<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/bcm/dwcotg.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/bcm/dwcotg.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB host driver for BCM2835
 *	Synopsis DesignWare Core USB 2.0 OTG controller
 *
 * Device register definitions
 */

typedef unsigned int Reg;
typedef struct Dwcregs Dwcregs;
typedef struct Hostchan Hostchan;

enum {
	Maxchans	= 16,	/* actual number of channels in ghwcfg2 */
};

struct Dwcregs {
	/* Core global registers 0x000-0x140 */
	Reg	gotgctl;	/* OTG Control and Status */
	Reg	gotgint;	/* OTG Interrupt */
	Reg	gahbcfg;	/* Core AHB Configuration */
	Reg	gusbcfg;	/* Core USB Configuration */
	Reg	grstctl;	/* Core Reset */
	Reg	gintsts;	/* Core Interrupt */
	Reg	gintmsk;	/* Core Interrupt Mask */
	Reg	grxstsr;	/* Receive Status Queue Read (RO) */
	Reg	grxstsp;	/* Receive Status Queue Read &amp; POP (RO) */
	Reg	grxfsiz;	/* Receive FIFO Size */
	Reg	gnptxfsiz;	/* Non Periodic Transmit FIFO Size */
	Reg	gnptxsts;	/* Non Periodic Transmit FIFO/Queue Status (RO) */
	Reg	gi2cctl;	/* I2C Access */
	Reg	gpvndctl;	/* PHY Vendor Control */
	Reg	ggpio;		/* General Purpose Input/Output */
	Reg	guid;		/* User ID */
	Reg	gsnpsid;	/* Synopsys ID (RO) */
	Reg	ghwcfg1;	/* User HW Config1 (RO) (DEVICE) */
	Reg	ghwcfg2;	/* User HW Config2 (RO) */
	Reg	ghwcfg3;	/* User HW Config3 (RO) */
	Reg	ghwcfg4;	/* User HW Config4 (RO)*/
	Reg	glpmcfg;	/* Core LPM Configuration */
	Reg	gpwrdn;		/* Global PowerDn */
	Reg	gdfifocfg;	/* Global DFIFO SW Config (DEVICE?) */
	Reg	adpctl;		/* ADP Control */
	Reg	reserved0[39];
	Reg	hptxfsiz;	/* Host Periodic Transmit FIFO Size */
	Reg	dtxfsiz[15];	/* Device Periodic Transmit FIFOs (DEVICE) */
	char	pad0[0x400-0x140];

	/* Host global registers 0x400-0x420 */
	Reg	hcfg;		/* Configuration */
	Reg	hfir;		/* Frame Interval */
	Reg	hfnum;		/* Frame Number / Frame Remaining (RO) */
	Reg	reserved1;
	Reg	hptxsts;	/* Periodic Transmit FIFO / Queue Status */
	Reg	haint;		/* All Channels Interrupt */
	Reg	haintmsk;	/* All Channels Interrupt Mask */
	Reg	hflbaddr;	/* Frame List Base Address */
	char	pad1[0x440-0x420];

	/* Host port register 0x440 */
	Reg	hport0;		/* Host Port 0 Control and Status */
	char	pad2[0x500-0x444];

	/* Host channel specific registers 0x500-0x700 */
	struct	Hostchan {
		Reg	hcchar;	/* Characteristic */
		Reg	hcsplt;	/* Split Control */
		Reg	hcint;	/* Interrupt */
		Reg	hcintmsk; /* Interrupt Mask */
		Reg	hctsiz;	/* Transfer Size */
		Reg	hcdma;	/* DMA Address */
		Reg	reserved;
		Reg	hcdmab;	/* DMA Buffer Address */
	} hchan[Maxchans];
	char	pad3[0xE00-0x700];

	/* Power &amp; clock gating control register 0xE00 */
	Reg	pcgcctl;
};

enum {
	/* gotgctl */
	Sesreqscs	= 1&lt;&lt;0,
	Sesreq		= 1&lt;&lt;1,
	Vbvalidoven	= 1&lt;&lt;2,
	Vbvalidovval	= 1&lt;&lt;3,
	Avalidoven	= 1&lt;&lt;4,
	Avalidovval	= 1&lt;&lt;5,
	Bvalidoven	= 1&lt;&lt;6,
	Bvalidovval	= 1&lt;&lt;7,
	Hstnegscs	= 1&lt;&lt;8,
	Hnpreq		= 1&lt;&lt;9,
	Hstsethnpen	= 1&lt;&lt;10,
	Devhnpen	= 1&lt;&lt;11,
	Conidsts	= 1&lt;&lt;16,
	Dbnctime	= 1&lt;&lt;17,
	Asesvld		= 1&lt;&lt;18,
	Bsesvld		= 1&lt;&lt;19,
	Otgver		= 1&lt;&lt;20,
	Multvalidbc	= 0x1F&lt;&lt;22,
	Chirpen		= 1&lt;&lt;27,

	/* gotgint */
	Sesenddet	= 1&lt;&lt;2,
	Sesreqsucstschng= 1&lt;&lt;8,
	Hstnegsucstschng= 1&lt;&lt;9,
	Hstnegdet	= 1&lt;&lt;17,
	Adevtoutchng	= 1&lt;&lt;18,
	Debdone		= 1&lt;&lt;19,
	Mvic		= 1&lt;&lt;20,

	/* gahbcfg */
	Glblintrmsk	= 1&lt;&lt;0,
	/* bits 1:4 redefined for BCM2835 */
	Axiburstlen	= 0x3&lt;&lt;1,
		BURST1		= 3&lt;&lt;1,
		BURST2		= 2&lt;&lt;1,
		BURST3		= 1&lt;&lt;1,
		BURST4		= 0&lt;&lt;1,
	Axiwaitwrites	= 1&lt;&lt;4,
	Dmaenable	= 1&lt;&lt;5,
	Nptxfemplvl	= 1&lt;&lt;7,
		NPTX_HALFEMPTY	= 0&lt;&lt;7,
		NPTX_EMPTY	= 1&lt;&lt;7,
	Ptxfemplvl	= 1&lt;&lt;8,
		PTX_HALFEMPTY	= 0&lt;&lt;8,
		PTX_EMPTY	= 1&lt;&lt;8,
	Remmemsupp	= 1&lt;&lt;21,
	Notialldmawrit	= 1&lt;&lt;22,
	Ahbsingle	= 1&lt;&lt;23,

	/* gusbcfg */
	Toutcal		= 0x7&lt;&lt;0,
	Phyif		= 1&lt;&lt;3,
	Ulpi_utmi_sel	= 1&lt;&lt;4,
	Fsintf		= 1&lt;&lt;5,
		FsUnidir	= 0&lt;&lt;5,
		FsBidir		= 1&lt;&lt;5,
	Physel		= 1&lt;&lt;6,
		PhyHighspeed	= 0&lt;&lt;6,
		PhyFullspeed	= 1&lt;&lt;6,
	Ddrsel		= 1&lt;&lt;7,
	Srpcap		= 1&lt;&lt;8,
	Hnpcap		= 1&lt;&lt;9,
	Usbtrdtim	= 0xf&lt;&lt;10,
		OUsbtrdtim		= 10,
	Phylpwrclksel	= 1&lt;&lt;15,
	Otgutmifssel	= 1&lt;&lt;16,
	Ulpi_fsls	= 1&lt;&lt;17,
	Ulpi_auto_res	= 1&lt;&lt;18,
	Ulpi_clk_sus_m	= 1&lt;&lt;19,
	Ulpi_ext_vbus_drv= 1&lt;&lt;20,
	Ulpi_int_vbus_indicator= 1&lt;&lt;21,
	Term_sel_dl_pulse= 1&lt;&lt;22,
	Indicator_complement= 1&lt;&lt;23,
	Indicator_pass_through= 1&lt;&lt;24,
	Ulpi_int_prot_dis= 1&lt;&lt;25,
	Ic_usb_cap	= 1&lt;&lt;26,
	Ic_traffic_pull_remove= 1&lt;&lt;27,
	Tx_end_delay	= 1&lt;&lt;28,
	Force_host_mode	= 1&lt;&lt;29,
	Force_dev_mode	= 1&lt;&lt;30,

	/* grstctl */
	Csftrst		= 1&lt;&lt;0,
	Hsftrst		= 1&lt;&lt;1,
	Hstfrm		= 1&lt;&lt;2,
	Intknqflsh	= 1&lt;&lt;3,
	Rxfflsh		= 1&lt;&lt;4,
	Txfflsh		= 1&lt;&lt;5,
	Txfnum		= 0x1f&lt;&lt;6,
		TXF_ALL		= 0x10&lt;&lt;6,
	Dmareq		= 1&lt;&lt;30,
	Ahbidle		= 1&lt;&lt;31,

	/* gintsts, gintmsk */
	Curmode		= 1&lt;&lt;0,
		HOSTMODE	= 1&lt;&lt;0,
		DEVMODE		= 0&lt;&lt;0,
	Modemismatch	= 1&lt;&lt;1,
	Otgintr		= 1&lt;&lt;2,
	Sofintr		= 1&lt;&lt;3,
	Rxstsqlvl	= 1&lt;&lt;4,
	Nptxfempty	= 1&lt;&lt;5,
	Ginnakeff	= 1&lt;&lt;6,
	Goutnakeff	= 1&lt;&lt;7,
	Ulpickint	= 1&lt;&lt;8,
	I2cintr		= 1&lt;&lt;9,
	Erlysuspend	= 1&lt;&lt;10,
	Usbsuspend	= 1&lt;&lt;11,
	Usbreset	= 1&lt;&lt;12,
	Enumdone	= 1&lt;&lt;13,
	Isooutdrop	= 1&lt;&lt;14,
	Eopframe	= 1&lt;&lt;15,
	Restoredone	= 1&lt;&lt;16,
	Epmismatch	= 1&lt;&lt;17,
	Inepintr	= 1&lt;&lt;18,
	Outepintr	= 1&lt;&lt;19,
	Incomplisoin	= 1&lt;&lt;20,
	Incomplisoout	= 1&lt;&lt;21,
	Fetsusp		= 1&lt;&lt;22,
	Resetdet	= 1&lt;&lt;23,
	Portintr	= 1&lt;&lt;24,
	Hcintr		= 1&lt;&lt;25,
	Ptxfempty	= 1&lt;&lt;26,
	Lpmtranrcvd	= 1&lt;&lt;27,
	Conidstschng	= 1&lt;&lt;28,
	Disconnect	= 1&lt;&lt;29,
	Sessreqintr	= 1&lt;&lt;30,
	Wkupintr	= 1&lt;&lt;31,

	/* grxsts[rp] */
	Chnum		= 0xf&lt;&lt;0,
	Bcnt		= 0x7ff&lt;&lt;4,
	Dpid		= 0x3&lt;&lt;15,
	Pktsts		= 0xf&lt;&lt;17,
		PKTSTS_IN		= 2&lt;&lt;17,
		PKTSTS_IN_XFER_COMP	= 3&lt;&lt;17,
		PKTSTS_DATA_TOGGLE_ERR	= 5&lt;&lt;17,
		PKTSTS_CH_HALTED	= 7&lt;&lt;17,

	/* hptxfsiz, gnptxfsiz */
	Startaddr	= 0xffff&lt;&lt;0,
	Depth		= 0xffff&lt;&lt;16,
		ODepth		= 16,

	/* gnptxsts */
	Nptxfspcavail	= 0xffff&lt;&lt;0,
	Nptxqspcavail	= 0xff&lt;&lt;16,
	Nptxqtop_terminate= 1&lt;&lt;24,
	Nptxqtop_token	= 0x3&lt;&lt;25,
	Nptxqtop_chnep	= 0xf&lt;&lt;27,

	/* gpvndctl */
	Regdata		= 0xff&lt;&lt;0,
	Vctrl		= 0xff&lt;&lt;8,
	Regaddr16_21	= 0x3f&lt;&lt;16,
	Regwr		= 1&lt;&lt;22,
	Newregreq	= 1&lt;&lt;25,
	Vstsbsy		= 1&lt;&lt;26,
	Vstsdone	= 1&lt;&lt;27,
	Disulpidrvr	= 1&lt;&lt;31,

	/* ggpio */
	Gpi		= 0xffff&lt;&lt;0,
	Gpo		= 0xffff&lt;&lt;16,

	/* ghwcfg2 */
	Op_mode		= 0x7&lt;&lt;0,
		HNP_SRP_CAPABLE_OTG	= 0&lt;&lt;0,
		SRP_ONLY_CAPABLE_OTG	= 1&lt;&lt;0,
		NO_HNP_SRP_CAPABLE	= 2&lt;&lt;0,
		SRP_CAPABLE_DEVICE	= 3&lt;&lt;0,
		NO_SRP_CAPABLE_DEVICE	= 4&lt;&lt;0,
		SRP_CAPABLE_HOST	= 5&lt;&lt;0,
		NO_SRP_CAPABLE_HOST	= 6&lt;&lt;0,
	Architecture	= 0x3&lt;&lt;3,
		SLAVE_ONLY		= 0&lt;&lt;3,
		EXT_DMA			= 1&lt;&lt;3,
		INT_DMA			= 2&lt;&lt;3,
	Point2point	= 1&lt;&lt;5,
	Hs_phy_type	= 0x3&lt;&lt;6,
		PHY_NOT_SUPPORTED	= 0&lt;&lt;6,
		PHY_UTMI		= 1&lt;&lt;6,
		PHY_ULPI		= 2&lt;&lt;6,
		PHY_UTMI_ULPI		= 3&lt;&lt;6,
	Fs_phy_type	= 0x3&lt;&lt;8,
	Num_dev_ep	= 0xf&lt;&lt;10,
	Num_host_chan	= 0xf&lt;&lt;14,
		ONum_host_chan		= 14,
	Perio_ep_supported= 1&lt;&lt;18,
	Dynamic_fifo	= 1&lt;&lt;19,
	Nonperio_tx_q_depth= 0x3&lt;&lt;22,
	Host_perio_tx_q_depth= 0x3&lt;&lt;24,
	Dev_token_q_depth= 0x1f&lt;&lt;26,
	Otg_enable_ic_usb= 1&lt;&lt;31,

	/* ghwcfg3 */
	Xfer_size_cntr_width	= 0xf&lt;&lt;0,
	Packet_size_cntr_width	= 0x7&lt;&lt;4,
	Otg_func		= 1&lt;&lt;7,
	I2c			= 1&lt;&lt;8,
	Vendor_ctrl_if		= 1&lt;&lt;9,
	Optional_features	= 1&lt;&lt;10,
	Synch_reset_type	= 1&lt;&lt;11,
	Adp_supp		= 1&lt;&lt;12,
	Otg_enable_hsic		= 1&lt;&lt;13,
	Bc_support		= 1&lt;&lt;14,
	Otg_lpm_en		= 1&lt;&lt;15,
	Dfifo_depth		= 0xffff&lt;&lt;16,
		ODfifo_depth		= 16,

	/* ghwcfg4 */
	Num_dev_perio_in_ep	= 0xf&lt;&lt;0,
	Power_optimiz		= 1&lt;&lt;4,
	Min_ahb_freq		= 1&lt;&lt;5,
	Hiber			= 1&lt;&lt;6,
	Xhiber			= 1&lt;&lt;7,
	Utmi_phy_data_width	= 0x3&lt;&lt;14,
	Num_dev_mode_ctrl_ep	= 0xf&lt;&lt;16,
	Iddig_filt_en		= 1&lt;&lt;20,
	Vbus_valid_filt_en	= 1&lt;&lt;21,
	A_valid_filt_en		= 1&lt;&lt;22,
	B_valid_filt_en		= 1&lt;&lt;23,
	Session_end_filt_en	= 1&lt;&lt;24,
	Ded_fifo_en		= 1&lt;&lt;25,
	Num_in_eps		= 0xf&lt;&lt;26,
	Desc_dma		= 1&lt;&lt;30,
	Desc_dma_dyn		= 1&lt;&lt;31,

	/* glpmcfg */
	Lpm_cap_en	= 1&lt;&lt;0,
	Appl_resp	= 1&lt;&lt;1,
	Hird		= 0xf&lt;&lt;2,
	Rem_wkup_en	= 1&lt;&lt;6,
	En_utmi_sleep	= 1&lt;&lt;7,
	Hird_thres	= 0x1f&lt;&lt;8,
	Lpm_resp	= 0x3&lt;&lt;13,
	Prt_sleep_sts	= 1&lt;&lt;15,
	Sleep_state_resumeok= 1&lt;&lt;16,
	Lpm_chan_index	= 0xf&lt;&lt;17,
	Retry_count	= 0x7&lt;&lt;21,
	Send_lpm	= 1&lt;&lt;24,
	Retry_count_sts	= 0x7&lt;&lt;25,
	Hsic_connect	= 1&lt;&lt;30,
	Inv_sel_hsic	= 1&lt;&lt;31,

	/* gpwrdn */
	Pmuintsel	= 1&lt;&lt;0,
	Pmuactv		= 1&lt;&lt;1,
	Restore		= 1&lt;&lt;2,
	Pwrdnclmp	= 1&lt;&lt;3,
	Pwrdnrstn	= 1&lt;&lt;4,
	Pwrdnswtch	= 1&lt;&lt;5,
	Dis_vbus	= 1&lt;&lt;6,
	Lnstschng	= 1&lt;&lt;7,
	Lnstchng_msk	= 1&lt;&lt;8,
	Rst_det		= 1&lt;&lt;9,
	Rst_det_msk	= 1&lt;&lt;10,
	Disconn_det	= 1&lt;&lt;11,
	Disconn_det_msk	= 1&lt;&lt;12,
	Connect_det	= 1&lt;&lt;13,
	Connect_det_msk	= 1&lt;&lt;14,
	Srp_det		= 1&lt;&lt;15,
	Srp_det_msk	= 1&lt;&lt;16,
	Sts_chngint	= 1&lt;&lt;17,
	Sts_chngint_msk	= 1&lt;&lt;18,
	Linestate	= 0x3&lt;&lt;19,
	Idsts		= 1&lt;&lt;21,
	Bsessvld	= 1&lt;&lt;22,
	Adp_int		= 1&lt;&lt;23,
	Mult_val_id_bc	= 0x1f&lt;&lt;24,

	/* gdfifocfg */
	Gdfifocfg	= 0xffff&lt;&lt;0,
	Epinfobase	= 0xffff&lt;&lt;16,

	/* adpctl */
	Prb_dschg	= 0x3&lt;&lt;0,
	Prb_delta	= 0x3&lt;&lt;2,
	Prb_per		= 0x3&lt;&lt;4,
	Rtim		= 0x7ff&lt;&lt;6,
	Enaprb		= 1&lt;&lt;17,
	Enasns		= 1&lt;&lt;18,
	Adpres		= 1&lt;&lt;19,
	Adpen		= 1&lt;&lt;20,
	Adp_prb_int	= 1&lt;&lt;21,
	Adp_sns_int	= 1&lt;&lt;22,
	Adp_tmout_int	= 1&lt;&lt;23,
	Adp_prb_int_msk	= 1&lt;&lt;24,
	Adp_sns_int_msk	= 1&lt;&lt;25,
	Adp_tmout_int_msk= 1&lt;&lt;26,
	Ar		= 0x3&lt;&lt;27,

	/* hcfg */
	Fslspclksel	= 0x3&lt;&lt;0,
		HCFG_30_60_MHZ	= 0&lt;&lt;0,
		HCFG_48_MHZ	= 1&lt;&lt;0,
		HCFG_6_MHZ	= 2&lt;&lt;0,
	Fslssupp	= 1&lt;&lt;2,
	Ena32khzs	= 1&lt;&lt;7,
	Resvalid	= 0xff&lt;&lt;8,
	Descdma		= 1&lt;&lt;23,
	Frlisten	= 0x3&lt;&lt;24,
	Modechtimen	= 1&lt;&lt;31,

	/* hfir */
	Frint		= 0xffff&lt;&lt;0,
	Hfirrldctrl	= 1&lt;&lt;16,

	/* hfnum */
	Frnum		= 0xffff&lt;&lt;0,
		MAX_FRNUM 	= 0x3FFF&lt;&lt;0,
	Frrem		= 0xffff&lt;&lt;16,

	/* hptxsts */
	Ptxfspcavail	= 0xffff&lt;&lt;0,
	Ptxqspcavail	= 0xff&lt;&lt;16,
	Ptxqtop_terminate= 1&lt;&lt;24,
	Ptxqtop_token	= 0x3&lt;&lt;25,
	Ptxqtop_chnum	= 0xf&lt;&lt;27,
	Ptxqtop_odd	= 1&lt;&lt;31,

	/* haint, haintmsk */
#define CHANINT(n)	(1&lt;&lt;(n))

	/* hport0 */
	Prtconnsts	= 1&lt;&lt;0,		/* connect status (RO) */
	Prtconndet	= 1&lt;&lt;1,		/* connect detected R/W1C) */
	Prtena		= 1&lt;&lt;2,		/* enable (R/W1C) */
	Prtenchng	= 1&lt;&lt;3,		/* enable/disable change (R/W1C) */
	Prtovrcurract	= 1&lt;&lt;4,		/* overcurrent active (RO) */
	Prtovrcurrchng	= 1&lt;&lt;5,		/* overcurrent change (R/W1C) */
	Prtres		= 1&lt;&lt;6,		/* resume */
	Prtsusp		= 1&lt;&lt;7,		/* suspend */
	Prtrst		= 1&lt;&lt;8,		/* reset */
	Prtlnsts	= 0x3&lt;&lt;10,	/* line state {D+,D-} (RO) */
	Prtpwr		= 1&lt;&lt;12,	/* power on */
	Prttstctl	= 0xf&lt;&lt;13,	/* test */
	Prtspd		= 0x3&lt;&lt;17,	/* speed (RO) */
		HIGHSPEED	= 0&lt;&lt;17,
		FULLSPEED	= 1&lt;&lt;17,
		LOWSPEED	= 2&lt;&lt;17,

	/* hcchar */
	Mps		= 0x7ff&lt;&lt;0,	/* endpoint maximum packet size */
	Epnum		= 0xf&lt;&lt;11,	/* endpoint number */
		OEpnum		= 11,
	Epdir		= 1&lt;&lt;15,	/* endpoint direction */
		Epout		= 0&lt;&lt;15,
		Epin		= 1&lt;&lt;15,
	Lspddev		= 1&lt;&lt;17,	/* device is lowspeed */
	Eptype		= 0x3&lt;&lt;18,	/* endpoint type */
		Epctl		= 0&lt;&lt;18,
		Episo		= 1&lt;&lt;18,
		Epbulk		= 2&lt;&lt;18,
		Epintr		= 3&lt;&lt;18,
	Multicnt	= 0x3&lt;&lt;20,	/* transactions per μframe */
					/* or retries per periodic split */
		OMulticnt	= 20,
	Devaddr		= 0x7f&lt;&lt;22,	/* device address */
		ODevaddr	= 22,
	Oddfrm		= 1&lt;&lt;29,	/* xfer in odd frame (iso/interrupt) */
	Chdis		= 1&lt;&lt;30,	/* channel disable (write 1 only) */
	Chen		= 1&lt;&lt;31,	/* channel enable (write 1 only) */

	/* hcsplt */
	Prtaddr		= 0x7f&lt;&lt;0,	/* port address of recipient */
					/* transaction translator */
	Hubaddr		= 0x7f&lt;&lt;7,	/* dev address of transaction */
					/* translator's hub */
		OHubaddr	= 7,
	Xactpos		= 0x3&lt;&lt;14,	/* payload's position within transaction */
		POS_MID		= 0&lt;&lt;14,		
		POS_END		= 1&lt;&lt;14,
		POS_BEGIN	= 2&lt;&lt;14,
		POS_ALL		= 3&lt;&lt;14, /* all of data (&lt;= 188 bytes) */
	Compsplt	= 1&lt;&lt;16,	/* do complete split */
	Spltena		= 1&lt;&lt;31,	/* channel enabled to do splits */

	/* hcint, hcintmsk */
	Xfercomp	= 1&lt;&lt;0,		/* transfer completed without error */
	Chhltd		= 1&lt;&lt;1,		/* channel halted */
	Ahberr		= 1&lt;&lt;2,		/* AHB dma error */
	Stall		= 1&lt;&lt;3,
	Nak		= 1&lt;&lt;4,
	Ack		= 1&lt;&lt;5,
	Nyet		= 1&lt;&lt;6,
	Xacterr		= 1&lt;&lt;7,	/* transaction error (crc, t/o, bit stuff, eop) */
	Bblerr		= 1&lt;&lt;8,
	Frmovrun	= 1&lt;&lt;9,
	Datatglerr	= 1&lt;&lt;10,
	Bna		= 1&lt;&lt;11,
	Xcs_xact	= 1&lt;&lt;12,
	Frm_list_roll	= 1&lt;&lt;13,

	/* hctsiz */
	Xfersize	= 0x7ffff&lt;&lt;0,	/* expected total bytes */
	Pktcnt		= 0x3ff&lt;&lt;19,	/* expected number of packets */
		OPktcnt		= 19,
	Pid		= 0x3&lt;&lt;29,	/* packet id for initial transaction */
		DATA0		= 0&lt;&lt;29,
		DATA1		= 2&lt;&lt;29,	/* sic */
		DATA2		= 1&lt;&lt;29,	/* sic */
		MDATA		= 3&lt;&lt;29,	/* (non-ctl ep) */
		SETUP		= 3&lt;&lt;29,	/* (ctl ep) */
	Dopng		= 1&lt;&lt;31,	/* do PING protocol */

	/* pcgcctl */
	Stoppclk		= 1&lt;&lt;0,
	Gatehclk		= 1&lt;&lt;1,
	Pwrclmp			= 1&lt;&lt;2,
	Rstpdwnmodule		= 1&lt;&lt;3,
	Enbl_sleep_gating	= 1&lt;&lt;5,
	Phy_in_sleep		= 1&lt;&lt;6,
	Deep_sleep		= 1&lt;&lt;7,
	Resetaftsusp		= 1&lt;&lt;8,
	Restoremode		= 1&lt;&lt;9,
	Enbl_extnd_hiber	= 1&lt;&lt;10,
	Extnd_hiber_pwrclmp	= 1&lt;&lt;11,
	Extnd_hiber_switch	= 1&lt;&lt;12,
	Ess_reg_restored	= 1&lt;&lt;13,
	Prt_clk_sel		= 0x3&lt;&lt;14,
	Port_power		= 1&lt;&lt;16,
	Max_xcvrselect		= 0x3&lt;&lt;17,
	Max_termsel		= 1&lt;&lt;19,
	Mac_dev_addr		= 0x7f&lt;&lt;20,
	P2hd_dev_enum_spd	= 0x3&lt;&lt;27,
	P2hd_prt_spd		= 0x3&lt;&lt;29,
	If_dev_mode		= 1&lt;&lt;31,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

