<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/bcm/emmc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/bcm/emmc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * bcm2835 external mass media controller (mmc / sd host interface)
 *
 * Copyright © 2012 Richard Miller &lt;r.miller@acm.org&gt;
 */

#include "u.h"
#include "../port/lib.h"
#include "../port/error.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/sd.h"

#define EMMCREGS	(VIRTIO+0x300000)

enum {
	Extfreq		= 100*Mhz,	/* guess external clock frequency if */
					/* not available from vcore */
	Initfreq	= 400000,	/* initialisation frequency for MMC */
	SDfreq		= 25*Mhz,	/* standard SD frequency */
	DTO		= 14,		/* data timeout exponent (guesswork) */

	MMCSelect	= 7,		/* mmc/sd card select command */
	Setbuswidth	= 6,		/* mmc/sd set bus width command */
};

enum {
	/* Controller registers */
	Arg2			= 0x00&gt;&gt;2,
	Blksizecnt		= 0x04&gt;&gt;2,
	Arg1			= 0x08&gt;&gt;2,
	Cmdtm			= 0x0c&gt;&gt;2,
	Resp0			= 0x10&gt;&gt;2,
	Resp1			= 0x14&gt;&gt;2,
	Resp2			= 0x18&gt;&gt;2,
	Resp3			= 0x1c&gt;&gt;2,
	Data			= 0x20&gt;&gt;2,
	Status			= 0x24&gt;&gt;2,
	Control0		= 0x28&gt;&gt;2,
	Control1		= 0x2c&gt;&gt;2,
	Interrupt		= 0x30&gt;&gt;2,
	Irptmask		= 0x34&gt;&gt;2,
	Irpten			= 0x38&gt;&gt;2,
	Control2		= 0x3c&gt;&gt;2,
	Forceirpt		= 0x50&gt;&gt;2,
	Boottimeout		= 0x70&gt;&gt;2,
	Dbgsel			= 0x74&gt;&gt;2,
	Exrdfifocfg		= 0x80&gt;&gt;2,
	Exrdfifoen		= 0x84&gt;&gt;2,
	Tunestep		= 0x88&gt;&gt;2,
	Tunestepsstd		= 0x8c&gt;&gt;2,
	Tunestepsddr		= 0x90&gt;&gt;2,
	Spiintspt		= 0xf0&gt;&gt;2,
	Slotisrver		= 0xfc&gt;&gt;2,

	/* Control0 */
	Dwidth4			= 1&lt;&lt;1,
	Dwidth1			= 0&lt;&lt;1,

	/* Control1 */
	Srstdata		= 1&lt;&lt;26,	/* reset data circuit */
	Srstcmd			= 1&lt;&lt;25,	/* reset command circuit */
	Srsthc			= 1&lt;&lt;24,	/* reset complete host controller */
	Datatoshift		= 16,		/* data timeout unit exponent */
	Datatomask		= 0xF0000,
	Clkfreq8shift		= 8,		/* SD clock base divider LSBs */
	Clkfreq8mask		= 0xFF00,
	Clkfreqms2shift		= 6,		/* SD clock base divider MSBs */
	Clkfreqms2mask		= 0xC0,
	Clkgendiv		= 0&lt;&lt;5,		/* SD clock divided */
	Clkgenprog		= 1&lt;&lt;5,		/* SD clock programmable */
	Clken			= 1&lt;&lt;2,		/* SD clock enable */
	Clkstable		= 1&lt;&lt;1,	
	Clkintlen		= 1&lt;&lt;0,		/* enable internal EMMC clocks */

	/* Cmdtm */
	Indexshift		= 24,
	Suspend			= 1&lt;&lt;22,
	Resume			= 2&lt;&lt;22,
	Abort			= 3&lt;&lt;22,
	Isdata			= 1&lt;&lt;21,
	Ixchken			= 1&lt;&lt;20,
	Crcchken		= 1&lt;&lt;19,
	Respmask		= 3&lt;&lt;16,
	Respnone		= 0&lt;&lt;16,
	Resp136			= 1&lt;&lt;16,
	Resp48			= 2&lt;&lt;16,
	Resp48busy		= 3&lt;&lt;16,
	Multiblock		= 1&lt;&lt;5,
	Host2card		= 0&lt;&lt;4,
	Card2host		= 1&lt;&lt;4,
	Autocmd12		= 1&lt;&lt;2,
	Autocmd23		= 2&lt;&lt;2,
	Blkcnten		= 1&lt;&lt;1,

	/* Interrupt */
	Acmderr		= 1&lt;&lt;24,
	Denderr		= 1&lt;&lt;22,
	Dcrcerr		= 1&lt;&lt;21,
	Dtoerr		= 1&lt;&lt;20,
	Cbaderr		= 1&lt;&lt;19,
	Cenderr		= 1&lt;&lt;18,
	Ccrcerr		= 1&lt;&lt;17,
	Ctoerr		= 1&lt;&lt;16,
	Err		= 1&lt;&lt;15,
	Cardintr	= 1&lt;&lt;8,		/* not in Broadcom datasheet */
	Cardinsert	= 1&lt;&lt;6,		/* not in Broadcom datasheet */
	Readrdy		= 1&lt;&lt;5,
	Writerdy	= 1&lt;&lt;4,
	Datadone	= 1&lt;&lt;1,
	Cmddone		= 1&lt;&lt;0,

	/* Status */
	Bufread		= 1&lt;&lt;11,	/* not in Broadcom datasheet */
	Bufwrite	= 1&lt;&lt;10,	/* not in Broadcom datasheet */
	Readtrans	= 1&lt;&lt;9,
	Writetrans	= 1&lt;&lt;8,
	Datactive	= 1&lt;&lt;2,
	Datinhibit	= 1&lt;&lt;1,
	Cmdinhibit	= 1&lt;&lt;0,
};

int cmdinfo[64] = {
[0]  Ixchken,
[2]  Resp136,
[3]  Resp48 | Ixchken | Crcchken,
[6]  Resp48 | Ixchken | Crcchken,
[7]  Resp48busy | Ixchken | Crcchken,
[8]  Resp48 | Ixchken | Crcchken,
[9]  Resp136,
[12] Resp48busy | Ixchken | Crcchken,
[13] Resp48 | Ixchken | Crcchken,
[16] Resp48,
[17] Resp48 | Isdata | Card2host | Ixchken | Crcchken,
[18] Resp48 | Isdata | Card2host | Multiblock | Blkcnten | Ixchken | Crcchken,
[24] Resp48 | Isdata | Host2card | Ixchken | Crcchken,
[25] Resp48 | Isdata | Host2card | Multiblock | Blkcnten | Ixchken | Crcchken,
[41] Resp48,
[55] Resp48 | Ixchken | Crcchken,
};

typedef struct Ctlr Ctlr;

struct Ctlr {
	Rendez	r;
	int	datadone;
	int	fastclock;
	ulong	extclk;
};

static Ctlr emmc;

static void mmcinterrupt(Ureg*, void*);

static void
WR(int reg, u32int val)
{
	u32int *r = (u32int*)EMMCREGS;

	if(0)print("WR %2.2ux %ux\n", reg&lt;&lt;2, val);
	microdelay(emmc.fastclock? 2 : 20);
	r[reg] = val;
}

static uint
clkdiv(uint d)
{
	uint v;

	assert(d &lt; 1&lt;&lt;10);
	v = (d &lt;&lt; Clkfreq8shift) &amp; Clkfreq8mask;
	v |= ((d &gt;&gt; 8) &lt;&lt; Clkfreqms2shift) &amp; Clkfreqms2mask;
	return v;
}

static int
datadone(void*)
{
	return emmc.datadone;
}

static int
emmcinit(void)
{
	u32int *r;
	ulong clk;
	char *s;

	clk = getclkrate(ClkEmmc);
	s = "";
	if(clk == 0){
		s = "Assuming ";
		clk = Extfreq;
	}
	emmc.extclk = clk;
	print("%seMMC external clock %lud Mhz\n", s, clk/1000000);
	r = (u32int*)EMMCREGS;
	if(0)print("emmc control %8.8ux %8.8ux %8.8ux\n",
		r[Control0], r[Control1], r[Control2]);
	WR(Control1, Srsthc);
	delay(10);
	while(r[Control1] &amp; Srsthc)
		;
	return 0;
}

static int
emmcinquiry(char *inquiry, int inqlen)
{
	u32int *r;
	uint ver;

	r = (u32int*)EMMCREGS;
	ver = r[Slotisrver] &gt;&gt; 16;
	return snprint(inquiry, inqlen,
		"Arasan eMMC SD Host Controller %2.2x Version %2.2x",
		ver&amp;0xFF, ver&gt;&gt;8);
}

static void
emmcenable(void)
{
	u32int *r;
	int i;

	r = (u32int*)EMMCREGS;
	WR(Control1, clkdiv(emmc.extclk/Initfreq - 1) |
		DTO&lt;&lt;Datatoshift | Clkgendiv | Clken | Clkintlen);
	for(i = 0; i &lt; 1000; i++){
		delay(1);
		if(r[Control1] &amp; Clkstable)
			break;
	}
	if(i == 1000)
		print("SD clock won't initialise!\n");
	WR(Irptmask, ~(Dtoerr|Cardintr));
	intrenable(IRQmmc, mmcinterrupt, nil, 0, "mmc");
}

static int
emmccmd(u32int cmd, u32int arg, u32int *resp)
{
	u32int *r;
	u32int c;
	int i;
	ulong now;

	r = (u32int*)EMMCREGS;
	assert(cmd &lt; nelem(cmdinfo) &amp;&amp; cmdinfo[cmd] != 0);
	c = (cmd &lt;&lt; Indexshift) | cmdinfo[cmd];
	if(r[Status] &amp; Cmdinhibit){
		print("emmccmd: need to reset Cmdinhibit intr %ux stat %ux\n",
			r[Interrupt], r[Status]);
		WR(Control1, r[Control1] | Srstcmd);
		while(r[Control1] &amp; Srstcmd)
			;
		while(r[Status] &amp; Cmdinhibit)
			;
	}
	if((r[Status] &amp; Datinhibit) &amp;&amp;
	   ((c &amp; Isdata) || (c &amp; Respmask) == Resp48busy)){
		print("emmccmd: need to reset Datinhibit intr %ux stat %ux\n",
			r[Interrupt], r[Status]);
		WR(Control1, r[Control1] | Srstdata);
		while(r[Control1] &amp; Srstdata)
			;
		while(r[Status] &amp; Datinhibit)
			;
	}
	WR(Arg1, arg);
	if((i = r[Interrupt]) != 0){
		if(i != Cardinsert)
			print("emmc: before command, intr was %ux\n", i);
		WR(Interrupt, i);
	}
	WR(Cmdtm, c);
	now = m-&gt;ticks;
	while(((i=r[Interrupt])&amp;(Cmddone|Err)) == 0)
		if(m-&gt;ticks-now &gt; HZ)
			break;
	if((i&amp;(Cmddone|Err)) != Cmddone){
		if((i&amp;~Err) != Ctoerr)
			print("emmc: cmd %ux error intr %ux stat %ux\n", c, i, r[Status]);
		WR(Interrupt, i);
		if(r[Status]&amp;Cmdinhibit){
			WR(Control1, r[Control1]|Srstcmd);
			while(r[Control1]&amp;Srstcmd)
				;
		}
		error(Eio);
	}
	WR(Interrupt, i &amp; ~(Datadone|Readrdy|Writerdy));
	switch(c &amp; Respmask){
	case Resp136:
		resp[0] = r[Resp0]&lt;&lt;8;
		resp[1] = r[Resp0]&gt;&gt;24 | r[Resp1]&lt;&lt;8;
		resp[2] = r[Resp1]&gt;&gt;24 | r[Resp2]&lt;&lt;8;
		resp[3] = r[Resp2]&gt;&gt;24 | r[Resp3]&lt;&lt;8;
		break;
	case Resp48:
	case Resp48busy:
		resp[0] = r[Resp0];
		break;
	case Respnone:
		resp[0] = 0;
		break;
	}
	if((c &amp; Respmask) == Resp48busy){
		WR(Irpten, Datadone|Err);
		tsleep(&amp;emmc.r, datadone, 0, 3000);
		i = emmc.datadone;
		emmc.datadone = 0;
		WR(Irpten, 0);
		if((i &amp; Datadone) == 0)
			print("emmcio: no Datadone after CMD%d\n", cmd);
		if(i &amp; Err)
			print("emmcio: CMD%d error interrupt %ux\n",
				cmd, r[Interrupt]);
		WR(Interrupt, i);
	}
	/*
	 * Once card is selected, use faster clock
	 */
	if(cmd == MMCSelect){
		delay(10);
		WR(Control1, clkdiv(emmc.extclk/SDfreq - 1) |
			DTO&lt;&lt;Datatoshift | Clkgendiv | Clken | Clkintlen);
		for(i = 0; i &lt; 1000; i++){
			delay(1);
			if(r[Control1] &amp; Clkstable)
				break;
		}
		delay(10);
		emmc.fastclock = 1;
	}
	/*
	 * If card bus width changes, change host bus width
	 */
	if(cmd == Setbuswidth){
		switch(arg){
		case 0:
			WR(Control0, r[Control0] &amp; ~Dwidth4);
			break;
		case 2:
			WR(Control0, r[Control0] | Dwidth4);
			break;
		}
	}
	return 0;
}

void
emmciosetup(int write, void *buf, int bsize, int bcount)
{
	USED(write);
	USED(buf);
	WR(Blksizecnt, bcount&lt;&lt;16 | bsize);
}

static void
emmcio(int write, uchar *buf, int len)
{
	u32int *r;
	int i;

	r = (u32int*)EMMCREGS;
	assert((len&amp;3) == 0);
	okay(1);
	if(waserror()){
		okay(0);
		nexterror();
	}
	if(write)
		dmastart(DmaChanEmmc, DmaDevEmmc, DmaM2D,
			buf, &amp;r[Data], len);
	else
		dmastart(DmaChanEmmc, DmaDevEmmc, DmaD2M,
			&amp;r[Data], buf, len);
	if(dmawait(DmaChanEmmc) &lt; 0)
		error(Eio);
	WR(Irpten, Datadone|Err);
	tsleep(&amp;emmc.r, datadone, 0, 3000);
	i = emmc.datadone;
	emmc.datadone = 0;
	WR(Irpten, 0);
	if((i &amp; Datadone) == 0){
		print("emmcio: %d timeout intr %ux stat %ux\n",
			write, i, r[Status]);
		WR(Interrupt, i);
		error(Eio);
	}
	if(i &amp; Err){
		print("emmcio: %d error intr %ux stat %ux\n",
			write, r[Interrupt], r[Status]);
		WR(Interrupt, i);
		error(Eio);
	}
	if(i)
		WR(Interrupt, i);
	poperror();
	okay(0);
}

static void
mmcinterrupt(Ureg*, void*)
{	
	u32int *r;
	int i;

	r = (u32int*)EMMCREGS;
	i = r[Interrupt];
	r[Interrupt] = i &amp; (Datadone|Err);
	emmc.datadone = i;
	wakeup(&amp;emmc.r);
}

SDio sdio = {
	"emmc",
	emmcinit,
	emmcenable,
	emmcinquiry,
	emmccmd,
	emmciosetup,
	emmcio,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

