<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/bcm/usbdwc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/bcm/usbdwc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB host driver for BCM2835
 *	Synopsis DesignWare Core USB 2.0 OTG controller
 *
 * Copyright © 2012 Richard Miller &lt;r.miller@acm.org&gt;
 *
 * This is work in progress:
 * - no isochronous pipes
 * - no bandwidth budgeting
 * - frame scheduling is crude
 * - error handling is overly optimistic
 * It should be just about adequate for a Plan 9 terminal with
 * keyboard, mouse, ethernet adapter, and an external flash drive.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"

#include "dwcotg.h"

enum
{
	USBREGS		= VIRTIO + 0x980000,
	Enabledelay	= 50,
	Resetdelay	= 10,
	ResetdelayHS	= 50,

	Read		= 0,
	Write		= 1,
};

typedef struct Ctlr Ctlr;
typedef struct Epio Epio;

struct Ctlr {
	Dwcregs	*regs;		/* controller registers */
	int	nchan;		/* number of host channels */
	ulong	chanbusy;	/* bitmap of in-use channels */
	QLock	chanlock;	/* serialise access to chanbusy */
	QLock	split;		/* serialise split transactions */
	int	splitretry;	/* count retries of Nyet */
	int	sofchan;	/* bitmap of channels waiting for sof */
	int	wakechan;	/* bitmap of channels to wakeup after fiq */
	int	debugchan;	/* bitmap of channels for interrupt debug */
	Rendez	*chanintr;	/* sleep till interrupt on channel N */
};

struct Epio {
	QLock;
	Block	*cb;
	ulong	lastpoll;
};

static Ctlr dwc;
static int debug;

static char Ebadlen[] = "bad usb request length";

static void clog(Ep *ep, Hostchan *hc);
static void logdump(Ep *ep);

static Hostchan*
chanalloc(Ep *ep)
{
	Ctlr *ctlr;
	int bitmap, i;

	ctlr = ep-&gt;hp-&gt;aux;
	qlock(&amp;ctlr-&gt;chanlock);
	bitmap = ctlr-&gt;chanbusy;
	for(i = 0; i &lt; ctlr-&gt;nchan; i++)
		if((bitmap &amp; (1&lt;&lt;i)) == 0){
			ctlr-&gt;chanbusy = bitmap | 1&lt;&lt;i;
			qunlock(&amp;ctlr-&gt;chanlock);
			return &amp;ctlr-&gt;regs-&gt;hchan[i];
		}
	qunlock(&amp;ctlr-&gt;chanlock);
	panic("miller is a lazy git");
	return nil;
}

static void
chanrelease(Ep *ep, Hostchan *chan)
{
	Ctlr *ctlr;
	int i;

	ctlr = ep-&gt;hp-&gt;aux;
	i = chan - ctlr-&gt;regs-&gt;hchan;
	qlock(&amp;ctlr-&gt;chanlock);
	ctlr-&gt;chanbusy &amp;= ~(1&lt;&lt;i);
	qunlock(&amp;ctlr-&gt;chanlock);
}

static void
chansetup(Hostchan *hc, Ep *ep)
{
	int hcc;
	Ctlr *ctlr = ep-&gt;hp-&gt;aux;

	if(ep-&gt;debug)
		ctlr-&gt;debugchan |= 1 &lt;&lt; (hc - ctlr-&gt;regs-&gt;hchan);
	else
		ctlr-&gt;debugchan &amp;= ~(1 &lt;&lt; (hc - ctlr-&gt;regs-&gt;hchan));
	switch(ep-&gt;dev-&gt;state){
	case Dconfig:
	case Dreset:
		hcc = 0;
		break;
	default:
		hcc = ep-&gt;dev-&gt;nb&lt;&lt;ODevaddr;
		break;
	}
	hcc |= ep-&gt;maxpkt | 1&lt;&lt;OMulticnt | ep-&gt;nb&lt;&lt;OEpnum;
	switch(ep-&gt;ttype){
	case Tctl:
		hcc |= Epctl;
		break;
	case Tiso:
		hcc |= Episo;
		break;
	case Tbulk:
		hcc |= Epbulk;
		break;
	case Tintr:
		hcc |= Epintr;
		break;
	}
	switch(ep-&gt;dev-&gt;speed){
	case Lowspeed:
		hcc |= Lspddev;
		/* fall through */
	case Fullspeed:
		if(ep-&gt;dev-&gt;hub &gt; 1){
			hc-&gt;hcsplt = Spltena | POS_ALL | ep-&gt;dev-&gt;hub&lt;&lt;OHubaddr |
				ep-&gt;dev-&gt;port;
			break;
		}
		/* fall through */
	default:
		hc-&gt;hcsplt = 0;
		break;
	}
	hc-&gt;hcchar = hcc;
	hc-&gt;hcint = ~0;
}

static int
sofdone(void *a)
{
	Dwcregs *r;

	r = a;
	return r-&gt;gintsts &amp; Sofintr;
}

static void
sofwait(Ctlr *ctlr, int n)
{
	Dwcregs *r;
	int x;

	r = ctlr-&gt;regs;
	do{
		r-&gt;gintsts = Sofintr;
		x = splfhi();
		ctlr-&gt;sofchan |= 1&lt;&lt;n;
		r-&gt;gintmsk |= Sofintr;
		sleep(&amp;ctlr-&gt;chanintr[n], sofdone, r);
		splx(x);
	}while((r-&gt;hfnum &amp; 7) == 6);
}

static int
chandone(void *a)
{
	Hostchan *hc;

	hc = a;
	if(hc-&gt;hcint == (Chhltd|Ack))
		return 0;
	return (hc-&gt;hcint &amp; hc-&gt;hcintmsk) != 0;
}

static int
chanwait(Ep *ep, Ctlr *ctlr, Hostchan *hc, int mask)
{
	int intr, n, x, ointr;
	ulong start, now;
	Dwcregs *r;

	r = ctlr-&gt;regs;
	n = hc - r-&gt;hchan;
	for(;;){
restart:
		x = splfhi();
		r-&gt;haintmsk |= 1&lt;&lt;n;
		hc-&gt;hcintmsk = mask;
		sleep(&amp;ctlr-&gt;chanintr[n], chandone, hc);
		hc-&gt;hcintmsk = 0;
		splx(x);
		intr = hc-&gt;hcint;
		if(intr &amp; Chhltd)
			return intr;
		start = fastticks(0);
		ointr = intr;
		now = start;
		do{
			intr = hc-&gt;hcint;
			if(intr &amp; Chhltd){
				if((ointr != Ack &amp;&amp; ointr != (Ack|Xfercomp)) ||
				   intr != (Ack|Chhltd|Xfercomp) ||
				   (now - start) &gt; 60)
					dprint("await %x after %ld %x -&gt; %x\n",
						mask, now - start, ointr, intr);
				return intr;
			}
			if((intr &amp; mask) == 0){
				dprint("ep%d.%d await %x intr %x -&gt; %x\n",
					ep-&gt;dev-&gt;nb, ep-&gt;nb, mask, ointr, intr);
				goto restart;
			}
			now = fastticks(0);
		}while(now - start &lt; 100);
		dprint("ep%d.%d halting channel %8.8ux hcchar %8.8ux "
			"grxstsr %8.8ux gnptxsts %8.8ux hptxsts %8.8ux\n",
			ep-&gt;dev-&gt;nb, ep-&gt;nb, intr, hc-&gt;hcchar, r-&gt;grxstsr,
			r-&gt;gnptxsts, r-&gt;hptxsts);
		mask = Chhltd;
		hc-&gt;hcchar |= Chdis;
		start = m-&gt;ticks;
		while(hc-&gt;hcchar &amp; Chen){
			if(m-&gt;ticks - start &gt;= 100){
				print("ep%d.%d channel won't halt hcchar %8.8ux\n",
					ep-&gt;dev-&gt;nb, ep-&gt;nb, hc-&gt;hcchar);
				break;
			}
		}
		logdump(ep);
	}
}

static int
chanintr(Ctlr *ctlr, int n)
{
	Hostchan *hc;
	int i;

	hc = &amp;ctlr-&gt;regs-&gt;hchan[n];
	if(ctlr-&gt;debugchan &amp; (1&lt;&lt;n))
		clog(nil, hc);
	if((hc-&gt;hcsplt &amp; Spltena) == 0)
		return 0;
	i = hc-&gt;hcint;
	if(i == (Chhltd|Ack)){
		hc-&gt;hcsplt |= Compsplt;
		ctlr-&gt;splitretry = 0;
	}else if(i == (Chhltd|Nyet)){
		if(++ctlr-&gt;splitretry &gt;= 3)
			return 0;
	}else
		return 0;
	if(hc-&gt;hcchar &amp; Chen){
		iprint("hcchar %8.8ux hcint %8.8ux", hc-&gt;hcchar, hc-&gt;hcint);
		hc-&gt;hcchar |= Chen | Chdis;
		while(hc-&gt;hcchar&amp;Chen)
			;
		iprint(" %8.8ux\n", hc-&gt;hcint);
	}
	hc-&gt;hcint = i;
	if(ctlr-&gt;regs-&gt;hfnum &amp; 1)
		hc-&gt;hcchar &amp;= ~Oddfrm;
	else
		hc-&gt;hcchar |= Oddfrm;
	hc-&gt;hcchar = (hc-&gt;hcchar &amp;~ Chdis) | Chen;
	return 1;
}

static Reg chanlog[32][5];
static int nchanlog;

static void
logstart(Ep *ep)
{
	if(ep-&gt;debug)
		nchanlog = 0;
}

static void
clog(Ep *ep, Hostchan *hc)
{
	Reg *p;

	if(ep != nil &amp;&amp; !ep-&gt;debug)
		return;
	if(nchanlog == 32)
		nchanlog--;
	p = chanlog[nchanlog];
	p[0] = dwc.regs-&gt;hfnum;
	p[1] = hc-&gt;hcchar;
	p[2] = hc-&gt;hcint;
	p[3] = hc-&gt;hctsiz;
	p[4] = hc-&gt;hcdma;
	nchanlog++;
}

static void
logdump(Ep *ep)
{
	Reg *p;
	int i;

	if(!ep-&gt;debug)
		return;
	p = chanlog[0];
	for(i = 0; i &lt; nchanlog; i++){
		print("%5.5d.%5.5d %8.8ux %8.8ux %8.8ux %8.8ux\n",
			p[0]&amp;0xFFFF, p[0]&gt;&gt;16, p[1], p[2], p[3], p[4]);
		p += 5;
	}
	nchanlog = 0;
}

static int
chanio(Ep *ep, Hostchan *hc, int dir, int pid, void *a, int len)
{
	Ctlr *ctlr;
	int nleft, n, nt, i, maxpkt, npkt;
	uint hcdma, hctsiz;

	ctlr = ep-&gt;hp-&gt;aux;
	maxpkt = ep-&gt;maxpkt;
	npkt = HOWMANY(len, ep-&gt;maxpkt);
	if(npkt == 0)
		npkt = 1;

	hc-&gt;hcchar = (hc-&gt;hcchar &amp; ~Epdir) | dir;
	if(dir == Epin)
		n = ROUND(len, ep-&gt;maxpkt);
	else
		n = len;
	hc-&gt;hctsiz = n | npkt&lt;&lt;OPktcnt | pid;
	hc-&gt;hcdma  = PADDR(a);

	nleft = len;
	logstart(ep);
	for(;;){
		hcdma = hc-&gt;hcdma;
		hctsiz = hc-&gt;hctsiz;
		hc-&gt;hctsiz = hctsiz &amp; ~Dopng;
		if(hc-&gt;hcchar&amp;Chen){
			dprint("ep%d.%d before chanio hcchar=%8.8ux\n",
				ep-&gt;dev-&gt;nb, ep-&gt;nb, hc-&gt;hcchar);
			hc-&gt;hcchar |= Chen | Chdis;
			while(hc-&gt;hcchar&amp;Chen)
				;
			hc-&gt;hcint = Chhltd;
		}
		if((i = hc-&gt;hcint) != 0){
			dprint("ep%d.%d before chanio hcint=%8.8ux\n",
				ep-&gt;dev-&gt;nb, ep-&gt;nb, i);
			hc-&gt;hcint = i;
		}
		if(hc-&gt;hcsplt &amp; Spltena){
			qlock(&amp;ctlr-&gt;split);
			sofwait(ctlr, hc - ctlr-&gt;regs-&gt;hchan);
			if((dwc.regs-&gt;hfnum &amp; 1) == 0)
				hc-&gt;hcchar &amp;= ~Oddfrm;
			else
				hc-&gt;hcchar |= Oddfrm;
		}
		hc-&gt;hcchar = (hc-&gt;hcchar &amp;~ Chdis) | Chen;
		clog(ep, hc);
		if(ep-&gt;ttype == Tbulk &amp;&amp; dir == Epin)
			i = chanwait(ep, ctlr, hc, /* Ack| */ Chhltd);
		else if(ep-&gt;ttype == Tintr &amp;&amp; (hc-&gt;hcsplt &amp; Spltena))
			i = chanwait(ep, ctlr, hc, Chhltd);
		else
			i = chanwait(ep, ctlr, hc, Chhltd|Nak);
		clog(ep, hc);
		hc-&gt;hcint = i;

		if(hc-&gt;hcsplt &amp; Spltena){
			hc-&gt;hcsplt &amp;= ~Compsplt;
			qunlock(&amp;ctlr-&gt;split);
		}

		if((i &amp; Xfercomp) == 0 &amp;&amp; i != (Chhltd|Ack) &amp;&amp; i != Chhltd){
			if(i &amp; Stall)
				error(Estalled);
			if(i &amp; (Nyet|Frmovrun))
				continue;
			if(i &amp; Nak){
				if(ep-&gt;ttype == Tintr)
					tsleep(&amp;up-&gt;sleep, return0, 0, ep-&gt;pollival);
				else
					tsleep(&amp;up-&gt;sleep, return0, 0, 1);
				continue;
			}
			logdump(ep);
			print("usbotg: ep%d.%d error intr %8.8ux\n",
				ep-&gt;dev-&gt;nb, ep-&gt;nb, i);
			if(i &amp; ~(Chhltd|Ack))
				error(Eio);
			if(hc-&gt;hcdma != hcdma)
				print("usbotg: weird hcdma %x-&gt;%x intr %x-&gt;%x\n",
					hcdma, hc-&gt;hcdma, i, hc-&gt;hcint);
		}
		n = hc-&gt;hcdma - hcdma;
		if(n == 0){
			if((hc-&gt;hctsiz &amp; Pktcnt) != (hctsiz &amp; Pktcnt))
				break;
			else
				continue;
		}
		if(dir == Epin &amp;&amp; ep-&gt;ttype == Tbulk &amp;&amp; n == nleft){
			nt = (hctsiz &amp; Xfersize) - (hc-&gt;hctsiz &amp; Xfersize);
			if(nt != n){
				if(n == ROUND(nt, 4))
					n = nt;
				else
					print("usbotg: intr %8.8ux "
						"dma %8.8ux-%8.8ux "
						"hctsiz %8.8ux-%8.ux\n",
						i, hcdma, hc-&gt;hcdma, hctsiz,
						hc-&gt;hctsiz);
			}
		}
		if(n &gt; nleft){
			if(n != ROUND(nleft, 4))
				dprint("too much: wanted %d got %d\n",
					len, len - nleft + n);
			n = nleft;
		}
		nleft -= n;
		if(nleft == 0 || (n % maxpkt) != 0)
			break;
		if((i &amp; Xfercomp) &amp;&amp; ep-&gt;ttype != Tctl)
			break;
		if(dir == Epout)
			dprint("too little: nleft %d hcdma %x-&gt;%x hctsiz %x-&gt;%x intr %x\n",
				nleft, hcdma, hc-&gt;hcdma, hctsiz, hc-&gt;hctsiz, i);
	}
	logdump(ep);
	return len - nleft;
}

static long
multitrans(Ep *ep, Hostchan *hc, int rw, void *a, long n)
{
	long sofar, m;

	sofar = 0;
	do{
		m = n - sofar;
		if(m &gt; ep-&gt;maxpkt)
			m = ep-&gt;maxpkt;
		m = chanio(ep, hc, rw == Read? Epin : Epout, ep-&gt;toggle[rw],
			(char*)a + sofar, m);
		ep-&gt;toggle[rw] = hc-&gt;hctsiz &amp; Pid;
		sofar += m;
	}while(sofar &lt; n &amp;&amp; m == ep-&gt;maxpkt);
	return sofar;
}

static long
eptrans(Ep *ep, int rw, void *a, long n)
{
	Hostchan *hc;

	if(ep-&gt;clrhalt){
		ep-&gt;clrhalt = 0;
		if(ep-&gt;mode != OREAD)
			ep-&gt;toggle[Write] = DATA0;
		if(ep-&gt;mode != OWRITE)
			ep-&gt;toggle[Read] = DATA0;
	}
	hc = chanalloc(ep);
	if(waserror()){
		ep-&gt;toggle[rw] = hc-&gt;hctsiz &amp; Pid;
		chanrelease(ep, hc);
		if(strcmp(up-&gt;errstr, Estalled) == 0)
			return 0;
		nexterror();
	}
	chansetup(hc, ep);
	if(rw == Read &amp;&amp; ep-&gt;ttype == Tbulk)
		n = multitrans(ep, hc, rw, a, n);
	else{
		n = chanio(ep, hc, rw == Read? Epin : Epout, ep-&gt;toggle[rw],
			a, n);
		ep-&gt;toggle[rw] = hc-&gt;hctsiz &amp; Pid;
	}
	chanrelease(ep, hc);
	poperror();
	return n;
}

static long
ctltrans(Ep *ep, uchar *req, long n)
{
	Hostchan *hc;
	Epio *epio;
	Block *b;
	uchar *data;
	int datalen;

	epio = ep-&gt;aux;
	if(epio-&gt;cb != nil){
		freeb(epio-&gt;cb);
		epio-&gt;cb = nil;
	}
	if(n &lt; Rsetuplen)
		error(Ebadlen);
	if(req[Rtype] &amp; Rd2h){
		datalen = GET2(req+Rcount);
		if(datalen &lt;= 0 || datalen &gt; Maxctllen)
			error(Ebadlen);
		/* XXX cache madness */
		epio-&gt;cb = b = allocb(ROUND(datalen, ep-&gt;maxpkt) + CACHELINESZ);
		b-&gt;wp = (uchar*)ROUND((uintptr)b-&gt;wp, CACHELINESZ);
		memset(b-&gt;wp, 0x55, b-&gt;lim - b-&gt;wp);
		cachedwbinvse(b-&gt;wp, b-&gt;lim - b-&gt;wp);
		data = b-&gt;wp;
	}else{
		b = nil;
		datalen = n - Rsetuplen;
		data = req + Rsetuplen;
	}
	hc = chanalloc(ep);
	if(waserror()){
		chanrelease(ep, hc);
		if(strcmp(up-&gt;errstr, Estalled) == 0)
			return 0;
		nexterror();
	}
	chansetup(hc, ep);
	chanio(ep, hc, Epout, SETUP, req, Rsetuplen);
	if(req[Rtype] &amp; Rd2h){
		if(ep-&gt;dev-&gt;hub &lt;= 1){
			ep-&gt;toggle[Read] = DATA1;
			b-&gt;wp += multitrans(ep, hc, Read, data, datalen);
		}else
			b-&gt;wp += chanio(ep, hc, Epin, DATA1, data, datalen);
		chanio(ep, hc, Epout, DATA1, nil, 0);
		n = Rsetuplen;
	}else{
		if(datalen &gt; 0)
			chanio(ep, hc, Epout, DATA1, data, datalen);
		chanio(ep, hc, Epin, DATA1, nil, 0);
		n = Rsetuplen + datalen;
	}
	chanrelease(ep, hc);
	poperror();
	return n;
}

static long
ctldata(Ep *ep, void *a, long n)
{
	Epio *epio;
	Block *b;

	epio = ep-&gt;aux;
	b = epio-&gt;cb;
	if(b == nil)
		return 0;
	if(n &gt; BLEN(b))
		n = BLEN(b);
	memmove(a, b-&gt;rp, n);
	b-&gt;rp += n;
	if(BLEN(b) == 0){
		freeb(b);
		epio-&gt;cb = nil;
	}
	return n;
}

static void
greset(Dwcregs *r, int bits)
{
	r-&gt;grstctl |= bits;
	while(r-&gt;grstctl &amp; bits)
		;
	microdelay(10);
}

static void
init(Hci *hp)
{
	Ctlr *ctlr;
	Dwcregs *r;
	uint n, rx, tx, ptx;

	ctlr = hp-&gt;aux;
	r = ctlr-&gt;regs;

	ctlr-&gt;nchan = 1 + ((r-&gt;ghwcfg2 &amp; Num_host_chan) &gt;&gt; ONum_host_chan);
	ctlr-&gt;chanintr = malloc(ctlr-&gt;nchan * sizeof(Rendez));

	r-&gt;gahbcfg = 0;
	setpower(PowerUsb, 1);

	while((r-&gt;grstctl&amp;Ahbidle) == 0)
		;
	greset(r, Csftrst);

	r-&gt;gusbcfg |= Force_host_mode;
	tsleep(&amp;up-&gt;sleep, return0, 0, 25);
	r-&gt;gahbcfg |= Dmaenable;

	n = (r-&gt;ghwcfg3 &amp; Dfifo_depth) &gt;&gt; ODfifo_depth;
	rx = 0x306;
	tx = 0x100;
	ptx = 0x200;
	r-&gt;grxfsiz = rx;
	r-&gt;gnptxfsiz = rx | tx&lt;&lt;ODepth;
	tsleep(&amp;up-&gt;sleep, return0, 0, 1);
	r-&gt;hptxfsiz = (rx + tx) | ptx &lt;&lt; ODepth;
	greset(r, Rxfflsh);
	r-&gt;grstctl = TXF_ALL;
	greset(r, Txfflsh);
	dprint("usbotg: FIFO depth %d sizes rx/nptx/ptx %8.8ux %8.8ux %8.8ux\n",
		n, r-&gt;grxfsiz, r-&gt;gnptxfsiz, r-&gt;hptxfsiz);

	r-&gt;hport0 = Prtpwr|Prtconndet|Prtenchng|Prtovrcurrchng;
	r-&gt;gintsts = ~0;
	r-&gt;gintmsk = Hcintr;
	r-&gt;gahbcfg |= Glblintrmsk;
}

static void
dump(Hci*)
{
}

static void
fiqintr(Ureg*, void *a)
{
	Hci *hp;
	Ctlr *ctlr;
	Dwcregs *r;
	uint intr, haint, wakechan;
	int i;

	hp = a;
	ctlr = hp-&gt;aux;
	r = ctlr-&gt;regs;
	wakechan = 0;
	intr = r-&gt;gintsts;
	if(intr &amp; Hcintr){
		haint = r-&gt;haint &amp; r-&gt;haintmsk;
		for(i = 0; haint; i++){
			if(haint &amp; 1){
				if(chanintr(ctlr, i) == 0){
					r-&gt;haintmsk &amp;= ~(1&lt;&lt;i);
					wakechan |= 1&lt;&lt;i;
				}
			}
			haint &gt;&gt;= 1;
		}
	}
	if(intr &amp; Sofintr){
		r-&gt;gintsts = Sofintr;
		if((r-&gt;hfnum&amp;7) != 6){
			r-&gt;gintmsk &amp;= ~Sofintr;
			wakechan |= ctlr-&gt;sofchan;
			ctlr-&gt;sofchan = 0;
		}
	}
	if(wakechan){
		ctlr-&gt;wakechan |= wakechan;
		armtimerset(1);
	}
}

static void
irqintr(Ureg*, void *a)
{
	Ctlr *ctlr;
	uint wakechan;
	int i, x;

	ctlr = a;
	x = splfhi();
	armtimerset(0);
	wakechan = ctlr-&gt;wakechan;
	ctlr-&gt;wakechan = 0;
	splx(x);
	for(i = 0; wakechan; i++){
		if(wakechan &amp; 1)
			wakeup(&amp;ctlr-&gt;chanintr[i]);
		wakechan &gt;&gt;= 1;
	}
}

static void
epopen(Ep *ep)
{
	ddprint("usbotg: epopen ep%d.%d ttype %d\n",
		ep-&gt;dev-&gt;nb, ep-&gt;nb, ep-&gt;ttype);
	switch(ep-&gt;ttype){
	case Tnone:
		error(Enotconf);
	case Tintr:
		assert(ep-&gt;pollival &gt; 0);
		/* fall through */
	case Tbulk:
		if(ep-&gt;toggle[Read] == 0)
			ep-&gt;toggle[Read] = DATA0;
		if(ep-&gt;toggle[Write] == 0)
			ep-&gt;toggle[Write] = DATA0;
		break;
	}
	ep-&gt;aux = malloc(sizeof(Epio));
	if(ep-&gt;aux == nil)
		error(Enomem);
}

static void
epclose(Ep *ep)
{
	ddprint("usbotg: epclose ep%d.%d ttype %d\n",
		ep-&gt;dev-&gt;nb, ep-&gt;nb, ep-&gt;ttype);
	switch(ep-&gt;ttype){
	case Tctl:
		freeb(((Epio*)ep-&gt;aux)-&gt;cb);
		/* fall through */
	default:
		free(ep-&gt;aux);
		break;
	}
}

static long
epread(Ep *ep, void *a, long n)
{
	Epio *epio;
	Block *b;
	uchar *p;
	ulong elapsed;
	long nr;

	ddprint("epread ep%d.%d %ld\n", ep-&gt;dev-&gt;nb, ep-&gt;nb, n);
	epio = ep-&gt;aux;
	b = nil;
	qlock(epio);
	if(waserror()){
		qunlock(epio);
		if(b)
			freeb(b);
		nexterror();
	}
	switch(ep-&gt;ttype){
	default:
		error(Egreg);
	case Tctl:
		nr = ctldata(ep, a, n);
		qunlock(epio);
		poperror();
		return nr;
	case Tintr:
		elapsed = TK2MS(m-&gt;ticks) - epio-&gt;lastpoll;
		if(elapsed &lt; ep-&gt;pollival)
			tsleep(&amp;up-&gt;sleep, return0, 0, ep-&gt;pollival - elapsed);
		/* fall through */
	case Tbulk:
		/* XXX cache madness */
		b = allocb(ROUND(n, ep-&gt;maxpkt) + CACHELINESZ);
		p = (uchar*)ROUND((uintptr)b-&gt;base, CACHELINESZ);
		cachedwbinvse(p, n);
		nr = eptrans(ep, Read, p, n);
		epio-&gt;lastpoll = TK2MS(m-&gt;ticks);
		memmove(a, p, nr);
		qunlock(epio);
		freeb(b);
		poperror();
		return nr;
	}
}

static long
epwrite(Ep *ep, void *a, long n)
{
	Epio *epio;
	Block *b;
	uchar *p;
	ulong elapsed;

	ddprint("epwrite ep%d.%d %ld\n", ep-&gt;dev-&gt;nb, ep-&gt;nb, n);
	epio = ep-&gt;aux;
	b = nil;
	qlock(epio);
	if(waserror()){
		qunlock(epio);
		if(b)
			freeb(b);
		nexterror();
	}
	switch(ep-&gt;ttype){
	default:
		error(Egreg);
	case Tintr:
		elapsed = TK2MS(m-&gt;ticks) - epio-&gt;lastpoll;
		if(elapsed &lt; ep-&gt;pollival)
			tsleep(&amp;up-&gt;sleep, return0, 0, ep-&gt;pollival - elapsed);
		/* fall through */
	case Tctl:
	case Tbulk:
		/* XXX cache madness */
		b = allocb(n + CACHELINESZ);
		p = (uchar*)ROUND((uintptr)b-&gt;base, CACHELINESZ);
		memmove(p, a, n);
		cachedwbse(p, n);
		if(ep-&gt;ttype == Tctl)
			n = ctltrans(ep, p, n);
		else{
			n = eptrans(ep, Write, p, n);
			epio-&gt;lastpoll = TK2MS(m-&gt;ticks);
		}
		qunlock(epio);
		freeb(b);
		poperror();
		return n;
	}
}

static char*
seprintep(char *s, char*, Ep*)
{
	return s;
}
	
static int
portenable(Hci *hp, int port, int on)
{
	Ctlr *ctlr;
	Dwcregs *r;

	assert(port == 1);
	ctlr = hp-&gt;aux;
	r = ctlr-&gt;regs;
	dprint("usbotg enable=%d; sts %#x\n", on, r-&gt;hport0);
	if(!on)
		r-&gt;hport0 = Prtpwr | Prtena;
	tsleep(&amp;up-&gt;sleep, return0, 0, Enabledelay);
	dprint("usbotg enable=%d; sts %#x\n", on, r-&gt;hport0);
	return 0;
}

static int
portreset(Hci *hp, int port, int on)
{
	Ctlr *ctlr;
	Dwcregs *r;
	int b, s;

	assert(port == 1);
	ctlr = hp-&gt;aux;
	r = ctlr-&gt;regs;
	dprint("usbotg reset=%d; sts %#x\n", on, r-&gt;hport0);
	if(!on)
		return 0;
	r-&gt;hport0 = Prtpwr | Prtrst;
	tsleep(&amp;up-&gt;sleep, return0, 0, ResetdelayHS);
	r-&gt;hport0 = Prtpwr;
	tsleep(&amp;up-&gt;sleep, return0, 0, Enabledelay);
	s = r-&gt;hport0;
	b = s &amp; (Prtconndet|Prtenchng|Prtovrcurrchng);
	if(b != 0)
		r-&gt;hport0 = Prtpwr | b;
	dprint("usbotg reset=%d; sts %#x\n", on, s);
	if((s &amp; Prtena) == 0)
		print("usbotg: host port not enabled after reset");
	return 0;
}

static int
portstatus(Hci *hp, int port)
{
	Ctlr *ctlr;
	Dwcregs *r;
	int b, s;

	assert(port == 1);
	ctlr = hp-&gt;aux;
	r = ctlr-&gt;regs;
	s = r-&gt;hport0;
	b = s &amp; (Prtconndet|Prtenchng|Prtovrcurrchng);
	if(b != 0)
		r-&gt;hport0 = Prtpwr | b;
	b = 0;
	if(s &amp; Prtconnsts)
		b |= HPpresent;
	if(s &amp; Prtconndet)
		b |= HPstatuschg;
	if(s &amp; Prtena)
		b |= HPenable;
	if(s &amp; Prtenchng)
		b |= HPchange;
	if(s &amp; Prtovrcurract)
		 b |= HPovercurrent;
	if(s &amp; Prtsusp)
		b |= HPsuspend;
	if(s &amp; Prtrst)
		b |= HPreset;
	if(s &amp; Prtpwr)
		b |= HPpower;
	switch(s &amp; Prtspd){
	case HIGHSPEED:
		b |= HPhigh;
		break;
	case LOWSPEED:
		b |= HPslow;
		break;
	}
	return b;
}

static void
shutdown(Hci*)
{
}

static void
setdebug(Hci*, int d)
{
	debug = d;
}

static int
reset(Hci *hp)
{
	Ctlr *ctlr;
	uint id;

	ctlr = &amp;dwc;
	if(ctlr-&gt;regs != nil)
		return -1;
	ctlr-&gt;regs = (Dwcregs*)USBREGS;
	id = ctlr-&gt;regs-&gt;gsnpsid;
	if((id&gt;&gt;16) != ('O'&lt;&lt;8 | 'T'))
		return -1;
	dprint("usbotg: rev %d.%3.3x\n", (id&gt;&gt;12)&amp;0xF, id&amp;0xFFF);

	intrenable(IRQtimerArm, irqintr, ctlr, 0, "dwc");

	hp-&gt;aux = ctlr;
	hp-&gt;port = 0;
	hp-&gt;irq = IRQusb;
	hp-&gt;tbdf = 0;
	hp-&gt;nports = 1;
	hp-&gt;highspeed = 1;

	hp-&gt;init = init;
	hp-&gt;dump = dump;
	hp-&gt;interrupt = fiqintr;
	hp-&gt;epopen = epopen;
	hp-&gt;epclose = epclose;
	hp-&gt;epread = epread;
	hp-&gt;epwrite = epwrite;
	hp-&gt;seprintep = seprintep;
	hp-&gt;portenable = portenable;
	hp-&gt;portreset = portreset;
	hp-&gt;portstatus = portstatus;
	hp-&gt;shutdown = shutdown;
	hp-&gt;debug = setdebug;
	hp-&gt;type = "dwcotg";
	return 0;
}

void
usbdwclink(void)
{
	addhcitype("dwcotg", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

