<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/boot/usb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/boot/usb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* usb support */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "../boot/boot.h"

#define PARTSRV "partfs.sdXX"

enum {
	Dontpost,
	Post,
};

static char usbdisk0[] = "/dev/sdU0.0";
static char sdxxctl[]  = "/dev/sdXX/ctl";

/*
 * run argv[0] (short name is name) and wait awhile for file to appear.
 * file must be generated by running argv[0]; if it already exists, we're done.
 */
static int
start(char *name, char **argv, char *file)
{
	int cnt;

	if(access(file, AEXIST) &gt;= 0)
		return 0;
	if(access(argv[0], AEXIST) &lt; 0) {
		fprint(2, "no %s...", argv[0]);
		return -1;
	}

	dprint("%s...", name);
	runv(argv);
	for(cnt = 10; cnt &gt; 0 &amp;&amp; access(file, AEXIST) &lt; 0; cnt--)
		sleep(100);
	if (cnt &lt;= 0) {
		dprint("no %s...", file);
		return -1;
	}
	return 0;
}

int
chmod(char *file, int mode)
{
	Dir *dir;

	dir = dirstat(file);
	if (dir == nil) {
		dprint("can't stat %s: %r\n", file);
		return -1;
	}
	dir-&gt;mode &amp;= ~0777;
	dir-&gt;mode |= mode &amp; 0777;
	dirwstat("/srv/" PARTSRV, dir);
	free(dir);
	return 0;
}

/* start partfs on first usb disk, if any.  optionally post partfs in /srv. */
static int
startpartfs(int post)
{
	int r, i;
	char *parts;
	char *partfsv[32];

	if(access(usbdisk0, AEXIST) &lt; 0)
		return -1;	/* can't run partfs until usbd is mounted */

	if (post)
		remove("/srv/" PARTSRV);

	i = 0;
	partfsv[i++] = "/boot/partfs";
	/*
	 * hack for booting from usb: if /env/sdB0part (from 9load) exists,
	 * pass it to partfs for sdXX.
	 */
	parts = getenv("sdB0part");
	if (parts != nil) {
		partfsv[i++] = "-p";
		partfsv[i++] = parts;
	}
	if (post) {
		partfsv[i++] = "-s";
		partfsv[i++] = PARTSRV;
	}
	partfsv[i++] = usbdisk0;
	partfsv[i] = nil;
	r = start("partfs", partfsv, sdxxctl);

	if (post)
		chmod("/srv/" PARTSRV, 0666);
	return r;
}

static int
mountusb(void)
{
	int fd;

	dprint("mount usbd...");
	fd = open("/srv/usb", ORDWR);
	if(fd &lt; 0)
		warning("can't open /srv/usb");
	else if(mount(fd, -1, "/dev", MBEFORE, "") &lt; 0) {
		warning("mount -a /srv/usb /dev");
		close(fd);
	} else
		return 0;		/* mount closed fd */
	return -1;
}

int
mountusbparts(void)
{
	mountusb();
	return startpartfs(Post);
}

/*
 *  start usbd, which mounts itself on /dev.
 *  start partfs on first disk, if any, to permit nvram on usb.
 */
void
usbinit(int post)
{
	int cnt;
	static char *usbdv[] = { "/boot/usbd", nil };

	if(access("#u/usb/ctl", AEXIST) &lt; 0 || bind("#u", "/dev", MAFTER) &lt; 0)
		return;
	dprint("usbinit...");
	start("usbd", usbdv, "/srv/usb");

	/* allow a little time for usbd's device discovery */
	for(cnt = 20; cnt &gt; 0 &amp;&amp; access(usbdisk0, AEXIST) &lt; 0; cnt--)
		sleep(100);
	if(cnt &gt; 0)
		startpartfs(post);
	else
		dprint("no usb disk...");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

