<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/esp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/esp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Encapsulating Security Payload for IPsec for IPv4, rfc1827.
 * extended to IPv6.
 * rfc2104 defines hmac computation.
 *	currently only implements tunnel mode.
 * TODO: verify aes algorithms;
 *	transport mode (host-to-host)
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"
#include	"ipv6.h"
#include	"libsec.h"

#define BITS2BYTES(bi) (((bi) + BI2BY - 1) / BI2BY)
#define BYTES2BITS(by)  ((by) * BI2BY)

typedef struct Algorithm Algorithm;
typedef struct Esp4hdr Esp4hdr;
typedef struct Esp6hdr Esp6hdr;
typedef struct Espcb Espcb;
typedef struct Esphdr Esphdr;
typedef struct Esppriv Esppriv;
typedef struct Esptail Esptail;
typedef struct Userhdr Userhdr;

enum {
	Encrypt,
	Decrypt,

	IP_ESPPROTO	= 50,	/* IP v4 and v6 protocol number */
	Esp4hdrlen	= IP4HDR + 8,
	Esp6hdrlen	= IP6HDR + 8,

	Esptaillen	= 2,	/* does not include pad or auth data */
	Userhdrlen	= 4,	/* user-visible header size - if enabled */

	Desblk	 = BITS2BYTES(64),
	Des3keysz = BITS2BYTES(192),

	Aesblk	 = BITS2BYTES(128),
	Aeskeysz = BITS2BYTES(128),
};

struct Esphdr
{
	uchar	espspi[4];	/* Security parameter index */
	uchar	espseq[4];	/* Sequence number */
	uchar	payload[];
};

/*
 * tunnel-mode (network-to-network, etc.) layout is:
 * new IP hdrs | ESP hdr |
 *	 enc { orig IP hdrs | TCP/UDP hdr | user data | ESP trailer } | ESP ICV
 *
 * transport-mode (host-to-host) layout would be:
 *	orig IP hdrs | ESP hdr |
 *			enc { TCP/UDP hdr | user data | ESP trailer } | ESP ICV
 */
struct Esp4hdr
{
	/* ipv4 header */
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	Unused;
	uchar	espproto;	/* Protocol */
	uchar	espplen[2];	/* Header plus data length */
	uchar	espsrc[4];	/* Ip source */
	uchar	espdst[4];	/* Ip destination */

	Esphdr;
};

/* tunnel-mode layout */
struct Esp6hdr
{
	IPV6HDR;
	Esphdr;
};

struct Esptail
{
	uchar	pad;
	uchar	nexthdr;
};

/* IP-version-dependent data */
typedef struct Versdep Versdep;
struct Versdep
{
	ulong	version;
	ulong	iphdrlen;
	ulong	hdrlen;		/* iphdrlen + esp hdr len */
	ulong	spi;
	uchar	laddr[IPaddrlen];
	uchar	raddr[IPaddrlen];
};

/* header as seen by the user */
struct Userhdr
{
	uchar	nexthdr;	/* next protocol */
	uchar	unused[3];
};

struct Esppriv
{
	uvlong	in;
	ulong	inerrors;
};

/*
 *  protocol specific part of Conv
 */
struct Espcb
{
	int	incoming;
	int	header;		/* user-level header */
	ulong	spi;
	ulong	seq;		/* last seq sent */
	ulong	window;		/* for replay attacks */

	char	*espalg;
	void	*espstate;	/* other state for esp */
	int	espivlen;	/* in bytes */
	int	espblklen;
	int	(*cipher)(Espcb*, uchar *buf, int len);

	char	*ahalg;
	void	*ahstate;	/* other state for esp */
	int	ahlen;		/* auth data length in bytes */
	int	ahblklen;
	int	(*auth)(Espcb*, uchar *buf, int len, uchar *hash);
	DigestState *ds;
};

struct Algorithm
{
	char 	*name;
	int	keylen;		/* in bits */
	void	(*init)(Espcb*, char* name, uchar *key, unsigned keylen);
};

static	Conv* convlookup(Proto *esp, ulong spi);
static	char *setalg(Espcb *ecb, char **f, int n, Algorithm *alg);
static	void espkick(void *x);

static	void nullespinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void des3espinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void aescbcespinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void aesctrespinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void desespinit(Espcb *ecb, char *name, uchar *k, unsigned n);

static	void nullahinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void shaahinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void aesahinit(Espcb*, char*, uchar *key, unsigned keylen);
static	void md5ahinit(Espcb*, char*, uchar *key, unsigned keylen);

static Algorithm espalg[] =
{
	"null",		0,	nullespinit,
	"des3_cbc",	192,	des3espinit,	/* new rfc2451, des-ede3 */
	"aes_128_cbc",	128,	aescbcespinit,	/* new rfc3602 */
	"aes_ctr",	128,	aesctrespinit,	/* new rfc3686 */
	"des_56_cbc",	64,	desespinit,	/* rfc2405, deprecated */
	/* rc4 was never required, was used in original bandt */
//	"rc4_128",	128,	rc4espinit,
	nil,		0,	nil,
};

static Algorithm ahalg[] =
{
	"null",		0,	nullahinit,
	"hmac_sha1_96",	128,	shaahinit,	/* rfc2404 */
	"aes_xcbc_mac_96", 128,	aesahinit,	/* new rfc3566 */
	"hmac_md5_96",	128,	md5ahinit,	/* rfc2403 */
	nil,		0,	nil,
};

static char*
espconnect(Conv *c, char **argv, int argc)
{
	char *p, *pp, *e = nil;
	ulong spi;
	Espcb *ecb = (Espcb*)c-&gt;ptcl;

	switch(argc) {
	default:
		e = "bad args to connect";
		break;
	case 2:
		p = strchr(argv[1], '!');
		if(p == nil){
			e = "malformed address";
			break;
		}
		*p++ = 0;
		if (parseip(c-&gt;raddr, argv[1]) == -1) {
			e = Ebadip;
			break;
		}
		findlocalip(c-&gt;p-&gt;f, c-&gt;laddr, c-&gt;raddr);
		ecb-&gt;incoming = 0;
		ecb-&gt;seq = 0;
		if(strcmp(p, "*") == 0) {
			qlock(c-&gt;p);
			for(;;) {
				spi = nrand(1&lt;&lt;16) + 256;
				if(convlookup(c-&gt;p, spi) == nil)
					break;
			}
			qunlock(c-&gt;p);
			ecb-&gt;spi = spi;
			ecb-&gt;incoming = 1;
			qhangup(c-&gt;wq, nil);
		} else {
			spi = strtoul(p, &amp;pp, 10);
			if(pp == p) {
				e = "malformed address";
				break;
			}
			ecb-&gt;spi = spi;
			qhangup(c-&gt;rq, nil);
		}
		nullespinit(ecb, "null", nil, 0);
		nullahinit(ecb, "null", nil, 0);
	}
	Fsconnected(c, e);

	return e;
}


static int
espstate(Conv *c, char *state, int n)
{
	return snprint(state, n, "%s", c-&gt;inuse?"Open\n":"Closed\n");
}

static void
espcreate(Conv *c)
{
	c-&gt;rq = qopen(64*1024, Qmsg, 0, 0);
	c-&gt;wq = qopen(64*1024, Qkick, espkick, c);
}

static void
espclose(Conv *c)
{
	Espcb *ecb;

	qclose(c-&gt;rq);
	qclose(c-&gt;wq);
	qclose(c-&gt;eq);
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);

	ecb = (Espcb*)c-&gt;ptcl;
	free(ecb-&gt;espstate);
	free(ecb-&gt;ahstate);
	memset(ecb, 0, sizeof(Espcb));
}

static int
convipvers(Conv *c)
{
	if((memcmp(c-&gt;raddr, v4prefix, IPv4off) == 0 &amp;&amp;
	    memcmp(c-&gt;laddr, v4prefix, IPv4off) == 0) ||
	    ipcmp(c-&gt;raddr, IPnoaddr) == 0)
		return V4;
	else
		return V6;
}

static int
pktipvers(Fs *f, Block **bpp)
{
	if (*bpp == nil || BLEN(*bpp) == 0) {
		/* get enough to identify the IP version */
		*bpp = pullupblock(*bpp, IP4HDR);
		if(*bpp == nil) {
			netlog(f, Logesp, "esp: short packet\n");
			return 0;
		}
	}
	return (((Esp4hdr*)(*bpp)-&gt;rp)-&gt;vihl &amp; 0xf0) == IP_VER4? V4: V6;
}

static void
getverslens(int version, Versdep *vp)
{
	vp-&gt;version = version;
	switch(vp-&gt;version) {
	case V4:
		vp-&gt;iphdrlen = IP4HDR;
		vp-&gt;hdrlen   = Esp4hdrlen;
		break;
	case V6:
		vp-&gt;iphdrlen = IP6HDR;
		vp-&gt;hdrlen   = Esp6hdrlen;
		break;
	default:
		panic("esp: getverslens version %d wrong", version);
	}
}

static void
getpktspiaddrs(uchar *pkt, Versdep *vp)
{
	Esp4hdr *eh4;
	Esp6hdr *eh6;

	switch(vp-&gt;version) {
	case V4:
		eh4 = (Esp4hdr*)pkt;
		v4tov6(vp-&gt;raddr, eh4-&gt;espsrc);
		v4tov6(vp-&gt;laddr, eh4-&gt;espdst);
		vp-&gt;spi = nhgetl(eh4-&gt;espspi);
		break;
	case V6:
		eh6 = (Esp6hdr*)pkt;
		ipmove(vp-&gt;raddr, eh6-&gt;src);
		ipmove(vp-&gt;laddr, eh6-&gt;dst);
		vp-&gt;spi = nhgetl(eh6-&gt;espspi);
		break;
	default:
		panic("esp: getpktspiaddrs vp-&gt;version %ld wrong", vp-&gt;version);
	}
}

/*
 * encapsulate next IP packet on x's write queue in IP/ESP packet
 * and initiate output of the result.
 */
static void
espkick(void *x)
{
	int nexthdr, payload, pad, align;
	uchar *auth;
	Block *bp;
	Conv *c = x;
	Esp4hdr *eh4;
	Esp6hdr *eh6;
	Espcb *ecb;
	Esptail *et;
	Userhdr *uh;
	Versdep vers;

	getverslens(convipvers(c), &amp;vers);
	bp = qget(c-&gt;wq);
	if(bp == nil)
		return;

	qlock(c);
	ecb = c-&gt;ptcl;

	if(ecb-&gt;header) {
		/* make sure the message has a User header */
		bp = pullupblock(bp, Userhdrlen);
		if(bp == nil) {
			qunlock(c);
			return;
		}
		uh = (Userhdr*)bp-&gt;rp;
		nexthdr = uh-&gt;nexthdr;
		bp-&gt;rp += Userhdrlen;
	} else {
		nexthdr = 0;	/* what should this be? */
	}

	payload = BLEN(bp) + ecb-&gt;espivlen;

	/* Make space to fit ip header */
	bp = padblock(bp, vers.hdrlen + ecb-&gt;espivlen);
	getpktspiaddrs(bp-&gt;rp, &amp;vers);

	align = 4;
	if(ecb-&gt;espblklen &gt; align)
		align = ecb-&gt;espblklen;
	if(align % ecb-&gt;ahblklen != 0)
		panic("espkick: ahblklen is important after all");
	pad = (align-1) - (payload + Esptaillen-1)%align;

	/*
	 * Make space for tail
	 * this is done by calling padblock with a negative size
	 * Padblock does not change bp-&gt;wp!
	 */
	bp = padblock(bp, -(pad+Esptaillen+ecb-&gt;ahlen));
	bp-&gt;wp += pad+Esptaillen+ecb-&gt;ahlen;

	et = (Esptail*)(bp-&gt;rp + vers.hdrlen + payload + pad);

	/* fill in tail */
	et-&gt;pad = pad;
	et-&gt;nexthdr = nexthdr;

	/* encrypt the payload */
	ecb-&gt;cipher(ecb, bp-&gt;rp + vers.hdrlen, payload + pad + Esptaillen);
	auth = bp-&gt;rp + vers.hdrlen + payload + pad + Esptaillen;

	/* fill in head; construct a new IP header and an ESP header */
	if (vers.version == V4) {
		eh4 = (Esp4hdr *)bp-&gt;rp;
		eh4-&gt;vihl = IP_VER4;
		v6tov4(eh4-&gt;espsrc, c-&gt;laddr);
		v6tov4(eh4-&gt;espdst, c-&gt;raddr);
		eh4-&gt;espproto = IP_ESPPROTO;
		eh4-&gt;frag[0] = 0;
		eh4-&gt;frag[1] = 0;

		hnputl(eh4-&gt;espspi, ecb-&gt;spi);
		hnputl(eh4-&gt;espseq, ++ecb-&gt;seq);
	} else {
		eh6 = (Esp6hdr *)bp-&gt;rp;
		eh6-&gt;vcf[0] = IP_VER6;
		ipmove(eh6-&gt;src, c-&gt;laddr);
		ipmove(eh6-&gt;dst, c-&gt;raddr);
		eh6-&gt;proto = IP_ESPPROTO;

		hnputl(eh6-&gt;espspi, ecb-&gt;spi);
		hnputl(eh6-&gt;espseq, ++ecb-&gt;seq);
	}

	/* compute secure hash */
	ecb-&gt;auth(ecb, bp-&gt;rp + vers.iphdrlen, (vers.hdrlen - vers.iphdrlen) +
		payload + pad + Esptaillen, auth);

	qunlock(c);
	/* print("esp: pass down: %uld\n", BLEN(bp)); */
	if (vers.version == V4)
		ipoput4(c-&gt;p-&gt;f, bp, 0, c-&gt;ttl, c-&gt;tos, c);
	else
		ipoput6(c-&gt;p-&gt;f, bp, 0, c-&gt;ttl, c-&gt;tos, c);
}

/*
 * decapsulate IP packet from IP/ESP packet in bp and
 * pass the result up the spi's Conv's read queue.
 */
void
espiput(Proto *esp, Ipifc*, Block *bp)
{
	int payload, nexthdr;
	uchar *auth, *espspi;
	Conv *c;
	Espcb *ecb;
	Esptail *et;
	Fs *f;
	Userhdr *uh;
	Versdep vers;

	f = esp-&gt;f;

	getverslens(pktipvers(f, &amp;bp), &amp;vers);

	bp = pullupblock(bp, vers.hdrlen + Esptaillen);
	if(bp == nil) {
		netlog(f, Logesp, "esp: short packet\n");
		return;
	}
	getpktspiaddrs(bp-&gt;rp, &amp;vers);

	qlock(esp);
	/* Look for a conversation structure for this port */
	c = convlookup(esp, vers.spi);
	if(c == nil) {
		qunlock(esp);
		netlog(f, Logesp, "esp: no conv %I -&gt; %I!%lud\n", vers.raddr,
			vers.laddr, vers.spi);
		icmpnoconv(f, bp);
		freeblist(bp);
		return;
	}

	qlock(c);
	qunlock(esp);

	ecb = c-&gt;ptcl;
	/* too hard to do decryption/authentication on block lists */
	if(bp-&gt;next)
		bp = concatblock(bp);

	if(BLEN(bp) &lt; vers.hdrlen + ecb-&gt;espivlen + Esptaillen + ecb-&gt;ahlen) {
		qunlock(c);
		netlog(f, Logesp, "esp: short block %I -&gt; %I!%lud\n", vers.raddr,
			vers.laddr, vers.spi);
		freeb(bp);
		return;
	}

	auth = bp-&gt;wp - ecb-&gt;ahlen;
	espspi = vers.version == V4?	((Esp4hdr*)bp-&gt;rp)-&gt;espspi:
					((Esp6hdr*)bp-&gt;rp)-&gt;espspi;

	/* compute secure hash and authenticate */
	if(!ecb-&gt;auth(ecb, espspi, auth - espspi, auth)) {
		qunlock(c);
print("esp: bad auth %I -&gt; %I!%ld\n", vers.raddr, vers.laddr, vers.spi);
		netlog(f, Logesp, "esp: bad auth %I -&gt; %I!%lud\n", vers.raddr,
			vers.laddr, vers.spi);
		freeb(bp);
		return;
	}

	payload = BLEN(bp) - vers.hdrlen - ecb-&gt;ahlen;
	if(payload &lt;= 0 || payload % 4 != 0 || payload % ecb-&gt;espblklen != 0) {
		qunlock(c);
		netlog(f, Logesp, "esp: bad length %I -&gt; %I!%lud payload=%d BLEN=%lud\n",
			vers.raddr, vers.laddr, vers.spi, payload, BLEN(bp));
		freeb(bp);
		return;
	}

	/* decrypt payload */
	if(!ecb-&gt;cipher(ecb, bp-&gt;rp + vers.hdrlen, payload)) {
		qunlock(c);
print("esp: cipher failed %I -&gt; %I!%ld: %s\n", vers.raddr, vers.laddr, vers.spi, up-&gt;errstr);
		netlog(f, Logesp, "esp: cipher failed %I -&gt; %I!%lud: %s\n",
			vers.raddr, vers.laddr, vers.spi, up-&gt;errstr);
		freeb(bp);
		return;
	}

	payload -= Esptaillen;
	et = (Esptail*)(bp-&gt;rp + vers.hdrlen + payload);
	payload -= et-&gt;pad + ecb-&gt;espivlen;
	nexthdr = et-&gt;nexthdr;
	if(payload &lt;= 0) {
		qunlock(c);
		netlog(f, Logesp, "esp: short packet after decrypt %I -&gt; %I!%lud\n",
			vers.raddr, vers.laddr, vers.spi);
		freeb(bp);
		return;
	}

	/* trim packet */
	bp-&gt;rp += vers.hdrlen + ecb-&gt;espivlen; /* toss original IP &amp; ESP hdrs */
	bp-&gt;wp = bp-&gt;rp + payload;
	if(ecb-&gt;header) {
		/* assume Userhdrlen &lt; Esp4hdrlen &lt; Esp6hdrlen */
		bp-&gt;rp -= Userhdrlen;
		uh = (Userhdr*)bp-&gt;rp;
		memset(uh, 0, Userhdrlen);
		uh-&gt;nexthdr = nexthdr;
	}

	/* ingress filtering here? */

	if(qfull(c-&gt;rq)){
		netlog(f, Logesp, "esp: qfull %I -&gt; %I.%uld\n", vers.raddr,
			vers.laddr, vers.spi);
		freeblist(bp);
	}else {
//		print("esp: pass up: %uld\n", BLEN(bp));
		qpass(c-&gt;rq, bp);	/* pass packet up the read queue */
	}

	qunlock(c);
}

char*
espctl(Conv *c, char **f, int n)
{
	Espcb *ecb = c-&gt;ptcl;
	char *e = nil;

	if(strcmp(f[0], "esp") == 0)
		e = setalg(ecb, f, n, espalg);
	else if(strcmp(f[0], "ah") == 0)
		e = setalg(ecb, f, n, ahalg);
	else if(strcmp(f[0], "header") == 0)
		ecb-&gt;header = 1;
	else if(strcmp(f[0], "noheader") == 0)
		ecb-&gt;header = 0;
	else
		e = "unknown control request";
	return e;
}

/* called from icmp(v6) for unreachable hosts, time exceeded, etc. */
void
espadvise(Proto *esp, Block *bp, char *msg)
{
	Conv *c;
	Versdep vers;

	getverslens(pktipvers(esp-&gt;f, &amp;bp), &amp;vers);
	getpktspiaddrs(bp-&gt;rp, &amp;vers);

	qlock(esp);
	c = convlookup(esp, vers.spi);
	if(c != nil) {
		qhangup(c-&gt;rq, msg);
		qhangup(c-&gt;wq, msg);
	}
	qunlock(esp);
	freeblist(bp);
}

int
espstats(Proto *esp, char *buf, int len)
{
	Esppriv *upriv;

	upriv = esp-&gt;priv;
	return snprint(buf, len, "%llud %lud\n",
		upriv-&gt;in,
		upriv-&gt;inerrors);
}

static int
esplocal(Conv *c, char *buf, int len)
{
	Espcb *ecb = c-&gt;ptcl;
	int n;

	qlock(c);
	if(ecb-&gt;incoming)
		n = snprint(buf, len, "%I!%uld\n", c-&gt;laddr, ecb-&gt;spi);
	else
		n = snprint(buf, len, "%I\n", c-&gt;laddr);
	qunlock(c);
	return n;
}

static int
espremote(Conv *c, char *buf, int len)
{
	Espcb *ecb = c-&gt;ptcl;
	int n;

	qlock(c);
	if(ecb-&gt;incoming)
		n = snprint(buf, len, "%I\n", c-&gt;raddr);
	else
		n = snprint(buf, len, "%I!%uld\n", c-&gt;raddr, ecb-&gt;spi);
	qunlock(c);
	return n;
}

static	Conv*
convlookup(Proto *esp, ulong spi)
{
	Conv *c, **p;
	Espcb *ecb;

	for(p=esp-&gt;conv; *p; p++){
		c = *p;
		ecb = c-&gt;ptcl;
		if(ecb-&gt;incoming &amp;&amp; ecb-&gt;spi == spi)
			return c;
	}
	return nil;
}

static char *
setalg(Espcb *ecb, char **f, int n, Algorithm *alg)
{
	uchar *key;
	int c, nbyte, nchar;
	uint i;

	if(n &lt; 2 || n &gt; 3)
		return "bad format";
	for(; alg-&gt;name; alg++)
		if(strcmp(f[1], alg-&gt;name) == 0)
			break;
	if(alg-&gt;name == nil)
		return "unknown algorithm";

	nbyte = (alg-&gt;keylen + 7) &gt;&gt; 3;
	if (n == 2)
		nchar = 0;
	else
		nchar = strlen(f[2]);
	if(nchar != 2 * nbyte)			/* TODO: maybe &lt; is ok */
		return "key not required length";
	/* convert hex digits from ascii, in place */
	for(i=0; i&lt;nchar; i++) {
		c = f[2][i];
		if(c &gt;= '0' &amp;&amp; c &lt;= '9')
			f[2][i] -= '0';
		else if(c &gt;= 'a' &amp;&amp; c &lt;= 'f')
			f[2][i] -= 'a'-10;
		else if(c &gt;= 'A' &amp;&amp; c &lt;= 'F')
			f[2][i] -= 'A'-10;
		else
			return "non-hex character in key";
	}
	/* collapse hex digits into complete bytes in reverse order in key */
	key = smalloc(nbyte);
	for(i = 0; i &lt; nchar &amp;&amp; i/2 &lt; nbyte; i++) {
		c = f[2][nchar-i-1];
		if(i&amp;1)
			c &lt;&lt;= 4;
		key[i/2] |= c;
	}

	alg-&gt;init(ecb, alg-&gt;name, key, alg-&gt;keylen);
	free(key);
	return nil;
}


/*
 * null encryption
 */

static int
nullcipher(Espcb*, uchar*, int)
{
	return 1;
}

static void
nullespinit(Espcb *ecb, char *name, uchar*, unsigned)
{
	ecb-&gt;espalg = name;
	ecb-&gt;espblklen = 1;
	ecb-&gt;espivlen = 0;
	ecb-&gt;cipher = nullcipher;
}

static int
nullauth(Espcb*, uchar*, int, uchar*)
{
	return 1;
}

static void
nullahinit(Espcb *ecb, char *name, uchar*, unsigned)
{
	ecb-&gt;ahalg = name;
	ecb-&gt;ahblklen = 1;
	ecb-&gt;ahlen = 0;
	ecb-&gt;auth = nullauth;
}


/*
 * sha1
 */

static void
seanq_hmac_sha1(uchar hash[SHA1dlen], uchar *t, long tlen, uchar *key, long klen)
{
	int i;
	uchar ipad[Hmacblksz+1], opad[Hmacblksz+1], innerhash[SHA1dlen];
	DigestState *digest;

	memset(ipad, 0x36, Hmacblksz);
	memset(opad, 0x5c, Hmacblksz);
	ipad[Hmacblksz] = opad[Hmacblksz] = 0;
	for(i = 0; i &lt; klen; i++){
		ipad[i] ^= key[i];
		opad[i] ^= key[i];
	}
	digest = sha1(ipad, Hmacblksz, nil, nil);
	sha1(t, tlen, innerhash, digest);
	digest = sha1(opad, Hmacblksz, nil, nil);
	sha1(innerhash, SHA1dlen, hash, digest);
}

static int
shaauth(Espcb *ecb, uchar *t, int tlen, uchar *auth)
{
	int r;
	uchar hash[SHA1dlen];

	memset(hash, 0, SHA1dlen);
	seanq_hmac_sha1(hash, t, tlen, (uchar*)ecb-&gt;ahstate, BITS2BYTES(128));
	r = memcmp(auth, hash, ecb-&gt;ahlen) == 0;
	memmove(auth, hash, ecb-&gt;ahlen);
	return r;
}

static void
shaahinit(Espcb *ecb, char *name, uchar *key, unsigned klen)
{
	if(klen != 128)
		panic("shaahinit: bad keylen");
	klen /= BI2BY;

	ecb-&gt;ahalg = name;
	ecb-&gt;ahblklen = 1;
	ecb-&gt;ahlen = BITS2BYTES(96);
	ecb-&gt;auth = shaauth;
	ecb-&gt;ahstate = smalloc(klen);
	memmove(ecb-&gt;ahstate, key, klen);
}


/*
 * aes
 */

/* ah_aes_xcbc_mac_96, rfc3566 */
static int
aesahauth(Espcb *ecb, uchar *t, int tlen, uchar *auth)
{
	int r;
	uchar hash[AESdlen];

	memset(hash, 0, AESdlen);
	ecb-&gt;ds = hmac_aes(t, tlen, (uchar*)ecb-&gt;ahstate, BITS2BYTES(96), hash,
		ecb-&gt;ds);
	r = memcmp(auth, hash, ecb-&gt;ahlen) == 0;
	memmove(auth, hash, ecb-&gt;ahlen);
	return r;
}

static void
aesahinit(Espcb *ecb, char *name, uchar *key, unsigned klen)
{
	if(klen != 128)
		panic("aesahinit: keylen not 128");
	klen /= BI2BY;

	ecb-&gt;ahalg = name;
	ecb-&gt;ahblklen = 1;
	ecb-&gt;ahlen = BITS2BYTES(96);
	ecb-&gt;auth = aesahauth;
	ecb-&gt;ahstate = smalloc(klen);
	memmove(ecb-&gt;ahstate, key, klen);
}

static int
aescbccipher(Espcb *ecb, uchar *p, int n)	/* 128-bit blocks */
{
	uchar tmp[AESbsize], q[AESbsize];
	uchar *pp, *tp, *ip, *eip, *ep;
	AESstate *ds = ecb-&gt;espstate;

	ep = p + n;
	if(ecb-&gt;incoming) {
		memmove(ds-&gt;ivec, p, AESbsize);
		p += AESbsize;
		while(p &lt; ep){
			memmove(tmp, p, AESbsize);
			aes_decrypt(ds-&gt;dkey, ds-&gt;rounds, p, q);
			memmove(p, q, AESbsize);
			tp = tmp;
			ip = ds-&gt;ivec;
			for(eip = ip + AESbsize; ip &lt; eip; ){
				*p++ ^= *ip;
				*ip++ = *tp++;
			}
		}
	} else {
		memmove(p, ds-&gt;ivec, AESbsize);
		for(p += AESbsize; p &lt; ep; p += AESbsize){
			pp = p;
			ip = ds-&gt;ivec;
			for(eip = ip + AESbsize; ip &lt; eip; )
				*pp++ ^= *ip++;
			aes_encrypt(ds-&gt;ekey, ds-&gt;rounds, p, q);
			memmove(ds-&gt;ivec, q, AESbsize);
			memmove(p, q, AESbsize);
		}
	}
	return 1;
}

static void
aescbcespinit(Espcb *ecb, char *name, uchar *k, unsigned n)
{
	uchar key[Aeskeysz], ivec[Aeskeysz];
	int i;

	n = BITS2BYTES(n);
	if(n &gt; Aeskeysz)
		n = Aeskeysz;
	memset(key, 0, sizeof(key));
	memmove(key, k, n);
	for(i = 0; i &lt; Aeskeysz; i++)
		ivec[i] = nrand(256);
	ecb-&gt;espalg = name;
	ecb-&gt;espblklen = Aesblk;
	ecb-&gt;espivlen = Aesblk;
	ecb-&gt;cipher = aescbccipher;
	ecb-&gt;espstate = smalloc(sizeof(AESstate));
	setupAESstate(ecb-&gt;espstate, key, n /* keybytes */, ivec);
}

static int
aesctrcipher(Espcb *ecb, uchar *p, int n)	/* 128-bit blocks */
{
	uchar tmp[AESbsize], q[AESbsize];
	uchar *pp, *tp, *ip, *eip, *ep;
	AESstate *ds = ecb-&gt;espstate;

	ep = p + n;
	if(ecb-&gt;incoming) {
		memmove(ds-&gt;ivec, p, AESbsize);
		p += AESbsize;
		while(p &lt; ep){
			memmove(tmp, p, AESbsize);
			aes_decrypt(ds-&gt;dkey, ds-&gt;rounds, p, q);
			memmove(p, q, AESbsize);
			tp = tmp;
			ip = ds-&gt;ivec;
			for(eip = ip + AESbsize; ip &lt; eip; ){
				*p++ ^= *ip;
				*ip++ = *tp++;
			}
		}
	} else {
		memmove(p, ds-&gt;ivec, AESbsize);
		for(p += AESbsize; p &lt; ep; p += AESbsize){
			pp = p;
			ip = ds-&gt;ivec;
			for(eip = ip + AESbsize; ip &lt; eip; )
				*pp++ ^= *ip++;
			aes_encrypt(ds-&gt;ekey, ds-&gt;rounds, p, q);
			memmove(ds-&gt;ivec, q, AESbsize);
			memmove(p, q, AESbsize);
		}
	}
	return 1;
}

static void
aesctrespinit(Espcb *ecb, char *name, uchar *k, unsigned n)
{
	uchar key[Aesblk], ivec[Aesblk];
	int i;

	n = BITS2BYTES(n);
	if(n &gt; Aeskeysz)
		n = Aeskeysz;
	memset(key, 0, sizeof(key));
	memmove(key, k, n);
	for(i = 0; i &lt; Aesblk; i++)
		ivec[i] = nrand(256);
	ecb-&gt;espalg = name;
	ecb-&gt;espblklen = Aesblk;
	ecb-&gt;espivlen = Aesblk;
	ecb-&gt;cipher = aesctrcipher;
	ecb-&gt;espstate = smalloc(sizeof(AESstate));
	setupAESstate(ecb-&gt;espstate, key, n /* keybytes */, ivec);
}


/*
 * md5
 */

static void
seanq_hmac_md5(uchar hash[MD5dlen], uchar *t, long tlen, uchar *key, long klen)
{
	int i;
	uchar ipad[Hmacblksz+1], opad[Hmacblksz+1], innerhash[MD5dlen];
	DigestState *digest;

	memset(ipad, 0x36, Hmacblksz);
	memset(opad, 0x5c, Hmacblksz);
	ipad[Hmacblksz] = opad[Hmacblksz] = 0;
	for(i = 0; i &lt; klen; i++){
		ipad[i] ^= key[i];
		opad[i] ^= key[i];
	}
	digest = md5(ipad, Hmacblksz, nil, nil);
	md5(t, tlen, innerhash, digest);
	digest = md5(opad, Hmacblksz, nil, nil);
	md5(innerhash, MD5dlen, hash, digest);
}

static int
md5auth(Espcb *ecb, uchar *t, int tlen, uchar *auth)
{
	uchar hash[MD5dlen];
	int r;

	memset(hash, 0, MD5dlen);
	seanq_hmac_md5(hash, t, tlen, (uchar*)ecb-&gt;ahstate, BITS2BYTES(128));
	r = memcmp(auth, hash, ecb-&gt;ahlen) == 0;
	memmove(auth, hash, ecb-&gt;ahlen);
	return r;
}

static void
md5ahinit(Espcb *ecb, char *name, uchar *key, unsigned klen)
{
	if(klen != 128)
		panic("md5ahinit: bad keylen");
	klen = BITS2BYTES(klen);
	ecb-&gt;ahalg = name;
	ecb-&gt;ahblklen = 1;
	ecb-&gt;ahlen = BITS2BYTES(96);
	ecb-&gt;auth = md5auth;
	ecb-&gt;ahstate = smalloc(klen);
	memmove(ecb-&gt;ahstate, key, klen);
}


/*
 * des, single and triple
 */

static int
descipher(Espcb *ecb, uchar *p, int n)
{
	DESstate *ds = ecb-&gt;espstate;

	if(ecb-&gt;incoming) {
		memmove(ds-&gt;ivec, p, Desblk);
		desCBCdecrypt(p + Desblk, n - Desblk, ds);
	} else {
		memmove(p, ds-&gt;ivec, Desblk);
		desCBCencrypt(p + Desblk, n - Desblk, ds);
	}
	return 1;
}

static int
des3cipher(Espcb *ecb, uchar *p, int n)
{
	DES3state *ds = ecb-&gt;espstate;

	if(ecb-&gt;incoming) {
		memmove(ds-&gt;ivec, p, Desblk);
		des3CBCdecrypt(p + Desblk, n - Desblk, ds);
	} else {
		memmove(p, ds-&gt;ivec, Desblk);
		des3CBCencrypt(p + Desblk, n - Desblk, ds);
	}
	return 1;
}

static void
desespinit(Espcb *ecb, char *name, uchar *k, unsigned n)
{
	uchar key[Desblk], ivec[Desblk];
	int i;

	n = BITS2BYTES(n);
	if(n &gt; Desblk)
		n = Desblk;
	memset(key, 0, sizeof(key));
	memmove(key, k, n);
	for(i = 0; i &lt; Desblk; i++)
		ivec[i] = nrand(256);
	ecb-&gt;espalg = name;
	ecb-&gt;espblklen = Desblk;
	ecb-&gt;espivlen = Desblk;

	ecb-&gt;cipher = descipher;
	ecb-&gt;espstate = smalloc(sizeof(DESstate));
	setupDESstate(ecb-&gt;espstate, key, ivec);
}

static void
des3espinit(Espcb *ecb, char *name, uchar *k, unsigned n)
{
	uchar key[3][Desblk], ivec[Desblk];
	int i;

	n = BITS2BYTES(n);
	if(n &gt; Des3keysz)
		n = Des3keysz;
	memset(key, 0, sizeof(key));
	memmove(key, k, n);
	for(i = 0; i &lt; Desblk; i++)
		ivec[i] = nrand(256);
	ecb-&gt;espalg = name;
	ecb-&gt;espblklen = Desblk;
	ecb-&gt;espivlen = Desblk;

	ecb-&gt;cipher = des3cipher;
	ecb-&gt;espstate = smalloc(sizeof(DES3state));
	setupDES3state(ecb-&gt;espstate, key, ivec);
}


/*
 * interfacing to devip
 */
void
espinit(Fs *fs)
{
	Proto *esp;

	esp = smalloc(sizeof(Proto));
	esp-&gt;priv = smalloc(sizeof(Esppriv));
	esp-&gt;name = "esp";
	esp-&gt;connect = espconnect;
	esp-&gt;announce = nil;
	esp-&gt;ctl = espctl;
	esp-&gt;state = espstate;
	esp-&gt;create = espcreate;
	esp-&gt;close = espclose;
	esp-&gt;rcv = espiput;
	esp-&gt;advise = espadvise;
	esp-&gt;stats = espstats;
	esp-&gt;local = esplocal;
	esp-&gt;remote = espremote;
	esp-&gt;ipproto = IP_ESPPROTO;
	esp-&gt;nc = Nchans;
	esp-&gt;ptclsize = sizeof(Espcb);

	Fsproto(fs, esp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

