<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/ethermedium.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/ethermedium.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "../port/netif.h"
#include "ip.h"
#include "ipv6.h"

typedef struct Etherhdr Etherhdr;
struct Etherhdr
{
	uchar	d[6];
	uchar	s[6];
	uchar	t[2];
};

static uchar ipbroadcast[IPaddrlen] = {
	0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,
};

static uchar etherbroadcast[] = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };

static void	etherread4(void *a);
static void	etherread6(void *a);
static void	etherbind(Ipifc *ifc, int argc, char **argv);
static void	etherunbind(Ipifc *ifc);
static void	etherbwrite(Ipifc *ifc, Block *bp, int version, uchar *ip);
static void	etheraddmulti(Ipifc *ifc, uchar *a, uchar *ia);
static void	etherremmulti(Ipifc *ifc, uchar *a, uchar *ia);
static Block*	multicastarp(Fs *f, Arpent *a, Medium*, uchar *mac);
static void	sendarp(Ipifc *ifc, Arpent *a);
static void	sendgarp(Ipifc *ifc, uchar*);
static int	multicastea(uchar *ea, uchar *ip);
static void	recvarpproc(void*);
static void	resolveaddr6(Ipifc *ifc, Arpent *a);
static void	etherpref2addr(uchar *pref, uchar *ea);

Medium ethermedium =
{
.name=		"ether",
.hsize=		14,
.mintu=		60,
.maxtu=		1514,
.maclen=	6,
.bind=		etherbind,
.unbind=	etherunbind,
.bwrite=	etherbwrite,
.addmulti=	etheraddmulti,
.remmulti=	etherremmulti,
.ares=		arpenter,
.areg=		sendgarp,
.pref2addr=	etherpref2addr,
};

Medium gbemedium =
{
.name=		"gbe",
.hsize=		14,
.mintu=		60,
.maxtu=		9014,
.maclen=	6,
.bind=		etherbind,
.unbind=	etherunbind,
.bwrite=	etherbwrite,
.addmulti=	etheraddmulti,
.remmulti=	etherremmulti,
.ares=		arpenter,
.areg=		sendgarp,
.pref2addr=	etherpref2addr,
};

typedef struct	Etherrock Etherrock;
struct Etherrock
{
	Fs	*f;		/* file system we belong to */
	Proc	*arpp;		/* arp process */
	Proc	*read4p;	/* reading process (v4)*/
	Proc	*read6p;	/* reading process (v6)*/
	Chan	*mchan4;	/* Data channel for v4 */
	Chan	*achan;		/* Arp channel */
	Chan	*cchan4;	/* Control channel for v4 */
	Chan	*mchan6;	/* Data channel for v6 */
	Chan	*cchan6;	/* Control channel for v6 */
};

/*
 *  ethernet arp request
 */
enum
{
	ARPREQUEST	= 1,
	ARPREPLY	= 2,
};

typedef struct Etherarp Etherarp;
struct Etherarp
{
	uchar	d[6];
	uchar	s[6];
	uchar	type[2];
	uchar	hrd[2];
	uchar	pro[2];
	uchar	hln;
	uchar	pln;
	uchar	op[2];
	uchar	sha[6];
	uchar	spa[4];
	uchar	tha[6];
	uchar	tpa[4];
};

static char *nbmsg = "nonblocking";

/*
 *  called to bind an IP ifc to an ethernet device
 *  called with ifc wlock'd
 */
static void
etherbind(Ipifc *ifc, int argc, char **argv)
{
	Chan *mchan4, *cchan4, *achan, *mchan6, *cchan6, *schan;
	char addr[Maxpath];	//char addr[2*KNAMELEN];
	char dir[Maxpath];	//char dir[2*KNAMELEN];
	char *buf;
	int n;
	char *ptr;
	Etherrock *er;

	if(argc &lt; 2)
		error(Ebadarg);

	mchan4 = cchan4 = achan = mchan6 = cchan6 = nil;
	buf = nil;
	if(waserror()){
		if(mchan4 != nil)
			cclose(mchan4);
		if(cchan4 != nil)
			cclose(cchan4);
		if(achan != nil)
			cclose(achan);
		if(mchan6 != nil)
			cclose(mchan6);
		if(cchan6 != nil)
			cclose(cchan6);
		if(buf != nil)
			free(buf);
		nexterror();
	}

	/*
	 *  open ipv4 conversation
	 *
	 *  the dial will fail if the type is already open on
	 *  this device.
	 */
	snprint(addr, sizeof(addr), "%s!0x800", argv[2]);	/* ETIP4 */
	mchan4 = chandial(addr, nil, dir, &amp;cchan4);

	/*
	 *  make it non-blocking
	 */
	devtab[cchan4-&gt;type]-&gt;write(cchan4, nbmsg, strlen(nbmsg), 0);

	/*
	 *  get mac address and speed
	 */
	snprint(addr, sizeof(addr), "%s/stats", argv[2]);
	buf = smalloc(512);
	schan = namec(addr, Aopen, OREAD, 0);
	if(waserror()){
		cclose(schan);
		nexterror();
	}
	n = devtab[schan-&gt;type]-&gt;read(schan, buf, 511, 0);
	cclose(schan);
	poperror();
	buf[n] = 0;

	ptr = strstr(buf, "addr: ");
	if(!ptr)
		error(Eio);
	ptr += 6;
	parsemac(ifc-&gt;mac, ptr, 6);

	ptr = strstr(buf, "mbps: ");
	if(ptr){
		ptr += 6;
		ifc-&gt;mbps = atoi(ptr);
	} else
		ifc-&gt;mbps = 100;

	/*
 	 *  open arp conversation
	 */
	snprint(addr, sizeof(addr), "%s!0x806", argv[2]);	/* ETARP */
	achan = chandial(addr, nil, nil, nil);

	/*
	 *  open ipv6 conversation
	 *
	 *  the dial will fail if the type is already open on
	 *  this device.
	 */
	snprint(addr, sizeof(addr), "%s!0x86DD", argv[2]);	/* ETIP6 */
	mchan6 = chandial(addr, nil, dir, &amp;cchan6);

	/*
	 *  make it non-blocking
	 */
	devtab[cchan6-&gt;type]-&gt;write(cchan6, nbmsg, strlen(nbmsg), 0);

	er = smalloc(sizeof(*er));
	er-&gt;mchan4 = mchan4;
	er-&gt;cchan4 = cchan4;
	er-&gt;achan = achan;
	er-&gt;mchan6 = mchan6;
	er-&gt;cchan6 = cchan6;
	er-&gt;f = ifc-&gt;conv-&gt;p-&gt;f;
	ifc-&gt;arg = er;

	free(buf);
	poperror();

	kproc("etherread4", etherread4, ifc);
	kproc("recvarpproc", recvarpproc, ifc);
	kproc("etherread6", etherread6, ifc);
}

/*
 *  called with ifc wlock'd
 */
static void
etherunbind(Ipifc *ifc)
{
	Etherrock *er = ifc-&gt;arg;

	if(er-&gt;read4p)
		postnote(er-&gt;read4p, 1, "unbind", 0);
	if(er-&gt;read6p)
		postnote(er-&gt;read6p, 1, "unbind", 0);
	if(er-&gt;arpp)
		postnote(er-&gt;arpp, 1, "unbind", 0);

	/* wait for readers to die */
	while(er-&gt;arpp != 0 || er-&gt;read4p != 0 || er-&gt;read6p != 0)
		tsleep(&amp;up-&gt;sleep, return0, 0, 300);

	if(er-&gt;mchan4 != nil)
		cclose(er-&gt;mchan4);
	if(er-&gt;achan != nil)
		cclose(er-&gt;achan);
	if(er-&gt;cchan4 != nil)
		cclose(er-&gt;cchan4);
	if(er-&gt;mchan6 != nil)
		cclose(er-&gt;mchan6);
	if(er-&gt;cchan6 != nil)
		cclose(er-&gt;cchan6);

	free(er);
}

/*
 *  called by ipoput with a single block to write with ifc rlock'd
 */
static void
etherbwrite(Ipifc *ifc, Block *bp, int version, uchar *ip)
{
	Etherhdr *eh;
	Arpent *a;
	uchar mac[6];
	Etherrock *er = ifc-&gt;arg;

	/* get mac address of destination */
	a = arpget(er-&gt;f-&gt;arp, bp, version, ifc, ip, mac);
	if(a){
		/* check for broadcast or multicast */
		bp = multicastarp(er-&gt;f, a, ifc-&gt;m, mac);
		if(bp==nil){
			switch(version){
			case V4:
				sendarp(ifc, a);
				break;
			case V6:
				resolveaddr6(ifc, a);
				break;
			default:
				panic("etherbwrite: version %d", version);
			}
			return;
		}
	}

	/* make it a single block with space for the ether header */
	bp = padblock(bp, ifc-&gt;m-&gt;hsize);
	if(bp-&gt;next)
		bp = concatblock(bp);
	if(BLEN(bp) &lt; ifc-&gt;mintu)
		bp = adjustblock(bp, ifc-&gt;mintu);
	eh = (Etherhdr*)bp-&gt;rp;

	/* copy in mac addresses and ether type */
	memmove(eh-&gt;s, ifc-&gt;mac, sizeof(eh-&gt;s));
	memmove(eh-&gt;d, mac, sizeof(eh-&gt;d));

 	switch(version){
	case V4:
		eh-&gt;t[0] = 0x08;
		eh-&gt;t[1] = 0x00;
		devtab[er-&gt;mchan4-&gt;type]-&gt;bwrite(er-&gt;mchan4, bp, 0);
		break;
	case V6:
		eh-&gt;t[0] = 0x86;
		eh-&gt;t[1] = 0xDD;
		devtab[er-&gt;mchan6-&gt;type]-&gt;bwrite(er-&gt;mchan6, bp, 0);
		break;
	default:
		panic("etherbwrite2: version %d", version);
	}
	ifc-&gt;out++;
}


/*
 *  process to read from the ethernet
 */
static void
etherread4(void *a)
{
	Ipifc *ifc;
	Block *bp;
	Etherrock *er;

	ifc = a;
	er = ifc-&gt;arg;
	er-&gt;read4p = up;	/* hide identity under a rock for unbind */
	if(waserror()){
		er-&gt;read4p = 0;
		pexit("hangup", 1);
	}
	for(;;){
		bp = devtab[er-&gt;mchan4-&gt;type]-&gt;bread(er-&gt;mchan4, ifc-&gt;maxtu, 0);
		if(!canrlock(ifc)){
			freeb(bp);
			continue;
		}
		if(waserror()){
			runlock(ifc);
			nexterror();
		}
		ifc-&gt;in++;
		bp-&gt;rp += ifc-&gt;m-&gt;hsize;
		if(ifc-&gt;lifc == nil)
			freeb(bp);
		else
			ipiput4(er-&gt;f, ifc, bp);
		runlock(ifc);
		poperror();
	}
}


/*
 *  process to read from the ethernet, IPv6
 */
static void
etherread6(void *a)
{
	Ipifc *ifc;
	Block *bp;
	Etherrock *er;

	ifc = a;
	er = ifc-&gt;arg;
	er-&gt;read6p = up;	/* hide identity under a rock for unbind */
	if(waserror()){
		er-&gt;read6p = 0;
		pexit("hangup", 1);
	}
	for(;;){
		bp = devtab[er-&gt;mchan6-&gt;type]-&gt;bread(er-&gt;mchan6, ifc-&gt;maxtu, 0);
		if(!canrlock(ifc)){
			freeb(bp);
			continue;
		}
		if(waserror()){
			runlock(ifc);
			nexterror();
		}
		ifc-&gt;in++;
		bp-&gt;rp += ifc-&gt;m-&gt;hsize;
		if(ifc-&gt;lifc == nil)
			freeb(bp);
		else
			ipiput6(er-&gt;f, ifc, bp);
		runlock(ifc);
		poperror();
	}
}

static void
etheraddmulti(Ipifc *ifc, uchar *a, uchar *)
{
	uchar mac[6];
	char buf[64];
	Etherrock *er = ifc-&gt;arg;
	int version;

	version = multicastea(mac, a);
	snprint(buf, sizeof buf, "addmulti %E", mac);
	switch(version){
	case V4:
		devtab[er-&gt;cchan4-&gt;type]-&gt;write(er-&gt;cchan4, buf, strlen(buf), 0);
		break;
	case V6:
		devtab[er-&gt;cchan6-&gt;type]-&gt;write(er-&gt;cchan6, buf, strlen(buf), 0);
		break;
	default:
		panic("etheraddmulti: version %d", version);
	}
}

static void
etherremmulti(Ipifc *ifc, uchar *a, uchar *)
{
	uchar mac[6];
	char buf[64];
	Etherrock *er = ifc-&gt;arg;
	int version;

	version = multicastea(mac, a);
	snprint(buf, sizeof buf, "remmulti %E", mac);
	switch(version){
	case V4:
		devtab[er-&gt;cchan4-&gt;type]-&gt;write(er-&gt;cchan4, buf, strlen(buf), 0);
		break;
	case V6:
		devtab[er-&gt;cchan6-&gt;type]-&gt;write(er-&gt;cchan6, buf, strlen(buf), 0);
		break;
	default:
		panic("etherremmulti: version %d", version);
	}
}

/*
 *  send an ethernet arp
 *  (only v4, v6 uses the neighbor discovery, rfc1970)
 */
static void
sendarp(Ipifc *ifc, Arpent *a)
{
	int n;
	Block *bp;
	Etherarp *e;
	Etherrock *er = ifc-&gt;arg;

	/* don't do anything if it's been less than a second since the last */
	if(NOW - a-&gt;ctime &lt; 1000){
		arprelease(er-&gt;f-&gt;arp, a);
		return;
	}

	/* remove all but the last message */
	while((bp = a-&gt;hold) != nil){
		if(bp == a-&gt;last)
			break;
		a-&gt;hold = bp-&gt;list;
		freeblist(bp);
	}

	/* try to keep it around for a second more */
	a-&gt;ctime = NOW;
	arprelease(er-&gt;f-&gt;arp, a);

	n = sizeof(Etherarp);
	if(n &lt; a-&gt;type-&gt;mintu)
		n = a-&gt;type-&gt;mintu;
	bp = allocb(n);
	memset(bp-&gt;rp, 0, n);
	e = (Etherarp*)bp-&gt;rp;
	memmove(e-&gt;tpa, a-&gt;ip+IPv4off, sizeof(e-&gt;tpa));
	ipv4local(ifc, e-&gt;spa);
	memmove(e-&gt;sha, ifc-&gt;mac, sizeof(e-&gt;sha));
	memset(e-&gt;d, 0xff, sizeof(e-&gt;d));		/* ethernet broadcast */
	memmove(e-&gt;s, ifc-&gt;mac, sizeof(e-&gt;s));

	hnputs(e-&gt;type, ETARP);
	hnputs(e-&gt;hrd, 1);
	hnputs(e-&gt;pro, ETIP4);
	e-&gt;hln = sizeof(e-&gt;sha);
	e-&gt;pln = sizeof(e-&gt;spa);
	hnputs(e-&gt;op, ARPREQUEST);
	bp-&gt;wp += n;

	devtab[er-&gt;achan-&gt;type]-&gt;bwrite(er-&gt;achan, bp, 0);
}

static void
resolveaddr6(Ipifc *ifc, Arpent *a)
{
	int sflag;
	Block *bp;
	Etherrock *er = ifc-&gt;arg;
	uchar ipsrc[IPaddrlen];

	/* don't do anything if it's been less than a second since the last */
	if(NOW - a-&gt;ctime &lt; ReTransTimer){
		arprelease(er-&gt;f-&gt;arp, a);
		return;
	}

	/* remove all but the last message */
	while((bp = a-&gt;hold) != nil){
		if(bp == a-&gt;last)
			break;
		a-&gt;hold = bp-&gt;list;
		freeblist(bp);
	}

	/* try to keep it around for a second more */
	a-&gt;ctime = NOW;
	a-&gt;rtime = NOW + ReTransTimer;
	if(a-&gt;rxtsrem &lt;= 0) {
		arprelease(er-&gt;f-&gt;arp, a);
		return;
	}

	a-&gt;rxtsrem--;
	arprelease(er-&gt;f-&gt;arp, a);

	if(sflag = ipv6anylocal(ifc, ipsrc))
		icmpns(er-&gt;f, ipsrc, sflag, a-&gt;ip, TARG_MULTI, ifc-&gt;mac);
}

/*
 *  send a gratuitous arp to refresh arp caches
 */
static void
sendgarp(Ipifc *ifc, uchar *ip)
{
	int n;
	Block *bp;
	Etherarp *e;
	Etherrock *er = ifc-&gt;arg;

	/* don't arp for our initial non address */
	if(ipcmp(ip, IPnoaddr) == 0)
		return;

	n = sizeof(Etherarp);
	if(n &lt; ifc-&gt;m-&gt;mintu)
		n = ifc-&gt;m-&gt;mintu;
	bp = allocb(n);
	memset(bp-&gt;rp, 0, n);
	e = (Etherarp*)bp-&gt;rp;
	memmove(e-&gt;tpa, ip+IPv4off, sizeof(e-&gt;tpa));
	memmove(e-&gt;spa, ip+IPv4off, sizeof(e-&gt;spa));
	memmove(e-&gt;sha, ifc-&gt;mac, sizeof(e-&gt;sha));
	memset(e-&gt;d, 0xff, sizeof(e-&gt;d));		/* ethernet broadcast */
	memmove(e-&gt;s, ifc-&gt;mac, sizeof(e-&gt;s));

	hnputs(e-&gt;type, ETARP);
	hnputs(e-&gt;hrd, 1);
	hnputs(e-&gt;pro, ETIP4);
	e-&gt;hln = sizeof(e-&gt;sha);
	e-&gt;pln = sizeof(e-&gt;spa);
	hnputs(e-&gt;op, ARPREQUEST);
	bp-&gt;wp += n;

	devtab[er-&gt;achan-&gt;type]-&gt;bwrite(er-&gt;achan, bp, 0);
}

static void
recvarp(Ipifc *ifc)
{
	int n;
	Block *ebp, *rbp;
	Etherarp *e, *r;
	uchar ip[IPaddrlen];
	static uchar eprinted[4];
	Etherrock *er = ifc-&gt;arg;

	ebp = devtab[er-&gt;achan-&gt;type]-&gt;bread(er-&gt;achan, ifc-&gt;maxtu, 0);
	if(ebp == nil)
		return;

	e = (Etherarp*)ebp-&gt;rp;
	switch(nhgets(e-&gt;op)) {
	default:
		break;

	case ARPREPLY:
		/* check for machine using my ip address */
		v4tov6(ip, e-&gt;spa);
		if(iplocalonifc(ifc, ip) || ipproxyifc(er-&gt;f, ifc, ip)){
			if(memcmp(e-&gt;sha, ifc-&gt;mac, sizeof(e-&gt;sha)) != 0){
				print("arprep: 0x%E/0x%E also has ip addr %V\n",
					e-&gt;s, e-&gt;sha, e-&gt;spa);
				break;
			}
		}

		/* make sure we're not entering broadcast addresses */
		if(ipcmp(ip, ipbroadcast) == 0 ||
			!memcmp(e-&gt;sha, etherbroadcast, sizeof(e-&gt;sha))){
			print("arprep: 0x%E/0x%E cannot register broadcast address %I\n",
				e-&gt;s, e-&gt;sha, e-&gt;spa);
			break;
		}

		arpenter(er-&gt;f, V4, e-&gt;spa, e-&gt;sha, sizeof(e-&gt;sha), 0);
		break;

	case ARPREQUEST:
		/* don't answer arps till we know who we are */
		if(ifc-&gt;lifc == 0)
			break;

		/* check for machine using my ip or ether address */
		v4tov6(ip, e-&gt;spa);
		if(iplocalonifc(ifc, ip) || ipproxyifc(er-&gt;f, ifc, ip)){
			if(memcmp(e-&gt;sha, ifc-&gt;mac, sizeof(e-&gt;sha)) != 0){
				if (memcmp(eprinted, e-&gt;spa, sizeof(e-&gt;spa))){
					/* print only once */
					print("arpreq: 0x%E also has ip addr %V\n", e-&gt;sha, e-&gt;spa);
					memmove(eprinted, e-&gt;spa, sizeof(e-&gt;spa));
				}
			}
		} else {
			if(memcmp(e-&gt;sha, ifc-&gt;mac, sizeof(e-&gt;sha)) == 0){
				print("arpreq: %V also has ether addr %E\n", e-&gt;spa, e-&gt;sha);
				break;
			}
		}

		/* refresh what we know about sender */
		arpenter(er-&gt;f, V4, e-&gt;spa, e-&gt;sha, sizeof(e-&gt;sha), 1);

		/* answer only requests for our address or systems we're proxying for */
		v4tov6(ip, e-&gt;tpa);
		if(!iplocalonifc(ifc, ip))
		if(!ipproxyifc(er-&gt;f, ifc, ip))
			break;

		n = sizeof(Etherarp);
		if(n &lt; ifc-&gt;mintu)
			n = ifc-&gt;mintu;
		rbp = allocb(n);
		r = (Etherarp*)rbp-&gt;rp;
		memset(r, 0, sizeof(Etherarp));
		hnputs(r-&gt;type, ETARP);
		hnputs(r-&gt;hrd, 1);
		hnputs(r-&gt;pro, ETIP4);
		r-&gt;hln = sizeof(r-&gt;sha);
		r-&gt;pln = sizeof(r-&gt;spa);
		hnputs(r-&gt;op, ARPREPLY);
		memmove(r-&gt;tha, e-&gt;sha, sizeof(r-&gt;tha));
		memmove(r-&gt;tpa, e-&gt;spa, sizeof(r-&gt;tpa));
		memmove(r-&gt;sha, ifc-&gt;mac, sizeof(r-&gt;sha));
		memmove(r-&gt;spa, e-&gt;tpa, sizeof(r-&gt;spa));
		memmove(r-&gt;d, e-&gt;sha, sizeof(r-&gt;d));
		memmove(r-&gt;s, ifc-&gt;mac, sizeof(r-&gt;s));
		rbp-&gt;wp += n;

		devtab[er-&gt;achan-&gt;type]-&gt;bwrite(er-&gt;achan, rbp, 0);
	}
	freeb(ebp);
}

static void
recvarpproc(void *v)
{
	Ipifc *ifc = v;
	Etherrock *er = ifc-&gt;arg;

	er-&gt;arpp = up;
	if(waserror()){
		er-&gt;arpp = 0;
		pexit("hangup", 1);
	}
	for(;;)
		recvarp(ifc);
}

static int
multicastea(uchar *ea, uchar *ip)
{
	int x;

	switch(x = ipismulticast(ip)){
	case V4:
		ea[0] = 0x01;
		ea[1] = 0x00;
		ea[2] = 0x5e;
		ea[3] = ip[13] &amp; 0x7f;
		ea[4] = ip[14];
		ea[5] = ip[15];
		break;
 	case V6:
 		ea[0] = 0x33;
 		ea[1] = 0x33;
 		ea[2] = ip[12];
		ea[3] = ip[13];
 		ea[4] = ip[14];
 		ea[5] = ip[15];
 		break;
	}
	return x;
}

/*
 *  fill in an arp entry for broadcast or multicast
 *  addresses.  Return the first queued packet for the
 *  IP address.
 */
static Block*
multicastarp(Fs *f, Arpent *a, Medium *medium, uchar *mac)
{
	/* is it broadcast? */
	switch(ipforme(f, a-&gt;ip)){
	case Runi:
		return nil;
	case Rbcast:
		memset(mac, 0xff, 6);
		return arpresolve(f-&gt;arp, a, medium, mac);
	default:
		break;
	}

	/* if multicast, fill in mac */
	switch(multicastea(mac, a-&gt;ip)){
	case V4:
	case V6:
		return arpresolve(f-&gt;arp, a, medium, mac);
	}

	/* let arp take care of it */
	return nil;
}

void
ethermediumlink(void)
{
	addipmedium(&amp;ethermedium);
	addipmedium(&amp;gbemedium);
}


static void
etherpref2addr(uchar *pref, uchar *ea)
{
	pref[8] = ea[0] | 0x2;
	pref[9] = ea[1];
	pref[10] = ea[2];
	pref[11] = 0xFF;
	pref[12] = 0xFE;
	pref[13] = ea[3];
	pref[14] = ea[4];
	pref[15] = ea[5];
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

