<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/gre.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/gre.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Generic Routing Encapsulation over IPv4, rfc1702
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ip.h"

enum {
	GRE_IPONLY	= 12,		/* size of ip header */
	GRE_IPPLUSGRE	= 12,		/* minimum size of GRE header */
	IP_GREPROTO	= 47,

	GRErxms		= 200,
	GREtickms	= 100,
	GREmaxxmit	= 10,

	K		= 1024,
	GREqlen		= 256 * K,

	GRE_cksum	= 0x8000,
	GRE_routing	= 0x4000,
	GRE_key		= 0x2000,
	GRE_seq		= 0x1000,

	Nring		= 1 &lt;&lt; 10,	/* power of two, please */
	Ringmask	= Nring - 1,

	GREctlraw	= 0,
	GREctlcooked,
	GREctlretunnel,
	GREctlreport,
	GREctldlsuspend,
	GREctlulsuspend,
	GREctldlresume,
	GREctlulresume,
	GREctlforward,
	GREctlulkey,
	Ncmds,
};

typedef struct GREhdr GREhdr;
struct GREhdr{
	/* ip header */
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	len[2];		/* packet length (including headers) */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* checksum */
	uchar	src[4];		/* Ip source */
	uchar	dst[4];		/* Ip destination */

	/* gre header */
	uchar	flags[2];
	uchar	eproto[2];	/* encapsulation protocol */
};

typedef struct GREpriv GREpriv;
struct GREpriv{
	/* non-MIB stats */
	ulong	lenerr;			/* short packet */
};

typedef struct Bring	Bring;
struct Bring{
	Block	*ring[Nring];
	long	produced;
	long	consumed;
};

typedef struct GREconv	GREconv;
struct GREconv{
	int	raw;

	/* Retunnelling information.  v4 only */
	uchar	north[4];			/* HA */
	uchar	south[4];			/* Base station */
	uchar	hoa[4];				/* Home address */
	uchar	coa[4];				/* Careof address */
	ulong	seq;				/* Current sequence # */
	int	dlsusp;				/* Downlink suspended? */
	int	ulsusp;				/* Uplink suspended? */
	ulong	ulkey;				/* GRE key */

	QLock	lock;				/* Lock for rings */
	Bring	dlpending;			/* Ring of pending packets */
	Bring	dlbuffered;			/* Received while suspended */
	Bring	ulbuffered;			/* Received while suspended */
};

typedef struct Metablock Metablock;
struct Metablock{
	uchar	*rp;
	ulong	seq;
};

static char *grectlcooked(Conv *, int, char **);
static char *grectldlresume(Conv *, int, char **);
static char *grectldlsuspend(Conv *, int, char **);
static char *grectlforward(Conv *, int, char **);
static char *grectlraw(Conv *, int, char **);
static char *grectlreport(Conv *, int, char **);
static char *grectlretunnel(Conv *, int, char **);
static char *grectlulkey(Conv *, int, char **);
static char *grectlulresume(Conv *, int, char **);
static char *grectlulsuspend(Conv *, int, char **);

static struct{
	char	*cmd;
	int	argc;
	char	*(*f)(Conv *, int, char **);
} grectls[Ncmds] = {
[GREctlraw]	=	{	"raw",		1,	grectlraw,	},
[GREctlcooked]	=	{	"cooked",	1,	grectlcooked,	},
[GREctlretunnel]=	{	"retunnel",	5,	grectlretunnel,	},
[GREctlreport]	=	{	"report",	2,	grectlreport,	},
[GREctldlsuspend]=	{	"dlsuspend",	1,	grectldlsuspend,},
[GREctlulsuspend]=	{	"ulsuspend",	1,	grectlulsuspend,},
[GREctldlresume]=	{	"dlresume",	1,	grectldlresume,	},
[GREctlulresume]=	{	"ulresume",	1,	grectlulresume,	},
[GREctlforward]	=	{	"forward",	2,	grectlforward,	},
[GREctlulkey]	=	{	"ulkey",	2,	grectlulkey,	},
};

static uchar nulladdr[4];
static char *sessend = "session end";

static void grekick(void *x, Block *bp);
static char *gresetup(Conv *, char *, char *, char *);

ulong grepdin, grepdout, grebdin, grebdout;
ulong grepuin, grepuout, grebuin, grebuout;

static Block *
getring(Bring *r)
{
	Block *bp;

	if(r-&gt;consumed == r-&gt;produced)
		return nil;

	bp = r-&gt;ring[r-&gt;consumed &amp; Ringmask];
	r-&gt;ring[r-&gt;consumed &amp; Ringmask] = nil;
	r-&gt;consumed++;
	return bp;
}

static void
addring(Bring *r, Block *bp)
{
	Block *tbp;

	if(r-&gt;produced - r-&gt;consumed &gt; Ringmask){
		/* Full! */
		tbp = r-&gt;ring[r-&gt;produced &amp; Ringmask];
		assert(tbp);
		freeb(tbp);
		r-&gt;consumed++;
	}
	r-&gt;ring[r-&gt;produced &amp; Ringmask] = bp;
	r-&gt;produced++;
}

static char *
greconnect(Conv *c, char **argv, int argc)
{
	Proto *p;
	char *err;
	Conv *tc, **cp, **ecp;

	err = Fsstdconnect(c, argv, argc);
	if(err != nil)
		return err;

	/* make sure noone's already connected to this other sys */
	p = c-&gt;p;
	qlock(p);
	ecp = &amp;p-&gt;conv[p-&gt;nc];
	for(cp = p-&gt;conv; cp &lt; ecp; cp++){
		tc = *cp;
		if(tc == nil)
			break;
		if(tc == c)
			continue;
		if(tc-&gt;rport == c-&gt;rport &amp;&amp; ipcmp(tc-&gt;raddr, c-&gt;raddr) == 0){
			err = "already connected to that addr/proto";
			ipmove(c-&gt;laddr, IPnoaddr);
			ipmove(c-&gt;raddr, IPnoaddr);
			break;
		}
	}
	qunlock(p);

	if(err != nil)
		return err;
	Fsconnected(c, nil);

	return nil;
}

static void
grecreate(Conv *c)
{
	c-&gt;rq = qopen(GREqlen, Qmsg, 0, c);
	c-&gt;wq = qbypass(grekick, c);
}

static int
grestate(Conv *c, char *state, int n)
{
	GREconv *grec;
	char *ep, *p;

	grec = c-&gt;ptcl;
	p    = state;
	ep   = p + n;
	p    = seprint(p, ep, "%s%s%s%shoa %V north %V south %V seq %ulx "
	 "pending %uld  %uld buffered dl %uld %uld ul %uld %uld ulkey %.8ulx\n",
			c-&gt;inuse? "Open ": "Closed ",
			grec-&gt;raw? "raw ": "",
			grec-&gt;dlsusp? "DL suspended ": "",
			grec-&gt;ulsusp? "UL suspended ": "",
			grec-&gt;hoa, grec-&gt;north, grec-&gt;south, grec-&gt;seq,
			grec-&gt;dlpending.consumed, grec-&gt;dlpending.produced,
			grec-&gt;dlbuffered.consumed, grec-&gt;dlbuffered.produced,
			grec-&gt;ulbuffered.consumed, grec-&gt;ulbuffered.produced,
			grec-&gt;ulkey);
	return p - state;
}

static char*
greannounce(Conv*, char**, int)
{
	return "gre does not support announce";
}

static void
greclose(Conv *c)
{
	GREconv *grec;
	Block *bp;

	grec = c-&gt;ptcl;

	/* Make sure we don't forward any more packets */
	memset(grec-&gt;hoa, 0, sizeof grec-&gt;hoa);
	memset(grec-&gt;north, 0, sizeof grec-&gt;north);
	memset(grec-&gt;south, 0, sizeof grec-&gt;south);

	qlock(&amp;grec-&gt;lock);
	while((bp = getring(&amp;grec-&gt;dlpending)) != nil)
		freeb(bp);

	while((bp = getring(&amp;grec-&gt;dlbuffered)) != nil)
		freeb(bp);

	while((bp = getring(&amp;grec-&gt;ulbuffered)) != nil)
		freeb(bp);

	grec-&gt;dlpending.produced = grec-&gt;dlpending.consumed = 0;
	grec-&gt;dlbuffered.produced = grec-&gt;dlbuffered.consumed = 0;
	grec-&gt;ulbuffered.produced = grec-&gt;ulbuffered.consumed = 0;
	qunlock(&amp;grec-&gt;lock);

	grec-&gt;raw = 0;
	grec-&gt;seq = 0;
	grec-&gt;dlsusp = grec-&gt;ulsusp = 1;

	qhangup(c-&gt;rq, sessend);
	qhangup(c-&gt;wq, sessend);
	qhangup(c-&gt;eq, sessend);
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);
	c-&gt;lport = c-&gt;rport = 0;
}

static void
grekick(void *x, Block *bp)
{
	Conv *c;
	GREconv *grec;
	GREhdr *gre;
	uchar laddr[IPaddrlen], raddr[IPaddrlen];

	if(bp == nil)
		return;

	c    = x;
	grec = c-&gt;ptcl;

	/* Make space to fit ip header (gre header already there) */
	bp = padblock(bp, GRE_IPONLY);
	if(bp == nil)
		return;

	/* make sure the message has a GRE header */
	bp = pullupblock(bp, GRE_IPONLY+GRE_IPPLUSGRE);
	if(bp == nil)
		return;

	gre = (GREhdr *)bp-&gt;rp;
	gre-&gt;vihl = IP_VER4;

	if(grec-&gt;raw == 0){
		v4tov6(raddr, gre-&gt;dst);
		if(ipcmp(raddr, v4prefix) == 0)
			memmove(gre-&gt;dst, c-&gt;raddr + IPv4off, IPv4addrlen);
		v4tov6(laddr, gre-&gt;src);
		if(ipcmp(laddr, v4prefix) == 0){
			if(ipcmp(c-&gt;laddr, IPnoaddr) == 0)
				/* pick interface closest to dest */
				findlocalip(c-&gt;p-&gt;f, c-&gt;laddr, raddr);
			memmove(gre-&gt;src, c-&gt;laddr + IPv4off, sizeof gre-&gt;src);
		}
		hnputs(gre-&gt;eproto, c-&gt;rport);
	}

	gre-&gt;proto = IP_GREPROTO;
	gre-&gt;frag[0] = gre-&gt;frag[1] = 0;

	grepdout++;
	grebdout += BLEN(bp);
	ipoput4(c-&gt;p-&gt;f, bp, 0, c-&gt;ttl, c-&gt;tos, nil);
}

static void
gredownlink(Conv *c, Block *bp)
{
	Metablock *m;
	GREconv *grec;
	GREhdr *gre;
	int hdrlen, suspended, extra;
	ushort flags;
	ulong seq;

	gre = (GREhdr *)bp-&gt;rp;
	if(gre-&gt;ttl == 1){
		freeb(bp);
		return;
	}

	/*
	 * We've received a packet with a GRE header and we need to
	 * re-adjust the packet header to strip all unwanted parts
	 * but leave room for only a sequence number.
	 */
	grec   = c-&gt;ptcl;
	flags  = nhgets(gre-&gt;flags);
	hdrlen = 0;
	if(flags &amp; GRE_cksum)
		hdrlen += 2;
	if(flags &amp; GRE_routing){
		print("%V routing info present.  Discarding packet", gre-&gt;src);
		freeb(bp);
		return;
	}
	if(flags &amp; (GRE_cksum|GRE_routing))
		hdrlen += 2;			/* Offset field */
	if(flags &amp; GRE_key)
		hdrlen += 4;
	if(flags &amp; GRE_seq)
		hdrlen += 4;

	/*
	 * The outgoing packet only has the sequence number set.  Make room
	 * for the sequence number.
	 */
	if(hdrlen != sizeof(ulong)){
		extra = hdrlen - sizeof(ulong);
		if(extra &lt; 0 &amp;&amp; bp-&gt;rp - bp-&gt;base &lt; -extra){
			print("gredownlink: cannot add sequence number\n");
			freeb(bp);
			return;
		}
		memmove(bp-&gt;rp + extra, bp-&gt;rp, sizeof(GREhdr));
		bp-&gt;rp += extra;
		assert(BLEN(bp) &gt;= sizeof(GREhdr) + sizeof(ulong));
		gre = (GREhdr *)bp-&gt;rp;
	}
	seq = grec-&gt;seq++;
	hnputs(gre-&gt;flags, GRE_seq);
	hnputl(bp-&gt;rp + sizeof(GREhdr), seq);

	/*
	 * Keep rp and seq at the base.  ipoput4 consumes rp for
	 * refragmentation.
	 */
	assert(bp-&gt;rp - bp-&gt;base &gt;= sizeof(Metablock));
	m = (Metablock *)bp-&gt;base;
	m-&gt;rp  = bp-&gt;rp;
	m-&gt;seq = seq;

	/*
	 * Here we make a decision what we're doing with the packet.  We're
	 * doing this w/o holding a lock which means that later on in the
	 * process we may discover we've done the wrong thing.  I don't want
	 * to call ipoput with the lock held.
	 */
restart:
	suspended = grec-&gt;dlsusp;
	if(suspended){
		if(!canqlock(&amp;grec-&gt;lock)){
			/*
			 * just give up.  too bad, we lose a packet.  this
			 * is just too hard and my brain already hurts.
			 */
			freeb(bp);
			return;
		}

		if(!grec-&gt;dlsusp){
			/*
			 * suspend race.  We though we were suspended, but
			 * we really weren't.
			 */
			qunlock(&amp;grec-&gt;lock);
			goto restart;
		}

		/* Undo the incorrect ref count addition */
		addring(&amp;grec-&gt;dlbuffered, bp);
		qunlock(&amp;grec-&gt;lock);
		return;
	}

	/*
	 * When we get here, we're not suspended.  Proceed to send the
	 * packet.
	 */
	memmove(gre-&gt;src, grec-&gt;coa, sizeof gre-&gt;dst);
	memmove(gre-&gt;dst, grec-&gt;south, sizeof gre-&gt;dst);

	/*
	 * Make sure the packet does not go away.
	 */
	_xinc(&amp;bp-&gt;ref);
	assert(bp-&gt;ref == 2);

	ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
	grepdout++;
	grebdout += BLEN(bp);

	/*
	 * Now make sure we didn't do the wrong thing.
	 */
	if(!canqlock(&amp;grec-&gt;lock)){
		freeb(bp);		/* The packet just goes away */
		return;
	}

	/* We did the right thing */
	addring(&amp;grec-&gt;dlpending, bp);
	qunlock(&amp;grec-&gt;lock);
}

static void
greuplink(Conv *c, Block *bp)
{
	GREconv *grec;
	GREhdr *gre;
	ushort flags;

	gre = (GREhdr *)bp-&gt;rp;
	if(gre-&gt;ttl == 1)
		return;

	grec = c-&gt;ptcl;
	memmove(gre-&gt;src, grec-&gt;coa, sizeof gre-&gt;src);
	memmove(gre-&gt;dst, grec-&gt;north, sizeof gre-&gt;dst);

	/*
	 * Add a key, if needed.
	 */
	if(grec-&gt;ulkey){
		flags = nhgets(gre-&gt;flags);
		if(flags &amp; (GRE_cksum|GRE_routing)){
			print("%V routing info present.  Discarding packet\n",
				gre-&gt;src);
			freeb(bp);
			return;
		}

		if((flags &amp; GRE_key) == 0){
			/* Make room for the key */
			if(bp-&gt;rp - bp-&gt;base &lt; sizeof(ulong)){
				print("%V can't add key\n", gre-&gt;src);
				freeb(bp);
				return;
			}

			bp-&gt;rp -= 4;
			memmove(bp-&gt;rp, bp-&gt;rp + 4, sizeof(GREhdr));

			gre = (GREhdr *)bp-&gt;rp;
			hnputs(gre-&gt;flags, flags | GRE_key);
		}

		/* Add the key */
		hnputl(bp-&gt;rp + sizeof(GREhdr), grec-&gt;ulkey);
	}

	if(!canqlock(&amp;grec-&gt;lock)){
		freeb(bp);
		return;
	}

	if(grec-&gt;ulsusp)
		addring(&amp;grec-&gt;ulbuffered, bp);
	else{
		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
		grepuout++;
		grebuout += BLEN(bp);
	}
	qunlock(&amp;grec-&gt;lock);
}

static void
greiput(Proto *proto, Ipifc *, Block *bp)
{
	int len, hdrlen;
	ushort eproto, flags;
	uchar raddr[IPaddrlen];
	Conv *c, **p;
	GREconv *grec;
	GREhdr *gre;
	GREpriv *gpriv;
	Ip4hdr *ip;

	/*
	 * We don't want to deal with block lists.  Ever.  The problem is
	 * that when the block is forwarded, devether.c puts the block into
	 * a queue that also uses -&gt;next.  Just do not use -&gt;next here!
	 */
	if(bp-&gt;next){
		len = blocklen(bp);
		bp  = pullupblock(bp, len);
		assert(BLEN(bp) == len &amp;&amp; bp-&gt;next == nil);
	}

	gre = (GREhdr *)bp-&gt;rp;
	if(BLEN(bp) &lt; sizeof(GREhdr) || gre-&gt;proto != IP_GREPROTO){
		freeb(bp);
		return;
	}

	v4tov6(raddr, gre-&gt;src);
	eproto = nhgets(gre-&gt;eproto);
	flags  = nhgets(gre-&gt;flags);
	hdrlen = sizeof(GREhdr);

	if(flags &amp; GRE_cksum)
		hdrlen += 2;
	if(flags &amp; GRE_routing){
		print("%I routing info present.  Discarding packet\n", raddr);
		freeb(bp);
		return;
	}
	if(flags &amp; (GRE_cksum|GRE_routing))
		hdrlen += 2;			/* Offset field */
	if(flags &amp; GRE_key)
		hdrlen += 4;
	if(flags &amp; GRE_seq)
		hdrlen += 4;

	if(BLEN(bp) - hdrlen &lt; sizeof(Ip4hdr)){
		print("greretunnel: packet too short (s=%V d=%V)\n",
			gre-&gt;src, gre-&gt;dst);
		freeb(bp);
		return;
	}
	ip = (Ip4hdr *)(bp-&gt;rp + hdrlen);

	qlock(proto);
	/*
	 * Look for a conversation structure for this port and address, or
	 * match the retunnel part, or match on the raw flag.
	 */
	for(p = proto-&gt;conv; *p; p++) {
		c = *p;

		if(c-&gt;inuse == 0)
			continue;

		/*
		 * Do not stop this session - blocking here
		 * implies that etherread is blocked.
		 */
		grec = c-&gt;ptcl;
		if(memcmp(ip-&gt;dst, grec-&gt;hoa, sizeof ip-&gt;dst) == 0){
			grepdin++;
			grebdin += BLEN(bp);
			gredownlink(c, bp);
			qunlock(proto);
			return;
		}

		if(memcmp(ip-&gt;src, grec-&gt;hoa, sizeof ip-&gt;src) == 0){
			grepuin++;
			grebuin += BLEN(bp);
			greuplink(c, bp);
			qunlock(proto);
			return;
		}
	}

	/*
	 * when we get here, none of the forwarding tunnels matched.  now
	 * try to match on raw and conversational sessions.
	 */
	for(c = nil, p = proto-&gt;conv; *p; p++) {
		c = *p;

		if(c-&gt;inuse == 0)
			continue;

		/*
		 * Do not stop this session - blocking here
		 * implies that etherread is blocked.
		 */
		grec = c-&gt;ptcl;
		if(c-&gt;rport == eproto &amp;&amp;
		    (grec-&gt;raw || ipcmp(c-&gt;raddr, raddr) == 0))
			break;
	}

	qunlock(proto);

	if(*p == nil){
		freeb(bp);
		return;
	}

	/*
	 * Trim the packet down to data size
	 */
	len = nhgets(gre-&gt;len) - GRE_IPONLY;
	if(len &lt; GRE_IPPLUSGRE){
		freeb(bp);
		return;
	}

	bp = trimblock(bp, GRE_IPONLY, len);
	if(bp == nil){
		gpriv = proto-&gt;priv;
		gpriv-&gt;lenerr++;
		return;
	}

	/*
	 *  Can't delimit packet so pull it all into one block.
	 */
	if(qlen(c-&gt;rq) &gt; GREqlen)
		freeb(bp);
	else{
		bp = concatblock(bp);
		if(bp == 0)
			panic("greiput");
		qpass(c-&gt;rq, bp);
	}
}

int
grestats(Proto *gre, char *buf, int len)
{
	GREpriv *gpriv;

	gpriv = gre-&gt;priv;
	return snprint(buf, len,
		"gre: %lud %lud %lud %lud %lud %lud %lud %lud, lenerrs %lud\n",
		grepdin, grepdout, grepuin, grepuout,
		grebdin, grebdout, grebuin, grebuout, gpriv-&gt;lenerr);
}

static char *
grectlraw(Conv *c, int, char **)
{
	GREconv *grec;

	grec = c-&gt;ptcl;
	grec-&gt;raw = 1;
	return nil;
}

static char *
grectlcooked(Conv *c, int, char **)
{
	GREconv *grec;

	grec = c-&gt;ptcl;
	grec-&gt;raw = 0;
	return nil;
}

static char *
grectlretunnel(Conv *c, int, char **argv)
{
	GREconv *grec;
	uchar ipaddr[4];

	grec = c-&gt;ptcl;
	if(memcmp(grec-&gt;hoa, nulladdr, sizeof grec-&gt;hoa))
		return "tunnel already set up";

	v4parseip(ipaddr, argv[1]);
	if(memcmp(ipaddr, nulladdr, sizeof ipaddr) == 0)
		return "bad hoa";
	memmove(grec-&gt;hoa, ipaddr, sizeof grec-&gt;hoa);
	v4parseip(ipaddr, argv[2]);
	memmove(grec-&gt;north, ipaddr, sizeof grec-&gt;north);
	v4parseip(ipaddr, argv[3]);
	memmove(grec-&gt;south, ipaddr, sizeof grec-&gt;south);
	v4parseip(ipaddr, argv[4]);
	memmove(grec-&gt;coa, ipaddr, sizeof grec-&gt;coa);
	grec-&gt;ulsusp = 1;
	grec-&gt;dlsusp = 0;

	return nil;
}

static char *
grectlreport(Conv *c, int, char **argv)
{
	ulong seq;
	Block *bp;
	Bring *r;
	GREconv *grec;
	Metablock *m;

	grec = c-&gt;ptcl;
	seq  = strtoul(argv[1], nil, 0);

	qlock(&amp;grec-&gt;lock);
	r = &amp;grec-&gt;dlpending;
	while(r-&gt;produced - r-&gt;consumed &gt; 0){
		bp = r-&gt;ring[r-&gt;consumed &amp; Ringmask];

		assert(bp &amp;&amp; bp-&gt;rp - bp-&gt;base &gt;= sizeof(Metablock));
		m = (Metablock *)bp-&gt;base;
		if((long)(seq - m-&gt;seq) &lt;= 0)
			break;

		r-&gt;ring[r-&gt;consumed &amp; Ringmask] = nil;
		r-&gt;consumed++;

		freeb(bp);
	}
	qunlock(&amp;grec-&gt;lock);
	return nil;
}

static char *
grectldlsuspend(Conv *c, int, char **)
{
	GREconv *grec;

	grec = c-&gt;ptcl;
	if(grec-&gt;dlsusp)
		return "already suspended";

	grec-&gt;dlsusp = 1;
	return nil;
}

static char *
grectlulsuspend(Conv *c, int, char **)
{
	GREconv *grec;

	grec = c-&gt;ptcl;
	if(grec-&gt;ulsusp)
		return "already suspended";

	grec-&gt;ulsusp = 1;
	return nil;
}

static char *
grectldlresume(Conv *c, int, char **)
{
	GREconv *grec;
	GREhdr *gre;
	Block *bp;

	grec = c-&gt;ptcl;

	qlock(&amp;grec-&gt;lock);
	if(!grec-&gt;dlsusp){
		qunlock(&amp;grec-&gt;lock);
		return "not suspended";
	}

	while((bp = getring(&amp;grec-&gt;dlbuffered)) != nil){
		gre = (GREhdr *)bp-&gt;rp;
		qunlock(&amp;grec-&gt;lock);

		/*
		 * Make sure the packet does not go away.
		 */
		_xinc(&amp;bp-&gt;ref);
		assert(bp-&gt;ref == 2);

		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);

		qlock(&amp;grec-&gt;lock);
		addring(&amp;grec-&gt;dlpending, bp);
	}
	grec-&gt;dlsusp = 0;
	qunlock(&amp;grec-&gt;lock);
	return nil;
}

static char *
grectlulresume(Conv *c, int, char **)
{
	GREconv *grec;
	GREhdr *gre;
	Block *bp;

	grec = c-&gt;ptcl;

	qlock(&amp;grec-&gt;lock);
	while((bp = getring(&amp;grec-&gt;ulbuffered)) != nil){
		gre = (GREhdr *)bp-&gt;rp;

		qunlock(&amp;grec-&gt;lock);
		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
		qlock(&amp;grec-&gt;lock);
	}
	grec-&gt;ulsusp = 0;
	qunlock(&amp;grec-&gt;lock);
	return nil;
}

static char *
grectlforward(Conv *c, int, char **argv)
{
	int len;
	Block *bp, *nbp;
	GREconv *grec;
	GREhdr *gre;
	Metablock *m;

	grec = c-&gt;ptcl;

	v4parseip(grec-&gt;south, argv[1]);
	memmove(grec-&gt;north, grec-&gt;south, sizeof grec-&gt;north);

	qlock(&amp;grec-&gt;lock);
	if(!grec-&gt;dlsusp){
		qunlock(&amp;grec-&gt;lock);
		return "not suspended";
	}
	grec-&gt;dlsusp = 0;
	grec-&gt;ulsusp = 0;

	while((bp = getring(&amp;grec-&gt;dlpending)) != nil){

		assert(bp-&gt;rp - bp-&gt;base &gt;= sizeof(Metablock));
		m = (Metablock *)bp-&gt;base;
		assert(m-&gt;rp &gt;= bp-&gt;base &amp;&amp; m-&gt;rp &lt; bp-&gt;lim);

		/*
		 * If the packet is still held inside the IP transmit
		 * system, make a copy of the packet first.
		 */
		if(bp-&gt;ref &gt; 1){
			len = bp-&gt;wp - m-&gt;rp;
			nbp = allocb(len);
			memmove(nbp-&gt;wp, m-&gt;rp, len);
			nbp-&gt;wp += len;
			freeb(bp);
			bp  = nbp;
		}
		else{
			/* Patch up rp */
			bp-&gt;rp = m-&gt;rp;
		}

		gre = (GREhdr *)bp-&gt;rp;
		memmove(gre-&gt;src, grec-&gt;coa, sizeof gre-&gt;dst);
		memmove(gre-&gt;dst, grec-&gt;south, sizeof gre-&gt;dst);

		qunlock(&amp;grec-&gt;lock);
		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
		qlock(&amp;grec-&gt;lock);
	}

	while((bp = getring(&amp;grec-&gt;dlbuffered)) != nil){
		gre = (GREhdr *)bp-&gt;rp;
		memmove(gre-&gt;src, grec-&gt;coa, sizeof gre-&gt;dst);
		memmove(gre-&gt;dst, grec-&gt;south, sizeof gre-&gt;dst);

		qunlock(&amp;grec-&gt;lock);
		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
		qlock(&amp;grec-&gt;lock);
	}

	while((bp = getring(&amp;grec-&gt;ulbuffered)) != nil){
		gre = (GREhdr *)bp-&gt;rp;

		memmove(gre-&gt;src, grec-&gt;coa, sizeof gre-&gt;dst);
		memmove(gre-&gt;dst, grec-&gt;south, sizeof gre-&gt;dst);

		qunlock(&amp;grec-&gt;lock);
		ipoput4(c-&gt;p-&gt;f, bp, 0, gre-&gt;ttl - 1, gre-&gt;tos, nil);
		qlock(&amp;grec-&gt;lock);
	}
	qunlock(&amp;grec-&gt;lock);
	return nil;
}

static char *
grectlulkey(Conv *c, int, char **argv)
{
	GREconv *grec;

	grec = c-&gt;ptcl;
	grec-&gt;ulkey = strtoul(argv[1], nil, 0);
	return nil;
}

char *
grectl(Conv *c, char **f, int n)
{
	int i;

	if(n &lt; 1)
		return "too few arguments";

	for(i = 0; i &lt; Ncmds; i++)
		if(strcmp(f[0], grectls[i].cmd) == 0)
			break;

	if(i == Ncmds)
		return "no such command";
	if(grectls[i].argc != 0 &amp;&amp; grectls[i].argc != n)
		return "incorrect number of arguments";

	return grectls[i].f(c, n, f);
}

void
greinit(Fs *fs)
{
	Proto *gre;

	gre = smalloc(sizeof(Proto));
	gre-&gt;priv = smalloc(sizeof(GREpriv));
	gre-&gt;name = "gre";
	gre-&gt;connect = greconnect;
	gre-&gt;announce = greannounce;
	gre-&gt;state = grestate;
	gre-&gt;create = grecreate;
	gre-&gt;close = greclose;
	gre-&gt;rcv = greiput;
	gre-&gt;ctl = grectl;
	gre-&gt;advise = nil;
	gre-&gt;stats = grestats;
	gre-&gt;ipproto = IP_GREPROTO;
	gre-&gt;nc = 64;
	gre-&gt;ptclsize = sizeof(GREconv);

	Fsproto(fs, gre);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

