<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/icmp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/icmp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"

#include "ip.h"

typedef struct Icmp {
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	ipcksum[2];	/* Header checksum */
	uchar	src[4];		/* Ip source */
	uchar	dst[4];		/* Ip destination */
	uchar	type;
	uchar	code;
	uchar	cksum[2];
	uchar	icmpid[2];
	uchar	seq[2];
	uchar	data[1];
} Icmp;

enum {			/* Packet Types */
	EchoReply	= 0,
	Unreachable	= 3,
	SrcQuench	= 4,
	Redirect	= 5,
	EchoRequest	= 8,
	TimeExceed	= 11,
	InParmProblem	= 12,
	Timestamp	= 13,
	TimestampReply	= 14,
	InfoRequest	= 15,
	InfoReply	= 16,
	AddrMaskRequest = 17,
	AddrMaskReply   = 18,

	Maxtype		= 18,
};

enum
{
	MinAdvise	= 24,	/* minimum needed for us to advise another protocol */
};

char *icmpnames[Maxtype+1] =
{
[EchoReply]		"EchoReply",
[Unreachable]		"Unreachable",
[SrcQuench]		"SrcQuench",
[Redirect]		"Redirect",
[EchoRequest]		"EchoRequest",
[TimeExceed]		"TimeExceed",
[InParmProblem]		"InParmProblem",
[Timestamp]		"Timestamp",
[TimestampReply]	"TimestampReply",
[InfoRequest]		"InfoRequest",
[InfoReply]		"InfoReply",
[AddrMaskRequest]	"AddrMaskRequest",
[AddrMaskReply  ]	"AddrMaskReply  ",
};

enum {
	IP_ICMPPROTO	= 1,
	ICMP_IPSIZE	= 20,
	ICMP_HDRSIZE	= 8,
};

enum
{
	InMsgs,
	InErrors,
	OutMsgs,
	CsumErrs,
	LenErrs,
	HlenErrs,

	Nstats,
};

static char *statnames[Nstats] =
{
[InMsgs]	"InMsgs",
[InErrors]	"InErrors",
[OutMsgs]	"OutMsgs",
[CsumErrs]	"CsumErrs",
[LenErrs]	"LenErrs",
[HlenErrs]	"HlenErrs",
};

typedef struct Icmppriv Icmppriv;
struct Icmppriv
{
	ulong	stats[Nstats];

	/* message counts */
	ulong	in[Maxtype+1];
	ulong	out[Maxtype+1];
};

static void icmpkick(void *x, Block*);

static void
icmpcreate(Conv *c)
{
	c-&gt;rq = qopen(64*1024, Qmsg, 0, c);
	c-&gt;wq = qbypass(icmpkick, c);
}

extern char*
icmpconnect(Conv *c, char **argv, int argc)
{
	char *e;

	e = Fsstdconnect(c, argv, argc);
	if(e != nil)
		return e;
	Fsconnected(c, e);

	return nil;
}

extern int
icmpstate(Conv *c, char *state, int n)
{
	USED(c);
	return snprint(state, n, "%s qin %d qout %d\n",
		"Datagram",
		c-&gt;rq ? qlen(c-&gt;rq) : 0,
		c-&gt;wq ? qlen(c-&gt;wq) : 0
	);
}

extern char*
icmpannounce(Conv *c, char **argv, int argc)
{
	char *e;

	e = Fsstdannounce(c, argv, argc);
	if(e != nil)
		return e;
	Fsconnected(c, nil);

	return nil;
}

extern void
icmpclose(Conv *c)
{
	qclose(c-&gt;rq);
	qclose(c-&gt;wq);
	ipmove(c-&gt;laddr, IPnoaddr);
	ipmove(c-&gt;raddr, IPnoaddr);
	c-&gt;lport = 0;
}

static void
icmpkick(void *x, Block *bp)
{
	Conv *c = x;
	Icmp *p;
	Icmppriv *ipriv;

	if(bp == nil)
		return;

	if(blocklen(bp) &lt; ICMP_IPSIZE + ICMP_HDRSIZE){
		freeblist(bp);
		return;
	}
	p = (Icmp *)(bp-&gt;rp);
	p-&gt;vihl = IP_VER4;
	ipriv = c-&gt;p-&gt;priv;
	if(p-&gt;type &lt;= Maxtype)
		ipriv-&gt;out[p-&gt;type]++;

	v6tov4(p-&gt;dst, c-&gt;raddr);
	v6tov4(p-&gt;src, c-&gt;laddr);
	p-&gt;proto = IP_ICMPPROTO;
	hnputs(p-&gt;icmpid, c-&gt;lport);
	memset(p-&gt;cksum, 0, sizeof(p-&gt;cksum));
	hnputs(p-&gt;cksum, ptclcsum(bp, ICMP_IPSIZE, blocklen(bp) - ICMP_IPSIZE));
	ipriv-&gt;stats[OutMsgs]++;
	ipoput4(c-&gt;p-&gt;f, bp, 0, c-&gt;ttl, c-&gt;tos, nil);
}

extern void
icmpttlexceeded(Fs *f, uchar *ia, Block *bp)
{
	Block	*nbp;
	Icmp	*p, *np;

	p = (Icmp *)bp-&gt;rp;

	netlog(f, Logicmp, "sending icmpttlexceeded -&gt; %V\n", p-&gt;src);
	nbp = allocb(ICMP_IPSIZE + ICMP_HDRSIZE + ICMP_IPSIZE + 8);
	nbp-&gt;wp += ICMP_IPSIZE + ICMP_HDRSIZE + ICMP_IPSIZE + 8;
	np = (Icmp *)nbp-&gt;rp;
	np-&gt;vihl = IP_VER4;
	memmove(np-&gt;dst, p-&gt;src, sizeof(np-&gt;dst));
	v6tov4(np-&gt;src, ia);
	memmove(np-&gt;data, bp-&gt;rp, ICMP_IPSIZE + 8);
	np-&gt;type = TimeExceed;
	np-&gt;code = 0;
	np-&gt;proto = IP_ICMPPROTO;
	hnputs(np-&gt;icmpid, 0);
	hnputs(np-&gt;seq, 0);
	memset(np-&gt;cksum, 0, sizeof(np-&gt;cksum));
	hnputs(np-&gt;cksum, ptclcsum(nbp, ICMP_IPSIZE, blocklen(nbp) - ICMP_IPSIZE));
	ipoput4(f, nbp, 0, MAXTTL, DFLTTOS, nil);

}

static void
icmpunreachable(Fs *f, Block *bp, int code, int seq)
{
	Block	*nbp;
	Icmp	*p, *np;
	int	i;
	uchar	addr[IPaddrlen];

	p = (Icmp *)bp-&gt;rp;

	/* only do this for unicast sources and destinations */
	v4tov6(addr, p-&gt;dst);
	i = ipforme(f, addr);
	if((i&amp;Runi) == 0)
		return;
	v4tov6(addr, p-&gt;src);
	i = ipforme(f, addr);
	if(i != 0 &amp;&amp; (i&amp;Runi) == 0)
		return;

	netlog(f, Logicmp, "sending icmpnoconv -&gt; %V\n", p-&gt;src);
	nbp = allocb(ICMP_IPSIZE + ICMP_HDRSIZE + ICMP_IPSIZE + 8);
	nbp-&gt;wp += ICMP_IPSIZE + ICMP_HDRSIZE + ICMP_IPSIZE + 8;
	np = (Icmp *)nbp-&gt;rp;
	np-&gt;vihl = IP_VER4;
	memmove(np-&gt;dst, p-&gt;src, sizeof(np-&gt;dst));
	memmove(np-&gt;src, p-&gt;dst, sizeof(np-&gt;src));
	memmove(np-&gt;data, bp-&gt;rp, ICMP_IPSIZE + 8);
	np-&gt;type = Unreachable;
	np-&gt;code = code;
	np-&gt;proto = IP_ICMPPROTO;
	hnputs(np-&gt;icmpid, 0);
	hnputs(np-&gt;seq, seq);
	memset(np-&gt;cksum, 0, sizeof(np-&gt;cksum));
	hnputs(np-&gt;cksum, ptclcsum(nbp, ICMP_IPSIZE, blocklen(nbp) - ICMP_IPSIZE));
	ipoput4(f, nbp, 0, MAXTTL, DFLTTOS, nil);
}

extern void
icmpnoconv(Fs *f, Block *bp)
{
	icmpunreachable(f, bp, 3, 0);
}

extern void
icmpcantfrag(Fs *f, Block *bp, int mtu)
{
	icmpunreachable(f, bp, 4, mtu);
}

static void
goticmpkt(Proto *icmp, Block *bp)
{
	Conv	**c, *s;
	Icmp	*p;
	uchar	dst[IPaddrlen];
	ushort	recid;

	p = (Icmp *) bp-&gt;rp;
	v4tov6(dst, p-&gt;src);
	recid = nhgets(p-&gt;icmpid);

	for(c = icmp-&gt;conv; *c; c++) {
		s = *c;
		if(s-&gt;lport == recid)
		if(ipcmp(s-&gt;raddr, dst) == 0){
			bp = concatblock(bp);
			if(bp != nil)
				qpass(s-&gt;rq, bp);
			return;
		}
	}
	freeblist(bp);
}

static Block *
mkechoreply(Block *bp)
{
	Icmp	*q;
	uchar	ip[4];

	q = (Icmp *)bp-&gt;rp;
	q-&gt;vihl = IP_VER4;
	memmove(ip, q-&gt;src, sizeof(q-&gt;dst));
	memmove(q-&gt;src, q-&gt;dst, sizeof(q-&gt;src));
	memmove(q-&gt;dst, ip,  sizeof(q-&gt;dst));
	q-&gt;type = EchoReply;
	memset(q-&gt;cksum, 0, sizeof(q-&gt;cksum));
	hnputs(q-&gt;cksum, ptclcsum(bp, ICMP_IPSIZE, blocklen(bp) - ICMP_IPSIZE));

	return bp;
}

static char *unreachcode[] =
{
[0]	"net unreachable",
[1]	"host unreachable",
[2]	"protocol unreachable",
[3]	"port unreachable",
[4]	"fragmentation needed and DF set",
[5]	"source route failed",
};

static void
icmpiput(Proto *icmp, Ipifc*, Block *bp)
{
	int	n, iplen;
	Icmp	*p;
	Block	*r;
	Proto	*pr;
	char	*msg;
	char	m2[128];
	Icmppriv *ipriv;

	ipriv = icmp-&gt;priv;

	ipriv-&gt;stats[InMsgs]++;

	p = (Icmp *)bp-&gt;rp;
	netlog(icmp-&gt;f, Logicmp, "icmpiput %s (%d) %d\n",
		(p-&gt;type &lt; nelem(icmpnames)? icmpnames[p-&gt;type]: ""),
		p-&gt;type, p-&gt;code);
	n = blocklen(bp);
	if(n &lt; ICMP_IPSIZE+ICMP_HDRSIZE){
		ipriv-&gt;stats[InErrors]++;
		ipriv-&gt;stats[HlenErrs]++;
		netlog(icmp-&gt;f, Logicmp, "icmp hlen %d\n", n);
		goto raise;
	}
	iplen = nhgets(p-&gt;length);
	if(iplen &gt; n){
		ipriv-&gt;stats[LenErrs]++;
		ipriv-&gt;stats[InErrors]++;
		netlog(icmp-&gt;f, Logicmp, "icmp length %d\n", iplen);
		goto raise;
	}
	if(ptclcsum(bp, ICMP_IPSIZE, iplen - ICMP_IPSIZE)){
		ipriv-&gt;stats[InErrors]++;
		ipriv-&gt;stats[CsumErrs]++;
		netlog(icmp-&gt;f, Logicmp, "icmp checksum error\n");
		goto raise;
	}
	if(p-&gt;type &lt;= Maxtype)
		ipriv-&gt;in[p-&gt;type]++;

	switch(p-&gt;type) {
	case EchoRequest:
		if (iplen &lt; n)
			bp = trimblock(bp, 0, iplen);
		r = mkechoreply(concatblock(bp));
		ipriv-&gt;out[EchoReply]++;
		ipoput4(icmp-&gt;f, r, 0, MAXTTL, DFLTTOS, nil);
		break;
	case Unreachable:
		if(p-&gt;code &gt; 5)
			msg = unreachcode[1];
		else
			msg = unreachcode[p-&gt;code];

		bp-&gt;rp += ICMP_IPSIZE+ICMP_HDRSIZE;
		if(blocklen(bp) &lt; MinAdvise){
			ipriv-&gt;stats[LenErrs]++;
			goto raise;
		}
		p = (Icmp *)bp-&gt;rp;
		pr = Fsrcvpcolx(icmp-&gt;f, p-&gt;proto);
		if(pr != nil &amp;&amp; pr-&gt;advise != nil) {
			(*pr-&gt;advise)(pr, bp, msg);
			return;
		}

		bp-&gt;rp -= ICMP_IPSIZE+ICMP_HDRSIZE;
		goticmpkt(icmp, bp);
		break;
	case TimeExceed:
		if(p-&gt;code == 0){
			snprint(m2, sizeof m2, "ttl exceeded at %V", p-&gt;src);

			bp-&gt;rp += ICMP_IPSIZE+ICMP_HDRSIZE;
			if(blocklen(bp) &lt; MinAdvise){
				ipriv-&gt;stats[LenErrs]++;
				goto raise;
			}
			p = (Icmp *)bp-&gt;rp;
			pr = Fsrcvpcolx(icmp-&gt;f, p-&gt;proto);
			if(pr != nil &amp;&amp; pr-&gt;advise != nil) {
				(*pr-&gt;advise)(pr, bp, m2);
				return;
			}
			bp-&gt;rp -= ICMP_IPSIZE+ICMP_HDRSIZE;
		}

		goticmpkt(icmp, bp);
		break;
	default:
		goticmpkt(icmp, bp);
		break;
	}
	return;

raise:
	freeblist(bp);
}

void
icmpadvise(Proto *icmp, Block *bp, char *msg)
{
	Conv	**c, *s;
	Icmp	*p;
	uchar	dst[IPaddrlen];
	ushort	recid;

	p = (Icmp *) bp-&gt;rp;
	v4tov6(dst, p-&gt;dst);
	recid = nhgets(p-&gt;icmpid);

	for(c = icmp-&gt;conv; *c; c++) {
		s = *c;
		if(s-&gt;lport == recid)
		if(ipcmp(s-&gt;raddr, dst) == 0){
			qhangup(s-&gt;rq, msg);
			qhangup(s-&gt;wq, msg);
			break;
		}
	}
	freeblist(bp);
}

int
icmpstats(Proto *icmp, char *buf, int len)
{
	Icmppriv *priv;
	char *p, *e;
	int i;

	priv = icmp-&gt;priv;
	p = buf;
	e = p+len;
	for(i = 0; i &lt; Nstats; i++)
		p = seprint(p, e, "%s: %lud\n", statnames[i], priv-&gt;stats[i]);
	for(i = 0; i &lt;= Maxtype; i++){
		if(icmpnames[i])
			p = seprint(p, e, "%s: %lud %lud\n", icmpnames[i], priv-&gt;in[i], priv-&gt;out[i]);
		else
			p = seprint(p, e, "%d: %lud %lud\n", i, priv-&gt;in[i], priv-&gt;out[i]);
	}
	return p - buf;
}

void
icmpinit(Fs *fs)
{
	Proto *icmp;

	icmp = smalloc(sizeof(Proto));
	icmp-&gt;priv = smalloc(sizeof(Icmppriv));
	icmp-&gt;name = "icmp";
	icmp-&gt;connect = icmpconnect;
	icmp-&gt;announce = icmpannounce;
	icmp-&gt;state = icmpstate;
	icmp-&gt;create = icmpcreate;
	icmp-&gt;close = icmpclose;
	icmp-&gt;rcv = icmpiput;
	icmp-&gt;stats = icmpstats;
	icmp-&gt;ctl = nil;
	icmp-&gt;advise = icmpadvise;
	icmp-&gt;gc = nil;
	icmp-&gt;ipproto = IP_ICMPPROTO;
	icmp-&gt;nc = 128;
	icmp-&gt;ptclsize = 0;

	Fsproto(fs, icmp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

