<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/ip.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/ip.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"

#define BLKIPVER(xp)	(((Ip4hdr*)((xp)-&gt;rp))-&gt;vihl&amp;0xF0)

static char *statnames[] =
{
[Forwarding]	"Forwarding",
[DefaultTTL]	"DefaultTTL",
[InReceives]	"InReceives",
[InHdrErrors]	"InHdrErrors",
[InAddrErrors]	"InAddrErrors",
[ForwDatagrams]	"ForwDatagrams",
[InUnknownProtos]	"InUnknownProtos",
[InDiscards]	"InDiscards",
[InDelivers]	"InDelivers",
[OutRequests]	"OutRequests",
[OutDiscards]	"OutDiscards",
[OutNoRoutes]	"OutNoRoutes",
[ReasmTimeout]	"ReasmTimeout",
[ReasmReqds]	"ReasmReqds",
[ReasmOKs]	"ReasmOKs",
[ReasmFails]	"ReasmFails",
[FragOKs]	"FragOKs",
[FragFails]	"FragFails",
[FragCreates]	"FragCreates",
};

#define BLKIP(xp)	((Ip4hdr*)((xp)-&gt;rp))
/*
 * This sleazy macro relies on the media header size being
 * larger than sizeof(Ipfrag). ipreassemble checks this is true
 */
#define BKFG(xp)	((Ipfrag*)((xp)-&gt;base))

ushort		ipcsum(uchar*);
Block*		ip4reassemble(IP*, int, Block*, Ip4hdr*);
void		ipfragfree4(IP*, Fragment4*);
Fragment4*	ipfragallo4(IP*);

void
ip_init_6(Fs *f)
{
	v6params *v6p;

	v6p = smalloc(sizeof(v6params));

	v6p-&gt;rp.mflag		= 0;		/* default not managed */
	v6p-&gt;rp.oflag		= 0;
	v6p-&gt;rp.maxraint	= 600000;	/* millisecs */
	v6p-&gt;rp.minraint	= 200000;
	v6p-&gt;rp.linkmtu		= 0;		/* no mtu sent */
	v6p-&gt;rp.reachtime	= 0;
	v6p-&gt;rp.rxmitra		= 0;
	v6p-&gt;rp.ttl		= MAXTTL;
	v6p-&gt;rp.routerlt	= 3 * v6p-&gt;rp.maxraint;

	v6p-&gt;hp.rxmithost	= 1000;		/* v6 RETRANS_TIMER */

	v6p-&gt;cdrouter 		= -1;

	f-&gt;v6p			= v6p;
}

void
initfrag(IP *ip, int size)
{
	Fragment4 *fq4, *eq4;
	Fragment6 *fq6, *eq6;

	ip-&gt;fragfree4 = (Fragment4*)malloc(sizeof(Fragment4) * size);
	if(ip-&gt;fragfree4 == nil)
		panic("initfrag");

	eq4 = &amp;ip-&gt;fragfree4[size];
	for(fq4 = ip-&gt;fragfree4; fq4 &lt; eq4; fq4++)
		fq4-&gt;next = fq4+1;

	ip-&gt;fragfree4[size-1].next = nil;

	ip-&gt;fragfree6 = (Fragment6*)malloc(sizeof(Fragment6) * size);
	if(ip-&gt;fragfree6 == nil)
		panic("initfrag");

	eq6 = &amp;ip-&gt;fragfree6[size];
	for(fq6 = ip-&gt;fragfree6; fq6 &lt; eq6; fq6++)
		fq6-&gt;next = fq6+1;

	ip-&gt;fragfree6[size-1].next = nil;
}

void
ip_init(Fs *f)
{
	IP *ip;

	ip = smalloc(sizeof(IP));
	initfrag(ip, 100);
	f-&gt;ip = ip;

	ip_init_6(f);
}

void
iprouting(Fs *f, int on)
{
	f-&gt;ip-&gt;iprouting = on;
	if(f-&gt;ip-&gt;iprouting==0)
		f-&gt;ip-&gt;stats[Forwarding] = 2;
	else
		f-&gt;ip-&gt;stats[Forwarding] = 1;
}

int
ipoput4(Fs *f, Block *bp, int gating, int ttl, int tos, Conv *c)
{
	Ipifc *ifc;
	uchar *gate;
	ulong fragoff;
	Block *xp, *nb;
	Ip4hdr *eh, *feh;
	int lid, len, seglen, chunk, dlen, blklen, offset, medialen;
	Route *r, *sr;
	IP *ip;
	int rv = 0;

	ip = f-&gt;ip;

	/* Fill out the ip header */
	eh = (Ip4hdr*)(bp-&gt;rp);

	ip-&gt;stats[OutRequests]++;

	/* Number of uchars in data and ip header to write */
	len = blocklen(bp);

	if(gating){
		chunk = nhgets(eh-&gt;length);
		if(chunk &gt; len){
			ip-&gt;stats[OutDiscards]++;
			netlog(f, Logip, "short gated packet\n");
			goto free;
		}
		if(chunk &lt; len)
			len = chunk;
	}
	if(len &gt;= IP_MAX){
		ip-&gt;stats[OutDiscards]++;
		netlog(f, Logip, "exceeded ip max size %V\n", eh-&gt;dst);
		goto free;
	}

	r = v4lookup(f, eh-&gt;dst, c);
	if(r == nil){
		ip-&gt;stats[OutNoRoutes]++;
		netlog(f, Logip, "no interface %V\n", eh-&gt;dst);
		rv = -1;
		goto free;
	}

	ifc = r-&gt;ifc;
	if(r-&gt;type &amp; (Rifc|Runi))
		gate = eh-&gt;dst;
	else
	if(r-&gt;type &amp; (Rbcast|Rmulti)) {
		gate = eh-&gt;dst;
		sr = v4lookup(f, eh-&gt;src, nil);
		if(sr != nil &amp;&amp; (sr-&gt;type &amp; Runi))
			ifc = sr-&gt;ifc;
	}
	else
		gate = r-&gt;v4.gate;

	if(!gating)
		eh-&gt;vihl = IP_VER4|IP_HLEN4;
	eh-&gt;ttl = ttl;
	if(!gating)
		eh-&gt;tos = tos;

	if(!canrlock(ifc))
		goto free;
	if(waserror()){
		runlock(ifc);
		nexterror();
	}
	if(ifc-&gt;m == nil)
		goto raise;

	/* If we dont need to fragment just send it */
	if(c &amp;&amp; c-&gt;maxfragsize &amp;&amp; c-&gt;maxfragsize &lt; ifc-&gt;maxtu)
		medialen = c-&gt;maxfragsize - ifc-&gt;m-&gt;hsize;
	else
		medialen = ifc-&gt;maxtu - ifc-&gt;m-&gt;hsize;
	if(len &lt;= medialen) {
		if(!gating)
			hnputs(eh-&gt;id, incref(&amp;ip-&gt;id4));
		hnputs(eh-&gt;length, len);
		if(!gating){
			eh-&gt;frag[0] = 0;
			eh-&gt;frag[1] = 0;
		}
		eh-&gt;cksum[0] = 0;
		eh-&gt;cksum[1] = 0;
		hnputs(eh-&gt;cksum, ipcsum(&amp;eh-&gt;vihl));
		assert(bp-&gt;next == nil);
		ifc-&gt;m-&gt;bwrite(ifc, bp, V4, gate);
		runlock(ifc);
		poperror();
		return 0;
	}

	if((eh-&gt;frag[0] &amp; (IP_DF&gt;&gt;8)) &amp;&amp; !gating)
		print("%V: DF set\n", eh-&gt;dst);

	if(eh-&gt;frag[0] &amp; (IP_DF&gt;&gt;8)){
		ip-&gt;stats[FragFails]++;
		ip-&gt;stats[OutDiscards]++;
		icmpcantfrag(f, bp, medialen);
		netlog(f, Logip, "%V: eh-&gt;frag[0] &amp; (IP_DF&gt;&gt;8)\n", eh-&gt;dst);
		goto raise;
	}

	seglen = (medialen - IP4HDR) &amp; ~7;
	if(seglen &lt; 8){
		ip-&gt;stats[FragFails]++;
		ip-&gt;stats[OutDiscards]++;
		netlog(f, Logip, "%V seglen &lt; 8\n", eh-&gt;dst);
		goto raise;
	}

	dlen = len - IP4HDR;
	xp = bp;
	if(gating)
		lid = nhgets(eh-&gt;id);
	else
		lid = incref(&amp;ip-&gt;id4);

	offset = IP4HDR;
	while(xp != nil &amp;&amp; offset &amp;&amp; offset &gt;= BLEN(xp)) {
		offset -= BLEN(xp);
		xp = xp-&gt;next;
	}
	xp-&gt;rp += offset;

	if(gating)
		fragoff = nhgets(eh-&gt;frag)&lt;&lt;3;
	else
		fragoff = 0;
	dlen += fragoff;
	for(; fragoff &lt; dlen; fragoff += seglen) {
		nb = allocb(IP4HDR+seglen);
		feh = (Ip4hdr*)(nb-&gt;rp);

		memmove(nb-&gt;wp, eh, IP4HDR);
		nb-&gt;wp += IP4HDR;

		if((fragoff + seglen) &gt;= dlen) {
			seglen = dlen - fragoff;
			hnputs(feh-&gt;frag, fragoff&gt;&gt;3);
		}
		else
			hnputs(feh-&gt;frag, (fragoff&gt;&gt;3)|IP_MF);

		hnputs(feh-&gt;length, seglen + IP4HDR);
		hnputs(feh-&gt;id, lid);

		/* Copy up the data area */
		chunk = seglen;
		while(chunk) {
			if(!xp) {
				ip-&gt;stats[OutDiscards]++;
				ip-&gt;stats[FragFails]++;
				freeblist(nb);
				netlog(f, Logip, "!xp: chunk %d\n", chunk);
				goto raise;
			}
			blklen = chunk;
			if(BLEN(xp) &lt; chunk)
				blklen = BLEN(xp);
			memmove(nb-&gt;wp, xp-&gt;rp, blklen);
			nb-&gt;wp += blklen;
			xp-&gt;rp += blklen;
			chunk -= blklen;
			if(xp-&gt;rp == xp-&gt;wp)
				xp = xp-&gt;next;
		}

		feh-&gt;cksum[0] = 0;
		feh-&gt;cksum[1] = 0;
		hnputs(feh-&gt;cksum, ipcsum(&amp;feh-&gt;vihl));
		ifc-&gt;m-&gt;bwrite(ifc, nb, V4, gate);
		ip-&gt;stats[FragCreates]++;
	}
	ip-&gt;stats[FragOKs]++;
raise:
	runlock(ifc);
	poperror();
free:
	freeblist(bp);
	return rv;
}

void
ipiput4(Fs *f, Ipifc *ifc, Block *bp)
{
	int hl;
	int hop, tos, proto, olen;
	Ip4hdr *h;
	Proto *p;
	ushort frag;
	int notforme;
	uchar *dp, v6dst[IPaddrlen];
	IP *ip;
	Route *r;
	Conv conv;

	if(BLKIPVER(bp) != IP_VER4) {
		ipiput6(f, ifc, bp);
		return;
	}

	ip = f-&gt;ip;
	ip-&gt;stats[InReceives]++;

	/*
	 *  Ensure we have all the header info in the first
	 *  block.  Make life easier for other protocols by
	 *  collecting up to the first 64 bytes in the first block.
	 */
	if(BLEN(bp) &lt; 64) {
		hl = blocklen(bp);
		if(hl &lt; IP4HDR)
			hl = IP4HDR;
		if(hl &gt; 64)
			hl = 64;
		bp = pullupblock(bp, hl);
		if(bp == nil)
			return;
	}

	h = (Ip4hdr*)(bp-&gt;rp);

	/* dump anything that whose header doesn't checksum */
	if((bp-&gt;flag &amp; Bipck) == 0 &amp;&amp; ipcsum(&amp;h-&gt;vihl)) {
		ip-&gt;stats[InHdrErrors]++;
		netlog(f, Logip, "ip: checksum error %V\n", h-&gt;src);
		freeblist(bp);
		return;
	}
	v4tov6(v6dst, h-&gt;dst);
	notforme = ipforme(f, v6dst) == 0;

	/* Check header length and version */
	if((h-&gt;vihl&amp;0x0F) != IP_HLEN4) {
		hl = (h-&gt;vihl&amp;0xF)&lt;&lt;2;
		if(hl &lt; (IP_HLEN4&lt;&lt;2)) {
			ip-&gt;stats[InHdrErrors]++;
			netlog(f, Logip, "ip: %V bad hivl %ux\n", h-&gt;src, h-&gt;vihl);
			freeblist(bp);
			return;
		}
		/* If this is not routed strip off the options */
		if(notforme == 0) {
			olen = nhgets(h-&gt;length);
			dp = bp-&gt;rp + (hl - (IP_HLEN4&lt;&lt;2));
			memmove(dp, h, IP_HLEN4&lt;&lt;2);
			bp-&gt;rp = dp;
			h = (Ip4hdr*)(bp-&gt;rp);
			h-&gt;vihl = (IP_VER4|IP_HLEN4);
			hnputs(h-&gt;length, olen-hl+(IP_HLEN4&lt;&lt;2));
		}
	}

	/* route */
	if(notforme) {
		if(!ip-&gt;iprouting){
			freeblist(bp);
			return;
		}

		/* don't forward to source's network */
		memset(&amp;conv, 0, sizeof conv);
		conv.r = nil;
		r = v4lookup(f, h-&gt;dst, &amp;conv);
		if(r == nil || r-&gt;ifc == ifc){
			ip-&gt;stats[OutDiscards]++;
			freeblist(bp);
			return;
		}

		/* don't forward if packet has timed out */
		hop = h-&gt;ttl;
		if(hop &lt; 1) {
			ip-&gt;stats[InHdrErrors]++;
			icmpttlexceeded(f, ifc-&gt;lifc-&gt;local, bp);
			freeblist(bp);
			return;
		}

		/* reassemble if the interface expects it */
if(r-&gt;ifc == nil) panic("nil route rfc");
		if(r-&gt;ifc-&gt;reassemble){
			frag = nhgets(h-&gt;frag);
			if(frag) {
				h-&gt;tos = 0;
				if(frag &amp; IP_MF)
					h-&gt;tos = 1;
				bp = ip4reassemble(ip, frag, bp, h);
				if(bp == nil)
					return;
				h = (Ip4hdr*)(bp-&gt;rp);
			}
		}

		ip-&gt;stats[ForwDatagrams]++;
		tos = h-&gt;tos;
		hop = h-&gt;ttl;
		ipoput4(f, bp, 1, hop - 1, tos, &amp;conv);
		return;
	}

	frag = nhgets(h-&gt;frag);
	if(frag) {
		h-&gt;tos = 0;
		if(frag &amp; IP_MF)
			h-&gt;tos = 1;
		bp = ip4reassemble(ip, frag, bp, h);
		if(bp == nil)
			return;
		h = (Ip4hdr*)(bp-&gt;rp);
	}

	/* don't let any frag info go up the stack */
	h-&gt;frag[0] = 0;
	h-&gt;frag[1] = 0;

	proto = h-&gt;proto;
	p = Fsrcvpcol(f, proto);
	if(p != nil &amp;&amp; p-&gt;rcv != nil) {
		ip-&gt;stats[InDelivers]++;
		(*p-&gt;rcv)(p, ifc, bp);
		return;
	}
	ip-&gt;stats[InDiscards]++;
	ip-&gt;stats[InUnknownProtos]++;
	freeblist(bp);
}

int
ipstats(Fs *f, char *buf, int len)
{
	IP *ip;
	char *p, *e;
	int i;

	ip = f-&gt;ip;
	ip-&gt;stats[DefaultTTL] = MAXTTL;

	p = buf;
	e = p+len;
	for(i = 0; i &lt; Nipstats; i++)
		p = seprint(p, e, "%s: %llud\n", statnames[i], ip-&gt;stats[i]);
	return p - buf;
}

Block*
ip4reassemble(IP *ip, int offset, Block *bp, Ip4hdr *ih)
{
	int fend;
	ushort id;
	Fragment4 *f, *fnext;
	ulong src, dst;
	Block *bl, **l, *last, *prev;
	int ovlap, len, fragsize, pktposn;

	src = nhgetl(ih-&gt;src);
	dst = nhgetl(ih-&gt;dst);
	id = nhgets(ih-&gt;id);

	/*
	 *  block lists are too hard, pullupblock into a single block
	 */
	if(bp-&gt;next){
		bp = pullupblock(bp, blocklen(bp));
		ih = (Ip4hdr*)(bp-&gt;rp);
	}

	qlock(&amp;ip-&gt;fraglock4);

	/*
	 *  find a reassembly queue for this fragment
	 */
	for(f = ip-&gt;flisthead4; f; f = fnext){
		fnext = f-&gt;next;	/* because ipfragfree4 changes the list */
		if(f-&gt;src == src &amp;&amp; f-&gt;dst == dst &amp;&amp; f-&gt;id == id)
			break;
		if(f-&gt;age &lt; NOW){
			ip-&gt;stats[ReasmTimeout]++;
			ipfragfree4(ip, f);
		}
	}

	/*
	 *  if this isn't a fragmented packet, accept it
	 *  and get rid of any fragments that might go
	 *  with it.
	 */
	if(!ih-&gt;tos &amp;&amp; (offset &amp; ~(IP_MF|IP_DF)) == 0) {
		if(f != nil) {
			ipfragfree4(ip, f);
			ip-&gt;stats[ReasmFails]++;
		}
		qunlock(&amp;ip-&gt;fraglock4);
		return bp;
	}

	if(bp-&gt;base+IPFRAGSZ &gt;= bp-&gt;rp){
		bp = padblock(bp, IPFRAGSZ);
		bp-&gt;rp += IPFRAGSZ;
	}

	BKFG(bp)-&gt;foff = offset&lt;&lt;3;
	BKFG(bp)-&gt;flen = nhgets(ih-&gt;length)-IP4HDR;

	/* First fragment allocates a reassembly queue */
	if(f == nil) {
		f = ipfragallo4(ip);
		f-&gt;id = id;
		f-&gt;src = src;
		f-&gt;dst = dst;

		f-&gt;blist = bp;

		qunlock(&amp;ip-&gt;fraglock4);
		ip-&gt;stats[ReasmReqds]++;
		return nil;
	}

	/*
	 *  find the new fragment's position in the queue
	 */
	prev = nil;
	l = &amp;f-&gt;blist;
	bl = f-&gt;blist;
	while(bl != nil &amp;&amp; BKFG(bp)-&gt;foff &gt; BKFG(bl)-&gt;foff) {
		prev = bl;
		l = &amp;bl-&gt;next;
		bl = bl-&gt;next;
	}

	/* Check overlap of a previous fragment - trim away as necessary */
	if(prev) {
		ovlap = BKFG(prev)-&gt;foff + BKFG(prev)-&gt;flen - BKFG(bp)-&gt;foff;
		if(ovlap &gt; 0) {
			if(ovlap &gt;= BKFG(bp)-&gt;flen) {
				freeblist(bp);
				qunlock(&amp;ip-&gt;fraglock4);
				return nil;
			}
			BKFG(prev)-&gt;flen -= ovlap;
		}
	}

	/* Link onto assembly queue */
	bp-&gt;next = *l;
	*l = bp;

	/* Check to see if succeeding segments overlap */
	if(bp-&gt;next) {
		l = &amp;bp-&gt;next;
		fend = BKFG(bp)-&gt;foff + BKFG(bp)-&gt;flen;
		/* Take completely covered segments out */
		while(*l) {
			ovlap = fend - BKFG(*l)-&gt;foff;
			if(ovlap &lt;= 0)
				break;
			if(ovlap &lt; BKFG(*l)-&gt;flen) {
				BKFG(*l)-&gt;flen -= ovlap;
				BKFG(*l)-&gt;foff += ovlap;
				/* move up ih hdrs */
				memmove((*l)-&gt;rp + ovlap, (*l)-&gt;rp, IP4HDR);
				(*l)-&gt;rp += ovlap;
				break;
			}
			last = (*l)-&gt;next;
			(*l)-&gt;next = nil;
			freeblist(*l);
			*l = last;
		}
	}

	/*
	 *  look for a complete packet.  if we get to a fragment
	 *  without IP_MF set, we're done.
	 */
	pktposn = 0;
	for(bl = f-&gt;blist; bl; bl = bl-&gt;next) {
		if(BKFG(bl)-&gt;foff != pktposn)
			break;
		if((BLKIP(bl)-&gt;frag[0]&amp;(IP_MF&gt;&gt;8)) == 0) {
			bl = f-&gt;blist;
			len = nhgets(BLKIP(bl)-&gt;length);
			bl-&gt;wp = bl-&gt;rp + len;

			/* Pullup all the fragment headers and
			 * return a complete packet
			 */
			for(bl = bl-&gt;next; bl; bl = bl-&gt;next) {
				fragsize = BKFG(bl)-&gt;flen;
				len += fragsize;
				bl-&gt;rp += IP4HDR;
				bl-&gt;wp = bl-&gt;rp + fragsize;
			}

			bl = f-&gt;blist;
			f-&gt;blist = nil;
			ipfragfree4(ip, f);
			ih = BLKIP(bl);
			hnputs(ih-&gt;length, len);
			qunlock(&amp;ip-&gt;fraglock4);
			ip-&gt;stats[ReasmOKs]++;
			return bl;
		}
		pktposn += BKFG(bl)-&gt;flen;
	}
	qunlock(&amp;ip-&gt;fraglock4);
	return nil;
}

/*
 * ipfragfree4 - Free a list of fragments - assume hold fraglock4
 */
void
ipfragfree4(IP *ip, Fragment4 *frag)
{
	Fragment4 *fl, **l;

	if(frag-&gt;blist)
		freeblist(frag-&gt;blist);

	frag-&gt;src = 0;
	frag-&gt;id = 0;
	frag-&gt;blist = nil;

	l = &amp;ip-&gt;flisthead4;
	for(fl = *l; fl; fl = fl-&gt;next) {
		if(fl == frag) {
			*l = frag-&gt;next;
			break;
		}
		l = &amp;fl-&gt;next;
	}

	frag-&gt;next = ip-&gt;fragfree4;
	ip-&gt;fragfree4 = frag;

}

/*
 * ipfragallo4 - allocate a reassembly queue - assume hold fraglock4
 */
Fragment4 *
ipfragallo4(IP *ip)
{
	Fragment4 *f;

	while(ip-&gt;fragfree4 == nil) {
		/* free last entry on fraglist */
		for(f = ip-&gt;flisthead4; f-&gt;next; f = f-&gt;next)
			;
		ipfragfree4(ip, f);
	}
	f = ip-&gt;fragfree4;
	ip-&gt;fragfree4 = f-&gt;next;
	f-&gt;next = ip-&gt;flisthead4;
	ip-&gt;flisthead4 = f;
	f-&gt;age = NOW + 30000;

	return f;
}

ushort
ipcsum(uchar *addr)
{
	int len;
	ulong sum;

	sum = 0;
	len = (addr[0]&amp;0xf)&lt;&lt;2;

	while(len &gt; 0) {
		sum += addr[0]&lt;&lt;8 | addr[1] ;
		len -= 2;
		addr += 2;
	}

	sum = (sum &amp; 0xffff) + (sum &gt;&gt; 16);
	sum = (sum &amp; 0xffff) + (sum &gt;&gt; 16);

	return (sum^0xffff);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

