<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/ipv6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/ipv6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

#include	"ip.h"
#include	"ipv6.h"

enum
{
	IP6FHDR		= 8, 		/* sizeof(Fraghdr6) */
};

#define IPV6CLASS(hdr)	(((hdr)-&gt;vcf[0]&amp;0x0F)&lt;&lt;2 | ((hdr)-&gt;vcf[1]&amp;0xF0)&gt;&gt;2)
#define BLKIPVER(xp)	(((Ip6hdr*)((xp)-&gt;rp))-&gt;vcf[0] &amp; 0xF0)
/*
 * This sleazy macro is stolen shamelessly from ip.c, see comment there.
 */
#define BKFG(xp)	((Ipfrag*)((xp)-&gt;base))

Block*		ip6reassemble(IP*, int, Block*, Ip6hdr*);
Fragment6*	ipfragallo6(IP*);
void		ipfragfree6(IP*, Fragment6*);
Block*		procopts(Block *bp);
static Block*	procxtns(IP *ip, Block *bp, int doreasm);
int		unfraglen(Block *bp, uchar *nexthdr, int setfh);

int
ipoput6(Fs *f, Block *bp, int gating, int ttl, int tos, Conv *c)
{
	int medialen, len, chunk, uflen, flen, seglen, lid, offset, fragoff;
	int morefrags, blklen, rv = 0, tentative;
	uchar *gate, nexthdr;
	Block *xp, *nb;
	Fraghdr6 fraghdr;
	IP *ip;
	Ip6hdr *eh;
	Ipifc *ifc;
	Route *r, *sr;

	ip = f-&gt;ip;

	/* Fill out the ip header */
	eh = (Ip6hdr*)(bp-&gt;rp);

	ip-&gt;stats[OutRequests]++;

	/* Number of uchars in data and ip header to write */
	len = blocklen(bp);

	tentative = iptentative(f, eh-&gt;src);
	if(tentative){
		netlog(f, Logip, "reject tx of packet with tentative src address %I\n",
			eh-&gt;src);
		goto free;
	}

	if(gating){
		chunk = nhgets(eh-&gt;ploadlen);
		if(chunk &gt; len){
			ip-&gt;stats[OutDiscards]++;
			netlog(f, Logip, "short gated packet\n");
			goto free;
		}
		if(chunk + IP6HDR &lt; len)
			len = chunk + IP6HDR;
	}

	if(len &gt;= IP_MAX){
		ip-&gt;stats[OutDiscards]++;
		netlog(f, Logip, "exceeded ip max size %I\n", eh-&gt;dst);
		goto free;
	}

	r = v6lookup(f, eh-&gt;dst, c);
	if(r == nil){
//		print("no route for %I, src %I free\n", eh-&gt;dst, eh-&gt;src);
		ip-&gt;stats[OutNoRoutes]++;
		netlog(f, Logip, "no interface %I\n", eh-&gt;dst);
		rv = -1;
		goto free;
	}

	ifc = r-&gt;ifc;
	if(r-&gt;type &amp; (Rifc|Runi))
		gate = eh-&gt;dst;
	else if(r-&gt;type &amp; (Rbcast|Rmulti)) {
		gate = eh-&gt;dst;
		sr = v6lookup(f, eh-&gt;src, nil);
		if(sr &amp;&amp; (sr-&gt;type &amp; Runi))
			ifc = sr-&gt;ifc;
	}
	else
		gate = r-&gt;v6.gate;

	if(!gating)
		eh-&gt;vcf[0] = IP_VER6;
	eh-&gt;ttl = ttl;
	if(!gating) {
		eh-&gt;vcf[0] |= tos &gt;&gt; 4;
		eh-&gt;vcf[1]  = tos &lt;&lt; 4;
	}

	if(!canrlock(ifc))
		goto free;

	if(waserror()){
		runlock(ifc);
		nexterror();
	}

	if(ifc-&gt;m == nil)
		goto raise;

	/* If we dont need to fragment just send it */
	medialen = ifc-&gt;maxtu - ifc-&gt;m-&gt;hsize;
	if(len &lt;= medialen) {
		hnputs(eh-&gt;ploadlen, len - IP6HDR);
		ifc-&gt;m-&gt;bwrite(ifc, bp, V6, gate);
		runlock(ifc);
		poperror();
		return 0;
	}

	if(gating &amp;&amp; ifc-&gt;reassemble &lt;= 0) {
		/*
		 * v6 intermediate nodes are not supposed to fragment pkts;
		 * we fragment if ifc-&gt;reassemble is turned on; an exception
		 * needed for nat.
		 */
		ip-&gt;stats[OutDiscards]++;
		icmppkttoobig6(f, ifc, bp);
		netlog(f, Logip, "%I: gated pkts not fragmented\n", eh-&gt;dst);
		goto raise;
	}

	/* start v6 fragmentation */
	uflen = unfraglen(bp, &amp;nexthdr, 1);
	if(uflen &gt; medialen) {
		ip-&gt;stats[FragFails]++;
		ip-&gt;stats[OutDiscards]++;
		netlog(f, Logip, "%I: unfragmentable part too big\n", eh-&gt;dst);
		goto raise;
	}

	flen = len - uflen;
	seglen = (medialen - (uflen + IP6FHDR)) &amp; ~7;
	if(seglen &lt; 8) {
		ip-&gt;stats[FragFails]++;
		ip-&gt;stats[OutDiscards]++;
		netlog(f, Logip, "%I: seglen &lt; 8\n", eh-&gt;dst);
		goto raise;
	}

	lid = incref(&amp;ip-&gt;id6);
	fraghdr.nexthdr = nexthdr;
	fraghdr.res = 0;
	hnputl(fraghdr.id, lid);

	xp = bp;
	offset = uflen;
	while (xp &amp;&amp; offset &amp;&amp; offset &gt;= BLEN(xp)) {
		offset -= BLEN(xp);
		xp = xp-&gt;next;
	}
	xp-&gt;rp += offset;

	fragoff = 0;
	morefrags = 1;

	for(; fragoff &lt; flen; fragoff += seglen) {
		nb = allocb(uflen + IP6FHDR + seglen);

		if(fragoff + seglen &gt;= flen) {
			seglen = flen - fragoff;
			morefrags = 0;
		}

		hnputs(eh-&gt;ploadlen, seglen+IP6FHDR);
		memmove(nb-&gt;wp, eh, uflen);
		nb-&gt;wp += uflen;

		hnputs(fraghdr.offsetRM, fragoff); /* last 3 bits must be 0 */
		fraghdr.offsetRM[1] |= morefrags;
		memmove(nb-&gt;wp, &amp;fraghdr, IP6FHDR);
		nb-&gt;wp += IP6FHDR;

		/* Copy data */
		chunk = seglen;
		while (chunk) {
			if(!xp) {
				ip-&gt;stats[OutDiscards]++;
				ip-&gt;stats[FragFails]++;
				freeblist(nb);
				netlog(f, Logip, "!xp: chunk in v6%d\n", chunk);
				goto raise;
			}
			blklen = chunk;
			if(BLEN(xp) &lt; chunk)
				blklen = BLEN(xp);
			memmove(nb-&gt;wp, xp-&gt;rp, blklen);

			nb-&gt;wp += blklen;
			xp-&gt;rp += blklen;
			chunk -= blklen;
			if(xp-&gt;rp == xp-&gt;wp)
				xp = xp-&gt;next;
		}

		ifc-&gt;m-&gt;bwrite(ifc, nb, V6, gate);
		ip-&gt;stats[FragCreates]++;
	}
	ip-&gt;stats[FragOKs]++;

raise:
	runlock(ifc);
	poperror();
free:
	freeblist(bp);
	return rv;
}

void
ipiput6(Fs *f, Ipifc *ifc, Block *bp)
{
	int hl, hop, tos, notforme, tentative;
	uchar proto;
	uchar v6dst[IPaddrlen];
	IP *ip;
	Ip6hdr *h;
	Proto *p;
	Route *r, *sr;

	ip = f-&gt;ip;
	ip-&gt;stats[InReceives]++;

	/*
	 *  Ensure we have all the header info in the first
	 *  block.  Make life easier for other protocols by
	 *  collecting up to the first 64 bytes in the first block.
	 */
	if(BLEN(bp) &lt; 64) {
		hl = blocklen(bp);
		if(hl &lt; IP6HDR)
			hl = IP6HDR;
		if(hl &gt; 64)
			hl = 64;
		bp = pullupblock(bp, hl);
		if(bp == nil)
			return;
	}

	h = (Ip6hdr *)bp-&gt;rp;

	memmove(&amp;v6dst[0], &amp;h-&gt;dst[0], IPaddrlen);
	notforme = ipforme(f, v6dst) == 0;
	tentative = iptentative(f, v6dst);

	if(tentative &amp;&amp; h-&gt;proto != ICMPv6) {
		print("ipv6 non-icmp tentative addr %I, drop\n", v6dst);
		freeblist(bp);
		return;
	}

	/* Check header version */
	if(BLKIPVER(bp) != IP_VER6) {
		ip-&gt;stats[InHdrErrors]++;
		netlog(f, Logip, "ip: bad version %ux\n", (h-&gt;vcf[0]&amp;0xF0)&gt;&gt;2);
		freeblist(bp);
		return;
	}

	/* route */
	if(notforme) {
		if(!ip-&gt;iprouting){
			freeblist(bp);
			return;
		}

		/* don't forward to link-local destinations */
		if(islinklocal(h-&gt;dst) ||
		   (isv6mcast(h-&gt;dst) &amp;&amp; (h-&gt;dst[1]&amp;0xF) &lt;= Link_local_scop)){
			ip-&gt;stats[OutDiscards]++;
			freeblist(bp);
			return;
		}

		/* don't forward to source's network */
		sr = v6lookup(f, h-&gt;src, nil);
		r  = v6lookup(f, h-&gt;dst, nil);

		if(r == nil || sr == r){
			ip-&gt;stats[OutDiscards]++;
			freeblist(bp);
			return;
		}

		/* don't forward if packet has timed out */
		hop = h-&gt;ttl;
		if(hop &lt; 1) {
			ip-&gt;stats[InHdrErrors]++;
			icmpttlexceeded6(f, ifc, bp);
			freeblist(bp);
			return;
		}

		/* process headers &amp; reassemble if the interface expects it */
		bp = procxtns(ip, bp, r-&gt;ifc-&gt;reassemble);
		if(bp == nil)
			return;

		ip-&gt;stats[ForwDatagrams]++;
		h = (Ip6hdr *)bp-&gt;rp;
		tos = IPV6CLASS(h);
		hop = h-&gt;ttl;
		ipoput6(f, bp, 1, hop-1, tos, nil);
		return;
	}

	/* reassemble &amp; process headers if needed */
	bp = procxtns(ip, bp, 1);
	if(bp == nil)
		return;

	h = (Ip6hdr *) (bp-&gt;rp);
	proto = h-&gt;proto;
	p = Fsrcvpcol(f, proto);
	if(p &amp;&amp; p-&gt;rcv) {
		ip-&gt;stats[InDelivers]++;
		(*p-&gt;rcv)(p, ifc, bp);
		return;
	}

	ip-&gt;stats[InDiscards]++;
	ip-&gt;stats[InUnknownProtos]++;
	freeblist(bp);
}

/*
 * ipfragfree6 - copied from ipfragfree4 - assume hold fraglock6
 */
void
ipfragfree6(IP *ip, Fragment6 *frag)
{
	Fragment6 *fl, **l;

	if(frag-&gt;blist)
		freeblist(frag-&gt;blist);

	memset(frag-&gt;src, 0, IPaddrlen);
	frag-&gt;id = 0;
	frag-&gt;blist = nil;

	l = &amp;ip-&gt;flisthead6;
	for(fl = *l; fl; fl = fl-&gt;next) {
		if(fl == frag) {
			*l = frag-&gt;next;
			break;
		}
		l = &amp;fl-&gt;next;
	}

	frag-&gt;next = ip-&gt;fragfree6;
	ip-&gt;fragfree6 = frag;
}

/*
 * ipfragallo6 - copied from ipfragalloc4
 */
Fragment6*
ipfragallo6(IP *ip)
{
	Fragment6 *f;

	while(ip-&gt;fragfree6 == nil) {
		/* free last entry on fraglist */
		for(f = ip-&gt;flisthead6; f-&gt;next; f = f-&gt;next)
			;
		ipfragfree6(ip, f);
	}
	f = ip-&gt;fragfree6;
	ip-&gt;fragfree6 = f-&gt;next;
	f-&gt;next = ip-&gt;flisthead6;
	ip-&gt;flisthead6 = f;
	f-&gt;age = NOW + 30000;

	return f;
}

static Block*
procxtns(IP *ip, Block *bp, int doreasm)
{
	int offset;
	uchar proto;
	Ip6hdr *h;

	h = (Ip6hdr *)bp-&gt;rp;
	offset = unfraglen(bp, &amp;proto, 0);

	if(proto == FH &amp;&amp; doreasm != 0) {
		bp = ip6reassemble(ip, offset, bp, h);
		if(bp == nil)
			return nil;
		offset = unfraglen(bp, &amp;proto, 0);
	}

	if(proto == DOH || offset &gt; IP6HDR)
		bp = procopts(bp);
	return bp;
}

/*
 * returns length of "Unfragmentable part", i.e., sum of lengths of ipv6 hdr,
 * hop-by-hop &amp; routing headers if present; *nexthdr is set to nexthdr value
 * of the last header in the "Unfragmentable part"; if setfh != 0, nexthdr
 * field of the last header in the "Unfragmentable part" is set to FH.
 */
int
unfraglen(Block *bp, uchar *nexthdr, int setfh)
{
	uchar *p, *q;
	int ufl, hs;

	p = bp-&gt;rp;
	q = p+6;   /* proto, = p+sizeof(Ip6hdr.vcf)+sizeof(Ip6hdr.ploadlen) */
	*nexthdr = *q;
	ufl = IP6HDR;
	p += ufl;

	while (*nexthdr == HBH || *nexthdr == RH) {
		*nexthdr = *p;
		hs = ((int)*(p+1) + 1) * 8;
		ufl += hs;
		q = p;
		p += hs;
	}

	if(*nexthdr == FH)
		*q = *p;
	if(setfh)
		*q = FH;
	return ufl;
}

Block*
procopts(Block *bp)
{
	return bp;
}

Block*
ip6reassemble(IP* ip, int uflen, Block* bp, Ip6hdr* ih)
{
	int fend, offset, ovlap, len, fragsize, pktposn;
	uint id;
	uchar src[IPaddrlen], dst[IPaddrlen];
	Block *bl, **l, *last, *prev;
	Fraghdr6 *fraghdr;
	Fragment6 *f, *fnext;

	fraghdr = (Fraghdr6 *)(bp-&gt;rp + uflen);
	memmove(src, ih-&gt;src, IPaddrlen);
	memmove(dst, ih-&gt;dst, IPaddrlen);
	id = nhgetl(fraghdr-&gt;id);
	offset = nhgets(fraghdr-&gt;offsetRM) &amp; ~7;

	/*
	 *  block lists are too hard, pullupblock into a single block
	 */
	if(bp-&gt;next){
		bp = pullupblock(bp, blocklen(bp));
		ih = (Ip6hdr *)bp-&gt;rp;
	}

	qlock(&amp;ip-&gt;fraglock6);

	/*
	 *  find a reassembly queue for this fragment
	 */
	for(f = ip-&gt;flisthead6; f; f = fnext){
		fnext = f-&gt;next;
		if(ipcmp(f-&gt;src, src)==0 &amp;&amp; ipcmp(f-&gt;dst, dst)==0 &amp;&amp; f-&gt;id == id)
			break;
		if(f-&gt;age &lt; NOW){
			ip-&gt;stats[ReasmTimeout]++;
			ipfragfree6(ip, f);
		}
	}

	/*
	 *  if this isn't a fragmented packet, accept it
	 *  and get rid of any fragments that might go
	 *  with it.
	 */
	if(nhgets(fraghdr-&gt;offsetRM) == 0) {	/* 1st frag is also last */
		if(f) {
			ipfragfree6(ip, f);
			ip-&gt;stats[ReasmFails]++;
		}
		qunlock(&amp;ip-&gt;fraglock6);
		return bp;
	}

	if(bp-&gt;base+IPFRAGSZ &gt;= bp-&gt;rp){
		bp = padblock(bp, IPFRAGSZ);
		bp-&gt;rp += IPFRAGSZ;
	}

	BKFG(bp)-&gt;foff = offset;
	BKFG(bp)-&gt;flen = nhgets(ih-&gt;ploadlen) + IP6HDR - uflen - IP6FHDR;

	/* First fragment allocates a reassembly queue */
	if(f == nil) {
		f = ipfragallo6(ip);
		f-&gt;id = id;
		memmove(f-&gt;src, src, IPaddrlen);
		memmove(f-&gt;dst, dst, IPaddrlen);

		f-&gt;blist = bp;

		qunlock(&amp;ip-&gt;fraglock6);
		ip-&gt;stats[ReasmReqds]++;
		return nil;
	}

	/*
	 *  find the new fragment's position in the queue
	 */
	prev = nil;
	l = &amp;f-&gt;blist;
	bl = f-&gt;blist;
	while(bl != nil &amp;&amp; BKFG(bp)-&gt;foff &gt; BKFG(bl)-&gt;foff) {
		prev = bl;
		l = &amp;bl-&gt;next;
		bl = bl-&gt;next;
	}

	/* Check overlap of a previous fragment - trim away as necessary */
	if(prev) {
		ovlap = BKFG(prev)-&gt;foff + BKFG(prev)-&gt;flen - BKFG(bp)-&gt;foff;
		if(ovlap &gt; 0) {
			if(ovlap &gt;= BKFG(bp)-&gt;flen) {
				freeblist(bp);
				qunlock(&amp;ip-&gt;fraglock6);
				return nil;
			}
			BKFG(prev)-&gt;flen -= ovlap;
		}
	}

	/* Link onto assembly queue */
	bp-&gt;next = *l;
	*l = bp;

	/* Check to see if succeeding segments overlap */
	if(bp-&gt;next) {
		l = &amp;bp-&gt;next;
		fend = BKFG(bp)-&gt;foff + BKFG(bp)-&gt;flen;

		/* Take completely covered segments out */
		while(*l) {
			ovlap = fend - BKFG(*l)-&gt;foff;
			if(ovlap &lt;= 0)
				break;
			if(ovlap &lt; BKFG(*l)-&gt;flen) {
				BKFG(*l)-&gt;flen -= ovlap;
				BKFG(*l)-&gt;foff += ovlap;
				/* move up ih hdrs */
				memmove((*l)-&gt;rp + ovlap, (*l)-&gt;rp, uflen);
				(*l)-&gt;rp += ovlap;
				break;
			}
			last = (*l)-&gt;next;
			(*l)-&gt;next = nil;
			freeblist(*l);
			*l = last;
		}
	}

	/*
	 *  look for a complete packet.  if we get to a fragment
	 *  with the trailing bit of fraghdr-&gt;offsetRM[1] set, we're done.
	 */
	pktposn = 0;
	for(bl = f-&gt;blist; bl &amp;&amp; BKFG(bl)-&gt;foff == pktposn; bl = bl-&gt;next) {
		fraghdr = (Fraghdr6 *)(bl-&gt;rp + uflen);
		if((fraghdr-&gt;offsetRM[1] &amp; 1) == 0) {
			bl = f-&gt;blist;

			/* get rid of frag header in first fragment */
			memmove(bl-&gt;rp + IP6FHDR, bl-&gt;rp, uflen);
			bl-&gt;rp += IP6FHDR;
			len = nhgets(((Ip6hdr*)bl-&gt;rp)-&gt;ploadlen) - IP6FHDR;
			bl-&gt;wp = bl-&gt;rp + len + IP6HDR;
			/*
			 * Pullup all the fragment headers and
			 * return a complete packet
			 */
			for(bl = bl-&gt;next; bl; bl = bl-&gt;next) {
				fragsize = BKFG(bl)-&gt;flen;
				len += fragsize;
				bl-&gt;rp += uflen + IP6FHDR;
				bl-&gt;wp = bl-&gt;rp + fragsize;
			}

			bl = f-&gt;blist;
			f-&gt;blist = nil;
			ipfragfree6(ip, f);
			ih = (Ip6hdr*)bl-&gt;rp;
			hnputs(ih-&gt;ploadlen, len);
			qunlock(&amp;ip-&gt;fraglock6);
			ip-&gt;stats[ReasmOKs]++;
			return bl;
		}
		pktposn += BKFG(bl)-&gt;flen;
	}
	qunlock(&amp;ip-&gt;fraglock6);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

