<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ip/netlog.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ip/netlog.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../ip/ip.h"

enum {
	Nlog		= 16*1024,
};

/*
 *  action log
 */
struct Netlog {
	Lock;
	int	opens;
	char*	buf;
	char	*end;
	char	*rptr;
	int	len;

	int	logmask;			/* mask of things to debug */
	uchar	iponly[IPaddrlen];		/* ip address to print debugging for */
	int	iponlyset;

	QLock;
	Rendez;
};

typedef struct Netlogflag {
	char*	name;
	int	mask;
} Netlogflag;

static Netlogflag flags[] =
{
	{ "ppp",	Logppp, },
	{ "ip",		Logip, },
	{ "fs",		Logfs, },
	{ "tcp",	Logtcp, },
	{ "icmp",	Logicmp, },
	{ "udp",	Logudp, },
	{ "compress",	Logcompress, },
	{ "gre",	Loggre, },
	{ "tcpwin",	Logtcp|Logtcpwin, },
	{ "tcprxmt",	Logtcp|Logtcprxmt, },
	{ "udpmsg",	Logudp|Logudpmsg, },
	{ "ipmsg",	Logip|Logipmsg, },
	{ "esp",	Logesp, },
	{ nil,		0, },
};

char Ebadnetctl[] = "too few arguments for netlog control message";

enum
{
	CMset,
	CMclear,
	CMonly,
};

static
Cmdtab routecmd[] = {
	CMset,		"set",		0,
	CMclear,	"clear",	0,
	CMonly,		"only",		0,
};

void
netloginit(Fs *f)
{
	f-&gt;alog = smalloc(sizeof(Netlog));
}

void
netlogopen(Fs *f)
{
	lock(f-&gt;alog);
	if(waserror()){
		unlock(f-&gt;alog);
		nexterror();
	}
	if(f-&gt;alog-&gt;opens == 0){
		if(f-&gt;alog-&gt;buf == nil)
			f-&gt;alog-&gt;buf = malloc(Nlog);
		if(f-&gt;alog-&gt;buf == nil)
			error(Enomem);
		f-&gt;alog-&gt;rptr = f-&gt;alog-&gt;buf;
		f-&gt;alog-&gt;end = f-&gt;alog-&gt;buf + Nlog;
	}
	f-&gt;alog-&gt;opens++;
	unlock(f-&gt;alog);
	poperror();
}

void
netlogclose(Fs *f)
{
	lock(f-&gt;alog);
	if(waserror()){
		unlock(f-&gt;alog);
		nexterror();
	}
	f-&gt;alog-&gt;opens--;
	if(f-&gt;alog-&gt;opens == 0){
		free(f-&gt;alog-&gt;buf);
		f-&gt;alog-&gt;buf = nil;
	}
	unlock(f-&gt;alog);
	poperror();
}

static int
netlogready(void *a)
{
	Fs *f = a;

	return f-&gt;alog-&gt;len;
}

long
netlogread(Fs *f, void *a, ulong, long n)
{
	int i, d;
	char *p, *rptr;

	qlock(f-&gt;alog);
	if(waserror()){
		qunlock(f-&gt;alog);
		nexterror();
	}

	for(;;){
		lock(f-&gt;alog);
		if(f-&gt;alog-&gt;len){
			if(n &gt; f-&gt;alog-&gt;len)
				n = f-&gt;alog-&gt;len;
			d = 0;
			rptr = f-&gt;alog-&gt;rptr;
			f-&gt;alog-&gt;rptr += n;
			if(f-&gt;alog-&gt;rptr &gt;= f-&gt;alog-&gt;end){
				d = f-&gt;alog-&gt;rptr - f-&gt;alog-&gt;end;
				f-&gt;alog-&gt;rptr = f-&gt;alog-&gt;buf + d;
			}
			f-&gt;alog-&gt;len -= n;
			unlock(f-&gt;alog);

			i = n-d;
			p = a;
			memmove(p, rptr, i);
			memmove(p+i, f-&gt;alog-&gt;buf, d);
			break;
		}
		else
			unlock(f-&gt;alog);

		sleep(f-&gt;alog, netlogready, f);
	}

	qunlock(f-&gt;alog);
	poperror();

	return n;
}

void
netlogctl(Fs *f, char* s, int n)
{
	int i, set;
	Netlogflag *fp;
	Cmdbuf *cb;
	Cmdtab *ct;

	cb = parsecmd(s, n);
	if(waserror()){
		free(cb);
		nexterror();
	}

	if(cb-&gt;nf &lt; 2)
		error(Ebadnetctl);

	ct = lookupcmd(cb, routecmd, nelem(routecmd));

	SET(set);

	switch(ct-&gt;index){
	case CMset:
		set = 1;
		break;

	case CMclear:
		set = 0;
		break;

	case CMonly:
		parseip(f-&gt;alog-&gt;iponly, cb-&gt;f[1]);
		if(ipcmp(f-&gt;alog-&gt;iponly, IPnoaddr) == 0)
			f-&gt;alog-&gt;iponlyset = 0;
		else
			f-&gt;alog-&gt;iponlyset = 1;
		free(cb);
		poperror();
		return;

	default:
		cmderror(cb, "unknown netlog control message");
	}

	for(i = 1; i &lt; cb-&gt;nf; i++){
		for(fp = flags; fp-&gt;name; fp++)
			if(strcmp(fp-&gt;name, cb-&gt;f[i]) == 0)
				break;
		if(fp-&gt;name == nil)
			continue;
		if(set)
			f-&gt;alog-&gt;logmask |= fp-&gt;mask;
		else
			f-&gt;alog-&gt;logmask &amp;= ~fp-&gt;mask;
	}

	free(cb);
	poperror();
}

void
netlog(Fs *f, int mask, char *fmt, ...)
{
	char buf[256], *t, *fp;
	int i, n;
	va_list arg;

	if(!(f-&gt;alog-&gt;logmask &amp; mask))
		return;

	if(f-&gt;alog-&gt;opens == 0)
		return;

	va_start(arg, fmt);
	n = vseprint(buf, buf+sizeof(buf), fmt, arg) - buf;
	va_end(arg);

	lock(f-&gt;alog);
	i = f-&gt;alog-&gt;len + n - Nlog;
	if(i &gt; 0){
		f-&gt;alog-&gt;len -= i;
		f-&gt;alog-&gt;rptr += i;
		if(f-&gt;alog-&gt;rptr &gt;= f-&gt;alog-&gt;end)
			f-&gt;alog-&gt;rptr = f-&gt;alog-&gt;buf + (f-&gt;alog-&gt;rptr - f-&gt;alog-&gt;end);
	}
	t = f-&gt;alog-&gt;rptr + f-&gt;alog-&gt;len;
	fp = buf;
	f-&gt;alog-&gt;len += n;
	while(n-- &gt; 0){
		if(t &gt;= f-&gt;alog-&gt;end)
			t = f-&gt;alog-&gt;buf + (t - f-&gt;alog-&gt;end);
		*t++ = *fp++;
	}
	unlock(f-&gt;alog);

	wakeup(f-&gt;alog);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

