<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/archkw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/archkw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * stuff specific to marvell's kirkwood architecture
 * as seen in the sheevaplug
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"

#include "../port/netif.h"
#include "etherif.h"
#include "../port/flashif.h"

#include "arm.h"

enum {
	L2writeback = 1,
	Debug = 0,
};

typedef struct GpioReg GpioReg;
struct GpioReg {
	ulong	dataout;
	ulong	dataoutena;
	ulong	blinkena;
	ulong	datainpol;
	ulong	datain;
	ulong	intrcause;
	ulong	intrmask;
	ulong	intrlevelmask;
};

typedef struct L2uncache L2uncache;
typedef struct L2win L2win;
struct L2uncache {
	struct L2win {
		ulong	base;	/* phys addr */
		ulong	size;
	} win[4];
};

enum {
	/* L2win-&gt;base bits */
	L2enable	= 1&lt;&lt;0,
};

typedef struct Dramctl Dramctl;
struct Dramctl {
	ulong	ctl;
	ulong	ddrctllo;
	struct {
		ulong	lo;
		ulong	hi;
	} time;
	ulong	addrctl;
	ulong	opagectl;
	ulong	oper;
	ulong	mode;
	ulong	extmode;
	ulong	ddrctlhi;
	ulong	ddr2timelo;
	ulong	operctl;
	struct {
		ulong	lo;
		ulong	hi;
	} mbusctl;
	ulong	mbustimeout;
	ulong	ddrtimehi;
	ulong	sdinitctl;
	ulong	extsdmode1;
	ulong	extsdmode2;
	struct {
		ulong	lo;
		ulong	hi;
	} odtctl;
	ulong	ddrodtctl;
	ulong	rbuffsel;

	ulong	accalib;
	ulong	dqcalib;
	ulong	dqscalib;
};

/* unused so far */
typedef struct SDramdReg SDramdReg;
struct SDramdReg {
	struct {
		ulong	base;
		ulong	size;
	} win[4];
};

typedef struct Addrmap Addrmap;
typedef struct Addrwin Addrwin;
struct Addrmap {
	struct Addrwin {
		ulong	ctl;		/* see Winenable in io.h */
		ulong	base;		/* virtual address */
		ulong	remaplo;	/* physical address sent to target */
		ulong	remaphi;	/* " */
	} win[8];
	ulong	dirba;		/* device internal reg's base addr.: PHYSIO */
};

Soc soc = {
	.cpu		= PHYSIO+0x20100,
	.devid		= PHYSIO+0x10034,
	.l2cache	= PHYSIO+0x20a00,  	/* uncachable addrs for L2 */
	.sdramc		= PHYSIO+0x01400,
//	.sdramd		= PHYSIO+0x01500,	/* unused */

	.iocfg		= PHYSIO+0x100e0,
	.addrmap	= PHYSIO+0x20000,	/* cpu address map */
	.intr		= PHYSIO+0x20200,
	.nand		= PHYSIO+0x10418,
	.cesa		= PHYSIO+0x30000,	/* crypto accelerator */
	.ehci		= PHYSIO+0x50000,
	.spi		= PHYSIO+0x10600,
 	.twsi		= PHYSIO+0x11000,

	.analog		= PHYSIO+0x1007c,
	.pci		= PHYSIO+0x40000,
	.pcibase	= PHYSIO+0x41800,

	.rtc		= PHYSIO+0x10300,
	.clock		= PHYSIO+0x20300,
//	.clockctl	= PHYSIO+0x1004c,	/* unused */

	.ether		= { PHYSIO+0x72000, PHYSIO+0x76000, },
	.sata		= { PHYSIO+0x80000,	/* sata config reg here */
			PHYSIO+0x82000,		/* edma config reg here */
			PHYSIO+0x84000,		/* edma config reg here */
			},
	.uart		= { PHYSIO+0x12000, PHYSIO+0x12100, },
	.gpio		= { PHYSIO+0x10100, PHYSIO+0x10140, },
};

/*
 * sheeva/openrd u-boot leaves us with this address map:
 *
 * 0 targ 4 attr 0xe8 size 256MB addr 0x9::  remap addr 0x9::	pci mem
 * 1 targ 1 attr 0x2f size   8MB addr 0xf9:: remap addr 0xf9::	nand flash
 * 2 targ 4 attr 0xe0 size  16MB addr 0xf::  remap addr 0xc::	pci i/o
 * 3 targ 1 attr 0x1e size  16MB addr 0xf8:: remap addr 0x0	spi flash
 * 4 targ 1 attr 0x1d size  16MB addr 0xff::			boot rom
 * 5 targ 1 attr 0x1e size 128MB addr 0xe8::	disabled	spi flash
 * 6 targ 1 attr 0x1d size 128MB addr 0xf::	disabled	boot rom
 * 7 targ 3 attr 0x1  size  64K  addr 0xfb::			crypto sram
 *
 * dreamplug u-boot leaves us with this address map:
 *
 * 0 targ 4 attr 0xe8 size 256MB addr 0x9::  remap addr 0x9::	pci mem
 * 1 targ 4 attr 0xe0 size  64KB addr 0xc::  remap addr 0xc::	pci i/o
 * 2 targ 1 attr 0x2f size 128MB addr 0xd8:: remap addr 0xd8::	nand flash
 * 3 targ 1 attr 0x1e size 128MB addr 0xe8:: remap addr 0xe8::	spi flash
 * 4 targ 1 attr 0x1d size 128MB addr 0xf8::			boot rom
 * 5 targ 3 attr 0x1  size  64K  addr 0xc801::			crypto sram
 * 6 targ 0 attr 0x0  size  64K  addr 0xf::	disabled	ram?
 * 7 targ 0 attr 0x0  size  64K  addr 0xf8::	disabled	ram?
 */

#define WINTARG(ctl)	(((ctl) &gt;&gt; 4) &amp; 017)
#define WINATTR(ctl)	(((ctl) &gt;&gt; 8) &amp; 0377)
#define WIN64KSIZE(ctl)	(((ctl) &gt;&gt; 16) + 1)

static void
praddrwin(Addrwin *win, int i)
{
	ulong ctl, targ, attr, size64k;

	if (!Debug) {
		USED(win, i);
		return;
	}
	ctl = win-&gt;ctl;
	targ = WINTARG(ctl);
	attr = WINATTR(ctl);
	size64k = WIN64KSIZE(ctl);
	print("cpu addr map: %s window %d: targ %ld attr %#lux size %,ld addr %#lux",
		ctl &amp; Winenable? "enabled": "disabled", i, targ, attr,
		size64k * 64*1024, win-&gt;base);
	if (i &lt; 4)
		print(" remap addr %#llux", (uvlong)win-&gt;remaphi&lt;&lt;32 |
			win-&gt;remaplo);
	print("\n");
}

static void
fixaddrmap(void)
{
	int i;
	ulong ctl, targ, attr, size64k;
	Addrmap *map;
	Addrwin *win;

	map = (Addrmap *)soc.addrmap;
	for (i = 0; i &lt; nelem(map-&gt;win); i++) {
		win = &amp;map-&gt;win[i];
		ctl = win-&gt;ctl;
		targ = WINTARG(ctl);
		attr = WINATTR(ctl);
		size64k = WIN64KSIZE(ctl);

		USED(attr, size64k);
		if (targ == Targcesasram) {
			win-&gt;ctl |= Winenable;
			win-&gt;base = PHYSCESASRAM;
			coherence();
			praddrwin(win, i);
		}
	}
	if (map-&gt;dirba != PHYSIO)
		panic("dirba not %#ux", PHYSIO);
}

static void
praddrmap(void)
{
	int i;
	Addrmap *map;

	map = (Addrmap *)soc.addrmap;
	for (i = 0; i &lt; nelem(map-&gt;win); i++)
		praddrwin(&amp;map-&gt;win[i], i);
}

int
ispow2(uvlong ul)
{
	/* see Hacker's Delight if this isn't obvious */
	return (ul &amp; (ul - 1)) == 0;
}

/*
 * return exponent of smallest power of 2 ≥ n
 */
int
log2(ulong n)
{
	int i;

	i = 31 - clz(n);
	if (!ispow2(n) || n == 0)
		i++;
	return i;
}

void
cacheinfo(int level, int kind, Memcache *cp)		/* l1 only */
{
	uint len, assoc, size;
	ulong setsways;

	/* get cache types &amp; sizes (read-only reg) */
	setsways = cprdsc(0, CpID, CpIDidct, CpIDct);

	cp-&gt;level = level;
	cp-&gt;kind = kind;

	if ((setsways &amp; (1&lt;&lt;24)) == 0)
		kind = Unified;
	if (kind != Icache)
		setsways &gt;&gt;= 12;

	assoc = (setsways &gt;&gt; 3) &amp; MASK(3);
	cp-&gt;nways = 1 &lt;&lt; assoc;
	size = (setsways &gt;&gt; 6) &amp; MASK(4);
	cp-&gt;size  = 1 &lt;&lt; (size + 9);
	len = setsways &amp; MASK(2);
	cp-&gt;log2linelen = len + 3;
	cp-&gt;linelen = 1 &lt;&lt; cp-&gt;log2linelen;
	cp-&gt;setsways = setsways;

	cp-&gt;nsets = 1 &lt;&lt; (size + 6 - assoc - len);
	cp-&gt;setsh = cp-&gt;log2linelen;
	cp-&gt;waysh = 32 - log2(cp-&gt;nways);
}

static char *
wbtype(uint type)
{
	static char *types[] = {
		"write-through",
		"read data block",
		"reg 7 ops, no lock-down",
	[06]	"reg 7 ops, format A",
	[07]	"reg 7 ops, format B deprecated",
	[016]	"reg 7 ops, format C",
	[05]	"reg 7 ops, format D",
	};

	if (type &gt;= nelem(types) || types[type] == nil)
		return "GOK";
	return types[type];
}

static void
prcache(Memcache *mcp)
{
	int type;
	char id;

	if (mcp-&gt;kind == Unified)
		id = 'U';
	else if (mcp-&gt;kind == Icache)
		id = 'I';
	else if (mcp-&gt;kind == Dcache)
		id = 'D';
	else
		id = '?';
	print("l%d %c: %d bytes, %d ways %d sets %d bytes/line",
		mcp-&gt;level, id, mcp-&gt;size, mcp-&gt;nways, mcp-&gt;nsets,
		mcp-&gt;linelen);
	if (mcp-&gt;linelen != CACHELINESZ)
		print(" *should* be %d", CACHELINESZ);
	type = (mcp-&gt;setsways &gt;&gt; 25) &amp; MASK(4);
	if (type == 0)
		print("; write-through only");
	else
		print("; write-back type `%s' (%#o) possible",
			wbtype(type), type);
	if (mcp-&gt;setsways &amp; (1&lt;&lt;11))
		print("; page table mapping restrictions apply");
	if (mcp-&gt;setsways &amp; (1&lt;&lt;2))
		print("; M bit is set in cache type reg");
	print("\n");
}

static void
prcachecfg(void)
{
	Memcache mc;

	cacheinfo(1, Dcache, &amp;mc);
	prcache(&amp;mc);
	cacheinfo(1, Icache, &amp;mc);
	prcache(&amp;mc);
}

void
l2cacheon(void)
{
	ulong cfg;
	CpucsReg *cpu;
	L2uncache *l2p;

	cacheuwbinv();
	l2cacheuwbinv();
	l1cachesoff();			/* turns off L2 as a side effect */

	cpwrsc(CpDef, CpCLD, 0, 0, 0);  /* GL-CPU-100: set D cache lockdown reg. */

	/* marvell guideline GL-CPU-130 */
	cpu = (CpucsReg *)soc.cpu;
	cfg = cpu-&gt;cpucfg | L2exists | L2ecc | Cfgiprefetch | Cfgdprefetch;

	if (L2writeback)
		cfg &amp;= ~L2writethru;	/* see PTE Cached &amp; Buffered bits */
	else
		cfg |= L2writethru;
	cpu-&gt;l2cfg = cfg;
	coherence();			/* force l2 cache to pay attention */
	cpu-&gt;l2tm1 = cpu-&gt;l2tm0 = 0x66666666; /* marvell guideline GL-CPU-120 */
	coherence();

	cpwrsc(CpL2, CpTESTCFG, CpTCl2waylck, CpTCl2waylock, 0);

	cachedinv();
	l2cacheuinv();

	/* disable l2 caching of i/o registers */
	l2p = (L2uncache *)soc.l2cache;
	memset(l2p, 0, sizeof *l2p);
	/*
	 * l2: don't cache upper half of address space.
	 * the L2 cache is PIPT, so the addresses are physical.
	 */
	l2p-&gt;win[0].base = 0x80000000 | L2enable;	/* 64K multiple */
	l2p-&gt;win[0].size = (32*1024-1) &lt;&lt; 16;		/* 64K multiples */
	coherence();

	l2cachecfgon();
	l1cacheson();			/* turns L2 on as a side effect */
	print("l2 cache: 256K or 512K: 4 ways, 32-byte lines, write-%s, sdram only\n",
		cpu-&gt;l2cfg &amp; L2writethru? "through": "back");
}

/* called late in main */
void
archconfinit(void)
{
	m-&gt;cpuhz = Frequency;
	m-&gt;delayloop = m-&gt;cpuhz/2000; 	 /* initial estimate */
	fixaddrmap();
	if (Debug)
		praddrmap();
	prcachecfg();

	l2cacheon();
}

void
archkwlink(void)
{
}

int
archether(unsigned ctlno, Ether *ether)
{
	if(ctlno &gt;= 2)
		return -1;
	ether-&gt;type = "88e1116";
	ether-&gt;port = ctlno;
//	ether-&gt;mbps = 1000;
	return 1;
}

/* LED/USB gpios */
enum {
	/*
	 * the bit assignments are MPP pin numbers from the last page of the
	 * sheevaplug 6.0.1 schematic.
	 */
	KWOEValHigh	= 1&lt;&lt;(49-32),	/* pin 49: LED pin */
	KWOEValLow	= 1&lt;&lt;29,	/* pin 29: USB_PWEN, pin 28: usb_pwerr */
	KWOELow		= ~0,
	KWOEHigh	= ~0,
};

/* called early in main */
void
archreset(void)
{
	ulong clocks;
	CpucsReg *cpu;
	Dramctl *dram;
	GpioReg *gpio;

	clockshutdown();		/* watchdog disabled */

	/* configure gpios */
	gpio = (GpioReg*)soc.gpio[0];
	gpio-&gt;dataout = KWOEValLow;
	coherence();
	gpio-&gt;dataoutena = KWOELow;

	gpio = (GpioReg*)soc.gpio[1];
	gpio-&gt;dataout = KWOEValHigh;
	coherence();
	gpio-&gt;dataoutena = KWOEHigh;
	coherence();

	cpu = (CpucsReg *)soc.cpu;
	cpu-&gt;mempm = 0;			/* turn everything on */
	coherence();

	clocks = MASK(10);
	clocks |= MASK(21) &amp; ~MASK(14);
	clocks &amp;= ~(1&lt;&lt;18 | 1&lt;&lt;1);	/* reserved bits */
	cpu-&gt;clockgate |= clocks;	/* enable all the clocks */
	cpu-&gt;l2cfg |= L2exists;		/* when L2exists is 0, the l2 ignores us */
	coherence();

	dram = (Dramctl *)soc.sdramc;
	dram-&gt;ddrctllo &amp;= ~(1&lt;&lt;6);	/* marvell guideline GL-MEM-70 */

	*(ulong *)soc.analog = 0x68;	/* marvell guideline GL-MISC-40 */
	coherence();
}

void
archreboot(void)
{
	CpucsReg *cpu;

	iprint("reset!\n");
	delay(10);

	cpu = (CpucsReg *)soc.cpu;
	cpu-&gt;rstout = RstoutSoft;
	cpu-&gt;softreset = ResetSystem;
	coherence();
	cpu-&gt;cpucsr = Reset;
	coherence();
	delay(500);

	splhi();
	iprint("waiting...");
	for(;;)
		idlehands();
}

void
archconsole(void)
{
//	uartconsole(0, "b115200");
//serialputs("uart0 console @ 115200\n", strlen("uart0 console @ 115200\n"));
}

void
archflashwp(Flash*, int)
{
}

int	flashat(Flash *f, uintptr pa);

/*
 * for ../port/devflash.c:/^flashreset
 * retrieve flash type, virtual base and length and return 0;
 * return -1 on error (no flash)
 */
int
archflashreset(int bank, Flash *f)
{
	if(bank != 0)
		return -1;
	f-&gt;type = "nand";
	if (flashat(f, PHYSNAND1))
		f-&gt;addr = (void*)PHYSNAND1;
	else if (flashat(f, PHYSNAND2))
		f-&gt;addr = (void*)PHYSNAND2;
	else
		f-&gt;addr = nil;
	f-&gt;size = 0;		/* done by probe */
	f-&gt;width = 1;
	f-&gt;interleave = 0;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

