<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/devrtc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/devrtc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * devrtc - real-time clock, for kirkwood
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"

typedef	struct	RtcReg	RtcReg;
typedef	struct	Rtc	Rtc;

struct RtcReg
{
	ulong	time;
	ulong	date;
	ulong	alarmtm;
	ulong	alarmdt;
	ulong	intrmask;
	ulong	intrcause;
};

struct Rtc
{
	int	sec;
	int	min;
	int	hour;
	int	wday;
	int	mday;
	int	mon;
	int	year;
};

enum {
	Qdir,
	Qrtc,
};

static Dirtab rtcdir[] = {
	".",	{Qdir, 0, QTDIR},	0,		0555,
	"rtc",	{Qrtc},			NUMSIZE,	0664,
};
static	RtcReg	*rtcreg;		/* filled in by attach */
static	Lock	rtclock;

#define SEC2MIN	60
#define SEC2HOUR (60*SEC2MIN)
#define SEC2DAY (24L*SEC2HOUR)

/*
 * days per month plus days/year
 */
static	int	dmsize[] =
{
	365, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};
static	int	ldmsize[] =
{
	366, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};

/*
 *  return the days/month for the given year
 */
static int *
yrsize(int yr)
{
	if((yr % 4) == 0)
		return ldmsize;
	else
		return dmsize;
}

/*
 *  compute seconds since Jan 1 1970
 */
static ulong
rtc2sec(Rtc *rtc)
{
	ulong secs;
	int i;
	int *d2m;

	/*
	 *  seconds per year
	 */
	secs = 0;
	for(i = 1970; i &lt; rtc-&gt;year; i++){
		d2m = yrsize(i);
		secs += d2m[0] * SEC2DAY;
	}

	/*
	 *  seconds per month
	 */
	d2m = yrsize(rtc-&gt;year);
	for(i = 1; i &lt; rtc-&gt;mon; i++)
		secs += d2m[i] * SEC2DAY;

	secs += (rtc-&gt;mday-1) * SEC2DAY;
	secs += rtc-&gt;hour * SEC2HOUR;
	secs += rtc-&gt;min * SEC2MIN;
	secs += rtc-&gt;sec;

	return secs;
}

/*
 *  compute rtc from seconds since Jan 1 1970
 */
static void
sec2rtc(ulong secs, Rtc *rtc)
{
	int d;
	long hms, day;
	int *d2m;

	/*
	 * break initial number into days
	 */
	hms = secs % SEC2DAY;
	day = secs / SEC2DAY;
	if(hms &lt; 0) {
		hms += SEC2DAY;
		day -= 1;
	}

	/*
	 * 19700101 was thursday
	 */
	rtc-&gt;wday = (day + 7340036L) % 7;

	/*
	 * generate hours:minutes:seconds
	 */
	rtc-&gt;sec = hms % 60;
	d = hms / 60;
	rtc-&gt;min = d % 60;
	d /= 60;
	rtc-&gt;hour = d;

	/*
	 * year number
	 */
	if(day &gt;= 0)
		for(d = 1970; day &gt;= *yrsize(d); d++)
			day -= *yrsize(d);
	else
		for (d = 1970; day &lt; 0; d--)
			day += *yrsize(d-1);
	rtc-&gt;year = d;

	/*
	 * generate month
	 */
	d2m = yrsize(rtc-&gt;year);
	for(d = 1; day &gt;= d2m[d]; d++)
		day -= d2m[d];
	rtc-&gt;mday = day + 1;
	rtc-&gt;mon = d;
}

enum {
	Rtcsec	= 0x00007f,
	Rtcmin	= 0x007f00,
	Rtcms	= 8,
	Rtchr12	= 0x1f0000,
	Rtchr24	= 0x3f0000,
	Rtchrs	= 16,

	Rdmday	= 0x00003f,
	Rdmon	= 0x001f00,
	Rdms	= 8,
	Rdyear	= 0x7f0000,
	Rdys	= 16,

	Rtcpm	= 1&lt;&lt;21,		/* pm bit */
	Rtc12	= 1&lt;&lt;22,		/* 12 hr clock */
};

static ulong
bcd2dec(ulong bcd)
{
	ulong d, m, i;

	d = 0;
	m = 1;
	for(i = 0; i &lt; 2 * sizeof d; i++){
		d += ((bcd &gt;&gt; (4*i)) &amp; 0xf) * m;
		m *= 10;
	}
	return d;
}

static ulong
dec2bcd(ulong d)
{
	ulong bcd, i;

	bcd = 0;
	for(i = 0; d != 0; i++){
		bcd |= (d%10) &lt;&lt; (4*i);
		d /= 10;
	}
	return bcd;
}

static long
_rtctime(void)
{
	ulong t, d;
	Rtc rtc;

	t = rtcreg-&gt;time;
	d = rtcreg-&gt;date;

	rtc.sec = bcd2dec(t &amp; Rtcsec);
	rtc.min = bcd2dec((t &amp; Rtcmin) &gt;&gt; Rtcms);

	if(t &amp; Rtc12){
		rtc.hour = bcd2dec((t &amp; Rtchr12) &gt;&gt; Rtchrs) - 1; /* 1—12 */
		if(t &amp; Rtcpm)
			rtc.hour += 12;
	}else
		rtc.hour = bcd2dec((t &amp; Rtchr24) &gt;&gt; Rtchrs);	/* 0—23 */

	rtc.mday = bcd2dec(d &amp; Rdmday);				/* 1—31 */
	rtc.mon = bcd2dec((d &amp; Rdmon) &gt;&gt; Rdms);			/* 1—12 */
	rtc.year = bcd2dec((d &amp; Rdyear) &gt;&gt; Rdys) + 2000;	/* year%100 */

//	print("%0.2d:%0.2d:%.02d %0.2d/%0.2d/%0.2d\n", /* HH:MM:SS YY/MM/DD */
//		rtc.hour, rtc.min, rtc.sec, rtc.year, rtc.mon, rtc.mday);
	return rtc2sec(&amp;rtc);
}

long
rtctime(void)
{
	int i;
	long t, ot;

	ilock(&amp;rtclock);

	/* loop until we get two reads in a row the same */
	t = _rtctime();
	ot = ~t;
	for(i = 0; i &lt; 100 &amp;&amp; ot != t; i++){
		ot = t;
		t = _rtctime();
	}
	if(ot != t)
		print("rtctime: we are boofheads\n");

	iunlock(&amp;rtclock);
	return t;
}

static void
setrtc(Rtc *rtc)
{
	ilock(&amp;rtclock);
	rtcreg-&gt;time = dec2bcd(rtc-&gt;wday) &lt;&lt; 24 | dec2bcd(rtc-&gt;hour) &lt;&lt; 16 |
		dec2bcd(rtc-&gt;min) &lt;&lt; 8 | dec2bcd(rtc-&gt;sec);
	rtcreg-&gt;date = dec2bcd(rtc-&gt;year - 2000) &lt;&lt; 16 |
		dec2bcd(rtc-&gt;mon) &lt;&lt; 8 | dec2bcd(rtc-&gt;mday);
	iunlock(&amp;rtclock);
}

static Chan*
rtcattach(char *spec)
{
	rtcreg = (RtcReg*)soc.rtc;
	return devattach(L'r', spec);
}

static Walkqid*
rtcwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, rtcdir, nelem(rtcdir), devgen);
}

static int
rtcstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, rtcdir, nelem(rtcdir), devgen);
}

static Chan*
rtcopen(Chan *c, int omode)
{
	return devopen(c, omode, rtcdir, nelem(rtcdir), devgen);
}

static void
rtcclose(Chan*)
{
}

static long
rtcread(Chan *c, void *buf, long n, vlong off)
{
	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, buf, n, rtcdir, nelem(rtcdir), devgen);

	switch((ulong)c-&gt;qid.path){
	default:
		error(Egreg);
	case Qrtc:
		return readnum(off, buf, n, rtctime(), NUMSIZE);
	}
}

static long
rtcwrite(Chan *c, void *buf, long n, vlong off)
{
	ulong offset = off;
	char *cp, sbuf[32];
	Rtc rtc;

	switch((ulong)c-&gt;qid.path){
	default:
		error(Egreg);
	case Qrtc:
		if(offset != 0 || n &gt;= sizeof(sbuf)-1)
			error(Ebadarg);
		memmove(sbuf, buf, n);
		sbuf[n] = '\0';
		for(cp = sbuf; *cp != '\0'; cp++)
			if(*cp &gt;= '0' &amp;&amp; *cp &lt;= '9')
				break;
		sec2rtc(strtoul(cp, 0, 0), &amp;rtc);
		setrtc(&amp;rtc);
		return n;
	}
}

Dev rtcdevtab = {
	L'r',
	"rtc",

	devreset,
	devinit,
	devshutdown,
	rtcattach,
	rtcwalk,
	rtcstat,
	rtcopen,
	devcreate,
	rtcclose,
	rtcread,
	devbread,
	rtcwrite,
	devbwrite,
	devremove,
	devwstat,
	devpower,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

