<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/devtwsi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/devtwsi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * kirkwood two-wire serial interface (TWSI) and
 * inter-integrated circuit (I⁲C) driver
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"

enum {
	Qdir,
	Qtwsi,
};

typedef struct Kwtwsi Kwtwsi;
typedef struct Twsi Twsi;

struct Kwtwsi {				/* device registers */
	ulong	saddr;
	ulong	data;
	ulong	ctl;
	union {
		ulong	status;		/* ro */
		ulong	rate;		/* wo: baud rate */
	};

	ulong	saddrext;
	uchar	_pad0[0x1c-0x14];
	ulong	reset;
	uchar	_pad1[0x98-0x20];
	ulong	initlastdata;
};

enum {
	Twsidowrite,
	Twsidoread,

	/* ctl bits */
	Twsiack		= 1&lt;&lt;2,		/* recv'd data; clear to ack */
	Twsiint		= 1&lt;&lt;3,		/* interrupt conditions true */
	Twsistop	= 1&lt;&lt;4,		
	Twsistart	= 1&lt;&lt;5,
	Twsislaveen	= 1&lt;&lt;6,
	Twsiinten	= 1&lt;&lt;7,		/* interrupts enabled */

	/* status codes */
	SStart	= 0x08,
	SWa	= 0x18,
	SWda	= 0x28,
	SRa	= 0x40,
	SRda	= 0x50,
	SRna	= 0x58,
};

struct Twsi {
	QLock;
	Rendez	nextbyte;

	/* remainder is state needed to track the operation in progress */
	int	intr;
	int	done;

	uchar	*bp;			/* current ptr into buf */
	uchar	*end;

	ulong	addr;			/* device address */
	char	*error;
};

static Twsi twsi;

static Dirtab twsidir[] = {
	".",	{Qdir, 0, QTDIR},	0,	DMDIR|0555,
	"twsi",	{Qtwsi},		0,	0660,
};

static char Eabsts[] = "abnormal status";

static void
twsifinish(void)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	twsi.done = 1;
	krp-&gt;ctl |= Twsistop;
	coherence();
}

static void
twsidoread(void)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	switch(krp-&gt;status){
	case SStart:
		krp-&gt;data = twsi.addr &lt;&lt; 1 | Twsidoread;
		break;
	case SRa:
		krp-&gt;ctl |= Twsiack;
		break;
	case SRda:
		if(twsi.bp &lt; twsi.end) {
			*twsi.bp++ = krp-&gt;data;
			krp-&gt;ctl |= Twsiack;
		} else
			krp-&gt;ctl &amp;= ~Twsiack;
		break;
	case SRna:
		twsifinish();
		break;
	default:
		twsifinish();
		twsi.error = Eabsts;
		break;
	}
}

static void
twsidowrite(void)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	switch(krp-&gt;status){
	case SStart:
		krp-&gt;data = twsi.addr &lt;&lt; 1 | Twsidowrite;
		break;
	case SWa:
	case SWda:
		if(twsi.bp &lt; twsi.end)
			krp-&gt;data = *twsi.bp++;
		else
			twsifinish();
		break;
	default:
		twsifinish();
		twsi.error = Eabsts;
		break;
	}
}

static int
twsigotintr(void *)
{
	return twsi.intr;
}

static long
twsixfer(uchar *buf, ulong len, ulong offset, void (*op)(void))
{
	ulong off;
	char *err;
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	qlock(&amp;twsi);
	twsi.bp = buf;
	twsi.end = buf + len;

	twsi.addr = offset;
	twsi.done = twsi.intr = 0;
	twsi.error = nil;

	krp-&gt;ctl = (krp-&gt;ctl &amp; ~Twsiint) | Twsistart;
	coherence();
	while (!twsi.done) {
		sleep(&amp;twsi.nextbyte, twsigotintr, 0);
		twsi.intr = 0;
		(*op)();
		/* signal to start new op &amp; extinguish intr source */
		krp-&gt;ctl &amp;= ~Twsiint;
		coherence();
		krp-&gt;ctl |= Twsiinten;
		coherence();
	}
	twsifinish();
	err = twsi.error;
	off = twsi.bp - buf;
	twsi.bp = nil;				/* prevent accidents */
	qunlock(&amp;twsi);

	if(err)
		error(err);
	return off;
}

static void
interrupt(Ureg *, void *)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	twsi.intr = 1;
	wakeup(&amp;twsi.nextbyte);

	krp-&gt;ctl &amp;= ~Twsiinten;			/* stop further interrupts */
	coherence();
	intrclear(Irqlo, IRQ0twsi);
}

static void
twsiinit(void)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	intrenable(Irqlo, IRQ0twsi, interrupt, nil, "twsi");
	krp-&gt;ctl &amp;= ~Twsiint;
	krp-&gt;ctl |= Twsiinten;
	coherence();
}

static void
twsishutdown(void)
{
	Kwtwsi *krp = (Kwtwsi *)soc.twsi;

	krp-&gt;ctl &amp;= ~Twsiinten;
	coherence();
	intrdisable(Irqlo, IRQ0twsi, interrupt, nil, "twsi");
}

static Chan*
twsiattach(char *param)
{
	return devattach(L'⁲', param);
}

static Walkqid*
twsiwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, twsidir, nelem(twsidir), devgen);
}

static int
twsistat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, twsidir, nelem(twsidir), devgen);
}

static Chan*
twsiopen(Chan *c, int omode)
{
	switch((ulong)c-&gt;qid.path){
	default:
		error(Eperm);
	case Qdir:
	case Qtwsi:
		break;
	}
	c = devopen(c, omode, twsidir, nelem(twsidir), devgen);
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
twsiclose(Chan *)
{
}

static long
twsiread(Chan *c, void *v, long n, vlong off)
{
	switch((ulong)c-&gt;qid.path){
	default:
		error(Eperm);
	case Qdir:
		return devdirread(c, v, n, twsidir, nelem(twsidir), devgen);
	case Qtwsi:
		return twsixfer(v, n, off, twsidoread);
	}
}

static long
twsiwrite(Chan *c, void *v, long n, vlong off)
{
	switch((ulong)c-&gt;qid.path){
	default:
		error(Eperm);
	case Qtwsi:
		return twsixfer(v, n, off, twsidowrite);
	}
}

Dev twsidevtab = {
	L'⁲',
	"twsi",

	devreset,
	twsiinit,
	twsishutdown,
	twsiattach,
	twsiwalk,
	twsistat,
	twsiopen,
	devcreate,
	twsiclose,
	twsiread,
	devbread,
	twsiwrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

