<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/ether1116.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/ether1116.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * marvell kirkwood gigabit ethernet (88e1116 and 88e1121) driver
 * (as found in the sheevaplug, openrd and guruplug).
 * the main difference is the flavour of phy kludgery necessary.
 *
 * from /public/doc/marvell/88f61xx.kirkwood.pdf,
 *	/public/doc/marvell/88e1116.pdf, and
 *	/public/doc/marvell/88e1121r.pdf.
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "ethermii.h"
#include "../ip/ip.h"

#define	MIIDBG	if(0)iprint

#define WINATTR(v)      (((v) &amp; MASK(8)) &lt;&lt; 8)
#define WINSIZE(v)      (((v)/(64*1024) - 1) &lt;&lt; 16)

enum {
	Nrx		= 512,
	Ntx		= 32,
	Nrxblks		= 1024,
	Rxblklen	= 2+1522,  /* ifc. supplies first 2 bytes as padding */

	Maxrxintrsec	= 20*1000,	/* max. rx intrs. / sec */
	Etherstuck	= 70,	/* must send or receive a packet in this many sec.s */

	Descralign	= 16,
	Bufalign	= 8,

	Pass		= 1,		/* accept packets */

	Qno		= 0,		/* do everything on queue zero */
};

typedef struct Ctlr Ctlr;
typedef struct Gbereg Gbereg;
typedef struct Mibstats Mibstats;
typedef struct Rx Rx;
typedef struct Tx Tx;

static struct {
	Lock;
	Block	*head;
} freeblocks;

/* hardware receive buffer descriptor */
struct Rx {
	ulong	cs;
	ulong	countsize;	/* bytes, buffer size */
	ulong	buf;		/* phys. addr. of packet buffer */
	ulong	next;		/* phys. addr. of next Rx */
};

/* hardware transmit buffer descriptor */
struct Tx {
	ulong	cs;
	ulong	countchk;	/* bytes, checksum */
	ulong	buf;		/* phys. addr. of packet buffer */
	ulong	next;		/* phys. addr. of next Tx */
};

/* fixed by hw; part of Gberegs */
struct Mibstats {
	union {
		uvlong	rxby;		/* good bytes rcv'd */
		struct {
			ulong	rxbylo;
			ulong	rxbyhi;
		};
	};
	ulong	badrxby;		/* bad bytes rcv'd */
	ulong	mactxerr;		/* tx err pkts */
	ulong	rxpkt;			/* good pkts rcv'd */
	ulong	badrxpkt;		/* bad pkts rcv'd */
	ulong	rxbcastpkt;		/* b'cast pkts rcv'd */
	ulong	rxmcastpkt;		/* m'cast pkts rcv'd */

	ulong	rx64;			/* pkts &lt;= 64 bytes */
	ulong	rx65_127;		/* pkts 65—127 bytes */
	ulong	rx128_255;		/* pkts 128—255 bytes */
	ulong	rx256_511;		/* pkts 256—511 bytes */
	ulong	rx512_1023;		/* pkts 512—1023 bytes */
	ulong	rx1024_max;		/* pkts &gt;= 1024 bytes */

	union {
		uvlong	txby;		/* good bytes sent */
		struct {
			ulong	txbylo;
			ulong	txbyhi;
		};
	};
	ulong	txpkt;			/* good pkts sent */
	/* half-duplex: pkts dropped due to excessive collisions */
	ulong	txcollpktdrop;
	ulong	txmcastpkt;		/* m'cast pkts sent */
	ulong	txbcastpkt;		/* b'cast pkts sent */

	ulong	badmacctlpkts;		/* bad mac ctl pkts */
	ulong	txflctl;		/* flow-control pkts sent */
	ulong	rxflctl;		/* good flow-control pkts rcv'd */
	ulong	badrxflctl;		/* bad flow-control pkts rcv'd */

	ulong	rxundersized;		/* runts */
	ulong	rxfrags;		/* fragments rcv'd */
	ulong	rxtoobig;		/* oversized pkts rcv'd */
	ulong	rxjabber;		/* jabber pkts rcv'd */
	ulong	rxerr;			/* rx error events */
	ulong	crcerr;			/* crc error events */
	ulong	collisions;		/* collision events */
	ulong	latecoll;		/* late collisions */
};

struct Ctlr {
	Lock;
	Ether	*ether;
	Gbereg	*reg;

	Lock	initlock;
	int	init;

	Rx	*rx;		/* receive descriptors */
	Block	*rxb[Nrx];	/* blocks belonging to the descriptors */
	int	rxhead;		/* descr ethernet will write to next */
	int	rxtail;		/* next descr that might need a buffer */
	Rendez	rrendez;	/* interrupt wakes up read process */
	int	haveinput;

	Tx	*tx;
	Block	*txb[Ntx];
	int	txhead;		/* next descr we can use for new packet */
	int	txtail;		/* next descr to reclaim on tx complete */

	Mii	*mii;
	int	port;

	/* stats */
	ulong	intrs;
	ulong	newintrs;
	ulong	txunderrun;
	ulong	txringfull;
	ulong	rxdiscard;
	ulong	rxoverrun;
	ulong	nofirstlast;

	Mibstats;
};

#define	Rxqon(q)	(1&lt;&lt;(q))
#define	Txqon(q)	(1&lt;&lt;(q))

enum {
	/* euc bits */
	Portreset	= 1 &lt;&lt; 20,

	/* sdma config, sdc bits */
	Burst1		= 0,
	Burst2,
	Burst4,
	Burst8,
	Burst16,
	SDCrifb		= 1&lt;&lt;0,		/* rx intr on pkt boundaries */
#define SDCrxburst(v)	((v)&lt;&lt;1)
	SDCrxnobyteswap	= 1&lt;&lt;4,
	SDCtxnobyteswap	= 1&lt;&lt;5,
	SDCswap64byte	= 1&lt;&lt;6,
#define SDCtxburst(v)	((v)&lt;&lt;22)
	/* rx intr ipg (inter packet gap) */
#define SDCipgintrx(v)	((((v)&gt;&gt;15) &amp; 1)&lt;&lt;25) | (((v) &amp; MASK(15))&lt;&lt;7)

	/* portcfg bits */
	PCFGupromisc		= 1&lt;&lt;0,	/* unicast promiscuous mode */
#define Rxqdefault(q)	((q)&lt;&lt;1)
#define Rxqarp(q)	((q)&lt;&lt;4)
	PCFGbcrejectnoiparp	= 1&lt;&lt;7,
	PCFGbcrejectip		= 1&lt;&lt;8,
	PCFGbcrejectarp		= 1&lt;&lt;9,
	PCFGamnotxes		= 1&lt;&lt;12, /* auto mode, no summary update on tx */
	PCFGtcpq	= 1&lt;&lt;14,	/* capture tcp frames to tcpq */
	PCFGudpq	= 1&lt;&lt;15,	/* capture udp frames to udpq */
#define	Rxqtcp(q)	((q)&lt;&lt;16)
#define	Rxqudp(q)	((q)&lt;&lt;19)
#define	Rxqbpdu(q)	((q)&lt;&lt;22)
	PCFGrxcs	= 1&lt;&lt;25,	/* rx tcp checksum mode with header */

	/* portcfgx bits */
	PCFGXspanq	= 1&lt;&lt;1,
	PCFGXcrcoff	= 1&lt;&lt;2,		/* no ethernet crc */

	/* port serial control0, psc0 bits */
	PSC0porton		= 1&lt;&lt;0,
	PSC0forcelinkup		= 1&lt;&lt;1,
	PSC0an_dplxoff		= 1&lt;&lt;2,	/* an_ = auto. negotiate */
	PSC0an_flctloff		= 1&lt;&lt;3,
	PSC0an_pauseadv		= 1&lt;&lt;4,
	PSC0nofrclinkdown	= 1&lt;&lt;10,
	PSC0an_spdoff		= 1&lt;&lt;13,
	PSC0dteadv		= 1&lt;&lt;14,	/* dte advertise */

	/* max. input pkt size */
#define PSC0mru(v)	((v)&lt;&lt;17)
	PSC0mrumask	= PSC0mru(MASK(3)),
	PSC0mru1518	= 0,		/* 1500+2* 6(addrs) +2 + 4(crc) */
	PSC0mru1522,			/* 1518 + 4(vlan tags) */
	PSC0mru1552,			/* `baby giant' */
	PSC0mru9022,			/* `jumbo' */
	PSC0mru9192,			/* bigger jumbo */
	PSC0mru9700,			/* still bigger jumbo */

	PSC0fd_frc		= 1&lt;&lt;21,	/* force full duplex */
	PSC0flctlfrc		= 1&lt;&lt;22,
	PSC0gmiispd_gbfrc	= 1&lt;&lt;23,
	PSC0miispdfrc100mbps	= 1&lt;&lt;24,

	/* port status 0, ps0 bits */
	PS0linkup	= 1&lt;&lt;1,
	PS0fd		= 1&lt;&lt;2,			/* full duplex */
	PS0flctl	= 1&lt;&lt;3,
	PS0gmii_gb	= 1&lt;&lt;4,
	PS0mii100mbps	= 1&lt;&lt;5,
	PS0txbusy	= 1&lt;&lt;7,
	PS0txfifoempty	= 1&lt;&lt;10,
	PS0rxfifo1empty	= 1&lt;&lt;11,
	PS0rxfifo2empty	= 1&lt;&lt;12,

	/* port serial control 1, psc1 bits */
	PSC1loopback	= 1&lt;&lt;1,
	PSC1mii		= 0&lt;&lt;2,
	PSC1rgmii	= 1&lt;&lt;3,			/* enable RGMII */
	PSC1portreset	= 1&lt;&lt;4,
	PSC1clockbypass	= 1&lt;&lt;5,
	PSC1iban	= 1&lt;&lt;6,
	PSC1iban_bypass	= 1&lt;&lt;7,
	PSC1iban_restart= 1&lt;&lt;8,
	PSC1_gbonly	= 1&lt;&lt;11,
	PSC1encolonbp	= 1&lt;&lt;15, /* "collision during back-pressure mib counting" */
	PSC1coldomlimmask= MASK(6)&lt;&lt;16,
#define PSC1coldomlim(v) (((v) &amp; MASK(6))&lt;&lt;16)
	PSC1miiallowoddpreamble	= 1&lt;&lt;22,

	/* port status 1, ps1 bits */
	PS1rxpause	= 1&lt;&lt;0,
	PS1txpause	= 1&lt;&lt;1,
	PS1pressure	= 1&lt;&lt;2,
	PS1syncfail10ms	= 1&lt;&lt;3,
	PS1an_done	= 1&lt;&lt;4,
	PS1inbandan_bypassed	= 1&lt;&lt;5,
	PS1serdesplllocked	= 1&lt;&lt;6,
	PS1syncok	= 1&lt;&lt;7,
	PS1nosquelch	= 1&lt;&lt;8,

	/* irq bits */
	/* rx buf returned to cpu ownership, or frame reception finished */
	Irx		= 1&lt;&lt;0,
	Iextend		= 1&lt;&lt;1,		/* IEsum of irqe set */
#define Irxbufferq(q)	(1&lt;&lt;((q)+2))	/* rx buf returned to cpu ownership */
	Irxerr		= 1&lt;&lt;10,	/* input ring full, usually */
#define Irxerrq(q)	(1&lt;&lt;((q)+11))
#define Itxendq(q)	(1&lt;&lt;((q)+19))	/* tx dma stopped for q */
	Isum		= 1&lt;&lt;31,

	/* irq extended, irqe bits */
#define	IEtxbufferq(q)	(1&lt;&lt;((q)+0))	/* tx buf returned to cpu ownership */
#define	IEtxerrq(q)	(1&lt;&lt;((q)+8))
	IEphystschg	= 1&lt;&lt;16,
	IEptp		= 1&lt;&lt;17,
	IErxoverrun	= 1&lt;&lt;18,
	IEtxunderrun	= 1&lt;&lt;19,
	IElinkchg	= 1&lt;&lt;20,
	IEintaddrerr	= 1&lt;&lt;23,
	IEprbserr	= 1&lt;&lt;25,
	IEsum		= 1&lt;&lt;31,

	/* tx fifo urgent threshold (tx interrupt coalescing), pxtfut */
#define TFUTipginttx(v)	(((v) &amp; MASK(16))&lt;&lt;4);

	/* minimal frame size, mfs */
	MFS40by	= 10&lt;&lt;2,
	MFS44by	= 11&lt;&lt;2,
	MFS48by	= 12&lt;&lt;2,
	MFS52by	= 13&lt;&lt;2,
	MFS56by	= 14&lt;&lt;2,
	MFS60by	= 15&lt;&lt;2,
	MFS64by	= 16&lt;&lt;2,

	/* receive descriptor status */
	RCSmacerr	= 1&lt;&lt;0,
	RCSmacmask	= 3&lt;&lt;1,
	RCSmacce	= 0&lt;&lt;1,
	RCSmacor	= 1&lt;&lt;1,
	RCSmacmf	= 2&lt;&lt;1,
	RCSl4chkshift	= 3,
	RCSl4chkmask	= MASK(16),
	RCSvlan		= 1&lt;&lt;17,
	RCSbpdu		= 1&lt;&lt;18,
	RCSl4mask	= 3&lt;&lt;21,
	RCSl4tcp4	= 0&lt;&lt;21,
	RCSl4udp4	= 1&lt;&lt;21,
	RCSl4other	= 2&lt;&lt;21,
	RCSl4rsvd	= 3&lt;&lt;21,
	RCSl2ev2	= 1&lt;&lt;23,
	RCSl3ip4	= 1&lt;&lt;24,
	RCSip4headok	= 1&lt;&lt;25,
	RCSlast		= 1&lt;&lt;26,
	RCSfirst	= 1&lt;&lt;27,
	RCSunknownaddr	= 1&lt;&lt;28,
	RCSenableintr	= 1&lt;&lt;29,
	RCSl4chkok	= 1&lt;&lt;30,
	RCSdmaown	= 1&lt;&lt;31,

	/* transmit descriptor status */
	TCSmacerr	= 1&lt;&lt;0,
	TCSmacmask	= 3&lt;&lt;1,
	TCSmaclc	= 0&lt;&lt;1,
	TCSmacur	= 1&lt;&lt;1,
	TCSmacrl	= 2&lt;&lt;1,
	TCSllc		= 1&lt;&lt;9,
	TCSl4chkmode	= 1&lt;&lt;10,
	TCSipv4hdlenshift= 11,
	TCSvlan		= 1&lt;&lt;15,
	TCSl4type	= 1&lt;&lt;16,
	TCSgl4chk	= 1&lt;&lt;17,
	TCSgip4chk	= 1&lt;&lt;18,
	TCSpadding	= 1&lt;&lt;19,
	TCSlast		= 1&lt;&lt;20,
	TCSfirst	= 1&lt;&lt;21,
	TCSenableintr	= 1&lt;&lt;23,
	TCSautomode	= 1&lt;&lt;30,
	TCSdmaown	= 1&lt;&lt;31,
};

enum {
	/* SMI regs */
	PhysmiTimeout	= 10000,	/* what units? in ms. */
	Physmidataoff	= 0,		/* Data */
	Physmidatamask	= 0xffff&lt;&lt;Physmidataoff,

	Physmiaddroff 	= 16,		/* PHY device addr */
	Physmiaddrmask	= 0x1f &lt;&lt; Physmiaddroff,

	Physmiop	= 26,
	Physmiopmask	= 3&lt;&lt;Physmiop,
	PhysmiopWr	= 0&lt;&lt;Physmiop,
	PhysmiopRd	= 1&lt;&lt;Physmiop,

	PhysmiReadok	= 1&lt;&lt;27,
	PhysmiBusy	= 1&lt;&lt;28,

	SmiRegaddroff	= 21,		/* PHY device register addr */
	SmiRegaddrmask	= 0x1f &lt;&lt; SmiRegaddroff,
};

struct Gbereg {
	ulong	phy;			/* PHY address */
	ulong	smi;			/* serial mgmt. interface */
	ulong	euda;			/* ether default address */
	ulong	eudid;			/* ether default id */
	uchar	_pad0[0x80-0x10];

	/* dma stuff */
	ulong	euirq;			/* interrupt cause */
	ulong	euirqmask;		/* interrupt mask */
	uchar	_pad1[0x94-0x88];
	ulong	euea;			/* error address */
	ulong	euiae;			/* internal error address */
	uchar	_pad2[0xb0-0x9c];
	ulong	euc;			/* control */
	uchar	_pad3[0x200-0xb4];
	struct {
		ulong	base;		/* window base */
		ulong	size;		/* window size */
	} base[6];
	uchar	_pad4[0x280-0x230];
	ulong	harr[4];		/* high address remap */
	ulong	bare;			/* base address enable */
	ulong	epap;			/* port access protect */
	uchar	_pad5[0x400-0x298];

	ulong	portcfg;		/* port configuration */
	ulong	portcfgx;		/* port config. extend */
	ulong	mii;			/* mii serial parameters */
	ulong	_pad6;
	ulong	evlane;			/* vlan ether type */
	ulong	macal;			/* mac address low */
	ulong	macah;			/* mac address high */
	ulong	sdc;			/* sdma config. */
	ulong	dscp[7];		/* ip diff. serv. code point -&gt; pri */
	ulong	psc0;			/* port serial control 0 */
	ulong	vpt2p;			/* vlan priority tag -&gt; pri */
	ulong	ps0;			/* ether port status 0 */
	ulong	tqc;			/* transmit queue command */
	ulong	psc1;			/* port serial control 1 */
	ulong	ps1;			/* ether port status 1 */
	ulong	mvhdr;			/* marvell header */
	ulong	_pad8[2];

	/* interrupts */
	ulong	irq;			/* interrupt cause; some rw0c bits */
	ulong	irqe;			/* " " extended; some rw0c bits */
	ulong	irqmask;		/* interrupt mask (actually enable) */
	ulong	irqemask;		/* " " extended */

	ulong	_pad9;
	ulong	pxtfut;			/* port tx fifo urgent threshold */
	ulong	_pad10;
	ulong	pxmfs;			/* port rx minimum frame size */
	ulong	_pad11;

	/*
	 * # of input frames discarded by addr filtering or lack of resources;
	 * zeroed upon read.
	 */
	ulong	pxdfc;			/* port rx discard frame counter */
	ulong	pxofc;			/* port overrun frame counter */
	ulong	_pad12[2];
	ulong	piae;			/* port internal address error */
	uchar	_pad13[0x4bc-0x498];
	ulong	etherprio;		/* ether type priority */
	uchar	_pad14[0x4dc-0x4c0];
	ulong	tqfpc;			/* tx queue fixed priority config. */
	ulong	pttbrc;			/* port tx token-bucket rate config. */
	ulong	tqc1;			/* tx queue command 1 */
	ulong	pmtu;			/* port maximum transmit unit */
	ulong	pmtbs;			/* port maximum token bucket size */
	uchar	_pad15[0x600-0x4f0];

	struct {
		ulong	_pad[3];
		ulong	r;		/* phys. addr.: cur. rx desc. ptrs */
	} crdp[8];
	ulong	rqc;			/* rx queue command */
	ulong	tcsdp;			/* phys. addr.: cur. tx desc. ptr */
	uchar	_pad16[0x6c0-0x688];

	ulong	tcqdp[8];		/* phys. addr.: cur. tx q. desc. ptr */
	uchar	_pad17[0x700-0x6e0];

	struct {
		ulong	tbctr;		/* queue tx token-bucket counter */
		ulong	tbcfg;		/* tx queue token-bucket config. */
		ulong	acfg;		/* tx queue arbiter config. */
		ulong	_pad;
	} tq[8];
	ulong	pttbc;			/* port tx token-bucket counter */
	uchar	_pad18[0x7a8-0x784];

	ulong	ipg2;			/* tx queue ipg */
	ulong	_pad19[3];
	ulong	ipg3;
	ulong	_pad20;
	ulong	htlp;			/* high token in low packet */
	ulong	htap;			/* high token in async packet */
	ulong	ltap;			/* low token in async packet */
	ulong	_pad21;
	ulong	ts;			/* tx speed */
	uchar	_pad22[0x1000-0x7d4];

	/* mac mib counters: statistics */
	Mibstats;
	uchar	_pad23[0x1400-0x1080];

	/* multicast filtering; each byte: Qno&lt;&lt;1 | Pass */
	ulong	dfsmt[64];	/* dest addr filter special m'cast table */
	ulong	dfomt[64];	/* dest addr filter other m'cast table */
	/* unicast filtering */
	ulong	dfut[4];		/* dest addr filter unicast table */
};

static Ctlr *ctlrs[MaxEther];
static uchar zeroea[Eaddrlen];

static void getmibstats(Ctlr *);

static void
rxfreeb(Block *b)
{
	/* freeb(b) will have previously decremented b-&gt;ref to 0; raise to 1 */
	_xinc(&amp;b-&gt;ref);
	b-&gt;wp = b-&gt;rp =
		(uchar*)((uintptr)(b-&gt;lim - Rxblklen) &amp; ~(Bufalign - 1));
	assert(((uintptr)b-&gt;rp &amp; (Bufalign - 1)) == 0);
	b-&gt;free = rxfreeb;

	ilock(&amp;freeblocks);
	b-&gt;next = freeblocks.head;
	freeblocks.head = b;
	iunlock(&amp;freeblocks);
}

static Block *
rxallocb(void)
{
	Block *b;

	ilock(&amp;freeblocks);
	b = freeblocks.head;
	if(b != nil) {
		freeblocks.head = b-&gt;next;
		b-&gt;next = nil;
		b-&gt;free = rxfreeb;
	}
	iunlock(&amp;freeblocks);
	return b;
}

static void
rxkick(Ctlr *ctlr)
{
	Gbereg *reg = ctlr-&gt;reg;

	if (reg-&gt;crdp[Qno].r == 0)
		reg-&gt;crdp[Qno].r = PADDR(&amp;ctlr-&gt;rx[ctlr-&gt;rxhead]);
	if ((reg-&gt;rqc &amp; 0xff) == 0)		/* all queues are stopped? */
		reg-&gt;rqc = Rxqon(Qno);		/* restart */
	coherence();
}

static void
txkick(Ctlr *ctlr)
{
	Gbereg *reg = ctlr-&gt;reg;

	if (reg-&gt;tcqdp[Qno] == 0)
		reg-&gt;tcqdp[Qno] = PADDR(&amp;ctlr-&gt;tx[ctlr-&gt;txhead]);
	if ((reg-&gt;tqc &amp; 0xff) == 0)		/* all q's stopped? */
		reg-&gt;tqc = Txqon(Qno);		/* restart */
	coherence();
}

static void
rxreplenish(Ctlr *ctlr)
{
	Rx *r;
	Block *b;

	while(ctlr-&gt;rxb[ctlr-&gt;rxtail] == nil) {
		b = rxallocb();
		if(b == nil) {
			iprint("#l%d: rxreplenish out of buffers\n",
				ctlr-&gt;ether-&gt;ctlrno);
			break;
		}

		ctlr-&gt;rxb[ctlr-&gt;rxtail] = b;

		/* set up uncached receive descriptor */
		r = &amp;ctlr-&gt;rx[ctlr-&gt;rxtail];
		assert(((uintptr)r &amp; (Descralign - 1)) == 0);
		r-&gt;countsize = ROUNDUP(Rxblklen, 8);
		r-&gt;buf = PADDR(b-&gt;rp);
		coherence();

		/* and fire */
		r-&gt;cs = RCSdmaown | RCSenableintr;
		coherence();

		ctlr-&gt;rxtail = NEXT(ctlr-&gt;rxtail, Nrx);
	}
}

static void
dump(uchar *bp, long max)
{
	if (max &gt; 64)
		max = 64;
	for (; max &gt; 0; max--, bp++)
		iprint("%02.2ux ", *bp);
	print("...\n");
}

static void
etheractive(Ether *ether)
{
	ether-&gt;starttime = TK2MS(MACHP(0)-&gt;ticks)/1000;
}

static void
ethercheck(Ether *ether)
{
	if (ether-&gt;starttime != 0 &amp;&amp;
	    TK2MS(MACHP(0)-&gt;ticks)/1000 - ether-&gt;starttime &gt; Etherstuck) {
		etheractive(ether);
		if (ether-&gt;ctlrno == 0)	/* only complain about main ether */
			iprint("#l%d: ethernet stuck\n", ether-&gt;ctlrno);
	}
}

static void
receive(Ether *ether)
{
	int i;
	ulong n;
	Block *b;
	Ctlr *ctlr = ether-&gt;ctlr;
	Rx *r;

	ethercheck(ether);
	for (i = Nrx-2; i &gt; 0; i--) {
		r = &amp;ctlr-&gt;rx[ctlr-&gt;rxhead];	/* *r is uncached */
		assert(((uintptr)r &amp; (Descralign - 1)) == 0);
		if(r-&gt;cs &amp; RCSdmaown)		/* descriptor busy? */
			break;

		b = ctlr-&gt;rxb[ctlr-&gt;rxhead];	/* got input buffer? */
		if (b == nil)
			panic("ether1116: nil ctlr-&gt;rxb[ctlr-&gt;rxhead] "
				"in receive");
		ctlr-&gt;rxb[ctlr-&gt;rxhead] = nil;
		ctlr-&gt;rxhead = NEXT(ctlr-&gt;rxhead, Nrx);

		if((r-&gt;cs &amp; (RCSfirst|RCSlast)) != (RCSfirst|RCSlast)) {
			ctlr-&gt;nofirstlast++;	/* partial packet */
			freeb(b);
			continue;
		}
		if(r-&gt;cs &amp; RCSmacerr) {
			freeb(b);
			continue;
		}

		n = r-&gt;countsize &gt;&gt; 16;		/* TODO includes 2 pad bytes? */
		assert(n &gt;= 2 &amp;&amp; n &lt; 2048);

		/* clear any cached packet or part thereof */
		l2cacheuinvse(b-&gt;rp, n+2);
		cachedinvse(b-&gt;rp, n+2);
		b-&gt;wp = b-&gt;rp + n;
		/*
		 * skip hardware padding intended to align ipv4 address
		 * in memory (mv-s104860-u0 §8.3.4.1)
		 */
		b-&gt;rp += 2;
		etheriq(ether, b, 1);
		etheractive(ether);
		if (i % (Nrx / 2) == 0) {
			rxreplenish(ctlr);
			rxkick(ctlr);
		}
	}
	rxreplenish(ctlr);
	rxkick(ctlr);
}

static void
txreplenish(Ether *ether)			/* free transmitted packets */
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	while(ctlr-&gt;txtail != ctlr-&gt;txhead) {
		/* ctlr-&gt;tx is uncached */
		if(ctlr-&gt;tx[ctlr-&gt;txtail].cs &amp; TCSdmaown)
			break;
		if(ctlr-&gt;txb[ctlr-&gt;txtail] == nil)
			panic("no block for sent packet?!");
		freeb(ctlr-&gt;txb[ctlr-&gt;txtail]);
		ctlr-&gt;txb[ctlr-&gt;txtail] = nil;

		ctlr-&gt;txtail = NEXT(ctlr-&gt;txtail, Ntx);
		etheractive(ether);
	}
}

/*
 * transmit strategy: fill the output ring as far as possible,
 * perhaps leaving a few spare; kick off the output and take
 * an interrupt only when the transmit queue is empty.
 */
static void
transmit(Ether *ether)
{
	int i, kick, len;
	Block *b;
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;
	Tx *t;

	ethercheck(ether);
	ilock(ctlr);
	txreplenish(ether);			/* reap old packets */

	/* queue new packets; use at most half the tx descs to avoid livelock */
	kick = 0;
	for (i = Ntx/2 - 2; i &gt; 0; i--) {
		t = &amp;ctlr-&gt;tx[ctlr-&gt;txhead];	/* *t is uncached */
		assert(((uintptr)t &amp; (Descralign - 1)) == 0);
		if(t-&gt;cs &amp; TCSdmaown) {		/* descriptor busy? */
			ctlr-&gt;txringfull++;
			break;
		}

		b = qget(ether-&gt;oq);		/* outgoing packet? */
		if (b == nil)
			break;
		len = BLEN(b);
		if(len &lt; ether-&gt;minmtu || len &gt; ether-&gt;maxmtu) {
			freeb(b);
			continue;
		}
		ctlr-&gt;txb[ctlr-&gt;txhead] = b;

		/* make sure the whole packet is in memory */
		cachedwbse(b-&gt;rp, len);
		l2cacheuwbse(b-&gt;rp, len);

		/* set up the transmit descriptor */
		t-&gt;buf = PADDR(b-&gt;rp);
		t-&gt;countchk = len &lt;&lt; 16;
		coherence();

		/* and fire */
		t-&gt;cs = TCSpadding | TCSfirst | TCSlast | TCSdmaown |
			TCSenableintr;
		coherence();

		kick++;
		ctlr-&gt;txhead = NEXT(ctlr-&gt;txhead, Ntx);
	}
	if (kick) {
		txkick(ctlr);

		reg-&gt;irqmask  |= Itxendq(Qno);
		reg-&gt;irqemask |= IEtxerrq(Qno) | IEtxunderrun;
	}
	iunlock(ctlr);
}

static void
dumprxdescs(Ctlr *ctlr)
{
	int i;
	Gbereg *reg = ctlr-&gt;reg;

	iprint("\nrxhead %d rxtail %d; txcdp %#p rxcdp %#p\n",
		ctlr-&gt;rxhead, ctlr-&gt;rxtail, reg-&gt;tcqdp[Qno], reg-&gt;crdp[Qno].r);
	for (i = 0; i &lt; Nrx; i++) {
		iprint("rxb %d @ %#p: %#p\n", i, &amp;ctlr-&gt;rxb[i], ctlr-&gt;rxb[i]);
		delay(50);
	}
	for (i = 0; i &lt; Nrx; i++) {
		iprint("rx %d @ %#p: cs %#lux countsize %lud buf %#lux next %#lux\n",
			i, &amp;ctlr-&gt;rx[i], ctlr-&gt;rx[i].cs,
			ctlr-&gt;rx[i].countsize &gt;&gt; 3, ctlr-&gt;rx[i].buf,
			ctlr-&gt;rx[i].next);
		delay(50);
	}
	delay(1000);
}

static int
gotinput(void* ctlr)
{
	return ((Ctlr*)ctlr)-&gt;haveinput != 0;
}

/*
 * process any packets in the input ring.
 * also sum mib stats frequently to avoid the overflow
 * mentioned in the errata.
 */
static void
rcvproc(void* arg)
{
	Ctlr *ctlr;
	Ether *ether;

	ether = arg;
	ctlr = ether-&gt;ctlr;
	for(;;){
		tsleep(&amp;ctlr-&gt;rrendez, gotinput, ctlr, 10*1000);
		ilock(ctlr);
		getmibstats(ctlr);
		if (ctlr-&gt;haveinput) {
			ctlr-&gt;haveinput = 0;
			iunlock(ctlr);
			receive(ether);
		} else
			iunlock(ctlr);
	}
}

static void
interrupt(Ureg*, void *arg)
{
	ulong irq, irqe, handled;
	Ether *ether = arg;
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;

	handled = 0;
	irq = reg-&gt;irq;
	irqe = reg-&gt;irqe;
	reg-&gt;irqe = 0;				/* extinguish intr causes */
	reg-&gt;irq = 0;				/* extinguish intr causes */
	ethercheck(ether);

	if(irq &amp; (Irx | Irxbufferq(Qno))) {
		/*
		 * letting a kproc process the input takes far less real time
		 * than doing it all at interrupt level.
		 */
		ctlr-&gt;haveinput = 1;
		wakeup(&amp;ctlr-&gt;rrendez);
		irq &amp;= ~(Irx | Irxbufferq(Qno));
		handled++;
	} else
		rxkick(ctlr);

	if(irq &amp; Itxendq(Qno)) {		/* transmit ring empty? */
		reg-&gt;irqmask  &amp;= ~Itxendq(Qno);	/* prevent more interrupts */
		reg-&gt;irqemask &amp;= ~(IEtxerrq(Qno) | IEtxunderrun);
		transmit(ether);
		irq &amp;= ~Itxendq(Qno);
		handled++;
	}

	if(irqe &amp; IEsum) {
		/*
		 * IElinkchg appears to only be set when unplugging.
		 * autonegotiation is likely not done yet, so linkup not valid,
		 * thus we note the link change here, and check for
		 * that and autonegotiation done below.
		 */
		if(irqe &amp; IEphystschg) {
			ether-&gt;link = (reg-&gt;ps0 &amp; PS0linkup) != 0;
			ether-&gt;linkchg = 1;
		}
		if(irqe &amp; IEtxerrq(Qno))
			ether-&gt;oerrs++;
		if(irqe &amp; IErxoverrun)
			ether-&gt;overflows++;
		if(irqe &amp; IEtxunderrun)
			ctlr-&gt;txunderrun++;
		if(irqe &amp; (IEphystschg | IEtxerrq(Qno) | IErxoverrun |
		    IEtxunderrun))
			handled++;
	}
	if (irq &amp; Isum) {
		if (irq &amp; Irxerr) {  /* nil desc. ptr. or desc. owned by cpu */
			ether-&gt;buffs++;		/* approx. error */

			/* if the input ring is full, drain it */
			ctlr-&gt;haveinput = 1;
			wakeup(&amp;ctlr-&gt;rrendez);
		}
		if(irq &amp; (Irxerr | Irxerrq(Qno)))
			handled++;
		irq  &amp;= ~(Irxerr | Irxerrq(Qno));
	}

	if(ether-&gt;linkchg &amp;&amp; (reg-&gt;ps1 &amp; PS1an_done)) {
		handled++;
		ether-&gt;link = (reg-&gt;ps0 &amp; PS0linkup) != 0;
		ether-&gt;linkchg = 0;
	}
	ctlr-&gt;newintrs++;

	if (!handled) {
		irq  &amp;= ~Isum;
		irqe &amp;= ~IEtxbufferq(Qno);
		if (irq == 0 &amp;&amp; irqe == 0) {
			/* seems to be triggered by continuous output */
			// iprint("ether1116: spurious interrupt\n");
		} else
			iprint("ether1116: interrupt cause unknown; "
				"irq %#lux irqe %#lux\n", irq, irqe);
	}
	intrclear(Irqlo, ether-&gt;irq);
}

void
promiscuous(void *arg, int on)
{
	Ether *ether = arg;
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;

	ilock(ctlr);
	ether-&gt;prom = on;
	if(on)
		reg-&gt;portcfg |= PCFGupromisc;
	else
		reg-&gt;portcfg &amp;= ~PCFGupromisc;
	iunlock(ctlr);
}

void
multicast(void *, uchar *, int)
{
	/* nothing to do; we always accept multicast */
}

static void quiesce(Gbereg *reg);

static void
shutdown(Ether *ether)
{
	int i;
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;

	ilock(ctlr);
	quiesce(reg);
	reg-&gt;euc |= Portreset;
	coherence();
	iunlock(ctlr);
	delay(100);
	ilock(ctlr);
	reg-&gt;euc &amp;= ~Portreset;
	coherence();
	delay(20);

	reg-&gt;psc0 = 0;			/* no PSC0porton */
	reg-&gt;psc1 |= PSC1portreset;
	coherence();
	delay(50);
	reg-&gt;psc1 &amp;= ~PSC1portreset;
	coherence();

	for (i = 0; i &lt; nelem(reg-&gt;tcqdp); i++)
		reg-&gt;tcqdp[i] = 0;
	for (i = 0; i &lt; nelem(reg-&gt;crdp); i++)
		reg-&gt;crdp[i].r = 0;
	coherence();

	iunlock(ctlr);
}

enum {
	CMjumbo,
};

static Cmdtab ctlmsg[] = {
	CMjumbo,	"jumbo",	2,
};

long
ctl(Ether *e, void *p, long n)
{
	Cmdbuf *cb;
	Cmdtab *ct;
	Ctlr *ctlr = e-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;

	cb = parsecmd(p, n);
	if(waserror()) {
		free(cb);
		nexterror();
	}

	ct = lookupcmd(cb, ctlmsg, nelem(ctlmsg));
	switch(ct-&gt;index) {
	case CMjumbo:
		if(strcmp(cb-&gt;f[1], "on") == 0) {
			/* incoming packet queue doesn't expect jumbo frames */
			error("jumbo disabled");
			reg-&gt;psc0 = (reg-&gt;psc0 &amp; ~PSC0mrumask) |
				PSC0mru(PSC0mru9022);
			e-&gt;maxmtu = 9022;
		} else if(strcmp(cb-&gt;f[1], "off") == 0) {
			reg-&gt;psc0 = (reg-&gt;psc0 &amp; ~PSC0mrumask) |
				PSC0mru(PSC0mru1522);
			e-&gt;maxmtu = ETHERMAXTU;
		} else
			error(Ebadctl);
		break;
	default:
		error(Ebadctl);
		break;
	}
	free(cb);
	poperror();
	return n;
}

/*
 * phy/mii goo
 */

static int
smibusywait(Gbereg *reg, ulong waitbit)
{
	ulong timeout, smi_reg;

	timeout = PhysmiTimeout;
	/* wait till the SMI is not busy */
	do {
		/* read smi register */
		smi_reg = reg-&gt;smi;
		if (timeout-- == 0) {
			MIIDBG("SMI busy timeout\n");
			return -1;
		}
//		delay(1);
	} while (smi_reg &amp; waitbit);
	return 0;
}

static int
miird(Mii *mii, int pa, int ra)
{
	ulong smi_reg, timeout;
	Gbereg *reg;

	reg = ((Ctlr*)mii-&gt;ctlr)-&gt;reg;

	/* check params */
	if ((pa&lt;&lt;Physmiaddroff) &amp; ~Physmiaddrmask ||
	    (ra&lt;&lt;SmiRegaddroff) &amp; ~SmiRegaddrmask)
		return -1;

	smibusywait(reg, PhysmiBusy);

	/* fill the phy address and register offset and read opcode */
	reg-&gt;smi = pa &lt;&lt; Physmiaddroff | ra &lt;&lt; SmiRegaddroff | PhysmiopRd;
	coherence();

	/* wait til read value is ready */
	timeout = PhysmiTimeout;
	do {
		smi_reg = reg-&gt;smi;
		if (timeout-- == 0) {
			MIIDBG("SMI read-valid timeout\n");
			return -1;
		}
	} while (!(smi_reg &amp; PhysmiReadok));

	/* Wait for the data to update in the SMI register */
	for (timeout = 0; timeout &lt; PhysmiTimeout; timeout++)
		;
	return reg-&gt;smi &amp; Physmidatamask;
}

static int
miiwr(Mii *mii, int pa, int ra, int v)
{
	Gbereg *reg;
	ulong smi_reg;

	reg = ((Ctlr*)mii-&gt;ctlr)-&gt;reg;

	/* check params */
	if (((pa&lt;&lt;Physmiaddroff) &amp; ~Physmiaddrmask) ||
	    ((ra&lt;&lt;SmiRegaddroff) &amp; ~SmiRegaddrmask))
		return -1;

	smibusywait(reg, PhysmiBusy);

	/* fill the phy address and register offset and read opcode */
	smi_reg = v &lt;&lt; Physmidataoff | pa &lt;&lt; Physmiaddroff | ra &lt;&lt; SmiRegaddroff;
	reg-&gt;smi = smi_reg &amp; ~PhysmiopRd;
	coherence();
	return 0;
}

#define MIIMODEL(idr2)	(((idr2) &gt;&gt; 4) &amp; MASK(6))

enum {
	Hacknone,
	Hackdual,

	Ouimarvell	= 0x005043,

	/* idr2 mii/phy model numbers */
	Phy1000		= 0x00,		/* 88E1000 Gb */
	Phy1011		= 0x02,		/* 88E1011 Gb */
	Phy1000_3	= 0x03,		/* 88E1000 Gb */
	Phy1000s	= 0x04,		/* 88E1000S Gb */
	Phy1000_5	= 0x05,		/* 88E1000 Gb */
	Phy1000_6	= 0x06,		/* 88E1000 Gb */
	Phy3082		= 0x08,		/* 88E3082 10/100 */
	Phy1112		= 0x09,		/* 88E1112 Gb */
	Phy1121r	= 0x0b,		/* says the 1121r manual */
	Phy1149		= 0x0b,		/* 88E1149 Gb */
	Phy1111		= 0x0c,		/* 88E1111 Gb */
	Phy1116		= 0x21,		/* 88E1116 Gb */
	Phy1116r	= 0x24,		/* 88E1116R Gb */
	Phy1118		= 0x22,		/* 88E1118 Gb */
	Phy3016		= 0x26,		/* 88E3016 10/100 */
};

static int hackflavour;

/*
 * on openrd, ether0's phy has address 8, ether1's is ether0's 24.
 * on guruplug, ether0's is phy 0 and ether1's is ether0's phy 1.
 */
int
mymii(Mii* mii, int mask)
{
	Ctlr *ctlr;
	MiiPhy *miiphy;
	int bit, ctlrno, oui, model, phyno, r, rmask;
	static int dualport, phyidx;
	static int phynos[NMiiPhy];

	ctlr = mii-&gt;ctlr;
	ctlrno = ctlr-&gt;ether-&gt;ctlrno;

	/* first pass: figure out what kind of phy(s) we have. */
	dualport = 0;
	if (ctlrno == 0) {
		for(phyno = 0; phyno &lt; NMiiPhy; phyno++){
			bit = 1&lt;&lt;phyno;
			if(!(mask &amp; bit) || mii-&gt;mask &amp; bit)
				continue;
			if(mii-&gt;mir(mii, phyno, Bmsr) == -1)
				continue;
			r = mii-&gt;mir(mii, phyno, Phyidr1);
			oui = (r &amp; 0x3FFF)&lt;&lt;6;
			r = mii-&gt;mir(mii, phyno, Phyidr2);
			oui |= r&gt;&gt;10;
			model = MIIMODEL(r);
			if (oui == 0xfffff &amp;&amp; model == 0x3f)
				continue;
			MIIDBG("ctlrno %d phy %d oui %#ux model %#ux\n",
				ctlrno, phyno, oui, model);
			if (oui == Ouimarvell &amp;&amp;
			    (model == Phy1121r || model == Phy1116r))
				++dualport;
			phynos[phyidx++] = phyno;
		}
		hackflavour = dualport == 2 &amp;&amp; phyidx == 2? Hackdual: Hacknone;
		MIIDBG("ether1116: %s-port phy\n",
			hackflavour == Hackdual? "dual": "single");
	}

	/*
	 * Probe through mii for PHYs in mask;
	 * return the mask of those found in the current probe.
	 * If the PHY has not already been probed, update
	 * the Mii information.
	 */
	rmask = 0;
	if (hackflavour == Hackdual &amp;&amp; ctlrno &lt; phyidx) {
		/*
		 * openrd, guruplug or the like: use ether0's phys.
		 * this is a nasty hack, but so is the hardware.
		 */
		MIIDBG("ctlrno %d using ctlrno 0's phyno %d\n",
			ctlrno, phynos[ctlrno]);
		ctlr-&gt;mii = mii = ctlrs[0]-&gt;mii;
		mask = 1 &lt;&lt; phynos[ctlrno];
		mii-&gt;mask = ~mask;
	}
	for(phyno = 0; phyno &lt; NMiiPhy; phyno++){
		bit = 1&lt;&lt;phyno;
		if(!(mask &amp; bit))
			continue;
		if(mii-&gt;mask &amp; bit){
			rmask |= bit;
			continue;
		}
		if(mii-&gt;mir(mii, phyno, Bmsr) == -1)
			continue;
		r = mii-&gt;mir(mii, phyno, Phyidr1);
		oui = (r &amp; 0x3FFF)&lt;&lt;6;
		r = mii-&gt;mir(mii, phyno, Phyidr2);
		oui |= r&gt;&gt;10;
		if(oui == 0xFFFFF || oui == 0)
			continue;

		if((miiphy = malloc(sizeof(MiiPhy))) == nil)
			continue;
		miiphy-&gt;mii = mii;
		miiphy-&gt;oui = oui;
		miiphy-&gt;phyno = phyno;

		miiphy-&gt;anar = ~0;
		miiphy-&gt;fc = ~0;
		miiphy-&gt;mscr = ~0;

		mii-&gt;phy[phyno] = miiphy;
		if(ctlrno == 0 || hackflavour != Hackdual &amp;&amp; mii-&gt;curphy == nil)
			mii-&gt;curphy = miiphy;
		mii-&gt;mask |= bit;
		mii-&gt;nphy++;

		rmask |= bit;
	}
	return rmask;
}

static int
kirkwoodmii(Ether *ether)
{
	int i;
	Ctlr *ctlr;
	MiiPhy *phy;

	MIIDBG("mii\n");
	ctlr = ether-&gt;ctlr;
	if((ctlr-&gt;mii = malloc(sizeof(Mii))) == nil)
		return -1;
	ctlr-&gt;mii-&gt;ctlr = ctlr;
	ctlr-&gt;mii-&gt;mir = miird;
	ctlr-&gt;mii-&gt;miw = miiwr;

	if(mymii(ctlr-&gt;mii, ~0) == 0 || (phy = ctlr-&gt;mii-&gt;curphy) == nil){
		print("#l%d: ether1116: init mii failure\n", ether-&gt;ctlrno);
		free(ctlr-&gt;mii);
		ctlr-&gt;mii = nil;
		return -1;
	}

	/* oui 005043 is marvell */
	MIIDBG("oui %#X phyno %d\n", phy-&gt;oui, phy-&gt;phyno);
	// TODO: does this make sense? shouldn't each phy be initialised?
	if((ctlr-&gt;ether-&gt;ctlrno == 0 || hackflavour != Hackdual) &amp;&amp;
	    miistatus(ctlr-&gt;mii) &lt; 0){
		miireset(ctlr-&gt;mii);
		MIIDBG("miireset\n");
		if(miiane(ctlr-&gt;mii, ~0, 0, ~0) &lt; 0){
			iprint("miiane failed\n");
			return -1;
		}
		MIIDBG("miistatus\n");
		miistatus(ctlr-&gt;mii);
		if(miird(ctlr-&gt;mii, phy-&gt;phyno, Bmsr) &amp; BmsrLs){
			for(i = 0; ; i++){
				if(i &gt; 600){
					iprint("ether1116: autonegotiation failed\n");
					break;
				}
				if(miird(ctlr-&gt;mii, phy-&gt;phyno, Bmsr) &amp; BmsrAnc)
					break;
				delay(10);
			}
			if(miistatus(ctlr-&gt;mii) &lt; 0)
				iprint("miistatus failed\n");
		}else{
			iprint("ether1116: no link\n");
			phy-&gt;speed = 10;	/* simple default */
		}
	}

	ether-&gt;mbps = phy-&gt;speed;
	MIIDBG("#l%d: kirkwoodmii: fd %d speed %d tfc %d rfc %d\n",
		ctlr-&gt;port, phy-&gt;fd, phy-&gt;speed, phy-&gt;tfc, phy-&gt;rfc);
	MIIDBG("mii done\n");
	return 0;
}

enum {						/* PHY register pages */
	Pagcopper,
	Pagfiber,
	Pagrgmii,
	Pagled,
	Pagrsvd1,
	Pagvct,
	Pagtest,
	Pagrsvd2,
	Pagfactest,
};

static void
miiregpage(Mii *mii, ulong dev, ulong page)
{
	miiwr(mii, dev, Eadr, page);
}

static int
miiphyinit(Mii *mii)
{
	ulong dev;
	Ctlr *ctlr;
	Gbereg *reg;

	ctlr = (Ctlr*)mii-&gt;ctlr;
	reg = ctlr-&gt;reg;
	dev = reg-&gt;phy;
	MIIDBG("phy dev addr %lux\n", dev);

	/* leds link &amp; activity */
	miiregpage(mii, dev, Pagled);
	/* low 4 bits == 1: on - link, blink - activity, off - no link */
	miiwr(mii, dev, Scr, (miird(mii, dev, Scr) &amp; ~0xf) | 1);

	miiregpage(mii, dev, Pagrgmii);
	miiwr(mii, dev, Scr, miird(mii, dev, Scr) | Rgmiipwrup);
	/* must now do a software reset, says the manual */
	miireset(ctlr-&gt;mii);

	/* enable RGMII delay on Tx and Rx for CPU port */
	miiwr(mii, dev, Recr, miird(mii, dev, Recr) | Rxtiming | Rxtiming);
	/* must now do a software reset, says the manual */
	miireset(ctlr-&gt;mii);

	miiregpage(mii, dev, Pagcopper);
	miiwr(mii, dev, Scr,
		(miird(mii, dev, Scr) &amp; ~(Pwrdown|Endetect)) | Mdix);

	return 0;
}

/*
 * initialisation
 */

static void
quiesce(Gbereg *reg)
{
	ulong v;

	v = reg-&gt;tqc;
	if (v &amp; 0xFF)
		reg-&gt;tqc = v &lt;&lt; 8;		/* stop active channels */
	v = reg-&gt;rqc;
	if (v &amp; 0xFF)
		reg-&gt;rqc = v &lt;&lt; 8;		/* stop active channels */
	/* wait for all queues to stop */
	while (reg-&gt;tqc &amp; 0xFF || reg-&gt;rqc &amp; 0xFF)
		;
}

static void
p16(uchar *p, ulong v)		/* convert big-endian short to bytes */
{
	*p++ = v&gt;&gt;8;
	*p   = v;
}

static void
p32(uchar *p, ulong v)		/* convert big-endian long to bytes */
{
	*p++ = v&gt;&gt;24;
	*p++ = v&gt;&gt;16;
	*p++ = v&gt;&gt;8;
	*p   = v;
}

/*
 * set ether-&gt;ea from hw mac address,
 * configure unicast filtering to accept it.
 */
void
archetheraddr(Ether *ether, Gbereg *reg, int rxqno)
{
	uchar *ea;
	ulong nibble, ucreg, tbloff, regoff;

	ea = ether-&gt;ea;
	p32(ea,   reg-&gt;macah);
	p16(ea+4, reg-&gt;macal);
	if (memcmp(ea, zeroea, sizeof zeroea) == 0 &amp;&amp; ether-&gt;ctlrno &gt; 0) {
		/* hack: use ctlr[0]'s + ctlrno */
		memmove(ea, ctlrs[0]-&gt;ether-&gt;ea, Eaddrlen);
		ea[Eaddrlen-1] += ether-&gt;ctlrno;
		reg-&gt;macah = ea[0] &lt;&lt; 24 | ea[1] &lt;&lt; 16 | ea[2] &lt;&lt; 8 | ea[3];
		reg-&gt;macal = ea[4] &lt;&lt;  8 | ea[5];
		coherence();
	}

	/* accept frames on ea */
	nibble = ea[5] &amp; 0xf;
	tbloff = nibble / 4;
	regoff = nibble % 4;

	regoff *= 8;
	ucreg = reg-&gt;dfut[tbloff] &amp; (0xff &lt;&lt; regoff);
	ucreg |= (rxqno &lt;&lt; 1 | Pass) &lt;&lt; regoff;
	reg-&gt;dfut[tbloff] = ucreg;

	/* accept all multicast too.  set up special &amp; other tables. */
	memset(reg-&gt;dfsmt, Qno&lt;&lt;1 | Pass, sizeof reg-&gt;dfsmt);
	memset(reg-&gt;dfomt, Qno&lt;&lt;1 | Pass, sizeof reg-&gt;dfomt);
	coherence();
}

static void
cfgdramacc(Gbereg *reg)
{
	memset(reg-&gt;harr, 0, sizeof reg-&gt;harr);
	memset(reg-&gt;base, 0, sizeof reg-&gt;base);

	reg-&gt;bare = MASK(6) - MASK(2);	/* disable wins 2-5 */
	/* this doesn't make any sense, but it's required */
	reg-&gt;epap = 3 &lt;&lt; 2 | 3;		/* full access for wins 0 &amp; 1 */
//	reg-&gt;epap = 0;		/* no access on access violation for all wins */
	coherence();

	reg-&gt;base[0].base = PHYSDRAM | WINATTR(Attrcs0) | Targdram;
	reg-&gt;base[0].size = WINSIZE(256*MB);
	reg-&gt;base[1].base = (PHYSDRAM + 256*MB) | WINATTR(Attrcs1) | Targdram;
	reg-&gt;base[1].size = WINSIZE(256*MB);
	coherence();
}

static void
ctlralloc(Ctlr *ctlr)
{
	int i;
	Block *b;
	Rx *r;
	Tx *t;

	ilock(&amp;freeblocks);
	for(i = 0; i &lt; Nrxblks; i++) {
		b = iallocb(Rxblklen+Bufalign-1);
		if(b == nil) {
			iprint("ether1116: no memory for rx buffers\n");
			break;
		}
		assert(b-&gt;ref == 1);
		b-&gt;wp = b-&gt;rp = (uchar*)
			((uintptr)(b-&gt;lim - Rxblklen) &amp; ~(Bufalign - 1));
		assert(((uintptr)b-&gt;rp &amp; (Bufalign - 1)) == 0);
		b-&gt;free = rxfreeb;
		b-&gt;next = freeblocks.head;
		freeblocks.head = b;
	}
	iunlock(&amp;freeblocks);

	/*
	 * allocate uncached rx ring descriptors because rings are shared
	 * with the ethernet controller and more than one fits in a cache line.
	 */
	ctlr-&gt;rx = ucallocalign(Nrx * sizeof(Rx), Descralign, 0);
	if(ctlr-&gt;rx == nil)
		panic("ether1116: no memory for rx ring");
	for(i = 0; i &lt; Nrx; i++) {
		r = &amp;ctlr-&gt;rx[i];
		assert(((uintptr)r &amp; (Descralign - 1)) == 0);
		r-&gt;cs = 0;	/* owned by software until r-&gt;buf is non-nil */
		r-&gt;buf = 0;
		r-&gt;next = PADDR(&amp;ctlr-&gt;rx[NEXT(i, Nrx)]);
		ctlr-&gt;rxb[i] = nil;
	}
	ctlr-&gt;rxtail = ctlr-&gt;rxhead = 0;
	rxreplenish(ctlr);

	/* allocate uncached tx ring descriptors */
	ctlr-&gt;tx = ucallocalign(Ntx * sizeof(Tx), Descralign, 0);
	if(ctlr-&gt;tx == nil)
		panic("ether1116: no memory for tx ring");
	for(i = 0; i &lt; Ntx; i++) {
		t = &amp;ctlr-&gt;tx[i];
		assert(((uintptr)t &amp; (Descralign - 1)) == 0);
		t-&gt;cs = 0;
		t-&gt;buf = 0;
		t-&gt;next = PADDR(&amp;ctlr-&gt;tx[NEXT(i, Ntx)]);
		ctlr-&gt;txb[i] = nil;
	}
	ctlr-&gt;txtail = ctlr-&gt;txhead = 0;
}

static void
ctlrinit(Ether *ether)
{
	int i;
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;
	static char name[KNAMELEN];
	static Ctlr fakectlr;		/* bigger than 4K; keep off the stack */

	for (i = 0; i &lt; nelem(reg-&gt;tcqdp); i++)
		reg-&gt;tcqdp[i] = 0;
	for (i = 0; i &lt; nelem(reg-&gt;crdp); i++)
		reg-&gt;crdp[i].r = 0;
	coherence();

	cfgdramacc(reg);
	ctlralloc(ctlr);

	reg-&gt;tcqdp[Qno]  = PADDR(&amp;ctlr-&gt;tx[ctlr-&gt;txhead]);
	reg-&gt;crdp[Qno].r = PADDR(&amp;ctlr-&gt;rx[ctlr-&gt;rxhead]);
	coherence();

//	dumprxdescs(ctlr);

	/* clear stats by reading them into fake ctlr */
	getmibstats(&amp;fakectlr);

	reg-&gt;pxmfs = MFS40by;			/* allow runts in */

	/*
	 * ipg's (inter packet gaps) for interrupt coalescing,
	 * values in units of 64 clock cycles.  A full-sized
	 * packet (1514 bytes) takes just over 12µs to transmit.
	 */
	if (CLOCKFREQ/(Maxrxintrsec*64) &gt;= (1&lt;&lt;16))
		panic("rx coalescing value %d too big for short",
			CLOCKFREQ/(Maxrxintrsec*64));
	reg-&gt;sdc = SDCrifb | SDCrxburst(Burst16) | SDCtxburst(Burst16) |
		SDCrxnobyteswap | SDCtxnobyteswap |
		SDCipgintrx(CLOCKFREQ/(Maxrxintrsec*64));
	reg-&gt;pxtfut = 0;	/* TFUTipginttx(CLOCKFREQ/(Maxrxintrsec*64)) */

	/* allow just these interrupts */
	/* guruplug generates Irxerr interrupts continually */
	reg-&gt;irqmask = Isum | Irx | Irxbufferq(Qno) | Irxerr | Itxendq(Qno);
	reg-&gt;irqemask = IEsum | IEtxerrq(Qno) | IEphystschg | IErxoverrun |
		IEtxunderrun;

	reg-&gt;irqe = 0;
	reg-&gt;euirqmask = 0;
	coherence();
	reg-&gt;irq = 0;
	reg-&gt;euirq = 0;
	/* send errors to end of memory */
//	reg-&gt;euda = PHYSDRAM + 512*MB - 8*1024;
	reg-&gt;euda = 0;
	reg-&gt;eudid = Attrcs1 &lt;&lt; 4 | Targdram;

//	archetheraddr(ether, ctlr-&gt;reg, Qno);	/* 2nd location */

	reg-&gt;portcfg = Rxqdefault(Qno) | Rxqarp(Qno);
	reg-&gt;portcfgx = 0;
	coherence();

	/*
	 * start the controller running.
	 * turn the port on, kick the receiver.
	 */

	reg-&gt;psc1 = PSC1rgmii | PSC1encolonbp | PSC1coldomlim(0x23);
	/* do this only when the controller is quiescent */
	reg-&gt;psc0 = PSC0porton | PSC0an_flctloff |
		PSC0an_pauseadv | PSC0nofrclinkdown | PSC0mru(PSC0mru1522);
	coherence();
	for (i = 0; i &lt; 4000; i++)		/* magic delay */
		;

	ether-&gt;link = (reg-&gt;ps0 &amp; PS0linkup) != 0;

	/* set ethernet MTU for leaky bucket mechanism to 0 (disabled) */
	reg-&gt;pmtu = 0;
	etheractive(ether);

	snprint(name, sizeof name, "#l%drproc", ether-&gt;ctlrno);
	kproc(name, rcvproc, ether);

	reg-&gt;rqc = Rxqon(Qno);
	coherence();
}

static void
attach(Ether* ether)
{
	Ctlr *ctlr = ether-&gt;ctlr;

	lock(&amp;ctlr-&gt;initlock);
	if(ctlr-&gt;init == 0) {
		ctlrinit(ether);
		ctlr-&gt;init = 1;
	}
	unlock(&amp;ctlr-&gt;initlock);
}

/*
 * statistics goo.
 * mib registers clear on read.
 */

static void
getmibstats(Ctlr *ctlr)
{
	Gbereg *reg = ctlr-&gt;reg;

	/*
	 * Marvell 88f6281 errata FE-ETH-120: high long of rxby and txby
	 * can't be read correctly, so read the low long frequently
	 * (every 30 seconds or less), thus avoiding overflow into high long.
	 */
	ctlr-&gt;rxby	+= reg-&gt;rxbylo;
	ctlr-&gt;txby	+= reg-&gt;txbylo;

	ctlr-&gt;badrxby	+= reg-&gt;badrxby;
	ctlr-&gt;mactxerr	+= reg-&gt;mactxerr;
	ctlr-&gt;rxpkt	+= reg-&gt;rxpkt;
	ctlr-&gt;badrxpkt	+= reg-&gt;badrxpkt;
	ctlr-&gt;rxbcastpkt+= reg-&gt;rxbcastpkt;
	ctlr-&gt;rxmcastpkt+= reg-&gt;rxmcastpkt;
	ctlr-&gt;rx64	+= reg-&gt;rx64;
	ctlr-&gt;rx65_127	+= reg-&gt;rx65_127;
	ctlr-&gt;rx128_255	+= reg-&gt;rx128_255;
	ctlr-&gt;rx256_511	+= reg-&gt;rx256_511;
	ctlr-&gt;rx512_1023+= reg-&gt;rx512_1023;
	ctlr-&gt;rx1024_max+= reg-&gt;rx1024_max;
	ctlr-&gt;txpkt	+= reg-&gt;txpkt;
	ctlr-&gt;txcollpktdrop+= reg-&gt;txcollpktdrop;
	ctlr-&gt;txmcastpkt+= reg-&gt;txmcastpkt;
	ctlr-&gt;txbcastpkt+= reg-&gt;txbcastpkt;
	ctlr-&gt;badmacctlpkts+= reg-&gt;badmacctlpkts;
	ctlr-&gt;txflctl	+= reg-&gt;txflctl;
	ctlr-&gt;rxflctl	+= reg-&gt;rxflctl;
	ctlr-&gt;badrxflctl+= reg-&gt;badrxflctl;
	ctlr-&gt;rxundersized+= reg-&gt;rxundersized;
	ctlr-&gt;rxfrags	+= reg-&gt;rxfrags;
	ctlr-&gt;rxtoobig	+= reg-&gt;rxtoobig;
	ctlr-&gt;rxjabber	+= reg-&gt;rxjabber;
	ctlr-&gt;rxerr	+= reg-&gt;rxerr;
	ctlr-&gt;crcerr	+= reg-&gt;crcerr;
	ctlr-&gt;collisions+= reg-&gt;collisions;
	ctlr-&gt;latecoll	+= reg-&gt;latecoll;
}

long
ifstat(Ether *ether, void *a, long n, ulong off)
{
	Ctlr *ctlr = ether-&gt;ctlr;
	Gbereg *reg = ctlr-&gt;reg;
	char *buf, *p, *e;

	buf = p = malloc(READSTR);
	if(p == nil)
		panic("ether1116 ifstat: no memory");
	e = p + READSTR;

	ilock(ctlr);
	getmibstats(ctlr);

	ctlr-&gt;intrs += ctlr-&gt;newintrs;
	p = seprint(p, e, "interrupts: %lud\n", ctlr-&gt;intrs);
	p = seprint(p, e, "new interrupts: %lud\n", ctlr-&gt;newintrs);
	ctlr-&gt;newintrs = 0;
	p = seprint(p, e, "tx underrun: %lud\n", ctlr-&gt;txunderrun);
	p = seprint(p, e, "tx ring full: %lud\n", ctlr-&gt;txringfull);

	ctlr-&gt;rxdiscard += reg-&gt;pxdfc;
	ctlr-&gt;rxoverrun += reg-&gt;pxofc;
	p = seprint(p, e, "rx discarded frames: %lud\n", ctlr-&gt;rxdiscard);
	p = seprint(p, e, "rx overrun frames: %lud\n", ctlr-&gt;rxoverrun);
	p = seprint(p, e, "no first+last flag: %lud\n", ctlr-&gt;nofirstlast);

	p = seprint(p, e, "duplex: %s\n", (reg-&gt;ps0 &amp; PS0fd)? "full": "half");
	p = seprint(p, e, "flow control: %s\n", (reg-&gt;ps0 &amp; PS0flctl)? "on": "off");
	/* p = seprint(p, e, "speed: %d mbps\n", ); */

	p = seprint(p, e, "received bytes: %llud\n", ctlr-&gt;rxby);
	p = seprint(p, e, "bad received bytes: %lud\n", ctlr-&gt;badrxby);
	p = seprint(p, e, "internal mac transmit errors: %lud\n", ctlr-&gt;mactxerr);
	p = seprint(p, e, "total received frames: %lud\n", ctlr-&gt;rxpkt);
	p = seprint(p, e, "received broadcast frames: %lud\n", ctlr-&gt;rxbcastpkt);
	p = seprint(p, e, "received multicast frames: %lud\n", ctlr-&gt;rxmcastpkt);
	p = seprint(p, e, "bad received frames: %lud\n", ctlr-&gt;badrxpkt);
	p = seprint(p, e, "received frames 0-64: %lud\n", ctlr-&gt;rx64);
	p = seprint(p, e, "received frames 65-127: %lud\n", ctlr-&gt;rx65_127);
	p = seprint(p, e, "received frames 128-255: %lud\n", ctlr-&gt;rx128_255);
	p = seprint(p, e, "received frames 256-511: %lud\n", ctlr-&gt;rx256_511);
	p = seprint(p, e, "received frames 512-1023: %lud\n", ctlr-&gt;rx512_1023);
	p = seprint(p, e, "received frames 1024-max: %lud\n", ctlr-&gt;rx1024_max);
	p = seprint(p, e, "transmitted bytes: %llud\n", ctlr-&gt;txby);
	p = seprint(p, e, "total transmitted frames: %lud\n", ctlr-&gt;txpkt);
	p = seprint(p, e, "transmitted broadcast frames: %lud\n", ctlr-&gt;txbcastpkt);
	p = seprint(p, e, "transmitted multicast frames: %lud\n", ctlr-&gt;txmcastpkt);
	p = seprint(p, e, "transmit frames dropped by collision: %lud\n", ctlr-&gt;txcollpktdrop);
	p = seprint(p, e, "misaligned buffers: %lud\n", ether-&gt;pktsmisaligned);

	p = seprint(p, e, "bad mac control frames: %lud\n", ctlr-&gt;badmacctlpkts);
	p = seprint(p, e, "transmitted flow control messages: %lud\n", ctlr-&gt;txflctl);
	p = seprint(p, e, "received flow control messages: %lud\n", ctlr-&gt;rxflctl);
	p = seprint(p, e, "bad received flow control messages: %lud\n", ctlr-&gt;badrxflctl);
	p = seprint(p, e, "received undersized packets: %lud\n", ctlr-&gt;rxundersized);
	p = seprint(p, e, "received fragments: %lud\n", ctlr-&gt;rxfrags);
	p = seprint(p, e, "received oversized packets: %lud\n", ctlr-&gt;rxtoobig);
	p = seprint(p, e, "received jabber packets: %lud\n", ctlr-&gt;rxjabber);
	p = seprint(p, e, "mac receive errors: %lud\n", ctlr-&gt;rxerr);
	p = seprint(p, e, "crc errors: %lud\n", ctlr-&gt;crcerr);
	p = seprint(p, e, "collisions: %lud\n", ctlr-&gt;collisions);
	p = seprint(p, e, "late collisions: %lud\n", ctlr-&gt;latecoll);
	USED(p);
	iunlock(ctlr);

	n = readstr(off, a, n, buf);
	free(buf);
	return n;
}


static int
reset(Ether *ether)
{
	Ctlr *ctlr;

	ether-&gt;ctlr = ctlr = malloc(sizeof *ctlr);
	if (ctlr == nil)
		panic("ether1116 reset: no memory");
	switch(ether-&gt;ctlrno) {
	case 0:
		ether-&gt;irq = IRQ0gbe0sum;
		break;
	case 1:
		ether-&gt;irq = IRQ0gbe1sum;
		break;
	default:
		panic("ether1116: bad ether ctlr #%d", ether-&gt;ctlrno);
	}
	ctlr-&gt;reg = (Gbereg*)soc.ether[ether-&gt;ctlrno];

	/* need this for guruplug, at least */
	*(ulong *)soc.iocfg |= 1 &lt;&lt; 7 | 1 &lt;&lt; 15;	/* io cfg 0: 1.8v gbe */
	coherence();

	ctlr-&gt;ether = ether;
	ctlrs[ether-&gt;ctlrno] = ctlr;

	shutdown(ether);
	/* ensure that both interfaces are set to RGMII before calling mii */
	((Gbereg*)soc.ether[0])-&gt;psc1 |= PSC1rgmii;
	((Gbereg*)soc.ether[1])-&gt;psc1 |= PSC1rgmii;
	coherence();

	/* Set phy address of the port */
	ctlr-&gt;port = ether-&gt;ctlrno;
	ctlr-&gt;reg-&gt;phy = ether-&gt;ctlrno;
	coherence();
	ether-&gt;port = (uintptr)ctlr-&gt;reg;

	if(kirkwoodmii(ether) &lt; 0){
		free(ctlr);
		ether-&gt;ctlr = nil;
		return -1;
	}
	miiphyinit(ctlr-&gt;mii);
	archetheraddr(ether, ctlr-&gt;reg, Qno);	/* original location */
	if (memcmp(ether-&gt;ea, zeroea, sizeof zeroea) == 0){
iprint("ether1116: reset: zero ether-&gt;ea\n");
		free(ctlr);
		ether-&gt;ctlr = nil;
		return -1;			/* no rj45 for this ether */
	}

	ether-&gt;attach = attach;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;ifstat = ifstat;
	ether-&gt;shutdown = shutdown;
	ether-&gt;ctl = ctl;

	ether-&gt;arg = ether;
	ether-&gt;promiscuous = promiscuous;
	ether-&gt;multicast = multicast;
	return 0;
}

void
ether1116link(void)
{
	addethercard("88e1116", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

