<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sheevaplug traps, exceptions, interrupts, system calls.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

#include "arm.h"

enum {
	Debug = 0,

	Ntimevec = 20,			/* # of time buckets for each intr */
	Nvecs = 256,
};

extern int notify(Ureg*);

extern int ldrexvalid;

typedef struct Vctl Vctl;
typedef struct Vctl {
	Vctl*	next;		/* handlers on this vector */
	char	*name;		/* of driver, xallocated */
	void	(*f)(Ureg*, void*);	/* handler to call */
	void*	a;		/* argument to call it with */
} Vctl;

static Lock vctllock;
static Vctl* vctl[32];

uvlong ninterrupt;
uvlong ninterruptticks;
ulong intrtimes[Nvecs][Ntimevec];

typedef struct Handler Handler;
struct Handler {
	void	(*r)(Ureg*, void*);
	void	*a;
	char	name[KNAMELEN];
};

static Handler irqlo[32];
static Handler irqhi[32];
static Handler irqbridge[32];
static Lock irqlock;
static int probing, trapped;

typedef struct Irq Irq;
struct Irq {
	ulong	*irq;
	ulong	*irqmask;
	Handler	*irqvec;
	int	nirqvec;
	char	*name;
};
/* irq and irqmask are filled in by trapinit */
static Irq irqs[] = {
[Irqlo]		{nil, nil, irqlo,	nelem(irqlo),	"lo"},
[Irqhi]		{nil, nil, irqhi,	nelem(irqhi),	"hi"},
[Irqbridge]	{nil, nil, irqbridge,	nelem(irqbridge), "bridge"},
};

/*
 *  keep histogram of interrupt service times
 */
void
intrtime(Mach*, int vno)
{
	ulong diff, x;

	if (m == nil)
		return;
	x = perfticks();
	diff = x - m-&gt;perf.intrts;
	m-&gt;perf.intrts = x;

	m-&gt;perf.inintr += diff;
	if(up == nil &amp;&amp; m-&gt;perf.inidle &gt; diff)
		m-&gt;perf.inidle -= diff;

	if (m-&gt;cpuhz == 0)			/* not set yet? */
		return;
	diff /= (m-&gt;cpuhz/1000000)*100;		/* quantum = 100µsec */
	if(diff &gt;= Ntimevec)
		diff = Ntimevec-1;
	assert(vno &gt;= 0 &amp;&amp; vno &lt; Nvecs);
	intrtimes[vno][diff]++;
}

void
intrfmtcounts(char *s, char *se)
{
	USED(s, se);
}

static void
dumpcounts(void)
{
}

void
intrclear(int sort, int v)
{
	*irqs[sort].irq = ~(1 &lt;&lt; v);
}

void
intrmask(int sort, int v)
{
	*irqs[sort].irqmask &amp;= ~(1 &lt;&lt; v);
}

void
intrunmask(int sort, int v)
{
	*irqs[sort].irqmask |= 1 &lt;&lt; v;
}

static void
maskallints(void)
{
	CpucsReg *cpu = (CpucsReg *)soc.cpu;
	IntrReg *intr;

	/* no fiq or ep in use */
	intr = (IntrReg *)soc.intr;
	intr-&gt;lo.irqmask = 0;
	intr-&gt;hi.irqmask = 0;
	cpu-&gt;irqmask = 0;
	coherence();
}

void
intrset(Handler *h, void (*f)(Ureg*, void*), void *a, char *name)
{
	if(h-&gt;r != nil) {
//		iprint("duplicate irq: %s (%#p)\n", h-&gt;name, h-&gt;r);
		return;
	}
	h-&gt;r = f;
	h-&gt;a = a;
	strncpy(h-&gt;name, name, KNAMELEN-1);
	h-&gt;name[KNAMELEN-1] = 0;
}

void
intrunset(Handler *h)
{
	h-&gt;r = nil;
	h-&gt;a = nil;
	h-&gt;name[0] = 0;
}

void
intrdel(Handler *h, void (*f)(Ureg*, void*), void *a, char *name)
{
	if(h-&gt;r != f || h-&gt;a != a || strcmp(h-&gt;name, name) != 0)
		return;
	intrunset(h);
}

void
intrenable(int sort, int v, void (*f)(Ureg*, void*), void *a, char *name)
{
//iprint("enabling intr %d vec %d for %s\n", sort, v, name);
	ilock(&amp;irqlock);
	intrset(&amp;irqs[sort].irqvec[v], f, a, name);
	intrunmask(sort, v);
	iunlock(&amp;irqlock);
}

void
intrdisable(int sort, int v, void (*f)(Ureg*, void*), void* a, char *name)
{
	ilock(&amp;irqlock);
	intrdel(&amp;irqs[sort].irqvec[v], f, a, name);
	intrmask(sort, v);
	iunlock(&amp;irqlock);
}

/*
 *  called by trap to handle interrupts
 */
static void
intrs(Ureg *ur, int sort)
{
	int i, s;
	ulong ibits;
	Handler *h;
	Irq irq;

	assert(sort &gt;= 0 &amp;&amp; sort &lt; nelem(irqs));
	irq = irqs[sort];
	ibits = *irq.irq;
	ibits &amp;= *irq.irqmask;

	for(i = 0; i &lt; irq.nirqvec &amp;&amp; ibits; i++)
		if(ibits &amp; (1&lt;&lt;i)){
			h = &amp;irq.irqvec[i];
			if(h-&gt;r != nil){
				h-&gt;r(ur, h-&gt;a);
				splhi();
				intrtime(m, sort*32 + i);
				if (sort == Irqbridge &amp;&amp; i == IRQcputimer0)
					m-&gt;inclockintr = 1;
				ibits &amp;= ~(1&lt;&lt;i);
			}
		}
	if(ibits != 0) {
		iprint("spurious irq%s interrupt: %8.8lux\n", irq.name, ibits);
		s = splfhi();
		*irq.irq &amp;= ibits;
		*irq.irqmask &amp;= ~ibits;
		splx(s);
	}
}

void
intrhi(Ureg *ureg, void*)
{
	intrs(ureg, Irqhi);
}

void
intrbridge(Ureg *ureg, void*)
{
	intrs(ureg, Irqbridge);
	intrclear(Irqlo, IRQ0bridge);
}

void
trapinit(void)
{
	int i;
	CpucsReg *cpu;
	IntrReg *intr;
	Vectorpage *page0 = (Vectorpage*)HVECTORS;

	intr = (IntrReg *)soc.intr;
	cpu = (CpucsReg *)soc.cpu;
	irqs[Irqlo].irq = &amp;intr-&gt;lo.irq;
	irqs[Irqlo].irqmask = &amp;intr-&gt;lo.irqmask;
	irqs[Irqhi].irq = &amp;intr-&gt;hi.irq;
	irqs[Irqhi].irqmask = &amp;intr-&gt;hi.irqmask;
	irqs[Irqbridge].irq = &amp;cpu-&gt;irq;
	irqs[Irqbridge].irqmask = &amp;cpu-&gt;irqmask;
	coherence();

	setr13(PsrMfiq, m-&gt;fiqstack + nelem(m-&gt;fiqstack));
	setr13(PsrMirq, m-&gt;irqstack + nelem(m-&gt;irqstack));
	setr13(PsrMabt, m-&gt;abtstack + nelem(m-&gt;abtstack));
	setr13(PsrMund, m-&gt;undstack + nelem(m-&gt;undstack));

	memmove(page0-&gt;vectors, vectors, sizeof page0-&gt;vectors);
	memmove(page0-&gt;vtable,  vtable,  sizeof page0-&gt;vtable);
	cacheuwbinv();
	l2cacheuwbinv();

	cpu-&gt;cpucfg &amp;= ~Cfgvecinithi;

	for(i = 0; i &lt; nelem(irqlo); i++)
		intrunset(&amp;irqlo[i]);
	for(i = 0; i &lt; nelem(irqhi); i++)
		intrunset(&amp;irqhi[i]);
	for(i = 0; i &lt; nelem(irqbridge); i++)
		intrunset(&amp;irqbridge[i]);

	/* disable all interrupts */
	intr-&gt;lo.fiqmask = intr-&gt;hi.fiqmask = 0;
	intr-&gt;lo.irqmask = intr-&gt;hi.irqmask = 0;
	intr-&gt;lo.epmask =  intr-&gt;hi.epmask = 0;
	cpu-&gt;irqmask = 0;
	coherence();

	/* clear interrupts */
	intr-&gt;lo.irq = intr-&gt;hi.irq = ~0;
	cpu-&gt;irq = ~0;
	coherence();

	intrenable(Irqlo, IRQ0hisum, intrhi, nil, "hi");
	intrenable(Irqlo, IRQ0bridge, intrbridge, nil, "bridge");

	/* enable watchdog &amp; access-error interrupts */
	cpu-&gt;irqmask |= 1 &lt;&lt; IRQcputimerwd | 1 &lt;&lt; IRQaccesserr;
	coherence();
}

static char *trapnames[PsrMask+1] = {
	[ PsrMusr ] "user mode",
	[ PsrMfiq ] "fiq interrupt",
	[ PsrMirq ] "irq interrupt",
	[ PsrMsvc ] "svc/swi exception",
	[ PsrMabt ] "prefetch abort/data abort",
	[ PsrMabt+1 ] "data abort",
	[ PsrMund ] "undefined instruction",
	[ PsrMsys ] "sys trap",
};

static char *
trapname(int psr)
{
	char *s;

	s = trapnames[psr &amp; PsrMask];
	if(s == nil)
		s = "unknown trap number in psr";
	return s;
}

/* this is quite helpful during mmu and cache debugging */
static void
ckfaultstuck(uintptr va)
{
	static int cnt, lastpid;
	static uintptr lastva;

	if (va == lastva &amp;&amp; up-&gt;pid == lastpid) {
		++cnt;
		if (cnt &gt;= 2)
			/* fault() isn't fixing the underlying cause */
			panic("fault: %d consecutive faults for va %#p",
				cnt+1, va);
	} else {
		cnt = 0;
		lastva = va;
		lastpid = up-&gt;pid;
	}
}

/*
 *  called by trap to handle access faults
 */
static void
faultarm(Ureg *ureg, uintptr va, int user, int read)
{
	int n, insyscall;
	char buf[ERRMAX];
	static int cnt, lastpid;
	static ulong lastva;

	if(up == nil) {
		dumpregs(ureg);
		panic("fault: nil up in faultarm, accessing %#p", va);
	}
	insyscall = up-&gt;insyscall;
	up-&gt;insyscall = 1;
	if (Debug)
		ckfaultstuck(va);

	n = fault(va, read);
	if(n &lt; 0){
		if(!user){
			dumpregs(ureg);
			panic("fault: kernel accessing %#p", va);
		}
		/* don't dump registers; programs suicide all the time */
		snprint(buf, sizeof buf, "sys: trap: fault %s va=%#p",
			read? "read": "write", va);
		postnote(up, 1, buf, NDebug);
	}
	up-&gt;insyscall = insyscall;
}

/*
 *  returns 1 if the instruction writes memory, 0 otherwise
 */
int
writetomem(ulong inst)
{
	/* swap always write memory */
	if((inst &amp; 0x0FC00000) == 0x01000000)
		return 1;

	/* loads and stores are distinguished by bit 20 */
	if(inst &amp; (1&lt;&lt;20))
		return 0;

	return 1;
}

void
trap(Ureg *ureg)
{
	int user, x, rv, rem;
	ulong inst;
	u32int fsr;
	uintptr va;
	char buf[ERRMAX];

	if(up != nil)
		rem = (char*)ureg - up-&gt;kstack;
	else
		rem = (char*)ureg - ((char*)m + sizeof(Mach));
	if(rem &lt; 256) {
		dumpstack();
		panic("trap %d bytes remaining, up %#p ureg %#p at pc %#lux",
			rem, up, ureg, ureg-&gt;pc);
	}

	user = (ureg-&gt;psr &amp; PsrMask) == PsrMusr;
	if(user){
		up-&gt;dbgreg = ureg;
		cycles(&amp;up-&gt;kentry);
	}

	if(ureg-&gt;type == PsrMabt+1)
		ureg-&gt;pc -= 8;
	else
		ureg-&gt;pc -= 4;

	m-&gt;inclockintr = 0;
	switch(ureg-&gt;type) {
	default:
		panic("unknown trap %ld", ureg-&gt;type);
		break;
	case PsrMirq:
		ldrexvalid = 0;
		// splflo();		/* allow fast interrupts */
		intrs(ureg, Irqlo);
		m-&gt;intr++;
		break;
	case PsrMabt:			/* prefetch fault */
		ldrexvalid = 0;
		faultarm(ureg, ureg-&gt;pc, user, 1);
		if(up-&gt;nnote == 0 &amp;&amp;
		   (*(u32int*)ureg-&gt;pc &amp; ~(0xF&lt;&lt;28)) == 0x01200070)
			postnote(up, 1, "sys: breakpoint", NDebug);
		break;
	case PsrMabt+1:			/* data fault */
		ldrexvalid = 0;
		va = farget();
		inst = *(ulong*)(ureg-&gt;pc);
		fsr = fsrget() &amp; 0xf;
		if (probing &amp;&amp; !user) {
			if (trapped++ &gt; 0)
				panic("trap: recursive probe %#lux", va);
			ureg-&gt;pc += 4;	/* continue at next instruction */
			break;
		}
		switch(fsr){
		case 0x0:
			panic("vector exception at %#lux", ureg-&gt;pc);
			break;
		case 0x1:
		case 0x3:
			if(user){
				snprint(buf, sizeof buf,
					"sys: alignment: pc %#lux va %#p\n",
					ureg-&gt;pc, va);
				postnote(up, 1, buf, NDebug);
			} else
				panic("kernel alignment: pc %#lux va %#p", ureg-&gt;pc, va);
			break;
		case 0x2:
			panic("terminal exception at %#lux", ureg-&gt;pc);
			break;
		case 0x4:
		case 0x6:
		case 0x8:
		case 0xa:
		case 0xc:
		case 0xe:
			panic("external abort %#ux pc %#lux addr %#px",
				fsr, ureg-&gt;pc, va);
			break;
		case 0x5:		/* translation fault, no section entry */
		case 0x7:		/* translation fault, no page entry */
			faultarm(ureg, va, user, !writetomem(inst));
			break;
		case 0x9:
		case 0xb:
			/* domain fault, accessing something we shouldn't */
			if(user){
				snprint(buf, sizeof buf,
					"sys: access violation: pc %#lux va %#p\n",
					ureg-&gt;pc, va);
				postnote(up, 1, buf, NDebug);
			} else
				panic("kernel access violation: pc %#lux va %#p",
					ureg-&gt;pc, va);
			break;
		case 0xd:
		case 0xf:
			/* permission error, copy on write or real permission error */
			faultarm(ureg, va, user, !writetomem(inst));
			break;
		}
		break;
	case PsrMund:	/* undefined instruction */
		if(user){
			if(seg(up, ureg-&gt;pc, 0) != nil &amp;&amp;
			   (*(u32int*)ureg-&gt;pc &amp; ~(0xF&lt;&lt;28)) == 0x01200070)
				postnote(up, 1, "sys: breakpoint", NDebug);
			else{
				/* look for floating point instructions to interpret */
				x = spllo();
				rv = fpiarm(ureg);
				splx(x);
				if(rv == 0){
					ldrexvalid = 0;
					snprint(buf, sizeof buf,
						"undefined instruction: pc %#lux",
						ureg-&gt;pc);
					postnote(up, 1, buf, NDebug);
				}
			}
		}else{
			iprint("undefined instruction: pc %#lux inst %#ux\n",
				ureg-&gt;pc, ((u32int*)ureg-&gt;pc)[-2]);
			panic("undefined instruction");
		}
		break;
	}
	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; m-&gt;inclockintr){
		ldrexvalid = 0;
		sched();
		splhi();
	}

	if(user){
		if(up-&gt;procctl || up-&gt;nnote)
			notify(ureg);
		kexit(ureg);
	}
}

int
isvalidaddr(void *v)
{
	return (uintptr)v &gt;= KZERO;
}

void
dumplongs(char *msg, ulong *v, int n)
{
	int i, l;

	l = 0;
	iprint("%s at %.8p: ", msg, v);
	for(i=0; i&lt;n; i++){
		if(l &gt;= 4){
			iprint("\n    %.8p: ", v);
			l = 0;
		}
		if(isvalidaddr(v)){
			iprint(" %.8lux", *v++);
			l++;
		}else{
			iprint(" invalid");
			break;
		}
	}
	iprint("\n");
}

static void
dumpstackwithureg(Ureg *ureg)
{
	uintptr l, i, v, estack;
	u32int *p;

	iprint("ktrace /kernel/path %#.8lux %#.8lux %#.8lux # pc, sp, link\n",
		ureg-&gt;pc, ureg-&gt;sp, ureg-&gt;r14);
	delay(2000);
	i = 0;
	if(up != nil &amp;&amp; (uintptr)&amp;l &lt;= (uintptr)up-&gt;kstack+KSTACK)
		estack = (uintptr)up-&gt;kstack+KSTACK;
	else if((uintptr)&amp;l &gt;= (uintptr)m-&gt;stack
	     &amp;&amp; (uintptr)&amp;l &lt;= (uintptr)m+MACHSIZE)
		estack = (uintptr)m+MACHSIZE;
	else{
		if(up != nil)
			iprint("&amp;up-&gt;kstack %#p &amp;l %#p\n", up-&gt;kstack, &amp;l);
		else
			iprint("&amp;m %#p &amp;l %#p\n", m, &amp;l);
		return;
	}
	for(l = (uintptr)&amp;l; l &lt; estack; l += sizeof(uintptr)){
		v = *(uintptr*)l;
		if(KTZERO &lt; v &amp;&amp; v &lt; (uintptr)etext &amp;&amp; !(v &amp; 3)){
			v -= sizeof(u32int);		/* back up an instr */
			p = (u32int*)v;
			if((*p &amp; 0x0f000000) == 0x0b000000){	/* BL instr? */
				iprint("%#8.8lux=%#8.8lux ", l, v);
				i++;
			}
		}
		if(i == 4){
			i = 0;
			iprint("\n");
		}
	}
	if(i)
		iprint("\n");
}

/*
 * Fill in enough of Ureg to get a stack trace, and call a function.
 * Used by debugging interface rdb.
 */
void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;

	ureg.pc = getcallerpc(&amp;fn);
	ureg.sp = PTR2UINT(&amp;fn);
	fn(&amp;ureg);
}

void
dumpstack(void)
{
	callwithureg(dumpstackwithureg);
}

void
dumpregs(Ureg* ureg)
{
	int s;

	if (ureg == nil) {
		iprint("trap: no user process\n");
		return;
	}
	s = splhi();
	iprint("trap: %s", trapname(ureg-&gt;type));
	if(ureg != nil &amp;&amp; (ureg-&gt;psr &amp; PsrMask) != PsrMsvc)
		iprint(" in %s", trapname(ureg-&gt;psr));
	iprint("\n");
	iprint("psr %8.8lux type %2.2lux pc %8.8lux link %8.8lux\n",
		ureg-&gt;psr, ureg-&gt;type, ureg-&gt;pc, ureg-&gt;link);
	iprint("R14 %8.8lux R13 %8.8lux R12 %8.8lux R11 %8.8lux R10 %8.8lux\n",
		ureg-&gt;r14, ureg-&gt;r13, ureg-&gt;r12, ureg-&gt;r11, ureg-&gt;r10);
	iprint("R9  %8.8lux R8  %8.8lux R7  %8.8lux R6  %8.8lux R5  %8.8lux\n",
		ureg-&gt;r9, ureg-&gt;r8, ureg-&gt;r7, ureg-&gt;r6, ureg-&gt;r5);
	iprint("R4  %8.8lux R3  %8.8lux R2  %8.8lux R1  %8.8lux R0  %8.8lux\n",
		ureg-&gt;r4, ureg-&gt;r3, ureg-&gt;r2, ureg-&gt;r1, ureg-&gt;r0);
	iprint("stack is at %#p\n", ureg);
	iprint("pc %#lux link %#lux\n", ureg-&gt;pc, ureg-&gt;link);

	if(up)
		iprint("user stack: %#p-%#p\n", up-&gt;kstack, up-&gt;kstack+KSTACK-4);
	else
		iprint("kernel stack: %8.8lux-%8.8lux\n",
			(ulong)(m+1), (ulong)m+BY2PG-4);
	dumplongs("stack", (ulong *)(ureg + 1), 16);
	delay(2000);
	dumpstack();
	splx(s);
}

void
idlehands(void)
{
	extern void _idlehands(void);

	_idlehands();
}

/* assumes that addr is already mapped suitable (e.g., by mmuidmap) */
vlong
probeaddr(uintptr addr)
{
	vlong v;
	static Lock fltlck;

	ilock(&amp;fltlck);
	trapped = 0;
	probing = 1;
	coherence();

	v = *(ulong *)addr;	/* this may cause a fault (okay under ilock) */
	USED(probing);
	coherence();

	probing = 0;
	coherence();
	if (trapped)
		v = -1;
	iunlock(&amp;fltlck);
	return v;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

