<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/uartkw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/uartkw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * marvell kirkwood uart (supposed to be a 16550)
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
// #include "../port/uart.h"

enum {
	UartFREQ =	0, // xxx

	IERrx		= 1&lt;&lt;0,
	IERtx		= 1&lt;&lt;1,

	IRRintrmask	= (1&lt;&lt;4)-1,
	IRRnointr	= 1,
	IRRthrempty	= 2,
	IRRrxdata	= 4,
	IRRrxstatus	= 6,
	IRRtimeout	= 12,

	IRRfifomask	= 3&lt;&lt;6,
	IRRfifoenable	= 3&lt;&lt;6,

	FCRenable	= 1&lt;&lt;0,
	FCRrxreset	= 1&lt;&lt;1,
	FCRtxreset	= 1&lt;&lt;2,
	/* reserved */
	FCRrxtriggermask	= 3&lt;&lt;6,
	FCRrxtrigger1	= 0&lt;&lt;6,
	FCRrxtrigger4	= 1&lt;&lt;6,
	FCRrxtrigger8	= 2&lt;&lt;6,
	FCRrxtrigger14	= 3&lt;&lt;6,

	LCRbpcmask	= 3&lt;&lt;0,
	LCRbpc5		= 0&lt;&lt;0,
	LCRbpc6		= 1&lt;&lt;0,
	LCRbpc7		= 2&lt;&lt;0,
	LCRbpc8		= 3&lt;&lt;0,
	LCRstop2b	= 1&lt;&lt;2,
	LCRparity	= 1&lt;&lt;3,
	LCRparityeven	= 1&lt;&lt;4,
	LCRbreak	= 1&lt;&lt;6,
	LCRdivlatch	= 1&lt;&lt;7,

	LSRrx		= 1&lt;&lt;0,
	LSRrunerr	= 1&lt;&lt;1,
	LSRparerr	= 1&lt;&lt;2,
	LSRframeerr	= 1&lt;&lt;3,
	LSRbi		= 1&lt;&lt;4,
	LSRthre		= 1&lt;&lt;5,
	LSRtxempty	= 1&lt;&lt;6,
	LSRfifoerr	= 1&lt;&lt;7,
};

extern PhysUart kwphysuart;

typedef struct UartReg UartReg;
struct UartReg
{
	union {
		ulong	thr;
		ulong	dll;
		ulong	rbr;
	};
	union {
		ulong	ier;
		ulong	dlh;
	};
	union {
		ulong	iir;
		ulong	fcr;
	};
	ulong	lcr;
	ulong	mcr;
	ulong	lsr;
	ulong	scr;
};

typedef struct Ctlr Ctlr;
struct Ctlr {
	UartReg*regs;
	int	irq;
	Lock;
};

static Ctlr kirkwoodctlr[] = {
{
	.regs   = nil,			/* filled in below */
	.irq    = IRQ1uart0, },
};

static Uart kirkwooduart[] = {
{
	.regs	= &amp;kirkwoodctlr[0],
	.name	= "eia0",
	.freq	= UartFREQ,
	.phys	= &amp;kwphysuart,
	.special= 0,
	.console= 1,
	.next	= nil, },
};

static void
kw_read(Uart *uart)
{
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;
	ulong lsr;
	char c;

	while ((lsr = regs-&gt;lsr) &amp; LSRrx) {
		if(lsr&amp;LSRrunerr)
			uart-&gt;oerr++;
		if(lsr&amp;LSRparerr)
			uart-&gt;perr++;
		if(lsr&amp;LSRframeerr)
			uart-&gt;ferr++;
		c = regs-&gt;rbr;
		if((lsr &amp; (LSRbi|LSRframeerr|LSRparerr)) == 0)
			uartrecv(uart, c);
	}
}

static void
kw_intr(Ureg*, void *arg)
{
	Uart *uart = arg;
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;
	ulong v;

	if(regs == 0) {
		kirkwoodctlr[0].regs = (UartReg *)soc.uart[0];
		regs = (UartReg *)soc.uart[0];		/* caution */
		coherence();
	}
	v = regs-&gt;iir;
	if(v &amp; IRRthrempty)
		uartkick(uart);
	if(v &amp; IRRrxdata)
		kw_read(uart);

	intrclear(Irqhi, ctlr-&gt;irq);
}

static Uart*
kw_pnp(void)
{
	kirkwoodctlr[0].regs = (UartReg *)soc.uart[0];
	coherence();
	return kirkwooduart;
}

static void
kw_enable(Uart* uart, int ie)
{
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;

	if(regs == 0) {
		kirkwoodctlr[0].regs = (UartReg *)soc.uart[0];
		regs = (UartReg *)soc.uart[0];		/* caution */
		coherence();
	}
	USED(ie);
	regs-&gt;fcr = FCRenable|FCRrxtrigger4;
	regs-&gt;ier = IERrx|IERtx;
	intrenable(Irqhi, ctlr-&gt;irq, kw_intr, uart, uart-&gt;name);

	(*uart-&gt;phys-&gt;dtr)(uart, 1);
	(*uart-&gt;phys-&gt;rts)(uart, 1);
}

static void
kw_disable(Uart* uart)
{
	Ctlr *ctlr = uart-&gt;regs;

	(*uart-&gt;phys-&gt;dtr)(uart, 0);
	(*uart-&gt;phys-&gt;rts)(uart, 0);
	(*uart-&gt;phys-&gt;fifo)(uart, 0);

	intrdisable(Irqhi, ctlr-&gt;irq, kw_intr, uart, uart-&gt;name);
}

static void
kw_kick(Uart* uart)
{
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;
	int i;

	if(uart-&gt;cts == 0 || uart-&gt;blocked)
		return;

	for(i = 0; i &lt; 16; i++) {
		if((regs-&gt;lsr &amp; LSRthre) == 0 ||
		    uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		regs-&gt;thr = *uart-&gt;op++;
	}
}

static void
kw_break(Uart* uart, int ms)
{
	USED(uart, ms);
}

static int
kw_baud(Uart* uart, int baud)
{
	USED(uart, baud);
	return 0;
}

static int
kw_bits(Uart* uart, int bits)
{
	USED(uart, bits);
	return 0;
}

static int
kw_stop(Uart* uart, int stop)
{
	USED(uart, stop);
	return 0;
}

static int
kw_parity(Uart* uart, int parity)
{
	USED(uart, parity);
	return 0;
}

static void
kw_modemctl(Uart* uart, int on)
{
	USED(uart, on);
}

static void
kw_rts(Uart* uart, int on)
{
	USED(uart, on);
}

static void
kw_dtr(Uart* uart, int on)
{
	USED(uart, on);
}

static long
kw_status(Uart* uart, void* buf, long n, long offset)
{
	USED(uart, buf, n, offset);
	return 0;
}

static void
kw_fifo(Uart* uart, int level)
{
	USED(uart, level);
}

static int
kw_getc(Uart *uart)
{
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;

	while((regs-&gt;lsr&amp;LSRrx) == 0)
		;
	return regs-&gt;rbr;
}

static void
kw_putc(Uart *uart, int c)
{
	Ctlr *ctlr = uart-&gt;regs;
	UartReg *regs = ctlr-&gt;regs;

	/* can be called from iprint, among many other places */
	if(regs == 0) {
		kirkwoodctlr[0].regs = (UartReg *)soc.uart[0];
		regs = (UartReg *)soc.uart[0];		/* caution */
		coherence();
	}
	while((regs-&gt;lsr&amp;LSRthre) == 0)
		;
	regs-&gt;thr = c;
	coherence();
}

PhysUart kwphysuart = {
	.name		= "kirkwood",
	.pnp		= kw_pnp,
	.enable		= kw_enable,
	.disable	= kw_disable,
	.kick		= kw_kick,
	.dobreak	= kw_break,
	.baud		= kw_baud,
	.bits		= kw_bits,
	.stop		= kw_stop,
	.parity		= kw_parity,
	.modemctl	= kw_modemctl,
	.rts		= kw_rts,
	.dtr		= kw_dtr,
	.status		= kw_status,
	.fifo		= kw_fifo,
	.getc		= kw_getc,
	.putc		= kw_putc,
};

void
uartkirkwoodconsole(void)
{
	Uart *uart;

	uart = &amp;kirkwooduart[0];
	(*uart-&gt;phys-&gt;enable)(uart, 0);
	uartctl(uart, "b115200 l8 pn s1 i1");
	uart-&gt;console = 1;
	consuart = uart;
//serialputs("uart0 kirkwood\n", strlen("uart0 kirkwood\n"));
}

void
serialputc(int c)
{
	int cnt, s;
	UartReg *regs = (UartReg *)soc.uart[0];

	s = splhi();
	cnt = m-&gt;cpuhz;
	if (cnt &lt;= 0)			/* cpuhz not set yet? */
		cnt = 1000000;
	while((regs-&gt;lsr &amp; LSRthre) == 0 &amp;&amp; --cnt &gt; 0)
		;
	regs-&gt;thr = c;
	coherence();
	delay(1);
	splx(s);
}

void
serialputs(char *p, int len)
{
	while(--len &gt;= 0) {
		if(*p == '\n')
			serialputc('\r');
		serialputc(*p++);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

