<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/kw/usbehcikw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/kw/usbehcikw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Kirkwood-specific code for
 * USB Enhanced Host Controller Interface (EHCI) driver
 * High speed USB 2.0.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"
#include	"../port/portusbehci.h"
#include	"usbehci.h"
//#include	"uncached.h"

#define WINTARG(ctl)	(((ctl) &gt;&gt; 4) &amp; 017)
#define WINATTR(ctl)	(((ctl) &gt;&gt; 8) &amp; 0377)
#define WIN64KSIZE(ctl)	(((ctl) &gt;&gt; 16) + 1)

#define SIZETO64KSIZE(size) ((size) / (64*1024) - 1)

enum {
	Debug = 0,
};

typedef struct Kwusb Kwusb;
typedef struct Kwusbtt Kwusbtt;
typedef struct Usbwin Usbwin;

/* kirkwood usb transaction translator registers? (undocumented) */
struct Kwusbtt {		/* at soc.ehci */
	ulong	id;
	ulong	hwgeneral;
	ulong	hwhost;
	ulong	hwdevice;
	ulong	hwtxbuf;
	ulong	hwrxbuf;
	ulong	hwtttxbuf;
	ulong	hwttrxbuf;
};

/* kirkwood usb bridge &amp; phy registers */
struct Kwusb {			/* at offset 0x300 from soc.ehci */
	ulong	bcs;		/* bridge ctl &amp; sts */
	uchar	_pad0[0x310-0x304];

	ulong	bic;		/* bridge intr. cause */
	ulong	bim;		/* bridge intr. mask */
	ulong	_pad1;
	ulong	bea;		/* bridge error addr. */
	struct Usbwin {
		ulong	ctl;	/* see Winenable in io.h */
		ulong	base;
		ulong	_pad2[2];
	} win[4];
	ulong	phycfg;		/* phy config. */
	uchar	_pad3[0x400-0x364];

	ulong	pwrctl;		/* power control */
	uchar	_pad4[0x410-0x404];
	ulong	phypll;		/* phy pll control */
	uchar	_pad5[0x420-0x414];
	ulong	phytxctl;	/* phy transmit control */
	uchar	_pad6[0x430-0x424];
	ulong	phyrxctl;	/* phy receive control */
	uchar	_pad7[0x440-0x434];
	ulong	phyivref;	/* phy ivref control */
};

static Ctlr* ctlrs[Nhcis];

static void
addrmapdump(void)
{
	int i;
	ulong ctl, targ, attr, size64k;
	Kwusb *map;
	Usbwin *win;

	if (!Debug)
		return;
	map = (Kwusb *)(soc.ehci + 0x300);
	for (i = 0; i &lt; nelem(map-&gt;win); i++) {
		win = &amp;map-&gt;win[i];
		ctl = win-&gt;ctl;
		if (ctl &amp; Winenable) {
			targ = WINTARG(ctl);
			attr = WINATTR(ctl);
			size64k = WIN64KSIZE(ctl);
			print("usbehci: address map window %d: "
				"targ %ld attr %#lux size %,ld addr %#lux\n",
				i, targ, attr, size64k * 64*1024, win-&gt;base);
		}
	}
}

/* assumes ctlr is ilocked */
static void
ctlrreset(Ctlr *ctlr)
{
	int i;
	Eopio *opio;

	opio = ctlr-&gt;opio;
	opio-&gt;cmd |= Chcreset;
	coherence();
	/* wait for it to come out of reset */
	for(i = 0; i &lt; 100 &amp;&amp; opio-&gt;cmd &amp; Chcreset; i++)
		delay(1);
	if(i &gt;= 100)
		print("ehci %#p controller reset timed out\n", ctlr-&gt;capio);
	/*
	 * Marvell errata FE-USB-340 workaround: 1 &lt;&lt; 4 magic:
	 * disable streaming.  Magic 3 (usb host mode) from the linux driver
	 * makes it work.  Ick.
	 */
	opio-&gt;usbmode |= 1 &lt;&lt; 4 | 3;
	coherence();
}

/*
 * configure window `win' as 256MB dram with attribute `attr' and
 * base address
 */
static void
setaddrwin(Kwusb *kw, int win, int attr, ulong base)
{
	kw-&gt;win[win].ctl = Winenable | Targdram &lt;&lt; 4 | attr &lt;&lt; 8 |
		SIZETO64KSIZE(256*MB) &lt;&lt; 16;
	kw-&gt;win[win].base = base;
}

static void
ehcireset(Ctlr *ctlr)
{
	int i, amp, txvdd;
	ulong v;
	Eopio *opio;
	Kwusb *kw;

	ilock(ctlr);
	dprint("ehci %#p reset\n", ctlr-&gt;capio);
	opio = ctlr-&gt;opio;

	kw = (Kwusb *)(soc.ehci + 0x300);
	kw-&gt;bic = 0;
	kw-&gt;bim = (1&lt;&lt;4) - 1;		/* enable all defined intrs */
	ctlrreset(ctlr);

	/*
	 * clear high 32 bits of address signals if it's 64 bits capable.
	 * This is probably not needed but it does not hurt and others do it.
	 */
	if((ctlr-&gt;capio-&gt;capparms &amp; C64) != 0){
		dprint("ehci: 64 bits\n");
		opio-&gt;seg = 0;
	}

	/* requesting more interrupts per µframe may miss interrupts */
	opio-&gt;cmd &amp;= ~Citcmask;
	opio-&gt;cmd |= 1 &lt;&lt; Citcshift;		/* max of 1 intr. per 125 µs */
	switch(opio-&gt;cmd &amp; Cflsmask){
	case Cfls1024:
		ctlr-&gt;nframes = 1024;
		break;
	case Cfls512:
		ctlr-&gt;nframes = 512;
		break;
	case Cfls256:
		ctlr-&gt;nframes = 256;
		break;
	default:
		panic("ehci: unknown fls %ld", opio-&gt;cmd &amp; Cflsmask);
	}
	dprint("ehci: %d frames\n", ctlr-&gt;nframes);

	/*
	 * set up the USB address map (bridge address decoding)
	 */
	for (i = 0; i &lt; nelem(kw-&gt;win); i++)
		kw-&gt;win[i].ctl = kw-&gt;win[i].base = 0;
	coherence();

	setaddrwin(kw, 0, Attrcs0, 0);
	setaddrwin(kw, 1, Attrcs1, 256*MB);
	coherence();

	if (Debug)
		if (kw-&gt;bcs &amp; (1 &lt;&lt; 4))
			print("usbehci: not swapping bytes\n");
		else
			print("usbehci: swapping bytes\n");
	addrmapdump();				/* verify sanity */

	kw-&gt;pwrctl |= 1 &lt;&lt; 0 | 1 &lt;&lt; 1;		/* Pu | PuPll */
	coherence();

	/*
	 * Marvell guideline GL-USB-160.
	 */
	kw-&gt;phypll |= 1 &lt;&lt; 21;		/* VCOCAL_START: PLL calibration */
	coherence();
	microdelay(100);
	kw-&gt;phypll &amp;= ~(1 &lt;&lt; 21);

	v = kw-&gt;phytxctl &amp; ~(017 &lt;&lt; 27 | 7);	/* REG_EXT_FS_RCALL &amp; AMP_2_0 */
	switch (m-&gt;socrev) {
	default:
		print("usbehci: bad 6281 soc rev %d\n", m-&gt;socrev);
		/* fall through */
	case Socreva0:
		amp = 4;
		txvdd = 1;
		break;
	case Socreva1:
		amp = 3;
		txvdd = 3;
		break;
	}
	/* REG_EXT_FS_RCALL_EN | REG_RCAL_START | AMP_2_0 */
	kw-&gt;phytxctl = v | 1 &lt;&lt; 26 | 1 &lt;&lt; 12 | amp;
	coherence();
	microdelay(100);
	kw-&gt;phytxctl &amp;= ~(1 &lt;&lt; 12);

	v = kw-&gt;phyrxctl &amp; ~(3 &lt;&lt; 2 | 017 &lt;&lt; 4); /* LPF_COEF_1_0 &amp; SQ_THRESH_3_0 */
	kw-&gt;phyrxctl = v | 1 &lt;&lt; 2 | 8 &lt;&lt; 4;

	v = kw-&gt;phyivref &amp; ~(3 &lt;&lt; 8);		/* TXVDD12 */
	kw-&gt;phyivref = v | txvdd &lt;&lt; 8;
	coherence();

	ehcirun(ctlr, 0);
	ctlrreset(ctlr);

	iunlock(ctlr);
}

static void
setdebug(Hci*, int d)
{
	ehcidebug = d;
}

static void
shutdown(Hci *hp)
{
	Ctlr *ctlr;
	Eopio *opio;

	ctlr = hp-&gt;aux;
	ilock(ctlr);
	ctlrreset(ctlr);

	delay(100);
	ehcirun(ctlr, 0);

	opio = ctlr-&gt;opio;
	opio-&gt;frbase = 0;
	coherence();
	iunlock(ctlr);
}

static void
findehcis(void)		/* actually just use fixed addresses on sheeva */
{
	int i;
	Ctlr *ctlr;
	static int already = 0;

	if(already)
		return;
	already = 1;

	ctlr = malloc(sizeof(Ctlr));
	if (ctlr == nil)
		panic("ehci: out of memory");
	/* the sheeva's usb 2.0 otg uses a superset of the ehci registers */
	ctlr-&gt;capio = (Ecapio *)(soc.ehci + 0x100);
	ctlr-&gt;opio  = (Eopio *) (soc.ehci + 0x140);
	dprint("usbehci: port %#p\n", ctlr-&gt;capio);

	for(i = 0; i &lt; Nhcis; i++)
		if(ctlrs[i] == nil){
			ctlrs[i] = ctlr;
			break;
		}
	if(i == Nhcis)
		print("ehci: bug: more than %d controllers\n", Nhcis);
}

static int
reset(Hci *hp)
{
	static Lock resetlck;
	int i;
	Ctlr *ctlr;
	Ecapio *capio;

	ilock(&amp;resetlck);
	findehcis();

	/*
	 * Any adapter matches if no hp-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	ctlr = nil;
	for(i = 0; i &lt; Nhcis &amp;&amp; ctlrs[i] != nil; i++){
		ctlr = ctlrs[i];
		if(ctlr-&gt;active == 0)
		if(hp-&gt;port == 0 || hp-&gt;port == (uintptr)ctlr-&gt;capio){
			ctlr-&gt;active = 1;
			break;
		}
	}
	iunlock(&amp;resetlck);
	if(ctlrs[i] == nil || i == Nhcis)
		return -1;

	hp-&gt;aux = ctlr;
	hp-&gt;port = (uintptr)ctlr-&gt;capio;
	hp-&gt;irq = IRQ0usb0;
	hp-&gt;tbdf = 0;

	capio = ctlr-&gt;capio;
	hp-&gt;nports = capio-&gt;parms &amp; Cnports;

	ddprint("echi: %s, ncc %lud npcc %lud\n",
		capio-&gt;parms &amp; 0x10000 ? "leds" : "no leds",
		(capio-&gt;parms &gt;&gt; 12) &amp; 0xf, (capio-&gt;parms &gt;&gt; 8) &amp; 0xf);
	ddprint("ehci: routing %s, %sport power ctl, %d ports\n",
		capio-&gt;parms &amp; 0x40 ? "explicit" : "automatic",
		capio-&gt;parms &amp; 0x10 ? "" : "no ", hp-&gt;nports);

	ehcireset(ctlr);
	ehcimeminit(ctlr);

	/*
	 * Linkage to the generic HCI driver.
	 */
	ehcilinkage(hp);
	hp-&gt;shutdown = shutdown;
	hp-&gt;debug = setdebug;
	return 0;
}

void
usbehcilink(void)
{
	addhcitype("ehci", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

