<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/mtx/devarch.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/mtx/devarch.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

typedef struct IOMap IOMap;
struct IOMap
{
	IOMap	*next;
	char	tag[13];
	ulong	start;
	ulong	end;
};

static struct
{
	Lock;
	IOMap	*m;
	IOMap	*free;
	IOMap	maps[32];		// some initial free maps

	QLock	ql;			// lock for reading map
} iomap;

enum {
	Qdir = 0,
	Qioalloc = 1,
	Qiob,
	Qiow,
	Qiol,
	Qbase,

	Qmax = 16,
};

typedef long Rdwrfn(Chan*, void*, long, vlong);

static Rdwrfn *readfn[Qmax];
static Rdwrfn *writefn[Qmax];

static Dirtab archdir[] = {
	".",	{ Qdir, 0, QTDIR },	0,	0555,
	"ioalloc",	{ Qioalloc, 0 },	0,	0444,
	"iob",		{ Qiob, 0 },		0,	0660,
	"iow",		{ Qiow, 0 },		0,	0660,
	"iol",		{ Qiol, 0 },		0,	0660,
};
Lock archwlock;	/* the lock is only for changing archdir */
int narchdir = Qbase;
int (*_pcmspecial)(char *, ISAConf *);
void (*_pcmspecialclose)(int);

/*
 * Add a file to the #P listing.  Once added, you can't delete it.
 * You can't add a file with the same name as one already there,
 * and you get a pointer to the Dirtab entry so you can do things
 * like change the Qid version.  Changing the Qid path is disallowed.
 */
Dirtab*
addarchfile(char *name, int perm, Rdwrfn *rdfn, Rdwrfn *wrfn)
{
	int i;
	Dirtab d;
	Dirtab *dp;

	memset(&amp;d, 0, sizeof d);
	strcpy(d.name, name);
	d.perm = perm;

	lock(&amp;archwlock);
	if(narchdir &gt;= Qmax){
		unlock(&amp;archwlock);
		return nil;
	}

	for(i=0; i&lt;narchdir; i++)
		if(strcmp(archdir[i].name, name) == 0){
			unlock(&amp;archwlock);
			return nil;
		}

	d.qid.path = narchdir;
	archdir[narchdir] = d;
	readfn[narchdir] = rdfn;
	writefn[narchdir] = wrfn;
	dp = &amp;archdir[narchdir++];
	unlock(&amp;archwlock);

	return dp;
}

void
ioinit(void)
{
	int i;

	for(i = 0; i &lt; nelem(iomap.maps)-1; i++)
		iomap.maps[i].next = &amp;iomap.maps[i+1];
	iomap.maps[i].next = nil;
	iomap.free = iomap.maps;

	// a dummy entry at 2^17
	ioalloc(0x20000, 1, 0, "dummy");
}

//
//	alloc some io port space and remember who it was
//	alloced to.  if port &lt; 0, find a free region.
//
int
ioalloc(int port, int size, int align, char *tag)
{
	IOMap *m, **l;
	int i;

	lock(&amp;iomap);
	if(port &lt; 0){
		// find a free port above 0x400 and below 0x1000
		port = 0x400;
		for(l = &amp;iomap.m; *l; l = &amp;(*l)-&gt;next){
			m = *l;
			i = m-&gt;start - port;
			if(i &gt; size)
				break;
			if(align &gt; 0)
				port = ((port+align-1)/align)*align;
			else
				port = m-&gt;end;
		}
		if(*l == nil){
			unlock(&amp;iomap);
			return -1;
		}
	} else {
		// see if the space clashes with previously allocated ports
		for(l = &amp;iomap.m; *l; l = &amp;(*l)-&gt;next){
			m = *l;
			if(m-&gt;end &lt;= port)
				continue;
			if(m-&gt;start &gt;= port+size)
				break;
			unlock(&amp;iomap);
			return -1;
		}
	}
	m = iomap.free;
	if(m == nil){
		print("ioalloc: out of maps");
		unlock(&amp;iomap);
		return port;
	}
	iomap.free = m-&gt;next;
	m-&gt;next = *l;
	m-&gt;start = port;
	m-&gt;end = port + size;
	strncpy(m-&gt;tag, tag, sizeof(m-&gt;tag));
	m-&gt;tag[sizeof(m-&gt;tag)-1] = 0;
	*l = m;

	archdir[0].qid.vers++;

	unlock(&amp;iomap);
	return m-&gt;start;
}

void
iofree(int port)
{
	IOMap *m, **l;

	lock(&amp;iomap);
	for(l = &amp;iomap.m; *l; l = &amp;(*l)-&gt;next){
		if((*l)-&gt;start == port){
			m = *l;
			*l = m-&gt;next;
			m-&gt;next = iomap.free;
			iomap.free = m;
			break;
		}
		if((*l)-&gt;start &gt; port)
			break;
	}
	archdir[0].qid.vers++;
	unlock(&amp;iomap);
}

int
iounused(int start, int end)
{
	IOMap *m;

	for(m = iomap.m; m; m = m-&gt;next){
		if(start &gt;= m-&gt;start &amp;&amp; start &lt; m-&gt;end
		|| start &lt;= m-&gt;start &amp;&amp; end &gt; m-&gt;start)
			return 0; 
	}
	return 1;
}

static void
checkport(int start, int end)
{
	/* standard vga regs are OK */
	if(start &gt;= 0x2b0 &amp;&amp; end &lt;= 0x2df+1)
		return;
	if(start &gt;= 0x3c0 &amp;&amp; end &lt;= 0x3da+1)
		return;

	if(iounused(start, end))
		return;
	error(Eperm);
}

static Chan*
archattach(char* spec)
{
	return devattach('P', spec);
}

Walkqid*
archwalk(Chan* c, Chan *nc, char** name, int nname)
{
	return devwalk(c, nc, name, nname, archdir, narchdir, devgen);
}

static int
archstat(Chan* c, uchar* dp, int n)
{
	return devstat(c, dp, n, archdir, narchdir, devgen);
}

static Chan*
archopen(Chan* c, int omode)
{
	return devopen(c, omode, archdir, nelem(archdir), devgen);
}

static void
archclose(Chan*)
{
}

enum
{
	Linelen= 31,
};

static long
archread(Chan *c, void *a, long n, vlong offset)
{
	char buf[Linelen+1], *p;
	int port;
	ushort *sp;
	ulong *lp;
	IOMap *m;
	Rdwrfn *fn;

	switch((ulong)c-&gt;qid.path){

	case Qdir:
		return devdirread(c, a, n, archdir, nelem(archdir), devgen);

	case Qiob:
		port = offset;
		checkport(offset, offset+n);
		for(p = a; port &lt; offset+n; port++)
			*p++ = inb(port);
		return n;

	case Qiow:
		if((n &amp; 0x01) || (offset &amp; 0x01))
			error(Ebadarg);
		checkport(offset, offset+n+1);
		n /= 2;
		sp = a;
		for(port = offset; port &lt; offset+n; port += 2)
			*sp++ = ins(port);
		return n*2;

	case Qiol:
		if((n &amp; 0x03) || (offset &amp; 0x03))
			error(Ebadarg);
		checkport(offset, offset+n+3);
		n /= 4;
		lp = a;
		for(port = offset; port &lt; offset+n; port += 4)
			*lp++ = inl(port);
		return n*4;

	case Qioalloc:
		break;

	default:
		if(c-&gt;qid.path &lt; narchdir &amp;&amp; (fn = readfn[c-&gt;qid.path]))
			return fn(c, a, n, offset);
		error(Eperm);
		break;
	}

	offset = offset/Linelen;
	n = n/Linelen;
	p = a;
	lock(&amp;iomap);
	for(m = iomap.m; n &gt; 0 &amp;&amp; m != nil; m = m-&gt;next){
		if(offset-- &gt; 0)
			continue;
		if(strcmp(m-&gt;tag, "dummy") == 0)
			break;
		sprint(buf, "%8lux %8lux %-12.12s\n", m-&gt;start, m-&gt;end-1, m-&gt;tag);
		memmove(p, buf, Linelen);
		p += Linelen;
		n--;
	}
	unlock(&amp;iomap);

	return p - (char*)a;
}

static long
archwrite(Chan *c, void *a, long n, vlong offset)
{
	char *p;
	int port;
	ushort *sp;
	ulong *lp;
	Rdwrfn *fn;

	switch((ulong)c-&gt;qid.path){

	case Qiob:
		p = a;
		checkport(offset, offset+n);
		for(port = offset; port &lt; offset+n; port++)
			outb(port, *p++);
		return n;

	case Qiow:
		if((n &amp; 01) || (offset &amp; 01))
			error(Ebadarg);
		checkport(offset, offset+n+1);
		n /= 2;
		sp = a;
		for(port = offset; port &lt; offset+n; port += 2)
			outs(port, *sp++);
		return n*2;

	case Qiol:
		if((n &amp; 0x03) || (offset &amp; 0x03))
			error(Ebadarg);
		checkport(offset, offset+n+3);
		n /= 4;
		lp = a;
		for(port = offset; port &lt; offset+n; port += 4)
			outl(port, *lp++);
		return n*4;

	default:
		if(c-&gt;qid.path &lt; narchdir &amp;&amp; (fn = writefn[c-&gt;qid.path]))
			return fn(c, a, n, offset);
		error(Eperm);
		break;
	}
	return 0;
}

Dev archdevtab = {
	'P',
	"arch",

	devreset,
	devinit,
	devshutdown,
	archattach,
	archwalk,
	archstat,
	archopen,
	devcreate,
	archclose,
	archread,
	devbread,
	archwrite,
	devbwrite,
	devremove,
	devwstat,
};

int
pcmspecial(char *idstr, ISAConf *isa)
{
	return (_pcmspecial  != nil)? _pcmspecial(idstr, isa): -1;
}

void
pcmspecialclose(int a)
{
	if (_pcmspecialclose != nil)
		_pcmspecialclose(a);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

