<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/mtx/devether.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/mtx/devether.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

static Ether *etherxx[MaxEther];

Chan*
etherattach(char* spec)
{
	ulong ctlrno;
	char *p;
	Chan *chan;

	ctlrno = 0;
	if(spec &amp;&amp; *spec){
		ctlrno = strtoul(spec, &amp;p, 0);
		if((ctlrno == 0 &amp;&amp; p == spec) || *p || (ctlrno &gt;= MaxEther))
			error(Ebadarg);
	}
	if(etherxx[ctlrno] == 0)
		error(Enodev);

	chan = devattach('l', spec);
	chan-&gt;dev = ctlrno;
	if(etherxx[ctlrno]-&gt;attach)
		etherxx[ctlrno]-&gt;attach(etherxx[ctlrno]);
	return chan;
}

static Walkqid*
etherwalk(Chan* chan, Chan* nchan, char** name, int nname)
{
	return netifwalk(etherxx[chan-&gt;dev], chan, nchan, name, nname);
}

static int
etherstat(Chan* chan, uchar* dp, int n)
{
	return netifstat(etherxx[chan-&gt;dev], chan, dp, n);
}

static Chan*
etheropen(Chan* chan, int omode)
{
	return netifopen(etherxx[chan-&gt;dev], chan, omode);
}

static void
ethercreate(Chan*, char*, int, ulong)
{
}

static void
etherclose(Chan* chan)
{
	netifclose(etherxx[chan-&gt;dev], chan);
}

static long
etherread(Chan* chan, void* buf, long n, vlong off)
{
	Ether *ether;
	ulong offset = off;

	ether = etherxx[chan-&gt;dev];
	if((chan-&gt;qid.type &amp; QTDIR) == 0 &amp;&amp; ether-&gt;ifstat){
		/*
		 * With some controllers it is necessary to reach
		 * into the chip to extract statistics.
		 */
		if(NETTYPE(chan-&gt;qid.path) == Nifstatqid)
			return ether-&gt;ifstat(ether, buf, n, offset);
		else if(NETTYPE(chan-&gt;qid.path) == Nstatqid)
			ether-&gt;ifstat(ether, buf, 0, offset);
	}

	return netifread(ether, chan, buf, n, offset);
}

static Block*
etherbread(Chan* chan, long n, ulong offset)
{
	return netifbread(etherxx[chan-&gt;dev], chan, n, offset);
}

static int
etherwstat(Chan* chan, uchar* dp, int n)
{
	return netifwstat(etherxx[chan-&gt;dev], chan, dp, n);
}

static void
etherrtrace(Netfile* f, Etherpkt* pkt, int len)
{
	int i, n;
	Block *bp;

	if(qwindow(f-&gt;in) &lt;= 0)
		return;
	if(len &gt; 58)
		n = 58;
	else
		n = len;
	bp = iallocb(64);
	if(bp == nil)
		return;
	memmove(bp-&gt;wp, pkt-&gt;d, n);
	i = TK2MS(MACHP(0)-&gt;ticks);
	bp-&gt;wp[58] = len&gt;&gt;8;
	bp-&gt;wp[59] = len;
	bp-&gt;wp[60] = i&gt;&gt;24;
	bp-&gt;wp[61] = i&gt;&gt;16;
	bp-&gt;wp[62] = i&gt;&gt;8;
	bp-&gt;wp[63] = i;
	bp-&gt;wp += 64;
	qpass(f-&gt;in, bp);
}

Block*
etheriq(Ether* ether, Block* bp, int fromwire)
{
	Etherpkt *pkt;
	ushort type;
	int len, multi, tome, fromme;
	Netfile **ep, *f, **fp, *fx;
	Block *xbp;

	ether-&gt;inpackets++;

	pkt = (Etherpkt*)bp-&gt;rp;
	len = BLEN(bp);
	type = (pkt-&gt;type[0]&lt;&lt;8)|pkt-&gt;type[1];
	fx = 0;
	ep = &amp;ether-&gt;f[Ntypes];

	multi = pkt-&gt;d[0] &amp; 1;
	/* check for valid multicast addresses */
	if(multi &amp;&amp; memcmp(pkt-&gt;d, ether-&gt;bcast, sizeof(pkt-&gt;d)) &amp;&amp; ether-&gt;prom == 0){
		if(!activemulti(ether, pkt-&gt;d, sizeof(pkt-&gt;d))){
			if(fromwire){
				freeb(bp);
				bp = 0;
			}
			return bp;
		}
	}

	/* is it for me? */
	tome = memcmp(pkt-&gt;d, ether-&gt;ea, sizeof(pkt-&gt;d)) == 0;
	fromme = memcmp(pkt-&gt;s, ether-&gt;ea, sizeof(pkt-&gt;s)) == 0;

	/*
	 * Multiplex the packet to all the connections which want it.
	 * If the packet is not to be used subsequently (fromwire != 0),
	 * attempt to simply pass it into one of the connections, thereby
	 * saving a copy of the data (usual case hopefully).
	 */
	for(fp = ether-&gt;f; fp &lt; ep; fp++){
		if(f = *fp)
		if(f-&gt;type == type || f-&gt;type &lt; 0)
		if(tome || multi || f-&gt;prom){
			/* Don't want to hear bridged packets */
			if(f-&gt;bridge &amp;&amp; !fromwire &amp;&amp; !fromme)
				continue;
			if(!f-&gt;headersonly){
				if(fromwire &amp;&amp; fx == 0)
					fx = f;
				else if(xbp = iallocb(len)){
					memmove(xbp-&gt;wp, pkt, len);
					xbp-&gt;wp += len;
					qpass(f-&gt;in, xbp);
				}
				else
					ether-&gt;soverflows++;
			}
			else
				etherrtrace(f, pkt, len);
		}
	}

	if(fx){
		if(qpass(fx-&gt;in, bp) &lt; 0)
			ether-&gt;soverflows++;
		return 0;
	}
	if(fromwire){
		freeb(bp);
		return 0;
	}

	return bp;
}

static int
etheroq(Ether* ether, Block* bp)
{
	int len, loopback, s;
	Etherpkt *pkt;

	ether-&gt;outpackets++;

	/*
	 * Check if the packet has to be placed back onto the input queue,
	 * i.e. if it's a loopback or broadcast packet or the interface is
	 * in promiscuous mode.
	 * If it's a loopback packet indicate to etheriq that the data isn't
	 * needed and return, etheriq will pass-on or free the block.
	 * To enable bridging to work, only packets that were originated
	 * by this interface are fed back.
	 */
	pkt = (Etherpkt*)bp-&gt;rp;
	len = BLEN(bp);
	loopback = memcmp(pkt-&gt;d, ether-&gt;ea, sizeof(pkt-&gt;d)) == 0;
	if(loopback || memcmp(pkt-&gt;d, ether-&gt;bcast, sizeof(pkt-&gt;d)) == 0 || ether-&gt;prom){
		s = splhi();
		etheriq(ether, bp, 0);
		splx(s);
	}

	if(!loopback){
		qbwrite(ether-&gt;oq, bp);
		ether-&gt;transmit(ether);
	} else
		freeb(bp);

	return len;
}

static long
etherwrite(Chan* chan, void* buf, long n, vlong)
{
	Ether *ether;
	Block *bp;
	int nn;

	ether = etherxx[chan-&gt;dev];
	if(NETTYPE(chan-&gt;qid.path) != Ndataqid) {
		nn = netifwrite(ether, chan, buf, n);
		if(nn &gt;= 0)
			return nn;

		if(n == sizeof("nonblocking")-1 &amp;&amp; strncmp((char*)buf, "nonblocking", n) == 0){
			qnoblock(ether-&gt;oq, 1);
			return n;
		}

		if(ether-&gt;ctl!=nil)
			return ether-&gt;ctl(ether,buf,n);
			
		error(Ebadctl);
	}

	if(n &gt; ether-&gt;maxmtu)
		error(Etoobig);
	if(n &lt; ether-&gt;minmtu)
		error(Etoosmall);

	bp = allocb(n);
	if(waserror()){
		freeb(bp);
		nexterror();
	}
	memmove(bp-&gt;rp, buf, n);
	memmove(bp-&gt;rp+Eaddrlen, ether-&gt;ea, Eaddrlen);
	poperror();
	bp-&gt;wp += n;

	return etheroq(ether, bp);
}

static long
etherbwrite(Chan* chan, Block* bp, ulong)
{
	Ether *ether;
	long n;

	n = BLEN(bp);
	if(NETTYPE(chan-&gt;qid.path) != Ndataqid){
		if(waserror()) {
			freeb(bp);
			nexterror();
		}
		n = etherwrite(chan, bp-&gt;rp, n, 0);
		poperror();
		freeb(bp);
		return n;
	}
	ether = etherxx[chan-&gt;dev];

	if(n &gt; ether-&gt;maxmtu){
		freeb(bp);
		error(Etoobig);
	}
	if(n &lt; ether-&gt;minmtu){
		freeb(bp);
		error(Etoosmall);
	}

	return etheroq(ether, bp);
}

static struct {
	char*	type;
	int	(*reset)(Ether*);
} cards[MaxEther+1];

void
addethercard(char* t, int (*r)(Ether*))
{
	static int ncard;

	if(ncard == MaxEther)
		panic("too many ether cards");
	cards[ncard].type = t;
	cards[ncard].reset = r;
	ncard++;
}

int
parseether(uchar *to, char *from)
{
	char nip[4];
	char *p;
	int i;

	p = from;
	for(i = 0; i &lt; 6; i++){
		if(*p == 0)
			return -1;
		nip[0] = *p++;
		if(*p == 0)
			return -1;
		nip[1] = *p++;
		nip[2] = 0;
		to[i] = strtoul(nip, 0, 16);
		if(*p == ':')
			p++;
	}
	return 0;
}

static void
etherreset(void)
{
	Ether *ether;
	int i, n, ctlrno;
	char name[32], buf[128];

	for(ether = 0, ctlrno = 0; ctlrno &lt; MaxEther; ctlrno++){
		if(ether == 0)
			ether = malloc(sizeof(Ether));
		memset(ether, 0, sizeof(Ether));
		ether-&gt;ctlrno = ctlrno;
		ether-&gt;tbdf = BUSUNKNOWN;
		ether-&gt;mbps = 10;
		ether-&gt;minmtu = ETHERMINTU;
		ether-&gt;maxmtu = ETHERMAXTU;
		if(isaconfig("ether", ctlrno, ether) == 0)
			continue;
		for(n = 0; cards[n].type; n++){
			if(cistrcmp(cards[n].type, ether-&gt;type))
				continue;
			for(i = 0; i &lt; ether-&gt;nopt; i++){
				if(strncmp(ether-&gt;opt[i], "ea=", 3))
					continue;
				if(parseether(ether-&gt;ea, &amp;ether-&gt;opt[i][3]) == -1)
					memset(ether-&gt;ea, 0, Eaddrlen);
			}	
			if(cards[n].reset(ether))
				break;

			/*
			 * IRQ2 doesn't really exist, it's used to gang the interrupt
			 * controllers together. A device set to IRQ2 will appear on
			 * the second interrupt controller as IRQ9.
			 */
			if(ether-&gt;irq == 2 &amp;&amp; BUSTYPE(ether-&gt;tbdf) != BusPCI)
				ether-&gt;irq = 9;
			snprint(name, sizeof(name), "ether%d", ctlrno);

			/*
			 * If ether-&gt;irq is &lt;0, it is a hack to indicate no interrupt
			 * used by ethersink.
			 */
			if(ether-&gt;irq &gt;= 0)
				intrenable(ether-&gt;irq, ether-&gt;interrupt, ether, ether-&gt;tbdf, name);

			i = sprint(buf, "#l%d: %s: %dMbps port 0x%luX irq %d",
				ctlrno, ether-&gt;type, ether-&gt;mbps, ether-&gt;port, ether-&gt;irq);
			if(ether-&gt;mem)
				i += sprint(buf+i, " addr 0x%luX", PADDR(ether-&gt;mem));
			if(ether-&gt;size)
				i += sprint(buf+i, " size 0x%luX", ether-&gt;size);
			i += sprint(buf+i, ": %2.2ux%2.2ux%2.2ux%2.2ux%2.2ux%2.2ux",
				ether-&gt;ea[0], ether-&gt;ea[1], ether-&gt;ea[2],
				ether-&gt;ea[3], ether-&gt;ea[4], ether-&gt;ea[5]);
			sprint(buf+i, "\n");
			print(buf);

			if(ether-&gt;mbps &gt;= 100){
				netifinit(ether, name, Ntypes, 256*1024);
				if(ether-&gt;oq == 0)
					ether-&gt;oq = qopen(256*1024, Qmsg, 0, 0);
			}
			else{
				netifinit(ether, name, Ntypes, 65*1024);
				if(ether-&gt;oq == 0)
					ether-&gt;oq = qopen(65*1024, Qmsg, 0, 0);
			}
			if(ether-&gt;oq == 0)
				panic("etherreset %s", name);
			ether-&gt;alen = Eaddrlen;
			memmove(ether-&gt;addr, ether-&gt;ea, Eaddrlen);
			memset(ether-&gt;bcast, 0xFF, Eaddrlen);

			etherxx[ctlrno] = ether;
			ether = 0;
			break;
		}
	}
	if(ether)
		free(ether);
}

#define POLY 0xedb88320

/* really slow 32 bit crc for ethers */
ulong
ethercrc(uchar *p, int len)
{
	int i, j;
	ulong crc, b;

	crc = 0xffffffff;
	for(i = 0; i &lt; len; i++){
		b = *p++;
		for(j = 0; j &lt; 8; j++){
			crc = (crc&gt;&gt;1) ^ (((crc^b) &amp; 1) ? POLY : 0);
			b &gt;&gt;= 1;
		}
	}
	return crc;
}

Dev etherdevtab = {
	'l',
	"ether",

	etherreset,
	devinit,
	devshutdown,
	etherattach,
	etherwalk,
	etherstat,
	etheropen,
	ethercreate,
	etherclose,
	etherread,
	etherbread,
	etherwrite,
	etherbwrite,
	devremove,
	etherwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

