<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/mtx/pci.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/mtx/pci.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * PCI support code.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define DBG	if(0) pcilog

struct
{
	char	output[16384];
	int	ptr;
}PCICONS;

int
pcilog(char *fmt, ...)
{
	int n;
	va_list arg;
	char buf[PRINTSIZE];

	va_start(arg, fmt);
	n = vseprint(buf, buf+sizeof(buf), fmt, arg) - buf;
	va_end(arg);

	memmove(PCICONS.output+PCICONS.ptr, buf, n);
	PCICONS.ptr += n;
	return n;
}

enum
{					/* configuration mechanism #1 */
	PciADDR		= 0xCF8,	/* CONFIG_ADDRESS */
	PciDATA		= 0xCFC,	/* CONFIG_DATA */

					/* configuration mechanism #2 */
	PciCSE		= 0xCF8,	/* configuration space enable */
	PciFORWARD	= 0xCFA,	/* which bus */

	MaxFNO		= 7,
	MaxUBN		= 255,
};

enum
{					/* command register */
	IOen		= (1&lt;&lt;0),
	MEMen		= (1&lt;&lt;1),
	MASen		= (1&lt;&lt;2),
	MemWrInv	= (1&lt;&lt;4),
	PErrEn		= (1&lt;&lt;6),
	SErrEn		= (1&lt;&lt;8),
};

static Lock pcicfglock;
static QLock pcicfginitlock;
static int pcicfgmode = -1;
static int pcimaxbno = 7;
static int pcimaxdno;
static Pcidev* pciroot;
static Pcidev* pcilist;
static Pcidev* pcitail;

static int pcicfgrw32(int, int, int, int);
static int pcicfgrw8(int, int, int, int);

static char* bustypes[] = {
	"CBUSI",
	"CBUSII",
	"EISA",
	"FUTURE",
	"INTERN",
	"ISA",
	"MBI",
	"MBII",
	"MCA",
	"MPI",
	"MPSA",
	"NUBUS",
	"PCI",
	"PCMCIA",
	"TC",
	"VL",
	"VME",
	"XPRESS",
};

#pragma	varargck	type	"T"	int

static int
tbdffmt(Fmt* fmt)
{
	char *p;
	int l, r, type, tbdf;

	if((p = malloc(READSTR)) == nil)
		return fmtstrcpy(fmt, "(tbdfconv)");
		
	switch(fmt-&gt;r){
	case 'T':
		tbdf = va_arg(fmt-&gt;args, int);
		type = BUSTYPE(tbdf);
		if(type &lt; nelem(bustypes))
			l = snprint(p, READSTR, bustypes[type]);
		else
			l = snprint(p, READSTR, "%d", type);
		snprint(p+l, READSTR-l, ".%d.%d.%d",
			BUSBNO(tbdf), BUSDNO(tbdf), BUSFNO(tbdf));
		break;

	default:
		snprint(p, READSTR, "(tbdfconv)");
		break;
	}
	r = fmtstrcpy(fmt, p);
	free(p);

	return r;
}

ulong
pcibarsize(Pcidev *p, int rno)
{
	ulong v, size;

	v = pcicfgrw32(p-&gt;tbdf, rno, 0, 1);
	pcicfgrw32(p-&gt;tbdf, rno, 0xFFFFFFF0, 0);
	size = pcicfgrw32(p-&gt;tbdf, rno, 0, 1);
	if(v &amp; 1)
		size |= 0xFFFF0000;
	pcicfgrw32(p-&gt;tbdf, rno, v, 0);

	return -(size &amp; ~0x0F);
}

static int
pcisizcmp(void *a, void *b)
{
	Pcisiz *aa, *bb;

	aa = a;
	bb = b;
	return aa-&gt;siz - bb-&gt;siz;
}

static ulong
pcimask(ulong v)
{
	ulong m;

	m = BI2BY*sizeof(v);
	for(m = 1&lt;&lt;(m-1); m != 0; m &gt;&gt;= 1) {
		if(m &amp; v)
			break;
	}

	m--;
	if((v &amp; m) == 0)
		return v;

	v |= m;
	return v+1;
}

static void
pcibusmap(Pcidev *root, ulong *pmema, ulong *pioa, int wrreg)
{
	Pcidev *p;
	int ntb, i, size, rno, hole;
	ulong v, mema, ioa, sioa, smema, base, limit;
	Pcisiz *table, *tptr, *mtb, *itb;
	extern void qsort(void*, long, long, int (*)(void*, void*));

	ioa = *pioa;
	mema = *pmema;

	DBG("pcibusmap wr=%d %T mem=%luX io=%luX\n", 
		wrreg, root-&gt;tbdf, mema, ioa);

	ntb = 0;
	for(p = root; p != nil; p = p-&gt;link)
		ntb++;

	ntb *= (PciCIS-PciBAR0)/4;
	table = malloc(2*ntb*sizeof(Pcisiz));
	itb = table;
	mtb = table+ntb;

	/*
	 * Build a table of sizes
	 */
	for(p = root; p != nil; p = p-&gt;link) {
		if(p-&gt;ccrb == 0x06) {
			if(p-&gt;ccru == 0x04 &amp;&amp; p-&gt;bridge != nil) {
				sioa = ioa;
				smema = mema;
				pcibusmap(p-&gt;bridge, &amp;smema, &amp;sioa, 0);
	
				hole = pcimask(smema-mema);
				if(hole &lt; (1&lt;&lt;20))
					hole = 1&lt;&lt;20;
				p-&gt;mema.size = hole;
	
				hole = pcimask(sioa-ioa);
				if(hole &lt; (1&lt;&lt;12))
					hole = 1&lt;&lt;12;
	
				p-&gt;ioa.size = hole;
	
				itb-&gt;dev = p;
				itb-&gt;bar = -1;
				itb-&gt;siz = p-&gt;ioa.size;
				itb++;
	
				mtb-&gt;dev = p;
				mtb-&gt;bar = -1;
				mtb-&gt;siz = p-&gt;mema.size;
				mtb++;
			}
			if((pcicfgr8(p, PciHDT)&amp;0x7f) != 0)
				continue;
		}

		for(i = 0; i &lt;= 5; i++) {
			rno = PciBAR0 + i*4;
			v = pcicfgrw32(p-&gt;tbdf, rno, 0, 1);
			size = pcibarsize(p, rno);
			if(size == 0)
				continue;

			if(v &amp; 1) {
				itb-&gt;dev = p;
				itb-&gt;bar = i;
				itb-&gt;siz = size;
				itb++;
			}
			else {
				mtb-&gt;dev = p;
				mtb-&gt;bar = i;
				mtb-&gt;siz = size;
				mtb++;
			}

			p-&gt;mem[i].size = size;
		}
	}

	/*
	 * Sort both tables IO smallest first, Memory largest
	 */
	qsort(table, itb-table, sizeof(Pcisiz), pcisizcmp);
	tptr = table+ntb;
	qsort(tptr, mtb-tptr, sizeof(Pcisiz), pcisizcmp);

	/*
	 * Allocate IO address space on this bus
	 */
	for(tptr = table; tptr &lt; itb; tptr++) {
		hole = tptr-&gt;siz;
		if(tptr-&gt;bar == -1)
			hole = 1&lt;&lt;12;
		ioa = (ioa+hole-1) &amp; ~(hole-1);

		p = tptr-&gt;dev;
		if(tptr-&gt;bar == -1)
			p-&gt;ioa.bar = ioa;
		else {
			p-&gt;pcr |= IOen;
			p-&gt;mem[tptr-&gt;bar].bar = ioa|1;
			if(wrreg)
				pcicfgrw32(p-&gt;tbdf, PciBAR0+(tptr-&gt;bar*4), ioa|1, 0);
		}

		ioa += tptr-&gt;siz;
	}

	/*
	 * Allocate Memory address space on this bus
	 */
	for(tptr = table+ntb; tptr &lt; mtb; tptr++) {
		hole = tptr-&gt;siz;
		if(tptr-&gt;bar == -1)
			hole = 1&lt;&lt;20;
		mema = (mema+hole-1) &amp; ~(hole-1);

		p = tptr-&gt;dev;
		if(tptr-&gt;bar == -1)
			p-&gt;mema.bar = mema;
		else {
			p-&gt;pcr |= MEMen;
			p-&gt;mem[tptr-&gt;bar].bar = mema;
			if(wrreg)
				pcicfgrw32(p-&gt;tbdf, PciBAR0+(tptr-&gt;bar*4), mema, 0);
		}
		mema += tptr-&gt;siz;
	}

	*pmema = mema;
	*pioa = ioa;
	free(table);

	if(wrreg == 0)
		return;

	/*
	 * Finally set all the bridge addresses &amp; registers
	 */
	for(p = root; p != nil; p = p-&gt;link) {
		if(p-&gt;bridge == nil) {
			pcicfgrw8(p-&gt;tbdf, PciLTR, 64, 0);

			p-&gt;pcr |= MASen;
			pcicfgrw32(p-&gt;tbdf, PciPCR, p-&gt;pcr, 0);
			continue;
		}

		base = p-&gt;ioa.bar;
		limit = base+p-&gt;ioa.size-1;
		v = pcicfgrw32(p-&gt;tbdf, PciIBR, 0, 1);
		v = (v&amp;0xFFFF0000)|(limit &amp; 0xF000)|((base &amp; 0xF000)&gt;&gt;8);
		pcicfgrw32(p-&gt;tbdf, PciIBR, v, 0);
		v = (limit &amp; 0xFFFF0000)|(base&gt;&gt;16);
		pcicfgrw32(p-&gt;tbdf, PciIUBR, v, 0);

		base = p-&gt;mema.bar;
		limit = base+p-&gt;mema.size-1;
		v = (limit &amp; 0xFFF00000)|((base &amp; 0xFFF00000)&gt;&gt;16);
		pcicfgrw32(p-&gt;tbdf, PciMBR, v, 0);

		/*
		 * Disable memory prefetch
		 */
		pcicfgrw32(p-&gt;tbdf, PciPMBR, 0x0000FFFF, 0);
		pcicfgrw8(p-&gt;tbdf, PciLTR, 64, 0);

		/*
		 * Enable the bridge
		 */
		v = 0xFFFF0000 | IOen | MEMen | MASen;
		pcicfgrw32(p-&gt;tbdf, PciPCR, v, 0);

		sioa = p-&gt;ioa.bar;
		smema = p-&gt;mema.bar;
		pcibusmap(p-&gt;bridge, &amp;smema, &amp;sioa, 1);
	}
}

static int
pcilscan(int bno, Pcidev** list)
{
	Pcidev *p, *head, *tail;
	int dno, fno, i, hdt, l, maxfno, maxubn, rno, sbn, tbdf, ubn;

	maxubn = bno;
	head = nil;
	tail = nil;
	for(dno = 0; dno &lt;= pcimaxdno; dno++){
		maxfno = 0;
		for(fno = 0; fno &lt;= maxfno; fno++){
			/*
			 * For this possible device, form the
			 * bus+device+function triplet needed to address it
			 * and try to read the vendor and device ID.
			 * If successful, allocate a device struct and
			 * start to fill it in with some useful information
			 * from the device's configuration space.
			 */
			tbdf = MKBUS(BusPCI, bno, dno, fno);
			l = pcicfgrw32(tbdf, PciVID, 0, 1);
			if(l == 0xFFFFFFFF || l == 0)
				continue;
			p = malloc(sizeof(*p));
			p-&gt;tbdf = tbdf;
			p-&gt;vid = l;
			p-&gt;did = l&gt;&gt;16;

			if(pcilist != nil)
				pcitail-&gt;list = p;
			else
				pcilist = p;
			pcitail = p;

			p-&gt;rid = pcicfgr8(p, PciRID);
			p-&gt;ccrp = pcicfgr8(p, PciCCRp);
			p-&gt;ccru = pcicfgr8(p, PciCCRu);
			p-&gt;ccrb = pcicfgr8(p, PciCCRb);
			p-&gt;pcr = pcicfgr32(p, PciPCR);

			p-&gt;intl = pcicfgr8(p, PciINTL);

			/*
			 * If the device is a multi-function device adjust the
			 * loop count so all possible functions are checked.
			 */
			hdt = pcicfgr8(p, PciHDT);
			if(hdt &amp; 0x80)
				maxfno = MaxFNO;

			/*
			 * If appropriate, read the base address registers
			 * and work out the sizes.
			 */
			switch(p-&gt;ccrb) {
			case 0x01:		/* mass storage controller */
			case 0x02:		/* network controller */
			case 0x03:		/* display controller */
			case 0x04:		/* multimedia device */
			case 0x06:		/* bridge device */
			case 0x07:		/* simple comm. controllers */
			case 0x08:		/* base system peripherals */
			case 0x09:		/* input devices */
			case 0x0A:		/* docking stations */
			case 0x0B:		/* processors */
			case 0x0C:		/* serial bus controllers */
				if((hdt &amp; 0x7F) != 0)
					break;
				rno = PciBAR0 - 4;
				for(i = 0; i &lt; nelem(p-&gt;mem); i++) {
					rno += 4;
					p-&gt;mem[i].bar = pcicfgr32(p, rno);
					p-&gt;mem[i].size = pcibarsize(p, rno);
				}
				break;

			case 0x00:
			case 0x05:		/* memory controller */
			default:
				break;
			}

			if(head != nil)
				tail-&gt;link = p;
			else
				head = p;
			tail = p;
		}
	}

	*list = head;
	for(p = head; p != nil; p = p-&gt;link){
		/*
		 * Find PCI-PCI bridges and recursively descend the tree.
		 */
		if(p-&gt;ccrb != 0x06 || p-&gt;ccru != 0x04)
			continue;

		/*
		 * If the secondary or subordinate bus number is not
		 * initialised try to do what the PCI BIOS should have
		 * done and fill in the numbers as the tree is descended.
		 * On the way down the subordinate bus number is set to
		 * the maximum as it's not known how many buses are behind
		 * this one; the final value is set on the way back up.
		 */
		sbn = pcicfgr8(p, PciSBN);
		ubn = pcicfgr8(p, PciUBN);

		if(sbn == 0 || ubn == 0) {
			sbn = maxubn+1;
			/*
			 * Make sure memory, I/O and master enables are
			 * off, set the primary, secondary and subordinate
			 * bus numbers and clear the secondary status before
			 * attempting to scan the secondary bus.
			 *
			 * Initialisation of the bridge should be done here.
			 */
			pcicfgw32(p, PciPCR, 0xFFFF0000);
			l = (MaxUBN&lt;&lt;16)|(sbn&lt;&lt;8)|bno;
			pcicfgw32(p, PciPBN, l);
			pcicfgw16(p, PciSPSR, 0xFFFF);
			maxubn = pcilscan(sbn, &amp;p-&gt;bridge);
			l = (maxubn&lt;&lt;16)|(sbn&lt;&lt;8)|bno;

			pcicfgw32(p, PciPBN, l);
		}
		else {
			maxubn = ubn;
			pcilscan(sbn, &amp;p-&gt;bridge);
		}
	}

	return maxubn;
}

int
pciscan(int bno, Pcidev **list)
{
	int ubn;

	qlock(&amp;pcicfginitlock);
	ubn = pcilscan(bno, list);
	qunlock(&amp;pcicfginitlock);
	return ubn;
}

static void
pcicfginit(void)
{
	char *p;
	int bno;
	Pcidev **list;
	ulong mema, ioa;

	qlock(&amp;pcicfginitlock);
	if(pcicfgmode != -1)
		goto out;

	/*
	 * Try to determine which PCI configuration mode is implemented.
	 * Mode2 uses a byte at 0xCF8 and another at 0xCFA; Mode1 uses
	 * a DWORD at 0xCF8 and another at 0xCFC and will pass through
	 * any non-DWORD accesses as normal I/O cycles. There shouldn't be
	 * a device behind these addresses so if Mode2 accesses fail try
	 * for Mode1 (which is preferred, Mode2 is deprecated).
	 */
	outb(PciCSE, 0);
	if(inb(PciCSE) == 0){
		pcicfgmode = 2;
		pcimaxdno = 15;
	}
	else {
		outl(PciADDR, 0);
		if(inl(PciADDR) == 0){
			pcicfgmode = 1;
			pcimaxdno = 31;
		}
	}
	
	if(pcicfgmode &lt; 0)
		goto out;

	fmtinstall('T', tbdffmt);

	if(p = getconf("*pcimaxbno"))
		pcimaxbno = strtoul(p, 0, 0);
	if(p = getconf("*pcimaxdno"))
		pcimaxdno = strtoul(p, 0, 0);

	list = &amp;pciroot;
	for(bno = 0; bno &lt;= pcimaxbno; bno++) {
		int sbno = bno;
		bno = pcilscan(bno, list);

		while(*list)
			list = &amp;(*list)-&gt;link;

		if (sbno == 0) {
			Pcidev *pci;

			/*
			  * If we have found a PCI-to-Cardbus bridge, make sure
			  * it has no valid mappings anymore.  
			  */
			pci = pciroot;
			while (pci) {
				if (pci-&gt;ccrb == 6 &amp;&amp; pci-&gt;ccru == 7) {
					ushort bcr;

					/* reset the cardbus */
					bcr = pcicfgr16(pci, PciBCR);
					pcicfgw16(pci, PciBCR, 0x40 | bcr);
					delay(50);
				}
				pci = pci-&gt;link;
			}
		}
	}

	if(pciroot == nil)
		goto out;

	/*
	 * Work out how big the top bus is
	 */
	mema = 0;
	ioa = 0;
	pcibusmap(pciroot, &amp;mema, &amp;ioa, 0);

	DBG("Sizes: mem=%8.8lux size=%8.8lux io=%8.8lux\n",
		mema, pcimask(mema), ioa);

	/*
	 * Align the windows and map it
	 */
	ioa = 0x1000;
	mema = 0;

	pcilog("Mask sizes: mem=%lux io=%lux\n", mema, ioa);

	pcibusmap(pciroot, &amp;mema, &amp;ioa, 1);
	DBG("Sizes2: mem=%lux io=%lux\n", mema, ioa);

out:
	qunlock(&amp;pcicfginitlock);
}

static int
pcicfgrw8(int tbdf, int rno, int data, int read)
{
	int o, type, x;

	if(pcicfgmode == -1)
		pcicfginit();

	if(BUSBNO(tbdf))
		type = 0x01;
	else
		type = 0x00;
	x = -1;
	if(BUSDNO(tbdf) &gt; pcimaxdno)
		return x;

	lock(&amp;pcicfglock);
	switch(pcicfgmode){

	case 1:
		o = rno &amp; 0x03;
		rno &amp;= ~0x03;
		outl(PciADDR, 0x80000000|BUSBDF(tbdf)|rno|type);
		if(read)
			x = inb(PciDATA+o);
		else
			outb(PciDATA+o, data);
		outl(PciADDR, 0);
		break;

	case 2:
		outb(PciCSE, 0x80|(BUSFNO(tbdf)&lt;&lt;1));
		outb(PciFORWARD, BUSBNO(tbdf));
		if(read)
			x = inb((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno);
		else
			outb((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno, data);
		outb(PciCSE, 0);
		break;
	}
	unlock(&amp;pcicfglock);

	return x;
}

int
pcicfgr8(Pcidev* pcidev, int rno)
{
	return pcicfgrw8(pcidev-&gt;tbdf, rno, 0, 1);
}

void
pcicfgw8(Pcidev* pcidev, int rno, int data)
{
	pcicfgrw8(pcidev-&gt;tbdf, rno, data, 0);
}

static int
pcicfgrw16(int tbdf, int rno, int data, int read)
{
	int o, type, x;

	if(pcicfgmode == -1)
		pcicfginit();

	if(BUSBNO(tbdf))
		type = 0x01;
	else
		type = 0x00;
	x = -1;
	if(BUSDNO(tbdf) &gt; pcimaxdno)
		return x;

	lock(&amp;pcicfglock);
	switch(pcicfgmode){

	case 1:
		o = rno &amp; 0x02;
		rno &amp;= ~0x03;
		outl(PciADDR, 0x80000000|BUSBDF(tbdf)|rno|type);
		if(read)
			x = ins(PciDATA+o);
		else
			outs(PciDATA+o, data);
		outl(PciADDR, 0);
		break;

	case 2:
		outb(PciCSE, 0x80|(BUSFNO(tbdf)&lt;&lt;1));
		outb(PciFORWARD, BUSBNO(tbdf));
		if(read)
			x = ins((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno);
		else
			outs((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno, data);
		outb(PciCSE, 0);
		break;
	}
	unlock(&amp;pcicfglock);

	return x;
}

int
pcicfgr16(Pcidev* pcidev, int rno)
{
	return pcicfgrw16(pcidev-&gt;tbdf, rno, 0, 1);
}

void
pcicfgw16(Pcidev* pcidev, int rno, int data)
{
	pcicfgrw16(pcidev-&gt;tbdf, rno, data, 0);
}

static int
pcicfgrw32(int tbdf, int rno, int data, int read)
{
	int type, x;

	if(pcicfgmode == -1)
		pcicfginit();

	if(BUSBNO(tbdf))
		type = 0x01;
	else
		type = 0x00;
	x = -1;
	if(BUSDNO(tbdf) &gt; pcimaxdno)
		return x;

	lock(&amp;pcicfglock);
	switch(pcicfgmode){

	case 1:
		rno &amp;= ~0x03;
		outl(PciADDR, 0x80000000|BUSBDF(tbdf)|rno|type);
		if(read)
			x = inl(PciDATA);
		else
			outl(PciDATA, data);
		outl(PciADDR, 0);
		break;

	case 2:
		outb(PciCSE, 0x80|(BUSFNO(tbdf)&lt;&lt;1));
		outb(PciFORWARD, BUSBNO(tbdf));
		if(read)
			x = inl((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno);
		else
			outl((0xC000|(BUSDNO(tbdf)&lt;&lt;8)) + rno, data);
		outb(PciCSE, 0);
		break;
	}
	unlock(&amp;pcicfglock);

	return x;
}

int
pcicfgr32(Pcidev* pcidev, int rno)
{
	return pcicfgrw32(pcidev-&gt;tbdf, rno, 0, 1);
}

void
pcicfgw32(Pcidev* pcidev, int rno, int data)
{
	pcicfgrw32(pcidev-&gt;tbdf, rno, data, 0);
}

Pcidev*
pcimatch(Pcidev* prev, int vid, int did)
{
	if(pcicfgmode == -1)
		pcicfginit();

	if(prev == nil)
		prev = pcilist;
	else
		prev = prev-&gt;list;

	while(prev != nil){
		if((vid == 0 || prev-&gt;vid == vid)
		&amp;&amp; (did == 0 || prev-&gt;did == did))
			break;
		prev = prev-&gt;list;
	}
	return prev;
}

Pcidev*
pcimatchtbdf(int tbdf)
{
	Pcidev *pcidev;

	if(pcicfgmode == -1)
		pcicfginit();

	for(pcidev = pcilist; pcidev != nil; pcidev = pcidev-&gt;list) {
		if(pcidev-&gt;tbdf == tbdf)
			break;
	}
	return pcidev;
}

uchar
pciipin(Pcidev *pci, uchar pin)
{
	if (pci == nil)
		pci = pcilist;

	while (pci) {
		uchar intl;

		if (pcicfgr8(pci, PciINTP) == pin &amp;&amp; pci-&gt;intl != 0 &amp;&amp; pci-&gt;intl != 0xff)
			return pci-&gt;intl;

		if (pci-&gt;bridge &amp;&amp; (intl = pciipin(pci-&gt;bridge, pin)) != 0)
			return intl;

		pci = pci-&gt;list;
	}
	return 0;
}

static void
pcilhinv(Pcidev* p)
{
	int i;
	Pcidev *t;

	if(p == nil) {
		putstrn(PCICONS.output, PCICONS.ptr);
		p = pciroot;
		print("bus dev type vid  did intl memory\n");
	}
	for(t = p; t != nil; t = t-&gt;link) {
		print("%d  %2d/%d %.2ux %.2ux %.2ux %.4ux %.4ux %3d  ",
			BUSBNO(t-&gt;tbdf), BUSDNO(t-&gt;tbdf), BUSFNO(t-&gt;tbdf),
			t-&gt;ccrb, t-&gt;ccru, t-&gt;ccrp, t-&gt;vid, t-&gt;did, t-&gt;intl);

		for(i = 0; i &lt; nelem(p-&gt;mem); i++) {
			if(t-&gt;mem[i].size == 0)
				continue;
			print("%d:%.8lux %d ", i,
				t-&gt;mem[i].bar, t-&gt;mem[i].size);
		}
		if(t-&gt;ioa.bar || t-&gt;ioa.size)
			print("ioa:%.8lux %d ", t-&gt;ioa.bar, t-&gt;ioa.size);
		if(t-&gt;mema.bar || t-&gt;mema.size)
			print("mema:%.8lux %d ", t-&gt;mema.bar, t-&gt;mema.size);
		if(t-&gt;bridge)
			print("-&gt;%d", BUSBNO(t-&gt;bridge-&gt;tbdf));
		print("\n");
	}
	while(p != nil) {
		if(p-&gt;bridge != nil)
			pcilhinv(p-&gt;bridge);
		p = p-&gt;link;
	}	
}

void
pcihinv(Pcidev* p)
{
	if(pcicfgmode == -1)
		pcicfginit();
	qlock(&amp;pcicfginitlock);
	pcilhinv(p);
	qunlock(&amp;pcicfginitlock);
}

void
pcireset(void)
{
	Pcidev *p;
	int pcr;

	if(pcicfgmode == -1)
		pcicfginit();

	for(p = pcilist; p != nil; p = p-&gt;list){
		pcr = pcicfgr16(p, PciPCR);
		pcr &amp;= ~0x0004;
		pcicfgw16(p, PciPCR, pcr);
	}
}

void
pcisetbme(Pcidev* p)
{
	int pcr;

	pcr = pcicfgr16(p, PciPCR);
	pcr |= MASen;
	pcicfgw16(p, PciPCR, pcr);
}

void
pciclrbme(Pcidev* p)
{
	int pcr;

	pcr = pcicfgr16(p, PciPCR);
	pcr &amp;= ~MASen;
	pcicfgw16(p, PciPCR, pcr);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

