<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/archomap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/archomap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * omap3530 SoC (e.g. beagleboard) architecture-specific stuff
 *
 * errata: usb port 3 cannot operate in ulpi mode, only serial or
 * utmi tll mode
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"
#include "arm.h"

#include "../port/netif.h"
#include "etherif.h"
#include "../port/flashif.h"
#include "../port/usb.h"
#include "../port/portusbehci.h"
#include "usbehci.h"

#define FREQSEL(x) ((x) &lt;&lt; 4)

typedef struct Cm Cm;
typedef struct Cntrl Cntrl;
typedef struct Gen Gen;
typedef struct Gpio Gpio;
typedef struct L3agent L3agent;
typedef struct L3protreg L3protreg;
typedef struct L3regs L3regs;
typedef struct Prm Prm;
typedef struct Usbotg Usbotg;
typedef struct Usbtll Usbtll;

/* omap3 non-standard usb stuff */
struct Usbotg {
	uchar	faddr;
	uchar	power;
	ushort	intrtx;
	ushort	intrrx;
	ushort	intrtxe;
	ushort	intrrxe;
	uchar	intrusb;
	uchar	intrusbe;
	ushort	frame;
	uchar	index;
	uchar	testmode;

	/* indexed registers follow; ignore for now */
	uchar	_pad0[0x400 - 0x10];

	ulong	otgrev;
	ulong	otgsyscfg;
	ulong	otgsyssts;
	ulong	otgifcsel;	/* interface selection */
	uchar	_pad1[0x414 - 0x410];
	ulong	otgforcestdby;
};

enum {
	/* power bits */
	Hsen		= 1&lt;&lt;5,		/* high-speed enable */

	/* testmode bits */
	Forcehost	= 1&lt;&lt;7,		/* force host (vs peripheral) mode */
	Forcehs		= 1&lt;&lt;4,		/* force high-speed at reset */

	/* otgsyscfg bits */
	Midle		= 1&lt;&lt;12,	/* no standby mode */
	Sidle		= 1&lt;&lt;3,		/* no idle mode */
//	Softreset	= 1&lt;&lt;1,

	/* otgsyssts bits, per sysstatus */
};

struct Usbtll {
	ulong	revision;	/* ro */
	uchar	_pad0[0x10-0x4];
	ulong	sysconfig;
	ulong	sysstatus;	/* ro */

	ulong	irqstatus;
	ulong	irqenable;
};

enum {
	/* sysconfig bits */
	Softreset	= 1&lt;&lt;1,

	/* sysstatus bits */
	Resetdone	= 1&lt;&lt;0,
	/* only in uhh-&gt;sysstatus */
	Ehci_resetdone	= 1&lt;&lt;2,
	Ohci_resetdone	= 1&lt;&lt;1,
};

/*
 * an array of these structs is preceded by error_log at 0x20, control,
 * error_clear_single, error_clear_multi.  first struct is at offset 0x48.
 */
struct L3protreg {		/* hw: an L3 protection region */
	uvlong	req_info_perm;
	uvlong	read_perm;
	uvlong	write_perm;
	uvlong	addr_match;	/* ro? write this one last, then flush */
};

// TODO: set these permission bits (e.g., for usb)?
enum {
	Permusbhost	= 1&lt;&lt;9,
	Permusbotg	= 1&lt;&lt;4,
	Permsysdma	= 1&lt;&lt;3,
	Permmpu		= 1&lt;&lt;1,
};

struct L3agent {		/* hw registers */
	uchar	_pad0[0x20];
	uvlong	ctl;
	uvlong	sts;
	uchar	_pad1[0x58 - 0x30];
	uvlong	errlog;
	uvlong	errlogaddr;
};

struct L3regs {
	L3protreg *base;		/* base of array */
	int	upper;			/* index maximum */
	char	*name;
};
L3regs l3regs[] = {
	(L3protreg *)(PHYSL3GPMCPM+0x48), 7, "gpmc",	/* known to be first */
	(L3protreg *)(PHYSL3PMRT+0x48), 1, "rt",	/* l3 config */
	(L3protreg *)(PHYSL3OCTRAM+0x48), 7, "ocm ram",
	(L3protreg *)(PHYSL3OCTROM+0x48), 1, "ocm rom",
	(L3protreg *)(PHYSL3MAD2D+0x48), 7, "mad2d",	/* die-to-die */
	(L3protreg *)(PHYSL3IVA+0x48), 3, "iva2.2",	/* a/v */
};

/*
 * PRM_CLKSEL (0x48306d40) low 3 bits are system clock speed, assuming
 * 	units of MHz: 0 = 12, 1 = 13, 2 = 19.2, 3 = 26, 4 = 38.4, 5 = 16.8
 */

struct Cm {				/* clock management */
	ulong	fclken;			/* ``functional'' clock enable */
	ulong	fclken2;
	ulong	fclken3;
	uchar	_pad0[0x10 - 0xc];

	ulong	iclken;			/* ``interface'' clock enable */
	ulong	iclken2;
	ulong	iclken3;
	uchar	_pad1[0x20 - 0x1c];

	ulong	idlest;			/* idle status */
	ulong	idlest2;
	ulong	idlest3;
	uchar	_pad2[0x30 - 0x2c];

	ulong	autoidle;
	ulong	autoidle2;
	ulong	autoidle3;
	uchar	_pad3[0x40 - 0x3c];

	union {
		ulong	clksel[5];
		struct unused {
			ulong	sleepdep;
			ulong	clkstctrl;
			ulong	clkstst;
		};
		uchar	_pad4[0x70 - 0x40];
	};
	ulong	clkoutctrl;
};

struct Prm {				/* power &amp; reset management */
	uchar	_pad[0x50];
	ulong	rstctrl;
};

struct Gpio {
	ulong	_pad0[4];
	ulong	sysconfig;
	ulong	sysstatus;

	ulong	irqsts1;		/* for mpu */
	ulong	irqen1;
	ulong	wkupen;
	ulong	_pad1;
	ulong	irqsts2;		/* for iva */
	ulong	irqen2;

	ulong	ctrl;

	ulong	oe;
	ulong	datain;
	ulong	dataout;

	ulong	lvldet0;
	ulong	lvldet1;
	ulong	risingdet;
	ulong	fallingdet;

	/* rest are uninteresting */
	ulong	deben;			/* debouncing enable */
	ulong	debtime;
	ulong	_pad2[2];

	ulong	clrirqen1;
	ulong	setirqen1;
	ulong	_pad3[2];

	ulong	clrirqen2;
	ulong	setirqen2;
	ulong	_pad4[2];

	ulong	clrwkupen;
	ulong	setwkupen;
	ulong	_pad5[2];

	ulong	clrdataout;
	ulong	setdataout;
};

enum {
	/* clock enable &amp; idle status bits */
	Wkusimocp	= 1 &lt;&lt; 9,	/* SIM card: uses 120MHz clock */
	Wkwdt2		= 1 &lt;&lt; 5,	/* wdt2 clock enable bit for wakeup */
	Wkgpio1		= 1 &lt;&lt; 3,	/* gpio1 " */
	Wkgpt1		= 1 &lt;&lt; 0,	/* gpt1 " */

	Dssl3l4		= 1 &lt;&lt; 0,	/* dss l3, l4 i clks */
	Dsstv		= 1 &lt;&lt; 2,	/* dss tv f clock */
	Dss2		= 1 &lt;&lt; 1,	/* dss clock 2 */
	Dss1		= 1 &lt;&lt; 0,	/* dss clock 1 */

	Pergpio6	= 1 &lt;&lt; 17,
	Pergpio5	= 1 &lt;&lt; 16,
	Pergpio4	= 1 &lt;&lt; 15,
	Pergpio3	= 1 &lt;&lt; 14,
	Pergpio2	= 1 &lt;&lt; 13,
	Perwdt3		= 1 &lt;&lt; 12,	/* wdt3 clock enable bit for periphs */
	Peruart3	= 1 &lt;&lt; 11,	/* console uart */
	Pergpt9		= 1 &lt;&lt; 10,
	Pergpt8		= 1 &lt;&lt; 9,
	Pergpt7		= 1 &lt;&lt; 8,
	Pergpt6		= 1 &lt;&lt; 7,
	Pergpt5		= 1 &lt;&lt; 6,
	Pergpt4		= 1 &lt;&lt; 5,
	Pergpt3		= 1 &lt;&lt; 4,
	Pergpt2		= 1 &lt;&lt; 3,	/* gpt2 clock enable bit for periphs */

	Perenable	= Pergpio6 | Pergpio5 | Perwdt3 | Pergpt2 | Peruart3,

	Usbhost2	= 1 &lt;&lt; 1,	/* 120MHz clock enable */
	Usbhost1	= 1 &lt;&lt; 0,	/* 48MHz clock enable */
	Usbhost		= Usbhost1,	/* iclock enable */
	Usbhostidle	= 1 &lt;&lt; 1,
	Usbhoststdby	= 1 &lt;&lt; 0,

	Coreusbhsotg	= 1 &lt;&lt; 4,	/* usb hs otg enable bit */
	Core3usbtll	= 1 &lt;&lt; 2,	/* usb tll enable bit */

	/* core-&gt;idlest bits */
	Coreusbhsotgidle = 1 &lt;&lt; 5,
	Coreusbhsotgstdby= 1 &lt;&lt; 4,

	Dplllock	= 7,

	/* mpu-&gt;idlest2 bits */
	Dplllocked	= 1,
	Dpllbypassed	= 0,

	/* wkup-&gt;idlest bits */
	Gpio1idle	= 1 &lt;&lt; 3,

	/* dss-&gt;idlest bits */
	Dssidle		= 1 &lt;&lt; 1,

	Gpio1vidmagic	= 1&lt;&lt;24 | 1&lt;&lt;8 | 1&lt;&lt;5,	/* gpio 1 pins for video */
};
enum {
	Rstgs		= 1 &lt;&lt; 1,	/* global sw. reset */

	/* fp control regs.  most are read-only */
	Fpsid		= 0,
	Fpscr,				/* rw */
	Mvfr1		= 6,
	Mvfr0,
	Fpexc,				/* rw */
};

/* see ether9221.c for explanation */
enum {
	Ethergpio	= 176,
	Etherchanbit	= 1 &lt;&lt; (Ethergpio % 32),
};

/*
 * these shift values are for the Cortex-A8 L1 cache (A=2, L=6) and
 * the Cortex-A8 L2 cache (A=3, L=6).
 * A = log2(# of ways), L = log2(bytes per cache line).
 * see armv7 arch ref p. 1403.
 *
 * #define L1WAYSH 30
 * #define L1SETSH 6
 * #define L2WAYSH 29
 * #define L2SETSH 6
 */
enum {
	/*
	 * cache capabilities.  write-back vs write-through is controlled
	 * by the Buffered bit in PTEs.
	 */
	Cawt	= 1 &lt;&lt; 31,
	Cawb	= 1 &lt;&lt; 30,
	Cara	= 1 &lt;&lt; 29,
	Cawa	= 1 &lt;&lt; 28,
};

struct Gen {
	ulong	padconf_off;
	ulong	devconf0;
	uchar	_pad0[0x68 - 8];
	ulong	devconf1;
};

struct Cntrl {
	ulong	_pad0;
	ulong	id;
	ulong	_pad1;
	ulong	skuid;
};


static char *
devidstr(ulong)
{
	return "ARM Cortex-A8";
}

void
archomaplink(void)
{
}

int
ispow2(uvlong ul)
{
	/* see Hacker's Delight if this isn't obvious */
	return (ul &amp; (ul - 1)) == 0;
}

/*
 * return exponent of smallest power of 2 ≥ n
 */
int
log2(ulong n)
{
	int i;

	i = 31 - clz(n);
	if (n == 0 || !ispow2(n))
		i++;
	return i;
}

void
archconfinit(void)
{
	char *p;
	ulong mhz;

	assert(m != nil);
	m-&gt;cpuhz = 500 * Mhz;			/* beagle speed */
	p = getconf("*cpumhz");
	if (p) {
		mhz = atoi(p) * Mhz;
		if (mhz &gt;= 100*Mhz &amp;&amp; mhz &lt;= 3000UL*Mhz)
			m-&gt;cpuhz = mhz;
	}
	m-&gt;delayloop = m-&gt;cpuhz/2000;		/* initial estimate */
}

static void
prperm(uvlong perm)
{
	if (perm == MASK(16))
		print("all");
	else
		print("%#llux", perm);
}

static void
prl3region(L3protreg *pr, int r)
{
	int level, size, addrspace;
	uvlong am, base;

	if (r == 0)
		am = 0;
	else
		am = pr-&gt;addr_match;
	size = (am &gt;&gt; 3) &amp; MASK(5);
	if (r &gt; 0 &amp;&amp; size == 0)			/* disabled? */
		return;

	print("  %d: perms req ", r);
	prperm(pr-&gt;req_info_perm);
	if (pr-&gt;read_perm == pr-&gt;write_perm &amp;&amp; pr-&gt;read_perm == MASK(16))
		print(" rw all");
	else {
		print(" read ");
		prperm(pr-&gt;read_perm);
		print(" write ");
		prperm(pr-&gt;write_perm);
	}
	if (r == 0)
		print(", all addrs level 0");
	else {
		size = 1 &lt;&lt; size;		/* 2^size */
		level = (am &gt;&gt; 9) &amp; 1;
		if (r == 1)
			level = 3;
		else
			level++;
		addrspace = am &amp; 7;
		base = am &amp; ~MASK(10);
		print(", base %#llux size %dKB level %d addrspace %d",
			base, size, level, addrspace);
	}
	print("\n");
	delay(100);
}


/*
 * dump the l3 interconnect firewall settings by protection region.
 * mpu, sys dma and both usbs (0x21a) should be set in all read &amp; write
 * permission registers.
 */
static void
dumpl3pr(void)
{
	int r;
	L3regs *reg;
	L3protreg *pr;

	for (reg = l3regs; reg &lt; l3regs + nelem(l3regs); reg++) {
		print("%#p (%s) enabled l3 regions:\n", reg-&gt;base, reg-&gt;name);
		for (r = 0; r &lt;= reg-&gt;upper; r++)
			prl3region(reg-&gt;base + r, r);
	}
if (0) {				// TODO
	/* touch up gpmc perms */
	reg = l3regs;			/* first entry is gpmc */
	for (r = 0; r &lt;= reg-&gt;upper; r++) {
		pr = reg-&gt;base + r;
		// TODO
	}
	print("%#p (%s) modified l3 regions:\n", reg-&gt;base, reg-&gt;name);
	for (r = 0; r &lt;= reg-&gt;upper; r++)
		prl3region(reg-&gt;base + r, r);
}
}

static void
p16(uchar *p, ulong v)
{
	*p++ = v&gt;&gt;8;
	*p   = v;
}

static void
p32(uchar *p, ulong v)
{
	*p++ = v&gt;&gt;24;
	*p++ = v&gt;&gt;16;
	*p++ = v&gt;&gt;8;
	*p   = v;
}

int
archether(unsigned ctlrno, Ether *ether)
{
	switch(ctlrno) {
	case 0:
		/* there's no built-in ether on the beagle but igepv2 has 1 */
		ether-&gt;type = "9221";
		ether-&gt;ctlrno = ctlrno;
		ether-&gt;irq = 34;
		ether-&gt;nopt = 0;
		ether-&gt;mbps = 100;
		return 1;
	}
	return -1;
}

/*
 * turn on all the necessary clocks on the SoC.
 *
 * a ``functional'' clock drives a device; an ``interface'' clock drives
 * its communication with the rest of the system.  so the interface
 * clock must be enabled to reach the device's registers.
 *
 * dplls: 1 mpu, 2 iva2, 3 core, 4 per, 5 per2.
 */

static void
configmpu(void)
{
	ulong clk, mhz, nmhz, maxmhz;
	Cm *mpu = (Cm *)PHYSSCMMPU;
	Cntrl *id = (Cntrl *)PHYSCNTRL;

	if ((id-&gt;skuid &amp; MASK(4)) == 8)
		maxmhz = 720;
	else
		maxmhz = 600;
	iprint("cpu capable of %ldMHz operation", maxmhz);

	clk = mpu-&gt;clksel[0];
	mhz = (clk &gt;&gt; 8) &amp; MASK(11);		/* configured speed */
//	iprint("\tfclk src %ld; dpll1 mult %ld (MHz) div %ld",
//		(clk &gt;&gt; 19) &amp; MASK(3), mhz, clk &amp; MASK(7));
	iprint("; at %ldMHz", mhz);
	nmhz = m-&gt;cpuhz / Mhz;			/* nominal speed */
	if (mhz == nmhz) {
		iprint("\n");
		return;
	}

	mhz = nmhz;
	if (mhz &gt; maxmhz) {
		mhz = maxmhz;
		iprint("; limiting operation to %ldMHz", mhz);
	}

	/* disable dpll1 lock mode; put into low-power bypass mode */
	mpu-&gt;fclken2 = mpu-&gt;fclken2 &amp; ~MASK(3) | 5;
	coherence();
	while (mpu-&gt;idlest2 != Dpllbypassed)
		;

	/*
	 * there's a dance to change processor speed,
	 * prescribed in spruf98d §4.7.6.9.
	 */

	/* just change multiplier; leave divider alone at 12 (meaning 13?) */
	mpu-&gt;clksel[0] = clk &amp; ~(MASK(11) &lt;&lt; 8) | mhz &lt;&lt; 8;
	coherence();

	/* set output divider (M2) in clksel[1]: leave at 1 */

	/*
	 * u-boot calls us with just freqsel 3 (~1MHz) &amp; dpll1 lock mode.
	 */
	/* set FREQSEL */
	mpu-&gt;fclken2 = mpu-&gt;fclken2 &amp; ~FREQSEL(MASK(4)) | FREQSEL(3);
	coherence();

	/* set ramp-up delay to `fast' */
	mpu-&gt;fclken2 = mpu-&gt;fclken2 &amp; ~(MASK(2) &lt;&lt; 8) | 3 &lt;&lt; 8;
	coherence();

	/* set auto-recalibration (off) */
	mpu-&gt;fclken2 &amp;= ~(1 &lt;&lt; 3);
	coherence();

	/* disable auto-idle: ? */
	/* unmask clock intr: later */

	/* enable dpll lock mode */
	mpu-&gt;fclken2 |= Dplllock;
	coherence();
	while (mpu-&gt;idlest2 != Dplllocked)
		;
	delay(200);			/* allow time for speed to ramp up */

	if (((mpu-&gt;clksel[0] &gt;&gt; 8) &amp; MASK(11)) != mhz)
		panic("mpu clock speed change didn't stick");
	iprint("; now at %ldMHz\n", mhz);
}

static void
configpll(void)
{
	int i;
	Cm *pll = (Cm *)PHYSSCMPLL;

	pll-&gt;clkoutctrl |= 1 &lt;&lt; 7;	/* enable sys_clkout2 */
	coherence();
	delay(10);

	/*
	 * u-boot calls us with just freqsel 3 (~1MHz) &amp; lock mode
	 * for both dplls (3 &amp; 4).  ensure that.
	 */
	if ((pll-&gt;idlest &amp; 3) != 3) {
		/* put dpll[34] into low-power bypass mode */
		pll-&gt;fclken = pll-&gt;fclken &amp; ~(MASK(3) &lt;&lt; 16 | MASK(3)) |
			1 &lt;&lt; 16 | 5;
		coherence();
		while (pll-&gt;idlest &amp; 3)  /* wait for both to bypass or stop */
			;

		pll-&gt;fclken =  (FREQSEL(3) | Dplllock) &lt;&lt; 16 |
				FREQSEL(3) | Dplllock;
		coherence();
		while ((pll-&gt;idlest &amp; 3) != 3)	/* wait for both to lock */
			;
	}

	/*
	 * u-boot calls us with just freqsel 1 (default but undefined)
	 * &amp; stop mode for dpll5.  try to lock it at 120MHz.
	 */
	if (!(pll-&gt;idlest2 &amp; Dplllocked)) {
		/* force dpll5 into low-power bypass mode */
		pll-&gt;fclken2 = 3 &lt;&lt; 8 | FREQSEL(1) | 1;
		coherence();
		for (i = 0; pll-&gt;idlest2 &amp; Dplllocked &amp;&amp; i &lt; 20; i++)
			delay(50);
		if (i &gt;= 20)
			iprint(" [dpll5 failed to stop]");

		/*
		 * CORE_CLK is 26MHz.
		 */
		pll-&gt;clksel[4-1] = 120 &lt;&lt; 8 | 12;	/* M=120, N=12+1 */
		/* M2 divisor: 120MHz clock is exactly the DPLL5 clock */
		pll-&gt;clksel[5-1] = 1;
		coherence();

		pll-&gt;fclken2 = 3 &lt;&lt; 8 | FREQSEL(1) | Dplllock; /* def. freq */
		coherence();

		for (i = 0; !(pll-&gt;idlest2 &amp; Dplllocked) &amp;&amp; i &lt; 20; i++)
			delay(50);
		if (i &gt;= 20)
			iprint(" [dpll5 failed to lock]");
	}
	if (!(pll-&gt;idlest2 &amp; (1&lt;&lt;1)))
		iprint(" [no 120MHz clock]");
	if (!(pll-&gt;idlest2 &amp; (1&lt;&lt;3)))
		iprint(" [no dpll5 120MHz clock output]");
}

static void
configper(void)
{
	Cm *per = (Cm *)PHYSSCMPER;

	per-&gt;clksel[0] &amp;= ~MASK(8);	/* select 32kHz clock for GPTIMER2-9 */

	per-&gt;iclken |= Perenable;
	coherence();
	per-&gt;fclken |= Perenable;
	coherence();
	while (per-&gt;idlest &amp; Perenable)
		;

	per-&gt;autoidle = 0;
	coherence();
}

static void
configwkup(void)
{
	Cm *wkup = (Cm *)PHYSSCMWKUP;

	/* select 32kHz clock (not system clock) for GPTIMER1 */
	wkup-&gt;clksel[0] &amp;= ~1;

	wkup-&gt;iclken |= Wkusimocp | Wkwdt2 | Wkgpt1;
	coherence();
	wkup-&gt;fclken |= Wkusimocp | Wkwdt2 | Wkgpt1;
	coherence();
	while (wkup-&gt;idlest &amp; (Wkusimocp | Wkwdt2 | Wkgpt1))
		;
}

static void
configusb(void)
{
	int i;
	Cm *usb = (Cm *)PHYSSCMUSB;

	/*
	 * make the usb registers accessible without address faults,
	 * notably uhh, ochi &amp; ehci.  tll seems to be separate &amp; otg is okay.
	 */
	usb-&gt;iclken |= Usbhost;
	coherence();
	usb-&gt;fclken |= Usbhost1 | Usbhost2;	/* includes 120MHz clock */
	coherence();
	for (i = 0; usb-&gt;idlest &amp; Usbhostidle &amp;&amp; i &lt; 20; i++)
		delay(50);
	if (i &gt;= 20)
		iprint(" [usb inaccessible]");
}

static void
configcore(void)
{
	Cm *core = (Cm *)PHYSSCMCORE;

	/*
	 * make the usb tll registers accessible.
	 */
	core-&gt;iclken  |= Coreusbhsotg;
	core-&gt;iclken3 |= Core3usbtll;
	coherence();
	core-&gt;fclken3 |= Core3usbtll;
	coherence();
	delay(100);
	while (core-&gt;idlest &amp; Coreusbhsotgidle)
		;
	if (core-&gt;idlest3 &amp; Core3usbtll)
		iprint(" [no usb tll]");
}

static void
configclks(void)
{
	int s;
	Gen *gen = (Gen *)PHYSSCMPCONF;

	delay(20);
	s = splhi();
	configmpu();		/* sets cpu clock rate, turns on dplls 1 &amp; 2 */

	/*
	 * the main goal is to get enough clocks running, in the right order,
	 * so that usb has all the necessary clock signals.
	 */
	iprint("clocks:");
	iprint(" usb");
	configusb();		/* starts usb clocks &amp; 120MHz clock */
	iprint(", pll");
	configpll();		/* starts dplls 3, 4 &amp; 5 &amp; 120MHz clock */
	iprint(", wakeup");
	configwkup();		/* starts timer clocks and usim clock */
	iprint(", per");
	configper();		/* starts timer &amp; gpio (ether) clocks */
	iprint(", core");
	configcore();		/* starts usb tll */
	iprint("\n");

	gen-&gt;devconf0 |= 1 &lt;&lt; 1 | 1 &lt;&lt; 0;	/* dmareq[01] edge sensitive */
	/* make dmareq[2-6] edge sensitive */
	gen-&gt;devconf1 |= 1 &lt;&lt; 23 | 1 &lt;&lt; 22 | 1 &lt;&lt; 21 | 1 &lt;&lt; 8 | 1 &lt;&lt; 7;
	coherence();
	splx(s);
	delay(20);
}

static void
resetwait(ulong *reg)
{
	long bound;

	for (bound = 400*Mhz; !(*reg &amp; Resetdone) &amp;&amp; bound &gt; 0; bound--)
		;
	if (bound &lt;= 0)
		iprint("archomap: Resetdone didn't come ready\n");
}

/*
 * gpio irq 1 goes to the mpu intr ctlr; irq 2 goes to the iva's.
 * this stuff is magic and without it, we won't get irq 34 interrupts
 * from the 9221 ethernet controller.
 */
static void
configgpio(void)
{
	Gpio *gpio = (Gpio *)PHYSGPIO6;

	gpio-&gt;sysconfig = Softreset;
	coherence();
	resetwait(&amp;gpio-&gt;sysstatus);

	gpio-&gt;ctrl = 1&lt;&lt;1 | 0;	/* enable this gpio module, gating ratio 1 */
	gpio-&gt;oe |= Etherchanbit;	/* cfg ether pin as input */
	coherence();

	gpio-&gt;irqen1 = Etherchanbit;	/* channel # == pin # */
	gpio-&gt;irqen2 = 0;

	gpio-&gt;lvldet0 = Etherchanbit;	/* enable irq ass'n on low det'n */
	gpio-&gt;lvldet1 = 0;		/* disable irq ass'n on high det'n */
	gpio-&gt;risingdet = 0;		/* enable irq rising edge det'n */
	gpio-&gt;fallingdet = 0;		/* disable irq falling edge det'n */

	gpio-&gt;wkupen = 0;

	gpio-&gt;deben = 0;		/* no de-bouncing */
	gpio-&gt;debtime = 0;
	coherence();

	gpio-&gt;irqsts1 = ~0;		/* dismiss all outstanding intrs */
	gpio-&gt;irqsts2 = ~0;
	coherence();
}

void
configscreengpio(void)
{
	Cm *wkup = (Cm *)PHYSSCMWKUP;
	Gpio *gpio = (Gpio *)PHYSGPIO1;

	/* no clocksel needed */
	wkup-&gt;iclken |= Wkgpio1;
	coherence();
	wkup-&gt;fclken |= Wkgpio1;		/* turn gpio clock on */
	coherence();
	// wkup-&gt;autoidle |= Wkgpio1; 		/* set gpio clock on auto */
	wkup-&gt;autoidle = 0;
	coherence();
	while (wkup-&gt;idlest &amp; Gpio1idle)
		;

	/*
	 * 0 bits in oe are output signals.
	 * enable output for gpio 1 (first gpio) video magic pins.
	 */
	gpio-&gt;oe &amp;= ~Gpio1vidmagic;
	coherence();
	gpio-&gt;dataout |= Gpio1vidmagic;		/* set output pins to 1 */
	coherence();
	delay(50);
}

void
screenclockson(void)
{
	Cm *dss = (Cm *)PHYSSCMDSS;

	dss-&gt;iclken |= Dssl3l4;
	coherence();
	dss-&gt;fclken = Dsstv | Dss2 | Dss1;
	coherence();
	/* tv fclk is dpll4 clk; dpll4 m4 divide factor for dss1 fclk is 2 */
	dss-&gt;clksel[0] = 1&lt;&lt;12 | 2;
	coherence();
	delay(50);
	while (dss-&gt;idlest &amp; Dssidle)
		;
}

void
gpioirqclr(void)
{
	Gpio *gpio = (Gpio *)PHYSGPIO6;

	gpio-&gt;irqsts1 = gpio-&gt;irqsts1;
	coherence();
}

static char *
l1iptype(uint type)
{
	static char *types[] = {
		"reserved",
		"asid-tagged VIVT",
		"VIPT",
		"PIPT",
	};

	if (type &gt;= nelem(types) || types[type] == nil)
		return "GOK";
	return types[type];
}

void
cacheinfo(int level, Memcache *cp)
{
	ulong setsways;

	/* select cache level */
	cpwrsc(CpIDcssel, CpID, CpIDid, 0, (level - 1) &lt;&lt; 1);

	setsways = cprdsc(CpIDcsize, CpID, CpIDid, 0);
	cp-&gt;l1ip = cprdsc(0, CpID, CpIDidct, CpIDct);
	cp-&gt;level = level;
	cp-&gt;nways = ((setsways &gt;&gt; 3)  &amp; MASK(10)) + 1;
	cp-&gt;nsets = ((setsways &gt;&gt; 13) &amp; MASK(15)) + 1;
	cp-&gt;log2linelen = (setsways &amp; MASK(2)) + 2 + 2;
	cp-&gt;linelen = 1 &lt;&lt; cp-&gt;log2linelen;
	cp-&gt;setsways = setsways;

	cp-&gt;setsh = cp-&gt;log2linelen;
	cp-&gt;waysh = 32 - log2(cp-&gt;nways);
}

static void
prcachecfg(void)
{
	int cache;
	Memcache mc;

	for (cache = 1; cache &lt;= 2; cache++) {
		cacheinfo(cache, &amp;mc);
		iprint("l%d: %d ways %d sets %d bytes/line",
			mc.level, mc.nways, mc.nsets, mc.linelen);
		if (mc.linelen != CACHELINESZ)
			iprint(" *should* be %d", CACHELINESZ);
		if (mc.setsways &amp; Cawt)
			iprint("; can WT");
		if (mc.setsways &amp; Cawb)
			iprint("; can WB");
#ifdef COMPULSIVE			/* both caches can do this */
		if (mc.setsways &amp; Cara)
			iprint("; can read-allocate");
#endif
		if (mc.setsways &amp; Cawa)
			iprint("; can write-allocate");
		if (cache == 1)
			iprint("; l1 I policy %s",
				l1iptype((mc.l1ip &gt;&gt; 14) &amp; MASK(2)));
		iprint("\n");
	}
}

static char *
subarch(int impl, uint sa)
{
	static char *armarchs[] = {
		"VFPv1 (pre-armv7)",
		"VFPv2 (pre-armv7)",
		"VFPv3+ with common VFP subarch v2",
		"VFPv3+ with null subarch",
		"VFPv3+ with common VFP subarch v3",
	};

	if (impl != 'A' || sa &gt;= nelem(armarchs))
		return "GOK";
	else
		return armarchs[sa];
}

/*
 * padconf bits in a short, 2 per long register
 *	15	wakeupevent
 *	14	wakeupenable
 *	13	offpulltypeselect
 *	12	offpulludenable
 *	11	offoutvalue
 *	10	offoutenable
 *	9	offenable
 *	8	inputenable
 *	4	pulltypeselect
 *	3	pulludenable
 *	2-0	muxmode
 *
 * see table 7-5 in §7.4.4.3 of spruf98d
 */

enum {
	/* pad config register bits */
	Inena	= 1 &lt;&lt; 8,		/* input enable */
	Indis	= 0 &lt;&lt; 8,		/* input disable */
	Ptup	= 1 &lt;&lt; 4,		/* pull type up */
	Ptdown	= 0 &lt;&lt; 4,		/* pull type down */
	Ptena	= 1 &lt;&lt; 3,		/* pull type selection is active */
	Ptdis	= 0 &lt;&lt; 3,		/* pull type selection is inactive */
	Muxmode	= MASK(3),

	/* pad config registers relevant to flash */
	GpmcA1		= 0x4800207A,
	GpmcA2		= 0x4800207C,
	GpmcA3		= 0x4800207E,
	GpmcA4		= 0x48002080,
	GpmcA5		= 0x48002082,
	GpmcA6		= 0x48002084,
	GpmcA7		= 0x48002086,
	GpmcA8		= 0x48002088,
	GpmcA9		= 0x4800208A,
	GpmcA10		= 0x4800208C,
	GpmcD0		= 0x4800208E,
	GpmcD1		= 0x48002090,
	GpmcD2		= 0x48002092,
	GpmcD3		= 0x48002094,
	GpmcD4		= 0x48002096,
	GpmcD5		= 0x48002098,
	GpmcD6		= 0x4800209A,
	GpmcD7		= 0x4800209C,
	GpmcD8		= 0x4800209E,
	GpmcD9		= 0x480020A0,
	GpmcD10		= 0x480020A2,
	GpmcD11		= 0x480020A4,
	GpmcD12		= 0x480020A6,
	GpmcD13		= 0x480020A8,
	GpmcD14		= 0x480020AA,
	GpmcD15		= 0x480020AC,
	GpmcNCS0	= 0x480020AE,
	GpmcNCS1	= 0x480020B0,
	GpmcNCS2	= 0x480020B2,
	GpmcNCS3	= 0x480020B4,
	GpmcNCS4	= 0x480020B6,
	GpmcNCS5	= 0x480020B8,
	GpmcNCS6	= 0x480020BA,
	GpmcNCS7	= 0x480020BC,
	GpmcCLK		= 0x480020BE,
	GpmcNADV_ALE	= 0x480020C0,
	GpmcNOE		= 0x480020C2,
	GpmcNWE		= 0x480020C4,
	GpmcNBE0_CLE	= 0x480020C6,
	GpmcNBE1	= 0x480020C8,
	GpmcNWP		= 0x480020CA,
	GpmcWAIT0	= 0x480020CC,
	GpmcWAIT1	= 0x480020CE,
	GpmcWAIT2	= 0x480020D0,
	GpmcWAIT3	= 0x480020D2,
};

/* set SCM pad config mux mode */
void
setmuxmode(ulong addr, int shorts, int mode)
{
	int omode;
	ushort *ptr;

	mode &amp;= Muxmode;
	for (ptr = (ushort *)addr; shorts-- &gt; 0; ptr++) {
		omode = *ptr &amp; Muxmode;
		if (omode != mode)
			*ptr = *ptr &amp; ~Muxmode | mode;
	}
	coherence();
}

static void
setpadmodes(void)
{
	int off;

	/* set scm pad modes for usb; hasn't made any difference yet */
	setmuxmode(0x48002166, 7, 5);	/* hsusb3_tll* in mode 5; is mode 4 */
	setmuxmode(0x48002180, 1, 5);	/* hsusb3_tll_clk; is mode 4 */
	setmuxmode(0x48002184, 4, 5);	/* hsusb3_tll_data?; is mode 1 */
	setmuxmode(0x480021a2, 12, 0);	/* hsusb0 (console) in mode 0 */
	setmuxmode(0x480021d4, 6, 2);	/* hsusb2_tll* (ehci port 2) in mode 2 */
					/* mode 3 is hsusb2_data* */
	setmuxmode(0x480025d8, 18, 6);	/* hsusb[12]_tll*; mode 3 is */
					/* hsusb1_data*, hsusb2* */

	setmuxmode(0x480020e4, 2, 5);	/* uart3_rx_* in mode 5 */
	setmuxmode(0x4800219a, 4, 0);	/* uart3_* in mode 0 */
	/* uart3_* in mode 2; TODO: conflicts with hsusb0 */
	setmuxmode(0x480021aa, 4, 2);
	setmuxmode(0x48002240, 2, 3);	/* uart3_* in mode 3 */

	/*
	 * igep/gumstix only: mode 4 of 21d2 is gpio_176 (smsc9221 ether irq).
	 * see ether9221.c for more.
	 */
	*(ushort *)0x480021d2 = Inena | Ptup | Ptena | 4;

	/* magic from u-boot for flash */
	*(ushort *)GpmcA1	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA2	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA3	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA4	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA5	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA6	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA7	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA8	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA9	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcA10	= Indis | Ptup | Ptena | 0;

	*(ushort *)GpmcD0	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD1	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD2	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD3	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD4	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD5	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD6	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD7	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD8	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD9	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD10	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD11	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD12	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD13	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD14	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcD15	= Inena | Ptup | Ptena | 0;

	*(ushort *)GpmcNCS0	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS1	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS2	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS3	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS4	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS5	= Indis | Ptup | Ptena | 0;
	*(ushort *)GpmcNCS6	= Indis | Ptup | Ptena | 0;

	*(ushort *)GpmcNOE	= Indis | Ptdown | Ptdis | 0;
	*(ushort *)GpmcNWE	= Indis | Ptdown | Ptdis | 0;

	*(ushort *)GpmcWAIT2	= Inena | Ptup | Ptena | 4; /* GPIO_64 -ETH_NRESET */
	*(ushort *)GpmcNCS7	= Inena | Ptup | Ptena | 1; /* SYS_nDMA_REQ3 */

	*(ushort *)GpmcCLK	= Indis | Ptdown | Ptdis | 0;

	*(ushort *)GpmcNBE1	= Inena | Ptdown | Ptdis | 0;

	*(ushort *)GpmcNADV_ALE	= Indis | Ptdown | Ptdis | 0;
	*(ushort *)GpmcNBE0_CLE	= Indis | Ptdown | Ptdis | 0;

	*(ushort *)GpmcNWP	= Inena | Ptdown | Ptdis | 0;

	*(ushort *)GpmcWAIT0	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcWAIT1	= Inena | Ptup | Ptena | 0;
	*(ushort *)GpmcWAIT3	= Inena | Ptup | Ptena | 0;

	/*
	 * magic from u-boot: set 0xe00 bits in gpmc_(nwe|noe|nadv_ale)
	 * to enable `off' mode for each.
	 */
	for (off = 0xc0; off &lt;= 0xc4; off += sizeof(short))
		*((ushort *)(PHYSSCM + off)) |= 0xe00;
	coherence();
}

static char *
implement(uchar impl)
{
	if (impl == 'A')
		return "arm";
	else
		return "unknown";
}

static void
fpon(void)
{
	int gotfp, impl;
	ulong acc, scr;

	gotfp = 1 &lt;&lt; CpFP | 1 &lt;&lt; CpDFP;
	cpwrsc(0, CpCONTROL, 0, CpCPaccess, MASK(28));
	acc = cprdsc(0, CpCONTROL, 0, CpCPaccess);
	if ((acc &amp; (MASK(2) &lt;&lt; (2*CpFP))) == 0) {
		gotfp &amp;= ~(1 &lt;&lt; CpFP);
		print("fpon: no single FP coprocessor\n");
	}
	if ((acc &amp; (MASK(2) &lt;&lt; (2*CpDFP))) == 0) {
		gotfp &amp;= ~(1 &lt;&lt; CpDFP);
		print("fpon: no double FP coprocessor\n");
	}
	if (!gotfp) {
		print("fpon: no FP coprocessors\n");
		return;
	}

	/* enable fp.  must be first operation on the FPUs. */
	fpwr(Fpexc, fprd(Fpexc) | 1 &lt;&lt; 30);

	scr = fprd(Fpsid);
	impl = scr &gt;&gt; 24;
	print("fp: %s arch %s", implement(impl),
		subarch(impl, (scr &gt;&gt; 16) &amp; MASK(7)));

	scr = fprd(Fpscr);
	// TODO configure Fpscr further
	scr |= 1 &lt;&lt; 9;					/* div-by-0 exception */
	scr &amp;= ~(MASK(2) &lt;&lt; 20 | MASK(3) &lt;&lt; 16);	/* all ops are scalar */
	fpwr(Fpscr, scr);
	print("\n");
	/* we should now be able to execute VFP-style FP instr'ns natively */
}

static void
resetusb(void)
{
	int bound;
	Uhh *uhh;
	Usbotg *otg;
	Usbtll *tll;

	iprint("resetting usb: otg...");
	otg = (Usbotg *)PHYSUSBOTG;
	otg-&gt;otgsyscfg = Softreset;	/* see omap35x errata 3.1.1.144 */
	coherence();
	resetwait(&amp;otg-&gt;otgsyssts);
	otg-&gt;otgsyscfg |= Sidle | Midle;
	coherence();

	iprint("uhh...");
	uhh = (Uhh *)PHYSUHH;
	uhh-&gt;sysconfig |= Softreset;
	coherence();
	resetwait(&amp;uhh-&gt;sysstatus);
	for (bound = 400*Mhz; !(uhh-&gt;sysstatus &amp; Resetdone) &amp;&amp; bound &gt; 0;
	    bound--)
		;
	uhh-&gt;sysconfig |= Sidle | Midle;

	/*
	 * using the TLL seems to be an optimisation when talking
	 * to another identical SoC, thus not very useful, so
	 * force PHY (ULPI) mode.
	 */
	/* this bit is normally off when we get here */
	uhh-&gt;hostconfig &amp;= ~P1ulpi_bypass;
	coherence();
	if (uhh-&gt;hostconfig &amp; P1ulpi_bypass)
		iprint("utmi (tll) mode...");	/* via tll */
	else
		/* external transceiver (phy), no tll */
		iprint("ulpi (phy) mode...");

	tll = (Usbtll *)PHYSUSBTLL;
	if (probeaddr(PHYSUSBTLL) &gt;= 0) {
		iprint("tll...");
		tll-&gt;sysconfig |= Softreset;
		coherence();
		resetwait(&amp;tll-&gt;sysstatus);
		tll-&gt;sysconfig |= Sidle;
		coherence();
	} else
		iprint("no tll...");
	iprint("\n");
}

/*
 * there are secure sdrc registers at 0x48002460
 * sdrc regs at PHYSSDRC; see spruf98c §1.2.8.2.
 * set or dump l4 prot regs at PHYSL4?
 */
void
archreset(void)
{
	static int beenhere;

	if (beenhere)
		return;
	beenhere = 1;

	/* conservative temporary values until archconfinit runs */
	m-&gt;cpuhz = 500 * Mhz;			/* beagle speed */
	m-&gt;delayloop = m-&gt;cpuhz/2000;		/* initial estimate */

//	dumpl3pr();
	prcachecfg();
	/* fight omap35x errata 2.0.1.104 */
	memset((void *)PHYSSWBOOTCFG, 0, 240);
	coherence();

	setpadmodes();
	configclks();			/* may change cpu speed */
	configgpio();

	archconfinit();

	resetusb();
	fpon();
}

void
archreboot(void)
{
	Prm *prm = (Prm *)PHYSPRMGLBL;

	iprint("archreboot: reset!\n");
	delay(20);

	prm-&gt;rstctrl |= Rstgs;
	coherence();
	delay(500);

	/* shouldn't get here */
	splhi();
	iprint("awaiting reset");
	for(;;) {
		delay(1000);
		print(".");
	}
}

void
kbdinit(void)
{
}

void
lastresortprint(char *buf, long bp)
{
	iprint("%.*s", (int)bp, buf);	/* nothing else seems to work */
}

static void
scmdump(ulong addr, int shorts)
{
	ushort reg;
	ushort *ptr;

	ptr = (ushort *)addr;
	print("scm regs:\n");
	while (shorts-- &gt; 0) {
		reg = *ptr++;
		print("%#p: %#ux\tinputenable %d pulltypeselect %d "
			"pulludenable %d muxmode %d\n",
			ptr, reg, (reg&gt;&gt;8) &amp; 1, (reg&gt;&gt;4) &amp; 1, (reg&gt;&gt;3) &amp; 1,
			reg &amp; 7);
	}
}

char *cputype2name(char *buf, int size);

void
cpuidprint(void)
{
	char name[64];

	cputype2name(name, sizeof name);
	delay(250);				/* let uart catch up */
	iprint("cpu%d: %lldMHz ARM %s\n", m-&gt;machno, m-&gt;cpuhz / Mhz, name);
}

static void
missing(ulong addr, char *name)
{
	static int firstmiss = 1;

	if (probeaddr(addr) &gt;= 0)
		return;
	if (firstmiss) {
		iprint("missing:");
		firstmiss = 0;
	} else
		iprint(",\n\t");
	iprint(" %s at %#lux", name, addr);
}

/* verify that all the necessary device registers are accessible */
void
chkmissing(void)
{
	delay(20);
	missing(PHYSSCM, "scm");
	missing(KZERO, "dram");
	missing(PHYSL3, "l3 config");
	missing(PHYSINTC, "intr ctlr");
	missing(PHYSTIMER1, "timer1");
	missing(PHYSCONS, "console uart2");
	missing(PHYSUART0, "uart0");
	missing(PHYSUART1, "uart1");
	missing(PHYSETHER, "smc9221");		/* not on beagle */
	missing(PHYSUSBOTG, "usb otg");
	missing(PHYSUHH, "usb uhh");
	missing(PHYSOHCI, "usb ohci");
	missing(PHYSEHCI, "usb ehci");
	missing(PHYSSDMA, "dma");
	missing(PHYSWDOG, "watchdog timer");
	missing(PHYSUSBTLL, "usb tll");
	iprint("\n");
	delay(20);
}

void
archflashwp(Flash*, int)
{
}

/*
 * for ../port/devflash.c:/^flashreset
 * retrieve flash type, virtual base and length and return 0;
 * return -1 on error (no flash)
 */
int
archflashreset(int bank, Flash *f)
{
	if(bank != 0)
		return -1;
	/*
	 * this is set up for the igepv2 board.
	 * if the beagleboard ever works, we'll have to sort this out.
	 */
	f-&gt;type = "onenand";
	f-&gt;addr = (void*)PHYSNAND;		/* mapped here by archreset */
	f-&gt;size = 0;				/* done by probe */
	f-&gt;width = 1;
	f-&gt;interleave = 0;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

