<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/omap/syscall.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/omap/syscall.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "../port/systab.h"

#include &lt;tos.h&gt;
#include "ureg.h"

#include "arm.h"

typedef struct {
	uintptr	ip;
	Ureg*	arg0;
	char*	arg1;
	char	msg[ERRMAX];
	Ureg*	old;
	Ureg	ureg;
} NFrame;

/*
 *   Return user to state before notify()
 */
static void
noted(Ureg* cur, uintptr arg0)
{
	NFrame *nf;
	Ureg *nur;

	qlock(&amp;up-&gt;debug);
	if(arg0 != NRSTR &amp;&amp; !up-&gt;notified){
		qunlock(&amp;up-&gt;debug);
		pprint("call to noted() when not notified\n");
		pexit("Suicide", 0);
	}
	up-&gt;notified = 0;
	fpunoted();

	nf = up-&gt;ureg;

	/* sanity clause */
	if(!okaddr(PTR2UINT(nf), sizeof(NFrame), 0)){
		qunlock(&amp;up-&gt;debug);
		pprint("bad ureg in noted %#p\n", nf);
		pexit("Suicide", 0);
	}

	/* don't let user change system flags */
	nur = &amp;nf-&gt;ureg;
	nur-&gt;psr &amp;= PsrMask|PsrDfiq|PsrDirq;
	nur-&gt;psr |= (cur-&gt;psr &amp; ~(PsrMask|PsrDfiq|PsrDirq));

	memmove(cur, nur, sizeof(Ureg));

	switch((int)arg0){
	case NCONT:
	case NRSTR:
		if(!okaddr(nur-&gt;pc, BY2WD, 0) || !okaddr(nur-&gt;sp, BY2WD, 0)){
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: trap in noted\n");
			pexit("Suicide", 0);
		}
		up-&gt;ureg = nf-&gt;old;
		qunlock(&amp;up-&gt;debug);
		break;
	case NSAVE:
		if(!okaddr(nur-&gt;pc, BY2WD, 0) || !okaddr(nur-&gt;sp, BY2WD, 0)){
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: trap in noted\n");
			pexit("Suicide", 0);
		}
		qunlock(&amp;up-&gt;debug);

		splhi();
		nf-&gt;arg1 = nf-&gt;msg;
		nf-&gt;arg0 = &amp;nf-&gt;ureg;
		nf-&gt;ip = 0;
		cur-&gt;sp = PTR2UINT(nf);
		cur-&gt;r0 = PTR2UINT(nf-&gt;arg0);
		break;
	default:
		pprint("unknown noted arg %#p\n", arg0);
		up-&gt;lastnote.flag = NDebug;
		/*FALLTHROUGH*/
	case NDFLT:
		if(up-&gt;lastnote.flag == NDebug){ 
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: %s\n", up-&gt;lastnote.msg);
		}
		else
			qunlock(&amp;up-&gt;debug);
		pexit(up-&gt;lastnote.msg, up-&gt;lastnote.flag != NDebug);
	}
}

/*
 *  Call user, if necessary, with note.
 *  Pass user the Ureg struct and the note on his stack.
 */
int
notify(Ureg* ureg)
{
	int l;
	Note *n;
	u32int s;
	uintptr sp;
	NFrame *nf;

	if(up-&gt;procctl)
		procctl(up);
	if(up-&gt;nnote == 0)
		return 0;

	fpunotify(ureg);

	s = spllo();
	qlock(&amp;up-&gt;debug);

	up-&gt;notepending = 0;
	n = &amp;up-&gt;note[0];
	if(strncmp(n-&gt;msg, "sys:", 4) == 0){
		l = strlen(n-&gt;msg);
		if(l &gt; ERRMAX-23)	/* " pc=0x0123456789abcdef\0" */
			l = ERRMAX-23;
		snprint(n-&gt;msg + l, sizeof n-&gt;msg - l, " pc=%#lux", ureg-&gt;pc);
	}

	if(n-&gt;flag != NUser &amp;&amp; (up-&gt;notified || up-&gt;notify == 0)){
		if(n-&gt;flag == NDebug)
			pprint("suicide: %s\n", n-&gt;msg);
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag != NDebug);
	}

	if(up-&gt;notified){
		qunlock(&amp;up-&gt;debug);
		splhi();
		return 0;
	}
		
	if(up-&gt;notify == nil){
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag != NDebug);
	}
	if(!okaddr(PTR2UINT(up-&gt;notify), 1, 0)){
		pprint("suicide: notify function address %#p\n", up-&gt;notify);
		qunlock(&amp;up-&gt;debug);
		pexit("Suicide", 0);
	}

	sp = ureg-&gt;sp - sizeof(NFrame);
	if(!okaddr(sp, sizeof(NFrame), 1)){
		qunlock(&amp;up-&gt;debug);
		pprint("suicide: notify stack address %#p\n", sp);
		pexit("Suicide", 0);
	}

	nf = UINT2PTR(sp);
	memmove(&amp;nf-&gt;ureg, ureg, sizeof(Ureg));
	nf-&gt;old = up-&gt;ureg;
	up-&gt;ureg = nf;
	memmove(nf-&gt;msg, up-&gt;note[0].msg, ERRMAX);
	nf-&gt;arg1 = nf-&gt;msg;
	nf-&gt;arg0 = &amp;nf-&gt;ureg;
	ureg-&gt;r0 = PTR2UINT(nf-&gt;arg0);
	nf-&gt;ip = 0;

	ureg-&gt;sp = sp;
	ureg-&gt;pc = PTR2UINT(up-&gt;notify);
	up-&gt;notified = 1;
	up-&gt;nnote--;
	memmove(&amp;up-&gt;lastnote, &amp;up-&gt;note[0], sizeof(Note));
	memmove(&amp;up-&gt;note[0], &amp;up-&gt;note[1], up-&gt;nnote*sizeof(Note));

	qunlock(&amp;up-&gt;debug);
	splx(s);

	return 1;
}

void
syscall(Ureg* ureg)
{
	char *e;
	u32int s;
	ulong sp;
	long ret;
	int i, scallnr;

	if(!userureg(ureg))
		panic("syscall: from kernel: pc %#lux r14 %#lux psr %#lux",
			ureg-&gt;pc, ureg-&gt;r14, ureg-&gt;psr);

	cycles(&amp;up-&gt;kentry);

	m-&gt;syscall++;
	up-&gt;insyscall = 1;
	up-&gt;pc = ureg-&gt;pc;
	up-&gt;dbgreg = ureg;

	if(up-&gt;procctl == Proc_tracesyscall){
		up-&gt;procctl = Proc_stopme;
		procctl(up);
	}

	scallnr = ureg-&gt;r0;
	up-&gt;scallnr = scallnr;
	if(scallnr == RFORK)
		fpusysrfork(ureg);
	spllo();

	sp = ureg-&gt;sp;
	up-&gt;nerrlab = 0;
	ret = -1;
	if(!waserror()){
		if(scallnr &gt;= nsyscall){
			pprint("bad sys call number %d pc %#lux\n",
				scallnr, ureg-&gt;pc);
			postnote(up, 1, "sys: bad sys call", NDebug);
			error(Ebadarg);
		}

		if(sp &lt; (USTKTOP-BY2PG) || sp &gt; (USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		up-&gt;s = *((Sargs*)(sp+BY2WD));
		up-&gt;psstate = sysctab[scallnr];

	/*	iprint("%s: syscall %s\n", up-&gt;text, sysctab[scallnr]?sysctab[scallnr]:"huh?"); */

		ret = systab[scallnr](up-&gt;s.args);
		poperror();
	}else{
		/* failure: save the error buffer for errstr */
		e = up-&gt;syserrstr;
		up-&gt;syserrstr = up-&gt;errstr;
		up-&gt;errstr = e;
	}
	if(up-&gt;nerrlab){
		print("bad errstack [%d]: %d extra\n", scallnr, up-&gt;nerrlab);
		for(i = 0; i &lt; NERR; i++)
			print("sp=%#p pc=%#p\n",
				up-&gt;errlab[i].sp, up-&gt;errlab[i].pc);
		panic("error stack");
	}

	/*
	 *  Put return value in frame.  On the x86 the syscall is
	 *  just another trap and the return value from syscall is
	 *  ignored.  On other machines the return value is put into
	 *  the results register by caller of syscall.
	 */
	ureg-&gt;r0 = ret;

	if(up-&gt;procctl == Proc_tracesyscall){
		up-&gt;procctl = Proc_stopme;
		s = splhi();
		procctl(up);
		splx(s);
	}

	up-&gt;insyscall = 0;
	up-&gt;psstate = 0;

	if(scallnr == NOTED)
		noted(ureg, *(ulong*)(sp+BY2WD));

	splhi();
	if(scallnr != RFORK &amp;&amp; (up-&gt;procctl || up-&gt;nnote))
		notify(ureg);

	/* if we delayed sched because we held a lock, sched now */
	if(up-&gt;delaysched){
		sched();
		splhi();
	}
	kexit(ureg);
}

long	/* void* */
execregs(ulong entry, ulong ssize, ulong nargs)
{
	ulong *sp;
	Ureg *ureg;

	sp = (ulong*)(USTKTOP - ssize);
	*--sp = nargs;

	ureg = up-&gt;dbgreg;
//	memset(ureg, 0, 15*sizeof(ulong));
	ureg-&gt;r13 = (ulong)sp;
	ureg-&gt;pc = entry;
//print("%lud: EXECREGS pc %#ux sp %#ux nargs %ld\n", up-&gt;pid, ureg-&gt;pc, ureg-&gt;r13, nargs);

	/*
	 * return the address of kernel/user shared data
	 * (e.g. clock stuff)
	 */
	return USTKTOP-sizeof(Tos);
}

void
sysprocsetup(Proc* p)
{
	fpusysprocsetup(p);
}

/* 
 *  Craft a return frame which will cause the child to pop out of
 *  the scheduler in user mode with the return register zero.  Set
 *  pc to point to a l.s return function.
 */
void
forkchild(Proc *p, Ureg *ureg)
{
	Ureg *cureg;

//print("%lud setting up for forking child %lud\n", up-&gt;pid, p-&gt;pid);
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-sizeof(Ureg);
	p-&gt;sched.pc = (ulong)forkret;

	cureg = (Ureg*)(p-&gt;sched.sp);
	memmove(cureg, ureg, sizeof(Ureg));

	/* syscall returns 0 for child */
	cureg-&gt;r0 = 0;

	/* Things from bottom of syscall which were never executed */
	p-&gt;psstate = 0;
	p-&gt;insyscall = 0;

	fpusysrforkchild(p, cureg, up);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

