<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/devfloppy.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/devfloppy.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"

#include	"floppy.h"

/* Intel 82077A (8272A compatible) floppy controller */

/* This module expects the following functions to be defined
 * elsewhere: 
 * 
 * inb()
 * outb()
 * floppyexec()
 * floppyeject() 
 * floppysetup0()
 * floppysetup1()
 * dmainit()
 * dmasetup()
 * dmaend()
 * 
 * On DMA systems, floppyexec() should be an empty function; 
 * on non-DMA systems, dmaend() should be an empty function; 
 * dmasetup() may enforce maximum transfer sizes. 
 */

enum {
	/* file types */
	Qdir=		0, 
	Qdata=		(1&lt;&lt;2),
	Qctl=		(2&lt;&lt;2),
	Qmask=		(3&lt;&lt;2),

	DMAchan=	2,	/* floppy dma channel */
};

#define DPRINT if(floppydebug)print
int floppydebug = 0;

/*
 *  types of drive (from PC equipment byte)
 */
enum
{
	Tnone=		0,
	T360kb=		1,
	T1200kb=	2,
	T720kb=		3,
	T1440kb=	4,
};

FType floppytype[] =
{
 { "3½HD",	T1440kb, 512, 18, 2, 1, 80, 0x1B, 0x54,	0, },
 { "3½DD",	T1440kb, 512,  9, 2, 1, 80, 0x1B, 0x54, 2, },
 { "3½DD",	T720kb,  512,  9, 2, 1, 80, 0x1B, 0x54, 2, },
 { "5¼HD",	T1200kb, 512, 15, 2, 1, 80, 0x2A, 0x50, 0, },
 { "5¼DD",	T1200kb, 512,  9, 2, 2, 40, 0x2A, 0x50, 1, },
 { "ATT3B1",	T1200kb, 512,  8, 2, 2, 48, 0x2A, 0x50, 1, },
 { "5¼DD",	T360kb,  512,  9, 2, 1, 40, 0x2A, 0x50, 2, },
};

/*
 *  bytes per sector encoding for the controller.
 *  - index for b2c is is (bytes per sector/128).
 *  - index for c2b is code from b2c
 */
static int b2c[] =
{
[1]	0,
[2]	1,
[4]	2,
[8]	3,
};
static int c2b[] =
{
	128,
	256,
	512,
	1024,
};

FController	fl;

#define MOTORBIT(i)	(1&lt;&lt;((i)+4))

/*
 *  predeclared
 */
static int	cmddone(void*);
static void	floppyformat(FDrive*, Cmdbuf*);
static void	floppykproc(void*);
static void	floppypos(FDrive*,long);
static int	floppyrecal(FDrive*);
static int	floppyresult(void);
static void	floppyrevive(void);
static long	floppyseek(FDrive*, long);
static int	floppysense(void);
static void	floppywait(int);
static long	floppyxfer(FDrive*, int, void*, long, long);

Dirtab floppydir[]={
	".",		{Qdir, 0, QTDIR},	0,	0550,
	"fd0disk",		{Qdata + 0},	0,	0660,
	"fd0ctl",		{Qctl + 0},	0,	0660,
	"fd1disk",		{Qdata + 1},	0,	0660,
	"fd1ctl",		{Qctl + 1},	0,	0660,
	"fd2disk",		{Qdata + 2},	0,	0660,
	"fd2ctl",		{Qctl + 2},	0,	0660,
	"fd3disk",		{Qdata + 3},	0,	0660,
	"fd3ctl",		{Qctl + 3},	0,	0660,
};
#define NFDIR	2	/* directory entries/drive */

enum
{
	CMdebug,
	CMnodebug,
	CMeject,
	CMformat,
	CMreset,
};

static Cmdtab floppyctlmsg[] =
{
	CMdebug,	"debug",	1,
	CMnodebug,	"nodebug", 1,
	CMeject,	"eject",	1,
	CMformat,	"format",	0,
	CMreset,	"reset",	1,
};

static void
fldump(void)
{
	DPRINT("sra %ux srb %ux dor %ux msr %ux dir %ux\n", inb(Psra), inb(Psrb),
		inb(Pdor), inb(Pmsr), inb(Pdir));
}

/*
 *  set floppy drive to its default type
 */
static void
floppysetdef(FDrive *dp)
{
	FType *t;

	for(t = floppytype; t &lt; &amp;floppytype[nelem(floppytype)]; t++)
		if(dp-&gt;dt == t-&gt;dt){
			dp-&gt;t = t;
			floppydir[1+NFDIR*dp-&gt;dev].length = dp-&gt;t-&gt;cap;
			break;
		}
}

static void
floppyreset(void)
{
	FDrive *dp;
	FType *t;
	ulong maxtsize;
	
	floppysetup0(&amp;fl);
	if(fl.ndrive == 0)
		return;

	/*
	 *  init dependent parameters
	 */
	maxtsize = 0;
	for(t = floppytype; t &lt; &amp;floppytype[nelem(floppytype)]; t++){
		t-&gt;cap = t-&gt;bytes * t-&gt;heads * t-&gt;sectors * t-&gt;tracks;
		t-&gt;bcode = b2c[t-&gt;bytes/128];
		t-&gt;tsize = t-&gt;bytes * t-&gt;sectors;
		if(maxtsize &lt; t-&gt;tsize)
			maxtsize = t-&gt;tsize;
	}

	/*
	 * Should check if this fails. Can do so
	 * if there is no space &lt;= 16MB for the DMA
	 * bounce buffer.
	 */
	dmainit(DMAchan, maxtsize);

	/*
	 *  allocate the drive storage
	 */
	fl.d = xalloc(fl.ndrive*sizeof(FDrive));
	fl.selected = fl.d;

	/*
	 *  stop the motors
	 */
	fl.motor = 0;
	delay(10);
	outb(Pdor, fl.motor | Fintena | Fena);
	delay(10);

	/*
	 *  init drives
	 */
	for(dp = fl.d; dp &lt; &amp;fl.d[fl.ndrive]; dp++){
		dp-&gt;dev = dp - fl.d;
		dp-&gt;dt = T1440kb;
		floppysetdef(dp);
		dp-&gt;cyl = -1;			/* because we don't know */
		dp-&gt;cache = (uchar*)xspanalloc(maxtsize, BY2PG, 64*1024);
		dp-&gt;ccyl = -1;
		dp-&gt;vers = 0;
	}

	/*
	 *  first operation will recalibrate
	 */
	fl.confused = 1;

	floppysetup1(&amp;fl);
}

static Chan*
floppyattach(char *spec)
{
	static int kstarted;

	if(fl.ndrive == 0)
		error(Enodev);

	if(kstarted == 0){
		/*
		 *  watchdog to turn off the motors
		 */
		kstarted = 1;
		kproc("floppy", floppykproc, 0);
	}
	return devattach('f', spec);
}

static Walkqid*
floppywalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, floppydir, 1+fl.ndrive*NFDIR, devgen);
}

static int
floppystat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, floppydir, 1+fl.ndrive*NFDIR, devgen);
}

static Chan*
floppyopen(Chan *c, int omode)
{
	return devopen(c, omode, floppydir, 1+fl.ndrive*NFDIR, devgen);
}

static void
floppyclose(Chan *)
{
}

static void
islegal(ulong offset, long n, FDrive *dp)
{
	if(offset % dp-&gt;t-&gt;bytes)
		error(Ebadarg);
	if(n % dp-&gt;t-&gt;bytes)
		error(Ebadarg);
}

/*
 *  check if the floppy has been replaced under foot.  cause
 *  an error if it has.
 *
 *  a seek and a read clears the condition.  this was determined
 *  experimentally, there has to be a better way.
 *
 *  if the read fails, cycle through the possible floppy
 *  density till one works or we've cycled through all
 *  possibilities for this drive.
 */
static void
changed(Chan *c, FDrive *dp)
{
	ulong old;
	FType *start;

	/*
	 *  if floppy has changed or first time through
	 */
	if((inb(Pdir)&amp;Fchange) || dp-&gt;vers == 0){
		DPRINT("changed\n");
		fldump();
		dp-&gt;vers++;
		start = dp-&gt;t;
		dp-&gt;maxtries = 3;	/* limit it when we're probing */

		/* floppyon will fail if there's a controller but no drive */
		dp-&gt;confused = 1;	/* make floppyon recal */
		if(floppyon(dp) &lt; 0)
			error(Eio);

		/* seek to the first track */
		floppyseek(dp, dp-&gt;t-&gt;heads*dp-&gt;t-&gt;tsize);
		while(waserror()){
			/*
			 *  if first attempt doesn't reset changed bit, there's
			 *  no floppy there
			 */
			if(inb(Pdir)&amp;Fchange)
				nexterror();

			while(++dp-&gt;t){
				if(dp-&gt;t == &amp;floppytype[nelem(floppytype)])
					dp-&gt;t = floppytype;
				if(dp-&gt;dt == dp-&gt;t-&gt;dt)
					break;
			}
			floppydir[1+NFDIR*dp-&gt;dev].length = dp-&gt;t-&gt;cap;

			/* floppyon will fail if there's a controller but no drive */
			if(floppyon(dp) &lt; 0)
				error(Eio);

			DPRINT("changed: trying %s\n", dp-&gt;t-&gt;name);
			fldump();
			if(dp-&gt;t == start)
				nexterror();
		}

		/* if the read succeeds, we've got the density right */
		floppyxfer(dp, Fread, dp-&gt;cache, 0, dp-&gt;t-&gt;tsize);
		poperror();
		dp-&gt;maxtries = 20;
	}

	old = c-&gt;qid.vers;
	c-&gt;qid.vers = dp-&gt;vers;
	if(old &amp;&amp; old != dp-&gt;vers)
		error(Eio);
}

static int
readtrack(FDrive *dp, int cyl, int head)
{
	int i, nn, sofar;
	ulong pos;

	nn = dp-&gt;t-&gt;tsize;
	if(dp-&gt;ccyl==cyl &amp;&amp; dp-&gt;chead==head)
		return nn;
	pos = (cyl*dp-&gt;t-&gt;heads+head) * nn;
	for(sofar = 0; sofar &lt; nn; sofar += i){
		dp-&gt;ccyl = -1;
		i = floppyxfer(dp, Fread, dp-&gt;cache + sofar, pos + sofar, nn - sofar);
		if(i &lt;= 0)
			return -1;
	}
	dp-&gt;ccyl = cyl;
	dp-&gt;chead = head;
	return nn;
}

static long
floppyread(Chan *c, void *a, long n, vlong off)
{
	FDrive *dp;
	long rv;
	int sec, head, cyl;
	long len;
	uchar *aa;
	ulong offset = off;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, floppydir, 1+fl.ndrive*NFDIR, devgen);

	rv = 0;
	dp = &amp;fl.d[c-&gt;qid.path &amp; ~Qmask];
	switch ((int)(c-&gt;qid.path &amp; Qmask)) {
	case Qdata:
		islegal(offset, n, dp);
		aa = a;

		qlock(&amp;fl);
		if(waserror()){
			qunlock(&amp;fl);
			nexterror();
		}
		floppyon(dp);
		changed(c, dp);
		for(rv = 0; rv &lt; n; rv += len){
			/*
			 *  all xfers come out of the track cache
			 */
			dp-&gt;len = n - rv;
			floppypos(dp, offset+rv);
			cyl = dp-&gt;tcyl;
			head = dp-&gt;thead;
			len = dp-&gt;len;
			sec = dp-&gt;tsec;
			if(readtrack(dp, cyl, head) &lt; 0)
				break;
			memmove(aa+rv, dp-&gt;cache + (sec-1)*dp-&gt;t-&gt;bytes, len);
		}
		qunlock(&amp;fl);
		poperror();

		break;
	case Qctl:
		return readstr(offset, a, n, dp-&gt;t-&gt;name);
	default:
		panic("floppyread: bad qid");
	}

	return rv;
}

static long
floppywrite(Chan *c, void *a, long n, vlong off)
{
	FDrive *dp;
	long rv, i;
	char *aa = a;
	Cmdbuf *cb;
	Cmdtab *ct;
	ulong offset = off;

	rv = 0;
	dp = &amp;fl.d[c-&gt;qid.path &amp; ~Qmask];
	switch ((int)(c-&gt;qid.path &amp; Qmask)) {
	case Qdata:
		islegal(offset, n, dp);
		qlock(&amp;fl);
		if(waserror()){
			qunlock(&amp;fl);
			nexterror();
		}
		floppyon(dp);
		changed(c, dp);
		for(rv = 0; rv &lt; n; rv += i){
			floppypos(dp, offset+rv);
			if(dp-&gt;tcyl == dp-&gt;ccyl)
				dp-&gt;ccyl = -1;
			i = floppyxfer(dp, Fwrite, aa+rv, offset+rv, n-rv);
			if(i &lt; 0)
				break;
			if(i == 0)
				error(Eio);
		}
		qunlock(&amp;fl);
		poperror();
		break;
	case Qctl:
		rv = n;
		cb = parsecmd(a, n);
		if(waserror()){
			free(cb);
			nexterror();
		}
		qlock(&amp;fl);
		if(waserror()){
			qunlock(&amp;fl);
			nexterror();
		}
		ct = lookupcmd(cb, floppyctlmsg, nelem(floppyctlmsg));
		switch(ct-&gt;index){
		case CMeject:
			floppyeject(dp);
			break;
		case CMformat:
			floppyformat(dp, cb);
			break;
		case CMreset:
			fl.confused = 1;
			floppyon(dp);
			break;
		case CMdebug:
			floppydebug = 1;
			break;
		case CMnodebug:
			floppydebug = 0;
			break;
		}
		poperror();
		qunlock(&amp;fl);
		poperror();
		free(cb);
		break;
	default:
		panic("floppywrite: bad qid");
	}

	return rv;
}

static void
floppykproc(void *)
{
	FDrive *dp;

	while(waserror())
		;
	for(;;){
		for(dp = fl.d; dp &lt; &amp;fl.d[fl.ndrive]; dp++){
			if((fl.motor&amp;MOTORBIT(dp-&gt;dev))
			&amp;&amp; TK2SEC(m-&gt;ticks - dp-&gt;lasttouched) &gt; 5
			&amp;&amp; canqlock(&amp;fl)){
				if(TK2SEC(m-&gt;ticks - dp-&gt;lasttouched) &gt; 5)
					floppyoff(dp);
				qunlock(&amp;fl);
			}
		}
		tsleep(&amp;up-&gt;sleep, return0, 0, 1000);
	}
}

/*
 *  start a floppy drive's motor.
 */
static int
floppyon(FDrive *dp)
{
	int alreadyon;
	int tries;

	if(fl.confused)
		floppyrevive();

	/* start motor and select drive */
	alreadyon = fl.motor &amp; MOTORBIT(dp-&gt;dev);
	fl.motor |= MOTORBIT(dp-&gt;dev);
	outb(Pdor, fl.motor | Fintena | Fena | dp-&gt;dev);
	if(!alreadyon){
		/* wait for drive to spin up */
		tsleep(&amp;up-&gt;sleep, return0, 0, 750);

		/* clear any pending interrupts */
		floppysense();
	}

	/* set transfer rate */
	if(fl.rate != dp-&gt;t-&gt;rate){
		fl.rate = dp-&gt;t-&gt;rate;
		outb(Pdsr, fl.rate);
	}

	/* get drive to a known cylinder */
	if(dp-&gt;confused)
		for(tries = 0; tries &lt; 4; tries++)
			if(floppyrecal(dp) &gt;= 0)
				break;
	dp-&gt;lasttouched = m-&gt;ticks;
	fl.selected = dp;

	/* return -1 if this didn't work */
	if(dp-&gt;confused)
		return -1;
	return 0;
}

/*
 *  stop the floppy if it hasn't been used in 5 seconds
 */
static void
floppyoff(FDrive *dp)
{
	fl.motor &amp;= ~MOTORBIT(dp-&gt;dev);
	outb(Pdor, fl.motor | Fintena | Fena | dp-&gt;dev);
}

/*
 *  send a command to the floppy
 */
static int
floppycmd(void)
{
	int i;
	int tries;

	fl.nstat = 0;
	for(i = 0; i &lt; fl.ncmd; i++){
		for(tries = 0; ; tries++){
			if((inb(Pmsr)&amp;(Ffrom|Fready)) == Fready)
				break;
			if(tries &gt; 1000){
				DPRINT("cmd %ux can't be sent (%d)\n", fl.cmd[0], i);
				fldump();

				/* empty fifo, might have been a bad command */
				floppyresult();
				return -1;
			}
			microdelay(8);	/* for machine independence */
		}
		outb(Pfdata, fl.cmd[i]);
	}
	return 0;
}

/*
 *  get a command result from the floppy
 *
 *  when the controller goes ready waiting for a command
 *  (instead of sending results), we're done
 * 
 */
static int
floppyresult(void)
{
	int i, s;
	int tries;

	/* get the result of the operation */
	for(i = 0; i &lt; sizeof(fl.stat); i++){
		/* wait for status byte */
		for(tries = 0; ; tries++){
			s = inb(Pmsr)&amp;(Ffrom|Fready);
			if(s == Fready){
				fl.nstat = i;
				return fl.nstat;
			}
			if(s == (Ffrom|Fready))
				break;
			if(tries &gt; 1000){
				DPRINT("floppyresult: %d stats\n", i);
				fldump();
				fl.confused = 1;
				return -1;
			}
			microdelay(8);	/* for machine independence */
		}
		fl.stat[i] = inb(Pfdata);
	}
	fl.nstat = sizeof(fl.stat);
	return fl.nstat;
}

/*
 *  calculate physical address of a logical byte offset into the disk
 *
 *  truncate dp-&gt;length if it crosses a track boundary
 */
static void
floppypos(FDrive *dp, long off)
{
	int lsec;
	int ltrack;
	int end;

	lsec = off/dp-&gt;t-&gt;bytes;
	ltrack = lsec/dp-&gt;t-&gt;sectors;
	dp-&gt;tcyl = ltrack/dp-&gt;t-&gt;heads;
	dp-&gt;tsec = (lsec % dp-&gt;t-&gt;sectors) + 1;
	dp-&gt;thead = (lsec/dp-&gt;t-&gt;sectors) % dp-&gt;t-&gt;heads;

	/*
	 *  can't read across track boundaries.
	 *  if so, decrement the bytes to be read.
	 */
	end = (ltrack+1)*dp-&gt;t-&gt;sectors*dp-&gt;t-&gt;bytes;
	if(off+dp-&gt;len &gt; end)
		dp-&gt;len = end - off;
}

/*
 *  get the interrupt cause from the floppy.
 */
static int
floppysense(void)
{
	fl.ncmd = 0;
	fl.cmd[fl.ncmd++] = Fsense;
	if(floppycmd() &lt; 0)
		return -1;
	if(floppyresult() &lt; 2){
		DPRINT("can't read sense response\n");
		fldump();
		fl.confused = 1;
		return -1;
	}
	return 0;
}

static int
cmddone(void *)
{
	return fl.ncmd == 0;
}

/*
 *  Wait for a floppy interrupt.  If none occurs in 5 seconds, we
 *  may have missed one.  This only happens on some portables which
 *  do power management behind our backs.  Call the interrupt
 *  routine to try to clear any conditions.
 */
static void
floppywait(int slow)
{
	tsleep(&amp;fl.r, cmddone, 0, slow ? 5000 : 1000);
	if(!cmddone(0)){
		floppyintr(0);
		fl.confused = 1;
	}
}

/*
 *  we've lost the floppy position, go to cylinder 0.
 */
static int
floppyrecal(FDrive *dp)
{
	dp-&gt;ccyl = -1;
	dp-&gt;cyl = -1;

	fl.ncmd = 0;
	fl.cmd[fl.ncmd++] = Frecal;
	fl.cmd[fl.ncmd++] = dp-&gt;dev;
	if(floppycmd() &lt; 0)
		return -1;
	floppywait(1);
	if(fl.nstat &lt; 2){
		DPRINT("recalibrate: confused %ux\n", inb(Pmsr));
		fl.confused = 1;
		return -1;
	}
	if((fl.stat[0] &amp; (Codemask|Seekend)) != Seekend){
		DPRINT("recalibrate: failed\n");
		dp-&gt;confused = 1;
		return -1;
	}
	dp-&gt;cyl = fl.stat[1];
	if(dp-&gt;cyl != 0){
		DPRINT("recalibrate: wrong cylinder %d\n", dp-&gt;cyl);
		dp-&gt;cyl = -1;
		dp-&gt;confused = 1;
		return -1;
	}

	dp-&gt;confused = 0;
	return 0;
}

/*
 *  if the controller or a specific drive is in a confused state,
 *  reset it and get back to a known state
 */
static void
floppyrevive(void)
{
	FDrive *dp;

	/*
	 *  reset the controller if it's confused
	 */
	if(fl.confused){
		DPRINT("floppyrevive in\n");
		fldump();

		/* reset controller and turn all motors off */
		splhi();
		fl.ncmd = 1;
		fl.cmd[0] = 0;
		outb(Pdor, 0);
		delay(10);
		outb(Pdor, Fintena|Fena);
		delay(10);
		spllo();
		fl.motor = 0;
		fl.confused = 0;
		floppywait(0);

		/* mark all drives in an unknown state */
		for(dp = fl.d; dp &lt; &amp;fl.d[fl.ndrive]; dp++)
			dp-&gt;confused = 1;

		/* set rate to a known value */
		outb(Pdsr, 0);
		fl.rate = 0;

		DPRINT("floppyrevive out\n");
		fldump();
	}
}

/*
 *  seek to the target cylinder
 *
 *	interrupt, no results
 */
static long
floppyseek(FDrive *dp, long off)
{
	floppypos(dp, off);
	if(dp-&gt;cyl == dp-&gt;tcyl)
		return dp-&gt;tcyl;
	dp-&gt;cyl = -1;

	fl.ncmd = 0;
	fl.cmd[fl.ncmd++] = Fseek;
	fl.cmd[fl.ncmd++] = (dp-&gt;thead&lt;&lt;2) | dp-&gt;dev;
	fl.cmd[fl.ncmd++] = dp-&gt;tcyl * dp-&gt;t-&gt;steps;
	if(floppycmd() &lt; 0)
		return -1;
	floppywait(1);
	if(fl.nstat &lt; 2){
		DPRINT("seek: confused\n");
		fl.confused = 1;
		return -1;
	}
	if((fl.stat[0] &amp; (Codemask|Seekend)) != Seekend){
		DPRINT("seek: failed\n");
		dp-&gt;confused = 1;
		return -1;
	}

	dp-&gt;cyl = dp-&gt;tcyl;
	return dp-&gt;tcyl;
}

/*
 *  read or write to floppy.  try up to three times.
 */
static long
floppyxfer(FDrive *dp, int cmd, void *a, long off, long n)
{
	long offset;
	int tries;

	if(off &gt;= dp-&gt;t-&gt;cap)
		return 0;
	if(off + n &gt; dp-&gt;t-&gt;cap)
		n = dp-&gt;t-&gt;cap - off;

	/* retry on error (until it gets ridiculous) */
	tries = 0;
	while(waserror()){
		if(tries++ &gt;= dp-&gt;maxtries)
			nexterror();
		DPRINT("floppyxfer: retrying\n");
	}

	dp-&gt;len = n;
	if(floppyseek(dp, off) &lt; 0){
		DPRINT("xfer: seek failed\n");
		dp-&gt;confused = 1;
		error(Eio);
	}

	/*
	 *  set up the dma (dp-&gt;len may be trimmed)
	 */
	if(waserror()){
		dmaend(DMAchan);
		nexterror();
	}
	dp-&gt;len = dmasetup(DMAchan, a, dp-&gt;len, cmd==Fread);
	if(dp-&gt;len &lt; 0)
		error(Eio);

	/*
	 *  start operation
	 */
	fl.ncmd = 0;
	fl.cmd[fl.ncmd++] = cmd | (dp-&gt;t-&gt;heads &gt; 1 ? Fmulti : 0);
	fl.cmd[fl.ncmd++] = (dp-&gt;thead&lt;&lt;2) | dp-&gt;dev;
	fl.cmd[fl.ncmd++] = dp-&gt;tcyl;
	fl.cmd[fl.ncmd++] = dp-&gt;thead;
	fl.cmd[fl.ncmd++] = dp-&gt;tsec;
	fl.cmd[fl.ncmd++] = dp-&gt;t-&gt;bcode;
	fl.cmd[fl.ncmd++] = dp-&gt;t-&gt;sectors;
	fl.cmd[fl.ncmd++] = dp-&gt;t-&gt;gpl;
	fl.cmd[fl.ncmd++] = 0xFF;
	if(floppycmd() &lt; 0)
		error(Eio);

	/* Poll ready bits and transfer data */
	floppyexec((char*)a, dp-&gt;len, cmd==Fread);

	/*
	 *  give bus to DMA, floppyintr() will read result
	 */
	floppywait(0);
	dmaend(DMAchan);
	poperror();

	/*
	 *  check for errors
	 */
	if(fl.nstat &lt; 7){
		DPRINT("xfer: confused\n");
		fl.confused = 1;
		error(Eio);
	}
	if((fl.stat[0] &amp; Codemask)!=0 || fl.stat[1] || fl.stat[2]){
		DPRINT("xfer: failed %ux %ux %ux\n", fl.stat[0],
			fl.stat[1], fl.stat[2]);
		DPRINT("offset %lud len %ld\n", off, dp-&gt;len);
		if((fl.stat[0]&amp;Codemask)==Cmdexec &amp;&amp; fl.stat[1]==Overrun){
			DPRINT("DMA overrun: retry\n");
		} else
			dp-&gt;confused = 1;
		error(Eio);
	}

	/*
	 *  check for correct cylinder
	 */
	offset = fl.stat[3] * dp-&gt;t-&gt;heads + fl.stat[4];
	offset = offset*dp-&gt;t-&gt;sectors + fl.stat[5] - 1;
	offset = offset * c2b[fl.stat[6]];
	if(offset != off+dp-&gt;len){
		DPRINT("xfer: ends on wrong cyl\n");
		dp-&gt;confused = 1;
		error(Eio);
	}
	poperror();

	dp-&gt;lasttouched = m-&gt;ticks;
	return dp-&gt;len;
}

/*
 *  format a track
 */
static void
floppyformat(FDrive *dp, Cmdbuf *cb)
{
 	int cyl, h, sec;
	ulong track;
	uchar *buf, *bp;
	FType *t;

	/*
	 *  set the type
	 */
	if(cb-&gt;nf == 2){
		for(t = floppytype; t &lt; &amp;floppytype[nelem(floppytype)]; t++){
			if(strcmp(cb-&gt;f[1], t-&gt;name)==0 &amp;&amp; t-&gt;dt==dp-&gt;dt){
				dp-&gt;t = t;
				floppydir[1+NFDIR*dp-&gt;dev].length = dp-&gt;t-&gt;cap;
				break;
			}
		}
		if(t &gt;= &amp;floppytype[nelem(floppytype)])
			error(Ebadarg);
	} else if(cb-&gt;nf == 1){
		floppysetdef(dp);
		t = dp-&gt;t;
	} else {
		cmderror(cb, "invalid floppy format command");
		SET(t);
	}

	/*
	 *  buffer for per track info
	 */
	buf = smalloc(t-&gt;sectors*4);
	if(waserror()){
		free(buf);
		nexterror();
	}

	/* force a recalibrate to cylinder 0 */
	dp-&gt;confused = 1;
	if(!waserror()){
		floppyon(dp);
		poperror();
	}

	/*
	 *  format a track at time
	 */
	for(track = 0; track &lt; t-&gt;tracks*t-&gt;heads; track++){
		cyl = track/t-&gt;heads;
		h = track % t-&gt;heads;

		/*
		 *  seek to track, ignore errors
		 */
		floppyseek(dp, track*t-&gt;tsize);
		dp-&gt;cyl = cyl;
		dp-&gt;confused = 0;

		/*
		 *  set up the dma (dp-&gt;len may be trimmed)
		 */
		bp = buf;
		for(sec = 1; sec &lt;= t-&gt;sectors; sec++){
			*bp++ = cyl;
			*bp++ = h;
			*bp++ = sec;
			*bp++ = t-&gt;bcode;
		}
		if(waserror()){
			dmaend(DMAchan);
			nexterror();
		}
		if(dmasetup(DMAchan, buf, bp-buf, 0) &lt; 0)
			error(Eio);

		/*
		 *  start operation
		 */
		fl.ncmd = 0;
		fl.cmd[fl.ncmd++] = Fformat;
		fl.cmd[fl.ncmd++] = (h&lt;&lt;2) | dp-&gt;dev;
		fl.cmd[fl.ncmd++] = t-&gt;bcode;
		fl.cmd[fl.ncmd++] = t-&gt;sectors;
		fl.cmd[fl.ncmd++] = t-&gt;fgpl;
		fl.cmd[fl.ncmd++] = 0x5a;
		if(floppycmd() &lt; 0)
			error(Eio);

		/* Poll ready bits and transfer data */
		floppyexec((char *)buf, bp-buf, 0);

		/*
		 *  give bus to DMA, floppyintr() will read result
		 */
		floppywait(1);
		dmaend(DMAchan);
		poperror();

		/*
		 *  check for errors
		 */
		if(fl.nstat &lt; 7){
			DPRINT("format: confused\n");
			fl.confused = 1;
			error(Eio);
		}
		if((fl.stat[0]&amp;Codemask)!=0 || fl.stat[1]|| fl.stat[2]){
			DPRINT("format: failed %ux %ux %ux\n",
				fl.stat[0], fl.stat[1], fl.stat[2]);
			dp-&gt;confused = 1;
			error(Eio);
		}
	}
	free(buf);
	dp-&gt;confused = 1;
	poperror();
}

static void
floppyintr(Ureg *)
{
	switch(fl.cmd[0]&amp;~Fmulti){
	case Fread:
	case Fwrite:
	case Fformat:
	case Fdumpreg: 
		floppyresult();
		break;
	case Fseek:
	case Frecal:
	default:
		floppysense();	/* to clear interrupt */
		break;
	}
	fl.ncmd = 0;
	wakeup(&amp;fl.r);
}

Dev floppydevtab = {
	'f',
	"floppy",

	floppyreset,
	devinit,
	devshutdown,
	floppyattach,
	floppywalk,
	floppystat,
	floppyopen,
	devcreate,
	floppyclose,
	floppyread,
	devbread,
	floppywrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

