<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/devi82365.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/devi82365.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"

/*
 *  Intel 82365SL PCIC controller and compatibles.
 */
enum
{
	/*
	 *  registers indices
	 */
	Rid=		0x0,		/* identification and revision */
	Ris=		0x1,		/* interface status */
	Rpc=	 	0x2,		/* power control */
	 Foutena=	 (1&lt;&lt;7),	/*  output enable */
	 Fautopower=	 (1&lt;&lt;5),	/*  automatic power switching */
	 Fcardena=	 (1&lt;&lt;4),	/*  PC card enable */
	Rigc= 		0x3,		/* interrupt and general control */
	 Fiocard=	 (1&lt;&lt;5),	/*  I/O card (vs memory) */
	 Fnotreset=	 (1&lt;&lt;6),	/*  reset if not set */	
	 FSMIena=	 (1&lt;&lt;4),	/*  enable change interrupt on SMI */ 
	Rcsc= 		0x4,		/* card status change */
	Rcscic= 	0x5,		/* card status change interrupt config */
	 Fchangeena=	 (1&lt;&lt;3),	/*  card changed */
	 Fbwarnena=	 (1&lt;&lt;1),	/*  card battery warning */
	 Fbdeadena=	 (1&lt;&lt;0),	/*  card battery dead */
	Rwe= 		0x6,		/* address window enable */
	 Fmem16=	 (1&lt;&lt;5),	/*  use A23-A12 to decode address */
	Rio= 		0x7,		/* I/O control */
	 Fwidth16=	 (1&lt;&lt;0),	/*  16 bit data width */
	 Fiocs16=	 (1&lt;&lt;1),	/*  IOCS16 determines data width */
	 Fzerows=	 (1&lt;&lt;2),	/*  zero wait state */
	 Ftiming=	 (1&lt;&lt;3),	/*  timing register to use */
	Riobtm0lo=	0x8,		/* I/O address 0 start low byte */
	Riobtm0hi=	0x9,		/* I/O address 0 start high byte */
	Riotop0lo=	0xa,		/* I/O address 0 stop low byte */
	Riotop0hi=	0xb,		/* I/O address 0 stop high byte */
	Riobtm1lo=	0xc,		/* I/O address 1 start low byte */
	Riobtm1hi=	0xd,		/* I/O address 1 start high byte */
	Riotop1lo=	0xe,		/* I/O address 1 stop low byte */
	Riotop1hi=	0xf,		/* I/O address 1 stop high byte */
	Rmap=		0x10,		/* map 0 */

	/*
	 *  CL-PD67xx extension registers
	 */
	Rmisc1=		0x16,		/* misc control 1 */
	 F5Vdetect=	 (1&lt;&lt;0),
	 Fvcc3V=	 (1&lt;&lt;1),
	 Fpmint=	 (1&lt;&lt;2),
	 Fpsirq=	 (1&lt;&lt;3),
	 Fspeaker=	 (1&lt;&lt;4),
	 Finpack=	 (1&lt;&lt;7),
	Rfifo=		0x17,		/* fifo control */
	 Fflush=	 (1&lt;&lt;7),	/*  flush fifo */
	Rmisc2=		0x1E,		/* misc control 2 */
	 Flowpow=	 (1&lt;&lt;1),	/*  low power mode */
	Rchipinfo=	0x1F,		/* chip information */
	Ratactl=	0x26,		/* ATA control */

	/*
	 *  offsets into the system memory address maps
	 */
	Mbtmlo=		0x0,		/* System mem addr mapping start low byte */
	Mbtmhi=		0x1,		/* System mem addr mapping start high byte */
	 F16bit=	 (1&lt;&lt;7),	/*  16-bit wide data path */
	Mtoplo=		0x2,		/* System mem addr mapping stop low byte */
	Mtophi=		0x3,		/* System mem addr mapping stop high byte */
	 Ftimer1=	 (1&lt;&lt;6),	/*  timer set 1 */
	Mofflo=		0x4,		/* Card memory offset address low byte */
	Moffhi=		0x5,		/* Card memory offset address high byte */
	 Fregactive=	 (1&lt;&lt;6),	/*  attribute memory */

	/*
	 *  configuration registers - they start at an offset in attribute
	 *  memory found in the CIS.
	 */
	Rconfig=	0,
	 Creset=	 (1&lt;&lt;7),	/*  reset device */
	 Clevel=	 (1&lt;&lt;6),	/*  level sensitive interrupt line */
	 Cirq=		 (1&lt;&lt;2),	/*  IRQ enable */
	 Cdecode=	 (1&lt;&lt;1),	/*  address decode */
	 Cfunc=		 (1&lt;&lt;0),	/*  function enable */
	Riobase0=	5,
	Riobase1=	6,
	Riosize=	9,
};

#define MAP(x,o)	(Rmap + (x)*0x8 + o)

typedef struct I82365	I82365;

/* a controller */
enum
{
	Ti82365,
	Tpd6710,
	Tpd6720,
	Tvg46x,
};
struct I82365
{
	int	type;
	int	dev;
	int	nslot;
	int	xreg;		/* index register address */
	int	dreg;		/* data register address */
	int	irq;
};
static I82365 *controller[4];
static int ncontroller;
static PCMslot	*slot;
static PCMslot	*lastslot;
static nslot;

static void	i82365intr(Ureg*, void*);
static int	pcmio(int, ISAConf*);
static long	pcmread(int, int, void*, long, vlong);
static long	pcmwrite(int, int, void*, long, vlong);

static void i82365dump(PCMslot*);

/*
 *  reading and writing card registers
 */
static uchar
rdreg(PCMslot *pp, int index)
{
	outb(((I82365*)pp-&gt;cp)-&gt;xreg, pp-&gt;base + index);
	return inb(((I82365*)pp-&gt;cp)-&gt;dreg);
}
static void
wrreg(PCMslot *pp, int index, uchar val)
{
	outb(((I82365*)pp-&gt;cp)-&gt;xreg, pp-&gt;base + index);
	outb(((I82365*)pp-&gt;cp)-&gt;dreg, val);
}

/*
 *  get info about card
 */
static void
slotinfo(PCMslot *pp)
{
	uchar isr;

	isr = rdreg(pp, Ris);
	pp-&gt;occupied = (isr &amp; (3&lt;&lt;2)) == (3&lt;&lt;2);
	pp-&gt;powered = isr &amp; (1&lt;&lt;6);
	pp-&gt;battery = (isr &amp; 3) == 3;
	pp-&gt;wrprot = isr &amp; (1&lt;&lt;4);
	pp-&gt;busy = isr &amp; (1&lt;&lt;5);
	pp-&gt;msec = TK2MS(MACHP(0)-&gt;ticks);
}

static int
vcode(int volt)
{
	switch(volt){
	case 5:
		return 1;
	case 12:
		return 2;
	default:
		return 0;
	}
}

/*
 *  enable the slot card
 */
static void
slotena(PCMslot *pp)
{
	if(pp-&gt;enabled)
		return;

	/* power up and unreset, wait's are empirical (???) */
	wrreg(pp, Rpc, Fautopower|Foutena|Fcardena);
	delay(300);
	wrreg(pp, Rigc, 0);
	delay(100);
	wrreg(pp, Rigc, Fnotreset);
	delay(500);

	/* get configuration */
	slotinfo(pp);
	if(pp-&gt;occupied){
		pcmcisread(pp);
		pp-&gt;enabled = 1;
	} else
		wrreg(pp, Rpc, Fautopower);
}

/*
 *  disable the slot card
 */
static void
slotdis(PCMslot *pp)
{
	wrreg(pp, Rpc, 0);	/* turn off card power */
	wrreg(pp, Rwe, 0);	/* no windows */
	pp-&gt;enabled = 0;
}

/*
 *  status change interrupt
 */
static void
i82365intr(Ureg *, void *)
{
	uchar csc, was;
	PCMslot *pp;

	if(slot == 0)
		return;

	for(pp = slot; pp &lt; lastslot; pp++){
		csc = rdreg(pp, Rcsc);
		was = pp-&gt;occupied;
		slotinfo(pp);
		if(csc &amp; (1&lt;&lt;3) &amp;&amp; was != pp-&gt;occupied){
			if(!pp-&gt;occupied)
				slotdis(pp);
		}
	}
}

enum
{
	Mshift=	12,
	Mgran=	(1&lt;&lt;Mshift),	/* granularity of maps */
	Mmask=	~(Mgran-1),	/* mask for address bits important to the chip */
};

/*
 *  get a map for pc card region, return corrected len
 */
PCMmap*
pcmmap(int slotno, ulong offset, int len, int attr)
{
	PCMslot *pp;
	uchar we, bit;
	PCMmap *m, *nm;
	int i;
	ulong e;

	pp = slot + slotno;
	lock(&amp;pp-&gt;mlock);

	/* convert offset to granularity */
	if(len &lt;= 0)
		len = 1;
	e = ROUND(offset+len, Mgran);
	offset &amp;= Mmask;
	len = e - offset;

	/* look for a map that covers the right area */
	we = rdreg(pp, Rwe);
	bit = 1;
	nm = 0;
	for(m = pp-&gt;mmap; m &lt; &amp;pp-&gt;mmap[nelem(pp-&gt;mmap)]; m++){
		if((we &amp; bit))
		if(m-&gt;attr == attr)
		if(offset &gt;= m-&gt;ca &amp;&amp; e &lt;= m-&gt;cea){

			m-&gt;ref++;
			unlock(&amp;pp-&gt;mlock);
			return m;
		}
		bit &lt;&lt;= 1;
		if(nm == 0 &amp;&amp; m-&gt;ref == 0)
			nm = m;
	}
	m = nm;
	if(m == 0){
		unlock(&amp;pp-&gt;mlock);
		return 0;
	}

	/* if isa space isn't big enough, free it and get more */
	if(m-&gt;len &lt; len){
		if(m-&gt;isa){
			umbfree(m-&gt;isa, m-&gt;len);
			m-&gt;len = 0;
		}
		m-&gt;isa = PADDR(umbmalloc(0, len, Mgran));
		if(m-&gt;isa == 0){
			print("pcmmap: out of isa space\n");
			unlock(&amp;pp-&gt;mlock);
			return 0;
		}
		m-&gt;len = len;
	}

	/* set up new map */
	m-&gt;ca = offset;
	m-&gt;cea = m-&gt;ca + m-&gt;len;
	m-&gt;attr = attr;
	i = m-pp-&gt;mmap;
	bit = 1&lt;&lt;i;
	wrreg(pp, Rwe, we &amp; ~bit);		/* disable map before changing it */
	wrreg(pp, MAP(i, Mbtmlo), m-&gt;isa&gt;&gt;Mshift);
	wrreg(pp, MAP(i, Mbtmhi), (m-&gt;isa&gt;&gt;(Mshift+8)) | F16bit);
	wrreg(pp, MAP(i, Mtoplo), (m-&gt;isa+m-&gt;len-1)&gt;&gt;Mshift);
	wrreg(pp, MAP(i, Mtophi), ((m-&gt;isa+m-&gt;len-1)&gt;&gt;(Mshift+8)));
	offset -= m-&gt;isa;
	offset &amp;= (1&lt;&lt;25)-1;
	offset &gt;&gt;= Mshift;
	wrreg(pp, MAP(i, Mofflo), offset);
	wrreg(pp, MAP(i, Moffhi), (offset&gt;&gt;8) | (attr ? Fregactive : 0));
	wrreg(pp, Rwe, we | bit);		/* enable map */
	m-&gt;ref = 1;

	unlock(&amp;pp-&gt;mlock);
	return m;
}

void
pcmunmap(int slotno, PCMmap* m)
{
	PCMslot *pp;

	pp = slot + slotno;
	lock(&amp;pp-&gt;mlock);
	m-&gt;ref--;
	unlock(&amp;pp-&gt;mlock);
}

static void
increfp(PCMslot *pp)
{
	lock(pp);
	if(pp-&gt;ref++ == 0)
		slotena(pp);
	unlock(pp);
}

static void
decrefp(PCMslot *pp)
{
	lock(pp);
	if(pp-&gt;ref-- == 1)
		slotdis(pp);
	unlock(pp);
}

/*
 *  look for a card whose version contains 'idstr'
 */
static int
pcmcia_pcmspecial(char *idstr, ISAConf *isa)
{
	PCMslot *pp;
	extern char *strstr(char*, char*);
	int enabled;

	for(pp = slot; pp &lt; lastslot; pp++){
		if(pp-&gt;special)
			continue;	/* already taken */

		/*
		 *  make sure we don't power on cards when we already know what's
		 *  in them.  We'll reread every two minutes if necessary
		 */
		enabled = 0;
		if (pp-&gt;msec == ~0 || TK2MS(MACHP(0)-&gt;ticks) - pp-&gt;msec &gt; 120000){
			increfp(pp);
			enabled++;
		}

		if(pp-&gt;occupied) {
			if(strstr(pp-&gt;verstr, idstr)){
				if (!enabled){
					enabled = 1;
					increfp(pp);
				}
				if(isa == 0 || pcmio(pp-&gt;slotno, isa) == 0){
					pp-&gt;special = 1;
					return pp-&gt;slotno;
				}
			}
		} else
			pp-&gt;special = 1;
		if (enabled)
			decrefp(pp);
	}
	return -1;
}

static void
pcmcia_pcmspecialclose(int slotno)
{
	PCMslot *pp;

	if(slotno &gt;= nslot)
		panic("pcmspecialclose");
	pp = slot + slotno;
	pp-&gt;special = 0;
	decrefp(pp);
}

enum
{
	Qdir,
	Qmem,
	Qattr,
	Qctl,

	Nents = 3,
};

#define SLOTNO(c)	((ulong)((c-&gt;qid.path&gt;&gt;8)&amp;0xff))
#define TYPE(c)	((ulong)(c-&gt;qid.path&amp;0xff))
#define QID(s,t)	(((s)&lt;&lt;8)|(t))

static int
pcmgen(Chan *c, char*, Dirtab *, int , int i, Dir *dp)
{
	int slotno;
	Qid qid;
	long len;
	PCMslot *pp;

	if(i == DEVDOTDOT){
		mkqid(&amp;qid, Qdir, 0, QTDIR);
		devdir(c, qid, "#y", 0, eve, 0555, dp);
		return 1;
	}

	if(i &gt;= Nents*nslot)
		return -1;
	slotno = i/Nents;
	pp = slot + slotno;
	len = 0;
	switch(i%Nents){
	case 0:
		qid.path = QID(slotno, Qmem);
		snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "pcm%dmem", slotno);
		len = pp-&gt;memlen;
		break;
	case 1:
		qid.path = QID(slotno, Qattr);
		snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "pcm%dattr", slotno);
		len = pp-&gt;memlen;
		break;
	case 2:
		qid.path = QID(slotno, Qctl);
		snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "pcm%dctl", slotno);
		break;
	}
	qid.vers = 0;
	qid.type = QTFILE;
	devdir(c, qid, up-&gt;genbuf, len, eve, 0660, dp);
	return 1;
}

static char *chipname[] =
{
[Ti82365]	"Intel 82365SL",
[Tpd6710]	"Cirrus Logic CL-PD6710",
[Tpd6720]	"Cirrus Logic CL-PD6720",
[Tvg46x]	"Vadem VG-46x",
};

static I82365*
i82365probe(int x, int d, int dev)
{
	uchar c, id;
	I82365 *cp;
	ISAConf isa;
	int i, nslot;

	outb(x, Rid + (dev&lt;&lt;7));
	id = inb(d);
	if((id &amp; 0xf0) != 0x80)
		return 0;		/* not a memory &amp; I/O card */
	if((id &amp; 0x0f) == 0x00)
		return 0;		/* no revision number, not possible */

	cp = xalloc(sizeof(I82365));
	cp-&gt;xreg = x;
	cp-&gt;dreg = d;
	cp-&gt;dev = dev;
	cp-&gt;type = Ti82365;
	cp-&gt;nslot = 2;

	switch(id){
	case 0x82:
	case 0x83:
	case 0x84:
		/* could be a cirrus */
		outb(x, Rchipinfo + (dev&lt;&lt;7));
		outb(d, 0);
		c = inb(d);
		if((c &amp; 0xc0) != 0xc0)
			break;
		c = inb(d);
		if((c &amp; 0xc0) != 0x00)
			break;
		if(c &amp; 0x20){
			cp-&gt;type = Tpd6720;
		} else {
			cp-&gt;type = Tpd6710;
			cp-&gt;nslot = 1;
		}

		/* low power mode */
		outb(x, Rmisc2 + (dev&lt;&lt;7));
		c = inb(d);
		outb(d, c &amp; ~Flowpow);
		break;
	}

	/* if it's not a Cirrus, it could be a Vadem... */
	if(cp-&gt;type == Ti82365){
		/* unlock the Vadem extended regs */
		outb(x, 0x0E + (dev&lt;&lt;7));
		outb(x, 0x37 + (dev&lt;&lt;7));

		/* make the id register show the Vadem id */
		outb(x, 0x3A + (dev&lt;&lt;7));
		c = inb(d);
		outb(d, c|0xC0);
		outb(x, Rid + (dev&lt;&lt;7));
		c = inb(d);
		if(c &amp; 0x08)
			cp-&gt;type = Tvg46x;

		/* go back to Intel compatible id */
		outb(x, 0x3A + (dev&lt;&lt;7));
		c = inb(d);
		outb(d, c &amp; ~0xC0);
	}

	memset(&amp;isa, 0, sizeof(ISAConf));
	if(isaconfig("pcmcia", ncontroller, &amp;isa) &amp;&amp; isa.irq)
		cp-&gt;irq = isa.irq;
	else
		cp-&gt;irq = IrqPCMCIA;

	for(i = 0; i &lt; isa.nopt; i++){
		if(cistrncmp(isa.opt[i], "nslot=", 6))
			continue;
		nslot = strtol(&amp;isa.opt[i][6], nil, 0);
		if(nslot &gt; 0 &amp;&amp; nslot &lt;= 2)
			cp-&gt;nslot = nslot;
	}

	controller[ncontroller++] = cp;
	return cp;
}

static void
i82365dump(PCMslot *pp)
{
	int i;

	for(i = 0; i &lt; 0x40; i++){
		if((i&amp;0x0F) == 0)
			print("\n%2.2uX:	", i);
		print("%2.2uX ", rdreg(pp, i));
		if(((i+1) &amp; 0x0F) == 0x08)
			print(" - ");
	}
	print("\n");
}

/*
 *  set up for slot cards
 */
void
devi82365link(void)
{
	static int already;
	int i, j;
	I82365 *cp;
	PCMslot *pp;
	char buf[32], *p;

	if(already)
		return;
	already = 1;

	if((p=getconf("pcmcia0")) &amp;&amp; strncmp(p, "disabled", 8)==0)
		return;

	if(_pcmspecial)
		return;
	
	/* look for controllers if the ports aren't already taken */
	if(ioalloc(0x3E0, 2, 0, "i82365.0") &gt;= 0){
		i82365probe(0x3E0, 0x3E1, 0);
		i82365probe(0x3E0, 0x3E1, 1);
		if(ncontroller == 0)
			iofree(0x3E0);
	}
	if(ioalloc(0x3E2, 2, 0, "i82365.1") &gt;= 0){
		i = ncontroller;
		i82365probe(0x3E2, 0x3E3, 0);
		i82365probe(0x3E2, 0x3E3, 1);
		if(ncontroller == i)
			iofree(0x3E2);
	}

	if(ncontroller == 0)
		return;

	_pcmspecial = pcmcia_pcmspecial;
	_pcmspecialclose = pcmcia_pcmspecialclose;

	for(i = 0; i &lt; ncontroller; i++)
		nslot += controller[i]-&gt;nslot;
	slot = xalloc(nslot * sizeof(PCMslot));

	lastslot = slot;
	for(i = 0; i &lt; ncontroller; i++){
		cp = controller[i];
		print("#y%d: %d slot %s: port 0x%uX irq %d\n",
			i, cp-&gt;nslot, chipname[cp-&gt;type], cp-&gt;xreg, cp-&gt;irq);
		for(j = 0; j &lt; cp-&gt;nslot; j++){
			pp = lastslot++;
			pp-&gt;slotno = pp - slot;
			pp-&gt;memlen = 64*MB;
			pp-&gt;base = (cp-&gt;dev&lt;&lt;7) | (j&lt;&lt;6);
			pp-&gt;cp = cp;
			pp-&gt;msec = ~0;
			pp-&gt;verstr[0] = 0;
			slotdis(pp);

			/* interrupt on status change */
			wrreg(pp, Rcscic, (cp-&gt;irq&lt;&lt;4) | Fchangeena);
			rdreg(pp, Rcsc);
		}

		/* for card management interrupts */
		snprint(buf, sizeof buf, "i82365.%d", i);
		intrenable(cp-&gt;irq, i82365intr, 0, BUSUNKNOWN, buf);
	}
}

static Chan*
i82365attach(char *spec)
{
	return devattach('y', spec);
}

static Walkqid*
i82365walk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, pcmgen);
}

static int
i82365stat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, 0, 0, pcmgen);
}

static Chan*
i82365open(Chan *c, int omode)
{
	if(c-&gt;qid.type &amp; QTDIR){
		if(omode != OREAD)
			error(Eperm);
	} else
		increfp(slot + SLOTNO(c));
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
i82365close(Chan *c)
{
	if(c-&gt;flag &amp; COPEN)
		if((c-&gt;qid.type &amp; QTDIR) == 0)
			decrefp(slot+SLOTNO(c));
}

/* a memmove using only bytes */
static void
memmoveb(uchar *to, uchar *from, int n)
{
	while(n-- &gt; 0)
		*to++ = *from++;
}

/* a memmove using only shorts &amp; bytes */
static void
memmoves(uchar *to, uchar *from, int n)
{
	ushort *t, *f;

	if((((ulong)to) &amp; 1) || (((ulong)from) &amp; 1) || (n &amp; 1)){
		while(n-- &gt; 0)
			*to++ = *from++;
	} else {
		n = n/2;
		t = (ushort*)to;
		f = (ushort*)from;
		while(n-- &gt; 0)
			*t++ = *f++;
	}
}

static long
pcmread(int slotno, int attr, void *a, long n, vlong off)
{
	int i, len;
	PCMmap *m;
	uchar *ac;
	PCMslot *pp;
	ulong offset = off;

	pp = slot + slotno;
	if(pp-&gt;memlen &lt; offset)
		return 0;
	if(pp-&gt;memlen &lt; offset + n)
		n = pp-&gt;memlen - offset;

	m = 0;
	if(waserror()){
		if(m)
			pcmunmap(pp-&gt;slotno, m);
		nexterror();
	}

	ac = a;
	for(len = n; len &gt; 0; len -= i){
		m = pcmmap(pp-&gt;slotno, offset, 0, attr);
		if(m == 0)
			error("cannot map PCMCIA card");
		if(offset + len &gt; m-&gt;cea)
			i = m-&gt;cea - offset;
		else
			i = len;
		memmoveb(ac, KADDR(m-&gt;isa + offset - m-&gt;ca), i);
		pcmunmap(pp-&gt;slotno, m);
		offset += i;
		ac += i;
	}

	poperror();
	return n;
}

static long
i82365read(Chan *c, void *a, long n, vlong off)
{
	char *p, *buf, *e;
	PCMslot *pp;
	ulong offset = off;

	switch(TYPE(c)){
	case Qdir:
		return devdirread(c, a, n, 0, 0, pcmgen);
	case Qmem:
	case Qattr:
		return pcmread(SLOTNO(c), TYPE(c) == Qattr, a, n, off);
	case Qctl:
		buf = p = malloc(READSTR);
		if(p == nil)
			error(Enomem);
		e = p + READSTR;
		pp = slot + SLOTNO(c);

		buf[0] = 0;
		if(pp-&gt;occupied){
			p = seprint(p, e, "occupied\n");
			if(pp-&gt;verstr[0])
				p = seprint(p, e, "version %s\n", pp-&gt;verstr);
		}
		if(pp-&gt;enabled)
			p = seprint(p, e, "enabled\n");
		if(pp-&gt;powered)
			p = seprint(p, e, "powered\n");
		if(pp-&gt;configed)
			p = seprint(p, e, "configed\n");
		if(pp-&gt;wrprot)
			p = seprint(p, e, "write protected\n");
		if(pp-&gt;busy)
			p = seprint(p, e, "busy\n");
		seprint(p, e, "battery lvl %d\n", pp-&gt;battery);

		n = readstr(offset, a, n, buf);
		free(buf);

		return n;
	}
	error(Ebadarg);
	return -1;	/* not reached */
}

static long
pcmwrite(int dev, int attr, void *a, long n, vlong off)
{
	int i, len;
	PCMmap *m;
	uchar *ac;
	PCMslot *pp;
	ulong offset = off;

	pp = slot + dev;
	if(pp-&gt;memlen &lt; offset)
		return 0;
	if(pp-&gt;memlen &lt; offset + n)
		n = pp-&gt;memlen - offset;

	m = 0;
	if(waserror()){
		if(m)
			pcmunmap(pp-&gt;slotno, m);
		nexterror();
	}

	ac = a;
	for(len = n; len &gt; 0; len -= i){
		m = pcmmap(pp-&gt;slotno, offset, 0, attr);
		if(m == 0)
			error("cannot map PCMCIA card");
		if(offset + len &gt; m-&gt;cea)
			i = m-&gt;cea - offset;
		else
			i = len;
		memmoveb(KADDR(m-&gt;isa + offset - m-&gt;ca), ac, i);
		pcmunmap(pp-&gt;slotno, m);
		offset += i;
		ac += i;
	}

	poperror();
	return n;
}

static long
i82365write(Chan *c, void *a, long n, vlong off)
{
	PCMslot *pp;
	char buf[32];

	switch(TYPE(c)){
	case Qctl:
		if(n &gt;= sizeof(buf))
			n = sizeof(buf) - 1;
		strncpy(buf, a, n);
		buf[n] = 0;
		pp = slot + SLOTNO(c);
		if(!pp-&gt;occupied)
			error(Eio);

		/* set vpp on card */
		if(strncmp(buf, "vpp", 3) == 0)
			wrreg(pp, Rpc, vcode(atoi(buf+3))|Fautopower|Foutena|Fcardena);
		return n;
	case Qmem:
	case Qattr:
		pp = slot + SLOTNO(c);
		if(pp-&gt;occupied == 0 || pp-&gt;enabled == 0)
			error(Eio);
		n = pcmwrite(pp-&gt;slotno, TYPE(c) == Qattr, a, n, off);
		if(n &lt; 0)
			error(Eio);
		return n;
	}
	error(Ebadarg);
	return -1;	/* not reached */
}

Dev i82365devtab = {
	'y',
	"i82365",

	devreset,
	devinit,
	devshutdown,
	i82365attach,
	i82365walk,
	i82365stat,
	i82365open,
	devcreate,
	i82365close,
	i82365read,
	devbread,
	i82365write,
	devbwrite,
	devremove,
	devwstat,
};

/*
 *  configure the PCMslot for IO.  We assume very heavily that we can read
 *  configuration info from the CIS.  If not, we won't set up correctly.
 */
static int
pcmio(int slotno, ISAConf *isa)
{
	uchar we, x, *p;
	PCMslot *pp;
	PCMconftab *ct, *et, *t;
	PCMmap *m;
	int i, index, irq;
	char *cp;

	irq = isa-&gt;irq;
	if(irq == 2)
		irq = 9;

	if(slotno &gt; nslot)
		return -1;
	pp = slot + slotno;

	if(!pp-&gt;occupied)
		return -1;

	et = &amp;pp-&gt;ctab[pp-&gt;nctab];

	ct = 0;
	for(i = 0; i &lt; isa-&gt;nopt; i++){
		if(strncmp(isa-&gt;opt[i], "index=", 6))
			continue;
		index = strtol(&amp;isa-&gt;opt[i][6], &amp;cp, 0);
		if(cp == &amp;isa-&gt;opt[i][6] || index &gt;= pp-&gt;nctab)
			return -1;
		ct = &amp;pp-&gt;ctab[index];
	}

	if(ct == 0){
		/* assume default is right */
		if(pp-&gt;def)
			ct = pp-&gt;def;
		else
			ct = pp-&gt;ctab;
	
		/* try for best match */
		if(ct-&gt;nio == 0
		|| ct-&gt;io[0].start != isa-&gt;port || ((1&lt;&lt;irq) &amp; ct-&gt;irqs) == 0){
			for(t = pp-&gt;ctab; t &lt; et; t++)
				if(t-&gt;nio
				&amp;&amp; t-&gt;io[0].start == isa-&gt;port
				&amp;&amp; ((1&lt;&lt;irq) &amp; t-&gt;irqs)){
					ct = t;
					break;
				}
		}
		if(ct-&gt;nio == 0 || ((1&lt;&lt;irq) &amp; ct-&gt;irqs) == 0){
			for(t = pp-&gt;ctab; t &lt; et; t++)
				if(t-&gt;nio &amp;&amp; ((1&lt;&lt;irq) &amp; t-&gt;irqs)){
					ct = t;
					break;
				}
		}
		if(ct-&gt;nio == 0){
			for(t = pp-&gt;ctab; t &lt; et; t++)
				if(t-&gt;nio){
					ct = t;
					break;
				}
		}
	}

	if(ct == et || ct-&gt;nio == 0)
		return -1;
	if(isa-&gt;port == 0 &amp;&amp; ct-&gt;io[0].start == 0)
		return -1;

	/* route interrupts */
	isa-&gt;irq = irq;
	wrreg(pp, Rigc, irq | Fnotreset | Fiocard);

	/* set power and enable device */
	x = vcode(ct-&gt;vpp1);
	wrreg(pp, Rpc, x|Fautopower|Foutena|Fcardena);

	/* 16-bit data path */
	if(ct-&gt;bit16)
		x = Ftiming|Fiocs16|Fwidth16;
	else
		x = Ftiming;
	if(ct-&gt;nio == 2 &amp;&amp; ct-&gt;io[1].start)
		x |= x&lt;&lt;4;
	wrreg(pp, Rio, x);

	/*
	 * enable io port map 0
	 * the 'top' register value includes the last valid address
	 */
	if(isa-&gt;port == 0)
		isa-&gt;port = ct-&gt;io[0].start;
	we = rdreg(pp, Rwe);
	wrreg(pp, Riobtm0lo, isa-&gt;port);
	wrreg(pp, Riobtm0hi, isa-&gt;port&gt;&gt;8);
	i = isa-&gt;port+ct-&gt;io[0].len-1;
	wrreg(pp, Riotop0lo, i);
	wrreg(pp, Riotop0hi, i&gt;&gt;8);
	we |= 1&lt;&lt;6;
	if(ct-&gt;nio &gt;= 2 &amp;&amp; ct-&gt;io[1].start){
		wrreg(pp, Riobtm1lo, ct-&gt;io[1].start);
		wrreg(pp, Riobtm1hi, ct-&gt;io[1].start&gt;&gt;8);
		i = ct-&gt;io[1].start+ct-&gt;io[1].len-1;
		wrreg(pp, Riotop1lo, i);
		wrreg(pp, Riotop1hi, i&gt;&gt;8);
		we |= 1&lt;&lt;7;
	}
	wrreg(pp, Rwe, we);

	/* only touch Rconfig if it is present */
	m = pcmmap(slotno, pp-&gt;cfg[0].caddr + Rconfig, 0x20, 1);
	p = KADDR(m-&gt;isa + pp-&gt;cfg[0].caddr - m-&gt;ca);
	if(pp-&gt;cfg[0].cpresent &amp; (1&lt;&lt;Rconfig)){
		/*  Reset adapter */

		/*  set configuration and interrupt type.
		 *  if level is possible on the card, use it.
		 */
		x = ct-&gt;index;
		if(ct-&gt;irqtype &amp; 0x20)
			x |= Clevel;

		/*  enable the device, enable address decode and
		 *  irq enable.
		 */
		x |= Cfunc|Cdecode|Cirq;

		p[0] = x;
		//delay(5);
		microdelay(40);
	}

	if(pp-&gt;cfg[0].cpresent &amp; (1&lt;&lt;Riobase0)){
		/* set up the iobase 0 */
		p[Riobase0 &lt;&lt; 1] = isa-&gt;port;
		p[Riobase1 &lt;&lt; 1] = isa-&gt;port &gt;&gt; 8;
	}

	if(pp-&gt;cfg[0].cpresent &amp; (1&lt;&lt;Riosize))
		p[Riosize &lt;&lt; 1] = ct-&gt;io[0].len;
	pcmunmap(slotno, m);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

