<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/devvga.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/devvga.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * VGA controller
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

enum {
	Qdir,
	Qvgabios,
	Qvgactl,
	Qvgaovl,
	Qvgaovlctl,
};

static Dirtab vgadir[] = {
	".",	{ Qdir, 0, QTDIR },		0,	0550,
	"vgabios",	{ Qvgabios, 0 },	0x100000, 0440,
	"vgactl",		{ Qvgactl, 0 },		0,	0660,
	"vgaovl",		{ Qvgaovl, 0 },		0,	0660,
	"vgaovlctl",	{ Qvgaovlctl, 0 },	0, 	0660,
};

enum {
	CMactualsize,
	CMblank,
	CMblanktime,
	CMdrawinit,
	CMhwaccel,
	CMhwblank,
	CMhwgc,
	CMlinear,
	CMpalettedepth,
	CMpanning,
	CMsize,
	CMtextmode,
	CMtype,
	CMunblank,
};

static Cmdtab vgactlmsg[] = {
	CMactualsize,	"actualsize",	2,
	CMblank,	"blank",	1,
	CMblanktime,	"blanktime",	2,
	CMdrawinit,	"drawinit",	1,
	CMhwaccel,	"hwaccel",	2,
	CMhwblank,	"hwblank",	2,
	CMhwgc,		"hwgc",		2,
	CMlinear,	"linear",	0,
	CMpalettedepth,	"palettedepth",	2,
	CMpanning,	"panning",	2,
	CMsize,		"size",		3,
	CMtextmode,	"textmode",	1,
	CMtype,		"type",		2,
	CMunblank,	"unblank",	1,
};

static void
vgareset(void)
{
	/* reserve the 'standard' vga registers */
	if(ioalloc(0x2b0, 0x2df-0x2b0+1, 0, "vga") &lt; 0)
		panic("vga ports already allocated"); 
	if(ioalloc(0x3c0, 0x3da-0x3c0+1, 0, "vga") &lt; 0)
		panic("vga ports already allocated"); 
	conf.monitor = 1;
}

static Chan*
vgaattach(char* spec)
{
	if(*spec &amp;&amp; strcmp(spec, "0"))
		error(Eio);
	return devattach('v', spec);
}

Walkqid*
vgawalk(Chan* c, Chan *nc, char** name, int nname)
{
	return devwalk(c, nc, name, nname, vgadir, nelem(vgadir), devgen);
}

static int
vgastat(Chan* c, uchar* dp, int n)
{
	return devstat(c, dp, n, vgadir, nelem(vgadir), devgen);
}

static Chan*
vgaopen(Chan* c, int omode)
{
	VGAscr *scr;
	static char *openctl = "openctl\n";

	scr = &amp;vgascreen[0];
	if ((ulong)c-&gt;qid.path == Qvgaovlctl) {
		if (scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;ovlctl)
			scr-&gt;dev-&gt;ovlctl(scr, c, openctl, strlen(openctl));
		else 
			error(Enonexist);
	}
	return devopen(c, omode, vgadir, nelem(vgadir), devgen);
}

static void
vgaclose(Chan* c)
{
	VGAscr *scr;
	static char *closectl = "closectl\n";

	scr = &amp;vgascreen[0];
	if((ulong)c-&gt;qid.path == Qvgaovlctl)
		if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;ovlctl){
			if(waserror()){
				print("ovlctl error: %s\n", up-&gt;errstr);
				return;
			}
			scr-&gt;dev-&gt;ovlctl(scr, c, closectl, strlen(closectl));
			poperror();
		}
}

static void
checkport(int start, int end)
{
	/* standard vga regs are OK */
	if(start &gt;= 0x2b0 &amp;&amp; end &lt;= 0x2df+1)
		return;
	if(start &gt;= 0x3c0 &amp;&amp; end &lt;= 0x3da+1)
		return;

	if(iounused(start, end))
		return;
	error(Eperm);
}

static long
vgaread(Chan* c, void* a, long n, vlong off)
{
	int len;
	char *p, *s;
	VGAscr *scr;
	ulong offset = off;
	char chbuf[30];

	switch((ulong)c-&gt;qid.path){

	case Qdir:
		return devdirread(c, a, n, vgadir, nelem(vgadir), devgen);

	case Qvgabios:
		if(offset &gt;= 0x100000)
			return 0;
		if(offset+n &gt;= 0x100000)
			n = 0x100000 - offset;
		memmove(a, (uchar*)kaddr(0)+offset, n);
		return n;

	case Qvgactl:
		scr = &amp;vgascreen[0];

		p = malloc(READSTR);
		if(p == nil)
			error(Enomem);
		if(waserror()){
			free(p);
			nexterror();
		}

		len = 0;

		if(scr-&gt;dev)
			s = scr-&gt;dev-&gt;name;
		else
			s = "cga";
		len += snprint(p+len, READSTR-len, "type %s\n", s);

		if(scr-&gt;gscreen) {
			len += snprint(p+len, READSTR-len, "size %dx%dx%d %s\n",
				scr-&gt;gscreen-&gt;r.max.x, scr-&gt;gscreen-&gt;r.max.y,
				scr-&gt;gscreen-&gt;depth, chantostr(chbuf, scr-&gt;gscreen-&gt;chan));

			if(Dx(scr-&gt;gscreen-&gt;r) != Dx(physgscreenr) 
			|| Dy(scr-&gt;gscreen-&gt;r) != Dy(physgscreenr))
				len += snprint(p+len, READSTR-len, "actualsize %dx%d\n",
					physgscreenr.max.x, physgscreenr.max.y);
		}

		len += snprint(p+len, READSTR-len, "blank time %lud idle %d state %s\n",
			blanktime, drawidletime(), scr-&gt;isblank ? "off" : "on");
		len += snprint(p+len, READSTR-len, "hwaccel %s\n", hwaccel ? "on" : "off");
		len += snprint(p+len, READSTR-len, "hwblank %s\n", hwblank ? "on" : "off");
		len += snprint(p+len, READSTR-len, "panning %s\n", panning ? "on" : "off");
		len += snprint(p+len, READSTR-len, "addr p 0x%lux v 0x%p size 0x%ux\n", scr-&gt;paddr, scr-&gt;vaddr, scr-&gt;apsize);
		USED(len);

		n = readstr(offset, a, n, p);
		poperror();
		free(p);

		return n;

	case Qvgaovl:
	case Qvgaovlctl:
		error(Ebadusefd);
		break;

	default:
		error(Egreg);
		break;
	}

	return 0;
}

static char Ebusy[] = "vga already configured";

static void
vgactl(Cmdbuf *cb)
{
	int align, i, size, x, y, z;
	char *chanstr, *p;
	ulong chan;
	Cmdtab *ct;
	VGAscr *scr;
	extern VGAdev *vgadev[];
	extern VGAcur *vgacur[];

	scr = &amp;vgascreen[0];
	ct = lookupcmd(cb, vgactlmsg, nelem(vgactlmsg));
	switch(ct-&gt;index){
	case CMhwgc:
		if(strcmp(cb-&gt;f[1], "off") == 0){
			lock(&amp;cursor);
			if(scr-&gt;cur){
				if(scr-&gt;cur-&gt;disable)
					scr-&gt;cur-&gt;disable(scr);
				scr-&gt;cur = nil;
			}
			unlock(&amp;cursor);
			return;
		}
		if(strcmp(cb-&gt;f[1], "soft") == 0){
			lock(&amp;cursor);
			swcursorinit();
			if(scr-&gt;cur &amp;&amp; scr-&gt;cur-&gt;disable)
				scr-&gt;cur-&gt;disable(scr);
			scr-&gt;cur = &amp;swcursor;
			if(scr-&gt;cur-&gt;enable)
				scr-&gt;cur-&gt;enable(scr);
			unlock(&amp;cursor);
			return;
		}
		for(i = 0; vgacur[i]; i++){
			if(strcmp(cb-&gt;f[1], vgacur[i]-&gt;name))
				continue;
			lock(&amp;cursor);
			if(scr-&gt;cur &amp;&amp; scr-&gt;cur-&gt;disable)
				scr-&gt;cur-&gt;disable(scr);
			scr-&gt;cur = vgacur[i];
			if(scr-&gt;cur-&gt;enable)
				scr-&gt;cur-&gt;enable(scr);
			unlock(&amp;cursor);
			return;
		}
		break;

	case CMtype:
		for(i = 0; vgadev[i]; i++){
			if(strcmp(cb-&gt;f[1], vgadev[i]-&gt;name))
				continue;
			if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;disable)
				scr-&gt;dev-&gt;disable(scr);
			scr-&gt;dev = vgadev[i];
			if(scr-&gt;dev-&gt;enable)
				scr-&gt;dev-&gt;enable(scr);
			return;
		}
		break;

	case CMtextmode:
		screeninit();
		return;

	case CMsize:
		x = strtoul(cb-&gt;f[1], &amp;p, 0);
		if(x == 0 || x &gt; 10240)
			error(Ebadarg);
		if(*p)
			p++;

		y = strtoul(p, &amp;p, 0);
		if(y == 0 || y &gt; 10240)
			error(Ebadarg);
		if(*p)
			p++;

		z = strtoul(p, &amp;p, 0);

		chanstr = cb-&gt;f[2];
		if((chan = strtochan(chanstr)) == 0)
			error("bad channel");

		if(chantodepth(chan) != z)
			error("depth, channel do not match");

		cursoroff(1);
		deletescreenimage();
		if(screensize(x, y, z, chan))
			error(Egreg);
		vgascreenwin(scr);
		resetscreenimage();
		cursoron(1);
		return;

	case CMactualsize:
		if(scr-&gt;gscreen == nil)
			error("set the screen size first");

		x = strtoul(cb-&gt;f[1], &amp;p, 0);
		if(x == 0 || x &gt; 2048)
			error(Ebadarg);
		if(*p)
			p++;

		y = strtoul(p, nil, 0);
		if(y == 0 || y &gt; 2048)
			error(Ebadarg);

		if(x &gt; scr-&gt;gscreen-&gt;r.max.x || y &gt; scr-&gt;gscreen-&gt;r.max.y)
			error("physical screen bigger than virtual");

		physgscreenr = Rect(0,0,x,y);
		scr-&gt;gscreen-&gt;clipr = physgscreenr;
		return;
	
	case CMpalettedepth:
		x = strtoul(cb-&gt;f[1], &amp;p, 0);
		if(x != 8 &amp;&amp; x != 6)
			error(Ebadarg);

		scr-&gt;palettedepth = x;
		return;

	case CMdrawinit:
		if(scr-&gt;gscreen == nil)
			error("drawinit: no gscreen");
		if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;drawinit)
			scr-&gt;dev-&gt;drawinit(scr);
		return;
	
	case CMlinear:
		if(cb-&gt;nf!=2 &amp;&amp; cb-&gt;nf!=3)
			error(Ebadarg);
		size = strtoul(cb-&gt;f[1], 0, 0);
		if(cb-&gt;nf == 2)
			align = 0;
		else
			align = strtoul(cb-&gt;f[2], 0, 0);
		if(screenaperture(size, align) &lt; 0)
			error("not enough free address space");
		return;
/*	
	case CMmemset:
		memset((void*)strtoul(cb-&gt;f[1], 0, 0), atoi(cb-&gt;f[2]), atoi(cb-&gt;f[3]));
		return;
*/

	case CMblank:
		drawblankscreen(1);
		return;
	
	case CMunblank:
		drawblankscreen(0);
		return;
	
	case CMblanktime:
		blanktime = strtoul(cb-&gt;f[1], 0, 0);
		return;

	case CMpanning:
		if(strcmp(cb-&gt;f[1], "on") == 0){
			if(scr == nil || scr-&gt;cur == nil)
				error("set screen first");
			if(!scr-&gt;cur-&gt;doespanning)
				error("panning not supported");
			scr-&gt;gscreen-&gt;clipr = scr-&gt;gscreen-&gt;r;
			panning = 1;
		}
		else if(strcmp(cb-&gt;f[1], "off") == 0){
			scr-&gt;gscreen-&gt;clipr = physgscreenr;
			panning = 0;
		}else
			break;
		return;

	case CMhwaccel:
		if(strcmp(cb-&gt;f[1], "on") == 0)
			hwaccel = 1;
		else if(strcmp(cb-&gt;f[1], "off") == 0)
			hwaccel = 0;
		else
			break;
		return;
	
	case CMhwblank:
		if(strcmp(cb-&gt;f[1], "on") == 0)
			hwblank = 1;
		else if(strcmp(cb-&gt;f[1], "off") == 0)
			hwblank = 0;
		else
			break;
		return;
	}

	cmderror(cb, "bad VGA control message");
}

char Enooverlay[] = "No overlay support";

static long
vgawrite(Chan* c, void* a, long n, vlong off)
{
	ulong offset = off;
	Cmdbuf *cb;
	VGAscr *scr;

	switch((ulong)c-&gt;qid.path){

	case Qdir:
		error(Eperm);

	case Qvgactl:
		if(offset || n &gt;= READSTR)
			error(Ebadarg);
		cb = parsecmd(a, n);
		if(waserror()){
			free(cb);
			nexterror();
		}
		vgactl(cb);
		poperror();
		free(cb);
		return n;

	case Qvgaovl:
		scr = &amp;vgascreen[0];
		if (scr-&gt;dev == nil || scr-&gt;dev-&gt;ovlwrite == nil) {
			error(Enooverlay);
			break;
		}
		return scr-&gt;dev-&gt;ovlwrite(scr, a, n, off);

	case Qvgaovlctl:
		scr = &amp;vgascreen[0];
		if (scr-&gt;dev == nil || scr-&gt;dev-&gt;ovlctl == nil) {
			error(Enooverlay);
			break;
		}
		scr-&gt;dev-&gt;ovlctl(scr, c, a, n);
		return n;

	default:
		error(Egreg);
		break;
	}

	return 0;
}

Dev vgadevtab = {
	'v',
	"vga",

	vgareset,
	devinit,
	devshutdown,
	vgaattach,
	vgawalk,
	vgastat,
	vgaopen,
	devcreate,
	vgaclose,
	vgaread,
	devbread,
	vgawrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

