<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/dma.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/dma.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"

typedef struct DMAport	DMAport;
typedef struct DMA	DMA;
typedef struct DMAxfer	DMAxfer;

/*
 *  state of a dma transfer
 */
struct DMAxfer
{
	ulong	bpa;		/* bounce buffer physical address */
	void*	bva;		/* bounce buffer virtual address */
	int	blen;		/* bounce buffer length */
	void*	va;		/* virtual address destination/src */
	long	len;		/* bytes to be transferred */
	int	isread;
};

/*
 *  the dma controllers.  the first half of this structure specifies
 *  the I/O ports used by the DMA controllers.
 */
struct DMAport
{
	uchar	addr[4];	/* current address (4 channels) */
	uchar	count[4];	/* current count (4 channels) */
	uchar	page[4];	/* page registers (4 channels) */
	uchar	cmd;		/* command status register */
	uchar	req;		/* request registers */
	uchar	sbm;		/* single bit mask register */
	uchar	mode;		/* mode register */
	uchar	cbp;		/* clear byte pointer */
	uchar	mc;		/* master clear */
	uchar	cmask;		/* clear mask register */
	uchar	wam;		/* write all mask register bit */
};

struct DMA
{
	DMAport;
	int	shift;
	Lock;
	DMAxfer	x[4];
};

DMA dma[2] = {
	{ 0x00, 0x02, 0x04, 0x06,
	  0x01, 0x03, 0x05, 0x07,
	  0x87, 0x83, 0x81, 0x82,
	  0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
	 0 },

	{ 0xc0, 0xc4, 0xc8, 0xcc,
	  0xc2, 0xc6, 0xca, 0xce,
	  0x8f, 0x8b, 0x89, 0x8a,
	  0xd0, 0xd2, 0xd4, 0xd6, 0xd8, 0xda, 0xdc, 0xde,
	 1 },
};

extern int i8237dma;
static void* i8237bva[2];
static int i8237used;

/*
 *  DMA must be in the first 16MB.  This gets called early by the
 *  initialisation routines of any devices which require DMA to ensure
 *  the allocated bounce buffers are below the 16MB limit.
 */
void
_i8237alloc(void)
{
	void* bva;

	if(i8237dma &lt;= 0)
		return;
	if(i8237dma &gt; 2)
		i8237dma = 2;

	bva = xspanalloc(64*1024*i8237dma, BY2PG, 64*1024);
	if(bva == nil || PADDR(bva)+64*1024*i8237dma &gt; 16*MB){
		/*
		 * This will panic with the current
		 * implementation of xspanalloc().
		if(bva != nil)
			xfree(bva);
		 */
		return;
	}

	i8237bva[0] = bva;
	if(i8237dma == 2)
		i8237bva[1] = ((uchar*)i8237bva[0])+64*1024;
}

/*
 *  DMA must be in the first 16MB.  This gets called early by the
 *  initialisation routines of any devices which require DMA to ensure
 *  the allocated bounce buffers are below the 16MB limit.
 */
int
dmainit(int chan, int maxtransfer)
{
	DMA *dp;
	DMAxfer *xp;
	static int once;

	if(once == 0){
		if(ioalloc(0x00, 0x10, 0, "dma") &lt; 0
		|| ioalloc(0x80, 0x10, 0, "dma") &lt; 0
		|| ioalloc(0xd0, 0x10, 0, "dma") &lt; 0)
			panic("dmainit");
		once = 1;
	}

	if(maxtransfer &gt; 64*1024)
		maxtransfer = 64*1024;

	dp = &amp;dma[(chan&gt;&gt;2)&amp;1];
	chan = chan &amp; 3;
	xp = &amp;dp-&gt;x[chan];
	if(xp-&gt;bva != nil){
		if(xp-&gt;blen &lt; maxtransfer)
			return 1;
		return 0;
	}

	if(i8237used &gt;= i8237dma || i8237bva[i8237used] == nil){
		print("no i8237 DMA bounce buffer &lt; 16MB\n");
		return 1;
	}
	xp-&gt;bva = i8237bva[i8237used++];
	xp-&gt;bpa = PADDR(xp-&gt;bva);
	xp-&gt;blen = maxtransfer;
	xp-&gt;len = 0;
	xp-&gt;isread = 0;

	return 0;
}

/*
 *  setup a dma transfer.  if the destination is not in kernel
 *  memory, allocate a page for the transfer.
 *
 *  we assume BIOS has set up the command register before we
 *  are booted.
 *
 *  return the updated transfer length (we can't transfer across 64k
 *  boundaries)
 */
long
dmasetup(int chan, void *va, long len, int isread)
{
	DMA *dp;
	ulong pa;
	uchar mode;
	DMAxfer *xp;

	dp = &amp;dma[(chan&gt;&gt;2)&amp;1];
	chan = chan &amp; 3;
	xp = &amp;dp-&gt;x[chan];

	/*
	 *  if this isn't kernel memory or crossing 64k boundary or above 16 meg
	 *  use the bounce buffer.
	 */
	if((ulong)va &lt; KZERO 
	|| ((pa=PADDR(va))&amp;0xFFFF0000) != ((pa+len)&amp;0xFFFF0000)
	|| pa &gt;= 16*MB){
		if(xp-&gt;bva == nil)
			return -1;
		if(len &gt; xp-&gt;blen)
			len = xp-&gt;blen;
		if(!isread)
			memmove(xp-&gt;bva, va, len);
		xp-&gt;va = va;
		xp-&gt;len = len;
		xp-&gt;isread = isread;
		pa = xp-&gt;bpa;
	}
	else
		xp-&gt;len = 0;

	/*
	 * this setup must be atomic
	 */
	ilock(dp);
	mode = (isread ? 0x44 : 0x48) | chan;
	outb(dp-&gt;mode, mode);	/* single mode dma (give CPU a chance at mem) */
	outb(dp-&gt;page[chan], pa&gt;&gt;16);
	outb(dp-&gt;cbp, 0);		/* set count &amp; address to their first byte */
	outb(dp-&gt;addr[chan], pa&gt;&gt;dp-&gt;shift);		/* set address */
	outb(dp-&gt;addr[chan], pa&gt;&gt;(8+dp-&gt;shift));
	outb(dp-&gt;count[chan], (len&gt;&gt;dp-&gt;shift)-1);		/* set count */
	outb(dp-&gt;count[chan], ((len&gt;&gt;dp-&gt;shift)-1)&gt;&gt;8);
	outb(dp-&gt;sbm, chan);		/* enable the channel */
	iunlock(dp);

	return len;
}

int
dmadone(int chan)
{
	DMA *dp;

	dp = &amp;dma[(chan&gt;&gt;2)&amp;1];
	chan = chan &amp; 3;

	return inb(dp-&gt;cmd) &amp; (1&lt;&lt;chan);
}

/*
 *  this must be called after a dma has been completed.
 *
 *  if a page has been allocated for the dma,
 *  copy the data into the actual destination
 *  and free the page.
 */
void
dmaend(int chan)
{
	DMA *dp;
	DMAxfer *xp;

	dp = &amp;dma[(chan&gt;&gt;2)&amp;1];
	chan = chan &amp; 3;

	/*
	 *  disable the channel
	 */
	ilock(dp);
	outb(dp-&gt;sbm, 4|chan);
	iunlock(dp);

	xp = &amp;dp-&gt;x[chan];
	if(xp-&gt;len == 0 || !xp-&gt;isread)
		return;

	/*
	 *  copy out of temporary page
	 */
	memmove(xp-&gt;va, xp-&gt;bva, xp-&gt;len);
	xp-&gt;len = 0;
}

/*
int
dmacount(int chan)
{
	int     retval;
	DMA     *dp;
 
	dp = &amp;dma[(chan&gt;&gt;2)&amp;1];
	outb(dp-&gt;cbp, 0);
	retval = inb(dp-&gt;count[chan]);
	retval |= inb(dp-&gt;count[chan]) &lt;&lt; 8;
	return((retval&lt;&lt;dp-&gt;shift)+1);
}
 */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

