<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ether79c970.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ether79c970.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * AMD79C970
 * PCnet-PCI Single-Chip Ethernet Controller for PCI Local Bus
 * To do:
 *	finish this rewrite
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

enum {
	Lognrdre	= 6,
	Nrdre		= (1&lt;&lt;Lognrdre),/* receive descriptor ring entries */
	Logntdre	= 4,
	Ntdre		= (1&lt;&lt;Logntdre),/* transmit descriptor ring entries */

	Rbsize		= ETHERMAXTU+4,	/* ring buffer size (+4 for CRC) */
};

enum {					/* DWIO I/O resource map */
	Aprom		= 0x0000,	/* physical address */
	Rdp		= 0x0010,	/* register data port */
	Rap		= 0x0014,	/* register address port */
	Sreset		= 0x0018,	/* software reset */
	Bdp		= 0x001C,	/* bus configuration register data port */
};

enum {					/* CSR0 */
	Init		= 0x0001,	/* begin initialisation */
	Strt		= 0x0002,	/* enable chip */
	Stop		= 0x0004,	/* disable chip */
	Tdmd		= 0x0008,	/* transmit demand */
	Txon		= 0x0010,	/* transmitter on */
	Rxon		= 0x0020,	/* receiver on */
	Iena		= 0x0040,	/* interrupt enable */
	Intr		= 0x0080,	/* interrupt flag */
	Idon		= 0x0100,	/* initialisation done */
	Tint		= 0x0200,	/* transmit interrupt */
	Rint		= 0x0400,	/* receive interrupt */
	Merr		= 0x0800,	/* memory error */
	Miss		= 0x1000,	/* missed frame */
	Cerr		= 0x2000,	/* collision */
	Babl		= 0x4000,	/* transmitter timeout */
	Err		= 0x8000,	/* Babl|Cerr|Miss|Merr */
};
	
enum {					/* CSR3 */
	Bswp		= 0x0004,	/* byte swap */
	Emba		= 0x0008,	/* enable modified back-off algorithm */
	Dxmt2pd		= 0x0010,	/* disable transmit two part deferral */
	Lappen		= 0x0020,	/* look-ahead packet processing enable */
};

enum {					/* CSR4 */
	ApadXmt		= 0x0800,	/* auto pad transmit */
};

enum {					/* CSR15 */
	Prom		= 0x8000,	/* promiscuous mode */
};

typedef struct Iblock Iblock;
struct Iblock {			/* Initialisation Block */
	ushort	mode;
	uchar	rlen;			/* upper 4 bits */
	uchar	tlen;			/* upper 4 bits */
	uchar	padr[6];
	uchar	res[2];
	uchar	ladr[8];
	ulong	rdra;
	ulong	tdra;
};

typedef struct Dre Dre;
struct Dre {			/* descriptor ring entry */
	ulong	addr;
	ulong	md1;			/* status|bcnt */
	ulong	md2;			/* rcc|rpc|mcnt */
	Block*	bp;
};

enum {					/* md1 */
	Enp		= 0x01000000,	/* end of packet */
	Stp		= 0x02000000,	/* start of packet */
	RxBuff		= 0x04000000,	/* buffer error */
	Def		= 0x04000000,	/* deferred */
	Crc		= 0x08000000,	/* CRC error */
	One		= 0x08000000,	/* one retry needed */
	Oflo		= 0x10000000,	/* overflow error */
	More		= 0x10000000,	/* more than one retry needed */
	Fram		= 0x20000000,	/* framing error */
	RxErr		= 0x40000000,	/* Fram|Oflo|Crc|RxBuff */
	TxErr		= 0x40000000,	/* Uflo|Lcol|Lcar|Rtry */
	Own		= 0x80000000,
};

enum {					/* md2 */
	Rtry		= 0x04000000,	/* failed after repeated retries */
	Lcar		= 0x08000000,	/* loss of carrier */
	Lcol		= 0x10000000,	/* late collision */
	Uflo		= 0x40000000,	/* underflow error */
	TxBuff		= 0x80000000,	/* buffer error */
};

typedef struct Ctlr Ctlr;
struct Ctlr {
	Lock;
	int	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;

	int	init;			/* initialisation in progress */
	Iblock	iblock;

	Dre*	rdr;			/* receive descriptor ring */
	int	rdrx;

	Dre*	tdr;			/* transmit descriptor ring */
	int	tdrh;			/* host index into tdr */
	int	tdri;			/* interface index into tdr */
	int	ntq;			/* descriptors active */

	ulong	rxbuff;			/* receive statistics */
	ulong	crc;
	ulong	oflo;
	ulong	fram;

	ulong	rtry;			/* transmit statistics */
	ulong	lcar;
	ulong	lcol;
	ulong	uflo;
	ulong	txbuff;

	ulong	merr;			/* bobf is such a whiner */
	ulong	miss;
	ulong	babl;

	int	(*ior)(Ctlr*, int);
	void	(*iow)(Ctlr*, int, int);
};

static Ctlr* ctlrhead;
static Ctlr* ctlrtail;

/*
 * The Rdp, Rap, Sreset, Bdp ports are 32-bit port offset in the enumeration above.
 * To get to 16-bit offsets, scale down with 0x10 staying the same.
 */
static int
io16r(Ctlr *c, int r)
{
	if(r &gt;= Rdp)
		r = (r-Rdp)/2+Rdp;
	return ins(c-&gt;port+r);
}

static void
io16w(Ctlr *c, int r, int v)
{
	if(r &gt;= Rdp)
		r = (r-Rdp)/2+Rdp;
	outs(c-&gt;port+r, v);
}

static int
io32r(Ctlr *c, int r)
{
	return inl(c-&gt;port+r);
}

static void
io32w(Ctlr *c, int r, int v)
{
	outl(c-&gt;port+r, v);
}

static void
attach(Ether*)
{
}

static long
ifstat(Ether* ether, void* a, long n, ulong offset)
{
	char *p;
	int len;
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;

	ether-&gt;crcs = ctlr-&gt;crc;
	ether-&gt;frames = ctlr-&gt;fram;
	ether-&gt;buffs = ctlr-&gt;rxbuff+ctlr-&gt;txbuff;
	ether-&gt;overflows = ctlr-&gt;oflo;

	if(n == 0)
		return 0;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	len = snprint(p, READSTR, "Rxbuff: %ld\n", ctlr-&gt;rxbuff);
	len += snprint(p+len, READSTR-len, "Crc: %ld\n", ctlr-&gt;crc);
	len += snprint(p+len, READSTR-len, "Oflo: %ld\n", ctlr-&gt;oflo);
	len += snprint(p+len, READSTR-len, "Fram: %ld\n", ctlr-&gt;fram);
	len += snprint(p+len, READSTR-len, "Rtry: %ld\n", ctlr-&gt;rtry);
	len += snprint(p+len, READSTR-len, "Lcar: %ld\n", ctlr-&gt;lcar);
	len += snprint(p+len, READSTR-len, "Lcol: %ld\n", ctlr-&gt;lcol);
	len += snprint(p+len, READSTR-len, "Uflo: %ld\n", ctlr-&gt;uflo);
	len += snprint(p+len, READSTR-len, "Txbuff: %ld\n", ctlr-&gt;txbuff);
	len += snprint(p+len, READSTR-len, "Merr: %ld\n", ctlr-&gt;merr);
	len += snprint(p+len, READSTR-len, "Miss: %ld\n", ctlr-&gt;miss);
	snprint(p+len, READSTR-len, "Babl: %ld\n", ctlr-&gt;babl);

	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

static void
ringinit(Ctlr* ctlr)
{
	Dre *dre;

	/*
	 * Initialise the receive and transmit buffer rings.
	 * The ring entries must be aligned on 16-byte boundaries.
	 *
	 * This routine is protected by ctlr-&gt;init.
	 */
	if(ctlr-&gt;rdr == 0){
		ctlr-&gt;rdr = xspanalloc(Nrdre*sizeof(Dre), 0x10, 0);
		for(dre = ctlr-&gt;rdr; dre &lt; &amp;ctlr-&gt;rdr[Nrdre]; dre++){
			dre-&gt;bp = iallocb(Rbsize);
			if(dre-&gt;bp == nil)
				panic("can't allocate ethernet receive ring\n");
			dre-&gt;addr = PADDR(dre-&gt;bp-&gt;rp);
			dre-&gt;md2 = 0;
			dre-&gt;md1 = Own|(-Rbsize &amp; 0xFFFF);
		}
	}
	ctlr-&gt;rdrx = 0;

	if(ctlr-&gt;tdr == 0)
		ctlr-&gt;tdr = xspanalloc(Ntdre*sizeof(Dre), 0x10, 0);
	memset(ctlr-&gt;tdr, 0, Ntdre*sizeof(Dre));
	ctlr-&gt;tdrh = ctlr-&gt;tdri = 0;
}

static void
promiscuous(void* arg, int on)
{
	Ether *ether;
	int x;
	Ctlr *ctlr;

	ether = arg;
	ctlr = ether-&gt;ctlr;

	/*
	 * Put the chip into promiscuous mode. First must wait until
	 * anyone transmitting is done, then stop the chip and put
	 * it in promiscuous mode. Restarting is made harder by the chip
	 * reloading the transmit and receive descriptor pointers with their
	 * base addresses when Strt is set (unlike the older Lance chip),
	 * so the rings must be re-initialised.
	 */
	ilock(ctlr);
	if(ctlr-&gt;init){
		iunlock(ctlr);
		return;
	}
	ctlr-&gt;init = 1;
	iunlock(ctlr);

	while(ctlr-&gt;ntq)
		;

	ctlr-&gt;iow(ctlr, Rdp, Stop);

	ctlr-&gt;iow(ctlr, Rap, 15);
	x = ctlr-&gt;ior(ctlr, Rdp) &amp; ~Prom;
	if(on)
		x |= Prom;
	ctlr-&gt;iow(ctlr, Rdp, x);
	ctlr-&gt;iow(ctlr, Rap, 0);

	ringinit(ctlr);

	ilock(ctlr);
	ctlr-&gt;init = 0;
	ctlr-&gt;iow(ctlr, Rdp, Iena|Strt);
	iunlock(ctlr);
}

static void
multicast(void* arg, uchar*, int)
{
	promiscuous(arg, 1);
}

static void
shutdown(Ether *ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	io32r(ctlr, Sreset);
	io16r(ctlr, Sreset);
	iunlock(ctlr);
}

static void
txstart(Ether* ether)
{
	Ctlr *ctlr;
	Block *bp;
	Dre *dre;

	ctlr = ether-&gt;ctlr;

	if(ctlr-&gt;init)
		return;

	while(ctlr-&gt;ntq &lt; (Ntdre-1)){
		bp = qget(ether-&gt;oq);
		if(bp == nil)
			break;

		/*
		 * Give ownership of the descriptor to the chip,
		 * increment the software ring descriptor pointer
		 * and tell the chip to poll.
		 * There's no need to pad to ETHERMINTU
		 * here as ApadXmt is set in CSR4.
		 */
		dre = &amp;ctlr-&gt;tdr[ctlr-&gt;tdrh];
		dre-&gt;bp = bp;
		dre-&gt;addr = PADDR(bp-&gt;rp);
		dre-&gt;md2 = 0;
		dre-&gt;md1 = Own|Stp|Enp|(-BLEN(bp) &amp; 0xFFFF);
		ctlr-&gt;ntq++;
		ctlr-&gt;iow(ctlr, Rdp, Iena|Tdmd);
		ctlr-&gt;tdrh = NEXT(ctlr-&gt;tdrh, Ntdre);
	}
}

static void
transmit(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	txstart(ether);
	iunlock(ctlr);
}

static void
interrupt(Ureg*, void* arg)
{
	Ctlr *ctlr;
	Ether *ether;
	int csr0, len;
	Dre *dre;
	Block *bp;

	ether = arg;
	ctlr = ether-&gt;ctlr;

	/*
	 * Acknowledge all interrupts and whine about those that shouldn't
	 * happen.
	 */
intrloop:
	csr0 = ctlr-&gt;ior(ctlr, Rdp) &amp; 0xFFFF;
	ctlr-&gt;iow(ctlr, Rdp, Babl|Cerr|Miss|Merr|Rint|Tint|Iena);
	if(csr0 &amp; Merr)
		ctlr-&gt;merr++;
	if(csr0 &amp; Miss)
		ctlr-&gt;miss++;
	if(csr0 &amp; Babl)
		ctlr-&gt;babl++;
	//if(csr0 &amp; (Babl|Miss|Merr))
	//	print("#l%d: csr0 = 0x%uX\n", ether-&gt;ctlrno, csr0);
	if(!(csr0 &amp; (Rint|Tint)))
		return;

	/*
	 * Receiver interrupt: run round the descriptor ring logging
	 * errors and passing valid receive data up to the higher levels
	 * until a descriptor is encountered still owned by the chip.
	 */
	if(csr0 &amp; Rint){
		dre = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
		while(!(dre-&gt;md1 &amp; Own)){
			if(dre-&gt;md1 &amp; RxErr){
				if(dre-&gt;md1 &amp; RxBuff)
					ctlr-&gt;rxbuff++;
				if(dre-&gt;md1 &amp; Crc)
					ctlr-&gt;crc++;
				if(dre-&gt;md1 &amp; Oflo)
					ctlr-&gt;oflo++;
				if(dre-&gt;md1 &amp; Fram)
					ctlr-&gt;fram++;
			}
			else if(bp = iallocb(Rbsize)){
				len = (dre-&gt;md2 &amp; 0x0FFF)-4;
				dre-&gt;bp-&gt;wp = dre-&gt;bp-&gt;rp+len;
				etheriq(ether, dre-&gt;bp, 1);
				dre-&gt;bp = bp;
				dre-&gt;addr = PADDR(bp-&gt;rp);
			}

			/*
			 * Finished with this descriptor, reinitialise it,
			 * give it back to the chip, then on to the next...
			 */
			dre-&gt;md2 = 0;
			dre-&gt;md1 = Own|(-Rbsize &amp; 0xFFFF);

			ctlr-&gt;rdrx = NEXT(ctlr-&gt;rdrx, Nrdre);
			dre = &amp;ctlr-&gt;rdr[ctlr-&gt;rdrx];
		}
	}

	/*
	 * Transmitter interrupt: wakeup anyone waiting for a free descriptor.
	 */
	if(csr0 &amp; Tint){
		lock(ctlr);
		while(ctlr-&gt;ntq){
			dre = &amp;ctlr-&gt;tdr[ctlr-&gt;tdri];
			if(dre-&gt;md1 &amp; Own)
				break;
	
			if(dre-&gt;md1 &amp; TxErr){
				if(dre-&gt;md2 &amp; Rtry)
					ctlr-&gt;rtry++;
				if(dre-&gt;md2 &amp; Lcar)
					ctlr-&gt;lcar++;
				if(dre-&gt;md2 &amp; Lcol)
					ctlr-&gt;lcol++;
				if(dre-&gt;md2 &amp; Uflo)
					ctlr-&gt;uflo++;
				if(dre-&gt;md2 &amp; TxBuff)
					ctlr-&gt;txbuff++;
				ether-&gt;oerrs++;
			}
	
			freeb(dre-&gt;bp);
	
			ctlr-&gt;ntq--;
			ctlr-&gt;tdri = NEXT(ctlr-&gt;tdri, Ntdre);
		}
		txstart(ether);
		unlock(ctlr);
	}
	goto intrloop;
}

static void
amd79c970pci(void)
{
	int port;
	Ctlr *ctlr;
	Pcidev *p;

	p = nil;
	while(p = pcimatch(p, 0x1022, 0x2000)){
		port = p-&gt;mem[0].bar &amp; ~0x01;
		if(ioalloc(port, p-&gt;mem[0].size, 0, "amd79c970") &lt; 0){
			print("amd79c970: port 0x%uX in use\n", port);
			continue;
		}
		ctlr = malloc(sizeof(Ctlr));
		if(ctlr == nil)
			error(Enomem);
		ctlr-&gt;port = p-&gt;mem[0].bar &amp; ~0x01;
		ctlr-&gt;pcidev = p;

		if(ctlrhead != nil)
			ctlrtail-&gt;next = ctlr;
		else
			ctlrhead = ctlr;
		ctlrtail = ctlr;
	}
}

static int
reset(Ether* ether)
{
	int x;
	uchar ea[Eaddrlen];
	Ctlr *ctlr;

	if(ctlrhead == nil)
		amd79c970pci();

	/*
	 * Any adapter matches if no port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = ctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		if(ether-&gt;port == 0 || ether-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	if(ctlr == nil)
		return -1;

	/*
	 * Allocate a controller structure and start to initialise it.
	 */
	ether-&gt;ctlr = ctlr;
	ether-&gt;port = ctlr-&gt;port;
	ether-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	ether-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;
	pcisetbme(ctlr-&gt;pcidev);
	shutdown(ether);
	ilock(ctlr);
	ctlr-&gt;init = 1;

	if(io16w(ctlr, Rap, 0), io16r(ctlr, Rdp) == 4){
		ctlr-&gt;ior = io16r;
		ctlr-&gt;iow = io16w;
	}else if(io32w(ctlr, Rap, 0), io32r(ctlr, Rdp) == 4){
		ctlr-&gt;ior = io32r;
		ctlr-&gt;iow = io32w;
	}else{
		print("#l%d: card doesn't talk right\n", ether-&gt;ctlrno);
		iunlock(ctlr);
		return -1;
	}

	ctlr-&gt;iow(ctlr, Rap, 88);
	x = ctlr-&gt;ior(ctlr, Rdp);
	ctlr-&gt;iow(ctlr, Rap, 89);
	x |= ctlr-&gt;ior(ctlr, Rdp)&lt;&lt;16;

	switch(x&amp;0xFFFFFFF){
	case 0x2420003:	/* PCnet/PCI 79C970 */
	case 0x2621003:	/* PCnet/PCI II 79C970A */
	case 0x2625003:	/* PCnet-FAST III 79C973 */
		break;
	default:
		print("#l%d: unknown PCnet card version 0x%.7ux\n",
			ether-&gt;ctlrno, x&amp;0xFFFFFFF);
		iunlock(ctlr);
		return -1;
	}

	/*
	 * Set the software style in BCR20 to be PCnet-PCI to ensure 32-bit access.
	 * Set the auto pad transmit in CSR4.
	 */
	ctlr-&gt;iow(ctlr, Rap, 20);
	ctlr-&gt;iow(ctlr, Bdp, 0x0002);

	ctlr-&gt;iow(ctlr, Rap, 4);
	x = ctlr-&gt;ior(ctlr, Rdp) &amp; 0xFFFF;
	ctlr-&gt;iow(ctlr, Rdp, ApadXmt|x);

	ctlr-&gt;iow(ctlr, Rap, 0);

	/*
	 * Check if the adapter's station address is to be overridden.
	 * If not, read it from the I/O-space and set in ether-&gt;ea prior to
	 * loading the station address in the initialisation block.
	 */
	memset(ea, 0, Eaddrlen);
	if(!memcmp(ea, ether-&gt;ea, Eaddrlen)){
		x = ctlr-&gt;ior(ctlr, Aprom);
		ether-&gt;ea[0] = x;
		ether-&gt;ea[1] = x&gt;&gt;8;
		if(ctlr-&gt;ior == io16r)
			x = ctlr-&gt;ior(ctlr, Aprom+2);
		else
			x &gt;&gt;= 16;
		ether-&gt;ea[2] = x;
		ether-&gt;ea[3] = x&gt;&gt;8;
		x = ctlr-&gt;ior(ctlr, Aprom+4);
		ether-&gt;ea[4] = x;
		ether-&gt;ea[5] = x&gt;&gt;8;
	}

	/*
	 * Start to fill in the initialisation block
	 * (must be DWORD aligned).
	 */
	ctlr-&gt;iblock.rlen = Lognrdre&lt;&lt;4;
	ctlr-&gt;iblock.tlen = Logntdre&lt;&lt;4;
	memmove(ctlr-&gt;iblock.padr, ether-&gt;ea, sizeof(ctlr-&gt;iblock.padr));

	ringinit(ctlr);
	ctlr-&gt;iblock.rdra = PADDR(ctlr-&gt;rdr);
	ctlr-&gt;iblock.tdra = PADDR(ctlr-&gt;tdr);

	/*
	 * Point the chip at the initialisation block and tell it to go.
	 * Mask the Idon interrupt and poll for completion. Strt and interrupt
	 * enables will be set later when attaching to the network.
	 */
	x = PADDR(&amp;ctlr-&gt;iblock);
	ctlr-&gt;iow(ctlr, Rap, 1);
	ctlr-&gt;iow(ctlr, Rdp, x &amp; 0xFFFF);
	ctlr-&gt;iow(ctlr, Rap, 2);
	ctlr-&gt;iow(ctlr, Rdp, (x&gt;&gt;16) &amp; 0xFFFF);
	ctlr-&gt;iow(ctlr, Rap, 3);
	ctlr-&gt;iow(ctlr, Rdp, Idon);
	ctlr-&gt;iow(ctlr, Rap, 0);
	ctlr-&gt;iow(ctlr, Rdp, Init);

	while(!(ctlr-&gt;ior(ctlr, Rdp) &amp; Idon))
		;

	/*
	 * We used to set CSR0 to Idon|Stop here, and then
	 * in attach change it to Iena|Strt.  Apparently the simulated
	 * 79C970 in VMware never enables after a write of Idon|Stop,
	 * so we enable the device here now.
	 */
	ctlr-&gt;iow(ctlr, Rdp, Iena|Strt);
	ctlr-&gt;init = 0;
	iunlock(ctlr);

	/*
	 * Linkage to the generic ethernet driver.
	 */
	ether-&gt;attach = attach;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;ifstat = ifstat;

	ether-&gt;arg = ether;
	ether-&gt;promiscuous = promiscuous;
	ether-&gt;multicast = multicast;
	ether-&gt;shutdown = shutdown;

	return 0;
}

void
ether79c970link(void)
{
	addethercard("AMD79C970",  reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

