<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ether82557.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ether82557.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Intel 82557 Fast Ethernet PCI Bus LAN Controller
 * as found on the Intel EtherExpress PRO/100B. This chip is full
 * of smarts, unfortunately they're not all in the right place.
 * To do:
 *	the PCI scanning code could be made common to other adapters;
 *	auto-negotiation, full-duplex;
 *	optionally use memory-mapped registers;
 *	detach for PCI reset problems (also towards loadable drivers).
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"

enum {
	/*
	 * these were both 64.  increased them to try to improve lookout's
	 * reliability as a pxe booter.
	 */
	Nrfd		= 128,		/* receive frame area */
	Ncb		= 128,		/* maximum control blocks queued */

	NullPointer	= 0xFFFFFFFF,	/* 82557 NULL pointer */
};

enum {					/* CSR */
	Status		= 0x00,		/* byte or word (word includes Ack) */
	Ack		= 0x01,		/* byte */
	CommandR	= 0x02,		/* byte or word (word includes Interrupt) */
	Interrupt	= 0x03,		/* byte */
	General		= 0x04,		/* dword */
	Port		= 0x08,		/* dword */
	Fcr		= 0x0C,		/* Flash control register */
	Ecr		= 0x0E,		/* EEPROM control register */
	Mcr		= 0x10,		/* MDI control register */
	Gstatus		= 0x1D,		/* General status register */
};

enum {					/* Status */
	RUidle		= 0x0000,
	RUsuspended	= 0x0004,
	RUnoresources	= 0x0008,
	RUready		= 0x0010,
	RUrbd		= 0x0020,	/* bit */
	RUstatus	= 0x003F,	/* mask */

	CUidle		= 0x0000,
	CUsuspended	= 0x0040,
	CUactive	= 0x0080,
	CUstatus	= 0x00C0,	/* mask */

	StatSWI		= 0x0400,	/* SoftWare generated Interrupt */
	StatMDI		= 0x0800,	/* MDI r/w done */
	StatRNR		= 0x1000,	/* Receive unit Not Ready */
	StatCNA		= 0x2000,	/* Command unit Not Active (Active-&gt;Idle) */
	StatFR		= 0x4000,	/* Finished Receiving */
	StatCX		= 0x8000,	/* Command eXecuted */
	StatTNO		= 0x8000,	/* Transmit NOT OK */
};

enum {					/* Command (byte) */
	CUnop		= 0x00,
	CUstart		= 0x10,
	CUresume	= 0x20,
	LoadDCA		= 0x40,		/* Load Dump Counters Address */
	DumpSC		= 0x50,		/* Dump Statistical Counters */
	LoadCUB		= 0x60,		/* Load CU Base */
	ResetSA		= 0x70,		/* Dump and Reset Statistical Counters */

	RUstart		= 0x01,
	RUresume	= 0x02,
	RUabort		= 0x04,
	LoadHDS		= 0x05,		/* Load Header Data Size */
	LoadRUB		= 0x06,		/* Load RU Base */
	RBDresume	= 0x07,		/* Resume frame reception */
};

enum {					/* Interrupt (byte) */
	InterruptM	= 0x01,		/* interrupt Mask */
	InterruptSI	= 0x02,		/* Software generated Interrupt */
};

enum {					/* Ecr */
	EEsk		= 0x01,		/* serial clock */
	EEcs		= 0x02,		/* chip select */
	EEdi		= 0x04,		/* serial data in */
	EEdo		= 0x08,		/* serial data out */

	EEstart		= 0x04,		/* start bit */
	EEread		= 0x02,		/* read opcode */
};

enum {					/* Mcr */
	MDIread		= 0x08000000,	/* read opcode */
	MDIwrite	= 0x04000000,	/* write opcode */
	MDIready	= 0x10000000,	/* ready bit */
	MDIie		= 0x20000000,	/* interrupt enable */
};

typedef struct Rfd {
	int	field;
	ulong	link;
	ulong	rbd;
	ushort	count;
	ushort	size;

	uchar	data[1700];
} Rfd;

enum {					/* field */
	RfdCollision	= 0x00000001,
	RfdIA		= 0x00000002,	/* IA match */
	RfdRxerr	= 0x00000010,	/* PHY character error */
	RfdType		= 0x00000020,	/* Type frame */
	RfdRunt		= 0x00000080,
	RfdOverrun	= 0x00000100,
	RfdBuffer	= 0x00000200,
	RfdAlignment	= 0x00000400,
	RfdCRC		= 0x00000800,

	RfdOK		= 0x00002000,	/* frame received OK */
	RfdC		= 0x00008000,	/* reception Complete */
	RfdSF		= 0x00080000,	/* Simplified or Flexible (1) Rfd */
	RfdH		= 0x00100000,	/* Header RFD */

	RfdI		= 0x20000000,	/* Interrupt after completion */
	RfdS		= 0x40000000,	/* Suspend after completion */
	RfdEL		= 0x80000000,	/* End of List */
};

enum {					/* count */
	RfdF		= 0x4000,
	RfdEOF		= 0x8000,
};

typedef struct Cb Cb;
typedef struct Cb {
	ushort	status;
	ushort	command;
	ulong	link;
	union {
		uchar	data[24];	/* CbIAS + CbConfigure */
		struct {
			ulong	tbd;
			ushort	count;
			uchar	threshold;
			uchar	number;

			ulong	tba;
			ushort	tbasz;
			ushort	pad;
		};
	};

	Block*	bp;
	Cb*	next;
} Cb;

enum {					/* action command */
	CbU		= 0x1000,	/* transmit underrun */
	CbOK		= 0x2000,	/* DMA completed OK */
	CbC		= 0x8000,	/* execution Complete */

	CbNOP		= 0x0000,
	CbIAS		= 0x0001,	/* Individual Address Setup */
	CbConfigure	= 0x0002,
	CbMAS		= 0x0003,	/* Multicast Address Setup */
	CbTransmit	= 0x0004,
	CbDump		= 0x0006,
	CbDiagnose	= 0x0007,
	CbCommand	= 0x0007,	/* mask */

	CbSF		= 0x0008,	/* Flexible-mode CbTransmit */

	CbI		= 0x2000,	/* Interrupt after completion */
	CbS		= 0x4000,	/* Suspend after completion */
	CbEL		= 0x8000,	/* End of List */
};

enum {					/* CbTransmit count */
	CbEOF		= 0x8000,
};

typedef struct Ctlr Ctlr;
typedef struct Ctlr {
	Lock	slock;			/* attach */
	int	state;

	int	port;
	Pcidev*	pcidev;
	Ctlr*	next;
	int	active;

	int	eepromsz;		/* address size in bits */
	ushort*	eeprom;

	Lock	miilock;

	int	tick;

	Lock	rlock;			/* registers */
	int	command;		/* last command issued */

	Block*	rfdhead;		/* receive side */
	Block*	rfdtail;
	int	nrfd;

	Lock	cblock;			/* transmit side */
	int	action;
	int	nop;
	uchar	configdata[24];
	int	threshold;
	int	ncb;
	Cb*	cbr;
	Cb*	cbhead;
	Cb*	cbtail;
	int	cbq;
	int	cbqmax;
	int	cbqmaxhw;

	Lock	dlock;			/* dump statistical counters */
	ulong	dump[17];
} Ctlr;

static Ctlr* ctlrhead;
static Ctlr* ctlrtail;

static uchar configdata[24] = {
	0x16,				/* byte count */
	0x08,				/* Rx/Tx FIFO limit */
	0x00,				/* adaptive IFS */
	0x00,	
	0x00,				/* Rx DMA maximum byte count */
//	0x80,				/* Tx DMA maximum byte count */
	0x00,				/* Tx DMA maximum byte count */
	0x32,				/* !late SCB, CNA interrupts */
	0x03,				/* discard short Rx frames */
	0x00,				/* 503/MII */

	0x00,	
	0x2E,				/* normal operation, NSAI */
	0x00,				/* linear priority */
	0x60,				/* inter-frame spacing */
	0x00,	
	0xF2,	
	0xC8,				/* 503, promiscuous mode off */
	0x00,	
	0x40,	
	0xF3,				/* transmit padding enable */
	0x80,				/* full duplex pin enable */
	0x3F,				/* no Multi IA */
	0x05,				/* no Multi Cast ALL */
};

#define csr8r(c, r)	(inb((c)-&gt;port+(r)))
#define csr16r(c, r)	(ins((c)-&gt;port+(r)))
#define csr32r(c, r)	(inl((c)-&gt;port+(r)))
#define csr8w(c, r, b)	(outb((c)-&gt;port+(r), (int)(b)))
#define csr16w(c, r, w)	(outs((c)-&gt;port+(r), (ushort)(w)))
#define csr32w(c, r, l)	(outl((c)-&gt;port+(r), (ulong)(l)))

static void
command(Ctlr* ctlr, int c, int v)
{
	int timeo;

	ilock(&amp;ctlr-&gt;rlock);

	/*
	 * Only back-to-back CUresume can be done
	 * without waiting for any previous command to complete.
	 * This should be the common case.
	 * Unfortunately there's a chip errata where back-to-back
	 * CUresumes can be lost, the fix is to always wait.
	if(c == CUresume &amp;&amp; ctlr-&gt;command == CUresume){
		csr8w(ctlr, CommandR, c);
		iunlock(&amp;ctlr-&gt;rlock);
		return;
	}
	 */

	for(timeo = 0; timeo &lt; 100; timeo++){
		if(!csr8r(ctlr, CommandR))
			break;
		microdelay(1);
	}
	if(timeo &gt;= 100){
		ctlr-&gt;command = -1;
		iunlock(&amp;ctlr-&gt;rlock);
		iprint("i82557: command %#ux %#ux timeout\n", c, v);
		return;
	}

	switch(c){

	case CUstart:
	case LoadDCA:
	case LoadCUB:
	case RUstart:
	case LoadHDS:
	case LoadRUB:
		csr32w(ctlr, General, v);
		break;

	/*
	case CUnop:
	case CUresume:
	case DumpSC:
	case ResetSA:
	case RUresume:
	case RUabort:
	 */
	default:
		break;
	}
	csr8w(ctlr, CommandR, c);
	ctlr-&gt;command = c;

	iunlock(&amp;ctlr-&gt;rlock);
}

static Block*
rfdalloc(ulong link)
{
	Block *bp;
	Rfd *rfd;

	if(bp = iallocb(sizeof(Rfd))){
		rfd = (Rfd*)bp-&gt;rp;
		rfd-&gt;field = 0;
		rfd-&gt;link = link;
		rfd-&gt;rbd = NullPointer;
		rfd-&gt;count = 0;
		rfd-&gt;size = sizeof(Etherpkt);
	}

	return bp;
}

static void
ethwatchdog(void* arg)
{
	Ether *ether;
	Ctlr *ctlr;
	static void txstart(Ether*);

	ether = arg;
	for(;;){
		tsleep(&amp;up-&gt;sleep, return0, 0, 4000);

		/*
		 * Hmmm. This doesn't seem right. Currently
		 * the device can't be disabled but it may be in
		 * the future.
		 */
		ctlr = ether-&gt;ctlr;
		if(ctlr == nil || ctlr-&gt;state == 0){
			print("%s: exiting\n", up-&gt;text);
			pexit("disabled", 0);
		}

		ilock(&amp;ctlr-&gt;cblock);
		if(ctlr-&gt;tick++){
			ctlr-&gt;action = CbMAS;
			txstart(ether);
		}
		iunlock(&amp;ctlr-&gt;cblock);
	}
}

static void
attach(Ether* ether)
{
	Ctlr *ctlr;
	char name[KNAMELEN];

	ctlr = ether-&gt;ctlr;
	lock(&amp;ctlr-&gt;slock);
	if(ctlr-&gt;state == 0){
		ilock(&amp;ctlr-&gt;rlock);
		csr8w(ctlr, Interrupt, 0);
		iunlock(&amp;ctlr-&gt;rlock);
		command(ctlr, RUstart, PADDR(ctlr-&gt;rfdhead-&gt;rp));
		ctlr-&gt;state = 1;

		/*
		 * Start the watchdog timer for the receive lockup errata
		 * unless the EEPROM compatibility word indicates it may be
		 * omitted.
		 */
		if((ctlr-&gt;eeprom[0x03] &amp; 0x0003) != 0x0003){
			snprint(name, KNAMELEN, "#l%dwatchdog", ether-&gt;ctlrno);
			kproc(name, ethwatchdog, ether);
		}
	}
	unlock(&amp;ctlr-&gt;slock);
}

static long
ifstat(Ether* ether, void* a, long n, ulong offset)
{
	char *p;
	int i, len, phyaddr;
	Ctlr *ctlr;
	ulong dump[17];

	ctlr = ether-&gt;ctlr;
	lock(&amp;ctlr-&gt;dlock);

	/*
	 * Start the command then
	 * wait for completion status,
	 * should be 0xA005.
	 */
	ctlr-&gt;dump[16] = 0;
	command(ctlr, DumpSC, 0);
	while(ctlr-&gt;dump[16] == 0)
		;

	ether-&gt;oerrs = ctlr-&gt;dump[1]+ctlr-&gt;dump[2]+ctlr-&gt;dump[3];
	ether-&gt;crcs = ctlr-&gt;dump[10];
	ether-&gt;frames = ctlr-&gt;dump[11];
	ether-&gt;buffs = ctlr-&gt;dump[12]+ctlr-&gt;dump[15];
	ether-&gt;overflows = ctlr-&gt;dump[13];

	if(n == 0){
		unlock(&amp;ctlr-&gt;dlock);
		return 0;
	}

	memmove(dump, ctlr-&gt;dump, sizeof(dump));
	unlock(&amp;ctlr-&gt;dlock);

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	len = snprint(p, READSTR, "transmit good frames: %lud\n", dump[0]);
	len += snprint(p+len, READSTR-len, "transmit maximum collisions errors: %lud\n", dump[1]);
	len += snprint(p+len, READSTR-len, "transmit late collisions errors: %lud\n", dump[2]);
	len += snprint(p+len, READSTR-len, "transmit underrun errors: %lud\n", dump[3]);
	len += snprint(p+len, READSTR-len, "transmit lost carrier sense: %lud\n", dump[4]);
	len += snprint(p+len, READSTR-len, "transmit deferred: %lud\n", dump[5]);
	len += snprint(p+len, READSTR-len, "transmit single collisions: %lud\n", dump[6]);
	len += snprint(p+len, READSTR-len, "transmit multiple collisions: %lud\n", dump[7]);
	len += snprint(p+len, READSTR-len, "transmit total collisions: %lud\n", dump[8]);
	len += snprint(p+len, READSTR-len, "receive good frames: %lud\n", dump[9]);
	len += snprint(p+len, READSTR-len, "receive CRC errors: %lud\n", dump[10]);
	len += snprint(p+len, READSTR-len, "receive alignment errors: %lud\n", dump[11]);
	len += snprint(p+len, READSTR-len, "receive resource errors: %lud\n", dump[12]);
	len += snprint(p+len, READSTR-len, "receive overrun errors: %lud\n", dump[13]);
	len += snprint(p+len, READSTR-len, "receive collision detect errors: %lud\n", dump[14]);
	len += snprint(p+len, READSTR-len, "receive short frame errors: %lud\n", dump[15]);
	len += snprint(p+len, READSTR-len, "nop: %d\n", ctlr-&gt;nop);
	if(ctlr-&gt;cbqmax &gt; ctlr-&gt;cbqmaxhw)
		ctlr-&gt;cbqmaxhw = ctlr-&gt;cbqmax;
	len += snprint(p+len, READSTR-len, "cbqmax: %d\n", ctlr-&gt;cbqmax);
	ctlr-&gt;cbqmax = 0;
	len += snprint(p+len, READSTR-len, "threshold: %d\n", ctlr-&gt;threshold);

	len += snprint(p+len, READSTR-len, "eeprom:");
	for(i = 0; i &lt; (1&lt;&lt;ctlr-&gt;eepromsz); i++){
		if(i &amp;&amp; ((i &amp; 0x07) == 0))
			len += snprint(p+len, READSTR-len, "\n       ");
		len += snprint(p+len, READSTR-len, " %4.4ux", ctlr-&gt;eeprom[i]);
	}

	if((ctlr-&gt;eeprom[6] &amp; 0x1F00) &amp;&amp; !(ctlr-&gt;eeprom[6] &amp; 0x8000)){
		phyaddr = ctlr-&gt;eeprom[6] &amp; 0x00FF;
		len += snprint(p+len, READSTR-len, "\nphy %2d:", phyaddr);
		for(i = 0; i &lt; 6; i++){
			static int miir(Ctlr*, int, int);

			len += snprint(p+len, READSTR-len, " %4.4ux",
				miir(ctlr, phyaddr, i));
		}
	}

	snprint(p+len, READSTR-len, "\n");
	n = readstr(offset, a, n, p);
	free(p);

	return n;
}

static void
txstart(Ether* ether)
{
	Ctlr *ctlr;
	Block *bp;
	Cb *cb;

	ctlr = ether-&gt;ctlr;
	while(ctlr-&gt;cbq &lt; (ctlr-&gt;ncb-1)){
		cb = ctlr-&gt;cbhead-&gt;next;
		if(ctlr-&gt;action == 0){
			bp = qget(ether-&gt;oq);
			if(bp == nil)
				break;

			cb-&gt;command = CbS|CbSF|CbTransmit;
			cb-&gt;tbd = PADDR(&amp;cb-&gt;tba);
			cb-&gt;count = 0;
			cb-&gt;threshold = ctlr-&gt;threshold;
			cb-&gt;number = 1;
			cb-&gt;tba = PADDR(bp-&gt;rp);
			cb-&gt;bp = bp;
			cb-&gt;tbasz = BLEN(bp);
		}
		else if(ctlr-&gt;action == CbConfigure){
			cb-&gt;command = CbS|CbConfigure;
			memmove(cb-&gt;data, ctlr-&gt;configdata, sizeof(ctlr-&gt;configdata));
			ctlr-&gt;action = 0;
		}
		else if(ctlr-&gt;action == CbIAS){
			cb-&gt;command = CbS|CbIAS;
			memmove(cb-&gt;data, ether-&gt;ea, Eaddrlen);
			ctlr-&gt;action = 0;
		}
		else if(ctlr-&gt;action == CbMAS){
			cb-&gt;command = CbS|CbMAS;
			memset(cb-&gt;data, 0, sizeof(cb-&gt;data));
			ctlr-&gt;action = 0;
		}
		else{
			print("#l%d: action %#ux\n", ether-&gt;ctlrno, ctlr-&gt;action);
			ctlr-&gt;action = 0;
			break;
		}
		cb-&gt;status = 0;

		coherence();
		ctlr-&gt;cbhead-&gt;command &amp;= ~CbS;
		ctlr-&gt;cbhead = cb;
		ctlr-&gt;cbq++;
	}

	/*
	 * Workaround for some broken HUB chips
	 * when connected at 10Mb/s half-duplex.
	 */
	if(ctlr-&gt;nop){
		command(ctlr, CUnop, 0);
		microdelay(1);
	}
	command(ctlr, CUresume, 0);

	if(ctlr-&gt;cbq &gt; ctlr-&gt;cbqmax)
		ctlr-&gt;cbqmax = ctlr-&gt;cbq;
}

static void
configure(Ether* ether, int promiscuous)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(&amp;ctlr-&gt;cblock);
	if(promiscuous){
		ctlr-&gt;configdata[6] |= 0x80;		/* Save Bad Frames */
		//ctlr-&gt;configdata[6] &amp;= ~0x40;		/* !Discard Overrun Rx Frames */
		ctlr-&gt;configdata[7] &amp;= ~0x01;		/* !Discard Short Rx Frames */
		ctlr-&gt;configdata[15] |= 0x01;		/* Promiscuous mode */
		ctlr-&gt;configdata[18] &amp;= ~0x01;		/* (!Padding enable?), !stripping enable */
		ctlr-&gt;configdata[21] |= 0x08;		/* Multi Cast ALL */
	}
	else{
		ctlr-&gt;configdata[6] &amp;= ~0x80;
		//ctlr-&gt;configdata[6] |= 0x40;
		ctlr-&gt;configdata[7] |= 0x01;
		ctlr-&gt;configdata[15] &amp;= ~0x01;
		ctlr-&gt;configdata[18] |= 0x01;		/* 0x03? */
		ctlr-&gt;configdata[21] &amp;= ~0x08;
	}
	ctlr-&gt;action = CbConfigure;
	txstart(ether);
	iunlock(&amp;ctlr-&gt;cblock);
}

static void
promiscuous(void* arg, int on)
{
	configure(arg, on);
}

static void
multicast(void* ether, uchar *addr, int add)
{
	USED(addr);
	/*
	 * TODO: if (add) add addr to list of mcast addrs in controller
	 *	else remove addr from list of mcast addrs in controller
	 * enable multicast input (see CbMAS) instead of promiscuous mode.
	 */
	if (add)
		configure(ether, 1);
}

static void
transmit(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(&amp;ctlr-&gt;cblock);
	txstart(ether);
	iunlock(&amp;ctlr-&gt;cblock);
}

static void
receive(Ether* ether)
{
	Rfd *rfd;
	Ctlr *ctlr;
	int count;
	Block *bp, *pbp, *xbp;

	ctlr = ether-&gt;ctlr;
	bp = ctlr-&gt;rfdhead;
	for(rfd = (Rfd*)bp-&gt;rp; rfd-&gt;field &amp; RfdC; rfd = (Rfd*)bp-&gt;rp){
		/*
		 * If it's an OK receive frame
		 * 1) save the count 
		 * 2) if it's small, try to allocate a block and copy
		 *    the data, then adjust the necessary fields for reuse;
		 * 3) if it's big, try to allocate a new Rfd and if
		 *    successful
		 *	adjust the received buffer pointers for the
		 *	  actual data received;
		 *	initialise the replacement buffer to point to
		 *	  the next in the ring;
		 *	initialise bp to point to the replacement;
		 * 4) if there's a good packet, pass it on for disposal.
		 */
		if(rfd-&gt;field &amp; RfdOK){
			pbp = nil;
			count = rfd-&gt;count &amp; 0x3FFF;
			if((count &lt; ETHERMAXTU/4) &amp;&amp; (pbp = iallocb(count))){
				memmove(pbp-&gt;rp, bp-&gt;rp+offsetof(Rfd, data[0]), count);
				pbp-&gt;wp = pbp-&gt;rp + count;

				rfd-&gt;count = 0;
				rfd-&gt;field = 0;
			}
			else if(xbp = rfdalloc(rfd-&gt;link)){
				bp-&gt;rp += offsetof(Rfd, data[0]);
				bp-&gt;wp = bp-&gt;rp + count;

				xbp-&gt;next = bp-&gt;next;
				bp-&gt;next = 0;

				pbp = bp;
				bp = xbp;
			}
			if(pbp != nil)
				etheriq(ether, pbp, 1);
		}
		else{
			rfd-&gt;count = 0;
			rfd-&gt;field = 0;
		}

		/*
		 * The ring tail pointer follows the head with with one
		 * unused buffer in between to defeat hardware prefetch;
		 * once the tail pointer has been bumped on to the next
		 * and the new tail has the Suspend bit set, it can be
		 * removed from the old tail buffer.
		 * As a replacement for the current head buffer may have
		 * been allocated above, ensure that the new tail points
		 * to it (next and link).
		 */
		rfd = (Rfd*)ctlr-&gt;rfdtail-&gt;rp;
		ctlr-&gt;rfdtail = ctlr-&gt;rfdtail-&gt;next;
		ctlr-&gt;rfdtail-&gt;next = bp;
		((Rfd*)ctlr-&gt;rfdtail-&gt;rp)-&gt;link = PADDR(bp-&gt;rp);
		((Rfd*)ctlr-&gt;rfdtail-&gt;rp)-&gt;field |= RfdS;
		coherence();
		rfd-&gt;field &amp;= ~RfdS;

		/*
		 * Finally done with the current (possibly replaced)
		 * head, move on to the next and maintain the sentinel
		 * between tail and head.
		 */
		ctlr-&gt;rfdhead = bp-&gt;next;
		bp = ctlr-&gt;rfdhead;
	}
}

static void
interrupt(Ureg*, void* arg)
{
	Cb* cb;
	Ctlr *ctlr;
	Ether *ether;
	int status;

	ether = arg;
	ctlr = ether-&gt;ctlr;

	for(;;){
		ilock(&amp;ctlr-&gt;rlock);
		status = csr16r(ctlr, Status);
		csr8w(ctlr, Ack, (status&gt;&gt;8) &amp; 0xFF);
		iunlock(&amp;ctlr-&gt;rlock);

		if(!(status &amp; (StatCX|StatFR|StatCNA|StatRNR|StatMDI|StatSWI)))
			break;

		/*
		 * If the watchdog timer for the receiver lockup errata is running,
		 * let it know the receiver is active.
		 */
		if(status &amp; (StatFR|StatRNR)){
			ilock(&amp;ctlr-&gt;cblock);
			ctlr-&gt;tick = 0;
			iunlock(&amp;ctlr-&gt;cblock);
		}

		if(status &amp; StatFR){
			receive(ether);
			status &amp;= ~StatFR;
		}

		if(status &amp; StatRNR){
			command(ctlr, RUresume, 0);
			status &amp;= ~StatRNR;
		}

		if(status &amp; StatCNA){
			ilock(&amp;ctlr-&gt;cblock);

			cb = ctlr-&gt;cbtail;
			while(ctlr-&gt;cbq){
				if(!(cb-&gt;status &amp; CbC))
					break;
				if(cb-&gt;bp){
					freeb(cb-&gt;bp);
					cb-&gt;bp = nil;
				}
				if((cb-&gt;status &amp; CbU) &amp;&amp; ctlr-&gt;threshold &lt; 0xE0)
					ctlr-&gt;threshold++;

				ctlr-&gt;cbq--;
				cb = cb-&gt;next;
			}
			ctlr-&gt;cbtail = cb;

			txstart(ether);
			iunlock(&amp;ctlr-&gt;cblock);

			status &amp;= ~StatCNA;
		}

		if(status &amp; (StatCX|StatFR|StatCNA|StatRNR|StatMDI|StatSWI))
			panic("#l%d: status %#ux\n", ether-&gt;ctlrno, status);
	}
}

static void
ctlrinit(Ctlr* ctlr)
{
	int i;
	Block *bp;
	Rfd *rfd;
	ulong link;

	/*
	 * Create the Receive Frame Area (RFA) as a ring of allocated
	 * buffers.
	 * A sentinel buffer is maintained between the last buffer in
	 * the ring (marked with RfdS) and the head buffer to defeat the
	 * hardware prefetch of the next RFD and allow dynamic buffer
	 * allocation.
	 */
	link = NullPointer;
	for(i = 0; i &lt; Nrfd; i++){
		bp = rfdalloc(link);
		if(ctlr-&gt;rfdhead == nil)
			ctlr-&gt;rfdtail = bp;
		bp-&gt;next = ctlr-&gt;rfdhead;
		ctlr-&gt;rfdhead = bp;
		link = PADDR(bp-&gt;rp);
	}
	ctlr-&gt;rfdtail-&gt;next = ctlr-&gt;rfdhead;
	rfd = (Rfd*)ctlr-&gt;rfdtail-&gt;rp;
	rfd-&gt;link = PADDR(ctlr-&gt;rfdhead-&gt;rp);
	rfd-&gt;field |= RfdS;
	ctlr-&gt;rfdhead = ctlr-&gt;rfdhead-&gt;next;

	/*
	 * Create a ring of control blocks for the
	 * transmit side.
	 */
	ilock(&amp;ctlr-&gt;cblock);
	ctlr-&gt;cbr = malloc(ctlr-&gt;ncb*sizeof(Cb));
	if(ctlr-&gt;cbr == nil) {
		iunlock(&amp;ctlr-&gt;cblock);
		error(Enomem);
	}
	for(i = 0; i &lt; ctlr-&gt;ncb; i++){
		ctlr-&gt;cbr[i].status = CbC|CbOK;
		ctlr-&gt;cbr[i].command = CbS|CbNOP;
		ctlr-&gt;cbr[i].link = PADDR(&amp;ctlr-&gt;cbr[NEXT(i, ctlr-&gt;ncb)].status);
		ctlr-&gt;cbr[i].next = &amp;ctlr-&gt;cbr[NEXT(i, ctlr-&gt;ncb)];
	}
	ctlr-&gt;cbhead = ctlr-&gt;cbr;
	ctlr-&gt;cbtail = ctlr-&gt;cbr;
	ctlr-&gt;cbq = 0;

	memmove(ctlr-&gt;configdata, configdata, sizeof(configdata));
	ctlr-&gt;threshold = 80;
	ctlr-&gt;tick = 0;

	iunlock(&amp;ctlr-&gt;cblock);
}

static int
miir(Ctlr* ctlr, int phyadd, int regadd)
{
	int mcr, timo;

	lock(&amp;ctlr-&gt;miilock);
	csr32w(ctlr, Mcr, MDIread|(phyadd&lt;&lt;21)|(regadd&lt;&lt;16));
	mcr = 0;
	for(timo = 64; timo; timo--){
		mcr = csr32r(ctlr, Mcr);
		if(mcr &amp; MDIready)
			break;
		microdelay(1);
	}
	unlock(&amp;ctlr-&gt;miilock);

	if(mcr &amp; MDIready)
		return mcr &amp; 0xFFFF;

	return -1;
}

static int
miiw(Ctlr* ctlr, int phyadd, int regadd, int data)
{
	int mcr, timo;

	lock(&amp;ctlr-&gt;miilock);
	csr32w(ctlr, Mcr, MDIwrite|(phyadd&lt;&lt;21)|(regadd&lt;&lt;16)|(data &amp; 0xFFFF));
	mcr = 0;
	for(timo = 64; timo; timo--){
		mcr = csr32r(ctlr, Mcr);
		if(mcr &amp; MDIready)
			break;
		microdelay(1);
	}
	unlock(&amp;ctlr-&gt;miilock);

	if(mcr &amp; MDIready)
		return 0;

	return -1;
}

static int
hy93c46r(Ctlr* ctlr, int r)
{
	int data, i, op, size;

	/*
	 * Hyundai HY93C46 or equivalent serial EEPROM.
	 * This sequence for reading a 16-bit register 'r'
	 * in the EEPROM is taken straight from Section
	 * 3.3.4.2 of the Intel 82557 User's Guide.
	 */
reread:
	csr16w(ctlr, Ecr, EEcs);
	op = EEstart|EEread;
	for(i = 2; i &gt;= 0; i--){
		data = (((op&gt;&gt;i) &amp; 0x01)&lt;&lt;2)|EEcs;
		csr16w(ctlr, Ecr, data);
		csr16w(ctlr, Ecr, data|EEsk);
		microdelay(1);
		csr16w(ctlr, Ecr, data);
		microdelay(1);
	}

	/*
	 * First time through must work out the EEPROM size.
	 */
	if((size = ctlr-&gt;eepromsz) == 0)
		size = 8;

	for(size = size-1; size &gt;= 0; size--){
		data = (((r&gt;&gt;size) &amp; 0x01)&lt;&lt;2)|EEcs;
		csr16w(ctlr, Ecr, data);
		csr16w(ctlr, Ecr, data|EEsk);
		delay(1);
		csr16w(ctlr, Ecr, data);
		microdelay(1);
		if(!(csr16r(ctlr, Ecr) &amp; EEdo))
			break;
	}

	data = 0;
	for(i = 15; i &gt;= 0; i--){
		csr16w(ctlr, Ecr, EEcs|EEsk);
		microdelay(1);
		if(csr16r(ctlr, Ecr) &amp; EEdo)
			data |= (1&lt;&lt;i);
		csr16w(ctlr, Ecr, EEcs);
		microdelay(1);
	}

	csr16w(ctlr, Ecr, 0);

	if(ctlr-&gt;eepromsz == 0){
		ctlr-&gt;eepromsz = 8-size;
		ctlr-&gt;eeprom = malloc((1&lt;&lt;ctlr-&gt;eepromsz)*sizeof(ushort));
		if(ctlr-&gt;eeprom == nil)
			error(Enomem);
		goto reread;
	}

	return data;
}

static void
i82557pci(void)
{
	Pcidev *p;
	Ctlr *ctlr;
	int i, nop, port;

	p = nil;
	nop = 0;
	while(p = pcimatch(p, 0x8086, 0)){
		switch(p-&gt;did){
		default:
			continue;
		case 0x1031:		/* Intel 82562EM */
		case 0x103B:		/* Intel 82562EM */
		case 0x103C:		/* Intel 82562EM */
		case 0x1050:		/* Intel 82562EZ */
		case 0x1039:		/* Intel 82801BD PRO/100 VE */
		case 0x103A:		/* Intel 82562 PRO/100 VE */
		case 0x103D:		/* Intel 82562 PRO/100 VE */
		case 0x1064:		/* Intel 82562 PRO/100 VE */
		case 0x2449:		/* Intel 82562ET */
		case 0x27DC:		/* Intel 82801G PRO/100 VE */
			nop = 1;
			/*FALLTHROUGH*/
		case 0x1209:		/* Intel 82559ER */
		case 0x1229:		/* Intel 8255[789] */
		case 0x1030:		/* Intel 82559 InBusiness 10/100  */
			break;
		}

		if(pcigetpms(p) &gt; 0){
			pcisetpms(p, 0);
	
			for(i = 0; i &lt; 6; i++)
				pcicfgw32(p, PciBAR0+i*4, p-&gt;mem[i].bar);
			pcicfgw8(p, PciINTL, p-&gt;intl);
			pcicfgw8(p, PciLTR, p-&gt;ltr);
			pcicfgw8(p, PciCLS, p-&gt;cls);
			pcicfgw16(p, PciPCR, p-&gt;pcr);
		}

		/*
		 * bar[0] is the memory-mapped register address (4KB),
		 * bar[1] is the I/O port register address (32 bytes) and
		 * bar[2] is for the flash ROM (1MB).
		 */
		port = p-&gt;mem[1].bar &amp; ~0x01;
		if(ioalloc(port, p-&gt;mem[1].size, 0, "i82557") &lt; 0){
			print("i82557: port %#ux in use\n", port);
			continue;
		}

		ctlr = malloc(sizeof(Ctlr));
		if(ctlr == nil)
			error(Enomem);
		ctlr-&gt;port = port;
		ctlr-&gt;pcidev = p;
		ctlr-&gt;nop = nop;

		if(ctlrhead != nil)
			ctlrtail-&gt;next = ctlr;
		else
			ctlrhead = ctlr;
		ctlrtail = ctlr;

		pcisetbme(p);
	}
}

static char* mediatable[9] = {
	"10BASE-T",				/* TP */
	"10BASE-2",				/* BNC */
	"10BASE-5",				/* AUI */
	"100BASE-TX",
	"10BASE-TFD",
	"100BASE-TXFD",
	"100BASE-T4",
	"100BASE-FX",
	"100BASE-FXFD",
};

static int
scanphy(Ctlr* ctlr)
{
	int i, oui, x;

	for(i = 0; i &lt; 32; i++){
		if((oui = miir(ctlr, i, 2)) == -1 || oui == 0 || oui == 0xFFFF)
			continue;
		oui &lt;&lt;= 6;
		x = miir(ctlr, i, 3);
		oui |= x&gt;&gt;10;
		//print("phy%d: oui %#ux reg1 %#ux\n", i, oui, miir(ctlr, i, 1));

		ctlr-&gt;eeprom[6] = i;
		if(oui == 0xAA00)
			ctlr-&gt;eeprom[6] |= 0x07&lt;&lt;8;
		else if(oui == 0x80017){
			if(x &amp; 0x01)
				ctlr-&gt;eeprom[6] |= 0x0A&lt;&lt;8;
			else
				ctlr-&gt;eeprom[6] |= 0x04&lt;&lt;8;
		}
		return i;
	}
	return -1;
}

static void
shutdown(Ether* ether)
{
	Ctlr *ctlr = ether-&gt;ctlr;

print("ether82557 shutting down\n");
	csr32w(ctlr, Port, 0);
	delay(1);
	csr8w(ctlr, Interrupt, InterruptM);
}


static int
reset(Ether* ether)
{
	int anar, anlpar, bmcr, bmsr, i, k, medium, phyaddr, x;
	unsigned short sum;
	uchar ea[Eaddrlen];
	Ctlr *ctlr;

	if(ctlrhead == nil)
		i82557pci();

	/*
	 * Any adapter matches if no ether-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	for(ctlr = ctlrhead; ctlr != nil; ctlr = ctlr-&gt;next){
		if(ctlr-&gt;active)
			continue;
		if(ether-&gt;port == 0 || ether-&gt;port == ctlr-&gt;port){
			ctlr-&gt;active = 1;
			break;
		}
	}
	if(ctlr == nil)
		return -1;

	/*
	 * Initialise the Ctlr structure.
	 * Perform a software reset after which should ensure busmastering
	 * is still enabled. The EtherExpress PRO/100B appears to leave
	 * the PCI configuration alone (see the 'To do' list above) so punt
	 * for now.
	 * Load the RUB and CUB registers for linear addressing (0).
	 */
	ether-&gt;ctlr = ctlr;
	ether-&gt;port = ctlr-&gt;port;
	ether-&gt;irq = ctlr-&gt;pcidev-&gt;intl;
	ether-&gt;tbdf = ctlr-&gt;pcidev-&gt;tbdf;

	ilock(&amp;ctlr-&gt;rlock);
	csr32w(ctlr, Port, 0);
	delay(1);
	csr8w(ctlr, Interrupt, InterruptM);
	iunlock(&amp;ctlr-&gt;rlock);

	command(ctlr, LoadRUB, 0);
	command(ctlr, LoadCUB, 0);
	command(ctlr, LoadDCA, PADDR(ctlr-&gt;dump));

	/*
	 * Initialise the receive frame, transmit ring and configuration areas.
	 */
	ctlr-&gt;ncb = Ncb;
	ctlrinit(ctlr);

	/*
	 * Read the EEPROM.
	 * Do a dummy read first to get the size
	 * and allocate ctlr-&gt;eeprom.
	 */
	hy93c46r(ctlr, 0);
	sum = 0;
	for(i = 0; i &lt; (1&lt;&lt;ctlr-&gt;eepromsz); i++){
		x = hy93c46r(ctlr, i);
		ctlr-&gt;eeprom[i] = x;
		sum += x;
	}
	if(sum != 0xBABA)
		print("#l%d: EEPROM checksum - %#4.4ux\n", ether-&gt;ctlrno, sum);

	/*
	 * Eeprom[6] indicates whether there is a PHY and whether
	 * it's not 10Mb-only, in which case use the given PHY address
	 * to set any PHY specific options and determine the speed.
	 * Unfortunately, sometimes the EEPROM is blank except for
	 * the ether address and checksum; in this case look at the
	 * controller type and if it's am 82558 or 82559 it has an
	 * embedded PHY so scan for that.
	 * If no PHY, assume 82503 (serial) operation.
	 */
	if((ctlr-&gt;eeprom[6] &amp; 0x1F00) &amp;&amp; !(ctlr-&gt;eeprom[6] &amp; 0x8000))
		phyaddr = ctlr-&gt;eeprom[6] &amp; 0x00FF;
	else
	switch(ctlr-&gt;pcidev-&gt;rid){
	case 0x01:			/* 82557 A-step */
	case 0x02:			/* 82557 B-step */
	case 0x03:			/* 82557 C-step */
	default:
		phyaddr = -1;
		break;
	case 0x04:			/* 82558 A-step */
	case 0x05:			/* 82558 B-step */
	case 0x06:			/* 82559 A-step */
	case 0x07:			/* 82559 B-step */
	case 0x08:			/* 82559 C-step */
	case 0x09:			/* 82559ER A-step */
		phyaddr = scanphy(ctlr);
		break;
	}
	if(phyaddr &gt;= 0){
		/*
		 * Resolve the highest common ability of the two
		 * link partners. In descending order:
		 *	0x0100		100BASE-TX Full Duplex
		 *	0x0200		100BASE-T4
		 *	0x0080		100BASE-TX
		 *	0x0040		10BASE-T Full Duplex
		 *	0x0020		10BASE-T
		 */
		anar = miir(ctlr, phyaddr, 0x04);
		anlpar = miir(ctlr, phyaddr, 0x05) &amp; 0x03E0;
		anar &amp;= anlpar;
		bmcr = 0;
		if(anar &amp; 0x380)
			bmcr = 0x2000;
		if(anar &amp; 0x0140)
			bmcr |= 0x0100;

		switch((ctlr-&gt;eeprom[6]&gt;&gt;8) &amp; 0x001F){

		case 0x04:				/* DP83840 */
		case 0x0A:				/* DP83840A */
			/*
			 * The DP83840[A] requires some tweaking for
			 * reliable operation.
			 * The manual says bit 10 should be unconditionally
			 * set although it supposedly only affects full-duplex
			 * operation (an &amp; 0x0140).
			 */
			x = miir(ctlr, phyaddr, 0x17) &amp; ~0x0520;
			x |= 0x0420;
			for(i = 0; i &lt; ether-&gt;nopt; i++){
				if(cistrcmp(ether-&gt;opt[i], "congestioncontrol"))
					continue;
				x |= 0x0100;
				break;
			}
			miiw(ctlr, phyaddr, 0x17, x);

			/*
			 * If the link partner can't autonegotiate, determine
			 * the speed from elsewhere.
			 */
			if(anlpar == 0){
				miir(ctlr, phyaddr, 0x01);
				bmsr = miir(ctlr, phyaddr, 0x01);
				x = miir(ctlr, phyaddr, 0x19);
				if((bmsr &amp; 0x0004) &amp;&amp; !(x &amp; 0x0040))
					bmcr = 0x2000;
			}
			break;

		case 0x07:				/* Intel 82555 */
			/*
			 * Auto-negotiation may fail if the other end is
			 * a DP83840A and the cable is short.
			 */
			miir(ctlr, phyaddr, 0x01);
			bmsr = miir(ctlr, phyaddr, 0x01);
			if((miir(ctlr, phyaddr, 0) &amp; 0x1000) &amp;&amp; !(bmsr &amp; 0x0020)){
				miiw(ctlr, phyaddr, 0x1A, 0x2010);
				x = miir(ctlr, phyaddr, 0);
				miiw(ctlr, phyaddr, 0, 0x0200|x);
				for(i = 0; i &lt; 3000; i++){
					delay(1);
					if(miir(ctlr, phyaddr, 0x01) &amp; 0x0020)
						break;
				}
				miiw(ctlr, phyaddr, 0x1A, 0x2000);
					
				anar = miir(ctlr, phyaddr, 0x04);
				anlpar = miir(ctlr, phyaddr, 0x05) &amp; 0x03E0;
				anar &amp;= anlpar;
				bmcr = 0;
				if(anar &amp; 0x380)
					bmcr = 0x2000;
				if(anar &amp; 0x0140)
					bmcr |= 0x0100;
			}
			break;
		}

		/*
		 * Force speed and duplex if no auto-negotiation.
		 */
		if(anlpar == 0){
			medium = -1;
			for(i = 0; i &lt; ether-&gt;nopt; i++){
				for(k = 0; k &lt; nelem(mediatable); k++){
					if(cistrcmp(mediatable[k], ether-&gt;opt[i]))
						continue;
					medium = k;
					break;
				}
		
				switch(medium){
				default:
					break;

				case 0x00:			/* 10BASE-T */
				case 0x01:			/* 10BASE-2 */
				case 0x02:			/* 10BASE-5 */
					bmcr &amp;= ~(0x2000|0x0100);
					ctlr-&gt;configdata[19] &amp;= ~0x40;
					break;

				case 0x03:			/* 100BASE-TX */
				case 0x06:			/* 100BASE-T4 */
				case 0x07:			/* 100BASE-FX */
					ctlr-&gt;configdata[19] &amp;= ~0x40;
					bmcr |= 0x2000;
					break;

				case 0x04:			/* 10BASE-TFD */
					bmcr = (bmcr &amp; ~0x2000)|0x0100;
					ctlr-&gt;configdata[19] |= 0x40;
					break;

				case 0x05:			/* 100BASE-TXFD */
				case 0x08:			/* 100BASE-FXFD */
					bmcr |= 0x2000|0x0100;
					ctlr-&gt;configdata[19] |= 0x40;
					break;
				}
			}
			if(medium != -1)
				miiw(ctlr, phyaddr, 0x00, bmcr);
		}

		if(bmcr &amp; 0x2000)
			ether-&gt;mbps = 100;

		ctlr-&gt;configdata[8] = 1;
		ctlr-&gt;configdata[15] &amp;= ~0x80;
	}
	else{
		ctlr-&gt;configdata[8] = 0;
		ctlr-&gt;configdata[15] |= 0x80;
	}

	/*
	 * Workaround for some broken HUB chips when connected at 10Mb/s
	 * half-duplex.
	 * This is a band-aid, but as there's no dynamic auto-negotiation
	 * code at the moment, only deactivate the workaround code in txstart
	 * if the link is 100Mb/s.
	 */
	if(ether-&gt;mbps != 10)
		ctlr-&gt;nop = 0;

	/*
	 * Load the chip configuration and start it off.
	 */
	if(ether-&gt;oq == 0)
		ether-&gt;oq = qopen(64*1024, Qmsg, 0, 0);
	configure(ether, 0);
	command(ctlr, CUstart, PADDR(&amp;ctlr-&gt;cbr-&gt;status));

	/*
	 * Check if the adapter's station address is to be overridden.
	 * If not, read it from the EEPROM and set in ether-&gt;ea prior to loading
	 * the station address with the Individual Address Setup command.
	 */
	memset(ea, 0, Eaddrlen);
	if(memcmp(ea, ether-&gt;ea, Eaddrlen) == 0){
		for(i = 0; i &lt; Eaddrlen/2; i++){
			x = ctlr-&gt;eeprom[i];
			ether-&gt;ea[2*i] = x;
			ether-&gt;ea[2*i+1] = x&gt;&gt;8;
		}
	}

	ilock(&amp;ctlr-&gt;cblock);
	ctlr-&gt;action = CbIAS;
	txstart(ether);
	iunlock(&amp;ctlr-&gt;cblock);

	/*
	 * Linkage to the generic ethernet driver.
	 */
	ether-&gt;attach = attach;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;ifstat = ifstat;
	ether-&gt;shutdown = shutdown;

	ether-&gt;promiscuous = promiscuous;
	ether-&gt;multicast = multicast;
	ether-&gt;arg = ether;

	return 0;
}

void
ether82557link(void)
{
	addethercard("i82557",  reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

