<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/ether82598.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/ether82598.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * intel pci-express 10Gb ethernet driver for 8259[89]
 * copyright © 2007, coraid, inc.
 * depessimised and made to work on the 82599 at bell labs, 2013.
 *
 * 82599 requests should ideally not cross a 4KB (page) boundary.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"
#include "etherif.h"

#define NEXTPOW2(x, m)	(((x)+1) &amp; (m))

enum {
	Rbsz	= ETHERMAXTU+32, /* +slop is for vlan headers, crcs, etc. */
	Descalign= 128,		/* 599 manual needs 128-byte alignment */

	/* tunable parameters */
	Goslow	= 0,		/* flag: go slow by throttling intrs, etc. */
	/* were 256, 1024 &amp; 64, but 30, 47 and 1 are ample. */
	Nrd	= 64,		/* multiple of 8, power of 2 for NEXTPOW2 */
	Nrb	= 128,
	Ntd	= 32,		/* multiple of 8, power of 2 for NEXTPOW2 */
};

enum {
	/* general */
	Ctrl		= 0x00000/4,	/* Device Control */
	Status		= 0x00008/4,	/* Device Status */
	Ctrlext		= 0x00018/4,	/* Extended Device Control */
	Esdp		= 0x00020/4,	/* extended sdp control */
	Esodp		= 0x00028/4,	/* extended od sdp control (i2cctl on 599) */
	Ledctl		= 0x00200/4,	/* led control */
	Tcptimer	= 0x0004c/4,	/* tcp timer */
	Ecc		= 0x110b0/4,	/* errata ecc control magic (pcie intr cause on 599) */

	/* nvm */
	Eec		= 0x10010/4,	/* eeprom/flash control */
	Eerd		= 0x10014/4,	/* eeprom read */
	Fla		= 0x1001c/4,	/* flash access */
	Flop		= 0x1013c/4,	/* flash opcode */
	Grc		= 0x10200/4,	/* general rx control */

	/* interrupt */
	Icr		= 0x00800/4,	/* interrupt cause read */
	Ics		= 0x00808/4,	/* " set */
	Ims		= 0x00880/4,	/* " mask read/set (actually enable) */
	Imc		= 0x00888/4,	/* " mask clear */
	Iac		= 0x00810/4,	/* " auto clear */
	Iam		= 0x00890/4,	/* " auto mask enable */
	Itr		= 0x00820/4,	/* " throttling rate regs (0-19) */
	Ivar		= 0x00900/4,	/* " vector allocation regs. */
	/* msi interrupt */
	Msixt		= 0x0000/4,	/* msix table (bar3) */
	Msipba		= 0x2000/4,	/* msix pending bit array (bar3) */
	Pbacl		= 0x11068/4,	/* pba clear */
	Gpie		= 0x00898/4,	/* general purpose int enable */

	/* flow control */
	Pfctop		= 0x03008/4,	/* priority flow ctl type opcode */
	Fcttv		= 0x03200/4,	/* " transmit timer value (0-3) */
	Fcrtl		= 0x03220/4,	/* " rx threshold low (0-7) +8n */
	Fcrth		= 0x03260/4,	/* " rx threshold high (0-7) +8n */
	Rcrtv		= 0x032a0/4,	/* " refresh value threshold */
	Tfcs		= 0x0ce00/4,	/* " tx status */

	/* rx dma */
	Rbal		= 0x01000/4,	/* rx desc base low (0-63) +0x40n */
	Rbah		= 0x01004/4,	/* " high */
	Rdlen		= 0x01008/4,	/* " length */
	Rdh		= 0x01010/4,	/* " head */
	Rdt		= 0x01018/4,	/* " tail */
	Rxdctl		= 0x01028/4,	/* " control */

	Srrctl		= 0x02100/4,	/* split &amp; replication rx ctl. array */
	Dcarxctl	= 0x02200/4,	/* rx dca control */
	Rdrxctl		= 0x02f00/4,	/* rx dma control */
	Rxpbsize	= 0x03c00/4,	/* rx packet buffer size */
	Rxctl		= 0x03000/4,	/* rx control */
	Dropen		= 0x03d04/4,	/* drop enable control (598 only) */

	/* rx */
	Rxcsum		= 0x05000/4,	/* rx checksum control */
	Rfctl		= 0x05008/4,	/* rx filter control */
	Mta		= 0x05200/4,	/* multicast table array (0-127) */
	Ral98		= 0x05400/4,	/* rx address low (598) */
	Rah98		= 0x05404/4,
	Ral99		= 0x0a200/4,	/* rx address low array (599) */
	Rah99		= 0x0a204/4,
	Psrtype		= 0x05480/4,	/* packet split rx type. */
	Vfta		= 0x0a000/4,	/* vlan filter table array. */
	Fctrl		= 0x05080/4,	/* filter control */
	Vlnctrl		= 0x05088/4,	/* vlan control */
	Msctctrl	= 0x05090/4,	/* multicast control */
	Mrqc		= 0x05818/4,	/* multiple rx queues cmd */
	Vmdctl		= 0x0581c/4,	/* vmdq control (598 only) */
	Imir		= 0x05a80/4,	/* immediate irq rx (0-7) (598 only) */
	Imirext		= 0x05aa0/4,	/* immediate irq rx ext (598 only) */
	Imirvp		= 0x05ac0/4,	/* immediate irq vlan priority (598 only) */
	Reta		= 0x05c00/4,	/* redirection table */
	Rssrk		= 0x05c80/4,	/* rss random key */

	/* tx */
	Tdbal		= 0x06000/4,	/* tx desc base low +0x40n array */
	Tdbah		= 0x06004/4,	/* " high */
	Tdlen		= 0x06008/4,	/* " len */
	Tdh		= 0x06010/4,	/* " head */
	Tdt		= 0x06018/4,	/* " tail */
	Txdctl		= 0x06028/4,	/* " control */
	Tdwbal		= 0x06038/4,	/* " write-back address low */
	Tdwbah		= 0x0603c/4,

	Dtxctl98	= 0x07e00/4,	/* tx dma control (598 only) */
	Dtxctl99	= 0x04a80/4,	/* tx dma control (599 only) */
	Tdcatxctrl98	= 0x07200/4,	/* tx dca register (0-15) (598 only) */
	Tdcatxctrl99	= 0x0600c/4,	/* tx dca register (0-127) (599 only) */
	Tipg		= 0x0cb00/4,	/* tx inter-packet gap (598 only) */
	Txpbsize	= 0x0cc00/4,	/* tx packet-buffer size (0-15) */

	/* mac */
	Hlreg0		= 0x04240/4,	/* highlander control reg 0 */
	Hlreg1		= 0x04244/4,	/* highlander control reg 1 (ro) */
	Msca		= 0x0425c/4,	/* mdi signal cmd &amp; addr */
	Msrwd		= 0x04260/4,	/* mdi single rw data */
	Mhadd		= 0x04268/4,	/* mac addr high &amp; max frame */
	Pcss1		= 0x04288/4,	/* xgxs status 1 */
	Pcss2		= 0x0428c/4,
	Xpcss		= 0x04290/4,	/* 10gb-x pcs status */
	Serdesc		= 0x04298/4,	/* serdes control */
	Macs		= 0x0429c/4,	/* fifo control &amp; report */
	Autoc		= 0x042a0/4,	/* autodetect control &amp; status */
	Links		= 0x042a4/4,	/* link status */
	Links2		= 0x04324/4,	/* 599 only */
	Autoc2		= 0x042a8/4,
};

enum {
	Factive		= 1&lt;&lt;0,
	Enable		= 1&lt;&lt;31,

	/* Ctrl */
	Rst		= 1&lt;&lt;26,	/* full nic reset */

	/* Txdctl */
	Ten		= 1&lt;&lt;25,

	/* Dtxctl99 */
	Te		= 1&lt;&lt;0,		/* dma tx enable */

	/* Fctrl */
	Bam		= 1&lt;&lt;10,	/* broadcast accept mode */
	Upe 		= 1&lt;&lt;9,		/* unicast promiscuous */
	Mpe 		= 1&lt;&lt;8,		/* multicast promiscuous */

	/* Rxdctl */
	Pthresh		= 0,		/* prefresh threshold shift in bits */
	Hthresh		= 8,		/* host buffer minimum threshold " */
	Wthresh		= 16,		/* writeback threshold */
	Renable		= 1&lt;&lt;25,

	/* Rxctl */
	Rxen		= 1&lt;&lt;0,
	Dmbyps		= 1&lt;&lt;1,		/* descr. monitor bypass (598 only) */

	/* Rdrxctl */
	Rdmt½		= 0,		/* 598 */
	Rdmt¼		= 1,		/* 598 */
	Rdmt⅛		= 2,		/* 598 */
	Crcstrip	= 1&lt;&lt;1,		/* 599 */
	Rscfrstsize	= 037&lt;&lt;17,	/* 599; should be zero */

	/* Rxcsum */
	Ippcse		= 1&lt;&lt;12,	/* ip payload checksum enable */

	/* Eerd */
	EEstart		= 1&lt;&lt;0,		/* Start Read */
	EEdone		= 1&lt;&lt;1,		/* Read done */

	/* interrupts */
	Irx0		= 1&lt;&lt;0,		/* driver defined */
	Itx0		= 1&lt;&lt;1,		/* driver defined */
	Lsc		= 1&lt;&lt;20,	/* link status change */

	/* Links */
	Lnkup		= 1&lt;&lt;30,
	Lnkspd		= 1&lt;&lt;29,

	/* Hlreg0 */
	Txcrcen		= 1&lt;&lt;0,		/* add crc during xmit */
	Rxcrcstrip	= 1&lt;&lt;1,		/* strip crc during recv */
	Jumboen		= 1&lt;&lt;2,
	Txpaden		= 1&lt;&lt;10,	/* pad short frames during xmit */

	/* Autoc */
	Flu		= 1&lt;&lt;0,		/* force link up */
	Lmsshift	= 13,		/* link mode select shift */
	Lmsmask		= 7,
};

typedef struct Ctlr Ctlr;
typedef struct Rd Rd;
typedef struct Td Td;

typedef struct {
	uint	reg;
	char	*name;
} Stat;

Stat stattab[] = {
	0x4000,	"crc error",
	0x4004,	"illegal byte",
	0x4008,	"short packet",
	0x3fa0,	"missed pkt0",
	0x4034,	"mac local flt",
	0x4038,	"mac rmt flt",
	0x4040,	"rx length err",
	0x3f60,	"xon tx",
	0xcf60,	"xon rx",
	0x3f68,	"xoff tx",
	0xcf68,	"xoff rx",
	0x405c,	"rx 040",
	0x4060,	"rx 07f",
	0x4064,	"rx 100",
	0x4068,	"rx 200",
	0x406c,	"rx 3ff",
	0x4070,	"rx big",
	0x4074,	"rx ok",
	0x4078,	"rx bcast",
	0x3fc0,	"rx no buf0",
	0x40a4,	"rx runt",
	0x40a8,	"rx frag",
	0x40ac,	"rx ovrsz",
	0x40b0,	"rx jab",
	0x40d0,	"rx pkt",

	0x40d4,	"tx pkt",
	0x40d8,	"tx 040",
	0x40dc,	"tx 07f",
	0x40e0,	"tx 100",
	0x40e4,	"tx 200",
	0x40e8,	"tx 3ff",
	0x40ec,	"tx big",
	0x40f4,	"tx bcast",
	0x4120,	"xsum err",
};

/* status */
enum {
	Pif	= 1&lt;&lt;7,	/* past exact filter (sic) */
	Ipcs	= 1&lt;&lt;6,	/* ip checksum calculated */
	L4cs	= 1&lt;&lt;5,	/* layer 2 */
	Tcpcs	= 1&lt;&lt;4,	/* tcp checksum calculated */
	Vp	= 1&lt;&lt;3,	/* 802.1q packet matched vet */
	Ixsm	= 1&lt;&lt;2,	/* ignore checksum */
	Reop	= 1&lt;&lt;1,	/* end of packet */
	Rdd	= 1&lt;&lt;0,	/* descriptor done */
};

struct Rd {			/* Receive Descriptor */
	u32int	addr[2];
	ushort	length;
	ushort	cksum;
	uchar	status;
	uchar	errors;
	ushort	vlan;
};

enum {
	/* Td cmd */
	Rs	= 1&lt;&lt;3,		/* report status */
	Ic	= 1&lt;&lt;2,		/* insert checksum */
	Ifcs	= 1&lt;&lt;1,		/* insert FCS (ethernet crc) */
	Teop	= 1&lt;&lt;0,		/* end of packet */

	/* Td status */
	Tdd	= 1&lt;&lt;0,		/* descriptor done */
};

struct Td {			/* Transmit Descriptor */
	u32int	addr[2];
	ushort	length;
	uchar	cso;
	uchar	cmd;
	uchar	status;
	uchar	css;
	ushort	vlan;
};

struct Ctlr {
	Pcidev	*p;
	Ether	*edev;
	int	type;

	/* virtual */
	u32int	*reg;
	u32int	*msix;			/* unused */

	/* physical */
	u32int	*physreg;
	u32int	*physmsix;		/* unused */

	uchar	flag;
	int	nrd;
	int	ntd;
	int	nrb;			/* # bufs this Ctlr has in the pool */
	uint	rbsz;
	int	procsrunning;
	int	attached;

	Watermark wmrb;
	Watermark wmrd;
	Watermark wmtd;

	QLock	slock;
	QLock	alock;			/* attach lock */
	QLock	tlock;
	Rendez	lrendez;
	Rendez	trendez;
	Rendez	rrendez;

	uint	im;			/* interrupt mask */
	uint	lim;
	uint	rim;
	uint	tim;
	Lock	imlock;

	Rd*	rdba;			/* receive descriptor base address */
	Block**	rb;			/* receive buffers */
	int	rdt;			/* receive descriptor tail */
	int	rdfree;			/* rx descriptors awaiting packets */

	Td*	tdba;			/* transmit descriptor base address */
	int	tdh;			/* transmit descriptor head */
	int	tdt;			/* transmit descriptor tail */
	Block**	tb;			/* transmit buffers */

	uchar	ra[Eaddrlen];		/* receive address */
	uchar	mta[128];		/* multicast table array */
	ulong	stats[nelem(stattab)];
	uint	speeds[3];
};

enum {
	I82598 = 1,
	I82599,
};

static	Ctlr	*ctlrtab[4];
static	int	nctlr;
static	Lock	rblock;
static	Block	*rbpool;
static	int	nrbfull;  /* # of rcv Blocks with data awaiting processing */

static void
readstats(Ctlr *ctlr)
{
	int i;

	qlock(&amp;ctlr-&gt;slock);
	for(i = 0; i &lt; nelem(ctlr-&gt;stats); i++)
		ctlr-&gt;stats[i] += ctlr-&gt;reg[stattab[i].reg &gt;&gt; 2];
	qunlock(&amp;ctlr-&gt;slock);
}

static int speedtab[] = {
	0,
	1000,
	10000,
};

static long
ifstat(Ether *edev, void *a, long n, ulong offset)
{
	uint i, *t;
	char *s, *p, *e;
	Ctlr *ctlr;

	ctlr = edev-&gt;ctlr;
	p = s = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	e = p + READSTR;

	readstats(ctlr);
	for(i = 0; i &lt; nelem(stattab); i++)
		if(ctlr-&gt;stats[i] &gt; 0)
			p = seprint(p, e, "%.10s  %uld\n", stattab[i].name,
				ctlr-&gt;stats[i]);
	t = ctlr-&gt;speeds;
	p = seprint(p, e, "speeds: 0:%d 1000:%d 10000:%d\n", t[0], t[1], t[2]);
	p = seprint(p, e, "mtu: min:%d max:%d\n", edev-&gt;minmtu, edev-&gt;maxmtu);
	p = seprint(p, e, "rdfree %d rdh %d rdt %d\n", ctlr-&gt;rdfree, ctlr-&gt;reg[Rdt],
		ctlr-&gt;reg[Rdh]);
	p = seprintmark(p, e, &amp;ctlr-&gt;wmrb);
	p = seprintmark(p, e, &amp;ctlr-&gt;wmrd);
	p = seprintmark(p, e, &amp;ctlr-&gt;wmtd);
	USED(p);
	n = readstr(offset, a, n, s);
	free(s);

	return n;
}

static void
ienable(Ctlr *ctlr, int i)
{
	ilock(&amp;ctlr-&gt;imlock);
	ctlr-&gt;im |= i;
	ctlr-&gt;reg[Ims] = ctlr-&gt;im;
	iunlock(&amp;ctlr-&gt;imlock);
}

static int
lim(void *v)
{
	return ((Ctlr*)v)-&gt;lim != 0;
}

static void
lproc(void *v)
{
	int r, i;
	Ctlr *ctlr;
	Ether *e;

	e = v;
	ctlr = e-&gt;ctlr;
	for (;;) {
		r = ctlr-&gt;reg[Links];
		e-&gt;link = (r &amp; Lnkup) != 0;
		i = 0;
		if(e-&gt;link)
			i = 1 + ((r &amp; Lnkspd) != 0);
		ctlr-&gt;speeds[i]++;
		e-&gt;mbps = speedtab[i];
		ctlr-&gt;lim = 0;
		ienable(ctlr, Lsc);
		sleep(&amp;ctlr-&gt;lrendez, lim, ctlr);
		ctlr-&gt;lim = 0;
	}
}

static long
ctl(Ether *, void *, long)
{
	error(Ebadarg);
	return -1;
}

static Block*
rballoc(void)
{
	Block *bp;

	ilock(&amp;rblock);
	if((bp = rbpool) != nil){
		rbpool = bp-&gt;next;
		bp-&gt;next = 0;
		_xinc(&amp;bp-&gt;ref);	/* prevent bp from being freed */
	}
	iunlock(&amp;rblock);
	return bp;
}

void
rbfree(Block *b)
{
	b-&gt;rp = b-&gt;wp = (uchar*)PGROUND((uintptr)b-&gt;base);
 	b-&gt;flag &amp;= ~(Bipck | Budpck | Btcpck | Bpktck);
	ilock(&amp;rblock);
	b-&gt;next = rbpool;
	rbpool = b;
	nrbfull--;
	iunlock(&amp;rblock);
}

static int
cleanup(Ctlr *ctlr, int tdh)
{
	Block *b;
	uint m, n;

	m = ctlr-&gt;ntd - 1;
	while(ctlr-&gt;tdba[n = NEXTPOW2(tdh, m)].status &amp; Tdd){
		tdh = n;
		b = ctlr-&gt;tb[tdh];
		ctlr-&gt;tb[tdh] = 0;
		if (b)
			freeb(b);
		ctlr-&gt;tdba[tdh].status = 0;
	}
	return tdh;
}

void
transmit(Ether *e)
{
	uint i, m, tdt, tdh;
	Ctlr *ctlr;
	Block *b;
	Td *t;

	ctlr = e-&gt;ctlr;
	if(!canqlock(&amp;ctlr-&gt;tlock)){
		ienable(ctlr, Itx0);
		return;
	}
	tdh = ctlr-&gt;tdh = cleanup(ctlr, ctlr-&gt;tdh);
	tdt = ctlr-&gt;tdt;
	m = ctlr-&gt;ntd - 1;
	for(i = 0; ; i++){
		if(NEXTPOW2(tdt, m) == tdh){	/* ring full? */
			ienable(ctlr, Itx0);
			break;
		}
		if((b = qget(e-&gt;oq)) == nil)
			break;
		assert(ctlr-&gt;tdba != nil);
		t = ctlr-&gt;tdba + tdt;
		t-&gt;addr[0] = PCIWADDR(b-&gt;rp);
		t-&gt;length = BLEN(b);
		t-&gt;cmd = Ifcs | Teop;
		if (!Goslow)
			t-&gt;cmd |= Rs;
		ctlr-&gt;tb[tdt] = b;
		/* note size of queue of tds awaiting transmission */
		notemark(&amp;ctlr-&gt;wmtd, (tdt + Ntd - tdh) % Ntd);
		tdt = NEXTPOW2(tdt, m);
	}
	if(i) {
		coherence();
		ctlr-&gt;reg[Tdt] = ctlr-&gt;tdt = tdt;  /* make new Tds active */
		coherence();
		ienable(ctlr, Itx0);
	}
	qunlock(&amp;ctlr-&gt;tlock);
}

static int
tim(void *c)
{
	return ((Ctlr*)c)-&gt;tim != 0;
}

static void
tproc(void *v)
{
	Ctlr *ctlr;
	Ether *e;

	e = v;
	ctlr = e-&gt;ctlr;
	for (;;) {
		sleep(&amp;ctlr-&gt;trendez, tim, ctlr); /* xmit interrupt kicks us */
		ctlr-&gt;tim = 0;
		transmit(e);
	}
}

static void
rxinit(Ctlr *ctlr)
{
	int i, is598, autoc;
	ulong until;
	Block *b;

	ctlr-&gt;reg[Rxctl] &amp;= ~Rxen;
	ctlr-&gt;reg[Rxdctl] = 0;
	for(i = 0; i &lt; ctlr-&gt;nrd; i++){
		b = ctlr-&gt;rb[i];
		ctlr-&gt;rb[i] = 0;
		if(b)
			freeb(b);
	}
	ctlr-&gt;rdfree = 0;

	coherence();
	ctlr-&gt;reg[Fctrl] |= Bam;
	ctlr-&gt;reg[Fctrl] &amp;= ~(Upe | Mpe);

	/* intel gets some csums wrong (e.g., errata 44) */
	ctlr-&gt;reg[Rxcsum] &amp;= ~Ippcse;
	ctlr-&gt;reg[Hlreg0] &amp;= ~Jumboen;		/* jumbos are a bad idea */
	ctlr-&gt;reg[Hlreg0] |= Txcrcen | Rxcrcstrip | Txpaden;
	ctlr-&gt;reg[Srrctl] = (ctlr-&gt;rbsz + 1024 - 1) / 1024;
	ctlr-&gt;reg[Mhadd] = ctlr-&gt;rbsz &lt;&lt; 16;

	ctlr-&gt;reg[Rbal] = PCIWADDR(ctlr-&gt;rdba);
	ctlr-&gt;reg[Rbah] = 0;
	ctlr-&gt;reg[Rdlen] = ctlr-&gt;nrd*sizeof(Rd); /* must be multiple of 128 */
	ctlr-&gt;reg[Rdh] = 0;
	ctlr-&gt;reg[Rdt] = ctlr-&gt;rdt = 0;
	coherence();

	is598 = (ctlr-&gt;type == I82598);
	if (is598)
		ctlr-&gt;reg[Rdrxctl] = Rdmt¼;
	else {
		ctlr-&gt;reg[Rdrxctl] |= Crcstrip;
		ctlr-&gt;reg[Rdrxctl] &amp;= ~Rscfrstsize;
	}
	if (Goslow &amp;&amp; is598)
		ctlr-&gt;reg[Rxdctl] = 8&lt;&lt;Wthresh | 8&lt;&lt;Pthresh | 4&lt;&lt;Hthresh | Renable;
	else
		ctlr-&gt;reg[Rxdctl] = Renable;
	coherence();

	/*
	 * don't wait forever like an idiot (and hang the system),
	 * maybe it's disconnected.
	 */
	until = TK2MS(MACHP(0)-&gt;ticks) + 250;
	while (!(ctlr-&gt;reg[Rxdctl] &amp; Renable) &amp;&amp; TK2MS(MACHP(0)-&gt;ticks) &lt; until)
		;
	if(!(ctlr-&gt;reg[Rxdctl] &amp; Renable))
		print("#l%d: Renable didn't come on, might be disconnected\n",
			ctlr-&gt;edev-&gt;ctlrno);

	ctlr-&gt;reg[Rxctl] |= Rxen | (is598? Dmbyps: 0);

	if (is598){
		autoc = ctlr-&gt;reg[Autoc];
		/* what is this rubbish and why do we care? */
		print("#l%d: autoc %#ux; lms %d (3 is 10g sfp)\n",
			ctlr-&gt;edev-&gt;ctlrno, autoc, (autoc&gt;&gt;Lmsshift) &amp; Lmsmask);
		ctlr-&gt;reg[Autoc] |= Flu;
		coherence();
		delay(50);
	}
}

static void
replenish(Ctlr *ctlr, uint rdh)
{
	int rdt, m, i;
	Block *b;
	Rd *r;

	m = ctlr-&gt;nrd - 1;
	i = 0;
	for(rdt = ctlr-&gt;rdt; NEXTPOW2(rdt, m) != rdh; rdt = NEXTPOW2(rdt, m)){
		r = ctlr-&gt;rdba + rdt;
		if((b = rballoc()) == nil){
			print("#l%d: no buffers\n", ctlr-&gt;edev-&gt;ctlrno);
			break;
		}
		ctlr-&gt;rb[rdt] = b;
		r-&gt;addr[0] = PCIWADDR(b-&gt;rp);
		r-&gt;status = 0;
		ctlr-&gt;rdfree++;
		i++;
	}
	if(i) {
		coherence();
		ctlr-&gt;reg[Rdt] = ctlr-&gt;rdt = rdt; /* hand back recycled rdescs */
		coherence();
	}
}

static int
rim(void *v)
{
	return ((Ctlr*)v)-&gt;rim != 0;
}

void
rproc(void *v)
{
	int passed;
	uint m, rdh;
	Block *bp;
	Ctlr *ctlr;
	Ether *e;
	Rd *r;

	e = v;
	ctlr = e-&gt;ctlr;
	m = ctlr-&gt;nrd - 1;
	for (rdh = 0; ; ) {
		replenish(ctlr, rdh);
		ienable(ctlr, Irx0);
		sleep(&amp;ctlr-&gt;rrendez, rim, ctlr);
		passed = 0;
		for (;;) {
			ctlr-&gt;rim = 0;
			r = ctlr-&gt;rdba + rdh;
			if(!(r-&gt;status &amp; Rdd))
				break;		/* wait for pkts to arrive */
			bp = ctlr-&gt;rb[rdh];
			ctlr-&gt;rb[rdh] = 0;
			if (r-&gt;length &gt; ETHERMAXTU)
				print("#l%d: got jumbo of %d bytes\n",
					e-&gt;ctlrno, r-&gt;length);
			bp-&gt;wp += r-&gt;length;
			bp-&gt;lim = bp-&gt;wp;		/* lie like a dog */
//			r-&gt;status = 0;

			ilock(&amp;rblock);
			nrbfull++;
			iunlock(&amp;rblock);
			notemark(&amp;ctlr-&gt;wmrb, nrbfull);
			etheriq(e, bp, 1);

			passed++;
			ctlr-&gt;rdfree--;
			rdh = NEXTPOW2(rdh, m);
			if (ctlr-&gt;rdfree &lt;= ctlr-&gt;nrd - 16)
				replenish(ctlr, rdh);
		}
		/* note how many rds had full buffers */
		notemark(&amp;ctlr-&gt;wmrd, passed);
	}
}

static void
promiscuous(void *a, int on)
{
	Ctlr *ctlr;
	Ether *e;

	e = a;
	ctlr = e-&gt;ctlr;
	if(on)
		ctlr-&gt;reg[Fctrl] |= Upe | Mpe;
	else
		ctlr-&gt;reg[Fctrl] &amp;= ~(Upe | Mpe);
}

static void
multicast(void *a, uchar *ea, int on)
{
	int b, i;
	Ctlr *ctlr;
	Ether *e;

	e = a;
	ctlr = e-&gt;ctlr;

	/*
	 * multiple ether addresses can hash to the same filter bit,
	 * so it's never safe to clear a filter bit.
	 * if we want to clear filter bits, we need to keep track of
	 * all the multicast addresses in use, clear all the filter bits,
	 * then set the ones corresponding to in-use addresses.
	 */
	i = ea[5] &gt;&gt; 1;
	b = (ea[5]&amp;1)&lt;&lt;4 | ea[4]&gt;&gt;4;
	b = 1 &lt;&lt; b;
	if(on)
		ctlr-&gt;mta[i] |= b;
//	else
//		ctlr-&gt;mta[i] &amp;= ~b;
	ctlr-&gt;reg[Mta+i] = ctlr-&gt;mta[i];
}

static void
freemem(Ctlr *ctlr)
{
	Block *b;

	while(b = rballoc()){
		b-&gt;free = 0;
		freeb(b);
	}
	free(ctlr-&gt;rdba);
	ctlr-&gt;rdba = nil;
	free(ctlr-&gt;tdba);
	ctlr-&gt;tdba = nil;
	free(ctlr-&gt;rb);
	ctlr-&gt;rb = nil;
	free(ctlr-&gt;tb);
	ctlr-&gt;tb = nil;
}

static int
detach(Ctlr *ctlr)
{
	int i, is598;

	ctlr-&gt;reg[Imc] = ~0;
	ctlr-&gt;reg[Ctrl] |= Rst;
	for(i = 0; i &lt; 100; i++){
		delay(1);
		if((ctlr-&gt;reg[Ctrl] &amp; Rst) == 0)
			break;
	}
	if (i &gt;= 100)
		return -1;
	is598 = (ctlr-&gt;type == I82598);
	if (is598) {			/* errata */
		delay(50);
		ctlr-&gt;reg[Ecc] &amp;= ~(1&lt;&lt;21 | 1&lt;&lt;18 | 1&lt;&lt;9 | 1&lt;&lt;6);
	}

	/* not cleared by reset; kill it manually. */
	for(i = 1; i &lt; 16; i++)
		ctlr-&gt;reg[is598? Rah98: Rah99] &amp;= ~Enable;
	for(i = 0; i &lt; 128; i++)
		ctlr-&gt;reg[Mta + i] = 0;
	for(i = 1; i &lt; (is598? 640: 128); i++)
		ctlr-&gt;reg[Vfta + i] = 0;

//	freemem(ctlr);			// TODO
	ctlr-&gt;attached = 0;
	return 0;
}

static void
shutdown(Ether *e)
{
	detach(e-&gt;ctlr);
//	freemem(e-&gt;ctlr);
}

/* ≤ 20ms */
static ushort
eeread(Ctlr *ctlr, int i)
{
	ctlr-&gt;reg[Eerd] = EEstart | i&lt;&lt;2;
	while((ctlr-&gt;reg[Eerd] &amp; EEdone) == 0)
		;
	return ctlr-&gt;reg[Eerd] &gt;&gt; 16;
}

static int
eeload(Ctlr *ctlr)
{
	ushort u, v, p, l, i, j;

	if((eeread(ctlr, 0) &amp; 0xc0) != 0x40)
		return -1;
	u = 0;
	for(i = 0; i &lt; 0x40; i++)
		u +=  eeread(ctlr, i);
	for(i = 3; i &lt; 0xf; i++){
		p = eeread(ctlr, i);
		l = eeread(ctlr, p++);
		if((int)p + l + 1 &gt; 0xffff)
			continue;
		for(j = p; j &lt; p + l; j++)
			u += eeread(ctlr, j);
	}
	if(u != 0xbaba)
		return -1;
	if(ctlr-&gt;reg[Status] &amp; (1&lt;&lt;3))
		u = eeread(ctlr, 10);
	else
		u = eeread(ctlr, 9);
	u++;
	for(i = 0; i &lt; Eaddrlen;){
		v = eeread(ctlr, u + i/2);
		ctlr-&gt;ra[i++] = v;
		ctlr-&gt;ra[i++] = v&gt;&gt;8;
	}
	ctlr-&gt;ra[5] += (ctlr-&gt;reg[Status] &amp; 0xc) &gt;&gt; 2;
	return 0;
}

static int
reset(Ctlr *ctlr)
{
	int i, is598;
	uchar *p;

	if(detach(ctlr)){
		print("82598: reset timeout\n");
		return -1;
	}
	if(eeload(ctlr)){
		print("82598: eeprom failure\n");
		return -1;
	}
	p = ctlr-&gt;ra;
	is598 = (ctlr-&gt;type == I82598);
	ctlr-&gt;reg[is598? Ral98: Ral99] = p[3]&lt;&lt;24 | p[2]&lt;&lt;16 | p[1]&lt;&lt;8 | p[0];
	ctlr-&gt;reg[is598? Rah98: Rah99] = p[5]&lt;&lt;8 | p[4] | Enable;

	readstats(ctlr);
	for(i = 0; i&lt;nelem(ctlr-&gt;stats); i++)
		ctlr-&gt;stats[i] = 0;

	ctlr-&gt;reg[Ctrlext] |= 1 &lt;&lt; 16;	/* required by errata (spec change 4) */
	if (Goslow) {
		/* make some guesses for flow control */
		ctlr-&gt;reg[Fcrtl] = 0x10000 | Enable;
		ctlr-&gt;reg[Fcrth] = 0x40000 | Enable;
		ctlr-&gt;reg[Rcrtv] = 0x6000;
	} else
		ctlr-&gt;reg[Fcrtl] = ctlr-&gt;reg[Fcrth] = ctlr-&gt;reg[Rcrtv] = 0;

	/* configure interrupt mapping (don't ask) */
	ctlr-&gt;reg[Ivar+0] =     0 | 1&lt;&lt;7;
	ctlr-&gt;reg[Ivar+64/4] =  1 | 1&lt;&lt;7;
//	ctlr-&gt;reg[Ivar+97/4] = (2 | 1&lt;&lt;7) &lt;&lt; (8*(97%4));

	if (Goslow) {
		/* interrupt throttling goes here. */
		for(i = Itr; i &lt; Itr + 20; i++)
			ctlr-&gt;reg[i] = 128;		/* ¼µs intervals */
		ctlr-&gt;reg[Itr + Itx0] = 256;
	} else {					/* don't throttle */
		for(i = Itr; i &lt; Itr + 20; i++)
			ctlr-&gt;reg[i] = 0;		/* ¼µs intervals */
		ctlr-&gt;reg[Itr + Itx0] = 0;
	}
	return 0;
}

static void
txinit(Ctlr *ctlr)
{
	Block *b;
	int i;

	if (Goslow)
		ctlr-&gt;reg[Txdctl] = 16&lt;&lt;Wthresh | 16&lt;&lt;Pthresh;
	else
		ctlr-&gt;reg[Txdctl] = 0;
	if (ctlr-&gt;type == I82599)
		ctlr-&gt;reg[Dtxctl99] = 0;
	coherence();
	for(i = 0; i &lt; ctlr-&gt;ntd; i++){
		b = ctlr-&gt;tb[i];
		ctlr-&gt;tb[i] = 0;
		if(b)
			freeb(b);
	}

	assert(ctlr-&gt;tdba != nil);
	memset(ctlr-&gt;tdba, 0, ctlr-&gt;ntd * sizeof(Td));
	ctlr-&gt;reg[Tdbal] = PCIWADDR(ctlr-&gt;tdba);
	ctlr-&gt;reg[Tdbah] = 0;
	ctlr-&gt;reg[Tdlen] = ctlr-&gt;ntd*sizeof(Td); /* must be multiple of 128 */
	ctlr-&gt;reg[Tdh] = 0;
	ctlr-&gt;tdh = ctlr-&gt;ntd - 1;
	ctlr-&gt;reg[Tdt] = ctlr-&gt;tdt = 0;
	coherence();
	if (ctlr-&gt;type == I82599)
		ctlr-&gt;reg[Dtxctl99] |= Te;
	coherence();
	ctlr-&gt;reg[Txdctl] |= Ten;
	coherence();
	while (!(ctlr-&gt;reg[Txdctl] &amp; Ten))
		;
}

static void
attach(Ether *e)
{
	Block *b;
	Ctlr *ctlr;
	char buf[KNAMELEN];

	ctlr = e-&gt;ctlr;
	ctlr-&gt;edev = e;			/* point back to Ether* */
	qlock(&amp;ctlr-&gt;alock);
	if(waserror()){
		reset(ctlr);
		freemem(ctlr);
		qunlock(&amp;ctlr-&gt;alock);
		nexterror();
	}
	if(ctlr-&gt;rdba == nil) {
		ctlr-&gt;nrd = Nrd;
		ctlr-&gt;ntd = Ntd;
		ctlr-&gt;rdba = mallocalign(ctlr-&gt;nrd * sizeof *ctlr-&gt;rdba,
			Descalign, 0, 0);
		ctlr-&gt;tdba = mallocalign(ctlr-&gt;ntd * sizeof *ctlr-&gt;tdba,
			Descalign, 0, 0);
		ctlr-&gt;rb = malloc(ctlr-&gt;nrd * sizeof(Block *));
		ctlr-&gt;tb = malloc(ctlr-&gt;ntd * sizeof(Block *));
		if (ctlr-&gt;rdba == nil || ctlr-&gt;tdba == nil ||
		    ctlr-&gt;rb == nil || ctlr-&gt;tb == nil)
			error(Enomem);

		for(ctlr-&gt;nrb = 0; ctlr-&gt;nrb &lt; 2*Nrb; ctlr-&gt;nrb++){
			b = allocb(ctlr-&gt;rbsz + BY2PG);	/* see rbfree() */
			if(b == nil)
				error(Enomem);
			b-&gt;free = rbfree;
			freeb(b);
		}
	}
	if (!ctlr-&gt;attached) {
		rxinit(ctlr);
		txinit(ctlr);
		nrbfull = 0;
		if (!ctlr-&gt;procsrunning) {
			snprint(buf, sizeof buf, "#l%dl", e-&gt;ctlrno);
			kproc(buf, lproc, e);
			snprint(buf, sizeof buf, "#l%dr", e-&gt;ctlrno);
			kproc(buf, rproc, e);
			snprint(buf, sizeof buf, "#l%dt", e-&gt;ctlrno);
			kproc(buf, tproc, e);
			ctlr-&gt;procsrunning = 1;
		}
		initmark(&amp;ctlr-&gt;wmrb, Nrb, "rcv bufs unprocessed");
		initmark(&amp;ctlr-&gt;wmrd, Nrd-1, "rcv descrs processed at once");
		initmark(&amp;ctlr-&gt;wmtd, Ntd-1, "xmit descr queue len");
		ctlr-&gt;attached = 1;
	}
	qunlock(&amp;ctlr-&gt;alock);
	poperror();
}

static void
interrupt(Ureg*, void *v)
{
	int icr, im;
	Ctlr *ctlr;
	Ether *e;

	e = v;
	ctlr = e-&gt;ctlr;
	ilock(&amp;ctlr-&gt;imlock);
	ctlr-&gt;reg[Imc] = ~0;			/* disable all intrs */
	im = ctlr-&gt;im;
	while((icr = ctlr-&gt;reg[Icr] &amp; ctlr-&gt;im) != 0){
		if(icr &amp; Irx0){
			im &amp;= ~Irx0;
			ctlr-&gt;rim = Irx0;
			wakeup(&amp;ctlr-&gt;rrendez);
		}
		if(icr &amp; Itx0){
			im &amp;= ~Itx0;
			ctlr-&gt;tim = Itx0;
			wakeup(&amp;ctlr-&gt;trendez);
		}
		if(icr &amp; Lsc){
			im &amp;= ~Lsc;
			ctlr-&gt;lim = Lsc;
			wakeup(&amp;ctlr-&gt;lrendez);
		}
	}
	ctlr-&gt;reg[Ims] = ctlr-&gt;im = im; /* enable only intrs we didn't service */
	iunlock(&amp;ctlr-&gt;imlock);
}

static void
scan(void)
{
	int pciregs, pcimsix, type;
	ulong io, iomsi;
	void *mem, *memmsi;
	Ctlr *ctlr;
	Pcidev *p;

	p = 0;
	while(p = pcimatch(p, Vintel, 0)){
		switch(p-&gt;did){
		case 0x10b6:		/* 82598 backplane */
		case 0x10c6:		/* 82598 af dual port */
		case 0x10c7:		/* 82598 af single port */
		case 0x10dd:		/* 82598 at cx4 */
		case 0x10ec:		/* 82598 at cx4 dual port */
			pcimsix = 3;
			type = I82598;
			break;
		case 0x10f7:		/* 82599 kx/kx4 */
		case 0x10f8:		/* 82599 kx/kx4/kx */
		case 0x10f9:		/* 82599 cx4 */
		case 0x10fb:		/* 82599 sfi/sfp+ */
		case 0x10fc:		/* 82599 xaui/bx4 */
		case 0x1557:		/* 82599 single-port sfi */
			pcimsix = 4;
			type = I82599;
			break;
		default:
			continue;
		}
		pciregs = 0;
		if(nctlr &gt;= nelem(ctlrtab)){
			print("i82598: too many controllers\n");
			return;
		}

		io = p-&gt;mem[pciregs].bar &amp; ~0xf;
		mem = vmap(io, p-&gt;mem[pciregs].size);
		if(mem == nil){
			print("i82598: can't map regs %#p\n",
				p-&gt;mem[pciregs].bar);
			continue;
		}

		iomsi = p-&gt;mem[pcimsix].bar &amp; ~0xf;
		memmsi = vmap(iomsi, p-&gt;mem[pcimsix].size);
		if(memmsi == nil){
			print("i82598: can't map msi-x regs %#p\n",
				p-&gt;mem[pcimsix].bar);
			vunmap(mem, p-&gt;mem[pciregs].size);
			continue;
		}

		ctlr = malloc(sizeof *ctlr);
		if(ctlr == nil) {
			vunmap(mem, p-&gt;mem[pciregs].size);
			vunmap(memmsi, p-&gt;mem[pcimsix].size);
			error(Enomem);
		}
		ctlr-&gt;p = p;
		ctlr-&gt;type = type;
		ctlr-&gt;physreg = (u32int*)io;
		ctlr-&gt;physmsix = (u32int*)iomsi;
		ctlr-&gt;reg = (u32int*)mem;
		ctlr-&gt;msix = (u32int*)memmsi;	/* unused */
		ctlr-&gt;rbsz = Rbsz;
		if(reset(ctlr)){
			print("i82598: can't reset\n");
			free(ctlr);
			vunmap(mem, p-&gt;mem[pciregs].size);
			vunmap(memmsi, p-&gt;mem[pcimsix].size);
			continue;
		}
		pcisetbme(p);
		ctlrtab[nctlr++] = ctlr;
	}
}

static int
pnp(Ether *e)
{
	int i;
	Ctlr *ctlr;

	if(nctlr == 0)
		scan();
	ctlr = nil;
	for(i = 0; i &lt; nctlr; i++){
		ctlr = ctlrtab[i];
		if(ctlr == nil || ctlr-&gt;flag &amp; Factive)
			continue;
		if(e-&gt;port == 0 || e-&gt;port == (ulong)ctlr-&gt;reg)
			break;
	}
	if (i &gt;= nctlr)
		return -1;
	ctlr-&gt;flag |= Factive;
	e-&gt;ctlr = ctlr;
	e-&gt;port = (uintptr)ctlr-&gt;physreg;
	e-&gt;irq = ctlr-&gt;p-&gt;intl;
	e-&gt;tbdf = ctlr-&gt;p-&gt;tbdf;
	e-&gt;mbps = 10000;
	e-&gt;maxmtu = ETHERMAXTU;
	memmove(e-&gt;ea, ctlr-&gt;ra, Eaddrlen);

	e-&gt;arg = e;
	e-&gt;attach = attach;
	e-&gt;detach = shutdown;
	e-&gt;transmit = transmit;
	e-&gt;interrupt = interrupt;
	e-&gt;ifstat = ifstat;
	e-&gt;shutdown = shutdown;
	e-&gt;ctl = ctl;
	e-&gt;multicast = multicast;
	e-&gt;promiscuous = promiscuous;

	return 0;
}

void
ether82598link(void)
{
	addethercard("i82598", pnp);
	addethercard("i10gbe", pnp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

