<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/etherec2t.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/etherec2t.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Supposed NE2000 PCMCIA clones, see the comments in ether2000.c
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "ether8390.h"

enum {
	Data		= 0x10,		/* offset from I/O base of data port */
	Reset		= 0x1F,		/* offset from I/O base of reset port */
};

typedef struct Ec2t {
	char*	name;
	int	iochecksum;
} Ec2t;

static Ec2t ec2tpcmcia[] = {
	{ "EC2T", 0, },			/* Linksys Combo PCMCIA EthernetCard */
	{ "PCMPC100", 1, },		/* EtherFast 10/100 PC Card */
	{ "PCM100", 1, },		/* EtherFast PCM100 Card */
	{ "EN2216", 0, },		/* Accton EtherPair-PCMCIA */
	{ "FA410TX", 1, },		/* Netgear FA410TX */
	{ "FA411", 0 },			/* Netgear FA411 PCMCIA */
	{ "Network Everywhere", 0, },	/* Linksys NP10T 10BaseT Card */
	{ "10/100 Port Attached", 1, },	/* SMC 8040TX */
	{ "8041TX-10/100-PC-Card-V2", 0 }, /* SMC 8041TX */
	{ "SMC8022", 0},		/* SMC 8022 / EZCard-10-PCMCIA */
	{ nil, 0, },
};

static int
reset(Ether* ether)
{
	ushort buf[16];
	ulong port;
	Dp8390 *ctlr;
	int i, slot;
	uchar ea[Eaddrlen], sum, x;
	Ec2t *ec2t, tmpec2t;

	/*
	 * Set up the software configuration.
	 * Use defaults for port, irq, mem and size
	 * if not specified.
	 * The manual says 16KB memory, the box
	 * says 32KB. The manual seems to be correct.
	 */
	if(ether-&gt;port == 0)
		ether-&gt;port = 0x300;
	if(ether-&gt;irq == 0)
		ether-&gt;irq = 9;
	if(ether-&gt;mem == 0)
		ether-&gt;mem = 0x4000;
	if(ether-&gt;size == 0)
		ether-&gt;size = 16*1024;
	port = ether-&gt;port;

	if(ioalloc(ether-&gt;port, 0x20, 0, "ec2t") &lt; 0)
		return -1;
	slot = -1;
	for(ec2t = ec2tpcmcia; ec2t-&gt;name != nil; ec2t++){
		if((slot = pcmspecial(ec2t-&gt;name, ether)) &gt;= 0)
			break;
	}
	if(ec2t-&gt;name == nil){
		ec2t = &amp;tmpec2t;
		ec2t-&gt;name = nil;
		ec2t-&gt;iochecksum = 0;
		for(i = 0; i &lt; ether-&gt;nopt; i++){
			if(cistrncmp(ether-&gt;opt[i], "id=", 3) == 0){
				ec2t-&gt;name = &amp;ether-&gt;opt[i][3];
				slot = pcmspecial(ec2t-&gt;name, ether);
			}
			else if(cistrncmp(ether-&gt;opt[i], "iochecksum", 10) == 0)
				ec2t-&gt;iochecksum = 1;
		}
	}
	if(slot &lt; 0){
		iofree(port);
		return -1;
	}

	ether-&gt;ctlr = malloc(sizeof(Dp8390));
	ctlr = ether-&gt;ctlr;
	if(ctlr == nil) {
		iofree(port);
		error(Enomem);
	}
	ctlr-&gt;width = 2;
	ctlr-&gt;ram = 0;

	ctlr-&gt;port = port;
	ctlr-&gt;data = port+Data;

	ctlr-&gt;tstart = HOWMANY(ether-&gt;mem, Dp8390BufSz);
	ctlr-&gt;pstart = ctlr-&gt;tstart + HOWMANY(sizeof(Etherpkt), Dp8390BufSz);
	ctlr-&gt;pstop = ctlr-&gt;tstart + HOWMANY(ether-&gt;size, Dp8390BufSz);

	ctlr-&gt;dummyrr = 0;
	for(i = 0; i &lt; ether-&gt;nopt; i++){
		if(cistrcmp(ether-&gt;opt[i], "nodummyrr") == 0)
			ctlr-&gt;dummyrr = 0;
		else if(cistrncmp(ether-&gt;opt[i], "dummyrr=", 8) == 0)
			ctlr-&gt;dummyrr = strtol(&amp;ether-&gt;opt[i][8], nil, 0);
	}

	/*
	 * Reset the board. This is done by doing a read
	 * followed by a write to the Reset address.
	 */
	buf[0] = inb(port+Reset);
	delay(2);
	outb(port+Reset, buf[0]);
	delay(2);

	/*
	 * Init the (possible) chip, then use the (possible)
	 * chip to read the (possible) PROM for ethernet address
	 * and a marker byte.
	 * Could just look at the DP8390 command register after
	 * initialisation has been tried, but that wouldn't be
	 * enough, there are other ethernet boards which could
	 * match.
	 */
	dp8390reset(ether);
	sum = 0;
	if(ec2t-&gt;iochecksum){
		/*
		 * These cards have the ethernet address in I/O space.
		 * There's a checksum over 8 bytes which sums to 0xFF.
		 */
		for(i = 0; i &lt; 8; i++){
			x = inb(port+0x14+i);
			sum += x;
			buf[i] = (x&lt;&lt;8)|x;
		}
	}
	else{
		memset(buf, 0, sizeof(buf));
		dp8390read(ctlr, buf, 0, sizeof(buf));
		if((buf[0x0E] &amp; 0xFF) == 0x57 &amp;&amp; (buf[0x0F] &amp; 0xFF) == 0x57)
			sum = 0xFF;
	}
	if(sum != 0xFF){
		pcmspecialclose(slot);
		iofree(ether-&gt;port);
		free(ether-&gt;ctlr);
		return -1;
	}

	/*
	 * Stupid machine. Shorts were asked for,
	 * shorts were delivered, although the PROM is a byte array.
	 * Set the ethernet address.
	 */
	memset(ea, 0, Eaddrlen);
	if(memcmp(ea, ether-&gt;ea, Eaddrlen) == 0){
		for(i = 0; i &lt; sizeof(ether-&gt;ea); i++)
			ether-&gt;ea[i] = buf[i];
	}
	dp8390setea(ether);

	return 0;
}

void
etherec2tlink(void)
{
	addethercard("EC2T", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

