<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/screen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/screen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

#define RGB2K(r,g,b)	((156763*(r)+307758*(g)+59769*(b))&gt;&gt;19)

Point ZP = {0, 0};

Rectangle physgscreenr;

Memdata gscreendata;
Memimage *gscreen;

VGAscr vgascreen[1];

Cursor	arrow = {
	{ -1, -1 },
	{ 0xFF, 0xFF, 0x80, 0x01, 0x80, 0x02, 0x80, 0x0C, 
	  0x80, 0x10, 0x80, 0x10, 0x80, 0x08, 0x80, 0x04, 
	  0x80, 0x02, 0x80, 0x01, 0x80, 0x02, 0x8C, 0x04, 
	  0x92, 0x08, 0x91, 0x10, 0xA0, 0xA0, 0xC0, 0x40, 
	},
	{ 0x00, 0x00, 0x7F, 0xFE, 0x7F, 0xFC, 0x7F, 0xF0, 
	  0x7F, 0xE0, 0x7F, 0xE0, 0x7F, 0xF0, 0x7F, 0xF8, 
	  0x7F, 0xFC, 0x7F, 0xFE, 0x7F, 0xFC, 0x73, 0xF8, 
	  0x61, 0xF0, 0x60, 0xE0, 0x40, 0x40, 0x00, 0x00, 
	},
};

int didswcursorinit;

static void *softscreen;

int
screensize(int x, int y, int z, ulong chan)
{
	VGAscr *scr;
	void *oldsoft;

	lock(&amp;vgascreenlock);
	if(waserror()){
		unlock(&amp;vgascreenlock);
		nexterror();
	}

	memimageinit();
	scr = &amp;vgascreen[0];
	oldsoft = softscreen;

	if(scr-&gt;paddr == 0){
		int width = (x*z)/BI2WD;
		void *p;

		p = xalloc(width*BY2WD*y);
		if(p == nil)
			error("no memory for vga soft screen");
		gscreendata.bdata = softscreen = p;
		if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;page){
			scr-&gt;vaddr = KADDR(VGAMEM());
			scr-&gt;apsize = 1&lt;&lt;16;
		}
		scr-&gt;useflush = 1;
	}
	else{
		gscreendata.bdata = scr-&gt;vaddr;
		scr-&gt;useflush = scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;flush;
	}

	scr-&gt;gscreen = nil;
	if(gscreen)
		freememimage(gscreen);
	gscreen = allocmemimaged(Rect(0,0,x,y), chan, &amp;gscreendata);
	if(gscreen == nil)
		error("no memory for vga memimage");
	vgaimageinit(chan);

	scr-&gt;palettedepth = 6;	/* default */
	scr-&gt;gscreendata = &amp;gscreendata;
	scr-&gt;memdefont = getmemdefont();
	scr-&gt;gscreen = gscreen;

	physgscreenr = gscreen-&gt;r;
	unlock(&amp;vgascreenlock);
	poperror();
	if(oldsoft)
		xfree(oldsoft);

	memimagedraw(gscreen, gscreen-&gt;r, memblack, ZP, nil, ZP, S);
	flushmemscreen(gscreen-&gt;r);

	if(didswcursorinit)
		swcursorinit();
	drawcmap();
	return 0;
}

int
screenaperture(int size, int align)
{
	VGAscr *scr;

	scr = &amp;vgascreen[0];

	if(scr-&gt;paddr)	/* set up during enable */
		return 0;

	if(size == 0)
		return 0;

	if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;linear){
		scr-&gt;dev-&gt;linear(scr, size, align);
		return 0;
	}

	/*
	 * Need to allocate some physical address space.
	 * The driver will tell the card to use it.
	 */
	size = PGROUND(size);
	scr-&gt;paddr = upaalloc(size, align);
	if(scr-&gt;paddr == 0)
		return -1;
	scr-&gt;vaddr = vmap(scr-&gt;paddr, size);
	if(scr-&gt;vaddr == nil)
		return -1;
	scr-&gt;apsize = size;

	return 0;
}

uchar*
attachscreen(Rectangle* r, ulong* chan, int* d, int* width, int *softscreen)
{
	VGAscr *scr;

	scr = &amp;vgascreen[0];
	if(scr-&gt;gscreen == nil || scr-&gt;gscreendata == nil)
		return nil;

	*r = scr-&gt;gscreen-&gt;clipr;
	*chan = scr-&gt;gscreen-&gt;chan;
	*d = scr-&gt;gscreen-&gt;depth;
	*width = scr-&gt;gscreen-&gt;width;
	*softscreen = scr-&gt;useflush;

	return scr-&gt;gscreendata-&gt;bdata;
}

/*
 * It would be fair to say that this doesn't work for &gt;8-bit screens.
 */
void
flushmemscreen(Rectangle r)
{
	VGAscr *scr;
	uchar *sp, *disp, *sdisp, *edisp;
	int y, len, incs, off, page;

	scr = &amp;vgascreen[0];
	if(scr-&gt;dev &amp;&amp; scr-&gt;dev-&gt;flush){
		scr-&gt;dev-&gt;flush(scr, r);
		return;
	}
	if(scr-&gt;gscreen == nil || scr-&gt;useflush == 0)
		return;
	if(scr-&gt;dev == nil || scr-&gt;dev-&gt;page == nil)
		return;

	if(rectclip(&amp;r, scr-&gt;gscreen-&gt;r) == 0)
		return;

	incs = scr-&gt;gscreen-&gt;width * BY2WD;

	switch(scr-&gt;gscreen-&gt;depth){
	default:
		len = 0;
		panic("flushmemscreen: depth\n");
		break;
	case 8:
		len = Dx(r);
		break;
	}
	if(len &lt; 1)
		return;

	off = r.min.y*scr-&gt;gscreen-&gt;width*BY2WD+(r.min.x*scr-&gt;gscreen-&gt;depth)/8;
	page = off/scr-&gt;apsize;
	off %= scr-&gt;apsize;
	disp = scr-&gt;vaddr;
	sdisp = disp+off;
	edisp = disp+scr-&gt;apsize;

	off = r.min.y*scr-&gt;gscreen-&gt;width*BY2WD+(r.min.x*scr-&gt;gscreen-&gt;depth)/8;

	sp = scr-&gt;gscreendata-&gt;bdata + off;

	scr-&gt;dev-&gt;page(scr, page);
	for(y = r.min.y; y &lt; r.max.y; y++) {
		if(sdisp + incs &lt; edisp) {
			memmove(sdisp, sp, len);
			sp += incs;
			sdisp += incs;
		}
		else {
			off = edisp - sdisp;
			page++;
			if(off &lt;= len){
				if(off &gt; 0)
					memmove(sdisp, sp, off);
				scr-&gt;dev-&gt;page(scr, page);
				if(len - off &gt; 0)
					memmove(disp, sp+off, len - off);
			}
			else {
				memmove(sdisp, sp, len);
				scr-&gt;dev-&gt;page(scr, page);
			}
			sp += incs;
			sdisp += incs - scr-&gt;apsize;
		}
	}
}

void
getcolor(ulong p, ulong* pr, ulong* pg, ulong* pb)
{
	VGAscr *scr;
	ulong x;

	scr = &amp;vgascreen[0];
	if(scr-&gt;gscreen == nil)
		return;

	switch(scr-&gt;gscreen-&gt;depth){
	default:
		x = 0x0F;
		break;
	case 8:
		x = 0xFF;
		break;
	}
	p &amp;= x;

	lock(&amp;cursor);
	*pr = scr-&gt;colormap[p][0];
	*pg = scr-&gt;colormap[p][1];
	*pb = scr-&gt;colormap[p][2];
	unlock(&amp;cursor);
}

int
setpalette(ulong p, ulong r, ulong g, ulong b)
{
	VGAscr *scr;
	int d;

	scr = &amp;vgascreen[0];
	d = scr-&gt;palettedepth;

	lock(&amp;cursor);
	scr-&gt;colormap[p][0] = r;
	scr-&gt;colormap[p][1] = g;
	scr-&gt;colormap[p][2] = b;
	vgao(PaddrW, p);
	vgao(Pdata, r&gt;&gt;(32-d));
	vgao(Pdata, g&gt;&gt;(32-d));
	vgao(Pdata, b&gt;&gt;(32-d));
	unlock(&amp;cursor);

	return ~0;
}

/*
 * On some video cards (e.g. Mach64), the palette is used as the 
 * DAC registers for &gt;8-bit modes.  We don't want to set them when the user
 * is trying to set a colormap and the card is in one of these modes.
 */
int
setcolor(ulong p, ulong r, ulong g, ulong b)
{
	VGAscr *scr;
	int x;

	scr = &amp;vgascreen[0];
	if(scr-&gt;gscreen == nil)
		return 0;

	switch(scr-&gt;gscreen-&gt;depth){
	case 1:
	case 2:
	case 4:
		x = 0x0F;
		break;
	case 8:
		x = 0xFF;
		break;
	default:
		return 0;
	}
	p &amp;= x;

	return setpalette(p, r, g, b);
}

int
cursoron(int dolock)
{
	VGAscr *scr;
	int v;

	scr = &amp;vgascreen[0];
	if(scr-&gt;cur == nil || scr-&gt;cur-&gt;move == nil)
		return 0;

	if(dolock)
		lock(&amp;cursor);
	v = scr-&gt;cur-&gt;move(scr, mousexy());
	if(dolock)
		unlock(&amp;cursor);

	return v;
}

void
cursoroff(int)
{
}

void
setcursor(Cursor* curs)
{
	VGAscr *scr;

	scr = &amp;vgascreen[0];
	if(scr-&gt;cur == nil || scr-&gt;cur-&gt;load == nil)
		return;

	scr-&gt;cur-&gt;load(scr, curs);
}

int hwaccel = 1;
int hwblank = 0;	/* turned on by drivers that are known good */
int panning = 0;

int
hwdraw(Memdrawparam *par)
{
	VGAscr *scr;
	Memimage *dst, *src, *mask;
	int m;

	if(hwaccel == 0)
		return 0;

	scr = &amp;vgascreen[0];
	if((dst=par-&gt;dst) == nil || dst-&gt;data == nil)
		return 0;
	if((src=par-&gt;src) == nil || src-&gt;data == nil)
		return 0;
	if((mask=par-&gt;mask) == nil || mask-&gt;data == nil)
		return 0;

	if(scr-&gt;cur == &amp;swcursor){
		/*
		 * always calling swcursorhide here doesn't cure
		 * leaving cursor tracks nor failing to refresh menus
		 * with the latest libmemdraw/draw.c.
		 */
		if(dst-&gt;data-&gt;bdata == gscreendata.bdata)
			swcursoravoid(par-&gt;r);
		if(src-&gt;data-&gt;bdata == gscreendata.bdata)
			swcursoravoid(par-&gt;sr);
		if(mask-&gt;data-&gt;bdata == gscreendata.bdata)
			swcursoravoid(par-&gt;mr);
	}
	
	if(dst-&gt;data-&gt;bdata != gscreendata.bdata)
		return 0;

	if(scr-&gt;fill==nil &amp;&amp; scr-&gt;scroll==nil)
		return 0;

	/*
	 * If we have an opaque mask and source is one opaque
	 * pixel we can convert to the destination format and just
	 * replicate with memset.
	 */
	m = Simplesrc|Simplemask|Fullmask;
	if(scr-&gt;fill
	&amp;&amp; (par-&gt;state&amp;m)==m
	&amp;&amp; ((par-&gt;srgba&amp;0xFF) == 0xFF)
	&amp;&amp; (par-&gt;op&amp;S) == S)
		return scr-&gt;fill(scr, par-&gt;r, par-&gt;sdval);

	/*
	 * If no source alpha, an opaque mask, we can just copy the
	 * source onto the destination.  If the channels are the same and
	 * the source is not replicated, memmove suffices.
	 */
	m = Simplemask|Fullmask;
	if(scr-&gt;scroll
	&amp;&amp; src-&gt;data-&gt;bdata==dst-&gt;data-&gt;bdata
	&amp;&amp; !(src-&gt;flags&amp;Falpha)
	&amp;&amp; (par-&gt;state&amp;m)==m
	&amp;&amp; (par-&gt;op&amp;S) == S)
		return scr-&gt;scroll(scr, par-&gt;r, par-&gt;sr);

	return 0;	
}

void
blankscreen(int blank)
{
	VGAscr *scr;

	scr = &amp;vgascreen[0];
	if(hwblank){
		if(scr-&gt;blank)
			scr-&gt;blank(scr, blank);
		else
			vgablank(scr, blank);
	}
}

void
vgalinearpciid(VGAscr *scr, int vid, int did)
{
	Pcidev *p;

	p = nil;
	while((p = pcimatch(p, vid, 0)) != nil){
		if(p-&gt;ccrb != 3)	/* video card */
			continue;
		if(did != 0 &amp;&amp; p-&gt;did != did)
			continue;
		break;
	}
	if(p == nil)
		error("pci video card not found");

	scr-&gt;pci = p;
	vgalinearpci(scr);
}

void
vgalinearpci(VGAscr *scr)
{
	ulong paddr;
	int i, size, best;
	Pcidev *p;
	
	p = scr-&gt;pci;
	if(p == nil)
		return;

	/*
	 * Scan for largest memory region on card.
	 * Some S3 cards (e.g. Savage) have enormous
	 * mmio regions (but even larger frame buffers).
	 * Some 3dfx cards (e.g., Voodoo3) have mmio
	 * buffers the same size as the frame buffer,
	 * but only the frame buffer is marked as
	 * prefetchable (bar&amp;8).  If a card doesn't fit
	 * into these heuristics, its driver will have to
	 * call vgalinearaddr directly.
	 */
	best = -1;
	for(i=0; i&lt;nelem(p-&gt;mem); i++){
		if(p-&gt;mem[i].bar&amp;1)	/* not memory */
			continue;
		if(p-&gt;mem[i].size &lt; 640*480)	/* not big enough */
			continue;
		if(best==-1 
		|| p-&gt;mem[i].size &gt; p-&gt;mem[best].size 
		|| (p-&gt;mem[i].size == p-&gt;mem[best].size 
		  &amp;&amp; (p-&gt;mem[i].bar&amp;8)
		  &amp;&amp; !(p-&gt;mem[best].bar&amp;8)))
			best = i;
	}
	if(best &gt;= 0){
		paddr = p-&gt;mem[best].bar &amp; ~0x0F;
		size = p-&gt;mem[best].size;
		vgalinearaddr(scr, paddr, size);
		return;
	}
	error("no video memory found on pci card");
}

void
vgalinearaddr(VGAscr *scr, ulong paddr, int size)
{
	int x, nsize;
	ulong npaddr;

	/*
	 * new approach.  instead of trying to resize this
	 * later, let's assume that we can just allocate the
	 * entire window to start with.
	 */

	if(scr-&gt;paddr == paddr &amp;&amp; size &lt;= scr-&gt;apsize)
		return;

	if(scr-&gt;paddr){
		/*
		 * could call vunmap and vmap,
		 * but worried about dangling pointers in devdraw
		 */
		error("cannot grow vga frame buffer");
	}
	
	/* round to page boundary, just in case */
	x = paddr&amp;(BY2PG-1);
	npaddr = paddr-x;
	nsize = PGROUND(size+x);

	/*
	 * Don't bother trying to map more than 4000x4000x32 = 64MB.
	 * We only have a 256MB window.
	 */
	if(nsize &gt; 64*MB)
		nsize = 64*MB;
	scr-&gt;vaddr = vmap(npaddr, nsize);
	if(scr-&gt;vaddr == 0)
		error("cannot allocate vga frame buffer");
	scr-&gt;vaddr = (char*)scr-&gt;vaddr+x;
	scr-&gt;paddr = paddr;
	scr-&gt;apsize = nsize;
	/* let mtrr harmlessly fail on old CPUs, e.g., P54C */
	if(!waserror()){
		mtrr(npaddr, nsize, "wc");
		poperror();
	}
}


/*
 * Software cursor. 
 */
int	swvisible;	/* is the cursor visible? */
int	swenabled;	/* is the cursor supposed to be on the screen? */
Memimage*	swback;	/* screen under cursor */
Memimage*	swimg;	/* cursor image */
Memimage*	swmask;	/* cursor mask */
Memimage*	swimg1;
Memimage*	swmask1;

Point	swoffset;
Rectangle	swrect;	/* screen rectangle in swback */
Point	swpt;	/* desired cursor location */
Point	swvispt;	/* actual cursor location */
int	swvers;	/* incremented each time cursor image changes */
int	swvisvers;	/* the version on the screen */

/*
 * called with drawlock locked for us, most of the time.
 * kernel prints at inopportune times might mean we don't
 * hold the lock, but memimagedraw is now reentrant so
 * that should be okay: worst case we get cursor droppings.
 */
void
swcursorhide(void)
{
	if(swvisible == 0)
		return;
	if(swback == nil)
		return;
	swvisible = 0;
	memimagedraw(gscreen, swrect, swback, ZP, memopaque, ZP, S);
	flushmemscreen(swrect);
}

void
swcursoravoid(Rectangle r)
{
	if(swvisible &amp;&amp; rectXrect(r, swrect))
		swcursorhide();
}

void
swcursordraw(void)
{
	if(swvisible)
		return;
	if(swenabled == 0)
		return;
	if(swback == nil || swimg1 == nil || swmask1 == nil)
		return;
	assert(!canqlock(&amp;drawlock));
	swvispt = swpt;
	swvisvers = swvers;
	swrect = rectaddpt(Rect(0,0,16,16), swvispt);
	memimagedraw(swback, swback-&gt;r, gscreen, swpt, memopaque, ZP, S);
	memimagedraw(gscreen, swrect, swimg1, ZP, swmask1, ZP, SoverD);
	flushmemscreen(swrect);
	swvisible = 1;
}

/*
 * Need to lock drawlock for ourselves.
 */
void
swenable(VGAscr*)
{
	swenabled = 1;
	if(canqlock(&amp;drawlock)){
		swcursordraw();
		qunlock(&amp;drawlock);
	}
}

void
swdisable(VGAscr*)
{
	swenabled = 0;
	if(canqlock(&amp;drawlock)){
		swcursorhide();
		qunlock(&amp;drawlock);
	}
}

void
swload(VGAscr*, Cursor *curs)
{
	uchar *ip, *mp;
	int i, j, set, clr;

	if(!swimg || !swmask || !swimg1 || !swmask1)
		return;
	/*
	 * Build cursor image and mask.
	 * Image is just the usual cursor image
	 * but mask is a transparent alpha mask.
	 * 
	 * The 16x16x8 memimages do not have
	 * padding at the end of their scan lines.
	 */
	ip = byteaddr(swimg, ZP);
	mp = byteaddr(swmask, ZP);
	for(i=0; i&lt;32; i++){
		set = curs-&gt;set[i];
		clr = curs-&gt;clr[i];
		for(j=0x80; j; j&gt;&gt;=1){
			*ip++ = set&amp;j ? 0x00 : 0xFF;
			*mp++ = (clr|set)&amp;j ? 0xFF : 0x00;
		}
	}
	swoffset = curs-&gt;offset;
	swvers++;
	memimagedraw(swimg1, swimg1-&gt;r, swimg, ZP, memopaque, ZP, S);
	memimagedraw(swmask1, swmask1-&gt;r, swmask, ZP, memopaque, ZP, S);
}

int
swmove(VGAscr*, Point p)
{
	swpt = addpt(p, swoffset);
	return 0;
}

void
swcursorclock(void)
{
	int x;

	if(!swenabled)
		return;
	if(swvisible &amp;&amp; eqpt(swpt, swvispt) &amp;&amp; swvers==swvisvers)
		return;

	x = splhi();
	if(swenabled)
	if(!swvisible || !eqpt(swpt, swvispt) || swvers!=swvisvers)
	if(canqlock(&amp;drawlock)){
		swcursorhide();
		swcursordraw();
		qunlock(&amp;drawlock);
	}
	splx(x);
}

void
swcursorinit(void)
{
	static int init, warned;
	VGAscr *scr;

	didswcursorinit = 1;
	if(!init){
		init = 1;
		addclock0link(swcursorclock, 10);
	}
	scr = &amp;vgascreen[0];
	if(scr==nil || scr-&gt;gscreen==nil)
		return;

	if(scr-&gt;dev == nil || scr-&gt;dev-&gt;linear == nil){
		if(!warned){
			print("cannot use software cursor on non-linear vga screen\n");
			warned = 1;
		}
		return;
	}

	if(swback){
		freememimage(swback);
		freememimage(swmask);
		freememimage(swmask1);
		freememimage(swimg);
		freememimage(swimg1);
	}

	swback = allocmemimage(Rect(0,0,32,32), gscreen-&gt;chan);
	swmask = allocmemimage(Rect(0,0,16,16), GREY8);
	swmask1 = allocmemimage(Rect(0,0,16,16), GREY1);
	swimg = allocmemimage(Rect(0,0,16,16), GREY8);
	swimg1 = allocmemimage(Rect(0,0,16,16), GREY1);
	if(swback==nil || swmask==nil || swmask1==nil || swimg==nil || swimg1 == nil){
		print("software cursor: allocmemimage fails");
		return;
	}

	memfillcolor(swmask, DOpaque);
	memfillcolor(swmask1, DOpaque);
	memfillcolor(swimg, DBlack);
	memfillcolor(swimg1, DBlack);
}

VGAcur swcursor =
{
	"soft",
	swenable,
	swdisable,
	swload,
	swmove,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

