<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/sdiahci.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/sdiahci.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ahci serial ata driver
 * copyright © 2007-8 coraid, inc.
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/sd.h"
#include "ahci.h"

#define	dprint(...)	if(debug)	iprint(__VA_ARGS__); else USED(debug)
#define	idprint(...)	if(prid)	iprint(__VA_ARGS__);  else USED(prid)
#define	aprint(...)	if(datapi)	iprint(__VA_ARGS__);  else USED(datapi)

#define Tname(c)	tname[(c)-&gt;type]
#define Intel(x)	((x)-&gt;pci-&gt;vid == Vintel)

enum {
	NCtlr	= 16,
	NCtlrdrv= 32,
	NDrive	= NCtlr*NCtlrdrv,

	Read	= 0,
	Write,

	Nms	= 256,			/* ms. between drive checks */
	Mphywait=  2*1024/Nms - 1,
	Midwait	= 16*1024/Nms - 1,
	Mcomrwait= 64*1024/Nms - 1,

	Obs	= 0xa0,			/* obsolete device bits */

	/*
	 * if we get more than this many interrupts per tick for a drive,
	 * either the hardware is broken or we've got a bug in this driver.
	 */
	Maxintrspertick = 2000,		/* was 1000 */
};

/* pci space configuration */
enum {
	Pmap	= 0x90,
	Ppcs	= 0x91,
	Prev	= 0xa8,
};

enum {
	Tesb,
	Tich,
	Tsb600,
	Tunk,
};

static char *tname[] = {
	"63xxesb",
	"ich",
	"sb600",
	"unknown",
};

enum {
	Dnull,
	Dmissing,
	Dnew,
	Dready,
	Derror,
	Dreset,
	Doffline,
	Dportreset,
	Dlast,
};

static char *diskstates[Dlast] = {
	"null",
	"missing",
	"new",
	"ready",
	"error",
	"reset",
	"offline",
	"portreset",
};

enum {
	DMautoneg,
	DMsatai,
	DMsataii,
	DMsata3,
};

static char *modename[] = {		/* used in control messages */
	"auto",
	"satai",
	"sataii",
	"sata3",
};
static char *descmode[] = {		/*  only printed */
	"auto",
	"sata 1",
	"sata 2",
	"sata 3",
};

static char *flagname[] = {
	"llba",
	"smart",
	"power",
	"nop",
	"atapi",
	"atapi16",
};

typedef struct Asleep Asleep;
typedef struct Ctlr Ctlr;
typedef struct Drive Drive;

struct Drive {
	Lock;

	Ctlr	*ctlr;
	SDunit	*unit;
	char	name[10];
	Aport	*port;
	Aportm	portm;
	Aportc	portc;		/* redundant ptr to port and portm */

	uchar	mediachange;
	uchar	state;
	uchar	smartrs;

	uvlong	sectors;
	ulong	secsize;
	ulong	intick;		/* start tick of current transfer */
	ulong	lastseen;
	int	wait;
	uchar	mode;		/* DMautoneg, satai or sataii */
	uchar	active;

	char	serial[20+1];
	char	firmware[8+1];
	char	model[40+1];

	int	infosz;
	ushort	*info;
	ushort	tinyinfo[2];	/* used iff malloc fails */

	int	driveno;	/* ctlr*NCtlrdrv + unit */
	/* controller port # != driveno when not all ports are enabled */
	int	portno;

	ulong	lastintr0;
	ulong	intrs;
};

struct Ctlr {
	Lock;

	int	type;
	int	enabled;
	SDev	*sdev;
	Pcidev	*pci;

	/* virtual register addresses */
	uchar	*mmio;
	ulong	*lmmio;
	Ahba	*hba;

	/* phyical register address */
	uchar	*physio;

	Drive	*rawdrive;
	Drive	*drive[NCtlrdrv];
	int	ndrive;
	int	mport;		/* highest drive # (0-origin) on ich9 at least */

	ulong	lastintr0;
	ulong	intrs;		/* not attributable to any drive */
};

struct Asleep {
	Aport	*p;
	int	i;
};

extern SDifc sdiahciifc;

static	Ctlr	iactlr[NCtlr];
static	SDev	sdevs[NCtlr];
static	int	niactlr;

static	Drive	*iadrive[NDrive];
static	int	niadrive;

/* these are fiddled in iawtopctl() */
static	int	debug;
static	int	prid = 1;
static	int	datapi;

static char stab[] = {
[0]	'i', 'm',
[8]	't', 'c', 'p', 'e',
[16]	'N', 'I', 'W', 'B', 'D', 'C', 'H', 'S', 'T', 'F', 'X'
};

static void
serrstr(ulong r, char *s, char *e)
{
	int i;

	e -= 3;
	for(i = 0; i &lt; nelem(stab) &amp;&amp; s &lt; e; i++)
		if(r &amp; (1&lt;&lt;i) &amp;&amp; stab[i]){
			*s++ = stab[i];
			if(SerrBad &amp; (1&lt;&lt;i))
				*s++ = '*';
		}
	*s = 0;
}

static char ntab[] = "0123456789abcdef";

static void
preg(uchar *reg, int n)
{
	int i;
	char buf[25*3+1], *e;

	e = buf;
	for(i = 0; i &lt; n; i++){
		*e++ = ntab[reg[i]&gt;&gt;4];
		*e++ = ntab[reg[i]&amp;0xf];
		*e++ = ' ';
	}
	*e++ = '\n';
	*e = 0;
	dprint(buf);
}

static void
dreg(char *s, Aport *p)
{
	dprint("ahci: %stask=%#lux; cmd=%#lux; ci=%#lux; is=%#lux\n",
		s, p-&gt;task, p-&gt;cmd, p-&gt;ci, p-&gt;isr);
}

static void
esleep(int ms)
{
	if(waserror())
		return;
	tsleep(&amp;up-&gt;sleep, return0, 0, ms);
	poperror();
}

static int
ahciclear(void *v)
{
	Asleep *s;

	s = v;
	return (s-&gt;p-&gt;ci &amp; s-&gt;i) == 0;
}

static void
aesleep(Aportm *pm, Asleep *a, int ms)
{
	if(waserror())
		return;
	tsleep(pm, ahciclear, a, ms);
	poperror();
}

static int
ahciwait(Aportc *c, int ms)
{
	Asleep as;
	Aport *p;

	p = c-&gt;p;
	p-&gt;ci = 1;
	as.p = p;
	as.i = 1;
	aesleep(c-&gt;pm, &amp;as, ms);
	if((p-&gt;task&amp;1) == 0 &amp;&amp; p-&gt;ci == 0)
		return 0;
	dreg("ahciwait timeout ", c-&gt;p);
	return -1;
}

/* fill in cfis boilerplate */
static uchar *
cfissetup(Aportc *pc)
{
	uchar *cfis;

	cfis = pc-&gt;pm-&gt;ctab-&gt;cfis;
	memset(cfis, 0, 0x20);
	cfis[0] = 0x27;
	cfis[1] = 0x80;
	cfis[7] = Obs;
	return cfis;
}

/* initialise pc's list */
static void
listsetup(Aportc *pc, int flags)
{
	Alist *list;

	list = pc-&gt;pm-&gt;list;
	list-&gt;flags = flags | 5;
	list-&gt;len = 0;
	list-&gt;ctab = PCIWADDR(pc-&gt;pm-&gt;ctab);
	list-&gt;ctabhi = 0;
}

static int
nop(Aportc *pc)
{
	uchar *c;

	if((pc-&gt;pm-&gt;feat &amp; Dnop) == 0)
		return -1;
	c = cfissetup(pc);
	c[2] = 0;
	listsetup(pc, Lwrite);
	return ahciwait(pc, 3*1000);
}

static int
setfeatures(Aportc *pc, uchar f)
{
	uchar *c;

	c = cfissetup(pc);
	c[2] = 0xef;
	c[3] = f;
	listsetup(pc, Lwrite);
	return ahciwait(pc, 3*1000);
}

static int
setudmamode(Aportc *pc, uchar f)
{
	uchar *c;

	/* hack */
	if((pc-&gt;p-&gt;sig &gt;&gt; 16) == 0xeb14)
		return 0;
	c = cfissetup(pc);
	c[2] = 0xef;
	c[3] = 3;		/* set transfer mode */
	c[12] = 0x40 | f;	/* sector count */
	listsetup(pc, Lwrite);
	return ahciwait(pc, 3*1000);
}

static void
asleep(int ms)
{
	if(up == nil)
		delay(ms);
	else
		esleep(ms);
}

static int
ahciportreset(Aportc *c)
{
	ulong *cmd, i;
	Aport *p;

	p = c-&gt;p;
	cmd = &amp;p-&gt;cmd;
	*cmd &amp;= ~(Afre|Ast);
	for(i = 0; i &lt; 500; i += 25){
		if((*cmd&amp;Acr) == 0)
			break;
		asleep(25);
	}
	p-&gt;sctl = 1|(p-&gt;sctl&amp;~7);
	delay(1);
	p-&gt;sctl &amp;= ~7;
	return 0;
}

static int
smart(Aportc *pc, int n)
{
	uchar *c;

	if((pc-&gt;pm-&gt;feat&amp;Dsmart) == 0)
		return -1;
	c = cfissetup(pc);
	c[2] = 0xb0;
	c[3] = 0xd8 + n;	/* able smart */
	c[5] = 0x4f;
	c[6] = 0xc2;
	listsetup(pc, Lwrite);
	if(ahciwait(pc, 1000) == -1 || pc-&gt;p-&gt;task &amp; (1|32)){
		dprint("ahci: smart fail %#lux\n", pc-&gt;p-&gt;task);
//		preg(pc-&gt;m-&gt;fis.r, 20);
		return -1;
	}
	if(n)
		return 0;
	return 1;
}

static int
smartrs(Aportc *pc)
{
	uchar *c;

	c = cfissetup(pc);
	c[2] = 0xb0;
	c[3] = 0xda;		/* return smart status */
	c[5] = 0x4f;
	c[6] = 0xc2;
	listsetup(pc, Lwrite);

	c = pc-&gt;pm-&gt;fis.r;
	if(ahciwait(pc, 1000) == -1 || pc-&gt;p-&gt;task &amp; (1|32)){
		dprint("ahci: smart fail %#lux\n", pc-&gt;p-&gt;task);
		preg(c, 20);
		return -1;
	}
	if(c[5] == 0x4f &amp;&amp; c[6] == 0xc2)
		return 1;
	return 0;
}

static int
ahciflushcache(Aportc *pc)
{
	uchar *c;

	c = cfissetup(pc);
	c[2] = pc-&gt;pm-&gt;feat &amp; Dllba? 0xea: 0xe7;
	listsetup(pc, Lwrite);
	if(ahciwait(pc, 60000) == -1 || pc-&gt;p-&gt;task &amp; (1|32)){
		dprint("ahciflushcache: fail %#lux\n", pc-&gt;p-&gt;task);
//		preg(pc-&gt;m-&gt;fis.r, 20);
		return -1;
	}
	return 0;
}

static ushort
gbit16(void *a)
{
	uchar *i;

	i = a;
	return i[1]&lt;&lt;8 | i[0];
}

static ulong
gbit32(void *a)
{
	ulong j;
	uchar *i;

	i = a;
	j  = i[3] &lt;&lt; 24;
	j |= i[2] &lt;&lt; 16;
	j |= i[1] &lt;&lt; 8;
	j |= i[0];
	return j;
}

static uvlong
gbit64(void *a)
{
	uchar *i;

	i = a;
	return (uvlong)gbit32(i+4) &lt;&lt; 32 | gbit32(a);
}

static int
ahciidentify0(Aportc *pc, void *id, int atapi)
{
	uchar *c;
	Aprdt *p;
	static uchar tab[] = { 0xec, 0xa1, };

	c = cfissetup(pc);
	c[2] = tab[atapi];
	listsetup(pc, 1&lt;&lt;16);

	memset(id, 0, 0x100);			/* magic */
	p = &amp;pc-&gt;pm-&gt;ctab-&gt;prdt;
	p-&gt;dba = PCIWADDR(id);
	p-&gt;dbahi = 0;
	p-&gt;count = 1&lt;&lt;31 | (0x200-2) | 1;
	return ahciwait(pc, 3*1000);
}

static vlong
ahciidentify(Aportc *pc, ushort *id)
{
	int i, sig;
	vlong s;
	Aportm *pm;

	pm = pc-&gt;pm;
	pm-&gt;feat = 0;
	pm-&gt;smart = 0;
	i = 0;
	sig = pc-&gt;p-&gt;sig &gt;&gt; 16;
	if(sig == 0xeb14){
		pm-&gt;feat |= Datapi;
		i = 1;
	}
	if(ahciidentify0(pc, id, i) == -1)
		return -1;

	i = gbit16(id+83) | gbit16(id+86);
	if(i &amp; (1&lt;&lt;10)){
		pm-&gt;feat |= Dllba;
		s = gbit64(id+100);
	}else
		s = gbit32(id+60);

	if(pm-&gt;feat&amp;Datapi){
		i = gbit16(id+0);
		if(i&amp;1)
			pm-&gt;feat |= Datapi16;
	}

	i = gbit16(id+83);
	if((i&gt;&gt;14) == 1) {
		if(i &amp; (1&lt;&lt;3))
			pm-&gt;feat |= Dpower;
		i = gbit16(id+82);
		if(i &amp; 1)
			pm-&gt;feat |= Dsmart;
		if(i &amp; (1&lt;&lt;14))
			pm-&gt;feat |= Dnop;
	}
	return s;
}

static int
ahciquiet(Aport *a)
{
	ulong *p, i;

	p = &amp;a-&gt;cmd;
	*p &amp;= ~Ast;
	for(i = 0; i &lt; 500; i += 50){
		if((*p &amp; Acr) == 0)
			goto stop;
		asleep(50);
	}
	return -1;
stop:
	if((a-&gt;task &amp; (ASdrq|ASbsy)) == 0){
		*p |= Ast;
		return 0;
	}

	*p |= Aclo;
	for(i = 0; i &lt; 500; i += 50){
		if((*p &amp; Aclo) == 0)
			goto stop1;
		asleep(50);
	}
	return -1;
stop1:
	/* extra check */
	dprint("ahci: clo clear %#lx\n", a-&gt;task);
	if(a-&gt;task &amp; ASbsy)
		return -1;
	*p |= Ast;
	return 0;
}

static int
ahcicomreset(Aportc *pc)
{
	uchar *c;

	dprint("ahcicomreset\n");
	dreg("ahci: comreset ", pc-&gt;p);
	if(ahciquiet(pc-&gt;p) == -1){
		dprint("ahciquiet failed\n");
		return -1;
	}
	dreg("comreset ", pc-&gt;p);

	c = cfissetup(pc);
	c[1] = 0;
	c[15] = 1&lt;&lt;2;		/* srst */
	listsetup(pc, Lclear | Lreset);
	if(ahciwait(pc, 500) == -1){
		dprint("ahcicomreset: first command failed\n");
		return -1;
	}
	microdelay(250);
	dreg("comreset ", pc-&gt;p);

	c = cfissetup(pc);
	c[1] = 0;
	listsetup(pc, Lwrite);
	if(ahciwait(pc, 150) == -1){
		dprint("ahcicomreset: second command failed\n");
		return -1;
	}
	dreg("comreset ", pc-&gt;p);
	return 0;
}

static int
ahciidle(Aport *port)
{
	ulong *p, i, r;

	p = &amp;port-&gt;cmd;
	if((*p &amp; Arun) == 0)
		return 0;
	*p &amp;= ~Ast;
	r = 0;
	for(i = 0; i &lt; 500; i += 25){
		if((*p &amp; Acr) == 0)
			goto stop;
		asleep(25);
	}
	r = -1;
stop:
	if((*p &amp; Afre) == 0)
		return r;
	*p &amp;= ~Afre;
	for(i = 0; i &lt; 500; i += 25){
		if((*p &amp; Afre) == 0)
			return 0;
		asleep(25);
	}
	return -1;
}

/*
 * § 6.2.2.1  first part; comreset handled by reset disk.
 *	- remainder is handled by configdisk.
 *	- ahcirecover is a quick recovery from a failed command.
 */
static int
ahciswreset(Aportc *pc)
{
	int i;

	i = ahciidle(pc-&gt;p);
	pc-&gt;p-&gt;cmd |= Afre;
	if(i == -1)
		return -1;
	if(pc-&gt;p-&gt;task &amp; (ASdrq|ASbsy))
		return -1;
	return 0;
}

static int
ahcirecover(Aportc *pc)
{
	ahciswreset(pc);
	pc-&gt;p-&gt;cmd |= Ast;
	if(setudmamode(pc, 5) == -1)
		return -1;
	return 0;
}

static void*
malign(int size, int align)
{
	void *v;

	v = xspanalloc(size, align, 0);
	memset(v, 0, size);
	return v;
}

static void
setupfis(Afis *f)
{
	f-&gt;base = malign(0x100, 0x100);		/* magic */
	f-&gt;d = f-&gt;base + 0;
	f-&gt;p = f-&gt;base + 0x20;
	f-&gt;r = f-&gt;base + 0x40;
	f-&gt;u = f-&gt;base + 0x60;
	f-&gt;devicebits = (ulong*)(f-&gt;base + 0x58);
}

static void
ahciwakeup(Aport *p)
{
	ushort s;

	s = p-&gt;sstatus;
	if((s &amp; Intpm) != Intslumber &amp;&amp; (s &amp; Intpm) != Intpartpwr)
		return;
	if((s &amp; Devdet) != Devpresent){	/* not (device, no phy) */
		iprint("ahci: slumbering drive unwakable %#ux\n", s);
		return;
	}
	p-&gt;sctl = 3*Aipm | 0*Aspd | Adet;
	delay(1);
	p-&gt;sctl &amp;= ~7;
//	iprint("ahci: wake %#ux -&gt; %#ux\n", s, p-&gt;sstatus);
}

static int
ahciconfigdrive(Drive *d)
{
	char *name;
	Ahba *h;
	Aport *p;
	Aportm *pm;

	h = d-&gt;ctlr-&gt;hba;
	p = d-&gt;portc.p;
	pm = d-&gt;portc.pm;
	if(pm-&gt;list == 0){
		setupfis(&amp;pm-&gt;fis);
		pm-&gt;list = malign(sizeof *pm-&gt;list, 1024);
		pm-&gt;ctab = malign(sizeof *pm-&gt;ctab, 128);
	}

	if (d-&gt;unit)
		name = d-&gt;unit-&gt;name;
	else
		name = nil;
	if(p-&gt;sstatus &amp; (Devphycomm|Devpresent) &amp;&amp; h-&gt;cap &amp; Hsss){
		/* device connected &amp; staggered spin-up */
		dprint("ahci: configdrive: %s: spinning up ... [%#lux]\n",
			name, p-&gt;sstatus);
		p-&gt;cmd |= Apod|Asud;
		asleep(1400);
	}

	p-&gt;serror = SerrAll;

	p-&gt;list = PCIWADDR(pm-&gt;list);
	p-&gt;listhi = 0;
	p-&gt;fis = PCIWADDR(pm-&gt;fis.base);
	p-&gt;fishi = 0;
	p-&gt;cmd |= Afre|Ast;

	/* drive coming up in slumbering? */
	if((p-&gt;sstatus &amp; Devdet) == Devpresent &amp;&amp;
	   ((p-&gt;sstatus &amp; Intpm) == Intslumber ||
	    (p-&gt;sstatus &amp; Intpm) == Intpartpwr))
		ahciwakeup(p);

	/* "disable power managment" sequence from book. */
	p-&gt;sctl = (3*Aipm) | (d-&gt;mode*Aspd) | (0*Adet);
	p-&gt;cmd &amp;= ~Aalpe;

	p-&gt;ie = IEM;

	return 0;
}

static void
ahcienable(Ahba *h)
{
	h-&gt;ghc |= Hie;
}

static void
ahcidisable(Ahba *h)
{
	h-&gt;ghc &amp;= ~Hie;
}

static int
countbits(ulong u)
{
	int n;

	n = 0;
	for (; u != 0; u &gt;&gt;= 1)
		if(u &amp; 1)
			n++;
	return n;
}

static int
ahciconf(Ctlr *ctlr)
{
	Ahba *h;
	ulong u;

	h = ctlr-&gt;hba = (Ahba*)ctlr-&gt;mmio;
	u = h-&gt;cap;

	if((u&amp;Hsam) == 0)
		h-&gt;ghc |= Hae;

	dprint("#S/sd%c: type %s port %#p: sss %ld ncs %ld coal %ld "
		"%ld ports, led %ld clo %ld ems %ld\n",
		ctlr-&gt;sdev-&gt;idno, tname[ctlr-&gt;type], h,
		(u&gt;&gt;27) &amp; 1, (u&gt;&gt;8) &amp; 0x1f, (u&gt;&gt;7) &amp; 1,
		(u &amp; 0x1f) + 1, (u&gt;&gt;25) &amp; 1, (u&gt;&gt;24) &amp; 1, (u&gt;&gt;6) &amp; 1);
	return countbits(h-&gt;pi);
}

static int
ahcihbareset(Ahba *h)
{
	int wait;

	h-&gt;ghc |= 1;
	for(wait = 0; wait &lt; 1000; wait += 100){
		if(h-&gt;ghc == 0)
			return 0;
		delay(100);
	}
	return -1;
}

static void
idmove(char *p, ushort *a, int n)
{
	int i;
	char *op, *e;

	op = p;
	for(i = 0; i &lt; n/2; i++){
		*p++ = a[i] &gt;&gt; 8;
		*p++ = a[i];
	}
	*p = 0;
	while(p &gt; op &amp;&amp; *--p == ' ')
		*p = 0;
	e = p;
	for (p = op; *p == ' '; p++)
		;
	memmove(op, p, n - (e - p));
}

static int
identify(Drive *d)
{
	ushort *id;
	vlong osectors, s;
	uchar oserial[21];
	SDunit *u;

	if(d-&gt;info == nil) {
		d-&gt;infosz = 512 * sizeof(ushort);
		d-&gt;info = malloc(d-&gt;infosz);
	}
	if(d-&gt;info == nil) {
		d-&gt;info = d-&gt;tinyinfo;
		d-&gt;infosz = sizeof d-&gt;tinyinfo;
	}
	id = d-&gt;info;
	s = ahciidentify(&amp;d-&gt;portc, id);
	if(s == -1){
		d-&gt;state = Derror;
		return -1;
	}
	osectors = d-&gt;sectors;
	memmove(oserial, d-&gt;serial, sizeof d-&gt;serial);

	u = d-&gt;unit;
	d-&gt;sectors = s;
	d-&gt;secsize = u-&gt;secsize;
	if(d-&gt;secsize == 0)
		d-&gt;secsize = 512;		/* default */
	d-&gt;smartrs = 0;

	idmove(d-&gt;serial, id+10, 20);
	idmove(d-&gt;firmware, id+23, 8);
	idmove(d-&gt;model, id+27, 40);

	memset(u-&gt;inquiry, 0, sizeof u-&gt;inquiry);
	u-&gt;inquiry[2] = 2;
	u-&gt;inquiry[3] = 2;
	u-&gt;inquiry[4] = sizeof u-&gt;inquiry - 4;
	memmove(u-&gt;inquiry+8, d-&gt;model, 40);

	if(osectors != s || memcmp(oserial, d-&gt;serial, sizeof oserial) != 0){
		d-&gt;mediachange = 1;
		u-&gt;sectors = 0;
	}
	return 0;
}

static void
clearci(Aport *p)
{
	if(p-&gt;cmd &amp; Ast) {
		p-&gt;cmd &amp;= ~Ast;
		p-&gt;cmd |=  Ast;
	}
}

static void
updatedrive(Drive *d)
{
	ulong cause, serr, s0, pr, ewake;
	char *name;
	Aport *p;
	static ulong last;

	pr = 1;
	ewake = 0;
	p = d-&gt;port;
	cause = p-&gt;isr;
	serr = p-&gt;serror;
	p-&gt;isr = cause;
	name = "??";
	if(d-&gt;unit &amp;&amp; d-&gt;unit-&gt;name)
		name = d-&gt;unit-&gt;name;

	if(p-&gt;ci == 0){
		d-&gt;portm.flag |= Fdone;
		wakeup(&amp;d-&gt;portm);
		pr = 0;
	}else if(cause &amp; Adps)
		pr = 0;
	if(cause &amp; Ifatal){
		ewake = 1;
		dprint("ahci: updatedrive: %s: fatal\n", name);
	}
	if(cause &amp; Adhrs){
		if(p-&gt;task &amp; (1&lt;&lt;5|1)){
			dprint("ahci: %s: Adhrs cause %#lux serr %#lux task %#lux\n",
				name, cause, serr, p-&gt;task);
			d-&gt;portm.flag |= Ferror;
			ewake = 1;
		}
		pr = 0;
	}
	if(p-&gt;task &amp; 1 &amp;&amp; last != cause)
		dprint("%s: err ca %#lux serr %#lux task %#lux sstat %#lux\n",
			name, cause, serr, p-&gt;task, p-&gt;sstatus);
	if(pr)
		dprint("%s: upd %#lux ta %#lux\n", name, cause, p-&gt;task);

	if(cause &amp; (Aprcs|Aifs)){
		s0 = d-&gt;state;
		switch(p-&gt;sstatus &amp; Devdet){
		case 0:				/* no device */
			d-&gt;state = Dmissing;
			break;
		case Devpresent:		/* device but no phy comm. */
			if((p-&gt;sstatus &amp; Intpm) == Intslumber ||
			   (p-&gt;sstatus &amp; Intpm) == Intpartpwr)
				d-&gt;state = Dnew;	/* slumbering */
			else
				d-&gt;state = Derror;
			break;
		case Devpresent|Devphycomm:
			/* power mgnt crap for surprise removal */
			p-&gt;ie |= Aprcs|Apcs;	/* is this required? */
			d-&gt;state = Dreset;
			break;
		case Devphyoffline:
			d-&gt;state = Doffline;
			break;
		}
		dprint("%s: %s → %s [Apcrs] %#lux\n", name,
			diskstates[s0], diskstates[d-&gt;state], p-&gt;sstatus);
		/* print pulled message here. */
		if(s0 == Dready &amp;&amp; d-&gt;state != Dready)
			idprint("%s: pulled\n", name);		/* wtf? */
		if(d-&gt;state != Dready)
			d-&gt;portm.flag |= Ferror;
		ewake = 1;
	}
	p-&gt;serror = serr;
	if(ewake){
		clearci(p);
		wakeup(&amp;d-&gt;portm);
	}
	last = cause;
}

static void
pstatus(Drive *d, ulong s)
{
	/*
	 * s is masked with Devdet.
	 *
	 * bogus code because the first interrupt is currently dropped.
	 * likely my fault.  serror may be cleared at the wrong time.
	 */
	switch(s){
	case 0:			/* no device */
		d-&gt;state = Dmissing;
		break;
	case Devpresent:	/* device but no phy. comm. */
		break;
	case Devphycomm:	/* should this be missing?  need testcase. */
		dprint("ahci: pstatus 2\n");
		/* fallthrough */
	case Devpresent|Devphycomm:
		d-&gt;wait = 0;
		d-&gt;state = Dnew;
		break;
	case Devphyoffline:
		d-&gt;state = Doffline;
		break;
	case Devphyoffline|Devphycomm:	/* does this make sense? */
		d-&gt;state = Dnew;
		break;
	}
}

static int
configdrive(Drive *d)
{
	if(ahciconfigdrive(d) == -1)
		return -1;
	ilock(d);
	pstatus(d, d-&gt;port-&gt;sstatus &amp; Devdet);
	iunlock(d);
	return 0;
}

static void
setstate(Drive *d, int state)
{
	ilock(d);
	d-&gt;state = state;
	iunlock(d);
}

static void
resetdisk(Drive *d)
{
	uint state, det, stat;
	Aport *p;

	p = d-&gt;port;
	det = p-&gt;sctl &amp; 7;
	stat = p-&gt;sstatus &amp; Devdet;
	state = (p-&gt;cmd&gt;&gt;28) &amp; 0xf;
	dprint("ahci: resetdisk: icc %#ux  det %d sdet %d\n", state, det, stat);

	ilock(d);
	state = d-&gt;state;
	if(d-&gt;state != Dready || d-&gt;state != Dnew)
		d-&gt;portm.flag |= Ferror;
	clearci(p);			/* satisfy sleep condition. */
	wakeup(&amp;d-&gt;portm);
	if(stat != (Devpresent|Devphycomm)){
		/* device absent or phy not communicating */
		d-&gt;state = Dportreset;
		iunlock(d);
		return;
	}
	d-&gt;state = Derror;
	iunlock(d);

	qlock(&amp;d-&gt;portm);
	if(p-&gt;cmd&amp;Ast &amp;&amp; ahciswreset(&amp;d-&gt;portc) == -1)
		setstate(d, Dportreset);	/* get a bigger stick. */
	else {
		setstate(d, Dmissing);
		configdrive(d);
	}
	dprint("ahci: %s: resetdisk: %s → %s\n", (d-&gt;unit? d-&gt;unit-&gt;name: nil),
		diskstates[state], diskstates[d-&gt;state]);
	qunlock(&amp;d-&gt;portm);
}

static int
newdrive(Drive *d)
{
	char *name;
	Aportc *c;
	Aportm *pm;

	c = &amp;d-&gt;portc;
	pm = &amp;d-&gt;portm;

	name = d-&gt;unit-&gt;name;
	if(name == 0)
		name = "??";

	if(d-&gt;port-&gt;task == 0x80)
		return -1;
	qlock(c-&gt;pm);
	if(setudmamode(c, 5) == -1){
		dprint("%s: can't set udma mode\n", name);
		goto lose;
	}
	if(identify(d) == -1){
		dprint("%s: identify failure\n", name);
		goto lose;
	}
	if(pm-&gt;feat &amp; Dpower &amp;&amp; setfeatures(c, 0x85) == -1){
		pm-&gt;feat &amp;= ~Dpower;
		if(ahcirecover(c) == -1)
			goto lose;
	}
	setstate(d, Dready);
	qunlock(c-&gt;pm);

	idprint("%s: %sLBA %,llud sectors: %s %s %s %s\n", d-&gt;unit-&gt;name,
		(pm-&gt;feat &amp; Dllba? "L": ""), d-&gt;sectors, d-&gt;model, d-&gt;firmware,
		d-&gt;serial, d-&gt;mediachange? "[mediachange]": "");
	return 0;

lose:
	idprint("%s: can't be initialized\n", d-&gt;unit-&gt;name);
	setstate(d, Dnull);
	qunlock(c-&gt;pm);
	return -1;
}

static void
westerndigitalhung(Drive *d)
{
	if((d-&gt;portm.feat&amp;Datapi) == 0 &amp;&amp; d-&gt;active &amp;&amp;
	    TK2MS(MACHP(0)-&gt;ticks - d-&gt;intick) &gt; 5000){
		dprint("%s: drive hung; resetting [%#lux] ci %#lx\n",
			d-&gt;unit-&gt;name, d-&gt;port-&gt;task, d-&gt;port-&gt;ci);
		d-&gt;state = Dreset;
	}
}

static ushort olds[NCtlr*NCtlrdrv];

static int
doportreset(Drive *d)
{
	int i;

	i = -1;
	qlock(&amp;d-&gt;portm);
	if(ahciportreset(&amp;d-&gt;portc) == -1)
		dprint("ahci: doportreset: fails\n");
	else
		i = 0;
	qunlock(&amp;d-&gt;portm);
	dprint("ahci: doportreset: portreset → %s  [task %#lux]\n",
		diskstates[d-&gt;state], d-&gt;port-&gt;task);
	return i;
}

/* drive must be locked */
static void
statechange(Drive *d)
{
	switch(d-&gt;state){
	case Dnull:
	case Doffline:
		if(d-&gt;unit-&gt;sectors != 0){
			d-&gt;sectors = 0;
			d-&gt;mediachange = 1;
		}
		/* fallthrough */
	case Dready:
		d-&gt;wait = 0;
		break;
	}
}

static void
checkdrive(Drive *d, int i)
{
	ushort s;
	char *name;

	if(d == nil) {
		print("checkdrive: nil d\n");
		return;
	}
	ilock(d);
	if(d-&gt;unit == nil || d-&gt;port == nil) {
		if(0)
			print("checkdrive: nil d-&gt;%s\n",
				d-&gt;unit == nil? "unit": "port");
		iunlock(d);
		return;
	}
	name = d-&gt;unit-&gt;name;
	s = d-&gt;port-&gt;sstatus;
	if(s)
		d-&gt;lastseen = MACHP(0)-&gt;ticks;
	if(s != olds[i]){
		dprint("%s: status: %06#ux -&gt; %06#ux: %s\n",
			name, olds[i], s, diskstates[d-&gt;state]);
		olds[i] = s;
		d-&gt;wait = 0;
	}
	westerndigitalhung(d);

	switch(d-&gt;state){
	case Dnull:
	case Dready:
		break;
	case Dmissing:
	case Dnew:
		switch(s &amp; (Intactive | Devdet)){
		case Devpresent:  /* no device (pm), device but no phy. comm. */
			ahciwakeup(d-&gt;port);
			/* fall through */
		case 0:			/* no device */
			break;
		default:
			dprint("%s: unknown status %06#ux\n", name, s);
			/* fall through */
		case Intactive:		/* active, no device */
			if(++d-&gt;wait&amp;Mphywait)
				break;
reset:
			if(++d-&gt;mode &gt; DMsataii)
				d-&gt;mode = 0;
			if(d-&gt;mode == DMsatai){	/* we tried everything */
				d-&gt;state = Dportreset;
				goto portreset;
			}
			dprint("%s: reset; new mode %s\n", name,
				modename[d-&gt;mode]);
			iunlock(d);
			resetdisk(d);
			ilock(d);
			break;
		case Intactive|Devphycomm|Devpresent:
			if((++d-&gt;wait&amp;Midwait) == 0){
				dprint("%s: slow reset %06#ux task=%#lux; %d\n",
					name, s, d-&gt;port-&gt;task, d-&gt;wait);
				goto reset;
			}
			s = (uchar)d-&gt;port-&gt;task;
			if(s == 0x7f || ((d-&gt;port-&gt;sig &gt;&gt; 16) != 0xeb14 &amp;&amp;
			    (s &amp; ~0x17) != (1&lt;&lt;6)))
				break;
			iunlock(d);
			newdrive(d);
			ilock(d);
			break;
		}
		break;
	case Doffline:
		if(d-&gt;wait++ &amp; Mcomrwait)
			break;
		/* fallthrough */
	case Derror:
	case Dreset:
		dprint("%s: reset [%s]: mode %d; status %06#ux\n",
			name, diskstates[d-&gt;state], d-&gt;mode, s);
		iunlock(d);
		resetdisk(d);
		ilock(d);
		break;
	case Dportreset:
portreset:
		if(d-&gt;wait++ &amp; 0xff &amp;&amp; (s &amp; Intactive) == 0)
			break;
		/* device is active */
		dprint("%s: portreset [%s]: mode %d; status %06#ux\n",
			name, diskstates[d-&gt;state], d-&gt;mode, s);
		d-&gt;portm.flag |= Ferror;
		clearci(d-&gt;port);
		wakeup(&amp;d-&gt;portm);
		if((s &amp; Devdet) == 0){	/* no device */
			d-&gt;state = Dmissing;
			break;
		}
		iunlock(d);
		doportreset(d);
		ilock(d);
		break;
	}
	statechange(d);
	iunlock(d);
}

static void
satakproc(void*)
{
	int i;

	for(;;){
		tsleep(&amp;up-&gt;sleep, return0, 0, Nms);
		for(i = 0; i &lt; niadrive; i++)
			if(iadrive[i] != nil)
				checkdrive(iadrive[i], i);
	}
}

static void
isctlrjabbering(Ctlr *c, ulong cause)
{
	ulong now;

	now = TK2MS(MACHP(0)-&gt;ticks);
	if (now &gt; c-&gt;lastintr0) {
		c-&gt;intrs = 0;
		c-&gt;lastintr0 = now;
	}
	if (++c-&gt;intrs &gt; Maxintrspertick) {
		iprint("sdiahci: %lud intrs per tick for no serviced "
			"drive; cause %#lux mport %d\n",
			c-&gt;intrs, cause, c-&gt;mport);
		c-&gt;intrs = 0;
	}
}

static void
isdrivejabbering(Drive *d)
{
	ulong now;

	now = TK2MS(MACHP(0)-&gt;ticks);
	if (now &gt; d-&gt;lastintr0) {
		d-&gt;intrs = 0;
		d-&gt;lastintr0 = now;
	}
	if (++d-&gt;intrs &gt; Maxintrspertick) {
		iprint("sdiahci: %lud interrupts per tick for %s\n",
			d-&gt;intrs, d-&gt;unit-&gt;name);
		d-&gt;intrs = 0;
	}
}

static void
iainterrupt(Ureg*, void *a)
{
	int i;
	ulong cause, mask;
	Ctlr *c;
	Drive *d;

	c = a;
	ilock(c);
	cause = c-&gt;hba-&gt;isr;
	if (cause == 0) {
		isctlrjabbering(c, cause);
		// iprint("sdiahci: interrupt for no drive\n");
		iunlock(c);
		return;
	}
	for(i = 0; cause &amp;&amp; i &lt;= c-&gt;mport; i++){
		mask = 1 &lt;&lt; i;
		if((cause &amp; mask) == 0)
			continue;
		d = c-&gt;rawdrive + i;
		ilock(d);
		isdrivejabbering(d);
		if(d-&gt;port-&gt;isr &amp;&amp; c-&gt;hba-&gt;pi &amp; mask)
			updatedrive(d);
		c-&gt;hba-&gt;isr = mask;
		iunlock(d);

		cause &amp;= ~mask;
	}
	if (cause) {
		isctlrjabbering(c, cause);
		iprint("sdiachi: intr cause unserviced: %#lux\n", cause);
	}
	iunlock(c);
}

/* checkdrive, called from satakproc, will prod the drive while we wait */
static void
awaitspinup(Drive *d)
{
	int ms;
	ushort s;
	char *name;

	ilock(d);
	if(d-&gt;unit == nil || d-&gt;port == nil) {
		panic("awaitspinup: nil d-&gt;unit or d-&gt;port");
		iunlock(d);
		return;
	}
	name = (d-&gt;unit? d-&gt;unit-&gt;name: nil);
	s = d-&gt;port-&gt;sstatus;
	if(!(s &amp; Devpresent)) {			/* never going to be ready */
		dprint("awaitspinup: %s absent, not waiting\n", name);
		iunlock(d);
		return;
	}

	for (ms = 20000; ms &gt; 0; ms -= 50)
		switch(d-&gt;state){
		case Dnull:
			/* absent; done */
			iunlock(d);
			dprint("awaitspinup: %s in null state\n", name);
			return;
		case Dready:
		case Dnew:
			if(d-&gt;sectors || d-&gt;mediachange) {
				/* ready to use; done */
				iunlock(d);
				dprint("awaitspinup: %s ready!\n", name);
				return;
			}
			/* fall through */
		default:
		case Dmissing:			/* normal waiting states */
		case Dreset:
		case Doffline:			/* transitional states */
		case Derror:
		case Dportreset:
			iunlock(d);
			asleep(50);
			ilock(d);
			break;
		}
	print("awaitspinup: %s didn't spin up after 20 seconds\n", name);
	iunlock(d);
}

static int
iaverify(SDunit *u)
{
	Ctlr *c;
	Drive *d;

	c = u-&gt;dev-&gt;ctlr;
	d = c-&gt;drive[u-&gt;subno];
	ilock(c);
	ilock(d);
	d-&gt;unit = u;
	iunlock(d);
	iunlock(c);
	checkdrive(d, d-&gt;driveno);		/* c-&gt;d0 + d-&gt;driveno */

	/*
	 * hang around until disks are spun up and thus available as
	 * nvram, dos file systems, etc.  you wouldn't expect it, but
	 * the intel 330 ssd takes a while to `spin up'.
	 */
	awaitspinup(d);
	return 1;
}

static int
iaenable(SDev *s)
{
	char name[32];
	Ctlr *c;
	static int once;

	c = s-&gt;ctlr;
	ilock(c);
	if(!c-&gt;enabled) {
		if(once == 0) {
			once = 1;
			kproc("ahci", satakproc, 0);
		}
		if(c-&gt;ndrive == 0)
			panic("iaenable: zero s-&gt;ctlr-&gt;ndrive");
		pcisetbme(c-&gt;pci);
		snprint(name, sizeof name, "%s (%s)", s-&gt;name, s-&gt;ifc-&gt;name);
		intrenable(c-&gt;pci-&gt;intl, iainterrupt, c, c-&gt;pci-&gt;tbdf, name);
		/* supposed to squelch leftover interrupts here. */
		ahcienable(c-&gt;hba);
		c-&gt;enabled = 1;
	}
	iunlock(c);
	return 1;
}

static int
iadisable(SDev *s)
{
	char name[32];
	Ctlr *c;

	c = s-&gt;ctlr;
	ilock(c);
	ahcidisable(c-&gt;hba);
	snprint(name, sizeof name, "%s (%s)", s-&gt;name, s-&gt;ifc-&gt;name);
	intrdisable(c-&gt;pci-&gt;intl, iainterrupt, c, c-&gt;pci-&gt;tbdf, name);
	c-&gt;enabled = 0;
	iunlock(c);
	return 1;
}

static int
iaonline(SDunit *unit)
{
	int r;
	Ctlr *c;
	Drive *d;

	c = unit-&gt;dev-&gt;ctlr;
	d = c-&gt;drive[unit-&gt;subno];
	r = 0;

	if(d-&gt;portm.feat &amp; Datapi &amp;&amp; d-&gt;mediachange){
		r = scsionline(unit);
		if(r &gt; 0)
			d-&gt;mediachange = 0;
		return r;
	}

	ilock(d);
	if(d-&gt;mediachange){
		r = 2;
		d-&gt;mediachange = 0;
		/* devsd resets this after online is called; why? */
		unit-&gt;sectors = d-&gt;sectors;
		unit-&gt;secsize = 512;		/* default size */
	} else if(d-&gt;state == Dready)
		r = 1;
	iunlock(d);
	return r;
}

/* returns locked list! */
static Alist*
ahcibuild(Drive *d, uchar *cmd, void *data, int n, vlong lba)
{
	uchar *c, acmd, dir, llba;
	Alist *l;
	Actab *t;
	Aportm *pm;
	Aprdt *p;
	static uchar tab[2][2] = { 0xc8, 0x25, 0xca, 0x35, };

	pm = &amp;d-&gt;portm;
	dir = *cmd != 0x28;
	llba = pm-&gt;feat&amp;Dllba? 1: 0;
	acmd = tab[dir][llba];
	qlock(pm);
	l = pm-&gt;list;
	t = pm-&gt;ctab;
	c = t-&gt;cfis;

	c[0] = 0x27;
	c[1] = 0x80;
	c[2] = acmd;
	c[3] = 0;

	c[4] = lba;		/* sector		lba low	7:0 */
	c[5] = lba &gt;&gt; 8;	/* cylinder low		lba mid	15:8 */
	c[6] = lba &gt;&gt; 16;	/* cylinder hi		lba hi	23:16 */
	c[7] = Obs | 0x40;	/* 0x40 == lba */
	if(llba == 0)
		c[7] |= (lba&gt;&gt;24) &amp; 7;

	c[8] = lba &gt;&gt; 24;	/* sector (exp)		lba 	31:24 */
	c[9] = lba &gt;&gt; 32;	/* cylinder low (exp)	lba	39:32 */
	c[10] = lba &gt;&gt; 48;	/* cylinder hi (exp)	lba	48:40 */
	c[11] = 0;		/* features (exp); */

	c[12] = n;		/* sector count */
	c[13] = n &gt;&gt; 8;		/* sector count (exp) */
	c[14] = 0;		/* r */
	c[15] = 0;		/* control */

	*(ulong*)(c + 16) = 0;

	l-&gt;flags = 1&lt;&lt;16 | Lpref | 0x5;	/* Lpref ?? */
	if(dir == Write)
		l-&gt;flags |= Lwrite;
	l-&gt;len = 0;
	l-&gt;ctab = PCIWADDR(t);
	l-&gt;ctabhi = 0;

	p = &amp;t-&gt;prdt;
	p-&gt;dba = PCIWADDR(data);
	p-&gt;dbahi = 0;
	if(d-&gt;unit == nil)
		panic("ahcibuild: nil d-&gt;unit");
	p-&gt;count = 1&lt;&lt;31 | (d-&gt;unit-&gt;secsize*n - 2) | 1;

	return l;
}

static Alist*
ahcibuildpkt(Aportm *pm, SDreq *r, void *data, int n)
{
	int fill, len;
	uchar *c;
	Alist *l;
	Actab *t;
	Aprdt *p;

	qlock(pm);
	l = pm-&gt;list;
	t = pm-&gt;ctab;
	c = t-&gt;cfis;

	fill = pm-&gt;feat&amp;Datapi16? 16: 12;
	if((len = r-&gt;clen) &gt; fill)
		len = fill;
	memmove(t-&gt;atapi, r-&gt;cmd, len);
	memset(t-&gt;atapi+len, 0, fill-len);

	c[0] = 0x27;
	c[1] = 0x80;
	c[2] = 0xa0;
	if(n != 0)
		c[3] = 1;	/* dma */
	else
		c[3] = 0;	/* features (exp); */

	c[4] = 0;		/* sector		lba low	7:0 */
	c[5] = n;		/* cylinder low		lba mid	15:8 */
	c[6] = n &gt;&gt; 8;		/* cylinder hi		lba hi	23:16 */
	c[7] = Obs;

	*(ulong*)(c + 8) = 0;
	*(ulong*)(c + 12) = 0;
	*(ulong*)(c + 16) = 0;

	l-&gt;flags = 1&lt;&lt;16 | Lpref | Latapi | 0x5;
	if(r-&gt;write != 0 &amp;&amp; data)
		l-&gt;flags |= Lwrite;
	l-&gt;len = 0;
	l-&gt;ctab = PCIWADDR(t);
	l-&gt;ctabhi = 0;

	if(data == 0)
		return l;

	p = &amp;t-&gt;prdt;
	p-&gt;dba = PCIWADDR(data);
	p-&gt;dbahi = 0;
	p-&gt;count = 1&lt;&lt;31 | (n - 2) | 1;

	return l;
}

static int
waitready(Drive *d)
{
	ulong s, i, δ;

	for(i = 0; i &lt; 15000; i += 250){
		if(d-&gt;state == Dreset || d-&gt;state == Dportreset ||
		    d-&gt;state == Dnew)
			return 1;
		δ = MACHP(0)-&gt;ticks - d-&gt;lastseen;
		if(d-&gt;state == Dnull || δ &gt; 10*1000)
			return -1;
		ilock(d);
		s = d-&gt;port-&gt;sstatus;
		iunlock(d);
		if((s &amp; Intpm) == 0 &amp;&amp; δ &gt; 1500)
			return -1;	/* no detect */
		if(d-&gt;state == Dready &amp;&amp;
		    (s &amp; Devdet) == (Devphycomm|Devpresent))
			return 0;	/* ready, present &amp; phy. comm. */
		esleep(250);
	}
	print("%s: not responding; offline\n", d-&gt;unit-&gt;name);
	setstate(d, Doffline);
	return -1;
}

static int
lockready(Drive *d)
{
	int i;

	qlock(&amp;d-&gt;portm);
	while ((i = waitready(d)) == 1) {	/* could wait forever? */
		qunlock(&amp;d-&gt;portm);
		esleep(1);
		qlock(&amp;d-&gt;portm);
	}
	return i;
}

static int
flushcache(Drive *d)
{
	int i;

	i = -1;
	if(lockready(d) == 0)
		i = ahciflushcache(&amp;d-&gt;portc);
	qunlock(&amp;d-&gt;portm);
	return i;
}

static int
iariopkt(SDreq *r, Drive *d)
{
	int n, count, try, max, flag, task, wormwrite;
	char *name;
	uchar *cmd, *data;
	Aport *p;
	Asleep as;

	cmd = r-&gt;cmd;
	name = d-&gt;unit-&gt;name;
	p = d-&gt;port;

	aprint("ahci: iariopkt: %04#ux %04#ux %c %d %p\n",
		cmd[0], cmd[2], "rw"[r-&gt;write], r-&gt;dlen, r-&gt;data);
	if(cmd[0] == 0x5a &amp;&amp; (cmd[2] &amp; 0x3f) == 0x3f)
		return sdmodesense(r, cmd, d-&gt;info, d-&gt;infosz);
	r-&gt;rlen = 0;
	count = r-&gt;dlen;
	max = 65536;

	try = 0;
retry:
	data = r-&gt;data;
	n = count;
	if(n &gt; max)
		n = max;
	ahcibuildpkt(&amp;d-&gt;portm, r, data, n);
	switch(waitready(d)){
	case -1:
		qunlock(&amp;d-&gt;portm);
		return SDeio;
	case 1:
		qunlock(&amp;d-&gt;portm);
		esleep(1);
		goto retry;
	}
	/* d-&gt;portm qlock held here */

	ilock(d);
	d-&gt;portm.flag = 0;
	iunlock(d);
	p-&gt;ci = 1;

	as.p = p;
	as.i = 1;
	d-&gt;intick = MACHP(0)-&gt;ticks;
	d-&gt;active++;

	while(waserror())
		;
	/* don't sleep here forever */
	tsleep(&amp;d-&gt;portm, ahciclear, &amp;as, 3*1000);
	poperror();
	if(!ahciclear(&amp;as)) {
		qunlock(&amp;d-&gt;portm);
		print("%s: ahciclear not true after 3 seconds\n", name);
		r-&gt;status = SDcheck;
		return SDcheck;
	}

	d-&gt;active--;
	ilock(d);
	flag = d-&gt;portm.flag;
	task = d-&gt;port-&gt;task;
	iunlock(d);

	if(task &amp; (Efatal&lt;&lt;8) || task &amp; (ASbsy|ASdrq) &amp;&amp; d-&gt;state == Dready){
		d-&gt;port-&gt;ci = 0;
		ahcirecover(&amp;d-&gt;portc);
		task = d-&gt;port-&gt;task;
		flag &amp;= ~Fdone;		/* either an error or do-over */
	}
	qunlock(&amp;d-&gt;portm);
	if(flag == 0){
		if(++try == 10){
			print("%s: bad disk\n", name);
			r-&gt;status = SDcheck;
			return SDcheck;
		}
		/*
		 * write retries cannot succeed on write-once media,
		 * so just accept any failure.
		 */
		wormwrite = 0;
		switch(d-&gt;unit-&gt;inquiry[0] &amp; SDinq0periphtype){
		case SDperworm:
		case SDpercd:
			switch(cmd[0]){
			case 0x0a:		/* write (6?) */
			case 0x2a:		/* write (10) */
			case 0x8a:		/* long write (16) */
			case 0x2e:		/* write and verify (10) */
				wormwrite = 1;
				break;
			}
			break;
		}
		if (!wormwrite) {
			print("%s: retry\n", name);
			goto retry;
		}
	}
	if(flag &amp; Ferror){
		if((task&amp;Eidnf) == 0)
			print("%s: i/o error task=%#ux\n", name, task);
		r-&gt;status = SDcheck;
		return SDcheck;
	}

	data += n;

	r-&gt;rlen = data - (uchar*)r-&gt;data;
	r-&gt;status = SDok;
	return SDok;
}

static int
iario(SDreq *r)
{
	int i, n, count, try, max, flag, task;
	vlong lba;
	char *name;
	uchar *cmd, *data;
	Aport *p;
	Asleep as;
	Ctlr *c;
	Drive *d;
	SDunit *unit;

	unit = r-&gt;unit;
	c = unit-&gt;dev-&gt;ctlr;
	d = c-&gt;drive[unit-&gt;subno];
	if(d-&gt;portm.feat &amp; Datapi)
		return iariopkt(r, d);
	cmd = r-&gt;cmd;
	name = d-&gt;unit-&gt;name;
	p = d-&gt;port;

	if(r-&gt;cmd[0] == 0x35 || r-&gt;cmd[0] == 0x91){
		if(flushcache(d) == 0)
			return sdsetsense(r, SDok, 0, 0, 0);
		return sdsetsense(r, SDcheck, 3, 0xc, 2);
	}

	if((i = sdfakescsi(r, d-&gt;info, d-&gt;infosz)) != SDnostatus){
		r-&gt;status = i;
		return i;
	}

	if(*cmd != 0x28 &amp;&amp; *cmd != 0x2a){
		print("%s: bad cmd %.2#ux\n", name, cmd[0]);
		r-&gt;status = SDcheck;
		return SDcheck;
	}

	lba   = cmd[2]&lt;&lt;24 | cmd[3]&lt;&lt;16 | cmd[4]&lt;&lt;8 | cmd[5];
	count = cmd[7]&lt;&lt;8 | cmd[8];
	if(r-&gt;data == nil)
		return SDok;
	if(r-&gt;dlen &lt; count * unit-&gt;secsize)
		count = r-&gt;dlen / unit-&gt;secsize;
	max = 128;

	try = 0;
retry:
	data = r-&gt;data;
	while(count &gt; 0){
		n = count;
		if(n &gt; max)
			n = max;
		ahcibuild(d, cmd, data, n, lba);
		switch(waitready(d)){
		case -1:
			qunlock(&amp;d-&gt;portm);
			return SDeio;
		case 1:
			qunlock(&amp;d-&gt;portm);
			esleep(1);
			goto retry;
		}
		/* d-&gt;portm qlock held here */
		ilock(d);
		d-&gt;portm.flag = 0;
		iunlock(d);
		p-&gt;ci = 1;

		as.p = p;
		as.i = 1;
		d-&gt;intick = MACHP(0)-&gt;ticks;
		d-&gt;active++;

		while(waserror())
			;
		/* don't sleep here forever */
		tsleep(&amp;d-&gt;portm, ahciclear, &amp;as, 3*1000);
		poperror();
		if(!ahciclear(&amp;as)) {
			qunlock(&amp;d-&gt;portm);
			print("%s: ahciclear not true after 3 seconds\n", name);
			r-&gt;status = SDcheck;
			return SDcheck;
		}

		d-&gt;active--;
		ilock(d);
		flag = d-&gt;portm.flag;
		task = d-&gt;port-&gt;task;
		iunlock(d);

		if(task &amp; (Efatal&lt;&lt;8) ||
		    task &amp; (ASbsy|ASdrq) &amp;&amp; d-&gt;state == Dready){
			d-&gt;port-&gt;ci = 0;
			ahcirecover(&amp;d-&gt;portc);
			task = d-&gt;port-&gt;task;
		}
		qunlock(&amp;d-&gt;portm);
		if(flag == 0){
			if(++try == 10){
				print("%s: bad disk\n", name);
				r-&gt;status = SDeio;
				return SDeio;
			}
			print("%s: retry blk %lld\n", name, lba);
			goto retry;
		}
		if(flag &amp; Ferror){
			print("%s: i/o error task=%#ux @%,lld\n",
				name, task, lba);
			r-&gt;status = SDeio;
			return SDeio;
		}

		count -= n;
		lba   += n;
		data += n * unit-&gt;secsize;
	}
	r-&gt;rlen = data - (uchar*)r-&gt;data;
	r-&gt;status = SDok;
	return SDok;
}

/*
 * configure drives 0-5 as ahci sata (c.f. errata).
 * what about 6 &amp; 7, as claimed by marvell 0x9123?
 */
static int
iaahcimode(Pcidev *p)
{
	dprint("iaahcimode: %#ux %#ux %#ux\n", pcicfgr8(p, 0x91), pcicfgr8(p, 92),
		pcicfgr8(p, 93));
	pcicfgw16(p, 0x92, pcicfgr16(p, 0x92) | 0x3f);	/* ports 0-5 */
	return 0;
}

static void
iasetupahci(Ctlr *c)
{
	/* disable cmd block decoding. */
	pcicfgw16(c-&gt;pci, 0x40, pcicfgr16(c-&gt;pci, 0x40) &amp; ~(1&lt;&lt;15));
	pcicfgw16(c-&gt;pci, 0x42, pcicfgr16(c-&gt;pci, 0x42) &amp; ~(1&lt;&lt;15));

	c-&gt;lmmio[0x4/4] |= 1 &lt;&lt; 31;	/* enable ahci mode (ghc register) */
	c-&gt;lmmio[0xc/4] = (1 &lt;&lt; 6) - 1;	/* 5 ports. (supposedly ro pi reg.) */

	/* enable ahci mode and 6 ports; from ich9 datasheet */
	pcicfgw16(c-&gt;pci, 0x90, 1&lt;&lt;6 | 1&lt;&lt;5);
}

static int
didtype(Pcidev *p)
{
	switch(p-&gt;vid){
	case Vintel:
		if((p-&gt;did &amp; 0xfffc) == 0x2680)
			return Tesb;
		/*
		 * 0x27c4 is the intel 82801 in compatibility (not sata) mode.
		 */
		if (p-&gt;did == 0x1e02 ||			/* c210 */
		    p-&gt;did == 0x24d1 ||			/* 82801eb/er */
		    (p-&gt;did &amp; 0xfffb) == 0x27c1 ||	/* 82801g[bh]m ich7 */
		    p-&gt;did == 0x2821 ||			/* 82801h[roh] */
		    (p-&gt;did &amp; 0xfffe) == 0x2824 ||	/* 82801h[b] */
		    (p-&gt;did &amp; 0xfeff) == 0x2829 ||	/* ich8/9m */
		    (p-&gt;did &amp; 0xfffe) == 0x2922 ||	/* ich9 */
		    p-&gt;did == 0x3a02 ||			/* 82801jd/do */
		    (p-&gt;did &amp; 0xfefe) == 0x3a22 ||	/* ich10, pch */
		    (p-&gt;did &amp; 0xfff8) == 0x3b28)	/* pchm */
			return Tich;
		break;
	case Vatiamd:
		if(p-&gt;did == 0x4380 || p-&gt;did == 0x4390 || p-&gt;did == 0x4391){
			print("detected sb600 vid %#ux did %#ux\n", p-&gt;vid, p-&gt;did);
			return Tsb600;
		}
		break;
	case Vmarvell:
		if (p-&gt;did == 0x9123)
			print("ahci: marvell sata 3 controller has delusions "
				"of something on unit 7\n");
		break;
	}
	if(p-&gt;ccrb == Pcibcstore &amp;&amp; p-&gt;ccru == Pciscsata &amp;&amp; p-&gt;ccrp == 1){
		print("ahci: Tunk: vid %#4.4ux did %#4.4ux\n", p-&gt;vid, p-&gt;did);
		return Tunk;
	}
	return -1;
}

static int
newctlr(Ctlr *ctlr, SDev *sdev, int nunit)
{
	int i, n;
	Drive *drive;

	ctlr-&gt;ndrive = sdev-&gt;nunit = nunit;
	ctlr-&gt;mport = ctlr-&gt;hba-&gt;cap &amp; ((1&lt;&lt;5)-1);

	i = (ctlr-&gt;hba-&gt;cap &gt;&gt; 20) &amp; ((1&lt;&lt;4)-1);		/* iss */
	print("#S/sd%c: %s: %#p %s, %d ports, irq %d\n", sdev-&gt;idno,
		Tname(ctlr), ctlr-&gt;physio, descmode[i], nunit, ctlr-&gt;pci-&gt;intl);
	/* map the drives -- they don't all need to be enabled. */
	n = 0;
	ctlr-&gt;rawdrive = malloc(NCtlrdrv * sizeof(Drive));
	if(ctlr-&gt;rawdrive == nil) {
		print("ahci: out of memory\n");
		return -1;
	}
	for(i = 0; i &lt; NCtlrdrv; i++) {
		drive = ctlr-&gt;rawdrive + i;
		drive-&gt;portno = i;
		drive-&gt;driveno = -1;
		drive-&gt;sectors = 0;
		drive-&gt;serial[0] = ' ';
		drive-&gt;ctlr = ctlr;
		if((ctlr-&gt;hba-&gt;pi &amp; (1&lt;&lt;i)) == 0)
			continue;
		drive-&gt;port = (Aport*)(ctlr-&gt;mmio + 0x80*i + 0x100);
		drive-&gt;portc.p = drive-&gt;port;
		drive-&gt;portc.pm = &amp;drive-&gt;portm;
		drive-&gt;driveno = n++;
		ctlr-&gt;drive[drive-&gt;driveno] = drive;
		iadrive[niadrive + drive-&gt;driveno] = drive;
	}
	for(i = 0; i &lt; n; i++)
		if(ahciidle(ctlr-&gt;drive[i]-&gt;port) == -1){
			dprint("ahci: %s: port %d wedged; abort\n",
				Tname(ctlr), i);
			return -1;
		}
	for(i = 0; i &lt; n; i++){
		ctlr-&gt;drive[i]-&gt;mode = DMsatai;
		configdrive(ctlr-&gt;drive[i]);
	}
	return n;
}

static SDev*
iapnp(void)
{
	int n, nunit, type;
	ulong io;
	Ctlr *c;
	Pcidev *p;
	SDev *head, *tail, *s;
	static int done;

	if(done++)
		return nil;

	memset(olds, 0xff, sizeof olds);
	p = nil;
	head = tail = nil;
	while((p = pcimatch(p, 0, 0)) != nil){
		type = didtype(p);
		if (type == -1 || p-&gt;mem[Abar].bar == 0)
			continue;
		if(niactlr == NCtlr){
			print("ahci: iapnp: %s: too many controllers\n",
				tname[type]);
			break;
		}
		c = iactlr + niactlr;
		s = sdevs  + niactlr;
		memset(c, 0, sizeof *c);
		memset(s, 0, sizeof *s);
		io = p-&gt;mem[Abar].bar &amp; ~0xf;
		c-&gt;physio = (uchar *)io;
		c-&gt;mmio = vmap(io, p-&gt;mem[Abar].size);
		if(c-&gt;mmio == 0){
			print("ahci: %s: address %#luX in use did=%#x\n",
				Tname(c), io, p-&gt;did);
			continue;
		}
		c-&gt;lmmio = (ulong*)c-&gt;mmio;
		c-&gt;pci = p;
		c-&gt;type = type;

		s-&gt;ifc = &amp;sdiahciifc;
		s-&gt;idno = 'E' + niactlr;
		s-&gt;ctlr = c;
		c-&gt;sdev = s;

		if(Intel(c) &amp;&amp; p-&gt;did != 0x2681)
			iasetupahci(c);
		nunit = ahciconf(c);
//		ahcihbareset((Ahba*)c-&gt;mmio);
		if(Intel(c) &amp;&amp; iaahcimode(p) == -1)
			break;
		if(nunit &lt; 1){
			vunmap(c-&gt;mmio, p-&gt;mem[Abar].size);
			continue;
		}
		n = newctlr(c, s, nunit);
		if(n &lt; 0)
			continue;
		niadrive += n;
		niactlr++;
		if(head)
			tail-&gt;next = s;
		else
			head = s;
		tail = s;
	}
	return head;
}

static char* smarttab[] = {
	"unset",
	"error",
	"threshold exceeded",
	"normal"
};

static char *
pflag(char *s, char *e, uchar f)
{
	uchar i;

	for(i = 0; i &lt; 8; i++)
		if(f &amp; (1 &lt;&lt; i))
			s = seprint(s, e, "%s ", flagname[i]);
	return seprint(s, e, "\n");
}

static int
iarctl(SDunit *u, char *p, int l)
{
	char buf[32];
	char *e, *op;
	Aport *o;
	Ctlr *c;
	Drive *d;

	c = u-&gt;dev-&gt;ctlr;
	if(c == nil) {
print("iarctl: nil u-&gt;dev-&gt;ctlr\n");
		return 0;
	}
	d = c-&gt;drive[u-&gt;subno];
	o = d-&gt;port;

	e = p+l;
	op = p;
	if(d-&gt;state == Dready){
		p = seprint(p, e, "model\t%s\n", d-&gt;model);
		p = seprint(p, e, "serial\t%s\n", d-&gt;serial);
		p = seprint(p, e, "firm\t%s\n", d-&gt;firmware);
		if(d-&gt;smartrs == 0xff)
			p = seprint(p, e, "smart\tenable error\n");
		else if(d-&gt;smartrs == 0)
			p = seprint(p, e, "smart\tdisabled\n");
		else
			p = seprint(p, e, "smart\t%s\n",
				smarttab[d-&gt;portm.smart]);
		p = seprint(p, e, "flag\t");
		p = pflag(p, e, d-&gt;portm.feat);
	}else
		p = seprint(p, e, "no disk present [%s]\n", diskstates[d-&gt;state]);
	serrstr(o-&gt;serror, buf, buf + sizeof buf - 1);
	p = seprint(p, e, "reg\ttask %#lux cmd %#lux serr %#lux %s ci %#lux "
		"is %#lux; sig %#lux sstatus %06#lux\n",
		o-&gt;task, o-&gt;cmd, o-&gt;serror, buf,
		o-&gt;ci, o-&gt;isr, o-&gt;sig, o-&gt;sstatus);
	if(d-&gt;unit == nil)
		panic("iarctl: nil d-&gt;unit");
	p = seprint(p, e, "geometry %llud %lud\n", d-&gt;sectors, d-&gt;unit-&gt;secsize);
	return p - op;
}

static void
runflushcache(Drive *d)
{
	long t0;

	t0 = MACHP(0)-&gt;ticks;
	if(flushcache(d) != 0)
		error(Eio);
	dprint("ahci: flush in %ld ms\n", MACHP(0)-&gt;ticks - t0);
}

static void
forcemode(Drive *d, char *mode)
{
	int i;

	for(i = 0; i &lt; nelem(modename); i++)
		if(strcmp(mode, modename[i]) == 0)
			break;
	if(i == nelem(modename))
		i = 0;
	ilock(d);
	d-&gt;mode = i;
	iunlock(d);
}

static void
runsmartable(Drive *d, int i)
{
	if(waserror()){
		qunlock(&amp;d-&gt;portm);
		d-&gt;smartrs = 0;
		nexterror();
	}
	if(lockready(d) == -1)
		error(Eio);
	d-&gt;smartrs = smart(&amp;d-&gt;portc, i);
	d-&gt;portm.smart = 0;
	qunlock(&amp;d-&gt;portm);
	poperror();
}

static void
forcestate(Drive *d, char *state)
{
	int i;

	for(i = 0; i &lt; nelem(diskstates); i++)
		if(strcmp(state, diskstates[i]) == 0)
			break;
	if(i == nelem(diskstates))
		error(Ebadctl);
	setstate(d, i);
}

/*
 * force this driver to notice a change of medium if the hardware doesn't
 * report it.
 */
static void
changemedia(SDunit *u)
{
	Ctlr *c;
	Drive *d;

	c = u-&gt;dev-&gt;ctlr;
	d = c-&gt;drive[u-&gt;subno];
	ilock(d);
	d-&gt;mediachange = 1;
	u-&gt;sectors = 0;
	iunlock(d);
}

static int
iawctl(SDunit *u, Cmdbuf *cmd)
{
	char **f;
	Ctlr *c;
	Drive *d;
	uint i;

	c = u-&gt;dev-&gt;ctlr;
	d = c-&gt;drive[u-&gt;subno];
	f = cmd-&gt;f;

	if(strcmp(f[0], "change") == 0)
		changemedia(u);
	else if(strcmp(f[0], "flushcache") == 0)
		runflushcache(d);
	else if(strcmp(f[0], "identify") ==  0){
		i = strtoul(f[1]? f[1]: "0", 0, 0);
		if(i &gt; 0xff)
			i = 0;
		dprint("ahci: %04d %#ux\n", i, d-&gt;info[i]);
	}else if(strcmp(f[0], "mode") == 0)
		forcemode(d, f[1]? f[1]: "satai");
	else if(strcmp(f[0], "nop") == 0){
		if((d-&gt;portm.feat &amp; Dnop) == 0){
			cmderror(cmd, "no drive support");
			return -1;
		}
		if(waserror()){
			qunlock(&amp;d-&gt;portm);
			nexterror();
		}
		if(lockready(d) == -1)
			error(Eio);
		nop(&amp;d-&gt;portc);
		qunlock(&amp;d-&gt;portm);
		poperror();
	}else if(strcmp(f[0], "reset") == 0)
		forcestate(d, "reset");
	else if(strcmp(f[0], "smart") == 0){
		if(d-&gt;smartrs == 0){
			cmderror(cmd, "smart not enabled");
			return -1;
		}
		if(waserror()){
			qunlock(&amp;d-&gt;portm);
			d-&gt;smartrs = 0;
			nexterror();
		}
		if(lockready(d) == -1)
			error(Eio);
		d-&gt;portm.smart = 2 + smartrs(&amp;d-&gt;portc);
		qunlock(&amp;d-&gt;portm);
		poperror();
	}else if(strcmp(f[0], "smartdisable") == 0)
		runsmartable(d, 1);
	else if(strcmp(f[0], "smartenable") == 0)
		runsmartable(d, 0);
	else if(strcmp(f[0], "state") == 0)
		forcestate(d, f[1]? f[1]: "null");
	else{
		cmderror(cmd, Ebadctl);
		return -1;
	}
	return 0;
}

static char *
portr(char *p, char *e, uint x)
{
	int i, a;

	p[0] = 0;
	a = -1;
	for(i = 0; i &lt; 32; i++){
		if((x &amp; (1&lt;&lt;i)) == 0){
			if(a != -1 &amp;&amp; i - 1 != a)
				p = seprint(p, e, "-%d", i - 1);
			a = -1;
			continue;
		}
		if(a == -1){
			if(i &gt; 0)
				p = seprint(p, e, ", ");
			p = seprint(p, e, "%d", a = i);
		}
	}
	if(a != -1 &amp;&amp; i - 1 != a)
		p = seprint(p, e, "-%d", i - 1);
	return p;
}

/* must emit exactly one line per controller (sd(3)) */
static char*
iartopctl(SDev *sdev, char *p, char *e)
{
	ulong cap;
	char pr[25];
	Ahba *hba;
	Ctlr *ctlr;

#define has(x, str) if(cap &amp; (x)) p = seprint(p, e, "%s ", (str))

	ctlr = sdev-&gt;ctlr;
	hba = ctlr-&gt;hba;
	p = seprint(p, e, "sd%c ahci port %#p: ", sdev-&gt;idno, ctlr-&gt;physio);
	cap = hba-&gt;cap;
	has(Hs64a, "64a");
	has(Hsalp, "alp");
	has(Hsam, "am");
	has(Hsclo, "clo");
	has(Hcccs, "coal");
	has(Hems, "ems");
	has(Hsal, "led");
	has(Hsmps, "mps");
	has(Hsncq, "ncq");
	has(Hssntf, "ntf");
	has(Hspm, "pm");
	has(Hpsc, "pslum");
	has(Hssc, "slum");
	has(Hsss, "ss");
	has(Hsxs, "sxs");
	portr(pr, pr + sizeof pr, hba-&gt;pi);
	return seprint(p, e,
		"iss %ld ncs %ld np %ld; ghc %#lux isr %#lux pi %#lux %s ver %#lux\n",
		(cap&gt;&gt;20) &amp; 0xf, (cap&gt;&gt;8) &amp; 0x1f, 1 + (cap &amp; 0x1f),
		hba-&gt;ghc, hba-&gt;isr, hba-&gt;pi, pr, hba-&gt;ver);
#undef has
}

static int
iawtopctl(SDev *, Cmdbuf *cmd)
{
	int *v;
	char **f;

	f = cmd-&gt;f;
	v = 0;

	if (f[0] == nil)
		return 0;
	if(strcmp(f[0], "debug") == 0)
		v = &amp;debug;
	else if(strcmp(f[0], "idprint") == 0)
		v = &amp;prid;
	else if(strcmp(f[0], "aprint") == 0)
		v = &amp;datapi;
	else
		cmderror(cmd, Ebadctl);

	switch(cmd-&gt;nf){
	default:
		cmderror(cmd, Ebadarg);
	case 1:
		*v ^= 1;
		break;
	case 2:
		if(f[1])
			*v = strcmp(f[1], "on") == 0;
		else
			*v ^= 1;
		break;
	}
	return 0;
}

SDifc sdiahciifc = {
	"iahci",

	iapnp,
	nil,		/* legacy */
	iaenable,
	iadisable,

	iaverify,
	iaonline,
	iario,
	iarctl,
	iawctl,

	scsibio,
	nil,		/* probe */
	nil,		/* clear */
	iartopctl,
	iawtopctl,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

