<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/sdmv50xx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/sdmv50xx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Marvell 88SX[56]0[48][01] fileserver Serial ATA (SATA) driver
 *
 * See MV-S101357-00 Rev B Marvell PCI/PCI-X to 8-Port/4-Port
 * SATA Host Controller, ATA-5 ANSI NCITS 340-2000.
 *
 * This is a heavily-modified version (by Coraid) of a heavily-modified
 * version (from The Labs) of a driver written by Coraid, Inc.
 * The original copyright notice appears at the end of this file.
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#include "../port/sd.h"

#define dprint if(!0){}else iprint
#define idprint if(!0){}else iprint
#define ioprint if(!0){}else iprint

enum {
	NCtlr		= 4,
	NCtlrdrv	= 8,
	NDrive		= NCtlr*NCtlrdrv,

	Read 		= 0,
	Write,

	Coraiddebug	= 0,
};

enum {
	SrbRing = 32,

	/* Addresses of ATA register */
	ARcmd		= 027,
	ARdev		= 026,
	ARerr		= 021,
	ARfea		= 021,
	ARlba2		= 025,
	ARlba1		= 024,
	ARlba0		= 023,
	ARseccnt	= 022,
	ARstat		= 027,

	ATAerr		= (1&lt;&lt;0),
	ATAdrq		= (1&lt;&lt;3),
	ATAdf 		= (1&lt;&lt;5),
	ATAdrdy 	= (1&lt;&lt;6),
	ATAbusy 	= (1&lt;&lt;7),
	ATAabort	= (1&lt;&lt;2),
	ATAobs		= (1&lt;&lt;1 | 1&lt;&lt;2 | 1&lt;&lt;4),
	ATAeIEN		= (1&lt;&lt;1),
	ATAsrst		= (1&lt;&lt;2),
	ATAhob		= (1&lt;&lt;7),
	ATAbad		= (ATAbusy|ATAdf|ATAdrq|ATAerr),

	SFdone 		= (1&lt;&lt;0),
	SFerror 	= (1&lt;&lt;1),

	SRBident 	= 0,
	SRBread,
	SRBwrite,
	SRBsmart,

	SRBnodata = 0,
	SRBdatain,
	SRBdataout,

	RQread		= 1,		/* data coming IN from device */

	PRDeot		= (1&lt;&lt;15),

	/* EDMA interrupt error cause register */

	ePrtDataErr	= (1&lt;&lt;0),
	ePrtPRDErr	= (1&lt;&lt;1),
	eDevErr		= (1&lt;&lt;2),
	eDevDis		= (1&lt;&lt;3),
	eDevCon		= (1&lt;&lt;4),
	eOverrun	= (1&lt;&lt;5),
	eUnderrun	= (1&lt;&lt;6),
	eSelfDis	= (1&lt;&lt;8),
	ePrtCRQBErr	= (1&lt;&lt;9),
	ePrtCRPBErr	= (1&lt;&lt;10),
	ePrtIntErr	= (1&lt;&lt;11),
	eIORdyErr	= (1&lt;&lt;12),

	/* flags for sata 2 version */
	eSelfDis2	= (1&lt;&lt;7),
	SerrInt		= (1&lt;&lt;5),

	/* EDMA Command Register */

	eEnEDMA	= (1&lt;&lt;0),
	eDsEDMA 	= (1&lt;&lt;1),
	eAtaRst 	= (1&lt;&lt;2),

	/* Interrupt mask for errors we care about */
	IEM		= (eDevDis | eDevCon | eSelfDis),
	IEM2		= (eDevDis | eDevCon | eSelfDis2),

	/* drive states */
	Dnull 		= 0,
	Dnew,
	Dready,
	Derror,
	Dmissing,
	Dreset,
	Dlast,

	/* drive flags */
	Dext	 	= (1&lt;&lt;0),	/* use ext commands */
	Dpio		= (1&lt;&lt;1),	/* doing pio */
	Dwanted		= (1&lt;&lt;2),	/* someone wants an srb entry */
	Dedma		= (1&lt;&lt;3),	/* device in edma mode */
	Dpiowant	= (1&lt;&lt;4),	/* some wants to use the pio mode */

	/* phyerrata magic crap */
	Mpreamp	= 0x7e0,
	Dpreamp	= 0x720,

	REV60X1B2	= 0x7,
	REV60X1C0	= 0x9,

};

static char* diskstates[Dlast] = {
	"null",
	"new",
	"ready",
	"error",
	"missing",
	"reset",
};

extern SDifc sdmv50xxifc;

typedef struct Arb Arb;
typedef struct Bridge Bridge;
typedef struct Chip Chip;
typedef struct Ctlr Ctlr;
typedef struct Drive Drive;
typedef struct Edma Edma;
typedef struct Prd Prd;
typedef struct Rx Rx;
typedef struct Srb Srb;
typedef struct Tx Tx;

/*
 * there are 4 drives per chip.  thus an 8-port
 * card has two chips.
 */
struct Chip
{
	Arb	*arb;
	Edma	*edma;
};

enum {
	DMautoneg,
	DMsatai,
	DMsataii,
};

struct Drive
{
	Lock;

	Ctlr	*ctlr;
	SDunit	*unit;
	char	name[10];
	ulong	magic;

	Bridge	*bridge;
	Edma	*edma;
	Chip	*chip;
	int	chipx;

	int	mediachange;
	int	state;
	int	flag;
	uvlong	sectors;
	ulong	pm2;		/* phymode 2 init state */
	ulong	intick;		/* check for hung western digital drives. */
	int	wait;
	int	mode;		/* DMautoneg, satai or sataii. */

	char	serial[20+1];
	char	firmware[8+1];
	char	model[40+1];

	ushort	info[256];

	Srb	*srb[SrbRing-1];
	int	nsrb;
	Prd	*prd;
	Tx	*tx;
	Rx	*rx;

	Srb	*srbhead;
	Srb	*srbtail;
	int	driveno;	/* ctlr*NCtlrdrv + unit */
};

struct Ctlr
{
	Lock;

	int	irq;
	int	tbdf;
	int	rid;
	ulong	magic;
	int	enabled;
	int	type;
	SDev	*sdev;
	Pcidev	*pcidev;

	uchar	*mmio;
	ulong	*lmmio;
	Chip	chip[2];
	int	nchip;
	Drive	drive[NCtlrdrv];
	int	ndrive;
};

struct Srb			/* request buffer */
{
	Lock;
	Rendez;
	Srb	*next;

	Drive	*drive;
	uvlong	blockno;
	int	count;
	int	req;
	int	flag;
	uchar	*data;

	uchar	cmd;
	uchar	lba[6];
	uchar	sectors;
	int	sta;
	int	err;
};

/*
 * Memory-mapped I/O registers in many forms.
 */
struct Bridge			/* memory-mapped per-Drive registers */
{
	ulong	status;
	ulong	serror;
	ulong	sctrl;
	ulong	phyctrl;
	ulong	phymode3;
	ulong	phymode4;
	uchar	fill0[0x14];
	ulong	phymode1;
	ulong	phymode2;
	char	fill1[8];
	ulong	ctrl;
	char	fill2[0x34];
	ulong	phymode;
	char	fill3[0x88];
};				/* length must be 0x100 */

struct Arb			/* memory-mapped per-Chip registers */
{
	ulong	config;		/* satahc configuration register (sata2 only) */
	ulong	rqop;		/* request queue out-pointer */
	ulong	rqip;		/* response queue in pointer */
	ulong	ict;		/* inerrupt caolescing threshold */
	ulong	itt;		/* interrupt timer threshold */
	ulong	ic;		/* interrupt cause */
	ulong	btc;		/* bridges test control */
	ulong	bts;		/* bridges test status */
	ulong	bpc;		/* bridges pin configuration */
	char	fill1[0xdc];
	Bridge	bridge[4];
};

struct Edma			/* memory-mapped per-Drive DMA-related registers */
{
	ulong	config;		/* configuration register */
	ulong	timer;
	ulong	iec;		/* interrupt error cause */
	ulong	iem;		/* interrupt error mask */

	ulong	txbasehi;		/* request queue base address high */
	ulong	txi;		/* request queue in pointer */
	ulong	txo;		/* request queue out pointer */

	ulong	rxbasehi;		/* response queue base address high */
	ulong	rxi;		/* response queue in pointer */
	ulong	rxo;		/* response queue out pointer */

	ulong	ctl;		/* command register */
	ulong	testctl;		/* test control */
	ulong	status;
	ulong	iordyto;		/* IORDY timeout */
	char	fill[0x18];
	ulong	sataconfig;	/* sata 2 */
	char	fill[0xac];
	ushort	pio;		/* data register */
	char	pad0[2];
	uchar	err;		/* features and error */
	char	pad1[3];
	uchar	seccnt;		/* sector count */
	char	pad2[3];
	uchar	lba0;
	char	pad3[3];
	uchar	lba1;
	char	pad4[3];
	uchar	lba2;
	char	pad5[3];
	uchar	lba3;
	char	pad6[3];
	uchar	cmdstat;		/* cmd/status */
	char	pad7[3];
	uchar	altstat;		/* alternate status */
	uchar	fill2[0x1df];
	Bridge	port;
	char	fill3[0x1c00];	/* pad to 0x2000 bytes */
};

/*
 * Memory structures shared with card.
 */
struct Prd			/* physical region descriptor */
{
	ulong	pa;		/* byte address of physical memory */
	ushort	count;		/* byte count (bit0 must be 0) */
	ushort	flag;
	ulong	zero;		/* high long of 64 bit address */
	ulong	reserved;
};

struct Tx				/* command request block */
{
	ulong	prdpa;		/* physical region descriptor table structures */
	ulong	zero;		/* must be zero (high long of prd address) */
	ushort	flag;		/* control flags */
	ushort	regs[11];
};

struct Rx				/* command response block */
{
	ushort	cid;		/* cID of response */
	uchar	cEdmaSts;	/* EDMA status */
	uchar	cDevSts;		/* status from disk */
	ulong	ts;		/* time stamp */
};

static Drive 	*mvsatadrive[NDrive];
static int	nmvsatadrive;

/*
 * Little-endian parsing for drive data.
 */
static ushort
lhgets(void *p)
{
	uchar *a = p;
	return ((ushort) a[1] &lt;&lt; 8) | a[0];
}

static ulong
lhgetl(void *p)
{
	uchar *a = p;
	return ((ulong) lhgets(a+2) &lt;&lt; 16) | lhgets(a);
}

static uvlong
lhgetv(void *p)
{
	uchar *a = p;
	return ((uvlong) lhgetl(a+4) &lt;&lt; 32) | lhgetl(a);
}

static void
idmove(char *p, ushort *a, int n)
{
	char *op;
	int i;

	op = p;
	for(i=0; i&lt;n/2; i++){
		*p++ = a[i]&gt;&gt;8;
		*p++ = a[i];
	}
	while(p&gt;op &amp;&amp; *--p == ' ')
		*p = 0;
}

/*
 * Request buffers.
 */
struct
{
	Lock;
	Srb *freechain;
	int nalloc;
} srblist;

static Srb*
allocsrb(void)
{
	Srb *p;

	ilock(&amp;srblist);
	if((p = srblist.freechain) == nil){
		srblist.nalloc++;
		iunlock(&amp;srblist);
		p = smalloc(sizeof *p);
	}else{
		srblist.freechain = p-&gt;next;
		iunlock(&amp;srblist);
	}
	return p;
}

static void
freesrb(Srb *p)
{
	ilock(&amp;srblist);
	p-&gt;next = srblist.freechain;
	srblist.freechain = p;
	iunlock(&amp;srblist);
}

/*
 * Wait for a byte to be a particular value.
 */
static int
satawait(uchar *p, uchar mask, uchar v, int ms)
{
	int i;

	for(i=0; i&lt;ms &amp;&amp; (*p &amp; mask) != v; i++)
		microdelay(1000);
	return (*p &amp; mask) == v;
}

/*
 * Drive initialization
 */
/* unmask in the pci registers err done */
static void
unmask(ulong *mmio, int port, int coal)
{
	port &amp;= 7;
	if(coal)
		coal = 1;
	if (port &lt; 4)
		mmio[0x1d64/4] |= (3 &lt;&lt; (((port&amp;3)*2)) | (coal&lt;&lt;8));
	else
		mmio[0x1d64/4] |= (3 &lt;&lt; (((port&amp;3)*2+9)) | (coal&lt;&lt;17));
}

static void
mask(ulong *mmio, int port, int coal)
{
	port &amp;= 7;
	if(coal)
		coal = 1;
	if (port &lt; 4)
		mmio[0x1d64/4] &amp;= ~(3 &lt;&lt; (((port&amp;3)*2)) | (coal&lt;&lt;8));
	else
		mmio[0x1d64/4] &amp;= ~(3 &lt;&lt; (((port&amp;3)*2+9)) | (coal&lt;&lt;17));
}

/* I give up, marvell.  You win. */
static void
phyerrata(Drive *d)
{
	ulong n, m;
	enum { BadAutoCal = 0xf &lt;&lt; 26, };

	if (d-&gt;ctlr-&gt;type == 1)
		return;
	microdelay(200);
	n = d-&gt;bridge-&gt;phymode2;
	while ((n &amp; BadAutoCal) == BadAutoCal) {
		dprint("%s: badautocal\n", d-&gt;unit-&gt;name);
		n &amp;= ~(1&lt;&lt;16);
		n |= (1&lt;&lt;31);
		d-&gt;bridge-&gt;phymode2 = n;
		microdelay(200);
		d-&gt;bridge-&gt;phymode2 &amp;= ~((1&lt;&lt;16) | (1&lt;&lt;31));
		microdelay(200);
		n = d-&gt;bridge-&gt;phymode2;
	}
	n &amp;= ~(1&lt;&lt;31);
	d-&gt;bridge-&gt;phymode2 = n;
	microdelay(200);

	/* abra cadabra!  (random magic) */
	m = d-&gt;bridge-&gt;phymode3;
	m &amp;= ~0x7f800000;
	m |= 0x2a800000;
	d-&gt;bridge-&gt;phymode3 = m;

	/* fix phy mode 4 */
	m = d-&gt;bridge-&gt;phymode3;
	n = d-&gt;bridge-&gt;phymode4;
	n &amp;= ~(1&lt;&lt;1);
	n |= 1;
	switch(d-&gt;ctlr-&gt;rid){
	case REV60X1B2:
	default:
		d-&gt;bridge-&gt;phymode4 = n;
		d-&gt;bridge-&gt;phymode3 = m;
		break;
	case REV60X1C0:
		d-&gt;bridge-&gt;phymode4 = n;
		break;
	}

	/* revert values of pre-emphasis and signal amps to the saved ones */
	n = d-&gt;bridge-&gt;phymode2;
	n &amp;= ~Mpreamp;
	n |= d-&gt;pm2;
	n &amp;= ~(1&lt;&lt;16);
	d-&gt;bridge-&gt;phymode2 = n;
}

static void
edmacleanout(Drive *d)
{
	int i;
	Srb *srb;

	for(i=0; i&lt;nelem(d-&gt;srb); i++){
		if(srb = d-&gt;srb[i]){
			d-&gt;srb[i] = nil;
			d-&gt;nsrb--;
			srb-&gt;flag |= SFerror|SFdone;
			wakeup(srb);
		}
	}
	while(srb = d-&gt;srbhead){
		d-&gt;srbhead = srb-&gt;next;
		srb-&gt;flag |= SFerror|SFdone;
		wakeup(srb);
	}
}

static void
resetdisk(Drive *d)
{
	ulong n;

	d-&gt;sectors = 0;
	d-&gt;unit-&gt;sectors = 0;
	if (d-&gt;ctlr-&gt;type == 2) {
		/*
		 * without bit 8 we can boot without disks, but
		 * inserted disks will never appear.  :-X
		 */
		n = d-&gt;edma-&gt;sataconfig;
		n &amp;= 0xff;
		n |= 0x9b1100;
		d-&gt;edma-&gt;sataconfig = n;
		n = d-&gt;edma-&gt;sataconfig;	/* flush */
		USED(n);
	}
	d-&gt;edma-&gt;ctl = eDsEDMA;
	microdelay(1);
	d-&gt;edma-&gt;ctl = eAtaRst;
	microdelay(25);
	d-&gt;edma-&gt;ctl = 0;
	if (satawait((uchar *)&amp;d-&gt;edma-&gt;ctl, eEnEDMA, 0, 3*1000) == 0)
		print("%s: eEnEDMA never cleared on reset\n", d-&gt;unit-&gt;name);
	edmacleanout(d);
	phyerrata(d);
	d-&gt;bridge-&gt;sctrl = 0x301 | (d-&gt;mode &lt;&lt; 4);
	d-&gt;state = Dmissing;
}

static void
edmainit(Drive *d)
{
	int i;

	if(d-&gt;tx != nil)
		return;

	d-&gt;tx = xspanalloc(32*sizeof(Tx), 1024, 0);
	d-&gt;rx = xspanalloc(32*sizeof(Rx), 256, 0);
	d-&gt;prd = xspanalloc(32*sizeof(Prd), 32, 0);
	for(i = 0; i &lt; 32; i++)
		d-&gt;tx[i].prdpa = PADDR(&amp;d-&gt;prd[i]);
	coherence();
}

static int
configdrive(Ctlr *ctlr, Drive *d, SDunit *unit)
{
	dprint("%s: configdrive\n", unit-&gt;name);
	if(d-&gt;driveno &lt; 0)
		panic("mv50xx: configdrive: unset driveno\n");
	d-&gt;unit = unit;
	edmainit(d);
	d-&gt;mode = DMsatai;
	if(d-&gt;ctlr-&gt;type == 1){
		d-&gt;edma-&gt;iem = IEM;
		d-&gt;bridge = &amp;d-&gt;chip-&gt;arb-&gt;bridge[d-&gt;chipx];
	}else{
		d-&gt;edma-&gt;iem = IEM2;
		d-&gt;bridge = &amp;d-&gt;chip-&gt;edma[d-&gt;chipx].port;
		d-&gt;edma-&gt;iem = ~(1&lt;&lt;6);
		d-&gt;pm2 = Dpreamp;
		if(d-&gt;ctlr-&gt;lmmio[0x180d8/4] &amp; 1)
			d-&gt;pm2 = d-&gt;bridge-&gt;phymode2 &amp; Mpreamp;
	}
	resetdisk(d);
	unmask(ctlr-&gt;lmmio, d-&gt;driveno, 0);
	delay(100);
	if(d-&gt;bridge-&gt;status){
		dprint("%s: configdrive: found drive %lx\n", unit-&gt;name, d-&gt;bridge-&gt;status);
		return 0;
	}
	return -1;
}

static int
enabledrive(Drive *d)
{
	Edma *edma;

	dprint("%s: enabledrive..", d-&gt;unit-&gt;name);

	if((d-&gt;bridge-&gt;status &amp; 0xf) != 3){
		dprint("%s: not present\n", d-&gt;unit-&gt;name);
		d-&gt;state = Dmissing;
		return -1;
	}
	edma = d-&gt;edma;
	if(satawait(&amp;edma-&gt;cmdstat, ATAbusy, 0, 5*1000) == 0){
		dprint("%s: busy timeout\n", d-&gt;unit-&gt;name);
		d-&gt;state = Dmissing;
		return -1;
	}
	edma-&gt;iec = 0;
	d-&gt;chip-&gt;arb-&gt;ic &amp;= ~(0x101 &lt;&lt; d-&gt;chipx);
	edma-&gt;config = 0x51f;
	if (d-&gt;ctlr-&gt;type == 2)
		edma-&gt;config |= 7&lt;&lt;11;
	edma-&gt;txi = PADDR(d-&gt;tx);
	edma-&gt;txo = (ulong)d-&gt;tx &amp; 0x3e0;
	edma-&gt;rxi = (ulong)d-&gt;rx &amp; 0xf8;
	edma-&gt;rxo = PADDR(d-&gt;rx);
	edma-&gt;ctl |= 1;		/* enable dma */

	if(d-&gt;bridge-&gt;status = 0x113){
		dprint("%s: new\n", d-&gt;unit-&gt;name);
		d-&gt;state = Dnew;
	}else
		print("%s: status not forced (should be okay)\n", d-&gt;unit-&gt;name);
	return 0;
}

static void
disabledrive(Drive *d)
{
	int i;
	ulong *r;

	dprint("%s: disabledrive\n", d-&gt;unit-&gt;name);

	if(d-&gt;tx == nil)	/* never enabled */
		return;

	d-&gt;edma-&gt;ctl = 0;
	d-&gt;edma-&gt;iem = 0;

	r = (ulong*)(d-&gt;ctlr-&gt;mmio + 0x1d64);
	i = d-&gt;chipx;
	if(d-&gt;chipx &lt; 4)
		*r &amp;= ~(3 &lt;&lt; (i*2));
	else
		*r |= ~(3 &lt;&lt; (i*2+9));
}

static int
setudmamode(Drive *d, uchar mode)
{
	Edma *edma;

	dprint("%s: setudmamode %d\n", d-&gt;unit-&gt;name, mode);

	edma = d-&gt;edma;
	if (edma == nil) {
		iprint("setudamode(m%d): zero d-&gt;edma\m", d-&gt;driveno);
		return 0;
	}
	if(satawait(&amp;edma-&gt;cmdstat, ~ATAobs, ATAdrdy, 9*1000) == 0){
		iprint("%s: cmdstat 0x%.2ux ready timeout\n", d-&gt;unit-&gt;name, edma-&gt;cmdstat);
		return 0;
	}
	edma-&gt;altstat = ATAeIEN;
	edma-&gt;err = 3;
	edma-&gt;seccnt = 0x40 | mode;
	edma-&gt;cmdstat = 0xef;
	microdelay(1);
	if(satawait(&amp;edma-&gt;cmdstat, ATAbusy, 0, 5*1000) == 0){
		iprint("%s: cmdstat 0x%.2ux busy timeout\n", d-&gt;unit-&gt;name, edma-&gt;cmdstat);
		return 0;
	}
	return 1;
}

static int
identifydrive(Drive *d)
{
	int i;
	ushort *id;
	Edma *edma;
	SDunit *unit;

	dprint("%s: identifydrive\n", d-&gt;unit-&gt;name);

	if(setudmamode(d, 5) == 0)	/* do all SATA support 5? */
		goto Error;

	id = d-&gt;info;
	memset(d-&gt;info, 0, sizeof d-&gt;info);
	edma = d-&gt;edma;
	if(satawait(&amp;edma-&gt;cmdstat, ~ATAobs, ATAdrdy, 5*1000) == 0)
		goto Error;

	edma-&gt;altstat = ATAeIEN;	/* no interrupts */
	edma-&gt;cmdstat = 0xec;
	microdelay(1);
	if(satawait(&amp;edma-&gt;cmdstat, ATAbusy, 0, 5*1000) == 0)
		goto Error;
	for(i = 0; i &lt; 256; i++)
		id[i] = edma-&gt;pio;
	if(edma-&gt;cmdstat &amp; ATAbad)
		goto Error;
	i = lhgets(id+83) | lhgets(id+86);
	if(i &amp; (1&lt;&lt;10)){
		d-&gt;flag |= Dext;
		d-&gt;sectors = lhgetv(id+100);
	}else{
		d-&gt;flag &amp;= ~Dext;
		d-&gt;sectors = lhgetl(id+60);
	}
	idmove(d-&gt;serial, id+10, 20);
	idmove(d-&gt;firmware, id+23, 8);
	idmove(d-&gt;model, id+27, 40);

	unit = d-&gt;unit;
	memset(unit-&gt;inquiry, 0, sizeof unit-&gt;inquiry);
	unit-&gt;inquiry[2] = 2;
	unit-&gt;inquiry[3] = 2;
	unit-&gt;inquiry[4] = sizeof(unit-&gt;inquiry)-4;
	idmove((char*)unit-&gt;inquiry+8, id+27, 40);

	if(enabledrive(d) == 0) {
		d-&gt;state = Dready;
		d-&gt;mediachange = 1;
		idprint("%s: LLBA %lld sectors\n", d-&gt;unit-&gt;name, d-&gt;sectors);
	} else
		d-&gt;state = Derror;
	if(d-&gt;state == Dready)
		return 0;
	return -1;
Error:
	dprint("error...");
	d-&gt;state = Derror;
	return -1;
}

/* p. 163:
	M	recovered error
	P	protocol error
	N	PhyRdy change
	W	CommWake
	B	8-to-10 encoding error
	D	disparity error
	C	crc error
	H	handshake error
	S	link sequence error
	T	transport state transition error
	F	unrecognized fis type
	X	device changed
*/

static char stab[] = {
[1]	'M',
[10]	'P',
[16]	'N',
[18]	'W', 'B', 'D', 'C', 'H', 'S', 'T', 'F', 'X'
};
static ulong sbad = (7&lt;&lt;20)|(3&lt;&lt;23);

static void
serrdecode(ulong r, char *s, char *e)
{
	int i;

	e -= 3;
	for(i = 0; i &lt; nelem(stab) &amp;&amp; s &lt; e; i++){
		if((r&amp;(1&lt;&lt;i)) &amp;&amp; stab[i]){
			*s++ = stab[i];
			if(sbad&amp;(1&lt;&lt;i))
				*s++ = '*';
		}
	}
	*s = 0;
}

char *iectab[] = {
	"ePrtDataErr",
	"ePrtPRDErr",
	"eDevErr",
	"eDevDis",
	"eDevCon",
	"SerrInt",
	"eUnderrun",
	"eSelfDis2",
	"eSelfDis",
	"ePrtCRQBErr",
	"ePrtCRPBErr",
	"ePrtIntErr",
	"eIORdyErr",
};

static char*
iecdecode(ulong cause)
{
	int i;

	for(i = 0; i &lt; nelem(iectab); i++)
		if(cause&amp;(1&lt;&lt;i))
			return iectab[i];
	return "";
}

enum{
	Cerror = ePrtDataErr|ePrtPRDErr|eDevErr|eSelfDis2|ePrtCRPBErr|ePrtIntErr,
};

static void
updatedrive(Drive *d)
{
	int x;
	ulong cause;
	Edma *edma;
	char buf[32+4+1];

	edma = d-&gt;edma;
	if((edma-&gt;ctl&amp;eEnEDMA) == 0){
		/* FEr SATA#4 40xx */
		x = d-&gt;edma-&gt;cmdstat;
		USED(x);
	}
	cause = edma-&gt;iec;
	if(cause == 0)
		return;
	dprint("%s: cause %08ulx [%s]\n", d-&gt;unit-&gt;name, cause, iecdecode(cause));
	if(cause &amp; eDevCon)
		d-&gt;state = Dnew;
	if(cause&amp;eDevDis &amp;&amp; d-&gt;state == Dready)
		iprint("%s: pulled: st=%08ulx\n", d-&gt;unit-&gt;name, cause);
	switch(d-&gt;ctlr-&gt;type){
	case 1:
		if(cause&amp;eSelfDis)
			d-&gt;state = Derror;
		break;
	case 2:
		if(cause&amp;Cerror)
			d-&gt;state = Derror;
		if(cause&amp;SerrInt){
			serrdecode(d-&gt;bridge-&gt;serror, buf, buf+sizeof buf);
			dprint("%s: serror %08ulx [%s]\n", d-&gt;unit-&gt;name, (ulong)d-&gt;bridge-&gt;serror, buf);
			d-&gt;bridge-&gt;serror = d-&gt;bridge-&gt;serror;
		}
	}
	edma-&gt;iec = ~cause;
}

/*
 * Requests
 */
static Srb*
srbrw(int req, Drive *d, uchar *data, uint sectors, uvlong lba)
{
	int i;
	Srb *srb;
	static uchar cmd[2][2] = { 0xC8, 0x25, 0xCA, 0x35 };

	srb = allocsrb();
	srb-&gt;req = req;
	srb-&gt;drive = d;
	srb-&gt;blockno = lba;
	srb-&gt;sectors = sectors;
	srb-&gt;count = sectors*512;
	srb-&gt;flag = 0;
	srb-&gt;data = data;

	for(i=0; i&lt;6; i++)
		srb-&gt;lba[i] = lba &gt;&gt; (8*i);
	srb-&gt;cmd = cmd[srb-&gt;req!=SRBread][(d-&gt;flag&amp;Dext)!=0];
	return srb;
}

static uintptr
advance(uintptr pa, int shift)
{
	int n, mask;

	mask = 0x1F&lt;&lt;shift;
	n = (pa &amp; mask) + (1&lt;&lt;shift);
	return (pa &amp; ~mask) | (n &amp; mask);
}

#define CMD(r, v) (((r)&lt;&lt;8) | ((v)&amp;0xFF))
static void
mvsatarequest(ushort *cmd, Srb *srb, int ext)
{
	*cmd++ = CMD(ARseccnt, 0);
	*cmd++ = CMD(ARseccnt, srb-&gt;sectors);
	*cmd++ = CMD(ARfea, 0);
	if(ext){
		*cmd++ = CMD(ARlba0, srb-&gt;lba[3]);
		*cmd++ = CMD(ARlba0, srb-&gt;lba[0]);
		*cmd++ = CMD(ARlba1, srb-&gt;lba[4]);
		*cmd++ = CMD(ARlba1, srb-&gt;lba[1]);
		*cmd++ = CMD(ARlba2, srb-&gt;lba[5]);
		*cmd++ = CMD(ARlba2, srb-&gt;lba[2]);
		*cmd++ = CMD(ARdev, 0xe0);
	}else{
		*cmd++ = CMD(ARlba0, srb-&gt;lba[0]);
		*cmd++ = CMD(ARlba1, srb-&gt;lba[1]);
		*cmd++ = CMD(ARlba2, srb-&gt;lba[2]);
		*cmd++ = CMD(ARdev, srb-&gt;lba[3] | 0xe0);
	}
	*cmd = CMD(ARcmd, srb-&gt;cmd) | (1&lt;&lt;15);
}

static void
startsrb(Drive *d, Srb *srb)
{
	int i;
	Edma *edma;
	Prd *prd;
	Tx *tx;

	if(d-&gt;nsrb &gt;= nelem(d-&gt;srb)){
		srb-&gt;next = nil;
		if(d-&gt;srbhead)
			d-&gt;srbtail-&gt;next = srb;
		else
			d-&gt;srbhead = srb;
		d-&gt;srbtail = srb;
		return;
	}

	d-&gt;nsrb++;
	for(i=0; i&lt;nelem(d-&gt;srb); i++)
		if(d-&gt;srb[i] == nil)
			break;
	if(i == nelem(d-&gt;srb))
		panic("sdmv50xx: no free srbs");
	d-&gt;intick = MACHP(0)-&gt;ticks;
	d-&gt;srb[i] = srb;
	edma = d-&gt;edma;
	tx = (Tx*)KADDR(edma-&gt;txi);
	tx-&gt;flag = (i&lt;&lt;1) | (srb-&gt;req == SRBread);
	prd = KADDR(tx-&gt;prdpa);
	prd-&gt;pa = PADDR(srb-&gt;data);
	prd-&gt;count = srb-&gt;count;
	prd-&gt;flag = PRDeot;
	mvsatarequest(tx-&gt;regs, srb, d-&gt;flag&amp;Dext);
	coherence();
	edma-&gt;txi = advance(edma-&gt;txi, 5);
	d-&gt;intick = MACHP(0)-&gt;ticks;
}

enum{
	Rpidx	= 0x1f&lt;&lt;3,
};

static void
completesrb(Drive *d)
{
	Edma *edma;
	Rx *rx;
	Srb *srb;

	edma = d-&gt;edma;
	if((edma-&gt;ctl &amp; eEnEDMA) == 0)
		return;

	while((edma-&gt;rxo&amp;Rpidx) != (edma-&gt;rxi&amp;Rpidx)){
		rx = (Rx*)KADDR(edma-&gt;rxo);
		if(srb = d-&gt;srb[rx-&gt;cid]){
			d-&gt;srb[rx-&gt;cid] = nil;
			d-&gt;nsrb--;
			if(rx-&gt;cDevSts &amp; ATAbad)
				srb-&gt;flag |= SFerror;
			if (rx-&gt;cEdmaSts)
				iprint("cEdmaSts: %02ux\n", rx-&gt;cEdmaSts);
			srb-&gt;sta = rx-&gt;cDevSts;
			srb-&gt;flag |= SFdone;
			wakeup(srb);
		}else
			iprint("srb missing\n");
		edma-&gt;rxo = advance(edma-&gt;rxo, 3);
		if(srb = d-&gt;srbhead){
			d-&gt;srbhead = srb-&gt;next;
			startsrb(d, srb);
		}
	}
}

static int
srbdone(void *v)
{
	Srb *srb;

	srb = v;
	return srb-&gt;flag &amp; SFdone;
}

/*
 * Interrupts
 */
static void
mv50interrupt(Ureg*, void *a)
{
	int i;
	ulong cause;
	Ctlr *ctlr;
	Drive *drive;

	ctlr = a;
	ilock(ctlr);
	cause = ctlr-&gt;lmmio[0x1d60/4];
//	dprint("sd%c: mv50interrupt: 0x%lux\n", ctlr-&gt;sdev-&gt;idno, cause);
	for(i=0; i&lt;ctlr-&gt;ndrive; i++)
		if(cause &amp; (3&lt;&lt;(i*2+i/4))){
			drive = &amp;ctlr-&gt;drive[i];
			if(drive-&gt;edma == 0)
				continue;	/* not ready yet. */
			ilock(drive);
			updatedrive(drive);
			while(ctlr-&gt;chip[i/4].arb-&gt;ic &amp; (0x0101 &lt;&lt; (i%4))){
				ctlr-&gt;chip[i/4].arb-&gt;ic = ~(0x101 &lt;&lt; (i%4));
				completesrb(drive);
			}
			iunlock(drive);
		}
	iunlock(ctlr);
}

enum{
	Nms		= 256,
	Midwait		= 16*1024/Nms-1,
	Mphywait	= 512/Nms-1,
};

static void
westerndigitalhung(Drive *d)
{
	Edma *e;

	e = d-&gt;edma;
	if(d-&gt;srb
	&amp;&amp; TK2MS(MACHP(0)-&gt;ticks-d-&gt;intick) &gt; 5*1000
	&amp;&amp; (e-&gt;rxo&amp;Rpidx) == (e-&gt;rxi&amp;Rpidx)){
		dprint("westerndigital drive hung; resetting\n");
		d-&gt;state = Dreset;
	}
}

static void
checkdrive(Drive *d, int i)
{
	static ulong s, olds[NCtlr*NCtlrdrv];
	char *name;

	ilock(d);
	name = d-&gt;unit-&gt;name;
	s = d-&gt;bridge-&gt;status;
	if(s != olds[i]){
		dprint("%s: status: %08lx -&gt; %08lx: %s\n", name, olds[i], s, diskstates[d-&gt;state]);
		olds[i] = s;
	}
	/* westerndigitalhung(d); */
	switch(d-&gt;state){
	case Dnew:
	case Dmissing:
		switch(s){
		case 0x000:
			break;
		default:
			dprint("%s: unknown state %8lx\n", name, s);
		case 0x100:
			if(++d-&gt;wait&amp;Mphywait)
				break;
		reset:	d-&gt;mode ^= 1;
			dprint("%s: reset; new mode %d\n", name, d-&gt;mode);
			resetdisk(d);
			break;
		case 0x123:
		case 0x113:
			s = d-&gt;edma-&gt;cmdstat;
			if(s == 0x7f || (s&amp;~ATAobs) != ATAdrdy){
				if((++d-&gt;wait&amp;Midwait) == 0)
					goto reset;
			}else if(identifydrive(d) == -1)
				goto reset;
		}
		break;
	case Dready:
		if(s != 0)
			break;
		iprint("%s: pulled: st=%08ulx\n", name, s);	/* never happens */
	case Dreset:
	case Derror:
		dprint("%s reset: mode %d\n", name, d-&gt;mode);
		resetdisk(d);
		break;
	}
	iunlock(d);
}

static void
satakproc(void*)
{
	int i;

	while(waserror())
		;

	for(;;){
		tsleep(&amp;up-&gt;sleep, return0, 0, Nms);
		for(i = 0; i &lt; nmvsatadrive; i++)
			checkdrive(mvsatadrive[i], i);
	}
}

/*
 * Device discovery
 */
static SDev*
mv50pnp(void)
{
	int i, nunit;
	uchar *base;
	ulong io, n, *mem;
	Ctlr *ctlr;
	Pcidev *p;
	SDev *head, *tail, *sdev;
	Drive *d;
	static int ctlrno, done;

	dprint("mv50pnp\n");
	if(done++)
		return nil;

	p = nil;
	head = nil;
	tail = nil;
	while((p = pcimatch(p, 0x11ab, 0)) != nil){
		switch(p-&gt;did){
		case 0x5040:
		case 0x5041:
		case 0x5080:
		case 0x5081:
		case 0x6041:
		case 0x6081:
			break;
		default:
			print("mv50pnp: unknown did %ux ignored\n", (ushort)p-&gt;did);
			continue;
		}
		if (ctlrno &gt;= NCtlr) {
			print("mv50pnp: too many controllers\n");
			break;
		}
		nunit = (p-&gt;did&amp;0xf0) &gt;&gt; 4;
		print("Marvell 88SX%ux: %d SATA-%s ports with%s flash\n",
			(ushort)p-&gt;did, nunit,
			((p-&gt;did&amp;0xf000)==0x6000? "II": "I"),
			(p-&gt;did&amp;1? "": "out"));
		if((sdev = malloc(sizeof(SDev))) == nil)
			continue;
		if((ctlr = malloc(sizeof(Ctlr))) == nil){
			free(sdev);
			continue;
		}
		memset(sdev, 0, sizeof *sdev);
		memset(ctlr, 0, sizeof *ctlr);

		io = p-&gt;mem[0].bar &amp; ~0x0F;
		mem = (ulong*)vmap(io, p-&gt;mem[0].size);
		if(mem == 0){
			print("sdmv50xx: address 0x%luX in use\n", io);
			free(sdev);
			free(ctlr);
			continue;
		}
		ctlr-&gt;rid = p-&gt;rid;

		/* avert thine eyes!  (what does this do?) */
		mem[0x104f0/4] = 0;
		ctlr-&gt;type = (p-&gt;did &gt;&gt; 12) &amp; 3;
		if(ctlr-&gt;type == 1){
			n = mem[0xc00/4];
			n &amp;= ~(3&lt;&lt;4);
			mem[0xc00/4] = n;
		}

		sdev-&gt;ifc = &amp;sdmv50xxifc;
		sdev-&gt;ctlr = ctlr;
		sdev-&gt;nunit = nunit;
		sdev-&gt;idno = 'E';
		ctlr-&gt;sdev = sdev;
		ctlr-&gt;irq = p-&gt;intl;
		ctlr-&gt;tbdf = p-&gt;tbdf;
		ctlr-&gt;pcidev = p;
		ctlr-&gt;lmmio = mem;
		ctlr-&gt;mmio = (uchar*)mem;
		ctlr-&gt;nchip = (nunit+3)/4;
		ctlr-&gt;ndrive = nunit;
		ctlr-&gt;enabled = 0;
		for(i = 0; i &lt; ctlr-&gt;nchip; i++){
			base = ctlr-&gt;mmio+0x20000+0x10000*i;
			ctlr-&gt;chip[i].arb = (Arb*)base;
			ctlr-&gt;chip[i].edma = (Edma*)(base + 0x2000);
		}
		for (i = 0; i &lt; nunit; i++) {
			d = &amp;ctlr-&gt;drive[i];
			d-&gt;sectors = 0;
			d-&gt;ctlr = ctlr;
			d-&gt;driveno = ctlrno*NCtlrdrv + i;
			d-&gt;chipx = i%4;
			d-&gt;chip = &amp;ctlr-&gt;chip[i/4];
			d-&gt;edma = &amp;d-&gt;chip-&gt;edma[d-&gt;chipx];
			mvsatadrive[d-&gt;driveno] = d;
		}
		nmvsatadrive += nunit;
		ctlrno++;
		if(head)
			tail-&gt;next = sdev;
		else
			head = sdev;
		tail = sdev;
	}
	return head;
}

/*
 * Enable the controller.  Each disk has its own interrupt mask,
 * and those get enabled as the disks are brought online.
 */
static int
mv50enable(SDev *sdev)
{
	char name[32];
	Ctlr *ctlr;

	dprint("sd%c: enable\n", sdev-&gt;idno);

	ctlr = sdev-&gt;ctlr;
	if (ctlr-&gt;enabled)
		return 1;
	snprint(name, sizeof name, "%s (%s)", sdev-&gt;name, sdev-&gt;ifc-&gt;name);
	intrenable(ctlr-&gt;irq, mv50interrupt, ctlr, ctlr-&gt;tbdf, name);
	ctlr-&gt;enabled = 1;
	return 1;
}

/*
 * Disable the controller.
 */
static int
mv50disable(SDev *sdev)
{
	char name[32];
	int i;
	Ctlr *ctlr;
	Drive *drive;

	dprint("sd%c: disable\n", sdev-&gt;idno);

	ctlr = sdev-&gt;ctlr;
	ilock(ctlr);
	for(i=0; i&lt;ctlr-&gt;sdev-&gt;nunit; i++){
		drive = &amp;ctlr-&gt;drive[i];
		ilock(drive);
		disabledrive(drive);
		iunlock(drive);
	}
	iunlock(ctlr);
	snprint(name, sizeof name, "%s (%s)", sdev-&gt;name, sdev-&gt;ifc-&gt;name);
	intrdisable(ctlr-&gt;irq, mv50interrupt, ctlr, ctlr-&gt;tbdf, name);
	return 0;
}

/*
 * Clean up all disk structures.  Already disabled.
 * Could keep count of number of allocated controllers
 * and free the srblist when it drops to zero.
 */
static void
mv50clear(SDev *sdev)
{
	int i;
	Ctlr *ctlr;
	Drive *d;

	dprint("sd%c: clear\n", sdev-&gt;idno);

	ctlr = sdev-&gt;ctlr;
	for(i=0; i&lt;ctlr-&gt;ndrive; i++){
		d = &amp;ctlr-&gt;drive[i];
		free(d-&gt;tx);
		free(d-&gt;rx);
		free(d-&gt;prd);
	}
	free(ctlr);
}

/*
 * Check that there is a disk or at least a hot swap bay in the drive.
 */
static int
mv50verify(SDunit *unit)
{
	Ctlr *ctlr;
	Drive *drive;
	int i;

	dprint("%s: verify\n", unit-&gt;name);
	ctlr = unit-&gt;dev-&gt;ctlr;
	drive = &amp;ctlr-&gt;drive[unit-&gt;subno];
	ilock(ctlr);
	ilock(drive);
	i = configdrive(ctlr, drive, unit);
	iunlock(drive);
	iunlock(ctlr);

	/*
	 * If ctlr-&gt;type == 1, then the drives spin up whenever
	 * the controller feels like it; if ctlr-&gt;type != 1, then
	 * they spin up as a result of configdrive.
	 *
	 * If there is a drive in the slot, give it 1.5s to spin up
	 * before returning.  There is a noticeable drag on the
	 * power supply when spinning up fifteen drives
	 * all at once (like in the Coraid enclosures).
	 */
	if(ctlr-&gt;type != 1 &amp;&amp; i == 0){
		if(!waserror()){
			tsleep(&amp;up-&gt;sleep, return0, 0, 1500);
			poperror();
		}
	}
	return 1;
}

/*
 * Check whether the disk is online.
 */
static int
mv50online(SDunit *unit)
{
	Ctlr *ctlr;
	Drive *d;
	int r, s0;
	static int once;

	if(once++ == 0)
		kproc("mvsata", satakproc, 0);

	ctlr = unit-&gt;dev-&gt;ctlr;
	d = &amp;ctlr-&gt;drive[unit-&gt;subno];
	r = 0;
	ilock(d);
	s0 = d-&gt;state;
	USED(s0);
	if(d-&gt;state == Dnew)
		identifydrive(d);
	if(d-&gt;mediachange){
		idprint("%s: online: %s -&gt; %s\n", unit-&gt;name, diskstates[s0], diskstates[d-&gt;state]);
		r = 2;
		unit-&gt;sectors = d-&gt;sectors;
		unit-&gt;secsize = 512;
		d-&gt;mediachange = 0;
	} else if(d-&gt;state == Dready)
		r = 1;
	iunlock(d);
	return r;
}

/*
 * Register dumps
 */
typedef struct Regs Regs;
struct Regs
{
	ulong offset;
	char *name;
};

static Regs regsctlr[] =
{
	0x0C28, "pci serr# mask",
	0x1D40, "pci err addr low",
	0x1D44, "pci err addr hi",
	0x1D48, "pci err attr",
	0x1D50, "pci err cmd",
	0x1D58, "pci intr cause",
	0x1D5C, "pci mask cause",
	0x1D60, "device micr",
	0x1D64, "device mimr",
};

static Regs regsarb[] =
{
	0x0004,	"arb rqop",
	0x0008,	"arb rqip",
	0x000C,	"arb ict",
	0x0010,	"arb itt",
	0x0014,	"arb ic",
	0x0018,	"arb btc",
	0x001C,	"arb bts",
	0x0020,	"arb bpc",
};

static Regs regsbridge[] =
{
	0x0000,	"bridge status",
	0x0004,	"bridge serror",
	0x0008,	"bridge sctrl",
	0x000C,	"bridge phyctrl",
	0x003C,	"bridge ctrl",
	0x0074,	"bridge phymode",
};

static Regs regsedma[] =
{
	0x0000,	"edma config",
	0x0004,	"edma timer",
	0x0008,	"edma iec",
	0x000C,	"edma iem",
	0x0010,	"edma txbasehi",
	0x0014,	"edma txi",
	0x0018,	"edma txo",
	0x001C,	"edma rxbasehi",
	0x0020,	"edma rxi",
	0x0024,	"edma rxo",
	0x0028,	"edma c",
	0x002C,	"edma tc",
	0x0030,	"edma status",
	0x0034,	"edma iordyto",
/*	0x0100,	"edma pio",
	0x0104,	"edma err",
	0x0108,	"edma sectors",
	0x010C,	"edma lba0",
	0x0110,	"edma lba1",
	0x0114,	"edma lba2",
	0x0118,	"edma lba3",
	0x011C,	"edma cmdstat",
	0x0120,	"edma altstat",
*/
};

static char*
rdregs(char *p, char *e, void *base, Regs *r, int n, char *prefix)
{
	int i;

	for(i = 0; i &lt; n; i++)
		p = seprint(p, e, "%s%s%-19s %.8lux\n",
			prefix? prefix: "", prefix? ": ": "",
			r[i].name, *(ulong *)((uchar*)base + r[i].offset));
	return p;
}

static char*
rdinfo(char *p, char *e, ushort *info)
{
	int i;

	p = seprint(p, e, "info");
	for(i = 0; i &lt; 256; i++)
		p = seprint(p, e, "%s%.4ux%s", i%8 == 0? "\t": "", info[i],
			i%8 == 7? "\n": "");
	return p;
}

static int
mv50rctl(SDunit *unit, char *p, int l)
{
	char *e, *op;
	Ctlr *ctlr;
	Drive *drive;

	if((ctlr = unit-&gt;dev-&gt;ctlr) == nil)
		return 0;
	drive = &amp;ctlr-&gt;drive[unit-&gt;subno];

	e = p+l;
	op = p;
	if(drive-&gt;state == Dready){
		p = seprint(p, e, "model    %s\n", drive-&gt;model);
		p = seprint(p, e, "serial   %s\n", drive-&gt;serial);
		p = seprint(p, e, "firmware %s\n", drive-&gt;firmware);
	}else
		p = seprint(p, e, "no disk present\n");
	p = seprint(p, e, "geometry %llud 512\n", drive-&gt;sectors);
	p = rdinfo(p, e, drive-&gt;info);

	p = rdregs(p, e, drive-&gt;chip-&gt;arb, regsarb, nelem(regsarb), nil);
	p = rdregs(p, e, drive-&gt;bridge, regsbridge, nelem(regsbridge), nil);
	p = rdregs(p, e, drive-&gt;edma, regsedma, nelem(regsedma), nil);

	return p-op;
}

static int
mv50wctl(SDunit *unit, Cmdbuf *cb)
{
	Ctlr *ctlr;
	Drive *drive;

	USED(unit);
	if(strcmp(cb-&gt;f[0], "reset") == 0){
		ctlr = unit-&gt;dev-&gt;ctlr;
		drive = &amp;ctlr-&gt;drive[unit-&gt;subno];
		ilock(drive);
		drive-&gt;state = Dreset;
		iunlock(drive);
		return 0;
	}
	cmderror(cb, Ebadctl);
	return -1;
}

/*
 * sd(3): ``Reading /dev/sdctl yields information about each controller,
 * one line per controller.''
 */
static char*
mv50rtopctl(SDev *sdev, char *p, char *e)
{
	char name[10];
	Ctlr *ctlr;

	ctlr = sdev-&gt;ctlr;
	if(ctlr == nil)
		return p;

	snprint(name, sizeof name, "sd%c", sdev-&gt;idno);
	p = rdregs(p, e, ctlr-&gt;mmio, regsctlr, nelem(regsctlr), name);
	if (Coraiddebug) {
		/* info for first disk.  BUG: this shouldn't be here. */
		p = rdregs(p, e, ctlr-&gt;chip[0].arb,
			regsarb, nelem(regsarb), name);
		p = rdregs(p, e, &amp;ctlr-&gt;chip[0].arb-&gt;bridge[0],
			regsbridge, nelem(regsbridge), name);
		p = rdregs(p, e, &amp;ctlr-&gt;chip[0].edma[0],
			regsedma, nelem(regsedma), name);
	}
	return p;
}

static int
waitready(Drive *d)
{
	ulong s, i;

	for(i = 0; i &lt; 120; i++){
		ilock(d);
		s = d-&gt;bridge-&gt;status;
		iunlock(d);
		if(s == 0)
			return SDeio;
		if (d-&gt;state == Dready)
			return SDok;
		if ((i+1)%60 == 0){
			ilock(d);
			resetdisk(d);
			iunlock(d);
		}
		if(!waserror()){
			tsleep(&amp;up-&gt;sleep, return0, 0, 1000);
			poperror();
		}
	}
	print("%s: not responding after 2 minutes\n", d-&gt;unit-&gt;name);
	return SDeio;
}

static int
mv50rio(SDreq *r)
{
	int count, max, n, status, try, flag;
	uchar *cmd, *data;
	uvlong lba;
	Ctlr *ctlr;
	Drive *drive;
	SDunit *unit;
	Srb *srb;

	unit = r-&gt;unit;
	ctlr = unit-&gt;dev-&gt;ctlr;
	drive = &amp;ctlr-&gt;drive[unit-&gt;subno];
	cmd = r-&gt;cmd;

	if((status = sdfakescsi(r, drive-&gt;info, sizeof drive-&gt;info)) != SDnostatus){
		/* XXX check for SDcheck here */
		r-&gt;status = status;
		return status;
	}

	switch(cmd[0]){
	case 0x28:	/* read */
	case 0x2A:	/* write */
		break;
	default:
		iprint("%s: bad cmd 0x%.2ux\n", drive-&gt;unit-&gt;name, cmd[0]);
		r-&gt;status = SDcheck;
		return SDcheck;
	}

	lba = (cmd[2]&lt;&lt;24)|(cmd[3]&lt;&lt;16)|(cmd[4]&lt;&lt;8)|cmd[5];
	count = (cmd[7]&lt;&lt;8)|cmd[8];
	if(r-&gt;data == nil)
		return SDok;
	if(r-&gt;dlen &lt; count*unit-&gt;secsize)
		count = r-&gt;dlen/unit-&gt;secsize;

	try = 0;
retry:
	if(waitready(drive) != SDok)
		return SDeio;
	/*
	 * Could arrange here to have an Srb always outstanding:
	 *
	 *	lsrb = nil;
	 *	while(count &gt; 0 || lsrb != nil){
	 *		srb = nil;
	 *		if(count &gt; 0){
	 *			srb = issue next srb;
	 *		}
	 *		if(lsrb){
	 *			sleep on lsrb and handle it
	 *		}
	 *	}
	 *
	 * On the disks I tried, this didn't help.  If anything,
	 * it's a little slower.		-rsc
	 */
	data = r-&gt;data;
	while(count &gt; 0){
		/*
		 * Max is 128 sectors (64kB) because prd-&gt;count is 16 bits.
		 */
		max = 128;
		n = count;
		if(n &gt; max)
			n = max;
		if((drive-&gt;edma-&gt;ctl&amp;eEnEDMA) == 0)
			goto tryagain;
		srb = srbrw(cmd[0]==0x28 ? SRBread : SRBwrite, drive, data, n, lba);
		ilock(drive);
		startsrb(drive, srb);
		iunlock(drive);

		/* Don't let user interrupt DMA. */
		while(waserror())
			;
		sleep(srb, srbdone, srb);
		poperror();

		flag = srb-&gt;flag;
		freesrb(srb);
		if(flag == 0){
tryagain:
			if(++try == 10){
				print("%s: bad disk\n", drive-&gt;unit-&gt;name);
				return SDeio;
			}
			dprint("%s: retry\n", drive-&gt;unit-&gt;name);
			if(!waserror()){
				tsleep(&amp;up-&gt;sleep, return0, 0, 1000);
				poperror();
			}
			goto retry;
		}
		if(flag &amp; SFerror){
			print("%s: i/o error\n", drive-&gt;unit-&gt;name);
			return SDeio;
		}
		count -= n;
		lba += n;
		data += n*unit-&gt;secsize;
	}
	r-&gt;rlen = data - (uchar*)r-&gt;data;
	return SDok;
}

SDifc sdmv50xxifc = {
	"mv50xx",			/* name */

	mv50pnp,			/* pnp */
	nil,				/* legacy */
	mv50enable,			/* enable */
	mv50disable,			/* disable */

	mv50verify,			/* verify */
	mv50online,			/* online */
	mv50rio,				/* rio */
	mv50rctl,			/* rctl */
	mv50wctl,			/* wctl */

	scsibio,			/* bio */
	nil,				/* probe */
	mv50clear,			/* clear */
	mv50rtopctl,			/* rtopctl */
};

/*
 * The original driver on which this one is based came with the
 * following notice:
 *
 * Copyright 2005
 * Coraid, Inc.
 *
 * This software is provided `as-is,' without any express or implied
 * warranty.  In no event will the author be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1.  The origin of this software must not be misrepresented; you must
 * not claim that you wrote the original software.  If you use this
 * software in a product, an acknowledgment in the product documentation
 * would be appreciated but is not required.
 *
 * 2.  Altered source versions must be plainly marked as such, and must
 * not be misrepresented as being the original software.
 *
 * 3.  This notice may not be removed or altered from any source
 * distribution.
 */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

