<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"tos.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"../port/error.h"
#include	&lt;trace.h&gt;

static int trapinited;

void	noted(Ureg*, ulong);

static void debugbpt(Ureg*, void*);
static void fault386(Ureg*, void*);
static void doublefault(Ureg*, void*);
static void unexpected(Ureg*, void*);
static void _dumpstack(Ureg*);

static Lock vctllock;
static Vctl *vctl[256];

enum
{
	Ntimevec = 20		/* number of time buckets for each intr */
};
ulong intrtimes[256][Ntimevec];

void
intrenable(int irq, void (*f)(Ureg*, void*), void* a, int tbdf, char *name)
{
	int vno;
	Vctl *v;

	if(f == nil){
		print("intrenable: nil handler for %d, tbdf 0x%uX for %s\n",
			irq, tbdf, name);
		return;
	}

	v = xalloc(sizeof(Vctl));
	v-&gt;isintr = 1;
	v-&gt;irq = irq;
	v-&gt;tbdf = tbdf;
	v-&gt;f = f;
	v-&gt;a = a;
	strncpy(v-&gt;name, name, KNAMELEN-1);
	v-&gt;name[KNAMELEN-1] = 0;

	ilock(&amp;vctllock);
	vno = arch-&gt;intrenable(v);
	if(vno == -1){
		iunlock(&amp;vctllock);
		print("intrenable: couldn't enable irq %d, tbdf 0x%uX for %s\n",
			irq, tbdf, v-&gt;name);
		xfree(v);
		return;
	}
	if(vctl[vno]){
		if(vctl[vno]-&gt;isr != v-&gt;isr || vctl[vno]-&gt;eoi != v-&gt;eoi)
			panic("intrenable: handler: %s %s %#p %#p %#p %#p",
				vctl[vno]-&gt;name, v-&gt;name,
				vctl[vno]-&gt;isr, v-&gt;isr, vctl[vno]-&gt;eoi, v-&gt;eoi);
		v-&gt;next = vctl[vno];
	}
	vctl[vno] = v;
	iunlock(&amp;vctllock);
}

int
intrdisable(int irq, void (*f)(Ureg *, void *), void *a, int tbdf, char *name)
{
	Vctl **pv, *v;
	int vno;

	/*
	 * For now, none of this will work with the APIC code,
	 * there is no mapping between irq and vector as the IRQ
	 * is pretty meaningless.
	 */
	if(arch-&gt;intrvecno == nil)
		return -1;
	vno = arch-&gt;intrvecno(irq);
	ilock(&amp;vctllock);
	pv = &amp;vctl[vno];
	while (*pv &amp;&amp;
		  ((*pv)-&gt;irq != irq || (*pv)-&gt;tbdf != tbdf || (*pv)-&gt;f != f || (*pv)-&gt;a != a ||
		   strcmp((*pv)-&gt;name, name)))
		pv = &amp;((*pv)-&gt;next);
	assert(*pv);

	v = *pv;
	*pv = (*pv)-&gt;next;	/* Link out the entry */

	if(vctl[vno] == nil &amp;&amp; arch-&gt;intrdisable != nil)
		arch-&gt;intrdisable(irq);
	iunlock(&amp;vctllock);
	xfree(v);
	return 0;
}

static long
irqallocread(Chan*, void *vbuf, long n, vlong offset)
{
	char *buf, *p, str[2*(11+1)+KNAMELEN+1+1];
	int m, vno;
	long oldn;
	Vctl *v;

	if(n &lt; 0 || offset &lt; 0)
		error(Ebadarg);

	oldn = n;
	buf = vbuf;
	for(vno=0; vno&lt;nelem(vctl); vno++){
		for(v=vctl[vno]; v; v=v-&gt;next){
			m = snprint(str, sizeof str, "%11d %11d %.*s\n", vno, v-&gt;irq, KNAMELEN, v-&gt;name);
			if(m &lt;= offset)	/* if do not want this, skip entry */
				offset -= m;
			else{
				/* skip offset bytes */
				m -= offset;
				p = str+offset;
				offset = 0;

				/* write at most max(n,m) bytes */
				if(m &gt; n)
					m = n;
				memmove(buf, p, m);
				n -= m;
				buf += m;

				if(n == 0)
					return oldn;
			}
		}
	}
	return oldn - n;
}

void
trapenable(int vno, void (*f)(Ureg*, void*), void* a, char *name)
{
	Vctl *v;

	if(vno &lt; 0 || vno &gt;= VectorPIC)
		panic("trapenable: vno %d", vno);
	v = xalloc(sizeof(Vctl));
	v-&gt;tbdf = BUSUNKNOWN;
	v-&gt;f = f;
	v-&gt;a = a;
	strncpy(v-&gt;name, name, KNAMELEN);
	v-&gt;name[KNAMELEN-1] = 0;

	ilock(&amp;vctllock);
	v-&gt;next = vctl[vno];
	vctl[vno] = v;
	iunlock(&amp;vctllock);
}

static void
nmienable(void)
{
	int x;

	/*
	 * Hack: should be locked with NVRAM access.
	 */
	outb(0x70, 0x80);		/* NMI latch clear */
	outb(0x70, 0);

	x = inb(0x61) &amp; 0x07;		/* Enable NMI */
	outb(0x61, 0x08|x);
	outb(0x61, x);
}

/*
 * Minimal trap setup.  Just enough so that we can panic
 * on traps (bugs) during kernel initialization.
 * Called very early - malloc is not yet available.
 */
void
trapinit0(void)
{
	int d1, v;
	ulong vaddr;
	Segdesc *idt;

	idt = (Segdesc*)IDTADDR;
	vaddr = (ulong)vectortable;
	for(v = 0; v &lt; 256; v++){
		d1 = (vaddr &amp; 0xFFFF0000)|SEGP;
		switch(v){

		case VectorBPT:
			d1 |= SEGPL(3)|SEGIG;
			break;

		case VectorSYSCALL:
			d1 |= SEGPL(3)|SEGIG;
			break;

		default:
			d1 |= SEGPL(0)|SEGIG;
			break;
		}
		idt[v].d0 = (vaddr &amp; 0xFFFF)|(KESEL&lt;&lt;16);
		idt[v].d1 = d1;
		vaddr += 6;
	}
}

void
trapinit(void)
{
	/*
	 * Special traps.
	 * Syscall() is called directly without going through trap().
	 */
	trapenable(VectorBPT, debugbpt, 0, "debugpt");
	trapenable(VectorPF, fault386, 0, "fault386");
	trapenable(Vector2F, doublefault, 0, "doublefault");
	trapenable(Vector15, unexpected, 0, "unexpected");
	nmienable();

	addarchfile("irqalloc", 0444, irqallocread, nil);
	trapinited = 1;
}

static char* excname[32] = {
	"divide error",
	"debug exception",
	"nonmaskable interrupt",
	"breakpoint",
	"overflow",
	"bounds check",
	"invalid opcode",
	"coprocessor not available",
	"double fault",
	"coprocessor segment overrun",
	"invalid TSS",
	"segment not present",
	"stack exception",
	"general protection violation",
	"page fault",
	"15 (reserved)",
	"coprocessor error",
	"alignment check",
	"machine check",
	"19 (reserved)",
	"20 (reserved)",
	"21 (reserved)",
	"22 (reserved)",
	"23 (reserved)",
	"24 (reserved)",
	"25 (reserved)",
	"26 (reserved)",
	"27 (reserved)",
	"28 (reserved)",
	"29 (reserved)",
	"30 (reserved)",
	"31 (reserved)",
};

/*
 *  keep histogram of interrupt service times
 */
void
intrtime(Mach*, int vno)
{
	ulong diff;
	ulong x;

	x = perfticks();
	diff = x - m-&gt;perf.intrts;
	m-&gt;perf.intrts = x;

	m-&gt;perf.inintr += diff;
	if(up == nil &amp;&amp; m-&gt;perf.inidle &gt; diff)
		m-&gt;perf.inidle -= diff;

	diff /= m-&gt;cpumhz*100;		/* quantum = 100µsec */
	if(diff &gt;= Ntimevec)
		diff = Ntimevec-1;
	intrtimes[vno][diff]++;
}

/* go to user space */
void
kexit(Ureg*)
{
	uvlong t;
	Tos *tos;

	/* precise time accounting, kernel exit */
	tos = (Tos*)(USTKTOP-sizeof(Tos));
	cycles(&amp;t);
	tos-&gt;kcycles += t - up-&gt;kentry;
	tos-&gt;pcycles = up-&gt;pcycles;
	tos-&gt;pid = up-&gt;pid;
}

/*
 *  All traps come here.  It is slower to have all traps call trap()
 *  rather than directly vectoring the handler.  However, this avoids a
 *  lot of code duplication and possible bugs.  The only exception is
 *  VectorSYSCALL.
 *  Trap is called with interrupts disabled via interrupt-gates.
 */
void
trap(Ureg* ureg)
{
	int clockintr, i, vno, user;
	char buf[ERRMAX];
	Vctl *ctl, *v;
	Mach *mach;

	if(!trapinited){
		/* fault386 can give a better error message */
		if(ureg-&gt;trap == VectorPF)
			fault386(ureg, nil);
		panic("trap %lud: not ready", ureg-&gt;trap);
	}

	m-&gt;perf.intrts = perfticks();
	user = (ureg-&gt;cs &amp; 0xFFFF) == UESEL;
	if(user){
		up-&gt;dbgreg = ureg;
		cycles(&amp;up-&gt;kentry);
	}

	clockintr = 0;

	vno = ureg-&gt;trap;
	if(ctl = vctl[vno]){
		if(ctl-&gt;isintr){
			m-&gt;intr++;
			if(vno &gt;= VectorPIC &amp;&amp; vno != VectorSYSCALL)
				m-&gt;lastintr = ctl-&gt;irq;
		}

		if(ctl-&gt;isr)
			ctl-&gt;isr(vno);
		for(v = ctl; v != nil; v = v-&gt;next){
			if(v-&gt;f)
				v-&gt;f(ureg, v-&gt;a);
		}
		if(ctl-&gt;eoi)
			ctl-&gt;eoi(vno);

		if(ctl-&gt;isintr){
			intrtime(m, vno);

			if(ctl-&gt;irq == IrqCLOCK || ctl-&gt;irq == IrqTIMER)
				clockintr = 1;

			if(up &amp;&amp; !clockintr)
				preempted();
		}
	}
	else if(vno &lt; nelem(excname) &amp;&amp; user){
		spllo();
		snprint(buf, sizeof buf, "sys: trap: %s", excname[vno]);
		postnote(up, 1, buf, NDebug);
	}
	else if(vno &gt;= VectorPIC &amp;&amp; vno != VectorSYSCALL){
		/*
		 * An unknown interrupt.
		 * Check for a default IRQ7. This can happen when
		 * the IRQ input goes away before the acknowledge.
		 * In this case, a 'default IRQ7' is generated, but
		 * the corresponding bit in the ISR isn't set.
		 * In fact, just ignore all such interrupts.
		 */

		/* call all interrupt routines, just in case */
		for(i = VectorPIC; i &lt;= MaxIrqLAPIC; i++){
			ctl = vctl[i];
			if(ctl == nil)
				continue;
			if(!ctl-&gt;isintr)
				continue;
			for(v = ctl; v != nil; v = v-&gt;next){
				if(v-&gt;f)
					v-&gt;f(ureg, v-&gt;a);
			}
			/* should we do this? */
			if(ctl-&gt;eoi)
				ctl-&gt;eoi(i);
		}

		/* clear the interrupt */
		i8259isr(vno);

		if(0)print("cpu%d: spurious interrupt %d, last %d\n",
			m-&gt;machno, vno, m-&gt;lastintr);
		if(0)if(conf.nmach &gt; 1){
			for(i = 0; i &lt; 32; i++){
				if(!(active.machs &amp; (1&lt;&lt;i)))
					continue;
				mach = MACHP(i);
				if(m-&gt;machno == mach-&gt;machno)
					continue;
				print(" cpu%d: last %d",
					mach-&gt;machno, mach-&gt;lastintr);
			}
			print("\n");
		}
		m-&gt;spuriousintr++;
		if(user)
			kexit(ureg);
		return;
	}
	else{
		if(vno == VectorNMI){
			/*
			 * Don't re-enable, it confuses the crash dumps.
			nmienable();
			 */
			iprint("cpu%d: NMI PC %#8.8lux\n", m-&gt;machno, ureg-&gt;pc);
			while(m-&gt;machno != 0)
				;
		}
		dumpregs(ureg);
		if(!user){
			ureg-&gt;sp = (ulong)&amp;ureg-&gt;sp;
			_dumpstack(ureg);
		}
		if(vno &lt; nelem(excname))
			panic("%s", excname[vno]);
		panic("unknown trap/intr: %d", vno);
	}
	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; clockintr){
		sched();
		splhi();
	}

	if(user){
		if(up-&gt;procctl || up-&gt;nnote)
			notify(ureg);
		kexit(ureg);
	}
}

/*
 *  dump registers
 */
void
dumpregs2(Ureg* ureg)
{
	if(up)
		iprint("cpu%d: registers for %s %lud\n",
			m-&gt;machno, up-&gt;text, up-&gt;pid);
	else
		iprint("cpu%d: registers for kernel\n", m-&gt;machno);
	iprint("FLAGS=%luX TRAP=%luX ECODE=%luX PC=%luX",
		ureg-&gt;flags, ureg-&gt;trap, ureg-&gt;ecode, ureg-&gt;pc);
	iprint(" SS=%4.4luX USP=%luX\n", ureg-&gt;ss &amp; 0xFFFF, ureg-&gt;usp);
	iprint("  AX %8.8luX  BX %8.8luX  CX %8.8luX  DX %8.8luX\n",
		ureg-&gt;ax, ureg-&gt;bx, ureg-&gt;cx, ureg-&gt;dx);
	iprint("  SI %8.8luX  DI %8.8luX  BP %8.8luX\n",
		ureg-&gt;si, ureg-&gt;di, ureg-&gt;bp);
	iprint("  CS %4.4luX  DS %4.4luX  ES %4.4luX  FS %4.4luX  GS %4.4luX\n",
		ureg-&gt;cs &amp; 0xFFFF, ureg-&gt;ds &amp; 0xFFFF, ureg-&gt;es &amp; 0xFFFF,
		ureg-&gt;fs &amp; 0xFFFF, ureg-&gt;gs &amp; 0xFFFF);
}

void
dumpregs(Ureg* ureg)
{
	vlong mca, mct;

	dumpregs2(ureg);

	/*
	 * Processor control registers.
	 * If machine check exception, time stamp counter, page size extensions
	 * or enhanced virtual 8086 mode extensions are supported, there is a
	 * CR4. If there is a CR4 and machine check extensions, read the machine
	 * check address and machine check type registers if RDMSR supported.
	 */
	iprint("  CR0 %8.8lux CR2 %8.8lux CR3 %8.8lux",
		getcr0(), getcr2(), getcr3());
	if(m-&gt;cpuiddx &amp; (Mce|Tsc|Pse|Vmex)){
		iprint(" CR4 %8.8lux", getcr4());
		if((m-&gt;cpuiddx &amp; (Mce|Cpumsr)) == (Mce|Cpumsr)){
			rdmsr(0x00, &amp;mca);
			rdmsr(0x01, &amp;mct);
			iprint("\n  MCA %8.8llux MCT %8.8llux", mca, mct);
		}
	}
	iprint("\n  ur %#p up %#p\n", ureg, up);
}


/*
 * Fill in enough of Ureg to get a stack trace, and call a function.
 * Used by debugging interface rdb.
 */
void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;
	ureg.pc = getcallerpc(&amp;fn);
	ureg.sp = (ulong)&amp;fn;
	fn(&amp;ureg);
}

static void
_dumpstack(Ureg *ureg)
{
	uintptr l, v, i, estack;
	extern ulong etext;
	int x;
	char *s;

	if((s = getconf("*nodumpstack")) != nil &amp;&amp; strcmp(s, "0") != 0){
		iprint("dumpstack disabled\n");
		return;
	}
	iprint("dumpstack\n");

	x = 0;
	x += iprint("ktrace /kernel/path %.8lux %.8lux &lt;&lt;EOF\n", ureg-&gt;pc, ureg-&gt;sp);
	i = 0;
	if(up
	&amp;&amp; (uintptr)&amp;l &gt;= (uintptr)up-&gt;kstack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)up-&gt;kstack+KSTACK)
		estack = (uintptr)up-&gt;kstack+KSTACK;
	else if((uintptr)&amp;l &gt;= (uintptr)m-&gt;stack
	&amp;&amp; (uintptr)&amp;l &lt;= (uintptr)m+MACHSIZE)
		estack = (uintptr)m+MACHSIZE;
	else
		return;
	x += iprint("estackx %p\n", estack);

	for(l = (uintptr)&amp;l; l &lt; estack; l += sizeof(uintptr)){
		v = *(uintptr*)l;
		if((KTZERO &lt; v &amp;&amp; v &lt; (uintptr)&amp;etext) || estack-l &lt; 32){
			/*
			 * Could Pick off general CALL (((uchar*)v)[-5] == 0xE8)
			 * and CALL indirect through AX
			 * (((uchar*)v)[-2] == 0xFF &amp;&amp; ((uchar*)v)[-2] == 0xD0),
			 * but this is too clever and misses faulting address.
			 */
			x += iprint("%.8p=%.8p ", l, v);
			i++;
		}
		if(i == 4){
			i = 0;
			x += iprint("\n");
		}
	}
	if(i)
		iprint("\n");
	iprint("EOF\n");

	if(ureg-&gt;trap != VectorNMI)
		return;

	i = 0;
	for(l = (uintptr)&amp;l; l &lt; estack; l += sizeof(uintptr)){
		iprint("%.8p ", *(uintptr*)l);
		if(++i == 8){
			i = 0;
			iprint("\n");
		}
	}
	if(i)
		iprint("\n");
}

void
dumpstack(void)
{
	callwithureg(_dumpstack);
}

static void
debugbpt(Ureg* ureg, void*)
{
	char buf[ERRMAX];

	if(up == 0)
		panic("kernel bpt");
	/* restore pc to instruction that caused the trap */
	ureg-&gt;pc--;
	snprint(buf, sizeof buf, "sys: breakpoint");
	postnote(up, 1, buf, NDebug);
}

static void
doublefault(Ureg*, void*)
{
	panic("double fault");
}

static void
unexpected(Ureg* ureg, void*)
{
	print("unexpected trap %lud; ignoring\n", ureg-&gt;trap);
}

extern void checkpages(void);
extern void checkfault(ulong, ulong);
static void
fault386(Ureg* ureg, void*)
{
	ulong addr;
	int read, user, n, insyscall;
	char buf[ERRMAX];

	addr = getcr2();
	read = !(ureg-&gt;ecode &amp; 2);

	user = (ureg-&gt;cs &amp; 0xFFFF) == UESEL;
	if(!user){
		if(vmapsync(addr))
			return;
		if(addr &gt;= USTKTOP)
			panic("kernel fault: bad address pc=0x%.8lux addr=0x%.8lux", ureg-&gt;pc, addr);
		if(up == nil)
			panic("kernel fault: no user process pc=0x%.8lux addr=0x%.8lux", ureg-&gt;pc, addr);
	}
	if(up == nil)
		panic("user fault: up=0 pc=0x%.8lux addr=0x%.8lux", ureg-&gt;pc, addr);

	insyscall = up-&gt;insyscall;
	up-&gt;insyscall = 1;
	n = fault(addr, read);
	if(n &lt; 0){
		if(!user){
			dumpregs(ureg);
			panic("fault: 0x%lux", addr);
		}
		checkpages();
		checkfault(addr, ureg-&gt;pc);
		snprint(buf, sizeof buf, "sys: trap: fault %s addr=0x%lux",
			read ? "read" : "write", addr);
		postnote(up, 1, buf, NDebug);
	}
	up-&gt;insyscall = insyscall;
}

/*
 *  system calls
 */
#include "../port/systab.h"

/*
 *  Syscall is called directly from assembler without going through trap().
 */
void
syscall(Ureg* ureg)
{
	char *e;
	ulong	sp;
	long	ret;
	int	i, s;
	ulong scallnr;
	vlong startns, stopns;

	if((ureg-&gt;cs &amp; 0xFFFF) != UESEL)
		panic("syscall: cs 0x%4.4luX", ureg-&gt;cs);

	cycles(&amp;up-&gt;kentry);

	m-&gt;syscall++;
	up-&gt;insyscall = 1;
	up-&gt;pc = ureg-&gt;pc;
	up-&gt;dbgreg = ureg;

	sp = ureg-&gt;usp;
	scallnr = ureg-&gt;ax;
	up-&gt;scallnr = scallnr;

	if(up-&gt;procctl == Proc_tracesyscall){
		/*
		 * Redundant validaddr.  Do we care?
		 * Tracing syscalls is not exactly a fast path...
		 * Beware, validaddr currently does a pexit rather
		 * than an error if there's a problem; that might
		 * change in the future.
		 */
		if(sp &lt; (USTKTOP-BY2PG) || sp &gt; (USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		syscallfmt(scallnr, ureg-&gt;pc, (va_list)(sp+BY2WD));
		up-&gt;procctl = Proc_stopme;
		procctl(up);
		if(up-&gt;syscalltrace)
			free(up-&gt;syscalltrace);
		up-&gt;syscalltrace = nil;
		startns = todget(nil);
	}

	if(scallnr == RFORK &amp;&amp; up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
	spllo();

	up-&gt;nerrlab = 0;
	ret = -1;
	if(!waserror()){
		if(scallnr &gt;= nsyscall || systab[scallnr] == 0){
			pprint("bad sys call number %lud pc %lux\n",
				scallnr, ureg-&gt;pc);
			postnote(up, 1, "sys: bad sys call", NDebug);
			error(Ebadarg);
		}

		if(sp&lt;(USTKTOP-BY2PG) || sp&gt;(USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		up-&gt;s = *((Sargs*)(sp+BY2WD));
		up-&gt;psstate = sysctab[scallnr];

		ret = systab[scallnr](up-&gt;s.args);
		poperror();
	}else{
		/* failure: save the error buffer for errstr */
		e = up-&gt;syserrstr;
		up-&gt;syserrstr = up-&gt;errstr;
		up-&gt;errstr = e;
		if(0 &amp;&amp; up-&gt;pid == 1)
			print("syscall %lud error %s\n", scallnr, up-&gt;syserrstr);
	}
	if(up-&gt;nerrlab){
		print("bad errstack [%lud]: %d extra\n", scallnr, up-&gt;nerrlab);
		for(i = 0; i &lt; NERR; i++)
			print("sp=%lux pc=%lux\n",
				up-&gt;errlab[i].sp, up-&gt;errlab[i].pc);
		panic("error stack");
	}

	/*
	 *  Put return value in frame.  On the x86 the syscall is
	 *  just another trap and the return value from syscall is
	 *  ignored.  On other machines the return value is put into
	 *  the results register by caller of syscall.
	 */
	ureg-&gt;ax = ret;

	if(up-&gt;procctl == Proc_tracesyscall){
		stopns = todget(nil);
		up-&gt;procctl = Proc_stopme;
		sysretfmt(scallnr, (va_list)(sp+BY2WD), ret, startns, stopns);
		s = splhi();
		procctl(up);
		splx(s);
		if(up-&gt;syscalltrace)
			free(up-&gt;syscalltrace);
		up-&gt;syscalltrace = nil;
	}

	up-&gt;insyscall = 0;
	up-&gt;psstate = 0;

	if(scallnr == NOTED)
		noted(ureg, *(ulong*)(sp+BY2WD));

	if(scallnr!=RFORK &amp;&amp; (up-&gt;procctl || up-&gt;nnote)){
		splhi();
		notify(ureg);
	}
	/* if we delayed sched because we held a lock, sched now */
	if(up-&gt;delaysched)
		sched();
	kexit(ureg);
}

/*
 *  Call user, if necessary, with note.
 *  Pass user the Ureg struct and the note on his stack.
 */
int
notify(Ureg* ureg)
{
	int l;
	ulong s, sp;
	Note *n;

	if(up-&gt;procctl)
		procctl(up);
	if(up-&gt;nnote == 0)
		return 0;

	if(up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
	up-&gt;fpstate |= FPillegal;

	s = spllo();
	qlock(&amp;up-&gt;debug);
	up-&gt;notepending = 0;
	n = &amp;up-&gt;note[0];
	if(strncmp(n-&gt;msg, "sys:", 4) == 0){
		l = strlen(n-&gt;msg);
		if(l &gt; ERRMAX-15)	/* " pc=0x12345678\0" */
			l = ERRMAX-15;
		seprint(n-&gt;msg+l, &amp;n-&gt;msg[sizeof n-&gt;msg], " pc=0x%.8lux",
			ureg-&gt;pc);
	}

	if(n-&gt;flag!=NUser &amp;&amp; (up-&gt;notified || up-&gt;notify==0)){
		if(n-&gt;flag == NDebug)
			pprint("suicide: %s\n", n-&gt;msg);
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}

	if(up-&gt;notified){
		qunlock(&amp;up-&gt;debug);
		splhi();
		return 0;
	}

	if(!up-&gt;notify){
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}
	sp = ureg-&gt;usp;
	sp -= 256;	/* debugging: preserve context causing problem */
	sp -= sizeof(Ureg);
if(0) print("%s %lud: notify %.8lux %.8lux %.8lux %s\n",
	up-&gt;text, up-&gt;pid, ureg-&gt;pc, ureg-&gt;usp, sp, n-&gt;msg);

	if(!okaddr((ulong)up-&gt;notify, 1, 0)
	|| !okaddr(sp-ERRMAX-4*BY2WD, sizeof(Ureg)+ERRMAX+4*BY2WD, 1)){
		qunlock(&amp;up-&gt;debug);
		pprint("suicide: bad address in notify\n");
		pexit("Suicide", 0);
	}

	memmove((Ureg*)sp, ureg, sizeof(Ureg));
	*(Ureg**)(sp-BY2WD) = up-&gt;ureg;	/* word under Ureg is old up-&gt;ureg */
	up-&gt;ureg = (void*)sp;
	sp -= BY2WD+ERRMAX;
	memmove((char*)sp, up-&gt;note[0].msg, ERRMAX);
	sp -= 3*BY2WD;
	*(ulong*)(sp+2*BY2WD) = sp+3*BY2WD;		/* arg 2 is string */
	*(ulong*)(sp+1*BY2WD) = (ulong)up-&gt;ureg;	/* arg 1 is ureg* */
	*(ulong*)(sp+0*BY2WD) = 0;			/* arg 0 is pc */
	ureg-&gt;usp = sp;
	ureg-&gt;pc = (ulong)up-&gt;notify;
	up-&gt;notified = 1;
	up-&gt;nnote--;
	memmove(&amp;up-&gt;lastnote, &amp;up-&gt;note[0], sizeof(Note));
	memmove(&amp;up-&gt;note[0], &amp;up-&gt;note[1], up-&gt;nnote*sizeof(Note));

	qunlock(&amp;up-&gt;debug);
	splx(s);
	return 1;
}

/*
 *   Return user to state before notify()
 */
void
noted(Ureg* ureg, ulong arg0)
{
	Ureg *nureg;
	ulong oureg, sp;

	qlock(&amp;up-&gt;debug);
	if(arg0!=NRSTR &amp;&amp; !up-&gt;notified) {
		qunlock(&amp;up-&gt;debug);
		pprint("call to noted() when not notified\n");
		pexit("Suicide", 0);
	}
	up-&gt;notified = 0;

	nureg = up-&gt;ureg;	/* pointer to user returned Ureg struct */

	up-&gt;fpstate &amp;= ~FPillegal;

	/* sanity clause */
	oureg = (ulong)nureg;
	if(!okaddr((ulong)oureg-BY2WD, BY2WD+sizeof(Ureg), 0)){
		qunlock(&amp;up-&gt;debug);
		pprint("bad ureg in noted or call to noted when not notified\n");
		pexit("Suicide", 0);
	}

	/*
	 * Check the segment selectors are all valid, otherwise
	 * a fault will be taken on attempting to return to the
	 * user process.
	 * Take care with the comparisons as different processor
	 * generations push segment descriptors in different ways.
	 */
	if((nureg-&gt;cs &amp; 0xFFFF) != UESEL || (nureg-&gt;ss &amp; 0xFFFF) != UDSEL
	  || (nureg-&gt;ds &amp; 0xFFFF) != UDSEL || (nureg-&gt;es &amp; 0xFFFF) != UDSEL
	  || (nureg-&gt;fs &amp; 0xFFFF) != UDSEL || (nureg-&gt;gs &amp; 0xFFFF) != UDSEL){
		qunlock(&amp;up-&gt;debug);
		pprint("bad segment selector in noted\n");
		pexit("Suicide", 0);
	}

	/* don't let user change system flags */
	nureg-&gt;flags = (ureg-&gt;flags &amp; ~0xCD5) | (nureg-&gt;flags &amp; 0xCD5);

	memmove(ureg, nureg, sizeof(Ureg));

	switch(arg0){
	case NCONT:
	case NRSTR:
if(0) print("%s %lud: noted %.8lux %.8lux\n",
	up-&gt;text, up-&gt;pid, nureg-&gt;pc, nureg-&gt;usp);
		if(!okaddr(nureg-&gt;pc, 1, 0) || !okaddr(nureg-&gt;usp, BY2WD, 0)){
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: trap in noted\n");
			pexit("Suicide", 0);
		}
		up-&gt;ureg = (Ureg*)(*(ulong*)(oureg-BY2WD));
		qunlock(&amp;up-&gt;debug);
		break;

	case NSAVE:
		if(!okaddr(nureg-&gt;pc, BY2WD, 0)
		|| !okaddr(nureg-&gt;usp, BY2WD, 0)){
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: trap in noted\n");
			pexit("Suicide", 0);
		}
		qunlock(&amp;up-&gt;debug);
		sp = oureg-4*BY2WD-ERRMAX;
		splhi();
		ureg-&gt;sp = sp;
		((ulong*)sp)[1] = oureg;	/* arg 1 0(FP) is ureg* */
		((ulong*)sp)[0] = 0;		/* arg 0 is pc */
		break;

	default:
		pprint("unknown noted arg 0x%lux\n", arg0);
		up-&gt;lastnote.flag = NDebug;
		/* fall through */

	case NDFLT:
		if(up-&gt;lastnote.flag == NDebug){
			qunlock(&amp;up-&gt;debug);
			pprint("suicide: %s\n", up-&gt;lastnote.msg);
		} else
			qunlock(&amp;up-&gt;debug);
		pexit(up-&gt;lastnote.msg, up-&gt;lastnote.flag!=NDebug);
	}
}

void
validalign(uintptr addr, unsigned align)
{
	/*
	 * Plan 9 is a 32-bit O/S, and the hardware it runs on
	 * does not usually have instructions which move 64-bit
	 * quantities directly, synthesizing the operations
	 * with 32-bit move instructions. Therefore, the compiler
	 * (and hardware) usually only enforce 32-bit alignment,
	 * if at all.
	 *
	 * Take this out if the architecture warrants it.
	 */
	if(align == sizeof(vlong))
		align = sizeof(long);

	/*
	 * Check align is a power of 2, then addr alignment.
	 */
	if((align != 0 &amp;&amp; !(align &amp; (align-1))) &amp;&amp; !(addr &amp; (align-1)))
		return;
	postnote(up, 1, "sys: odd address", NDebug);
	error(Ebadarg);
	/*NOTREACHED*/
}

long
execregs(ulong entry, ulong ssize, ulong nargs)
{
	ulong *sp;
	Ureg *ureg;

	up-&gt;fpstate = FPinit;
	fpoff();

	sp = (ulong*)(USTKTOP - ssize);
	*--sp = nargs;

	ureg = up-&gt;dbgreg;
	ureg-&gt;usp = (ulong)sp;
	ureg-&gt;pc = entry;
	return USTKTOP-sizeof(Tos);		/* address of kernel/user shared data */
}

/*
 *  return the userpc the last exception happened at
 */
ulong
userpc(void)
{
	Ureg *ureg;

	ureg = (Ureg*)up-&gt;dbgreg;
	return ureg-&gt;pc;
}

/* This routine must save the values of registers the user is not permitted
 * to write from devproc and then restore the saved values before returning.
 */
void
setregisters(Ureg* ureg, char* pureg, char* uva, int n)
{
	ulong cs, ds, es, flags, fs, gs, ss;

	ss = ureg-&gt;ss;
	flags = ureg-&gt;flags;
	cs = ureg-&gt;cs;
	ds = ureg-&gt;ds;
	es = ureg-&gt;es;
	fs = ureg-&gt;fs;
	gs = ureg-&gt;gs;
	memmove(pureg, uva, n);
	ureg-&gt;gs = gs;
	ureg-&gt;fs = fs;
	ureg-&gt;es = es;
	ureg-&gt;ds = ds;
	ureg-&gt;cs = cs;
	ureg-&gt;flags = (ureg-&gt;flags &amp; 0x00FF) | (flags &amp; 0xFF00);
	ureg-&gt;ss = ss;
}

static void
linkproc(void)
{
	spllo();
	up-&gt;kpfun(up-&gt;kparg);
	pexit("kproc dying", 0);
}

void
kprocchild(Proc* p, void (*func)(void*), void* arg)
{
	/*
	 * gotolabel() needs a word on the stack in
	 * which to place the return PC used to jump
	 * to linkproc().
	 */
	p-&gt;sched.pc = (ulong)linkproc;
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-BY2WD;

	p-&gt;kpfun = func;
	p-&gt;kparg = arg;
}

void
forkchild(Proc *p, Ureg *ureg)
{
	Ureg *cureg;

	/*
	 * Add 2*BY2WD to the stack to account for
	 *  - the return PC
	 *  - trap's argument (ur)
	 */
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-(sizeof(Ureg)+2*BY2WD);
	p-&gt;sched.pc = (ulong)forkret;

	cureg = (Ureg*)(p-&gt;sched.sp+2*BY2WD);
	memmove(cureg, ureg, sizeof(Ureg));
	/* return value of syscall in child */
	cureg-&gt;ax = 0;

	/* Things from bottom of syscall which were never executed */
	p-&gt;psstate = 0;
	p-&gt;insyscall = 0;
}

/* Give enough context in the ureg to produce a kernel stack for
 * a sleeping process
 */
void
setkernur(Ureg* ureg, Proc* p)
{
	ureg-&gt;pc = p-&gt;sched.pc;
	ureg-&gt;sp = p-&gt;sched.sp+4;
}

ulong
dbgpc(Proc *p)
{
	Ureg *ureg;

	ureg = p-&gt;dbgreg;
	if(ureg == 0)
		return 0;

	return ureg-&gt;pc;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

