<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/uartaxp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/uartaxp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Avanstar Xp pci uart driver
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#include "uartaxp.i"

typedef struct Cc Cc;
typedef struct Ccb Ccb;
typedef struct Ctlr Ctlr;
typedef struct Gcb Gcb;

/*
 * Global Control Block.
 * Service Request fields must be accessed using XCHG.
 */
struct Gcb {
	u16int	gcw;				/* Global Command Word */
	u16int	gsw;				/* Global Status Word */
	u16int	gsr;				/* Global Service Request */
	u16int	abs;				/* Available Buffer Space */
	u16int	bt;				/* Board Type */
	u16int	cpv;				/* Control Program Version */
	u16int	ccbn;				/* Ccb count */
	u16int	ccboff;				/* Ccb offset */
	u16int	ccbsz;				/* Ccb size */
	u16int	gcw2;				/* Global Command Word 2 */
	u16int	gsw2;				/* Global Status Word 2 */
	u16int	esr;				/* Error Service Request */
	u16int	isr;				/* Input Service Request */
	u16int	osr;				/* Output Service Request */
	u16int	msr;				/* Modem Service Request */
	u16int	csr;				/* Command Service Request */
};

/*
 * Channel Control Block.
 */
struct Ccb {
	u16int	br;				/* Baud Rate */
	u16int	df;				/* Data Format */
	u16int	lp;				/* Line Protocol */
	u16int	ibs;				/* Input Buffer Size */
	u16int	obs;				/* Output Buffer Size */
	u16int 	ibtr;				/* Ib Trigger Rate */
	u16int	oblw;				/* Ob Low Watermark */
	u8int	ixon[2];			/* IXON characters */
	u16int	ibhw;				/* Ib High Watermark */
	u16int	iblw;				/* Ib Low Watermark */
	u16int	cc;				/* Channel Command */
	u16int	cs;				/* Channel Status */
	u16int	ibsa;				/* Ib Start Addr */
	u16int 	ibea;				/* Ib Ending Addr */
	u16int	obsa;				/* Ob Start Addr */
	u16int 	obea;				/* Ob Ending Addr */
	u16int	ibwp;				/* Ib write pointer (RO) */
	u16int	ibrp;				/* Ib read pointer (R/W) */
	u16int	obwp;				/* Ob write pointer (R/W) */
	u16int	obrp;				/* Ob read pointer (RO) */
	u16int	ces;				/* Communication Error Status */
	u16int	bcp;				/* Bad Character Pointer */
	u16int	mc;				/* Modem Control */
	u16int	ms;				/* Modem Status */
	u16int	bs;				/* Blocking Status */
	u16int	crf;				/* Character Received Flag */
	u8int	ixoff[2];			/* IXOFF characters */
	u16int	cs2;				/* Channel Status 2 */
	u8int	sec[2];				/* Strip/Error Characters */
};

enum {						/* br */
	Br76800		= 0xFF00,
	Br115200	= 0xFF01,
};

enum {						/* df */
	Db5		= 0x0000,		/* Data Bits - 5 bits/byte */
	Db6		= 0x0001,		/*	6 bits/byte */
	Db7		= 0x0002,		/*	7 bits/byte */
	Db8		= 0x0003,		/*	8 bits/byte */
	DbMASK		= 0x0003,
	Sb1		= 0x0000,		/* 1 Stop Bit */
	Sb2		= 0x0004,		/* 2 Stop Bit */
	SbMASK		= 0x0004,
	Np		= 0x0000,		/* No Parity */
	Op		= 0x0008,		/* Odd Parity */
	Ep		= 0x0010,		/* Even Parity */
	Mp		= 0x0020,		/* Mark Parity */
	Sp		= 0x0030,		/* Space Parity */
	PMASK		= 0x0038,
	Cmn		= 0x0000,		/* Channel Mode Normal */
	Cme		= 0x0040,		/* CM Echo */
	Cmll		= 0x0080,		/* CM Local Loopback */
	Cmrl		= 0x00C0,		/* CM Remote Loopback */
};

enum {						/* lp */
	Ixon		= 0x0001,		/* Obey IXON/IXOFF */
	Ixany		= 0x0002,		/* Any character retarts Tx */
	Ixgen		= 0x0004,		/* Generate IXON/IXOFF  */
	Cts		= 0x0008,		/* CTS controls Tx */
	Dtr		= 0x0010,		/* Rx controls DTR */
	½d		= 0x0020,		/* RTS off during Tx */
	Rts		= 0x0040,		/* generate RTS */
	Emcs		= 0x0080,		/* Enable Modem Control */
	Ecs		= 0x1000,		/* Enable Character Stripping */
	Eia422		= 0x2000,		/* EIA422 */
};

enum {						/* cc */
	Ccu		= 0x0001,		/* Configure Channel and UART */
	Cco		= 0x0002,		/* Configure Channel Only */
	Fib		= 0x0004,		/* Flush Input Buffer */
	Fob		= 0x0008,		/* Flush Output Buffer */
	Er		= 0x0010,		/* Enable Receiver */
	Dr		= 0x0020,		/* Disable Receiver */
	Et		= 0x0040,		/* Enable Transmitter */
	Dt		= 0x0080,		/* Disable Transmitter */
};

enum {						/* ces */
	Oe		= 0x0001,		/* Overrun Error */
	Pe		= 0x0002,		/* Parity Error */
	Fe		= 0x0004,		/* Framing Error */
	Br		= 0x0008,		/* Break Received */
};

enum {						/* mc */
	Adtr		= 0x0001,		/* Assert DTR */
	Arts		= 0x0002,		/* Assert RTS */
	Ab		= 0x0010,		/* Assert BREAK */
};

enum {						/* ms */
	Scts		= 0x0001,		/* Status od CTS */
	Sdsr		= 0x0002,		/* Status of DSR */
	Sri		= 0x0004,		/* Status of RI */
	Sdcd		= 0x0008,		/* Status of DCD */
};

enum {						/* bs */
	Rd		= 0x0001,		/* Receiver Disabled */
	Td		= 0x0002,		/* Transmitter Disabled */
	Tbxoff		= 0x0004,		/* Tx Blocked by XOFF */
	Tbcts		= 0x0008,		/* Tx Blocked by CTS */
	Rbxoff		= 0x0010,		/* Rx Blocked by XOFF */
	Rbrts		= 0x0020,		/* Rx Blocked by RTS */
};

enum {						/* Local Configuration */
	Range		= 0x00,
	Remap		= 0x04,
	Region		= 0x18,
	Mb0		= 0x40,			/* Mailbox 0 */
	Ldb		= 0x60,			/* PCI to Local Doorbell */
	Pdb		= 0x64,			/* Local to PCI Doorbell */
	Ics		= 0x68,			/* Interrupt Control/Status */
	Mcc		= 0x6C,			/* Misc. Command and Control */
};

enum {						/* Mb0 */
	Edcc		= 1,			/* exec. downloaded code cmd */
	Aic		= 0x10,			/* adapter init'zed correctly */
	Cpr		= 1ul &lt;&lt; 31,		/* control program ready */
};

enum {						/* Mcc */
	Rcr		= 1ul &lt;&lt; 29,		/* reload config. reg.s */
	Asr		= 1ul &lt;&lt; 30,		/* pci adapter sw reset */
	Lis		= 1ul &lt;&lt; 31,		/* local init status */
};

typedef struct Cc Cc;
typedef struct Ccb Ccb;
typedef struct Ctlr Ctlr;

/*
 * Channel Control, one per uart.
 * Devuart communicates via the PhysUart functions with
 * a Uart* argument. Uart.regs is filled in by this driver
 * to point to a Cc, and Cc.ctlr points to the Axp board
 * controller.
 */
struct Cc {
	int	uartno;
	Ccb*	ccb;
	Ctlr*	ctlr;

	Rendez;

	Uart;
};

typedef struct Ctlr {
	char*	name;
	Pcidev*	pcidev;
	int	ctlrno;
	Ctlr*	next;

	u32int*	reg;
	uchar*	mem;
	Gcb*	gcb;

	int	im;		/* interrupt mask */
	Cc	cc[16];
} Ctlr;

#define csr32r(c, r)	(*((c)-&gt;reg+((r)/4)))
#define csr32w(c, r, v)	(*((c)-&gt;reg+((r)/4)) = (v))

static Ctlr* axpctlrhead;
static Ctlr* axpctlrtail;

extern PhysUart axpphysuart;

static int
axpccdone(void* ccb)
{
	return !((Ccb*)ccb)-&gt;cc;	/* hw sets ccb-&gt;cc to zero */
}

static void
axpcc(Cc* cc, int cmd)
{
	Ccb *ccb;
	int timeo;
	u16int cs;

	ccb = cc-&gt;ccb;
	ccb-&gt;cc = cmd;

	if(!cc-&gt;ctlr-&gt;im)
		for(timeo = 0; timeo &lt; 1000000; timeo++){
			if(!ccb-&gt;cc)
				break;
			microdelay(1);
		}
	else
		tsleep(cc, axpccdone, ccb, 1000);

	cs = ccb-&gt;cs;
	if(ccb-&gt;cc || cs){
		print("%s: cmd %#ux didn't terminate: %#ux %#ux\n",
			cc-&gt;name, cmd, ccb-&gt;cc, cs);
		if(cc-&gt;ctlr-&gt;im)
			error(Eio);
	}
}

static long
axpstatus(Uart* uart, void* buf, long n, long offset)
{
	char *p;
	Ccb *ccb;
	u16int bs, fstat, ms;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;
	bs = ccb-&gt;bs;
	fstat = ccb-&gt;df;
	ms = ccb-&gt;ms;

	snprint(p, READSTR,
		"b%d c%d d%d e%d l%d m%d p%c r%d s%d i%d\n"
		"dev(%d) type(%d) framing(%d) overruns(%d) "
		"berr(%d) serr(%d)%s%s%s%s\n",

		uart-&gt;baud,
		uart-&gt;hup_dcd,
		ms &amp; Sdsr,
		uart-&gt;hup_dsr,
		(fstat &amp; DbMASK) + 5,
		0,
		(fstat &amp; PMASK) ? ((fstat &amp; Ep) == Ep? 'e': 'o'): 'n',
		(bs &amp; Rbrts) ? 1 : 0,
		(fstat &amp; Sb2) ? 2 : 1,
		0,

		uart-&gt;dev,
		uart-&gt;type,
		uart-&gt;ferr,
		uart-&gt;oerr,
		uart-&gt;berr,
		uart-&gt;serr,
		(ms &amp; Scts) ? " cts"  : "",
		(ms &amp; Sdsr) ? " dsr"  : "",
		(ms &amp; Sdcd) ? " dcd"  : "",
		(ms &amp; Sri) ? " ring" : ""
	);
	n = readstr(offset, buf, n, p);
	free(p);

	return n;
}

static void
axpfifo(Uart*, int)
{
}

static void
axpdtr(Uart* uart, int on)
{
	Ccb *ccb;
	u16int mc;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	mc = ccb-&gt;mc;
	if(on)
		mc |= Adtr;
	else
		mc &amp;= ~Adtr;
	ccb-&gt;mc = mc;
}

/*
 * can be called from uartstageinput() during an input interrupt,
 * with uart-&gt;rlock ilocked or the uart qlocked, sometimes both.
 */
static void
axprts(Uart* uart, int on)
{
	Ccb *ccb;
	u16int mc;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	mc = ccb-&gt;mc;
	if(on)
		mc |= Arts;
	else
		mc &amp;= ~Arts;
	ccb-&gt;mc = mc;
}

static void
axpmodemctl(Uart* uart, int on)
{
	Ccb *ccb;
	u16int lp;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	ilock(&amp;uart-&gt;tlock);
	lp = ccb-&gt;lp;
	if(on){
		lp |= Cts|Rts;
		lp &amp;= ~Emcs;
		uart-&gt;cts = ccb-&gt;ms &amp; Scts;
	}
	else{
		lp &amp;= ~(Cts|Rts);
		lp |= Emcs;
		uart-&gt;cts = 1;
	}
	uart-&gt;modem = on;
	iunlock(&amp;uart-&gt;tlock);

	ccb-&gt;lp = lp;
	axpcc(uart-&gt;regs, Ccu);
}

static int
axpparity(Uart* uart, int parity)
{
	Ccb *ccb;
	u16int df;

	switch(parity){
	default:
		return -1;
	case 'e':
		parity = Ep;
		break;
	case 'o':
		parity = Op;
		break;
	case 'n':
		parity = Np;
		break;
	}

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	df = ccb-&gt;df &amp; ~PMASK;
	ccb-&gt;df = df|parity;
	axpcc(uart-&gt;regs, Ccu);

	return 0;
}

static int
axpstop(Uart* uart, int stop)
{
	Ccb *ccb;
	u16int df;

	switch(stop){
	default:
		return -1;
	case 1:
		stop = Sb1;
		break;
	case 2:
		stop = Sb2;
		break;
	}

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	df = ccb-&gt;df &amp; ~SbMASK;
	ccb-&gt;df = df|stop;
	axpcc(uart-&gt;regs, Ccu);

	return 0;
}

static int
axpbits(Uart* uart, int bits)
{
	Ccb *ccb;
	u16int df;

	bits -= 5;
	if(bits &lt; 0 || bits &gt; 3)
		return -1;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	df = ccb-&gt;df &amp; ~DbMASK;
	ccb-&gt;df = df|bits;
	axpcc(uart-&gt;regs, Ccu);

	return 0;
}

static int
axpbaud(Uart* uart, int baud)
{
	Ccb *ccb;
	int i, ibtr;

	/*
	 * Set baud rate (high rates are special - only 16 bits).
	 */
	if(baud &lt;= 0)
		return -1;
	uart-&gt;baud = baud;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	switch(baud){
	default:
		ccb-&gt;br = baud;
		break;
	case 76800:
		ccb-&gt;br = Br76800;
		break;
	case 115200:
		ccb-&gt;br = Br115200;
		break;
	}

	/*
	 * Set trigger level to about 50 per second.
	 */
	ibtr = baud/500;
	i = (ccb-&gt;ibea - ccb-&gt;ibsa)/2;
	if(ibtr &gt; i)
		ibtr = i;
	ccb-&gt;ibtr = ibtr;
	axpcc(uart-&gt;regs, Ccu);

	return 0;
}

static void
axpbreak(Uart* uart, int ms)
{
	Ccb *ccb;
	u16int mc;

	/*
	 * Send a break.
	 */
	if(ms &lt;= 0)
		ms = 200;

	ccb = ((Cc*)(uart-&gt;regs))-&gt;ccb;

	mc = ccb-&gt;mc;
	ccb-&gt;mc = Ab|mc;
	tsleep(&amp;up-&gt;sleep, return0, 0, ms);
	ccb-&gt;mc = mc &amp; ~Ab;
}

/* only called from interrupt service */
static void
axpmc(Cc* cc)
{
	int old;
	Ccb *ccb;
	u16int ms;

	ccb = cc-&gt;ccb;

	ms = ccb-&gt;ms;

	if(ms &amp; Scts){
		ilock(&amp;cc-&gt;tlock);
		old = cc-&gt;cts;
		cc-&gt;cts = ms &amp; Scts;
		if(old == 0 &amp;&amp; cc-&gt;cts)
			cc-&gt;ctsbackoff = 2;
		iunlock(&amp;cc-&gt;tlock);
	}
	if(ms &amp; Sdsr){
		old = ms &amp; Sdsr;
		if(cc-&gt;hup_dsr &amp;&amp; cc-&gt;dsr &amp;&amp; !old)
			cc-&gt;dohup = 1;
		cc-&gt;dsr = old;
	}
	if(ms &amp; Sdcd){
		old = ms &amp; Sdcd;
		if(cc-&gt;hup_dcd &amp;&amp; cc-&gt;dcd &amp;&amp; !old)
			cc-&gt;dohup = 1;
		cc-&gt;dcd = old;
	}
}

/* called from uartkick() with uart-&gt;tlock ilocked */
static void
axpkick(Uart* uart)
{
	Cc *cc;
	Ccb *ccb;
	uchar *ep, *mem, *rp, *wp, *bp;

	if(uart-&gt;cts == 0 || uart-&gt;blocked)
		return;

	cc = uart-&gt;regs;
	ccb = cc-&gt;ccb;

	mem = (uchar*)cc-&gt;ctlr-&gt;gcb;
	bp = mem + ccb-&gt;obsa;
	rp = mem + ccb-&gt;obrp;
	wp = mem + ccb-&gt;obwp;
	ep = mem + ccb-&gt;obea;
	while(wp != rp-1 &amp;&amp; (rp != bp || wp != ep)){
		/*
		 * if we've exhausted the uart's output buffer,
		 * ask for more from the output queue, and quit if there
		 * isn't any.
		 */
		if(uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		*wp++ = *(uart-&gt;op++);
		if(wp &gt; ep)
			wp = bp;
		ccb-&gt;obwp = wp - mem;
	}
}

/* only called from interrupt service */
static void
axprecv(Cc* cc)
{
	Ccb *ccb;
	uchar *ep, *mem, *rp, *wp;

	ccb = cc-&gt;ccb;

	mem = (uchar*)cc-&gt;ctlr-&gt;gcb;
	rp = mem + ccb-&gt;ibrp;
	wp = mem + ccb-&gt;ibwp;
	ep = mem + ccb-&gt;ibea;

	while(rp != wp){
		uartrecv(cc, *rp++);		/* ilocks cc-&gt;tlock */
		if(rp &gt; ep)
			rp = mem + ccb-&gt;ibsa;
		ccb-&gt;ibrp = rp - mem;
	}
}

static void
axpinterrupt(Ureg*, void* arg)
{
	int work;
	Cc *cc;
	Ctlr *ctlr;
	u32int ics;
	u16int r, sr;

	work = 0;
	ctlr = arg;
	ics = csr32r(ctlr, Ics);
	if(ics &amp; 0x0810C000)
		print("%s: unexpected interrupt %#ux\n", ctlr-&gt;name, ics);
	if(!(ics &amp; 0x00002000)) {
		/* we get a steady stream of these on consoles */
		// print("%s: non-doorbell interrupt\n", ctlr-&gt;name);
		ctlr-&gt;gcb-&gt;gcw2 = 0x0001;	/* set Gintack */
		return;
	}

//	while(work to do){
		cc = ctlr-&gt;cc;
		for(sr = xchgw(&amp;ctlr-&gt;gcb-&gt;isr, 0); sr != 0; sr &gt;&gt;= 1){
			if(sr &amp; 0x0001)
				work++, axprecv(cc);
			cc++;
		}
		cc = ctlr-&gt;cc;
		for(sr = xchgw(&amp;ctlr-&gt;gcb-&gt;osr, 0); sr != 0; sr &gt;&gt;= 1){
			if(sr &amp; 0x0001)
				work++, uartkick(&amp;cc-&gt;Uart);
			cc++;
		}
		cc = ctlr-&gt;cc;
		for(sr = xchgw(&amp;ctlr-&gt;gcb-&gt;csr, 0); sr != 0; sr &gt;&gt;= 1){
			if(sr &amp; 0x0001)
				work++, wakeup(cc);
			cc++;
		}
		cc = ctlr-&gt;cc;
		for(sr = xchgw(&amp;ctlr-&gt;gcb-&gt;msr, 0); sr != 0; sr &gt;&gt;= 1){
			if(sr &amp; 0x0001)
				work++, axpmc(cc);
			cc++;
		}
		cc = ctlr-&gt;cc;
		for(sr = xchgw(&amp;ctlr-&gt;gcb-&gt;esr, 0); sr != 0; sr &gt;&gt;= 1){
			if(sr &amp; 0x0001){
				r = cc-&gt;ccb-&gt;ms;
				if(r &amp; Oe)
					cc-&gt;oerr++;
				if(r &amp; Pe)
					cc-&gt;perr++;
				if(r &amp; Fe)
					cc-&gt;ferr++;
				if (r &amp; (Oe|Pe|Fe))
					work++;
			}
			cc++;
		}
//	}
	/* only meaningful if we don't share the irq */
	if (0 &amp;&amp; !work)
		print("%s: interrupt with no work\n", ctlr-&gt;name);
	csr32w(ctlr, Pdb, 1);		/* clear doorbell interrupt */
	ctlr-&gt;gcb-&gt;gcw2 = 0x0001;	/* set Gintack */
}

static void
axpdisable(Uart* uart)
{
	Cc *cc;
	u16int lp;
	Ctlr *ctlr;

	/*
 	 * Turn off DTR and RTS, disable interrupts.
	 */
	(*uart-&gt;phys-&gt;dtr)(uart, 0);
	(*uart-&gt;phys-&gt;rts)(uart, 0);

	cc = uart-&gt;regs;
	lp = cc-&gt;ccb-&gt;lp;
	cc-&gt;ccb-&gt;lp = Emcs|lp;
	axpcc(cc, Dt|Dr|Fob|Fib|Ccu);

	/*
	 * The Uart is qlocked.
	 */
	ctlr = cc-&gt;ctlr;
	ctlr-&gt;im &amp;= ~(1&lt;&lt;cc-&gt;uartno);
	if(ctlr-&gt;im == 0)
		intrdisable(ctlr-&gt;pcidev-&gt;intl, axpinterrupt, ctlr,
			ctlr-&gt;pcidev-&gt;tbdf, ctlr-&gt;name);
}

static void
axpenable(Uart* uart, int ie)
{
	Cc *cc;
	Ctlr *ctlr;
	u16int lp;

	cc = uart-&gt;regs;
	ctlr = cc-&gt;ctlr;

	/*
 	 * Enable interrupts and turn on DTR and RTS.
	 * Be careful if this is called to set up a polled serial line
	 * early on not to try to enable interrupts as interrupt-
	 * -enabling mechanisms might not be set up yet.
	 */
	if(ie){
		/*
		 * The Uart is qlocked.
		 */
		if(ctlr-&gt;im == 0){
			intrenable(ctlr-&gt;pcidev-&gt;intl, axpinterrupt, ctlr,
				ctlr-&gt;pcidev-&gt;tbdf, ctlr-&gt;name);
			csr32w(ctlr, Ics, 0x00031F00);
			csr32w(ctlr, Pdb, 1);
			ctlr-&gt;gcb-&gt;gcw2 = 1;
		}
		ctlr-&gt;im |= 1&lt;&lt;cc-&gt;uartno;
	}

	(*uart-&gt;phys-&gt;dtr)(uart, 1);
	(*uart-&gt;phys-&gt;rts)(uart, 1);

	/*
	 * Make sure we control RTS, DTR and break.
	 */
	lp = cc-&gt;ccb-&gt;lp;
	cc-&gt;ccb-&gt;lp = Emcs|lp;
	cc-&gt;ccb-&gt;oblw = 64;
	axpcc(cc, Et|Er|Ccu);
}

static void*
axpdealloc(Ctlr* ctlr)
{
	int i;

	for(i = 0; i &lt; 16; i++){
		if(ctlr-&gt;cc[i].name != nil)
			free(ctlr-&gt;cc[i].name);
	}
	if(ctlr-&gt;reg != nil)
		vunmap(ctlr-&gt;reg, ctlr-&gt;pcidev-&gt;mem[0].size);
	if(ctlr-&gt;mem != nil)
		vunmap(ctlr-&gt;mem, ctlr-&gt;pcidev-&gt;mem[2].size);
	if(ctlr-&gt;name != nil)
		free(ctlr-&gt;name);
	free(ctlr);

	return nil;
}

static Uart*
axpalloc(int ctlrno, Pcidev* pcidev)
{
	Cc *cc;
	uchar *p;
	Ctlr *ctlr;
	void *addr;
	char name[64];
	u32int bar, r;
	int i, n, timeo;

	ctlr = malloc(sizeof(Ctlr));
	if(ctlr == nil)
		error(Enomem);
	seprint(name, name+sizeof(name), "uartaxp%d", ctlrno);
	kstrdup(&amp;ctlr-&gt;name, name);
	ctlr-&gt;pcidev = pcidev;
	ctlr-&gt;ctlrno = ctlrno;

	/*
	 * Access to runtime registers.
	 */
	bar = pcidev-&gt;mem[0].bar;
	if((addr = vmap(bar &amp; ~0x0F, pcidev-&gt;mem[0].size)) == 0){
		print("%s: can't map registers at %#ux\n", ctlr-&gt;name, bar);
		return axpdealloc(ctlr);
	}
	ctlr-&gt;reg = addr;
	print("%s: port 0x%ux irq %d ", ctlr-&gt;name, bar, pcidev-&gt;intl);

	/*
	 * Local address space 0.
	 */
	bar = pcidev-&gt;mem[2].bar;
	if((addr = vmap(bar &amp; ~0x0F, pcidev-&gt;mem[2].size)) == 0){
		print("%s: can't map memory at %#ux\n", ctlr-&gt;name, bar);
		return axpdealloc(ctlr);
	}
	ctlr-&gt;mem = addr;
	ctlr-&gt;gcb = (Gcb*)(ctlr-&gt;mem+0x10000);
	print("mem 0x%ux size %d: ", bar, pcidev-&gt;mem[2].size);

	/*
	 * Toggle the software reset and wait for
	 * the adapter local init status to indicate done.
	 *
	 * The two 'delay(100)'s below are important,
	 * without them the board seems to become confused
	 * (perhaps it needs some 'quiet time' because the
	 * timeout loops are not sufficient in themselves).
	 */
	r = csr32r(ctlr, Mcc);
	csr32w(ctlr, Mcc, r|Asr);
	microdelay(1);
	csr32w(ctlr, Mcc, r&amp;~Asr);
	delay(100);

	for(timeo = 0; timeo &lt; 100000; timeo++){
		if(csr32r(ctlr, Mcc) &amp; Lis)
			break;
		microdelay(1);
	}
	if(!(csr32r(ctlr, Mcc) &amp; Lis)){
		print("%s: couldn't reset\n", ctlr-&gt;name);
		return axpdealloc(ctlr);
	}
	print("downloading...");
	/*
	 * Copy the control programme to the card memory.
	 * The card's i960 control structures live at 0xD000.
	 */
	if(sizeof(uartaxpcp) &gt; 0xD000){
		print("%s: control programme too big\n", ctlr-&gt;name);
		return axpdealloc(ctlr);
	}
	/* TODO: is this right for more than 1 card? devastar does the same */
	csr32w(ctlr, Remap, 0xA0000001);
	for(i = 0; i &lt; sizeof(uartaxpcp); i++)
		ctlr-&gt;mem[i] = uartaxpcp[i];
	/*
	 * Execute downloaded code and wait for it
	 * to signal ready.
	 */
	csr32w(ctlr, Mb0, Edcc);
	delay(100);
	/* the manual says to wait for Cpr for 1 second */
	for(timeo = 0; timeo &lt; 10000; timeo++){
		if(csr32r(ctlr, Mb0) &amp; Cpr)
			break;
		microdelay(100);
	}
	if(!(csr32r(ctlr, Mb0) &amp; Cpr)){
		print("control programme not ready; Mb0 %#ux\n",
			csr32r(ctlr, Mb0));
		print("%s: distribution panel not connected or card not fully seated?\n",
			ctlr-&gt;name);

		return axpdealloc(ctlr);
	}
	print("\n");

	n = ctlr-&gt;gcb-&gt;ccbn;
	if(ctlr-&gt;gcb-&gt;bt != 0x12 || n &gt; 16){
		print("%s: wrong board type %#ux, %d channels\n",
			ctlr-&gt;name, ctlr-&gt;gcb-&gt;bt, ctlr-&gt;gcb-&gt;ccbn);
		return axpdealloc(ctlr);
	}

	p = ((uchar*)ctlr-&gt;gcb) + ctlr-&gt;gcb-&gt;ccboff;
	for(i = 0; i &lt; n; i++){
		cc = &amp;ctlr-&gt;cc[i];
		cc-&gt;ccb = (Ccb*)p;
		p += ctlr-&gt;gcb-&gt;ccbsz;
		cc-&gt;uartno = i;
		cc-&gt;ctlr = ctlr;

		cc-&gt;regs = cc;		/* actually Uart-&gt;regs */
		seprint(name, name+sizeof(name), "uartaxp%d%2.2d", ctlrno, i);
		kstrdup(&amp;cc-&gt;name, name);
		cc-&gt;freq = 0;
		cc-&gt;bits = 8;
		cc-&gt;stop = 1;
		cc-&gt;parity = 'n';
		cc-&gt;baud = 9600;
		cc-&gt;phys = &amp;axpphysuart;
		cc-&gt;console = 0;
		cc-&gt;special = 0;

		cc-&gt;next = &amp;ctlr-&gt;cc[i+1];
	}
	ctlr-&gt;cc[n-1].next = nil;

	ctlr-&gt;next = nil;
	if(axpctlrhead != nil)
		axpctlrtail-&gt;next = ctlr;
	else
		axpctlrhead = ctlr;
	axpctlrtail = ctlr;

	return ctlr-&gt;cc;
}

static Uart*
axppnp(void)
{
	Pcidev *p;
	int ctlrno;
	Uart *head, *tail, *uart;

	/*
	 * Loop through all PCI devices looking for simple serial
	 * controllers (ccrb == 0x07) and configure the ones which
	 * are familiar.
	 */
	head = tail = nil;
	ctlrno = 0;
	for(p = pcimatch(nil, 0, 0); p != nil; p = pcimatch(p, 0, 0)){
		if(p-&gt;ccrb != 0x07)
			continue;

		switch((p-&gt;did&lt;&lt;16)|p-&gt;vid){
		default:
			continue;
		case (0x6001&lt;&lt;16)|0x114F:	/* AvanstarXp */
			if((uart = axpalloc(ctlrno, p)) == nil)
				continue;
			break;
		}

		if(head != nil)
			tail-&gt;next = uart;
		else
			head = uart;
		for(tail = uart; tail-&gt;next != nil; tail = tail-&gt;next)
			;
		ctlrno++;
	}

	return head;
}

PhysUart axpphysuart = {
	.name		= "AvanstarXp",
	.pnp		= axppnp,
	.enable		= axpenable,
	.disable	= axpdisable,
	.kick		= axpkick,
	.dobreak	= axpbreak,
	.baud		= axpbaud,
	.bits		= axpbits,
	.stop		= axpstop,
	.parity		= axpparity,
	.modemctl	= axpmodemctl,
	.rts		= axprts,
	.dtr		= axpdtr,
	.status		= axpstatus,
	.fifo		= axpfifo,
	.getc		= nil,
	.putc		= nil,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

