<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/uarti8250.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/uarti8250.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

/*
 * 8250 UART and compatibles.
 */
enum {
	Uart0		= 0x3F8,	/* COM1 */
	Uart0IRQ	= 4,
	Uart1		= 0x2F8,	/* COM2 */
	Uart1IRQ	= 3,

	UartFREQ	= 1843200,
};

enum {					/* I/O ports */
	Rbr		= 0,		/* Receiver Buffer (RO) */
	Thr		= 0,		/* Transmitter Holding (WO) */
	Ier		= 1,		/* Interrupt Enable */
	Iir		= 2,		/* Interrupt Identification (RO) */
	Fcr		= 2,		/* FIFO Control (WO) */
	Lcr		= 3,		/* Line Control */
	Mcr		= 4,		/* Modem Control */
	Lsr		= 5,		/* Line Status */
	Msr		= 6,		/* Modem Status */
	Scr		= 7,		/* Scratch Pad */
	Dll		= 0,		/* Divisor Latch LSB */
	Dlm		= 1,		/* Divisor Latch MSB */
};

enum {					/* Ier */
	Erda		= 0x01,		/* Enable Received Data Available */
	Ethre		= 0x02,		/* Enable Thr Empty */
	Erls		= 0x04,		/* Enable Receiver Line Status */
	Ems		= 0x08,		/* Enable Modem Status */
};

enum {					/* Iir */
	Ims		= 0x00,		/* Ms interrupt */
	Ip		= 0x01,		/* Interrupt Pending (not) */
	Ithre		= 0x02,		/* Thr Empty */
	Irda		= 0x04,		/* Received Data Available */
	Irls		= 0x06,		/* Receiver Line Status */
	Ictoi		= 0x0C,		/* Character Time-out Indication */
	IirMASK		= 0x3F,
	Ifena		= 0xC0,		/* FIFOs enabled */
};

enum {					/* Fcr */
	FIFOena		= 0x01,		/* FIFO enable */
	FIFOrclr	= 0x02,		/* clear Rx FIFO */
	FIFOtclr	= 0x04,		/* clear Tx FIFO */
	FIFO1		= 0x00,		/* Rx FIFO trigger level 1 byte */
	FIFO4		= 0x40,		/*	4 bytes */
	FIFO8		= 0x80,		/*	8 bytes */
	FIFO14		= 0xC0,		/*	14 bytes */
};

enum {					/* Lcr */
	Wls5		= 0x00,		/* Word Length Select 5 bits/byte */
	Wls6		= 0x01,		/*	6 bits/byte */
	Wls7		= 0x02,		/*	7 bits/byte */
	Wls8		= 0x03,		/*	8 bits/byte */
	WlsMASK		= 0x03,
	Stb		= 0x04,		/* 2 stop bits */
	Pen		= 0x08,		/* Parity Enable */
	Eps		= 0x10,		/* Even Parity Select */
	Stp		= 0x20,		/* Stick Parity */
	Brk		= 0x40,		/* Break */
	Dlab		= 0x80,		/* Divisor Latch Access Bit */
};

enum {					/* Mcr */
	Dtr		= 0x01,		/* Data Terminal Ready */
	Rts		= 0x02,		/* Ready To Send */
	Out1		= 0x04,		/* no longer in use */
	Ie		= 0x08,		/* IRQ Enable */
	Dm		= 0x10,		/* Diagnostic Mode loopback */
};

enum {					/* Lsr */
	Dr		= 0x01,		/* Data Ready */
	Oe		= 0x02,		/* Overrun Error */
	Pe		= 0x04,		/* Parity Error */
	Fe		= 0x08,		/* Framing Error */
	Bi		= 0x10,		/* Break Interrupt */
	Thre		= 0x20,		/* Thr Empty */
	Temt		= 0x40,		/* Tramsmitter Empty */
	FIFOerr		= 0x80,		/* error in receiver FIFO */
};

enum {					/* Msr */
	Dcts		= 0x01,		/* Delta Cts */
	Ddsr		= 0x02,		/* Delta Dsr */
	Teri		= 0x04,		/* Trailing Edge of Ri */
	Ddcd		= 0x08,		/* Delta Dcd */
	Cts		= 0x10,		/* Clear To Send */
	Dsr		= 0x20,		/* Data Set Ready */
	Ri		= 0x40,		/* Ring Indicator */
	Dcd		= 0x80,		/* Data Set Ready */
};

typedef struct Ctlr {
	int	io;
	int	irq;
	int	tbdf;
	int	iena;

	uchar	sticky[8];

	Lock;
	int	hasfifo;
	int	checkfifo;
	int	fena;
} Ctlr;

extern PhysUart i8250physuart;

static Ctlr i8250ctlr[2] = {
{	.io	= Uart0,
	.irq	= Uart0IRQ,
	.tbdf	= BUSUNKNOWN, },

{	.io	= Uart1,
	.irq	= Uart1IRQ,
	.tbdf	= BUSUNKNOWN, },
};

static Uart i8250uart[2] = {
{	.regs	= &amp;i8250ctlr[0],
	.name	= "COM1",
	.freq	= UartFREQ,
	.phys	= &amp;i8250physuart,
	.special= 0,
	.next	= &amp;i8250uart[1], },

{	.regs	= &amp;i8250ctlr[1],
	.name	= "COM2",
	.freq	= UartFREQ,
	.phys	= &amp;i8250physuart,
	.special= 0,
	.next	= nil, },
};

#define csr8r(c, r)	inb((c)-&gt;io+(r))
#define csr8w(c, r, v)	outb((c)-&gt;io+(r), (c)-&gt;sticky[(r)]|(v))

static long
i8250status(Uart* uart, void* buf, long n, long offset)
{
	char *p;
	Ctlr *ctlr;
	uchar ier, lcr, mcr, msr;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	ctlr = uart-&gt;regs;
	mcr = ctlr-&gt;sticky[Mcr];
	msr = csr8r(ctlr, Msr);
	ier = ctlr-&gt;sticky[Ier];
	lcr = ctlr-&gt;sticky[Lcr];
	snprint(p, READSTR,
		"b%d c%d d%d e%d l%d m%d p%c r%d s%d i%d\n"
		"dev(%d) type(%d) framing(%d) overruns(%d) "
		"berr(%d) serr(%d)%s%s%s%s\n",

		uart-&gt;baud,
		uart-&gt;hup_dcd, 
		(msr &amp; Dsr) != 0,
		uart-&gt;hup_dsr,
		(lcr &amp; WlsMASK) + 5,
		(ier &amp; Ems) != 0, 
		(lcr &amp; Pen) ? ((lcr &amp; Eps) ? 'e': 'o'): 'n',
		(mcr &amp; Rts) != 0,
		(lcr &amp; Stb) ? 2: 1,
		ctlr-&gt;fena,

		uart-&gt;dev,
		uart-&gt;type,
		uart-&gt;ferr,
		uart-&gt;oerr,
		uart-&gt;berr,
		uart-&gt;serr,
		(msr &amp; Cts) ? " cts": "",
		(msr &amp; Dsr) ? " dsr": "",
		(msr &amp; Dcd) ? " dcd": "",
		(msr &amp; Ri) ? " ring": ""
	);
	n = readstr(offset, buf, n, p);
	free(p);

	return n;
}

static void
i8250fifo(Uart* uart, int level)
{
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	if(ctlr-&gt;hasfifo == 0)
		return;

	/*
	 * Changing the FIFOena bit in Fcr flushes data
	 * from both receive and transmit FIFOs; there's
	 * no easy way to guarantee not losing data on
	 * the receive side, but it's possible to wait until
	 * the transmitter is really empty.
	 */
	ilock(ctlr);
	while(!(csr8r(ctlr, Lsr) &amp; Temt))
		;

	/*
	 * Set the trigger level, default is the max.
	 * value.
	 * Some UARTs require FIFOena to be set before
	 * other bits can take effect, so set it twice.
	 */
	ctlr-&gt;fena = level;
	switch(level){
	case 0:
		break;
	case 1:
		level = FIFO1|FIFOena;
		break;
	case 4:
		level = FIFO4|FIFOena;
		break;
	case 8:
		level = FIFO8|FIFOena;
		break;
	default:
		level = FIFO14|FIFOena;
		break;
	}
	csr8w(ctlr, Fcr, level);
	csr8w(ctlr, Fcr, level);
	iunlock(ctlr);
}

static void
i8250dtr(Uart* uart, int on)
{
	Ctlr *ctlr;

	/*
	 * Toggle DTR.
	 */
	ctlr = uart-&gt;regs;
	if(on)
		ctlr-&gt;sticky[Mcr] |= Dtr;
	else
		ctlr-&gt;sticky[Mcr] &amp;= ~Dtr;
	csr8w(ctlr, Mcr, 0);
}

static void
i8250rts(Uart* uart, int on)
{
	Ctlr *ctlr;

	/*
	 * Toggle RTS.
	 */
	ctlr = uart-&gt;regs;
	if(on)
		ctlr-&gt;sticky[Mcr] |= Rts;
	else
		ctlr-&gt;sticky[Mcr] &amp;= ~Rts;
	csr8w(ctlr, Mcr, 0);
}

static void
i8250modemctl(Uart* uart, int on)
{
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	ilock(&amp;uart-&gt;tlock);
	if(on){
		ctlr-&gt;sticky[Ier] |= Ems;
		csr8w(ctlr, Ier, ctlr-&gt;sticky[Ier]);
		uart-&gt;modem = 1;
		uart-&gt;cts = csr8r(ctlr, Msr) &amp; Cts;
	}
	else{
		ctlr-&gt;sticky[Ier] &amp;= ~Ems;
		csr8w(ctlr, Ier, ctlr-&gt;sticky[Ier]);
		uart-&gt;modem = 0;
		uart-&gt;cts = 1;
	}
	iunlock(&amp;uart-&gt;tlock);

	/* modem needs fifo */
	(*uart-&gt;phys-&gt;fifo)(uart, on);
}

static int
i8250parity(Uart* uart, int parity)
{
	int lcr;
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	lcr = ctlr-&gt;sticky[Lcr] &amp; ~(Eps|Pen);

	switch(parity){
	case 'e':
		lcr |= Eps|Pen;
		break;
	case 'o':
		lcr |= Pen;
		break;
	case 'n':
		break;
	default:
		return -1;
	}
	ctlr-&gt;sticky[Lcr] = lcr;
	csr8w(ctlr, Lcr, 0);

	uart-&gt;parity = parity;

	return 0;
}

static int
i8250stop(Uart* uart, int stop)
{
	int lcr;
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	lcr = ctlr-&gt;sticky[Lcr] &amp; ~Stb;

	switch(stop){
	case 1:
		break;
	case 2:
		lcr |= Stb;
		break;
	default:
		return -1;
	}
	ctlr-&gt;sticky[Lcr] = lcr;
	csr8w(ctlr, Lcr, 0);

	uart-&gt;stop = stop;

	return 0;
}

static int
i8250bits(Uart* uart, int bits)
{
	int lcr;
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	lcr = ctlr-&gt;sticky[Lcr] &amp; ~WlsMASK;

	switch(bits){
	case 5:
		lcr |= Wls5;
		break;
	case 6:
		lcr |= Wls6;
		break;
	case 7:
		lcr |= Wls7;
		break;
	case 8:
		lcr |= Wls8;
		break;
	default:
		return -1;
	}
	ctlr-&gt;sticky[Lcr] = lcr;
	csr8w(ctlr, Lcr, 0);

	uart-&gt;bits = bits;

	return 0;
}

static int
i8250baud(Uart* uart, int baud)
{
	ulong bgc;
	Ctlr *ctlr;

	/*
	 * Set the Baud rate by calculating and setting the Baud rate
	 * Generator Constant. This will work with fairly non-standard
	 * Baud rates.
	 */
	if(uart-&gt;freq == 0 || baud &lt;= 0)
		return -1;
	bgc = (uart-&gt;freq+8*baud-1)/(16*baud);

	ctlr = uart-&gt;regs;
	csr8w(ctlr, Lcr, Dlab);
	outb(ctlr-&gt;io+Dlm, bgc&gt;&gt;8);
	outb(ctlr-&gt;io+Dll, bgc);
	csr8w(ctlr, Lcr, 0);

	uart-&gt;baud = baud;

	return 0;
}

static void
i8250break(Uart* uart, int ms)
{
	Ctlr *ctlr;

	/*
	 * Send a break.
	 */
	if(ms &lt;= 0)
		ms = 200;

	ctlr = uart-&gt;regs;
	csr8w(ctlr, Lcr, Brk);
	tsleep(&amp;up-&gt;sleep, return0, 0, ms);
	csr8w(ctlr, Lcr, 0);
}

static void
i8250kick(Uart* uart)
{
	int i;
	Ctlr *ctlr;

	if(uart-&gt;cts == 0 || uart-&gt;blocked)
		return;

	/*
	 *  128 here is an arbitrary limit to make sure
	 *  we don't stay in this loop too long.  If the
	 *  chip's output queue is longer than 128, too
	 *  bad -- presotto
	 */
	ctlr = uart-&gt;regs;
	for(i = 0; i &lt; 128; i++){
		if(!(csr8r(ctlr, Lsr) &amp; Thre))
			break;
		if(uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		outb(ctlr-&gt;io+Thr, *(uart-&gt;op++));
	}
}

static void
i8250interrupt(Ureg*, void* arg)
{
	Ctlr *ctlr;
	Uart *uart;
	int iir, lsr, old, r;

	uart = arg;

	ctlr = uart-&gt;regs;
	for(iir = csr8r(ctlr, Iir); !(iir &amp; Ip); iir = csr8r(ctlr, Iir)){
		switch(iir &amp; IirMASK){
		case Ims:		/* Ms interrupt */
			r = csr8r(ctlr, Msr);
			if(r &amp; Dcts){
				ilock(&amp;uart-&gt;tlock);
				old = uart-&gt;cts;
				uart-&gt;cts = r &amp; Cts;
				if(old == 0 &amp;&amp; uart-&gt;cts)
					uart-&gt;ctsbackoff = 2;
				iunlock(&amp;uart-&gt;tlock);
			}
		 	if(r &amp; Ddsr){
				old = r &amp; Dsr;
				if(uart-&gt;hup_dsr &amp;&amp; uart-&gt;dsr &amp;&amp; !old)
					uart-&gt;dohup = 1;
				uart-&gt;dsr = old;
			}
		 	if(r &amp; Ddcd){
				old = r &amp; Dcd;
				if(uart-&gt;hup_dcd &amp;&amp; uart-&gt;dcd &amp;&amp; !old)
					uart-&gt;dohup = 1;
				uart-&gt;dcd = old;
			}
			break;
		case Ithre:		/* Thr Empty */
			uartkick(uart);
			break;
		case Irda:		/* Received Data Available */
		case Irls:		/* Receiver Line Status */
		case Ictoi:		/* Character Time-out Indication */
			/*
			 * Consume any received data.
			 * If the received byte came in with a break,
			 * parity or framing error, throw it away;
			 * overrun is an indication that something has
			 * already been tossed.
			 */
			while((lsr = csr8r(ctlr, Lsr)) &amp; Dr){
				if(lsr &amp; (FIFOerr|Oe))
					uart-&gt;oerr++;
				if(lsr &amp; Pe)
					uart-&gt;perr++;
				if(lsr &amp; Fe)
					uart-&gt;ferr++;
				r = csr8r(ctlr, Rbr);
				if(!(lsr &amp; (Bi|Fe|Pe)))
					uartrecv(uart, r);
			}
			break;

		default:
			iprint("weird uart interrupt 0x%2.2uX\n", iir);
			break;
		}
	}
}

static void
i8250disable(Uart* uart)
{
	Ctlr *ctlr;

	/*
 	 * Turn off DTR and RTS, disable interrupts and fifos.
	 */
	(*uart-&gt;phys-&gt;dtr)(uart, 0);
	(*uart-&gt;phys-&gt;rts)(uart, 0);
	(*uart-&gt;phys-&gt;fifo)(uart, 0);

	ctlr = uart-&gt;regs;
	ctlr-&gt;sticky[Ier] = 0;
	csr8w(ctlr, Ier, ctlr-&gt;sticky[Ier]);

	if(ctlr-&gt;iena != 0){
		if(intrdisable(ctlr-&gt;irq, i8250interrupt, uart, ctlr-&gt;tbdf, uart-&gt;name) == 0)
			ctlr-&gt;iena = 0;
	}
}

static void
i8250enable(Uart* uart, int ie)
{
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;

	/*
	 * Check if there is a FIFO.
	 * Changing the FIFOena bit in Fcr flushes data
	 * from both receive and transmit FIFOs; there's
	 * no easy way to guarantee not losing data on
	 * the receive side, but it's possible to wait until
	 * the transmitter is really empty.
	 * Also, reading the Iir outwith i8250interrupt()
	 * can be dangerous, but this should only happen
	 * once before interrupts are enabled.
	 */
	ilock(ctlr);
	if(!ctlr-&gt;checkfifo){
		/*
		 * Wait until the transmitter is really empty.
		 */
		while(!(csr8r(ctlr, Lsr) &amp; Temt))
			;
		csr8w(ctlr, Fcr, FIFOena);
		if(csr8r(ctlr, Iir) &amp; Ifena)
			ctlr-&gt;hasfifo = 1;
		csr8w(ctlr, Fcr, 0);
		ctlr-&gt;checkfifo = 1;
	}
	iunlock(ctlr);

	/*
 	 * Enable interrupts and turn on DTR and RTS.
	 * Be careful if this is called to set up a polled serial line
	 * early on not to try to enable interrupts as interrupt-
	 * -enabling mechanisms might not be set up yet.
	 */
	if(ie){
		if(ctlr-&gt;iena == 0){
			intrenable(ctlr-&gt;irq, i8250interrupt, uart, ctlr-&gt;tbdf, uart-&gt;name);
			ctlr-&gt;iena = 1;
		}
		ctlr-&gt;sticky[Ier] = Ethre|Erda;
		ctlr-&gt;sticky[Mcr] |= Ie;
	}
	else{
		ctlr-&gt;sticky[Ier] = 0;
		ctlr-&gt;sticky[Mcr] = 0;
	}
	csr8w(ctlr, Ier, ctlr-&gt;sticky[Ier]);
	csr8w(ctlr, Mcr, ctlr-&gt;sticky[Mcr]);

	(*uart-&gt;phys-&gt;dtr)(uart, 1);
	(*uart-&gt;phys-&gt;rts)(uart, 1);

	/*
	 * During startup, the i8259 interrupt controller is reset.
	 * This may result in a lost interrupt from the i8250 uart.
	 * The i8250 thinks the interrupt is still outstanding and does not
	 * generate any further interrupts. The workaround is to call the
	 * interrupt handler to clear any pending interrupt events.
	 * Note: this must be done after setting Ier.
	 */
	if(ie)
		i8250interrupt(nil, uart);
}

void*
i8250alloc(int io, int irq, int tbdf)
{
	Ctlr *ctlr;

	if((ctlr = malloc(sizeof(Ctlr))) != nil){
		ctlr-&gt;io = io;
		ctlr-&gt;irq = irq;
		ctlr-&gt;tbdf = tbdf;
	}

	return ctlr;
}

static Uart*
i8250pnp(void)
{
	return i8250uart;
}

static int
i8250getc(Uart *uart)
{
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	while(!(csr8r(ctlr, Lsr)&amp;Dr))
		delay(1);
	return csr8r(ctlr, Rbr);
}

static void
i8250putc(Uart *uart, int c)
{
	int i;
	Ctlr *ctlr;

	ctlr = uart-&gt;regs;
	for(i = 0; !(csr8r(ctlr, Lsr)&amp;Thre) &amp;&amp; i &lt; 128; i++)
		delay(1);
	outb(ctlr-&gt;io+Thr, c);
	for(i = 0; !(csr8r(ctlr, Lsr)&amp;Thre) &amp;&amp; i &lt; 128; i++)
		delay(1);
}

PhysUart i8250physuart = {
	.name		= "i8250",
	.pnp		= i8250pnp,
	.enable		= i8250enable,
	.disable	= i8250disable,
	.kick		= i8250kick,
	.dobreak	= i8250break,
	.baud		= i8250baud,
	.bits		= i8250bits,
	.stop		= i8250stop,
	.parity		= i8250parity,
	.modemctl	= i8250modemctl,
	.rts		= i8250rts,
	.dtr		= i8250dtr,
	.status		= i8250status,
	.fifo		= i8250fifo,
	.getc		= i8250getc,
	.putc		= i8250putc,
};

void
i8250config(char *p)
{
	Uart *uart;
	int n;
	char *cmd;

	if(p == nil)
		return;
	n = strtoul(p, &amp;cmd, 0);
	if(p == cmd)
		return;
	switch(n){
	default:
		return;
	case 0:
		uart = &amp;i8250uart[0];
		break;
	case 1:
		uart = &amp;i8250uart[1];
		break;	
	}

	if(!uart-&gt;enabled)
		(*uart-&gt;phys-&gt;enable)(uart, 0);
	uartctl(uart, "b9600 l8 pn s1");
	if(*cmd != '\0')
		uartctl(uart, cmd);

	consuart = uart;
	uart-&gt;console = 1;
}

void
i8250console(void)
{
	i8250config(getconf("console"));
}

void
i8250mouse(char* which, int (*putc)(Queue*, int), int setb1200)
{
	char *p;
	int port;

	port = strtol(which, &amp;p, 0);
	if(p == which || port &lt; 0 || port &gt; 1)
		error(Ebadarg);
	uartmouse(&amp;i8250uart[port], putc, setb1200);
}

void
i8250setmouseputc(char* which, int (*putc)(Queue*, int))
{
	char *p;
	int port;

	port = strtol(which, &amp;p, 0);
	if(p == which || port &lt; 0 || port &gt; 1)
		error(Ebadarg);
	uartsetmouseputc(&amp;i8250uart[port], putc);

}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

