<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/uartisa.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/uartisa.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

extern PhysUart i8250physuart;
extern PhysUart isaphysuart;
extern void* i8250alloc(int, int, int);

static Uart*
uartisa(int ctlrno, ISAConf* isa)
{
	int io;
	void *ctlr;
	Uart *uart;
	char buf[64];

	io = isa-&gt;port;
	snprint(buf, sizeof(buf), "%s%d", isaphysuart.name, ctlrno);
	if(ioalloc(io, 8, 0, buf) &lt; 0){
		print("uartisa: I/O 0x%uX in use\n", io);
		return nil;
	}

	uart = malloc(sizeof(Uart));
	ctlr = i8250alloc(io, isa-&gt;irq, BUSUNKNOWN);
	if(uart == nil || ctlr == nil){
		iofree(io);
		free(uart);
		free(ctlr);
		return nil;
	}

	uart-&gt;regs = ctlr;
	snprint(buf, sizeof(buf), "COM%d", ctlrno+1);
	kstrdup(&amp;uart-&gt;name, buf);
	uart-&gt;freq = isa-&gt;freq;
	uart-&gt;phys = &amp;i8250physuart;

	return uart;
}

static Uart*
uartisapnp(void)
{
	int ctlrno;
	ISAConf isa;
	Uart *head, *tail, *uart;

	/*
	 * Look for up to 4 discrete UARTs on the ISA bus.
	 * All suitable devices are configured to simply point
	 * to the generic i8250 driver.
	 */
	head = tail = nil;
	for(ctlrno = 2; ctlrno &lt; 6; ctlrno++){
		memset(&amp;isa, 0, sizeof(isa));
		if(!isaconfig("uart", ctlrno, &amp;isa))
			continue;
		if(strcmp(isa.type, "isa") != 0)
			continue;
		if(isa.port == 0 || isa.irq == 0)
			continue;
		if(isa.freq == 0)
			isa.freq = 1843200;
		uart = uartisa(ctlrno, &amp;isa);
		if(uart == nil)
			continue;
		if(head != nil)
			tail-&gt;next = uart;
		else
			head = uart;
		tail = uart;
	}

	return head;
}

PhysUart isaphysuart = {
	.name		= "UartISA",
	.pnp		= uartisapnp,
	.enable		= nil,
	.disable	= nil,
	.kick		= nil,
	.dobreak	= nil,
	.baud		= nil,
	.bits		= nil,
	.stop		= nil,
	.parity		= nil,
	.modemctl	= nil,
	.rts		= nil,
	.dtr		= nil,
	.status		= nil,
	.fifo		= nil,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

