<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/uartox.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/uartox.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Oxford Semiconductor OXPCIe95x UART driver
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

extern PhysUart oxphysuart;

enum {
	Ccr		= 0x0000/4,	/* Class Code and Revision ID */
	Nuart		= 0x0004/4,	/* Decimal Number of UARTs */
	Gis		= 0x0008/4,	/* Global UART IRQ Status */
	Gie		= 0x000C/4,	/* Global UART IRQ Enable */
	Gid		= 0x0010/4,	/* Global UART IRQ Disable */
	Gwe		= 0x0014/4,	/* Global UART Wake Enable */
	Gwd		= 0x0018/4,	/* Global UART Wake Disable */
};

enum {
	Thr		= 0x00,		/* Transmitter Holding */
	Rhr		= 0x00,		/* Receiver Holding */
	Ier		= 0x01,		/* Interrupt Enable */
	Fcr		= 0x02,		/* FIFO Control */
	Isr		= 0x02,		/* Interrupt Status */
	Lcr		= 0x03,		/* Line Control */
	Mcr		= 0x04,		/* Modem Control */
	Lsr		= 0x05,		/* Line Status */
	Msr		= 0x06,		/* Modem Status */
	Spr		= 0x07,		/* Scratch Pad */
	Dll		= 0x00,		/* Divisor Latch LSB */
	Dlm		= 0x01,		/* Divisor Latch MSB */
	Efr		= 0x02,		/* Enhanced Feature */
};

typedef struct Port Port;
typedef struct Ctlr Ctlr;

struct Port {
	Uart;
	Ctlr	*ctlr;
	u8int	*mem;

	int	level;
	int	dtr, rts;
	int	ri;
};

struct Ctlr {
	Lock;
	char	*name;
	Pcidev	*pcidev;
	u32int	*mem;

	u32int	im;

	Port	port[0x10];
	int	nport;
};

static Uart *
oxpnp(void)
{
	Pcidev *p;
	Ctlr *ctlr;
	Port *port;
	int i;
	char *model;
	char name[12+1];
	Uart *head, *tail;
	static int ctlrno;

	p = nil;
	head = tail = nil;
	while(p = pcimatch(p, 0x1415, 0)){
		switch(p-&gt;did){
		case 0xc101:
		case 0xc105:
		case 0xc11b:
		case 0xc11f:
		case 0xc120:
		case 0xc124:
		case 0xc138:
		case 0xc13d:
		case 0xc140:
		case 0xc141:
		case 0xc144:
		case 0xc145:
		case 0xc158:
		case 0xc15d:
			model = "OXPCIe952";
			break;
		case 0xc208:
		case 0xc20d:
			model = "OXPCIe954";
			break;
		case 0xc308:
		case 0xc30d:
			model = "OXPCIe958";
			break;
		default:
			continue;
		}
		ctlr = malloc(sizeof *ctlr);
		if(ctlr == nil){
			print("oxpnp: out of memory\n");
			continue;
		}
		ctlr-&gt;pcidev = p;
		ctlr-&gt;mem = vmap(p-&gt;mem[0].bar &amp; ~0xf, p-&gt;mem[0].size);
		if(ctlr-&gt;mem == nil){
			print("oxpnp: vmap failed\n");
			free(ctlr);
			continue;
		}
		snprint(name, sizeof name, "uartox%d", ctlrno);
		kstrdup(&amp;ctlr-&gt;name, name);
		ctlr-&gt;nport = ctlr-&gt;mem[Nuart] &amp; 0x1f;
		for(i = 0; i &lt; ctlr-&gt;nport; ++i){
			port = &amp;ctlr-&gt;port[i];
			port-&gt;ctlr = ctlr;
			port-&gt;mem = (u8int *)ctlr-&gt;mem + 0x1000 + 0x200*i;
			port-&gt;regs = port;
			snprint(name, sizeof name, "%s.%d", ctlr-&gt;name, i);
			kstrdup(&amp;port-&gt;name, name);
			port-&gt;phys = &amp;oxphysuart;
			if(head == nil)
				head = port;
			else
				tail-&gt;next = port;
			tail = port;
		}
		print("%s: %s: %d ports irq %d\n",
		    ctlr-&gt;name, model, ctlr-&gt;nport, p-&gt;intl);
		ctlrno++;
	}
	return head;
}

static void
oxinterrupt(Ureg *, void *arg)
{
	Ctlr *ctlr;
	Port *port;
	Uart *uart;
	int i, old;
	u8int val;
	char ch;

	ctlr = arg;

	ilock(ctlr);
	if(!(ctlr-&gt;im &amp; ctlr-&gt;mem[Gis])){
		iunlock(ctlr);
		return;
	}
	for(i = 0; i &lt; ctlr-&gt;nport; ++i){
		if(!(ctlr-&gt;im &amp; 1&lt;&lt;i))
			continue;
		port = &amp;ctlr-&gt;port[i];
		uart = port;	/* "Come Clarity" */
		switch(port-&gt;mem[Isr] &amp; 0x3f){
		case 0x06:	/* Receiver status error */
		case 0x04:	/* Receiver data available */
		case 0x0c:	/* Receiver time-out */
			for(;;){
				val = port-&gt;mem[Lsr];
				if(!(val &amp; 1&lt;&lt;0))	/* RxRDY */
					break;
				if(val &amp; 1&lt;&lt;1)		/* Overrun Error */
					uart-&gt;oerr++;
				if(val &amp; 1&lt;&lt;2)		/* Parity Error */
					uart-&gt;perr++;
				if(val &amp; 1&lt;&lt;3)		/* Framing Error */
					uart-&gt;ferr++;
				ch = port-&gt;mem[Rhr];
				if(!(val &amp; 1&lt;&lt;7))	/* Data Error */
					uartrecv(uart, ch);
			}
			break;
		case 0x02:	/* Transmitter THR empty */
			uartkick(uart);
			break;
		case 0x00:	/* Modem status change */
			val = port-&gt;mem[Msr];
			if(val &amp; 1&lt;&lt;0){			/* Delta nCTS */
				ilock(&amp;uart-&gt;tlock);
				old = uart-&gt;cts;
				uart-&gt;cts = val &amp; 1&lt;&lt;4;	/* CTS */
				if(!old &amp;&amp; uart-&gt;cts)
					uart-&gt;ctsbackoff = 2;
				iunlock(&amp;uart-&gt;tlock);
			}
			if(val &amp; 1&lt;&lt;1){			/* Delta nDSR */
				old = val &amp; 1&lt;&lt;5;	/* DSR */
				if(!old &amp;&amp; uart-&gt;dsr &amp;&amp; uart-&gt;hup_dsr)
					uart-&gt;dohup = 1;
				uart-&gt;dsr = old;
			}
			port-&gt;ri = val &amp; 1&lt;&lt;6;		/* RI */
			if(val &amp; 1&lt;&lt;3){			/* Delta nDCD */
				old = val &amp; 1&lt;&lt;7;	/* DCD */
				if(!old &amp;&amp; uart-&gt;dcd &amp;&amp; uart-&gt;hup_dcd)
					uart-&gt;dohup = 1;
				uart-&gt;dcd = old;
			}
			break;
		}
	}
	iunlock(ctlr);
}

#define MASK(p)	(1UL&lt;&lt;((p)-(p)-&gt;ctlr-&gt;port))

static void
oxenable(Uart *uart, int)
{
	Ctlr *ctlr;
	Port *port;

	port = uart-&gt;regs;
	ctlr = port-&gt;ctlr;

	ilock(ctlr);
	if(ctlr-&gt;im == 0)
		intrenable(ctlr-&gt;pcidev-&gt;intl, oxinterrupt, ctlr,
		    ctlr-&gt;pcidev-&gt;tbdf, ctlr-&gt;name);
	ctlr-&gt;im |= MASK(port);
	iunlock(ctlr);

	/* Enable 950 Mode */
	port-&gt;mem[Lcr] |= 1&lt;&lt;7;			/* Divisor latch access */
	port-&gt;mem[Efr] = 1&lt;&lt;4;			/* Enhanced mode */
	port-&gt;mem[Lcr] &amp;= ~(1&lt;&lt;7);

	port-&gt;mem[Ier] = 1&lt;&lt;2|1&lt;&lt;1|1&lt;&lt;0;	/* Rx Stat, THRE, RxRDY */

	(*uart-&gt;phys-&gt;dtr)(uart, 1);
	(*uart-&gt;phys-&gt;rts)(uart, 1);

	/* Enable FIFO */
	(*uart-&gt;phys-&gt;fifo)(uart, ~0);
}

static void
oxdisable(Uart *uart)
{
	Ctlr *ctlr;
	Port *port;

	port = uart-&gt;regs;
	ctlr = port-&gt;ctlr;

	(*uart-&gt;phys-&gt;dtr)(uart, 0);
	(*uart-&gt;phys-&gt;rts)(uart, 0);
	(*uart-&gt;phys-&gt;fifo)(uart, 0);

	port-&gt;mem[Ier] = 0;

	ilock(ctlr);
	ctlr-&gt;im &amp;= ~MASK(port);
	if(ctlr-&gt;im == 0)
		intrdisable(ctlr-&gt;pcidev-&gt;intl, oxinterrupt, ctlr,
		    ctlr-&gt;pcidev-&gt;tbdf, ctlr-&gt;name);
	iunlock(ctlr);
}

static void
oxkick(Uart *uart)
{
	Port *port;

	if(uart-&gt;cts == 0 || uart-&gt;blocked)
		return;

	port = uart-&gt;regs;

	for(;;){
		if(!(port-&gt;mem[Lsr] &amp; 1&lt;&lt;5))	/* THR Empty */
			break;
		if(uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		port-&gt;mem[Thr] = *(uart-&gt;op++);
	}
}

static void
oxdobreak(Uart *uart, int ms)
{
	Port *port;

	if(ms &lt;= 0)
		ms = 200;

	port = uart-&gt;regs;

	port-&gt;mem[Lcr] |= 1&lt;&lt;6;			/* Transmission break */
	if(!waserror()){
		tsleep(&amp;up-&gt;sleep, return0, nil, ms);
		poperror();
	}
	port-&gt;mem[Lcr] &amp;= ~(1&lt;&lt;6);
}

static int
oxbaud(Uart *uart, int baud)
{
	Port *port;
	u16int val;

	if(baud &lt;= 0)
		return -1;

	port = uart-&gt;regs;

	/*
	 * We aren't terribly interested in non-standard baud rates.
	 * Rather than mess about with generator constants, we instead
	 * program DLM and DLL according to Table 37 in the datasheet.
	 */
	switch(baud){
	case 1200:
		val = 0x0cb6;
		break;
	case 2400:
		val = 0x065b;
		break;
	case 4800:
		val = 0x032d;
		break;
	case 9600:
		val = 0x0196;
		break;
	case 19200:
		val = 0x00cb;
		break;
	case 38400:
		val = 0x0066;
		break;
	case 57600:
		val = 0x0044;
		break;
	case 115200:
		val = 0x0022;
		break;
	default:
		return -1;
	}
	port-&gt;mem[Lcr] |= 1&lt;&lt;7;			/* Divisor latch access */
	port-&gt;mem[Dlm] = val&gt;&gt;8;
	port-&gt;mem[Dll] = val;
	port-&gt;mem[Lcr] &amp;= ~(1&lt;&lt;7);
	uart-&gt;baud = baud;
	return 0;
}

static int
oxbits(Uart *uart, int bits)
{
	Port *port;
	u8int val;

	port = uart-&gt;regs;

	val = port-&gt;mem[Lcr] &amp; 0x7c;
	switch(bits){
	case 8:
		val |= 0x3;			/* Data length */
		break;
	case 7:
		val |= 0x2;
		break;
	case 6:
		val |= 0x1;
		break;
	case 5:
		break;
	default:
		return -1;
	}
	port-&gt;mem[Lcr] = val;
	uart-&gt;bits = bits;
	return 0;
}

static int
oxstop(Uart *uart, int stop)
{
	Port *port;
	u8int val;

	port = uart-&gt;regs;

	val = port-&gt;mem[Lcr] &amp; 0x7b;
	switch(stop){
	case 2:
		val |= 1&lt;&lt;2;			/* Number of Stop Bits */
		break;
	case 1:
		break;
	default:
		return -1;
	}
	port-&gt;mem[Lcr] = val;
	uart-&gt;stop = stop;
	return 0;
}

static int
oxparity(Uart *uart, int parity)
{
	Port *port;
	u8int val;

	port = uart-&gt;regs;

	val = port-&gt;mem[Lcr] &amp; 0x67;
	switch(parity){
	case 'e':
		val |= 1&lt;&lt;4;			/* Even/Odd Parity */
	case 'o':
		val |= 1&lt;&lt;3;			/* Parity Enable */
		break;
	case 'n':
		break;
	default:
		return -1;
	}
	port-&gt;mem[Lcr] = val;
	uart-&gt;parity = parity;
	return 0;
}

static void
oxmodemctl(Uart *uart, int on)
{
	Ctlr *ctlr;
	Port *port;

	port = uart-&gt;regs;
	ctlr = port-&gt;ctlr;

	ilock(ctlr);
	ilock(&amp;uart-&gt;tlock);
	if(on){
		port-&gt;mem[Ier] |= 1&lt;&lt;3;			/* Modem */
		uart-&gt;cts = port-&gt;mem[Msr] &amp; 1&lt;&lt;4;	/* CTS */
	}else{
		port-&gt;mem[Ier] &amp;= ~(1&lt;&lt;3);
		uart-&gt;cts = 1;
	}
	uart-&gt;modem = on;
	iunlock(&amp;uart-&gt;tlock);
	iunlock(ctlr);
}

static void
oxrts(Uart *uart, int on)
{
	Port *port;

	port = uart-&gt;regs;

	if(on)
		port-&gt;mem[Mcr] |= 1&lt;&lt;1;		/* RTS */
	else
		port-&gt;mem[Mcr] &amp;= ~(1&lt;&lt;1);
	port-&gt;rts = on;
}

static void
oxdtr(Uart *uart, int on)
{
	Port *port;

	port = uart-&gt;regs;

	if(on)
		port-&gt;mem[Mcr] |= 1&lt;&lt;0;		/* DTR */
	else
		port-&gt;mem[Mcr] &amp;= ~(1&lt;&lt;0);
	port-&gt;dtr = on;
}

static long
oxstatus(Uart *uart, void *buf, long n, long offset)
{
	Port *port;

	if(offset &gt; 0)
		return 0;

	port = uart-&gt;regs;

	return snprint(buf, n,
	    "b%d c%d d%d e%d l%d m%d p%c r%d s%d i%d\n"
	    "dev(%d) type(%d) framing(%d) overruns(%d) "
	    "berr(%d) serr(%d)%s%s%s%s\n",

	    uart-&gt;baud,
	    uart-&gt;hup_dcd,
	    port-&gt;dtr,
	    uart-&gt;hup_dsr,
	    uart-&gt;bits,
	    uart-&gt;modem,
	    uart-&gt;parity,
	    port-&gt;rts,
	    uart-&gt;stop,
	    port-&gt;level,

	    uart-&gt;dev,
	    uart-&gt;type,
	    uart-&gt;ferr,
	    uart-&gt;oerr,
	    uart-&gt;berr,
	    uart-&gt;serr,
	    uart-&gt;cts ? " cts": "",
	    uart-&gt;dsr ? " dsr": "",
	    port-&gt;ri ? " ring": "",
	    uart-&gt;dcd ? " dcd": ""
	);
}

static void
oxfifo(Uart *uart, int level)
{
	Ctlr *ctlr;
	Port *port;

	port = uart-&gt;regs;
	ctlr = port-&gt;ctlr;

	/*
	 * 950 Mode FIFOs have a depth of 128 bytes; devuart only
	 * cares about setting RHR trigger levels.  THR trigger
	 * levels are not supported.
	 */
	ilock(ctlr);
	if(level == 0)
		port-&gt;mem[Fcr] = 0;		/* Disable FIFO */
	else{
		port-&gt;mem[Fcr] = 1&lt;&lt;0;		/* Enable FIFO */
		switch(level){
		default:
			level = 112;
		case 112:
			port-&gt;mem[Fcr] = 0x03&lt;&lt;6|1&lt;&lt;0;	/* RHR Trigger Level */
			break;
		case 64:
			port-&gt;mem[Fcr] = 0x02&lt;&lt;6|1&lt;&lt;0;
			break;
		case 32:
			port-&gt;mem[Fcr] = 0x01&lt;&lt;6|1&lt;&lt;0;
			break;
		case 16:
			break;
		}
	}
	port-&gt;level = level;
	iunlock(ctlr);
}

PhysUart oxphysuart = {
	.name		= "OXPCIe95x",
	.pnp		= oxpnp,
	.enable		= oxenable,
	.disable	= oxdisable,
	.kick		= oxkick,
	.dobreak	= oxdobreak,
	.baud		= oxbaud,
	.bits		= oxbits,
	.stop		= oxstop,
	.parity		= oxparity,
	.modemctl	= oxmodemctl,
	.rts		= oxrts,
	.dtr		= oxdtr,
	.status		= oxstatus,
	.fifo		= oxfifo,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

