<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/uartpci.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/uartpci.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

extern PhysUart i8250physuart;
extern PhysUart pciphysuart;
extern void* i8250alloc(int, int, int);

static Uart *perlehead, *perletail;

static Uart*
uartpci(int ctlrno, Pcidev* p, int barno, int n, int freq, char* name,
	int iosize)
{
	int i, io;
	void *ctlr;
	char buf[64];
	Uart *head, *uart;

	io = p-&gt;mem[barno].bar &amp; ~0x01;
	snprint(buf, sizeof(buf), "%s%d", pciphysuart.name, ctlrno);
	if(ioalloc(io, p-&gt;mem[barno].size, 0, buf) &lt; 0){
		print("uartpci: I/O 0x%uX in use\n", io);
		return nil;
	}

	head = uart = malloc(sizeof(Uart)*n);
	if(uart == nil)
		error(Enomem);
	for(i = 0; i &lt; n; i++){
		ctlr = i8250alloc(io, p-&gt;intl, p-&gt;tbdf);
		io += iosize;
		if(ctlr == nil)
			continue;

		uart-&gt;regs = ctlr;
		snprint(buf, sizeof(buf), "%s.%8.8uX", name, p-&gt;tbdf);
		kstrdup(&amp;uart-&gt;name, buf);
		uart-&gt;freq = freq;
		uart-&gt;phys = &amp;i8250physuart;
		/* print("#t: %s port %#x freq %,ldHz irq %d\n",
			uart-&gt;name, io - iosize, uart-&gt;freq, p-&gt;intl); /**/
		if(uart != head)
			(uart-1)-&gt;next = uart;
		uart++;
	}

	if (head) {
		if(perlehead != nil)
			perletail-&gt;next = head;
		else
			perlehead = head;
		for(perletail = head; perletail-&gt;next != nil;
		    perletail = perletail-&gt;next)
			;
	}
	return head;
}

static Uart *
ultraport16si(int ctlrno, Pcidev *p, ulong freq)
{
	int io, i;
	char *name;
	Uart *uart;

	name = "Ultraport16si";		/* 16L788 UARTs */
	io = p-&gt;mem[4].bar &amp; ~1;
	if (ioalloc(io, p-&gt;mem[4].size, 0, name) &lt; 0) {
		print("uartpci: can't get IO space to set %s to rs-232\n", name);
		return nil;
	}
	for (i = 0; i &lt; 16; i++) {
		outb(io, i &lt;&lt; 4);
		outb(io, (i &lt;&lt; 4) + 1);	/* set to RS232 mode  (Don't ask!) */
	}

	uart = uartpci(ctlrno, p, 2, 8, freq, name, 16);
	if(uart)
		uart = uartpci(ctlrno, p, 3, 8, freq, name, 16);
	return uart;
}

static Uart*
uartpcipnp(void)
{
	Pcidev *p;
	char *name;
	int ctlrno, subid;
	ulong freq;
	Uart *uart;

	/*
	 * Loop through all PCI devices looking for simple serial
	 * controllers (ccrb == Pcibccomm (7)) and configure the ones which
	 * are familiar. All suitable devices are configured to
	 * simply point to the generic i8250 driver.
	 */
	perlehead = perletail = nil;
	ctlrno = 0;
	for(p = pcimatch(nil, 0, 0); p != nil; p = pcimatch(p, 0, 0)){
		/* StarTech PCI8S9503V has ccru == 0x80 (other) */
		if(p-&gt;ccrb != Pcibccomm || p-&gt;ccru &gt; 2 &amp;&amp; p-&gt;ccru != 0x80)
			continue;

		switch(p-&gt;did&lt;&lt;16 | p-&gt;vid){
		default:
			continue;
		case (0x9835&lt;&lt;16)|0x9710:	/* StarTech PCI2S550 */
			uart = uartpci(ctlrno, p, 0, 1, 1843200, "PCI2S550-0", 8);
			if(uart == nil)
				continue;
			uart-&gt;next = uartpci(ctlrno, p, 1, 1, 1843200,
				"PCI2S550-1", 8);
			if(uart-&gt;next == nil)
				continue;
			break;
		case (0x950A&lt;&lt;16)|0x1415:	/* Oxford Semi OX16PCI954 */
		case (0x9501&lt;&lt;16)|0x1415:
		case (0x9521&lt;&lt;16)|0x1415:
			/*
			 * These are common devices used by 3rd-party
			 * manufacturers.
			 * Must check the subsystem VID and DID for correct
			 * match.
			 */
			subid = pcicfgr16(p, PciSVID);
			subid |= pcicfgr16(p, PciSID)&lt;&lt;16;
			switch(subid){
			default:
				print("oxsemi uart %.8#ux of vid %#ux did %#ux unknown\n",
					subid, p-&gt;vid, p-&gt;did);
				continue;
			case (0&lt;&lt;16)|0x1415:
				uart = uartpci(ctlrno, p, 0, 4, 1843200,
					"starport-pex4s", 8);
				break;
			case (1&lt;&lt;16)|0x1415:
				uart = uartpci(ctlrno, p, 0, 2, 14745600,
					"starport-pex2s", 8);
				break;
			case (0x2000&lt;&lt;16)|0x131F:/* SIIG CyberSerial PCIe */
				uart = uartpci(ctlrno, p, 0, 1, 18432000,
					"CyberSerial-1S", 8);
				break;
			}
			break;
		case (0x9505&lt;&lt;16)|0x1415:	/* Oxford Semi OXuPCI952 */
			name = "SATAGear-IOI-102";  /* PciSVID=1415, PciSID=0 */
			if (uartpci(ctlrno, p, 0, 1, 14745600, name, 8) != nil)
				ctlrno++;
			if (uartpci(ctlrno, p, 1, 1, 14745600, name, 8) != nil)
				ctlrno++;
			uart = nil;		/* don't ctlrno++ below */
			break;
		case (0x9050&lt;&lt;16)|0x10B5:	/* Perle PCI-Fast4 series */
		case (0x9030&lt;&lt;16)|0x10B5:	/* Perle Ultraport series */
			/*
			 * These devices consists of a PLX bridge (the above
			 * PCI VID+DID) behind which are some 16C654 UARTs.
			 * Must check the subsystem VID and DID for correct
			 * match.
			 */
			subid = pcicfgr16(p, PciSVID);
			subid |= pcicfgr16(p, PciSID)&lt;&lt;16;
			freq = 7372800;
			switch(subid){
			default:
				print("uartpci: unknown perle subid %#ux\n",
					subid);
				continue;
			case (0x1588&lt;&lt;16)|0x10B5: /* StarTech PCI8S9503V (P588UG) */
				name = "P588UG";
				/* max. baud rate is 921,600 */
				freq = 1843200;
				uart = uartpci(ctlrno, p, 2, 8, freq, name, 8);
				break;
			case (0x0011&lt;&lt;16)|0x12E0:	/* Perle PCI-Fast16 */
				name = "PCI-Fast16";
				uart = uartpci(ctlrno, p, 2, 16, freq, name, 8);
				break;
			case (0x0021&lt;&lt;16)|0x12E0:	/* Perle PCI-Fast8 */
				name = "PCI-Fast8";
				uart = uartpci(ctlrno, p, 2, 8, freq, name, 8);
				break;
			case (0x0031&lt;&lt;16)|0x12E0:	/* Perle PCI-Fast4 */
				name = "PCI-Fast4";
				uart = uartpci(ctlrno, p, 2, 4, freq, name, 8);
				break;
			case (0x0021&lt;&lt;16)|0x155F:	/* Perle Ultraport8 */
				name = "Ultraport8";	/* 16C754 UARTs */
				uart = uartpci(ctlrno, p, 2, 8, freq, name, 8);
				break;
			case (0x0041&lt;&lt;16)|0x155F:	/* Perle Ultraport16 */
				name = "Ultraport16";
				uart = uartpci(ctlrno, p, 2, 16, 2 * freq,
					name, 8);
				break;
			case (0x0241&lt;&lt;16)|0x155F:	/* Perle Ultraport16 */
				uart = ultraport16si(ctlrno, p, 4 * freq);
				break;
			}
			break;
		}
		if(uart)
			ctlrno++;
	}

	return perlehead;
}

PhysUart pciphysuart = {
	.name		= "UartPCI",
	.pnp		= uartpcipnp,
	.enable		= nil,
	.disable	= nil,
	.kick		= nil,
	.dobreak	= nil,
	.baud		= nil,
	.bits		= nil,
	.stop		= nil,
	.parity		= nil,
	.modemctl	= nil,
	.rts		= nil,
	.dtr		= nil,
	.status		= nil,
	.fifo		= nil,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

