<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/usbehcipc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/usbehcipc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * PC-specific code for
 * USB Enhanced Host Controller Interface (EHCI) driver
 * High speed USB 2.0.
 */

#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"
#include	"../port/usb.h"
#include	"../port/portusbehci.h"
#include	"usbehci.h"

static Ctlr* ctlrs[Nhcis];
static int maxehci = Nhcis;

/* Isn't this cap list search in a helper function? */
static void
getehci(Ctlr* ctlr)
{
	int i, ptr, cap, sem;

	ptr = (ctlr-&gt;capio-&gt;capparms &gt;&gt; Ceecpshift) &amp; Ceecpmask;
	for(; ptr != 0; ptr = pcicfgr8(ctlr-&gt;pcidev, ptr+1)){
		if(ptr &lt; 0x40 || (ptr &amp; ~0xFC))
			break;
		cap = pcicfgr8(ctlr-&gt;pcidev, ptr);
		if(cap != Clegacy)
			continue;
		sem = pcicfgr8(ctlr-&gt;pcidev, ptr+CLbiossem);
		if(sem == 0)
			continue;
		pcicfgw8(ctlr-&gt;pcidev, ptr+CLossem, 1);
		for(i = 0; i &lt; 100; i++){
			if(pcicfgr8(ctlr-&gt;pcidev, ptr+CLbiossem) == 0)
				break;
			delay(10);
		}
		if(i == 100)
			dprint("ehci %#p: bios timed out\n", ctlr-&gt;capio);
		pcicfgw32(ctlr-&gt;pcidev, ptr+CLcontrol, 0);	/* no SMIs */
		ctlr-&gt;opio-&gt;config = 0;
		coherence();
		return;
	}
}

static void
ehcireset(Ctlr *ctlr)
{
	Eopio *opio;
	int i;

	ilock(ctlr);
	dprint("ehci %#p reset\n", ctlr-&gt;capio);
	opio = ctlr-&gt;opio;

	/*
	 * Turn off legacy mode. Some controllers won't
	 * interrupt us as expected otherwise.
	 */
	ehcirun(ctlr, 0);
	pcicfgw16(ctlr-&gt;pcidev, 0xc0, 0x2000);

	/*
	 * reclaim from bios
	 */
	getehci(ctlr);

	/* clear high 32 bits of address signals if it's 64 bits capable.
	 * This is probably not needed but it does not hurt and others do it.
	 */
	if((ctlr-&gt;capio-&gt;capparms &amp; C64) != 0){
		dprint("ehci: 64 bits\n");
		opio-&gt;seg = 0;
		coherence();
	}

	if(ehcidebugcapio != ctlr-&gt;capio){
		opio-&gt;cmd |= Chcreset;	/* controller reset */
		coherence();
		for(i = 0; i &lt; 100; i++){
			if((opio-&gt;cmd &amp; Chcreset) == 0)
				break;
			delay(1);
		}
		if(i == 100)
			print("ehci %#p controller reset timed out\n", ctlr-&gt;capio);
	}

	/* requesting more interrupts per µframe may miss interrupts */
	opio-&gt;cmd &amp;= ~Citcmask;
	opio-&gt;cmd |= 1 &lt;&lt; Citcshift;		/* max of 1 intr. per 125 µs */
	coherence();
	switch(opio-&gt;cmd &amp; Cflsmask){
	case Cfls1024:
		ctlr-&gt;nframes = 1024;
		break;
	case Cfls512:
		ctlr-&gt;nframes = 512;
		break;
	case Cfls256:
		ctlr-&gt;nframes = 256;
		break;
	default:
		panic("ehci: unknown fls %ld", opio-&gt;cmd &amp; Cflsmask);
	}
	dprint("ehci: %d frames\n", ctlr-&gt;nframes);
	iunlock(ctlr);
}

static void
setdebug(Hci*, int d)
{
	ehcidebug = d;
}

static void
shutdown(Hci *hp)
{
	int i;
	Ctlr *ctlr;
	Eopio *opio;

	ctlr = hp-&gt;aux;
	ilock(ctlr);
	opio = ctlr-&gt;opio;
	opio-&gt;cmd |= Chcreset;		/* controller reset */
	coherence();
	for(i = 0; i &lt; 100; i++){
		if((opio-&gt;cmd &amp; Chcreset) == 0)
			break;
		delay(1);
	}
	if(i &gt;= 100)
		print("ehci %#p controller reset timed out\n", ctlr-&gt;capio);
	delay(100);
	ehcirun(ctlr, 0);
	opio-&gt;frbase = 0;
	iunlock(ctlr);
}

static void
scanpci(void)
{
	static int already = 0;
	int i;
	ulong io;
	Ctlr *ctlr;
	Pcidev *p;
	Ecapio *capio;

	if(already)
		return;
	already = 1;
	p = nil;
	while ((p = pcimatch(p, 0, 0)) != nil) {
		/*
		 * Find EHCI controllers (Programming Interface = 0x20).
		 */
		if(p-&gt;ccrb != Pcibcserial || p-&gt;ccru != Pciscusb)
			continue;
		switch(p-&gt;ccrp){
		case 0x20:
			io = p-&gt;mem[0].bar &amp; ~0x0f;
			break;
		default:
			continue;
		}
		if(0 &amp;&amp; p-&gt;vid == Vintel &amp;&amp; p-&gt;did == 0x3b34) {
			print("usbehci: ignoring known bad ctlr %#ux/%#ux\n",
				p-&gt;vid, p-&gt;did);
			continue;
		}
		if(io == 0){
			print("usbehci: %x %x: failed to map registers\n",
				p-&gt;vid, p-&gt;did);
			continue;
		}
		if(p-&gt;intl == 0xff || p-&gt;intl == 0) {
			print("usbehci: no irq assigned for port %#lux\n", io);
			continue;
		}
		dprint("usbehci: %#x %#x: port %#lux size %#x irq %d\n",
			p-&gt;vid, p-&gt;did, io, p-&gt;mem[0].size, p-&gt;intl);

		ctlr = malloc(sizeof(Ctlr));
		if (ctlr == nil)
			panic("usbehci: out of memory");
		ctlr-&gt;pcidev = p;
		capio = ctlr-&gt;capio = vmap(io, p-&gt;mem[0].size);
		ctlr-&gt;opio = (Eopio*)((uintptr)capio + (capio-&gt;cap &amp; 0xff));
		pcisetbme(p);
		pcisetpms(p, 0);
		for(i = 0; i &lt; Nhcis; i++)
			if(ctlrs[i] == nil){
				ctlrs[i] = ctlr;
				break;
			}
		if(i &gt;= Nhcis)
			print("ehci: bug: more than %d controllers\n", Nhcis);

		/*
		 * currently, if we enable a second ehci controller on zt
		 * systems w x58m motherboard, we'll wedge solid after iunlock
		 * in init for the second one.
		 */
		if (i &gt;= maxehci) {
			print("usbehci: ignoring controllers after first %d, "
				"at %#p\n", maxehci, io);
			ctlrs[i] = nil;
		}
	}
}

static int
reset(Hci *hp)
{
	int i;
	char *s;
	Ctlr *ctlr;
	Ecapio *capio;
	Pcidev *p;
	static Lock resetlck;

	s = getconf("*maxehci");
	if (s != nil &amp;&amp; s[0] &gt;= '0' &amp;&amp; s[0] &lt;= '9')
		maxehci = atoi(s);
	if(maxehci == 0 || getconf("*nousbehci"))
		return -1;

	ilock(&amp;resetlck);
	scanpci();

	/*
	 * Any adapter matches if no hp-&gt;port is supplied,
	 * otherwise the ports must match.
	 */
	ctlr = nil;
	for(i = 0; i &lt; Nhcis &amp;&amp; ctlrs[i] != nil; i++){
		ctlr = ctlrs[i];
		if(ctlr-&gt;active == 0)
		if(hp-&gt;port == 0 || hp-&gt;port == (uintptr)ctlr-&gt;capio){
			ctlr-&gt;active = 1;
			break;
		}
	}
	iunlock(&amp;resetlck);
	if(i &gt;= Nhcis || ctlrs[i] == nil)
		return -1;

	p = ctlr-&gt;pcidev;
	hp-&gt;aux = ctlr;
	hp-&gt;port = (uintptr)ctlr-&gt;capio;
	hp-&gt;irq = p-&gt;intl;
	hp-&gt;tbdf = p-&gt;tbdf;

	capio = ctlr-&gt;capio;
	hp-&gt;nports = capio-&gt;parms &amp; Cnports;

	ddprint("echi: %s, ncc %lud npcc %lud\n",
		capio-&gt;parms &amp; 0x10000 ? "leds" : "no leds",
		(capio-&gt;parms &gt;&gt; 12) &amp; 0xf, (capio-&gt;parms &gt;&gt; 8) &amp; 0xf);
	ddprint("ehci: routing %s, %sport power ctl, %d ports\n",
		capio-&gt;parms &amp; 0x40 ? "explicit" : "automatic",
		capio-&gt;parms &amp; 0x10 ? "" : "no ", hp-&gt;nports);

	ehcireset(ctlr);
	ehcimeminit(ctlr);

	/*
	 * Linkage to the generic HCI driver.
	 */
	ehcilinkage(hp);
	hp-&gt;shutdown = shutdown;
	hp-&gt;debug = setdebug;
	return 0;
}

void
usbehcilink(void)
{
	addhcitype("ehci", reset);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

