<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgahiqvideo.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgahiqvideo.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

enum {
	Xrx		= 0x3D6,	/* Configuration Extensions Index */
};

static uchar
hiqvideoxi(long port, uchar index)
{
	uchar data;

	outb(port, index);
	data = inb(port+1);

	return data;
}

static void
hiqvideoxo(long port, uchar index, uchar data)
{
	outb(port, index);
	outb(port+1, data);
}

static void
hiqvideolinear(VGAscr*, int, int)
{
}

static void
hiqvideoenable(VGAscr* scr)
{
	Pcidev *p;
	int vmsize;

	/*
	 * Only once, can't be disabled for now.
	 */
	if(scr-&gt;mmio)
		return;
	if(p = pcimatch(nil, 0x102C, 0)){
		switch(p-&gt;did){
		case 0x00C0:		/* 69000 HiQVideo */
			vmsize = 2*1024*1024;
			break;
		case 0x00E0:		/* 65550 HiQV32 */
		case 0x00E4:		/* 65554 HiQV32 */
		case 0x00E5:		/* 65555 HiQV32 */
			switch((hiqvideoxi(Xrx, 0x43)&gt;&gt;1) &amp; 0x03){
			default:
			case 0:
				vmsize = 1*1024*1024;
				break;
			case 1:
				vmsize = 2*1024*1024;
				break;
			}
			break;
		default:
			return;
		}
	}
	else
		return;

	scr-&gt;pci = p;
	vgalinearpci(scr);
	
	if(scr-&gt;paddr) {
		addvgaseg("hiqvideoscreen", scr-&gt;paddr, scr-&gt;apsize);
	}

	/*
	 * Find a place for the cursor data in display memory.
	 * Must be on a 4096-byte boundary.
	 * scr-&gt;mmio holds the virtual address of the cursor
	 * storage area in the framebuffer region.
	 */
	scr-&gt;storage = vmsize-4096;
	scr-&gt;mmio = (ulong*)((uchar*)scr-&gt;vaddr+scr-&gt;storage);
}

static void
hiqvideocurdisable(VGAscr*)
{
	hiqvideoxo(Xrx, 0xA0, 0x10);
}

static void
hiqvideocurload(VGAscr* scr, Cursor* curs)
{
	uchar *p;
	int x, y;

	/*
	 * Disable the cursor.
	 */
	hiqvideocurdisable(scr);

	if(scr-&gt;mmio == 0)
		return;
	p = (uchar*)scr-&gt;mmio;

	for(y = 0; y &lt; 16; y += 2){
		*p++ = ~(curs-&gt;clr[2*y]|curs-&gt;set[2*y]);
		*p++ = ~(curs-&gt;clr[2*y+1]|curs-&gt;set[2*y+1]);
		*p++ = 0xFF;
		*p++ = 0xFF;
		*p++ = ~(curs-&gt;clr[2*y+2]|curs-&gt;set[2*y+2]);
		*p++ = ~(curs-&gt;clr[2*y+3]|curs-&gt;set[2*y+3]);
		*p++ = 0xFF;
		*p++ = 0xFF;
		*p++ = curs-&gt;set[2*y];
		*p++ = curs-&gt;set[2*y+1];
		*p++ = 0x00;
		*p++ = 0x00;
		*p++ = curs-&gt;set[2*y+2];
		*p++ = curs-&gt;set[2*y+3];
		*p++ = 0x00;
		*p++ = 0x00;
	}
	while(y &lt; 32){
		for(x = 0; x &lt; 64; x += 8)
			*p++ = 0xFF;
		for(x = 0; x &lt; 64; x += 8)
			*p++ = 0x00;
		y += 2;
	}

	/*
	 * Save the cursor hotpoint and enable the cursor.
	 */
	scr-&gt;offset = curs-&gt;offset;
	hiqvideoxo(Xrx, 0xA0, 0x11);
}

static int
hiqvideocurmove(VGAscr* scr, Point p)
{
	int x, y;

	if(scr-&gt;mmio == 0)
		return 1;

	if((x = p.x+scr-&gt;offset.x) &lt; 0)
		x = 0x8000|(-x &amp; 0x07FF);
	if((y = p.y+scr-&gt;offset.y) &lt; 0)
		y = 0x8000|(-y &amp; 0x07FF);

	hiqvideoxo(Xrx, 0xA4, x &amp; 0xFF);
	hiqvideoxo(Xrx, 0xA5, (x&gt;&gt;8) &amp; 0xFF);
	hiqvideoxo(Xrx, 0xA6, y &amp; 0xFF);
	hiqvideoxo(Xrx, 0xA7, (y&gt;&gt;8) &amp; 0xFF);

	return 0;
}

static void
hiqvideocurenable(VGAscr* scr)
{
	uchar xr80;

	hiqvideoenable(scr);
	if(scr-&gt;mmio == 0)
		return;

	/*
	 * Disable the cursor.
	 */
	hiqvideocurdisable(scr);

	/*
	 * Cursor colours.
	 * Can't call setcolor here as cursor is already locked.
	 * When done make sure the cursor enable in Xr80 is set.
	 */
	xr80 = hiqvideoxi(Xrx, 0x80);
	hiqvideoxo(Xrx, 0x80, xr80|0x01);
	vgao(PaddrW, 0x04);
	vgao(Pdata, Pwhite);
	vgao(Pdata, Pwhite);
	vgao(Pdata, Pwhite);
	vgao(Pdata, Pblack);
	vgao(Pdata, Pblack);
	vgao(Pdata, Pblack);
	hiqvideoxo(Xrx, 0x80, xr80|0x10);

	hiqvideoxo(Xrx, 0xA2, (scr-&gt;storage&gt;&gt;12)&lt;&lt;4);
	hiqvideoxo(Xrx, 0xA3, (scr-&gt;storage&gt;&gt;16) &amp; 0x3F);

	/*
	 * Load, locate and enable the 32x32 cursor.
	 * Cursor enable in Xr80 better be set already.
	 */
	hiqvideocurload(scr, &amp;arrow);
	hiqvideocurmove(scr, ZP);
	hiqvideoxo(Xrx, 0xA0, 0x11);
}

VGAdev vgahiqvideodev = {
	"hiqvideo",

	hiqvideoenable,			/* enable */
	nil,				/* disable */
	nil,				/* page */
	hiqvideolinear,			/* linear */
};

VGAcur vgahiqvideocur = {
	"hiqvideohwgc",

	hiqvideocurenable,		/* enable */
	hiqvideocurdisable,		/* disable */
	hiqvideocurload,		/* load */
	hiqvideocurmove,		/* move */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

