<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgai81x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgai81x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

typedef struct
{
	ushort	ctl;
	ushort	pad;
	ulong	base;
	ulong	pos;
} CursorI81x;

enum {
	Fbsize		= 8*MB,

	hwCur		= 0x70080,
	SRX		= 0x3c4,
	DPMSsync	= 0x5002,
};

static void
i81xblank(VGAscr *scr, int blank)
{
	char *srx, *srxd, *dpms;
	char sr01, mode;

	srx = (char *)scr-&gt;mmio+SRX;
	srxd = srx+1;
	dpms = (char *)scr-&gt;mmio+DPMSsync;

	*srx = 0x01;
	sr01 = *srxd &amp; ~0x20;
	mode = *dpms &amp; 0xf0;

	if(blank) {
		sr01 |= 0x20;
		mode |= 0x0a;
	}
	*srxd = sr01;
	*dpms = mode;
}

static Pcidev *
i81xpcimatch(void)
{
	Pcidev *p;

	p = nil;
	while((p = pcimatch(p, 0x8086, 0)) != nil){
		switch(p-&gt;did){
		default:
			continue;
		case 0x7121:
		case 0x7123:
		case 0x7125:
		case 0x1102:
		case 0x1112:
		case 0x1132:
		case 0x3577:	/* IBM R31 uses intel 830M chipset */
			return p;
		}
	}
	return nil;
}

static void
i81xenable(VGAscr* scr)
{
	Pcidev *p;
	int size;
	Mach *mach0;
	ulong *pgtbl, *rp, cursor, *pte, fbuf, fbend;
	
	if(scr-&gt;mmio)
		return;
	p = i81xpcimatch();
	if(p == nil)
		return;
	scr-&gt;mmio = vmap(p-&gt;mem[1].bar &amp; ~0x0F, p-&gt;mem[1].size);
	if(scr-&gt;mmio == 0)
		return;
	addvgaseg("i81xmmio", p-&gt;mem[1].bar&amp;~0x0F, p-&gt;mem[1].size);

	/* allocate page table */
	pgtbl = xspanalloc(64*1024, BY2PG, 0);
	scr-&gt;mmio[0x2020/4] = PADDR(pgtbl) | 1;

	size = p-&gt;mem[0].size;
	if(size &gt; 0)
		size = Fbsize;
	vgalinearaddr(scr, p-&gt;mem[0].bar&amp;~0xF, size);
	addvgaseg("i81xscreen", p-&gt;mem[0].bar&amp;~0xF, size);

	/*
	 * allocate backing store for frame buffer
	 * and populate device page tables.
	 */
	fbuf = PADDR(xspanalloc(size, BY2PG, 0));
	fbend = PGROUND(fbuf+size);
	rp = scr-&gt;mmio+0x10000/4;
	while(fbuf &lt; fbend) {
		*rp++ = fbuf | 1;
		fbuf += BY2PG;
	}

	/*
	 * allocate space for the cursor data in system memory.
	 * must be uncached.
	 */
	cursor = (ulong)xspanalloc(BY2PG, BY2PG, 0);
	mach0 = MACHP(0);
	pte = mmuwalk(mach0-&gt;pdb, cursor, 2, 0);
	if(pte == nil)
		panic("i81x cursor mmuwalk");
	*pte |= PTEUNCACHED;
	scr-&gt;storage = cursor;

	scr-&gt;blank = i81xblank;
	hwblank = 1;
}

static void
i81xcurdisable(VGAscr* scr)
{
	CursorI81x *hwcurs;

	if(scr-&gt;mmio == 0)
		return;
	hwcurs = (void*)((uchar*)scr-&gt;mmio+hwCur);
	hwcurs-&gt;ctl = (1&lt;&lt;4);
}

static void
i81xcurload(VGAscr* scr, Cursor* curs)
{
	int y;
	uchar *p;
	CursorI81x *hwcurs;

	if(scr-&gt;mmio == 0)
		return;
	hwcurs = (void*)((uchar*)scr-&gt;mmio+hwCur);

	/*
	 * Disable the cursor then load the new image in
	 * the top-left of the 32x32 array.
	 * Unused portions of the image have been initialised to be
	 * transparent.
	 */
	hwcurs-&gt;ctl = (1&lt;&lt;4);
	p = (uchar*)scr-&gt;storage;
	for(y = 0; y &lt; 16; y += 2) {
		*p++ = ~(curs-&gt;clr[2*y]|curs-&gt;set[2*y]);
		*p++ = ~(curs-&gt;clr[2*y+1]|curs-&gt;set[2*y+1]);
		p += 2;
		*p++ = ~(curs-&gt;clr[2*y+2]|curs-&gt;set[2*y+2]);
		*p++ = ~(curs-&gt;clr[2*y+3]|curs-&gt;set[2*y+3]);
		p += 2;
		*p++ = curs-&gt;set[2*y];
		*p++ = curs-&gt;set[2*y+1];
		p += 2;
		*p++ = curs-&gt;set[2*y+2];
		*p++ = curs-&gt;set[2*y+3];
		p += 2;
	}

	/*
	 * Save the cursor hotpoint and enable the cursor.
	 * The 0,0 cursor point is top-left.
	 */
	scr-&gt;offset.x = curs-&gt;offset.x;
	scr-&gt;offset.y = curs-&gt;offset.y;
	hwcurs-&gt;ctl = (1&lt;&lt;4)|1;
}

static int
i81xcurmove(VGAscr* scr, Point p)
{
	int x, y;
	ulong pos;
	CursorI81x *hwcurs;

	if(scr-&gt;mmio == 0)
		return 1;
	hwcurs = (void*)((uchar*)scr-&gt;mmio+hwCur);

	x = p.x+scr-&gt;offset.x;
	y = p.y+scr-&gt;offset.y;
	pos = 0;
	if(x &lt; 0) {
		pos |= (1&lt;&lt;15);
		x = -x;
	}
	if(y &lt; 0) {
		pos |= (1&lt;&lt;31);
		y = -y;
	}
	pos |= ((y&amp;0x7ff)&lt;&lt;16)|(x&amp;0x7ff);
	hwcurs-&gt;pos = pos;

	return 0;
}

static void
i81xcurenable(VGAscr* scr)
{
	int i;
	uchar *p;
	CursorI81x *hwcurs;

	i81xenable(scr);
	if(scr-&gt;mmio == 0)
		return;
	hwcurs = (void*)((uchar*)scr-&gt;mmio+hwCur);

	/*
	 * Initialise the 32x32 cursor to be transparent in 2bpp mode.
	 */
	hwcurs-&gt;base = PADDR(scr-&gt;storage);
	p = (uchar*)scr-&gt;storage;
	for(i = 0; i &lt; 32/2; i++) {
		memset(p, 0xff, 8);
		memset(p+8, 0, 8);
		p += 16;
	}
	/*
	 * Load, locate and enable the 32x32 cursor in 2bpp mode.
	 */
	i81xcurload(scr, &amp;arrow);
	i81xcurmove(scr, ZP);
}

VGAdev vgai81xdev = {
	"i81x",

	i81xenable,
	nil,
	nil,
	nil,
};

VGAcur vgai81xcur = {
	"i81xhwgc",

	i81xcurenable,
	i81xcurdisable,
	i81xcurload,
	i81xcurmove,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

