<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vganvidia.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vganvidia.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->

/* Portions of this file derived from work with the following copyright */

 /***************************************************************************\
|*                                                                           *|
|*       Copyright 2003 NVIDIA, Corporation.  All rights reserved.           *|
|*                                                                           *|
|*     NOTICE TO USER:   The source code  is copyrighted under  U.S. and     *|
|*     international laws.  Users and possessors of this source code are     *|
|*     hereby granted a nonexclusive,  royalty-free copyright license to     *|
|*     use this code in individual and commercial software.                  *|
|*                                                                           *|
|*     Any use of this source code must include,  in the user documenta-     *|
|*     tion and  internal comments to the code,  notices to the end user     *|
|*     as follows:                                                           *|
|*                                                                           *|
|*       Copyright 2003 NVIDIA, Corporation.  All rights reserved.           *|
|*                                                                           *|
|*     NVIDIA, CORPORATION MAKES NO REPRESENTATION ABOUT THE SUITABILITY     *|
|*     OF  THIS SOURCE  CODE  FOR ANY PURPOSE.  IT IS  PROVIDED  "AS IS"     *|
|*     WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND.  NVIDIA, CORPOR-     *|
|*     ATION DISCLAIMS ALL WARRANTIES  WITH REGARD  TO THIS SOURCE CODE,     *|
|*     INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, NONINFRINGE-     *|
|*     MENT,  AND FITNESS  FOR A PARTICULAR PURPOSE.   IN NO EVENT SHALL     *|
|*     NVIDIA, CORPORATION  BE LIABLE FOR ANY SPECIAL,  INDIRECT,  INCI-     *|
|*     DENTAL, OR CONSEQUENTIAL DAMAGES,  OR ANY DAMAGES  WHATSOEVER RE-     *|
|*     SULTING FROM LOSS OF USE,  DATA OR PROFITS,  WHETHER IN AN ACTION     *|
|*     OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,  ARISING OUT OF     *|
|*     OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOURCE CODE.     *|
|*                                                                           *|
|*     U.S. Government  End  Users.   This source code  is a "commercial     *|
|*     item,"  as that  term is  defined at  48 C.F.R. 2.101 (OCT 1995),     *|
|*     consisting  of "commercial  computer  software"  and  "commercial     *|
|*     computer  software  documentation,"  as such  terms  are  used in     *|
|*     48 C.F.R. 12.212 (SEPT 1995)  and is provided to the U.S. Govern-     *|
|*     ment only as  a commercial end item.   Consistent with  48 C.F.R.     *|
|*     12.212 and  48 C.F.R. 227.7202-1 through  227.7202-4 (JUNE 1995),     *|
|*     all U.S. Government End Users  acquire the source code  with only     *|
|*     those rights set forth herein.                                        *|
|*                                                                           *|
 \***************************************************************************/

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"
#include "nv_dma.h"

enum {
	Pramin = 0x00710000,
	Pramdac = 0x00680000,
	Fifo = 0x00800000,
	Pgraph = 0x00400000,
	Pfb = 0x00100000
};

enum {
	hwCurPos = Pramdac + 0x0300,
};

#define SKIPS 8

struct {
	ulong	*dmabase;
	int		dmacurrent;
	int		dmaput;
	int		dmafree;
	int		dmamax;
} nv;

static Pcidev*
nvidiapci(void)
{
	Pcidev *p;

	p = nil;
	while((p = pcimatch(p, 0x10DE, 0)) != nil){
		if(p-&gt;did &gt;= 0x20 &amp;&amp; p-&gt;ccrb == 3)	/* video card */
			return p;
	}
	return nil;
}

static void
nvidialinear(VGAscr*, int, int)
{
}

static void
nvidiaenable(VGAscr* scr)
{
	Pcidev *p;
	ulong *q;
	int tmp;

	if(scr-&gt;mmio)
		return;
	p = nvidiapci();
	if(p == nil)
		return;
	scr-&gt;id = p-&gt;did;
	scr-&gt;pci = p;

	scr-&gt;mmio = vmap(p-&gt;mem[0].bar &amp; ~0x0F, p-&gt;mem[0].size);
	if(scr-&gt;mmio == nil)
		return;
	addvgaseg("nvidiammio", p-&gt;mem[0].bar&amp;~0x0F, p-&gt;mem[0].size);

	vgalinearpci(scr);
	if(scr-&gt;apsize)
		addvgaseg("nvidiascreen", scr-&gt;paddr, scr-&gt;apsize);

	/* find video memory size */
	switch (scr-&gt;id &amp; 0x0ff0) {
	case 0x0020:
	case 0x00A0:
		q = (void*)((uchar*)scr-&gt;mmio + Pfb);
		tmp = *q;
		if (tmp &amp; 0x0100) {
			scr-&gt;storage = ((tmp &gt;&gt; 12) &amp; 0x0F) * 1024 + 1024 * 2;
		} else {
			tmp &amp;= 0x03;
			if (tmp)
				scr-&gt;storage = (1024*1024*2) &lt;&lt; tmp;
			else
				scr-&gt;storage = 1024*1024*32;
		}
		break;
	case 0x01A0:
		p = pcimatchtbdf(MKBUS(BusPCI, 0, 0, 1));
		tmp = pcicfgr32(p, 0x7C);
		scr-&gt;storage = (((tmp &gt;&gt; 6) &amp; 31) + 1) * 1024 * 1024;
		break;
	case 0x01F0:
		p = pcimatchtbdf(MKBUS(BusPCI, 0, 0, 1));
		tmp = pcicfgr32(p, 0x84);
		scr-&gt;storage = (((tmp &gt;&gt; 4) &amp; 127) + 1) * 1024 * 1024;
		break;
	default:
		q = (void*)((uchar*)scr-&gt;mmio + Pfb + 0x020C);
		tmp = (*q &gt;&gt; 20) &amp; 0xFFF;
		if (tmp == 0)
			tmp = 16;
		scr-&gt;storage = tmp*1024*1024;
		break;
	}
}

static void
nvidiacurdisable(VGAscr* scr)
{
	if(scr-&gt;mmio == 0)
		return;

	vgaxo(Crtx, 0x31, vgaxi(Crtx, 0x31) &amp; ~0x01);
}


static void
nvidiacurload(VGAscr* scr, Cursor* curs)
{
	ulong*	p;
	int	i,j;
	ushort	c,s;
	ulong	tmp;

	if(scr-&gt;mmio == 0)
		return;

	vgaxo(Crtx, 0x31, vgaxi(Crtx, 0x31) &amp; ~0x01);

	switch (scr-&gt;id &amp; 0x0ff0) {
	case 0x0020:
	case 0x00A0:
		p = (void*)((uchar*)scr-&gt;mmio + Pramin + 0x1E00 * 4);
		break;
	default:
		/*
		 * Reset the cursor location, since the kernel may
		 * have allocated less storage than aux/vga
		 * expected.
		 */
		tmp = scr-&gt;apsize - 96*1024;
		p = (void*)((uchar*)scr-&gt;vaddr + tmp);
		vgaxo(Crtx, 0x30, 0x80|(tmp&gt;&gt;17));
		vgaxo(Crtx, 0x31, (tmp&gt;&gt;11)&lt;&lt;2);
		vgaxo(Crtx, 0x2F, tmp&gt;&gt;24);
		break;
	}

	for(i=0; i&lt;16; i++) {
		c = (curs-&gt;clr[2 * i] &lt;&lt; 8) | curs-&gt;clr[2 * i+1];
		s = (curs-&gt;set[2 * i] &lt;&lt; 8) | curs-&gt;set[2 * i+1];
		tmp = 0;
		for (j=0; j&lt;16; j++){
			if(s&amp;0x8000)
				tmp |= 0x80000000;
			else if(c&amp;0x8000)
				tmp |= 0xFFFF0000;
			if (j&amp;0x1){
				*p++ = tmp;
				tmp = 0;
			} else {
				tmp&gt;&gt;=16;
			}
			c&lt;&lt;=1;
			s&lt;&lt;=1;
		}
		for (j=0; j&lt;8; j++)
			*p++ = 0;
	}
	for (i=0; i&lt;256; i++)
		*p++ = 0;

	scr-&gt;offset = curs-&gt;offset;
	vgaxo(Crtx, 0x31, vgaxi(Crtx, 0x31) | 0x01);

	return;
}

static int
nvidiacurmove(VGAscr* scr, Point p)
{
	ulong*	cursorpos;

	if(scr-&gt;mmio == 0)
		return 1;

	cursorpos = (void*)((uchar*)scr-&gt;mmio + hwCurPos);
	*cursorpos = ((p.y+scr-&gt;offset.y)&lt;&lt;16)|((p.x+scr-&gt;offset.x) &amp; 0xFFFF);

	return 0;
}

static void
nvidiacurenable(VGAscr* scr)
{
	nvidiaenable(scr);
	if(scr-&gt;mmio == 0)
		return;

	vgaxo(Crtx, 0x1F, 0x57);

	nvidiacurload(scr, &amp;arrow);
	nvidiacurmove(scr, ZP);

	vgaxo(Crtx, 0x31, vgaxi(Crtx, 0x31) | 0x01);
}

void
writeput(VGAscr *scr, int data)
{
	uchar	*p, scratch;
	ulong	*fifo;

	outb(0x3D0,0);
	p = scr-&gt;vaddr;
	scratch = *p;
	fifo = (void*)((uchar*)scr-&gt;mmio + Fifo);
	fifo[0x10] = (data &lt;&lt; 2);
	USED(scratch);
}

ulong
readget(VGAscr *scr)
{
	ulong	*fifo;

	fifo = (void*)((uchar*)scr-&gt;mmio + Fifo);
	return (fifo[0x0011] &gt;&gt; 2);
}

void
nvdmakickoff(VGAscr *scr)
{
	if(nv.dmacurrent != nv.dmaput) {
		nv.dmaput = nv.dmacurrent;
		writeput(scr, nv.dmaput);
	}
}

static void
nvdmanext(ulong data)
{
	nv.dmabase[nv.dmacurrent++] = data;
}

void
nvdmawait(VGAscr *scr, int size)
{
	int dmaget;

	size++;

	while(nv.dmafree &lt; size) {
		dmaget = readget(scr);

		if(nv.dmaput &gt;= dmaget) {
			nv.dmafree = nv.dmamax - nv.dmacurrent;
			if(nv.dmafree &lt; size) {
				nvdmanext(0x20000000);
				if(dmaget &lt;= SKIPS) {
					if (nv.dmaput &lt;= SKIPS) /* corner case - will be idle */
						writeput(scr, SKIPS + 1);
					do { dmaget = readget(scr); }
					while(dmaget &lt;= SKIPS);
				}
				writeput(scr, SKIPS);
				nv.dmacurrent = nv.dmaput = SKIPS;
				nv.dmafree = dmaget - (SKIPS + 1);
			}
		} else
			nv.dmafree = dmaget - nv.dmacurrent - 1;
	}
}


static void
nvdmastart(VGAscr *scr, ulong tag, int size)
{
	if (nv.dmafree &lt;= size)
		nvdmawait(scr, size);
	nvdmanext((size &lt;&lt; 18) | tag);
	nv.dmafree -= (size + 1);
}

static void
waitforidle(VGAscr *scr)
{
	ulong*	pgraph;
	int x;

	pgraph = (void*)((uchar*)scr-&gt;mmio + Pgraph);

	x = 0;
	while((readget(scr) != nv.dmaput) &amp;&amp; x++ &lt; 1000000)
		;
	if(x &gt;= 1000000)
		iprint("idle stat %lud put %d scr %#p pc %#p\n", readget(scr), nv.dmaput, scr, getcallerpc(&amp;scr));

	x = 0;
	while(pgraph[0x00000700/4] &amp; 0x01 &amp;&amp; x++ &lt; 1000000)
		;

	if(x &gt;= 1000000)
		iprint("idle stat %lud scrio %#p scr %#p pc %#p\n", *pgraph, scr-&gt;mmio, scr, getcallerpc(&amp;scr));
}

static void
nvresetgraphics(VGAscr *scr)
{
	ulong	surfaceFormat, patternFormat, rectFormat, lineFormat;
	int		pitch, i;

	pitch = scr-&gt;gscreen-&gt;width*BY2WD;

	/*
	 * DMA is at the end of the virtual window,
	 * but we might have cut it short when mapping it.
	 */
	if(nv.dmabase == nil){
		if(scr-&gt;storage &lt;= scr-&gt;apsize)
			nv.dmabase = (ulong*)((uchar*)scr-&gt;vaddr + scr-&gt;storage - 128*1024);
		else{
			nv.dmabase = (void*)vmap(scr-&gt;paddr + scr-&gt;storage - 128*1024, 128*1024);
			if(nv.dmabase == 0){
				hwaccel = 0;
				hwblank = 0;
				print("vmap nvidia dma failed\n");
				return;
			}
		}
	}

	for(i=0; i&lt;SKIPS; i++)
		nv.dmabase[i] = 0x00000000;

	nv.dmabase[0x0 + SKIPS] = 0x00040000;
	nv.dmabase[0x1 + SKIPS] = 0x80000010;
	nv.dmabase[0x2 + SKIPS] = 0x00042000;
	nv.dmabase[0x3 + SKIPS] = 0x80000011;
	nv.dmabase[0x4 + SKIPS] = 0x00044000;
	nv.dmabase[0x5 + SKIPS] = 0x80000012;
	nv.dmabase[0x6 + SKIPS] = 0x00046000;
	nv.dmabase[0x7 + SKIPS] = 0x80000013;
	nv.dmabase[0x8 + SKIPS] = 0x00048000;
	nv.dmabase[0x9 + SKIPS] = 0x80000014;
	nv.dmabase[0xA + SKIPS] = 0x0004A000;
	nv.dmabase[0xB + SKIPS] = 0x80000015;
	nv.dmabase[0xC + SKIPS] = 0x0004C000;
	nv.dmabase[0xD + SKIPS] = 0x80000016;
	nv.dmabase[0xE + SKIPS] = 0x0004E000;
	nv.dmabase[0xF + SKIPS] = 0x80000017;

	nv.dmaput = 0;
	nv.dmacurrent = 16 + SKIPS;
	nv.dmamax = 8191;
	nv.dmafree = nv.dmamax - nv.dmacurrent;

	switch(scr-&gt;gscreen-&gt;depth) {
	case 32:
	case 24:
		surfaceFormat = SURFACE_FORMAT_DEPTH24;
		patternFormat = PATTERN_FORMAT_DEPTH24;
		rectFormat = RECT_FORMAT_DEPTH24;
		lineFormat = LINE_FORMAT_DEPTH24;
		break;
	case 16:
	case 15:
		surfaceFormat = SURFACE_FORMAT_DEPTH16;
		patternFormat = PATTERN_FORMAT_DEPTH16;
		rectFormat = RECT_FORMAT_DEPTH16;
		lineFormat = LINE_FORMAT_DEPTH16;
		break;
	default:
		surfaceFormat = SURFACE_FORMAT_DEPTH8;
		patternFormat = PATTERN_FORMAT_DEPTH8;
		rectFormat = RECT_FORMAT_DEPTH8;
		lineFormat = LINE_FORMAT_DEPTH8;
		break;
	}

	nvdmastart(scr, SURFACE_FORMAT, 4);
	nvdmanext(surfaceFormat);
	nvdmanext(pitch | (pitch &lt;&lt; 16));
	nvdmanext(0);
	nvdmanext(0);

	nvdmastart(scr, PATTERN_FORMAT, 1);
	nvdmanext(patternFormat);

	nvdmastart(scr, RECT_FORMAT, 1);
	nvdmanext(rectFormat);

	nvdmastart(scr, LINE_FORMAT, 1);
	nvdmanext(lineFormat);

	nvdmastart(scr, PATTERN_COLOR_0, 4);
	nvdmanext(~0);
	nvdmanext(~0);
	nvdmanext(~0);
	nvdmanext(~0);

	nvdmastart(scr, ROP_SET, 1);
	nvdmanext(0xCC);

	nvdmakickoff(scr);
	waitforidle(scr);
}


static int
nvidiahwfill(VGAscr *scr, Rectangle r, ulong sval)
{
	nvdmastart(scr, RECT_SOLID_COLOR, 1);
	nvdmanext(sval);

	nvdmastart(scr, RECT_SOLID_RECTS(0), 2);
	nvdmanext((r.min.x &lt;&lt; 16) | r.min.y);
	nvdmanext((Dx(r) &lt;&lt; 16) | Dy(r));

	//if ( (Dy(r) * Dx(r)) &gt;= 512)
		nvdmakickoff(scr);

	waitforidle(scr);

	return 1;
}

static int
nvidiahwscroll(VGAscr *scr, Rectangle r, Rectangle sr)
{
	nvdmastart(scr, BLIT_POINT_SRC, 3);
	nvdmanext((sr.min.y &lt;&lt; 16) | sr.min.x);
	nvdmanext((r.min.y &lt;&lt; 16) | r.min.x);
	nvdmanext((Dy(r) &lt;&lt; 16) | Dx(r));

	//if ( (Dy(r) * Dx(r)) &gt;= 512)
		nvdmakickoff(scr);

	waitforidle(scr);

	return 1;
}

void
nvidiablank(VGAscr*, int blank)
{
	uchar seq1, crtc1A;

	seq1 = vgaxi(Seqx, 1) &amp; ~0x20;
	crtc1A = vgaxi(Crtx, 0x1A) &amp; ~0xC0;

	if(blank){
		seq1 |= 0x20;
//		crtc1A |= 0xC0;
		crtc1A |= 0x80;
	}

	vgaxo(Seqx, 1, seq1);
	vgaxo(Crtx, 0x1A, crtc1A);
}

static void
nvidiadrawinit(VGAscr *scr)
{
	nvresetgraphics(scr);
	scr-&gt;blank = nvidiablank;
	hwblank = 1;
	scr-&gt;fill = nvidiahwfill;
	scr-&gt;scroll = nvidiahwscroll;
}

VGAdev vganvidiadev = {
	"nvidia",

	nvidiaenable,
	nil,
	nil,
	nvidialinear,
	nvidiadrawinit,
};

VGAcur vganvidiacur = {
	"nvidiahwgc",

	nvidiacurenable,
	nvidiacurdisable,
	nvidiacurload,
	nvidiacurmove,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

