<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/vgavesa.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/vgavesa.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * vga driver using just vesa bios to set up.
 *
 * note that setting hwaccel to zero will cause cursor ghosts to be
 * left behind.  hwaccel set non-zero repairs this.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "ureg.h"

#define	Image	IMAGE
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;cursor.h&gt;
#include "screen.h"

enum {
	Usesoftscreen = 1,
};

static void *hardscreen;
static uchar modebuf[0x1000];

#define WORD(p) ((p)[0] | ((p)[1]&lt;&lt;8))
#define LONG(p) ((p)[0] | ((p)[1]&lt;&lt;8) | ((p)[2]&lt;&lt;16) | ((p)[3]&lt;&lt;24))
#define PWORD(p, v) (p)[0] = (v); (p)[1] = (v)&gt;&gt;8
#define PLONG(p, v) (p)[0] = (v); (p)[1] = (v)&gt;&gt;8; (p)[2] = (v)&gt;&gt;16; (p)[3] = (v)&gt;&gt;24

static uchar*
vbesetup(Ureg *u, int ax)
{
	ulong pa;

	pa = PADDR(RMBUF);
	memset(modebuf, 0, sizeof modebuf);
	memset(u, 0, sizeof *u);
	u-&gt;ax = ax;
	u-&gt;es = (pa&gt;&gt;4)&amp;0xF000;
	u-&gt;di = pa&amp;0xFFFF;
	return modebuf;
}

static void
vbecall(Ureg *u)
{
	Chan *creg, *cmem;
	ulong pa;

	cmem = namec("/dev/realmodemem", Aopen, ORDWR, 0);
	if(waserror()){
		cclose(cmem);
		nexterror();
	}
	creg = namec("/dev/realmode", Aopen, ORDWR, 0);
	if(waserror()){
		cclose(creg);
		nexterror();
	}
	pa = PADDR(RMBUF);
	devtab[cmem-&gt;type]-&gt;write(cmem, modebuf, sizeof modebuf, pa);
	u-&gt;trap = 0x10;
	devtab[creg-&gt;type]-&gt;write(creg, u, sizeof *u, 0);

	devtab[creg-&gt;type]-&gt;read(creg, u, sizeof *u, 0);
	if((u-&gt;ax&amp;0xFFFF) != 0x004F)
		error("vesa bios error");
	devtab[cmem-&gt;type]-&gt;read(cmem, modebuf, sizeof modebuf, pa);

	poperror();
	cclose(creg);
	poperror();
	cclose(cmem);
}

static void
vbecheck(void)
{
	Ureg u;
	uchar *p;

	p = vbesetup(&amp;u, 0x4F00);
	strcpy((char*)p, "VBE2");
	vbecall(&amp;u);
	if(memcmp((char*)p, "VESA", 4) != 0)
		error("bad vesa signature");
	if(p[5] &lt; 2)
		error("bad vesa version");
}

static int
vbegetmode(void)
{
	Ureg u;

	vbesetup(&amp;u, 0x4F03);
	vbecall(&amp;u);
	return u.bx;
}

static uchar*
vbemodeinfo(int mode)
{
	uchar *p;
	Ureg u;

	p = vbesetup(&amp;u, 0x4F01);
	u.cx = mode;
	vbecall(&amp;u);
	return p;
}

static void
vesalinear(VGAscr *scr, int, int)
{
	int i, mode, size, havesize;
	uchar *p;
	ulong paddr;
	Pcidev *pci;

	if(hardscreen) {
		scr-&gt;vaddr = 0;
		scr-&gt;paddr = scr-&gt;apsize = 0;
		return;
	}

	vbecheck();
	mode = vbegetmode();
	/*
	 * bochs loses the top bits - cannot use this
	if((mode&amp;(1&lt;&lt;14)) == 0)
		error("not in linear graphics mode");
	 */
	mode &amp;= 0x3FFF;
	p = vbemodeinfo(mode);
	if(!(WORD(p+0) &amp; (1&lt;&lt;4)))
		error("not in VESA graphics mode");
	if(!(WORD(p+0) &amp; (1&lt;&lt;7)))
		error("not in linear graphics mode");

	paddr = LONG(p+40);
	size = WORD(p+20)*WORD(p+16);
	size = PGROUND(size);

	/*
	 * figure out max size of memory so that we have
	 * enough if the screen is resized.
	 */
	pci = nil;
	havesize = 0;
	while(!havesize &amp;&amp; (pci = pcimatch(pci, 0, 0)) != nil){
		if(pci-&gt;ccrb != Pcibcdisp)
			continue;
		for(i=0; i&lt;nelem(pci-&gt;mem); i++)
			if(paddr == (pci-&gt;mem[i].bar&amp;~0x0F)){
				if(pci-&gt;mem[i].size &gt; size)
					size = pci-&gt;mem[i].size;
				havesize = 1;
				break;
			}
	}

	/* no pci - heuristic guess */
	if (!havesize)
		if(size &lt; 4*1024*1024)
			size = 4*1024*1024;
		else
			size = ROUND(size, 1024*1024);
	if(size &gt; 16*1024*1024)		/* arbitrary */
		size = 16*1024*1024;

	vgalinearaddr(scr, paddr, size);
	if(scr-&gt;apsize)
		addvgaseg("vesascreen", scr-&gt;paddr, scr-&gt;apsize);

	if(Usesoftscreen){
		hardscreen = scr-&gt;vaddr;
		scr-&gt;vaddr = 0;
		scr-&gt;paddr = scr-&gt;apsize = 0;
	}
}

static void
vesaflush(VGAscr *scr, Rectangle r)
{
	int t, w, wid, off;
	ulong *hp, *sp, *esp;

	if(hardscreen == nil)
		return;
	if(rectclip(&amp;r, scr-&gt;gscreen-&gt;r) == 0)
		return;
	sp = (ulong*)(scr-&gt;gscreendata-&gt;bdata + scr-&gt;gscreen-&gt;zero);
	t = (r.max.x * scr-&gt;gscreen-&gt;depth + 2*BI2WD-1) / BI2WD;
	w = (r.min.x * scr-&gt;gscreen-&gt;depth) / BI2WD;
	w = (t - w) * BY2WD;
	wid = scr-&gt;gscreen-&gt;width;
	off = r.min.y * wid + (r.min.x * scr-&gt;gscreen-&gt;depth) / BI2WD;

	hp = hardscreen;
	hp += off;
	sp += off;
	esp = sp + Dy(r) * wid;
	while(sp &lt; esp){
		memmove(hp, sp, w);
		hp += wid;
		sp += wid;
	}
}

VGAdev vgavesadev = {
	"vesa",
	0,
	0,
	0,
	vesalinear,
	0,
	0,
	0,
	0,
	vesaflush,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

