<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pc/wavelan.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pc/wavelan.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
	Lucent Wavelan IEEE 802.11 pcmcia.
	There is almost no documentation for the card.
	the driver is done using both the FreeBSD, Linux and
	original Plan 9 drivers as `documentation'.

	Has been used with the card plugged in during all up time.
	no cards removals/insertions yet.

	For known BUGS see the comments below. Besides,
	the driver keeps interrupts disabled for just too
	long. When it gets robust, locks should be revisited.

	BUGS: check endian, alignment and mem/io issues;
	      receive watchdog interrupts.
	TODO: automatic power management;
	      multicast filtering;
	      improve locking.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"
#include "etherif.h"
#include "wavelan.h"

enum
{
	MSperTick=	50,	/* ms between ticks of kproc */
};

/*
 * When we're using a PCI device and memory-mapped I/O, 
 * the registers are spaced out as though each takes 32 bits,
 * even though they are only 16-bit registers.  Thus, 
 * ctlr-&gt;mmb[reg] is the right way to access register reg,
 * even though a priori you'd expect to use ctlr-&gt;mmb[reg/2].
 */
void
csr_outs(Ctlr *ctlr, int reg, ushort arg)
{
	if(ctlr-&gt;mmb)
		ctlr-&gt;mmb[reg] = arg;
	else
		outs(ctlr-&gt;iob+reg, arg);
}

ushort
csr_ins(Ctlr *ctlr, int reg)
{
	if(ctlr-&gt;mmb)
		return ctlr-&gt;mmb[reg];
	else
		return ins(ctlr-&gt;iob+reg);
}

static void
csr_ack(Ctlr *ctlr, int ev)
{
	csr_outs(ctlr, WR_EvAck, ev);
}

static void
csr_inss(Ctlr *ctlr, int reg, void *dat, int ndat)
{
	ushort *rp, *wp;

	if(ctlr-&gt;mmb){
		rp = &amp;ctlr-&gt;mmb[reg];
		wp = dat;
		while(ndat-- &gt; 0)
			*wp++ = *rp;
	}else
		inss(ctlr-&gt;iob+reg, dat, ndat);
}

static void
csr_outss(Ctlr *ctlr, int reg, void *dat, int ndat)
{
	ushort *rp, *wp;

	if(ctlr-&gt;mmb){
		rp = dat;
		wp = &amp;ctlr-&gt;mmb[reg];
		while(ndat-- &gt; 0)
			*wp = *rp++;
	}else
		outss(ctlr-&gt;iob+reg, dat, ndat);
}

// w_... routines do not ilock the Ctlr and should
// be called locked.

void
w_intdis(Ctlr* ctlr)
{
	csr_outs(ctlr, WR_IntEna, 0);
	csr_ack(ctlr, 0xffff);
}

static void
w_intena(Ctlr* ctlr)
{
	csr_outs(ctlr, WR_IntEna, WEvs);
}

int
w_cmd(Ctlr *ctlr, ushort cmd, ushort arg)
{
	int i, rc;

	for(i=0; i&lt;WTmOut; i++)
		if((csr_ins(ctlr, WR_Cmd)&amp;WCmdBusy) == 0)
			break;
	if(i==WTmOut){
		print("#l%d: issuing cmd %.4ux: %.4ux\n", ctlr-&gt;ctlrno, cmd, csr_ins(ctlr, WR_Cmd));
		return -1;
	}

	csr_outs(ctlr, WR_Parm0, arg);
	csr_outs(ctlr, WR_Cmd, cmd);

	for(i=0; i&lt;WTmOut; i++)
		if(csr_ins(ctlr, WR_EvSts)&amp;WCmdEv)
			break;
	if(i==WTmOut){
		/*
		 * WCmdIni can take a really long time.
		 */
		enum { IniTmOut = 2000 };
		for(i=0; i&lt;IniTmOut; i++){
			if(csr_ins(ctlr, WR_EvSts)&amp;WCmdEv)
				break;
			microdelay(100);
		}
		if(i &lt; IniTmOut)
			if(0) print("#l%d: long cmd %.4ux %d\n", ctlr-&gt;ctlrno, cmd, i);
		if(i == IniTmOut){
			print("#l%d: execing cmd %.4ux: %.4ux\n", ctlr-&gt;ctlrno, cmd, csr_ins(ctlr, WR_EvSts));
			return -1;
		}
	}
	rc = csr_ins(ctlr, WR_Sts);
	csr_ack(ctlr, WCmdEv);

	if((rc&amp;WCmdMsk) != (cmd&amp;WCmdMsk)){
		print("#l%d: cmd %.4ux: status %.4ux\n", ctlr-&gt;ctlrno, cmd, rc);
		return -1;
	}
	if(rc&amp;WResSts){
		/*
		 * Don't print; this happens on every WCmdAccWr for some reason.
		 */
		if(0) print("#l%d: cmd %.4ux: status %.4ux\n", ctlr-&gt;ctlrno, cmd, rc);
		return -1;
	}
	return 0;
}

static int
w_seek(Ctlr* ctlr, ushort id, ushort offset, int chan)
{
	int i, rc;
	static ushort sel[] = { WR_Sel0, WR_Sel1 };
	static ushort off[] = { WR_Off0, WR_Off1 };

	if(chan != 0 &amp;&amp; chan != 1)
		panic("wavelan: bad chan\n");
	csr_outs(ctlr, sel[chan], id);
	csr_outs(ctlr, off[chan], offset);
	for (i=0; i&lt;WTmOut; i++){
		rc = csr_ins(ctlr, off[chan]);
		if((rc &amp; (WBusyOff|WErrOff)) == 0)
			return 0;
	}
	return -1;
}

int
w_inltv(Ctlr* ctlr, Wltv* ltv)
{
	int len;
	ushort code;

	if(w_cmd(ctlr, WCmdAccRd, ltv-&gt;type)){
		DEBUG("wavelan: access read failed\n");
		return -1;
	}
	if(w_seek(ctlr,ltv-&gt;type,0,1)){
		DEBUG("wavelan: seek failed\n");
		return -1;
	}
	len = csr_ins(ctlr, WR_Data1);
	if(len &gt; ltv-&gt;len)
		return -1;
	ltv-&gt;len = len;
	if((code=csr_ins(ctlr, WR_Data1)) != ltv-&gt;type){
		USED(code);
		DEBUG("wavelan: type %x != code %x\n",ltv-&gt;type,code);
		return -1;
	}
	if(ltv-&gt;len &gt; 0)
		csr_inss(ctlr, WR_Data1, &amp;ltv-&gt;val, ltv-&gt;len-1);

	return 0;
}

static void
w_outltv(Ctlr* ctlr, Wltv* ltv)
{
	if(w_seek(ctlr,ltv-&gt;type, 0, 1))
		return;
	csr_outss(ctlr, WR_Data1, ltv, ltv-&gt;len+1);
	w_cmd(ctlr, WCmdAccWr, ltv-&gt;type);
}

void
ltv_outs(Ctlr* ctlr, int type, ushort val)
{
	Wltv ltv;

	ltv.len = 2;
	ltv.type = type;
	ltv.val = val;
	w_outltv(ctlr, &amp;ltv);
}

int
ltv_ins(Ctlr* ctlr, int type)
{
	Wltv ltv;

	ltv.len = 2;
	ltv.type = type;
	ltv.val = 0;
	if(w_inltv(ctlr, &amp;ltv))
		return -1;
	return ltv.val;
}

static void
ltv_outstr(Ctlr* ctlr, int type, char* val)
{
	Wltv ltv;
	int len;

	len = strlen(val);
	if(len &gt; sizeof(ltv.s))
		len = sizeof(ltv.s);
	memset(&amp;ltv, 0, sizeof(ltv));
	ltv.len = (sizeof(ltv.type)+sizeof(ltv.slen)+sizeof(ltv.s))/2;
	ltv.type = type;

//	This should be ltv.slen = len; according to Axel Belinfante
	ltv.slen = len;	

	strncpy(ltv.s, val, len);
	w_outltv(ctlr, &amp;ltv);
}

static char Unkname[] = "who knows";
static char Nilname[] = "card does not tell";

static char*
ltv_inname(Ctlr* ctlr, int type)
{
	static Wltv ltv;
	int len;

	memset(&amp;ltv,0,sizeof(ltv));
	ltv.len = WNameLen/2+2;
	ltv.type = type;
	if(w_inltv(ctlr, &amp;ltv))
		return Unkname;
	len = ltv.slen;
	if(len == 0 || ltv.s[0] == 0)
		return Nilname;
	if(len &gt;= sizeof ltv.s)
		len = sizeof ltv.s - 1;
	ltv.s[len] = '\0';
	return ltv.s;
}

static int
w_read(Ctlr* ctlr, int type, int off, void* buf, ulong len)
{
	if(w_seek(ctlr, type, off, 1)){
		DEBUG("wavelan: w_read: seek failed");
		return 0;
	}
	csr_inss(ctlr, WR_Data1, buf, len/2);

	return len;
}

static int
w_write(Ctlr* ctlr, int type, int off, void* buf, ulong len)
{
	if(w_seek(ctlr, type, off, 0)){
		DEBUG("wavelan: w_write: seek failed\n");
		return 0;
	}

	csr_outss(ctlr, WR_Data0, buf, len/2);
	csr_outs(ctlr, WR_Data0, 0xdead);
	csr_outs(ctlr, WR_Data0, 0xbeef);
	if(w_seek(ctlr, type, off + len, 0)){
		DEBUG("wavelan: write seek failed\n");
		return 0;
	}
	if(csr_ins(ctlr, WR_Data0) == 0xdead &amp;&amp; csr_ins(ctlr, WR_Data0) == 0xbeef)
		return len;

	DEBUG("wavelan: Hermes bug byte.\n");
	return 0;
}

static int
w_alloc(Ctlr* ctlr, int len)
{
	int rc;
	int i,j;

	if(w_cmd(ctlr, WCmdMalloc, len)==0)
		for (i = 0; i&lt;WTmOut; i++)
			if(csr_ins(ctlr, WR_EvSts) &amp; WAllocEv){
				csr_ack(ctlr, WAllocEv);
				rc=csr_ins(ctlr, WR_Alloc);
				if(w_seek(ctlr, rc, 0, 0))
					return -1;
				len = len/2;
				for (j=0; j&lt;len; j++)
					csr_outs(ctlr, WR_Data0, 0);
				return rc;
			}
	return -1;
}

static int
w_enable(Ether* ether)
{
	Wltv ltv;
	Ctlr* ctlr = (Ctlr*) ether-&gt;ctlr;

	if(!ctlr)
		return -1;

	w_intdis(ctlr);
	w_cmd(ctlr, WCmdDis, 0);
	w_intdis(ctlr);
	if(w_cmd(ctlr, WCmdIni, 0))
		return -1;
	w_intdis(ctlr);

	ltv_outs(ctlr, WTyp_Tick, 8);
	ltv_outs(ctlr, WTyp_MaxLen, ctlr-&gt;maxlen);
	ltv_outs(ctlr, WTyp_Ptype, ctlr-&gt;ptype);
 	ltv_outs(ctlr, WTyp_CreateIBSS, ctlr-&gt;createibss);
	ltv_outs(ctlr, WTyp_RtsThres, ctlr-&gt;rtsthres);
	ltv_outs(ctlr, WTyp_TxRate, ctlr-&gt;txrate);
	ltv_outs(ctlr, WTyp_ApDens, ctlr-&gt;apdensity);
	ltv_outs(ctlr, WTyp_PMWait, ctlr-&gt;pmwait);
	ltv_outs(ctlr, WTyp_PM, ctlr-&gt;pmena);
	if(*ctlr-&gt;netname)
		ltv_outstr(ctlr, WTyp_NetName, ctlr-&gt;netname);
	if(*ctlr-&gt;wantname)
		ltv_outstr(ctlr, WTyp_WantName, ctlr-&gt;wantname);
	ltv_outs(ctlr, WTyp_Chan, ctlr-&gt;chan);
	if(*ctlr-&gt;nodename)
		ltv_outstr(ctlr, WTyp_NodeName, ctlr-&gt;nodename);
	ltv.len = 4;
	ltv.type = WTyp_Mac;
	memmove(ltv.addr, ether-&gt;ea, Eaddrlen);
	w_outltv(ctlr, &amp;ltv);

	ltv_outs(ctlr, WTyp_Prom, (ether-&gt;prom?1:0));

	if(ctlr-&gt;hascrypt &amp;&amp; ctlr-&gt;crypt){
		ltv_outs(ctlr, WTyp_Crypt, ctlr-&gt;crypt);
		ltv_outs(ctlr, WTyp_TxKey, ctlr-&gt;txkey);
		w_outltv(ctlr, &amp;ctlr-&gt;keys);
		ltv_outs(ctlr, WTyp_XClear, ctlr-&gt;xclear);
	}

	// BUG: set multicast addresses

	if(w_cmd(ctlr, WCmdEna, 0)){
		DEBUG("wavelan: Enable failed");
		return -1;
	}
	ctlr-&gt;txdid = w_alloc(ctlr, 1518 + sizeof(WFrame) + 8);
	ctlr-&gt;txmid = w_alloc(ctlr, 1518 + sizeof(WFrame) + 8);
	if(ctlr-&gt;txdid == -1 || ctlr-&gt;txmid == -1)
		DEBUG("wavelan: alloc failed");
	ctlr-&gt;txbusy = 0;
	w_intena(ctlr);
	return 0;
}

static void
w_rxdone(Ether* ether)
{
	Ctlr* ctlr = (Ctlr*) ether-&gt;ctlr;
	int len, sp;
	WFrame f;
	Block* bp=0;
	Etherpkt* ep;

	sp = csr_ins(ctlr, WR_RXId);
	len = w_read(ctlr, sp, 0, &amp;f, sizeof(f));
	if(len == 0){
		DEBUG("wavelan: read frame error\n");
		goto rxerror;
	}
	if(f.sts&amp;WF_Err){
		goto rxerror;
	}
	switch(f.sts){
	case WF_1042:
	case WF_Tunnel:
	case WF_WMP:
		len = f.dlen + WSnapHdrLen;
		bp = iallocb(ETHERHDRSIZE + len + 2);
		if(!bp)
			goto rxerror;
		ep = (Etherpkt*) bp-&gt;wp;
		memmove(ep-&gt;d, f.addr1, Eaddrlen);
		memmove(ep-&gt;s, f.addr2, Eaddrlen);
		memmove(ep-&gt;type,&amp;f.type,2);
		bp-&gt;wp += ETHERHDRSIZE;
		if(w_read(ctlr, sp, WF_802_11_Off, bp-&gt;wp, len+2) == 0){
			DEBUG("wavelan: read 802.11 error\n");
			goto rxerror;
		}
		bp-&gt;wp = bp-&gt;rp+(ETHERHDRSIZE+f.dlen);
		break;
	default:
		len = ETHERHDRSIZE + f.dlen + 2;
		bp = iallocb(len);
		if(!bp)
			goto rxerror;
		if(w_read(ctlr, sp, WF_802_3_Off, bp-&gt;wp, len) == 0){
			DEBUG("wavelan: read 800.3 error\n");
			goto rxerror;
		}
		bp-&gt;wp += len;
	}

	ctlr-&gt;nrx++;
	etheriq(ether,bp,1);
	ctlr-&gt;signal = ((ctlr-&gt;signal*15)+((f.qinfo&gt;&gt;8) &amp; 0xFF))/16;
	ctlr-&gt;noise = ((ctlr-&gt;noise*15)+(f.qinfo &amp; 0xFF))/16;
	return;

rxerror:
	freeb(bp);
	ctlr-&gt;nrxerr++;
}

static void
w_txstart(Ether* ether)
{
	Etherpkt *pkt;
	Ctlr *ctlr;
	Block *bp;
	int len, off;

	if((ctlr = ether-&gt;ctlr) == nil || (ctlr-&gt;state &amp; (Attached|Power)) != (Attached|Power) || ctlr-&gt;txbusy)
		return;

	if((bp = qget(ether-&gt;oq)) == nil)
		return;
	pkt = (Etherpkt*)bp-&gt;rp;

	//
	// If the packet header type field is &gt; 1500 it is an IP or
	// ARP datagram, otherwise it is an 802.3 packet. See RFC1042.
	//
	memset(&amp;ctlr-&gt;txf, 0, sizeof(ctlr-&gt;txf));
	if(((pkt-&gt;type[0]&lt;&lt;8)|pkt-&gt;type[1]) &gt; 1500){
		ctlr-&gt;txf.framectl = WF_Data;
		memmove(ctlr-&gt;txf.addr1, pkt-&gt;d, Eaddrlen);
		memmove(ctlr-&gt;txf.addr2, pkt-&gt;s, Eaddrlen);
		memmove(ctlr-&gt;txf.dstaddr, pkt-&gt;d, Eaddrlen);
		memmove(ctlr-&gt;txf.srcaddr, pkt-&gt;s, Eaddrlen);
		memmove(&amp;ctlr-&gt;txf.type, pkt-&gt;type, 2);
		bp-&gt;rp += ETHERHDRSIZE;
		len = BLEN(bp);
		off = WF_802_11_Off;
		ctlr-&gt;txf.dlen = len+ETHERHDRSIZE-WSnapHdrLen;
		hnputs((uchar*)&amp;ctlr-&gt;txf.dat[0], WSnap0);
		hnputs((uchar*)&amp;ctlr-&gt;txf.dat[1], WSnap1);
		hnputs((uchar*)&amp;ctlr-&gt;txf.len, len+ETHERHDRSIZE-WSnapHdrLen);
	}
	else{
		len = BLEN(bp);
		off = WF_802_3_Off;
		ctlr-&gt;txf.dlen = len;
	}
	w_write(ctlr, ctlr-&gt;txdid, 0, &amp;ctlr-&gt;txf, sizeof(ctlr-&gt;txf));
	w_write(ctlr, ctlr-&gt;txdid, off, bp-&gt;rp, len+2);

	if(w_cmd(ctlr, WCmdReclaim|WCmdTx, ctlr-&gt;txdid)){
		DEBUG("wavelan: transmit failed\n");
		ctlr-&gt;ntxerr++;
	}
	else{
		ctlr-&gt;txbusy = 1;
		ctlr-&gt;txtmout = 2;
	}
	freeb(bp);
}

static void
w_txdone(Ctlr* ctlr, int sts)
{
	ctlr-&gt;txbusy = 0;
	ctlr-&gt;txtmout = 0;
	if(sts &amp; WTxErrEv)
		ctlr-&gt;ntxerr++;
	else
		ctlr-&gt;ntx++;
}

/* save the stats info in the ctlr struct */
static void
w_stats(Ctlr* ctlr, int len)
{
	int i, rc;
	ulong* p = (ulong*)&amp;ctlr-&gt;WStats;
	ulong* pend = (ulong*)&amp;ctlr-&gt;end;

	for (i = 0; i &lt; len &amp;&amp; p &lt; pend; i++){
		rc = csr_ins(ctlr, WR_Data1);
		if(rc &gt; 0xf000)
			rc = ~rc &amp; 0xffff;
		p[i] += rc;
	}
}

/* send the base station scan info to any readers */
static void
w_scaninfo(Ether* ether, Ctlr *ctlr, int len)
{
	int i, j;
	Netfile **ep, *f, **fp;
	Block *bp;
	WScan *wsp;
	ushort *scanbuf;

	scanbuf = malloc(len*2);
	if(scanbuf == nil)
		return;
	
	for (i = 0; i &lt; len ; i++)
		scanbuf[i] = csr_ins(ctlr, WR_Data1);

	/* calculate number of samples */
	len /= 25;
	if(len == 0)
		goto out;

	i = ether-&gt;scan;
	ep = &amp;ether-&gt;f[Ntypes];
	for(fp = ether-&gt;f; fp &lt; ep &amp;&amp; i &gt; 0; fp++){
		f = *fp;
		if(f == nil || f-&gt;scan == 0)
			continue;

		bp = iallocb(100*len);
		if(bp == nil)
			break;
		for(j = 0; j &lt; len; j++){
			wsp = (WScan*)(&amp;scanbuf[j*25]);
			if(wsp-&gt;ssid_len &gt; 32)
				wsp-&gt;ssid_len = 32;
			bp-&gt;wp = (uchar*)seprint((char*)bp-&gt;wp, (char*)bp-&gt;lim,
				"ssid=%.*s;bssid=%E;signal=%d;noise=%d;chan=%d%s\n",
				wsp-&gt;ssid_len, wsp-&gt;ssid, wsp-&gt;bssid, wsp-&gt;signal,
				wsp-&gt;noise, wsp-&gt;chan, (wsp-&gt;capinfo&amp;(1&lt;&lt;4))?";wep":"");
		}
		qpass(f-&gt;in, bp);
		i--;
	}
out:
	free(scanbuf);
}

static int
w_info(Ether *ether, Ctlr* ctlr)
{
	int sp;
	Wltv ltv;

	sp = csr_ins(ctlr, WR_InfoId);
	ltv.len = ltv.type = 0;
	w_read(ctlr, sp, 0, &amp;ltv, 4);
	ltv.len--;
	switch(ltv.type){
	case WTyp_Stats:
		w_stats(ctlr, ltv.len);
		return 0;
	case WTyp_Scan:
		w_scaninfo(ether, ctlr, ltv.len);
		return 0;
	}
	return -1;
}

/* set scanning interval */
static void
w_scanbs(void *a, uint secs)
{
	Ether *ether = a;
	Ctlr* ctlr = (Ctlr*) ether-&gt;ctlr;

	ctlr-&gt;scanticks = secs*(1000/MSperTick);
}

static void
w_intr(Ether *ether)
{
	int rc, txid;
	Ctlr* ctlr = (Ctlr*) ether-&gt;ctlr;

	if((ctlr-&gt;state &amp; Power) == 0)
		return;

	if((ctlr-&gt;state &amp; Attached) == 0){
		csr_ack(ctlr, 0xffff);
		csr_outs(ctlr, WR_IntEna, 0);
		return;
	}

	rc = csr_ins(ctlr, WR_EvSts);
	csr_ack(ctlr, ~WEvs);	// Not interested in them
	if(rc &amp; WRXEv){
		w_rxdone(ether);
		csr_ack(ctlr, WRXEv);
	}
	if(rc &amp; WTXEv){
		w_txdone(ctlr, rc);
		csr_ack(ctlr, WTXEv);
	}
	if(rc &amp; WAllocEv){
		ctlr-&gt;nalloc++;
		txid = csr_ins(ctlr, WR_Alloc);
		csr_ack(ctlr, WAllocEv);
		if(txid == ctlr-&gt;txdid){
			if((rc &amp; WTXEv) == 0)
				w_txdone(ctlr, rc);
		}
	}
	if(rc &amp; WInfoEv){
		ctlr-&gt;ninfo++;
		w_info(ether, ctlr);
		csr_ack(ctlr, WInfoEv);
	}
	if(rc &amp; WTxErrEv){
		w_txdone(ctlr, rc);
		csr_ack(ctlr, WTxErrEv);
	}
	if(rc &amp; WIDropEv){
		ctlr-&gt;nidrop++;
		csr_ack(ctlr, WIDropEv);
	}
	w_txstart(ether);
}

// Watcher to ensure that the card still works properly and
// to request WStats updates once a minute.
// BUG: it runs much more often, see the comment below.

static void
w_timer(void* arg)
{
	Ether* ether = (Ether*) arg;
	Ctlr* ctlr = (Ctlr*)ether-&gt;ctlr;

	ctlr-&gt;timerproc = up;
	for(;;){
		tsleep(&amp;up-&gt;sleep, return0, 0, MSperTick);
		ctlr = (Ctlr*)ether-&gt;ctlr;
		if(ctlr == 0)
			break;
		if((ctlr-&gt;state &amp; (Attached|Power)) != (Attached|Power))
			continue;
		ctlr-&gt;ticks++;

		ilock(ctlr);

		// Seems that the card gets frames BUT does
		// not send the interrupt; this is a problem because
		// I suspect it runs out of receive buffers and
		// stops receiving until a transmit watchdog
		// reenables the card.
		// The problem is serious because it leads to
		// poor rtts.
		// This can be seen clearly by commenting out
		// the next if and doing a ping: it will stop
		// receiving (although the icmp replies are being
		// issued from the remote) after a few seconds.
		// Of course this `bug' could be because I'm reading
		// the card frames in the wrong way; due to the
		// lack of documentation I cannot know.

		if(csr_ins(ctlr, WR_EvSts)&amp;WEvs){
			ctlr-&gt;tickintr++;
			w_intr(ether);
		}

		if((ctlr-&gt;ticks % 10) == 0) {
			if(ctlr-&gt;txtmout &amp;&amp; --ctlr-&gt;txtmout == 0){
				ctlr-&gt;nwatchdogs++;
				w_txdone(ctlr, WTxErrEv);
				if(w_enable(ether)){
					DEBUG("wavelan: wdog enable failed\n");
				}
				w_txstart(ether);
			}
			if((ctlr-&gt;ticks % 120) == 0)
			if(ctlr-&gt;txbusy == 0)
				w_cmd(ctlr, WCmdEnquire, WTyp_Stats);
			if(ctlr-&gt;scanticks &gt; 0)
			if((ctlr-&gt;ticks % ctlr-&gt;scanticks) == 0)
			if(ctlr-&gt;txbusy == 0)
				w_cmd(ctlr, WCmdEnquire, WTyp_Scan);
		}
		iunlock(ctlr);
	}
	pexit("terminated", 0);
}

void
w_multicast(void *ether, uchar*, int add)
{
	/* BUG: use controller's multicast filter */
	if (add)
		w_promiscuous(ether, 1);
}

void
w_attach(Ether* ether)
{
	Ctlr* ctlr;
	char name[64];
	int rc;

	if(ether-&gt;ctlr == 0)
		return;

	snprint(name, sizeof(name), "#l%dtimer", ether-&gt;ctlrno);
	ctlr = (Ctlr*) ether-&gt;ctlr;
	if((ctlr-&gt;state &amp; Attached) == 0){
		ilock(ctlr);
		rc = w_enable(ether);
		iunlock(ctlr);
		if(rc == 0){
			ctlr-&gt;state |= Attached;
			kproc(name, w_timer, ether);
		} else
			print("#l%d: enable failed\n",ether-&gt;ctlrno);
	}
}

void
w_detach(Ether* ether)
{
	Ctlr* ctlr;
	char name[64];

	if(ether-&gt;ctlr == nil)
		return;

	snprint(name, sizeof(name), "#l%dtimer", ether-&gt;ctlrno);
	ctlr = (Ctlr*) ether-&gt;ctlr;
	if(ctlr-&gt;state &amp; Attached){
		ilock(ctlr);
		w_intdis(ctlr);
		if(ctlr-&gt;timerproc){
			if(!postnote(ctlr-&gt;timerproc, 1, "kill", NExit))
				print("timerproc note not posted\n");
			print("w_detach, killing 0x%p\n", ctlr-&gt;timerproc);
		}
		ctlr-&gt;state &amp;= ~Attached;
		iunlock(ctlr);
	}
	ether-&gt;ctlr = nil;
}

void
w_power(Ether* ether, int on)
{
	Ctlr *ctlr;

	ctlr = (Ctlr*) ether-&gt;ctlr;
	ilock(ctlr);
iprint("w_power %d\n", on);
	if(on){
		if((ctlr-&gt;state &amp; Power) == 0){
			if (wavelanreset(ether, ctlr) &lt; 0){
				iprint("w_power: reset failed\n");
				iunlock(ctlr);
				w_detach(ether);
				free(ctlr);
				return;
			}
			if(ctlr-&gt;state &amp; Attached)
				w_enable(ether);
			ctlr-&gt;state |= Power;
		}
	}else{
		if(ctlr-&gt;state &amp; Power){
			if(ctlr-&gt;state &amp; Attached)
				w_intdis(ctlr);
			ctlr-&gt;state &amp;= ~Power;
		}
	}
	iunlock(ctlr);
}

#define PRINTSTAT(fmt,val)	l += snprint(p+l, READSTR-l, (fmt), (val))
#define PRINTSTR(fmt)		l += snprint(p+l, READSTR-l, (fmt))

long
w_ifstat(Ether* ether, void* a, long n, ulong offset)
{
	Ctlr *ctlr = (Ctlr*) ether-&gt;ctlr;
	char *k, *p;
	int i, l, txid;

	ether-&gt;oerrs = ctlr-&gt;ntxerr;
	ether-&gt;crcs = ctlr-&gt;nrxfcserr;
	ether-&gt;frames = 0;
	ether-&gt;buffs = ctlr-&gt;nrxdropnobuf;
	ether-&gt;overflows = 0;

	//
	// Offset must be zero or there's a possibility the
	// new data won't match the previous read.
	//
	if(n == 0 || offset != 0)
		return 0;

	p = malloc(READSTR);
	if(p == nil)
		error(Enomem);
	l = 0;

	PRINTSTAT("Signal: %d\n", ctlr-&gt;signal-149);
	PRINTSTAT("Noise: %d\n", ctlr-&gt;noise-149);
	PRINTSTAT("SNR: %ud\n", ctlr-&gt;signal-ctlr-&gt;noise);
	PRINTSTAT("Interrupts: %lud\n", ctlr-&gt;nints);
	PRINTSTAT("Double Interrupts: %lud\n", ctlr-&gt;ndoubleint);
	PRINTSTAT("TxPackets: %lud\n", ctlr-&gt;ntx);
	PRINTSTAT("RxPackets: %lud\n", ctlr-&gt;nrx);
	PRINTSTAT("TxErrors: %lud\n", ctlr-&gt;ntxerr);
	PRINTSTAT("RxErrors: %lud\n", ctlr-&gt;nrxerr);
	PRINTSTAT("TxRequests: %lud\n", ctlr-&gt;ntxrq);
	PRINTSTAT("AllocEvs: %lud\n", ctlr-&gt;nalloc);
	PRINTSTAT("InfoEvs: %lud\n", ctlr-&gt;ninfo);
	PRINTSTAT("InfoDrop: %lud\n", ctlr-&gt;nidrop);
	PRINTSTAT("WatchDogs: %lud\n", ctlr-&gt;nwatchdogs);
	PRINTSTAT("Ticks: %ud\n", ctlr-&gt;ticks);
	PRINTSTAT("TickIntr: %ud\n", ctlr-&gt;tickintr);
	k = ((ctlr-&gt;state &amp; Attached) ? "attached" : "not attached");
	PRINTSTAT("Card %s", k);
	k = ((ctlr-&gt;state &amp; Power) ? "on" : "off");
	PRINTSTAT(", power %s", k);
	k = ((ctlr-&gt;txbusy)? ", txbusy" : "");
	PRINTSTAT("%s\n", k);

	if(ctlr-&gt;hascrypt){
		PRINTSTR("Keys: ");
		for (i = 0; i &lt; WNKeys; i++){
			if(ctlr-&gt;keys.keys[i].len == 0)
				PRINTSTR("none ");
			else if(SEEKEYS == 0)
				PRINTSTR("set ");
			else
				PRINTSTAT("%s ", ctlr-&gt;keys.keys[i].dat);
		}
		PRINTSTR("\n");
	}

	// real card stats
	ilock(ctlr);
	PRINTSTR("\nCard stats: \n");
	PRINTSTAT("Status: %ux\n", csr_ins(ctlr, WR_Sts));
	PRINTSTAT("Event status: %ux\n", csr_ins(ctlr, WR_EvSts));
	i = ltv_ins(ctlr, WTyp_Ptype);
	PRINTSTAT("Port type: %d\n", i);
	PRINTSTAT("Transmit rate: %d\n", ltv_ins(ctlr, WTyp_TxRate));
	PRINTSTAT("Current Transmit rate: %d\n",
		ltv_ins(ctlr, WTyp_CurTxRate));
	PRINTSTAT("Channel: %d\n", ltv_ins(ctlr, WTyp_Chan));
	PRINTSTAT("AP density: %d\n", ltv_ins(ctlr, WTyp_ApDens));
	PRINTSTAT("Promiscuous mode: %d\n", ltv_ins(ctlr, WTyp_Prom));
	if(i == WPTypeAdHoc)
		PRINTSTAT("SSID name: %s\n", ltv_inname(ctlr, WTyp_NetName));
	else {
		Wltv ltv;
		PRINTSTAT("Current name: %s\n", ltv_inname(ctlr, WTyp_CurName));
		ltv.type = WTyp_BaseID;
		ltv.len = 4;
		if(w_inltv(ctlr, &amp;ltv))
			print("#l%d: unable to read base station mac addr\n", ether-&gt;ctlrno);
		l += snprint(p+l, READSTR-l, "Base station: %2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			ltv.addr[0], ltv.addr[1], ltv.addr[2], ltv.addr[3], ltv.addr[4], ltv.addr[5]);
	}
	PRINTSTAT("Net name: %s\n", ltv_inname(ctlr, WTyp_WantName));
	PRINTSTAT("Node name: %s\n", ltv_inname(ctlr, WTyp_NodeName));
	if(ltv_ins(ctlr, WTyp_HasCrypt) == 0)
		PRINTSTR("WEP: not supported\n");
	else {
		if(ltv_ins(ctlr, WTyp_Crypt) == 0)
			PRINTSTR("WEP: disabled\n");
		else{
			PRINTSTR("WEP: enabled\n");
			k = ((ctlr-&gt;xclear)? "excluded": "included");
			PRINTSTAT("Clear packets: %s\n", k);
			txid = ltv_ins(ctlr, WTyp_TxKey);
			PRINTSTAT("Transmit key id: %d\n", txid);
		}
	}
	iunlock(ctlr);

	PRINTSTAT("ntxuframes: %lud\n", ctlr-&gt;ntxuframes);
	PRINTSTAT("ntxmframes: %lud\n", ctlr-&gt;ntxmframes);
	PRINTSTAT("ntxfrags: %lud\n", ctlr-&gt;ntxfrags);
	PRINTSTAT("ntxubytes: %lud\n", ctlr-&gt;ntxubytes);
	PRINTSTAT("ntxmbytes: %lud\n", ctlr-&gt;ntxmbytes);
	PRINTSTAT("ntxdeferred: %lud\n", ctlr-&gt;ntxdeferred);
	PRINTSTAT("ntxsretries: %lud\n", ctlr-&gt;ntxsretries);
	PRINTSTAT("ntxmultiretries: %lud\n", ctlr-&gt;ntxmultiretries);
	PRINTSTAT("ntxretrylimit: %lud\n", ctlr-&gt;ntxretrylimit);
	PRINTSTAT("ntxdiscards: %lud\n", ctlr-&gt;ntxdiscards);
	PRINTSTAT("nrxuframes: %lud\n", ctlr-&gt;nrxuframes);
	PRINTSTAT("nrxmframes: %lud\n", ctlr-&gt;nrxmframes);
	PRINTSTAT("nrxfrags: %lud\n", ctlr-&gt;nrxfrags);
	PRINTSTAT("nrxubytes: %lud\n", ctlr-&gt;nrxubytes);
	PRINTSTAT("nrxmbytes: %lud\n", ctlr-&gt;nrxmbytes);
	PRINTSTAT("nrxfcserr: %lud\n", ctlr-&gt;nrxfcserr);
	PRINTSTAT("nrxdropnobuf: %lud\n", ctlr-&gt;nrxdropnobuf);
	PRINTSTAT("nrxdropnosa: %lud\n", ctlr-&gt;nrxdropnosa);
	PRINTSTAT("nrxcantdecrypt: %lud\n", ctlr-&gt;nrxcantdecrypt);
	PRINTSTAT("nrxmsgfrag: %lud\n", ctlr-&gt;nrxmsgfrag);
	PRINTSTAT("nrxmsgbadfrag: %lud\n", ctlr-&gt;nrxmsgbadfrag);
	USED(l);
	n = readstr(offset, a, n, p);
	free(p);
	return n;
}
#undef PRINTSTR
#undef PRINTSTAT

static int
parsekey(WKey* key, char* a) 
{
	int i, k, len, n;
	char buf[WMaxKeyLen];

	len = strlen(a);
	if(len == WMinKeyLen || len == WMaxKeyLen){
		memset(key-&gt;dat, 0, sizeof(key-&gt;dat));
		memmove(key-&gt;dat, a, len);
		key-&gt;len = len;

		return 0;
	}
	else if(len == WMinKeyLen*2 || len == WMaxKeyLen*2){
		k = 0;
		for(i = 0; i &lt; len; i++){
			if(*a &gt;= '0' &amp;&amp; *a &lt;= '9')
				n = *a++ - '0';
			else if(*a &gt;= 'a' &amp;&amp; *a &lt;= 'f')
				n = *a++ - 'a' + 10;
			else if(*a &gt;= 'A' &amp;&amp; *a &lt;= 'F')
				n = *a++ - 'A' + 10;
			else
				return -1;
	
			if(i &amp; 1){
				buf[k] |= n;
				k++;
			}
			else
				buf[k] = n&lt;&lt;4;
		}

		memset(key-&gt;dat, 0, sizeof(key-&gt;dat));
		memmove(key-&gt;dat, buf, k);
		key-&gt;len = k;

		return 0;
	}

	return -1;
}

int
w_option(Ctlr* ctlr, char* buf, long n)
{
	char *p;
	int i, r;
	Cmdbuf *cb;

	r = 0;

	cb = parsecmd(buf, n);
	if(cb-&gt;nf &lt; 2)
		r = -1;
	else if(cistrcmp(cb-&gt;f[0], "essid") == 0){
		if(cistrcmp(cb-&gt;f[1],"default") == 0)
			p = "";
		else
			p = cb-&gt;f[1];
		if(ctlr-&gt;ptype == WPTypeAdHoc){
			memset(ctlr-&gt;netname, 0, sizeof(ctlr-&gt;netname));
			strncpy(ctlr-&gt;netname, p, WNameLen);
		}
		else{
			memset(ctlr-&gt;wantname, 0, sizeof(ctlr-&gt;wantname));
			strncpy(ctlr-&gt;wantname, p, WNameLen);
		}
	}
	else if(cistrcmp(cb-&gt;f[0], "station") == 0){
		memset(ctlr-&gt;nodename, 0, sizeof(ctlr-&gt;nodename));
		strncpy(ctlr-&gt;nodename, cb-&gt;f[1], WNameLen);
	}
	else if(cistrcmp(cb-&gt;f[0], "channel") == 0){
		if((i = atoi(cb-&gt;f[1])) &gt;= 1 &amp;&amp; i &lt;= 16)
			ctlr-&gt;chan = i;
		else
			r = -1;
	}
	else if(cistrcmp(cb-&gt;f[0], "mode") == 0){
		if(cistrcmp(cb-&gt;f[1], "managed") == 0)
			ctlr-&gt;ptype = WPTypeManaged;
		else if(cistrcmp(cb-&gt;f[1], "wds") == 0)
			ctlr-&gt;ptype = WPTypeWDS;
		else if(cistrcmp(cb-&gt;f[1], "adhoc") == 0)
			ctlr-&gt;ptype = WPTypeAdHoc;
		else if((i = atoi(cb-&gt;f[1])) &gt;= 0 &amp;&amp; i &lt;= 3)
			ctlr-&gt;ptype = i;
		else
			r = -1;
	}
	else if(cistrcmp(cb-&gt;f[0], "ibss") == 0){
		if(cistrcmp(cb-&gt;f[1], "on") == 0)
			ctlr-&gt;createibss = 1;
		else
			ctlr-&gt;createibss = 0;
	}
	else if(cistrcmp(cb-&gt;f[0], "crypt") == 0){
		if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;crypt = 0;
		else if(cistrcmp(cb-&gt;f[1], "on") == 0 &amp;&amp; ctlr-&gt;hascrypt)
			ctlr-&gt;crypt = 1;
		else
			r = -1;
	}
	else if(cistrcmp(cb-&gt;f[0], "clear") == 0){
		if(cistrcmp(cb-&gt;f[1], "on") == 0)
			ctlr-&gt;xclear = 0;
		else if(cistrcmp(cb-&gt;f[1], "off") == 0 &amp;&amp; ctlr-&gt;hascrypt)
			ctlr-&gt;xclear = 1;
		else
			r = -1;
	}
	else if(cistrncmp(cb-&gt;f[0], "key", 3) == 0){
		if((i = atoi(cb-&gt;f[0]+3)) &gt;= 1 &amp;&amp; i &lt;= WNKeys){
			ctlr-&gt;txkey = i-1;
			if(parsekey(&amp;ctlr-&gt;keys.keys[ctlr-&gt;txkey], cb-&gt;f[1]))
				r = -1;
		}
		else
			r = -1;
	}
	else if(cistrcmp(cb-&gt;f[0], "txkey") == 0){
		if((i = atoi(cb-&gt;f[1])) &gt;= 1 &amp;&amp; i &lt;= WNKeys)
			ctlr-&gt;txkey = i-1;
		else
			r = -1;
	}
	else if(cistrcmp(cb-&gt;f[0], "pm") == 0){
		if(cistrcmp(cb-&gt;f[1], "off") == 0)
			ctlr-&gt;pmena = 0;
		else if(cistrcmp(cb-&gt;f[1], "on") == 0){
			ctlr-&gt;pmena = 1;
			if(cb-&gt;nf == 3){
				i = atoi(cb-&gt;f[2]);
				// check range here? what are the units?
				ctlr-&gt;pmwait = i;
			}
		}
		else
			r = -1;
	}
	else
		r = -2;
	free(cb);

	return r;
}

long
w_ctl(Ether* ether, void* buf, long n)
{
	Ctlr *ctlr;

	if((ctlr = ether-&gt;ctlr) == nil)
		error(Enonexist);
	if((ctlr-&gt;state &amp; Attached) == 0)
		error(Eshutdown);

	ilock(ctlr);
	if(w_option(ctlr, buf, n)){
		iunlock(ctlr);
		error(Ebadctl);
	}
	if(ctlr-&gt;txbusy)
		w_txdone(ctlr, WTxErrEv);
	w_enable(ether);
	w_txstart(ether);
	iunlock(ctlr);

	return n;
}

void
w_transmit(Ether* ether)
{
	Ctlr* ctlr = ether-&gt;ctlr;

	if(ctlr == 0)
		return;

	ilock(ctlr);
	ctlr-&gt;ntxrq++;
	w_txstart(ether);
	iunlock(ctlr);
}

void
w_promiscuous(void* arg, int on)
{
	Ether* ether = (Ether*)arg;
	Ctlr* ctlr = ether-&gt;ctlr;

	if(ctlr == nil)
		error("card not found");
	if((ctlr-&gt;state &amp; Attached) == 0)
		error("card not attached");
	ilock(ctlr);
	ltv_outs(ctlr, WTyp_Prom, (on?1:0));
	iunlock(ctlr);
}

void
w_interrupt(Ureg* ,void* arg)
{
	Ether* ether = (Ether*) arg;
	Ctlr* ctlr = (Ctlr*) ether-&gt;ctlr;

	if(ctlr == 0)
		return;
	ilock(ctlr);
	ctlr-&gt;nints++;
	w_intr(ether);
	iunlock(ctlr);
}

static void
w_shutdown(Ether* ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	w_intdis(ctlr);
	if(w_cmd(ctlr,WCmdIni,0))
		iprint("#l%d: init failed\n", ether-&gt;ctlrno);
	w_intdis(ctlr);
}

int
wavelanreset(Ether* ether, Ctlr *ctlr)
{
	Wltv ltv;

	iprint("wavelanreset, iob 0x%ux\n", ctlr-&gt;iob);
	w_intdis(ctlr);
	if(w_cmd(ctlr,WCmdIni,0)){
		iprint("#l%d: init failed\n", ether-&gt;ctlrno);
		return -1;
	}
	w_intdis(ctlr);
	ltv_outs(ctlr, WTyp_Tick, 8);

	ctlr-&gt;chan = 0;
	ctlr-&gt;ptype = WDfltPType;
	ctlr-&gt;txkey = 0;
	ctlr-&gt;createibss = 0;
	ctlr-&gt;keys.len = sizeof(WKey)*WNKeys/2 + 1;
	ctlr-&gt;keys.type = WTyp_Keys;
	if(ctlr-&gt;hascrypt = ltv_ins(ctlr, WTyp_HasCrypt))
		ctlr-&gt;crypt = 1;
	*ctlr-&gt;netname = *ctlr-&gt;wantname = 0;
	strcpy(ctlr-&gt;nodename, "Plan 9 STA");

	ctlr-&gt;netname[WNameLen-1] = 0;
	ctlr-&gt;wantname[WNameLen-1] = 0;
	ctlr-&gt;nodename[WNameLen-1] =0;

	ltv.type = WTyp_Mac;
	ltv.len	= 4;
	if(w_inltv(ctlr, &amp;ltv)){
		iprint("#l%d: unable to read mac addr\n",
			ether-&gt;ctlrno);
		return -1;
	}
	memmove(ether-&gt;ea, ltv.addr, Eaddrlen);

	if(ctlr-&gt;chan == 0)
		ctlr-&gt;chan = ltv_ins(ctlr, WTyp_Chan);
	ctlr-&gt;apdensity = WDfltApDens;
	ctlr-&gt;rtsthres = WDfltRtsThres;
	ctlr-&gt;txrate = WDfltTxRate;
	ctlr-&gt;maxlen = WMaxLen;
	ctlr-&gt;pmena = 0;
	ctlr-&gt;pmwait = 100;
	ctlr-&gt;signal = 1;
	ctlr-&gt;noise = 1;
	ctlr-&gt;state |= Power;

	// free old Ctlr struct if resetting after suspend
	if(ether-&gt;ctlr &amp;&amp; ether-&gt;ctlr != ctlr)
		free(ether-&gt;ctlr);

	// link to ether
	ether-&gt;ctlr = ctlr;
	ether-&gt;mbps = 10;
	ether-&gt;attach = w_attach;
	ether-&gt;detach = w_detach;
	ether-&gt;interrupt = w_interrupt;
	ether-&gt;transmit = w_transmit;
	ether-&gt;ifstat = w_ifstat;
	ether-&gt;ctl = w_ctl;
	ether-&gt;power = w_power;
	ether-&gt;promiscuous = w_promiscuous;
	ether-&gt;multicast = w_multicast;
	ether-&gt;shutdown = w_shutdown;
	ether-&gt;scanbs = w_scanbs;
	ether-&gt;arg = ether;

	DEBUG("#l%d: irq %d port %lx type %s",
		ether-&gt;ctlrno, ether-&gt;irq, ether-&gt;port,	ether-&gt;type);
	DEBUG(" %2.2ux%2.2ux%2.2ux%2.2ux%2.2ux%2.2ux\n",
		ether-&gt;ea[0], ether-&gt;ea[1], ether-&gt;ea[2],
		ether-&gt;ea[3], ether-&gt;ea[4], ether-&gt;ea[5]);

	return 0;
}

char* wavenames[] = {
	"WaveLAN/IEEE",
	"TrueMobile 1150",
	"Instant Wireless ; Network PC CARD",
	"Instant Wireless Network PC Card",
	"Avaya Wireless PC Card",
	"AirLancer MC-11",
	"INTERSIL;HFA384x/IEEE;Version 01.02;",
	nil,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

