<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/bootld.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/bootld.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * load kernel into memory
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"pool.h"
#include	"../port/netif.h"
#include	"../ip/ip.h"
#include	"pxe.h"

#include	&lt;a.out.h&gt;
#include 	"/sys/src/libmach/elf.h"

#undef KADDR
#undef PADDR

#define KADDR(a)	((void*)((ulong)(a) | KZERO))
#define PADDR(a)	((ulong)(a) &amp; ~KSEGM)

extern int debug;

extern void pagingoff(ulong);

static uchar elfident[] = {
	'\177', 'E', 'L', 'F',
};
static Ehdr ehdr, rehdr;
static E64hdr e64hdr;
static Phdr *phdr;
static P64hdr *p64hdr;

static int curphdr;
static ulong curoff;
static ulong elftotal;

static uvlong (*swav)(uvlong);
static long (*swal)(long);
static ushort (*swab)(ushort);

/*
 * big-endian short
 */
ushort
beswab(ushort s)
{
	uchar *p;

	p = (uchar*)&amp;s;
	return (p[0]&lt;&lt;8) | p[1];
}

/*
 * big-endian long
 */
long
beswal(long l)
{
	uchar *p;

	p = (uchar*)&amp;l;
	return (p[0]&lt;&lt;24) | (p[1]&lt;&lt;16) | (p[2]&lt;&lt;8) | p[3];
}

/*
 * big-endian vlong
 */
uvlong
beswav(uvlong v)
{
	uchar *p;

	p = (uchar*)&amp;v;
	return ((uvlong)p[0]&lt;&lt;56) | ((uvlong)p[1]&lt;&lt;48) | ((uvlong)p[2]&lt;&lt;40)
				  | ((uvlong)p[3]&lt;&lt;32) | ((uvlong)p[4]&lt;&lt;24)
				  | ((uvlong)p[5]&lt;&lt;16) | ((uvlong)p[6]&lt;&lt;8)
				  | (uvlong)p[7];
}

/*
 * little-endian short
 */
ushort
leswab(ushort s)
{
	uchar *p;

	p = (uchar*)&amp;s;
	return (p[1]&lt;&lt;8) | p[0];
}

/*
 * little-endian long
 */
long
leswal(long l)
{
	uchar *p;

	p = (uchar*)&amp;l;
	return (p[3]&lt;&lt;24) | (p[2]&lt;&lt;16) | (p[1]&lt;&lt;8) | p[0];
}

/*
 * little-endian vlong
 */
uvlong
leswav(uvlong v)
{
	uchar *p;

	p = (uchar*)&amp;v;
	return ((uvlong)p[7]&lt;&lt;56) | ((uvlong)p[6]&lt;&lt;48) | ((uvlong)p[5]&lt;&lt;40)
				  | ((uvlong)p[4]&lt;&lt;32) | ((uvlong)p[3]&lt;&lt;24)
				  | ((uvlong)p[2]&lt;&lt;16) | ((uvlong)p[1]&lt;&lt;8)
				  | (uvlong)p[0];
}

/*
 * Convert header to canonical form
 */
static void
hswal(long *lp, int n, long (*swap) (long))
{
	while (n--) {
		*lp = (*swap) (*lp);
		lp++;
	}
}

static void
hswav(uvlong *lp, int n, uvlong (*swap)(uvlong))
{
	while (n--) {
		*lp = (*swap)(*lp);
		lp++;
	}
}

static int
readehdr(Boot *b)
{
	int i;

	/* bitswap the header according to the DATA format */
	if(ehdr.ident[CLASS] != ELFCLASS32) {
		print("bad ELF class - not 32 bit\n");
		return 0;
	}
	if(ehdr.ident[DATA] == ELFDATA2LSB) {
		swab = leswab;
		swal = leswal;
	} else if(ehdr.ident[DATA] == ELFDATA2MSB) {
		swab = beswab;
		swal = beswal;
	} else {
		print("bad ELF encoding - not big or little endian\n");
		return 0;
	}
	memmove(&amp;rehdr, &amp;ehdr, sizeof(Ehdr));	/* copy; never used */

	ehdr.type = swab(ehdr.type);
	ehdr.machine = swab(ehdr.machine);
	ehdr.version = swal(ehdr.version);
	ehdr.elfentry = swal(ehdr.elfentry);
	ehdr.phoff = swal(ehdr.phoff);
	ehdr.shoff = swal(ehdr.shoff);
	ehdr.flags = swal(ehdr.flags);
	ehdr.ehsize = swab(ehdr.ehsize);
	ehdr.phentsize = swab(ehdr.phentsize);
	ehdr.phnum = swab(ehdr.phnum);
	ehdr.shentsize = swab(ehdr.shentsize);
	ehdr.shnum = swab(ehdr.shnum);
	ehdr.shstrndx = swab(ehdr.shstrndx);
	if(ehdr.type != EXEC || ehdr.version != CURRENT)
		return 0;
	if(ehdr.phentsize != sizeof(Phdr))
		return 0;

	if(debug)
		print("readehdr OK entry %#lux\n", ehdr.elfentry);

	curoff = sizeof(Ehdr);
	i = ehdr.phoff+ehdr.phentsize*ehdr.phnum - curoff;
	b-&gt;state = READPHDR;
	b-&gt;bp = (char*)smalloc(i);
	b-&gt;wp = b-&gt;bp;
	b-&gt;ep = b-&gt;wp + i;
	elftotal = 0;
	phdr = (Phdr*)(b-&gt;bp + ehdr.phoff-sizeof(Ehdr));
	if(debug)
		print("phdr...");

	return 1;
}

static int
reade64hdr(Boot *b)
{
	int i;

	/* bitswap the header according to the DATA format */
	if(e64hdr.ident[CLASS] != ELFCLASS64) {
		print("bad ELF class - not 64 bit\n");
		return 0;
	}
	if(e64hdr.ident[DATA] == ELFDATA2LSB) {
		swab = leswab;
		swal = leswal;
		swav = leswav;
	} else if(e64hdr.ident[DATA] == ELFDATA2MSB) {
		swab = beswab;
		swal = beswal;
		swav = beswav;
	} else {
		print("bad ELF encoding - not big or little endian\n");
		return 0;
	}
//	memmove(&amp;rehdr, &amp;ehdr, sizeof(Ehdr));	/* copy; never used */

	e64hdr.type = swab(e64hdr.type);
	e64hdr.machine = swab(e64hdr.machine);
	e64hdr.version = swal(e64hdr.version);
	e64hdr.elfentry = swav(e64hdr.elfentry);
	e64hdr.phoff = swav(e64hdr.phoff);
	e64hdr.shoff = swav(e64hdr.shoff);
	e64hdr.flags = swal(e64hdr.flags);
	e64hdr.ehsize = swab(e64hdr.ehsize);
	e64hdr.phentsize = swab(e64hdr.phentsize);
	e64hdr.phnum = swab(e64hdr.phnum);
	e64hdr.shentsize = swab(e64hdr.shentsize);
	e64hdr.shnum = swab(e64hdr.shnum);
	e64hdr.shstrndx = swab(e64hdr.shstrndx);
	if(e64hdr.type != EXEC || e64hdr.version != CURRENT)
		return 0;
	if(e64hdr.phentsize != sizeof(P64hdr))
		return 0;

	if(debug)
		print("reade64hdr OK entry %#llux\n", e64hdr.elfentry);

	curoff = sizeof(E64hdr);
	i = e64hdr.phoff + e64hdr.phentsize*e64hdr.phnum - curoff;
	b-&gt;state = READ64PHDR;
	b-&gt;bp = (char*)smalloc(i);
	b-&gt;wp = b-&gt;bp;
	b-&gt;ep = b-&gt;wp + i;
	elftotal = 0;
	p64hdr = (P64hdr*)(b-&gt;bp + e64hdr.phoff-sizeof(E64hdr));
	if(debug)
		print("p64hdr...");

	return 1;
}

static int
nextphdr(Boot *b)
{
	Phdr *php;
	ulong offset;
	char *physaddr;

	if(debug)
		print("readedata %d\n", curphdr);

	for(; curphdr &lt; ehdr.phnum; curphdr++){
		php = phdr+curphdr;
		if(php-&gt;type != LOAD)
			continue;
		offset = php-&gt;offset;
		physaddr = (char*)KADDR(PADDR(php-&gt;paddr));
		if(offset &lt; curoff){
			/*
			 * Can't (be bothered to) rewind the
			 * input, it might be from tftp. If we
			 * did then we could boot FreeBSD kernels
			 * too maybe.
			 */
			return 0;
		}
		if(php-&gt;offset &gt; curoff){
			b-&gt;state = READEPAD;
			b-&gt;bp = (char*)smalloc(offset - curoff);
			b-&gt;wp = b-&gt;bp;
			b-&gt;ep = b-&gt;wp + offset - curoff;
			if(debug)
				print("nextphdr %lud...\n", offset - curoff);
			return 1;
		}
		b-&gt;state = READEDATA;
		b-&gt;bp = physaddr;
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp+php-&gt;filesz;
		print("%ud+", php-&gt;filesz);
		elftotal += php-&gt;filesz;
		if(debug)
			print("nextphdr %ud@%#p\n", php-&gt;filesz, physaddr);

		return 1;
	}

	if(curphdr != 0){
		print("=%lud\n", elftotal);
		b-&gt;state = TRYEBOOT;
		b-&gt;entry = ehdr.elfentry;
		// PLLONG(b-&gt;hdr.entry, b-&gt;entry);
		return 1;
	}

	return 0;
}

static int
nextp64hdr(Boot *b)
{
	P64hdr *php;
	uvlong offset;
	char *physaddr;

	if(debug)
		print("reade64data %d\n", curphdr);

	for(; curphdr &lt; e64hdr.phnum; curphdr++){
		php = p64hdr+curphdr;
		if(php-&gt;type != LOAD)
			continue;
		offset = php-&gt;offset;
		physaddr = (char*)KADDR(PADDR(php-&gt;paddr));
		if(offset &lt; curoff){
			/*
			 * Can't (be bothered to) rewind the
			 * input, it might be from tftp. If we
			 * did then we could boot FreeBSD kernels
			 * too maybe.
			 */
			return 0;
		}
		if(php-&gt;offset &gt; curoff){
			b-&gt;state = READE64PAD;
			b-&gt;bp = (char*)smalloc(offset - curoff);
			b-&gt;wp = b-&gt;bp;
			b-&gt;ep = b-&gt;wp + offset - curoff;
			if(debug)
				print("nextp64hdr %llud...\n", offset - curoff);
			return 1;
		}
		b-&gt;state = READE64DATA;
		b-&gt;bp = physaddr;
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp+php-&gt;filesz;
		print("%llud+", php-&gt;filesz);
		elftotal += php-&gt;filesz;
		if(debug)
			print("nextp64hdr %llud@%#p\n", php-&gt;filesz, physaddr);

		return 1;
	}

	if(curphdr != 0){
		print("=%lud\n", elftotal);
		b-&gt;state = TRYE64BOOT;
		b-&gt;entry = e64hdr.elfentry;
		return 1;
	}

	return 0;
}

static int
readepad(Boot *b)
{
	Phdr *php;

	php = phdr+curphdr;
	if(debug)
		print("readepad %d\n", curphdr);
	curoff = php-&gt;offset;

	return nextphdr(b);
}

static int
reade64pad(Boot *b)
{
	P64hdr *php;

	php = p64hdr+curphdr;
	if(debug)
		print("reade64pad %d\n", curphdr);
	curoff = php-&gt;offset;

	return nextp64hdr(b);
}

static int
readedata(Boot *b)
{
	Phdr *php;

	php = phdr+curphdr;
	if(debug)
		print("readedata %d\n", curphdr);
	if(php-&gt;filesz &lt; php-&gt;memsz){
		print("%lud",  php-&gt;memsz-php-&gt;filesz);
		elftotal += php-&gt;memsz-php-&gt;filesz;
		memset((char*)KADDR(PADDR(php-&gt;paddr)+php-&gt;filesz), 0,
			php-&gt;memsz-php-&gt;filesz);
	}
	curoff = php-&gt;offset+php-&gt;filesz;
	curphdr++;

	return nextphdr(b);
}

static int
reade64data(Boot *b)
{
	P64hdr *php;

	php = p64hdr+curphdr;
	if(debug)
		print("reade64data %d\n", curphdr);
	if(php-&gt;filesz &lt; php-&gt;memsz){
		print("%llud",  php-&gt;memsz - php-&gt;filesz);
		elftotal += php-&gt;memsz - php-&gt;filesz;
		memset((char*)KADDR(PADDR(php-&gt;paddr) + php-&gt;filesz), 0,
			php-&gt;memsz - php-&gt;filesz);
	}
	curoff = php-&gt;offset + php-&gt;filesz;
	curphdr++;

	return nextp64hdr(b);
}

static int
readphdr(Boot *b)
{
	Phdr *php;

	php = phdr;
	hswal((long*)php, ehdr.phentsize*ehdr.phnum/sizeof(long), swal);
	if(debug)
		print("phdr curoff %lud vaddr %#lux paddr %#lux\n",
			curoff, php-&gt;vaddr, php-&gt;paddr);

	curoff = ehdr.phoff+ehdr.phentsize*ehdr.phnum;
	curphdr = 0;

	return nextphdr(b);
}

static int
readp64hdr(Boot *b)
{
	int hdr;
	P64hdr *php, *p;

	php = p = p64hdr;
	for (hdr = 0; hdr &lt; e64hdr.phnum; hdr++, p++) {
		hswal((long*)p, 2, swal);
		hswav((uvlong*)&amp;p-&gt;offset, 6, swav);
	}
	if(debug)
		print("p64hdr curoff %lud vaddr %#llux paddr %#llux\n",
			curoff, php-&gt;vaddr, php-&gt;paddr);

	curoff = e64hdr.phoff + e64hdr.phentsize*e64hdr.phnum;
	curphdr = 0;

	return nextp64hdr(b);
}

static int
addbytes(char **dbuf, char *edbuf, char **sbuf, char *esbuf)
{
	int n;

	n = edbuf - *dbuf;
	if(n &lt;= 0)
		return 0;			/* dest buffer is full */
	if(n &gt; esbuf - *sbuf)
		n = esbuf - *sbuf;
	if(n &lt;= 0)
		return -1;			/* src buffer is empty */

	memmove(*dbuf, *sbuf, n);
	*sbuf += n;
	*dbuf += n;
	return edbuf - *dbuf;
}

void
impulse(void)
{
	delay(500);				/* drain uart */
	splhi();

	/* turn off buffered serial console */
	serialoq = nil;

	/* shutdown devices */
	chandevshutdown();
	arch-&gt;introff();
}

void
prstackuse(int)
{
	char *top, *base;
	ulong *p;

	base = up-&gt;kstack;
	top =  up-&gt;kstack + KSTACK - (sizeof(Sargs) + BY2WD);
	for (p = (ulong *)base; (char *)p &lt; top &amp;&amp; *p ==
	    (Stkpat&lt;&lt;24 | Stkpat&lt;&lt;16 | Stkpat&lt;&lt;8 | Stkpat); p++)
		;
	print("proc stack: used %ld bytes, %ld left (stack pattern)\n",
		top - (char *)p, (char *)p - base);
}

/*
 * this code is simplified from reboot().  It doesn't need to relocate
 * the new kernel nor deal with other processors.
 */
void
warp9(ulong entry)
{
//	prstackuse(0);			/* debugging */
	mkmultiboot();
	impulse();

	/* get out of KZERO space, turn off paging and jump to entry */
	pagingoff(PADDR(entry));
}

static int
bootfail(Boot *b)
{
	b-&gt;state = FAILED;
	return FAIL;
}

static int
isgzipped(uchar *p)
{
	return p[0] == 0x1F &amp;&amp; p[1] == 0x8B &amp;&amp; p[2] == 0x08;
}

static int
readexec(Boot *b)
{
	Exechdr *hdr;
	ulong pentry, text, data, magic;

	hdr = &amp;b-&gt;hdr;
	magic = GLLONG(hdr-&gt;magic);
	if(magic == I_MAGIC || magic == S_MAGIC) {
		pentry = PADDR(GLLONG(hdr-&gt;entry));
		text = GLLONG(hdr-&gt;text);
		data = GLLONG(hdr-&gt;data);
		if (pentry &lt; MB)
			panic("kernel entry %#p below 1 MB", pentry);
		if (PGROUND(pentry + text) + data &gt; MB + Kernelmax)
			panic("kernel larger than %d bytes", Kernelmax);
		b-&gt;state = READ9TEXT;
		b-&gt;bp = (char*)KADDR(pentry);
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp+text;

		if(magic == I_MAGIC){
			memmove(b-&gt;bp, b-&gt;hdr.uvl, sizeof(b-&gt;hdr.uvl));
			b-&gt;wp += sizeof(b-&gt;hdr.uvl);
		}

		print("%lud", text);
	} else if(memcmp(b-&gt;bp, elfident, 4) == 0 &amp;&amp;
	    (uchar)b-&gt;bp[4] == ELFCLASS32){
		b-&gt;state = READEHDR;
		b-&gt;bp = (char*)&amp;ehdr;
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp + sizeof(Ehdr);
		memmove(b-&gt;bp, &amp;b-&gt;hdr, sizeof(Exechdr));
		b-&gt;wp += sizeof(Exechdr);
		print("elf...");
	} else if(memcmp(b-&gt;bp, elfident, 4) == 0 &amp;&amp;
	    (uchar)b-&gt;bp[4] == ELFCLASS64){
		b-&gt;state = READE64HDR;
		b-&gt;bp = (char*)&amp;e64hdr;
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp + sizeof(E64hdr);
		memmove(b-&gt;bp, &amp;b-&gt;hdr, sizeof(Exechdr));
		b-&gt;wp += sizeof(Exechdr);
		print("elf64...");
	} else if(isgzipped((uchar *)b-&gt;bp)) {
		b-&gt;state = READGZIP;
		/* could use Unzipbuf instead of smalloc() */
		b-&gt;bp = (char*)smalloc(Kernelmax);
		b-&gt;wp = b-&gt;bp;
		b-&gt;ep = b-&gt;wp + Kernelmax;
		memmove(b-&gt;bp, &amp;b-&gt;hdr, sizeof(Exechdr));
		b-&gt;wp += sizeof(Exechdr);
		print("gz...");
	} else {
		print("bad kernel format (magic %#lux)\n", magic);
		return bootfail(b);
	}
	return MORE;
}

static void
boot9(Boot *b, ulong magic, ulong entry)
{
	if(magic == I_MAGIC){
		print("entry: %#lux\n", entry);
		warp9(PADDR(entry));
	}
	else if(magic == S_MAGIC)
		warp64(beswav(b-&gt;hdr.uvl[0]));
	else
		print("bad magic %#lux\n", magic);
}

/* only returns upon failure */
static void
readgzip(Boot *b)
{
	ulong entry, text, data, bss, magic, all, pentry;
	uchar *sdata;
	Exechdr *hdr;

	/* the whole gzipped kernel is now at b-&gt;bp */
	hdr = &amp;b-&gt;hdr;
	if(!isgzipped((uchar *)b-&gt;bp)) {
		print("lost magic\n");
		return;
	}
	print("%ld =&gt; ", b-&gt;wp - b-&gt;bp);
	/* just fill hdr from gzipped b-&gt;bp, to get various sizes */
	if(gunzip((uchar*)hdr, sizeof *hdr, (uchar*)b-&gt;bp, b-&gt;wp - b-&gt;bp)
	    &lt; sizeof *hdr) {
		print("error uncompressing kernel exec header\n");
		return;
	}

	/* assume uncompressed kernel is a plan 9 boot image */
	magic = GLLONG(hdr-&gt;magic);
	entry = GLLONG(hdr-&gt;entry);
	text = GLLONG(hdr-&gt;text);
	data = GLLONG(hdr-&gt;data);
	bss = GLLONG(hdr-&gt;bss);
	print("%lud+%lud+%lud=%lud\n", text, data, bss, text+data+bss);

	pentry = PADDR(entry);
	if (pentry &lt; MB)
		panic("kernel entry %#p below 1 MB", pentry);
	if (PGROUND(pentry + text) + data &gt; MB + Kernelmax)
		panic("kernel larger than %d bytes", Kernelmax);

	/* fill entry from gzipped b-&gt;bp */
	all = sizeof(Exec) + text + data;
	if(gunzip((uchar *)KADDR(PADDR(entry)) - sizeof(Exec), all,
	    (uchar*)b-&gt;bp, b-&gt;wp - b-&gt;bp) &lt; all) {
		print("error uncompressing kernel\n");
		return;
	}

	/* relocate data to start at page boundary */
	sdata = KADDR(PADDR(entry+text));
	memmove((void*)PGROUND((uintptr)sdata), sdata, data);

	boot9(b, magic, entry);
}

/*
 * if nbuf is zero, boot.
 * else add nbuf bytes from vbuf to b-&gt;wp (if there is room)
 * and advance the state machine, which may reset b's pointers
 * and return to the top.
 */
int
bootpass(Boot *b, void *vbuf, int nbuf)
{
	char *buf, *ebuf;
	Exechdr *hdr;
	ulong entry, bss;
	uvlong entry64;

	if(b-&gt;state == FAILED)
		return FAIL;

	if(nbuf == 0)
		goto Endofinput;

	buf = vbuf;
	ebuf = buf+nbuf;
	/* possibly copy into b-&gt;wp from buf (not first time) */
	while(addbytes(&amp;b-&gt;wp, b-&gt;ep, &amp;buf, ebuf) == 0) {
		/* b-&gt;bp is full, so advance the state machine */
		switch(b-&gt;state) {
		case INITKERNEL:
			b-&gt;state = READEXEC;
			b-&gt;bp = (char*)&amp;b-&gt;hdr;
			b-&gt;wp = b-&gt;bp;
			b-&gt;ep = b-&gt;bp+sizeof(Exechdr);
			break;
		case READEXEC:
			readexec(b);
			break;

		case READ9TEXT:
			hdr = &amp;b-&gt;hdr;
			b-&gt;state = READ9DATA;
			b-&gt;bp = (char*)PGROUND((uintptr)
				KADDR(PADDR(GLLONG(hdr-&gt;entry))) +
				GLLONG(hdr-&gt;text));
			b-&gt;wp = b-&gt;bp;
			b-&gt;ep = b-&gt;wp + GLLONG(hdr-&gt;data);
			print("+%ld", GLLONG(hdr-&gt;data));
			break;
	
		case READ9DATA:
			hdr = &amp;b-&gt;hdr;
			bss = GLLONG(hdr-&gt;bss);
			memset(b-&gt;ep, 0, bss);
			print("+%ld=%ld\n",
				bss, GLLONG(hdr-&gt;text)+GLLONG(hdr-&gt;data)+bss);
			b-&gt;state = TRYBOOT;
			return ENOUGH;

		/*
		 * elf
		 */
		case READEHDR:
			if(!readehdr(b))
				print("readehdr failed\n");
			break;
		case READPHDR:
			readphdr(b);
			break;
		case READEPAD:
			readepad(b);
			break;
		case READEDATA:
			readedata(b);
			if(b-&gt;state == TRYEBOOT)
				return ENOUGH;
			break;

		/*
		 * elf64
		 */
		case READE64HDR:
			if(!reade64hdr(b))
				print("reade64hdr failed\n");
			break;
		case READ64PHDR:
			readp64hdr(b);
			break;
		case READE64PAD:
			reade64pad(b);
			break;
		case READE64DATA:
			reade64data(b);
			if(b-&gt;state == TRYE64BOOT)
				return ENOUGH;
			break;

		case TRYBOOT:
		case TRYEBOOT:
		case TRYE64BOOT:
		case READGZIP:
			return ENOUGH;

		case READ9LOAD:
		case INIT9LOAD:
			panic("9load");

		default:
			panic("bootstate");
		}
		if(b-&gt;state == FAILED)
			return FAIL;
	}
	return MORE;

Endofinput:
	/* end of input */
	switch(b-&gt;state) {
	case INITKERNEL:
	case READEXEC:
	case READ9TEXT:
	case READ9DATA:
	case READEHDR:
	case READPHDR:
	case READEPAD:
	case READEDATA:
	case READE64HDR:
	case READ64PHDR:
	case READE64PAD:
	case READE64DATA:
		print("premature EOF\n");
		break;

	case TRYBOOT:
		boot9(b, GLLONG(b-&gt;hdr.magic), GLLONG(b-&gt;hdr.entry));
		break;

	case TRYEBOOT:
		entry = b-&gt;entry;
		if(ehdr.machine == I386){
			print("entry: %#lux\n", entry);
			warp9(PADDR(entry));
		}
		else if(ehdr.machine == AMD64)
			warp64(entry);
		else
			panic("elf boot: ehdr.machine %d unknown", ehdr.machine);
		break;

	case TRYE64BOOT:
		entry64 = b-&gt;entry;
		if(e64hdr.machine == I386){
			print("entry: %#llux\n", entry64);
			warp9(PADDR(entry64));
		}
		else if(e64hdr.machine == AMD64)
			warp64(entry64);
		else
			panic("elf64 boot: e64hdr.machine %d unknown",
				e64hdr.machine);
		break;

	case READGZIP:
		readgzip(b);
		break;

	case INIT9LOAD:
	case READ9LOAD:
		panic("end 9load");

	default:
		panic("bootdone");
	}
	return bootfail(b);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

