<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/diskload.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/diskload.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * 9load - load next kernel from disk and start it
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"pool.h"
#include	"../port/error.h"
#include	"../port/netif.h"
#include	"dosfs.h"
#include	"../port/sd.h"

/* from &lt;libc.h&gt; */
#define	DIRMAX	(sizeof(Dir)+STATMAX)	/* max length of Dir structure */ 
#define	STATMAX	65535U	/* max length of machine-independent stat structure */

enum {
	Bufsize = 8192,
};

int	dosdirread(File *f, char ***nmarray);
int	isconf(char *name);

static int progress = 1;
static Bootfs fs;

/*
 * from 9load's bootp.c:
 */

static int
dumpfile(char *file)
{
	int n;
	char *buf;

	buf = smalloc(Maxfile + 1);
	n = readfile(file, buf, Maxfile);
	if (n &lt; 0)
		return -1;
	buf[n] = 0;
	print("%s (%d bytes):\n", file, n);
	print("%s\n", buf);
	free(buf);
	return 0;
}

long
dirread0(Chan *c, uchar *p, long n)
{
	long nn, nnn;
	vlong off;

	/*
	 * The offset is passed through on directories, normally.
	 * Sysseek complains, but pread is used by servers like exportfs,
	 * that shouldn't need to worry about this issue.
	 *
	 * Notice that c-&gt;devoffset is the offset that c's dev is seeing.
	 * The number of bytes read on this fd (c-&gt;offset) may be different
	 * due to rewritings in rockfix.
	 */
	/* use and maintain channel's offset */
	off = c-&gt;offset;
	if(off &lt; 0)
		error(Enegoff);

	if(off == 0){	/* rewind to the beginning of the directory */
		c-&gt;offset = 0;
		c-&gt;devoffset = 0;
		mountrewind(c);
		unionrewind(c);
	}

	if(c-&gt;qid.type &amp; QTDIR){
		if(mountrockread(c, p, n, &amp;nn)){
			/* do nothing: mountrockread filled buffer */
		}else if(c-&gt;umh)
			nn = unionread(c, p, n);
		else{
			if(off != c-&gt;offset)
				error(Edirseek);
			nn = devtab[c-&gt;type]-&gt;read(c, p, n, c-&gt;devoffset);
		}
		nnn = mountfix(c, p, nn, n);
	}else
		nnn = nn = devtab[c-&gt;type]-&gt;read(c, p, n, off);

	lock(c);
	c-&gt;devoffset += nn;
	c-&gt;offset += nnn;
	unlock(c);

	/* nnn == 54, sizeof(Dir) == 60 */
	return nnn;
}

long
dirread(Chan *c, Dir **d)
{
	uchar *buf;
	long ts;

	buf = malloc(DIRMAX);
	if(buf == nil)
		return -1;
	ts = dirread0(c, buf, DIRMAX);
	if(ts &gt;= 0)
		/* convert machine-independent representation to Dirs */
		ts = dirpackage(buf, ts, d);
	free(buf);
	return ts;
}

static int
addsdev(Dir *dirp)
{
	int n, f, lines, flds;
	vlong start, end;
	char *buf, *part;
	char *line[64], *fld[5];
	char ctl[64], disk[64];

	buf = smalloc(Maxfile + 1);
	snprint(ctl, sizeof ctl, "#S/%s/ctl", dirp-&gt;name);
	n = readfile(ctl, buf, Maxfile);
	if (n &lt; 0) {
		free(buf);
		return -1;
	}
	buf[n] = 0;

	lines = getfields(buf, line, nelem(line), 0, "\r\n");
	part = nil;
	for (f = 0; f &lt; lines; f++) {
		flds = tokenize(line[f], fld, nelem(fld));
		if (flds &lt; 4 || strcmp(fld[0], "part") != 0)
			continue;
		kstrdup(&amp;part, fld[1]);
		start = strtoull(fld[2], nil, 0);
		end   = strtoull(fld[3], nil, 0);
		if (end &gt; (vlong)100*(vlong)MB*MB) {
			print("addsdev: implausible partition #S/%s/%s %lld %lld\n",
				dirp-&gt;name, part, start, end);
			continue;
		}
		/*
		 * We are likely to only see a "data" partition on each disk.
		 *
		 * Read the on-disk partition tables &amp; set in-core partitions
		 * (disk, part, start, end).
		 */
		print("found partition #S/%s/%s %,lld %,lld\n",
			dirp-&gt;name, part, start, end);
		snprint(disk, sizeof disk, "#S/%s", dirp-&gt;name);
		readparts(disk);
	}
	free(buf);
	return 0;
}

static File file;

/*
 * look for kernels on a 9fat; if there's just one, return it.
 * could treat x and x.gz as one kernel.
 */
static char *
findonekernel(Bootfs *fs)
{
	int n, kerns;
	char *bootfile, *name;
	char **array;

	if(fswalk(fs, "", &amp;file) &lt;= 0) {
		print("can't walk to ''\n");
		return nil;
	}
	dosdirread(&amp;file, &amp;array);
	bootfile = nil;
	kerns = 0;
	for (n = 0; (name = array[n]) != nil; n++)
		if(strncmp(name, "9pc", 3) == 0 ||
		   strncmp(name, "9k8", 3) == 0 ||
		   strncmp(name, "9k10", 4) == 0){
			bootfile = name;
			kerns++;
		}
	if (kerns &gt; 1) {
		print("found these kernels:");
		for (n = 0; (name = array[n]) != nil; n++)
			print(" %s", name);
		print("\n");
	}
	return kerns == 1? bootfile: nil;
}

int
partboot(char *path)
{
	long n;
	char *buf;
	Boot boot;
	Boot *b;
	Chan *ch;

	b = &amp;boot;
	memset(b, 0, sizeof *b);
	b-&gt;state = INITKERNEL;
	ch = namecopen(path, OREAD);
	if (ch == nil) {
		print("can't open partition %s\n", path);
		return -1;
	}
	print("loading %s\n", path);
	buf = smalloc(Bufsize);
	while((n = devtab[ch-&gt;type]-&gt;read(ch, buf, Bufsize, ch-&gt;offset)) &gt; 0)
		if(bootpass(b, buf, n) != MORE)
			break;
	bootpass(b, nil, 0);		/* attempts to boot */

	free(buf);
	cclose(ch);
	return -1;
}

/* fsroot must be nil or a fat root directory already dosinit'ed */
static void
trybootfile(char *bootfile, Bootfs *fsroot)
{
	int nf;
	char fat[64];
	char *disk, *part, *file, *bootcopy;
	char *fields[4];
	Boot boot;
	static int didaddconf;

	bootcopy = file = nil;
	kstrdup(&amp;bootcopy, bootfile);
	nf = getfields(bootcopy, fields, nelem(fields), 0, "!");
	switch(nf){
	case 3:
		file = fields[2];
		/* fall through */
	case 2:
		disk = fields[0];
		part = fields[1];
		break;
	default:
		print("bad bootfile syntax: %s\n", bootfile);
		return;
	}

	if(didaddconf == 0) {
		didaddconf = 1;
		sdaddallconfs(sdaddconf);
	}

	snprint(fat, sizeof fat, "#S/%s/%s", disk, part);
	if (file == nil) { /* if no file, try to load from partition directly */
		partboot(fat);
		return;
	}

	if (fsroot == nil) {
		fsroot = &amp;fs;
		memset(fsroot, 0, sizeof *fsroot);
		if (dosinit(fsroot, fat) &lt; 0) {
			print("dosinit %s failed\n", fat);
			return;
		}
	}

	/* load kernel and jump to it */
	memset(&amp;boot, 0, sizeof boot);
	boot.state = INITKERNEL;
	fsboot(fsroot, file, &amp;boot);

	/* failed to boot */
}

/*
 * for a given disk's 9fat, find &amp; load plan9.ini, parse it,
 * extract kernel filename, load that kernel and jump to it.
 */
static void
trydiskboot(char *disk)
{
	int n;
	char fat[80];
	char *ini, *bootfile;

	/* mount the disk's 9fat */
	memset(&amp;fs, 0, sizeof fs);
	snprint(fat, sizeof fat, "#S/%s/9fat", disk);
	if (dosinit(&amp;fs, fat) &lt; 0) {
		print("dosinit %s failed\n", fat);
		return;
	}

	/* open plan9.ini, read it */
	ini = smalloc(Maxfile+1);
	if(fswalk(&amp;fs, "plan9.ini", &amp;file) &lt;= 0) {
		print("no plan9.ini in %s\n", fat);
		n = 0;
	} else {
		n = fsread(&amp;file, ini, Maxfile);
		if (n &lt; 0)
			panic("error reading %s", ini);
	}
	ini[n] = 0;

	/*
	 * take note of plan9.ini contents.  consumes ini to make config vars,
	 * thus we can't free ini.
	 */
	dotini(ini);
	i8250console();			/* (re)configure serial port */

	bootfile = nil;			/* for kstrdup in askbootfile */
	if(isconf("bootfile")) {
		kstrdup(&amp;bootfile, getconf("bootfile"));
		if(strcmp(bootfile, "manual") == 0)
			askbootfile(fat, sizeof fat, &amp;bootfile, 0, "");

		/* pass arguments to kernels that can use them */
		strecpy(BOOTLINE, BOOTLINE+BOOTLINELEN, bootfile);
	} else if ((bootfile = findonekernel(&amp;fs)) != nil) {  /* look in fat */
		snprint(fat, sizeof fat, "%s!9fat!%s", disk, bootfile);
		bootfile = fat;
		print("no bootfile named in plan9.ini; found %s\n", bootfile);
	} else {
		/* if #S/disk/kernel partition exists, load from it. */
		snprint(fat, sizeof fat, "#S/%s/kernel", disk);
		partboot(fat);
		/* last resort: ask the user */
		askbootfile(fat, sizeof fat, &amp;bootfile, Promptsecs,
			"sdC0!9fat!9pccpu");
	}
	trybootfile(bootfile, &amp;fs);

	/* failed; try again */
}

/*
 * find all the disks in #S, read their partition tables and set those
 * partitions in core, mainly so that we can access 9fat file systems.
 * for each disk's 9fat, read plan9.ini and boot the named kernel.
 */
void
bootloadproc(void *)
{
	int n, dirs, sdev;
	char kern[64];
	char *sdevs[128];
	Chan *sdch;
	Dir *dirp, *dp;

	memset(sdevs, 0, sizeof sdevs);
	sdch = nil;
	while(waserror()) {
		print("error caught at top level in bootload\n");
		if(sdch) {
			cclose(sdch);
			sdch = nil;
		}
	}
	bind("#S", "/dev", MAFTER);		/* try to force an attach */
	sdch = namecopen("#S", OREAD);
	if (sdch == nil)
		panic("no disks (no #S)");
	sdev = 0;
	while ((dirs = dirread(sdch, &amp;dirp)) &gt; 0) {
		for (dp = dirp; dirs-- &gt; 0; dp++)
			if (strcmp(dp-&gt;name, "sdctl") != 0) {
				addsdev(dp);
				if (sdev &gt;= nelem(sdevs))
					print("too many sdevs; ignoring %s\n",
						dp-&gt;name);
				else
					kstrdup(&amp;sdevs[sdev++], dp-&gt;name);
			}
		free(dirp);
	}
	cclose(sdch);
	sdch = nil;
	if (sdev == 0)
		panic("no disks (in #S)");

	print("disks:");
	for (n = 0; n &lt; sdev; n++)
		print(" %s", sdevs[n]);
	print("\n");

	for (n = 0; n &lt; sdev; n++) {
		print("trying %s...", sdevs[n]);
		trydiskboot(sdevs[n]);
	}
	USED(sdch);
	for (;;) {
		askbootfile(kern, sizeof kern, nil, 0, "");
		trybootfile(kern, nil);
	}
	// poperror();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

