<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/expand.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/expand.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * expand gzipped boot loader appended to this binary and execute it.
 *
 * due to Russ Cox, rsc@swtch.com.
 * see http://plan9.bell-labs.com/wiki/plan9/Replacing_9load
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;a.out.h&gt;
#include &lt;flate.h&gt;
#include "mem.h"
#include "expand.h"

#include "inflate.guts.c"

#define KB		1024
#define MB		(1024*1024)

extern char edata[];

/* ldecomp.s */
void mb586(void);
void splhi(void);
void wbinvd(void);

/* inflate.guts.c */
int gunzip(uchar*, int, uchar*, int);

int isexec(void*);
int isgzip(uchar*);
void run(void*);

#pragma varargck type "d" ulong
#pragma varargck type "x" ulong

static uchar *kernel = (uchar*)Bootkernaddr;
static char *dbrk = (char*)Mallocbase;

ulong
swap(ulong p)
{
	return p&lt;&lt;24 | p&gt;&gt;24 | (p&lt;&lt;8)&amp;0x00FF0000 | (p&gt;&gt;8)&amp;0x0000FF00;
}

enum {
	/* keyboard controller ports &amp; cmds */
	Data=		0x60,		/* data port */
	Status=		0x64,		/* status port */
	 Inready=	0x01,		/*  input character ready */
	 Outbusy=	0x02,		/*  output busy */
	Cmd=		0x64,		/* command port (write only) */

	/* system control port a */
	Sysctla=	0x92,
	 Sysctlreset=	1&lt;&lt;0,
	 Sysctla20ena=	1&lt;&lt;1,
};

static int
isa20on(void)
{
	int r;
	ulong o;
	ulong *zp, *mb1p;

	zp = 0;
	mb1p = (ulong *)MB;
	o = *zp;

	*zp = 0x1234;
	*mb1p = 0x8765;
	mb586();
	wbinvd();
	r = *zp != *mb1p;

	*zp = o;
	return r;
}

static void
delay(uint ms)				/* approximate */
{
	int i;

	while(ms-- &gt; 0)
		for(i = 1000*1000; i &gt; 0; i--)
			;
}

static int
kbdinit(void)
{
	int c, try;

	/* wait for a quiescent controller */
	try = 500;			/* was 1000 */
	while(try-- &gt; 0 &amp;&amp; (c = inb(Status)) &amp; (Outbusy | Inready)) {
		if(c &amp; Inready)
			inb(Data);
		delay(1);
	}
	return try &lt;= 0? -1: 0;
}

/*
 *  wait for output no longer busy (but not forever,
 *  there might not be a keyboard controller).
 */
static void
outready(void)
{
	int i;

	for (i = 1000; i &gt; 0 &amp;&amp; inb(Status) &amp; Outbusy; i--)
		delay(1);
}

/*
 *  ask 8042 to enable the use of address bit 20
 */
int
i8042a20(void)
{
	if (kbdinit() &lt; 0)
		return -1;
	outready();
	outb(Cmd, 0xD1);
	outready();
	outb(Data, 0xDF);
	outready();
	return 0;
}

void
a20init(void)
{
	int b;

	if (isa20on())
		return;
	if (i8042a20() &lt; 0) {		/* original method, via kbd ctlr */
		/* newer method, last resort */
		b = inb(Sysctla);
		if (!(b &amp; Sysctla20ena))
			outb(Sysctla, (b &amp; ~Sysctlreset) | Sysctla20ena);
	}
	if (!isa20on()){
		print("a20 didn't come on!\n");
		for(;;)
			;
	}
}

void
_main(void)
{
	int ksize;
	Exec *exec;

	splhi();
	a20init();		/* don't wrap addresses at 1MB boundaries */
	ksize = Lowmemsz - (ulong)edata;	/* payload size */
	memmove(kernel, edata, ksize);
	memset(edata, 0, end - edata);

	cgainit();
	if(isgzip(kernel)) {
		print("gz...");
		memmove((uchar*)Unzipbuf, kernel, ksize);

		/* we have to uncompress the entire kernel to get OK status */
		if(gunzip(kernel, Bootkernmax, (uchar*)Unzipbuf, ksize) &lt; 0){
			print("gzip failed.");
			exits(0);
		}
	}
	if(isexec(kernel))
		run(kernel);

	exec = (Exec *)kernel;
	print("unrecognized program; magic # 0x%x\n", swap(exec-&gt;magic));
	exits(0);
}

int
isexec(void *v)
{
	Exec *exec;

	exec = v;
	return swap(exec-&gt;magic) == I_MAGIC || swap(exec-&gt;magic) == S_MAGIC;
}

void
run(void *v)
{
	ulong entry, text, data;
	uchar *base;
	Exec *exec;

	base = v;
	exec = v;
	entry = swap(exec-&gt;entry) &amp; ~KSEGM;
	text = swap(exec-&gt;text);
	data = swap(exec-&gt;data);
	/*
	 * align data segment on the expected page boundary.
	 * sizeof(Exec)+text is offset from base to data segment.
	 */
	memmove(base+PGROUND(sizeof(Exec)+text), base+sizeof(Exec)+text, data);

	print("starting protected-mode loader at 0x%x\n", entry);
	((void(*)(void))entry)();

	print("exec failed");
	exits(0);
}

int
isgzip(uchar *p)
{
	return p[0] == 0x1F &amp;&amp; p[1] == 0x8B;
}

void*
malloc(ulong n)
{
	void *v;

	v = dbrk;
	dbrk += ROUND(n, BY2WD);
	return v;
}

void
free(void*)
{
}

void
puts(char *s)
{
	for(; *s; s++)
		cgaputc(*s);
}

int
print(char *fmt, ...)
{
	int sign;
	long d;
	ulong x;
	char *p, *s, buf[20];
	va_list arg;
	static char *hex = "0123456789abcdef";

	va_start(arg, fmt);
	for(p = fmt; *p; p++){
		if(*p != '%') {
			cgaputc(*p);
			continue;
		}
		SET(s);
		switch(*++p){
		case 'p':
		case 'x':
			x = va_arg(arg, ulong);
			if(x == 0){
				s = "0";
				break;
			}
			s = buf+sizeof buf;
			*--s = 0;
			while(x &gt; 0){
				*--s = hex[x&amp;15];
				x /= 16;
			}
			if(s == buf+sizeof buf)
				*--s = '0';
			break;
		case 'd':
			d = va_arg(arg, ulong);
			if(d == 0){
				s = "0";
				break;
			}
			if(d &lt; 0){
				d = -d;
				sign = -1;
			}else
				sign = 1;
			s = buf+sizeof buf;
			*--s = 0;
			while(d &gt; 0){
				*--s = (d%10)+'0';
				d /= 10;
			}
			if(sign &lt; 0)
				*--s = '-';
			break;
		case 's':
			s = va_arg(arg, char*);
			break;
		case 0:
			return 0;
		}
		puts(s);
	}
	return 0;
}

void
exits(char*)
{
	for(;;)
		;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

