<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/inflate.guts.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/inflate.guts.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* included by expand and 9boot with different header files */

typedef struct Biobuf	Biobuf;

struct Biobuf
{
	uchar *bp;
	uchar *p;
	uchar *ep;
};

static ulong	Boffset(Biobuf *bp);
static int	crcwrite(void *out, void *buf, int n);
static ulong	get4(Biobuf *b);
static int	getc(void*);
static int	header(Biobuf*);
static ulong	offset(Biobuf*);
static int	trailer(Biobuf*, Biobuf*);

/* GZIP flags */
enum {
	Ftext=		(1&lt;&lt;0),
	Fhcrc=		(1&lt;&lt;1),
	Fextra=		(1&lt;&lt;2),
	Fname=		(1&lt;&lt;3),
	Fcomment=	(1&lt;&lt;4),

	GZCRCPOLY	= 0xedb88320UL,
};

static ulong	*crctab;
static ulong	crc;

int
gunzip(uchar *out, int outn, uchar *in, int inn)
{
	Biobuf bin, bout;
	int err;

	crc = 0;
	crctab = mkcrctab(GZCRCPOLY);
	err = inflateinit();
	if(err != FlateOk)
		print("inflateinit failed: %s\n", flateerr(err));

	bin.bp = bin.p = in;
	bin.ep = in+inn;
	bout.bp = bout.p = out;
	bout.ep = out+outn;

	err = header(&amp;bin);
	if(err != FlateOk)
		return err;

	err = inflate(&amp;bout, crcwrite, &amp;bin, getc);
	if(err != FlateOk)
		print("inflate failed: %s\n", flateerr(err));

	err = trailer(&amp;bout, &amp;bin);
	if(err != FlateOk)
		return err;

	return Boffset(&amp;bout);
}

static int
header(Biobuf *bin)
{
	int i, flag;

	if(getc(bin) != 0x1f || getc(bin) != 0x8b){
		print("bad magic\n");
		return FlateCorrupted;
	}
	if(getc(bin) != 8){
		print("unknown compression type\n");
		return FlateCorrupted;
	}
	
	flag = getc(bin);
	
	/* mod time */
	get4(bin);
	
	/* extra flags */
	getc(bin);
	
	/* OS type */
	getc(bin);

	if(flag &amp; Fextra)
		for(i=getc(bin); i&gt;0; i--)
			getc(bin);
	
	/* name */
	if(flag&amp;Fname)
		while(getc(bin) != 0)
			;

	/* comment */
	if(flag&amp;Fcomment)
		while(getc(bin) != 0)
			;

	/* crc16 */
	if(flag&amp;Fhcrc) {
		getc(bin);
		getc(bin);
	}
		
	return FlateOk;
}

static int
trailer(Biobuf *bout, Biobuf *bin)
{
	/* crc32 */
	if(crc != get4(bin)){
		print("crc mismatch\n");
		return FlateCorrupted;
	}

	/* length */
	if(get4(bin) != Boffset(bout)){
		print("bad output len\n");
		return FlateCorrupted;
	}
	return FlateOk;
}

static ulong
get4(Biobuf *b)
{
	ulong v;
	int i, c;

	v = 0;
	for(i = 0; i &lt; 4; i++){
		c = getc(b);
		v |= c &lt;&lt; (i * 8);
	}
	return v;
}

static int
getc(void *in)
{
	Biobuf *bp = in;

//	if((bp-&gt;p - bp-&gt;bp) % 10000 == 0)
//		print(".");
	if(bp-&gt;p &gt;= bp-&gt;ep){
		print("EOF");
		return -1;
	}
	return *bp-&gt;p++;
}

static ulong
Boffset(Biobuf *bp)
{
	return bp-&gt;p - bp-&gt;bp;
}

static int
crcwrite(void *out, void *buf, int n)
{
	Biobuf *bp;
	int nn;

	crc = blockcrc(crctab, crc, buf, n);
	bp = out;
	nn = n;
	if(nn &gt; bp-&gt;ep-bp-&gt;p)
		nn = bp-&gt;ep-bp-&gt;p;
	if(nn &gt; 0)
		memmove(bp-&gt;p, buf, nn);
	bp-&gt;p += n;
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

