<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/iso9660.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/iso9660.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ISO 9660 CD format
 */

#define	VOLDESC	16	/* sector number */

/*
 * L means little-endian, M means big-endian, and LM means little-endian
 * then again big-endian.
 */
typedef uchar		Byte2L[2];
typedef uchar		Byte2M[2];
typedef uchar		Byte4LM[4];
typedef uchar		Byte4L[4];
typedef uchar		Byte4M[4];
typedef uchar		Byte8LM[8];
typedef union Drec	Drec;
typedef union Voldesc	Voldesc;

enum {
	BootIso		= 0,
	PrimaryIso	= 1,
	SupplementaryIso = 2,
	PartitionIso	= 3,
	TerminatorIso	= 255,
};

enum {
	Cdsec	= 2048,
	Maxname = 256,
};

union Voldesc {			/* volume descriptor */
	uchar	byte[Cdsec];
	union {			/* for CD001, the ECMA standard */
		struct {
			uchar	type;
			uchar	stdid[5];
			uchar	version;
			uchar	unused;
			uchar	sysid[32];
			uchar	bootid[32];
			uchar	data[1977];
		} boot;
		struct {
			uchar	type;
			uchar	stdid[5];
			uchar	version;
			uchar	flags;
			uchar	sysid[32];
			uchar	volid[32];
			Byte8LM	partloc;
			Byte8LM	size;
			uchar	escapes[32];
			Byte4LM	vsetsize;
			Byte4LM	vseqno;
			Byte4LM	blksize;
			Byte8LM	ptabsize;
			Byte4L	lptable;
			Byte4L	optlptable;
			Byte4M	mptable;
			Byte4M	optmptable;
			uchar	rootdir[34];
			uchar	volsetid[128];
			uchar	pubid[128];
			uchar	prepid[128];
			uchar	appid[128];
			uchar	copyright[37];
			uchar	abstract[37];
			uchar	bibliography[37];
			uchar	cdate[17];
			uchar	mdate[17];
			uchar	expdate[17];
			uchar	effdate[17];
			uchar	fsversion;
			uchar	unused3[1];
			uchar	appuse[512];
			uchar	unused4[653];
		} desc;
	} z;
	union {			/* for CDROM, the `High Sierra' standard */
		struct {
			Byte8LM	number;
			uchar	type;
			uchar	stdid[5];
			uchar	version;
			uchar	flags;
			uchar	sysid[32];
			uchar	volid[32];
			Byte8LM	partloc;
			Byte8LM	size;
			uchar	escapes[32];
			Byte4LM	vsetsize;
			Byte4LM	vseqno;
			Byte4LM	blksize;
			uchar	quux[40];
			uchar	rootdir[34];
			uchar	volsetid[128];
			uchar	pubid[128];
			uchar	prepid[128];
			uchar	appid[128];
			uchar	copyright[32];
			uchar	abstract[32];
			uchar	cdate[16];
			uchar	mdate[16];
			uchar	expdate[16];
			uchar	effdate[16];
			uchar	fsversion;
		} desc;
	} r;
};

union Drec {
	struct {
		uchar	reclen;
		uchar	attrlen;
		Byte8LM	addr;
		Byte8LM	size;
		uchar	date[6];
		uchar	tzone;		/* flags in high sierra */
		uchar	flags;		/* ? in high sierra */
		uchar	unitsize;	/* ? in high sierra */
		uchar	gapsize;	/* ? in high sierra */
		Byte4LM	vseqno;		/* ? in high sierra */
		uchar	namelen;
		uchar	name[1];
	};
	struct {
		uchar	r_pad[24];
		uchar	r_flags;
	};
};

struct Isofile {
	short	fmt;		/* 'z' if iso, 'r' if high sierra */
	short	blksize;
	vlong	offset;		/* true offset when reading directory */
	long	odelta;		/* true size of directory just read */
	vlong	doffset;	/* plan9 offset when reading directory */
	Drec	d;
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

