<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/mem.h - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/mem.h</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Memory and machine-specific definitions.  Used in C and assembler.
 */

/*
 * Sizes
 */
#define	BI2BY		8			/* bits per byte */
#define	BI2WD		32			/* bits per word */
#define	BY2WD		4			/* bytes per word */
#define	BY2V		8			/* bytes per double word */
#define	BY2PG		4096			/* bytes per page */
#define	WD2PG		(BY2PG/BY2WD)		/* words per page */
#define	BY2XPG		(4096*1024)		/* bytes per big page */
#define	PGSHIFT		12			/* log(BY2PG) */
#define CACHELINESZ	32			/* pentium &amp; later */
#define	BLOCKALIGN	8

#define	MAXMACH		1			/* max # cpus system can run */
/*
 * we use a larger-than-normal kernel stack in the bootstraps as we have
 * significant arrays (buffers) on the stack.  we typically consume about
 * 4.5K of stack.
 */
#define KSTACK		(4*BY2PG)		/* Size of kernel stack */
#define MACHSIZE	BY2PG

/*
 * Time
 */
#define	HZ		(100)			/* clock frequency */
#define	MS2HZ		(1000/HZ)		/* millisec per clock tick */
#define	TK2SEC(t)	((t)/HZ)		/* ticks to seconds */

/*
 *  Address spaces
 *
 *  Kernel is at 2GB-4GB
 */
#define	KZERO		0x80000000		/* base of kernel address space */
#define	KSEGM		0xF0000000
#define	VPT		(KZERO-VPTSIZE)
#define	VPTSIZE		BY2XPG
#define	NVPT		(VPTSIZE/BY2WD)
#define	KMAP		(VPT-KMAPSIZE)
#define	KMAPSIZE	BY2XPG
#define	VMAP		(KMAP-VMAPSIZE)
#define	VMAPSIZE	(0x10000000-VPTSIZE-KMAPSIZE)
#define	UZERO		0			/* base of user address space */
#define	UTZERO		(UZERO+BY2PG)		/* first address in user text */
#define UTROUND(t)	ROUNDUP((t), BY2PG)
#define	USTKTOP		(VMAP-BY2PG)		/* byte just beyond user stack */
#define	USTKSIZE	(16*1024*1024)		/* size of user stack */
#define	TSTKTOP		(USTKTOP-USTKSIZE)	/* end of new stack in sysexec */
#define	TSTKSIZ 	100			/* pages in new stack; limits exec args */

/*
 * Fundamental addresses - bottom 64kB saved for return to real mode
 *
 * we need some fixed address space for things that normally fit below the
 * kernel and some of it needs to be addressible from real mode, thus under 1MB.
 *
 * pxe loading starts us at 0x7c00 and non-pxe loading starts us at 0x10000.
 *
 * this assertion must hold: PDX(TMPADDR) == PDX(MACHADDR).
 * see realmode0.s for a description of the Chinese puzzle.
 */
/* first 1K is real-mode IVT (vectors) */
/* next 256 bytes are bios data area (bda) */
/* 0x500 to 0x800 unused [768] */
/*
 * RMCODE should be the lowest address used in real mode.
 * all real-mode buffers, etc. should follow it.
 */
#define RMCODE		(KZERO+0x800)	/* copy of initial KTZERO [2K, magic] */
#define	REBOOTADDR	(RMCODE-KZERO)	/* reboot code - physical address [128] */
#define RMSIZE		2048
/* 0x1000 to 0x1200 unused [512] */
/* CONFADDR must match def'n in kernel being loaded */
#define	CONFADDR	(KZERO+0x1200)	/* cfg passed to kernel [3.5K, fixed] */
#define BIOSXCHG	(KZERO+0x2000)	/* BIOS data exchange [2K+32] */
/* 0x2820 to 0x2900 unused [224] */
#define	RMUADDR		(KZERO+0x2900)	/* real mode Ureg [128 (76 actual)] */
/* 0x2980 to 0x3000 unused [1664] */
#define IDTADDR		(KZERO+0x3000)	/* protected-mode idt [2K] */
/* 0x3800 to 0x4000 unused [2K] */

/* we only use one processor for bootstrapping, so merge MACHADDR &amp; CPU0MACH */
#define	MACHADDR	(KZERO+0x4000)	/* as seen by current processor */
#define	CPU0MACH	MACHADDR	/* Mach for bootstrap processor */
#define	CPU0GDT		(KZERO+0x5000)	/* bootstrap processor GDT after Mach */
#define	TMPADDR		(KZERO+0x6000)	/* used for temporary mappings */
/* 0x7000—0x7800 unused [2K], could be extra real-mode stack */
#define PXEBASE 	0x7c00		/* pxe loads us here */
#define RMSTACK 	PXEBASE		/* real phys. stack base [1K below] */
#define PBSBASE		0x10000		/* pbs loads us here (at 64K) */

/*
 * we used to use 9boot's `end', rounded up, but that was when the boot loader
 * was in the first 640K; now end is up around 10MB (at least for 9boot).
 * various machines nibble away at the top of the lowest 640K.
 */
#define BIOSTABLES	(512*1024)
// #define BIOSTABLES	(600*1024)	/* fails on amd64 */
// #define BIOSTABLES	0x3800		/* 2K: fails on amd64 */

#define Bootkernaddr	(9*MB)	/* where to put decompressed boot kernel */
#define Bootkernmax	(4*MB)	/* max size */
#define Unzipbuf	(13*MB)
#define Mallocbase	(16*MB)
/*
 * MemMin is what the bootstrap code in l*.s has already mapped;
 * MemMax is the limit of physical memory to scan.
 */
#define MemMin		(20*MB)	/* don't have PTEs for more allocated yet */
#define MemMax		(512*MB) /* allow for huge 10gbe buffers */

#define Lowmemsz	(640*KB)

#define LOWPTEPAGES	(MemMin / (4*MB))

#define Kernelmax	(8*MB)	/* max size of real kernel, not an address */

/*
 *  known x86 segments (in GDT) and their selectors
 */
#define	NULLSEG	0	/* null segment */
#define	KDSEG	1	/* kernel data/stack */
#define	KESEG	2	/* kernel executable */	
#define	UDSEG	3	/* user data/stack */
#define	UESEG	4	/* user executable */
#define	TSSSEG	5	/* task segment */
#define	APMCSEG		6	/* APM code segment */
#define	APMCSEG16	7	/* APM 16-bit code segment */
#define	APMDSEG		8	/* APM data segment */
#define	KESEG16		9	/* kernel executable 16-bit */
#define	NGDT		10	/* number of GDT entries required */
/* #define	APM40SEG	8	/* APM segment 0x40 */

#define	SELGDT	(0&lt;&lt;2)	/* selector is in gdt */
#define	SELLDT	(1&lt;&lt;2)	/* selector is in ldt */

#define	SELECTOR(i, t, p)	(((i)&lt;&lt;3) | (t) | (p))

#define	NULLSEL	SELECTOR(NULLSEG, SELGDT, 0)
#define	KDSEL	SELECTOR(KDSEG, SELGDT, 0)
#define	KESEL	SELECTOR(KESEG, SELGDT, 0)
#define	UESEL	SELECTOR(UESEG, SELGDT, 3)
#define	UDSEL	SELECTOR(UDSEG, SELGDT, 3)
#define	TSSSEL	SELECTOR(TSSSEG, SELGDT, 0)
#define	APMCSEL 	SELECTOR(APMCSEG, SELGDT, 0)
#define	APMCSEL16	SELECTOR(APMCSEG16, SELGDT, 0)
#define	APMDSEL		SELECTOR(APMDSEG, SELGDT, 0)
/* #define	APM40SEL	SELECTOR(APM40SEG, SELGDT, 0) */

/*
 *  fields in segment descriptors
 */
#define	SEGDATA	(0x10&lt;&lt;8)	/* data/stack segment */
#define	SEGEXEC	(0x18&lt;&lt;8)	/* executable segment */
#define	SEGTSS	(0x9&lt;&lt;8)	/* TSS segment */
#define	SEGCG	(0x0C&lt;&lt;8)	/* call gate */
#define	SEGIG	(0x0E&lt;&lt;8)	/* interrupt gate */
#define	SEGTG	(0x0F&lt;&lt;8)	/* trap gate */
#define	SEGTYPE	(0x1F&lt;&lt;8)

#define	SEGP	(1&lt;&lt;15)		/* segment present */
#define	SEGPL(x) ((x)&lt;&lt;13)	/* priority level */
#define	SEGB	(1&lt;&lt;22)		/* granularity 1==4k (for expand-down) */
#define	SEGG	(1&lt;&lt;23)		/* granularity 1==4k (for other) */
#define	SEGE	(1&lt;&lt;10)		/* expand down */
#define	SEGW	(1&lt;&lt;9)		/* writable (for data/stack) */
#define	SEGR	(1&lt;&lt;9)		/* readable (for code) */
#define	SEGD	(1&lt;&lt;22)		/* default 1==32bit (for code) */

/*
 *  virtual MMU
 */
#define	PTEMAPMEM	(1024*1024)	
#define	PTEPERTAB	(PTEMAPMEM/BY2PG)
#define	SEGMAPSIZE	1984
#define	SSEGMAPSIZE	16
#define	PPN(x)		((x)&amp;~(BY2PG-1))

/*
 *  physical MMU
 */
#define	PTEVALID	(1&lt;&lt;0)
#define	PTEWT		(1&lt;&lt;3)
#define	PTEUNCACHED	(1&lt;&lt;4)
#define	PTEWRITE	(1&lt;&lt;1)
#define	PTERONLY	(0&lt;&lt;1)
#define	PTEKERNEL	(0&lt;&lt;2)
#define	PTEUSER		(1&lt;&lt;2)
#define	PTESIZE		(1&lt;&lt;7)
#define	PTEGLOBAL	(1&lt;&lt;8)

/* CR0 */
#define PG	0x80000000

/*
 * Macros for calculating offsets within the page directory base
 * and page tables. 
 */
#define	PDX(va)		((((ulong)(va))&gt;&gt;22) &amp; 0x03FF)
#define	PTX(va)		((((ulong)(va))&gt;&gt;12) &amp; 0x03FF)

#define	getpgcolor(a)	0

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

