<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/pcboot/realmode.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/pcboot/realmode.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"ureg.h"
#include	"../port/error.h"

/*
 * Back the processor into real mode to run a BIOS call,
 * then return.  This must be used carefully, since it 
 * completely disables hardware interrupts (e.g., the i8259)
 * while running.  It is *not* using VM86 mode. 
 * Maybe that's really the right answer, but real mode
 * is fine for now.  We don't expect to use this very much --
 * just for BIOS INT 13 disk i/o.
 */

void realmode0(void);		/* in realmode0.s */
void realmodeintrinst(void);	/* in realmode0.s */
void realmodeend(void);		/* in realmode0.s */

extern ushort rmseg;		/* in realmode0.s */

static Ureg rmu;
static QLock rmlock;
static int beenhere;

void
realmode(Ureg *ureg)
{
	int s, sz;
	ulong cr3;
	uchar *ip;

	qlock(&amp;rmlock);
	if (!beenhere)
		iprint("into bios in real mode...");
	*(Ureg *)RMUADDR = *ureg;

	/*
	 * in pxe-loaded bootstraps, the l.s real-mode code is already
	 * below 64K, but for pbs-loaded bootstraps, we need to copy it there.
	 */
	ip = (void *)realmodeintrinst;		/* the INT instruction */
	ip[1] = ureg-&gt;trap;			/* insert INT number */
	coherence();
	if ((uintptr)KTZERO == KZERO+PXEBASE)	/* pxe-loaded? */
		rmseg = 0;			/* into JMPFAR instr. */
	else {
		/* copy l.s so that it can be run from 16-bit mode */
		sz = (char *)realmodeend - (char *)KTZERO;
		if (sz &gt; RMSIZE)
			panic("real mode code %d bytes &gt; %d", sz, RMSIZE);
		rmseg = (RMCODE - KZERO) &gt;&gt; 4;	/* into JMPFAR instr. */
		memmove((void*)RMCODE, (void*)KTZERO, sz);
	}
	coherence();

	s = splhi();
	m-&gt;pdb[PDX(0)] = m-&gt;pdb[PDX(KZERO)];	/* identity map low */
	cr3 = getcr3();
	putcr3(PADDR(m-&gt;pdb));
	if (arch)
		arch-&gt;introff();
	else
		i8259off();

	realmode0();
	splhi();				/* who knows what the bios did */

	if(m-&gt;tss){
		/*
		 * Called from memory.c before initialization of mmu.
		 * Don't turn interrupts on before the kernel is ready!
		 */
		if (arch)
			arch-&gt;intron();
		else
			i8259on();
	}
	m-&gt;pdb[PDX(0)] = 0;	/* remove low mapping */
	putcr3(cr3);
	splx(s);

	*ureg = *(Ureg *)RMUADDR;
	if (!beenhere) {
		beenhere = 1;
		iprint("and back\n");
	}
	qunlock(&amp;rmlock);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

