<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/allocb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/allocb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Block allocation */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

#define ALIGNUP(a)	ROUND((uintptr)(a), BLOCKALIGN)

enum
{
	Hdrspc		= 64,		/* leave room for high-level headers */
	Bdead		= 0x51494F42,	/* "QIOB" */
	Bmagic		= 0x0910b10c,
};

struct
{
	Lock;
	ulong	bytes;
} ialloc;

/*
 * convert the size of a desired buffer to the size needed
 * to include Block overhead and alignment.
 */
ulong
blocksize(ulong size)
{
	return ALIGNUP(sizeof(Block)) + Hdrspc + ALIGNUP(size);
}

/*
 * convert malloced or non-malloced buffer to a Block.
 * used to build custom Block allocators.
 *
 * buf must be at least blocksize(usable) bytes.
 */
Block *
mem2block(void *buf, ulong usable, int malloced)
{
	Block *b;

	if(buf == nil)
		return nil;

	b = (Block *)buf;
	b-&gt;next = nil;
	b-&gt;list = nil;
	b-&gt;free = 0;
	b-&gt;flag = 0;
	b-&gt;ref = 0;
	b-&gt;magic = Bmagic;
	_xinc(&amp;b-&gt;ref);

	/* align start of data portion by rounding up */
	b-&gt;base = (uchar*)ALIGNUP((ulong)b + sizeof(Block));

	/* align end of data portion by rounding down */
	b-&gt;lim = (uchar*)b + (malloced? msize(b): blocksize(usable));
	b-&gt;lim = (uchar*)((ulong)b-&gt;lim &amp; ~(BLOCKALIGN-1));

	/* leave sluff at beginning for added headers */
	b-&gt;wp = b-&gt;rp = b-&gt;lim - ALIGNUP(usable);
	if(b-&gt;rp &lt; b-&gt;base)
		panic("mem2block: b-&gt;rp &lt; b-&gt;base");
	if(b-&gt;lim &gt; (uchar*)b + (malloced? msize(b): blocksize(usable)))
		panic("mem2block: b-&gt;lim beyond Block end");
	return b;
}

static Block*
_allocb(int size)
{
	return mem2block(mallocz(blocksize(size), 0), size, 1);
}

Block*
allocb(int size)
{
	Block *b;

	/*
	 * Check in a process and wait until successful.
	 * Can still error out of here, though.
	 */
	if(up == nil)
		panic("allocb without up: %#p", getcallerpc(&amp;size));
	if((b = _allocb(size)) == nil){
		splhi();
		xsummary();
		mallocsummary();
		delay(500);
		panic("allocb: no memory for %d bytes; caller %#p", size,
			getcallerpc(&amp;size));
	}
	setmalloctag(b, getcallerpc(&amp;size));

	return b;
}

Block*
iallocb(int size)
{
	Block *b;
	static int m1, m2, mp;

	if(ialloc.bytes &gt; conf.ialloc){
		if((m1++%10000)==0){
			if(mp++ &gt; 1000){
				active.exiting = 1;
				exit(0);
			}
			iprint("iallocb: limited %lud/%lud\n",
				ialloc.bytes, conf.ialloc);
		}
		return nil;
	}

	if((b = _allocb(size)) == nil){
		if((m2++%10000)==0){
			if(mp++ &gt; 1000){
				active.exiting = 1;
				exit(0);
			}
			iprint("iallocb: no memory %lud/%lud\n",
				ialloc.bytes, conf.ialloc);
		}
		return nil;
	}
	setmalloctag(b, getcallerpc(&amp;size));
	b-&gt;flag = BINTR;

	ilock(&amp;ialloc);
	ialloc.bytes += b-&gt;lim - b-&gt;base;
	iunlock(&amp;ialloc);

	return b;
}

void
freeb(Block *b)
{
	void *dead = (void*)Bdead;
	long ref;

	if(b == nil)
		return;
	if(Bmagic &amp;&amp; b-&gt;magic != Bmagic)
		panic("freeb: bad magic %#lux in Block %#p; caller pc %#p",
			b-&gt;magic, b, getcallerpc(&amp;b));

	if((ref = _xdec(&amp;b-&gt;ref)) &gt; 0)
		return;
	if(ref &lt; 0){
		dumpstack();
		panic("freeb: ref %ld; caller pc %#p", ref, getcallerpc(&amp;b));
	}

	/*
	 * drivers which perform non cache coherent DMA manage their own buffer
	 * pool of uncached buffers and provide their own free routine.
	 */
	if(b-&gt;free) {
		b-&gt;free(b);
		return;
	}
	if(b-&gt;flag &amp; BINTR) {
		ilock(&amp;ialloc);
		ialloc.bytes -= b-&gt;lim - b-&gt;base;
		iunlock(&amp;ialloc);
	}

	/* poison the block in case someone is still holding onto it */
	b-&gt;next = dead;
	b-&gt;rp = dead;
	b-&gt;wp = dead;
	b-&gt;lim = dead;
	b-&gt;base = dead;
	b-&gt;magic = 0;

	free(b);
}

void
checkb(Block *b, char *msg)
{
	void *dead = (void*)Bdead;

	if(b == dead)
		panic("checkb b %s %#p", msg, b);
	if(b-&gt;base == dead || b-&gt;lim == dead || b-&gt;next == dead
	  || b-&gt;rp == dead || b-&gt;wp == dead){
		print("checkb: base %#p lim %#p next %#p\n",
			b-&gt;base, b-&gt;lim, b-&gt;next);
		print("checkb: rp %#p wp %#p\n", b-&gt;rp, b-&gt;wp);
		panic("checkb dead: %s", msg);
	}
	if(Bmagic &amp;&amp; b-&gt;magic != Bmagic)
		panic("checkb: bad magic %#lux in Block %#p", b-&gt;magic, b);
	if(b-&gt;base &gt; b-&gt;lim)
		panic("checkb 0 %s %#p %#p", msg, b-&gt;base, b-&gt;lim);
	if(b-&gt;rp &lt; b-&gt;base)
		panic("checkb 1 %s %#p %#p", msg, b-&gt;base, b-&gt;rp);
	if(b-&gt;wp &lt; b-&gt;base)
		panic("checkb 2 %s %#p %#p", msg, b-&gt;base, b-&gt;wp);
	if(b-&gt;rp &gt; b-&gt;lim)
		panic("checkb 3 %s %#p %#p", msg, b-&gt;rp, b-&gt;lim);
	if(b-&gt;wp &gt; b-&gt;lim)
		panic("checkb 4 %s %#p %#p", msg, b-&gt;wp, b-&gt;lim);
}

void
iallocsummary(void)
{
	print("ialloc %lud/%lud\n", ialloc.bytes, conf.ialloc);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

