<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

enum
{
	NHASH		= 128,
	MAXCACHE	= 1024*1024,
	NFILE		= 4096,
	NEXTENT		= 200,		/* extent allocation size */
};

typedef struct Extent Extent;
struct Extent
{
	int	bid;
	ulong	start;
	int	len;
	Page	*cache;
	Extent	*next;
};

typedef struct Mntcache Mntcache;
struct Mntcache
{
	Qid	qid;
	int	dev;
	int	type;
	QLock;
	Extent	 *list;
	Mntcache *hash;
	Mntcache *prev;
	Mntcache *next;
};

typedef struct Cache Cache;
struct Cache
{
	QLock;
	int		pgno;
	Mntcache	*head;
	Mntcache	*tail;
	Mntcache	*hash[NHASH];
};

typedef struct Ecache Ecache;
struct Ecache
{
	Lock;
	int	total;
	int	free;
	Extent*	head;
};

static Image fscache;
static Cache cache;
static Ecache ecache;
static int maxcache = MAXCACHE;

static void
extentfree(Extent* e)
{
	lock(&amp;ecache);
	e-&gt;next = ecache.head;
	ecache.head = e;
	ecache.free++;
	unlock(&amp;ecache);
}

static Extent*
extentalloc(void)
{
	Extent *e;
	int i;

	lock(&amp;ecache);
	if(ecache.head == nil){
		e = xalloc(NEXTENT*sizeof(Extent));
		if(e == nil){
			unlock(&amp;ecache);
			return nil;
		}
		for(i = 0; i &lt; NEXTENT; i++){
			e-&gt;next = ecache.head;
			ecache.head = e;
			e++;
		}
		ecache.free += NEXTENT;
		ecache.total += NEXTENT;
	}

	e = ecache.head;
	ecache.head = e-&gt;next;
	memset(e, 0, sizeof(Extent));
	ecache.free--;
	unlock(&amp;ecache);

	return e;
}

void
cinit(void)
{
	int i;
	Mntcache *m;

	cache.head = xalloc(sizeof(Mntcache)*NFILE);
	m = cache.head;
	if (m == nil)
		panic("cinit: no memory");

	/* a better algorithm would be nice */
	if(conf.npage*BY2PG &gt; 400*MB)
		maxcache = 20*MAXCACHE;
	else if(conf.npage*BY2PG &gt; 200*MB)
		maxcache = 10*MAXCACHE;

	for(i = 0; i &lt; NFILE-1; i++) {
		m-&gt;next = m+1;
		m-&gt;prev = m-1;
		m++;
	}

	cache.tail = m;
	cache.tail-&gt;next = 0;
	cache.head-&gt;prev = 0;

	fscache.notext = 1;
}

void
cprint(Chan *c, Mntcache *m, char *s)
{
	ulong o;
	int nb, ct;
	Extent *e;

	nb = 0;
	ct = 1;
	o = 0;
	if(m-&gt;list)
		o = m-&gt;list-&gt;start;
	for(e = m-&gt;list; e; e = e-&gt;next) {
		nb += e-&gt;len;
		if(o != e-&gt;start)
			ct = 0;
		o = e-&gt;start+e-&gt;len;
	}
	pprint("%s: %#llux.%#lux %d %d %s (%d %c)\n",
	s, m-&gt;qid.path, m-&gt;qid.vers, m-&gt;type, m-&gt;dev, c-&gt;path-&gt;s, nb, ct ? 'C' : 'N');

	for(e = m-&gt;list; e; e = e-&gt;next) {
		pprint("\t%4d %5lud %4d %#p\n",
			e-&gt;bid, e-&gt;start, e-&gt;len, e-&gt;cache);
	}
}

Page*
cpage(Extent *e)
{
	/* Easy consistency check */
	if(e-&gt;cache-&gt;daddr != e-&gt;bid)
		return 0;

	return lookpage(&amp;fscache, e-&gt;bid);
}

void
cnodata(Mntcache *m)
{
	Extent *e, *n;

	/*
	 * Invalidate all extent data
	 * Image lru will waste the pages
	 */
	for(e = m-&gt;list; e; e = n) {
		n = e-&gt;next;
		extentfree(e);
	}
	m-&gt;list = 0;
}

void
ctail(Mntcache *m)
{
	/* Unlink and send to the tail */
	if(m-&gt;prev)
		m-&gt;prev-&gt;next = m-&gt;next;
	else
		cache.head = m-&gt;next;
	if(m-&gt;next)
		m-&gt;next-&gt;prev = m-&gt;prev;
	else
		cache.tail = m-&gt;prev;

	if(cache.tail) {
		m-&gt;prev = cache.tail;
		cache.tail-&gt;next = m;
		m-&gt;next = 0;
		cache.tail = m;
	}
	else {
		cache.head = m;
		cache.tail = m;
		m-&gt;prev = 0;
		m-&gt;next = 0;
	}
}

void
copen(Chan *c)
{
	int h;
	Extent *e, *next;
	Mntcache *m, *f, **l;

	/* directories aren't cacheable and append-only files confuse us */
	if(c-&gt;qid.type&amp;(QTDIR|QTAPPEND))
		return;

	h = c-&gt;qid.path%NHASH;
	qlock(&amp;cache);
	for(m = cache.hash[h]; m; m = m-&gt;hash) {
		if(m-&gt;qid.path == c-&gt;qid.path)
		if(m-&gt;qid.type == c-&gt;qid.type)
		if(m-&gt;dev == c-&gt;dev &amp;&amp; m-&gt;type == c-&gt;type) {
			c-&gt;mcp = m;
			ctail(m);
			qunlock(&amp;cache);

			/* File was updated, invalidate cache */
			if(m-&gt;qid.vers != c-&gt;qid.vers) {
				m-&gt;qid.vers = c-&gt;qid.vers;
				qlock(m);
				cnodata(m);
				qunlock(m);
			}
			return;
		}
	}

	/* LRU the cache headers */
	m = cache.head;
	l = &amp;cache.hash[m-&gt;qid.path%NHASH];
	for(f = *l; f; f = f-&gt;hash) {
		if(f == m) {
			*l = m-&gt;hash;
			break;
		}
		l = &amp;f-&gt;hash;
	}

	m-&gt;qid = c-&gt;qid;
	m-&gt;dev = c-&gt;dev;
	m-&gt;type = c-&gt;type;

	l = &amp;cache.hash[h];
	m-&gt;hash = *l;
	*l = m;
	ctail(m);

	qlock(m);
	c-&gt;mcp = m;
	e = m-&gt;list;
	m-&gt;list = 0;
	qunlock(&amp;cache);

	while(e) {
		next = e-&gt;next;
		extentfree(e);
		e = next;
	}
	qunlock(m);
}

static int
cdev(Mntcache *m, Chan *c)
{
	if(m-&gt;qid.path != c-&gt;qid.path)
		return 0;
	if(m-&gt;qid.type != c-&gt;qid.type)
		return 0;
	if(m-&gt;dev != c-&gt;dev)
		return 0;
	if(m-&gt;type != c-&gt;type)
		return 0;
	if(m-&gt;qid.vers != c-&gt;qid.vers)
		return 0;
	return 1;
}

int
cread(Chan *c, uchar *buf, int len, vlong off)
{
	KMap *k;
	Page *p;
	Mntcache *m;
	Extent *e, **t;
	int o, l, total;
	ulong offset;

	if(off+len &gt; maxcache)
		return 0;

	m = c-&gt;mcp;
	if(m == 0)
		return 0;

	qlock(m);
	if(cdev(m, c) == 0) {
		qunlock(m);
		return 0;
	}

	offset = off;
	t = &amp;m-&gt;list;
	for(e = *t; e; e = e-&gt;next) {
		if(offset &gt;= e-&gt;start &amp;&amp; offset &lt; e-&gt;start+e-&gt;len)
			break;
		t = &amp;e-&gt;next;
	}

	if(e == 0) {
		qunlock(m);
		return 0;
	}

	total = 0;
	while(len) {
		p = cpage(e);
		if(p == 0) {
			*t = e-&gt;next;
			extentfree(e);
			qunlock(m);
			return total;
		}

		o = offset - e-&gt;start;
		l = len;
		if(l &gt; e-&gt;len-o)
			l = e-&gt;len-o;

		k = kmap(p);
		if(waserror()) {
			kunmap(k);
			putpage(p);
			qunlock(m);
			nexterror();
		}

		memmove(buf, (uchar*)VA(k) + o, l);

		poperror();
		kunmap(k);

		putpage(p);

		buf += l;
		len -= l;
		offset += l;
		total += l;
		t = &amp;e-&gt;next;
		e = e-&gt;next;
		if(e == 0 || e-&gt;start != offset)
			break;
	}

	qunlock(m);
	return total;
}

Extent*
cchain(uchar *buf, ulong offset, int len, Extent **tail)
{
	int l;
	Page *p;
	KMap *k;
	Extent *e, *start, **t;

	start = 0;
	*tail = 0;
	t = &amp;start;
	while(len) {
		e = extentalloc();
		if(e == 0)
			break;

		p = auxpage();
		if(p == 0) {
			extentfree(e);
			break;
		}
		l = len;
		if(l &gt; BY2PG)
			l = BY2PG;

		e-&gt;cache = p;
		e-&gt;start = offset;
		e-&gt;len = l;

		qlock(&amp;cache);
		e-&gt;bid = cache.pgno;
		cache.pgno += BY2PG;
		/* wrap the counter; low bits are unused by pghash but checked by lookpage */
		if((cache.pgno &amp; ~(BY2PG-1)) == 0){
			if(cache.pgno == BY2PG-1){
				print("cache wrapped\n");
				cache.pgno = 0;
			}else
				cache.pgno++;
		}
		qunlock(&amp;cache);

		p-&gt;daddr = e-&gt;bid;
		k = kmap(p);
		if(waserror()) {		/* buf may be virtual */
			kunmap(k);
			nexterror();
		}
		memmove((void*)VA(k), buf, l);
		poperror();
		kunmap(k);

		cachepage(p, &amp;fscache);
		putpage(p);

		buf += l;
		offset += l;
		len -= l;

		*t = e;
		*tail = e;
		t = &amp;e-&gt;next;
	}

	return start;
}

int
cpgmove(Extent *e, uchar *buf, int boff, int len)
{
	Page *p;
	KMap *k;

	p = cpage(e);
	if(p == 0)
		return 0;

	k = kmap(p);
	if(waserror()) {		/* Since buf may be virtual */
		kunmap(k);
		nexterror();
	}

	memmove((uchar*)VA(k)+boff, buf, len);

	poperror();
	kunmap(k);
	putpage(p);

	return 1;
}

void
cupdate(Chan *c, uchar *buf, int len, vlong off)
{
	Mntcache *m;
	Extent *tail;
	Extent *e, *f, *p;
	int o, ee, eblock;
	ulong offset;

	if(off &gt; maxcache || len == 0)
		return;

	m = c-&gt;mcp;
	if(m == 0)
		return;
	qlock(m);
	if(cdev(m, c) == 0) {
		qunlock(m);
		return;
	}

	/*
	 * Find the insertion point
	 */
	offset = off;
	p = 0;
	for(f = m-&gt;list; f; f = f-&gt;next) {
		if(f-&gt;start &gt; offset)
			break;
		p = f;
	}

	/* trim if there is a successor */
	eblock = offset+len;
	if(f != 0 &amp;&amp; eblock &gt; f-&gt;start) {
		len -= (eblock - f-&gt;start);
		if(len &lt;= 0) {
			qunlock(m);
			return;
		}
	}

	if(p == 0) {		/* at the head */
		e = cchain(buf, offset, len, &amp;tail);
		if(e != 0) {
			m-&gt;list = e;
			tail-&gt;next = f;
		}
		qunlock(m);
		return;
	}

	/* trim to the predecessor */
	ee = p-&gt;start+p-&gt;len;
	if(offset &lt; ee) {
		o = ee - offset;
		len -= o;
		if(len &lt;= 0) {
			qunlock(m);
			return;
		}
		buf += o;
		offset += o;
	}

	/* try and pack data into the predecessor */
	if(offset == ee &amp;&amp; p-&gt;len &lt; BY2PG) {
		o = len;
		if(o &gt; BY2PG - p-&gt;len)
			o = BY2PG - p-&gt;len;
		if(cpgmove(p, buf, p-&gt;len, o)) {
			p-&gt;len += o;
			buf += o;
			len -= o;
			offset += o;
			if(len &lt;= 0) {
if(f &amp;&amp; p-&gt;start + p-&gt;len &gt; f-&gt;start) print("CACHE: p-&gt;start=%uld p-&gt;len=%d f-&gt;start=%uld\n", p-&gt;start, p-&gt;len, f-&gt;start);
				qunlock(m);
				return;
			}
		}
	}

	e = cchain(buf, offset, len, &amp;tail);
	if(e != 0) {
		p-&gt;next = e;
		tail-&gt;next = f;
	}
	qunlock(m);
}

void
cwrite(Chan* c, uchar *buf, int len, vlong off)
{
	int o, eo;
	Mntcache *m;
	ulong eblock, ee;
	Extent *p, *f, *e, *tail;
	ulong offset;

	if(off &gt; maxcache || len == 0)
		return;

	m = c-&gt;mcp;
	if(m == 0)
		return;

	qlock(m);
	if(cdev(m, c) == 0) {
		qunlock(m);
		return;
	}

	offset = off;
	m-&gt;qid.vers++;
	c-&gt;qid.vers++;

	p = 0;
	for(f = m-&gt;list; f; f = f-&gt;next) {
		if(f-&gt;start &gt;= offset)
			break;
		p = f;
	}

	if(p != 0) {
		ee = p-&gt;start+p-&gt;len;
		eo = offset - p-&gt;start;
		/* pack in predecessor if there is space */
		if(offset &lt;= ee &amp;&amp; eo &lt; BY2PG) {
			o = len;
			if(o &gt; BY2PG - eo)
				o = BY2PG - eo;
			if(cpgmove(p, buf, eo, o)) {
				if(eo+o &gt; p-&gt;len)
					p-&gt;len = eo+o;
				buf += o;
				len -= o;
				offset += o;
			}
		}
	}

	/* free the overlap -- it's a rare case */
	eblock = offset+len;
	while(f &amp;&amp; f-&gt;start &lt; eblock) {
		e = f-&gt;next;
		extentfree(f);
		f = e;
	}

	/* link the block (if any) into the middle */
	e = cchain(buf, offset, len, &amp;tail);
	if(e != 0) {
		tail-&gt;next = f;
		f = e;
	}

	if(p == 0)
		m-&gt;list = f;
	else
		p-&gt;next = f;
	qunlock(m);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

