<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/cis.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/cis.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "io.h"

enum{
	Linktarget = 0x13,
};
	
/*
 *  read and crack the card information structure enough to set
 *  important parameters like power
 */
/* cis memory walking */
typedef struct Cisdat {
	uchar	*cisbase;
	int	cispos;
	int	cisskip;
	int	cislen;
} Cisdat;

static void	tcfig(PCMslot*, Cisdat*, int);
static void	tentry(PCMslot*, Cisdat*, int);
static void	tvers1(PCMslot*, Cisdat*, int);
static void	tlonglnkmfc(PCMslot*, Cisdat*, int);

static int
readc(Cisdat *cis, uchar *x)
{
	if(cis-&gt;cispos &gt;= cis-&gt;cislen)
		return 0;
	*x = cis-&gt;cisbase[cis-&gt;cisskip*cis-&gt;cispos];
	cis-&gt;cispos++;
	return 1;
}

static int
xcistuple(int slotno, int tuple, int subtuple, void *v, int nv, int attr)
{
	PCMmap *m;
	Cisdat cis;
	int i, l;
	uchar *p;
	uchar type, link, n, c;
	int this, subtype;

	m = pcmmap(slotno, 0, 0, attr);
	if(m == 0)
		return -1;

	cis.cisbase = KADDR(m-&gt;isa);
	cis.cispos = 0;
	cis.cisskip = attr ? 2 : 1;
	cis.cislen = m-&gt;len;

	/* loop through all the tuples */
	for(i = 0; i &lt; 1000; i++){
		this = cis.cispos;
		if(readc(&amp;cis, &amp;type) != 1)
			break;
		if(type == 0xFF)
			break;
		if(readc(&amp;cis, &amp;link) != 1)
			break;
		if(link == 0xFF)
			break;

		n = link;
		if(link &gt; 1 &amp;&amp; subtuple != -1){
			if(readc(&amp;cis, &amp;c) != 1)
				break;
			subtype = c;
			n--;
		}else
			subtype = -1;

		if(type == tuple &amp;&amp; subtype == subtuple){
			p = v;
			for(l=0; l&lt;nv &amp;&amp; l&lt;n; l++)
				if(readc(&amp;cis, p++) != 1)
					break;
			pcmunmap(slotno, m);
			return nv;
		}
		cis.cispos = this + (2+link);
	}
	pcmunmap(slotno, m);
	return -1;
}

int
pcmcistuple(int slotno, int tuple, int subtuple, void *v, int nv)
{
	int n;

	/* try attribute space, then memory */
	if((n = xcistuple(slotno, tuple, subtuple, v, nv, 1)) &gt;= 0)
		return n;
	return xcistuple(slotno, tuple, subtuple, v, nv, 0);
}

void
pcmcisread(PCMslot *pp)
{
	int this;
	Cisdat cis;
	PCMmap *m;
	uchar type, link;

	memset(pp-&gt;ctab, 0, sizeof(pp-&gt;ctab));
	pp-&gt;ncfg = 0;
	memset(pp-&gt;cfg, 0, sizeof(pp-&gt;cfg));
	pp-&gt;configed = 0;
	pp-&gt;nctab = 0;
	pp-&gt;verstr[0] = 0;

	/*
	 * Read all tuples in attribute space.
	 */
	m = pcmmap(pp-&gt;slotno, 0, 0, 1);
	if(m == 0)
		return;

	cis.cisbase = KADDR(m-&gt;isa);
	cis.cispos = 0;
	cis.cisskip = 2;
	cis.cislen = m-&gt;len;

	/* loop through all the tuples */
	for(;;){
		this = cis.cispos;
		if(readc(&amp;cis, &amp;type) != 1)
			break;
		if(type == 0xFF)
			break;
		if(readc(&amp;cis, &amp;link) != 1)
			break;

		switch(type){
		default:
			break;
		case 6:
			tlonglnkmfc(pp, &amp;cis, type);
			break;
		case 0x15:
			tvers1(pp, &amp;cis, type);
			break;
		case 0x1A:
			tcfig(pp, &amp;cis, type);
			break;
		case 0x1B:
			tentry(pp, &amp;cis, type);
			break;
		}

		if(link == 0xFF)
			break;
		cis.cispos = this + (2+link);
	}
	pcmunmap(pp-&gt;slotno, m);
}

static ulong
getlong(Cisdat *cis, int size)
{
	uchar c;
	int i;
	ulong x;

	x = 0;
	for(i = 0; i &lt; size; i++){
		if(readc(cis, &amp;c) != 1)
			break;
		x |= c&lt;&lt;(i*8);
	}
	return x;
}

static void
tcfig(PCMslot *pp, Cisdat *cis, int )
{
	uchar size, rasize, rmsize;
	uchar last;

	if(readc(cis, &amp;size) != 1)
		return;
	rasize = (size&amp;0x3) + 1;
	rmsize = ((size&gt;&gt;2)&amp;0xf) + 1;
	if(readc(cis, &amp;last) != 1)
		return;

	if(pp-&gt;ncfg &gt;= 8){
		print("tcfig: too many configuration registers\n");
		return;
	}
	
	pp-&gt;cfg[pp-&gt;ncfg].caddr = getlong(cis, rasize);
	pp-&gt;cfg[pp-&gt;ncfg].cpresent = getlong(cis, rmsize);
	pp-&gt;ncfg++;
}

static ulong vexp[8] =
{
	1, 10, 100, 1000, 10000, 100000, 1000000, 10000000
};
static ulong vmant[16] =
{
	10, 12, 13, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 70, 80, 90,
};

static ulong
microvolt(Cisdat *cis)
{
	uchar c;
	ulong microvolts;
	ulong exp;

	if(readc(cis, &amp;c) != 1)
		return 0;
	exp = vexp[c&amp;0x7];
	microvolts = vmant[(c&gt;&gt;3)&amp;0xf]*exp;
	while(c &amp; 0x80){
		if(readc(cis, &amp;c) != 1)
			return 0;
		switch(c){
		case 0x7d:
			break;		/* high impedence when sleeping */
		case 0x7e:
		case 0x7f:
			microvolts = 0;	/* no connection */
			break;
		default:
			exp /= 10;
			microvolts += exp*(c&amp;0x7f);
		}
	}
	return microvolts;
}

static ulong
nanoamps(Cisdat *cis)
{
	uchar c;
	ulong nanoamps;

	if(readc(cis, &amp;c) != 1)
		return 0;
	nanoamps = vexp[c&amp;0x7]*vmant[(c&gt;&gt;3)&amp;0xf];
	while(c &amp; 0x80){
		if(readc(cis, &amp;c) != 1)
			return 0;
		if(c == 0x7d || c == 0x7e || c == 0x7f)
			nanoamps = 0;
	}
	return nanoamps;
}

/*
 * only nominal voltage (feature 1) is important for config,
 * other features must read card to stay in sync.
 */
static ulong
power(Cisdat *cis)
{
	uchar feature;
	ulong mv;

	mv = 0;
	if(readc(cis, &amp;feature) != 1)
		return 0;
	if(feature &amp; 1)
		mv = microvolt(cis);
	if(feature &amp; 2)
		microvolt(cis);
	if(feature &amp; 4)
		microvolt(cis);
	if(feature &amp; 8)
		nanoamps(cis);
	if(feature &amp; 0x10)
		nanoamps(cis);
	if(feature &amp; 0x20)
		nanoamps(cis);
	if(feature &amp; 0x40)
		nanoamps(cis);
	return mv/1000000;
}

static ulong mantissa[16] =
{ 0, 10, 12, 13, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 70, 80, };

static ulong exponent[8] =
{ 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, };

static ulong
ttiming(Cisdat *cis, int scale)
{
	uchar unscaled;
	ulong nanosecs;

	if(readc(cis, &amp;unscaled) != 1)
		return 0;
	nanosecs = (mantissa[(unscaled&gt;&gt;3)&amp;0xf]*exponent[unscaled&amp;7])/10;
	nanosecs = nanosecs * vexp[scale];
	return nanosecs;
}

static void
timing(Cisdat *cis, PCMconftab *ct)
{
	uchar c, i;

	if(readc(cis, &amp;c) != 1)
		return;
	i = c&amp;0x3;
	if(i != 3)
		ct-&gt;maxwait = ttiming(cis, i);		/* max wait */
	i = (c&gt;&gt;2)&amp;0x7;
	if(i != 7)
		ct-&gt;readywait = ttiming(cis, i);		/* max ready/busy wait */
	i = (c&gt;&gt;5)&amp;0x7;
	if(i != 7)
		ct-&gt;otherwait = ttiming(cis, i);		/* reserved wait */
}

static void
iospaces(Cisdat *cis, PCMconftab *ct)
{
	uchar c;
	int i, nio;

	ct-&gt;nio = 0;
	if(readc(cis, &amp;c) != 1)
		return;

	ct-&gt;bit16 = ((c&gt;&gt;5)&amp;3) &gt;= 2;
	if(!(c &amp; 0x80)){
		ct-&gt;io[0].start = 0;
		ct-&gt;io[0].len = 1&lt;&lt;(c&amp;0x1f);
		ct-&gt;nio = 1;
		return;
	}

	if(readc(cis, &amp;c) != 1)
		return;

	/*
	 * For each of the range descriptions read the
	 * start address and the length (value is length-1).
	 */
	nio = (c&amp;0xf)+1;
	for(i = 0; i &lt; nio; i++){
		ct-&gt;io[i].start = getlong(cis, (c&gt;&gt;4)&amp;0x3);
		ct-&gt;io[i].len = getlong(cis, (c&gt;&gt;6)&amp;0x3)+1;
	}
	ct-&gt;nio = nio;
}

static void
irq(Cisdat *cis, PCMconftab *ct)
{
	uchar c;

	if(readc(cis, &amp;c) != 1)
		return;
	ct-&gt;irqtype = c &amp; 0xe0;
	if(c &amp; 0x10)
		ct-&gt;irqs = getlong(cis, 2);
	else
		ct-&gt;irqs = 1&lt;&lt;(c&amp;0xf);
	ct-&gt;irqs &amp;= 0xDEB8;		/* levels available to card */
}

static void
memspace(Cisdat *cis, int asize, int lsize, int host)
{
	ulong haddress, address, len;

	len = getlong(cis, lsize)*256;
	address = getlong(cis, asize)*256;
	USED(len, address);
	if(host){
		haddress = getlong(cis, asize)*256;
		USED(haddress);
	}
}

static void
tentry(PCMslot *pp, Cisdat *cis, int )
{
	uchar c, i, feature;
	PCMconftab *ct;

	if(pp-&gt;nctab &gt;= nelem(pp-&gt;ctab))
		return;
	if(readc(cis, &amp;c) != 1)
		return;
	ct = &amp;pp-&gt;ctab[pp-&gt;nctab++];

	/* copy from last default config */
	if(pp-&gt;def)
		*ct = *pp-&gt;def;

	ct-&gt;index = c &amp; 0x3f;

	/* is this the new default? */
	if(c &amp; 0x40)
		pp-&gt;def = ct;

	/* memory wait specified? */
	if(c &amp; 0x80){
		if(readc(cis, &amp;i) != 1)
			return;
		if(i&amp;0x80)
			ct-&gt;memwait = 1;
	}

	if(readc(cis, &amp;feature) != 1)
		return;
	switch(feature&amp;0x3){
	case 1:
		ct-&gt;vpp1 = ct-&gt;vpp2 = power(cis);
		break;
	case 2:
		power(cis);
		ct-&gt;vpp1 = ct-&gt;vpp2 = power(cis);
		break;
	case 3:
		power(cis);
		ct-&gt;vpp1 = power(cis);
		ct-&gt;vpp2 = power(cis);
		break;
	default:
		break;
	}
	if(feature&amp;0x4)
		timing(cis, ct);
	if(feature&amp;0x8)
		iospaces(cis, ct);
	if(feature&amp;0x10)
		irq(cis, ct);
	switch((feature&gt;&gt;5)&amp;0x3){
	case 1:
		memspace(cis, 0, 2, 0);
		break;
	case 2:
		memspace(cis, 2, 2, 0);
		break;
	case 3:
		if(readc(cis, &amp;c) != 1)
			return;
		for(i = 0; i &lt;= (c&amp;0x7); i++)
			memspace(cis, (c&gt;&gt;5)&amp;0x3, (c&gt;&gt;3)&amp;0x3, c&amp;0x80);
		break;
	}
	pp-&gt;configed++;
}

static void
tvers1(PCMslot *pp, Cisdat *cis, int )
{
	uchar c, major, minor, last;
	int  i;

	if(readc(cis, &amp;major) != 1)
		return;
	if(readc(cis, &amp;minor) != 1)
		return;
	last = 0;
	for(i = 0; i &lt; sizeof(pp-&gt;verstr)-1; i++){
		if(readc(cis, &amp;c) != 1)
			return;
		if(c == 0)
			c = ';';
		if(c == '\n')
			c = ';';
		if(c == 0xff)
			break;
		if(c == ';' &amp;&amp; last == ';')
			continue;
		pp-&gt;verstr[i] = c;
		last = c;
	}
	pp-&gt;verstr[i] = 0;
}

static void
tlonglnkmfc(PCMslot *pp, Cisdat *cis, int)
{
	int i, npos, opos;
	uchar nfn, space, expect, type, this, link;

	readc(cis, &amp;nfn);
	for(i = 0; i &lt; nfn; i++){
		readc(cis, &amp;space);
		npos        = getlong(cis, 4);
		opos        = cis-&gt;cispos;
		cis-&gt;cispos = npos;
		expect      = Linktarget;

		while(1){
			this = cis-&gt;cispos;
			if(readc(cis, &amp;type) != 1)
				break;
			if(type == 0xFF)
				break;
			if(readc(cis, &amp;link) != 1)
				break;

			if(expect &amp;&amp; expect != type){
				print("tlonglnkmfc: expected %X found %X\n",
					expect, type);
				break;
			}
			expect = 0;

			switch(type){
			default:
				break;
			case 0x15:
				tvers1(pp, cis, type);
				break;
			case 0x1A:
				tcfig(pp, cis, type);
				break;
			case 0x1B:
				tentry(pp, cis, type);
				break;
			}

			if(link == 0xFF)
				break;
			cis-&gt;cispos = this + (2+link);
		}
		cis-&gt;cispos = opos;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

