<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devenv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devenv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

enum
{
	Maxenvsize = 16300,
};

static Egrp	*envgrp(Chan *c);
static int	envwriteable(Chan *c);

static Egrp	confegrp;	/* global environment group containing the kernel configuration */

static Evalue*
envlookup(Egrp *eg, char *name, ulong qidpath)
{
	Evalue *e;
	int i;

	for(i=0; i&lt;eg-&gt;nent; i++){
		e = eg-&gt;ent[i];
		if(e-&gt;qid.path == qidpath || (name &amp;&amp; e-&gt;name[0]==name[0] &amp;&amp; strcmp(e-&gt;name, name) == 0))
			return e;
	}
	return nil;
}

static int
envgen(Chan *c, char *name, Dirtab*, int, int s, Dir *dp)
{
	Egrp *eg;
	Evalue *e;

	if(s == DEVDOTDOT){
		devdir(c, c-&gt;qid, "#e", 0, eve, DMDIR|0775, dp);
		return 1;
	}

	eg = envgrp(c);
	rlock(eg);
	e = 0;
	if(name)
		e = envlookup(eg, name, -1);
	else if(s &lt; eg-&gt;nent)
		e = eg-&gt;ent[s];

	if(e == 0) {
		runlock(eg);
		return -1;
	}

	/* make sure name string continues to exist after we release lock */
	kstrcpy(up-&gt;genbuf, e-&gt;name, sizeof up-&gt;genbuf);
	devdir(c, e-&gt;qid, up-&gt;genbuf, e-&gt;len, eve, 0666, dp);
	runlock(eg);
	return 1;
}

static Chan*
envattach(char *spec)
{
	Chan *c;
	Egrp *egrp = nil;

	if(spec &amp;&amp; *spec) {
		if(strcmp(spec, "c") == 0)
			egrp = &amp;confegrp;
		if(egrp == nil)
			error(Ebadarg);
	}

	c = devattach('e', spec);
	c-&gt;aux = egrp;
	return c;
}

static Walkqid*
envwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, envgen);
}

static int
envstat(Chan *c, uchar *db, int n)
{
	if(c-&gt;qid.type &amp; QTDIR)
		c-&gt;qid.vers = envgrp(c)-&gt;vers;
	return devstat(c, db, n, 0, 0, envgen);
}

static Chan*
envopen(Chan *c, int omode)
{
	Egrp *eg;
	Evalue *e;
	int trunc;

	eg = envgrp(c);
	if(c-&gt;qid.type &amp; QTDIR) {
		if(omode != OREAD)
			error(Eperm);
	}
	else {
		trunc = omode &amp; OTRUNC;
		if(omode != OREAD &amp;&amp; !envwriteable(c))
			error(Eperm);
		if(trunc)
			wlock(eg);
		else
			rlock(eg);
		e = envlookup(eg, nil, c-&gt;qid.path);
		if(e == 0) {
			if(trunc)
				wunlock(eg);
			else
				runlock(eg);
			error(Enonexist);
		}
		if(trunc &amp;&amp; e-&gt;value) {
			e-&gt;qid.vers++;
			free(e-&gt;value);
			e-&gt;value = 0;
			e-&gt;len = 0;
		}
		if(trunc)
			wunlock(eg);
		else
			runlock(eg);
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
envcreate(Chan *c, char *name, int omode, ulong)
{
	Egrp *eg;
	Evalue *e;
	Evalue **ent;

	if(c-&gt;qid.type != QTDIR)
		error(Eperm);
	if(strlen(name) &gt;= sizeof up-&gt;genbuf)
		error("name too long");			/* protect envgen */

	omode = openmode(omode);
	eg = envgrp(c);

	wlock(eg);
	if(waserror()) {
		wunlock(eg);
		nexterror();
	}

	if(envlookup(eg, name, -1))
		error(Eexist);

	e = smalloc(sizeof(Evalue));
	e-&gt;name = smalloc(strlen(name)+1);
	strcpy(e-&gt;name, name);

	if(eg-&gt;nent == eg-&gt;ment){
		eg-&gt;ment += 32;
		ent = smalloc(sizeof(eg-&gt;ent[0])*eg-&gt;ment);
		if(eg-&gt;nent)
			memmove(ent, eg-&gt;ent, sizeof(eg-&gt;ent[0])*eg-&gt;nent);
		free(eg-&gt;ent);
		eg-&gt;ent = ent;
	}
	e-&gt;qid.path = ++eg-&gt;path;
	e-&gt;qid.vers = 0;
	eg-&gt;vers++;
	eg-&gt;ent[eg-&gt;nent++] = e;
	c-&gt;qid = e-&gt;qid;

	wunlock(eg);
	poperror();

	c-&gt;offset = 0;
	c-&gt;mode = omode;
	c-&gt;flag |= COPEN;
}

static void
envremove(Chan *c)
{
	int i;
	Egrp *eg;
	Evalue *e;

	if(c-&gt;qid.type &amp; QTDIR)
		error(Eperm);

	eg = envgrp(c);
	wlock(eg);
	e = 0;
	for(i=0; i&lt;eg-&gt;nent; i++){
		if(eg-&gt;ent[i]-&gt;qid.path == c-&gt;qid.path){
			e = eg-&gt;ent[i];
			eg-&gt;nent--;
			eg-&gt;ent[i] = eg-&gt;ent[eg-&gt;nent];
			eg-&gt;vers++;
			break;
		}
	}
	wunlock(eg);
	if(e == 0)
		error(Enonexist);
	free(e-&gt;name);
	if(e-&gt;value)
		free(e-&gt;value);
	free(e);
}

static void
envclose(Chan *c)
{
	/*
	 * cclose can't fail, so errors from remove will be ignored.
	 * since permissions aren't checked,
	 * envremove can't not remove it if its there.
	 */
	if(c-&gt;flag &amp; CRCLOSE)
		envremove(c);
}

static long
envread(Chan *c, void *a, long n, vlong off)
{
	Egrp *eg;
	Evalue *e;
	ulong offset = off;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, 0, 0, envgen);

	eg = envgrp(c);
	rlock(eg);
	e = envlookup(eg, nil, c-&gt;qid.path);
	if(e == 0) {
		runlock(eg);
		error(Enonexist);
	}

	if(offset &gt; e-&gt;len)	/* protects against overflow converting vlong to ulong */
		n = 0;
	else if(offset + n &gt; e-&gt;len)
		n = e-&gt;len - offset;
	if(n &lt;= 0)
		n = 0;
	else
		memmove(a, e-&gt;value+offset, n);
	runlock(eg);
	return n;
}

static long
envwrite(Chan *c, void *a, long n, vlong off)
{
	char *s;
	ulong len;
	Egrp *eg;
	Evalue *e;
	ulong offset = off;

	if(n &lt;= 0)
		return 0;
	if(offset &gt; Maxenvsize || n &gt; (Maxenvsize - offset))
		error(Etoobig);

	eg = envgrp(c);
	wlock(eg);
	e = envlookup(eg, nil, c-&gt;qid.path);
	if(e == 0) {
		wunlock(eg);
		error(Enonexist);
	}

	len = offset+n;
	if(len &gt; e-&gt;len) {
		s = smalloc(len);
		if(e-&gt;value){
			memmove(s, e-&gt;value, e-&gt;len);
			free(e-&gt;value);
		}
		e-&gt;value = s;
		e-&gt;len = len;
	}
	memmove(e-&gt;value+offset, a, n);
	e-&gt;qid.vers++;
	eg-&gt;vers++;
	wunlock(eg);
	return n;
}

Dev envdevtab = {
	'e',
	"env",

	devreset,
	devinit,
	devshutdown,
	envattach,
	envwalk,
	envstat,
	envopen,
	envcreate,
	envclose,
	envread,
	devbread,
	envwrite,
	devbwrite,
	envremove,
	devwstat,
};

void
envcpy(Egrp *to, Egrp *from)
{
	int i;
	Evalue *ne, *e;

	rlock(from);
	to-&gt;ment = (from-&gt;nent+31)&amp;~31;
	to-&gt;ent = smalloc(to-&gt;ment*sizeof(to-&gt;ent[0]));
	for(i=0; i&lt;from-&gt;nent; i++){
		e = from-&gt;ent[i];
		ne = smalloc(sizeof(Evalue));
		ne-&gt;name = smalloc(strlen(e-&gt;name)+1);
		strcpy(ne-&gt;name, e-&gt;name);
		if(e-&gt;value){
			ne-&gt;value = smalloc(e-&gt;len);
			memmove(ne-&gt;value, e-&gt;value, e-&gt;len);
			ne-&gt;len = e-&gt;len;
		}
		ne-&gt;qid.path = ++to-&gt;path;
		to-&gt;ent[i] = ne;
	}
	to-&gt;nent = from-&gt;nent;
	runlock(from);
}

void
closeegrp(Egrp *eg)
{
	int i;
	Evalue *e;

	if(decref(eg) == 0){
		for(i=0; i&lt;eg-&gt;nent; i++){
			e = eg-&gt;ent[i];
			free(e-&gt;name);
			if(e-&gt;value)
				free(e-&gt;value);
			free(e);
		}
		free(eg-&gt;ent);
		free(eg);
	}
}

static Egrp*
envgrp(Chan *c)
{
	if(c-&gt;aux == nil)
		return up-&gt;egrp;
	return c-&gt;aux;
}

static int
envwriteable(Chan *c)
{
	return iseve() || c-&gt;aux == nil;
}

/*
 *  to let the kernel set environment variables
 */
void
ksetenv(char *ename, char *eval, int conf)
{
	Chan *c;
	char buf[2*KNAMELEN];
	
	snprint(buf, sizeof(buf), "#e%s/%s", conf?"c":"", ename);
	c = namec(buf, Acreate, OWRITE, 0600);
	devtab[c-&gt;type]-&gt;write(c, eval, strlen(eval), 0);
	cclose(c);
}

/*
 * Return a copy of configuration environment as a sequence of strings.
 * The strings alternate between name and value.  A zero length name string
 * indicates the end of the list
 */
char *
getconfenv(void)
{
	Egrp *eg = &amp;confegrp;
	Evalue *e;
	char *p, *q;
	int i, n;

	rlock(eg);
	if(waserror()) {
		runlock(eg);
		nexterror();
	}
	
	/* determine size */
	n = 0;
	for(i=0; i&lt;eg-&gt;nent; i++){
		e = eg-&gt;ent[i];
		n += strlen(e-&gt;name) + e-&gt;len + 2;
	}
	p = malloc(n + 1);
	if(p == nil)
		error(Enomem);
	q = p;
	for(i=0; i&lt;eg-&gt;nent; i++){
		e = eg-&gt;ent[i];
		strcpy(q, e-&gt;name);
		q += strlen(q) + 1;
		memmove(q, e-&gt;value, e-&gt;len);
		q[e-&gt;len] = 0;
		/* move up to the first null */
		q += strlen(q) + 1;
	}
	*q = 0;
	
	poperror();
	runlock(eg);
	return p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

