<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devproc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devproc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	&lt;trace.h&gt;
#include	"tos.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"ureg.h"
#include	"../port/edf.h"

enum
{
	Qdir,
	Qtrace,
	Qargs,
	Qctl,
	Qfd,
	Qfpregs,
	Qkregs,
	Qmem,
	Qnote,
	Qnoteid,
	Qnotepg,
	Qns,
	Qproc,
	Qregs,
	Qsegment,
	Qstatus,
	Qtext,
	Qwait,
	Qprofile,
	Qsyscall,
};

enum
{
	CMclose,
	CMclosefiles,
	CMfixedpri,
	CMhang,
	CMkill,
	CMnohang,
	CMnoswap,
	CMpri,
	CMprivate,
	CMprofile,
	CMstart,
	CMstartstop,
	CMstartsyscall,
	CMstop,
	CMwaitstop,
	CMwired,
	CMtrace,
	/* real time */
	CMperiod,
	CMdeadline,
	CMcost,
	CMsporadic,
	CMdeadlinenotes,
	CMadmit,
	CMextra,
	CMexpel,
	CMevent,
};

enum{
	Nevents = 0x4000,
	Emask = Nevents - 1,
};

#define	STATSIZE	(2*KNAMELEN+12+9*12)
/*
 * Status, fd, and ns are left fully readable (0444) because of their use in debugging,
 * particularly on shared servers.
 * Arguably, ns and fd shouldn't be readable; if you'd prefer, change them to 0000
 */
Dirtab procdir[] =
{
	"args",		{Qargs},	0,			0660,
	"ctl",		{Qctl},		0,			0000,
	"fd",		{Qfd},		0,			0444,
	"fpregs",	{Qfpregs},	sizeof(FPsave),		0000,
	"kregs",	{Qkregs},	sizeof(Ureg),		0400,
	"mem",		{Qmem},		0,			0000,
	"note",		{Qnote},	0,			0000,
	"noteid",	{Qnoteid},	0,			0664,
	"notepg",	{Qnotepg},	0,			0000,
	"ns",		{Qns},		0,			0444,
	"proc",		{Qproc},	0,			0400,
	"regs",		{Qregs},	sizeof(Ureg),		0000,
	"segment",	{Qsegment},	0,			0444,
	"status",	{Qstatus},	STATSIZE,		0444,
	"text",		{Qtext},	0,			0000,
	"wait",		{Qwait},	0,			0400,
	"profile",	{Qprofile},	0,			0400,
	"syscall",	{Qsyscall},	0,			0400,	
};

static
Cmdtab proccmd[] = {
	CMclose,		"close",		2,
	CMclosefiles,		"closefiles",		1,
	CMfixedpri,		"fixedpri",		2,
	CMhang,			"hang",			1,
	CMnohang,		"nohang",		1,
	CMnoswap,		"noswap",		1,
	CMkill,			"kill",			1,
	CMpri,			"pri",			2,
	CMprivate,		"private",		1,
	CMprofile,		"profile",		1,
	CMstart,		"start",		1,
	CMstartstop,		"startstop",		1,
	CMstartsyscall,		"startsyscall",		1,
	CMstop,			"stop",			1,
	CMwaitstop,		"waitstop",		1,
	CMwired,		"wired",		2,
	CMtrace,		"trace",		0,
	CMperiod,		"period",		2,
	CMdeadline,		"deadline",		2,
	CMcost,			"cost",			2,
	CMsporadic,		"sporadic",		1,
	CMdeadlinenotes,	"deadlinenotes",	1,
	CMadmit,		"admit",		1,
	CMextra,		"extra",		1,
	CMexpel,		"expel",		1,
	CMevent,		"event",		1,
};

/* Segment type from portdat.h */
static char *sname[]={ "Text", "Data", "Bss", "Stack", "Shared", "Phys", };

/*
 * Qids are, in path:
 *	 5 bits of file type (qids above)
 *	26 bits of process slot number + 1
 *	     in vers,
 *	32 bits of pid, for consistency checking
 * If notepg, c-&gt;pgrpid.path is pgrp slot, .vers is noteid.
 */
#define	QSHIFT	5	/* location in qid of proc slot # */

#define	QID(q)		((((ulong)(q).path) &amp; ((1&lt;&lt;QSHIFT)-1)) &gt;&gt; 0)
#define	SLOT(q)		(((((ulong)(q).path) &amp; ~(1UL&lt;&lt;31)) &gt;&gt; QSHIFT) - 1)
#define	PID(q)		((q).vers)
#define	NOTEID(q)	((q).vers)

void	procctlreq(Proc*, char*, int);
int	procctlmemio(Proc*, ulong, int, void*, int);
Chan*	proctext(Chan*, Proc*);
Segment* txt2data(Proc*, Segment*);
int	procstopped(void*);
void	mntscan(Mntwalk*, Proc*);

static Traceevent *tevents;
static Lock tlock;
static int topens;
static int tproduced, tconsumed;
void (*proctrace)(Proc*, int, vlong);

extern int unfair;

static void
profclock(Ureg *ur, Timer *)
{
	Tos *tos;

	if(up == 0 || up-&gt;state != Running)
		return;

	/* user profiling clock */
	if(userureg(ur)){
		tos = (Tos*)(USTKTOP-sizeof(Tos));
		tos-&gt;clock += TK2MS(1);
		segclock(ur-&gt;pc);
	}
}

static int
procgen(Chan *c, char *name, Dirtab *tab, int, int s, Dir *dp)
{
	Qid qid;
	Proc *p;
	char *ename;
	Segment *q;
	ulong pid, path, perm, len;

	if(s == DEVDOTDOT){
		mkqid(&amp;qid, Qdir, 0, QTDIR);
		devdir(c, qid, "#p", 0, eve, 0555, dp);
		return 1;
	}

	if(c-&gt;qid.path == Qdir){
		if(s == 0){
			strcpy(up-&gt;genbuf, "trace");
			mkqid(&amp;qid, Qtrace, -1, QTFILE);
			devdir(c, qid, up-&gt;genbuf, 0, eve, 0444, dp);
			return 1;
		}

		if(name != nil){
			/* ignore s and use name to find pid */
			pid = strtol(name, &amp;ename, 10);
			if(pid==0 || ename[0]!='\0')
				return -1;
			s = procindex(pid);
			if(s &lt; 0)
				return -1;
		}
		else if(--s &gt;= conf.nproc)
			return -1;

		p = proctab(s);
		pid = p-&gt;pid;
		if(pid == 0)
			return 0;
		snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "%lud", pid);
		/*
		 * String comparison is done in devwalk so name must match its formatted pid
		*/
		if(name != nil &amp;&amp; strcmp(name, up-&gt;genbuf) != 0)
			return -1;
		mkqid(&amp;qid, (s+1)&lt;&lt;QSHIFT, pid, QTDIR);
		devdir(c, qid, up-&gt;genbuf, 0, p-&gt;user, DMDIR|0555, dp);
		return 1;
	}
	if(c-&gt;qid.path == Qtrace){
		strcpy(up-&gt;genbuf, "trace");
		mkqid(&amp;qid, Qtrace, -1, QTFILE);
		devdir(c, qid, up-&gt;genbuf, 0, eve, 0444, dp);
		return 1;
	}
	if(s &gt;= nelem(procdir))
		return -1;
	if(tab)
		panic("procgen");

	tab = &amp;procdir[s];
	path = c-&gt;qid.path&amp;~(((1&lt;&lt;QSHIFT)-1));	/* slot component */

	/* p-&gt;procmode determines default mode for files in /proc */
	p = proctab(SLOT(c-&gt;qid));
	perm = tab-&gt;perm;
	if(perm == 0)
		perm = p-&gt;procmode;
	else	/* just copy read bits */
		perm |= p-&gt;procmode &amp; 0444;

	len = tab-&gt;length;
	switch(QID(c-&gt;qid)) {
	case Qwait:
		len = p-&gt;nwait;	/* incorrect size, but &gt;0 means there's something to read */
		break;
	case Qprofile:
		q = p-&gt;seg[TSEG];
		if(q &amp;&amp; q-&gt;profile) {
			len = (q-&gt;top-q-&gt;base)&gt;&gt;LRESPROF;
			len *= sizeof(*q-&gt;profile);
		}
		break;
	}

	mkqid(&amp;qid, path|tab-&gt;qid.path, c-&gt;qid.vers, QTFILE);
	devdir(c, qid, tab-&gt;name, len, p-&gt;user, perm, dp);
	return 1;
}

static void
_proctrace(Proc* p, Tevent etype, vlong ts)
{
	Traceevent *te;

	if (p-&gt;trace == 0 || topens == 0 ||
		tproduced - tconsumed &gt;= Nevents)
		return;

	te = &amp;tevents[tproduced&amp;Emask];
	te-&gt;pid = p-&gt;pid;
	te-&gt;etype = etype;
	if (ts == 0)
		te-&gt;time = todget(nil);
	else
		te-&gt;time = ts;
	tproduced++;
}

static void
procinit(void)
{
	if(conf.nproc &gt;= (1&lt;&lt;(31-QSHIFT))-1)
		print("warning: too many procs for devproc\n");
	addclock0link((void (*)(void))profclock, 113);	/* Relative prime to HZ */
}

static Chan*
procattach(char *spec)
{
	return devattach('p', spec);
}

static Walkqid*
procwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, procgen);
}

static int
procstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, 0, 0, procgen);
}

/*
 *  none can't read or write state on other
 *  processes.  This is to contain access of
 *  servers running as none should they be
 *  subverted by, for example, a stack attack.
 */
static void
nonone(Proc *p)
{
	if(p == up)
		return;
	if(strcmp(up-&gt;user, "none") != 0)
		return;
	if(iseve())
		return;
	error(Eperm);
}

static Chan*
procopen(Chan *c, int omode)
{
	Proc *p;
	Pgrp *pg;
	Chan *tc;
	int pid;

	if(c-&gt;qid.type &amp; QTDIR)
		return devopen(c, omode, 0, 0, procgen);

	if(QID(c-&gt;qid) == Qtrace){
		if (omode != OREAD) 
			error(Eperm);
		lock(&amp;tlock);
		if (waserror()){
			unlock(&amp;tlock);
			nexterror();
		}
		if (topens &gt; 0)
			error("already open");
		topens++;
		if (tevents == nil){
			tevents = (Traceevent*)malloc(sizeof(Traceevent) * Nevents);
			if(tevents == nil)
				error(Enomem);
			tproduced = tconsumed = 0;
		}
		proctrace = _proctrace;
		unlock(&amp;tlock);
		poperror();

		c-&gt;mode = openmode(omode);
		c-&gt;flag |= COPEN;
		c-&gt;offset = 0;
		return c;
	}
		
	p = proctab(SLOT(c-&gt;qid));
	qlock(&amp;p-&gt;debug);
	if(waserror()){
		qunlock(&amp;p-&gt;debug);
		nexterror();
	}
	pid = PID(c-&gt;qid);
	if(p-&gt;pid != pid)
		error(Eprocdied);

	omode = openmode(omode);

	switch(QID(c-&gt;qid)){
	case Qtext:
		if(omode != OREAD)
			error(Eperm);
		tc = proctext(c, p);
		tc-&gt;offset = 0;
		qunlock(&amp;p-&gt;debug);
		poperror();
		cclose(c);
		return tc;

	case Qproc:
	case Qkregs:
	case Qsegment:
	case Qprofile:
	case Qfd:
		if(omode != OREAD)
			error(Eperm);
		break;

	case Qnote:
		if(p-&gt;privatemem)
			error(Eperm);
		break;

	case Qmem:
	case Qctl:
		if(p-&gt;privatemem)
			error(Eperm);
		nonone(p);
		break;

	case Qargs:
	case Qnoteid:
	case Qstatus:
	case Qwait:
	case Qregs:
	case Qfpregs:
	case Qsyscall:	
		nonone(p);
		break;

	case Qns:
		if(omode != OREAD)
			error(Eperm);
		c-&gt;aux = malloc(sizeof(Mntwalk));
		break;

	case Qnotepg:
		nonone(p);
		pg = p-&gt;pgrp;
		if(pg == nil)
			error(Eprocdied);
		if(omode!=OWRITE || pg-&gt;pgrpid == 1)
			error(Eperm);
		c-&gt;pgrpid.path = pg-&gt;pgrpid+1;
		c-&gt;pgrpid.vers = p-&gt;noteid;
		break;

	default:
		pprint("procopen %#lux\n", QID(c-&gt;qid));
		error(Egreg);
	}

	/* Affix pid to qid */
	if(p-&gt;state != Dead)
		c-&gt;qid.vers = p-&gt;pid;

	/* make sure the process slot didn't get reallocated while we were playing */
	coherence();
	if(p-&gt;pid != pid)
		error(Eprocdied);

	tc = devopen(c, omode, 0, 0, procgen);
	qunlock(&amp;p-&gt;debug);
	poperror();

	return tc;
}

static int
procwstat(Chan *c, uchar *db, int n)
{
	Proc *p;
	Dir *d;

	if(c-&gt;qid.type&amp;QTDIR)
		error(Eperm);

	if(QID(c-&gt;qid) == Qtrace)
		return devwstat(c, db, n);
		
	p = proctab(SLOT(c-&gt;qid));
	nonone(p);
	d = nil;
	if(waserror()){
		free(d);
		qunlock(&amp;p-&gt;debug);
		nexterror();
	}
	qlock(&amp;p-&gt;debug);

	if(p-&gt;pid != PID(c-&gt;qid))
		error(Eprocdied);

	if(strcmp(up-&gt;user, p-&gt;user) != 0 &amp;&amp; strcmp(up-&gt;user, eve) != 0)
		error(Eperm);

	d = smalloc(sizeof(Dir)+n);
	n = convM2D(db, n, &amp;d[0], (char*)&amp;d[1]);
	if(n == 0)
		error(Eshortstat);
	if(!emptystr(d-&gt;uid) &amp;&amp; strcmp(d-&gt;uid, p-&gt;user) != 0){
		if(strcmp(up-&gt;user, eve) != 0)
			error(Eperm);
		else
			kstrdup(&amp;p-&gt;user, d-&gt;uid);
	}
	/* p-&gt;procmode determines default mode for files in /proc */
	if(d-&gt;mode != ~0UL)
		p-&gt;procmode = d-&gt;mode&amp;0777;

	poperror();
	free(d);
	qunlock(&amp;p-&gt;debug);
	return n;
}


static long
procoffset(long offset, char *va, int *np)
{
	if(offset &gt; 0) {
		offset -= *np;
		if(offset &lt; 0) {
			memmove(va, va+*np+offset, -offset);
			*np = -offset;
		}
		else
			*np = 0;
	}
	return offset;
}

static int
procqidwidth(Chan *c)
{
	char buf[32];

	return snprint(buf, sizeof buf, "%lud", c-&gt;qid.vers);
}

int
procfdprint(Chan *c, int fd, int w, char *s, int ns)
{
	int n;

	if(w == 0)
		w = procqidwidth(c);
	n = snprint(s, ns, "%3d %.2s %C %4ld (%.16llux %*lud %.2ux) %5ld %8lld %s\n",
		fd,
		&amp;"r w rw"[(c-&gt;mode&amp;3)&lt;&lt;1],
		devtab[c-&gt;type]-&gt;dc, c-&gt;dev,
		c-&gt;qid.path, w, c-&gt;qid.vers, c-&gt;qid.type,
		c-&gt;iounit, c-&gt;offset, c-&gt;path-&gt;s);
	return n;
}

static int
procfds(Proc *p, char *va, int count, long offset)
{
	Fgrp *f;
	Chan *c;
	char buf[256];
	int n, i, w, ww;
	char *a;

	/* print to buf to avoid holding fgrp lock while writing to user space */
	if(count &gt; sizeof buf)
		count = sizeof buf;
	a = buf;

	qlock(&amp;p-&gt;debug);
	f = p-&gt;fgrp;
	if(f == nil){
		qunlock(&amp;p-&gt;debug);
		return 0;
	}
	lock(f);
	if(waserror()){
		unlock(f);
		qunlock(&amp;p-&gt;debug);
		nexterror();
	}

	n = readstr(0, a, count, p-&gt;dot-&gt;path-&gt;s);
	n += snprint(a+n, count-n, "\n");
	offset = procoffset(offset, a, &amp;n);
	/* compute width of qid.path */
	w = 0;
	for(i = 0; i &lt;= f-&gt;maxfd; i++) {
		c = f-&gt;fd[i];
		if(c == nil)
			continue;
		ww = procqidwidth(c);
		if(ww &gt; w)
			w = ww;
	}
	for(i = 0; i &lt;= f-&gt;maxfd; i++) {
		c = f-&gt;fd[i];
		if(c == nil)
			continue;
		n += procfdprint(c, i, w, a+n, count-n);
		offset = procoffset(offset, a, &amp;n);
	}
	unlock(f);
	qunlock(&amp;p-&gt;debug);
	poperror();

	/* copy result to user space, now that locks are released */
	memmove(va, buf, n);

	return n;
}

static void
procclose(Chan * c)
{
	if(QID(c-&gt;qid) == Qtrace){
		lock(&amp;tlock);
		if(topens &gt; 0)
			topens--;
		if(topens == 0)
			proctrace = nil;
		unlock(&amp;tlock);
	}
	if(QID(c-&gt;qid) == Qns &amp;&amp; c-&gt;aux != 0)
		free(c-&gt;aux);
}

static void
int2flag(int flag, char *s)
{
	if(flag == 0){
		*s = '\0';
		return;
	}
	*s++ = '-';
	if(flag &amp; MAFTER)
		*s++ = 'a';
	if(flag &amp; MBEFORE)
		*s++ = 'b';
	if(flag &amp; MCREATE)
		*s++ = 'c';
	if(flag &amp; MCACHE)
		*s++ = 'C';
	*s = '\0';
}

static int
procargs(Proc *p, char *buf, int nbuf)
{
	int j, k, m;
	char *a;
	int n;

	a = p-&gt;args;
	if(p-&gt;setargs){
		snprint(buf, nbuf, "%s [%s]", p-&gt;text, p-&gt;args);
		return strlen(buf);
	}
	n = p-&gt;nargs;
	for(j = 0; j &lt; nbuf - 1; j += m){
		if(n &lt;= 0)
			break;
		if(j != 0)
			buf[j++] = ' ';
		m = snprint(buf+j, nbuf-j, "%q",  a);
		k = strlen(a) + 1;
		a += k;
		n -= k;
	}
	return j;
}

static int
eventsavailable(void *)
{
	return tproduced &gt; tconsumed;
}

static long
procread(Chan *c, void *va, long n, vlong off)
{
	/* NSEG*32 was too small for worst cases */
	char *a, flag[10], *sps, *srv, statbuf[NSEG*64];
	int i, j, m, navail, ne, pid, rsize;
	long l;
	uchar *rptr;
	ulong offset;
	Confmem *cm;
	Mntwalk *mw;
	Proc *p;
	Segment *sg, *s;
	Ureg kur;
	Waitq *wq;
	
	a = va;
	offset = off;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, 0, 0, procgen);

	if(QID(c-&gt;qid) == Qtrace){
		if(!eventsavailable(nil))
			return 0;

		rptr = (uchar*)va;
		navail = tproduced - tconsumed;
		if(navail &gt; n / sizeof(Traceevent))
			navail = n / sizeof(Traceevent);
		while(navail &gt; 0) {
			ne = ((tconsumed &amp; Emask) + navail &gt; Nevents)? 
					Nevents - (tconsumed &amp; Emask): navail;
			memmove(rptr, &amp;tevents[tconsumed &amp; Emask], 
					ne * sizeof(Traceevent));

			tconsumed += ne;
			rptr += ne * sizeof(Traceevent);
			navail -= ne;
		}
		return rptr - (uchar*)va;
	}

	p = proctab(SLOT(c-&gt;qid));
	if(p-&gt;pid != PID(c-&gt;qid))
		error(Eprocdied);

	switch(QID(c-&gt;qid)){
	case Qargs:
		qlock(&amp;p-&gt;debug);
		j = procargs(p, up-&gt;genbuf, sizeof up-&gt;genbuf);
		qunlock(&amp;p-&gt;debug);
		if(offset &gt;= j)
			return 0;
		if(offset+n &gt; j)
			n = j-offset;
		memmove(a, &amp;up-&gt;genbuf[offset], n);
		return n;
	case Qsyscall:
		if(!p-&gt;syscalltrace)
			return 0;
		n = readstr(offset, a, n, p-&gt;syscalltrace);
		return n;

	case Qmem:
		if(offset &lt; KZERO)
			return procctlmemio(p, offset, n, va, 1);

		if(!iseve())
			error(Eperm);

		/* validate kernel addresses */
		if(offset &lt; (ulong)end) {
			if(offset+n &gt; (ulong)end)
				n = (ulong)end - offset;
			memmove(a, (char*)offset, n);
			return n;
		}
		for(i=0; i&lt;nelem(conf.mem); i++){
			cm = &amp;conf.mem[i];
			/* klimit-1 because klimit might be zero! */
			if(cm-&gt;kbase &lt;= offset &amp;&amp; offset &lt;= cm-&gt;klimit-1){
				if(offset+n &gt;= cm-&gt;klimit-1)
					n = cm-&gt;klimit - offset;
				memmove(a, (char*)offset, n);
				return n;
			}
		}
		error(Ebadarg);

	case Qprofile:
		s = p-&gt;seg[TSEG];
		if(s == 0 || s-&gt;profile == 0)
			error("profile is off");
		i = (s-&gt;top-s-&gt;base)&gt;&gt;LRESPROF;
		i *= sizeof(*s-&gt;profile);
		if(offset &gt;= i)
			return 0;
		if(offset+n &gt; i)
			n = i - offset;
		memmove(a, ((char*)s-&gt;profile)+offset, n);
		return n;

	case Qnote:
		qlock(&amp;p-&gt;debug);
		if(waserror()){
			qunlock(&amp;p-&gt;debug);
			nexterror();
		}
		if(p-&gt;pid != PID(c-&gt;qid))
			error(Eprocdied);
		if(n &lt; 1)	/* must accept at least the '\0' */
			error(Etoosmall);
		if(p-&gt;nnote == 0)
			n = 0;
		else {
			m = strlen(p-&gt;note[0].msg) + 1;
			if(m &gt; n)
				m = n;
			memmove(va, p-&gt;note[0].msg, m);
			((char*)va)[m-1] = '\0';
			p-&gt;nnote--;
			memmove(p-&gt;note, p-&gt;note+1, p-&gt;nnote*sizeof(Note));
			n = m;
		}
		if(p-&gt;nnote == 0)
			p-&gt;notepending = 0;
		poperror();
		qunlock(&amp;p-&gt;debug);
		return n;

	case Qproc:
		if(offset &gt;= sizeof(Proc))
			return 0;
		if(offset+n &gt; sizeof(Proc))
			n = sizeof(Proc) - offset;
		memmove(a, ((char*)p)+offset, n);
		return n;

	case Qregs:
		rptr = (uchar*)p-&gt;dbgreg;
		rsize = sizeof(Ureg);
		goto regread;

	case Qkregs:
		memset(&amp;kur, 0, sizeof(Ureg));
		setkernur(&amp;kur, p);
		rptr = (uchar*)&amp;kur;
		rsize = sizeof(Ureg);
		goto regread;

	case Qfpregs:
		rptr = (uchar*)&amp;p-&gt;fpsave;
		rsize = sizeof(FPsave);
	regread:
		if(rptr == 0)
			error(Enoreg);
		if(offset &gt;= rsize)
			return 0;
		if(offset+n &gt; rsize)
			n = rsize - offset;
		memmove(a, rptr+offset, n);
		return n;

	case Qstatus:
		if(offset &gt;= STATSIZE)
			return 0;
		if(offset+n &gt; STATSIZE)
			n = STATSIZE - offset;

		sps = p-&gt;psstate;
		if(sps == 0)
			sps = statename[p-&gt;state];
		memset(statbuf, ' ', sizeof statbuf);
		readstr(0, statbuf+0*KNAMELEN, KNAMELEN-1, p-&gt;text);
		readstr(0, statbuf+1*KNAMELEN, KNAMELEN-1, p-&gt;user);
		readstr(0, statbuf+2*KNAMELEN, 11, sps);
		j = 2*KNAMELEN + 12;

		for(i = 0; i &lt; 6; i++) {
			l = p-&gt;time[i];
			if(i == TReal)
				l = MACHP(0)-&gt;ticks - l;
			l = TK2MS(l);
			readnum(0, statbuf+j+NUMSIZE*i, NUMSIZE, l, NUMSIZE);
		}
		/* ignore stack, which is mostly non-existent */
		l = 0;
		for(i=1; i&lt;NSEG; i++){
			s = p-&gt;seg[i];
			if(s)
				l += s-&gt;top - s-&gt;base;
		}
		readnum(0, statbuf+j+NUMSIZE*6, NUMSIZE, l&gt;&gt;10, NUMSIZE);
		readnum(0, statbuf+j+NUMSIZE*7, NUMSIZE, p-&gt;basepri, NUMSIZE);
		readnum(0, statbuf+j+NUMSIZE*8, NUMSIZE, p-&gt;priority, NUMSIZE);
		memmove(a, statbuf+offset, n);
		return n;

	case Qsegment:
		j = 0;
		for(i = 0; i &lt; NSEG; i++) {
			sg = p-&gt;seg[i];
			if(sg == 0)
				continue;
			j += snprint(statbuf+j, sizeof statbuf - j,
				"%-6s %c%c %.8lux %.8lux %4ld\n",
				sname[sg-&gt;type&amp;SG_TYPE],
				sg-&gt;type&amp;SG_RONLY ? 'R' : ' ',
				sg-&gt;profile ? 'P' : ' ',
				sg-&gt;base, sg-&gt;top, sg-&gt;ref);
		}
		if(offset &gt;= j)
			return 0;
		if(offset+n &gt; j)
			n = j-offset;
		if(n == 0 &amp;&amp; offset == 0)
			exhausted("segments");
		memmove(a, &amp;statbuf[offset], n);
		return n;

	case Qwait:
		if(!canqlock(&amp;p-&gt;qwaitr))
			error(Einuse);

		if(waserror()) {
			qunlock(&amp;p-&gt;qwaitr);
			nexterror();
		}

		lock(&amp;p-&gt;exl);
		if(up == p &amp;&amp; p-&gt;nchild == 0 &amp;&amp; p-&gt;waitq == 0) {
			unlock(&amp;p-&gt;exl);
			error(Enochild);
		}
		pid = p-&gt;pid;
		while(p-&gt;waitq == 0) {
			unlock(&amp;p-&gt;exl);
			sleep(&amp;p-&gt;waitr, haswaitq, p);
			if(p-&gt;pid != pid)
				error(Eprocdied);
			lock(&amp;p-&gt;exl);
		}
		wq = p-&gt;waitq;
		p-&gt;waitq = wq-&gt;next;
		p-&gt;nwait--;
		unlock(&amp;p-&gt;exl);

		qunlock(&amp;p-&gt;qwaitr);
		poperror();
		n = snprint(a, n, "%d %lud %lud %lud %q",
			wq-&gt;w.pid,
			wq-&gt;w.time[TUser], wq-&gt;w.time[TSys], wq-&gt;w.time[TReal],
			wq-&gt;w.msg);
		free(wq);
		return n;

	case Qns:
		qlock(&amp;p-&gt;debug);
		if(waserror()){
			qunlock(&amp;p-&gt;debug);
			nexterror();
		}
		if(p-&gt;pgrp == nil || p-&gt;pid != PID(c-&gt;qid))
			error(Eprocdied);
		mw = c-&gt;aux;
		if(mw == nil)
			error(Enomem);
		if(mw-&gt;cddone){
			qunlock(&amp;p-&gt;debug);
			poperror();
			return 0;
		}
		mntscan(mw, p);
		if(mw-&gt;mh == 0){
			mw-&gt;cddone = 1;
			i = snprint(a, n, "cd %s\n", p-&gt;dot-&gt;path-&gt;s);
			qunlock(&amp;p-&gt;debug);
			poperror();
			return i;
		}
		int2flag(mw-&gt;cm-&gt;mflag, flag);
		if(strcmp(mw-&gt;cm-&gt;to-&gt;path-&gt;s, "#M") == 0){
			srv = srvname(mw-&gt;cm-&gt;to-&gt;mchan);
			i = snprint(a, n, "mount %s %s %s %s\n", flag,
				srv==nil? mw-&gt;cm-&gt;to-&gt;mchan-&gt;path-&gt;s : srv,
				mw-&gt;mh-&gt;from-&gt;path-&gt;s, mw-&gt;cm-&gt;spec? mw-&gt;cm-&gt;spec : "");
			free(srv);
		}else
			i = snprint(a, n, "bind %s %s %s\n", flag,
				mw-&gt;cm-&gt;to-&gt;path-&gt;s, mw-&gt;mh-&gt;from-&gt;path-&gt;s);
		qunlock(&amp;p-&gt;debug);
		poperror();
		return i;

	case Qnoteid:
		return readnum(offset, va, n, p-&gt;noteid, NUMSIZE);
	case Qfd:
		return procfds(p, va, n, offset);
	}
	error(Egreg);
	return 0;		/* not reached */
}

void
mntscan(Mntwalk *mw, Proc *p)
{
	Pgrp *pg;
	Mount *t;
	Mhead *f;
	int nxt, i;
	ulong last, bestmid;

	pg = p-&gt;pgrp;
	rlock(&amp;pg-&gt;ns);

	nxt = 0;
	bestmid = ~0;

	last = 0;
	if(mw-&gt;mh)
		last = mw-&gt;cm-&gt;mountid;

	for(i = 0; i &lt; MNTHASH; i++) {
		for(f = pg-&gt;mnthash[i]; f; f = f-&gt;hash) {
			for(t = f-&gt;mount; t; t = t-&gt;next) {
				if(mw-&gt;mh == 0 ||
				  (t-&gt;mountid &gt; last &amp;&amp; t-&gt;mountid &lt; bestmid)) {
					mw-&gt;cm = t;
					mw-&gt;mh = f;
					bestmid = mw-&gt;cm-&gt;mountid;
					nxt = 1;
				}
			}
		}
	}
	if(nxt == 0)
		mw-&gt;mh = 0;

	runlock(&amp;pg-&gt;ns);
}

static long
procwrite(Chan *c, void *va, long n, vlong off)
{
	int id, m;
	Proc *p, *t, *et;
	char *a, *arg, buf[ERRMAX];
	ulong offset = off;

	a = va;
	if(c-&gt;qid.type &amp; QTDIR)
		error(Eisdir);

	p = proctab(SLOT(c-&gt;qid));

	/* Use the remembered noteid in the channel rather
	 * than the process pgrpid
	 */
	if(QID(c-&gt;qid) == Qnotepg) {
		pgrpnote(NOTEID(c-&gt;pgrpid), va, n, NUser);
		return n;
	}

	qlock(&amp;p-&gt;debug);
	if(waserror()){
		qunlock(&amp;p-&gt;debug);
		nexterror();
	}
	if(p-&gt;pid != PID(c-&gt;qid))
		error(Eprocdied);

	switch(QID(c-&gt;qid)){
	case Qargs:
		if(n == 0)
			error(Eshort);
		if(n &gt;= ERRMAX)
			error(Etoobig);
		arg = malloc(n+1);
		if(arg == nil)
			error(Enomem);
		memmove(arg, va, n);
		m = n;
		if(arg[m-1] != 0)
			arg[m++] = 0;
		free(p-&gt;args);
		p-&gt;nargs = m;
		p-&gt;args = arg;
		p-&gt;setargs = 1;
		break;

	case Qmem:
		if(p-&gt;state != Stopped)
			error(Ebadctl);

		n = procctlmemio(p, offset, n, va, 0);
		break;

	case Qregs:
		if(offset &gt;= sizeof(Ureg))
			n = 0;
		else if(offset+n &gt; sizeof(Ureg))
			n = sizeof(Ureg) - offset;
		if(p-&gt;dbgreg == 0)
			error(Enoreg);
		setregisters(p-&gt;dbgreg, (char*)(p-&gt;dbgreg)+offset, va, n);
		break;

	case Qfpregs:
		if(offset &gt;= sizeof(FPsave))
			n = 0;
		else if(offset+n &gt; sizeof(FPsave))
			n = sizeof(FPsave) - offset;
		memmove((uchar*)&amp;p-&gt;fpsave+offset, va, n);
		break;

	case Qctl:
		procctlreq(p, va, n);
		break;

	case Qnote:
		if(p-&gt;kp)
			error(Eperm);
		if(n &gt;= ERRMAX-1)
			error(Etoobig);
		memmove(buf, va, n);
		buf[n] = 0;
		if(!postnote(p, 0, buf, NUser))
			error("note not posted");
		break;
	case Qnoteid:
		id = atoi(a);
		if(id == p-&gt;pid) {
			p-&gt;noteid = id;
			break;
		}
		t = proctab(0);
		for(et = t+conf.nproc; t &lt; et; t++) {
			if(t-&gt;state == Dead)
				continue;
			if(id == t-&gt;noteid) {
				if(strcmp(p-&gt;user, t-&gt;user) != 0)
					error(Eperm);
				p-&gt;noteid = id;
				break;
			}
		}
		if(p-&gt;noteid != id)
			error(Ebadarg);
		break;
	default:
		pprint("unknown qid in procwrite\n");
		error(Egreg);
	}
	poperror();
	qunlock(&amp;p-&gt;debug);
	return n;
}

Dev procdevtab = {
	'p',
	"proc",

	devreset,
	procinit,
	devshutdown,
	procattach,
	procwalk,
	procstat,
	procopen,
	devcreate,
	procclose,
	procread,
	devbread,
	procwrite,
	devbwrite,
	devremove,
	procwstat,
};

Chan*
proctext(Chan *c, Proc *p)
{
	Chan *tc;
	Image *i;
	Segment *s;

	s = p-&gt;seg[TSEG];
	if(s == 0)
		error(Enonexist);
	if(p-&gt;state==Dead)
		error(Eprocdied);

	lock(s);
	i = s-&gt;image;
	if(i == 0) {
		unlock(s);
		error(Eprocdied);
	}
	unlock(s);

	lock(i);
	if(waserror()) {
		unlock(i);
		nexterror();
	}

	tc = i-&gt;c;
	if(tc == 0)
		error(Eprocdied);

	if(incref(tc) == 1 || (tc-&gt;flag&amp;COPEN) == 0 || tc-&gt;mode!=OREAD) {
		cclose(tc);
		error(Eprocdied);
	}

	if(p-&gt;pid != PID(c-&gt;qid)){
		cclose(tc);
		error(Eprocdied);
	}

	unlock(i);
	poperror();

	return tc;
}

void
procstopwait(Proc *p, int ctl)
{
	int pid;

	if(p-&gt;pdbg)
		error(Einuse);
	if(procstopped(p) || p-&gt;state == Broken)
		return;

	if(ctl != 0)
		p-&gt;procctl = ctl;
	p-&gt;pdbg = up;
	pid = p-&gt;pid;
	qunlock(&amp;p-&gt;debug);
	up-&gt;psstate = "Stopwait";
	if(waserror()) {
		p-&gt;pdbg = 0;
		qlock(&amp;p-&gt;debug);
		nexterror();
	}
	sleep(&amp;up-&gt;sleep, procstopped, p);
	poperror();
	qlock(&amp;p-&gt;debug);
	if(p-&gt;pid != pid)
		error(Eprocdied);
}

static void
procctlcloseone(Proc *p, Fgrp *f, int fd)
{
	Chan *c;

	c = f-&gt;fd[fd];
	if(c == nil)
		return;
	f-&gt;fd[fd] = nil;
	unlock(f);
	qunlock(&amp;p-&gt;debug);
	cclose(c);
	qlock(&amp;p-&gt;debug);
	lock(f);
}

void
procctlclosefiles(Proc *p, int all, int fd)
{
	int i;
	Fgrp *f;

	f = p-&gt;fgrp;
	if(f == nil)
		error(Eprocdied);

	lock(f);
	f-&gt;ref++;
	if(all)
		for(i = 0; i &lt; f-&gt;maxfd; i++)
			procctlcloseone(p, f, i);
	else
		procctlcloseone(p, f, fd);
	unlock(f);
	closefgrp(f);
}

static char *
parsetime(vlong *rt, char *s)
{
	uvlong ticks;
	ulong l;
	char *e, *p;
	static int p10[] = {100000000, 10000000, 1000000, 100000, 10000, 1000, 100, 10, 1};

	if (s == nil)
		return("missing value");
	ticks=strtoul(s, &amp;e, 10);
	if (*e == '.'){
		p = e+1;
		l = strtoul(p, &amp;e, 10);
		if(e-p &gt; nelem(p10))
			return "too many digits after decimal point";
		if(e-p == 0)
			return "ill-formed number";
		l *= p10[e-p-1];
	}else
		l = 0;
	if (*e == '\0' || strcmp(e, "s") == 0){
		ticks = 1000000000 * ticks + l;
	}else if (strcmp(e, "ms") == 0){
		ticks = 1000000 * ticks + l/1000;
	}else if (strcmp(e, "µs") == 0 || strcmp(e, "us") == 0){
		ticks = 1000 * ticks + l/1000000;
	}else if (strcmp(e, "ns") != 0)
		return "unrecognized unit";
	*rt = ticks;
	return nil;
}

void
procctlreq(Proc *p, char *va, int n)
{
	Segment *s;
	int npc, pri;
	Cmdbuf *cb;
	Cmdtab *ct;
	vlong time;
	char *e;
	void (*pt)(Proc*, int, vlong);

	if(p-&gt;kp)	/* no ctl requests to kprocs */
		error(Eperm);

	cb = parsecmd(va, n);
	if(waserror()){
		free(cb);
		nexterror();
	}

	ct = lookupcmd(cb, proccmd, nelem(proccmd));

	switch(ct-&gt;index){
	case CMclose:
		procctlclosefiles(p, 0, atoi(cb-&gt;f[1]));
		break;
	case CMclosefiles:
		procctlclosefiles(p, 1, 0);
		break;
	case CMhang:
		p-&gt;hang = 1;
		break;
	case CMkill:
		switch(p-&gt;state) {
		case Broken:
			unbreak(p);
			break;
		case Stopped:
			p-&gt;procctl = Proc_exitme;
			postnote(p, 0, "sys: killed", NExit);
			ready(p);
			break;
		default:
			p-&gt;procctl = Proc_exitme;
			postnote(p, 0, "sys: killed", NExit);
		}
		break;
	case CMnohang:
		p-&gt;hang = 0;
		break;
	case CMnoswap:
		p-&gt;noswap = 1;
		break;
	case CMpri:
		pri = atoi(cb-&gt;f[1]);
		if(pri &gt; PriNormal &amp;&amp; !iseve())
			error(Eperm);
		procpriority(p, pri, 0);
		break;
	case CMfixedpri:
		pri = atoi(cb-&gt;f[1]);
		if(pri &gt; PriNormal &amp;&amp; !iseve())
			error(Eperm);
		procpriority(p, pri, 1);
		break;
	case CMprivate:
		p-&gt;privatemem = 1;
		break;
	case CMprofile:
		s = p-&gt;seg[TSEG];
		if(s == 0 || (s-&gt;type&amp;SG_TYPE) != SG_TEXT)
			error(Ebadctl);
		if(s-&gt;profile != 0)
			free(s-&gt;profile);
		npc = (s-&gt;top-s-&gt;base)&gt;&gt;LRESPROF;
		s-&gt;profile = malloc(npc*sizeof(*s-&gt;profile));
		if(s-&gt;profile == 0)
			error(Enomem);
		break;
	case CMstart:
		if(p-&gt;state != Stopped)
			error(Ebadctl);
		ready(p);
		break;
	case CMstartstop:
		if(p-&gt;state != Stopped)
			error(Ebadctl);
		p-&gt;procctl = Proc_traceme;
		ready(p);
		procstopwait(p, Proc_traceme);
		break;
	case CMstartsyscall:
		if(p-&gt;state != Stopped)
			error(Ebadctl);
		p-&gt;procctl = Proc_tracesyscall;
		ready(p);
		procstopwait(p, Proc_tracesyscall);
		break;
	case CMstop:
		procstopwait(p, Proc_stopme);
		break;
	case CMwaitstop:
		procstopwait(p, 0);
		break;
	case CMwired:
		procwired(p, atoi(cb-&gt;f[1]));
		break;
	case CMtrace:
		switch(cb-&gt;nf){
		case 1:
			p-&gt;trace ^= 1;
			break;
		case 2:
			p-&gt;trace = (atoi(cb-&gt;f[1]) != 0);
			break;
		default:
			error("args");
		}
		break;
	/* real time */
	case CMperiod:
		if(p-&gt;edf == nil)
			edfinit(p);
		if(e=parsetime(&amp;time, cb-&gt;f[1]))	/* time in ns */
			error(e);
		edfstop(p);
		p-&gt;edf-&gt;T = time/1000;	/* Edf times are in µs */
		break;
	case CMdeadline:
		if(p-&gt;edf == nil)
			edfinit(p);
		if(e=parsetime(&amp;time, cb-&gt;f[1]))
			error(e);
		edfstop(p);
		p-&gt;edf-&gt;D = time/1000;
		break;
	case CMcost:
		if(p-&gt;edf == nil)
			edfinit(p);
		if(e=parsetime(&amp;time, cb-&gt;f[1]))
			error(e);
		edfstop(p);
		p-&gt;edf-&gt;C = time/1000;
		break;
	case CMsporadic:
		if(p-&gt;edf == nil)
			edfinit(p);
		p-&gt;edf-&gt;flags |= Sporadic;
		break;
	case CMdeadlinenotes:
		if(p-&gt;edf == nil)
			edfinit(p);
		p-&gt;edf-&gt;flags |= Sendnotes;
		break;
	case CMadmit:
		if(p-&gt;edf == 0)
			error("edf params");
		if(e = edfadmit(p))
			error(e);
		break;
	case CMextra:
		if(p-&gt;edf == nil)
			edfinit(p);
		p-&gt;edf-&gt;flags |= Extratime;
		break;
	case CMexpel:
		if(p-&gt;edf)
			edfstop(p);
		break;
	case CMevent:
		pt = proctrace;
		if(up-&gt;trace &amp;&amp; pt)
			pt(up, SUser, 0);
		break;
	}

	poperror();
	free(cb);
}

int
procstopped(void *a)
{
	Proc *p = a;
	return p-&gt;state == Stopped;
}

int
procctlmemio(Proc *p, ulong offset, int n, void *va, int read)
{
	KMap *k;
	Pte *pte;
	Page *pg;
	Segment *s;
	ulong soff, l;
	char *a = va, *b;

	for(;;) {
		s = seg(p, offset, 1);
		if(s == 0)
			error(Ebadarg);

		if(offset+n &gt;= s-&gt;top)
			n = s-&gt;top-offset;

		if(!read &amp;&amp; (s-&gt;type&amp;SG_TYPE) == SG_TEXT)
			s = txt2data(p, s);

		s-&gt;steal++;
		soff = offset-s-&gt;base;
		if(waserror()) {
			s-&gt;steal--;
			nexterror();
		}
		if(fixfault(s, offset, read, 0) == 0)
			break;
		poperror();
		s-&gt;steal--;
	}
	poperror();
	pte = s-&gt;map[soff/PTEMAPMEM];
	if(pte == 0)
		panic("procctlmemio");
	pg = pte-&gt;pages[(soff&amp;(PTEMAPMEM-1))/BY2PG];
	if(pagedout(pg))
		panic("procctlmemio1");

	l = BY2PG - (offset&amp;(BY2PG-1));
	if(n &gt; l)
		n = l;

	k = kmap(pg);
	if(waserror()) {
		s-&gt;steal--;
		kunmap(k);
		nexterror();
	}
	b = (char*)VA(k);
	b += offset&amp;(BY2PG-1);
	if(read == 1)
		memmove(a, b, n);	/* This can fault */
	else
		memmove(b, a, n);
	kunmap(k);
	poperror();

	/* Ensure the process sees text page changes */
	if(s-&gt;flushme)
		memset(pg-&gt;cachectl, PG_TXTFLUSH, sizeof(pg-&gt;cachectl));

	s-&gt;steal--;

	if(read == 0)
		p-&gt;newtlb = 1;

	return n;
}

Segment*
txt2data(Proc *p, Segment *s)
{
	int i;
	Segment *ps;

	ps = newseg(SG_DATA, s-&gt;base, s-&gt;size);
	ps-&gt;image = s-&gt;image;
	incref(ps-&gt;image);
	ps-&gt;fstart = s-&gt;fstart;
	ps-&gt;flen = s-&gt;flen;
	ps-&gt;flushme = 1;

	qlock(&amp;p-&gt;seglock);
	for(i = 0; i &lt; NSEG; i++)
		if(p-&gt;seg[i] == s)
			break;
	if(i == NSEG)
		panic("segment gone");

	qunlock(&amp;s-&gt;lk);
	putseg(s);
	qlock(&amp;ps-&gt;lk);
	p-&gt;seg[i] = ps;
	qunlock(&amp;p-&gt;seglock);

	return ps;
}

Segment*
data2txt(Segment *s)
{
	Segment *ps;

	ps = newseg(SG_TEXT, s-&gt;base, s-&gt;size);
	ps-&gt;image = s-&gt;image;
	incref(ps-&gt;image);
	ps-&gt;fstart = s-&gt;fstart;
	ps-&gt;flen = s-&gt;flen;
	ps-&gt;flushme = 1;

	return ps;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

