<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devsd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devsd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Storage Device.
 */
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

#include "../port/sd.h"

extern Dev sddevtab;
extern SDifc* sdifc[];

static char devletters[] = "0123456789"
	"abcdefghijklmnopqrstuvwxyz"
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ";

static SDev *devs[sizeof devletters-1];
static QLock devslock;

enum {
	Rawcmd,
	Rawdata,
	Rawstatus,
};

enum {
	Qtopdir		= 1,		/* top level directory */
	Qtopbase,
	Qtopctl		 = Qtopbase,

	Qunitdir,			/* directory per unit */
	Qunitbase,
	Qctl		= Qunitbase,
	Qraw,
	Qpart,

	TypeLOG		= 4,
	NType		= (1&lt;&lt;TypeLOG),
	TypeMASK	= (NType-1),
	TypeSHIFT	= 0,

	PartLOG		= 8,
	NPart		= (1&lt;&lt;PartLOG),
	PartMASK	= (NPart-1),
	PartSHIFT	= TypeLOG,

	UnitLOG		= 8,
	NUnit		= (1&lt;&lt;UnitLOG),
	UnitMASK	= (NUnit-1),
	UnitSHIFT	= (PartLOG+TypeLOG),

	DevLOG		= 8,
	NDev		= (1 &lt;&lt; DevLOG),
	DevMASK		= (NDev-1),
	DevSHIFT	 = (UnitLOG+PartLOG+TypeLOG),

	Ncmd = 20,
};

#define TYPE(q)		((((ulong)(q).path)&gt;&gt;TypeSHIFT) &amp; TypeMASK)
#define PART(q)		((((ulong)(q).path)&gt;&gt;PartSHIFT) &amp; PartMASK)
#define UNIT(q)		((((ulong)(q).path)&gt;&gt;UnitSHIFT) &amp; UnitMASK)
#define DEV(q)		((((ulong)(q).path)&gt;&gt;DevSHIFT) &amp; DevMASK)
#define QID(d,u, p, t)	(((d)&lt;&lt;DevSHIFT)|((u)&lt;&lt;UnitSHIFT)|\
					 ((p)&lt;&lt;PartSHIFT)|((t)&lt;&lt;TypeSHIFT))


void
sdaddpart(SDunit* unit, char* name, uvlong start, uvlong end)
{
	SDpart *pp;
	int i, partno;

	/*
	 * Check name not already used
	 * and look for a free slot.
	 */
	if(unit-&gt;part != nil){
		partno = -1;
		for(i = 0; i &lt; unit-&gt;npart; i++){
			pp = &amp;unit-&gt;part[i];
			if(!pp-&gt;valid){
				if(partno == -1)
					partno = i;
				break;
			}
			if(strcmp(name, pp-&gt;name) == 0){
				if(pp-&gt;start == start &amp;&amp; pp-&gt;end == end)
					return;
				error(Ebadctl);
			}
		}
	}
	else{
		if((unit-&gt;part = malloc(sizeof(SDpart)*SDnpart)) == nil)
			error(Enomem);
		unit-&gt;npart = SDnpart;
		partno = 0;
	}

	/*
	 * If no free slot found then increase the
	 * array size (can't get here with unit-&gt;part == nil).
	 */
	if(partno == -1){
		if(unit-&gt;npart &gt;= NPart)
			error(Enomem);
		if((pp = malloc(sizeof(SDpart)*(unit-&gt;npart+SDnpart))) == nil)
			error(Enomem);
		memmove(pp, unit-&gt;part, sizeof(SDpart)*unit-&gt;npart);
		free(unit-&gt;part);
		unit-&gt;part = pp;
		partno = unit-&gt;npart;
		unit-&gt;npart += SDnpart;
	}

	/*
	 * Check size and extent are valid.
	 */
	if(start &gt; end || end &gt; unit-&gt;sectors)
		error(Eio);
	pp = &amp;unit-&gt;part[partno];
	pp-&gt;start = start;
	pp-&gt;end = end;
	kstrdup(&amp;pp-&gt;name, name);
	kstrdup(&amp;pp-&gt;user, eve);
	pp-&gt;perm = 0640;
	pp-&gt;valid = 1;
}

static void
sddelpart(SDunit* unit, char* name)
{
	int i;
	SDpart *pp;

	/*
	 * Look for the partition to delete.
	 * Can't delete if someone still has it open.
	 */
	pp = unit-&gt;part;
	for(i = 0; i &lt; unit-&gt;npart; i++){
		if(strcmp(name, pp-&gt;name) == 0)
			break;
		pp++;
	}
	if(i &gt;= unit-&gt;npart)
		error(Ebadctl);
	if(strcmp(up-&gt;user, pp-&gt;user) &amp;&amp; !iseve())
		error(Eperm);
	pp-&gt;valid = 0;
	pp-&gt;vers++;
}

static void
sdincvers(SDunit *unit)
{
	int i;

	unit-&gt;vers++;
	if(unit-&gt;part){
		for(i = 0; i &lt; unit-&gt;npart; i++){
			unit-&gt;part[i].valid = 0;
			unit-&gt;part[i].vers++;
		}
	}
}

static int
sdinitpart(SDunit* unit)
{
	int nf;
	uvlong start, end;
	char *f[4], *p, *q, buf[10];

	if(unit-&gt;sectors &gt; 0){
		unit-&gt;sectors = unit-&gt;secsize = 0;
		sdincvers(unit);
	}

	/* device must be connected or not; other values are trouble */
	if(unit-&gt;inquiry[0] &amp; 0xC0)	/* see SDinq0periphqual */
		return 0;
	switch(unit-&gt;inquiry[0] &amp; SDinq0periphtype){
	case SDperdisk:
	case SDperworm:
	case SDpercd:
	case SDpermo:
		break;
	default:
		return 0;
	}

	if(unit-&gt;dev-&gt;ifc-&gt;online)
		unit-&gt;dev-&gt;ifc-&gt;online(unit);
	if(unit-&gt;sectors){
		sdincvers(unit);
		sdaddpart(unit, "data", 0, unit-&gt;sectors);

		/*
		 * Use partitions passed from boot program,
		 * e.g.
		 *	sdC0part=dos 63 123123/plan9 123123 456456
		 * This happens before /boot sets hostname so the
		 * partitions will have the null-string for user.
		 * The gen functions patch it up.
		 */
		snprint(buf, sizeof buf, "%spart", unit-&gt;name);
		for(p = getconf(buf); p != nil; p = q){
			if(q = strchr(p, '/'))
				*q++ = '\0';
			nf = tokenize(p, f, nelem(f));
			if(nf &lt; 3)
				continue;

			start = strtoull(f[1], 0, 0);
			end = strtoull(f[2], 0, 0);
			if(!waserror()){
				sdaddpart(unit, f[0], start, end);
				poperror();
			}
		}
	}

	return 1;
}

static int
sdindex(int idno)
{
	char *p;

	p = strchr(devletters, idno);
	if(p == nil)
		return -1;
	return p-devletters;
}

static SDev*
sdgetdev(int idno)
{
	SDev *sdev;
	int i;

	if((i = sdindex(idno)) &lt; 0)
		return nil;

	qlock(&amp;devslock);
	if(sdev = devs[i])
		incref(&amp;sdev-&gt;r);
	qunlock(&amp;devslock);
	return sdev;
}

static SDunit*
sdgetunit(SDev* sdev, int subno)
{
	SDunit *unit;
	char buf[32];

	/*
	 * Associate a unit with a given device and sub-unit
	 * number on that device.
	 * The device will be probed if it has not already been
	 * successfully accessed.
	 */
	qlock(&amp;sdev-&gt;unitlock);
	if(subno &gt; sdev-&gt;nunit){
		qunlock(&amp;sdev-&gt;unitlock);
		return nil;
	}

	unit = sdev-&gt;unit[subno];
	if(unit == nil){
		/*
		 * Probe the unit only once. This decision
		 * may be a little severe and reviewed later.
		 */
		if(sdev-&gt;unitflg[subno]){
			qunlock(&amp;sdev-&gt;unitlock);
			return nil;
		}
		if((unit = malloc(sizeof(SDunit))) == nil){
			qunlock(&amp;sdev-&gt;unitlock);
			return nil;
		}
		sdev-&gt;unitflg[subno] = 1;

		snprint(buf, sizeof(buf), "%s%d", sdev-&gt;name, subno);
		kstrdup(&amp;unit-&gt;name, buf);
		kstrdup(&amp;unit-&gt;user, eve);
		unit-&gt;perm = 0555;
		unit-&gt;subno = subno;
		unit-&gt;dev = sdev;

		if(sdev-&gt;enabled == 0 &amp;&amp; sdev-&gt;ifc-&gt;enable)
			sdev-&gt;ifc-&gt;enable(sdev);
		sdev-&gt;enabled = 1;

		/*
		 * No need to lock anything here as this is only
		 * called before the unit is made available in the
		 * sdunit[] array.
		 */
		if(unit-&gt;dev-&gt;ifc-&gt;verify(unit) == 0){
			qunlock(&amp;sdev-&gt;unitlock);
			free(unit);
			return nil;
		}
		sdev-&gt;unit[subno] = unit;
	}
	qunlock(&amp;sdev-&gt;unitlock);
	return unit;
}

static void
sdreset(void)
{
	int i;
	SDev *sdev;

	/*
	 * Probe all known controller types and register any devices found.
	 */
	for(i = 0; sdifc[i] != nil; i++){
		if(sdifc[i]-&gt;pnp == nil || (sdev = sdifc[i]-&gt;pnp()) == nil)
			continue;
		sdadddevs(sdev);
	}
}

void
sdadddevs(SDev *sdev)
{
	int i, j, id;
	SDev *next;

	for(; sdev; sdev=next){
		next = sdev-&gt;next;

		sdev-&gt;unit = (SDunit**)malloc(sdev-&gt;nunit * sizeof(SDunit*));
		sdev-&gt;unitflg = (int*)malloc(sdev-&gt;nunit * sizeof(int));
		if(sdev-&gt;unit == nil || sdev-&gt;unitflg == nil){
			print("sdadddevs: out of memory\n");
		giveup:
			free(sdev-&gt;unit);
			free(sdev-&gt;unitflg);
			if(sdev-&gt;ifc-&gt;clear)
				sdev-&gt;ifc-&gt;clear(sdev);
			free(sdev);
			continue;
		}
		id = sdindex(sdev-&gt;idno);
		if(id == -1){
			print("sdadddevs: bad id number %d (%C)\n", id, id);
			goto giveup;
		}
		qlock(&amp;devslock);
		for(i=0; i&lt;nelem(devs); i++){
			if(devs[j = (id+i)%nelem(devs)] == nil){
				sdev-&gt;idno = devletters[j];
				devs[j] = sdev;
				snprint(sdev-&gt;name, sizeof sdev-&gt;name, "sd%c", devletters[j]);
				break;
			}
		}
		qunlock(&amp;devslock);
		if(i == nelem(devs)){
			print("sdadddevs: out of device letters\n");
			goto giveup;
		}
	}
}

// void
// sdrmdevs(SDev *sdev)
// {
// 	char buf[2];
//
// 	snprint(buf, sizeof buf, "%c", sdev-&gt;idno);
// 	unconfigure(buf);
// }

void
sdaddallconfs(void (*addconf)(SDunit *))
{
	int i, u;
	SDev *sdev;

	for(i = 0; i &lt; nelem(devs); i++)		/* each controller */
		for(sdev = devs[i]; sdev; sdev = sdev-&gt;next)
			for(u = 0; u &lt; sdev-&gt;nunit; u++)	/* each drive */
				(*addconf)(sdev-&gt;unit[u]);
}

static int
sd2gen(Chan* c, int i, Dir* dp)
{
	Qid q;
	uvlong l;
	SDpart *pp;
	SDperm *perm;
	SDunit *unit;
	SDev *sdev;
	int rv;

	sdev = sdgetdev(DEV(c-&gt;qid));
	assert(sdev);
	unit = sdev-&gt;unit[UNIT(c-&gt;qid)];

	rv = -1;
	switch(i){
	case Qctl:
		mkqid(&amp;q, QID(DEV(c-&gt;qid), UNIT(c-&gt;qid), PART(c-&gt;qid), Qctl),
			unit-&gt;vers, QTFILE);
		perm = &amp;unit-&gt;ctlperm;
		if(emptystr(perm-&gt;user)){
			kstrdup(&amp;perm-&gt;user, eve);
			perm-&gt;perm = 0644;	/* nothing secret in ctl */
		}
		devdir(c, q, "ctl", 0, perm-&gt;user, perm-&gt;perm, dp);
		rv = 1;
		break;

	case Qraw:
		mkqid(&amp;q, QID(DEV(c-&gt;qid), UNIT(c-&gt;qid), PART(c-&gt;qid), Qraw),
			unit-&gt;vers, QTFILE);
		perm = &amp;unit-&gt;rawperm;
		if(emptystr(perm-&gt;user)){
			kstrdup(&amp;perm-&gt;user, eve);
			perm-&gt;perm = DMEXCL|0600;
		}
		devdir(c, q, "raw", 0, perm-&gt;user, perm-&gt;perm, dp);
		rv = 1;
		break;

	case Qpart:
		pp = &amp;unit-&gt;part[PART(c-&gt;qid)];
		l = (pp-&gt;end - pp-&gt;start) * unit-&gt;secsize;
		mkqid(&amp;q, QID(DEV(c-&gt;qid), UNIT(c-&gt;qid), PART(c-&gt;qid), Qpart),
			unit-&gt;vers+pp-&gt;vers, QTFILE);
		if(emptystr(pp-&gt;user))
			kstrdup(&amp;pp-&gt;user, eve);
		devdir(c, q, pp-&gt;name, l, pp-&gt;user, pp-&gt;perm, dp);
		rv = 1;
		break;
	}

	decref(&amp;sdev-&gt;r);
	return rv;
}

static int
sd1gen(Chan* c, int i, Dir* dp)
{
	Qid q;

	switch(i){
	case Qtopctl:
		mkqid(&amp;q, QID(0, 0, 0, Qtopctl), 0, QTFILE);
		devdir(c, q, "sdctl", 0, eve, 0644, dp);	/* no secrets */
		return 1;
	}
	return -1;
}

static int
sdgen(Chan* c, char*, Dirtab*, int, int s, Dir* dp)
{
	Qid q;
	uvlong l;
	int i, r;
	SDpart *pp;
	SDunit *unit;
	SDev *sdev;

	switch(TYPE(c-&gt;qid)){
	case Qtopdir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(0, 0, 0, Qtopdir), 0, QTDIR);
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "#%C",
				sddevtab.dc);
			devdir(c, q, up-&gt;genbuf, 0, eve, 0555, dp);
			return 1;
		}

		if(s+Qtopbase &lt; Qunitdir)
			return sd1gen(c, s+Qtopbase, dp);
		s -= (Qunitdir-Qtopbase);

		qlock(&amp;devslock);
		for(i=0; i&lt;nelem(devs); i++){
			if(devs[i]){
				if(s &lt; devs[i]-&gt;nunit)
					break;
				s -= devs[i]-&gt;nunit;
			}
		}

		if(i == nelem(devs)){
			/* Run off the end of the list */
			qunlock(&amp;devslock);
			return -1;
		}

		if((sdev = devs[i]) == nil){
			qunlock(&amp;devslock);
			return 0;
		}

		incref(&amp;sdev-&gt;r);
		qunlock(&amp;devslock);

		if((unit = sdev-&gt;unit[s]) == nil)
			if((unit = sdgetunit(sdev, s)) == nil){
				decref(&amp;sdev-&gt;r);
				return 0;
			}

		mkqid(&amp;q, QID(sdev-&gt;idno, s, 0, Qunitdir), 0, QTDIR);
		if(emptystr(unit-&gt;user))
			kstrdup(&amp;unit-&gt;user, eve);
		devdir(c, q, unit-&gt;name, 0, unit-&gt;user, unit-&gt;perm, dp);
		decref(&amp;sdev-&gt;r);
		return 1;

	case Qunitdir:
		if(s == DEVDOTDOT){
			mkqid(&amp;q, QID(0, 0, 0, Qtopdir), 0, QTDIR);
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "#%C",
				sddevtab.dc);
			devdir(c, q, up-&gt;genbuf, 0, eve, 0555, dp);
			return 1;
		}

		if((sdev = sdgetdev(DEV(c-&gt;qid))) == nil){
			devdir(c, c-&gt;qid, "unavailable", 0, eve, 0, dp);
			return 1;
		}

		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
		qlock(&amp;unit-&gt;ctl);

		/*
		 * Check for media change.
		 * If one has already been detected, sectors will be zero.
		 * If there is one waiting to be detected, online
		 * will return &gt; 1.
		 * Online is a bit of a large hammer but does the job.
		 */
		if(unit-&gt;sectors == 0
		|| (unit-&gt;dev-&gt;ifc-&gt;online &amp;&amp; unit-&gt;dev-&gt;ifc-&gt;online(unit) &gt; 1))
			sdinitpart(unit);

		i = s+Qunitbase;
		if(i &lt; Qpart){
			r = sd2gen(c, i, dp);
			qunlock(&amp;unit-&gt;ctl);
			decref(&amp;sdev-&gt;r);
			return r;
		}
		i -= Qpart;
		if(unit-&gt;part == nil || i &gt;= unit-&gt;npart){
			qunlock(&amp;unit-&gt;ctl);
			decref(&amp;sdev-&gt;r);
			break;
		}
		pp = &amp;unit-&gt;part[i];
		if(!pp-&gt;valid){
			qunlock(&amp;unit-&gt;ctl);
			decref(&amp;sdev-&gt;r);
			return 0;
		}
		l = (pp-&gt;end - pp-&gt;start) * unit-&gt;secsize;
		mkqid(&amp;q, QID(DEV(c-&gt;qid), UNIT(c-&gt;qid), i, Qpart),
			unit-&gt;vers+pp-&gt;vers, QTFILE);
		if(emptystr(pp-&gt;user))
			kstrdup(&amp;pp-&gt;user, eve);
		devdir(c, q, pp-&gt;name, l, pp-&gt;user, pp-&gt;perm, dp);
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		return 1;
	case Qraw:
	case Qctl:
	case Qpart:
		if((sdev = sdgetdev(DEV(c-&gt;qid))) == nil){
			devdir(c, q, "unavailable", 0, eve, 0, dp);
			return 1;
		}
		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
		qlock(&amp;unit-&gt;ctl);
		r = sd2gen(c, TYPE(c-&gt;qid), dp);
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		return r;
	case Qtopctl:
		return sd1gen(c, TYPE(c-&gt;qid), dp);
	default:
		break;
	}

	return -1;
}

static Chan*
sdattach(char* spec)
{
	Chan *c;
	char *p;
	SDev *sdev;
	int idno, subno;

	if(*spec == '\0'){
		c = devattach(sddevtab.dc, spec);
		mkqid(&amp;c-&gt;qid, QID(0, 0, 0, Qtopdir), 0, QTDIR);
		return c;
	}

	if(spec[0] != 's' || spec[1] != 'd')
		error(Ebadspec);
	idno = spec[2];
	subno = strtol(&amp;spec[3], &amp;p, 0);
	if(p == &amp;spec[3])
		error(Ebadspec);

	if((sdev=sdgetdev(idno)) == nil)
		error(Enonexist);
	if(sdgetunit(sdev, subno) == nil){
		decref(&amp;sdev-&gt;r);
		error(Enonexist);
	}

	c = devattach(sddevtab.dc, spec);
	mkqid(&amp;c-&gt;qid, QID(sdev-&gt;idno, subno, 0, Qunitdir), 0, QTDIR);
	c-&gt;dev = (sdev-&gt;idno &lt;&lt; UnitLOG) + subno;
	decref(&amp;sdev-&gt;r);
	return c;
}

static Walkqid*
sdwalk(Chan* c, Chan* nc, char** name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, sdgen);
}

static int
sdstat(Chan* c, uchar* db, int n)
{
	return devstat(c, db, n, nil, 0, sdgen);
}

static Chan*
sdopen(Chan* c, int omode)
{
	SDpart *pp;
	SDunit *unit;
	SDev *sdev;
	uchar tp;

	c = devopen(c, omode, 0, 0, sdgen);
	if((tp = TYPE(c-&gt;qid)) != Qctl &amp;&amp; tp != Qraw &amp;&amp; tp != Qpart)
		return c;

	sdev = sdgetdev(DEV(c-&gt;qid));
	if(sdev == nil)
		error(Enonexist);

	unit = sdev-&gt;unit[UNIT(c-&gt;qid)];

	switch(TYPE(c-&gt;qid)){
	case Qctl:
		c-&gt;qid.vers = unit-&gt;vers;
		break;
	case Qraw:
		c-&gt;qid.vers = unit-&gt;vers;
		if(tas(&amp;unit-&gt;rawinuse) != 0){
			c-&gt;flag &amp;= ~COPEN;
			decref(&amp;sdev-&gt;r);
			error(Einuse);
		}
		unit-&gt;state = Rawcmd;
		break;
	case Qpart:
		qlock(&amp;unit-&gt;ctl);
		if(waserror()){
			qunlock(&amp;unit-&gt;ctl);
			c-&gt;flag &amp;= ~COPEN;
			decref(&amp;sdev-&gt;r);
			nexterror();
		}
		pp = &amp;unit-&gt;part[PART(c-&gt;qid)];
		c-&gt;qid.vers = unit-&gt;vers+pp-&gt;vers;
		qunlock(&amp;unit-&gt;ctl);
		poperror();
		break;
	}
	decref(&amp;sdev-&gt;r);
	return c;
}

static void
sdclose(Chan* c)
{
	SDunit *unit;
	SDev *sdev;

	if(c-&gt;qid.type &amp; QTDIR)
		return;
	if(!(c-&gt;flag &amp; COPEN))
		return;

	switch(TYPE(c-&gt;qid)){
	default:
		break;
	case Qraw:
		sdev = sdgetdev(DEV(c-&gt;qid));
		if(sdev){
			unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
			unit-&gt;rawinuse = 0;
			decref(&amp;sdev-&gt;r);
		}
		break;
	}
}

static long
sdbio(Chan* c, int write, char* a, long len, uvlong off)
{
	int nchange;
	long l;
	uchar *b;
	SDpart *pp;
	SDunit *unit;
	SDev *sdev;
	ulong max, nb, offset;
	uvlong bno;

	sdev = sdgetdev(DEV(c-&gt;qid));
	if(sdev == nil){
		decref(&amp;sdev-&gt;r);
		error(Enonexist);
	}
	unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
	if(unit == nil)
		error(Enonexist);

	nchange = 0;
	qlock(&amp;unit-&gt;ctl);
	while(waserror()){
		/* notification of media change; go around again */
		if(strcmp(up-&gt;errstr, Eio) == 0 &amp;&amp; unit-&gt;sectors == 0 &amp;&amp; nchange++ == 0){
			sdinitpart(unit);
			continue;
		}

		/* other errors; give up */
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		nexterror();
	}
	pp = &amp;unit-&gt;part[PART(c-&gt;qid)];
	if(unit-&gt;vers+pp-&gt;vers != c-&gt;qid.vers)
		error(Echange);

	/*
	 * Check the request is within bounds.
	 * Removeable drives are locked throughout the I/O
	 * in case the media changes unexpectedly.
	 * Non-removeable drives are not locked during the I/O
	 * to allow the hardware to optimise if it can; this is
	 * a little fast and loose.
	 * It's assumed that non-removeable media parameters
	 * (sectors, secsize) can't change once the drive has
	 * been brought online.
	 */
	bno = (off/unit-&gt;secsize) + pp-&gt;start;
	nb = ((off+len+unit-&gt;secsize-1)/unit-&gt;secsize) + pp-&gt;start - bno;
	max = SDmaxio/unit-&gt;secsize;
	if(nb &gt; max)
		nb = max;
	if(bno+nb &gt; pp-&gt;end)
		nb = pp-&gt;end - bno;
	if(bno &gt;= pp-&gt;end || nb == 0){
		if(write)
			error(Eio);
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		poperror();
		return 0;
	}
	if(!(unit-&gt;inquiry[1] &amp; SDinq1removable)){
		qunlock(&amp;unit-&gt;ctl);
		poperror();
	}

	b = sdmalloc(nb*unit-&gt;secsize);
	if(b == nil)
		error(Enomem);
	if(waserror()){
		sdfree(b);
		if(!(unit-&gt;inquiry[1] &amp; SDinq1removable))
			decref(&amp;sdev-&gt;r);		/* gadverdamme! */
		nexterror();
	}

	offset = off%unit-&gt;secsize;
	if(offset+len &gt; nb*unit-&gt;secsize)
		len = nb*unit-&gt;secsize - offset;
	if(write){
		if(offset || (len%unit-&gt;secsize)){
			l = unit-&gt;dev-&gt;ifc-&gt;bio(unit, 0, 0, b, nb, bno);
			if(l &lt; 0)
				error(Eio);
			if(l &lt; (nb*unit-&gt;secsize)){
				nb = l/unit-&gt;secsize;
				l = nb*unit-&gt;secsize - offset;
				if(len &gt; l)
					len = l;
			}
		}
		memmove(b+offset, a, len);
		l = unit-&gt;dev-&gt;ifc-&gt;bio(unit, 0, 1, b, nb, bno);
		if(l &lt; 0)
			error(Eio);
		if(l &lt; offset)
			len = 0;
		else if(len &gt; l - offset)
			len = l - offset;
	}
	else{
		l = unit-&gt;dev-&gt;ifc-&gt;bio(unit, 0, 0, b, nb, bno);
		if(l &lt; 0)
			error(Eio);
		if(l &lt; offset)
			len = 0;
		else if(len &gt; l - offset)
			len = l - offset;
		memmove(a, b+offset, len);
	}
	sdfree(b);
	poperror();

	if(unit-&gt;inquiry[1] &amp; SDinq1removable){
		qunlock(&amp;unit-&gt;ctl);
		poperror();
	}

	decref(&amp;sdev-&gt;r);
	return len;
}

static long
sdrio(SDreq* r, void* a, long n)
{
	void *data;

	if(n &gt;= SDmaxio || n &lt; 0)
		error(Etoobig);

	data = nil;
	if(n){
		if((data = sdmalloc(n)) == nil)
			error(Enomem);
		if(r-&gt;write)
			memmove(data, a, n);
	}
	r-&gt;data = data;
	r-&gt;dlen = n;

	if(waserror()){
		sdfree(data);
		r-&gt;data = nil;
		nexterror();
	}

	if(r-&gt;unit-&gt;dev-&gt;ifc-&gt;rio(r) != SDok)
		error(Eio);

	if(!r-&gt;write &amp;&amp; r-&gt;rlen &gt; 0)
		memmove(a, data, r-&gt;rlen);
	sdfree(data);
	r-&gt;data = nil;
	poperror();

	return r-&gt;rlen;
}

/*
 * SCSI simulation for non-SCSI devices
 */
int
sdsetsense(SDreq *r, int status, int key, int asc, int ascq)
{
	int len;
	SDunit *unit;

	unit = r-&gt;unit;
	unit-&gt;sense[2] = key;
	unit-&gt;sense[12] = asc;
	unit-&gt;sense[13] = ascq;

	r-&gt;status = status;
	if(status == SDcheck &amp;&amp; !(r-&gt;flags &amp; SDnosense)){
		/* request sense case from sdfakescsi */
		len = sizeof unit-&gt;sense;
		if(len &gt; sizeof r-&gt;sense-1)
			len = sizeof r-&gt;sense-1;
		memmove(r-&gt;sense, unit-&gt;sense, len);
		unit-&gt;sense[2] = 0;
		unit-&gt;sense[12] = 0;
		unit-&gt;sense[13] = 0;
		r-&gt;flags |= SDvalidsense;
		return SDok;
	}
	return status;
}

int
sdmodesense(SDreq *r, uchar *cmd, void *info, int ilen)
{
	int len;
	uchar *data;

	/*
	 * Fake a vendor-specific request with page code 0,
	 * return the drive info.
	 */
	if((cmd[2] &amp; 0x3F) != 0 &amp;&amp; (cmd[2] &amp; 0x3F) != 0x3F)
		return sdsetsense(r, SDcheck, 0x05, 0x24, 0);
	len = (cmd[7]&lt;&lt;8)|cmd[8];
	if(len == 0)
		return SDok;
	if(len &lt; 8+ilen)
		return sdsetsense(r, SDcheck, 0x05, 0x1A, 0);
	if(r-&gt;data == nil || r-&gt;dlen &lt; len)
		return sdsetsense(r, SDcheck, 0x05, 0x20, 1);
	data = r-&gt;data;
	memset(data, 0, 8);
	data[0] = ilen&gt;&gt;8;
	data[1] = ilen;
	if(ilen)
		memmove(data+8, info, ilen);
	r-&gt;rlen = 8+ilen;
	return sdsetsense(r, SDok, 0, 0, 0);
}

int
sdfakescsi(SDreq *r, void *info, int ilen)
{
	uchar *cmd, *p;
	uvlong len;
	SDunit *unit;

	cmd = r-&gt;cmd;
	r-&gt;rlen = 0;
	unit = r-&gt;unit;

	/*
	 * Rewrite read(6)/write(6) into read(10)/write(10).
	 */
	switch(cmd[0]){
	case 0x08:	/* read */
	case 0x0A:	/* write */
		cmd[9] = 0;
		cmd[8] = cmd[4];
		cmd[7] = 0;
		cmd[6] = 0;
		cmd[5] = cmd[3];
		cmd[4] = cmd[2];
		cmd[3] = cmd[1] &amp; 0x0F;
		cmd[2] = 0;
		cmd[1] &amp;= 0xE0;
		cmd[0] |= 0x20;
		break;
	}

	/*
	 * Map SCSI commands into ATA commands for discs.
	 * Fail any command with a LUN except INQUIRY which
	 * will return 'logical unit not supported'.
	 */
	if((cmd[1]&gt;&gt;5) &amp;&amp; cmd[0] != 0x12)
		return sdsetsense(r, SDcheck, 0x05, 0x25, 0);

	switch(cmd[0]){
	default:
		return sdsetsense(r, SDcheck, 0x05, 0x20, 0);

	case 0x00:	/* test unit ready */
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x03:	/* request sense */
		if(cmd[4] &lt; sizeof unit-&gt;sense)
			len = cmd[4];
		else
			len = sizeof unit-&gt;sense;
		if(r-&gt;data &amp;&amp; r-&gt;dlen &gt;= len){
			memmove(r-&gt;data, unit-&gt;sense, len);
			r-&gt;rlen = len;
		}
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x12:	/* inquiry */
		if(cmd[4] &lt; sizeof unit-&gt;inquiry)
			len = cmd[4];
		else
			len = sizeof unit-&gt;inquiry;
		if(r-&gt;data &amp;&amp; r-&gt;dlen &gt;= len){
			memmove(r-&gt;data, unit-&gt;inquiry, len);
			r-&gt;rlen = len;
		}
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x1B:	/* start/stop unit */
		/*
		 * nop for now, can use power management later.
		 */
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x25:	/* read capacity */
		if((cmd[1] &amp; 0x01) || cmd[2] || cmd[3])
			return sdsetsense(r, SDcheck, 0x05, 0x24, 0);
		if(r-&gt;data == nil || r-&gt;dlen &lt; 8)
			return sdsetsense(r, SDcheck, 0x05, 0x20, 1);

		/*
		 * Read capacity returns the LBA of the last sector.
		 */
		len = unit-&gt;sectors - 1;
		p = r-&gt;data;
		*p++ = len&gt;&gt;24;
		*p++ = len&gt;&gt;16;
		*p++ = len&gt;&gt;8;
		*p++ = len;
		len = 512;
		*p++ = len&gt;&gt;24;
		*p++ = len&gt;&gt;16;
		*p++ = len&gt;&gt;8;
		*p++ = len;
		r-&gt;rlen = p - (uchar*)r-&gt;data;
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x9E:	/* long read capacity */
		if((cmd[1] &amp; 0x01) || cmd[2] || cmd[3])
			return sdsetsense(r, SDcheck, 0x05, 0x24, 0);
		if(r-&gt;data == nil || r-&gt;dlen &lt; 8)
			return sdsetsense(r, SDcheck, 0x05, 0x20, 1);
		/*
		 * Read capcity returns the LBA of the last sector.
		 */
		len = unit-&gt;sectors - 1;
		p = r-&gt;data;
		*p++ = len&gt;&gt;56;
		*p++ = len&gt;&gt;48;
		*p++ = len&gt;&gt;40;
		*p++ = len&gt;&gt;32;
		*p++ = len&gt;&gt;24;
		*p++ = len&gt;&gt;16;
		*p++ = len&gt;&gt;8;
		*p++ = len;
		len = 512;
		*p++ = len&gt;&gt;24;
		*p++ = len&gt;&gt;16;
		*p++ = len&gt;&gt;8;
		*p++ = len;
		r-&gt;rlen = p - (uchar*)r-&gt;data;
		return sdsetsense(r, SDok, 0, 0, 0);

	case 0x5A:	/* mode sense */
		return sdmodesense(r, cmd, info, ilen);

	case 0x28:	/* read */
	case 0x2A:	/* write */
	case 0x88:	/* read16 */
	case 0x8a:	/* write16 */
		return SDnostatus;
	}
}

static long
sdread(Chan *c, void *a, long n, vlong off)
{
	char *p, *e, *buf;
	SDpart *pp;
	SDunit *unit;
	SDev *sdev;
	ulong offset;
	int i, l, m, status;

	offset = off;
	switch(TYPE(c-&gt;qid)){
	default:
		error(Eperm);
	case Qtopctl:
		m = 64*1024;	/* room for register dumps */
		p = buf = malloc(m);
		if(p == nil)
			error(Enomem);
		e = p + m;
		qlock(&amp;devslock);
		for(i = 0; i &lt; nelem(devs); i++){
			sdev = devs[i];
			if(sdev &amp;&amp; sdev-&gt;ifc-&gt;rtopctl)
				p = sdev-&gt;ifc-&gt;rtopctl(sdev, p, e);
		}
		qunlock(&amp;devslock);
		n = readstr(off, a, n, buf);
		free(buf);
		return n;

	case Qtopdir:
	case Qunitdir:
		return devdirread(c, a, n, 0, 0, sdgen);

	case Qctl:
		sdev = sdgetdev(DEV(c-&gt;qid));
		if(sdev == nil)
			error(Enonexist);

		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
		m = 16*1024;	/* room for register dumps */
		p = malloc(m);
		if(p == nil)
			error(Enomem);
		l = snprint(p, m, "inquiry %.48s\n",
			(char*)unit-&gt;inquiry+8);
		qlock(&amp;unit-&gt;ctl);
		/*
		 * If there's a device specific routine it must
		 * provide all information pertaining to night geometry
		 * and the garscadden trains.
		 */
		if(unit-&gt;dev-&gt;ifc-&gt;rctl)
			l += unit-&gt;dev-&gt;ifc-&gt;rctl(unit, p+l, m-l);
		if(unit-&gt;sectors == 0)
			sdinitpart(unit);
		if(unit-&gt;sectors){
			if(unit-&gt;dev-&gt;ifc-&gt;rctl == nil)
				l += snprint(p+l, m-l,
					"geometry %llud %lud\n",
					unit-&gt;sectors, unit-&gt;secsize);
			pp = unit-&gt;part;
			for(i = 0; i &lt; unit-&gt;npart; i++){
				if(pp-&gt;valid)
					l += snprint(p+l, m-l,
						"part %s %llud %llud\n",
						pp-&gt;name, pp-&gt;start, pp-&gt;end);
				pp++;
			}
		}
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		l = readstr(offset, a, n, p);
		free(p);
		return l;

	case Qraw:
		sdev = sdgetdev(DEV(c-&gt;qid));
		if(sdev == nil)
			error(Enonexist);

		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
		qlock(&amp;unit-&gt;raw);
		if(waserror()){
			qunlock(&amp;unit-&gt;raw);
			decref(&amp;sdev-&gt;r);
			nexterror();
		}
		if(unit-&gt;state == Rawdata){
			unit-&gt;state = Rawstatus;
			i = sdrio(unit-&gt;req, a, n);
		}
		else if(unit-&gt;state == Rawstatus){
			status = unit-&gt;req-&gt;status;
			unit-&gt;state = Rawcmd;
			free(unit-&gt;req);
			unit-&gt;req = nil;
			i = readnum(0, a, n, status, NUMSIZE);
		} else
			i = 0;
		qunlock(&amp;unit-&gt;raw);
		decref(&amp;sdev-&gt;r);
		poperror();
		return i;

	case Qpart:
		return sdbio(c, 0, a, n, off);
	}
}

static void legacytopctl(Cmdbuf*);

static long
sdwrite(Chan* c, void* a, long n, vlong off)
{
	char *f0;
	int i;
	uvlong end, start;
	Cmdbuf *cb;
	SDifc *ifc;
	SDreq *req;
	SDunit *unit;
	SDev *sdev;

	switch(TYPE(c-&gt;qid)){
	default:
		error(Eperm);
	case Qtopctl:
		cb = parsecmd(a, n);
		if(waserror()){
			free(cb);
			nexterror();
		}
		if(cb-&gt;nf == 0)
			error("empty control message");
		f0 = cb-&gt;f[0];
		cb-&gt;f++;
		cb-&gt;nf--;
		if(strcmp(f0, "config") == 0){
			/* wormhole into ugly legacy interface */
			legacytopctl(cb);
			poperror();
			free(cb);
			break;
		}
		/*
		 * "ata arg..." invokes sdifc[i]-&gt;wtopctl(nil, cb),
		 * where sdifc[i]-&gt;name=="ata" and cb contains the args.
		 */
		ifc = nil;
		sdev = nil;
		for(i=0; sdifc[i]; i++){
			if(strcmp(sdifc[i]-&gt;name, f0) == 0){
				ifc = sdifc[i];
				sdev = nil;
				goto subtopctl;
			}
		}
		/*
		 * "sd1 arg..." invokes sdifc[i]-&gt;wtopctl(sdev, cb),
		 * where sdifc[i] and sdev match controller letter "1",
		 * and cb contains the args.
		 */
		if(f0[0]=='s' &amp;&amp; f0[1]=='d' &amp;&amp; f0[2] &amp;&amp; f0[3] == 0){
			if((sdev = sdgetdev(f0[2])) != nil){
				ifc = sdev-&gt;ifc;
				goto subtopctl;
			}
		}
		error("unknown interface");

	subtopctl:
		if(waserror()){
			if(sdev)
				decref(&amp;sdev-&gt;r);
			nexterror();
		}
		if(ifc-&gt;wtopctl)
			ifc-&gt;wtopctl(sdev, cb);
		else
			error(Ebadctl);
		poperror();
		poperror();
		if (sdev)
			decref(&amp;sdev-&gt;r);
		free(cb);
		break;

	case Qctl:
		cb = parsecmd(a, n);
		sdev = sdgetdev(DEV(c-&gt;qid));
		if(sdev == nil)
			error(Enonexist);
		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];

		qlock(&amp;unit-&gt;ctl);
		if(waserror()){
			qunlock(&amp;unit-&gt;ctl);
			decref(&amp;sdev-&gt;r);
			free(cb);
			nexterror();
		}
		if(unit-&gt;vers != c-&gt;qid.vers)
			error(Echange);

		if(cb-&gt;nf &lt; 1)
			error(Ebadctl);
		if(strcmp(cb-&gt;f[0], "part") == 0){
			if(cb-&gt;nf != 4)
				error(Ebadctl);
			if(unit-&gt;sectors == 0 &amp;&amp; !sdinitpart(unit))
				error(Eio);
			start = strtoull(cb-&gt;f[2], 0, 0);
			end = strtoull(cb-&gt;f[3], 0, 0);
			sdaddpart(unit, cb-&gt;f[1], start, end);
		}
		else if(strcmp(cb-&gt;f[0], "delpart") == 0){
			if(cb-&gt;nf != 2 || unit-&gt;part == nil)
				error(Ebadctl);
			sddelpart(unit, cb-&gt;f[1]);
		}
		else if(unit-&gt;dev-&gt;ifc-&gt;wctl)
			unit-&gt;dev-&gt;ifc-&gt;wctl(unit, cb);
		else
			error(Ebadctl);
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		poperror();
		free(cb);
		break;

	case Qraw:
		sdev = sdgetdev(DEV(c-&gt;qid));
		if(sdev == nil)
			error(Enonexist);
		unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
		qlock(&amp;unit-&gt;raw);
		if(waserror()){
			qunlock(&amp;unit-&gt;raw);
			decref(&amp;sdev-&gt;r);
			nexterror();
		}
		switch(unit-&gt;state){
		case Rawcmd:
			if(n &lt; 6 || n &gt; sizeof(req-&gt;cmd))
				error(Ebadarg);
			if((req = malloc(sizeof(SDreq))) == nil)
				error(Enomem);
			req-&gt;unit = unit;
			memmove(req-&gt;cmd, a, n);
			req-&gt;clen = n;
			req-&gt;flags = SDnosense;
			req-&gt;status = ~0;

			unit-&gt;req = req;
			unit-&gt;state = Rawdata;
			break;

		case Rawstatus:
			unit-&gt;state = Rawcmd;
			free(unit-&gt;req);
			unit-&gt;req = nil;
			error(Ebadusefd);

		case Rawdata:
			unit-&gt;state = Rawstatus;
			unit-&gt;req-&gt;write = 1;
			n = sdrio(unit-&gt;req, a, n);
		}
		qunlock(&amp;unit-&gt;raw);
		decref(&amp;sdev-&gt;r);
		poperror();
		break;
	case Qpart:
		return sdbio(c, 1, a, n, off);
	}

	return n;
}

static int
sdwstat(Chan* c, uchar* dp, int n)
{
	Dir *d;
	SDpart *pp;
	SDperm *perm;
	SDunit *unit;
	SDev *sdev;

	if(c-&gt;qid.type &amp; QTDIR)
		error(Eperm);

	sdev = sdgetdev(DEV(c-&gt;qid));
	if(sdev == nil)
		error(Enonexist);
	unit = sdev-&gt;unit[UNIT(c-&gt;qid)];
	qlock(&amp;unit-&gt;ctl);
	d = nil;
	if(waserror()){
		free(d);
		qunlock(&amp;unit-&gt;ctl);
		decref(&amp;sdev-&gt;r);
		nexterror();
	}

	switch(TYPE(c-&gt;qid)){
	default:
		error(Eperm);
	case Qctl:
		perm = &amp;unit-&gt;ctlperm;
		break;
	case Qraw:
		perm = &amp;unit-&gt;rawperm;
		break;
	case Qpart:
		pp = &amp;unit-&gt;part[PART(c-&gt;qid)];
		if(unit-&gt;vers+pp-&gt;vers != c-&gt;qid.vers)
			error(Enonexist);
		perm = &amp;pp-&gt;SDperm;
		break;
	}

	if(strcmp(up-&gt;user, perm-&gt;user) &amp;&amp; !iseve())
		error(Eperm);

	d = smalloc(sizeof(Dir)+n);
	n = convM2D(dp, n, &amp;d[0], (char*)&amp;d[1]);
	if(n == 0)
		error(Eshortstat);
	if(!emptystr(d[0].uid))
		kstrdup(&amp;perm-&gt;user, d[0].uid);
	if(d[0].mode != ~0UL)
		perm-&gt;perm = (perm-&gt;perm &amp; ~0777) | (d[0].mode &amp; 0777);

	free(d);
	qunlock(&amp;unit-&gt;ctl);
	decref(&amp;sdev-&gt;r);
	poperror();
	return n;
}

static int
configure(char* spec, DevConf* cf)
{
	SDev *s, *sdev;
	char *p;
	int i;

	if(sdindex(*spec) &lt; 0)
		error("bad sd spec");

	if((p = strchr(cf-&gt;type, '/')) != nil)
		*p++ = '\0';

	for(i = 0; sdifc[i] != nil; i++)
		if(strcmp(sdifc[i]-&gt;name, cf-&gt;type) == 0)
			break;
	if(sdifc[i] == nil)
		error("sd type not found");
	if(p)
		*(p-1) = '/';

	if(sdifc[i]-&gt;probe == nil)
		error("sd type cannot probe");

	sdev = sdifc[i]-&gt;probe(cf);
	for(s=sdev; s; s=s-&gt;next)
		s-&gt;idno = *spec;
	sdadddevs(sdev);
	return 0;
}

static int
unconfigure(char* spec)
{
	int i;
	SDev *sdev;
	SDunit *unit;

	if((i = sdindex(*spec)) &lt; 0)
		error(Enonexist);

	qlock(&amp;devslock);
	if((sdev = devs[i]) == nil){
		qunlock(&amp;devslock);
		error(Enonexist);
	}
	if(sdev-&gt;r.ref){
		qunlock(&amp;devslock);
		error(Einuse);
	}
	devs[i] = nil;
	qunlock(&amp;devslock);

	/* make sure no interrupts arrive anymore before removing resources */
	if(sdev-&gt;enabled &amp;&amp; sdev-&gt;ifc-&gt;disable)
		sdev-&gt;ifc-&gt;disable(sdev);

	for(i = 0; i != sdev-&gt;nunit; i++){
		if(unit = sdev-&gt;unit[i]){
			free(unit-&gt;name);
			free(unit-&gt;user);
			free(unit);
		}
	}

	if(sdev-&gt;ifc-&gt;clear)
		sdev-&gt;ifc-&gt;clear(sdev);
	free(sdev);
	return 0;
}

static int
sdconfig(int on, char* spec, DevConf* cf)
{
	if(on)
		return configure(spec, cf);
	return unconfigure(spec);
}

Dev sddevtab = {
	'S',
	"sd",

	sdreset,
	devinit,
	devshutdown,
	sdattach,
	sdwalk,
	sdstat,
	sdopen,
	devcreate,
	sdclose,
	sdread,
	devbread,
	sdwrite,
	devbwrite,
	devremove,
	sdwstat,
	devpower,
	sdconfig,	/* probe; only called for pcmcia-like devices */
};

/*
 * This is wrong for so many reasons.  This code must go.
 */
typedef struct Confdata Confdata;
struct Confdata {
	int	on;
	char*	spec;
	DevConf	cf;
};

static void
parseswitch(Confdata* cd, char* option)
{
	if(!strcmp("on", option))
		cd-&gt;on = 1;
	else if(!strcmp("off", option))
		cd-&gt;on = 0;
	else
		error(Ebadarg);
}

static void
parsespec(Confdata* cd, char* option)
{
	if(strlen(option) &gt; 1)
		error(Ebadarg);
	cd-&gt;spec = option;
}

static Devport*
getnewport(DevConf* dc)
{
	Devport *p;

	p = (Devport *)malloc((dc-&gt;nports + 1) * sizeof(Devport));
	if(p == nil)
		error(Enomem);
	if(dc-&gt;nports &gt; 0){
		memmove(p, dc-&gt;ports, dc-&gt;nports * sizeof(Devport));
		free(dc-&gt;ports);
	}
	dc-&gt;ports = p;
	p = &amp;dc-&gt;ports[dc-&gt;nports++];
	p-&gt;size = -1;
	p-&gt;port = (ulong)-1;
	return p;
}

static void
parseport(Confdata* cd, char* option)
{
	char *e;
	Devport *p;

	if(cd-&gt;cf.nports == 0 || cd-&gt;cf.ports[cd-&gt;cf.nports-1].port != (ulong)-1)
		p = getnewport(&amp;cd-&gt;cf);
	else
		p = &amp;cd-&gt;cf.ports[cd-&gt;cf.nports-1];
	p-&gt;port = strtol(option, &amp;e, 0);
	if(e == nil || *e != '\0')
		error(Ebadarg);
}

static void
parsesize(Confdata* cd, char* option)
{
	char *e;
	Devport *p;

	if(cd-&gt;cf.nports == 0 || cd-&gt;cf.ports[cd-&gt;cf.nports-1].size != -1)
		p = getnewport(&amp;cd-&gt;cf);
	else
		p = &amp;cd-&gt;cf.ports[cd-&gt;cf.nports-1];
	p-&gt;size = (int)strtol(option, &amp;e, 0);
	if(e == nil || *e != '\0')
		error(Ebadarg);
}

static void
parseirq(Confdata* cd, char* option)
{
	char *e;

	cd-&gt;cf.intnum = strtoul(option, &amp;e, 0);
	if(e == nil || *e != '\0')
		error(Ebadarg);
}

static void
parsetype(Confdata* cd, char* option)
{
	cd-&gt;cf.type = option;
}

static struct {
	char	*name;
	void	(*parse)(Confdata*, char*);
} options[] = {
	"switch",	parseswitch,
	"spec",		parsespec,
	"port",		parseport,
	"size",		parsesize,
	"irq",		parseirq,
	"type",		parsetype,
};

static void
legacytopctl(Cmdbuf *cb)
{
	char *opt;
	int i, j;
	Confdata cd;

	memset(&amp;cd, 0, sizeof cd);
	cd.on = -1;
	for(i=0; i&lt;cb-&gt;nf; i+=2){
		if(i+2 &gt; cb-&gt;nf)
			error(Ebadarg);
		opt = cb-&gt;f[i];
		for(j=0; j&lt;nelem(options); j++)
			if(strcmp(opt, options[j].name) == 0){
				options[j].parse(&amp;cd, cb-&gt;f[i+1]);
				break;
			}
		if(j == nelem(options))
			error(Ebadarg);
	}
	/* this has been rewritten to accomodate sdaoe */
	if(cd.on &lt; 0 || cd.spec == 0)
		error(Ebadarg);
	if(cd.on &amp;&amp; cd.cf.type == nil)
		error(Ebadarg);
	sdconfig(cd.on, cd.spec, &amp;cd.cf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

