<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devsegment.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devsegment.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

enum
{
	Qtopdir,
	Qsegdir,
	Qctl,
	Qdata,

	/* commands to kproc */
	Cnone=0,
	Cread,
	Cwrite,
	Cstart,
	Cdie,
};

#define TYPE(x) 	(int)( (c)-&gt;qid.path &amp; 0x7 )
#define SEG(x)	 	( ((c)-&gt;qid.path &gt;&gt; 3) &amp; 0x3f )
#define PATH(s, t) 	( ((s)&lt;&lt;3) | (t) )

typedef struct Globalseg Globalseg;
struct Globalseg
{
	Ref;
	Segment	*s;

	char	*name;
	char	*uid;
	vlong	length;
	long	perm;

	/* kproc to do reading and writing */
	QLock	l;		/* sync kproc access */
	Rendez	cmdwait;	/* where kproc waits */
	Rendez	replywait;	/* where requestor waits */
	Proc	*kproc;
	char	*data;
	long	off;
	int	dlen;
	int	cmd;	
	char	err[64];
};

static Globalseg *globalseg[100];
static Lock globalseglock;


	Segment* (*_globalsegattach)(Proc*, char*);
static	Segment* globalsegattach(Proc *p, char *name);
static	int	cmddone(void*);
static	void	segmentkproc(void*);
static	void	docmd(Globalseg *g, int cmd);

/*
 *  returns with globalseg incref'd
 */
static Globalseg*
getgseg(Chan *c)
{
	int x;
	Globalseg *g;

	x = SEG(c);
	lock(&amp;globalseglock);
	if(x &gt;= nelem(globalseg))
		panic("getgseg");
	g = globalseg[x];
	if(g != nil)
		incref(g);
	unlock(&amp;globalseglock);
	if(g == nil)
		error("global segment disappeared");
	return g;
}

static void
putgseg(Globalseg *g)
{
	if(decref(g) &gt; 0)
		return;
	if(g-&gt;s != nil)
		putseg(g-&gt;s);
	if(g-&gt;kproc)
		docmd(g, Cdie);
	free(g-&gt;name);
	free(g-&gt;uid);
	free(g);
}

static int
segmentgen(Chan *c, char*, Dirtab*, int, int s, Dir *dp)
{
	Qid q;
	Globalseg *g;
	ulong size;

	switch(TYPE(c)) {
	case Qtopdir:
		if(s == DEVDOTDOT){
			q.vers = 0;
			q.path = PATH(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, "#g", 0, eve, DMDIR|0777, dp);
			break;
		}

		if(s &gt;= nelem(globalseg))
			return -1;

		lock(&amp;globalseglock);
		g = globalseg[s];
		if(g == nil){
			unlock(&amp;globalseglock);
			return 0;
		}
		q.vers = 0;
		q.path = PATH(s, Qsegdir);
		q.type = QTDIR;
		devdir(c, q, g-&gt;name, 0, g-&gt;uid, DMDIR|0777, dp);
		unlock(&amp;globalseglock);

		break;
	case Qsegdir:
		if(s == DEVDOTDOT){
			q.vers = 0;
			q.path = PATH(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, "#g", 0, eve, DMDIR|0777, dp);
			break;
		}
		/* fall through */
	case Qctl:
	case Qdata:
		switch(s){
		case 0:
			g = getgseg(c);
			q.vers = 0;
			q.path = PATH(SEG(c), Qctl);
			q.type = QTFILE;
			devdir(c, q, "ctl", 0, g-&gt;uid, g-&gt;perm, dp);
			putgseg(g);
			break;
		case 1:
			g = getgseg(c);
			q.vers = 0;
			q.path = PATH(SEG(c), Qdata);
			q.type = QTFILE;
			if(g-&gt;s != nil)
				size = g-&gt;s-&gt;top - g-&gt;s-&gt;base;
			else
				size = 0;
			devdir(c, q, "data", size, g-&gt;uid, g-&gt;perm, dp);
			putgseg(g);
			break;
		default:
			return -1;
		}
		break;
	}
	return 1;
}

static void
segmentinit(void)
{
	_globalsegattach = globalsegattach;
}

static Chan*
segmentattach(char *spec)
{
	return devattach('g', spec);
}

static Walkqid*
segmentwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, segmentgen);
}

static int
segmentstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, 0, 0, segmentgen);
}

static int
cmddone(void *arg)
{
	Globalseg *g = arg;

	return g-&gt;cmd == Cnone;
}

static Chan*
segmentopen(Chan *c, int omode)
{
	Globalseg *g;

	switch(TYPE(c)){
	case Qtopdir:
	case Qsegdir:
		if(omode != 0)
			error(Eisdir);
		break;
	case Qctl:
		g = getgseg(c);
		if(waserror()){
			putgseg(g);
			nexterror();
		}
		devpermcheck(g-&gt;uid, g-&gt;perm, omode);
		c-&gt;aux = g;
		poperror();
		c-&gt;flag |= COPEN;
		break;
	case Qdata:
		g = getgseg(c);
		if(waserror()){
			putgseg(g);
			nexterror();
		}
		devpermcheck(g-&gt;uid, g-&gt;perm, omode);
		if(g-&gt;s == nil)
			error("segment not yet allocated");
		if(g-&gt;kproc == nil){
			qlock(&amp;g-&gt;l);
			if(waserror()){
				qunlock(&amp;g-&gt;l);
				nexterror();
			}
			if(g-&gt;kproc == nil){
				g-&gt;cmd = Cnone;
				kproc(g-&gt;name, segmentkproc, g);
				docmd(g, Cstart);
			}
			qunlock(&amp;g-&gt;l);
			poperror();
		}
		c-&gt;aux = g;
		poperror();
		c-&gt;flag |= COPEN;
		break;
	default:
		panic("segmentopen");
	}
	c-&gt;mode = openmode(omode);
	c-&gt;offset = 0;
	return c;
}

static void
segmentclose(Chan *c)
{
	if(TYPE(c) == Qtopdir)
		return;
	if(c-&gt;flag &amp; COPEN)
		putgseg(c-&gt;aux);
}

static void
segmentcreate(Chan *c, char *name, int omode, ulong perm)
{
	int x, xfree;
	Globalseg *g;

	if(TYPE(c) != Qtopdir)
		error(Eperm);

	if(isphysseg(name))
		error(Eexist);

	if((perm &amp; DMDIR) == 0)
		error(Ebadarg);

	if(waserror()){
		unlock(&amp;globalseglock);
		nexterror();
	}
	lock(&amp;globalseglock);
	xfree = -1;
	for(x = 0; x &lt; nelem(globalseg); x++){
		g = globalseg[x];
		if(g == nil){
			if(xfree &lt; 0)
				xfree = x;
		} else {
			if(strcmp(g-&gt;name, name) == 0)
				error(Eexist);
		}
	}
	if(xfree &lt; 0)
		error("too many global segments");
	g = smalloc(sizeof(Globalseg));
	g-&gt;ref = 1;
	kstrdup(&amp;g-&gt;name, name);
	kstrdup(&amp;g-&gt;uid, up-&gt;user);
	g-&gt;perm = 0660; 
	globalseg[xfree] = g;
	unlock(&amp;globalseglock);
	poperror();

	c-&gt;qid.path = PATH(x, Qsegdir);
	c-&gt;qid.type = QTDIR;
	c-&gt;qid.vers = 0;
	c-&gt;mode = openmode(omode);
	c-&gt;mode = OWRITE;
}

static long
segmentread(Chan *c, void *a, long n, vlong voff)
{
	Globalseg *g;
	char buf[32];

	if(c-&gt;qid.type == QTDIR)
		return devdirread(c, a, n, (Dirtab *)0, 0L, segmentgen);

	switch(TYPE(c)){
	case Qctl:
		g = c-&gt;aux;
		if(g-&gt;s == nil)
			error("segment not yet allocated");
		snprint(buf, sizeof buf, "va %#lux %#lux\n", g-&gt;s-&gt;base,
			g-&gt;s-&gt;top-g-&gt;s-&gt;base);
		return readstr(voff, a, n, buf);
	case Qdata:
		g = c-&gt;aux;
		if(voff &gt; g-&gt;s-&gt;top - g-&gt;s-&gt;base)
			error(Ebadarg);
		if(voff + n &gt; g-&gt;s-&gt;top - g-&gt;s-&gt;base)
			n = g-&gt;s-&gt;top - g-&gt;s-&gt;base - voff;
		qlock(&amp;g-&gt;l);
		g-&gt;off = voff + g-&gt;s-&gt;base;
		g-&gt;data = smalloc(n);
		if(waserror()){
			free(g-&gt;data);
			qunlock(&amp;g-&gt;l);
			nexterror();
		}
		g-&gt;dlen = n;
		docmd(g, Cread);
		memmove(a, g-&gt;data, g-&gt;dlen);
		free(g-&gt;data);
		qunlock(&amp;g-&gt;l);
		poperror();
		return g-&gt;dlen;
	default:
		panic("segmentread");
	}
	return 0;	/* not reached */
}

static long
segmentwrite(Chan *c, void *a, long n, vlong voff)
{
	Cmdbuf *cb;
	Globalseg *g;
	ulong va, len, top;

	if(c-&gt;qid.type == QTDIR)
		error(Eperm);

	switch(TYPE(c)){
	case Qctl:
		g = c-&gt;aux;
		cb = parsecmd(a, n);
		if(strcmp(cb-&gt;f[0], "va") == 0){
			if(g-&gt;s != nil)
				error("already has a virtual address");
			if(cb-&gt;nf &lt; 3)
				error(Ebadarg);
			va = strtoul(cb-&gt;f[1], 0, 0);
			len = strtoul(cb-&gt;f[2], 0, 0);
			top = PGROUND(va + len);
			va = va&amp;~(BY2PG-1);
			len = (top - va) / BY2PG;
			if(len == 0)
				error(Ebadarg);
			g-&gt;s = newseg(SG_SHARED, va, len);
		} else
			error(Ebadctl);
		break;
	case Qdata:
		g = c-&gt;aux;
		if(voff + n &gt; g-&gt;s-&gt;top - g-&gt;s-&gt;base)
			error(Ebadarg);
		qlock(&amp;g-&gt;l);
		g-&gt;off = voff + g-&gt;s-&gt;base;
		g-&gt;data = smalloc(n);
		if(waserror()){
			free(g-&gt;data);
			qunlock(&amp;g-&gt;l);
			nexterror();
		}
		g-&gt;dlen = n;
		memmove(g-&gt;data, a, g-&gt;dlen);
		docmd(g, Cwrite);
		free(g-&gt;data);
		qunlock(&amp;g-&gt;l);
		poperror();
		return g-&gt;dlen;
	default:
		panic("segmentwrite");
	}
	return 0;	/* not reached */
}

static int
segmentwstat(Chan *c, uchar *dp, int n)
{
	Globalseg *g;
	Dir *d;

	if(c-&gt;qid.type == QTDIR)
		error(Eperm);

	g = getgseg(c);
	if(waserror()){
		putgseg(g);
		nexterror();
	}

	if(strcmp(g-&gt;uid, up-&gt;user) &amp;&amp; !iseve())
		error(Eperm);
	d = smalloc(sizeof(Dir)+n);
	n = convM2D(dp, n, &amp;d[0], (char*)&amp;d[1]);
	g-&gt;perm = d-&gt;mode &amp; 0777;

	putgseg(g);
	poperror();

	free(d);
	return n;
}

static void
segmentremove(Chan *c)
{
	Globalseg *g;
	int x;

	if(TYPE(c) != Qsegdir)
		error(Eperm);
	lock(&amp;globalseglock);
	x = SEG(c);
	g = globalseg[x];
	globalseg[x] = nil;
	unlock(&amp;globalseglock);
	if(g != nil)
		putgseg(g);
}

/*
 *  called by segattach()
 */
static Segment*
globalsegattach(Proc *p, char *name)
{
	int x;
	Globalseg *g;
	Segment *s;

	g = nil;
	if(waserror()){
		unlock(&amp;globalseglock);
		nexterror();
	}
	lock(&amp;globalseglock);
	for(x = 0; x &lt; nelem(globalseg); x++){
		g = globalseg[x];
		if(g != nil &amp;&amp; strcmp(g-&gt;name, name) == 0)
			break;
	}
	if(x == nelem(globalseg)){
		unlock(&amp;globalseglock);
		poperror();
		return nil;
	}
	devpermcheck(g-&gt;uid, g-&gt;perm, ORDWR);
	s = g-&gt;s;
	if(s == nil)
		error("global segment not assigned a virtual address");
	if(isoverlap(p, s-&gt;base, s-&gt;top - s-&gt;base) != nil)
		error("overlaps existing segment");
	incref(s);
	unlock(&amp;globalseglock);
	poperror();
	return s;
}

static void
docmd(Globalseg *g, int cmd)
{
	g-&gt;err[0] = 0;
	g-&gt;cmd = cmd;
	wakeup(&amp;g-&gt;cmdwait);
	sleep(&amp;g-&gt;replywait, cmddone, g);
	if(g-&gt;err[0])
		error(g-&gt;err);
}

static int
cmdready(void *arg)
{
	Globalseg *g = arg;

	return g-&gt;cmd != Cnone;
}

static void
segmentkproc(void *arg)
{
	Globalseg *g = arg;
	int done;
	int sno;

	for(sno = 0; sno &lt; NSEG; sno++)
		if(up-&gt;seg[sno] == nil &amp;&amp; sno != ESEG)
			break;
	if(sno == NSEG)
		panic("segmentkproc");
	g-&gt;kproc = up;

	incref(g-&gt;s);
	up-&gt;seg[sno] = g-&gt;s;

	for(done = 0; !done;){
		sleep(&amp;g-&gt;cmdwait, cmdready, g);
		if(waserror()){
			strncpy(g-&gt;err, up-&gt;errstr, sizeof(g-&gt;err));
		} else {
			switch(g-&gt;cmd){
			case Cstart:
				break;
			case Cdie:
				done = 1;
				break;
			case Cread:
				memmove(g-&gt;data, (char*)g-&gt;off, g-&gt;dlen);
				break;
			case Cwrite:
				memmove((char*)g-&gt;off, g-&gt;data, g-&gt;dlen);
				break;
			}
			poperror();
		}
		g-&gt;cmd = Cnone;
		wakeup(&amp;g-&gt;replywait);
	}
}

Dev segmentdevtab = {
	'g',
	"segment",

	devreset,
	segmentinit,
	devshutdown,
	segmentattach,
	segmentwalk,
	segmentstat,
	segmentopen,
	segmentcreate,
	segmentclose,
	segmentread,
	devbread,
	segmentwrite,
	devbwrite,
	segmentremove,
	segmentwstat,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

