<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/devuart.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/devuart.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"
#include	"../port/error.h"

#include	"../port/netif.h"

enum
{
	/* soft flow control chars */
	CTLS= 023,
	CTLQ= 021,
};

extern Dev uartdevtab;
extern PhysUart* physuart[];

static Uart* uartlist;
static Uart** uart;
static int uartnuart;
static Dirtab *uartdir;
static int uartndir;
static Timer *uarttimer;

struct Uartalloc {
	Lock;
	Uart *elist;	/* list of enabled interfaces */
} uartalloc;

static void	uartclock(void);
static void	uartflow(void*);

/*
 *  enable/disable uart and add/remove to list of enabled uarts
 */
Uart*
uartenable(Uart *p)
{
	Uart **l;

	if(p-&gt;enabled)
		return p;
	if(p-&gt;iq == nil){
		if((p-&gt;iq = qopen(8*1024, 0, uartflow, p)) == nil)
			return nil;
	}
	else
		qreopen(p-&gt;iq);
	if(p-&gt;oq == nil){
		if((p-&gt;oq = qopen(8*1024, 0, uartkick, p)) == nil){
			qfree(p-&gt;iq);
			p-&gt;iq = nil;
			return nil;
		}
	}
	else
		qreopen(p-&gt;oq);

	p-&gt;ir = p-&gt;istage;
	p-&gt;iw = p-&gt;istage;
	p-&gt;ie = &amp;p-&gt;istage[Stagesize];
	p-&gt;op = p-&gt;ostage;
	p-&gt;oe = p-&gt;ostage;

	p-&gt;hup_dsr = p-&gt;hup_dcd = 0;
	p-&gt;dsr = p-&gt;dcd = 0;

	/* assume we can send */
	p-&gt;cts = 1;
	p-&gt;ctsbackoff = 0;

	if(p-&gt;bits == 0)
		uartctl(p, "l8");
	if(p-&gt;stop == 0)
		uartctl(p, "s1");
	if(p-&gt;parity == 0)
		uartctl(p, "pn");
	if(p-&gt;baud == 0)
		uartctl(p, "b9600");
	(*p-&gt;phys-&gt;enable)(p, 1);

	/*
	 * use ilock because uartclock can otherwise interrupt here
	 * and would hang on an attempt to lock uartalloc.
	 */
	ilock(&amp;uartalloc);
	for(l = &amp;uartalloc.elist; *l; l = &amp;(*l)-&gt;elist){
		if(*l == p)
			break;
	}
	if(*l == 0){
		p-&gt;elist = uartalloc.elist;
		uartalloc.elist = p;
	}
	p-&gt;enabled = 1;
	iunlock(&amp;uartalloc);

	return p;
}

static void
uartdisable(Uart *p)
{
	Uart **l;

	if(!p-&gt;enabled)
		return;
	(*p-&gt;phys-&gt;disable)(p);

	ilock(&amp;uartalloc);
	for(l = &amp;uartalloc.elist; *l; l = &amp;(*l)-&gt;elist){
		if(*l == p){
			*l = p-&gt;elist;
			break;
		}
	}
	p-&gt;enabled = 0;
	iunlock(&amp;uartalloc);
}

void
uartmouse(Uart* p, int (*putc)(Queue*, int), int setb1200)
{
	qlock(p);
	if(p-&gt;opens++ == 0 &amp;&amp; uartenable(p) == nil){
		qunlock(p);
		error(Enodev);
	}
	if(setb1200)
		uartctl(p, "b1200");
	p-&gt;putc = putc;
	p-&gt;special = 1;
	qunlock(p);
}

void
uartsetmouseputc(Uart* p, int (*putc)(Queue*, int))
{
	qlock(p);
	if(p-&gt;opens == 0 || p-&gt;special == 0){
		qunlock(p);
		error(Enodev);
	}
	p-&gt;putc = putc;
	qunlock(p);
}

static void
setlength(int i)
{
	Uart *p;

	if(i &gt; 0){
		p = uart[i];
		if(p &amp;&amp; p-&gt;opens &amp;&amp; p-&gt;iq)
			uartdir[1+3*i].length = qlen(p-&gt;iq);
	} else for(i = 0; i &lt; uartnuart; i++){
		p = uart[i];
		if(p &amp;&amp; p-&gt;opens &amp;&amp; p-&gt;iq)
			uartdir[1+3*i].length = qlen(p-&gt;iq);
	}
}

/*
 *  set up the '#t' directory
 */
static void
uartreset(void)
{
	int i;
	Dirtab *dp;
	Uart *p, *tail;

	tail = nil;
	for(i = 0; physuart[i] != nil; i++){
		if(physuart[i]-&gt;pnp == nil)
			continue;
		if((p = physuart[i]-&gt;pnp()) == nil)
			continue;
		if(uartlist != nil)
			tail-&gt;next = p;
		else
			uartlist = p;
		for(tail = p; tail-&gt;next != nil; tail = tail-&gt;next)
			uartnuart++;
		uartnuart++;
	}

	if(uartnuart) {
		uart = xalloc(uartnuart*sizeof(Uart*));
		if (uart == nil)
			panic("uartreset: no memory");
	}

	uartndir = 1 + 3*uartnuart;
	uartdir = xalloc(uartndir * sizeof(Dirtab));
	if (uartdir == nil)
		panic("uartreset: no memory");
	dp = uartdir;
	strcpy(dp-&gt;name, ".");
	mkqid(&amp;dp-&gt;qid, 0, 0, QTDIR);
	dp-&gt;length = 0;
	dp-&gt;perm = DMDIR|0555;
	dp++;
	p = uartlist;
	for(i = 0; i &lt; uartnuart; i++){
		/* 3 directory entries per port */
		snprint(dp-&gt;name, sizeof dp-&gt;name, "eia%d", i);
		dp-&gt;qid.path = NETQID(i, Ndataqid);
		dp-&gt;perm = 0660;
		dp++;
		snprint(dp-&gt;name, sizeof dp-&gt;name, "eia%dctl", i);
		dp-&gt;qid.path = NETQID(i, Nctlqid);
		dp-&gt;perm = 0660;
		dp++;
		snprint(dp-&gt;name, sizeof dp-&gt;name, "eia%dstatus", i);
		dp-&gt;qid.path = NETQID(i, Nstatqid);
		dp-&gt;perm = 0444;
		dp++;

		uart[i] = p;
		p-&gt;dev = i;
		if(p-&gt;console || p-&gt;special){
			if(uartenable(p) != nil){
				if(p-&gt;console){
					kbdq = p-&gt;iq;
					serialoq = p-&gt;oq;
					p-&gt;putc = kbdcr2nl;
				}
				p-&gt;opens++;
			}
		}
		p = p-&gt;next;
	}

	if(uartnuart){
		/*
		 * at 115200 baud, the 1024 char buffer takes 56 ms to process,
		 * processing it every 22 ms should be fine.
		 */
		uarttimer = addclock0link(uartclock, 22);
	}
}


static Chan*
uartattach(char *spec)
{
	return devattach('t', spec);
}

static Walkqid*
uartwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, uartdir, uartndir, devgen);
}

static int
uartstat(Chan *c, uchar *dp, int n)
{
	if(NETTYPE(c-&gt;qid.path) == Ndataqid)
		setlength(NETID(c-&gt;qid.path));
	return devstat(c, dp, n, uartdir, uartndir, devgen);
}

static Chan*
uartopen(Chan *c, int omode)
{
	Uart *p;

	c = devopen(c, omode, uartdir, uartndir, devgen);

	switch(NETTYPE(c-&gt;qid.path)){
	case Nctlqid:
	case Ndataqid:
		p = uart[NETID(c-&gt;qid.path)];
		qlock(p);
		if(p-&gt;opens++ == 0 &amp;&amp; uartenable(p) == nil){
			qunlock(p);
			c-&gt;flag &amp;= ~COPEN;
			error(Enodev);
		}
		qunlock(p);
		break;
	}

	c-&gt;iounit = qiomaxatomic;
	return c;
}

static int
uartdrained(void* arg)
{
	Uart *p;

	p = arg;
	return qlen(p-&gt;oq) == 0 &amp;&amp; p-&gt;op == p-&gt;oe;
}

static void
uartdrainoutput(Uart *p)
{
	if(!p-&gt;enabled)
		return;

	p-&gt;drain = 1;
	if(waserror()){
		p-&gt;drain = 0;
		nexterror();
	}
	sleep(&amp;p-&gt;r, uartdrained, p);
	poperror();
}

static void
uartclose(Chan *c)
{
	Uart *p;

	if(c-&gt;qid.type &amp; QTDIR)
		return;
	if((c-&gt;flag &amp; COPEN) == 0)
		return;
	switch(NETTYPE(c-&gt;qid.path)){
	case Ndataqid:
	case Nctlqid:
		p = uart[NETID(c-&gt;qid.path)];
		qlock(p);
		if(--(p-&gt;opens) == 0){
			qclose(p-&gt;iq);
			ilock(&amp;p-&gt;rlock);
			p-&gt;ir = p-&gt;iw = p-&gt;istage;
			iunlock(&amp;p-&gt;rlock);

			/*
			 */
			qhangup(p-&gt;oq, nil);
			if(!waserror()){
				uartdrainoutput(p);
				poperror();
			}
			qclose(p-&gt;oq);
			uartdisable(p);
			p-&gt;dcd = p-&gt;dsr = p-&gt;dohup = 0;
		}
		qunlock(p);
		break;
	}
}

static long
uartread(Chan *c, void *buf, long n, vlong off)
{
	Uart *p;
	ulong offset = off;

	if(c-&gt;qid.type &amp; QTDIR){
		setlength(-1);
		return devdirread(c, buf, n, uartdir, uartndir, devgen);
	}

	p = uart[NETID(c-&gt;qid.path)];
	switch(NETTYPE(c-&gt;qid.path)){
	case Ndataqid:
		return qread(p-&gt;iq, buf, n);
	case Nctlqid:
		return readnum(offset, buf, n, NETID(c-&gt;qid.path), NUMSIZE);
	case Nstatqid:
		return (*p-&gt;phys-&gt;status)(p, buf, n, offset);
	}

	return 0;
}

int
uartctl(Uart *p, char *cmd)
{
	char *f[16];
	int i, n, nf;

	nf = tokenize(cmd, f, nelem(f));
	for(i = 0; i &lt; nf; i++){
		if(strncmp(f[i], "break", 5) == 0){
			(*p-&gt;phys-&gt;dobreak)(p, 0);
			continue;
		}

		n = atoi(f[i]+1);
		switch(*f[i]){
		case 'B':
		case 'b':
			uartdrainoutput(p);
			if((*p-&gt;phys-&gt;baud)(p, n) &lt; 0)
				return -1;
			break;
		case 'C':
		case 'c':
			p-&gt;hup_dcd = n;
			break;
		case 'D':
		case 'd':
			uartdrainoutput(p);
			(*p-&gt;phys-&gt;dtr)(p, n);
			break;
		case 'E':
		case 'e':
			p-&gt;hup_dsr = n;
			break;
		case 'f':
		case 'F':
			if(p-&gt;oq != nil)
				qflush(p-&gt;oq);
			break;
		case 'H':
		case 'h':
			if(p-&gt;iq != nil)
				qhangup(p-&gt;iq, 0);
			if(p-&gt;oq != nil)
				qhangup(p-&gt;oq, 0);
			break;
		case 'i':
		case 'I':
			uartdrainoutput(p);
			(*p-&gt;phys-&gt;fifo)(p, n);
			break;
		case 'K':
		case 'k':
			uartdrainoutput(p);
			(*p-&gt;phys-&gt;dobreak)(p, n);
			break;
		case 'L':
		case 'l':
			uartdrainoutput(p);
			if((*p-&gt;phys-&gt;bits)(p, n) &lt; 0)
				return -1;
			break;
		case 'm':
		case 'M':
			uartdrainoutput(p);
			(*p-&gt;phys-&gt;modemctl)(p, n);
			break;
		case 'n':
		case 'N':
			if(p-&gt;oq != nil)
				qnoblock(p-&gt;oq, n);
			break;
		case 'P':
		case 'p':
			uartdrainoutput(p);
			if((*p-&gt;phys-&gt;parity)(p, *(f[i]+1)) &lt; 0)
				return -1;
			break;
		case 'Q':
		case 'q':
			if(p-&gt;iq != nil)
				qsetlimit(p-&gt;iq, n);
			if(p-&gt;oq != nil)
				qsetlimit(p-&gt;oq, n);
			break;
		case 'R':
		case 'r':
			uartdrainoutput(p);
			(*p-&gt;phys-&gt;rts)(p, n);
			break;
		case 'S':
		case 's':
			uartdrainoutput(p);
			if((*p-&gt;phys-&gt;stop)(p, n) &lt; 0)
				return -1;
			break;
		case 'W':
		case 'w':
			if(uarttimer == nil || n &lt; 1)
				return -1;
			uarttimer-&gt;tns = (vlong)n * 100000LL;
			break;
		case 'X':
		case 'x':
			if(p-&gt;enabled){
				ilock(&amp;p-&gt;tlock);
				p-&gt;xonoff = n;
				iunlock(&amp;p-&gt;tlock);
			}
			break;
		}
	}
	return 0;
}

static long
uartwrite(Chan *c, void *buf, long n, vlong)
{
	Uart *p;
	char *cmd;

	if(c-&gt;qid.type &amp; QTDIR)
		error(Eperm);

	p = uart[NETID(c-&gt;qid.path)];

	switch(NETTYPE(c-&gt;qid.path)){
	case Ndataqid:
		qlock(p);
		if(waserror()){
			qunlock(p);
			nexterror();
		}

		n = qwrite(p-&gt;oq, buf, n);

		qunlock(p);
		poperror();
		break;
	case Nctlqid:
		cmd = malloc(n+1);
		if(cmd == nil)
			error(Enomem);
		memmove(cmd, buf, n);
		cmd[n] = 0;
		qlock(p);
		if(waserror()){
			qunlock(p);
			free(cmd);
			nexterror();
		}

		/* let output drain */
		if(uartctl(p, cmd) &lt; 0)
			error(Ebadarg);

		qunlock(p);
		poperror();
		free(cmd);
		break;
	}

	return n;
}

static int
uartwstat(Chan *c, uchar *dp, int n)
{
	Dir d;
	Dirtab *dt;

	if(!iseve())
		error(Eperm);
	if(QTDIR &amp; c-&gt;qid.type)
		error(Eperm);
	if(NETTYPE(c-&gt;qid.path) == Nstatqid)
		error(Eperm);

	dt = &amp;uartdir[1 + 3 * NETID(c-&gt;qid.path)];
	n = convM2D(dp, n, &amp;d, nil);
	if(n == 0)
		error(Eshortstat);
	if(d.mode != ~0UL)
		dt[0].perm = dt[1].perm = d.mode;
	return n;
}

void
uartpower(int on)
{
	Uart *p;

	for(p = uartlist; p != nil; p = p-&gt;next) {
		if(p-&gt;phys-&gt;power)
			(*p-&gt;phys-&gt;power)(p, on);
	}
}

Dev uartdevtab = {
	't',
	"uart",

	uartreset,
	devinit,
	devshutdown,
	uartattach,
	uartwalk,
	uartstat,
	uartopen,
	devcreate,
	uartclose,
	uartread,
	devbread,
	uartwrite,
	devbwrite,
	devremove,
	uartwstat,
	uartpower,
};

/*
 *  restart input if it's off
 */
static void
uartflow(void *v)
{
	Uart *p;

	p = v;
	if(p-&gt;modem)
		(*p-&gt;phys-&gt;rts)(p, 1);
}

/*
 *  put some bytes into the local queue to avoid calling
 *  qconsume for every character
 */
int
uartstageoutput(Uart *p)
{
	int n;

	n = qconsume(p-&gt;oq, p-&gt;ostage, Stagesize);
	if(n &lt;= 0)
		return 0;
	p-&gt;op = p-&gt;ostage;
	p-&gt;oe = p-&gt;ostage + n;
	return n;
}

/*
 *  restart output
 */
void
uartkick(void *v)
{
	Uart *p = v;

	if(p-&gt;blocked)
		return;

	ilock(&amp;p-&gt;tlock);
	(*p-&gt;phys-&gt;kick)(p);
	iunlock(&amp;p-&gt;tlock);

	if(p-&gt;drain &amp;&amp; uartdrained(p)){
		p-&gt;drain = 0;
		wakeup(&amp;p-&gt;r);
	}
}

/*
 * Move data from the interrupt staging area to
 * the input Queue.
 */
static void
uartstageinput(Uart *p)
{
	int n;
	uchar *ir, *iw;

	while(p-&gt;ir != p-&gt;iw){
		ir = p-&gt;ir;
		if(p-&gt;ir &gt; p-&gt;iw){
			iw = p-&gt;ie;
			p-&gt;ir = p-&gt;istage;
		}
		else{
			iw = p-&gt;iw;
			p-&gt;ir = p-&gt;iw;
		}
		if((n = qproduce(p-&gt;iq, ir, iw - ir)) &lt; 0){
			p-&gt;serr++;
			(*p-&gt;phys-&gt;rts)(p, 0);
		}
		else if(n == 0)
			p-&gt;berr++;
	}
}

/*
 *  receive a character at interrupt time
 */
void
uartrecv(Uart *p,  char ch)
{
	uchar *next;

	/* software flow control */
	if(p-&gt;xonoff){
		if(ch == CTLS){
			p-&gt;blocked = 1;
		}else if(ch == CTLQ){
			p-&gt;blocked = 0;
			p-&gt;ctsbackoff = 2; /* clock gets output going again */
		}
	}

	/* receive the character */
	if(p-&gt;putc)
		p-&gt;putc(p-&gt;iq, ch);
	else if (p-&gt;iw) {		/* maybe the line isn't enabled yet */
		ilock(&amp;p-&gt;rlock);
		next = p-&gt;iw + 1;
		if(next == p-&gt;ie)
			next = p-&gt;istage;
		if(next == p-&gt;ir)
			uartstageinput(p);
		if(next != p-&gt;ir){
			*p-&gt;iw = ch;
			p-&gt;iw = next;
		}
		iunlock(&amp;p-&gt;rlock);
	}
}

/*
 *  we save up input characters till clock time to reduce
 *  per character interrupt overhead.
 */
static void
uartclock(void)
{
	Uart *p;

	ilock(&amp;uartalloc);
	for(p = uartalloc.elist; p; p = p-&gt;elist){

		/* this hopefully amortizes cost of qproduce to many chars */
		if(p-&gt;iw != p-&gt;ir){
			ilock(&amp;p-&gt;rlock);
			uartstageinput(p);
			iunlock(&amp;p-&gt;rlock);
		}

		/* hang up if requested */
		if(p-&gt;dohup){
			qhangup(p-&gt;iq, 0);
			qhangup(p-&gt;oq, 0);
			p-&gt;dohup = 0;
		}

		/* this adds hysteresis to hardware/software flow control */
		if(p-&gt;ctsbackoff){
			ilock(&amp;p-&gt;tlock);
			if(p-&gt;ctsbackoff){
				if(--(p-&gt;ctsbackoff) == 0)
					(*p-&gt;phys-&gt;kick)(p);
			}
			iunlock(&amp;p-&gt;tlock);
		}
	}
	iunlock(&amp;uartalloc);
}

/*
 * polling console input, output
 */

Uart* consuart;

int
uartgetc(void)
{
	if(consuart == nil || consuart-&gt;phys-&gt;getc == nil)
		return -1;
	return consuart-&gt;phys-&gt;getc(consuart);
}

void
uartputc(int c)
{
	char c2;

	if(consuart == nil || consuart-&gt;phys-&gt;putc == nil) {
		c2 = c;
		if (lprint)
			(*lprint)(&amp;c2, 1);
		return;
	}
	consuart-&gt;phys-&gt;putc(consuart, c);
}

void
uartputs(char *s, int n)
{
	char *e;

	if(consuart == nil || consuart-&gt;phys-&gt;putc == nil) {
		if (lprint)
			(*lprint)(s, n);
		return;
	}
	e = s+n;
	for(; s&lt;e; s++){
		if(*s == '\n')
			consuart-&gt;phys-&gt;putc(consuart, '\r');
		consuart-&gt;phys-&gt;putc(consuart, *s);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

