<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/fpimem.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/fpimem.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "fpi.h"

/*
 * the following routines depend on memory format, not the machine
 */

enum {
	Sign	= 1u &lt;&lt; 31,
};

void
fpis2i(Internal *i, void *v)
{
	Single *s = v;

	i-&gt;s = (*s &amp; Sign) ? 1: 0;
	if((*s &amp; ~Sign) == 0){
		SetZero(i);
		return;
	}
	i-&gt;e = ((*s&gt;&gt;23) &amp; 0x00FF) - SingleExpBias + ExpBias;
	i-&gt;h = (*s &amp; 0x007FFFFF)&lt;&lt;(1+NGuardBits);
	i-&gt;l = 0;
	if(i-&gt;e)
		i-&gt;h |= HiddenBit;
	else
		i-&gt;e++;
}

void
fpid2i(Internal *i, void *v)
{
	Double *d = v;

	i-&gt;s = (d-&gt;h &amp; Sign) ? 1: 0;
	i-&gt;e = (d-&gt;h&gt;&gt;20) &amp; 0x07FF;
	i-&gt;h = ((d-&gt;h &amp; 0x000FFFFF)&lt;&lt;(4+NGuardBits))|((d-&gt;l&gt;&gt;25) &amp; 0x7F);
	i-&gt;l = (d-&gt;l &amp; 0x01FFFFFF)&lt;&lt;NGuardBits;
	if(i-&gt;e)
		i-&gt;h |= HiddenBit;
	else
		i-&gt;e++;
}

void
fpiw2i(Internal *i, void *v)
{
	Word w, word = *(Word*)v;
	short e;

	if(word &lt; 0){
		i-&gt;s = 1;
		word = -word;
	}
	else
		i-&gt;s = 0;
	if(word == 0){
		SetZero(i);
		return;
	}
	if(word &gt; 0){
		for (e = 0, w = word; w; w &gt;&gt;= 1, e++)
			;
	} else
		e = 32;
	if(e &gt; FractBits){
		i-&gt;h = word&gt;&gt;(e - FractBits);
		i-&gt;l = (word &amp; ((1&lt;&lt;(e - FractBits)) - 1))&lt;&lt;(2*FractBits - e);
	}
	else {
		i-&gt;h = word&lt;&lt;(FractBits - e);
		i-&gt;l = 0;
	}
	i-&gt;e = (e - 1) + ExpBias;
}

void
fpiv2i(Internal *i, void *v)
{
	Vlong w, word = *(Vlong*)v;
	short e;

	if(word &lt; 0){
		i-&gt;s = 1;
		word = -word;
	}
	else
		i-&gt;s = 0;
	if(word == 0){
		SetZero(i);
		return;
	}
	if(word &gt; 0){
		for (e = 0, w = word; w; w &gt;&gt;= 1, e++)
			;
	} else
		e = 64;
	if(e &gt; FractBits){
		i-&gt;h = word&gt;&gt;(e - FractBits);
		i-&gt;l = (word &amp; ((1&lt;&lt;(e - FractBits)) - 1))&lt;&lt;(2*FractBits - e);
	}
	else {
		i-&gt;h = word&lt;&lt;(FractBits - e);
		i-&gt;l = 0;
	}
	i-&gt;e = (e - 1) + ExpBias;
}

/*
 * Note that all of these conversions from Internal format
 * potentially alter *i, so it should be a disposable copy
 * of the value to be converted.
 */

void
fpii2s(void *v, Internal *i)
{
	short e;
	Single *s = (Single*)v;

	fpiround(i);
	if(i-&gt;h &amp; HiddenBit)
		i-&gt;h &amp;= ~HiddenBit;
	else
		i-&gt;e--;
	*s = i-&gt;s ? Sign: 0;
	e = i-&gt;e;
	if(e &lt; ExpBias){
		if(e &lt;= (ExpBias - SingleExpBias))
			return;
		e = SingleExpBias - (ExpBias - e);
	}
	else  if(e &gt;= (ExpBias + (SingleExpMax-SingleExpBias))){
		*s |= SingleExpMax&lt;&lt;23;
		return;
	}
	else
		e = SingleExpBias + (e - ExpBias);
	*s |= (e&lt;&lt;23)|(i-&gt;h&gt;&gt;(1+NGuardBits));
}

void
fpii2d(void *v, Internal *i)
{
	Double *d = (Double*)v;

	fpiround(i);
	if(i-&gt;h &amp; HiddenBit)
		i-&gt;h &amp;= ~HiddenBit;
	else
		i-&gt;e--;
	i-&gt;l = ((i-&gt;h &amp; GuardMask)&lt;&lt;25)|(i-&gt;l&gt;&gt;NGuardBits);
	i-&gt;h &gt;&gt;= NGuardBits;
	d-&gt;h = i-&gt;s ? Sign: 0;
	d-&gt;h |= (i-&gt;e&lt;&lt;20)|((i-&gt;h &amp; 0x00FFFFFF)&gt;&gt;4);
	d-&gt;l = (i-&gt;h&lt;&lt;28)|i-&gt;l;
}

void
fpii2w(Word *word, Internal *i)
{
	Word w;
	short e;

	fpiround(i);
	e = (i-&gt;e - ExpBias) + 1;
	if(e &lt;= 0)
		w = 0;
	else if(e &gt; 31)
		w = 0x7FFFFFFF;
	else if(e &gt; FractBits)
		w = (i-&gt;h&lt;&lt;(e - FractBits))|(i-&gt;l&gt;&gt;(2*FractBits - e));
	else
		w = i-&gt;h&gt;&gt;(FractBits-e);
	if(i-&gt;s)
		w = -w;
	*word = w;
}

void
fpii2v(Vlong *word, Internal *i)
{
	Vlong w;
	short e;

	fpiround(i);
	e = (i-&gt;e - ExpBias) + 1;
	if(e &lt;= 0)
		w = 0;
	else if(e &gt; 63)
		w = (1ull&lt;&lt;63) - 1;		/* maxlong */
	else if(e &gt; FractBits)
		w = (Vlong)i-&gt;h&lt;&lt;(e - FractBits) | i-&gt;l&gt;&gt;(2*FractBits - e);
	else
		w = i-&gt;h&gt;&gt;(FractBits-e);
	if(i-&gt;s)
		w = -w;
	*word = w;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

