<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/portclock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/portclock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

enum {
	Maxtimerloops = 20*1000,
};

struct Timers
{
	Lock;
	Timer	*head;
};

static Timers timers[MAXMACH];
static int timersinited;

ulong intrcount[MAXMACH];
ulong fcallcount[MAXMACH];

static vlong
tadd(Timers *tt, Timer *nt)
{
	Timer *t, **last;

	/* Called with tt locked */
	assert(nt-&gt;tt == nil);
	switch(nt-&gt;tmode){
	default:
		panic("timer");
		break;
	case Trelative:
		if(nt-&gt;tns &lt;= 0)
			nt-&gt;tns = 1;
		nt-&gt;twhen = fastticks(nil) + ns2fastticks(nt-&gt;tns);
		break;
	case Tperiodic:
		assert(nt-&gt;tns &gt;= 100000);	/* At least 100 µs period */
		if(nt-&gt;twhen == 0){
			/* look for another timer at same frequency for combining */
			for(t = tt-&gt;head; t; t = t-&gt;tnext){
				if(t-&gt;tmode == Tperiodic &amp;&amp; t-&gt;tns == nt-&gt;tns)
					break;
			}
			if (t)
				nt-&gt;twhen = t-&gt;twhen;
			else
				nt-&gt;twhen = fastticks(nil);
		}
		nt-&gt;twhen += ns2fastticks(nt-&gt;tns);
		break;
	}

	for(last = &amp;tt-&gt;head; t = *last; last = &amp;t-&gt;tnext){
		if(t-&gt;twhen &gt; nt-&gt;twhen)
			break;
	}
	nt-&gt;tnext = *last;
	*last = nt;
	nt-&gt;tt = tt;
	if(last == &amp;tt-&gt;head)
		return nt-&gt;twhen;
	return 0;
}

static uvlong
tdel(Timer *dt)
{

	Timer *t, **last;
	Timers *tt;

	tt = dt-&gt;tt;
	if (tt == nil)
		return 0;
	for(last = &amp;tt-&gt;head; t = *last; last = &amp;t-&gt;tnext){
		if(t == dt){
			assert(dt-&gt;tt);
			dt-&gt;tt = nil;
			*last = t-&gt;tnext;
			break;
		}
	}
	if(last == &amp;tt-&gt;head &amp;&amp; tt-&gt;head)
		return tt-&gt;head-&gt;twhen;
	return 0;
}

/* add or modify a timer */
void
timeradd(Timer *nt)
{
	Timers *tt;
	vlong when;

	/* Must lock Timer struct before Timers struct */
	ilock(nt);
	if(tt = nt-&gt;tt){
		ilock(tt);
		tdel(nt);
		iunlock(tt);
	}
	tt = &amp;timers[m-&gt;machno];
	ilock(tt);
	when = tadd(tt, nt);
	if(when)
		timerset(when);
	iunlock(tt);
	iunlock(nt);
}


void
timerdel(Timer *dt)
{
	Timers *tt;
	uvlong when;

	ilock(dt);
	if(tt = dt-&gt;tt){
		ilock(tt);
		when = tdel(dt);
		if(when &amp;&amp; tt == &amp;timers[m-&gt;machno])
			timerset(tt-&gt;head-&gt;twhen);
		iunlock(tt);
	}
	iunlock(dt);
}

void
hzclock(Ureg *ur)
{
	m-&gt;ticks++;
	if(m-&gt;proc)
		m-&gt;proc-&gt;pc = ur-&gt;pc;

	if(m-&gt;flushmmu){
		if(up)
			flushmmu();
		m-&gt;flushmmu = 0;
	}

	accounttime();
	kmapinval();

	if(kproftimer != nil)
		kproftimer(ur-&gt;pc);

	if((active.machs&amp;(1&lt;&lt;m-&gt;machno)) == 0)
		return;

	if(active.exiting) {
		print("someone's exiting\n");
		exit(0);
	}

	checkalarms();

	if(up &amp;&amp; up-&gt;state == Running)
		hzsched();	/* in proc.c */
}

void
timerintr(Ureg *u, Tval)
{
	Timer *t;
	Timers *tt;
	uvlong when, now;
	int count, callhzclock;

	intrcount[m-&gt;machno]++;
	callhzclock = 0;
	tt = &amp;timers[m-&gt;machno];
	now = fastticks(nil);
	if(now == 0)
		panic("timerintr: zero fastticks()");
	ilock(tt);
	count = Maxtimerloops;
	while((t = tt-&gt;head) != nil){
		/*
		 * No need to ilock t here: any manipulation of t
		 * requires tdel(t) and this must be done with a
		 * lock to tt held.  We have tt, so the tdel will
		 * wait until we're done
		 */
		when = t-&gt;twhen;
		if(when &gt; now){
			timerset(when);
			iunlock(tt);
			if(callhzclock)
				hzclock(u);
			return;
		}
		tt-&gt;head = t-&gt;tnext;
		assert(t-&gt;tt == tt);
		t-&gt;tt = nil;
		fcallcount[m-&gt;machno]++;
		iunlock(tt);
		if(t-&gt;tf)
			(*t-&gt;tf)(u, t);
		else
			callhzclock++;
		ilock(tt);
		if(t-&gt;tmode == Tperiodic)
			tadd(tt, t);
		if (--count &lt;= 0) {
			count = Maxtimerloops;
			iprint("timerintr: probably stuck in while loop; "
				"scrutinise clock.c or use faster cycle "
				"counter\n");
		}
	}
	iunlock(tt);
}

void
timersinit(void)
{
	Timer *t;

	/*
	 * T-&gt;tf == nil means the HZ clock for this processor.
	 */
	timersinited = 1;
	todinit();
	t = malloc(sizeof(*t));
	if(t == nil)
		error(Enomem);
	t-&gt;tmode = Tperiodic;
	t-&gt;tt = nil;
	t-&gt;tns = 1000000000/HZ;
	t-&gt;tf = nil;
	timeradd(t);
}

Timer*
addclock0link(void (*f)(void), int ms)
{
	Timer *nt;
	uvlong when;

	if(!timersinited)
		panic("addclock0link: timersinit not called yet");
	/* Synchronize to hztimer if ms is 0 */
	nt = malloc(sizeof(Timer));
	if(nt == nil)
		error(Enomem);
	if(ms == 0)
		ms = 1000/HZ;
	nt-&gt;tns = (vlong)ms*1000000LL;
	nt-&gt;tmode = Tperiodic;
	nt-&gt;tt = nil;
	nt-&gt;tf = (void (*)(Ureg*, Timer*))f;

	ilock(&amp;timers[0]);
	when = tadd(&amp;timers[0], nt);
	if(when)
		timerset(when);
	iunlock(&amp;timers[0]);
	return nt;
}

/*
 *  This tk2ms avoids overflows that the macro version is prone to.
 *  It is a LOT slower so shouldn't be used if you're just converting
 *  a delta.
 */
ulong
tk2ms(ulong ticks)
{
	uvlong t, hz;

	t = ticks;
	hz = HZ;
	t *= 1000L;
	t = t/hz;
	ticks = t;
	return ticks;
}

ulong
ms2tk(ulong ms)
{
	/* avoid overflows at the cost of precision */
	if(ms &gt;= 1000000000/HZ)
		return (ms/1000)*HZ;
	return (ms*HZ+500)/1000;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

