<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/proc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/proc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"
#include	"../port/edf.h"
#include	&lt;trace.h&gt;

int	schedgain = 30;	/* units in seconds */
int	nrdy;
Ref	noteidalloc;

void updatecpu(Proc*);
int reprioritize(Proc*);

ulong	delayedscheds;	/* statistics */
long skipscheds;
long preempts;
ulong load;

static Ref	pidalloc;

static struct Procalloc
{
	Lock;
	Proc*	ht[128];
	Proc*	arena;
	Proc*	free;
} procalloc;

enum
{
	Q=10,
	DQ=4,
	Scaling=2,
};

Schedq	runq[Nrq];
ulong	runvec;

char *statename[] =
{	/* BUG: generate automatically */
	"Dead",
	"Moribund",
	"Ready",
	"Scheding",
	"Running",
	"Queueing",
	"QueueingR",
	"QueueingW",
	"Wakeme",
	"Broken",
	"Stopped",
	"Rendez",
	"Waitrelease",
};

static void pidhash(Proc*);
static void pidunhash(Proc*);
static void rebalance(void);

/*
 * Always splhi()'ed.
 */
void
schedinit(void)		/* never returns */
{
	Edf *e;

	setlabel(&amp;m-&gt;sched);
	if(up) {
		if((e = up-&gt;edf) &amp;&amp; (e-&gt;flags &amp; Admitted))
			edfrecord(up);
		m-&gt;proc = 0;
		switch(up-&gt;state) {
		case Running:
			ready(up);
			break;
		case Moribund:
			up-&gt;state = Dead;
			edfstop(up);
			if (up-&gt;edf)
				free(up-&gt;edf);
			up-&gt;edf = nil;

			/*
			 * Holding locks from pexit:
			 * 	procalloc
			 *	palloc
			 */
			mmurelease(up);

			up-&gt;qnext = procalloc.free;
			procalloc.free = up;

			unlock(&amp;palloc);
			unlock(&amp;procalloc);
			break;
		}
		up-&gt;mach = nil;
		updatecpu(up);
		up = nil;
	}
	sched();
}

/*
 *  If changing this routine, look also at sleep().  It
 *  contains a copy of the guts of sched().
 */
void
sched(void)
{
	Proc *p;

	if(m-&gt;ilockdepth)
		panic("cpu%d: ilockdepth %d, last lock %#p at %#p, sched called from %#p",
			m-&gt;machno,
			m-&gt;ilockdepth,
			up? up-&gt;lastilock: nil,
			(up &amp;&amp; up-&gt;lastilock)? up-&gt;lastilock-&gt;pc: 0,
			getcallerpc(&amp;p+2));
	if(up){
		/*
		 * Delay the sched until the process gives up the locks
		 * it is holding.  This avoids dumb lock loops.
		 * Don't delay if the process is Moribund.
		 * It called sched to die.
		 * But do sched eventually.  This avoids a missing unlock
		 * from hanging the entire kernel. 
		 * But don't reschedule procs holding palloc or procalloc.
		 * Those are far too important to be holding while asleep.
		 *
		 * This test is not exact.  There can still be a few instructions
		 * in the middle of taslock when a process holds a lock
		 * but Lock.p has not yet been initialized.
		 */
		if(up-&gt;nlocks.ref)
		if(up-&gt;state != Moribund)
		if(up-&gt;delaysched &lt; 20
		|| palloc.Lock.p == up
		|| procalloc.Lock.p == up){
			up-&gt;delaysched++;
 			delayedscheds++;
			return;
		}
		up-&gt;delaysched = 0;

		splhi();

		/* statistics */
		m-&gt;cs++;

		procsave(up);
		if(setlabel(&amp;up-&gt;sched)){
			procrestore(up);
			spllo();
			return;
		}
		gotolabel(&amp;m-&gt;sched);
	}
	p = runproc();
	if(!p-&gt;edf){
		updatecpu(p);
		p-&gt;priority = reprioritize(p);
	}
	if(p != m-&gt;readied)
		m-&gt;schedticks = m-&gt;ticks + HZ/10;
	m-&gt;readied = 0;
	up = p;
	up-&gt;state = Running;
	up-&gt;mach = MACHP(m-&gt;machno);
	m-&gt;proc = up;
	mmuswitch(up);
	gotolabel(&amp;up-&gt;sched);
}

int
anyready(void)
{
	return runvec;
}

int
anyhigher(void)
{
	return runvec &amp; ~((1&lt;&lt;(up-&gt;priority+1))-1);
}

/*
 *  here once per clock tick to see if we should resched
 */
void
hzsched(void)
{
	/* once a second, rebalance will reprioritize ready procs */
	if(m-&gt;machno == 0)
		rebalance();

	/* unless preempted, get to run for at least 100ms */
	if(anyhigher()
	|| (!up-&gt;fixedpri &amp;&amp; m-&gt;ticks &gt; m-&gt;schedticks &amp;&amp; anyready())){
		m-&gt;readied = nil;	/* avoid cooperative scheduling */
		up-&gt;delaysched++;
	}
}

/*
 *  here at the end of non-clock interrupts to see if we should preempt the
 *  current process.  Returns 1 if preempted, 0 otherwise.
 */
int
preempted(void)
{
	if(up &amp;&amp; up-&gt;state == Running)
	if(up-&gt;preempted == 0)
	if(anyhigher())
	if(!active.exiting){
		m-&gt;readied = nil;	/* avoid cooperative scheduling */
		up-&gt;preempted = 1;
		sched();
		splhi();
		up-&gt;preempted = 0;
		return 1;
	}
	return 0;
}

/*
 * Update the cpu time average for this particular process,
 * which is about to change from up -&gt; not up or vice versa.
 * p-&gt;lastupdate is the last time an updatecpu happened.
 *
 * The cpu time average is a decaying average that lasts
 * about D clock ticks.  D is chosen to be approximately
 * the cpu time of a cpu-intensive "quick job".  A job has to run
 * for approximately D clock ticks before we home in on its 
 * actual cpu usage.  Thus if you manage to get in and get out
 * quickly, you won't be penalized during your burst.  Once you
 * start using your share of the cpu for more than about D
 * clock ticks though, your p-&gt;cpu hits 1000 (1.0) and you end up 
 * below all the other quick jobs.  Interactive tasks, because
 * they basically always use less than their fair share of cpu,
 * will be rewarded.
 *
 * If the process has not been running, then we want to
 * apply the filter
 *
 *	cpu = cpu * (D-1)/D
 *
 * n times, yielding 
 * 
 *	cpu = cpu * ((D-1)/D)^n
 *
 * but D is big enough that this is approximately 
 *
 * 	cpu = cpu * (D-n)/D
 *
 * so we use that instead.
 * 
 * If the process has been running, we apply the filter to
 * 1 - cpu, yielding a similar equation.  Note that cpu is 
 * stored in fixed point (* 1000).
 *
 * Updatecpu must be called before changing up, in order
 * to maintain accurate cpu usage statistics.  It can be called
 * at any time to bring the stats for a given proc up-to-date.
 */
void
updatecpu(Proc *p)
{
	int n, t, ocpu;
	int D = schedgain*HZ*Scaling;

	if(p-&gt;edf)
		return;

	t = MACHP(0)-&gt;ticks*Scaling + Scaling/2;
	n = t - p-&gt;lastupdate;
	p-&gt;lastupdate = t;

	if(n == 0)
		return;
	if(n &gt; D)
		n = D;

	ocpu = p-&gt;cpu;
	if(p != up)
		p-&gt;cpu = (ocpu*(D-n))/D;
	else{
		t = 1000 - ocpu;
		t = (t*(D-n))/D;
		p-&gt;cpu = 1000 - t;
	}

//iprint("pid %d %s for %d cpu %d -&gt; %d\n", p-&gt;pid,p==up?"active":"inactive",n, ocpu,p-&gt;cpu);
}

/*
 * On average, p has used p-&gt;cpu of a cpu recently.
 * Its fair share is conf.nmach/m-&gt;load of a cpu.  If it has been getting
 * too much, penalize it.  If it has been getting not enough, reward it.
 * I don't think you can get much more than your fair share that 
 * often, so most of the queues are for using less.  Having a priority
 * of 3 means you're just right.  Having a higher priority (up to p-&gt;basepri) 
 * means you're not using as much as you could.
 */
int
reprioritize(Proc *p)
{
	int fairshare, n, load, ratio;

	load = MACHP(0)-&gt;load;
	if(load == 0)
		return p-&gt;basepri;

	/*
	 *  fairshare = 1.000 * conf.nproc * 1.000/load,
	 * except the decimal point is moved three places
	 * on both load and fairshare.
	 */
	fairshare = (conf.nmach*1000*1000)/load;
	n = p-&gt;cpu;
	if(n == 0)
		n = 1;
	ratio = (fairshare+n/2) / n;
	if(ratio &gt; p-&gt;basepri)
		ratio = p-&gt;basepri;
	if(ratio &lt; 0)
		panic("reprioritize");
//iprint("pid %d cpu %d load %d fair %d pri %d\n", p-&gt;pid, p-&gt;cpu, load, fairshare, ratio);
	return ratio;
}

/*
 * add a process to a scheduling queue
 */
void
queueproc(Schedq *rq, Proc *p)
{
	int pri;

	pri = rq - runq;
	lock(runq);
	p-&gt;priority = pri;
	p-&gt;rnext = 0;
	if(rq-&gt;tail)
		rq-&gt;tail-&gt;rnext = p;
	else
		rq-&gt;head = p;
	rq-&gt;tail = p;
	rq-&gt;n++;
	nrdy++;
	runvec |= 1&lt;&lt;pri;
	unlock(runq);
}

/*
 *  try to remove a process from a scheduling queue (called splhi)
 */
Proc*
dequeueproc(Schedq *rq, Proc *tp)
{
	Proc *l, *p;

	if(!canlock(runq))
		return nil;

	/*
	 *  the queue may have changed before we locked runq,
	 *  refind the target process.
	 */
	l = 0;
	for(p = rq-&gt;head; p; p = p-&gt;rnext){
		if(p == tp)
			break;
		l = p;
	}

	/*
	 *  p-&gt;mach==0 only when process state is saved
	 */
	if(p == 0 || p-&gt;mach){
		unlock(runq);
		return nil;
	}
	if(p-&gt;rnext == 0)
		rq-&gt;tail = l;
	if(l)
		l-&gt;rnext = p-&gt;rnext;
	else
		rq-&gt;head = p-&gt;rnext;
	if(rq-&gt;head == nil)
		runvec &amp;= ~(1&lt;&lt;(rq-runq));
	rq-&gt;n--;
	nrdy--;
	if(p-&gt;state != Ready)
		print("dequeueproc %s %lud %s\n", p-&gt;text, p-&gt;pid, statename[p-&gt;state]);

	unlock(runq);
	return p;
}

/*
 *  ready(p) picks a new priority for a process and sticks it in the
 *  runq for that priority.
 */
void
ready(Proc *p)
{
	int s, pri;
	Schedq *rq;
	void (*pt)(Proc*, int, vlong);

	s = splhi();
	if(edfready(p)){
		splx(s);
		return;
	}

	if(up != p &amp;&amp; (p-&gt;wired == nil || p-&gt;wired == m))
		m-&gt;readied = p;	/* group scheduling */

	updatecpu(p);
	pri = reprioritize(p);
	p-&gt;priority = pri;
	rq = &amp;runq[pri];
	p-&gt;state = Ready;
	queueproc(rq, p);
	pt = proctrace;
	if(pt)
		pt(p, SReady, 0);
	splx(s);
}

/*
 *  yield the processor and drop our priority
 */
void
yield(void)
{
	if(anyready()){
		/* pretend we just used 1/2 tick */
		up-&gt;lastupdate -= Scaling/2;  
		sched();
	}
}

/*
 *  recalculate priorities once a second.  We need to do this
 *  since priorities will otherwise only be recalculated when
 *  the running process blocks.
 */
ulong balancetime;

static void
rebalance(void)
{
	int pri, npri, t, x;
	Schedq *rq;
	Proc *p;

	t = m-&gt;ticks;
	if(t - balancetime &lt; HZ)
		return;
	balancetime = t;

	for(pri=0, rq=runq; pri&lt;Npriq; pri++, rq++){
another:
		p = rq-&gt;head;
		if(p == nil)
			continue;
		if(p-&gt;mp != MACHP(m-&gt;machno))
			continue;
		if(pri == p-&gt;basepri)
			continue;
		updatecpu(p);
		npri = reprioritize(p);
		if(npri != pri){
			x = splhi();
			p = dequeueproc(rq, p);
			if(p)
				queueproc(&amp;runq[npri], p);
			splx(x);
			goto another;
		}
	}
}
	

/*
 *  pick a process to run
 */
Proc*
runproc(void)
{
	Schedq *rq;
	Proc *p;
	ulong start, now;
	int i;
	void (*pt)(Proc*, int, vlong);

	start = perfticks();

	/* cooperative scheduling until the clock ticks */
	if((p=m-&gt;readied) &amp;&amp; p-&gt;mach==0 &amp;&amp; p-&gt;state==Ready
	&amp;&amp; (p-&gt;wired == nil || p-&gt;wired == m)
	&amp;&amp; runq[Nrq-1].head == nil &amp;&amp; runq[Nrq-2].head == nil){
		skipscheds++;
		rq = &amp;runq[p-&gt;priority];
		goto found;
	}

	preempts++;

loop:
	/*
	 *  find a process that last ran on this processor (affinity),
	 *  or one that hasn't moved in a while (load balancing).  Every
	 *  time around the loop affinity goes down.
	 */
	spllo();
	for(i = 0;; i++){
		/*
		 *  find the highest priority target process that this
		 *  processor can run given affinity constraints.
		 *
		 */
		for(rq = &amp;runq[Nrq-1]; rq &gt;= runq; rq--){
			for(p = rq-&gt;head; p; p = p-&gt;rnext){
				if(p-&gt;mp == nil || p-&gt;mp == MACHP(m-&gt;machno)
				|| (!p-&gt;wired &amp;&amp; i &gt; 0))
					goto found;
			}
		}

		/* waste time or halt the CPU */
		idlehands();

		/* remember how much time we're here */
		now = perfticks();
		m-&gt;perf.inidle += now-start;
		start = now;
	}

found:
	splhi();
	p = dequeueproc(rq, p);
	if(p == nil)
		goto loop;

	p-&gt;state = Scheding;
	p-&gt;mp = MACHP(m-&gt;machno);

	if(edflock(p)){
		edfrun(p, rq == &amp;runq[PriEdf]);	/* start deadline timer and do admin */
		edfunlock();
	}
	pt = proctrace;
	if(pt)
		pt(p, SRun, 0);
	return p;
}

int
canpage(Proc *p)
{
	int ok = 0;

	splhi();
	lock(runq);
	/* Only reliable way to see if we are Running */
	if(p-&gt;mach == 0) {
		p-&gt;newtlb = 1;
		ok = 1;
	}
	unlock(runq);
	spllo();

	return ok;
}

void
noprocpanic(char *msg)
{
	/*
	 * setting exiting will make hzclock() on each processor call exit(0).
	 * clearing our bit in machs avoids calling exit(0) from hzclock()
	 * on this processor.
	 */
	lock(&amp;active);
	active.machs &amp;= ~(1&lt;&lt;m-&gt;machno);
	active.exiting = 1;
	unlock(&amp;active);

	procdump();
	delay(1000);
	panic(msg);
}

Proc*
newproc(void)
{
	char msg[64];
	Proc *p;

	lock(&amp;procalloc);
	while((p = procalloc.free) == nil) {
		unlock(&amp;procalloc);

		snprint(msg, sizeof msg, "no procs; %s forking",
			up? up-&gt;text: "kernel");
		/*
		 * the situation is unlikely to heal itself.
		 * dump the proc table and restart by default.
		 * *noprocspersist in plan9.ini will yield the old
		 * behaviour of trying forever.
		 */
		if(getconf("*noprocspersist") == nil)
			noprocpanic(msg);
		resrcwait(msg);
		lock(&amp;procalloc);
	}
	procalloc.free = p-&gt;qnext;
	unlock(&amp;procalloc);

	p-&gt;state = Scheding;
	p-&gt;psstate = "New";
	p-&gt;mach = 0;
	p-&gt;qnext = 0;
	p-&gt;nchild = 0;
	p-&gt;nwait = 0;
	p-&gt;waitq = 0;
	p-&gt;parent = 0;
	p-&gt;pgrp = 0;
	p-&gt;egrp = 0;
	p-&gt;fgrp = 0;
	p-&gt;rgrp = 0;
	p-&gt;pdbg = 0;
	p-&gt;fpstate = FPinit;
	p-&gt;kp = 0;
	if(up &amp;&amp; up-&gt;procctl == Proc_tracesyscall)
		p-&gt;procctl = Proc_tracesyscall;
	else
		p-&gt;procctl = 0;
	p-&gt;syscalltrace = 0;	
	p-&gt;notepending = 0;
	p-&gt;ureg = 0;
	p-&gt;privatemem = 0;
	p-&gt;noswap = 0;
	p-&gt;errstr = p-&gt;errbuf0;
	p-&gt;syserrstr = p-&gt;errbuf1;
	p-&gt;errbuf0[0] = '\0';
	p-&gt;errbuf1[0] = '\0';
	p-&gt;nlocks.ref = 0;
	p-&gt;delaysched = 0;
	p-&gt;trace = 0;
	kstrdup(&amp;p-&gt;user, "*nouser");
	kstrdup(&amp;p-&gt;text, "*notext");
	kstrdup(&amp;p-&gt;args, "");
	p-&gt;nargs = 0;
	p-&gt;setargs = 0;
	memset(p-&gt;seg, 0, sizeof p-&gt;seg);
	p-&gt;pid = incref(&amp;pidalloc);
	pidhash(p);
	p-&gt;noteid = incref(&amp;noteidalloc);
	if(p-&gt;pid==0 || p-&gt;noteid==0)
		panic("pidalloc");
	if(p-&gt;kstack == 0)
		p-&gt;kstack = smalloc(KSTACK);

	/* sched params */
	p-&gt;mp = 0;
	p-&gt;wired = 0;
	procpriority(p, PriNormal, 0);
	p-&gt;cpu = 0;
	p-&gt;lastupdate = MACHP(0)-&gt;ticks*Scaling;
	p-&gt;edf = nil;

	return p;
}

/*
 * wire this proc to a machine
 */
void
procwired(Proc *p, int bm)
{
	Proc *pp;
	int i;
	char nwired[MAXMACH];
	Mach *wm;

	if(bm &lt; 0){
		/* pick a machine to wire to */
		memset(nwired, 0, sizeof(nwired));
		p-&gt;wired = 0;
		pp = proctab(0);
		for(i=0; i&lt;conf.nproc; i++, pp++){
			wm = pp-&gt;wired;
			if(wm &amp;&amp; pp-&gt;pid)
				nwired[wm-&gt;machno]++;
		}
		bm = 0;
		for(i=0; i&lt;conf.nmach; i++)
			if(nwired[i] &lt; nwired[bm])
				bm = i;
	} else {
		/* use the virtual machine requested */
		bm = bm % conf.nmach;
	}

	p-&gt;wired = MACHP(bm);
	p-&gt;mp = p-&gt;wired;
}

void
procpriority(Proc *p, int pri, int fixed)
{
	if(pri &gt;= Npriq)
		pri = Npriq - 1;
	else if(pri &lt; 0)
		pri = 0;
	p-&gt;basepri = pri;
	p-&gt;priority = pri;
	if(fixed){
		p-&gt;fixedpri = 1;
	} else {
		p-&gt;fixedpri = 0;
	}
}

void
procinit0(void)		/* bad planning - clashes with devproc.c */
{
	Proc *p;
	int i;

	procalloc.free = xalloc(conf.nproc*sizeof(Proc));
	if(procalloc.free == nil){
		xsummary();
		panic("cannot allocate %lud procs (%ludMB)\n", conf.nproc, conf.nproc*sizeof(Proc)/(1024*1024));
	}
	procalloc.arena = procalloc.free;

	p = procalloc.free;
	for(i=0; i&lt;conf.nproc-1; i++,p++)
		p-&gt;qnext = p+1;
	p-&gt;qnext = 0;
}

/*
 *  sleep if a condition is not true.  Another process will
 *  awaken us after it sets the condition.  When we awaken
 *  the condition may no longer be true.
 *
 *  we lock both the process and the rendezvous to keep r-&gt;p
 *  and p-&gt;r synchronized.
 */
void
sleep(Rendez *r, int (*f)(void*), void *arg)
{
	int s;
	void (*pt)(Proc*, int, vlong);

	s = splhi();

	if(up-&gt;nlocks.ref)
		print("process %lud sleeps with %lud locks held, last lock %#p locked at pc %#lux, sleep called from %#p\n",
			up-&gt;pid, up-&gt;nlocks.ref, up-&gt;lastlock, up-&gt;lastlock-&gt;pc, getcallerpc(&amp;r));
	lock(r);
	lock(&amp;up-&gt;rlock);
	if(r-&gt;p){
		print("double sleep called from %#p, %lud %lud\n", getcallerpc(&amp;r), r-&gt;p-&gt;pid, up-&gt;pid);
		dumpstack();
	}

	/*
	 *  Wakeup only knows there may be something to do by testing
	 *  r-&gt;p in order to get something to lock on.
	 *  Flush that information out to memory in case the sleep is
	 *  committed.
	 */
	r-&gt;p = up;

	if((*f)(arg) || up-&gt;notepending){
		/*
		 *  if condition happened or a note is pending
		 *  never mind
		 */
		r-&gt;p = nil;
		unlock(&amp;up-&gt;rlock);
		unlock(r);
	} else {
		/*
		 *  now we are committed to
		 *  change state and call scheduler
		 */
		pt = proctrace;
		if(pt)
			pt(up, SSleep, 0);
		up-&gt;state = Wakeme;
		up-&gt;r = r;

		/* statistics */
		m-&gt;cs++;

		procsave(up);
		if(setlabel(&amp;up-&gt;sched)) {
			/*
			 *  here when the process is awakened
			 */
			procrestore(up);
			spllo();
		} else {
			/*
			 *  here to go to sleep (i.e. stop Running)
			 */
			unlock(&amp;up-&gt;rlock);
			unlock(r);
			gotolabel(&amp;m-&gt;sched);
		}
	}

	if(up-&gt;notepending) {
		up-&gt;notepending = 0;
		splx(s);
		if(up-&gt;procctl == Proc_exitme &amp;&amp; up-&gt;closingfgrp)
			forceclosefgrp();
		error(Eintr);
	}

	splx(s);
}

static int
tfn(void *arg)
{
	return up-&gt;trend == nil || up-&gt;tfn(arg);
}

void
twakeup(Ureg*, Timer *t)
{
	Proc *p;
	Rendez *trend;

	p = t-&gt;ta;
	trend = p-&gt;trend;
	p-&gt;trend = 0;
	if(trend)
		wakeup(trend);
}

void
tsleep(Rendez *r, int (*fn)(void*), void *arg, ulong ms)
{
	if (up-&gt;tt){
		print("tsleep: timer active: mode %d, tf %#p\n", up-&gt;tmode, up-&gt;tf);
		timerdel(up);
	}
	up-&gt;tns = MS2NS(ms);
	up-&gt;tf = twakeup;
	up-&gt;tmode = Trelative;
	up-&gt;ta = up;
	up-&gt;trend = r;
	up-&gt;tfn = fn;
	timeradd(up);

	if(waserror()){
		timerdel(up);
		nexterror();
	}
	sleep(r, tfn, arg);
	if(up-&gt;tt)
		timerdel(up);
	up-&gt;twhen = 0;
	poperror();
}

/*
 *  Expects that only one process can call wakeup for any given Rendez.
 *  We hold both locks to ensure that r-&gt;p and p-&gt;r remain consistent.
 *  Richard Miller has a better solution that doesn't require both to
 *  be held simultaneously, but I'm a paranoid - presotto.
 */
Proc*
wakeup(Rendez *r)
{
	Proc *p;
	int s;

	s = splhi();

	lock(r);
	p = r-&gt;p;

	if(p != nil){
		lock(&amp;p-&gt;rlock);
		if(p-&gt;state != Wakeme || p-&gt;r != r){
			iprint("%p %p %d\n", p-&gt;r, r, p-&gt;state);
			panic("wakeup: state");
		}
		r-&gt;p = nil;
		p-&gt;r = nil;
		ready(p);
		unlock(&amp;p-&gt;rlock);
	}
	unlock(r);

	splx(s);

	return p;
}

/*
 *  if waking a sleeping process, this routine must hold both
 *  p-&gt;rlock and r-&gt;lock.  However, it can't know them in
 *  the same order as wakeup causing a possible lock ordering
 *  deadlock.  We break the deadlock by giving up the p-&gt;rlock
 *  lock if we can't get the r-&gt;lock and retrying.
 */
int
postnote(Proc *p, int dolock, char *n, int flag)
{
	int s, ret;
	Rendez *r;
	Proc *d, **l;

	if(dolock)
		qlock(&amp;p-&gt;debug);

	if(flag != NUser &amp;&amp; (p-&gt;notify == 0 || p-&gt;notified))
		p-&gt;nnote = 0;

	ret = 0;
	if(p-&gt;nnote &lt; NNOTE) {
		strcpy(p-&gt;note[p-&gt;nnote].msg, n);
		p-&gt;note[p-&gt;nnote++].flag = flag;
		ret = 1;
	}
	p-&gt;notepending = 1;
	if(dolock)
		qunlock(&amp;p-&gt;debug);

	/* this loop is to avoid lock ordering problems. */
	for(;;){
		s = splhi();
		lock(&amp;p-&gt;rlock);
		r = p-&gt;r;

		/* waiting for a wakeup? */
		if(r == nil)
			break;	/* no */

		/* try for the second lock */
		if(canlock(r)){
			if(p-&gt;state != Wakeme || r-&gt;p != p)
				panic("postnote: state %d %d %d", r-&gt;p != p, p-&gt;r != r, p-&gt;state);
			p-&gt;r = nil;
			r-&gt;p = nil;
			ready(p);
			unlock(r);
			break;
		}

		/* give other process time to get out of critical section and try again */
		unlock(&amp;p-&gt;rlock);
		splx(s);
		sched();
	}
	unlock(&amp;p-&gt;rlock);
	splx(s);

	if(p-&gt;state != Rendezvous)
		return ret;

	/* Try and pull out of a rendezvous */
	lock(p-&gt;rgrp);
	if(p-&gt;state == Rendezvous) {
		p-&gt;rendval = ~0;
		l = &amp;REND(p-&gt;rgrp, p-&gt;rendtag);
		for(d = *l; d; d = d-&gt;rendhash) {
			if(d == p) {
				*l = p-&gt;rendhash;
				break;
			}
			l = &amp;d-&gt;rendhash;
		}
		ready(p);
	}
	unlock(p-&gt;rgrp);
	return ret;
}

/*
 * weird thing: keep at most NBROKEN around
 */
#define	NBROKEN 4
struct
{
	QLock;
	int	n;
	Proc	*p[NBROKEN];
}broken;

void
addbroken(Proc *p)
{
	qlock(&amp;broken);
	if(broken.n == NBROKEN) {
		ready(broken.p[0]);
		memmove(&amp;broken.p[0], &amp;broken.p[1], sizeof(Proc*)*(NBROKEN-1));
		--broken.n;
	}
	broken.p[broken.n++] = p;
	qunlock(&amp;broken);

	edfstop(up);
	p-&gt;state = Broken;
	p-&gt;psstate = 0;
	sched();
}

void
unbreak(Proc *p)
{
	int b;

	qlock(&amp;broken);
	for(b=0; b &lt; broken.n; b++)
		if(broken.p[b] == p) {
			broken.n--;
			memmove(&amp;broken.p[b], &amp;broken.p[b+1],
					sizeof(Proc*)*(NBROKEN-(b+1)));
			ready(p);
			break;
		}
	qunlock(&amp;broken);
}

int
freebroken(void)
{
	int i, n;

	qlock(&amp;broken);
	n = broken.n;
	for(i=0; i&lt;n; i++) {
		ready(broken.p[i]);
		broken.p[i] = 0;
	}
	broken.n = 0;
	qunlock(&amp;broken);
	return n;
}

void
pexit(char *exitstr, int freemem)
{
	Proc *p;
	Segment **s, **es;
	long utime, stime;
	Waitq *wq, *f, *next;
	Fgrp *fgrp;
	Egrp *egrp;
	Rgrp *rgrp;
	Pgrp *pgrp;
	Chan *dot;
	void (*pt)(Proc*, int, vlong);

	if(up-&gt;syscalltrace)
		free(up-&gt;syscalltrace);
	up-&gt;alarm = 0;
	if (up-&gt;tt)
		timerdel(up);
	pt = proctrace;
	if(pt)
		pt(up, SDead, 0);

	/* nil out all the resources under lock (free later) */
	qlock(&amp;up-&gt;debug);
	fgrp = up-&gt;fgrp;
	up-&gt;fgrp = nil;
	egrp = up-&gt;egrp;
	up-&gt;egrp = nil;
	rgrp = up-&gt;rgrp;
	up-&gt;rgrp = nil;
	pgrp = up-&gt;pgrp;
	up-&gt;pgrp = nil;
	dot = up-&gt;dot;
	up-&gt;dot = nil;
	qunlock(&amp;up-&gt;debug);

	if(fgrp)
		closefgrp(fgrp);
	if(egrp)
		closeegrp(egrp);
	if(rgrp)
		closergrp(rgrp);
	if(dot)
		cclose(dot);
	if(pgrp)
		closepgrp(pgrp);

	/*
	 * if not a kernel process and have a parent,
	 * do some housekeeping.
	 */
	if(up-&gt;kp == 0) {
		p = up-&gt;parent;
		if(p == 0) {
			if(exitstr == 0)
				exitstr = "unknown";
			panic("boot process died: %s", exitstr);
		}

		while(waserror())
			;

		wq = smalloc(sizeof(Waitq));
		poperror();

		wq-&gt;w.pid = up-&gt;pid;
		utime = up-&gt;time[TUser] + up-&gt;time[TCUser];
		stime = up-&gt;time[TSys] + up-&gt;time[TCSys];
		wq-&gt;w.time[TUser] = tk2ms(utime);
		wq-&gt;w.time[TSys] = tk2ms(stime);
		wq-&gt;w.time[TReal] = tk2ms(MACHP(0)-&gt;ticks - up-&gt;time[TReal]);
		if(exitstr &amp;&amp; exitstr[0])
			snprint(wq-&gt;w.msg, sizeof(wq-&gt;w.msg), "%s %lud: %s", up-&gt;text, up-&gt;pid, exitstr);
		else
			wq-&gt;w.msg[0] = '\0';

		lock(&amp;p-&gt;exl);
		/*
		 * Check that parent is still alive.
		 */
		if(p-&gt;pid == up-&gt;parentpid &amp;&amp; p-&gt;state != Broken) {
			p-&gt;nchild--;
			p-&gt;time[TCUser] += utime;
			p-&gt;time[TCSys] += stime;
			/*
			 * If there would be more than 128 wait records
			 * processes for my parent, then don't leave a wait
			 * record behind.  This helps prevent badly written
			 * daemon processes from accumulating lots of wait
			 * records.
		 	 */
			if(p-&gt;nwait &lt; 128) {
				wq-&gt;next = p-&gt;waitq;
				p-&gt;waitq = wq;
				p-&gt;nwait++;
				wq = nil;
				wakeup(&amp;p-&gt;waitr);
			}
		}
		unlock(&amp;p-&gt;exl);
		if(wq)
			free(wq);
	}

	if(!freemem)
		addbroken(up);

	qlock(&amp;up-&gt;seglock);
	es = &amp;up-&gt;seg[NSEG];
	for(s = up-&gt;seg; s &lt; es; s++) {
		if(*s) {
			putseg(*s);
			*s = 0;
		}
	}
	qunlock(&amp;up-&gt;seglock);

	lock(&amp;up-&gt;exl);		/* Prevent my children from leaving waits */
	pidunhash(up);
	up-&gt;pid = 0;
	wakeup(&amp;up-&gt;waitr);
	unlock(&amp;up-&gt;exl);

	for(f = up-&gt;waitq; f; f = next) {
		next = f-&gt;next;
		free(f);
	}

	/* release debuggers */
	qlock(&amp;up-&gt;debug);
	if(up-&gt;pdbg) {
		wakeup(&amp;up-&gt;pdbg-&gt;sleep);
		up-&gt;pdbg = 0;
	}
	qunlock(&amp;up-&gt;debug);

	/* Sched must not loop for these locks */
	lock(&amp;procalloc);
	lock(&amp;palloc);

	edfstop(up);
	up-&gt;state = Moribund;
	sched();
	panic("pexit");
}

int
haswaitq(void *x)
{
	Proc *p;

	p = (Proc *)x;
	return p-&gt;waitq != 0;
}

ulong
pwait(Waitmsg *w)
{
	ulong cpid;
	Waitq *wq;

	if(!canqlock(&amp;up-&gt;qwaitr))
		error(Einuse);

	if(waserror()) {
		qunlock(&amp;up-&gt;qwaitr);
		nexterror();
	}

	lock(&amp;up-&gt;exl);
	if(up-&gt;nchild == 0 &amp;&amp; up-&gt;waitq == 0) {
		unlock(&amp;up-&gt;exl);
		error(Enochild);
	}
	unlock(&amp;up-&gt;exl);

	sleep(&amp;up-&gt;waitr, haswaitq, up);

	lock(&amp;up-&gt;exl);
	wq = up-&gt;waitq;
	up-&gt;waitq = wq-&gt;next;
	up-&gt;nwait--;
	unlock(&amp;up-&gt;exl);

	qunlock(&amp;up-&gt;qwaitr);
	poperror();

	if(w)
		memmove(w, &amp;wq-&gt;w, sizeof(Waitmsg));
	cpid = wq-&gt;w.pid;
	free(wq);
	return cpid;
}

Proc*
proctab(int i)
{
	return &amp;procalloc.arena[i];
}

void
dumpaproc(Proc *p)
{
	ulong bss;
	char *s;

	if(p == 0)
		return;

	bss = 0;
	if(p-&gt;seg[BSEG])
		bss = p-&gt;seg[BSEG]-&gt;top;

	s = p-&gt;psstate;
	if(s == 0)
		s = statename[p-&gt;state];
	print("%3lud:%10s pc %8lux dbgpc %8lux  %8s (%s) ut %ld st %ld bss %lux qpc %lux nl %lud nd %lud lpc %lux pri %lud\n",
		p-&gt;pid, p-&gt;text, p-&gt;pc, dbgpc(p),  s, statename[p-&gt;state],
		p-&gt;time[0], p-&gt;time[1], bss, p-&gt;qpc, p-&gt;nlocks.ref, p-&gt;delaysched, p-&gt;lastlock ? p-&gt;lastlock-&gt;pc : 0, p-&gt;priority);
}

void
procdump(void)
{
	int i;
	Proc *p;

	if(up)
		print("up %lud\n", up-&gt;pid);
	else
		print("no current process\n");
	for(i=0; i&lt;conf.nproc; i++) {
		p = &amp;procalloc.arena[i];
		if(p-&gt;state == Dead)
			continue;

		dumpaproc(p);
	}
}

/*
 *  wait till all processes have flushed their mmu
 *  state about segement s
 */
void
procflushseg(Segment *s)
{
	int i, ns, nm, nwait;
	Proc *p;

	/*
	 *  tell all processes with this
	 *  segment to flush their mmu's
	 */
	nwait = 0;
	for(i=0; i&lt;conf.nproc; i++) {
		p = &amp;procalloc.arena[i];
		if(p-&gt;state == Dead)
			continue;
		for(ns = 0; ns &lt; NSEG; ns++)
			if(p-&gt;seg[ns] == s){
				p-&gt;newtlb = 1;
				for(nm = 0; nm &lt; conf.nmach; nm++){
					if(MACHP(nm)-&gt;proc == p){
						MACHP(nm)-&gt;flushmmu = 1;
						nwait++;
					}
				}
				break;
			}
	}

	if(nwait == 0)
		return;

	/*
	 *  wait for all processors to take a clock interrupt
	 *  and flush their mmu's
	 */
	for(nm = 0; nm &lt; conf.nmach; nm++)
		if(MACHP(nm) != m)
			while(MACHP(nm)-&gt;flushmmu)
				sched();
}

void
scheddump(void)
{
	Proc *p;
	Schedq *rq;

	for(rq = &amp;runq[Nrq-1]; rq &gt;= runq; rq--){
		if(rq-&gt;head == 0)
			continue;
		print("rq%ld:", rq-runq);
		for(p = rq-&gt;head; p; p = p-&gt;rnext)
			print(" %lud(%lud)", p-&gt;pid, m-&gt;ticks - p-&gt;readytime);
		print("\n");
		delay(150);
	}
	print("nrdy %d\n", nrdy);
}

void
kproc(char *name, void (*func)(void *), void *arg)
{
	Proc *p;
	static Pgrp *kpgrp;

	p = newproc();
	p-&gt;psstate = 0;
	p-&gt;procmode = 0640;
	p-&gt;kp = 1;
	p-&gt;noswap = 1;

	p-&gt;fpsave = up-&gt;fpsave;
	p-&gt;scallnr = up-&gt;scallnr;
	p-&gt;s = up-&gt;s;
	p-&gt;nerrlab = 0;
	p-&gt;slash = up-&gt;slash;
	p-&gt;dot = up-&gt;dot;
	if(p-&gt;dot)
		incref(p-&gt;dot);

	memmove(p-&gt;note, up-&gt;note, sizeof(p-&gt;note));
	p-&gt;nnote = up-&gt;nnote;
	p-&gt;notified = 0;
	p-&gt;lastnote = up-&gt;lastnote;
	p-&gt;notify = up-&gt;notify;
	p-&gt;ureg = 0;
	p-&gt;dbgreg = 0;

	procpriority(p, PriKproc, 0);

	kprocchild(p, func, arg);

	kstrdup(&amp;p-&gt;user, eve);
	kstrdup(&amp;p-&gt;text, name);
	if(kpgrp == 0)
		kpgrp = newpgrp();
	p-&gt;pgrp = kpgrp;
	incref(kpgrp);

	memset(p-&gt;time, 0, sizeof(p-&gt;time));
	p-&gt;time[TReal] = MACHP(0)-&gt;ticks;
	ready(p);
}

/*
 *  called splhi() by notify().  See comment in notify for the
 *  reasoning.
 */
void
procctl(Proc *p)
{
	char *state;
	ulong s;

	switch(p-&gt;procctl) {
	case Proc_exitbig:
		spllo();
		pexit("Killed: Insufficient physical memory", 1);

	case Proc_exitme:
		spllo();		/* pexit has locks in it */
		pexit("Killed", 1);

	case Proc_traceme:
		if(p-&gt;nnote == 0)
			return;
		/* No break */

	case Proc_stopme:
		p-&gt;procctl = 0;
		state = p-&gt;psstate;
		p-&gt;psstate = "Stopped";
		/* free a waiting debugger */
		s = spllo();
		qlock(&amp;p-&gt;debug);
		if(p-&gt;pdbg) {
			wakeup(&amp;p-&gt;pdbg-&gt;sleep);
			p-&gt;pdbg = 0;
		}
		qunlock(&amp;p-&gt;debug);
		splhi();
		p-&gt;state = Stopped;
		sched();
		p-&gt;psstate = state;
		splx(s);
		return;
	}
}

#include "errstr.h"

void
error(char *err)
{
	spllo();

	assert(up-&gt;nerrlab &lt; NERR);
	kstrcpy(up-&gt;errstr, err, ERRMAX);
	setlabel(&amp;up-&gt;errlab[NERR-1]);
	nexterror();
}

void
nexterror(void)
{
	gotolabel(&amp;up-&gt;errlab[--up-&gt;nerrlab]);
}

void
exhausted(char *resource)
{
	char buf[ERRMAX];

	snprint(buf, sizeof buf, "no free %s", resource);
	iprint("%s\n", buf);
	error(buf);
}

void
killbig(char *why)
{
	int i;
	Segment *s;
	ulong l, max;
	Proc *p, *ep, *kp;

	max = 0;
	kp = 0;
	ep = procalloc.arena+conf.nproc;
	for(p = procalloc.arena; p &lt; ep; p++) {
		if(p-&gt;state == Dead || p-&gt;kp)
			continue;
		l = 0;
		for(i=1; i&lt;NSEG; i++) {
			s = p-&gt;seg[i];
			if(s != 0)
				l += s-&gt;top - s-&gt;base;
		}
		if(l &gt; max &amp;&amp; ((p-&gt;procmode&amp;0222) || strcmp(eve, p-&gt;user)!=0)) {
			kp = p;
			max = l;
		}
	}

	print("%lud: %s killed: %s\n", kp-&gt;pid, kp-&gt;text, why);
	for(p = procalloc.arena; p &lt; ep; p++) {
		if(p-&gt;state == Dead || p-&gt;kp)
			continue;
		if(p != kp &amp;&amp; p-&gt;seg[BSEG] &amp;&amp; p-&gt;seg[BSEG] == kp-&gt;seg[BSEG])
			p-&gt;procctl = Proc_exitbig;
	}
	kp-&gt;procctl = Proc_exitbig;
	for(i = 0; i &lt; NSEG; i++) {
		s = kp-&gt;seg[i];
		if(s != 0 &amp;&amp; canqlock(&amp;s-&gt;lk)) {
			mfreeseg(s, s-&gt;base, (s-&gt;top - s-&gt;base)/BY2PG);
			qunlock(&amp;s-&gt;lk);
		}
	}
}

/*
 *  change ownership to 'new' of all processes owned by 'old'.  Used when
 *  eve changes.
 */
void
renameuser(char *old, char *new)
{
	Proc *p, *ep;

	ep = procalloc.arena+conf.nproc;
	for(p = procalloc.arena; p &lt; ep; p++)
		if(p-&gt;user!=nil &amp;&amp; strcmp(old, p-&gt;user)==0)
			kstrdup(&amp;p-&gt;user, new);
}

/*
 *  time accounting called by clock() splhi'd
 */
void
accounttime(void)
{
	Proc *p;
	ulong n, per;
	static ulong nrun;

	p = m-&gt;proc;
	if(p) {
		nrun++;
		p-&gt;time[p-&gt;insyscall]++;
	}

	/* calculate decaying duty cycles */
	n = perfticks();
	per = n - m-&gt;perf.last;
	m-&gt;perf.last = n;
	per = (m-&gt;perf.period*(HZ-1) + per)/HZ;
	if(per != 0)
		m-&gt;perf.period = per;

	m-&gt;perf.avg_inidle = (m-&gt;perf.avg_inidle*(HZ-1)+m-&gt;perf.inidle)/HZ;
	m-&gt;perf.inidle = 0;

	m-&gt;perf.avg_inintr = (m-&gt;perf.avg_inintr*(HZ-1)+m-&gt;perf.inintr)/HZ;
	m-&gt;perf.inintr = 0;

	/* only one processor gets to compute system load averages */
	if(m-&gt;machno != 0)
		return;

	/*
	 * calculate decaying load average.
	 * if we decay by (n-1)/n then it takes
	 * n clock ticks to go from load L to .36 L once
	 * things quiet down.  it takes about 5 n clock
	 * ticks to go to zero.  so using HZ means this is
	 * approximately the load over the last second,
	 * with a tail lasting about 5 seconds.
	 */
	n = nrun;
	nrun = 0;
	n = (nrdy+n)*1000;
	m-&gt;load = (m-&gt;load*(HZ-1)+n)/HZ;
}

static void
pidhash(Proc *p)
{
	int h;

	h = p-&gt;pid % nelem(procalloc.ht);
	lock(&amp;procalloc);
	p-&gt;pidhash = procalloc.ht[h];
	procalloc.ht[h] = p;
	unlock(&amp;procalloc);
}

static void
pidunhash(Proc *p)
{
	int h;
	Proc **l;

	h = p-&gt;pid % nelem(procalloc.ht);
	lock(&amp;procalloc);
	for(l = &amp;procalloc.ht[h]; *l != nil; l = &amp;(*l)-&gt;pidhash)
		if(*l == p){
			*l = p-&gt;pidhash;
			break;
		}
	unlock(&amp;procalloc);
}

int
procindex(ulong pid)
{
	Proc *p;
	int h;
	int s;

	s = -1;
	h = pid % nelem(procalloc.ht);
	lock(&amp;procalloc);
	for(p = procalloc.ht[h]; p != nil; p = p-&gt;pidhash)
		if(p-&gt;pid == pid){
			s = p - procalloc.arena;
			break;
		}
	unlock(&amp;procalloc);
	return s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

