<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/qlock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/qlock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"

struct {
	ulong rlock;
	ulong rlockq;
	ulong wlock;
	ulong wlockq;
	ulong qlock;
	ulong qlockq;
} rwstats;

void
qlock(QLock *q)
{
	Proc *p;

	if(m-&gt;ilockdepth != 0)
		print("qlock: %#p: ilockdepth %d\n", getcallerpc(&amp;q), m-&gt;ilockdepth);
	if(up != nil &amp;&amp; up-&gt;nlocks.ref)
		print("qlock: %#p: nlocks %lud\n", getcallerpc(&amp;q), up-&gt;nlocks.ref);

	if(q-&gt;use.key == 0x55555555)
		panic("qlock: q %#p, key 5*\n", q);
	lock(&amp;q-&gt;use);
	rwstats.qlock++;
	if(!q-&gt;locked) {
		q-&gt;locked = 1;
		q-&gt;qpc = getcallerpc(&amp;q);
		unlock(&amp;q-&gt;use);
		return;
	}
	if(up == 0)
		panic("qlock");
	rwstats.qlockq++;
	p = q-&gt;tail;
	if(p == 0)
		q-&gt;head = up;
	else
		p-&gt;qnext = up;
	q-&gt;tail = up;
	up-&gt;qnext = 0;
	up-&gt;state = Queueing;
	up-&gt;qpc = getcallerpc(&amp;q);
	unlock(&amp;q-&gt;use);
	sched();
	q-&gt;qpc = getcallerpc(&amp;q);
}

int
canqlock(QLock *q)
{
	if(!canlock(&amp;q-&gt;use))
		return 0;
	if(q-&gt;locked){
		unlock(&amp;q-&gt;use);
		return 0;
	}
	q-&gt;locked = 1;
	q-&gt;qpc = getcallerpc(&amp;q);
	unlock(&amp;q-&gt;use);
	return 1;
}

void
qunlock(QLock *q)
{
	Proc *p;

	lock(&amp;q-&gt;use);
	if (q-&gt;locked == 0)
		print("qunlock called with qlock not held, from %#p\n",
			getcallerpc(&amp;q));
	p = q-&gt;head;
	if(p){
		q-&gt;head = p-&gt;qnext;
		if(q-&gt;head == 0)
			q-&gt;tail = 0;
		unlock(&amp;q-&gt;use);
		ready(p);
		return;
	}
	q-&gt;locked = 0;
	q-&gt;qpc = 0;
	unlock(&amp;q-&gt;use);
}

void
rlock(RWlock *q)
{
	Proc *p;

	lock(&amp;q-&gt;use);
	rwstats.rlock++;
	if(q-&gt;writer == 0 &amp;&amp; q-&gt;head == nil){
		/* no writer, go for it */
		q-&gt;readers++;
		unlock(&amp;q-&gt;use);
		return;
	}

	rwstats.rlockq++;
	p = q-&gt;tail;
	if(up == nil)
		panic("rlock");
	if(p == 0)
		q-&gt;head = up;
	else
		p-&gt;qnext = up;
	q-&gt;tail = up;
	up-&gt;qnext = 0;
	up-&gt;state = QueueingR;
	unlock(&amp;q-&gt;use);
	sched();
}

void
runlock(RWlock *q)
{
	Proc *p;

	lock(&amp;q-&gt;use);
	p = q-&gt;head;
	if(--(q-&gt;readers) &gt; 0 || p == nil){
		unlock(&amp;q-&gt;use);
		return;
	}

	/* start waiting writer */
	if(p-&gt;state != QueueingW)
		panic("runlock");
	q-&gt;head = p-&gt;qnext;
	if(q-&gt;head == 0)
		q-&gt;tail = 0;
	q-&gt;writer = 1;
	unlock(&amp;q-&gt;use);
	ready(p);
}

void
wlock(RWlock *q)
{
	Proc *p;

	lock(&amp;q-&gt;use);
	rwstats.wlock++;
	if(q-&gt;readers == 0 &amp;&amp; q-&gt;writer == 0){
		/* noone waiting, go for it */
		q-&gt;wpc = getcallerpc(&amp;q);
		q-&gt;wproc = up;
		q-&gt;writer = 1;
		unlock(&amp;q-&gt;use);
		return;
	}

	/* wait */
	rwstats.wlockq++;
	p = q-&gt;tail;
	if(up == nil)
		panic("wlock");
	if(p == nil)
		q-&gt;head = up;
	else
		p-&gt;qnext = up;
	q-&gt;tail = up;
	up-&gt;qnext = 0;
	up-&gt;state = QueueingW;
	unlock(&amp;q-&gt;use);
	sched();
}

void
wunlock(RWlock *q)
{
	Proc *p;

	lock(&amp;q-&gt;use);
	p = q-&gt;head;
	if(p == nil){
		q-&gt;writer = 0;
		unlock(&amp;q-&gt;use);
		return;
	}
	if(p-&gt;state == QueueingW){
		/* start waiting writer */
		q-&gt;head = p-&gt;qnext;
		if(q-&gt;head == nil)
			q-&gt;tail = nil;
		unlock(&amp;q-&gt;use);
		ready(p);
		return;
	}

	if(p-&gt;state != QueueingR)
		panic("wunlock");

	/* waken waiting readers */
	while(q-&gt;head != nil &amp;&amp; q-&gt;head-&gt;state == QueueingR){
		p = q-&gt;head;
		q-&gt;head = p-&gt;qnext;
		q-&gt;readers++;
		ready(p);
	}
	if(q-&gt;head == nil)
		q-&gt;tail = nil;
	q-&gt;writer = 0;
	unlock(&amp;q-&gt;use);
}

/* same as rlock but punts if there are any writers waiting */
int
canrlock(RWlock *q)
{
	lock(&amp;q-&gt;use);
	rwstats.rlock++;
	if(q-&gt;writer == 0 &amp;&amp; q-&gt;head == nil){
		/* no writer, go for it */
		q-&gt;readers++;
		unlock(&amp;q-&gt;use);
		return 1;
	}
	unlock(&amp;q-&gt;use);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

