<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/sdaoe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/sdaoe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * aoe sd driver, copyright © 2007 coraid
 */

#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/sd.h"
#include "../port/netif.h"
#include "../port/aoe.h"

#define uprint(...)	snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, __VA_ARGS__);

enum {
	Nctlr	= 32,
	Maxpath	= 128,

	Probeintvl	= 100,		/* ms. between probes */
	Probemax	= 20,		/* max probes */
};

enum {
	/* sync with ahci.h */
	Dllba 	= 1&lt;&lt;0,
	Dsmart	= 1&lt;&lt;1,
	Dpower	= 1&lt;&lt;2,
	Dnop	= 1&lt;&lt;3,
	Datapi	= 1&lt;&lt;4,
	Datapi16= 1&lt;&lt;5,
};

static char *flagname[] = {
	"llba",
	"smart",
	"power",
	"nop",
	"atapi",
	"atapi16",
};

typedef struct Ctlr Ctlr;
struct Ctlr{
	QLock;

	Ctlr	*next;
	SDunit	*unit;

	char	path[Maxpath];
	Chan	*c;

	ulong	vers;
	uchar	mediachange;
	uchar	flag;
	uchar	smart;
	uchar	smartrs;
	uchar	feat;

	uvlong	sectors;
	char	serial[20+1];
	char	firmware[8+1];
	char	model[40+1];
	char	ident[0x100];
};

void	aoeidmove(char *p, ushort *a, unsigned n);

static	Lock	ctlrlock;
static	Ctlr	*head;
static	Ctlr	*tail;

SDifc sdaoeifc;

static ushort
gbit16(void *a)
{
	uchar *i;

	i = a;
	return i[1] &lt;&lt; 8 | i[0];
}

static ulong
gbit32(void *a)
{
	ulong j;
	uchar *i;

	i = a;
	j  = i[3] &lt;&lt; 24;
	j |= i[2] &lt;&lt; 16;
	j |= i[1] &lt;&lt; 8;
	j |= i[0];
	return j;
}

static uvlong
gbit64(void *a)
{
	uchar *i;

	i = a;
	return (uvlong)gbit32(i+4)&lt;&lt;32 | gbit32(i);
}

static int
identify(Ctlr *c, ushort *id)
{
	int i;
	uchar oserial[21];
	uvlong osectors, s;

	osectors = c-&gt;sectors;
	memmove(oserial, c-&gt;serial, sizeof c-&gt;serial);

	c-&gt;feat &amp;= ~(Dllba|Dpower|Dsmart|Dnop);
	i = gbit16(id+83) | gbit16(id+86);
	if(i &amp; (1&lt;&lt;10)){
		c-&gt;feat |= Dllba;
		s = gbit64(id+100);
	}else
		s = gbit32(id+60);

	i = gbit16(id+83);
	if((i&gt;&gt;14) == 1) {
		if(i &amp; (1&lt;&lt;3))
			c-&gt;feat |= Dpower;
		i = gbit16(id+82);
		if(i &amp; 1)
			c-&gt;feat |= Dsmart;
		if(i &amp; (1&lt;&lt;14))
			c-&gt;feat |= Dnop;
	}

	aoeidmove(c-&gt;serial, id+10, 20);
	aoeidmove(c-&gt;firmware, id+23, 8);
	aoeidmove(c-&gt;model, id+27, 40);

	if((osectors == 0 || osectors != s) &amp;&amp;
	    memcmp(oserial, c-&gt;serial, sizeof oserial) != 0){
		c-&gt;sectors = s;
		c-&gt;mediachange = 1;
		c-&gt;vers++;
	}
	return 0;
}

/* must call with d qlocked */
static int
aoeidentify(Ctlr *d, SDunit *u)
{
	Chan *c;

	c = nil;
	if(waserror()){
		if(c)
			cclose(c);
		iprint("aoeidentify: %s\n", up-&gt;errstr);
		nexterror();
	}

	uprint("%s/ident", d-&gt;path);
	c = namec(up-&gt;genbuf, Aopen, OREAD, 0);
	devtab[c-&gt;type]-&gt;read(c, d-&gt;ident, sizeof d-&gt;ident, 0);

	poperror();
	cclose(c);

	d-&gt;feat = 0;
	d-&gt;smart = 0;
	identify(d, (ushort*)d-&gt;ident);

	memset(u-&gt;inquiry, 0, sizeof u-&gt;inquiry);
	u-&gt;inquiry[2] = 2;
	u-&gt;inquiry[3] = 2;
	u-&gt;inquiry[4] = sizeof u-&gt;inquiry - 4;
	memmove(u-&gt;inquiry+8, d-&gt;model, 40);

	return 0;
}

static Ctlr*
ctlrlookup(char *path)
{
	Ctlr *c;

	lock(&amp;ctlrlock);
	for(c = head; c; c = c-&gt;next)
		if(strcmp(c-&gt;path, path) == 0)
			break;
	unlock(&amp;ctlrlock);
	return c;
}

static Ctlr*
newctlr(char *path)
{
	Ctlr *c;

	/* race? */
	if(ctlrlookup(path))
		error(Eexist);

	if((c = malloc(sizeof *c)) == nil)
		return 0;
	kstrcpy(c-&gt;path, path, sizeof c-&gt;path);
	lock(&amp;ctlrlock);
	if(head != nil)
		tail-&gt;next = c;
	else
		head = c;
	tail = c;
	unlock(&amp;ctlrlock);
	return c;
}

static void
delctlr(Ctlr *c)
{
	Ctlr *x, *prev;

	lock(&amp;ctlrlock);

	for(prev = 0, x = head; x; prev = x, x = c-&gt;next)
		if(strcmp(c-&gt;path, x-&gt;path) == 0)
			break;
	if(x == 0){
		unlock(&amp;ctlrlock);
		error(Enonexist);
	}

	if(prev)
		prev-&gt;next = x-&gt;next;
	else
		head = x-&gt;next;
	if(x-&gt;next == nil)
		tail = prev;
	unlock(&amp;ctlrlock);

	if(x-&gt;c)
		cclose(x-&gt;c);
	free(x);
}

/* don't call aoeprobe from within a loop; it loops internally retrying open. */
static SDev*
aoeprobe(char *path, SDev *s)
{
	int n, i;
	char *p;
	Chan *c;
	Ctlr *ctlr;

	if((p = strrchr(path, '/')) == 0)
		error(Ebadarg);
	*p = 0;
	uprint("%s/ctl", path);
	*p = '/';

	c = namec(up-&gt;genbuf, Aopen, OWRITE, 0);
	if(waserror()) {
		cclose(c);
		nexterror();
	}
	n = uprint("discover %s", p+1);
	devtab[c-&gt;type]-&gt;write(c, up-&gt;genbuf, n, 0);
	poperror();
	cclose(c);

	for(i = 0; i &lt; Probemax; i++){
		tsleep(&amp;up-&gt;sleep, return0, 0, Probeintvl);
		uprint("%s/ident", path);
		if(!waserror()) {
			c = namec(up-&gt;genbuf, Aopen, OREAD, 0);
			poperror();
			cclose(c);
			break;
		}
	}
	if(i &gt;= Probemax)
		error(Etimedout);
	uprint("%s/ident", path);
	ctlr = newctlr(path);
	if(ctlr == nil || s == nil &amp;&amp; (s = malloc(sizeof *s)) == nil)
		return nil;
	s-&gt;ctlr = ctlr;
	s-&gt;ifc = &amp;sdaoeifc;
	s-&gt;nunit = 1;
	return s;
}

static char 	*probef[32];
static int 	nprobe;

static int
pnpprobeid(char *s)
{
	if(strlen(s) &lt; 2)
		return 0;
	return s[1] == '!'? s[0]: 'e';
}

static SDev*
aoepnp(void)
{
	int i, id;
	char *p;
	SDev *h, *t, *s;

	if((p = getconf("aoedev")) == 0)
		return 0;
	nprobe = tokenize(p, probef, nelem(probef));
	h = t = 0;
	for(i = 0; i &lt; nprobe; i++){
		id = pnpprobeid(probef[i]);
		if(id == 0)
			continue;
		s = malloc(sizeof *s);
		if(s == nil)
			break;
		s-&gt;ctlr = 0;
		s-&gt;idno = id;
		s-&gt;ifc = &amp;sdaoeifc;
		s-&gt;nunit = 1;

		if(h)
			t-&gt;next = s;
		else
			h = s;
		t = s;
	}
	return h;
}

static Ctlr*
pnpprobe(SDev *sd)
{
	ulong start;
	char *p;
	static int i;

	if(i &gt; nprobe)
		return 0;
	p = probef[i++];
	if(strlen(p) &lt; 2)
		return 0;
	if(p[1] == '!')
		p += 2;

	start = TK2MS(MACHP(0)-&gt;ticks);
	if(waserror()){
		print("#æ: pnpprobe failed in %lud ms: %s: %s\n",
			TK2MS(MACHP(0)-&gt;ticks) - start, probef[i-1],
			up-&gt;errstr);
		return nil;
	}
	sd = aoeprobe(p, sd);			/* does a round of probing */
	poperror();
	print("#æ: pnpprobe established %s in %lud ms\n",
		probef[i-1], TK2MS(MACHP(0)-&gt;ticks) - start);
	return sd-&gt;ctlr;
}


static int
aoeverify(SDunit *u)
{
	SDev *s;
	Ctlr *c;

	s = u-&gt;dev;
	c = s-&gt;ctlr;
	if(c == nil &amp;&amp; (s-&gt;ctlr = c = pnpprobe(s)) == nil)
		return 0;
	c-&gt;mediachange = 1;
	return 1;
}

static int
aoeconnect(SDunit *u, Ctlr *c)
{
	qlock(c);
	if(waserror()){
		qunlock(c);
		return -1;
	}

	aoeidentify(u-&gt;dev-&gt;ctlr, u);
	if(c-&gt;c)
		cclose(c-&gt;c);
	c-&gt;c = 0;
	uprint("%s/data", c-&gt;path);
	c-&gt;c = namec(up-&gt;genbuf, Aopen, ORDWR, 0);
	qunlock(c);
	poperror();

	return 0;
}

static int
aoeonline(SDunit *u)
{
	Ctlr *c;
	int r;

	c = u-&gt;dev-&gt;ctlr;
	r = 0;

	if((c-&gt;feat&amp;Datapi) &amp;&amp; c-&gt;mediachange){
		if(aoeconnect(u, c) == 0 &amp;&amp; (r = scsionline(u)) &gt; 0)
			c-&gt;mediachange = 0;
		return r;
	}

	if(c-&gt;mediachange){
		if(aoeconnect(u, c) == -1)
			return 0;
		r = 2;
		c-&gt;mediachange = 0;
		u-&gt;sectors = c-&gt;sectors;
		u-&gt;secsize = Aoesectsz;
	} else
		r = 1;

	return r;
}

static int
aoerio(SDreq *r)
{
	int i, count;
	uvlong lba;
	char *name;
	uchar *cmd;
	long (*rio)(Chan*, void*, long, vlong);
	Ctlr *c;
	SDunit *unit;

	unit = r-&gt;unit;
	c = unit-&gt;dev-&gt;ctlr;
//	if(c-&gt;feat &amp; Datapi)
//		return aoeriopkt(r, d);

	cmd = r-&gt;cmd;
	name = unit-&gt;name;

	if(r-&gt;cmd[0] == 0x35 || r-&gt;cmd[0] == 0x91){
//		qlock(c);
//		i = flushcache();
//		qunlock(c);
//		if(i == 0)
//			return sdsetsense(r, SDok, 0, 0, 0);
		return sdsetsense(r, SDcheck, 3, 0xc, 2);
	}

	if((i = sdfakescsi(r, c-&gt;ident, sizeof c-&gt;ident)) != SDnostatus){
		r-&gt;status = i;
		return i;
	}

	switch(*cmd){
	case 0x88:
	case 0x28:
		rio = devtab[c-&gt;c-&gt;type]-&gt;read;
		break;
	case 0x8a:
	case 0x2a:
		rio = devtab[c-&gt;c-&gt;type]-&gt;write;
		break;
	default:
		print("%s: bad cmd %#.2ux\n", name, cmd[0]);
		r-&gt;status = SDcheck;
		return SDcheck;
	}

	if(r-&gt;data == nil)
		return SDok;

	if(r-&gt;clen == 16){
		if(cmd[2] || cmd[3])
			return sdsetsense(r, SDcheck, 3, 0xc, 2);
		lba = (uvlong)cmd[4]&lt;&lt;40 | (uvlong)cmd[5]&lt;&lt;32;
		lba |=   cmd[6]&lt;&lt;24 |  cmd[7]&lt;&lt;16 |  cmd[8]&lt;&lt;8 | cmd[9];
		count = cmd[10]&lt;&lt;24 | cmd[11]&lt;&lt;16 | cmd[12]&lt;&lt;8 | cmd[13];
	}else{
		lba  = cmd[2]&lt;&lt;24 | cmd[3]&lt;&lt;16 | cmd[4]&lt;&lt;8 | cmd[5];
		count = cmd[7]&lt;&lt;8 | cmd[8];
	}

	count *= Aoesectsz;

	if(r-&gt;dlen &lt; count)
		count = r-&gt;dlen &amp; ~0x1ff;

	if(waserror()){
		if(strcmp(up-&gt;errstr, Echange) == 0 ||
		    strcmp(up-&gt;errstr, Eaoedown) == 0)
			unit-&gt;sectors = 0;
		nexterror();
	}
	r-&gt;rlen = rio(c-&gt;c, r-&gt;data, count, Aoesectsz * lba);
	poperror();
	r-&gt;status = SDok;
	return SDok;
}

static char *smarttab[] = {
	"unset",
	"error",
	"threshold exceeded",
	"normal"
};

static char *
pflag(char *s, char *e, uchar f)
{
	uchar i;

	for(i = 0; i &lt; 8; i++)
		if(f &amp; (1 &lt;&lt; i))
			s = seprint(s, e, "%s ", flagname[i]);
	return seprint(s, e, "\n");
}

static int
aoerctl(SDunit *u, char *p, int l)
{
	Ctlr *c;
	char *e, *op;

	if((c = u-&gt;dev-&gt;ctlr) == nil)
		return 0;
	e = p+l;
	op = p;

	p = seprint(p, e, "model\t%s\n", c-&gt;model);
	p = seprint(p, e, "serial\t%s\n", c-&gt;serial);
	p = seprint(p, e, "firm	%s\n", c-&gt;firmware);
	if(c-&gt;smartrs == 0xff)
		p = seprint(p, e, "smart\tenable error\n");
	else if(c-&gt;smartrs == 0)
		p = seprint(p, e, "smart\tdisabled\n");
	else
		p = seprint(p, e, "smart\t%s\n", smarttab[c-&gt;smart]);
	p = seprint(p, e, "flag	");
	p = pflag(p, e, c-&gt;feat);
	p = seprint(p, e, "geometry %llud %d\n", c-&gt;sectors, Aoesectsz);
	return p-op;
}

static int
aoewctl(SDunit *, Cmdbuf *cmd)
{
	cmderror(cmd, Ebadarg);
	return 0;
}

static SDev*
aoeprobew(DevConf *c)
{
	char *p;

	p = strchr(c-&gt;type, '/');
	if(p == nil || strlen(p) &gt; Maxpath - 11)
		error(Ebadarg);
	if(p[1] == '#')
		p++;			/* hack */
	if(ctlrlookup(p))
		error(Einuse);
	return aoeprobe(p, 0);
}

static void
aoeclear(SDev *s)
{
	delctlr((Ctlr *)s-&gt;ctlr);
}

static char*
aoertopctl(SDev *s, char *p, char *e)
{
	Ctlr *c;

	if(s == nil || (c = s-&gt;ctlr) == nil)
		return p;

	return seprint(p, e, "%s aoe %s\n", s-&gt;name, c-&gt;path);
}

static int
aoewtopctl(SDev *, Cmdbuf *cmd)
{
	switch(cmd-&gt;nf){
	default:
		cmderror(cmd, Ebadarg);
	}
	return 0;
}

SDifc sdaoeifc = {
	"aoe",

	aoepnp,
	nil,		/* legacy */
	nil,		/* enable */
	nil,		/* disable */

	aoeverify,
	aoeonline,
	aoerio,
	aoerctl,
	aoewctl,

	scsibio,
	aoeprobew,	/* probe */
	aoeclear,	/* clear */
	aoertopctl,
	aoewtopctl,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

