<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/sdmmc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/sdmmc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * mmc / sd memory card
 *
 * Copyright © 2012 Richard Miller &lt;r.miller@acm.org&gt;
 *
 * Assumes only one card on the bus
 */

#include "u.h"
#include "../port/lib.h"
#include "../port/error.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"

#include "../port/sd.h"

#define CSD(end, start)	rbits(csd, start, (end)-(start)+1)

typedef struct Ctlr Ctlr;

enum {
	Inittimeout	= 15,
	Multiblock	= 1,

	/* Commands */
	GO_IDLE_STATE	= 0,
	ALL_SEND_CID	= 2,
	SEND_RELATIVE_ADDR= 3,
	SELECT_CARD	= 7,
	SD_SEND_IF_COND	= 8,
	SEND_CSD	= 9,
	STOP_TRANSMISSION= 12,
	SEND_STATUS	= 13,
	SET_BLOCKLEN	= 16,
	READ_SINGLE_BLOCK= 17,
	READ_MULTIPLE_BLOCK= 18,
	WRITE_BLOCK	= 24,
	WRITE_MULTIPLE_BLOCK= 25,
	APP_CMD		= 55,	/* prefix for following app-specific commands */
	SET_BUS_WIDTH	= 6,
	SD_SEND_OP_COND	= 41,

	/* Command arguments */
	/* SD_SEND_IF_COND */
	Voltage		= 1&lt;&lt;8,
	Checkpattern	= 0x42,

	/* SELECT_CARD */
	Rcashift	= 16,

	/* SD_SEND_OP_COND */
	Hcs	= 1&lt;&lt;30,	/* host supports SDHC &amp; SDXC */
	Ccs	= 1&lt;&lt;30,	/* card is SDHC or SDXC */
	V3_3	= 3&lt;&lt;20,	/* 3.2-3.4 volts */

	/* SET_BUS_WIDTH */
	Width1	= 0&lt;&lt;0,
	Width4	= 2&lt;&lt;0,

	/* OCR (operating conditions register) */
	Powerup	= 1&lt;&lt;31,
};

struct Ctlr {
	SDev	*dev;
	SDio	*io;
	/* SD card registers */
	u16int	rca;
	u32int	ocr;
	u32int	cid[4];
	u32int	csd[4];
};

extern SDifc sdmmcifc;
extern SDio sdio;

static uint
rbits(u32int *p, uint start, uint len)
{
	uint w, off, v;

	w   = start / 32;
	off = start % 32;
	if(off == 0)
		v = p[w];
	else
		v = p[w] &gt;&gt; off | p[w+1] &lt;&lt; (32-off);
	if(len &lt; 32)
		return v &amp; ((1&lt;&lt;len) - 1);
	else
		return v;
}

static void
identify(SDunit *unit, u32int *csd)
{
	uint csize, mult;

	unit-&gt;secsize = 1 &lt;&lt; CSD(83, 80);
	switch(CSD(127, 126)){
	case 0:				/* CSD version 1 */
		csize = CSD(73, 62);
		mult = CSD(49, 47);
		unit-&gt;sectors = (csize+1) * (1&lt;&lt;(mult+2));
		break;
	case 1:				/* CSD version 2 */
		csize = CSD(69, 48);
		unit-&gt;sectors = (csize+1) * 512LL*KiB / unit-&gt;secsize;
		break;
	}
	if(unit-&gt;secsize == 1024){
		unit-&gt;sectors &lt;&lt;= 1;
		unit-&gt;secsize = 512;
	}
}

static SDev*
mmcpnp(void)
{
	SDev *sdev;
	Ctlr *ctl;

	if(sdio.init() &lt; 0)
		return nil;
	sdev = malloc(sizeof(SDev));
	if(sdev == nil)
		return nil;
	ctl = malloc(sizeof(Ctlr));
	if(ctl == nil){
		free(sdev);
		return nil;
	}
	sdev-&gt;idno = 'M';
	sdev-&gt;ifc = &amp;sdmmcifc;
	sdev-&gt;nunit = 1;
	sdev-&gt;ctlr = ctl;
	ctl-&gt;dev = sdev;
	ctl-&gt;io = &amp;sdio;
	return sdev;
}

static int
mmcverify(SDunit *unit)
{
	int n;
	Ctlr *ctl;

	ctl = unit-&gt;dev-&gt;ctlr;
	n = ctl-&gt;io-&gt;inquiry((char*)&amp;unit-&gt;inquiry[8], sizeof(unit-&gt;inquiry)-8);
	if(n &lt; 0)
		return 0;
	unit-&gt;inquiry[0] = SDperdisk;
	unit-&gt;inquiry[1] = SDinq1removable;
	unit-&gt;inquiry[4] = sizeof(unit-&gt;inquiry)-4;
	return 1;
}

static int
mmcenable(SDev* dev)
{
	Ctlr *ctl;

	ctl = dev-&gt;ctlr;
	ctl-&gt;io-&gt;enable();
	return 1;
}

static int
mmconline(SDunit *unit)
{
	int hcs, i;
	u32int r[4];
	Ctlr *ctl;
	SDio *io;

	ctl = unit-&gt;dev-&gt;ctlr;
	io = ctl-&gt;io;
	assert(unit-&gt;subno == 0);

	if(waserror()){
		unit-&gt;sectors = 0;
		return 0;
	}
	if(unit-&gt;sectors != 0){
		io-&gt;cmd(SEND_STATUS, ctl-&gt;rca&lt;&lt;Rcashift, r);
		poperror();
		return 1;
	}
	io-&gt;cmd(GO_IDLE_STATE, 0, r);
	hcs = 0;
	if(!waserror()){
		io-&gt;cmd(SD_SEND_IF_COND, Voltage|Checkpattern, r);
		if(r[0] == (Voltage|Checkpattern))	/* SD 2.0 or above */
			hcs = Hcs;
		poperror();
	}
	for(i = 0; i &lt; Inittimeout; i++){
		delay(100);
		io-&gt;cmd(APP_CMD, 0, r);
		io-&gt;cmd(SD_SEND_OP_COND, hcs|V3_3, r);
		if(r[0] &amp; Powerup)
			break;
	}
	if(i == Inittimeout){
		print("sdmmc: card won't power up\n");
		poperror();
		return 2;
	}
	ctl-&gt;ocr = r[0];
	io-&gt;cmd(ALL_SEND_CID, 0, r);
	memmove(ctl-&gt;cid, r, sizeof ctl-&gt;cid);
	io-&gt;cmd(SEND_RELATIVE_ADDR, 0, r);
	ctl-&gt;rca = r[0]&gt;&gt;16;
	io-&gt;cmd(SEND_CSD, ctl-&gt;rca&lt;&lt;Rcashift, r);
	memmove(ctl-&gt;csd, r, sizeof ctl-&gt;csd);
	identify(unit, ctl-&gt;csd);
	io-&gt;cmd(SELECT_CARD, ctl-&gt;rca&lt;&lt;Rcashift, r);
	io-&gt;cmd(SET_BLOCKLEN, unit-&gt;secsize, r);
	io-&gt;cmd(APP_CMD, ctl-&gt;rca&lt;&lt;Rcashift, r);
	io-&gt;cmd(SET_BUS_WIDTH, Width4, r);
	poperror();
	return 1;
}

static int
mmcrctl(SDunit *unit, char *p, int l)
{
	Ctlr *ctl;
	int i, n;

	ctl = unit-&gt;dev-&gt;ctlr;
	assert(unit-&gt;subno == 0);
	if(unit-&gt;sectors == 0){
		mmconline(unit);
		if(unit-&gt;sectors == 0)
			return 0;
	}
	n = snprint(p, l, "rca %4.4ux ocr %8.8ux\ncid ", ctl-&gt;rca, ctl-&gt;ocr);
	for(i = nelem(ctl-&gt;cid)-1; i &gt;= 0; i--)
		n += snprint(p+n, l-n, "%8.8ux", ctl-&gt;cid[i]);
	n += snprint(p+n, l-n, " csd ");
	for(i = nelem(ctl-&gt;csd)-1; i &gt;= 0; i--)
		n += snprint(p+n, l-n, "%8.8ux", ctl-&gt;csd[i]);
	n += snprint(p+n, l-n, "\ngeometry %llud %ld\n",
		unit-&gt;sectors, unit-&gt;secsize);
	return n;
}

static long
mmcbio(SDunit *unit, int lun, int write, void *data, long nb, uvlong bno)
{
	int len, tries;
	ulong b;
	u32int r[4];
	uchar *buf;
	Ctlr *ctl;
	SDio *io;

	USED(lun);
	ctl = unit-&gt;dev-&gt;ctlr;
	io = ctl-&gt;io;
	assert(unit-&gt;subno == 0);
	if(unit-&gt;sectors == 0)
		error("media change");
	buf = data;
	len = unit-&gt;secsize;
	if(Multiblock){
		b = bno;
		tries = 0;
		while(waserror())
			if(++tries == 3)
				nexterror();
		io-&gt;iosetup(write, buf, len, nb);
		if(waserror()){
			io-&gt;cmd(STOP_TRANSMISSION, 0, r);
			nexterror();
		}
		io-&gt;cmd(write? WRITE_MULTIPLE_BLOCK: READ_MULTIPLE_BLOCK,
			ctl-&gt;ocr &amp; Ccs? b: b * len, r);
		io-&gt;io(write, buf, nb * len);
		poperror();
		io-&gt;cmd(STOP_TRANSMISSION, 0, r);
		poperror();
		b += nb;
	}else{
		for(b = bno; b &lt; bno + nb; b++){
			io-&gt;iosetup(write, buf, len, 1);
			io-&gt;cmd(write? WRITE_BLOCK : READ_SINGLE_BLOCK,
				ctl-&gt;ocr &amp; Ccs? b: b * len, r);
			io-&gt;io(write, buf, len);
			buf += len;
		}
	}
	return (b - bno) * len;
}

static int
mmcrio(SDreq*)
{
	return -1;
}

SDifc sdmmcifc = {
	.name	= "mmc",
	.pnp	= mmcpnp,
	.enable	= mmcenable,
	.verify	= mmcverify,
	.online	= mmconline,
	.rctl	= mmcrctl,
	.bio	= mmcbio,
	.rio	= mmcrio,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

