<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/sdscsi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/sdscsi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "ureg.h"
#include "../port/error.h"

#include "../port/sd.h"

static int
scsitest(SDreq* r)
{
	r-&gt;write = 0;
	memset(r-&gt;cmd, 0, sizeof(r-&gt;cmd));
	r-&gt;cmd[1] = r-&gt;lun&lt;&lt;5;
	r-&gt;clen = 6;
	r-&gt;data = nil;
	r-&gt;dlen = 0;
	r-&gt;flags = 0;

	r-&gt;status = ~0;

	return r-&gt;unit-&gt;dev-&gt;ifc-&gt;rio(r);
}

int
scsiverify(SDunit* unit)
{
	SDreq *r;
	int i, status;
	uchar *inquiry;

	if((r = malloc(sizeof(SDreq))) == nil)
		return 0;
	if((inquiry = sdmalloc(sizeof(unit-&gt;inquiry))) == nil){
		free(r);
		return 0;
	}
	r-&gt;unit = unit;
	r-&gt;lun = 0;		/* ??? */

	memset(unit-&gt;inquiry, 0, sizeof(unit-&gt;inquiry));
	r-&gt;write = 0;
	r-&gt;cmd[0] = 0x12;
	r-&gt;cmd[1] = r-&gt;lun&lt;&lt;5;
	r-&gt;cmd[4] = sizeof(unit-&gt;inquiry)-1;
	r-&gt;clen = 6;
	r-&gt;data = inquiry;
	r-&gt;dlen = sizeof(unit-&gt;inquiry)-1;
	r-&gt;flags = 0;

	r-&gt;status = ~0;
	if(unit-&gt;dev-&gt;ifc-&gt;rio(r) != SDok){
		free(r);
		return 0;
	}
	memmove(unit-&gt;inquiry, inquiry, r-&gt;dlen);
	free(inquiry);

	SET(status);
	for(i = 0; i &lt; 3; i++){
		while((status = scsitest(r)) == SDbusy)
			;
		if(status == SDok || status != SDcheck)
			break;
		if(!(r-&gt;flags &amp; SDvalidsense))
			break;
		if((r-&gt;sense[2] &amp; 0x0F) != 0x02)
			continue;

		/*
		 * Unit is 'not ready'.
		 * If it is in the process of becoming ready or needs
		 * an initialising command, set status so it will be spun-up
		 * below.
		 * If there's no medium, that's OK too, but don't
		 * try to spin it up.
		 */
		if(r-&gt;sense[12] == 0x04){
			if(r-&gt;sense[13] == 0x02 || r-&gt;sense[13] == 0x01){
				status = SDok;
				break;
			}
		}
		if(r-&gt;sense[12] == 0x3A)
			break;
	}

	if(status == SDok){
		/*
		 * Try to ensure a direct-access device is spinning.
		 * Don't wait for completion, ignore the result.
		 */
		if((unit-&gt;inquiry[0] &amp; SDinq0periphtype) == SDperdisk){
			memset(r-&gt;cmd, 0, sizeof(r-&gt;cmd));
			r-&gt;write = 0;
			r-&gt;cmd[0] = 0x1B;
			r-&gt;cmd[1] = (r-&gt;lun&lt;&lt;5)|0x01;
			r-&gt;cmd[4] = 1;
			r-&gt;clen = 6;
			r-&gt;data = nil;
			r-&gt;dlen = 0;
			r-&gt;flags = 0;

			r-&gt;status = ~0;
			unit-&gt;dev-&gt;ifc-&gt;rio(r);
		}
	}
	free(r);

	if(status == SDok || status == SDcheck)
		return 1;
	return 0;
}

static int
scsirio(SDreq* r)
{
	/*
	 * Perform an I/O request, returning
	 *	-1	failure
	 *	 0	ok
	 *	 1	no medium present
	 *	 2	retry
	 * The contents of r may be altered so the
	 * caller should re-initialise if necesary.
	 */
	r-&gt;status = ~0;
	switch(r-&gt;unit-&gt;dev-&gt;ifc-&gt;rio(r)){
	default:
		break;
	case SDcheck:
		if(!(r-&gt;flags &amp; SDvalidsense))
			break;
		switch(r-&gt;sense[2] &amp; 0x0F){
		case 0x00:		/* no sense */
		case 0x01:		/* recovered error */
			return 2;
		case 0x06:		/* check condition */
			/*
			 * 0x28 - not ready to ready transition,
			 *	  medium may have changed.
			 * 0x29 - power on or some type of reset.
			 */
			if(r-&gt;sense[12] == 0x28 &amp;&amp; r-&gt;sense[13] == 0)
				return 2;
			if(r-&gt;sense[12] == 0x29)
				return 2;
			break;
		case 0x02:		/* not ready */
			/*
			 * If no medium present, bail out.
			 * If unit is becoming ready, rather than not
			 * not ready, wait a little then poke it again. 				 */
			if(r-&gt;sense[12] == 0x3A)
				break;
			if(r-&gt;sense[12] != 0x04 || r-&gt;sense[13] != 0x01)
				break;

			while(waserror())
				;
			tsleep(&amp;up-&gt;sleep, return0, 0, 500);
			poperror();
			scsitest(r);
			return 2;
		default:
			break;
		}
		break;
	case SDok:
		return 0;
	}
	return -1;
}

int
scsionline(SDunit* unit)
{
	SDreq *r;
	uchar *p;
	int ok, retries;

	if((r = malloc(sizeof(SDreq))) == nil)
		return 0;
	if((p = sdmalloc(8)) == nil){
		free(r);
		return 0;
	}

	ok = 0;

	r-&gt;unit = unit;
	r-&gt;lun = 0;				/* ??? */
	for(retries = 0; retries &lt; 10; retries++){
		/*
		 * Read-capacity is mandatory for DA, WORM, CD-ROM and
		 * MO. It may return 'not ready' if type DA is not
		 * spun up, type MO or type CD-ROM are not loaded or just
		 * plain slow getting their act together after a reset.
		 */
		r-&gt;write = 0;
		memset(r-&gt;cmd, 0, sizeof(r-&gt;cmd));
		r-&gt;cmd[0] = 0x25;
		r-&gt;cmd[1] = r-&gt;lun&lt;&lt;5;
		r-&gt;clen = 10;
		r-&gt;data = p;
		r-&gt;dlen = 8;
		r-&gt;flags = 0;

		r-&gt;status = ~0;
		switch(scsirio(r)){
		default:
			break;
		case 0:
			unit-&gt;sectors = (p[0]&lt;&lt;24)|(p[1]&lt;&lt;16)|(p[2]&lt;&lt;8)|p[3];
			unit-&gt;secsize = (p[4]&lt;&lt;24)|(p[5]&lt;&lt;16)|(p[6]&lt;&lt;8)|p[7];

			/*
			 * Some ATAPI CD readers lie about the block size.
			 * Since we don't read audio via this interface
			 * it's okay to always fudge this.
			 */
			if(unit-&gt;secsize == 2352)
				unit-&gt;secsize = 2048;
			/*
			 * Devices with removable media may return 0 sectors
			 * when they have empty media (e.g. sata dvd writers);
			 * if so, keep the count zero.
			 *
			 * Read-capacity returns the LBA of the last sector,
			 * therefore the number of sectors must be incremented.
			 */
			if(unit-&gt;sectors != 0)
				unit-&gt;sectors++;
			ok = 1;
			break;
		case 1:
			ok = 1;
			break;
		case 2:
			continue;
		}
		break;
	}
	free(p);
	free(r);

	if(ok)
		return ok+retries;
	else
		return 0;
}

int
scsiexec(SDunit* unit, int write, uchar* cmd, int clen, void* data, int* dlen)
{
	SDreq *r;
	int status;

	if((r = malloc(sizeof(SDreq))) == nil)
		return SDmalloc;
	r-&gt;unit = unit;
	r-&gt;lun = cmd[1]&gt;&gt;5;		/* ??? */
	r-&gt;write = write;
	memmove(r-&gt;cmd, cmd, clen);
	r-&gt;clen = clen;
	r-&gt;data = data;
	if(dlen)
		r-&gt;dlen = *dlen;
	r-&gt;flags = 0;

	r-&gt;status = ~0;

	/*
	 * Call the device-specific I/O routine.
	 * There should be no calls to 'error()' below this
	 * which percolate back up.
	 */
	switch(status = unit-&gt;dev-&gt;ifc-&gt;rio(r)){
	case SDok:
		if(dlen)
			*dlen = r-&gt;rlen;
		/*FALLTHROUGH*/
	case SDcheck:
		/*FALLTHROUGH*/
	default:
		/*
		 * It's more complicated than this. There are conditions
		 * which are 'ok' but for which the returned status code
		 * is not 'SDok'.
		 * Also, not all conditions require a reqsense, might
		 * need to do a reqsense here and make it available to the
		 * caller somehow.
		 *
		 * Mañana.
		 */
		break;
	}
	sdfree(r);

	return status;
}

static void
scsifmt10(SDreq *r, int write, int lun, ulong nb, uvlong bno)
{
	uchar *c;

	c = r-&gt;cmd;
	if(write == 0)
		c[0] = 0x28;
	else
		c[0] = 0x2A;
	c[1] = lun&lt;&lt;5;
	c[2] = bno&gt;&gt;24;
	c[3] = bno&gt;&gt;16;
	c[4] = bno&gt;&gt;8;
	c[5] = bno;
	c[6] = 0;
	c[7] = nb&gt;&gt;8;
	c[8] = nb;
	c[9] = 0;

	r-&gt;clen = 10;
}

static void
scsifmt16(SDreq *r, int write, int lun, ulong nb, uvlong bno)
{
	uchar *c;

	c = r-&gt;cmd;
	if(write == 0)
		c[0] = 0x88;
	else
		c[0] = 0x8A;
	c[1] = lun&lt;&lt;5;		/* so wrong */
	c[2] = bno&gt;&gt;56;
	c[3] = bno&gt;&gt;48;
	c[4] = bno&gt;&gt;40;
	c[5] = bno&gt;&gt;32;
	c[6] = bno&gt;&gt;24;
	c[7] = bno&gt;&gt;16;
	c[8] = bno&gt;&gt;8;
	c[9] = bno;
	c[10] = nb&gt;&gt;24;
	c[11] = nb&gt;&gt;16;
	c[12] = nb&gt;&gt;8;
	c[13] = nb;
	c[14] = 0;
	c[15] = 0;

	r-&gt;clen = 16;
}

long
scsibio(SDunit* unit, int lun, int write, void* data, long nb, uvlong bno)
{
	SDreq *r;
	long rlen;

	if((r = malloc(sizeof(SDreq))) == nil)
		error(Enomem);
	r-&gt;unit = unit;
	r-&gt;lun = lun;
again:
	r-&gt;write = write;
	if(bno &gt;= (1ULL&lt;&lt;32))
		scsifmt16(r, write, lun, nb, bno);
	else
		scsifmt10(r, write, lun, nb, bno);
	r-&gt;data = data;
	r-&gt;dlen = nb*unit-&gt;secsize;
	r-&gt;flags = 0;

	r-&gt;status = ~0;
	switch(scsirio(r)){
	default:
		rlen = -1;
		break;
	case 0:
		rlen = r-&gt;rlen;
		break;
	case 2:
		rlen = -1;
		if(!(r-&gt;flags &amp; SDvalidsense))
			break;
		switch(r-&gt;sense[2] &amp; 0x0F){
		default:
			break;
		case 0x01:		/* recovered error */
			print("%s: recovered error at sector %llud\n",
				unit-&gt;name, bno);
			rlen = r-&gt;rlen;
			break;
		case 0x06:		/* check condition */
			/*
			 * Check for a removeable media change.
			 * If so, mark it by zapping the geometry info
			 * to force an online request.
			 */
			if(r-&gt;sense[12] != 0x28 || r-&gt;sense[13] != 0)
				break;
			if(unit-&gt;inquiry[1] &amp; SDinq1removable)
				unit-&gt;sectors = 0;
			break;
		case 0x02:		/* not ready */
			/*
			 * If unit is becoming ready,
			 * rather than not not ready, try again.
			 */
			if(r-&gt;sense[12] == 0x04 &amp;&amp; r-&gt;sense[13] == 0x01)
				goto again;
			break;
		}
		break;
	}
	free(r);

	return rlen;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

