<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/swap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/swap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

static int	canflush(Proc*, Segment*);
static void	executeio(void);
static int	needpages(void*);
static void	pageout(Proc*, Segment*);
static void	pagepte(int, Page**);
static void	pager(void*);

Image 	swapimage;

static 	int	swopen;
static	Page	**iolist;
static	int	ioptr;

static	ulong	genage, genclock, gencount;
static	uvlong	gensum;

static void
gentick(void)
{
	genclock++;
	if(gencount)
		genage = gensum / gencount;
	else
		genage = 0;
	gensum = gencount = 0;
}

void
swapinit(void)
{
	swapalloc.swmap = xalloc(conf.nswap);
	swapalloc.top = &amp;swapalloc.swmap[conf.nswap];
	swapalloc.alloc = swapalloc.swmap;
	swapalloc.last = swapalloc.swmap;
	swapalloc.free = conf.nswap;
	iolist = xalloc(conf.nswppo*sizeof(Page*));
	if(swapalloc.swmap == 0 || iolist == 0)
		panic("swapinit: not enough memory");

	swapimage.notext = 1;
}

ulong
newswap(void)
{
	uchar *look;

	lock(&amp;swapalloc);

	if(swapalloc.free == 0){
		unlock(&amp;swapalloc);
		return ~0;
	}

	look = memchr(swapalloc.last, 0, swapalloc.top-swapalloc.last);
	if(look == 0)
		panic("inconsistent swap");

	*look = 1;
	swapalloc.last = look;
	swapalloc.free--;
	unlock(&amp;swapalloc);
	return (look-swapalloc.swmap) * BY2PG;
}

void
putswap(Page *p)
{
	uchar *idx;

	lock(&amp;swapalloc);
	idx = &amp;swapalloc.swmap[((ulong)p)/BY2PG];
	if(--(*idx) == 0) {
		swapalloc.free++;
		if(idx &lt; swapalloc.last)
			swapalloc.last = idx;
	}
	if(*idx &gt;= 254)
		panic("putswap %#p == %ud", p, *idx);
	unlock(&amp;swapalloc);
}

void
dupswap(Page *p)
{
	lock(&amp;swapalloc);
	if(++swapalloc.swmap[((ulong)p)/BY2PG] == 0)
		panic("dupswap");
	unlock(&amp;swapalloc);
}

int
swapcount(ulong daddr)
{
	return swapalloc.swmap[daddr/BY2PG];
}

void
kickpager(void)
{
	static int started;

	if(started)
		wakeup(&amp;swapalloc.r);
	else {
		kproc("pager", pager, 0);
		started = 1;
	}
}

static void
pager(void *junk)
{
	int i;
	Segment *s;
	Proc *p, *ep;

	if(waserror())
		panic("pager: os error");

	p = proctab(0);
	ep = &amp;p[conf.nproc];

loop:
	up-&gt;psstate = "Idle";
	wakeup(&amp;palloc.r);
	sleep(&amp;swapalloc.r, needpages, 0);

	while(needpages(junk)) {
		if(swapimage.c) {
			p++;
			if(p &gt;= ep){
				p = proctab(0);
				gentick();			
			}

			if(p-&gt;state == Dead || p-&gt;noswap)
				continue;

			if(!canqlock(&amp;p-&gt;seglock))
				continue;		/* process changing its segments */

			for(i = 0; i &lt; NSEG; i++) {
				if(!needpages(junk)){
					qunlock(&amp;p-&gt;seglock);
					goto loop;
				}

				if(s = p-&gt;seg[i]) {
					switch(s-&gt;type&amp;SG_TYPE) {
					default:
						break;
					case SG_TEXT:
						pageout(p, s);
						break;
					case SG_DATA:
					case SG_BSS:
					case SG_STACK:
					case SG_SHARED:
						up-&gt;psstate = "Pageout";
						pageout(p, s);
						if(ioptr != 0) {
							up-&gt;psstate = "I/O";
							executeio();
						}
						break;
					}
				}
			}
			qunlock(&amp;p-&gt;seglock);
		} else {
			print("out of memory\n");
			killbig("out of memory");
			freebroken();		/* can use the memory */

			/* Emulate the old system if no swap channel */
			if(!swapimage.c)
				tsleep(&amp;up-&gt;sleep, return0, 0, 5000);
		}
	}
	goto loop;
}

static void
pageout(Proc *p, Segment *s)
{
	int type, i, size;
	ulong age;
	Pte *l;
	Page **pg, *entry;

	if(!canqlock(&amp;s-&gt;lk))	/* We cannot afford to wait, we will surely deadlock */
		return;

	if(s-&gt;steal) {		/* Protected by /dev/proc */
		qunlock(&amp;s-&gt;lk);
		return;
	}

	if(!canflush(p, s)) {	/* Able to invalidate all tlbs with references */
		qunlock(&amp;s-&gt;lk);
		putseg(s);
		return;
	}

	if(waserror()) {
		qunlock(&amp;s-&gt;lk);
		putseg(s);
		return;
	}

	/* Pass through the pte tables looking for memory pages to swap out */
	type = s-&gt;type&amp;SG_TYPE;
	size = s-&gt;mapsize;
	for(i = 0; i &lt; size; i++) {
		l = s-&gt;map[i];
		if(l == 0)
			continue;
		for(pg = l-&gt;first; pg &lt; l-&gt;last; pg++) {
			entry = *pg;
			if(pagedout(entry))
				continue;

			if(entry-&gt;modref &amp; PG_REF) {
				entry-&gt;modref &amp;= ~PG_REF;
				entry-&gt;gen = genclock;
			}

			if(genclock &lt; entry-&gt;gen)
				age = ~(entry-&gt;gen - genclock);
			else
				age = genclock - entry-&gt;gen;
			gensum += age;
			gencount++;
			if(age &lt;= genage)
				continue;

			pagepte(type, pg);

			if(ioptr &gt;= conf.nswppo)
				goto out;
		}
	}
out:
	poperror();
	qunlock(&amp;s-&gt;lk);
	putseg(s);
}

static int
canflush(Proc *p, Segment *s)
{
	int i;
	Proc *ep;

	lock(s);
	if(s-&gt;ref == 1) {		/* Easy if we are the only user */
		s-&gt;ref++;
		unlock(s);
		return canpage(p);
	}
	s-&gt;ref++;
	unlock(s);

	/* Now we must do hardwork to ensure all processes which have tlb
	 * entries for this segment will be flushed if we succeed in paging it out
	 */
	p = proctab(0);
	ep = &amp;p[conf.nproc];
	while(p &lt; ep) {
		if(p-&gt;state != Dead) {
			for(i = 0; i &lt; NSEG; i++)
				if(p-&gt;seg[i] == s)
					if(!canpage(p))
						return 0;
		}
		p++;
	}
	return 1;
}

static void
pagepte(int type, Page **pg)
{
	ulong daddr;
	Page *outp;

	outp = *pg;
	switch(type) {
	case SG_TEXT:				/* Revert to demand load */
		putpage(outp);
		*pg = 0;
		break;

	case SG_DATA:
	case SG_BSS:
	case SG_STACK:
	case SG_SHARED:
		/*
		 *  get a new swap address and clear any pages
		 *  referring to it from the cache
		 */
		daddr = newswap();
		if(daddr == ~0)
			break;
		cachedel(&amp;swapimage, daddr);

		lock(outp);

		/* forget anything that it used to cache */
		uncachepage(outp);

		/*
		 *  incr the reference count to make sure it sticks around while
		 *  being written
		 */
		outp-&gt;ref++;

		/*
		 *  enter it into the cache so that a fault happening
		 *  during the write will grab the page from the cache
		 *  rather than one partially written to the disk
		 */
		outp-&gt;daddr = daddr;
		cachepage(outp, &amp;swapimage);
		*pg = (Page*)(daddr|PG_ONSWAP);
		unlock(outp);

		/* Add page to IO transaction list */
		iolist[ioptr++] = outp;
		break;
	}
}

void
pagersummary(void)
{
	print("%lud/%lud memory %lud/%lud swap %d iolist\n",
		palloc.user-palloc.freecount,
		palloc.user, conf.nswap-swapalloc.free, conf.nswap,
		ioptr);
}

static int
pageiocomp(void *a, void *b)
{
	Page *p1, *p2;

	p1 = *(Page **)a;
	p2 = *(Page **)b;
	if(p1-&gt;daddr &gt; p2-&gt;daddr)
		return 1;
	else
		return -1;
}

static void
executeio(void)
{
	Page *out;
	int i, n;
	Chan *c;
	char *kaddr;
	KMap *k;

	c = swapimage.c;
	qsort(iolist, ioptr, sizeof iolist[0], pageiocomp);
	for(i = 0; i &lt; ioptr; i++) {
		if(ioptr &gt; conf.nswppo)
			panic("executeio: ioptr %d &gt; %d", ioptr, conf.nswppo);
		out = iolist[i];
		k = kmap(out);
		kaddr = (char*)VA(k);

		if(waserror())
			panic("executeio: page out I/O error");

		n = devtab[c-&gt;type]-&gt;write(c, kaddr, BY2PG, out-&gt;daddr);
		if(n != BY2PG)
			nexterror();

		kunmap(k);
		poperror();

		/* Free up the page after I/O */
		lock(out);
		out-&gt;ref--;
		unlock(out);
		putpage(out);
	}
	ioptr = 0;
}

static int
needpages(void*)
{
	return palloc.freecount &lt; swapalloc.headroom;
}

void
setswapchan(Chan *c)
{
	uchar dirbuf[sizeof(Dir)+100];
	Dir d;
	int n;

	if(swapimage.c) {
		if(swapalloc.free != conf.nswap){
			cclose(c);
			error(Einuse);
		}
		cclose(swapimage.c);
	}

	/*
	 *  if this isn't a file, set the swap space
	 *  to be at most the size of the partition
	 */
	if(devtab[c-&gt;type]-&gt;dc != L'M'){
		n = devtab[c-&gt;type]-&gt;stat(c, dirbuf, sizeof dirbuf);
		if(n &lt;= 0){
			cclose(c);
			error("stat failed in setswapchan");
		}
		convM2D(dirbuf, n, &amp;d, nil);
		if(d.length &lt; conf.nswap*BY2PG){
			conf.nswap = d.length/BY2PG;
			swapalloc.top = &amp;swapalloc.swmap[conf.nswap];
			swapalloc.free = conf.nswap;
		}
	}

	swapimage.c = c;
}

int
swapfull(void)
{
	return swapalloc.free &lt; conf.nswap/10;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

