<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/taslock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/taslock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "../port/error.h"
#include "../port/edf.h"

long maxlockcycles;
long maxilockcycles;
long cumlockcycles;
long cumilockcycles;
ulong maxlockpc;
ulong maxilockpc;

struct
{
	ulong	locks;
	ulong	glare;
	ulong	inglare;
} lockstats;

static void
inccnt(Ref *r)
{
	_xinc(&amp;r-&gt;ref);
}

static int
deccnt(Ref *r)
{
	int x;

	x = _xdec(&amp;r-&gt;ref);
	if(x &lt; 0)
		panic("deccnt pc=%#p", getcallerpc(&amp;r));
	return x;
}

static void
dumplockmem(char *tag, Lock *l)
{
	uchar *cp;
	int i;

	iprint("%s: ", tag);
	cp = (uchar*)l;
	for(i = 0; i &lt; 64; i++)
		iprint("%2.2ux ", cp[i]);
	iprint("\n");
}

void
lockloop(Lock *l, ulong pc)
{
	Proc *p;

	p = l-&gt;p;
	print("lock %#p loop key %#lux pc %#lux held by pc %#lux proc %lud\n",
		l, l-&gt;key, pc, l-&gt;pc, p ? p-&gt;pid : 0);
	dumpaproc(up);
	if(p != nil)
		dumpaproc(p);
}

int
lock(Lock *l)
{
	int i;
	ulong pc;

	pc = getcallerpc(&amp;l);

	lockstats.locks++;
	if(up)
		inccnt(&amp;up-&gt;nlocks);	/* prevent being scheded */
	if(tas(&amp;l-&gt;key) == 0){
		if(up)
			up-&gt;lastlock = l;
		l-&gt;pc = pc;
		l-&gt;p = up;
		l-&gt;isilock = 0;
#ifdef LOCKCYCLES
		l-&gt;lockcycles = -lcycles();
#endif
		return 0;
	}
	if(up)
		deccnt(&amp;up-&gt;nlocks);

	lockstats.glare++;
	for(;;){
		lockstats.inglare++;
		i = 0;
		while(l-&gt;key){
			if(conf.nmach &lt; 2 &amp;&amp; up &amp;&amp; up-&gt;edf &amp;&amp; (up-&gt;edf-&gt;flags &amp; Admitted)){
				/*
				 * Priority inversion, yield on a uniprocessor; on a
				 * multiprocessor, the other processor will unlock
				 */
				print("inversion %#p pc %#lux proc %lud held by pc %#lux proc %lud\n",
					l, pc, up ? up-&gt;pid : 0, l-&gt;pc, l-&gt;p ? l-&gt;p-&gt;pid : 0);
				up-&gt;edf-&gt;d = todget(nil);	/* yield to process with lock */
			}
			if(i++ &gt; 100000000){
				i = 0;
				lockloop(l, pc);
			}
		}
		if(up)
			inccnt(&amp;up-&gt;nlocks);
		if(tas(&amp;l-&gt;key) == 0){
			if(up)
				up-&gt;lastlock = l;
			l-&gt;pc = pc;
			l-&gt;p = up;
			l-&gt;isilock = 0;
#ifdef LOCKCYCLES
			l-&gt;lockcycles = -lcycles();
#endif
			return 1;
		}
		if(up)
			deccnt(&amp;up-&gt;nlocks);
	}
}

void
ilock(Lock *l)
{
	ulong x;
	ulong pc;

	pc = getcallerpc(&amp;l);
	lockstats.locks++;

	x = splhi();
	if(tas(&amp;l-&gt;key) != 0){
		lockstats.glare++;
		/*
		 * Cannot also check l-&gt;pc, l-&gt;m, or l-&gt;isilock here
		 * because they might just not be set yet, or
		 * (for pc and m) the lock might have just been unlocked.
		 */
		for(;;){
			lockstats.inglare++;
			splx(x);
			while(l-&gt;key)
				;
			x = splhi();
			if(tas(&amp;l-&gt;key) == 0)
				goto acquire;
		}
	}
acquire:
	m-&gt;ilockdepth++;
	if(up)
		up-&gt;lastilock = l;
	l-&gt;sr = x;
	l-&gt;pc = pc;
	l-&gt;p = up;
	l-&gt;isilock = 1;
	l-&gt;m = MACHP(m-&gt;machno);
#ifdef LOCKCYCLES
	l-&gt;lockcycles = -lcycles();
#endif
}

int
canlock(Lock *l)
{
	if(up)
		inccnt(&amp;up-&gt;nlocks);
	if(tas(&amp;l-&gt;key)){
		if(up)
			deccnt(&amp;up-&gt;nlocks);
		return 0;
	}

	if(up)
		up-&gt;lastlock = l;
	l-&gt;pc = getcallerpc(&amp;l);
	l-&gt;p = up;
	l-&gt;m = MACHP(m-&gt;machno);
	l-&gt;isilock = 0;
#ifdef LOCKCYCLES
	l-&gt;lockcycles = -lcycles();
#endif
	return 1;
}

void
unlock(Lock *l)
{
#ifdef LOCKCYCLES
	l-&gt;lockcycles += lcycles();
	cumlockcycles += l-&gt;lockcycles;
	if(l-&gt;lockcycles &gt; maxlockcycles){
		maxlockcycles = l-&gt;lockcycles;
		maxlockpc = l-&gt;pc;
	}
#endif
	if(l-&gt;key == 0)
		print("unlock: not locked: pc %#p\n", getcallerpc(&amp;l));
	if(l-&gt;isilock)
		print("unlock of ilock: pc %lux, held by %lux\n", getcallerpc(&amp;l), l-&gt;pc);
	if(l-&gt;p != up)
		print("unlock: up changed: pc %#p, acquired at pc %lux, lock p %#p, unlock up %#p\n", getcallerpc(&amp;l), l-&gt;pc, l-&gt;p, up);
	l-&gt;m = nil;
	l-&gt;key = 0;
	coherence();

	if(up &amp;&amp; deccnt(&amp;up-&gt;nlocks) == 0 &amp;&amp; up-&gt;delaysched &amp;&amp; islo()){
		/*
		 * Call sched if the need arose while locks were held
		 * But, don't do it from interrupt routines, hence the islo() test
		 */
		sched();
	}
}

ulong ilockpcs[0x100] = { [0xff] = 1 };
static int n;

void
iunlock(Lock *l)
{
	ulong sr;

#ifdef LOCKCYCLES
	l-&gt;lockcycles += lcycles();
	cumilockcycles += l-&gt;lockcycles;
	if(l-&gt;lockcycles &gt; maxilockcycles){
		maxilockcycles = l-&gt;lockcycles;
		maxilockpc = l-&gt;pc;
	}
	if(l-&gt;lockcycles &gt; 2400)
		ilockpcs[n++ &amp; 0xff]  = l-&gt;pc;
#endif
	if(l-&gt;key == 0)
		print("iunlock: not locked: pc %#p\n", getcallerpc(&amp;l));
	if(!l-&gt;isilock)
		print("iunlock of lock: pc %#p, held by %#lux\n", getcallerpc(&amp;l), l-&gt;pc);
	if(islo())
		print("iunlock while lo: pc %#p, held by %#lux\n", getcallerpc(&amp;l), l-&gt;pc);

	sr = l-&gt;sr;
	l-&gt;m = nil;
	l-&gt;key = 0;
	coherence();
	m-&gt;ilockdepth--;
	if(up)
		up-&gt;lastilock = nil;
	splx(sr);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

