<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/thwack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/thwack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"

#include "thwack.h"

typedef struct Huff	Huff;

enum
{
	MaxFastLen	= 9,
	BigLenCode	= 0x1f4,	/* minimum code for large lenth encoding */
	BigLenBits	= 9,
	BigLenBase	= 4		/* starting items to encode for big lens */
};

enum
{
	StatBytes,
	StatOutBytes,
	StatLits,
	StatMatches,
	StatOffBits,
	StatLenBits,

	StatDelay,
	StatHist,

	MaxStat
};

struct Huff
{
	short	bits;				/* length of the code */
	ulong	encode;				/* the code */
};

static	Huff	lentab[MaxFastLen] =
{
	{2,	0x2},		/* 10 */
	{3,	0x6},		/* 110 */
	{5,	0x1c},		/* 11100 */
	{5,	0x1d},		/* 11101 */
	{6,	0x3c},		/* 111100 */
	{7,	0x7a},		/* 1111010 */
	{7,	0x7b},		/* 1111011 */
	{8,	0xf8},		/* 11111000 */
	{8,	0xf9},		/* 11111001 */
};

void
thwackinit(Thwack *tw)
{
	int i;

	memset(tw, 0, sizeof *tw);
	for(i = 0; i &lt; EWinBlocks; i++){
		tw-&gt;blocks[i].data = tw-&gt;data[i];
		tw-&gt;blocks[i].edata = tw-&gt;blocks[i].data;
		tw-&gt;blocks[i].hash = tw-&gt;hash[i];
		tw-&gt;blocks[i].acked = 0;
	}
}

/*
 * acknowledgement for block seq &amp; nearby preds
 */
void
thwackack(Thwack *tw, ulong seq, ulong mask)
{
	int slot, b;

	slot = tw-&gt;slot;
	for(;;){
		slot--;
		if(slot &lt; 0)
			slot += EWinBlocks;
		if(slot == tw-&gt;slot)
			break;
		if(tw-&gt;blocks[slot].seq != seq)
			continue;

		tw-&gt;blocks[slot].acked = 1;

		if(mask == 0)
			break;
		do{
			b = mask &amp; 1;
			seq--;
			mask &gt;&gt;= 1;
		}while(!b);
	}
}

/*
 * find a string in the dictionary
 */
static int
thwmatch(ThwBlock *b, ThwBlock *eblocks, uchar **ss, uchar *esrc, ulong h)
{
	int then, toff, w, ok;
	uchar *s, *t;

	s = *ss;
	if(esrc &lt; s + MinMatch)
		return 0;

	toff = 0;
	for(; b &lt; eblocks; b++){
		then = b-&gt;hash[(h ^ b-&gt;seq) &amp; HashMask];
		toff += b-&gt;maxoff;
		w = (ushort)(then - b-&gt;begin);

		if(w &gt;= b-&gt;maxoff)
			continue;


		/*
		 * don't need to check for the end because
		 * 1) s too close check above
		 * 2) entries too close not added to hash tables
		 */
		t = w + b-&gt;data;
		if(s[0] != t[0] || s[1] != t[1] || s[2] != t[2])
			continue;
		ok = b-&gt;edata - t;
		if(esrc - s &gt; ok)
			esrc = s + ok;

		t += 3;
		for(s += 3; s &lt; esrc; s++){
			if(*s != *t)
				break;
			t++;
		}
		*ss = s;
		return toff - w;
	}
	return 0;
}

/*
 * knuth vol. 3 multiplicative hashing
 * each byte x chosen according to rules
 * 1/4 &lt; x &lt; 3/10, 1/3 x &lt; &lt; 3/7, 4/7 &lt; x &lt; 2/3, 7/10 &lt; x &lt; 3/4
 * with reasonable spread between the bytes &amp; their complements
 *
 * the 3 byte value appears to be as almost good as the 4 byte value,
 * and might be faster on some machines
 */
/*
#define hashit(c)	(((ulong)(c) * 0x6b43a9) &gt;&gt; (24 - HashLog))
*/
#define hashit(c)	((((ulong)(c) &amp; 0xffffff) * 0x6b43a9b5) &gt;&gt; (32 - HashLog))

/*
 * lz77 compression with single lookup in a hash table for each block
 */
int
thwack(Thwack *tw, uchar *dst, uchar *src, int n, ulong seq, ulong stats[ThwStats])
{
	ThwBlock *eblocks, *b, blocks[CompBlocks];
	uchar *s, *ss, *sss, *esrc, *half, *twdst, *twdmax;
	ulong cont, cseq, bseq, cmask, code, twbits;
	int now, toff, lithist, h, len, slot, bits, use, twnbits, lits, matches, offbits, lenbits, nhist;

	if(n &gt; ThwMaxBlock || n &lt; MinMatch)
		return -1;

	twdst = dst;
	twdmax = dst + n;

	/*
	 * add source to the coding window
	 * there is always enough space
	 */
	slot = tw-&gt;slot;
	b = &amp;tw-&gt;blocks[slot];
	b-&gt;seq = seq;
	b-&gt;acked = 0;
	now = b-&gt;begin + b-&gt;maxoff;
	s = b-&gt;data;
	memmove(s, src, n);
	b-&gt;edata = s + n;
	b-&gt;begin = now;
	b-&gt;maxoff = n;

	/*
	 * set up the history blocks
	 */
	cseq = seq;
	cmask = 0;
	*blocks = *b;
	b = blocks;
	b-&gt;maxoff = 0;
	b++;
	nhist = 0;
	while(b &lt; blocks + CompBlocks){
		slot--;
		if(slot &lt; 0)
			slot += EWinBlocks;
		if(slot == tw-&gt;slot)
			break;
		if(!tw-&gt;blocks[slot].acked)
			continue;
		bseq = tw-&gt;blocks[slot].seq;
		if(cseq == seq){
			if(seq - bseq &gt;= MaxSeqStart)
				break;
			cseq = bseq;
		}else if(cseq - bseq &gt; MaxSeqMask)
			break;
		else
			cmask |= 1 &lt;&lt; (cseq - bseq - 1);
		*b = tw-&gt;blocks[slot];
		nhist += b-&gt;maxoff;
		b++;
	}
	eblocks = b;
	*twdst++ = seq - cseq;
	*twdst++ = cmask;

	cont = (s[0] &lt;&lt; 16) | (s[1] &lt;&lt; 8) | s[2];

	esrc = s + n;
	half = s + (n &gt;&gt; 1);
	twnbits = 0;
	twbits = 0;
	lits = 0;
	matches = 0;
	offbits = 0;
	lenbits = 0;
	lithist = ~0;
	while(s &lt; esrc){
		h = hashit(cont);

		sss = s;
		toff = thwmatch(blocks, eblocks, &amp;sss, esrc, h);
		ss = sss;

		len = ss - s;
		for(; twnbits &gt;= 8; twnbits -= 8){
			if(twdst &gt;= twdmax)
				return -1;
			*twdst++ = twbits &gt;&gt; (twnbits - 8);
		}
		if(len &lt; MinMatch){
			toff = *s;
			lithist = (lithist &lt;&lt; 1) | (toff &lt; 32) | (toff &gt; 127);
			if(lithist &amp; 0x1e){
				twbits = (twbits &lt;&lt; 9) | toff;
				twnbits += 9;
			}else if(lithist &amp; 1){
				toff = (toff + 64) &amp; 0xff;
				if(toff &lt; 96){
					twbits = (twbits &lt;&lt; 10) | toff;
					twnbits += 10;
				}else{
					twbits = (twbits &lt;&lt; 11) | toff;
					twnbits += 11;
				}
			}else{
				twbits = (twbits &lt;&lt; 8) | toff;
				twnbits += 8;
			}
			lits++;
			blocks-&gt;maxoff++;

			/*
			 * speed hack
			 * check for compression progress, bail if none achieved
			 */
			if(s &gt; half){
				if(4 * blocks-&gt;maxoff &lt; 5 * lits)
					return -1;
				half = esrc;
			}

			if(s + MinMatch &lt;= esrc){
				blocks-&gt;hash[(h ^ blocks-&gt;seq) &amp; HashMask] = now;
				if(s + MinMatch &lt; esrc)
					cont = (cont &lt;&lt; 8) | s[MinMatch];
			}
			now++;
			s++;
			continue;
		}

		blocks-&gt;maxoff += len;
		matches++;

		/*
		 * length of match
		 */
		len -= MinMatch;
		if(len &lt; MaxFastLen){
			bits = lentab[len].bits;
			twbits = (twbits &lt;&lt; bits) | lentab[len].encode;
			twnbits += bits;
			lenbits += bits;
		}else{
			code = BigLenCode;
			bits = BigLenBits;
			use = BigLenBase;
			len -= MaxFastLen;
			while(len &gt;= use){
				len -= use;
				code = (code + use) &lt;&lt; 1;
				use &lt;&lt;= (bits &amp; 1) ^ 1;
				bits++;
			}
			twbits = (twbits &lt;&lt; bits) | (code + len);
			twnbits += bits;
			lenbits += bits;

			for(; twnbits &gt;= 8; twnbits -= 8){
				if(twdst &gt;= twdmax)
					return -1;
				*twdst++ = twbits &gt;&gt; (twnbits - 8);
			}
		}

		/*
		 * offset in history
		 */
		toff--;
		for(bits = OffBase; toff &gt;= (1 &lt;&lt; bits); bits++)
			;
		if(bits &lt; MaxOff+OffBase-1){
			twbits = (twbits &lt;&lt; 3) | (bits - OffBase);
			if(bits != OffBase)
				bits--;
			twnbits += bits + 3;
			offbits += bits + 3;
		}else{
			twbits = (twbits &lt;&lt; 4) | 0xe | (bits - (MaxOff+OffBase-1));
			bits--;
			twnbits += bits + 4;
			offbits += bits + 4;
		}
		twbits = (twbits &lt;&lt; bits) | toff &amp; ((1 &lt;&lt; bits) - 1);

		for(; s != ss; s++){
			if(s + MinMatch &lt;= esrc){
				h = hashit(cont);
				blocks-&gt;hash[(h ^ blocks-&gt;seq) &amp; HashMask] = now;
				if(s + MinMatch &lt; esrc)
					cont = (cont &lt;&lt; 8) | s[MinMatch];
			}
			now++;
		}
	}


	if(twnbits &amp; 7){
		twbits &lt;&lt;= 8 - (twnbits &amp; 7);
		twnbits += 8 - (twnbits &amp; 7);
	}
	for(; twnbits &gt;= 8; twnbits -= 8){
		if(twdst &gt;= twdmax)
			return -1;
		*twdst++ = twbits &gt;&gt; (twnbits - 8);
	}

	tw-&gt;slot++;
	if(tw-&gt;slot &gt;= EWinBlocks)
		tw-&gt;slot = 0;

	stats[StatBytes] += blocks-&gt;maxoff;
	stats[StatLits] += lits;
	stats[StatMatches] += matches;
	stats[StatOffBits] += offbits;
	stats[StatLenBits] += lenbits;
	stats[StatDelay] = stats[StatDelay]*7/8 + dst[0];
	stats[StatHist] = stats[StatHist]*7/8 + nhist;
	stats[StatOutBytes] += twdst - dst;

	return twdst - dst;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

