<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/ucallocb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/ucallocb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * allocate Blocks from uncached memory
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

enum
{
	Hdrspc		= 64,		/* leave room for high-level headers */
	Bdead		= 0x51494F42,	/* "QIOB" */
};

struct
{
	Lock;
	ulong	bytes;
} ucialloc;

static Block*
_ucallocb(int size)
{
	Block *b;
	ulong addr;

	if((b = ucalloc(sizeof(Block)+size+Hdrspc)) == nil)
		return nil;

	b-&gt;next = nil;
	b-&gt;list = nil;
	b-&gt;free = 0;
	b-&gt;flag = 0;
	b-&gt;ref = 0;
	_xinc(&amp;b-&gt;ref);

	/* align start of data portion by rounding up */
	addr = (ulong)b;
	addr = ROUND(addr + sizeof(Block), BLOCKALIGN);
	b-&gt;base = (uchar*)addr;

	/* align end of data portion by rounding down */
	b-&gt;lim = ((uchar*)b) + msize(b);
	addr = (ulong)(b-&gt;lim);
	addr = addr &amp; ~(BLOCKALIGN-1);
	b-&gt;lim = (uchar*)addr;

	/* leave sluff at beginning for added headers */
	b-&gt;rp = b-&gt;lim - ROUND(size, BLOCKALIGN);
	if(b-&gt;rp &lt; b-&gt;base)
		panic("_ucallocb");
	b-&gt;wp = b-&gt;rp;

	return b;
}

Block*
ucallocb(int size)
{
	Block *b;

	/*
	 * Check in a process and wait until successful.
	 * Can still error out of here, though.
	 */
	if(up == nil)
		panic("ucallocb without up: %#p", getcallerpc(&amp;size));
	if((b = _ucallocb(size)) == nil)
		panic("ucallocb: no memory for %d bytes", size);
	setmalloctag(b, getcallerpc(&amp;size));

	return b;
}

Block*
uciallocb(int size)
{
	Block *b;
	static int m1, m2, mp;

	if(0 &amp;&amp; ucialloc.bytes &gt; conf.ialloc){
		if((m1++%10000)==0){
			if(mp++ &gt; 1000){
				active.exiting = 1;
				exit(0);
			}
			iprint("uciallocb: limited %lud/%lud\n",
				ucialloc.bytes, conf.ialloc);
		}
		return nil;
	}

	if((b = _ucallocb(size)) == nil){
		if(0 &amp;&amp; (m2++%10000)==0){
			if(mp++ &gt; 1000){
				active.exiting = 1;
				exit(0);
			}
			iprint("uciallocb: no memory %lud/%lud\n",
				ucialloc.bytes, conf.ialloc);
		}
		return nil;
	}
	setmalloctag(b, getcallerpc(&amp;size));
	b-&gt;flag = BINTR;

	ilock(&amp;ucialloc);
	ucialloc.bytes += b-&gt;lim - b-&gt;base;
	iunlock(&amp;ucialloc);

	return b;
}

void
ucfreeb(Block *b)
{
	void *dead = (void*)Bdead;
	long ref;

	if(b == nil || (ref = _xdec(&amp;b-&gt;ref)) &gt; 0)
		return;

	if(ref &lt; 0){
		dumpstack();
		panic("ucfreeb: ref %ld; caller pc %#p", ref, getcallerpc(&amp;b));
	}

	/*
	 * drivers which perform non cache coherent DMA manage their own buffer
	 * pool of uncached buffers and provide their own free routine.
	 */
	if(b-&gt;free) {
		b-&gt;free(b);
		return;
	}
	if(b-&gt;flag &amp; BINTR) {
		ilock(&amp;ucialloc);
		ucialloc.bytes -= b-&gt;lim - b-&gt;base;
		iunlock(&amp;ucialloc);
	}

	/* poison the block in case someone is still holding onto it */
	b-&gt;next = dead;
	b-&gt;rp = dead;
	b-&gt;wp = dead;
	b-&gt;lim = dead;
	b-&gt;base = dead;

	ucfree(b);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

