<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/port/xalloc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/port/xalloc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"

enum
{
	Nhole		= 128,
	Magichole	= 0x484F4C45,			/* HOLE */
};

typedef struct Hole Hole;
typedef struct Xalloc Xalloc;
typedef struct Xhdr Xhdr;

struct Hole
{
	ulong	addr;
	ulong	size;
	ulong	top;
	Hole*	link;
};

struct Xhdr
{
	ulong	size;
	ulong	magix;
	char	data[];
};

struct Xalloc
{
	Lock;
	Hole	hole[Nhole];
	Hole*	flist;
	Hole*	table;
};

static Xalloc	xlists;

void
xinit(void)
{
	int i, n, upages, kpages;
	ulong maxpages;
	Confmem *m;
	Pallocmem *pm;
	Hole *h, *eh;

	eh = &amp;xlists.hole[Nhole-1];
	for(h = xlists.hole; h &lt; eh; h++)
		h-&gt;link = h+1;

	xlists.flist = xlists.hole;

	upages = conf.upages;
	kpages = conf.npage - upages;
	pm = palloc.mem;
	for(i=0; i&lt;nelem(conf.mem); i++){
		m = &amp;conf.mem[i];
		n = m-&gt;npage;
		if(n &gt; kpages)
			n = kpages;
		/* don't try to use non-KADDR-able memory for kernel */
		maxpages = cankaddr(m-&gt;base)/BY2PG;
		if(n &gt; maxpages)
			n = maxpages;
		/* first give to kernel */
		if(n &gt; 0){
			m-&gt;kbase = (ulong)KADDR(m-&gt;base);
			m-&gt;klimit = (ulong)KADDR(m-&gt;base+n*BY2PG);
			xhole(m-&gt;base, n*BY2PG);
			kpages -= n;
		}
		/* if anything left over, give to user */
		if(n &lt; m-&gt;npage){
			if(pm &gt;= palloc.mem+nelem(palloc.mem)){
				print("xinit: losing %lud pages\n", m-&gt;npage-n);
				continue;
			}
			pm-&gt;base = m-&gt;base+n*BY2PG;
			pm-&gt;npage = m-&gt;npage - n;
			pm++;
		}
	}
//	xsummary();			/* call it from main if desired */
}

void*
xspanalloc(ulong size, int align, ulong span)
{
	ulong a, v, t;
	a = (ulong)xalloc(size+align+span);
	if(a == 0)
		panic("xspanalloc: %lud %d %lux", size, align, span);

	if(span &gt; 2) {
		v = (a + span) &amp; ~(span-1);
		t = v - a;
		if(t &gt; 0)
			xhole(PADDR(a), t);
		t = a + span - v;
		if(t &gt; 0)
			xhole(PADDR(v+size+align), t);
	}
	else
		v = a;

	if(align &gt; 1)
		v = (v + align) &amp; ~(align-1);

	return (void*)v;
}

void*
xallocz(ulong size, int zero)
{
	Xhdr *p;
	Hole *h, **l;

	/* add room for magix &amp; size overhead, round up to nearest vlong */
	size += BY2V + offsetof(Xhdr, data[0]);
	size &amp;= ~(BY2V-1);

	ilock(&amp;xlists);
	l = &amp;xlists.table;
	for(h = *l; h; h = h-&gt;link) {
		if(h-&gt;size &gt;= size) {
			p = (Xhdr*)KADDR(h-&gt;addr);
			h-&gt;addr += size;
			h-&gt;size -= size;
			if(h-&gt;size == 0) {
				*l = h-&gt;link;
				h-&gt;link = xlists.flist;
				xlists.flist = h;
			}
			iunlock(&amp;xlists);
			if(zero)
				memset(p, 0, size);
			p-&gt;magix = Magichole;
			p-&gt;size = size;
			return p-&gt;data;
		}
		l = &amp;h-&gt;link;
	}
	iunlock(&amp;xlists);
	return nil;
}

void*
xalloc(ulong size)
{
	return xallocz(size, 1);
}

void
xfree(void *p)
{
	Xhdr *x;

	x = (Xhdr*)((ulong)p - offsetof(Xhdr, data[0]));
	if(x-&gt;magix != Magichole) {
		xsummary();
		panic("xfree(%#p) %#ux != %#lux", p, Magichole, x-&gt;magix);
	}
	xhole(PADDR((uintptr)x), x-&gt;size);
}

int
xmerge(void *vp, void *vq)
{
	Xhdr *p, *q;

	p = (Xhdr*)(((ulong)vp - offsetof(Xhdr, data[0])));
	q = (Xhdr*)(((ulong)vq - offsetof(Xhdr, data[0])));
	if(p-&gt;magix != Magichole || q-&gt;magix != Magichole) {
		int i;
		ulong *wd;
		void *badp;

		xsummary();
		badp = (p-&gt;magix != Magichole? p: q);
		wd = (ulong *)badp - 12;
		for (i = 24; i-- &gt; 0; ) {
			print("%#p: %lux", wd, *wd);
			if (wd == badp)
				print(" &lt;-");
			print("\n");
			wd++;
		}
		panic("xmerge(%#p, %#p) bad magic %#lux, %#lux",
			vp, vq, p-&gt;magix, q-&gt;magix);
	}
	if((uchar*)p+p-&gt;size == (uchar*)q) {
		p-&gt;size += q-&gt;size;
		return 1;
	}
	return 0;
}

void
xhole(ulong addr, ulong size)
{
	ulong top;
	Hole *h, *c, **l;

	if(size == 0)
		return;

	top = addr + size;
	ilock(&amp;xlists);
	l = &amp;xlists.table;
	for(h = *l; h; h = h-&gt;link) {
		if(h-&gt;top == addr) {
			h-&gt;size += size;
			h-&gt;top = h-&gt;addr+h-&gt;size;
			c = h-&gt;link;
			if(c &amp;&amp; h-&gt;top == c-&gt;addr) {
				h-&gt;top += c-&gt;size;
				h-&gt;size += c-&gt;size;
				h-&gt;link = c-&gt;link;
				c-&gt;link = xlists.flist;
				xlists.flist = c;
			}
			iunlock(&amp;xlists);
			return;
		}
		if(h-&gt;addr &gt; addr)
			break;
		l = &amp;h-&gt;link;
	}
	if(h &amp;&amp; top == h-&gt;addr) {
		h-&gt;addr -= size;
		h-&gt;size += size;
		iunlock(&amp;xlists);
		return;
	}

	if(xlists.flist == nil) {
		iunlock(&amp;xlists);
		print("xfree: no free holes, leaked %lud bytes\n", size);
		return;
	}

	h = xlists.flist;
	xlists.flist = h-&gt;link;
	h-&gt;addr = addr;
	h-&gt;top = top;
	h-&gt;size = size;
	h-&gt;link = *l;
	*l = h;
	iunlock(&amp;xlists);
}

void
xsummary(void)
{
	int i;
	Hole *h;

	i = 0;
	for(h = xlists.flist; h; h = h-&gt;link)
		i++;

	print("%d holes free", i);
	i = 0;
	for(h = xlists.table; h; h = h-&gt;link) {
		if (0) {
			print("addr %#.8lux top %#.8lux size %lud\n",
				h-&gt;addr, h-&gt;top, h-&gt;size);
			delay(10);
		}
		i += h-&gt;size;
		if (h == h-&gt;link) {
			print("xsummary: infinite loop broken\n");
			break;
		}
	}
	print(" %d bytes free\n", i);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

