<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/devirq.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/devirq.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"m8260.h"
#include	"../port/error.h"

enum{
	IRQ0 = 18,
	Level = 0,
	Edge = 1,
};

enum{
	Qdir,
	Qirq1,
	Qirq2,
	Qirq3,
	Qirq4,
	Qirq5,
	Qirq6,
	Qirq7,
	Qmstimer,
	Qfpgareset,
	NIRQ,
};

static Dirtab irqdir[]={
	".",		{Qdir, 0, QTDIR},	0,	DMDIR|0555,
	"irq1",		{Qirq1},		0,	0666,
	"irq2",		{Qirq2},		0,	0666,
	"irq3",		{Qirq1},		0,	0666,
	"irq4",		{Qirq1},		0,	0666,
	"irq5",		{Qirq1},		0,	0666,
	"irq6",		{Qirq1},		0,	0666,
	"irq7",		{Qirq1},		0,	0666,
	"mstimer",	{Qmstimer},		0,	0666,
	"fpgareset",	{Qfpgareset},		0,	0222,
};

enum
{
	CMinterrupt,
	CMmode,
	CMreset,
	CMwait,
	CMdebug,
};

Cmdtab irqmsg[] =
{
	CMinterrupt,	"interrupt",	2,
	CMmode,		"mode",		2,
	CMreset,	"reset",	1,
	CMwait,		"wait",		1,
	CMdebug,	"debug",	1,
};

typedef struct Irqconfig Irqconfig;
struct Irqconfig {
	int		intenable;	/* Interrupts are enabled */
	int		mode;		/* level == 0; edge == 1 */
	ulong		interrupts;	/* Count interrupts */
	ulong		sleepints;	/* interrupt count when waiting */
	Rendez		r;		/* Rendez-vous point for interrupt waiting */
	Irqconfig	*next;
	Timer;
};

Irqconfig *irqconfig[NIRQ];	/* irqconfig[0] is not used */
Lock irqlock;

static void interrupt(Ureg*, void*);
void dumpvno(void);

#ifdef notdef
ulong multiplier;

ulong
µs(void)
{
	uvlong x;

	if(multiplier == 0){
		multiplier = (uvlong)(1000000LL &lt;&lt; 16) / m-&gt;cyclefreq;
		print("µs: multiplier %ld, cyclefreq %lld, shifter %d\n", multiplier, m-&gt;cyclefreq, 16);
	}
	cycles(&amp;x);
	return (x*multiplier) &gt;&gt; 16;
}
#endif

static void
ticmstimer(Ureg*, Timer *t)
{
	Irqconfig *ic;

	ic = t-&gt;ta;
 	ic-&gt;interrupts++;
	wakeup(&amp;ic-&gt;r);
}

void
irqenable(Irqconfig *ic, int irq)
{
	/* call with ilock(&amp;irqlock) held */

	if (ic-&gt;intenable)
		return;
	if (irq == Qmstimer){
		if (ic-&gt;tnext == nil)
			ic-&gt;tns = MS2NS(ic-&gt;mode);
		ic-&gt;tmode = Tperiodic;
		timeradd(&amp;ic-&gt;Timer);
	}else{
		if (irqconfig[irq]){
			ic-&gt;next = irqconfig[irq];
			irqconfig[irq] = ic;
		}else{
			ic-&gt;next = nil;
			irqconfig[irq] = ic;
			intrenable(IRQ0 + irq, interrupt, &amp;irqconfig[irq], irqdir[irq].name);
		}
	}
	ic-&gt;intenable = 1;
}

void
irqdisable(Irqconfig *ic, int irq)
{
	Irqconfig **pic;

	/* call with ilock(&amp;irqlock) held */

	if (ic-&gt;intenable == 0)
		return;
	if (irq == Qmstimer){
		timerdel(&amp;ic-&gt;Timer);
	}else{
		for(pic = &amp;irqconfig[irq]; *pic != ic; pic = &amp;(*pic)-&gt;next)
			assert(*pic);
		*pic = (*pic)-&gt;next;
		if (irqconfig[irq] == nil)
			intrdisable(IRQ0 + irq, interrupt, &amp;irqconfig[irq], irqdir[irq].name);
	}
	ic-&gt;intenable = 0;
}

static Chan*
irqattach(char *spec)
{
	return devattach('b', spec);
}

static Walkqid*
irqwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name,nname, irqdir, nelem(irqdir), devgen);
}

static int
irqstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, irqdir, nelem(irqdir), devgen);
}

static Chan*
irqopen(Chan *c, int omode)
{
	Irqconfig *ic;
	int irq;

	irq = (ulong)c-&gt;qid.path;
	if(irq != Qdir){
		ic = mallocz(sizeof(Irqconfig), 1);
		ic-&gt;tf = ticmstimer;
		ic-&gt;ta = ic;
		if (irq == Qmstimer)
			ic-&gt;mode = 1000;
		c-&gt;aux = ic;
	}
	return devopen(c, omode, irqdir, nelem(irqdir), devgen);
}

static void
irqclose(Chan *c)
{
	int irq;
	Irqconfig *ic;

	irq = (ulong)c-&gt;qid.path;
	if(irq == Qdir)
		return;
	ic = c-&gt;aux;
	if (irq &gt; Qmstimer)
		return;
	ilock(&amp;irqlock);
	irqdisable(ic, irq);
	iunlock(&amp;irqlock);
	free(ic);
}

static int
irqtfn(void *arg)
{
	Irqconfig *ic;

	ic = arg;
	return ic-&gt;sleepints != ic-&gt;interrupts;
}

static long
irqread(Chan *c, void *buf, long n, vlong)
{
	int irq;
	Irqconfig *ic;
	char tmp[24];

	if(n &lt;= 0)
		return n;
	irq = (ulong)c-&gt;qid.path;
	if(irq == Qdir)
		return devdirread(c, buf, n, irqdir, nelem(irqdir), devgen);
	if(irq &gt; Qmstimer){
		print("irqread 0x%llux\n", c-&gt;qid.path);
		error(Egreg);
	}
	ic = c-&gt;aux;
	if (ic-&gt;intenable == 0)
		error("disabled");
	ic-&gt;sleepints = ic-&gt;interrupts;
	sleep(&amp;ic-&gt;r, irqtfn, ic);
	if (irq == Qmstimer)
		snprint(tmp, sizeof tmp, "%11lud %d", ic-&gt;interrupts, ic-&gt;mode);
	else
		snprint(tmp, sizeof tmp, "%11lud %s", ic-&gt;interrupts, ic-&gt;mode ?"edge":"level");
	n = readstr(0, buf, n, tmp);
	return n;
}

static long
irqwrite(Chan *c, void *a, long n, vlong)
{
	int irq;
	Irqconfig *ic;
	Cmdbuf *cb;
	Cmdtab *ct;

	if(n &lt;= 0)
		return n;

	irq = (ulong)c-&gt;qid.path;
	if(irq &lt;= 0 || irq &gt;= nelem(irqdir)){
		print("irqwrite 0x%llux\n", c-&gt;qid.path);
		error(Egreg);
	}
	if (irq == Qfpgareset){
		if (strncmp(a, "reset", 5) == 0)
			fpgareset();
		else
			error(Egreg);
		return n;
	}
	ic = c-&gt;aux;

	cb = parsecmd(a, n);

	if(waserror()) {
		free(cb);
		nexterror();
	}
	ct = lookupcmd(cb, irqmsg, nelem(irqmsg));
	switch(ct-&gt;index) {
	case 	CMinterrupt:
		/* Turn interrupts on or off */
		if (strcmp(cb-&gt;f[1], "on") == 0){
			ilock(&amp;irqlock);
			irqenable(ic, irq);
			iomem-&gt;siprr = 0x65009770;
			iunlock(&amp;irqlock);
		}else if (strcmp(cb-&gt;f[1], "off") == 0){
			ilock(&amp;irqlock);
			irqdisable(ic, irq);
			iunlock(&amp;irqlock);
		}else
			error(Ebadarg);
		break;
	case CMmode:
		/* Set mode */
		if (irq == Qmstimer){
			ic-&gt;mode = strtol(cb-&gt;f[1], nil, 0);
			if (ic-&gt;mode &lt;= 0){
				ic-&gt;tns = MS2NS(1000);
				ic-&gt;mode = 1000;
				error(Ebadarg);
			}
			ic-&gt;tns = MS2NS(ic-&gt;mode);
		}else if (strcmp(cb-&gt;f[1], "level") == 0){
			ic-&gt;mode = Level;
			iomem-&gt;siexr &amp;= ~(0x8000 &gt;&gt; irq);
		}else if (strcmp(cb-&gt;f[1], "edge") == 0){
			ic-&gt;mode = Edge;
			iomem-&gt;siexr |= 0x8000 &gt;&gt; irq;
		}else
			error(Ebadarg);
		break;
	case CMreset:
		ic-&gt;interrupts = 0;
		break;
	case CMwait:
		if (ic-&gt;intenable == 0)
			error("interrupts are off");
		ic-&gt;sleepints = ic-&gt;interrupts;
		sleep(&amp;ic-&gt;r, irqtfn, ic);
		break;
	case CMdebug:
		print("simr h/l 0x%lux/0x%lux, sipnr h/l 0x%lux/0x%lux, siexr 0x%lux, siprr 0x%lux\n",
			iomem-&gt;simr_h, iomem-&gt;simr_l,
			iomem-&gt;sipnr_h, iomem-&gt;sipnr_l,
			iomem-&gt;siexr, iomem-&gt;siprr);
//		dumpvno();
	}
	poperror();
	free(cb);

	/* Irqi */
	return n;
}

static void
interrupt(Ureg*, void *arg)
{
	Irqconfig **pic, *ic;
	int irq;

	pic = arg;
	irq = pic - irqconfig;
	if (irq &lt;= 0 || irq &gt; nelem(irqdir)){
		print("Unexpected interrupt: %d\n", irq);
		return;
	}
	ilock(&amp;irqlock);
	if (irq &lt;= Qirq7)
		iomem-&gt;sipnr_h |= 0x8000 &gt;&gt; irq;	/* Clear the interrupt */
	for(ic = *pic; ic; ic = ic-&gt;next){
		ic-&gt;interrupts++;
		wakeup(&amp;ic-&gt;r);
	}
	iunlock(&amp;irqlock);
}

Dev irqdevtab = {
	'b',
	"irq",

	devreset,
	devinit,
	devshutdown,
	irqattach,
	irqwalk,
	irqstat,
	irqopen,
	devcreate,
	irqclose,
	irqread,
	devbread,
	irqwrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

