<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/ethermii.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/ethermii.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"

#include "etherif.h"
#include "../ppc/ethermii.h"

int
mii(Mii* mii, int mask)
{
	MiiPhy *miiphy;
	int bit, oui, phyno, r, rmask;

	/*
	 * Probe through mii for PHYs in mask;
	 * return the mask of those found in the current probe.
	 * If the PHY has not already been probed, update
	 * the Mii information.
	 */
	rmask = 0;
	for(phyno = 0; phyno &lt; NMiiPhy; phyno++){
		bit = 1&lt;&lt;phyno;
		if(!(mask &amp; bit))
			continue;
		if(mii-&gt;mask &amp; bit){
			rmask |= bit;
			continue;
		}
		if(mii-&gt;mir(mii, phyno, Bmsr) == -1)
			continue;
		r = mii-&gt;mir(mii, phyno, Phyidr1);
		oui = (r &amp; 0x3FFF)&lt;&lt;6;
		r = mii-&gt;mir(mii, phyno, Phyidr2);
		oui |= r&gt;&gt;10;
		if(oui == 0xFFFFF || oui == 0)
			continue;

		if((miiphy = malloc(sizeof(MiiPhy))) == nil)
			continue;

		miiphy-&gt;mii = mii;
		miiphy-&gt;oui = oui;
		miiphy-&gt;phyno = phyno;

		miiphy-&gt;anar = ~0;
		miiphy-&gt;fc = ~0;
		miiphy-&gt;mscr = ~0;

		mii-&gt;phy[phyno] = miiphy;
		if(mii-&gt;curphy == nil)
			mii-&gt;curphy = miiphy;
		mii-&gt;mask |= bit;
		mii-&gt;nphy++;

		rmask |= bit;
	}
	return rmask;
}

int
miimir(Mii* mii, int r)
{
	if(mii == nil || mii-&gt;ctlr == nil || mii-&gt;curphy == nil)
		return -1;
	return mii-&gt;mir(mii, mii-&gt;curphy-&gt;phyno, r);
}

int
miimiw(Mii* mii, int r, int data)
{
	if(mii == nil || mii-&gt;ctlr == nil || mii-&gt;curphy == nil)
		return -1;
	return mii-&gt;miw(mii, mii-&gt;curphy-&gt;phyno, r, data);
}

int
miireset(Mii* mii)
{
	int bmcr;

	if(mii == nil || mii-&gt;ctlr == nil || mii-&gt;curphy == nil)
		return -1;
	bmcr = mii-&gt;mir(mii, mii-&gt;curphy-&gt;phyno, Bmcr);
	bmcr |= BmcrR;
	mii-&gt;miw(mii, mii-&gt;curphy-&gt;phyno, Bmcr, bmcr);
	microdelay(1);

	return 0;
}

int
miiane(Mii* mii, int a, int p, int e)
{
	int anar, bmsr, mscr, r, phyno;

	if(mii == nil || mii-&gt;ctlr == nil || mii-&gt;curphy == nil)
		return -1;
	phyno = mii-&gt;curphy-&gt;phyno;

	bmsr = mii-&gt;mir(mii, phyno, Bmsr);
	if(!(bmsr &amp; BmsrAna))
		return -1;

	anar = mii-&gt;mir(mii, phyno, Anar);
	anar &amp;= ~(AnaAP|AnaP|AnaT4|AnaTXFD|AnaTXHD|Ana10FD|Ana10HD);

	if(a != ~0)
		anar |= (AnaT4|AnaTXFD|AnaTXHD|Ana10FD|Ana10HD) &amp; a;
	else if(mii-&gt;curphy-&gt;anar != ~0)
		anar = mii-&gt;curphy-&gt;anar;
	else{
		if(bmsr &amp; Bmsr10THD)
			anar |= Ana10HD;
		if(bmsr &amp; Bmsr10TFD)
			anar |= Ana10FD;
		if(bmsr &amp; Bmsr100TXHD)
			anar |= AnaTXHD;
		if(bmsr &amp; Bmsr100TXFD)
			anar |= AnaTXFD;
	}
	mii-&gt;curphy-&gt;anar = anar;

	if(p != ~0)
		anar |= (AnaAP|AnaP) &amp; p;
	else if(mii-&gt;curphy-&gt;fc != ~0)
		anar |= mii-&gt;curphy-&gt;fc;
	mii-&gt;curphy-&gt;fc = (AnaAP|AnaP) &amp; anar;

	mii-&gt;miw(mii, phyno, Anar, anar);

	mscr = 0;
	if(bmsr &amp; BmsrEs){
		mscr = mii-&gt;mir(mii, phyno, Mscr);
		mscr &amp;= ~(Mscr1000TFD|Mscr1000THD);
		if(e != ~0)
			mscr |= (Mscr1000TFD|Mscr1000THD) &amp; e;
		else if(mii-&gt;curphy-&gt;mscr != ~0)
			mscr = mii-&gt;curphy-&gt;mscr;
		else{
			r = mii-&gt;mir(mii, phyno, Esr);
			if(r &amp; Esr1000THD)
				mscr |= Mscr1000THD;
			if(r &amp; Esr1000TFD)
				mscr |= Mscr1000TFD;
		}
		mii-&gt;miw(mii, phyno, Mscr, mscr);
	}
	mii-&gt;curphy-&gt;mscr = mscr;

	r = mii-&gt;mir(mii, phyno, Bmcr);
	if(!(r &amp; BmcrR)){
		r |= BmcrAne|BmcrRan;
		mii-&gt;miw(mii, phyno, Bmcr, r);
	}

	return 0;
}

int
miistatus(Mii* mii)
{
	MiiPhy *phy;
	int anlpar, bmsr, p, r, phyno;

	if(mii == nil || mii-&gt;ctlr == nil || mii-&gt;curphy == nil)
		return -1;
	phy = mii-&gt;curphy;
	phyno = phy-&gt;phyno;

	/*
	 * Check Auto-Negotiation is complete and link is up.
	 * (Read status twice as the Ls bit is sticky).
	 */
	phy-&gt;bmsr = bmsr = mii-&gt;mir(mii, phyno, Bmsr);
	if(!(bmsr &amp; (BmsrAnc|BmsrAna)))
		return -1;

	phy-&gt;bmsr = bmsr = mii-&gt;mir(mii, phyno, Bmsr);
	if(!(bmsr &amp; BmsrLs)){
		phy-&gt;link = 0;
		return 0;
	}

	phy-&gt;speed = phy-&gt;fd = phy-&gt;rfc = phy-&gt;tfc = 0;
	if(phy-&gt;mscr &amp; (Mscr1000TFD|Mscr1000THD)){
		r = mii-&gt;mir(mii, phyno, Mssr);
		if((phy-&gt;mscr &amp; Mscr1000TFD) &amp;&amp; (r &amp; Mssr1000TFD)){
			phy-&gt;speed = 1000;
			phy-&gt;fd = 1;
		}
		else if((phy-&gt;mscr &amp; Mscr1000THD) &amp;&amp; (r &amp; Mssr1000THD))
			phy-&gt;speed = 1000;
	}

	anlpar = mii-&gt;mir(mii, phyno, Anlpar);
	if(phy-&gt;speed == 0){
		r = phy-&gt;anar &amp; anlpar;
		if(r &amp; AnaTXFD){
			phy-&gt;speed = 100;
			phy-&gt;fd = 1;
		}
		else if(r &amp; AnaTXHD)
			phy-&gt;speed = 100;
		else if(r &amp; Ana10FD){
			phy-&gt;speed = 10;
			phy-&gt;fd = 1;
		}
		else if(r &amp; Ana10HD)
			phy-&gt;speed = 10;
	}
	if(phy-&gt;speed == 0)
		return -1;

	if(phy-&gt;fd){
		p = phy-&gt;fc;
		r = anlpar &amp; (AnaAP|AnaP);
		if(p == AnaAP &amp;&amp; r == (AnaAP|AnaP))
			phy-&gt;tfc = 1;
		else if(p == (AnaAP|AnaP) &amp;&amp; r == AnaAP)
			phy-&gt;rfc = 1;
		else if((p &amp; AnaP) &amp;&amp; (r &amp; AnaP))
			phy-&gt;rfc = phy-&gt;tfc = 1;
	}

	phy-&gt;link = 1;

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

