<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/ethersaturn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/ethersaturn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "../port/netif.h"
#include "msaturn.h"

#include "etherif.h"

enum{
	Etcr = Saturn + 0x0c00,
	Etsr = Saturn + 0x0c02,
	Ercr = Saturn + 0x0c04,
	Ersr = Saturn + 0x0c06,
	Eisr = Saturn + 0x0d04,
	Eimr = Saturn + 0x0d06,
	Emacaddr0 = Saturn + 0x0e02,
	Miicr = Saturn + 0x0f02,
	Miiwdr = Saturn + 0x0f04,
	Miirdr = Saturn + 0x0f06,

	Ethermem = 0xf2c00000,
	Etherfsize = 0x2000,
	Nrx = 14,
	Ntx = 2,		// Nrx + Ntx must be 16

	Ersr_rxfpmask = 0xf,
	Ersr_rxevent = RBIT(0, ushort),
	Etcr_txfpmask = 0xf,
	Ercr_rxenab = RBIT(0, ushort),
	Ercr_auienab = RBIT(2, ushort),
	Etcr_txstart = RBIT(1, ushort),
	Etcr_retries = 0xf&lt;&lt;8,
	Ei_txecall = RBIT(0, ushort),
	Ei_txretry = RBIT(2, ushort),
	Ei_txdefer = RBIT(3, ushort),
	Ei_txcrs = RBIT(4, ushort),
	Ei_txdone = RBIT(5, ushort),
	Ei_rxcrcerr = RBIT(8, ushort),
	Ei_rxdrib = RBIT(9, ushort),
	Ei_rxdone = RBIT(10, ushort),
	Ei_rxshort = RBIT(11, ushort),
	Ei_rxlong = RBIT(12, ushort),

	Miicr_regshift = 6,
	Miicr_read = RBIT(10, ushort),
	Miicr_preambledis = RBIT(12, ushort),
	Miicr_accack = RBIT(14, ushort),
	Miicr_accbsy = RBIT(15, ushort),
};

typedef struct {
	Lock;
	int		txbusy;
	int		txempty;
	int		txfull;
	int		ntx;			/* number of entries in transmit ring */
	int		rxlast;

	int		active;
	ulong	interrupts;	/* statistics */
	ulong	overflows;
} Ctlr;

uchar etheraddr[6] = { 0x90, 0x85, 0x82, 0x32, 0x83, 0x00};
static ushort*etcr=(ushort*)Etcr;
static ushort*etsr=(ushort*)Etsr;
static ushort*ercr=(ushort*)Ercr;
static ushort*ersr=(ushort*)Ersr;
static ushort*eimr=(ushort*)Eimr;
static ushort*eisr=(ushort*)Eisr;
static ushort*miicr=(ushort*)Miicr;
static ushort*miirdr=(ushort*)Miirdr;

static void
txfill(Ether*ether, Ctlr*ctlr)
{
	int len;
	Block *b;
	ushort*dst;

	while(ctlr-&gt;ntx&lt;Ntx){
		if((b=qget(ether-&gt;oq)) == nil)
			break;

		len = BLEN(b);
		dst = (ushort*)(Ethermem+(ctlr-&gt;txempty+Nrx)*Etherfsize);
		*dst = len;
		memmove(&amp;dst[1], b-&gt;rp, len);
		ctlr-&gt;ntx++;
		ctlr-&gt;txempty++;
		if(ctlr-&gt;txempty==Ntx)
			ctlr-&gt;txempty = 0;
		freeb(b);
	}
}

static void
txrestart(Ctlr*ctlr)
{
	if(ctlr-&gt;ntx==0 || ctlr-&gt;txbusy)
		return;
	ctlr-&gt;txbusy = 1;
	*etcr = Etcr_txstart|Etcr_retries|(ctlr-&gt;txfull+Nrx);
}

static void interrupt(Ureg*, void*);

static void
transmit(Ether*ether)
{
	Ctlr *ctlr;

	ctlr = ether-&gt;ctlr;
	ilock(ctlr);
	txfill(ether, ctlr);
	txrestart(ctlr);
	iunlock(ctlr);

}

static void
interrupt(Ureg*, void*arg)
{
	Ctlr*ctlr;
	Ether*ether = arg;
	Etherpkt*pkt;
	ushort ie;
	int rx, len;
	Block *b;

	ctlr = ether-&gt;ctlr;
	if(!ctlr-&gt;active)
		return;	/* not ours */
	ctlr-&gt;interrupts++;

	ilock(ctlr);
	ie = *eisr;
	*eisr = ie;
	intack();

	if(ie==0)
		iprint("interrupt: no interrupt source?\n");

	if(ie&amp;Ei_txdone){
		if((*etcr&amp;Etcr_txstart)==0){
			if(ctlr-&gt;txbusy){
				ctlr-&gt;txbusy = 0;
				ctlr-&gt;ntx--;
				ctlr-&gt;txfull++;
				if(ctlr-&gt;txfull==Ntx)
					ctlr-&gt;txfull = 0;
			}
			txrestart(ctlr);
			txfill(ether, ctlr);
			txrestart(ctlr);
		}
		else
			iprint("interrupt: bogus tx interrupt\n");
		ie &amp;= ~Ei_txdone;
	}

	if(ie&amp;Ei_rxdone){
		rx=*ersr&amp;Ersr_rxfpmask;
		while(ctlr-&gt;rxlast!=rx){

			ctlr-&gt;rxlast++;
			if(ctlr-&gt;rxlast &gt;= Nrx)
				ctlr-&gt;rxlast = 0;

			pkt = (Etherpkt*)(Ethermem+ctlr-&gt;rxlast*Etherfsize);
			len = *(ushort*)pkt;
			if((b = iallocb(len+sizeof(ushort))) != nil){
				memmove(b-&gt;wp, pkt, len+sizeof(ushort));
				b-&gt;rp += sizeof(ushort);
				b-&gt;wp = b-&gt;rp + len;
				etheriq(ether, b, 1);
			}else
				ether-&gt;soverflows++;
			rx=*ersr&amp;Ersr_rxfpmask;
		}
		ie &amp;= ~Ei_rxdone;
	}

	if(ie&amp;Ei_txretry){
		iprint("ethersaturn: txretry!\n");
		ie &amp;= ~Ei_txretry;
		ctlr-&gt;txbusy = 0;
		txrestart(ctlr);
	}

	ie &amp;= ~Ei_txcrs;
	if(ie)
		iprint("interrupt: unhandled interrupts %.4uX\n", ie);
	iunlock(ctlr);
}

static int
reset(Ether* ether)
{
	Ctlr*ctlr;

	*ercr = 0;
	ctlr = malloc(sizeof(*ctlr));
	memset(ctlr, 0, sizeof(*ctlr));
	ctlr-&gt;active = 1;

	ether-&gt;ctlr = ctlr;
	ether-&gt;transmit = transmit;
	ether-&gt;interrupt = interrupt;
	ether-&gt;irq = Vecether;
	ether-&gt;arg = ether;
	memmove(ether-&gt;ea, (ushort*)Emacaddr0, Eaddrlen);

	*ercr = Ercr_rxenab|Ercr_auienab|(Nrx-1);
	*eimr = Ei_rxdone|Ei_txretry|Ei_txdone;
	
	iprint("reset: ercr %.4uX\n", *ercr);
	return 0;
}

void
ethersaturnlink(void)
{
	addethercard("saturn", reset);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

