<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/m8260.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/m8260.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *	8260 specific stuff:
 *		Interrupt handling
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"io.h"
#include	"fns.h"
#include	"m8260.h"

enum {
	Pin4 = BIT(4),
};

static union {
	struct {
		ulong	hi;
		ulong	lo;
	};
	uvlong		val;
} ticks;

struct {
	ulong	hi;
	ulong	lo;
} vec2mask[64]	= {
[0]	= {0,		0	},	/* Error, No interrupt */
[1]	= {0,		BIT(16)	},	/* I2C */
[2]	= {0,		BIT(17)	},	/* SPI */
[3]	= {0,		BIT(18)	},	/* Risc Timers */
[4]	= {0,		BIT(19)	},	/* SMC1 */
[5]	= {0,		BIT(20)	},	/* SMC2 */
[6]	= {0,		BIT(21)	},	/* IDMA1 */
[7]	= {0,		BIT(22)	},	/* IDMA2 */
[8]	= {0,		BIT(23)	},	/* IDMA3 */
[9]	= {0,		BIT(24)	},	/* IDMA4 */
[10]	= {0,		BIT(25)	},	/* SDMA */
[11]	= {0,		0	},	/* Reserved */
[12]	= {0,		BIT(27)	},	/* Timer1 */
[13]	= {0,		BIT(28)	},	/* Timer2 */
[14]	= {0,		BIT(29)	},	/* Timer3 */
[15]	= {0,		BIT(30)	},	/* Timer4 */

[16]	= {BIT(29),	0	},	/* TMCNT */
[17]	= {BIT(30),	0	},	/* PIT */
[18]	= {0,		0	},	/* Reserved */
[19]	= {BIT(17),	0	},	/* IRQ1 */
[20]	= {BIT(18),	0	},	/* IRQ2 */
[21]	= {BIT(19),	0	},	/* IRQ3 */
[22]	= {BIT(20),	0	},	/* IRQ4 */
[23]	= {BIT(21),	0	},	/* IRQ5 */
[24]	= {BIT(22),	0	},	/* IRQ6 */
[25]	= {BIT(23),	0	},	/* IRQ7 */
[26]	= {0,		0	},	/* Reserved */
[27]	= {0,		0	},	/* Reserved */
[28]	= {0,		0	},	/* Reserved */
[29]	= {0,		0	},	/* Reserved */
[30]	= {0,		0	},	/* Reserved */
[31]	= {0,		0	},	/* Reserved */

[32]	= {0,		BIT(0)	},	/* FCC1 */
[33]	= {0,		BIT(1)	},	/* FCC2 */
[34]	= {0,		BIT(2)	},	/* FCC3 */
[35]	= {0,		0	},	/* Reserved */
[36]	= {0,		BIT(4)	},	/* MCC1 */
[37]	= {0,		BIT(5)	},	/* MCC2 */
[38]	= {0,		0	},	/* Reserved */
[39]	= {0,		0	},	/* Reserved */
[40]	= {0,		BIT(8)	},	/* SCC1 */
[41]	= {0,		BIT(9)	},	/* SCC2 */
[42]	= {0,		BIT(10)	},	/* SCC3 */
[43]	= {0,		BIT(11)	},	/* SCC4 */
[44]	= {0,		0	},	/* Reserved */
[45]	= {0,		0	},	/* Reserved */
[46]	= {0,		0	},	/* Reserved */
[47]	= {0,		0	},	/* Reserved */

[48]	= {BIT(15),	0	},	/* PC15 */
[49]	= {BIT(14),	0	},	/* PC14 */
[50]	= {BIT(13),	0	},	/* PC13 */
[51]	= {BIT(12),	0	},	/* PC12 */
[52]	= {BIT(11),	0	},	/* PC11 */
[53]	= {BIT(10),	0	},	/* PC10 */
[54]	= {BIT(9),	0	},	/* PC9 */
[55]	= {BIT(8),	0	},	/* PC8 */
[56]	= {BIT(7),	0	},	/* PC7 */
[57]	= {BIT(6),	0	},	/* PC6 */
[58]	= {BIT(5),	0	},	/* PC5 */
[59]	= {BIT(4),	0	},	/* PC4 */
[60]	= {BIT(3),	0	},	/* PC3 */
[61]	= {BIT(2),	0	},	/* PC2 */
[62]	= {BIT(1),	0	},	/* PC1 */
[63]	= {BIT(0),	0	},	/* PC0 */
};

/* Blast memory layout:
 *	CS0: FE000000 -&gt; FFFFFFFF (Flash)
 *	CS1: FC000000 -&gt; FCFFFFFF (DSP hpi)
 *	CS2: 00000000 -&gt; 03FFFFFF (60x sdram)
 *	CS3: 04000000 -&gt; 04FFFFFF (FPGA)
 *	CS4: 05000000 -&gt; 06FFFFFF (local bus sdram)
 *	CS5: 07000000 -&gt; 0700FFFF (eeprom - not populated)
 *	CS6: E0000000 -&gt; E0FFFFFF (FPGA - 64bits)
 *
 * Main Board memory layout:
 *	CS0: FE000000 -&gt; FEFFFFFF (16 M FLASH)
 *	CS1: FC000000 -&gt; FCFFFFFF (16 M DSP1)
 *	CS2: 00000000 -&gt; 03FFFFFF (64 M SDRAM)
 *	CS3: 04000000 -&gt; 04FFFFFF (16M DSP2)
 *	CS4: 05000000 -&gt; 06FFFFFF (32 M Local SDRAM)
 *	CS5: 07000000 -&gt; 0700FFFF (eeprom - not populated)
 *	CS6: unused
 *	CS7: E0000000 -&gt; E0FFFFFF (16 M FPGA)
 */

IMM* iomem = (IMM*)IOMEM;
uchar etheraddr[6] = { 0x90, 0x85, 0x82, 0x32, 0x83, 0x00};

static Lock cpmlock;

void
machinit(void)
{
	ulong scmr;
	int pllmf;
	extern char* plan9inistr;

	memset(m, 0, sizeof(*m));
	m-&gt;cputype = getpvr()&gt;&gt;16;	/* pvr = 0x00810101 for the 8260 */
	m-&gt;imap = (Imap*)INTMEM;

	m-&gt;loopconst = 1096;

	/* Make sure Ethernet is disabled (boot code may have buffers allocated anywhere in memory) */
	iomem-&gt;fcc[0].gfmr &amp;= ~(BIT(27)|BIT(26));
	iomem-&gt;fcc[1].gfmr &amp;= ~(BIT(27)|BIT(26));
	iomem-&gt;fcc[2].gfmr &amp;= ~(BIT(27)|BIT(26));

	/* Flashed CS configuration is wrong for DSP2.  It's set to 64 bits, should be 16 */
	iomem-&gt;bank[3].br = 0x04001001;	/* Set 16-bit port */

	/*
	 * FPGA is capable of doing 64-bit transfers.  To use these, set br to 0xe0000001.
	 * Currently we use 32-bit transfers, because the 8260 does not easily do 64-bit operations.
	 */
	iomem-&gt;bank[6].br = 0xe0001801;
	iomem-&gt;bank[6].or = 0xff000830;	/* Was 0xff000816 */

/*
 * All systems with rev. A.1 (0K26N) silicon had serious problems when doing
 * DMA transfers with data cache enabled (usually this shows when  using
 * one of the FCC's with some traffic on the ethernet).  Allocating FCC buffer
 * descriptors in main memory instead of DP ram solves this problem.
 */

	/* Guess at clocks based upon the PLL configuration from the
	 * power-on reset.
	 */
	scmr = iomem-&gt;scmr;

	/* The EST8260 is typically run using either 33 or 66 MHz
	 * external clock.  The configuration byte in the Flash will
	 * tell us which is configured.  The blast appears to be slightly
	 * overclocked at 72 MHz (if set to 66 MHz, the uart runs too fast)
	 */

	m-&gt;clkin = CLKIN;

	pllmf = scmr &amp; 0xfff;

	/* This is arithmetic from the 8260 manual, section 9.4.1. */

	/* Collect the bits from the scmr.
	*/
	m-&gt;vco_out = m-&gt;clkin * (pllmf + 1);
	if (scmr &amp; BIT(19))	/* plldf (division factor is 1 or 2) */
		m-&gt;vco_out &gt;&gt;= 1;

	m-&gt;cpmhz = m-&gt;vco_out &gt;&gt; 1;	/* cpm hz is half of vco_out */
	m-&gt;brghz = m-&gt;vco_out &gt;&gt; (2 * ((iomem-&gt;sccr &amp; 0x3) + 1));
	m-&gt;bushz = m-&gt;vco_out / (((scmr &amp; 0x00f00000) &gt;&gt; 20) + 1);

	/* Serial init sets BRG clock....I don't know how to compute
	 * core clock from core configuration, but I think I know the
	 * mapping....
	 */
	switch(scmr &gt;&gt; (31-7)){
	case 0x0a:
		m-&gt;cpuhz = m-&gt;clkin * 2;
		break;
	case 0x0b:
		m-&gt;cpuhz = (m-&gt;clkin &gt;&gt; 1) * 5;
		break;
	default:
	case 0x0d:
		m-&gt;cpuhz = m-&gt;clkin * 3;
		break;
	case 0x14:
		m-&gt;cpuhz = (m-&gt;clkin &gt;&gt; 1) * 7;
		break;
	case 0x1c:
		m-&gt;cpuhz = m-&gt;clkin * 4;
		break;
	}

	m-&gt;cyclefreq = m-&gt;bushz / 4;

/*	Expect:
	intfreq	133		m-&gt;cpuhz
	busfreq	33		m-&gt;bushz
	cpmfreq	99		m-&gt;cpmhz
	brgfreq	49.5		m-&gt;brghz
	vco		198
*/

	active.machs = 1;
	active.exiting = 0;

	putmsr(getmsr() | MSR_ME);

	/*
	 * turn on data cache before instruction cache;
	 * for some reason which I don't understand,
	 * you can't turn on both caches at once
	 */
	icacheenb();
	dcacheenb();

	kfpinit();

	/* Plan9.ini location in flash is FLASHMEM+PLAN9INI
	 * if PLAN9INI == ~0, it's not stored in flash or there is no flash
	 * if *cp == 0xff, flash memory is not initialized
	 */
	if (PLAN9INI == ~0 ||
	    (uchar)*(plan9inistr = (char*)(FLASHMEM+PLAN9INI)) == 0xff){
		/* No plan9.ini in flash */
		plan9inistr =
			"console=0\n"
			"ether0=type=fcc port=0 ea=00601d051dd8\n"
			"flash0=mem=0xfe000000\n"
			"fs=135.104.9.42\n"
			"auth=135.104.9.7\n"
			"authdom=cs.bell-labs.com\n"
			"sys=blast\n"
			"ntp=135.104.9.52\n";
	}
}

void
fpgareset(void)
{
	print("fpga reset\n");

	ioplock();

	iomem-&gt;port[1].pdat &amp;= ~Pin4;	/* force reset signal to 0 */
	delay(100);
	iomem-&gt;port[1].pdat |= Pin4;		/* force reset signal back to one */

	iopunlock();
}

void
hwintrinit(void)
{
	iomem-&gt;sicr = 2 &lt;&lt; 8;
	/* Write ones into most bits of the interrupt pending registers to clear interrupts */
	iomem-&gt;sipnr_h = ~7;
	iomem-&gt;sipnr_h = ~1;
	/* Clear the interrupt masks, thereby disabling all interrupts */
	iomem-&gt;simr_h = 0;
	iomem-&gt;simr_l = 0;

	iomem-&gt;sypcr &amp;= ~2;	/* cause a machine check interrupt on memory timeout */

	/* Initialize fpga reset pin */
	iomem-&gt;port[1].pdir |= Pin4;		/* 1 is an output */
	iomem-&gt;port[1].ppar &amp;= ~Pin4;
	iomem-&gt;port[1].pdat |= Pin4;		/* force reset signal back to one */
}

int
vectorenable(Vctl *v)
{
	ulong hi, lo;

	if (v-&gt;irq &amp; ~0x3f){
		print("m8260enable: interrupt vector %d out of range\n", v-&gt;irq);
		return -1;
	}
	hi = vec2mask[v-&gt;irq].hi;
	lo = vec2mask[v-&gt;irq].lo;
	if (hi == 0 &amp;&amp; lo == 0){
		print("m8260enable: nonexistent vector %d\n", v-&gt;irq);
		return -1;
	}
	ioplock();
	/* Clear the interrupt before enabling */
	iomem-&gt;sipnr_h |= hi;
	iomem-&gt;sipnr_l |= lo;
	/* Enable */
	iomem-&gt;simr_h |= hi;
	iomem-&gt;simr_l |= lo;
	iopunlock();
	return v-&gt;irq;
}

void
vectordisable(Vctl *v)
{
	ulong hi, lo;

	if (v-&gt;irq &amp; ~0x3f){
		print("m8260disable: interrupt vector %d out of range\n", v-&gt;irq);
		return;
	}
	hi = vec2mask[v-&gt;irq].hi;
	lo = vec2mask[v-&gt;irq].lo;
	if (hi == 0 &amp;&amp; lo == 0){
		print("m8260disable: nonexistent vector %d\n", v-&gt;irq);
		return;
	}
	ioplock();
	iomem-&gt;simr_h &amp;= ~hi;
	iomem-&gt;simr_l &amp;= ~lo;
	iopunlock();
}

int
intvec(void)
{
	return iomem-&gt;sivec &gt;&gt; 26;
}

void
intend(int vno)
{
	/* Clear interrupt */
	ioplock();
	iomem-&gt;sipnr_h |= vec2mask[vno].hi;
	iomem-&gt;sipnr_l |= vec2mask[vno].lo;
	iopunlock();
}

int
m8260eoi(int)
{
	return 0;
}

int
m8260isr(int)
{
	return 0;
}

void
flashprogpower(int)
{
}

enum {
	TgcrCas 			= 0x80,
	TgcrGm 			= 0x08,
	TgcrStp 			= 0x2,	/* There are two of these, timer-2 bits are bits &lt;&lt; 4 */
	TgcrRst 			= 0x1,

	TmrIclkCasc		= 0x00&lt;&lt;1,
	TmrIclkIntclock	= 0x01&lt;&lt;1,
	TmrIclkIntclock16	= 0x02&lt;&lt;1,
	TmrIclkTin		= 0x03&lt;&lt;1,
	TmrCERising		= 0x1 &lt;&lt; 6,
	TmrCEFalling		= 0x2 &lt;&lt; 6,
	TmrCEAny		= 0x3 &lt;&lt; 6,
	TmrFrr			= SBIT(12),
	TmrOri			= SBIT(11),

	TerRef			= SBIT(14),
	TerCap			= SBIT(15),
};

uvlong
fastticks(uvlong *hz)
{
	ulong count;
	static Lock fasttickslock;

	if (hz)
		*hz = m-&gt;clkin&gt;&gt;1;
	ilock(&amp;fasttickslock);
	count = iomem-&gt;tcnl1;
	if (count &lt; ticks.lo)
		ticks.hi += 1;
	ticks.lo = count;
	iunlock(&amp;fasttickslock);
	return ticks.val;
}

ulong multiplier;

ulong
µs(void)
{
	uvlong x;

	if(multiplier == 0){
		multiplier = (uvlong)(1000000LL &lt;&lt; 16) / m-&gt;cyclefreq;
		print("µs: multiplier %ld, cyclefreq %lld, shifter %d\n", multiplier, m-&gt;cyclefreq, 16);
	}
	cycles(&amp;x);
	return (x*multiplier) &gt;&gt; 16;
}

void
timerset(Tval next)
{
	long offset;
	uvlong now;
	static int cnt;

	now = fastticks(nil);
	offset = next - now;
	if (offset &lt; 2500)
		next = now + 2500;	/* 10000 instructions */
	else if (offset &gt; m-&gt;clkin / HZ){
		print("too far in the future: offset %llux, now %llux\n", next, now);
		next = now + m-&gt;clkin / HZ;
	}
	iomem-&gt;trrl1 = next;
}

void
m8260timerintr(Ureg *u, void*)
{
	iomem-&gt;ter2 |= TerRef | TerCap;		/* Clear interrupt */
	timerintr(u, 0);
}

void
timerinit(void)
{

	iomem-&gt;tgcr1 = TgcrCas | TgcrGm;		/* cascade timers 1 &amp; 2, normal gate mode */
	iomem-&gt;tcnl1 = 0;
	iomem-&gt;trrl1 = m-&gt;clkin / HZ;		/* first capture in 1/HZ seconds */
	iomem-&gt;tmr1 = TmrIclkCasc;
	iomem-&gt;tmr2 = TmrIclkIntclock | TmrOri;
	intrenable(13, m8260timerintr, nil, "timer");	/* Timer 2 interrupt is on 13 */
	iomem-&gt;tgcr1 |= TgcrRst &lt;&lt; 4;
}

static void
addseg(char *name, ulong start, ulong length)
{
	Physseg segbuf;

	memset(&amp;segbuf, 0, sizeof(segbuf));
	segbuf.attr = SG_PHYSICAL;
	kstrdup(&amp;segbuf.name, name);
	segbuf.pa = start;
	segbuf.size = length;
	if (addphysseg(&amp;segbuf) == -1) {
		print("addphysseg: %s\n", name);
		return;
	}
}

void
sharedseginit(void)
{
	int i, j;
	ulong base, size;
	char name[16], *a, *b, *s;
	static char *segnames[] = {
		"fpga",
		"dsp",
	};

	for (j = 0; j &lt; nelem(segnames); j++){
		for (i = 0; i &lt; 8; i++){
			snprint(name, sizeof name, "%s%d", segnames[j], i);
			if ((a = getconf(name)) == nil)
				continue;
			if ((b = strstr(a, "mem=")) == nil){
				print("blastseginit: %s: no base\n", name);
				continue;
			}
			b += 4;
			base = strtoul(b, nil, 0);
			if (base == 0){
				print("blastseginit: %s: bad base: %s\n", name, b);
				continue;
			}
			if ((s = strstr(a, "size=")) == nil){
				print("blastseginit: %s: no size\n", name);
				continue;
			}
			s += 5;
			size = strtoul(s, nil, 0);
			if (size == 0){
				print("blastseginit: %s: bad size: %s\n", name, s);
				continue;
			}
			addseg(name, base, size);
		}
	}
}

void
cpmop(int op, int dev, int mcn)
{
	ioplock();
	eieio();
	while(iomem-&gt;cpcr &amp; 0x10000)
		eieio();
	iomem-&gt;cpcr = dev&lt;&lt;(31-10) | mcn&lt;&lt;(31-25) | op | 0x10000;
	eieio();
	while(iomem-&gt;cpcr &amp; 0x10000)
		eieio();
	iopunlock();
}

/*
 * connect SCCx clocks in NSMI mode (x=1 for USB)
 */
void
sccnmsi(int x, int rcs, int tcs)
{
	ulong v;
	int sh;

	sh = (x-1)*8;	/* each SCCx field in sicr is 8 bits */
	v = (((rcs&amp;7)&lt;&lt;3) | (tcs&amp;7)) &lt;&lt; sh;
	iomem-&gt;sicr = (iomem-&gt;sicr &amp; ~(0xFF&lt;&lt;sh)) | v;
}

/*
 * lock the shared IO memory and return a reference to it
 */
void
ioplock(void)
{
	ilock(&amp;cpmlock);
}

/*
 * release the lock on the shared IO memory
 */
void
iopunlock(void)
{
	eieio();
	iunlock(&amp;cpmlock);
}

BD*
bdalloc(int n)
{
	static BD *palloc = ((Imap*)INTMEM)-&gt;bd;
	BD *p;
	
	p = palloc;
	if (palloc &gt; ((Imap*)INTMEM)-&gt;bd + nelem(((Imap*)INTMEM)-&gt;bd)){
		print("bdalloc: out of BDs\n");
		return nil;
	}
	palloc += n;
	return p;
}

/*
 * Initialise receive and transmit buffer rings.  Only used for FCC
 * Ethernet now.
 *
 * Ioringinit will allocate the buffer descriptors in normal memory
 * and NOT in Dual-Ported Ram, as prescribed by the MPC8260
 * PowerQUICC II manual (Section 28.6).  When they are allocated
 * in DPram and the Dcache is enabled, the processor will hang.
 * This has been observed for the FCCs, it may or may not be true
 * for SCCs or DMA.
 * The SMC Uart buffer descriptors are not allocated here; (1) they
 * can ONLY be in DPram and (2) they are not configured as a ring.
 */
int
ioringinit(Ring* r, int nrdre, int ntdre, int bufsize)
{
	int i, x;
	static uchar *dpmallocaddr;
	static uchar *dpmallocend;

	if (dpmallocaddr == nil){
		dpmallocaddr = m-&gt;imap-&gt;dpram1;
		dpmallocend = dpmallocaddr + sizeof(m-&gt;imap-&gt;dpram1);
	}
	/* the ring entries must be aligned on sizeof(BD) boundaries */
	r-&gt;nrdre = nrdre;
	if(r-&gt;rdr == nil)
		r-&gt;rdr = xspanalloc(nrdre*sizeof(BD), 0, 8);
	if(r-&gt;rdr == nil)
		return -1;
	if(r-&gt;rrb == nil &amp;&amp; bufsize){
		r-&gt;rrb = xspanalloc(nrdre*bufsize, 0, CACHELINESZ);
		if(r-&gt;rrb == nil)
			return -1;
	}
	x = bufsize ? PADDR(r-&gt;rrb) : 0;
	for(i = 0; i &lt; nrdre; i++){
		r-&gt;rdr[i].length = 0;
		r-&gt;rdr[i].addr = x;
		r-&gt;rdr[i].status = BDEmpty|BDInt;
		x += bufsize;
	}
	r-&gt;rdr[i-1].status |= BDWrap;
	r-&gt;rdrx = 0;

	r-&gt;ntdre = ntdre;
	if(r-&gt;tdr == nil)
		r-&gt;tdr = xspanalloc(ntdre*sizeof(BD), 0, 8);
	if(r-&gt;txb == nil)
		r-&gt;txb = xspanalloc(ntdre*sizeof(Block*), 0, CACHELINESZ);
	if(r-&gt;tdr == nil || r-&gt;txb == nil)
		return -1;
	for(i = 0; i &lt; ntdre; i++){
		r-&gt;txb[i] = nil;
		r-&gt;tdr[i].addr = 0;
		r-&gt;tdr[i].length = 0;
		r-&gt;tdr[i].status = 0;
	}
	r-&gt;tdr[i-1].status |= BDWrap;
	r-&gt;tdrh = 0;
	r-&gt;tdri = 0;
	r-&gt;ntq = 0;
	return 0;
}

void
trapinit(void)
{
	int i;

	/*
	 * set all exceptions to trap
	 */
	for(i = 0x0; i &lt; 0x2000; i += 0x100)
		sethvec(i, trapvec);

	setmvec(0x1000, imiss, tlbvec);
	setmvec(0x1100, dmiss, tlbvec);
	setmvec(0x1200, dmiss, tlbvec);

/*	Useful for avoiding assembler miss handling:
	sethvec(0x1000, tlbvec);
	sethvec(0x1100, tlbvec);
	sethvec(0x1200, tlbvec);
/* */
	dcflush(KADDR(0), 0x2000);
	icflush(KADDR(0), 0x2000);

	putmsr(getmsr() &amp; ~MSR_IP);
}

void
reboot(void*, void*, ulong)
{
	ulong *p;
	int x;

	p = (ulong*)0x90000000;
	x = splhi();
	iomem-&gt;sypcr |= 0xc0;
	print("iomem-&gt;sypcr = 0x%lux\n", iomem-&gt;sypcr);
	*p = 0;
	print("still alive\n");
	splx(x);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

