<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/mmu.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/mmu.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;ureg.h&gt;
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"

/*
 *	We have one page table per processor.
 *
 *	Different processes are distinguished via the VSID field in
 *	the segment registers.  As flushing the entire page table is an
 *	expensive operation, we implement an aging algorithm for
 *	mmu pids, with a background kproc to purge stale pids en mass.
 *
 *	This needs modifications to run on a multiprocessor.
 */

static ulong	ptabsize;			/* number of bytes in page table */
static ulong	ptabmask;		/* hash mask */

/*
 *	VSID is 24 bits.  3 are required to distinguish segments in user
 *	space (kernel space only uses the BATs).  pid 0 is reserved.
 *	The top 2 bits of the pid are used as a `color' for the background
 *	pid reclamation algorithm.
 */

enum {
	PIDBASE = 1,
	PIDBITS = 21,
	COLBITS = 2,
	PIDMAX = ((1&lt;&lt;PIDBITS)-1),
	COLMASK = ((1&lt;&lt;COLBITS)-1),
};

#define	VSID(pid, i)	(((pid)&lt;&lt;3)|i)
#define	PIDCOLOR(pid)	((pid)&gt;&gt;(PIDBITS-COLBITS))
#define	PTECOL(color)	PTE0(1, VSID(((color)&lt;&lt;(PIDBITS-COLBITS)), 0), 0, 0)

void
mmuinit(void)
{
	int lhash, mem, i;
	ulong memsize;

	memsize = conf.npage * BY2PG;
	if(ptabsize == 0) {
		/* heuristically size the hash table */
		lhash = 10;
		mem = (1&lt;&lt;23);
		while(mem &lt; memsize) {
			lhash++;
			mem &lt;&lt;= 1;
		}
		ptabsize = (1&lt;&lt;(lhash+6));
		ptabmask = (1&lt;&lt;lhash)-1;
	}
	m-&gt;ptabbase = (ulong)xspanalloc(ptabsize, 0, ptabsize);
	/* set page table base address */
	putsdr1(PADDR(m-&gt;ptabbase) | (ptabmask&gt;&gt;10));
	m-&gt;mmupid = PIDBASE;
	m-&gt;sweepcolor = 0;
	m-&gt;trigcolor = COLMASK;

	for(i = 0; i &lt; 16; i++)
		putsr(i&lt;&lt;28, 0);
}

static int
work(void*)
{
	return PIDCOLOR(m-&gt;mmupid) == m-&gt;trigcolor;
}

void
mmusweep(void*)
{
	Proc *p;
	int i, x, sweepcolor;
	ulong *ptab, *ptabend, ptecol;

	for(;;) {
		if(PIDCOLOR(m-&gt;mmupid) != m-&gt;trigcolor)
			sleep(&amp;m-&gt;sweepr, work, nil);

		sweepcolor = m-&gt;sweepcolor;
		x = splhi();
		p = proctab(0);
		for(i = 0; i &lt; conf.nproc; i++, p++)
			if(PIDCOLOR(p-&gt;mmupid) == sweepcolor)
				p-&gt;mmupid = 0;
		splx(x);

		ptab = (ulong*)m-&gt;ptabbase;
		ptabend = (ulong*)(m-&gt;ptabbase+ptabsize);
		ptecol = PTECOL(sweepcolor);
		while(ptab &lt; ptabend) {
			if((*ptab &amp; PTECOL(3)) == ptecol){
				*ptab = 0;
			}
			ptab += 2;
		}

		m-&gt;sweepcolor = (sweepcolor+1) &amp; COLMASK;
		m-&gt;trigcolor = (m-&gt;trigcolor+1) &amp; COLMASK;
	}
}

int
newmmupid(void)
{
	int pid, newcolor, i, x;
	Proc *p;

	pid = m-&gt;mmupid++;
	if(m-&gt;mmupid &gt; PIDMAX){
		/* Used up all mmupids, start again from first.  Flush the tlb
		 * to delete any entries with old pids remaining, then reassign
		 * all pids.
		 */
		m-&gt;mmupid = PIDBASE;
		x = splhi();
		tlbflushall();
		p = proctab(0);
		for(i = 0; i &lt; conf.nproc; i++, p++)
			p-&gt;mmupid = 0;
		splx(x);
		wakeup(&amp;m-&gt;sweepr);
	}
	newcolor = PIDCOLOR(m-&gt;mmupid);
	if(newcolor != PIDCOLOR(pid)) {
		if(newcolor == m-&gt;sweepcolor) {
			/* desperation time.  can't block here.  punt to fault/putmmu */
			print("newmmupid: %uld: no free mmu pids\n", up-&gt;pid);
			if(m-&gt;mmupid == PIDBASE)
				m-&gt;mmupid = PIDMAX;
			else
				m-&gt;mmupid--;
			pid = 0;
		}
		else if(newcolor == m-&gt;trigcolor)
			wakeup(&amp;m-&gt;sweepr);
	}
	up-&gt;mmupid = pid;
	return pid;
}

void
flushmmu(void)
{
	int x;

	x = splhi();
	up-&gt;newtlb = 1;
	mmuswitch(up);
	splx(x);
}

/*
 * called with splhi
 */
void
mmuswitch(Proc *p)
{
	int i, mp;
	ulong r;

	if(p-&gt;kp) {
		for(i = 0; i &lt; 8; i++)
			putsr(i&lt;&lt;28, 0);
		return;
	}

	if(p-&gt;newtlb) {
		p-&gt;mmupid = 0;
		p-&gt;newtlb = 0;
	}
	mp = p-&gt;mmupid;
	if(mp == 0)
		mp = newmmupid();

	for(i = 0; i &lt; 8; i++){
		r = VSID(mp, i)|BIT(1)|BIT(2);
		putsr(i&lt;&lt;28, r);
	}
}

void
mmurelease(Proc* p)
{
	p-&gt;mmupid = 0;
}

void
putmmu(ulong va, ulong pa, Page *pg)
{
	int mp;
	char *ctl;
	ulong *p, *ep, *q, pteg;
	ulong vsid, hash;
	ulong ptehi, x;
	static ulong pva;

	/*
	 *	If mmupid is 0, mmuswitch/newmmupid was unable to assign us
	 *	a pid, hence we faulted.  Keep calling sched() until the mmusweep
	 *	proc catches up, and we are able to get a pid.
	 */
	while((mp = up-&gt;mmupid) == 0)
		sched();

	vsid = VSID(mp, va&gt;&gt;28);
	hash = (vsid ^ ((va&gt;&gt;12)&amp;0xffff)) &amp; ptabmask;
	ptehi = PTE0(1, vsid, 0, va);
	pteg = m-&gt;ptabbase + BY2PTEG*hash;

	p = (ulong*)pteg;
	ep = (ulong*)(pteg+BY2PTEG);
	q = nil;

	while(p &lt; ep) {
		x = p[0];
		if(x == ptehi) {
			q = p;
			break;
		}
		if(q == nil &amp;&amp; (x &amp; BIT(0)) == 0)
			q = p;
		p += 2;
	}
	if(q == nil) {
		q = (ulong*)(pteg+m-&gt;slotgen);
		m-&gt;slotgen = (m-&gt;slotgen + BY2PTE) &amp; (BY2PTEG-1);
	}

	if (q[0] != ptehi || q[1] != pa){
		tlbflush(va);
		m-&gt;tlbpurge++;
	}
	q[0] = ptehi;
	q[1] = pa;

	ctl = &amp;pg-&gt;cachectl[m-&gt;machno];
	switch(*ctl) {
	case PG_NEWCOL:
	default:
		panic("putmmu: %d\n", *ctl);
		break;
	case PG_TXTFLUSH:
		dcflush((void*)pg-&gt;va, BY2PG);
		icflush((void*)pg-&gt;va, BY2PG);
		*ctl = PG_NOFLUSH;
		break;
	case PG_NOFLUSH:
		break;
	}

}

void
checkmmu(ulong, ulong)
{
}

void
countpagerefs(ulong*, int)
{
}

/*
 * Return the number of bytes that can be accessed via KADDR(pa).
 * If pa is not a valid argument to KADDR, return 0.
 */
ulong
cankaddr(ulong pa)
{
	if(pa &gt;= -KZERO)
		return 0;
	return -KZERO - pa;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

