<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/msaturn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/msaturn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "../port/error.h"
#include "msaturn.h"

enum {
	Isr = Saturn + 0x0400,
	Ipol = Saturn + 0x0404,
	Issr = Saturn + 0x0500,
	Ier = Saturn + 0x0504,
	Ipri = Saturn + 0x0600,
	Ithresh = Saturn + 0x0706,
#define Iar	Ithresh
};

enum{
	Syscfg = Saturn + 0x0100,
};

static uchar intprio[] = {
		Vecuart0,			// uart 0
		Vecunused,		// uart 1
		Vecunused,		// sint
		Vectimer0,		// timer 0
		Vecunused,		// timer 1
		Vecether,			// ethernet
		Vecunused,		// tea
		Vecunused,		// irq0	
		Vecunused,		// irq1	
		Vecunused,		// irq2	
		Vecunused,		// irq3	
		Vecunused,		// irq4	
		Vecunused,		// irq5	
		Vecunused,		// irq6	
		Vecunused,		// irq7	
		Vecunused,		// irq8	
};

void
intend(int)
{
}

void
hwintrinit(void)
{
	int i;

	*(ulong*)Ier=0;

	for(i=0; i&lt;nelem(intprio)/2; i++)
		((uchar*)Ipri)[i] = (intprio[2*i]&lt;&lt;4)|intprio[2*i+1];
}

int
vectorenable(Vctl*v)
{
	int i;

	for(i=0; i&lt;nelem(intprio); i++)
		if(v-&gt;irq==intprio[i]){
			*(ulong*)Ier |= 1&lt;&lt;(31-i);
			return v-&gt;irq;
		}
	print("intrenable: cannot enable intr %d\n", v-&gt;irq);
	return -1;
}

void
vectordisable(Vctl*v)
{
	int i;

	for(i=0; i&lt;nelem(intprio); i++)
		if(v-&gt;irq==intprio[i]){
			*(ulong*)Ier &amp;= ~(1&lt;&lt;(31-i));
			return;
		}
}

int
intvec(void)
{
	ushort iar;
	int i;

	iar = *(ushort*)Iar;		// push(prio) onto stack
	for(i=0; i&lt;nelem(intprio); i++)
		if(iar==intprio[i])
			return iar;
		
	iprint("saturnint: no vector %d\n", iar);
	intack();
	return -1;
}

void
intack(void)
{
	*(ushort*)Ithresh = 0;	// pop(prio) stack
}

void
machinit(void)
{
	int rrate;
	ulong hid;
	extern char* plan9inistr;
	ulong l2cr;

	memset(m, 0, sizeof(*m));
	m-&gt;cputype = getpvr()&gt;&gt;16;
	m-&gt;imap = (Imap*)INTMEM;

	m-&gt;loopconst = 1096;

	rrate = (*(ushort*)Syscfg &gt;&gt; 6) &amp; 3;
	switch(rrate){
	case 0:
		m-&gt;bushz = 66666666;
		break;
	case 1:
		m-&gt;bushz = 83333333;
		break;
	case 2:
		m-&gt;bushz = 100000000;
		break;
	case 3:
		m-&gt;bushz = 133333333;
		break;
	}

	if(getpll() == 0x80000000)
		m-&gt;cpuhz = 300000000;
	else
		m-&gt;cpuhz = 200000000;		/* 750FX? */
	m-&gt;cyclefreq = m-&gt;bushz / 4;

	active.machs = 1;
	active.exiting = 0;

	putmsr(getmsr() | MSR_ME);

	dcflush((void*)KZERO, 0x2000000);
	l2cr = getl2cr();
	putl2cr(l2cr|BIT(10));

	kfpinit();

	hid=gethid0();
	hid |= BIT(28)|BIT(26)|BIT(24);
	puthid0(hid);

	plan9inistr =
		"console=0\n"
		"ether0=type=saturn\n"
		"fs=135.104.9.42\n"
		"auth=135.104.9.7\n"
		"authdom=cs.bell-labs.com\n"
		"sys=ucu\n"
		"ntp=135.104.9.52\n";
}

void
sharedseginit(void)
{
}

void
trapinit(void)
{
	int i;

	for(i = 0x0; i &lt; 0x2000; i += 0x100)
		sethvec(i, trapvec);

	dcflush(KADDR(0), 0x2000);
	icflush(KADDR(0), 0x2000);

	putmsr(getmsr() &amp; ~MSR_IP);
}

void
reboot(void*, void*, ulong)
{
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

