<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"ureg.h"
#include	"../port/error.h"
#include	"tos.h"
#include	&lt;trace.h&gt;

static Lock vctllock;
Vctl *vctl[256];

int intrstack[5];
uvlong intrtime[5];
vlong lastoffset;
int inintr;
int nintr[10];
int nintro;
int dblintr[64];
ulong thisto[32];
ulong thistoo;
vlong vnot[64];
ulong vnon[64];

void
intrenable(int irq, void (*f)(Ureg*, void*), void* a, char *name)
{
	int vno;
	Vctl *v;

	if(f == nil){
		print("intrenable: nil handler for %d for %s\n",
			irq, name);
		return;
	}

	v = xalloc(sizeof(Vctl));
	v-&gt;isintr = 1;
	v-&gt;irq = irq;
	v-&gt;f = f;
	v-&gt;a = a;
	strncpy(v-&gt;name, name, KNAMELEN-1);
	v-&gt;name[KNAMELEN-1] = 0;

	ilock(&amp;vctllock);
	vno = vectorenable(v);
	if(vno == -1){
		iunlock(&amp;vctllock);
		print("intrenable: couldn't enable irq %d for %s\n",
			irq, v-&gt;name);
		xfree(v);
		return;
	}
	v-&gt;next = vctl[vno];
	vctl[vno] = v;
	iunlock(&amp;vctllock);
}

void
intrdisable(int irq, void (*f)(Ureg *, void *), void *a, char *name)
{
	Vctl **pv, *v;

	ilock(&amp;vctllock);
	pv = &amp;vctl[irq];
	while (*pv &amp;&amp; 
		  ((*pv)-&gt;irq != irq || (*pv)-&gt;f != f || (*pv)-&gt;a != a ||
		   strcmp((*pv)-&gt;name, name)))
		pv = &amp;((*pv)-&gt;next);

	if(*pv == nil){
		print("intrdisable: irq %d not found\n", irq);
		iunlock(&amp;vctllock);
		return;
	}

	v = *pv;
	*pv = (*pv)-&gt;next;	/* Link out the entry */
	
	if(vctl[irq] == nil)
		vectordisable(v);
	iunlock(&amp;vctllock);
	xfree(v);
}

void	syscall(Ureg*);
void	noted(Ureg*, ulong);
static void _dumpstack(Ureg*);

char *excname[] =
{
	"reserved 0",
	"system reset",
	"machine check",
	"data access",
	"instruction access",
	"external interrupt",
	"alignment",
	"program exception",
	"floating-point unavailable",
	"decrementer",
	"reserved A",
	"reserved B",
	"system call",
	"trace trap",
	"floating point assist",
	"reserved F",
	"reserved 10",
	"data load translation miss",
	"data store translation miss",
	"instruction address breakpoint",
	"system management interrupt",
};

char *fpcause[] =
{
	"inexact operation",
	"division by zero",
	"underflow",
	"overflow",
	"invalid operation",
};
char	*fpexcname(Ureg*, ulong, char*);
#define FPEXPMASK	0xfff80300		/* Floating exception bits in fpscr */


char *regname[]={
	"CAUSE",	"SRR1",
	"PC",		"GOK",
	"LR",		"CR",
	"XER",		"CTR",
	"R0",		"R1",
	"R2",		"R3",
	"R4",		"R5",
	"R6",		"R7",
	"R8",		"R9",
	"R10",		"R11",
	"R12",		"R13",
	"R14",		"R15",
	"R16",		"R17",
	"R18",		"R19",
	"R20",		"R21",
	"R22",		"R23",
	"R24",		"R25",
	"R26",		"R27",
	"R28",		"R29",
	"R30",		"R31",
	"DCMP",		"ICMP",
	"DMISS",	"IMISS",
	"HASH1",	"HASH2",
	"DAR",		"DSISR",
};

void
kexit(Ureg*)
{
	uvlong t;
	Tos *tos;

	/* precise time accounting, kernel exit */
	tos = (Tos*)(USTKTOP-sizeof(Tos));
	cycles(&amp;t);
	tos-&gt;kcycles += t - up-&gt;kentry;
	tos-&gt;pcycles = up-&gt;pcycles;
	tos-&gt;pid = up-&gt;pid;
}

void
trap(Ureg *ureg)
{
	int ecode, user;
	char buf[ERRMAX], *s;
	extern FPsave initfp;

	ecode = (ureg-&gt;cause &gt;&gt; 8) &amp; 0xff;
	user = (ureg-&gt;srr1 &amp; MSR_PR) != 0;
	if(user){
		cycles(&amp;up-&gt;kentry);
		up-&gt;dbgreg = ureg;
	}
	if(ureg-&gt;status &amp; MSR_RI == 0)
		print("double fault?: ecode = %d\n", ecode);

	switch(ecode) {
	case CEI:
		m-&gt;intr++;
		intr(ureg);
		break;
	case CDEC:
		clockintr(ureg);
		break;
	case CDSI:
		m-&gt;pfault++;
		if (up == nil){
			dumpregs(ureg);
			panic("kernel fault");
		}
		up-&gt;mmureg = ureg;
		faultpower(ureg, ureg-&gt;dar, (ureg-&gt;dsisr &amp; BIT(6)) == 0);
		break;
	case CISI:
		m-&gt;pfault++;
		if (up == nil){
			dumpregs(ureg);
			panic("kernel fault");
		}
		up-&gt;mmureg = ureg;
		faultpower(ureg, ureg-&gt;pc, 1);
		break;
	case CIMISS:	/* instruction miss */
		if (up == nil){
			dumpregs(ureg);
			panic("kernel fault");
		}
		up-&gt;mmureg = ureg;
		faultpower(ureg, ureg-&gt;imiss, 1);
		break;
	case CLMISS:	/* data load miss */
		if (up == nil){
			dumpregs(ureg);
			panic("kernel fault");
		}
		up-&gt;mmureg = ureg;
		faultpower(ureg, ureg-&gt;dmiss, 1);
		break;
	case CSMISS:	/* data store miss */
		if (up == nil){
			dumpregs(ureg);
			panic("kernel fault");
		}
		up-&gt;mmureg = ureg;
		faultpower(ureg, ureg-&gt;dmiss, 0);
		break;

	case CSYSCALL:
		if(!user)
			panic("syscall in kernel: srr1 0x%4.4luX\n", ureg-&gt;srr1);
		syscall(ureg);
		if (up-&gt;delaysched){
			sched();
			splhi();
		}
		kexit(ureg);
		return;		/* syscall() calls notify itself, don't do it again */

	case CFPU:
		if(!user || up == nil) {
			dumpregs(ureg);
			panic("floating point in kernel");
		}
		switch(up-&gt;fpstate){
		case FPinit:
			fprestore(&amp;initfp);
			up-&gt;fpstate = FPactive;
			break;
		case FPinactive:
			fprestore(&amp;up-&gt;fpsave);
			up-&gt;fpstate = FPactive;
			break;
		case FPactive:
			print("up-&gt;fpstate %d\n", up-&gt;fpstate);
			delay(100);
			dumpregs(ureg);
			delay(200);
			panic("fpstate");
			break;
		default:
			if(user){
				spllo();
				sprint(buf, "sys: floating point in note handler:");
				postnote(up, 1, buf, NDebug);
				break;
			}
			panic("kernel fpstate illegal");
		}
		ureg-&gt;srr1 |= MSR_FP;
		break;
	case CPROG:
		if(ureg-&gt;status &amp; (1&lt;&lt;19))
			s = "floating point exception";
		else if(ureg-&gt;status &amp; (1&lt;&lt;18))
			s = "illegal instruction";
		else if(ureg-&gt;status &amp; (1&lt;&lt;17))
			s = "privileged instruction";
		else
			s = "undefined program exception";
		if(user){
			spllo();
			sprint(buf, "sys: trap: %s", s);
			postnote(up, 1, buf, NDebug);
			break;
		}
		dumpregs(ureg);
		panic(s);
		break;
	default:
		if(ecode &lt; nelem(excname) &amp;&amp; user){
			spllo();
			sprint(buf, "sys: trap: %s", excname[ecode]);
			postnote(up, 1, buf, NDebug);
			break;
		}
		dumpregs(ureg);
		if(ecode &lt; nelem(excname))
			panic("%s", excname[ecode]);
		panic("unknown trap/intr: %d\n", ecode);
	}

	/* restoreureg must execute at high IPL */
	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; ecode == CDEC){
		sched();
		splhi();
	}

	if(user) {
		if (up-&gt;fpstate == FPactive &amp;&amp; (ureg-&gt;srr1 &amp; MSR_FP) == 0){
			postnote(up, 1, buf, NDebug);
		}
		notify(ureg);
		if(up-&gt;fpstate != FPactive)
			ureg-&gt;srr1 &amp;= ~MSR_FP;
		kexit(ureg);
	}
}

void
faultpower(Ureg *ureg, ulong addr, int read)
{
	int user, insyscall, n;
	char buf[ERRMAX];

	user = (ureg-&gt;srr1 &amp; MSR_PR) != 0;
	insyscall = up-&gt;insyscall;
	up-&gt;insyscall = 1;
	n = fault(addr, read);
	if(n &lt; 0){
		if(!user){
			dumpregs(ureg);
			panic("fault: 0x%lux", addr);
		}
		sprint(buf, "sys: trap: fault %s addr=0x%lux", read? "read" : "write", addr);
		postnote(up, 1, buf, NDebug);
	}
	up-&gt;insyscall = insyscall;
}

void
sethvec(int v, void (*r)(void))
{
	ulong *vp, pa, o;

	vp = KADDR(v);
	vp[0] = 0x7c1043a6;			/* MOVW R0, SPR(SPRG0) */
	vp[1] = 0x7c0802a6;			/* MOVW LR, R0 */
	vp[2] = 0x7c1243a6;			/* MOVW R0, SPR(SPRG2) */
	pa = PADDR(r);
	o = pa &gt;&gt; 25;
	if(o != 0 &amp;&amp; o != 0x7F){
		/* a branch too far */
		vp[3] = (15&lt;&lt;26)|(pa&gt;&gt;16);	/* MOVW $r&amp;~0xFFFF, R0 */
		vp[4] = (24&lt;&lt;26)|(pa&amp;0xFFFF);	/* OR $r&amp;0xFFFF, R0 */
		vp[5] = 0x7c0803a6;		/* MOVW	R0, LR */
		vp[6] = 0x4e800021;		/* BL (LR) */
	}else
		vp[3] = (18&lt;&lt;26)|(pa&amp;0x3FFFFFC)|3;	/* bla */
}

void
setmvec(int v, void (*r)(void), void (*t)(void))
{
	ulong *vp, pa, o, n;

	vp = KADDR(v);
	n = 0;
	vp[n++] = 0x7c1043a6;			/* MOVW R0, SPR(SPRG0) */
	vp[n++] = 0x7c0802a6;			/* MOVW LR, R0 */
	vp[n++] = 0x7c1243a6;			/* MOVW R0, SPR(SPRG2) */
	pa = PADDR(r);
	o = pa &gt;&gt; 25;
	if(o != 0 &amp;&amp; o != 0x7F){
		/* a branch too far */
		vp[n++] = (15&lt;&lt;26)|(pa&gt;&gt;16);	/* MOVW $r&amp;~0xFFFF, R0 */
		vp[n++] = (24&lt;&lt;26)|(pa&amp;0xFFFF);	/* OR $r&amp;0xFFFF, R0 */
		vp[n++] = 0x7c0803a6;		/* MOVW	R0, LR */
		vp[n++] = 0x4e800021;		/* BL (LR) */
	}else
		vp[n++] = (18&lt;&lt;26)|(pa&amp;0x3FFFFFC)|3;	/* bla */
	pa = PADDR(t);
	o = pa &gt;&gt; 25;
	if(o != 0 &amp;&amp; o != 0x7F){
		/* a branch too far */
		vp[n++] = (15&lt;&lt;26)|(pa&gt;&gt;16);	/* MOVW $r&amp;~0xFFFF, R0 */
		vp[n++] = (24&lt;&lt;26)|(pa&amp;0xFFFF);	/* OR $r&amp;0xFFFF, R0 */
		vp[n++] = 0x7c0803a6;		/* MOVW	R0, LR */
		vp[n] = 0x4e800021;		/* BL (LR) */
	}else
		vp[n] = (18&lt;&lt;26)|(pa&amp;0x3FFFFFC)|3;	/* bla */
}


void
intr(Ureg *ureg)
{
	int vno, pvno, i;
	Vctl *ctl, *v;
	void (*pt)(Proc*, int, vlong);
	uvlong tt, x;

	cycles(&amp;tt);
	pt = proctrace;
	pvno = -1;
	for(i = 0; i &lt; 64; i++){
		vno = intvec();
		if(vno == 0)
			break;
		cycles(&amp;x);
		vnot[vno] -= x;
		if(vno == pvno)
			dblintr[vno]++;
		pvno = vno;
		if(pt &amp;&amp; up &amp;&amp; up-&gt;trace)
			pt(up, (vno &lt;&lt; 16) | SInts, 0);
	
		if(vno &gt; nelem(vctl) || (ctl = vctl[vno]) == 0) {
			iprint("spurious intr %d\n", vno);
			return;
		}

		for(v = ctl; v != nil; v = v-&gt;next)
			if(v-&gt;f)
				v-&gt;f(ureg, v-&gt;a);

		intend(vno);	/* reenable the interrupt */

		if(pt &amp;&amp; up &amp;&amp; up-&gt;trace)
			pt(up, (vno &lt;&lt; 16) | SInte, 0);
		cycles(&amp;x);
		vnot[vno] += x;
		vnon[vno]++;
	}
	if(i &lt; nelem(nintr))
		nintr[i]++;
	else
		nintro++;
	cycles(&amp;x);
	tt = x - tt;
	i = tt / 3600;	 /* 100 microseconds units */
	if(i &lt; nelem(thisto))
		thisto[i]++;
	else
		thistoo++;

	if(up)
		preempted();
}

char*
fpexcname(Ureg *ur, ulong fpscr, char *buf)
{
	int i;
	char *s;
	ulong fppc;

	fppc = ur-&gt;pc;
	s = 0;
	fpscr &gt;&gt;= 3;		/* trap enable bits */
	fpscr &amp;= (fpscr&gt;&gt;22);	/* anded with exceptions */
	for(i=0; i&lt;5; i++)
		if(fpscr &amp; (1&lt;&lt;i))
			s = fpcause[i];
	if(s == 0)
		return "no floating point exception";
	sprint(buf, "%s fppc=0x%lux", s, fppc);
	return buf;
}

/*
 * Fill in enough of Ureg to get a stack trace, and call a function.
 * Used by debugging interface rdb.
 */

static void
getpcsp(ulong *pc, ulong *sp)
{
	*pc = getcallerpc(&amp;pc);
	*sp = (ulong)&amp;pc-4;
}

void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;

	getpcsp((ulong*)&amp;ureg.pc, (ulong*)&amp;ureg.sp);
	ureg.lr = getcallerpc(&amp;fn);
	fn(&amp;ureg);
}

static void
_dumpstack(Ureg *ureg)
{
	ulong l, sl, el, v;
	int i;

	l = (ulong)&amp;l;
	if(up == 0){
		el = (ulong)m+BY2PG;
		sl = el-KSTACK;
	}
	else{
		sl = (ulong)up-&gt;kstack;
		el = sl + KSTACK;
	}
	if(l &gt; el || l &lt; sl){
		el = (ulong)m+BY2PG;
		sl = el-KSTACK;
	}
	if(l &gt; el || l &lt; sl)
		return;
	print("ktrace /kernel/path %.8lux %.8lux %.8lux\n", ureg-&gt;pc, ureg-&gt;sp, ureg-&gt;lr);
	i = 0;
	for(; l &lt; el; l += 4){
		v = *(ulong*)l;
		if(KTZERO &lt; v &amp;&amp; v &lt; (ulong)etext){
			print("%.8lux=%.8lux ", l, v);
			if(i++ == 4){
				print("\n");
				i = 0;
			}
		}
	}
}

void
dumpstack(void)
{
	callwithureg(_dumpstack);
}

void
dumpregs(Ureg *ur)
{
	int i;
	ulong *l;

	if(up) {
		print("registers for %s %ld\n", up-&gt;text, up-&gt;pid);
		if(ur-&gt;srr1 &amp; MSR_PR == 0)
		if(ur-&gt;usp &lt; (ulong)up-&gt;kstack || ur-&gt;usp &gt; (ulong)up-&gt;kstack+KSTACK)
			print("invalid stack ptr\n");
	}
	else
		print("registers for kernel\n");

	for(i=0; i&lt;16; i+=2)
		print("sr[%x]\t0x%.8lux\tsr[%x]\t0x%.8lux\n", i, getsr(i&lt;&lt;28), i+1, getsr((i+1)&lt;&lt;28));
	l = &amp;ur-&gt;cause;
	for(i=0; i&lt;sizeof regname/sizeof(char*); i+=2, l+=2)
		print("%s\t0x%.8lux\t%s\t0x%.8lux\n", regname[i], l[0], regname[i+1], l[1]);
	delay(500);
}

static void
linkproc(void)
{
	spllo();
	(*up-&gt;kpfun)(up-&gt;kparg);
	pexit("", 0);
}

void
kprocchild(Proc *p, void (*func)(void*), void *arg)
{
	p-&gt;sched.pc = (ulong)linkproc;
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK;

	p-&gt;kpfun = func;
	p-&gt;kparg = arg;
}

/*
 * called in syscallfmt.c, sysfile.c, sysproc.c
 */
void
validalign(uintptr addr, unsigned align)
{
	/*
	 * Plan 9 is a 32-bit O/S, and the hardware it runs on
	 * does not usually have instructions which move 64-bit
	 * quantities directly, synthesizing the operations
	 * with 32-bit move instructions. Therefore, the compiler
	 * (and hardware) usually only enforce 32-bit alignment,
	 * if at all.
	 *
	 * Take this out if the architecture warrants it.
	 */
	if(align == sizeof(vlong))
		align = sizeof(long);

	/*
	 * Check align is a power of 2, then addr alignment.
	 */
	if((align != 0 &amp;&amp; !(align &amp; (align-1))) &amp;&amp; !(addr &amp; (align-1)))
		return;
	postnote(up, 1, "sys: odd address", NDebug);
	error(Ebadarg);
	/*NOTREACHED*/
}

long
execregs(ulong entry, ulong ssize, ulong nargs)
{
	ulong *sp;
	Ureg *ureg;

	sp = (ulong*)(USTKTOP - ssize);
	*--sp = nargs;

	ureg = up-&gt;dbgreg;
	ureg-&gt;usp = (ulong)sp;
	ureg-&gt;pc = entry;
	ureg-&gt;srr1 &amp;= ~MSR_FP;		/* disable floating point */
	up-&gt;fpstate = FPinit;
	return USTKTOP-sizeof(Tos);		/* address of kernel/user shared data */
}

void
forkchild(Proc *p, Ureg *ur)
{
	Ureg *cur;

	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-UREGSIZE;
	p-&gt;sched.pc = (ulong)forkret;

	cur = (Ureg*)(p-&gt;sched.sp+2*BY2WD);
	memmove(cur, ur, sizeof(Ureg));
	cur-&gt;r3 = 0;
	
	/* Things from bottom of syscall we never got to execute */
	p-&gt;psstate = 0;
	p-&gt;insyscall = 0;
}

ulong
userpc(void)
{
	Ureg *ureg;

	ureg = (Ureg*)up-&gt;dbgreg;
	return ureg-&gt;pc;
}


/* This routine must save the values of registers the user is not 
 * permitted to write from devproc and then restore the saved values 
 * before returning
 */
void
setregisters(Ureg *xp, char *pureg, char *uva, int n)
{
	ulong status;

	status = xp-&gt;status;
	memmove(pureg, uva, n);
	xp-&gt;status = status;
}

/* Give enough context in the ureg to produce a kernel stack for
 * a sleeping process
 */
void
setkernur(Ureg* ureg, Proc* p)
{
	ureg-&gt;pc = p-&gt;sched.pc;
	ureg-&gt;sp = p-&gt;sched.sp+4;
}

ulong
dbgpc(Proc *p)
{
	Ureg *ureg;

	ureg = p-&gt;dbgreg;
	if(ureg == 0)
		return 0;

	return ureg-&gt;pc;
}

/*
 *  system calls
 */
#include "../port/systab.h"

/* TODO: make this trap a separate asm entry point, like on other RISC architectures */
void
syscall(Ureg* ureg)
{
	int i;
	char *e;
	long	ret;
	ulong sp, scallnr;

	m-&gt;syscall++;
	up-&gt;insyscall = 1;
	up-&gt;pc = ureg-&gt;pc;
	up-&gt;dbgreg = ureg;

	if (up-&gt;fpstate == FPactive &amp;&amp; (ureg-&gt;srr1 &amp; MSR_FP) == 0){
		print("fpstate check, entry syscall\n");
		delay(200);
		dumpregs(ureg);
		print("fpstate check, entry syscall\n");
	}

	scallnr = ureg-&gt;r3;
	up-&gt;scallnr = ureg-&gt;r3;
	if(scallnr == RFORK &amp;&amp; up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
	spllo();

	sp = ureg-&gt;usp;
	up-&gt;nerrlab = 0;
	ret = -1;
	if(!waserror()){
		if(scallnr &gt;= nsyscall || systab[scallnr] == nil){
			pprint("bad sys call number %ld pc %lux\n", scallnr, ureg-&gt;pc);
			postnote(up, 1, "sys: bad sys call", NDebug);
			error(Ebadarg);
		}

		if(sp&lt;(USTKTOP-BY2PG) || sp&gt;(USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		up-&gt;s = *((Sargs*)(sp+BY2WD));
		up-&gt;psstate = sysctab[scallnr];

		ret = systab[scallnr](up-&gt;s.args);
		poperror();
	}else{
		/* failure: save the error buffer for errstr */
		e = up-&gt;syserrstr;
		up-&gt;syserrstr = up-&gt;errstr;
		up-&gt;errstr = e;
	}
	if(up-&gt;nerrlab){
		print("bad errstack [%uld]: %d extra\n", scallnr, up-&gt;nerrlab);
		print("scall %s lr =%lux\n", sysctab[scallnr], ureg-&gt;lr);
		for(i = 0; i &lt; NERR; i++)
			print("sp=%lux pc=%lux\n", up-&gt;errlab[i].sp, up-&gt;errlab[i].pc);
		panic("error stack");
	}

	up-&gt;insyscall = 0;
	up-&gt;psstate = 0;

	/*
	 *  Put return value in frame.  On the x86 the syscall is
	 *  just another trap and the return value from syscall is
	 *  ignored.  On other machines the return value is put into
	 *  the results register by caller of syscall.
	 */
	ureg-&gt;r3 = ret;

	if(scallnr == NOTED)
		noted(ureg, *(ulong*)(sp+BY2WD));

	/* restoreureg must execute at high IPL */
	splhi();
	if(scallnr!=RFORK)
		notify(ureg);

	if (up-&gt;fpstate == FPactive &amp;&amp; (ureg-&gt;srr1 &amp; MSR_FP) == 0){
		print("fpstate check, exit syscall nr %lud, pid %lud\n", scallnr, up-&gt;pid);
		dumpregs(ureg);
	}
	if(up-&gt;fpstate != FPactive)
		ureg-&gt;srr1 &amp;= ~MSR_FP;
}

/*
 *  Call user, if necessary, with note.
 *  Pass user the Ureg struct and the note on his stack.
 */
int
notify(Ureg* ur)
{
	int l;
	ulong s, sp;
	Note *n;

	if(up-&gt;procctl)
		procctl(up);
	if(up-&gt;nnote == 0)
		return 0;

	s = spllo();
	qlock(&amp;up-&gt;debug);
	up-&gt;notepending = 0;
	n = &amp;up-&gt;note[0];
	if(strncmp(n-&gt;msg, "sys:", 4) == 0){
		l = strlen(n-&gt;msg);
		if(l &gt; ERRMAX-15)	/* " pc=0x12345678\0" */
			l = ERRMAX-15;
		sprint(n-&gt;msg+l, " pc=0x%.8lux", ur-&gt;pc);
	}

	if(n-&gt;flag!=NUser &amp;&amp; (up-&gt;notified || up-&gt;notify==0)){
		if(n-&gt;flag == NDebug)
			pprint("suicide: %s\n", n-&gt;msg);
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}

	if(up-&gt;notified) {
		qunlock(&amp;up-&gt;debug);
		splhi();
		return 0;
	}

	if(!up-&gt;notify) {
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}

	if(up-&gt;fpstate == FPactive){
		fpsave(&amp;up-&gt;fpsave);
		up-&gt;fpstate = FPinactive;
	}
	up-&gt;fpstate |= FPillegal;

	sp = ur-&gt;usp &amp; ~(BY2V-1);
	sp -= sizeof(Ureg);

	if(!okaddr((ulong)up-&gt;notify, BY2WD, 0) ||
	   !okaddr(sp-ERRMAX-4*BY2WD, sizeof(Ureg)+ERRMAX+4*BY2WD, 1)) {
		pprint("suicide: bad address or sp in notify\n");
		qunlock(&amp;up-&gt;debug);
		pexit("Suicide", 0);
	}

	memmove((Ureg*)sp, ur, sizeof(Ureg));
	*(Ureg**)(sp-BY2WD) = up-&gt;ureg;	/* word under Ureg is old up-&gt;ureg */
	up-&gt;ureg = (void*)sp;
	sp -= BY2WD+ERRMAX;
	memmove((char*)sp, up-&gt;note[0].msg, ERRMAX);
	sp -= 3*BY2WD;
	*(ulong*)(sp+2*BY2WD) = sp+3*BY2WD;	/* arg 2 is string */
	ur-&gt;r1 = (long)up-&gt;ureg;		/* arg 1 is ureg* */
	((ulong*)sp)[1] = (ulong)up-&gt;ureg;	/* arg 1 0(FP) is ureg* */
	((ulong*)sp)[0] = 0;			/* arg 0 is pc */
	ur-&gt;usp = sp;
	ur-&gt;pc = (ulong)up-&gt;notify;
	up-&gt;notified = 1;
	up-&gt;nnote--;
	memmove(&amp;up-&gt;lastnote, &amp;up-&gt;note[0], sizeof(Note));
	memmove(&amp;up-&gt;note[0], &amp;up-&gt;note[1], up-&gt;nnote*sizeof(Note));

	qunlock(&amp;up-&gt;debug);
	splx(s);
	return 1;
}


/*
 *   Return user to state before notify()
 */
void
noted(Ureg* ureg, ulong arg0)
{
	Ureg *nureg;
	ulong oureg, sp;

	qlock(&amp;up-&gt;debug);
	if(arg0!=NRSTR &amp;&amp; !up-&gt;notified) {
		qunlock(&amp;up-&gt;debug);
		pprint("call to noted() when not notified\n");
		pexit("Suicide", 0);
	}
	up-&gt;notified = 0;

	nureg = up-&gt;ureg;	/* pointer to user returned Ureg struct */

	/* sanity clause */
	oureg = (ulong)nureg;
	if(!okaddr((ulong)oureg-BY2WD, BY2WD+sizeof(Ureg), 0)){
		pprint("bad ureg in noted or call to noted when not notified\n");
		qunlock(&amp;up-&gt;debug);
		pexit("Suicide", 0);
	}

	memmove(ureg, nureg, sizeof(Ureg));

	switch(arg0){
	case NCONT:
	case NRSTR:
		if(!okaddr(nureg-&gt;pc, 1, 0) || !okaddr(nureg-&gt;usp, BY2WD, 0)){
			pprint("suicide: trap in noted\n");
			qunlock(&amp;up-&gt;debug);
			pexit("Suicide", 0);
		}
		up-&gt;ureg = (Ureg*)(*(ulong*)(oureg-BY2WD));
		qunlock(&amp;up-&gt;debug);
		break;

	case NSAVE:
		if(!okaddr(nureg-&gt;pc, BY2WD, 0)
		|| !okaddr(nureg-&gt;usp, BY2WD, 0)){
			pprint("suicide: trap in noted\n");
			qunlock(&amp;up-&gt;debug);
			pexit("Suicide", 0);
		}
		qunlock(&amp;up-&gt;debug);
		sp = oureg-4*BY2WD-ERRMAX;
		splhi();
		ureg-&gt;sp = sp;
		((ulong*)sp)[1] = oureg;	/* arg 1 0(FP) is ureg* */
		((ulong*)sp)[0] = 0;		/* arg 0 is pc */
		break;

	default:
		pprint("unknown noted arg 0x%lux\n", arg0);
		up-&gt;lastnote.flag = NDebug;
		/* fall through */
		
	case NDFLT:
		if(up-&gt;lastnote.flag == NDebug)
			pprint("suicide: %s\n", up-&gt;lastnote.msg);
		qunlock(&amp;up-&gt;debug);
		pexit(up-&gt;lastnote.msg, up-&gt;lastnote.flag!=NDebug);
	}
	up-&gt;fpstate &amp;= ~FPillegal;
	if (up-&gt;fpstate == FPactive)
		ureg-&gt;srr1 |= MSR_FP;
	else
		ureg-&gt;srr1 &amp;= ~MSR_FP;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

