<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/ppc/uartsmc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/ppc/uartsmc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "../port/lib.h"
#include "mem.h"
#include "dat.h"
#include "fns.h"
#include "io.h"
#include "imm.h"
#include "../port/error.h"
#include "../ppc/uartsmc.h"

/*
 * PowerPC 8260 SMC UART
 */

enum {
	/* SMC Mode Registers */
	Clen		= 0x7800,	/* Character length */
	Sl		= 0x0400,	/* Stop length, 0: one stop bit, 1: two */
	Pen		= 0x0200,	/* Parity enable */
	Pm		= 0x0100,	/* Parity mode, 0 is odd */
	Sm		= 0x0030,	/* SMC mode, two bits */
	SMUart	= 0x0020,	/* SMC mode, 0b10 is uart */
	Dm		= 0x000c,	/* Diagnostic mode, 00 is normal */
	Ten		= 0x0002,	/* Transmit enable, 1 is enabled */
	Ren		= 0x0001,	/* Receive enable, 1 is enabled */

	/* SMC Event/Mask Registers */
	ce_Brke	= 0x0040,	/* Break end */
	ce_Br	= 0x0020,	/* Break character received */
	ce_Bsy	= 0x0004,	/* Busy condition */
	ce_Txb	= 0x0002,	/* Tx buffer */
	ce_Rxb	= 0x0001,	/* Rx buffer */

	/* Receive/Transmit Buffer Descriptor Control bits */
	BDContin=	1&lt;&lt;9,
	BDIdle=		1&lt;&lt;8,
	BDPreamble=	1&lt;&lt;8,
	BDBreak=	1&lt;&lt;5,
	BDFrame=	1&lt;&lt;4,
	BDParity=	1&lt;&lt;3,
	BDOverrun=	1&lt;&lt;1,

	/* Tx and Rx buffer sizes (32 bytes) */
	Rxsize=		CACHELINESZ,
	Txsize=		CACHELINESZ,
};

extern PhysUart smcphysuart;

Uart smcuart[Nuart] = {
	{
		.name = "SMC1",
		.baud = 115200,
		.bits = 8,
		.stop = 1,
		.parity = 'n',
		.phys = &amp;smcphysuart,
		.special = 0,
	},
/*	Only configure SMC1 for now
	{
		.name = "SMC2",
		.baud = 115200,
		.bits = 8,
		.stop = 1,
		.parity = 'n',
		.phys = &amp;smcphysuart,
		.special = 0,
	},
*/
};

int uartinited = 0;

static void smcinterrupt(Ureg*, void*);
static void smcputc(Uart *uart, int c);

int
baudgen(int baud)
{
	int d;

	d = ((m-&gt;brghz+(baud&gt;&gt;1))/baud)&gt;&gt;4;
	if(d &gt;= (1&lt;&lt;12))
		return ((d+15)&gt;&gt;3)|1;
	return d&lt;&lt;1;
}

static Uart*
smcpnp(void)
{
	int i;

	for (i = 0; i &lt; nelem(smcuart) - 1; i++)
		smcuart[i].next = smcuart + i + 1;
	return smcuart;
}

void
smcsetup(Uart *uart)
{
	Uartsmc *p;
	SMC *smc;
	UartData *ud;

	ud = uart-&gt;regs;

	/* magic addresses */

	p = &amp;m-&gt;immr-&gt;uartsmc[ud-&gt;smcno];
	smc = imm-&gt;smc + ud-&gt;smcno;	/* SMC1 */
	ud-&gt;smc = smc;
	ud-&gt;usmc = p;

	/* step 0: disable rx/tx */
	smc-&gt;smcmr &amp;= ~3;

	ioplock();

	/* step 1, Using Port D */
	if (ud-&gt;smcno != 0)
		panic("Don't know how to set Port D bits");
	imm-&gt;port[SMC1PORT].ppar |= SMRXD1|SMTXD1;
	imm-&gt;port[SMC1PORT].pdir |= SMTXD1;
	imm-&gt;port[SMC1PORT].pdir &amp;= ~SMRXD1;
	imm-&gt;port[SMC1PORT].psor &amp;= ~(SMRXD1|SMTXD1);

	/* step 2: set up brgc1 */
	imm-&gt;brgc[ud-&gt;smcno]  = baudgen(uart-&gt;baud) | 0x10000;

	/* step 3: route clock to SMC1 */
	imm-&gt;cmxsmr &amp;= (ud-&gt;smcno == 0) ? ~0xb0 : ~0xb;	/* clear smcx and smcxcs */

	iopunlock();

	/* step 4: assign a pointer to the SMCparameter RAM */
	m-&gt;immr-&gt;param[ud-&gt;smcno].smcbase = (ulong)p - IMMR;

	/* step 6: issue command to CP */
	if (ud-&gt;smcno == 0)
		cpmop(InitRxTx, SMC1ID, 0);
	else
		cpmop(InitRxTx, SMC2ID, 0);

	/* step 7: protocol parameters */
	p-&gt;rfcr = 0x30;
	p-&gt;tfcr = 0x30;
}

void
smcinit(Uart *uart)
{
	Uartsmc *p;
	SMC *smc;
	UartData *ud;
	ulong lcr;
	int bits;

	ud = uart-&gt;regs;

	if (ud-&gt;initialized)
		return;

	smcsetup(uart);	/* Steps 1 through 4, PPC-dependent */
	p = ud-&gt;usmc;
	smc = ud-&gt;smc;

	/* step 5: set up buffer descriptors */
	/* setup my uart structure */
	if (ud-&gt;rxb == nil)
		ud-&gt;rxb = bdalloc(1);
	if (ud-&gt;txb == nil)
		ud-&gt;txb = bdalloc(1);

	p-&gt;rbase = ((ulong)ud-&gt;rxb) - (ulong)IMMR;
	p-&gt;tbase = ((ulong)ud-&gt;txb) - (ulong)IMMR;

	/* step 8: receive buffer size */
	p-&gt;mrblr = Rxsize;

	/* step 9: */
	p-&gt;maxidl = 15;

	/* step 10: */
	p-&gt;brkln = 0;
	p-&gt;brkec = 0;

	/* step 11: */
	p-&gt;brkcr = 0;

	/* step 12: setup receive buffer */
	ud-&gt;rxb-&gt;status = BDEmpty|BDWrap|BDInt;
	ud-&gt;rxb-&gt;length = 0;
	ud-&gt;rxbuf = xspanalloc(Rxsize, 0, CACHELINESZ);
	ud-&gt;rxb-&gt;addr = PADDR(ud-&gt;rxbuf);

	/* step 13: step transmit buffer */
	ud-&gt;txb-&gt;status = BDWrap|BDInt;
	ud-&gt;txb-&gt;length = 0;
	ud-&gt;txbuf = xspanalloc(Txsize, 0, CACHELINESZ);
	ud-&gt;txb-&gt;addr = PADDR(ud-&gt;txbuf);

	/* step 14: clear events */
	smc-&gt;smce = ce_Brke | ce_Br | ce_Bsy | ce_Txb | ce_Rxb;

	/* 
	 * step 15: enable interrupts (done later)
	 * smc-&gt;smcm = ce_Brke | ce_Br | ce_Bsy | ce_Txb | ce_Rxb;
	 */

	/* step 17: set parity, no of bits, UART mode, ... */
	lcr = SMUart;
	bits = uart-&gt;bits + 1;

	switch(uart-&gt;parity){
	case 'e':
		lcr |= (Pen|Pm);
		bits +=1;
		break;
	case 'o':
		lcr |= Pen;
		bits +=1;
		break;
	case 'n':
	default:
		break;
	}

	if(uart-&gt;stop == 2){
		lcr |= Sl;
		bits += 1;
	}

	/* Set new value and reenable if device was previously enabled */
	smc-&gt;smcmr = lcr |  bits &lt;&lt;11 | 0x3;

	ud-&gt;initialized = 1;
}

static void
smcenable(Uart *uart, int intenb)
{
	UartData *ud;
	SMC *smc;
	int nr;

	nr = uart - smcuart;
	if (nr &lt; 0 || nr &gt; Nuart)
		panic("No SMC %d", nr);
	ud = uartdata + nr;
	ud-&gt;smcno = nr;
	uart-&gt;regs = ud;
	if (ud-&gt;initialized == 0)
		smcinit(uart);
	if (ud-&gt;enabled || intenb == 0)
		return;
	smc = ud-&gt;smc;
	/* clear events */
	smc-&gt;smce = ce_Brke | ce_Br | ce_Bsy | ce_Txb | ce_Rxb;
	/* enable interrupts */
	smc-&gt;smcm = ce_Brke | ce_Br | ce_Bsy | ce_Txb | ce_Rxb;
	intrenable(VecSMC1 + ud-&gt;smcno, smcinterrupt, uart, uart-&gt;name);
	ud-&gt;enabled = 1;
}

static long
smcstatus(Uart* uart, void* buf, long n, long offset)
{
	SMC *sp;
	char p[128];

	sp = ((UartData*)uart-&gt;regs)-&gt;smc;
	snprint(p, sizeof p, "b%d c%d e%d l%d m0 p%c s%d i1\n"
		"dev(%d) type(%d) framing(%d) overruns(%d)\n",

		uart-&gt;baud,
		uart-&gt;hup_dcd, 
		uart-&gt;hup_dsr,
		((sp-&gt;smcmr &amp; Clen) &gt;&gt;11) - ((sp-&gt;smcmr&amp;Pen) ? 1 : 0) - ((sp-&gt;smcmr&amp;Sl) ? 2 : 1),
		(sp-&gt;smcmr &amp; Pen) ? ((sp-&gt;smcmr &amp; Pm) ? 'e': 'o'): 'n',
		(sp-&gt;smcmr &amp; Sl) ? 2: 1,

		uart-&gt;dev,
		uart-&gt;type,
		uart-&gt;ferr,
		uart-&gt;oerr 
	);
	n = readstr(offset, buf, n, p);
	free(p);

	return n;
}

static void
smcfifo(Uart*, int)
{
	/*
	 * Toggle FIFOs:
	 * if none, do nothing;
	 * reset the Rx and Tx FIFOs;
	 * empty the Rx buffer and clear any interrupt conditions;
	 * if enabling, try to turn them on.
	 */
	return;
}

static void
smcdtr(Uart*, int)
{
}

static void
smcrts(Uart*, int)
{
}

static void
smcmodemctl(Uart*, int)
{
}

static int
smcparity(Uart* uart, int parity)
{
	int lcr;
	SMC *sp;

	sp = ((UartData*)uart-&gt;regs)-&gt;smc;

	lcr = sp-&gt;smcmr &amp; ~(Pen|Pm);

	/* Disable transmitter/receiver. */
	sp-&gt;smcmr &amp;= ~(Ren | Ten);

	switch(parity){
	case 'e':
		lcr |= (Pen|Pm);
		break;
	case 'o':
		lcr |= Pen;
		break;
	case 'n':
	default:
		break;
	}
	/* Set new value and reenable if device was previously enabled */
	sp-&gt;smcmr = lcr;

	uart-&gt;parity = parity;

	return 0;
}

static int
smcstop(Uart* uart, int stop)
{
	int lcr, bits;
	SMC *sp;

	sp = ((UartData*)uart-&gt;regs)-&gt;smc;
	lcr = sp-&gt;smcmr &amp; ~(Sl | Clen);

	/* Disable transmitter/receiver. */
	sp-&gt;smcmr &amp;= ~(Ren | Ten);

	switch(stop){
	case 1:
		break;
	case 2:
		lcr |= Sl;
		break;
	default:
		return -1;
	}

	bits = uart-&gt;bits + ((lcr &amp; Pen) ? 1 : 0) + ((lcr &amp; Sl) ? 2 : 1);
	lcr |= bits&lt;&lt;11;

	/* Set new value and reenable if device was previously enabled */
	sp-&gt;smcmr = lcr;

	uart-&gt;stop = stop;

	return 0;
}

static int
smcbits(Uart* uart, int bits)
{
	int lcr, b;
	SMC *sp;

	if (bits &lt; 5 || bits &gt; 14)
		return -1;

	sp = ((UartData*)uart-&gt;regs)-&gt;smc;
	lcr = sp-&gt;smcmr &amp; ~Clen;

	b = bits + ((sp-&gt;smcmr &amp; Pen) ? 1 : 0) + ((sp-&gt;smcmr &amp; Sl) ? 2 : 1);

	if (b &gt; 15)
		return -1;

	/* Disable transmitter/receiver */
	sp-&gt;smcmr &amp;= ~(Ren | Ten);

	/* Set new value and reenable if device was previously enabled */
	sp-&gt;smcmr = lcr |  b&lt;&lt;11;

	uart-&gt;bits = bits;

	return 0;
}

static int
smcbaud(Uart* uart, int baud)
{
	int i;
	SMC *sp;

	if (uart-&gt;enabled){
		sp = ((UartData*)uart-&gt;regs)-&gt;smc;
	
		if(uart-&gt;freq == 0 || baud &lt;= 0)
			return -1;
	
		i = sp - imm-&gt;smc;
		imm-&gt;brgc[i] = (((m-&gt;brghz &gt;&gt; 4) / baud) &lt;&lt; 1) | 0x00010000;
	}
	uart-&gt;baud = baud;

	return 0;
}

static void
smcbreak(Uart*, int)
{
}

static void
smckick(Uart *uart)
{
	BD *txb;
	UartData *ud;
	int i;

	if(uart-&gt;blocked)
		return;

	ud = uart-&gt;regs;
	txb = ud-&gt;txb;

	if (txb-&gt;status &amp; BDReady)
		return;	/* Still busy */

	for(i = 0; i &lt; Txsize; i++){
		if(uart-&gt;op &gt;= uart-&gt;oe &amp;&amp; uartstageoutput(uart) == 0)
			break;
		ud-&gt;txbuf[i] = *(uart-&gt;op++);
	}
	if (i == 0)
		return;
	dcflush(ud-&gt;txbuf, Txsize);
	txb-&gt;length = i;
	sync();
	txb-&gt;status |= BDReady|BDInt;
}

static void
smcinterrupt(Ureg*, void* u)
{
	int i, nc;
	char *buf;
	BD *rxb;
	UartData *ud;
	Uart *uart;
	uchar events;

	uart = u;
	if (uart == nil)
		panic("uart is nil");
	ud = uart-&gt;regs;
	if (ud == nil)
		panic("ud is nil");

	events = ud-&gt;smc-&gt;smce;
	ud-&gt;smc-&gt;smce = events;	/* Clear events */

	if (events &amp; 0x10)
		iprint("smc%d: break\n", ud-&gt;smcno);
	if (events &amp; 0x4)
		uart-&gt;oerr++;
	if (events &amp; 0x1){
		/* Receive characters
		*/
		rxb = ud-&gt;rxb;
		buf = ud-&gt;rxbuf;
		dczap(buf, Rxsize);	/* invalidate data cache before copying */
		if ((rxb-&gt;status &amp; BDEmpty) == 0){
			nc = rxb-&gt;length;
			for (i=0; i&lt;nc; i++)
				uartrecv(uart, *buf++);
			sync();
			rxb-&gt;status |= BDEmpty;
		}else{
			iprint("uartsmc: unexpected receive event\n");
		}
	}
	if (events &amp; 0x2){
		if ((ud-&gt;txb-&gt;status &amp; BDReady) == 0)
			uartkick(uart);
	}
}

static void
smcdisable(Uart* uart)
{
	SMC *sp;

	sp = ((UartData*)uart-&gt;regs)-&gt;smc;
	sp-&gt;smcmr &amp;= ~(Ren | Ten);
}

static int
getchars(Uart *uart, uchar *cbuf)
{
	int i, nc;
	char *buf;
	BD *rxb;
	UartData *ud;

	ud = uart-&gt;regs;
	rxb = ud-&gt;rxb;

	/* Wait for character to show up.
	*/
	buf = ud-&gt;rxbuf;
	while (rxb-&gt;status &amp; BDEmpty)
		;
	nc = rxb-&gt;length;
	for (i=0; i&lt;nc; i++)
		*cbuf++ = *buf++;
	sync();
	rxb-&gt;status |= BDEmpty;

	return(nc);
}

static int
smcgetc(Uart *uart)
{
	static uchar buf[128], *p;
	static int cnt;
	char	c;

	if (cnt &lt;= 0) {
		cnt = getchars(uart, buf);
		p = buf;
	}
	c = *p++;
	cnt--;

	return(c);
}

static void
smcputc(Uart *uart, int c)
{
	BD *txb;
	UartData *ud;
	SMC *smc;

	ud = uart-&gt;regs;
	txb = ud-&gt;txb;
	smc = ud-&gt;smc;
	smc-&gt;smcm = 0;

	/* Wait for last character to go.
	*/
	while (txb-&gt;status &amp; BDReady)
		;

	ud-&gt;txbuf[0] = c;
	dcflush(ud-&gt;txbuf, 1);
	txb-&gt;length = 1;
	sync();
	txb-&gt;status |= BDReady;

	while (txb-&gt;status &amp; BDReady)
		;
}

PhysUart smcphysuart = {
	.name		= "smc",
	.pnp			= smcpnp,
	.enable		= smcenable,
	.disable		= smcdisable,
	.kick			= smckick,
	.dobreak		= smcbreak,
	.baud		= smcbaud,
	.bits			= smcbits,
	.stop			= smcstop,
	.parity		= smcparity,
	.modemctl	= smcmodemctl,
	.rts			= smcrts,
	.dtr			= smcdtr,
	.status		= smcstatus,
	.fifo			= smcfifo,
	.getc			= smcgetc,
	.putc			= smcputc,
};

void
console(void)
{
	Uart *uart;
	int n;
	char *cmd, *p;

	if((p = getconf("console")) == nil)
		return;
	n = strtoul(p, &amp;cmd, 0);
	if(p == cmd)
		return;
	if(n &lt; 0 || n &gt;= nelem(smcuart))
		return;
	uart = smcuart + n;

/*	uartctl(uart, "b115200 l8 pn s1"); */
	if(*cmd != '\0')
		uartctl(uart, cmd);
	(*uart-&gt;phys-&gt;enable)(uart, 0);

	consuart = uart;
	uart-&gt;console = 1;
} 
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

