<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/9/rb/trap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/9/rb/trap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * traps, exceptions, faults and interrupts on ar7161
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"ureg.h"
#include	"io.h"
#include	&lt;tos.h&gt;
#include	"../port/error.h"

#define setstatus(v)	/* experiment: delete this to enable recursive traps */

typedef struct Handler Handler;

struct Handler {
	void	(*handler)(void *);
	void	*arg;
	Handler	*next;			/* at this interrupt level */
	ulong	intrs;
};

ulong offintrs;
ulong intrcauses[ILmax+1];

int	intr(Ureg*);
void	kernfault(Ureg*, int);
void	noted(Ureg*, Ureg**, ulong);
void	rfnote(Ureg**);

char *excname[] =
{
	"trap: external interrupt",
	"trap: TLB modification (store to unwritable)",
	"trap: TLB miss (load or fetch)",
	"trap: TLB miss (store)",
	"trap: address error (load or fetch)",
	"trap: address error (store)",
	"trap: bus error (fetch)",
	"trap: bus error (data load or store)",
	"trap: system call",
	"breakpoint",
	"trap: reserved instruction",
	"trap: coprocessor unusable",
	"trap: arithmetic overflow",
	"trap: TRAP exception",
	"trap: VCE (instruction)",
	"trap: floating-point exception",
	"trap: coprocessor 2 implementation-specific", /* used as sys call for debugger */
	"trap: corextend unusable",
	"trap: precise coprocessor 2 exception",
	"trap: TLB read-inhibit",
	"trap: TLB execute-inhibit",
	"trap: undefined 21",
	"trap: undefined 22",
	"trap: WATCH exception",
	"trap: machine checkcore",
	"trap: undefined 25",
	"trap: undefined 26",
	"trap: undefined 27",
	"trap: undefined 28",
	"trap: undefined 29",
	"trap: cache error",
	"trap: VCE (data)",
};

char *fpcause[] =
{
	"inexact operation",
	"underflow",
	"overflow",
	"division by zero",
	"invalid operation",
};
char	*fpexcname(Ureg*, ulong, char*, uint);
#define FPEXPMASK	(0x3f&lt;&lt;12)	/* Floating exception bits in fcr31 */

struct {
	char	*name;
	uint	off;
} regname[] = {
	"STATUS", Ureg_status,
	"PC",	Ureg_pc,
	"SP",	Ureg_sp,
	"CAUSE",Ureg_cause,
	"BADADDR", Ureg_badvaddr,
	"TLBVIRT", Ureg_tlbvirt,
	"HI",	Ureg_hi,
	"LO",	Ureg_lo,
	"R31",	Ureg_r31,
	"R30",	Ureg_r30,
	"R28",	Ureg_r28,
	"R27",	Ureg_r27,
	"R26",	Ureg_r26,
	"R25",	Ureg_r25,
	"R24",	Ureg_r24,
	"R23",	Ureg_r23,
	"R22",	Ureg_r22,
	"R21",	Ureg_r21,
	"R20",	Ureg_r20,
	"R19",	Ureg_r19,
	"R18",	Ureg_r18,
	"R17",	Ureg_r17,
	"R16",	Ureg_r16,
	"R15",	Ureg_r15,
	"R14",	Ureg_r14,
	"R13",	Ureg_r13,
	"R12",	Ureg_r12,
	"R11",	Ureg_r11,
	"R10",	Ureg_r10,
	"R9",	Ureg_r9,
	"R8",	Ureg_r8,
	"R7",	Ureg_r7,
	"R6",	Ureg_r6,
	"R5",	Ureg_r5,
	"R4",	Ureg_r4,
	"R3",	Ureg_r3,
	"R2",	Ureg_r2,
	"R1",	Ureg_r1,
};

static Lock intrlock;
static Handler handlers[ILmax+1];

static char *
ptlb(ulong phys)
{
	static char buf[4][32];
	static int k;
	char *p;

	k = (k+1)&amp;3;
	p = buf[k];
	p += snprint(p, sizeof buf[k] - (p - buf[k]), "(%#lux %lud ",
		(phys&lt;&lt;6) &amp; ~(BY2PG-1), (phys&gt;&gt;3)&amp;7);
	if(phys &amp; 4)
		*p++ = 'd';
	if(phys &amp; 2)
		*p++ = 'v';
	if(phys &amp; 1)
		*p++ = 'g';
	*p++ = ')';
	*p = 0;
	return buf[k];
}

static void
kpteprint(Ureg *ur)
{
	ulong i, tlbstuff[3];
	KMap *k;

	i = (ur-&gt;badvaddr &amp; ~(2*BY2PG-1)) | TLBPID(tlbvirt());
	print("tlbvirt=%#lux\n", i);
	i = gettlbp(i, tlbstuff);
	print("i=%lud v=%#lux p0=%s p1=%s\n",
		i, tlbstuff[0], ptlb(tlbstuff[1]), ptlb(tlbstuff[2]));

	i = (ur-&gt;badvaddr &amp; ~KMAPADDR)&gt;&gt;15;
	if(i &gt; KPTESIZE){
		print("kpte index = %lud ?\n", i);
		return;
	}
	k = &amp;kpte[i];
	print("i=%lud, &amp;k=%#p, k={v=%#lux, p0=%s, p1=%s, pg=%#p}\n",
		i, k, k-&gt;virt, ptlb(k-&gt;phys0), ptlb(k-&gt;phys1), k-&gt;pg);
	print("pg={pa=%#lux, va=%#lux}\n", k-&gt;pg-&gt;pa, k-&gt;pg-&gt;va);
}

void
kvce(Ureg *ur, int ecode)
{
	char c;
	Pte **p;
	Page **pg;
	Segment *s;
	ulong addr, soff;

	c = 'D';
	if(ecode == CVCEI)
		c = 'I';
	print("Trap: VCE%c: addr=%#lux\n", c, ur-&gt;badvaddr);
	if((ur-&gt;badvaddr &amp; KSEGM) == KSEG3) {
		kpteprint(ur);
		return;
	}
	if(up &amp;&amp; !(ur-&gt;badvaddr &amp; KSEGM)) {
		addr = ur-&gt;badvaddr;
		s = seg(up, addr, 0);
		if(s == 0){
			print("kvce: no seg for %#lux\n", addr);
			for(;;)
				;
		}
		addr &amp;= ~(BY2PG-1);
		soff = addr - s-&gt;base;
		p = &amp;s-&gt;map[soff/PTEMAPMEM];
		if(*p){
			pg = &amp;(*p)-&gt;pages[(soff&amp;(PTEMAPMEM-1))/BY2PG];
			if(*pg)
				print("kvce: pa=%#lux, va=%#lux\n",
					(*pg)-&gt;pa, (*pg)-&gt;va);
			else
				print("kvce: no *pg\n");
		}else
			print("kvce: no *p\n");
	}
}

/* prepare to go to user space */
void
kexit(Ureg*)
{
	Tos *tos;

	/* precise time accounting, kernel exit */
	tos = (Tos*)(USTKTOP-sizeof(Tos));
	tos-&gt;kcycles += fastticks(&amp;tos-&gt;cyclefreq) - up-&gt;kentry;
	tos-&gt;pcycles = up-&gt;pcycles;
	tos-&gt;pid = up-&gt;pid;
}

void
trap(Ureg *ur)
{
	int ecode, clockintr, user, cop, x, fpchk;
	ulong fpfcr31;
	char buf[2*ERRMAX], buf1[ERRMAX], *fpexcep;
	static int dumps;

	ecode = (ur-&gt;cause&gt;&gt;2)&amp;EXCMASK;
	user = ur-&gt;status&amp;KUSER;
	if (ur-&gt;cause &amp; TS)
		panic("trap: tlb shutdown");

	fpchk = 0;
	if(user){
		up-&gt;dbgreg = ur;
		cycles(&amp;up-&gt;kentry);
		/* no fpu, so no fp state to save */
	}

	if (up &amp;&amp; (char *)(ur) - up-&gt;kstack &lt; 1024 &amp;&amp; dumps++ == 0) {
		iprint("trap: proc %ld kernel stack getting full\n", up-&gt;pid);
		dumpregs(ur);
		dumpstack();
	}
	if (up == nil &amp;&amp;
	    (char *)(ur) - (char *)m-&gt;stack &lt; 1024 &amp;&amp; dumps++ == 0) {
		iprint("trap: cpu%d kernel stack getting full\n", m-&gt;machno);
		dumpregs(ur);
		dumpstack();
	}

//	splhi();		/* for the experiment: make it explicit */
	/* clear EXL in status */
	setstatus(getstatus() &amp; ~EXL);

	clockintr = 0;
	switch(ecode){
	case CINT:
		clockintr = intr(ur);
		break;

	case CFPE:
		panic("FP exception but no FPU");
#ifdef OLD_MIPS_EXAMPLE
		fptrap(ur);
		clrfpintr();
		fpchk = 1;
#endif
		break;

	case CTLBM:
	case CTLBL:
	case CTLBS:
		/* user tlb entries assumed not overwritten during startup */
		if(up == 0)
			kernfault(ur, ecode);

		if(!user &amp;&amp; (ur-&gt;badvaddr &amp; KSEGM) == KSEG3) {
			kfault(ur);
			break;
		}
		x = up-&gt;insyscall;
		up-&gt;insyscall = 1;
		spllo();
		faultmips(ur, user, ecode);
		up-&gt;insyscall = x;
		break;

	case CVCEI:
	case CVCED:
		kvce(ur, ecode);
		goto Default;

	case CWATCH:
		if(!user)
			panic("watchpoint trap from kernel mode pc=%#p",
				ur-&gt;pc);
		fpwatch(ur);
		break;

	case CCPU:
		cop = (ur-&gt;cause&gt;&gt;28)&amp;3;
		if(user &amp;&amp; up &amp;&amp; cop == 1) {
			if(up-&gt;fpstate &amp; FPillegal) {
				/* someone used floating point in a note handler */
				postnote(up, 1,
					"sys: floating point in note handler",
					NDebug);
				break;
			}
			/* no fpu, so we can only emulate fp ins'ns */
			if (fpuemu(ur) &lt; 0)
				postnote(up, 1,
					"sys: fp instruction not emulated",
					NDebug);
			else
				fpchk = 1;
			break;
		}
		/* Fallthrough */

	Default:
	default:
		if(user) {
			spllo();
			snprint(buf, sizeof buf, "sys: %s", excname[ecode]);
			postnote(up, 1, buf, NDebug);
			break;
		}
		if (ecode == CADREL || ecode == CADRES)
			iprint("kernel addr exception for va %#p pid %#ld %s\n",
				ur-&gt;badvaddr, (up? up-&gt;pid: 0),
				(up? up-&gt;text: ""));
		print("cpu%d: kernel %s pc=%#lux\n",
			m-&gt;machno, excname[ecode], ur-&gt;pc);
		dumpregs(ur);
		dumpstack();
		if(m-&gt;machno == 0)
			spllo();
		exit(1);
	}

	if(fpchk) {
		fpfcr31 = up-&gt;fpsave.fpstatus;
		if((fpfcr31&gt;&gt;12) &amp; ((fpfcr31&gt;&gt;7)|0x20) &amp; 0x3f) {
			spllo();
			fpexcep	= fpexcname(ur, fpfcr31, buf1, sizeof buf1);
			snprint(buf, sizeof buf, "sys: fp: %s", fpexcep);
			postnote(up, 1, buf, NDebug);
		}
	}

	splhi();

	/* delaysched set because we held a lock or because our quantum ended */
	if(up &amp;&amp; up-&gt;delaysched &amp;&amp; clockintr){
		sched();
		splhi();
	}

	if(user){
		notify(ur);
		/* no fpu, so no fp state to restore */
		kexit(ur);
	}

	/* restore EXL in status */
	setstatus(getstatus() | EXL);
}

/* periodically zero all the interrupt counts */
static void
resetcounts(void)
{
	int i;
	Handler *hp;

	ilock(&amp;intrlock);
	for (i = 0; i &lt; nelem(handlers); i++)
		for (hp = &amp;handlers[i]; hp != nil; hp = hp-&gt;next)
			hp-&gt;intrs = 0;
	iunlock(&amp;intrlock);
}

/*
 *  set handlers
 */
void
intrenable(int irq, void (*h)(void *), void *arg)
{
	Handler *hp;
	static int resetclock;

	if (h == nil)
		panic("intrenable: nil handler intr %d", irq);
	if(irq &lt; ILmin || irq &gt;= nelem(handlers))
		panic("intrenable: bad handler intr %d %#p", irq, h);

	hp = &amp;handlers[irq];
	ilock(&amp;intrlock);
	if (hp-&gt;handler != nil) {		/* occupied? */
		/* add a new one at the end of the chain */
		for (; hp-&gt;next != nil; hp = hp-&gt;next)
			;
		hp-&gt;next = smalloc(sizeof *hp);
		hp = hp-&gt;next;
		hp-&gt;next = nil;
	}
	hp-&gt;handler = h;
	hp-&gt;arg = arg;
	iunlock(&amp;intrlock);

	if (irq == ILduart0) {		/* special apb sub-interrupt */
		*Apbintrsts = 0;
		*Apbintrmask = 1 &lt;&lt; Apbintruart;  /* enable, actually */
		coherence();
	}
	intron(1 &lt;&lt; (ILshift + irq));
	if (!resetclock) {
		resetclock = 1;
		addclock0link(resetcounts, 100);
	}
}

void
intrshutdown(void)
{
	introff(INTMASK);
}

static void
jabberoff(Ureg *ur, int irq, ulong bit)
{
	introff(bit);			/* interrupt off now ... */
	if (ur)
		ur-&gt;status &amp;= ~bit;	/* ... and upon return */
	offintrs |= bit;
	iprint("irq %d jabbering; shutting it down\n", irq);
}

ulong
pollall(Ureg *ur, ulong cause)			/* must be called splhi */
{
	int i, intrs, sts;
	ulong bit;
	Handler *hp;

	/* exclude clock and sw intrs */
	intrs = cause &amp; (INTR6|INTR5|INTR4|INTR3|INTR2) &amp; getstatus();
	if(intrs == 0)
		return cause;

	ilock(&amp;intrlock);
	for (i = ILmax; i &gt;= ILmin; i--) {
		bit = 1 &lt;&lt; (ILshift + i);
		if (!(intrs &amp; bit))
			continue;
		intrcauses[i]++;
		for (hp = &amp;handlers[i]; hp != nil; hp = hp-&gt;next)
			if (hp-&gt;handler) {
				if (i == ILduart0) {
					sts = *Apbintrsts;
					if((sts &amp; (1 &lt;&lt; Apbintruart)) == 0)
						continue;
					/* don't need to ack apb sub-intr */
					// *Apbintrsts &amp;= ~(1 &lt;&lt; Apbintruart);
				}
				(*hp-&gt;handler)(hp-&gt;arg);
				splhi();
				if (++hp-&gt;intrs &gt; 25000) {
					jabberoff(ur, i, bit);
					intrs &amp;= ~bit;
					hp-&gt;intrs = 0;
				}
			} else if (ur)
				iprint("no handler for interrupt %d\n", i);
		cause &amp;= ~bit;
	}
	iunlock(&amp;intrlock);
	return cause;
}

int
intr(Ureg *ur)
{
	int clockintr;
	ulong cause;

	m-&gt;intr++;
	clockintr = 0;
	/*
	 * ignore interrupts that we have disabled, even if their cause bits
	 * are set.
	 */
	cause = ur-&gt;cause &amp; ur-&gt;status &amp; INTMASK;
	cause &amp;= ~(INTR1|INTR0);		/* ignore sw interrupts */
	if (cause == 0)
		print("spurious interrupt\n");
	if(cause &amp; INTR7){
		clock(ur);
		intrcauses[ILclock]++;
		cause &amp;= ~(1 &lt;&lt; (ILclock + ILshift));
		clockintr = 1;
	}
	cause = pollall(ur, cause);
	if(cause){
		print("intr: cause %#lux not handled\n", cause);
		exit(1);
	}

	/* preemptive scheduling */
	if(up &amp;&amp; !clockintr)
		preempted();
	/* if it was a clockintr, sched will be called at end of trap() */
	return clockintr;
}

char*
fpexcname(Ureg *ur, ulong fcr31, char *buf, uint size)
{
	int i;
	char *s;
	ulong fppc;

	fppc = ur-&gt;pc;
	if(ur-&gt;cause &amp; BD)	/* branch delay */
		fppc += 4;
	s = 0;
	if(fcr31 &amp; (1&lt;&lt;17))
		s = "unimplemented operation";
	else{
		fcr31 &gt;&gt;= 7;		/* trap enable bits */
		fcr31 &amp;= (fcr31&gt;&gt;5);	/* anded with exceptions */
		for(i=0; i&lt;5; i++)
			if(fcr31 &amp; (1&lt;&lt;i))
				s = fpcause[i];
	}

	if(s == 0)
		return "no floating point exception";

	snprint(buf, size, "%s fppc=%#lux", s, fppc);
	return buf;
}

#define KERNPC(x) (KTZERO &lt;= (ulong)(x) &amp;&amp; (ulong)(x) &lt; (ulong)&amp;etext)

void
kernfault(Ureg *ur, int code)
{
	print("panic: kfault %s badvaddr=%#lux", excname[code], ur-&gt;badvaddr);
	kpteprint(ur);
	print("u=%#p status=%#lux pc=%#lux sp=%#lux\n",
		up, ur-&gt;status, ur-&gt;pc, ur-&gt;sp);
	delay(500);
	panic("kfault");
}

static void
getpcsp(ulong *pc, ulong *sp)
{
	*pc = getcallerpc(&amp;pc);
	*sp = (ulong)&amp;pc-4;
}

void
callwithureg(void (*fn)(Ureg*))
{
	Ureg ureg;

	memset(&amp;ureg, 0, sizeof ureg);
	getpcsp((ulong*)&amp;ureg.pc, (ulong*)&amp;ureg.sp);
	ureg.r31 = getcallerpc(&amp;fn);
	fn(&amp;ureg);
}

static void
_dumpstack(Ureg *ureg)
{
	ulong l, v, top, i;
	extern ulong etext;

	if(up == 0)
		return;

	print("ktrace /kernel/path %.8lux %.8lux %.8lux\n",
		ureg-&gt;pc, ureg-&gt;sp, ureg-&gt;r31);
	top = (ulong)up-&gt;kstack + KSTACK;
	i = 0;
	for(l=ureg-&gt;sp; l &lt; top; l += BY2WD) {
		v = *(ulong*)l;
		if(KTZERO &lt; v &amp;&amp; v &lt; (ulong)&amp;etext) {
			print("%.8lux=%.8lux ", l, v);
			if((++i%4) == 0){
				print("\n");
				delay(200);
			}
		}
	}
	print("\n");
}

void
dumpstack(void)
{
	callwithureg(_dumpstack);
}

static ulong
R(Ureg *ur, int i)
{
	uchar *s;

	s = (uchar*)ur;
	return *(ulong*)(s + regname[i].off - Uoffset);
}

void
dumpregs(Ureg *ur)
{
	int i;

	if(up)
		print("registers for %s %lud\n", up-&gt;text, up-&gt;pid);
	else
		print("registers for kernel\n");

	for(i = 0; i &lt; nelem(regname); i += 2)
		print("%s\t%#.8lux\t%s\t%#.8lux\n",
			regname[i].name,   R(ur, i),
			regname[i+1].name, R(ur, i+1));
}

int
notify(Ureg *ur)
{
	int l, s;
	ulong sp;
	Note *n;

	if(up-&gt;procctl)
		procctl(up);
	if(up-&gt;nnote == 0)
		return 0;

	s = spllo();
	qlock(&amp;up-&gt;debug);
	up-&gt;fpstate |= FPillegal;
	up-&gt;notepending = 0;
	n = &amp;up-&gt;note[0];
	if(strncmp(n-&gt;msg, "sys:", 4) == 0) {
		l = strlen(n-&gt;msg);
		if(l &gt; ERRMAX-15)	/* " pc=0x12345678\0" */
			l = ERRMAX-15;

		seprint(n-&gt;msg+l, &amp;n-&gt;msg[sizeof n-&gt;msg], " pc=%#lux", ur-&gt;pc);
	}

	if(n-&gt;flag != NUser &amp;&amp; (up-&gt;notified || up-&gt;notify==0)) {
		if(n-&gt;flag == NDebug)
			pprint("suicide: %s\n", n-&gt;msg);

		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}

	if(up-&gt;notified) {
		qunlock(&amp;up-&gt;debug);
		splx(s);
		return 0;
	}

	if(!up-&gt;notify) {
		qunlock(&amp;up-&gt;debug);
		pexit(n-&gt;msg, n-&gt;flag!=NDebug);
	}
	sp = ur-&gt;usp &amp; ~(BY2V-1);
	sp -= sizeof(Ureg);

	if(!okaddr((ulong)up-&gt;notify, BY2WD, 0) ||
	   !okaddr(sp-ERRMAX-4*BY2WD, sizeof(Ureg)+ERRMAX+4*BY2WD, 1)) {
		pprint("suicide: bad address or sp in notify\n");
		qunlock(&amp;up-&gt;debug);
		pexit("Suicide", 0);
	}

	memmove((Ureg*)sp, ur, sizeof(Ureg));	/* push user regs */
	*(Ureg**)(sp-BY2WD) = up-&gt;ureg;	/* word under Ureg is old up-&gt;ureg */
	up-&gt;ureg = (void*)sp;

	sp -= BY2WD+ERRMAX;
	memmove((char*)sp, up-&gt;note[0].msg, ERRMAX);	/* push err string */

	sp -= 3*BY2WD;
	*(ulong*)(sp+2*BY2WD) = sp+3*BY2WD;	/* arg 2 is string */
	ur-&gt;r1 = (long)up-&gt;ureg;		/* arg 1 is ureg* */
	((ulong*)sp)[1] = (ulong)up-&gt;ureg;	/* arg 1 0(FP) is ureg* */
	((ulong*)sp)[0] = 0;			/* arg 0 is pc */
	ur-&gt;usp = sp;
	/*
	 * arrange to resume at user's handler as if handler(ureg, errstr)
	 * were being called.
	 */
	ur-&gt;pc = (ulong)up-&gt;notify;

	up-&gt;notified = 1;
	up-&gt;nnote--;
	memmove(&amp;up-&gt;lastnote, &amp;up-&gt;note[0], sizeof(Note));
	memmove(&amp;up-&gt;note[0], &amp;up-&gt;note[1], up-&gt;nnote*sizeof(Note));

	qunlock(&amp;up-&gt;debug);
	splx(s);
	return 1;
}

/*
 * Check that status is OK to return from note.
 */
int
validstatus(ulong kstatus, ulong ustatus)
{
//	if((kstatus &amp; (INTMASK|KX|SX|UX)) != (ustatus &amp; (INTMASK|KX|SX|UX)))
	if((kstatus &amp; INTMASK) != (ustatus &amp; INTMASK))
		return 0;
	if((ustatus&amp;(KSU|ERL|EXL|IE)) != (KUSER|EXL|IE))
		return 0;
	if(ustatus &amp; (0xFFFF0000&amp;~CU1))	/* no CU3, CU2, CU0, RP, FR, RE, DS */
		return 0;
	return 1;
}

/*
 * Return user to state before notify(); called from user's handler.
 */
void
noted(Ureg *kur, Ureg **urp, ulong arg0)
{
	Ureg *nur;
	ulong oureg, sp;

	qlock(&amp;up-&gt;debug);
	if(arg0!=NRSTR &amp;&amp; !up-&gt;notified) {
		qunlock(&amp;up-&gt;debug);
		pprint("call to noted() when not notified\n");
		pexit("Suicide", 0);
	}
	up-&gt;notified = 0;

	up-&gt;fpstate &amp;= ~FPillegal;

	nur = up-&gt;ureg;

	oureg = (ulong)nur;
	if((oureg &amp; (BY2WD-1))
	|| !okaddr((ulong)oureg-BY2WD, BY2WD+sizeof(Ureg), 0)){
		pprint("bad up-&gt;ureg in noted or call to noted() when not notified\n");
		qunlock(&amp;up-&gt;debug);
		pexit("Suicide", 0);
	}

	if(!validstatus(kur-&gt;status, nur-&gt;status)) {
		qunlock(&amp;up-&gt;debug);
		pprint("bad noted ureg status %#lux\n", nur-&gt;status);
		pexit("Suicide", 0);
	}

	memmove(*urp, up-&gt;ureg, sizeof(Ureg));
	switch(arg0) {
	case NCONT:
	case NRSTR:				/* only used by APE */
		if(!okaddr(nur-&gt;pc, BY2WD, 0) || !okaddr(nur-&gt;usp, BY2WD, 0)){
			pprint("suicide: trap in noted\n");
			qunlock(&amp;up-&gt;debug);
			pexit("Suicide", 0);
		}
		up-&gt;ureg = (Ureg*)(*(ulong*)(oureg-BY2WD));
		qunlock(&amp;up-&gt;debug);
		splhi();
		/*
		 * the old challenge and carrera ports called rfnote here,
		 * but newer ports do not, and notes seem to work only
		 * without this call.
		 */
		// rfnote(urp);		/* return from note with SP=urp */
		break;

	case NSAVE:				/* only used by APE */
		if(!okaddr(nur-&gt;pc, BY2WD, 0) || !okaddr(nur-&gt;usp, BY2WD, 0)){
			pprint("suicide: trap in noted\n");
			qunlock(&amp;up-&gt;debug);
			pexit("Suicide", 0);
		}
		qunlock(&amp;up-&gt;debug);
		sp = oureg-4*BY2WD-ERRMAX;

		splhi();
		(*urp)-&gt;sp = sp;
		((ulong*)sp)[1] = oureg;	/* arg 1 0(FP) is ureg* */
		((ulong*)sp)[0] = 0;		/* arg 0 is pc */
		(*urp)-&gt;r1 = oureg;		/* arg 1 is ureg* */

		// rfnote(urp);		/* return from note with SP=urp */
		break;

	default:
		pprint("unknown noted arg %#lux\n", arg0);
		up-&gt;lastnote.flag = NDebug;
		/* fall through */

	case NDFLT:
		if(up-&gt;lastnote.flag == NDebug)
			pprint("suicide: %s\n", up-&gt;lastnote.msg);
		qunlock(&amp;up-&gt;debug);
		pexit(up-&gt;lastnote.msg, up-&gt;lastnote.flag!=NDebug);
	}
}

#include "../port/systab.h"

static Ref goodsyscall;
static Ref totalsyscall;

static void
sctracesetup(ulong scallnr, ulong sp, uintptr pc, vlong *startnsp)
{
	if(up-&gt;procctl == Proc_tracesyscall){
		/*
		 * Redundant validaddr.  Do we care?
		 * Tracing syscalls is not exactly a fast path...
		 * Beware, validaddr currently does a pexit rather
		 * than an error if there's a problem; that might
		 * change in the future.
		 */
		if(sp &lt; (USTKTOP-BY2PG) || sp &gt; (USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		syscallfmt(scallnr, pc, (va_list)(sp+BY2WD));
		up-&gt;procctl = Proc_stopme;
		procctl(up);
		if(up-&gt;syscalltrace)
			free(up-&gt;syscalltrace);
		up-&gt;syscalltrace = nil;
		*startnsp = todget(nil);
	}
}

static void
sctracefinish(ulong scallnr, ulong sp, int ret, vlong startns)
{
	int s;

	if(up-&gt;procctl == Proc_tracesyscall){
		up-&gt;procctl = Proc_stopme;
		sysretfmt(scallnr, (va_list)(sp+BY2WD), ret,
			startns, todget(nil));
		s = splhi();
		procctl(up);
		splx(s);
		if(up-&gt;syscalltrace)
			free(up-&gt;syscalltrace);
		up-&gt;syscalltrace = nil;
	}
}

/*
 * called directly from assembler, not via trap()
 */
long
syscall(Ureg *aur)
{
	int i;
	volatile long ret;
	ulong sp, scallnr;
	vlong startns;
	char *e;
	Ureg *ur;

	cycles(&amp;up-&gt;kentry);

	incref(&amp;totalsyscall);
	m-&gt;syscall++;
	up-&gt;insyscall = 1;
	ur = aur;
	up-&gt;pc = ur-&gt;pc;
	up-&gt;dbgreg = aur;
	ur-&gt;cause = 16&lt;&lt;2;	/* for debugging: system call is undef 16 */

	scallnr = ur-&gt;r1;
	up-&gt;scallnr = ur-&gt;r1;
	sp = ur-&gt;sp;
	sctracesetup(scallnr, sp, ur-&gt;pc, &amp;startns);

	/* clear EXL in status */
	setstatus(getstatus() &amp; ~EXL);

	/* no fpu, so no fp state to save */
	spllo();

	up-&gt;nerrlab = 0;
	ret = -1;
	if(!waserror()) {
		if(scallnr &gt;= nsyscall || systab[scallnr] == 0){
			pprint("bad sys call number %ld pc %#lux\n",
				scallnr, ur-&gt;pc);
			postnote(up, 1, "sys: bad sys call", NDebug);
			error(Ebadarg);
		}

		if(sp &amp; (BY2WD-1)){
			pprint("odd sp in sys call pc %#lux sp %#lux\n",
				ur-&gt;pc, ur-&gt;sp);
			postnote(up, 1, "sys: odd stack", NDebug);
			error(Ebadarg);
		}

		if(sp&lt;(USTKTOP-BY2PG) || sp&gt;(USTKTOP-sizeof(Sargs)-BY2WD))
			validaddr(sp, sizeof(Sargs)+BY2WD, 0);

		up-&gt;s = *((Sargs*)(sp+BY2WD));
		up-&gt;psstate = sysctab[scallnr];

		ret = systab[scallnr](up-&gt;s.args);
		poperror();
	}else{
		/* failure: save the error buffer for errstr */
		e = up-&gt;syserrstr;
		up-&gt;syserrstr = up-&gt;errstr;
		up-&gt;errstr = e;
		if(0 &amp;&amp; up-&gt;pid == 1)
			print("[%lud %s] syscall %lud: %s\n",
				up-&gt;pid, up-&gt;text, scallnr, up-&gt;errstr);
	}
	if(up-&gt;nerrlab){
		print("bad errstack [%lud]: %d extra\n", scallnr, up-&gt;nerrlab);
		for(i = 0; i &lt; NERR; i++)
			print("sp=%#lux pc=%#lux\n",
				up-&gt;errlab[i].sp, up-&gt;errlab[i].pc);
		panic("error stack");
	}
	sctracefinish(scallnr, sp, ret, startns);

	ur-&gt;pc += 4;
	ur-&gt;r1 = ret;

	up-&gt;psstate = 0;
	up-&gt;insyscall = 0;

	if(scallnr == NOTED) {				/* ugly hack */
		noted(ur, &amp;aur, *(ulong*)(sp+BY2WD));	/* may return */
		ret = ur-&gt;r1;
	}
	incref(&amp;goodsyscall);
	splhi();
	if(scallnr!=RFORK &amp;&amp; (up-&gt;procctl || up-&gt;nnote)){
		ur-&gt;r1 = ret;			/* load up for noted() above */
		notify(ur);
	}
	/* if we delayed sched because we held a lock, sched now */
	if(up-&gt;delaysched)
		sched();
	kexit(ur);

	/* restore EXL in status */
	setstatus(getstatus() | EXL);

	return ret;
}

void
forkchild(Proc *p, Ureg *ur)
{
	Ureg *cur;

	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK-UREGSIZE;
	p-&gt;sched.pc = (ulong)forkret;

	cur = (Ureg*)(p-&gt;sched.sp+2*BY2WD);
	memmove(cur, ur, sizeof(Ureg));

	cur-&gt;pc += 4;

	/* Things from bottom of syscall we never got to execute */
	p-&gt;psstate = 0;
	p-&gt;insyscall = 0;
}

static
void
linkproc(void)
{
	spllo();
	up-&gt;kpfun(up-&gt;kparg);
	pexit("kproc exiting", 0);
}

void
kprocchild(Proc *p, void (*func)(void*), void *arg)
{
	p-&gt;sched.pc = (ulong)linkproc;
	p-&gt;sched.sp = (ulong)p-&gt;kstack+KSTACK;

	p-&gt;kpfun = func;
	p-&gt;kparg = arg;
}

/* set up user registers before return from exec() */
long
execregs(ulong entry, ulong ssize, ulong nargs)
{
	Ureg *ur;
	ulong *sp;

	sp = (ulong*)(USTKTOP - ssize);
	*--sp = nargs;

	ur = (Ureg*)up-&gt;dbgreg;
	ur-&gt;usp = (ulong)sp;
	ur-&gt;pc = entry - 4;		/* syscall advances it */
	up-&gt;fpsave.fpstatus = initfp.fpstatus;
	return USTKTOP-sizeof(Tos);	/* address of kernel/user shared data */
}

ulong
userpc(void)
{
	Ureg *ur;

	ur = (Ureg*)up-&gt;dbgreg;
	return ur-&gt;pc;
}

/*
 * This routine must save the values of registers the user is not
 * permitted to write from devproc and then restore the saved values
 * before returning
 */
void
setregisters(Ureg *xp, char *pureg, char *uva, int n)
{
	ulong status;

	status = xp-&gt;status;
	memmove(pureg, uva, n);
	xp-&gt;status = status;
}

/*
 * Give enough context in the ureg to produce a kernel stack for
 * a sleeping process
 */
void
setkernur(Ureg *xp, Proc *p)
{
	xp-&gt;pc = p-&gt;sched.pc;
	xp-&gt;sp = p-&gt;sched.sp;
	xp-&gt;r24 = (ulong)p;		/* up */
	xp-&gt;r31 = (ulong)sched;
}

ulong
dbgpc(Proc *p)
{
	Ureg *ur;

	ur = p-&gt;dbgreg;
	if(ur == 0)
		return 0;

	return ur-&gt;pc;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

