<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/make/files.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/make/files.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* POSIX DEPENDENT PROCEDURES */
#include "defs.h"
#include &lt;sys/stat.h&gt;
#include &lt;ar.h&gt;

#define NAMESPERBLOCK	32

/* DEFAULT RULES FOR POSIX */

char *dfltmacro[] =
	{
	".SUFFIXES : .o .c .y .l .a .sh .f",
	"MAKE=make",
	"AR=ar",
	"ARFLAGS=rv",
	"YACC=yacc",
	"YFLAGS=",
	"LEX=lex",
	"LFLAGS=",
	"LDFLAGS=",
	"CC=c89",
	"CFLAGS=-O",
	"FC=fort77",
	"FFLAGS=-O 1",
	0 };

char *dfltpat[] =
	{
	"%.o : %.c",
	"\t$(CC) $(CFLAGS) -c $&lt;",

	"%.o : %.y",
	"\t$(YACC) $(YFLAGS) $&lt;",
	"\t$(CC) $(CFLAGS) -c y.tab.c",
	"\trm y.tab.c",
	"\tmv y.tab.o $@",

	"%.o : %.l",
	"\t$(LEX) $(LFLAGS) $&lt;",
	"\t$(CC) $(CFLAGS) -c lex.yy.c",
	"\trm lex.yy.c",
	"\tmv lex.yy.o $@",

	"%.c : %.y",
	"\t$(YACC) $(YFLAGS) $&lt;",
	"\tmv y.tab.c $@",

	"%.c : %.l",
	"\t$(LEX) $(LFLAGS) $&lt;",
	"\tmv lex.yy.c $@",

	"% : %.o",
	"\t$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $&lt;",

	"% : %.c",
	"\t$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $&lt;",

	0 };



char *dfltsuff[] =
	{
	".SUFFIXES : .o .c .y .l .a .sh .f",
	".c.o :",
	"\t$(CC) $(CFLAGS) -c $&lt;",

	".f.o :",
	"\t$(FC) $(FFLAGS) -c $&lt;",

	".y.o :",
	"\t$(YACC) $(YFLAGS) $&lt;",
	"\t$(CC) $(CFLAGS) -c y.tab.c",
	"\trm -f y.tab.c",
	"\tmv y.tab.o $@",

	".l.o :",
	"\t$(LEX) $(LFLAGS) $&lt;",
	"\t$(CC) $(CFLAGS) -c lex.yy.c",
	"\trm -f lex.yy.c",
	"\tmv lex.yy.o $@",

	".y.c :",
	"\t$(YACC) $(YFLAGS) $&lt;",
	"\tmv y.tab.c $@",

	".l.c :",
	"\t$(LEX) $(LFLAGS) $&lt;",
	"\tmv lex.yy.c $@",

	".c.a:",
	"\t$(CC) -c $(CFLAGS) $&lt;",
	"\t$(AR) $(ARFLAGS) $@ $*.o",
	"\trm -f $*.o",

	".f.a:",
	"\t$(FC) -c $(FFLAGS) $&lt;",
	"\t$(AR) $(ARFLAGS) $@ $*.o",
	"\trm -f $*.o",

	".c:",
	"\t$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $&lt;",

	".f:",
	"\t$(FC) $(FFLAGS) $(LDFLAGS) -o $@ $&lt;",

	".sh:",
	"\tcp $&lt; $@",
	"\tchmod a+x $@",

	0 };


static struct dirhd	*opdir(char *, int);
static void		cldir(struct dirhd *, int);
static int		amatch(char *, char *);
static int		umatch(char *, char *);
static void		clarch(void);
static int		openarch(char *);
static int		getarch(void);

time_t
exists(char *filename)
{
struct stat buf;
char *s;

for(s = filename ; *s!='\0' &amp;&amp; *s!='(' &amp;&amp;  *s!=')' ; ++s)
	;

if(*s != '\0')
	return lookarch(filename);

if(stat(filename,&amp;buf) &lt; 0) 
	return 0;
else	return buf.st_mtime;
}


time_t
prestime(void)
{
time_t t;
time(&amp;t);
return t;
}

static char nmtemp[MAXNAMLEN+1];	/* guarantees a null after the name */
static char *tempend = nmtemp + MAXNAMLEN;



depblkp
srchdir(char *pat, int mkchain, depblkp nextdbl)
{
DIR *dirf;
struct dirhd *dirptr;
char *dirname, *dirpref, *endir, *filepat, *p, temp[100];
char fullname[100];
nameblkp q;
depblkp thisdbl;
struct pattern *patp;

struct dirent *dptr;

thisdbl = 0;

if(mkchain == NO)
	for(patp=firstpat ; patp ; patp = patp-&gt;nxtpattern)
		if(equal(pat, patp-&gt;patval)) return 0;

patp = ALLOC(pattern);
patp-&gt;nxtpattern = firstpat;
firstpat = patp;
patp-&gt;patval = copys(pat);

endir = 0;

for(p=pat; *p!='\0'; ++p)
	if(*p=='/') endir = p;

if(endir==0)
	{
	dirname = ".";
	dirpref = "";
	filepat = pat;
	}
else	{
	dirname = pat;
	*endir = '\0';
	dirpref = concat(dirname, "/", temp);
	filepat = endir+1;
	}

dirptr = opdir(dirname,YES);
dirf = dirptr-&gt;dirfc;

for( dptr = readdir(dirf) ; dptr ; dptr = readdir(dirf) )
	{
	char *p1, *p2;
	p1 = dptr-&gt;d_name;
	p2 = nmtemp;
	while( (p2&lt;tempend) &amp;&amp; (*p2++ = *p1++)!='\0')
		;
	if( amatch(nmtemp,filepat) )
		{
		concat(dirpref,nmtemp,fullname);
		if( (q=srchname(fullname)) ==0)
			q = makename(copys(fullname));
		if(mkchain)
			{
			thisdbl = ALLOC(depblock);
			thisdbl-&gt;nxtdepblock = nextdbl;
			thisdbl-&gt;depname = q;
			nextdbl = thisdbl;
			}
		}
	}


if(endir)
	*endir = '/';

cldir(dirptr, YES);

return thisdbl;
}

static struct dirhd *
opdir(char *dirname, int stopifbad)
{
struct dirhd *od;

for(od = firstod; od; od = od-&gt;nxtdirhd)
	if(equal(dirname, od-&gt;dirn) )
		break;

if(od == NULL)
	{
	++nopdir;
	od = ALLOC(dirhd);
	od-&gt;nxtdirhd = firstod;
	firstod = od;
	od-&gt;dirn = copys(dirname);
	}

if(od-&gt;dirfc==NULL &amp;&amp; (od-&gt;dirfc = opendir(dirname)) == NULL &amp;&amp; stopifbad)
	{
	fprintf(stderr, "Directory %s: ", dirname);
	fatal("Cannot open");
	}

return od;
}


static void
cldir(struct dirhd *dp, int used)
{
if(nopdir &gt;= MAXDIR)
	{
	closedir(dp-&gt;dirfc);
	dp-&gt;dirfc = NULL;
	}
else if(used)
	rewinddir(dp-&gt;dirfc); /* start over at the beginning  */
}

/* stolen from glob through find */

static int
amatch(char *s, char *p)
{
	int cc, scc, k;
	int c, lc;

	scc = *s;
	lc = 077777;
	switch (c = *p) {

	case '[':
		k = 0;
		while (cc = *++p) {
			switch (cc) {

			case ']':
				if (k)
					return amatch(++s, ++p);
				else
					return 0;

			case '-':
				k |= (lc &lt;= scc)  &amp; (scc &lt;= (cc=p[1]) ) ;
			}
			if (scc==(lc=cc)) k++;
		}
		return 0;

	case '?':
	caseq:
		if(scc) return amatch(++s, ++p);
		return 0;
	case '*':
		return umatch(s, ++p);
	case 0:
		return !scc;
	}
	if (c==scc) goto caseq;
	return 0;
}

static int
umatch(char *s, char *p)
{
	if(*p==0) return 1;
	while(*s)
		if (amatch(s++,p)) return 1;
	return 0;
}

#ifdef METERFILE
#include &lt;pwd.h&gt;
int meteron	= 0;	/* default: metering off */

extern void meter(char *file)
{
time_t tvec;
char *p;
FILE * mout;
struct passwd *pwd;

if(file==0 || meteron==0) return;

pwd = getpwuid(getuid());

time(&amp;tvec);

if( mout = fopen(file,"a") )
	{
	p = ctime(&amp;tvec);
	p[16] = '\0';
	fprintf(mout, "User %s, %s\n", pwd-&gt;pw_name, p+4);
	fclose(mout);
	}
}
#endif


/* look inside archives for notation a(b)
	a(b)	is file member   b   in archive a
*/

static long arflen;
static long arfdate;
static char arfname[16];
FILE *arfd;
long int arpos, arlen;

time_t
lookarch(char *filename)
{
char *p, *q, *send, s[15], pad;
int i, nc, nsym;

for(p = filename; *p!= '(' ; ++p)
	;

*p = '\0';
if( ! openarch(filename) )
	{
	*p = '(';
	return 0L;
	}
*p++ = '(';
nc = 14;
pad = ' ';

send = s + nc;
for( q = s ; q&lt;send &amp;&amp; *p!='\0' &amp;&amp; *p!=')' ; *q++ = *p++ )
	;
if(p[0]==')' &amp;&amp; p[1]!='\0')	/* forbid stuff after the paren */
	{
	clarch();
	return 0L;
	}
while(q &lt; send)
	*q++ = pad;
while(getarch())
	{
	if( !strncmp(arfname, s, nc))
		{
		clarch();
/*TEMP fprintf(stderr, "found archive member %14s, time=%d\n", s, arfdate); */
		return arfdate;
		}
	}

clarch();
return  0L;
}

static void
clarch(void)
{
fclose( arfd );
}

static int
openarch(char *f)
{
char magic[SARMAG];
int word;
struct stat buf;
nameblkp p;

stat(f, &amp;buf);
arlen = buf.st_size;

arfd = fopen(f, "r");
if(arfd == NULL)
	return NO;
	/* fatal1("cannot open %s", f); */

fread( (char *) &amp;word, sizeof(word), 1, arfd);

fseek(arfd, 0L, 0);
fread(magic, SARMAG, 1, arfd);
arpos = SARMAG;
if( strncmp(magic, ARMAG, SARMAG) )
	fatal1("%s is not an archive", f);

if( !(p = srchname(f)) )
	p = makename( copys(f) );
p-&gt;isarch = YES;
arflen = 0;
return YES;
}


static int
getarch(void)
{
struct ar_hdr arhead;

arpos += (arflen + 1) &amp; ~1L;	/* round archived file length up to even */
if(arpos &gt;= arlen)
	return 0;
fseek(arfd, arpos, 0);

fread( (char *) &amp;arhead, sizeof(arhead), 1, arfd);
arpos += sizeof(arhead);
arflen = atol(arhead.ar_size);
arfdate = atol(arhead.ar_date);
strncpy(arfname, arhead.ar_name, sizeof(arhead.ar_name));
return 1;
}

/* find the directory containing name.
   read it into the hash table if it hasn't been used before or if
   if might have changed since last reference
*/

void
dirsrch(char *name)
{
DIR *dirf;
struct dirhd *dirp;
time_t dirt, objt;
int dirused, hasparen;
char *dirname, *lastslash;
char *fullname, *filepart, *fileend, *s;
struct dirent *dptr;

lastslash = NULL;
hasparen = NO;

for(s=name; *s; ++s)
	if(*s == '/')
		lastslash = s;
	else if(*s=='(' || *s==')')
		hasparen = YES;

if(hasparen)
	{
	if(objt = lookarch(name))
		makename(name)-&gt;modtime = objt;
	return;
	}

if(lastslash)
	{
	dirname = name;
	*lastslash = '\0';
	}
else
	dirname = ".";

dirused = NO;
dirp = opdir(dirname, NO);
dirf = dirp-&gt;dirfc;
if(dirp-&gt;dirok || !dirf)
	goto ret;
dirt = exists(dirname);
if(dirp-&gt;dirtime == dirt)
	goto ret;

dirp-&gt;dirok = YES;
dirp-&gt;dirtime = dirt;
dirused = YES;

/* allocate buffer to hold full file name */
if(lastslash)
	{
	fullname = (char *) ckalloc(strlen(dirname)+MAXNAMLEN+2);
	concat(dirname, "/", fullname);
	filepart = fullname + strlen(fullname);
	}
else
	filepart = fullname = (char *) ckalloc(MAXNAMLEN+1);


fileend = filepart + MAXNAMLEN;
*fileend = '\0';
for(dptr = readdir(dirf) ; dptr ; dptr = readdir(dirf) )
	{
	char *p1, *p2;
	p1 = dptr-&gt;d_name;
	p2 = filepart;
	while( (p2&lt;fileend) &amp;&amp; (*p2++ = *p1++)!='\0')
		;
	if( ! srchname(fullname) )
		(void) makename(copys(fullname));
	}

free(fullname);

ret:
	cldir(dirp, dirused);
	if(lastslash)
		*lastslash = '/';
}



void
baddirs(void)
{
struct dirhd *od;

for(od = firstod; od; od = od-&gt;nxtdirhd)
	od-&gt;dirok = NO;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

