<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/alloc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/alloc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * area-based allocation built on malloc/free
 */

#include "sh.h"



# if DEBUG_ALLOC
void acheck ARGS((Area *ap));
#  define ACHECK(ap)	acheck(ap)
# else /* DEBUG_ALLOC */
#  define ACHECK(ap)
# endif /* DEBUG_ALLOC */

#define	ICELLS	200		/* number of Cells in small Block */

typedef union Cell Cell;
typedef struct Block Block;

/*
 * The Cells in a Block are organized as a set of objects.
 * Each object (pointed to by dp) begins with the block it is in
 * (dp-2)-&gt;block, then has a size in (dp-1)-&gt;size, which is
 * followed with "size" data Cells.  Free objects are
 * linked together via dp-&gt;next.
 */

#define NOBJECT_FIELDS	2	/* the block and size `fields' */

union Cell {
	size_t	size;
	Cell   *next;
	Block  *block;
	struct {int _;} junk;	/* alignment */
	double djunk;		/* alignment */
};

struct Block {
	Block  *next;		/* list of Blocks in Area */
	Block  *prev;		/* previous block in list */
	Cell   *freelist;	/* object free list */
	Cell   *last;		/* &amp;b.cell[size] */
	Cell	cell [1];	/* [size] Cells for allocation */
};

static Block aempty = {&amp;aempty, &amp;aempty, aempty.cell, aempty.cell};

static void ablockfree ARGS((Block *bp, Area *ap));
static void *asplit ARGS((Area *ap, Block *bp, Cell *fp, Cell *fpp, int cells));

/* create empty Area */
Area *
ainit(ap)
	register Area *ap;
{
	ap-&gt;freelist = &amp;aempty;
	ACHECK(ap);
	return ap;
}

/* free all object in Area */
void
afreeall(ap)
	register Area *ap;
{
	register Block *bp;
	register Block *tmp;

	ACHECK(ap);
	bp = ap-&gt;freelist;
	if (bp != NULL &amp;&amp; bp != &amp;aempty) {
		do {
			tmp = bp;
			bp = bp-&gt;next;
			free((void*)tmp);
		} while (bp != ap-&gt;freelist);
		ap-&gt;freelist = &amp;aempty;
	}
	ACHECK(ap);
}

/* allocate object from Area */
void *
alloc(size, ap)
	size_t size;
	register Area *ap;
{
	int cells, acells;
	Block *bp = 0;
	Cell *fp = 0, *fpp = 0;

	ACHECK(ap);
	if (size &lt;= 0)
		aerror(ap, "allocate bad size");
	cells = (unsigned)(size + sizeof(Cell) - 1) / sizeof(Cell);

	/* allocate at least this many cells */
	acells = cells + NOBJECT_FIELDS;

	/*
	 * Only attempt to track small objects - let malloc deal
	 * with larger objects. (this way we don't have to deal with
	 * coalescing memory, or with releasing it to the system)
	 */
	if (cells &lt;= ICELLS) {
		/* find free Cell large enough */
		for (bp = ap-&gt;freelist; ; bp = bp-&gt;next) {
			for (fpp = NULL, fp = bp-&gt;freelist;
			     fp != bp-&gt;last; fpp = fp, fp = fp-&gt;next)
			{
				if ((fp-1)-&gt;size &gt;= cells)
					goto Found;
			}
			/* wrapped around Block list, create new Block */
			if (bp-&gt;next == ap-&gt;freelist) {
				bp = 0;
				break;
			}
		}
		/* Not much free space left?  Allocate a big object this time */
		acells += ICELLS;
	}
	if (bp == 0) {
		bp = (Block*) malloc(offsetof(Block, cell[acells]));
		if (bp == NULL)
			aerror(ap, "cannot allocate");
		if (ap-&gt;freelist == &amp;aempty) {
			ap-&gt;freelist = bp-&gt;next = bp-&gt;prev = bp;
		} else {
			bp-&gt;next = ap-&gt;freelist-&gt;next;
			ap-&gt;freelist-&gt;next-&gt;prev = bp;
			ap-&gt;freelist-&gt;next = bp;
			bp-&gt;prev = ap-&gt;freelist;
		}
		bp-&gt;last = bp-&gt;cell + acells;
		/* initial free list */
		fp = bp-&gt;freelist = bp-&gt;cell + NOBJECT_FIELDS;
		(fp-1)-&gt;size = acells - NOBJECT_FIELDS;
		(fp-2)-&gt;block = bp;
		fp-&gt;next = bp-&gt;last;
		fpp = NULL;
	}

  Found:
	return asplit(ap, bp, fp, fpp, cells);
}

/* Do the work of splitting an object into allocated and (possibly) unallocated
 * objects.  Returns the `allocated' object.
 */
static void *
asplit(ap, bp, fp, fpp, cells)
	Area *ap;
	Block *bp;
	Cell *fp;
	Cell *fpp;
	int cells;
{
	Cell *dp = fp;	/* allocated object */
	int split = (fp-1)-&gt;size - cells;

	ACHECK(ap);
	if (split &lt; 0)
		aerror(ap, "allocated object too small");
	if (split &lt;= NOBJECT_FIELDS) {	/* allocate all */
		fp = fp-&gt;next;
	} else {		/* allocate head, free tail */
		Cell *next = fp-&gt;next; /* needed, as cells may be 0 */
		ap-&gt;freelist = bp; /* next time, start looking for space here */
		(fp-1)-&gt;size = cells;
		fp += cells + NOBJECT_FIELDS;
		(fp-1)-&gt;size = split - NOBJECT_FIELDS;
		(fp-2)-&gt;block = bp;
		fp-&gt;next = next;
	}
	if (fpp == NULL)
		bp-&gt;freelist = fp;
	else
		fpp-&gt;next = fp;
	ACHECK(ap);
	return (void*) dp;
}

/* change size of object -- like realloc */
void *
aresize(ptr, size, ap)
	register void *ptr;
	size_t size;
	Area *ap;
{
	int cells;
	Cell *dp = (Cell*) ptr;
	int oldcells = dp ? (dp-1)-&gt;size : 0;

	ACHECK(ap);
	if (size &lt;= 0)
		aerror(ap, "allocate bad size");
	/* New size (in cells) */
	cells = (unsigned)(size - 1) / sizeof(Cell) + 1;

	/* Is this a large object?  If so, let malloc deal with it
	 * directly (unless we are crossing the ICELLS border, in
	 * which case the alloc/free below handles it - this should
	 * cut down on fragmentation, and will also keep the code
	 * working (as it assumes size &lt; ICELLS means it is not
	 * a `large object').
	 */
	if (oldcells &gt; ICELLS &amp;&amp; cells &gt; ICELLS) {
		Block *bp = (dp-2)-&gt;block;
		Block *nbp;
		/* Saved in case realloc fails.. */
		Block *next = bp-&gt;next, *prev = bp-&gt;prev;

		if (bp-&gt;freelist != bp-&gt;last)
			aerror(ap, "allocation resizing free pointer");
		nbp = realloc((void *) bp,
			      offsetof(Block, cell[cells + NOBJECT_FIELDS]));
		if (!nbp) {
			/* Have to clean up... */
			/* NOTE: If this code changes, similar changes may be
			 * needed in ablockfree().
			 */
			if (next == bp) /* only block */
				ap-&gt;freelist = &amp;aempty;
			else {
				next-&gt;prev = prev;
				prev-&gt;next = next;
				if (ap-&gt;freelist == bp)
					ap-&gt;freelist = next;
			}
			aerror(ap, "cannot re-allocate");
		}
		/* If location changed, keep pointers straight... */
		if (nbp != bp) {
			if (next == bp) /* only one block */
				nbp-&gt;next = nbp-&gt;prev = nbp;
			else {
				next-&gt;prev = nbp;
				prev-&gt;next = nbp;
			}
			if (ap-&gt;freelist == bp)
				ap-&gt;freelist = nbp;
			dp = nbp-&gt;cell + NOBJECT_FIELDS;
			(dp-2)-&gt;block = nbp;
		}
		(dp-1)-&gt;size = cells;
		nbp-&gt;last = nbp-&gt;cell + cells + NOBJECT_FIELDS;
		nbp-&gt;freelist = nbp-&gt;last;

		ACHECK(ap);
		return (void*) dp;
	}

	/* Check if we can just grow this cell
	 * (need to check that cells &lt; ICELLS so we don't make an
	 * object a `large' - that would mess everything up).
	 */
	if (dp &amp;&amp; cells &gt; oldcells &amp;&amp; cells &lt;= ICELLS) {
		Cell *fp, *fpp;
		Block *bp = (dp-2)-&gt;block;
		int need = cells - oldcells - NOBJECT_FIELDS;

		/* XXX if we had a flag in an object indicating
		 * if the object was free/allocated, we could
		 * avoid this loop (perhaps)
		 */
		for (fpp = NULL, fp = bp-&gt;freelist;
		     fp != bp-&gt;last
		     &amp;&amp; dp + oldcells + NOBJECT_FIELDS &lt;= fp
		     ; fpp = fp, fp = fp-&gt;next)
		{
			if (dp + oldcells + NOBJECT_FIELDS == fp
			    &amp;&amp; (fp-1)-&gt;size &gt;= need)
			{
				Cell *np = asplit(ap, bp, fp, fpp, need);
				/* May get more than we need here */
				(dp-1)-&gt;size += (np-1)-&gt;size + NOBJECT_FIELDS;
				ACHECK(ap);
				return ptr;
			}
		}
	}

	/* Check if we can just shrink this cell
	 * (if oldcells &gt; ICELLS, this is a large object and we leave
	 * it to malloc...)
	 * Note: this also handles cells == oldcells (a no-op).
	 */
	if (dp &amp;&amp; cells &lt;= oldcells &amp;&amp; oldcells &lt;= ICELLS) {
		int split;

		split = oldcells - cells;
		if (split &lt;= NOBJECT_FIELDS) /* cannot split */
			;
		else {		/* shrink head, free tail */
			Block *bp = (dp-2)-&gt;block;

			(dp-1)-&gt;size = cells;
			dp += cells + NOBJECT_FIELDS;
			(dp-1)-&gt;size = split - NOBJECT_FIELDS;
			(dp-2)-&gt;block = bp;
			afree((void*)dp, ap);
		}
		/* ACHECK() done in afree() */
		return ptr;
	}

	/* Have to do it the hard way... */
	ptr = alloc(size, ap);
	if (dp != NULL) {
		size_t s = (dp-1)-&gt;size * sizeof(Cell);
		if (s &gt; size)
			s = size;
		memcpy(ptr, dp, s);
		afree((void *) dp, ap);
	}
	/* ACHECK() done in alloc()/afree() */
	return ptr;
}

void
afree(ptr, ap)
	void *ptr;
	register Area *ap;
{
	register Block *bp;
	register Cell *fp, *fpp;
	register Cell *dp = (Cell*)ptr;

	ACHECK(ap);
	if (ptr == 0)
		aerror(ap, "freeing null pointer");
	bp = (dp-2)-&gt;block;

	/* If this is a large object, just free it up... */
	/* Release object... */
	if ((dp-1)-&gt;size &gt; ICELLS) {
		ablockfree(bp, ap);
		ACHECK(ap);
		return;
	}

	if (dp &lt; &amp;bp-&gt;cell[NOBJECT_FIELDS] || dp &gt;= bp-&gt;last)
		aerror(ap, "freeing memory outside of block (corrupted?)");

	/* find position in free list */
	/* XXX if we had prev/next pointers for objects, this loop could go */
	for (fpp = NULL, fp = bp-&gt;freelist; fp &lt; dp; fpp = fp, fp = fp-&gt;next)
		;

	if (fp == dp)
		aerror(ap, "freeing free object");

	/* join object with next */
	if (dp + (dp-1)-&gt;size == fp-NOBJECT_FIELDS) { /* adjacent */
		(dp-1)-&gt;size += (fp-1)-&gt;size + NOBJECT_FIELDS;
		dp-&gt;next = fp-&gt;next;
	} else			/* non-adjacent */
		dp-&gt;next = fp;

	/* join previous with object */
	if (fpp == NULL)
		bp-&gt;freelist = dp;
	else if (fpp + (fpp-1)-&gt;size == dp-NOBJECT_FIELDS) { /* adjacent */
		(fpp-1)-&gt;size += (dp-1)-&gt;size + NOBJECT_FIELDS;
		fpp-&gt;next = dp-&gt;next;
	} else			/* non-adjacent */
		fpp-&gt;next = dp;

	/* If whole block is free (and we have some other blocks
	 * around), release this block back to the system...
	 */
	if (bp-&gt;next != bp &amp;&amp; bp-&gt;freelist == bp-&gt;cell + NOBJECT_FIELDS
	    &amp;&amp; bp-&gt;freelist + (bp-&gt;freelist-1)-&gt;size == bp-&gt;last
	    /* XXX and the other block has some free memory? */
	    )
		ablockfree(bp, ap);
	ACHECK(ap);
}

static void
ablockfree(bp, ap)
	Block *bp;
	Area *ap;
{
	/* NOTE: If this code changes, similar changes may be
	 * needed in alloc() (where realloc fails).
	 */

	if (bp-&gt;next == bp) /* only block */
		ap-&gt;freelist = &amp;aempty;
	else {
		bp-&gt;next-&gt;prev = bp-&gt;prev;
		bp-&gt;prev-&gt;next = bp-&gt;next;
		if (ap-&gt;freelist == bp)
			ap-&gt;freelist = bp-&gt;next;
	}
	free((void*) bp);
}

# if DEBUG_ALLOC
void
acheck(ap)
	Area *ap;
{
	Block *bp, *bpp;
	Cell *dp, *dptmp, *fp;
	int ok = 1;
	int isfree;
	static int disabled;

	if (disabled)
		return;

	if (!ap) {
		disabled = 1;
		aerror(ap, "acheck: null area pointer");
	}

	bp = ap-&gt;freelist;
	if (!bp) {
		disabled = 1;
		aerror(ap, "acheck: null area freelist");
	}

	/* Nothing to check... */
	if (bp == &amp;aempty)
		return;

	bpp = ap-&gt;freelist-&gt;prev;
	while (1) {
		if (bp-&gt;prev != bpp) {
			shellf("acheck: bp-&gt;prev != previous\n");
			ok = 0;
		}
		fp = bp-&gt;freelist;
		for (dp = &amp;bp-&gt;cell[NOBJECT_FIELDS]; dp != bp-&gt;last; ) {
			if ((dp-2)-&gt;block != bp) {
				shellf("acheck: fragment's block is wrong\n");
				ok = 0;
			}
			isfree = dp == fp;
			if ((dp-1)-&gt;size == 0 &amp;&amp; isfree) {
				shellf("acheck: 0 size frag\n");
				ok = 0;
			}
			if ((dp-1)-&gt;size &gt; ICELLS
			    &amp;&amp; !isfree
			    &amp;&amp; (dp != &amp;bp-&gt;cell[NOBJECT_FIELDS]
				|| dp + (dp-1)-&gt;size != bp-&gt;last))
			{
				shellf("acheck: big cell doesn't make up whole block\n");
				ok = 0;
			}
			if (isfree) {
				if (dp-&gt;next &lt;= dp) {
					shellf("acheck: free fragment's next &lt;= self\n");
					ok = 0;
				}
				if (dp-&gt;next &gt; bp-&gt;last) {
					shellf("acheck: free fragment's next &gt; last\n");
					ok = 0;
				}
				fp = dp-&gt;next;
			}
			dptmp = dp + (dp-1)-&gt;size;
			if (dptmp &gt; bp-&gt;last) {
				shellf("acheck: next frag out of range\n");
				ok = 0;
				break;
			} else if (dptmp != bp-&gt;last) {
				dptmp += NOBJECT_FIELDS;
				if (dptmp &gt; bp-&gt;last) {
					shellf("acheck: next frag just out of range\n");
					ok = 0;
					break;
				}
			}
			if (isfree &amp;&amp; dptmp == fp &amp;&amp; dptmp != bp-&gt;last) {
				shellf("acheck: adjacent free frags\n");
				ok = 0;
			} else if (dptmp &gt; fp) {
				shellf("acheck: free frag list messed up\n");
				ok = 0;
			}
			dp = dptmp;
		}
		bpp = bp;
		bp = bp-&gt;next;
		if (bp == ap-&gt;freelist)
			break;
	}
	if (!ok) {
		disabled = 1;
		aerror(ap, "acheck failed");
	}
}

void
aprint(ap, ptr, size)
	register Area *ap;
	void *ptr;
	size_t size;
{
	Block *bp;

	if (!ap)
		shellf("aprint: null area pointer\n");
	else if (!(bp = ap-&gt;freelist))
		shellf("aprint: null area freelist\n");
	else if (bp == &amp;aempty)
		shellf("aprint: area is empty\n");
	else {
		int i;
		Cell *dp, *fp;
		Block *bpp;

		bpp = ap-&gt;freelist-&gt;prev;
		for (i = 0; ; i++) {
			if (ptr) {
				void *eptr = (void *) (((char *) ptr) + size);
				/* print block only if it overlaps ptr/size */
				if (!((ptr &gt;= (void *) bp
				       &amp;&amp; ptr &lt;= (void *) bp-&gt;last)
				      || (eptr &gt;= (void *) bp
				         &amp;&amp; eptr &lt;= (void *) bp-&gt;last)))
					continue;
				shellf("aprint: overlap of 0x%p .. 0x%p\n",
					ptr, eptr);
			}
			if (bp-&gt;prev != bpp || bp-&gt;next-&gt;prev != bp)
				shellf(
	"aprint: BAD prev pointer: bp %p, bp-&gt;prev %p, bp-&gt;next %p, bpp=%p\n",
					bp, bp-&gt;prev, bp-&gt;next, bpp);
			shellf("aprint: block %2d (p=%p,%p,n=%p): 0x%p .. 0x%p (%ld)\n", i,
				bp-&gt;prev, bp, bp-&gt;next,
				bp-&gt;cell, bp-&gt;last,
				(long) ((char *) bp-&gt;last - (char *) bp-&gt;cell));
			fp = bp-&gt;freelist;
			if (bp-&gt;last &lt;= bp-&gt;cell + NOBJECT_FIELDS)
				shellf(
			"aprint: BAD bp-&gt;last too small: %p &lt;= %p\n",
					bp-&gt;last, bp-&gt;cell + NOBJECT_FIELDS);
			if (bp-&gt;freelist &lt; bp-&gt;cell + NOBJECT_FIELDS
			    || bp-&gt;freelist &gt; bp-&gt;last)
				shellf(
			"aprint: BAD bp-&gt;freelist %p out of range: %p .. %p\n",
					bp-&gt;freelist,
					bp-&gt;cell + NOBJECT_FIELDS, bp-&gt;last);
			for (dp = bp-&gt;cell; dp != bp-&gt;last ; ) {
				dp += NOBJECT_FIELDS;
				shellf(
				    "aprint:   0x%p .. 0x%p (%ld) %s\n",
					(dp-NOBJECT_FIELDS),
					(dp-NOBJECT_FIELDS) + (dp-1)-&gt;size
						+ NOBJECT_FIELDS,
					(long) ((dp-1)-&gt;size + NOBJECT_FIELDS)
						* sizeof(Cell),
					dp == fp ? "free" : "allocated");
				if ((dp-2)-&gt;block != bp)
					shellf(
					"aprint: BAD dp-&gt;block %p != bp %p\n",
						(dp-2)-&gt;block, bp);
				if (dp &gt; bp-&gt;last)
					shellf(
				"aprint: BAD dp gone past block: %p &gt; %p\n",
						dp, bp-&gt;last);
				if (dp &gt; fp)
					shellf(
				"aprint: BAD dp gone past free: %p &gt; %p\n",
						dp, fp);
				if (dp == fp) {
					fp = fp-&gt;next;
					if (fp &lt; dp || fp &gt; bp-&gt;last)
						shellf(
			"aprint: BAD free object %p out of range: %p .. %p\n",
							fp,
							dp, bp-&gt;last);
				}
				dp += (dp-1)-&gt;size;
			}
			bpp = bp;
			bp = bp-&gt;next;
			if (bp == ap-&gt;freelist)
				break;
		}
	}
}

#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

