<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/exec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/exec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * execute command tree
 */

#include "sh.h"
#include "c_test.h"
#include &lt;ctype.h&gt;
#include "ksh_stat.h"

/* Does ps4 get parameter substitutions done? */
#ifdef KSH
# define PS4_SUBSTITUTE(s)	substitute((s), 0)
#else
# define PS4_SUBSTITUTE(s)	(s)
#endif /* KSH */

static int	comexec	 ARGS((struct op *t, struct tbl *volatile tp, char **ap,
			      int volatile flags));
static void	scriptexec ARGS((struct op *tp, char **ap));
static int	call_builtin ARGS((struct tbl *tp, char **wp));
static int	iosetup ARGS((struct ioword *iop, struct tbl *tp));
static int	herein ARGS((const char *content, int sub));
#ifdef KSH
static char 	*do_selectargs ARGS((char **ap, bool_t print_menu));
#endif /* KSH */
#ifdef KSH
static int	dbteste_isa ARGS((Test_env *te, Test_meta meta));
static const char *dbteste_getopnd ARGS((Test_env *te, Test_op op,
					 int do_eval));
static int	dbteste_eval ARGS((Test_env *te, Test_op op, const char *opnd1,
				const char *opnd2, int do_eval));
static void	dbteste_error ARGS((Test_env *te, int offset, const char *msg));
#endif /* KSH */
#ifdef OS2
static int	search_access1 ARGS((const char *path, int mode, int *errnop));
#endif /* OS2 */


/*
 * handle systems that don't have F_SETFD
 */
#ifndef F_SETFD
# ifndef MAXFD
#   define  MAXFD 64
# endif
/* a bit field would be smaller, but this will work */
static char clexec_tab[MAXFD+1];
#endif

/*
 * we now use this function always.
 */
int
fd_clexec(fd)
    int fd;
{
#ifndef F_SETFD
	if (fd &gt;= 0 &amp;&amp; fd &lt; sizeof(clexec_tab)) {
		clexec_tab[fd] = 1;
		return 0;
	}
	return -1;
#else
	return fcntl(fd, F_SETFD, 1);
#endif
}


/*
 * execute command tree
 */
int
execute(t, flags)
	struct op * volatile t;
	volatile int flags;	/* if XEXEC don't fork */
{
	int i;
	volatile int rv = 0;
	int pv[2];
	char ** volatile ap;
	char *s, *cp;
	struct ioword **iowp;
	struct tbl *tp = NULL;

	if (t == NULL)
		return 0;

	/* Is this the end of a pipeline?  If so, we want to evaluate the
	 * command arguments
	bool_t eval_done = FALSE;
	if ((flags&amp;XFORK) &amp;&amp; !(flags&amp;XEXEC) &amp;&amp; (flags&amp;XPCLOSE)) {
		eval_done = TRUE;
		tp = eval_execute_args(t, &amp;ap);
	}
	 */
	if ((flags&amp;XFORK) &amp;&amp; !(flags&amp;XEXEC) &amp;&amp; t-&gt;type != TPIPE)
		return exchild(t, flags &amp; ~XTIME, -1); /* run in sub-process */

	newenv(E_EXEC);
	if (trap)
		runtraps(0);
 
	if (t-&gt;type == TCOM) {
		/* Clear subst_exstat before argument expansion.  Used by
		 * null commands (see comexec() and c_eval()) and by c_set().
		 */
		subst_exstat = 0;

		current_lineno = t-&gt;lineno;	/* for $LINENO */

		/* POSIX says expand command words first, then redirections,
		 * and assignments last..
		 */
		ap = eval(t-&gt;args, t-&gt;u.evalflags | DOBLANK | DOGLOB | DOTILDE);
		if (flags &amp; XTIME)
			/* Allow option parsing (bizarre, but POSIX) */
			timex_hook(t, &amp;ap);
		if (Flag(FXTRACE) &amp;&amp; ap[0]) {
			shf_fprintf(shl_out, "%s",
				PS4_SUBSTITUTE(str_val(global("PS4"))));
			for (i = 0; ap[i]; i++)
				shf_fprintf(shl_out, "%s%s", ap[i],
					ap[i + 1] ? space : newline);
			shf_flush(shl_out);
		}
		if (ap[0])
			tp = findcom(ap[0], FC_BI|FC_FUNC);
	}
	flags &amp;= ~XTIME;

	if (t-&gt;ioact != NULL || t-&gt;type == TPIPE || t-&gt;type == TCOPROC) {
		e-&gt;savefd = (short *) alloc(sizeofN(short, NUFILE), ATEMP);
		/* initialize to not redirected */
		memset(e-&gt;savefd, 0, sizeofN(short, NUFILE));
	}

	/* do redirection, to be restored in quitenv() */
	if (t-&gt;ioact != NULL)
		for (iowp = t-&gt;ioact; *iowp != NULL; iowp++) {
			if (iosetup(*iowp, tp) &lt; 0) {
				exstat = rv = 1;
				/* Redirection failures for special commands
				 * cause (non-interactive) shell to exit.
				 */
				if (tp &amp;&amp; tp-&gt;type == CSHELL
				    &amp;&amp; (tp-&gt;flag &amp; SPEC_BI))
					errorf(null);
				/* Deal with FERREXIT, quitenv(), etc. */
				goto Break;
			}
		}
	
	switch(t-&gt;type) {
	  case TCOM:
		rv = comexec(t, tp, ap, flags);
		break;

	  case TPAREN:
		rv = execute(t-&gt;left, flags|XFORK);
		break;

	  case TPIPE:
		flags |= XFORK;
		flags &amp;= ~XEXEC;
		e-&gt;savefd[0] = savefd(0, 0);
		(void) ksh_dup2(e-&gt;savefd[0], 0, FALSE); /* stdin of first */
		e-&gt;savefd[1] = savefd(1, 0);
		while (t-&gt;type == TPIPE) {
			openpipe(pv);
			(void) ksh_dup2(pv[1], 1, FALSE); /* stdout of curr */
			/* Let exchild() close pv[0] in child
			 * (if this isn't done, commands like
			 *    (: ; cat /etc/termcap) | sleep 1
			 *  will hang forever).
			 */
			exchild(t-&gt;left, flags|XPIPEO|XCCLOSE, pv[0]);
			(void) ksh_dup2(pv[0], 0, FALSE); /* stdin of next */
			closepipe(pv);
			flags |= XPIPEI;
			t = t-&gt;right;
		}
		restfd(1, e-&gt;savefd[1]); /* stdout of last */
		e-&gt;savefd[1] = 0; /* no need to re-restore this */
		/* Let exchild() close 0 in parent, after fork, before wait */
		i = exchild(t, flags|XPCLOSE, 0);
		if (!(flags&amp;XBGND) &amp;&amp; !(flags&amp;XXCOM))
			rv = i;
		break;

	  case TLIST:
		while (t-&gt;type == TLIST) {
			execute(t-&gt;left, flags &amp; XERROK);
			t = t-&gt;right;
		}
		rv = execute(t, flags &amp; XERROK);
		break;

#ifdef KSH
	  case TCOPROC:
	  {
# ifdef JOB_SIGS
		sigset_t	omask;
# endif /* JOB_SIGS */

# ifdef JOB_SIGS
		/* Block sigchild as we are using things changed in the
		 * signal handler
		 */
		sigprocmask(SIG_BLOCK, &amp;sm_sigchld, &amp;omask);
		e-&gt;type = E_ERRH;
		i = ksh_sigsetjmp(e-&gt;jbuf, 0);
		if (i) {
			sigprocmask(SIG_SETMASK, &amp;omask, (sigset_t *) 0);
			quitenv();
			unwind(i);
			/*NOTREACHED*/
		}
# endif /* JOB_SIGS */
		/* Already have a (live) co-process? */
		if (coproc.job &amp;&amp; coproc.write &gt;= 0)
			errorf("coprocess already exists");

		/* Can we re-use the existing co-process pipe? */
		coproc_cleanup(TRUE);

		/* do this before opening pipes, in case these fail */
		e-&gt;savefd[0] = savefd(0, 0);
		e-&gt;savefd[1] = savefd(1, 0);

		openpipe(pv);
		ksh_dup2(pv[0], 0, FALSE);
		close(pv[0]);
		coproc.write = pv[1];
		coproc.job = (void *) 0;

		if (coproc.readw &gt;= 0)
			ksh_dup2(coproc.readw, 1, FALSE);
		else {
			openpipe(pv);
			coproc.read = pv[0];
			ksh_dup2(pv[1], 1, FALSE);
			coproc.readw = pv[1];	 /* closed before first read */
			coproc.njobs = 0;
			/* create new coprocess id */
			++coproc.id;
		}
# ifdef JOB_SIGS
		sigprocmask(SIG_SETMASK, &amp;omask, (sigset_t *) 0);
		e-&gt;type = E_EXEC; /* no more need for error handler */
# endif /* JOB_SIGS */

		/* exchild() closes coproc.* in child after fork,
		 * will also increment coproc.njobs when the
		 * job is actually created.
		 */
		flags &amp;= ~XEXEC;
		exchild(t-&gt;left, flags|XBGND|XFORK|XCOPROC|XCCLOSE,
			coproc.readw);
		break;
	  }
#endif /* KSH */

	  case TASYNC:
		/* XXX non-optimal, I think - "(foo &amp;)", forks for (),
		 * forks again for async...  parent should optimize
		 * this to "foo &amp;"...
		 */
		rv = execute(t-&gt;left, (flags&amp;~XEXEC)|XBGND|XFORK);
		break;

	  case TOR:
	  case TAND:
		rv = execute(t-&gt;left, XERROK);
		if (t-&gt;right != NULL &amp;&amp; (rv == 0) == (t-&gt;type == TAND))
			rv = execute(t-&gt;right, flags &amp; XERROK);
		else
			flags |= XERROK;
		break;

	  case TBANG:
		rv = !execute(t-&gt;right, XERROK);
		break;

#ifdef KSH
	  case TDBRACKET:
	    {
		Test_env te;

		te.flags = TEF_DBRACKET;
		te.pos.wp = t-&gt;args;
		te.isa = dbteste_isa;
		te.getopnd = dbteste_getopnd;
		te.eval = dbteste_eval;
		te.error = dbteste_error;

		rv = test_parse(&amp;te);
		break;
	    }
#endif /* KSH */

	  case TFOR:
#ifdef KSH
	  case TSELECT:
	    {
		volatile bool_t is_first = TRUE;
#endif /* KSH */
		ap = (t-&gt;vars != NULL) ?
			  eval(t-&gt;vars, DOBLANK|DOGLOB|DOTILDE)
			: e-&gt;loc-&gt;argv + 1;
		e-&gt;type = E_LOOP;
		while (1) {
			i = ksh_sigsetjmp(e-&gt;jbuf, 0);
			if (!i)
				break;
			if ((e-&gt;flags&amp;EF_BRKCONT_PASS)
			    || (i != LBREAK &amp;&amp; i != LCONTIN))
			{
				quitenv();
				unwind(i);
			} else if (i == LBREAK) {
				rv = 0;
				goto Break;
			}
		}
		rv = 0; /* in case of a continue */
		if (t-&gt;type == TFOR) {
			while (*ap != NULL) {
				setstr(global(t-&gt;str), *ap++, KSH_UNWIND_ERROR);
				rv = execute(t-&gt;left, flags &amp; XERROK);
			}
		}
#ifdef KSH
		else { /* TSELECT */
			for (;;) {
				if (!(cp = do_selectargs(ap, is_first))) {
					rv = 1;
					break;
				}
				is_first = FALSE;
				setstr(global(t-&gt;str), cp, KSH_UNWIND_ERROR);
				rv = execute(t-&gt;left, flags &amp; XERROK);
			}
		}
	    }
#endif /* KSH */
		break;

	  case TWHILE:
	  case TUNTIL:
		e-&gt;type = E_LOOP;
		while (1) {
			i = ksh_sigsetjmp(e-&gt;jbuf, 0);
			if (!i)
				break;
			if ((e-&gt;flags&amp;EF_BRKCONT_PASS)
			    || (i != LBREAK &amp;&amp; i != LCONTIN))
			{
				quitenv();
				unwind(i);
			} else if (i == LBREAK) {
				rv = 0;
				goto Break;
			}
		}
		rv = 0; /* in case of a continue */
		while ((execute(t-&gt;left, XERROK) == 0) == (t-&gt;type == TWHILE))
			rv = execute(t-&gt;right, flags &amp; XERROK);
		break;

	  case TIF:
	  case TELIF:
		if (t-&gt;right == NULL)
			break;	/* should be error */
		rv = execute(t-&gt;left, XERROK) == 0 ?
			execute(t-&gt;right-&gt;left, flags &amp; XERROK) :
			execute(t-&gt;right-&gt;right, flags &amp; XERROK);
		break;

	  case TCASE:
		cp = evalstr(t-&gt;str, DOTILDE);
		for (t = t-&gt;left; t != NULL &amp;&amp; t-&gt;type == TPAT; t = t-&gt;right)
		    for (ap = t-&gt;vars; *ap; ap++)
			if ((s = evalstr(*ap, DOTILDE|DOPAT))
			    &amp;&amp; gmatch(cp, s, FALSE))
				goto Found;
		break;
	  Found:
		rv = execute(t-&gt;left, flags &amp; XERROK);
		break;

	  case TBRACE:
		rv = execute(t-&gt;left, flags &amp; XERROK);
		break;

	  case TFUNCT:
		rv = define(t-&gt;str, t);
		break;

	  case TTIME:
		/* Clear XEXEC so nested execute() call doesn't exit
		 * (allows "ls -l | time grep foo").
		 */
		rv = timex(t, flags &amp; ~XEXEC);
		break;

	  case TEXEC:		/* an eval'd TCOM */
		s = t-&gt;args[0];
		ap = makenv();
#ifndef F_SETFD
		for (i = 0; i &lt; sizeof(clexec_tab); i++)
			if (clexec_tab[i]) {
				close(i);
				clexec_tab[i] = 0;
			}
#endif
		restoresigs();
		cleanup_proc_env();
		/* XINTACT bit is for OS2 */
		ksh_execve(t-&gt;str, t-&gt;args, ap, (flags &amp; XINTACT) ? 1 : 0);
		if (errno == ENOEXEC)
			scriptexec(t, ap);
		else
			errorf("%s: %s", s, strerror(errno));
	}
    Break:
	exstat = rv;

	quitenv();		/* restores IO */
	if ((flags&amp;XEXEC))
		unwind(LEXIT);	/* exit child */
	if (rv != 0 &amp;&amp; !(flags &amp; XERROK)) {
		if (Flag(FERREXIT))
			unwind(LERROR);
		trapsig(SIGERR_);
	}
	return rv;
}

/*
 * execute simple command
 */

static int
comexec(t, tp, ap, flags)
	struct op *t;
	struct tbl *volatile tp;
	register char **ap;
	int volatile flags;
{
	int i;
	int rv = 0;
	register char *cp;
	register char **lastp;
	static struct op texec; /* Must be static (XXX but why?) */
	int type_flags;
	int keepasn_ok;
	int fcflags = FC_BI|FC_FUNC|FC_PATH;

#ifdef KSH
	/* snag the last argument for $_ XXX not the same as at&amp;t ksh,
	 * which only seems to set $_ after a newline (but not in
	 * functions/dot scripts, but in interactive and scipt) -
	 * perhaps save last arg here and set it in shell()?.
	 */
	if (Flag(FTALKING) &amp;&amp; *(lastp = ap)) {
		while (*++lastp)
			;
		/* setstr() can't fail here */
		setstr(typeset("_", LOCAL, 0, INTEGER, 0), *--lastp,
		       KSH_RETURN_ERROR);
	}
#endif /* KSH */

	/* Deal with the shell builtins builtin, exec and command since
	 * they can be followed by other commands.  This must be done before
	 * we know if we should create a local block, which must be done
	 * before we can do a path search (in case the assignments change
	 * PATH).
	 * Odd cases:
	 *   FOO=bar exec &gt; /dev/null		FOO is kept but not exported
	 *   FOO=bar exec foobar		FOO is exported
	 *   FOO=bar command exec &gt; /dev/null	FOO is neither kept nor exported
	 *   FOO=bar command			FOO is neither kept nor exported
	 *   PATH=... foobar			use new PATH in foobar search
	 */
	keepasn_ok = 1;
	while (tp &amp;&amp; tp-&gt;type == CSHELL) {
		fcflags = FC_BI|FC_FUNC|FC_PATH;/* undo effects of command */
		if (tp-&gt;val.f == c_builtin) {
			if ((cp = *++ap) == NULL) {
				tp = NULL;
				break;
			}
			tp = findcom(cp, FC_BI);
			if (tp == NULL)
				errorf("builtin: %s: not a builtin", cp);
			continue;
		} else if (tp-&gt;val.f == c_exec) {
			if (ap[1] == NULL)
				break;
			ap++;
			flags |= XEXEC;
		} else if (tp-&gt;val.f == c_command) {
			int optc, saw_p = 0;

			/* Ugly dealing with options in two places (here and
			 * in c_command(), but such is life)
			 */
			ksh_getopt_reset(&amp;builtin_opt, 0);
			while ((optc = ksh_getopt(ap, &amp;builtin_opt, ":p"))
									== 'p')
				saw_p = 1;
			if (optc != EOF)
				break;	/* command -vV or something */
			/* don't look for functions */
			fcflags = FC_BI|FC_PATH;
			if (saw_p) {
				if (Flag(FRESTRICTED)) {
					warningf(TRUE,
						"command -p: restricted");
					rv = 1;
					goto Leave;
				}
				fcflags |= FC_DEFPATH;
			}
			ap += builtin_opt.optind;
			/* POSIX says special builtins lose their status
			 * if accessed using command.
			 */
			keepasn_ok = 0;
			if (!ap[0]) {
				/* ensure command with no args exits with 0 */
				subst_exstat = 0;
				break;
			}
		} else
			break;
		tp = findcom(ap[0], fcflags &amp; (FC_BI|FC_FUNC));
	}
	if (keepasn_ok &amp;&amp; (!ap[0] || (tp &amp;&amp; (tp-&gt;flag &amp; KEEPASN))))
		type_flags = 0;
	else {
		/* create new variable/function block */
		newblock();
		/* ksh functions don't keep assignments, POSIX functions do. */
		if (keepasn_ok &amp;&amp; tp &amp;&amp; tp-&gt;type == CFUNC
		    &amp;&amp; !(tp-&gt;flag &amp; FKSH))
			type_flags = 0;
		else
			type_flags = LOCAL|LOCAL_COPY|EXPORT;
	}
	if (Flag(FEXPORT))
		type_flags |= EXPORT;
	for (i = 0; t-&gt;vars[i]; i++) {
		cp = evalstr(t-&gt;vars[i], DOASNTILDE);
		if (Flag(FXTRACE)) {
			if (i == 0)
				shf_fprintf(shl_out, "%s",
					PS4_SUBSTITUTE(str_val(global("PS4"))));
			shf_fprintf(shl_out, "%s%s", cp,
				t-&gt;vars[i + 1] ? space : newline);
			if (!t-&gt;vars[i + 1])
				shf_flush(shl_out);
		}
		typeset(cp, type_flags, 0, 0, 0);
	}

	if ((cp = *ap) == NULL) {
		rv = subst_exstat;
		goto Leave;
	} else if (!tp) {
		if (Flag(FRESTRICTED) &amp;&amp; ksh_strchr_dirsep(cp)) {
			warningf(TRUE, "%s: restricted", cp);
			rv = 1;
			goto Leave;
		}
		tp = findcom(cp, fcflags);
	}

	switch (tp-&gt;type) {
	  case CSHELL:			/* shell built-in */
		rv = call_builtin(tp, ap);
		break;

	  case CFUNC:			/* function call */
	  {
		volatile int old_xflag;
		volatile Tflag old_inuse;
		const char *volatile old_kshname;

		if (!(tp-&gt;flag &amp; ISSET)) {
			struct tbl *ftp;

			if (!tp-&gt;u.fpath) {
				if (tp-&gt;u2.errno_) {
					warningf(TRUE,
				"%s: can't find function definition file - %s",
						cp, strerror(tp-&gt;u2.errno_));
					rv = 126;
				} else {
					warningf(TRUE,
				"%s: can't find function definition file", cp);
					rv = 127;
				}
				break;
			}
			if (include(tp-&gt;u.fpath, 0, (char **) 0, 0) &lt; 0) {
				warningf(TRUE,
			    "%s: can't open function definition file %s - %s",
					cp, tp-&gt;u.fpath, strerror(errno));
				rv = 127;
				break;
			}
			if (!(ftp = findfunc(cp, hash(cp), FALSE))
			    || !(ftp-&gt;flag &amp; ISSET))
			{
				warningf(TRUE,
					"%s: function not defined by %s",
					cp, tp-&gt;u.fpath);
				rv = 127;
				break;
			}
			tp = ftp;
		}

		/* ksh functions set $0 to function name, POSIX functions leave
		 * $0 unchanged.
		 */
		old_kshname = kshname;
		if (tp-&gt;flag &amp; FKSH)
			kshname = ap[0];
		else
			ap[0] = (char *) kshname;
		e-&gt;loc-&gt;argv = ap;
		for (i = 0; *ap++ != NULL; i++)
			;
		e-&gt;loc-&gt;argc = i - 1;
		/* ksh-style functions handle getopts sanely,
		 * bourne/posix functions are insane...
		 */
		if (tp-&gt;flag &amp; FKSH) {
			e-&gt;loc-&gt;flags |= BF_DOGETOPTS;
			e-&gt;loc-&gt;getopts_state = user_opt;
			getopts_reset(1);
		}

		old_xflag = Flag(FXTRACE);
		Flag(FXTRACE) = tp-&gt;flag &amp; TRACE ? TRUE : FALSE;

		old_inuse = tp-&gt;flag &amp; FINUSE;
		tp-&gt;flag |= FINUSE;

		e-&gt;type = E_FUNC;
		i = ksh_sigsetjmp(e-&gt;jbuf, 0);
		if (i == 0) {
			/* seems odd to pass XERROK here, but at&amp;t ksh does */
			exstat = execute(tp-&gt;val.t, flags &amp; XERROK);
			i = LRETURN;
		}
		kshname = old_kshname;
		Flag(FXTRACE) = old_xflag;
		tp-&gt;flag = (tp-&gt;flag &amp; ~FINUSE) | old_inuse;
		/* Were we deleted while executing?  If so, free the execution
		 * tree.  todo: Unfortunately, the table entry is never re-used
		 * until the lookup table is expanded.
		 */
		if ((tp-&gt;flag &amp; (FDELETE|FINUSE)) == FDELETE) {
			if (tp-&gt;flag &amp; ALLOC) {
				tp-&gt;flag &amp;= ~ALLOC;
				tfree(tp-&gt;val.t, tp-&gt;areap);
			}
			tp-&gt;flag = 0;
		}
		switch (i) {
		  case LRETURN:
		  case LERROR:
			rv = exstat;
			break;
		  case LINTR:
		  case LEXIT:
		  case LLEAVE:
		  case LSHELL:
			quitenv();
			unwind(i);
			/*NOTREACHED*/
		  default:
			quitenv();
			internal_errorf(1, "CFUNC %d", i);
		}
		break;
	  }

	  case CEXEC:		/* executable command */
	  case CTALIAS:		/* tracked alias */
		if (!(tp-&gt;flag&amp;ISSET)) {
			/* errno_ will be set if the named command was found
			 * but could not be executed (permissions, no execute
			 * bit, directory, etc).  Print out a (hopefully)
			 * useful error message and set the exit status to 126.
			 */
			if (tp-&gt;u2.errno_) {
				warningf(TRUE, "%s: cannot execute - %s", cp,
					strerror(tp-&gt;u2.errno_));
				rv = 126;	/* POSIX */
			} else {
				warningf(TRUE, "%s: not found", cp);
				rv = 127;
			}
			break;
		}

#ifdef KSH
		/* set $_ to program's full path */
		/* setstr() can't fail here */
		setstr(typeset("_", LOCAL|EXPORT, 0, INTEGER, 0), tp-&gt;val.s,
		       KSH_RETURN_ERROR);
#endif /* KSH */

		if (flags&amp;XEXEC) {
			j_exit();
			if (!(flags&amp;XBGND) || Flag(FMONITOR)) {
				setexecsig(&amp;sigtraps[SIGINT], SS_RESTORE_ORIG);
				setexecsig(&amp;sigtraps[SIGQUIT], SS_RESTORE_ORIG);
			}
		}

		/* to fork we set up a TEXEC node and call execute */
		texec.type = TEXEC;
		texec.left = t;	/* for tprint */
		texec.str = tp-&gt;val.s;
		texec.args = ap;
		rv = exchild(&amp;texec, flags, -1);
		break;
	}
  Leave:
	if (flags &amp; XEXEC) {
		exstat = rv;
		unwind(LLEAVE);
	}
	return rv;
}

static void
scriptexec(tp, ap)
	register struct op *tp;
	register char **ap;
{
	char *shell;

	shell = str_val(global(EXECSHELL_STR));
	if (shell &amp;&amp; *shell)
		shell = search(shell, path, X_OK, (int *) 0);
	if (!shell || !*shell)
		shell = EXECSHELL;

	*tp-&gt;args-- = tp-&gt;str;
#ifdef	SHARPBANG
	{
		char buf[LINE];
		register char *cp;
		register int fd, n;

		buf[0] = '\0';
		if ((fd = open(tp-&gt;str, O_RDONLY)) &gt;= 0) {
			if ((n = read(fd, buf, LINE - 1)) &gt; 0)
				buf[n] = '\0';
			(void) close(fd);
		}
		if ((buf[0] == '#' &amp;&amp; buf[1] == '!' &amp;&amp; (cp = &amp;buf[2]))
# ifdef OS2
		    || (strncmp(buf, "extproc", 7) == 0 &amp;&amp; isspace(buf[7])
			&amp;&amp; (cp = &amp;buf[7]))
# endif /* OS2 */
		    )
		{
			while (*cp &amp;&amp; (*cp == ' ' || *cp == '\t'))
				cp++;
			if (*cp &amp;&amp; *cp != '\n') {
				char *a0 = cp, *a1 = (char *) 0;
# ifdef OS2
				char *a2 = cp;
# endif /* OS2 */

				while (*cp &amp;&amp; *cp != '\n' &amp;&amp; *cp != ' '
				       &amp;&amp; *cp != '\t')
				{
# ifdef OS2
			/* Allow shell search without prepended path
			 * if shell with / in pathname cannot be found.
			 * Use / explicitly so \ can be used if explicit
			 * needs to be forced.
			 */
					if (*cp == '/')
						a2 = cp + 1;
# endif /* OS2 */
					cp++;
				}
				if (*cp &amp;&amp; *cp != '\n') {
					*cp++ = '\0';
					while (*cp
					       &amp;&amp; (*cp == ' ' || *cp == '\t'))
						cp++;
					if (*cp &amp;&amp; *cp != '\n') {
						a1 = cp;
						/* all one argument */
						while (*cp &amp;&amp; *cp != '\n')
							cp++;
					}
				}
				if (*cp == '\n') {
					*cp = '\0';
					if (a1)
						*tp-&gt;args-- = a1;
# ifdef OS2
					if (a0 != a2) {
						char *tmp_a0 = str_nsave(a0,
							strlen(a0) + 5, ATEMP);
						if (search_access(tmp_a0, X_OK,
								(int *) 0))
							a0 = a2;
						afree(tmp_a0, ATEMP);
					}
# endif /* OS2 */
					shell = a0;
				}
			}
# ifdef OS2
		} else {
		        /* Use ksh documented shell default if present
			 * else use OS2_SHELL which is assumed to need
			 * the /c option and '\' as dir separater.
			 */
		         char *p = shell;

			 shell = str_val(global("EXECSHELL"));
			 if (shell &amp;&amp; *shell)
				 shell = search(shell, path, X_OK, (int *) 0);
			 if (!shell || !*shell) {
				 shell = p;
				 *tp-&gt;args-- = "/c";
				 for (p = tp-&gt;str; *p; p++)
					 if (*p == '/')
						 *p = '\\';
			 }
# endif /* OS2 */
		}
	}
#endif	/* SHARPBANG */
	*tp-&gt;args = shell;

	ksh_execve(tp-&gt;args[0], tp-&gt;args, ap, 0);

	/* report both the program that was run and the bogus shell */
	errorf("%s: %s: %s", tp-&gt;str, shell, strerror(errno));
}

int
shcomexec(wp)
	register char **wp;
{
	register struct tbl *tp;

	tp = tsearch(&amp;builtins, *wp, hash(*wp));
	if (tp == NULL)
		internal_errorf(1, "shcomexec: %s", *wp);
	return call_builtin(tp, wp);
}

/*
 * Search function tables for a function.  If create set, a table entry
 * is created if none is found.
 */
struct tbl *
findfunc(name, h, create)
	const char *name;
	unsigned int h;
	int create;
{
	struct block *l;
	struct tbl *tp = (struct tbl *) 0;

	for (l = e-&gt;loc; l; l = l-&gt;next) {
		tp = tsearch(&amp;l-&gt;funs, name, h);
		if (tp)
			break;
		if (!l-&gt;next &amp;&amp; create) {
			tp = tenter(&amp;l-&gt;funs, name, h);
			tp-&gt;flag = DEFINED;
			tp-&gt;type = CFUNC;
			tp-&gt;val.t = (struct op *) 0;
			break;
		}
	}
	return tp;
}

/*
 * define function.  Returns 1 if function is being undefined (t == 0) and
 * function did not exist, returns 0 otherwise.
 */
int
define(name, t)
	const char *name;
	struct op *t;
{
	struct tbl *tp;
	int was_set = 0;

	while (1) {
		tp = findfunc(name, hash(name), TRUE);

		if (tp-&gt;flag &amp; ISSET)
			was_set = 1;
		/* If this function is currently being executed, we zap this
		 * table entry so findfunc() won't see it
		 */
		if (tp-&gt;flag &amp; FINUSE) {
			tp-&gt;name[0] = '\0';
			tp-&gt;flag &amp;= ~DEFINED; /* ensure it won't be found */
			tp-&gt;flag |= FDELETE;
		} else
			break;
	}

	if (tp-&gt;flag &amp; ALLOC) {
		tp-&gt;flag &amp;= ~(ISSET|ALLOC);
		tfree(tp-&gt;val.t, tp-&gt;areap);
	}

	if (t == NULL) {		/* undefine */
		tdelete(tp);
		return was_set ? 0 : 1;
	}

	tp-&gt;val.t = tcopy(t-&gt;left, tp-&gt;areap);
	tp-&gt;flag |= (ISSET|ALLOC);
	if (t-&gt;u.ksh_func)
		tp-&gt;flag |= FKSH;

	return 0;
}

/*
 * add builtin
 */
void
builtin(name, func)
	const char *name;
	int (*func) ARGS((char **));
{
	register struct tbl *tp;
	Tflag flag;

	/* see if any flags should be set for this builtin */
	for (flag = 0; ; name++) {
		if (*name == '=')	/* command does variable assignment */
			flag |= KEEPASN;
		else if (*name == '*')	/* POSIX special builtin */
			flag |= SPEC_BI;
		else if (*name == '+')	/* POSIX regular builtin */
			flag |= REG_BI;
		else
			break;
	}

	tp = tenter(&amp;builtins, name, hash(name));
	tp-&gt;flag = DEFINED | flag;
	tp-&gt;type = CSHELL;
	tp-&gt;val.f = func;
}

/*
 * find command
 * either function, hashed command, or built-in (in that order)
 */
struct tbl *
findcom(name, flags)
	const char *name;
	int	flags;		/* FC_* */
{
	static struct tbl temp;
	unsigned int h = hash(name);
	struct tbl *tp = NULL, *tbi;
	int insert = Flag(FTRACKALL);	/* insert if not found */
	char *fpath;			/* for function autoloading */
	char *npath;

	if (ksh_strchr_dirsep(name) != NULL) {
		insert = 0;
		/* prevent FPATH search below */
		flags &amp;= ~FC_FUNC;
		goto Search;
	}
	tbi = (flags &amp; FC_BI) ? tsearch(&amp;builtins, name, h) : NULL;
	/* POSIX says special builtins first, then functions, then
	 * POSIX regular builtins, then search path...
	 */
	if ((flags &amp; FC_SPECBI) &amp;&amp; tbi &amp;&amp; (tbi-&gt;flag &amp; SPEC_BI))
		tp = tbi;
	if (!tp &amp;&amp; (flags &amp; FC_FUNC)) {
		tp = findfunc(name, h, FALSE);
		if (tp &amp;&amp; !(tp-&gt;flag &amp; ISSET)) {
			if ((fpath = str_val(global("FPATH"))) == null) {
				tp-&gt;u.fpath = (char *) 0;
				tp-&gt;u2.errno_ = 0;
			} else
				tp-&gt;u.fpath = search(name, fpath, R_OK,
					&amp;tp-&gt;u2.errno_);
		}
	}
	if (!tp &amp;&amp; (flags &amp; FC_REGBI) &amp;&amp; tbi &amp;&amp; (tbi-&gt;flag &amp; REG_BI))
		tp = tbi;
	/* todo: posix says non-special/non-regular builtins must
	 * be triggered by some user-controllable means like a
	 * special directory in PATH.  Requires modifications to
	 * the search() function.  Tracked aliases should be
	 * modified to allow tracking of builtin commands.
	 * This should be under control of the FPOSIX flag.
	 * If this is changed, also change c_whence...
	 */
	if (!tp &amp;&amp; (flags &amp; FC_UNREGBI) &amp;&amp; tbi)
		tp = tbi;
	if (!tp &amp;&amp; (flags &amp; FC_PATH) &amp;&amp; !(flags &amp; FC_DEFPATH)) {
		tp = tsearch(&amp;taliases, name, h);
		if (tp &amp;&amp; (tp-&gt;flag &amp; ISSET) &amp;&amp; eaccess(tp-&gt;val.s, X_OK) != 0) {
			if (tp-&gt;flag &amp; ALLOC) {
				tp-&gt;flag &amp;= ~ALLOC;
				afree(tp-&gt;val.s, APERM);
			}
			tp-&gt;flag &amp;= ~ISSET;
		}
	}

  Search:
	if ((!tp || (tp-&gt;type == CTALIAS &amp;&amp; !(tp-&gt;flag&amp;ISSET)))
	    &amp;&amp; (flags &amp; FC_PATH))
	{
		if (!tp) {
			if (insert &amp;&amp; !(flags &amp; FC_DEFPATH)) {
				tp = tenter(&amp;taliases, name, h);
				tp-&gt;type = CTALIAS;
			} else {
				tp = &amp;temp;
				tp-&gt;type = CEXEC;
			}
			tp-&gt;flag = DEFINED;	/* make ~ISSET */
		}
		npath = search(name, flags &amp; FC_DEFPATH ? def_path : path,
				X_OK, &amp;tp-&gt;u2.errno_);
		if (npath) {
			tp-&gt;val.s = tp == &amp;temp ? npath : str_save(npath, APERM);
			tp-&gt;flag |= ISSET|ALLOC;
		} else if ((flags &amp; FC_FUNC)
			   &amp;&amp; (fpath = str_val(global("FPATH"))) != null
			   &amp;&amp; (npath = search(name, fpath, R_OK,
					      &amp;tp-&gt;u2.errno_)) != (char *) 0)
		{
			/* An undocumented feature of at&amp;t ksh is that it
			 * searches FPATH if a command is not found, even
			 * if the command hasn't been set up as an autoloaded
			 * function (ie, no typeset -uf).
			 */
			tp = &amp;temp;
			tp-&gt;type = CFUNC;
			tp-&gt;flag = DEFINED; /* make ~ISSET */
			tp-&gt;u.fpath = npath;
		}
	}
	return tp;
}

/*
 * flush executable commands with relative paths
 */
void
flushcom(all)
	int all;		/* just relative or all */
{
	struct tbl *tp;
	struct tstate ts;

	for (twalk(&amp;ts, &amp;taliases); (tp = tnext(&amp;ts)) != NULL; )
		if ((tp-&gt;flag&amp;ISSET) &amp;&amp; (all || !ISDIRSEP(tp-&gt;val.s[0]))) {
			if (tp-&gt;flag&amp;ALLOC) {
				tp-&gt;flag &amp;= ~(ALLOC|ISSET);
				afree(tp-&gt;val.s, APERM);
			}
			tp-&gt;flag &amp;= ~ISSET;
		}
}

/* Check if path is something we want to find.  Returns -1 for failure. */
int
search_access(path, mode, errnop)
	const char *path;
	int mode;
	int *errnop;		/* set if candidate found, but not suitable */
{
#ifndef OS2
	int ret, err = 0;
	struct stat statb;

	if (stat(path, &amp;statb) &lt; 0)
		return -1;
	ret = eaccess(path, mode);
	if (ret &lt; 0)
		err = errno; /* File exists, but we can't access it */
	else if (mode == X_OK
		 &amp;&amp; (!S_ISREG(statb.st_mode)
		     /* This 'cause access() says root can execute everything */
		     || !(statb.st_mode &amp; (S_IXUSR|S_IXGRP|S_IXOTH))))
	{
		ret = -1;
		err = S_ISDIR(statb.st_mode) ? EISDIR : EACCES;
	}
	if (err &amp;&amp; errnop &amp;&amp; !*errnop)
		*errnop = err;
	return ret;
#else /* !OS2 */
	/*
	 * NOTE: ASSUMES path can be modified and has enough room at the
	 *       end of the string for a suffix (ie, 4 extra characters).
	 *	 Certain code knows this (eg, eval.c(globit()),
	 *	 exec.c(search())).
	 */
	static char *xsuffixes[] = { ".ksh", ".exe", ".", ".sh", ".cmd",
				     ".com", ".bat", (char *) 0
				   };
	static char *rsuffixes[] = { ".ksh", ".", ".sh", ".cmd", ".bat",
				      (char *) 0
				   };
	int i;
	char *mpath = (char *) path;
	char *tp = mpath + strlen(mpath);
	char *p;
	char **sfx;
 
	/* If a suffix has been specified, check if it is one of the
	 * suffixes that indicate the file is executable - if so, change
	 * the access test to R_OK...
	 * This code assumes OS/2 files can have only one suffix...
	 */
	if ((p = strrchr((p = ksh_strrchr_dirsep(mpath)) ? p : mpath, '.'))) {
		if (mode == X_OK) 
			mode = R_OK;
		return search_access1(mpath, mode, errnop);
	}
	/* Try appending the various suffixes.  Different suffixes for
	 * read and execute 'cause we don't want to read an executable...
	 */
	sfx = mode == R_OK ? rsuffixes : xsuffixes;
	for (i = 0; sfx[i]; i++) {
		strcpy(tp, p = sfx[i]);
		if (search_access1(mpath, R_OK, errnop) == 0)
			return 0;
		*tp = '\0';
	}
	return -1;
#endif /* !OS2 */
}

#ifdef OS2
static int
search_access1(path, mode, errnop)
	const char *path;
	int mode;
	int *errnop;		/* set if candidate found, but not suitable */
{
	int ret, err = 0;
	struct stat statb;

	if (stat(path, &amp;statb) &lt; 0)
		return -1;
	ret = eaccess(path, mode);
	if (ret &lt; 0)
		err = errno; /* File exists, but we can't access it */
	else if (!S_ISREG(statb.st_mode)) {
		ret = -1;
		err = S_ISDIR(statb.st_mode) ? EISDIR : EACCES;
	}
	if (err &amp;&amp; errnop &amp;&amp; !*errnop)
		*errnop = err;
	return ret;
}
#endif /* OS2 */

/*
 * search for command with PATH
 */
char *
search(name, path, mode, errnop)
	const char *name;
	const char *path;
	int mode;		/* R_OK or X_OK */
	int *errnop;		/* set if candidate found, but not suitable */
{
	const char *sp, *p;
	char *xp;
	XString xs;
	int namelen;

	if (errnop)
		*errnop = 0;
#ifdef OS2
	/* Xinit() allocates 8 additional bytes, so appended suffixes won't
	 * overflow the memory.
	 */
	namelen = strlen(name) + 1;
	Xinit(xs, xp, namelen, ATEMP);
	memcpy(Xstring(xs, xp), name, namelen);

 	if (ksh_strchr_dirsep(name)) {
		if (search_access(Xstring(xs, xp), mode, errnop) &gt;= 0)
			return Xstring(xs, xp); /* not Xclose() - see above */
		Xfree(xs, xp);
		return NULL;
	}

	/* Look in current context always. (os2 style) */
	if (search_access(Xstring(xs, xp), mode, errnop) == 0) 
		return Xstring(xs, xp); /* not Xclose() - xp may be wrong */
#else /* OS2 */
	if (ksh_strchr_dirsep(name)) {
		if (search_access(name, mode, errnop) == 0)
			return (char *) name;
		return NULL;
	}

	namelen = strlen(name) + 1;
	Xinit(xs, xp, 128, ATEMP);
#endif /* OS2 */

	sp = path;
	while (sp != NULL) {
		xp = Xstring(xs, xp);
		if (!(p = strchr(sp, PATHSEP)))
			p = sp + strlen(sp);
		if (p != sp) {
			XcheckN(xs, xp, p - sp);
			memcpy(xp, sp, p - sp);
			xp += p - sp;
			*xp++ = DIRSEP;
		}
		sp = p;
		XcheckN(xs, xp, namelen);
		memcpy(xp, name, namelen);
 		if (search_access(Xstring(xs, xp), mode, errnop) == 0)
#ifdef OS2
 			return Xstring(xs, xp); /* Not Xclose() - see above */
#else /* OS2 */
			return Xclose(xs, xp + namelen);
#endif /* OS2 */
		if (*sp++ == '\0')
			sp = NULL;
	}
	Xfree(xs, xp);
	return NULL;
}

static int
call_builtin(tp, wp)
	struct tbl *tp;
	char **wp;
{
	int rv;

	builtin_argv0 = wp[0];
	builtin_flag = tp-&gt;flag;
	shf_reopen(1, SHF_WR, shl_stdout);
	shl_stdout_ok = 1;
	ksh_getopt_reset(&amp;builtin_opt, GF_ERROR);
	rv = (*tp-&gt;val.f)(wp);
	shf_flush(shl_stdout);
	shl_stdout_ok = 0;
	builtin_flag = 0;
	builtin_argv0 = (char *) 0;
	return rv;
}

/*
 * set up redirection, saving old fd's in e-&gt;savefd
 */
static int
iosetup(iop, tp)
	register struct ioword *iop;
	struct tbl *tp;
{
	register int u = -1;
	char *cp = iop-&gt;name;
	int iotype = iop-&gt;flag &amp; IOTYPE;
	int do_open = 1, do_close = 0, UNINITIALIZED(flags);
	struct ioword iotmp;
	struct stat statb;

	if (iotype != IOHERE)
		cp = evalonestr(cp, DOTILDE|(Flag(FTALKING_I) ? DOGLOB : 0));

	/* Used for tracing and error messages to print expanded cp */
	iotmp = *iop;
	iotmp.name = (iotype == IOHERE) ? (char *) 0 : cp;
	iotmp.flag |= IONAMEXP;

	if (Flag(FXTRACE))
		shellf("%s%s\n",
			PS4_SUBSTITUTE(str_val(global("PS4"))),
			snptreef((char *) 0, 32, "%R", &amp;iotmp));

	switch (iotype) {
	  case IOREAD:
		flags = O_RDONLY;
		break;

	  case IOCAT:
		flags = O_WRONLY | O_APPEND | O_CREAT;
		break;

	  case IOWRITE:
		flags = O_WRONLY | O_CREAT | O_TRUNC;
		/* The stat() is here to allow redirections to
		 * things like /dev/null without error.
		 */
		if (Flag(FNOCLOBBER) &amp;&amp; !(iop-&gt;flag &amp; IOCLOB)
		    &amp;&amp; (stat(cp, &amp;statb) &lt; 0 || S_ISREG(statb.st_mode)))
			flags |= O_EXCL;
		break;

	  case IORDWR:
		flags = O_RDWR | O_CREAT;
		break;

	  case IOHERE:
		do_open = 0;
		/* herein() returns -2 if error has been printed */
		u = herein(iop-&gt;heredoc, iop-&gt;flag &amp; IOEVAL);
		/* cp may have wrong name */
		break;

	  case IODUP:
	  {
		const char *emsg;

		do_open = 0;
		if (*cp == '-' &amp;&amp; !cp[1]) {
			u = 1009;	 /* prevent error return below */
			do_close = 1;
		} else if ((u = check_fd(cp,
				X_OK | ((iop-&gt;flag &amp; IORDUP) ? R_OK : W_OK),
				&amp;emsg)) &lt; 0)
		{
			warningf(TRUE, "%s: %s",
				snptreef((char *) 0, 32, "%R", &amp;iotmp), emsg);
			return -1;
		}
		break;
	  }
	}
	if (do_open) {
		if (Flag(FRESTRICTED) &amp;&amp; (flags &amp; O_CREAT)) {
			warningf(TRUE, "%s: restricted", cp);
			return -1;
		}
		u = open(cp, flags, 0666);
#ifdef OS2
		if (u &lt; 0 &amp;&amp; strcmp(cp, "/dev/null") == 0)
			u = open("nul", flags, 0666);
#endif /* OS2 */
	}
	if (u &lt; 0) {
		/* herein() may already have printed message */
		if (u == -1)
			warningf(TRUE, "cannot %s %s: %s",
			       iotype == IODUP ? "dup"
				: (iotype == IOREAD || iotype == IOHERE) ?
				    "open" : "create", cp, strerror(errno));
		return -1;
	}
	/* Do not save if it has already been redirected (i.e. "cat &gt;x &gt;y"). */
	if (e-&gt;savefd[iop-&gt;unit] == 0)
		/* c_exec() assumes e-&gt;savefd[fd] set for any redirections.
		 * Ask savefd() not to close iop-&gt;unit - allows error messages
		 * to be seen if iop-&gt;unit is 2; also means we can't lose
		 * the fd (eg, both dup2 below and dup2 in restfd() failing).
		 */
		e-&gt;savefd[iop-&gt;unit] = savefd(iop-&gt;unit, 1);

	if (do_close)
		close(iop-&gt;unit);
	else if (u != iop-&gt;unit) {
		if (ksh_dup2(u, iop-&gt;unit, TRUE) &lt; 0) {
			warningf(TRUE,
				"could not finish (dup) redirection %s: %s",
				snptreef((char *) 0, 32, "%R", &amp;iotmp),
				strerror(errno));
			if (iotype != IODUP)
				close(u);
			return -1;
		}
		if (iotype != IODUP)
			close(u);
#ifdef KSH
		/* Touching any co-process fd in an empty exec
		 * causes the shell to close its copies
		 */
		else if (tp &amp;&amp; tp-&gt;type == CSHELL &amp;&amp; tp-&gt;val.f == c_exec) {
			if (iop-&gt;flag &amp; IORDUP)	/* possible exec &lt;&amp;p */
				coproc_read_close(u);
			else			/* possible exec &gt;&amp;p */
				coproc_write_close(u);
		}
#endif /* KSH */
	}
	if (u == 2) /* Clear any write errors */
		shf_reopen(2, SHF_WR, shl_out);
	return 0;
}

/*
 * open here document temp file.
 * if unquoted here, expand here temp file into second temp file.
 */
static int
herein(content, sub)
	const char *content;
	int sub;
{
	volatile int fd = -1;
	struct source *s, *volatile osource;
	struct shf *volatile shf;
	struct temp *h;
	int i;

	/* ksh -c 'cat &lt;&lt; EOF' can cause this... */
	if (content == (char *) 0) {
		warningf(TRUE, "here document missing");
		return -2; /* special to iosetup(): don't print error */
	}

	/* Create temp file to hold content (done before newenv so temp
	 * doesn't get removed too soon).
	 */
	h = maketemp(ATEMP, TT_HEREDOC_EXP, &amp;e-&gt;temps);
	if (!(shf = h-&gt;shf) || (fd = open(h-&gt;name, O_RDONLY, 0)) &lt; 0) {
		warningf(TRUE, "can't %s temporary file %s: %s",
			!shf ? "create" : "open",
			h-&gt;name, strerror(errno));
		if (shf)
			shf_close(shf);
		return -2 /* special to iosetup(): don't print error */;
	}

	osource = source;
	newenv(E_ERRH);
	i = ksh_sigsetjmp(e-&gt;jbuf, 0);
	if (i) {
		source = osource;
		quitenv();
		shf_close(shf);	/* after quitenv */
		close(fd);
		return -2; /* special to iosetup(): don't print error */
	}
	if (sub) {
		/* Do substitutions on the content of heredoc */
		s = pushs(SSTRING, ATEMP);
		s-&gt;start = s-&gt;str = content;
		source = s;
		if (yylex(ONEWORD) != LWORD)
			internal_errorf(1, "herein: yylex");
		source = osource;
		shf_puts(evalstr(yylval.cp, 0), shf);
	} else
		shf_puts(content, shf);

	quitenv();

	if (shf_close(shf) == EOF) {
		close(fd);
		warningf(TRUE, "error writing %s: %s", h-&gt;name,
			strerror(errno));
		return -2; /* special to iosetup(): don't print error */
	}

	return fd;
}

#ifdef KSH
/*
 *	ksh special - the select command processing section
 *	print the args in column form - assuming that we can
 */
static char *
do_selectargs(ap, print_menu)
	register char **ap;
	bool_t print_menu;
{
	static const char *const read_args[] = {
					"read", "-r", "REPLY", (char *) 0
				    };
	char *s;
	int i, argct;

	for (argct = 0; ap[argct]; argct++)
		;
	while (1) {
		/* Menu is printed if
		 *	- this is the first time around the select loop
		 *	- the user enters a blank line
		 *	- the REPLY parameter is empty
		 */
		if (print_menu || !*str_val(global("REPLY")))
			pr_menu(ap);
		shellf("%s", str_val(global("PS3")));
		if (call_builtin(findcom("read", FC_BI), (char **) read_args))
			return (char *) 0;
		s = str_val(global("REPLY"));
		if (*s) {
			i = atoi(s);
			return (i &gt;= 1 &amp;&amp; i &lt;= argct) ? ap[i - 1] : null;
		}
		print_menu = 1;
	}
}

struct select_menu_info {
	char	*const *args;
	int	arg_width;
	int	num_width;
} info;

static char *select_fmt_entry ARGS((void *arg, int i, char *buf, int buflen));

/* format a single select menu item */
static char *
select_fmt_entry(arg, i, buf, buflen)
	void *arg;
	int i;
	char *buf;
	int buflen;
{
	struct select_menu_info *smi = (struct select_menu_info *) arg;

	shf_snprintf(buf, buflen, "%*d) %s",
		smi-&gt;num_width, i + 1, smi-&gt;args[i]);
	return buf;
}

/*
 *	print a select style menu
 */
int
pr_menu(ap)
	char *const *ap;
{
	struct select_menu_info smi;
	char *const *pp;
	int nwidth, dwidth;
	int i, n;

	/* Width/column calculations were done once and saved, but this
	 * means select can't be used recursively so we re-calculate each
	 * time (could save in a structure that is returned, but its probably
	 * not worth the bother).
	 */

	/*
	 * get dimensions of the list
	 */
	for (n = 0, nwidth = 0, pp = ap; *pp; n++, pp++) {
		i = strlen(*pp);
		nwidth = (i &gt; nwidth) ? i : nwidth;
	}
	/*
	 * we will print an index of the form
	 *	%d)
	 * in front of each entry
	 * get the max width of this
	 */
	for (i = n, dwidth = 1; i &gt;= 10; i /= 10)
		dwidth++;

	smi.args = ap;
	smi.arg_width = nwidth;
	smi.num_width = dwidth;
	print_columns(shl_out, n, select_fmt_entry, (void *) &amp;smi,
		dwidth + nwidth + 2);

	return n;
}
#endif /* KSH */
#ifdef KSH

/*
 *	[[ ... ]] evaluation routines
 */

extern const char *const dbtest_tokens[];
extern const char db_close[];

/* Test if the current token is a whatever.  Accepts the current token if
 * it is.  Returns 0 if it is not, non-zero if it is (in the case of
 * TM_UNOP and TM_BINOP, the returned value is a Test_op).
 */
static int
dbteste_isa(te, meta)
	Test_env *te;
	Test_meta meta;
{
	int ret = 0;
	int uqword;
	char *p;

	if (!*te-&gt;pos.wp)
		return meta == TM_END;

	/* unquoted word? */
	for (p = *te-&gt;pos.wp; *p == CHAR; p += 2)
		;
	uqword = *p == EOS;

	if (meta == TM_UNOP || meta == TM_BINOP) {
		if (uqword) {
			char buf[8];	/* longer than the longest operator */
			char *q = buf;
			for (p = *te-&gt;pos.wp; *p == CHAR
					      &amp;&amp; q &lt; &amp;buf[sizeof(buf) - 1];
					      p += 2)
				*q++ = p[1];
			*q = '\0';
			ret = (int) test_isop(te, meta, buf);
		}
	} else if (meta == TM_END)
		ret = 0;
	else
		ret = uqword
			&amp;&amp; strcmp(*te-&gt;pos.wp, dbtest_tokens[(int) meta]) == 0;

	/* Accept the token? */
	if (ret)
		te-&gt;pos.wp++;

	return ret;
}

static const char *
dbteste_getopnd(te, op, do_eval)
	Test_env *te;
	Test_op op;
	int do_eval;
{
	char *s = *te-&gt;pos.wp;

	if (!s)
		return (char *) 0;

	te-&gt;pos.wp++;

	if (!do_eval)
		return null;

	if (op == TO_STEQL || op == TO_STNEQ)
		s = evalstr(s, DOTILDE | DOPAT);
	else
		s = evalstr(s, DOTILDE);

	return s;
}

static int
dbteste_eval(te, op, opnd1, opnd2, do_eval)
	Test_env *te;
	Test_op op;
	const char *opnd1;
	const char *opnd2;
	int do_eval;
{
	return test_eval(te, op, opnd1, opnd2, do_eval);
}

static void
dbteste_error(te, offset, msg)
	Test_env *te;
	int offset;
	const char *msg;
{
	te-&gt;flags |= TEF_ERROR;
	internal_errorf(0, "dbteste_error: %s (offset %d)", msg, offset);
}
#endif /* KSH */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

