<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/expr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/expr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Korn expression evaluation
 */
/*
 * todo: better error handling: if in builtin, should be builtin error, etc.
 */

#include "sh.h"
#include &lt;ctype.h&gt;


/* The order of these enums is constrained by the order of opinfo[] */
enum token {
	/* some (long) unary operators */
	O_PLUSPLUS = 0, O_MINUSMINUS,
	/* binary operators */
	O_EQ, O_NE,
	/* assignments are assumed to be in range O_ASN .. O_BORASN */
	O_ASN, O_TIMESASN, O_DIVASN, O_MODASN, O_PLUSASN, O_MINUSASN,
	       O_LSHIFTASN, O_RSHIFTASN, O_BANDASN, O_BXORASN, O_BORASN,
	O_LSHIFT, O_RSHIFT,
	O_LE, O_GE, O_LT, O_GT,
	O_LAND,
	O_LOR,
	O_TIMES, O_DIV, O_MOD,
	O_PLUS, O_MINUS,
	O_BAND,
	O_BXOR,
	O_BOR,
	O_TERN,
	O_COMMA,
	/* things after this aren't used as binary operators */
	/* unary that are not also binaries */
	O_BNOT, O_LNOT,
	/* misc */
	OPEN_PAREN, CLOSE_PAREN, CTERN,
	/* things that don't appear in the opinfo[] table */
	VAR, LIT, END, BAD
    };
#define IS_BINOP(op) (((int)op) &gt;= (int)O_EQ &amp;&amp; ((int)op) &lt;= (int)O_COMMA)
#define IS_ASSIGNOP(op)	((int)(op) &gt;= (int)O_ASN &amp;&amp; (int)(op) &lt;= (int)O_BORASN)

enum prec {
	P_PRIMARY = 0,		/* VAR, LIT, (), ~ ! - + */
	P_MULT,			/* * / % */
	P_ADD,			/* + - */
	P_SHIFT,		/* &lt;&lt; &gt;&gt; */
	P_RELATION,		/* &lt; &lt;= &gt; &gt;= */
	P_EQUALITY,		/* == != */
	P_BAND,			/* &amp; */
	P_BXOR,			/* ^ */
	P_BOR,			/* | */
	P_LAND,			/* &amp;&amp; */
	P_LOR,			/* || */
	P_TERN,			/* ?: */
	P_ASSIGN,		/* = *= /= %= += -= &lt;&lt;= &gt;&gt;= &amp;= ^= |= */
	P_COMMA			/* , */
    };
#define MAX_PREC	P_COMMA

struct opinfo {
	char		name[4];
	int		len;	/* name length */
	enum prec	prec;	/* precidence: lower is higher */
};

/* Tokens in this table must be ordered so the longest are first
 * (eg, += before +).  If you change something, change the order
 * of enum token too.
 */
static const struct opinfo opinfo[] = {
		{ "++",	 2, P_PRIMARY },	/* before + */
		{ "--",	 2, P_PRIMARY },	/* before - */
		{ "==",	 2, P_EQUALITY },	/* before = */
		{ "!=",	 2, P_EQUALITY },	/* before ! */
		{ "=",	 1, P_ASSIGN },		/* keep assigns in a block */
		{ "*=",	 2, P_ASSIGN },
		{ "/=",	 2, P_ASSIGN },
		{ "%=",	 2, P_ASSIGN },
		{ "+=",	 2, P_ASSIGN },
		{ "-=",	 2, P_ASSIGN },
		{ "&lt;&lt;=", 3, P_ASSIGN },
		{ "&gt;&gt;=", 3, P_ASSIGN },
		{ "&amp;=",	 2, P_ASSIGN },
		{ "^=",	 2, P_ASSIGN },
		{ "|=",	 2, P_ASSIGN },
		{ "&lt;&lt;",	 2, P_SHIFT },
		{ "&gt;&gt;",	 2, P_SHIFT },
		{ "&lt;=",	 2, P_RELATION },
		{ "&gt;=",	 2, P_RELATION },
		{ "&lt;",	 1, P_RELATION },
		{ "&gt;",	 1, P_RELATION },
		{ "&amp;&amp;",	 2, P_LAND },
		{ "||",	 2, P_LOR },
		{ "*",	 1, P_MULT },
		{ "/",	 1, P_MULT },
		{ "%",	 1, P_MULT },
		{ "+",	 1, P_ADD },
		{ "-",	 1, P_ADD },
		{ "&amp;",	 1, P_BAND },
		{ "^",	 1, P_BXOR },
		{ "|",	 1, P_BOR },
		{ "?",	 1, P_TERN },
		{ ",",	 1, P_COMMA },
		{ "~",	 1, P_PRIMARY },
		{ "!",	 1, P_PRIMARY },
		{ "(",	 1, P_PRIMARY },
		{ ")",	 1, P_PRIMARY },
		{ ":",	 1, P_PRIMARY },
		{ "",	 0, P_PRIMARY } /* end of table */
	    };


typedef struct expr_state Expr_state;
struct expr_state {
	const char *expression;		/* expression being evaluated */
	const char *tokp;		/* lexical position */
	enum token  tok;		/* token from token() */
	int	    noassign;		/* don't do assigns (for ?:,&amp;&amp;,||) */
	struct tbl *val;		/* value from token() */
	struct tbl *evaling;		/* variable that is being recursively
					 * expanded (EXPRINEVAL flag set)
					 */
};

enum error_type { ET_UNEXPECTED, ET_BADLIT, ET_RECURSIVE,
		  ET_LVALUE, ET_RDONLY, ET_STR };

static void        evalerr  ARGS((Expr_state *es, enum error_type type,
				  const char *str)) GCC_FUNC_ATTR(noreturn);
static struct tbl *evalexpr ARGS((Expr_state *es, enum prec prec));
static void        token    ARGS((Expr_state *es));
static struct tbl *do_ppmm  ARGS((Expr_state *es, enum token op,
				  struct tbl *vasn, bool_t is_prefix));
static void	   assign_check ARGS((Expr_state *es, enum token op,
				      struct tbl *vasn));
static struct tbl *tempvar  ARGS((void));
static struct tbl *intvar   ARGS((Expr_state *es, struct tbl *vp));

/*
 * parse and evalute expression
 */
int
evaluate(expr, rval, error_ok)
	const char *expr;
	long *rval;
	int error_ok;
{
	struct tbl v;
	int ret;

	v.flag = DEFINED|INTEGER;
	v.type = 0;
	ret = v_evaluate(&amp;v, expr, error_ok);
	*rval = v.val.i;
	return ret;
}

/*
 * parse and evalute expression, storing result in vp.
 */
int
v_evaluate(vp, expr, error_ok)
	struct tbl *vp;
	const char *expr;
	volatile int error_ok;
{
	struct tbl *v;
	Expr_state curstate;
	Expr_state * const es = &amp;curstate;
	int i;

	/* save state to allow recursive calls */
	curstate.expression = curstate.tokp = expr;
	curstate.noassign = 0;
	curstate.evaling = (struct tbl *) 0;

	newenv(E_ERRH);
	i = ksh_sigsetjmp(e-&gt;jbuf, 0);
	if (i) {
		/* Clear EXPRINEVAL in of any variables we were playing with */
		if (curstate.evaling)
			curstate.evaling-&gt;flag &amp;= ~EXPRINEVAL;
		quitenv();
		if (i == LAEXPR) {
			if (error_ok == KSH_RETURN_ERROR)
				return 0;
			errorf(null);
		}
		unwind(i);
		/*NOTREACHED*/
	}

	token(es);
#if 1 /* ifdef-out to disallow empty expressions to be treated as 0 */
	if (es-&gt;tok == END) {
		es-&gt;tok = LIT;
		es-&gt;val = tempvar();
	}
#endif /* 0 */
	v = intvar(es, evalexpr(es, MAX_PREC));

	if (es-&gt;tok != END)
		evalerr(es, ET_UNEXPECTED, (char *) 0);

	if (vp-&gt;flag &amp; INTEGER)
		setint_v(vp, v);
	else
		/* can fail if readony */
		setstr(vp, str_val(v), error_ok);

	quitenv();

	return 1;
}

static void
evalerr(es, type, str)
	Expr_state *es;
	enum error_type type;
	const char *str;
{
	char tbuf[2];
	const char *s;

	switch (type) {
	case ET_UNEXPECTED:
		switch (es-&gt;tok) {
		case VAR:
			s = es-&gt;val-&gt;name;
			break;
		case LIT:
			s = str_val(es-&gt;val);
			break;
		case END:
			s = "end of expression";
			break;
		case BAD:
			tbuf[0] = *es-&gt;tokp;
			tbuf[1] = '\0';
			s = tbuf;
			break;
		default:
			s = opinfo[(int)es-&gt;tok].name;
		}
		warningf(TRUE, "%s: unexpected `%s'", es-&gt;expression, s);
		break;

	case ET_BADLIT:
		warningf(TRUE, "%s: bad number `%s'", es-&gt;expression, str);
		break;

	case ET_RECURSIVE:
		warningf(TRUE, "%s: expression recurses on parameter `%s'",
			es-&gt;expression, str);
		break;

	case ET_LVALUE:
		warningf(TRUE, "%s: %s requires lvalue",
			es-&gt;expression, str);
		break;

	case ET_RDONLY:
		warningf(TRUE, "%s: %s applied to read only variable",
			es-&gt;expression, str);
		break;

	default: /* keep gcc happy */
	case ET_STR:
		warningf(TRUE, "%s: %s", es-&gt;expression, str);
		break;
	}
	unwind(LAEXPR);
}

static struct tbl *
evalexpr(es, prec)
	Expr_state *es;
	enum prec prec;
{
	struct tbl *vl, UNINITIALIZED(*vr), *vasn;
	enum token op;
	long UNINITIALIZED(res);

	if (prec == P_PRIMARY) {
		op = es-&gt;tok;
		if (op == O_BNOT || op == O_LNOT || op == O_MINUS
		    || op == O_PLUS)
		{
			token(es);
			vl = intvar(es, evalexpr(es, P_PRIMARY));
			if (op == O_BNOT)
				vl-&gt;val.i = ~vl-&gt;val.i;
			else if (op == O_LNOT)
				vl-&gt;val.i = !vl-&gt;val.i;
			else if (op == O_MINUS)
				vl-&gt;val.i = -vl-&gt;val.i;
			/* op == O_PLUS is a no-op */
		} else if (op == OPEN_PAREN) {
			token(es);
			vl = evalexpr(es, MAX_PREC);
			if (es-&gt;tok != CLOSE_PAREN)
				evalerr(es, ET_STR, "missing )");
			token(es);
		} else if (op == O_PLUSPLUS || op == O_MINUSMINUS) {
			token(es);
			vl = do_ppmm(es, op, es-&gt;val, TRUE);
			token(es);
		} else if (op == VAR || op == LIT) {
			vl = es-&gt;val;
			token(es);
		} else {
			evalerr(es, ET_UNEXPECTED, (char *) 0);
			/*NOTREACHED*/
		}
		if (es-&gt;tok == O_PLUSPLUS || es-&gt;tok == O_MINUSMINUS) {
			vl = do_ppmm(es, es-&gt;tok, vl, FALSE);
			token(es);
		}
		return vl;
	}
	vl = evalexpr(es, ((int) prec) - 1);
	for (op = es-&gt;tok; IS_BINOP(op) &amp;&amp; opinfo[(int) op].prec == prec;
		op = es-&gt;tok)
	{
		token(es);
		vasn = vl;
		if (op != O_ASN) /* vl may not have a value yet */
			vl = intvar(es, vl);
		if (IS_ASSIGNOP(op)) {
			assign_check(es, op, vasn);
			vr = intvar(es, evalexpr(es, P_ASSIGN));
		} else if (op != O_TERN &amp;&amp; op != O_LAND &amp;&amp; op != O_LOR)
			vr = intvar(es, evalexpr(es, ((int) prec) - 1));
		if ((op == O_DIV || op == O_MOD || op == O_DIVASN
		     || op == O_MODASN) &amp;&amp; vr-&gt;val.i == 0)
		{
			if (es-&gt;noassign)
				vr-&gt;val.i = 1;
			else
				evalerr(es, ET_STR, "zero divisor");
		}
		switch ((int) op) {
		case O_TIMES:
		case O_TIMESASN:
			res = vl-&gt;val.i * vr-&gt;val.i;
			break;
		case O_DIV:
		case O_DIVASN:
			res = vl-&gt;val.i / vr-&gt;val.i;
			break;
		case O_MOD:
		case O_MODASN:
			res = vl-&gt;val.i % vr-&gt;val.i;
			break;
		case O_PLUS:
		case O_PLUSASN:
			res = vl-&gt;val.i + vr-&gt;val.i;
			break;
		case O_MINUS:
		case O_MINUSASN:
			res = vl-&gt;val.i - vr-&gt;val.i;
			break;
		case O_LSHIFT:
		case O_LSHIFTASN:
			res = vl-&gt;val.i &lt;&lt; vr-&gt;val.i;
			break;
		case O_RSHIFT:
		case O_RSHIFTASN:
			res = vl-&gt;val.i &gt;&gt; vr-&gt;val.i;
			break;
		case O_LT:
			res = vl-&gt;val.i &lt; vr-&gt;val.i;
			break;
		case O_LE:
			res = vl-&gt;val.i &lt;= vr-&gt;val.i;
			break;
		case O_GT:
			res = vl-&gt;val.i &gt; vr-&gt;val.i;
			break;
		case O_GE:
			res = vl-&gt;val.i &gt;= vr-&gt;val.i;
			break;
		case O_EQ:
			res = vl-&gt;val.i == vr-&gt;val.i;
			break;
		case O_NE:
			res = vl-&gt;val.i != vr-&gt;val.i;
			break;
		case O_BAND:
		case O_BANDASN:
			res = vl-&gt;val.i &amp; vr-&gt;val.i;
			break;
		case O_BXOR:
		case O_BXORASN:
			res = vl-&gt;val.i ^ vr-&gt;val.i;
			break;
		case O_BOR:
		case O_BORASN:
			res = vl-&gt;val.i | vr-&gt;val.i;
			break;
		case O_LAND:
			if (!vl-&gt;val.i)
				es-&gt;noassign++;
			vr = intvar(es, evalexpr(es, ((int) prec) - 1));
			res = vl-&gt;val.i &amp;&amp; vr-&gt;val.i;
			if (!vl-&gt;val.i)
				es-&gt;noassign--;
			break;
		case O_LOR:
			if (vl-&gt;val.i)
				es-&gt;noassign++;
			vr = intvar(es, evalexpr(es, ((int) prec) - 1));
			res = vl-&gt;val.i || vr-&gt;val.i;
			if (vl-&gt;val.i)
				es-&gt;noassign--;
			break;
		case O_TERN:
			{
				int e = vl-&gt;val.i != 0;
				if (!e)
					es-&gt;noassign++;
				vl = evalexpr(es, MAX_PREC);
				if (!e)
					es-&gt;noassign--;
				if (es-&gt;tok != CTERN)
					evalerr(es, ET_STR, "missing :");
				token(es);
				if (e)
					es-&gt;noassign++;
				vr = evalexpr(es, P_TERN);
				if (e)
					es-&gt;noassign--;
				vl = e ? vl : vr;
			}
			break;
		case O_ASN:
			res = vr-&gt;val.i;
			break;
		case O_COMMA:
			res = vr-&gt;val.i;
			break;
		}
		if (IS_ASSIGNOP(op)) {
			vr-&gt;val.i = res;
			if (vasn-&gt;flag &amp; INTEGER)
				setint_v(vasn, vr);
			else
				setint(vasn, res);
			vl = vr;
		} else if (op != O_TERN)
			vl-&gt;val.i = res;
	}
	return vl;
}

static void
token(es)
	Expr_state *es;
{
	const char *cp;
	int c;
	char *tvar;

	/* skip white space */
	for (cp = es-&gt;tokp; (c = *cp), isspace(c); cp++)
		;
	es-&gt;tokp = cp;

	if (c == '\0')
		es-&gt;tok = END;
	else if (letter(c)) {
		for (; letnum(c); c = *cp)
			cp++;
		if (c == '[') {
			int len;

			len = array_ref_len(cp);
			if (len == 0)
				evalerr(es, ET_STR, "missing ]");
			cp += len;
		}
#ifdef KSH
		else if (c == '(' /*)*/ ) {
		    /* todo: add math functions (all take single argument):
		     * abs acos asin atan cos cosh exp int log sin sinh sqrt
		     * tan tanh
		     */
		    ;
		}
#endif /* KSH */
		if (es-&gt;noassign) {
			es-&gt;val = tempvar();
			es-&gt;val-&gt;flag |= EXPRLVALUE;
		} else {
			tvar = str_nsave(es-&gt;tokp, cp - es-&gt;tokp, ATEMP);
			es-&gt;val = global(tvar);
			afree(tvar, ATEMP);
		}
		es-&gt;tok = VAR;
	} else if (digit(c)) {
		for (; c != '_' &amp;&amp; (letnum(c) || c == '#'); c = *cp++)
			;
		tvar = str_nsave(es-&gt;tokp, --cp - es-&gt;tokp, ATEMP);
		es-&gt;val = tempvar();
		es-&gt;val-&gt;flag &amp;= ~INTEGER;
		es-&gt;val-&gt;type = 0;
		es-&gt;val-&gt;val.s = tvar;
		if (setint_v(es-&gt;val, es-&gt;val) == NULL)
			evalerr(es, ET_BADLIT, tvar);
		afree(tvar, ATEMP);
		es-&gt;tok = LIT;
	} else {
		int i, n0;

		for (i = 0; (n0 = opinfo[i].name[0]); i++)
			if (c == n0
			    &amp;&amp; strncmp(cp, opinfo[i].name, opinfo[i].len) == 0)
			{
				es-&gt;tok = (enum token) i;
				cp += opinfo[i].len;
				break;
			}
		if (!n0)
			es-&gt;tok = BAD;
	}
	es-&gt;tokp = cp;
}

/* Do a ++ or -- operation */
static struct tbl *
do_ppmm(es, op, vasn, is_prefix)
	Expr_state *es;
	enum token op;
	struct tbl *vasn;
	bool_t is_prefix;
{
	struct tbl *vl;
	int oval;

	assign_check(es, op, vasn);

	vl = intvar(es, vasn);
	oval = op == O_PLUSPLUS ? vl-&gt;val.i++ : vl-&gt;val.i--;
	if (vasn-&gt;flag &amp; INTEGER)
		setint_v(vasn, vl);
	else
		setint(vasn, vl-&gt;val.i);
	if (!is_prefix)		/* undo the inc/dec */
		vl-&gt;val.i = oval;

	return vl;
}

static void
assign_check(es, op, vasn)
	Expr_state *es;
	enum token op;
	struct tbl *vasn;
{
	if (vasn-&gt;name[0] == '\0' &amp;&amp; !(vasn-&gt;flag &amp; EXPRLVALUE))
		evalerr(es, ET_LVALUE, opinfo[(int) op].name);
	else if (vasn-&gt;flag &amp; RDONLY)
		evalerr(es, ET_RDONLY, opinfo[(int) op].name);
}

static struct tbl *
tempvar()
{
	register struct tbl *vp;

	vp = (struct tbl*) alloc(sizeof(struct tbl), ATEMP);
	vp-&gt;flag = ISSET|INTEGER;
	vp-&gt;type = 0;
	vp-&gt;areap = ATEMP;
	vp-&gt;val.i = 0;
	vp-&gt;name[0] = '\0';
	return vp;
}

/* cast (string) variable to temporary integer variable */
static struct tbl *
intvar(es, vp)
	Expr_state *es;
	struct tbl *vp;
{
	struct tbl *vq;

	/* try to avoid replacing a temp var with another temp var */
	if (vp-&gt;name[0] == '\0'
	    &amp;&amp; (vp-&gt;flag &amp; (ISSET|INTEGER|EXPRLVALUE)) == (ISSET|INTEGER))
		return vp;

	vq = tempvar();
	if (setint_v(vq, vp) == NULL) {
		if (vp-&gt;flag &amp; EXPRINEVAL)
			evalerr(es, ET_RECURSIVE, vp-&gt;name);
		es-&gt;evaling = vp;
		vp-&gt;flag |= EXPRINEVAL;
		v_evaluate(vq, str_val(vp), KSH_UNWIND_ERROR);
		vp-&gt;flag &amp;= ~EXPRINEVAL;
		es-&gt;evaling = (struct tbl *) 0;
	}
	return vq;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

