<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/shf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/shf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  Shell file I/O routines
 */

#include "sh.h"
#include "ksh_stat.h"
#include "ksh_limval.h"


/* flags to shf_emptybuf() */
#define EB_READSW	0x01	/* about to switch to reading */
#define EB_GROW		0x02	/* grow buffer if necessary (STRING+DYNAMIC) */

/*
 * Replacement stdio routines.  Stdio is too flakey on too many machines
 * to be useful when you have multiple processes using the same underlying
 * file descriptors.
 */

static int	shf_fillbuf	ARGS((struct shf *shf));
static int	shf_emptybuf	ARGS((struct shf *shf, int flags));

/* Open a file.  First three args are for open(), last arg is flags for
 * this package.  Returns NULL if file could not be opened, or if a dup
 * fails.
 */
struct shf *
shf_open(name, oflags, mode, sflags)
	const char *name;
	int oflags;
	int mode;
	int sflags;
{
	struct shf *shf;
	int bsize = sflags &amp; SHF_UNBUF ? (sflags &amp; SHF_RD ? 1 : 0) : SHF_BSIZE;
	int fd;

	/* Done before open so if alloca fails, fd won't be lost. */
	shf = (struct shf *) alloc(sizeof(struct shf) + bsize, ATEMP);
	shf-&gt;areap = ATEMP;
	shf-&gt;buf = (unsigned char *) &amp;shf[1];
	shf-&gt;bsize = bsize;
	shf-&gt;flags = SHF_ALLOCS;
	/* Rest filled in by reopen. */

	fd = open(name, oflags, mode);
	if (fd &lt; 0) {
		afree(shf, shf-&gt;areap);
		return NULL;
	}
	if ((sflags &amp; SHF_MAPHI) &amp;&amp; fd &lt; FDBASE) {
		int nfd;

		nfd = ksh_dupbase(fd, FDBASE);
		close(fd);
		if (nfd &lt; 0) {
			afree(shf, shf-&gt;areap);
			return NULL;
		}
		fd = nfd;
	}
	sflags &amp;= ~SHF_ACCMODE;
	sflags |= (oflags &amp; O_ACCMODE) == O_RDONLY ? SHF_RD
		  : ((oflags &amp; O_ACCMODE) == O_WRONLY ? SHF_WR
		     : SHF_RDWR);

	return shf_reopen(fd, sflags, shf);
}

/* Set up the shf structure for a file descriptor.  Doesn't fail. */
struct shf *
shf_fdopen(fd, sflags, shf)
	int fd;
	int sflags;
	struct shf *shf;
{
	int bsize = sflags &amp; SHF_UNBUF ? (sflags &amp; SHF_RD ? 1 : 0) : SHF_BSIZE;

	/* use fcntl() to figure out correct read/write flags */
	if (sflags &amp; SHF_GETFL) {
		int flags = fcntl(fd, F_GETFL, 0);

		if (flags &lt; 0)
			/* will get an error on first read/write */
			sflags |= SHF_RDWR;
		else
			switch (flags &amp; O_ACCMODE) {
			case O_RDONLY: sflags |= SHF_RD; break;
			case O_WRONLY: sflags |= SHF_WR; break;
			case O_RDWR: sflags |= SHF_RDWR; break;
			}
	}

	if (!(sflags &amp; (SHF_RD | SHF_WR)))
		internal_errorf(1, "shf_fdopen: missing read/write");

	if (shf) {
		if (bsize) {
			shf-&gt;buf = (unsigned char *) alloc(bsize, ATEMP);
			sflags |= SHF_ALLOCB;
		} else
			shf-&gt;buf = (unsigned char *) 0;
	} else {
		shf = (struct shf *) alloc(sizeof(struct shf) + bsize, ATEMP);
		shf-&gt;buf = (unsigned char *) &amp;shf[1];
		sflags |= SHF_ALLOCS;
	}
	shf-&gt;areap = ATEMP;
	shf-&gt;fd = fd;
	shf-&gt;rp = shf-&gt;wp = shf-&gt;buf;
	shf-&gt;rnleft = 0;
	shf-&gt;rbsize = bsize;
	shf-&gt;wnleft = 0; /* force call to shf_emptybuf() */
	shf-&gt;wbsize = sflags &amp; SHF_UNBUF ? 0 : bsize;
	shf-&gt;flags = sflags;
	shf-&gt;errno_ = 0;
	shf-&gt;bsize = bsize;
	if (sflags &amp; SHF_CLEXEC)
		fd_clexec(fd);
	return shf;
}

/* Set up an existing shf (and buffer) to use the given fd */
struct shf *
shf_reopen(fd, sflags, shf)
	int fd;
	int sflags;
	struct shf *shf;
{
	int bsize = sflags &amp; SHF_UNBUF ? (sflags &amp; SHF_RD ? 1 : 0) : SHF_BSIZE;

	/* use fcntl() to figure out correct read/write flags */
	if (sflags &amp; SHF_GETFL) {
		int flags = fcntl(fd, F_GETFL, 0);

		if (flags &lt; 0)
			/* will get an error on first read/write */
			sflags |= SHF_RDWR;
		else
			switch (flags &amp; O_ACCMODE) {
			case O_RDONLY: sflags |= SHF_RD; break;
			case O_WRONLY: sflags |= SHF_WR; break;
			case O_RDWR: sflags |= SHF_RDWR; break;
			}
	}

	if (!(sflags &amp; (SHF_RD | SHF_WR)))
		internal_errorf(1, "shf_reopen: missing read/write");
	if (!shf || !shf-&gt;buf || shf-&gt;bsize &lt; bsize)
		internal_errorf(1, "shf_reopen: bad shf/buf/bsize");

	/* assumes shf-&gt;buf and shf-&gt;bsize already set up */
	shf-&gt;fd = fd;
	shf-&gt;rp = shf-&gt;wp = shf-&gt;buf;
	shf-&gt;rnleft = 0;
	shf-&gt;rbsize = bsize;
	shf-&gt;wnleft = 0; /* force call to shf_emptybuf() */
	shf-&gt;wbsize = sflags &amp; SHF_UNBUF ? 0 : bsize;
	shf-&gt;flags = (shf-&gt;flags &amp; (SHF_ALLOCS | SHF_ALLOCB)) | sflags;
	shf-&gt;errno_ = 0;
	if (sflags &amp; SHF_CLEXEC)
		fd_clexec(fd);
	return shf;
}

/* Open a string for reading or writing.  If reading, bsize is the number
 * of bytes that can be read.  If writing, bsize is the maximum number of
 * bytes that can be written.  If shf is not null, it is filled in and
 * returned, if it is null, shf is allocated.  If writing and buf is null
 * and SHF_DYNAMIC is set, the buffer is allocated (if bsize &gt; 0, it is
 * used for the initial size).  Doesn't fail.
 * When writing, a byte is reserved for a trailing null - see shf_sclose().
 */
struct shf *
shf_sopen(buf, bsize, sflags, shf)
	char *buf;
	int bsize;
	int sflags;
	struct shf *shf;
{
	/* can't have a read+write string */
	if (!(sflags &amp; (SHF_RD | SHF_WR))
	    || (sflags &amp; (SHF_RD | SHF_WR)) == (SHF_RD | SHF_WR))
		internal_errorf(1, "shf_sopen: flags 0x%x", sflags);

	if (!shf) {
		shf = (struct shf *) alloc(sizeof(struct shf), ATEMP);
		sflags |= SHF_ALLOCS;
	}
	shf-&gt;areap = ATEMP;
	if (!buf &amp;&amp; (sflags &amp; SHF_WR) &amp;&amp; (sflags &amp; SHF_DYNAMIC)) {
		if (bsize &lt;= 0)
			bsize = 64;
		sflags |= SHF_ALLOCB;
		buf = alloc(bsize, shf-&gt;areap);
	}
	shf-&gt;fd = -1;
	shf-&gt;buf = shf-&gt;rp = shf-&gt;wp = (unsigned char *) buf;
	shf-&gt;rnleft = bsize;
	shf-&gt;rbsize = bsize;
	shf-&gt;wnleft = bsize - 1;	/* space for a '\0' */
	shf-&gt;wbsize = bsize;
	shf-&gt;flags = sflags | SHF_STRING;
	shf-&gt;errno_ = 0;
	shf-&gt;bsize = bsize;

	return shf;
}

/* Flush and close file descriptor, free the shf structure */
int
shf_close(shf)
	struct shf *shf;
{
	int ret = 0;

	if (shf-&gt;fd &gt;= 0) {
		ret = shf_flush(shf);
		if (close(shf-&gt;fd) &lt; 0)
			ret = EOF;
	}
	if (shf-&gt;flags &amp; SHF_ALLOCS)
		afree(shf, shf-&gt;areap);
	else if (shf-&gt;flags &amp; SHF_ALLOCB)
		afree(shf-&gt;buf, shf-&gt;areap);

	return ret;
}

/* Flush and close file descriptor, don't free file structure */
int
shf_fdclose(shf)
	struct shf *shf;
{
	int ret = 0;

	if (shf-&gt;fd &gt;= 0) {
		ret = shf_flush(shf);
		if (close(shf-&gt;fd) &lt; 0)
			ret = EOF;
		shf-&gt;rnleft = 0;
		shf-&gt;rp = shf-&gt;buf;
		shf-&gt;wnleft = 0;
		shf-&gt;fd = -1;
	}

	return ret;
}

/* Close a string - if it was opened for writing, it is null terminated;
 * returns a pointer to the string and frees shf if it was allocated
 * (does not free string if it was allocated).
 */
char *
shf_sclose(shf)
	struct shf *shf;
{
	unsigned char *s = shf-&gt;buf;

	/* null terminate */
	if (shf-&gt;flags &amp; SHF_WR) {
		shf-&gt;wnleft++;
		shf_putc('\0', shf);
	}
	if (shf-&gt;flags &amp; SHF_ALLOCS)
		afree(shf, shf-&gt;areap);
	return (char *) s;
}

/* Flush and free file structure, don't close file descriptor */
int
shf_finish(shf)
	struct shf *shf;
{
	int ret = 0;

	if (shf-&gt;fd &gt;= 0)
		ret = shf_flush(shf);
	if (shf-&gt;flags &amp; SHF_ALLOCS)
		afree(shf, shf-&gt;areap);
	else if (shf-&gt;flags &amp; SHF_ALLOCB)
		afree(shf-&gt;buf, shf-&gt;areap);

	return ret;
}

/* Un-read what has been read but not examined, or write what has been
 * buffered.  Returns 0 for success, EOF for (write) error.
 */
int
shf_flush(shf)
	struct shf *shf;
{
	if (shf-&gt;flags &amp; SHF_STRING)
		return (shf-&gt;flags &amp; SHF_WR) ? EOF : 0;

	if (shf-&gt;fd &lt; 0)
		internal_errorf(1, "shf_flush: no fd");

	if (shf-&gt;flags &amp; SHF_ERROR) {
		errno = shf-&gt;errno_;
		return EOF;
	}

	if (shf-&gt;flags &amp; SHF_READING) {
		shf-&gt;flags &amp;= ~(SHF_EOF | SHF_READING);
		if (shf-&gt;rnleft &gt; 0) {
			lseek(shf-&gt;fd, (off_t) -shf-&gt;rnleft, 1);
			shf-&gt;rnleft = 0;
			shf-&gt;rp = shf-&gt;buf;
		}
		return 0;
	} else if (shf-&gt;flags &amp; SHF_WRITING)
		return shf_emptybuf(shf, 0);

	return 0;
}

/* Write out any buffered data.  If currently reading, flushes the read
 * buffer.  Returns 0 for success, EOF for (write) error.
 */
static int
shf_emptybuf(shf, flags)
	struct shf *shf;
	int flags;
{
	int ret = 0;

	if (!(shf-&gt;flags &amp; SHF_STRING) &amp;&amp; shf-&gt;fd &lt; 0)
		internal_errorf(1, "shf_emptybuf: no fd");

	if (shf-&gt;flags &amp; SHF_ERROR) {
		errno = shf-&gt;errno_;
		return EOF;
	}

	if (shf-&gt;flags &amp; SHF_READING) {
		if (flags &amp; EB_READSW) /* doesn't happen */
			return 0;
		ret = shf_flush(shf);
		shf-&gt;flags &amp;= ~SHF_READING;
	}
	if (shf-&gt;flags &amp; SHF_STRING) {
		unsigned char	*nbuf;

		/* Note that we assume SHF_ALLOCS is not set if SHF_ALLOCB
		 * is set... (changing the shf pointer could cause problems)
		 */
		if (!(flags &amp; EB_GROW) || !(shf-&gt;flags &amp; SHF_DYNAMIC)
		    || !(shf-&gt;flags &amp; SHF_ALLOCB))
			return EOF;
		/* allocate more space for buffer */
		nbuf = (unsigned char *) aresize(shf-&gt;buf, shf-&gt;wbsize * 2,
						shf-&gt;areap);
		shf-&gt;rp = nbuf + (shf-&gt;rp - shf-&gt;buf);
		shf-&gt;wp = nbuf + (shf-&gt;wp - shf-&gt;buf);
		shf-&gt;rbsize += shf-&gt;wbsize;
		shf-&gt;wbsize += shf-&gt;wbsize;
		shf-&gt;wnleft += shf-&gt;wbsize;
		shf-&gt;wbsize *= 2;
		shf-&gt;buf = nbuf;
	} else {
		if (shf-&gt;flags &amp; SHF_WRITING) {
			int ntowrite = shf-&gt;wp - shf-&gt;buf;
			unsigned char *buf = shf-&gt;buf;
			int n;

			while (ntowrite &gt; 0) {
				n = write(shf-&gt;fd, buf, ntowrite);
				if (n &lt; 0) {
					if (errno == EINTR
					    &amp;&amp; !(shf-&gt;flags &amp; SHF_INTERRUPT))
						continue;
					shf-&gt;flags |= SHF_ERROR;
					shf-&gt;errno_ = errno;
					shf-&gt;wnleft = 0;
					if (buf != shf-&gt;buf) {
						/* allow a second flush
						 * to work */
						memmove(shf-&gt;buf, buf,
							ntowrite);
						shf-&gt;wp = shf-&gt;buf + ntowrite;
					}
					return EOF;
				}
				buf += n;
				ntowrite -= n;
			}
			if (flags &amp; EB_READSW) {
				shf-&gt;wp = shf-&gt;buf;
				shf-&gt;wnleft = 0;
				shf-&gt;flags &amp;= ~SHF_WRITING;
				return 0;
			}
		}
		shf-&gt;wp = shf-&gt;buf;
		shf-&gt;wnleft = shf-&gt;wbsize;
	}
	shf-&gt;flags |= SHF_WRITING;

	return ret;
}

/* Fill up a read buffer.  Returns EOF for a read error, 0 otherwise. */
static int
shf_fillbuf(shf)
	struct shf *shf;
{
	if (shf-&gt;flags &amp; SHF_STRING)
		return 0;

	if (shf-&gt;fd &lt; 0)
		internal_errorf(1, "shf_fillbuf: no fd");

	if (shf-&gt;flags &amp; (SHF_EOF | SHF_ERROR)) {
		if (shf-&gt;flags &amp; SHF_ERROR)
			errno = shf-&gt;errno_;
		return EOF;
	}

	if ((shf-&gt;flags &amp; SHF_WRITING) &amp;&amp; shf_emptybuf(shf, EB_READSW) == EOF)
		return EOF;

	shf-&gt;flags |= SHF_READING;

	shf-&gt;rp = shf-&gt;buf;
	while (1) {
		shf-&gt;rnleft = blocking_read(shf-&gt;fd, (char *) shf-&gt;buf,
					    shf-&gt;rbsize);
		if (shf-&gt;rnleft &lt; 0 &amp;&amp; errno == EINTR
		    &amp;&amp; !(shf-&gt;flags &amp; SHF_INTERRUPT))
			continue;
		break;
	}
	if (shf-&gt;rnleft &lt;= 0) {
		if (shf-&gt;rnleft &lt; 0) {
			shf-&gt;flags |= SHF_ERROR;
			shf-&gt;errno_ = errno;
			shf-&gt;rnleft = 0;
			shf-&gt;rp = shf-&gt;buf;
			return EOF;
		}
		shf-&gt;flags |= SHF_EOF;
	}
	return 0;
}

/* Seek to a new position in the file.  If writing, flushes the buffer
 * first.  If reading, optimizes small relative seeks that stay inside the
 * buffer.  Returns 0 for success, EOF otherwise.
 */
int
shf_seek(shf, where, from)
	struct shf *shf;
	off_t where;
	int from;
{
	if (shf-&gt;fd &lt; 0) {
		errno = EINVAL;
		return EOF;
	}

	if (shf-&gt;flags &amp; SHF_ERROR) {
		errno = shf-&gt;errno_;
		return EOF;
	}

	if ((shf-&gt;flags &amp; SHF_WRITING) &amp;&amp; shf_emptybuf(shf, EB_READSW) == EOF)
		return EOF;

	if (shf-&gt;flags &amp; SHF_READING) {
		if (from == SEEK_CUR &amp;&amp;
				(where &lt; 0 ?
					-where &gt;= shf-&gt;rbsize - shf-&gt;rnleft :
					where &lt; shf-&gt;rnleft)) {
			shf-&gt;rnleft -= where;
			shf-&gt;rp += where;
			return 0;
		}
		shf-&gt;rnleft = 0;
		shf-&gt;rp = shf-&gt;buf;
	}

	shf-&gt;flags &amp;= ~(SHF_EOF | SHF_READING | SHF_WRITING);

	if (lseek(shf-&gt;fd, where, from) &lt; 0) {
		shf-&gt;errno_ = errno;
		shf-&gt;flags |= SHF_ERROR;
		return EOF;
	}

	return 0;
}


/* Read a buffer from shf.  Returns the number of bytes read into buf,
 * if no bytes were read, returns 0 if end of file was seen, EOF if
 * a read error occurred.
 */
int
shf_read(buf, bsize, shf)
	char *buf;
	int bsize;
	struct shf *shf;
{
	int orig_bsize = bsize;
	int ncopy;

	if (!(shf-&gt;flags &amp; SHF_RD))
		internal_errorf(1, "shf_read: flags %x", shf-&gt;flags);

	if (bsize &lt;= 0)
		internal_errorf(1, "shf_read: bsize %d", bsize);

	while (bsize &gt; 0) {
		if (shf-&gt;rnleft == 0
		    &amp;&amp; (shf_fillbuf(shf) == EOF || shf-&gt;rnleft == 0))
			break;
		ncopy = shf-&gt;rnleft;
		if (ncopy &gt; bsize)
			ncopy = bsize;
		memcpy(buf, shf-&gt;rp, ncopy);
		buf += ncopy;
		bsize -= ncopy;
		shf-&gt;rp += ncopy;
		shf-&gt;rnleft -= ncopy;
	}
	/* Note: fread(3S) returns 0 for errors - this doesn't */
	return orig_bsize == bsize ? (shf_error(shf) ? EOF : 0)
				   : orig_bsize - bsize;
}

/* Read up to a newline or EOF.  The newline is put in buf; buf is always
 * null terminated.  Returns NULL on read error or if nothing was read before
 * end of file, returns a pointer to the null byte in buf otherwise.
 */
char *
shf_getse(buf, bsize, shf)
	char *buf;
	int bsize;
	struct shf *shf;
{
	unsigned char *end;
	int ncopy;
	char *orig_buf = buf;

	if (!(shf-&gt;flags &amp; SHF_RD))
		internal_errorf(1, "shf_getse: flags %x", shf-&gt;flags);

	if (bsize &lt;= 0)
		return (char *) 0;

	--bsize;	/* save room for null */
	do {
		if (shf-&gt;rnleft == 0) {
			if (shf_fillbuf(shf) == EOF)
				return NULL;
			if (shf-&gt;rnleft == 0) {
				*buf = '\0';
				return buf == orig_buf ? NULL : buf;
			}
		}
		end = (unsigned char *) memchr((char *) shf-&gt;rp, '\n',
					     shf-&gt;rnleft);
		ncopy = end ? end - shf-&gt;rp + 1 : shf-&gt;rnleft;
		if (ncopy &gt; bsize)
			ncopy = bsize;
		memcpy(buf, (char *) shf-&gt;rp, ncopy);
		shf-&gt;rp += ncopy;
		shf-&gt;rnleft -= ncopy;
		buf += ncopy;
		bsize -= ncopy;
#ifdef OS2
		if (end &amp;&amp; buf &gt; orig_buf + 1 &amp;&amp; buf[-2] == '\r') {
			buf--;
			bsize++;
			buf[-1] = '\n';
		}
#endif

	} while (!end &amp;&amp; bsize);
	*buf = '\0';
	return buf;
}

/* Returns the char read.  Returns EOF for error and end of file. */
int
shf_getchar(shf)
	struct shf *shf;
{
	if (!(shf-&gt;flags &amp; SHF_RD))
		internal_errorf(1, "shf_getchar: flags %x", shf-&gt;flags);

	if (shf-&gt;rnleft == 0 &amp;&amp; (shf_fillbuf(shf) == EOF || shf-&gt;rnleft == 0))
		return EOF;
	--shf-&gt;rnleft;
	return *shf-&gt;rp++;
}

/* Put a character back in the input stream.  Returns the character if
 * successful, EOF if there is no room.
 */
int
shf_ungetc(c, shf)
	int c;
	struct shf *shf;
{
	if (!(shf-&gt;flags &amp; SHF_RD))
		internal_errorf(1, "shf_ungetc: flags %x", shf-&gt;flags);

	if ((shf-&gt;flags &amp; SHF_ERROR) || c == EOF
	    || (shf-&gt;rp == shf-&gt;buf &amp;&amp; shf-&gt;rnleft))
		return EOF;

	if ((shf-&gt;flags &amp; SHF_WRITING) &amp;&amp; shf_emptybuf(shf, EB_READSW) == EOF)
		return EOF;

	if (shf-&gt;rp == shf-&gt;buf)
		shf-&gt;rp = shf-&gt;buf + shf-&gt;rbsize;
	if (shf-&gt;flags &amp; SHF_STRING) {
		/* Can unget what was read, but not something different - we
		 * don't want to modify a string.
		 */
		if (shf-&gt;rp[-1] != c)
			return EOF;
		shf-&gt;flags &amp;= ~SHF_EOF;
		shf-&gt;rp--;
		shf-&gt;rnleft++;
		return c;
	}
	shf-&gt;flags &amp;= ~SHF_EOF;
	*--(shf-&gt;rp) = c;
	shf-&gt;rnleft++;
	return c;
}

/* Write a character.  Returns the character if successful, EOF if
 * the char could not be written.
 */
int
shf_putchar(c, shf)
	int c;
	struct shf *shf;
{
	if (!(shf-&gt;flags &amp; SHF_WR))
		internal_errorf(1, "shf_putchar: flags %x", shf-&gt;flags);

	if (c == EOF)
		return EOF;

	if (shf-&gt;flags &amp; SHF_UNBUF) {
		char cc = c;
		int n;

		if (shf-&gt;fd &lt; 0)
			internal_errorf(1, "shf_putchar: no fd");
		if (shf-&gt;flags &amp; SHF_ERROR) {
			errno = shf-&gt;errno_;
			return EOF;
		}
		while ((n = write(shf-&gt;fd, &amp;cc, 1)) != 1)
			if (n &lt; 0) {
				if (errno == EINTR
				    &amp;&amp; !(shf-&gt;flags &amp; SHF_INTERRUPT))
					continue;
				shf-&gt;flags |= SHF_ERROR;
				shf-&gt;errno_ = errno;
				return EOF;
			}
	} else {
		/* Flush deals with strings and sticky errors */
		if (shf-&gt;wnleft == 0 &amp;&amp; shf_emptybuf(shf, EB_GROW) == EOF)
			return EOF;
		shf-&gt;wnleft--;
		*shf-&gt;wp++ = c;
	}

	return c;
}

/* Write a string.  Returns the length of the string if successful, EOF if
 * the string could not be written.
 */
int
shf_puts(s, shf)
	const char *s;
	struct shf *shf;
{
	if (!s)
		return EOF;

	return shf_write(s, strlen(s), shf);
}

/* Write a buffer.  Returns nbytes if successful, EOF if there is an error. */
int
shf_write(buf, nbytes, shf)
	const char *buf;
	int nbytes;
	struct shf *shf;
{
	int orig_nbytes = nbytes;
	int n;
	int ncopy;

	if (!(shf-&gt;flags &amp; SHF_WR))
		internal_errorf(1, "shf_write: flags %x", shf-&gt;flags);

	if (nbytes &lt; 0)
		internal_errorf(1, "shf_write: nbytes %d", nbytes);

	/* Don't buffer if buffer is empty and we're writting a large amount. */
	if ((ncopy = shf-&gt;wnleft)
	    &amp;&amp; (shf-&gt;wp != shf-&gt;buf || nbytes &lt; shf-&gt;wnleft))
	{
		if (ncopy &gt; nbytes)
			ncopy = nbytes;
		memcpy(shf-&gt;wp, buf, ncopy);
		nbytes -= ncopy;
		buf += ncopy;
		shf-&gt;wp += ncopy;
		shf-&gt;wnleft -= ncopy;
	}
	if (nbytes &gt; 0) {
		/* Flush deals with strings and sticky errors */
		if (shf_emptybuf(shf, EB_GROW) == EOF)
			return EOF;
		if (nbytes &gt; shf-&gt;wbsize) {
			ncopy = nbytes;
			if (shf-&gt;wbsize)
				ncopy -= nbytes % shf-&gt;wbsize;
			nbytes -= ncopy;
			while (ncopy &gt; 0) {
				n = write(shf-&gt;fd, buf, ncopy);
				if (n &lt; 0) {
					if (errno == EINTR
					    &amp;&amp; !(shf-&gt;flags &amp; SHF_INTERRUPT))
						continue;
					shf-&gt;flags |= SHF_ERROR;
					shf-&gt;errno_ = errno;
					shf-&gt;wnleft = 0;
					/* Note: fwrite(3S) returns 0 for
					 * errors - this doesn't */
					return EOF;
				}
				buf += n;
				ncopy -= n;
			}
		}
		if (nbytes &gt; 0) {
			memcpy(shf-&gt;wp, buf, nbytes);
			shf-&gt;wp += nbytes;
			shf-&gt;wnleft -= nbytes;
		}
	}

	return orig_nbytes;
}

int
#ifdef HAVE_PROTOTYPES
shf_fprintf(struct shf *shf, const char *fmt, ...)
#else
shf_fprintf(shf, fmt, va_alist)
	struct shf *shf;
	const char *fmt;
	va_dcl
#endif
{
	va_list args;
	int n;

	SH_VA_START(args, fmt);
	n = shf_vfprintf(shf, fmt, args);
	va_end(args);

	return n;
}

int
#ifdef HAVE_PROTOTYPES
shf_snprintf(char *buf, int bsize, const char *fmt, ...)
#else
shf_snprintf(buf, bsize, fmt, va_alist)
	char *buf;
	int bsize;
	const char *fmt;
	va_dcl
#endif
{
	struct shf shf;
	va_list args;
	int n;

	if (!buf || bsize &lt;= 0)
		internal_errorf(1, "shf_snprintf: buf %lx, bsize %d",
			(long) buf, bsize);

	shf_sopen(buf, bsize, SHF_WR, &amp;shf);
	SH_VA_START(args, fmt);
	n = shf_vfprintf(&amp;shf, fmt, args);
	va_end(args);
	shf_sclose(&amp;shf); /* null terminates */
	return n;
}

char *
#ifdef HAVE_PROTOTYPES
shf_smprintf(const char *fmt, ...)
#else
shf_smprintf(fmt, va_alist)
	char *fmt;
	va_dcl
#endif
{
	struct shf shf;
	va_list args;

	shf_sopen((char *) 0, 0, SHF_WR|SHF_DYNAMIC, &amp;shf);
	SH_VA_START(args, fmt);
	shf_vfprintf(&amp;shf, fmt, args);
	va_end(args);
	return shf_sclose(&amp;shf); /* null terminates */
}

#undef FP  			/* if you want floating point stuff */

#define BUF_SIZE	128
#define FPBUF_SIZE	(DMAXEXP+16)/* this must be &gt;
				 *	MAX(DMAXEXP, log10(pow(2, DSIGNIF)))
				 *    + ceil(log10(DMAXEXP)) + 8 (I think).
				 * Since this is hard to express as a
				 * constant, just use a large buffer.
				 */

/*
 *	What kinda of machine we on?  Hopefully the C compiler will optimize
 *  this out...
 *
 *	For shorts, we want sign extend for %d but not for %[oxu] - on 16 bit
 *  machines it don't matter.  Assmumes C compiler has converted shorts to
 *  ints before pushing them.
 */
#define POP_INT(f, s, a) (((f) &amp; FL_LONG) ?				\
				va_arg((a), unsigned long)		\
			    :						\
				(sizeof(int) &lt; sizeof(long) ?		\
					((s) ?				\
						(long) va_arg((a), int)	\
					    :				\
						va_arg((a), unsigned))	\
				    :					\
					va_arg((a), unsigned)))

#define ABIGNUM		32000	/* big numer that will fit in a short */
#define LOG2_10		3.321928094887362347870319429	/* log base 2 of 10 */

#define	FL_HASH		0x001	/* `#' seen */
#define FL_PLUS		0x002	/* `+' seen */
#define FL_RIGHT	0x004	/* `-' seen */
#define FL_BLANK	0x008	/* ` ' seen */
#define FL_SHORT	0x010	/* `h' seen */
#define FL_LONG		0x020	/* `l' seen */
#define FL_ZERO		0x040	/* `0' seen */
#define FL_DOT		0x080	/* '.' seen */
#define FL_UPPER	0x100	/* format character was uppercase */
#define FL_NUMBER	0x200	/* a number was formated %[douxefg] */


#ifdef FP
#include &lt;math.h&gt;

static double
my_ceil(d)
	double	d;
{
	double		i;

	return d - modf(d, &amp;i) + (d &lt; 0 ? -1 : 1);
}
#endif /* FP */

int
shf_vfprintf(shf, fmt, args)
	struct shf *shf;
	const char *fmt;
	va_list args;
{
	char		c, *s;
	int		UNINITIALIZED(tmp);
	int		field, precision;
	int		len;
	int		flags;
	unsigned long	lnum;
					/* %#o produces the longest output */
	char		numbuf[(BITS(long) + 2) / 3 + 1];
	/* this stuff for dealing with the buffer */
	int		nwritten = 0;
#ifdef FP
	/* should be in &lt;math.h&gt;
	 *  extern double frexp();
	 */
	extern char *ecvt();

	double		fpnum;
	int		expo, decpt;
	char		style;
	char		fpbuf[FPBUF_SIZE];
#endif /* FP */

	if (!fmt)
		return 0;

	while ((c = *fmt++)) {
		if (c != '%') {
			shf_putc(c, shf);
			nwritten++;
			continue;
		}
		/*
		 *	This will accept flags/fields in any order - not
		 *  just the order specified in printf(3), but this is
		 *  the way _doprnt() seems to work (on bsd and sysV).
		 *  The only resriction is that the format character must
		 *  come last :-).
		 */
		flags = field = precision = 0;
		for ( ; (c = *fmt++) ; ) {
			switch (c) {
			case '#':
				flags |= FL_HASH;
				continue;

			case '+':
				flags |= FL_PLUS;
				continue;

			case '-':
				flags |= FL_RIGHT;
				continue;

			case ' ':
				flags |= FL_BLANK;
				continue;

			case '0':
				if (!(flags &amp; FL_DOT))
					flags |= FL_ZERO;
				continue;

			case '.':
				flags |= FL_DOT;
				precision = 0;
				continue;

			case '*':
				tmp = va_arg(args, int);
				if (flags &amp; FL_DOT)
					precision = tmp;
				else if ((field = tmp) &lt; 0) {
					field = -field;
					flags |= FL_RIGHT;
				}
				continue;

			case 'l':
				flags |= FL_LONG;
				continue;

			case 'h':
				flags |= FL_SHORT;
				continue;
			}
			if (digit(c)) {
				tmp = c - '0';
				while (c = *fmt++, digit(c))
					tmp = tmp * 10 + c - '0';
				--fmt;
				if (tmp &lt; 0)		/* overflow? */
					tmp = 0;
				if (flags &amp; FL_DOT)
					precision = tmp;
				else
					field = tmp;
				continue;
			}
			break;
		}

		if (precision &lt; 0)
			precision = 0;

		if (!c)		/* nasty format */
			break;

		if (c &gt;= 'A' &amp;&amp; c &lt;= 'Z') {
			flags |= FL_UPPER;
			c = c - 'A' + 'a';
		}

		switch (c) {
		case 'p': /* pointer */
			flags &amp;= ~(FL_LONG | FL_SHORT);
			if (sizeof(char *) &gt; sizeof(int))
				flags |= FL_LONG; /* hope it fits.. */
			/* aaahhh... */
		case 'd':
		case 'i':
		case 'o':
		case 'u':
		case 'x':
			flags |= FL_NUMBER;
			s = &amp;numbuf[sizeof(numbuf)];
			lnum = POP_INT(flags, c == 'd', args);
			switch (c) {
			case 'd':
			case 'i':
				if (0 &gt; (long) lnum)
					lnum = - (long) lnum, tmp = 1;
				else
					tmp = 0;
				/* aaahhhh..... */

			case 'u':
				do {
					*--s = lnum % 10 + '0';
					lnum /= 10;
				} while (lnum);

				if (c != 'u') {
					if (tmp)
						*--s = '-';
					else if (flags &amp; FL_PLUS)
						*--s = '+';
					else if (flags &amp; FL_BLANK)
						*--s = ' ';
				}
				break;

			case 'o':
				do {
					*--s = (lnum &amp; 0x7) + '0';
					lnum &gt;&gt;= 3;
				} while (lnum);

				if ((flags &amp; FL_HASH) &amp;&amp; *s != '0')
					*--s = '0';
				break;

			case 'p':
			case 'x':
			    {
				const char *digits = (flags &amp; FL_UPPER) ?
						  "0123456789ABCDEF"
						: "0123456789abcdef";
				do {
					*--s = digits[lnum &amp; 0xf];
					lnum &gt;&gt;= 4;
				} while (lnum);

				if (flags &amp; FL_HASH) {
					*--s = (flags &amp; FL_UPPER) ? 'X' : 'x';
					*--s = '0';
				}
			    }
			}
			len = &amp;numbuf[sizeof(numbuf)] - s;
			if (flags &amp; FL_DOT) {
				if (precision &gt; len) {
					field = precision;
					flags |= FL_ZERO;
				} else
					precision = len; /* no loss */
			}
			break;

#ifdef FP
		case 'e':
		case 'g':
		case 'f':
		    {
			char *p;

			/*
			 *	This could proabably be done better,
			 *  but it seems to work.  Note that gcvt()
			 *  is not used, as you cannot tell it to
			 *  not strip the zeros.
			 */
			flags |= FL_NUMBER;
			if (!(flags &amp; FL_DOT))
				precision = 6;	/* default */
			/*
			 *	Assumes doubles are pushed on
			 *  the stack.  If this is not so, then
			 *  FL_LONG/FL_SHORT should be checked.
			 */
			fpnum = va_arg(args, double);
			s = fpbuf;
			style = c;
			/*
			 *  This is the same as
			 *	expo = ceil(log10(fpnum))
			 *  but doesn't need -lm.  This is an
			 *  aproximation as expo is rounded up.
			 */
			(void) frexp(fpnum, &amp;expo);
			expo = my_ceil(expo / LOG2_10);

			if (expo &lt; 0)
				expo = 0;

			p = ecvt(fpnum, precision + 1 + expo,
				 &amp;decpt, &amp;tmp);
			if (c == 'g') {
				if (decpt &lt; -4 || decpt &gt; precision)
					style = 'e';
				else
					style = 'f';
				if (decpt &gt; 0 &amp;&amp; (precision -= decpt) &lt; 0)
					precision = 0;
			}
			if (tmp)
				*s++ = '-';
			else if (flags &amp; FL_PLUS)
				*s++ = '+';
			else if (flags &amp; FL_BLANK)
				*s++ = ' ';

			if (style == 'e')
				*s++ = *p++;
			else {
				if (decpt &gt; 0) {
					/* Overflow check - should
					 * never have this problem.
					 */
					if (decpt &gt;
						&amp;fpbuf[sizeof(fpbuf)]
							- s - 8)
						decpt =
						 &amp;fpbuf[sizeof(fpbuf)]
							- s - 8;
					(void) memcpy(s, p, decpt);
					s += decpt;
					p += decpt;
				} else
					*s++ = '0';
			}

			/* print the fraction? */
			if (precision &gt; 0) {
				*s++ = '.';
				/* Overflow check - should
				 * never have this problem.
				 */
				if (precision &gt; &amp;fpbuf[sizeof(fpbuf)]
							- s - 7)
					precision =
						&amp;fpbuf[sizeof(fpbuf)]
						- s - 7;
				for (tmp = decpt;  tmp++ &lt; 0 &amp;&amp;
					    precision &gt; 0 ; precision--)
					*s++ = '0';
				tmp = strlen(p);
				if (precision &gt; tmp)
					precision = tmp;
				/* Overflow check - should
				 * never have this problem.
				 */
				if (precision &gt; &amp;fpbuf[sizeof(fpbuf)]
							- s - 7)
					precision =
						&amp;fpbuf[sizeof(fpbuf)]
						- s - 7;
				(void) memcpy(s, p, precision);
				s += precision;
				/*
				 *	`g' format strips trailing
				 *  zeros after the decimal.
				 */
				if (c == 'g' &amp;&amp; !(flags &amp; FL_HASH)) {
					while (*--s == '0')
						;
					if (*s != '.')
						s++;
				}
			} else if (flags &amp; FL_HASH)
				*s++ = '.';

			if (style == 'e') {
				*s++ = (flags &amp; FL_UPPER) ? 'E' : 'e';
				if (--decpt &gt;= 0)
					*s++ = '+';
				else {
					*s++ = '-';
					decpt = -decpt;
				}
				p = &amp;numbuf[sizeof(numbuf)];
				for (tmp = 0; tmp &lt; 2 || decpt ; tmp++) {
					*--p = '0' + decpt % 10;
					decpt /= 10;
				}
				tmp = &amp;numbuf[sizeof(numbuf)] - p;
				(void) memcpy(s, p, tmp);
				s += tmp;
			}

			len = s - fpbuf;
			s = fpbuf;
			precision = len;
			break;
		    }
#endif /* FP */

		case 's':
			if (!(s = va_arg(args, char *)))
				s = "(null %s)";
			len = strlen(s);
			break;

		case 'c':
			flags &amp;= ~FL_DOT;
			numbuf[0] = va_arg(args, int);
			s = numbuf;
			len = 1;
			break;

		case '%':
		default:
			numbuf[0] = c;
			s = numbuf;
			len = 1;
			break;
		}

		/*
		 *	At this point s should point to a string that is
		 *  to be formatted, and len should be the length of the
		 *  string.
		 */
		if (!(flags &amp; FL_DOT) || len &lt; precision)
			precision = len;
		if (field &gt; precision) {
			field -= precision;
			if (!(flags &amp; FL_RIGHT)) {
				field = -field;
				/* skip past sign or 0x when padding with 0 */
				if ((flags &amp; FL_ZERO) &amp;&amp; (flags &amp; FL_NUMBER)) {
					if (*s == '+' || *s == '-' || *s ==' ')
					{
						shf_putc(*s, shf);
						s++;
						precision--;
						nwritten++;
					} else if (*s == '0') {
						shf_putc(*s, shf);
						s++;
						nwritten++;
						if (--precision &gt; 0 &amp;&amp;
							(*s | 0x20) == 'x')
						{
							shf_putc(*s, shf);
							s++;
							precision--;
							nwritten++;
						}
					}
					c = '0';
				} else
					c = flags &amp; FL_ZERO ? '0' : ' ';
				if (field &lt; 0) {
					nwritten += -field;
					for ( ; field &lt; 0 ; field++)
						shf_putc(c, shf);
				}
			} else
				c = ' ';
		} else
			field = 0;

		if (precision &gt; 0) {
			nwritten += precision;
			for ( ; precision-- &gt; 0 ; s++)
				shf_putc(*s, shf);
		}
		if (field &gt; 0) {
			nwritten += field;
			for ( ; field &gt; 0 ; --field)
				shf_putc(c, shf);
		}
	}

	return shf_error(shf) ? EOF : nwritten;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

