<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/table.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/table.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * dynamic hashed associative table for commands and variables
 */

#include "sh.h"

#define	INIT_TBLS	8	/* initial table size (power of 2) */

static void     texpand     ARGS((struct table *tp, int nsize));
static int      tnamecmp    ARGS((void *p1, void *p2));


unsigned int
hash(n)
	register const char * n;
{
	register unsigned int h = 0;

	while (*n != '\0')
		h = 2*h + *n++;
	return h * 32821;	/* scatter bits */
}

void
tinit(tp, ap, tsize)
	register struct table *tp;
	register Area *ap;
	int tsize;
{
	tp-&gt;areap = ap;
	tp-&gt;tbls = NULL;
	tp-&gt;size = tp-&gt;nfree = 0;
	if (tsize)
		texpand(tp, tsize);
}

static void
texpand(tp, nsize)
	register struct table *tp;
	int nsize;
{
	register int i;
	register struct tbl *tblp, **p;
	register struct tbl **ntblp, **otblp = tp-&gt;tbls;
	int osize = tp-&gt;size;

	ntblp = (struct tbl**) alloc(sizeofN(struct tbl *, nsize), tp-&gt;areap);
	for (i = 0; i &lt; nsize; i++)
		ntblp[i] = NULL;
	tp-&gt;size = nsize;
	tp-&gt;nfree = 8*nsize/10;	/* table can get 80% full */
	tp-&gt;tbls = ntblp;
	if (otblp == NULL)
		return;
	for (i = 0; i &lt; osize; i++)
		if ((tblp = otblp[i]) != NULL)
			if ((tblp-&gt;flag&amp;DEFINED)) {
				for (p = &amp;ntblp[hash(tblp-&gt;name)
					  &amp; (tp-&gt;size-1)];
				     *p != NULL; p--)
					if (p == ntblp) /* wrap */
						p += tp-&gt;size;
				*p = tblp;
				tp-&gt;nfree--;
			} else if (!(tblp-&gt;flag &amp; FINUSE)) {
				afree((void*)tblp, tp-&gt;areap);
			}
	afree((void*)otblp, tp-&gt;areap);
}

struct tbl *
tsearch(tp, n, h)
	register struct table *tp;	/* table */
	register const char *n;		/* name to enter */
	unsigned int h;			/* hash(n) */
{
	register struct tbl **pp, *p;

	if (tp-&gt;size == 0)
		return NULL;

	/* search for name in hashed table */
	for (pp = &amp;tp-&gt;tbls[h &amp; (tp-&gt;size-1)]; (p = *pp) != NULL; pp--) {
		if (*p-&gt;name == *n &amp;&amp; strcmp(p-&gt;name, n) == 0
		    &amp;&amp; (p-&gt;flag&amp;DEFINED))
			return p;
		if (pp == tp-&gt;tbls) /* wrap */
			pp += tp-&gt;size;
	}

	return NULL;
}

struct tbl *
tenter(tp, n, h)
	register struct table *tp;	/* table */
	register const char *n;		/* name to enter */
	unsigned int h;			/* hash(n) */
{
	register struct tbl **pp, *p;
	register int len;

	if (tp-&gt;size == 0)
		texpand(tp, INIT_TBLS);
  Search:
	/* search for name in hashed table */
	for (pp = &amp;tp-&gt;tbls[h &amp; (tp-&gt;size-1)]; (p = *pp) != NULL; pp--) {
		if (*p-&gt;name == *n &amp;&amp; strcmp(p-&gt;name, n) == 0)
			return p; 	/* found */
		if (pp == tp-&gt;tbls) /* wrap */
			pp += tp-&gt;size;
	}

	if (tp-&gt;nfree &lt;= 0) {	/* too full */
		texpand(tp, 2*tp-&gt;size);
		goto Search;
	}

	/* create new tbl entry */
	len = strlen(n) + 1;
	p = (struct tbl *) alloc(offsetof(struct tbl, name[0]) + len,
				 tp-&gt;areap);
	p-&gt;flag = 0;
	p-&gt;type = 0;
	p-&gt;areap = tp-&gt;areap;
	p-&gt;u2.field = 0;
	p-&gt;u.array = (struct tbl *)0;
	memcpy(p-&gt;name, n, len);

	/* enter in tp-&gt;tbls */
	tp-&gt;nfree--;
	*pp = p;
	return p;
}

void
tdelete(p)
	register struct tbl *p;
{
	p-&gt;flag = 0;
}

void
twalk(ts, tp)
	struct tstate *ts;
	struct table *tp;
{
	ts-&gt;left = tp-&gt;size;
	ts-&gt;next = tp-&gt;tbls;
}

struct tbl *
tnext(ts)
	struct tstate *ts;
{
	while (--ts-&gt;left &gt;= 0) {
		struct tbl *p = *ts-&gt;next++;
		if (p != NULL &amp;&amp; (p-&gt;flag&amp;DEFINED))
			return p;
	}
	return NULL;
}

static int
tnamecmp(p1, p2)
	void *p1, *p2;
{
	return strcmp(((struct tbl *)p1)-&gt;name, ((struct tbl *)p2)-&gt;name);
}

struct tbl **
tsort(tp)
	register struct table *tp;
{
	register int i;
	register struct tbl **p, **sp, **dp;

	p = (struct tbl **)alloc(sizeofN(struct tbl *, tp-&gt;size+1), ATEMP);
	sp = tp-&gt;tbls;		/* source */
	dp = p;			/* dest */
	for (i = 0; i &lt; tp-&gt;size; i++)
		if ((*dp = *sp++) != NULL &amp;&amp; (((*dp)-&gt;flag&amp;DEFINED) ||
					      ((*dp)-&gt;flag&amp;ARRAY)))
			dp++;
	i = dp - p;
	qsortp((void**)p, (size_t)i, tnamecmp);
	p[i] = NULL;
	return p;
}

#ifdef PERF_DEBUG /* performance debugging */

void tprintinfo ARGS((struct table *tp));

void
tprintinfo(tp)
	struct table *tp;
{
	struct tbl *te;
	char *n;
	unsigned int h;
	int ncmp;
	int totncmp = 0, maxncmp = 0;
	int nentries = 0;
	struct tstate ts;

	shellf("table size %d, nfree %d\n", tp-&gt;size, tp-&gt;nfree);
	shellf("    Ncmp name\n");
	twalk(&amp;ts, tp);
	while ((te = tnext(&amp;ts))) {
		register struct tbl **pp, *p;

		h = hash(n = te-&gt;name);
		ncmp = 0;

		/* taken from tsearch() and added counter */
		for (pp = &amp;tp-&gt;tbls[h &amp; (tp-&gt;size-1)]; (p = *pp); pp--) {
			ncmp++;
			if (*p-&gt;name == *n &amp;&amp; strcmp(p-&gt;name, n) == 0
			    &amp;&amp; (p-&gt;flag&amp;DEFINED))
				break; /* return p; */
			if (pp == tp-&gt;tbls) /* wrap */
				pp += tp-&gt;size;
		}
		shellf("    %4d %s\n", ncmp, n);
		totncmp += ncmp;
		nentries++;
		if (ncmp &gt; maxncmp)
			maxncmp = ncmp;
	}
	if (nentries)
		shellf("  %d entries, worst ncmp %d, avg ncmp %d.%02d\n",
			nentries, maxncmp,
			totncmp / nentries,
			(totncmp % nentries) * 100 / nentries);
}
#endif /* PERF_DEBUG */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

