<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/cmd/pdksh/tree.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/cmd/pdksh/tree.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * command tree climbing
 */

#include "sh.h"

#define INDENT	4

#define tputc(c, shf)	shf_putchar(c, shf);
static void 	ptree ARGS((struct op *t, int indent, struct shf *f));
static void 	pioact ARGS((struct shf *f, int indent, struct ioword *iop));
static void	tputC ARGS((int c, struct shf *shf));
static void	tputS ARGS((char *wp, struct shf *shf));
static void	vfptreef ARGS((struct shf *shf, int indent, const char *fmt, va_list va));
static struct ioword **iocopy ARGS((struct ioword **iow, Area *ap));
static void     iofree ARGS((struct ioword **iow, Area *ap));

/*
 * print a command tree
 */

static void
ptree(t, indent, shf)
	register struct op *t;
	int indent;
	register struct shf *shf;
{
	register char **w;
	struct ioword **ioact;
	struct op *t1;

 Chain:
	if (t == NULL)
		return;
	switch (t-&gt;type) {
	  case TCOM:
		if (t-&gt;vars)
			for (w = t-&gt;vars; *w != NULL; )
				fptreef(shf, indent, "%S ", *w++);
		else
			fptreef(shf, indent, "#no-vars# ");
		if (t-&gt;args)
			for (w = t-&gt;args; *w != NULL; )
				fptreef(shf, indent, "%S ", *w++);
		else
			fptreef(shf, indent, "#no-args# ");
		break;
	  case TEXEC:
#if 0 /* ?not useful - can't be called? */
		/* Print original vars */
		if (t-&gt;left-&gt;vars)
			for (w = t-&gt;left-&gt;vars; *w != NULL; )
				fptreef(shf, indent, "%S ", *w++);
		else
			fptreef(shf, indent, "#no-vars# ");
		/* Print expanded vars */
		if (t-&gt;args)
			for (w = t-&gt;args; *w != NULL; )
				fptreef(shf, indent, "%s ", *w++);
		else
			fptreef(shf, indent, "#no-args# ");
		/* Print original io */
		t = t-&gt;left;
#else
		t = t-&gt;left;
		goto Chain;
#endif
	  case TPAREN:
		fptreef(shf, indent + 2, "( %T) ", t-&gt;left);
		break;
	  case TPIPE:
		fptreef(shf, indent, "%T| ", t-&gt;left);
		t = t-&gt;right;
		goto Chain;
	  case TLIST:
		fptreef(shf, indent, "%T%;", t-&gt;left);
		t = t-&gt;right;
		goto Chain;
	  case TOR:
	  case TAND:
		fptreef(shf, indent, "%T%s %T",
			t-&gt;left, (t-&gt;type==TOR) ? "||" : "&amp;&amp;", t-&gt;right);
		break;
	  case TBANG:
		fptreef(shf, indent, "! ");
		t = t-&gt;right;
		goto Chain;
	  case TDBRACKET:
	  {
		int i;

		fptreef(shf, indent, "[[");
		for (i = 0; t-&gt;args[i]; i++)
			fptreef(shf, indent, " %S", t-&gt;args[i]);
		fptreef(shf, indent, " ]] ");
		break;
	  }
#ifdef KSH
	  case TSELECT:
		fptreef(shf, indent, "select %s ", t-&gt;str);
		/* fall through */
#endif /* KSH */
	  case TFOR:
		if (t-&gt;type == TFOR)
			fptreef(shf, indent, "for %s ", t-&gt;str);
		if (t-&gt;vars != NULL) {
			fptreef(shf, indent, "in ");
			for (w = t-&gt;vars; *w; )
				fptreef(shf, indent, "%S ", *w++);
			fptreef(shf, indent, "%;");
		}
		fptreef(shf, indent + INDENT, "do%N%T", t-&gt;left);
		fptreef(shf, indent, "%;done ");
		break;
	  case TCASE:
		fptreef(shf, indent, "case %S in", t-&gt;str);
		for (t1 = t-&gt;left; t1 != NULL; t1 = t1-&gt;right) {
			fptreef(shf, indent, "%N(");
			for (w = t1-&gt;vars; *w != NULL; w++)
				fptreef(shf, indent, "%S%c", *w,
					(w[1] != NULL) ? '|' : ')');
			fptreef(shf, indent + INDENT, "%;%T%N;;", t1-&gt;left);
		}
		fptreef(shf, indent, "%Nesac ");
		break;
	  case TIF:
	  case TELIF:
		/* 3 == strlen("if ") */
		fptreef(shf, indent + 3, "if %T", t-&gt;left);
		for (;;) {
			t = t-&gt;right;
			if (t-&gt;left != NULL) {
				fptreef(shf, indent, "%;");
				fptreef(shf, indent + INDENT, "then%N%T",
					t-&gt;left);
			}
			if (t-&gt;right == NULL || t-&gt;right-&gt;type != TELIF)
				break;
			t = t-&gt;right;
			fptreef(shf, indent, "%;");
			/* 5 == strlen("elif ") */
			fptreef(shf, indent + 5, "elif %T", t-&gt;left);
		}
		if (t-&gt;right != NULL) {
			fptreef(shf, indent, "%;");
			fptreef(shf, indent + INDENT, "else%;%T", t-&gt;right);
		}
		fptreef(shf, indent, "%;fi ");
		break;
	  case TWHILE:
	  case TUNTIL:
		/* 6 == strlen("while"/"until") */
		fptreef(shf, indent + 6, "%s %T",
			(t-&gt;type==TWHILE) ? "while" : "until",
			t-&gt;left);
		fptreef(shf, indent, "%;do");
		fptreef(shf, indent + INDENT, "%;%T", t-&gt;right);
		fptreef(shf, indent, "%;done ");
		break;
	  case TBRACE:
		fptreef(shf, indent + INDENT, "{%;%T", t-&gt;left);
		fptreef(shf, indent, "%;} ");
		break;
	  case TCOPROC:
		fptreef(shf, indent, "%T|&amp; ", t-&gt;left);
		break;
	  case TASYNC:
		fptreef(shf, indent, "%T&amp; ", t-&gt;left);
		break;
	  case TFUNCT:
		fptreef(shf, indent,
			t-&gt;u.ksh_func ? "function %s %T" : "%s() %T",
				t-&gt;str, t-&gt;left);
		break;
	  case TTIME:
		fptreef(shf, indent, "time %T", t-&gt;left);
		break;
	  default:
		fptreef(shf, indent, "&lt;botch&gt;");
		break;
	}
	if ((ioact = t-&gt;ioact) != NULL) {
		int	need_nl = 0;

		while (*ioact != NULL)
			pioact(shf, indent, *ioact++);
		/* Print here documents after everything else... */
		for (ioact = t-&gt;ioact; *ioact != NULL; ) {
			struct ioword *iop = *ioact++;

			/* heredoc is 0 when tracing (set -x) */
			if ((iop-&gt;flag &amp; IOTYPE) == IOHERE &amp;&amp; iop-&gt;heredoc) {
				tputc('\n', shf);
				shf_puts(iop-&gt;heredoc, shf);
				fptreef(shf, indent, "%s",
					evalstr(iop-&gt;delim, 0));
				need_nl = 1;
			}
		}
		/* Last delimiter must be followed by a newline (this often
		 * leads to an extra blank line, but its not worth worrying
		 * about)
		 */
		if (need_nl)
			tputc('\n', shf);
	}
}

static void
pioact(shf, indent, iop)
	register struct shf *shf;
	int indent;
	register struct ioword *iop;
{
	int flag = iop-&gt;flag;
	int type = flag &amp; IOTYPE;
	int expected;

	expected = (type == IOREAD || type == IORDWR || type == IOHERE) ? 0
		    : (type == IOCAT || type == IOWRITE) ? 1
		    : (type == IODUP &amp;&amp; (iop-&gt;unit == !(flag &amp; IORDUP))) ?
			iop-&gt;unit
		    : iop-&gt;unit + 1;
	if (iop-&gt;unit != expected)
		tputc('0' + iop-&gt;unit, shf);

	switch (type) {
	case IOREAD:
		fptreef(shf, indent, "&lt; ");
		break;
	case IOHERE:
		if (flag&amp;IOSKIP)
			fptreef(shf, indent, "&lt;&lt;- ");
		else
			fptreef(shf, indent, "&lt;&lt; ");
		break;
	case IOCAT:
		fptreef(shf, indent, "&gt;&gt; ");
		break;
	case IOWRITE:
		if (flag&amp;IOCLOB)
			fptreef(shf, indent, "&gt;| ");
		else
			fptreef(shf, indent, "&gt; ");
		break;
	case IORDWR:
		fptreef(shf, indent, "&lt;&gt; ");
		break;
	case IODUP:
		if (flag &amp; IORDUP)
			fptreef(shf, indent, "&lt;&amp;");
		else
			fptreef(shf, indent, "&gt;&amp;");
		break;
	}
	/* name/delim are 0 when printing syntax errors */
	if (type == IOHERE) {
		if (iop-&gt;delim)
			fptreef(shf, indent, "%S ", iop-&gt;delim);
	} else if (iop-&gt;name)
		fptreef(shf, indent, (iop-&gt;flag &amp; IONAMEXP) ? "%s " : "%S ",
			iop-&gt;name);
}


/*
 * variants of fputc, fputs for ptreef and snptreef
 */

static void
tputC(c, shf)
	register int c;
	register struct shf *shf;
{
	if ((c&amp;0x60) == 0) {		/* C0|C1 */
		tputc((c&amp;0x80) ? '$' : '^', shf);
		tputc(((c&amp;0x7F)|0x40), shf);
	} else if ((c&amp;0x7F) == 0x7F) {	/* DEL */
		tputc((c&amp;0x80) ? '$' : '^', shf);
		tputc('?', shf);
	} else
		tputc(c, shf);
}

static void
tputS(wp, shf)
	register char *wp;
	register struct shf *shf;
{
	register int c, quoted=0;

	/* problems:
	 *	`...` -&gt; $(...)
	 *	'foo' -&gt; "foo"
	 * could change encoding to:
	 *	OQUOTE ["'] ... CQUOTE ["']
	 * 	COMSUB [(`] ...\0	(handle $ ` \ and maybe " in `...` case)
	 */
	while (1)
		switch ((c = *wp++)) {
		  case EOS:
			return;
		  case CHAR:
			tputC(*wp++, shf);
			break;
		  case QCHAR:
			c = *wp++;
			if (!quoted || (c == '"' || c == '`' || c == '$'))
				tputc('\\', shf);
			tputC(c, shf);
			break;
		  case COMSUB:
			tputc('$', shf);
			tputc('(', shf);
			while (*wp != 0)
				tputC(*wp++, shf);
			tputc(')', shf);
			wp++;
			break;
		  case EXPRSUB:
			tputc('$', shf);
			tputc('(', shf);
			tputc('(', shf);
			while (*wp != 0)
				tputC(*wp++, shf);
			tputc(')', shf);
			tputc(')', shf);
			wp++;
			break;
		  case OQUOTE:
		  	quoted = 1;
			tputc('"', shf);
			break;
		  case CQUOTE:
			quoted = 0;
			tputc('"', shf);
			break;
		  case OSUBST:
			tputc('$', shf);
			if (*wp++ == '{')
				tputc('{', shf);
			while ((c = *wp++) != 0)
				tputC(c, shf);
			break;
		  case CSUBST:
			if (*wp++ == '}')
				tputc('}', shf);
			break;
#ifdef KSH
		  case OPAT:
			tputc(*wp++, shf);
			tputc('(', shf);
			break;
		  case SPAT:
			tputc('|', shf);
			break;
		  case CPAT:
			tputc(')', shf);
			break;
#endif /* KSH */
		}
}

/*
 * this is the _only_ way to reliably handle
 * variable args with an ANSI compiler
 */
/* VARARGS */
int
#ifdef HAVE_PROTOTYPES
fptreef(struct shf *shf, int indent, const char *fmt, ...)
#else
fptreef(shf, indent, fmt, va_alist) 
  struct shf *shf;
  int indent;
  const char *fmt;
  va_dcl
#endif
{
  va_list	va;

  SH_VA_START(va, fmt);
  
  vfptreef(shf, indent, fmt, va);
  va_end(va);
  return 0;
}

/* VARARGS */
char *
#ifdef HAVE_PROTOTYPES
snptreef(char *s, int n, const char *fmt, ...)
#else
snptreef(s, n, fmt, va_alist)
  char *s;
  int n;
  const char *fmt;
  va_dcl
#endif
{
  va_list va;
  struct shf shf;

  shf_sopen(s, n, SHF_WR | (s ? 0 : SHF_DYNAMIC), &amp;shf);

  SH_VA_START(va, fmt);
  vfptreef(&amp;shf, 0, fmt, va);
  va_end(va);

  return shf_sclose(&amp;shf); /* null terminates */
}

static void
vfptreef(shf, indent, fmt, va)
	register struct shf *shf;
	int indent;
	const char *fmt;
	register va_list va;
{
	register int c;

	while ((c = *fmt++))
	    if (c == '%') {
		register long n;
		register char *p;
		int neg;

		switch ((c = *fmt++)) {
		  case 'c':
			tputc(va_arg(va, int), shf);
			break;
		  case 's':
			p = va_arg(va, char *);
			while (*p)
				tputc(*p++, shf);
			break;
		  case 'S':	/* word */
			p = va_arg(va, char *);
			tputS(p, shf);
			break;
		  case 'd': case 'u': /* decimal */
			n = (c == 'd') ? va_arg(va, int)
				       : va_arg(va, unsigned int);
			neg = c=='d' &amp;&amp; n&lt;0;
			p = ulton((neg) ? -n : n, 10);
			if (neg)
				*--p = '-';
			while (*p)
				tputc(*p++, shf);
			break;
		  case 'T':	/* format tree */
			ptree(va_arg(va, struct op *), indent, shf);
			break;
		  case ';':	/* newline or ; */
		  case 'N':	/* newline or space */
			if (shf-&gt;flags &amp; SHF_STRING) {
				if (c == ';')
					tputc(';', shf);
				tputc(' ', shf);
			} else {
				int i;

				tputc('\n', shf);
				for (i = indent; i &gt;= 8; i -= 8)
					tputc('\t', shf);
				for (; i &gt; 0; --i)
					tputc(' ', shf);
			}
			break;
		  case 'R':
			pioact(shf, indent, va_arg(va, struct ioword *));
			break;
		  default:
			tputc(c, shf);
			break;
		}
	    } else
		tputc(c, shf);
}

/*
 * copy tree (for function definition)
 */

struct op *
tcopy(t, ap)
	register struct op *t;
	Area *ap;
{
	register struct op *r;
	register char **tw, **rw;

	if (t == NULL)
		return NULL;

	r = (struct op *) alloc(sizeof(struct op), ap);

	r-&gt;type = t-&gt;type;
	r-&gt;u.evalflags = t-&gt;u.evalflags;

	r-&gt;str = t-&gt;type == TCASE ? wdcopy(t-&gt;str, ap) : str_save(t-&gt;str, ap);

	if (t-&gt;vars == NULL)
		r-&gt;vars = NULL;
	else {
		for (tw = t-&gt;vars; *tw++ != NULL; )
			;
		rw = r-&gt;vars = (char **)
			alloc((int)(tw - t-&gt;vars) * sizeof(*tw), ap);
		for (tw = t-&gt;vars; *tw != NULL; )
			*rw++ = wdcopy(*tw++, ap);
		*rw = NULL;
	}

	if (t-&gt;args == NULL)
		r-&gt;args = NULL;
	else {
		for (tw = t-&gt;args; *tw++ != NULL; )
			;
		rw = r-&gt;args = (char **)
			alloc((int)(tw - t-&gt;args) * sizeof(*tw), ap);
		for (tw = t-&gt;args; *tw != NULL; )
			*rw++ = wdcopy(*tw++, ap);
		*rw = NULL;
	}

	r-&gt;ioact = (t-&gt;ioact == NULL) ? NULL : iocopy(t-&gt;ioact, ap);

	r-&gt;left = tcopy(t-&gt;left, ap);
	r-&gt;right = tcopy(t-&gt;right, ap);
	r-&gt;lineno = t-&gt;lineno;

	return r;
}

char *
wdcopy(wp, ap)
	const char *wp;
	Area *ap;
{
	size_t len = wdscan(wp, EOS) - wp;
	return memcpy(alloc(len, ap), wp, len);
}

/* return the position of prefix c in wp plus 1 */
char *
wdscan(wp, c)
	register const char *wp;
	register int c;
{
	register int nest = 0;

	while (1)
		switch (*wp++) {
		  case EOS:
			return (char *) wp;
		  case CHAR:
		  case QCHAR:
			wp++;
			break;
		  case COMSUB:
		  case EXPRSUB:
			while (*wp++ != 0)
				;
			break;
		  case OQUOTE:
		  case CQUOTE:
			break;
		  case OSUBST:
			nest++;
			while (*wp++ != '\0')
				;
			break;
		  case CSUBST:
			wp++;
			if (c == CSUBST &amp;&amp; nest == 0)
				return (char *) wp;
			nest--;
			break;
#ifdef KSH
		  case OPAT:
			nest++;
			wp++;
			break;
		  case SPAT:
		  case CPAT:
			if (c == wp[-1] &amp;&amp; nest == 0)
				return (char *) wp;
			if (wp[-1] == CPAT)
				nest--;
			break;
#endif /* KSH */
		  default:
			internal_errorf(0,
				"wdscan: unknown char 0x%x (carrying on)",
				wp[-1]);
		}
}

/* return a copy of wp without any of the mark up characters and
 * with quote characters (" ' \) stripped.
 * (string is allocated from ATEMP)
 */
char *
wdstrip(wp)
	const char *wp;
{
	struct shf shf;
	int c;

	shf_sopen((char *) 0, 32, SHF_WR | SHF_DYNAMIC, &amp;shf);

	/* problems:
	 *	`...` -&gt; $(...)
	 *	x${foo:-"hi"} -&gt; x${foo:-hi}
	 *	x${foo:-'hi'} -&gt; x${foo:-hi}
	 */
	while (1)
		switch ((c = *wp++)) {
		  case EOS:
			return shf_sclose(&amp;shf); /* null terminates */
		  case CHAR:
		  case QCHAR:
			shf_putchar(*wp++, &amp;shf);
			break;
		  case COMSUB:
			shf_putchar('$', &amp;shf);
			shf_putchar('(', &amp;shf);
			while (*wp != 0)
				shf_putchar(*wp++, &amp;shf);
			shf_putchar(')', &amp;shf);
			break;
		  case EXPRSUB:
			shf_putchar('$', &amp;shf);
			shf_putchar('(', &amp;shf);
			shf_putchar('(', &amp;shf);
			while (*wp != 0)
				shf_putchar(*wp++, &amp;shf);
			shf_putchar(')', &amp;shf);
			shf_putchar(')', &amp;shf);
			break;
		  case OQUOTE:
			break;
		  case CQUOTE:
			break;
		  case OSUBST:
			shf_putchar('$', &amp;shf);
			if (*wp++ == '{')
			    shf_putchar('{', &amp;shf);
			while ((c = *wp++) != 0)
				shf_putchar(c, &amp;shf);
			break;
		  case CSUBST:
			if (*wp++ == '}')
				shf_putchar('}', &amp;shf);
			break;
#ifdef KSH
		  case OPAT:
			shf_putchar(*wp++, &amp;shf);
			shf_putchar('(', &amp;shf);
			break;
		  case SPAT:
			shf_putchar('|', &amp;shf);
			break;
		  case CPAT:
			shf_putchar(')', &amp;shf);
			break;
#endif /* KSH */
		}
}

static	struct ioword **
iocopy(iow, ap)
	register struct ioword **iow;
	Area *ap;
{
	register struct ioword **ior;
	register int i;

	for (ior = iow; *ior++ != NULL; )
		;
	ior = (struct ioword **) alloc((int)(ior - iow) * sizeof(*ior), ap);

	for (i = 0; iow[i] != NULL; i++) {
		register struct ioword *p, *q;

		p = iow[i];
		q = (struct ioword *) alloc(sizeof(*p), ap);
		ior[i] = q;
		*q = *p;
		if (p-&gt;name != (char *) 0)
			q-&gt;name = wdcopy(p-&gt;name, ap);
		if (p-&gt;delim != (char *) 0)
			q-&gt;delim = wdcopy(p-&gt;delim, ap);
		if (p-&gt;heredoc != (char *) 0)
			q-&gt;heredoc = str_save(p-&gt;heredoc, ap);
	}
	ior[i] = NULL;

	return ior;
}

/*
 * free tree (for function definition)
 */

void
tfree(t, ap)
	register struct op *t;
	Area *ap;
{
	register char **w;

	if (t == NULL)
		return;

	if (t-&gt;str != NULL)
		afree((void*)t-&gt;str, ap);

	if (t-&gt;vars != NULL) {
		for (w = t-&gt;vars; *w != NULL; w++)
			afree((void*)*w, ap);
		afree((void*)t-&gt;vars, ap);
	}

	if (t-&gt;args != NULL) {
		for (w = t-&gt;args; *w != NULL; w++)
			afree((void*)*w, ap);
		afree((void*)t-&gt;args, ap);
	}

	if (t-&gt;ioact != NULL)
		iofree(t-&gt;ioact, ap);

	tfree(t-&gt;left, ap);
	tfree(t-&gt;right, ap);

	afree((void*)t, ap);
}

static	void
iofree(iow, ap)
	struct ioword **iow;
	Area *ap;
{
	register struct ioword **iop;
	register struct ioword *p;

	for (iop = iow; (p = *iop++) != NULL; ) {
		if (p-&gt;name != NULL)
			afree((void*)p-&gt;name, ap);
		if (p-&gt;delim != NULL)
			afree((void*)p-&gt;delim, ap);
		if (p-&gt;heredoc != NULL)
			afree((void*)p-&gt;heredoc, ap);
		afree((void*)p, ap);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

