<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/arm/vlrt.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/arm/vlrt.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
typedef	unsigned long	ulong;
typedef	unsigned int	uint;
typedef	unsigned short	ushort;
typedef	unsigned char	uchar;
typedef	signed char	schar;

#define	SIGN(n)	(1UL&lt;&lt;(n-1))

typedef	struct	Vlong	Vlong;
struct	Vlong
{
	ulong	lo;
	ulong	hi;
};

void	abort(void);

/* needed by profiler; can't be profiled */
#pragma profile off

void
_addv(Vlong *r, Vlong a, Vlong b)
{
	ulong lo, hi;

	lo = a.lo + b.lo;
	hi = a.hi + b.hi;
	if(lo &lt; a.lo)
		hi++;
	r-&gt;lo = lo;
	r-&gt;hi = hi;
}

void
_subv(Vlong *r, Vlong a, Vlong b)
{
	ulong lo, hi;

	lo = a.lo - b.lo;
	hi = a.hi - b.hi;
	if(lo &gt; a.lo)
		hi--;
	r-&gt;lo = lo;
	r-&gt;hi = hi;
}

#pragma profile on

void
_d2v(Vlong *y, double d)
{
	union { double d; struct Vlong; } x;
	ulong xhi, xlo, ylo, yhi;
	int sh;

	x.d = d;

	xhi = (x.hi &amp; 0xfffff) | 0x100000;
	xlo = x.lo;
	sh = 1075 - ((x.hi &gt;&gt; 20) &amp; 0x7ff);

	ylo = 0;
	yhi = 0;
	if(sh &gt;= 0) {
		/* v = (hi||lo) &gt;&gt; sh */
		if(sh &lt; 32) {
			if(sh == 0) {
				ylo = xlo;
				yhi = xhi;
			} else {
				ylo = (xlo &gt;&gt; sh) | (xhi &lt;&lt; (32-sh));
				yhi = xhi &gt;&gt; sh;
			}
		} else {
			if(sh == 32) {
				ylo = xhi;
			} else
			if(sh &lt; 64) {
				ylo = xhi &gt;&gt; (sh-32);
			}
		}
	} else {
		/* v = (hi||lo) &lt;&lt; -sh */
		sh = -sh;
		if(sh &lt;= 10) {
			ylo = xlo &lt;&lt; sh;
			yhi = (xhi &lt;&lt; sh) | (xlo &gt;&gt; (32-sh));
		} else {
			/* overflow */
			yhi = d;	/* causes something awful */
		}
	}
	if(x.hi &amp; SIGN(32)) {
		if(ylo != 0) {
			ylo = -ylo;
			yhi = ~yhi;
		} else
			yhi = -yhi;
	}

	y-&gt;hi = yhi;
	y-&gt;lo = ylo;
}

void
_f2v(Vlong *y, float f)
{
	_d2v(y, f);
}

double
_v2d(Vlong x)
{
	if(x.hi &amp; SIGN(32)) {
		if(x.lo) {
			x.lo = -x.lo;
			x.hi = ~x.hi;
		} else
			x.hi = -x.hi;
		return -((long)x.hi*4294967296. + x.lo);
	}
	return (long)x.hi*4294967296. + x.lo;
}

float
_v2f(Vlong x)
{
	return _v2d(x);
}


static void
dodiv(Vlong num, Vlong den, Vlong *q, Vlong *r)
{
	ulong numlo, numhi, denhi, denlo, quohi, quolo, t;
	int i;

	numhi = num.hi;
	numlo = num.lo;
	denhi = den.hi;
	denlo = den.lo;
	/*
	 * get a divide by zero
	 */
	if(denlo==0 &amp;&amp; denhi==0) {
		numlo = numlo / denlo;
	}

	/*
	 * set up the divisor and find the number of iterations needed
	 */
	if(numhi &gt;= SIGN(32)) {
		quohi = SIGN(32);
		quolo = 0;
	} else {
		quohi = numhi;
		quolo = numlo;
	}
	i = 0;
	while(denhi &lt; quohi || (denhi == quohi &amp;&amp; denlo &lt; quolo)) {
		denhi = (denhi&lt;&lt;1) | (denlo&gt;&gt;31);
		denlo &lt;&lt;= 1;
		i++;
	}

	quohi = 0;
	quolo = 0;
	for(; i &gt;= 0; i--) {
		quohi = (quohi&lt;&lt;1) | (quolo&gt;&gt;31);
		quolo &lt;&lt;= 1;
		if(numhi &gt; denhi || (numhi == denhi &amp;&amp; numlo &gt;= denlo)) {
			t = numlo;
			numlo -= denlo;
			if(numlo &gt; t)
				numhi--;
			numhi -= denhi;
			quolo |= 1;
		}
		denlo = (denlo&gt;&gt;1) | (denhi&lt;&lt;31);
		denhi &gt;&gt;= 1;
	}

	if(q) {
		q-&gt;lo = quolo;
		q-&gt;hi = quohi;
	}
	if(r) {
		r-&gt;lo = numlo;
		r-&gt;hi = numhi;
	}
}

void
_divvu(Vlong *q, Vlong n, Vlong d)
{
	if(n.hi == 0 &amp;&amp; d.hi == 0) {
		q-&gt;hi = 0;
		q-&gt;lo = n.lo / d.lo;
		return;
	}
	dodiv(n, d, q, 0);
}

void
_modvu(Vlong *r, Vlong n, Vlong d)
{

	if(n.hi == 0 &amp;&amp; d.hi == 0) {
		r-&gt;hi = 0;
		r-&gt;lo = n.lo % d.lo;
		return;
	}
	dodiv(n, d, 0, r);
}

static void
vneg(Vlong *v)
{

	if(v-&gt;lo == 0) {
		v-&gt;hi = -v-&gt;hi;
		return;
	}
	v-&gt;lo = -v-&gt;lo;
	v-&gt;hi = ~v-&gt;hi;
}

void
_divv(Vlong *q, Vlong n, Vlong d)
{
	long nneg, dneg;

	if(n.hi == (((long)n.lo)&gt;&gt;31) &amp;&amp; d.hi == (((long)d.lo)&gt;&gt;31)) {
		q-&gt;lo = (long)n.lo / (long)d.lo;
		q-&gt;hi = ((long)q-&gt;lo) &gt;&gt; 31;
		return;
	}
	nneg = n.hi &gt;&gt; 31;
	if(nneg)
		vneg(&amp;n);
	dneg = d.hi &gt;&gt; 31;
	if(dneg)
		vneg(&amp;d);
	dodiv(n, d, q, 0);
	if(nneg != dneg)
		vneg(q);
}

void
_modv(Vlong *r, Vlong n, Vlong d)
{
	long nneg, dneg;

	if(n.hi == (((long)n.lo)&gt;&gt;31) &amp;&amp; d.hi == (((long)d.lo)&gt;&gt;31)) {
		r-&gt;lo = (long)n.lo % (long)d.lo;
		r-&gt;hi = ((long)r-&gt;lo) &gt;&gt; 31;
		return;
	}
	nneg = n.hi &gt;&gt; 31;
	if(nneg)
		vneg(&amp;n);
	dneg = d.hi &gt;&gt; 31;
	if(dneg)
		vneg(&amp;d);
	dodiv(n, d, 0, r);
	if(nneg)
		vneg(r);
}

void
_rshav(Vlong *r, Vlong a, int b)
{
	long t;

	t = a.hi;
	if(b &gt;= 32) {
		r-&gt;hi = t&gt;&gt;31;
		if(b &gt;= 64) {
			/* this is illegal re C standard */
			r-&gt;lo = t&gt;&gt;31;
			return;
		}
		r-&gt;lo = t &gt;&gt; (b-32);
		return;
	}
	if(b &lt;= 0) {
		r-&gt;hi = t;
		r-&gt;lo = a.lo;
		return;
	}
	r-&gt;hi = t &gt;&gt; b;
	r-&gt;lo = (t &lt;&lt; (32-b)) | (a.lo &gt;&gt; b);
}

void
_rshlv(Vlong *r, Vlong a, int b)
{
	ulong t;

	t = a.hi;
	if(b &gt;= 32) {
		r-&gt;hi = 0;
		if(b &gt;= 64) {
			/* this is illegal re C standard */
			r-&gt;lo = 0;
			return;
		}
		r-&gt;lo = t &gt;&gt; (b-32);
		return;
	}
	if(b &lt;= 0) {
		r-&gt;hi = t;
		r-&gt;lo = a.lo;
		return;
	}
	r-&gt;hi = t &gt;&gt; b;
	r-&gt;lo = (t &lt;&lt; (32-b)) | (a.lo &gt;&gt; b);
}

void
_lshv(Vlong *r, Vlong a, int b)
{
	ulong t;

	t = a.lo;
	if(b &gt;= 32) {
		r-&gt;lo = 0;
		if(b &gt;= 64) {
			/* this is illegal re C standard */
			r-&gt;hi = 0;
			return;
		}
		r-&gt;hi = t &lt;&lt; (b-32);
		return;
	}
	if(b &lt;= 0) {
		r-&gt;lo = t;
		r-&gt;hi = a.hi;
		return;
	}
	r-&gt;lo = t &lt;&lt; b;
	r-&gt;hi = (t &gt;&gt; (32-b)) | (a.hi &lt;&lt; b);
}

void
_andv(Vlong *r, Vlong a, Vlong b)
{
	r-&gt;hi = a.hi &amp; b.hi;
	r-&gt;lo = a.lo &amp; b.lo;
}

void
_orv(Vlong *r, Vlong a, Vlong b)
{
	r-&gt;hi = a.hi | b.hi;
	r-&gt;lo = a.lo | b.lo;
}

void
_xorv(Vlong *r, Vlong a, Vlong b)
{
	r-&gt;hi = a.hi ^ b.hi;
	r-&gt;lo = a.lo ^ b.lo;
}

void
_vpp(Vlong *l, Vlong *r)
{

	l-&gt;hi = r-&gt;hi;
	l-&gt;lo = r-&gt;lo;
	r-&gt;lo++;
	if(r-&gt;lo == 0)
		r-&gt;hi++;
}

void
_vmm(Vlong *l, Vlong *r)
{

	l-&gt;hi = r-&gt;hi;
	l-&gt;lo = r-&gt;lo;
	if(r-&gt;lo == 0)
		r-&gt;hi--;
	r-&gt;lo--;
}

void
_ppv(Vlong *l, Vlong *r)
{

	r-&gt;lo++;
	if(r-&gt;lo == 0)
		r-&gt;hi++;
	l-&gt;hi = r-&gt;hi;
	l-&gt;lo = r-&gt;lo;
}

void
_mmv(Vlong *l, Vlong *r)
{

	if(r-&gt;lo == 0)
		r-&gt;hi--;
	r-&gt;lo--;
	l-&gt;hi = r-&gt;hi;
	l-&gt;lo = r-&gt;lo;
}

void
_vasop(Vlong *ret, void *lv, void fn(Vlong*, Vlong, Vlong), int type, Vlong rv)
{
	Vlong t, u;

	u = *ret;
	switch(type) {
	default:
		abort();
		break;

	case 1:	/* schar */
		t.lo = *(schar*)lv;
		t.hi = t.lo &gt;&gt; 31;
		fn(&amp;u, t, rv);
		*(schar*)lv = u.lo;
		break;

	case 2:	/* uchar */
		t.lo = *(uchar*)lv;
		t.hi = 0;
		fn(&amp;u, t, rv);
		*(uchar*)lv = u.lo;
		break;

	case 3:	/* short */
		t.lo = *(short*)lv;
		t.hi = t.lo &gt;&gt; 31;
		fn(&amp;u, t, rv);
		*(short*)lv = u.lo;
		break;

	case 4:	/* ushort */
		t.lo = *(ushort*)lv;
		t.hi = 0;
		fn(&amp;u, t, rv);
		*(ushort*)lv = u.lo;
		break;

	case 9:	/* int */
		t.lo = *(int*)lv;
		t.hi = t.lo &gt;&gt; 31;
		fn(&amp;u, t, rv);
		*(int*)lv = u.lo;
		break;

	case 10:	/* uint */
		t.lo = *(uint*)lv;
		t.hi = 0;
		fn(&amp;u, t, rv);
		*(uint*)lv = u.lo;
		break;

	case 5:	/* long */
		t.lo = *(long*)lv;
		t.hi = t.lo &gt;&gt; 31;
		fn(&amp;u, t, rv);
		*(long*)lv = u.lo;
		break;

	case 6:	/* ulong */
		t.lo = *(ulong*)lv;
		t.hi = 0;
		fn(&amp;u, t, rv);
		*(ulong*)lv = u.lo;
		break;

	case 7:	/* vlong */
	case 8:	/* uvlong */
		fn(&amp;u, *(Vlong*)lv, rv);
		*(Vlong*)lv = u;
		break;
	}
	*ret = u;
}

void
_p2v(Vlong *ret, void *p)
{
	long t;

	t = (ulong)p;
	ret-&gt;lo = t;
	ret-&gt;hi = 0;
}

void
_sl2v(Vlong *ret, long sl)
{
	long t;

	t = sl;
	ret-&gt;lo = t;
	ret-&gt;hi = t &gt;&gt; 31;
}

void
_ul2v(Vlong *ret, ulong ul)
{
	long t;

	t = ul;
	ret-&gt;lo = t;
	ret-&gt;hi = 0;
}

void
_si2v(Vlong *ret, int si)
{
	long t;

	t = si;
	ret-&gt;lo = t;
	ret-&gt;hi = t &gt;&gt; 31;
}

void
_ui2v(Vlong *ret, uint ui)
{
	long t;

	t = ui;
	ret-&gt;lo = t;
	ret-&gt;hi = 0;
}

void
_sh2v(Vlong *ret, long sh)
{
	long t;

	t = (sh &lt;&lt; 16) &gt;&gt; 16;
	ret-&gt;lo = t;
	ret-&gt;hi = t &gt;&gt; 31;
}

void
_uh2v(Vlong *ret, ulong ul)
{
	long t;

	t = ul &amp; 0xffff;
	ret-&gt;lo = t;
	ret-&gt;hi = 0;
}

void
_sc2v(Vlong *ret, long uc)
{
	long t;

	t = (uc &lt;&lt; 24) &gt;&gt; 24;
	ret-&gt;lo = t;
	ret-&gt;hi = t &gt;&gt; 31;
}

void
_uc2v(Vlong *ret, ulong ul)
{
	long t;

	t = ul &amp; 0xff;
	ret-&gt;lo = t;
	ret-&gt;hi = 0;
}

long
_v2sc(Vlong rv)
{
	long t;

	t = rv.lo &amp; 0xff;
	return (t &lt;&lt; 24) &gt;&gt; 24;
}

long
_v2uc(Vlong rv)
{

	return rv.lo &amp; 0xff;
}

long
_v2sh(Vlong rv)
{
	long t;

	t = rv.lo &amp; 0xffff;
	return (t &lt;&lt; 16) &gt;&gt; 16;
}

long
_v2uh(Vlong rv)
{

	return rv.lo &amp; 0xffff;
}

long
_v2sl(Vlong rv)
{

	return rv.lo;
}

long
_v2ul(Vlong rv)
{

	return rv.lo;
}

long
_v2si(Vlong rv)
{

	return rv.lo;
}

long
_v2ui(Vlong rv)
{

	return rv.lo;
}

int
_testv(Vlong rv)
{
	return rv.lo || rv.hi;
}

int
_eqv(Vlong lv, Vlong rv)
{
	return lv.lo == rv.lo &amp;&amp; lv.hi == rv.hi;
}

int
_nev(Vlong lv, Vlong rv)
{
	return lv.lo != rv.lo || lv.hi != rv.hi;
}

int
_ltv(Vlong lv, Vlong rv)
{
	return (long)lv.hi &lt; (long)rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &lt; rv.lo);
}

int
_lev(Vlong lv, Vlong rv)
{
	return (long)lv.hi &lt; (long)rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &lt;= rv.lo);
}

int
_gtv(Vlong lv, Vlong rv)
{
	return (long)lv.hi &gt; (long)rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &gt; rv.lo);
}

int
_gev(Vlong lv, Vlong rv)
{
	return (long)lv.hi &gt; (long)rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &gt;= rv.lo);
}

int
_lov(Vlong lv, Vlong rv)
{
	return lv.hi &lt; rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &lt; rv.lo);
}

int
_lsv(Vlong lv, Vlong rv)
{
	return lv.hi &lt; rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &lt;= rv.lo);
}

int
_hiv(Vlong lv, Vlong rv)
{
	return lv.hi &gt; rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &gt; rv.lo);
}

int
_hsv(Vlong lv, Vlong rv)
{
	return lv.hi &gt; rv.hi || 
		(lv.hi == rv.hi &amp;&amp; lv.lo &gt;= rv.lo);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

