<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/gen/mktime.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/gen/mktime.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;time.h&gt;

/*
 * BUG: Doesn't do leap years in full glory,
 * or calendar changes. In 2038 the sign bit
 * will be needed in time_t, but we say it
 * can't be represented.
 */
static int
dysize(int y)
{
	y += 1900; /* arg is a tm_year, number of years since 1900 */
	if((y%4) == 0 &amp;&amp; ((y%100) !=0 || (y%400) == 0))
		return 366;
	return 365;
}

static int
dmsize(int m, int y)
{
	static	char	sizes[12] =
		{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	if(m == 1)
		return (dysize(y)==366)? 29 : 28;
	else
		return sizes[m];
}

/* Reduce *v to [0, mult), adding 1 to *next for every mult
 * subtracted from *v, and return 1 if reduction worked (no overflow)
 */
static int
reduce(int *v, int *next, int mult)
{
	int oldnext;

	while(*v &lt; 0){
		*v += mult;
		oldnext = *next;
		--*next;
		if(!(*next &lt; oldnext))
			return 0;
	}
	while(*v &gt;= mult){
		*v -= mult;
		oldnext = *next;
		++*next;
		if(!(*next &gt; oldnext))
			return 0;
	}
	return 1;
}

static int
jan1(int yr)
{
	int y, d;

	y = yr+1900;
	d = (4+y+(y+3)/4-(y-1701)/100+(y-1601)/400+3)%7;
	return d;
}

time_t
mktime(struct tm *t)
{
	time_t a;
	int i, d;
	struct tm *ptm;

	if(!(reduce(&amp;t-&gt;tm_sec, &amp;t-&gt;tm_min, 60) &amp;&amp;
	     reduce(&amp;t-&gt;tm_min, &amp;t-&gt;tm_hour, 60) &amp;&amp;
	     reduce(&amp;t-&gt;tm_hour, &amp;t-&gt;tm_mday, 24) &amp;&amp;
	     reduce(&amp;t-&gt;tm_mon, &amp;t-&gt;tm_year, 12)))
		return -1;
	while(t-&gt;tm_mday &lt; 1){
		if(--t-&gt;tm_mon == -1){
			t-&gt;tm_mon = 11;
			t-&gt;tm_year--;
		}
		t-&gt;tm_mday += dmsize(t-&gt;tm_mon, t-&gt;tm_year);
	}
	while(t-&gt;tm_mday &gt; dmsize(t-&gt;tm_mon, t-&gt;tm_year)){
		t-&gt;tm_mday -= dmsize(t-&gt;tm_mon, t-&gt;tm_year);
		if(++t-&gt;tm_mon == 12){
			t-&gt;tm_mon = 0;
			t-&gt;tm_year++;
		}
	}
	a = t-&gt;tm_sec + 60*t-&gt;tm_min + 3600*t-&gt;tm_hour;
	t-&gt;tm_yday = t-&gt;tm_mday-1;
	for(i=0; i&lt;t-&gt;tm_mon; i++)
		t-&gt;tm_yday += dmsize(i, t-&gt;tm_year);
	a += t-&gt;tm_yday*86400L;
	if(t-&gt;tm_year &lt; 70){
		for(i=t-&gt;tm_year; i&lt;70; i++)
			if((a -= dysize(i)*86400L) &lt; 0)
				return -1;
	}else if(t-&gt;tm_year &gt; 70){
		for(i=70; i&lt;t-&gt;tm_year; i++)
			if((a += dysize(i)*86400L) &lt; 0)
				return -1;
	}
	/*
	 * Now a is number of seconds past Jan 1 1970.
	 * Convert to GMT.
	 */
	ptm = gmtime(&amp;a);
	d = ptm-&gt;tm_hour;
	ptm = localtime(&amp;a);
	d -= ptm-&gt;tm_hour;
	if(d &lt; 0)
		d += 24;
	if(t-&gt;tm_isdst == 0 &amp;&amp; ptm-&gt;tm_isdst)
		d--;
	if(t-&gt;tm_isdst &gt; 0 &amp;&amp; !ptm-&gt;tm_isdst)
		d++;
	a += d*3600;
	t-&gt;tm_wday = (jan1(t-&gt;tm_year)+t-&gt;tm_yday)%7;
	return a;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

