<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/gen/qsort.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/gen/qsort.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* qsort -- qsort interface implemented by faster quicksort */
#include &lt;stdlib.h&gt;

#define SWAPINIT(a, es) swaptype =                            \
    (a - (char*) 0) % sizeof(long) || es % sizeof(long) ? 2 : \
    es == sizeof(long) ? 0 : 1;
#define swapcode(TYPE, parmi, parmj, n) {  \
    long i = (n) / (int) sizeof(TYPE);     \
    register TYPE *pi = (TYPE *) (parmi);  \
    register TYPE *pj = (TYPE *) (parmj);  \
    do {                                   \
        register TYPE t = *pi;             \
        *pi++ = *pj;                       \
        *pj++ = t;                         \
    } while (--i &gt; 0);                     \
}
static void swapfunc(char *a, char *b, int n, int swaptype)
{   if (swaptype &lt;= 1) swapcode(long, a, b, n)
    else swapcode(char, a, b, n)
}
#define swap(a, b) {                       \
    if (swaptype == 0) {                   \
        long t = * (long *) (a);           \
        * (long *) (a) = * (long *) (b);   \
        * (long *) (b) = t;                \
    } else                                 \
        swapfunc(a, b, es, swaptype);      \
}
#define vecswap(a, b, n) { if (n &gt; 0) swapfunc(a, b, n*es, swaptype); }

static char *med3func(char *a, char *b, char *c, int (*cmp)(const void *, const void *))
{	return cmp(a, b) &lt; 0 ?
		  (cmp(b, c) &lt; 0 ? b : (cmp(a, c) &lt; 0 ? c : a ) )
		: (cmp(b, c) &gt; 0 ? b : (cmp(a, c) &lt; 0 ? a : c ) );
}
#define med3(a, b, c) med3func(a, b, c, cmp)

void qsort(void *va, size_t n, size_t es, int (*cmp)(const void *, const void *))
{
	char *a, *pa, *pb, *pc, *pd, *pl, *pm, *pn;
	int  r, swaptype, na, nb, nc, nd, d;

	a = va;
	SWAPINIT(a, es);
	if (n &lt; 7) { /* Insertion sort on small arrays */
		for (pm = a + es; pm &lt; a + n*es; pm += es)
			for (pl = pm; pl &gt; a &amp;&amp; cmp(pl-es, pl) &gt; 0; pl -= es)
				swap(pl, pl-es);
		return;
	}
	pm = a + (n/2) * es;
	if (n &gt; 7) {
		pl = a;
		pn = a + (n-1) * es;
		if (n &gt; 40) { /* On big arrays, pseudomedian of 9 */
			d = (n/8) * es;
			pl = med3(pl, pl+d, pl+2*d);
			pm = med3(pm-d, pm, pm+d);
			pn = med3(pn-2*d, pn-d, pn);
		}
		pm = med3(pl, pm, pn); /* On medium arrays, median of 3 */
	}
	swap(a, pm); /* On tiny arrays, partition around middle */
	pa = pb = a + es;
	pc = pd = pn = a + (n-1)*es;
	for (;;) {
		while (pb &lt;= pc &amp;&amp; (r = cmp(pb, a)) &lt;= 0) {
			if (r == 0) { swap(pa, pb); pa += es; }
			pb += es;
		}
		while (pb &lt;= pc &amp;&amp; (r = cmp(pc, a)) &gt;= 0) {
			if (r == 0) { swap(pc, pd); pd -= es; }
			pc -= es;
		}
		if (pb &gt; pc) break;
		swap(pb, pc);
		pb += es;
		pc -= es;
	}
	na = (pa - a)  / es;
	nb = (pb - pa) / es;
	nc = (pd - pc) / es;
	nd = (pn - pd) / es;
	if (na &lt; nb) { vecswap(a,  a + nb*es,  na); }
	else	     { vecswap(a,  a + na*es,  nb); }
	if (nc &lt; nd) { vecswap(pb, pb + nd*es, nc); }
	else	     { vecswap(pb, pb + nc*es, nd); }
	if (nb &gt; 1) qsort(a, nb, es, cmp);
	if (nc &gt; 1) qsort(a + (n-nc) * es, nc, es, cmp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

