<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/ctime.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/ctime.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * This routine converts time as follows.
 * The epoch is 0000 Jan 1 1970 GMT.
 * The argument time is in seconds since then.
 * The localtime(t) entry returns a pointer to an array
 * containing
 *
 *	seconds (0-59)
 *	minutes (0-59)
 *	hours (0-23)
 *	day of month (1-31)
 *	month (0-11)
 *	year-1970
 *	weekday (0-6, Sun is 0)
 *	day of the year
 *	daylight savings flag
 *
 * The routine gets the daylight savings time from the environment.
 *
 * asctime(tvec))
 * where tvec is produced by localtime
 * returns a ptr to a character string
 * that has the ascii time in the form
 *
 *	                            \\
 *	Thu Jan 01 00:00:00 1970n0
 *	01234567890123456789012345
 *	0	  1	    2
 *
 * ctime(t) just calls localtime, then asctime.
 */

#include &lt;sys/types.h&gt;
#include &lt;sys/stat.h&gt;
#include &lt;fcntl.h&gt;
#include &lt;time.h&gt;
#include &lt;unistd.h&gt;
#include &lt;string.h&gt;

static	char	dmsize[12] =
{
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};

/*
 * The following table is used for 1974 and 1975 and
 * gives the day number of the first day after the Sunday of the
 * change.
 */

static	int	dysize(int);
static	void	ct_numb(char*, int);
static	void	readtimezone(void);
static	int	rd_name(char**, char*);
static	int	rd_long(char**, long*);

#define	TZSIZE	150

static
struct
{
	char	stname[4];
	char	dlname[4];
	long	stdiff;
	long	dldiff;
	long	dlpairs[TZSIZE];
} timezone;

char*
ctime(const time_t *t)
{
	return asctime(localtime(t));
}

struct tm*
gmtime_r(const time_t *timp, struct tm *result)
{
	int d0, d1;
	long hms, day;
	time_t tim;

	tim = *timp;
	/*
	 * break initial number into days
	 */
	hms = tim % 86400L;
	day = tim / 86400L;
	if(hms &lt; 0) {
		hms += 86400L;
		day -= 1;
	}

	/*
	 * generate hours:minutes:seconds
	 */
	result-&gt;tm_sec = hms % 60;
	d1 = hms / 60;
	result-&gt;tm_min = d1 % 60;
	d1 /= 60;
	result-&gt;tm_hour = d1;

	/*
	 * day is the day number.
	 * generate day of the week.
	 * The addend is 4 mod 7 (1/1/1970 was Thursday)
	 */

	result-&gt;tm_wday = (day + 7340036L) % 7;

	/*
	 * year number
	 */
	if(day &gt;= 0)
		for(d1 = 70; day &gt;= dysize(d1); d1++)
			day -= dysize(d1);
	else
		for (d1 = 70; day &lt; 0; d1--)
			day += dysize(d1-1);
	result-&gt;tm_year = d1;
	result-&gt;tm_yday = d0 = day;

	/*
	 * generate month
	 */

	if(dysize(d1) == 366)
		dmsize[1] = 29;
	for(d1 = 0; d0 &gt;= dmsize[d1]; d1++)
		d0 -= dmsize[d1];
	dmsize[1] = 28;
	result-&gt;tm_mday = d0 + 1;
	result-&gt;tm_mon = d1;
	result-&gt;tm_isdst = 0;
	return result;
}

struct tm*
gmtime(const time_t *timp)
{
	static struct tm xtime;

	return gmtime_r(timp, &amp;xtime);
}

struct tm*
localtime_r(const time_t *timp, struct tm *result)
{
	struct tm *ct;
	time_t t, tim;
	long *p;
	int dlflag;

	tim = *timp;
	if(timezone.stname[0] == 0)
		readtimezone();
	t = tim + timezone.stdiff;
	dlflag = 0;
	for(p = timezone.dlpairs; *p; p += 2)
		if(t &gt;= p[0])
		if(t &lt; p[1]) {
			t = tim + timezone.dldiff;
			dlflag++;
			break;
		}
	ct = gmtime_r(&amp;t, result);
	ct-&gt;tm_isdst = dlflag;
	return ct;
}

struct tm*
localtime(const time_t *timp)
{
	static struct tm xtime;

	return localtime_r(timp, &amp;xtime);
}

char*
asctime_r(const struct tm *t, char *buf)
{
	char *ncp;

	strcpy(buf, "Thu Jan 01 00:00:00 1970\n");
	ncp = &amp;"SunMonTueWedThuFriSat"[t-&gt;tm_wday*3];
	buf[0] = *ncp++;
	buf[1] = *ncp++;
	buf[2] = *ncp;
	ncp = &amp;"JanFebMarAprMayJunJulAugSepOctNovDec"[t-&gt;tm_mon*3];
	buf[4] = *ncp++;
	buf[5] = *ncp++;
	buf[6] = *ncp;
	ct_numb(buf+8, t-&gt;tm_mday);
	ct_numb(buf+11, t-&gt;tm_hour+100);
	ct_numb(buf+14, t-&gt;tm_min+100);
	ct_numb(buf+17, t-&gt;tm_sec+100);
	if(t-&gt;tm_year &gt;= 100) {
		buf[20] = '2';
		buf[21] = '0';
	}
	ct_numb(buf+22, t-&gt;tm_year+100);
	return buf;
}

char*
asctime(const struct tm *t)
{
	static char cbuf[30];

	return asctime_r(t, cbuf);
}

static
dysize(int y)
{
	if((y%4) == 0)
		return 366;
	return 365;
}

static
void
ct_numb(char *cp, int n)
{
	cp[0] = ' ';
	if(n &gt;= 10)
		cp[0] = (n/10)%10 + '0';
	cp[1] = n%10 + '0';
}

static
void
readtimezone(void)
{
	char buf[TZSIZE*11+30], *p;
	int i;

	memset(buf, 0, sizeof(buf));
	i = open("/env/timezone", 0);
	if(i &lt; 0)
		goto error;
	if(read(i, buf, sizeof(buf)) &gt;= sizeof(buf))
		goto error;
	close(i);
	p = buf;
	if(rd_name(&amp;p, timezone.stname))
		goto error;
	if(rd_long(&amp;p, &amp;timezone.stdiff))
		goto error;
	if(rd_name(&amp;p, timezone.dlname))
		goto error;
	if(rd_long(&amp;p, &amp;timezone.dldiff))
		goto error;
	for(i=0; i&lt;TZSIZE; i++) {
		if(rd_long(&amp;p, &amp;timezone.dlpairs[i]))
			goto error;
		if(timezone.dlpairs[i] == 0)
			return;
	}

error:
	timezone.stdiff = 0;
	strcpy(timezone.stname, "GMT");
	timezone.dlpairs[0] = 0;
}

static
rd_name(char **f, char *p)
{
	int c, i;

	for(;;) {
		c = *(*f)++;
		if(c != ' ' &amp;&amp; c != '\n')
			break;
	}
	for(i=0; i&lt;3; i++) {
		if(c == ' ' || c == '\n')
			return 1;
		*p++ = c;
		c = *(*f)++;
	}
	if(c != ' ' &amp;&amp; c != '\n')
		return 1;
	*p = 0;
	return 0;
}

static
rd_long(char **f, long *p)
{
	int c, s;
	long l;

	s = 0;
	for(;;) {
		c = *(*f)++;
		if(c == '-') {
			s++;
			continue;
		}
		if(c != ' ' &amp;&amp; c != '\n')
			break;
	}
	if(c == 0) {
		*p = 0;
		return 0;
	}
	l = 0;
	for(;;) {
		if(c == ' ' || c == '\n')
			break;
		if(c &lt; '0' || c &gt; '9')
			return 1;
		l = l*10 + c-'0';
		c = *(*f)++;
	}
	if(s)
		l = -l;
	*p = l;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

