<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/opendir.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/opendir.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "lib.h"
#include &lt;stdlib.h&gt;
#include &lt;sys/stat.h&gt;
#include &lt;dirent.h&gt;
#include &lt;unistd.h&gt;
#include &lt;errno.h&gt;
#include &lt;string.h&gt;
#include "sys9.h"
#include "dir.h"

#define DBLOCKSIZE 20

DIR *
opendir(const char *filename)
{
	int f;
	DIR *d;
	struct stat sb;
	Dir *d9;

	if((d9 = _dirstat(filename)) == nil){
		_syserrno();
		return NULL;
	}
	_dirtostat(&amp;sb, d9, 0);
	free(d9);
	if(S_ISDIR(sb.st_mode) == 0) {
		errno = ENOTDIR;
		return NULL;
	}

	f = open(filename, O_RDONLY);
	if(f &lt; 0){
		_syserrno();
		return NULL;
	}
	_fdinfo[f].flags |= FD_CLOEXEC;
	d = (DIR *)malloc(sizeof(DIR) + DBLOCKSIZE*sizeof(struct dirent));
	if(!d){
		errno = ENOMEM;
		return NULL;
	}
	d-&gt;dd_buf = (char *)d + sizeof(DIR);
	d-&gt;dd_fd = f;
	d-&gt;dd_loc = 0;
	d-&gt;dd_size = 0;
	d-&gt;dirs = nil;
	d-&gt;dirsize = 0;
	d-&gt;dirloc = 0;
	return d;
}

int
closedir(DIR *d)
{
	if(!d){
		errno = EBADF;
		return -1;
	}
	if(close(d-&gt;dd_fd) &lt; 0)
		return -1;
	free(d-&gt;dirs);
	free(d);
	return 0;
}

void
rewinddir(DIR *d)
{
	if(!d)
		return;
	d-&gt;dd_loc = 0;
	d-&gt;dd_size = 0;
	d-&gt;dirsize = 0;
	d-&gt;dirloc = 0;
	free(d-&gt;dirs);
	d-&gt;dirs = nil;
	if(_SEEK(d-&gt;dd_fd, 0, 0) &lt; 0){
		_syserrno();
		return;
	}
}

struct dirent *
readdir(DIR *d)
{
	int i;
	struct dirent *dr;
	Dir *dirs;

	if(!d){
		errno = EBADF;
		return NULL;
	}
	if(d-&gt;dd_loc &gt;= d-&gt;dd_size){
		if(d-&gt;dirloc &gt;= d-&gt;dirsize){
			free(d-&gt;dirs);
			d-&gt;dirs = NULL;
			d-&gt;dirsize = _dirread(d-&gt;dd_fd, &amp;d-&gt;dirs);
			d-&gt;dirloc = 0;
		}
		if(d-&gt;dirsize &lt; 0) {	/* malloc or read failed in _dirread? */
			free(d-&gt;dirs);
			d-&gt;dirs = NULL;
		}
		if(d-&gt;dirs == NULL)
			return NULL;

		dr = (struct dirent *)d-&gt;dd_buf;
		dirs = d-&gt;dirs;
		for(i=0; i&lt;DBLOCKSIZE &amp;&amp; d-&gt;dirloc &lt; d-&gt;dirsize; i++){
			strncpy(dr[i].d_name, dirs[d-&gt;dirloc++].name, MAXNAMLEN);
			dr[i].d_name[MAXNAMLEN] = 0;
		}
		d-&gt;dd_loc = 0;
		d-&gt;dd_size = i*sizeof(struct dirent);
	}
	dr = (struct dirent*)(d-&gt;dd_buf+d-&gt;dd_loc);
	d-&gt;dd_loc += sizeof(struct dirent);
	return dr;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

