<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/plan9/qlock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/plan9/qlock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#define _LOCK_EXTENSION
#define _QLOCK_EXTENSION
#define _RESEARCH_SOURCE
#include &lt;u.h&gt;
#include &lt;lock.h&gt;
#include &lt;qlock.h&gt;
#include &lt;stdlib.h&gt;
#include "sys9.h"

#define rendezvous _RENDEZVOUS
#define _rendezvousp rendezvous
#define _tas tas
#define nelem(x) (sizeof(x)/sizeof((x)[0]))

static struct {
	QLp	*p;
	QLp	x[1024];
} ql = {
	ql.x
};

enum
{
	Queuing,
	QueuingR,
	QueuingW,
	Sleeping,
};

/* find a free shared memory location to queue ourselves in */
static QLp*
getqlp(void)
{
	QLp *p, *op;

	op = ql.p;
	for(p = op+1; ; p++){
		if(p == &amp;ql.x[nelem(ql.x)])
			p = ql.x;
		if(p == op)
			abort();
		if(_tas(&amp;(p-&gt;inuse)) == 0){
			ql.p = p;
			p-&gt;next = nil;
			break;
		}
	}
	return p;
}

void
qlock(QLock *q)
{
	QLp *p, *mp;

	lock(&amp;q-&gt;lock);
	if(!q-&gt;locked){
		q-&gt;locked = 1;
		unlock(&amp;q-&gt;lock);
		return;
	}


	/* chain into waiting list */
	mp = getqlp();
	p = q-&gt;tail;
	if(p == nil)
		q-&gt;head = mp;
	else
		p-&gt;next = mp;
	q-&gt;tail = mp;
	mp-&gt;state = Queuing;
	unlock(&amp;q-&gt;lock);

	/* wait */
	while((*_rendezvousp)((ulong)mp, 1) == ~0)
		;
	mp-&gt;inuse = 0;
}

void
qunlock(QLock *q)
{
	QLp *p;

	lock(&amp;q-&gt;lock);
	p = q-&gt;head;
	if(p != nil){
		/* wakeup head waiting process */
		q-&gt;head = p-&gt;next;
		if(q-&gt;head == nil)
			q-&gt;tail = nil;
		unlock(&amp;q-&gt;lock);
		while((*_rendezvousp)((ulong)p, 0x12345) == ~0)
			;
		return;
	}
	q-&gt;locked = 0;
	unlock(&amp;q-&gt;lock);
}

int
canqlock(QLock *q)
{
	if(!canlock(&amp;q-&gt;lock))
		return 0;
	if(!q-&gt;locked){
		q-&gt;locked = 1;
		unlock(&amp;q-&gt;lock);
		return 1;
	}
	unlock(&amp;q-&gt;lock);
	return 0;
}

#if 0

void
rlock(RWLock *q)
{
	QLp *p, *mp;

	lock(&amp;q-&gt;lock);
	if(q-&gt;writer == 0 &amp;&amp; q-&gt;head == nil){
		/* no writer, go for it */
		q-&gt;readers++;
		unlock(&amp;q-&gt;lock);
		return;
	}

	mp = getqlp();
	p = q-&gt;tail;
	if(p == 0)
		q-&gt;head = mp;
	else
		p-&gt;next = mp;
	q-&gt;tail = mp;
	mp-&gt;next = nil;
	mp-&gt;state = QueuingR;
	unlock(&amp;q-&gt;lock);

	/* wait in kernel */
	while((*_rendezvousp)((ulong)mp, 1) == ~0)
		;
	mp-&gt;inuse = 0;
}

int
canrlock(RWLock *q)
{
	lock(&amp;q-&gt;lock);
	if (q-&gt;writer == 0 &amp;&amp; q-&gt;head == nil) {
		/* no writer; go for it */
		q-&gt;readers++;
		unlock(&amp;q-&gt;lock);
		return 1;
	}
	unlock(&amp;q-&gt;lock);
	return 0;
}

void
runlock(RWLock *q)
{
	QLp *p;

	lock(&amp;q-&gt;lock);
	if(q-&gt;readers &lt;= 0)
		abort();
	p = q-&gt;head;
	if(--(q-&gt;readers) &gt; 0 || p == nil){
		unlock(&amp;q-&gt;lock);
		return;
	}

	/* start waiting writer */
	if(p-&gt;state != QueuingW)
		abort();
	q-&gt;head = p-&gt;next;
	if(q-&gt;head == 0)
		q-&gt;tail = 0;
	q-&gt;writer = 1;
	unlock(&amp;q-&gt;lock);

	/* wakeup waiter */
	while((*_rendezvousp)((ulong)p, 0) == ~0)
		;
}

void
wlock(RWLock *q)
{
	QLp *p, *mp;

	lock(&amp;q-&gt;lock);
	if(q-&gt;readers == 0 &amp;&amp; q-&gt;writer == 0){
		/* noone waiting, go for it */
		q-&gt;writer = 1;
		unlock(&amp;q-&gt;lock);
		return;
	}

	/* wait */
	p = q-&gt;tail;
	mp = getqlp();
	if(p == nil)
		q-&gt;head = mp;
	else
		p-&gt;next = mp;
	q-&gt;tail = mp;
	mp-&gt;next = nil;
	mp-&gt;state = QueuingW;
	unlock(&amp;q-&gt;lock);

	/* wait in kernel */
	while((*_rendezvousp)((ulong)mp, 1) == ~0)
		;
	mp-&gt;inuse = 0;
}

int
canwlock(RWLock *q)
{
	lock(&amp;q-&gt;lock);
	if (q-&gt;readers == 0 &amp;&amp; q-&gt;writer == 0) {
		/* no one waiting; go for it */
		q-&gt;writer = 1;
		unlock(&amp;q-&gt;lock);
		return 1;
	}
	unlock(&amp;q-&gt;lock);
	return 0;
}

void
wunlock(RWLock *q)
{
	QLp *p;

	lock(&amp;q-&gt;lock);
	if(q-&gt;writer == 0)
		abort();
	p = q-&gt;head;
	if(p == nil){
		q-&gt;writer = 0;
		unlock(&amp;q-&gt;lock);
		return;
	}
	if(p-&gt;state == QueuingW){
		/* start waiting writer */
		q-&gt;head = p-&gt;next;
		if(q-&gt;head == nil)
			q-&gt;tail = nil;
		unlock(&amp;q-&gt;lock);
		while((*_rendezvousp)((ulong)p, 0) == ~0)
			;
		return;
	}

	if(p-&gt;state != QueuingR)
		abort();

	/* wake waiting readers */
	while(q-&gt;head != nil &amp;&amp; q-&gt;head-&gt;state == QueuingR){
		p = q-&gt;head;
		q-&gt;head = p-&gt;next;
		q-&gt;readers++;
		while((*_rendezvousp)((ulong)p, 0) == ~0)
			;
	}
	if(q-&gt;head == nil)
		q-&gt;tail = nil;
	q-&gt;writer = 0;
	unlock(&amp;q-&gt;lock);
}

void
rsleep(Rendez *r)
{
	QLp *t, *me;

	if(!r-&gt;l)
		abort();
	lock(&amp;r-&gt;l-&gt;lock);
	/* we should hold the qlock */
	if(!r-&gt;l-&gt;locked)
		abort();

	/* add ourselves to the wait list */
	me = getqlp();
	me-&gt;state = Sleeping;
	if(r-&gt;head == nil)
		r-&gt;head = me;
	else
		r-&gt;tail-&gt;next = me;
	me-&gt;next = nil;
	r-&gt;tail = me;

	/* pass the qlock to the next guy */
	t = r-&gt;l-&gt;head;
	if(t){
		r-&gt;l-&gt;head = t-&gt;next;
		if(r-&gt;l-&gt;head == nil)
			r-&gt;l-&gt;tail = nil;
		unlock(&amp;r-&gt;l-&gt;lock);
		while((*_rendezvousp)((ulong)t, 0x12345) == ~0)
			;
	}else{
		r-&gt;l-&gt;locked = 0;
		unlock(&amp;r-&gt;l-&gt;lock);
	}

	/* wait for a wakeup */
	while((*_rendezvousp)((ulong)me, 1) == ~0)
		;
	me-&gt;inuse = 0;
}

int
rwakeup(Rendez *r)
{
	QLp *t;

	/*
	 * take off wait and put on front of queue
	 * put on front so guys that have been waiting will not get starved
	 */
	
	if(!r-&gt;l)
		abort();
	lock(&amp;r-&gt;l-&gt;lock);
	if(!r-&gt;l-&gt;locked)
		abort();

	t = r-&gt;head;
	if(t == nil){
		unlock(&amp;r-&gt;l-&gt;lock);
		return 0;
	}

	r-&gt;head = t-&gt;next;
	if(r-&gt;head == nil)
		r-&gt;tail = nil;

	t-&gt;next = r-&gt;l-&gt;head;
	r-&gt;l-&gt;head = t;
	if(r-&gt;l-&gt;tail == nil)
		r-&gt;l-&gt;tail = t;

	t-&gt;state = Queuing;
	unlock(&amp;r-&gt;l-&gt;lock);
	return 1;
}

int
rwakeupall(Rendez *r)
{
	int i;

	for(i=0; rwakeup(r); i++)
		;
	return i;
}

#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

