<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/ap/stdio/strtod.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/ap/stdio/strtod.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "fconv.h"

/* strtod for IEEE-, VAX-, and IBM-arithmetic machines (dmg).
 *
 * This strtod returns a nearest machine number to the input decimal
 * string (or sets errno to ERANGE).  With IEEE arithmetic, ties are
 * broken by the IEEE round-even rule.  Otherwise ties are broken by
 * biased rounding (add half and chop).
 *
 * Inspired loosely by William D. Clinger's paper "How to Read Floating
 * Point Numbers Accurately" [Proc. ACM SIGPLAN '90, pp. 92-101].
 *
 * Modifications:
 *
 *	1. We only require IEEE, IBM, or VAX double-precision
 *		arithmetic (not IEEE double-extended).
 *	2. We get by with floating-point arithmetic in a case that
 *		Clinger missed -- when we're computing d * 10^n
 *		for a small integer d and the integer n is not too
 *		much larger than 22 (the maximum integer k for which
 *		we can represent 10^k exactly), we may be able to
 *		compute (d*10^k) * 10^(e-k) with just one roundoff.
 *	3. Rather than a bit-at-a-time adjustment of the binary
 *		result in the hard case, we use floating-point
 *		arithmetic to determine the adjustment to within
 *		one bit; only in really hard cases do we need to
 *		compute a second residual.
 *	4. Because of 3., we don't need a large table of powers of 10
 *		for ten-to-e (just some small tables, e.g. of 10^k
 *		for 0 &lt;= k &lt;= 22).
 */

#ifdef RND_PRODQUOT
#define rounded_product(a,b) a = rnd_prod(a, b)
#define rounded_quotient(a,b) a = rnd_quot(a, b)
extern double rnd_prod(double, double), rnd_quot(double, double);
#else
#define rounded_product(a,b) a *= b
#define rounded_quotient(a,b) a /= b
#endif

 static double
ulp(double xarg)
{
	register long L;
	Dul a;
	Dul x;

	x.d = xarg;
	L = (word0(x) &amp; Exp_mask) - (P-1)*Exp_msk1;
#ifndef Sudden_Underflow
	if (L &gt; 0) {
#endif
#ifdef IBM
		L |= Exp_msk1 &gt;&gt; 4;
#endif
		word0(a) = L;
		word1(a) = 0;
#ifndef Sudden_Underflow
		}
	else {
		L = -L &gt;&gt; Exp_shift;
		if (L &lt; Exp_shift) {
			word0(a) = 0x80000 &gt;&gt; L;
			word1(a) = 0;
			}
		else {
			word0(a) = 0;
			L -= Exp_shift;
			word1(a) = L &gt;= 31 ? 1 : 1 &lt;&lt; 31 - L;
			}
		}
#endif
	return a.d;
	}

 static Bigint *
s2b(CONST char *s, int nd0, int nd, unsigned long y9)
{
	Bigint *b;
	int i, k;
	long x, y;

	x = (nd + 8) / 9;
	for(k = 0, y = 1; x &gt; y; y &lt;&lt;= 1, k++) ;
#ifdef Pack_32
	b = Balloc(k);
	b-&gt;x[0] = y9;
	b-&gt;wds = 1;
#else
	b = Balloc(k+1);
	b-&gt;x[0] = y9 &amp; 0xffff;
	b-&gt;wds = (b-&gt;x[1] = y9 &gt;&gt; 16) ? 2 : 1;
#endif

	i = 9;
	if (9 &lt; nd0) {
		s += 9;
		do b = multadd(b, 10, *s++ - '0');
			while(++i &lt; nd0);
		s++;
		}
	else
		s += 10;
	for(; i &lt; nd; i++)
		b = multadd(b, 10, *s++ - '0');
	return b;
	}

 static double
b2d(Bigint *a, int *e)
{
	unsigned long *xa, *xa0, w, y, z;
	int k;
	Dul d;
#ifdef VAX
	unsigned long d0, d1;
#else
#define d0 word0(d)
#define d1 word1(d)
#endif

	xa0 = a-&gt;x;
	xa = xa0 + a-&gt;wds;
	y = *--xa;
#ifdef DEBUG
	if (!y) Bug("zero y in b2d");
#endif
	k = hi0bits(y);
	*e = 32 - k;
#ifdef Pack_32
	if (k &lt; Ebits) {
		d0 = Exp_1 | y &gt;&gt; Ebits - k;
		w = xa &gt; xa0 ? *--xa : 0;
		d1 = y &lt;&lt; (32-Ebits) + k | w &gt;&gt; Ebits - k;
		goto ret_d;
		}
	z = xa &gt; xa0 ? *--xa : 0;
	if (k -= Ebits) {
		d0 = Exp_1 | y &lt;&lt; k | z &gt;&gt; 32 - k;
		y = xa &gt; xa0 ? *--xa : 0;
		d1 = z &lt;&lt; k | y &gt;&gt; 32 - k;
		}
	else {
		d0 = Exp_1 | y;
		d1 = z;
		}
#else
	if (k &lt; Ebits + 16) {
		z = xa &gt; xa0 ? *--xa : 0;
		d0 = Exp_1 | y &lt;&lt; k - Ebits | z &gt;&gt; Ebits + 16 - k;
		w = xa &gt; xa0 ? *--xa : 0;
		y = xa &gt; xa0 ? *--xa : 0;
		d1 = z &lt;&lt; k + 16 - Ebits | w &lt;&lt; k - Ebits | y &gt;&gt; 16 + Ebits - k;
		goto ret_d;
		}
	z = xa &gt; xa0 ? *--xa : 0;
	w = xa &gt; xa0 ? *--xa : 0;
	k -= Ebits + 16;
	d0 = Exp_1 | y &lt;&lt; k + 16 | z &lt;&lt; k | w &gt;&gt; 16 - k;
	y = xa &gt; xa0 ? *--xa : 0;
	d1 = w &lt;&lt; k + 16 | y &lt;&lt; k;
#endif
 ret_d:
#ifdef VAX
	word0(d) = d0 &gt;&gt; 16 | d0 &lt;&lt; 16;
	word1(d) = d1 &gt;&gt; 16 | d1 &lt;&lt; 16;
#else
#undef d0
#undef d1
#endif
	return d.d;
	}

 static double
ratio(Bigint *a, Bigint *b)
{
	Dul da, db;
	int k, ka, kb;

	da.d = b2d(a, &amp;ka);
	db.d = b2d(b, &amp;kb);
#ifdef Pack_32
	k = ka - kb + 32*(a-&gt;wds - b-&gt;wds);
#else
	k = ka - kb + 16*(a-&gt;wds - b-&gt;wds);
#endif
#ifdef IBM
	if (k &gt; 0) {
		word0(da) += (k &gt;&gt; 2)*Exp_msk1;
		if (k &amp;= 3)
			da *= 1 &lt;&lt; k;
		}
	else {
		k = -k;
		word0(db) += (k &gt;&gt; 2)*Exp_msk1;
		if (k &amp;= 3)
			db *= 1 &lt;&lt; k;
		}
#else
	if (k &gt; 0)
		word0(da) += k*Exp_msk1;
	else {
		k = -k;
		word0(db) += k*Exp_msk1;
		}
#endif
	return da.d / db.d;
	}

 double
strtod(CONST char *s00, char **se)
{
	int bb2, bb5, bbe, bd2, bd5, bbbits, bs2, c, dsign,
		 e, e1, esign, i, j, k, nd, nd0, nf, nz, nz0, sign;
	CONST char *s, *s0, *s1;
	double aadj, aadj1, adj;
	Dul rv, rv0;
	long L;
	unsigned long y, z;
	Bigint *bb, *bb1, *bd, *bd0, *bs, *delta;
	sign = nz0 = nz = 0;
	rv.d = 0.;
	for(s = s00;;s++) switch(*s) {
		case '-':
			sign = 1;
			/* no break */
		case '+':
			if (*++s)
				goto break2;
			/* no break */
		case 0:
			s = s00;
			goto ret;
		case '\t':
		case '\n':
		case '\v':
		case '\f':
		case '\r':
		case ' ':
			continue;
		default:
			goto break2;
		}
 break2:
	if (*s == '0') {
		nz0 = 1;
		while(*++s == '0') ;
		if (!*s)
			goto ret;
		}
	s0 = s;
	y = z = 0;
	for(nd = nf = 0; (c = *s) &gt;= '0' &amp;&amp; c &lt;= '9'; nd++, s++)
		if (nd &lt; 9)
			y = 10*y + c - '0';
		else if (nd &lt; 16)
			z = 10*z + c - '0';
	nd0 = nd;
	if (c == '.') {
		c = *++s;
		if (!nd) {
			for(; c == '0'; c = *++s)
				nz++;
			if (c &gt; '0' &amp;&amp; c &lt;= '9') {
				s0 = s;
				nf += nz;
				nz = 0;
				goto have_dig;
				}
			goto dig_done;
			}
		for(; c &gt;= '0' &amp;&amp; c &lt;= '9'; c = *++s) {
 have_dig:
			nz++;
			if (c -= '0') {
				nf += nz;
				for(i = 1; i &lt; nz; i++)
					if (nd++ &lt; 9)
						y *= 10;
					else if (nd &lt;= DBL_DIG + 1)
						z *= 10;
				if (nd++ &lt; 9)
					y = 10*y + c;
				else if (nd &lt;= DBL_DIG + 1)
					z = 10*z + c;	
				nz = 0;
				}
			}
		}
 dig_done:
	e = 0;
	if (c == 'e' || c == 'E') {
		if (!nd &amp;&amp; !nz &amp;&amp; !nz0) {
			s = s00;
			goto ret;
			}
		s00 = s;
		esign = 0;
		switch(c = *++s) {
			case '-':
				esign = 1;
			case '+':
				c = *++s;
			}
		if (c &gt;= '0' &amp;&amp; c &lt;= '9') {
			while(c == '0')
				c = *++s;
			if (c &gt; '0' &amp;&amp; c &lt;= '9') {
				e = c - '0';
				s1 = s;
				while((c = *++s) &gt;= '0' &amp;&amp; c &lt;= '9')
					e = 10*e + c - '0';
				if (s - s1 &gt; 8)
					/* Avoid confusion from exponents
					 * so large that e might overflow.
					 */
					e = 9999999;
				if (esign)
					e = -e;
				}
			else
				e = 0;
			}
		else
			s = s00;
		}
	if (!nd) {
		if (!nz &amp;&amp; !nz0)
			s = s00;
		goto ret;
		}
	e1 = e -= nf;

	/* Now we have nd0 digits, starting at s0, followed by a
	 * decimal point, followed by nd-nd0 digits.  The number we're
	 * after is the integer represented by those digits times
	 * 10**e */

	if (!nd0)
		nd0 = nd;
	k = nd &lt; DBL_DIG + 1 ? nd : DBL_DIG + 1;
	rv.d = y;
	if (k &gt; 9)
		rv.d = tens[k - 9] * rv.d + z;
	bd0 = 0;
	if (nd &lt;= DBL_DIG
#ifndef RND_PRODQUOT
		&amp;&amp; FLT_ROUNDS == 1
#endif
			) {
		if (!e)
			goto ret;
		if (e &gt; 0) {
			if (e &lt;= Ten_pmax) {
#ifdef VAX
				goto vax_ovfl_check;
#else
				/* rv = */ rounded_product(rv.d, tens[e]);
				goto ret;
#endif
				}
			i = DBL_DIG - nd;
			if (e &lt;= Ten_pmax + i) {
				/* A fancier test would sometimes let us do
				 * this for larger i values.
				 */
				e -= i;
				rv.d *= tens[i];
#ifdef VAX
				/* VAX exponent range is so narrow we must
				 * worry about overflow here...
				 */
 vax_ovfl_check:
				word0(rv) -= P*Exp_msk1;
				/* rv = */ rounded_product(rv.d, tens[e]);
				if ((word0(rv) &amp; Exp_mask)
				 &gt; Exp_msk1*(DBL_MAX_EXP+Bias-1-P))
					goto ovfl;
				word0(rv) += P*Exp_msk1;
#else
				/* rv = */ rounded_product(rv.d, tens[e]);
#endif
				goto ret;
				}
			}
		else if (e &gt;= -Ten_pmax) {
			/* rv = */ rounded_quotient(rv.d, tens[-e]);
			goto ret;
			}
		}
	e1 += nd - k;

	/* Get starting approximation = rv * 10**e1 */

	if (e1 &gt; 0) {
		if (nd0 + e1 - 1 &gt; DBL_MAX_10_EXP)
			goto ovfl;
		if (i = e1 &amp; 15)
			rv.d *= tens[i];
		if (e1 &amp;= ~15) {
			if (e1 &gt; DBL_MAX_10_EXP) {
 ovfl:
				errno = ERANGE;
				rv.d = HUGE_VAL;
				if (bd0)
					goto retfree;
				goto ret;
				}
			if (e1 &gt;&gt;= 4) {
				for(j = 0; e1 &gt; 1; j++, e1 &gt;&gt;= 1)
					if (e1 &amp; 1)
						rv.d *= bigtens[j];
			/* The last multiplication could overflow. */
				word0(rv) -= P*Exp_msk1;
				rv.d *= bigtens[j];
				if ((z = word0(rv) &amp; Exp_mask)
				 &gt; Exp_msk1*(DBL_MAX_EXP+Bias-P))
					goto ovfl;
				if (z &gt; Exp_msk1*(DBL_MAX_EXP+Bias-1-P)) {
					/* set to largest number */
					/* (Can't trust DBL_MAX) */
					word0(rv) = Big0;
					word1(rv) = Big1;
					}
				else
					word0(rv) += P*Exp_msk1;
				}

			}
		}
	else if (e1 &lt; 0) {
		e1 = -e1;
		if (i = e1 &amp; 15)
			rv.d /= tens[i];
		if (e1 &amp;= ~15) {
			e1 &gt;&gt;= 4;
			if (e1 &gt;= 1 &lt;&lt; n_bigtens)
				goto undfl;
			for(j = 0; e1 &gt; 1; j++, e1 &gt;&gt;= 1)
				if (e1 &amp; 1)
					rv.d *= tinytens[j];
			/* The last multiplication could underflow. */
			rv0.d = rv.d;
			rv.d *= tinytens[j];
			if (rv.d == 0) {
				rv.d = 2.*rv0.d;
				rv.d *= tinytens[j];
				if (rv.d == 0) {
 undfl:
					rv.d = 0.;
					errno = ERANGE;
					if (bd0)
						goto retfree;
					goto ret;
					}
				word0(rv) = Tiny0;
				word1(rv) = Tiny1;
				/* The refinement below will clean
				 * this approximation up.
				 */
				}
			}
		}

	/* Now the hard part -- adjusting rv to the correct value.*/

	/* Put digits into bd: true value = bd * 10^e */

	bd0 = s2b(s0, nd0, nd, y);

	for(;;) {
		bd = Balloc(bd0-&gt;k);
		Bcopy(bd, bd0);
		bb = d2b(rv.d, &amp;bbe, &amp;bbbits);	/* rv = bb * 2^bbe */
		bs = i2b(1);

		if (e &gt;= 0) {
			bb2 = bb5 = 0;
			bd2 = bd5 = e;
			}
		else {
			bb2 = bb5 = -e;
			bd2 = bd5 = 0;
			}
		if (bbe &gt;= 0)
			bb2 += bbe;
		else
			bd2 -= bbe;
		bs2 = bb2;
#ifdef Sudden_Underflow
#ifdef IBM
		j = 1 + 4*P - 3 - bbbits + ((bbe + bbbits - 1) &amp; 3);
#else
		j = P + 1 - bbbits;
#endif
#else
		i = bbe + bbbits - 1;	/* logb(rv) */
		if (i &lt; Emin)	/* denormal */
			j = bbe + (P-Emin);
		else
			j = P + 1 - bbbits;
#endif
		bb2 += j;
		bd2 += j;
		i = bb2 &lt; bd2 ? bb2 : bd2;
		if (i &gt; bs2)
			i = bs2;
		if (i &gt; 0) {
			bb2 -= i;
			bd2 -= i;
			bs2 -= i;
			}
		if (bb5 &gt; 0) {
			bs = pow5mult(bs, bb5);
			bb1 = mult(bs, bb);
			Bfree(bb);
			bb = bb1;
			}
		if (bb2 &gt; 0)
			bb = lshift(bb, bb2);
		if (bd5 &gt; 0)
			bd = pow5mult(bd, bd5);
		if (bd2 &gt; 0)
			bd = lshift(bd, bd2);
		if (bs2 &gt; 0)
			bs = lshift(bs, bs2);
		delta = diff(bb, bd);
		dsign = delta-&gt;sign;
		delta-&gt;sign = 0;
		i = cmp(delta, bs);
		if (i &lt; 0) {
			/* Error is less than half an ulp -- check for
			 * special case of mantissa a power of two.
			 */
			if (dsign || word1(rv) || word0(rv) &amp; Bndry_mask)
				break;
			delta = lshift(delta,Log2P);
			if (cmp(delta, bs) &gt; 0)
				goto drop_down;
			break;
			}
		if (i == 0) {
			/* exactly half-way between */
			if (dsign) {
				if ((word0(rv) &amp; Bndry_mask1) == Bndry_mask1
				 &amp;&amp;  word1(rv) == 0xffffffff) {
					/*boundary case -- increment exponent*/
					word0(rv) = (word0(rv) &amp; Exp_mask)
						+ Exp_msk1
#ifdef IBM
						| Exp_msk1 &gt;&gt; 4
#endif
						;
					word1(rv) = 0;
					break;
					}
				}
			else if (!(word0(rv) &amp; Bndry_mask) &amp;&amp; !word1(rv)) {
 drop_down:
				/* boundary case -- decrement exponent */
#ifdef Sudden_Underflow
				L = word0(rv) &amp; Exp_mask;
#ifdef IBM
				if (L &lt;  Exp_msk1)
#else
				if (L &lt;= Exp_msk1)
#endif
					goto undfl;
				L -= Exp_msk1;
#else
				L = (word0(rv) &amp; Exp_mask) - Exp_msk1;
#endif
				word0(rv) = L | Bndry_mask1;
				word1(rv) = 0xffffffff;
#ifdef IBM
				goto cont;
#else
				break;
#endif
				}
#ifndef ROUND_BIASED
			if (!(word1(rv) &amp; LSB))
				break;
#endif
			if (dsign)
				rv.d += ulp(rv.d);
#ifndef ROUND_BIASED
			else {
				rv.d -= ulp(rv.d);
#ifndef Sudden_Underflow
				if (rv.d == 0)
					goto undfl;
#endif
				}
#endif
			break;
			}
		if ((aadj = ratio(delta, bs)) &lt;= 2.) {
			if (dsign)
				aadj = aadj1 = 1.;
			else if (word1(rv) || word0(rv) &amp; Bndry_mask) {
#ifndef Sudden_Underflow
				if (word1(rv) == Tiny1 &amp;&amp; !word0(rv))
					goto undfl;
#endif
				aadj = 1.;
				aadj1 = -1.;
				}
			else {
				/* special case -- power of FLT_RADIX to be */
				/* rounded down... */

				if (aadj &lt; 2./FLT_RADIX)
					aadj = 1./FLT_RADIX;
				else
					aadj *= 0.5;
				aadj1 = -aadj;
				}
			}
		else {
			aadj *= 0.5;
			aadj1 = dsign ? aadj : -aadj;
#ifdef Check_FLT_ROUNDS
			switch(FLT_ROUNDS) {
				case 2: /* towards +infinity */
					aadj1 -= 0.5;
					break;
				case 0: /* towards 0 */
				case 3: /* towards -infinity */
					aadj1 += 0.5;
				}
#else
			if (FLT_ROUNDS == 0)
				aadj1 += 0.5;
#endif
			}
		y = word0(rv) &amp; Exp_mask;

		/* Check for overflow */

		if (y == Exp_msk1*(DBL_MAX_EXP+Bias-1)) {
			rv0.d = rv.d;
			word0(rv) -= P*Exp_msk1;
			adj = aadj1 * ulp(rv.d);
			rv.d += adj;
			if ((word0(rv) &amp; Exp_mask) &gt;=
					Exp_msk1*(DBL_MAX_EXP+Bias-P)) {
				if (word0(rv0) == Big0 &amp;&amp; word1(rv0) == Big1)
					goto ovfl;
				word0(rv) = Big0;
				word1(rv) = Big1;
				goto cont;
				}
			else
				word0(rv) += P*Exp_msk1;
			}
		else {
#ifdef Sudden_Underflow
			if ((word0(rv) &amp; Exp_mask) &lt;= P*Exp_msk1) {
				rv0.d = rv.d;
				word0(rv) += P*Exp_msk1;
				adj = aadj1 * ulp(rv.d);
				rv.d += adj;
#ifdef IBM
				if ((word0(rv) &amp; Exp_mask) &lt;  P*Exp_msk1)
#else
				if ((word0(rv) &amp; Exp_mask) &lt;= P*Exp_msk1)
#endif
					{
					if (word0(rv0) == Tiny0
					 &amp;&amp; word1(rv0) == Tiny1)
						goto undfl;
					word0(rv) = Tiny0;
					word1(rv) = Tiny1;
					goto cont;
					}
				else
					word0(rv) -= P*Exp_msk1;
				}
			else {
				adj = aadj1 * ulp(rv.d);
				rv.d += adj;
				}
#else
			/* Compute adj so that the IEEE rounding rules will
			 * correctly round rv + adj in some half-way cases.
			 * If rv * ulp(rv) is denormalized (i.e.,
			 * y &lt;= (P-1)*Exp_msk1), we must adjust aadj to avoid
			 * trouble from bits lost to denormalization;
			 * example: 1.2e-307 .
			 */
			if (y &lt;= (P-1)*Exp_msk1 &amp;&amp; aadj &gt;= 1.) {
				aadj1 = (double)(int)(aadj + 0.5);
				if (!dsign)
					aadj1 = -aadj1;
				}
			adj = aadj1 * ulp(rv.d);
			rv.d += adj;
#endif
			}
		z = word0(rv) &amp; Exp_mask;
		if (y == z) {
			/* Can we stop now? */
			L = aadj;
			aadj -= L;
			/* The tolerances below are conservative. */
			if (dsign || word1(rv) || word0(rv) &amp; Bndry_mask) {
				if (aadj &lt; .4999999 || aadj &gt; .5000001)
					break;
				}
			else if (aadj &lt; .4999999/FLT_RADIX)
				break;
			}
 cont:
		Bfree(bb);
		Bfree(bd);
		Bfree(bs);
		Bfree(delta);
		}
 retfree:
	Bfree(bb);
	Bfree(bd);
	Bfree(bs);
	Bfree(bd0);
	Bfree(delta);
 ret:
	if (se)
		*se = (char *)s;
	return sign ? -rv.d : rv.d;
	}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

