<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/regexp/rregexec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/regexp/rregexec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdlib.h&gt;
#include &lt;stdio.h&gt;
#include "regexp.h"
#include "regcomp.h"

static Resublist sempty;		/* empty set of matches */

/*
 *  return	0 if no match
 *		&gt;0 if a match
 *		&lt;0 if we ran out of _relist space
 */
static int
rregexec1(Reprog *progp,	/* program to run */
	wchar_t *bol,		/* string to run machine on */
	Resub *mp,		/* subexpression elements */
	int ms,			/* number of elements at mp */
	wchar_t *starts,
	wchar_t *eol,
	wchar_t startchar)
{
	int flag=0;
	Reinst *inst;
	Relist *tlp;
	wchar_t *s;
	int i, checkstart;
	wchar_t r, *rp, *ep;
	Relist* tl;		/* This list, next list */
	Relist* nl;
	Relist* tle;		/* ends of this and next list */
	Relist* nle;
	int match;

	match = 0;
	checkstart = startchar;
	sempty.m[0].s.rsp = 0;
	if(mp!=0)
		for(i=0; i&lt;ms; i++)
			mp[i].s.rsp = mp[i].e.rep = 0;
	_relist[0][0].inst = _relist[1][0].inst = 0;

	/* Execute machine once for each character, including terminal NUL */
	s = starts;
	do{
		r = *s;

		/* fast check for first char */
		if(checkstart &amp;&amp; r!=startchar){
			s++;
			continue;
		}

		/* switch run lists */
		tl = _relist[flag];
		tle = _reliste[flag];
		nl = _relist[flag^=1];
		nle = _reliste[flag];
		nl-&gt;inst = 0;

		/* Add first instruction to current list */
		sempty.m[0].s.rsp = s;
		_renewthread(tl, progp-&gt;startinst, &amp;sempty);

		/* Execute machine until current list is empty */
		for(tlp=tl; tlp-&gt;inst; tlp++){	/* assignment = */
			if(s == eol)
				break;

			for(inst=tlp-&gt;inst; ; inst = inst-&gt;l.next){
				switch(inst-&gt;type){
				case RUNE:	/* regular character */
					if(inst-&gt;r.r == r)
						if(_renewthread(nl, inst-&gt;l.next, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case LBRA:
					tlp-&gt;se.m[inst-&gt;r.subid].s.rsp = s;
					continue;
				case RBRA:
					tlp-&gt;se.m[inst-&gt;r.subid].e.rep = s;
					continue;
				case ANY:
					if(r != '\n')
						if(_renewthread(nl, inst-&gt;l.next, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case ANYNL:
					if(_renewthread(nl, inst-&gt;l.next, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case BOL:
					if(s == bol || *(s-1) == '\n')
						continue;
					break;
				case EOL:
					if(r == 0 || r == '\n')
						continue;
					break;
				case CCLASS:
					ep = inst-&gt;r.cp-&gt;end;
					for(rp = inst-&gt;r.cp-&gt;spans; rp &lt; ep; rp += 2)
						if(r &gt;= rp[0] &amp;&amp; r &lt;= rp[1]){
							if(_renewthread(nl, inst-&gt;l.next, &amp;tlp-&gt;se)==nle)
								return -1;
							break;
						}
					break;
				case NCCLASS:
					ep = inst-&gt;r.cp-&gt;end;
					for(rp = inst-&gt;r.cp-&gt;spans; rp &lt; ep; rp += 2)
						if(r &gt;= rp[0] &amp;&amp; r &lt;= rp[1])
							break;
					if(rp == ep)
						if(_renewthread(nl, inst-&gt;l.next, &amp;tlp-&gt;se)==nle)
							return -1;
					break;
				case OR:
					/* evaluate right choice later */
					if(_renewthread(tlp, inst-&gt;r.right, &amp;tlp-&gt;se) == tle)
						return -1;
					/* efficiency: advance and re-evaluate */
					continue;
				case END:	/* Match! */
					match = 1;
					tlp-&gt;se.m[0].e.rep = s;
					if(mp != 0)
						_renewmatch(mp, ms, &amp;tlp-&gt;se);
					break;
				}
				break;
			}
		}
		checkstart = startchar &amp;&amp; nl-&gt;inst==0;
		s++;
	}while(r);
	return match;
}

extern int
rregexec(Reprog *progp,	/* program to run */
	wchar_t *bol,	/* string to run machine on */
	Resub *mp,	/* subexpression elements */
	int ms)		/* number of elements at mp */
{
	wchar_t *starts;	/* where to start match */
	wchar_t *eol;	/* where to end match */
	wchar_t startchar;
	int rv;

	/*
 	 *  use user-specified starting/ending location if specified
	 */
	starts = bol;
	eol = 0;
	if(mp &amp;&amp; ms&gt;0){
		if(mp-&gt;s.rsp)
			starts = mp-&gt;s.rsp;
		if(mp-&gt;e.rep)
			eol = mp-&gt;e.rep;
	}
	startchar = progp-&gt;startinst-&gt;type == RUNE ? progp-&gt;startinst-&gt;r.r : 0;

	/* keep trying till we have enough list space to terminate */
	for(;;){
		if(_relist[0] == 0){
			_relist[0] = malloc(2*_relistsize*sizeof(Relist));
			_relist[1] = _relist[0] + _relistsize;
			_reliste[0] = _relist[0] + _relistsize - 1;
			_reliste[1] = _relist[1] + _relistsize - 1;
			if(_relist[0] == 0)
				regerror("_relist overflow");
		}
		rv = rregexec1(progp, bol, mp, ms, starts, eol, startchar);
		if(rv &gt;= 0)
			return rv;
		free(_relist[0]);
		_relist[0] = 0;
		_relistsize += LISTINCREMENT;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

