<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/ape/lib/sec/port/x509-ape.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/ape/lib/sec/port/x509-ape.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;

typedef DigestState*(*DigestFun)(uchar*,ulong,uchar*,DigestState*);

/* ANSI offsetof, backwards. */
#define	OFFSETOF(a, b)	offsetof(b, a)

/*=============================================================*/
/*  general ASN1 declarations and parsing
 *
 *  For now, this is used only for extracting the key from an
 *  X509 certificate, so the entire collection is hidden.  But
 *  someday we should probably make the functions visible and
 *  give them their own man page.
 */
typedef struct Elem Elem;
typedef struct Tag Tag;
typedef struct Value Value;
typedef struct Bytes Bytes;
typedef struct Ints Ints;
typedef struct Bits Bits;
typedef struct Elist Elist;

/* tag classes */
#define Universal 0
#define Context 0x80

/* universal tags */
#define BOOLEAN 1
#define INTEGER 2
#define BIT_STRING 3
#define OCTET_STRING 4
#define NULLTAG 5
#define OBJECT_ID 6
#define ObjectDescriptor 7
#define EXTERNAL 8
#define REAL 9
#define ENUMERATED 10
#define EMBEDDED_PDV 11
#define UTF8String 12
#define SEQUENCE 16		/* also SEQUENCE OF */
#define SETOF 17				/* also SETOF OF */
#define NumericString 18
#define PrintableString 19
#define TeletexString 20
#define VideotexString 21
#define IA5String 22
#define UTCTime 23
#define GeneralizedTime 24
#define GraphicString 25
#define VisibleString 26
#define GeneralString 27
#define UniversalString 28
#define BMPString 30

struct Bytes {
	int	len;
	uchar	data[1];
};

struct Ints {
	int	len;
	int	data[1];
};

struct Bits {
	int	len;		/* number of bytes */
	int	unusedbits;	/* unused bits in last byte */
	uchar	data[1];	/* most-significant bit first */
};

struct Tag {
	int	class;
	int	num;
};

enum { VBool, VInt, VOctets, VBigInt, VReal, VOther,
	VBitString, VNull, VEOC, VObjId, VString, VSeq, VSet };
struct Value {
	int	tag;		/* VBool, etc. */
	union {
		int	boolval;
		int	intval;
		Bytes*	octetsval;
		Bytes*	bigintval;
		Bytes*	realval;	/* undecoded; hardly ever used */
		Bytes*	otherval;
		Bits*	bitstringval;
		Ints*	objidval;
		char*	stringval;
		Elist*	seqval;
		Elist*	setval;
	} u;  /* (Don't use anonymous unions, for ease of porting) */
};

struct Elem {
	Tag	tag;
	Value	val;
};

struct Elist {
	Elist*	tl;
	Elem	hd;
};

/* decoding errors */
enum { ASN_OK, ASN_ESHORT, ASN_ETOOBIG, ASN_EVALLEN,
		ASN_ECONSTR, ASN_EPRIM, ASN_EINVAL, ASN_EUNIMPL };


/* here are the functions to consider making extern someday */
static Bytes*	newbytes(int len);
static Bytes*	makebytes(uchar* buf, int len);
static void	freebytes(Bytes* b);
static Bytes*	catbytes(Bytes* b1, Bytes* b2);
static Ints*	newints(int len);
static Ints*	makeints(int* buf, int len);
static void	freeints(Ints* b);
static Bits*	newbits(int len);
static Bits*	makebits(uchar* buf, int len, int unusedbits);
static void	freebits(Bits* b);
static Elist*	mkel(Elem e, Elist* tail);
static void	freeelist(Elist* el);
static int	elistlen(Elist* el);
static int	is_seq(Elem* pe, Elist** pseq);
static int	is_set(Elem* pe, Elist** pset);
static int	is_int(Elem* pe, int* pint);
static int	is_bigint(Elem* pe, Bytes** pbigint);
static int	is_bitstring(Elem* pe, Bits** pbits);
static int	is_octetstring(Elem* pe, Bytes** poctets);
static int	is_oid(Elem* pe, Ints** poid);
static int	is_string(Elem* pe, char** pstring);
static int	is_time(Elem* pe, char** ptime);
static int	decode(uchar* a, int alen, Elem* pelem);
static int	decode_seq(uchar* a, int alen, Elist** pelist);
static int	decode_value(uchar* a, int alen, int kind, int isconstr, Value* pval);
static int	encode(Elem e, Bytes** pbytes);
static int	oid_lookup(Ints* o, Ints** tab);
static void	freevalfields(Value* v);
static mpint	*asn1mpint(Elem *e);



#define TAG_MASK 0x1F
#define CONSTR_MASK 0x20
#define CLASS_MASK 0xC0
#define MAXOBJIDLEN 20

static int ber_decode(uchar** pp, uchar* pend, Elem* pelem);
static int tag_decode(uchar** pp, uchar* pend, Tag* ptag, int* pisconstr);
static int length_decode(uchar** pp, uchar* pend, int* plength);
static int value_decode(uchar** pp, uchar* pend, int length, int kind, int isconstr, Value* pval);
static int int_decode(uchar** pp, uchar* pend, int count, int unsgned, int* pint);
static int uint7_decode(uchar** pp, uchar* pend, int* pint);
static int octet_decode(uchar** pp, uchar* pend, int length, int isconstr, Bytes** pbytes);
static int seq_decode(uchar** pp, uchar* pend, int length, int isconstr, Elist** pelist);
static int enc(uchar** pp, Elem e, int lenonly);
static int val_enc(uchar** pp, Elem e, int *pconstr, int lenonly);
static void uint7_enc(uchar** pp, int num, int lenonly);
static void int_enc(uchar** pp, int num, int unsgned, int lenonly);

static void *
emalloc(int n)
{
	void *p;
	if(n==0)
		n=1;
	p = malloc(n);
	if(p == nil){
		exits("out of memory");
	}
	memset(p, 0, n);
	setmalloctag(p, getcallerpc(&amp;n));
	return p;
}

static char*
estrdup(char *s)
{
	char *d, *d0;

	if(!s)
		return 0;
	d = d0 = emalloc(strlen(s)+1);
	while(*d++ = *s++)
		;
	return d0;
}


/*
 * Decode a[0..len] as a BER encoding of an ASN1 type.
 * The return value is one of ASN_OK, etc.
 * Depending on the error, the returned elem may or may not
 * be nil.
 */
static int
decode(uchar* a, int alen, Elem* pelem)
{
	uchar* p = a;

	return  ber_decode(&amp;p, &amp;a[alen], pelem);
}

/*
 * Like decode, but continue decoding after first element
 * of array ends.
 */
static int
decode_seq(uchar* a, int alen, Elist** pelist)
{
	uchar* p = a;

	return seq_decode(&amp;p, &amp;a[alen], -1, 1, pelist);
}

/*
 * Decode the whole array as a BER encoding of an ASN1 value,
 * (i.e., the part after the tag and length).
 * Assume the value is encoded as universal tag "kind".
 * The constr arg is 1 if the value is constructed, 0 if primitive.
 * If there's an error, the return string will contain the error.
 * Depending on the error, the returned value may or may not
 * be nil.
 */
static int
decode_value(uchar* a, int alen, int kind, int isconstr, Value* pval)
{
	uchar* p = a;

	return value_decode(&amp;p, &amp;a[alen], alen, kind, isconstr, pval);
}

/*
 * All of the following decoding routines take arguments:
 *	uchar **pp;
 *	uchar *pend;
 * Where parsing is supposed to start at **pp, and when parsing
 * is done, *pp is updated to point at next char to be parsed.
 * The pend pointer is just past end of string; an error should
 * be returned parsing hasn't finished by then.
 *
 * The returned int is ASN_OK if all went fine, else ASN_ESHORT, etc.
 * The remaining argument(s) are pointers to where parsed entity goes.
 */

/* Decode an ASN1 'Elem' (tag, length, value) */
static int
ber_decode(uchar** pp, uchar* pend, Elem* pelem)
{
	int err;
	int isconstr;
	int length;
	Tag tag;
	Value val;

	err = tag_decode(pp, pend, &amp;tag, &amp;isconstr);
	if(err == ASN_OK) {
		err = length_decode(pp, pend, &amp;length);
		if(err == ASN_OK) {
			if(tag.class == Universal) {
				err = value_decode(pp, pend, length, tag.num, isconstr, &amp;val);
				if(val.tag == VSeq || val.tag == VSet)
					setmalloctag(val.u.seqval, getcallerpc(&amp;pp));
			}else
				err = value_decode(pp, pend, length, OCTET_STRING, 0, &amp;val);
			if(err == ASN_OK) {
				pelem-&gt;tag = tag;
				pelem-&gt;val = val;
			}
		}
	}
	return err;
}

/* Decode a tag field */
static int
tag_decode(uchar** pp, uchar* pend, Tag* ptag, int* pisconstr)
{
	int err;
	int v;
	uchar* p;

	err = ASN_OK;
	p = *pp;
	if(pend-p &gt;= 2) {
		v = *p++;
		ptag-&gt;class = v&amp;CLASS_MASK;
		if(v&amp;CONSTR_MASK)
			*pisconstr = 1;
		else
			*pisconstr = 0;
		v &amp;= TAG_MASK;
		if(v == TAG_MASK)
			err = uint7_decode(&amp;p, pend, &amp;v);
		ptag-&gt;num = v;
	}
	else
		err = ASN_ESHORT;
	*pp = p;
	return err;
}

/* Decode a length field */
static int
length_decode(uchar** pp, uchar* pend, int* plength)
{
	int err;
	int num;
	int v;
	uchar* p;

	err = ASN_OK;
	num = 0;
	p = *pp;
	if(p &lt; pend) {
		v = *p++;
		if(v&amp;0x80)
			err = int_decode(&amp;p, pend, v&amp;0x7F, 1, &amp;num);
		else
			num = v;
	}
	else
		err = ASN_ESHORT;
	*pp = p;
	*plength = num;
	return err;
}

/* Decode a value field  */
static int
value_decode(uchar** pp, uchar* pend, int length, int kind, int isconstr, Value* pval)
{
	int err;
	Bytes* va;
	int num;
	int bitsunused;
	int subids[MAXOBJIDLEN];
	int isubid;
	Elist*	vl;
	uchar* p;
	uchar* pe;

	err = ASN_OK;
	p = *pp;
	if(length == -1) {	/* "indefinite" length spec */
		if(!isconstr)
			err = ASN_EINVAL;
	}
	else if(p + length &gt; pend)
		err = ASN_EVALLEN;
	if(err != ASN_OK)
		return err;

	switch(kind) {
	case 0:
		/* marker for end of indefinite constructions */
		if(length == 0)
			pval-&gt;tag = VNull;
		else
			err = ASN_EINVAL;
		break;

	case BOOLEAN:
		if(isconstr)
			err = ASN_ECONSTR;
		else if(length != 1)
			err = ASN_EVALLEN;
		else {
			pval-&gt;tag = VBool;
			pval-&gt;u.boolval = (*p++ != 0);
		}
		break;

	case INTEGER:
	case ENUMERATED:
		if(isconstr)
			err = ASN_ECONSTR;
		else if(length &lt;= 4) {
			err = int_decode(&amp;p, pend, length, 0, &amp;num);
			if(err == ASN_OK) {
				pval-&gt;tag = VInt;
				pval-&gt;u.intval = num;
			}
		}
		else {
			pval-&gt;tag = VBigInt;
			pval-&gt;u.bigintval = makebytes(p, length);
			p += length;
		}
		break;

	case BIT_STRING:
		pval-&gt;tag = VBitString;
		if(isconstr) {
			if(length == -1 &amp;&amp; p + 2 &lt;= pend &amp;&amp; *p == 0 &amp;&amp; *(p+1) ==0) {
				pval-&gt;u.bitstringval = makebits(0, 0, 0);
				p += 2;
			}
			else
				/* TODO: recurse and concat results */
				err = ASN_EUNIMPL;
		}
		else {
			if(length &lt; 2) {
				if(length == 1 &amp;&amp; *p == 0) {
					pval-&gt;u.bitstringval = makebits(0, 0, 0);
					p++;
				}
				else
					err = ASN_EINVAL;
			}
			else {
				bitsunused = *p;
				if(bitsunused &gt; 7)
					err = ASN_EINVAL;
				else if(length &gt; 0x0FFFFFFF)
					err = ASN_ETOOBIG;
				else {
					pval-&gt;u.bitstringval = makebits(p+1, length-1, bitsunused);
					p += length;
				}
			}
		}
		break;

	case OCTET_STRING:
	case ObjectDescriptor:
		err = octet_decode(&amp;p, pend, length, isconstr, &amp;va);
		if(err == ASN_OK) {
			pval-&gt;tag = VOctets;
			pval-&gt;u.octetsval = va;
		}
		break;

	case NULLTAG:
		if(isconstr)
			err = ASN_ECONSTR;
		else if(length != 0)
			err = ASN_EVALLEN;
		else
			pval-&gt;tag = VNull;
		break;

	case OBJECT_ID:
		if(isconstr)
			err = ASN_ECONSTR;
		else if(length == 0)
			err = ASN_EVALLEN;
		else {
			isubid = 0;
			pe = p+length;
			while(p &lt; pe &amp;&amp; isubid &lt; MAXOBJIDLEN) {
				err = uint7_decode(&amp;p, pend, &amp;num);
				if(err != ASN_OK)
					break;
				if(isubid == 0) {
					subids[isubid++] = num / 40;
					subids[isubid++] = num % 40;
				}
				else
					subids[isubid++] = num;
			}
			if(err == ASN_OK) {
				if(p != pe)
					err = ASN_EVALLEN;
				else {
					pval-&gt;tag = VObjId;
					pval-&gt;u.objidval = makeints(subids, isubid);
				}
			}
		}
		break;

	case EXTERNAL:
	case EMBEDDED_PDV:
		/* TODO: parse this internally */
		if(p+length &gt; pend)
			err = ASN_EVALLEN;
		else {
			pval-&gt;tag = VOther;
			pval-&gt;u.otherval = makebytes(p, length);
			p += length;
		}
		break;

	case REAL:
		/* Let the application decode */
		if(isconstr)
			err = ASN_ECONSTR;
		else if(p+length &gt; pend)
			err = ASN_EVALLEN;
		else {
			pval-&gt;tag = VReal;
			pval-&gt;u.realval = makebytes(p, length);
			p += length;
		}
		break;

	case SEQUENCE:
		err = seq_decode(&amp;p, pend, length, isconstr, &amp;vl);
		setmalloctag(vl, getcallerpc(&amp;pp));
		if(err == ASN_OK) {
			pval-&gt;tag = VSeq ;
			pval-&gt;u.seqval = vl;
		}
		break;

	case SETOF:
		err = seq_decode(&amp;p, pend, length, isconstr, &amp;vl);
		setmalloctag(vl, getcallerpc(&amp;pp));
		if(err == ASN_OK) {
			pval-&gt;tag = VSet;
			pval-&gt;u.setval = vl;
		}
		break;
	case UTF8String:
	case NumericString:
	case PrintableString:
	case TeletexString:
	case VideotexString:
	case IA5String:
	case UTCTime:
	case GeneralizedTime:
	case GraphicString:
	case VisibleString:
	case GeneralString:
	case UniversalString:
	case BMPString:
		/* TODO: figure out when character set conversion is necessary */
		err = octet_decode(&amp;p, pend, length, isconstr, &amp;va);
		if(err == ASN_OK) {
			pval-&gt;tag = VString;
			pval-&gt;u.stringval = (char*)emalloc(va-&gt;len+1);
			memmove(pval-&gt;u.stringval, va-&gt;data, va-&gt;len);
			pval-&gt;u.stringval[va-&gt;len] = 0;
			free(va);
		}
		break;

	default:
		if(p+length &gt; pend)
			err = ASN_EVALLEN;
		else {
			pval-&gt;tag = VOther;
			pval-&gt;u.otherval = makebytes(p, length);
			p += length;
		}
		break;
	}
	*pp = p;
	return err;
}

/*
 * Decode an int in format where count bytes are
 * concatenated to form value.
 * Although ASN1 allows any size integer, we return
 * an error if the result doesn't fit in a 32-bit int.
 * If unsgned is not set, make sure to propagate sign bit.
 */
static int
int_decode(uchar** pp, uchar* pend, int count, int unsgned, int* pint)
{
	int err;
	int num;
	uchar* p;

	p = *pp;
	err = ASN_OK;
	num = 0;
	if(p+count &lt;= pend) {
		if((count &gt; 4) || (unsgned &amp;&amp; count == 4 &amp;&amp; (*p&amp;0x80)))
			err = ASN_ETOOBIG;
		else {
			if(!unsgned &amp;&amp; count &gt; 0 &amp;&amp; count &lt; 4 &amp;&amp; (*p&amp;0x80))
				num = -1;	/* set all bits, initially */
			while(count--)
				num = (num &lt;&lt; 8)|(*p++);
		}
	}
	else
		err = ASN_ESHORT;
	*pint = num;
	*pp = p;
	return err;
}

/*
 * Decode an unsigned int in format where each
 * byte except last has high bit set, and remaining
 * seven bits of each byte are concatenated to form value.
 * Although ASN1 allows any size integer, we return
 * an error if the result doesn't fit in a 32 bit int.
 */
static int
uint7_decode(uchar** pp, uchar* pend, int* pint)
{
	int err;
	int num;
	int more;
	int v;
	uchar* p;

	p = *pp;
	err = ASN_OK;
	num = 0;
	more = 1;
	while(more &amp;&amp; p &lt; pend) {
		v = *p++;
		if(num&amp;0x7F000000) {
			err = ASN_ETOOBIG;
			break;
		}
		num &lt;&lt;= 7;
		more = v&amp;0x80;
		num |= (v&amp;0x7F);
	}
	if(p == pend)
		err = ASN_ESHORT;
	*pint = num;
	*pp = p;
	return err;
}

/*
 * Decode an octet string, recursively if isconstr.
 * We've already checked that length==-1 implies isconstr==1,
 * and otherwise that specified length fits within (*pp..pend)
 */
static int
octet_decode(uchar** pp, uchar* pend, int length, int isconstr, Bytes** pbytes)
{
	int err;
	uchar* p;
	Bytes* ans;
	Bytes* newans;
	uchar* pstart;
	uchar* pold;
	Elem	elem;

	err = ASN_OK;
	p = *pp;
	ans = nil;
	if(length &gt;= 0 &amp;&amp; !isconstr) {
		ans = makebytes(p, length);
		p += length;
	}
	else {
		/* constructed, either definite or indefinite length */
		pstart = p;
		for(;;) {
			if(length &gt;= 0 &amp;&amp; p &gt;= pstart + length) {
				if(p != pstart + length)
					err = ASN_EVALLEN;
				break;
			}
			pold = p;
			err = ber_decode(&amp;p, pend, &amp;elem);
			if(err != ASN_OK)
				break;
			switch(elem.val.tag) {
			case VOctets:
				newans = catbytes(ans, elem.val.u.octetsval);
				freebytes(ans);
				ans = newans;
				break;

			case VEOC:
				if(length != -1) {
					p = pold;
					err = ASN_EINVAL;
				}
				goto cloop_done;

			default:
				p = pold;
				err = ASN_EINVAL;
				goto cloop_done;
			}
		}
cloop_done:
		;
	}
	*pp = p;
	*pbytes = ans;
	return err;
}

/*
 * Decode a sequence or set.
 * We've already checked that length==-1 implies isconstr==1,
 * and otherwise that specified length fits within (*p..pend)
 */
static int
seq_decode(uchar** pp, uchar* pend, int length, int isconstr, Elist** pelist)
{
	int err;
	uchar* p;
	uchar* pstart;
	uchar* pold;
	Elist* ans;
	Elem elem;
	Elist* lve;
	Elist* lveold;

	err = ASN_OK;
	ans = nil;
	p = *pp;
	if(!isconstr)
		err = ASN_EPRIM;
	else {
		/* constructed, either definite or indefinite length */
		lve = nil;
		pstart = p;
		for(;;) {
			if(length &gt;= 0 &amp;&amp; p &gt;= pstart + length) {
				if(p != pstart + length)
					err = ASN_EVALLEN;
				break;
			}
			pold = p;
			err = ber_decode(&amp;p, pend, &amp;elem);
			if(err != ASN_OK)
				break;
			if(elem.val.tag == VEOC) {
				if(length != -1) {
					p = pold;
					err = ASN_EINVAL;
				}
				break;
			}
			else
				lve = mkel(elem, lve);
		}
		if(err == ASN_OK) {
			/* reverse back to original order */
			while(lve != nil) {
				lveold = lve;
				lve = lve-&gt;tl;
				lveold-&gt;tl = ans;
				ans = lveold;
			}
		}
	}
	*pp = p;
	*pelist = ans;
	setmalloctag(ans, getcallerpc(&amp;pp));
	return err;
}

/*
 * Encode e by BER rules, putting answer in *pbytes.
 * This is done by first calling enc with lenonly==1
 * to get the length of the needed buffer,
 * then allocating the buffer and using enc again to fill it up.
 */
static int
encode(Elem e, Bytes** pbytes)
{
	uchar* p;
	Bytes* ans;
	int err;
	uchar uc;

	p = &amp;uc;
	err = enc(&amp;p, e, 1);
	if(err == ASN_OK) {
		ans = newbytes(p-&amp;uc);
		p = ans-&gt;data;
		err = enc(&amp;p, e, 0);
		*pbytes = ans;
	}
	return err;
}

/*
 * The various enc functions take a pointer to a pointer
 * into a buffer, and encode their entity starting there,
 * updating the pointer afterwards.
 * If lenonly is 1, only the pointer update is done,
 * allowing enc to be called first to calculate the needed
 * buffer length.
 * If lenonly is 0, it is assumed that the answer will fit.
 */

static int
enc(uchar** pp, Elem e, int lenonly)
{
	int err;
	int vlen;
	int constr;
	Tag tag;
	int v;
	int ilen;
	uchar* p;
	uchar* psave;

	p = *pp;
	err = val_enc(&amp;p, e, &amp;constr, 1);
	if(err != ASN_OK)
		return err;
	vlen = p - *pp;
	p = *pp;
	tag = e.tag;
	v = tag.class|constr;
	if(tag.num &lt; 31) {
		if(!lenonly)
			*p = (v|tag.num);
		p++;
	}
	else {
		if(!lenonly)
			*p = (v|31);
		p++;
		if(tag.num &lt; 0)
			return ASN_EINVAL;
		uint7_enc(&amp;p, tag.num, lenonly);
	}
	if(vlen &lt; 0x80) {
		if(!lenonly)
			*p = vlen;
		p++;
	}
	else {
		psave = p;
		int_enc(&amp;p, vlen, 1, 1);
		ilen = p-psave;
		p = psave;
		if(!lenonly) {
			*p++ = (0x80 | ilen);
			int_enc(&amp;p, vlen, 1, 0);
		}
		else
			p += 1 + ilen;
	}
	if(!lenonly)
		val_enc(&amp;p, e, &amp;constr, 0);
	else
		p += vlen;
	*pp = p;
	return err;
}

static int
val_enc(uchar** pp, Elem e, int *pconstr, int lenonly)
{
	int err;
	uchar* p;
	int kind;
	int cl;
	int v;
	Bytes* bb = nil;
	Bits* bits;
	Ints* oid;
	int k;
	Elist* el;
	char* s;

	p = *pp;
	err = ASN_OK;
	kind = e.tag.num;
	cl = e.tag.class;
	*pconstr = 0;
	if(cl != Universal) {
		switch(e.val.tag) {
		case VBool:
			kind = BOOLEAN;
			break;
		case VInt:
			kind = INTEGER;
			break;
		case VBigInt:
			kind = INTEGER;
			break;
		case VOctets:
			kind = OCTET_STRING;
			break;
		case VReal:
			kind = REAL;
			break;
		case VOther:
			kind = OCTET_STRING;
			break;
		case VBitString:
			kind = BIT_STRING;
			break;
		case VNull:
			kind = NULLTAG;
			break;
		case VObjId:
			kind = OBJECT_ID;
			break;
		case VString:
			kind = UniversalString;
			break;
		case VSeq:
			kind = SEQUENCE;
			break;
		case VSet:
			kind = SETOF;
			break;
		}
	}
	switch(kind) {
	case BOOLEAN:
		if(is_int(&amp;e, &amp;v)) {
			if(v != 0)
				v = 255;
			 int_enc(&amp;p, v, 1, lenonly);
		}
		else
			err = ASN_EINVAL;
		break;

	case INTEGER:
	case ENUMERATED:
		if(is_int(&amp;e, &amp;v))
			int_enc(&amp;p, v, 0, lenonly);
		else {
			if(is_bigint(&amp;e, &amp;bb)) {
				if(!lenonly)
					memmove(p, bb-&gt;data, bb-&gt;len);
				p += bb-&gt;len;
			}
			else
				err = ASN_EINVAL;
		}
		break;

	case BIT_STRING:
		if(is_bitstring(&amp;e, &amp;bits)) {
			if(bits-&gt;len == 0) {
				if(!lenonly)
					*p = 0;
				p++;
			}
			else {
				v = bits-&gt;unusedbits;
				if(v &lt; 0 || v &gt; 7)
					err = ASN_EINVAL;
				else {
					if(!lenonly) {
						*p = v;
						memmove(p+1, bits-&gt;data, bits-&gt;len);
					}
					p += 1 + bits-&gt;len;
				}
			}
		}
		else
			err = ASN_EINVAL;
		break;

	case OCTET_STRING:
	case ObjectDescriptor:
	case EXTERNAL:
	case REAL:
	case EMBEDDED_PDV:
		bb = nil;
		switch(e.val.tag) {
		case VOctets:
			bb = e.val.u.octetsval;
			break;
		case VReal:
			bb = e.val.u.realval;
			break;
		case VOther:
			bb = e.val.u.otherval;
			break;
		}
		if(bb != nil) {
			if(!lenonly)
				memmove(p, bb-&gt;data, bb-&gt;len);
			p += bb-&gt;len;
		}
			else
				err = ASN_EINVAL;
		break;

	case NULLTAG:
		break;

	case OBJECT_ID:
		if(is_oid(&amp;e, &amp;oid)) {
			for(k = 0; k &lt; oid-&gt;len; k++) {
				v = oid-&gt;data[k];
				if(k == 0) {
					v *= 40;
					if(oid-&gt;len &gt; 1)
						v += oid-&gt;data[++k];
				}
				uint7_enc(&amp;p, v, lenonly);
			}
		}
		else
			err = ASN_EINVAL;
		break;

	case SEQUENCE:
	case SETOF:
		el = nil;
		if(e.val.tag == VSeq)
			el = e.val.u.seqval;
		else if(e.val.tag == VSet)
			el = e.val.u.setval;
		else
			err = ASN_EINVAL;
		if(el != nil) {
			*pconstr = CONSTR_MASK;
			for(; el != nil; el = el-&gt;tl) {
				err = enc(&amp;p, el-&gt;hd, lenonly);
				if(err != ASN_OK)
					break;
			}
		}
		break;

	case UTF8String:
	case NumericString:
	case PrintableString:
	case TeletexString:
	case VideotexString:
	case IA5String:
	case UTCTime:
	case GeneralizedTime:
	case GraphicString:
	case VisibleString:
	case GeneralString:
	case UniversalString:
	case BMPString:
		if(e.val.tag == VString) {
			s = e.val.u.stringval;
			if(s != nil) {
				v = strlen(s);
				if(!lenonly)
					memmove(p, s, v);
				p += v;
			}
		}
		else
			err = ASN_EINVAL;
		break;

	default:
		err = ASN_EINVAL;
	}
	*pp = p;
	return err;
}

/*
 * Encode num as unsigned 7 bit values with top bit 1 on all bytes
 * except last, only putting in bytes if !lenonly.
 */
static void
uint7_enc(uchar** pp, int num, int lenonly)
{
	int n;
	int v;
	int k;
	uchar* p;

	p = *pp;
	n = 1;
	v = num &gt;&gt; 7;
	while(v &gt; 0) {
		v &gt;&gt;= 7;
		n++;
	}
	if(lenonly)
		p += n;
	else {
		for(k = (n - 1)*7; k &gt; 0; k -= 7)
			*p++= ((num &gt;&gt; k)|0x80);
		*p++ = (num&amp;0x7F);
	}
	*pp = p;
}

/*
 * Encode num as unsigned or signed integer,
 * only putting in bytes if !lenonly.
 * Encoding is length followed by bytes to concatenate.
 */
static void
int_enc(uchar** pp, int num, int unsgned, int lenonly)
{
	int v;
	int n;
	int prevv;
	int k;
	uchar* p;

	p = *pp;
	v = num;
	if(v &lt; 0)
		v = -(v + 1);
	n = 1;
	prevv = v;
	v &gt;&gt;= 8;
	while(v &gt; 0) {
		prevv = v;
		v &gt;&gt;= 8;
		n++;
	}
	if(!unsgned &amp;&amp; (prevv&amp;0x80))
		n++;
	if(lenonly)
		p += n;
	else {
		for(k = (n - 1)*8; k &gt;= 0; k -= 8)
			*p++ = (num &gt;&gt; k);
	}
	*pp = p;
}

static int
ints_eq(Ints* a, Ints* b)
{
	int	alen;
	int	i;

	alen = a-&gt;len;
	if(alen != b-&gt;len)
		return 0;
	for(i = 0; i &lt; alen; i++)
		if(a-&gt;data[i] != b-&gt;data[i])
			return 0;
	return 1;
}

/*
 * Look up o in tab (which must have nil entry to terminate).
 * Return index of matching entry, or -1 if none.
 */
static int
oid_lookup(Ints* o, Ints** tab)
{
	int i;

	for(i = 0; tab[i] != nil; i++)
		if(ints_eq(o, tab[i]))
			return  i;
	return -1;
}

/*
 * Return true if *pe is a SEQUENCE, and set *pseq to
 * the value of the sequence if so.
 */
static int
is_seq(Elem* pe, Elist** pseq)
{
	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == SEQUENCE &amp;&amp; pe-&gt;val.tag == VSeq) {
		*pseq = pe-&gt;val.u.seqval;
		return 1;
	}
	return 0;
}

static int
is_set(Elem* pe, Elist** pset)
{
	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == SETOF &amp;&amp; pe-&gt;val.tag == VSet) {
		*pset = pe-&gt;val.u.setval;
		return 1;
	}
	return 0;
}

static int
is_int(Elem* pe, int* pint)
{
	if(pe-&gt;tag.class == Universal) {
		if(pe-&gt;tag.num == INTEGER &amp;&amp; pe-&gt;val.tag == VInt) {
			*pint = pe-&gt;val.u.intval;
			return 1;
		}
		else if(pe-&gt;tag.num == BOOLEAN &amp;&amp; pe-&gt;val.tag == VBool) {
			*pint = pe-&gt;val.u.boolval;
			return 1;
		}
	}
	return 0;
}

/*
 * for convience, all VInt's are readable via this routine,
 * as well as all VBigInt's
 */
static int
is_bigint(Elem* pe, Bytes** pbigint)
{
	int v, n, i;

	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == INTEGER) {
		if(pe-&gt;val.tag == VBigInt)
			*pbigint = pe-&gt;val.u.bigintval;
		else if(pe-&gt;val.tag == VInt){
			v = pe-&gt;val.u.intval;
			for(n = 1; n &lt; 4; n++)
				if((1 &lt;&lt; (8 * n)) &gt; v)
					break;
			*pbigint = newbytes(n);
			for(i = 0; i &lt; n; i++)
				(*pbigint)-&gt;data[i] = (v &gt;&gt; ((n - 1 - i) * 8));
		}else
			return 0;
		return 1;
	}
	return 0;
}

static int
is_bitstring(Elem* pe, Bits** pbits)
{
	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == BIT_STRING &amp;&amp; pe-&gt;val.tag == VBitString) {
		*pbits = pe-&gt;val.u.bitstringval;
		return 1;
	}
	return 0;
}

static int
is_octetstring(Elem* pe, Bytes** poctets)
{
	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == OCTET_STRING &amp;&amp; pe-&gt;val.tag == VOctets) {
		*poctets = pe-&gt;val.u.octetsval;
		return 1;
	}
	return 0;
}

static int
is_oid(Elem* pe, Ints** poid)
{
	if(pe-&gt;tag.class == Universal &amp;&amp; pe-&gt;tag.num == OBJECT_ID &amp;&amp; pe-&gt;val.tag == VObjId) {
		*poid = pe-&gt;val.u.objidval;
		return 1;
	}
	return 0;
}

static int
is_string(Elem* pe, char** pstring)
{
	if(pe-&gt;tag.class == Universal) {
		switch(pe-&gt;tag.num) {
		case UTF8String:
		case NumericString:
		case PrintableString:
		case TeletexString:
		case VideotexString:
		case IA5String:
		case GraphicString:
		case VisibleString:
		case GeneralString:
		case UniversalString:
		case BMPString:
			if(pe-&gt;val.tag == VString) {
				*pstring = pe-&gt;val.u.stringval;
				return 1;
			}
		}
	}
	return 0;
}

static int
is_time(Elem* pe, char** ptime)
{
	if(pe-&gt;tag.class == Universal
	   &amp;&amp; (pe-&gt;tag.num == UTCTime || pe-&gt;tag.num == GeneralizedTime)
	   &amp;&amp; pe-&gt;val.tag == VString) {
		*ptime = pe-&gt;val.u.stringval;
		return 1;
	}
	return 0;
}


/*
 * malloc and return a new Bytes structure capable of
 * holding len bytes. (len &gt;= 0)
 */
static Bytes*
newbytes(int len)
{
	Bytes* ans;

	ans = (Bytes*)emalloc(OFFSETOF(data[0], Bytes) + len);
	ans-&gt;len = len;
	return ans;
}

/*
 * newbytes(len), with data initialized from buf
 */
static Bytes*
makebytes(uchar* buf, int len)
{
	Bytes* ans;

	ans = newbytes(len);
	memmove(ans-&gt;data, buf, len);
	return ans;
}

static void
freebytes(Bytes* b)
{
	if(b != nil)
		free(b);
}

/*
 * Make a new Bytes, containing bytes of b1 followed by those of b2.
 * Either b1 or b2 or both can be nil.
 */
static Bytes*
catbytes(Bytes* b1, Bytes* b2)
{
	Bytes* ans;
	int n;

	if(b1 == nil) {
		if(b2 == nil)
			ans = newbytes(0);
		else
			ans = makebytes(b2-&gt;data, b2-&gt;len);
	}
	else if(b2 == nil) {
		ans = makebytes(b1-&gt;data, b1-&gt;len);
	}
	else {
		n = b1-&gt;len + b2-&gt;len;
		ans = newbytes(n);
		ans-&gt;len = n;
		memmove(ans-&gt;data, b1-&gt;data, b1-&gt;len);
		memmove(ans-&gt;data+b1-&gt;len, b2-&gt;data, b2-&gt;len);
	}
	return ans;
}

/* len is number of ints */
static Ints*
newints(int len)
{
	Ints* ans;

	ans = (Ints*)emalloc(OFFSETOF(data[0], Ints) + len*sizeof(int));
	ans-&gt;len = len;
	return ans;
}

static Ints*
makeints(int* buf, int len)
{
	Ints* ans;

	ans = newints(len);
	if(len &gt; 0)
		memmove(ans-&gt;data, buf, len*sizeof(int));
	return ans;
}

static void
freeints(Ints* b)
{
	if(b != nil)
		free(b);
}

/* len is number of bytes */
static Bits*
newbits(int len)
{
	Bits* ans;

	ans = (Bits*)emalloc(OFFSETOF(data[0], Bits) + len);
	ans-&gt;len = len;
	ans-&gt;unusedbits = 0;
	return ans;
}

static Bits*
makebits(uchar* buf, int len, int unusedbits)
{
	Bits* ans;

	ans = newbits(len);
	memmove(ans-&gt;data, buf, len);
	ans-&gt;unusedbits = unusedbits;
	return ans;
}

static void
freebits(Bits* b)
{
	if(b != nil)
		free(b);
}

static Elist*
mkel(Elem e, Elist* tail)
{
	Elist* el;

	el = (Elist*)emalloc(sizeof(Elist));
	setmalloctag(el, getcallerpc(&amp;e));
	el-&gt;hd = e;
	el-&gt;tl = tail;
	return el;
}

static int
elistlen(Elist* el)
{
	int ans = 0;
	while(el != nil) {
		ans++;
		el = el-&gt;tl;
	}
	return ans;
}

/* Frees elist, but not fields inside values of constituent elems */
static void
freeelist(Elist* el)
{
	Elist* next;

	while(el != nil) {
		next = el-&gt;tl;
		free(el);
		el = next;
	}
}

/* free any allocated structures inside v (recursively freeing Elists) */
static void
freevalfields(Value* v)
{
	Elist* el;
	Elist* l;
	if(v == nil)
		return;
	switch(v-&gt;tag) {
 	case VOctets:
		freebytes(v-&gt;u.octetsval);
		break;
	case VBigInt:
		freebytes(v-&gt;u.bigintval);
		break;
	case VReal:
		freebytes(v-&gt;u.realval);
		break;
	case VOther:
		freebytes(v-&gt;u.otherval);
		break;
	case VBitString:
		freebits(v-&gt;u.bitstringval);
		break;
	case VObjId:
		freeints(v-&gt;u.objidval);
		break;
	case VString:
		if(v-&gt;u.stringval)
			free(v-&gt;u.stringval);
		break;
	case VSeq:
		el = v-&gt;u.seqval;
		for(l = el; l != nil; l = l-&gt;tl)
			freevalfields(&amp;l-&gt;hd.val);
		if(el)
			freeelist(el);
		break;
	case VSet:
		el = v-&gt;u.setval;
		for(l = el; l != nil; l = l-&gt;tl)
			freevalfields(&amp;l-&gt;hd.val);
		if(el)
			freeelist(el);
		break;
	}
}

/* end of general ASN1 functions */





/*=============================================================*/
/*
 * Decode and parse an X.509 Certificate, defined by this ASN1:
 *	Certificate ::= SEQUENCE {
 *		certificateInfo CertificateInfo,
 *		signatureAlgorithm AlgorithmIdentifier,
 *		signature BIT STRING }
 *
 *	CertificateInfo ::= SEQUENCE {
 *		version [0] INTEGER DEFAULT v1 (0),
 *		serialNumber INTEGER,
 *		signature AlgorithmIdentifier,
 *		issuer Name,
 *		validity Validity,
 *		subject Name,
 *		subjectPublicKeyInfo SubjectPublicKeyInfo }
 *	(version v2 has two more fields, optional unique identifiers for
 *  issuer and subject; since we ignore these anyway, we won't parse them)
 *
 *	Validity ::= SEQUENCE {
 *		notBefore UTCTime,
 *		notAfter UTCTime }
 *
 *	SubjectPublicKeyInfo ::= SEQUENCE {
 *		algorithm AlgorithmIdentifier,
 *		subjectPublicKey BIT STRING }
 *
 *	AlgorithmIdentifier ::= SEQUENCE {
 *		algorithm OBJECT IDENTIFER,
 *		parameters ANY DEFINED BY ALGORITHM OPTIONAL }
 *
 *	Name ::= SEQUENCE OF RelativeDistinguishedName
 *
 *	RelativeDistinguishedName ::= SETOF SIZE(1..MAX) OF AttributeTypeAndValue
 *
 *	AttributeTypeAndValue ::= SEQUENCE {
 *		type OBJECT IDENTIFER,
 *		value DirectoryString }
 *	(selected attributes have these Object Ids:
 *		commonName {2 5 4 3}
 *		countryName {2 5 4 6}
 *		localityName {2 5 4 7}
 *		stateOrProvinceName {2 5 4 8}
 *		organizationName {2 5 4 10}
 *		organizationalUnitName {2 5 4 11}
 *	)
 *
 *	DirectoryString ::= CHOICE {
 *		teletexString TeletexString,
 *		printableString PrintableString,
 *		universalString UniversalString }
 *
 *  See rfc1423, rfc2437 for AlgorithmIdentifier, subjectPublicKeyInfo, signature.
 *
 *  Not yet implemented:
 *   CertificateRevocationList ::= SIGNED SEQUENCE{
 *           signature       AlgorithmIdentifier,
 *           issuer          Name,
 *           lastUpdate      UTCTime,
 *           nextUpdate      UTCTime,
 *           revokedCertificates
 *                           SEQUENCE OF CRLEntry OPTIONAL}
 *   CRLEntry ::= SEQUENCE{
 *           userCertificate SerialNumber,
 *           revocationDate UTCTime}
 */

typedef struct CertX509 {
	int	serial;
	char*	issuer;
	char*	validity_start;
	char*	validity_end;
	char*	subject;
	int	publickey_alg;
	Bytes*	publickey;
	int	signature_alg;
	Bytes*	signature;
} CertX509;

/* Algorithm object-ids */
enum {
	ALG_rsaEncryption,
	ALG_md2WithRSAEncryption,
	ALG_md4WithRSAEncryption,
	ALG_md5WithRSAEncryption,
	ALG_sha1WithRSAEncryption,
	ALG_sha1WithRSAEncryptionOiw,
	ALG_md5,
	NUMALGS
};
typedef struct Ints7 {
	int		len;
	int		data[7];
} Ints7;
static Ints7 oid_rsaEncryption = {7, 1, 2, 840, 113549, 1, 1, 1 };
static Ints7 oid_md2WithRSAEncryption = {7, 1, 2, 840, 113549, 1, 1, 2 };
static Ints7 oid_md4WithRSAEncryption = {7, 1, 2, 840, 113549, 1, 1, 3 };
static Ints7 oid_md5WithRSAEncryption = {7, 1, 2, 840, 113549, 1, 1, 4 };
static Ints7 oid_sha1WithRSAEncryption ={7, 1, 2, 840, 113549, 1, 1, 5 };
static Ints7 oid_sha1WithRSAEncryptionOiw ={6, 1, 3, 14, 3, 2, 29 };
static Ints7 oid_md5 ={6, 1, 2, 840, 113549, 2, 5, 0 };
static Ints *alg_oid_tab[NUMALGS+1] = {
	(Ints*)&amp;oid_rsaEncryption,
	(Ints*)&amp;oid_md2WithRSAEncryption,
	(Ints*)&amp;oid_md4WithRSAEncryption,
	(Ints*)&amp;oid_md5WithRSAEncryption,
	(Ints*)&amp;oid_sha1WithRSAEncryption,
	(Ints*)&amp;oid_sha1WithRSAEncryptionOiw,
	(Ints*)&amp;oid_md5,
	nil
};
static DigestFun digestalg[NUMALGS+1] = { md5, md5, md5, md5, sha1, sha1, md5, nil };

static void
freecert(CertX509* c)
{
	if(!c) return;
	if(c-&gt;issuer != nil)
		free(c-&gt;issuer);
	if(c-&gt;validity_start != nil)
		free(c-&gt;validity_start);
	if(c-&gt;validity_end != nil)
		free(c-&gt;validity_end);
	if(c-&gt;subject != nil)
		free(c-&gt;subject);
	freebytes(c-&gt;publickey);
	freebytes(c-&gt;signature);
	free(c);
}

/*
 * Parse the Name ASN1 type.
 * The sequence of RelativeDistinguishedName's gives a sort of pathname,
 * from most general to most specific.  Each element of the path can be
 * one or more (but usually just one) attribute-value pair, such as
 * countryName="US".
 * We'll just form a "postal-style" address string by concatenating the elements
 * from most specific to least specific, separated by commas.
 * Return name-as-string (which must be freed by caller).
 */
static char*
parse_name(Elem* e)
{
	Elist* el;
	Elem* es;
	Elist* esetl;
	Elem* eat;
	Elist* eatl;
	char* s;
	enum { MAXPARTS = 100 };
	char* parts[MAXPARTS];
	int i;
	int plen;
	char* ans = nil;

	if(!is_seq(e, &amp;el))
		goto errret;
	i = 0;
	plen = 0;
	while(el != nil) {
		es = &amp;el-&gt;hd;
		if(!is_set(es, &amp;esetl))
			goto errret;
		while(esetl != nil) {
			eat = &amp;esetl-&gt;hd;
			if(!is_seq(eat, &amp;eatl) || elistlen(eatl) != 2)
				goto errret;
			if(!is_string(&amp;eatl-&gt;tl-&gt;hd, &amp;s) || i&gt;=MAXPARTS)
				goto errret;
			parts[i++] = s;
			plen += strlen(s) + 2;		/* room for ", " after */
			esetl = esetl-&gt;tl;
		}
		el = el-&gt;tl;
	}
	if(i &gt; 0) {
		ans = (char*)emalloc(plen);
		*ans = '\0';
		while(--i &gt;= 0) {
			s = parts[i];
			strcat(ans, s);
			if(i &gt; 0)
				strcat(ans, ", ");
		}
	}

errret:
	return ans;
}

/*
 * Parse an AlgorithmIdentifer ASN1 type.
 * Look up the oid in oid_tab and return one of OID_rsaEncryption, etc..,
 * or -1 if not found.
 * For now, ignore parameters, since none of our algorithms need them.
 */
static int
parse_alg(Elem* e)
{
	Elist* el;
	Ints* oid;

	if(!is_seq(e, &amp;el) || el == nil || !is_oid(&amp;el-&gt;hd, &amp;oid))
		return -1;
	return oid_lookup(oid, alg_oid_tab);
}

static CertX509*
decode_cert(Bytes* a)
{
	int ok = 0;
	int n;
	CertX509* c = nil;
	Elem  ecert;
	Elem* ecertinfo;
	Elem* esigalg;
	Elem* esig;
	Elem* eserial;
	Elem* eissuer;
	Elem* evalidity;
	Elem* esubj;
	Elem* epubkey;
	Elist* el;
	Elist* elcert = nil;
	Elist* elcertinfo = nil;
	Elist* elvalidity = nil;
	Elist* elpubkey = nil;
	Bits* bits = nil;
	Bytes* b;
	Elem* e;

	if(decode(a-&gt;data, a-&gt;len, &amp;ecert) != ASN_OK)
		goto errret;

	c = (CertX509*)emalloc(sizeof(CertX509));
	c-&gt;serial = -1;
	c-&gt;issuer = nil;
	c-&gt;validity_start = nil;
	c-&gt;validity_end = nil;
	c-&gt;subject = nil;
	c-&gt;publickey_alg = -1;
	c-&gt;publickey = nil;
	c-&gt;signature_alg = -1;
	c-&gt;signature = nil;

	/* Certificate */
 	if(!is_seq(&amp;ecert, &amp;elcert) || elistlen(elcert) !=3)
		goto errret;
 	ecertinfo = &amp;elcert-&gt;hd;
 	el = elcert-&gt;tl;
 	esigalg = &amp;el-&gt;hd;
	c-&gt;signature_alg = parse_alg(esigalg);
 	el = el-&gt;tl;
 	esig = &amp;el-&gt;hd;

	/* Certificate Info */
	if(!is_seq(ecertinfo, &amp;elcertinfo))
		goto errret;
	n = elistlen(elcertinfo);
  	if(n &lt; 6)
		goto errret;
	eserial =&amp;elcertinfo-&gt;hd;
 	el = elcertinfo-&gt;tl;
 	/* check for optional version, marked by explicit context tag 0 */
	if(eserial-&gt;tag.class == Context &amp;&amp; eserial-&gt;tag.num == 0) {
 		eserial = &amp;el-&gt;hd;
 		if(n &lt; 7)
 			goto errret;
 		el = el-&gt;tl;
 	}

	if(parse_alg(&amp;el-&gt;hd) != c-&gt;signature_alg)
		goto errret;
 	el = el-&gt;tl;
 	eissuer = &amp;el-&gt;hd;
 	el = el-&gt;tl;
 	evalidity = &amp;el-&gt;hd;
 	el = el-&gt;tl;
 	esubj = &amp;el-&gt;hd;
 	el = el-&gt;tl;
 	epubkey = &amp;el-&gt;hd;
 	if(!is_int(eserial, &amp;c-&gt;serial)) {
		if(!is_bigint(eserial, &amp;b))
			goto errret;
		c-&gt;serial = -1;	/* else we have to change cert struct */
  	}
	c-&gt;issuer = parse_name(eissuer);
	if(c-&gt;issuer == nil)
		goto errret;
	/* Validity */
  	if(!is_seq(evalidity, &amp;elvalidity))
		goto errret;
	if(elistlen(elvalidity) != 2)
		goto errret;
	e = &amp;elvalidity-&gt;hd;
	if(!is_time(e, &amp;c-&gt;validity_start))
		goto errret;
	e-&gt;val.u.stringval = nil;	/* string ownership transfer */
	e = &amp;elvalidity-&gt;tl-&gt;hd;
 	if(!is_time(e, &amp;c-&gt;validity_end))
		goto errret;
	e-&gt;val.u.stringval = nil;	/* string ownership transfer */

	/* resume CertificateInfo */
 	c-&gt;subject = parse_name(esubj);
	if(c-&gt;subject == nil)
		goto errret;

	/* SubjectPublicKeyInfo */
 	if(!is_seq(epubkey, &amp;elpubkey))
		goto errret;
	if(elistlen(elpubkey) != 2)
		goto errret;

	c-&gt;publickey_alg = parse_alg(&amp;elpubkey-&gt;hd);
	if(c-&gt;publickey_alg &lt; 0)
		goto errret;
  	if(!is_bitstring(&amp;elpubkey-&gt;tl-&gt;hd, &amp;bits))
		goto errret;
	if(bits-&gt;unusedbits != 0)
		goto errret;
 	c-&gt;publickey = makebytes(bits-&gt;data, bits-&gt;len);

	/*resume Certificate */
	if(c-&gt;signature_alg &lt; 0)
		goto errret;
 	if(!is_bitstring(esig, &amp;bits))
		goto errret;
 	c-&gt;signature = makebytes(bits-&gt;data, bits-&gt;len);
	ok = 1;

errret:
	freevalfields(&amp;ecert.val);	/* recurses through lists, too */
	if(!ok){
		freecert(c);
		c = nil;
	}
	return c;
}

/*
 *	RSAPublickKey :: SEQUENCE {
 *		modulus INTEGER,
 *		publicExponent INTEGER
 *	}
 */
static RSApub*
decode_rsapubkey(Bytes* a)
{
	Elem e;
	Elist *el, *l;
	mpint *mp;
	RSApub* key;

	l = nil;
	key = rsapuballoc();
	if(decode(a-&gt;data, a-&gt;len, &amp;e) != ASN_OK)
		goto errret;
	if(!is_seq(&amp;e, &amp;el) || elistlen(el) != 2)
		goto errret;

	l = el;

	key-&gt;n = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;ek = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	if(l != nil)
		freeelist(l);
	return key;
errret:
	if(l != nil)
		freeelist(l);
	rsapubfree(key);
	return nil;
}

/*
 *	RSAPrivateKey ::= SEQUENCE {
 *		version Version,
 *		modulus INTEGER, -- n
 *		publicExponent INTEGER, -- e
 *		privateExponent INTEGER, -- d
 *		prime1 INTEGER, -- p
 *		prime2 INTEGER, -- q
 *		exponent1 INTEGER, -- d mod (p-1)
 *		exponent2 INTEGER, -- d mod (q-1)
 *		coefficient INTEGER -- (inverse of q) mod p }
 */
static RSApriv*
decode_rsaprivkey(Bytes* a)
{
	int version;
	Elem e;
	Elist *el;
	mpint *mp;
	RSApriv* key;

	key = rsaprivalloc();
	if(decode(a-&gt;data, a-&gt;len, &amp;e) != ASN_OK)
		goto errret;
	if(!is_seq(&amp;e, &amp;el) || elistlen(el) != 9)
		goto errret;
	if(!is_int(&amp;el-&gt;hd, &amp;version) || version != 0)
		goto errret;

	el = el-&gt;tl;
	key-&gt;pub.n = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;pub.ek = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;dk = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;q = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;p = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;kq = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;kp = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;c2 = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	return key;
errret:
	rsaprivfree(key);
	return nil;
}

/*
 * 	DSAPrivateKey ::= SEQUENCE{
 *		version Version,
 *		p INTEGER,
 *		q INTEGER,
 *		g INTEGER, -- alpha
 *		pub_key INTEGER, -- key
 *		priv_key INTEGER, -- secret
 *	}
 */
static DSApriv*
decode_dsaprivkey(Bytes* a)
{
	int version;
	Elem e;
	Elist *el;
	mpint *mp;
	DSApriv* key;

	key = dsaprivalloc();
	if(decode(a-&gt;data, a-&gt;len, &amp;e) != ASN_OK)
		goto errret;
	if(!is_seq(&amp;e, &amp;el) || elistlen(el) != 6)
		goto errret;
version = -1;
	if(!is_int(&amp;el-&gt;hd, &amp;version) || version != 0)
{
fprint(2, "version %d\n", version);
		goto errret;
}

	el = el-&gt;tl;
	key-&gt;pub.p = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;pub.q = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;pub.alpha = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;pub.key = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;secret = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	return key;
errret:
	dsaprivfree(key);
	return nil;
}

static mpint*
asn1mpint(Elem *e)
{
	Bytes *b;
	mpint *mp;
	int v;

	if(is_int(e, &amp;v))
		return itomp(v, nil);
	if(is_bigint(e, &amp;b)) {
		mp = betomp(b-&gt;data, b-&gt;len, nil);
		freebytes(b);
		return mp;
	}
	return nil;
}

static mpint*
pkcs1pad(Bytes *b, mpint *modulus)
{
	int n = (mpsignif(modulus)+7)/8;
	int pm1, i;
	uchar *p;
	mpint *mp;

	pm1 = n - 1 - b-&gt;len;
	p = (uchar*)emalloc(n);
	p[0] = 0;
	p[1] = 1;
	for(i = 2; i &lt; pm1; i++)
		p[i] = 0xFF;
	p[pm1] = 0;
	memcpy(&amp;p[pm1+1], b-&gt;data, b-&gt;len);
	mp = betomp(p, n, nil);
	free(p);
	return mp;
}

RSApriv*
asn1toRSApriv(uchar *kd, int kn)
{
	Bytes *b;
	RSApriv *key;

	b = makebytes(kd, kn);
	key = decode_rsaprivkey(b);
	freebytes(b);
	return key;
}

DSApriv*
asn1toDSApriv(uchar *kd, int kn)
{
	Bytes *b;
	DSApriv *key;

	b = makebytes(kd, kn);
	key = decode_dsaprivkey(b);
	freebytes(b);
	return key;
}

/*
 * digest(CertificateInfo)
 * Our ASN.1 library doesn't return pointers into the original
 * data array, so we need to do a little hand decoding.
 */
static void
digest_certinfo(Bytes *cert, DigestFun digestfun, uchar *digest)
{
	uchar *info, *p, *pend;
	ulong infolen;
	int isconstr, length;
	Tag tag;
	Elem elem;

	p = cert-&gt;data;
	pend = cert-&gt;data + cert-&gt;len;
	if(tag_decode(&amp;p, pend, &amp;tag, &amp;isconstr) != ASN_OK ||
	   tag.class != Universal || tag.num != SEQUENCE ||
	   length_decode(&amp;p, pend, &amp;length) != ASN_OK ||
	   p+length &gt; pend ||
	   p+length &lt; p)
		return;
	info = p;
	if(ber_decode(&amp;p, pend, &amp;elem) != ASN_OK)
		return;
	freevalfields(&amp;elem.val);
	if(elem.tag.num != SEQUENCE)
		return;
	infolen = p - info;
	(*digestfun)(info, infolen, digest, nil);
}

static char*
verify_signature(Bytes* signature, RSApub *pk, uchar *edigest, Elem **psigalg)
{
	Elem e;
	Elist *el;
	Bytes *digest;
	uchar *pkcs1buf, *buf;
	int buflen;
	mpint *pkcs1;
	int nlen;
	char *err;

	err = nil;
	pkcs1buf = nil;

	/* one less than the byte length of the modulus */
	nlen = (mpsignif(pk-&gt;n)-1)/8;

	/* see 9.2.1 of rfc2437 */
	pkcs1 = betomp(signature-&gt;data, signature-&gt;len, nil);
	mpexp(pkcs1, pk-&gt;ek, pk-&gt;n, pkcs1);
	buflen = mptobe(pkcs1, nil, 0, &amp;pkcs1buf);
	buf = pkcs1buf;
	if(buflen != nlen || buf[0] != 1) {
		err = "expected 1";
		goto end;
	}
	buf++;
	while(buf[0] == 0xff)
		buf++;
	if(buf[0] != 0) {
		err = "expected 0";
		goto end;
	}
	buf++;
	buflen -= buf-pkcs1buf;
	if(decode(buf, buflen, &amp;e) != ASN_OK || !is_seq(&amp;e, &amp;el) || elistlen(el) != 2 ||
			!is_octetstring(&amp;el-&gt;tl-&gt;hd, &amp;digest)) {
		err = "signature parse error";
		goto end;
	}
	*psigalg = &amp;el-&gt;hd;
	if(memcmp(digest-&gt;data, edigest, digest-&gt;len) == 0)
		goto end;
	err = "digests did not match";

end:
	if(pkcs1 != nil)
		mpfree(pkcs1);
	if(pkcs1buf != nil)
		free(pkcs1buf);
	return err;
}

RSApub*
X509toRSApub(uchar *cert, int ncert, char *name, int nname)
{
	char *e;
	Bytes *b;
	CertX509 *c;
	RSApub *pk;

	b = makebytes(cert, ncert);
	c = decode_cert(b);
	freebytes(b);
	if(c == nil)
		return nil;
	if(name != nil &amp;&amp; c-&gt;subject != nil){
		e = strchr(c-&gt;subject, ',');
		if(e != nil)
			*e = 0;	/* take just CN part of Distinguished Name */
		strncpy(name, c-&gt;subject, nname);
	}
	pk = decode_rsapubkey(c-&gt;publickey);
	freecert(c);
	return pk;
}

int
getalgo(Elem *e)
{
	Value *v;
	Elist *el;
	int a;

	if((a = parse_alg(e)) &gt;= 0)
		return a;
	v = &amp;e-&gt;val;
	if(v-&gt;tag == VSeq){
		print("Seq\n");
		for(el = v-&gt;u.seqval; el!=nil; el = el-&gt;tl){
			if((a = getalgo(&amp;el-&gt;hd)) &gt;= 0)
				return a;
		}
	}
	return -1;
}

static void edump(Elem e);

RSApub*
asn1toRSApub(uchar *der, int nder)
{
	Elem e;
	Elist *el, *l;
	int n;
	Bits *b;
	RSApub *key;
	mpint *mp;

	if(decode(der, nder, &amp;e) != ASN_OK){
		print("didn't parse\n");
		return nil;
	}
	if(!is_seq(&amp;e, &amp;el)){
		print("no seq");
		return nil;
	}
	if((n = elistlen(el)) != 2){
		print("bad length %d\n", n);
		return nil;
	}
	if((n = getalgo(&amp;el-&gt;hd)) &lt; 0){
		print("no algo\n");
		return nil;
	}
	if(n != 0){
		print("cant do algorithm %d\n", n);
		return nil;
	}
	if(!is_bitstring(&amp;el-&gt;tl-&gt;hd, &amp;b)){
		print("no bits\n");
		return nil;
	}
	if(decode(b-&gt;data, b-&gt;len, &amp;e) != ASN_OK){
		print("no second decode\n");
		return nil;
	}
	if(!is_seq(&amp;e, &amp;el)){
		print("no second seq\n");
		return nil;
	}
	if(elistlen(el) != 2){
		print("no second length\n");
		return nil;
	}
	key = rsapuballoc();

	l = el;

	key-&gt;n = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	el = el-&gt;tl;
	key-&gt;ek = mp = asn1mpint(&amp;el-&gt;hd);
	if(mp == nil)
		goto errret;

	if(l != nil)
		freeelist(l);
	return key;
errret:
	if(l != nil)
		freeelist(l);
	rsapubfree(key);
	return nil;
}

char*
X509verify(uchar *cert, int ncert, RSApub *pk)
{
	char *e;
	Bytes *b;
	CertX509 *c;
	uchar digest[SHA1dlen];
	Elem *sigalg;

	b = makebytes(cert, ncert);
	c = decode_cert(b);
	if(c != nil)
		digest_certinfo(b, digestalg[c-&gt;signature_alg], digest);
	freebytes(b);
	if(c == nil)
		return "cannot decode cert";
	e = verify_signature(c-&gt;signature, pk, digest, &amp;sigalg);
	freecert(c);
	return e;
}

/* ------- Elem constructors ---------- */
static Elem
Null(void)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = NULLTAG;
	e.val.tag = VNull;
	return e;
}

static Elem
mkint(int j)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = INTEGER;
	e.val.tag = VInt;
	e.val.u.intval = j;
	return e;
}

static Elem
mkbigint(mpint *p)
{
	Elem e;
	uchar *buf;
	int buflen;

	e.tag.class = Universal;
	e.tag.num = INTEGER;
	e.val.tag = VBigInt;
	buflen = mptobe(p, nil, 0, &amp;buf);
	e.val.u.bigintval = makebytes(buf, buflen);
	free(buf);
	return e;
}

static Elem
mkstring(char *s)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = IA5String;
	e.val.tag = VString;
	e.val.u.stringval = estrdup(s);
	return e;
}

static Elem
mkoctet(uchar *buf, int buflen)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = OCTET_STRING;
	e.val.tag = VOctets;
	e.val.u.octetsval = makebytes(buf, buflen);
	return e;
}

static Elem
mkbits(uchar *buf, int buflen)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = BIT_STRING;
	e.val.tag = VBitString;
	e.val.u.bitstringval = makebits(buf, buflen, 0);
	return e;
}

static Elem
mkutc(long t)
{
	Elem e;
	char utc[50];
	Tm *tm = gmtime(t);

	e.tag.class = Universal;
	e.tag.num = UTCTime;
	e.val.tag = VString;
	snprint(utc, 50, "%.2d%.2d%.2d%.2d%.2d%.2dZ",
		tm-&gt;year % 100, tm-&gt;mon+1, tm-&gt;mday, tm-&gt;hour, tm-&gt;min, tm-&gt;sec);
	e.val.u.stringval = estrdup(utc);
	return e;
}

static Elem
mkoid(Ints *oid)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = OBJECT_ID;
	e.val.tag = VObjId;
	e.val.u.objidval = makeints(oid-&gt;data, oid-&gt;len);
	return e;
}

static Elem
mkseq(Elist *el)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = SEQUENCE;
	e.val.tag = VSeq;
	e.val.u.seqval = el;
	return e;
}

static Elem
mkset(Elist *el)
{
	Elem e;

	e.tag.class = Universal;
	e.tag.num = SETOF;
	e.val.tag = VSet;
	e.val.u.setval = el;
	return e;
}

static Elem
mkalg(int alg)
{
	return mkseq(mkel(mkoid(alg_oid_tab[alg]), mkel(Null(), nil)));
}

typedef struct Ints7pref {
	int		len;
	int		data[7];
	char	prefix[4];
} Ints7pref;
Ints7pref DN_oid[] = {
	{4, 2, 5, 4, 6, 0, 0, 0,  "C="},
	{4, 2, 5, 4, 8, 0, 0, 0,  "ST="},
	{4, 2, 5, 4, 7, 0, 0, 0,  "L="},
	{4, 2, 5, 4, 10, 0, 0, 0, "O="},
	{4, 2, 5, 4, 11, 0, 0, 0, "OU="},
	{4, 2, 5, 4, 3, 0, 0, 0,  "CN="},
 	{7, 1,2,840,113549,1,9,1, "E="},
};

static Elem
mkname(Ints7pref *oid, char *subj)
{
	return mkset(mkel(mkseq(mkel(mkoid((Ints*)oid), mkel(mkstring(subj), nil))), nil));
}

static Elem
mkDN(char *dn)
{
	int i, j, nf;
	char *f[20], *prefix, *d2 = estrdup(dn);
	Elist* el = nil;

	nf = tokenize(d2, f, nelem(f));
	for(i=nf-1; i&gt;=0; i--){
		for(j=0; j&lt;nelem(DN_oid); j++){
			prefix = DN_oid[j].prefix;
			if(strncmp(f[i],prefix,strlen(prefix))==0){
				el = mkel(mkname(&amp;DN_oid[j],f[i]+strlen(prefix)), el);
				break;
			}
		}
	}
	free(d2);
	return mkseq(el);
}

uchar*
RSApubtoasn1(RSApub *pub, int *keylen)
{
	Elem pubkey;
	Bytes *pkbytes;
	uchar *key;

	key = nil;
	pubkey = mkseq(mkel(mkbigint(pub-&gt;n),mkel(mkint(mptoi(pub-&gt;ek)),nil)));
	if(encode(pubkey, &amp;pkbytes) != ASN_OK)
		goto errret;
	freevalfields(&amp;pubkey.val);
	pubkey = mkseq(
		mkel(mkalg(ALG_rsaEncryption),
		mkel(mkbits(pkbytes-&gt;data, pkbytes-&gt;len),
		nil)));
	freebytes(pkbytes);
	if(encode(pubkey, &amp;pkbytes) != ASN_OK)
		goto errret;
	if(keylen)
		*keylen = pkbytes-&gt;len;
	key = malloc(pkbytes-&gt;len);
	memmove(key, pkbytes-&gt;data, pkbytes-&gt;len);
	free(pkbytes);
errret:
	freevalfields(&amp;pubkey.val);
	return key;
}

uchar*
X509gen(RSApriv *priv, char *subj, ulong valid[2], int *certlen)
{
	int serial = 0;
	uchar *cert = nil;
	RSApub *pk = rsaprivtopub(priv);
	Bytes *certbytes, *pkbytes, *certinfobytes, *sigbytes;
	Elem e, certinfo, issuer, subject, pubkey, validity, sig;
	uchar digest[MD5dlen], *buf;
	int buflen;
	mpint *pkcs1;

	e.val.tag = VInt;  /* so freevalfields at errret is no-op */
	issuer = mkDN(subj);
	subject = mkDN(subj);
	pubkey = mkseq(mkel(mkbigint(pk-&gt;n),mkel(mkint(mptoi(pk-&gt;ek)),nil)));
	if(encode(pubkey, &amp;pkbytes) != ASN_OK)
		goto errret;
	freevalfields(&amp;pubkey.val);
	pubkey = mkseq(
		mkel(mkalg(ALG_rsaEncryption),
		mkel(mkbits(pkbytes-&gt;data, pkbytes-&gt;len),
		nil)));
	freebytes(pkbytes);
	validity = mkseq(
		mkel(mkutc(valid[0]),
		mkel(mkutc(valid[1]),
		nil)));
	certinfo = mkseq(
		mkel(mkint(serial),
		mkel(mkalg(ALG_md5WithRSAEncryption),
		mkel(issuer,
		mkel(validity,
		mkel(subject,
		mkel(pubkey,
		nil)))))));
	if(encode(certinfo, &amp;certinfobytes) != ASN_OK)
		goto errret;
	md5(certinfobytes-&gt;data, certinfobytes-&gt;len, digest, 0);
	freebytes(certinfobytes);
	sig = mkseq(
		mkel(mkalg(ALG_md5),
		mkel(mkoctet(digest, MD5dlen),
		nil)));
	if(encode(sig, &amp;sigbytes) != ASN_OK)
		goto errret;
	pkcs1 = pkcs1pad(sigbytes, pk-&gt;n);
	freebytes(sigbytes);
	rsadecrypt(priv, pkcs1, pkcs1);
	buflen = mptobe(pkcs1, nil, 0, &amp;buf);
	mpfree(pkcs1);
	e = mkseq(
		mkel(certinfo,
		mkel(mkalg(ALG_md5WithRSAEncryption),
		mkel(mkbits(buf, buflen),
		nil))));
	free(buf);
	if(encode(e, &amp;certbytes) != ASN_OK)
		goto errret;
	if(certlen)
		*certlen = certbytes-&gt;len;
	cert = certbytes-&gt;data;
errret:
	freevalfields(&amp;e.val);
	return cert;
}

uchar*
X509req(RSApriv *priv, char *subj, int *certlen)
{
	/* RFC 2314, PKCS #10 Certification Request Syntax */
	int version = 0;
	uchar *cert = nil;
	RSApub *pk = rsaprivtopub(priv);
	Bytes *certbytes, *pkbytes, *certinfobytes, *sigbytes;
	Elem e, certinfo, subject, pubkey, sig;
	uchar digest[MD5dlen], *buf;
	int buflen;
	mpint *pkcs1;

	e.val.tag = VInt;  /* so freevalfields at errret is no-op */
	subject = mkDN(subj);
	pubkey = mkseq(mkel(mkbigint(pk-&gt;n),mkel(mkint(mptoi(pk-&gt;ek)),nil)));
	if(encode(pubkey, &amp;pkbytes) != ASN_OK)
		goto errret;
	freevalfields(&amp;pubkey.val);
	pubkey = mkseq(
		mkel(mkalg(ALG_rsaEncryption),
		mkel(mkbits(pkbytes-&gt;data, pkbytes-&gt;len),
		nil)));
	freebytes(pkbytes);
	certinfo = mkseq(
		mkel(mkint(version),
		mkel(subject,
		mkel(pubkey,
		nil))));
	if(encode(certinfo, &amp;certinfobytes) != ASN_OK)
		goto errret;
	md5(certinfobytes-&gt;data, certinfobytes-&gt;len, digest, 0);
	freebytes(certinfobytes);
	sig = mkseq(
		mkel(mkalg(ALG_md5),
		mkel(mkoctet(digest, MD5dlen),
		nil)));
	if(encode(sig, &amp;sigbytes) != ASN_OK)
		goto errret;
	pkcs1 = pkcs1pad(sigbytes, pk-&gt;n);
	freebytes(sigbytes);
	rsadecrypt(priv, pkcs1, pkcs1);
	buflen = mptobe(pkcs1, nil, 0, &amp;buf);
	mpfree(pkcs1);
	e = mkseq(
		mkel(certinfo,
		mkel(mkalg(ALG_md5),
		mkel(mkbits(buf, buflen),
		nil))));
	free(buf);
	if(encode(e, &amp;certbytes) != ASN_OK)
		goto errret;
	if(certlen)
		*certlen = certbytes-&gt;len;
	cert = certbytes-&gt;data;
errret:
	freevalfields(&amp;e.val);
	return cert;
}

static char*
tagdump(Tag tag)
{
	if(tag.class != Universal)
		return smprint("class%d,num%d", tag.class, tag.num);
	switch(tag.num){
	case BOOLEAN: return "BOOLEAN";
	case INTEGER: return "INTEGER";
	case BIT_STRING: return "BIT STRING";
	case OCTET_STRING: return "OCTET STRING";
	case NULLTAG: return "NULLTAG";
	case OBJECT_ID: return "OID";
	case ObjectDescriptor: return "OBJECT_DES";
	case EXTERNAL: return "EXTERNAL";
	case REAL: return "REAL";
	case ENUMERATED: return "ENUMERATED";
	case EMBEDDED_PDV: return "EMBEDDED PDV";
	case SEQUENCE: return "SEQUENCE";
	case SETOF: return "SETOF";
	case UTF8String: return "UTF8String";
	case NumericString: return "NumericString";
	case PrintableString: return "PrintableString";
	case TeletexString: return "TeletexString";
	case VideotexString: return "VideotexString";
	case IA5String: return "IA5String";
	case UTCTime: return "UTCTime";
	case GeneralizedTime: return "GeneralizedTime";
	case GraphicString: return "GraphicString";
	case VisibleString: return "VisibleString";
	case GeneralString: return "GeneralString";
	case UniversalString: return "UniversalString";
	case BMPString: return "BMPString";
	default:
		return smprint("Universal,num%d", tag.num);
	}
}

static void
edump(Elem e)
{
	Value v;
	Elist *el;
	int i;

	print("%s{", tagdump(e.tag));
	v = e.val;
	switch(v.tag){
	case VBool: print("Bool %d",v.u.boolval); break;
	case VInt: print("Int %d",v.u.intval); break;
	case VOctets: print("Octets[%d] %.2x%.2x...",v.u.octetsval-&gt;len,v.u.octetsval-&gt;data[0],v.u.octetsval-&gt;data[1]); break;
	case VBigInt: print("BigInt[%d] %.2x%.2x...",v.u.bigintval-&gt;len,v.u.bigintval-&gt;data[0],v.u.bigintval-&gt;data[1]); break;
	case VReal: print("Real..."); break;
	case VOther: print("Other..."); break;
	case VBitString: print("BitString");
		for(i = 0; i&lt;v.u.bitstringval-&gt;len; i++)
			print(" %02x", v.u.bitstringval-&gt;data[i]);
		break;
	case VNull: print("Null"); break;
	case VEOC: print("EOC..."); break;
	case VObjId: print("ObjId");
		for(i = 0; i&lt;v.u.objidval-&gt;len; i++)
			print(" %d", v.u.objidval-&gt;data[i]);
		break;
	case VString: print("String \"%s\"",v.u.stringval); break;
	case VSeq: print("Seq\n");
		for(el = v.u.seqval; el!=nil; el = el-&gt;tl)
			edump(el-&gt;hd);
		break;
	case VSet: print("Set\n");
		for(el = v.u.setval; el!=nil; el = el-&gt;tl)
			edump(el-&gt;hd);
		break;
	}
	print("}\n");
}

void
asn1dump(uchar *der, int len)
{
	Elem e;

	if(decode(der, len, &amp;e) != ASN_OK){
		print("didn't parse\n");
		exits("didn't parse");
	}
	edump(e);
}

void
X509dump(uchar *cert, int ncert)
{
	char *e;
	Bytes *b;
	CertX509 *c;
	RSApub *pk;
	uchar digest[SHA1dlen];
	Elem *sigalg;

	print("begin X509dump\n");
	b = makebytes(cert, ncert);
	c = decode_cert(b);
	if(c != nil)
		digest_certinfo(b, digestalg[c-&gt;signature_alg], digest);
	freebytes(b);
	if(c == nil){
		print("cannot decode cert");
		return;
	}

	print("serial %d\n", c-&gt;serial);
	print("issuer %s\n", c-&gt;issuer);
	print("validity %s %s\n", c-&gt;validity_start, c-&gt;validity_end);
	print("subject %s\n", c-&gt;subject);
	pk = decode_rsapubkey(c-&gt;publickey);
	print("pubkey e=%B n(%d)=%B\n", pk-&gt;ek, mpsignif(pk-&gt;n), pk-&gt;n);

	print("sigalg=%d digest=%.*H\n", c-&gt;signature_alg, MD5dlen, digest);
	e = verify_signature(c-&gt;signature, pk, digest, &amp;sigalg);
	if(e==nil){
		e = "nil (meaning ok)";
		print("sigalg=\n");
		if(sigalg)
			edump(*sigalg);
	}
	print("self-signed verify_signature returns: %s\n", e);

	rsapubfree(pk);
	freecert(c);
	print("end X509dump\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

