<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/5l/list.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/5l/list.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "l.h"

void
listinit(void)
{

	fmtinstall('A', Aconv);
	fmtinstall('C', Cconv);
	fmtinstall('D', Dconv);
	fmtinstall('P', Pconv);
	fmtinstall('S', Sconv);
	fmtinstall('N', Nconv);
}

void
prasm(Prog *p)
{
	print("%P\n", p);
}

int
Pconv(Fmt *fp)
{
	char str[STRINGSZ], *s;
	Prog *p;
	int a;

	p = va_arg(fp-&gt;args, Prog*);
	curp = p;
	a = p-&gt;as;
	switch(a) {
	default:
		s = str;
		s += sprint(s, "(%ld)", p-&gt;line);
		if(p-&gt;reg == NREG)
			sprint(s, "	%A%C	%D,%D",
				a, p-&gt;scond, &amp;p-&gt;from, &amp;p-&gt;to);
		else
		if(p-&gt;from.type != D_FREG)
			sprint(s, "	%A%C	%D,R%d,%D",
				a, p-&gt;scond, &amp;p-&gt;from, p-&gt;reg, &amp;p-&gt;to);
		else
			sprint(s, "	%A%C	%D,F%d,%D",
				a, p-&gt;scond, &amp;p-&gt;from, p-&gt;reg, &amp;p-&gt;to);
		break;

	case ASWPW:
	case ASWPBU:
		sprint(str, "(%ld)	%A%C	R%d,%D,%D",
			p-&gt;line, a, p-&gt;scond, p-&gt;reg, &amp;p-&gt;from, &amp;p-&gt;to);
		break;

	case ADATA:
	case AINIT:
	case ADYNT:
		sprint(str, "(%ld)	%A%C	%D/%d,%D",
			p-&gt;line, a, p-&gt;scond, &amp;p-&gt;from, p-&gt;reg, &amp;p-&gt;to);
		break;
	}
	return fmtstrcpy(fp, str);
}

int
Aconv(Fmt *fp)
{
	char *s;
	int a;

	a = va_arg(fp-&gt;args, int);
	s = "???";
	if(a &gt;= AXXX &amp;&amp; a &lt; ALAST)
		s = anames[a];
	return fmtstrcpy(fp, s);
}

char*	strcond[16] =
{
	".EQ",
	".NE",
	".HS",
	".LO",
	".MI",
	".PL",
	".VS",
	".VC",
	".HI",
	".LS",
	".GE",
	".LT",
	".GT",
	".LE",
	"",
	".NV"
};

int
Cconv(Fmt *fp)
{
	char s[20];
	int c;

	c = va_arg(fp-&gt;args, int);
	strcpy(s, strcond[c &amp; C_SCOND]);
	if(c &amp; C_SBIT)
		strcat(s, ".S");
	if(c &amp; C_PBIT)
		strcat(s, ".P");
	if(c &amp; C_WBIT)
		strcat(s, ".W");
	if(c &amp; C_UBIT)		/* ambiguous with FBIT */
		strcat(s, ".U");
	return fmtstrcpy(fp, s);
}

int
Dconv(Fmt *fp)
{
	char str[STRINGSZ];
	char *op;
	Adr *a;
	long v;

	a = va_arg(fp-&gt;args, Adr*);
	switch(a-&gt;type) {

	default:
		sprint(str, "GOK-type(%d)", a-&gt;type);
		break;

	case D_NONE:
		str[0] = 0;
		if(a-&gt;name != D_NONE || a-&gt;reg != NREG || a-&gt;sym != S)
			sprint(str, "%N(R%d)(NONE)", a, a-&gt;reg);
		break;

	case D_CONST:
		if(a-&gt;reg == NREG)
			sprint(str, "$%N", a);
		else
			sprint(str, "$%N(R%d)", a, a-&gt;reg);
		break;

	case D_SHIFT:
		v = a-&gt;offset;
		op = "&lt;&lt;&gt;&gt;-&gt;@&gt;" + (((v&gt;&gt;5) &amp; 3) &lt;&lt; 1);
		if(v &amp; (1&lt;&lt;4))
			sprint(str, "R%ld%c%cR%ld", v&amp;15, op[0], op[1], (v&gt;&gt;8)&amp;15);
		else
			sprint(str, "R%ld%c%c%ld", v&amp;15, op[0], op[1], (v&gt;&gt;7)&amp;31);
		if(a-&gt;reg != NREG)
			sprint(str+strlen(str), "(R%d)", a-&gt;reg);
		break;

	case D_OCONST:
		sprint(str, "$*$%N", a);
		if(a-&gt;reg != NREG)
			sprint(str, "%N(R%d)(CONST)", a, a-&gt;reg);
		break;

	case D_OREG:
		if(a-&gt;reg != NREG)
			sprint(str, "%N(R%d)", a, a-&gt;reg);
		else
			sprint(str, "%N", a);
		break;

	case D_REG:
		sprint(str, "R%d", a-&gt;reg);
		if(a-&gt;name != D_NONE || a-&gt;sym != S)
			sprint(str, "%N(R%d)(REG)", a, a-&gt;reg);
		break;

	case D_REGREG:
		sprint(str, "(R%d,R%d)", a-&gt;reg, (int)a-&gt;offset);
		if(a-&gt;name != D_NONE || a-&gt;sym != S)
			sprint(str, "%N(R%d)(REG)", a, a-&gt;reg);
		break;

	case D_FREG:
		sprint(str, "F%d", a-&gt;reg);
		if(a-&gt;name != D_NONE || a-&gt;sym != S)
			sprint(str, "%N(R%d)(REG)", a, a-&gt;reg);
		break;

	case D_PSR:
		switch(a-&gt;reg) {
		case 0:
			sprint(str, "CPSR");
			break;
		case 1:
			sprint(str, "SPSR");
			break;
		default:
			sprint(str, "PSR%d", a-&gt;reg);
			break;
		}
		if(a-&gt;name != D_NONE || a-&gt;sym != S)
			sprint(str, "%N(PSR%d)(REG)", a, a-&gt;reg);
		break;

	case D_FPCR:
		switch(a-&gt;reg){
		case 0:
			sprint(str, "FPSR");
			break;
		case 1:
			sprint(str, "FPCR");
			break;
		default:
			sprint(str, "FCR%d", a-&gt;reg);
			break;
		}
		if(a-&gt;name != D_NONE || a-&gt;sym != S)
			sprint(str, "%N(FCR%d)(REG)", a, a-&gt;reg);

		break;

	case D_BRANCH:	/* botch */
		if(curp-&gt;cond != P) {
			v = curp-&gt;cond-&gt;pc;
			if(a-&gt;sym != S)
				sprint(str, "%s+%.5lux(BRANCH)", a-&gt;sym-&gt;name, v);
			else
				sprint(str, "%.5lux(BRANCH)", v);
		} else
			if(a-&gt;sym != S)
				sprint(str, "%s+%ld(APC)", a-&gt;sym-&gt;name, a-&gt;offset);
			else
				sprint(str, "%ld(APC)", a-&gt;offset);
		break;

	case D_FCONST:
		sprint(str, "$%e", ieeedtod(a-&gt;ieee));
		break;

	case D_SCONST:
		sprint(str, "$\"%S\"", a-&gt;sval);
		break;
	}
	return fmtstrcpy(fp, str);
}

int
Nconv(Fmt *fp)
{
	char str[STRINGSZ];
	Adr *a;
	Sym *s;

	a = va_arg(fp-&gt;args, Adr*);
	s = a-&gt;sym;
	switch(a-&gt;name) {
	default:
		sprint(str, "GOK-name(%d)", a-&gt;name);
		break;

	case D_NONE:
		sprint(str, "%ld", a-&gt;offset);
		break;

	case D_EXTERN:
		if(s == S)
			sprint(str, "%ld(SB)", a-&gt;offset);
		else
			sprint(str, "%s+%ld(SB)", s-&gt;name, a-&gt;offset);
		break;

	case D_STATIC:
		if(s == S)
			sprint(str, "&lt;&gt;+%ld(SB)", a-&gt;offset);
		else
			sprint(str, "%s&lt;&gt;+%ld(SB)", s-&gt;name, a-&gt;offset);
		break;

	case D_AUTO:
		if(s == S)
			sprint(str, "%ld(SP)", a-&gt;offset);
		else
			sprint(str, "%s-%ld(SP)", s-&gt;name, -a-&gt;offset);
		break;

	case D_PARAM:
		if(s == S)
			sprint(str, "%ld(FP)", a-&gt;offset);
		else
			sprint(str, "%s+%ld(FP)", s-&gt;name, a-&gt;offset);
		break;
	}
	return fmtstrcpy(fp, str);
}

int
Sconv(Fmt *fp)
{
	int i, c;
	char str[STRINGSZ], *p, *a;

	a = va_arg(fp-&gt;args, char*);
	p = str;
	for(i=0; i&lt;sizeof(long); i++) {
		c = a[i] &amp; 0xff;
		if(c &gt;= 'a' &amp;&amp; c &lt;= 'z' ||
		   c &gt;= 'A' &amp;&amp; c &lt;= 'Z' ||
		   c &gt;= '0' &amp;&amp; c &lt;= '9' ||
		   c == ' ' || c == '%') {
			*p++ = c;
			continue;
		}
		*p++ = '\\';
		switch(c) {
		case 0:
			*p++ = 'z';
			continue;
		case '\\':
		case '"':
			*p++ = c;
			continue;
		case '\n':
			*p++ = 'n';
			continue;
		case '\t':
			*p++ = 't';
			continue;
		}
		*p++ = (c&gt;&gt;6) + '0';
		*p++ = ((c&gt;&gt;3) &amp; 7) + '0';
		*p++ = (c &amp; 7) + '0';
	}
	*p = 0;
	return fmtstrcpy(fp, str);
}

void
diag(char *fmt, ...)
{
	char buf[STRINGSZ], *tn;
	va_list arg;

	tn = "??none??";
	if(curtext != P &amp;&amp; curtext-&gt;from.sym != S)
		tn = curtext-&gt;from.sym-&gt;name;
	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	print("%s: %s\n", tn, buf);

	nerrors++;
	if(nerrors &gt; 10) {
		print("too many errors\n");
		errorexit();
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

