<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/5l/noop.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/5l/noop.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

static	Sym*	sym_div;
static	Sym*	sym_divu;
static	Sym*	sym_mod;
static	Sym*	sym_modu;

void
noops(void)
{
	Prog *p, *q, *q1;
	int o, curframe, curbecome, maxbecome;

	/*
	 * find leaf subroutines
	 * become sizes
	 * frame sizes
	 * strip NOPs
	 * expand RET
	 * expand BECOME pseudo
	 */

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f noops\n", cputime());
	Bflush(&amp;bso);

	curframe = 0;
	curbecome = 0;
	maxbecome = 0;
	curtext = 0;

	q = P;
	for(p = firstp; p != P; p = p-&gt;link) {

		/* find out how much arg space is used in this TEXT */
		if(p-&gt;to.type == D_OREG &amp;&amp; p-&gt;to.reg == REGSP)
			if(p-&gt;to.offset &gt; curframe)
				curframe = p-&gt;to.offset;

		switch(p-&gt;as) {
		case ATEXT:
			if(curtext &amp;&amp; curtext-&gt;from.sym) {
				curtext-&gt;from.sym-&gt;frame = curframe;
				curtext-&gt;from.sym-&gt;become = curbecome;
				if(curbecome &gt; maxbecome)
					maxbecome = curbecome;
			}
			curframe = 0;
			curbecome = 0;

			p-&gt;mark |= LEAF;
			curtext = p;
			break;

		case ARET:
			/* special form of RET is BECOME */
			if(p-&gt;from.type == D_CONST)
				if(p-&gt;from.offset &gt; curbecome)
					curbecome = p-&gt;from.offset;
			break;

		case ADIV:
		case ADIVU:
		case AMOD:
		case AMODU:
			q = p;
			if(prog_div == P)
				initdiv();
			if(curtext != P)
				curtext-&gt;mark &amp;= ~LEAF;
			continue;

		case ANOP:
			q1 = p-&gt;link;
			q-&gt;link = q1;		/* q is non-nop */
			q1-&gt;mark |= p-&gt;mark;
			continue;

		case ABL:
			if(curtext != P)
				curtext-&gt;mark &amp;= ~LEAF;

		case ABCASE:
		case AB:

		case ABEQ:
		case ABNE:
		case ABCS:
		case ABHS:
		case ABCC:
		case ABLO:
		case ABMI:
		case ABPL:
		case ABVS:
		case ABVC:
		case ABHI:
		case ABLS:
		case ABGE:
		case ABLT:
		case ABGT:
		case ABLE:

			q1 = p-&gt;cond;
			if(q1 != P) {
				while(q1-&gt;as == ANOP) {
					q1 = q1-&gt;link;
					p-&gt;cond = q1;
				}
			}
			break;
		}
		q = p;
	}

	if(curtext &amp;&amp; curtext-&gt;from.sym) {
		curtext-&gt;from.sym-&gt;frame = curframe;
		curtext-&gt;from.sym-&gt;become = curbecome;
		if(curbecome &gt; maxbecome)
			maxbecome = curbecome;
	}

	if(debug['b'])
		print("max become = %d\n", maxbecome);
	xdefine("ALEFbecome", STEXT, maxbecome);

	curtext = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		switch(p-&gt;as) {
		case ATEXT:
			curtext = p;
			break;
		case ABL:
			if(curtext != P &amp;&amp; curtext-&gt;from.sym != S &amp;&amp; curtext-&gt;to.offset &gt;= 0) {
				o = maxbecome - curtext-&gt;from.sym-&gt;frame;
				if(o &lt;= 0)
					break;
				/* calling a become or calling a variable */
				if(p-&gt;to.sym == S || p-&gt;to.sym-&gt;become) {
					curtext-&gt;to.offset += o;
					if(debug['b']) {
						curp = p;
						print("%D calling %D increase %d\n",
							&amp;curtext-&gt;from, &amp;p-&gt;to, o);
					}
				}
			}
			break;
		}
	}

	for(p = firstp; p != P; p = p-&gt;link) {
		o = p-&gt;as;
		switch(o) {
		case ATEXT:
			curtext = p;
			autosize = p-&gt;to.offset + 4;
			if(autosize &lt;= 4)
			if(curtext-&gt;mark &amp; LEAF) {
				p-&gt;to.offset = -4;
				autosize = 0;
			}

			if(!autosize &amp;&amp; !(curtext-&gt;mark &amp; LEAF)) {
				if(debug['v'])
					Bprint(&amp;bso, "save suppressed in: %s\n",
						curtext-&gt;from.sym-&gt;name);
				Bflush(&amp;bso);
				curtext-&gt;mark |= LEAF;
			}

			if(curtext-&gt;mark &amp; LEAF) {
				if(curtext-&gt;from.sym)
					curtext-&gt;from.sym-&gt;type = SLEAF;
#ifdef optimise_time
				if(autosize) {
					q = prg();
					q-&gt;as = ASUB;
					q-&gt;line = p-&gt;line;
					q-&gt;from.type = D_CONST;
					q-&gt;from.offset = autosize;
					q-&gt;to.type = D_REG;
					q-&gt;to.reg = REGSP;

					q-&gt;link = p-&gt;link;
					p-&gt;link = q;
				}
				break;
#else
				if(!autosize)
					break;
#endif
			}

			q1 = prg();
			q1-&gt;as = AMOVW;
			q1-&gt;scond |= C_WBIT;
			q1-&gt;line = p-&gt;line;
			q1-&gt;from.type = D_REG;
			q1-&gt;from.reg = REGLINK;
			q1-&gt;to.type = D_OREG;
			q1-&gt;to.offset = -autosize;
			q1-&gt;to.reg = REGSP;

			q1-&gt;link = p-&gt;link;
			p-&gt;link = q1;
			break;

		case ARET:
			nocache(p);
			if(p-&gt;from.type == D_CONST)
				goto become;
			if(curtext-&gt;mark &amp; LEAF) {
				if(!autosize) {
					p-&gt;as = AB;
					p-&gt;from = zprg.from;
					p-&gt;to.type = D_OREG;
					p-&gt;to.offset = 0;
					p-&gt;to.reg = REGLINK;
					break;
				}

#ifdef optimise_time
				p-&gt;as = AADD;
				p-&gt;from.type = D_CONST;
				p-&gt;from.offset = autosize;
				p-&gt;to.type = D_REG;
				p-&gt;to.reg = REGSP;

				q = prg();
				q-&gt;as = AB;
				q-&gt;scond = p-&gt;scond;
				q-&gt;line = p-&gt;line;
				q-&gt;to.type = D_OREG;
				q-&gt;to.offset = 0;
				q-&gt;to.reg = REGLINK;

				q-&gt;link = p-&gt;link;
				p-&gt;link = q;

				break;
#endif
			}
			p-&gt;as = AMOVW;
			p-&gt;scond |= C_PBIT;
			p-&gt;from.type = D_OREG;
			p-&gt;from.offset = autosize;
			p-&gt;from.reg = REGSP;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGPC;
			break;

		become:
			if(curtext-&gt;mark &amp; LEAF) {

				if(!autosize) {
					p-&gt;as = AB;
					p-&gt;from = zprg.from;
					break;
				}

#ifdef optimise_time
				q = prg();
				q-&gt;scond = p-&gt;scond;
				q-&gt;line = p-&gt;line;
				q-&gt;as = AB;
				q-&gt;from = zprg.from;
				q-&gt;to = p-&gt;to;
				q-&gt;cond = p-&gt;cond;
				q-&gt;link = p-&gt;link;
				p-&gt;link = q;

				p-&gt;as = AADD;
				p-&gt;from = zprg.from;
				p-&gt;from.type = D_CONST;
				p-&gt;from.offset = autosize;
				p-&gt;to = zprg.to;
				p-&gt;to.type = D_REG;
				p-&gt;to.reg = REGSP;

				break;
#endif
			}
			q = prg();
			q-&gt;scond = p-&gt;scond;
			q-&gt;line = p-&gt;line;
			q-&gt;as = AB;
			q-&gt;from = zprg.from;
			q-&gt;to = p-&gt;to;
			q-&gt;cond = p-&gt;cond;
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;

			p-&gt;as = AMOVW;
			p-&gt;scond |= C_PBIT;
			p-&gt;from = zprg.from;
			p-&gt;from.type = D_OREG;
			p-&gt;from.offset = autosize;
			p-&gt;from.reg = REGSP;
			p-&gt;to = zprg.to;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGLINK;

			break;

		/*
		 * 5c code generation for unsigned -&gt; double made the
		 * unfortunate assumption that single and double floating
		 * point registers are aliased - true for emulated 7500
		 * but not for vfp.  Now corrected, but this test is
		 * insurance against old 5c compiled code in libraries.
		 */
		case AMOVWD:
			if((q = p-&gt;link) != P &amp;&amp; q-&gt;as == ACMP)
			if((q = q-&gt;link) != P &amp;&amp; q-&gt;as == AMOVF)
			if((q1 = q-&gt;link) != P &amp;&amp; q1-&gt;as == AADDF)
			if(q1-&gt;to.type == D_FREG &amp;&amp; q1-&gt;to.reg == p-&gt;to.reg) {
				q1-&gt;as = AADDD;
				q1 = prg();
				q1-&gt;scond = q-&gt;scond;
				q1-&gt;line = q-&gt;line;
				q1-&gt;as = AMOVFD;
				q1-&gt;from = q-&gt;to;
				q1-&gt;to = q1-&gt;from;
				q1-&gt;link = q-&gt;link;
				q-&gt;link = q1;
			}
			break;

		case ADIV:
		case ADIVU:
		case AMOD:
		case AMODU:
			if(debug['M'])
				break;
			if(p-&gt;from.type != D_REG)
				break;
			if(p-&gt;to.type != D_REG)
				break;
			q1 = p;

			/* MOV a,4(SP) */
			q = prg();
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;

			p-&gt;as = AMOVW;
			p-&gt;line = q1-&gt;line;
			p-&gt;from.type = D_REG;
			p-&gt;from.reg = q1-&gt;from.reg;
			p-&gt;to.type = D_OREG;
			p-&gt;to.reg = REGSP;
			p-&gt;to.offset = 4;

			/* MOV b,REGTMP */
			q = prg();
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;

			p-&gt;as = AMOVW;
			p-&gt;line = q1-&gt;line;
			p-&gt;from.type = D_REG;
			p-&gt;from.reg = q1-&gt;reg;
			if(q1-&gt;reg == NREG)
				p-&gt;from.reg = q1-&gt;to.reg;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGTMP;
			p-&gt;to.offset = 0;

			/* CALL appropriate */
			q = prg();
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;

			p-&gt;as = ABL;
			p-&gt;line = q1-&gt;line;
			p-&gt;to.type = D_BRANCH;
			p-&gt;cond = p;
			switch(o) {
			case ADIV:
				p-&gt;cond = prog_div;
				p-&gt;to.sym = sym_div;
				break;
			case ADIVU:
				p-&gt;cond = prog_divu;
				p-&gt;to.sym = sym_divu;
				break;
			case AMOD:
				p-&gt;cond = prog_mod;
				p-&gt;to.sym = sym_mod;
				break;
			case AMODU:
				p-&gt;cond = prog_modu;
				p-&gt;to.sym = sym_modu;
				break;
			}

			/* MOV REGTMP, b */
			q = prg();
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;

			p-&gt;as = AMOVW;
			p-&gt;line = q1-&gt;line;
			p-&gt;from.type = D_REG;
			p-&gt;from.reg = REGTMP;
			p-&gt;from.offset = 0;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = q1-&gt;to.reg;

			/* ADD $8,SP */
			q = prg();
			q-&gt;link = p-&gt;link;
			p-&gt;link = q;
			p = q;

			p-&gt;as = AADD;
			p-&gt;from.type = D_CONST;
			p-&gt;from.reg = NREG;
			p-&gt;from.offset = 8;
			p-&gt;reg = NREG;
			p-&gt;to.type = D_REG;
			p-&gt;to.reg = REGSP;

			/* SUB $8,SP */
			q1-&gt;as = ASUB;
			q1-&gt;from.type = D_CONST;
			q1-&gt;from.offset = 8;
			q1-&gt;from.reg = NREG;
			q1-&gt;reg = NREG;
			q1-&gt;to.type = D_REG;
			q1-&gt;to.reg = REGSP;
			break;
		}
	}
}

static void
sigdiv(char *n)
{
	Sym *s;

	s = lookup(n, 0);
	if(s-&gt;type == STEXT){
		if(s-&gt;sig == 0)
			s-&gt;sig = SIGNINTERN;
	}
	else if(s-&gt;type == 0 || s-&gt;type == SXREF)
		s-&gt;type = SUNDEF;
}

void
divsig(void)
{
	sigdiv("_div");
	sigdiv("_divu");
	sigdiv("_mod");
	sigdiv("_modu");
}

static void
sdiv(Sym *s)
{
	if(s-&gt;type == 0 || s-&gt;type == SXREF){
		/* undefsym(s); */
		s-&gt;type = SXREF;
		if(s-&gt;sig == 0)
			s-&gt;sig = SIGNINTERN;
		s-&gt;subtype = SIMPORT;
	}
	else if(s-&gt;type != STEXT)
		diag("undefined: %s", s-&gt;name);
}

void
initdiv(void)
{
	Sym *s2, *s3, *s4, *s5;
	Prog *p;

	if(prog_div != P)
		return;
	sym_div = s2 = lookup("_div", 0);
	sym_divu = s3 = lookup("_divu", 0);
	sym_mod = s4 = lookup("_mod", 0);
	sym_modu = s5 = lookup("_modu", 0);
	if(dlm) {
		sdiv(s2); if(s2-&gt;type == SXREF) prog_div = UP;
		sdiv(s3); if(s3-&gt;type == SXREF) prog_divu = UP;
		sdiv(s4); if(s4-&gt;type == SXREF) prog_mod = UP;
		sdiv(s5); if(s5-&gt;type == SXREF) prog_modu = UP;
	}
	for(p = firstp; p != P; p = p-&gt;link)
		if(p-&gt;as == ATEXT) {
			if(p-&gt;from.sym == s2)
				prog_div = p;
			if(p-&gt;from.sym == s3)
				prog_divu = p;
			if(p-&gt;from.sym == s4)
				prog_mod = p;
			if(p-&gt;from.sym == s5)
				prog_modu = p;
		}
	if(prog_div == P) {
		diag("undefined: %s", s2-&gt;name);
		prog_div = curtext;
	}
	if(prog_divu == P) {
		diag("undefined: %s", s3-&gt;name);
		prog_divu = curtext;
	}
	if(prog_mod == P) {
		diag("undefined: %s", s4-&gt;name);
		prog_mod = curtext;
	}
	if(prog_modu == P) {
		diag("undefined: %s", s5-&gt;name);
		prog_modu = curtext;
	}
}

void
nocache(Prog *p)
{
	p-&gt;optab = 0;
	p-&gt;from.class = 0;
	p-&gt;to.class = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

