<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/6l/asm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/6l/asm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

#define	Dbufslop	100

#define PADDR(a)	((a) &amp; ~0xfffffffff0000000ull)

vlong
entryvalue(void)
{
	char *a;
	Sym *s;

	a = INITENTRY;
	if(*a &gt;= '0' &amp;&amp; *a &lt;= '9')
		return atolwhex(a);
	s = lookup(a, 0);
	if(s-&gt;type == 0)
		return INITTEXT;
	switch(s-&gt;type) {
	case STEXT:
		break;
	case SDATA:
		if(dlm)
			return s-&gt;value+INITDAT;
	default:
		diag("entry not text: %s", s-&gt;name);
	}
	return s-&gt;value;
}

/* these need to take long arguments to be compatible with elf.c */void
wputl(long w)
{
	cput(w);
	cput(w&gt;&gt;8);
}

void
wput(long w)
{
	cput(w&gt;&gt;8);
	cput(w);
}

void
lput(long l)
{
	cput(l&gt;&gt;24);
	cput(l&gt;&gt;16);
	cput(l&gt;&gt;8);
	cput(l);
}

void
llput(vlong v)
{
	lput(v&gt;&gt;32);
	lput(v);
}

void
lputl(long l)
{
	cput(l);
	cput(l&gt;&gt;8);
	cput(l&gt;&gt;16);
	cput(l&gt;&gt;24);
}

void
llputl(vlong v)
{
	lputl(v);
	lputl(v&gt;&gt;32);
}

void
strnput(char *s, int n)
{
	for(; *s &amp;&amp; n &gt; 0; s++){
		cput(*s);
		n--;
	}
	while(n &gt; 0){
		cput(0);
		n--;
	}
}

void
asmb(void)
{
	Prog *p;
	long v, magic;
	int a;
	uchar *op1;
	vlong vl;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f asmb\n", cputime());
	Bflush(&amp;bso);

	seek(cout, HEADR, 0);
	pc = INITTEXT;
	curp = firstp;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		if(p-&gt;pc != pc) {
			if(!debug['a'])
				print("%P\n", curp);
			diag("phase error %llux sb %llux in %s", p-&gt;pc, pc, TNAME);
			pc = p-&gt;pc;
		}
		curp = p;
		asmins(p);
		a = (andptr - and);
		if(cbc &lt; a)
			cflush();
		if(debug['a']) {
			Bprint(&amp;bso, pcstr, pc);
			for(op1 = and; op1 &lt; andptr; op1++)
				Bprint(&amp;bso, "%.2ux", *op1 &amp; 0xff);
			Bprint(&amp;bso, "\t%P\n", curp);
		}
		if(dlm) {
			if(p-&gt;as == ATEXT)
				reloca = nil;
			else if(reloca != nil)
				diag("reloc failure: %P", curp);
		}
		memmove(cbp, and, a);
		cbp += a;
		pc += a;
		cbc -= a;
	}
	cflush();
	switch(HEADTYPE) {
	default:
		diag("unknown header type %ld", HEADTYPE);
	case 2:
	case 5:
	case 6:
		seek(cout, HEADR+textsize, 0);
		break;
	}

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f datblk\n", cputime());
	Bflush(&amp;bso);

	if(dlm){
		char buf[8];

		write(cout, buf, INITDAT-textsize);
		textsize = INITDAT;
	}

	for(v = 0; v &lt; datsize; v += sizeof(buf)-Dbufslop) {
		if(datsize-v &gt; sizeof(buf)-Dbufslop)
			datblk(v, sizeof(buf)-Dbufslop);
		else
			datblk(v, datsize-v);
	}

	symsize = 0;
	spsize = 0;
	lcsize = 0;
	if(!debug['s']) {
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f sym\n", cputime());
		Bflush(&amp;bso);
		switch(HEADTYPE) {
		default:
		case 2:
		case 5:
		case 6:
			seek(cout, HEADR+textsize+datsize, 0);
			break;
		}
		if(!debug['s'])
			asmsym();
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f sp\n", cputime());
		Bflush(&amp;bso);
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f pc\n", cputime());
		Bflush(&amp;bso);
		if(!debug['s'])
			asmlc();
		if(dlm)
			asmdyn();
		cflush();
	}
	else if(dlm){
		seek(cout, HEADR+textsize+datsize, 0);
		asmdyn();
		cflush();
	}
	if(debug['v'])
		Bprint(&amp;bso, "%5.2f headr\n", cputime());
	Bflush(&amp;bso);
	seek(cout, 0L, 0);
	switch(HEADTYPE) {
	default:
	case 2:	/* plan9 */
		magic = 4*26*26+7;
		magic |= 0x00008000;		/* fat header */
		if(dlm)
			magic |= 0x80000000;	/* dlm */
		lput(magic);			/* magic */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(symsize);			/* nsyms */
		vl = entryvalue();
		lput(PADDR(vl));		/* va of entry */
		lput(spsize);			/* sp offsets */
		lput(lcsize);			/* line offsets */
		llput(vl);			/* va of entry */
		break;
	case 5:
		elf32(debug['8']? I386: AMD64, ELFDATA2LSB, 0, nil);
		break;
	case 6:
		elf64(AMD64, ELFDATA2LSB, 0, nil);
		break;
	}
	cflush();
}

void
cflush(void)
{
	int n;

	n = sizeof(buf.cbuf) - cbc;
	if(n)
		write(cout, buf.cbuf, n);
	cbp = buf.cbuf;
	cbc = sizeof(buf.cbuf);
}

void
datblk(long s, long n)
{
	Prog *p;
	uchar *cast;
	long l, fl, j;
	vlong o;
	int i, c;

	memset(buf.dbuf, 0, n+Dbufslop);
	for(p = datap; p != P; p = p-&gt;link) {
		curp = p;
		l = p-&gt;from.sym-&gt;value + p-&gt;from.offset - s;
		c = p-&gt;from.scale;
		i = 0;
		if(l &lt; 0) {
			if(l+c &lt;= 0)
				continue;
			while(l &lt; 0) {
				l++;
				i++;
			}
		}
		if(l &gt;= n)
			continue;
		if(p-&gt;as != AINIT &amp;&amp; p-&gt;as != ADYNT) {
			for(j=l+(c-i)-1; j&gt;=l; j--)
				if(buf.dbuf[j]) {
					print("%P\n", p);
					diag("multiple initialization");
					break;
				}
		}
		switch(p-&gt;to.type) {
		case D_FCONST:
			switch(c) {
			default:
			case 4:
				fl = ieeedtof(&amp;p-&gt;to.ieee);
				cast = (uchar*)&amp;fl;
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[fnuxi4[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi4[i]];
					l++;
				}
				break;
			case 8:
				cast = (uchar*)&amp;p-&gt;to.ieee;
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[fnuxi8[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i]];
					l++;
				}
				break;
			}
			break;

		case D_SCONST:
			if(debug['a'] &amp;&amp; i == 0) {
				Bprint(&amp;bso, pcstr, l+s+INITDAT);
				for(j=0; j&lt;c; j++)
					Bprint(&amp;bso, "%.2ux", p-&gt;to.scon[j] &amp; 0xff);
				Bprint(&amp;bso, "\t%P\n", curp);
			}
			for(; i&lt;c; i++) {
				buf.dbuf[l] = p-&gt;to.scon[i];
				l++;
			}
			break;
		default:
			o = p-&gt;to.offset;
			if(p-&gt;to.type == D_ADDR) {
				if(p-&gt;to.index != D_STATIC &amp;&amp; p-&gt;to.index != D_EXTERN)
					diag("DADDR type%P", p);
				if(p-&gt;to.sym) {
					if(p-&gt;to.sym-&gt;type == SUNDEF)
						ckoff(p-&gt;to.sym, o);
					o += p-&gt;to.sym-&gt;value;
					if(p-&gt;to.sym-&gt;type != STEXT &amp;&amp; p-&gt;to.sym-&gt;type != SUNDEF)
						o += INITDAT;
					if(dlm)
						dynreloc(p-&gt;to.sym, l+s+INITDAT, 1);
				}
			}
			fl = o;
			cast = (uchar*)&amp;fl;
			switch(c) {
			default:
				diag("bad nuxi %d %d\n%P", c, i, curp);
				break;
			case 1:
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[inuxi1[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi1[i]];
					l++;
				}
				break;
			case 2:
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[inuxi2[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi2[i]];
					l++;
				}
				break;
			case 4:
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[inuxi4[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi4[i]];
					l++;
				}
				break;
			case 8:
				cast = (uchar*)&amp;o;
				if(debug['a'] &amp;&amp; i == 0) {
					Bprint(&amp;bso, pcstr, l+s+INITDAT);
					for(j=0; j&lt;c; j++)
						Bprint(&amp;bso, "%.2ux", cast[inuxi8[j]]);
					Bprint(&amp;bso, "\t%P\n", curp);
				}
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi8[i]];
					l++;
				}
				break;
			}
			break;
		}
	}
	write(cout, buf.dbuf, n);
}

vlong
rnd(vlong v, vlong r)
{
	vlong c;

	if(r &lt;= 0)
		return v;
	v += r - 1;
	c = v % r;
	if(c &lt; 0)
		c += r;
	v -= c;
	return v;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

