<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/6l/pass.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/6l/pass.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

void
dodata(void)
{
	int i;
	Sym *s;
	Prog *p;
	long t, u;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f dodata\n", cputime());
	Bflush(&amp;bso);
	for(p = datap; p != P; p = p-&gt;link) {
		s = p-&gt;from.sym;
		if(p-&gt;as == ADYNT || p-&gt;as == AINIT)
			s-&gt;value = dtype;
		if(s-&gt;type == SBSS)
			s-&gt;type = SDATA;
		if(s-&gt;type != SDATA)
			diag("initialize non-data (%d): %s\n%P",
				s-&gt;type, s-&gt;name, p);
		t = p-&gt;from.offset + p-&gt;width;
		if(t &gt; s-&gt;value)
			diag("initialize bounds (%lld): %s\n%P",
				s-&gt;value, s-&gt;name, p);
	}
	/* allocate small guys */
	datsize = 0;
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		if(s-&gt;type != SDATA)
		if(s-&gt;type != SBSS)
			continue;
		t = s-&gt;value;
		if(t == 0) {
			diag("%s: no size", s-&gt;name);
			t = 1;
		}
		t = rnd(t, 4);
		s-&gt;value = t;
		if(t &gt; MINSIZ)
			continue;
		if(t &gt;= 8)
			datsize = rnd(datsize, 8);
		s-&gt;value = datsize;
		datsize += t;
		s-&gt;type = SDATA1;
	}

	/* allocate the rest of the data */
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		if(s-&gt;type != SDATA) {
			if(s-&gt;type == SDATA1)
				s-&gt;type = SDATA;
			continue;
		}
		t = s-&gt;value;
		if(t &gt;= 8)
			datsize = rnd(datsize, 8);
		s-&gt;value = datsize;
		datsize += t;
	}
	if(datsize)
		datsize = rnd(datsize, 8);

	if(debug['j']) {
		/*
		 * pad data with bss that fits up to next
		 * 8k boundary, then push data to 8k
		 */
		u = rnd(datsize, 8192);
		u -= datsize;
		for(i=0; i&lt;NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link) {
			if(s-&gt;type != SBSS)
				continue;
			t = s-&gt;value;
			if(t &gt; u)
				continue;
			u -= t;
			s-&gt;value = datsize;
			s-&gt;type = SDATA;
			datsize += t;
		}
		datsize += u;
	}

	/* now the bss */
	bsssize = 0;
	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link) {
		if(s-&gt;type != SBSS)
			continue;
		t = s-&gt;value;
		if(t &gt;= 8)
			bsssize = rnd(bsssize, 8);
		s-&gt;value = bsssize + datsize;
		bsssize += t;
	}
	xdefine("edata", SBSS, datsize);
	xdefine("end", SBSS, bsssize + datsize);
}

Prog*
brchain(Prog *p)
{
	int i;

	for(i=0; i&lt;20; i++) {
		if(p == P || p-&gt;as != AJMP)
			return p;
		p = p-&gt;pcond;
	}
	return P;
}

void
follow(void)
{

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f follow\n", cputime());
	Bflush(&amp;bso);
	firstp = prg();
	lastp = firstp;
	xfol(textp);
	lastp-&gt;link = P;
	firstp = firstp-&gt;link;
}

void
xfol(Prog *p)
{
	Prog *q;
	int i;
	enum as a;

loop:
	if(p == P)
		return;
	if(p-&gt;as == ATEXT)
		curtext = p;
	if(p-&gt;as == AJMP)
	if((q = p-&gt;pcond) != P) {
		p-&gt;mark = 1;
		p = q;
		if(p-&gt;mark == 0)
			goto loop;
	}
	if(p-&gt;mark) {
		/* copy up to 4 instructions to avoid branch */
		for(i=0,q=p; i&lt;4; i++,q=q-&gt;link) {
			if(q == P)
				break;
			if(q == lastp)
				break;
			a = q-&gt;as;
			if(a == ANOP) {
				i--;
				continue;
			}
			switch(a) {
			case AJMP:
			case ARET:
			case AIRETL:
			case AIRETQ:
			case AIRETW:
			case ARETFL:
			case ARETFQ:
			case ARETFW:

			case APUSHL:
			case APUSHFL:
			case APUSHQ:
			case APUSHFQ:
			case APUSHW:
			case APUSHFW:
			case APOPL:
			case APOPFL:
			case APOPQ:
			case APOPFQ:
			case APOPW:
			case APOPFW:
				goto brk;
			}
			if(q-&gt;pcond == P || q-&gt;pcond-&gt;mark)
				continue;
			if(a == ACALL || a == ALOOP)
				continue;
			for(;;) {
				if(p-&gt;as == ANOP) {
					p = p-&gt;link;
					continue;
				}
				q = copyp(p);
				p = p-&gt;link;
				q-&gt;mark = 1;
				lastp-&gt;link = q;
				lastp = q;
				if(q-&gt;as != a || q-&gt;pcond == P || q-&gt;pcond-&gt;mark)
					continue;

				q-&gt;as = relinv(q-&gt;as);
				p = q-&gt;pcond;
				q-&gt;pcond = q-&gt;link;
				q-&gt;link = p;
				xfol(q-&gt;link);
				p = q-&gt;link;
				if(p-&gt;mark)
					return;
				goto loop;
			}
		} /* */
	brk:;
		q = prg();
		q-&gt;as = AJMP;
		q-&gt;line = p-&gt;line;
		q-&gt;to.type = D_BRANCH;
		q-&gt;to.offset = p-&gt;pc;
		q-&gt;pcond = p;
		p = q;
	}
	p-&gt;mark = 1;
	lastp-&gt;link = p;
	lastp = p;
	a = p-&gt;as;
	if(a == AJMP || a == ARET || a == AIRETL || a == AIRETQ || a == AIRETW ||
	   a == ARETFL || a == ARETFQ || a == ARETFW)
		return;
	if(p-&gt;pcond != P)
	if(a != ACALL) {
		q = brchain(p-&gt;link);
		if(q != P &amp;&amp; q-&gt;mark)
		if(a != ALOOP) {
			p-&gt;as = relinv(a);
			p-&gt;link = p-&gt;pcond;
			p-&gt;pcond = q;
		}
		xfol(p-&gt;link);
		q = brchain(p-&gt;pcond);
		if(q-&gt;mark) {
			p-&gt;pcond = q;
			return;
		}
		p = q;
		goto loop;
	}
	p = p-&gt;link;
	goto loop;
}

int
relinv(int a)
{

	switch(a) {
	case AJEQ:	return AJNE;
	case AJNE:	return AJEQ;
	case AJLE:	return AJGT;
	case AJLS:	return AJHI;
	case AJLT:	return AJGE;
	case AJMI:	return AJPL;
	case AJGE:	return AJLT;
	case AJPL:	return AJMI;
	case AJGT:	return AJLE;
	case AJHI:	return AJLS;
	case AJCS:	return AJCC;
	case AJCC:	return AJCS;
	case AJPS:	return AJPC;
	case AJPC:	return AJPS;
	case AJOS:	return AJOC;
	case AJOC:	return AJOS;
	}
	diag("unknown relation: %s in %s", anames[a], TNAME);
	return a;
}

void
doinit(void)
{
	Sym *s;
	Prog *p;
	int x;

	for(p = datap; p != P; p = p-&gt;link) {
		x = p-&gt;to.type;
		if(x != D_EXTERN &amp;&amp; x != D_STATIC)
			continue;
		s = p-&gt;to.sym;
		if(s-&gt;type == 0 || s-&gt;type == SXREF)
			diag("undefined %s initializer of %s",
				s-&gt;name, p-&gt;from.sym-&gt;name);
		p-&gt;to.offset += s-&gt;value;
		p-&gt;to.type = D_CONST;
		if(s-&gt;type == SDATA || s-&gt;type == SBSS)
			p-&gt;to.offset += INITDAT;
	}
}

void
patch(void)
{
	long c;
	Prog *p, *q;
	Sym *s;
	long vexit;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f mkfwd\n", cputime());
	Bflush(&amp;bso);
	mkfwd();
	if(debug['v'])
		Bprint(&amp;bso, "%5.2f patch\n", cputime());
	Bflush(&amp;bso);
	s = lookup("exit", 0);
	vexit = s-&gt;value;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		if(p-&gt;as == ACALL || p-&gt;as == ARET) {
			s = p-&gt;to.sym;
			if(s) {
				if(debug['c'])
					Bprint(&amp;bso, "%s calls %s\n", TNAME, s-&gt;name);
				switch(s-&gt;type) {
				default:
					diag("undefined: %s in %s", s-&gt;name, TNAME);
					s-&gt;type = STEXT;
					s-&gt;value = vexit;
					break;	/* or fall through to set offset? */
				case STEXT:
					p-&gt;to.offset = s-&gt;value;
					break;
				case SUNDEF:
					p-&gt;pcond = UP;
					p-&gt;to.offset = 0;
					break;
				}
				p-&gt;to.type = D_BRANCH;
			}
		}
		if(p-&gt;to.type != D_BRANCH || p-&gt;pcond == UP)
			continue;
		c = p-&gt;to.offset;
		for(q = firstp; q != P;) {
			if(q-&gt;forwd != P)
			if(c &gt;= q-&gt;forwd-&gt;pc) {
				q = q-&gt;forwd;
				continue;
			}
			if(c == q-&gt;pc)
				break;
			q = q-&gt;link;
		}
		if(q == P) {
			diag("branch out of range in %s\n%P", TNAME, p);
			p-&gt;to.type = D_NONE;
		}
		p-&gt;pcond = q;
	}

	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		p-&gt;mark = 0;	/* initialization for follow */
		if(p-&gt;pcond != P &amp;&amp; p-&gt;pcond != UP) {
			p-&gt;pcond = brloop(p-&gt;pcond);
			if(p-&gt;pcond != P)
			if(p-&gt;to.type == D_BRANCH)
				p-&gt;to.offset = p-&gt;pcond-&gt;pc;
		}
	}
}

#define	LOG	5
void
mkfwd(void)
{
	Prog *p;
	int i;
	long dwn[LOG], cnt[LOG];
	Prog *lst[LOG];

	for(i=0; i&lt;LOG; i++) {
		if(i == 0)
			cnt[i] = 1; else
			cnt[i] = LOG * cnt[i-1];
		dwn[i] = 1;
		lst[i] = P;
	}
	i = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT)
			curtext = p;
		i--;
		if(i &lt; 0)
			i = LOG-1;
		p-&gt;forwd = P;
		dwn[i]--;
		if(dwn[i] &lt;= 0) {
			dwn[i] = cnt[i];
			if(lst[i] != P)
				lst[i]-&gt;forwd = p;
			lst[i] = p;
		}
	}
}

Prog*
brloop(Prog *p)
{
	int c;
	Prog *q;

	c = 0;
	for(q = p; q != P; q = q-&gt;pcond) {
		if(q-&gt;as != AJMP)
			break;
		c++;
		if(c &gt;= 5000)
			return P;
	}
	return q;
}

void
dostkoff(void)
{
	Prog *p, *q;
	long autoffset, deltasp;
	int a, f, curframe, curbecome, maxbecome, pcsize;

	curframe = 0;
	curbecome = 0;
	maxbecome = 0;
	curtext = 0;
	for(p = firstp; p != P; p = p-&gt;link) {

		/* find out how much arg space is used in this TEXT */
		if(p-&gt;to.type == (D_INDIR+D_SP))
			if(p-&gt;to.offset &gt; curframe)
				curframe = p-&gt;to.offset;

		switch(p-&gt;as) {
		case ATEXT:
			if(curtext &amp;&amp; curtext-&gt;from.sym) {
				curtext-&gt;from.sym-&gt;frame = curframe;
				curtext-&gt;from.sym-&gt;become = curbecome;
				if(curbecome &gt; maxbecome)
					maxbecome = curbecome;
			}
			curframe = 0;
			curbecome = 0;

			curtext = p;
			break;

		case ARET:
			/* special form of RET is BECOME */
			if(p-&gt;from.type == D_CONST)
				if(p-&gt;from.offset &gt; curbecome)
					curbecome = p-&gt;from.offset;
			break;
		}
	}
	if(curtext &amp;&amp; curtext-&gt;from.sym) {
		curtext-&gt;from.sym-&gt;frame = curframe;
		curtext-&gt;from.sym-&gt;become = curbecome;
		if(curbecome &gt; maxbecome)
			maxbecome = curbecome;
	}

	if(debug['b'])
		print("max become = %d\n", maxbecome);
	xdefine("ALEFbecome", STEXT, maxbecome);

	curtext = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		switch(p-&gt;as) {
		case ATEXT:
			curtext = p;
			break;
		case ACALL:
			if(curtext != P &amp;&amp; curtext-&gt;from.sym != S &amp;&amp; curtext-&gt;to.offset &gt;= 0) {
				f = maxbecome - curtext-&gt;from.sym-&gt;frame;
				if(f &lt;= 0)
					break;
				/* calling a become or calling a variable */
				if(p-&gt;to.sym == S || p-&gt;to.sym-&gt;become) {
					curtext-&gt;to.offset += f;
					if(debug['b']) {
						curp = p;
						print("%D calling %D increase %d\n",
							&amp;curtext-&gt;from, &amp;p-&gt;to, f);
					}
				}
			}
			break;
		}
	}

	autoffset = 0;
	deltasp = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			curtext = p;
			autoffset = p-&gt;to.offset;
			if(autoffset &lt; 0)
				autoffset = 0;
			if(autoffset) {
				p = appendp(p);
				p-&gt;as = AADJSP;
				p-&gt;from.type = D_CONST;
				p-&gt;from.offset = autoffset;
			}
			deltasp = autoffset;
		}
		pcsize = p-&gt;mode/8;
		a = p-&gt;from.type;
		if(a == D_AUTO)
			p-&gt;from.offset += deltasp;
		if(a == D_PARAM)
			p-&gt;from.offset += deltasp + pcsize;
		a = p-&gt;to.type;
		if(a == D_AUTO)
			p-&gt;to.offset += deltasp;
		if(a == D_PARAM)
			p-&gt;to.offset += deltasp + pcsize;

		switch(p-&gt;as) {
		default:
			continue;
		case APUSHL:
		case APUSHFL:
			deltasp += 4;
			continue;
		case APUSHQ:
		case APUSHFQ:
			deltasp += 8;
			continue;
		case APUSHW:
		case APUSHFW:
			deltasp += 2;
			continue;
		case APOPL:
		case APOPFL:
			deltasp -= 4;
			continue;
		case APOPQ:
		case APOPFQ:
			deltasp -= 8;
			continue;
		case APOPW:
		case APOPFW:
			deltasp -= 2;
			continue;
		case ARET:
			break;
		}

		if(autoffset != deltasp)
			diag("unbalanced PUSH/POP");
		if(p-&gt;from.type == D_CONST)
			goto become;

		if(autoffset) {
			q = p;
			p = appendp(p);
			p-&gt;as = ARET;

			q-&gt;as = AADJSP;
			q-&gt;from.type = D_CONST;
			q-&gt;from.offset = -autoffset;
		}
		continue;

	become:
		q = p;
		p = appendp(p);
		p-&gt;as = AJMP;
		p-&gt;to = q-&gt;to;
		p-&gt;pcond = q-&gt;pcond;

		q-&gt;as = AADJSP;
		q-&gt;from = zprg.from;
		q-&gt;from.type = D_CONST;
		q-&gt;from.offset = -autoffset;
		q-&gt;to = zprg.to;
		continue;
	}
}

vlong
atolwhex(char *s)
{
	vlong n;
	int f;

	n = 0;
	f = 0;
	while(*s == ' ' || *s == '\t')
		s++;
	if(*s == '-' || *s == '+') {
		if(*s++ == '-')
			f = 1;
		while(*s == ' ' || *s == '\t')
			s++;
	}
	if(s[0]=='0' &amp;&amp; s[1]){
		if(s[1]=='x' || s[1]=='X'){
			s += 2;
			for(;;){
				if(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
					n = n*16 + *s++ - '0';
				else if(*s &gt;= 'a' &amp;&amp; *s &lt;= 'f')
					n = n*16 + *s++ - 'a' + 10;
				else if(*s &gt;= 'A' &amp;&amp; *s &lt;= 'F')
					n = n*16 + *s++ - 'A' + 10;
				else
					break;
			}
		} else
			while(*s &gt;= '0' &amp;&amp; *s &lt;= '7')
				n = n*8 + *s++ - '0';
	} else
		while(*s &gt;= '0' &amp;&amp; *s &lt;= '9')
			n = n*10 + *s++ - '0';
	if(f)
		n = -n;
	return n;
}

void
undef(void)
{
	int i;
	Sym *s;

	for(i=0; i&lt;NHASH; i++)
	for(s = hash[i]; s != S; s = s-&gt;link)
		if(s-&gt;type == SXREF)
			diag("%s: not defined", s-&gt;name);
}

void
import(void)
{
	int i;
	Sym *s;

	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type == SXREF &amp;&amp; (nimports == 0 || s-&gt;subtype == SIMPORT)){
				if(s-&gt;value != 0)
					diag("value != 0 on SXREF");
				undefsym(s);
				Bprint(&amp;bso, "IMPORT: %s sig=%lux v=%lld\n", s-&gt;name, s-&gt;sig, s-&gt;value);
				if(debug['S'])
					s-&gt;sig = 0;
			}
}

void
ckoff(Sym *s, long v)
{
	if(v &lt; 0 || v &gt;= 1&lt;&lt;Roffset)
		diag("relocation offset %ld for %s out of range", v, s-&gt;name);
}

static Prog*
newdata(Sym *s, int o, int w, int t)
{
	Prog *p;

	p = prg();
	if(edatap == P)
		datap = p;
	else
		edatap-&gt;link = p;
	edatap = p;
	p-&gt;as = ADATA;
	p-&gt;width = w;
	p-&gt;from.scale = w;
	p-&gt;from.type = t;
	p-&gt;from.sym = s;
	p-&gt;from.offset = o;
	p-&gt;to.type = D_CONST;
	return p;
}

void
export(void)
{
	int i, j, n, off, nb, sv, ne;
	Sym *s, *et, *str, **esyms;
	Prog *p;
	char buf[NSNAME], *t;

	n = 0;
	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type != SXREF &amp;&amp; s-&gt;type != SUNDEF &amp;&amp; (nexports == 0 || s-&gt;subtype == SEXPORT))
				n++;
	esyms = malloc(n*sizeof(Sym*));
	ne = n;
	n = 0;
	for(i = 0; i &lt; NHASH; i++)
		for(s = hash[i]; s != S; s = s-&gt;link)
			if(s-&gt;sig != 0 &amp;&amp; s-&gt;type != SXREF &amp;&amp; s-&gt;type != SUNDEF &amp;&amp; (nexports == 0 || s-&gt;subtype == SEXPORT))
				esyms[n++] = s;
	for(i = 0; i &lt; ne-1; i++)
		for(j = i+1; j &lt; ne; j++)
			if(strcmp(esyms[i]-&gt;name, esyms[j]-&gt;name) &gt; 0){
				s = esyms[i];
				esyms[i] = esyms[j];
				esyms[j] = s;
			}

	nb = 0;
	off = 0;
	et = lookup(EXPTAB, 0);
	if(et-&gt;type != 0 &amp;&amp; et-&gt;type != SXREF)
		diag("%s already defined", EXPTAB);
	et-&gt;type = SDATA;
	str = lookup(".string", 0);
	if(str-&gt;type == 0)
		str-&gt;type = SDATA;
	sv = str-&gt;value;
	for(i = 0; i &lt; ne; i++){
		s = esyms[i];
		if(debug['S'])
			s-&gt;sig = 0;
		/* Bprint(&amp;bso, "EXPORT: %s sig=%lux t=%d\n", s-&gt;name, s-&gt;sig, s-&gt;type); */

		/* signature */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.offset = s-&gt;sig;

		/* address */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.type = D_ADDR;
		p-&gt;to.index = D_EXTERN;
		p-&gt;to.sym = s;

		/* string */
		t = s-&gt;name;
		n = strlen(t)+1;
		for(;;){
			buf[nb++] = *t;
			sv++;
			if(nb &gt;= NSNAME){
				p = newdata(str, sv-NSNAME, NSNAME, D_STATIC);
				p-&gt;to.type = D_SCONST;
				memmove(p-&gt;to.scon, buf, NSNAME);
				nb = 0;
			}
			if(*t++ == 0)
				break;
		}

		/* name */
		p = newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
		p-&gt;to.type = D_ADDR;
		p-&gt;to.index = D_STATIC;
		p-&gt;to.sym = str;
		p-&gt;to.offset = sv-n;
	}

	if(nb &gt; 0){
		p = newdata(str, sv-nb, nb, D_STATIC);
		p-&gt;to.type = D_SCONST;
		memmove(p-&gt;to.scon, buf, nb);
	}

	for(i = 0; i &lt; 3; i++){
		newdata(et, off, sizeof(long), D_EXTERN);
		off += sizeof(long);
	}
	et-&gt;value = off;
	if(sv == 0)
		sv = 1;
	str-&gt;value = sv;
	exports = ne;
	free(esyms);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

