<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/8c/sgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/8c/sgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "gc.h"

void
noretval(int n)
{

	if(n &amp; 1) {
		gins(ANOP, Z, Z);
		p-&gt;to.type = REGRET;
	}
	if(n &amp; 2) {
		gins(ANOP, Z, Z);
		p-&gt;to.type = FREGRET;
	}
	if((n&amp;3) == 3)
	if(thisfn &amp;&amp; thisfn-&gt;link &amp;&amp; typefd[thisfn-&gt;link-&gt;etype])
		gins(AFLDZ, Z, Z);
}

/* welcome to commute */
static void
commute(Node *n)
{
	Node *l, *r;

	l = n-&gt;left;
	r = n-&gt;right;
	if(r-&gt;complex &gt; l-&gt;complex) {
		n-&gt;left = r;
		n-&gt;right = l;
	}
}

void
indexshift(Node *n)
{
	int g;

	if(!typechlp[n-&gt;type-&gt;etype])
		return;
	simplifyshift(n);
	if(n-&gt;op == OASHL &amp;&amp; n-&gt;right-&gt;op == OCONST){
		g = vconst(n-&gt;right);
		if(g &gt;= 0 &amp;&amp; g &lt; 4)
			n-&gt;addable = 7;
	}
}

/*
 *	calculate addressability as follows
 *		NAME ==&gt; 10/11		name+value(SB/SP)
 *		REGISTER ==&gt; 12		register
 *		CONST ==&gt; 20		$value
 *		*(20) ==&gt; 21		value
 *		&amp;(10) ==&gt; 13		$name+value(SB)
 *		&amp;(11) ==&gt; 1		$name+value(SP)
 *		(13) + (20) ==&gt; 13	fold constants
 *		(1) + (20) ==&gt; 1	fold constants
 *		*(13) ==&gt; 10		back to name
 *		*(1) ==&gt; 11		back to name
 *
 *		(20) * (X) ==&gt; 7	multiplier in indexing
 *		(X,7) + (13,1) ==&gt; 8	adder in indexing (addresses)
 *		(8) ==&gt; &amp;9(OINDEX)	index, almost addressable
 *
 *	calculate complexity (number of registers)
 */
void
xcom(Node *n)
{
	Node *l, *r;
	int g;

	if(n == Z)
		return;
	l = n-&gt;left;
	r = n-&gt;right;
	n-&gt;complex = 0;
	n-&gt;addable = 0;
	switch(n-&gt;op) {
	case OCONST:
		n-&gt;addable = 20;
		break;

	case ONAME:
		n-&gt;addable = 10;
		if(n-&gt;class == CPARAM || n-&gt;class == CAUTO)
			n-&gt;addable = 11;
		break;

	case OEXREG:
		n-&gt;addable = 12;
		break;

	case OREGISTER:
		n-&gt;addable = 12;
		break;

	case OINDREG:
		n-&gt;addable = 12;
		break;

	case OADDR:
		xcom(l);
		if(l-&gt;addable == 10)
			n-&gt;addable = 13;
		else
		if(l-&gt;addable == 11)
			n-&gt;addable = 1;
		break;

	case OADD:
		xcom(l);
		xcom(r);
		if(n-&gt;type-&gt;etype != TIND)
			break;

		switch(r-&gt;addable) {
		case 20:
			switch(l-&gt;addable) {
			case 1:
			case 13:
			commadd:
				l-&gt;type = n-&gt;type;
				*n = *l;
				l = new(0, Z, Z);
				*l = *(n-&gt;left);
				l-&gt;xoffset += r-&gt;vconst;
				n-&gt;left = l;
				r = n-&gt;right;
				goto brk;
			}
			break;

		case 1:
		case 13:
		case 10:
		case 11:
			/* l is the base, r is the index */
			if(l-&gt;addable != 20)
				n-&gt;addable = 8;
			break;
		}
		switch(l-&gt;addable) {
		case 20:
			switch(r-&gt;addable) {
			case 13:
			case 1:
				r = n-&gt;left;
				l = n-&gt;right;
				n-&gt;left = l;
				n-&gt;right = r;
				goto commadd;
			}
			break;

		case 13:
		case 1:
		case 10:
		case 11:
			/* r is the base, l is the index */
			if(r-&gt;addable != 20)
				n-&gt;addable = 8;
			break;
		}
		if(n-&gt;addable == 8 &amp;&amp; !side(n)) {
			indx(n);
			l = new1(OINDEX, idx.basetree, idx.regtree);
			l-&gt;scale = idx.scale;
			l-&gt;addable = 9;
			l-&gt;complex = l-&gt;right-&gt;complex;
			l-&gt;type = l-&gt;left-&gt;type;
			n-&gt;op = OADDR;
			n-&gt;left = l;
			n-&gt;right = Z;
			n-&gt;addable = 8;
			break;
		}
		break;

	case OINDEX:
		xcom(l);
		xcom(r);
		n-&gt;addable = 9;
		break;

	case OIND:
		xcom(l);
		if(l-&gt;op == OADDR) {
			l = l-&gt;left;
			l-&gt;type = n-&gt;type;
			*n = *l;
			return;
		}
		switch(l-&gt;addable) {
		case 20:
			n-&gt;addable = 21;
			break;
		case 1:
			n-&gt;addable = 11;
			break;
		case 13:
			n-&gt;addable = 10;
			break;
		}
		break;

	case OASHL:
		xcom(l);
		xcom(r);
		indexshift(n);
		break;

	case OMUL:
	case OLMUL:
		xcom(l);
		xcom(r);
		g = vlog(l);
		if(g &gt;= 0) {
			n-&gt;left = r;
			n-&gt;right = l;
			l = r;
			r = n-&gt;right;
		}
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OASHL;
			r-&gt;vconst = g;
			r-&gt;type = types[TINT];
			indexshift(n);
			break;
		}
commute(n);
		break;

	case OASLDIV:
		xcom(l);
		xcom(r);
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OASLSHR;
			r-&gt;vconst = g;
			r-&gt;type = types[TINT];
		}
		break;

	case OLDIV:
		xcom(l);
		xcom(r);
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OLSHR;
			r-&gt;vconst = g;
			r-&gt;type = types[TINT];
			indexshift(n);
			break;
		}
		break;

	case OASLMOD:
		xcom(l);
		xcom(r);
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OASAND;
			r-&gt;vconst--;
		}
		break;

	case OLMOD:
		xcom(l);
		xcom(r);
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OAND;
			r-&gt;vconst--;
		}
		break;

	case OASMUL:
	case OASLMUL:
		xcom(l);
		xcom(r);
		g = vlog(r);
		if(g &gt;= 0) {
			n-&gt;op = OASASHL;
			r-&gt;vconst = g;
		}
		break;

	case OLSHR:
	case OASHR:
		xcom(l);
		xcom(r);
		indexshift(n);
		break;

	default:
		if(l != Z)
			xcom(l);
		if(r != Z)
			xcom(r);
		break;
	}
brk:
	if(n-&gt;addable &gt;= 10)
		return;
	if(l != Z)
		n-&gt;complex = l-&gt;complex;
	if(r != Z) {
		if(r-&gt;complex == n-&gt;complex)
			n-&gt;complex = r-&gt;complex+1;
		else
		if(r-&gt;complex &gt; n-&gt;complex)
			n-&gt;complex = r-&gt;complex;
	}
	if(n-&gt;complex == 0)
		n-&gt;complex++;

	if(com64(n))
		return;

	switch(n-&gt;op) {

	case OFUNC:
		n-&gt;complex = FNX;
		break;

	case OLMOD:
	case OMOD:
	case OLMUL:
	case OLDIV:
	case OMUL:
	case ODIV:
	case OASLMUL:
	case OASLDIV:
	case OASLMOD:
	case OASMUL:
	case OASDIV:
	case OASMOD:
		if(r-&gt;complex &gt;= l-&gt;complex) {
			n-&gt;complex = l-&gt;complex + 3;
			if(r-&gt;complex &gt; n-&gt;complex)
				n-&gt;complex = r-&gt;complex;
		} else {
			n-&gt;complex = r-&gt;complex + 3;
			if(l-&gt;complex &gt; n-&gt;complex)
				n-&gt;complex = l-&gt;complex;
		}
		break;

	case OLSHR:
	case OASHL:
	case OASHR:
	case OASLSHR:
	case OASASHL:
	case OASASHR:
		if(r-&gt;complex &gt;= l-&gt;complex) {
			n-&gt;complex = l-&gt;complex + 2;
			if(r-&gt;complex &gt; n-&gt;complex)
				n-&gt;complex = r-&gt;complex;
		} else {
			n-&gt;complex = r-&gt;complex + 2;
			if(l-&gt;complex &gt; n-&gt;complex)
				n-&gt;complex = l-&gt;complex;
		}
		break;

	case OADD:
	case OXOR:
	case OAND:
	case OOR:
		/*
		 * immediate operators, make const on right
		 */
		if(l-&gt;op == OCONST) {
			n-&gt;left = r;
			n-&gt;right = l;
		}
		break;

	case OEQ:
	case ONE:
	case OLE:
	case OLT:
	case OGE:
	case OGT:
	case OHI:
	case OHS:
	case OLO:
	case OLS:
		/*
		 * compare operators, make const on left
		 */
		if(r-&gt;op == OCONST) {
			n-&gt;left = r;
			n-&gt;right = l;
			n-&gt;op = invrel[relindex(n-&gt;op)];
		}
		break;
	}
}

void
indx(Node *n)
{
	Node *l, *r;

	if(debug['x'])
		prtree(n, "indx");

	l = n-&gt;left;
	r = n-&gt;right;
	if(l-&gt;addable == 1 || l-&gt;addable == 13 || r-&gt;complex &gt; l-&gt;complex) {
		n-&gt;right = l;
		n-&gt;left = r;
		l = r;
		r = n-&gt;right;
	}
	if(l-&gt;addable != 7) {
		idx.regtree = l;
		idx.scale = 1;
	} else
	if(l-&gt;right-&gt;addable == 20) {
		idx.regtree = l-&gt;left;
		idx.scale = 1 &lt;&lt; l-&gt;right-&gt;vconst;
	} else
	if(l-&gt;left-&gt;addable == 20) {
		idx.regtree = l-&gt;right;
		idx.scale = 1 &lt;&lt; l-&gt;left-&gt;vconst;
	} else
		diag(n, "bad index");

	idx.basetree = r;
	if(debug['x']) {
		print("scale = %d\n", idx.scale);
		prtree(idx.regtree, "index");
		prtree(idx.basetree, "base");
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

