<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/8l/elf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/8l/elf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * emit 32- or 64-bit elf headers for any architecture.
 * this is a component of ?l.
 */
#include "l.h"

enum {
	/* offsets into string table */
	Stitext		= 1,
	Stidata		= 7,
	Stistrtab	= 13,
};

void
elfident(int bo, int class)
{
	strnput("\177ELF", 4);		/* e_ident */
	cput(class);
	cput(bo);			/* byte order */
	cput(1);			/* version = CURRENT */
	if(debug['k']){			/* boot/embedded/standalone */
		cput(255);
		cput(0);
	}
	else{
		cput(0);		/* osabi = SYSV */
		cput(0);		/* abiversion = 3 */
	}
	strnput("", 7);
}

void
elfstrtab(void)
{
	/* string table */
	cput(0);
	strnput(".text", 5);		/* +1 */
	cput(0);
	strnput(".data", 5);		/* +7 */
	cput(0);
	strnput(".strtab", 7);		/* +13 */
	cput(0);
	cput(0);
}

void
elf32phdr(void (*putl)(long), ulong type, ulong off, ulong vaddr, ulong paddr,
	ulong filesz, ulong memsz, ulong prots, ulong align)
{
	putl(type);
	putl(off);
	putl(vaddr);
	putl(paddr);
	putl(filesz);
	putl(memsz);
	putl(prots);
	putl(align);
}

void
elf32shdr(void (*putl)(long), ulong name, ulong type, ulong flags, ulong vaddr,
	ulong off, ulong sectsz, ulong link, ulong addnl, ulong align,
	ulong entsz)
{
	putl(name);
	putl(type);
	putl(flags);
	putl(vaddr);
	putl(off);
	putl(sectsz);
	putl(link);
	putl(addnl);
	putl(align);
	putl(entsz);
}

static void
elf32sectab(void (*putl)(long))
{
	seek(cout, HEADR+textsize+datsize+symsize, 0);
	elf32shdr(putl, Stitext, Progbits, Salloc|Sexec, INITTEXT,
		HEADR, textsize, 0, 0, 0x10000, 0);
	elf32shdr(putl, Stidata, Progbits, Salloc|Swrite, INITDAT,
		HEADR+textsize, datsize, 0, 0, 0x10000, 0);
	elf32shdr(putl, Stistrtab, Strtab, 1 &lt;&lt; 5, 0,
		HEADR+textsize+datsize+symsize+3*Shdr32sz, 14, 0, 0, 1, 0);
	elfstrtab();
}

/* if addpsects &gt; 0, putpsects must emit exactly that many psects. */
void
elf32(int mach, int bo, int addpsects, void (*putpsects)(Putl))
{
	ulong phydata;
	void (*putw)(long), (*putl)(long);

	if(bo == ELFDATA2MSB){
		putw = wput;
		putl = lput;
	}else if(bo == ELFDATA2LSB){
		putw = wputl;
		putl = lputl;
	}else{
		print("elf32 byte order is mixed-endian\n");
		errorexit();
		return;
	}

	elfident(bo, ELFCLASS32);
	putw(EXEC);
	putw(mach);
	putl(1L);			/* version = CURRENT */
	putl(entryvalue());		/* entry vaddr */
	putl(Ehdr32sz);			/* offset to first phdr */
	if(debug['S'])
		putl(HEADR+textsize+datsize+symsize); /* offset to first shdr */
	else
		putl(0);
	putl(0L);			/* flags */
	putw(Ehdr32sz);
	putw(Phdr32sz);
	putw(3 + addpsects);		/* # of Phdrs */
	putw(Shdr32sz);
	if(debug['S']){
		putw(3);		/* # of Shdrs */
		putw(2);		/* Shdr table index */
	}else{
		putw(0);
		putw(0);
	}

	/*
	 * could include ELF headers in text -- 8l doesn't,
	 * but in theory it aids demand loading.
	 */
	elf32phdr(putl, PT_LOAD, HEADR, INITTEXT, INITTEXTP,
		textsize, textsize, R|X, INITRND);	/* text */
	/*
	 * we need INITDATP, but it has to be computed.
	 * assume distance between INITTEXT &amp; INITTEXTP is also
	 * correct for INITDAT and INITDATP.
	 */
	phydata = INITDAT - (INITTEXT - INITTEXTP);
	elf32phdr(putl, PT_LOAD, HEADR+textsize, INITDAT, phydata,
		datsize, datsize+bsssize, R|W|X, INITRND); /* data */
	elf32phdr(putl, NOPTYPE, HEADR+textsize+datsize, 0, 0,
		symsize, lcsize, R, 4);			/* symbol table */
	if (addpsects &gt; 0)
		putpsects(putl);
	cflush();

	if(debug['S'])
		elf32sectab(putl);
}

/*
 * elf64
 */

void
elf64phdr(void (*putl)(long), void (*putll)(vlong), ulong type, uvlong off,
	uvlong vaddr, uvlong paddr, uvlong filesz, uvlong memsz, ulong prots,
	uvlong align)
{
	putl(type);		
	putl(prots);		
	putll(off);		
	putll(vaddr);	
	putll(paddr);	
	putll(filesz);	
	putll(memsz);	
	putll(align);		
}

void
elf64shdr(void (*putl)(long), void (*putll)(vlong), ulong name, ulong type,
	uvlong flags, uvlong vaddr, uvlong off, uvlong sectsz, ulong link,
	ulong addnl, uvlong align, uvlong entsz)
{
	putl(name);
	putl(type);
	putll(flags);
	putll(vaddr);
	putll(off);
	putll(sectsz);
	putl(link);
	putl(addnl);
	putll(align);
	putll(entsz);
}

static void
elf64sectab(void (*putl)(long), void (*putll)(vlong))
{
	seek(cout, HEADR+textsize+datsize+symsize, 0);
	elf64shdr(putl, putll, Stitext, Progbits, Salloc|Sexec, INITTEXT,
		HEADR, textsize, 0, 0, 0x10000, 0);
	elf64shdr(putl, putll, Stidata, Progbits, Salloc|Swrite, INITDAT,
		HEADR+textsize, datsize, 0, 0, 0x10000, 0);
	elf64shdr(putl, putll, Stistrtab, Strtab, 1 &lt;&lt; 5, 0,
		HEADR+textsize+datsize+symsize+3*Shdr64sz, 14, 0, 0, 1, 0);
	elfstrtab();
}

/* if addpsects &gt; 0, putpsects must emit exactly that many psects. */
void
elf64(int mach, int bo, int addpsects, void (*putpsects)(Putl))
{
	uvlong phydata;
	void (*putw)(long), (*putl)(long);
	void (*putll)(vlong);

	if(bo == ELFDATA2MSB){
		putw = wput;
		putl = lput;
		putll = llput;
	}else if(bo == ELFDATA2LSB){
		putw = wputl;
		putl = lputl;
		putll = llputl;
	}else{
		print("elf64 byte order is mixed-endian\n");
		errorexit();
		return;
	}

	elfident(bo, ELFCLASS64);
	putw(EXEC);
	putw(mach);
	putl(1L);			/* version = CURRENT */
	putll(entryvalue());		/* entry vaddr */
	putll(Ehdr64sz);		/* offset to first phdr */
	if(debug['S'])
		putll(HEADR+textsize+datsize+symsize); /* offset to 1st shdr */
	else
		putll(0);
	putl(0L);			/* flags */
	putw(Ehdr64sz);
	putw(Phdr64sz);
	putw(3 + addpsects);		/* # of Phdrs */
	putw(Shdr64sz);
	if(debug['S']){
		putw(3);		/* # of Shdrs */
		putw(2);		/* Shdr table index */
	}else{
		putw(0);
		putw(0);
	}

	elf64phdr(putl, putll, PT_LOAD, HEADR, INITTEXT, INITTEXTP,
		textsize, textsize, R|X, INITRND);	/* text */
	/*
	 * see 32-bit ELF case for physical data address computation.
	 */
	phydata = INITDAT - (INITTEXT - INITTEXTP);
	elf64phdr(putl, putll, PT_LOAD, HEADR+textsize, INITDAT, phydata,
		datsize, datsize+bsssize, R|W, INITRND); /* data */
	elf64phdr(putl, putll, NOPTYPE, HEADR+textsize+datsize, 0, 0,
		symsize, lcsize, R, 4);			/* symbol table */
	if (addpsects &gt; 0)
		putpsects(putl);
	cflush();

	if(debug['S'])
		elf64sectab(putl, putll);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

