<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9660srv/9660srv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9660srv/9660srv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "dat.h"
#include "fns.h"
#include "iso9660.h"

static void	ireset(void);
static int	iattach(Xfile*);
static void	iclone(Xfile*, Xfile*);
static void	iwalkup(Xfile*);
static void	iwalk(Xfile*, char*);
static void	iopen(Xfile*, int);
static void	icreate(Xfile*, char*, long, int);
static long	ireaddir(Xfile*, uchar*, long, long);
static long	iread(Xfile*, char*, vlong, long);
static long	iwrite(Xfile*, char*, vlong, long);
static void	iclunk(Xfile*);
static void	iremove(Xfile*);
static void	istat(Xfile*, Dir*);
static void	iwstat(Xfile*, Dir*);

static char*	nstr(uchar*, int);
static char*	rdate(uchar*, int);
static int	getcontin(Xdata*, uchar*, uchar**);
static int	getdrec(Xfile*, void*);
static void	ungetdrec(Xfile*);
static int	opendotdot(Xfile*, Xfile*);
static int	showdrec(int, int, void*);
static long	gtime(uchar*);
static long	l16(void*);
static long	l32(void*);
static vlong	l64(void *);
static void	newdrec(Xfile*, Drec*);
static int	rzdir(Xfs*, Dir*, int, Drec*);

Xfsub	isosub =
{
	ireset, iattach, iclone, iwalkup, iwalk, iopen, icreate,
	ireaddir, iread, iwrite, iclunk, iremove, istat, iwstat
};

static vlong
fakemax(vlong len)
{
	if(len == (1UL &lt;&lt; 31) - 1)	/* max. 9660 size? */
		len = (1ULL &lt;&lt; 63) - 1;	/* pretend it's vast */
	return len;
}

static void
ireset(void)
{}

static int
iattach(Xfile *root)
{
	Xfs *cd = root-&gt;xf;
	Iobuf *p; Voldesc *v; Isofile *fp; Drec *dp;
	int fmt, blksize, i, n, l, haveplan9;
	Iobuf *dirp;
	uchar dbuf[256];
	Drec *rd = (Drec *)dbuf;
	uchar *q, *s;

	dirp = nil;
	blksize = 0;
	fmt = 0;
	dp = nil;
	haveplan9 = 0;
	for(i=VOLDESC;i&lt;VOLDESC+100; i++){	/* +100 for sanity */
		p = getbuf(cd-&gt;d, i);
		v = (Voldesc*)(p-&gt;iobuf);
		if(memcmp(v-&gt;byte, "\01CD001\01", 7) == 0){		/* iso */
			if(dirp)
				putbuf(dirp);
			dirp = p;
			fmt = 'z';
			dp = (Drec*)v-&gt;z.desc.rootdir;
			blksize = l16(v-&gt;z.desc.blksize);
			chat("iso, blksize=%d...", blksize);

			v = (Voldesc*)(dirp-&gt;iobuf);
			haveplan9 = (strncmp((char*)v-&gt;z.boot.sysid, "PLAN 9", 6)==0);
			if(haveplan9){
				if(noplan9) {
					chat("ignoring plan9");
					haveplan9 = 0;
				} else {
					fmt = '9';
					chat("plan9 iso...");
				}
			}
			continue;
		}

		if(memcmp(&amp;v-&gt;byte[8], "\01CDROM\01", 7) == 0){	/* high sierra */
			if(dirp)
				putbuf(dirp);
			dirp = p;
			fmt = 'r';
			dp = (Drec*)v-&gt;r.desc.rootdir;
			blksize = l16(v-&gt;r.desc.blksize);
			chat("high sierra, blksize=%d...", blksize);
			continue;
		}

		if(haveplan9==0 &amp;&amp; !nojoliet
		&amp;&amp; memcmp(v-&gt;byte, "\02CD001\01", 7) == 0){
chat("%d %d\n", haveplan9, nojoliet);
			/*
			 * The right thing to do is walk the escape sequences looking
			 * for one of 25 2F 4[035], but Microsoft seems to not honor
			 * the format, which makes it hard to walk over.
			 */
			q = v-&gt;z.desc.escapes;
			if(q[0] == 0x25 &amp;&amp; q[1] == 0x2F &amp;&amp; (q[2] == 0x40 || q[2] == 0x43 || q[2] == 0x45)){	/* Joliet, it appears */
				if(dirp)
					putbuf(dirp);
				dirp = p;
				fmt = 'J';
				dp = (Drec*)v-&gt;z.desc.rootdir;
				if(blksize != l16(v-&gt;z.desc.blksize))
					fprint(2, "warning: suspicious Joliet blocksize\n");
				chat("joliet...");
				continue;
			}
		}
		putbuf(p);
		if(v-&gt;byte[0] == 0xFF)
			break;
	}

	if(fmt == 0){
		if(dirp)
			putbuf(dirp);
		return -1;
	}
	assert(dirp != nil);

	if(chatty)
		showdrec(2, fmt, dp);
	if(blksize &gt; Sectorsize){
		chat("blksize too big...");
		putbuf(dirp);
		return -1;
	}
	if(waserror()){
		putbuf(dirp);
		nexterror();
	}
	root-&gt;len = sizeof(Isofile) - sizeof(Drec) + dp-&gt;reclen;
	root-&gt;ptr = fp = ealloc(root-&gt;len);

	if(haveplan9)
		root-&gt;xf-&gt;isplan9 = 1;

	fp-&gt;fmt = fmt;
	fp-&gt;blksize = blksize;
	fp-&gt;offset = 0;
	fp-&gt;doffset = 0;
	memmove(&amp;fp-&gt;d, dp, dp-&gt;reclen);
	root-&gt;qid.path = l32(dp-&gt;addr);
	root-&gt;qid.type = QTDIR;
	putbuf(dirp);
	poperror();
	if(getdrec(root, rd) &gt;= 0){
		n = rd-&gt;reclen-(34+rd-&gt;namelen);
		s = (uchar*)rd-&gt;name + rd-&gt;namelen;
		if((uintptr)s &amp; 1){
			s++;
			n--;
		}
		if(n &gt;= 7 &amp;&amp; s[0] == 'S' &amp;&amp; s[1] == 'P' &amp;&amp; s[2] == 7 &amp;&amp;
		   s[3] == 1 &amp;&amp; s[4] == 0xBE &amp;&amp; s[5] == 0xEF){
			root-&gt;xf-&gt;issusp = 1;
			root-&gt;xf-&gt;suspoff = s[6];
			n -= root-&gt;xf-&gt;suspoff;
			s += root-&gt;xf-&gt;suspoff;
			for(; n &gt;= 4; s += l, n -= l){
				l = s[2];
				if(s[0] == 'E' &amp;&amp; s[1] == 'R'){
					if(!norock &amp;&amp; s[4] == 10 &amp;&amp; memcmp(s+8, "RRIP_1991A", 10) == 0)
						root-&gt;xf-&gt;isrock = 1;
					break;
				} else if(s[0] == 'C' &amp;&amp; s[1] == 'E' &amp;&amp; s[2] &gt;= 28){
					n = getcontin(root-&gt;xf-&gt;d, s, &amp;s);
					continue;
				} else if(s[0] == 'R' &amp;&amp; s[1] == 'R'){
					if(!norock)
						root-&gt;xf-&gt;isrock = 1;
					break;
				} else if(s[0] == 'S' &amp;&amp; s[1] == 'T')
					break;
			}
		}
	}
	if(root-&gt;xf-&gt;isrock)
		chat("Rock Ridge...");
	fp-&gt;offset = 0;
	fp-&gt;doffset = 0;
	return 0;
}

static void
iclone(Xfile *of, Xfile *nf)
{
	USED(of, nf);
}

static void
iwalkup(Xfile *f)
{
	vlong paddr;
	uchar dbuf[256];
	Drec *d = (Drec *)dbuf;
	Xfile pf, ppf;
	Isofile piso, ppiso;

	memset(&amp;pf, 0, sizeof pf);
	memset(&amp;ppf, 0, sizeof ppf);
	pf.ptr = &amp;piso;
	ppf.ptr = &amp;ppiso;
	if(opendotdot(f, &amp;pf) &lt; 0)
		error("can't open pf");
	paddr = l32(pf.ptr-&gt;d.addr);
	if(l32(f-&gt;ptr-&gt;d.addr) == paddr)
		return;
	if(opendotdot(&amp;pf, &amp;ppf) &lt; 0)
		error("can't open ppf");
	while(getdrec(&amp;ppf, d) &gt;= 0){
		if(l32(d-&gt;addr) == paddr){
			newdrec(f, d);
			f-&gt;qid.path = paddr;
			f-&gt;qid.type = QTDIR;
			return;
		}
	}
	error("can't find addr of ..");
}

static int
casestrcmp(int isplan9, char *a, char *b)
{
	if(isplan9)
		return strcmp(a, b);
	return cistrcmp(a, b);
}

static void
iwalk(Xfile *f, char *name)
{
	Isofile *ip = f-&gt;ptr;
	uchar dbuf[256];
	char nbuf[4*Maxname];
	Drec *d = (Drec*)dbuf;
	Dir dir;
	char *p;
	int len, vers, dvers;

	vers = -1;
	if(p = strchr(name, ';')) {	/* assign = */
		len = p-name;
		if(len &gt;= Maxname)
			len = Maxname-1;
		memmove(nbuf, name, len);
		vers = strtoul(p+1, 0, 10);
		name = nbuf;
	}
/*
	len = strlen(name);
	if(len &gt;= Maxname){
		len = Maxname-1;
		if(name != nbuf){
			memmove(nbuf, name, len);
			name = nbuf;
		}
		name[len] = 0;
	}
*/

	chat("%d \"%s\"...", strlen(name), name);
	ip-&gt;offset = 0;
	setnames(&amp;dir, nbuf);
	while(getdrec(f, d) &gt;= 0) {
		dvers = rzdir(f-&gt;xf, &amp;dir, ip-&gt;fmt, d);
		if(casestrcmp(f-&gt;xf-&gt;isplan9||f-&gt;xf-&gt;isrock, name, dir.name) != 0)
			continue;
		newdrec(f, d);
		f-&gt;qid.path = dir.qid.path;
		f-&gt;qid.type = dir.qid.type;
		USED(dvers);
		return;
	}
	USED(vers);
	error(Enonexist);
}

static void
iopen(Xfile *f, int mode)
{
	mode &amp;= ~OCEXEC;
	if(mode != OREAD &amp;&amp; mode != OEXEC)
		error(Eperm);
	f-&gt;ptr-&gt;offset = 0;
	f-&gt;ptr-&gt;doffset = 0;
}

static void
icreate(Xfile *f, char *name, long perm, int mode)
{
	USED(f, name, perm, mode);
	error(Eperm);
}

static long
ireaddir(Xfile *f, uchar *buf, long offset, long count)
{
	Isofile *ip = f-&gt;ptr;
	Dir d;
	char names[4*Maxname];
	uchar dbuf[256];
	Drec *drec = (Drec *)dbuf;
	int n, rcnt;

	if(offset==0){
		ip-&gt;offset = 0;
		ip-&gt;doffset = 0;
	}else if(offset != ip-&gt;doffset)
		error("seek in directory not allowed");

	rcnt = 0;
	setnames(&amp;d, names);
	while(rcnt &lt; count &amp;&amp; getdrec(f, drec) &gt;= 0){
		if(drec-&gt;namelen == 1){
			if(drec-&gt;name[0] == 0)
				continue;
			if(drec-&gt;name[0] == 1)
				continue;
		}
		rzdir(f-&gt;xf, &amp;d, ip-&gt;fmt, drec);
		d.qid.vers = f-&gt;qid.vers;
		if((n = convD2M(&amp;d, buf+rcnt, count-rcnt)) &lt;= BIT16SZ){
			ungetdrec(f);
			break;
		}
		rcnt += n;
	}
	ip-&gt;doffset += rcnt;
	return rcnt;
}

static long
iread(Xfile *f, char *buf, vlong offset, long count)
{
	int n, o, rcnt = 0;
	vlong size, addr;
	Isofile *ip = f-&gt;ptr;
	Iobuf *p;

	size = fakemax(l32(ip-&gt;d.size));
	if(offset &gt;= size)
		return 0;
	if(offset+count &gt; size)
		count = size - offset;
	addr = ((vlong)l32(ip-&gt;d.addr) + ip-&gt;d.attrlen)*ip-&gt;blksize + offset;
	o = addr % Sectorsize;
	addr /= Sectorsize;
	/*chat("d.addr=%ld, addr=%lld, o=%d...", l32(ip-&gt;d.addr), addr, o);*/
	n = Sectorsize - o;

	while(count &gt; 0){
		if(n &gt; count)
			n = count;
		p = getbuf(f-&gt;xf-&gt;d, addr);
		memmove(&amp;buf[rcnt], &amp;p-&gt;iobuf[o], n);
		putbuf(p);
		count -= n;
		rcnt += n;
		++addr;
		o = 0;
		n = Sectorsize;
	}
	return rcnt;
}

static long
iwrite(Xfile *f, char *buf, vlong offset, long count)
{
	USED(f, buf, offset, count);
	error(Eperm);
	return 0;
}

static void
iclunk(Xfile *f)
{
	USED(f);
}

static void
iremove(Xfile *f)
{
	USED(f);
	error(Eperm);
}

static void
istat(Xfile *f, Dir *d)
{
	Isofile *ip = f-&gt;ptr;

	rzdir(f-&gt;xf, d, ip-&gt;fmt, &amp;ip-&gt;d);
	d-&gt;qid.vers = f-&gt;qid.vers;
	if(d-&gt;qid.path==f-&gt;xf-&gt;rootqid.path){
		d-&gt;qid.path = 0;
		d-&gt;qid.type = QTDIR;
	}
}

static void
iwstat(Xfile *f, Dir *d)
{
	USED(f, d);
	error(Eperm);
}

static int
showdrec(int fd, int fmt, void *x)
{
	Drec *d = (Drec *)x;
	int namelen;
	int syslen;

	if(d-&gt;reclen == 0)
		return 0;
	fprint(fd, "%d %d %ld %ld ",
		d-&gt;reclen, d-&gt;attrlen, l32(d-&gt;addr), l32(d-&gt;size));
	fprint(fd, "%s 0x%2.2x %d %d %ld ",
		rdate(d-&gt;date, fmt), (fmt=='z' ? d-&gt;flags : d-&gt;r_flags),
		d-&gt;unitsize, d-&gt;gapsize, l16(d-&gt;vseqno));
	fprint(fd, "%d %s", d-&gt;namelen, nstr(d-&gt;name, d-&gt;namelen));
	if(fmt != 'J'){
		namelen = d-&gt;namelen + (1-(d-&gt;namelen&amp;1));
		syslen = d-&gt;reclen - 33 - namelen;
		if(syslen != 0)
			fprint(fd, " %s", nstr(&amp;d-&gt;name[namelen], syslen));
	}
	fprint(fd, "\n");
	return d-&gt;reclen + (d-&gt;reclen&amp;1);
}

static void
newdrec(Xfile *f, Drec *dp)
{
	Isofile *x = f-&gt;ptr;
	Isofile *n;
	int len;

	len = sizeof(Isofile) - sizeof(Drec) + dp-&gt;reclen;
	n = ealloc(len);
	n-&gt;fmt = x-&gt;fmt;
	n-&gt;blksize = x-&gt;blksize;
	n-&gt;offset = 0;
	n-&gt;doffset = 0;
	memmove(&amp;n-&gt;d, dp, dp-&gt;reclen);
	free(x);
	f-&gt;ptr = n;
	f-&gt;len = len;
}

static void
ungetdrec(Xfile *f)
{
	Isofile *ip = f-&gt;ptr;

	if(ip-&gt;offset &gt;= ip-&gt;odelta){
		ip-&gt;offset -= ip-&gt;odelta;
		ip-&gt;odelta = 0;
	}
}

static int
getdrec(Xfile *f, void *buf)
{
	Isofile *ip = f-&gt;ptr;
	int len = 0, boff = 0;
	vlong addr;
	uvlong size;
	Iobuf *p = 0;

	if(!ip)
		return -1;
	size = fakemax(l32(ip-&gt;d.size));
	while(ip-&gt;offset &lt; size){
		addr = ((vlong)l32(ip-&gt;d.addr)+ip-&gt;d.attrlen)*ip-&gt;blksize + ip-&gt;offset;
		boff = addr % Sectorsize;
		if(boff &gt; Sectorsize-34){
			ip-&gt;offset += Sectorsize-boff;
			continue;
		}
		p = getbuf(f-&gt;xf-&gt;d, addr/Sectorsize);
		len = p-&gt;iobuf[boff];
		if(len &gt;= 34)
			break;
		putbuf(p);
		p = 0;
		ip-&gt;offset += Sectorsize-boff;
	}
	if(p) {
		memmove(buf, &amp;p-&gt;iobuf[boff], len);
		putbuf(p);
		ip-&gt;odelta = len + (len&amp;1);
		ip-&gt;offset += ip-&gt;odelta;
		return 0;
	}
	return -1;
}

static int
opendotdot(Xfile *f, Xfile *pf)
{
	uchar dbuf[256];
	Drec *d = (Drec *)dbuf;
	Isofile *ip = f-&gt;ptr, *pip = pf-&gt;ptr;

	ip-&gt;offset = 0;
	if(getdrec(f, d) &lt; 0){
		chat("opendotdot: getdrec(.) failed...");
		return -1;
	}
	if(d-&gt;namelen != 1 || d-&gt;name[0] != 0){
		chat("opendotdot: no . entry...");
		return -1;
	}
	if(l32(d-&gt;addr) != l32(ip-&gt;d.addr)){
		chat("opendotdot: bad . address...");
		return -1;
	}
	if(getdrec(f, d) &lt; 0){
		chat("opendotdot: getdrec(..) failed...");
		return -1;
	}
	if(d-&gt;namelen != 1 || d-&gt;name[0] != 1){
		chat("opendotdot: no .. entry...");
		return -1;
	}

	pf-&gt;xf = f-&gt;xf;
	pip-&gt;fmt = ip-&gt;fmt;
	pip-&gt;blksize = ip-&gt;blksize;
	pip-&gt;offset = 0;
	pip-&gt;doffset = 0;
	pip-&gt;d = *d;
	return 0;
}

enum {
	Hname = 1,
	Hmode = 2,
};

static int
rzdir(Xfs *fs, Dir *d, int fmt, Drec *dp)
{
	int n, flags, i, j, lj, nl, vers, sysl, mode, l, have;
	uchar *s;
	char *p;
	char buf[Maxname+UTFmax+1];
	uchar *q;
	Rune r;
	enum { ONAMELEN = 28 };	/* old Plan 9 directory name length */

	have = 0;
	flags = 0;
	vers = -1;
	d-&gt;qid.path = l32(dp-&gt;addr);
	d-&gt;qid.type = 0;
	d-&gt;qid.vers = 0;
	n = dp-&gt;namelen;
	memset(d-&gt;name, 0, Maxname);
	if(n == 1) {
		switch(dp-&gt;name[0]){
		case 1:
			d-&gt;name[1] = '.';
			/* fall through */
		case 0:
			d-&gt;name[0] = '.';
			have = Hname;
			break;
		default:
			d-&gt;name[0] = tolower(dp-&gt;name[0]);
		}
	} else {
		if(fmt == 'J'){	/* Joliet, 16-bit Unicode */
			q = (uchar*)dp-&gt;name;
			for(i=j=lj=0; i&lt;n &amp;&amp; j&lt;Maxname; i+=2){
				lj = j;
				r = (q[i]&lt;&lt;8)|q[i+1];
				j += runetochar(buf+j, &amp;r);
			}
			if(j &gt;= Maxname)
				j = lj;
			memmove(d-&gt;name, buf, j);
		}else{
			if(n &gt;= Maxname)
				n = Maxname-1;
			for(i=0; i&lt;n; i++)
				d-&gt;name[i] = tolower(dp-&gt;name[i]);
		}
	}

	sysl = dp-&gt;reclen-(34+dp-&gt;namelen);
	s = (uchar*)dp-&gt;name + dp-&gt;namelen;
	if(((uintptr)s) &amp; 1) {
		s++;
		sysl--;
	}
	if(fs-&gt;isplan9 &amp;&amp; sysl &gt; 0) {
		/*
		 * get gid, uid, mode and possibly name
		 * from plan9 directory extension
		 */
		nl = *s;
		if(nl &gt;= ONAMELEN)
			nl = ONAMELEN-1;
		if(nl) {
			memset(d-&gt;name, 0, ONAMELEN);
			memmove(d-&gt;name, s+1, nl);
		}
		s += 1 + *s;
		nl = *s;
		if(nl &gt;= ONAMELEN)
			nl = ONAMELEN-1;
		memset(d-&gt;uid, 0, ONAMELEN);
		memmove(d-&gt;uid, s+1, nl);
		s += 1 + *s;
		nl = *s;
		if(nl &gt;= ONAMELEN)
			nl = ONAMELEN-1;
		memset(d-&gt;gid, 0, ONAMELEN);
		memmove(d-&gt;gid, s+1, nl);
		s += 1 + *s;
		if(((uintptr)s) &amp; 1)
			s++;
		d-&gt;mode = l32(s);
		if(d-&gt;mode &amp; DMDIR)
			d-&gt;qid.type |= QTDIR;
	} else {
		d-&gt;mode = 0444;
		switch(fmt) {
		case 'z':
			if(fs-&gt;isrock)
				strcpy(d-&gt;gid, "ridge");
			else
				strcpy(d-&gt;gid, "iso9660");
			flags = dp-&gt;flags;
			break;
		case 'r':
			strcpy(d-&gt;gid, "sierra");
			flags = dp-&gt;r_flags;
			break;
		case 'J':
			strcpy(d-&gt;gid, "joliet");
			flags = dp-&gt;flags;
			break;
		case '9':
			strcpy(d-&gt;gid, "plan9");
			flags = dp-&gt;flags;
			break;
		}
		if(flags &amp; 0x02){
			d-&gt;qid.type |= QTDIR;
			d-&gt;mode |= DMDIR|0111;
		}
		strcpy(d-&gt;uid, "cdrom");
		if(fmt!='9' &amp;&amp; !(d-&gt;mode&amp;DMDIR)){
			/*
			 * ISO 9660 actually requires that you always have a . and a ;,
			 * even if there is no version and no extension.  Very few writers
			 * do this.  If the version is present, we use it for qid.vers.
			 * If there is no extension but there is a dot, we strip it off.
			 * (VMS heads couldn't comprehend the dot as a file name character
			 * rather than as just a separator between name and extension.)
			 *
			 * We don't do this for directory names because directories are
			 * not allowed to have extensions and versions.
			 */
			if((p=strchr(d-&gt;name, ';')) != nil){
				vers = strtoul(p+1, 0, 0);
				d-&gt;qid.vers = vers;
				*p = '\0';
			}
			if((p=strchr(d-&gt;name, '.')) != nil &amp;&amp; *(p+1)=='\0')
				*p = '\0';
		}
		if(fs-&gt;issusp){
			nl = 0;
			s += fs-&gt;suspoff;
			sysl -= fs-&gt;suspoff;
			for(; sysl &gt;= 4 &amp;&amp; have != (Hname|Hmode); sysl -= l, s += l){
				if(s[0] == 0 &amp;&amp; ((uintptr)s &amp; 1)){
					/* MacOS pads individual entries, contrary to spec */
					s++;
					sysl--;
				}
				l = s[2];
				if(s[0] == 'P' &amp;&amp; s[1] == 'X' &amp;&amp; s[3] == 1){
					/* posix file attributes */
					mode = l32(s+4);
					d-&gt;mode = mode &amp; 0777;
					if((mode &amp; 0170000) == 040000){
						d-&gt;mode |= DMDIR;
						d-&gt;qid.type |= QTDIR;
					}
					have |= Hmode;
				} else if(s[0] == 'N' &amp;&amp; s[1] == 'M' &amp;&amp; s[3] == 1){
					/* alternative name */
					if((s[4] &amp; ~1) == 0){
						i = nl+l-5;
						if(i &gt;= Maxname)
							i = Maxname-1;
						if((i -= nl) &gt; 0){
							memmove(d-&gt;name+nl, s+5, i);
							nl += i;
						}
						if(s[4] == 0)
							have |= Hname;
					}
				} else if(s[0] == 'C' &amp;&amp; s[1] == 'E' &amp;&amp; s[2] &gt;= 28){
					sysl = getcontin(fs-&gt;d, s, &amp;s);
					continue;
				} else if(s[0] == 'S' &amp;&amp; s[1] == 'T')
					break;
			}
		}
	}
	d-&gt;length = 0;
	if((d-&gt;mode &amp; DMDIR) == 0)	
		d-&gt;length = fakemax(l32(dp-&gt;size));
	d-&gt;type = 0;
	d-&gt;dev = 0;
	d-&gt;atime = gtime(dp-&gt;date);
	d-&gt;mtime = d-&gt;atime;
	return vers;
}

static int
getcontin(Xdata *dev, uchar *p, uchar **s)
{
	vlong bn, off, len;
	Iobuf *b;

	bn = l32(p+4);
	off = l32(p+12);
	len = l32(p+20);
	chat("getcontin %lld...", bn);
	b = getbuf(dev, bn);
	if(b == 0){
		*s = 0;
		return 0;
	}
	*s = b-&gt;iobuf+off;
	putbuf(b);
	return len;
}

static char *
nstr(uchar *p, int n)
{
	static char buf[132];
	char *q = buf;

	while(--n &gt;= 0){
		if(*p == '\\')
			*q++ = '\\';
		if(' ' &lt;= *p &amp;&amp; *p &lt;= '~')
			*q++ = *p++;
		else
			q += sprint(q, "\\%2.2ux", *p++);
	}
	*q = 0;
	return buf;
}

static char *
rdate(uchar *p, int fmt)
{
	static char buf[64];
	int htz, s, n;

	n = sprint(buf, "%2.2d.%2.2d.%2.2d %2.2d:%2.2d:%2.2d",
		p[0], p[1], p[2], p[3], p[4], p[5]);
	if(fmt == 'z'){
		htz = p[6];
		if(htz &gt;= 128){
			htz = 256-htz;
			s = '-';
		}else
			s = '+';
		sprint(&amp;buf[n], " (%c%.1f)", s, (float)htz/2);
	}
	return buf;
}

static char
dmsize[12] =
{
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,
};

static int
dysize(int y)
{

	if((y%4) == 0)
		return 366;
	return 365;
}

static long
gtime(uchar *p)	/* yMdhmsz */
{
	long t;
	int i, y, M, d, h, m, s, tz;

	y=p[0]; M=p[1]; d=p[2];
	h=p[3]; m=p[4]; s=p[5]; tz=p[6];
	USED(tz);
	y += 1900;
	if (y &lt; 1970)
		return 0;
	if (M &lt; 1 || M &gt; 12)
		return 0;
	if (d &lt; 1 || d &gt; dmsize[M-1])
		if (!(M == 2 &amp;&amp; d == 29 &amp;&amp; dysize(y) == 366))
			return 0;
	if (h &gt; 23)
		return 0;
	if (m &gt; 59)
		return 0;
	if (s &gt; 59)
		return 0;
	t = 0;
	for(i=1970; i&lt;y; i++)
		t += dysize(i);
	if (dysize(y)==366 &amp;&amp; M &gt;= 3)
		t++;
	while(--M)
		t += dmsize[M-1];
	t += d-1;
	t = 24*t + h;
	t = 60*t + m;
	t = 60*t + s;
	return t;
}

#define	p	((uchar*)arg)

static long
l16(void *arg)
{
	long v;

	v = ((long)p[1]&lt;&lt;8)|p[0];
	if (v &gt;= 0x8000L)
		v -= 0x10000L;
	return v;
}

static long
l32(void *arg)
{
	return (((long)p[3]&lt;&lt;8 | p[2])&lt;&lt;8 | p[1])&lt;&lt;8 | p[0];
}

#undef	p

static vlong
l64(void *arg)
{
	uchar *p;

	p = arg;
	return (vlong)l32(p+4) &lt;&lt; 32 | (ulong)l32(p);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

