<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9660srv/xfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9660srv/xfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "dat.h"
#include "fns.h"

static Xfile*	clean(Xfile*);

#define	FIDMOD	127	/* prime */

static Xdata*	xhead;
static Xfile*	xfiles[FIDMOD];
static Xfile*	freelist;

Xdata*
getxdata(char *name)
{
	int fd;
	Dir *dir;
	Xdata *xf, *fxf;
	int flag;

	if(name[0] == 0)
		name = deffile;
	if(name == 0)
		error(Enofile);
	flag = (access(name, 6) == 0) ? ORDWR : OREAD;
	fd = open(name, flag);
	if(fd &lt; 0)
		error(Enonexist);
	dir = nil;
	if(waserror()){
		close(fd);
		free(dir);
		nexterror();
	}
	if((dir = dirfstat(fd)) == nil)
		error("I/O error");
	if((dir-&gt;qid.type &amp; ~QTTMP) != QTFILE)
		error("attach name not a plain file");
	for(fxf=0,xf=xhead; xf; xf=xf-&gt;next){
		if(xf-&gt;name == 0){
			if(fxf == 0)
				fxf = xf;
			continue;
		}
		if(xf-&gt;qid.path != dir-&gt;qid.path || xf-&gt;qid.vers != dir-&gt;qid.vers)
			continue;
		if(xf-&gt;type != dir-&gt;type || xf-&gt;fdev != dir-&gt;dev)
			continue;
		xf-&gt;ref++;
		chat("incref=%d, \"%s\", dev=%d...", xf-&gt;ref, xf-&gt;name, xf-&gt;dev);
		close(fd);
		poperror();
		free(dir);
		return xf;
	}
	if(fxf==0){
		fxf = ealloc(sizeof(Xfs));
		fxf-&gt;next = xhead;
		xhead = fxf;
	}
	chat("alloc \"%s\", dev=%d...", name, fd);
	fxf-&gt;ref = 1;
	fxf-&gt;name = strcpy(ealloc(strlen(name)+1), name);
	fxf-&gt;qid = dir-&gt;qid;
	fxf-&gt;type = dir-&gt;type;
	fxf-&gt;fdev = dir-&gt;dev;
	fxf-&gt;dev = fd;
	free(dir);
	poperror();
	return fxf;
}

static void
putxdata(Xdata *d)
{
	if(d-&gt;ref &lt;= 0)
		panic(0, "putxdata");
	d-&gt;ref--;
	chat("decref=%d, \"%s\", dev=%d...", d-&gt;ref, d-&gt;name, d-&gt;dev);
	if(d-&gt;ref == 0){
		chat("purgebuf...");
		purgebuf(d);
		close(d-&gt;dev);
		free(d-&gt;name);
		d-&gt;name = 0;
	}
}

void
refxfs(Xfs *xf, int delta)
{
	xf-&gt;ref += delta;
	if(xf-&gt;ref == 0){
		if(xf-&gt;d)
			putxdata(xf-&gt;d);
		if(xf-&gt;ptr)
			free(xf-&gt;ptr);
		free(xf);
	}
}

Xfile*
xfile(int fid, int flag)
{
	int k = fid%FIDMOD;
	Xfile **hp=&amp;xfiles[k], *f, *pf;

	for(f=*hp,pf=0; f; pf=f,f=f-&gt;next)
		if(f-&gt;fid == fid)
			break;
	if(f &amp;&amp; pf){
		pf-&gt;next = f-&gt;next;
		f-&gt;next = *hp;
		*hp = f;
	}
	switch(flag){
	default:
		panic(0, "xfile");
	case Asis:
		if(f == 0)
			error("unassigned fid");
		return f;
	case Clean:
		break;
	case Clunk:
		if(f){
			*hp = f-&gt;next;
			clean(f);
			f-&gt;next = freelist;
			freelist = f;
		}
		return 0;
	}
	if(f)
		return clean(f);
	if(f = freelist)	/* assign = */
		freelist = f-&gt;next;
	else
		f = ealloc(sizeof(Xfile));
	f-&gt;next = *hp;
	*hp = f;
	f-&gt;xf = 0;
	f-&gt;fid = fid;
	f-&gt;flags = 0;
	f-&gt;qid = (Qid){0,0,0};
	f-&gt;len = 0;
	f-&gt;ptr = 0;
	return f;
}

static Xfile *
clean(Xfile *f)
{
	if(f-&gt;xf){
		refxfs(f-&gt;xf, -1);
		f-&gt;xf = 0;
	}
	if(f-&gt;len){
		free(f-&gt;ptr);
		f-&gt;len = 0;
	}
	f-&gt;ptr = 0;
	f-&gt;flags = 0;
	f-&gt;qid = (Qid){0,0,0};
	return f;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

