<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/9p.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/9p.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static char *tnames[] = {
	[Tversion]	"version",
	[Tauth]		"auth",
	[Tattach]	"attach",
	[Tflush]	"flush",
	[Twalk]		"walk",
	[Topen]		"open",
	[Tcreate]	"create",
	[Tread]		"read",
	[Twrite]	"write",
	[Tclunk]	"clunk",
	[Tremove]	"remove",
	[Tstat]		"stat",
	[Twstat]	"wstat",
};

int	messagesize = IOHDRSZ+Maxfdata;

int
xmesg(Session *s, int t)
{
	int n;

	if(chatty){
		if(0 &lt;= t &amp;&amp; t &lt; nelem(tnames) &amp;&amp; tnames[t])
			chat("T%s...", tnames[t]);
		else
			chat("T%d...", t);
	}
	s-&gt;f.type = t;
	s-&gt;f.tag = ++s-&gt;tag;
	if(p9debug)
		fprint(2, "xmseg\tsend %F\n", &amp;s-&gt;f);
	n = convS2M(&amp;s-&gt;f, s-&gt;data, messagesize);
	if(niwrite(s-&gt;fd, s-&gt;data, n) != n){
		clog("xmesg write error on %d: %r\n", s-&gt;fd);
		return -1;
	}
again:
	n = read9pmsg(s-&gt;fd, s-&gt;data, messagesize);
	if(n &lt; 0){
		clog("xmesg read error: %r\n");
		return -1;
	}
	if(convM2S(s-&gt;data, n, &amp;s-&gt;f) &lt;= 0){
		clog("xmesg bad convM2S %d %.2x %.2x %.2x %.2x\n",
			n, ((uchar*)s-&gt;data)[0], ((uchar*)s-&gt;data)[1],
			((uchar*)s-&gt;data)[2], ((uchar*)s-&gt;data)[3]);
		return -1;
	}
	if(p9debug)
		fprint(2, "\trecv %F\n", &amp;s-&gt;f);
	if(s-&gt;f.tag != s-&gt;tag){
		clog("xmesg tag %d for %d\n", s-&gt;f.tag, s-&gt;tag);
		goto again;
	}
	if(s-&gt;f.type == Rerror){
		if(t == Tclunk)
			clog("xmesg clunk: %s", s-&gt;f.ename);
		chat("xmesg %d error %s...", t, s-&gt;f.ename);
		return -1;
	}
	if(s-&gt;f.type != t+1){
		clog("xmesg type mismatch: %d, expected %d\n", s-&gt;f.type, t+1);
		return -1;
	}
	return 0;
}

int
clunkfid(Session *s, Fid *f)
{
	putfid(s, f);
	if(s == 0 || f == 0)
		return 0;
	s-&gt;f.fid = f - s-&gt;fids;
	return xmesg(s, Tclunk);
}

#define	UNLINK(p)	((p)-&gt;prev-&gt;next = (p)-&gt;next, (p)-&gt;next-&gt;prev = (p)-&gt;prev)

#define	LINK(h, p)	((p)-&gt;next = (h)-&gt;next, (p)-&gt;prev = (h), \
			 (h)-&gt;next-&gt;prev = (p), (h)-&gt;next = (p))

#define	TOFRONT(h, p)	((h)-&gt;next != (p) ? (UNLINK(p), LINK(h,p)) : 0)

Fid *
newfid(Session *s)
{
	Fid *f, *fN;

	chat("newfid..");
	if(s-&gt;list.prev == 0){
		chat("init..");
		s-&gt;list.prev = &amp;s-&gt;list;
		s-&gt;list.next = &amp;s-&gt;list;
		s-&gt;free = s-&gt;fids;
		if(0 &amp;&amp; chatty)
			fN = &amp;s-&gt;fids[25];
		else
			fN = &amp;s-&gt;fids[nelem(s-&gt;fids)];
		for(f=s-&gt;fids; f&lt;fN; f++){
			f-&gt;owner = 0;
			f-&gt;prev = 0;
			f-&gt;next = f+1;
		}
		(f-1)-&gt;next = 0;
	}
	if(s-&gt;free){
		f = s-&gt;free;
		s-&gt;free = f-&gt;next;
		LINK(&amp;s-&gt;list, f);
	}else{
		for(f=s-&gt;list.prev; f!=&amp;s-&gt;list; f=f-&gt;prev)
			if(f-&gt;owner)
				break;
		if(f == &amp;s-&gt;list){
			clog("fid leak");
			return 0;
		}
		setfid(s, f);
		if(xmesg(s, Tclunk) &lt; 0){
			clog("clunk failed, no fids?");
			/*return 0;*/
		}
		*(f-&gt;owner) = 0;
		f-&gt;owner = 0;
	}
	chat("%ld...", f - s-&gt;fids);
	f-&gt;tstale = nfstime + staletime;
	return f;
}

void
setfid(Session *s, Fid *f)
{
	/*
	 * TOFRONT(&amp;s-&gt;list, f);
	 */
	if(s-&gt;list.next != f){
		UNLINK(f);
		LINK(&amp;s-&gt;list, f);
	}

	f-&gt;tstale = nfstime + staletime;
	s-&gt;f.fid = f - s-&gt;fids;
}

void
putfid(Session *s, Fid *f)
{
	chat("putfid %ld...", f-s-&gt;fids);
	if(s == 0 || f == 0){
		clog("putfid(0x%p, 0x%p) %s", s, f, (s ? s-&gt;service : "?"));
		return;
	}
	UNLINK(f);
	if(f-&gt;owner)
		*(f-&gt;owner) = 0;
	f-&gt;owner = 0;
	f-&gt;prev = 0;
	f-&gt;next = s-&gt;free;
	s-&gt;free = f;
}

void
fidtimer(Session *s, long now)
{
	Fid *f, *t;
	int n;

	f = s-&gt;list.next;
	n = 0;
	while(f != &amp;s-&gt;list){
		t = f;
		f = f-&gt;next;
		if(t-&gt;owner &amp;&amp; now &gt;= t-&gt;tstale)
			++n, clunkfid(s, t);
	}
	if(n &gt; 0)
		chat("fidtimer %s\n", s-&gt;service);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

