<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/rpc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/rpc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

#define	SHORT(x)	r-&gt;x = (p[1] | (p[0]&lt;&lt;8)); p += 2
#define	LONG(x)		r-&gt;x = (p[3] | (p[2]&lt;&lt;8) |\
				(p[1]&lt;&lt;16) | (p[0]&lt;&lt;24)); p += 4
#define SKIPLONG	p += 4
#define	PTR(x, n)	r-&gt;x = (void *)(p); p += ROUNDUP(n)

int
rpcM2S(void *ap, Rpccall *r, int n)
{
	int k;
	uchar *p;
	Udphdr *up;

	/* copy IPv4 header fields from Udphdr */
	up = ap;
	p = &amp;up-&gt;raddr[IPaddrlen - IPv4addrlen];
	LONG(host);
	USED(p);
	p = &amp;up-&gt;laddr[IPaddrlen - IPv4addrlen];
	LONG(lhost);
	USED(p);
	/* ignore up-&gt;ifcaddr */
	p = up-&gt;rport;
	SHORT(port);
	SHORT(lport);

	LONG(xid);
	LONG(mtype);
	switch(r-&gt;mtype){
	case CALL:
		LONG(rpcvers);
		if(r-&gt;rpcvers != 2)
			break;
		LONG(prog);
		LONG(vers);
		LONG(proc);
		LONG(cred.flavor);
		LONG(cred.count);
		PTR(cred.data, r-&gt;cred.count);
		LONG(verf.flavor);
		LONG(verf.count);
		PTR(verf.data, r-&gt;verf.count);
		r-&gt;up = 0;
		k = n - (p - (uchar *)ap);
		if(k &lt; 0)
			break;
		PTR(args, k);
		break;
	case REPLY:
		LONG(stat);
		switch(r-&gt;stat){
		case MSG_ACCEPTED:
			LONG(averf.flavor);
			LONG(averf.count);
			PTR(averf.data, r-&gt;averf.count);
			LONG(astat);
			switch(r-&gt;astat){
			case SUCCESS:
				k = n - (p - (uchar *)ap);
				if(k &lt; 0)
					break;
				PTR(results, k);
				break;
			case PROG_MISMATCH:
				LONG(plow);
				LONG(phigh);
				break;
			}
			break;
		case MSG_DENIED:
			LONG(rstat);
			switch(r-&gt;rstat){
			case RPC_MISMATCH:
				LONG(rlow);
				LONG(rhigh);
				break;
			case AUTH_ERROR:
				LONG(authstat);
				break;
			}
			break;
		}
		break;
	}
	n -= p - (uchar *)ap;
	return n;
}

int
auth2unix(Auth *arg, Authunix *r)
{
	int i, n;
	uchar *p;

	if(arg-&gt;flavor != AUTH_UNIX)
		return -1;
	p = arg-&gt;data;
	LONG(stamp);
	LONG(mach.n);
	PTR(mach.s, r-&gt;mach.n);
	LONG(uid);
	LONG(gid);
	LONG(gidlen);
	n = r-&gt;gidlen;
	for(i=0; i&lt;n &amp;&amp; i &lt; nelem(r-&gt;gids); i++){
		LONG(gids[i]);
	}
	for(; i&lt;n; i++){
		SKIPLONG;
	}
	return arg-&gt;count - (p - (uchar *)arg-&gt;data);
}

int
string2S(void *arg, String *r)
{
	uchar *p;
	char *s;

	p = arg;
	LONG(n);
	PTR(s, r-&gt;n);
	/* must NUL terminate */
	s = malloc(r-&gt;n+1);
	if(s == nil)
		panic("malloc(%ld) failed in string2S\n", r-&gt;n+1);
	memmove(s, r-&gt;s, r-&gt;n);
	s[r-&gt;n] = '\0';
	r-&gt;s = strstore(s);
	free(s);
	return p - (uchar *)arg;
}

#undef	SHORT
#undef	LONG
#undef	PTR

#define	SHORT(x)	p[1] = r-&gt;x; p[0] = r-&gt;x&gt;&gt;8; p += 2
#define	LONG(x)		p[3] = r-&gt;x; p[2] = r-&gt;x&gt;&gt;8; p[1] = r-&gt;x&gt;&gt;16; p[0] = r-&gt;x&gt;&gt;24; p += 4

#define	PTR(x,n)	memmove(p, r-&gt;x, n); p += ROUNDUP(n)

int
rpcS2M(Rpccall *r, int ndata, void *ap)
{
	uchar *p;
	Udphdr *up;

	/* copy header fields to Udphdr */
	up = ap;
	memmove(up-&gt;raddr, v4prefix, IPaddrlen);
	p = &amp;up-&gt;raddr[IPaddrlen - IPv4addrlen];
	LONG(host);
	USED(p);
	memmove(up-&gt;laddr, v4prefix, IPaddrlen);
	p = &amp;up-&gt;laddr[IPaddrlen - IPv4addrlen];
	LONG(lhost);
	USED(p);
	memmove(up-&gt;ifcaddr, IPnoaddr, sizeof up-&gt;ifcaddr);
	p = up-&gt;rport;
	SHORT(port);
	SHORT(lport);

	LONG(xid);
	LONG(mtype);
	switch(r-&gt;mtype){
	case CALL:
		LONG(rpcvers);
		LONG(prog);
		LONG(vers);
		LONG(proc);
		LONG(cred.flavor);
		LONG(cred.count);
		PTR(cred.data, r-&gt;cred.count);
		LONG(verf.flavor);
		LONG(verf.count);
		PTR(verf.data, r-&gt;verf.count);
		PTR(args, ndata);
		break;
	case REPLY:
		LONG(stat);
		switch(r-&gt;stat){
		case MSG_ACCEPTED:
			LONG(averf.flavor);
			LONG(averf.count);
			PTR(averf.data, r-&gt;averf.count);
			LONG(astat);
			switch(r-&gt;astat){
			case SUCCESS:
				PTR(results, ndata);
				break;
			case PROG_MISMATCH:
				LONG(plow);
				LONG(phigh);
				break;
			}
			break;
		case MSG_DENIED:
			LONG(rstat);
			switch(r-&gt;rstat){
			case RPC_MISMATCH:
				LONG(rlow);
				LONG(rhigh);
				break;
			case AUTH_ERROR:
				LONG(authstat);
				break;
			}
			break;
		}
		break;
	}
	return p - (uchar *)ap;
}

#undef	SHORT
#undef	LONG
#undef	PTR

#define	LONG(m, x)	fprint(fd, "%s = %ld\n", m, r-&gt;x)

#define	PTR(m, count)	fprint(fd, "%s [%ld]\n", m, count)

void
rpcprint(int fd, Rpccall *r)
{
	fprint(fd, "%s: host = %I, port = %ld\n", 
		argv0, r-&gt;host, r-&gt;port);
	LONG("xid", xid);
	LONG("mtype", mtype);
	switch(r-&gt;mtype){
	case CALL:
		LONG("rpcvers", rpcvers);
		LONG("prog", prog);
		LONG("vers", vers);
		LONG("proc", proc);
		LONG("cred.flavor", cred.flavor);
		PTR("cred.data", r-&gt;cred.count);
		LONG("verf.flavor", verf.flavor);
		PTR("verf.data", r-&gt;verf.count);
		fprint(fd, "args...\n");
		break;
	case REPLY:
		LONG("stat", stat);
		switch(r-&gt;stat){
		case MSG_ACCEPTED:
			LONG("averf.flavor", averf.flavor);
			PTR("averf.data", r-&gt;averf.count);
			LONG("astat", astat);
			switch(r-&gt;astat){
			case SUCCESS:
				fprint(fd, "results...\n");
				break;
			case PROG_MISMATCH:
				LONG("plow", plow);
				LONG("phigh", phigh);
				break;
			}
			break;
		case MSG_DENIED:
			LONG("rstat", rstat);
			switch(r-&gt;rstat){
			case RPC_MISMATCH:
				LONG("rlow", rlow);
				LONG("rhigh", rhigh);
				break;
			case AUTH_ERROR:
				LONG("authstat", authstat);
				break;
			}
			break;
		}
	}
}

void
showauth(Auth *ap)
{
	Authunix au;
	int i;

	if(auth2unix(ap, &amp;au) != 0){
		chat("auth flavor=%ld, count=%ld",
			ap-&gt;flavor, ap-&gt;count);
		for(i=0; i&lt;ap-&gt;count; i++)
			chat(" %.2ux", ((uchar *)ap-&gt;data)[i]);
	}else{
		chat("auth: %ld %.*s u=%ld g=%ld",
			au.stamp, utfnlen(au.mach.s, au.mach.n), au.mach.s, au.uid, au.gid);
		for(i=0; i&lt;au.gidlen; i++)
			chat(", %ld", au.gids[i]);
	}
	chat("...");
}

int
garbage(Rpccall *reply, char *msg)
{
	chat("%s\n", msg ? msg : "garbage");
	reply-&gt;astat = GARBAGE_ARGS;
	return 0;
}

int
error(Rpccall *reply, int errno)
{
	uchar *dataptr = reply-&gt;results;

	chat("error %d\n", errno);
	PLONG(errno);
	return dataptr - (uchar *)reply-&gt;results;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

