<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/unixnames.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/unixnames.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static void	uxfree(Unixid*);

static Unixid *	xfree;

Unixidmap *idhead, *idtail;

Unixscmap *scmap;

#define	UNUSED	0x7FFFFFFF

/*
 * Sadly we have to use the IP address, since some systems (FreeBSD in particular)
 * do not believe it to be safe to depend on the hostname and so refuse to send it.
 * I dislike making this IP-centric, but so be it.
 * We keep a cache of host names in getdom.
 */
Unixidmap *
pair2idmap(char *server, ulong clientip)
{
	Resub match;
	Unixscmap *m, *mp;
	Unixidmap *r;
	char dom[256];

	for(mp=0,m=scmap; m; mp=m,m=m-&gt;next){
		if(m-&gt;server[0] != server[0])
			continue;
		if(strcmp(m-&gt;server, server))
			continue;
		if(m-&gt;clientip != clientip)
			continue;
		if(mp){
			mp-&gt;next = m-&gt;next;
			m-&gt;next = scmap;
			scmap = m;
		}
		r = m-&gt;map;
		if(r-&gt;u.timestamp != 0 &amp;&amp; r-&gt;g.timestamp != 0)
			return r;
		scmap = m-&gt;next;
		free(m);
		break;
	}
	if(rpcdebug)
		fprint(2, "looking for %lux\n", clientip);
	if(getdom(clientip, dom, sizeof dom)&lt;0){
		clog("auth: unknown ip address");
		return nil;
	}
	if(rpcdebug)
		fprint(2, "dom is %s\n", dom);
	for(r=idhead; r; r=r-&gt;next){
		if(r-&gt;u.timestamp == 0 || r-&gt;g.timestamp == 0)
			continue;
		match.sp = match.ep = 0;
		if(regexec(r-&gt;sexp, server, &amp;match, 1) == 0)
			continue;
		if(match.sp != server || match.ep &lt;= match.sp || *match.ep)
			continue;
		match.sp = match.ep = 0;
		if(regexec(r-&gt;cexp, dom, &amp;match, 1) == 0)
			continue;
		if(match.sp != dom || match.ep &lt;= match.sp || *match.ep)
			continue;
		m = malloc(sizeof(Unixscmap));
		m-&gt;next = scmap;
		scmap = m;
		m-&gt;server = strstore(server);
		m-&gt;clientip = clientip;
		m-&gt;map = r;
		break;
	}
	return r;
}

int
readunixidmaps(char *file)
{
	Waitmsg *w;
	Biobuf *in;
	Unixidmap *m;
	int i, arc; char *arv[16], buf[256];
	char *l;
// 	long savalarm;

// 	savalarm = alarm(0);
	in = Bopen(file, OREAD);
	if(in == 0){
		clog("readunixidmaps can't open %s: %r\n", file);
//		alarm(savalarm);
		return -1;
	}
	for(m=idhead; m; m=m-&gt;next)
		m-&gt;flag = 0;
	while(l = Brdline(in, '\n')){	/* assign = */
		l[Blinelen(in)-1] = 0;
		arc = strparse(l, nelem(arv), arv);
		if(arc &gt; 0 &amp;&amp; arv[0][0] == '!'){
			++arv[0];
			snprint(buf, sizeof buf, "/bin/%s", arv[0]);
			if(chatty){
				chat("!");
				for(i=0; i&lt;arc; i++)
					chat(" %s", arv[i]);
				chat("...");
			}
			w = system(buf, arv);
			if(w == nil)
				chat("err: %r\n");
			else if(w-&gt;msg &amp;&amp; w-&gt;msg[0])
				chat("status: %s\n", w-&gt;msg);
			else
				chat("OK\n");
			free(w);
			continue;
		}
		if(arc != 4)
			continue;
		for(m=idhead; m; m=m-&gt;next)
			if(strcmp(arv[0], m-&gt;server) == 0 &amp;&amp;
			   strcmp(arv[1], m-&gt;client) == 0)
				break;
		if(m == 0){
			m = malloc(sizeof(Unixidmap));
			if(idtail)
				idtail-&gt;next = m;
			else
				idhead = m;
			idtail = m;
			m-&gt;next = 0;
			m-&gt;server = strstore(arv[0]);
			m-&gt;client = strstore(arv[1]);
			m-&gt;sexp = regcomp(m-&gt;server);
			m-&gt;cexp = regcomp(m-&gt;client);
			m-&gt;u.file = strstore(arv[2]);
			m-&gt;u.style = 'u';
			m-&gt;u.timestamp = 0;
			m-&gt;u.ids = 0;
			m-&gt;g.file = strstore(arv[3]);
			m-&gt;g.style = 'u';
			m-&gt;g.timestamp = 0;
			m-&gt;g.ids = 0;
		}else{
			if(!m-&gt;u.file || strcmp(m-&gt;u.file, arv[2]) != 0){
				m-&gt;u.file = strstore(arv[2]);
				m-&gt;u.timestamp = 0;
			}
			if(!m-&gt;g.file || strcmp(m-&gt;g.file, arv[3]) != 0){
				m-&gt;g.file = strstore(arv[3]);
				m-&gt;g.timestamp = 0;
			}
		}
		m-&gt;flag = 1;
		checkunixmap(&amp;m-&gt;u);
		checkunixmap(&amp;m-&gt;g);
	}
	Bterm(in);
	for(m=idhead; m; m=m-&gt;next)
		if(m-&gt;flag == 0){
			m-&gt;u.file = 0;
			m-&gt;u.timestamp = 0;
			uxfree(m-&gt;u.ids);
			m-&gt;u.ids = 0;
			m-&gt;g.file = 0;
			m-&gt;g.timestamp = 0;
			uxfree(m-&gt;g.ids);
			m-&gt;g.ids = 0;
		}
// 	alarm(savalarm);
	return 0;
}

static void
uxfree(Unixid *x)
{
	Unixid *tail;
	int count=0;

	if(x){
		tail = x;
		if(tail-&gt;id &lt; 0)
			abort();
		tail-&gt;id = UNUSED;
		while(tail-&gt;next){
			tail = tail-&gt;next;
			++count;
			if(tail-&gt;id == UNUSED)
				abort();
			tail-&gt;id = UNUSED;
		}
		tail-&gt;next = xfree;
		xfree = x;
	}
}

int
checkunixmap(Unixmap *u)
{
	Dir *dir;

	dir = dirstat(u-&gt;file);
	if(dir == nil){
		clog("checkunixmap can't stat %s: %r\n", u-&gt;file);
		return -1;
	}
	if(u-&gt;timestamp &gt; dir-&gt;mtime){
		free(dir);
		return 0;
	}
	uxfree(u-&gt;ids);
	u-&gt;ids = readunixids(u-&gt;file, u-&gt;style);
	u-&gt;timestamp = time(0);
	free(dir);
	return 1;
}

int
name2id(Unixid **list, char *name)
{
	Unixid *x, *xp;

	for(xp=0,x=*list; x; xp=x,x=x-&gt;next){
		if(x-&gt;name[0] == name[0] &amp;&amp; strcmp(x-&gt;name, name) == 0){
			if(xp){
				xp-&gt;next = x-&gt;next;
				x-&gt;next = *list;
				*list = x;
			}
			return x-&gt;id;
		}
	}
	return -1;
}

char *
id2name(Unixid **list, int id)
{
	Unixid *x, *xp;

	for(xp=0,x=*list; x; xp=x,x=x-&gt;next){
		if(x-&gt;id == id){
			if(xp){
				xp-&gt;next = x-&gt;next;
				x-&gt;next = *list;
				*list = x;
			}
			return x-&gt;name;
		}
	}
	return "none";
}

void
idprint(int fd, Unixid *xp)
{
	while(xp){
		fprint(fd, "%d\t%s\n", xp-&gt;id, xp-&gt;name);
		xp = xp-&gt;next;
	}
}

/*
 *	style '9': 3:tom:tom:
 *	style 'u': sysadm:*:0:0:System-Administrator:/usr/admin:/bin/sh
 */

Unixid *
readunixids(char *file, int style)
{
	Biobuf *in;
	char *l, *name = 0;
	Unixid *x, *xp = 0;
	int id = 0;

	in = Bopen(file, OREAD);
	if(in == 0){
		clog("readunixids can't open %s: %r\n", file);
		return 0;
	}
	while(l = Brdline(in, '\n')){	/* assign = */
		l[Blinelen(in)-1] = 0;
		switch(style){
		case '9':
			id = strtol(l, &amp;l, 10);
			if(*l != ':')
				continue;
			name = ++l;
			l = strchr(l, ':');
			if(l == 0)
				continue;
			*l = 0;
			break;
		case 'u':
			name = l;
			l = strchr(l, ':');
			if(l == 0)
				continue;
			*l++ = 0;
			/* skip password */
			l = strchr(l, ':');
			if(l == 0)
				continue;
			id = strtol(l+1, 0, 10);
			break;
		default:
			panic("unknown unixid style %d\n", style);
		}
		if(id == UNUSED)
			id = -1;	/* any value will do */
		if(!(x = xfree))	/* assign = */
			x = listalloc(1024/sizeof(Unixid), sizeof(Unixid));
		xfree = x-&gt;next;
		x-&gt;id = id;
		x-&gt;name = strstore(name);
		x-&gt;next = xp;
		xp = x;
	}
	Bterm(in);
	return xp;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

