<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/9nfs/xfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/9nfs/xfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static Xfile *	xflfree;
static Xfid *	xfdfree;

#define	FIDMOD	127	/* prime */

static Xfile	*xfiles[FIDMOD];
static Lock	xlocks[FIDMOD];

Xfile *
xfile(Qid *qid, void *s, int new)
{
	int k;
	Xfile **hp, *f, *pf;

	k = ((ulong)qid-&gt;path ^ (((u32int)(uintptr)s)&lt;&lt;24))%FIDMOD;
	hp = &amp;xfiles[k];

	lock(&amp;xlocks[k]);
	for(f=*hp, pf=0; f; pf=f, f=f-&gt;next)
		if(f-&gt;qid.path == qid-&gt;path 
		&amp;&amp; (u32int)(uintptr)f-&gt;s == (u32int)(uintptr)s)
			break;
	if(f &amp;&amp; pf){
		pf-&gt;next = f-&gt;next;
		f-&gt;next = *hp;
		*hp = f;
	}
	if(new &lt; 0 &amp;&amp; f){
		*hp = f-&gt;next;
		f-&gt;next = xflfree;
		xflfree = f;
		f = 0;
	}
	if(new &gt; 0 &amp;&amp; !f){
		if(!(f = xflfree))	/* assign = */
			f = listalloc(1024/sizeof(Xfile), sizeof(Xfile));
		xflfree = f-&gt;next;
		memset(f, 0, sizeof(Xfile));
		f-&gt;next = *hp;
		*hp = f;
		f-&gt;qid = *qid;
		f-&gt;s = s;
	}
	unlock(&amp;xlocks[k]);
	return f;
}

Xfid *
xfid(char *uid, Xfile *xp, int new)
{
	Xfid *f, *pf;

	for(f=xp-&gt;users, pf=0; f; pf=f, f=f-&gt;next)
		if(f-&gt;uid[0] == uid[0] &amp;&amp; strcmp(f-&gt;uid, uid) == 0)
			break;
	if(f &amp;&amp; pf){
		pf-&gt;next = f-&gt;next;
		f-&gt;next = xp-&gt;users;
		xp-&gt;users = f;
	}
	if(new &lt; 0 &amp;&amp; f){
		if(f-&gt;urfid)
			clunkfid(xp-&gt;s, f-&gt;urfid);
		if(f-&gt;opfid)
			clunkfid(xp-&gt;s, f-&gt;opfid);
		xp-&gt;users = f-&gt;next;
		f-&gt;next = xfdfree;
		xfdfree = f;
		f = 0;
	}
	if(new &gt; 0 &amp;&amp; !f){
		if(!(f = xfdfree))	/* assign = */
			f = listalloc(1024/sizeof(Xfid), sizeof(Xfid));
		xfdfree = f-&gt;next;
		memset(f, 0, sizeof(Xfid));
		f-&gt;next = xp-&gt;users;
		xp-&gt;users = f;
		f-&gt;xp = xp;
		f-&gt;uid = strstore(uid);
		f-&gt;urfid = 0;
		f-&gt;opfid = 0;
	}
	return f;
}

int
xfpurgeuid(Session *s, char *uid)
{
	Xfile **hp, *f;
	Xfid *xf;
	int k, count=0;

	for(k=0; k&lt;FIDMOD; k++){
		lock(&amp;xlocks[k]);
		hp=&amp;xfiles[k];
		for(f=*hp; f; f=f-&gt;next)
			if(f-&gt;s == s &amp;&amp; (xf = xfid(uid, f, 0))){ /* assign = */
				xfclear(xf);
				++count;
			}
		unlock(&amp;xlocks[k]);
	}
	return count;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

