<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/html.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/html.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

static void sizeitem(Lay *, Item *);

static
void
sizetext(Lay *lay, Itext *i)
{
	lay-&gt;font = getfont(i-&gt;fnt);
	i-&gt;height = lay-&gt;font-&gt;height + 2*Space;
	i-&gt;width = runestringwidth(lay-&gt;font, i-&gt;s);
	i-&gt;width += runestringnwidth(lay-&gt;font, L" ", 1);
}

static
void
sizerule(Lay *lay, Irule *i)
{
	i-&gt;width = lay-&gt;width;
	i-&gt;height = Space + i-&gt;size + Space;
}

static
void
sizeimage(Lay *, Iimage *i)
{
	Cimage *ci;

	ci = (Cimage *)i-&gt;aux;

	if(ci==nil)
		return;

	if(ci-&gt;i == nil)
		getimage(ci, i-&gt;altrep);
	if(ci-&gt;i == nil)
		return;
	i-&gt;width = Dx(ci-&gt;i-&gt;r) + i-&gt;border + i-&gt;hspace;
	i-&gt;height = Dy(ci-&gt;i-&gt;r) + i-&gt;border + i-&gt;vspace;
}

static
void
sizetextfield(Lay *, Iformfield *i)
{
	Formfield *ff;
	Font *f;
	int w, h;

	ff = i-&gt;formfield;
	if(ff-&gt;ftype == Ftextarea){
		w = ff-&gt;cols;
		h = ff-&gt;rows;
	}else{
		w = ff-&gt;size;
		h = 1;
	}
	f = getfont(WFont);
	i-&gt;width = runestringnwidth(f, L"0", 1)*w + 2*(Space+Border+Margin);
	i-&gt;width += Scrollsize+Scrollgap;
	i-&gt;height = f-&gt;height*h + 2*(Space+Border+Margin);
}

static
void
sizecheck(Lay *, Iformfield *i)
{
	i-&gt;width = Boxsize + Space;
	i-&gt;height = Boxsize;
}

static
void
sizebutton(Lay *, Iformfield *i)
{
	Font *f;
	int x;

	x = Margin + Border + Space;
	f = getfont(WFont);
	i-&gt;width = runestringwidth(f, i-&gt;formfield-&gt;value) + 2*x + Space;
	i-&gt;height = f-&gt;height + 2*x;
}

static
void
sizefimage(Lay *lay, Iformfield *i)
{
	Iimage *ii;

	ii = (Iimage *)i-&gt;formfield-&gt;image;
	sizeimage(lay, ii);
	i-&gt;width = ii-&gt;width;
	i-&gt;height = ii-&gt;height;
}

static
void
sizeselect(Lay *, Iformfield *i)
{
	Option *o;
	Font *f;
	int x;

	f = getfont(WFont);
	i-&gt;width = 0;
	for(o=i-&gt;formfield-&gt;options; o!=nil; o=o-&gt;next)
		i-&gt;width = max(i-&gt;width, runestringwidth(f, o-&gt;display));
	x = Margin + Border + Space;
	i-&gt;width += 2*x;
	i-&gt;height = f-&gt;height+2*x;
}

static
void
sizeformfield(Lay *lay, Iformfield *i)
{
	int type;

	type = i-&gt;formfield-&gt;ftype;

	if(type==Ftext || type==Ftextarea || type==Fpassword)
		sizetextfield(lay, i);
	else if(type==Fcheckbox || type==Fradio)
		sizecheck(lay, i);
	else if(type==Fbutton || type==Freset || type==Fsubmit)
		sizebutton(lay, i);
	else if(type == Fimage)
		sizefimage(lay, i);
	else if(type == Fselect)
		sizeselect(lay, i);
}

static
void
sizetable(Lay *lay, Itable *i)
{
	tablesize(i-&gt;table, lay-&gt;width);
	i-&gt;width = i-&gt;table-&gt;totw;
	i-&gt;height = i-&gt;table-&gt;toth;
}

static
void
sizefloat(Lay *lay, Ifloat *i)
{
	sizeitem(lay, i-&gt;item);
	i-&gt;width = i-&gt;item-&gt;width;
	i-&gt;height = i-&gt;item-&gt;height;
}

static
void
sizespacer(Lay *lay, Ispacer *i)
{
	if(i-&gt;spkind != ISPnull){
		if(i-&gt;spkind == ISPhspace)
			i-&gt;width = stringnwidth(lay-&gt;font, " ", 1);
		i-&gt;height = lay-&gt;font-&gt;height + 2*Space;
	}
}

static
void
sizeitem(Lay *lay, Item *i)
{

	switch(i-&gt;tag){
	case Itexttag:
		sizetext(lay, (Itext *)i);
		break;
	case Iruletag:
		sizerule(lay, (Irule *)i);
		break;
	case Iimagetag:
		sizeimage(lay, (Iimage *)i);
		break;
	case Iformfieldtag:
		sizeformfield(lay, (Iformfield *)i);
		break;
	case Itabletag:
		sizetable(lay, (Itable *)i);
		break;
	case Ifloattag:
		sizefloat(lay, (Ifloat *)i);
		break;
	case Ispacertag:
		sizespacer(lay, (Ispacer *)i);
		break;
	default:
		error("can't happen");
	}
}

static
void
drawtext(Box *b, Page *p, Image *im)
{
	Rectangle r, r1;
	Image *c;
	Point pt;
	Font *f;
	Itext *i;
	int q0, q1;

	r = rectsubpt(b-&gt;r, p-&gt;pos);
	i = (Itext *)b-&gt;i;
	f = getfont(i-&gt;fnt);
	if(istextsel(p, b-&gt;r, &amp;q0, &amp;q1, i-&gt;s, f)){
		r1 = r;
		if(q0 &gt; 0)
			r1.min.x += runestringnwidth(f, i-&gt;s, q0);
		if(q1 &gt; 0)
			r1.max.x = r1.min.x + runestringnwidth(f, i-&gt;s+q0, q1-q0);
		draw(im, r1, textcols[HIGH], nil, ZP);
	}
	c = getcolor(i-&gt;fg);
	runestringbg(im, r.min, c, ZP, f, i-&gt;s, im, addpt(r.min, im-&gt;r.min));

	if(i-&gt;ul == ULnone)
		return;

	if(i-&gt;ul == ULmid)
		r.min.y += f-&gt;height/2;
	else
		r.min.y +=f-&gt;height-1;
	pt = r.min;
	pt.x +=  runestringwidth(f, i-&gt;s);
	line(im, r.min, pt, Enddisc, Enddisc, 0, c, ZP);
}

static
void
drawrule(Box *b, Page *p, Image *im)
{
	Rectangle r;
	Irule *i;

	i = ((Irule *)b-&gt;i);
	r = rectsubpt(b-&gt;r, p-&gt;pos);
	r.min.y += Space;
	r.max.y -=Space;
	draw(im, r, getcolor(i-&gt;color), nil, ZP);
}

static
void
drawimage(Box *b, Page *p, Image *im)
{
	Rectangle r;
	Cimage *ci;
	Iimage *i;
	Image *c;

	if(b-&gt;i-&gt;tag==Iimagetag)
		i = (Iimage *)b-&gt;i;
	else
		i = (Iimage *)((Iformfield *)b-&gt;i)-&gt;formfield-&gt;image;

	ci = (Cimage *)i-&gt;aux;
	if(ci==nil || ci-&gt;i==nil)
		return;

	r = rectsubpt(b-&gt;r, p-&gt;pos);
	r.min.x += i-&gt;border + i-&gt;hspace;
	r.min.y += i-&gt;border + i-&gt;vspace;
	r.max.x -= i-&gt;border + i-&gt;hspace;
	r.max.y -= i-&gt;border + i-&gt;vspace;

	draw(im, r,  ci-&gt;i, nil, ci-&gt;i-&gt;r.min);

	if(i-&gt;border){
		if(i-&gt;anchorid &gt;= 0)
			c = getcolor(p-&gt;doc-&gt;link);
		else
			c = display-&gt;black;

		border(im, r, i-&gt;border, c, ZP);
	}
}

static
void
drawtextfield(Image *im, Rectangle r, Iformfield *i)
{
	Formfield *ff;
	Image *c[3];
	Text *t;
	Font *f;

	r = insetrect(r, Space);
	colarray(c, getcolor(Dark), getcolor(Light), display-&gt;white, 1);
	rect3d(im, r, Border, c, ZP);
	r = insetrect(r, Border+Margin);

	if(i-&gt;aux == nil){
		ff = i-&gt;formfield;
		t = emalloc(sizeof(Text));
		if(ff-&gt;ftype == Ftextarea)
			t-&gt;what = Textarea;
		else
			t-&gt;what = Entry;
		if(ff-&gt;ftype == Fpassword)
			f = passfont;
		else
			f = getfont(WFont);
		textinit(t, im, r, f, textcols);
		if(ff-&gt;value!=nil){
			textinsert(t, 0, ff-&gt;value, runestrlen(ff-&gt;value));
			textsetselect(t, t-&gt;rs.nr, t-&gt;rs.nr);
		}
		if(t-&gt;what == Textarea)
			textscrdraw(t);
		i-&gt;aux = t;
	}else
		textresize(i-&gt;aux, im, r);
}

void
drawcheck(Image *im, Rectangle r, Formfield *f)
{
	Image *c[3];
	Point pt;
	int n;

	if(f-&gt;flags &amp; FFchecked)
		colarray(c, getcolor(Dark), getcolor(Light), getcolor(Red), TRUE);
	else
		colarray(c, getcolor(Dark), getcolor(Light), getcolor(Back), FALSE);

	if(f-&gt;ftype == Fradio){
		n = Boxsize/2-1;
		pt = addpt(r.min, Pt(n,n));
		ellipse3d(im, pt, n, Border, c, ZP);
	}else
		rect3d(im, r, Border, c, ZP);
}

void
drawbutton(Image *im, Rectangle r, Formfield *f, int checked)
{
	Image *c[3];

	r = insetrect(r, Space);
	colarray(c, getcolor(Dark), getcolor(Light), getcolor(Back), checked);
	rect3d(im, r, Border, c, ZP);
	r.min.x += Border + Margin;
	r.min.y += Border + Margin;
	runestringbg(im, r.min, display-&gt;black, ZP,  getfont(WFont), f-&gt;value, c[2], ZP);
}

void
drawselect(Image *im, Rectangle r,	Iformfield *i)
{
	Formfield *f;
	Image *c[3];

	f = i-&gt;formfield;
	if(f-&gt;options == nil)
		return;
	r = insetrect(r, Space);
	colarray(c, getcolor(Dark), getcolor(Light), display-&gt;white, 1);
	rect3d(im, r, Border, c, ZP);
	r = insetrect(r, Border+Margin);
	draw(im, r, textcols[HIGH], nil, ZP);
	if(i-&gt;aux==nil){
		i-&gt;aux = f-&gt;options-&gt;display;
		i-&gt;formfield-&gt;value = erunestrdup(f-&gt;options-&gt;value);
	}
	runestring(im, r.min, display-&gt;black, ZP,  getfont(WFont), i-&gt;aux);
}

/* Formfields are a special case */
static
void
drawformfield(Box *b, Page *p, Image *im)
{
	Formfield *f;
	int type;

	f = ((Iformfield *)b-&gt;i)-&gt;formfield;
	type =f-&gt;ftype;
	if(istextfield(b-&gt;i))
		drawtextfield(im, rectsubpt(b-&gt;r, p-&gt;pos), (Iformfield *)b-&gt;i);
	else if(type==Fcheckbox || type==Fradio)
		drawcheck(im, rectsubpt(b-&gt;r, p-&gt;pos), f);
	else if(type==Fbutton || type==Freset || type==Fsubmit)
		drawbutton(im, rectsubpt(b-&gt;r, p-&gt;pos), f, FALSE);
	else if(type == Fimage)
		drawimage(b, p, im);
	else if(type == Fselect)
		drawselect(im, rectsubpt(b-&gt;r, p-&gt;pos), (Iformfield *)b-&gt;i);
}

static
void
drawnull(Box *, Page *, Image *)
{
}

static
Page *
whichtarget1(Page *p, Rune *r)
{
	Kidinfo *k;
	Page *c, *ret;

	k = p-&gt;kidinfo;
	if(k &amp;&amp; k-&gt;name &amp;&amp; runestrcmp(k-&gt;name, r)==0)
		return p;
	for(c=p-&gt;child; c; c=c-&gt;next){
		ret = whichtarget1(c, r);
		if(ret)
			return ret;
	}
	return nil;
}

static
Page *
whichtarget(Page *p, int t)
{
	Page *r;

	switch(t){
	case FTblank:
	case FTtop:
		r = &amp;p-&gt;w-&gt;page;
		break;
	case FTself:
		r = p;
		break;
	case FTparent:
		r = p-&gt;parent;
		break;
	default:
		if(targetname(t) == L"?")
			error("targetname");
		r = whichtarget1(&amp;p-&gt;w-&gt;page, targetname(t));
	}

	return r ? r: &amp;p-&gt;w-&gt;page;
}

static
void
mouselink(Box *b, Page *p, int but)
{
	Runestr rs;
	Anchor *a;

	/* eat mouse */
	while(mousectl-&gt;buttons)
		readmouse(mousectl);

	if(b-&gt;i-&gt;anchorid &lt; 0)
		return;

	/* binary search would be better */
	for(a=p-&gt;doc-&gt;anchors; a!=nil; a=a-&gt;next)
		if(a-&gt;index == b-&gt;i-&gt;anchorid)
			break;

	if(a==nil || a-&gt;href==nil)
		return;

	p = whichtarget(p, a-&gt;target);
	rs.r = urlcombine(getbase(p), a-&gt;href);
	if(rs.r == nil)
		return;
	rs.nr = runestrlen(rs.r);

	if(but == 1)
		pageget(p, &amp;rs, nil, HGet, p==&amp;p-&gt;w-&gt;page);
	else if(but == 2)
		textset(&amp;p-&gt;w-&gt;status, rs.r, rs.nr);
	else if(but == 3)
		plumbrunestr(&amp;rs, nil);
	closerunestr(&amp;rs);
}

static
void
submit(Page *p, Formfield *formfield, int subfl)
{
	Formfield *f;
	Form *form;
	Runestr src, post;
	Rune *x, *sep, *y, *z;

	form = formfield-&gt;form;
	x = erunestrdup(L"");
	sep = L"";
	for(f=form-&gt;fields; f!=nil; f=f-&gt;next){
		if(f-&gt;ftype == Freset)
			continue;
		if((f-&gt;ftype==Fradio || f-&gt;ftype==Fcheckbox) &amp;&amp; !(f-&gt;flags&amp;FFchecked))
			continue;
		if(f-&gt;ftype==Fsubmit &amp;&amp; (f!=formfield || !subfl))
			continue;
		if(f-&gt;value==nil || f-&gt;name==nil || runestrcmp(f-&gt;name, L"_no_name_submit_")==0)
			continue;

		z = ucvt(f-&gt;value);
		y = runesmprint("%S%S%S=%S", x, sep, f-&gt;name, z);
		free(z);
		sep = L"&amp;";
		free(x);
		x = y;
	}
	p = whichtarget(p, form-&gt;target);
	y = urlcombine(getbase(p), form-&gt;action);

	memset(&amp;src, 0, sizeof(Runestr));
	memset(&amp;post, 0, sizeof(Runestr));
	if(form-&gt;method == HGet){
		if(y[runestrlen(y)-1] == L'?')
			sep = L"";
		else
			sep = L"?";
		src.r = runesmprint("%S%S%S",y, sep,  x);
		free(x);
		free(y);
	}else{
		src.r = y;
		post.r = x;
		post.nr = runestrlen(x);
		if(post.nr == 0){
			free(post.r);
			post.r = nil;
		}
	}
	src.nr = runestrlen(src.r);
	pageget(p, &amp;src, &amp;post, form-&gt;method, p==&amp;p-&gt;w-&gt;page);
	closerunestr(&amp;src);
	closerunestr(&amp;post);
}

static
void
setradios(Formfield *formfield)
{
	Formfield *f;

	for(f=formfield-&gt;form-&gt;fields; f!=nil; f=f-&gt;next)
		if(f-&gt;ftype==Fradio &amp;&amp; f!=formfield &amp;&amp; runestrcmp(f-&gt;name, formfield-&gt;name)==0)
			f-&gt;flags &amp;=~FFchecked;
}

static
void
selectmouse(Box *b, Page *p, int but)
{
	Formfield *f;
	Option *o;
	Menu m;
	char **item;
	int i, n;

	f = ((Iformfield *)b-&gt;i)-&gt;formfield;
	n = 0;
	item = nil;
	for(o=f-&gt;options; o!=nil; o=o-&gt;next){
		item = erealloc(item, ++n*sizeof(char *));
		if(o-&gt;display)
			item[n-1] = smprint("%S", o-&gt;display);
		else
			item[n-1] = estrdup("--");
	}
	if(item == nil)
		return;

	item[n] = 0;
	m.item = item;
	i = menuhit(but, mousectl, &amp;m, nil);
	if(i &gt;= 0){
		for(o=f-&gt;options; o!=nil; o=o-&gt;next, i--){
			if(i == 0)
				break;
		}
		((Iformfield *)b-&gt;i)-&gt;aux = o-&gt;display;
		drawselect(p-&gt;b, rectaddpt(rectsubpt(b-&gt;r, p-&gt;pos), p-&gt;r.min), (Iformfield *)b-&gt;i);
		if(f-&gt;value != nil)
			free(f-&gt;value);
		f-&gt;value = erunestrdup(o-&gt;value);
	}
	for(i=0; i&lt; n; i++)
		free(item[i]);
//	free(item);
}

static
void
mouseform(Box *b, Page *p, int but)
{
	Rectangle r, cr;
	Formfield *f;
	Text *t;

	f = ((Iformfield *)b-&gt;i)-&gt;formfield;
	r = rectaddpt(rectsubpt(b-&gt;r, p-&gt;pos), p-&gt;r.min);
	if(istextfield(b-&gt;i)){
		cr = p-&gt;b-&gt;clipr;
		replclipr(p-&gt;b, 0, p-&gt;r);
		t = ((Iformfield *)b-&gt;i)-&gt;aux;
		if(p-&gt;b != t-&gt;b)
			drawtextfield(p-&gt;b, r, (Iformfield *)b-&gt;i);
		textmouse(t, mouse-&gt;xy, but);
		if(f-&gt;value)
			free(f-&gt;value);
		f-&gt;value = runesmprint("%.*S", t-&gt;rs.nr, t-&gt;rs.r);
		replclipr(p-&gt;b, 0, cr);
		return;
	}

	if(but != 1)
		return;

	if(f-&gt;ftype==Fselect){
		selectmouse(b, p, but);
		return;
	}
	if(f-&gt;ftype==Fsubmit || f-&gt;ftype==Fimage){
		if(f-&gt;ftype == Fsubmit)
			drawbutton(p-&gt;b, r, f, TRUE);
		while(mouse-&gt;buttons == but)
			readmouse(mousectl);
		if(f-&gt;ftype == Fsubmit)
			drawbutton(p-&gt;b, r, f, FALSE);
		if(mouse-&gt;buttons==0 &amp;&amp; ptinrect(mouse-&gt;xy, r))
			submit(p, f, TRUE);
		return;
	}
	if(f-&gt;ftype==Fradio || f-&gt;ftype==Fcheckbox){
		if(f-&gt;flags&amp;FFchecked){
			if(f-&gt;ftype==Fcheckbox)
				f-&gt;flags &amp;=~FFchecked;
		}else{
			f-&gt;flags |= FFchecked;
		}
		if(f-&gt;ftype == Fradio)
			setradios(f);
		pageredraw(p);
	}
}

static
void
keyform(Box *b, Page *p, Rune r)
{
	Rectangle cr;
	Formfield *f;
	Text *t;

	f = ((Iformfield *)b-&gt;i)-&gt;formfield;
	if(r==L'\n' &amp;&amp; f-&gt;ftype==Ftext){
		submit(p, f, FALSE);
		return;
	}
	t = ((Iformfield *)b-&gt;i)-&gt;aux;
	cr = p-&gt;b-&gt;clipr;
	replclipr(p-&gt;b, 0, p-&gt;r);
	if(t-&gt;b != p-&gt;b)
		drawtextfield(p-&gt;b, rectaddpt(rectsubpt(b-&gt;r, p-&gt;pos), p-&gt;r.min), (Iformfield *)b-&gt;i);
	texttype(t, r);
	if(f-&gt;value)
		free(f-&gt;value);
	f-&gt;value = runesmprint("%.*S", t-&gt;rs.nr, t-&gt;rs.r);
	replclipr(p-&gt;b, 0, cr);
}

void
boxinit(Box *b)
{
	if(b-&gt;i-&gt;anchorid)
		b-&gt;mouse = mouselink;
	/* override mouselink for forms */
	if(b-&gt;i-&gt;tag == Iformfieldtag){
		b-&gt;mouse = mouseform;
		if(istextfield(b-&gt;i))
			b-&gt;key = keyform;
	}
	switch(b-&gt;i-&gt;tag){
	case Itexttag:
		b-&gt;draw = drawtext;
		break;
	case Iruletag:
		b-&gt;draw = drawrule;
		break;
	case Iimagetag:
		b-&gt;draw = drawimage;
		break;
	case Iformfieldtag:
		b-&gt;draw = drawformfield;
		break;
	case Itabletag:
		b-&gt;draw = drawtable;
		break;
	case Ifloattag:
		b-&gt;draw = drawnull;
		break;
	case Ispacertag:
		b-&gt;draw = drawnull;
	}
}

Box *
boxalloc(Line *l, Item *i, Rectangle r)
{
	Box *b;

	b = emalloc(sizeof(Box));
	b-&gt;i = i;
	b-&gt;r = r;
	if(l-&gt;boxes == nil)
		l-&gt;boxes = b;
	else{
		b-&gt;prev = l-&gt;lastbox;
		l-&gt;lastbox-&gt;next = b;
	}
	l-&gt;lastbox = b;

	return b;
}

Box *
pttobox(Line *l, Point xy)
{
	Box *b;

	for(b=l-&gt;boxes; b!=nil; b=b-&gt;next)
		if(ptinrect(xy, b-&gt;r))
			return b;

	return nil;
}

static
Line *
tbtoline(Itable *i, Point xy)
{
	Tablecell *c;

	for(c=i-&gt;table-&gt;cells; c!=nil; c=c-&gt;next)
		if(ptinrect(xy, c-&gt;lay-&gt;r))
			return linewhich(c-&gt;lay, xy);

	return nil;
}

Line *
linewhich(Lay *lay, Point xy)
{
	Line *l, *t;
	Box *b;

	t = nil;
	for(l=lay-&gt;lines; l!=nil; l=l-&gt;next)
		if(ptinrect(xy, l-&gt;r))
			break;

	if(l!=nil &amp;&amp; l-&gt;hastable){
		b = pttobox(l, xy);
		if(b!=nil &amp;&amp; b-&gt;i-&gt;tag==Itabletag)
			t = tbtoline((Itable *)b-&gt;i, xy);
	}
	return t? t: l;
}

Box *
boxwhich(Lay *lay, Point xy)
{
	Line *l;

	l = linewhich(lay, xy);
	if(l)
		return pttobox(l, xy);

	return nil;
}

static void justline1(Line *, int);

static
void
justlay(Lay *lay, int x)
{
	Line *l;

	lay-&gt;r.min.x += x;
	lay-&gt;r.max.x += x;

	for(l=lay-&gt;lines; l!=nil; l=l-&gt;next)
		justline1(l, x);
}

static
void
justtable(Itable *i, int x)
{
	Tablecell *c;

	for(c=i-&gt;table-&gt;cells; c!=nil; c=c-&gt;next)
		justlay(c-&gt;lay, x);
}

static
void
justline1(Line *l, int x)
{
	Box *b;

	l-&gt;r.min.x += x;
	l-&gt;r.max.x += x;
	for(b=l-&gt;boxes; b!=nil; b=b-&gt;next){
		if(b-&gt;i-&gt;tag == Itabletag)
			justtable((Itable *)b-&gt;i, x);
		b-&gt;r.min.x += x;
		b-&gt;r.max.x += x;
	}
}

static
void
justline(Lay *lay, Line *l)
{

	int w, x;

	w = Dx(l-&gt;r);
	if(w&gt;0 &amp;&amp; w&lt;lay-&gt;width){
		x = 0;
		if(l-&gt;state &amp; IFrjust)
			x = lay-&gt;width - w;
		else if(l-&gt;state &amp; IFcjust)
			x = lay-&gt;width/2 - w/2;
		if(x &gt; 0)
			justline1(l, x);
	}
}

static
void
newline(Lay *lay, int state)
{
	Line *l, *last;
	int indent, nl;

	last = lay-&gt;lastline;
	if(lay-&gt;laying == TRUE)
		justline(lay, last);

	lay-&gt;r.max.x = max(lay-&gt;r.max.x, last-&gt;r.max.x);
	lay-&gt;r.max.y = last-&gt;r.max.y;

	indent = ((state&amp;IFindentmask)&gt;&gt;IFindentshift) * Tabspace;
	nl = (state &amp; IFbrksp) ? 1 : 0;

	l = emalloc(sizeof(Line));
	l-&gt;state = state;
	l-&gt;hastext = FALSE;
	l-&gt;hastable = FALSE;
	l-&gt;r.min.x = lay-&gt;r.min.x + indent;
	l-&gt;r.min.y = last-&gt;r.max.y + font-&gt;height*nl;
	l-&gt;r.max = l-&gt;r.min;
	l-&gt;prev = last;
	last-&gt;next = l;
	lay-&gt;lastline = l;
}


static
void
layitem(Lay *lay, Item *i)
{
	Rectangle r;
	Line *l;
	Box *b;

	if(i-&gt;state&amp;IFbrk || i-&gt;state&amp;IFbrksp)
		newline(lay, i-&gt;state);
	else	if(lay-&gt;lastline-&gt;r.max.x+i-&gt;width&gt;lay-&gt;xwall &amp;&amp; forceitem(i)==FALSE)
		newline(lay, i-&gt;state);

	l = lay-&gt;lastline;
	r = Rect(l-&gt;r.max.x, l-&gt;r.min.y, l-&gt;r.max.x+i-&gt;width, l-&gt;r.min.y+i-&gt;height);
	l-&gt;r.max.x = r.max.x;
	if(l-&gt;r.max.y &lt; r.max.y)
		l-&gt;r.max.y = r.max.y;

	if(i-&gt;tag == Ifloattag)
		i = ((Ifloat *)i)-&gt;item;
	if(i-&gt;tag == Itexttag)
		l-&gt;hastext = TRUE;
	else if(i-&gt;tag == Itabletag &amp;&amp; lay-&gt;laying==TRUE){
		laytable((Itable *)i, r);
		l-&gt;hastable = TRUE;
	}
	b = boxalloc(l, i, r);
	if(lay-&gt;laying)
		boxinit(b);
}

static
void
linefix(Lay *lay)
{
	Line *l;

	for(l=lay-&gt;lines; l!=nil; l=l-&gt;next){
		l-&gt;r.min.x = lay-&gt;r.min.x;
		l-&gt;r.max.x = lay-&gt;r.max.x;
	}
}

Lay *
layitems(Item *items, Rectangle r, int laying)
{
	Lay *lay;
	Line *l;
	Item *i;

	lay = emalloc(sizeof(Lay));
	lay-&gt;r.min = r.min;
	lay-&gt;r.max = r.min;
	lay-&gt;xwall = r.max.x;
	lay-&gt;width = Dx(r);
	lay-&gt;laying = laying;
	l = emalloc(sizeof(Line));
	l-&gt;r.min = lay-&gt;r.min;
	l-&gt;r.max = lay-&gt;r.min;
	l-&gt;state = IFbrk;
	l-&gt;boxes = nil;
	lay-&gt;lines = l;
	lay-&gt;lastline = l;
	lay-&gt;font = font;

	for(i=items; i; i=i-&gt;next){
		sizeitem(lay, i);
		layitem(lay, i);
	}
	newline(lay, IFbrk);
	if(laying)
		linefix(lay);

	return lay;
}

void
laypage(Page *p)
{
	settables(p);
	layfree(p-&gt;lay);
	p-&gt;lay = layitems(p-&gt;items, Rect(0,0,Dx(p-&gt;r),Dy(p-&gt;r)), TRUE);
	p-&gt;lay-&gt;r.max.y = max(p-&gt;lay-&gt;r.max.y, Dy(p-&gt;r));
}

static
void
drawline(Page *p, Image *im, Line *l)
{
	Box *b;

	for(b=l-&gt;boxes; b!=nil; b=b-&gt;next)
		b-&gt;draw(b, p, im);
}

void
laydraw(Page *p, Image *im, Lay *lay)
{
	Rectangle r;
	Line *l;

	r = rectaddpt(p-&gt;lay-&gt;r, p-&gt;pos);
	for(l=lay-&gt;lines; l!=nil; l=l-&gt;next){
		if(rectXrect(r, l-&gt;r))
			drawline(p, im, l);
	}
}

static
void
laytablefree(Table *t)
{
	Tablecell *c;

	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		layfree(c-&gt;lay);
		c-&gt;lay = nil;
	}
}

void
layfree(Lay *lay)
{
	Line *l, *nextline;
	Box *b, *nextbox;
	void **aux;

	if(lay == nil)
		return;

	for(l=lay-&gt;lines; l!=nil; l=nextline){
		for(b=l-&gt;boxes; b!=nil; b=nextbox){
			nextbox = b-&gt;next;
			if(b-&gt;i-&gt;tag==Iformfieldtag &amp;&amp; istextfield(b-&gt;i)){
				aux = &amp;((Iformfield *)b-&gt;i)-&gt;aux;
				if(*aux){
					textclose(*aux);
					free(*aux);
				}
				*aux = nil;
			}else if(b-&gt;i-&gt;tag == Itabletag)
				laytablefree(((Itable *)b-&gt;i)-&gt;table);

			free(b);
		}
		nextline = l-&gt;next;
		free(l);
	}
	free(lay);
}

void
laysnarf(Page *p, Lay *lay, Runestr *rs)
{
	Tablecell *c;
	Itext *i;
	Font *f;
	Line *l;
	Box *b;
	int q0, q1, n;

	for(l=lay-&gt;lines; l!=nil; l=l-&gt;next) for(b=l-&gt;boxes; b!=nil; b=b-&gt;next){
		if(p-&gt;selecting &amp;&amp; hasbrk(b-&gt;i-&gt;state)){
			rs-&gt;r = runerealloc(rs-&gt;r, rs-&gt;nr+2);
			rs-&gt;r[rs-&gt;nr++] = L'\n';
			rs-&gt;r[rs-&gt;nr] = L'\0';
		}
		if(b-&gt;i-&gt;tag==Itexttag){
			i = (Itext *)b-&gt;i;
			f = getfont(i-&gt;fnt);
			if(istextsel(p, b-&gt;r, &amp;q0, &amp;q1, i-&gt;s, f)){
				if(q1 == 0)
					q1 = runestrlen(i-&gt;s);
				n = q1-q0;
				if(n == 0)
					n = runestrlen(i-&gt;s);
				rs-&gt;r = runerealloc(rs-&gt;r, rs-&gt;nr+n+2);
				runemove(rs-&gt;r+rs-&gt;nr, i-&gt;s+q0, n);
				rs-&gt;nr += n;
				rs-&gt;r[rs-&gt;nr++] = L' ';
				rs-&gt;r[rs-&gt;nr] = L'\0';
			}
		}else if(b-&gt;i-&gt;tag == Itabletag)
			for(c=((Itable *)b-&gt;i)-&gt;table-&gt;cells; c!=nil; c=c-&gt;next)
				if(c-&gt;lay)
					laysnarf(p, c-&gt;lay, rs);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

