<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/tabs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/tabs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

void
drawtable(Box *b, Page *p, Image *im)
{
	Rectangle r, cr;
	Tablecell *c;
	Table *t;

	t = ((Itable *)b-&gt;i)-&gt;table;
	r = rectsubpt(b-&gt;r, p-&gt;pos);
	draw(im, r, getcolor(t-&gt;background.color), nil, ZP);
	if(t-&gt;border)
		border(im, r, t-&gt;border, display-&gt;black, ZP);
	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		cr = rectsubpt(c-&gt;lay-&gt;r, p-&gt;pos);
		if(c-&gt;background.color != t-&gt;background.color)
			draw(im, cr, getcolor(c-&gt;background.color), nil, ZP);
		if(t-&gt;border)
			border(im, cr, t-&gt;border, display-&gt;black, ZP);
		laydraw(p, im,  c-&gt;lay);
	}
}

enum
{
	Tablemax = 2000,
	Ttoplevel = 1&lt;&lt;0,

};

static
void
settable(Table *t)
{
	Tablecell *c;
	Lay *lay;

	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		lay = layitems(c-&gt;content, Rect(0,0,0,0), FALSE);
		c-&gt;minw = Dx(lay-&gt;r);
		layfree(lay);
		if(dimenkind(c-&gt;wspec) == Dnone){
			lay = layitems(c-&gt;content, Rect(0,0,Tablemax,0), FALSE);
			c-&gt;maxw = Dx(lay-&gt;r);
			layfree(lay);
		}
	}
}

void
settables(Page *p)
{
	Table *t;
	Item *i;

	if(p-&gt;doc==nil)
		return;
	for(i=p-&gt;items; i!=nil; i=i-&gt;next)
		if(i-&gt;tag == Itabletag)
			((Itable *)i)-&gt;table-&gt;flags |= Ttoplevel;

	for(t=p-&gt;doc-&gt;tables; t!=nil; t=t-&gt;next)
		settable(t);
}

static
int
cellwidth(Table *t, Tablecell *c, int sep)
{
	int w, i, n;

	n = c-&gt;colspan;
	if(n == 1)
		return t-&gt;cols[c-&gt;col].width;
	if(n == 0)
		n = t-&gt;ncol - c-&gt;col;

	w = t-&gt;cellspacing*(n-1) + n*sep;
	for(i=c-&gt;col; i&lt;c-&gt;col+n; i++)
		w += t-&gt;cols[i].width;

	return w;
}

static
int
cellheight(Table *t, Tablecell *c, int sep)
{
	int h, i, n;

	n = c-&gt;rowspan;
	if(n == 1)
		return t-&gt;rows[c-&gt;row].height;
	if(n == 0)
		n = t-&gt;nrow - c-&gt;row;

	h = t-&gt;cellspacing*(n-1) + n*sep;
	for(i=c-&gt;row; i&lt;c-&gt;row+n; i++)
		h += t-&gt;rows[i].height;

	return h;
}

static
int
getwidth(int *w, int n)
{
	int i, tot;

	tot = 0;
	for(i=0; i&lt;n; i++)
		tot += w[i];

	return tot;
}

static
void
fixcols(Table *t, int *width, int sep, int domax)
{
	Tablecell *c;
	int w, aw, i, d, n, rem;


	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		if(c-&gt;colspan == 1)
			continue;

		n = c-&gt;colspan;
		if(n == 0)
			n = t-&gt;ncol - c-&gt;col;

		w = domax ? c-&gt;maxw : c-&gt;minw;
		w -= t-&gt;cellspacing*(n-1) + n*sep;

		aw = 0;
		for(i=c-&gt;col; i&lt;c-&gt;col+n; i++)
			aw += width[i];

		rem = w-aw;
		if(rem &lt;= 0)
			continue;

		for(i=c-&gt;col; i&lt;c-&gt;col+n; i++){
			if(aw &gt; 0){
				d = width[i]*100/aw;
				d = d*rem/100;
			}else
				d = rem/n;
			width[i] += d;
		}
	}
}

static
int
tablewidth(Table *t, int tw, int sep)
{
	Tablecell *c;
	int i, w, tmin, tmax, d;
	int *maxw, *minw;
	int totw;

	maxw = emalloc(sizeof(int)*t-&gt;ncol);
	minw = emalloc(sizeof(int)*t-&gt;ncol);
	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		if(dimenkind(c-&gt;wspec) != Dnone){
			d = c-&gt;minw;
			c-&gt;minw = c-&gt;maxw = max(dimwidth(c-&gt;wspec, tw), c-&gt;minw);
			c-&gt;minw = d;
		}
		if(c-&gt;colspan != 1)
			continue;
		maxw[c-&gt;col] = max(maxw[c-&gt;col], c-&gt;maxw);
		minw[c-&gt;col] = max(minw[c-&gt;col], c-&gt;minw);
	}
	totw = 0;
	fixcols(t, maxw, sep, TRUE);
	tmax = getwidth(maxw, t-&gt;ncol);
	if(tmax &lt;= tw){
		d = 0;
		if(tw&gt;tmax &amp;&amp; dimenkind(t-&gt;width)!=Dnone &amp;&amp; t-&gt;availw!=Tablemax)
			d = (tw-tmax)/t-&gt;ncol;
		for(i=0; i&lt;t-&gt;ncol; i++){
			t-&gt;cols[i].width = maxw[i] + d;
			totw += t-&gt;cols[i].width;
		}
	}else{
		fixcols(t, minw, sep, FALSE);
		tmin = getwidth(minw, t-&gt;ncol);
		w = tw - tmin;
		d = tmax - tmin;
		for(i=0; i&lt;t-&gt;ncol; i++){
			if(w&lt;=0 || d&lt;=0)
				t-&gt;cols[i].width = minw[i];
			else
				t-&gt;cols[i].width = minw[i] + (maxw[i] - minw[i])*w/d;
			totw += t-&gt;cols[i].width;
		}
	}
	free(minw);
	free(maxw);

	return totw;
}

static
void
fixrows(Table *t, int sep)
{
	Tablecell *c;
	Lay *lay;
	int h, ah, i, d, n, rem;

	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		if(c-&gt;rowspan == 1)
			continue;
		n = c-&gt;rowspan;
		if(n==0 || c-&gt;row+n&gt;t-&gt;nrow)
			n = t-&gt;nrow - c-&gt;row;

		lay = layitems(c-&gt;content, Rect(0,0,cellwidth(t, c, sep),0), FALSE);
		h = max(Dy(lay-&gt;r), c-&gt;hspec);
		layfree(lay);
		h -= t-&gt;cellspacing*(n-1) + n*sep;
		ah = 0;
		for(i=c-&gt;row; i&lt;c-&gt;row+n; i++)
			ah += t-&gt;rows[i].height;

		rem = h-ah;
		if(rem &lt;= 0)
			continue;

		for(i=c-&gt;row; i&lt;c-&gt;row+n; i++){
			if(ah &gt; 0){
				d = t-&gt;rows[i].height*100/ah;
				d = d*rem/100;
			}else
				d = rem/n;

			t-&gt;rows[i].height += d;
		}
	}
}

static
int
tableheight(Table *t, int sep)
{
	Tablecell *c;
	Lay *lay;
	int i, h, toth;

	for(i=0; i&lt;t-&gt;nrow; i++){
		h = 0;
		for(c=t-&gt;rows[i].cells; c!=nil; c=c-&gt;nextinrow){
			if(c-&gt;rowspan != 1)
				continue;
			lay = layitems(c-&gt;content, Rect(0, 0, cellwidth(t, c, sep), 0), FALSE);
			h = max(h, max(Dy(lay-&gt;r), c-&gt;hspec));
			layfree(lay);
		}
		t-&gt;rows[i].height = h;
	}
	fixrows(t, sep);
	toth = 0;
	for(i=0; i&lt;t-&gt;nrow; i++)
		toth += t-&gt;rows[i].height;

	return toth;
}

void
tablesize(Table *t, int availw)
{
	int w, sep, hsep, vsep;

	t-&gt;availw = availw;
	sep = 2*(t-&gt;border+t-&gt;cellpadding);
	hsep = t-&gt;cellspacing*(t-&gt;ncol+1) + 2*t-&gt;border + t-&gt;ncol*sep;
	vsep = t-&gt;cellspacing*(t-&gt;nrow+1) + 2*t-&gt;border + t-&gt;nrow*sep;
	w = dimwidth(t-&gt;width, availw);
	w -= hsep;
	w = w&gt;0 ? w : 0;
	t-&gt;totw = tablewidth(t, w, sep);
	t-&gt;totw += hsep;
	t-&gt;toth = tableheight(t, sep);
	t-&gt;toth += vsep;
}

void
laytable(Itable *it, Rectangle r)
{
	Rectangle cr;
	Tablecell *c;
	Table *t;
	int x, y, h, w;
	int sep, i;

	t = it-&gt;table;

	sep = (t-&gt;cellpadding+t-&gt;border) * 2;
	r = insetrect(r, t-&gt;cellspacing+t-&gt;border);
	for(c=t-&gt;cells; c!=nil; c=c-&gt;next){
		w = cellwidth(t, c, sep);
		h = cellheight(t, c, sep);
		x = r.min.x;
		if(c-&gt;col &gt; 0)
			for(i=0; i&lt;c-&gt;col; i++)
				x += t-&gt;cols[i].width + sep + t-&gt;cellspacing;
		y = r.min.y;
		if(c-&gt;row &gt; 0)
			for(i=0;i &lt;c-&gt;row; i++)
				y += t-&gt;rows[i].height + sep + t-&gt;cellspacing;
		cr = Rect(x, y, x+w+sep, y+h+sep);
		c-&gt;lay = layitems(c-&gt;content, insetrect(cr, sep/2), TRUE);
		c-&gt;lay-&gt;r = cr;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

