<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/text.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/text.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include "dat.h"
#include "fns.h"

Image	*tagcols[NCOL];
Image	*textcols[NCOL];


void
textinit(Text *t, Image *b, Rectangle r, Font *f, Image *cols[NCOL])
{
	t-&gt;all = r;
	t-&gt;scrollr = r;
	t-&gt;scrollr.max.x = r.min.x+Scrollsize;
	t-&gt;lastsr = ZR;
	r.min.x += Scrollsize+Scrollgap;
	t-&gt;rs.nr = 0;
	memmove(t-&gt;Frame.cols, cols, sizeof t-&gt;Frame.cols);
	textredraw(t, r, f, b);
}

void
textredraw(Text *t, Rectangle r, Font *f, Image *b)
{
	Rectangle r1;

	frinit(t, r, f, b, t-&gt;Frame.cols);
	r1 = t-&gt;r;
	r1.min.x -= Scrollsize+Scrollgap;	/* back fill to scroll bar */
	draw(t-&gt;b, r1, t-&gt;cols[BACK], nil, ZP);
	t-&gt;maxtab = Maxtab*stringwidth(f, "0");
	textfill(t);
	textsetselect(t, t-&gt;q0, t-&gt;q1);
}

int
textresize(Text *t, Image *b, Rectangle r)
{
	if(Dy(r) &gt; 0)
		r.max.y -= Dy(r)%t-&gt;font-&gt;height;
	else
		r.max.y = r.min.y;

	t-&gt;all = r;
	t-&gt;scrollr = r;
	t-&gt;scrollr.max.x = r.min.x+Scrollsize;
	t-&gt;lastsr = ZR;
	r.min.x += Scrollsize+Scrollgap;
	frclear(t, 0);
	textredraw(t, r, t-&gt;font, b);
	if(t-&gt;what == Textarea)
		textscrdraw(t);
	return r.max.y;
}

void
textclose(Text *t)
{
	closerunestr(&amp;t-&gt;rs);
	frclear(t, 1);
}

void
textinsert(Text *t, uint q0, Rune *r, uint n)
{
	if(n == 0)
		return;

	t-&gt;rs.r = runerealloc(t-&gt;rs.r, t-&gt;rs.nr+n);
	runemove(t-&gt;rs.r+q0+n, t-&gt;rs.r+q0, t-&gt;rs.nr-q0);
	runemove(t-&gt;rs.r+q0, r, n);
	t-&gt;rs.nr += n;
	if(q0 &lt; t-&gt;q1)
		t-&gt;q1 += n;
	if(q0 &lt; t-&gt;q0)
		t-&gt;q0 += n;
	if(q0 &lt; t-&gt;org)
		t-&gt;org += n;
	else if(q0 &lt;= t-&gt;org+t-&gt;nchars)
		frinsert(t, r, r+n, q0-t-&gt;org);
}

void
textfill(Text *t)
{
	Rune *rp;
	int i, n, m, nl;

	if(t-&gt;lastlinefull)
		return;
	rp = runemalloc(BUFSIZE*8);
	do{
		n = t-&gt;rs.nr-(t-&gt;org+t-&gt;nchars);
		if(n == 0)
			break;
		if(n &gt; 2000)	/* educated guess at reasonable amount */
			n = 2000;
		runemove(rp, t-&gt;rs.r+(t-&gt;org+t-&gt;nchars), n);
		/*
		 * it's expensive to frinsert more than we need, so
		 * count newlines.
		 */
		nl = t-&gt;maxlines-t-&gt;nlines;
		m = 0;
		for(i=0; i&lt;n; ){
			if(rp[i++] == '\n'){
				m++;
				if(m &gt;= nl)
					break;
			}
		}
		frinsert(t, rp, rp+i, t-&gt;nchars);
	}while(t-&gt;lastlinefull == FALSE);
	free(rp);
}

void
textdelete(Text *t, uint q0, uint q1)
{
	uint n, p0, p1;

	n = q1-q0;
	if(n == 0)
		return;

	runemove(t-&gt;rs.r+q0, t-&gt;rs.r+q1, t-&gt;rs.nr-q1);
	t-&gt;rs.nr -= n;
	if(q0 &lt; t-&gt;q0)
		t-&gt;q0 -= min(n, t-&gt;q0-q0);
	if(q0 &lt; t-&gt;q1)
		t-&gt;q1 -= min(n, t-&gt;q1-q0);
	if(q1 &lt;= t-&gt;org)
		t-&gt;org -= n;
	else if(q0 &lt; t-&gt;org+t-&gt;nchars){
		p1 = q1 - t-&gt;org;
		if(p1 &gt; t-&gt;nchars)
			p1 = t-&gt;nchars;
		if(q0 &lt; t-&gt;org){
			t-&gt;org = q0;
			p0 = 0;
		}else
			p0 = q0 - t-&gt;org;
		frdelete(t, p0, p1);
		textfill(t);
	}
	t-&gt;rs.r[t-&gt;rs.nr] = L'\0';
}

int
textbswidth(Text *t, Rune c)
{
	uint q, eq;
	Rune r;
	int skipping;

	/* there is known to be at least one character to erase */
	if(c == 0x08)	/* ^H: erase character */
		return 1;
	q = t-&gt;q0;
	skipping = TRUE;
	while(q &gt; 0){
		r = t-&gt;rs.r[q-1];
		if(r == '\n'){		/* eat at most one more character */
			if(q == t-&gt;q0)	/* eat the newline */
				--q;
			break;
		}
		if(c == 0x17){
			eq = isalnum(r);
			if(eq &amp;&amp; skipping)	/* found one; stop skipping */
				skipping = FALSE;
			else if(!eq &amp;&amp; !skipping)
				break;
		}
		--q;
	}
	return t-&gt;q0-q;
}

void
texttype(Text *t, Rune r)
{
	uint q0, q1;
	int nb, n;
	int nr;
	Rune *rp;

	if(t-&gt;what!=Textarea &amp;&amp; r=='\n'){
		if(t-&gt;what==Urltag)
			get(t, t, XXX, XXX, nil, 0);
		return;
	}
	if(t-&gt;what==Tag &amp;&amp; (r==Kscrollonedown || r==Kscrolloneup))
		return;

	nr = 1;
	rp = &amp;r;
	switch(r){
	case Kleft:
		if(t-&gt;q0 &gt; 0)
			textshow(t, t-&gt;q0-1, t-&gt;q0-1, TRUE);
		return;
	case Kright:
		if(t-&gt;q1 &lt; t-&gt;rs.nr)
			textshow(t, t-&gt;q1+1, t-&gt;q1+1, TRUE);
		return;
	case Kdown:
		n = t-&gt;maxlines/3;
		goto case_Down;
	case Kscrollonedown:
		n = mousescrollsize(t-&gt;maxlines);
		if(n &lt;= 0)
			n = 1;
		goto case_Down;
	case Kpgdown:
		n = 2*t-&gt;maxlines/3;
	case_Down:
		q0 = t-&gt;org+frcharofpt(t, Pt(t-&gt;r.min.x, t-&gt;r.min.y+n*t-&gt;font-&gt;height));
		textsetorigin(t, q0, TRUE);
		return;
	case Kup:
		n = t-&gt;maxlines/3;
		goto case_Up;
	case Kscrolloneup:
		n = mousescrollsize(t-&gt;maxlines);
		goto case_Up;
	case Kpgup:
		n = 2*t-&gt;maxlines/3;
	case_Up:
		q0 = textbacknl(t, t-&gt;org, n);
		textsetorigin(t, q0, TRUE);
		return;
	case Khome:
		textshow(t, 0, 0, FALSE);
		return;
	case Kend:
		textshow(t, t-&gt;rs.nr, t-&gt;rs.nr, FALSE);
		return;
	case 0x01:	/* ^A: beginning of line */
		/* go to where ^U would erase, if not already at BOL */
		nb = 0;
		if(t-&gt;q0&gt;0 &amp;&amp; t-&gt;rs.r[t-&gt;q0-1]!='\n')
			nb = textbswidth(t, 0x15);
		textshow(t, t-&gt;q0-nb, t-&gt;q0-nb, TRUE);
		return;
	case 0x05:	/* ^E: end of line */
		q0 = t-&gt;q0;
		while(q0&lt;t-&gt;rs.nr &amp;&amp; t-&gt;rs.r[q0]!='\n')
			q0++;
		textshow(t, q0, q0, TRUE);
		return;
	}
	if(t-&gt;q1 &gt; t-&gt;q0)
		cut(t, t, TRUE, TRUE, nil, 0);

	textshow(t, t-&gt;q0, t-&gt;q0, TRUE);
	switch(r){
	case 0x08:	/* ^H: erase character */
	case 0x15:	/* ^U: erase line */
	case 0x17:	/* ^W: erase word */
		if(t-&gt;q0 == 0)	/* nothing to erase */
			return;
		nb = textbswidth(t, r);
		q1 = t-&gt;q0;
		q0 = q1-nb;
		/* if selection is at beginning of window, avoid deleting invisible text */
		if(q0 &lt; t-&gt;org){
			q0 = t-&gt;org;
			nb = q1-q0;
		}
		if(nb &gt; 0){
			textdelete(t, q0, q0+nb);
			textsetselect(t, q0, q0);
		}
		return;
	}
	/* otherwise ordinary character; just insert */
	textinsert(t, t-&gt;q0, &amp;r, 1);
	if(rp != &amp;r)
		free(rp);
	textsetselect(t, t-&gt;q0+nr, t-&gt;q0+nr);
	if(t-&gt;what == Textarea)
		textscrdraw(t);
}

static	Text	*clicktext;
static	uint	clickmsec;
static	Text	*selecttext;
static	uint	selectq;

/*
 * called from frame library
 */
void
framescroll(Frame *f, int dl)
{
	if(f != &amp;selecttext-&gt;Frame)
		error("frameselect not right frame");
	textframescroll(selecttext, dl);
}

void
textframescroll(Text *t, int dl)
{
	uint q0;

	if(dl == 0){
		scrsleep(100);
		return;
	}
	if(dl &lt; 0){
		q0 = textbacknl(t, t-&gt;org, -dl);
		if(selectq &gt; t-&gt;org+t-&gt;p0)
			textsetselect(t, t-&gt;org+t-&gt;p0, selectq);
		else
			textsetselect(t, selectq, t-&gt;org+t-&gt;p0);
	}else{
		if(t-&gt;org+t-&gt;nchars == t-&gt;rs.nr)
			return;
		q0 = t-&gt;org+frcharofpt(t, Pt(t-&gt;r.min.x, t-&gt;r.min.y+dl*t-&gt;font-&gt;height));
		if(selectq &gt; t-&gt;org+t-&gt;p1)
			textsetselect(t, t-&gt;org+t-&gt;p1, selectq);
		else
			textsetselect(t, selectq, t-&gt;org+t-&gt;p1);
	}
	textsetorigin(t, q0, TRUE);
}

void
textselect(Text *t)
{
	uint q0, q1;
	int b, x, y;
	int state;

	selecttext = t;
	/*
	 * To have double-clicking and chording, we double-click
	 * immediately if it might make sense.
	 */
	b = mouse-&gt;buttons;
	q0 = t-&gt;q0;
	q1 = t-&gt;q1;
	selectq = t-&gt;org+frcharofpt(t, mouse-&gt;xy);
	if(clicktext==t &amp;&amp; mouse-&gt;msec-clickmsec&lt;500)
	if(q0==q1 &amp;&amp; selectq==q0){
		textdoubleclick(t, &amp;q0, &amp;q1);
		textsetselect(t, q0, q1);
		flushimage(display, 1);
		x = mouse-&gt;xy.x;
		y = mouse-&gt;xy.y;
		/* stay here until something interesting happens */
		do
			readmouse(mousectl);
		while(mouse-&gt;buttons==b &amp;&amp; abs(mouse-&gt;xy.x-x)&lt;3 &amp;&amp; abs(mouse-&gt;xy.y-y)&lt;3);
		mouse-&gt;xy.x = x;	/* in case we're calling frselect */
		mouse-&gt;xy.y = y;
		q0 = t-&gt;q0;	/* may have changed */
		q1 = t-&gt;q1;
		selectq = q0;
	}
	if(mouse-&gt;buttons == b){
		t-&gt;Frame.scroll = framescroll;
		frselect(t, mousectl);
		/* horrible botch: while asleep, may have lost selection altogether */
		if(selectq &gt; t-&gt;rs.nr)
			selectq = t-&gt;org + t-&gt;p0;
		t-&gt;Frame.scroll = nil;
		if(selectq &lt; t-&gt;org)
			q0 = selectq;
		else
			q0 = t-&gt;org + t-&gt;p0;
		if(selectq &gt; t-&gt;org+t-&gt;nchars)
			q1 = selectq;
		else
			q1 = t-&gt;org+t-&gt;p1;
	}
	if(q0 == q1){
		if(q0==t-&gt;q0 &amp;&amp; clicktext==t &amp;&amp; mouse-&gt;msec-clickmsec&lt;500){
			textdoubleclick(t, &amp;q0, &amp;q1);
			clicktext = nil;
		}else{
			clicktext = t;
			clickmsec = mouse-&gt;msec;
		}
	}else
		clicktext = nil;
	textsetselect(t, q0, q1);
	flushimage(display, 1);
	state = 0;	/* undo when possible; +1 for cut, -1 for paste */
	while(mouse-&gt;buttons){
		mouse-&gt;msec = 0;
		b = mouse-&gt;buttons;
		if((b&amp;1) &amp;&amp; (b&amp;6)){
			if(b &amp; 2){
				if(state==-1 &amp;&amp; t-&gt;what==Textarea){
					textsetselect(t, q0, t-&gt;q0);
					state = 0;
				}else if(state != 1){
					cut(t, t, TRUE, TRUE, nil, 0);
					state = 1;
				}
			}else{
				if(state==1 &amp;&amp; t-&gt;what==Textarea){
					textsetselect(t, q0, t-&gt;q1);
					state = 0;
				}else if(state != -1){
					paste(t, t, TRUE, FALSE, nil, 0);
					state = -1;
				}
			}
			textscrdraw(t);
		}
		flushimage(display, 1);
		while(mouse-&gt;buttons == b)
			readmouse(mousectl);
		clicktext = nil;
	}
}

void
textshow(Text *t, uint q0, uint q1, int doselect)
{
	int qe;
	int nl;
	uint q;

	if(t-&gt;what != Textarea){
		if(doselect)
			textsetselect(t, q0, q1);
		return;
	}
	if(doselect)
		textsetselect(t, q0, q1);
	qe = t-&gt;org+t-&gt;nchars;
	if(t-&gt;org&lt;=q0 &amp;&amp; (q0&lt;qe || (q0==qe &amp;&amp; qe==t-&gt;rs.nr)))
		textscrdraw(t);
	else{
		nl = t-&gt;maxlines/4;
		q = textbacknl(t, q0, nl);
		/* avoid going backwards if trying to go forwards - long lines! */
		if(!(q0&gt;t-&gt;org &amp;&amp; q&lt;t-&gt;org))
			textsetorigin(t, q, TRUE);
		while(q0 &gt; t-&gt;org+t-&gt;nchars)
			textsetorigin(t, t-&gt;org+1, FALSE);
	}
}

static
int
region(int a, int b)
{
	if(a &lt; b)
		return -1;
	if(a == b)
		return 0;
	return 1;
}

void
selrestore(Frame *f, Point pt0, uint p0, uint p1)
{
	if(p1&lt;=f-&gt;p0 || p0&gt;=f-&gt;p1){
		/* no overlap */
		frdrawsel0(f, pt0, p0, p1, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		return;
	}
	if(p0&gt;=f-&gt;p0 &amp;&amp; p1&lt;=f-&gt;p1){
		/* entirely inside */
		frdrawsel0(f, pt0, p0, p1, f-&gt;cols[HIGH], f-&gt;cols[HTEXT]);
		return;
	}

	/* they now are known to overlap */

	/* before selection */
	if(p0 &lt; f-&gt;p0){
		frdrawsel0(f, pt0, p0, f-&gt;p0, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		p0 = f-&gt;p0;
		pt0 = frptofchar(f, p0);
	}
	/* after selection */
	if(p1 &gt; f-&gt;p1){
		frdrawsel0(f, frptofchar(f, f-&gt;p1), f-&gt;p1, p1, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		p1 = f-&gt;p1;
	}
	/* inside selection */
	frdrawsel0(f, pt0, p0, p1, f-&gt;cols[HIGH], f-&gt;cols[HTEXT]);
}

void
textsetselect(Text *t, uint q0, uint q1)
{
	int p0, p1;

	/* t-&gt;p0 and t-&gt;p1 are always right; t-&gt;q0 and t-&gt;q1 may be off */
	t-&gt;q0 = q0;
	t-&gt;q1 = q1;
	/* compute desired p0,p1 from q0,q1 */
	p0 = q0-t-&gt;org;
	p1 = q1-t-&gt;org;
	if(p0 &lt; 0)
		p0 = 0;
	if(p1 &lt; 0)
		p1 = 0;
	if(p0 &gt; t-&gt;nchars)
		p0 = t-&gt;nchars;
	if(p1 &gt; t-&gt;nchars)
		p1 = t-&gt;nchars;
	if(p0==t-&gt;p0 &amp;&amp; p1==t-&gt;p1)
		return;
	/* screen disagrees with desired selection */
	if(t-&gt;p1&lt;=p0 || p1&lt;=t-&gt;p0 || p0==p1 || t-&gt;p1==t-&gt;p0){
		/* no overlap or too easy to bother trying */
		frdrawsel(t, frptofchar(t, t-&gt;p0), t-&gt;p0, t-&gt;p1, 0);
		frdrawsel(t, frptofchar(t, p0), p0, p1, 1);
		goto Return;
	}
	/* overlap; avoid unnecessary painting */
	if(p0 &lt; t-&gt;p0){
		/* extend selection backwards */
		frdrawsel(t, frptofchar(t, p0), p0, t-&gt;p0, 1);
	}else if(p0 &gt; t-&gt;p0){
		/* trim first part of selection */
		frdrawsel(t, frptofchar(t, t-&gt;p0), t-&gt;p0, p0, 0);
	}
	if(p1 &gt; t-&gt;p1){
		/* extend selection forwards */
		frdrawsel(t, frptofchar(t, t-&gt;p1), t-&gt;p1, p1, 1);
	}else if(p1 &lt; t-&gt;p1){
		/* trim last part of selection */
		frdrawsel(t, frptofchar(t, p1), p1, t-&gt;p1, 0);
	}

    Return:
	t-&gt;p0 = p0;
	t-&gt;p1 = p1;
}


/*
 * Release the button in less than DELAY ms and it's considered a null selection
 * if the mouse hardly moved, regardless of whether it crossed a char boundary.
 */
enum {
	DELAY = 2,
	MINMOVE = 4,
};

uint
xselect(Frame *f, Mousectl *mc, Image *col, uint *p1p)	/* when called, button is down */
{
	uint p0, p1, q, tmp;
	ulong msec;
	Point mp, pt0, pt1, qt;
	int reg, b;

	mp = mc-&gt;xy;
	b = mc-&gt;buttons;
	msec = mc-&gt;msec;

	/* remove tick */
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 0);
	p0 = p1 = frcharofpt(f, mp);
	pt0 = frptofchar(f, p0);
	pt1 = frptofchar(f, p1);
	reg = 0;
	frtick(f, pt0, 1);
	do{
		q = frcharofpt(f, mc-&gt;xy);
		if(p1 != q){
			if(p0 == p1)
				frtick(f, pt0, 0);
			if(reg != region(q, p0)){	/* crossed starting point; reset */
				if(reg &gt; 0)
					selrestore(f, pt0, p0, p1);
				else if(reg &lt; 0)
					selrestore(f, pt1, p1, p0);
				p1 = p0;
				pt1 = pt0;
				reg = region(q, p0);
				if(reg == 0)
					frdrawsel0(f, pt0, p0, p1, col, display-&gt;white);
			}
			qt = frptofchar(f, q);
			if(reg &gt; 0){
				if(q &gt; p1)
					frdrawsel0(f, pt1, p1, q, col, display-&gt;white);

				else if(q &lt; p1)
					selrestore(f, qt, q, p1);
			}else if(reg &lt; 0){
				if(q &gt; p1)
					selrestore(f, pt1, p1, q);
				else
					frdrawsel0(f, qt, q, p1, col, display-&gt;white);
			}
			p1 = q;
			pt1 = qt;
		}
		if(p0 == p1)
			frtick(f, pt0, 1);
		flushimage(f-&gt;display, 1);
		readmouse(mc);
	}while(mc-&gt;buttons == b);
	if(mc-&gt;msec-msec &lt; DELAY &amp;&amp; p0!=p1
	&amp;&amp; abs(mp.x-mc-&gt;xy.x)&lt;MINMOVE
	&amp;&amp; abs(mp.y-mc-&gt;xy.y)&lt;MINMOVE) {
		if(reg &gt; 0)
			selrestore(f, pt0, p0, p1);
		else if(reg &lt; 0)
			selrestore(f, pt1, p1, p0);
		p1 = p0;
	}
	if(p1 &lt; p0){
		tmp = p0;
		p0 = p1;
		p1 = tmp;
	}
	pt0 = frptofchar(f, p0);
	if(p0 == p1)
		frtick(f, pt0, 0);
	selrestore(f, pt0, p0, p1);
	/* restore tick */
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 1);
	flushimage(f-&gt;display, 1);
	*p1p = p1;
	return p0;
}

int
textselect23(Text *t, uint *q0, uint *q1, Image *high, int mask)
{
	uint p0, p1;
	int buts;

	p0 = xselect(t, mousectl, high, &amp;p1);
	buts = mousectl-&gt;buttons;
	if((buts &amp; mask) == 0){
		*q0 = p0+t-&gt;org;
		*q1 = p1+t-&gt;org;
	}

	while(mousectl-&gt;buttons)
		readmouse(mousectl);
	return buts;
}

int
textselect2(Text *t, uint *q0, uint *q1, Text **tp)
{
	int buts;

	*tp = nil;
	buts = textselect23(t, q0, q1, but2col, 4);
	if(buts &amp; 4)
		return 0;
	if(buts &amp; 1){	/* pick up argument */
		*tp = argtext;
		return 1;
	}
	return 1;
}

int
textselect3(Text *t, uint *q0, uint *q1)
{
	int h;

	h = (textselect23(t, q0, q1, but3col, 1|2) == 0);
	return h;
}

static Rune left1[] =  { L'{', L'[', L'(', L'&lt;', L'«', 0 };
static Rune right1[] = { L'}', L']', L')', L'&gt;', L'»', 0 };
static Rune left2[] =  { L'\n', 0 };
static Rune left3[] =  { L'\'', L'"', L'`', 0 };

static
Rune *left[] = {
	left1,
	left2,
	left3,
	nil
};
static
Rune *right[] = {
	right1,
	left2,
	left3,
	nil
};

void
textdoubleclick(Text *t, uint *q0, uint *q1)
{
	int c, i;
	Rune *r, *l, *p;
	uint q;

	if(t-&gt;rs.nr == 0)
		return;

	for(i=0; left[i]!=nil; i++){
		q = *q0;
		l = left[i];
		r = right[i];
		/* try matching character to left, looking right */
		if(q == 0)
			c = '\n';
		else
			c = t-&gt;rs.r[q-1];
		p = runestrchr(l, c);
		if(p != nil){
			if(textclickmatch(t, c, t-&gt;rs.r[p-l], 1, &amp;q))
				*q1 = q-(c!='\n');
			return;
		}
		/* try matching character to right, looking left */
		if(q == t-&gt;rs.nr)
			c = '\n';
		else
			c = t-&gt;rs.r[q];
		p = runestrchr(r, c);
		if(p != nil){
			if(textclickmatch(t, c, l[p-r], -1, &amp;q)){
				*q1 = *q0+(*q0&lt;t-&gt;rs.nr &amp;&amp; c=='\n');
				*q0 = q;
				if(c!='\n' || q!=0 || t-&gt;rs.r[0]=='\n')
					(*q0)++;
			}
			return;
		}
	}
	/* try filling out word to right */
	while(*q1&lt;t-&gt;rs.nr &amp;&amp; isalnum(t-&gt;rs.r[*q1]))
		(*q1)++;
	/* try filling out word to left */
	while(*q0&gt;0 &amp;&amp; isalnum(t-&gt;rs.r[*q0-1]))
		(*q0)--;
}

int
textclickmatch(Text *t, int cl, int cr, int dir, uint *q)
{
	Rune c;
	int nest;

	nest = 1;
	for(;;){
		if(dir &gt; 0){
			if(*q == t-&gt;rs.nr)
				break;
			c = t-&gt;rs.r[*q];
			(*q)++;
		}else{
			if(*q == 0)
				break;
			(*q)--;
			c = t-&gt;rs.r[*q];
		}
		if(c == cr){
			if(--nest==0)
				return 1;
		}else if(c == cl)
			nest++;
	}
	return cl=='\n' &amp;&amp; nest==1;
}

uint
textbacknl(Text *t, uint p, uint n)
{
	int i, j;

	/* look for start of this line if n==0 */
	if(n==0 &amp;&amp; p&gt;0 &amp;&amp; t-&gt;rs.r[p-1]!='\n')
		n = 1;
	i = n;
	while(i--&gt;0 &amp;&amp; p&gt;0){
		--p;	/* it's at a newline now; back over it */
		if(p == 0)
			break;
		/* at 128 chars, call it a line anyway */
		for(j=128; --j&gt;0 &amp;&amp; p&gt;0; p--)
			if(t-&gt;rs.r[p-1]=='\n')
				break;
	}
	return p;
}

void
textsetorigin(Text *t, uint org, int exact)
{
	int i, a, fixup;
	Rune *r;
	uint n;

	if(org&gt;0 &amp;&amp; !exact){
		/* org is an estimate of the char posn; find a newline */
		/* don't try harder than 256 chars */
		for(i=0; i&lt;256 &amp;&amp; org&lt;t-&gt;rs.nr; i++){
			if(t-&gt;rs.r[org] == '\n'){
				org++;
				break;
			}
			org++;
		}
	}
	a = org-t-&gt;org;
	fixup = 0;
	if(a&gt;=0 &amp;&amp; a&lt;t-&gt;nchars){
		frdelete(t, 0, a);
		fixup = 1;	/* frdelete can leave end of last line in wrong selection mode; it doesn't know what follows */
	}else if(a&lt;0 &amp;&amp; -a&lt;t-&gt;nchars){
		n = t-&gt;org - org;
		r = runemalloc(n);
		runemove(r, t-&gt;rs.r+org, n);
		frinsert(t, r, r+n, 0);
		free(r);
	}else
		frdelete(t, 0, t-&gt;nchars);
	t-&gt;org = org;
	textfill(t);
	textscrdraw(t);
	textsetselect(t, t-&gt;q0, t-&gt;q1);
	if(fixup &amp;&amp; t-&gt;p1 &gt; t-&gt;p0)
		frdrawsel(t, frptofchar(t, t-&gt;p1-1), t-&gt;p1-1, t-&gt;p1, 1);
}

void
textset(Text *t, Rune*r, int n)
{
	textdelete(t, 0, t-&gt;rs.nr);
	textinsert(t, 0, r, n);
	textsetselect(t, t-&gt;q0, t-&gt;q1);
}

void
textmouse(Text *t, Point xy, int but)
{
	Text *argt;
	uint q0, q1;

	if(ptinrect(xy, t-&gt;scrollr)){
		if(t-&gt;what == Columntag)
			rowdragcol(&amp;row, t-&gt;col, but);
		else if(t-&gt;what == Tag)
			coldragwin(t-&gt;col, t-&gt;w, but);
		else if(t-&gt;what == Textarea)
			textscroll(t, but);
		if(t-&gt;col)
			activecol = t-&gt;col;
		return;
	}
	if(but == 1){
		selpage = nil;
		textselect(t);
		argtext = t;
		seltext = t;
	}else if(but == 2){
		if(textselect2(t, &amp;q0, &amp;q1, &amp;argt))
			execute(t, q0, q1, argt);
	}else if(but == 3){
		if(textselect3(t, &amp;q0, &amp;q1))
			look3(t, q0, q1);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

