<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/abaco/util.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/abaco/util.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;plumb.h&gt;
#include &lt;html.h&gt;
#include &lt;regexp.h&gt;
#include "dat.h"
#include "fns.h"

static	Point		prevmouse;
static	Window	*mousew;

int
min(int a, int b)
{
	if(a &lt; b)
		return a;
	return b;
}

int
max(int a, int b)
{
	if(a &gt; b)
		return a;
	return b;
}

void
cvttorunes(char *p, int n, Rune *r, int *nb, int *nr, int *nulls)
{
	uchar *q;
	Rune *s;
	int j, w;

	/*
	 * Always guaranteed that n bytes may be interpreted
	 * without worrying about partial runes.  This may mean
	 * reading up to UTFmax-1 more bytes than n; the caller
	 * knows this.  If n is a firm limit, the caller should
	 * set p[n] = 0.
	 */
	q = (uchar*)p;
	s = r;
	for(j=0; j&lt;n; j+=w){
		if(*q &lt; Runeself){
			w = 1;
			*s = *q++;
		}else{
			w = chartorune(s, (char*)q);
			q += w;
		}
		if(*s)
			s++;
		else if(nulls)
			*nulls = TRUE;
	}
	*nb = (char*)q-p;
	*nr = s-r;
}

void
bytetorunestr(char *s, Runestr *rs)
{
	Rune *r;
	int nb, nr;

	nb = strlen(s);
	r = runemalloc(nb+1);
	cvttorunes(s, nb, r, &amp;nb, &amp;nr, nil);
	r[nr] = '\0';
	rs-&gt;nr = nr;
	rs-&gt;r = r;
}

void
error(char *s)
{
	fprint(2, "abaco: %s: %r\n", s);
//	abort();
	threadexitsall(s);
}

void*
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		error("malloc failed");
	setmalloctag(p, getcallerpc(&amp;n));
	memset(p, 0, n);
	return p;
}

void*
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(p == nil)
		error("realloc failed");
	setmalloctag(p, getcallerpc(&amp;n));
	return p;
}

Rune*
erunestrdup(Rune *r)
{
	void *p;

	if(r == nil)
		return nil;
	p = runestrdup(r);
	if(p == nil)
		error("runestrdup failed");
	setmalloctag(p, getcallerpc(&amp;r));
	return p;
}

char*
estrdup(char *s)
{
	char *t;

	t = strdup(s);
	if(t == nil)
		error("strdup failed");
	setmalloctag(t, getcallerpc(&amp;s));
	return t;
}

int
runestreq(Runestr a, Runestr b)
{
	return runeeq(a.r, a.nr, b.r, b.nr);
}

int
runeeq(Rune *s1, uint n1, Rune *s2, uint n2)
{
	if(n1 != n2)
		return FALSE;
	return memcmp(s1, s2, n1*sizeof(Rune)) == 0;
}

void
closerunestr(Runestr *rs)
{

	rs-&gt;nr = 0;
	if(rs-&gt;r)
		free(rs-&gt;r);
	rs-&gt;r = nil;
}

void
copyrunestr(Runestr *a, Runestr *b)
{
	closerunestr(a);
	a-&gt;r = runemalloc(b-&gt;nr+1);
	runemove(a-&gt;r, b-&gt;r, b-&gt;nr);
	a-&gt;r[b-&gt;nr] = 0;
	a-&gt;nr = b-&gt;nr;
}

int
isalnum(Rune c)
{
	/*
	 * Hard to get absolutely right.  Use what we know about ASCII
	 * and assume anything above the Latin control characters is
	 * potentially an alphanumeric.
	 */
	if(c &lt;= ' ')
		return FALSE;
	if(0x7F&lt;=c &amp;&amp; c&lt;=0xA0)
		return FALSE;
	if(utfrune("!\"#$%&amp;'()*+,-./:;&lt;=&gt;?@[\\]^`{|}~", c))
		return FALSE;
	return TRUE;
}

Rune*
skipbl(Rune *r, int n, int *np)
{
	while(n&gt;0 &amp;&amp; (*r==' ' || *r=='\t' || *r=='\n')){
		--n;
		r++;
	}
	*np = n;
	return r;
}

Rune*
findbl(Rune *r, int n, int *np)
{
	while(n&gt;0 &amp;&amp; *r!=' ' &amp;&amp; *r!='\t' &amp;&amp; *r!='\n'){
		--n;
		r++;
	}
	*np = n;
	return r;
}

int
istextfield(Item *i)
{
	Formfield *ff;

	ff = ((Iformfield *)i)-&gt;formfield;
	if(ff-&gt;ftype==Ftext || ff-&gt;ftype==Ftextarea || ff-&gt;ftype==Fpassword)
		return TRUE;

	return FALSE;
}

int
forceitem(Item *i)
{
	if(i-&gt;state&amp;IFwrap &amp;&amp; i-&gt;tag!=Iruletag &amp;&amp; i-&gt;tag!=Itabletag)
		return FALSE;

	return TRUE;
}

int
dimwidth(Dimen d, int w)
{
	int s, k;

	k = dimenkind(d);
	if(k == Dnone)
		return w;
	s = dimenspec(d);
	if(k == Dpixels)
		 w = s;
	else if(k==Dpercent &amp;&amp; s&lt;100)
		w = s*w/100;

	return w;
}

void
frdims(Dimen *d, int n, int t, int **ret)
{
	int totpix, totpcnt, totrel;
	double spix, spcnt, relu, vd;
	int tt, trest, totpixrel, minrelu, i;
	int *x, *spec, *kind;

	if(n == 1){
		*ret = x = emalloc(sizeof(int));
		x[0] = t;
		return;
	}
	totpix = totpcnt = totrel = 0;
	spec = emalloc(n*sizeof(int));
	kind = emalloc(n*sizeof(int));
	for(i=0; i&lt;n; i++){
		spec[i] = dimenspec(d[i]);
		if(spec[i] &lt; 0)
			spec[i] = 0;
		kind[i] = dimenkind(d[i]);
		switch(kind[i]){
		case Dpixels:
			totpix += spec[i];
			break;
		case Dpercent:
			totpcnt += spec[i];
			break;
		case Drelative:
			totrel += spec[i];
			break;
		case Dnone:
			totrel++;
			break;
		}
	}
	spix = spcnt = 1.0;
	minrelu = 0;
	if(totrel &gt; 0)
		minrelu = Scrollsize+Scrollgap;
	relu = (double)minrelu;
	tt = totpix + t*totpcnt/100 + totrel*minrelu;
	if(tt &lt; t){
		if(totrel == 0){
			if(totpcnt != 0)
				spcnt = (double)((t-totpix)*100)/(double)(t*totpcnt);
			else
				spix = (double)t/(double)totpix;
		}else
			relu += (double)(t-tt)/(double)totrel;
	}else{
		totpixrel = totpix + totrel*minrelu;
		if(totpixrel &lt; t)
			spcnt = (double)((t-totpixrel)*100)/(double)(t*totpcnt);
		else{
			trest = t - totrel*minrelu;
			if(trest &gt; 0)
				spcnt = (double)trest/(double)(totpix + (t*totpcnt/100));
			else{
				spcnt = (double)t/(double)tt;
				relu = 0.0;
			}
			spix = spcnt;
		}
	}
	x = emalloc(n * sizeof(int));
	tt = 0;
	for(i=0; i&lt;n-1; i++){
		vd = (double)spec[i];
		switch(kind[i]){
		case Dpixels:
			vd = vd*spix;
			break;
		case Dpercent:
			vd = vd*(double)t*spcnt/100.0;
			break;
		case Drelative:
			vd = vd*relu;
			break;
		case Dnone:
			vd = relu;
			break;
		}
		x[i] = (int)(vd+.5);
		tt += x[i];
	}
	x[n - 1] = t - tt;
	*ret = x;
	free(spec);
	free(kind);
}

Image *
getbg(Page *p)
{
	Docinfo *d;
	Cimage *ci;
	Image *bg;

	d = p-&gt;doc;
	if(d-&gt;backgrounditem){
		if(d-&gt;backgrounditem-&gt;aux){
			ci = d-&gt;backgrounditem-&gt;aux;
			if(ci-&gt;mi)
				getimage(ci, d-&gt;backgrounditem-&gt;altrep);
			bg = ci-&gt;i;
		}else
			bg = display-&gt;white;
	}else
		bg = getcolor(d-&gt;background.color);

	return bg;
}

Rune *
getbase(Page *p)
{
	if(p-&gt;doc)
		return p-&gt;doc-&gt;base;
	if(p-&gt;url-&gt;act.r)
		return p-&gt;url-&gt;act.r;
	return p-&gt;url-&gt;src.r;
}

Image *
eallocimage(Display *d, Rectangle r, ulong chan, int repl, int col)
{
	Image *i;

	i = allocimage(d, r, chan, repl, col);
	if(i == nil)
		error("allocimage failed");
	return i;
}

void
rect3d(Image *im, Rectangle r, int i, Image **c, Point sp)
{
	Point p[6];

	if(i &lt; 0){
		r = insetrect(r, i);
		sp = addpt(sp, Pt(i,i));
		i = -i;
	}
	draw(im, Rect(r.min.x+i, r.min.y+i, r.max.x-i, r.max.y-i), c[2], nil, sp);
	p[0] = r.min;
	p[1] = Pt(r.min.x, r.max.y);
	p[2] = Pt(r.min.x+i, r.max.y-i);
	p[3] = Pt(r.min.x+i, r.min.y+i);
	p[4] = Pt(r.max.x-i, r.min.y+i);
	p[5] = Pt(r.max.x, r.min.y);
	fillpoly(im, p, 6, 0, c[0], sp);
	p[0] = r.max;
	p[1] = Pt(r.min.x, r.max.y);
	p[2] = Pt(r.min.x+i, r.max.y-i);
	p[3] = Pt(r.max.x-i, r.max.y-i);
	p[4] = Pt(r.max.x-i, r.min.y+i);
	p[5] = Pt(r.max.x, r.min.y);
	fillpoly(im, p, 6, 0, c[1], sp);
}

void
ellipse3d(Image *im, Point p, int rad, int i, Image **c, Point sp)
{
	fillarc(im, p, rad, rad, c[0], sp, 45, 180);
	fillarc(im, p, rad, rad, c[1], sp,  45, -180);
	fillellipse(im, p, rad-i, rad-i, c[2], sp);
}

void
colarray(Image **c, Image *c0, Image *c1, Image *c2, int checked)
{
	if(checked){
		c[0] = c0;
		c[1] = c1;
	}else{
		c[0] = c1;
		c[1] = c0;
	}
	c[2] = c2;
}

static char *deffontpaths[] = {
#include "fonts.h"
};

static char *fontpaths[NumFnt];
static Font *fonts[NumFnt];

void
initfontpaths(void)
{
	Biobufhdr *bp;
	char buf[128];
	int i;

	/* we don't care if getenv(2) fails */
	snprint(buf, sizeof(buf)-1, "%s/lib/abaco.fonts", getenv("home"));
	if((bp=Bopen(buf, OREAD)) == nil)
		goto Default;

	for(i=0; i&lt;NumFnt; i++)
		if((fontpaths[i]=Brdstr(bp, '\n', 1)) == nil)
			goto Error;

	Bterm(bp);
	return;
Error:
	fprint(2, "abaco: not enough fontpaths in '%s'\n", buf);
	Bterm(bp);
	for(i--; i&gt;=0; i--)
		free(fontpaths[i]);
Default:
	for(i=0; i&lt;NumFnt; i++)
		fontpaths[i] = deffontpaths[i];
}

Font *
getfont(int i)
{
	if(fonts[i] == nil){
		fonts[i] = openfont(display, fontpaths[i]);
		if(fonts[i] == nil)
			error("can't open font file");
	}
	return fonts[i];
}

typedef struct Color Color;

struct Color {
	int	rgb;
	Image	*i;
	Color	*next;
};

enum {
	NHASH = 19,
};

static Color *colortab[NHASH];

Image *
getcolor(int rgb)
{
	Color *c;
	int h;

	if(rgb == 0xFFFFFF)
		return display-&gt;white;
	else if(rgb == 0x000000)
		return display-&gt;black;

	h = rgb%NHASH;
	for(c=colortab[h]; c!=nil; c=c-&gt;next)
		if(c-&gt;rgb == rgb){
			flushimage(display, 0);	/* BUG? */
			return c-&gt;i;
		}
	c = emalloc(sizeof(Color));
	c-&gt;i = eallocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, (rgb&lt;&lt;8)|0xFF);
	c-&gt;rgb = rgb;
	c-&gt;next = colortab[h];
	colortab[h] = c;

	return c-&gt;i;
}

int
plumbrunestr(Runestr *rs, char *attr)
{
	Plumbmsg *m;
	int i;

	i = -1;
	if(plumbsendfd &gt;= 0){
		m = emalloc(sizeof(Plumbmsg));
		m-&gt;src = estrdup("abaco");
		m-&gt;dst = nil;
		m-&gt;wdir = estrdup("/tmp");
		m-&gt;type = estrdup("text");
		if(attr)
			m-&gt;attr = plumbunpackattr(attr);
		else
			m-&gt;attr = nil;
		m-&gt;data = smprint("%.*S", rs-&gt;nr, rs-&gt;r);
		m-&gt;ndata = -1;
		i = plumbsend(plumbsendfd, m);
		plumbfree(m);
	}
	return i;
}

int
hexdigit(int v)
{
	if(0&lt;=v &amp;&amp; v&lt;=9)
		return '0' + v;
	else
		return 'A' + v - 10;
}

static int
inclass(char c, Rune* cl)
{
	int n, ans, negate, i;

	n = runestrlen(cl);
	if(n == 0)
		return 0;
	ans = 0;
	negate = 0;
	if(cl[0] == '^'){
		negate = 1;
		cl++;
		n--;
	}
	for(i=0; i&lt;n; i++){
		if(cl[i]=='-' &amp;&amp; i&gt;0 &amp;&amp; i&lt;n-1){
			if(c&gt;=cl[i - 1] &amp;&amp; c&lt;=cl[i+1]){
				ans = 1;
				break;
			}
			i++;
		}
		else if(c == cl[i]){
			ans = 1;
			break;
		}
	}
	if(negate)
		ans = !ans;
	return ans;
}

Rune*
ucvt(Rune* s)
{
	Rune* u;
	char *t;
	int i, c, n, j, len;

	t = smprint("%S", s);
	n = strlen(t);
	len = 0;
	for(i=0; i&lt;n; i++){
		c = t[i];
		if(inclass(c, L"- /$_@.!*'(),a-zA-Z0-9"))
			len++;
		else
			len += 3;
	}
	u = runemalloc(len+1);
	j = 0;

	for(i=0; i&lt;n; i++){
		c = t[i];
		if(inclass(c, L"-/$_@.!*'(),a-zA-Z0-9"))
			u[j++] = c;
		else if(c == ' ')
			u[j++] = '+';
		else {
			u[j++] = '%';
			u[j++] = hexdigit((c &gt;&gt; 4)&amp;15);
			u[j++] = hexdigit(c&amp;15);
		}
	}
	u[j] = 0;
	free(t);
	return u;
}

void
reverseimages(Iimage **head)
{
	Iimage *r, *c, *n;

	r = nil;
	for(c=*head; c!=nil; c=n){
		n = c-&gt;nextimage;
		c-&gt;nextimage = r;
		r = c;
	}
	*head = r;
}

char urlexpr[] = "^(https?|ftp|file|gopher|mailto|news|nntp|telnet|wais|"
	"prospero)://([a-zA-Z0-9_@\\-]+([.:][a-zA-Z0-9_@\\-]+)*)";
Reprog	*urlprog;

int
validurl(Rune *r)
{
	Resub rs[10];

	if(urlprog == nil){
		urlprog = regcomp(urlexpr);
		if(urlprog == nil)
			error("regcomp");
	}
	memset(rs, 0, sizeof(rs));
	if(rregexec(urlprog, r, rs, nelem(rs)) == 0)
		return FALSE;
	return TRUE;
}

void
execproc(void *v)
{
	Channel *sync;
	Exec *e;
	int p[2], q[2];
	char *cmd;

	threadsetname("execproc");
	e = v;
	p[0] = e-&gt;p[0];
	p[1] = e-&gt;p[1];
	q[0] = e-&gt;q[0];
	q[1] = e-&gt;q[1];
	cmd = e-&gt;cmd;
	sync = e-&gt;sync;
	rfork(RFFDG);
	free(e);
	dup(p[0], 0);
	close(p[0]);
	close(p[1]);
	if(q[0]){
		dup(q[1], 1);
		close(q[0]);
		close(q[1]);
	}
	if(!procstderr)
		close(2);
	procexecl(sync, "/bin/rc", "rc", "-c", cmd, 0);
	error("can't exec");
}

static void
writeproc(void *v)
{
	Channel *sync;
	void **a;
	char *s;
	long np;
	int fd, i, n;

	threadsetname("writeproc");
	a = v;
	sync = a[0];
	fd = (uintptr)a[1];
	s = a[2];
	np =(uintptr)a[3];
	free(a);

	for(i=0; i&lt;np; i+=n){
		n = np-i;
		if(n &gt; BUFSIZE)
			n = BUFSIZE;
		if(write(fd, s+i, n) != n)
			break;
	}
	close(fd);
	sendul(sync, i);
}

struct {
	char *mime;
	char *tcs;
}tcstab[] = {

#include "tcs.h"

	/* not generated by the script */
	"euc_jp", "jis",
	"euc_kr", "euc-k",
	"windows-874", "tis",
	nil,	nil,
};

enum {
	Winstart = 127,
	Winend = 159
};

static int winchars[] = {
	 8226,	/* 8226 is a bullet */
	8226, 8226, 8218, 402, 8222, 8230, 8224, 8225,
	710, 8240, 352, 8249, 338, 8226, 8226, 8226,
	8226, 8216, 8217, 8220, 8221, 8226, 8211, 8212,
	732, 8482, 353, 8250, 339, 8226, 8226, 376
};

char *
tcs(char *cs, char *s, long *np)
{
	Channel *sync;
	Exec *e;
	Rune r;
	long i, n;
	void **a;
	uchar *us;
	char buf[BUFSIZE], cmd[50];
	char *t, *u;
	int p[2], q[2];


	if(s==nil || *s=='\0' || *np==0){
		werrstr("tcs failed: no data");
		return s;
	}

	if(cs == nil){
		werrstr("tcs failed: no charset");
		return s;
	}

	if(cistrncmp(cs, "utf-8", 5)==0 || cistrncmp(cs, "utf8", 4)==0)
		return s;

	for(i=0; tcstab[i].mime!=nil; i++)
		if(cistrncmp(cs, tcstab[i].mime, strlen(tcstab[i].mime)) == 0)
			break;

	if(tcstab[i].mime == nil){
		fprint(2, "abaco: charset: %s not supported\n", cs);
		goto latin1;
	}
	if(cistrcmp(tcstab[i].tcs, "8859-1")==0 || cistrcmp(tcstab[i].tcs, "ascii")==0){
latin1:
		n = 0;
		for(us=(uchar*)s; *us; us++)
			n += runelen(*us);
		n++;
		t = emalloc(n);
		for(us=(uchar*)s, u=t; *us; us++){
			if(*us&gt;=Winstart &amp;&amp; *us&lt;=Winend)
				*u++ = winchars[*us-Winstart];
			else{
				r = *us;
				u += runetochar(u, &amp;r);
			}
		}
		*u = 0;
		free(s);
		return t;
	}

	if(pipe(p)&lt;0 || pipe(q)&lt;0)
		error("can't create pipe");

	sync = chancreate(sizeof(ulong), 0);
	if(sync == nil)
		error("can't create channel");

	snprint(cmd, sizeof cmd, "tcs -f %s", tcstab[i].tcs);
	e = emalloc(sizeof(Exec));
	e-&gt;p[0] = p[0];
	e-&gt;p[1] = p[1];
	e-&gt;q[0] = q[0];
	e-&gt;q[1] = q[1];
	e-&gt;cmd = cmd;
	e-&gt;sync = sync;
	proccreate(execproc, e, STACK);
	recvul(sync);
	chanfree(sync);
	close(p[0]);
	close(q[1]);

	/* in case tcs fails */
	t = s;
	sync = chancreate(sizeof(ulong), 0);
	if(sync == nil)
		error("can't create channel");

	a = emalloc(4*sizeof(void *));
	a[0] = sync;
	a[1] = (void *)p[1];
	a[2] = s;
	a[3] = (void *)*np;
	proccreate(writeproc, a, STACK);

	s = nil;
	while((n = read(q[0], buf, sizeof(buf))) &gt; 0){
		s = erealloc(s, i+n+1);
		memmove(s+i, buf, n);
		i += n;
		s[i] = '\0';
	}
	n = recvul(sync);
	if(n != *np)
		fprint(2, "tcs: did not write %ld; wrote %uld\n", *np, n);

	*np = i;
	chanfree(sync);
	close(q[0]);

	if(s == nil){
		fprint(2, "tcs failed: can't convert charset=%s to %s\n", cs, tcstab[i].tcs);
		return t;
	}
	free(t);

	return s;
}

static
int
isspace(char c)
{
	return c==' ' || c== '\t' || c=='\r' || c=='\n';
}

static
int
findctype(char *b, int l, char *keyword, char *s)
{
	char *p, *e;
	int i;

	p = cistrstr(s, keyword);
	if(!p)
		return -1;
	p += strlen(keyword);
	while(*p &amp;&amp; isspace(*p))
		p++;
	if(*p != '=')
		return -1;
	p++;
	while(*p &amp;&amp; isspace(*p))
		p++;
	if(!*p)
		return -1;
	if(*p == '"'){
		p++;
		e = strchr(p, '"');
		if(!e)
			return -1;
	}else
		for(e = p; *e &lt; 127 &amp;&amp; *e &gt; ' ' ; e++)
			;
	i = e-p;
	if(i &lt; 1)
		return -1;
	snprint(b, l, "%.*s", i, p);
	return 0;
}

static
int
finddocctype(char *b, int l, char *s)
{
	char *p, *e;

	p = cistrstr(s, "&lt;meta");
	if(!p)
		return -1;
	p += 5;
	e = strchr(s, '&gt;');
	if(!e)
		return -1;
	snprint(b, l, "%.*s", (int)(e-p), p);
	return 0;
}

static
int
findxmltype(char *b, int l, char *s)
{
	char *p, *e;

	p = cistrstr(s, "&lt;?xml ");
	if(!p)
		return -1;

	p += 6;
	e = strstr(p, "?&gt;");
	if(!e)
		return -1;
	snprint(b, l, "%.*s", (int)(e-p), p);

	return 0;
}

/*
 * servers can lie about lie about the charset,
 * so we use the charset based on the priority.
 */
char *
convert(Runestr ctype, char *s, long *np)
{
	char t[25], buf[256];

	*t = '\0';
	if(ctype.nr){
		snprint(buf, sizeof(buf), "%.*S", ctype.nr, ctype.r);
		findctype(t, sizeof(t), "charset", buf);
	}
	if(findxmltype(buf, sizeof(buf), s)==0)
		findctype(t, sizeof(t), "encoding", buf);
	if(finddocctype(buf, sizeof(buf), s) == 0)
		findctype(t, sizeof(t), "charset", buf);

	if(*t == '\0')
		strcpy(t, charset);
	return tcs(t, s, np);
}

int
xtofchar(Rune *s, Font *f, long p)
{
	Rune *r;
	int q;

	if(p == 0)
		return 0;

	q = 0;
	for(r=s; *r!=L'\0'; r++){
		p -= runestringnwidth(f, r, 1);
		if(p &lt; 0)
			break;
		q++;
	}
	return q;
}

int
istextsel(Page *p, Rectangle r, int *q0, int *q1, Rune *s, Font *f)
{
	int topinr, botinr;

	*q0 = *q1 = 0;
	topinr= ptinrect(p-&gt;top, r);
	if(topinr || (r.min.y&gt;p-&gt;top.y &amp;&amp; r.max.y&lt;p-&gt;bot.y))
		p-&gt;selecting = TRUE;
	botinr = ptinrect(p-&gt;bot, r);
	if(botinr || r.min.y&gt;p-&gt;bot.y)
		p-&gt;selecting = FALSE;

	if(topinr || botinr){
		if(topinr)
			*q0 = xtofchar(s, f, p-&gt;top.x-r.min.x);
		if(botinr)
			*q1 = xtofchar(s, f, p-&gt;bot.x-r.min.x);
		if(*q0!=0 || *q1!=0)
			return TRUE;
	}
	return p-&gt;selecting;
}

Point
getpt(Page *p, Point xy)
{
	xy.x = xy.x-p-&gt;r.min.x+p-&gt;pos.x;
	xy.y = xy.y-p-&gt;r.min.y+p-&gt;pos.y;

	return xy;
}

void
getimage(Cimage *ci, Rune *altr)
{
	Rectangle r;
	Memimage *mi;
	Image *i, *i2;
	char buf[128];
	uchar *bits;
	int nbits;

	mi = ci-&gt;mi;
	if(mi == nil){
		snprint(buf, sizeof(buf), "[%S]", altr ? altr : L"IMG");
		r.min = Pt(0, 0);
		r.max.x = 2*Space + stringwidth(font, buf);
		r.max.y = 2*Space + font-&gt;height;
		ci-&gt;i = eallocimage(display, r, GREY1, 1, DBlack);
		r.min.x += Space;
		r.min.y += Space;
		string(ci-&gt;i, r.min, display-&gt;white, ZP, font, buf);
		return;
	}
	nbits = bytesperline(mi-&gt;r, mi-&gt;depth)*Dy(mi-&gt;r);
	bits = emalloc(nbits);
	unloadmemimage(mi, mi-&gt;r, bits, nbits);
/*
	/* get rid of alpha channel from transparent gif * /

	if(mi-&gt;depth == 16){
		for(y=1; y&lt;nbits; y+=2)
			bits[y&gt;&gt;1] = bits[y];
	}
*/
	i = eallocimage(display, mi-&gt;r, mi-&gt;chan, 0, DNofill);
	loadimage(i, i-&gt;r, bits, nbits);
	i2 = eallocimage(display, i-&gt;r, RGB24, 1, DNofill);
	draw(i2, i2-&gt;r, display-&gt;black, nil, ZP);
	draw(i2, i2-&gt;r, i, nil, i-&gt;r.min);
	free(bits);
	freememimage(mi);
	freeimage(i);
	ci-&gt;i = i2;
	ci-&gt;mi = nil;
}

static
void
fixtext1(Item **list)
{
	Itext *text, *ntext;
	Item *it, *prev;
	Rune *s, *s1, *s2;
	int n;

	if(*list == nil)
		return;

	prev = nil;
	for(it=*list; it!=nil; it=prev-&gt;next){
		if(it-&gt;tag!=Itexttag || forceitem(it))
			goto Continue;

		text = (Itext *)it;
		s = text-&gt;s;
		while(*s &amp;&amp; isspacerune(*s))
			s++;
		if(!*s){
			if(prev == nil)
				prev = *list = it-&gt;next;
			else
				prev-&gt;next = it-&gt;next;

			it-&gt;next = nil;
			freeitems(it);
			if(prev == nil)
				return;
			continue;
		}
		n = 0;
		while(s[n] &amp;&amp; !isspacerune(s[n]))
			n++;

		if(!s[n])
			goto Continue;

		s1 = runemalloc(n+1);
		s1 = runemove(s1, s, n);
		s1[n] = L'\0';
		s += n;

		while(*s &amp;&amp; isspacerune(*s))
			s++;

		if(*s){
			n = runestrlen(s);
			s2 = runemalloc(n+1);
			runemove(s2, s, n);
			s2[n] = L'\0';
			ntext = emalloc(sizeof(Itext));
			ntext-&gt;s = s2;
			ntext-&gt;ascent = text-&gt;ascent;
			ntext-&gt;anchorid = text-&gt;anchorid;
			ntext-&gt;state = text-&gt;state&amp;~(IFbrk|IFbrksp|IFnobrk|IFcleft|IFcright);
			ntext-&gt;tag = text-&gt;tag;
			ntext-&gt;fnt = text-&gt;fnt;
			ntext-&gt;fg = text-&gt;fg;
			ntext-&gt;ul = text-&gt;ul;
			ntext-&gt;next = (Item *)text-&gt;next;
			text-&gt;next = (Item *)ntext;
		}
		free(text-&gt;s);
		text-&gt;s = s1;
    Continue:
		prev = it;
	}
}

void
fixtext(Page *p)
{
	Tablecell *c;
	Table *t;

	fixtext1(&amp;p-&gt;items);
	for(t=p-&gt;doc-&gt;tables; t!=nil; t=t-&gt;next)
		for(c=t-&gt;cells; c!=nil; c=c-&gt;next)
			fixtext1(&amp;c-&gt;content);
}

typedef struct Refresh Refresh;

struct Refresh
{
	Page *p;
	Refresh *next;
};

static Refresh *refreshs = nil;
static QLock refreshlock;

void
addrefresh(Page *p, char *fmt, ...)
{
	Refresh *r;
	Rune *s;
	va_list arg;

	if(p-&gt;aborting)
		return;

	va_start(arg, fmt);
	s = runevsmprint(fmt, arg);
	va_end(arg);
	if(s == nil)
		error("runevsmprint failed");

	if(p-&gt;status){
		free(p-&gt;status);
		p-&gt;status = nil;
	}
	p-&gt;status = s;
	qlock(&amp;refreshlock);
	for(r=refreshs; r!=nil; r=r-&gt;next)
		if(r-&gt;p == p)
			goto Return;

	incref(p-&gt;w);				/* flushrefresh will decref */
	r = emalloc(sizeof(Refresh));
	r-&gt;p = p;
	r-&gt;next = refreshs;
	refreshs = r;

    Return:
	nbsendp(crefresh, nil);
	qunlock(&amp;refreshlock);
}

/* called while row is locked */
void
flushrefresh(void)
{
	Refresh *r, *next;
	Page *p;

	qlock(&amp;refreshlock);
	for(r=refreshs; r!=nil; r=next){
		p = r-&gt;p;
		if(p-&gt;changed==TRUE &amp;&amp; p-&gt;aborting==FALSE){
			p-&gt;changed = FALSE;
			if(p-&gt;parent==nil || p-&gt;loading==FALSE)
				pagerender(p);
			if(!p-&gt;refresh.t)
				pagesetrefresh(p);
		}
		if(p-&gt;status){
			winsetstatus(p-&gt;w, p-&gt;status);
			free(p-&gt;status);
			p-&gt;status = nil;
		}
		winseturl(p-&gt;w);
		winsettag(p-&gt;w);
		decref(p-&gt;w);
		next = r-&gt;next;
		free(r);
	}
	refreshs = nil;
	qunlock(&amp;refreshlock);
}

void
savemouse(Window *w)
{
	prevmouse = mouse-&gt;xy;
	mousew = w;
}

void
restoremouse(Window *w)
{
	if(mousew!=nil &amp;&amp; mousew==w)
		moveto(mousectl, prevmouse);
	mousew = nil;
}

void
clearmouse()
{
	mousew = nil;
}

/*
 * Heuristic city.
 */
Window*
makenewwindow(Page *p)
{
	Column *c;
	Window *w, *bigw, *emptyw;
	Page *emptyp;
	int i, y, el;

	if(activecol)
		c = activecol;
	else if(selpage &amp;&amp; selpage-&gt;col)
		c = selpage-&gt;col;
	else if(p &amp;&amp; p-&gt;col)
		c = p-&gt;col;
	else{
		if(row.ncol==0 &amp;&amp; rowadd(&amp;row, nil, -1)==nil)
			error("can't make column");
		c = row.col[row.ncol-1];
	}
	activecol = c;
	if(p==nil || p-&gt;w==nil || c-&gt;nw==0)
		return coladd(c, nil, nil, -1);

	/* find biggest window and biggest blank spot */
	emptyw = c-&gt;w[0];
	bigw = emptyw;
	for(i=1; i&lt;c-&gt;nw; i++){
		w = c-&gt;w[i];
		/* use &gt;= to choose one near bottom of screen */
		if(Dy(w-&gt;page.all) &gt;= Dy(bigw-&gt;page.all))
			bigw = w;
		if(w-&gt;page.lay==nil &amp;&amp; Dy(w-&gt;page.all) &gt;= Dy(emptyw-&gt;page.all))
			emptyw = w;
	}
	emptyp = &amp;emptyw-&gt;page;
	el = Dy(emptyp-&gt;all);
	/* if empty space is big, use it */
	if(el&gt;15 || (el&gt;3 &amp;&amp; el&gt;(Dy(bigw-&gt;page.all)-1)/2))
		y = emptyp-&gt;all.max.y;
	else{
		/* if this window is in column and isn't much smaller, split it */
		if(p-&gt;col==c &amp;&amp; Dy(p-&gt;w-&gt;r)&gt;2*Dy(bigw-&gt;r)/3)
			bigw = p-&gt;w;
		y = (bigw-&gt;r.min.y + bigw-&gt;r.max.y)/2;
	}
	w = coladd(c, nil, nil, y);
	colgrow(w-&gt;col, w, 1);
	return w;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

