<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/dot.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/dot.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"

Type*
srch(Type *t, char *s)
{
	Type *f;

	f = 0;
	while(t) {
		if(strcmp(t-&gt;tag-&gt;name, s) == 0) {
			if(f == 0 || t-&gt;depth &lt; f-&gt;depth)
				f = t;
		}
		t = t-&gt;next;
	}
	return f;
}

void
odot(Node *n, Node *r)
{
	char *s;
	Type *t;
	Node res;
	uvlong addr;

	s = n-&gt;sym-&gt;name;
	if(s == 0)
		fatal("dodot: no tag");

	expr(n-&gt;left, &amp;res);
	if(res.comt == 0)
		error("no type specified for (expr).%s", s);

	if(res.type != TINT)
		error("pointer must be integer for (expr).%s", s);

	t = srch(res.comt, s);
	if(t == 0)
		error("no tag for (expr).%s", s);

	/* Propagate types */
	if(t-&gt;type) 
		r-&gt;comt = t-&gt;type-&gt;lt;
	
	addr = res.ival+t-&gt;offset;
	if(t-&gt;fmt == 'a') {
		r-&gt;op = OCONST;
		r-&gt;fmt = 'a';
		r-&gt;type = TINT;
		r-&gt;ival = addr;
	}
	else 
		indir(cormap, addr, t-&gt;fmt, r);

}

static Type **tail;
static Lsym *base;

void
buildtype(Node *m, int d)
{
	Type *t;

	if(m == ZN)
		return;

	switch(m-&gt;op) {
	case OLIST:
		buildtype(m-&gt;left, d);		
		buildtype(m-&gt;right, d);
		break;

	case OCTRUCT:
		buildtype(m-&gt;left, d+1);
		break;
	default:
		t = malloc(sizeof(Type));
		t-&gt;next = 0;
		t-&gt;depth = d;
		t-&gt;tag = m-&gt;sym;
		t-&gt;base = base;
		t-&gt;offset = m-&gt;ival;
		if(m-&gt;left) {
			t-&gt;type = m-&gt;left-&gt;sym;
			t-&gt;fmt = 'a';			
		}
		else {
			t-&gt;type = 0;
			if(m-&gt;right)
				t-&gt;type = m-&gt;right-&gt;sym;
			t-&gt;fmt = m-&gt;fmt;
		}

		*tail = t;
		tail = &amp;t-&gt;next;
	}			
}

void
defcomplex(Node *tn, Node *m)
{
	tail = &amp;tn-&gt;sym-&gt;lt;
	base = tn-&gt;sym;
	buildtype(m, 0);
}

void
decl(Node *n)
{
	Node *l;
	Value *v;
	Frtype *f;
	Lsym *type;

	type = n-&gt;sym;
	if(type-&gt;lt == 0)
		error("%s is not a complex type", type-&gt;name);

	l = n-&gt;left;
	if(l-&gt;op == ONAME) {
		v = l-&gt;sym-&gt;v;
		v-&gt;comt = type-&gt;lt;
		v-&gt;fmt = 'a';
		return;
	}

	/*
	 * Frame declaration
	 */
	for(f = l-&gt;sym-&gt;local; f; f = f-&gt;next) {
		if(f-&gt;var == l-&gt;left-&gt;sym) {
			f-&gt;type = n-&gt;sym-&gt;lt;
			return;
		}
	}
	f = malloc(sizeof(Frtype));
	if(f == 0)
		fatal("out of memory");

	f-&gt;type = type-&gt;lt;

	f-&gt;var = l-&gt;left-&gt;sym;
	f-&gt;next = l-&gt;sym-&gt;local;
	l-&gt;sym-&gt;local = f;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

