<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/expr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/expr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"

static int fsize[] =
{
	['A'] 4,
	['B'] 4,
	['C'] 1,
	['D'] 4,
	['F'] 8,
	['G'] 8,
	['O'] 4,
	['Q'] 4,
	['R'] 4,
	['S'] 4,
	['U'] 4,
	['V'] 8,
	['W'] 8,
	['X'] 4,
	['Y'] 8,
	['Z'] 8,
	['a'] 4,
	['b'] 1,
	['c'] 1,
	['d'] 2,
	['f'] 4,
	['g'] 4,
	['o'] 2,
	['q'] 2,
	['r'] 2,
	['s'] 4,
	['u'] 2,
	['x'] 2,
	['3'] 10,
	['8'] 10,
};

int
fmtsize(Value *v)
{
	int ret;

	switch(v-&gt;fmt) {
	default:
		return  fsize[v-&gt;fmt];
	case 'i':
	case 'I':
		if(v-&gt;type != TINT || machdata == 0)
			error("no size for i fmt pointer ++/--");
		ret = (*machdata-&gt;instsize)(cormap, v-&gt;ival);
		if(ret &lt; 0) {
			ret = (*machdata-&gt;instsize)(symmap, v-&gt;ival);
			if(ret &lt; 0)
				error("%r");
		}
		return ret;
	}
}

void
chklval(Node *lp)
{
	if(lp-&gt;op != ONAME)
		error("need l-value");
}

void
olist(Node *n, Node *res)
{
	expr(n-&gt;left, res);
	expr(n-&gt;right, res);
}

void
oeval(Node *n, Node *res)
{
	expr(n-&gt;left, res);
	if(res-&gt;type != TCODE)
		error("bad type for eval");
	expr(res-&gt;cc, res);
}

void
ocast(Node *n, Node *res)
{
	if(n-&gt;sym-&gt;lt == 0)
		error("%s is not a complex type", n-&gt;sym-&gt;name);

	expr(n-&gt;left, res);
	res-&gt;comt = n-&gt;sym-&gt;lt;
	res-&gt;fmt = 'a';
}

void
oindm(Node *n, Node *res)
{
	Map *m;
	Node l;

	m = cormap;
	if(m == 0)
		m = symmap;
	expr(n-&gt;left, &amp;l);
	if(l.type != TINT)
		error("bad type for *");
	if(m == 0)
		error("no map for *");
	indir(m, l.ival, l.fmt, res);
	res-&gt;comt = l.comt;
}

void
oindc(Node *n, Node *res)
{
	Map *m;
	Node l;

	m = symmap;
	if(m == 0)
		m = cormap;
	expr(n-&gt;left, &amp;l);
	if(l.type != TINT)
		error("bad type for @");
	if(m == 0)
		error("no map for @");
	indir(m, l.ival, l.fmt, res);
	res-&gt;comt = l.comt;
}

void
oframe(Node *n, Node *res)
{
	char *p;
	Node *lp;
	uvlong ival;
	Frtype *f;

	p = n-&gt;sym-&gt;name;
	while(*p &amp;&amp; *p == '$')
		p++;
	lp = n-&gt;left;
	if(localaddr(cormap, p, lp-&gt;sym-&gt;name, &amp;ival, rget) &lt; 0)
		error("colon: %r");

	res-&gt;ival = ival;
	res-&gt;op = OCONST;
	res-&gt;fmt = 'X';
	res-&gt;type = TINT;

	/* Try and set comt */
	for(f = n-&gt;sym-&gt;local; f; f = f-&gt;next) {
		if(f-&gt;var == lp-&gt;sym) {
			res-&gt;comt = f-&gt;type;
			res-&gt;fmt = 'a';
			break;
		}
	}
}

void
oindex(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);

	if(r.type != TINT)
		error("bad type for []");

	switch(l.type) {
	default:
		error("lhs[] has bad type");
	case TINT:
		indir(cormap, l.ival+(r.ival*fsize[l.fmt]), l.fmt, res);
		res-&gt;comt = l.comt;
		res-&gt;fmt = l.fmt;
		break;
	case TLIST:
		nthelem(l.l, r.ival, res);
		break;
	case TSTRING:
		res-&gt;ival = 0;
		if(r.ival &gt;= 0 &amp;&amp; r.ival &lt; l.string-&gt;len) {
			int xx8;	/* to get around bug in vc */
			xx8 = r.ival;
			res-&gt;ival = l.string-&gt;string[xx8];
		}
		res-&gt;op = OCONST;
		res-&gt;type = TINT;
		res-&gt;fmt = 'c';
		break;
	}
}

void
oappend(Node *n, Node *res)
{
	Value *v;
	Node r, l;
	int  empty;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	if(l.type != TLIST)
		error("must append to list");
	empty = (l.l == nil &amp;&amp; (n-&gt;left-&gt;op == ONAME));
	append(res, &amp;l, &amp;r);
	if(empty) {
		v = n-&gt;left-&gt;sym-&gt;v;
		v-&gt;type = res-&gt;type;
		v-&gt;Store = res-&gt;Store;
		v-&gt;comt = res-&gt;comt;
	}
}

void
odelete(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	if(l.type != TLIST)
		error("must delete from list");
	if(r.type != TINT)
		error("delete index must be integer");

	delete(l.l, r.ival, res);
}

void
ohead(Node *n, Node *res)
{
	Node l;

	expr(n-&gt;left, &amp;l);
	if(l.type != TLIST)
		error("head needs list");
	res-&gt;op = OCONST;
	if(l.l) {
		res-&gt;type = l.l-&gt;type;
		res-&gt;Store = l.l-&gt;Store;
	}
	else {
		res-&gt;type = TLIST;
		res-&gt;l = 0;
	}
}

void
otail(Node *n, Node *res)
{
	Node l;

	expr(n-&gt;left, &amp;l);
	if(l.type != TLIST)
		error("tail needs list");
	res-&gt;op = OCONST;
	res-&gt;type = TLIST;
	if(l.l)
		res-&gt;l = l.l-&gt;next;
	else
		res-&gt;l = 0;
}

void
oconst(Node *n, Node *res)
{
	res-&gt;op = OCONST;
	res-&gt;type = n-&gt;type;
	res-&gt;Store = n-&gt;Store;
	res-&gt;comt = n-&gt;comt;
}

void
oname(Node *n, Node *res)
{
	Value *v;

	v = n-&gt;sym-&gt;v;
	if(v-&gt;set == 0)
		error("%s used but not set", n-&gt;sym-&gt;name);
	res-&gt;op = OCONST;
	res-&gt;type = v-&gt;type;
	res-&gt;Store = v-&gt;Store;
	res-&gt;comt = v-&gt;comt;
}

void
octruct(Node *n, Node *res)
{
	res-&gt;op = OCONST;
	res-&gt;type = TLIST;
	res-&gt;l = construct(n-&gt;left);
}

void
oasgn(Node *n, Node *res)
{
	Node *lp, r;
	Value *v;

	lp = n-&gt;left;
	switch(lp-&gt;op) {
	case OINDM:
		windir(cormap, lp-&gt;left, n-&gt;right, res);
		break;
	case OINDC:
		windir(symmap, lp-&gt;left, n-&gt;right, res);
		break;
	default:
		chklval(lp);
		v = lp-&gt;sym-&gt;v;
		expr(n-&gt;right, &amp;r);
		v-&gt;set = 1;
		v-&gt;type = r.type;
		v-&gt;Store = r.Store;
		res-&gt;op = OCONST;
		res-&gt;type = v-&gt;type;
		res-&gt;Store = v-&gt;Store;
		res-&gt;comt = v-&gt;comt;
	}
}

void
oadd(Node *n, Node *res)
{
	Node l, r;

	if(n-&gt;right == nil){		/* unary + */
		expr(n-&gt;left, res);
		return;
	}
	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TFLOAT;
	switch(l.type) {
	default:
		error("bad lhs type +");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;type = TINT;
			res-&gt;ival = l.ival+r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.ival+r.fval;
			break;
		default:
			error("bad rhs type +");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;fval = l.fval+r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.fval+r.fval;
			break;
		default:
			error("bad rhs type +");
		}
		break;
	case TSTRING:
		if(r.type == TSTRING) {
			res-&gt;type = TSTRING;
			res-&gt;fmt = 's';
			res-&gt;string = stradd(l.string, r.string); 
			break;
		}
		if(r.type == TINT) {
			res-&gt;type = TSTRING;
			res-&gt;fmt = 's';
			res-&gt;string = straddrune(l.string, r.ival);
			break;
		}
		error("bad rhs for +");
	case TLIST:
		res-&gt;type = TLIST;
		switch(r.type) {
		case TLIST:
			res-&gt;l = addlist(l.l, r.l);
			break;
		default:
			r.left = 0;
			r.right = 0;
			res-&gt;l = addlist(l.l, construct(&amp;r));
			break;
		}
	}
}

void
osub(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TFLOAT;
	switch(l.type) {
	default:
		error("bad lhs type -");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;type = TINT;
			res-&gt;ival = l.ival-r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.ival-r.fval;
			break;
		default:
			error("bad rhs type -");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;fval = l.fval-r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.fval-r.fval;
			break;
		default:
			error("bad rhs type -");
		}
		break;
	}
}

void
omul(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TFLOAT;
	switch(l.type) {
	default:
		error("bad lhs type *");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;type = TINT;
			res-&gt;ival = l.ival*r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.ival*r.fval;
			break;
		default:
			error("bad rhs type *");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;fval = l.fval*r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.fval*r.fval;
			break;
		default:
			error("bad rhs type *");
		}
		break;
	}
}

void
odiv(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TFLOAT;
	switch(l.type) {
	default:
		error("bad lhs type /");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;type = TINT;
			if(r.ival == 0)
				error("zero divide");
			res-&gt;ival = l.ival/r.ival;
			break;
		case TFLOAT:
			if(r.fval == 0)
				error("zero divide");
			res-&gt;fval = l.ival/r.fval;
			break;
		default:
			error("bad rhs type /");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;fval = l.fval/r.ival;
			break;
		case TFLOAT:
			res-&gt;fval = l.fval/r.fval;
			break;
		default:
			error("bad rhs type /");
		}
		break;
	}
}

void
omod(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type %");
	res-&gt;ival = l.ival%r.ival;
}

void
olsh(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type &lt;&lt;");
	res-&gt;ival = l.ival&lt;&lt;r.ival;
}

void
orsh(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type &gt;&gt;");
	res-&gt;ival = (uvlong)l.ival&gt;&gt;r.ival;
}

void
olt(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);

	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	switch(l.type) {
	default:
		error("bad lhs type &lt;");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.ival &lt; r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.ival &lt; r.fval;
			break;
		default:
			error("bad rhs type &lt;");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.fval &lt; r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.fval &lt; r.fval;
			break;
		default:
			error("bad rhs type &lt;");
		}
		break;
	}
}

void
ogt(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = 'D';
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	switch(l.type) {
	default:
		error("bad lhs type &gt;");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.ival &gt; r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.ival &gt; r.fval;
			break;
		default:
			error("bad rhs type &gt;");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.fval &gt; r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.fval &gt; r.fval;
			break;
		default:
			error("bad rhs type &gt;");
		}
		break;
	}
}

void
oleq(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = 'D';
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	switch(l.type) {
	default:
		error("bad expr type &lt;=");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.ival &lt;= r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.ival &lt;= r.fval;
			break;
		default:
			error("bad expr type &lt;=");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.fval &lt;= r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.fval &lt;= r.fval;
			break;
		default:
			error("bad expr type &lt;=");
		}
		break;
	}
}

void
ogeq(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = 'D';
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	switch(l.type) {
	default:
		error("bad lhs type &gt;=");
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.ival &gt;= r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.ival &gt;= r.fval;
			break;
		default:
			error("bad rhs type &gt;=");
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.fval &gt;= r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.fval &gt;= r.fval;
			break;
		default:
			error("bad rhs type &gt;=");
		}
		break;
	}
}

void
oeq(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = 'D';
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	res-&gt;ival = 0;
	switch(l.type) {
	default:
		break;
	case TINT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.ival == r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.ival == r.fval;
			break;
		default:
			break;
		}
		break;
	case TFLOAT:
		switch(r.type) {
		case TINT:
			res-&gt;ival = l.fval == r.ival;
			break;
		case TFLOAT:
			res-&gt;ival = l.fval == r.fval;
			break;
		default:
			break;
		}
		break;
	case TSTRING:
		if(r.type == TSTRING) {
			res-&gt;ival = scmp(r.string, l.string);
			break;
		}
		break;
	case TLIST:
		if(r.type == TLIST) {
			res-&gt;ival = listcmp(l.l, r.l);
			break;
		}
		break;
	}
	if(n-&gt;op == ONEQ)
		res-&gt;ival = !res-&gt;ival;
}


void
oland(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type &amp;");
	res-&gt;ival = l.ival&amp;r.ival;
}

void
oxor(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type ^");
	res-&gt;ival = l.ival^r.ival;
}

void
olor(Node *n, Node *res)
{
	Node l, r;

	expr(n-&gt;left, &amp;l);
	expr(n-&gt;right, &amp;r);
	res-&gt;fmt = l.fmt;
	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	if(l.type != TINT || r.type != TINT)
		error("bad expr type |");
	res-&gt;ival = l.ival|r.ival;
}

void
ocand(Node *n, Node *res)
{
	Node l, r;

	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	res-&gt;ival = 0;
	res-&gt;fmt = 'D';
	expr(n-&gt;left, &amp;l);
	if(bool(&amp;l) == 0)
		return;
	expr(n-&gt;right, &amp;r);
	if(bool(&amp;r) == 0)
		return;
	res-&gt;ival = 1;
}

void
onot(Node *n, Node *res)
{
	Node l;

	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	res-&gt;ival = 0;
	expr(n-&gt;left, &amp;l);
	res-&gt;fmt = l.fmt;
	if(bool(&amp;l) == 0)
		res-&gt;ival = 1;
}

void
ocor(Node *n, Node *res)
{
	Node l, r;

	res-&gt;op = OCONST;
	res-&gt;type = TINT;
	res-&gt;ival = 0;
	res-&gt;fmt = 'D';
	expr(n-&gt;left, &amp;l);
	if(bool(&amp;l)) {
		res-&gt;ival = 1;
		return;
	}
	expr(n-&gt;right, &amp;r);
	if(bool(&amp;r)) {
		res-&gt;ival = 1;
		return;
	}
}

void
oeinc(Node *n, Node *res)
{
	Value *v;

	chklval(n-&gt;left);
	v = n-&gt;left-&gt;sym-&gt;v;
	res-&gt;op = OCONST;
	res-&gt;type = v-&gt;type;
	switch(v-&gt;type) {
	case TINT:
		if(n-&gt;op == OEDEC)
			v-&gt;ival -= fmtsize(v);
		else
			v-&gt;ival += fmtsize(v);
		break;			
	case TFLOAT:
		if(n-&gt;op == OEDEC)
			v-&gt;fval--;
		else
			v-&gt;fval++;
		break;
	default:
		error("bad type for pre --/++");
	}
	res-&gt;Store = v-&gt;Store;
}

void
opinc(Node *n, Node *res)
{
	Value *v;

	chklval(n-&gt;left);
	v = n-&gt;left-&gt;sym-&gt;v;
	res-&gt;op = OCONST;
	res-&gt;type = v-&gt;type;
	res-&gt;Store = v-&gt;Store;
	switch(v-&gt;type) {
	case TINT:
		if(n-&gt;op == OPDEC)
			v-&gt;ival -= fmtsize(v);
		else
			v-&gt;ival += fmtsize(v);
		break;			
	case TFLOAT:
		if(n-&gt;op == OPDEC)
			v-&gt;fval--;
		else
			v-&gt;fval++;
		break;
	default:
		error("bad type for post --/++");
	}
}

void
ocall(Node *n, Node *res)
{
	Lsym *s;
	Rplace *rsav;

	res-&gt;op = OCONST;		/* Default return value */
	res-&gt;type = TLIST;
	res-&gt;l = 0;

	chklval(n-&gt;left);
	s = n-&gt;left-&gt;sym;

	if(n-&gt;builtin &amp;&amp; !s-&gt;builtin){
		error("no builtin %s", s-&gt;name);
		return;
	}
	if(s-&gt;builtin &amp;&amp; (n-&gt;builtin || s-&gt;proc == 0)) {
		(*s-&gt;builtin)(res, n-&gt;right);
		return;
	}
	if(s-&gt;proc == 0)
		error("no function %s", s-&gt;name);

	rsav = ret;
	call(s-&gt;name, n-&gt;right, s-&gt;proc-&gt;left, s-&gt;proc-&gt;right, res);
	ret = rsav;
}

void
ofmt(Node *n, Node *res)
{
	expr(n-&gt;left, res);
	res-&gt;fmt = n-&gt;right-&gt;ival;
}

void
owhat(Node *n, Node *res)
{
	res-&gt;op = OCONST;		/* Default return value */
	res-&gt;type = TLIST;
	res-&gt;l = 0;
	whatis(n-&gt;sym);
}

void (*expop[])(Node*, Node*) =
{
	[ONAME]		oname,
	[OCONST]	oconst,
	[OMUL]		omul,
	[ODIV]		odiv,
	[OMOD]		omod,
	[OADD]		oadd,
	[OSUB]		osub,
	[ORSH]		orsh,
	[OLSH]		olsh,
	[OLT]		olt,
	[OGT]		ogt,
	[OLEQ]		oleq,
	[OGEQ]		ogeq,
	[OEQ]		oeq,
	[ONEQ]		oeq,
	[OLAND]		oland,
	[OXOR]		oxor,
	[OLOR]		olor,
	[OCAND]		ocand,
	[OCOR]		ocor,
	[OASGN]		oasgn,
	[OINDM]		oindm,
	[OEDEC]		oeinc,
	[OEINC]		oeinc,
	[OPINC]		opinc,
	[OPDEC]		opinc,
	[ONOT]		onot,
	[OIF]		0,
	[ODO]		0,
	[OLIST]		olist,
	[OCALL]		ocall,
	[OCTRUCT]	octruct,
	[OWHILE]	0,
	[OELSE]		0,
	[OHEAD]		ohead,
	[OTAIL]		otail,
	[OAPPEND]	oappend,
	[ORET]		0,
	[OINDEX]	oindex,
	[OINDC]		oindc,
	[ODOT]		odot,
	[OLOCAL]	0,
	[OFRAME]	oframe,
	[OCOMPLEX]	0,
	[ODELETE]	odelete,
	[OCAST]		ocast,
	[OFMT]		ofmt,
	[OEVAL]		oeval,
	[OWHAT]		owhat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

