<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acid/print.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acid/print.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "acid.h"

static char *binop[] =
{
	[OMUL]	"*",
	[ODIV]	"/",
	[OMOD]	"%",
	[OADD]	"+",
	[OSUB]	"-",
	[ORSH]	"&gt;&gt;",
	[OLSH]	"&lt;&lt;",
	[OLT]	"&lt;",
	[OGT]	"&gt;",
	[OLEQ]	"&lt;=",
	[OGEQ]	"&gt;=",
	[OEQ]	"==",
	[ONEQ]	"!=",
	[OLAND]	"&amp;",
	[OXOR]	"^",
	[OLOR]	"|",
	[OCAND]	"&amp;&amp;",
	[OCOR]	"||",
	[OASGN]	" = ",
};

static char *tabs = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
char *typenames[] =
{
	[TINT]		"integer",
	[TFLOAT]	"float",
	[TSTRING]	"string",
	[TLIST]		"list",
	[TCODE]		"code",
};

int
cmp(void *va, void *vb)
{
	char **a = va;
	char **b = vb;

	return strcmp(*a, *b);
}

void
fundefs(void)
{
	Lsym *l;
	char **vec;
	int i, j, n, max, col, f, g, s;

	max = 0;
	f = 0;
	g = 100;
	vec = malloc(sizeof(char*)*g);
	if(vec == 0)
		fatal("out of memory");

	for(i = 0; i &lt; Hashsize; i++) {
		for(l = hash[i]; l; l = l-&gt;hash) {
			if(l-&gt;proc == 0 &amp;&amp; l-&gt;builtin == 0)
				continue;
			n = strlen(l-&gt;name);
			if(n &gt; max)
				max = n;
			if(f &gt;= g) {
				g *= 2;
				vec = realloc(vec, sizeof(char*)*g);
				if(vec == 0)
					fatal("out of memory");
			}
			vec[f++] = l-&gt;name;
		}
	}
        qsort(vec, f, sizeof(char*), cmp);
	max++;
	col = 60/max;
	s = (f+col-1)/col;

	for(i = 0; i &lt; s; i++) {
		for(j = i; j &lt; f; j += s)
			Bprint(bout, "%-*s", max, vec[j]);
		Bprint(bout, "\n");
	}
}

void
whatis(Lsym *l)
{
	int t;
	int def;
	Type *ti;

	if(l == 0) {
		fundefs();
		return;
	}

	def = 0;
	if(l-&gt;v-&gt;set) {
		t = l-&gt;v-&gt;type;
		Bprint(bout, "%s variable", typenames[t]);
		if(t == TINT || t == TFLOAT)
			Bprint(bout, " format %c", l-&gt;v-&gt;fmt);
		if(l-&gt;v-&gt;comt)
			Bprint(bout, " complex %s", l-&gt;v-&gt;comt-&gt;base-&gt;name);
		Bputc(bout, '\n');
		def = 1;
	}
	if(l-&gt;lt) {
		Bprint(bout, "complex %s {\n", l-&gt;name);
		for(ti = l-&gt;lt; ti; ti = ti-&gt;next) {
			if(ti-&gt;type) {
				if(ti-&gt;fmt == 'a') {
					Bprint(bout, "\t%s %d %s;\n",
					ti-&gt;type-&gt;name, ti-&gt;offset,
					ti-&gt;tag-&gt;name);
				}
				else {
					Bprint(bout, "\t'%c' %s %d %s;\n",
					ti-&gt;fmt, ti-&gt;type-&gt;name, ti-&gt;offset,
					ti-&gt;tag-&gt;name);
				}
			}
			else
				Bprint(bout, "\t'%c' %d %s;\n",
				ti-&gt;fmt, ti-&gt;offset, ti-&gt;tag-&gt;name);
		}
		Bprint(bout, "};\n");
		def = 1;
	}
	if(l-&gt;proc) {
		Bprint(bout, "defn %s(", l-&gt;name);
		pexpr(l-&gt;proc-&gt;left);
		Bprint(bout, ") {\n");
		pcode(l-&gt;proc-&gt;right, 1);
		Bprint(bout, "}\n");
		def = 1;
	}
	if(l-&gt;builtin) {
		Bprint(bout, "builtin function\n");
		def = 1;
	}
	if(def == 0)
		Bprint(bout, "%s is undefined\n", l-&gt;name);
}

void
slist(Node *n, int d)
{
	if(n == 0)
		return;
	if(n-&gt;op == OLIST)
		Bprint(bout, "%.*s{\n", d-1, tabs);
	pcode(n, d);
	if(n-&gt;op == OLIST)
		Bprint(bout, "%.*s}\n", d-1, tabs);
}

void
pcode(Node *n, int d)
{
	Node *r, *l;

	if(n == 0)
		return;

	r = n-&gt;right;
	l = n-&gt;left;

	switch(n-&gt;op) {
	default:
		Bprint(bout, "%.*s", d, tabs);
		pexpr(n);
		Bprint(bout, ";\n");
		break;
	case OLIST:
		pcode(n-&gt;left, d);
		pcode(n-&gt;right, d);
		break;
	case OLOCAL:
		Bprint(bout, "%.*slocal", d, tabs);
		while(l) {
			Bprint(bout, " %s", l-&gt;sym-&gt;name);
			l = l-&gt;left;
			if(l == 0)
				Bprint(bout, ";\n");
			else
				Bprint(bout, ",");
		}
		break;
	case OCOMPLEX:
		Bprint(bout, "%.*scomplex %s %s;\n", d, tabs, n-&gt;sym-&gt;name, l-&gt;sym-&gt;name);
		break;
	case OIF:
		Bprint(bout, "%.*sif ", d, tabs);
		pexpr(l);
		d++;
		Bprint(bout, " then\n");
		if(r &amp;&amp; r-&gt;op == OELSE) {
			slist(r-&gt;left, d);
			Bprint(bout, "%.*selse\n", d-1, tabs);
			slist(r-&gt;right, d);
		}
		else
			slist(r, d);
		break;
	case OWHILE:
		Bprint(bout, "%.*swhile ", d, tabs);
		pexpr(l);
		d++;
		Bprint(bout, " do\n");
		slist(r, d);
		break;
	case ORET:
		Bprint(bout, "%.*sreturn ", d, tabs);
		pexpr(l);
		Bprint(bout, ";\n");
		break;
	case ODO:
		Bprint(bout, "%.*sloop ", d, tabs);
		pexpr(l-&gt;left);
		Bprint(bout, ", ");
		pexpr(l-&gt;right);
		Bprint(bout, " do\n");
		slist(r, d+1);
	}
}

void
pexpr(Node *n)
{
	Node *r, *l;

	if(n == 0)
		return;

	r = n-&gt;right;
	l = n-&gt;left;

	switch(n-&gt;op) {
	case ONAME:
		Bprint(bout, "%s", n-&gt;sym-&gt;name);
		break;
	case OCONST:
		switch(n-&gt;type) {
		case TINT:
			Bprint(bout, "%lld", n-&gt;ival);
			break;
		case TFLOAT:
			Bprint(bout, "%g", n-&gt;fval);
			break;
		case TSTRING:
			pstr(n-&gt;string);
			break;
		case TLIST:
			break;
		}
		break;
	case OMUL:
	case ODIV:
	case OMOD:
	case OADD:
	case OSUB:
	case ORSH:
	case OLSH:
	case OLT:
	case OGT:
	case OLEQ:
	case OGEQ:
	case OEQ:
	case ONEQ:
	case OLAND:
	case OXOR:
	case OLOR:
	case OCAND:
	case OCOR:
		Bputc(bout, '(');
		pexpr(l);
		Bprint(bout, binop[n-&gt;op]);
		pexpr(r);
		Bputc(bout, ')');
		break;
	case OASGN:
		pexpr(l);
		Bprint(bout, binop[n-&gt;op]);
		pexpr(r);
		break;
	case OINDM:
		Bprint(bout, "*");
		pexpr(l);
		break;
	case OEDEC:
		Bprint(bout, "--");
		pexpr(l);
		break;
	case OEINC:
		Bprint(bout, "++");
		pexpr(l);
		break;
	case OPINC:
		pexpr(l);
		Bprint(bout, "++");
		break;
	case OPDEC:
		pexpr(l);
		Bprint(bout, "--");
		break;
	case ONOT:
		Bprint(bout, "!");
		pexpr(l);
		break;
	case OLIST:
		pexpr(l);
		if(r) {
			Bprint(bout, ",");
			pexpr(r);
		}
		break;
	case OCALL:
		pexpr(l);
		Bprint(bout, "(");
		pexpr(r);
		Bprint(bout, ")");
		break;
	case OCTRUCT:
		Bprint(bout, "{");
		pexpr(l);
		Bprint(bout, "}");
		break;
	case OHEAD:
		Bprint(bout, "head ");
		pexpr(l);
		break;
	case OTAIL:
		Bprint(bout, "tail ");
		pexpr(l);
		break;
	case OAPPEND:
		Bprint(bout, "append ");
		pexpr(l);
		Bprint(bout, ",");
		pexpr(r);
		break;
	case ODELETE:
		Bprint(bout, "delete ");
		pexpr(l);
		Bprint(bout, ",");
		pexpr(r);
		break;
	case ORET:
		Bprint(bout, "return ");
		pexpr(l);
		break;
	case OINDEX:
		pexpr(l);
		Bprint(bout, "[");
		pexpr(r);
		Bprint(bout, "]");
		break;
	case OINDC:
		Bprint(bout, "@");
		pexpr(l);
		break;
	case ODOT:
		pexpr(l);
		Bprint(bout, ".%s", n-&gt;sym-&gt;name);
		break;
	case OFRAME:
		Bprint(bout, "%s:%s", n-&gt;sym-&gt;name, l-&gt;sym-&gt;name);
		break;
	case OCAST:
		Bprint(bout, "(%s)", n-&gt;sym-&gt;name);
		pexpr(l);
		break;
	case OFMT:
		pexpr(l);
		Bprint(bout, "\\%c", (int)r-&gt;ival);
		break;
	case OEVAL:
		Bprint(bout, "eval ");
		pexpr(l);
		break;
	case OWHAT:
		Bprint(bout, "whatis");
		if(n-&gt;sym)
			Bprint(bout, " %s", n-&gt;sym-&gt;name);
		break;
	}
}

void
pstr(String *s)
{
	int i, c;

	Bputc(bout, '"');
	for(i = 0; i &lt; s-&gt;len; i++) {
		c = s-&gt;string[i];
		switch(c) {
		case '\0':
			c = '0';
			break;
		case '\n':
			c = 'n';
			break;
		case '\r':
			c = 'r';
			break;
		case '\t':
			c = 't';
			break;
		case '\b':
			c = 'b';
			break;
		case '\f':
			c = 'f';
			break;
		case '\a':
			c = 'a';
			break;
		case '\v':
			c = 'v';
			break;
		case '\\':
			c = '\\';
			break;
		case '"':
			c = '"';
			break;
		default:
			Bputc(bout, c);
			continue;
		}
		Bputc(bout, '\\');
		Bputc(bout, c);
	}
	Bputc(bout, '"');
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

