<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/buff.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/buff.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

enum
{
	Slop = 100,	/* room to grow with reallocation */
};

static
void
sizecache(Buffer *b, uint n)
{
	if(n &lt;= b-&gt;cmax)
		return;
	b-&gt;cmax = n+Slop;
	b-&gt;c = runerealloc(b-&gt;c, b-&gt;cmax);
}

static
void
addblock(Buffer *b, uint i, uint n)
{
	if(i &gt; b-&gt;nbl)
		error("internal error: addblock");

	b-&gt;bl = realloc(b-&gt;bl, (b-&gt;nbl+1)*sizeof b-&gt;bl[0]);
	if(i &lt; b-&gt;nbl)
		memmove(b-&gt;bl+i+1, b-&gt;bl+i, (b-&gt;nbl-i)*sizeof(Block*));
	b-&gt;bl[i] = disknewblock(disk, n);
	b-&gt;nbl++;
}

static
void
delblock(Buffer *b, uint i)
{
	if(i &gt;= b-&gt;nbl)
		error("internal error: delblock");

	diskrelease(disk, b-&gt;bl[i]);
	b-&gt;nbl--;
	if(i &lt; b-&gt;nbl)
		memmove(b-&gt;bl+i, b-&gt;bl+i+1, (b-&gt;nbl-i)*sizeof(Block*));
	b-&gt;bl = realloc(b-&gt;bl, b-&gt;nbl*sizeof b-&gt;bl[0]);
}

/*
 * Move cache so b-&gt;cq &lt;= q0 &lt; b-&gt;cq+b-&gt;cnc.
 * If at very end, q0 will fall on end of cache block.
 */

static
void
flush(Buffer *b)
{
	if(b-&gt;cdirty || b-&gt;cnc==0){
		if(b-&gt;cnc == 0)
			delblock(b, b-&gt;cbi);
		else
			diskwrite(disk, &amp;b-&gt;bl[b-&gt;cbi], b-&gt;c, b-&gt;cnc);
		b-&gt;cdirty = FALSE;
	}
}

static
void
setcache(Buffer *b, uint q0)
{
	Block **blp, *bl;
	uint i, q;

	if(q0 &gt; b-&gt;nc)
		error("internal error: setcache");
	/*
	 * flush and reload if q0 is not in cache.
	 */
	if(b-&gt;nc == 0 || (b-&gt;cq&lt;=q0 &amp;&amp; q0&lt;b-&gt;cq+b-&gt;cnc))
		return;
	/*
	 * if q0 is at end of file and end of cache, continue to grow this block
	 */
	if(q0==b-&gt;nc &amp;&amp; q0==b-&gt;cq+b-&gt;cnc &amp;&amp; b-&gt;cnc&lt;Maxblock)
		return;
	flush(b);
	/* find block */
	if(q0 &lt; b-&gt;cq){
		q = 0;
		i = 0;
	}else{
		q = b-&gt;cq;
		i = b-&gt;cbi;
	}
	blp = &amp;b-&gt;bl[i];
	while(q+(*blp)-&gt;n &lt;= q0 &amp;&amp; q+(*blp)-&gt;n &lt; b-&gt;nc){
		q += (*blp)-&gt;n;
		i++;
		blp++;
		if(i &gt;= b-&gt;nbl)
			error("block not found");
	}
	bl = *blp;
	/* remember position */
	b-&gt;cbi = i;
	b-&gt;cq = q;
	sizecache(b, bl-&gt;n);
	b-&gt;cnc = bl-&gt;n;
	/*read block*/
	diskread(disk, bl, b-&gt;c, b-&gt;cnc);
}

void
bufinsert(Buffer *b, uint q0, Rune *s, uint n)
{
	uint i, m, t, off;

	if(q0 &gt; b-&gt;nc)
		error("internal error: bufinsert");

	while(n &gt; 0){
		setcache(b, q0);
		off = q0-b-&gt;cq;
		if(b-&gt;cnc+n &lt;= Maxblock){
			/* Everything fits in one block. */
			t = b-&gt;cnc+n;
			m = n;
			if(b-&gt;bl == nil){	/* allocate */
				if(b-&gt;cnc != 0)
					error("internal error: bufinsert1 cnc!=0");
				addblock(b, 0, t);
				b-&gt;cbi = 0;
			}
			sizecache(b, t);
			runemove(b-&gt;c+off+m, b-&gt;c+off, b-&gt;cnc-off);
			runemove(b-&gt;c+off, s, m);
			b-&gt;cnc = t;
			goto Tail;
		}
		/*
		 * We must make a new block.  If q0 is at
		 * the very beginning or end of this block,
		 * just make a new block and fill it.
		 */
		if(q0==b-&gt;cq || q0==b-&gt;cq+b-&gt;cnc){
			if(b-&gt;cdirty)
				flush(b);
			m = min(n, Maxblock);
			if(b-&gt;bl == nil){	/* allocate */
				if(b-&gt;cnc != 0)
					error("internal error: bufinsert2 cnc!=0");
				i = 0;
			}else{
				i = b-&gt;cbi;
				if(q0 &gt; b-&gt;cq)
					i++;
			}
			addblock(b, i, m);
			sizecache(b, m);
			runemove(b-&gt;c, s, m);
			b-&gt;cq = q0;
			b-&gt;cbi = i;
			b-&gt;cnc = m;
			goto Tail;
		}
		/*
		 * Split the block; cut off the right side and
		 * let go of it.
		 */
		m = b-&gt;cnc-off;
		if(m &gt; 0){
			i = b-&gt;cbi+1;
			addblock(b, i, m);
			diskwrite(disk, &amp;b-&gt;bl[i], b-&gt;c+off, m);
			b-&gt;cnc -= m;
		}
		/*
		 * Now at end of block.  Take as much input
		 * as possible and tack it on end of block.
		 */
		m = min(n, Maxblock-b-&gt;cnc);
		sizecache(b, b-&gt;cnc+m);
		runemove(b-&gt;c+b-&gt;cnc, s, m);
		b-&gt;cnc += m;
  Tail:
		b-&gt;nc += m;
		q0 += m;
		s += m;
		n -= m;
		b-&gt;cdirty = TRUE;
	}
}

void
bufdelete(Buffer *b, uint q0, uint q1)
{
	uint m, n, off;

	if(!(q0&lt;=q1 &amp;&amp; q0&lt;=b-&gt;nc &amp;&amp; q1&lt;=b-&gt;nc))
		error("internal error: bufdelete");
	while(q1 &gt; q0){
		setcache(b, q0);
		off = q0-b-&gt;cq;
		if(q1 &gt; b-&gt;cq+b-&gt;cnc)
			n = b-&gt;cnc - off;
		else
			n = q1-q0;
		m = b-&gt;cnc - (off+n);
		if(m &gt; 0)
			runemove(b-&gt;c+off, b-&gt;c+off+n, m);
		b-&gt;cnc -= n;
		b-&gt;cdirty = TRUE;
		q1 -= n;
		b-&gt;nc -= n;
	}
}

static int
bufloader(void *v, uint q0, Rune *r, int nr)
{
	bufinsert(v, q0, r, nr);
	return nr;
}

uint
loadfile(int fd, uint q0, int *nulls, int(*f)(void*, uint, Rune*, int), void *arg)
{
	char *p;
	Rune *r;
	int l, m, n, nb, nr;
	uint q1;

	p = emalloc((Maxblock+UTFmax+1)*sizeof p[0]);
	r = runemalloc(Maxblock);
	m = 0;
	n = 1;
	q1 = q0;
	/*
	 * At top of loop, may have m bytes left over from
	 * last pass, possibly representing a partial rune.
	 */
	while(n &gt; 0){
		n = read(fd, p+m, Maxblock);
		if(n &lt; 0){
			warning(nil, "read error in Buffer.load");
			break;
		}
		m += n;
		p[m] = 0;
		l = m;
		if(n &gt; 0)
			l -= UTFmax;
		cvttorunes(p, l, r, &amp;nb, &amp;nr, nulls);
		memmove(p, p+nb, m-nb);
		m -= nb;
		q1 += (*f)(arg, q1, r, nr);
	}
	free(p);
	free(r);
	return q1-q0;
}

uint
bufload(Buffer *b, uint q0, int fd, int *nulls)
{
	if(q0 &gt; b-&gt;nc)
		error("internal error: bufload");
	return loadfile(fd, q0, nulls, bufloader, b);
}

void
bufread(Buffer *b, uint q0, Rune *s, uint n)
{
	uint m;

	if(!(q0&lt;=b-&gt;nc &amp;&amp; q0+n&lt;=b-&gt;nc))
		error("bufread: internal error");

	while(n &gt; 0){
		setcache(b, q0);
		m = min(n, b-&gt;cnc-(q0-b-&gt;cq));
		runemove(s, b-&gt;c+(q0-b-&gt;cq), m);
		q0 += m;
		s += m;
		n -= m;
	}
}

void
bufreset(Buffer *b)
{
	int i;

	b-&gt;nc = 0;
	b-&gt;cnc = 0;
	b-&gt;cq = 0;
	b-&gt;cdirty = 0;
	b-&gt;cbi = 0;
	/* delete backwards to avoid n² behavior */
	for(i=b-&gt;nbl-1; --i&gt;=0; )
		delblock(b, i);
}

void
bufclose(Buffer *b)
{
	bufreset(b);
	free(b-&gt;c);
	b-&gt;c = nil;
	b-&gt;cnc = 0;
	free(b-&gt;bl);
	b-&gt;bl = nil;
	b-&gt;nbl = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

