<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/ecmd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/ecmd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "edit.h"
#include "fns.h"

int	Glooping;
int	nest;
char	Enoname[] = "no file name given";

Address	addr;
File	*menu;
Rangeset	sel;
extern	Text*	curtext;
Rune	*collection;
int	ncollection;

int	append(File*, Cmd*, long);
int	pdisplay(File*);
void	pfilename(File*);
void	looper(File*, Cmd*, int);
void	filelooper(Cmd*, int);
void	linelooper(File*, Cmd*);
Address	lineaddr(long, Address, int);
int	filematch(File*, String*);
File	*tofile(String*);
Rune*	cmdname(File *f, String *s, int);
void	runpipe(Text*, int, Rune*, int, int);

void
clearcollection(void)
{
	free(collection);
	collection = nil;
	ncollection = 0;
}

void
resetxec(void)
{
	Glooping = nest = 0;
	clearcollection();
}

void
mkaddr(Address *a, File *f)
{
	a-&gt;r.q0 = f-&gt;curtext-&gt;q0;
	a-&gt;r.q1 = f-&gt;curtext-&gt;q1;
	a-&gt;f = f;
}

int
cmdexec(Text *t, Cmd *cp)
{
	int i;
	Addr *ap;
	File *f;
	Window *w;
	Address dot;

	if(t == nil)
		w = nil;
	else
		w = t-&gt;w;
	if(w==nil &amp;&amp; (cp-&gt;addr==0 || cp-&gt;addr-&gt;type!='"') &amp;&amp;
	    !utfrune("bBnqUXY!", cp-&gt;cmdc) &amp;&amp;
	    !(cp-&gt;cmdc=='D' &amp;&amp; cp-&gt;text))
		editerror("no current window");
	i = cmdlookup(cp-&gt;cmdc);	/* will be -1 for '{' */
	f = nil;
	if(t &amp;&amp; t-&gt;w){
		t = &amp;t-&gt;w-&gt;body;
		f = t-&gt;file;
		f-&gt;curtext = t;
	}
	if(i&gt;=0 &amp;&amp; cmdtab[i].defaddr != aNo){
		if((ap=cp-&gt;addr)==0 &amp;&amp; cp-&gt;cmdc!='\n'){
			cp-&gt;addr = ap = newaddr();
			ap-&gt;type = '.';
			if(cmdtab[i].defaddr == aAll)
				ap-&gt;type = '*';
		}else if(ap &amp;&amp; ap-&gt;type=='"' &amp;&amp; ap-&gt;next==0 &amp;&amp; cp-&gt;cmdc!='\n'){
			ap-&gt;next = newaddr();
			ap-&gt;next-&gt;type = '.';
			if(cmdtab[i].defaddr == aAll)
				ap-&gt;next-&gt;type = '*';
		}
		if(cp-&gt;addr){	/* may be false for '\n' (only) */
			static Address none = {0,0,nil};
			if(f){
				mkaddr(&amp;dot, f);
				addr = cmdaddress(ap, dot, 0);
			}else	/* a " */
				addr = cmdaddress(ap, none, 0);
			f = addr.f;
			t = f-&gt;curtext;
		}
	}
	switch(cp-&gt;cmdc){
	case '{':
		mkaddr(&amp;dot, f);
		if(cp-&gt;addr != nil)
			dot = cmdaddress(cp-&gt;addr, dot, 0);
		for(cp = cp-&gt;cmd; cp; cp = cp-&gt;next){
			if(dot.r.q1 &gt; t-&gt;file-&gt;nc)
				editerror("dot extends past end of buffer during { command");
			t-&gt;q0 = dot.r.q0;
			t-&gt;q1 = dot.r.q1;
			cmdexec(t, cp);
		}
		break;
	default:
		if(i &lt; 0)
			editerror("unknown command %c in cmdexec", cp-&gt;cmdc);
		i = (*cmdtab[i].fn)(t, cp);
		return i;
	}
	return 1;
}

char*
edittext(Window *w, int q, Rune *r, int nr)
{
	File *f;

	f = w-&gt;body.file;
	switch(editing){
	case Inactive:
		return "permission denied";
	case Inserting:
		eloginsert(f, q, r, nr);
		return nil;
	case Collecting:
		collection = runerealloc(collection, ncollection+nr+1);
		runemove(collection+ncollection, r, nr);
		ncollection += nr;
		collection[ncollection] = '\0';
		return nil;
	default:
		return "unknown state in edittext";
	}
}

/* string is known to be NUL-terminated */
Rune*
filelist(Text *t, Rune *r, int nr)
{
	if(nr == 0)
		return nil;
	r = skipbl(r, nr, &amp;nr);
	if(r[0] != '&lt;')
		return runestrdup(r);
	/* use &lt; command to collect text */
	clearcollection();
	runpipe(t, '&lt;', r+1, nr-1, Collecting);
	return collection;
}

int
a_cmd(Text *t, Cmd *cp)
{
	return append(t-&gt;file, cp, addr.r.q1);
}

int
b_cmd(Text*, Cmd *cp)
{
	File *f;

	f = tofile(cp-&gt;text);
	if(nest == 0)
		pfilename(f);
	curtext = f-&gt;curtext;
	return TRUE;
}

int
B_cmd(Text *t, Cmd *cp)
{
	Rune *list, *r, *s;
	int nr;

	list = filelist(t, cp-&gt;text-&gt;r, cp-&gt;text-&gt;n);
	if(list == nil)
		editerror(Enoname);
	r = list;
	nr = runestrlen(r);
	r = skipbl(r, nr, &amp;nr);
	if(nr == 0)
		new(t, t, nil, 0, 0, r, 0);
	else while(nr &gt; 0){
		s = findbl(r, nr, &amp;nr);
		*s = '\0';
		new(t, t, nil, 0, 0, r, runestrlen(r));
		if(nr &gt; 0)
			r = skipbl(s+1, nr-1, &amp;nr);
	}
	clearcollection();
	return TRUE;
}

int
c_cmd(Text *t, Cmd *cp)
{
	elogreplace(t-&gt;file, addr.r.q0, addr.r.q1, cp-&gt;text-&gt;r, cp-&gt;text-&gt;n);
	t-&gt;q0 = addr.r.q0;
	t-&gt;q1 = addr.r.q0;
	return TRUE;
}

int
d_cmd(Text *t, Cmd*)
{
	if(addr.r.q1 &gt; addr.r.q0)
		elogdelete(t-&gt;file, addr.r.q0, addr.r.q1);
	t-&gt;q0 = addr.r.q0;
	t-&gt;q1 = addr.r.q0;
	return TRUE;
}

void
D1(Text *t)
{
	if(t-&gt;w-&gt;body.file-&gt;ntext&gt;1 || winclean(t-&gt;w, FALSE))
		colclose(t-&gt;col, t-&gt;w, TRUE);
}

int
D_cmd(Text *t, Cmd *cp)
{
	Rune *list, *r, *s, *n;
	int nr, nn;
	Window *w;
	Runestr dir, rs;
	char buf[128];

	list = filelist(t, cp-&gt;text-&gt;r, cp-&gt;text-&gt;n);
	if(list == nil){
		D1(t);
		return TRUE;
	}
	dir = dirname(t, nil, 0);
	r = list;
	nr = runestrlen(r);
	r = skipbl(r, nr, &amp;nr);
	do{
		s = findbl(r, nr, &amp;nr);
		*s = '\0';
		/* first time through, could be empty string, meaning delete file empty name */
		nn = runestrlen(r);
		if(r[0]=='/' || nn==0 || dir.nr==0){
			rs.r = runestrdup(r);
			rs.nr = nn;
		}else{
			n = runemalloc(dir.nr+1+nn);
			runemove(n, dir.r, dir.nr);
			n[dir.nr] = '/';
			runemove(n+dir.nr+1, r, nn);
			rs = cleanrname((Runestr){n, dir.nr+1+nn});
		}
		w = lookfile(rs.r, rs.nr);
		if(w == nil){
			snprint(buf, sizeof buf, "no such file %.*S", rs.nr, rs.r);
			free(rs.r);
			editerror(buf);
		}
		free(rs.r);
		D1(&amp;w-&gt;body);
		if(nr &gt; 0)
			r = skipbl(s+1, nr-1, &amp;nr);
	}while(nr &gt; 0);
	clearcollection();
	free(dir.r);
	return TRUE;
}

static int
readloader(void *v, uint q0, Rune *r, int nr)
{
	if(nr &gt; 0)
		eloginsert(v, q0, r, nr);
	return 0;
}

int
e_cmd(Text *t, Cmd *cp)
{
	Rune *name;
	File *f;
	int i, isdir, q0, q1, fd, nulls, samename, allreplaced;
	char *s, tmp[128];
	Dir *d;

	f = t-&gt;file;
	q0 = addr.r.q0;
	q1 = addr.r.q1;
	if(cp-&gt;cmdc == 'e'){
		if(winclean(t-&gt;w, TRUE)==FALSE)
			editerror("");	/* winclean generated message already */
		q0 = 0;
		q1 = f-&gt;nc;
	}
	allreplaced = (q0==0 &amp;&amp; q1==f-&gt;nc);
	name = cmdname(f, cp-&gt;text, cp-&gt;cmdc=='e');
	if(name == nil)
		editerror(Enoname);
	i = runestrlen(name);
	samename = runeeq(name, i, t-&gt;file-&gt;name, t-&gt;file-&gt;nname);
	s = runetobyte(name, i);
	free(name);
	fd = open(s, OREAD);
	if(fd &lt; 0){
		snprint(tmp, sizeof tmp, "can't open %s: %r", s);
		free(s);
		editerror(tmp);
	}
	d = dirfstat(fd);
	isdir = (d!=nil &amp;&amp; (d-&gt;qid.type&amp;QTDIR));
	free(d);
	if(isdir){
		close(fd);
		snprint(tmp, sizeof tmp, "%s is a directory", s);
		free(s);
		editerror(tmp);
	}
	elogdelete(f, q0, q1);
	nulls = 0;
	loadfile(fd, q1, &amp;nulls, readloader, f);
	free(s);
	close(fd);
	if(nulls)
		warning(nil, "%s: NUL bytes elided\n", s);
	else if(allreplaced &amp;&amp; samename)
		f-&gt;editclean = TRUE;
	return TRUE;
}

int
f_cmd(Text *t, Cmd *cp)
{
	Rune *name;
	String *str;
	String empty;

	if(cp-&gt;text == nil){
		empty.n = 0;
		empty.r = L"";
		str = &amp;empty;
	}else
		str = cp-&gt;text;
	name = cmdname(t-&gt;file, str, TRUE);
	free(name);
	pfilename(t-&gt;file);
	return TRUE;
}

int
g_cmd(Text *t, Cmd *cp)
{
	if(t-&gt;file != addr.f){
		warning(nil, "internal error: g_cmd f!=addr.f\n");
		return FALSE;
	}
	if(rxcompile(cp-&gt;re-&gt;r) == FALSE)
		editerror("bad regexp in g command");
	if(rxexecute(t, nil, addr.r.q0, addr.r.q1, &amp;sel) ^ cp-&gt;cmdc=='v'){
		t-&gt;q0 = addr.r.q0;
		t-&gt;q1 = addr.r.q1;
		return cmdexec(t, cp-&gt;cmd);
	}
	return TRUE;
}

int
i_cmd(Text *t, Cmd *cp)
{
	return append(t-&gt;file, cp, addr.r.q0);
}

void
copy(File *f, Address addr2)
{
	long p;
	int ni;
	Rune *buf;

	buf = fbufalloc();
	for(p=addr.r.q0; p&lt;addr.r.q1; p+=ni){
		ni = addr.r.q1-p;
		if(ni &gt; RBUFSIZE)
			ni = RBUFSIZE;
		bufread(f, p, buf, ni);
		eloginsert(addr2.f, addr2.r.q1, buf, ni);
	}
	fbuffree(buf);
}

void
move(File *f, Address addr2)
{
	if(addr.f!=addr2.f || addr.r.q1&lt;=addr2.r.q0){
		elogdelete(f, addr.r.q0, addr.r.q1);
		copy(f, addr2);
	}else if(addr.r.q0 &gt;= addr2.r.q1){
		copy(f, addr2);
		elogdelete(f, addr.r.q0, addr.r.q1);
	}else if(addr.r.q0==addr2.r.q0 &amp;&amp; addr.r.q1==addr2.r.q1){
		;	/* move to self; no-op */
	}else
		editerror("move overlaps itself");
}

int
m_cmd(Text *t, Cmd *cp)
{
	Address dot, addr2;

	mkaddr(&amp;dot, t-&gt;file);
	addr2 = cmdaddress(cp-&gt;mtaddr, dot, 0);
	if(cp-&gt;cmdc == 'm')
		move(t-&gt;file, addr2);
	else
		copy(t-&gt;file, addr2);
	return TRUE;
}

int
p_cmd(Text *t, Cmd*)
{
	return pdisplay(t-&gt;file);
}

int
s_cmd(Text *t, Cmd *cp)
{
	int i, j, k, c, m, n, nrp, didsub;
	long p1, op, delta;
	String *buf;
	Rangeset *rp;
	char *err;
	Rune *rbuf;

	n = cp-&gt;num;
	op= -1;
	if(rxcompile(cp-&gt;re-&gt;r) == FALSE)
		editerror("bad regexp in s command");
	nrp = 0;
	rp = nil;
	delta = 0;
	didsub = FALSE;
	for(p1 = addr.r.q0; p1&lt;=addr.r.q1 &amp;&amp; rxexecute(t, nil, p1, addr.r.q1, &amp;sel); ){
		if(sel.r[0].q0 == sel.r[0].q1){	/* empty match? */
			if(sel.r[0].q0 == op){
				p1++;
				continue;
			}
			p1 = sel.r[0].q1+1;
		}else
			p1 = sel.r[0].q1;
		op = sel.r[0].q1;
		if(--n&gt;0)
			continue;
		nrp++;
		rp = erealloc(rp, nrp*sizeof(Rangeset));
		rp[nrp-1] = sel;
	}
	rbuf = fbufalloc();
	buf = allocstring(0);
	for(m=0; m&lt;nrp; m++){
		buf-&gt;n = 0;
		buf-&gt;r[0] = L'\0';
		sel = rp[m];
		for(i = 0; i&lt;cp-&gt;text-&gt;n; i++)
			if((c = cp-&gt;text-&gt;r[i])=='\\' &amp;&amp; i&lt;cp-&gt;text-&gt;n-1){
				c = cp-&gt;text-&gt;r[++i];
				if('1'&lt;=c &amp;&amp; c&lt;='9') {
					j = c-'0';
					if(sel.r[j].q1-sel.r[j].q0&gt;RBUFSIZE){
						err = "replacement string too long";
						goto Err;
					}
					bufread(t-&gt;file, sel.r[j].q0, rbuf, sel.r[j].q1-sel.r[j].q0);
					for(k=0; k&lt;sel.r[j].q1-sel.r[j].q0; k++)
						Straddc(buf, rbuf[k]);
				}else
				 	Straddc(buf, c);
			}else if(c!='&amp;')
				Straddc(buf, c);
			else{
				if(sel.r[0].q1-sel.r[0].q0&gt;RBUFSIZE){
					err = "right hand side too long in substitution";
					goto Err;
				}
				bufread(t-&gt;file, sel.r[0].q0, rbuf, sel.r[0].q1-sel.r[0].q0);
				for(k=0; k&lt;sel.r[0].q1-sel.r[0].q0; k++)
					Straddc(buf, rbuf[k]);
			}
		elogreplace(t-&gt;file, sel.r[0].q0, sel.r[0].q1,  buf-&gt;r, buf-&gt;n);
		delta -= sel.r[0].q1-sel.r[0].q0;
		delta += buf-&gt;n;
		didsub = 1;
		if(!cp-&gt;flag)
			break;
	}
	free(rp);
	freestring(buf);
	fbuffree(rbuf);
	if(!didsub &amp;&amp; nest==0)
		editerror("no substitution");
	t-&gt;q0 = addr.r.q0;
	t-&gt;q1 = addr.r.q1;
	return TRUE;

Err:
	free(rp);
	freestring(buf);
	fbuffree(rbuf);
	editerror(err);
	return FALSE;
}

int
u_cmd(Text *t, Cmd *cp)
{
	int n, oseq, flag;

	n = cp-&gt;num;
	flag = TRUE;
	if(n &lt; 0){
		n = -n;
		flag = FALSE;
	}
	oseq = -1;
	while(n--&gt;0 &amp;&amp; t-&gt;file-&gt;seq!=0 &amp;&amp; t-&gt;file-&gt;seq!=oseq){
		oseq = t-&gt;file-&gt;seq;
		undo(t, nil, nil, flag, 0, nil, 0);
	}
	return TRUE;
}

int
w_cmd(Text *t, Cmd *cp)
{
	Rune *r;
	File *f;

	f = t-&gt;file;
	if(f-&gt;seq == seq)
		editerror("can't write file with pending modifications");
	r = cmdname(f, cp-&gt;text, FALSE);
	if(r == nil)
		editerror("no name specified for 'w' command");
	putfile(f, addr.r.q0, addr.r.q1, r, runestrlen(r));
	/* r is freed by putfile */
	return TRUE;
}

int
x_cmd(Text *t, Cmd *cp)
{
	if(cp-&gt;re)
		looper(t-&gt;file, cp, cp-&gt;cmdc=='x');
	else
		linelooper(t-&gt;file, cp);
	return TRUE;
}

int
X_cmd(Text*, Cmd *cp)
{
	filelooper(cp, cp-&gt;cmdc=='X');
	return TRUE;
}

void
runpipe(Text *t, int cmd, Rune *cr, int ncr, int state)
{
	Rune *r, *s;
	int n;
	Runestr dir;
	Window *w;

	r = skipbl(cr, ncr, &amp;n);
	if(n == 0)
		editerror("no command specified for %c", cmd);
	w = nil;
	if(state == Inserting){
		w = t-&gt;w;
		t-&gt;q0 = addr.r.q0;
		t-&gt;q1 = addr.r.q1;
		if(cmd == '&lt;' || cmd=='|')
			elogdelete(t-&gt;file, t-&gt;q0, t-&gt;q1);
	}
	s = runemalloc(n+2);
	s[0] = cmd;
	runemove(s+1, r, n);
	n++;
	dir.r = nil;
	dir.nr = 0;
	if(t != nil)
		dir = dirname(t, nil, 0);
	if(dir.nr==1 &amp;&amp; dir.r[0]=='.'){	/* sigh */
		free(dir.r);
		dir.r = nil;
		dir.nr = 0;
	}
	editing = state;
	if(t!=nil &amp;&amp; t-&gt;w!=nil)
		incref(t-&gt;w);	/* run will decref */
	run(w, runetobyte(s, n), dir.r, dir.nr, TRUE, nil, nil, TRUE);
	free(s);
	if(t!=nil &amp;&amp; t-&gt;w!=nil)
		winunlock(t-&gt;w);
	qunlock(&amp;row);
	recvul(cedit);
	qlock(&amp;row);
	editing = Inactive;
	if(t!=nil &amp;&amp; t-&gt;w!=nil)
		winlock(t-&gt;w, 'M');
}

int
pipe_cmd(Text *t, Cmd *cp)
{
	runpipe(t, cp-&gt;cmdc, cp-&gt;text-&gt;r, cp-&gt;text-&gt;n, Inserting);
	return TRUE;
}

long
nlcount(Text *t, long q0, long q1)
{
	long nl;
	Rune *buf;
	int i, nbuf;

	buf = fbufalloc();
	nbuf = 0;
	i = nl = 0;
	while(q0 &lt; q1){
		if(i == nbuf){
			nbuf = q1-q0;
			if(nbuf &gt; RBUFSIZE)
				nbuf = RBUFSIZE;
			bufread(t-&gt;file, q0, buf, nbuf);
			i = 0;
		}
		if(buf[i++] == '\n')
			nl++;
		q0++;
	}
	fbuffree(buf);
	return nl;
}

void
printposn(Text *t, int charsonly)
{
	long l1, l2;

	if (t != nil &amp;&amp; t-&gt;file != nil &amp;&amp; t-&gt;file-&gt;name != nil)
		warning(nil, "%.*S:", t-&gt;file-&gt;nname, t-&gt;file-&gt;name);
	if(!charsonly){
		l1 = 1+nlcount(t, 0, addr.r.q0);
		l2 = l1+nlcount(t, addr.r.q0, addr.r.q1);
		/* check if addr ends with '\n' */
		if(addr.r.q1&gt;0 &amp;&amp; addr.r.q1&gt;addr.r.q0 &amp;&amp; textreadc(t, addr.r.q1-1)=='\n')
			--l2;
		warning(nil, "%lud", l1);
		if(l2 != l1)
			warning(nil, ",%lud", l2);
		warning(nil, "\n");
		return;
	}
	warning(nil, "#%d", addr.r.q0);
	if(addr.r.q1 != addr.r.q0)
		warning(nil, ",#%d", addr.r.q1);
	warning(nil, "\n");
}

int
eq_cmd(Text *t, Cmd *cp)
{
	int charsonly;

	switch(cp-&gt;text-&gt;n){
	case 0:
		charsonly = FALSE;
		break;
	case 1:
		if(cp-&gt;text-&gt;r[0] == '#'){
			charsonly = TRUE;
			break;
		}
	default:
		SET(charsonly);
		editerror("newline expected");
	}
	printposn(t, charsonly);
	return TRUE;
}

int
nl_cmd(Text *t, Cmd *cp)
{
	Address a;
	File *f;

	f = t-&gt;file;
	if(cp-&gt;addr == 0){
		/* First put it on newline boundaries */
		mkaddr(&amp;a, f);
		addr = lineaddr(0, a, -1);
		a = lineaddr(0, a, 1);
		addr.r.q1 = a.r.q1;
		if(addr.r.q0==t-&gt;q0 &amp;&amp; addr.r.q1==t-&gt;q1){
			mkaddr(&amp;a, f);
			addr = lineaddr(1, a, 1);
		}
	}
	textshow(t, addr.r.q0, addr.r.q1, 1);
	return TRUE;
}

int
append(File *f, Cmd *cp, long p)
{
	if(cp-&gt;text-&gt;n &gt; 0)
		eloginsert(f, p, cp-&gt;text-&gt;r, cp-&gt;text-&gt;n);
	f-&gt;curtext-&gt;q0 = p;
	f-&gt;curtext-&gt;q1 = p;
	return TRUE;
}

int
pdisplay(File *f)
{
	long p1, p2;
	int np;
	Rune *buf;

	p1 = addr.r.q0;
	p2 = addr.r.q1;
	if(p2 &gt; f-&gt;nc)
		p2 = f-&gt;nc;
	buf = fbufalloc();
	while(p1 &lt; p2){
		np = p2-p1;
		if(np&gt;RBUFSIZE-1)
			np = RBUFSIZE-1;
		bufread(f, p1, buf, np);
		buf[np] = L'\0';
		warning(nil, "%S", buf);
		p1 += np;
	}
	fbuffree(buf);
	f-&gt;curtext-&gt;q0 = addr.r.q0;
	f-&gt;curtext-&gt;q1 = addr.r.q1;
	return TRUE;
}

void
pfilename(File *f)
{
	int dirty;
	Window *w;

	w = f-&gt;curtext-&gt;w;
	/* same check for dirty as in settag, but we know ncache==0 */
	dirty = !w-&gt;isdir &amp;&amp; !w-&gt;isscratch &amp;&amp; f-&gt;mod;
	warning(nil, "%c%c%c %.*S\n", " '"[dirty],
		'+', " ."[curtext!=nil &amp;&amp; curtext-&gt;file==f], f-&gt;nname, f-&gt;name);
}

void
loopcmd(File *f, Cmd *cp, Range *rp, long nrp)
{
	long i;

	for(i=0; i&lt;nrp; i++){
		f-&gt;curtext-&gt;q0 = rp[i].q0;
		f-&gt;curtext-&gt;q1 = rp[i].q1;
		cmdexec(f-&gt;curtext, cp);
	}
}

void
looper(File *f, Cmd *cp, int xy)
{
	long p, op, nrp;
	Range r, tr;
	Range *rp;

	r = addr.r;
	op= xy? -1 : r.q0;
	nest++;
	if(rxcompile(cp-&gt;re-&gt;r) == FALSE)
		editerror("bad regexp in %c command", cp-&gt;cmdc);
	nrp = 0;
	rp = nil;
	for(p = r.q0; p&lt;=r.q1; ){
		if(!rxexecute(f-&gt;curtext, nil, p, r.q1, &amp;sel)){ /* no match, but y should still run */
			if(xy || op&gt;r.q1)
				break;
			tr.q0 = op, tr.q1 = r.q1;
			p = r.q1+1;	/* exit next loop */
		}else{
			if(sel.r[0].q0==sel.r[0].q1){	/* empty match? */
				if(sel.r[0].q0==op){
					p++;
					continue;
				}
				p = sel.r[0].q1+1;
			}else
				p = sel.r[0].q1;
			if(xy)
				tr = sel.r[0];
			else
				tr.q0 = op, tr.q1 = sel.r[0].q0;
		}
		op = sel.r[0].q1;
		nrp++;
		rp = erealloc(rp, nrp*sizeof(Range));
		rp[nrp-1] = tr;
	}
	loopcmd(f, cp-&gt;cmd, rp, nrp);
	free(rp);
	--nest;
}

void
linelooper(File *f, Cmd *cp)
{
	long nrp, p;
	Range r, linesel;
	Address a, a3;
	Range *rp;

	nest++;
	nrp = 0;
	rp = nil;
	r = addr.r;
	a3.f = f;
	a3.r.q0 = a3.r.q1 = r.q0;
	a = lineaddr(0, a3, 1);
	linesel = a.r;
	for(p = r.q0; p&lt;r.q1; p = a3.r.q1){
		a3.r.q0 = a3.r.q1;
		if(p!=r.q0 || linesel.q1==p){
			a = lineaddr(1, a3, 1);
			linesel = a.r;
		}
		if(linesel.q0 &gt;= r.q1)
			break;
		if(linesel.q1 &gt;= r.q1)
			linesel.q1 = r.q1;
		if(linesel.q1 &gt; linesel.q0)
			if(linesel.q0&gt;=a3.r.q1 &amp;&amp; linesel.q1&gt;a3.r.q1){
				a3.r = linesel;
				nrp++;
				rp = erealloc(rp, nrp*sizeof(Range));
				rp[nrp-1] = linesel;
				continue;
			}
		break;
	}
	loopcmd(f, cp-&gt;cmd, rp, nrp);
	free(rp);
	--nest;
}

struct Looper
{
	Cmd *cp;
	int	XY;
	Window	**w;
	int	nw;
} loopstruct;	/* only one; X and Y can't nest */

void
alllooper(Window *w, void *v)
{
	Text *t;
	struct Looper *lp;
	Cmd *cp;

	lp = v;
	cp = lp-&gt;cp;
//	if(w-&gt;isscratch || w-&gt;isdir)
//		return;
	t = &amp;w-&gt;body;
	/* only use this window if it's the current window for the file */
	if(t-&gt;file-&gt;curtext != t)
		return;
//	if(w-&gt;nopen[QWevent] &gt; 0)
//		return;
	/* no auto-execute on files without names */
	if(cp-&gt;re==nil &amp;&amp; t-&gt;file-&gt;nname==0)
		return;
	if(cp-&gt;re==nil || filematch(t-&gt;file, cp-&gt;re)==lp-&gt;XY){
		lp-&gt;w = erealloc(lp-&gt;w, (lp-&gt;nw+1)*sizeof(Window*));
		lp-&gt;w[lp-&gt;nw++] = w;
	}
}

void
alllocker(Window *w, void *v)
{
	if(v)
		incref(w);
	else
		winclose(w);
}

void
filelooper(Cmd *cp, int XY)
{
	int i;

	if(Glooping++)
		editerror("can't nest %c command", "YX"[XY]);
	nest++;

	loopstruct.cp = cp;
	loopstruct.XY = XY;
	if(loopstruct.w)	/* error'ed out last time */
		free(loopstruct.w);
	loopstruct.w = nil;
	loopstruct.nw = 0;
	allwindows(alllooper, &amp;loopstruct);
	/*
	 * add a ref to all windows to keep safe windows accessed by X
	 * that would not otherwise have a ref to hold them up during
	 * the shenanigans.  note this with globalincref so that any
	 * newly created windows start with an extra reference.
	 */
	allwindows(alllocker, (void*)1);
	globalincref = 1;
	for(i=0; i&lt;loopstruct.nw; i++)
		cmdexec(&amp;loopstruct.w[i]-&gt;body, cp-&gt;cmd);
	allwindows(alllocker, (void*)0);
	globalincref = 0;
	free(loopstruct.w);
	loopstruct.w = nil;

	--Glooping;
	--nest;
}

void
nextmatch(File *f, String *r, long p, int sign)
{
	if(rxcompile(r-&gt;r) == FALSE)
		editerror("bad regexp in command address");
	if(sign &gt;= 0){
		if(!rxexecute(f-&gt;curtext, nil, p, 0x7FFFFFFFL, &amp;sel))
			editerror("no match for regexp");
		if(sel.r[0].q0==sel.r[0].q1 &amp;&amp; sel.r[0].q0==p){
			if(++p&gt;f-&gt;nc)
				p = 0;
			if(!rxexecute(f-&gt;curtext, nil, p, 0x7FFFFFFFL, &amp;sel))
				editerror("address");
		}
	}else{
		if(!rxbexecute(f-&gt;curtext, p, &amp;sel))
			editerror("no match for regexp");
		if(sel.r[0].q0==sel.r[0].q1 &amp;&amp; sel.r[0].q1==p){
			if(--p&lt;0)
				p = f-&gt;nc;
			if(!rxbexecute(f-&gt;curtext, p, &amp;sel))
				editerror("address");
		}
	}
}

File	*matchfile(String*);
Address	charaddr(long, Address, int);
Address	lineaddr(long, Address, int);

Address
cmdaddress(Addr *ap, Address a, int sign)
{
	File *f = a.f;
	Address a1, a2;

	do{
		switch(ap-&gt;type){
		case 'l':
		case '#':
			a = (*(ap-&gt;type=='#'?charaddr:lineaddr))(ap-&gt;num, a, sign);
			break;

		case '.':
			mkaddr(&amp;a, f);
			break;

		case '$':
			a.r.q0 = a.r.q1 = f-&gt;nc;
			break;

		case '\'':
editerror("can't handle '");
//			a.r = f-&gt;mark;
			break;

		case '?':
			sign = -sign;
			if(sign == 0)
				sign = -1;
			/* fall through */
		case '/':
			nextmatch(f, ap-&gt;re, sign&gt;=0? a.r.q1 : a.r.q0, sign);
			a.r = sel.r[0];
			break;

		case '"':
			f = matchfile(ap-&gt;re);
			mkaddr(&amp;a, f);
			break;

		case '*':
			a.r.q0 = 0, a.r.q1 = f-&gt;nc;
			return a;

		case ',':
		case ';':
			if(ap-&gt;left)
				a1 = cmdaddress(ap-&gt;left, a, 0);
			else
				a1.f = a.f, a1.r.q0 = a1.r.q1 = 0;
			if(ap-&gt;type == ';'){
				f = a1.f;
				a = a1;
				f-&gt;curtext-&gt;q0 = a1.r.q0;
				f-&gt;curtext-&gt;q1 = a1.r.q1;
			}
			if(ap-&gt;next)
				a2 = cmdaddress(ap-&gt;next, a, 0);
			else
				a2.f = a.f, a2.r.q0 = a2.r.q1 = f-&gt;nc;
			if(a1.f != a2.f)
				editerror("addresses in different files");
			a.f = a1.f, a.r.q0 = a1.r.q0, a.r.q1 = a2.r.q1;
			if(a.r.q1 &lt; a.r.q0)
				editerror("addresses out of order");
			return a;

		case '+':
		case '-':
			sign = 1;
			if(ap-&gt;type == '-')
				sign = -1;
			if(ap-&gt;next==0 || ap-&gt;next-&gt;type=='+' || ap-&gt;next-&gt;type=='-')
				a = lineaddr(1L, a, sign);
			break;
		default:
			error("cmdaddress");
			return a;
		}
	}while(ap = ap-&gt;next);	/* assign = */
	return a;
}

struct Tofile{
	File		*f;
	String	*r;
};

void
alltofile(Window *w, void *v)
{
	Text *t;
	struct Tofile *tp;

	tp = v;
	if(tp-&gt;f != nil)
		return;
	if(w-&gt;isscratch || w-&gt;isdir)
		return;
	t = &amp;w-&gt;body;
	/* only use this window if it's the current window for the file */
	if(t-&gt;file-&gt;curtext != t)
		return;
//	if(w-&gt;nopen[QWevent] &gt; 0)
//		return;
	if(runeeq(tp-&gt;r-&gt;r, tp-&gt;r-&gt;n, t-&gt;file-&gt;name, t-&gt;file-&gt;nname))
		tp-&gt;f = t-&gt;file;
}

File*
tofile(String *r)
{
	struct Tofile t;
	String rr;

	rr.r = skipbl(r-&gt;r, r-&gt;n, &amp;rr.n);
	t.f = nil;
	t.r = &amp;rr;
	allwindows(alltofile, &amp;t);
	if(t.f == nil)
		editerror("no such file\"%S\"", rr.r);
	return t.f;
}

void
allmatchfile(Window *w, void *v)
{
	struct Tofile *tp;
	Text *t;

	tp = v;
	if(w-&gt;isscratch || w-&gt;isdir)
		return;
	t = &amp;w-&gt;body;
	/* only use this window if it's the current window for the file */
	if(t-&gt;file-&gt;curtext != t)
		return;
//	if(w-&gt;nopen[QWevent] &gt; 0)
//		return;
	if(filematch(w-&gt;body.file, tp-&gt;r)){
		if(tp-&gt;f != nil)
			editerror("too many files match \"%S\"", tp-&gt;r-&gt;r);
		tp-&gt;f = w-&gt;body.file;
	}
}

File*
matchfile(String *r)
{
	struct Tofile tf;

	tf.f = nil;
	tf.r = r;
	allwindows(allmatchfile, &amp;tf);

	if(tf.f == nil)
		editerror("no file matches \"%S\"", r-&gt;r);
	return tf.f;
}

int
filematch(File *f, String *r)
{
	char *buf;
	Rune *rbuf;
	Window *w;
	int match, i, dirty;
	Rangeset s;

	/* compile expr first so if we get an error, we haven't allocated anything */
	if(rxcompile(r-&gt;r) == FALSE)
		editerror("bad regexp in file match");
	buf = fbufalloc();
	w = f-&gt;curtext-&gt;w;
	/* same check for dirty as in settag, but we know ncache==0 */
	dirty = !w-&gt;isdir &amp;&amp; !w-&gt;isscratch &amp;&amp; f-&gt;mod;
	snprint(buf, BUFSIZE, "%c%c%c %.*S\n", " '"[dirty],
		'+', " ."[curtext!=nil &amp;&amp; curtext-&gt;file==f], f-&gt;nname, f-&gt;name);
	rbuf = bytetorune(buf, &amp;i);
	fbuffree(buf);
	match = rxexecute(nil, rbuf, 0, i, &amp;s);
	free(rbuf);
	return match;
}

Address
charaddr(long l, Address addr, int sign)
{
	if(sign == 0)
		addr.r.q0 = addr.r.q1 = l;
	else if(sign &lt; 0)
		addr.r.q1 = addr.r.q0 -= l;
	else if(sign &gt; 0)
		addr.r.q0 = addr.r.q1 += l;
	if(addr.r.q0&lt;0 || addr.r.q1&gt;addr.f-&gt;nc)
		editerror("address out of range");
	return addr;
}

Address
lineaddr(long l, Address addr, int sign)
{
	int n;
	int c;
	File *f = addr.f;
	Address a;
	long p;

	a.f = f;
	if(sign &gt;= 0){
		if(l == 0){
			if(sign==0 || addr.r.q1==0){
				a.r.q0 = a.r.q1 = 0;
				return a;
			}
			a.r.q0 = addr.r.q1;
			p = addr.r.q1-1;
		}else{
			if(sign==0 || addr.r.q1==0){
				p = 0;
				n = 1;
			}else{
				p = addr.r.q1-1;
				n = textreadc(f-&gt;curtext, p++)=='\n';
			}
			while(n &lt; l){
				if(p &gt;= f-&gt;nc)
					editerror("address out of range");
				if(textreadc(f-&gt;curtext, p++) == '\n')
					n++;
			}
			a.r.q0 = p;
		}
		while(p &lt; f-&gt;nc &amp;&amp; textreadc(f-&gt;curtext, p++)!='\n')
			;
		a.r.q1 = p;
	}else{
		p = addr.r.q0;
		if(l == 0)
			a.r.q1 = addr.r.q0;
		else{
			for(n = 0; n&lt;l; ){	/* always runs once */
				if(p == 0){
					if(++n != l)
						editerror("address out of range");
				}else{
					c = textreadc(f-&gt;curtext, p-1);
					if(c != '\n' || ++n != l)
						p--;
				}
			}
			a.r.q1 = p;
			if(p &gt; 0)
				p--;
		}
		while(p &gt; 0 &amp;&amp; textreadc(f-&gt;curtext, p-1)!='\n')	/* lines start after a newline */
			p--;
		a.r.q0 = p;
	}
	return a;
}

struct Filecheck
{
	File	*f;
	Rune	*r;
	int nr;
};

void
allfilecheck(Window *w, void *v)
{
	struct Filecheck *fp;
	File *f;

	fp = v;
	f = w-&gt;body.file;
	if(w-&gt;body.file == fp-&gt;f)
		return;
	if(runeeq(fp-&gt;r, fp-&gt;nr, f-&gt;name, f-&gt;nname))
		warning(nil, "warning: duplicate file name \"%.*S\"\n", fp-&gt;nr, fp-&gt;r);
}

Rune*
cmdname(File *f, String *str, int set)
{
	Rune *r, *s;
	int n;
	struct Filecheck fc;
	Runestr newname;

	r = nil;
	n = str-&gt;n;
	s = str-&gt;r;
	if(n == 0){
		/* no name; use existing */
		if(f-&gt;nname == 0)
			return nil;
		r = runemalloc(f-&gt;nname+1);
		runemove(r, f-&gt;name, f-&gt;nname);
		return r;
	}
	s = skipbl(s, n, &amp;n);
	if(n == 0)
		goto Return;

	if(s[0] == '/'){
		r = runemalloc(n+1);
		runemove(r, s, n);
	}else{
		newname = dirname(f-&gt;curtext, runestrdup(s), n);
		n = newname.nr;
		r = runemalloc(n+1);	/* NUL terminate */
		runemove(r, newname.r, n);
		free(newname.r);
	}
	fc.f = f;
	fc.r = r;
	fc.nr = n;
	allwindows(allfilecheck, &amp;fc);
	if(f-&gt;nname == 0)
		set = TRUE;

    Return:
	if(set &amp;&amp; !runeeq(r, n, f-&gt;name, f-&gt;nname)){
		filemark(f);
		f-&gt;mod = TRUE;
		f-&gt;curtext-&gt;w-&gt;dirty = TRUE;
		winsetname(f-&gt;curtext-&gt;w, r, n);
	}
	return r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

