<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/fsys.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/fsys.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

static	int	cfd;
static	int	sfd;

enum
{
	Nhash	= 16,
	DEBUG	= 0
};

static	Fid	*fids[Nhash];

Fid	*newfid(int);

static	Xfid*	fsysflush(Xfid*, Fid*);
static	Xfid*	fsysauth(Xfid*, Fid*);
static	Xfid*	fsysversion(Xfid*, Fid*);
static	Xfid*	fsysattach(Xfid*, Fid*);
static	Xfid*	fsyswalk(Xfid*, Fid*);
static	Xfid*	fsysopen(Xfid*, Fid*);
static	Xfid*	fsyscreate(Xfid*, Fid*);
static	Xfid*	fsysread(Xfid*, Fid*);
static	Xfid*	fsyswrite(Xfid*, Fid*);
static	Xfid*	fsysclunk(Xfid*, Fid*);
static	Xfid*	fsysremove(Xfid*, Fid*);
static	Xfid*	fsysstat(Xfid*, Fid*);
static	Xfid*	fsyswstat(Xfid*, Fid*);

Xfid* 	(*fcall[Tmax])(Xfid*, Fid*) =
{
	[Tflush]	= fsysflush,
	[Tversion]	= fsysversion,
	[Tauth]	= fsysauth,
	[Tattach]	= fsysattach,
	[Twalk]	= fsyswalk,
	[Topen]	= fsysopen,
	[Tcreate]	= fsyscreate,
	[Tread]	= fsysread,
	[Twrite]	= fsyswrite,
	[Tclunk]	= fsysclunk,
	[Tremove]= fsysremove,
	[Tstat]	= fsysstat,
	[Twstat]	= fsyswstat,
};

char Eperm[] = "permission denied";
char Eexist[] = "file does not exist";
char Enotdir[] = "not a directory";

Dirtab dirtab[]=
{
	{ ".",			QTDIR,	Qdir,		0500|DMDIR },
	{ "acme",		QTDIR,	Qacme,	0500|DMDIR },
	{ "cons",		QTFILE,	Qcons,	0600 },
	{ "consctl",	QTFILE,	Qconsctl,	0000 },
	{ "draw",		QTDIR,	Qdraw,	0000|DMDIR },	/* to suppress graphics progs started in acme */
	{ "editout",	QTFILE,	Qeditout,	0200 },
	{ "index",		QTFILE,	Qindex,	0400 },
	{ "label",		QTFILE,	Qlabel,	0600 },
	{ "new",		QTDIR,	Qnew,	0500|DMDIR },
	{ nil, }
};

Dirtab dirtabw[]=
{
	{ ".",			QTDIR,		Qdir,			0500|DMDIR },
	{ "addr",		QTFILE,		QWaddr,		0600 },
	{ "body",		QTAPPEND,	QWbody,		0600|DMAPPEND },
	{ "ctl",		QTFILE,		QWctl,		0600 },
	{ "data",		QTFILE,		QWdata,		0600 },
	{ "editout",	QTFILE,		QWeditout,	0200 },
	{ "errors",		QTFILE,		QWerrors,		0200 },
	{ "event",		QTFILE,		QWevent,		0600 },
	{ "rdsel",		QTFILE,		QWrdsel,		0400 },
	{ "wrsel",		QTFILE,		QWwrsel,		0200 },
	{ "tag",		QTAPPEND,	QWtag,		0600|DMAPPEND },
	{ "xdata",		QTFILE,		QWxdata,		0600 },
	{ nil, }
};

typedef struct Mnt Mnt;
struct Mnt
{
	QLock;
	int		id;
	Mntdir	*md;
};

Mnt	mnt;

Xfid*	respond(Xfid*, Fcall*, char*);
int		dostat(int, Dirtab*, uchar*, int, uint);
uint	getclock(void);

char	*user = "Wile E. Coyote";
int	clockfd;
static int closing = 0;
int	messagesize = Maxblock+IOHDRSZ;	/* good start */

void	fsysproc(void *);

void
fsysinit(void)
{
	int p[2];
	int n, fd;
	char buf[256];

	if(pipe(p) &lt; 0)
		error("can't create pipe");
	cfd = p[0];
	sfd = p[1];
	fmtinstall('F', fcallfmt);
	clockfd = open("/dev/time", OREAD|OCEXEC);
	fd = open("/dev/user", OREAD);
	if(fd &gt;= 0){
		n = read(fd, buf, sizeof buf-1);
		if(n &gt; 0){
			buf[n] = 0;
			user = estrdup(buf);
		}
		close(fd);
	}
	proccreate(fsysproc, nil, STACK);
}

void
fsysproc(void *)
{
	int n;
	Xfid *x;
	Fid *f;
	Fcall t;
	uchar *buf;

	threadsetname("fsysproc");

	x = nil;
	for(;;){
		buf = emalloc(messagesize+UTFmax);	/* overflow for appending partial rune in xfidwrite */
		n = read9pmsg(sfd, buf, messagesize);
		if(n &lt;= 0){
			if(closing)
				break;
			error("i/o error on server channel");
		}
		if(x == nil){
			sendp(cxfidalloc, nil);
			x = recvp(cxfidalloc);
		}
		x-&gt;buf = buf;
		if(convM2S(buf, n, x) != n)
			error("convert error in convM2S");
		if(DEBUG)
			fprint(2, "%F\n", &amp;x-&gt;Fcall);
		if(fcall[x-&gt;type] == nil)
			x = respond(x, &amp;t, "bad fcall type");
		else{
			switch(x-&gt;type){
			case Tversion:
			case Tauth:
			case Tflush:
				f = nil;
				break;
			case Tattach:
				f = newfid(x-&gt;fid);
				break;
			default:
				f = newfid(x-&gt;fid);
				if(!f-&gt;busy){
					x-&gt;f = f;
					x = respond(x, &amp;t, "fid not in use");
					continue;
				}
				break;
			}
			x-&gt;f = f;
			x  = (*fcall[x-&gt;type])(x, f);
		}
	}
}

Mntdir*
fsysaddid(Rune *dir, int ndir, Rune **incl, int nincl)
{
	Mntdir *m;
	int id;

	qlock(&amp;mnt);
	id = ++mnt.id;
	m = emalloc(sizeof *m);
	m-&gt;id = id;
	m-&gt;dir =  dir;
	m-&gt;ref = 1;	/* one for Command, one will be incremented in attach */
	m-&gt;ndir = ndir;
	m-&gt;next = mnt.md;
	m-&gt;incl = incl;
	m-&gt;nincl = nincl;
	mnt.md = m;
	qunlock(&amp;mnt);
	return m;
}

void
fsysincid(Mntdir *m)
{
	qlock(&amp;mnt);
	m-&gt;ref++;
	qunlock(&amp;mnt);
}

void
fsysdelid(Mntdir *idm)
{
	Mntdir *m, *prev;
	int i;
	char buf[64];

	if(idm == nil)
		return;
	qlock(&amp;mnt);
	if(--idm-&gt;ref &gt; 0){
		qunlock(&amp;mnt);
		return;
	}
	prev = nil;
	for(m=mnt.md; m; m=m-&gt;next){
		if(m == idm){
			if(prev)
				prev-&gt;next = m-&gt;next;
			else
				mnt.md = m-&gt;next;
			for(i=0; i&lt;m-&gt;nincl; i++)
				free(m-&gt;incl[i]);
			free(m-&gt;incl);
			free(m-&gt;dir);
			free(m);
			qunlock(&amp;mnt);
			return;
		}
		prev = m;
	}
	qunlock(&amp;mnt);
	sprint(buf, "fsysdelid: can't find id %d\n", idm-&gt;id);
	sendp(cerr, estrdup(buf));
}

/*
 * Called only in exec.c:/^run(), from a different FD group
 */
Mntdir*
fsysmount(Rune *dir, int ndir, Rune **incl, int nincl)
{
	char buf[256];
	Mntdir *m;

	/* close server side so don't hang if acme is half-exited */
	close(sfd);
	m = fsysaddid(dir, ndir, incl, nincl);
	sprint(buf, "%d", m-&gt;id);
	if(mount(cfd, -1, "/mnt/acme", MREPL, buf) &lt; 0){
		fsysdelid(m);
		return nil;
	}
	close(cfd);
	bind("/mnt/acme", "/mnt/wsys", MREPL);
	if(bind("/mnt/acme", "/dev", MBEFORE) &lt; 0){
		fsysdelid(m);
		return nil;
	}
	return m;
}

void
fsysclose(void)
{
	closing = 1;
	close(cfd);
	close(sfd);
}

Xfid*
respond(Xfid *x, Fcall *t, char *err)
{
	int n;

	if(err){
		t-&gt;type = Rerror;
		t-&gt;ename = err;
	}else
		t-&gt;type = x-&gt;type+1;
	t-&gt;fid = x-&gt;fid;
	t-&gt;tag = x-&gt;tag;
	if(x-&gt;buf == nil)
		x-&gt;buf = emalloc(messagesize);
	n = convS2M(t, x-&gt;buf, messagesize);
	if(n &lt;= 0)
		error("convert error in convS2M");
	if(write(sfd, x-&gt;buf, n) != n)
		error("write error in respond");
	free(x-&gt;buf);
	x-&gt;buf = nil;
	if(DEBUG)
		fprint(2, "r: %F\n", t);
	return x;
}

static
Xfid*
fsysversion(Xfid *x, Fid*)
{
	Fcall t;

	if(x-&gt;msize &lt; 256)
		return respond(x, &amp;t, "version: message size too small");
	if(x-&gt;msize &lt; messagesize)
		messagesize = x-&gt;msize;
	t.msize = messagesize;
	if(strncmp(x-&gt;version, "9P2000", 6) != 0)
		return respond(x, &amp;t, "unrecognized 9P version");
	t.version = "9P2000";
	return respond(x, &amp;t, nil);
}

static
Xfid*
fsysauth(Xfid *x, Fid*)
{
	Fcall t;

	return respond(x, &amp;t, "acme: authentication not required");
}

static
Xfid*
fsysflush(Xfid *x, Fid*)
{
	sendp(x-&gt;c, xfidflush);
	return nil;
}

static
Xfid*
fsysattach(Xfid *x, Fid *f)
{
	Fcall t;
	int id;
	Mntdir *m;

	if(strcmp(x-&gt;uname, user) != 0)
		return respond(x, &amp;t, Eperm);
	f-&gt;busy = TRUE;
	f-&gt;open = FALSE;
	f-&gt;qid.path = Qdir;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.vers = 0;
	f-&gt;dir = dirtab;
	f-&gt;nrpart = 0;
	f-&gt;w = nil;
	t.qid = f-&gt;qid;
	f-&gt;mntdir = nil;
	id = atoi(x-&gt;aname);
	qlock(&amp;mnt);
	for(m=mnt.md; m; m=m-&gt;next)
		if(m-&gt;id == id){
			f-&gt;mntdir = m;
			m-&gt;ref++;
			break;
		}
	if(m == nil)
		sendp(cerr, estrdup("unknown id in attach"));
	qunlock(&amp;mnt);
	return respond(x, &amp;t, nil);
}

static
Xfid*
fsyswalk(Xfid *x, Fid *f)
{
	Fcall t;
	int c, i, j, id;
	Qid q;
	uchar type;
	ulong path;
	Fid *nf;
	Dirtab *d, *dir;
	Window *w;
	char *err;

	nf = nil;
	w = nil;
	if(f-&gt;open)
		return respond(x, &amp;t, "walk of open file");
	if(x-&gt;fid != x-&gt;newfid){
		nf = newfid(x-&gt;newfid);
		if(nf-&gt;busy)
			return respond(x, &amp;t, "newfid already in use");
		nf-&gt;busy = TRUE;
		nf-&gt;open = FALSE;
		nf-&gt;mntdir = f-&gt;mntdir;
		if(f-&gt;mntdir)
			f-&gt;mntdir-&gt;ref++;
		nf-&gt;dir = f-&gt;dir;
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;w = f-&gt;w;
		nf-&gt;nrpart = 0;	/* not open, so must be zero */
		if(nf-&gt;w)
			incref(nf-&gt;w);
		f = nf;	/* walk f */
	}

	t.nwqid = 0;
	err = nil;
	dir = nil;
	id = WIN(f-&gt;qid);
	q = f-&gt;qid;

	if(x-&gt;nwname &gt; 0){
		for(i=0; i&lt;x-&gt;nwname; i++){
			if((q.type &amp; QTDIR) == 0){
				err = Enotdir;
				break;
			}

			if(strcmp(x-&gt;wname[i], "..") == 0){
				type = QTDIR;
				path = Qdir;
				id = 0;
				if(w){
					winclose(w);
					w = nil;
				}
    Accept:
				if(i == MAXWELEM){
					err = "name too long";
					break;
				}
				q.type = type;
				q.vers = 0;
				q.path = QID(id, path);
				t.wqid[t.nwqid++] = q;
				continue;
			}

			/* is it a numeric name? */
			for(j=0; (c=x-&gt;wname[i][j]); j++)
				if(c&lt;'0' || '9'&lt;c)
					goto Regular;
			/* yes: it's a directory */
			if(w)	/* name has form 27/23; get out before losing w */
				break;
			id = atoi(x-&gt;wname[i]);
			qlock(&amp;row);
			w = lookid(id, FALSE);
			if(w == nil){
				qunlock(&amp;row);
				break;
			}
			incref(w);	/* we'll drop reference at end if there's an error */
			path = Qdir;
			type = QTDIR;
			qunlock(&amp;row);
			dir = dirtabw;
			goto Accept;
	
    Regular:
//			if(FILE(f-&gt;qid) == Qacme)	/* empty directory */
//				break;
			if(strcmp(x-&gt;wname[i], "new") == 0){
				if(w)
					error("w set in walk to new");
				sendp(cnewwindow, nil);	/* signal newwindowthread */
				w = recvp(cnewwindow);	/* receive new window */
				incref(w);
				type = QTDIR;
				path = QID(w-&gt;id, Qdir);
				id = w-&gt;id;
				dir = dirtabw;
				goto Accept;
			}

			if(id == 0)
				d = dirtab;
			else
				d = dirtabw;
			d++;	/* skip '.' */
			for(; d-&gt;name; d++)
				if(strcmp(x-&gt;wname[i], d-&gt;name) == 0){
					path = d-&gt;qid;
					type = d-&gt;type;
					dir = d;
					goto Accept;
				}

			break;	/* file not found */
		}

		if(i==0 &amp;&amp; err == nil)
			err = Eexist;
	}

	if(err!=nil || t.nwqid&lt;x-&gt;nwname){
		if(nf){
			nf-&gt;busy = FALSE;
			fsysdelid(nf-&gt;mntdir);
		}
	}else if(t.nwqid  == x-&gt;nwname){
		if(w){
			f-&gt;w = w;
			w = nil;	/* don't drop the reference */
		}
		if(dir)
			f-&gt;dir = dir;
		f-&gt;qid = q;
	}

	if(w != nil)
		winclose(w);

	return respond(x, &amp;t, err);
}

static
Xfid*
fsysopen(Xfid *x, Fid *f)
{
	Fcall t;
	int m;

	/* can't truncate anything, so just disregard */
	x-&gt;mode &amp;= ~(OTRUNC|OCEXEC);
	/* can't execute or remove anything */
	if(x-&gt;mode==OEXEC || (x-&gt;mode&amp;ORCLOSE))
		goto Deny;
	switch(x-&gt;mode){
	default:
		goto Deny;
	case OREAD:
		m = 0400;
		break;
	case OWRITE:
		m = 0200;
		break;
	case ORDWR:
		m = 0600;
		break;
	}
	if(((f-&gt;dir-&gt;perm&amp;~(DMDIR|DMAPPEND))&amp;m) != m)
		goto Deny;

	sendp(x-&gt;c, xfidopen);
	return nil;

    Deny:
	return respond(x, &amp;t, Eperm);
}

static
Xfid*
fsyscreate(Xfid *x, Fid*)
{
	Fcall t;

	return respond(x, &amp;t, Eperm);
}

static
int
idcmp(void *a, void *b)
{
	return *(int*)a - *(int*)b;
}

static
Xfid*
fsysread(Xfid *x, Fid *f)
{
	Fcall t;
	uchar *b;
	int i, id, n, o, e, j, k, *ids, nids;
	Dirtab *d, dt;
	Column *c;
	uint clock, len;
	char buf[16];

	if(f-&gt;qid.type &amp; QTDIR){
		if(FILE(f-&gt;qid) == Qacme){	/* empty dir */
			t.data = nil;
			t.count = 0;
			respond(x, &amp;t, nil);
			return x;
		}
		o = x-&gt;offset;
		e = x-&gt;offset+x-&gt;count;
		clock = getclock();
		b = emalloc(messagesize);
		id = WIN(f-&gt;qid);
		n = 0;
		if(id &gt; 0)
			d = dirtabw;
		else
			d = dirtab;
		d++;	/* first entry is '.' */
		for(i=0; d-&gt;name!=nil &amp;&amp; i&lt;e; i+=len){
			len = dostat(WIN(x-&gt;f-&gt;qid), d, b+n, x-&gt;count-n, clock);
			if(len &lt;= BIT16SZ)
				break;
			if(i &gt;= o)
				n += len;
			d++;
		}
		if(id == 0){
			qlock(&amp;row);
			nids = 0;
			ids = nil;
			for(j=0; j&lt;row.ncol; j++){
				c = row.col[j];
				for(k=0; k&lt;c-&gt;nw; k++){
					ids = erealloc(ids, (nids+1)*sizeof(int));
					ids[nids++] = c-&gt;w[k]-&gt;id;
				}
			}
			qunlock(&amp;row);
			qsort(ids, nids, sizeof ids[0], idcmp);
			j = 0;
			dt.name = buf;
			for(; j&lt;nids &amp;&amp; i&lt;e; i+=len){
				k = ids[j];
				sprint(dt.name, "%d", k);
				dt.qid = QID(k, Qdir);
				dt.type = QTDIR;
				dt.perm = DMDIR|0700;
				len = dostat(k, &amp;dt, b+n, x-&gt;count-n, clock);
				if(len == 0)
					break;
				if(i &gt;= o)
					n += len;
				j++;
			}
			free(ids);
		}
		t.data = (char*)b;
		t.count = n;
		respond(x, &amp;t, nil);
		free(b);
		return x;
	}
	sendp(x-&gt;c, xfidread);
	return nil;
}

static
Xfid*
fsyswrite(Xfid *x, Fid*)
{
	sendp(x-&gt;c, xfidwrite);
	return nil;
}

static
Xfid*
fsysclunk(Xfid *x, Fid *f)
{
	fsysdelid(f-&gt;mntdir);
	sendp(x-&gt;c, xfidclose);
	return nil;
}

static
Xfid*
fsysremove(Xfid *x, Fid*)
{
	Fcall t;

	return respond(x, &amp;t, Eperm);
}

static
Xfid*
fsysstat(Xfid *x, Fid *f)
{
	Fcall t;

	t.stat = emalloc(messagesize-IOHDRSZ);
	t.nstat = dostat(WIN(x-&gt;f-&gt;qid), f-&gt;dir, t.stat, messagesize-IOHDRSZ, getclock());
	x = respond(x, &amp;t, nil);
	free(t.stat);
	return x;
}

static
Xfid*
fsyswstat(Xfid *x, Fid*)
{
	Fcall t;

	return respond(x, &amp;t, Eperm);
}

Fid*
newfid(int fid)
{
	Fid *f, *ff, **fh;

	ff = nil;
	fh = &amp;fids[fid&amp;(Nhash-1)];
	for(f=*fh; f; f=f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(ff==nil &amp;&amp; f-&gt;busy==FALSE)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = *fh;
	*fh = f;
	return f;
}

uint
getclock()
{
	char buf[32];

	buf[0] = '\0';
	pread(clockfd, buf, sizeof buf, 0);
	return atoi(buf);
}

int
dostat(int id, Dirtab *dir, uchar *buf, int nbuf, uint clock)
{
	Dir d;

	d.qid.path = QID(id, dir-&gt;qid);
	d.qid.vers = 0;
	d.qid.type = dir-&gt;type;
	d.mode = dir-&gt;perm;
	d.length = 0;	/* would be nice to do better */
	d.name = dir-&gt;name;
	d.uid = user;
	d.gid = user;
	d.muid = user;
	d.atime = clock;
	d.mtime = clock;
	return convD2M(&amp;d, buf, nbuf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

