<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/acme/text.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/acme/text.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include &lt;complete.h&gt;
#include "dat.h"
#include "fns.h"

Image	*tagcols[NCOL];
Image	*textcols[NCOL];

enum{
	TABDIR = 3	/* width of tabs in directory windows */
};

void
textinit(Text *t, File *f, Rectangle r, Reffont *rf, Image *cols[NCOL])
{
	t-&gt;file = f;
	t-&gt;all = r;
	t-&gt;scrollr = r;
	t-&gt;scrollr.max.x = r.min.x+Scrollwid;
	t-&gt;lastsr = nullrect;
	r.min.x += Scrollwid+Scrollgap;
	t-&gt;eq0 = ~0;
	t-&gt;ncache = 0;
	t-&gt;reffont = rf;
	t-&gt;tabstop = maxtab;
	memmove(t-&gt;Frame.cols, cols, sizeof t-&gt;Frame.cols);
	textredraw(t, r, rf-&gt;f, screen, -1);
}

void
textredraw(Text *t, Rectangle r, Font *f, Image *b, int odx)
{
	int maxt;
	Rectangle rr;

	frinit(t, r, f, b, t-&gt;Frame.cols);
	rr = t-&gt;r;
	rr.min.x -= Scrollwid+Scrollgap;	/* back fill to scroll bar */
	draw(t-&gt;b, rr, t-&gt;cols[BACK], nil, ZP);
	/* use no wider than 3-space tabs in a directory */
	maxt = maxtab;
	if(t-&gt;what == Body){
		if(t-&gt;w-&gt;isdir)
			maxt = min(TABDIR, maxtab);
		else
			maxt = t-&gt;tabstop;
	}
	t-&gt;maxtab = maxt*stringwidth(f, "0");
	if(t-&gt;what==Body &amp;&amp; t-&gt;w-&gt;isdir &amp;&amp; odx!=Dx(t-&gt;all)){
		if(t-&gt;maxlines &gt; 0){
			textreset(t);
			textcolumnate(t, t-&gt;w-&gt;dlp,  t-&gt;w-&gt;ndl);
			textshow(t, 0, 0, 1);
		}
	}else{
		textfill(t);
		textsetselect(t, t-&gt;q0, t-&gt;q1);
	}
}

int
textresize(Text *t, Rectangle r)
{
	int odx;

	if(Dy(r) &gt; 0)
		r.max.y -= Dy(r)%t-&gt;font-&gt;height;
	else
		r.max.y = r.min.y;
	odx = Dx(t-&gt;all);
	t-&gt;all = r;
	t-&gt;scrollr = r;
	t-&gt;scrollr.max.x = r.min.x+Scrollwid;
	t-&gt;lastsr = nullrect;
	r.min.x += Scrollwid+Scrollgap;
	frclear(t, 0);
	textredraw(t, r, t-&gt;font, t-&gt;b, odx);
	return r.max.y;
}

void
textclose(Text *t)
{
	free(t-&gt;cache);
	frclear(t, 1);
	filedeltext(t-&gt;file, t);
	t-&gt;file = nil;
	rfclose(t-&gt;reffont);
	if(argtext == t)
		argtext = nil;
	if(typetext == t)
		typetext = nil;
	if(seltext == t)
		seltext = nil;
	if(mousetext == t)
		mousetext = nil;
	if(barttext == t)
		barttext = nil;
}

int
dircmp(void *a, void *b)
{
	Dirlist *da, *db;
	int i, n;

	da = *(Dirlist**)a;
	db = *(Dirlist**)b;
	n = min(da-&gt;nr, db-&gt;nr);
	i = memcmp(da-&gt;r, db-&gt;r, n*sizeof(Rune));
	if(i)
		return i;
	return da-&gt;nr - db-&gt;nr;
}

void
textcolumnate(Text *t, Dirlist **dlp, int ndl)
{
	int i, j, w, colw, mint, maxt, ncol, nrow;
	Dirlist *dl;
	uint q1;

	if(t-&gt;file-&gt;ntext &gt; 1)
		return;
	mint = stringwidth(t-&gt;font, "0");
	/* go for narrower tabs if set more than 3 wide */
	t-&gt;maxtab = min(maxtab, TABDIR)*mint;
	maxt = t-&gt;maxtab;
	colw = 0;
	for(i=0; i&lt;ndl; i++){
		dl = dlp[i];
		w = dl-&gt;wid;
		if(maxt-w%maxt &lt; mint || w%maxt==0)
			w += mint;
		if(w % maxt)
			w += maxt-(w%maxt);
		if(w &gt; colw)
			colw = w;
	}
	if(colw == 0)
		ncol = 1;
	else
		ncol = max(1, Dx(t-&gt;r)/colw);
	nrow = (ndl+ncol-1)/ncol;

	q1 = 0;
	for(i=0; i&lt;nrow; i++){
		for(j=i; j&lt;ndl; j+=nrow){
			dl = dlp[j];
			fileinsert(t-&gt;file, q1, dl-&gt;r, dl-&gt;nr);
			q1 += dl-&gt;nr;
			if(j+nrow &gt;= ndl)
				break;
			w = dl-&gt;wid;
			if(maxt-w%maxt &lt; mint){
				fileinsert(t-&gt;file, q1, L"\t", 1);
				q1++;
				w += mint;
			}
			do{
				fileinsert(t-&gt;file, q1, L"\t", 1);
				q1++;
				w += maxt-(w%maxt);
			}while(w &lt; colw);
		}
		fileinsert(t-&gt;file, q1, L"\n", 1);
		q1++;
	}
}

uint
textload(Text *t, uint q0, char *file, int setqid)
{
	Rune *rp;
	Dirlist *dl, **dlp;
	int fd, i, j, n, ndl, nulls;
	uint q, q1;
	Dir *d, *dbuf;
	char *tmp;
	Text *u;

	if(t-&gt;ncache!=0 || t-&gt;file-&gt;nc || t-&gt;w==nil || t!=&amp;t-&gt;w-&gt;body)
		error("text.load");
	if(t-&gt;w-&gt;isdir &amp;&amp; t-&gt;file-&gt;nname==0){
		warning(nil, "empty directory name\n");
		return 0;
	}
	fd = open(file, OREAD);
	if(fd &lt; 0){
		warning(nil, "can't open %s: %r\n", file);
		return 0;
	}
	d = dirfstat(fd);
	if(d == nil){
		warning(nil, "can't fstat %s: %r\n", file);
		goto Rescue;
	}
	nulls = FALSE;
	if(d-&gt;qid.type &amp; QTDIR){
		/* this is checked in get() but it's possible the file changed underfoot */
		if(t-&gt;file-&gt;ntext &gt; 1){
			warning(nil, "%s is a directory; can't read with multiple windows on it\n", file);
			goto Rescue;
		}
		t-&gt;w-&gt;isdir = TRUE;
		t-&gt;w-&gt;filemenu = FALSE;
		if(t-&gt;file-&gt;name[t-&gt;file-&gt;nname-1] != '/'){
			rp = runemalloc(t-&gt;file-&gt;nname+1);
			runemove(rp, t-&gt;file-&gt;name, t-&gt;file-&gt;nname);
			rp[t-&gt;file-&gt;nname] = '/';
			winsetname(t-&gt;w, rp, t-&gt;file-&gt;nname+1);
			free(rp);
		}
		dlp = nil;
		ndl = 0;
		dbuf = nil;
		while((n=dirread(fd, &amp;dbuf)) &gt; 0){
			for(i=0; i&lt;n; i++){
				dl = emalloc(sizeof(Dirlist));
				j = strlen(dbuf[i].name);
				tmp = emalloc(j+1+1);
				memmove(tmp, dbuf[i].name, j);
				if(dbuf[i].qid.type &amp; QTDIR)
					tmp[j++] = '/';
				tmp[j] = '\0';
				dl-&gt;r = bytetorune(tmp, &amp;dl-&gt;nr);
				dl-&gt;wid = stringwidth(t-&gt;font, tmp);
				free(tmp);
				ndl++;
				dlp = realloc(dlp, ndl*sizeof(Dirlist*));
				dlp[ndl-1] = dl;
			}
			free(dbuf);
		}
		qsort(dlp, ndl, sizeof(Dirlist*), dircmp);
		t-&gt;w-&gt;dlp = dlp;
		t-&gt;w-&gt;ndl = ndl;
		textcolumnate(t, dlp, ndl);
		q1 = t-&gt;file-&gt;nc;
	}else{
		t-&gt;w-&gt;isdir = FALSE;
		t-&gt;w-&gt;filemenu = TRUE;
		q1 = q0 + fileload(t-&gt;file, q0, fd, &amp;nulls);
	}
	if(setqid){
		t-&gt;file-&gt;dev = d-&gt;dev;
		t-&gt;file-&gt;mtime = d-&gt;mtime;
		t-&gt;file-&gt;qidpath = d-&gt;qid.path;
	}
	close(fd);
	rp = fbufalloc();
	for(q=q0; q&lt;q1; q+=n){
		n = q1-q;
		if(n &gt; RBUFSIZE)
			n = RBUFSIZE;
		bufread(t-&gt;file, q, rp, n);
		if(q &lt; t-&gt;org)
			t-&gt;org += n;
		else if(q &lt;= t-&gt;org+t-&gt;nchars)
			frinsert(t, rp, rp+n, q-t-&gt;org);
		if(t-&gt;lastlinefull)
			break;
	}
	fbuffree(rp);
	for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
		u = t-&gt;file-&gt;text[i];
		if(u != t){
			if(u-&gt;org &gt; u-&gt;file-&gt;nc)	/* will be 0 because of reset(), but safety first */
				u-&gt;org = 0;
			textresize(u, u-&gt;all);
			textbacknl(u, u-&gt;org, 0);	/* go to beginning of line */
		}
		textsetselect(u, q0, q0);
	}
	if(nulls)
		warning(nil, "%s: NUL bytes elided\n", file);
	free(d);
	return q1-q0;

    Rescue:
	close(fd);
	return 0;
}

uint
textbsinsert(Text *t, uint q0, Rune *r, uint n, int tofile, int *nrp)
{
	Rune *bp, *tp, *up;
	int i, initial;

	if(t-&gt;what == Tag){	/* can't happen but safety first: mustn't backspace over file name */
    Err:
		textinsert(t, q0, r, n, tofile);
		*nrp = n;
		return q0;
	}
	bp = r;
	for(i=0; i&lt;n; i++)
		if(*bp++ == '\b'){
			--bp;
			initial = 0;
			tp = runemalloc(n);
			runemove(tp, r, i);
			up = tp+i;
			for(; i&lt;n; i++){
				*up = *bp++;
				if(*up == '\b')
					if(up == tp)
						initial++;
					else
						--up;
				else
					up++;
			}
			if(initial){
				if(initial &gt; q0)
					initial = q0;
				q0 -= initial;
				textdelete(t, q0, q0+initial, tofile);
			}
			n = up-tp;
			textinsert(t, q0, tp, n, tofile);
			free(tp);
			*nrp = n;
			return q0;
		}
	goto Err;
}

void
textinsert(Text *t, uint q0, Rune *r, uint n, int tofile)
{
	int c, i;
	Text *u;

	if(tofile &amp;&amp; t-&gt;ncache != 0)
		error("text.insert");
	if(n == 0)
		return;
	if(tofile){
		fileinsert(t-&gt;file, q0, r, n);
		if(t-&gt;what == Body){
			t-&gt;w-&gt;dirty = TRUE;
			t-&gt;w-&gt;utflastqid = -1;
		}
		if(t-&gt;file-&gt;ntext &gt; 1)
			for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
				u = t-&gt;file-&gt;text[i];
				if(u != t){
					u-&gt;w-&gt;dirty = TRUE;	/* always a body */
					textinsert(u, q0, r, n, FALSE);
					textsetselect(u, u-&gt;q0, u-&gt;q1);
					textscrdraw(u);
				}
			}
					
	}
	if(q0 &lt; t-&gt;q1)
		t-&gt;q1 += n;
	if(q0 &lt; t-&gt;q0)
		t-&gt;q0 += n;
	if(q0 &lt; t-&gt;org)
		t-&gt;org += n;
	else if(q0 &lt;= t-&gt;org+t-&gt;nchars)
		frinsert(t, r, r+n, q0-t-&gt;org);
	if(t-&gt;w){
		c = 'i';
		if(t-&gt;what == Body)
			c = 'I';
		if(n &lt;= EVENTSIZE)
			winevent(t-&gt;w, "%c%d %d 0 %d %.*S\n", c, q0, q0+n, n, n, r);
		else
			winevent(t-&gt;w, "%c%d %d 0 0 \n", c, q0, q0+n, n);
	}
}

void
typecommit(Text *t)
{
	if(t-&gt;w != nil)
		wincommit(t-&gt;w, t);
	else
		textcommit(t, TRUE);
}

void
textfill(Text *t)
{
	Rune *rp;
	int i, n, m, nl;

	if(t-&gt;lastlinefull || t-&gt;nofill)
		return;
	if(t-&gt;ncache &gt; 0)
		typecommit(t);
	rp = fbufalloc();
	do{
		n = t-&gt;file-&gt;nc-(t-&gt;org+t-&gt;nchars);
		if(n == 0)
			break;
		if(n &gt; 2000)	/* educated guess at reasonable amount */
			n = 2000;
		bufread(t-&gt;file, t-&gt;org+t-&gt;nchars, rp, n);
		/*
		 * it's expensive to frinsert more than we need, so
		 * count newlines.
		 */
		nl = t-&gt;maxlines-t-&gt;nlines;
		m = 0;
		for(i=0; i&lt;n; ){
			if(rp[i++] == '\n'){
				m++;
				if(m &gt;= nl)
					break;
			}
		}
		frinsert(t, rp, rp+i, t-&gt;nchars);
	}while(t-&gt;lastlinefull == FALSE);
	fbuffree(rp);
}

void
textdelete(Text *t, uint q0, uint q1, int tofile)
{
	uint n, p0, p1;
	int i, c;
	Text *u;

	if(tofile &amp;&amp; t-&gt;ncache != 0)
		error("text.delete");
	n = q1-q0;
	if(n == 0)
		return;
	if(tofile){
		filedelete(t-&gt;file, q0, q1);
		if(t-&gt;what == Body){
			t-&gt;w-&gt;dirty = TRUE;
			t-&gt;w-&gt;utflastqid = -1;
		}
		if(t-&gt;file-&gt;ntext &gt; 1)
			for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
				u = t-&gt;file-&gt;text[i];
				if(u != t){
					u-&gt;w-&gt;dirty = TRUE;	/* always a body */
					textdelete(u, q0, q1, FALSE);
					textsetselect(u, u-&gt;q0, u-&gt;q1);
					textscrdraw(u);
				}
			}
	}
	if(q0 &lt; t-&gt;q0)
		t-&gt;q0 -= min(n, t-&gt;q0-q0);
	if(q0 &lt; t-&gt;q1)
		t-&gt;q1 -= min(n, t-&gt;q1-q0);
	if(q1 &lt;= t-&gt;org)
		t-&gt;org -= n;
	else if(q0 &lt; t-&gt;org+t-&gt;nchars){
		p1 = q1 - t-&gt;org;
		if(p1 &gt; t-&gt;nchars)
			p1 = t-&gt;nchars;
		if(q0 &lt; t-&gt;org){
			t-&gt;org = q0;
			p0 = 0;
		}else
			p0 = q0 - t-&gt;org;
		frdelete(t, p0, p1);
		textfill(t);
	}
	if(t-&gt;w){
		c = 'd';
		if(t-&gt;what == Body)
			c = 'D';
		winevent(t-&gt;w, "%c%d %d 0 0 \n", c, q0, q1);
	}
}

void
textconstrain(Text *t, uint q0, uint q1, uint *p0, uint *p1)
{
	*p0 = min(q0, t-&gt;file-&gt;nc);
	*p1 = min(q1, t-&gt;file-&gt;nc);
}

Rune
textreadc(Text *t, uint q)
{
	Rune r;

	if(t-&gt;cq0&lt;=q &amp;&amp; q&lt;t-&gt;cq0+t-&gt;ncache)
		r = t-&gt;cache[q-t-&gt;cq0];
	else
		bufread(t-&gt;file, q, &amp;r, 1);
	return r;
}

int
textbswidth(Text *t, Rune c)
{
	uint q, eq;
	Rune r;
	int skipping;

	/* there is known to be at least one character to erase */
	if(c == 0x08)	/* ^H: erase character */
		return 1;
	q = t-&gt;q0;
	skipping = TRUE;
	while(q &gt; 0){
		r = textreadc(t, q-1);
		if(r == '\n'){		/* eat at most one more character */
			if(q == t-&gt;q0)	/* eat the newline */
				--q;
			break; 
		}
		if(c == 0x17){
			eq = isalnum(r);
			if(eq &amp;&amp; skipping)	/* found one; stop skipping */
				skipping = FALSE;
			else if(!eq &amp;&amp; !skipping)
				break;
		}
		--q;
	}
	return t-&gt;q0-q;
}

int
textfilewidth(Text *t, uint q0, int oneelement)
{
	uint q;
	Rune r;

	q = q0;
	while(q &gt; 0){
		r = textreadc(t, q-1);
		if(r &lt;= ' ')
			break;
		if(oneelement &amp;&amp; r=='/')
			break;
		--q;
	}
	return q0-q;
}

Rune*
textcomplete(Text *t)
{
	int i, nstr, npath;
	uint q;
	Rune tmp[200];
	Rune *str, *path;
	Rune *rp;
	Completion *c;
	char *s, *dirs;
	Runestr dir;

	/* control-f: filename completion; works back to white space or / */
	if(t-&gt;q0&lt;t-&gt;file-&gt;nc &amp;&amp; textreadc(t, t-&gt;q0)&gt;' ')	/* must be at end of word */
		return nil;
	nstr = textfilewidth(t, t-&gt;q0, TRUE);
	str = runemalloc(nstr);
	npath = textfilewidth(t, t-&gt;q0-nstr, FALSE);
	path = runemalloc(npath);

	c = nil;
	rp = nil;
	dirs = nil;

	q = t-&gt;q0-nstr;
	for(i=0; i&lt;nstr; i++)
		str[i] = textreadc(t, q++);
	q = t-&gt;q0-nstr-npath;
	for(i=0; i&lt;npath; i++)
		path[i] = textreadc(t, q++);
	/* is path rooted? if not, we need to make it relative to window path */
	if(npath&gt;0 &amp;&amp; path[0]=='/')
		dir = (Runestr){path, npath};
	else{
		dir = dirname(t, nil, 0);
		if(dir.nr + 1 + npath &gt; nelem(tmp)){
			free(dir.r);
			goto Return;
		}
		if(dir.nr == 0){
			dir.nr = 1;
			dir.r = runestrdup(L".");
		}
		runemove(tmp, dir.r, dir.nr);
		tmp[dir.nr] = '/';
		runemove(tmp+dir.nr+1, path, npath);
		free(dir.r);
		dir.r = tmp;
		dir.nr += 1+npath;
		dir = cleanrname(dir);
	}

	s = smprint("%.*S", nstr, str);
	dirs = smprint("%.*S", dir.nr, dir.r);
	c = complete(dirs, s);
	free(s);
	if(c == nil){
		warning(nil, "error attempting completion: %r\n");
		goto Return;
	}

	if(!c-&gt;advance){
		warning(nil, "%.*S%s%.*S*%s\n",
			dir.nr, dir.r,
			dir.nr&gt;0 &amp;&amp; dir.r[dir.nr-1]!='/' ? "/" : "",
			nstr, str,
			c-&gt;nmatch? "" : ": no matches in:");
		for(i=0; i&lt;c-&gt;nfile; i++)
			warning(nil, " %s\n", c-&gt;filename[i]);
	}

	if(c-&gt;advance)
		rp = runesmprint("%s", c-&gt;string);
	else
		rp = nil;
  Return:
	freecompletion(c);
	free(dirs);
	free(str);
	free(path);
	return rp;
}

void
texttype(Text *t, Rune r)
{
	uint q0, q1;
	int nnb, nb, n, i;
	int nr;
	Rune *rp;
	Text *u;

	if(t-&gt;what!=Body &amp;&amp; r=='\n')
		return;
	nr = 1;
	rp = &amp;r;
	switch(r){
	case Kleft:
		if(t-&gt;q0 &gt; 0){
			typecommit(t);
			textshow(t, t-&gt;q0-1, t-&gt;q0-1, TRUE);
		}
		return;
	case Kright:
		if(t-&gt;q1 &lt; t-&gt;file-&gt;nc){
			typecommit(t);
			textshow(t, t-&gt;q1+1, t-&gt;q1+1, TRUE);
		}
		return;
	case Kdown:
		n = t-&gt;maxlines/3;
		goto case_Down;
	case Kscrollonedown:
		n = mousescrollsize(t-&gt;maxlines);
		if(n &lt;= 0)
			n = 1;
		goto case_Down;
	case Kpgdown:
		n = 2*t-&gt;maxlines/3;
	case_Down:
		q0 = t-&gt;org+frcharofpt(t, Pt(t-&gt;r.min.x, t-&gt;r.min.y+n*t-&gt;font-&gt;height));
		textsetorigin(t, q0, TRUE);
		return;
	case Kup:
		n = t-&gt;maxlines/3;
		goto case_Up;
	case Kscrolloneup:
		n = mousescrollsize(t-&gt;maxlines);
		goto case_Up;
	case Kpgup:
		n = 2*t-&gt;maxlines/3;
	case_Up:
		q0 = textbacknl(t, t-&gt;org, n);
		textsetorigin(t, q0, TRUE);
		return;
	case Khome:
		typecommit(t);
		textshow(t, 0, 0, FALSE);
		return;
	case Kend:
		typecommit(t);
		textshow(t, t-&gt;file-&gt;nc, t-&gt;file-&gt;nc, FALSE);
		return;
	case 0x01:	/* ^A: beginning of line */
		typecommit(t);
		/* go to where ^U would erase, if not already at BOL */
		nnb = 0;
		if(t-&gt;q0&gt;0 &amp;&amp; textreadc(t, t-&gt;q0-1)!='\n')
			nnb = textbswidth(t, 0x15);
		textshow(t, t-&gt;q0-nnb, t-&gt;q0-nnb, TRUE);
		return;
	case 0x05:	/* ^E: end of line */
		typecommit(t);
		q0 = t-&gt;q0;
		while(q0&lt;t-&gt;file-&gt;nc &amp;&amp; textreadc(t, q0)!='\n')
			q0++;
		textshow(t, q0, q0, TRUE);
		return;
	}
	if(t-&gt;what == Body){
		seq++;
		filemark(t-&gt;file);
	}
	if(t-&gt;q1 &gt; t-&gt;q0){
		if(t-&gt;ncache != 0)
			error("text.type");
		cut(t, t, nil, TRUE, TRUE, nil, 0);
		t-&gt;eq0 = ~0;
	}
	textshow(t, t-&gt;q0, t-&gt;q0, 1);
	switch(r){
	case 0x06:
	case Kins:
		rp = textcomplete(t);
		if(rp == nil)
			return;
		nr = runestrlen(rp);
		break;	/* fall through to normal insertion case */
	case 0x1B:
		if(t-&gt;eq0 != ~0)
			textsetselect(t, t-&gt;eq0, t-&gt;q0);
		if(t-&gt;ncache &gt; 0)
			typecommit(t);
		return;
	case 0x08:	/* ^H: erase character */
	case 0x15:	/* ^U: erase line */
	case 0x17:	/* ^W: erase word */
		if(t-&gt;q0 == 0)	/* nothing to erase */
			return;
		nnb = textbswidth(t, r);
		q1 = t-&gt;q0;
		q0 = q1-nnb;
		/* if selection is at beginning of window, avoid deleting invisible text */
		if(q0 &lt; t-&gt;org){
			q0 = t-&gt;org;
			nnb = q1-q0;
		}
		if(nnb &lt;= 0)
			return;
		for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
			u = t-&gt;file-&gt;text[i];
			u-&gt;nofill = TRUE;
			nb = nnb;
			n = u-&gt;ncache;
			if(n &gt; 0){
				if(q1 != u-&gt;cq0+n)
					error("text.type backspace");
				if(n &gt; nb)
					n = nb;
				u-&gt;ncache -= n;
				textdelete(u, q1-n, q1, FALSE);
				nb -= n;
			}
			if(u-&gt;eq0==q1 || u-&gt;eq0==~0)
				u-&gt;eq0 = q0;
			if(nb &amp;&amp; u==t)
				textdelete(u, q0, q0+nb, TRUE);
			if(u != t)
				textsetselect(u, u-&gt;q0, u-&gt;q1);
			else
				textsetselect(t, q0, q0);
			u-&gt;nofill = FALSE;
		}
		for(i=0; i&lt;t-&gt;file-&gt;ntext; i++)
			textfill(t-&gt;file-&gt;text[i]);
		return;
	case '\n':
		if(t-&gt;w-&gt;autoindent){
			/* find beginning of previous line using backspace code */
			nnb = textbswidth(t, 0x15); /* ^U case */
			rp = runemalloc(nnb + 1);
			nr = 0;
			rp[nr++] = r;
			for(i=0; i&lt;nnb; i++){
				r = textreadc(t, t-&gt;q0-nnb+i);
				if(r != ' ' &amp;&amp; r != '\t')
					break;
				rp[nr++] = r;
			}
		}
		break; /* fall through to normal code */
	}
	/* otherwise ordinary character; just insert, typically in caches of all texts */
	for(i=0; i&lt;t-&gt;file-&gt;ntext; i++){
		u = t-&gt;file-&gt;text[i];
		if(u-&gt;eq0 == ~0)
			u-&gt;eq0 = t-&gt;q0;
		if(u-&gt;ncache == 0)
			u-&gt;cq0 = t-&gt;q0;
		else if(t-&gt;q0 != u-&gt;cq0+u-&gt;ncache)
			error("text.type cq1");
		textinsert(u, t-&gt;q0, rp, nr, FALSE);
		if(u != t)
			textsetselect(u, u-&gt;q0, u-&gt;q1);
		if(u-&gt;ncache+nr &gt; u-&gt;ncachealloc){
			u-&gt;ncachealloc += 10 + nr;
			u-&gt;cache = runerealloc(u-&gt;cache, u-&gt;ncachealloc);
		}
		runemove(u-&gt;cache+u-&gt;ncache, rp, nr);
		u-&gt;ncache += nr;
	}
	if(rp != &amp;r)
		free(rp);
	textsetselect(t, t-&gt;q0+nr, t-&gt;q0+nr);
	if(r=='\n' &amp;&amp; t-&gt;w!=nil)
		wincommit(t-&gt;w, t);
}

void
textcommit(Text *t, int tofile)
{
	if(t-&gt;ncache == 0)
		return;
	if(tofile)
		fileinsert(t-&gt;file, t-&gt;cq0, t-&gt;cache, t-&gt;ncache);
	if(t-&gt;what == Body){
		t-&gt;w-&gt;dirty = TRUE;
		t-&gt;w-&gt;utflastqid = -1;
	}
	t-&gt;ncache = 0;
}

static	Text	*clicktext;
static	uint	clickmsec;
static	Text	*selecttext;
static	uint	selectq;

/*
 * called from frame library
 */
void
framescroll(Frame *f, int dl)
{
	if(f != &amp;selecttext-&gt;Frame)
		error("frameselect not right frame");
	textframescroll(selecttext, dl);
}

void
textframescroll(Text *t, int dl)
{
	uint q0;

	if(dl == 0){
		scrsleep(100);
		return;
	}
	if(dl &lt; 0){
		q0 = textbacknl(t, t-&gt;org, -dl);
		if(selectq &gt; t-&gt;org+t-&gt;p0)
			textsetselect(t, t-&gt;org+t-&gt;p0, selectq);
		else
			textsetselect(t, selectq, t-&gt;org+t-&gt;p0);
	}else{
		if(t-&gt;org+t-&gt;nchars == t-&gt;file-&gt;nc)
			return;
		q0 = t-&gt;org+frcharofpt(t, Pt(t-&gt;r.min.x, t-&gt;r.min.y+dl*t-&gt;font-&gt;height));
		if(selectq &gt; t-&gt;org+t-&gt;p1)
			textsetselect(t, t-&gt;org+t-&gt;p1, selectq);
		else
			textsetselect(t, selectq, t-&gt;org+t-&gt;p1);
	}
	textsetorigin(t, q0, TRUE);
}


void
textselect(Text *t)
{
	uint q0, q1;
	int b, x, y;
	int state;

	selecttext = t;
	/*
	 * To have double-clicking and chording, we double-click
	 * immediately if it might make sense.
	 */
	b = mouse-&gt;buttons;
	q0 = t-&gt;q0;
	q1 = t-&gt;q1;
	selectq = t-&gt;org+frcharofpt(t, mouse-&gt;xy);
	if(clicktext==t &amp;&amp; mouse-&gt;msec-clickmsec&lt;500)
	if(q0==q1 &amp;&amp; selectq==q0){
		textdoubleclick(t, &amp;q0, &amp;q1);
		textsetselect(t, q0, q1);
		flushimage(display, 1);
		x = mouse-&gt;xy.x;
		y = mouse-&gt;xy.y;
		/* stay here until something interesting happens */
		do
			readmouse(mousectl);
		while(mouse-&gt;buttons==b &amp;&amp; abs(mouse-&gt;xy.x-x)&lt;3 &amp;&amp; abs(mouse-&gt;xy.y-y)&lt;3);
		mouse-&gt;xy.x = x;	/* in case we're calling frselect */
		mouse-&gt;xy.y = y;
		q0 = t-&gt;q0;	/* may have changed */
		q1 = t-&gt;q1;
		selectq = q0;
	}
	if(mouse-&gt;buttons == b){
		t-&gt;Frame.scroll = framescroll;
		frselect(t, mousectl);
		/* horrible botch: while asleep, may have lost selection altogether */
		if(selectq &gt; t-&gt;file-&gt;nc)
			selectq = t-&gt;org + t-&gt;p0;
		t-&gt;Frame.scroll = nil;
		if(selectq &lt; t-&gt;org)
			q0 = selectq;
		else
			q0 = t-&gt;org + t-&gt;p0;
		if(selectq &gt; t-&gt;org+t-&gt;nchars)
			q1 = selectq;
		else
			q1 = t-&gt;org+t-&gt;p1;
	}
	if(q0 == q1){
		if(q0==t-&gt;q0 &amp;&amp; clicktext==t &amp;&amp; mouse-&gt;msec-clickmsec&lt;500){
			textdoubleclick(t, &amp;q0, &amp;q1);
			clicktext = nil;
		}else{
			clicktext = t;
			clickmsec = mouse-&gt;msec;
		}
	}else
		clicktext = nil;
	textsetselect(t, q0, q1);
	flushimage(display, 1);
	state = 0;	/* undo when possible; +1 for cut, -1 for paste */
	while(mouse-&gt;buttons){
		mouse-&gt;msec = 0;
		b = mouse-&gt;buttons;
		if((b&amp;1) &amp;&amp; (b&amp;6)){
			if(state==0 &amp;&amp; t-&gt;what==Body){
				seq++;
				filemark(t-&gt;w-&gt;body.file);
			}
			if(b &amp; 2){
				if(state==-1 &amp;&amp; t-&gt;what==Body){
					winundo(t-&gt;w, TRUE);
					textsetselect(t, q0, t-&gt;q0);
					state = 0;
				}else if(state != 1){
					cut(t, t, nil, TRUE, TRUE, nil, 0);
					state = 1;
				}
			}else{
				if(state==1 &amp;&amp; t-&gt;what==Body){
					winundo(t-&gt;w, TRUE);
					textsetselect(t, q0, t-&gt;q1);
					state = 0;
				}else if(state != -1){
					paste(t, t, nil, TRUE, FALSE, nil, 0);
					state = -1;
				}
			}
			textscrdraw(t);
			clearmouse();
		}
		flushimage(display, 1);
		while(mouse-&gt;buttons == b)
			readmouse(mousectl);
		clicktext = nil;
	}
}

void
textshow(Text *t, uint q0, uint q1, int doselect)
{
	int qe;
	int nl;
	uint q;

	if(t-&gt;what != Body){
		if(doselect)
			textsetselect(t, q0, q1);
		return;
	}
	if(t-&gt;w!=nil &amp;&amp; t-&gt;maxlines==0)
		colgrow(t-&gt;col, t-&gt;w, 1);
	if(doselect)
		textsetselect(t, q0, q1);
	qe = t-&gt;org+t-&gt;nchars;
	if(t-&gt;org&lt;=q0 &amp;&amp; (q0&lt;qe || (q0==qe &amp;&amp; qe==t-&gt;file-&gt;nc+t-&gt;ncache)))
		textscrdraw(t);
	else{
		if(t-&gt;w-&gt;nopen[QWevent] &gt; 0)
			nl = 3*t-&gt;maxlines/4;
		else
			nl = t-&gt;maxlines/4;
		q = textbacknl(t, q0, nl);
		/* avoid going backwards if trying to go forwards - long lines! */
		if(!(q0&gt;t-&gt;org &amp;&amp; q&lt;t-&gt;org))
			textsetorigin(t, q, TRUE);
		while(q0 &gt; t-&gt;org+t-&gt;nchars)
			textsetorigin(t, t-&gt;org+1, FALSE);
	}
}

static
int
region(int a, int b)
{
	if(a &lt; b)
		return -1;
	if(a == b)
		return 0;
	return 1;
}

void
selrestore(Frame *f, Point pt0, uint p0, uint p1)
{
	if(p1&lt;=f-&gt;p0 || p0&gt;=f-&gt;p1){
		/* no overlap */
		frdrawsel0(f, pt0, p0, p1, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		return;
	}
	if(p0&gt;=f-&gt;p0 &amp;&amp; p1&lt;=f-&gt;p1){
		/* entirely inside */
		frdrawsel0(f, pt0, p0, p1, f-&gt;cols[HIGH], f-&gt;cols[HTEXT]);
		return;
	}

	/* they now are known to overlap */

	/* before selection */
	if(p0 &lt; f-&gt;p0){
		frdrawsel0(f, pt0, p0, f-&gt;p0, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		p0 = f-&gt;p0;
		pt0 = frptofchar(f, p0);
	}
	/* after selection */
	if(p1 &gt; f-&gt;p1){
		frdrawsel0(f, frptofchar(f, f-&gt;p1), f-&gt;p1, p1, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		p1 = f-&gt;p1;
	}
	/* inside selection */
	frdrawsel0(f, pt0, p0, p1, f-&gt;cols[HIGH], f-&gt;cols[HTEXT]);
}

void
textsetselect(Text *t, uint q0, uint q1)
{
	int p0, p1;

	/* t-&gt;p0 and t-&gt;p1 are always right; t-&gt;q0 and t-&gt;q1 may be off */
	t-&gt;q0 = q0;
	t-&gt;q1 = q1;
	/* compute desired p0,p1 from q0,q1 */
	p0 = q0-t-&gt;org;
	p1 = q1-t-&gt;org;
	if(p0 &lt; 0)
		p0 = 0;
	if(p1 &lt; 0)
		p1 = 0;
	if(p0 &gt; t-&gt;nchars)
		p0 = t-&gt;nchars;
	if(p1 &gt; t-&gt;nchars)
		p1 = t-&gt;nchars;
	if(p0==t-&gt;p0 &amp;&amp; p1==t-&gt;p1)
		return;
	/* screen disagrees with desired selection */
	if(t-&gt;p1&lt;=p0 || p1&lt;=t-&gt;p0 || p0==p1 || t-&gt;p1==t-&gt;p0){
		/* no overlap or too easy to bother trying */
		frdrawsel(t, frptofchar(t, t-&gt;p0), t-&gt;p0, t-&gt;p1, 0);
		frdrawsel(t, frptofchar(t, p0), p0, p1, 1);
		goto Return;
	}
	/* overlap; avoid unnecessary painting */
	if(p0 &lt; t-&gt;p0){
		/* extend selection backwards */
		frdrawsel(t, frptofchar(t, p0), p0, t-&gt;p0, 1);
	}else if(p0 &gt; t-&gt;p0){
		/* trim first part of selection */
		frdrawsel(t, frptofchar(t, t-&gt;p0), t-&gt;p0, p0, 0);
	}
	if(p1 &gt; t-&gt;p1){
		/* extend selection forwards */
		frdrawsel(t, frptofchar(t, t-&gt;p1), t-&gt;p1, p1, 1);
	}else if(p1 &lt; t-&gt;p1){
		/* trim last part of selection */
		frdrawsel(t, frptofchar(t, p1), p1, t-&gt;p1, 0);
	}

    Return:
	t-&gt;p0 = p0;
	t-&gt;p1 = p1;
}

/*
 * Release the button in less than DELAY ms and it's considered a null selection
 * if the mouse hardly moved, regardless of whether it crossed a char boundary.
 */
enum {
	DELAY = 2,
	MINMOVE = 4,
};

uint
xselect(Frame *f, Mousectl *mc, Image *col, uint *p1p)	/* when called, button is down */
{
	uint p0, p1, q, tmp;
	ulong msec;
	Point mp, pt0, pt1, qt;
	int reg, b;

	mp = mc-&gt;xy;
	b = mc-&gt;buttons;
	msec = mc-&gt;msec;

	/* remove tick */
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 0);
	p0 = p1 = frcharofpt(f, mp);
	pt0 = frptofchar(f, p0);
	pt1 = frptofchar(f, p1);
	reg = 0;
	frtick(f, pt0, 1);
	do{
		q = frcharofpt(f, mc-&gt;xy);
		if(p1 != q){
			if(p0 == p1)
				frtick(f, pt0, 0);
			if(reg != region(q, p0)){	/* crossed starting point; reset */
				if(reg &gt; 0)
					selrestore(f, pt0, p0, p1);
				else if(reg &lt; 0)
					selrestore(f, pt1, p1, p0);
				p1 = p0;
				pt1 = pt0;
				reg = region(q, p0);
				if(reg == 0)
					frdrawsel0(f, pt0, p0, p1, col, display-&gt;white);
			}
			qt = frptofchar(f, q);
			if(reg &gt; 0){
				if(q &gt; p1)
					frdrawsel0(f, pt1, p1, q, col, display-&gt;white);

				else if(q &lt; p1)
					selrestore(f, qt, q, p1);
			}else if(reg &lt; 0){
				if(q &gt; p1)
					selrestore(f, pt1, p1, q);
				else
					frdrawsel0(f, qt, q, p1, col, display-&gt;white);
			}
			p1 = q;
			pt1 = qt;
		}
		if(p0 == p1)
			frtick(f, pt0, 1);
		flushimage(f-&gt;display, 1);
		readmouse(mc);
	}while(mc-&gt;buttons == b);
	if(mc-&gt;msec-msec &lt; DELAY &amp;&amp; p0!=p1
	&amp;&amp; abs(mp.x-mc-&gt;xy.x)&lt;MINMOVE
	&amp;&amp; abs(mp.y-mc-&gt;xy.y)&lt;MINMOVE) {
		if(reg &gt; 0)
			selrestore(f, pt0, p0, p1);
		else if(reg &lt; 0)
			selrestore(f, pt1, p1, p0);
		p1 = p0;
	}
	if(p1 &lt; p0){
		tmp = p0;
		p0 = p1;
		p1 = tmp;
	}
	pt0 = frptofchar(f, p0);
	if(p0 == p1)
		frtick(f, pt0, 0);
	selrestore(f, pt0, p0, p1);
	/* restore tick */
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 1);
	flushimage(f-&gt;display, 1);
	*p1p = p1;
	return p0;
}

int
textselect23(Text *t, uint *q0, uint *q1, Image *high, int mask)
{
	uint p0, p1;
	int buts;
	
	p0 = xselect(t, mousectl, high, &amp;p1);
	buts = mousectl-&gt;buttons;
	if((buts &amp; mask) == 0){
		*q0 = p0+t-&gt;org;
		*q1 = p1+t-&gt;org;
	}

	while(mousectl-&gt;buttons)
		readmouse(mousectl);
	return buts;
}

int
textselect2(Text *t, uint *q0, uint *q1, Text **tp)
{
	int buts;

	*tp = nil;
	buts = textselect23(t, q0, q1, but2col, 4);
	if(buts &amp; 4)
		return 0;
	if(buts &amp; 1){	/* pick up argument */
		*tp = argtext;
		return 1;
	}
	return 1;
}

int
textselect3(Text *t, uint *q0, uint *q1)
{
	int h;

	h = (textselect23(t, q0, q1, but3col, 1|2) == 0);
	return h;
}

static Rune left1[] =  { L'{', L'[', L'(', L'&lt;', L'«', 0 };
static Rune right1[] = { L'}', L']', L')', L'&gt;', L'»', 0 };
static Rune left2[] =  { L'\n', 0 };
static Rune left3[] =  { L'\'', L'"', L'`', 0 };

static
Rune *left[] = {
	left1,
	left2,
	left3,
	nil
};
static
Rune *right[] = {
	right1,
	left2,
	left3,
	nil
};

void
textdoubleclick(Text *t, uint *q0, uint *q1)
{
	int c, i;
	Rune *r, *l, *p;
	uint q;

	for(i=0; left[i]!=nil; i++){
		q = *q0;
		l = left[i];
		r = right[i];
		/* try matching character to left, looking right */
		if(q == 0)
			c = '\n';
		else
			c = textreadc(t, q-1);
		p = runestrchr(l, c);
		if(p != nil){
			if(textclickmatch(t, c, r[p-l], 1, &amp;q))
				*q1 = q-(c!='\n');
			return;
		}
		/* try matching character to right, looking left */
		if(q == t-&gt;file-&gt;nc)
			c = '\n';
		else
			c = textreadc(t, q);
		p = runestrchr(r, c);
		if(p != nil){
			if(textclickmatch(t, c, l[p-r], -1, &amp;q)){
				*q1 = *q0+(*q0&lt;t-&gt;file-&gt;nc &amp;&amp; c=='\n');
				*q0 = q;
				if(c!='\n' || q!=0 || textreadc(t, 0)=='\n')
					(*q0)++;
			}
			return;
		}
	}
	/* try filling out word to right */
	while(*q1&lt;t-&gt;file-&gt;nc &amp;&amp; isalnum(textreadc(t, *q1)))
		(*q1)++;
	/* try filling out word to left */
	while(*q0&gt;0 &amp;&amp; isalnum(textreadc(t, *q0-1)))
		(*q0)--;
}

int
textclickmatch(Text *t, int cl, int cr, int dir, uint *q)
{
	Rune c;
	int nest;

	nest = 1;
	for(;;){
		if(dir &gt; 0){
			if(*q == t-&gt;file-&gt;nc)
				break;
			c = textreadc(t, *q);
			(*q)++;
		}else{
			if(*q == 0)
				break;
			(*q)--;
			c = textreadc(t, *q);
		}
		if(c == cr){
			if(--nest==0)
				return 1;
		}else if(c == cl)
			nest++;
	}
	return cl=='\n' &amp;&amp; nest==1;
}

uint
textbacknl(Text *t, uint p, uint n)
{
	int i, j;

	/* look for start of this line if n==0 */
	if(n==0 &amp;&amp; p&gt;0 &amp;&amp; textreadc(t, p-1)!='\n')
		n = 1;
	i = n;
	while(i--&gt;0 &amp;&amp; p&gt;0){
		--p;	/* it's at a newline now; back over it */
		if(p == 0)
			break;
		/* at 128 chars, call it a line anyway */
		for(j=128; --j&gt;0 &amp;&amp; p&gt;0; p--)
			if(textreadc(t, p-1)=='\n')
				break;
	}
	return p;
}

void
textsetorigin(Text *t, uint org, int exact)
{
	int i, a, fixup;
	Rune *r;
	uint n;

	if(org&gt;0 &amp;&amp; !exact){
		/* org is an estimate of the char posn; find a newline */
		/* don't try harder than 256 chars */
		for(i=0; i&lt;256 &amp;&amp; org&lt;t-&gt;file-&gt;nc; i++){
			if(textreadc(t, org) == '\n'){
				org++;
				break;
			}
			org++;
		}
	}
	a = org-t-&gt;org;
	fixup = 0;
	if(a&gt;=0 &amp;&amp; a&lt;t-&gt;nchars){
		frdelete(t, 0, a);
		fixup = 1;	/* frdelete can leave end of last line in wrong selection mode; it doesn't know what follows */
	}
	else if(a&lt;0 &amp;&amp; -a&lt;t-&gt;nchars){
		n = t-&gt;org - org;
		r = runemalloc(n);
		bufread(t-&gt;file, org, r, n);
		frinsert(t, r, r+n, 0);
		free(r);
	}else
		frdelete(t, 0, t-&gt;nchars);
	t-&gt;org = org;
	textfill(t);
	textscrdraw(t);
	textsetselect(t, t-&gt;q0, t-&gt;q1);
	if(fixup &amp;&amp; t-&gt;p1 &gt; t-&gt;p0)
		frdrawsel(t, frptofchar(t, t-&gt;p1-1), t-&gt;p1-1, t-&gt;p1, 1);
}

void
textreset(Text *t)
{
	t-&gt;file-&gt;seq = 0;
	t-&gt;eq0 = ~0;
	/* do t-&gt;delete(0, t-&gt;nc, TRUE) without building backup stuff */
	textsetselect(t, t-&gt;org, t-&gt;org);
	frdelete(t, 0, t-&gt;nchars);
	t-&gt;org = 0;
	t-&gt;q0 = 0;
	t-&gt;q1 = 0;
	filereset(t-&gt;file);
	bufreset(t-&gt;file);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

