<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/alarm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/alarm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static struct {
	int thread;
	int die;
	QLock;
	NbnsAlarm *head;
} alarmlist = { -1 };

#define MaxLong ((1 &lt;&lt; (sizeof(long) * 8 - 1)) - 1)

void
alarmist(void *)
{
	for (;;) {
		vlong now;
		long snooze;
//print("running\n");
		qlock(&amp;alarmlist);
		if (alarmlist.die) {
			qunlock(&amp;alarmlist);
			break;
		}
		now = nsec() / 1000000;
		while (alarmlist.head &amp;&amp; alarmlist.head-&gt;expirems &lt;= now) {
//print("expiring because %lld &gt; %lld\n", alarmlist.head-&gt;expirems, now);
			sendul(alarmlist.head-&gt;c, 1);
			alarmlist.head = alarmlist.head-&gt;next;
		}
		if (alarmlist.head) {
			vlong vsnooze = alarmlist.head-&gt;expirems - now;
			if (vsnooze &gt; MaxLong)
				snooze = MaxLong;
			else
				snooze = vsnooze;
		}
		else
			snooze = 60 * 1000;
//print("snoozing for %ld\n", snooze);
		qunlock(&amp;alarmlist);
		sleep(snooze);
	}
}

NbnsAlarm *
nbnsalarmnew(void)
{
	NbnsAlarm *a;
	a = mallocz(sizeof(*a), 1);
	if (a == nil)
		return nil;
	a-&gt;c = chancreate(sizeof(ulong), 1);
	if (a-&gt;c == nil) {
		free(a);
		return nil;
	}
	return a;
}

void
nbnsalarmcancel(NbnsAlarm *a)
{
	NbnsAlarm **ap;
	int rv;
	qlock(&amp;alarmlist);
	for (ap = &amp;alarmlist.head; *ap &amp;&amp; *ap != a; ap = &amp;(*ap)-&gt;next)
		;
	if (*ap) {
		*ap = a-&gt;next;
		if (ap == &amp;alarmlist.head)
			threadint(alarmlist.thread);
	}
	qunlock(&amp;alarmlist);
	do {
		ulong v;
		rv = nbrecv(a-&gt;c, &amp;v);
	} while (rv != 0);
}

void
nbnsalarmend(void)
{
	qlock(&amp;alarmlist);
	if (alarmlist.thread &gt;= 0) {
		alarmlist.die = 1;
		threadint(alarmlist.thread);
	}
	qunlock(&amp;alarmlist);
}

void
nbnsalarmset(NbnsAlarm *a, ulong millisec)
{
	NbnsAlarm **ap;
	nbnsalarmcancel(a);
	a-&gt;expirems = nsec() / 1000000 + millisec;
	qlock(&amp;alarmlist);
	for (ap = &amp;alarmlist.head; *ap; ap = &amp;(*ap)-&gt;next)
		if (a-&gt;expirems &lt; (*ap)-&gt;expirems)
			break;
	a-&gt;next = (*ap);
	*ap = a;
	if (alarmlist.thread &lt; 0)
		alarmlist.thread = proccreate(alarmist, nil, 16384);
	else
		threadint(alarmlist.thread);
	qunlock(&amp;alarmlist);
}

void
nbnsalarmfree(NbnsAlarm **ap)
{
	NbnsAlarm *a;
	a = *ap;
	if (a) {
		nbnsalarmcancel(a);
		chanfree(a-&gt;c);
		free(a);
		*ap = nil;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

