<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/aquarela.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/aquarela.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"
#include &lt;pool.h&gt;

static void
disconnecttree(void *magic, void *arg)
{
	smbtreedisconnect((SmbSession *)magic, (SmbTree *)arg);
}

static void
closesearch(void *magic, void *arg)
{
	smbsearchclose((SmbSession *)magic, (SmbSearch *)arg);
}

static void
smbsessionfree(SmbSession *s)
{
	if (s) {
		smbidmapfree(&amp;s-&gt;tidmap, disconnecttree, s);
		smbidmapfree(&amp;s-&gt;sidmap, closesearch, s);
		smbbufferfree(&amp;s-&gt;response);
		free(s-&gt;client.accountname);
		free(s-&gt;client.primarydomain);
		free(s-&gt;client.nativeos);
		free(s-&gt;client.nativelanman);
		free(s-&gt;transaction.in.parameters);
		free(s-&gt;transaction.in.data);
		free(s-&gt;transaction.in.setup);
		free(s-&gt;transaction.in.name);
		smbbufferfree(&amp;s-&gt;transaction.out.parameters);
		smbbufferfree(&amp;s-&gt;transaction.out.data);
		auth_freechal(s-&gt;cs);
		free(s);
	}
}

int
smbsessionwrite(SmbSession *smbs, void *p, long n)
{
	SmbHeader h;
	SmbOpTableEntry *ote;
	uchar *pdata;
	int rv;
	SmbBuffer *b = nil;
	ushort bytecount;
	SmbProcessResult pr;

	if (smbs-&gt;response == nil)
		smbs-&gt;response = smbbuffernew(576);
	else
		smbresponsereset(smbs);
	smbs-&gt;errclass = SUCCESS;
	smbs-&gt;error = SUCCESS;
//	print("received %ld bytes\n", n);
	if (n &lt;= 0)
		goto closedown;
	b = smbbufferinit(p, p, n);
	if (!smbbuffergetheader(b, &amp;h, &amp;pdata, &amp;bytecount)) {
		smblogprint(-1, "smb: invalid header\n");
		goto closedown;
	}
smbloglock();
smblogprint(h.command, "received:\n");
smblogdata(h.command, smblogprint, p, n, 0x1000);
smblogunlock();
	ote = smboptable + h.command;
	if (ote-&gt;name == nil) {
		smblogprint(-1, "smb: illegal opcode 0x%.2ux\n", h.command);
		goto unimp;
	}
	if (ote-&gt;process == nil) {
		smblogprint(-1, "smb: opcode %s unimplemented\n", ote-&gt;name);
		goto unimp;
	}
	if (smbs-&gt;nextcommand != SMB_COM_NO_ANDX_COMMAND
		&amp;&amp; smbs-&gt;nextcommand != h.command) {
		smblogprint(-1, "smb: wrong command - expected %.2ux\n", smbs-&gt;nextcommand);
		goto misc;
	}
	smbs-&gt;nextcommand = SMB_COM_NO_ANDX_COMMAND;
	switch (h.command) {
	case SMB_COM_NEGOTIATE:
	case SMB_COM_SESSION_SETUP_ANDX:
	case SMB_COM_TREE_CONNECT_ANDX:
	case SMB_COM_ECHO:
		break;
	default:
		if (smbs-&gt;state != SmbSessionEstablished) {
			smblogprint(-1, "aquarela: command %.2ux unexpected\n", h.command);
			goto unimp;
		}
	}
	pr = (*ote-&gt;process)(smbs, &amp;h, pdata, b);
	switch (pr) {
	case SmbProcessResultUnimp:
	unimp:
		smbseterror(smbs, ERRDOS, ERRunsup);
		pr = SmbProcessResultError;
		break;
	case SmbProcessResultFormat:
		smbseterror(smbs, ERRSRV, ERRsmbcmd);
		pr = SmbProcessResultError;
		break;
	case SmbProcessResultMisc:
	misc:
		smbseterror(smbs, ERRSRV, ERRerror);
		pr = SmbProcessResultError;
		break;
	}
	if (pr == SmbProcessResultError) {
		smblogprint(h.command, "reply: error %d/%d\n", smbs-&gt;errclass, smbs-&gt;error);
		if (!smbresponseputerror(smbs, &amp;h, smbs-&gt;errclass, smbs-&gt;error))
			pr = SmbProcessResultDie;
		else
			pr = SmbProcessResultReply;
	}
	else
		smblogprint(h.command, "reply: ok\n");
	if (pr == SmbProcessResultReply)
		rv = smbresponsesend(smbs) == SmbProcessResultOk ? 0 : -1;
	else if (pr == SmbProcessResultDie)
		rv = -1;
	else
		rv = 0;
	goto done;
closedown:
	rv = -1;
done:
	if (rv &lt; 0) {
		smblogprintif(smbglobals.log.sessions, "shutting down\n");
		smbsessionfree(smbs);
	}
	smbbufferfree(&amp;b);
	if (smbglobals.log.poolparanoia)
		poolcheck(mainmem);
	return rv;
}

static int
nbwrite(NbSession *nbss, void *p, long n)
{
	return smbsessionwrite((SmbSession *)nbss-&gt;magic, p, n);
}

static int
cifswrite(SmbCifsSession *cifs, void *p, long n)
{
	return smbsessionwrite((SmbSession *)cifs-&gt;magic, p, n);
}

int
nbssaccept(void *, NbSession *s, NBSSWRITEFN **writep)
{
	SmbSession *smbs = smbemallocz(sizeof(SmbSession), 1);
	smbs-&gt;nbss = s;
	s-&gt;magic = smbs;
	smbs-&gt;nextcommand = SMB_COM_NO_ANDX_COMMAND;
	*writep = nbwrite;
	smblogprintif(smbglobals.log.sessions, "netbios session started\n");
	return 1;
}

int
cifsaccept(SmbCifsSession *s, SMBCIFSWRITEFN **writep)
{
	SmbSession *smbs = smbemallocz(sizeof(SmbSession), 1);
	smbs-&gt;cifss = s;
	s-&gt;magic = smbs;
	smbs-&gt;nextcommand = SMB_COM_NO_ANDX_COMMAND;
	*writep = cifswrite;
	smblogprintif(smbglobals.log.sessions, "cifs session started\n");
	return 1;
}

void
usage(void)
{
	fprint(2, "usage: %s [-np] [-d debug] [-u N] [-w workgroup]\n", argv0);
	threadexitsall("usage");
}

static void
logset(char *cmd)
{
	int x;
	if (strcmp(cmd, "allcmds") == 0) {
		for (x = 0; x &lt; 256; x++)
			smboptable[x].debug = 1;
		for (x = 0; x &lt; smbtrans2optablesize; x++)
			smbtrans2optable[x].debug = 1;
		return;
	}
	if (strcmp(cmd, "tids") == 0) {
		smbglobals.log.tids = 1;
		return;
	}
	if (strcmp(cmd, "sids") == 0) {
		smbglobals.log.sids = 1;
		return;
	}
	if (strcmp(cmd, "fids") == 0) {
		smbglobals.log.fids = 1;
		return;
	}
	if (strcmp(cmd, "rap2") == 0) {
		smbglobals.log.rap2 = 1;
		return;
	}
	else if (strcmp(cmd, "find") == 0) {
		smbglobals.log.find = 1;
		return;
	}
	if (strcmp(cmd, "query") == 0) {
		smbglobals.log.query = 1;
		return;
	}
	if (strcmp(cmd, "sharedfiles") == 0) {
		smbglobals.log.sharedfiles = 1;
		return;
	}
	if (strcmp(cmd, "poolparanoia") == 0) {
		mainmem-&gt;flags |= POOL_PARANOIA;
		smbglobals.log.poolparanoia = 1;
		return;
	}
	if (strcmp(cmd, "sessions") == 0) {
		smbglobals.log.sessions = 1;
		return;
	}
	if (strcmp(cmd, "rep") == 0) {
		smbglobals.log.rep = 1;
		return;
	}
	if (strcmp(cmd, "locks") == 0) {
		smbglobals.log.locks = 1;
		return;
	}

	for (x = 0; x &lt; 256; x++)
		if (smboptable[x].name &amp;&amp; strcmp(smboptable[x].name, cmd) == 0) {
			smboptable[x].debug = 1;
			return;
		}
	for (x = 0; x &lt; smbtrans2optablesize; x++)
		if (smbtrans2optable[x].name &amp;&amp; strcmp(smbtrans2optable[x].name, cmd) == 0) {
			smbtrans2optable[x].debug = 1;
			return;
		}
	if (strlen(cmd) == 4 &amp;&amp; cmd[0] == '0' &amp;&amp; cmd[1] == 'x') {
		int c;
		c = strtoul(cmd + 2, 0, 16);
		if (c &gt;= 0 &amp;&amp; c &lt;= 255) {
			smboptable[c].debug = 1;
			return;
		}
	}
	print("debugging command %s not recognised\n", cmd);
}


void
threadmain(int argc, char **argv)
{
	NbName from, to;
	char *e = nil;
	int netbios = 0;
	ARGBEGIN {
	case 'u':
		smbglobals.unicode = strtol(ARGF(), 0, 0) != 0;
		break;
	case 'p':
		smbglobals.log.print = 1;
		break;
	case 'd':
		logset(ARGF());
		break;
	case 'w':
		smbglobals.primarydomain = ARGF();
		break;
	case 'n':
		netbios = 1;
		break;
	default:
		usage();
	} ARGEND;
	smbglobalsguess(0);
	smblistencifs(cifsaccept);
	if (netbios) {
		nbinit();
		nbmknamefromstring(from, "*");
		nbmknamefromstring(to, "*smbserver\\x20");
		nbsslisten(to, from, nbssaccept, nil);
		nbmknamefromstringandtype(to, smbglobals.serverinfo.name, 0x20);
		nbsslisten(to, from, nbssaccept, nil);
	}
	smblogprint(-1, "Aquarela %d.%d running\n", smbglobals.serverinfo.vmaj, smbglobals.serverinfo.vmin);
	for (;;) {
		if (netbios&amp;&amp; !smbbrowsesendhostannouncement(smbglobals.serverinfo.name, 60 * 1000,
			SV_TYPE_SERVER,
			smbglobals.serverinfo.remark, &amp;e)) {
			smblogprint(-1, "hostannounce failed: %s\n", e);
		}
		if (sleep(60 * 1000) &lt; 0)
			break;
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

