<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/cifscmd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/cifscmd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"
#include &lt;bio.h&gt;

SmbClient *c;
Biobuf bin, bout;
static int verbose = 1;

#define	SEP(c)	(((c)==' ')||((c)=='\t')||((c)=='\n'))

typedef struct Slut {
	char *name;
	int val;
} Slut;

static char *
tokenise(char *s, char **start, char **end)
{
	char *to;
	Rune r;
	int n;

	while(*s &amp;&amp; SEP(*s))				/* skip leading white space */
		s++;
	to = *start = s;
	while(*s){
		n = chartorune(&amp;r, s);
		if(SEP(r)){
			if(to != *start)		/* we have data */
				break;
			s += n;				/* null string - keep looking */
			while(*s &amp;&amp; SEP(*s))	
				s++;
			to = *start = s;
		} 
		else if(r == '\''){
			s += n;				/* skip leading quote */
			while(*s){
				n = chartorune(&amp;r, s);
				if(r == '\''){
					if(s[1] != '\'')
						break;
					s++;		/* embedded quote */
				}
				while (n--)
					*to++ = *s++;
			}
			if(!*s)				/* no trailing quote */
				break;
			s++;				/* skip trailing quote */ 
		}
		else  {
			while(n--)
				*to++ = *s++;
		}
	}
	*end = to;
	return s;
}

static int
parse(char *s, char *fields[], int nfields)
{
	int c, argc;
	char *start, *end;

	argc = 0;
	c = *s;
	while(c){
		s = tokenise(s, &amp;start, &amp;end);
		c = *s++;
		if(*start == 0)
			break;
		if(argc &gt;= nfields-1)
			return -1;
		*end = 0;
		fields[argc++] = start;
	}
	fields[argc] = 0;
Bprint(&amp;bout, "parse returns %d\n", argc);
	return argc;
}

typedef struct {
	char *name;
	long (*f)(SmbClient *, int, char *[]);
	int connected;
	char *help;
} Cmd;
static Cmd cmd[];

static long
cmdhelp(SmbClient *, int argc, char *argv[])
{
	Cmd *cp;
	char *p;

	if(argc)
		p = argv[0];
	else
		p = 0;
	for (cp = cmd; cp-&gt;name; cp++) {
		if (p == 0 || strcmp(p, cp-&gt;name) == 0)
			Bprint(&amp;bout, "%s\n", cp-&gt;help);
	}
	return 0;
}

static Slut sharemodeslut[] = {
	{ "compatibility", SMB_OPEN_MODE_SHARE_COMPATIBILITY },
	{ "exclusive", SMB_OPEN_MODE_SHARE_EXCLUSIVE },
	{ "denywrite", SMB_OPEN_MODE_SHARE_DENY_WRITE },
	{ "denyread", SMB_OPEN_MODE_SHARE_DENY_READOREXEC },
	{ "denynone", SMB_OPEN_MODE_SHARE_DENY_NONE },
	{ 0 }
};

static Slut openmodeslut[] = {
	{ "oread", OREAD },
	{ "owrite", OWRITE },
	{ "ordwr", ORDWR },
	{ "oexec", OEXEC },
	{ 0 }
};

static int
slut(Slut *s, char *pat)
{
	while (s-&gt;name) {
		if (cistrcmp(s-&gt;name, pat) == 0)
			return s-&gt;val;
		s++;
	}
	Bprint(&amp;bout, "%s unrecognised\n", pat);
	return -1;	
}

static long
cmdopen(SmbClient *c, int argc, char *argv[])
{
	char *errmsg;
	int sm, om;
	int rv;
	uchar errclass;
	ushort error;
	ushort fid, attr;
	ulong mtime, size;
	ushort accessallowed;

	if (argc != 3) {
		Bprint(&amp;bout, "wrong number of arguments\n");
		return -1;
	}
	sm = slut(sharemodeslut, argv[1]);
	if (sm &lt; 0) 
		return -1;
	om = slut(openmodeslut, argv[2]);
	if (om &lt; 0)
		return -1;
	errmsg = nil;
	rv = smbclientopen(c, (sm &lt;&lt; 3) | om, argv[0], &amp;errclass, &amp;error, &amp;fid, &amp;attr, &amp;mtime, &amp;size, &amp;accessallowed, &amp;errmsg);
	if (rv == 0) {
		if (errmsg) {
			print("local error %s\n", errmsg);
			free(errmsg);
			return -1;
		}
		return (errclass &lt;&lt; 16) | error;
	}
	print("fid 0x%.4ux attr 0x%.4ux time %ld size %lud accessallowed %ud\n",
		fid, attr, mtime, size, accessallowed);
	return 0;
}

static Cmd cmd[] = {
	{ "help",	cmdhelp,	0, "help" },
	{ "open", cmdopen, 1, "open name sharemode openmode" },
	{ 0, 0 },
};

void
threadmain(int argc, char *argv[])
{
	char *errmsg;
	int ac;
	char *ap, *av[256];
	Cmd *cp;
	long status;

	if (argc &gt; 3) {
		print("usage: cifscmd [to [share]]\n");
		exits("args");
	}
	smbglobalsguess(1);
	errmsg = nil;

	if (Binit(&amp;bin, 0, OREAD) == Beof || Binit(&amp;bout, 1, OWRITE) == Beof) {
		fprint(2, "%s: can't init bio: %r\n", argv0);
		threadexits("Binit");
	}

	if (argc &gt; 1) {
		c = smbconnect(argv[1], argc == 3 ? argv[2] : nil, &amp;errmsg);
		if (c == nil)
			fprint(2, "failed to connect: %s\n", errmsg);
	}
	while (ap = Brdline(&amp;bin, '\n')) {
		ap[Blinelen(&amp;bin) - 1] = 0;
		switch (ac = parse(ap, av, nelem(av))) {
		default:
			for (cp = cmd; cp-&gt;name; cp++) {
				if (strcmp(cp-&gt;name, av[0]) == 0)
					break;
			}
			if (cp-&gt;name == 0) {
				Bprint(&amp;bout, "eh?\n");
				break;
			}
			if (c == 0 &amp;&amp; cp-&gt;connected) {
				Bprint(&amp;bout, "not currently connected\n");
				break;
			}
			if ((status = (*cp-&gt;f)(c, ac - 1, &amp;av[1])) != -1) {
				if(verbose)
					Bprint(&amp;bout, "ok %ld/%ld\n", status &gt;&gt; 16, status &amp; 0xffff);
				break;
			}
			break;

		case -1:
			Bprint(&amp;bout, "eh?\n");
			break;

		case 0:
			break;
		}
		Bflush(&amp;bout);
	}
	threadexits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

