<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/nbdgramconv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/nbdgramconv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

int
nbdgramconvM2S(NbDgram *s, uchar *ap, uchar *ep)
{
	uchar *p = ap;
	int n;
	ushort length;

	if (ap + 6 + IPv4addrlen &gt; ep)
		return 0;
	s-&gt;type = *p++;
	s-&gt;flags = *p++;
	s-&gt;id = nhgets(p); p+= 2;
	v4tov6(s-&gt;srcip, p); p+= IPv4addrlen;
	s-&gt;srcport = nhgets(p); p += 2;
	switch (s-&gt;type) {
	case NbDgramDirectUnique:
	case NbDgramDirectGroup:
	case NbDgramBroadcast:
		if (p + 4 &gt; ep)
			return 0;
		length = nhgets(p); p += 2;
		s-&gt;datagram.offset = nhgets(p); p += 2;
		if (p + length &gt; ep)
			return 0;
		ep = p + length;
		n = nbnamedecode(p, p, ep, s-&gt;datagram.srcname);
		if (n == 0)
			return 0;
		p += n;
		n = nbnamedecode(p, p, ep, s-&gt;datagram.dstname);
		if (n == 0)
			return 0;
		p += n;
		s-&gt;datagram.data = p;
		s-&gt;datagram.length = ep - p;
		p = ep;
		break;
	case NbDgramError:
		if (p + 1 &gt; ep)
			return 0;
		s-&gt;error.code = *p++;
		break;
	case NbDgramQueryRequest:
	case NbDgramPositiveQueryResponse:
	case NbDgramNegativeQueryResponse:
		n = nbnamedecode(p, p, ep, s-&gt;query.dstname);
		if (n == 0)
			return 0;
		p += n;
		break;
	default:
		return 0;
	}
	return p - ap;
}

int
nbdgramconvS2M(uchar *ap, uchar *ep, NbDgram *s)
{
	uchar *p = ap;
	uchar *fixup;
	int n;

	if (p + 6 + IPv4addrlen &gt; ep)
		return 0;
	*p++ = s-&gt;type;
	*p++ = s-&gt;flags;
	hnputs(p, s-&gt;id); p+= 2;
	v6tov4(p, s-&gt;srcip); p += IPv4addrlen;
	hnputs(p, s-&gt;srcport); p+= 2;
	switch (s-&gt;type) {
	case NbDgramDirectUnique:
	case NbDgramDirectGroup:
	case NbDgramBroadcast:
		if (p + 4 &gt; ep)
			return 0;
		fixup = p;
		hnputs(p, s-&gt;datagram.length); p += 2;
		hnputs(p, s-&gt;datagram.offset); p += 2;
		n = nbnameencode(p, ep, s-&gt;datagram.srcname);
		if (n == 0)
			return 0;
		p += n;
		n = nbnameencode(p, ep, s-&gt;datagram.dstname);
		if (n == 0)
			return 0;
		p += n;
		if (p + s-&gt;datagram.length &gt; ep)
			return 0;
		memcpy(p, s-&gt;datagram.data, s-&gt;datagram.length); p += s-&gt;datagram.length;
		hnputs(fixup, p - fixup - 4);
		break;
	case NbDgramError:
		if (p + 1 &gt; ep)
			return 0;
		*p++ = s-&gt;error.code;
		break;
	case NbDgramQueryRequest:
	case NbDgramPositiveQueryResponse:
	case NbDgramNegativeQueryResponse:
		n = nbnameencode(p, ep, s-&gt;datagram.dstname);
		if (n == 0)
			return 0;
		p += n;
		break;
	default:
		return 0;
	}
	return p - ap;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

