<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/nbns.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/nbns.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

static struct {
	int thread;
	QLock;
	int fd;
} udp = { -1 };

typedef struct Listen Listen;

struct Listen {
	NbName to;
	int (*deliver)(void *magic, NbDgram *s);
	void *magic;
	Listen *next;
};

static struct {
	Lock;
	ushort id;
} id;

struct {
	QLock;
	NbnsTransaction *head;
} transactionlist;

static void
udplistener(void *)
{	
	for (;;) {
		uchar msg[Udphdrsize + 576];
		int len = read(udp.fd, msg, sizeof(msg));
		if (len &lt; 0)
			break;
		if (len &gt;= nbudphdrsize) {
			NbnsMessage *s;
//			Udphdr *uh;
			uchar *p;

//			uh = (Udphdr*)msg;
			p = msg + nbudphdrsize;
			len -= nbudphdrsize;
			s = nbnsconvM2S(p, len);
			if (s) {
//print("%I:%d -&gt; %I:%d\n", uh-&gt;raddr, nhgets(uh-&gt;rport), uh-&gt;laddr, nhgets(uh-&gt;lport));
//nbnsdumpmessage(s);
				if (s-&gt;response) {
					NbnsTransaction *t;
					qlock(&amp;transactionlist);
					for (t = transactionlist.head; t; t = t-&gt;next)
						if (t-&gt;id == s-&gt;id)
							break;
					if (t)
						sendp(t-&gt;c, s);
					else
						nbnsmessagefree(&amp;s);
					qunlock(&amp;transactionlist);
				}
				else
					nbnsmessagefree(&amp;s);
			}
		}
	}
}

static char *
startlistener(void)
{
	qlock(&amp;udp);
	if (udp.thread &lt; 0) {
		char *e;
		e = nbudpannounce(NbnsPort, &amp;udp.fd);
		if (e) {
			qunlock(&amp;udp);
			return e;
		}
		udp.thread = proccreate(udplistener, nil, 16384);
	}
	qunlock(&amp;udp);
	return nil;
}

ushort
nbnsnextid(void)
{
	ushort rv;
	lock(&amp;id);
	rv = id.id++;
	unlock(&amp;id);
	return rv;
}
	
NbnsTransaction *
nbnstransactionnew(NbnsMessage *s, uchar *ipaddr)
{
	NbnsTransaction *t;
	uchar msg[Udphdrsize + 576];
	Udphdr *u;
	int len;

	startlistener();
	len = nbnsconvS2M(s, msg + nbudphdrsize, sizeof(msg) - nbudphdrsize);
	if (len == 0)
		return 0;
	t = mallocz(sizeof(*t), 1);
	if (t == nil)
		return nil;
	t-&gt;id = s-&gt;id;	
	t-&gt;c = chancreate(sizeof(NbnsMessage *), 3);
	if (t-&gt;c == nil) {
		free(t);
		return nil;
	}
	qlock(&amp;transactionlist);
	t-&gt;next = transactionlist.head;
	transactionlist.head = t;
	qunlock(&amp;transactionlist);
	u = (Udphdr *)msg;
	ipmove(u-&gt;laddr, nbglobals.myipaddr);
	hnputs(u-&gt;lport, NbnsPort);
	if (s-&gt;broadcast || ipaddr == nil)
		ipmove(u-&gt;raddr, nbglobals.bcastaddr);
	else
		ipmove(u-&gt;raddr, ipaddr);
	hnputs(u-&gt;rport, NbnsPort);
	write(udp.fd, msg, len + nbudphdrsize);
	return t;
}

void
nbnstransactionfree(NbnsTransaction **tp)
{
	NbnsTransaction **tp2;
	NbnsMessage *s;
	NbnsTransaction *t;

	t = *tp;
	if (t) {
		qlock(&amp;transactionlist);
		while ((s = nbrecvp(t-&gt;c)) != nil)
			nbnsmessagefree(&amp;s);
		for (tp2 = &amp;transactionlist.head; *tp2 &amp;&amp; *tp2 != t; tp2 = &amp;(*tp2)-&gt;next)
			;
		if (*tp2) {
			*tp2 = t-&gt;next;
			free(t);
		}
		qunlock(&amp;transactionlist);
		*tp = nil;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

