<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/nbnsconv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/nbnsconv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;thread.h&gt;
#include "netbios.h"

void
nbnsmessagequestionfree(NbnsMessageQuestion **qp)
{
	NbnsMessageQuestion *q = *qp;
	if (q) {
		free(q);
		*qp = nil;
	}
}

void
nbnsmessageresourcefree(NbnsMessageResource **rp)
{
	NbnsMessageResource *r = *rp;
	if (r) {
		free(r-&gt;rdata);
		free(r);
		*rp = nil;
	}
}

static void
questionfree(NbnsMessageQuestion **qp)
{
	while (*qp) {
		NbnsMessageQuestion *next = (*qp)-&gt;next;
		nbnsmessagequestionfree(qp);
		*qp = next;
	}
}

static void
resourcefree(NbnsMessageResource **rp)
{
	while (*rp) {
		NbnsMessageResource *next = (*rp)-&gt;next;
		nbnsmessageresourcefree(rp);
		*rp = next;
	}
}

void
nbnsmessagefree(NbnsMessage **sp)
{
	NbnsMessage *s = *sp;
	if (s) {
		questionfree(&amp;s-&gt;q);
		resourcefree(&amp;s-&gt;an);
		resourcefree(&amp;s-&gt;ns);
		resourcefree(&amp;s-&gt;ar);
		free(s);
		*sp = nil;
	}
}

void
nbnsmessageaddquestion(NbnsMessage *s, NbnsMessageQuestion *q)
{
	NbnsMessageQuestion **qp;
	for (qp = &amp;s-&gt;q; *qp; qp = &amp;(*qp)-&gt;next)
		;
	*qp = q;
}

NbnsMessageQuestion *
nbnsmessagequestionnew(NbName name, ushort type, ushort class)
{
	NbnsMessageQuestion *q;
	q = mallocz(sizeof(*q), 1);
	if (q == nil)
		return nil;
	nbnamecpy(q-&gt;name, name);
	q-&gt;type = type;
	q-&gt;class = class;
	return q;
}

NbnsMessageResource *
nbnsmessageresourcenew(NbName name, ushort type, ushort class, ulong ttl, int rdlength, uchar *rdata)
{
	NbnsMessageResource *r;
	r= mallocz(sizeof(*r), 1);
	if (r == nil)
		return nil;
	nbnamecpy(r-&gt;name, name);
	r-&gt;type = type;
	r-&gt;class = class;
	r-&gt;ttl = ttl;
	r-&gt;rdlength = rdlength;
	if (rdlength) {
		r-&gt;rdata = malloc(rdlength);
		if (r-&gt;rdata == nil) {
			free(r);
			return nil;
		}
		memcpy(r-&gt;rdata, rdata, rdlength);
	}
	return r;
}

void
nbnsmessageaddresource(NbnsMessageResource **rp, NbnsMessageResource *r)
{
	for (; *rp; rp = &amp;(*rp)-&gt;next)
		;
	*rp = r;
}

NbnsMessage *
nbnsmessagenew(void)
{
	return mallocz(sizeof(NbnsMessage), 1);
}

static int
resourcedecode(NbnsMessageResource **headp, int count, uchar *ap, uchar *pp, uchar *ep)
{
	uchar *p = pp;
	int i;
	for (i = 0; i &lt; count; i++) {
		int n;
		NbnsMessageResource *r, **rp;
		r = mallocz(sizeof(NbnsMessageResource), 1);
		if (r == nil)
			return -1;
		for (rp = headp; *rp; rp = &amp;(*rp)-&gt;next)
			;
		*rp = r;
		n = nbnamedecode(ap, p, ep, r-&gt;name);
		if (n == 0)
			return -1;
		p += n;
		if (p + 10 &gt; ep)
			return -1;
		r-&gt;type = nhgets(p); p += 2;
		r-&gt;class = nhgets(p); p += 2;
		r-&gt;ttl = nhgetl(p); p += 4;
		r-&gt;rdlength = nhgets(p); p += 2;
//print("rdlength %d\n", r-&gt;rdlength);
		if (r-&gt;rdlength) {
			if (p + r-&gt;rdlength &gt; ep)
				return -1;
			r-&gt;rdata = malloc(r-&gt;rdlength);
			if (r == nil)
				return -1;
			memcpy(r-&gt;rdata, p, r-&gt;rdlength);
			p += r-&gt;rdlength;
		}
	}
	return p - pp;
}

NbnsMessage *
nbnsconvM2S(uchar *ap, int nap)
{
	uchar *p, *ep;
	ushort qdcount, ancount, nscount, arcount, ctrl;
	int i;
	NbnsMessage *s;
	int n;

	if (nap &lt; 12)
		return nil;
	p = ap;
	ep = ap + nap;
	s = nbnsmessagenew();
	if (s == nil)
		return nil;
	s-&gt;id = nhgets(p); p+= 2;
	ctrl = nhgets(p); p += 2;
	qdcount = nhgets(p); p += 2;
	ancount = nhgets(p); p += 2;
	nscount = nhgets(p); p += 2;
	arcount = nhgets(p); p += 2;
	s-&gt;response = (ctrl &amp; NbnsResponse) != 0;
	s-&gt;opcode = (ctrl &gt;&gt; NbnsOpShift) &amp; NbnsOpMask;
	s-&gt;broadcast = (ctrl &amp; NbnsFlagBroadcast) != 0;
	s-&gt;recursionavailable = (ctrl &amp; NbnsFlagRecursionAvailable) != 0;
	s-&gt;recursiondesired = (ctrl &amp; NbnsFlagRecursionDesired) != 0;
	s-&gt;truncation = (ctrl &amp; NbnsFlagTruncation) != 0;
	s-&gt;authoritativeanswer = (ctrl &amp; NbnsFlagAuthoritativeAnswer) != 0;
	s-&gt;rcode = s-&gt;response ? (ctrl &amp; NbnsRcodeMask) : 0;
	for (i = 0; i &lt; qdcount; i++) {
		int n;
		NbName nbname;
		NbnsMessageQuestion *q;
		ushort type, class;
		n = nbnamedecode(ap, p, ep, nbname);
		if (n == 0)
			goto fail;
		p += n;
		if (p + 4 &gt; ep)
			goto fail;
		type = nhgets(p); p += 2;
		class = nhgets(p); p += 2;
		q = nbnsmessagequestionnew(nbname, type, class);
		if (q == nil)
			goto fail;
		nbnsmessageaddquestion(s, q);
	}
	n = resourcedecode(&amp;s-&gt;an, ancount, ap, p, ep);
	if (n &lt; 0)
		goto fail;
	p += n;
	n = resourcedecode(&amp;s-&gt;ns, nscount, ap, p, ep);
	if (n &lt; 0)
		goto fail;
	p += n;
	n = resourcedecode(&amp;s-&gt;ar, arcount, ap, p, ep);
	if (n &lt; 0)
		goto fail;
//print("arcount %d\n", arcount);
	return s;
fail:
	nbnsmessagefree(&amp;s);
	return nil;
}

static int
resourceencode(NbnsMessageResource *r, uchar *ap, uchar *ep)
{
	uchar *p = ap;
	for (; r; r = r-&gt;next) {
		int n = nbnameencode(p, ep, r-&gt;name);
		if (n == 0)
			return -1;
		p += n;
		if (p + 10 &gt; ep)
			return -1;
		hnputs(p, r-&gt;type); p += 2;
		hnputs(p, r-&gt;class); p += 2;
		hnputl(p, r-&gt;ttl); p += 4;
		hnputs(p, r-&gt;rdlength); p += 2;
		if (p + r-&gt;rdlength &gt; ep)
			return -1;
		memcpy(p, r-&gt;rdata, r-&gt;rdlength);
		p += r-&gt;rdlength;
	}
	return p - ap;
}

int
nbnsconvS2M(NbnsMessage *s, uchar *ap, int nap)
{
	uchar *p = ap;
	uchar *ep = ap + nap;
	ushort ctrl;
	NbnsMessageQuestion *q;
	NbnsMessageResource *r;
	int k;
	int n;

	if (p + 12 &gt; ep)
		return 0;
	hnputs(p, s-&gt;id); p+= 2;
	ctrl = (s-&gt;opcode &amp; NbnsOpMask) &lt;&lt; NbnsOpShift;
	if (s-&gt;response) {
		ctrl |= s-&gt;rcode &amp; NbnsRcodeMask;
		ctrl |= NbnsResponse;
	}
	if (s-&gt;broadcast)
		ctrl |= NbnsFlagBroadcast;
	if (s-&gt;recursionavailable)
		ctrl |= NbnsFlagRecursionAvailable;
	if (s-&gt;recursiondesired)
		ctrl |= NbnsFlagRecursionDesired;
	if (s-&gt;truncation)
		ctrl |= NbnsFlagTruncation;
	if (s-&gt;authoritativeanswer)
		ctrl |= NbnsFlagAuthoritativeAnswer;
	hnputs(p, ctrl); p += 2;
	for (q = s-&gt;q, k = 0; q; k++, q = q-&gt;next)
		;
	hnputs(p, k); p += 2;
	for (r = s-&gt;an, k = 0; r; k++, r = r-&gt;next)
		;
	hnputs(p, k); p += 2;
	for (r = s-&gt;ns, k = 0; r; k++, r = r-&gt;next)
		;
	hnputs(p, k); p += 2;
	for (r = s-&gt;ar, k = 0; r; k++, r = r-&gt;next)
		;
	hnputs(p, k); p += 2;
	for (q = s-&gt;q; q; q = q-&gt;next) {
		int n = nbnameencode(p, ep, q-&gt;name);
		if (n == 0)
			return 0;
		p += n;
		if (p + 4 &gt; ep)
			return 0;
		hnputs(p, q-&gt;type); p += 2;
		hnputs(p, q-&gt;class); p += 2;
	}
	n = resourceencode(s-&gt;an, p, ep);
	if (n &lt; 0)
		return 0;
	p += n;
	n = resourceencode(s-&gt;ns, p, ep);
	if (n &lt; 0)
		return 0;
	p += n;
	n = resourceencode(s-&gt;ar, p, ep);
	if (n &lt; 0)
		return 0;
	p += n;
	return p - ap;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

