<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbbuffer.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbbuffer.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

#define BUFFER 1
#define STRUCT 2
#define PUSHED 4

struct SmbBuffer {
	uchar *buf;
	ulong realmaxlen;
	ulong maxlen;
	ulong rn;
	ulong wn;
	ulong savewn;
	int flags;
};

void
smbbufferreset(SmbBuffer *s)
{
	if (s == nil)
		return;
	s-&gt;rn = 0;
	s-&gt;wn = 0;
	s-&gt;flags &amp;= ~PUSHED;
}

void
smbbuffersetbuf(SmbBuffer *s, void *p, ulong maxlen)
{
	s-&gt;realmaxlen = s-&gt;maxlen = maxlen;
	if (s-&gt;buf) {
		if (s-&gt;flags &amp; BUFFER)
			free(s-&gt;buf);
		s-&gt;buf = nil;
	}
	s-&gt;flags &amp;= ~BUFFER;
	if (p)
		s-&gt;buf = p;
	else {
		s-&gt;buf = smbemalloc(maxlen);
		s-&gt;flags |= BUFFER;
	}
	smbbufferreset(s);
}

SmbBuffer *
smbbufferinit(void *base, void *bdata, ulong blen)
{
	SmbBuffer *b;
	b = smbemalloc(sizeof(*b));
	b-&gt;buf = base;
	b-&gt;flags = STRUCT;	
	b-&gt;rn = (uchar *)bdata - (uchar *)base;
	b-&gt;wn = b-&gt;rn + blen;
	b-&gt;realmaxlen = b-&gt;maxlen = b-&gt;wn;
	return b;
}

int
smbbufferalignl2(SmbBuffer *s, int al2)
{
	ulong mask, newn;
	mask = (1 &lt;&lt; al2) - 1;
	newn = (s-&gt;wn + mask) &amp; ~mask;
	if (newn != s-&gt;wn) {
		if (newn &gt; s-&gt;maxlen)
			return 0;
		s-&gt;wn = newn;
	}
	return 1;
}

int
smbbufferputb(SmbBuffer *s, uchar b)
{
	if (s-&gt;wn &gt;= s-&gt;maxlen)
		return 0;
	s-&gt;buf[s-&gt;wn++] = b;
	return 1;
}

ulong
smbbufferspace(SmbBuffer *sess)
{
	return sess-&gt;maxlen - sess-&gt;wn;
}

int
smbbufferoffsetputs(SmbBuffer *sess, ulong offset, ushort s)
{
	if (offset + 2 &gt; sess-&gt;wn)
		return 0;
	smbhnputs(sess-&gt;buf + offset, s);
	return 1;
}

int
smbbufferputs(SmbBuffer *sess, ushort s)
{
	if (sess-&gt;wn + sizeof(ushort) &gt; sess-&gt;maxlen)
		return 0;
	smbhnputs(sess-&gt;buf + sess-&gt;wn, s);
	sess-&gt;wn += sizeof(ushort);
	return 1;
}

int
smbbufferputl(SmbBuffer *s, ulong l)
{
	if (s-&gt;wn + sizeof(ulong) &gt; s-&gt;maxlen)
		return 0;
	smbhnputl(s-&gt;buf + s-&gt;wn, l);
	s-&gt;wn += sizeof(ulong);
	return 1;
}

int
smbbufferputv(SmbBuffer *s, vlong v)
{
	if (s-&gt;wn + sizeof(vlong) &gt; s-&gt;maxlen)
		return 0;
	smbhnputv(s-&gt;buf + s-&gt;wn, v);
	s-&gt;wn += sizeof(vlong);
	return 1;
}

int
smbbufferputbytes(SmbBuffer *s, void *data, ulong datalen)
{
	if (s-&gt;wn + datalen &gt; s-&gt;maxlen)
		return 0;
	if (data)
		memcpy(s-&gt;buf + s-&gt;wn, data, datalen);
	s-&gt;wn += datalen;
	return 1;
}

int
smbbufferputstring(SmbBuffer *b, SmbPeerInfo *p, ulong flags, char *string)
{
	int n = smbstringput(p, flags, b-&gt;buf, b-&gt;wn, b-&gt;maxlen, string);
	if (n &lt;= 0)
		return 0;
	b-&gt;wn += n;
	return 1;
}

int
smbbufferputstrn(SmbBuffer *s, char *string, int size, int upcase)
{
	int n = smbstrnput(s-&gt;buf, s-&gt;wn, s-&gt;maxlen, string, size, upcase);
	if (n &lt;= 0)
		return 0;
	s-&gt;wn += n;
	return 1;
}

ulong
smbbufferwriteoffset(SmbBuffer *s)
{
	return s-&gt;wn;
}

ulong
smbbufferwritemaxoffset(SmbBuffer *s)
{
	return s-&gt;maxlen;
}

ulong
smbbufferreadoffset(SmbBuffer *s)
{
	return s-&gt;rn;
}

void *
smbbufferreadpointer(SmbBuffer *s)
{
	return s-&gt;buf + s-&gt;rn;
}

void *
smbbufferwritepointer(SmbBuffer *s)
{
	return s-&gt;buf + s-&gt;wn;
}

ulong
smbbufferwritespace(SmbBuffer *b)
{
	return b-&gt;maxlen - b-&gt;wn;
}

SmbBuffer *
smbbuffernew(ulong maxlen)
{
	SmbBuffer *b;
	b = smbemalloc(sizeof(SmbBuffer));
	b-&gt;buf = smbemalloc(maxlen);
	b-&gt;realmaxlen = b-&gt;maxlen = maxlen;
	b-&gt;rn = 0;
	b-&gt;wn = 0;
	b-&gt;flags = STRUCT | BUFFER;
	return b;
}

void
smbbufferfree(SmbBuffer **bp)
{
	SmbBuffer *b = *bp;
	if (b) {
		if (b-&gt;flags &amp; BUFFER) {
			free(b-&gt;buf);
			b-&gt;buf = nil;
			b-&gt;flags &amp;= ~BUFFER;
		}
		if (b-&gt;flags &amp; STRUCT)
			free(b);
		*bp = nil;
	}
}

uchar *
smbbufferbase(SmbBuffer *b)
{
	return b-&gt;buf;
}

int
smbbuffergetbytes(SmbBuffer *b, void *buf, ulong len)
{
	if (b-&gt;rn + len &gt; b-&gt;wn)
		return 0;
	if (buf)
		memcpy(buf, b-&gt;buf + b-&gt;rn, len);
	b-&gt;rn += len;
	return 1;
}

void
smbbuffersetreadlen(SmbBuffer *b, ulong len)
{
	b-&gt;wn = b-&gt;rn + len;
}

int
smbbuffertrimreadlen(SmbBuffer *b, ulong len)
{
	if (b-&gt;rn + len &gt; b-&gt;wn)
		return 0;
	else if (b-&gt;rn + len &lt; b-&gt;wn)
		b-&gt;wn = b-&gt;rn + len;
	return 1;
}

int
smbbuffergets(SmbBuffer *b, ushort *sp)
{
	if (b-&gt;rn + 2 &gt; b-&gt;wn)
		return 0;
	*sp = smbnhgets(b-&gt;buf + b-&gt;rn);
	b-&gt;rn += 2;
	return 1;
}

int
smbbuffergetstrn(SmbBuffer *b, ushort size, char **sp)
{
	uchar *np;
	if (size &gt; b-&gt;wn - b-&gt;rn)
		return 0;
	np = memchr(b-&gt;buf + b-&gt;rn, 0, size);
	if (np == nil)
		return 0;
	*sp = strdup((char *)b-&gt;buf + b-&gt;rn);
	b-&gt;rn += size;
	return 1;
}

int
smbbuffergetstr(SmbBuffer *b, ulong flags, char **sp)
{
	int c;
	char *p;
	uchar *np;

	np = memchr(b-&gt;buf + b-&gt;rn, 0, b-&gt;wn - b-&gt;rn);
	if (np == nil)
		return 0;
	*sp = strdup((char *)b-&gt;buf + b-&gt;rn);
	for (p = *sp; *p != 0; p++) {
		c = *p;
		if (c &gt;= 'a' &amp;&amp; c &lt;= 'z' &amp;&amp; (flags &amp; SMB_STRING_UPCASE))
			*p = toupper(c);
		else if (c == '/' &amp;&amp; (flags &amp; SMB_STRING_REVPATH))
			*p = '\\';
		else if (c == '\\' &amp;&amp; (flags &amp; SMB_STRING_PATH))
			*p = '/';
		else if (smbglobals.convertspace){
			if (c == 0xa0 &amp;&amp; (flags &amp; SMB_STRING_REVPATH))
				*p = ' ';
			else if (c == ' ' &amp;&amp; (flags &amp; SMB_STRING_PATH))
				*p = 0xa0;
		}
	}
	b-&gt;rn = np - b-&gt;buf + 1;
	return 1;
}

int
smbbuffergetstrinline(SmbBuffer *b, char **sp)
{
	uchar *np;
	np = memchr(b-&gt;buf + b-&gt;rn, 0, b-&gt;wn - b-&gt;rn);
	if (np == nil)
		return 0;
	*sp = (char *)b-&gt;buf + b-&gt;rn;
	b-&gt;rn = np - b-&gt;buf + 1;
	return 1;
}

int
smbbuffergetucs2(SmbBuffer *b, ulong flags, char **sp)
{
	uchar *bdata = b-&gt;buf + b-&gt;rn;
	uchar *edata = b-&gt;buf + b-&gt;wn;
	Rune r;
	int l;
	char *p, *q;
	uchar *savebdata;
	int first;

	l = 0;
	if ((flags &amp; SMB_STRING_UNALIGNED) == 0 &amp;&amp; (bdata - b-&gt;buf) &amp; 1)
		bdata++;
	savebdata = bdata;
	first = 1;
	do {
		if (bdata + 2 &gt; edata) {
			l++;
			break;
		}
		r = smbnhgets(bdata); bdata += 2;
		if (first &amp;&amp; (flags &amp; SMB_STRING_PATH) &amp;&amp; r != '\\')
			l++;
		first = 0;
		if (flags &amp; SMB_STRING_CONVERT_MASK)
			r = smbruneconvert(r, flags);
		l += runelen(r);
	} while (r != 0);
	p = smbemalloc(l);
	bdata = savebdata;
	q = p;
	first = 1;
	do {
		if (bdata + 2 &gt; edata) {
			*q = 0;
			break;
		}
		r = smbnhgets(bdata); bdata += 2;
		if (first &amp;&amp; (flags &amp; SMB_STRING_PATH) &amp;&amp; r != '\\')
			*q++ = '/';
		first = 0;
		if (flags &amp; SMB_STRING_CONVERT_MASK)
			r = smbruneconvert(r, flags);
		q += runetochar(q, &amp;r);
	} while (r != 0);
	b-&gt;rn = bdata - b-&gt;buf;
	*sp = p;
	return 1;
}

int
smbbuffergetstring(SmbBuffer *b, SmbHeader *h, ulong flags, char **sp)
{
	if (flags &amp; SMB_STRING_UNICODE)
		return smbbuffergetucs2(b, flags, sp);
	else if (flags &amp; SMB_STRING_ASCII)
		return smbbuffergetstr(b, flags, sp);
	else if (h-&gt;flags2 &amp; SMB_FLAGS2_UNICODE)
		return smbbuffergetucs2(b, flags, sp);
	else
		return smbbuffergetstr(b, flags, sp);
}

void *
smbbufferpointer(SmbBuffer *b, ulong offset)
{
	return b-&gt;buf + offset;
}

int
smbbuffergetb(SmbBuffer *b, uchar *bp)
{
	if (b-&gt;rn &lt; b-&gt;wn) {
		*bp = b-&gt;buf[b-&gt;rn++];
		return 1;
	}
	return 0;
}

int
smbbuffergetl(SmbBuffer *b, ulong *lp)
{
	if (b-&gt;rn + 4 &lt;= b-&gt;wn) {
		*lp = smbnhgetl(b-&gt;buf + b-&gt;rn);
		b-&gt;rn += 4;
		return 1;
	}
	return 0;
}

int
smbbuffergetv(SmbBuffer *b, vlong *vp)
{
	if (b-&gt;rn + 8 &lt;= b-&gt;wn) {
		*vp = smbnhgetv(b-&gt;buf + b-&gt;rn);
		b-&gt;rn += 8;
		return 1;
	}
	return 0;
}

ulong
smbbufferreadspace(SmbBuffer *b)
{
	return b-&gt;wn - b-&gt;rn;
}

void
smbbufferwritelimit(SmbBuffer *b, ulong limit)
{
	if (b-&gt;rn + limit &lt; b-&gt;maxlen)
		b-&gt;maxlen = b-&gt;rn + limit;
}

int
smbbufferreadskipto(SmbBuffer *b, ulong offset)
{
	if (offset &lt; b-&gt;rn || offset &gt;= b-&gt;wn)
		return 0;
	b-&gt;rn = offset;
	return 1;
}

int
smbbufferpushreadlimit(SmbBuffer *b, ulong limit)
{
	if (b-&gt;flags &amp; PUSHED)
		return 0;
	if (limit &gt; b-&gt;wn || limit &lt; b-&gt;rn)
		return 0;
	b-&gt;savewn = b-&gt;wn;
	b-&gt;wn = limit;
	b-&gt;flags |= PUSHED;
	return 1;
}

int
smbbufferpopreadlimit(SmbBuffer *b)
{
	if ((b-&gt;flags &amp; PUSHED) == 0)
		return 0;
	b-&gt;wn = b-&gt;savewn;
	b-&gt;flags &amp;= ~PUSHED;
	return 1;
}

int
smbbufferwritebackup(SmbBuffer *b, ulong offset)
{
	if (offset &gt;= b-&gt;rn &amp;&amp; offset &lt;= b-&gt;wn) {
		b-&gt;wn = offset;
		return 1;
	}
	return 0;
}

int
smbbufferreadbackup(SmbBuffer *b, ulong offset)
{
	if (offset &lt;= b-&gt;rn) {
		b-&gt;rn = offset;
		return 1;
	}
	return 0;
}

int
smbbufferfixuprelatives(SmbBuffer *b, ulong fixupoffset)
{
	ulong fixval;
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 2)
		return 0;
	fixval = b-&gt;wn - fixupoffset - 2;
	if (fixval &gt; 65535)
		return 0;
	smbhnputs(b-&gt;buf + fixupoffset, fixval);
	return 1;
}

int
smbbufferfixuprelativel(SmbBuffer *b, ulong fixupoffset)
{
	ulong fixval;
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 4)
		return 0;
	fixval = b-&gt;wn - fixupoffset - 4;
	smbhnputl(b-&gt;buf + fixupoffset, fixval);
	return 1;
}

int
smbbufferfixupabsolutes(SmbBuffer *b, ulong fixupoffset)
{
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 2)
		return 0;
	if (b-&gt;wn &gt; 65535)
		return 0;
	smbhnputs(b-&gt;buf + fixupoffset, b-&gt;wn);
	return 1;
}

int
smbbufferfixupl(SmbBuffer *b, ulong fixupoffset, ulong fixupval)
{
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 4)
		return 0;
	smbhnputl(b-&gt;buf + fixupoffset, fixupval);
	return 1;
}

int
smbbufferfixupabsolutel(SmbBuffer *b, ulong fixupoffset)
{
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 2)
		return 0;
	smbhnputl(b-&gt;buf + fixupoffset, b-&gt;wn);
	return 1;
}

int
smbbufferfixuprelativeinclusivel(SmbBuffer *b, ulong fixupoffset)
{
	if (fixupoffset &lt; b-&gt;rn || fixupoffset &gt; b-&gt;wn - 4)
		return 0;
	smbhnputl(b-&gt;buf + fixupoffset, b-&gt;wn - fixupoffset);
	return 1;
}

int
smbbufferfill(SmbBuffer *b, uchar val, ulong len)
{
	if (b-&gt;maxlen - b-&gt;wn &lt; len)
		return 0;
	memset(b-&gt;buf + b-&gt;wn, val, len);
	b-&gt;wn += len;
	return 1;
}

int
smbbufferoffsetgetb(SmbBuffer *b, ulong offset, uchar *bp)
{
	if (offset &gt;= b-&gt;rn &amp;&amp; offset + 1 &lt;= b-&gt;wn) {
		*bp = b-&gt;buf[b-&gt;rn + offset];
		return 1;
	}
	return 0;
}

int
smbbuffercopy(SmbBuffer *to, SmbBuffer *from, ulong amount)
{
	if (smbbufferreadspace(from) &lt; amount)
		return 0;
	if (smbbufferputbytes(to, smbbufferreadpointer(from), amount)) {
		assert(smbbuffergetbytes(from, nil, amount));
		return 1;
	}
	return 0;
}

int
smbbufferoffsetcopystr(SmbBuffer *b, ulong offset, char *buf, int buflen, int *lenp)
{
	uchar *np;
	if (offset &lt; b-&gt;rn || offset &gt;= b-&gt;wn)
		return 0;
	np = memchr(b-&gt;buf + offset, 0, b-&gt;wn - offset);
	if (np == nil)
		return 0;
	*lenp = np - (b-&gt;buf + offset) + 1;
	if (*lenp &gt; buflen)
		return 0;
	memcpy(buf, b-&gt;buf + offset, *lenp);
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

