<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbcomopen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbcomopen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static void
smblogprintattr(int cmd, ushort attr)
{
	if (attr &amp; SMB_ATTR_READ_ONLY)
		smblogprint(cmd, " readonly");
	if (attr &amp; SMB_ATTR_HIDDEN)
		smblogprint(cmd, " hidden");
	if (attr &amp; SMB_ATTR_SYSTEM)
		smblogprint(cmd, " system");
	if (attr &amp; SMB_ATTR_DIRECTORY)
		smblogprint(cmd, " directory");
	if (attr &amp; SMB_ATTR_ARCHIVE)
		smblogprint(cmd, " archive");
}

static SmbFile *
openfile(SmbSession *s, SmbTree *t, char *path, ushort mode, ushort attr, ushort ofun, ulong createoptions, uvlong createsize,
	ushort *fidp, Dir **dp, ushort *actionp)
{
	int p9mode;
	int share;
	Dir *d = nil;
	int fd = -1;
	ushort action;
	SmbFile *f = nil;
	SmbSharedFile *sf = nil;
	char *fullpath = nil;
	int diropen = 0;

//smblogprint(-1, "%s A %r", path);
	p9mode = (mode &gt;&gt; SMB_OPEN_MODE_ACCESS_SHIFT) &amp; SMB_OPEN_MODE_ACCESS_MASK;	
	share = (mode &gt;&gt; SMB_OPEN_MODE_SHARE_SHIFT) &amp; SMB_OPEN_MODE_SHARE_MASK;	
	if (share == SMB_OPEN_MODE_SHARE_COMPATIBILITY) {
	badshare:
//smblogprint(-1, "%s SMB_OPEN_MODE_SHARE_COMPATIBILITY", path);
		smbseterror(s, ERRDOS, ERRbadshare);
		goto done;
	}
	smbstringprint(&amp;fullpath, "%s%s", t-&gt;serv-&gt;path, path);
	d = dirstat(fullpath);
	if (d) {
		/* file exists */
		int ofunexist;
		if (d-&gt;mode &amp; DMDIR) {
			if (createoptions &amp; SMB_CO_FILE) {
				smbseterror(s, ERRDOS, ERRnoaccess);
				goto done;
			}
		}
		else if (createoptions &amp; SMB_CO_DIRECTORY) {
			smbseterror(s, ERRDOS, ERRnoaccess);
			goto done;
		}
			
		sf = smbsharedfileget(d, p9mode, &amp;share);
		if (sf == nil)
			goto badshare;
		action = 1;
		ofunexist = (ofun &gt;&gt; SMB_OFUN_EXIST_SHIFT) &amp; SMB_OFUN_EXIST_MASK;
		if (ofunexist == SMB_OFUN_EXIST_FAIL) {
			smbseterror(s, ERRDOS, ERRfilexists);
			goto done;
		}
		else if (ofunexist == SMB_OFUN_EXIST_TRUNCATE) {
			if ((d-&gt;mode &amp; DMDIR) || (p9mode != OWRITE &amp;&amp; p9mode != ORDWR)) {
				smbseterror(s, ERRDOS, ERRbadaccess);
				goto done;
			}
			p9mode |= OTRUNC;
			action = 3;
		}
		else if (ofunexist != SMB_OFUN_EXIST_OPEN) {
			smbseterror(s, ERRDOS, ERRbadaccess);
			goto done;
		}
		if (d-&gt;mode &amp; DMDIR)
			diropen = 1;
		else
			fd = open(fullpath, p9mode);
	}
	else {
		/* file does not exist */
		ulong p9attr;
		action = 3;
		if ((ofun &amp; SMB_OFUN_NOEXIST_CREATE) == 0) {
			smbseterror(s, ERRDOS, ERRbadfile);
			goto done;
		}
		if (createsize != 0) {
			smbseterror(s, ERRDOS, ERRunsup);
			goto done;
		}
//smblogprint(-1, "creating: attr 0x%.4ux co 0x%.8lux\n", attr, createoptions);
		if (createoptions &amp; SMB_CO_FILE) {
			attr &amp;= SMB_ATTR_DIRECTORY;
			if (attr == 0)
				attr = SMB_ATTR_NORMAL;
		}
		else if (createoptions &amp; SMB_CO_DIRECTORY) {
			attr &amp;= ~SMB_ATTR_NORMAL;
			attr |= SMB_ATTR_DIRECTORY;
			p9mode = OREAD;
		}
//smblogprint(-1, "creating: before conversion attr 0x%.4ux\n", attr);
		p9attr = smbdosattr2plan9mode(attr);
//smblogprint(-1, "creating: after conversion p9attr 0%.uo\n", p9attr);
		fd = create(fullpath, p9mode, p9attr);
		if (fd &gt;= 0) {
			d = dirfstat(fd);
			sf = smbsharedfileget(d, p9mode, &amp;share);
			if (sf == nil) {
				close(fd);
				remove(path);
				goto badshare;
			}
		}
	}
//smblogprint(-1, "%s D %r", fullpath);
	if (!diropen &amp;&amp; fd &lt; 0) {
		smbseterror(s, ERRSRV, ERRaccess);
		goto done;
	}
	f = smbemalloc(sizeof(SmbFile));
	if (diropen) {
		f-&gt;ioallowed = 0;
		f-&gt;fd = -1;
	}
	else {
		f-&gt;ioallowed = 1;
		f-&gt;fd = fd;
	}
	f-&gt;name = smbestrdup(path);
	f-&gt;sf = sf;
	sf = nil;
	f-&gt;share = share;
	f-&gt;p9mode = p9mode;
	f-&gt;t = t;
	if (s-&gt;fidmap == nil)
		s-&gt;fidmap = smbidmapnew();
	*fidp = smbidmapadd(s-&gt;fidmap, f);
//smblogprint(h-&gt;command, "REPLY:\n t-&gt;id=0x%ux fid=%d path=%s\n", t-&gt;id, *fidp, path);
	smblogprintif(smbglobals.log.fids, "openfile: 0x%.4ux/0x%.4ux %s\n", t-&gt;id, *fidp, path);
	if (actionp)
		*actionp = action;
	if (dp) {
		*dp = d;
		d = nil;
	}
done:
	if (sf)
		smbsharedfileput(nil, sf, share);
	free(d);
	free(fullpath);
	return f;
}

SmbProcessResult
smbcomopenandx(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	uchar andxcommand;
	ushort andxoffset, flags, mode, sattr, attr;
	ulong createtime;	
	ushort ofun;
	ulong createsize, timeout;
	char *path = nil;
	ulong andxoffsetfixupoffset;
	SmbProcessResult pr;
	ushort action;
	Dir *d = nil;
	SmbFile *f;
	SmbTree *t;
	ushort fid;

	if (!smbcheckwordcount("comopenandx", h, 15))
		return SmbProcessResultFormat;

	andxcommand = *pdata++;
	pdata++;
	andxoffset = smbnhgets(pdata); pdata += 2;
	flags = smbnhgets(pdata); pdata += 2;
	mode = smbnhgets(pdata); pdata += 2;
	sattr = smbnhgets(pdata); pdata += 2;
	attr = smbnhgets(pdata); pdata += 2;
	createtime = smbnhgetl(pdata); pdata += 4;
	ofun = smbnhgets(pdata); pdata += 2;
	createsize = smbnhgetl(pdata); pdata += 4;
	timeout = smbnhgetl(pdata); pdata += 4;
	pdata += 4;
	USED(pdata);
	if (!smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)) {
		pr = SmbProcessResultFormat;
		goto done;
	}

	smbloglock();
	smblogprint(h-&gt;command, "flags 0x%.4ux", flags);
	if (flags &amp; SMB_OPEN_FLAGS_ADDITIONAL)
		smblogprint(h-&gt;command, " additional");
	if (flags &amp; SMB_OPEN_FLAGS_OPLOCK)
		smblogprint(h-&gt;command, " oplock");
	if (flags &amp; SMB_OPEN_FLAGS_OPBATCH)
		smblogprint(h-&gt;command, " opbatch");
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "mode 0x%.4ux", mode);
	switch ((mode &gt;&gt; SMB_OPEN_MODE_ACCESS_SHIFT) &amp; SMB_OPEN_MODE_ACCESS_MASK) {
	case OREAD:
		smblogprint(h-&gt;command, " OREAD");
		break;
	case OWRITE:
		smblogprint(h-&gt;command, " OWRITE");
		break;
	case ORDWR:
		smblogprint(h-&gt;command, " ORDWR");
		break;
	case OEXEC:
		smblogprint(h-&gt;command, " OEXEC");
		break;
	}
	switch ((mode &gt;&gt; SMB_OPEN_MODE_SHARE_SHIFT) &amp; SMB_OPEN_MODE_SHARE_MASK) {
	case SMB_OPEN_MODE_SHARE_COMPATIBILITY:
		smblogprint(h-&gt;command, " compatinility");
		break;
	case SMB_OPEN_MODE_SHARE_EXCLUSIVE:
		smblogprint(h-&gt;command, " exclusive");
		break;
	case SMB_OPEN_MODE_SHARE_DENY_WRITE:
		smblogprint(h-&gt;command, " deny write");
		break;
	case SMB_OPEN_MODE_SHARE_DENY_READOREXEC:
		smblogprint(h-&gt;command, " deny readorxec");
		break;
	case SMB_OPEN_MODE_SHARE_DENY_NONE:
		smblogprint(h-&gt;command, " deny none");
		break;
	}
	if (mode &amp; SMB_OPEN_MODE_WRITE_THROUGH)
		smblogprint(h-&gt;command, " write through");
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "sattr 0x%.4ux", sattr);
	smblogprintattr(h-&gt;command, sattr);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "attr 0x%.4ux", attr);
	smblogprintattr(h-&gt;command, attr);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "createtime 0x%.8lux\n", createtime);
	smblogprint(h-&gt;command, "ofun 0x%.4ux", ofun);
	if (ofun &amp; SMB_OFUN_NOEXIST_CREATE)
		smblogprint(h-&gt;command, " noexistscreate");
	else
		smblogprint(h-&gt;command, " noexistfail");
	switch ((ofun &gt;&gt; SMB_OFUN_EXIST_SHIFT) &amp; SMB_OFUN_EXIST_MASK) {
	case SMB_OFUN_EXIST_FAIL:
		smblogprint(h-&gt;command, " existfail");
		break;
	case SMB_OFUN_EXIST_OPEN:
		smblogprint(h-&gt;command, " existopen");
		break;
	case SMB_OFUN_EXIST_TRUNCATE:
		smblogprint(h-&gt;command, " existtruncate");
		break;
	}
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "createsize 0x%.8lux\n", createsize);
	smblogprint(h-&gt;command, "timeout 0x%.8lux\n", timeout);
	smblogprint(h-&gt;command, "path %s\n", path);
	smblogunlock();

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		goto errordone;
	}

	f = openfile(s, t, path, mode, attr, ofun, 0, createsize, &amp;fid, &amp;d, &amp;action);
	if (f == nil) {
		pr = SmbProcessResultError;
		goto done;
	}
	h-&gt;wordcount = 15;
	if (!smbbufferputandxheader(s-&gt;response, h, &amp;s-&gt;peerinfo, andxcommand, &amp;andxoffsetfixupoffset)
		|| !smbbufferputs(s-&gt;response, fid)
		|| !smbbufferputs(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode))
		|| !smbbufferputl(s-&gt;response, smbplan9time2utime(d-&gt;mtime, s-&gt;tzoff))
		|| !smbbufferputl(s-&gt;response, smbplan9length2size32(d-&gt;length))
		|| !smbbufferputs(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode)) // probbaly bogus
		|| !smbbufferputs(s-&gt;response, 0)	// all files are files
		|| !smbbufferputs(s-&gt;response, 0)	// pipe state
		|| !smbbufferputs(s-&gt;response, action)
		|| !smbbufferputl(s-&gt;response, 0)	// fileID
		|| !smbbufferputs(s-&gt;response, 0)
		|| !smbbufferputs(s-&gt;response, 0)) {	// bytecount 0
		smbfileclose(s, f);
		pr = SmbProcessResultMisc;
		goto done;
	}
	if (andxcommand != SMB_COM_NO_ANDX_COMMAND)
		pr = smbchaincommand(s, h, andxoffsetfixupoffset, andxcommand, andxoffset, b);
	else
		pr = SmbProcessResultReply;
	goto done;	
errordone:
	pr = SmbProcessResultError;
done:
	free(path);
	free(d);
	return pr;
}

SmbProcessResult
smbcomopen(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	uchar fmt;
	char *path;
	ushort mode, attr;
	SmbTree *t;
	ushort fid;
	Dir *d = nil;
	SmbFile *f;
	SmbProcessResult pr;

	if (!smbcheckwordcount("comopen", h, 2))
		return SmbProcessResultFormat;
	mode = smbnhgets(pdata);
	attr = smbnhgets(pdata + 2);
	if (!smbbuffergetb(b, &amp;fmt)
		|| fmt != 4
		|| !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)) {
		pr = SmbProcessResultFormat;
		goto done;
	}
	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
	error:
		pr = SmbProcessResultError;
		goto done;
	}
	f = openfile(s, t, path, mode, attr,
		SMB_OFUN_EXIST_OPEN &lt;&lt; SMB_OFUN_EXIST_SHIFT,
		0, 0, &amp;fid, &amp;d, nil);
	if (f == nil)
		goto error;
	h-&gt;wordcount = 7;
	if (!smbbufferputheader(s-&gt;response, h, &amp;s-&gt;peerinfo)
		|| !smbbufferputs(s-&gt;response, fid)
		|| !smbbufferputs(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode))
		|| !smbbufferputl(s-&gt;response, smbplan9time2utime(d-&gt;mtime, s-&gt;tzoff))
		|| !smbbufferputl(s-&gt;response, smbplan9length2size32(d-&gt;length))
		|| !smbbufferputs(s-&gt;response, 2)		// lies - this should be the actual access allowed
		|| !smbbufferputs(s-&gt;response, 0))
		pr = SmbProcessResultMisc;
	else
		pr = SmbProcessResultReply;
done:
	free(path);
	free(d);
	return pr;
}


/*
   smb_com      SMBcreate       smb_com      SMBcreate
   smb_wct      3               smb_wct      1
   smb_vwv[0]   attribute       smb_vwv[0]   file handle
   smb_vwv[1]   time low        smb_bcc      0
   smb_vwv[2]   time high
   smb_bcc      min = 2
   smb_buf[]    ASCII -- 04
                file pathname
*/

SmbProcessResult
smbcomcreate(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	int ofun, attr, mode;
	long createtime;
	char *path;
	uchar fmt;
	SmbFile *f;
	SmbTree *t;
	ushort fid;
	SmbProcessResult pr;

	path = nil;
	if (!smbcheckwordcount("comcreate", h, 3))
		return SmbProcessResultFormat;

	smblogprint(h-&gt;command, "tid=%d\n", h-&gt;tid);
	attr = smbnhgets(pdata); pdata += 2;
	createtime = smbnhgetl(pdata);
	if (!smbbuffergetb(b, &amp;fmt) || fmt != 0x04 || 
	    !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)){
		pr = SmbProcessResultError;
		goto done;
	}

	smbloglock();
	smblogprint(h-&gt;command, "path %s\n", path);
	smblogprint(h-&gt;command, "attr 0x%.4ux", attr);
	smblogprintattr(h-&gt;command, attr);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "createtime 0x%.8lux\n", createtime);
	smblogunlock();

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		pr = SmbProcessResultError;
		goto done;
	}

	mode = (ORDWR&lt;&lt;SMB_OPEN_MODE_ACCESS_SHIFT) | // SFS: FIXME: should be OWRITE?
		(SMB_OPEN_MODE_SHARE_EXCLUSIVE&lt;&lt;SMB_OPEN_MODE_SHARE_SHIFT);
	ofun = SMB_OFUN_NOEXIST_CREATE|(SMB_OFUN_EXIST_FAIL&lt;&lt;SMB_OFUN_EXIST_SHIFT);
	f = openfile(s, t, path, mode, attr, ofun, SMB_CO_FILE, 0, &amp;fid, nil, nil);
	if (f == nil) {
		pr = SmbProcessResultError;
		goto done;
	}

	h-&gt;wordcount = 1;		// SFS: FIXME: unsure of this constant, maybe should be 3
	if (!smbbufferputheader(s-&gt;response, h, &amp;s-&gt;peerinfo)
		|| !smbbufferputs(s-&gt;response, fid)
		|| !smbbufferputs(s-&gt;response, 0)){	// bytecount 0
		pr = SmbProcessResultMisc;
		goto done;
	}
	pr = SmbProcessResultReply;
	goto done;

done:
	free(path);
	return pr;
}


typedef struct SmbSblut {
	char *s;
	ulong mask;
} SmbSblut;

static SmbSblut dasblut[] = {
	{ "SMB_DA_SPECIFIC_READ_DATA", SMB_DA_SPECIFIC_READ_DATA },
	{ "SMB_DA_SPECIFIC_WRITE_DATA", SMB_DA_SPECIFIC_WRITE_DATA },
	{ "SMB_DA_SPECIFIC_APPEND_DATA", SMB_DA_SPECIFIC_APPEND_DATA },
	{ "SMB_DA_SPECIFIC_READ_EA", SMB_DA_SPECIFIC_READ_EA },
	{ "SMB_DA_SPECIFIC_WRITE_EA", SMB_DA_SPECIFIC_WRITE_EA },
	{ "SMB_DA_SPECIFIC_EXECUTE", SMB_DA_SPECIFIC_EXECUTE },
	{ "SMB_DA_SPECIFIC_DELETE_CHILD", SMB_DA_SPECIFIC_DELETE_CHILD },
	{ "SMB_DA_SPECIFIC_READ_ATTRIBUTES", SMB_DA_SPECIFIC_READ_ATTRIBUTES },
	{ "SMB_DA_SPECIFIC_WRITE_ATTRIBUTES", SMB_DA_SPECIFIC_WRITE_ATTRIBUTES },
	{ "SMB_DA_STANDARD_DELETE_ACCESS", SMB_DA_STANDARD_DELETE_ACCESS },
	{ "SMB_DA_STANDARD_READ_CONTROL_ACCESS", SMB_DA_STANDARD_READ_CONTROL_ACCESS },
	{ "SMB_DA_STANDARD_WRITE_DAC_ACCESS", SMB_DA_STANDARD_WRITE_DAC_ACCESS },
	{ "SMB_DA_STANDARD_WRITE_OWNER_ACCESS", SMB_DA_STANDARD_WRITE_OWNER_ACCESS },
	{ "SMB_DA_STANDARD_SYNCHRONIZE_ACCESS", SMB_DA_STANDARD_SYNCHRONIZE_ACCESS },
	{ "SMB_DA_GENERIC_ALL_ACCESS", SMB_DA_GENERIC_ALL_ACCESS },
	{ "SMB_DA_GENERIC_EXECUTE_ACCESS", SMB_DA_GENERIC_EXECUTE_ACCESS },
	{ "SMB_DA_GENERIC_WRITE_ACCESS", SMB_DA_GENERIC_WRITE_ACCESS },
	{ "SMB_DA_GENERIC_READ_ACCESS", SMB_DA_GENERIC_READ_ACCESS },
	{ 0 }
};

static SmbSblut efasblut[] = {
	{ "SMB_ATTR_READ_ONLY", SMB_ATTR_READ_ONLY },
	{ "SMB_ATTR_HIDDEN", SMB_ATTR_HIDDEN },
	{ "SMB_ATTR_SYSTEM", SMB_ATTR_SYSTEM },
	{ "SMB_ATTR_DIRECTORY", SMB_ATTR_DIRECTORY },
	{ "SMB_ATTR_ARCHIVE", SMB_ATTR_ARCHIVE },
	{ "SMB_ATTR_NORMAL", SMB_ATTR_NORMAL },
	{ "SMB_ATTR_COMPRESSED", SMB_ATTR_COMPRESSED },
	{ "SMB_ATTR_TEMPORARY", SMB_ATTR_TEMPORARY },
	{ "SMB_ATTR_WRITETHROUGH", SMB_ATTR_WRITETHROUGH },
	{ "SMB_ATTR_NO_BUFFERING", SMB_ATTR_NO_BUFFERING },
	{ "SMB_ATTR_RANDOM_ACCESS", SMB_ATTR_RANDOM_ACCESS },
	{ 0 }
};

static SmbSblut sasblut[] = {
	{ "SMB_SA_SHARE_READ", SMB_SA_SHARE_READ },
	{ "SMB_SA_SHARE_WRITE", SMB_SA_SHARE_WRITE },
	{ "SMB_SA_SHARE_DELETE", SMB_SA_SHARE_DELETE },
	{ "SMB_SA_NO_SHARE", SMB_SA_NO_SHARE },
	{ 0 }
};

static SmbSblut cosblut[] = {
	{ "SMB_CO_DIRECTORY", SMB_CO_DIRECTORY },
	{ "SMB_CO_WRITETHROUGH", SMB_CO_WRITETHROUGH },
	{ "SMB_CO_SEQUENTIAL_ONLY", SMB_CO_SEQUENTIAL_ONLY },
	{ "SMB_CO_FILE", SMB_CO_FILE },
	{ "SMB_CO_NO_EA_KNOWLEDGE", SMB_CO_NO_EA_KNOWLEDGE },
	{ "SMB_CO_EIGHT_DOT_THREE_ONLY", SMB_CO_EIGHT_DOT_THREE_ONLY },
	{ "SMB_CO_RANDOM_ACCESS", SMB_CO_RANDOM_ACCESS },
	{ "SMB_CO_DELETE_ON_CLOSE", SMB_CO_DELETE_ON_CLOSE },
	{ 0 }
};

static SmbSlut cdslut[] = {
	{ "SMB_CD_SUPERCEDE", SMB_CD_SUPERCEDE },
	{ "SMB_CD_OPEN", SMB_CD_OPEN },
	{ "SMB_CD_CREATE", SMB_CD_CREATE },
	{ "SMB_CD_OPEN_IF", SMB_CD_OPEN_IF },
	{ "SMB_CD_OVERWRITE", SMB_CD_OVERWRITE },
	{ "SMB_CD_OVERWRITE_IF", SMB_CD_OVERWRITE_IF },
	{ 0 }
};

static void
smbsblutlogprint(uchar cmd, SmbSblut *sblut, ulong mask)
{
	while (sblut-&gt;s) {
		if (mask &amp;&amp; (sblut-&gt;mask &amp; mask) || (mask == 0 &amp;&amp; sblut-&gt;mask == 0))
			smblogprint(cmd, " %s", sblut-&gt;s);
		sblut++;
	}
}

SmbProcessResult
smbcomntcreateandx(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	uchar andxcommand;
	ushort andxoffset;
	char *path = nil;
	SmbProcessResult pr;
	ulong namelength;
	ulong flags;
	ulong rootdirectoryfid, desiredaccess;
	uvlong allocationsize;
	ulong extfileattributes, shareaccess, createdisposition, createoptions, impersonationlevel;
	uchar securityflags;
	int p9mode;
	int sharemode;
	ushort mode;
	SmbTree *t;
	ushort ofun;
	SmbFile *f;
	ushort fid;
	Dir *d = nil;
	ushort action;
	uvlong mtime;
	ulong andxoffsetfixup;

	if (!smbcheckwordcount("comntcreateandx", h, 24))
		return SmbProcessResultFormat;

	andxcommand = *pdata++;
	pdata++;
	andxoffset = smbnhgets(pdata); pdata += 2;
	pdata++;
	namelength = smbnhgets(pdata); pdata += 2;
	flags = smbnhgetl(pdata); pdata += 4;
	rootdirectoryfid = smbnhgetl(pdata); pdata += 4;
	desiredaccess = smbnhgetl(pdata); pdata += 4;
	allocationsize = smbnhgetv(pdata); pdata += 8;
	extfileattributes = smbnhgetl(pdata); pdata += 4;
	shareaccess = smbnhgetl(pdata); pdata += 4;
	createdisposition = smbnhgetl(pdata); pdata += 4;
	createoptions = smbnhgetl(pdata); pdata += 4;
	impersonationlevel = smbnhgetl(pdata); pdata += 4;
	securityflags = *pdata++;
	USED(pdata);

	if (!smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)) {
		pr = SmbProcessResultFormat;
		goto done;
	}

	smblogprint(h-&gt;command, "namelength %d\n", namelength);
	smblogprint(h-&gt;command, "flags 0x%.8lux\n", flags);
	smblogprint(h-&gt;command, "rootdirectoryfid %lud\n", rootdirectoryfid);
	smblogprint(h-&gt;command, "desiredaccess 0x%.8lux", desiredaccess);
	smbsblutlogprint(h-&gt;command, dasblut, desiredaccess);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "allocationsize %llud\n", allocationsize);
	smblogprint(h-&gt;command, "extfileattributes 0x%.8lux", extfileattributes);
	smbsblutlogprint(h-&gt;command, efasblut, extfileattributes);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "shareaccess 0x%.8lux", shareaccess);
	smbsblutlogprint(h-&gt;command, sasblut, shareaccess);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "createdisposition 0x%.8lux %s\n",
		createdisposition, smbrevslut(cdslut, createdisposition));
	smblogprint(h-&gt;command, "createoptions 0x%.8lux", createoptions);
	smbsblutlogprint(h-&gt;command, cosblut, createoptions);
	smblogprint(h-&gt;command, "\n");
	smblogprint(h-&gt;command, "impersonationlevel 0x%.8lux\n", impersonationlevel);
	smblogprint(h-&gt;command, "securityflags 0x%.2ux\n", securityflags);
	smblogprint(h-&gt;command, "path %s\n", path);

	if (rootdirectoryfid != 0) {
		smblogprint(-1, "smbcomntcreateandx: fid relative not implemented\n");
		goto unimp;
	}

	if (desiredaccess &amp; SMB_DA_GENERIC_MASK)
		switch (desiredaccess &amp; SMB_DA_GENERIC_MASK){
		case SMB_DA_GENERIC_READ_ACCESS:
			p9mode = OREAD;
			break;
		case SMB_DA_GENERIC_WRITE_ACCESS:
			p9mode = OWRITE;
			break;
		case SMB_DA_GENERIC_ALL_ACCESS:
			p9mode = ORDWR;
			break;
		case SMB_DA_GENERIC_EXECUTE_ACCESS:
			p9mode = OEXEC;
			break;
		default:
			p9mode = OREAD;
			break;
		}
	else
	if (desiredaccess &amp; SMB_DA_SPECIFIC_READ_DATA)
		if (desiredaccess &amp; (SMB_DA_SPECIFIC_WRITE_DATA | SMB_DA_SPECIFIC_APPEND_DATA))
			p9mode = ORDWR;
		else
			p9mode = OREAD;
	else if (desiredaccess &amp; (SMB_DA_SPECIFIC_WRITE_DATA | SMB_DA_SPECIFIC_APPEND_DATA))
		p9mode = ORDWR;
	else
		p9mode = OREAD;

	if (shareaccess == SMB_SA_NO_SHARE)
		sharemode = SMB_OPEN_MODE_SHARE_EXCLUSIVE;
	else if (shareaccess &amp; (SMB_SA_SHARE_READ | SMB_SA_SHARE_WRITE) ==
		(SMB_SA_SHARE_READ | SMB_SA_SHARE_WRITE))
		sharemode = SMB_OPEN_MODE_SHARE_DENY_NONE;
	else if (shareaccess &amp; SMB_SA_SHARE_READ)
		sharemode = SMB_OPEN_MODE_SHARE_DENY_WRITE;
	else if (shareaccess &amp; SMB_SA_SHARE_WRITE)
		sharemode = SMB_OPEN_MODE_SHARE_DENY_READOREXEC;
	else
		sharemode = SMB_OPEN_MODE_SHARE_DENY_NONE;

	mode = (sharemode &lt;&lt; SMB_OPEN_MODE_SHARE_SHIFT) | (p9mode &lt;&lt; SMB_OPEN_MODE_ACCESS_SHIFT);

	switch (createdisposition) {
	default:
		smblogprint(-1, "smbcomntcreateandx: createdisposition 0x%.8lux not implemented\n", createdisposition);
		goto unimp;
	case SMB_CD_OPEN:
		ofun = SMB_OFUN_EXIST_OPEN;
		break;
	case SMB_CD_CREATE:
		ofun = SMB_OFUN_EXIST_FAIL | SMB_OFUN_NOEXIST_CREATE;
		break;
	case SMB_CD_OPEN_IF:
		ofun = SMB_OFUN_EXIST_OPEN | SMB_OFUN_NOEXIST_CREATE;
		break;
	case SMB_CD_OVERWRITE:
		ofun = SMB_OFUN_EXIST_TRUNCATE;
		break;
	case SMB_CD_OVERWRITE_IF:
		ofun = SMB_OFUN_EXIST_TRUNCATE | SMB_OFUN_NOEXIST_CREATE;
		break;
	}

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}

	f = openfile(s, t, path, mode, extfileattributes, ofun, createoptions, allocationsize, &amp;fid, &amp;d, &amp;action);

	if (f == nil) {
		pr = SmbProcessResultError;
		goto done;
	}

	h-&gt;wordcount = 42;
	mtime =  smbplan9time2time(d-&gt;mtime);
	if (!smbbufferputandxheader(s-&gt;response, h, &amp;s-&gt;peerinfo, andxcommand, &amp;andxoffsetfixup)
		|| !smbbufferputb(s-&gt;response, 0)		// oplocks? pah
		|| !smbbufferputs(s-&gt;response, fid)
		|| !smbbufferputl(s-&gt;response, action)
		|| !smbbufferputv(s-&gt;response, mtime)
		|| !smbbufferputv(s-&gt;response, smbplan9time2time(d-&gt;atime))
		|| !smbbufferputv(s-&gt;response, mtime)
		|| !smbbufferputv(s-&gt;response, mtime)
		|| !smbbufferputl(s-&gt;response, smbplan9mode2dosattr(d-&gt;mode))
		|| !smbbufferputv(s-&gt;response, smbl2roundupvlong(d-&gt;length, smbglobals.l2allocationsize))
		|| !smbbufferputv(s-&gt;response, d-&gt;length)
		|| !smbbufferputbytes(s-&gt;response, nil, 4)
		|| !smbbufferputb(s-&gt;response, (d-&gt;qid.type &amp; QTDIR) != 0)
		|| !smbbufferputbytes(s-&gt;response, nil, 8)
		|| !smbbufferputs(s-&gt;response, 0)) {
		pr = SmbProcessResultMisc;
		goto done;
	}

	if (andxcommand != SMB_COM_NO_ANDX_COMMAND)
		pr = smbchaincommand(s, h, andxoffsetfixup, andxcommand, andxoffset, b);
	else
		pr = SmbProcessResultReply;

	goto done;

unimp:
	pr = SmbProcessResultUnimp;

done:
	free(path);
	free(d);

	return pr;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

