<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbcomtreeconnectandx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbcomtreeconnectandx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static char *s9p2000 = "9p2000";

SmbProcessResult
smbcomtreeconnectandx(SmbSession *s, SmbHeader *h, uchar *pdata, SmbBuffer *b)
{
	uchar andxcommand;
	ushort andxoffset;
	char *path = nil;
	char *service = nil;
	ushort flags;
	ushort passwordlength;
//	ushort bytecount;
	uchar errclass;
	ushort error;
	SmbService *serv;
	SmbTree *tree;
	ulong andxfixupoffset, bytecountfixup;
	SmbProcessResult pr;

	if (!smbcheckwordcount("comtreeconnectandx", h, 4)) {
	fmtfail:
		pr = SmbProcessResultFormat;
		goto done;
	}

	switch (s-&gt;state) {
	case SmbSessionNeedNegotiate:
		smblogprint(-1, "smbcomtreeconnectandx: called when negotiate expected\n");
		return SmbProcessResultUnimp;
	case SmbSessionNeedSetup:
		smbseterror(s, ERRDOS, ERRbadpw);
		return SmbProcessResultError;
	}

	andxcommand = *pdata++;
	switch (andxcommand) {
	case SMB_COM_OPEN:
	case SMB_COM_CREATE_NEW:
	case SMB_COM_DELETE_DIRECTORY:
	case SMB_COM_FIND_UNIQUE:
	case SMB_COM_CHECK_DIRECTORY:
	case SMB_COM_GET_PRINT_QUEUE:
	case SMB_COM_TRANSACTION:
	case SMB_COM_SET_INFORMATION:
	case SMB_COM_OPEN_ANDX:
	case SMB_COM_CREATE_DIRECTORY:
	case SMB_COM_FIND:
	case SMB_COM_RENAME:
	case SMB_COM_QUERY_INFORMATION:
	case SMB_COM_OPEN_PRINT_FILE:
	case SMB_COM_NO_ANDX_COMMAND:
	case SMB_COM_NT_RENAME:
	case SMB_COM_CREATE:
	case SMB_COM_DELETE:
	case SMB_COM_COPY:
		break;
	default:
		smblogprint(h-&gt;command, "smbcomtreeconnectandx: invalid andxcommand %s (0x%.2ux)\n",
			smboptable[andxcommand].name, andxcommand);
		goto fmtfail;
	}
	pdata++;
	andxoffset = smbnhgets(pdata); pdata += 2;
	flags = smbnhgets(pdata); pdata += 2;
	passwordlength = smbnhgets(pdata); //pdata += 2;
//	bytecount = smbnhgets(pdata); pdata += 2;
smblogprint(h-&gt;command, "passwordlength: %ud\n", passwordlength);
smblogprint(h-&gt;command, "flags: 0x%.4ux\n", flags);
	if (!smbbuffergetbytes(b, nil, passwordlength)) {
		smblogprint(h-&gt;command, "smbcomtreeconnectandx: not enough bytes for password\n");
		goto fmtfail;
	}
smblogprint(h-&gt;command, "offset %lud limit %lud\n", smbbufferreadoffset(b), smbbufferwriteoffset(b));
	if (!smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)
		|| !smbbuffergetstr(b, 0, &amp;service)) {
		smblogprint(h-&gt;command, "smbcomtreeconnectandx: not enough bytes for strings\n");
		goto fmtfail;
	}
smblogprint(h-&gt;command, "path: %s\n", path);
smblogprint(h-&gt;command, "service: %s\n", service);
	if (flags &amp; 1)
		smbtreedisconnectbyid(s, h-&gt;tid);
	serv = smbservicefind(s, path, service, &amp;errclass, &amp;error);
	if (serv == nil) {
		pr = SmbProcessResultError;
		smbseterror(s, errclass, error);
		goto done;
	}
	tree = smbtreeconnect(s, serv);
	h-&gt;tid = tree-&gt;id;
	h-&gt;wordcount = 3;
	if (!smbresponseputandxheader(s, h, andxcommand, &amp;andxfixupoffset)
		|| !smbresponseputs(s, 1)) {
	misc:
		pr = SmbProcessResultMisc;
		goto done;
	}
	bytecountfixup = smbresponseoffset(s);
	if (!smbresponseputs(s, 0)
		|| !smbresponseputstr(s, serv-&gt;type)
		|| !smbresponseputstring(s, 1, s9p2000))
		goto misc;
	if (!smbbufferfixuprelatives(s-&gt;response, bytecountfixup))
		goto misc;
	if (andxcommand != SMB_COM_NO_ANDX_COMMAND) {
		pr = smbchaincommand(s, h, andxfixupoffset, andxcommand, andxoffset, b);
	}
	else
		pr = SmbProcessResultReply;
done:
	free(path);
	free(service);
	return pr;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

