<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbidmap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbidmap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

#define INITIALCHUNKSIZE 10

typedef struct Entry {
	void *p;
	long freechain;
} Entry;

struct SmbIdMap {
	Entry *array;
	ulong entries;
	long freeindex;
};

SmbIdMap *
smbidmapnew(void)
{
	SmbIdMap *m;
	m = smbemallocz(sizeof(SmbIdMap), 1);
	m-&gt;freeindex = -1;
	return m;
}

void
smbidmapremovebyid(SmbIdMap *m, long id)
{
	if (m == nil)
		return;
	assert(id &gt; 0);
	id--;
	assert(id &gt;= 0 &amp;&amp; id &lt; m-&gt;entries);
	assert(m-&gt;array[id].freechain == -2);
	m-&gt;array[id].freechain = m-&gt;freeindex;
	m-&gt;freeindex = id;
}

void
smbidmapremove(SmbIdMap *m, void *thing)
{
	long id;
	if (m == nil)
		return;
	id = *(long *)thing;
	smbidmapremovebyid(m, id);
}

void
smbidmapremoveif(SmbIdMap *m, int (*f)(void *p, void *arg), void *arg)
{
	int i;
	if (m == nil)
		return;
	for (i = 0; i &lt; m-&gt;entries; i++)
		if (m-&gt;array[i].freechain == -2 &amp;&amp; (*f)(m-&gt;array[i].p, arg))
			smbidmapremovebyid(m, i + 1);
}

static void
grow(SmbIdMap *m)
{
	long x;
	long oldentries = m-&gt;entries;
	if (m-&gt;entries == 0)
		m-&gt;entries = INITIALCHUNKSIZE;
	else
		m-&gt;entries *= 2;
	smberealloc(&amp;m-&gt;array, sizeof(Entry) * m-&gt;entries);
	for (x = m-&gt;entries - 1; x &gt;= oldentries; x--) {
		m-&gt;array[x].freechain = m-&gt;freeindex;
		m-&gt;freeindex = x;
	}
}

long
smbidmapadd(SmbIdMap *m, void *p)
{
	long i;
	if (m-&gt;freeindex &lt; 0)
		grow(m);
	i = m-&gt;freeindex;
	m-&gt;freeindex = m-&gt;array[i].freechain;
	m-&gt;array[i].freechain = -2;
	m-&gt;array[i].p = p;
	*(long *)p = i + 1;
	return i + 1;
}

void *
smbidmapfind(SmbIdMap *m, long id)
{
	if (m == nil)
		return nil;
	if (id &lt;= 0)
		return nil;
	id--;
	if (id &lt; 0 || id &gt; m-&gt;entries || m-&gt;array[id].freechain != -2)
		return nil;
	return m-&gt;array[id].p;
}

void
smbidmapfree(SmbIdMap **mp, SMBIDMAPAPPLYFN *freefn, void *magic)
{
	SmbIdMap *m = *mp;
	if (m) {
		long i;
		if (freefn) {
			for (i = 0; i &lt; m-&gt;entries; i++)
				if (m-&gt;array[i].freechain == -2)
					(*freefn)(magic, m-&gt;array[i].p);
		}
		free(m-&gt;array);
		free(m);
		*mp = nil;
	}
}

void
smbidmapapply(SmbIdMap *m, SMBIDMAPAPPLYFN *applyfn, void *magic)
{
	if (m) {
		long i;
		for (i = 0; i &lt; m-&gt;entries; i++)
			if (m-&gt;array[i].freechain == -2)
				(*applyfn)(magic, m-&gt;array[i].p);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

