<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbtrans2query.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbtrans2query.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

static SmbProcessResult
query(SmbSession *s, char *cmdname, char *filename, ushort infolevel, vlong cbo, Dir *d)
{
	vlong ntatime, ntmtime;
	ushort dosmode;
	ulong fnlfixupoffset;
	vlong allocsize;

	if (d == nil) {
		smbseterror(s, ERRDOS, ERRbadfile);
		return SmbProcessResultError;
	}

	switch (infolevel) {
	case SMB_QUERY_FILE_BASIC_INFO:
		ntatime = smbplan9time2time(d-&gt;atime);
		ntmtime = smbplan9time2time(d-&gt;mtime);
		dosmode = smbplan9mode2dosattr(d-&gt;mode);

		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FILE_BASIC_INFO\n");
		translogprint(s-&gt;transaction.in.setup[0], "REPLY:\n");
		translogprint(s-&gt;transaction.in.setup[0], "atime=%s", ctime(d-&gt;atime));
		translogprint(s-&gt;transaction.in.setup[0], "atime=%s", ctime(d-&gt;mtime));
		translogprint(s-&gt;transaction.in.setup[0], "mode=0%o -&gt; dosmode=0x%x\n", d-&gt;mode, dosmode);

		if (!smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntatime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputl(s-&gt;transaction.out.data, dosmode))
			return SmbProcessResultMisc;
		break;
	case SMB_QUERY_FILE_ALL_INFO:
		ntatime = smbplan9time2time(d-&gt;atime);
		ntmtime = smbplan9time2time(d-&gt;mtime);
		dosmode = smbplan9mode2dosattr(d-&gt;mode);
		allocsize = (d-&gt;length + (1 &lt;&lt; smbglobals.l2allocationsize) - 1) &amp; ~((1 &lt;&lt; smbglobals.l2allocationsize) - 1);

		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FILE_ALL_INFO\n");
		translogprint(s-&gt;transaction.in.setup[0], "REPLY:\n");
		translogprint(s-&gt;transaction.in.setup[0], "atime=%s", ctime(d-&gt;atime));
		translogprint(s-&gt;transaction.in.setup[0], "atime=%s", ctime(d-&gt;mtime));
		translogprint(s-&gt;transaction.in.setup[0], "mode=0%o -&gt; dosmode=0x%x\n", d-&gt;mode, dosmode);
		translogprint(s-&gt;transaction.in.setup[0], "allocsize=%d\n", allocsize);
		translogprint(s-&gt;transaction.in.setup[0], "isdir=%d\n", (d-&gt;mode &amp; DMDIR) != 0);

		if (!smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntatime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputv(s-&gt;transaction.out.data, ntmtime)
			|| !smbbufferputs(s-&gt;transaction.out.data, dosmode)
			|| !smbbufferputbytes(s-&gt;transaction.out.data, nil, 6)
			|| !smbbufferputv(s-&gt;transaction.out.data, allocsize)
			|| !smbbufferputv(s-&gt;transaction.out.data, d-&gt;length)
			|| !smbbufferputl(s-&gt;transaction.out.data, 0)		// hard links - ha
			|| !smbbufferputb(s-&gt;transaction.out.data, 0)		// TODO delete pending
			|| !smbbufferputb(s-&gt;transaction.out.data, (d-&gt;mode &amp; DMDIR) != 0)
			|| !smbbufferputv(s-&gt;transaction.out.data, d-&gt;qid.path)
			|| !smbbufferputl(s-&gt;transaction.out.data, 0)		// EA size
			|| !smbbufferputl(s-&gt;transaction.out.data, (dosmode &amp; SMB_ATTR_READ_ONLY) ? 0xa1 : 0x1a7)
			|| !smbbufferputv(s-&gt;transaction.out.data, cbo)
			|| !smbbufferputs(s-&gt;transaction.out.data, dosmode)
			|| !smbbufferputl(s-&gt;transaction.out.data, 0))	// alignment
			return SmbProcessResultMisc;
		fnlfixupoffset = smbbufferwriteoffset(s-&gt;transaction.out.data);
		if (!smbbufferputl(s-&gt;transaction.out.data, 0)
		    || !smbbufferputstring(s-&gt;transaction.out.data, &amp;s-&gt;peerinfo, SMB_STRING_REVPATH, filename)
		    || !smbbufferfixuprelativel(s-&gt;transaction.out.data, fnlfixupoffset))
			return SmbProcessResultMisc;
		break;
	case SMB_QUERY_FILE_STANDARD_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FILE_STANDARD_INFO\n");
		translogprint(s-&gt;transaction.in.setup[0], "REPLY:\n");
		translogprint(s-&gt;transaction.in.setup[0], "length=%lld", d-&gt;length);
		translogprint(s-&gt;transaction.in.setup[0], "isdir=%d\n", (d-&gt;qid.type &amp; QTDIR) != 0);

		if (!smbbufferputv(s-&gt;transaction.out.data, smbl2roundupvlong(d-&gt;length, smbglobals.l2allocationsize))
			|| !smbbufferputv(s-&gt;transaction.out.data, d-&gt;length)
			|| !smbbufferputl(s-&gt;transaction.out.data, 1)
			|| !smbbufferputb(s-&gt;transaction.out.data, 0)
			|| !smbbufferputb(s-&gt;transaction.out.data, (d-&gt;qid.type &amp; QTDIR) != 0))
			return SmbProcessResultMisc;
		break;
	case SMB_QUERY_FILE_EA_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FILE_EA_INFO\n");
		translogprint(s-&gt;transaction.in.setup[0], "REPLY:\n");
		translogprint(s-&gt;transaction.in.setup[0], "ea_len=0\n");
		if (!smbbufferputl(s-&gt;transaction.out.data, 0))
			return SmbProcessResultMisc;
		break;
	case SMB_QUERY_FILE_STREAM_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FILE_STREAM_INFO\n");
		translogprint(s-&gt;transaction.in.setup[0], "REPLY: failed\n");
		/* don't do it, never will */
		goto unknownlevel;
	default:
		smblogprint(-1, "smbtrans2query%sinformation: infolevel 0x%.4ux not implemented\n", cmdname, infolevel);
	unknownlevel:
		translogprint(s-&gt;transaction.in.setup[0], "[not supported]\n");
		smbseterror(s, ERRDOS, ERRunknownlevel);
		return SmbProcessResultError;
	}
	return SmbProcessResultReply;
}

SmbProcessResult
smbtrans2querypathinformation(SmbSession *s, SmbHeader *h)
{
	SmbTree *t;
	SmbBuffer *b = nil;
	SmbProcessResult pr;
	ushort infolevel;
	Dir *d;
	char *path = nil;
	char *fullpath;

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}
	b = smbbufferinit(s-&gt;transaction.in.parameters, s-&gt;transaction.in.parameters, s-&gt;transaction.in.tpcount);
	if (!smbbuffergets(b, &amp;infolevel) || !smbbuffergetbytes(b, nil, 4)
		|| !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;path)) {
		pr = SmbProcessResultMisc;
		goto done;
	}
	translogprint(s-&gt;transaction.in.setup[0], "infolevel 0x%.4ux\n", infolevel);
	translogprint(s-&gt;transaction.in.setup[0], "path %s\n", path);
	fullpath = nil;
	smbstringprint(&amp;fullpath, "%s%s", t-&gt;serv-&gt;path, path);
	translogprint(s-&gt;transaction.in.setup[0], "fullpath %s\n", fullpath);
	d = dirstat(fullpath);
	pr = query(s, "path", path, infolevel, 0, d);
	free(d);
	free(fullpath);
done:
	free(path);
	smbbufferfree(&amp;b);
	return pr;
}

SmbProcessResult
smbtrans2queryfileinformation(SmbSession *s, SmbHeader *h)
{
	SmbTree *t;
	SmbFile *f;
	SmbBuffer *b = nil;
	SmbProcessResult pr;
	ushort fid;
	ushort infolevel;
	vlong o;
	Dir *d;

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}
	b = smbbufferinit(s-&gt;transaction.in.parameters, s-&gt;transaction.in.parameters, s-&gt;transaction.in.tpcount);
	if (!smbbuffergets(b, &amp;fid) || !smbbuffergets(b, &amp;infolevel)) {
		pr = SmbProcessResultMisc;
		goto done;
	}
	translogprint(s-&gt;transaction.in.setup[0], "fid 0x%.4ux\n", fid);
	translogprint(s-&gt;transaction.in.setup[0], "infolevel 0x%.4ux\n", infolevel);
	f = smbidmapfind(s-&gt;fidmap, fid);
	if (f == nil) {
		smbseterror(s, ERRDOS, ERRbadfid);
		pr = SmbProcessResultError;
		goto done;
	}
	if(f-&gt;fd &gt;= 0){
		o = seek(f-&gt;fd, 0, 1);
		d = dirfstat(f-&gt;fd);
	} else {
		char *fullpath = nil;

		o = 0;
		smbstringprint(&amp;fullpath, "%s%s", f-&gt;t-&gt;serv-&gt;path, f-&gt;name);
		d = dirstat(fullpath);
		free(fullpath);
	}
	pr = query(s, "file", f-&gt;name, infolevel, o, d);
	free(d);
done:
	smbbufferfree(&amp;b);
	return pr;
}

SmbProcessResult
smbtrans2queryfsinformation(SmbSession *s, SmbHeader *h)
{
	SmbTree *t;
	ushort infolevel;
	SmbBuffer *b;
	SmbProcessResult pr;
	ulong fixup;
	ulong vnbase;

	t = smbidmapfind(s-&gt;tidmap, h-&gt;tid);
	if (t == nil) {
		smbseterror(s, ERRSRV, ERRinvtid);
		pr = SmbProcessResultError;
		goto done;
	}
	b = smbbufferinit(s-&gt;transaction.in.parameters, s-&gt;transaction.in.parameters, s-&gt;transaction.in.tpcount);
	if (!smbbuffergets(b, &amp;infolevel)) {
	misc:
		pr = SmbProcessResultMisc;
		goto done;
	}
	pr = SmbProcessResultReply;
	switch (infolevel) {
	case SMB_INFO_ALLOCATION:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_INFO_ALLOCATION\n");
		if (!smbbufferputl(s-&gt;transaction.out.data, 0)
			|| !smbbufferputl(s-&gt;transaction.out.data, 1 &lt;&lt; (smbglobals.l2allocationsize - smbglobals.l2sectorsize))
			|| !smbbufferputl(s-&gt;transaction.out.data, 0xffffffff)
			|| !smbbufferputl(s-&gt;transaction.out.data, 0xffffffff)
			|| !smbbufferputs(s-&gt;transaction.out.data, 1 &lt;&lt; smbglobals.l2sectorsize))
			goto misc;
		break;
	case SMB_INFO_VOLUME:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_INFO_VOLUME\n");
		if (!smbbufferputl(s-&gt;transaction.out.data, 0xdeadbeef)
			|| !smbbufferputstring(s-&gt;transaction.out.data, &amp;s-&gt;peerinfo, 0, t-&gt;serv-&gt;name))
			goto misc;
		break;
	case SMB_QUERY_FS_VOLUME_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FS_VOLUME_INFO\n");
		if (!smbbufferputv(s-&gt;transaction.out.data, 0)
			|| !smbbufferputl(s-&gt;transaction.out.data, 0xdeadbeef))
			goto misc;
		fixup = smbbufferwriteoffset(s-&gt;transaction.out.data);
		if (!smbbufferputl(s-&gt;transaction.out.data, 0)
			|| !smbbufferputs(s-&gt;transaction.out.data, 0))
			goto misc;
		vnbase = smbbufferwriteoffset(s-&gt;transaction.out.data);
		if (!smbbufferputstring(s-&gt;transaction.out.data, &amp;s-&gt;peerinfo, 0, t-&gt;serv-&gt;name)
			|| !smbbufferfixupl(s-&gt;transaction.out.data, fixup,
				smbbufferwriteoffset(s-&gt;transaction.out.data) - vnbase))
			goto misc;
		break;
	case SMB_QUERY_FS_SIZE_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FS_SIZE_INFO\n");
		if (!smbbufferputv(s-&gt;transaction.out.data, 0LL)
			|| !smbbufferputv(s-&gt;transaction.out.data, 0LL)
			|| !smbbufferputl(s-&gt;transaction.out.data, 1 &lt;&lt; (smbglobals.l2allocationsize - smbglobals.l2sectorsize))
			|| !smbbufferputl(s-&gt;transaction.out.data, 1 &lt;&lt; smbglobals.l2sectorsize))
			goto misc;
		break;
	case SMB_QUERY_FS_ATTRIBUTE_INFO:
		translogprint(s-&gt;transaction.in.setup[0], "SMB_QUERY_FS_ATTRIBUTE_INFO\n");
		if (!smbbufferputl(s-&gt;transaction.out.data, 3)
			|| !smbbufferputl(s-&gt;transaction.out.data, 255))
			goto misc;
		fixup = smbbufferwriteoffset(s-&gt;transaction.out.data);
		if (!smbbufferputl(s-&gt;transaction.out.data, 0)
			|| !smbbufferputstring(s-&gt;transaction.out.data, &amp;s-&gt;peerinfo, SMB_STRING_UNTERMINATED, smbglobals.serverinfo.nativelanman)
			|| !smbbufferfixuprelativel(s-&gt;transaction.out.data, fixup))
			goto misc;
		break;
	default:
		smblogprint(-1, "smbtrans2queryfsinformation: infolevel 0x%.4ux not implemented\n", infolevel);
		smbseterror(s, ERRDOS, ERRunknownlevel);
		pr = SmbProcessResultError;
	}
done:
	smbbufferfree(&amp;b);
	return pr;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

