<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aquarela/smbtransaction.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aquarela/smbtransaction.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "headers.h"

typedef struct Args Args;

struct Args {
	ulong pcount;
	ulong poffset;
	ulong pdisplacement;
	ulong dcount;
	ulong doffset;
	ulong ddisplacement;
	uchar scount;
};

int
_smbtransactiondecodeprimary(SmbTransaction *t, SmbHeader *h, uchar *pdata, SmbBuffer *b, int hasname, char **errmsgp)
{
	ushort poffset, doffset;

	if (h-&gt;wordcount &lt; 14) {
		smbstringprint(errmsgp, "word count less than 14");
		return -1;
	}
	t-&gt;in.scount = pdata[13 * 2];
	if (h-&gt;wordcount != 14 + t-&gt;in.scount) {
		smbstringprint(errmsgp, "smbcomtransaction: word count invalid\n");
		return -1;
	}
	t-&gt;in.tpcount = smbnhgets(pdata); pdata += 2;
	t-&gt;in.tdcount = smbnhgets(pdata); pdata += 2;
	t-&gt;in.maxpcount = smbnhgets(pdata); pdata += 2;
	t-&gt;in.maxdcount = smbnhgets(pdata); pdata += 2;
	t-&gt;in.maxscount = *pdata++;
	pdata++;
	t-&gt;in.flags = smbnhgets(pdata); pdata += 2;
	pdata += 4; /* timeout */
	pdata += 2;
	t-&gt;in.pcount = smbnhgets(pdata); pdata += 2;
	poffset = smbnhgets(pdata); pdata += 2;
	t-&gt;in.dcount = smbnhgets(pdata); pdata += 2;
	doffset = smbnhgets(pdata); pdata += 2;
	pdata++; /* scount */
	pdata++; /* reserved */
	smbfree(&amp;t-&gt;in.setup);
	if (t-&gt;in.scount) {
		int x;
		t-&gt;in.setup = smbemalloc(t-&gt;in.scount * sizeof(ushort));
		for (x = 0; x &lt; t-&gt;in.scount; x++) {
			t-&gt;in.setup[x] = smbnhgets(pdata);
			pdata += 2;
		}
	}
	smbfree(&amp;t-&gt;in.name);
	if (hasname &amp;&amp; !smbbuffergetstring(b, h, SMB_STRING_PATH, &amp;t-&gt;in.name)) {
		smbstringprint(errmsgp, "not enough bdata for name");
		return -1;
	}
	if (poffset + t-&gt;in.pcount &gt; smbbufferwriteoffset(b)) {
		smbstringprint(errmsgp, "not enough bdata for parameters");
		return -1;
	}
	if (t-&gt;in.pcount &gt; t-&gt;in.tpcount) {
		smbstringprint(errmsgp, "too many parameters");
		return -1;
	}
	smbfree(&amp;t-&gt;in.parameters);
	t-&gt;in.parameters = smbemalloc(t-&gt;in.tpcount);
	memcpy(t-&gt;in.parameters, smbbufferpointer(b, poffset), t-&gt;in.pcount);
	if (doffset + t-&gt;in.dcount &gt; smbbufferwriteoffset(b)) {
		smbstringprint(errmsgp, "not enough bdata for data");
		return -1;
	}
	if (t-&gt;in.dcount &gt; t-&gt;in.tdcount) {
		smbstringprint(errmsgp, "too much data");
		return -1;
	}
	smbfree(&amp;t-&gt;in.data);
	t-&gt;in.data = smbemalloc(t-&gt;in.tdcount);
	memcpy(t-&gt;in.data, smbbufferpointer(b, doffset), t-&gt;in.dcount);
	if (t-&gt;in.dcount &lt; t-&gt;in.tdcount || t-&gt;in.pcount &lt; t-&gt;in.tpcount)
		return 0;
	return 1;
}

int
decoderesponse(SmbTransaction *t, Args *a, SmbBuffer *b, char **errmsgp)
{
	if (t-&gt;out.tpcount &gt; smbbufferwritemaxoffset(t-&gt;out.parameters)) {
		smbstringprint(errmsgp, "decoderesponse: too many parameters for buffer");
		return 0;
	}
	if (t-&gt;out.tdcount &gt; smbbufferwritemaxoffset(t-&gt;out.data)) {
		smbstringprint(errmsgp, "decoderesponse: too much data for buffer");
		return 0;
	}
	if (a-&gt;pdisplacement + a-&gt;pcount &gt; t-&gt;out.tpcount) {
		smbstringprint(errmsgp, "decoderesponse: more parameters than tpcount");
		return 0;
	}
	if (a-&gt;pdisplacement != smbbufferwriteoffset(t-&gt;out.parameters)) {
		smbstringprint(errmsgp, "decoderesponse: parameter displacement inconsistent");
		return 0;
	}
	if (a-&gt;ddisplacement + a-&gt;dcount &gt; t-&gt;out.tdcount) {
		smbstringprint(errmsgp, "decoderesponse: more data than tdcount");
		return 0;
	}
	if (a-&gt;ddisplacement != smbbufferwriteoffset(t-&gt;out.data)) {
		smbstringprint(errmsgp, "decoderesponse: data displacement inconsistent");
		return 0;
	}
	assert(a-&gt;scount == 0);
	if (a-&gt;pcount) {
		if (!smbbufferreadskipto(b, a-&gt;poffset)) {
			smbstringprint(errmsgp, "smbtransactiondecoderesponse: invalid parameter offset");
			return 0;
		}
		if (!smbbuffercopy(t-&gt;out.parameters, b, a-&gt;pcount)) {
			smbstringprint(errmsgp, "smbtransactiondecoderesponse: not enough data for parameters");
			return 0;
		}
	}
	if (a-&gt;dcount) {
		if (!smbbufferreadskipto(b, a-&gt;doffset)) {
			smbstringprint(errmsgp, "smbtransactiondecoderesponse: invalid data offset");
			return 0;
		}
		if (!smbbuffercopy(t-&gt;out.data, b, a-&gt;dcount)) {
			smbstringprint(errmsgp, "smbtransactiondecoderesponse: not enough data for data");
			return 0;
		}
	}
	return 1;
}

int
smbtransactiondecoderesponse(SmbTransaction *t, SmbHeader *h, uchar *pdata, SmbBuffer *b, char **errmsgp)
{
	Args a;

	if (h-&gt;command != SMB_COM_TRANSACTION) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse: not an SMB_COM_TRANSACTION");
		return 0;
	}
	if (h-&gt;wordcount &lt; 10) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse: word count less than 10");
		return -1;
	}
	t-&gt;out.tpcount = smbnhgets(pdata); pdata += 2;
	t-&gt;out.tdcount = smbnhgets(pdata); pdata += 2;
	pdata += 2;
	a.pcount = smbnhgets(pdata); pdata += 2;
	a.poffset =  smbnhgets(pdata); pdata += 2;
	a.pdisplacement = smbnhgets(pdata); pdata += 2;
	a.dcount = smbnhgets(pdata); pdata += 2;
	a.doffset =  smbnhgets(pdata); pdata += 2;
	a.ddisplacement = smbnhgets(pdata); pdata += 2;
	a.scount = *pdata;
	if (a.scount != h-&gt;wordcount - 10) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse: scount inconsistent");
		return 0;
	}
	return decoderesponse(t, &amp;a, b, errmsgp);
}

int
smbtransactiondecoderesponse2(SmbTransaction *t, SmbHeader *h, uchar *pdata, SmbBuffer *b, char **errmsgp)
{
	Args a;

	if (h-&gt;command != SMB_COM_TRANSACTION2) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse2: not an SMB_COM_TRANSACTION2");
		return 0;
	}
	if (h-&gt;wordcount &lt; 10) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse2: word count less than 10");
		return -1;
	}
	t-&gt;out.tpcount = smbnhgets(pdata); pdata += 2;
	t-&gt;out.tdcount = smbnhgets(pdata); pdata += 2;
	pdata += 2;
	a.pcount = smbnhgets(pdata); pdata += 2;
	a.poffset =  smbnhgets(pdata); pdata += 2;
	a.pdisplacement = smbnhgets(pdata); pdata += 2;
	a.dcount = smbnhgets(pdata); pdata += 2;
	a.doffset =  smbnhgets(pdata); pdata += 2;
	a.ddisplacement = smbnhgets(pdata); pdata += 2;
	a.scount = *pdata;
	if (a.scount != h-&gt;wordcount - 10) {
		smbstringprint(errmsgp, "smbtransactiondecoderesponse2: scount inconsistent");
		return 0;
	}
	return decoderesponse(t, &amp;a, b, errmsgp);
}

int
smbtransactiondecodeprimary(SmbTransaction *t, SmbHeader *h, uchar *pdata, SmbBuffer *b, char **errmsgp)
{
	return _smbtransactiondecodeprimary(t, h, pdata, b, 1, errmsgp);
}

int
smbtransactiondecodeprimary2(SmbTransaction *t, SmbHeader *h, uchar *pdata, SmbBuffer *b, char **errmsgp)
{
	return _smbtransactiondecodeprimary(t, h, pdata, b, 0, errmsgp);
}

void
smbtransactionfree(SmbTransaction *t)
{
	free(t-&gt;in.parameters);
	free(t-&gt;in.data);
	free(t-&gt;in.setup);
	free(t-&gt;in.name);
	smbbufferfree(&amp;t-&gt;out.parameters);
	smbbufferfree(&amp;t-&gt;out.data);
}

static int
_transactionencodeprimary(SmbTransaction *t, uchar cmd, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob,
	uchar *wordcountp, ushort *bytecountp, char **errmsgp)
{
	SmbHeader mh;
	ulong countsfixupoffset, bytecountfixupoffset;
	int x;
	mh = *h;
	*wordcountp = mh.wordcount = 14 + t-&gt;in.scount;
	mh.flags &amp;= ~SMB_FLAGS_SERVER_TO_REDIR;
	mh.command = cmd;
	if (!smbbufferputheader(ob, &amp;mh, p)) {
	toosmall:
		smbstringprint(errmsgp, "output buffer too small");
		return 0;
	}
	if (t-&gt;in.tpcount &gt; 65535 || t-&gt;in.tdcount &gt; 65535 || t-&gt;in.maxpcount &gt; 65535 || t-&gt;in.maxdcount &gt; 65535) {
		smbstringprint(errmsgp, "counts too big");
		return 0;
	}
	if (!smbbufferputs(ob, t-&gt;in.tpcount)
		|| !smbbufferputs(ob, t-&gt;in.tdcount)
		|| !smbbufferputs(ob, t-&gt;in.maxpcount)
		|| !smbbufferputs(ob, t-&gt;in.maxdcount)
		|| !smbbufferputb(ob, t-&gt;in.maxscount)
		|| !smbbufferputb(ob, 0)
		|| !smbbufferputs(ob, t-&gt;in.flags)
		|| !smbbufferputl(ob, 0)
		|| !smbbufferputs(ob, 0))
		goto toosmall;
	countsfixupoffset = smbbufferwriteoffset(ob);
	if (!smbbufferputs(ob, 0)
		|| !smbbufferputs(ob, 0)
		|| !smbbufferputs(ob, 0)
		|| !smbbufferputs(ob, 0))
		goto toosmall;
	if (!smbbufferputb(ob, t-&gt;in.scount)
		|| !smbbufferputb(ob, 0))
		goto toosmall;
	for (x = 0; x &lt; t-&gt;in.scount; x++)
		if (!smbbufferputs(ob, t-&gt;in.setup[x]))
			goto toosmall;
	bytecountfixupoffset = smbbufferwriteoffset(ob);
	if (!smbbufferputs(ob, 0))
		goto toosmall;
	smbbufferwritelimit(ob, smbbufferwriteoffset(ob) + 65535);
	if (!smbbufferputstring(ob, p, SMB_STRING_UPCASE, t-&gt;in.name))
		goto toosmall;
	if (t-&gt;in.pcount &lt; t-&gt;in.tpcount) {
		ulong align = smbbufferwriteoffset(ob) &amp; 1;
		ulong pthistime;
		pthistime = smbbufferwritespace(ob) - align;
		if (pthistime &gt; t-&gt;in.tpcount - t-&gt;in.pcount)
			pthistime = t-&gt;in.tpcount - t-&gt;in.pcount;
		if (pthistime &gt; 65535)
			pthistime = 65535;
		if (smbbufferwriteoffset(ob) &gt; 65535)
			pthistime = 0;
		if (pthistime) {
			assert(smbbufferalignl2(ob, 0));
			assert(smbbufferoffsetputs(ob, countsfixupoffset, pthistime));
			assert(smbbufferoffsetputs(ob, countsfixupoffset + 2, smbbufferwriteoffset(ob)));
			assert(smbbufferputbytes(ob, t-&gt;in.parameters + t-&gt;in.pcount, pthistime));
		}
		t-&gt;in.pcount += pthistime;
	}
	if (t-&gt;in.dcount &lt; t-&gt;in.tdcount) {
		ulong align = smbbufferwriteoffset(ob) &amp; 1;
		ulong dthistime;
		dthistime = smbbufferwritespace(ob) - align;
		if (dthistime &gt; t-&gt;in.tdcount - t-&gt;in.dcount)
			dthistime = t-&gt;in.tdcount - t-&gt;in.dcount;
		if (dthistime &gt; 65535)
			dthistime = 65535;
		if (smbbufferwriteoffset(ob) &gt; 65535)
			dthistime = 0;
		if (dthistime) {
			assert(smbbufferalignl2(ob, 0));
			assert(smbbufferoffsetputs(ob, countsfixupoffset + 4, dthistime));
			assert(smbbufferoffsetputs(ob, countsfixupoffset + 6, smbbufferwriteoffset(ob)));
			assert(smbbufferputbytes(ob, t-&gt;in.data + t-&gt;in.dcount, dthistime));
		}
		t-&gt;in.dcount += dthistime;
	}
	*bytecountp = smbbufferwriteoffset(ob) - bytecountfixupoffset - 2;
	assert(smbbufferoffsetputs(ob, bytecountfixupoffset, *bytecountp));
	return 1;
}

int
smbtransactionencodeprimary(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob,
	uchar *wordcountp, ushort *bytecountp, char **errmsgp)
{
	return _transactionencodeprimary(t, SMB_COM_TRANSACTION, h, p,ob, wordcountp, bytecountp, errmsgp);
};

int
smbtransactionencodeprimary2(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob,
	uchar *wordcountp, ushort *bytecountp, char **errmsgp)
{
	return _transactionencodeprimary(t, SMB_COM_TRANSACTION2, h, p,ob, wordcountp, bytecountp, errmsgp);
};

int
_transactionencoderesponse(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob, uchar cmd,
	char **errmsgp)
{
	SmbHeader mh;
	ulong countsfixupoffset, bytecountfixupoffset;
	int palign, dalign;
	ulong pbytecount, dbytecount;
	ulong poffset, doffset;

	if (t-&gt;in.maxpcount &gt; 65535 || t-&gt;in.maxdcount &gt; 65535) {
		smbstringprint(errmsgp, "counts too big");
		return 0;
	}
	mh = *h;
	mh.wordcount = 10;
	mh.flags &amp;= ~SMB_FLAGS_SERVER_TO_REDIR;
	mh.command = cmd;
	mh.errclass = SUCCESS;
	mh.error = SUCCESS;
	if (!smbbufferputheader(ob, &amp;mh, p)
		|| !smbbufferputs(ob, smbbufferwriteoffset(t-&gt;out.parameters))
		|| !smbbufferputs(ob, smbbufferwriteoffset(t-&gt;out.data))
		|| !smbbufferputs(ob, 0)) {
	toosmall:
		smbstringprint(errmsgp, "output buffer too small");
		goto toosmall;
	}
	countsfixupoffset = smbbufferwriteoffset(ob);
	if (!smbbufferputbytes(ob, nil, 6 * sizeof(ushort))
		|| !smbbufferputb(ob, 0)	// scount == 0
		|| !smbbufferputb(ob, 0))	// reserved2
		goto toosmall;
	/* now the byte count */
	bytecountfixupoffset = smbbufferwriteoffset(ob);
	if (!smbbufferputs(ob, 0))
		goto toosmall;
	smbbufferwritelimit(ob, smbbufferwriteoffset(ob) + 65535);
	palign = bytecountfixupoffset &amp; 1;
	if (palign &amp;&amp; !smbbufferputb(ob, 0))
		goto toosmall;
	pbytecount = smbbufferreadspace(t-&gt;out.parameters);
	if (pbytecount &gt; smbbufferwritespace(ob))
		pbytecount = smbbufferwritespace(ob);
	poffset = smbbufferwriteoffset(ob);
	if (poffset &gt; 65535)
		goto toosmall;
	if (!smbbufferputbytes(ob, smbbufferreadpointer(t-&gt;out.parameters), pbytecount))
		goto toosmall;
	dalign = smbbufferwritespace(ob) &gt; 0 &amp;&amp; (smbbufferwriteoffset(ob) &amp; 1) != 0;
	if (dalign &amp;&amp; !smbbufferputb(ob, 0))
		goto toosmall;
	dbytecount = smbbufferreadspace(t-&gt;out.data);
	if (dbytecount &gt; smbbufferwritespace(ob))
		dbytecount = smbbufferwritespace(ob);
	doffset = smbbufferwriteoffset(ob);
	if (doffset &gt; 65535)
		goto toosmall;
	if (!smbbufferputbytes(ob, smbbufferreadpointer(t-&gt;out.data), dbytecount))
		goto toosmall;
	if (!smbbufferoffsetputs(ob, bytecountfixupoffset, palign + pbytecount + dalign + dbytecount)
		|| !smbbufferoffsetputs(ob, countsfixupoffset, pbytecount)
		|| !smbbufferoffsetputs(ob, countsfixupoffset + 2, poffset)
		|| !smbbufferoffsetputs(ob, countsfixupoffset + 4, smbbufferreadoffset(t-&gt;out.parameters))
		|| !smbbufferoffsetputs(ob, countsfixupoffset + 6, dbytecount)
		|| !smbbufferoffsetputs(ob, countsfixupoffset + 8, doffset)
		|| !smbbufferoffsetputs(ob, countsfixupoffset + 10, smbbufferreadoffset(t-&gt;out.data)))
		goto toosmall;
	assert(smbbufferoffsetputs(ob, bytecountfixupoffset, smbbufferwriteoffset(ob) - bytecountfixupoffset - 2));
	smbbuffergetbytes(t-&gt;out.parameters, nil, pbytecount);
	smbbuffergetbytes(t-&gt;out.data, nil, dbytecount);
	return 1;
}

int
smbtransactionencoderesponse(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob, char **errmsgp)
{
	return _transactionencoderesponse(t, h, p, ob, SMB_COM_TRANSACTION, errmsgp);
}

int
smbtransactionencoderesponse2(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob, char **errmsgp)
{
	return _transactionencoderesponse(t, h, p, ob, SMB_COM_TRANSACTION2, errmsgp);
}

int
smbtransactionrespond(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *ob, SmbTransactionMethod *method, void *magic, char **errmsgp)
{
	/* generate one or more responses */
	while (smbbufferreadspace(t-&gt;out.parameters) || smbbufferreadspace(t-&gt;out.data)) {
		assert(method-&gt;encoderesponse);
		if (!(*method-&gt;encoderesponse)(t, h, p, ob, errmsgp))
			return 0;
		assert(method-&gt;sendresponse);
		if (!(*method-&gt;sendresponse)(magic, ob, errmsgp))
			return 0;
	}
	return 1;
}

int
smbtransactionnbdgramsend(void *magic, SmbBuffer *ob, char **errmsgp)
{
	NbDgramSendParameters *p = magic;
//print("sending to %B\n", p-&gt;to);
//nbdumpdata(smbbufferreadpointer(ob), smbbufferreadspace(ob));
	if (!nbdgramsend(p, smbbufferreadpointer(ob), smbbufferreadspace(ob))) {
		smbstringprint(errmsgp, "dgram send failed");
		return 0;
	}
	return 1;
}

SmbTransactionMethod smbtransactionmethoddgram = {
	.encodeprimary = smbtransactionencodeprimary,
	.sendrequest = smbtransactionnbdgramsend,
	.encoderesponse = smbtransactionencoderesponse,
};

int
smbtransactionexecute(SmbTransaction *t, SmbHeader *h, SmbPeerInfo *p, SmbBuffer *iob, SmbTransactionMethod *method, void *magic, SmbHeader *rhp, char **errmsgp)
{
	uchar sentwordcount;
	ushort sentbytecount;
	SmbHeader rh;
	smbbufferreset(iob);
	if (!(*method-&gt;encodeprimary)(t, h, p, iob, &amp;sentwordcount, &amp;sentbytecount, errmsgp))
		return 0;
//	smblogprint(-1, "sent...\n");
//	smblogdata(-1, smblogprint, smbbufferreadpointer(iob), smbbufferreadspace(iob));
	if (!(*method-&gt;sendrequest)(magic, iob, errmsgp))
		return 0;
	if (t-&gt;in.pcount &lt; t-&gt;in.tpcount || t-&gt;in.dcount &lt; t-&gt;in.tdcount) {
		uchar wordcount;
		ushort bytecount;
		/* secondary needed */
		if (method-&gt;encodesecondary == nil || method-&gt;receiveintermediate == nil) {
			smbstringprint(errmsgp, "buffer too small and secondaries not allowed");
			return 0;
		}
		if (!(*method-&gt;receiveintermediate)(magic, &amp;wordcount, &amp;bytecount, errmsgp))
			return 0;
		if (sentwordcount != wordcount || sentbytecount != bytecount) {
			smbstringprint(errmsgp, "server intermediate reply counts differ");
			return 0;
		}
		do {
			if (!(*method-&gt;encodesecondary)(t, h, iob, errmsgp))
				return 0;
			if (!(*method-&gt;sendrequest)(magic, iob, errmsgp))
				return 0;
		} while (t-&gt;in.pcount &lt; t-&gt;in.tpcount || t-&gt;in.dcount &lt; t-&gt;in.tdcount);
	}
	if (method-&gt;receiveresponse == nil || method-&gt;decoderesponse == nil)
		return 1;
	do {
		uchar *pdata;
		ushort bytecount;

		if (!(*method-&gt;receiveresponse)(magic, iob, errmsgp))
			return 0;
		if (!smbbuffergetheader(iob, &amp;rh, &amp;pdata, &amp;bytecount)) {
			smbstringprint(errmsgp, "smbtransactionexecute: invalid response header");
			return 0;
		}
		if (!smbcheckheaderdirection(&amp;rh, 1, errmsgp))
			return 0;
		if (rh.errclass != SUCCESS) {
			smbstringprint(errmsgp, "smbtransactionexecute: remote error %d/%d", rh.errclass, rh.error);
			return 0;
		}
		if (!smbbuffertrimreadlen(iob, bytecount)) {
			smbstringprint(errmsgp, "smbtransactionexecute: invalid bytecount");
			return 0;
		}
//		smblogprint(-1, "received...\n");
//		smblogdata(-1, smblogprint, smbbufferreadpointer(iob), smbbufferreadspace(iob));
		if (!(*method-&gt;decoderesponse)(t, &amp;rh, pdata, iob, errmsgp))
			return 0;
	} while (smbbufferwriteoffset(t-&gt;out.parameters) &lt; t-&gt;out.tpcount || smbbufferwriteoffset(t-&gt;out.data) &lt; t-&gt;out.tdcount);
	if (rhp)
		*rhp = rh;
	return 1;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

