<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/astro/pdate.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/astro/pdate.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "astro.h"


char*	month[] =
{
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",
};

double
dsrc(double d, Tim *t, int i)
{
	double y;

	do {
		t-&gt;ifa[i] += 1.;
		y = convdate(t);
	} while(d &gt;= y);
	do {
		t-&gt;ifa[i] -= 1.;
		y = convdate(t);
	} while(d &lt; y);
	return d - y;
}

void
dtsetup(double d, Tim *t)
{
	double v;

	t-&gt;ifa[0] = floor(1900 + d/365.24220);
	t-&gt;ifa[1] = 1;
	t-&gt;ifa[2] = 1;
	t-&gt;ifa[3] = 0;
	t-&gt;ifa[4] = 0;
	t-&gt;ifa[1] = floor(1 + dsrc(d, t, 0)/30);
	t-&gt;ifa[2] = floor(1 + dsrc(d, t, 1));
	dsrc(d, t, 2);

	v = (d - convdate(t)) * 24;
	t-&gt;ifa[3] = floor(v);
	t-&gt;ifa[4] = (v - t-&gt;ifa[3]) * 60;
	convdate(t);	/* to set timezone */
}

void
pdate(double d)
{
	int i;
	Tim t;

	dtsetup(d, &amp;t);
	if(flags['s']) {
		i = t.ifa[1];
		print("%s ", month[i-1]);
		i = t.ifa[2];
		numb(i);
		print("...");
		return;
	}

	/* year month day */
	print("%4d %2d %2d",
		(int)t.ifa[0],
		(int)t.ifa[1],
		(int)t.ifa[2]);
}

void
ptime(double d)
{
	int h, m, s;
	char *mer;
	Tim t;

	if(flags['s']) {
		/* hour minute */
		dtsetup(d + .5/(24*60), &amp;t);
		h = t.ifa[3];
		m = floor(t.ifa[4]);

		mer = "AM";
		if(h &gt;= 12) {
			mer = "PM";
			h -= 12;
		}
		if(h == 0)
			h = 12;
		numb(h);
		if(m &lt; 10) {
			if(m == 0) {
				print("%s exactly ...", mer);
				return;
			}
			print("O ");
		}
		numb(m);
		print("%s ...", mer);
		return;
	}
	/* hour minute second */
	dtsetup(d, &amp;t);
	h = t.ifa[3];
	m = floor(t.ifa[4]);
	s = floor((t.ifa[4]-m) * 60);
	print("%.2d:%.2d:%.2d %.*s", h, m, s, utfnlen(t.tz, 3), t.tz);
}

char*	unit[] =
{
	"zero",
	"one",
	"two",
	"three",
	"four",
	"five",
	"six",
	"seven",
	"eight",
	"nine",
	"ten",
	"eleven",
	"twelve",
	"thirteen",
	"fourteen",
	"fifteen",
	"sixteen",
	"seventeen",
	"eighteen",
	"nineteen"
};
char*	decade[] =
{
	"twenty",
	"thirty",
	"forty",
	"fifty",
	"sixty",
	"seventy",
	"eighty",
	"ninety"
};

void
pstime(double d)
{

	setime(d);

	semi = 0;
	motion = 0;
	rad = 1.e9;
	lambda = 0;
	beta = 0;

// uses lambda, beta, rad, motion
// sets alpha, delta, rp

	helio();

// uses alpha, delta, rp
// sets ra, decl, lha, decl2, az, el

	geo();

	print(" %R %D %D %4.0f", lha, nlat, awlong, elev/3.28084);
}

void
numb(int n)
{

	if(n &gt;= 100) {
		print("%d ", n);
		return;
	}
	if(n &gt;= 20) {
		print("%s ", decade[n/10 - 2]);
		n %= 10;
		if(n == 0)
			return;
	}
	print("%s ", unit[n]);
}

double
tzone(double y, Tim *z)
{
	double t, l1, l2;
	Tm t1, t2;

	/*
	 * get a rough approximation to unix mean time
	 */
	t = (y - 25567.5) * 86400;

	/*
	 * if outside unix conversions,
	 * just call it GMT
	 */
	if(t &lt; 0 || t &gt; 2.1e9)
		return y;

	/*
	 * convert by both local and gmt
	 */
	t1 = *localtime((long)t);
	t2 = *gmtime((long)t);

	/*
	 * pick up year crossings
	 */
	if(t1.yday == 0 &amp;&amp; t2.yday &gt; 1)
		t1.yday = t2.yday+1;
	if(t2.yday == 0 &amp;&amp; t1.yday &gt; 1)
		t2.yday = t1.yday+1;

	/*
	 * convert times to days
	 */
	l1 = t1.yday + t1.hour/24. + t1.min/1440. + t1.sec/86400.;
	l2 = t2.yday + t2.hour/24. + t2.min/1440. + t2.sec/86400.;

	/*
	 * return difference
	 */
	strncpy(z-&gt;tz, t1.zone, sizeof(z-&gt;tz));
	return y + (l2 - l1);
}

int	dmo[12] =
{
	0,
	31,
	59,
	90,
	120,
	151,
	181,
	212,
	243,
	273,
	304,
	334
};

/*
 * input date conversion
 * output is done by zero crossing
 * on this input conversion.
 */
double
convdate(Tim *t)
{
	double y, d;
	int m;

	y = t-&gt;ifa[0];
	m = t-&gt;ifa[1];
	d = t-&gt;ifa[2];

	/*
	 * normalize the month
	 */
	while(m &lt; 1) {
		m += 12;
		y -= 1;
	}
	while(m &gt; 12) {
		m -= 12;
		y += 1;
	}

	/*
	 * bc correction
	 */
	if(y &lt; 0)
		y += 1;

	/*
	 * normal conversion
	 */
	y += 4712;
	if(fmod(y, 4) == 0 &amp;&amp; m &gt; 2)
		d += 1;
	y = y*365 + floor((y+3)/4) + dmo[m-1] + d - 1;

	/*
	 * gregorian change
	 */
	if(y &gt; 2361232)
		y -= floor((y-1794167)/36524.220) -
			floor((y-1721117)/146100);
	y += t-&gt;ifa[3]/24 + t-&gt;ifa[4]/1440 - 2415020.5;

	/*
	 * kitchen clock correction
	 */
	strncpy(t-&gt;tz, "GMT", sizeof(t-&gt;tz));
	if(flags['k'])
		y = tzone(y, t);
	return y;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

