<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/auth/factotum/chap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/auth/factotum/chap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * CHAP, MSCHAP
 * 
 * The client does not authenticate the server, hence no CAI
 *
 * Client protocol:
 *	write Chapchal 
 *	read response Chapreply or MSchaprely structure
 *
 * Server protocol:
 *	read challenge: 8 bytes binary
 *	write user: utf8
 *	write response: Chapreply or MSchapreply structure
 */

#include &lt;ctype.h&gt;
#include "dat.h"

enum {
	ChapChallen = 8,
	ChapResplen = 16,
	MSchapResplen = 24,
};

static int dochal(State*);
static int doreply(State*, void*, int);
static void doLMchap(char *, uchar [ChapChallen], uchar [MSchapResplen]);
static void doNTchap(char *, uchar [ChapChallen], uchar [MSchapResplen]);
static void dochap(char *, int, char [ChapChallen], uchar [ChapResplen]);


struct State
{
	char *protoname;
	int astype;
	int asfd;
	Key *key;
	Ticket	t;
	Ticketreq	tr;
	char chal[ChapChallen];
	MSchapreply mcr;
	char cr[ChapResplen];
	char err[ERRMAX];
	char user[64];
	uchar secret[16];	/* for mschap */
	int nsecret;
};

enum
{
	CNeedChal,
	CHaveResp,

	SHaveChal,
	SNeedUser,
	SNeedResp,
	SHaveZero,
	SHaveCAI,

	Maxphase
};

static char *phasenames[Maxphase] =
{
[CNeedChal]	"CNeedChal",
[CHaveResp]	"CHaveResp",

[SHaveChal]	"SHaveChal",
[SNeedUser]	"SNeedUser",
[SNeedResp]	"SNeedResp",
[SHaveZero]	"SHaveZero",
[SHaveCAI]	"SHaveCAI",
};

static int
chapinit(Proto *p, Fsstate *fss)
{
	int iscli, ret;
	State *s;

	if((iscli = isclient(_strfindattr(fss-&gt;attr, "role"))) &lt; 0)
		return failure(fss, nil);

	s = emalloc(sizeof *s);
	fss-&gt;phasename = phasenames;
	fss-&gt;maxphase = Maxphase;
	s-&gt;asfd = -1;
	if(p == &amp;chap){
		s-&gt;astype = AuthChap;
		s-&gt;protoname = "chap";
	}else{
		s-&gt;astype = AuthMSchap;
		s-&gt;protoname = "mschap";
	}

	if(iscli)
		fss-&gt;phase = CNeedChal;
	else{
		if((ret = findp9authkey(&amp;s-&gt;key, fss)) != RpcOk){
			free(s);
			return ret;
		}
		if(dochal(s) &lt; 0){
			free(s);
			return failure(fss, nil);
		}
		fss-&gt;phase = SHaveChal;
	}

	fss-&gt;ps = s;
	return RpcOk;
}

static void
chapclose(Fsstate *fss)
{
	State *s;

	s = fss-&gt;ps;
	if(s-&gt;asfd &gt;= 0){
		close(s-&gt;asfd);
		s-&gt;asfd = -1;
	}
	free(s);
}


static int
chapwrite(Fsstate *fss, void *va, uint n)
{
	int ret, nreply;
	char *a, *v;
	void *reply;
	Key *k;
	Keyinfo ki;
	State *s;
	Chapreply cr;
	MSchapreply mcr;
	OChapreply ocr;
	OMSchapreply omcr;

	s = fss-&gt;ps;
	a = va;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "write");

	case CNeedChal:
		ret = findkey(&amp;k, mkkeyinfo(&amp;ki, fss, nil), "%s", fss-&gt;proto-&gt;keyprompt);
		if(ret != RpcOk)
			return ret;
		v = _strfindattr(k-&gt;privattr, "!password");
		if(v == nil)
			return failure(fss, "key has no password");
		setattrs(fss-&gt;attr, k-&gt;attr);
		switch(s-&gt;astype){
		default:
			abort();
		case AuthMSchap:
			doLMchap(v, (uchar *)a, (uchar *)s-&gt;mcr.LMresp);
			doNTchap(v, (uchar *)a, (uchar *)s-&gt;mcr.NTresp);
			break;
		case AuthChap:
			dochap(v, *a, a+1, (uchar *)s-&gt;cr);
			break;
		}
		closekey(k);
		fss-&gt;phase = CHaveResp;
		return RpcOk;

	case SNeedUser:
		if(n &gt;= sizeof s-&gt;user)
			return failure(fss, "user name too long");
		memmove(s-&gt;user, va, n);
		s-&gt;user[n] = '\0';
		fss-&gt;phase = SNeedResp;
		return RpcOk;

	case SNeedResp:
		switch(s-&gt;astype){
		default:
			return failure(fss, "chap internal botch");
		case AuthChap:
			if(n != sizeof(Chapreply))
				return failure(fss, "did not get Chapreply");
			memmove(&amp;cr, va, sizeof cr);
			ocr.id = cr.id;
			memmove(ocr.resp, cr.resp, sizeof ocr.resp);
			memset(omcr.uid, 0, sizeof(omcr.uid));
			strecpy(ocr.uid, ocr.uid+sizeof ocr.uid, s-&gt;user);
			reply = &amp;ocr;
			nreply = sizeof ocr;
			break;
		case AuthMSchap:
			if(n != sizeof(MSchapreply))
				return failure(fss, "did not get MSchapreply");
			memmove(&amp;mcr, va, sizeof mcr);
			memmove(omcr.LMresp, mcr.LMresp, sizeof omcr.LMresp);
			memmove(omcr.NTresp, mcr.NTresp, sizeof omcr.NTresp);
			memset(omcr.uid, 0, sizeof(omcr.uid));
			strecpy(omcr.uid, omcr.uid+sizeof omcr.uid, s-&gt;user);
			reply = &amp;omcr;
			nreply = sizeof omcr;
			break;
		}
		if(doreply(s, reply, nreply) &lt; 0)
			return failure(fss, nil);
		fss-&gt;phase = Established;
		fss-&gt;ai.cuid = s-&gt;t.cuid;
		fss-&gt;ai.suid = s-&gt;t.suid;
		fss-&gt;ai.secret = s-&gt;secret;
		fss-&gt;ai.nsecret = s-&gt;nsecret;
		fss-&gt;haveai = 1;
		return RpcOk;
	}
}

static int
chapread(Fsstate *fss, void *va, uint *n)
{
	State *s;

	s = fss-&gt;ps;
	switch(fss-&gt;phase){
	default:
		return phaseerror(fss, "read");

	case CHaveResp:
		switch(s-&gt;astype){
		default:
			phaseerror(fss, "write");
			break;
		case AuthMSchap:
			if(*n &gt; sizeof(MSchapreply))
				*n = sizeof(MSchapreply);
			memmove(va, &amp;s-&gt;mcr, *n);
			break;
		case AuthChap:
			if(*n &gt; ChapResplen)
				*n = ChapResplen;
			memmove(va, s-&gt;cr, ChapResplen);
			break;
		}
		fss-&gt;phase = Established;
		fss-&gt;haveai = 0;
		return RpcOk;

	case SHaveChal:
		if(*n &gt; sizeof s-&gt;chal)
			*n = sizeof s-&gt;chal;
		memmove(va, s-&gt;chal, *n);
		fss-&gt;phase = SNeedUser;
		return RpcOk;
	}
}

static int
dochal(State *s)
{
	char *dom, *user;
	char trbuf[TICKREQLEN];

	s-&gt;asfd = -1;

	/* send request to authentication server and get challenge */
	if((dom = _strfindattr(s-&gt;key-&gt;attr, "dom")) == nil
	|| (user = _strfindattr(s-&gt;key-&gt;attr, "user")) == nil){
		werrstr("chap/dochal cannot happen");
		goto err;
	}
	s-&gt;asfd = _authdial(nil, dom);
	if(s-&gt;asfd &lt; 0)
		goto err;
	
	memset(&amp;s-&gt;tr, 0, sizeof(s-&gt;tr));
	s-&gt;tr.type = s-&gt;astype;
	safecpy(s-&gt;tr.authdom, dom, sizeof s-&gt;tr.authdom);
	safecpy(s-&gt;tr.hostid, user, sizeof(s-&gt;tr.hostid));
	convTR2M(&amp;s-&gt;tr, trbuf);

	if(write(s-&gt;asfd, trbuf, TICKREQLEN) != TICKREQLEN)
		goto err;

	/* readn, not _asrdresp.  needs to match auth.srv.c. */
	if(readn(s-&gt;asfd, s-&gt;chal, sizeof s-&gt;chal) != sizeof s-&gt;chal)
		goto err;
	return 0;

err:
	if(s-&gt;asfd &gt;= 0)
		close(s-&gt;asfd);
	s-&gt;asfd = -1;
	return -1;
}

static int
doreply(State *s, void *reply, int nreply)
{
	char ticket[TICKETLEN+AUTHENTLEN];
	int n;
	Authenticator a;

	if((n=write(s-&gt;asfd, reply, nreply)) != nreply){
		if(n &gt;= 0)
			werrstr("short write to auth server");
		goto err;
	}

	if(_asrdresp(s-&gt;asfd, ticket, TICKETLEN+AUTHENTLEN) &lt; 0){
		/* leave connection open so we can try again */
		return -1;
	}
	s-&gt;nsecret = readn(s-&gt;asfd, s-&gt;secret, sizeof s-&gt;secret);
	if(s-&gt;nsecret &lt; 0)
		s-&gt;nsecret = 0;
	close(s-&gt;asfd);
	s-&gt;asfd = -1;
	convM2T(ticket, &amp;s-&gt;t, s-&gt;key-&gt;priv);
	if(s-&gt;t.num != AuthTs
	|| memcmp(s-&gt;t.chal, s-&gt;tr.chal, sizeof(s-&gt;t.chal)) != 0){
		if(s-&gt;key-&gt;successes == 0)
			disablekey(s-&gt;key);
		werrstr(Easproto);
		return -1;
	}
	s-&gt;key-&gt;successes++;
	convM2A(ticket+TICKETLEN, &amp;a, s-&gt;t.key);
	if(a.num != AuthAc
	|| memcmp(a.chal, s-&gt;tr.chal, sizeof(a.chal)) != 0
	|| a.id != 0){
		werrstr(Easproto);
		return -1;
	}

	return 0;
err:
	if(s-&gt;asfd &gt;= 0)
		close(s-&gt;asfd);
	s-&gt;asfd = -1;
	return -1;
}

Proto chap = {
.name=	"chap",
.init=	chapinit,
.write=	chapwrite,
.read=	chapread,
.close=	chapclose,
.addkey= replacekey,
.keyprompt= "!password?"
};

Proto mschap = {
.name=	"mschap",
.init=	chapinit,
.write=	chapwrite,
.read=	chapread,
.close=	chapclose,
.addkey= replacekey,
.keyprompt= "!password?"
};

static void
hash(uchar pass[16], uchar c8[ChapChallen], uchar p24[MSchapResplen])
{
	int i;
	uchar p21[21];
	ulong schedule[32];

	memset(p21, 0, sizeof p21 );
	memmove(p21, pass, 16);

	for(i=0; i&lt;3; i++) {
		key_setup(p21+i*7, schedule);
		memmove(p24+i*8, c8, 8);
		block_cipher(schedule, p24+i*8, 0);
	}
}

static void
doNTchap(char *pass, uchar chal[ChapChallen], uchar reply[MSchapResplen])
{
	Rune r;
	int i, n;
	uchar digest[MD4dlen];
	uchar *w, unipass[256];

	// Standard says unlimited length, experience says 128 max
	if ((n = strlen(pass)) &gt; 128)
		n = 128;

	for(i=0, w=unipass; i &lt; n; i++) {
		pass += chartorune(&amp;r, pass);
		*w++ = r &amp; 0xff;
		*w++ = r &gt;&gt; 8;
	}

	memset(digest, 0, sizeof digest);
	md4(unipass, w-unipass, digest, nil);
	memset(unipass, 0, sizeof unipass);
	hash(digest, chal, reply);
}

static void
doLMchap(char *pass, uchar chal[ChapChallen], uchar reply[MSchapResplen])
{
	int i;
	ulong schedule[32];
	uchar p14[15], p16[16];
	uchar s8[8] = {0x4b, 0x47, 0x53, 0x21, 0x40, 0x23, 0x24, 0x25};
	int n = strlen(pass);

	if(n &gt; 14){
		// let prudent people avoid the LM vulnerability
		//   and protect the loop below from buffer overflow
		memset(reply, 0, MSchapResplen);
		return;
	}

	// Spec says space padded, experience says otherwise
	memset(p14, 0, sizeof p14 -1);
	p14[sizeof p14 - 1] = '\0';

	// NT4 requires uppercase, Win XP doesn't care
	for (i = 0; pass[i]; i++)
		p14[i] = islower(pass[i])? toupper(pass[i]): pass[i];

	for(i=0; i&lt;2; i++) {
		key_setup(p14+i*7, schedule);
		memmove(p16+i*8, s8, 8);
		block_cipher(schedule, p16+i*8, 0);
	}

	memset(p14, 0, sizeof p14);
	hash(p16, chal, reply);
}

static void
dochap(char *pass, int id, char chal[ChapChallen], uchar resp[ChapResplen])
{
	char buf[1+ChapChallen+MAXNAMELEN+1];
	int n = strlen(pass);

	*buf = id;
	if (n &gt; MAXNAMELEN)
		n = MAXNAMELEN-1;
	memset(buf, 0, sizeof buf);
	strncpy(buf+1, pass, n);
	memmove(buf+1+n, chal, ChapChallen);
	md5((uchar*)buf, 1+n+ChapChallen, resp, nil);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

