<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/accupoint.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/accupoint.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

/*
 * Convert AccuPoint buttons 4 and 5 to a simulation of button 2.
 * The buttons generate down events, repeat, and have no up events,
 * so it's a struggle. This program turns the left button into a near-as-
 * possible simulation of a regular button 2, but it can only sense up
 * events by timeout, so it's sluggish.  Thus it also turns the right button
 * into a click on button 2, useful for acme and chords.
 */

typedef struct M M;

struct M
{
	Mouse;
	int	byte;
};

int	button2;
int	interrupted;

int
readmouse(M *m)
{
	char buf[1+4*12];
	int n;

	n = read(0, buf, sizeof buf);
	if(n &lt; 0)
		return n;
	if(n != sizeof buf)
		return 0;
	m-&gt;byte = buf[0];
	m-&gt;xy.x =  atoi(buf+1+0*12);
	m-&gt;xy.y =  atoi(buf+1+1*12);
	m-&gt;buttons =  atoi(buf+1+2*12);
	m-&gt;msec =  atoi(buf+1+3*12);
	return 1;
}

void
writemouse(M *m)
{
	print("%c%11d %11d %11d %11ld ",
		m-&gt;byte,
		m-&gt;xy.x,
		m-&gt;xy.y,
		m-&gt;buttons&amp;7,
		m-&gt;msec);
}

void
notifyf(void*, char *s)
{
	if(strcmp(s, "alarm") == 0)
		interrupted = 1;
	noted(NCONT);
}

void
main(void)
{
	M m, om;
	int n;

	notify(notifyf);
	memset(&amp;m, 0, sizeof m);
	om = m;
	for(;;){
		interrupted = 0;
		/* first click waits 500ms before repeating; after that they're 150, but that's ok */
		if(button2)
			alarm(550);
		n = readmouse(&amp;m);
		if(button2)
			alarm(0);
		if(interrupted){
			/* timed out; clear button 2 */
			om.buttons &amp;= ~2;
			button2 = 0;
			writemouse(&amp;om);
			continue;
		}
		if(n &lt;= 0)
			break;
		/* avoid bounce caused by button 5 click */
		if((om.buttons&amp;16) &amp;&amp; (m.buttons&amp;16)){
			om.buttons &amp;= ~16;
			continue;
		}
		if(m.buttons &amp; 2)
			button2 = 0;
		else{
			/* only check 4 and 5 if 2 isn't down of its own accord */
			if(m.buttons &amp; 16){
				/* generate quick button 2 click */
				button2 = 0;
				m.buttons |= 2;
				writemouse(&amp;m);
				m.buttons &amp;= ~2;
				/* fall through to generate up event */
			}else if(m.buttons &amp; 8){
				/* press and hold button 2 */
				button2 = 1;
			}
		}
		if(button2)
			m.buttons |= 2;
		if(m.byte!=om.byte || m.buttons!=om.buttons || !eqpt(m.xy, om.xy))
			writemouse(&amp;m);
		om = m;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

