<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/dib2eps.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/dib2eps.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * dib2eps.c
 * Copyright (C) 2000-2003 A.J. van Os; Released under GPL
 *
 * Description:
 * Functions to translate dib pictures into eps
 *
 *================================================================
 * This part of the software is based on:
 * The Windows Bitmap Decoder Class part of paintlib
 * Paintlib is copyright (c) 1996-2000 Ulrich von Zadow
 *================================================================
 * The credit should go to him, but all the bugs are mine.
 */

#include &lt;stdio.h&gt;
#include "antiword.h"


/*
 * vDecode1bpp - decode an uncompressed 1 bit per pixel image
 */
static void
vDecode1bpp(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	size_t	tPadding;
	int	iX, iY, iN, iByte, iTmp, iEighthWidth, iUse;

	DBG_MSG("vDecode1bpp");

	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(pImg-&gt;iColorsUsed &lt; 1 || pImg-&gt;iColorsUsed &gt; 2);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	iEighthWidth = (pImg-&gt;iWidth + 7) / 8;
	tPadding = (size_t)(ROUND4(iEighthWidth) - iEighthWidth);

	for (iY = 0; iY &lt; pImg-&gt;iHeight; iY++) {
		for (iX = 0; iX &lt; iEighthWidth; iX++) {
			iByte = iNextByte(pInFile);
			if (iByte == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iX == iEighthWidth - 1 &amp;&amp; pImg-&gt;iWidth % 8 != 0) {
				iUse = pImg-&gt;iWidth % 8;
			} else {
				iUse = 8;
			}
			for (iN = 0; iN &lt; iUse; iN++) {
				switch (iN) {
				case 0: iTmp = (iByte &amp; 0x80) / 128; break;
				case 1: iTmp = (iByte &amp; 0x40) / 64; break;
				case 2: iTmp = (iByte &amp; 0x20) / 32; break;
				case 3: iTmp = (iByte &amp; 0x10) / 16; break;
				case 4: iTmp = (iByte &amp; 0x08) / 8; break;
				case 5: iTmp = (iByte &amp; 0x04) / 4; break;
				case 6: iTmp = (iByte &amp; 0x02) / 2; break;
				case 7: iTmp = (iByte &amp; 0x01); break;
				default: iTmp = 0; break;
				}
				vASCII85EncodeByte(pOutFile, iTmp);
			}
		}
		(void)tSkipBytes(pInFile, tPadding);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecode1bpp */

/*
 * vDecode4bpp - decode an uncompressed 4 bits per pixel image
 */
static void
vDecode4bpp(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	size_t	tPadding;
	int	iX, iY, iN, iByte, iTmp, iHalfWidth, iUse;

	DBG_MSG("vDecode4bpp");

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(pImg-&gt;iColorsUsed &lt; 1 || pImg-&gt;iColorsUsed &gt; 16);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	iHalfWidth = (pImg-&gt;iWidth + 1) / 2;
	tPadding = (size_t)(ROUND4(iHalfWidth) - iHalfWidth);

	for (iY = 0; iY &lt; pImg-&gt;iHeight; iY++) {
		for (iX = 0; iX &lt; iHalfWidth; iX++) {
			iByte = iNextByte(pInFile);
			if (iByte == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iX == iHalfWidth - 1 &amp;&amp; odd(pImg-&gt;iWidth)) {
				iUse = 1;
			} else {
				iUse = 2;
			}
			for (iN = 0; iN &lt; iUse; iN++) {
				if (odd(iN)) {
					iTmp = iByte &amp; 0x0f;
				} else {
					iTmp = (iByte &amp; 0xf0) / 16;
				}
				vASCII85EncodeByte(pOutFile, iTmp);
			}
		}
		(void)tSkipBytes(pInFile, tPadding);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecode4bpp */

/*
 * vDecode8bpp - decode an uncompressed 8 bits per pixel image
 */
static void
vDecode8bpp(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	size_t	tPadding;
	int	iX, iY, iByte;

	DBG_MSG("vDecode8bpp");

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(pImg-&gt;iColorsUsed &lt; 1 || pImg-&gt;iColorsUsed &gt; 256);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	tPadding = (size_t)(ROUND4(pImg-&gt;iWidth) - pImg-&gt;iWidth);

	for (iY = 0; iY &lt; pImg-&gt;iHeight; iY++) {
		for (iX = 0; iX &lt; pImg-&gt;iWidth; iX++) {
			iByte = iNextByte(pInFile);
			if (iByte == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			vASCII85EncodeByte(pOutFile, iByte);
		}
		(void)tSkipBytes(pInFile, tPadding);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecode8bpp */

/*
 * vDecode24bpp - decode an uncompressed 24 bits per pixel image
 */
static void
vDecode24bpp(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	size_t	tPadding;
	int	iX, iY, iBlue, iGreen, iRed, iTripleWidth;

	DBG_MSG("vDecode24bpp");

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(!pImg-&gt;bColorImage);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	iTripleWidth = pImg-&gt;iWidth * 3;
	tPadding = (size_t)(ROUND4(iTripleWidth) - iTripleWidth);

	for (iY = 0; iY &lt; pImg-&gt;iHeight; iY++) {
		for (iX = 0; iX &lt; pImg-&gt;iWidth; iX++) {
			/* Change from BGR order to RGB order */
			iBlue = iNextByte(pInFile);
			if (iBlue == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			iGreen = iNextByte(pInFile);
			if (iGreen == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			iRed = iNextByte(pInFile);
			if (iRed == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			vASCII85EncodeByte(pOutFile, iRed);
			vASCII85EncodeByte(pOutFile, iGreen);
			vASCII85EncodeByte(pOutFile, iBlue);
		}
		(void)tSkipBytes(pInFile, tPadding);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecode24bpp */

/*
 * vDecodeRle4 - decode a RLE compressed 4 bits per pixel image
 */
static void
vDecodeRle4(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	int	iX, iY, iByte, iTmp, iRunLength, iRun;
	BOOL	bEOF, bEOL;

	DBG_MSG("vDecodeRle4");

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(pImg-&gt;iColorsUsed &lt; 1 || pImg-&gt;iColorsUsed &gt; 16);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	bEOF = FALSE;

	for (iY =  0; iY &lt; pImg-&gt;iHeight &amp;&amp; !bEOF; iY++) {
		bEOL = FALSE;
		iX = 0;
		while (!bEOL) {
			iRunLength = iNextByte(pInFile);
			if (iRunLength == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iRunLength != 0) {
				/*
				 * Encoded packet:
				 * RunLength pixels, all the "same" value
				 */
				iByte = iNextByte(pInFile);
				if (iByte == EOF) {
					vASCII85EncodeByte(pOutFile, EOF);
					return;
				}
				for (iRun = 0; iRun &lt; iRunLength; iRun++) {
					if (odd(iRun)) {
						iTmp = iByte &amp; 0x0f;
					} else {
						iTmp = (iByte &amp; 0xf0) / 16;
					}
					if (iX &lt; pImg-&gt;iWidth) {
						vASCII85EncodeByte(pOutFile, iTmp);
					}
					iX++;
				}
				continue;
			}
			/* Literal or escape */
			iRunLength = iNextByte(pInFile);
			if (iRunLength == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iRunLength == 0) {		/* End of line escape */
				bEOL = TRUE;
			} else if (iRunLength == 1) {	/* End of file escape */
				bEOF = TRUE;
				bEOL = TRUE;
			} else if (iRunLength == 2) {	/* Delta escape */
				DBG_MSG("RLE4: encountered delta escape");
				bEOF = TRUE;
				bEOL = TRUE;
			} else {			/* Literal packet */
				iByte = 0;
				for (iRun = 0; iRun &lt; iRunLength; iRun++) {
					if (odd(iRun)) {
						iTmp = iByte &amp; 0x0f;
					} else {
						iByte = iNextByte(pInFile);
						if (iByte == EOF) {
							vASCII85EncodeByte(pOutFile, EOF);
							return;
						}
						iTmp = (iByte &amp; 0xf0) / 16;
					}
					if (iX &lt; pImg-&gt;iWidth) {
						vASCII85EncodeByte(pOutFile, iTmp);
					}
					iX++;
				}
				/* Padding if the number of bytes is odd */
				if (odd((iRunLength + 1) / 2)) {
					(void)tSkipBytes(pInFile, 1);
				}
			}
		}
		DBG_DEC_C(iX != pImg-&gt;iWidth, iX);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecodeRle4 */

/*
 * vDecodeRle8 - decode a RLE compressed 8 bits per pixel image
 */
static void
vDecodeRle8(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	int	iX, iY, iByte, iRunLength, iRun;
	BOOL	bEOF, bEOL;

	DBG_MSG("vDecodeRle8");

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);
	fail(pImg-&gt;iColorsUsed &lt; 1 || pImg-&gt;iColorsUsed &gt; 256);

	DBG_DEC(pImg-&gt;iWidth);
	DBG_DEC(pImg-&gt;iHeight);

	bEOF = FALSE;

	for (iY = 0; iY &lt; pImg-&gt;iHeight &amp;&amp; !bEOF; iY++) {
		bEOL = FALSE;
		iX = 0;
		while (!bEOL) {
			iRunLength = iNextByte(pInFile);
			if (iRunLength == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iRunLength != 0) {
				/*
				 * Encoded packet:
				 * RunLength pixels, all the same value
				 */
				iByte = iNextByte(pInFile);
				if (iByte == EOF) {
					vASCII85EncodeByte(pOutFile, EOF);
					return;
				}
				for (iRun = 0; iRun &lt; iRunLength; iRun++) {
					if (iX &lt; pImg-&gt;iWidth) {
						vASCII85EncodeByte(pOutFile, iByte);
					}
					iX++;
				}
				continue;
			}
			/* Literal or escape */
			iRunLength = iNextByte(pInFile);
			if (iRunLength == EOF) {
				vASCII85EncodeByte(pOutFile, EOF);
				return;
			}
			if (iRunLength == 0) {		/* End of line escape */
				bEOL = TRUE;
			} else if (iRunLength == 1) {	/* End of file escape */
				bEOF = TRUE;
				bEOL = TRUE;
			} else if (iRunLength == 2) {	/* Delta escape */
				DBG_MSG("RLE8: encountered delta escape");
				bEOF = TRUE;
				bEOL = TRUE;
			} else {			/* Literal packet */
				for (iRun = 0; iRun &lt; iRunLength; iRun++) {
					iByte = iNextByte(pInFile);
					if (iByte == EOF) {
						vASCII85EncodeByte(pOutFile, EOF);
						return;
					}
					if (iX &lt; pImg-&gt;iWidth) {
						vASCII85EncodeByte(pOutFile, iByte);
					}
					iX++;
				}
				/* Padding if the number of bytes is odd */
				if (odd(iRunLength)) {
					(void)tSkipBytes(pInFile, 1);
				}
			}
		}
		DBG_DEC_C(iX != pImg-&gt;iWidth, iX);
	}
	vASCII85EncodeByte(pOutFile, EOF);
} /* end of vDecodeRle8 */

/*
 * vDecodeDIB - decode a dib picture
 */
static void
vDecodeDIB(FILE *pInFile, FILE *pOutFile, const imagedata_type *pImg)
{
	size_t	tHeaderSize;

	fail(pInFile == NULL);
	fail(pOutFile == NULL);
	fail(pImg == NULL);

	/* Skip the bitmap info header */
	tHeaderSize = (size_t)ulNextLong(pInFile);
	(void)tSkipBytes(pInFile, tHeaderSize - 4);
	/* Skip the colortable */
	if (pImg-&gt;uiBitsPerComponent &lt;= 8) {
		(void)tSkipBytes(pInFile,
			(size_t)(pImg-&gt;iColorsUsed *
			 ((tHeaderSize &gt; 12) ? 4 : 3)));
	}

	switch (pImg-&gt;uiBitsPerComponent) {
	case 1:
		fail(pImg-&gt;eCompression != compression_none);
		vDecode1bpp(pInFile, pOutFile, pImg);
		break;
	case 4:
		fail(pImg-&gt;eCompression != compression_none &amp;&amp;
				pImg-&gt;eCompression != compression_rle4);
		if (pImg-&gt;eCompression == compression_rle4) {
			vDecodeRle4(pInFile, pOutFile, pImg);
		} else {
			vDecode4bpp(pInFile, pOutFile, pImg);
		}
		break;
	case 8:
		fail(pImg-&gt;eCompression != compression_none &amp;&amp;
				pImg-&gt;eCompression != compression_rle8);
		if (pImg-&gt;eCompression == compression_rle8) {
			vDecodeRle8(pInFile, pOutFile, pImg);
		} else {
			vDecode8bpp(pInFile, pOutFile, pImg);
		}
		break;
	case 24:
		fail(pImg-&gt;eCompression != compression_none);
		vDecode24bpp(pInFile, pOutFile, pImg);
		break;
	default:
		DBG_DEC(pImg-&gt;uiBitsPerComponent);
		break;
	}
} /* end of vDecodeDIB */

#if defined(DEBUG)
/*
 * vCopy2File
 */
static void
vCopy2File(FILE *pInFile, ULONG ulFileOffset, size_t tPictureLen)
{
	static int	iPicCounter = 0;
	FILE	*pOutFile;
	size_t	tIndex;
	int	iTmp;
	char	szFilename[30];

	if (!bSetDataOffset(pInFile, ulFileOffset)) {
		return;
	}

	sprintf(szFilename, "/tmp/pic/pic%04d.bmp", ++iPicCounter);
	pOutFile = fopen(szFilename, "wb");
	if (pOutFile == NULL) {
		return;
	}
	/* Turn a dib into a bmp by adding a fake 14 byte header */
	(void)putc('B', pOutFile);
	(void)putc('M', pOutFile);
	for (iTmp = 0; iTmp &lt; 12; iTmp++) {
		if (putc(0, pOutFile) == EOF) {
			break;
		}
	}
	for (tIndex = 0; tIndex &lt; tPictureLen; tIndex++) {
		iTmp = iNextByte(pInFile);
		if (putc(iTmp, pOutFile) == EOF) {
			break;
		}
	}
	(void)fclose(pOutFile);
} /* end of vCopy2File */
#endif /* DEBUG */

/*
 * bTranslateDIB - translate a DIB picture
 *
 * This function translates a picture from dib to eps
 *
 * return TRUE when sucessful, otherwise FALSE
 */
BOOL
bTranslateDIB(diagram_type *pDiag, FILE *pInFile,
		ULONG ulFileOffset, const imagedata_type *pImg)
{
#if defined(DEBUG)
	fail(pImg-&gt;tPosition &gt; pImg-&gt;tLength);
	vCopy2File(pInFile, ulFileOffset, pImg-&gt;tLength - pImg-&gt;tPosition);
#endif /* DEBUG */

	/* Seek to start position of DIB data */
	if (!bSetDataOffset(pInFile, ulFileOffset)) {
		return FALSE;
	}

	vImagePrologue(pDiag, pImg);
	vDecodeDIB(pInFile, pDiag-&gt;pOutFile, pImg);
	vImageEpilogue(pDiag);

	return TRUE;
} /* end of bTranslateDIB */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

