<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/drawfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/drawfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * drawfile.c
 * Copyright (C) 2005 A.J. van Os; Released under GPL
 *
 * Description:
 * Functions to process with the Draw diagram
 */

#include &lt;string.h&gt;
#include "DeskLib:Error.h"
#include "DeskLib:SWI.h"
#include "drawfile.h"
#include "antiword.h"

#define DRAWFILE_OBJECT_TOO_SMALL	200
#define DRAWFILE_NO_TEXT		201
#define DRAWFILE_BAD_CHARACTER		202
#define DRAWFILE_SMALL_MEMORY		203
#define DRAWFILE_PATH_WITHOUT_LINES	204
#define DRAWFILE_BAD_PATH_TYPE		205
#define DRAWFILE_PATH_WITHOUT_END	206
#define DRAWFILE_BAD_SPRITE_SIZE	207
#define DRAWFILE_BAD_JPEG_SIZE		208
#define DRAWFILE_TOO_SMALL		209
#define DRAWFILE_NOT_A_DRAWFILE		210
#define DRAWFILE_OBJECT_SIZE		211
#define DRAWFILE_MANY_FONTTABLES	212
#define DRAWFILE_TEXT_NO_FONT		213
#define DRAWFILE_OBJECT_UNEXPECTED	214
#define DRAWFILE_SIZE_ERROR		215

typedef struct drawfile_error_tag {
	int		iErrorNumber;
	const char	*szErrorText;
} drawfile_error_type;

static const drawfile_error_type atErrors[] = {
	{ DRAWFILE_OBJECT_TOO_SMALL, "Object too small"},
	{ DRAWFILE_NO_TEXT, "Text object without text"},
	{ DRAWFILE_BAD_CHARACTER, "Bad character in string"},
	{ DRAWFILE_SMALL_MEMORY, "Not enough memory reserved"},
	{ DRAWFILE_PATH_WITHOUT_LINES, "This path has no lines"},
	{ DRAWFILE_BAD_PATH_TYPE, "Bad path-type in path"},
	{ DRAWFILE_PATH_WITHOUT_END, "No end of path seen"},
	{ DRAWFILE_BAD_SPRITE_SIZE, "Bad sprite size"},
	{ DRAWFILE_BAD_JPEG_SIZE, "Bad jpeg size"},
	{ DRAWFILE_TOO_SMALL, "Too small to be a drawfile"},
	{ DRAWFILE_NOT_A_DRAWFILE, "Not a drawfile"},
	{ DRAWFILE_OBJECT_SIZE, "Object with incorrect size"},
	{ DRAWFILE_MANY_FONTTABLES, "More than one font table"},
	{ DRAWFILE_TEXT_NO_FONT, "Text, but no font table seen"},
	{ DRAWFILE_OBJECT_UNEXPECTED, "Unexpected object type"},
	{ DRAWFILE_SIZE_ERROR, "Sizes don't match"},
};


/*
 * pFillError - error number to error struct
 */
static os_error *
pFillError(int iErrorNumber)
{
	static os_error		tError;
	const drawfile_error_type	*pTmp;
	const char	*szErrorText;

	szErrorText = "Unknown error";
	for (pTmp = atErrors; pTmp &lt; atErrors + elementsof(atErrors); pTmp++) {
		if (iErrorNumber == pTmp-&gt;iErrorNumber) {
			szErrorText = pTmp-&gt;szErrorText;
			break;
		}
	}
	tError.errnum = iErrorNumber;
	strncpy(tError.errmess, szErrorText, sizeof(tError.errmess) - 1);
	tError.errmess[sizeof(tError.errmess) - 1] = '\0';
	DBG_DEC(tError.errnum);
	DBG_MSG(tError.errmess);
	return &amp;tError;
} /* end of pFillError */

/*
 * Drawfile_BBox - Find the bounding box of a diagram
 */
os_error *
Drawfile_Bbox(drawfile_bbox_flags flags,
	drawfile_diagram const *diagram,
	int size,
	os_trfm const *trfm,
	wimp_box *bbox)
{
	return SWI(5, 0, DrawFile_BBox | XOS_Bit,
		flags, diagram, size, trfm, bbox);
} /* end of Drawfile_Bbox */

/*
 * Drawfile_CreateDiagram - create an empty drawfile diagram
 */
os_error *
Drawfile_CreateDiagram(drawfile_info *pInfo, size_t tMemorySize,
	const char *szCreator, wimp_box tBbox)
{
	drawfile_diagram	*pDiag;

	if (tMemorySize &lt; offsetof(drawfile_diagram, objects)) {
		return pFillError(DRAWFILE_SMALL_MEMORY);
	}
	pDiag = (drawfile_diagram *)pInfo-&gt;data;
	strncpy(pDiag-&gt;tag, "Draw", 4);
	pDiag-&gt;major_version = 201;
	pDiag-&gt;minor_version = 0;
	strncpy(pDiag-&gt;source, szCreator, sizeof(pDiag-&gt;source));
	pDiag-&gt;bbox = tBbox;
	/* Memory in use */
	pInfo-&gt;length = offsetof(drawfile_diagram, objects);
	return NULL;
} /* end of Drawfile_CreateDiagram */

/*
 * Drawfile_AppendObject - append an object to a diagram
 */
os_error *
Drawfile_AppendObject(drawfile_info *pInfo, size_t tMemorySize,
	const drawfile_object *pObject, BOOL bRebind)
{
	wimp_box	*pMainBbox;
	const wimp_box	*pBbox;
	byte		*pAfter;

	if (tMemorySize &lt; pInfo-&gt;length + pObject-&gt;size) {
		return pFillError(DRAWFILE_OBJECT_TOO_SMALL);
	}
	/* After the last object */
	pAfter = (byte *)pInfo-&gt;data + pInfo-&gt;length;
	/* Copy in the new data */
	memcpy(pAfter, pObject, pObject-&gt;size);
	/* Rebind if needed */
	if (bRebind) {
		pMainBbox = &amp;((drawfile_diagram *)pInfo-&gt;data)-&gt;bbox;
		switch (pObject-&gt;type) {
		case drawfile_TYPE_FONT_TABLE:
			pBbox = NULL;
			break;
		case drawfile_TYPE_TEXT:
			pBbox = &amp;pObject-&gt;data.text.bbox;
			break;
		case drawfile_TYPE_PATH:
			pBbox = &amp;pObject-&gt;data.path.bbox;
			break;
		case drawfile_TYPE_SPRITE:
			pBbox = &amp;pObject-&gt;data.sprite.bbox;
			break;
		case drawfile_TYPE_GROUP:
			pBbox = &amp;pObject-&gt;data.group.bbox;
			break;
		case drawfile_TYPE_TAGGED:
			pBbox = &amp;pObject-&gt;data.tagged.bbox;
			break;
		case drawfile_TYPE_TEXT_AREA:
			pBbox = &amp;pObject-&gt;data.text_area.bbox;
			break;
		case drawfile_TYPE_TEXT_COLUMN:
			pBbox = NULL;
			break;
		case drawfile_TYPE_OPTIONS:
			pBbox = &amp;pObject-&gt;data.options.bbox;
			break;
		case drawfile_TYPE_TRFM_TEXT:
			pBbox = &amp;pObject-&gt;data.trfm_text.bbox;
			break;
		case drawfile_TYPE_TRFM_SPRITE:
			pBbox = &amp;pObject-&gt;data.trfm_sprite.bbox;
			break;
		case drawfile_TYPE_JPEG:
			pBbox = &amp;pObject-&gt;data.jpeg.bbox;
			break;
		default:
			pBbox = NULL;
			break;
		}
		if (pBbox != NULL) {
			if (pBbox-&gt;min.x &lt; pMainBbox-&gt;min.x) {
				pMainBbox-&gt;min.x = pBbox-&gt;min.x;
			}
			if (pBbox-&gt;min.y &lt; pMainBbox-&gt;min.y) {
				pMainBbox-&gt;min.y = pBbox-&gt;min.y;
			}
			if (pBbox-&gt;max.x &gt; pMainBbox-&gt;max.x) {
				pMainBbox-&gt;max.x = pBbox-&gt;max.x;
			}
			if (pBbox-&gt;max.y &gt; pMainBbox-&gt;max.y) {
				pMainBbox-&gt;max.y = pBbox-&gt;max.y;
			}
		}
	}
	/* Memory in use */
	pInfo-&gt;length += pObject-&gt;size;
	return NULL;
} /* end of Drawfile_AppendObject */

/*
 * Replaces the draw_render_diag function from RISC_OSLib
 */
os_error *
Drawfile_RenderDiagram(drawfile_info *pInfo, window_redrawblock *pRedraw,
	double dScale)
{
	int	aiTransform[6];

	fail(pInfo == NULL);
	fail(pInfo-&gt;data == NULL);
	fail(pRedraw == NULL);
	fail(dScale &lt; 0.01);

	aiTransform[0] = (int)(dScale * 0x10000);
	aiTransform[1] = 0;
	aiTransform[2] = 0;
	aiTransform[3] = (int)(dScale * 0x10000);
	aiTransform[4] = (pRedraw-&gt;rect.min.x - pRedraw-&gt;scroll.x) * 256;
	aiTransform[5] = (pRedraw-&gt;rect.max.y - pRedraw-&gt;scroll.y) * 256;

	return SWI(6, 0, DrawFile_Render | XOS_Bit,
		0, pInfo-&gt;data, pInfo-&gt;length, aiTransform, &amp;pRedraw-&gt;rect, 0);
} /* end of Drawfile_RenderDiagram */

/*
 * pVerifyText - verify a text object
 */
static os_error *
pVerifyText(const drawfile_text *pText)
{
	const unsigned char	*pucTmp;

	if (pText-&gt;text[0] == '\0') {
		return pFillError(DRAWFILE_NO_TEXT);
	}
	pucTmp = (const unsigned char *)pText-&gt;text;
	while (*pucTmp != '\0') {
		if (*pucTmp &lt; 0x20 || *pucTmp == 0x7f) {
			return pFillError(DRAWFILE_BAD_CHARACTER);
		}
		pucTmp++;
	}
	return NULL;
} /* end of pVerifyText */

/*
 * pVerifyPath - verify a path object
 */
static os_error *
pVerifyPath(const drawfile_path *pPath, int iSize)
{
	const int	*piTmp;
	int	iElements;
	BOOL	bLine;

	bLine = FALSE;
	iElements = (iSize - offsetof(drawfile_path, path)) / 4;

	for (piTmp = pPath-&gt;path; piTmp &lt; pPath-&gt;path + iElements; piTmp++) {
		switch(*piTmp) {
		case drawfile_PATH_END_PATH:
			if (bLine) {
				return NULL;
			}
			return pFillError(DRAWFILE_PATH_WITHOUT_LINES);
		case drawfile_PATH_LINE_TO:
			bLine = TRUE;
			piTmp += 2;
			break;
		case drawfile_PATH_MOVE_TO:
			piTmp += 2;
			break;
		case drawfile_PATH_CLOSE_LINE:
			bLine = TRUE;
			break;
		default:
			return pFillError(DRAWFILE_BAD_PATH_TYPE);
		}
	}
	return pFillError(DRAWFILE_PATH_WITHOUT_END);
} /* end of pVerifyPath */

/*
 * pVerifySprite - verify a sprite object
 */
static os_error *
pVerifySprite(const drawfile_sprite *pSprite, int iSize)
{
	iSize -= offsetof(drawfile_sprite, header);
	if (iSize &lt; pSprite-&gt;header.offset_next) {
		DBG_DEC(iSize);
		DBG_DEC(pSprite-&gt;header.offset_next);
		return pFillError(DRAWFILE_BAD_SPRITE_SIZE);
	}
	return NULL;
} /* end of pVerifySprite */

/*
 * pVerifyJpeg - verify a jpeg object
 */
static os_error *
pVerifyJpeg(const drawfile_jpeg *pJpeg, int iSize)
{
	iSize -= offsetof(drawfile_jpeg, data);
	if (iSize &lt; pJpeg-&gt;len) {
		DBG_DEC(iSize);
		DBG_DEC(pJpeg-&gt;len);
		return pFillError(DRAWFILE_BAD_JPEG_SIZE);
	}
	return NULL;
} /* end of pVerifyJpeg */

/*
 * Drawfile_VerifyDiagram - Verify the diagram generated from the Word file
 *
 * returns NULL if the diagram is correct
 */
os_error *
Drawfile_VerifyDiagram(drawfile_info *pInfo)
{
	drawfile_diagram	*pDiag;
	drawfile_object	*pObj;
	os_error	*pError;
	const char	*pcTmp;
	int		iToGo, iFontTables;
	BOOL		bTypeFontTable;

	TRACE_MSG("Drawfile_VerifyDiagram");

	fail(pInfo == NULL);

  	if (pInfo-&gt;length &lt; offsetof(drawfile_diagram, objects)) {
		return pFillError(DRAWFILE_TOO_SMALL);
  	}

	pDiag = (drawfile_diagram *)pInfo-&gt;data;
	if (strncmp(pDiag-&gt;tag, "Draw", 4) != 0 ||
	    pDiag-&gt;major_version != 201 ||
	    pDiag-&gt;minor_version != 0) {
		return pFillError(DRAWFILE_NOT_A_DRAWFILE);
	}

	iToGo = pInfo-&gt;length - offsetof(drawfile_diagram, objects);
	pcTmp = (const char *)pInfo-&gt;data + offsetof(drawfile_diagram, objects);
	iFontTables = 0;
	bTypeFontTable = FALSE;

	while (iToGo &gt; 0) {
		pObj = (drawfile_object *)pcTmp;
		if (pObj-&gt;size &lt; 0 || pObj-&gt;size % 4 != 0) {
			return pFillError(DRAWFILE_OBJECT_SIZE);
		}
		switch (pObj-&gt;type) {
		case drawfile_TYPE_FONT_TABLE:
			if (bTypeFontTable) {
				return pFillError(DRAWFILE_MANY_FONTTABLES);
			}
			bTypeFontTable = TRUE;
			break;
		case drawfile_TYPE_TEXT:
			if (pObj-&gt;data.text.style.font_ref != 0 &amp;&amp;
			    !bTypeFontTable) {
				return pFillError(DRAWFILE_TEXT_NO_FONT);
			}
			pError = pVerifyText(&amp;pObj-&gt;data.text);
			if (pError != NULL) {
				return pError;
			}
			break;
		case drawfile_TYPE_PATH:
			pError = pVerifyPath(&amp;pObj-&gt;data.path,
				pObj-&gt;size - offsetof(drawfile_object, data));
			if (pError != NULL) {
				return pError;
			}
			break;
		case drawfile_TYPE_SPRITE:
			pError = pVerifySprite(&amp;pObj-&gt;data.sprite,
				pObj-&gt;size - offsetof(drawfile_object, data));
			if (pError != NULL) {
				return pError;
			}
			break;
		case drawfile_TYPE_JPEG:
			pError = pVerifyJpeg(&amp;pObj-&gt;data.jpeg,
				pObj-&gt;size - offsetof(drawfile_object, data));
			if (pError != NULL) {
				return pError;
			}
			break;
		default:
			DBG_DEC(pObj-&gt;type);
			return pFillError(DRAWFILE_OBJECT_UNEXPECTED);
		}
		pcTmp += pObj-&gt;size;
		iToGo -= pObj-&gt;size;
	}
	if (iToGo &lt; 0) {
		return pFillError(DRAWFILE_SIZE_ERROR);
	}
	return NULL;
} /* end of Drawfile_VerifyDiagram */

/*
 * Drawfile_QueryBox - Find the bounding box of a diagram
 */
void
Drawfile_QueryBox(drawfile_info *pInfo, wimp_box *pRect, BOOL bScreenUnits)
{
	fail(pInfo == NULL);
	fail(pRect == NULL);

	Error_CheckFatal(Drawfile_Bbox(0,
		pInfo-&gt;data, pInfo-&gt;length, NULL, pRect));
	if (bScreenUnits) {
		pRect-&gt;min.x = Drawfile_DrawToScreen(pRect-&gt;min.x);
		pRect-&gt;min.y = Drawfile_DrawToScreen(pRect-&gt;min.y);
		pRect-&gt;max.x = Drawfile_DrawToScreen(pRect-&gt;max.x);
		pRect-&gt;max.y = Drawfile_DrawToScreen(pRect-&gt;max.y);
	}
} /* end of Drawfile_QueryBox */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

