<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/fmt_text.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/fmt_text.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * fmt_text.c
 * Copyright (C) 2004 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Functions to deal with the Formatted Text format
 *
 * Based on patches send by: Ofir Reichenberg &lt;ofir@qlusters.com&gt;
 *
 * The credit should go to him, but all the bugs are mine.
 */

#include &lt;string.h&gt;
#include "antiword.h"

/* The character set */
static encoding_type	eEncoding = encoding_neutral;
/* Current vertical position information */
static long		lYtopCurr = 0;
/* Local representation of the non-breaking space */
static UCHAR		ucNbsp = 0;


/*
 * vPrologueFMT - set options and perform the Formatted Text initialization
 */
void
vPrologueFMT(diagram_type *pDiag, const options_type *pOptions)
{
	fail(pDiag == NULL);
	fail(pOptions == NULL);

	eEncoding = pOptions-&gt;eEncoding;
	pDiag-&gt;lXleft = 0;
	pDiag-&gt;lYtop = 0;
	lYtopCurr = 0;
} /* end of vPrologueFMT */

/*
 * vPrintFMT - print a Formatted Text string
 */
static void
vPrintFMT(FILE *pFile,
	const char *szString, size_t tStringLength, USHORT usFontstyle)
{
	const UCHAR	*pucByte, *pucStart, *pucLast, *pucNonSpace;

	fail(szString == NULL);

	if (szString == NULL || szString[0] == '\0' || tStringLength == 0) {
		return;
	}

	if (eEncoding == encoding_utf_8) {
		fprintf(pFile, "%.*s", (int)tStringLength, szString);
		return;
	}

	if (ucNbsp == 0) {
		ucNbsp = ucGetNbspCharacter();
		DBG_HEX_C(ucNbsp != 0xa0, ucNbsp);
	}

	pucStart = (UCHAR *)szString;
	pucLast = pucStart + tStringLength - 1;
	pucNonSpace = pucLast;
	while ((*pucNonSpace == (UCHAR)' ' || *pucNonSpace == ucNbsp) &amp;&amp;
	       pucNonSpace &gt; pucStart) {
		pucNonSpace--;
	}

	/* 1: The spaces at the start */
	pucByte = pucStart;
	while ((*pucByte == (UCHAR)' ' || *pucByte == ucNbsp) &amp;&amp;
	       pucByte &lt;= pucLast) {
		(void)putc(' ', pFile);
		pucByte++;
	}

	if (pucByte &gt; pucLast) {
		/* There is no text, just spaces */
		return;
	}

	/* 2: Start the *bold*, /italic/ and _underline_ */
	if (bIsBold(usFontstyle)) {
		(void)putc('*', pFile);
	}
	if (bIsItalic(usFontstyle)) {
		(void)putc('/', pFile);
	}
	if (bIsUnderline(usFontstyle)) {
		(void)putc('_', pFile);
	}

	/* 3: The text itself */
	while (pucByte &lt;= pucNonSpace) {
		if (*pucByte == ucNbsp) {
			(void)putc(' ', pFile);
		} else {
			(void)putc((char)*pucByte, pFile);
		}
		pucByte++;
	}

	/* 4: End the *bold*, /italic/ and _underline_ */
	if (bIsUnderline(usFontstyle)) {
		(void)putc('_', pFile);
	}
	if (bIsItalic(usFontstyle)) {
		(void)putc('/', pFile);
	}
	if (bIsBold(usFontstyle)) {
		(void)putc('*', pFile);
	}

	/* 5: The spaces at the end */
	while (pucByte &lt;= pucLast) {
		(void)putc(' ', pFile);
		pucByte++;
	}
} /* end of vPrintFMT */

/*
 * vMoveTo - move to the given X,Y coordinates
 *
 * Move the current position of the given diagram to its X,Y coordinates,
 * start on a new page if needed
 */
static void
vMoveTo(diagram_type *pDiag)
{
	int	iCount, iNbr;

	fail(pDiag == NULL);
	fail(pDiag-&gt;pOutFile == NULL);

	if (pDiag-&gt;lYtop != lYtopCurr) {
		iNbr = iDrawUnits2Char(pDiag-&gt;lXleft);
		for (iCount = 0; iCount &lt; iNbr; iCount++) {
			(void)putc(FILLER_CHAR, pDiag-&gt;pOutFile);
		}
		lYtopCurr = pDiag-&gt;lYtop;
	}
} /* end of vMoveTo */

/*
 * vSubstringFMT - print a sub string
 */
void
vSubstringFMT(diagram_type *pDiag,
	const char *szString, size_t tStringLength, long lStringWidth,
	USHORT usFontstyle)
{
	fail(pDiag == NULL || szString == NULL);
	fail(pDiag-&gt;pOutFile == NULL);
	fail(pDiag-&gt;lXleft &lt; 0);
	fail(tStringLength != strlen(szString));

	if (szString[0] == '\0' || tStringLength == 0) {
		return;
	}

	vMoveTo(pDiag);
	vPrintFMT(pDiag-&gt;pOutFile, szString, tStringLength, usFontstyle);
	pDiag-&gt;lXleft += lStringWidth;
} /* end of vSubstringFMT */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

