<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/fontlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/fontlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * fontlist.c
 * Copyright (C) 1998-2004 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Build, read and destroy a list of Word font information
 */

#include &lt;stdlib.h&gt;
#include &lt;stddef.h&gt;
#include "antiword.h"


/*
 * Private structure to hide the way the information
 * is stored from the rest of the program
 */
typedef struct font_desc_tag {
	font_block_type tInfo;
	struct font_desc_tag    *pNext;
} font_mem_type;

/* Variables needed to write the Font Information List */
static font_mem_type	*pAnchor = NULL;
static font_mem_type	*pFontLast = NULL;


/*
 * vDestroyFontInfoList - destroy the Font Information List
 */
void
vDestroyFontInfoList(void)
{
	font_mem_type	*pCurr, *pNext;

	DBG_MSG("vDestroyFontInfoList");

	/* Free the Font Information List */
	pCurr = pAnchor;
	while (pCurr != NULL) {
		pNext = pCurr-&gt;pNext;
		pCurr = xfree(pCurr);
		pCurr = pNext;
	}
	pAnchor = NULL;
	/* Reset all control variables */
	pFontLast = NULL;
} /* end of vDestroyFontInfoList */

/*
 * vCorrectFontValues - correct font values to values Antiword can use
 */
void
vCorrectFontValues(font_block_type *pFontBlock)
{
	UINT	uiRealSize;
	USHORT	usRealStyle;

	uiRealSize = pFontBlock-&gt;usFontSize;
	usRealStyle = pFontBlock-&gt;usFontStyle;
	if (bIsSmallCapitals(pFontBlock-&gt;usFontStyle)) {
		/* Small capitals become normal capitals in a smaller font */
		uiRealSize = (uiRealSize * 4 + 2) / 5;
		usRealStyle &amp;= ~FONT_SMALL_CAPITALS;
		usRealStyle |= FONT_CAPITALS;
	}
	if (bIsSuperscript(pFontBlock-&gt;usFontStyle) ||
	    bIsSubscript(pFontBlock-&gt;usFontStyle)) {
		/* Superscript and subscript use a smaller fontsize */
		uiRealSize = (uiRealSize * 2 + 1) / 3;
	}

	if (uiRealSize &lt; MIN_FONT_SIZE) {
		DBG_DEC(uiRealSize);
		uiRealSize = MIN_FONT_SIZE;
	} else if (uiRealSize &gt; MAX_FONT_SIZE) {
		DBG_DEC(uiRealSize);
		uiRealSize = MAX_FONT_SIZE;
	}

	pFontBlock-&gt;usFontSize = (USHORT)uiRealSize;
	if (pFontBlock-&gt;ucFontColor == 8) {
		/* White text to light gray text */
		pFontBlock-&gt;ucFontColor = 16;
	}
	pFontBlock-&gt;usFontStyle = usRealStyle;
} /* end of vCorrectFontValues */

/*
 * vAdd2FontInfoList - Add an element to the Font Information List
 */
void
vAdd2FontInfoList(const font_block_type *pFontBlock)
{
	font_mem_type	*pListMember;

	fail(pFontBlock == NULL);

	NO_DBG_MSG("bAdd2FontInfoList");

	if (pFontBlock-&gt;ulFileOffset == FC_INVALID) {
		/*
		 * This offset is really past the end of the file,
		 * so don't waste any memory by storing it.
		 */
		return;
	}

	NO_DBG_HEX(pFontBlock-&gt;ulFileOffset);
	NO_DBG_DEC_C(pFontBlock-&gt;ucFontNumber != 0,
					pFontBlock-&gt;ucFontNumber);
	NO_DBG_DEC_C(pFontBlock-&gt;usFontSize != DEFAULT_FONT_SIZE,
					pFontBlock-&gt;usFontSize);
	NO_DBG_DEC_C(pFontBlock-&gt;ucFontColor != 0,
					pFontBlock-&gt;ucFontColor);
	NO_DBG_HEX_C(pFontBlock-&gt;usFontStyle != 0x00,
					pFontBlock-&gt;usFontStyle);

	if (pFontLast != NULL &amp;&amp;
	    pFontLast-&gt;tInfo.ulFileOffset == pFontBlock-&gt;ulFileOffset) {
		/*
		 * If two consecutive fonts share the same
		 * offset, remember only the last font
		 */
		fail(pFontLast-&gt;pNext != NULL);
		pFontLast-&gt;tInfo = *pFontBlock;
		return;
	}

	/* Create list member */
	pListMember = xmalloc(sizeof(font_mem_type));
	/* Fill the list member */
	pListMember-&gt;tInfo = *pFontBlock;
	pListMember-&gt;pNext = NULL;
	/* Correct the values where needed */
	vCorrectFontValues(&amp;pListMember-&gt;tInfo);
	/* Add the new member to the list */
	if (pAnchor == NULL) {
		pAnchor = pListMember;
	} else {
		fail(pFontLast == NULL);
		pFontLast-&gt;pNext = pListMember;
	}
	pFontLast = pListMember;
} /* end of vAdd2FontInfoList */

/*
 * Get the record that follows the given recored in the Font Information List
 */
const font_block_type *
pGetNextFontInfoListItem(const font_block_type *pCurr)
{
	const font_mem_type	*pRecord;
	size_t	tOffset;

	if (pCurr == NULL) {
		if (pAnchor == NULL) {
			/* There are no records */
			return NULL;
		}
		/* The first record is the only one without a predecessor */
		return &amp;pAnchor-&gt;tInfo;
	}
	tOffset = offsetof(font_mem_type, tInfo);
	/* Many casts to prevent alignment warnings */
	pRecord = (font_mem_type *)(void *)((char *)pCurr - tOffset);
	fail(pCurr != &amp;pRecord-&gt;tInfo);
	if (pRecord-&gt;pNext == NULL) {
		/* The last record has no successor */
		return NULL;
	}
	return &amp;pRecord-&gt;pNext-&gt;tInfo;
} /* end of pGetNextFontInfoListItem */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

