<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/hdrftrlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/hdrftrlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * hdrftrlist.c
 * Copyright (C) 2004,2005 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Build, read and destroy list(s) of Word Header/footer information
 */

#include &lt;string.h&gt;
#include "antiword.h"


#define HDR_EVEN_PAGES	0
#define HDR_ODD_PAGES	1
#define FTR_EVEN_PAGES	2
#define FTR_ODD_PAGES	3
#define HDR_FIRST_PAGE	4
#define FTR_FIRST_PAGE	5

/*
 * Private structures to hide the way the information
 * is stored from the rest of the program
 */
typedef struct hdrftr_local_tag {
	hdrftr_block_type	tInfo;
	ULONG			ulCharPosStart;
	ULONG			ulCharPosNext;
	BOOL			bUseful;
	BOOL			bTextOriginal;
} hdrftr_local_type;
typedef struct hdrftr_mem_tag {
	hdrftr_local_type	atElement[6];
} hdrftr_mem_type;

/* Variables needed to write the Header/footer Information List */
static hdrftr_mem_type	*pHdrFtrList = NULL;
static size_t		tHdrFtrLen = 0;


/*
 * vDestroyHdrFtrInfoList - destroy the Header/footer Information List
 */
void
vDestroyHdrFtrInfoList(void)
{
	hdrftr_mem_type *pRecord;
	output_type	*pCurr, *pNext;
	size_t		tHdrFtr, tIndex;

	DBG_MSG("vDestroyHdrFtrInfoList");

	/* Free the Header/footer Information List */
	for (tHdrFtr = 0; tHdrFtr &lt; tHdrFtrLen; tHdrFtr++) {
		pRecord = pHdrFtrList + tHdrFtr;
		for (tIndex = 0;
		     tIndex &lt; elementsof(pRecord-&gt;atElement);
		     tIndex++) {
			if (!pRecord-&gt;atElement[tIndex].bTextOriginal) {
				continue;
			}
			pCurr = pRecord-&gt;atElement[tIndex].tInfo.pText;
			while (pCurr != NULL) {
				pCurr-&gt;szStorage = xfree(pCurr-&gt;szStorage);
				pNext = pCurr-&gt;pNext;
				pCurr = xfree(pCurr);
				pCurr = pNext;
			}
		}
	}
	pHdrFtrList = xfree(pHdrFtrList);
	/* Reset all control variables */
	tHdrFtrLen = 0;
} /* end of vDestroyHdrFtrInfoList */

/*
 * vCreat8HdrFtrInfoList - Create the Header/footer Information List
 */
void
vCreat8HdrFtrInfoList(const ULONG *aulCharPos, size_t tLength)
{
	hdrftr_mem_type	*pListMember;
	size_t	tHdrFtr, tIndex, tMainIndex;

	fail(aulCharPos == NULL);

	DBG_DEC(tLength);
	if (tLength &lt;= 1) {
		return;
	}
	tHdrFtrLen = tLength / 12;
	if (tLength % 12 != 0 &amp;&amp; tLength % 12 != 1) {
		tHdrFtrLen++;
	}
	DBG_DEC(tHdrFtrLen);

	pHdrFtrList = xcalloc(tHdrFtrLen, sizeof(hdrftr_mem_type));

	for (tHdrFtr = 0; tHdrFtr &lt; tHdrFtrLen; tHdrFtr++) {
		pListMember = pHdrFtrList + tHdrFtr;
		for (tIndex = 0, tMainIndex = tHdrFtr * 12;
		     tIndex &lt; 6 &amp;&amp; tMainIndex &lt; tLength;
		     tIndex++, tMainIndex++) {
			pListMember-&gt;atElement[tIndex].tInfo.pText = NULL;
			pListMember-&gt;atElement[tIndex].ulCharPosStart =
						aulCharPos[tMainIndex];
			if (tMainIndex + 1 &lt; tLength) {
				pListMember-&gt;atElement[tIndex].ulCharPosNext =
					aulCharPos[tMainIndex + 1];
			} else {
				pListMember-&gt;atElement[tIndex].ulCharPosNext =
					aulCharPos[tMainIndex];
			}
		}
	}
} /* end of vCreat8HdrFtrInfoList */

/*
 * vCreat6HdrFtrInfoList - Create the Header/footer Information List
 */
void
vCreat6HdrFtrInfoList(const ULONG *aulCharPos, size_t tLength)
{
	static const size_t	atIndex[] =
		{ SIZE_T_MAX, SIZE_T_MAX, FTR_FIRST_PAGE, HDR_FIRST_PAGE,
		  FTR_ODD_PAGES, FTR_EVEN_PAGES, HDR_ODD_PAGES, HDR_EVEN_PAGES,
		};
	hdrftr_mem_type	*pListMember;
	size_t	tHdrFtr, tTmp, tIndex, tMainIndex, tBit;
	UCHAR	ucDopSpecification, ucSepSpecification;

	fail(aulCharPos == NULL);

	DBG_DEC(tLength);
	if (tLength &lt;= 1) {
		return;
	}
	tHdrFtrLen = tGetNumberOfSections();
	if (tHdrFtrLen == 0) {
		tHdrFtrLen = 1;
	}
	DBG_DEC(tHdrFtrLen);

	pHdrFtrList = xcalloc(tHdrFtrLen, sizeof(hdrftr_mem_type));

	/* Get the start index in aulCharPos */
	ucDopSpecification = ucGetDopHdrFtrSpecification();
	DBG_HEX(ucDopSpecification &amp; 0xe0);
	tMainIndex = 0;
	for (tBit = 7; tBit &gt;= 5; tBit--) {
		if ((ucDopSpecification &amp; BIT(tBit)) != 0) {
			tMainIndex++;
		}
	}
	DBG_DEC(tMainIndex);

	for (tHdrFtr = 0; tHdrFtr &lt; tHdrFtrLen; tHdrFtr++) {
		ucSepSpecification = ucGetSepHdrFtrSpecification(tHdrFtr);
		DBG_HEX(ucSepSpecification &amp; 0xfc);
		pListMember = pHdrFtrList + tHdrFtr;
		for (tTmp = 0;
		     tTmp &lt; elementsof(pListMember-&gt;atElement);
		     tTmp++) {
			pListMember-&gt;atElement[tTmp].tInfo.pText = NULL;
		}
		for (tBit = 7; tBit &gt;= 2; tBit--) {
			if (tMainIndex &gt;= tLength) {
				break;
			}
			if ((ucSepSpecification &amp; BIT(tBit)) == 0) {
				continue;
			}
			tIndex = atIndex[tBit];
			fail(tIndex &gt;= 6);
			pListMember-&gt;atElement[tIndex].ulCharPosStart =
				aulCharPos[tMainIndex];
			if (tMainIndex + 1 &lt; tLength) {
				pListMember-&gt;atElement[tIndex].ulCharPosNext =
					aulCharPos[tMainIndex + 1];
			} else {
				pListMember-&gt;atElement[tIndex].ulCharPosNext =
					aulCharPos[tMainIndex];
			}
			tMainIndex++;
		}
	}
} /* end of vCreat6HdrFtrInfoList */

/*
 * vCreat2HdrFtrInfoList - Create the Header/footer Information List
 */
void
vCreat2HdrFtrInfoList(const ULONG *aulCharPos, size_t tLength)
{
	vCreat6HdrFtrInfoList(aulCharPos, tLength);
} /* end of vCreat2HdrFtrInfoList */

/*
 * pGetHdrFtrInfo - get the Header/footer information
 */
const hdrftr_block_type *
pGetHdrFtrInfo(int iSectionIndex,
	BOOL bWantHeader, BOOL bOddPage, BOOL bFirstInSection)
{
	hdrftr_mem_type	*pCurr;

	fail(iSectionIndex &lt; 0);
	fail(pHdrFtrList == NULL &amp;&amp; tHdrFtrLen != 0);

	if (pHdrFtrList == NULL || tHdrFtrLen == 0) {
		/* No information */
		return NULL;
	}

	if (iSectionIndex &lt; 0) {
		iSectionIndex = 0;
	} else if (iSectionIndex &gt;= (int)tHdrFtrLen) {
		iSectionIndex = (int)(tHdrFtrLen - 1);
	}

	pCurr = pHdrFtrList + iSectionIndex;

	if (bFirstInSection) {
		if (bWantHeader) {
			return &amp;pCurr-&gt;atElement[HDR_FIRST_PAGE].tInfo;
		} else {
			return &amp;pCurr-&gt;atElement[FTR_FIRST_PAGE].tInfo;
		}
	} else {
		if (bWantHeader) {
			if (bOddPage) {
				return &amp;pCurr-&gt;atElement[HDR_ODD_PAGES].tInfo;
			} else {
				return &amp;pCurr-&gt;atElement[HDR_EVEN_PAGES].tInfo;
			}
		} else {
			if (bOddPage) {
				return &amp;pCurr-&gt;atElement[FTR_ODD_PAGES].tInfo;
			} else {
				return &amp;pCurr-&gt;atElement[FTR_EVEN_PAGES].tInfo;
			}
		}
	}
} /* end of pGetHdrFtrInfo */

/*
 * lComputeHdrFtrHeight - compute the height of a header or footer
 *
 * Returns the height in DrawUnits
 */
static long
lComputeHdrFtrHeight(const output_type *pAnchor)
{
	const output_type *pCurr;
	long	lTotal;
	USHORT	usFontSizeMax;

	lTotal = 0;
	usFontSizeMax = 0;
	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (pCurr-&gt;tNextFree == 1) {
			if (pCurr-&gt;szStorage[0] == PAR_END) {
				/* End of a paragraph */
				lTotal += lComputeLeading(usFontSizeMax);
				lTotal += lMilliPoints2DrawUnits(
						(long)pCurr-&gt;usFontSize * 200);
				usFontSizeMax = 0;
				continue;
			}
			if (pCurr-&gt;szStorage[0] == HARD_RETURN) {
				/* End of a line */
				lTotal += lComputeLeading(usFontSizeMax);
				usFontSizeMax = 0;
				continue;
			}
		}
		if (pCurr-&gt;usFontSize &gt; usFontSizeMax) {
			usFontSizeMax = pCurr-&gt;usFontSize;
		}
	}
	if (usFontSizeMax != 0) {
		/* Height of the last paragraph */
		lTotal += lComputeLeading(usFontSizeMax);
	}
	return lTotal;
} /* end of lComputeHdrFtrHeight */

/*
 * vPrepareHdrFtrText - prepare the header/footer text
 */
void
vPrepareHdrFtrText(FILE *pFile)
{
	hdrftr_mem_type		*pCurr, *pPrev;
	hdrftr_local_type	*pTmp;
	output_type		*pText;
	size_t		tHdrFtr, tIndex;

	fail(pFile == NULL);
	fail(pHdrFtrList == NULL &amp;&amp; tHdrFtrLen != 0);

	if (pHdrFtrList == NULL || tHdrFtrLen == 0) {
		/* No information */
		return;
	}

	/* Fill text, text height and useful-ness */
	for (tHdrFtr = 0; tHdrFtr &lt; tHdrFtrLen; tHdrFtr++) {
		pCurr = pHdrFtrList + tHdrFtr;
		for (tIndex = 0;
		     tIndex &lt; elementsof(pHdrFtrList-&gt;atElement);
		     tIndex++) {
			pTmp = &amp;pCurr-&gt;atElement[tIndex];
			pTmp-&gt;bUseful =
				pTmp-&gt;ulCharPosStart != pTmp-&gt;ulCharPosNext;
			if (pTmp-&gt;bUseful) {
				pText = pHdrFtrDecryptor(pFile,
						pTmp-&gt;ulCharPosStart,
						pTmp-&gt;ulCharPosNext);
				pTmp-&gt;tInfo.pText = pText;
				pTmp-&gt;tInfo.lHeight =
						lComputeHdrFtrHeight(pText);
				pTmp-&gt;bTextOriginal = pText != NULL;
			} else {
				pTmp-&gt;tInfo.pText = NULL;
				pTmp-&gt;tInfo.lHeight = 0;
				pTmp-&gt;bTextOriginal = FALSE;
			}
		}
	}

	/* Replace not-useful records by using inheritance */
	if (pHdrFtrList-&gt;atElement[HDR_FIRST_PAGE].bUseful) {
		pTmp = &amp;pHdrFtrList-&gt;atElement[HDR_ODD_PAGES];
		if (!pTmp-&gt;bUseful) {
			*pTmp = pHdrFtrList-&gt;atElement[HDR_FIRST_PAGE];
			pTmp-&gt;bTextOriginal = FALSE;
		}
		pTmp = &amp;pHdrFtrList-&gt;atElement[HDR_EVEN_PAGES];
		if (!pTmp-&gt;bUseful) {
			*pTmp = pHdrFtrList-&gt;atElement[HDR_FIRST_PAGE];
			pTmp-&gt;bTextOriginal = FALSE;
		}
	}
	if (pHdrFtrList-&gt;atElement[FTR_FIRST_PAGE].bUseful) {
		pTmp = &amp;pHdrFtrList-&gt;atElement[FTR_ODD_PAGES];
		if (!pTmp-&gt;bUseful) {
			*pTmp = pHdrFtrList-&gt;atElement[FTR_FIRST_PAGE];
			pTmp-&gt;bTextOriginal = FALSE;
		}
		pTmp = &amp;pHdrFtrList-&gt;atElement[FTR_EVEN_PAGES];
		if (!pTmp-&gt;bUseful) {
			*pTmp = pHdrFtrList-&gt;atElement[FTR_FIRST_PAGE];
			pTmp-&gt;bTextOriginal = FALSE;
		}
	}
	for (tHdrFtr = 1, pCurr = &amp;pHdrFtrList[1];
	     tHdrFtr &lt; tHdrFtrLen;
	     tHdrFtr++, pCurr++) {
		pPrev = pCurr - 1;
		for (tIndex = 0;
		     tIndex &lt; elementsof(pHdrFtrList-&gt;atElement);
		     tIndex++) {
			if (!pCurr-&gt;atElement[tIndex].bUseful &amp;&amp;
			    pPrev-&gt;atElement[tIndex].bUseful) {
				pCurr-&gt;atElement[tIndex] =
						pPrev-&gt;atElement[tIndex];
				pCurr-&gt;atElement[tIndex].bTextOriginal = FALSE;
			}
		}
	}
} /* end of vPrepareHdrFtrText */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

