<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/listlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/listlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * listlist.c
 * Copyright (C) 2002,2003 A.J. van Os; Released under GPL
 *
 * Description:
 * Build, read and destroy a list of Word list information
 *
 * Note:
 * This list only exists when the Word document is saved by Word 8 or later
 */

#include "antiword.h"

/*
 * Private structure to hide the way the information
 * is stored from the rest of the program
 */
typedef struct list_desc_tag {
	list_block_type		tInfo;
	ULONG			ulListID;
	USHORT			usIstd;
	UCHAR			ucListLevel;
	struct list_desc_tag	*pNext;
} list_desc_type;

typedef struct list_value_tag {
	USHORT			usValue;
	USHORT			usListIndex;
	UCHAR			ucListLevel;
	struct list_value_tag	*pNext;
} list_value_type;

/* Variables needed to describe the LFO list (pllfo) */
static ULONG		*aulLfoList = NULL;
static USHORT		usLfoLen = 0;
/* Variables needed to write the List Information List */
static list_desc_type	*pAnchor = NULL;
static list_desc_type	*pBlockLast = NULL;
/* Variable needed for numbering new lists */
static list_value_type	*pValues = NULL;
/* Variables needed for numbering old lists */
static int	iOldListSeqNumber = 0;
static USHORT	usOldListValue = 0;


/*
 * vDestroyListInfoList - destroy the List Information List
 */
void
vDestroyListInfoList(void)
{
	list_desc_type	*pCurr, *pNext;
	list_value_type	*pValueCurr, *pValueNext;

	DBG_MSG("vDestroyListInfoList");

	/* Free the LFO list */
	usLfoLen = 0;
	aulLfoList = xfree(aulLfoList);

	/* Free the List Information List */
	pCurr = pAnchor;
	while (pCurr != NULL) {
		pNext = pCurr-&gt;pNext;
		pCurr = xfree(pCurr);
		pCurr = pNext;
	}
	pAnchor = NULL;
	/* Reset all control variables */
	pBlockLast = NULL;

	/* Free the values list */
	pValueCurr = pValues;
	while (pValueCurr != NULL) {
		pValueNext = pValueCurr-&gt;pNext;
		pValueCurr = xfree(pValueCurr);
		pValueCurr = pValueNext;
	}
	pValues = NULL;
	/* Reset the values for the old lists */
	iOldListSeqNumber = 0;
	usOldListValue = 0;
} /* end of vDestroyListInfoList */

/*
 * vBuildLfoList - build the LFO list (pllfo)
 */
void
vBuildLfoList(const UCHAR *aucBuffer, size_t tBufLen)
{
	size_t	tRecords;
	int	iIndex;

	fail(aucBuffer == NULL);

	if (tBufLen &lt; 4) {
		return;
	}
	tRecords = (size_t)ulGetLong(0, aucBuffer);
	NO_DBG_DEC(tRecords);
	if (4 + 16 * tRecords &gt; tBufLen || tRecords &gt;= 0x7fff) {
		/* Just a sanity check */
		DBG_DEC(tRecords);
		DBG_DEC(4 + 16 * tRecords);
		DBG_DEC(tBufLen);
		return;
	}
	aulLfoList = xcalloc(tRecords, sizeof(ULONG));
	for (iIndex = 0; iIndex &lt; (int)tRecords; iIndex++) {
		aulLfoList[iIndex] = ulGetLong(4 + 16 * iIndex, aucBuffer);
		NO_DBG_HEX(aulLfoList[iIndex]);
	}
	usLfoLen = (USHORT)tRecords;
} /* end of vBuildLfoList */

/*
 * vAdd2ListInfoList - add an element to the List Information list
 */
void
vAdd2ListInfoList(ULONG ulListID, USHORT usIstd, UCHAR ucListLevel,
	const list_block_type *pListBlock)
{
	list_desc_type	*pListMember;

	fail(pListBlock == NULL);

	NO_DBG_HEX(ulListID);
	NO_DBG_DEC(usIstd);
	NO_DBG_DEC(ucListLevel);
	NO_DBG_DEC(pListBlock-&gt;ulStartAt);
	NO_DBG_DEC(pListBlock-&gt;bNoRestart);
	NO_DBG_DEC(pListBlock-&gt;sLeftIndent);
	NO_DBG_HEX(pListBlock-&gt;ucNFC);
	NO_DBG_HEX(pListBlock-&gt;usListChar);

	/* Create list member */
	pListMember = xmalloc(sizeof(list_desc_type));
	/* Fill the list member */
	pListMember-&gt;tInfo = *pListBlock;
	pListMember-&gt;ulListID = ulListID;
	pListMember-&gt;usIstd = usIstd;
	pListMember-&gt;ucListLevel = ucListLevel;
	pListMember-&gt;pNext = NULL;
	/* Correct the values where needed */
	if (pListMember-&gt;tInfo.ulStartAt &gt; 0xffff) {
		DBG_DEC(pListMember-&gt;tInfo.ulStartAt);
		pListMember-&gt;tInfo.ulStartAt = 1;
	}
	/* Add the new member to the list */
	if (pAnchor == NULL) {
		pAnchor = pListMember;
	} else {
		fail(pBlockLast == NULL);
		pBlockLast-&gt;pNext = pListMember;
	}
	pBlockLast = pListMember;
} /* end of vAdd2ListInfoList */

/*
 * Get a matching record from the List Information List
 *
 * Returns NULL if no matching records is found
 */
const list_block_type *
pGetListInfo(USHORT usListIndex, UCHAR ucListLevel)
{
	list_desc_type	*pCurr;
	list_block_type	*pNearMatch;
	ULONG	ulListID;

	if (usListIndex == 0) {
		return NULL;
	}
	if (usListIndex - 1 &gt;= usLfoLen || ucListLevel &gt; 8) {
		DBG_DEC(usListIndex);
		DBG_DEC(ucListLevel);
		return NULL;
	}
	fail(aulLfoList == NULL);
	ulListID = aulLfoList[usListIndex - 1];
	NO_DBG_HEX(ulListID);

	pNearMatch = NULL;
	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (pCurr-&gt;ulListID != ulListID) {
			/* No match */
			continue;
		}
		if (pCurr-&gt;ucListLevel == ucListLevel) {
			/* Exact match */
			return &amp;pCurr-&gt;tInfo;
		}
		if (pCurr-&gt;ucListLevel == 0) {
			/* Near match */
			pNearMatch = &amp;pCurr-&gt;tInfo;
		}
	}
	/* No exact match, use a near match if any */
	return pNearMatch;
} /* end of pGetListInfo */

/*
 * Get a matching record from the List Information List
 *
 * Returns NULL if no matching records is found
 */
const list_block_type *
pGetListInfoByIstd(USHORT usIstd)
{
	list_desc_type	*pCurr;

	if (usIstd == ISTD_INVALID || usIstd == STI_NIL || usIstd == STI_USER) {
		return NULL;
	}

	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (pCurr-&gt;usIstd == usIstd) {
			return &amp;pCurr-&gt;tInfo;
		}
	}
	return NULL;
} /* end of pGetListInfoByIstd */

/*
 * vRestartListValues - reset the less significant list levels
 */
static void
vRestartListValues(USHORT usListIndex, UCHAR ucListLevel)
{
	list_value_type	*pPrev, *pCurr, *pNext;
	int		iCounter;

	iCounter = 0;
	pPrev = NULL;
	pCurr = pValues;

	while (pCurr != NULL) {
		if (pCurr-&gt;usListIndex != usListIndex ||
		    pCurr-&gt;ucListLevel &lt;= ucListLevel) {
			pPrev = pCurr;
			pCurr = pCurr-&gt;pNext;
			continue;
		}
		/* Reset the level by deleting the record */
		pNext = pCurr-&gt;pNext;
		if (pPrev == NULL) {
			pValues = pNext;
		} else {
			pPrev-&gt;pNext = pNext;
		}
		DBG_DEC(pCurr-&gt;usListIndex);
		DBG_DEC(pCurr-&gt;ucListLevel);
		pCurr = xfree(pCurr);
		pCurr = pNext;
		iCounter++;
	}
	DBG_DEC_C(iCounter &gt; 0, iCounter);
} /* end of vRestartListValues */

/*
 * usGetListValue - Get the current value of the given list
 *
 * Returns the value of the given list
 */
USHORT
usGetListValue(int iListSeqNumber, int iWordVersion,
	const style_block_type *pStyle)
{
	list_value_type	*pCurr;
	USHORT		usValue;

	fail(iListSeqNumber &lt; 0);
	fail(iListSeqNumber &lt; iOldListSeqNumber);
	fail(iWordVersion &lt; 0);
	fail(pStyle == NULL);

	if (iListSeqNumber &lt;= 0) {
		return 0;
	}

	if (iWordVersion &lt; 8) {
		/* Old style list */
		if (iListSeqNumber == iOldListSeqNumber ||
		    (iListSeqNumber == iOldListSeqNumber + 1 &amp;&amp;
		     eGetNumType(pStyle-&gt;ucNumLevel) == level_type_sequence)) {
			if (!pStyle-&gt;bNumPause) {
				usOldListValue++;
			}
		} else {
			usOldListValue = pStyle-&gt;usStartAt;
		}
		iOldListSeqNumber = iListSeqNumber;
		return usOldListValue;
	}

	/* New style list */
	if (pStyle-&gt;usListIndex == 0 ||
	    pStyle-&gt;usListIndex - 1 &gt;= usLfoLen ||
	    pStyle-&gt;ucListLevel &gt; 8) {
		/* Out of range; no need to search */
		return 0;
	}

	for (pCurr = pValues; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		if (pCurr-&gt;usListIndex == pStyle-&gt;usListIndex &amp;&amp;
		    pCurr-&gt;ucListLevel == pStyle-&gt;ucListLevel) {
			/* Record found; increment and return the value */
			pCurr-&gt;usValue++;
			usValue = pCurr-&gt;usValue;
			if (!pStyle-&gt;bNoRestart) {
				vRestartListValues(pStyle-&gt;usListIndex,
						pStyle-&gt;ucListLevel);
			}
			return usValue;
		}
	}

	/* Record not found; create it and add it to the front of the list */
	pCurr = xmalloc(sizeof(list_value_type));
	pCurr-&gt;usValue = pStyle-&gt;usStartAt;
	pCurr-&gt;usListIndex = pStyle-&gt;usListIndex;
	pCurr-&gt;ucListLevel = pStyle-&gt;ucListLevel;
	pCurr-&gt;pNext = pValues;
	pValues = pCurr;
	usValue = pCurr-&gt;usValue;
	if (!pStyle-&gt;bNoRestart) {
		vRestartListValues(pStyle-&gt;usListIndex, pStyle-&gt;ucListLevel);
	}
	return usValue;
} /* end of usGetListValue */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

