<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/prop6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/prop6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * prop6.c
 * Copyright (C) 1998-2005 A.J. van Os; Released under GPL
 *
 * Description:
 * Read the property information from a MS Word 6 or 7 file
 */

#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include "antiword.h"


/*
 * iGet6InfoLength - the length of the information for Word 6/7 files
 */
static int
iGet6InfoLength(int iByteNbr, const UCHAR *aucGrpprl)
{
	int	iTmp, iDel, iAdd;

	switch (ucGetByte(iByteNbr, aucGrpprl)) {
	case   2: case  16: case  17: case  18: case  19: case  21: case  22:
	case  26: case  27: case  28: case  30: case  31: case  32: case  33:
	case  34: case  35: case  36: case  38: case  39: case  40: case  41:
	case  42: case  43: case  45: case  46: case  47: case  48: case  49:
	case  69: case  72: case  80: case  93: case  96: case  97: case  99:
	case 101: case 105: case 106: case 107: case 109: case 110: case 121:
	case 122: case 123: case 124: case 140: case 141: case 144: case 145:
	case 148: case 149: case 154: case 155: case 156: case 157: case 160:
	case 161: case 164: case 165: case 166: case 167: case 168: case 169:
	case 170: case 171: case 182: case 183: case 184: case 189: case 195:
	case 197: case 198:
		return 1 + 2;
	case   3: case  12: case  15: case  81: case 103: case 108: case 188:
	case 190: case 191:
		return 2 + (int)ucGetByte(iByteNbr + 1, aucGrpprl);
	case  20: case  70: case  74: case 192: case 194: case 196: case 200:
		return 1 + 4;
	case  23:
		iTmp = (int)ucGetByte(iByteNbr + 1, aucGrpprl);
		if (iTmp == 255) {
			iDel = (int)ucGetByte(iByteNbr + 2, aucGrpprl);
			iAdd = (int)ucGetByte(
					iByteNbr + 3 + iDel * 4, aucGrpprl);
			iTmp = 2 + iDel * 4 + iAdd * 3;
		}
		return 2 + iTmp;
	case  68: case 193: case 199:
		return 1 + 5;
	case  73: case  95: case 136: case 137:
		return 1 + 3;
	case 120: case 187:
		return 1 + 12;
	default:
		return 1 + 1;
	}
} /* end of iGet6InfoLength */

/*
 * Build the lists with Document Property Information for Word 6/7 files
 */
void
vGet6DopInfo(FILE *pFile, ULONG ulStartBlock,
	const ULONG *aulBBD, size_t tBBDLen,
	const UCHAR *aucHeader)
{
	document_block_type	tDocument;
	UCHAR	*aucBuffer;
	ULONG	ulBeginDocpInfo, ulTmp;
	size_t	tDocpInfoLen;
	USHORT	usTmp;

	ulBeginDocpInfo = ulGetLong(0x150, aucHeader); /* fcDop */
	DBG_HEX(ulBeginDocpInfo);
	tDocpInfoLen = (size_t)ulGetLong(0x154, aucHeader); /* lcbDop */
	DBG_DEC(tDocpInfoLen);
	if (tDocpInfoLen &lt; 28) {
		DBG_MSG("No Document information");
		return;
	}

	aucBuffer = xmalloc(tDocpInfoLen);
	if (!bReadBuffer(pFile, ulStartBlock,
			aulBBD, tBBDLen, BIG_BLOCK_SIZE,
			aucBuffer, ulBeginDocpInfo, tDocpInfoLen)) {
		aucBuffer = xfree(aucBuffer);
		return;
	}

	usTmp = usGetWord(0x00, aucBuffer);
	tDocument.ucHdrFtrSpecification = (UCHAR)(usTmp &gt;&gt; 8); /* grpfIhdt */
	tDocument.usDefaultTabWidth = usGetWord(0x0a, aucBuffer); /* dxaTab */
	ulTmp = ulGetLong(0x14, aucBuffer); /* dttmCreated */
	tDocument.tCreateDate = tConvertDTTM(ulTmp);
	ulTmp = ulGetLong(0x18, aucBuffer); /* dttmRevised */
	tDocument.tRevisedDate = tConvertDTTM(ulTmp);
	vCreateDocumentInfoList(&amp;tDocument);

	aucBuffer = xfree(aucBuffer);
} /* end of vGet6DopInfo */

/*
 * Fill the section information block with information
 * from a Word 6/7 file.
 */
static void
vGet6SectionInfo(const UCHAR *aucGrpprl, size_t tBytes,
		section_block_type *pSection)
{
	UINT	uiIndex;
	int	iFodoOff, iInfoLen, iSize, iTmp;
	USHORT	usCcol;
	UCHAR	ucTmp;

	fail(aucGrpprl == NULL || pSection == NULL);

	iFodoOff = 0;
	while (tBytes &gt;= (size_t)iFodoOff + 1) {
		iInfoLen = 0;
		switch (ucGetByte(iFodoOff, aucGrpprl)) {
		case 133:	/* olstAnm */
			iSize = (int)ucGetByte(iFodoOff + 1, aucGrpprl);
			DBG_DEC_C(iSize != 212, iSize);
			for (uiIndex = 0, iTmp = iFodoOff + 2;
			     uiIndex &lt; 9 &amp;&amp; iTmp &lt; iFodoOff + 2 + iSize - 15;
			     uiIndex++, iTmp += 16) {
				pSection-&gt;aucNFC[uiIndex] =
						ucGetByte(iTmp, aucGrpprl);
				NO_DBG_DEC(pSection-&gt;aucNFC[uiIndex]);
				ucTmp = ucGetByte(iTmp + 3, aucGrpprl);
				NO_DBG_HEX(ucTmp);
				if ((ucTmp &amp; BIT(2)) != 0) {
					pSection-&gt;usNeedPrevLvl |=
							(USHORT)BIT(uiIndex);
				}
				if ((ucTmp &amp; BIT(3)) != 0) {
					pSection-&gt;usHangingIndent |=
							(USHORT)BIT(uiIndex);
				}
			}
			DBG_HEX(pSection-&gt;usNeedPrevLvl);
			DBG_HEX(pSection-&gt;usHangingIndent);
			break;
		case 142:	/* bkc */
			ucTmp = ucGetByte(iFodoOff + 1, aucGrpprl);
			DBG_DEC(ucTmp);
			pSection-&gt;bNewPage = ucTmp != 0 &amp;&amp; ucTmp != 1;
			break;
		case 144:	/* ccolM1 */
			usCcol = 1 + usGetWord(iFodoOff + 1, aucGrpprl);
			DBG_DEC(usCcol);
			break;
		case 153:	/* grpfIhdt */
			pSection-&gt;ucHdrFtrSpecification =
					ucGetByte(iFodoOff + 1, aucGrpprl);
			break;
		default:
			break;
		}
		if (iInfoLen &lt;= 0) {
			iInfoLen = iGet6InfoLength(iFodoOff, aucGrpprl);
			fail(iInfoLen &lt;= 0);
		}
		iFodoOff += iInfoLen;
	}
} /* end of vGet6SectionInfo */

/*
 * Build the lists with Section Property Information for Word 6/7 files
 */
void
vGet6SepInfo(FILE *pFile, ULONG ulStartBlock,
	const ULONG *aulBBD, size_t tBBDLen,
	const UCHAR *aucHeader)
{
	section_block_type	tSection;
	ULONG		*aulSectPage, *aulCharPos;
	UCHAR	*aucBuffer, *aucFpage;
	ULONG	ulBeginOfText, ulTextOffset, ulBeginSectInfo;
	size_t	tSectInfoLen, tIndex, tOffset, tLen, tBytes;
	UCHAR	aucTmp[2];

	fail(pFile == NULL || aucHeader == NULL);
	fail(ulStartBlock &gt; MAX_BLOCKNUMBER &amp;&amp; ulStartBlock != END_OF_CHAIN);
	fail(aulBBD == NULL);

        ulBeginOfText = ulGetLong(0x18, aucHeader); /* fcMin */
        NO_DBG_HEX(ulBeginOfText);
	ulBeginSectInfo = ulGetLong(0x88, aucHeader); /* fcPlcfsed */
	DBG_HEX(ulBeginSectInfo);
	tSectInfoLen = (size_t)ulGetLong(0x8c, aucHeader); /* lcbPlcfsed */
	DBG_DEC(tSectInfoLen);
	if (tSectInfoLen &lt; 4) {
		DBG_DEC(tSectInfoLen);
		return;
	}

	aucBuffer = xmalloc(tSectInfoLen);
	if (!bReadBuffer(pFile, ulStartBlock,
			aulBBD, tBBDLen, BIG_BLOCK_SIZE,
			aucBuffer, ulBeginSectInfo, tSectInfoLen)) {
		aucBuffer = xfree(aucBuffer);
		return;
	}
	NO_DBG_PRINT_BLOCK(aucBuffer, tSectInfoLen);

	/* Read the Section Descriptors */
	tLen = (tSectInfoLen - 4) / 16;
	/* Save the section offsets */
	aulCharPos = xcalloc(tLen, sizeof(ULONG));
	for (tIndex = 0, tOffset = 0; tIndex &lt; tLen; tIndex++, tOffset += 4) {
		ulTextOffset = ulGetLong(tOffset, aucBuffer);
		NO_DBG_HEX(ulTextOffset);
		aulCharPos[tIndex] = ulBeginOfText + ulTextOffset;
		NO_DBG_HEX(aulCharPos[tIndex]);
	}
	/* Save the Sepx offsets */
	aulSectPage = xcalloc(tLen, sizeof(ULONG));
	for (tIndex = 0, tOffset = (tLen + 1) * 4;
	     tIndex &lt; tLen;
	     tIndex++, tOffset += 12) {
		aulSectPage[tIndex] = ulGetLong(tOffset + 2, aucBuffer);
		NO_DBG_HEX(aulSectPage[tIndex]); /* fcSepx */
	}
	aucBuffer = xfree(aucBuffer);

	/* Read the Section Properties */
	for (tIndex = 0; tIndex &lt; tLen; tIndex++) {
		if (aulSectPage[tIndex] == FC_INVALID) {
			vDefault2SectionInfoList(aulCharPos[tIndex]);
			continue;
		}
		/* Get the number of bytes to read */
		if (!bReadBuffer(pFile, ulStartBlock,
				aulBBD, tBBDLen, BIG_BLOCK_SIZE,
				aucTmp, aulSectPage[tIndex], 2)) {
			continue;
		}
		tBytes = 2 + (size_t)usGetWord(0, aucTmp);
		NO_DBG_DEC(tBytes);
		/* Read the bytes */
		aucFpage = xmalloc(tBytes);
		if (!bReadBuffer(pFile, ulStartBlock,
				aulBBD, tBBDLen, BIG_BLOCK_SIZE,
				aucFpage, aulSectPage[tIndex], tBytes)) {
			aucFpage = xfree(aucFpage);
			continue;
		}
		NO_DBG_PRINT_BLOCK(aucFpage, tBytes);
		/* Process the bytes */
		vGetDefaultSection(&amp;tSection);
		vGet6SectionInfo(aucFpage + 2, tBytes - 2, &amp;tSection);
		vAdd2SectionInfoList(&amp;tSection, aulCharPos[tIndex]);
		aucFpage = xfree(aucFpage);
	}
	aulCharPos = xfree(aulCharPos);
	aulSectPage = xfree(aulSectPage);
} /* end of vGet6SepInfo */

/*
 * Build the list with Header/Footer Information for Word 6/7 files
 */
void
vGet6HdrFtrInfo(FILE *pFile, ULONG ulStartBlock,
	const ULONG *aulBBD, size_t tBBDLen,
	const UCHAR *aucHeader)
{
	ULONG	*aulCharPos;
	UCHAR	*aucBuffer;
	ULONG	ulHdrFtrOffset, ulBeginHdrFtrInfo;
	size_t	tHdrFtrInfoLen, tIndex, tOffset, tLen;

	fail(pFile == NULL || aucHeader == NULL);
	fail(ulStartBlock &gt; MAX_BLOCKNUMBER &amp;&amp; ulStartBlock != END_OF_CHAIN);
	fail(aulBBD == NULL);

	ulBeginHdrFtrInfo = ulGetLong(0xb0, aucHeader); /* fcPlcfhdd */
	NO_DBG_HEX(ulBeginHdrFtrInfo);
	tHdrFtrInfoLen = (size_t)ulGetLong(0xb4, aucHeader); /* lcbPlcfhdd */
	NO_DBG_DEC(tHdrFtrInfoLen);
	if (tHdrFtrInfoLen &lt; 8) {
		DBG_DEC_C(tHdrFtrInfoLen != 0, tHdrFtrInfoLen);
		return;
	}

	aucBuffer = xmalloc(tHdrFtrInfoLen);
	if (!bReadBuffer(pFile, ulStartBlock,
			aulBBD, tBBDLen, BIG_BLOCK_SIZE,
			aucBuffer, ulBeginHdrFtrInfo, tHdrFtrInfoLen)) {
		aucBuffer = xfree(aucBuffer);
		return;
	}
	NO_DBG_PRINT_BLOCK(aucBuffer, tHdrFtrInfoLen);

	tLen = tHdrFtrInfoLen / 4 - 1;
	/* Save the header/footer offsets */
	aulCharPos = xcalloc(tLen, sizeof(ULONG));
	for (tIndex = 0, tOffset = 0;
	     tIndex &lt; tLen;
	     tIndex++, tOffset += 4) {
		ulHdrFtrOffset = ulGetLong(tOffset, aucBuffer);
		NO_DBG_HEX(ulHdrFtrOffset);
		aulCharPos[tIndex] = ulHdrFtrOffset2CharPos(ulHdrFtrOffset);
		NO_DBG_HEX(aulCharPos[tIndex]);
	}
	vCreat6HdrFtrInfoList(aulCharPos, tLen);
	aulCharPos = xfree(aulCharPos);
	aucBuffer = xfree(aucBuffer);
} /* end of vGet6HdrFtrInfo */

/*
 * Translate the rowinfo to a member of the row_info enumeration
 */
row_info_enum
eGet6RowInfo(int iFodo,
	const UCHAR *aucGrpprl, int iBytes, row_block_type *pRow)
{
	int	iFodoOff, iInfoLen;
	int	iIndex, iSize, iCol;
	int	iPosCurr, iPosPrev;
	USHORT	usTmp;
	BOOL	bFound24_0, bFound24_1, bFound25_0, bFound25_1, bFound190;

	fail(iFodo &lt; 0 || aucGrpprl == NULL || pRow == NULL);

	iFodoOff = 0;
	bFound24_0 = FALSE;
	bFound24_1 = FALSE;
	bFound25_0 = FALSE;
	bFound25_1 = FALSE;
	bFound190 = FALSE;
	while (iBytes &gt;= iFodoOff + 1) {
		iInfoLen = 0;
		switch (ucGetByte(iFodo + iFodoOff, aucGrpprl)) {
		case  24:	/* fInTable */
			if (odd(ucGetByte(iFodo + iFodoOff + 1, aucGrpprl))) {
				bFound24_1 = TRUE;
			} else {
				bFound24_0 = TRUE;
			}
			break;
		case  25:	/* fTtp */
			if (odd(ucGetByte(iFodo + iFodoOff + 1, aucGrpprl))) {
				bFound25_1 = TRUE;
			} else {
				bFound25_0 = TRUE;
			}
			break;
		case 38:	/* brcTop */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			usTmp &amp;= 0x0018;
			NO_DBG_DEC(usTmp &gt;&gt; 3);
			if (usTmp == 0) {
				pRow-&gt;ucBorderInfo &amp;= ~TABLE_BORDER_TOP;
			} else {
				pRow-&gt;ucBorderInfo |= TABLE_BORDER_TOP;
			}
			break;
		case 39:	/* brcLeft */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			usTmp &amp;= 0x0018;
			NO_DBG_DEC(usTmp &gt;&gt; 3);
			if (usTmp == 0) {
				pRow-&gt;ucBorderInfo &amp;= ~TABLE_BORDER_LEFT;
			} else {
				pRow-&gt;ucBorderInfo |= TABLE_BORDER_LEFT;
			}
			break;
		case 40:	/* brcBottom */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			usTmp &amp;= 0x0018;
			NO_DBG_DEC(usTmp &gt;&gt; 3);
			if (usTmp == 0) {
				pRow-&gt;ucBorderInfo &amp;= ~TABLE_BORDER_BOTTOM;
			} else {
				pRow-&gt;ucBorderInfo |= TABLE_BORDER_BOTTOM;
			}
			break;
		case 41:	/* brcRight */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			usTmp &amp;= 0x0018;
			NO_DBG_DEC(usTmp &gt;&gt; 3);
			if (usTmp == 0) {
				pRow-&gt;ucBorderInfo &amp;= ~TABLE_BORDER_RIGHT;
			} else {
				pRow-&gt;ucBorderInfo |= TABLE_BORDER_RIGHT;
			}
			break;
		case 188:	/* cDefTable10 */
			DBG_MSG("188: sprmTDefTable10");
			iSize = (int)usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			DBG_DEC(iSize);
			break;
		case 190:	/* cDefTable */
			iSize = (int)usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			if (iSize &lt; 6 || iBytes &lt; iFodoOff + 7) {
				DBG_DEC(iSize);
				DBG_DEC(iFodoOff);
				iInfoLen = 1;
				break;
			}
			iCol = (int)ucGetByte(iFodo + iFodoOff + 3, aucGrpprl);
			if (iCol &lt; 1 ||
			    iBytes &lt; iFodoOff + 3 + (iCol + 1) * 2) {
				DBG_DEC(iCol);
				DBG_DEC(iFodoOff);
				iInfoLen = 1;
				break;
			}
			if (iCol &gt;= (int)elementsof(pRow-&gt;asColumnWidth)) {
				DBG_DEC(iCol);
				werr(1, "The number of columns is corrupt");
			}
			pRow-&gt;ucNumberOfColumns = (UCHAR)iCol;
			iPosPrev = (int)(short)usGetWord(
					iFodo + iFodoOff + 4,
					aucGrpprl);
			for (iIndex = 0; iIndex &lt; iCol; iIndex++) {
				iPosCurr = (int)(short)usGetWord(
					iFodo + iFodoOff + 6 + iIndex * 2,
					aucGrpprl);
				pRow-&gt;asColumnWidth[iIndex] =
						(short)(iPosCurr - iPosPrev);
				iPosPrev = iPosCurr;
			}
			bFound190 = TRUE;
			break;
		default:
			break;
		}
		if (iInfoLen &lt;= 0) {
			iInfoLen =
				iGet6InfoLength(iFodo + iFodoOff, aucGrpprl);
			fail(iInfoLen &lt;= 0);
		}
		iFodoOff += iInfoLen;
	}

	if (bFound25_1 &amp;&amp; bFound190) {
		return found_end_of_row;
	}
	if (bFound25_0 &amp;&amp; !bFound190) {
		return found_not_end_of_row;
	}
	if (bFound24_1) {
		return found_a_cell;
	}
	if (bFound24_0) {
		return found_not_a_cell;
	}
	return found_nothing;
} /* end of eGet6RowInfo */

/*
 * Fill the style information block with information
 * from a Word 6/7 file.
 */
void
vGet6StyleInfo(int iFodo,
	const UCHAR *aucGrpprl, int iBytes, style_block_type *pStyle)
{
	int	iFodoOff, iInfoLen;
	int	iTmp, iDel, iAdd, iBefore;
	short	sTmp;
	UCHAR	ucTmp;

	fail(iFodo &lt; 0 || aucGrpprl == NULL || pStyle == NULL);

	NO_DBG_DEC(pStyle-&gt;usIstd);

	iFodoOff = 0;
	while (iBytes &gt;= iFodoOff + 1) {
		iInfoLen = 0;
		switch (ucGetByte(iFodo + iFodoOff, aucGrpprl)) {
		case   2:	/* istd */
			sTmp = (short)ucGetByte(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(sTmp);
			break;
		case   5:	/* jc */
			pStyle-&gt;ucAlignment = ucGetByte(
					iFodo + iFodoOff + 1, aucGrpprl);
			break;
		case  12:	/* anld */
			iTmp = (int)ucGetByte(
					iFodo + iFodoOff + 1, aucGrpprl);
			DBG_DEC_C(iTmp &lt; 52, iTmp);
			if (iTmp &gt;= 1) {
				pStyle-&gt;ucNFC = ucGetByte(
					iFodo + iFodoOff + 2, aucGrpprl);
			}
			if (pStyle-&gt;ucNFC != LIST_BULLETS &amp;&amp; iTmp &gt;= 2) {
				iBefore = (int)ucGetByte(
					iFodo + iFodoOff + 3, aucGrpprl);
			} else {
				iBefore = 0;
			}
			if (iTmp &gt;= 12) {
				pStyle-&gt;usStartAt = usGetWord(
					iFodo + iFodoOff + 12, aucGrpprl);
			}
			if (iTmp &gt;= iBefore + 21) {
				pStyle-&gt;usListChar = (USHORT)ucGetByte(
					iFodo + iFodoOff + iBefore + 22,
					aucGrpprl);
				NO_DBG_HEX(pStyle-&gt;usListChar);
			}
			break;
		case  13:	/* nLvlAnm */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			pStyle-&gt;ucNumLevel = ucTmp;
			pStyle-&gt;bNumPause =
				eGetNumType(ucTmp) == level_type_pause;
			break;
		case  15:	/* ChgTabsPapx */
		case  23:	/* ChgTabs */
			iTmp = (int)ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			if (iTmp &lt; 2) {
				iInfoLen = 1;
				break;
			}
			NO_DBG_DEC(iTmp);
			iDel = (int)ucGetByte(iFodo + iFodoOff + 2, aucGrpprl);
			if (iTmp &lt; 2 + 2 * iDel) {
				iInfoLen = 1;
				break;
			}
			NO_DBG_DEC(iDel);
			iAdd = (int)ucGetByte(
				iFodo + iFodoOff + 3 + 2 * iDel, aucGrpprl);
			if (iTmp &lt; 2 + 2 * iDel + 2 * iAdd) {
				iInfoLen = 1;
				break;
			}
			NO_DBG_DEC(iAdd);
			break;
		case  16:	/* dxaRight */
			pStyle-&gt;sRightIndent = (short)usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(pStyle-&gt;sRightIndent);
			break;
		case  17:	/* dxaLeft */
			pStyle-&gt;sLeftIndent = (short)usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(pStyle-&gt;sLeftIndent);
			break;
		case  18:	/* Nest dxaLeft */
			sTmp = (short)usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			pStyle-&gt;sLeftIndent += sTmp;
			if (pStyle-&gt;sLeftIndent &lt; 0) {
				pStyle-&gt;sLeftIndent = 0;
			}
			NO_DBG_DEC(sTmp);
			NO_DBG_DEC(pStyle-&gt;sLeftIndent);
			break;
		case  19:	/* dxaLeft1 */
			pStyle-&gt;sLeftIndent1 = (short)usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(pStyle-&gt;sLeftIndent1);
			break;
		case  21:	/* dyaBefore */
			pStyle-&gt;usBeforeIndent = usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(pStyle-&gt;usBeforeIndent);
			break;
		case  22:	/* dyaAfter */
			pStyle-&gt;usAfterIndent = usGetWord(
					iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(pStyle-&gt;usAfterIndent);
			break;
		default:
			break;
		}
		if (iInfoLen &lt;= 0) {
			iInfoLen =
				iGet6InfoLength(iFodo + iFodoOff, aucGrpprl);
			fail(iInfoLen &lt;= 0);
		}
		iFodoOff += iInfoLen;
	}
} /* end of vGet6StyleInfo */

/*
 * Build the lists with Paragraph Information for Word 6/7 files
 */
void
vGet6PapInfo(FILE *pFile, ULONG ulStartBlock,
	const ULONG *aulBBD, size_t tBBDLen,
	const UCHAR *aucHeader)
{
	row_block_type		tRow;
	style_block_type	tStyle;
	USHORT	*ausParfPage;
	UCHAR	*aucBuffer;
	ULONG	ulCharPos, ulCharPosFirst, ulCharPosLast;
	ULONG	ulBeginParfInfo;
	size_t	tParfInfoLen, tParfPageNum, tOffset, tSize, tLenOld, tLen;
	size_t	tIndex, tIndex2, tRun;
	int	iFodo, iLen;
	row_info_enum	eRowInfo;
	USHORT	usParfFirstPage, usCount, usIstd;
	UCHAR	aucFpage[BIG_BLOCK_SIZE];

	fail(pFile == NULL || aucHeader == NULL);
	fail(ulStartBlock &gt; MAX_BLOCKNUMBER &amp;&amp; ulStartBlock != END_OF_CHAIN);
	fail(aulBBD == NULL);

	ulBeginParfInfo = ulGetLong(0xc0, aucHeader); /* fcPlcfbtePapx */
	NO_DBG_HEX(ulBeginParfInfo);
	tParfInfoLen = (size_t)ulGetLong(0xc4, aucHeader); /* lcbPlcfbtePapx */
	NO_DBG_DEC(tParfInfoLen);
	if (tParfInfoLen &lt; 4) {
		DBG_DEC(tParfInfoLen);
		return;
	}

	aucBuffer = xmalloc(tParfInfoLen);
	if (!bReadBuffer(pFile, ulStartBlock,
			aulBBD, tBBDLen, BIG_BLOCK_SIZE,
			aucBuffer, ulBeginParfInfo, tParfInfoLen)) {
		aucBuffer = xfree(aucBuffer);
		return;
	}
	NO_DBG_PRINT_BLOCK(aucBuffer, tParfInfoLen);

	tLen = (tParfInfoLen - 4) / 6;
	ausParfPage = xcalloc(tLen, sizeof(USHORT));
	for (tIndex = 0, tOffset = (tLen + 1) * 4;
	     tIndex &lt; tLen;
	     tIndex++, tOffset += 2) {
		 ausParfPage[tIndex] = usGetWord(tOffset, aucBuffer);
		 NO_DBG_DEC(ausParfPage[tIndex]);
	}
	DBG_HEX(ulGetLong(0, aucBuffer));
	aucBuffer = xfree(aucBuffer);
	tParfPageNum = (size_t)usGetWord(0x190, aucHeader); /* cpnBtePap */
	DBG_DEC(tParfPageNum);
	if (tLen &lt; tParfPageNum) {
		/* Replace ParfPage by a longer version */
		tLenOld = tLen;
		usParfFirstPage = usGetWord(0x18c, aucHeader); /* pnPapFirst */
		DBG_DEC(usParfFirstPage);
		tLen += tParfPageNum - 1;
		tSize = tLen * sizeof(USHORT);
		ausParfPage = xrealloc(ausParfPage, tSize);
		/* Add new values */
		usCount = usParfFirstPage + 1;
		for (tIndex = tLenOld; tIndex &lt; tLen; tIndex++) {
			ausParfPage[tIndex] = usCount;
			NO_DBG_DEC(ausParfPage[tIndex]);
			usCount++;
		}
	}

	(void)memset(&amp;tRow, 0, sizeof(tRow));
	ulCharPosFirst = CP_INVALID;
	for (tIndex = 0; tIndex &lt; tLen; tIndex++) {
		if (!bReadBuffer(pFile, ulStartBlock,
				aulBBD, tBBDLen, BIG_BLOCK_SIZE,
				aucFpage,
				(ULONG)ausParfPage[tIndex] * BIG_BLOCK_SIZE,
				BIG_BLOCK_SIZE)) {
			break;
		}
		tRun = (size_t)ucGetByte(0x1ff, aucFpage);
		NO_DBG_DEC(tRun);
		for (tIndex2 = 0; tIndex2 &lt; tRun; tIndex2++) {
			NO_DBG_HEX(ulGetLong(tIndex2 * 4, aucFpage));
			iFodo = 2 * (int)ucGetByte(
				(tRun + 1) * 4 + tIndex2 * 7, aucFpage);
			if (iFodo &lt;= 0) {
				continue;
			}

			iLen = 2 * (int)ucGetByte(iFodo, aucFpage);

			usIstd = (USHORT)ucGetByte(iFodo + 1, aucFpage);
			vFillStyleFromStylesheet(usIstd, &amp;tStyle);
			vGet6StyleInfo(iFodo, aucFpage + 3, iLen - 3, &amp;tStyle);
			ulCharPos = ulGetLong(tIndex2 * 4, aucFpage);
			NO_DBG_HEX(ulCharPos);
			tStyle.ulFileOffset = ulCharPos2FileOffsetX(
				ulCharPos, &amp;tStyle.eListID);
			vAdd2StyleInfoList(&amp;tStyle);

			eRowInfo = eGet6RowInfo(iFodo,
					aucFpage + 3, iLen - 3, &amp;tRow);
			switch(eRowInfo) {
			case found_a_cell:
				if (ulCharPosFirst != CP_INVALID) {
					break;
				}
				ulCharPosFirst = ulGetLong(
						tIndex2 * 4, aucFpage);
				NO_DBG_HEX(ulCharPosFirst);
				tRow.ulCharPosStart = ulCharPosFirst;
				tRow.ulFileOffsetStart =
					ulCharPos2FileOffset(ulCharPosFirst);
				DBG_HEX_C(tRow.ulFileOffsetStart == FC_INVALID,
							ulCharPosFirst);
				break;
			case found_end_of_row:
				ulCharPosLast = ulGetLong(
						tIndex2 * 4, aucFpage);
				NO_DBG_HEX(ulCharPosLast);
				tRow.ulCharPosEnd = ulCharPosLast;
				tRow.ulFileOffsetEnd =
					ulCharPos2FileOffset(ulCharPosLast);
				DBG_HEX_C(tRow.ulFileOffsetEnd == FC_INVALID,
							ulCharPosLast);
				vAdd2RowInfoList(&amp;tRow);
				(void)memset(&amp;tRow, 0, sizeof(tRow));
				ulCharPosFirst = CP_INVALID;
				break;
			case found_nothing:
				break;
			default:
				DBG_DEC(eRowInfo);
				break;
			}
		}
	}
	ausParfPage = xfree(ausParfPage);
} /* end of vGet6PapInfo */

/*
 * Fill the font information block with information
 * from a Word 6/7 file.
 * Returns TRUE when successful, otherwise FALSE
 */
void
vGet6FontInfo(int iFodo, USHORT usIstd,
	const UCHAR *aucGrpprl, int iBytes, font_block_type *pFont)
{
	long	lTmp;
	int	iFodoOff, iInfoLen;
	USHORT	usTmp;
	UCHAR	ucTmp;

	TRACE_MSG("vGet6FontInfo");

	fail(iFodo &lt; 0 || aucGrpprl == NULL || pFont == NULL);

	iFodoOff = 0;
	while (iBytes &gt;= iFodoOff + 1) {
		switch (ucGetByte(iFodo + iFodoOff, aucGrpprl)) {
		case  65:	/* fRMarkDel */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			if (ucTmp == 0) {
				pFont-&gt;usFontStyle &amp;= ~FONT_MARKDEL;
			} else {
				pFont-&gt;usFontStyle |= FONT_MARKDEL;
			}
			break;
		case  80:	/* cIstd */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			NO_DBG_DEC(usTmp);
			break;
		case  82:	/* cDefault */
			pFont-&gt;usFontStyle &amp;= FONT_HIDDEN;
			pFont-&gt;ucFontColor = FONT_COLOR_DEFAULT;
			break;
		case  83:	/* cPlain */
			DBG_MSG("83: cPlain");
			vFillFontFromStylesheet(usIstd, pFont);
			break;
		case  85:	/* fBold */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_BOLD;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_BOLD;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_BOLD;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  86:	/* fItalic */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_ITALIC;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_ITALIC;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_ITALIC;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  87:	/* fStrike */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_STRIKE;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_STRIKE;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_STRIKE;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  90:	/* fSmallCaps */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_SMALL_CAPITALS;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_SMALL_CAPITALS;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_SMALL_CAPITALS;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  91:	/* fCaps */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_CAPITALS;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_CAPITALS;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_CAPITALS;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  92:	/* fVanish */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			switch (ucTmp) {
			case   0:	/* Unset */
				pFont-&gt;usFontStyle &amp;= ~FONT_HIDDEN;
				break;
			case   1:	/* Set */
				pFont-&gt;usFontStyle |= FONT_HIDDEN;
				break;
			case 128:	/* Unchanged */
				break;
			case 129:	/* Negation */
				pFont-&gt;usFontStyle ^= FONT_HIDDEN;
				break;
			default:
				DBG_DEC(ucTmp);
				DBG_FIXME();
				break;
			}
			break;
		case  93:	/* cFtc */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			if (usTmp &lt;= (USHORT)UCHAR_MAX) {
				pFont-&gt;ucFontNumber = (UCHAR)usTmp;
			} else {
				DBG_DEC(usTmp);
				DBG_FIXME();
				pFont-&gt;ucFontNumber = 0;
			}
			break;
		case  94:	/* cKul */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			if (ucTmp == 0 || ucTmp == 5) {
				pFont-&gt;usFontStyle &amp;= ~FONT_UNDERLINE;
			} else {
				NO_DBG_MSG("Underline text");
				pFont-&gt;usFontStyle |= FONT_UNDERLINE;
				if (ucTmp == 6) {
					DBG_MSG("Bold text");
					pFont-&gt;usFontStyle |= FONT_BOLD;
				}
			}
			break;
		case  95:	/* cHps, cHpsPos */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			DBG_DEC(ucTmp);
			if (ucTmp != 0) {
				pFont-&gt;usFontSize = (USHORT)ucTmp;
			}
			ucTmp = ucGetByte(iFodo + iFodoOff + 2, aucGrpprl);
			DBG_DEC(ucTmp);
			break;
		case  98:	/* cIco */
			pFont-&gt;ucFontColor =
				ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			break;
		case  99:	/* cHps */
			pFont-&gt;usFontSize =
				usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			break;
		case 100:	/* cHpsInc */
			DBG_MSG("100: sprmCHpsInc");
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			DBG_DEC(ucTmp);
			break;
		case 103:	/* cMajority */
			DBG_MSG("103: sprmCMajority");
			break;
		case 104:	/* cIss */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			ucTmp &amp;= 0x07;
			if (ucTmp == 1) {
				pFont-&gt;usFontStyle |= FONT_SUPERSCRIPT;
				NO_DBG_MSG("Superscript");
			} else if (ucTmp == 2) {
				pFont-&gt;usFontStyle |= FONT_SUBSCRIPT;
				NO_DBG_MSG("Subscript");
			}
			break;
		case 106:	/* cHpsInc1 */
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			lTmp = (long)pFont-&gt;usFontSize + (long)usTmp;
			if (lTmp &lt; 8) {
				pFont-&gt;usFontSize = 8;
			} else if (lTmp &gt; 32766) {
				pFont-&gt;usFontSize = 32766;
			} else {
				pFont-&gt;usFontSize = (USHORT)lTmp;
			}
			break;
		case 108:	/* cMajority50 */
			DBG_MSG("108: sprmCMajority50");
			break;
		case 109:	/* cHpsMul */
			DBG_MSG("109: sprmCHpsMul");
			usTmp = usGetWord(iFodo + iFodoOff + 1, aucGrpprl);
			DBG_DEC(usTmp);
			break;
		default:
			break;
		}
		iInfoLen = iGet6InfoLength(iFodo + iFodoOff, aucGrpprl);
		fail(iInfoLen &lt;= 0);
		iFodoOff += iInfoLen;
	}
} /* end of vGet6FontInfo */

/*
 * Fill the picture information block with information
 * from a Word 6/7 file.
 * Returns TRUE when successful, otherwise FALSE
 */
static BOOL
bGet6PicInfo(int iFodo,
	const UCHAR *aucGrpprl, int iBytes, picture_block_type *pPicture)
{
	int	iFodoOff, iInfoLen;
	BOOL	bFound;
	UCHAR	ucTmp;

	TRACE_MSG("vGet6PicInfo");

	fail(iFodo &lt; 0 || aucGrpprl == NULL || pPicture == NULL);

	iFodoOff = 0;
	bFound = FALSE;
	while (iBytes &gt;= iFodoOff + 1) {
		switch (ucGetByte(iFodo + iFodoOff, aucGrpprl)) {
		case  68:	/* fcPic */
			pPicture-&gt;ulPictureOffset = ulGetLong(
					iFodo + iFodoOff + 2, aucGrpprl);
			bFound = TRUE;
			break;
#if 0
		case  71:	/* fData */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			if (ucTmp == 0x01) {
				/* Not a picture, but a form field */
				return FALSE;
			}
			DBG_DEC_C(ucTmp != 0, ucTmp);
			break;
#endif
		case  75:	/* fOle2 */
			ucTmp = ucGetByte(iFodo + iFodoOff + 1, aucGrpprl);
			if (ucTmp == 0x01) {
				/* Not a picture, but an OLE object */
				return FALSE;
			}
			DBG_DEC_C(ucTmp != 0, ucTmp);
			break;
		default:
			break;
		}
		iInfoLen = iGet6InfoLength(iFodo + iFodoOff, aucGrpprl);
		fail(iInfoLen &lt;= 0);
		iFodoOff += iInfoLen;
	}
	return bFound;
} /* end of bGet6PicInfo */

/*
 * Build the lists with Character Information for Word 6/7 files
 */
void
vGet6ChrInfo(FILE *pFile, ULONG ulStartBlock,
	const ULONG *aulBBD, size_t tBBDLen, const UCHAR *aucHeader)
{
	font_block_type		tFont;
	picture_block_type	tPicture;
	USHORT	*ausCharPage;
	UCHAR	*aucBuffer;
	ULONG	ulFileOffset, ulCharPos, ulBeginCharInfo;
	size_t	tCharInfoLen, tOffset, tSize, tLenOld, tLen, tCharPageNum;
	size_t	tIndex, tIndex2, tRun;
	int	iFodo, iLen;
	USHORT	usCharFirstPage, usCount, usIstd;
	UCHAR	aucFpage[BIG_BLOCK_SIZE];

	fail(pFile == NULL || aucHeader == NULL);
	fail(ulStartBlock &gt; MAX_BLOCKNUMBER &amp;&amp; ulStartBlock != END_OF_CHAIN);
	fail(aulBBD == NULL);

	ulBeginCharInfo = ulGetLong(0xb8, aucHeader); /* fcPlcfbteChpx */
	NO_DBG_HEX(lBeginCharInfo);
	tCharInfoLen = (size_t)ulGetLong(0xbc, aucHeader); /* lcbPlcfbteChpx */
	NO_DBG_DEC(tCharInfoLen);
	if (tCharInfoLen &lt; 4) {
		DBG_DEC(tCharInfoLen);
		return;
	}

	aucBuffer = xmalloc(tCharInfoLen);
	if (!bReadBuffer(pFile, ulStartBlock,
			aulBBD, tBBDLen, BIG_BLOCK_SIZE,
			aucBuffer, ulBeginCharInfo, tCharInfoLen)) {
		aucBuffer = xfree(aucBuffer);
		return;
	}

	tLen = (tCharInfoLen - 4) / 6;
	ausCharPage = xcalloc(tLen, sizeof(USHORT));
	for (tIndex = 0, tOffset = (tLen + 1) * 4;
	     tIndex &lt; tLen;
	     tIndex++, tOffset += 2) {
		 ausCharPage[tIndex] = usGetWord(tOffset, aucBuffer);
		 NO_DBG_DEC(ausCharPage[tIndex]);
	}
	DBG_HEX(ulGetLong(0, aucBuffer));
	aucBuffer = xfree(aucBuffer);
	tCharPageNum = (size_t)usGetWord(0x18e, aucHeader); /* cpnBteChp */
	DBG_DEC(tCharPageNum);
	if (tLen &lt; tCharPageNum) {
		/* Replace CharPage by a longer version */
		tLenOld = tLen;
		usCharFirstPage = usGetWord(0x18a, aucHeader); /* pnChrFirst */
		DBG_DEC(usCharFirstPage);
		tLen += tCharPageNum - 1;
		tSize = tLen * sizeof(USHORT);
		ausCharPage = xrealloc(ausCharPage, tSize);
		/* Add new values */
		usCount = usCharFirstPage + 1;
		for (tIndex = tLenOld; tIndex &lt; tLen; tIndex++) {
			ausCharPage[tIndex] = usCount;
			NO_DBG_DEC(ausCharPage[tIndex]);
			usCount++;
		}
	}

	for (tIndex = 0; tIndex &lt; tLen; tIndex++) {
		if (!bReadBuffer(pFile, ulStartBlock,
				aulBBD, tBBDLen, BIG_BLOCK_SIZE,
				aucFpage,
				(ULONG)ausCharPage[tIndex] * BIG_BLOCK_SIZE,
				BIG_BLOCK_SIZE)) {
			break;
		}
		tRun = (size_t)ucGetByte(0x1ff, aucFpage);
		NO_DBG_DEC(tRun);
		for (tIndex2 = 0; tIndex2 &lt; tRun; tIndex2++) {
		  	ulCharPos = ulGetLong(tIndex2 * 4, aucFpage);
			ulFileOffset = ulCharPos2FileOffset(ulCharPos);
			iFodo = 2 * (int)ucGetByte(
				(tRun + 1) * 4 + tIndex2, aucFpage);

			iLen = (int)ucGetByte(iFodo, aucFpage);

			usIstd = usGetIstd(ulFileOffset);
			vFillFontFromStylesheet(usIstd, &amp;tFont);
			if (iFodo != 0) {
				vGet6FontInfo(iFodo, usIstd,
					aucFpage + 1, iLen - 1, &amp;tFont);
			}
			tFont.ulFileOffset = ulFileOffset;
			vAdd2FontInfoList(&amp;tFont);

			if (iFodo &lt;= 0) {
				continue;
			}

			(void)memset(&amp;tPicture, 0, sizeof(tPicture));
			if (bGet6PicInfo(iFodo, aucFpage + 1,
						iLen - 1, &amp;tPicture)) {
				tPicture.ulFileOffset = ulFileOffset;
				tPicture.ulFileOffsetPicture =
					ulDataPos2FileOffset(
						tPicture.ulPictureOffset);
				vAdd2PictInfoList(&amp;tPicture);
			}
		}
	}
	ausCharPage = xfree(ausCharPage);
} /* end of vGet6ChrInfo */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

