<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/antiword/sectlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/antiword/sectlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sectlist.c
 * Copyright (C) 2001-2004 A.J. van Os; Released under GNU GPL
 *
 * Description:
 * Build, read and destroy list(s) of Word section information
 */

#include &lt;stddef.h&gt;
#include &lt;string.h&gt;
#include "antiword.h"


/*
 * Private structure to hide the way the information
 * is stored from the rest of the program
 */
typedef struct section_mem_tag {
	section_block_type	tInfo;
	ULONG			ulCharPos;
	struct section_mem_tag	*pNext;
} section_mem_type;

/* Variables needed to write the Section Information List */
static section_mem_type	*pAnchor = NULL;
static section_mem_type	*pSectionLast = NULL;


/*
 * vDestroySectionInfoList - destroy the Section Information List
 */
void
vDestroySectionInfoList(void)
{
	section_mem_type	*pCurr, *pNext;

	DBG_MSG("vDestroySectionInfoList");

	/* Free the Section Information List */
	pCurr = pAnchor;
	while (pCurr != NULL) {
		pNext = pCurr-&gt;pNext;
		pCurr = xfree(pCurr);
		pCurr = pNext;
	}
	pAnchor = NULL;
	/* Reset all control variables */
	pSectionLast = NULL;
} /* end of vDestroySectionInfoList */

/*
 * vAdd2SectionInfoList - Add an element to the Section Information List
 */
void
vAdd2SectionInfoList(const section_block_type *pSection, ULONG ulCharPos)
{
	section_mem_type	*pListMember;

	fail(pSection == NULL);

	/* Create list member */
	pListMember = xmalloc(sizeof(section_mem_type));
	/* Fill the list member */
	pListMember-&gt;tInfo = *pSection;
	pListMember-&gt;ulCharPos = ulCharPos;
	pListMember-&gt;pNext = NULL;
	/* Add the new member to the list */
	if (pAnchor == NULL) {
		pAnchor = pListMember;
	} else {
		fail(pSectionLast == NULL);
		pSectionLast-&gt;pNext = pListMember;
	}
	pSectionLast = pListMember;
} /* vAdd2SectionInfoList */

/*
 * vGetDefaultSection - fill the section struct with default values
 */
void
vGetDefaultSection(section_block_type *pSection)
{
	(void)memset(pSection, 0, sizeof(*pSection));
	pSection-&gt;bNewPage = TRUE;
} /* end of vGetDefaultSection */

/*
 * vDefault2SectionInfoList - Add a default to the Section Information List
 */
void
vDefault2SectionInfoList(ULONG ulCharPos)
{
	section_block_type	tSection;

	vGetDefaultSection(&amp;tSection);
	vAdd2SectionInfoList(&amp;tSection, ulCharPos);
} /* end of vDefault2SectionInfoList */

/*
 * pGetSectionInfo - get the section information
 */
const section_block_type *
pGetSectionInfo(const section_block_type *pOld, ULONG ulCharPos)
{
	const section_mem_type	*pCurr;

	if (pOld == NULL || ulCharPos == 0) {
		if (pAnchor == NULL) {
			/* There are no records, make one */
			vDefault2SectionInfoList(0);
			fail(pAnchor == NULL);
		}
		/* The first record */
		NO_DBG_MSG("First record");
		return &amp;pAnchor-&gt;tInfo;
	}

	NO_DBG_HEX(ulCharPos);
	for (pCurr = pAnchor; pCurr != NULL; pCurr = pCurr-&gt;pNext) {
		NO_DBG_HEX(pCurr-&gt;ulCharPos);
		if (ulCharPos == pCurr-&gt;ulCharPos ||
		    ulCharPos + 1 == pCurr-&gt;ulCharPos) {
			NO_DBG_HEX(pCurr-&gt;ulCharPos);
			return &amp;pCurr-&gt;tInfo;
		}
	}
	return pOld;
} /* end of pGetSectionInfo */

/*
 * tGetNumberOfSections - get the number of sections
 */
size_t
tGetNumberOfSections(void)
{
	const section_mem_type	*pCurr;
	size_t	tCounter;

	for (tCounter = 0, pCurr = pAnchor;
	     pCurr != NULL;
	     tCounter++, pCurr = pCurr-&gt;pNext)
		;	/* Empty */
	return tCounter;
} /* end of tGetNumberOfSections */

/*
 * ucGetSepHdrFtrSpecification - get the Heder/footer specification
 */
UCHAR
ucGetSepHdrFtrSpecification(size_t tSectionNumber)
{
	const section_mem_type	*pCurr;
	size_t	tIndex;

	for (tIndex = 0, pCurr = pAnchor;
	     tIndex &lt; tSectionNumber &amp;&amp; pCurr != NULL;
	     tIndex++, pCurr = pCurr-&gt;pNext)
		;	/* Empty */
	if (pCurr == NULL) {
		DBG_DEC(tSectionNumber);
		DBG_FIXME();
		return 0x00;
	}
	return pCurr-&gt;tInfo.ucHdrFtrSpecification;
} /* end of ucGetSepHdrFtrSpecification */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

