<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/cddb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/cddb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;

char *server = "freedb.freedb.org";

int debug;
#define DPRINT if(debug)fprint
int tflag;
int Tflag;

typedef struct Track Track;
struct Track {
	int n;
	char *title;
};

enum {
	MTRACK = 64,
};

typedef struct Toc Toc;
struct Toc {
	ulong diskid;
	int ntrack;
	char *title;
	Track track[MTRACK];
};

void*
emalloc(uint n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		sysfatal("can't malloc: %r");
	memset(p, 0, n);
	return p;
}

char*
estrdup(char *s)
{
	char *t;

	t = emalloc(strlen(s)+1);
	strcpy(t, s);
	return t;
}

static void
dumpcddb(Toc *t)
{
	int i, n, s;

	print("title	%s\n", t-&gt;title);
	for(i=0; i&lt;t-&gt;ntrack; i++){
		if(tflag){
			n = t-&gt;track[i+1].n;
			if(i == t-&gt;ntrack-1)
				n *= 75;
			s = (n - t-&gt;track[i].n)/75;
			print("%d\t%s\t%d:%2.2d\n", i+1, t-&gt;track[i].title, s/60, s%60);
		}
		else
			print("%d\t%s\n", i+1, t-&gt;track[i].title);
	}
	if(Tflag){
		s = t-&gt;track[i].n;
		print("Total time: %d:%2.2d\n", s/60, s%60);
	}
}

char*
append(char *a, char *b)
{
	char *c;

	c = emalloc(strlen(a)+strlen(b)+1);
	strcpy(c, a);
	strcat(c, b);
	return c;
}

static int
cddbfilltoc(Toc *t)
{
	int fd;
	int i;
	char *p, *q;
	Biobuf bin;
	char *f[10];
	int nf;
	char *id, *categ;

	fd = dial(netmkaddr(server, "tcp", "888"), 0, 0, 0);
	if(fd &lt; 0) {
		fprint(2, "%s: %s: cannot dial: %r\n", argv0, server);
		return -1;
	}
	Binit(&amp;bin, fd, OREAD);

	if((p=Brdline(&amp;bin, '\n')) == nil || atoi(p)/100 != 2) {
	died:
		close(fd);
		Bterm(&amp;bin);
		fprint(2, "%s: error talking to cddb server %s\n",
			argv0, server);
		if(p) {
			p[Blinelen(&amp;bin)-1] = 0;
			fprint(2, "%s: server says: %s\n", argv0, p);
		}
		return -1;
	}

	fprint(fd, "cddb hello gre plan9 9cd 1.0\r\n");
	if((p = Brdline(&amp;bin, '\n')) == nil || atoi(p)/100 != 2)
		goto died;

	/*
	 *	Protocol level 6 is the same as level 5 except that
	 *	the character set is now UTF-8 instead of ISO-8859-1. 
 	 */
	fprint(fd, "proto 6\r\n");
	DPRINT(2, "proto 6\r\n");
	if((p = Brdline(&amp;bin, '\n')) == nil || atoi(p)/100 != 2)
		goto died;
	p[Blinelen(&amp;bin)-1] = 0;
	DPRINT(2, "cddb: %s\n", p);

	fprint(fd, "cddb query %8.8lux %d", t-&gt;diskid, t-&gt;ntrack);
	DPRINT(2, "cddb query %8.8lux %d", t-&gt;diskid, t-&gt;ntrack);
	for(i=0; i&lt;t-&gt;ntrack; i++) {
		fprint(fd, " %d", t-&gt;track[i].n);
		DPRINT(2, " %d", t-&gt;track[i].n);
	}
	fprint(fd, " %d\r\n", t-&gt;track[t-&gt;ntrack].n);
	DPRINT(2, " %d\r\n", t-&gt;track[t-&gt;ntrack].n);

	if((p = Brdline(&amp;bin, '\n')) == nil || atoi(p)/100 != 2)
		goto died;
	p[Blinelen(&amp;bin)-1] = 0;
	DPRINT(2, "cddb: %s\n", p);
	nf = tokenize(p, f, nelem(f));
	if(nf &lt; 1)
		goto died;

	switch(atoi(f[0])) {
	case 200:	/* exact match */
		if(nf &lt; 3)
			goto died;
		categ = f[1];
		id = f[2];
		break;
	case 210:	/* exact matches */
	case 211:	/* close matches */
		if((p = Brdline(&amp;bin, '\n')) == nil)
			goto died;
		if(p[0] == '.')	/* no close matches? */
			goto died;
		p[Blinelen(&amp;bin)-1] = '\0';

		/* accept first match */
		nf = tokenize(p, f, nelem(f));
		if(nf &lt; 2)
			goto died;
		categ = f[0];
		id = f[1];

		/* snarf rest of buffer */
		while(p[0] != '.') {
			if((p = Brdline(&amp;bin, '\n')) == nil)
				goto died;
			p[Blinelen(&amp;bin)-1] = '\0';
			DPRINT(2, "cddb: %s\n", p);
		}
		break;
	case 202: /* no match */
	default:
		goto died;
	}

	t-&gt;title = "";
	for(i=0; i&lt;t-&gt;ntrack; i++)
		t-&gt;track[i].title = "";

	/* fetch results for this cd */
	fprint(fd, "cddb read %s %s\r\n", categ, id);
	do {
		if((p = Brdline(&amp;bin, '\n')) == nil)
			goto died;
		q = p+Blinelen(&amp;bin)-1;
		while(isspace(*q))
			*q-- = 0;
DPRINT(2, "cddb %s\n", p);
		if(strncmp(p, "DTITLE=", 7) == 0)
			t-&gt;title = append(t-&gt;title, p+7);
		else if(strncmp(p, "TTITLE", 6) == 0 &amp;&amp; isdigit(p[6])) {
			i = atoi(p+6);
			if(i &lt; t-&gt;ntrack) {
				p += 6;
				while(isdigit(*p))
					p++;
				if(*p == '=')
					p++;

				t-&gt;track[i].title = append(t-&gt;track[i].title, estrdup(p));
			}
		} 
	} while(*p != '.');

	fprint(fd, "quit\r\n");
	close(fd);
	Bterm(&amp;bin);

	return 0;
}

void
usage(void)
{
	fprint(2, "usage: aux/cddb [-DTt] [-s server] query diskid n ...\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i;
	Toc toc;

	ARGBEGIN{
	case 'D':
		debug = 1;
		break;
	case 's':
		server = EARGF(usage());
		break;
	case 'T':
		Tflag = 1;
		/*FALLTHROUGH*/
	case 't':
		tflag = 1;
		break;
	}ARGEND

	if(argc &lt; 3 || strcmp(argv[0], "query") != 0)
		usage();

	toc.diskid = strtoul(argv[1], 0, 16);
	toc.ntrack = atoi(argv[2]);
	if(argc != 3+toc.ntrack+1)
		sysfatal("argument count does not match given ntrack");

	for(i=0; i&lt;=toc.ntrack; i++)
		toc.track[i].n = atoi(argv[3+i]);

	if(cddbfilltoc(&amp;toc) &lt; 0)
		exits("whoops");

	dumpcddb(&amp;toc);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

