<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/consolefs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/consolefs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;thread.h&gt;

/*
 *  This fs presents a 1 level file system.  It contains
 *  up to three files per console (xxx and xxxctl and xxxstat)
 */

typedef struct Console Console;
typedef struct Fid Fid;
typedef struct Request Request;
typedef struct Reqlist Reqlist;
typedef struct Fs Fs;

enum
{
	/* last 5 bits of qid.path */
	Textern=	0,		/* fake parent of top level */
	Ttopdir,			/* top level directory */
	Qctl,
	Qstat,
	Qdata,

	Bufsize=	32*1024,	/* chars buffered per reader */
	Maxcons=	64,		/* maximum consoles */
	Nhash=		64,		/* Fid hash buckets */
};

#define TYPE(x)		(((ulong)x.path) &amp; 0xf)
#define CONS(x)		((((ulong)x.path) &gt;&gt; 4)&amp;0xfff)
#define QID(c, x)	(((c)&lt;&lt;4) | (x))

struct Request
{
	Request	*next;
	Fid	*fid;
	Fs	*fs;
	Fcall	f;
	uchar	buf[1];
};

struct Reqlist
{
	Lock;
	Request	*first;
	Request *last;
};

struct Fid
{
	Lock;
	Fid	*next;			/* hash list */
	Fid	*cnext;			/* list of Fid's on a console */
	int	fid;
	int	ref;

	int	attached;
	int	open;
	char	*user;
	char	mbuf[Bufsize];		/* message */
	int	bufn;
	int	used;
	Qid	qid;

	Console	*c;

	char	buf[Bufsize];
	char	*rp;
	char	*wp;

	Reqlist	r;			/* active read requests */
};

struct Console
{
	Lock;

	char	*name;
	char	*dev;
	int	speed;
	int	cronly;
	int	ondemand;		/* open only on demand */
	int	chat;			/* chat consoles are special */

	int	pid;			/* pid of reader */

	int	fd;
	int	cfd;
	int	sfd;

	Fid	*flist;			/* open fids to broadcast to */
};

struct Fs
{
	Lock;

	int	fd;			/* to kernel mount point */
	int	messagesize;
	Fid	*hash[Nhash];
	Console	*cons[Maxcons];
	int	ncons;
};

extern	void	console(Fs*, char*, char*, int, int, int);
extern	Fs*	fsmount(char*);

extern	void	fsreader(void*);
extern	void	fsrun(void*);
extern	Fid*	fsgetfid(Fs*, int);
extern	void	fsputfid(Fs*, Fid*);
extern	int	fsdirgen(Fs*, Qid, int, Dir*, uchar*, int);
extern	void	fsreply(Fs*, Request*, char*);
extern	void	fskick(Fs*, Fid*);
extern	int	fsreopen(Fs*, Console*);

extern	void	fsversion(Fs*, Request*, Fid*);
extern	void	fsflush(Fs*, Request*, Fid*);
extern	void	fsauth(Fs*, Request*, Fid*);
extern	void	fsattach(Fs*, Request*, Fid*);
extern	void	fswalk(Fs*, Request*, Fid*);
extern	void	fsclwalk(Fs*, Request*, Fid*);
extern	void	fsopen(Fs*, Request*, Fid*);
extern	void	fscreate(Fs*, Request*, Fid*);
extern	void	fsread(Fs*, Request*, Fid*);
extern	void	fswrite(Fs*, Request*, Fid*);
extern	void	fsclunk(Fs*, Request*, Fid*);
extern	void	fsremove(Fs*, Request*, Fid*);
extern	void	fsstat(Fs*, Request*, Fid*);
extern	void	fswstat(Fs*, Request*, Fid*);


void 	(*fcall[])(Fs*, Request*, Fid*) =
{
	[Tflush]	fsflush,
	[Tversion]	fsversion,
	[Tauth]	fsauth,
	[Tattach]	fsattach,
	[Twalk]		fswalk,
	[Topen]		fsopen,
	[Tcreate]	fscreate,
	[Tread]		fsread,
	[Twrite]	fswrite,
	[Tclunk]	fsclunk,
	[Tremove]	fsremove,
	[Tstat]		fsstat,
	[Twstat]	fswstat
};

char Eperm[] = "permission denied";
char Eexist[] = "file does not exist";
char Enotdir[] = "not a directory";
char Eisopen[] = "file already open";
char Ebadcount[] = "bad read/write count";
char Enofid[] = "no such fid";

char *consoledb = "/lib/ndb/consoledb";
char *mntpt = "/mnt/consoles";

int messagesize = 8192+IOHDRSZ;

void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[1024];

	write(2, "consolefs: ", 10);
	va_start(arg, fmt);
	vseprint(buf, buf+1024, fmt, arg);
	va_end(arg);
	write(2, buf, strlen(buf));
	write(2, "\n", 1);
	threadexitsall(fmt);
}


void*
emalloc(uint n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		fatal("malloc failed: %r");
	memset(p, 0, n);
	return p;
}

int debug;
Ndb *db;

/*
 *  any request that can get queued for a delayed reply
 */
Request*
allocreq(Fs *fs, int bufsize)
{
	Request *r;

	r = emalloc(sizeof(Request)+bufsize);
	r-&gt;fs = fs;
	r-&gt;next = nil;
	return r;
}

/*
 *  for maintaining lists of requests
 */
void
addreq(Reqlist *l, Request *r)
{
	lock(l);
	if(l-&gt;first == nil)
		l-&gt;first = r;
	else
		l-&gt;last-&gt;next = r;
	l-&gt;last = r;
	r-&gt;next = nil;
	unlock(l);
}

/*
 *  remove the first request from a list of requests
 */
Request*
remreq(Reqlist *l)
{
	Request *r;

	lock(l);
	r = l-&gt;first;
	if(r != nil)
		l-&gt;first = r-&gt;next;
	unlock(l);
	return r;
}

/*
 *  remove a request with the given tag from a list of requests
 */
Request*
remtag(Reqlist *l, int tag)
{
	Request *or, **ll;

	lock(l);
	ll = &amp;l-&gt;first;
	for(or = *ll; or; or = or-&gt;next){
		if(or-&gt;f.tag == tag){
			*ll = or-&gt;next;
			unlock(l);
			return or;
		}
		ll = &amp;or-&gt;next;
	}
	unlock(l);
	return nil;
}

Qid
parentqid(Qid q)
{
	if(q.type &amp; QTDIR)
		return (Qid){QID(0, Textern), 0, QTDIR};
	else
		return (Qid){QID(0, Ttopdir), 0, QTDIR};
}

int
fsdirgen(Fs *fs, Qid parent, int i, Dir *d, uchar *buf, int nbuf)
{
	static char name[64];
	char *p;
	int xcons;

	d-&gt;uid = d-&gt;gid = d-&gt;muid = "network";
	d-&gt;length = 0;
	d-&gt;atime = time(nil);
	d-&gt;mtime = d-&gt;atime;
	d-&gt;type = 'C';
	d-&gt;dev = '0';

	switch(TYPE(parent)){
	case Textern:
		if(i != 0)
			return -1;
		p = "consoles";
		d-&gt;mode = DMDIR|0555;
		d-&gt;qid.type = QTDIR;
		d-&gt;qid.path = QID(0, Ttopdir);
		d-&gt;qid.vers = 0;
		break;
	case Ttopdir:
		xcons = i/3;
		if(xcons &gt;= fs-&gt;ncons)
			return -1;
		p = fs-&gt;cons[xcons]-&gt;name;
		switch(i%3){
		case 0:
			if(fs-&gt;cons[xcons]-&gt;cfd &lt; 0)
				return 0;
			snprint(name, sizeof name, "%sctl", p);
			p = name;
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = QID(xcons, Qctl);
			d-&gt;qid.vers = 0;
			break;
		case 1:
			if(fs-&gt;cons[xcons]-&gt;sfd &lt; 0)
				return 0;
			snprint(name, sizeof name, "%sstat", p);
			p = name;
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = QID(xcons, Qstat);
			d-&gt;qid.vers = 0;
			break;
		case 2:
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = QID(xcons, Qdata);
			d-&gt;qid.vers = 0;
			break;
		}
		d-&gt;mode = 0666;
		break;
	default:
		return -1;
	}
	d-&gt;name = p;
	if(buf != nil)
		return convD2M(d, buf, nbuf);
	return 1;
}

/*
 *  mount the user interface and start a request processor
 */
Fs*
fsmount(char *mntpt)
{
	Fs *fs;
	int pfd[2], srv;
	char buf[32];
	int n;
	static void *v[2];

	fs = emalloc(sizeof(Fs));

	if(pipe(pfd) &lt; 0)
		fatal("opening pipe: %r");

	/* start up the file system process */
	v[0] = fs;
	v[1] = pfd;
	proccreate(fsrun, v, 16*1024);

	/* Typically mounted before /srv exists */
	if(access("#s/consoles", AEXIST) &lt; 0){
		srv = create("#s/consoles", OWRITE, 0666);
		if(srv &lt; 0)
			fatal("post: %r");

		n = sprint(buf, "%d", pfd[1]);
		if(write(srv, buf, n) &lt; 0)
			fatal("write srv: %r");

		close(srv);
	}

	mount(pfd[1], -1, mntpt, MBEFORE, "");
	close(pfd[1]);
	return fs;
}

/*
 *  reopen a console
 */
int
fsreopen(Fs* fs, Console *c)
{
	char buf[128];
	static void *v[2];

	if(c-&gt;pid){
		if(postnote(PNPROC, c-&gt;pid, "reopen") != 0)
			fprint(2, "postnote failed: %r\n");
		c-&gt;pid = 0;
	}

	if(c-&gt;fd &gt;= 0){
		close(c-&gt;fd);
		close(c-&gt;cfd);
		close(c-&gt;sfd);
		c-&gt;cfd = -1;
		c-&gt;fd = -1;
		c-&gt;sfd = -1;
	}

	if(c-&gt;flist == nil &amp;&amp; c-&gt;ondemand)
		return 0;

	c-&gt;fd = open(c-&gt;dev, ORDWR);
	if(c-&gt;fd &lt; 0)
		return -1;

	snprint(buf, sizeof(buf), "%sctl", c-&gt;dev);
	c-&gt;cfd = open(buf, ORDWR);
	fprint(c-&gt;cfd, "b%d", c-&gt;speed);

	snprint(buf, sizeof(buf), "%sstat", c-&gt;dev);
	c-&gt;sfd = open(buf, OREAD);

	v[0] = fs;
	v[1] = c;
	proccreate(fsreader, v, 16*1024);

	return 0;
}

void
change(Fs *fs, Console *c, int doreopen, int speed, int cronly, int ondemand)
{
	lock(c);

	if(speed != c-&gt;speed){
		c-&gt;speed = speed;
		doreopen = 1;
	}
	if(ondemand != c-&gt;ondemand){
		c-&gt;ondemand = ondemand;
		doreopen = 1;
	}
	c-&gt;cronly = cronly;
	if(doreopen)
		fsreopen(fs, c);

	unlock(c);
}

/*
 *  create a console interface
 */
void
console(Fs* fs, char *name, char *dev, int speed, int cronly, int ondemand)
{
	Console *c;
	char *x;
	int i, doreopen;

	if(fs-&gt;ncons &gt;= Maxcons)
		fatal("too many consoles, too little time");

	doreopen = 0;
	for(i = 0; i &lt; fs-&gt;ncons; i++){
		c = fs-&gt;cons[i];
		if(strcmp(name, c-&gt;name) == 0){
			if(strcmp(dev, c-&gt;dev) != 0){
				/* new device */
				x = c-&gt;dev;
				c-&gt;dev = strdup(dev);
				free(x);
				doreopen = 1;
			}
			change(fs, c, doreopen, speed, cronly, ondemand);
			return;
		}
	}
#ifdef sapedoesntlikethis
	/*
	 * The code below prevents this from working.  I can't
	 * think of scenarios where the code below actually helps
	 *	Sape
	 *
	 * console=borneo dev=/dev/eia1
	 * 	speed=9600
	 * 	openondemand=1
	 * console=tottie dev=/dev/eia1
	 * 	speed=115200
	 * 	openondemand=1
	 */
	for(i = 0; i &lt; fs-&gt;ncons; i++){
		c = fs-&gt;cons[i];
		if(strcmp(dev, c-&gt;dev) == 0){
			/* at least a rename */
			x = c-&gt;name;
			c-&gt;name = strdup(name);
			free(x);
			change(fs, c, doreopen, speed, cronly, ondemand);
			return;
		}
	}
#endif
	c = emalloc(sizeof(Console));
	fs-&gt;cons[fs-&gt;ncons] = c;
	fs-&gt;ncons++;
	c-&gt;name = strdup(name);
	c-&gt;dev = strdup(dev);
	if(strcmp(c-&gt;dev, "/dev/null") == 0) 
		c-&gt;chat = 1;
	else 
		c-&gt;chat = 0;
	c-&gt;fd = -1;
	c-&gt;cfd = -1;
	c-&gt;sfd = -1;
	change(fs, c, 1, speed, cronly, ondemand);
}

/*
 *  buffer data from console to a client.
 *  circular q with writer able to catch up to reader.
 *  the reader may miss data but always sees an in order sequence.
 */
void
fromconsole(Fid *f, char *p, int n)
{
	char *rp, *wp, *ep;
	int pass;

	lock(f);
	rp = f-&gt;rp;
	wp = f-&gt;wp;
	ep = f-&gt;buf + sizeof(f-&gt;buf);
	pass = 0;
	while(n--){
		*wp++ = *p++;
		if(wp &gt;= ep)
			wp = f-&gt;buf;
		if(rp == wp)
			pass = 1;
	}
	f-&gt;wp = wp;

	/*  we overtook the read pointer, push it up so readers always
	 *  see the tail of what was written
	 */
	if(pass){
		wp++;
		if(wp &gt;= ep)
			f-&gt;rp = f-&gt;buf;
		else
			f-&gt;rp = wp;
	}
	unlock(f);
}

/*
 *  broadcast a list of members to all listeners
 */
void
bcastmembers(Fs *fs, Console *c, char *msg, Fid *f)
{
	int n;
	Fid *fl;
	char buf[512];

	sprint(buf, "[%s%s", msg, f-&gt;user);
	for(fl = c-&gt;flist; fl != nil &amp;&amp; strlen(buf) + 64 &lt; sizeof(buf); fl = fl-&gt;cnext){
		if(f == fl)
			continue;
		strcat(buf, ", ");
		strcat(buf, fl-&gt;user);
	}
	strcat(buf, "]\n");

	n = strlen(buf);
	for(fl = c-&gt;flist; fl; fl = fl-&gt;cnext){
		fromconsole(fl, buf, n);
		fskick(fs, fl);
	}
}

void
handler(void*, char *msg)
{
	if(strstr(msg, "reopen") != nil ||
	   strstr(msg, "write on closed pipe") != nil)
		noted(NCONT);
	noted(NDFLT);
}

/*
 *  a process to read console output and broadcast it (one per console)
 */
void
fsreader(void *v)
{
	int n;
	Fid *fl;
	char buf[1024];
	Fs *fs;
	Console *c;
	void **a;

	a = v;
	fs = a[0];
	c = a[1];
	c-&gt;pid = getpid();
	notify(handler);
	if(c-&gt;chat)
		threadexits(nil);
	for(;;){
		n = read(c-&gt;fd, buf, sizeof(buf));
		if(n &lt; 0)
			break;
		lock(c);
		for(fl = c-&gt;flist; fl; fl = fl-&gt;cnext){
			fromconsole(fl, buf, n);
			fskick(fs, fl);
		}
		unlock(c);
	}
}

void
readdb(Fs *fs)
{
	Ndbtuple *t, *nt;
	char *dev, *cons;
	int cronly, speed, ondemand;

	ndbreopen(db);

	/* start a listener for each console */
	for(;;){
		t = ndbparse(db);
		if(t == nil)
			break;
		dev = nil;
		cons = nil;
		speed = 9600;
		cronly = 0;
		ondemand = 0;
		for(nt = t; nt; nt = nt-&gt;entry){
			if(strcmp(nt-&gt;attr, "console") == 0)
				cons = nt-&gt;val;
			else if(strcmp(nt-&gt;attr, "dev") == 0)
				dev = nt-&gt;val;
			else if(strcmp(nt-&gt;attr, "speed") == 0)
				speed = atoi(nt-&gt;val);
			else if(strcmp(nt-&gt;attr, "cronly") == 0)
				cronly = 1;
			else if(strcmp(nt-&gt;attr, "openondemand") == 0)
				ondemand = 1;
		}
		if(dev != nil &amp;&amp; cons != nil)
			console(fs, cons, dev, speed, cronly, ondemand);
		ndbfree(t);
	}
}

int dbmtime;

/*
 *  a request processor (one per Fs)
 */
void
fsrun(void *v)
{
	int n, t;
	Request *r;
	Fid *f;
	Dir *d;
	void **a = v;
	Fs* fs;
	int *pfd;

	fs = a[0];
	pfd = a[1];
	fs-&gt;fd = pfd[0];
	notify(handler);
	for(;;){
		d = dirstat(consoledb);
		if(d != nil &amp;&amp; d-&gt;mtime != dbmtime){
			dbmtime = d-&gt;mtime;
			readdb(fs);
		}
		free(d);
		r = allocreq(fs, messagesize);
		n = read9pmsg(fs-&gt;fd, r-&gt;buf, messagesize);
		if(n &lt;= 0)
			fatal("unmounted");

		if(convM2S(r-&gt;buf, n, &amp;r-&gt;f) == 0){
			fprint(2, "can't convert %ux %ux %ux\n", r-&gt;buf[0],
				r-&gt;buf[1], r-&gt;buf[2]);
			free(r);
			continue;
		}


		f = fsgetfid(fs, r-&gt;f.fid);
		r-&gt;fid = f;
		if(debug)
			fprint(2, "%F path %llux\n", &amp;r-&gt;f, f-&gt;qid.path);

		t = r-&gt;f.type;
		r-&gt;f.type++;
		(*fcall[t])(fs, r, f);
	}
}

Fid*
fsgetfid(Fs *fs, int fid)
{
	Fid *f, *nf;

	lock(fs);
	for(f = fs-&gt;hash[fid%Nhash]; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			f-&gt;ref++;
			unlock(fs);
			return f;
		}
	}

	nf = emalloc(sizeof(Fid));
	nf-&gt;next = fs-&gt;hash[fid%Nhash];
	fs-&gt;hash[fid%Nhash] = nf;
	nf-&gt;fid = fid;
	nf-&gt;ref = 1;
	nf-&gt;wp = nf-&gt;buf;
	nf-&gt;rp = nf-&gt;wp;
	unlock(fs);
	return nf;
}

void
fsputfid(Fs *fs, Fid *f)
{
	Fid **l, *nf;

	lock(fs);
	if(--f-&gt;ref &gt; 0){
		unlock(fs);
		return;
	}
	for(l = &amp;fs-&gt;hash[f-&gt;fid%Nhash]; nf = *l; l = &amp;nf-&gt;next)
		if(nf == f){
			*l = f-&gt;next;
			break;
		}
	unlock(fs);
	free(f-&gt;user);
	free(f);
}

void
fsauth(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, "consolefs: authentication not required");
}

void
fsversion(Fs *fs, Request *r, Fid*)
{

	if(r-&gt;f.msize &lt; 256){
		fsreply(fs, r, "message size too small");
		return;
	}
	messagesize = r-&gt;f.msize;
	if(messagesize &gt; 8192+IOHDRSZ)
		messagesize = 8192+IOHDRSZ;
	r-&gt;f.msize = messagesize;
	if(strncmp(r-&gt;f.version, "9P2000", 6) != 0){
		fsreply(fs, r, "unrecognized 9P version");
		return;
	}
	r-&gt;f.version = "9P2000";

	fsreply(fs, r, nil);
}

void
fsflush(Fs *fs, Request *r, Fid *f)
{
	Request *or;

	or = remtag(&amp;f-&gt;r, r-&gt;f.oldtag);
	if(or != nil){
		fsputfid(fs, or-&gt;fid);
		free(or);
	}
	fsreply(fs, r, nil);
}

void
fsattach(Fs *fs, Request *r, Fid *f)
{
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.path = QID(0, Ttopdir);
	f-&gt;qid.vers = 0;

	if(r-&gt;f.uname[0])
		f-&gt;user = strdup(r-&gt;f.uname);
	else
		f-&gt;user = strdup("none");

	/* hold down the fid till the clunk */
	f-&gt;attached = 1;
	lock(fs);
	f-&gt;ref++;
	unlock(fs);

	r-&gt;f.qid = f-&gt;qid;
	fsreply(fs, r, nil);
}

void
fswalk(Fs *fs, Request *r, Fid *f)
{
	char *name;
	Dir d;
	int i, n, nqid, nwname;
	Qid qid, wqid[MAXWELEM];
	Fid *nf;
	char *err;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}

	nf = nil;
	if(r-&gt;f.fid != r-&gt;f.newfid){
		nf = fsgetfid(fs, r-&gt;f.newfid);
		nf-&gt;attached = f-&gt;attached;
		nf-&gt;open = f-&gt;open;
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;user = strdup(f-&gt;user);
		nf-&gt;c = f-&gt;c;
		nf-&gt;wp = nf-&gt;buf;
		nf-&gt;rp = nf-&gt;wp;
		f = nf;
	}

	qid = f-&gt;qid;
	err = nil;
	nwname = r-&gt;f.nwname;
	nqid = 0;
	if(nwname &gt; 0){
		for(; err == nil &amp;&amp; nqid &lt; nwname; nqid++){
			if(nqid &gt;= MAXWELEM){
				err = "too many name elements";
				break;
			}
			name = r-&gt;f.wname[nqid];
			if(strcmp(name, "..") == 0)
				qid = parentqid(qid);
			else if(strcmp(name, ".") != 0){
				for(i = 0; ; i++){
					n = fsdirgen(fs, qid, i, &amp;d, nil, 0);
					if(n &lt; 0){
						err = Eexist;
						break;
					}
					if(n &gt; 0 &amp;&amp; strcmp(name, d.name) == 0){
						qid = d.qid;
						break;
					}
				}
			}
			wqid[nqid] = qid;
		}
		if(nf != nil &amp;&amp; nqid &lt; nwname)
			fsputfid(fs, nf);
		if(nqid == nwname)
			f-&gt;qid = qid;
	}

	memmove(r-&gt;f.wqid, wqid, nqid*sizeof(Qid));
	r-&gt;f.nwqid = nqid;
	fsreply(fs, r, err);
}

int
ingroup(char *user, char *group)
{
	Ndbtuple *t, *nt;
	Ndbs s;

	t = ndbsearch(db, &amp;s, "group", group);
	if(t == nil)
		return 0;
	for(nt = t; nt; nt = nt-&gt;entry){
		if(strcmp(nt-&gt;attr, "uid") == 0)
		if(strcmp(nt-&gt;val, user) == 0)
			break;
	}
	ndbfree(t);
	return nt != nil;
}

int
userok(char *u, char *cname)
{
	Ndbtuple *t, *nt;
	Ndbs s;

	t = ndbsearch(db, &amp;s, "console", cname);
	if(t == nil)
		return 0;

	for(nt = t; nt; nt = nt-&gt;entry){
		if(strcmp(nt-&gt;attr, "uid") == 0)
		if(strcmp(nt-&gt;val, u) == 0)
			break;
		if(strcmp(nt-&gt;attr, "gid") == 0)
		if(ingroup(u, nt-&gt;val))
			break;
	}
	ndbfree(t);

	return nt != nil;
}

int m2p[] ={
	[OREAD]		4,
	[OWRITE]	2,
	[ORDWR]		6
};

/*
 *  broadcast a message to all listeners
 */
void
bcastmsg(Fs *fs, Console *c, char *msg, int n)
{
	Fid *fl;

	for(fl = c-&gt;flist; fl; fl = fl-&gt;cnext){
		fromconsole(fl, msg, n);
		fskick(fs, fl);
	}
}

void
fsopen(Fs *fs, Request *r, Fid *f)
{
	int mode;
	Console *c;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}

	if(f-&gt;open){
		fsreply(fs, r, Eisopen);
		return;
	}

	mode = r-&gt;f.mode &amp; 3;

	if((QTDIR &amp; f-&gt;qid.type) &amp;&amp; mode != OREAD){
		fsreply(fs, r, Eperm);
		return;
	}

	switch(TYPE(f-&gt;qid)){
	case Qdata:
		c = fs-&gt;cons[CONS(f-&gt;qid)];
		if(!userok(f-&gt;user, c-&gt;name)){
			fsreply(fs, r, Eperm);
			return;
		}
		f-&gt;rp = f-&gt;buf;
		f-&gt;wp = f-&gt;buf;
		f-&gt;c = c;
		lock(c);
		sprint(f-&gt;mbuf, "[%s] ", f-&gt;user);
		f-&gt;bufn = strlen(f-&gt;mbuf);
		f-&gt;used = 0;
		f-&gt;cnext = c-&gt;flist;
		c-&gt;flist = f;
		bcastmembers(fs, c, "+", f);
		if(c-&gt;pid == 0)
			fsreopen(fs, c);
		unlock(c);
		break;
	case Qctl:
		c = fs-&gt;cons[CONS(f-&gt;qid)];
		if(!userok(f-&gt;user, c-&gt;name)){
			fsreply(fs, r, Eperm);
			return;
		}
		f-&gt;c = c;
		break;
	case Qstat:
		c = fs-&gt;cons[CONS(f-&gt;qid)];
		if(!userok(f-&gt;user, c-&gt;name)){
			fsreply(fs, r, Eperm);
			return;
		}
		f-&gt;c = c;
		break;
	}

	f-&gt;open = 1;
	r-&gt;f.iounit = messagesize-IOHDRSZ;
	r-&gt;f.qid = f-&gt;qid;
	fsreply(fs, r, nil);
}

void
fscreate(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsread(Fs *fs, Request *r, Fid *f)
{
	uchar *p, *e;
	int i, m, off;
	vlong offset;
	Dir d;
	char sbuf[ERRMAX];

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}

	if((int)r-&gt;f.count &lt; 0){
		fsreply(fs, r, Ebadcount);
		return;
	}

	if(QTDIR &amp; f-&gt;qid.type){
		p = r-&gt;buf + IOHDRSZ;
		e = p + r-&gt;f.count;
		offset = r-&gt;f.offset;
		off = 0;
		for(i=0; p&lt;e; i++, off+=m){
			m = fsdirgen(fs, f-&gt;qid, i, &amp;d, p, e-p);
			if(m &lt; 0)
				break;
			if(m &gt; BIT16SZ &amp;&amp; off &gt;= offset)
				p += m;
		}
		r-&gt;f.data = (char*)r-&gt;buf + IOHDRSZ;
		r-&gt;f.count = (char*)p - r-&gt;f.data;
	} else {
		switch(TYPE(f-&gt;qid)){
		case Qdata:
			addreq(&amp;f-&gt;r, r);
			fskick(fs, f);
			return;
		case Qctl:
			r-&gt;f.data = (char*)r-&gt;buf+IOHDRSZ;
			r-&gt;f.count = 0;
			break;
		case Qstat:
			if(r-&gt;f.count &gt; sizeof(sbuf))
				r-&gt;f.count = sizeof(sbuf);
			i = pread(f-&gt;c-&gt;sfd, sbuf, r-&gt;f.count, r-&gt;f.offset);
			if(i &lt; 0){
				errstr(sbuf, sizeof sbuf);
				fsreply(fs, r, sbuf);
				return;
			}
			r-&gt;f.data = sbuf;
			r-&gt;f.count = i;
			break;
		default:
			fsreply(fs, r, Eexist);
			return;
		}
	}
	fsreply(fs, r, nil);
}

void
fswrite(Fs *fs, Request *r, Fid *f)
{
	int i, eol = 0;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}

	if((int)r-&gt;f.count &lt; 0){
		fsreply(fs, r, Ebadcount);
		return;
	}

	if(QTDIR &amp; f-&gt;qid.type){
		fsreply(fs, r, Eperm);
		return;
	}

	switch(TYPE(f-&gt;qid)){
	default:
		fsreply(fs, r, Eperm);
		return;
	case Qctl:
		write(f-&gt;c-&gt;cfd, r-&gt;f.data, r-&gt;f.count);
		break;
	case Qdata:
		for(i = 0; i &lt; r-&gt;f.count; i++){
			if(r-&gt;f.data[i] == '\n'){
				if(f-&gt;c-&gt;chat &amp;&amp; f-&gt;used)
					eol = 1;
				if(f-&gt;c-&gt;cronly)
					r-&gt;f.data[i] = '\r';
			}
			else
				f-&gt;used = 1;
		}
		if(f-&gt;c-&gt;chat){
			fskick(fs, f);
			if(!f-&gt;used)
				break;
	
			if(f-&gt;bufn + r-&gt;f.count &gt; Bufsize){
				r-&gt;f.count -= (f-&gt;bufn + r-&gt;f.count) % Bufsize;
				eol = 1;
			}
			strncat(f-&gt;mbuf, r-&gt;f.data, r-&gt;f.count);
			f-&gt;bufn += r-&gt;f.count;
			if(eol){
				bcastmsg(fs, f-&gt;c, f-&gt;mbuf, f-&gt;bufn);
				sprint(f-&gt;mbuf, "[%s] ", f-&gt;user);
				f-&gt;bufn = strlen(f-&gt;mbuf);
				f-&gt;used = 0;
			}
		}
		else
			write(f-&gt;c-&gt;fd, r-&gt;f.data, r-&gt;f.count);
		break;
	}
	fsreply(fs, r, nil);
}

void
fsclunk(Fs *fs, Request *r, Fid *f)
{
	Fid **l, *fl;
	Request *nr;

	if(f-&gt;open &amp;&amp; TYPE(f-&gt;qid) == Qdata){
		while((nr = remreq(&amp;f-&gt;r)) != nil){
			fsputfid(fs, f);
			free(nr);
		}

		lock(f-&gt;c);
		for(l = &amp;f-&gt;c-&gt;flist; *l; l = &amp;fl-&gt;cnext){
			fl = *l;
			if(fl == f){
				*l = fl-&gt;cnext;
				break;
			}
		}
		bcastmembers(fs, f-&gt;c, "-", f);
		if(f-&gt;c-&gt;ondemand &amp;&amp; f-&gt;c-&gt;flist == nil)
			fsreopen(fs, f-&gt;c);
		unlock(f-&gt;c);
	}
	fsreply(fs, r, nil);
	fsputfid(fs, f);
}

void
fsremove(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsstat(Fs *fs, Request *r, Fid *f)
{
	int i, n;
	Qid q;
	Dir d;

	q = parentqid(f-&gt;qid);
	for(i = 0; ; i++){
		r-&gt;f.stat = r-&gt;buf+IOHDRSZ;
		n = fsdirgen(fs, q, i, &amp;d, r-&gt;f.stat, messagesize-IOHDRSZ);
		if(n &lt; 0){
			fsreply(fs, r, Eexist);
			return;
		}
		r-&gt;f.nstat = n;
		if(r-&gt;f.nstat &gt; BIT16SZ &amp;&amp; d.qid.path == f-&gt;qid.path)
			break;
	}
	fsreply(fs, r, nil);
}

void
fswstat(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsreply(Fs *fs, Request *r, char *err)
{
	int n;
	uchar buf[8192+IOHDRSZ];

	if(err){
		r-&gt;f.type = Rerror;
		r-&gt;f.ename = err;
	}
	n = convS2M(&amp;r-&gt;f, buf, messagesize);
	if(debug)
		fprint(2, "%F path %llux n=%d\n", &amp;r-&gt;f, r-&gt;fid-&gt;qid.path, n);
	fsputfid(fs, r-&gt;fid);
	if(write(fs-&gt;fd, buf, n) != n)
		fatal("unmounted");
	free(r);
}

/*
 *  called whenever input or a read request has been received
 */
void
fskick(Fs *fs, Fid *f)
{
	Request *r;
	char *p, *rp, *wp, *ep;
	int i;

	lock(f);
	while(f-&gt;rp != f-&gt;wp){
		r = remreq(&amp;f-&gt;r);
		if(r == nil)
			break;
		p = (char*)r-&gt;buf;
		rp = f-&gt;rp;
		wp = f-&gt;wp;
		ep = &amp;f-&gt;buf[Bufsize];
		for(i = 0; i &lt; r-&gt;f.count &amp;&amp; rp != wp; i++){
			*p++ = *rp++;
			if(rp &gt;= ep)
				rp = f-&gt;buf;
		}
		f-&gt;rp = rp;
		r-&gt;f.data = (char*)r-&gt;buf;
		r-&gt;f.count = p - (char*)r-&gt;buf;
		fsreply(fs, r, nil);
	}
	unlock(f);
}

void
usage(void)
{
	fprint(2, "usage: consolefs [-d] [-m mount-point] [-c console-db]\n");
	threadexitsall("usage");
}

void
threadmain(int argc, char **argv)
{
	rfork(RFNOTEG);
	fmtinstall('F', fcallfmt);

	ARGBEGIN{
	case 'd':
		debug++;
		break;
	case 'c':
		consoledb = ARGF();
		if(consoledb == nil)
			usage();
		break;
	case 'm':
		mntpt = ARGF();
		if(mntpt == nil)
			usage();
		break;
	}ARGEND;

	db = ndbopen(consoledb);
	if(db == nil)
 		fatal("can't open %s: %r", consoledb);

	fsmount(mntpt);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

