<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/depend.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/depend.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;bio.h&gt;

typedef struct Args Args;

struct Args {
	int	argc;
	char	**argv;
};

typedef struct Dfile Dfile;
typedef struct Fid Fid;
typedef struct File File;
typedef struct Fs Fs;
typedef struct Request Request;
typedef struct Symbol Symbol;
typedef struct Tardir Tardir;

extern int threadrforkflag = RFNAMEG;

enum{
	Nstat = 1024,	/* plenty for this application */
	MAXSIZE = 8192+IOHDRSZ,
};

int messagesize = MAXSIZE;

void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[1024];

	write(2, "depend: ", 8);
	va_start(arg, fmt);
	vseprint(buf, buf+1024, fmt, arg);
	va_end(arg);
	write(2, buf, strlen(buf));
	write(2, "\n", 1);
	threadexitsall(fmt);
}

enum
{
	Nfidhash=	64,
	Ndfhash=	128,
};

struct Symbol
{
	Symbol	*next;		/* hash list chaining */
	char	*sym;
	int	fno;		/* file symbol is defined in */
};

/* source file */
struct File
{
	QLock;

	char	*name;
	Symbol	*ref;
	uchar	*refvec;	/* files resolving the references */
	uint	len;		/* length of file */
	uint	tarlen;		/* length of tar file */
	uint	mode;
	uint	mtime;

	int	use;
	int	fd;
};

/* .depend file */
struct Dfile
{
	Lock;
	int	use;		/* use count */
	int	old;		/* true if this is an superceded dfile */

	File	*file;		/* files */
	int	nfile;		/* number of files */
	int	flen;		/* length of file table */

	Symbol	**dhash;	/* hash table of symbols */
	int	hlen;		/* length of hash table */

	Dfile	*next;		/* hash chain */
	char	*path;		/* path name of dependency file */
	Qid	qid;		/* qid of the dependency file */
};

struct Fid
{
	Fid	*next;
	int	fid;
	int	ref;

	int	attached;
	int	open;
	Qid	qid;
	char	*path;
	Dfile	*df;
	Symbol	*dp;
	int	fd;
	Dir	*dir;
	int	ndir;
	int	dirindex;
};

struct Request
{
	Request	*next;
	Fid	*fid;
	Fcall	f;
	uchar	buf[1];
};

enum
{
	Tblocksize=	512,	/* tar block size */
	Tnamesize=	100,	/* tar name size */
};

struct Tardir
{
	char	name[Tnamesize];
	char	mode[8];
	char	uid[8];
	char	gid[8];
	char	size[12];
	char	mtime[12];
	char	chksum[8];
	char	linkflag;
	char	linkname[Tnamesize];
};

struct Fs
{
	Lock;

	int	fd;		/* to kernel mount point */
	Fid	*hash[Nfidhash];
	char	*root;
	Qid	rootqid;

};

struct Fsarg
{
	Fs	*fs;
	int	fd;
	char *root;
};


extern	void	fsrun(void*);
extern	Fid*	fsgetfid(Fs*, int);
extern	void	fsputfid(Fs*, Fid*);
extern	void	fsreply(Fs*, Request*, char*);
extern	void	fsversion(Fs*, Request*, Fid*);
extern	void	fsauth(Fs*, Request*, Fid*);
extern	void	fsflush(Fs*, Request*, Fid*);
extern	void	fsattach(Fs*, Request*, Fid*);
extern	void	fswalk(Fs*, Request*, Fid*);
extern	void	fsopen(Fs*, Request*, Fid*);
extern	void	fscreate(Fs*, Request*, Fid*);
extern	void	fsread(Fs*, Request*, Fid*);
extern	void	fswrite(Fs*, Request*, Fid*);
extern	void	fsclunk(Fs*, Request*, Fid*);
extern	void	fsremove(Fs*, Request*, Fid*);
extern	void	fsstat(Fs*, Request*, Fid*);
extern	void	fswstat(Fs*, Request*, Fid*);

void 	(*fcall[])(Fs*, Request*, Fid*) =
{
	[Tflush]	fsflush,
	[Tversion]	fsversion,
	[Tauth]	fsauth,
	[Tattach]	fsattach,
	[Twalk]		fswalk,
	[Topen]		fsopen,
	[Tcreate]	fscreate,
	[Tread]		fsread,
	[Twrite]	fswrite,
	[Tclunk]	fsclunk,
	[Tremove]	fsremove,
	[Tstat]		fsstat,
	[Twstat]	fswstat
};

char Eperm[]   = "permission denied";
char Eexist[]  = "file does not exist";
char Enotdir[] = "not a directory";
char Eisopen[] = "file already open";
char Enofid[] = "no such fid";
char mallocerr[]	= "malloc: %r";
char Etoolong[]	= "name too long";

char *dependlog = "depend";

int debug;
Dfile *dfhash[Ndfhash];		/* dependency file hash */
QLock dfhlock[Ndfhash];
QLock iolock;

Request*	allocreq(int);
Dfile*	getdf(char*);
void	releasedf(Dfile*);
Symbol*	dfsearch(Dfile*, char*);
void	dfresolve(Dfile*, int);
char*	mkpath(char*, char*);
int	mktar(Dfile*, Symbol*, uchar*, uint, int);
void	closetar(Dfile*, Symbol*);

void*
emalloc(uint n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		fatal(mallocerr);
	memset(p, 0, n);
	return p;
}

void *
erealloc(void *ReallocP, int ReallocN)
{
	if(ReallocN == 0)
		ReallocN = 1;
	if(!ReallocP)
		ReallocP = emalloc(ReallocN);
	else if(!(ReallocP = realloc(ReallocP, ReallocN)))
		fatal("unable to allocate %d bytes",ReallocN);
	return(ReallocP);
}

char*
estrdup(char *s)
{
	char *d, *d0;

	if(!s)
		return 0;
	d = d0 = emalloc(strlen(s)+1);
	while(*d++ = *s++)
		;
	return d0;
}

/*
 *  mount the user interface and start one request processor
 *  per CPU
 */
void
realmain(void *a)
{
	Fs *fs;
	int pfd[2];
	int srv;
	char service[128];
	struct Fsarg fsarg;
	Args *args;
	int argc;
	char **argv;

	args = a;
	argc = args-&gt;argc;
	argv = args-&gt;argv;

	fmtinstall('F', fcallfmt);

	ARGBEGIN{
		case 'd':
			debug++;
			break;
	}ARGEND
	if(argc != 2){
		fprint(2, "usage: %s [-d] svc-name directory\n", argv0);
		exits("usage");
	}
	snprint(service, sizeof service, "#s/%s", argv[0]);
	if(argv[1][0] != '/')
		fatal("directory must be rooted");

	if(pipe(pfd) &lt; 0)
		fatal("opening pipe: %r");

	/* Typically mounted before /srv exists */
	srv = create(service, OWRITE, 0666);
	if(srv &lt; 0)
		fatal("post: %r");
	fprint(srv, "%d", pfd[1]);
	close(srv);
	close(pfd[1]);

	time(nil);	/* open fd for time before losing / */
	if(bind(argv[1], "/", MREPL) == 0)
		fatal("can't bind %s to /", argv[1]);

	fs = emalloc(sizeof(Fs));
	fsarg.fs = fs;
	fsarg.fd = pfd[0];
	fsarg.root = argv[1];
	proccreate(fsrun, &amp;fsarg, 16*1024);
	proccreate(fsrun, &amp;fsarg, 16*1024);
	fsrun(&amp;fsarg);
	exits(nil);
}

void
threadmain(int argc, char *argv[])
{
	static Args args;

	args.argc = argc;
	args.argv = argv;
	rfork(RFNAMEG);
	proccreate(realmain, &amp;args, 16*1024);
}

char*
mkpath(char *dir, char *file)
{
	int len;
	char *path;

	len = strlen(dir) + 1;
	if(file != nil)
		len += strlen(file) + 1;
	path = emalloc(len);
	if(file != nil)
		sprint(path, "%s/%s", dir, file);
	else
		sprint(path, "%s", dir);
	return path;
}

void
fsrun(void *a)
{
	struct Fsarg *fsarg;
	Fs* fs;
	char *root;
	int n, t;
	Request *r;
	Fid *f;
	Dir *d;

	fsarg = a;
	fs = fsarg-&gt;fs;
	fs-&gt;fd = fsarg-&gt;fd;
	root = fsarg-&gt;root;
	d = dirstat("/");
	if(d == nil)
		fatal("root %s inaccessible: %r", root);
	fs-&gt;rootqid = d-&gt;qid;
	free(d);

	for(;;){
		r = allocreq(messagesize);
		qlock(&amp;iolock);
		n = read9pmsg(fs-&gt;fd, r-&gt;buf, messagesize);
		qunlock(&amp;iolock);
		if(n &lt;= 0)
			fatal("read9pmsg error: %r");

		if(convM2S(r-&gt;buf, n, &amp;r-&gt;f) == 0){
			fprint(2, "can't convert %ux %ux %ux\n", r-&gt;buf[0],
				r-&gt;buf[1], r-&gt;buf[2]);
			free(r);
			continue;
		}

		f = fsgetfid(fs, r-&gt;f.fid);
		r-&gt;fid = f;
		if(debug)
			fprint(2, "%F path %llux\n", &amp;r-&gt;f, f-&gt;qid.path);

		t = r-&gt;f.type;
		r-&gt;f.type++;
		(*fcall[t])(fs, r, f);
		fsputfid(fs, f);
	}

}

/*
 *  any request that can get queued for a delayed reply
 */
Request*
allocreq(int bufsize)
{
	Request *r;

	r = emalloc(sizeof(Request)+bufsize);
	r-&gt;next = nil;
	return r;
}

Fid*
fsgetfid(Fs *fs, int fid)
{
	Fid *f, *nf;

	lock(fs);
	for(f = fs-&gt;hash[fid%Nfidhash]; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			f-&gt;ref++;
			unlock(fs);
			return f;
		}
	}

	nf = emalloc(sizeof(Fid));
	nf-&gt;next = fs-&gt;hash[fid%Nfidhash];
	fs-&gt;hash[fid%Nfidhash] = nf;
	nf-&gt;fid = fid;
	nf-&gt;ref = 1;
	nf-&gt;fd = -1;
	unlock(fs);
	return nf;
}

void
fsputfid(Fs *fs, Fid *f)
{
	Fid **l, *nf;

	lock(fs);
	if(--f-&gt;ref &gt; 0){
		unlock(fs);
		return;
	}
	for(l = &amp;fs-&gt;hash[f-&gt;fid%Nfidhash]; nf = *l; l = &amp;nf-&gt;next)
		if(nf == f){
			*l = f-&gt;next;
			break;
		}
	unlock(fs);
	free(f);
}

void
fsreply(Fs *fs, Request *r, char *err)
{
	int n;
	uchar buf[MAXSIZE];

	if(err){
		r-&gt;f.type = Rerror;
		r-&gt;f.ename = err;
	}
	if(debug)
		fprint(2, "%F path %llux\n", &amp;r-&gt;f, r-&gt;fid-&gt;qid.path);
	n = convS2M(&amp;r-&gt;f, buf, messagesize);
	if(n == 0)
		fatal("bad convS2M");
	if(write(fs-&gt;fd, buf, n) != n)
		fatal("unmounted");
	free(r);
}

void
fsversion(Fs *fs, Request *r, Fid*)
{
	if(r-&gt;f.msize &lt; 256){
		fsreply(fs, r, "version: bad message size");
		return;
	}
	if(messagesize &gt; r-&gt;f.msize)
		messagesize = r-&gt;f.msize;
	r-&gt;f.msize = messagesize;
	r-&gt;f.version = "9P2000";
	fsreply(fs, r, nil);
}

void
fsauth(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, "depend: authentication not required");
}

void
fsflush(Fs*, Request*, Fid*)
{
}

void
fsattach(Fs *fs, Request *r, Fid *f)
{
	f-&gt;qid = fs-&gt;rootqid;
	f-&gt;path = strdup("/");
	f-&gt;df = getdf(mkpath(f-&gt;path, ".depend"));

	/* hold down the fid till the clunk */
	f-&gt;attached = 1;
	lock(fs);
	f-&gt;ref++;
	unlock(fs);

	r-&gt;f.qid = f-&gt;qid;
	fsreply(fs, r, nil);
}

void
fswalk(Fs *fs, Request *r, Fid *f)
{
	Fid *nf;
	char *name, *tmp;
	int i, nqid, nwname;
	char errbuf[ERRMAX], *err;
	Qid qid[MAXWELEM];
	Dfile *lastdf;
	char *path, *npath;
	Dir *d;
	Symbol *dp;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Eexist);
		return;
	}

	if(f-&gt;fd &gt;= 0 || f-&gt;open)
		fatal("walk of an open file");

	nf = nil;
	if(r-&gt;f.newfid != r-&gt;f.fid){
		nf = fsgetfid(fs, r-&gt;f.newfid);
		nf-&gt;attached = 1;
		nf-&gt;open = f-&gt;open;
		nf-&gt;path = strdup(f-&gt;path);
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;dp = f-&gt;dp;
		nf-&gt;fd = f-&gt;fd;
		nf-&gt;df = f-&gt;df;
		if(nf-&gt;df){
			lock(nf-&gt;df);
			nf-&gt;df-&gt;use++;
			unlock(nf-&gt;df);
		}
		if(r-&gt;f.nwname == 0){
			r-&gt;f.nwqid = 0;
			fsreply(fs, r, nil);
			return;
		}
		f = nf;
	}

	err = nil;
	path = strdup(f-&gt;path);
	if(path == nil)
		fatal(mallocerr);
	nqid = 0;
	nwname = r-&gt;f.nwname;
	lastdf = f-&gt;df;

	if(nwname &gt; 0){
		for(; nqid&lt;nwname; nqid++){
			name = r-&gt;f.wname[nqid];

			if(strcmp(name, ".") == 0){
	Noop:
				if(nqid == 0)
					qid[nqid] = f-&gt;qid;
				else
					qid[nqid] = qid[nqid-1];
				continue;
			}

			if(strcmp(name, "..") == 0){
				name = strrchr(path, '/');
				if(name){
					if(name == path)	/* at root */
						goto Noop;
					*name = '\0';
				}
				d = dirstat(path);
				if(d == nil){
					*name = '/';
					errstr(errbuf, sizeof errbuf);
					err = errbuf;
					break;
				}
	Directory:
				qid[nqid] = d-&gt;qid;
				free(d);
				releasedf(lastdf);
				lastdf = getdf(mkpath(path, ".depend"));
				continue;
			}

			npath = mkpath(path, name);
			free(path);
			path = npath;
			d = dirstat(path);

			if(d !=nil &amp;&amp; (d-&gt;qid.type &amp; QTDIR))
				goto Directory;
			free(d);

			qid[nqid].type = QTFILE;
			qid[nqid].path = 0;
			qid[nqid].vers = 0;

			dp = dfsearch(lastdf, name);
			if(dp == nil){
				tmp = strdup(name);
				if(tmp == nil)
					fatal("mallocerr");
				i = strlen(tmp);
				if(i &gt; 4 &amp;&amp; strcmp(&amp;tmp[i-4], ".tar") == 0){
					tmp[i-4] = 0;
					dp = dfsearch(lastdf, tmp);
				}
				free(tmp);
			}

			if(dp == nil){
				err = Eexist;
				break;
			}
			qid[nqid].path = (uvlong)dp;
			qid[nqid].vers = 0;
		}
		if(nqid == 0 &amp;&amp; err == nil)
			err = "file does not exist";
	}

	/* for error or partial success, put the cloned fid back*/
	if(nf!=nil &amp;&amp; (err != nil || nqid &lt; nwname)){
		releasedf(nf-&gt;df);
		nf-&gt;df = nil;
		fsputfid(fs, nf);
	}

	if(err == nil){
		/* return (possibly short) list of qids */
		for(i=0; i&lt;nqid; i++)
			r-&gt;f.wqid[i] = qid[i];
		r-&gt;f.nwqid = nqid;

		/* for full success, advance f */
		if(nqid &gt; 0 &amp;&amp; nqid == nwname){
			free(f-&gt;path);
			f-&gt;path = path;
			path = nil;

			f-&gt;qid = qid[nqid-1];
			f-&gt;dp = (Symbol*)f-&gt;qid.path;

			if(f-&gt;df != lastdf){
				releasedf(f-&gt;df);
				f-&gt;df = lastdf;
				lastdf = nil;
			}

		}
	}

	releasedf(lastdf);
	free(path);

	fsreply(fs, r, err);
}

#ifdef adf
void
fsclone(Fs *fs, Request *r, Fid *f)
{
	Fid *nf;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Eexist);
		return;
	}
	nf = fsgetfid(fs, r-&gt;f.newfid);

	nf-&gt;attached = 1;
	nf-&gt;open = f-&gt;open;
	nf-&gt;path = strdup(f-&gt;path);
	nf-&gt;qid = f-&gt;qid;
	nf-&gt;dp = f-&gt;dp;
	nf-&gt;fd = f-&gt;fd;
	nf-&gt;df = f-&gt;df;
	if(nf-&gt;df){
		lock(nf-&gt;df);
		nf-&gt;df-&gt;use++;
		unlock(nf-&gt;df);
	}
	fsreply(fs, r, nil);
}

void
fswalk(Fs *fs, Request *r, Fid *f)
{
	char *name;
	int i;
	Dir d;
	char errbuf[ERRLEN];
	char *path;
	Symbol *dp;

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}

	if(f-&gt;fd &gt;= 0 || f-&gt;open)
		fatal("walk of an open file");

	name = r-&gt;f.name;
	if(strcmp(name, ".") == 0){
		fsreply(fs, r, nil);
		return;
	}
	if(strcmp(name, "..") == 0){
		name = strrchr(f-&gt;path, '/');
		if(name){
			if(name == f-&gt;path){
				fsreply(fs, r, nil);
				return;
			}
			*name = 0;
		}
		if(dirstat(f-&gt;path, &amp;d) &lt; 0){
			*name = '/';
			errstr(errbuf);
			fsreply(fs, r, errbuf);
			return;
		}
		r-&gt;f.qid = f-&gt;qid = d.qid;

		releasedf(f-&gt;df);
		f-&gt;df = getdf(mkpath(f-&gt;path, ".depend"));

		fsreply(fs, r, nil);
		return;
	}

	path = mkpath(f-&gt;path, name);
	if(dirstat(path, &amp;d) &lt; 0 || (d.qid.path &amp; CHDIR) == 0){
		dp = dfsearch(f-&gt;df, name);
		if(dp == nil){
			i = strlen(name);
			if(i &gt; 4 &amp;&amp; strcmp(&amp;name[i-4], ".tar") == 0){
				name[i-4] = 0;
				dp = dfsearch(f-&gt;df, name);
			}
		}
		if(dp == nil){
			fsreply(fs, r, Eexist);
			free(path);
			return;
		}
		f-&gt;dp = dp;
		d.qid.path = (uint)dp;
		d.qid.vers = 0;
	}

	free(f-&gt;path);
	f-&gt;path = path;

	if(d.qid.path &amp; CHDIR){
		releasedf(f-&gt;df);
		f-&gt;df = getdf(mkpath(f-&gt;path, ".depend"));
	}

	r-&gt;f.qid = f-&gt;qid = d.qid;
	fsreply(fs, r, nil);
}
#endif
void
fsopen(Fs *fs, Request *r, Fid *f)
{
	int mode;
	char errbuf[ERRMAX];
	
	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}
	if(f-&gt;open){
		fsreply(fs, r, Eisopen);
		return;
	}

	mode = r-&gt;f.mode &amp; 3;
	if(mode != OREAD){
		fsreply(fs, r, Eperm);
		return;
	}

	if(f-&gt;qid.type &amp; QTDIR){
		f-&gt;fd = open(f-&gt;path, OREAD);
		if(f-&gt;fd &lt; 0){
			errstr(errbuf, sizeof errbuf);
			fsreply(fs, r, errbuf);
			return;
		}
	}

	f-&gt;open = 1;
	r-&gt;f.qid = f-&gt;qid;
	fsreply(fs, r, nil);
}

void
fscreate(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsread(Fs *fs, Request *r, Fid *f)
{
	int i, n, len,skip;
	Dir d;
	Symbol *dp;
	char buf[512];

	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}
	if((int)r-&gt;f.count &lt; 0){
		fsreply(fs, r, "bad read count");
		return;
	}

	if(f-&gt;qid.type &amp; QTDIR){
		n = 0;
		if(f-&gt;dir == nil){
			f-&gt;ndir = dirreadall(f-&gt;fd, &amp;f-&gt;dir);
			f-&gt;dirindex = 0;
		}
		if(f-&gt;dir == nil)
			goto Return;
		if(r-&gt;f.offset == 0)	/* seeking to zero is permitted */
			f-&gt;dirindex = 0;
		for(; f-&gt;dirindex &lt; f-&gt;ndir; f-&gt;dirindex++){
			if((f-&gt;dir[f-&gt;dirindex].qid.type &amp; QTDIR) == 0)
				continue;
			len = convD2M(&amp;f-&gt;dir[f-&gt;dirindex], r-&gt;buf+n, r-&gt;f.count-n);
			if(len &lt;= BIT16SZ)
				goto Return;
			n += len;
		}

		skip = f-&gt;dirindex - f-&gt;ndir;	/* # depend records already read */

		if(f-&gt;df){
			for(i = 0; i &lt; f-&gt;df-&gt;hlen; i++)
				for(dp = f-&gt;df-&gt;dhash[i]; dp; dp = dp-&gt;next){
					if(skip-- &gt; 0)
						continue;
					snprint(buf, sizeof buf, "%s.tar", dp-&gt;sym);
					d.name = buf;
					d.uid = "none";
					d.gid = "none";
					d.muid = "none";
					d.qid.type = QTFILE;
					d.qid.path = (uvlong)dp;
					d.qid.vers = 0;
					d.length = f-&gt;df-&gt;file[dp-&gt;fno].tarlen;
					d.mode = 0444;
					d.mtime = time(nil);
					d.atime = time(nil);
					len = convD2M(&amp;d, r-&gt;buf + n, r-&gt;f.count - n);
					if(len &lt;= BIT16SZ)
						goto Return;
					n += len;
					f-&gt;dirindex++;
				}
		}
	} else
		n = mktar(f-&gt;df, f-&gt;dp, r-&gt;buf, r-&gt;f.offset, r-&gt;f.count);

    Return:
	r-&gt;f.data = (char*)r-&gt;buf;
	r-&gt;f.count = n;
	fsreply(fs, r, nil);
}

void
fswrite(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsclunk(Fs *fs, Request *r, Fid *f)
{
	if(f-&gt;attached == 0){
		fsreply(fs, r, Enofid);
		return;
	}
	if(f-&gt;fd &gt;= 0){
		close(f-&gt;fd);
		f-&gt;fd = -1;
	}

	if((f-&gt;qid.type &amp; QTDIR) == 0)
		closetar(f-&gt;df, f-&gt;dp);

	releasedf(f-&gt;df);
	f-&gt;df = nil;
	free(f-&gt;dir);
	f-&gt;dir = nil;

	fsreply(fs, r, nil);
	fsputfid(fs, f);
}

void
fsremove(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

void
fsstat(Fs *fs, Request *r, Fid *f)
{
	char err[ERRMAX];
	Dir d;
	Symbol *dp;
	int n;
	uchar statbuf[Nstat];

	if(f-&gt;qid.type &amp; QTDIR)
		n = stat(f-&gt;path, statbuf, sizeof statbuf);
	else {
		dp = f-&gt;dp;
		d.name = dp-&gt;sym;
		d.uid = "none";
		d.gid = "none";
		d.muid = "none";
		d.qid.type = QTFILE;
		d.qid.path = (uvlong)dp;
		d.qid.vers = 0;
		d.length = f-&gt;df-&gt;file[dp-&gt;fno].tarlen;
		d.mode = 0444;
		d.mtime = time(nil);
		d.atime = time(nil);
		n = convD2M(&amp;d, statbuf, sizeof statbuf);
	}
	if(n &lt;= BIT16SZ){
		errstr(err, sizeof err);
		fsreply(fs, r, err);
	} else {
		r-&gt;f.stat = statbuf;
		r-&gt;f.nstat = n;
		fsreply(fs, r, nil);
	}
}

void
fswstat(Fs *fs, Request *r, Fid*)
{
	fsreply(fs, r, Eperm);
}

/*
 *  string hash
 */
uint
shash(char *str, int len)
{
	uint	hash;
	char	*val; 

	hash = 0;
	for(val = str; *val; val++)
		hash = (hash*13) + *val-'a';
	return hash % len;
}

/*
 *  free info about a dependency file
 */
void
freedf(Dfile *df)
{
	int i;
	Symbol *dp, *next;

	lock(df);
	df-&gt;old = 1;
	if(df-&gt;use){
		unlock(df);
		return;
	}

	unlock(df);	/* we're no longer referenced */
	for(i = 0; i &lt; df-&gt;nfile; i++)
		free(df-&gt;file[i].name);
	free(df-&gt;file[i].refvec);
	free(df-&gt;file);
	df-&gt;file = nil;

	for(i = 0; i &lt; df-&gt;hlen; i++)
		for(dp = df-&gt;dhash[i]; dp != nil; dp = next){
			next = dp-&gt;next;
			free(dp);
		}

	free(df-&gt;path);
	free(df);
	free(df-&gt;dhash);
	df-&gt;dhash = nil;
}

/*
 *  crack a dependency file
 */
void
newsym(char *name, int fno, Symbol **l)
{
	Symbol *dp;

	dp = emalloc(sizeof(Symbol));
	dp-&gt;sym = strdup(name);
	if(dp-&gt;sym == nil)
		fatal("mallocerr");
	dp-&gt;next = *l;
	dp-&gt;fno = fno;
	*l = dp;
}
int
awk(Biobuf *b, char **field, int n)
{
	char *line;
	int i;

	while(line = Brdline(b, '\n')){
		line[Blinelen(b)-1] = 0;
		while(*line == ' ' || *line == '\t')
			*line++ = 0;
		for(i = 0; i &lt; n; i++){
			if(*line == 0 || *line == '#')
				break;
			field[i] = line;
			while(*line &amp;&amp; *line != ' ' &amp;&amp; *line != '\t')
				line++;
			while(*line == ' ' || *line == '\t')
				*line++ = 0;
		}
		if(i)
			return i;
	}

	return 0;
}

void
crackdf(Dfile *df, Biobuf *b, uint len, char *dpath)
{
	char *name;
	char *field[3];
	char path[512];
	int n, inc, ok, npath;
	Symbol **l, *dp, *next;
	File *f, *ef;
	Dir *d;

	inc = 32;
	df-&gt;flen = inc;
	df-&gt;file = emalloc(df-&gt;flen*sizeof(File));
	df-&gt;nfile = 0;

	df-&gt;hlen = 1 + len/8;
	df-&gt;dhash = emalloc(df-&gt;hlen*sizeof(Symbol*));

	l = nil;
	while((n = awk(b, field, 3)) &gt; 0){
		if(n != 2)
			continue;

		name = field[1];
		switch(*field[0]){
		case 'F':
			if(df-&gt;flen == df-&gt;nfile){
				df-&gt;flen += inc;
				df-&gt;file = realloc(df-&gt;file, df-&gt;flen*sizeof(File));
				if(df-&gt;file == nil)
					fatal(mallocerr);
				memset(&amp;df-&gt;file[df-&gt;nfile], 0, inc*sizeof(File));
			}
			f = &amp;df-&gt;file[df-&gt;nfile++];
			f-&gt;name = strdup(name);
			l = &amp;f-&gt;ref;
			/* fall through and define as a symbol */
		case 'D':
			if(l == nil)
				continue;
			newsym(name, df-&gt;nfile-1, &amp;(df-&gt;dhash[shash(name, df-&gt;hlen)]));
			break;
		case 'R':
			if(l == nil)
				continue;
			newsym(name, 0, l);
			break;
		}
	}

	ef = &amp;df-&gt;file[df-&gt;nfile];

	/* stat the files to get sizes */
	npath = strlen(dpath);
	if(npath+1+1 &gt;= sizeof path)
		fatal(Etoolong);
	memmove(path, dpath, npath+1);	/* include NUL */
	name = strrchr(path, '/') + 1;
	for(f = df-&gt;file; f &lt; ef; f++){
		n = strlen(f-&gt;name);
		if(npath+1+n+3+1 &gt; sizeof path)
			fatal(Etoolong);
		memmove(name, f-&gt;name, n+1);	/* include NUL */
		ok = access(path, AEXIST);
		if(ok &lt; 0){
			strcpy(name+n, ".Z");
			ok = access(path, AEXIST);
			if(ok &lt; 0){
				strcpy(name+n, ".gz");
				ok = access(path, AEXIST);
			}
		}
		if(ok &gt;= 0){
			free(f-&gt;name);
			f-&gt;name = strdup(name);
			if(f-&gt;name == nil)
				fatal(mallocerr);
		}
		d = dirstat(path);
		if(d){
			f-&gt;len = d-&gt;length;
			f-&gt;mode = d-&gt;mode;
			f-&gt;mtime = d-&gt;mtime;
			free(d);
		}else{
			f-&gt;len = 0;
			f-&gt;mode = 0;
			f-&gt;mtime = 0;
		}
		f-&gt;fd = -1;
	}

	/* resolve all file references */
	for(f = df-&gt;file; f &lt; ef; f++)
		dfresolve(df, f-df-&gt;file);

	/* free the referenced symbols, don't need them anymore */
	for(f = df-&gt;file; f &lt; ef; f++){
		f-&gt;tarlen += 2*Tblocksize;	/* tars trailing 0 blocks */
		for(dp = f-&gt;ref; dp != nil; dp = next){
			next = dp-&gt;next;
			free(dp);
		}
		f-&gt;ref = nil;
	}
}

/*
 *  get a cracked dependency file
 */
Dfile*
getdf(char *path)
{
	Dfile *df, **l;
	QLock *lk;
	Dir *d;
	int i, fd;
	Biobuf *b;

	i = shash(path, Ndfhash);
	l = &amp;dfhash[i];
	lk = &amp;dfhlock[i];
	qlock(lk);
	for(df = *l; df; df = *l){
		if(strcmp(path, df-&gt;path) == 0)
			break;
		l = &amp;df-&gt;next;
	}
	d = dirstat(path);

	if(df){
		if(d!=nil &amp;&amp; d-&gt;qid.type == df-&gt;qid.type &amp;&amp; d-&gt;qid.vers == df-&gt;qid.vers &amp;&amp; d-&gt;qid.vers == df-&gt;qid.vers){
			free(path);
			lock(df);
			df-&gt;use++;
			unlock(df);
			goto Return;
		}
		*l = df-&gt;next;
		freedf(df);
	}

	fd = open(path, OREAD);
	if(d == nil || fd &lt; 0){
		close(fd);
		goto Return;
	}

	df = emalloc(sizeof(*df));
	b = emalloc(sizeof(Biobuf));

	Binit(b, fd, OREAD);
	df-&gt;qid = d-&gt;qid;
	df-&gt;path = path;
	crackdf(df, b, d-&gt;length, path);
	Bterm(b);

	free(b);

	df-&gt;next = *l;
	*l = df;
	df-&gt;use = 1;
    Return:
	qunlock(lk);
	free(d);
	return df;
}

/*
 *  stop using a dependency file.  Free it if it is no longer linked in.
 */
void
releasedf(Dfile *df)
{
	Dfile **l, *d;
	QLock *lk;
	int i;

	if(df == nil)
		return;

	/* remove from hash chain */
	i = shash(df-&gt;path, Ndfhash);
	l = &amp;dfhash[i];
	lk = &amp;dfhlock[i];
	qlock(lk);
	lock(df);
	df-&gt;use--;
	if(df-&gt;old == 0 || df-&gt;use &gt; 0){
		unlock(df);
		qunlock(lk);
		return;
	}
	for(d = *l; d; d = *l){
		if(d == df){
			*l = d-&gt;next;
			break;
		}
		l = &amp;d-&gt;next;
	}
	unlock(df);
	qunlock(lk);

	/* now we know it is unreferenced, remove it */
	freedf(df);
}

/*
 *  search a dependency file for a symbol
 */
Symbol*
dfsearch(Dfile *df, char *name)
{
	Symbol *dp;

	if(df == nil)
		return nil;
	for(dp = df-&gt;dhash[shash(name, df-&gt;hlen)]; dp; dp = dp-&gt;next)
		if(strcmp(dp-&gt;sym, name) == 0)
			return dp;
	return nil;
}

/*
 *  resolve a single file into a vector of referenced files and the sum of their
 *  lengths
 */
/* set a bit in the referenced file vector */
int
set(uchar *vec, int fno)
{
	if(vec[fno/8] &amp; (1&lt;&lt;(fno&amp;7)))
		return 1;
	vec[fno/8] |= 1&lt;&lt;(fno&amp;7);
	return 0;
}
/* merge two referenced file vectors */
void
merge(uchar *vec, uchar *ovec, int nfile)
{
	nfile = (nfile+7)/8;
	while(nfile-- &gt; 0)
		*vec++ |= *ovec++;
}
uint
res(Dfile *df, uchar *vec, int fno)
{
	File *f;
	Symbol *rp, *dp;
	int len;

	f = &amp;df-&gt;file[fno];
	if(set(vec, fno))
		return 0;				/* already set */
	if(f-&gt;refvec != nil){
		merge(vec, f-&gt;refvec, df-&gt;nfile);	/* we've descended here before */
		return f-&gt;tarlen;
	}

	len = 0;
	for(rp = f-&gt;ref; rp; rp = rp-&gt;next){
		dp = dfsearch(df, rp-&gt;sym);
		if(dp == nil)
			continue;
		len += res(df, vec, dp-&gt;fno);
	}
	return len + Tblocksize + ((f-&gt;len + Tblocksize - 1)/Tblocksize)*Tblocksize;
}
void
dfresolve(Dfile *df, int fno)
{
	uchar *vec;
	File *f;

	f = &amp;df-&gt;file[fno];
	vec = emalloc((df-&gt;nfile+7)/8);
	f-&gt;tarlen = res(df, vec, fno);
	f-&gt;refvec = vec;
}

/*
 *  make the tar directory block for a file
 */
uchar*
mktardir(File *f)
{
	uchar *ep;
	Tardir *tp;
	uint sum;
	uchar *p, *cp;

	p = emalloc(Tblocksize);
	tp = (Tardir*)p;

	strcpy(tp-&gt;name, f-&gt;name);
	sprint(tp-&gt;mode, "%6o ", f-&gt;mode &amp; 0777);
	sprint(tp-&gt;uid, "%6o ", 0);
	sprint(tp-&gt;gid, "%6o ", 0);
	sprint(tp-&gt;size, "%11o ", f-&gt;len);
	sprint(tp-&gt;mtime, "%11o ", f-&gt;mtime);

	/* calculate checksum */
	memset(tp-&gt;chksum, ' ', sizeof(tp-&gt;chksum));
	sum = 0;
	ep = p + Tblocksize;
	for (cp = p; cp &lt; ep; cp++)
		sum += *cp;
	sprint(tp-&gt;chksum, "%6o", sum);

	return p;
}

/*
 *  manage open files
 */
int
getfile(Dfile *df, File *f)
{
	int n;
	char path[512], *name;

	qlock(f);
	f-&gt;use++;
	if(f-&gt;fd &lt; 0){
		name = strrchr(df-&gt;path, '/') + 1;
		n = snprint(path, sizeof path, "%.*s/%s", (int)(name-df-&gt;path), df-&gt;path, f-&gt;name);
		if(n &gt;= sizeof path - UTFmax){
			syslog(0, dependlog, "path name too long: %.20s.../%.20s...", df-&gt;path, f-&gt;name);
			return -1;
		}
		f-&gt;fd = open(path, OREAD);
		if(f-&gt;fd &lt; 0)
			syslog(0, dependlog, "can't open %s: %r", path);
	}

	return f-&gt;fd;
}
void
releasefile(File *f)
{
	--f-&gt;use;
	qunlock(f);
}
void
closefile(File *f)
{
	qlock(f);
	if(f-&gt;use == 0){
		close(f-&gt;fd);
		f-&gt;fd = -1;
	}
	qunlock(f);
}

/*
 *  return a block of a tar file
 */
int
mktar(Dfile *df, Symbol *dp, uchar *area, uint offset, int len)
{
	int fd, i, j, n, off;
	uchar *p, *buf;
	uchar *vec;
	File *f;

	f = &amp;df-&gt;file[dp-&gt;fno];
	vec = f-&gt;refvec;
	p = area;

	/* find file */
	for(i = 0; i &lt; df-&gt;nfile &amp;&amp; len &gt; 0; i++){
		if((vec[i/8] &amp; (1&lt;&lt;(i&amp;7))) == 0)
			continue;

		f = &amp;df-&gt;file[i];
		n = Tblocksize + ((f-&gt;len + Tblocksize - 1)/Tblocksize)*Tblocksize;
		if(offset &gt;= n){
			offset -= n;
			continue;
		}

		if(offset &lt; Tblocksize){
			buf = mktardir(f);
			if(offset + len &gt; Tblocksize)
				j = Tblocksize - offset;
			else
				j = len;
//if(debug)fprint(2, "reading %d bytes dir of %s\n", j, f-&gt;name);
			memmove(p, buf+offset, j);
			p += j;
			len -= j;
			offset += j;
			free(buf);
		}
		if(len &lt;= 0)
			break;
		off = offset - Tblocksize;
		if(off &gt;= 0 &amp;&amp; off &lt; f-&gt;len){
			if(off + len &gt; f-&gt;len)
				j = f-&gt;len - off;
			else
				j = len;
			fd = getfile(df, f);
			if(fd &gt;= 0){
//if(debug)fprint(2, "reading %d bytes from offset %d of %s\n", j, off, f-&gt;name);
				if(pread(fd, p, j, off) != j)
					syslog(0, dependlog, "%r reading %d bytes from offset %d of %s", j, off, f-&gt;name);
			}
			releasefile(f);
			p += j;
			len -= j;
			offset += j;
		}
		if(len &lt;= 0)
			break;
		if(offset &lt; n){
			if(offset + len &gt; n)
				j = n - offset;
			else
				j = len;
//if(debug)fprint(2, "filling %d bytes after %s\n", j, f-&gt;name);
			memset(p, 0, j);
			p += j;
			len -= j;
		}
		offset = 0;
	}

	/* null blocks at end of tar file */
	if(offset &lt; 2*Tblocksize &amp;&amp; len &gt; 0){
		if(offset + len &gt; 2*Tblocksize)
			j = 2*Tblocksize - offset;
		else
			j = len;
//if(debug)fprint(2, "filling %d bytes at end\n", j);
		memset(p, 0, j);
		p += j;
	}

	return p - area;
}

/*
 *  close the files making up  a tar file
 */
void
closetar(Dfile *df, Symbol *dp)
{
	int i;
	uchar *vec;
	File *f;

	f = &amp;df-&gt;file[dp-&gt;fno];
	vec = f-&gt;refvec;

	/* find file */
	for(i = 0; i &lt; df-&gt;nfile; i++){
		if((vec[i/8] &amp; (1&lt;&lt;(i&amp;7))) == 0)
			continue;
		closefile(&amp;df-&gt;file[i]);
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

