<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/flashfs/entry.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/flashfs/entry.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "flashfs.h"

static	int	nextfnum;
static	Intmap*	map;
static	Dir	dirproto;

static	char	user[]	= "flash";

	Entry	*root;
	ulong	used;
	ulong	limit;
	ulong	maxwrite;

enum
{
	debug	= 0,
};

static int
fnum(void)
{
	return ++nextfnum;
}

static void
maxfnum(int n)
{
	if(n &gt; nextfnum)
		nextfnum = n;
}

static int
hash(char *s)
{
	int c, d, h;

	h = 0;
	while((c = *s++) != '\0') {
		d = c;
		c ^= c &lt;&lt; 6;
		h += (c &lt;&lt; 11) ^ (c &gt;&gt; 1);
		h ^= (d &lt;&lt; 14) + (d &lt;&lt; 7) + (d &lt;&lt; 4) + d;
	}

	if(h &lt; 0)
		return ~h;
	return h;
}

static void
dirinit(Entry *e)
{
	Entry **t;

	e-&gt;size = 0;
	t = emalloc9p(HSIZE * sizeof(Entry*));
	memset(t, 0, HSIZE * sizeof(Entry*));
	e-&gt;htab = t;
	e-&gt;files = nil;
	e-&gt;readers = nil;
}

static void
fileinit(Entry *e)
{
	e-&gt;size = 0;
	e-&gt;gen[0].head = nil;
	e-&gt;gen[0].tail = nil;
	e-&gt;gen[1].head = nil;
	e-&gt;gen[1].tail = nil;
}

static void
elfree(Extent *x)
{
	Extent *t;

	while(x != nil) {
		t = x-&gt;next;
		used -= x-&gt;size;
		free(x);
		x = t;
	}
}

static void
extfree(Entry *e)
{
	elfree(e-&gt;gen[0].head);
	elfree(e-&gt;gen[1].head);
}

static void
efree(Entry *e)
{
	if(debug)
		fprint(2, "free %s\n", e-&gt;name);

	if(e-&gt;mode &amp; DMDIR)
		free(e-&gt;htab);
	else
		extfree(e);

	free(e-&gt;name);
	free(e);
}

void
einit(void)
{
	Entry *e;

	e = emalloc9p(sizeof(Entry));
	e-&gt;ref = 1;
	e-&gt;parent = nil;
	dirinit(e);
	e-&gt;name = estrdup9p("");
	e-&gt;fnum = 0;
	e-&gt;mode = DMDIR | 0775;
	e-&gt;mnum = 0;
	e-&gt;mtime = 0;
	root = e;
	map = allocmap(nil);
}

static void
dumptree(Entry *e, int n)
{
	Entry *l;

	if(debug)
		fprint(2, "%d %s %d\n", n, e-&gt;name, e-&gt;ref);

	if(e-&gt;mode &amp; DMDIR) {
		n++;
		for(l = e-&gt;files; l != nil; l = l-&gt;fnext)
			dumptree(l, n);
	}
}

void
edump(void)
{
	if(debug)
		dumptree(root, 0);
}

Entry *
elookup(ulong key)
{
	if(key == 0)
		return root;
	maxfnum(key);
	return lookupkey(map, key);
}

Extent *
esum(Entry *e, int sect, ulong addr, int *more)
{
	Exts *x;
	Extent *t, *u;

	x = &amp;e-&gt;gen[eparity];
	t = x-&gt;tail;
	if(t == nil || t-&gt;sect != sect || t-&gt;addr != addr)
		return nil;
	u = t-&gt;prev;
	if(u != nil) {
		u-&gt;next = nil;
		*more = 1;
	}
	else {
		x-&gt;head = nil;
		*more = 0;
	}
	x-&gt;tail = u;
	x = &amp;e-&gt;gen[eparity^1];
	u = x-&gt;head;
	t-&gt;next = u;
	x-&gt;head = t;
	if(u == nil)
		x-&gt;tail = t;
	else
		u-&gt;prev = t;
	return t;
}

void
edestroy(Entry *e)
{
	e-&gt;ref--;
	if(e-&gt;ref == 0)
		efree(e);
}

Entry *
ecreate(Entry *d, char *name, ulong n, ulong mode, ulong mtime, char **err)
{
	int h;
	Entry *e, *f;

	h = hash(name) &amp; HMASK;
	for(e = d-&gt;htab[h]; e != nil; e = e-&gt;hnext) {
		if(strcmp(e-&gt;name, name) == 0) {
			*err = Eexists;
			return nil;
		}
	}

	e = emalloc9p(sizeof(Entry));
	e-&gt;ref = 1;
	e-&gt;parent = d;
	d-&gt;ref++;
	f = d-&gt;htab[h];
	e-&gt;hnext = f;
	e-&gt;hprev = nil;
	if(f != nil)
		f-&gt;hprev = e;
	d-&gt;htab[h] = e;
	f = d-&gt;files;
	e-&gt;fnext = f;
	e-&gt;fprev = nil;
	if(f != nil)
		f-&gt;fprev = e;
	d-&gt;files = e;

	d-&gt;ref--;
	e-&gt;ref++;
	e-&gt;name = estrdup9p(name);
	if(n == 0)
		n = fnum();
	else
		maxfnum(n);
	insertkey(map, n, e);
	e-&gt;fnum = n;
	e-&gt;mode = mode &amp; d-&gt;mode;
	e-&gt;mnum = 0;
	e-&gt;mtime = mtime;

	if(e-&gt;mode &amp; DMDIR)
		dirinit(e);
	else
		fileinit(e);

	d-&gt;mtime = mtime;
	return e;
}

void
etrunc(Entry *e, ulong n, ulong mtime)
{
	extfree(e);
	deletekey(map, e-&gt;fnum);
	if(n == 0)
		n = fnum();
	else
		maxfnum(n);
	e-&gt;fnum = n;
	e-&gt;mnum = 0;
	e-&gt;mtime = mtime;
	insertkey(map, n, e);
	fileinit(e);
	e-&gt;parent-&gt;mtime = mtime;
}

char *
eremove(Entry *e)
{
	Dirr *r;
	Entry *d, *n, *p;

	d = e-&gt;parent;
	if(d == nil)
		return Eperm;

	if((e-&gt;mode &amp; DMDIR) != 0 &amp;&amp; e-&gt;files != nil)
		return Edirnotempty;

	p = e-&gt;hprev;
	n = e-&gt;hnext;
	if(n != nil)
		n-&gt;hprev = p;
	if(p != nil)
		p-&gt;hnext = n;
	else
		d-&gt;htab[hash(e-&gt;name) &amp; HMASK] = n;

	for(r = d-&gt;readers; r != nil; r = r-&gt;next) {
		if(r-&gt;cur == e)
			r-&gt;cur = e-&gt;fnext;
	}

	p = e-&gt;fprev;
	n = e-&gt;fnext;
	if(n != nil)
		n-&gt;fprev = p;
	if(p != nil)
		p-&gt;fnext = n;
	else
		d-&gt;files = n;

	e-&gt;parent = nil;
	d-&gt;ref--;
	deletekey(map, e-&gt;fnum);
	edestroy(e);
	return nil;
}

Entry *
ewalk(Entry *d, char *name, char **err)
{
	Entry *e;

	if((d-&gt;mode &amp; DMDIR) == 0) {
		*err = Enotdir;
		return nil;
	}

	if(strcmp(name, "..") == 0) {
		e = d-&gt;parent;
		if(e == nil)
			return d;
		edestroy(d);
		e-&gt;ref++;
		return e;
	}

	for(e = d-&gt;htab[hash(name) &amp; HMASK]; e != nil; e = e-&gt;hnext) {
		if(strcmp(e-&gt;name, name) == 0) {
			d-&gt;ref--;
			e-&gt;ref++;
			return e;
		}
	}

	*err = Enonexist;
	return nil;
}

static void
eread0(Extent *e, Extent *x, uchar *a, ulong n, ulong off)
{
	uchar *a0, *a1;
	ulong n0, n1, o0, o1, d, z;

	for(;;) {
		while(e != nil) {
			if(off &lt; e-&gt;off + e-&gt;size &amp;&amp; off + n &gt; e-&gt;off) {
				if(off &gt;= e-&gt;off) {
					d = off - e-&gt;off;
					z = e-&gt;size - d;
					if(n &lt;= z) {
						readdata(e-&gt;sect, a, n, e-&gt;addr + d);
						return;
					}
					readdata(e-&gt;sect, a, z, e-&gt;addr + d);
					a += z;
					n -= z;
					off += z;
				}
				else {
					a0 = a;
					n0 = e-&gt;off - off;
					o0 = off;
					a += n0;
					n -= n0;
					off += n0;
					z = e-&gt;size;
					if(n &lt;= z) {
						readdata(e-&gt;sect, a, n, e-&gt;addr);
						a = a0;
						n = n0;
						off = o0;
					}
					else {
						readdata(e-&gt;sect, a, z, e-&gt;addr);
						a1 = a + z;
						n1 = n - z;
						o1 = off + z;
						if(n0 &lt; n1) {
							eread0(e-&gt;next, x, a0, n0, o0);
							a = a1;
							n = n1;
							off = o1;
						}
						else {
							eread0(e-&gt;next, x, a1, n1, o1);
							a = a0;
							n = n0;
							off = o0;
						}
					}
				}
			}
			e = e-&gt;next;
		}

		if(x == nil)
			break;

		e = x;
		x = nil;
	}

	memset(a, 0, n);
}

ulong
eread(Entry *e, int parity, void *a, ulong n, ulong off)
{
	if(n + off &gt;= e-&gt;size)
		n = e-&gt;size - off;
	if(n &lt;= 0)
		return 0;
	eread0(e-&gt;gen[parity].head, e-&gt;gen[parity^1].head, a, n, off);
	return n;
}

void
ewrite(Entry *e, Extent *x, int parity, ulong mtime)
{
	ulong z;
	Extent *t;

	t = e-&gt;gen[parity].head;
	x-&gt;next = t;
	x-&gt;prev = nil;
	e-&gt;gen[parity].head = x;
	if(t == nil)
		e-&gt;gen[parity].tail = x;
	else
		t-&gt;prev = x;
	if(mtime != 0)
		e-&gt;mtime = mtime;
	used += x-&gt;size;
	z = x-&gt;off + x-&gt;size;
	if(z &gt; e-&gt;size)
		e-&gt;size = z;
}

ulong
echmod(Entry *e, ulong mode, ulong mnum)
{
	if(mnum != 0)
		e-&gt;mnum = mnum;
	else
		e-&gt;mnum++;
	e-&gt;mode &amp;= ~0777;
	e-&gt;mode |= mode;
	return e-&gt;mnum;
}

Qid
eqid(Entry *e)
{
	Qid qid;

	if(e-&gt;mode &amp; DMDIR)
		qid.type = QTDIR;
	else
		qid.type = 0;
	qid.path = e-&gt;fnum;
	return qid;
}

void
estat(Entry *e, Dir *d, int alloc)
{
	d-&gt;type = 'z';
	d-&gt;dev = 0;
	if(alloc) {
		d-&gt;uid = estrdup9p(user);
		d-&gt;gid = estrdup9p(user);
		d-&gt;muid = estrdup9p(user);
		d-&gt;name = estrdup9p(e-&gt;name);
	}
	else {
		d-&gt;uid = user;
		d-&gt;gid = user;
		d-&gt;muid = user;
		d-&gt;name = e-&gt;name;
	}
	d-&gt;mode = e-&gt;mode;
	d-&gt;length = e-&gt;size;
	d-&gt;atime = e-&gt;mtime;
	d-&gt;mtime = e-&gt;mtime;
	d-&gt;qid = eqid(e);
}

Dirr *
ediropen(Entry *e)
{
	Dirr *d, *t;

	d = emalloc9p(sizeof(Dirr));
	d-&gt;dir = e;
	d-&gt;cur = e-&gt;files;
	t = e-&gt;readers;
	d-&gt;next = t;
	d-&gt;prev = nil;
	if(t != nil)
		t-&gt;prev = d;
	e-&gt;readers = d;
	e-&gt;ref++;
	return d;
}

int
edirread(Dirr *r, char *a, long n)
{
	Dir d;
	Entry *e;
	int m, x;

	m = 0;
	for(e = r-&gt;cur; e != nil; e = e-&gt;fnext) {
		estat(e, &amp;d, 0);
		x = convD2M(&amp;d, (uchar *)a, n);
		if(x &lt;= BIT16SZ)
			break;
		a += x;
		n -= x;
		m += x;
	}

	r-&gt;cur = e;
	return m;
}

void
edirclose(Dirr *d)
{
	Entry *e;
	Dirr *p, *n;

	e = d-&gt;dir;
	p = d-&gt;prev;
	n = d-&gt;next;
	if(n != nil)
		n-&gt;prev = p;
	if(p != nil)
		p-&gt;next = n;
	else
		e-&gt;readers = n;

	edestroy(e);
	free(d);
}

static	Renum	R;

static void
xrenum(Extent *x)
{
	while(x != nil) {
		if(x-&gt;sect == R.old)
			x-&gt;sect = R.new;
		x = x-&gt;next;
	}
}

static void
renum(Entry *e)
{
	if(e-&gt;mode &amp; DMDIR) {
		for(e = e-&gt;files; e != nil; e = e-&gt;fnext)
			renum(e);
	}
	else {
		xrenum(e-&gt;gen[0].head);
		xrenum(e-&gt;gen[1].head);
	}
}

void
erenum(Renum *r)
{
	R = *r;
	renum(root);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

