<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/flashfs/journal.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/flashfs/journal.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "flashfs.h"

enum
{
	debug	= 0,
	diags	= 1,
};

typedef struct	Gen	Gen;
typedef struct	Sect	Sect;

struct Gen
{
	int	gnum;
	int	count;
	int	low;
	int	high;
	Sect*	head;
	Sect*	tail;
	Sect*	dup;
	Sect**	vect;
};

struct Sect
{
	int	sect;
	ulong	seq;
	int	coff;
	int	toff;
	int	sum;
	ulong	time;
	Sect*	next;
};

static	Gen	gens[2];
static	Sect*	freehead;
static	Sect*	freetail;
static	int	nfree;
static	int	nbad;
static	ulong	ltime;
static	int	cursect;

/*
 *	If we have a delta then file times are in the future.
 *	But they drift back to reality.
 */
ulong
now(void)
{
	ulong cur, drift;
	static ulong last;

	cur = time(0);
	if(cur &lt; last)
		delta += last - cur;
	else if(delta != 0 &amp;&amp; last != 0) {
		drift = (cur - last + 1) / 2;
		if(drift &gt; delta)
			delta = 0;
		else
			delta -= drift;
	}
	last = cur;
	return cur + delta;
}

static void
damaged(char *mesg)
{
	sysfatal("damaged filesystem: %s", mesg);
}

static void
lddisc(char *mesg)
{
	if(debug)
		fprint(2, "discard %s\n", mesg);
	else
		USED(mesg);
}

static Sect *
getsect(void)
{
	Sect *t;

	t = freehead;
	freehead = t-&gt;next;
	if(freehead == nil)
		freetail = nil;
	nfree--;
	return t;
}

static void
newsect(Gen *g, Sect *s)
{
	int m, n, err;
	uchar hdr[2*3];

	if(debug)
		fprint(2, "new %d %ld\n", g-&gt;gnum, s-&gt;seq);
	if(g-&gt;tail == nil)
		g-&gt;head = s;
	else
		g-&gt;tail-&gt;next = s;
	g-&gt;tail = s;
	s-&gt;next = nil;
	m = putc3(&amp;hdr[0], g-&gt;gnum);
	n = putc3(&amp;hdr[m], s-&gt;seq);
	s-&gt;toff = MAGSIZE + m + n;
	s-&gt;coff = s-&gt;toff + 4;
	s-&gt;time = NOTIME;
	s-&gt;sum = 0;
	err = 1;
	for(;;) {
		if(writedata(err, s-&gt;sect, hdr, m + n, MAGSIZE)
		&amp;&amp; writedata(err, s-&gt;sect, magic, MAGSIZE, 0))
			break;
		clearsect(s-&gt;sect);
		err = 0;
	}
}

static Sect *
newsum(Gen *g, ulong seq)
{
	Sect *t;

	if(nfree == 0)
		damaged("no free sector for summary");
	t = getsect();
	t-&gt;seq = seq;
	newsect(g, t);
	return t;
}

static void
freesect(Sect *s)
{
	clearsect(s-&gt;sect);
	if(freetail == nil)
		freehead = s;
	else
		freetail-&gt;next = s;
	freetail = s;
	s-&gt;next = nil;
	nfree++;
}

static void
dupsect(Sect *s, int renum)
{
	Sect *t;
	Renum r;
	uchar *b;
	int err, n;
	ulong doff, off;

	if(nfree == 0)
		damaged("no free for copy");
	t = getsect();
	b = sectbuff;
	off = s-&gt;coff;
	readdata(s-&gt;sect, b, off, 0);
	doff = s-&gt;toff;
	if(s-&gt;time == NOTIME)
		doff += 4;
	// Window 5
	err = 1;
	for(;;) {
		if(writedata(err, t-&gt;sect, b + 1, s-&gt;toff - 1, 1)
		&amp;&amp; writedata(err, t-&gt;sect, b + doff, off - doff, doff)
		&amp;&amp; writedata(err, t-&gt;sect, b, 1, 0))
			break;
		clearsect(t-&gt;sect);
		err = 0;
	}
	if(renum) {
		r.old = s-&gt;sect;
		r.new = t-&gt;sect;
		erenum(&amp;r);
	}
	n = s-&gt;sect;
	s-&gt;sect = t-&gt;sect;
	t-&gt;sect = n;
	freesect(t);
	if(cursect &gt;= 0)
		readdata(cursect, b, sectsize, 0);
}

static void
gswap(void)
{
	Gen t;

	t = gens[0];
	gens[0] = gens[1];
	gens[1] = t;
}

static void
checkdata(void)
{
	Gen *g;

	g = &amp;gens[0];
	if(g-&gt;dup != nil) {	// Window 5 damage
		if(diags)
			fprint(2, "%s: window 5 damage\n", argv0);
		freesect(g-&gt;dup);
		g-&gt;dup = nil;
	}
}

static void
checksweep(void)
{
	Gen *g;
	Jrec j;
	uchar *b;
	int n, op;
	Sect *s, *t, *u;
	long off, seq, soff;

	g = &amp;gens[1];
	if(g-&gt;dup != nil) {	// Window 5 damage
		if(diags)
			fprint(2, "%s: window 5 damage\n", argv0);
		freesect(g-&gt;dup);
		g-&gt;dup = nil;
	}

	s = g-&gt;head;
	if(s != g-&gt;tail) {
		while(s-&gt;next != g-&gt;tail)
			s = s-&gt;next;
	}

	b = sectbuff;
	op = -1;
	seq = -1;
	soff = 0;
	u = nil;
	t = s;
	for(;;) {
		readdata(t-&gt;sect, b, sectsize, 0);
		off = t-&gt;toff + 4;
		for(;;) {
			n = convM2J(&amp;j, &amp;b[off]);
			if(n &lt; 0) {
				if(j.type != 0xFF) {
					if(debug)
						fprint(2, "s[%d] @ %d %ld\n", j.type, t-&gt;sect, off);
					damaged("bad Jrec");
				}
				break;
			}
			switch(j.type) {
			case FT_SUMMARY:
			case FT_SUMBEG:
				seq = j.seq;
			case FT_SUMEND:
				op = j.type;
				soff = off;
				u = t;
				break;
			case FT_WRITE:
			case FT_AWRITE:
				off += j.size;
			}
			off += n;
		}
		t = t-&gt;next;
		if(t == nil)
			break;
	}

	if(op == FT_SUMBEG) {		// Window 1 damage
		if(diags)
			fprint(2, "%s: window 1 damage\n", argv0);
		if(u != s) {
			freesect(u);
			s-&gt;next = nil;
			g-&gt;tail = s;
		}
		s-&gt;coff = soff;
		dupsect(s, 0);
		seq--;
	}

	if(seq &gt;= 0) {
		g = &amp;gens[0];
		if(seq &gt; g-&gt;low)
			damaged("high sweep");
		if(seq == g-&gt;low) {	// Window 2 damage
			if(diags)
				fprint(2, "%s: window 2 damage\n", argv0);
			s = g-&gt;head;
			g-&gt;head = s-&gt;next;
			freesect(s);
			if(g-&gt;head == nil) {
				g-&gt;tail = nil;
				g-&gt;gnum += 2;
				newsum(g, 0);
				gswap();
			}
		}
	}
}

void
load1(Sect *s, int parity)
{
	int n;
	Jrec j;
	uchar *b;
	char *err;
	Extent *x;
	Entry *d, *e;
	ulong ctime, off, mtime;

	if(s-&gt;sect &lt; 0 &amp;&amp; readonly)	// readonly damaged
		return;

	b = sectbuff;
	readdata(s-&gt;sect, b, sectsize, 0);
	s-&gt;sum = 0;
	off = s-&gt;toff;
	ctime = get4(&amp;b[off]);
	off += 4;

	for(;;) {
		n = convM2J(&amp;j, &amp;b[off]);
		if(n &lt; 0) {
			if(j.type != 0xFF) {
				if(debug)
					fprint(2, "l[%d] @  %d %ld\n", j.type, s-&gt;sect, off);
				damaged("bad Jrec");
			}
			s-&gt;coff = off;
			break;
		}
		off += n;
		if(debug)
			fprint(2, "get %J\n", &amp;j);
		switch(j.type) {
		case FT_create:
			ctime += j.mtime;
		create:
			d = elookup(j.parent);
			if(d == nil) {
				lddisc("parent");
				break;
			}
			d-&gt;ref++;
			e = ecreate(d, j.name, j.fnum, j.mode, ctime, &amp;err);
			if(e == nil) {
				d-&gt;ref--;
				lddisc("create");
				break;
			}
			e-&gt;ref--;
			if(j.type == FT_trunc)
				e-&gt;mode = j.mode;
			break;
		case FT_chmod:
			e = elookup(j.fnum);
			if(e == nil) {
				lddisc("lookup");
				break;
			}
			echmod(e, j.mode, j.mnum);
			break;
		case FT_REMOVE:
			e = elookup(j.fnum);
			if(e == nil) {
				lddisc("lookup");
				break;
			}
			if(eremove(e) != nil) {
				lddisc("remove");
				break;
			}
			break;
		case FT_AWRITE:
			mtime = 0;
			goto write;
		case FT_WRITE:
			ctime += j.mtime;
			mtime = ctime;
		write:
			x = emalloc9p(sizeof(Extent));
			x-&gt;sect = s-&gt;sect;
			x-&gt;addr = off;
			x-&gt;off = j.offset;
			x-&gt;size = j.size;
			off += j.size;
			e = elookup(j.fnum);
			if(e == nil) {
				lddisc("lookup");
				break;
			}
			ewrite(e, x, parity, mtime);
			break;
		case FT_trunc:
			ctime += j.mtime;
			e = elookup(j.tnum);
			if(e == nil) {
				if(debug)
					fprint(2, "-&gt; create\n");
				goto create;
			}
			etrunc(e, j.fnum, ctime);
			break;
		case FT_SUMMARY:
		case FT_SUMBEG:
		case FT_SUMEND:
			s-&gt;sum += n;
			break;
		default:
			damaged("load1 botch");
		}
	}

	if(s-&gt;sum &gt; Nsum)
		s-&gt;sum = Nsum;

	s-&gt;time = ctime;
	if(ctime != NOTIME &amp;&amp; ctime &gt; ltime)
		ltime = ctime;
}

void
load0(int parity)
{
	Sect *s;

	if(debug)
		fprint(2, "load %d\n", parity);
	for(s = gens[parity].head; s != nil; s = s-&gt;next)
		load1(s, parity);
}

void
loadfs(int ro)
{
	Gen *g;
	Sect *s;
	ulong u, v;
	int i, j, n;
	uchar hdr[MAXHDR];

	readonly = ro;
	fmtinstall('J', Jconv);

	for(i = 0; i &lt; 2; i++) {
		g = &amp;gens[i];
		g-&gt;gnum = -1;
		g-&gt;low = nsects;
		g-&gt;high = -1;
		g-&gt;count = 0;
		g-&gt;head = nil;
		g-&gt;tail = nil;
	}

	for(i = 0; i &lt; nsects; i++) {
		readdata(i, hdr, MAXHDR, 0);
		if(memcmp(hdr, magic, MAGSIZE) == 0) {
			n = MAGSIZE + getc3(&amp;hdr[MAGSIZE], &amp;u);
			getc3(&amp;hdr[n], &amp;v);
			if(debug)
				fprint(2, "%d: %ld %ld\n", i, u, v);
			for(j = 0; j &lt; 2; j++) {
				g = &amp;gens[j];
				if(g-&gt;gnum == u) {
					g-&gt;count++;
					if(v &lt; g-&gt;low)
						g-&gt;low = v;
					if(v &gt; g-&gt;high)
						g-&gt;high = v;
					break;
				}
				else if(g-&gt;gnum &lt; 0) {
					g-&gt;gnum = u;
					g-&gt;count = 1;
					g-&gt;low = v;
					g-&gt;high = v;
					break;
				}
			}
			if(j == 2)
				damaged("unexpected generation");
		}
		else if(hdr[0] == 0xFF) {
			nfree++;
			s = emalloc9p(sizeof(Sect));
			s-&gt;sect = i;
			s-&gt;next = freehead;
			freehead = s;
			if(freetail == nil)
				freetail = s;
		}
		else
			nbad++;
	}

	if(nbad &gt; 0)
		damaged("bad sectors");

	if(gens[0].gnum &lt; 0)
		damaged("no data");

	if(gens[1].gnum &lt; 0) {		// Window 3 death
		if(diags)
			fprint(2, "%s: window 3 damage\n", argv0);
		g = &amp;gens[1];
		g-&gt;gnum = gens[0].gnum + 1;
		g-&gt;low = 0;
		g-&gt;high = 0;
		g-&gt;count = 1;
		if(!readonly)
			newsum(g, 0);
	}

	if(gens[0].gnum &gt; gens[1].gnum)
		gswap();

	for(i = 0; i &lt; 2; i++) {
		g = &amp;gens[i];
		n = g-&gt;count;
		if(n &lt;= g-&gt;high - g-&gt;low)
			damaged("missing sectors");
		g-&gt;vect = emalloc9p(n * sizeof(Sect *));
		for(j = 0; j &lt; n; j++) {
			s = emalloc9p(sizeof(Sect));
			s-&gt;sect = -1;
			g-&gt;vect[j] = s;
		}
	}

	if(debug) {
		for(j = 0; j &lt; 2; j++) {
			g = &amp;gens[j];
			print("%d\t%d\t%d-%d\n", g-&gt;gnum, g-&gt;count, g-&gt;low, g-&gt;high);
		}
	}

	for(i = 0; i &lt; nsects; i++) {
		readdata(i, hdr, MAXHDR, 0);
		if(memcmp(hdr, magic, MAGSIZE) == 0) {
			n = MAGSIZE + getc3(&amp;hdr[MAGSIZE], &amp;u);
			n += getc3(&amp;hdr[n], &amp;v);
			g = nil;
			for(j = 0; j &lt; 2; j++) {
				g = &amp;gens[j];
				if(g-&gt;gnum == u)
					break;
			}
			if(j == 2)
				damaged("generation botch");
			s = g-&gt;vect[v - g-&gt;low];
			s-&gt;seq = v;
			s-&gt;toff = n;
			if(s-&gt;sect &lt; 0)
				s-&gt;sect = i;
			else if(v == g-&gt;high &amp;&amp; g-&gt;dup == nil) {
				s = emalloc9p(sizeof(Sect));
				s-&gt;sect = i;
				g-&gt;dup = s;
			}
			else
				damaged("dup block");
		}
	}

	for(j = 0; j &lt; 2; j++) {
		g = &amp;gens[j];
		for(i = 0; i &lt; g-&gt;count; i++) {
			s = g-&gt;vect[i];
			if(g-&gt;tail == nil)
				g-&gt;head = s;
			else
				g-&gt;tail-&gt;next = s;
			g-&gt;tail = s;
			s-&gt;next = nil;
		}
		free(g-&gt;vect);
	}

	cursect = -1;

	if(!readonly) {
		checkdata();
		checksweep();
	}

	load0(1);
	load0(0);

	if(ltime != 0) {
		u = now();
		if(u &lt; ltime) {
			delta = ltime - u;
			if(diags)
				fprint(2, "%s: check clock: delta = %lud\n", argv0, delta);
		}
	}

	limit = 80 * nsects * sectsize / 100;
	maxwrite = sectsize - MAXHDR - Nwrite - Nsum;
	if(maxwrite &gt; WRSIZE)
		maxwrite = WRSIZE;
}

static int
sputw(Sect *s, Jrec *j, int mtime, Extent *x, void *a)
{
	ulong t;
	int err, n, r;
	uchar buff[Nmax], type[1];

	if(debug)
		fprint(2, "put %J\n", j);

	if(mtime) {
		t = j-&gt;mtime;
		if(s-&gt;time == NOTIME) {
			put4(buff, t);
			if(!writedata(1, s-&gt;sect, buff, 4, s-&gt;toff)) {
				dupsect(s, 1);
				writedata(0, s-&gt;sect, buff, 4, s-&gt;toff);
			}
			s-&gt;time = t;
			j-&gt;mtime = 0;
		}
		else {
			j-&gt;mtime = t - s-&gt;time;
			s-&gt;time = t;
		}
	}

	n = convJ2M(j, buff);
	if(n &lt; 0)
		damaged("convJ2M");

	// Window 4
	err = 2;
	for(;;) {
		err--;
		if(!err)
			dupsect(s, 1);	// Window 4 damage
		t = s-&gt;coff + 1;
		if(!writedata(err, s-&gt;sect, buff, n, t))
			continue;

		t += n;
		r = n;
		if(x != nil) {
			x-&gt;sect = s-&gt;sect;
			x-&gt;addr = t;
			if(!writedata(err, s-&gt;sect, a, j-&gt;size, t))
				continue;
			t += j-&gt;size;
			r += j-&gt;size;
		}

		type[0] = j-&gt;type;
		if(!writedata(err, s-&gt;sect, type, 1, s-&gt;coff))
			continue;
		r++;
		break;
	}
	s-&gt;coff = t;
	return r;
}

static void
summarize(void)
{
	Gen *g;
	uchar *b;
	Entry *e;
	Extent *x;
	Jrec j, sum;
	Sect *s, *t;
	ulong off, ctime;
	int n, bytes, more, mtime, sumd;

	g = &amp;gens[eparity];
	s = g-&gt;head;
	g-&gt;head = s-&gt;next;
	if(g-&gt;head == nil)
		g-&gt;tail = nil;
	g = &amp;gens[eparity^1];
	t = g-&gt;tail;
	b = sectbuff;
	x = nil;

	if(debug)
		fprint(2, "summarize\n");

	for(;;) {	// Window 1
		readdata(s-&gt;sect, b, sectsize, 0);
		off = s-&gt;toff;
		ctime = get4(&amp;b[off]);
		off += 4;
		sumd = 0;

		cursect = s-&gt;sect;
		while(b[off] != 0xFF) {
			n = convM2J(&amp;j, &amp;b[off]);
			if(n &lt; 0)
				damaged("bad Jrec");
			if(debug)
				fprint(2, "read %J\n", &amp;j);
			off += n;
			bytes = n;
			mtime = 0;
			switch(j.type) {
			case FT_create:
				ctime += j.mtime;
				mtime = 1;
			create:
				e = elookup(j.fnum);
				if(e == nil)
					continue;
				break;
			case FT_chmod:
				e = elookup(j.fnum);
				if(e == nil || j.mnum != e-&gt;mnum)
					continue;
				break;
			case FT_REMOVE:
				e = elookup(j.fnum);
				if(e == nil)
					continue;
				break;
			case FT_trunc:
				ctime += j.mtime;
				mtime = 1;
				e = elookup(j.tnum);
				if(e == nil) {
					if(debug)
						fprint(2, "-&gt; create\n");
					j.type = FT_create;
					goto create;
				}
				break;
			case FT_AWRITE:
				goto write;
			case FT_WRITE:
				ctime += j.mtime;
				mtime = 1;
			write:
				e = elookup(j.fnum);
				if(e == nil) {
					off += j.size;
					continue;
				}
				x = esum(e, s-&gt;sect, off, &amp;more);
				if(x == nil) {
					damaged("missing extent");
					off += j.size;
					continue;
				}
				if(more) {
					j.type = FT_AWRITE;
					mtime = 0;
				}
				bytes += j.size;
				break;
			case FT_SUMMARY:
			case FT_SUMBEG:
			case FT_SUMEND:
				continue;
			default:
				damaged("summarize botch");
			}

			if(!sumd) {
				if(t-&gt;coff + Nsumbeg &gt;= sectsize - 1)
					t = newsum(g, t-&gt;seq + 1);
				sum.type = FT_SUMBEG;
				sum.seq = s-&gt;seq;
				if(debug)
					fprint(2, "+ %J\n", &amp;sum);
				t-&gt;sum += sputw(t, &amp;sum, 0, nil, nil);
				if(t-&gt;sum &gt;= Nsum)
					t-&gt;sum = Nsum;
				sumd = 1;
			}

			if(t-&gt;coff + bytes &gt;= sectsize - Nsum + t-&gt;sum - 1)
				t = newsum(g, t-&gt;seq + 1);

			if(mtime)
				j.mtime = ctime;

			switch(j.type) {
			case FT_AWRITE:
			case FT_WRITE:
				sputw(t, &amp;j, mtime, x, &amp;b[off]);
				off += j.size;
				break;
			default:
				sputw(t, &amp;j, mtime, nil, nil);
			}
		}
		cursect = -1;

		if(t-&gt;coff + Nsumbeg &gt;= sectsize - 1)
			t = newsum(g, t-&gt;seq + 1);
		if(sumd)
			sum.type = FT_SUMEND;
		else {
			sum.type = FT_SUMMARY;
			sum.seq = s-&gt;seq;
		}
		if(debug)
			fprint(2, "+ %J\n", &amp;sum);
		t-&gt;sum += sputw(t, &amp;sum, 0, nil, nil);
		if(t-&gt;sum &gt;= Nsum)
			t-&gt;sum = Nsum;

		// Window 2
		freesect(s);
		g = &amp;gens[eparity];
		s = g-&gt;head;
		if(s == nil) {
			// Window 3
			g-&gt;gnum += 2;
			newsum(g, 0);
			eparity ^= 1;
			return;
		}

		if(nfree &gt;= Nfree)
			return;

		g-&gt;head = s-&gt;next;
		if(g-&gt;head == nil)
			g-&gt;tail = nil;
		g = &amp;gens[eparity^1];
	}
}

char *
need(int bytes)
{
	Gen *g;
	int sums;
	Sect *s, *t;

	sums = 0;
	for(;;) {
		s = gens[eparity].tail;
		if(s-&gt;coff + bytes &lt; sectsize - Nsum + s-&gt;sum - 1)
			return nil;

		if(nfree &gt;= Nfree)
			break;

		if(sums == 2) {
			readonly = 1;
			return "generation full";
		}

		summarize();
		sums++;
	}

	g = &amp;gens[eparity];
	t = getsect();
	t-&gt;seq = g-&gt;tail-&gt;seq + 1;
	newsect(g, t);
	return nil;
}

void
putw(Jrec *j, int mtime, Extent *x, void *a)
{
	sputw(gens[eparity].tail, j, mtime, x, a);
}

void
put(Jrec *j, int mtime)
{
	sputw(gens[eparity].tail, j, mtime, nil, nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

