<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/flashfs/request.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/flashfs/request.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "flashfs.h"

static	Srv	flashsrv;

typedef struct	State	State;

struct State
{
	Entry	*e;
	Dirr	*r;
};

#define	writeable(e)	((e)-&gt;mode &amp; 0222)

static State *
state(Entry *e)
{
	State *s;

	s = emalloc9p(sizeof(State));
	s-&gt;e = e;
	s-&gt;r = nil;
	return s;
}

static void
destroy(Fid *f)
{
	State *s;

	s = f-&gt;aux;
	if(s == nil)		/* Tauth fids have no state */
		return;

	f-&gt;aux = nil;
	if(s-&gt;e)
		edestroy(s-&gt;e);
	if(s-&gt;r)
		edirclose(s-&gt;r);
	free(s);
}

static void
trace(Req *)
{
	edump();
}

/** T_ **/

static void
flattach(Req *r)
{
	root-&gt;ref++;
	r-&gt;ofcall.qid = eqid(root);
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	r-&gt;fid-&gt;aux = state(root);
	respond(r, nil);
}

static void
flopen(Req *r)
{
	Jrec j;
	int m, p;
	Entry *e;
	State *s;
	char *err;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	m = e-&gt;mode;
	m = (m | (m &gt;&gt; 3) | (m &gt;&gt; 6)) &amp; 7;
	switch(r-&gt;ifcall.mode &amp; 3) {
	case OREAD:
		p = AREAD;
		break;
	case OWRITE:
		p = AWRITE;
		break;
	case ORDWR:
		p = AREAD|AWRITE;
		break;
	case OEXEC:
		p = AEXEC;
		break;
	default:
		p = 0;
		break;
	}

	if((p &amp; m) != p) {
		respond(r, Eperm);
		return;
	}

	if(readonly &amp;&amp; (p &amp; AWRITE) != 0) {
		respond(r, Erofs);
		return;
	}

	r-&gt;ofcall.qid = eqid(e);
	if(r-&gt;ofcall.qid.type &amp; QTDIR) {
		if((p &amp; AWRITE) != 0) {
			respond(r, Eisdir);
			return;
		}
		s-&gt;r = ediropen(s-&gt;e);
	}
	else if(r-&gt;ifcall.mode &amp; OTRUNC) {
		err = need(Ntrunc);
		if(err != nil) {
			respond(r, err);
			return;
		}
		j.type = FT_trunc;
		j.tnum = e-&gt;fnum;
		j.mtime = now();
		etrunc(e, 0, j.mtime);
		j.fnum = e-&gt;fnum;
		j.parent = e-&gt;parent-&gt;fnum;
		j.mode = e-&gt;mode;
		strcpy(j.name, e-&gt;name);
		put(&amp;j, 1);
	}

	respond(r, nil);
}

static void
flcreate(Req *r)
{
	Jrec j;
	State *s;
	char *err;
	Entry *e, *f;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	if((e-&gt;mode &amp; DMDIR) == 0) {
		respond(r, Eisdir);
		return;
	}

	if(!writeable(e)) {
		respond(r, Eperm);
		return;
	}

	if(strlen(r-&gt;ifcall.name) &gt; MAXNSIZE) {
		respond(r, "filename too long");
		return;
	}

	err = need(Ncreate);
	if(err != nil) {
		respond(r, err);
		return;
	}

	j.type = FT_create;
	j.mtime = now();
	j.parent = e-&gt;fnum;
	j.mode = r-&gt;ifcall.perm;
	strcpy(j.name, r-&gt;ifcall.name);

	f = ecreate(e, r-&gt;ifcall.name, 0, r-&gt;ifcall.perm, j.mtime, &amp;err);
	if(f == nil) {
		respond(r, err);
		return;
	}

	j.fnum = f-&gt;fnum;
	put(&amp;j, 1);
	s-&gt;e = f;
	r-&gt;ofcall.qid = eqid(f);
	respond(r, nil);
}

static void
flread(Req *r)
{
	Entry *e;
	State *s;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;

	if(e-&gt;mode &amp; DMDIR)
		r-&gt;ofcall.count = edirread(s-&gt;r, r-&gt;ofcall.data, r-&gt;ifcall.count);
	else
		r-&gt;ofcall.count = eread(e, eparity, r-&gt;ofcall.data, r-&gt;ifcall.count, r-&gt;ifcall.offset);

	respond(r, nil);
}

static void
flwrite(Req *r)
{
	Jrec j;
	uchar *a;
	Entry *e;
	State *s;
	Extent *x;
	char *err;
	ulong c, n, o, mtime;

	c = r-&gt;ifcall.count;
	o = r-&gt;ifcall.offset;
	a = (uchar *)r-&gt;ifcall.data;

	if(c == 0) {
		respond(r, nil);
		return;
	}

	if(o + c &gt;= MAXFSIZE) {
		respond(r, "file too big");
		return;
	}

	if(used + c &gt; limit) {
		respond(r, "filesystem full");
		return;
	}

	r-&gt;ofcall.count = c;
	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	mtime = now();

	for(;;) {
		n = c;
		if(n &gt; maxwrite)
			n = maxwrite;

		err = need(Nwrite + n);
		if(err != nil) {
			respond(r, err);
			return;
		}

		x = emalloc9p(sizeof(Extent));
		x-&gt;size = n;
		x-&gt;off = o;
		ewrite(e, x, eparity, mtime);
		j.type = FT_WRITE;
		j.fnum = e-&gt;fnum;
		j.size = n;
		j.offset = o;
		j.mtime = mtime;
		putw(&amp;j, 1, x, a);
		c -= n;

		if(c == 0)
			break;

		o += n;
		a += n;
	}

	respond(r, nil);
}

static void
flremove(Req *r)
{
	Jrec j;
	State *s;
	Entry *e;
	char *d, *err;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	if(writeable(e-&gt;parent)) {
		err = need(Nremove);
		if(err != nil) {
			respond(r, err);
			return;
		}

		d = eremove(e);
		if(d == nil) {
			j.type = FT_REMOVE;
			j.fnum = e-&gt;fnum;
			put(&amp;j, 0);
		}
		respond(r, d);
	}
	else
		respond(r, Eperm);
}

static void
flstat(Req *r)
{
	State *s;

	s = r-&gt;fid-&gt;aux;
	estat(s-&gt;e, &amp;r-&gt;d, 1);
	respond(r, nil);
}

static void
flwstat(Req *r)
{
	int m;
	Jrec j;
	State *s;
	Entry *e;
	char *err;

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;

	if(readonly) {
		respond(r, Erofs);
		return;
	}

	if(e-&gt;fnum == 0) {
		respond(r, Eperm);
		return;
	}

	m = r-&gt;d.mode &amp; 0777;
	if(m != (e-&gt;mode &amp; 0777)) {
		err = need(Nchmod);
		if(err != nil) {
			respond(r, err);
			return;
		}

		echmod(e, m, 0);
		j.type = FT_chmod;
		j.mode = m;
		j.fnum = e-&gt;fnum;
		j.mnum = e-&gt;mnum;
		put(&amp;j, 0);
	}
	respond(r, nil);
}

static void
flwalk(Req *r)
{
	int i;
	State *s;
	char *err;
	Entry *e, *f;

	if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid)
		r-&gt;newfid-&gt;aux = state(nil);

	s = r-&gt;fid-&gt;aux;
	e = s-&gt;e;
	f = e;
	e-&gt;ref++;
	err = nil;
	for(i = 0; i &lt; r-&gt;ifcall.nwname; i++) {
		f = ewalk(e, r-&gt;ifcall.wname[i], &amp;err);
		if(f) {
			r-&gt;ofcall.wqid[i] = eqid(f);
			e = f;
		}
		else {
			e-&gt;ref--;
			break;
		}
	}
	r-&gt;ofcall.nwqid = i;
	if (i) err = nil;

	if(f) {
		if(r-&gt;ifcall.fid != r-&gt;ifcall.newfid) {
			s = r-&gt;newfid-&gt;aux;
			s-&gt;e = f;
			r-&gt;newfid-&gt;qid = eqid(f);
		}
		else {
			s = r-&gt;fid-&gt;aux;
			s-&gt;e-&gt;ref--;
			s-&gt;e = f;
			r-&gt;fid-&gt;qid = eqid(f);
		}
	}
	respond(r, err);
}

void
serve(char *mount)
{
	flashsrv.attach = flattach;
	flashsrv.open = flopen;
	flashsrv.create = flcreate;
	flashsrv.read = flread;
	flashsrv.write = flwrite;
	flashsrv.remove = flremove;
	flashsrv.stat = flstat;
	flashsrv.wstat = flwstat;
	flashsrv.walk = flwalk;

	flashsrv.destroyfid = destroy;
	flashsrv.destroyreq = trace;
	postmountsrv(&amp;flashsrv, "brzr", mount, MREPL|MCREATE);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

