<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/gps/gpsevermore.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/gps/gpsevermore.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "dat.h"

char *serial = "/dev/eia0";

int ttyfd, ctlfd, debug;
int baud = Baud;
char *baudstr = "b%dd1r1pns1l8i1w5";

Place where = {-(74.0 + 23.9191/60.0), 40.0 + 41.1346/60.0};

void	setline(void);
void	evermore80(Place, int);
void	evermore89(int);
void	evermore8e(void);

void
setline(void){
	char *serialctl;

	serialctl = smprint("%sctl", serial);
	if((ttyfd = open(serial, ORDWR)) &lt; 0)
		sysfatal("%s: %r", serial);
	if((ctlfd = open(serialctl, OWRITE)) &gt;= 0){
		if(fprint(ctlfd, baudstr, baud) &lt; 0)
			sysfatal("%s: %r", serialctl);
	}
	free(serialctl);
}

enum {
	GGAon = 0x01,
	GLLon = 0x02,
	GSAon = 0x04,
	GSVon = 0x08,
	RMCon = 0x10,
	VTGon = 0x20,
	CRCon = 0x40,
	EMTon = 0x80
};

char*
putbyte(char *s, int v)
{
	*s++ = v;
	if((v &amp; 0xff) == 0x10)
		*s++ = v;
	return s;
}

char*
putshort(char *s, int v)
{
	s = putbyte(s, v);
	s = putbyte(s, v &gt;&gt; 8);
	return s;
}

char*
putlong(char *s, long v)
{
	s = putbyte(s, v);
	s = putbyte(s, v &gt;&gt; 8);
	s = putbyte(s, v &gt;&gt; 16);
	s = putbyte(s, v &gt;&gt; 24);
	return s;
}

void
evermoresend(char *body, int l)
{
	char buf[8], *s;
	int crc, i;

	s = buf;
	*s++ = 0x10;			/* DCE */
	*s++ = 0x02;			/* STX */
	s = putbyte(s, l);		/* length */
	write(ttyfd, buf, s-buf);	/* write header */

	write(ttyfd, body, l);		/* write body */

	crc = 0;
	for(i = 0; i &lt; l; i++)
		crc += body[i];		/* calculate crc */
	s = buf;
	s = putbyte(s, crc);		/* checksum */
	*s++ = 0x10;			/* DCE */
	*s++ = 0x03;			/* ETX */
	write(ttyfd, buf, s-buf);	/* write trailer */
}

void
evermore80(Place pl, int baud)
{
	char buf[32], *s;
	long now, seconds, week;

	fprint(2, "Evermore80");

	time(&amp;now);
	seconds = now - 315964800;
	week = (seconds / (7*24*3600));
	seconds = seconds %  (7*24*3600);
	s = buf;

	s = putbyte(s, 0x80);		/* message ID */
	s = putshort(s, week);		/* week number */
	s = putlong(s, seconds*100);	/* seconds */
	s = putshort(s, pl.lat*10.0);	/* latitude tenths degree */
	s = putshort(s, pl.lon*10.0);	/* longitude tenths degree */
	s = putshort(s, 100);		/* altitude meters */
	s = putshort(s, 0);		/* datumn ID */
	s = putbyte(s, 2);		/* warm start */
	s = putbyte(s, GGAon|GSAon|GSVon|RMCon|CRCon);
	switch(baud){
	case 4800:	s = putbyte(s, 0);	break;
	case 9600:	s = putbyte(s, 1);	break;
	case 19200:	s = putbyte(s, 2);	break;
	case 38400:	s = putbyte(s, 3);	break;
	default:
		sysfatal("Illegal baud rate");
	}

	evermoresend(buf, s - buf);
	fprint(2, "\n");
}

void
evermore89(int baud)
{
	char buf[32], *s;

	fprint(2, "Evermore89");
	s = buf;
	s = putbyte(s, 0x89);		/* message ID */
	s = putbyte(s, 0x01);		/* set main serial port */
	switch(baud){
	case  4800:	s = putbyte(s, 0x00);	break;
	case  9600:	s = putbyte(s, 0x01);	break;
	case 19200:	s = putbyte(s, 0x02);	break;
	case 38400:	s = putbyte(s, 0x03);	break;
	default:
		sysfatal("illegal baud rate %d", baud);
	}

	evermoresend(buf, s - buf);
	fprint(2, "\n");
}

void
evermore8e(void)
{
	char buf[32], *s;

	fprint(2, "Evermore8e");
	s = buf;
	s = putbyte(s, 0x8e);		/* message ID */
	s = putbyte(s, GGAon|GSAon|GSVon|RMCon);		/* all messages except GLL and VTG */
	s = putbyte(s, 0x01);		/* checksum on */
	s = putbyte(s, 0x01);		/* GGA update rate */
	s = putbyte(s, 0x0b);		/* GLL update rate */
	s = putbyte(s, 0x0a);		/* GSA update rate */
	s = putbyte(s, 0x14);		/* GSV update rate */
	s = putbyte(s, 0x08);		/* RMC update rate */
	s = putbyte(s, 0x0d);		/* VTG update rate */

	evermoresend(buf, s - buf);
	fprint(2, "\n");
}

void
main(int argc, char*argv[])
{
	char *p;
	Place pl;
	int newbaud;

	newbaud = -1;
	pl = nowhere;
	ARGBEGIN {
	default:
		fprint(2, "usage: %s [-b baud] [-d device] [-l longitude latitude] [-n newbaud]\n", argv0);
		exits("usage");
	case 'D':
		debug++;
		break;
	case 'b':
		baud = strtol(ARGF(), nil, 0);
		break;
	case 'd':
		serial = ARGF();
		break;
	case 'l':
		p = ARGF();
		if(strtolatlon(p, &amp;p, &amp;pl) &lt; 0)
			sysfatal("bad position");
		while(*p == ' ' || *p == '\t' || *p == '\n')
			p++;
		if(*p == '\0')
			p = ARGF();
		if (strtolatlon(p, &amp;p, &amp;pl) &lt; 0)
			sysfatal("bad position");
		while(*p == ' ' || *p == '\t' || *p == '\n')
			p++;
		if(*p != '\0')
			sysfatal("trailing gunk in position");
		where = pl;
		break;
	case 'n':
		newbaud = strtol(ARGF(), nil, 0);
		break;
	} ARGEND

	if(newbaud &lt; 0)
		newbaud = baud;

	fmtinstall('L', placeconv);
	print("Initializing GPS to %d baud, at %L, time %s\n",
		newbaud, where, ctime(time(nil)));
	setline();
	evermore80(where, newbaud);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

