<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/gps/util.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/gps/util.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "dat.h"

Place nowhere = {
	Undef, Undef
};

static void
setlat(Place *p, double lat)
{
	p-&gt;lat = lat;
}

static void
setlon(Place *p, double lon)
{
	p-&gt;lon = lon;
}

static int
printlatlon(char *p, int n, double lat, char po, char ne)
{
	char c;
	double d;
	int deg, min, sec;

	if(lat &gt; 0)
		c = po;
	else if(lat &lt; 0){
		c = ne;
		lat = -lat;
	} else
		c = ' ';
	sec = 3600 * modf(lat, &amp;d);
	deg = d;
	min = sec/60;
	sec = sec % 60;
	return snprint(p, n, "%#3.3d°%#2.2d′%#2.2d″%c", deg, min, sec, c);
}

int
placeconv(Fmt *fp)
{
	char str[256];
	int n;
	Place pl;

	pl = va_arg(fp-&gt;args, Place);
	n = 0;
	n += printlatlon(str+n, sizeof(str)-n, pl.lat, 'N', 'S');
	n += snprint(str+n, sizeof(str)-n, ", ");
	printlatlon(str+n, sizeof(str)-n, pl.lon, 'E', 'W');
	return fmtstrcpy(fp, str);
}

int
strtolatlon(char *p, char **ep, Place *pl)
{
	double latlon;
	int neg = 0;

	while(*p == '0') p++;
	latlon = strtod(p, &amp;p);
	if(latlon &lt; 0){
		latlon = -latlon;
		neg = 1;
	}
	if(*p == ':'){
		p++;
		while(*p == '0') p++;
		latlon += strtod(p, &amp;p)/60.0;
		if(*p == ':'){
			p++;
			while(*p == '0') p++;
			latlon += strtod(p, &amp;p)/3600.0;
		}
	}
	switch (*p++){
	case 'N':
	case 'n':
		if(neg) latlon = -latlon;
		if(pl-&gt;lat != Undef)
			return -1;
		setlat(pl, latlon);
		break;
	case 'S':
	case 's':
		if(!neg) latlon = -latlon;
		if(pl-&gt;lat != Undef)
			return -1;
		setlat(pl, latlon);
		break;
	case 'E':
	case 'e':
		if(neg) latlon = -latlon;
		if(pl-&gt;lon != Undef)
			return -1;
		setlon(pl, latlon);
		break;
	case 'W':
	case 'w':
		if(!neg) latlon = -latlon;
		if(pl-&gt;lon != Undef)
			return -1;
		setlon(pl, latlon);
		break;
	case '\0':
	case ' ':
	case '\t':
	case '\n':
		p--;
		if(neg) latlon = -latlon;
		if(pl-&gt;lat == Undef){
			setlat(pl, latlon);
		} else if(pl-&gt;lon == Undef){
			latlon = -latlon;
			setlon(pl, latlon);
		} else return -1;
		break;
	default:
		return -1;
	}
	if(ep)
		*ep = p;
	return 0;
}

Place
strtopos(char *p, char **ep)
{
	Place pl = nowhere;

	if(strtolatlon(p, &amp;p, &amp;pl) &lt; 0)
		return nowhere;
	while(*p == ' ' || *p == '\t' || *p == '\n')
		p++;
	if(strtolatlon(p, &amp;p, &amp;pl) &lt; 0)
		return nowhere;
	if(ep)
		*ep = p;
	return pl;
}

static void
rtcset(long t)		/* We may use this some day */
{
	static int fd;
	long r;
	int n;
	char buf[32];

	if(fd &lt;= 0 &amp;&amp; (fd = open("#r/rtc", ORDWR)) &lt; 0){
		fprint(2, "Can't open #r/rtc: %r\n");
		return;
	}
	n = read(fd, buf, sizeof buf - 1);
	if(n &lt;= 0){
		fprint(2, "Can't read #r/rtc: %r\n");
		return;
	}
	buf[n] = '\0';
	r = strtol(buf, nil, 0);
	if(r &lt;= 0){
		fprint(2, "ridiculous #r/rtc: %ld\n", r);
		return;
	}
	if(r - t &gt; 1 || t - r &gt; 0){
		seek(fd, 0, 0);
		fprint(fd, "%ld", t);
		fprint(2, "correcting #r/rtc: %ld → %ld\n", r, t);
	}
	seek(fd, 0, 0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

