<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/ms2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/ms2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

void	record(uchar*, long);
void	usage(void);
void	segment(vlong, vlong);

enum
{
	Recordsize = 32,
};

int	dsegonly;
int	supressend;
int	binary;
int	halfswap;
int	srec = 2;
uvlong	addr;
uvlong 	psize = 4096;
Biobuf 	stdout;
Fhdr	exech;
Biobuf *bio;

void
main(int argc, char **argv)
{
	Dir *dir;
	uvlong totsz;

	ARGBEGIN{
	case 'd':
		dsegonly++;
		break;
	case 's':
		supressend++;
		break;
	case 'a':
		addr = strtoull(ARGF(), 0, 0);
		break;
	case 'p':
		psize = strtoul(ARGF(), 0, 0);
		break;
	case 'b':
		binary++;
		break;
	case 'h':
		halfswap++;
		break;
	case '1':
		srec = 1;
		break;
	case '2':
		srec = 2;
		break;
	case '3':
		srec = 3;
		break;
	default:
		usage();
	}ARGEND

	if(argc != 1)
		usage();

	Binit(&amp;stdout, 1, OWRITE);

	bio = Bopen(argv[0], OREAD);
	if(bio == 0) {
		fprint(2, "ms2: open %s: %r\n", argv[0]);
		exits("open");
	}

	if(binary) {
		if((dir = dirfstat(Bfildes(bio))) == nil) {
			fprint(2, "ms2: stat failed %r");
			exits("dirfstat");
		}
		segment(0, dir-&gt;length);
		Bprint(&amp;stdout, "S9030000FC\n");
		Bterm(&amp;stdout);
		Bterm(bio);
		free(dir);
		exits(0);
	}

	if(!crackhdr(Bfildes(bio), &amp;exech)) {
		fprint(2, "ms2: can't decode file header\n");
		return;
	}

	totsz = exech.txtsz + exech.datsz + exech.bsssz;
	fprint(2, "%s: %lud+%lud+%lud=%llud\n",
		exech.name, exech.txtsz, exech.datsz, exech.bsssz, totsz);

	if(dsegonly)
		segment(exech.datoff, exech.datsz);
	else {
		segment(exech.txtoff, exech.txtsz);
		addr = (addr+(psize-1))&amp;~(psize-1);
		segment(exech.datoff, exech.datsz);
	}

	if(supressend == 0) {
		switch(srec) {
		case 1:
		case 2:
			Bprint(&amp;stdout, "S9030000FC\n");
			break;
		case 3:
			Bprint(&amp;stdout, "S705000000FA\n");
			break;
		}
	}

	Bterm(&amp;stdout);
	Bterm(bio);
	exits(0);
}

void
segment(vlong foff, vlong len)
{
	int i;
	long l, n;
	uchar t, buf[2*Recordsize];

	Bseek(bio, foff, 0);
	for(;;) {
		l = len;
		if(l &gt; Recordsize)
			l = Recordsize;
		n = Bread(bio, buf, l);
		if(n == 0)
			break;
		if(n &lt; 0) {
			fprint(2, "ms2: read error: %r\n");
			exits("read");
		}
		if(halfswap) {
			if(n &amp; 1) {
				fprint(2, "ms2: data must be even length\n");
				exits("even");
			}
			for(i = 0; i &lt; n; i += 2) {
				t = buf[i];
				buf[i] = buf[i+1];
				buf[i+1] = t;
			}
		}
		record(buf, l);
		len -= l;
	}
}

void
record(uchar *s, long l)
{
	int i;
	ulong cksum = 0;

	switch(srec) {
	case 1:
		cksum = l+3;
		Bprint(&amp;stdout, "S1%.2lX%.4lluX", l+3, addr);
		cksum += addr&amp;0xff;
		cksum += (addr&gt;&gt;8)&amp;0xff;
		break;
	case 2:
		cksum = l+4;
		Bprint(&amp;stdout, "S2%.2lX%.6lluX", l+4, addr);
		cksum += addr&amp;0xff;
		cksum += (addr&gt;&gt;8)&amp;0xff;
		cksum += (addr&gt;&gt;16)&amp;0xff;
		break;
	case 3:
		cksum = l+5;
		Bprint(&amp;stdout, "S3%.2lX%.8lluX", l+5, addr);
		cksum += addr&amp;0xff;
		cksum += (addr&gt;&gt;8)&amp;0xff;
		cksum += (addr&gt;&gt;16)&amp;0xff;
		cksum += (addr&gt;&gt;24)&amp;0xff;
		break;
	}

	for(i = 0; i &lt; l; i++) {
		cksum += *s;
		Bprint(&amp;stdout, "%.2X", *s++);
	}
	Bprint(&amp;stdout, "%.2luX\n", (~cksum)&amp;0xff);
	addr += l;
}

void
usage(void)
{
	fprint(2, "usage: ms2 [-dsbh] [-a address] [-p pagesize] ?.out\n");
	exits("usage");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

