<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/nfsmount.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/nfsmount.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright © 2003 Russ Cox, MIT; see /sys/src/libsunrpc/COPYING */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;
#include &lt;nfs3.h&gt;

int chatty;
SunClient *client;

void
usage(void)
{
	fprint(2, "usage: nfsmount address [cmd]\n"
		"cmd is one of:\n"
		"\tnull\n"
		"\tmnt path\n"
		"\tdump\n"
		"\tumnt path\n"
		"\tumntall\n"
		"\texport (default)\n");
	threadexitsall("usage");
}

void
portCall(SunCall *c, PortCallType type)
{
	c-&gt;rpc.prog = PortProgram;
	c-&gt;rpc.vers = PortVersion;
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.iscall = !(type&amp;1);
	c-&gt;type = type;
}

int
getport(SunClient *client, uint prog, uint vers, uint prot, uint *port)
{
	PortTGetport tx;
	PortRGetport rx;

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTGetport);
	tx.map.prog = prog;
	tx.map.vers = vers;
	tx.map.prot = prot;

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRGetport);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	*port = rx.port;
	return 0;
}

uchar unixauth[] = {
	0x12, 0x23, 0x34, 0x45,	/* stamp */
	0x00, 0x00, 0x00, 0x04,	/* gnot */
	0x67, 0x6e, 0x6f, 0x74,
	0x00, 0x00, 0x03, 0xE9,	/* 1001 */
	0x00, 0x00, 0x03, 0xE9,	/* 1001 */
	0x00, 0x00, 0x00, 0x00,	/* gid list */
};
void
mountCall(SunCall *c, NfsMount3CallType type)
{
	c-&gt;rpc.prog = NfsMount3Program;
	c-&gt;rpc.vers = NfsMount3Version;
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.iscall = !(type&amp;1);
	if(c-&gt;rpc.iscall){
		c-&gt;rpc.cred.flavor = SunAuthSys;
		c-&gt;rpc.cred.data = unixauth;
		c-&gt;rpc.cred.ndata = sizeof unixauth;
	}
	c-&gt;type = type;
}

void
tnull(char **argv)
{
	NfsMount3TNull tx;
	NfsMount3RNull rx;

	USED(argv);

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTNull);

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRNull);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");
}

void
tmnt(char **argv)
{
	int i;
	NfsMount3TMnt tx;
	NfsMount3RMnt rx;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTMnt);
	tx.path = argv[0];

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRMnt);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	if(rx.status != 0){
		nfs3Errstr(rx.status);
		sysfatal("mnt: %r");
	}

	print("handle %.*H\n", rx.len, rx.handle);
	print("auth:");
	for(i=0; i&lt;rx.nauth; i++)
		print(" %ud", (uint)rx.auth[i]);
	print("\n");
}

void
tdump(char **argv)
{
	uchar *p, *ep;
	NfsMount3TDump tx;
	NfsMount3RDump rx;
	NfsMount3Entry e;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTDump);
	USED(argv);

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRDump);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	p = rx.data;
	ep = p+rx.count;
	while(p &lt; ep){
		if(nfsMount3EntryUnpack(p, ep, &amp;p, &amp;e) &lt; 0)
			sysfatal("unpack entry structure failed");
		print("%s %s\n", e.host, e.path);
	}
}

void
tumnt(char **argv)
{
	NfsMount3TUmnt tx;
	NfsMount3RUmnt rx;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTUmnt);
	tx.path = argv[0];

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRUmnt);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	print("\n");
}

void
tumntall(char **argv)
{
	NfsMount3TUmntall tx;
	NfsMount3RUmntall rx;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTUmntall);
	USED(argv);

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRUmntall);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		sysfatal("rpc: %r");

	print("\n");
}

void
texport(char **argv)
{
	uchar *p, *ep, *tofree;
	char **g, **gg;
	int ng, i, n;
	NfsMount3TDump tx;
	NfsMount3RDump rx;
	NfsMount3Export e;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(&amp;tx.call, NfsMount3CallTExport);
	USED(argv);

	memset(&amp;rx, 0, sizeof rx);
	mountCall(&amp;rx.call, NfsMount3CallRExport);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, &amp;tofree) &lt; 0)
		sysfatal("rpc: %r");

	p = rx.data;
	ep = p+rx.count;
	g = nil;
	ng = 0;
	while(p &lt; ep){
		n = nfsMount3ExportGroupSize(p);
		if(n &gt; ng){
			ng = n;
			g = erealloc(g, sizeof(g[0])*ng);
		}
		if(nfsMount3ExportUnpack(p, ep, &amp;p, g, &amp;gg, &amp;e) &lt; 0)
			sysfatal("unpack export structure failed");
		print("%s", e.path);
		for(i=0; i&lt;e.ng; i++)
			print(" %s", e.g[i]);
		print("\n");
	}
	free(tofree);
}

static struct {
	char *cmd;
	int narg;
	void (*fn)(char**);
} tab[] = {
	"null",	0,	tnull,
	"mnt",	1,	tmnt,
	"dump",	0,	tdump,
	"umnt",	1,	tumnt,
	"umntall",	1,	tumntall,
	"export",	0,	texport,
};

char*
netchangeport(char *addr, char *port)
{
	static char buf[256];
	char *r;

	strecpy(buf, buf+sizeof buf, addr);
	r = strrchr(buf, '!');
	if(r == nil)
		return nil;
	r++;
	strecpy(r, buf+sizeof buf, port);
	return buf;
}

void
threadmain(int argc, char **argv)
{
	char *dflt[] = { "export", };
	char *addr, *cmd;
	int i, proto;
	uint port;
	char buf[32];
	int mapit;

	mapit = 1;
	ARGBEGIN{
	case 'R':
		chatty++;
		break;
	case 'm':
		mapit = 0;
		break;
	}ARGEND

	if(argc &lt; 1)
		usage();

	fmtinstall('B', sunRpcFmt);
	fmtinstall('C', sunCallFmt);
	fmtinstall('H', encodefmt);
	sunFmtInstall(&amp;portProg);
	sunFmtInstall(&amp;nfsMount3Prog);

	addr = netmkaddr(argv[0], "udp", "portmap");
	if(mapit){
		/* translate with port mapper */
		fprint(2, "connecting to %s\n", addr);
		if((client = sunDial(addr)) == nil)
			sysfatal("dial %s: %r", addr);
		client-&gt;chatty = chatty;
		sunClientProg(client, &amp;portProg);
		if(strstr(addr, "udp!"))
			proto = PortProtoUdp;
		else
			proto = PortProtoTcp;
		if(getport(client, NfsMount3Program, NfsMount3Version, proto, &amp;port) &lt; 0)
			sysfatal("getport: %r");
		snprint(buf, sizeof buf, "%ud!r", port);
		addr = netchangeport(addr, buf);
		sunClientClose(client);
	}

	fprint(2, "connecting to %s\n", addr);
	if((client = sunDial(addr)) == nil)
		sysfatal("dial %s: %r", addr);

	client-&gt;chatty = chatty;
	sunClientProg(client, &amp;nfsMount3Prog);

	argv++;
	argc--;

	if(argc == 0){
		argc = 1;
		argv = dflt;
	}
	cmd = argv[0];
	argv++;
	argc--;

	for(i=0; i&lt;nelem(tab); i++){
		if(strcmp(tab[i].cmd, cmd) == 0){
			if(tab[i].narg != argc)
				usage();
			(*tab[i].fn)(argv);
			threadexitsall(nil);
		}
	}
	usage();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

