<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/olefs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/olefs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

/* little endian */
#define SHORT(p)	(((uchar*)(p))[0] | (((uchar*)(p))[1] &lt;&lt; 8))
#define LONG(p)	((ulong)SHORT(p) |(((ulong)SHORT((p)+2)) &lt;&lt; 16))

typedef struct Ofile	Ofile;
typedef struct Odir	Odir;

enum {
	/* special block map entries */
	Bspecial = 0xFFFFFFFD,
	Bendchain = 0xFFFFFFFE,
	Bunused = 0xFFFFFFFF,

	Blocksize = 0x200,

	Odirsize = 0x80,

	/* Odir types */
	Tstorage = 1,
	Tstream = 2,
	Troot = 5,
};

/*
 * the file consists of chains of blocks of size 0x200.
 * to find what block follows block n, you look at 
 * blockmap[n].  that block follows it unless it is Bspecial
 * or Bendchain.
 * 
 * it's like the MS-DOS file system allocation tables.
 */
struct Ofile {
	Biobuf *b;
	ulong nblock;
	ulong *blockmap;
	ulong rootblock;
	ulong smapblock;
	ulong *smallmap;
};

/* Odir headers are found in directory listings in the Olefile */
/* prev and next form a binary tree of directory entries */
struct Odir {
	Ofile *f;
	Rune name[32+1];
	uchar type;
	uchar isroot;
	ulong left;
	ulong right;
	ulong dir;
	ulong start;
	ulong size;
};

void*
emalloc(ulong sz)
{
	void *v;

	v = malloc(sz);
	assert(v != nil);
	return v;
}

int
convM2OD(Odir *f, void *buf, int nbuf)
{
	int i;
	char *p;
	int len;

	if(nbuf &lt; Odirsize)
		return -1;

	/*
	 * the short at 0x40 is the length of the name.
	 * when zero, it means there is no Odir here.
	 */
	p = buf;
	len = SHORT(p+0x40);
	if(len == 0)
		return 0;

	if(len &gt; 32)	/* shouldn't happen */
		len = 32;

	for(i=0; i&lt;len; i++)
		f-&gt;name[i] = SHORT(p+i*2);
	f-&gt;name[len] = 0;

	f-&gt;type = p[0x42];
	f-&gt;left = LONG(p+0x44);
	f-&gt;right = LONG(p+0x48);
	f-&gt;dir = LONG(p+0x4C);
	f-&gt;start = LONG(p+0x74);
	f-&gt;size = LONG(p+0x78);

	/* BUG: grab time in ms format from here */

	return 1;
}

int
oreadblock(Ofile *f, int block, ulong off, char *buf, int nbuf)
{
	int n;

	if(block &lt; 0 || block &gt;= f-&gt;nblock) {
		werrstr("attempt to read %x/%lux\n", block, f-&gt;nblock);
		return -1;
	}

	if(off &gt;= Blocksize){
		print("offset too far into block\n");
		return 0;
	}

	if(off+nbuf &gt; Blocksize)
		nbuf = Blocksize-off;

	/* blocks start numbering at -1 [sic] */
	off += (block+1)*Blocksize;

	if(Bseek(f-&gt;b, off, 0) != off){
		print("seek failed\n");
		return -1;
	}

	n = Bread(f-&gt;b, buf, nbuf);
	if(n &lt; 0)
		print("Bread failed: %r");
	return n;
}

int
chainlen(Ofile *f, ulong start)
{
	int i;
	for(i=0; start &lt; 0xFFFF0000; i++)
		start = f-&gt;blockmap[start];

	return i;
}

/*
 * read nbuf bytes starting at offset off from the 
 * chain whose first block is block.  the chain is linked
 * together via the blockmap as described above,
 * like the MS-DOS file allocation tables.
 */
int
oreadchain(Ofile *f, ulong block, int off, char *buf, int nbuf)
{
	int i;
	int offblock;

	offblock = off/Blocksize;
	for(i=0; i&lt;offblock &amp;&amp; block &lt; 0xFFFF0000; i++)
		block = f-&gt;blockmap[block];
	return oreadblock(f, block, off%Blocksize, buf, nbuf);
}

int 
oreadfile(Odir *d, int off, char *buf, int nbuf)
{
	/*
	 * if d-&gt;size &lt; 0x1000 then d-&gt;start refers
	 * to a small depot block, else a big one.
	 * if this is the root entry, it's a big one
	 * no matter what.
	 */

	if(off &gt;= d-&gt;size)
		return 0;
	if(off+nbuf &gt; d-&gt;size)
		nbuf = d-&gt;size-off;

	if(d-&gt;size &gt;= 0x1000 
	|| memcmp(d-&gt;name, L"Root Entry", 11*sizeof(Rune)) == 0)
		return oreadchain(d-&gt;f, d-&gt;start, off, buf, nbuf);
	else {	/* small block */
		off += d-&gt;start*64;
		return oreadchain(d-&gt;f, d-&gt;f-&gt;smapblock, off, buf, nbuf);
	}
}

int
oreaddir(Ofile *f, int entry, Odir *d)
{
	char buf[Odirsize];

	if(oreadchain(f, f-&gt;rootblock, entry*Odirsize, buf, Odirsize) != Odirsize)
		return -1;

	d-&gt;f = f;
	return convM2OD(d, buf, Odirsize);
}

void
dumpdir(Ofile *f, ulong dnum)
{
	Odir d;

	if(oreaddir(f, dnum, &amp;d) != 1) {
		fprint(2, "dumpdir %lux failed\n", dnum);
		return;
	}

	fprint(2, "%.8lux type %d size %lud l %.8lux r %.8lux d %.8lux (%S)\n", dnum, d.type, d.size, d.left, d.right, d.dir, d.name);
	if(d.left != (ulong)-1) 
		dumpdir(f, d.left);
	if(d.right != (ulong)-1)
		dumpdir(f, d.right);
	if(d.dir != (ulong)-1)
		dumpdir(f, d.dir);
}

Ofile*
oleopen(char *fn)
{
	int i, j, k, block;
	int ndepot;
	ulong u;
	Odir rootdir;
	ulong extrablock;
	uchar buf[Blocksize];

	Ofile *f;
	Biobuf *b;
	static char magic[] = {
		0xD0, 0xCF, 0x11, 0xE0,
		0xA1, 0xB1, 0x1A, 0xE1
	};

	b = Bopen(fn, OREAD);
	if(b == nil)
		return nil;

	/* the first bytes are magic */
	if(Bread(b, buf, sizeof magic) != sizeof magic
	|| memcmp(buf, magic, sizeof magic) != 0) {
		Bterm(b);
		werrstr("bad magic: not OLE file");
		return nil;
	}

	f = emalloc(sizeof *f);
	f-&gt;b = b;

	/*
	 * the header contains a list of depots, which are
	 * block maps.  we assimilate them into one large map,
	 * kept in main memory.
	 */
	Bseek(b, 0, 0);
	if(Bread(b, buf, Blocksize) != Blocksize) {
		Bterm(b);
		free(f);
		print("short read\n");
		return nil;
	}

	ndepot = LONG(buf+0x2C);
	f-&gt;nblock = ndepot*(Blocksize/4);
//	fprint(2, "ndepot = %d f-&gt;nblock = %lud\n", ndepot, f-&gt;nblock);
	f-&gt;rootblock = LONG(buf+0x30);
	f-&gt;smapblock = LONG(buf+0x3C);
	f-&gt;blockmap = emalloc(sizeof(f-&gt;blockmap[0])*f-&gt;nblock);
	extrablock = LONG(buf+0x44);

	u = 0;

	/* the big block map fills to the end of the first 512-byte block */
	for(i=0; i&lt;ndepot &amp;&amp; i&lt;(0x200-0x4C)/4; i++) {
		if(Bseek(b, 0x4C+4*i, 0) != 0x4C+4*i
		|| Bread(b, buf, 4) != 4) {
			print("bseek %d fail\n", 0x4C+4*i);
			goto Die;
		}
		block = LONG(buf);
		if((ulong)block == Bendchain) {
			ndepot = i;
			f-&gt;nblock = ndepot*(Blocksize/4);
			break;
		}

		if(Bseek(b, (block+1)*Blocksize, 0) != (block+1)*Blocksize) {
			print("Xbseek %d fail\n", (block+1)*Blocksize);
			goto Die;
		}
		for(j=0; j&lt;Blocksize/4; j++) {
			if(Bread(b, buf, 4) != 4) {
				print("Bread fail seek block %x, %d i %d ndepot %d\n", block, (block+1)*Blocksize, i, ndepot);
				goto Die;
			}
			f-&gt;blockmap[u++] = LONG(buf);
		}
	}
	/*
	 * if the first block can't hold it, it continues in the block at LONG(hdr+0x44).
	 * if that in turn is not big enough, there's a next block number at the end of 
	 * each block.
	 */
	while(i &lt; ndepot) {
		for(k=0; k&lt;(0x200-4)/4 &amp;&amp; i&lt;ndepot; i++, k++) {
			if(Bseek(b, 0x200+extrablock*Blocksize+4*i, 0) != 0x200+extrablock*0x200+4*i
			|| Bread(b, buf, 4) != 4) {
				print("bseek %d fail\n", 0x4C+4*i);
				goto Die;
			}
			block = LONG(buf);
			if((ulong)block == Bendchain) {
				ndepot = i;
				f-&gt;nblock = ndepot*(Blocksize/4);
				goto Break2;
			}

			if(Bseek(b, (block+1)*Blocksize, 0) != (block+1)*Blocksize) {
				print("Xbseek %d fail\n", (block+1)*Blocksize);
				goto Die;
			}
			for(j=0; j&lt;Blocksize/4; j++) {
				if(Bread(b, buf, 4) != 4) {
					print("Bread fail seek block %x, %d i %d ndepot %d\n", block, (block+1)*Blocksize, i, ndepot);
					goto Die;
				}
				f-&gt;blockmap[u++] = LONG(buf);
			}
		}
		if(Bseek(b, 0x200+extrablock*Blocksize+Blocksize-4, 0) != 0x200+extrablock*Blocksize+Blocksize-4
		|| Bread(b, buf, 4) != 4) {
			print("bseek %d fail\n", 0x4C+4*i);
			goto Die;
		}
		extrablock = LONG(buf);
	}
Break2:;

	if(oreaddir(f, 0, &amp;rootdir) &lt;= 0){
		print("oreaddir could not read root\n");
		goto Die;
	}

	f-&gt;smapblock = rootdir.start;
	return f;

Die:
	Bterm(b);
	free(f-&gt;blockmap);
	free(f);
	return nil;
}

void
oleread(Req *r)
{
	Odir *d;
	char *p;
	int e, n;
	long c;
	vlong o;

	o = r-&gt;ifcall.offset;
	d = r-&gt;fid-&gt;file-&gt;aux;
	if(d == nil) {
		respond(r, "cannot happen");
		return;
	}

	c = r-&gt;ifcall.count;

	if(o &gt;= d-&gt;size) {
		r-&gt;ofcall.count = 0;
		respond(r, nil);
		return;
	}

	if(o+c &gt; d-&gt;size)
		c = d-&gt;size-o;

	/*
	 * oreadfile returns so little data, it will
	 * help to read as much as we can.
	 */
	e = c+o;
	n = 0;
	for(p=r-&gt;ofcall.data; o&lt;e; o+=n, p+=n) {
		n = oreadfile(d, o, p, e-o);
		if(n &lt;= 0)
			break;
	}

	if(n == -1 &amp;&amp; o == r-&gt;ifcall.offset)
		respond(r, "error reading word file");
	else {
		r-&gt;ofcall.count = o - r-&gt;ifcall.offset;
		respond(r, nil);
	}
}

Odir*
copydir(Odir *d)
{
	Odir *e;

	e = emalloc(sizeof(*d));
	*e = *d;
	return e;
}
		
void
filldir(File *t, Ofile *f, int dnum, int nrecur)
{
	Odir d;
	int i;
	Rune rbuf[40];
	char buf[UTFmax*nelem(rbuf)];
	File *nt;

	if(dnum == 0xFFFFFFFF || oreaddir(f, dnum, &amp;d) != 1)
		return;

	/*
	 * i hope there are no broken files with
	 * circular trees.  i hate infinite loops.
	 */
	if(nrecur &gt; 100)
		sysfatal("tree too large in office file: probably circular");

	filldir(t, f, d.left, nrecur+1);

	/* add current tree entry */
	runestrecpy(rbuf, rbuf+sizeof rbuf, d.name);
	for(i=0; rbuf[i]; i++)
		if(rbuf[i] == L' ')
			rbuf[i] = L'␣';
		else if(rbuf[i] &lt;= 0x20 || rbuf[i] == L'/' 
			|| (0x80 &lt;= rbuf[i] &amp;&amp; rbuf[i] &lt;= 0x9F))
				rbuf[i] = ':';
	
	snprint(buf, sizeof buf, "%S", rbuf);

	if(d.dir == 0xFFFFFFFF) {
		/* make file */
		nt = createfile(t, buf, nil, 0444, nil);
		if(nt == nil)
			sysfatal("nt nil: create %s: %r", buf);
		nt-&gt;aux = copydir(&amp;d);
		nt-&gt;length = d.size;
	} else /* make directory */
		nt = createfile(t, buf, nil, DMDIR|0777, nil);

	filldir(t, f, d.right, nrecur+1);

	if(d.dir != 0xFFFFFFFF)
		filldir(nt, f, d.dir, nrecur+1);

	closefile(nt);
}

Srv olesrv = {
	.read=	oleread,
};

void
main(int argc, char **argv)
{
	char *mtpt;
	Ofile *f;
	Odir d;

	mtpt = "/mnt/doc";
	ARGBEGIN{
	case 'm':
		mtpt = ARGF();
		break;
	
	default:
		goto Usage;
	}ARGEND

	if(argc != 1) {
	Usage:
		fprint(2, "usage: olefs file\n");
		exits("usage");
	}

	f = oleopen(argv[0]);
	if(f == nil) {
		print("error opening %s: %r\n", argv[0]);
		exits("open");
	}

//	dumpdir(f, 0);

	if(oreaddir(f, 0, &amp;d) != 1) {
		fprint(2, "oreaddir error: %r\n");
		exits("oreaddir");
	}

	olesrv.tree = alloctree(nil, nil, DMDIR|0777, nil);
	filldir(olesrv.tree-&gt;root, f, d.dir, 0);
	postmountsrv(&amp;olesrv, nil, mtpt, MREPL);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

