<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/pcmcia.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/pcmcia.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

enum
{
	Linktarget = 0x13,
	Funcid = 0x21,
	End =	0xff,
};

int fd;
int pos;

void	tdevice(int, int);
void	tlonglnkmfc(int, int);
void	tfuncid(int, int);
void	tcfig(int, int);
void	tentry(int, int);
void	tvers1(int, int);

void (*parse[256])(int, int) =
{
[1]		tdevice,
[6]		tlonglnkmfc,
[0x15]		tvers1,
[0x17]		tdevice,
[0x1A]		tcfig,
[0x1B]		tentry,
[Funcid]	tfuncid,
};

int hex;

void
fatal(char *fmt, ...)
{
	va_list arg;
	char buf[512];

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	fprint(2, "pcmcia: %s\n", buf);
	exits(buf);
}

int
readc(void *x)
{
	int rv;

	seek(fd, 2*pos, 0);
	pos++;
	rv = read(fd, x, 1);
	if(hex)
		print("%2.2ux ", *(uchar*)x);
	return rv;
}

int
tuple(int next, int expect)
{
	uchar link;
	uchar type;

	pos = next;
	if(readc(&amp;type) != 1)
		return -1;
	if(type == 0xff)
		return -1;
print("type %.2uX\n", type &amp; 0xff);

	if(expect &amp;&amp; expect != type){
		print("expected %.2uX found %.2uX\n", 
			expect, type);
		return -1;
	}

	if(readc(&amp;link) != 1)
		return -1;
	if(parse[type])
		(*parse[type])(type, link);
	if(link == 0xff)
		next = -1;
	else
		next = next+2+link;
	return next;
}

void
main(int argc, char *argv[])
{
	char *file;
	int next;

	ARGBEGIN{
	case 'x':
		hex = 1;
	}ARGEND;

	if(argc == 0)
		file = "#y/pcm0attr";
	else
		file = argv[0];

	fd = open(file, OREAD);
	if(fd &lt; 0)
		fatal("opening %s: %r", file);

	for(next = 0; next &gt;= 0;)
		next = tuple(next, 0);
}

ulong speedtab[16] =
{
[1]	250,
[2]	200,
[3]	150,
[4]	100,
};

ulong mantissa[16] =
{
[1]	10,
[2]	12,
[3]	13,
[4]	15,
[5]	20,
[6]	25,
[7]	30,
[8]	35,
[9]	40,
[0xa]	45,
[0xb]	50,
[0xc]	55,
[0xd]	60,
[0xe]	70,
[0xf]	80,
};

ulong exponent[8] =
{
[0]	1,
[1]	10,
[2]	100,
[3]	1000,
[4]	10000,
[5]	100000,
[6]	1000000,
[7]	10000000,
};

char *typetab[256] =
{
[1]	"Masked ROM",
[2]	"PROM",
[3]	"EPROM",
[4]	"EEPROM",
[5]	"FLASH",
[6]	"SRAM",
[7]	"DRAM",
[0xD]	"IO+MEM",
};

ulong
getlong(int size)
{
	uchar c;
	int i;
	ulong x;

	x = 0;
	for(i = 0; i &lt; size; i++){
		if(readc(&amp;c) != 1)
			break;
		x |= c&lt;&lt;(i*8);
	}
	return x;
}

void
tdevice(int ttype, int len)
{
	uchar id;
	uchar type;
	uchar speed, aespeed;
	uchar size;
	ulong bytes, ns;
	char *tname, *ttname;

	while(len &gt; 0){
		if(readc(&amp;id) != 1)
			return;
		len--;
		if(id == End)
			return;

		/* PRISM cards have a device tuple with id = size = 0. */
		if(id == 0x00){
			if(readc(&amp;size) != 1)
				return;
			len--;
			continue;
		}

		speed = id &amp; 0x7;
		if(speed == 0x7){
			if(readc(&amp;speed) != 1)
				return;
			len--;
			if(speed &amp; 0x80){
				if(readc(&amp;aespeed) != 1)
					return;
				ns = 0;
			} else
				ns = (mantissa[(speed&gt;&gt;3)&amp;0xf]*exponent[speed&amp;7])/10;
		} else
			ns = speedtab[speed];

		type = id&gt;&gt;4;
		if(type == 0xE){
			if(readc(&amp;type) != 1)
				return;
			len--;
		}
		tname = typetab[type];
		if(tname == 0)
			tname = "unknown";

		if(readc(&amp;size) != 1)
			return;
		len--;
		bytes = ((size&gt;&gt;3)+1) * 512 * (1&lt;&lt;(2*(size&amp;0x7)));

		if(ttype == 1)
			ttname = "device";
		else
			ttname = "attr device";
		print("%s %ld bytes of %ldns %s\n", ttname, bytes, ns, tname);
	}
}

void
tlonglnkmfc(int, int)
{
	int i, opos;
	uchar nfn, space, expect;
	int addr;

	readc(&amp;nfn);
	for(i = 0; i &lt; nfn; i++){
		readc(&amp;space);
		addr = getlong(4);
		opos = pos;
		expect = Linktarget;
		while(addr &gt; 0){
			addr = tuple(addr, expect);
			expect = 0;
		}
		pos = opos;
	}
}

static char *funcids[] = {
	"MULTI",
	"MEMORY",
	"SERIAL",
	"PARALLEL",
	"FIXED",
	"VIDEO",
	"NETWORK",
	"AIMS",
	"SCSI",
};

void
tfuncid(int, int)
{
	uchar func;

	readc(&amp;func);
	print("Function %s\n", 
		(func &gt;= nelem(funcids))? "unknown function": funcids[func]);
}

void
tvers1(int ttype, int len)
{
	uchar c, major, minor;
	int  i;
	char string[512];

	USED(ttype);
	if(readc(&amp;major) != 1)
		return;
	len--;
	if(readc(&amp;minor) != 1)
		return;
	len--;
	print("version %d.%d\n", major, minor);
	while(len &gt; 0){
		for(i = 0; len &gt; 0 &amp;&amp; i &lt; sizeof(string); i++){
			if(readc(&amp;string[i]) != 1)
				return;
			len--;
			c = string[i];
			if(c == 0)
				break;
			if(c == 0xff){
				if(i != 0){
					string[i] = 0;
					print("\t%s&lt;missing null&gt;\n", string);
				}
				return;
			}
		}
		string[i] = 0;
		print("\t%s\n", string);
	}
}

void
tcfig(int ttype, int len)
{
	uchar size, rasize, rmsize;
	uchar last;
	ulong caddr;
	ulong cregs;
	int i;

	USED(ttype, len);
	if(readc(&amp;size) != 1)
		return;
	rasize = (size&amp;0x3) + 1;
	rmsize = ((size&gt;&gt;2)&amp;0xf) + 1;
	if(readc(&amp;last) != 1)
		return;
	caddr = getlong(rasize);
	cregs = getlong(rmsize);

	print("configuration registers at");
	for(i = 0; i &lt; 16; i++)
		if((1&lt;&lt;i) &amp; cregs)
			print(" (%d)0x%lux", i, caddr + i*2);
	print("\n");
}

char *intrname[16] =
{
[0]	"memory",
[1]	"I/O",
[4]	"Custom 0",
[5]	"Custom 1",
[6]	"Custom 2",
[7]	"Custom 3",
};

ulong vexp[8] =
{
	1, 10, 100, 1000, 10000, 100000, 1000000, 10000000
};
ulong vmant[16] =
{
	10, 12, 13, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 70, 80, 90,
};

void
volt(char *name)
{
	uchar c;
	ulong microv;
	ulong exp;

	if(readc(&amp;c) != 1)
		return;
	exp = vexp[c&amp;0x7];
	microv = vmant[(c&gt;&gt;3)&amp;0xf]*exp;
	while(c &amp; 0x80){
		if(readc(&amp;c) != 1)
			return;
		switch(c){
		case 0x7d:
			break;		/* high impedence when sleeping */
		case 0x7e:
		case 0x7f:
			microv = 0;	/* no connection */
			break;
		default:
			exp /= 10;
			microv += exp*(c&amp;0x7f);
		}
	}
	print(" V%s %lduV", name, microv);
}

void
amps(char *name)
{
	uchar c;
	ulong amps;

	if(readc(&amp;c) != 1)
		return;
	amps = vexp[c&amp;0x7]*vmant[(c&gt;&gt;3)&amp;0xf];
	while(c &amp; 0x80){
		if(readc(&amp;c) != 1)
			return;
		if(c == 0x7d || c == 0x7e || c == 0x7f)
			amps = 0;
	}
	if(amps &gt;= 1000000)
		print(" I%s %ldmA", name, amps/100000);
	else if(amps &gt;= 1000)
		print(" I%s %lduA", name, amps/100);
	else
		print(" I%s %ldnA", name, amps*10);
}

void
power(char *name)
{
	uchar feature;

	print("\t%s: ", name);
	if(readc(&amp;feature) != 1)
		return;
	if(feature &amp; 1)
		volt("nominal");
	if(feature &amp; 2)
		volt("min");
	if(feature &amp; 4)
		volt("max");
	if(feature &amp; 8)
		amps("static");
	if(feature &amp; 0x10)
		amps("avg");
	if(feature &amp; 0x20)
		amps("peak");
	if(feature &amp; 0x40)
		amps("powerdown");
	print("\n");
}

void
ttiming(char *name, int scale)
{
	uchar unscaled;
	ulong scaled;

	if(readc(&amp;unscaled) != 1)
		return;
	scaled = (mantissa[(unscaled&gt;&gt;3)&amp;0xf]*exponent[unscaled&amp;7])/10;
	scaled = scaled * vexp[scale];
	print("\t%s %ldns\n", name, scaled);
}

void
timing(void)
{
	uchar c, i;

	if(readc(&amp;c) != 1)
		return;
	i = c&amp;0x3;
	if(i != 3)
		ttiming("max wait", i);
	i = (c&gt;&gt;2)&amp;0x7;
	if(i != 7)
		ttiming("max ready/busy wait", i);
	i = (c&gt;&gt;5)&amp;0x7;
	if(i != 7)
		ttiming("reserved wait", i);
}

void
range(int asize, int lsize)
{
	ulong address, len;

	address = getlong(asize);
	len = getlong(lsize);
	print("\t\t%lux - %lux\n", address, address+len);
}

char *ioaccess[4] =
{
	" no access",
	" 8bit access only",
	" 8bit or 16bit access",
	" selectable 8bit or 8&amp;16bit access",
};

int
iospace(uchar c)
{
	int i;

	print("\tIO space %d address lines%s\n", c&amp;0x1f, ioaccess[(c&gt;&gt;5)&amp;3]);
	if((c &amp; 0x80) == 0)
		return -1;

	if(readc(&amp;c) != 1)
		return -1;

	for(i = (c&amp;0xf)+1; i; i--)
		range((c&gt;&gt;4)&amp;0x3, (c&gt;&gt;6)&amp;0x3);
	return 0;
}

void
iospaces(void)
{
	uchar c;

	if(readc(&amp;c) != 1)
		return;
	iospace(c);
}

void
irq(void)
{
	uchar c;
	uchar irq1, irq2;
	ushort i, irqs;

	if(readc(&amp;c) != 1)
		return;
	if(c &amp; 0x10){
		if(readc(&amp;irq1) != 1)
			return;
		if(readc(&amp;irq2) != 1)
			return;
		irqs = irq1|(irq2&lt;&lt;8);
	} else
		irqs = 1&lt;&lt;(c&amp;0xf);
	print("\tinterrupts%s%s%s", (c&amp;0x20)?":level":"", (c&amp;0x40)?":pulse":"",
		(c&amp;0x80)?":shared":"");
	for(i = 0; i &lt; 16; i++)
		if(irqs &amp; (1&lt;&lt;i))
			print(", %d", i);
	print("\n");
}

void
memspace(int asize, int lsize, int host)
{
	ulong haddress, address, len;

	len = getlong(lsize)*256;
	address = getlong(asize)*256;
	if(host){
		haddress = getlong(asize)*256;
		print("\tmemory address range 0x%lux - 0x%lux hostaddr 0x%lux\n",
			address, address+len, haddress);
	} else
		print("\tmemory address range 0x%lux - 0x%lux\n", address, address+len);
}

void
misc(void)
{
}

void
tentry(int ttype, int len)
{
	uchar c, i, feature;
	char *tname;
	char buf[16];

	USED(ttype, len);
	if(readc(&amp;c) != 1)
		return;
	print("configuration %d%s\n", c&amp;0x3f, (c&amp;0x40)?" (default)":"");
	if(c &amp; 0x80){
		if(readc(&amp;i) != 1)
			return;
		tname = intrname[i &amp; 0xf];
		if(tname == 0){
			tname = buf;
			sprint(buf, "type %d", i &amp; 0xf);
		}
		print("\t%s device, %s%s%s%s\n", tname,
			(i&amp;0x10)?" Battery status active":"",
			(i&amp;0x20)?" Write Protect active":"",
			(i&amp;0x40)?" Ready/Busy active":"",
			(i&amp;0x80)?" Memory Wait required":"");
	}
	if(readc(&amp;feature) != 1)
		return;
	switch(feature&amp;0x3){
	case 1:
		power("Vcc");
		break;
	case 2:
		power("Vcc");
		power("Vpp");
		break;
	case 3:
		power("Vcc");
		power("Vpp1");
		power("Vpp2");
		break;
	}
	if(feature&amp;0x4)
		timing();
	if(feature&amp;0x8)
		iospaces();
	if(feature&amp;0x10)
		irq();
	switch((feature&gt;&gt;5)&amp;0x3){
	case 1:
		memspace(0, 2, 0);
		break;
	case 2:
		memspace(2, 2, 0);
		break;
	case 3:
		if(readc(&amp;c) != 1)
			return;
		for(i = 0; i &lt;= (c&amp;0x7); i++)
			memspace((c&gt;&gt;5)&amp;0x3, (c&gt;&gt;3)&amp;0x3, c&amp;0x80);
		break;
	}
	if(feature&amp;0x80)
		misc();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

