<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/3dfx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/3dfx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * 3Dfx.
 */
enum {
	dramInit0		= 0x018/4,
	dramInit1		= 0x01C/4,
	vgaInit0		= 0x028/4,
	pllCtrl0		= 0x040/4,
	pllCtrl1		= 0x044/4,
	pllCtrl2		= 0x048/4,
	dacMode			= 0x04C/4,
	vidProcCfg		= 0x05C/4,
	vidScreenSize		= 0x098/4,
	vidDesktopOverlayStride	= 0x0E8/4,

	Nior			= 0x100/4,
};

typedef struct Tdfx {
	ulong	io;
	Pcidev*	pci;

	ulong	r[Nior];
} Tdfx;

static ulong
io32r(Tdfx* tdfx, int r)
{
	return inportl(tdfx-&gt;io+(r*4));
}

static void
io32w(Tdfx* tdfx, int r, ulong l)
{
	outportl(tdfx-&gt;io+(r*4), l);
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	ulong v;
	Tdfx *tdfx;

	if(vga-&gt;private == nil){
		tdfx = alloc(sizeof(Tdfx));
		tdfx-&gt;pci = pcimatch(0, 0x121A, 0);
		if(tdfx-&gt;pci == nil)
			error("%s: not found\n", ctlr-&gt;name);
		switch(tdfx-&gt;pci-&gt;did){
		default:
			error("%s: unknown chip - DID %4.4uX\n",
				ctlr-&gt;name, tdfx-&gt;pci-&gt;did);
			break;
		case 0x0003:		/* Banshee */
			vga-&gt;f[1] = 270000000;
			break;
		case 0x0005:		/* Avenger (a.k.a. Voodoo3) */
			vga-&gt;f[1] = 300000000;
			break;
		case 0x0009:		/* Voodoo5 */
			vga-&gt;f[1] = 350000000;
			break;
		}
		/*
		 * Frequency output of PLL's is given by
		 *	fout = RefFreq*(n+2)/((m+2)*2^p)
		 * where there are 6 bits for m, 8 bits for n
		 * and 2 bits for p (k).
		 */
		vga-&gt;m[1] = 64;
		vga-&gt;n[1] = 256;
		vga-&gt;p[1] = 4;

		if((v = (tdfx-&gt;pci-&gt;mem[2].bar &amp; ~0x3)) == 0)
			error("%s: I/O not mapped\n", ctlr-&gt;name);
		tdfx-&gt;io = v;

		vga-&gt;private = tdfx;
	}
	tdfx = vga-&gt;private;

	vga-&gt;crt[0x1A] = vgaxi(Crtx, 0x1A);
	vga-&gt;crt[0x1B] = vgaxi(Crtx, 0x1B);
	for(i = 0; i &lt; Nior; i++)
		tdfx-&gt;r[i] = io32r(tdfx, i);

	/*
	 * If SDRAM then there's 16MB memory else it's SGRAM
	 * and can count it based on the power-on straps -
	 * chip size can be 8Mb or 16Mb, and there can be 4 or
	 * 8 of them.
	 */
	vga-&gt;vma = tdfx-&gt;pci-&gt;mem[1].size;
	if(tdfx-&gt;r[dramInit1] &amp; 0x40000000)
		vga-&gt;vmz = 16*1024*1024;
	else{
		if(tdfx-&gt;r[dramInit0] &amp; 0x08000000)
			i = 16*1024*1024/8;
		else
			i = 8*1024*1024/8;
		if(tdfx-&gt;r[dramInit0] &amp; 0x04000000)
			i *= 8;
		else
			i *= 4;
		vga-&gt;vmz = i;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Hclk2|Foptions;
}

static void
tdfxclock(Vga* vga, Ctlr*)
{
	int d, dmin;
	uint f, m, n, p;

	dmin = vga-&gt;f[0];
	for(m = 1; m &lt; vga-&gt;m[1]; m++){
		for(n = 1; n &lt; vga-&gt;n[1]; n++){
			f = (RefFreq*(n+2))/(m+2);
			for(p = 0; p &lt; vga-&gt;p[1]; p++){
				d = vga-&gt;f[0] - (f/(1&lt;&lt;p));
				if(d &lt; 0)
					d = -d;
				if(d &gt;= dmin)
					continue;
				dmin = d;
				vga-&gt;m[0] = m;
				vga-&gt;n[0] = n;
				vga-&gt;p[0] = p;
			}
		}
	}
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	int x;
	Mode *mode;
	Tdfx *tdfx;

	mode = vga-&gt;mode;
	tdfx = vga-&gt;private;

	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
		ctlr-&gt;flag |= Ulinear;

	/*
	 * Clock bits. If the desired video clock is
	 * one of the two standard VGA clocks or 50MHz it can just be
	 * set using bits &lt;3:2&gt; of vga-&gt;misc, otherwise we
	 * need to programme the PLL.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = mode-&gt;frequency;
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;f[0] == VgaFreq0){
		/* nothing to do */;
	}
	else if(vga-&gt;f[0] == VgaFreq1)
		vga-&gt;misc |= 0x04;
	else if(vga-&gt;f[0] == 50000000)
		vga-&gt;misc |= 0x08;
	else{
		if(vga-&gt;f[0] &gt; vga-&gt;f[1])
			error("%s: invalid pclk - %lud\n",
				ctlr-&gt;name, vga-&gt;f[0]);
		if(vga-&gt;f[0] &gt; 135000000 &amp;&amp; (ctlr-&gt;flag &amp; Hclk2)){
			if(mode-&gt;x%16)
				error("%s: f &gt; 135MHz requires (x%%16) == 0\n",
					ctlr-&gt;name);
			ctlr-&gt;flag |= Uclk2;
		}
		tdfxclock(vga, ctlr);

		tdfx-&gt;r[pllCtrl0] = (vga-&gt;n[0]&lt;&lt;8)|(vga-&gt;m[0]&lt;&lt;2)|vga-&gt;p[0];
		vga-&gt;misc |= 0x0C;
	}

	/*
	 * Pixel format and memory stride.
	 */
	tdfx-&gt;r[vidScreenSize] = (mode-&gt;y&lt;&lt;12)|mode-&gt;x;
	tdfx-&gt;r[vidProcCfg] = 0x00000081;
	switch(mode-&gt;z){
	default:
		error("%s: %d-bit mode not supported\n", ctlr-&gt;name, mode-&gt;z);
		break;
	case 8:
		tdfx-&gt;r[vidDesktopOverlayStride] = mode-&gt;x;
		break;
	case 16:
		tdfx-&gt;r[vidDesktopOverlayStride] = mode-&gt;x*2;
		tdfx-&gt;r[vidProcCfg] |= 0x00040400;
		break;
	case 32:
		tdfx-&gt;r[vidDesktopOverlayStride] = mode-&gt;x*4;
		tdfx-&gt;r[vidProcCfg] |= 0x000C0400;
		break;
	}
	tdfx-&gt;r[vgaInit0] = 0x140;

	/*
	 * Adjust horizontal timing if doing two screen pixels per clock.
	 */
	tdfx-&gt;r[dacMode] = 0;
	if(ctlr-&gt;flag &amp; Uclk2){
		vga-&gt;crt[0x00] = ((mode-&gt;ht/2)&gt;&gt;3)-5;
		vga-&gt;crt[0x01] = ((mode-&gt;x/2)&gt;&gt;3)-1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb/2)&gt;&gt;3)-1;
	
		x = (mode-&gt;ehb/2)&gt;&gt;3;
		vga-&gt;crt[0x03] = 0x80|(x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs/2)&gt;&gt;3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs/2)&gt;&gt;3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;

		tdfx-&gt;r[dacMode] |= 0x01;
		tdfx-&gt;r[vidProcCfg] |= 0x04000000;
	}

	/*
	 * Overflow.
	 */
	vga-&gt;crt[0x1A] = 0x00;
	if(vga-&gt;crt[0x00] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x01;
	if(vga-&gt;crt[0x01] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x04;
	if(vga-&gt;crt[0x03] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x10;
	x = mode-&gt;ehb;
	if(ctlr-&gt;flag &amp; Uclk2)
		x /= 2;
	if((x&gt;&gt;3) &amp; 0x40)
		vga-&gt;crt[0x1A] |= 0x20;
	if(vga-&gt;crt[0x04] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x40;
	x = mode-&gt;ehs;
	if(ctlr-&gt;flag &amp; Uclk2)
		x /= 2;
	if((x&gt;&gt;3) &amp; 0x20)
		vga-&gt;crt[0x1A] |= 0x80;

	vga-&gt;crt[0x1B] = 0x00;
	if(vga-&gt;crt[0x06] &amp; 0x400)
		vga-&gt;crt[0x1B] |= 0x01;
	if(vga-&gt;crt[0x12] &amp; 0x400)
		vga-&gt;crt[0x1B] |= 0x04;
	if(vga-&gt;crt[0x15] &amp; 0x400)
		vga-&gt;crt[0x1B] |= 0x10;
	if(vga-&gt;crt[0x10] &amp; 0x400)
		vga-&gt;crt[0x1B] |= 0x40;

	vga-&gt;attribute[0x11] = Pblack;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	Tdfx *tdfx;

	vgaxo(Crtx, 0x1A, vga-&gt;crt[0x1A]);
	vgaxo(Crtx, 0x1B, vga-&gt;crt[0x1B]);

	tdfx = vga-&gt;private;
	io32w(tdfx, dacMode, tdfx-&gt;r[dacMode]);
	io32w(tdfx, vidScreenSize, tdfx-&gt;r[vidScreenSize]);
	io32w(tdfx, vidDesktopOverlayStride, tdfx-&gt;r[vidDesktopOverlayStride]);
	io32w(tdfx, vidProcCfg, tdfx-&gt;r[vidProcCfg]);
	io32w(tdfx, vgaInit0, tdfx-&gt;r[vgaInit0]);

	if((vga-&gt;misc &amp; 0x0C) == 0x0C)
		io32w(tdfx, pllCtrl0, tdfx-&gt;r[pllCtrl0]);

	ctlr-&gt;flag |= Fload;
}

static uint
pllctrl(Tdfx* tdfx, int pll)
{
	uint k, m, n, r;

	r = tdfx-&gt;r[pllCtrl0+pll];
	k = r &amp; 0x03;
	m = (r&gt;&gt;2) &amp; 0x3F;
	n = (r&gt;&gt;8) &amp; 0xFF;

	return (RefFreq*(n+2))/((m+2)*(1&lt;&lt;k));
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	Tdfx *tdfx;

	if((tdfx = vga-&gt;private) == nil)
		return;

	printitem(ctlr-&gt;name, "Crt1A");
	printreg(vga-&gt;crt[0x1A]);
	printreg(vga-&gt;crt[0x1B]);

	Bprint(&amp;stdout, "\n");
	for(i = 0; i &lt; Nior; i++)
		Bprint(&amp;stdout, "%s %2.2uX\t%.8luX\n",
			ctlr-&gt;name, i*4, tdfx-&gt;r[i]);

	printitem(ctlr-&gt;name, "pllCtrl");
	Bprint(&amp;stdout, "%9ud %8ud\n", pllctrl(tdfx, 0), pllctrl(tdfx, 1));
}

Ctlr tdfx = {
	"3dfx",				/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr tdfxhwgc = {
	"3dfxhwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

