<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/bt485.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/bt485.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Brooktree Bt485 Monolithic True-Color RAMDAC.
 * Assumes hooked up to an S3 86C928.
 *
 * There are only 16 directly addressable registers,
 * Cmd3 is accessed indirectly and overlays the
 * status register. We make this register index 0x1A.
 * Cmd4 is an artifact of the Tvp3025 in Bt485
 * emulation mode.
 */
enum {
	AddrW		= 0x00,		/* Address register; palette/cursor RAM write */
	Palette		= 0x01,		/* 6/8-bit color palette data */
	Pmask		= 0x02,		/* Pixel mask register */
	AddrR		= 0x03,		/* Address register; palette/cursor RAM read */
	ColorW		= 0x04,		/* Address register; cursor/overscan color write */
	Color		= 0x05,		/* Cursor/overscan color data */
	Cmd0		= 0x06,		/* Command register 0 */
	ColorR		= 0x07,		/* Address register; cursor/overscan color read */
	Cmd1		= 0x08,		/* Command register 1 */
	Cmd2		= 0x09,		/* Command register 2 */
	Status		= 0x0A,		/* Status */
	Cram		= 0x0B,		/* Cursor RAM array data */
	Cxlr		= 0x0C,		/* Cursor x-low register */
	Cxhr		= 0x0D,		/* Cursor x-high register */
	Cylr		= 0x0E,		/* Cursor y-low register */
	Cyhr		= 0x0F,		/* Cursor y-high register */

	Nreg		= 0x10,

	Cmd3		= 0x1A,		/* Command register 3 */
	Cmd4		= 0x2A,		/* Command register 4 */
};

static uchar
bt485io(uchar reg)
{
	uchar crt55, cr0;

	if(reg &gt;= Nreg &amp;&amp; (reg &amp; 0x0F) != Status)
		error("%s: bad reg - 0x%X\n", bt485.name, reg);

	crt55 = vgaxi(Crtx, 0x55) &amp; 0xFC;
	if((reg &amp; 0x0F) == Status){
		/*
		 * 1,2: Set indirect addressing for Status or
		 *      Cmd[34] - set bit7 of Cr0.
		 */
		vgaxo(Crtx, 0x55, crt55|((Cmd0&gt;&gt;2) &amp; 0x03));
		cr0 = vgai(dacxreg[Cmd0 &amp; 0x03])|0x80;
		vgao(dacxreg[Cmd0 &amp; 0x03], cr0);

		/*
		 * 3,4: Set the index into the Write register,
		 *      index == 0x00 for Status, 0x01 for Cmd3,
		 *		 0x02 for Cmd4.
		 */
		vgaxo(Crtx, 0x55, crt55|((AddrW&gt;&gt;2) &amp; 0x03));
		vgao(dacxreg[AddrW &amp; 0x03], (reg&gt;&gt;4) &amp; 0x0F);

		/*
		 * 5,6: Get the contents of the appropriate
		 *      register at 0x0A.
		 */
	}

	return crt55;
}

uchar
bt485i(uchar reg)
{
	uchar crt55, r;

	crt55 = bt485io(reg);
	vgaxo(Crtx, 0x55, crt55|((reg&gt;&gt;2) &amp; 0x03));
	r = vgai(dacxreg[reg &amp; 0x03]);
	vgaxo(Crtx, 0x55, crt55);

	return r;
}

void
bt485o(uchar reg, uchar data)
{
	uchar crt55;

	crt55 = bt485io(reg);
	vgaxo(Crtx, 0x55, crt55|((reg&gt;&gt;2) &amp; 0x03));
	vgao(dacxreg[reg &amp; 0x03], data);
	vgaxo(Crtx, 0x55, crt55);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hsid32|Hclk2|Hextsid|Henhanced|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong grade;
	char *p;

	/*
	 * Work out the part speed-grade from name.  Name can have,
	 * e.g. '-135' on the end  for 135MHz part.
	 */
	grade = 110000000;
	if(p = strrchr(ctlr-&gt;name, '-'))
		grade = strtoul(p+1, 0, 0) * 1000000;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; grade)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);

	/*
	 * Determine whether to use clock-doubler or not.
	 */
	if((ctlr-&gt;flag &amp; Uclk2) == 0 &amp;&amp; vga-&gt;f[0] &gt; 67500000){
		vga-&gt;f[0] /= 2;
		resyncinit(vga, ctlr, Uclk2, 0);
	}

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga*, Ctlr* ctlr)
{
	uchar x;

	/*
	 * Put the chip to sleep before (possibly) changing the clock-source
	 * to ensure the integrity of the palette.
	 */
	x = bt485i(Cmd0);
	bt485o(Cmd0, x|0x01);				/* sleep mode */

	/*
	 * Set the clock-source, clock-doubler and frequency
	 * appropriately:
	 *	if using the pixel-port, use Pclock1;
	 *	use the doubler if fvco &gt; 67.5MHz.
	 *	set the frequency.
	 */
	x = bt485i(Cmd2);
	if(ctlr-&gt;flag &amp; Uenhanced)
		x |= 0x10;				/* Pclock1 */
	else
		x &amp;= ~0x10;
	bt485o(Cmd2, x);

	x = bt485i(Cmd3);
	if(ctlr-&gt;flag &amp; Uclk2)
		x |= 0x08;				/* clock-doubler */
	else
		x &amp;= ~0x08;
	bt485o(Cmd3, x);

	/*
	 * Set 4:1 multiplex and portselect bits on the
	 * Bt485 appropriately for using the pixel-port.
	 */
	x = bt485i(Cmd2);
	if(ctlr-&gt;flag &amp; Uenhanced){
		bt485o(Cmd1, 0x40);			/* 4:1 multiplex */
		x |= 0x20;				/* portselect */
	}
	else{
		bt485o(Cmd1, 0x00);
		x &amp;= ~0x20;
	}
	bt485o(Cmd2, x);

	x = bt485i(Cmd4);
	if(ctlr-&gt;flag &amp; Uenhanced)
		x |= 0x01;
	else
		x &amp;= ~0x01;
	bt485o(Cmd4, x);

	/*
	 * All done, wake the chip back up.
	 * Set 6/8-bit colour as appropriate.
	 */
	x = bt485i(Cmd0) &amp; ~0x01;
	/*if(vga-&gt;mode.z == 8)
		x |= 0x02;
	else*/
		x &amp;= ~0x02;
	bt485o(Cmd0, x);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "direct");
	for(i = 0; i &lt; 0x10; i++)
		printreg(bt485i(i));
	printitem(ctlr-&gt;name, "indirect");
	printreg(bt485i(Cmd3));
	printreg(bt485i(Cmd4));
}

Ctlr bt485 = {
	"bt485",			/* name */
	0,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

