<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/clgd542x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/clgd542x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Cirrus Logic True Color VGA Family - CL-GD542X.
 * Also works for Alpine VGA Family - CL-GD543X.
 * Just the basics. BUGS:
 *   the added capabilities of the 543X aren't used.
 */

typedef struct {
	uchar	id;			/* Id */
	ulong	vclk;			/* Maximum dot clock */
} Gd542x;

static Gd542x family[] = {
	{ 0x88,  75000000, },		/* CL-GD5420 */
	{ 0x8C,  80000000, },		/* CL-GD5422 */
	{ 0x94,  80000000, },		/* CL-GD5424 */
	{ 0x90,  80000000, },		/* CL-GD5426 */
	{ 0x98,  80000000, },		/* CL-GD5428 */
	{ 0x9C,  86000000, },		/* CL-GD5429 */
	{ 0xA0,  86000000, },		/* CL-GD5430 */
	{ 0xA8,  86000000, },		/* CL-GD5434 */

	{ 0xAC, 135000000, },		/* CL-GD5436 */
	{ 0xB8, 135000000, },		/* CL-GD5446 */
	{ 0xBC, 135000000, },		/* CL-GD5480 */

	{ 0x30,  80000000, },		/* CL-GD7543 */

	{ 0x00, },
};

static Gd542x*
identify(Vga* vga, Ctlr* ctlr)
{
	Gd542x *gd542x;
	uchar id;

	id = vga-&gt;crt[0x27] &amp; ~0x03;
	for(gd542x = &amp;family[0]; gd542x-&gt;id; gd542x++){
		if(gd542x-&gt;id == id)
			return gd542x;
	}

	error("%s: unknown chip id - 0x%2.2X\n", ctlr-&gt;name, vga-&gt;crt[0x27]);
	return 0;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Gd542x *gd542x;

	/*
	 * Unlock extended registers.
	 */
	vgaxo(Seqx, 0x06, 0x12);

	/*
	 * Save all the registers, even though we'll only
	 * change a handful.
	 */
	for(i = 0x06; i &lt; 0x20; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);

	for(i = 0x09; i &lt; 0x3A; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);

	for(i = 0x19; i &lt; 0x1E; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	vga-&gt;crt[0x27] = vgaxi(Crtx, 0x27);

	/*
	 * Hack for Hidden DAC Register. Do 4 dummy reads
	 * of Pixmask first.
	 */
	for(i = 0; i &lt; 4; i++)
		vgai(Pixmask);
	vga-&gt;crt[0x28] = vgai(Pixmask);

	i = 0;
	switch(vga-&gt;crt[0x27] &amp; ~0x03){

	case 0x88:				/* CL-GD5420 */
	case 0x8C:				/* CL-GD5422 */
	case 0x94:				/* CL-GD5424 */
	case 0x80:				/* CL-GD5425 */
	case 0x90:				/* CL-GD5426 */
	case 0x98:				/* CL-GD5427 */
	case 0x9C:				/* CL-GD5429 */
		/*
		 * The BIOS leaves the memory size in Seq0A, bits 4 and 3.
		 * See Technical Reference Manual Appendix E1, Section 1.3.2.
		 *
		 * The storage area for the 64x64 cursors is the last 16Kb of
		 * display memory.
		 */
		i = (vga-&gt;sequencer[0x0A]&gt;&gt;3) &amp; 0x03;
		break;

	case 0xA0:				/* CL-GD5430 */
	case 0xA8:				/* CL-GD5434 */
	case 0xAC:				/* CL-GD5436 */
	case 0xB8:				/* CL-GD5446 */
	case 0x30:				/* CL-GD7543 */
		/*
		 * Attempt to intuit the memory size from the DRAM control
		 * register. Minimum is 512KB.
		 * If DRAM bank switching is on then there's double.
		 */
		i = (vga-&gt;sequencer[0x0F]&gt;&gt;3) &amp; 0x03;
		if(vga-&gt;sequencer[0x0F] &amp; 0x80)
			i++;

		/*
		 * If it's a PCI card, can do linear.
		 * Most of the Cirrus chips can do linear addressing with
		 * all the different buses, but it can get messy. It's easy
		 * to cut PCI on the CLGD543x chips out of the pack.
		 */
		if(((vga-&gt;sequencer[0x17]&gt;&gt;3) &amp; 0x07) == 0x04)
			ctlr-&gt;flag |= Hlinear;
		break;
	case 0xBC:				/* CL-GD5480 */
		i = 2;				/* 1024 = 256&lt;&lt;2 */
		if((vga-&gt;sequencer[0x0F] &amp; 0x18) == 0x18){
			i &lt;&lt;= 1;		/* 2048 = 256&lt;&lt;3 */
			if(vga-&gt;sequencer[0x0F] &amp; 0x80)
				i &lt;&lt;= 2;	/* 2048 = 256&lt;&lt;4 */
		}
		if(vga-&gt;sequencer[0x17] &amp; 0x80)
			i &lt;&lt;= 1;
		ctlr-&gt;flag |= Hlinear;
		break;

	default:				/* uh, ah dunno */
		break;
	}

	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear)){
		vga-&gt;vmz = 16*1024*1024;
		vga-&gt;vma = 16*1024*1024;
		ctlr-&gt;flag |= Ulinear;
	}
	else
		vga-&gt;vmz = (256&lt;&lt;i)*1024;

	gd542x = identify(vga, ctlr);
	if(vga-&gt;f[1] == 0 || vga-&gt;f[1] &gt; gd542x-&gt;vclk)
		vga-&gt;f[1] = gd542x-&gt;vclk;
	ctlr-&gt;flag |= Fsnarf;
}

void
clgd54xxclock(Vga* vga, Ctlr* ctlr)
{
	int f;
	ulong d, dmin, fmin, n, nmin, p;

	trace("%s-&gt;init-&gt;clgd54xxclock\n", ctlr-&gt;name);

	/*
	 * Athough the Technical Reference Manual says only a handful
	 * of frequencies are tested, it also gives the following formula
	 * which can be used to generate any frequency within spec.,
	 * including the tested ones.
	 *
	 * Numerator is 7-bits, denominator 5-bits.
	 * Guess from the Technical Reference Manual that
	 * The post divisor is 1 for vclk&lt;40MHz.
	 *
	 * Look for values of n and d and p that give
	 * the least error for
	 *	vclk = (RefFreq*n)/(d*(1+p));
	 *
	 * There's nothing like brute force and ignorance.
	 */
	fmin = vga-&gt;f[0];
	nmin = 69;
	dmin = 24;
	if(vga-&gt;f[0] &gt;= 40000000)
		p = 0;
	else
		p = 1;
	for(n = 1; n &lt; 128; n++){
		for(d = 1; d &lt; 32; d++){
			f = vga-&gt;f[0] - (RefFreq*n)/(d*(1+p));
			if(f &lt; 0)
				f = -f;
			if(f &lt;= fmin){
				fmin = f;
				nmin = n;
				dmin = d;
			}
		}
	}

	vga-&gt;f[0] = (RefFreq*nmin)/(dmin*(1+p));
	vga-&gt;d[0] = dmin;
	vga-&gt;n[0] = nmin;
	vga-&gt;p[0] = p;
}

void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	Gd542x *gd542x;
	ushort x;

	mode = vga-&gt;mode;
	gd542x = identify(vga, ctlr);

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &gt; gd542x-&gt;vclk)
		error("%s: pclk %lud too high (&gt; %lud)\n",
			ctlr-&gt;name, vga-&gt;f[0], gd542x-&gt;vclk);

	if(mode-&gt;z &gt; 8)
		error("%s: depth %d not supported\n", ctlr-&gt;name, mode-&gt;z);

	/*
	 * VCLK3
	 */
	clgd54xxclock(vga, ctlr);
	vga-&gt;misc |= 0x0C;
	vga-&gt;sequencer[0x0E] = vga-&gt;n[0];
	vga-&gt;sequencer[0x1E] = (vga-&gt;d[0]&lt;&lt;1)|vga-&gt;p[0];

	vga-&gt;sequencer[0x07] = 0x00;
	if(mode-&gt;z == 8)
		vga-&gt;sequencer[0x07] |= 0x01;

	if(vga-&gt;f[0] &gt;= 42000000)
		vga-&gt;sequencer[0x0F] |= 0x20;
	else
		vga-&gt;sequencer[0x0F] &amp;= ~0x20;

	vga-&gt;sequencer[0x16] = (vga-&gt;sequencer[0x16] &amp; 0xF0)|0x08;

	/*
	 * Overflow bits.
	 */
	vga-&gt;crt[0x1A] = 0x00;
	x = mode-&gt;ehb&gt;&gt;3;
	if(x &amp; 0x40)
		vga-&gt;crt[0x1A] |= 0x10;
	if(x &amp; 0x80)
		vga-&gt;crt[0x1A] |= 0x20;
	if(vga-&gt;crt[0x16] &amp; 0x100)
		vga-&gt;crt[0x1A] |= 0x40;
	if(vga-&gt;crt[0x16] &amp; 0x200)
		vga-&gt;crt[0x1A] |= 0x80;
	vga-&gt;crt[0x1B] = 0x22;
	if(vga-&gt;crt[0x13] &amp; 0x100)
		vga-&gt;crt[0x1B] |= 0x10;

	vga-&gt;graphics[0x0B] = 0x00;
	if(vga-&gt;vmz &gt; 1024*1024)
		vga-&gt;graphics[0x0B] |= 0x20;

	if(mode-&gt;interlace == 'v'){
		vga-&gt;crt[0x19] = vga-&gt;crt[0x00]/2;
		vga-&gt;crt[0x1A] |= 0x01;
	}
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	vgaxo(Seqx, 0x0E, vga-&gt;sequencer[0x0E]);
	vgaxo(Seqx, 0x1E, vga-&gt;sequencer[0x1E]);
	if(ctlr-&gt;flag &amp; Ulinear)
		vga-&gt;sequencer[0x07] |= 0xE0;
	vgaxo(Seqx, 0x07, vga-&gt;sequencer[0x07]);
	vgaxo(Seqx, 0x0F, vga-&gt;sequencer[0x0F]);
	vgaxo(Seqx, 0x16, vga-&gt;sequencer[0x16]);

	if(vga-&gt;mode-&gt;interlace == 'v')
		vgaxo(Crtx, 0x19, vga-&gt;crt[0x19]);
	vgaxo(Crtx, 0x1A, vga-&gt;crt[0x1A]);
	vgaxo(Crtx, 0x1B, vga-&gt;crt[0x1B]);

	vgaxo(Grx, 0x0B, vga-&gt;graphics[0x0B]);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *name;

	name = ctlr-&gt;name;

	printitem(name, "Seq06");
	for(i = 0x06; i &lt; 0x20; i++)
		printreg(vga-&gt;sequencer[i]);

	printitem(name, "Crt19");
	for(i = 0x19; i &lt; 0x1E; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Gr09");
	for(i = 0x09; i &lt; 0x3A; i++)
		printreg(vga-&gt;graphics[i]);

	printitem(name, "Id Hdr");
	printreg(vga-&gt;crt[0x27]);
	printreg(vga-&gt;crt[0x28]);
}

Ctlr clgd542x = {
	"clgd542x",			/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr clgd542xhwgc = {
	"clgd542xhwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

