<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/cyber938x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/cyber938x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Trident Cyber938x.
 */
typedef struct {
	uchar	old[3];
	int	pcr;		/* Pixel Command Register */

	int	x;
	int	y;
} Cyber938x;

/*
 * Access to the DAC Pixel Command Register.
 * The access is similar to that used on the old
 * SGS-Thompson STG1702 Enhanced True Color Palette-DAC
 * and Sierra SC1502[56] HiCOLOR-24 Palette.
 */
static void
pcrrw(void)
{
	int i;

	inportb(PaddrW);
	for(i = 0; i &lt; 4; i++)
		inportb(Pixmask);
}

static int
pcrr(void)
{
	int pcr;

	pcrrw();
	pcr = inportb(Pixmask);
	inportb(PaddrW);

	return pcr;
}

static void
pcrw(int pcr)
{
	pcrrw();
	outportb(Pixmask, pcr);
	inportb(PaddrW);
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Cyber938x *cyber;

	if(vga-&gt;private == nil)
		vga-&gt;private = alloc(sizeof(Cyber938x));
	cyber = vga-&gt;private;

	/*
	 * Switch to old mode (write to Seq0B), read the old
	 * mode registers (Seq0[CDE]) then switch to new mode
	 * (read Seq0B).
	 */
	vgaxo(Seqx, 0x0B, 0);
	cyber-&gt;old[0] = vgaxi(Seqx, 0x0C);
	cyber-&gt;old[1] = vgaxi(Seqx, 0x0D);
	cyber-&gt;old[2] = vgaxi(Seqx, 0x0E);
	vga-&gt;sequencer[0x0B] = vgaxi(Seqx, 0x0B);

	cyber-&gt;pcr = pcrr();

	for(i = 0x08; i &lt; 0x20; i++){
		if(i == 0x0B)
			continue;
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);
	}
	for(i = 0x19; i &lt; 0x60; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	vga-&gt;crt[0xCF] = vgaxi(Crtx, 0xCF);
	for(i = 0x09; i &lt; 0x60; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);

	vga-&gt;vma = 4*1024*1024;
	switch(vga-&gt;crt[0x1F] &amp; 0x07){
	case 0:
	case 4:
		vga-&gt;vma = 8*1024*1024;
		vga-&gt;vmz = 8*1024*1024;
		break;
	case 1:
	case 5:
		vga-&gt;vmz = 4*1024*1024;
		break;
	case 2:
	case 6:
		vga-&gt;vmz = 768*1024;
		break;
	case 7:
		vga-&gt;vmz = 2*1024*1024;
		break;
	case 3:
	default:
		vga-&gt;vmz = 1024*1024;
		break;
	}

	switch((vga-&gt;graphics[0x52]&gt;&gt;4) &amp; 0x03){
	case 0:
		cyber-&gt;x = 1280;
		cyber-&gt;y = 1024;
		break;

	case 1:
		cyber-&gt;x = 640;
		cyber-&gt;y = 480;
		break;

	case 2:
		cyber-&gt;x = 1024;
		cyber-&gt;y = 768;
		break;

	case 3:
		cyber-&gt;x = 800;
		cyber-&gt;y = 600;
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga* vga, Ctlr* ctlr)
{
	USED(vga);
	ctlr-&gt;flag |= Hlinear|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Cyber938x *cyber;

	cyber = vga-&gt;private;

	vga-&gt;crt[0x1E] = 0x80;
	vga-&gt;crt[0x2A] |= 0x40;

	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
		ctlr-&gt;flag |= Ulinear;

	vga-&gt;graphics[0x31] &amp;= 0x8F;
	if(vga-&gt;mode-&gt;y &gt; 768)
		vga-&gt;graphics[0x31] |= 0x30;
	else if(vga-&gt;mode-&gt;y &gt; 600)
		vga-&gt;graphics[0x31] |= 0x20;
	else if(vga-&gt;mode-&gt;y &gt; 480)
		vga-&gt;graphics[0x31] |= 0x10;

	switch(vga-&gt;mode-&gt;z){
	case 8:
		cyber-&gt;pcr = 0;		/* DAC Pixel Command Register */
		vga-&gt;crt[0x38] = 0x00;	/* Pixel Bus Register */
		break;
	case 16:
		cyber-&gt;pcr = 0x30;
		vga-&gt;crt[0x38] = 0x05;
		vga-&gt;crt[0x29] |= 0x10;	/* RSC: necessary for Versa SX */
		break;
	case 24:
		cyber-&gt;pcr = 0xD0;
		vga-&gt;crt[0x38] = 0x29;
		break;
	default:
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);
	}


	switch(vga-&gt;sequencer[0x09]){

	default:
		error("unknown Cyber revision 0x%uX\n", vga-&gt;sequencer[0x09]);
		break;
	case 0x21:				/* ProVidia 9685 */
		/*
		 * Incomplete - no clock code so only 640x480x8 works.
		 */
		vga-&gt;attribute[0x11] = 0;
		vga-&gt;graphics[0x0F] |= 0x07;
		break;
	case 0x42:				/* Cyber9382 */
		/*
		 * Try a little magic for DSTN displays.
		 * May work on other chips too, who knows.
		 */
		if(!(vga-&gt;graphics[0x42] &amp; 0x80)	/* !TFT */
		&amp;&amp; (vga-&gt;graphics[0x43] &amp; 0x20)){	/* DSTN */
			if(vga-&gt;mode-&gt;x == 640)
				vga-&gt;graphics[0x30] |= 0x81;
			else
				vga-&gt;graphics[0x30] &amp;= ~0x81;
		}
		/*FALLTHROUGH*/
	case 0x3:					/* Cyber9320 */
	case 0x33:				/* Cyber9385 */
	case 0x34:				/* Cyber9385 */
	case 0x35:				/* Cyber9385 */
	case 0x3A:				/* Cyber9385 */
		vga-&gt;graphics[0x0F] |= 0x07;
		break;
	case 0x41:				/* Cyber9525/DVD */
		vga-&gt;graphics[0x0F] |= 0x17;
		break;
	case 0x4A:				/* Cyber9388 */
	case 0x5D:				/* CyberBlade */
	case 0x6A:				/* CyberBlade (iTuner) */
	case 0x7A:				/* CyberBlade */
		vga-&gt;crt[0x2F] = 0x3F;
		vga-&gt;graphics[0x0F] |= 0x17;
		if(vga-&gt;mode-&gt;x == 1024)
			vga-&gt;graphics[0x30] = 0x18;
		break;
	}
	vga-&gt;graphics[0x52] &amp;= ~0x01;
	vga-&gt;graphics[0x53] &amp;= ~0x01;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	Cyber938x *cyber;

	cyber = vga-&gt;private;

	outportw(0x3C4, 0x000B);
	outportb(0x3C4, 0x0B);
	inportb(0x3C5);

	pcrw(cyber-&gt;pcr);

	outportw(0x3C4, (0xC2 &lt;&lt; 8) | 0x0E);
	vgaxo(Grx, 0x52, vga-&gt;graphics[0x52]);
	vgaxo(Grx, 0x53, vga-&gt;graphics[0x53]);
	vgaxo(Grx, 0x30, vga-&gt;graphics[0x30]);
	vgaxo(Grx, 0x31, vga-&gt;graphics[0x31]);

	vgaxo(Crtx, 0x1E, vga-&gt;crt[0x1E]);
	if(ctlr-&gt;flag &amp; Ulinear)
		vga-&gt;crt[0x21] |= 0x20;
	vgaxo(Crtx, 0x21, vga-&gt;crt[0x21]);
	vgaxo(Crtx, 0x29, vga-&gt;crt[0x29]);
	vgaxo(Crtx, 0x2A, vga-&gt;crt[0x2A]);
	vgaxo(Crtx, 0x2F, vga-&gt;crt[0x2F]);
	vgaxo(Crtx, 0x38, vga-&gt;crt[0x38]);

	vgaxo(Grx, 0x0F, vga-&gt;graphics[0x0F]);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	char *name;
	Cyber938x *cyber;
	int i, k, m, n, vclka, vclkb;

	name = ctlr-&gt;name;
	cyber = vga-&gt;private;
	printitem(name, "Seq08");
	for(i = 0x08; i &lt; 0x20; i++)
		printreg(vga-&gt;sequencer[i]);
	printitem(name, "Old Seq0C");
	for(i = 0; i &lt; 3; i++)
		printreg(cyber-&gt;old[i]);
	printitem(name, "pcr");
	printreg(cyber-&gt;pcr);
	printitem(name, "Crt19");
	for(i = 0x19; i &lt; 0x20; i++)
		printreg(vga-&gt;crt[i]);
	printitem(name, "Crt20");
	for(i = 0x20; i &lt; 0x60; i++)
		printreg(vga-&gt;crt[i]);
	printitem(name, "CrtCF");
	printreg(vga-&gt;crt[0xCF]);
	printitem(name, "Gr09");
	for(i = 0x09; i &lt; 0x10; i++)
		printreg(vga-&gt;graphics[i]);
	printitem(name, "Gr10");
	for(i = 0x10; i &lt; 0x60; i++)
		printreg(vga-&gt;graphics[i]);

	if(vga-&gt;sequencer[0x09] &gt;= 0x4A){
		vclka = vga-&gt;sequencer[0x18];
		vclkb = vga-&gt;sequencer[0x19];
	}
	else{
		vclka = inportb(0x43C8);
		vclkb = inportb(0x43C9);
		printitem(name, "mclk");
		printreg(inportb(0x43C6));
		printreg(inportb(0x43C7));
	}
	printitem(name, "vclk");
	printreg(vclka);
	printreg(vclkb);
	k = vclkb&gt;&gt;6;
	m = vclkb &amp; 0x3F;
	n = vclka;
 	Bprint(&amp;stdout, "%18d\n", (((n+8)*RefFreq)*(1&lt;&lt;k))/(m+2));

	printitem(name, "lcd size");
	Bprint(&amp;stdout, "%9ud %8ud\n", cyber-&gt;x, cyber-&gt;y);
}

Ctlr cyber938x = {
	"cyber938x",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr cyber938xhwgc = {
	"cyber938xhwgc",		/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

