<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/db.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/db.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;

#include "pci.h"
#include "vga.h"

static Ndb*
dbopen(char* dbname)
{
	Ndb *db;

	if((db = ndbopen(dbname)) == 0)
		error("dbopen: %s: %r\n", dbname);
	return db;
}

static void
addattr(Attr** app, Ndbtuple* t)
{
	Attr *attr, *l;

	attr = alloc(sizeof(Attr));
	attr-&gt;attr = alloc(strlen(t-&gt;attr)+1);
	strcpy(attr-&gt;attr, t-&gt;attr);
	attr-&gt;val = alloc(strlen(t-&gt;val)+1);
	strcpy(attr-&gt;val, t-&gt;val);

	for(l = *app; l; l = l-&gt;next)
		app = &amp;l-&gt;next;
	*app = attr;
}

char*
dbattr(Attr* ap, char* attr)
{
	while(ap){
		if(strcmp(ap-&gt;attr, attr) == 0)
			return ap-&gt;val;
		ap = ap-&gt;next;
	}

	return 0;
}

static Ctlr*
addctlr(Vga* vga, char* val)
{
	Ctlr **ctlr;
	char name[Namelen+1], *p;
	int i;

	/*
	 * A controller name may have an extension on the end
	 * following a '-' which can be used as a speed grade or
	 * subtype.  Do the match without the extension.
	 * The linked copy of the controller struct gets the
	 * full name with extension.
	 */
	strncpy(name, val, Namelen);
	name[Namelen] = 0;
	if(p = strchr(name, '-'))
		*p = 0;

	for(i = 0; ctlrs[i]; i++){
		if(strcmp(ctlrs[i]-&gt;name, name))
			continue;
		for(ctlr = &amp;vga-&gt;link; *ctlr; ctlr = &amp;((*ctlr)-&gt;link))
			;
		*ctlr = alloc(sizeof(Ctlr));
		**ctlr = *ctlrs[i];
		strncpy((*ctlr)-&gt;name, val, Namelen);
		return *ctlr;	
	}

	fprint(2, "dbctlr: unknown controller \"%s\" ctlr\n", val);
	return 0;
}

int
dbbios(Vga *vga, Ndbtuple *tuple)
{
	char *bios, *p, *string;
	int len;
	long offset, offset1;
	Ndbtuple *t;

	for(t = tuple-&gt;entry; t; t = t-&gt;entry){
		if((offset = strtol(t-&gt;attr, 0, 0)) == 0)
			continue;

		string = t-&gt;val;
		len = strlen(string);

		if(p = strchr(t-&gt;attr, '-')) {
			if((offset1 = strtol(p+1, 0, 0)) &lt; offset+len)
				continue;
		} else
			offset1 = offset+len;

		if(vga-&gt;offset) {
			if(offset &gt; vga-&gt;offset || vga-&gt;offset+len &gt; offset1)
				continue;
			offset = vga-&gt;offset;
			offset1 = offset+len;
		}

		for(; offset+len&lt;=offset1; offset++) {
			if(vga-&gt;bios)
				bios = vga-&gt;bios;
			else
				bios = readbios(len, offset);
			if(strncmp(bios, string, len) == 0){
				if(vga-&gt;bios == 0){
					vga-&gt;bios = alloc(len+1);
					strncpy(vga-&gt;bios, bios, len);
				}
				addattr(&amp;vga-&gt;attr, t);
				return 1;
			}
		}
	}
	return 0;
}

int
dbpci(Vga *vga, Ndbtuple *tuple)
{
	int did, vid;
	Ndbtuple *t, *td;
	Pcidev *pci;

	for(t = tuple-&gt;entry; t; t = t-&gt;entry){
		if(strcmp(t-&gt;attr, "vid") != 0 || (vid=atoi(t-&gt;val)) == 0)
			continue;
		for(td = t-&gt;line; td != t; td = td-&gt;line){
			if(strcmp(td-&gt;attr, "did") != 0)
				continue;
			if(strcmp(td-&gt;val, "*") == 0)
				did = 0;
			else if((did=atoi(td-&gt;val)) == 0)
				continue;
			for(pci=nil; pci=pcimatch(pci, vid, did);)
				if((pci-&gt;ccru&gt;&gt;8) == 3)
					break;
			if(pci == nil)
				continue;
			vga-&gt;pci = pci;
			addattr(&amp;vga-&gt;attr, t);
			addattr(&amp;vga-&gt;attr, td);
			return 1;
		}
	}
	return 0;
}

static void
save(Vga *vga, Ndbtuple *tuple)
{
	Ctlr *c;
	Ndbtuple *t;

	for(t = tuple-&gt;entry; t; t = t-&gt;entry){
		if(strcmp(t-&gt;attr, "ctlr") == 0){
			vga-&gt;ctlr = addctlr(vga, t-&gt;val);
			if(strcmp(t-&gt;val, "vesa") == 0)
				vga-&gt;vesa = vga-&gt;ctlr;
		}else if(strcmp(t-&gt;attr, "ramdac") == 0)
			vga-&gt;ramdac = addctlr(vga, t-&gt;val);
		else if(strcmp(t-&gt;attr, "clock") == 0)
			vga-&gt;clock = addctlr(vga, t-&gt;val);
		else if(strcmp(t-&gt;attr, "hwgc") == 0)
			vga-&gt;hwgc = addctlr(vga, t-&gt;val);
		else if(strcmp(t-&gt;attr, "link") == 0){
			c = addctlr(vga, t-&gt;val);
			if(strcmp(t-&gt;val, "vesa") == 0)
				vga-&gt;vesa = c;
		}else if(strcmp(t-&gt;attr, "linear") == 0)
			vga-&gt;linear = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "membw") == 0)
			vga-&gt;membw = strtol(t-&gt;val, 0, 0)*1000000;
		else if(strcmp(t-&gt;attr, "vid")==0 || strcmp(t-&gt;attr, "did")==0)
			{}
		else if(strtol(t-&gt;attr, 0, 0) == 0)
			addattr(&amp;vga-&gt;attr, t);
	}
}

int
dbctlr(char* name, Vga* vga)
{
	Ndb *db;
	Ndbs s;
	Ndbtuple *tuple;
	Ndbtuple *pcituple;

	db = dbopen(name);

	/*
	 * Search vgadb for a matching BIOS string or PCI id.
	 * If we have both, the BIOS string wins.
	 */
	pcituple = nil;
	for(tuple = ndbsearch(db, &amp;s, "ctlr", ""); tuple; tuple = ndbsnext(&amp;s, "ctlr", "")){
		if(!pcituple &amp;&amp; dbpci(vga, tuple))
			pcituple = tuple;
		if(dbbios(vga, tuple)){
			save(vga, tuple);
			if(pcituple &amp;&amp; pcituple != tuple)
				ndbfree(pcituple);
			ndbfree(tuple);
			ndbclose(db);
			return 1;
		}
		if(tuple != pcituple)
			ndbfree(tuple);
	}

	if(pcituple){
		save(vga, pcituple);
		ndbfree(pcituple);
	}
	ndbclose(db);
	if(pcituple)
		return 1;
	return 0;
}

static int
dbmonitor(Ndb* db, Mode* mode, char* type, char* size)
{
	Ndbs s;
	Ndbtuple *t, *tuple;
	char *p, attr[Namelen+1], val[Namelen+1], buf[2*Namelen+1];
	int clock, x, i;

	/*
	 * Clock rate hack.
	 * If the size is 'XxYxZ@NMHz' then override the database entry's
	 * 'clock=' with 'N*1000000'.
	 */
	clock = 0;
	strcpy(buf, size);
	if(p = strchr(buf, '@')){
		*p++ = 0;
		if((clock = strtol(p, &amp;p, 0)) &amp;&amp; strcmp(p, "MHz") == 0)
			clock *= 1000000;
	}

	memset(mode, 0, sizeof(Mode));

	if((p = strchr(buf, 'x')) &amp;&amp; (p = strchr(p+1, 'x'))){
		*p++ = 0;
		mode-&gt;z = atoi(p);
	}

	strcpy(attr, type);
	strcpy(val, buf);

	if(p = ndbgetvalue(db, &amp;s, attr, "", "videobw", nil)){
		mode-&gt;videobw = atol(p)*1000000UL;
		free(p);
	}

	if(mode-&gt;x == 0 &amp;&amp; ((mode-&gt;x = strtol(val, &amp;p, 0)) == 0 || *p++ != 'x'))
		return 0;
	if(mode-&gt;y == 0 &amp;&amp; (mode-&gt;y = strtol(p, &amp;p, 0)) == 0)
		return 0;
	i = 0;
buggery:
	if((tuple = ndbsearch(db, &amp;s, attr, val)) == 0)
		return 0;

	for(t = tuple-&gt;entry; t; t = t-&gt;entry){
		if(strcmp(t-&gt;attr, "clock") == 0 &amp;&amp; mode-&gt;frequency == 0)
			mode-&gt;frequency = strtod(t-&gt;val, 0)*1000000;
		else if(strcmp(t-&gt;attr, "defaultclock") == 0 &amp;&amp; mode-&gt;deffrequency == 0)
			mode-&gt;deffrequency = strtod(t-&gt;val, 0)*1000000;
		else if(strcmp(t-&gt;attr, "ht") == 0 &amp;&amp; mode-&gt;ht == 0)
			mode-&gt;ht = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "shb") == 0 &amp;&amp; mode-&gt;shb == 0)
			mode-&gt;shb = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "ehb") == 0 &amp;&amp; mode-&gt;ehb == 0)
			mode-&gt;ehb = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "shs") == 0 &amp;&amp; mode-&gt;shs == 0)
			mode-&gt;shs = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "ehs") == 0 &amp;&amp; mode-&gt;ehs == 0)
			mode-&gt;ehs = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "vt") == 0 &amp;&amp; mode-&gt;vt == 0)
			mode-&gt;vt = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "vrs") == 0 &amp;&amp; mode-&gt;vrs == 0)
			mode-&gt;vrs = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "vre") == 0 &amp;&amp; mode-&gt;vre == 0)
			mode-&gt;vre = strtol(t-&gt;val, 0, 0);
		else if(strcmp(t-&gt;attr, "hsync") == 0)
			mode-&gt;hsync = *t-&gt;val;
		else if(strcmp(t-&gt;attr, "vsync") == 0)
			mode-&gt;vsync = *t-&gt;val;
		else if(strcmp(t-&gt;attr, "interlace") == 0)
			mode-&gt;interlace = *t-&gt;val;
		else if(strcmp(t-&gt;attr, "include") == 0 /*&amp;&amp; strcmp(t-&gt;val, val) != 0*/){
			strcpy(attr, t-&gt;attr);
			strcpy(val, t-&gt;val);
			ndbfree(tuple);
			if(i++ &gt; 5)
				error("dbmonitor: implausible include depth at %s=%s\n", attr, val);
			goto buggery;
		}
		else if(strcmp(t-&gt;attr, "include") == 0){
			print("warning: bailed out of infinite loop in attr %s=%s\n", attr, val);
		}
		else
			addattr(&amp;mode-&gt;attr, t);
	}
	ndbfree(tuple);

	if((x = strtol(size, &amp;p, 0)) == 0 || x != mode-&gt;x || *p++ != 'x')
		return 0;
	if((x = strtol(p, &amp;p, 0)) == 0 || x != mode-&gt;y || *p++ != 'x')
		return 0;
	if((x = strtol(p, &amp;p, 0)) == 0 || x != mode-&gt;z)
		return 0;

	if(clock)
		mode-&gt;frequency = clock;

	return 1;
}

Mode*
dbmode(char* name, char* type, char* size)
{
	Ndb *db;
	Ndbs s;
	Ndbtuple *t, *tuple;
	Mode *mode;
	char attr[Namelen+1];
	ulong videobw;

	db = dbopen(name);
	mode = alloc(sizeof(Mode));
	strcpy(attr, type);

	videobw = 0;
	/*
	 * Look for the attr=size entry.
	 */
	if(dbmonitor(db, mode, attr, size)){
		strcpy(mode-&gt;type, type);
		strcpy(mode-&gt;size, size);
		ndbclose(db);
		return mode;
	}

	if(mode-&gt;videobw &amp;&amp; videobw == 0)	/* we at least found that; save it away */
		videobw = mode-&gt;videobw;

	/*
	 * Not found. Look for an attr="" entry and then
	 * for an alias=attr within.
	 */
buggery:
	for(tuple = ndbsearch(db, &amp;s, attr, ""); tuple; tuple = ndbsnext(&amp;s, attr, "")){
		for(t = tuple-&gt;entry; t; t = t-&gt;entry){
			if(strcmp(t-&gt;attr, "alias"))
				continue;
			strcpy(attr, t-&gt;val);
			if(dbmonitor(db, mode, attr, size)){
				strcpy(mode-&gt;type, type);
				strcpy(mode-&gt;size, size);
				ndbfree(tuple);
				ndbclose(db);
				if(videobw)
					mode-&gt;videobw = videobw;
				return mode;
			}

			/*
			 * Found an alias but no match for size,
			 * restart looking for attr="" with the
			 * new attr.
			 */
			ndbfree(tuple);
			goto buggery;
		}
		ndbfree(tuple);
	}

	free(mode);
	ndbclose(db);
	return 0;
}

void
dbdumpmode(Mode* mode)
{
	Attr *attr;

	Bprint(&amp;stdout, "dbdumpmode\n");

	Bprint(&amp;stdout, "type=%s, size=%s\n", mode-&gt;type, mode-&gt;size);
	Bprint(&amp;stdout, "frequency=%d\n", mode-&gt;frequency);
	Bprint(&amp;stdout, "x=%d (0x%X), y=%d (0x%X), z=%d (0x%X)\n",
		mode-&gt;x, mode-&gt;x, mode-&gt;y,  mode-&gt;y, mode-&gt;z, mode-&gt;z);
	Bprint(&amp;stdout, "ht=%d (0x%X), shb=%d (0x%X), ehb=%d (0x%X)\n",
		mode-&gt;ht, mode-&gt;ht, mode-&gt;shb, mode-&gt;shb, mode-&gt;ehb, mode-&gt;ehb);
	Bprint(&amp;stdout, "shs=%d (0x%X), ehs=%d (0x%X)\n",
		mode-&gt;shs, mode-&gt;shs, mode-&gt;ehs, mode-&gt;ehs);
	Bprint(&amp;stdout, "vt=%d (0x%X), vrs=%d (0x%X), vre=%d (0x%X)\n",
		mode-&gt;vt, mode-&gt;vt, mode-&gt;vrs, mode-&gt;vrs, mode-&gt;vre, mode-&gt;vre);
	Bprint(&amp;stdout, "hsync=%d, vsync=%d, interlace=%d\n",
		mode-&gt;hsync, mode-&gt;vsync, mode-&gt;interlace);

	for(attr = mode-&gt;attr; attr; attr = attr-&gt;next)
		Bprint(&amp;stdout, "mode-&gt;attr: %s=%s\n", attr-&gt;attr, attr-&gt;val);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

