<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/i81x.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/i81x.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Intel 81x chipset family.
 *   mem[0]: AGP aperture memory, 64MB for 810-DC100, from 0xF4000000
 *   mem[1]: GC Register mmio space, 512KB for 810-DC100, from 0xFF000000
 *   For the memory of David Hogan, died April 9, 2003,  who wrote this driver 
 *   first for LCD.
 *                   August 28, 2003 Kenji Okamoto
 */

typedef struct {
	Pcidev*	pci;
	uchar*	mmio;
	ulong	clk[6];
	ulong	lcd[9];
	ulong	pixconf;
} I81x;

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int f, i;
	uchar *mmio;
	ulong *rp;
	Pcidev *p;
	I81x *i81x;

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(I81x));
		p = nil;
		while((p = pcimatch(p, 0x8086, 0)) != nil) {
			switch(p-&gt;did) {
			default:
				continue;
			case 0x7121:	/* Vanilla 82810 */
			case 0x7123:	/* 810-DC100, DELL OptiPlex GX100 */
			case 0x7125:	/* 82810E */
			case 0x1102:	/* 82815 FSB limited to 100MHz */
			case 0x1112:	/* 82815 no AGP */
			case 0x1132:	/* 82815 fully featured Solano */
			case 0x3577:	/* IBM R31 uses intel 830M chipset */
				vga-&gt;f[1] = 230000000;		/* MAX speed of internal DAC (Hz)*/
				break;
			}
			break;
		}
		if(p == nil)
			error("%s: Intel 81x graphics function not found\n", ctlr-&gt;name);

		if((f = open("#v/vgactl", OWRITE)) &lt; 0)
			error("%s: can't open vgactl\n", ctlr-&gt;name);
		if(write(f, "type i81x", 9) != 9)
			error("%s: can't set type\n", ctlr-&gt;name);
		close(f);

		mmio = segattach(0, "i81xmmio", 0, p-&gt;mem[1].size);
		if(mmio == (void*)-1)
			error("%s: can't attach mmio segment\n", ctlr-&gt;name);
	
		i81x = vga-&gt;private;
		i81x-&gt;pci = p;
		i81x-&gt;mmio = mmio;
	}
	i81x = vga-&gt;private;

	/* must give aperture memory size for frame buffer memory
		such as 64*1024*1024 */
	vga-&gt;vma = vga-&gt;vmz = i81x-&gt;pci-&gt;mem[0].size;
//	vga-&gt;vmz = 8*1024*1024;
	vga-&gt;apz = i81x-&gt;pci-&gt;mem[0].size;
	ctlr-&gt;flag |= Hlinear;

	vga-&gt;graphics[0x10] = vgaxi(Grx, 0x10);
	vga-&gt;attribute[0x11] = vgaxi(Attrx, 0x11);	/* overscan color */
	for(i=0; i &lt; 0x19; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	for(i=0x30; i &lt;= 0x82; i++)		/* set CRT Controller Register (CR) */
		vga-&gt;crt[i] = vgaxi(Crtx, i);
	/* 0x06000: Clock Control Register base address (3 VCO frequency control) */
	rp = (ulong*)(i81x-&gt;mmio+0x06000);
	for(i = 0; i &lt; nelem(i81x-&gt;clk); i++)
		i81x-&gt;clk[i] = *rp++;

	/* i830 CRTC registers (A) */
	rp = (ulong*)(i81x-&gt;mmio+0x60000);
	for(i = 0; i &lt; nelem(i81x-&gt;lcd); i++)
		i81x-&gt;lcd[i] = *rp++;
	rp = (ulong*)(i81x-&gt;mmio+0x70008);	/* Pixel Pipeline Control register A */
	i81x-&gt;pixconf = *rp;

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Foptions;
}

static void
i81xdclk(I81x *i81x, Vga *vga)		/* freq = MHz */
{
	int m, n, post, mtp, ntp;
	double md, freq, error;

	freq = vga-&gt;mode-&gt;deffrequency/1000000.0;
	if (freq == 0)
		sysfatal("i81xdclk: deffrequency %d becomes freq 0.0",
			vga-&gt;mode-&gt;deffrequency);
	post = log(600.0/freq)/log(2.0);

	for(ntp=3;;ntp++) {
		md = freq*(1&lt;&lt;post)/(24.0/(double)ntp)/4.0;
		mtp = (int)(md+0.5);
		if(mtp&lt;3) mtp=3;
		error = 1.0-freq/(md/(ntp*(1&lt;&lt;post))*4*24.0);
		if((fabs(error) &lt; 0.001) || ((ntp &gt; 30) &amp;&amp; (fabs(error) &lt; 0.005)))
			break;
	}
	m = vga-&gt;m[1] = mtp-2;
	n = vga-&gt;n[1] = ntp-2;
	vga-&gt;r[1] = post;
	i81x-&gt;clk[2] = ((n &amp; 0x3FF)&lt;&lt;16) | (m &amp; 0x3FF);
	i81x-&gt;clk[4] = (i81x-&gt;clk[4] &amp; ~0x700000) | ((post &amp; 0x07)&lt;&lt;20);
	vga-&gt;mode-&gt;frequency = (m+2)/((n+2)*(1&lt;&lt;post))*4*24*1000000;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	I81x *i81x;
	int vt, vde, vrs, vre;
	ulong *rp;

	i81x = vga-&gt;private;

	/* &lt;&lt;TODO&gt;&gt;
	    i81x-&gt;clk[3]: LCD_CLKD: 0x0600c~0x0600f, default=00030013h
			(VCO N-divisor=03h, M-divisor=13h)
	    i81x-&gt;clk[4]: DCLK_0DS: 0x06010~0x06013, Post value, default=40404040h means
		Post Divisor=16, VCO Loop divisor = 4xM for all clocks.
	    Display&amp;LCD Clock Devisor Select Reg = 0x40404040 ==&gt; (LCD)(Clock2)(Clock1)(Clock0)
	*/
	i81x-&gt;clk[0] = 0x00030013;
	i81x-&gt;clk[1] = 0x00100053;
	rp = (ulong*)i81x-&gt;mmio+0x6010;
	i81x-&gt;clk[4] = *rp;
	i81x-&gt;clk[4] |= 0x4040;
	vga-&gt;misc = vgai(MiscR);
	switch(vga-&gt;virtx) {
	case 640:	/* 640x480 DCLK_0D 25.175MHz dot clock */
		vga-&gt;misc &amp;=  ~0x0A;
		break;
	case 720:	/* 720x480 DCLK_1D 28.322MHz dot clock */
		vga-&gt;misc = (vga-&gt;misc &amp; ~0x08) | (1&lt;&lt;2);
		break;
	case 800:
	case 1024:
	case 1152:
	case 1280:
	case 1376:
		vga-&gt;misc = vga-&gt;misc | (2&lt;&lt;2) &amp; ~0x02;		/* prohibit to access frame buffer */
		i81xdclk(i81x, vga);
		break;
	default:	/* for other higher resolution DCLK_2D */
		error("%s: Only 800, 1024, 1152, 1280, 1376 resolutions are supported\n", ctlr-&gt;name);
	}

	/*	&lt;&lt;TODO&gt;&gt;
		i830 LCD Controller, at i81x-&gt;mmio+0x60000
		i81x-&gt;lcd[0]: Horizontal Total Reg.		0x60000
		i81x-&gt;lcd[1]: Horizontal Blanking Reg.	0x60004
		i81x-&gt;lcd[2]: Horizontal Sync Reg. 		0x60008
		i81x-&gt;lcd[3]: Vertical Total Reg.		0x6000c
		i81x-&gt;lcd[4]: Vertical Blanking Reg.		0x60010
		i81x-&gt;lcd[5]: Vertical Sync Reg. 		0x60014
		i81x-&gt;lcd[6]: Pixel Pipeline A Sequencer Register Control(SRC,0~7)	0x6001c
		i81x-&gt;lcd[7]: BCLRPAT_A	0x60020
	         i81x-&gt;lcd[8]: 0
	*/
	/*
	 * Pixel pipeline control register 0x70008: 
	 *    16/24bp bypasses palette,
	 *    hw cursor enabled(1&lt;&lt;12), hi-res mode(1&lt;&lt;0), depth(16-19 bit)
	 *    8bit DAC enable (1&lt;&lt;15), don't wrap to 256kM memory of VGA(1&lt;&lt;1).
	 *    enable extended palette addressing (1&lt;&lt;8)
	*/
	i81x-&gt;pixconf = (1&lt;&lt;12)|(1&lt;&lt;0);
	i81x-&gt;pixconf &amp;= 0xFFFFFBFF;	/* disable overscan color */
	switch(vga-&gt;mode-&gt;z) {		/* vga-&gt;mode-&gt;z: color depth */
	case 8:
		i81x-&gt;pixconf |= (2&lt;&lt;16);
		break;
	case 16:	/* (5:6:5 bit) */
		i81x-&gt;pixconf |= (5&lt;&lt;16);
		break;
	case 24:
		i81x-&gt;pixconf |= (6&lt;&lt;16);
		break;
	case 32:		/* not supported */
		i81x-&gt;pixconf |= (7&lt;&lt;16);
		break;
	default:
		error("%s: depth %d not supported\n", ctlr-&gt;name, vga-&gt;mode-&gt;z);
	}

	/* DON'T CARE of Sequencer Reg. */
	/* DON'T CARE of Attribute registers other than this */
	vga-&gt;attribute[0x11] = 0;		/* over scancolor = black */
	/* DON't CARE of graphics[1], [2], [3], [4], [5], [6], [7] and [8] value */
	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear)) {
	/* enable linear mapping, no VGA memory and no page mapping */
		vga-&gt;graphics[0x10] = 0x0A;
		ctlr-&gt;flag |= Ulinear;
	}

	vt = vga-&gt;mode-&gt;vt;
	vde = vga-&gt;virty;
	vrs = vga-&gt;mode-&gt;vrs;
	vre = vga-&gt;mode-&gt;vre+6;		/* shift 7 pixel up */

	if(vga-&gt;mode-&gt;interlace == 'v') {
		vt /= 2;
		vde /= 2;
		vrs /= 2;
		vre /= 2;
	}
		/* Reset Row scan */
	vga-&gt;crt[8] = 0;
/* Line Compare, bit 6 of crt[9], bit 4 of crt[7] and crt[0x18], should be
 *	vga-&gt;crt[9] = vgaxi(Crtx, 9) | ((vde&gt;&gt;9 &amp; 1)&lt;&lt;6) &amp; 0x7F;
 *	vga-&gt;crt[7] = vgaxi(Crtx, 7) | ((vde&gt;&gt;8 &amp; 1)&lt;&lt;4);
 *	vga-&gt;crt[0x18] = vde &amp; 0xFF;
 *      However, above values don't work!!  I don't know why.   K.Okamoto
 */
	vga-&gt;crt[9] = 0;		/* I don't know why ? */
	vga-&gt;crt[7] = 0;		/* I don't know why ? */
	vga-&gt;crt[0x18] = 0;		/* I don't know why ? */
/*	32 bits Start Address of frame buffer (AGP aperture memory)
	vga-&gt;crt[0x42] = MSB 8 bits of Start Address Register, extended high start address Reg.
	vga-&gt;crt[0x40] = higer 6 bits in 0~5 bits, and the MSB = 1, extebded start address Reg.
	vga-&gt;crt[0x0C] = Start Address High Register
	vga-&gt;crt[0x0D] = Start Address Low Register
	LSB 2 bits of Start Address are always 0
 */
	vga-&gt;crt[0x42] = vga-&gt;pci-&gt;mem[0].bar&gt;&gt;24 &amp; 0xFF;
	vga-&gt;crt[0x40] = vga-&gt;pci-&gt;mem[0].bar&gt;&gt;18 &amp; 0x3F | 0x80;
		/* Start Address High */
	vga-&gt;crt[0x0C] = vga-&gt;pci-&gt;mem[0].bar&gt;&gt;10 &amp; 0xFF;
		/* Start Address Low */
	vga-&gt;crt[0x0D] = (vga-&gt;pci-&gt;mem[0].bar &gt;&gt;2 + 1)&amp; 0xFF;
		/* Underline Location, Memory Mode, DON'T CARE THIS VALUE */
	vga-&gt;crt[0x14] = 0x0;
		/* CRT Mode Control */
	vga-&gt;crt[0x17] = 0x80;		/* CRT normal mode */
		/* Frame buffer memory offset  (memory amount for a line) */
		/* vga-&gt;crt[0x13] = lower 8 bits of Offset Register
			vga-&gt;crt[0x41] = MSB 4 bits, those value should be
			vga-&gt;crt[0x13] = (vga-&gt;virtx*(vga-&gt;mode-&gt;z&gt;&gt;3)/4) &amp; 0xFF;
			vga-&gt;crt[0x41] = (vga-&gt;virtx*(vga-&gt;mode-&gt;z&gt;&gt;3)/4)&gt;&gt;8 &amp; 0x0F;
		  However, those doesn't work properly  K.Okamoto
		*/
	vga-&gt;crt[0x41] = (vga-&gt;crt[0x13]&gt;&gt;8) &amp; 0x0F;		//dhog

		/* Horizontal Total */
	vga-&gt;crt[0] = ((vga-&gt;mode-&gt;ht&gt;&gt;3)-6) &amp; 0xFF;
		/* Extended Horizontal Total Time Reg (ht)  */
	vga-&gt;crt[0x35] = vga-&gt;mode-&gt;ht&gt;&gt;12 &amp; 0x01;
//	vga-&gt;crt[0x35] = (((vga-&gt;mode-&gt;ht&gt;&gt;1)-5)&gt;&gt;8) &amp; 0x01;	//dhog
		/* Horizontal Display Enable End == horizontal width */
	vga-&gt;crt[1] = (vga-&gt;virtx-1)&gt;&gt;3 &amp; 0xFF;
		/* Horizontal Blanking Start */
	vga-&gt;crt[2] = ((vga-&gt;mode-&gt;shb&gt;&gt;3)-1) &amp; 0xFF;
		/* Horizontal blanking End crt[39](0),crt[5](7),crt[3](4:0) */
	vga-&gt;crt[3] = (vga-&gt;mode-&gt;shb - vga-&gt;virtx)&gt;&gt;3 &amp; 0x1F;
	vga-&gt;crt[5] = ((vga-&gt;mode-&gt;shb - vga-&gt;virtx)&gt;&gt;3 &amp; 0x20) &lt;&lt;2;
	vga-&gt;crt[0x39] = ((vga-&gt;mode-&gt;shb - vga-&gt;virtx)&gt;&gt;3 &amp; 0x40) &gt;&gt;6;
//	vga-&gt;crt[0x39] = (vga-&gt;mode-&gt;ehb&gt;&gt;9) &amp; 0x01;		//dhog
		/* Horizontal Sync Start */
	vga-&gt;crt[4] = vga-&gt;mode-&gt;shb&gt;&gt;3 &amp; 0xFF;
		/* Horizontal Sync End */
	vga-&gt;crt[5] |= vga-&gt;mode-&gt;ehb&gt;&gt;3 &amp; 0x1F;
		/* Extended Vertical Total (vt) */
	vga-&gt;crt[6] = (vt - 2) &amp; 0xFF;
	vga-&gt;crt[0x30] = (vt - 2)&gt;&gt;8 &amp; 0x0F;
		/* Vertical Sync Period */
	vga-&gt;crt[0x11] = (vre - vrs - 2) &amp; 0x0F;
		/* Vertical Blanking End  */
	vga-&gt;crt[0x16] = (vre - vrs) &amp; 0xFF;
		/* Extended Vertical Display End (y) */
	vga-&gt;crt[0x12] = (vde-1) &amp; 0xFF;
	vga-&gt;crt[0x31] = (vde-1)&gt;&gt;8 &amp; 0x0f;
		/* Extended Vertical Sync Start (vrs)  */
	vga-&gt;crt[0x10] = (vrs-1) &amp; 0xFF;
	vga-&gt;crt[0x32] = (vrs-1)&gt;&gt;8 &amp; 0x0F;
		/* Extended Vertical Blanking Start (vrs) */
	vga-&gt;crt[0x15] = vrs &amp; 0xFF;
	vga-&gt;crt[0x33] = vrs&gt;&gt;8 &amp; 0x0F;

	if(vga-&gt;mode-&gt;interlace == 'v')
		vga-&gt;crt[0x70] = vrs | 0x80;
	else
		vga-&gt;crt[0x70] = 0;
	vga-&gt;crt[0x80] = 1;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	int i;
	ulong *rp;
	I81x *i81x;
	char *p;

	i81x = vga-&gt;private;

	vgaxo(Attrx, 0x11, vga-&gt;attribute[0x11]);
	/* set the screen graphic mode */
	vgaxo(Crtx, 0x80, vga-&gt;crt[0x80]);
	vgaxo(Grx, 0x10, vga-&gt;graphics[0x10]);
	vgao(MiscW, vga-&gt;misc);
	for(i=0; i &lt;= 0x18; i++)
		vgaxo(Crtx, i, vga-&gt;crt[i]);
	for(i=0x30; i &lt;= 0x82; i++)
		vgaxo(Crtx, i, vga-&gt;crt[i]);
	vga-&gt;crt[0x40] |= 0x80;			/* set CR40, then set the MSB bit of it */
	vgaxo(Crtx, 0x40, vga-&gt;crt[0x40]);
	/* 0x06000 = offset of Vertical Clock Devisor VGA0 */
	rp = (ulong*)(i81x-&gt;mmio+0x06000);
	for(i=0; i &lt; nelem(i81x-&gt;clk); i++)
		*rp++ = i81x-&gt;clk[i];
	rp = (ulong*)(i81x-&gt;mmio+0x60000);
	for(i = 0; i &lt; nelem(i81x-&gt;lcd); i++)
		*rp++ = i81x-&gt;lcd[i];
	/* set cursor, graphic mode */
	rp = (ulong*)(i81x-&gt;mmio+0x70008);
	*rp = i81x-&gt;pixconf | (1&lt;&lt;8);

	p = (char*)(i81x-&gt;mmio+Pixmask);	/* DACMASK */
	*p = 0xff;
	p = (char*)(i81x-&gt;mmio+PaddrW);		/* DACWX */
	*p = 0x04;
	p = (char*)(i81x-&gt;mmio+Pdata);		/* DACDATA */
	*p = 0xff;
	*p = 0xff;
	*p = 0xff;
	*p = 0x00;
	*p = 0x00;
	*p = 0x00;
	*rp = i81x-&gt;pixconf;

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	Pcidev *p;
	I81x *i81x;
	char *name;

	name = ctlr-&gt;name;
	i81x = vga-&gt;private;

	printitem(name, "Crt30");
	for(i = 0x30; i &lt;= 0x39; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt40");
	for(i = 0x40; i &lt;= 0x42; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt70");
	for(i = 0x70; i &lt;= 0x79; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Crt80");
	for(i = 0x80; i &lt;= 0x82; i++)
		printreg(vga-&gt;crt[i]);

	printitem(name, "Graphics10");
	for(i = 0x10; i &lt;= 0x1f; i++)
		printreg(vga-&gt;graphics[i]);

	printitem(name, "clk");
	for(i = 0; i &lt; nelem(i81x-&gt;clk); i++)
		printreg(i81x-&gt;clk[i]);

	printitem(name, "lcd");
	for(i = 0; i &lt; nelem(i81x-&gt;lcd); i++)
		printreg(i81x-&gt;lcd[i]);

	printitem(name, "pixconf");
	printreg(i81x-&gt;pixconf);

	p = i81x-&gt;pci;
	printitem(name, "mem[0]");
	Bprint(&amp;stdout, "base %lux size %d\n", p-&gt;mem[0].bar &amp; ~0x0F, p-&gt;mem[0].size);

	printitem(name, "mem[1]");
	Bprint(&amp;stdout, "base %lux size %d\n", p-&gt;mem[1].bar &amp; ~0x0F, p-&gt;mem[1].size);

}

Ctlr i81x = {
	"i81x",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr i81xhwgc = {
	"i81xhwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

