<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/icd2061a.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/icd2061a.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * IC Designs ICD2061A Dual Programmable Graphics Clock Generator.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

enum {
	Prescale	= 2,			/* P counter prescale (default) */
	NIndex		= 14,			/* number of index field values */
};

/*
 * For an index value of x, the appropriate VCO range
 * is &gt;= index[x] &amp;&amp; &lt;= index[x+1]. The higher index is
 * prefered if VCO is on a boundary.
 */
static ulong index[NIndex] = {
	 50000000,
	 51000000,
	 53200000,
	 58500000,
	 60700000,
	 64400000,
	 66800000,
	 73500000,
	 75600000,
	 80900000,
	 83200000,
	 91500000,
	100000000,
	120000000,
};

static void
init(Vga* vga, Ctlr* ctlr)
{
	int f;
	ulong d, dmax, fmin, n;

	if(ctlr-&gt;flag &amp; Finit)
		return;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	/*
	 * Post-VCO divisor. Constraint:
	 * 	50MHz &lt;= vga-&gt;f &lt;= 120MHz
	 */
	for(vga-&gt;p[0] = 0; vga-&gt;f[0] &lt;= 50000000; vga-&gt;p[0]++)
		vga-&gt;f[0] &lt;&lt;= 1;

	/*
	 * Determine index.
	 */
	for(vga-&gt;i[0] = NIndex-1; vga-&gt;f[0] &lt; index[vga-&gt;i[0]] &amp;&amp; vga-&gt;i[0]; vga-&gt;i[0]--)
		;

	/*
	 * Denominator. Constraints:
	 *	200KHz &lt;= RefFreq/d &lt;= 1MHz
	 * and
	 *	3 &lt;= d &lt;= 129
	 *
	 * Numerator. Constraint:
	 *	4 &lt;= n &lt;= 130
	 */
	d = RefFreq/1000000 &gt; 3 ? RefFreq/1000000: 3;
	dmax = RefFreq/200000 &lt; 129 ? RefFreq/200000: 129;

	/*
	 * Now look for values of p and q that give
	 * the least error for
	 *	vga-&gt;f = (Prescale*RefFreq*n/d);
	 */
	vga-&gt;d[0] = d;
	vga-&gt;n[0] = 4;
	for(fmin = vga-&gt;f[0]; d &lt;= dmax; d++){
		for(n = 4; n &lt;= 130; n++){
			f = vga-&gt;f[0] - (Prescale*RefFreq*n/d);
			if(f &lt; 0)
				f = -f;
			if(f &lt; fmin){
				fmin = f;
				vga-&gt;d[0] = d;
				vga-&gt;n[0] = n;
			}
		}
	}

	/*
	 * The serial word to be loaded into the icd2061a is
	 *	(2&lt;&lt;21)|(vga-&gt;i&lt;&lt;17)|((vga-&gt;n)&lt;&lt;10)|(vga-&gt;p&lt;&lt;7)|vga-&gt;d
	 * Always select ICD2061A REG2.
	 */
	vga-&gt;f[0] = (Prescale*RefFreq*vga-&gt;n[0]/vga-&gt;d[0]);
	vga-&gt;d[0] -= 2;
	vga-&gt;n[0] -= 3;

	ctlr-&gt;flag |= Finit;
}

Ctlr icd2061a = {
	"icd2061a",
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

