<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/ics2494.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/ics2494.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Integrated Circuit Systems, Inc.
 * ICS2494[A] Dual Video/Memory Clock Generator.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

typedef struct {
	char*	name[2];
	ulong	frequency[16];
} Pattern;

static Pattern patterns[] = {
	{ "237", "304",
	 50350000,  56644000,  65000000,  72000000,  80000000,  89800000,  63000000,  75000000,
	 25175000,  28322000,  31500000,  36000000,  40000000,  44900000,  50000000,  65000000,
	},

	{ "324", 0,
	 50350000,  56644000,  65000000,  72000000,  80000000,  89800000,  63000000,  75000000,
	 83078000,  93463000, 100000000, 104000000, 108000000, 120000000, 130000000, 134700000,
	},

	{ 0,
	},
};

static void
init(Vga* vga, Ctlr* ctlr)
{
	Pattern *pattern;
	char *p;
	int f, index, divisor, maxdivisor;

	if(ctlr-&gt;flag &amp; Finit)
		return;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;

	if((p = strchr(ctlr-&gt;name, '-')) == 0)
		error("%s: unknown pattern\n", ctlr-&gt;name);
	p++;

	for(pattern = patterns; pattern-&gt;name[0]; pattern++){
		if(strcmp(pattern-&gt;name[0], p) == 0)
			break;
		if(pattern-&gt;name[1] &amp;&amp; strcmp(pattern-&gt;name[1], p) == 0)
			break;
	}
	if(pattern-&gt;name[0] == 0)
		error("%s: unknown pattern\n", ctlr-&gt;name);

	maxdivisor = 1;
	if(vga-&gt;ctlr &amp;&amp; (vga-&gt;ctlr-&gt;flag &amp; Hclkdiv))
		maxdivisor = 8;
	for(index = 0; index &lt; 16; index++){
		for(divisor = 1; divisor &lt;= maxdivisor; divisor &lt;&lt;= 1){
			f = vga-&gt;f[0] - pattern-&gt;frequency[index]/divisor;
			if(f &lt; 0)
				f = -f;
			if(f &lt; 1000000){
				/*vga-&gt;f = pattern-&gt;frequency[index];*/
				vga-&gt;d[0] = divisor;
				vga-&gt;i[0] = index;

				ctlr-&gt;flag |= Finit;
				return;
			}
		}
	}
	error("%s: can't find frequency %ld\n", ctlr-&gt;name, vga-&gt;f[0]);
}

Ctlr ics2494 = {
	"ics2494",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	0,				/* load */
	0,				/* dump */
};

Ctlr ics2494a = {
	"ics2494a",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

