<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/io.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/io.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

int curprintindex;

static int iobfd = -1;
static int iowfd = -1;
static int iolfd = -1;
static int biosfd = -1;
static ulong biosoffset = 0;

enum {
	Nctlchar	= 256,
	Nattr		= 16,
};

static int ctlfd = -1;
static char ctlbuf[Nctlchar];
static int ctlclean;

static struct {
	char*	attr;
	char*	val;
} attr[Nattr];

static int
devopen(char* device, int mode)
{
	int fd;

	if((fd = open(device, mode)) &lt; 0)
		error("devopen(%s, %d): %r\n", device, mode);
	return fd;
}

uchar
inportb(long port)
{
	uchar data;

	if(iobfd == -1)
		iobfd = devopen("#P/iob", ORDWR);

	if(pread(iobfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("inportb(0x%4.4lx): %r\n", port);
	return data;
}

void
outportb(long port, uchar data)
{
	if(iobfd == -1)
		iobfd = devopen("#P/iob", ORDWR);

	if(pwrite(iobfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("outportb(0x%4.4lx, 0x%2.2uX): %r\n", port, data);
}

ushort
inportw(long port)
{
	ushort data;

	if(iowfd == -1)
		iowfd = devopen("#P/iow", ORDWR);

	if(pread(iowfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("inportw(0x%4.4lx): %r\n", port);
	return data;
}

void
outportw(long port, ushort data)
{
	if(iowfd == -1)
		iowfd = devopen("#P/iow", ORDWR);

	if(pwrite(iowfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("outportw(0x%4.4lx, 0x%2.2uX): %r\n", port, data);
}

ulong
inportl(long port)
{
	ulong data;

	if(iolfd == -1)
		iolfd = devopen("#P/iol", ORDWR);

	if(pread(iolfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("inportl(0x%4.4lx): %r\n", port);
	return data;
}

void
outportl(long port, ulong data)
{
	if(iolfd == -1)
		iolfd = devopen("#P/iol", ORDWR);

	if(pwrite(iolfd, &amp;data, sizeof(data), port) != sizeof(data))
		error("outportl(0x%4.4lx, 0x%2.2luX): %r\n", port, data);
}

static void
vgactlinit(void)
{
	int nattr;
	char *nl, *p, *vp;

	if(ctlclean)
		return;

	if(ctlfd == -1){
		ctlfd = devopen("#v/vgactl", ORDWR);
		memset(attr, 0, sizeof(attr));
	}

	seek(ctlfd, 0, 0);
	nattr = read(ctlfd, ctlbuf, Nctlchar-1);
	if(nattr &lt; 0)
		error("vgactlr: read: %r\n");
	ctlbuf[nattr] = 0;

	nattr = 0;
	vp = ctlbuf;
	for(nl = strchr(ctlbuf, '\n'); nl; nl = strchr(nl, '\n')){

		*nl = '\0';
		if(p = strchr(vp, ' ')){
			*p++ = '\0';
			attr[nattr].attr = vp;
			if(*p == '\0')
				error("vgactlr: bad format: &lt;%s&gt;\n", vp);
			attr[nattr].val = p;
		}
		else
			error("vgactlr: bad format: &lt;%s&gt;\n", vp);

		if(++nattr &gt;= Nattr-2)
			error("vgactlr: too many attributes: %d\n", nattr);
		attr[nattr].attr = 0;

		vp = ++nl;
	}

	ctlclean = 1;
}

char*
vgactlr(char* a, char* v)
{
	int i;

	trace("vgactlr: look for %s\n", a);
	vgactlinit();
	for(i = 0; attr[i].attr; i++){
		if(strcmp(attr[i].attr, a) == 0){
			strcpy(v, attr[i].val);
			trace("vgactlr: value %s\n", v);
			return v;
		}
	}
	trace("vgactlr: %s not found\n", a);

	return 0;
}

void
vgactlw(char* attr, char* val)
{
	int len;
	char buf[128];

	if(ctlfd == -1)
		ctlfd = devopen("#v/vgactl", ORDWR);

	seek(ctlfd, 0, 0);
	len = sprint(buf, "%s %s", attr, val);
	trace("+vgactlw %s\n", buf);
	if(write(ctlfd, buf, len) != len)
		error("vgactlw: &lt;%s&gt;: %r\n",  buf);
	trace("-vgactlw %s\n", buf);

	ctlclean = 0;
}

void
setpalette(int p, int r, int g, int b)
{
	vgao(PaddrW, p);
	vgao(Pdata, r);
	vgao(Pdata, g);
	vgao(Pdata, b);
}

static long
doreadbios(char* buf, long len, long offset)
{
	char file[64];

	if(biosfd == -1){
		biosfd = open("#v/vgabios", OREAD);
		biosoffset = 0;
	}
	if(biosfd == -1){
		snprint(file, sizeof file, "#p/%d/mem", getpid());
		biosfd = devopen(file, OREAD);
		biosoffset = 0x80000000;
	}
	if(biosfd == -1)
		return -1;
	seek(biosfd, biosoffset+offset, 0);
	return read(biosfd, buf, len);
}

char*
readbios(long len, long offset)
{
	static char bios[0x10000];
	static long biosoffset;
	static long bioslen;
	int n;

	if(biosoffset &lt;= offset &amp;&amp; offset+len &lt;= biosoffset+bioslen)
		return bios+(offset - biosoffset);

	if(len &gt; sizeof(bios))
		error("enormous bios len %ld at %lux\n", len, offset);

	n = doreadbios(bios, sizeof(bios), offset);
	if(n &lt; len)
		error("short bios read %ld at %lux got %d\n", len,offset, n);

	biosoffset = offset;
	bioslen = n;
	return bios;
}

void
dumpbios(long size)
{
	uchar *buf;
	long offset;
	int i, n;
	char c;

	buf = alloc(size);
	offset = 0xC0000;
	if(doreadbios((char*)buf, size, offset) != size)
		error("short bios read in dumpbios\n");

	if(buf[0] != 0x55 || buf[1] != 0xAA){
		offset = 0xE0000;
		if(doreadbios((char*)buf, size, offset) != size)
			error("short bios read in dumpbios\n");
		if(buf[0] != 0x55 || buf[1] != 0xAA){
			free(buf);
			return;
		}
	}

	for(i = 0; i &lt; size; i += 16){
		Bprint(&amp;stdout, "0x%luX", offset+i);
		for(n = 0; n &lt; 16; n++)
			Bprint(&amp;stdout, " %2.2uX", buf[i+n]);
		Bprint(&amp;stdout, "  ");
		for(n = 0; n &lt; 16; n++){
			c = buf[i+n];
			if(c &lt; 0x20 || c &gt;= 0x7F)
				c = '.';
			Bprint(&amp;stdout, "%c", c);
		}
		Bprint(&amp;stdout, "\n");
	}
	free(buf);
}

void*
alloc(ulong nbytes)
{
	void *v;

	if((v = malloc(nbytes)) == 0)
		error("alloc: %lud bytes - %r\n", nbytes);

	return memset(v, 0, nbytes);
}

void
printitem(char* ctlr, char* item)
{
	int n;

	if(curprintindex){
		curprintindex = 0;
		Bprint(&amp;stdout, "\n");
	}

	n = 0;
	if(ctlr &amp;&amp; *ctlr)
		n = Bprint(&amp;stdout, "%s ", ctlr);
	Bprint(&amp;stdout, "%-*s", 20-n, item);
}

void
printreg(ulong data)
{
	int width;

	width = 3;
	if((curprintindex % 16) == 0 &amp;&amp; curprintindex){
		Bprint(&amp;stdout, "\n");
		curprintindex = 0;
		width = 23;
	}
	if(curprintindex == 8)
		Bprint(&amp;stdout, " -");
	Bprint(&amp;stdout, "%*.2luX", width, data);
	curprintindex++;
}

static char *flagname[32] = {
	[0x00]	"Fsnarf",
	[0x01]	"Foptions",
	[0x02]	"Finit",
	[0x03]	"Fload",
	[0x04]	"Fdump",

	[0x08]	"Hpclk2x8",
	[0x09]	"Upclk2x8",
	[0x0A]	"Henhanced",
	[0x0B]	"Uenhanced",
	[0x0C]	"Hpvram",
	[0x0D]	"Upvram",
	[0x0E]	"Hextsid",
	[0x0F]	"Uextsid",
	[0x10]	"Hclk2",
	[0x11]	"Uclk2",
	[0x12]	"Hlinear",
	[0x13]	"Ulinear",
	[0x14]	"Hclkdiv",
	[0x15]	"Uclkdiv",
	[0x16]	"Hsid32",
};

void
printflag(ulong flag)
{
	int i;
	char first;

	first = ' ';
	for(i = 31; i &gt;= 0; i--){
		if((flag &amp; (1&lt;&lt;i)) == 0)
			continue;
		if(flagname[i])
			Bprint(&amp;stdout, "%c%s", first, flagname[i]);
		else
			Bprint(&amp;stdout, "%c0x%x", first, 1&lt;&lt;i);
		first = '|';
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

