<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/mach32.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/mach32.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * ATI Mach32. Some hope.
 * No support for accelerator so can only do up to 1024x768.
 *
 * All ATI Extended Registers are addressed using the modified index
 *	index = (0x02&lt;&lt;6)|(index &amp; 0x3F);
 * so registers 0x00-&gt;0x3F map to 0x80-&gt;0xBF, but we will only ever
 * look at a few in the range 0xA0-&gt;0xBF. In this way we can stash
 * them in the vga-&gt;crt[] array.
 */
enum {
	Advfunc		= 0x4AE8,	/* Advanced Function Control Register */
	Clocksel	= 0x4AEE,	/* Clock Select Register */
	Misc		= 0x36EE,	/* Miscellaneous Register */
	Membndry	= 0x42EE,	/* Memory Boundary Register */
	Memcfg		= 0x5EEE,	/* Memory Control Register */
};

typedef struct {
	ushort	advfunc;
	ushort	clocksel;
	ushort	misc;
	ushort	membndry;
	ushort	memcfg;
} Mach32;

/*
 * There are a number of possible clock generator chips for these
 * boards, and I don't know how to find out which is installed, other
 * than by looking at the board. So, pick a subset that will work for
 * all.
 */
typedef struct {
	ulong	frequency;
	uchar	b8;			/* &lt;6&gt; - divide by 2 */
	uchar	b9;			/* &lt;1&gt; - bit &lt;3&gt; of frequency index */
	uchar	be;			/* &lt;4&gt; - bit &lt;2&gt; of frequency index */
	uchar	misc;			/* &lt;3:2&gt; - bits &lt;1:0&gt; of frequency index */
} Clock;

static Clock clocks[] = {
	{  VgaFreq0,	0x40, 0x02, 0x00, 0x00, },
	{  32000000,	0x00, 0x00, 0x10, 0x04, },
	{  40000000,	0x00, 0x02, 0x10, 0x00, },
	{  44900000,	0x00, 0x02, 0x00, 0x0C, },
	{  65000000,	0x00, 0x02, 0x10, 0x0C, },
	{  75000000,	0x00, 0x02, 0x10, 0x08, },
	{	  0, },
};
	
static ulong atix;

static uchar
atixi(uchar index)
{
	outportb(atix, index);
	return inportb(atix+1);
}

static void
atixo(uchar index, uchar data)
{
	outportw(atix, (data&lt;&lt;8)|index);
}

static void
atixinit(Vga* vga, Ctlr*)
{
	uchar b;
	Mach32 *mach32;

	/*
	 * We could try to read in a part of the BIOS and try to determine
	 * the extended register address, but since we can't determine the offset value,
	 * we'll just have to assume the defaults all round.
	 */
	atix = 0x1CE;

	/*
	 * Unlock the ATI Extended Registers.
	 * We leave them unlocked from now on.
	 * Why does this chip have so many
	 * lock bits?
	 */
	if((b = atixi(0xB8)) &amp; 0x3F)
		atixo(0xB8, b &amp; 0xC0);
	b = atixi(0xAB);
	atixo(0xAB, b &amp; ~0x18);
	atixo(0xB4, 0x00);
	b = atixi(0xB9);
	atixo(0xB9, b &amp; ~0x80);
	b = atixi(0xBE);
	atixo(0xBE, b|0x09);

	if(vga-&gt;private == 0)
		vga-&gt;private = alloc(sizeof(mach32));
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;
	Mach32 *mach32;

	atixinit(vga, ctlr);
	for(i = 0xA0; i &lt; 0xC0; i++)
		vga-&gt;crt[i] = atixi(i);

	mach32 = vga-&gt;private;
	mach32-&gt;advfunc = inportw(Advfunc);
	mach32-&gt;clocksel = inportw(Clocksel);
	mach32-&gt;misc = inportw(Misc);
	mach32-&gt;membndry = inportw(Membndry);
	mach32-&gt;memcfg = inportw(Memcfg);

	/*
	 * Memory size.
	 */
	switch((mach32-&gt;misc&gt;&gt;2) &amp; 0x03){

	case 0:
		vga-&gt;vmz = 512*1024;
		break;

	case 1:
		vga-&gt;vmz = 1024*1024;
		break;

	case 2:
		vga-&gt;vmz = 2*1024*1024;
		break;

	case 3:
		vga-&gt;vmz = 4*1024*1024;
		break;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Clock *clockp;
	Mode *mode;

	mode = vga-&gt;mode;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	for(clockp = clocks; clockp-&gt;frequency; clockp++){
		if(clockp-&gt;frequency &gt; vga-&gt;f[0]+100000)
			continue;
		if(clockp-&gt;frequency &gt; vga-&gt;f[0]-100000)
			break;
	}
	if(clockp-&gt;frequency == 0)
		error("%s: no suitable clock for %lud\n",
			ctlr-&gt;name, vga-&gt;f[0]);

	vga-&gt;crt[0xB0] &amp;= 0xDA;
	vga-&gt;crt[0xB1] &amp;= 0x87;
	vga-&gt;crt[0xB5] &amp;= 0x7E;
	vga-&gt;crt[0xB6] &amp;= 0xE2;
	vga-&gt;crt[0xB3] &amp;= 0xAF;
	vga-&gt;crt[0xA6] &amp;= 0xFE;
	vga-&gt;crt[0xA7] &amp;= 0xF4;

	/*
	 * 256-colour linear addressing.
	 */
	if(mode-&gt;z == 8){
		vga-&gt;graphics[0x05] = 0x00;
		vga-&gt;attribute[0x10] &amp;= ~0x40;
		vga-&gt;crt[0x13] = (mode-&gt;x/8)/2;
		vga-&gt;crt[0x14] = 0x00;
		vga-&gt;crt[0x17] = 0xE3;

		vga-&gt;crt[0xB0] |= 0x20;
		vga-&gt;crt[0xB6] |= 0x04;
	}
	vga-&gt;attribute[0x11] = 0x00;
	vga-&gt;crt[0xB6] |= 0x01;
	vga-&gt;crt[0xBE] &amp;= ~0x04;

	/*
	 * Do the clock index bits.
	 */
	vga-&gt;crt[0xB9] &amp;= 0xFD;
	vga-&gt;crt[0xB8] &amp;= 0x3F;
	vga-&gt;crt[0xBE] &amp;= 0xE5;

	vga-&gt;crt[0xB8] |= clockp-&gt;b8;
	vga-&gt;crt[0xB9] |= clockp-&gt;b9;
	vga-&gt;crt[0xBE] |= clockp-&gt;be;
	vga-&gt;misc |= clockp-&gt;misc;

	if(vga-&gt;mode-&gt;interlace == 'v')
		vga-&gt;crt[0xBE] |= 0x02;

	/*
	 * Turn off 128Kb CPU address bit so
	 * we only have a 64Kb aperture at 0xA0000.
	 */
	vga-&gt;crt[0xBD] &amp;= ~0x04;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ushort x;

	/*
	 * Make sure we are in VGA mode,
	 * and that we have access to all the video memory through
	 * the 64Kb VGA aperture by disabling and linear aperture
	 * and memory boundary.
	 */
	outportw(Clocksel, 0x0000);
	x = inportw(Memcfg) &amp; ~0x0003;
	outportw(Memcfg, x);
	outportw(Membndry, 0x0000);

	atixo(0xB0, vga-&gt;crt[0xB0]);
	atixo(0xB1, vga-&gt;crt[0xB1]);
	atixo(0xB5, vga-&gt;crt[0xB5]);
	atixo(0xB6, vga-&gt;crt[0xB6]);
	atixo(0xB3, vga-&gt;crt[0xB3]);
	atixo(0xA6, vga-&gt;crt[0xA6]);
	atixo(0xA7, vga-&gt;crt[0xA7]);
	atixo(0xB8, vga-&gt;crt[0xB8]);
	atixo(0xB9, vga-&gt;crt[0xB9]);
	atixo(0xBE, vga-&gt;crt[0xBE]);
	vgao(MiscW, vga-&gt;misc);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	Mach32 *mach32;

	printitem(ctlr-&gt;name, "ATIX");
	for(i = 0xA0; i &lt; 0xC0; i++)
		printreg(vga-&gt;crt[i]);

	if((mach32 = vga-&gt;private) == 0)
		return;

	printitem(ctlr-&gt;name, "ADVFUNC");
	Bprint(&amp;stdout, "%.4ux\n", mach32-&gt;advfunc);
	printitem(ctlr-&gt;name, "CLOCKSEL");
	Bprint(&amp;stdout, "%.4ux\n", mach32-&gt;clocksel);
	printitem(ctlr-&gt;name, "MISC");
	Bprint(&amp;stdout, "%.4ux\n", mach32-&gt;misc);
	printitem(ctlr-&gt;name, "MEMBNDRY");
	Bprint(&amp;stdout, "%.4ux\n", mach32-&gt;membndry);
	printitem(ctlr-&gt;name, "MEMCFG");
	Bprint(&amp;stdout, "%.4ux\n", mach32-&gt;memcfg);
}

Ctlr mach32 = {
	"mach32",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

