<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

Biobuf stdout;

static int iflag, lflag, pflag, rflag;

static char *dbname = "/lib/vgadb";
static char monitordb[128];

static void
dump(Vga* vga)
{
	Ctlr *ctlr;
	Attr *attr;
	
	if(vga-&gt;mode)
		dbdumpmode(vga-&gt;mode);

	for(attr = vga-&gt;attr; attr; attr = attr-&gt;next)
		Bprint(&amp;stdout, "vga-&gt;attr: %s=%s\n", attr-&gt;attr, attr-&gt;val);

	for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link){
		if(ctlr-&gt;dump == 0)
			continue;

		trace("%s-&gt;dump\n", ctlr-&gt;name);
		if(ctlr-&gt;flag &amp;&amp; ctlr-&gt;flag != Fsnarf){
			printitem(ctlr-&gt;name, "flag");
			printflag(ctlr-&gt;flag);
			Bprint(&amp;stdout, "\n");
		}
		(*ctlr-&gt;dump)(vga, ctlr);
		ctlr-&gt;flag |= Fdump;
	}
	Bprint(&amp;stdout, "\n");
}

void
resyncinit(Vga* vga, Ctlr* ctlr, ulong on, ulong off)
{
	Ctlr *link;

	trace("%s-&gt;resyncinit on 0x%8.8luX off 0x%8.8luX\n",
		ctlr-&gt;name, on, off);

	for(link = vga-&gt;link; link; link = link-&gt;link){
		link-&gt;flag |= on;
		link-&gt;flag &amp;= ~off;
		if(link == ctlr)
			continue;

		if(link-&gt;init == 0 || (link-&gt;flag &amp; Finit) == 0)
			continue;
		link-&gt;flag &amp;= ~Finit;
		trace("%s-&gt;init 0x%8.8luX\n", link-&gt;name, link-&gt;flag);
		(*link-&gt;init)(vga, link);
	}
}

void
sequencer(Vga* vga, int on)
{
	static uchar seq01;
	static int state = 1;
	char *s;

	if(on)
		s = "on";
	else
		s = "off";
	trace("sequencer-&gt;enter %s\n", s);
	if(on){
		if(vga)
			seq01 = vga-&gt;sequencer[0x01];
		if(state == 0){
			seq01 |= 0x01;
			vgaxo(Seqx, 0x01, seq01);
			vgaxo(Seqx, 0x00, 0x03);
		}
	}
	else{
		vgaxo(Seqx, 0x00, 0x01);
		seq01 = vgaxi(Seqx, 0x01);
		vgaxo(Seqx, 0x01, seq01|0x20);
	}
	state = on;
	trace("sequencer-&gt;leave %s\n", s);
}

static void
linear(Vga* vga)
{
	char buf[256];
	char *p;

	/*
	 * Set up for linear addressing: try to allocate the
	 * kernel memory map then read the base-address back.
	 * vga-&gt;linear is a compatibility hack.
	 */
	if(vga-&gt;linear == 0){
		vga-&gt;ctlr-&gt;flag &amp;= ~Ulinear;
		return;
	}
	if(vga-&gt;ctlr-&gt;flag &amp; Ulinear){
		/*
		 * If there's already an aperture don't bother trying
		 * to set up a new one.
		 */
		vgactlr("addr", buf);
		if(atoi(buf)==0 &amp;&amp; (buf[0]!='p' || buf[1]!=' ' || atoi(buf+2)==0)){
			sprint(buf, "0x%lux 0x%lux", vga-&gt;apz ? vga-&gt;apz : vga-&gt;vmz, vga-&gt;vma);
			vgactlw("linear", buf);
			vgactlr("addr", buf);
		}
		trace("linear-&gt;addr %s\n", buf);
		/*
		 * old: addr 0x12345678
		 * new: addr p 0x12345678 v 0x82345678 size 0x123
		 */
		if(buf[0]=='p' &amp;&amp; buf[1]==' '){
			vga-&gt;vmb = strtoul(buf+2, 0, 0);
			p = strstr(buf, "size");
			if(p)
				vga-&gt;apz = strtoul(p+4, 0, 0);
		}else
			vga-&gt;vmb = strtoul(buf, 0, 0);
	}
	else
		vgactlw("linear", "0");
}

char*
chanstr[32+1] = {
[1]	"k1",
[2]	"k2",
[4]	"k4",
[8]	"m8",
[16]	"r5g6b5",
[24]	"r8g8b8",
[32]	"x8r8g8b8",
};

static void
usage(void)
{
	fprint(2, "usage: aux/vga [ -BcdilpvV ] [ -b bios-id ] [ -m monitor ] [ -x db ] [ mode [ virtualsize ] ]\n");
	exits("usage");
}

void
main(int argc, char** argv)
{
	char *bios, buf[256], sizeb[256], *p, *vsize, *psize;
	char *type, *vtype;
	int fd, virtual, len;
	Ctlr *ctlr;
	Vga *vga;

	fmtinstall('H', encodefmt);
	Binit(&amp;stdout, 1, OWRITE);

	bios = getenv("vgactlr");
	if((type = getenv("monitor")) == 0)
		type = "vga";
	psize = vsize = "640x480x8";

	ARGBEGIN{
	default:
		usage();
		break;
	case 'b':
		bios = EARGF(usage());
		break;
	case 'B':
		dumpbios(0x10000);
		exits(0);
	case 'c':
		cflag = 1;
		break;
	case 'd':
		dflag = 1;
		break;
	case 'i':
		iflag = 1;
		break;
	case 'l':
		lflag = 1;
		break;
	case 'm':
		type = EARGF(usage());
		break;
	case 'p':
		pflag = 1;
		break;
	case 'r':
		/*
		 * rflag &gt; 1 means "leave me alone, I know what I'm doing."
		 */
		rflag++;
		break;
	case 'v':
		vflag = 1;
		break;
	case 'V':
		vflag = 1;
		Vflag = 1;
		break;
	case 'x':
		dbname = EARGF(usage());
		break;
	}ARGEND

	virtual = 0;
	switch(argc){
	default:
		usage();
		break;
	case 1:
		vsize = psize = argv[0];
		break;
	case 2:
		psize = argv[0];
		vsize = argv[1];
		virtual = 1;
		break;
	case 0:
		break;
	}

	if(lflag &amp;&amp; strcmp(vsize, "text") == 0){
		vesatextmode();
		vgactlw("textmode", "");
		exits(0);
	}

	vga = alloc(sizeof(Vga));
	if(bios){
		if((vga-&gt;offset = strtol(bios, &amp;p, 0)) == 0 || *p++ != '=')
			error("main: bad BIOS string format - %s\n", bios);
		len = strlen(p);
		vga-&gt;bios = alloc(len+1);
		strncpy(vga-&gt;bios, p, len);
		trace("main-&gt;BIOS %s\n", bios);
	}

	/*
	 * Try to identify the VGA card and grab
	 * registers.  Print them out if requested.
	 * If monitor=vesa or our vga controller can't be found
	 * in vgadb, try vesa modes; failing that, try vga.
	 */
	if(strcmp(type, "vesa") == 0 || dbctlr(dbname, vga) == 0 ||
	    vga-&gt;ctlr == 0)
		if(dbvesa(vga) == 0 || vga-&gt;ctlr == 0){
			Bprint(&amp;stdout, "%s: controller not in %s, not vesa\n",
				argv0, dbname);
			dumpbios(256);
			type = "vga";
			vsize = psize = "640x480x1";
			virtual = 0;
			vga-&gt;ctlr = &amp;generic;
			vga-&gt;link = &amp;generic;
		}

	trace("main-&gt;snarf\n");
	for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link){
		if(ctlr-&gt;snarf == 0)
			continue;
		trace("%s-&gt;snarf\n", ctlr-&gt;name);
		(*ctlr-&gt;snarf)(vga, ctlr);
	}

	if(pflag)
		dump(vga);

	for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link)
		if(ctlr-&gt;flag &amp; Ferror)
			error("%r\n");

	if(iflag || lflag){
		if(getenv(type))
			snprint(monitordb, sizeof monitordb, "/env/%s", type);
		else
			strecpy(monitordb, monitordb+sizeof monitordb, dbname);

		if(vga-&gt;vesa){
			strcpy(monitordb, "vesa bios");
			vga-&gt;mode = dbvesamode(psize);
		}else
			vga-&gt;mode = dbmode(monitordb, type, psize);
		if(vga-&gt;mode == 0)
			error("main: %s@%s not in %s\n", type, psize, monitordb);

		if(virtual){
			if((p = strchr(vsize, 'x')) == nil)
				error("bad virtual size %s\n", vsize);
			vga-&gt;virtx = atoi(vsize);
			vga-&gt;virty = atoi(p+1);
			if(vga-&gt;virtx &lt; vga-&gt;mode-&gt;x || vga-&gt;virty &lt; vga-&gt;mode-&gt;y)
				error("virtual size smaller than physical size\n");
			vga-&gt;panning = 1;
		}
		else{
			vga-&gt;virtx = vga-&gt;mode-&gt;x;
			vga-&gt;virty = vga-&gt;mode-&gt;y;
			vga-&gt;panning = 0;
		}

		trace("vmf %d vmdf %d vf1 %lud vbw %lud\n",
			vga-&gt;mode-&gt;frequency, vga-&gt;mode-&gt;deffrequency,
			vga-&gt;f[1], vga-&gt;mode-&gt;videobw);
		if(vga-&gt;mode-&gt;frequency == 0 &amp;&amp; vga-&gt;mode-&gt;videobw != 0 &amp;&amp; vga-&gt;f[1] != 0){
			/*
			 * boost clock as much as possible subject
			 * to video and memory bandwidth constraints
			 */
			ulong bytes, freq, membw;
			double rr;

			freq = vga-&gt;mode-&gt;videobw;
			if(freq &gt; vga-&gt;f[1])
				freq = vga-&gt;f[1];

			rr = (double)freq/(vga-&gt;mode-&gt;ht*vga-&gt;mode-&gt;vt);
			if(rr &gt; 85.0)		/* &gt;85Hz is ridiculous */
				rr = 85.0;

			bytes = (vga-&gt;mode-&gt;x*vga-&gt;mode-&gt;y*vga-&gt;mode-&gt;z)/8;
			membw = rr*bytes;
			if(vga-&gt;membw != 0 &amp;&amp; membw &gt; vga-&gt;membw){
				membw = vga-&gt;membw;
				rr = (double)membw/bytes;
			}

			freq = rr*(vga-&gt;mode-&gt;ht*vga-&gt;mode-&gt;vt);
			vga-&gt;mode-&gt;frequency = freq;

			trace("using frequency %lud rr %.2f membw %lud\n",
				freq, rr, membw);
		}
		else if(vga-&gt;mode-&gt;frequency == 0)
			vga-&gt;mode-&gt;frequency = vga-&gt;mode-&gt;deffrequency;

		for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link){
			if(ctlr-&gt;options == 0)
				continue;
			trace("%s-&gt;options\n", ctlr-&gt;name);
			(*ctlr-&gt;options)(vga, ctlr);
		}

		/*
		 * skip init for vesa - vesa will do the registers for us
		 */
		if(!vga-&gt;vesa)
		for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link){
			if(ctlr-&gt;init == 0)
				continue;
			trace("%s-&gt;init\n", ctlr-&gt;name);
			(*ctlr-&gt;init)(vga, ctlr);
		}

		if(strcmp(vga-&gt;mode-&gt;chan, "") == 0){
			if(vga-&gt;mode-&gt;z &lt; nelem(chanstr) &amp;&amp; chanstr[vga-&gt;mode-&gt;z])
				strcpy(vga-&gt;mode-&gt;chan, chanstr[vga-&gt;mode-&gt;z]);
			else
				error("%s: unknown channel type to use for depth %d\n", vga-&gt;ctlr-&gt;name, vga-&gt;mode-&gt;z);
		}

		if(iflag || pflag)
			dump(vga);

		if(lflag){
			trace("main-&gt;load\n");
			if(vga-&gt;vmz &amp;&amp; (vga-&gt;virtx*vga-&gt;virty*vga-&gt;mode-&gt;z)/8 &gt; vga-&gt;vmz)
				error("%s: not enough video memory - %lud\n",
					vga-&gt;ctlr-&gt;name, vga-&gt;vmz);

			if(vga-&gt;ctlr-&gt;type)
				vtype = vga-&gt;ctlr-&gt;type;
			else if(p = strchr(vga-&gt;ctlr-&gt;name, '-')){
				strncpy(buf, vga-&gt;ctlr-&gt;name, p - vga-&gt;ctlr-&gt;name);
				buf[p - vga-&gt;ctlr-&gt;name] = 0;
				vtype = buf;
			}
			else
				vtype = vga-&gt;ctlr-&gt;name;
			vgactlw("type", vtype);

			/*
			 * VESA must be set up before linear.
			 * Set type to vesa for linear.
			 */
			if(vga-&gt;vesa){
				vesa.load(vga, vga-&gt;vesa);
				if(vga-&gt;vesa-&gt;flag&amp;Ferror)
					error("vesa load error\n");
				vgactlw("type", vesa.name);
			}

			/*
			 * The new draw device needs linear mode set
			 * before size.
			 */
			linear(vga);

			/*
			 * Linear is over so switch to other driver for
			 * acceleration.
			 */
			if(vga-&gt;vesa)
				vgactlw("type", vtype);

			sprint(buf, "%ludx%ludx%d %s",
				vga-&gt;virtx, vga-&gt;virty,
				vga-&gt;mode-&gt;z, vga-&gt;mode-&gt;chan);
			if(rflag){
				vgactlr("size", sizeb);
				if(rflag &lt; 2 &amp;&amp; strcmp(buf, sizeb) != 0)
					error("bad refresh: %s != %s\n",
						buf, sizeb);
			}
			else
				vgactlw("size", buf);

			/*
			 * No fiddling with registers if VESA set 
			 * things up already.  Sorry.
			 */
			if(!vga-&gt;vesa){
				/*
				 * Turn off the display during the load.
				 */
				sequencer(vga, 0);
	
				for(ctlr = vga-&gt;link; ctlr; ctlr = ctlr-&gt;link){
					if(ctlr-&gt;load == 0 || ctlr == &amp;vesa)
						continue;
					trace("%s-&gt;load\n", ctlr-&gt;name);
					(*ctlr-&gt;load)(vga, ctlr);
				}
	
				sequencer(vga, 1);
			}

			vgactlw("drawinit", "");

			if(vga-&gt;hwgc == 0 || cflag)
				vgactlw("hwgc", "soft");
			else
				vgactlw("hwgc", vga-&gt;hwgc-&gt;name);

			/* might as well initialize the cursor */
			if((fd = open("/dev/cursor", OWRITE)) &gt;= 0){
				write(fd, buf, 0);
				close(fd);
			}

			if(vga-&gt;virtx != vga-&gt;mode-&gt;x || vga-&gt;virty != vga-&gt;mode-&gt;y){
				sprint(buf, "%dx%d", vga-&gt;mode-&gt;x, vga-&gt;mode-&gt;y);
				vgactlw("actualsize", buf);
				if(vga-&gt;panning)
					vgactlw("panning", "on");
			}

			if(pflag)
				dump(vga);
		}
	}

	trace("main-&gt;exits\n");
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

