<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/mga2164w.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/mga2164w.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Matrox Millenium and Matrox Millenium II.
 * Matrox MGA-2064W, MGA-2164W 3D graphics accelerators
 * Texas Instruments Tvp3026 RAMDAC.
 */
enum {
	Meg		= 1024*1024,
	/* pci chip manufacturer */
	MATROX		= 0x102B,

	/* pci chip device ids */
	MGA2064		= 0x0519,
	MGA2164		= 0x051B,
	MGA2164AGP	= 0x051F,

	/* i/o ports */
	Crtcext		= 0x03DE,	/* CRTC Extensions */

	/* config space offsets */
	Devctrl		= 0x04,		/* Device Control */
	Option		= 0x40,		/* Option */

	/* control aperture offsets */
	RAMDAC		= 0x3C00,	/* RAMDAC registers */
	CACHEFLUSH	= 0x1FFF,
};

typedef struct {
	Pcidev*	pci;
	int	devid;
	uchar*	membase1;
	uchar*	membase2;
	ulong	devctrl;
	ulong	option;
	uchar	crtcext[6];
	uchar	tvp[64];
	uchar	pclk[3];
	uchar	mclk[3];
	uchar	lclk[3];
} Mga;

static uchar
_tvp3026i(Vga* vga, Ctlr* ctlr, uchar reg)
{
	Mga *mga;

	if(reg &gt;= 0x10)
		error("%s: tvp3026io: direct reg 0x%uX out of range\n", ctlr-&gt;name, reg);

	if(vga-&gt;private == nil)
		error("%s: tvp3026io: no *mga\n", ctlr-&gt;name);
	mga = vga-&gt;private;

	return *(mga-&gt;membase1+RAMDAC+reg);
}

static void
_tvp3026o(Vga* vga, Ctlr* ctlr, uchar reg, uchar data)
{
	Mga *mga;

	if(reg &gt;= 0x10)
		error("%s: tvp3026io: direct reg 0x%uX out of range\n", ctlr-&gt;name, reg);

	if(vga-&gt;private == nil)
		error("%s: tvp3026io: no *mga\n", ctlr-&gt;name);
	mga = vga-&gt;private;

	*(mga-&gt;membase1+RAMDAC+reg) = data;
}

static uchar
_tvp3026xi(Vga* vga, Ctlr* ctlr, uchar index)
{
	if(index &gt;= 0x40)
		error("%s: tvp3026xi: reg 0x%uX out of range\n", ctlr-&gt;name, index);

	_tvp3026o(vga, ctlr, 0x00, index);

	return _tvp3026i(vga, ctlr, 0x0A);
}

void
_tvp3026xo(Vga* vga, Ctlr* ctlr, uchar index, uchar data)
{
	if(index &gt;= 0x40)
		error("%s: tvp3026xo: reg 0x%uX out of range\n", ctlr-&gt;name, index);

	_tvp3026o(vga, ctlr, 0x00, index);
	_tvp3026o(vga, ctlr, 0x0A, data);
}

static uchar
crtcexti(uchar index)
{
	uchar data;

	outportb(Crtcext, index);
	data = inportb(Crtcext+1);

	return data;
}

static void
crtcexto(uchar index, uchar data)
{
	outportb(Crtcext, index);
	outportb(Crtcext+1, data);
}

static void
mapmga(Vga* vga, Ctlr* ctlr)
{
	int f;
	uchar *m;
	Mga *mga;

	if(vga-&gt;private == nil)
		error("%s: tvp3026io: no *mga\n", ctlr-&gt;name);
	mga = vga-&gt;private;

	f = open("#v/vgactl", OWRITE);
	if(f &lt; 0)
		error("%s: can't open vgactl\n", ctlr-&gt;name);
	if(write(f, "type mga2164w", 13) != 13)
		error("%s: can't set mga type\n", ctlr-&gt;name);
	
	m = segattach(0, "mga2164wmmio", 0, 16*1024);
	if(m == (void*)-1)
		error("%s: can't attach mga2164wmmio segment\n", ctlr-&gt;name);
	mga-&gt;membase1 = m;

	m = segattach(0, "mga2164wscreen", 0, (mga-&gt;devid==MGA2064? 8 : 16)*Meg);
	if(m ==(void*)-1)
		error("%s: can't attach mga2164wscreen segment\n", ctlr-&gt;name);

	mga-&gt;membase2 = m;
}

static void
clockcalc(Vga* vga, Ctlr* ctlr, int bpp)
{
	ulong m, n, p, q;
	double z, fdiff, fmindiff, fvco, fgoal;
	Mga *mga;

	USED(ctlr);

	mga = vga-&gt;private;

	/*
	 * Look for values of n, d and p that give
	 * the least error for
	 *	Fvco = 8*RefFreq*(65-m)/(65-n)
	 *	Fpll = Fvco/2**p
	 * N and m are 6 bits, p is 2 bits. Constraints:
	 *	110MHz &lt;= Fvco &lt;= 250MHz
	 *	40 &lt;= n &lt;= 62
	 *	 1 &lt;= m &lt;= 62
	 *	 0 &lt;= p &lt;=  3
	 */
	fgoal = (double)vga-&gt;f[0];
	fmindiff = fgoal;
	vga-&gt;m[0] = 0x15;
	vga-&gt;n[0] = 0x18;
	vga-&gt;p[0] = 3;
	for(m = 62; m &gt; 0; m--){
		for(n = 62; n &gt;= 40; n--){
			fvco = 8.*((double)RefFreq)*(65.-m)/(65.-n);
			if(fvco &lt; 110e6 || fvco &gt; 250e6)
				continue;
			for(p = 0; p &lt; 4; p++){
				fdiff = fgoal - fvco/(1&lt;&lt;p);
				if(fdiff &lt; 0)
					fdiff = -fdiff;
				if(fdiff &lt; fmindiff){
					fmindiff = fdiff;
					vga-&gt;m[0] = m;
					vga-&gt;n[0] = n;
					vga-&gt;p[0] = p;
				}
			}
		}
	}
	mga-&gt;pclk[0] = 0xC0 | (vga-&gt;n[0] &amp; 0x3f);
	mga-&gt;pclk[1] = (vga-&gt;m[0] &amp; 0x3f);
	mga-&gt;pclk[2] = 0xB0 | (vga-&gt;p[0] &amp; 0x03);

	/*
	 * Now the loop clock:
	 * 	m is fixed;
	 *	calculate n;
	 *	set z to the lower bound (110MHz) and calculate p and q.
	 */
	vga-&gt;m[1] = 61;
	n = 65 - 4*(64/(vga-&gt;vmz==2*Meg? bpp*2 : bpp));
	fvco = (8*RefFreq*(65-vga-&gt;m[0]))/(65-vga-&gt;n[0]);
	vga-&gt;f[1] = fvco/(1&lt;&lt;vga-&gt;p[0]);
	z = 110e6*(65.-n)/(4.*vga-&gt;f[1]);
	if(z &lt;= 16){
		for(p = 0; p &lt; 4; p++){
			if(1&lt;&lt;(p+1) &gt; z)
				break;
		}
		q = 0;
	}
	else{
		p = 3;
		q = (z - 16)/16 + 1;
	}
	vga-&gt;n[1] = n;
	vga-&gt;p[1] = p;
	vga-&gt;q[1] = q;
	mga-&gt;lclk[0] = 0xC0 | (vga-&gt;n[1] &amp; 0x3f);
	mga-&gt;lclk[1] = (vga-&gt;m[1] &amp; 0x3f);
	mga-&gt;lclk[2] = 0xF0 | (vga-&gt;p[1] &amp; 0x03);
	mga-&gt;tvp[0x39] = 0x38 | q;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i, k, n;
	uchar *p, x[8];
	Pcidev *pci;
	Mga *mga;

	if(vga-&gt;private == nil) {
		pci = pcimatch(nil, MATROX, MGA2164AGP);
		if(pci == nil)
			pci = pcimatch(nil, MATROX, MGA2164);
		if(pci == nil)
			pci = pcimatch(nil, MATROX, MGA2064);
		if(pci == nil)
			error("%s: no Pcidev with Vid=0x102B, Did=0x051[9BF] or 0x521\n", ctlr-&gt;name);

		vga-&gt;private = alloc(sizeof(Mga));
		mga = (Mga*)vga-&gt;private;
		mga-&gt;devid = pci-&gt;did;
		mga-&gt;pci = pci;
		mapmga(vga, ctlr);
	}
	else {
		mga = (Mga*)vga-&gt;private;
		pci = mga-&gt;pci;
	}

	for(i = 0; i &lt; 0x06; i++)
		mga-&gt;crtcext[i] = crtcexti(i);

	mga-&gt;devctrl = pcicfgr32(pci, Devctrl);
	mga-&gt;option = pcicfgr32(pci, Option);

	for(i = 0; i &lt; 64; i++)
		mga-&gt;tvp[i] = _tvp3026xi(vga, ctlr, i);

	for(i = 0; i &lt; 3; i++){
		_tvp3026xo(vga, ctlr, 0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		mga-&gt;pclk[i] = _tvp3026xi(vga, ctlr, 0x2D);
	}

	for(i = 0; i &lt; 3; i++){
		_tvp3026xo(vga, ctlr, 0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		mga-&gt;mclk[i] = _tvp3026xi(vga, ctlr, 0x2E);
	}

	for(i = 0; i &lt; 3; i++){
		_tvp3026xo(vga, ctlr, 0x2C, (i&lt;&lt;4)|(i&lt;&lt;2)|i);
		mga-&gt;lclk[i] = _tvp3026xi(vga, ctlr, 0x2F);
	}

	/* find out how much memory is here, some multiple of 2Meg */
	crtcexto(3, mga-&gt;crtcext[3] | 0x80);	/* mga mode */
	p = mga-&gt;membase2;
	n = (mga-&gt;devid==MGA2064? 4 : 8);
	for(i = 0; i &lt; n; i++) {
		k = (2*i+1)*Meg;
		p[k] = 0;
		p[k] = i+1;
		*(mga-&gt;membase1+CACHEFLUSH) = 0;
		x[i] = p[k];
		trace("x[%d]=%d\n", i, x[i]);
	}
	for(i = 1; i &lt; n; i++)
		if(x[i] != i+1)
			break;
	vga-&gt;vmz = 2*i*Meg;
	trace("probe found %d megabytes\n", 2*i);
	crtcexto(3, mga-&gt;crtcext[3]);	/* restore mga mode */


	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga* vga, Ctlr* ctlr)
{
	if(vga-&gt;virtx &amp; 127)
		vga-&gt;virtx = (vga-&gt;virtx+127)&amp;~127;
	ctlr-&gt;flag |= Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	Ctlr *c;
	Mga *mga;
	int scale, offset, pixbuswidth;

	mga = vga-&gt;private;
	mode = vga-&gt;mode;

	ctlr-&gt;flag |= Ulinear;

	pixbuswidth = (vga-&gt;vmz == 2*Meg) ? 32 : 64;
	trace("pixbuswidth=%d\n", pixbuswidth);

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;

	/* supposed to let tvp reg 1D control sync polarity */
	vga-&gt;misc |= 0xC8;

	/*
	 * In power graphics mode, supposed to use
	 *	hblkend = htotal+4
	 *	hblkstr = hdispend
	 */
	if((vga-&gt;crt[0x00] &amp; 0x0F) == 0x0F) {
		vga-&gt;crt[0x00]++;
		mode-&gt;ht += 8;
	}
	vga-&gt;crt[0x02] = vga-&gt;crt[0x01];
	vga-&gt;crt[0x03] = (((mode-&gt;ht&gt;&gt;3)-1) &amp; 0x1F) | 0x80;
	vga-&gt;crt[0x05] = ((((mode-&gt;ht&gt;&gt;3)-1) &amp; 0x20) &lt;&lt; 2)
		| ((mode-&gt;ehs&gt;&gt;3) &amp; 0x1F);

	offset = (vga-&gt;virtx*mode-&gt;z) &gt;&gt; ((pixbuswidth==32)? 6 : 7);
	vga-&gt;crt[0x13] = offset;
	vga-&gt;crt[0x14] = 0;
	vga-&gt;crt[0x17] = 0xE3;

	mga-&gt;crtcext[0] = (offset &amp; 0x300) &gt;&gt; 4;
	mga-&gt;crtcext[1] = ((((mode-&gt;ht&gt;&gt;3)-5) &amp; 0x100) &gt;&gt; 8)
		| ((((mode-&gt;x&gt;&gt;3)-1) &amp; 0x100) &gt;&gt; 7)
		| (((mode-&gt;shs&gt;&gt;3) &amp; 0x100) &gt;&gt; 6)  /* why not (shs&gt;&gt;3)-1 ? */
		| (((mode-&gt;ht&gt;&gt;3)-1) &amp; 0x40);
	mga-&gt;crtcext[2] = (((mode-&gt;vt-2) &amp; 0xC00) &gt;&gt; 10)
		| (((mode-&gt;y-1) &amp; 0x400) &gt;&gt; 8)
		| ((mode-&gt;vrs &amp; 0xC00) &gt;&gt; 7)
		| ((mode-&gt;vrs &amp; 0xC00) &gt;&gt; 5);
	scale = mode-&gt;z == 8 ? 1 : (mode-&gt;z == 16? 2 : 4);
	if(pixbuswidth == 32)
		scale *= 2;
	scale--;
	mga-&gt;crtcext[3] = scale | 0x80;
	if(vga-&gt;vmz &gt;= 8*Meg)
		mga-&gt;crtcext[3] |= 0x10;
	else if(vga-&gt;vmz == 2*Meg)
		mga-&gt;crtcext[3] |= 0x08;
	mga-&gt;crtcext[4] = 0;
	mga-&gt;crtcext[5] = 0;

	mga-&gt;tvp[0x0F] = (mode-&gt;z == 8) ? 0x06 : 0x07;
	mga-&gt;tvp[0x18] = (mode-&gt;z == 8) ? 0x80 :
		(mode-&gt;z == 16) ? 0x05 : 0x06;
	mga-&gt;tvp[0x19] = (mode-&gt;z == 8) ? 0x4C :
		(mode-&gt;z == 16) ? 0x54 : 0x5C;
	if(pixbuswidth == 32)
		mga-&gt;tvp[0x19]--;
	mga-&gt;tvp[0x1A] = (mode-&gt;z == 8) ? 0x25 :
		(mode-&gt;z == 16) ? 0x15 : 0x05;
	mga-&gt;tvp[0x1C] = 0;
	mga-&gt;tvp[0x1D] = (mode-&gt;y &lt; 768) ? 0x00 : 0x03;
	mga-&gt;tvp[0x1E] = (mode-&gt;z == 8) ? 0x04 : 0x24; /* six bit mode */
	mga-&gt;tvp[0x2A] = 0;
	mga-&gt;tvp[0x2B] = 0x1E;
	mga-&gt;tvp[0x30] = 0xFF;
	mga-&gt;tvp[0x31] = 0xFF;
	mga-&gt;tvp[0x32] = 0xFF;
	mga-&gt;tvp[0x33] = 0xFF;
	mga-&gt;tvp[0x34] = 0xFF;
	mga-&gt;tvp[0x35] = 0xFF;
	mga-&gt;tvp[0x36] = 0xFF;
	mga-&gt;tvp[0x37] = 0xFF;
	mga-&gt;tvp[0x38] = 0;
	mga-&gt;tvp[0x39] = 0;
	mga-&gt;tvp[0x3A] = 0;
	mga-&gt;tvp[0x06] = 0;

	// From: "Bruce G. Stewart" &lt;bruce.g.stewart@worldnet.att.net&gt;
	// 05-Jul-00 - Fix vertical blanking setup
	// This should probably be corrected in vga.c too.
	{
		// Start vertical blanking after the last displayed line
		// End vertical blanking after the total line count
		int svb = mode-&gt;y;
		int evb = mode-&gt;vt;

		// A field is 1/2 of the lines in interlaced mode
		if(mode-&gt;interlace == 'v'){
			svb /= 2;
			evb /= 2;
		}
		--svb;
		--evb;			// line counter counts from 0

		vga-&gt;crt[0x15] = svb;
		vga-&gt;crt[0x07] = (vga-&gt;crt[0x07] &amp; ~0x08) | ((svb &amp; 0x100)&gt;&gt;5);
		vga-&gt;crt[0x09] = (vga-&gt;crt[0x09] &amp; ~0x20) | ((svb &amp; 0x200)&gt;&gt;4);
		// MGA specific: bits 10 and 11
		mga-&gt;crtcext[0x02] &amp;=  ~0x18;
		mga-&gt;crtcext[0x02] |= ((svb &amp; 0xC00)&gt;&gt;7);

		vga-&gt;crt[0x16]     = evb;
	}

	clockcalc(vga, ctlr, mode-&gt;z);


	mga-&gt;option = mga-&gt;option &amp; ~0x3000;
	if(vga-&gt;vmz &gt; 2*Meg)
		mga-&gt;option |= 0x1000;

	/* disable vga load (want to do fields in different order) */
	for(c = vga-&gt;link; c; c = c-&gt;link)
		if(c-&gt;name == "vga")
			c-&gt;load = nil;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	int i;
	Mga *mga;
	Pcidev* pci;

	mga = vga-&gt;private;
	pci = mga-&gt;pci;

	trace("loading crtcext0-5\n");
	/* turn on mga mode, set other crt high bits */
	for(i = 0; i &lt; 6; i++)
		crtcexto(i, mga-&gt;crtcext[i]);

	trace("setting memory mode\n");
	/* set memory mode */
	pcicfgw32(pci, Option, mga-&gt;option);

	/* clocksource: pixel clock PLL */
	_tvp3026xo(vga, ctlr, 0x1A, mga-&gt;tvp[0x1A]);

	/* disable pclk and lclk */
	_tvp3026xo(vga, ctlr, 0x2C, 0x2A);
	_tvp3026xo(vga, ctlr, 0x2F, 0);
	_tvp3026xo(vga, ctlr, 0x2D, 0);

	trace("loading vga registers\n");
	/* vga misc, seq, and registers */
	vgao(MiscW, vga-&gt;misc);

	for(i = 2; i &lt; 0x05; i++)
		vgaxo(Seqx, i, vga-&gt;sequencer[i]);

	vgaxo(Crtx, 0x11, vga-&gt;crt[0x11] &amp; ~0x80);
	for(i = 0; i &lt; 0x19; i++)
		vgaxo(Crtx, i, vga-&gt;crt[i]);

	/* apparently AGP needs this to restore start address */
	crtcexto(0, mga-&gt;crtcext[0]);

	trace("programming pclk\n");
	/* set up pclk */
	_tvp3026xo(vga, ctlr, 0x2C, 0);
	for(i = 0; i &lt; 3; i++)
		_tvp3026xo(vga, ctlr, 0x2D, mga-&gt;pclk[i]);
	while(!(_tvp3026xi(vga, ctlr, 0x2D) &amp; 0x40))
		;

	trace("programming lclk\n");
	/* set up lclk */
	_tvp3026xo(vga, ctlr, 0x39, mga-&gt;tvp[0x39]);
	_tvp3026xo(vga, ctlr, 0x2C, 0);
	for(i = 0; i &lt; 3; i++)
		_tvp3026xo(vga, ctlr, 0x2F, mga-&gt;lclk[i]);
	while(!(_tvp3026xi(vga, ctlr, 0x2F) &amp; 0x40))
		;

	trace("loading tvp registers\n");
	/* tvp registers, order matters */
	_tvp3026xo(vga, ctlr, 0x0F, mga-&gt;tvp[0x0F]);
	_tvp3026xo(vga, ctlr, 0x18, mga-&gt;tvp[0x18]);
	_tvp3026xo(vga, ctlr, 0x19, mga-&gt;tvp[0x19]);
	_tvp3026xo(vga, ctlr, 0x1A, mga-&gt;tvp[0x1A]);
	_tvp3026xo(vga, ctlr, 0x1C, mga-&gt;tvp[0x1C]);
	_tvp3026xo(vga, ctlr, 0x1D, mga-&gt;tvp[0x1D]);
	_tvp3026xo(vga, ctlr, 0x1E, mga-&gt;tvp[0x1E]);
	_tvp3026xo(vga, ctlr, 0x2A, mga-&gt;tvp[0x2A]);
	_tvp3026xo(vga, ctlr, 0x2B, mga-&gt;tvp[0x2B]);
	_tvp3026xo(vga, ctlr, 0x30, mga-&gt;tvp[0x30]);
	_tvp3026xo(vga, ctlr, 0x31, mga-&gt;tvp[0x31]);
	_tvp3026xo(vga, ctlr, 0x32, mga-&gt;tvp[0x32]);
	_tvp3026xo(vga, ctlr, 0x33, mga-&gt;tvp[0x33]);
	_tvp3026xo(vga, ctlr, 0x34, mga-&gt;tvp[0x34]);
	_tvp3026xo(vga, ctlr, 0x35, mga-&gt;tvp[0x35]);
	_tvp3026xo(vga, ctlr, 0x36, mga-&gt;tvp[0x36]);
	_tvp3026xo(vga, ctlr, 0x37, mga-&gt;tvp[0x37]);
	_tvp3026xo(vga, ctlr, 0x38, mga-&gt;tvp[0x38]);
	_tvp3026xo(vga, ctlr, 0x39, mga-&gt;tvp[0x39]);
	_tvp3026xo(vga, ctlr, 0x3A, mga-&gt;tvp[0x3A]);
	_tvp3026xo(vga, ctlr, 0x06, mga-&gt;tvp[0x06]);

	trace("done mga load\n");
	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	char *name;
	Mga *mga;

	name = ctlr-&gt;name;
	mga = vga-&gt;private;

	printitem(name, "Devctrl");
	printreg(mga-&gt;devctrl);

	printitem(name, "Option");
	printreg(mga-&gt;option);

	printitem(name, "Crtcext");
	for(i = 0; i &lt; 0x06; i++)
		printreg(mga-&gt;crtcext[i]);

	printitem(name, "TVP");
	for(i = 0; i &lt; 64; i++)
		printreg(mga-&gt;tvp[i]);

	printitem(name, "PCLK");
	for(i = 0; i &lt; 3; i++)
		printreg(mga-&gt;pclk[i]);

	printitem(name, "MCLK");
	for(i = 0; i &lt; 3; i++)
		printreg(mga-&gt;mclk[i]);

	printitem(name, "LCLK");
	for(i = 0; i &lt; 3; i++)
		printreg(mga-&gt;lclk[i]);
}

Ctlr mga2164w = {
	"mga2164w",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr mga2164whwgc = {
	"mga2164whwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

