<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/s3clock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/s3clock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * Clocks which require fiddling with the S3 registers
 * in order to be loaded.
 */
static void
setcrt42(Vga* vga, Ctlr* ctlr, uchar index)
{
	trace("%s-&gt;clock-&gt;setcrt42\n", ctlr-&gt;name);

	vgao(MiscW, vga-&gt;misc &amp; ~0x0C);
	outportb(Crtx+1, 0x00);

	vga-&gt;crt[0x42] = (vga-&gt;crt[0x42] &amp; 0xF0)|index;
	vgao(MiscW, vga-&gt;misc);
	vgaxo(Crtx, 0x42, vga-&gt;crt[0x42]);
}

static void
icd2061aload(Vga* vga, Ctlr* ctlr)
{
	ulong sdata;
	int i;
	uchar crt42;

	trace("%s-&gt;clock-&gt;icd2061aload\n", ctlr-&gt;name);
	/*
	 * The serial word to be loaded into the icd2061a is
	 *	(2&lt;&lt;21)|(vga-&gt;i&lt;&lt;17)|((vga-&gt;n)&lt;&lt;10)|(vga-&gt;p&lt;&lt;7)|vga-&gt;d
	 * Always select ICD2061A REG2.
	 */
	sdata = (2&lt;&lt;21)|(vga-&gt;i[0]&lt;&lt;17)|((vga-&gt;n[0])&lt;&lt;10)|(vga-&gt;p[0]&lt;&lt;7)|vga-&gt;d[0];

	/*
	 * The display should be already off to enable  us to clock the
	 * serial data word into either MiscW or Crt42.
	 *
	 * Set the Misc register to make clock-select-out the contents of
	 * register Crt42. Must turn the sequencer off when changing bits
	 * &lt;3:2&gt; of Misc. Also, must set Crt42 to 0 before setting &lt;3:2&gt;
	 * of Misc due to a hardware glitch.
	 */
	vgao(MiscW, vga-&gt;misc &amp; ~0x0C);
	crt42 = vgaxi(Crtx, 0x42) &amp; 0xF0;
	outportb(Crtx+1, 0x00);

	vgaxo(Seqx, 0x00, 0x00);
	vgao(MiscW, vga-&gt;misc|0x0C);
	vgaxo(Seqx, 0x00, 0x03);

	/*
	 * Unlock the ICD2061A. The unlock sequence is at least 5 low-to-high
	 * transitions of CLK with DATA high, followed by a single low-to-high
	 * transition of CLK with DATA low.
	 * Using Crt42, CLK is bit0, DATA is bit 1. If we used MiscW, they'd
	 * be bits 2 and 3 respectively.
	 */
	outportb(Crtx+1, crt42|0x00);			/* -DATA|-CLK */
	outportb(Crtx+1, crt42|0x02);			/* +DATA|-CLK */
	for(i = 0; i &lt; 5; i++){
		outportb(Crtx+1, crt42|0x03);		/* +DATA|+CLK */
		outportb(Crtx+1, crt42|0x02);		/* +DATA|-CLK */
	}
	outportb(Crtx+1, crt42|0x00);			/* -DATA|-CLK */
	outportb(Crtx+1, crt42|0x01);			/* -DATA|+CLK */

	/*
	 * Now write the serial data word, framed by a start-bit and a stop-bit.
	 * The data is written using a modified Manchester encoding such that a
	 * data-bit is sampled on the rising edge of CLK and the complement of
	 * the data-bit is sampled on the previous falling edge of CLK.
	 */
	outportb(Crtx+1, crt42|0x00);			/* -DATA|-CLK (start-bit) */
	outportb(Crtx+1, crt42|0x01);			/* -DATA|+CLK */

	for(i = 0; i &lt; 24; i++){			/* serial data word */
		if(sdata &amp; 0x01){
			outportb(Crtx+1, crt42|0x01);	/* -DATA|+CLK */
			outportb(Crtx+1, crt42|0x00);	/* -DATA|-CLK (falling edge) */
			outportb(Crtx+1, crt42|0x02);	/* +DATA|-CLK */
			outportb(Crtx+1, crt42|0x03);	/* +DATA|+CLK (rising edge) */
		}
		else {
			outportb(Crtx+1, crt42|0x03);	/* +DATA|+CLK */
			outportb(Crtx+1, crt42|0x02);	/* +DATA|-CLK (falling edge) */
			outportb(Crtx+1, crt42|0x00);	/* -DATA|-CLK */
			outportb(Crtx+1, crt42|0x01);	/* -DATA|+CLK (rising edge) */
		}
		sdata &gt;&gt;= 1;
	}

	outportb(Crtx+1, crt42|0x03);			/* +DATA|+CLK (stop-bit) */
	outportb(Crtx+1, crt42|0x02);			/* +DATA|-CLK */
	outportb(Crtx+1, crt42|0x03);			/* +DATA|+CLK */

	/*
	 * We always use REG2 in the ICD2061A.
	 */
	setcrt42(vga, ctlr, 0x02);
}

static void
ch9294load(Vga* vga, Ctlr* ctlr)
{
	trace("%s-&gt;clock-&gt;ch9294load\n", ctlr-&gt;name);

	setcrt42(vga, ctlr, vga-&gt;i[0]);
}

static void
tvp3025load(Vga* vga, Ctlr* ctlr)
{
	uchar crt5c, x;

	trace("%s-&gt;clock-&gt;tvp3025load\n", ctlr-&gt;name);

	/*
	 * Crt5C bit 5 is RS4.
	 * Clear it to select TVP3025 registers for
	 * the calls to tvp302xo().
	 */
	crt5c = vgaxi(Crtx, 0x5C);
	vgaxo(Crtx, 0x5C, crt5c &amp; ~0x20);

	tvp3020xo(0x2C, 0x00);
	tvp3020xo(0x2D, vga-&gt;d[0]);
	tvp3020xo(0x2D, vga-&gt;n[0]);
	tvp3020xo(0x2D, 0x08|vga-&gt;p[0]);

	tvp3020xo(0x2F, 0x01);
	tvp3020xo(0x2F, 0x01);
	tvp3020xo(0x2F, vga-&gt;p[0]);
	x = 0x54;
	if(vga-&gt;ctlr &amp;&amp; (vga-&gt;ctlr-&gt;flag &amp; Uenhanced))
		x = 0xC4;
	tvp3020xo(0x1E, x);

	vgaxo(Crtx, 0x5C, crt5c);
	vgao(MiscW, vga-&gt;misc);

	ctlr-&gt;flag |= Fload;
}

static void
tvp3026load(Vga* vga, Ctlr* ctlr)
{
	trace("%s-&gt;clock-&gt;tvp3026load\n", ctlr-&gt;name);

	if((vga-&gt;misc &amp; 0x0C) != 0x0C &amp;&amp; vga-&gt;mode-&gt;z == 1){
		tvp3026xo(0x1A, 0x07);
		tvp3026xo(0x18, 0x80);
		tvp3026xo(0x19, 0x98);
		tvp3026xo(0x2C, 0x2A);
		tvp3026xo(0x2F, 0x00);
		tvp3026xo(0x2D, 0x00);
		tvp3026xo(0x39, 0x18);
		setcrt42(vga, ctlr, 0);
	}
	else if(vga-&gt;mode-&gt;z == 8){
		tvp3026xo(0x1A, 0x05);
		tvp3026xo(0x18, 0x80);
		tvp3026xo(0x19, 0x4C);
		tvp3026xo(0x2C, 0x2A);
		tvp3026xo(0x2F, 0x00);
		tvp3026xo(0x2D, 0x00);

		tvp3026xo(0x2C, 0x00);
		tvp3026xo(0x2D, 0xC0|vga-&gt;n[0]);
		tvp3026xo(0x2D, vga-&gt;m[0] &amp; 0x3F);
		tvp3026xo(0x2D, 0xB0|vga-&gt;p[0]);
		while(!(tvp3026xi(0x2D) &amp; 0x40))
			;

		tvp3026xo(0x39, 0x38|vga-&gt;q[1]);
		tvp3026xo(0x2C, 0x00);
		tvp3026xo(0x2F, 0xC0|vga-&gt;n[1]);
		tvp3026xo(0x2F, vga-&gt;m[1]);
		tvp3026xo(0x2F, 0xF0|vga-&gt;p[1]);
		while(!(tvp3026xi(0x2F) &amp; 0x40))
			;

		setcrt42(vga, ctlr, 3);
	}

	ctlr-&gt;flag |= Fload;
}

static struct {
	char*	name;
	void	(*load)(Vga*, Ctlr*);
} clocks[] = {
	{ "icd2061a",		icd2061aload, },
	{ "ch9294",		ch9294load, },
	{ "tvp3025clock",	tvp3025load, },
	{ "tvp3026clock",	tvp3026load, },
	{ 0 },
};

static void
init(Vga* vga, Ctlr* ctlr)
{
	char name[Namelen+1], *p;
	int i;

	if(vga-&gt;clock == 0)
		return;

	/*
	 * Check we know about it.
	 */
	strncpy(name, vga-&gt;clock-&gt;name, Namelen);
	name[Namelen] = 0;
	if(p = strchr(name, '-'))
		*p = 0;
	for(i = 0; clocks[i].name; i++){
		if(strcmp(clocks[i].name, name) == 0)
			break;
	}
	if(clocks[i].name == 0)
		error("%s: unknown clock \"%s\"\n", ctlr-&gt;name, vga-&gt;clock-&gt;name);

	if(vga-&gt;clock-&gt;init &amp;&amp; (vga-&gt;clock-&gt;flag &amp; Finit) == 0)
		(*vga-&gt;clock-&gt;init)(vga, vga-&gt;clock);

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] != VgaFreq0 &amp;&amp; vga-&gt;f[0] != VgaFreq1)
		vga-&gt;misc |= 0x0C;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	char name[Namelen+1], *p;
	int i;

	if(vga-&gt;clock == 0 || (vga-&gt;clock-&gt;flag &amp; Fload))
		return;

	strncpy(name, vga-&gt;clock-&gt;name, Namelen);
	name[Namelen] = 0;
	if(p = strchr(name, '-'))
		*p = 0;

	for(i = 0; clocks[i].name; i++){
		if(strcmp(clocks[i].name, name))
			continue;
		clocks[i].load(vga, ctlr);
		if(strcmp(clocks[i].name, "icd2061a") == 0){
			clocks[i].load(vga, ctlr);
			clocks[i].load(vga, ctlr);
		}

		ctlr-&gt;flag |= Fload;
		return;
	}
}

Ctlr s3clock = {
	"s3clock",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

