<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/stg1702.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/stg1702.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * SGS-Thompson STG1702 Enhanced True Color Palette-DAC
 * with 16-bit Pixel Port.
 */
enum {
	Command		= 0x00,		/* Pixel Command Register */
	IndexLO		= 0x01,		/* LO-byte of 16-bit Index */
	IndexHI		= 0x02,		/* HI-byte of 16-bit Index */
	Index		= 0x03,		/* Indexed Register */

	CompanyID	= 0x00,		/* Company ID = 0x44 */
	DeviceID	= 0x01,		/* Device ID = 0x02 */
	Pmode		= 0x03,		/* Primary Pixel Mode Select */
	Smode		= 0x04,		/* Secondary Pixel Mode Select */
	Pipeline	= 0x05,		/* Pipeline Timing Control */
	Sreset		= 0x06,		/* Soft Reset */
	Power		= 0x07,		/* Power Management */

	Nindex		= 0x08,
};

static void
pixmask(void)
{
	inportb(PaddrW);
}

static void
commandrw(void)
{
	int i;

	pixmask();
	for(i = 0; i &lt; 4; i++)
		inportb(Pixmask);
}

static uchar
commandr(void)
{
	uchar command;

	commandrw();
	command = inportb(Pixmask);
	pixmask();

	return command;
}

static void
commandw(uchar command)
{
	commandrw();
	outportb(Pixmask, command);
	pixmask();
}

static void
indexrw(uchar index)
{
	uchar command;

	command = commandr();
	commandw(command|0x10);

	commandrw();
	inportb(Pixmask);
	outportb(Pixmask, index &amp; 0xFF);
	outportb(Pixmask, (index&gt;&gt;8) &amp; 0xFF);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hpclk2x8|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong pclk;

	/*
	 * Part comes in -135MHz speed-grade.
	 * In 8-bit mode the max. PCLK is 110MHz. In 2x8-bit mode
	 * the max. PCLK is the speed-grade, using the 2x doubler.
	 * We can use mode 2 (2x8-bit, internal clock doubler)
	 * if connected to a suitable graphics chip, e.g. the
	 * ET4000-w32p.
	 */
	if(vga-&gt;ctlr &amp;&amp; ((vga-&gt;ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8))
		pclk = 135000000;
	else
		pclk = 110000000;

	/*
	 * If we don't already have a desired pclk,
	 * take it from the mode.
	 * Check it's within range.
	 */
	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	if(vga-&gt;f[0] &lt; 16000000 || vga-&gt;f[0] &gt; pclk)
		error("%s: invalid pclk - %ld\n", ctlr-&gt;name, vga-&gt;f[0]);

	/*
	 * Determine whether to use 2x8-bit mode or not.
	 * If yes and the clock has already been initialised,
	 * initialise it again.
	 */
	if(vga-&gt;ctlr &amp;&amp; (vga-&gt;ctlr-&gt;flag &amp; Hpclk2x8) &amp;&amp; vga-&gt;mode-&gt;z == 8 &amp;&amp; vga-&gt;f[0] &gt;= 110000000){
		vga-&gt;f[0] /= 2;
		resyncinit(vga, ctlr, Upclk2x8, 0);
	}

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	uchar command, mode, pipeline;

	command = 0x00;
	mode = 0x00;
	pipeline = 0x02;
	if(ctlr-&gt;flag &amp; Upclk2x8){
		command = 0x08;
		mode = 0x05;
		pipeline = 0x02;
		if(vga-&gt;f[0] &lt; 16000000)
			pipeline = 0x00;
		else if(vga-&gt;f[0] &lt; 32000000)
			pipeline = 0x01;
	}

	indexrw(Pmode);
	outportb(Pixmask, mode);
	outportb(Pixmask, mode);
	outportb(Pixmask, pipeline);
	sleep(1);
	commandw(command);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga*, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "command");
	printreg(commandr());

	printitem(ctlr-&gt;name, "index");
	indexrw(CompanyID);
	for(i = 0; i &lt; Nindex; i++)
		printreg(inportb(Pixmask));

	pixmask();
}

Ctlr stg1702 = {
	"stg1702",			/* name */
	0,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

