<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/t2r4.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/t2r4.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * #9 Ticket to Ride IV.
 */
typedef struct {
	Pcidev*	pci;
	ulong	io;
	uchar*	mmio;

	ulong	ioreg[13];
	ulong	g[25];
	ulong	w[25];
} T2r4;

enum {					/* memory mapped global registers */
	IntVcnt		= 0x20/4,	/* vertical interrupt counter */
	IntHcnt		= 0x24/4,	/* horizontal interrupt counter */
	DbAdr		= 0x28/4,	/* display start address */
	DbPtch		= 0x2C/4,	/* display pitch */
	CrtHac		= 0x30/4,	/* horizontal active line width */
	CrtHbl		= 0x34/4,	/* horizontal blank width */
	CrtHfp		= 0x38/4,	/* horizontal front porch */
	CrtHs		= 0x3C/4,	/* horizontal sync width */
	CrtVac		= 0x40/4,	/* vertical active field width */
	CrtVbl		= 0x44/4,	/* vertical blank width */
	CrtVfp		= 0x48/4,	/* vertical front porch */
	CrtVs		= 0x4C/4,	/* vertical sync width */
	CrtLcnt		= 0x50/4,	/* CRT line counter */
	CrtZoom		= 0x54/4,	/* display zoom factor */
	Crt1con		= 0x58/4,	/* CRT configuration register 1 */
	Crt2con		= 0x5C/4,	/* CRT configuration register 2 */
	DbAdr2		= 0x60/4,	/* CRT display start address 2 */
};

enum {					/* memory windows registers */
	Mw0Ctrl		= 0x00/4,	/* memory window 0 control */
	Mw0Ad		= 0x04/4,	/* memory window 0 address */
	Mw0Sz		= 0x08/4,	/* memory window 0 size */
	Mw0Org		= 0x10/4,	/* memory window 0 origin */
	Mw0Mask		= 0x24/4,	/* Memory window 0 plane mask */
	Mw1Ctlr		= 0x28/4,	/* memory window 1 control */
	Mw1Ad		= 0x2C/4,	/* memory window 1 address */
	Mw1Sz		= 0x30/4,	/* memory window 1 size */
	Mw1Org		= 0x38/4,	/* memory window 1 origin */
	Mw1Mask		= 0x4C/4,	/* Memory window 1 plane mask */
	MwcFcnt		= 0x50/4,	/* memory window cache flush counter */
	MwcFlsh		= 0x54/4,	/* manual cache flush */
	YuvLi		= 0x58/4,	/* YUV LUT index */
	YuvLa		= 0x5C/4,	/* YUV LUT address */
	MwCtrl		= 0x60/4,	/* memory window 0 and 1 control */
};

enum {
	IndexLo		= 4,
	IndexHi		= 5,
	Data		= 6,
	IndexCtl	= 7,
};

static uchar
_rgb524xi(Vga* vga, int index)
{
	ulong *mmio;

	mmio = (ulong*)((T2r4*)vga-&gt;private)-&gt;mmio;
	mmio[IndexLo] = index &amp; 0xFF;
	mmio[IndexHi] = (index&gt;&gt;8) &amp; 0xFF;

	return mmio[Data];
}

static void
_rgb524xo(Vga* vga, int index, uchar data)
{
	ulong *mmio;

	mmio = (ulong*)((T2r4*)vga-&gt;private)-&gt;mmio;
	mmio[IndexLo] = index &amp; 0xFF;
	mmio[IndexHi] = (index&gt;&gt;8) &amp; 0xFF;

	mmio[Data] = data;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	ulong *mmio;
	int f, i, x;
	Pcidev *p;
	T2r4 *t2r4;
	ulong *rp;

	if(vga-&gt;private == nil){
		vga-&gt;private = alloc(sizeof(T2r4));
		if((p = pcimatch(0, 0x105D, 0)) == nil)
			error("%s: not found\n", ctlr-&gt;name);
		switch(p-&gt;did){
		case 0x5348:			/*  */
			break;
		default:
			error("%s: not found\n", ctlr-&gt;name);
		}

		if((f = open("#v/vgactl", OWRITE)) &lt; 0)
			error("%s: can't open vgactl\n", ctlr-&gt;name);
		if(write(f, "type t2r4", 9) != 9)
			error("%s: can't set type\n", ctlr-&gt;name);
		close(f);
	
		mmio = segattach(0, "t2r4mmio", 0, p-&gt;mem[4].size);
		if(mmio == (void*)-1)
			error("%s: can't attach mmio segment\n", ctlr-&gt;name);

		t2r4 = vga-&gt;private;
		t2r4-&gt;pci = p;
		t2r4-&gt;io = p-&gt;mem[5].bar &amp; ~0x0F;
		t2r4-&gt;mmio = (uchar*)mmio;
	}
	t2r4 = vga-&gt;private;
	for(i = 0; i &lt; nelem(t2r4-&gt;ioreg); i++)
		t2r4-&gt;ioreg[i] = inportl(t2r4-&gt;io+(i*4));

	x = t2r4-&gt;ioreg[7] &amp; 0xFF00001F;		/* config1 */
	outportl(t2r4-&gt;io+0x1C, x|0x00331F10);

	x = t2r4-&gt;ioreg[8] &amp; 0xFF0FFFFF;		/* config2 */
	outportl(t2r4-&gt;io+0x20, x|0x00100000);

	x = inportl(t2r4-&gt;io+0x30) &amp; 0xFF;		/* vgactl */
	outportl(t2r4-&gt;io+0x30, x|0x82);

	rp = (ulong*)t2r4-&gt;mmio;
	for(i = 0; i &lt; nelem(t2r4-&gt;g); i++)
		t2r4-&gt;g[i] = *rp++;
	rp = (ulong*)(t2r4-&gt;mmio+8192);
	for(i = 0; i &lt; nelem(t2r4-&gt;w); i++)
		t2r4-&gt;w[i] = *rp++;

	vga-&gt;vma = vga-&gt;vmz = t2r4-&gt;pci-&gt;mem[0].size;
	ctlr-&gt;flag |= Hlinear;

	/*
	 * Currently, the RGB524 has no need of a snarf
	 * routine so this will be called before any RGB524 code.
	 */
	if(vga-&gt;ramdac &amp;&amp; strncmp(vga-&gt;ramdac-&gt;name, "rgb524mn", 8) == 0){
		rgb524mnxi = _rgb524xi;
		rgb524mnxo = _rgb524xo;
	}

	ctlr-&gt;flag |= Fsnarf;
}

static void
options(Vga* vga, Ctlr* ctlr)
{
	USED(vga);
	ctlr-&gt;flag |= Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	char *val;
	T2r4 *t2r4;
	int crtclocks, zoom;

	t2r4 = vga-&gt;private;
	crtclocks = 64/vga-&gt;mode-&gt;z;

	zoom = 1;
	if((val = dbattr(vga-&gt;mode-&gt;attr, "zoom")) &amp;&amp; strtol(val, 0, 0))
		zoom = 2;

	t2r4-&gt;g[DbAdr] = 0;
	switch(vga-&gt;mode-&gt;z){
	case 8:
		t2r4-&gt;g[DbPtch] = vga-&gt;mode-&gt;x*1;
		break;
	case 16:
		t2r4-&gt;g[DbPtch] = vga-&gt;mode-&gt;x*2;
		break;
	case 32:
		t2r4-&gt;g[DbPtch] = vga-&gt;mode-&gt;x*4;
		break;
	}
	t2r4-&gt;g[CrtHac] = vga-&gt;mode-&gt;x/crtclocks;
	t2r4-&gt;g[CrtHbl] = (vga-&gt;mode-&gt;ht-vga-&gt;mode-&gt;x)/crtclocks;
	if(vga-&gt;mode-&gt;shs == 0)
		vga-&gt;mode-&gt;shs = vga-&gt;mode-&gt;shb;
	t2r4-&gt;g[CrtHfp] = (vga-&gt;mode-&gt;shs-vga-&gt;mode-&gt;x)/crtclocks;
	if(vga-&gt;mode-&gt;ehs == 0)
		vga-&gt;mode-&gt;ehs = vga-&gt;mode-&gt;ehb;
	t2r4-&gt;g[CrtHs] = (vga-&gt;mode-&gt;ehs-vga-&gt;mode-&gt;shs)/crtclocks;
	t2r4-&gt;g[CrtVac] = vga-&gt;mode-&gt;y * zoom;
	t2r4-&gt;g[CrtVbl] = (vga-&gt;mode-&gt;vt-vga-&gt;mode-&gt;y) * zoom;
	t2r4-&gt;g[CrtVfp] = (vga-&gt;mode-&gt;vrs-vga-&gt;mode-&gt;y) * zoom;
	t2r4-&gt;g[CrtVs] = (vga-&gt;mode-&gt;vre-vga-&gt;mode-&gt;vrs) * zoom;
	t2r4-&gt;g[CrtZoom] = 0;

	/*
	 * Turn on the syncs and video.
	 * Bts (bit 0x100) is digital RGB output enable. If there's
	 * a flat-panel then this is hopefully already set by the BIOS,
	 * so don't touch it. (It's possible that bit 0 of SoftSw
	 * indicates flat-panel or CRT).
	 */
	t2r4-&gt;g[Crt1con] &amp;= 0x00000100;
	t2r4-&gt;g[Crt1con] |= 0x70;
	t2r4-&gt;g[Crt2con] = 0x20000100;

	if(zoom == 2)
		t2r4-&gt;g[CrtZoom] = 1;

	t2r4-&gt;w[Mw0Ctrl] = 0;
	t2r4-&gt;w[Mw0Sz] = 0x0D;	/* 32MB */
	t2r4-&gt;w[Mw0Org] = 0;
	t2r4-&gt;w[Mw0Mask] = 0xFFFFFFFF;

	if(vga-&gt;linear &amp;&amp; (ctlr-&gt;flag &amp; Hlinear))
		ctlr-&gt;flag |= Ulinear;

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	T2r4 *t2r4;
	ulong *g, *w;

	t2r4 = vga-&gt;private;

	g = (ulong*)t2r4-&gt;mmio;
	g[DbAdr] = t2r4-&gt;g[DbAdr];
	g[DbPtch] = t2r4-&gt;g[DbPtch];
	g[CrtHac] = t2r4-&gt;g[CrtHac];
	g[CrtHbl] = t2r4-&gt;g[CrtHbl];
	g[CrtHfp] = t2r4-&gt;g[CrtHfp];
	g[CrtHs] = t2r4-&gt;g[CrtHs];
	g[CrtVac] = t2r4-&gt;g[CrtVac];
	g[CrtVbl] = t2r4-&gt;g[CrtVbl];
	g[CrtVfp] = t2r4-&gt;g[CrtVfp];
	g[CrtVs] = t2r4-&gt;g[CrtVs];
	g[Crt1con] = t2r4-&gt;g[Crt1con];
	g[Crt2con] = t2r4-&gt;g[Crt2con];
	g[CrtZoom] = t2r4-&gt;g[CrtZoom];

	w = (ulong*)(t2r4-&gt;mmio+8192);
	w[Mw0Ctrl] = t2r4-&gt;w[Mw0Ctrl];
	w[Mw0Sz] = t2r4-&gt;w[Mw0Sz];
	w[Mw0Org] = t2r4-&gt;w[Mw0Org];
	w[Mw0Mask] = t2r4-&gt;w[Mw0Mask];

	if(t2r4-&gt;g[CrtZoom])
		outportl(t2r4-&gt;io+0x30, 0xA2);	/* vgactl */
	else
		outportl(t2r4-&gt;io+0x30, 0x82);	/* vgactl */
	outportl(t2r4-&gt;io+0x24, 0x211BF030);	/* sgram */
	sleep(500);
	outportl(t2r4-&gt;io+0x24, 0xA11BF030);	/* sgram */

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	T2r4 *t2r4;

	t2r4 = vga-&gt;private;
	Bprint(&amp;stdout, "\n");
	Bprint(&amp;stdout, "%s ioreg\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;io);
	Bprint(&amp;stdout, "%s rbase_g\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[0]);
	Bprint(&amp;stdout, "%s rbase_w\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[1]);
	Bprint(&amp;stdout, "%s rbase_d\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[2]);
	Bprint(&amp;stdout, "%s rbase_i\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[4]);
	Bprint(&amp;stdout, "%s rbase_e\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[5]);
	Bprint(&amp;stdout, "%s id\t\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[6]);
	Bprint(&amp;stdout, "%s config1\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[7]);
	Bprint(&amp;stdout, "%s config2\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[8]);
	Bprint(&amp;stdout, "%s sgram\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[9]);
	Bprint(&amp;stdout, "%s softsw\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[10]);
	Bprint(&amp;stdout, "%s ddc\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[11]);
	Bprint(&amp;stdout, "%s vgactl\t\t%8.8luX\n", ctlr-&gt;name, t2r4-&gt;ioreg[12]);

	Bprint(&amp;stdout, "\n");
	for(i = 0; i &lt; nelem(t2r4-&gt;g); i++)
		Bprint(&amp;stdout, "%s g reg0x%2.2uX\t\t%8.8luX\n",
			ctlr-&gt;name, i*4, t2r4-&gt;g[i]);
	Bprint(&amp;stdout, "\n");
	for(i = 0; i &lt; nelem(t2r4-&gt;w); i++)
		Bprint(&amp;stdout, "%s w reg0x%2.2uX\t\t%8.8luX\n",
			ctlr-&gt;name, i*4, t2r4-&gt;w[i]);
}

Ctlr t2r4 = {
	"t2r4",				/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr t2r4hwgc = {
	"t2r4hwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

