<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/tvp3026clock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/tvp3026clock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

#define SCALE(f)	((f)/10)		/* could be /10 */

static void
init(Vga* vga, Ctlr* ctlr)
{
	int f, k;
	ulong fmin, fvco, m, n, p, q;
	double z;

	if(ctlr-&gt;flag &amp; Finit)
		return;

	if(vga-&gt;f[0] == 0)
		vga-&gt;f[0] = vga-&gt;mode-&gt;frequency;
	vga-&gt;misc &amp;= ~0x0C;
	if(vga-&gt;f[0] == VgaFreq0){
		/* nothing to do */;
	}
	else if(vga-&gt;f[0] == VgaFreq1)
		vga-&gt;misc |= 0x04;
	else
		vga-&gt;misc |= 0x0C;

	/*
	 * Look for values of n, d and p that give
	 * the least error for
	 *	Fvco = 8*RefFreq*(65-m)/(65-n)
	 *	Fpll = Fvco/2**p
	 * N and m are 6 bits, p is 2 bits. Constraints:
	 *	110MHz &lt;= Fvco &lt;= 250MHz
	 *	40 &lt;= n &lt;= 62
	 *	 1 &lt;= m &lt;= 62
	 *	 0 &lt;= p &lt;=  3
	 * Should try to minimise n, m.
	 *
	 * There's nothing like brute force and ignorance.
	 */
	fmin = vga-&gt;f[0];
	vga-&gt;m[0] = 0x15;
	vga-&gt;n[0] = 0x18;
	vga-&gt;p[0] = 3;
	for(m = 62; m &gt; 0; m--){
		for(n = 62; n &gt;= 40; n--){
			fvco = 8*SCALE(RefFreq)*(65-m)/(65-n);
			if(fvco &lt; SCALE(110000000) || fvco &gt; SCALE(250000000))
				continue;
			for(p = 0; p &lt; 4; p++){
				f = SCALE(vga-&gt;f[0]) - (fvco&gt;&gt;p);
				if(f &lt; 0)
					f = -f;
				if(f &lt; fmin){
					fmin = f;
					vga-&gt;m[0] = m;
					vga-&gt;n[0] = n;
					vga-&gt;p[0] = p;
				}
			}
		}
	}

	/*
	 * Now the loop clock:
	 * 	m is fixed;
	 *	calculate n;
	 *	set z to the lower bound (110MHz) and calculate p and q.
	 */
	vga-&gt;m[1] = 61;
	if(ctlr-&gt;flag &amp; Uenhanced)
		k = 64/8;
	else
		k = 8/8;
	n = 65 - 4*k;
	fvco = (8*RefFreq*(65-vga-&gt;m[0]))/(65-vga-&gt;n[0]);
	vga-&gt;f[1] = fvco;
	z = 110.0*(65-n)/(4*(fvco/1000000.0)*k);
	if(z &lt;= 16){
		for(p = 0; p &lt; 4; p++){
			if(1&lt;&lt;(p+1) &gt; z)
				break;
		}
		q = 0;
	}
	else{
		p = 3;
		q = (z - 16)/16 + 1;
	}
	vga-&gt;n[1] = n;
	vga-&gt;p[1] = p;
	vga-&gt;q[1] = q;

	ctlr-&gt;flag |= Finit;
}

Ctlr tvp3026clock = {
	"tvp3026clock",			/* name */
	0,				/* snarf */
	0,				/* options */
	init,				/* init */
	0,				/* load */
	0,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

