<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/vga.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/vga.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

enum {
	NSeqx		= 0x05,
	NCrtx		= 0x19,
	NGrx		= 0x09,
	NAttrx		= 0x15,
};

uchar
vgai(long port)
{
	uchar data;

	switch(port){

	case MiscR:
	case Status0:
	case Status1:
	case FeatureR:
	case PaddrW:
	case Pdata:
	case Pixmask:
	case Pstatus:
		data = inportb(port);
		break;

	default:
		error("vgai(0x%4.4lX): unknown port\n", port);
		/*NOTREACHED*/
		data = 0xFF;
		break;
	}
	return data;
}

uchar
vgaxi(long port, uchar index)
{
	uchar data;

	switch(port){

	case Seqx:
	case Crtx:
	case Grx:
		outportb(port, index);
		data = inportb(port+1);
		break;

	case Attrx:
		/*
		 * Allow processor access to the colour
		 * palette registers. Writes to Attrx must
		 * be preceded by a read from Status1 to
		 * initialise the register to point to the
		 * index register and not the data register.
		 * Processor access is allowed by turning
		 * off bit 0x20.
		 */
		inportb(Status1);
		if(index &lt; 0x10){
			outportb(Attrx, index);
			data = inportb(Attrx+1);
			inportb(Status1);
			outportb(Attrx, 0x20|index);
		}
		else{
			outportb(Attrx, 0x20|index);
			data = inportb(Attrx+1);
		}
		break;

	default:
		error("vgaxi(0x%4.4lx, 0x%2.2uX): unknown port\n", port, index);
		/*NOTREACHED*/
		data = 0xFF;
		break;
	}
	return data;
}

void
vgao(long port, uchar data)
{
	switch(port){

	case MiscW:
	case FeatureW:
	case PaddrW:
	case Pdata:
	case Pixmask:
	case PaddrR:
		outportb(port, data);
		break;

	default:
		error("vgao(0x%4.4lX, 0x%2.2uX): unknown port\n", port, data);
		/*NOTREACHED*/
		break;
	}
}

void
vgaxo(long port, uchar index, uchar data)
{
	switch(port){

	case Seqx:
	case Crtx:
	case Grx:
		/*
		 * We could use an outport here, but some chips
		 * (e.g. 86C928) have trouble with that for some
		 * registers.
		 */
		outportb(port, index);
		outportb(port+1, data);
		break;

	case Attrx:
		inportb(Status1);
		if(index &lt; 0x10){
			outportb(Attrx, index);
			outportb(Attrx, data);
			inportb(Status1);
			outportb(Attrx, 0x20|index);
		}
		else{
			outportb(Attrx, 0x20|index);
			outportb(Attrx, data);
		}
		break;

	default:
		error("vgaxo(0x%4.4lX, 0x%2.2uX, 0x%2.2uX): unknown port\n",
			port, index, data);
		break;
	}
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int i;

	/*
	 * Generic VGA registers:
	 * 	misc, feature;
	 *	sequencer;
	 *	crt;
	 *	graphics;
	 *	attribute;
	 *	palette.
	 */
	vga-&gt;misc = vgai(MiscR);
	vga-&gt;feature = vgai(FeatureR);

	for(i = 0; i &lt; NSeqx; i++)
		vga-&gt;sequencer[i] = vgaxi(Seqx, i);

	for(i = 0; i &lt; NCrtx; i++)
		vga-&gt;crt[i] = vgaxi(Crtx, i);

	for(i = 0; i &lt; NGrx; i++)
		vga-&gt;graphics[i] = vgaxi(Grx, i);

	for(i = 0; i &lt; NAttrx; i++)
		vga-&gt;attribute[i] = vgaxi(Attrx, i);

	if(dflag)
		palette.snarf(vga, ctlr);

	ctlr-&gt;flag |= Fsnarf;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	int vt, vde, vrs, vre;
	ulong tmp;

	mode = vga-&gt;mode;

	memset(vga-&gt;sequencer, 0, NSeqx*sizeof(vga-&gt;sequencer[0]));
	memset(vga-&gt;crt, 0, NCrtx*sizeof(vga-&gt;crt[0]));
	memset(vga-&gt;graphics, 0, NGrx*sizeof(vga-&gt;graphics[0]));
	memset(vga-&gt;attribute, 0, NAttrx*sizeof(vga-&gt;attribute[0]));
	if(dflag)
		memset(vga-&gt;palette, 0, sizeof(vga-&gt;palette));

	/*
	 * Misc. If both the horizontal and vertical sync polarity
	 * options are set, use them. Otherwise use the defaults for
	 * the given vertical size.
	 */
	vga-&gt;misc = 0x23;
	if(mode-&gt;frequency == VgaFreq1)
		vga-&gt;misc |= 0x04;
	if(mode-&gt;hsync &amp;&amp; mode-&gt;vsync){
		if(mode-&gt;hsync == '-')
			vga-&gt;misc |= 0x40;
		if(mode-&gt;vsync == '-')
			vga-&gt;misc |= 0x80;
	}
	else{
		if(mode-&gt;y &lt; 480)
			vga-&gt;misc |= 0x40;
		else if(mode-&gt;y &lt; 400)
			vga-&gt;misc |= 0x80;
		else if(mode-&gt;y &lt; 768)
			vga-&gt;misc |= 0xC0;
	}

	/*
	 * Sequencer
	 */
	vga-&gt;sequencer[0x00] = 0x03;
	vga-&gt;sequencer[0x01] = 0x01;
	vga-&gt;sequencer[0x02] = 0x0F;
	vga-&gt;sequencer[0x03] = 0x00;
	if(mode-&gt;z &gt;= 8)
		vga-&gt;sequencer[0x04] = 0x0A;
	else
		vga-&gt;sequencer[0x04] = 0x06;

	/*
	 * Crt. Most of the work here is in dealing
	 * with field overflow.
	 */
	memset(vga-&gt;crt, 0, NCrtx);

	vga-&gt;crt[0x00] = (mode-&gt;ht&gt;&gt;3)-5;
	vga-&gt;crt[0x01] = (mode-&gt;x&gt;&gt;3)-1;
	vga-&gt;crt[0x02] = (mode-&gt;shb&gt;&gt;3)-1;

	/*
	 * End Horizontal Blank is a 6-bit field, 5-bits
	 * in Crt3, high bit in Crt5.
	 */
	tmp = mode-&gt;ehb&gt;&gt;3;
	vga-&gt;crt[0x03] = 0x80|(tmp &amp; 0x1F);
	if(tmp &amp; 0x20)
		vga-&gt;crt[0x05] |= 0x80;

	if(mode-&gt;shs == 0)
		mode-&gt;shs = mode-&gt;shb;
	vga-&gt;crt[0x04] = mode-&gt;shs&gt;&gt;3;
	if(mode-&gt;ehs == 0)
		mode-&gt;ehs = mode-&gt;ehb;
	vga-&gt;crt[0x05] |= ((mode-&gt;ehs&gt;&gt;3) &amp; 0x1F);

	/*
	 * Vertical Total is 10-bits, 8 in Crt6, the high
	 * two bits in Crt7. What if vt is &gt;= 1024? We hope
	 * the specific controller has some more overflow
	 * bits.
	 *
	 * Interlace: if 'v',  divide the vertical timing
	 * values by 2.
	 */
	vt = mode-&gt;vt;
	vde = mode-&gt;y;
	vrs = mode-&gt;vrs;
	vre = mode-&gt;vre;

	if(mode-&gt;interlace == 'v'){
		vt /= 2;
		vde /= 2;
		vrs /= 2;
		vre /= 2;
	}

	tmp = vt-2;
	vga-&gt;crt[0x06] = tmp;
	if(tmp &amp; 0x100)
		vga-&gt;crt[0x07] |= 0x01;
	if(tmp &amp; 0x200)
		vga-&gt;crt[0x07] |= 0x20;

	tmp = vrs;
	vga-&gt;crt[0x10] = tmp;
	if(tmp &amp; 0x100)
		vga-&gt;crt[0x07] |= 0x04;
	if(tmp &amp; 0x200)
		vga-&gt;crt[0x07] |= 0x80;

	vga-&gt;crt[0x11] = 0x20|(vre &amp; 0x0F);

	tmp = vde-1;
	vga-&gt;crt[0x12] = tmp;
	if(tmp &amp; 0x100)
		vga-&gt;crt[0x07] |= 0x02;
	if(tmp &amp; 0x200)
		vga-&gt;crt[0x07] |= 0x40;

	vga-&gt;crt[0x15] = vrs;
	if(vrs &amp; 0x100)
		vga-&gt;crt[0x07] |= 0x08;
	if(vrs &amp; 0x200)
		vga-&gt;crt[0x09] |= 0x20;

	vga-&gt;crt[0x16] = (vrs+1);

	vga-&gt;crt[0x17] = 0x83;
	tmp = ((vga-&gt;virtx*mode-&gt;z)/8);
	if(tmp &gt;= 512){
		vga-&gt;crt[0x14] |= 0x60;
		tmp /= 8;
	}
	else if(tmp &gt;= 256){
		vga-&gt;crt[0x17] |= 0x08;
		tmp /= 4;
	}
	else{
		vga-&gt;crt[0x17] |= 0x40;
		tmp /= 2;
	}
	vga-&gt;crt[0x13] = tmp;

	if(mode-&gt;x*mode-&gt;y*mode-&gt;z/8 &gt; 64*1024)
		vga-&gt;crt[0x17] |= 0x20;

	vga-&gt;crt[0x18] = 0x7FF;
	if(vga-&gt;crt[0x18] &amp; 0x100)
		vga-&gt;crt[0x07] |= 0x10;
	if(vga-&gt;crt[0x18] &amp; 0x200)
		vga-&gt;crt[0x09] |= 0x40;

	/*
	 * Graphics
	 */
	memset(vga-&gt;graphics, 0, NGrx);
	if((vga-&gt;sequencer[0x04] &amp; 0x04) == 0)
		vga-&gt;graphics[0x05] |= 0x10;
	if(mode-&gt;z &gt;= 8)
		vga-&gt;graphics[0x05] |= 0x40;
	vga-&gt;graphics[0x06] = 0x05;
	vga-&gt;graphics[0x07] = 0x0F;
	vga-&gt;graphics[0x08] = 0xFF;

	/*
	 * Attribute
	 */
	memset(vga-&gt;attribute, 0, NAttrx);
	for(tmp = 0; tmp &lt; 0x10; tmp++)
		vga-&gt;attribute[tmp] = tmp;
	vga-&gt;attribute[0x10] = 0x01;
	if(mode-&gt;z &gt;= 8)
		vga-&gt;attribute[0x10] |= 0x40;
	vga-&gt;attribute[0x11] = 0xFF;
	vga-&gt;attribute[0x12] = 0x0F;

	/*
	 * Palette
	 */
	if(dflag)
		palette.init(vga, ctlr);

	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	int i;

	/*
	 * Reset the sequencer and leave it off.
	 * Load the generic VGA registers:
	 *	misc;
	 *	sequencer (but not seq01, display enable);
	 *	take the sequencer out of reset;
	 *	take off write-protect on crt[0x00-0x07];
	 *	crt;
	 *	graphics;
	 *	attribute;
	 *	palette.
	vgaxo(Seqx, 0x00, 0x00);
	 */

	vgao(MiscW, vga-&gt;misc);

	for(i = 2; i &lt; NSeqx; i++)
		vgaxo(Seqx, i, vga-&gt;sequencer[i]);
	/*vgaxo(Seqx, 0x00, 0x03);*/

	vgaxo(Crtx, 0x11, vga-&gt;crt[0x11] &amp; ~0x80);
	for(i = 0; i &lt; NCrtx; i++)
		vgaxo(Crtx, i, vga-&gt;crt[i]);

	for(i = 0; i &lt; NGrx; i++)
		vgaxo(Grx, i, vga-&gt;graphics[i]);

	for(i = 0; i &lt; NAttrx; i++)
		vgaxo(Attrx, i, vga-&gt;attribute[i]);

	if(dflag)
		palette.load(vga, ctlr);

	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;

	printitem(ctlr-&gt;name, "misc");
	printreg(vga-&gt;misc);
	printitem(ctlr-&gt;name, "feature");
	printreg(vga-&gt;feature);

	printitem(ctlr-&gt;name, "sequencer");
	for(i = 0; i &lt; NSeqx; i++)
		printreg(vga-&gt;sequencer[i]);

	printitem(ctlr-&gt;name, "crt");
	for(i = 0; i &lt; NCrtx; i++)
		printreg(vga-&gt;crt[i]);

	printitem(ctlr-&gt;name, "graphics");
	for(i = 0; i &lt; NGrx; i++)
		printreg(vga-&gt;graphics[i]);

	printitem(ctlr-&gt;name, "attribute");
	for(i = 0; i &lt; NAttrx; i++)
		printreg(vga-&gt;attribute[i]);

	if(dflag)
		palette.dump(vga, ctlr);

	printitem(ctlr-&gt;name, "virtual");
	Bprint(&amp;stdout, "%ld %ld\n", vga-&gt;virtx, vga-&gt;virty);
	printitem(ctlr-&gt;name, "panning");
	Bprint(&amp;stdout, "%s\n", vga-&gt;panning ? "on" : "off");
	if(vga-&gt;f[0]){
		printitem(ctlr-&gt;name, "clock[0] f");
		Bprint(&amp;stdout, "%9ld\n", vga-&gt;f[0]);
		printitem(ctlr-&gt;name, "clock[0] d i m");
		Bprint(&amp;stdout, "%9ld %8ld       - %8ld\n",
			vga-&gt;d[0], vga-&gt;i[0], vga-&gt;m[0]);
		printitem(ctlr-&gt;name, "clock[0] n p q r");
		Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n",
			vga-&gt;n[0], vga-&gt;p[0], vga-&gt;q[0], vga-&gt;r[0]);
	}
	if(vga-&gt;f[1]){
		printitem(ctlr-&gt;name, "clock[1] f");
		Bprint(&amp;stdout, "%9ld\n", vga-&gt;f[1]);
		printitem(ctlr-&gt;name, "clock[1] d i m");
		Bprint(&amp;stdout, "%9ld %8ld       - %8ld\n",
			vga-&gt;d[1], vga-&gt;i[1], vga-&gt;m[1]);
		printitem(ctlr-&gt;name, "clock[1] n p q r");
		Bprint(&amp;stdout, "%9ld %8ld       - %8ld %8ld\n",
			vga-&gt;n[1], vga-&gt;p[1], vga-&gt;q[1], vga-&gt;r[1]);
	}

	if(vga-&gt;vma || vga-&gt;vmb){
		printitem(ctlr-&gt;name, "vm a b");
		Bprint(&amp;stdout, "%9lud %8lud\n", vga-&gt;vma, vga-&gt;vmb);
	}
	if(vga-&gt;vmz){
		printitem(ctlr-&gt;name, "vmz");
		Bprint(&amp;stdout, "%9lud\n", vga-&gt;vmz);
	}
	printitem(ctlr-&gt;name, "apz");
	Bprint(&amp;stdout, "%9lud\n", vga-&gt;apz);

	printitem(ctlr-&gt;name, "linear");
	Bprint(&amp;stdout, "%9d\n", vga-&gt;linear);
}

Ctlr generic = {
	"vga",				/* name */
	snarf,				/* snarf */
	0,				/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

