<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/vision864.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/vision864.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * S3 Vision864 GUI Accelerator.
 * Pretty much the same as the 86C80[15].
 * First pass, needs tuning.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	s3generic.snarf(vga, ctlr);
}

static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Hpclk2x8|Henhanced|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	ulong x;
	char *val;

	s3generic.init(vga, ctlr);
	vga-&gt;crt[0x3B] = vga-&gt;crt[0]-5;

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	/*
	 * VL-bus crap.
	 */
	if((vga-&gt;crt[0x36] &amp; 0x03) == 0x01){
		vga-&gt;crt[0x40] |= 0x08;
		vga-&gt;crt[0x58] &amp;= ~0x88;
	}

	/*
	 * Display memory access control.
	 * Calculation of the M-parameter (Crt54) is
	 * memory-system and dot-clock dependent, the
	 * values below are guesses from dumping
	 * registers.
	 */
	vga-&gt;crt[0x60] = 0xFF;
	x = vga-&gt;mode-&gt;x/8;
	vga-&gt;crt[0x61] = 0x80|((x&gt;&gt;8) &amp; 0x07);
	vga-&gt;crt[0x62] = (x &amp; 0xFF);
	if(vga-&gt;mode-&gt;x &lt;= 800)
		vga-&gt;crt[0x54] = 0x88;
	else if(vga-&gt;mode-&gt;x &lt;= 1024)
		vga-&gt;crt[0x54] = 0xF8;
	else
		vga-&gt;crt[0x54] = 0x40;

	vga-&gt;crt[0x67] &amp;= ~0xF0;
	if(ctlr-&gt;flag &amp; Upclk2x8)
		vga-&gt;crt[0x67] |= 0x10;

	vga-&gt;crt[0x69] = 0x00;
	vga-&gt;crt[0x6A] = 0x00;

	/*
	 * Blank adjust.
	 * This may not be correct for all monitors.
	 */
	vga-&gt;crt[0x6D] = 0x00;
	if(val = dbattr(vga-&gt;attr, "delaybl"))
		vga-&gt;crt[0x6D] |= strtoul(val, 0, 0) &amp; 0x07;
	else
		vga-&gt;crt[0x6D] |= 2;
	if(val = dbattr(vga-&gt;attr, "delaysc"))
		vga-&gt;crt[0x6D] |= (strtoul(val, 0, 0) &amp; 0x07)&lt;&lt;4;
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ushort advfunc;

	s3generic.load(vga, ctlr);
	vgaxo(Crtx, 0x60, vga-&gt;crt[0x60]);
	vgaxo(Crtx, 0x61, vga-&gt;crt[0x61]);
	vgaxo(Crtx, 0x62, vga-&gt;crt[0x62]);
	vgaxo(Crtx, 0x67, vga-&gt;crt[0x67]);
	vgaxo(Crtx, 0x69, vga-&gt;crt[0x69]);
	vgaxo(Crtx, 0x6A, vga-&gt;crt[0x6A]);
	vgaxo(Crtx, 0x6D, vga-&gt;crt[0x6D]);

	advfunc = 0x0000;
	if(ctlr-&gt;flag &amp; Uenhanced){
		if(vga-&gt;mode-&gt;x == 1024 || vga-&gt;mode-&gt;x == 800)
			advfunc = 0x0057;
		else
			advfunc = 0x0053;
	}
	outportw(0x4AE8, advfunc);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	s3generic.dump(vga, ctlr);
}

Ctlr vision864 = {
	"vision864",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

