<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/vision968.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/vision968.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

/*
 * S3 Vision968 GUI Accelerator.
 */
static void
snarf(Vga* vga, Ctlr* ctlr)
{
	s3generic.snarf(vga, ctlr);

	vga-&gt;sequencer[0x09] = vgaxi(Seqx, 0x09);
	vga-&gt;sequencer[0x0A] = vgaxi(Seqx, 0x0A);

	vga-&gt;crt[0x22] = vgaxi(Crtx, 0x22);
	vga-&gt;crt[0x24] = vgaxi(Crtx, 0x24);
	vga-&gt;crt[0x26] = vgaxi(Crtx, 0x26);
	vga-&gt;crt[0x2D] = vgaxi(Crtx, 0x2D);
	vga-&gt;crt[0x2E] = vgaxi(Crtx, 0x2E);
	vga-&gt;crt[0x2F] = vgaxi(Crtx, 0x2F);
}

static void
options(Vga*, Ctlr* ctlr)
{	
	ctlr-&gt;flag |= Hlinear|Henhanced|Foptions;
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Mode *mode;
	ulong x;
	int sid, dbl, bpp, divide;
	char *val;

	if(vga-&gt;mode-&gt;z &gt; 8)
		error("depth %d not supported\n", vga-&gt;mode-&gt;z);

	mode = vga-&gt;mode;
	if(vga-&gt;ramdac &amp;&amp; (vga-&gt;ramdac-&gt;flag &amp; Uclk2)){
		resyncinit(vga, ctlr, Uenhanced, 0);
		vga-&gt;crt[0x00] = ((mode-&gt;ht/2)&gt;&gt;3)-5;
		vga-&gt;crt[0x01] = ((mode-&gt;x/2)&gt;&gt;3)-1;
		vga-&gt;crt[0x02] = ((mode-&gt;shb/2)&gt;&gt;3)-1;
	
		x = (mode-&gt;ehb/2)&gt;&gt;3;
		vga-&gt;crt[0x03] = 0x80|(x &amp; 0x1F);
		vga-&gt;crt[0x04] = (mode-&gt;shs/2)&gt;&gt;3;
		vga-&gt;crt[0x05] = ((mode-&gt;ehs/2)&gt;&gt;3) &amp; 0x1F;
		if(x &amp; 0x20)
			vga-&gt;crt[0x05] |= 0x80;
		vga-&gt;crt[0x13] = mode-&gt;x/8;
	}
	else if(mode-&gt;z == 8)
		resyncinit(vga, ctlr, Uenhanced, 0);
	s3generic.init(vga, ctlr);
	/*
	if((ctlr-&gt;flag &amp; Uenhanced) == 0)
		vga-&gt;crt[0x33] &amp;= ~0x20;
	 */
	vga-&gt;crt[0x3B] = (vga-&gt;crt[0]+vga-&gt;crt[4]+1)/2;
	if(vga-&gt;crt[0x3B] &amp; 0x100)
		vga-&gt;crt[0x5D] |= 0x40;
	vga-&gt;crt[0x55] = 0x00;

	vga-&gt;crt[0x40] &amp;= ~0x10;
	vga-&gt;crt[0x53] &amp;= ~0x20;
	vga-&gt;crt[0x58] &amp;= ~0x48;
	vga-&gt;crt[0x65] = 0x00;
	vga-&gt;crt[0x66] &amp;= ~0x07;
	vga-&gt;crt[0x67] = 0x00;
	vga-&gt;crt[0x6D] = 0x00;
	if(ctlr-&gt;flag &amp; Uenhanced){
		if(vga-&gt;ramdac &amp;&amp; (vga-&gt;ramdac-&gt;flag &amp; Hextsid)){
			if(vga-&gt;ramdac-&gt;flag &amp; Hsid32)
				sid = 32;
			else
				sid = 64;
			if(vga-&gt;ramdac-&gt;flag &amp; Uclk2)
				dbl = 2;
			else
				dbl = 1;
			if(mode-&gt;z &lt; 4)
				bpp = 4;
			else
				bpp = mode-&gt;z;
			divide = sid/(dbl*bpp);
			switch(divide){
			case 2:
				vga-&gt;crt[0x66] |= 0x01;
				break;
			case 4:
				vga-&gt;crt[0x66] |= 0x02;
				break;
			case 8:
				vga-&gt;crt[0x66] |= 0x03;
				break;
			case 16:
				vga-&gt;crt[0x66] |= 0x04;
				break;
			case 32:
				vga-&gt;crt[0x66] |= 0x05;
				break;
			}
		}

		vga-&gt;crt[0x40] |= 0x10;
		vga-&gt;crt[0x58] |= 0x40;

		/*
		 * The test against 1376 is necessary for the STB
		 * Velocity 64 Video, no idea if it's relevant to other
		 * cards.
		 * Although not mentioned in the databook, bit 4 of Crt67
		 * needs to be set on the STB Velocity 64 Video too. Gak.
		 */
		if(dbattr(vga-&gt;attr, "disa1sc") &amp;&amp; mode-&gt;x &lt;= 1376)
			vga-&gt;crt[0x65] |= 0x02;
		if(vga-&gt;ramdac &amp;&amp; strncmp(vga-&gt;ramdac-&gt;name, "tvp3026", 7))
			vga-&gt;crt[0x67] |= 0x10;

		if(dbattr(vga-&gt;attr, "vclkphs"))
			vga-&gt;crt[0x67] |= 0x01;
		if(val = dbattr(vga-&gt;attr, "delaybl"))
			vga-&gt;crt[0x6D] |= strtoul(val, 0, 0) &amp; 0x07;
		if(val = dbattr(vga-&gt;attr, "delaysc"))
			vga-&gt;crt[0x6D] |= (strtoul(val, 0, 0) &amp; 0x07)&lt;&lt;4;
	}
}

static void
load(Vga* vga, Ctlr* ctlr)
{
	ushort advfunc;

	s3generic.load(vga, ctlr);
	vgaxo(Crtx, 0x65, vga-&gt;crt[0x65]);
	vgaxo(Crtx, 0x66, vga-&gt;crt[0x66]);
	vgaxo(Crtx, 0x67, vga-&gt;crt[0x67]);
	vgaxo(Crtx, 0x6D, vga-&gt;crt[0x6D]);

	advfunc = 0x0000;
	if(ctlr-&gt;flag &amp; Uenhanced)
		advfunc = 0x0001;
	outportw(0x4AE8, advfunc);
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	s3generic.dump(vga, ctlr);

	printitem(ctlr-&gt;name, "Seq09");
	printreg(vga-&gt;sequencer[0x09]);
	printreg(vga-&gt;sequencer[0x0A]);

	printitem(ctlr-&gt;name, "Crt22");
	printreg(vga-&gt;crt[0x22]);
	printitem(ctlr-&gt;name, "Crt24");
	printreg(vga-&gt;crt[0x24]);
	printitem(ctlr-&gt;name, "Crt26");
	printreg(vga-&gt;crt[0x26]);
	printitem(ctlr-&gt;name, "Crt2D");
	printreg(vga-&gt;crt[0x2D]);
	printreg(vga-&gt;crt[0x2E]);
	printreg(vga-&gt;crt[0x2F]);
}

Ctlr vision968 = {
	"vision968",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

