<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/aux/vga/vmware.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/aux/vga/vmware.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "pci.h"
#include "vga.h"

enum {
	Rid = 0,
	Renable,
	Rwidth,
	Rheight,
	Rmaxwidth,
	Rmaxheight,
	Rdepth,
	Rbpp,
	Rpseudocolor,
	Rrmask,
	Rgmask,
	Rbmask,
	Rbpl,
	Rfbstart,
	Rfboffset,
	Rfbmaxsize,
	Rfbsize,
	Rcap,
	Rmemstart,
	Rmemsize,
	Rconfigdone,
	Rsync,
	Rbusy,
	Rguestid,
	Rcursorid,
	Rcursorx,
	Rcursory,
	Rcursoron,
	Rhostbpp,
	Nreg,

	Crectfill = 1&lt;&lt;0,
	Crectcopy = 1&lt;&lt;1,
	Crectpatfill = 1&lt;&lt;2,
	Coffscreen = 1&lt;&lt;3,
	Crasterop = 1&lt;&lt;4,
	Ccursor = 1&lt;&lt;5,
	Ccursorbypass = 1&lt;&lt;6,
	Ccursorbypass2 = 1&lt;&lt;7,
	C8bitemulation = 1&lt;&lt;8,
	Calphacursor = 1&lt;&lt;9,

	Rpalette = 1024,
};	

typedef struct Vmware	Vmware;
struct Vmware {
	ulong	mmio;
	ulong	fb;

	ulong	ra;
	ulong	rd;

	ulong	r[Nreg];

	char	chan[32];
	int	depth;
};

static char*
rname[Nreg] = {
	"ID",
	"Enable",
	"Width",
	"Height",
	"MaxWidth",
	"MaxHeight",
	"Depth",
	"Bpp",
	"PseudoColor",
	"RedMask",
	"GreenMask",
	"BlueMask",
	"Bpl",
	"FbStart",
	"FbOffset",
	"FbMaxSize",
	"FbSize",
	"Cap",
	"MemStart",
	"MemSize",
	"ConfigDone",
	"Sync",
	"Busy",
	"GuestID",
	"CursorID",
	"CursorX",
	"CursorY",
	"CursorOn",
	"HostBpp",
};

static ulong
vmrd(Vmware *vm, int i)
{
	outportl(vm-&gt;ra, i);
	return inportl(vm-&gt;rd);
}

static void
vmwr(Vmware *vm, int i, ulong v)
{
	outportl(vm-&gt;ra, i);
	outportl(vm-&gt;rd, v);
}

static uint
bits(ulong a)
{
	int b;

	for(b=0; a; a&gt;&gt;=1)
		if(a&amp;1)
			b++;
	return b;
}

static void
snarf(Vga* vga, Ctlr* ctlr)
{
	int extra, i;
	Pcidev *p;
	Vmware *vm;

	p = vga-&gt;pci;
	if(p == nil)
		error("%s: vga-&gt;pci not set\n", ctlr-&gt;name);

	vm = alloc(sizeof(Vmware));

	switch(p-&gt;did){
	case 0x710:	/* VMware video chipset #1 */
		vm-&gt;ra = 0x4560;
		vm-&gt;rd = 0x4560+4;
		break;

	case 0x405:	/* VMware video chipset #2, untested */
		vm-&gt;ra = p-&gt;mem[0].bar&amp;~3;
		vm-&gt;rd = vm-&gt;ra+1;
		break;

	default:
		error("%s: unrecognized chipset %.4ux\n", ctlr-&gt;name, p-&gt;did);
	}

	for(i=0; i&lt;Nreg; i++)
		vm-&gt;r[i] = vmrd(vm, i);

//vmwr(vm, Renable, 0);
	/*
	 * Figure out color channel.  Delay errors until init,
	 * which is after the register dump.
	 */
	vm-&gt;depth = vm-&gt;r[Rbpp];
	extra = vm-&gt;r[Rbpp] - vm-&gt;r[Rdepth];
	if(vm-&gt;r[Rrmask] &gt; vm-&gt;r[Rgmask] &amp;&amp; vm-&gt;r[Rgmask] &gt; vm-&gt;r[Rbmask]){
		if(extra)
			sprint(vm-&gt;chan, "x%d", extra);
		else
			vm-&gt;chan[0] = '\0';
		sprint(vm-&gt;chan+strlen(vm-&gt;chan), "r%dg%db%d", bits(vm-&gt;r[Rrmask]),
			bits(vm-&gt;r[Rgmask]), bits(vm-&gt;r[Rbmask]));
	}else if(vm-&gt;r[Rbmask] &gt; vm-&gt;r[Rgmask] &amp;&amp; vm-&gt;r[Rgmask] &gt; vm-&gt;r[Rrmask]){
		sprint(vm-&gt;chan, "b%dg%dr%d", bits(vm-&gt;r[Rbmask]),
			bits(vm-&gt;r[Rgmask]), bits(vm-&gt;r[Rrmask]));
		if(extra)
			sprint(vm-&gt;chan+strlen(vm-&gt;chan), "x%d", extra);
	}else
		sprint(vm-&gt;chan, "unknown");

	/* Record the frame buffer start, size */
	vga-&gt;vmb = vm-&gt;r[Rfbstart];
	vga-&gt;apz = vm-&gt;r[Rfbmaxsize];

	vga-&gt;private = vm;
	ctlr-&gt;flag |= Fsnarf;
}


static void
options(Vga*, Ctlr* ctlr)
{
	ctlr-&gt;flag |= Hlinear|Henhanced|Foptions;
}


static void
clock(Vga*, Ctlr*)
{
	/* BEST CLOCK ROUTINE EVER! */
}

static void
init(Vga* vga, Ctlr* ctlr)
{
	Vmware *vm;

	vm = vga-&gt;private;

	vmwr(vm, Rid, (0x900000&lt;&lt;8)|2);
	if(vmrd(vm, Rid)&amp;0xFF != 2)
		error("old vmware svga version %lud; need version 2\n",
			vmrd(vm,Rid)&amp;0xFF);

	ctlr-&gt;flag |= Ulinear;
	if(strcmp(vm-&gt;chan, "unknown") == 0)
		error("couldn't translate color masks into channel\n");

	/* Always use the screen depth, and clip the screen size */
	vga-&gt;mode-&gt;z = vm-&gt;r[Rbpp];
	if(vga-&gt;mode-&gt;x &gt; vm-&gt;r[Rmaxwidth])
		vga-&gt;mode-&gt;x = vm-&gt;r[Rmaxwidth];
	if(vga-&gt;mode-&gt;y &gt; vm-&gt;r[Rmaxheight])
		vga-&gt;mode-&gt;y = vm-&gt;r[Rmaxheight];

	vm-&gt;r[Rwidth] = vga-&gt;mode-&gt;x;
	vm-&gt;r[Rheight] = vga-&gt;mode-&gt;y;

	/* Figure out the channel string */
	strcpy(vga-&gt;mode-&gt;chan, vm-&gt;chan);

	/* Record the bytes per line */
	ctlr-&gt;flag |= Finit;
}

static void
load(Vga* vga, Ctlr *ctlr)
{
	char buf[64];
	int x;
	Vmware *vm;

	vm = vga-&gt;private;
	vmwr(vm, Rwidth, vm-&gt;r[Rwidth]);
	vmwr(vm, Rheight, vm-&gt;r[Rheight]);
	vmwr(vm, Renable, 1);
	vmwr(vm, Rguestid, 0x5010);	/* OS type is "Other" */

	x = vmrd(vm, Rbpl)/(vm-&gt;depth/8);
	if(x != vga-&gt;mode-&gt;x){
		vga-&gt;virtx = x;
		sprint(buf, "%ludx%ludx%d %s", vga-&gt;virtx, vga-&gt;virty,
			vga-&gt;mode-&gt;z, vga-&gt;mode-&gt;chan);
		vgactlw("size", buf);
	}
	ctlr-&gt;flag |= Fload;
}

static void
dump(Vga* vga, Ctlr* ctlr)
{
	int i;
	Vmware *vm;

	vm = vga-&gt;private;

	for(i=0; i&lt;Nreg; i++){
		printitem(ctlr-&gt;name, rname[i]);
		Bprint(&amp;stdout, " %.8lux\n", vm-&gt;r[i]);
	}

	printitem(ctlr-&gt;name, "chan");
	Bprint(&amp;stdout, " %s\n", vm-&gt;chan);
	printitem(ctlr-&gt;name, "depth");
	Bprint(&amp;stdout, " %d\n", vm-&gt;depth);
	printitem(ctlr-&gt;name, "linear");
	
}

Ctlr vmware = {
	"vmware",			/* name */
	snarf,				/* snarf */
	options,			/* options */
	init,				/* init */
	load,				/* load */
	dump,				/* dump */
};

Ctlr vmwarehwgc = {
	"vmwarehwgc",			/* name */
	0,				/* snarf */
	0,				/* options */
	0,				/* init */
	0,				/* load */
	0,				/* dump */
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

