<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/bsplit.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/bsplit.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * bsplit - split big binaries (copy-less plan 9 version)
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;authsrv.h&gt;		/* for ANAMELEN */

enum {
	Stdin,
	Sectsiz = 512,
	Bufsiz = 256*Sectsiz,
};

/* disk address (in bytes or sectors), also type of 2nd arg. to seek */
typedef uvlong Daddr;

#define BLEN(s)	((s)-&gt;wp - (s)-&gt;rp)
#define BALLOC(s) ((s)-&gt;lim - (s)-&gt;base)

typedef struct {
	uchar*	rp;		/* first unconsumed byte */
	uchar*	wp;		/* first empty byte */
	uchar*	lim;		/* 1 past the end of the buffer */
	uchar*	base;		/* start of the buffer */
} Buffer;

typedef struct {
	/* parameters */
	Daddr	maxoutsz;	/* maximum size of output file(s) */

	Daddr	fileout;	/* bytes written to the current output file */
	char	*filenm;
	int	filesz;		/* size of filenm */
	char	*prefix;
	long	filenum;
	int	outf;		/* open output file */

	Buffer	buff;
} Copy;

/* global data */
char *argv0;

/* private data */
static Copy cp = { 512*1024*1024 };	/* default maximum size */
static int debug;

static void
bufreset(Buffer *bp)
{
	bp-&gt;rp = bp-&gt;wp = bp-&gt;base;
}

static void
bufinit(Buffer *bp, uchar *block, unsigned size)
{
	bp-&gt;base = block;
	bp-&gt;lim = bp-&gt;base + size;
	bufreset(bp);
}

static int 
eopen(char *file, int mode)
{
	int fd = open(file, mode);

	if (fd &lt; 0)
		sysfatal("can't open %s: %r", file);
	return fd;
}

static int 
ecreate(char *file, int mode)
{
	int fd = create(file, mode, 0666);

	if (fd &lt; 0)
		sysfatal("can't create %s: %r", file);
	return fd;
}

static char *
filename(Copy *cp)
{
	return cp-&gt;filenm;
}

static int 
opennext(Copy *cp)
{
	if (cp-&gt;outf &gt;= 0)
		sysfatal("opennext called with file open");
	snprint(cp-&gt;filenm, cp-&gt;filesz, "%s%5.5ld", cp-&gt;prefix, cp-&gt;filenum++);
	cp-&gt;outf = ecreate(cp-&gt;filenm, OWRITE);
	cp-&gt;fileout = 0;
	return cp-&gt;outf;
}

static int 
closeout(Copy *cp)
{
	if (cp-&gt;outf &gt;= 0) {
		if (close(cp-&gt;outf) &lt; 0)
			sysfatal("error writing %s: %r", filename(cp));
		cp-&gt;outf = -1;
		cp-&gt;fileout = 0;
	}
	return cp-&gt;outf;
}

/*
 * process - process input file
 */
static void
process(int in, char *inname)
{
	int n = 1;
	unsigned avail, tolim, wsz;
	Buffer *bp = &amp;cp.buff;

	USED(inname);
	do {
		if (BLEN(bp) == 0) {
			if (bp-&gt;lim == bp-&gt;wp)
				bufreset(bp);
			n = read(in, bp-&gt;wp, bp-&gt;lim - bp-&gt;wp);
			if (n &lt;= 0)
				break;
			bp-&gt;wp += n;
		}
		if (cp.outf &lt; 0)
			opennext(&amp;cp);

		/*
		 * write from buffer's current point to end or enough bytes to
		 * reach file-size limit.
		 */
		avail = BLEN(bp);
		tolim = cp.maxoutsz - cp.fileout;
		wsz = (tolim &lt; avail? tolim: avail);

		/* try to write full sectors */
		if (tolim &gt;= avail &amp;&amp; n &gt; 0 &amp;&amp; wsz &gt;= Sectsiz)
			wsz = (wsz / Sectsiz) * Sectsiz;
		if (write(cp.outf, bp-&gt;rp, wsz) != wsz)
			sysfatal("error writing %s: %r", filename(&amp;cp));
		bp-&gt;rp += wsz;

		cp.fileout += wsz;
		if (cp.fileout &gt;= cp.maxoutsz)
			closeout(&amp;cp);
	} while (n &gt; 0 || BLEN(bp) != 0);
}

static void
usage(void)
{
	fprint(2, "usage: %s [-d][-p pfx][-s size] [file...]\n", argv0);
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, errflg = 0;
	uchar block[Bufsiz];

	cp.prefix = "bs.";
	ARGBEGIN {
	case 'd':
		debug++;
		break;
	case 'p':
		cp.prefix = EARGF(usage());
		break;
	case 's':
		cp.maxoutsz = atoll(EARGF(usage()));
		if (cp.maxoutsz &lt; 1)
			errflg++;
		break;
	default:
		errflg++;
		break;
	} ARGEND
	if (errflg || argc &lt; 0)
		usage();

	bufinit(&amp;cp.buff, block, sizeof block);
	cp.outf = -1;
	cp.filesz = strlen(cp.prefix) + 2*ANAMELEN;	/* 2* is slop */
	cp.filenm = malloc(cp.filesz + 1);
	if (cp.filenm == nil)
		sysfatal("no memory: %r");

	if (argc == 0)
		process(Stdin, "/fd/0");
	else
		for (i = 0; i &lt; argc; i++) {
			int in = eopen(argv[i], OREAD);

			process(in, argv[i]);
			close(in);
		}
	closeout(&amp;cp);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

