<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/bzip2/lib/compress.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/bzip2/lib/compress.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->

/*-------------------------------------------------------------*/
/*--- Compression machinery (not incl block sorting)        ---*/
/*---                                            compress.c ---*/
/*-------------------------------------------------------------*/

/*--
  This file is a part of bzip2 and/or libbzip2, a program and
  library for lossless, block-sorting data compression.

  Copyright (C) 1996-2000 Julian R Seward.  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. The origin of this software must not be misrepresented; you must 
     not claim that you wrote the original software.  If you use this 
     software in a product, an acknowledgment in the product 
     documentation would be appreciated but is not required.

  3. Altered source versions must be plainly marked as such, and must
     not be misrepresented as being the original software.

  4. The name of the author may not be used to endorse or promote 
     products derived from this software without specific prior written 
     permission.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  Julian Seward, Cambridge, UK.
  jseward@acm.org
  bzip2/libbzip2 version 1.0 of 21 March 2000

  This program is based on (at least) the work of:
     Mike Burrows
     David Wheeler
     Peter Fenwick
     Alistair Moffat
     Radford Neal
     Ian H. Witten
     Robert Sedgewick
     Jon L. Bentley

  For more information on these sources, see the manual.
--*/

/*--
   CHANGES
   ~~~~~~~
   0.9.0 -- original version.

   0.9.0a/b -- no changes in this file.

   0.9.0c
      * changed setting of nGroups in sendMTFValues() so as to 
        do a bit better on small files
--*/

#include "os.h"
#include "bzlib.h"
#include "bzlib_private.h"


/*---------------------------------------------------*/
/*--- Bit stream I/O                              ---*/
/*---------------------------------------------------*/

/*---------------------------------------------------*/
void BZ2_bsInitWrite ( EState* s )
{
   s-&gt;bsLive = 0;
   s-&gt;bsBuff = 0;
}


/*---------------------------------------------------*/
static
void bsFinishWrite ( EState* s )
{
   while (s-&gt;bsLive &gt; 0) {
      s-&gt;zbits[s-&gt;numZ] = (UChar)(s-&gt;bsBuff &gt;&gt; 24);
      s-&gt;numZ++;
      s-&gt;bsBuff &lt;&lt;= 8;
      s-&gt;bsLive -= 8;
   }
}


/*---------------------------------------------------*/
#define bsNEEDW(nz)                           \
{                                             \
   while (s-&gt;bsLive &gt;= 8) {                   \
      s-&gt;zbits[s-&gt;numZ]                       \
         = (UChar)(s-&gt;bsBuff &gt;&gt; 24);          \
      s-&gt;numZ++;                              \
      s-&gt;bsBuff &lt;&lt;= 8;                        \
      s-&gt;bsLive -= 8;                         \
   }                                          \
}


/*---------------------------------------------------*/
static
__inline__
void bsW ( EState* s, Int32 n, UInt32 v )
{
   bsNEEDW ( n );
   s-&gt;bsBuff |= (v &lt;&lt; (32 - s-&gt;bsLive - n));
   s-&gt;bsLive += n;
}


/*---------------------------------------------------*/
static
void bsPutUInt32 ( EState* s, UInt32 u )
{
   bsW ( s, 8, (u &gt;&gt; 24) &amp; 0xffL );
   bsW ( s, 8, (u &gt;&gt; 16) &amp; 0xffL );
   bsW ( s, 8, (u &gt;&gt;  8) &amp; 0xffL );
   bsW ( s, 8,  u        &amp; 0xffL );
}


/*---------------------------------------------------*/
static
void bsPutUChar ( EState* s, UChar c )
{
   bsW( s, 8, (UInt32)c );
}


/*---------------------------------------------------*/
/*--- The back end proper                         ---*/
/*---------------------------------------------------*/

/*---------------------------------------------------*/
static
void makeMaps_e ( EState* s )
{
   Int32 i;
   s-&gt;nInUse = 0;
   for (i = 0; i &lt; 256; i++)
      if (s-&gt;inUse[i]) {
         s-&gt;unseqToSeq[i] = s-&gt;nInUse;
         s-&gt;nInUse++;
      }
}


/*---------------------------------------------------*/
static
void generateMTFValues ( EState* s )
{
   UChar   yy[256];
   Int32   i, j;
   Int32   zPend;
   Int32   wr;
   Int32   EOB;

   /* 
      After sorting (eg, here),
         s-&gt;arr1 [ 0 .. s-&gt;nblock-1 ] holds sorted order,
         and
         ((UChar*)s-&gt;arr2) [ 0 .. s-&gt;nblock-1 ] 
         holds the original block data.

      The first thing to do is generate the MTF values,
      and put them in
         ((UInt16*)s-&gt;arr1) [ 0 .. s-&gt;nblock-1 ].
      Because there are strictly fewer or equal MTF values
      than block values, ptr values in this area are overwritten
      with MTF values only when they are no longer needed.

      The final compressed bitstream is generated into the
      area starting at
         (UChar*) (&amp;((UChar*)s-&gt;arr2)[s-&gt;nblock])

      These storage aliases are set up in bzCompressInit(),
      except for the last one, which is arranged in 
      compressBlock().
   */
   UInt32* ptr   = s-&gt;ptr;
   UChar* block  = s-&gt;block;
   UInt16* mtfv  = s-&gt;mtfv;

   makeMaps_e ( s );
   EOB = s-&gt;nInUse+1;

   for (i = 0; i &lt;= EOB; i++) s-&gt;mtfFreq[i] = 0;

   wr = 0;
   zPend = 0;
   for (i = 0; i &lt; s-&gt;nInUse; i++) yy[i] = (UChar) i;

   for (i = 0; i &lt; s-&gt;nblock; i++) {
      UChar ll_i;
      AssertD ( wr &lt;= i, "generateMTFValues(1)" );
      j = ptr[i]-1; if (j &lt; 0) j += s-&gt;nblock;
      ll_i = s-&gt;unseqToSeq[block[j]];
      AssertD ( ll_i &lt; s-&gt;nInUse, "generateMTFValues(2a)" );

      if (yy[0] == ll_i) { 
         zPend++;
      } else {

         if (zPend &gt; 0) {
            zPend--;
            while (True) {
               if (zPend &amp; 1) {
                  mtfv[wr] = BZ_RUNB; wr++; 
                  s-&gt;mtfFreq[BZ_RUNB]++; 
               } else {
                  mtfv[wr] = BZ_RUNA; wr++; 
                  s-&gt;mtfFreq[BZ_RUNA]++; 
               }
               if (zPend &lt; 2) break;
               zPend = (zPend - 2) / 2;
            };
            zPend = 0;
         }
         {
            register UChar  rtmp;
            register UChar* ryy_j;
            register UChar  rll_i;
            rtmp  = yy[1];
            yy[1] = yy[0];
            ryy_j = &amp;(yy[1]);
            rll_i = ll_i;
            while ( rll_i != rtmp ) {
               register UChar rtmp2;
               ryy_j++;
               rtmp2  = rtmp;
               rtmp   = *ryy_j;
               *ryy_j = rtmp2;
            };
            yy[0] = rtmp;
            j = ryy_j - &amp;(yy[0]);
            mtfv[wr] = j+1; wr++; s-&gt;mtfFreq[j+1]++;
         }

      }
   }

   if (zPend &gt; 0) {
      zPend--;
      while (True) {
         if (zPend &amp; 1) {
            mtfv[wr] = BZ_RUNB; wr++; 
            s-&gt;mtfFreq[BZ_RUNB]++; 
         } else {
            mtfv[wr] = BZ_RUNA; wr++; 
            s-&gt;mtfFreq[BZ_RUNA]++; 
         }
         if (zPend &lt; 2) break;
         zPend = (zPend - 2) / 2;
      };
//rsc: not used      zPend = 0;
   }

   mtfv[wr] = EOB; wr++; s-&gt;mtfFreq[EOB]++;

   s-&gt;nMTF = wr;
}


/*---------------------------------------------------*/
#define BZ_LESSER_ICOST  0
#define BZ_GREATER_ICOST 15

static
void sendMTFValues ( EState* s )
{
   Int32 v, t, i, j, gs, ge, totc, bt, bc, iter;
   Int32 nSelectors, alphaSize, minLen, maxLen, selCtr;
   Int32 nGroups, nBytes;

   /*--
   UChar  len [BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
   is a global since the decoder also needs it.

   Int32  code[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
   Int32  rfreq[BZ_N_GROUPS][BZ_MAX_ALPHA_SIZE];
   are also globals only used in this proc.
   Made global to keep stack frame size small.
   --*/


   UInt16 cost[BZ_N_GROUPS];
   Int32  fave[BZ_N_GROUPS];

   UInt16* mtfv = s-&gt;mtfv;

   if (s-&gt;verbosity &gt;= 3)
      VPrintf3( "      %d in block, %d after MTF &amp; 1-2 coding, "
                "%d+2 syms in use\n", 
                s-&gt;nblock, s-&gt;nMTF, s-&gt;nInUse );

   alphaSize = s-&gt;nInUse+2;
   for (t = 0; t &lt; BZ_N_GROUPS; t++)
      for (v = 0; v &lt; alphaSize; v++)
         s-&gt;len[t][v] = BZ_GREATER_ICOST;

   /*--- Decide how many coding tables to use ---*/
   AssertH ( s-&gt;nMTF &gt; 0, 3001 );
   if (s-&gt;nMTF &lt; 200)  nGroups = 2; else
   if (s-&gt;nMTF &lt; 600)  nGroups = 3; else
   if (s-&gt;nMTF &lt; 1200) nGroups = 4; else
   if (s-&gt;nMTF &lt; 2400) nGroups = 5; else
                       nGroups = 6;

   /*--- Generate an initial set of coding tables ---*/
   { 
      Int32 nPart, remF, tFreq, aFreq;

      nPart = nGroups;
      remF  = s-&gt;nMTF;
      gs = 0;
      while (nPart &gt; 0) {
         tFreq = remF / nPart;
         ge = gs-1;
         aFreq = 0;
         while (aFreq &lt; tFreq &amp;&amp; ge &lt; alphaSize-1) {
            ge++;
            aFreq += s-&gt;mtfFreq[ge];
         }

         if (ge &gt; gs 
             &amp;&amp; nPart != nGroups &amp;&amp; nPart != 1 
             &amp;&amp; ((nGroups-nPart) % 2 == 1)) {
            aFreq -= s-&gt;mtfFreq[ge];
            ge--;
         }

         if (s-&gt;verbosity &gt;= 3)
            VPrintf5( "      initial group %d, [%d .. %d], "
                      "has %d syms (%4.1f%%)\n",
                      nPart, gs, ge, aFreq, 
                      (100.0 * (float)aFreq) / (float)(s-&gt;nMTF) );
 
         for (v = 0; v &lt; alphaSize; v++)
            if (v &gt;= gs &amp;&amp; v &lt;= ge) 
               s-&gt;len[nPart-1][v] = BZ_LESSER_ICOST; else
               s-&gt;len[nPart-1][v] = BZ_GREATER_ICOST;
 
         nPart--;
         gs = ge+1;
         remF -= aFreq;
      }
   }

   /*--- 
      Iterate up to BZ_N_ITERS times to improve the tables.
   ---*/
   nSelectors = 40000;	/* shut up some compilers' warnings about used and not set */

   for (iter = 0; iter &lt; BZ_N_ITERS; iter++) {

      for (t = 0; t &lt; nGroups; t++) fave[t] = 0;

      for (t = 0; t &lt; nGroups; t++)
         for (v = 0; v &lt; alphaSize; v++)
            s-&gt;rfreq[t][v] = 0;

      /*---
        Set up an auxiliary length table which is used to fast-track
	the common case (nGroups == 6). 
      ---*/
      if (nGroups == 6) {
         for (v = 0; v &lt; alphaSize; v++) {
            s-&gt;len_pack[v][0] = (s-&gt;len[1][v] &lt;&lt; 16) | s-&gt;len[0][v];
            s-&gt;len_pack[v][1] = (s-&gt;len[3][v] &lt;&lt; 16) | s-&gt;len[2][v];
            s-&gt;len_pack[v][2] = (s-&gt;len[5][v] &lt;&lt; 16) | s-&gt;len[4][v];
	 }
      }

      nSelectors = 0;
      totc = 0;
      gs = 0;
      while (True) {

         /*--- Set group start &amp; end marks. --*/
         if (gs &gt;= s-&gt;nMTF) break;
         ge = gs + BZ_G_SIZE - 1; 
         if (ge &gt;= s-&gt;nMTF) ge = s-&gt;nMTF-1;

         /*-- 
            Calculate the cost of this group as coded
            by each of the coding tables.
         --*/
         for (t = 0; t &lt; nGroups; t++) cost[t] = 0;

         if (nGroups == 6 &amp;&amp; 50 == ge-gs+1) {
            /*--- fast track the common case ---*/
            register UInt32 cost01, cost23, cost45;
            register UInt16 icv;
            cost01 = cost23 = cost45 = 0;

#           define BZ_ITER(nn)                \
               icv = mtfv[gs+(nn)];           \
               cost01 += s-&gt;len_pack[icv][0]; \
               cost23 += s-&gt;len_pack[icv][1]; \
               cost45 += s-&gt;len_pack[icv][2]; \

            BZ_ITER(0);  BZ_ITER(1);  BZ_ITER(2);  BZ_ITER(3);  BZ_ITER(4);
            BZ_ITER(5);  BZ_ITER(6);  BZ_ITER(7);  BZ_ITER(8);  BZ_ITER(9);
            BZ_ITER(10); BZ_ITER(11); BZ_ITER(12); BZ_ITER(13); BZ_ITER(14);
            BZ_ITER(15); BZ_ITER(16); BZ_ITER(17); BZ_ITER(18); BZ_ITER(19);
            BZ_ITER(20); BZ_ITER(21); BZ_ITER(22); BZ_ITER(23); BZ_ITER(24);
            BZ_ITER(25); BZ_ITER(26); BZ_ITER(27); BZ_ITER(28); BZ_ITER(29);
            BZ_ITER(30); BZ_ITER(31); BZ_ITER(32); BZ_ITER(33); BZ_ITER(34);
            BZ_ITER(35); BZ_ITER(36); BZ_ITER(37); BZ_ITER(38); BZ_ITER(39);
            BZ_ITER(40); BZ_ITER(41); BZ_ITER(42); BZ_ITER(43); BZ_ITER(44);
            BZ_ITER(45); BZ_ITER(46); BZ_ITER(47); BZ_ITER(48); BZ_ITER(49);

#           undef BZ_ITER

            cost[0] = cost01 &amp; 0xffff; cost[1] = cost01 &gt;&gt; 16;
            cost[2] = cost23 &amp; 0xffff; cost[3] = cost23 &gt;&gt; 16;
            cost[4] = cost45 &amp; 0xffff; cost[5] = cost45 &gt;&gt; 16;

         } else {
	    /*--- slow version which correctly handles all situations ---*/
            for (i = gs; i &lt;= ge; i++) { 
               UInt16 icv = mtfv[i];
               for (t = 0; t &lt; nGroups; t++) cost[t] += s-&gt;len[t][icv];
            }
         }
 
         /*-- 
            Find the coding table which is best for this group,
            and record its identity in the selector table.
         --*/
         bc = 999999999; bt = -1;
         for (t = 0; t &lt; nGroups; t++)
            if (cost[t] &lt; bc) { bc = cost[t]; bt = t; };
         totc += bc;
         fave[bt]++;
         s-&gt;selector[nSelectors] = bt;
         nSelectors++;

         /*-- 
            Increment the symbol frequencies for the selected table.
          --*/
         if (nGroups == 6 &amp;&amp; 50 == ge-gs+1) {
            /*--- fast track the common case ---*/

#           define BZ_ITUR(nn) s-&gt;rfreq[bt][ mtfv[gs+(nn)] ]++

            BZ_ITUR(0);  BZ_ITUR(1);  BZ_ITUR(2);  BZ_ITUR(3);  BZ_ITUR(4);
            BZ_ITUR(5);  BZ_ITUR(6);  BZ_ITUR(7);  BZ_ITUR(8);  BZ_ITUR(9);
            BZ_ITUR(10); BZ_ITUR(11); BZ_ITUR(12); BZ_ITUR(13); BZ_ITUR(14);
            BZ_ITUR(15); BZ_ITUR(16); BZ_ITUR(17); BZ_ITUR(18); BZ_ITUR(19);
            BZ_ITUR(20); BZ_ITUR(21); BZ_ITUR(22); BZ_ITUR(23); BZ_ITUR(24);
            BZ_ITUR(25); BZ_ITUR(26); BZ_ITUR(27); BZ_ITUR(28); BZ_ITUR(29);
            BZ_ITUR(30); BZ_ITUR(31); BZ_ITUR(32); BZ_ITUR(33); BZ_ITUR(34);
            BZ_ITUR(35); BZ_ITUR(36); BZ_ITUR(37); BZ_ITUR(38); BZ_ITUR(39);
            BZ_ITUR(40); BZ_ITUR(41); BZ_ITUR(42); BZ_ITUR(43); BZ_ITUR(44);
            BZ_ITUR(45); BZ_ITUR(46); BZ_ITUR(47); BZ_ITUR(48); BZ_ITUR(49);

#           undef BZ_ITUR

         } else {
	    /*--- slow version which correctly handles all situations ---*/
            for (i = gs; i &lt;= ge; i++)
               s-&gt;rfreq[bt][ mtfv[i] ]++;
         }

         gs = ge+1;
      }
      if (s-&gt;verbosity &gt;= 3) {
         VPrintf2 ( "      pass %d: size is %d, grp uses are ", 
                   iter+1, totc/8 );
         for (t = 0; t &lt; nGroups; t++)
            VPrintf1 ( "%d ", fave[t] );
         VPrintf0 ( "\n" );
      }

      /*--
        Recompute the tables based on the accumulated frequencies.
      --*/
      for (t = 0; t &lt; nGroups; t++)
         BZ2_hbMakeCodeLengths ( &amp;(s-&gt;len[t][0]), &amp;(s-&gt;rfreq[t][0]), 
                                 alphaSize, 20 );
   }


   AssertH( nGroups &lt; 8, 3002 );
   AssertH( nSelectors &lt; 32768 &amp;&amp;
            nSelectors &lt;= (2 + (900000 / BZ_G_SIZE)),
            3003 );


   /*--- Compute MTF values for the selectors. ---*/
   {
      UChar pos[BZ_N_GROUPS], ll_i, tmp2, tmp;
      for (i = 0; i &lt; nGroups; i++) pos[i] = i;
      for (i = 0; i &lt; nSelectors; i++) {
         ll_i = s-&gt;selector[i];
         j = 0;
         tmp = pos[j];
         while ( ll_i != tmp ) {
            j++;
            tmp2 = tmp;
            tmp = pos[j];
            pos[j] = tmp2;
         };
         pos[0] = tmp;
         s-&gt;selectorMtf[i] = j;
      }
   };

   /*--- Assign actual codes for the tables. --*/
   for (t = 0; t &lt; nGroups; t++) {
      minLen = 32;
      maxLen = 0;
      for (i = 0; i &lt; alphaSize; i++) {
         if (s-&gt;len[t][i] &gt; maxLen) maxLen = s-&gt;len[t][i];
         if (s-&gt;len[t][i] &lt; minLen) minLen = s-&gt;len[t][i];
      }
      AssertH ( !(maxLen &gt; 20), 3004 );
      AssertH ( !(minLen &lt; 1),  3005 );
      BZ2_hbAssignCodes ( &amp;(s-&gt;code[t][0]), &amp;(s-&gt;len[t][0]), 
                          minLen, maxLen, alphaSize );
   }

   /*--- Transmit the mapping table. ---*/
   { 
      Bool inUse16[16];
      for (i = 0; i &lt; 16; i++) {
          inUse16[i] = False;
          for (j = 0; j &lt; 16; j++)
             if (s-&gt;inUse[i * 16 + j]) inUse16[i] = True;
      }
     
      nBytes = s-&gt;numZ;
      for (i = 0; i &lt; 16; i++)
         if (inUse16[i]) bsW(s,1,1); else bsW(s,1,0);

      for (i = 0; i &lt; 16; i++)
         if (inUse16[i])
            for (j = 0; j &lt; 16; j++) {
               if (s-&gt;inUse[i * 16 + j]) bsW(s,1,1); else bsW(s,1,0);
            }

      if (s-&gt;verbosity &gt;= 3) 
         VPrintf1( "      bytes: mapping %d, ", s-&gt;numZ-nBytes );
   }

   /*--- Now the selectors. ---*/
   nBytes = s-&gt;numZ;
   bsW ( s, 3, nGroups );
   bsW ( s, 15, nSelectors );
   for (i = 0; i &lt; nSelectors; i++) { 
      for (j = 0; j &lt; s-&gt;selectorMtf[i]; j++) bsW(s,1,1);
      bsW(s,1,0);
   }
   if (s-&gt;verbosity &gt;= 3)
      VPrintf1( "selectors %d, ", s-&gt;numZ-nBytes );

   /*--- Now the coding tables. ---*/
   nBytes = s-&gt;numZ;

   for (t = 0; t &lt; nGroups; t++) {
      Int32 curr = s-&gt;len[t][0];
      bsW ( s, 5, curr );
      for (i = 0; i &lt; alphaSize; i++) {
         while (curr &lt; s-&gt;len[t][i]) { bsW(s,2,2); curr++; /* 10 */ };
         while (curr &gt; s-&gt;len[t][i]) { bsW(s,2,3); curr--; /* 11 */ };
         bsW ( s, 1, 0 );
      }
   }

   if (s-&gt;verbosity &gt;= 3)
      VPrintf1 ( "code lengths %d, ", s-&gt;numZ-nBytes );

   /*--- And finally, the block data proper ---*/
   nBytes = s-&gt;numZ;
   selCtr = 0;
   gs = 0;
   while (True) {
      if (gs &gt;= s-&gt;nMTF) break;
      ge = gs + BZ_G_SIZE - 1; 
      if (ge &gt;= s-&gt;nMTF) ge = s-&gt;nMTF-1;
      AssertH ( s-&gt;selector[selCtr] &lt; nGroups, 3006 );

      if (nGroups == 6 &amp;&amp; 50 == ge-gs+1) {
            /*--- fast track the common case ---*/
            UInt16 mtfv_i;
            UChar* s_len_sel_selCtr 
               = &amp;(s-&gt;len[s-&gt;selector[selCtr]][0]);
            Int32* s_code_sel_selCtr
               = &amp;(s-&gt;code[s-&gt;selector[selCtr]][0]);

#           define BZ_ITAH(nn)                      \
               mtfv_i = mtfv[gs+(nn)];              \
               bsW ( s,                             \
                     s_len_sel_selCtr[mtfv_i],      \
                     s_code_sel_selCtr[mtfv_i] )

            BZ_ITAH(0);  BZ_ITAH(1);  BZ_ITAH(2);  BZ_ITAH(3);  BZ_ITAH(4);
            BZ_ITAH(5);  BZ_ITAH(6);  BZ_ITAH(7);  BZ_ITAH(8);  BZ_ITAH(9);
            BZ_ITAH(10); BZ_ITAH(11); BZ_ITAH(12); BZ_ITAH(13); BZ_ITAH(14);
            BZ_ITAH(15); BZ_ITAH(16); BZ_ITAH(17); BZ_ITAH(18); BZ_ITAH(19);
            BZ_ITAH(20); BZ_ITAH(21); BZ_ITAH(22); BZ_ITAH(23); BZ_ITAH(24);
            BZ_ITAH(25); BZ_ITAH(26); BZ_ITAH(27); BZ_ITAH(28); BZ_ITAH(29);
            BZ_ITAH(30); BZ_ITAH(31); BZ_ITAH(32); BZ_ITAH(33); BZ_ITAH(34);
            BZ_ITAH(35); BZ_ITAH(36); BZ_ITAH(37); BZ_ITAH(38); BZ_ITAH(39);
            BZ_ITAH(40); BZ_ITAH(41); BZ_ITAH(42); BZ_ITAH(43); BZ_ITAH(44);
            BZ_ITAH(45); BZ_ITAH(46); BZ_ITAH(47); BZ_ITAH(48); BZ_ITAH(49);

#           undef BZ_ITAH

      } else {
	 /*--- slow version which correctly handles all situations ---*/
         for (i = gs; i &lt;= ge; i++) {
            bsW ( s, 
                  s-&gt;len  [s-&gt;selector[selCtr]] [mtfv[i]],
                  s-&gt;code [s-&gt;selector[selCtr]] [mtfv[i]] );
         }
      }


      gs = ge+1;
      selCtr++;
   }
   AssertH( selCtr == nSelectors, 3007 );

   if (s-&gt;verbosity &gt;= 3)
      VPrintf1( "codes %d\n", s-&gt;numZ-nBytes );
}


/*---------------------------------------------------*/
void BZ2_compressBlock ( EState* s, Bool is_last_block )
{
   if (s-&gt;nblock &gt; 0) {

      BZ_FINALISE_CRC ( s-&gt;blockCRC );
      s-&gt;combinedCRC = (s-&gt;combinedCRC &lt;&lt; 1) | (s-&gt;combinedCRC &gt;&gt; 31);
      s-&gt;combinedCRC ^= s-&gt;blockCRC;
      if (s-&gt;blockNo &gt; 1) s-&gt;numZ = 0;

      if (s-&gt;verbosity &gt;= 2)
         VPrintf4( "    block %d: crc = 0x%8x, "
                   "combined CRC = 0x%8x, size = %d\n",
                   s-&gt;blockNo, s-&gt;blockCRC, s-&gt;combinedCRC, s-&gt;nblock );

      BZ2_blockSort ( s );
   }

   s-&gt;zbits = (UChar*) (&amp;((UChar*)s-&gt;arr2)[s-&gt;nblock]);

   /*-- If this is the first block, create the stream header. --*/
   if (s-&gt;blockNo == 1) {
      BZ2_bsInitWrite ( s );
      bsPutUChar ( s, 'B' );
      bsPutUChar ( s, 'Z' );
      bsPutUChar ( s, 'h' );
      bsPutUChar ( s, (UChar)('0' + s-&gt;blockSize100k) );
   }

   if (s-&gt;nblock &gt; 0) {

      bsPutUChar ( s, 0x31 ); bsPutUChar ( s, 0x41 );
      bsPutUChar ( s, 0x59 ); bsPutUChar ( s, 0x26 );
      bsPutUChar ( s, 0x53 ); bsPutUChar ( s, 0x59 );

      /*-- Now the block's CRC, so it is in a known place. --*/
      bsPutUInt32 ( s, s-&gt;blockCRC );

      /*-- 
         Now a single bit indicating (non-)randomisation. 
         As of version 0.9.5, we use a better sorting algorithm
         which makes randomisation unnecessary.  So always set
         the randomised bit to 'no'.  Of course, the decoder
         still needs to be able to handle randomised blocks
         so as to maintain backwards compatibility with
         older versions of bzip2.
      --*/
      bsW(s,1,0);

      bsW ( s, 24, s-&gt;origPtr );
      generateMTFValues ( s );
      sendMTFValues ( s );
   }


   /*-- If this is the last block, add the stream trailer. --*/
   if (is_last_block) {

      bsPutUChar ( s, 0x17 ); bsPutUChar ( s, 0x72 );
      bsPutUChar ( s, 0x45 ); bsPutUChar ( s, 0x38 );
      bsPutUChar ( s, 0x50 ); bsPutUChar ( s, 0x90 );
      bsPutUInt32 ( s, s-&gt;combinedCRC );
      if (s-&gt;verbosity &gt;= 2)
         VPrintf1( "    final combined CRC = 0x%x\n   ", s-&gt;combinedCRC );
      bsFinishWrite ( s );
   }
}


/*-------------------------------------------------------------*/
/*--- end                                        compress.c ---*/
/*-------------------------------------------------------------*/
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

