<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/bzip2/lib/decompress.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/bzip2/lib/decompress.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->

/*-------------------------------------------------------------*/
/*--- Decompression machinery                               ---*/
/*---                                          decompress.c ---*/
/*-------------------------------------------------------------*/

/*--
  This file is a part of bzip2 and/or libbzip2, a program and
  library for lossless, block-sorting data compression.

  Copyright (C) 1996-2000 Julian R Seward.  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

  2. The origin of this software must not be misrepresented; you must 
     not claim that you wrote the original software.  If you use this 
     software in a product, an acknowledgment in the product 
     documentation would be appreciated but is not required.

  3. Altered source versions must be plainly marked as such, and must
     not be misrepresented as being the original software.

  4. The name of the author may not be used to endorse or promote 
     products derived from this software without specific prior written 
     permission.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  Julian Seward, Cambridge, UK.
  jseward@acm.org
  bzip2/libbzip2 version 1.0 of 21 March 2000

  This program is based on (at least) the work of:
     Mike Burrows
     David Wheeler
     Peter Fenwick
     Alistair Moffat
     Radford Neal
     Ian H. Witten
     Robert Sedgewick
     Jon L. Bentley

  For more information on these sources, see the manual.
--*/


#include "os.h"
#include "bzlib.h"
#include "bzlib_private.h"


/*---------------------------------------------------*/
static
void makeMaps_d ( DState* s )
{
   Int32 i;
   s-&gt;nInUse = 0;
   for (i = 0; i &lt; 256; i++)
      if (s-&gt;inUse[i]) {
         s-&gt;seqToUnseq[s-&gt;nInUse] = i;
         s-&gt;nInUse++;
      }
}


/*---------------------------------------------------*/
#define RETURN(rrr)                               \
   { retVal = rrr; goto save_state_and_return; };

#define GET_BITS(lll,vvv,nnn)                     \
   case lll: s-&gt;state = lll;                      \
   while (True) {                                 \
      if (s-&gt;bsLive &gt;= nnn) {                     \
         UInt32 v;                                \
         v = (s-&gt;bsBuff &gt;&gt;                        \
             (s-&gt;bsLive-nnn)) &amp; ((1 &lt;&lt; nnn)-1);   \
         s-&gt;bsLive -= nnn;                        \
         vvv = v;                                 \
         break;                                   \
      }                                           \
      if (s-&gt;strm-&gt;avail_in == 0) RETURN(BZ_OK);  \
      s-&gt;bsBuff                                   \
         = (s-&gt;bsBuff &lt;&lt; 8) |                     \
           ((UInt32)                              \
              (*((UChar*)(s-&gt;strm-&gt;next_in))));   \
      s-&gt;bsLive += 8;                             \
      s-&gt;strm-&gt;next_in++;                         \
      s-&gt;strm-&gt;avail_in--;                        \
      s-&gt;strm-&gt;total_in_lo32++;                   \
      if (s-&gt;strm-&gt;total_in_lo32 == 0)            \
         s-&gt;strm-&gt;total_in_hi32++;                \
   }

#define GET_UCHAR(lll,uuu)                        \
   GET_BITS(lll,uuu,8)

#define GET_BIT(lll,uuu)                          \
   GET_BITS(lll,uuu,1)

/*---------------------------------------------------*/
#define GET_MTF_VAL(label1,label2,lval)           \
{                                                 \
   if (groupPos == 0) {                           \
      groupNo++;                                  \
      if (groupNo &gt;= nSelectors)                  \
         RETURN(BZ_DATA_ERROR);                   \
      groupPos = BZ_G_SIZE;                       \
      gSel = s-&gt;selector[groupNo];                \
      gMinlen = s-&gt;minLens[gSel];                 \
      gLimit = &amp;(s-&gt;limit[gSel][0]);              \
      gPerm = &amp;(s-&gt;perm[gSel][0]);                \
      gBase = &amp;(s-&gt;base[gSel][0]);                \
   }                                              \
   groupPos--;                                    \
   zn = gMinlen;                                  \
   GET_BITS(label1, zvec, zn);                    \
   while (1) {                                    \
      if (zn &gt; 20 /* the longest code */)         \
         RETURN(BZ_DATA_ERROR);                   \
      if (zvec &lt;= gLimit[zn]) break;              \
      zn++;                                       \
      GET_BIT(label2, zj);                        \
      zvec = (zvec &lt;&lt; 1) | zj;                    \
   };                                             \
   if (zvec - gBase[zn] &lt; 0                       \
       || zvec - gBase[zn] &gt;= BZ_MAX_ALPHA_SIZE)  \
      RETURN(BZ_DATA_ERROR);                      \
   lval = gPerm[zvec - gBase[zn]];                \
}


/*---------------------------------------------------*/
Int32 BZ2_decompress ( DState* s )
{
   UChar      uc;
   Int32      retVal;
   Int32      minLen, maxLen;
   bz_stream* strm = s-&gt;strm;

   /* stuff that needs to be saved/restored */
   Int32  i;
   Int32  j;
   Int32  t;
   Int32  alphaSize;
   Int32  nGroups;
   Int32  nSelectors;
   Int32  EOB;
   Int32  groupNo;
   Int32  groupPos;
   Int32  nextSym;
   Int32  nblockMAX;
   Int32  nblock;
   Int32  es;
   Int32  N;
   Int32  curr;
   Int32  zt;
   Int32  zn; 
   Int32  zvec;
   Int32  zj;
   Int32  gSel;
   Int32  gMinlen;
   Int32* gLimit;
   Int32* gBase;
   Int32* gPerm;

   if (s-&gt;state == BZ_X_MAGIC_1) {
      /*initialise the save area*/
      s-&gt;save_i           = 0;
      s-&gt;save_j           = 0;
      s-&gt;save_t           = 0;
      s-&gt;save_alphaSize   = 0;
      s-&gt;save_nGroups     = 0;
      s-&gt;save_nSelectors  = 0;
      s-&gt;save_EOB         = 0;
      s-&gt;save_groupNo     = 0;
      s-&gt;save_groupPos    = 0;
      s-&gt;save_nextSym     = 0;
      s-&gt;save_nblockMAX   = 0;
      s-&gt;save_nblock      = 0;
      s-&gt;save_es          = 0;
      s-&gt;save_N           = 0;
      s-&gt;save_curr        = 0;
      s-&gt;save_zt          = 0;
      s-&gt;save_zn          = 0;
      s-&gt;save_zvec        = 0;
      s-&gt;save_zj          = 0;
      s-&gt;save_gSel        = 0;
      s-&gt;save_gMinlen     = 0;
      s-&gt;save_gLimit      = NULL;
      s-&gt;save_gBase       = NULL;
      s-&gt;save_gPerm       = NULL;
   }

   /*restore from the save area*/
   i           = s-&gt;save_i;
   j           = s-&gt;save_j;
   t           = s-&gt;save_t;
   alphaSize   = s-&gt;save_alphaSize;
   nGroups     = s-&gt;save_nGroups;
   nSelectors  = s-&gt;save_nSelectors;
   EOB         = s-&gt;save_EOB;
   groupNo     = s-&gt;save_groupNo;
   groupPos    = s-&gt;save_groupPos;
   nextSym     = s-&gt;save_nextSym;
   nblockMAX   = s-&gt;save_nblockMAX;
   nblock      = s-&gt;save_nblock;
   es          = s-&gt;save_es;
   N           = s-&gt;save_N;
   curr        = s-&gt;save_curr;
   zt          = s-&gt;save_zt;
   zn          = s-&gt;save_zn; 
   zvec        = s-&gt;save_zvec;
   zj          = s-&gt;save_zj;
   gSel        = s-&gt;save_gSel;
   gMinlen     = s-&gt;save_gMinlen;
   gLimit      = s-&gt;save_gLimit;
   gBase       = s-&gt;save_gBase;
   gPerm       = s-&gt;save_gPerm;

   retVal = BZ_OK;

   switch (s-&gt;state) {

      GET_UCHAR(BZ_X_MAGIC_1, uc);
      if (uc != 'B') RETURN(BZ_DATA_ERROR_MAGIC);

      GET_UCHAR(BZ_X_MAGIC_2, uc);
      if (uc != 'Z') RETURN(BZ_DATA_ERROR_MAGIC);

      GET_UCHAR(BZ_X_MAGIC_3, uc)
      if (uc != 'h') RETURN(BZ_DATA_ERROR_MAGIC);

      GET_BITS(BZ_X_MAGIC_4, s-&gt;blockSize100k, 8)
      if (s-&gt;blockSize100k &lt; '1' || 
          s-&gt;blockSize100k &gt; '9') RETURN(BZ_DATA_ERROR_MAGIC);
      s-&gt;blockSize100k -= '0';

      if (s-&gt;smallDecompress) {
         s-&gt;ll16 = BZALLOC( s-&gt;blockSize100k * 100000 * sizeof(UInt16) );
         s-&gt;ll4  = BZALLOC( 
                      ((1 + s-&gt;blockSize100k * 100000) &gt;&gt; 1) * sizeof(UChar) 
                   );
         if (s-&gt;ll16 == NULL || s-&gt;ll4 == NULL) RETURN(BZ_MEM_ERROR);
      } else {
         s-&gt;tt  = BZALLOC( s-&gt;blockSize100k * 100000 * sizeof(Int32) );
         if (s-&gt;tt == NULL) RETURN(BZ_MEM_ERROR);
      }

      GET_UCHAR(BZ_X_BLKHDR_1, uc);

      if (uc == 0x17) goto endhdr_2;
      if (uc != 0x31) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_BLKHDR_2, uc);
      if (uc != 0x41) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_BLKHDR_3, uc);
      if (uc != 0x59) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_BLKHDR_4, uc);
      if (uc != 0x26) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_BLKHDR_5, uc);
      if (uc != 0x53) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_BLKHDR_6, uc);
      if (uc != 0x59) RETURN(BZ_DATA_ERROR);

      s-&gt;currBlockNo++;
      if (s-&gt;verbosity &gt;= 2)
         VPrintf1 ( "\n    [%d: huff+mtf ", s-&gt;currBlockNo );
 
      s-&gt;storedBlockCRC = 0;
      GET_UCHAR(BZ_X_BCRC_1, uc);
      s-&gt;storedBlockCRC = (s-&gt;storedBlockCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_BCRC_2, uc);
      s-&gt;storedBlockCRC = (s-&gt;storedBlockCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_BCRC_3, uc);
      s-&gt;storedBlockCRC = (s-&gt;storedBlockCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_BCRC_4, uc);
      s-&gt;storedBlockCRC = (s-&gt;storedBlockCRC &lt;&lt; 8) | ((UInt32)uc);

      GET_BITS(BZ_X_RANDBIT, s-&gt;blockRandomised, 1);

      s-&gt;origPtr = 0;
      GET_UCHAR(BZ_X_ORIGPTR_1, uc);
      s-&gt;origPtr = (s-&gt;origPtr &lt;&lt; 8) | ((Int32)uc);
      GET_UCHAR(BZ_X_ORIGPTR_2, uc);
      s-&gt;origPtr = (s-&gt;origPtr &lt;&lt; 8) | ((Int32)uc);
      GET_UCHAR(BZ_X_ORIGPTR_3, uc);
      s-&gt;origPtr = (s-&gt;origPtr &lt;&lt; 8) | ((Int32)uc);

      if (s-&gt;origPtr &lt; 0)
         RETURN(BZ_DATA_ERROR);
      if (s-&gt;origPtr &gt; 10 + 100000*s-&gt;blockSize100k) 
         RETURN(BZ_DATA_ERROR);

      /*--- Receive the mapping table ---*/
      for (i = 0; i &lt; 16; i++) {
         GET_BIT(BZ_X_MAPPING_1, uc);
         if (uc == 1) 
            s-&gt;inUse16[i] = True; else 
            s-&gt;inUse16[i] = False;
      }

      for (i = 0; i &lt; 256; i++) s-&gt;inUse[i] = False;

      for (i = 0; i &lt; 16; i++)
         if (s-&gt;inUse16[i])
            for (j = 0; j &lt; 16; j++) {
               GET_BIT(BZ_X_MAPPING_2, uc);
               if (uc == 1) s-&gt;inUse[i * 16 + j] = True;
            }
      makeMaps_d ( s );
      if (s-&gt;nInUse == 0) RETURN(BZ_DATA_ERROR);
      alphaSize = s-&gt;nInUse+2;

      /*--- Now the selectors ---*/
      GET_BITS(BZ_X_SELECTOR_1, nGroups, 3);
      if (nGroups &lt; 2 || nGroups &gt; 6) RETURN(BZ_DATA_ERROR);
      GET_BITS(BZ_X_SELECTOR_2, nSelectors, 15);
      if (nSelectors &lt; 1) RETURN(BZ_DATA_ERROR);
      for (i = 0; i &lt; nSelectors; i++) {
         j = 0;
         while (True) {
            GET_BIT(BZ_X_SELECTOR_3, uc);
            if (uc == 0) break;
            j++;
            if (j &gt;= nGroups) RETURN(BZ_DATA_ERROR);
         }
         s-&gt;selectorMtf[i] = j;
      }

      /*--- Undo the MTF values for the selectors. ---*/
      {
         UChar pos[BZ_N_GROUPS], tmp, v;
         for (v = 0; v &lt; nGroups; v++) pos[v] = v;
   
         for (i = 0; i &lt; nSelectors; i++) {
            v = s-&gt;selectorMtf[i];
            tmp = pos[v];
            while (v &gt; 0) { pos[v] = pos[v-1]; v--; }
            pos[0] = tmp;
            s-&gt;selector[i] = tmp;
         }
      }

      /*--- Now the coding tables ---*/
      for (t = 0; t &lt; nGroups; t++) {
         GET_BITS(BZ_X_CODING_1, curr, 5);
         for (i = 0; i &lt; alphaSize; i++) {
            while (True) {
               if (curr &lt; 1 || curr &gt; 20) RETURN(BZ_DATA_ERROR);
               GET_BIT(BZ_X_CODING_2, uc);
               if (uc == 0) break;
               GET_BIT(BZ_X_CODING_3, uc);
               if (uc == 0) curr++; else curr--;
            }
            s-&gt;len[t][i] = curr;
         }
      }

      /*--- Create the Huffman decoding tables ---*/
      for (t = 0; t &lt; nGroups; t++) {
         minLen = 32;
         maxLen = 0;
         for (i = 0; i &lt; alphaSize; i++) {
            if (s-&gt;len[t][i] &gt; maxLen) maxLen = s-&gt;len[t][i];
            if (s-&gt;len[t][i] &lt; minLen) minLen = s-&gt;len[t][i];
         }
         BZ2_hbCreateDecodeTables ( 
            &amp;(s-&gt;limit[t][0]), 
            &amp;(s-&gt;base[t][0]), 
            &amp;(s-&gt;perm[t][0]), 
            &amp;(s-&gt;len[t][0]),
            minLen, maxLen, alphaSize
         );
         s-&gt;minLens[t] = minLen;
      }

      /*--- Now the MTF values ---*/

      EOB      = s-&gt;nInUse+1;
      nblockMAX = 100000 * s-&gt;blockSize100k;
      groupNo  = -1;
      groupPos = 0;

      for (i = 0; i &lt;= 255; i++) s-&gt;unzftab[i] = 0;

      /*-- MTF init --*/
      {
         Int32 ii, jj, kk;
         kk = MTFA_SIZE-1;
         for (ii = 256 / MTFL_SIZE - 1; ii &gt;= 0; ii--) {
            for (jj = MTFL_SIZE-1; jj &gt;= 0; jj--) {
               s-&gt;mtfa[kk] = (UChar)(ii * MTFL_SIZE + jj);
               kk--;
            }
            s-&gt;mtfbase[ii] = kk + 1;
         }
      }
      /*-- end MTF init --*/

      nblock = 0;
      GET_MTF_VAL(BZ_X_MTF_1, BZ_X_MTF_2, nextSym);

      while (True) {

         if (nextSym == EOB) break;

         if (nextSym == BZ_RUNA || nextSym == BZ_RUNB) {

            es = -1;
            N = 1;
            do {
               if (nextSym == BZ_RUNA) es = es + (0+1) * N; else
               if (nextSym == BZ_RUNB) es = es + (1+1) * N;
               N = N * 2;
               GET_MTF_VAL(BZ_X_MTF_3, BZ_X_MTF_4, nextSym);
            }
               while (nextSym == BZ_RUNA || nextSym == BZ_RUNB);

            es++;
            uc = s-&gt;seqToUnseq[ s-&gt;mtfa[s-&gt;mtfbase[0]] ];
            s-&gt;unzftab[uc] += es;

            if (s-&gt;smallDecompress)
               while (es &gt; 0) {
                  if (nblock &gt;= nblockMAX) RETURN(BZ_DATA_ERROR);
                  s-&gt;ll16[nblock] = (UInt16)uc;
                  nblock++;
                  es--;
               }
            else
               while (es &gt; 0) {
                  if (nblock &gt;= nblockMAX) RETURN(BZ_DATA_ERROR);
                  s-&gt;tt[nblock] = (UInt32)uc;
                  nblock++;
                  es--;
               };

            continue;

         } else {

            if (nblock &gt;= nblockMAX) RETURN(BZ_DATA_ERROR);

            /*-- uc = MTF ( nextSym-1 ) --*/
            {
               Int32 ii, jj, kk, pp, lno, off;
               UInt32 nn;
               nn = (UInt32)(nextSym - 1);

               if (nn &lt; MTFL_SIZE) {
                  /* avoid general-case expense */
                  pp = s-&gt;mtfbase[0];
                  uc = s-&gt;mtfa[pp+nn];
                  while (nn &gt; 3) {
                     Int32 z = pp+nn;
                     s-&gt;mtfa[(z)  ] = s-&gt;mtfa[(z)-1];
                     s-&gt;mtfa[(z)-1] = s-&gt;mtfa[(z)-2];
                     s-&gt;mtfa[(z)-2] = s-&gt;mtfa[(z)-3];
                     s-&gt;mtfa[(z)-3] = s-&gt;mtfa[(z)-4];
                     nn -= 4;
                  }
                  while (nn &gt; 0) { 
                     s-&gt;mtfa[(pp+nn)] = s-&gt;mtfa[(pp+nn)-1]; nn--; 
                  };
                  s-&gt;mtfa[pp] = uc;
               } else { 
                  /* general case */
                  lno = nn / MTFL_SIZE;
                  off = nn % MTFL_SIZE;
                  pp = s-&gt;mtfbase[lno] + off;
                  uc = s-&gt;mtfa[pp];
                  while (pp &gt; s-&gt;mtfbase[lno]) { 
                     s-&gt;mtfa[pp] = s-&gt;mtfa[pp-1]; pp--; 
                  };
                  s-&gt;mtfbase[lno]++;
                  while (lno &gt; 0) {
                     s-&gt;mtfbase[lno]--;
                     s-&gt;mtfa[s-&gt;mtfbase[lno]] 
                        = s-&gt;mtfa[s-&gt;mtfbase[lno-1] + MTFL_SIZE - 1];
                     lno--;
                  }
                  s-&gt;mtfbase[0]--;
                  s-&gt;mtfa[s-&gt;mtfbase[0]] = uc;
                  if (s-&gt;mtfbase[0] == 0) {
                     kk = MTFA_SIZE-1;
                     for (ii = 256 / MTFL_SIZE-1; ii &gt;= 0; ii--) {
                        for (jj = MTFL_SIZE-1; jj &gt;= 0; jj--) {
                           s-&gt;mtfa[kk] = s-&gt;mtfa[s-&gt;mtfbase[ii] + jj];
                           kk--;
                        }
                        s-&gt;mtfbase[ii] = kk + 1;
                     }
                  }
               }
            }
            /*-- end uc = MTF ( nextSym-1 ) --*/

            s-&gt;unzftab[s-&gt;seqToUnseq[uc]]++;
            if (s-&gt;smallDecompress)
               s-&gt;ll16[nblock] = (UInt16)(s-&gt;seqToUnseq[uc]); else
               s-&gt;tt[nblock]   = (UInt32)(s-&gt;seqToUnseq[uc]);
            nblock++;

            GET_MTF_VAL(BZ_X_MTF_5, BZ_X_MTF_6, nextSym);
            continue;
         }
      }

      /* Now we know what nblock is, we can do a better sanity
         check on s-&gt;origPtr.
      */
      if (s-&gt;origPtr &lt; 0 || s-&gt;origPtr &gt;= nblock)
         RETURN(BZ_DATA_ERROR);

      s-&gt;state_out_len = 0;
      s-&gt;state_out_ch  = 0;
      BZ_INITIALISE_CRC ( s-&gt;calculatedBlockCRC );
      s-&gt;state = BZ_X_OUTPUT;
      if (s-&gt;verbosity &gt;= 2) VPrintf0 ( "rt+rld" );

      /*-- Set up cftab to facilitate generation of T^(-1) --*/
      s-&gt;cftab[0] = 0;
      for (i = 1; i &lt;= 256; i++) s-&gt;cftab[i] = s-&gt;unzftab[i-1];
      for (i = 1; i &lt;= 256; i++) s-&gt;cftab[i] += s-&gt;cftab[i-1];

      if (s-&gt;smallDecompress) {

         /*-- Make a copy of cftab, used in generation of T --*/
         for (i = 0; i &lt;= 256; i++) s-&gt;cftabCopy[i] = s-&gt;cftab[i];

         /*-- compute the T vector --*/
         for (i = 0; i &lt; nblock; i++) {
            uc = (UChar)(s-&gt;ll16[i]);
            SET_LL(i, s-&gt;cftabCopy[uc]);
            s-&gt;cftabCopy[uc]++;
         }

         /*-- Compute T^(-1) by pointer reversal on T --*/
         i = s-&gt;origPtr;
         j = GET_LL(i);
         do {
            Int32 tmp = GET_LL(j);
            SET_LL(j, i);
            i = j;
            j = tmp;
         }
            while (i != s-&gt;origPtr);

         s-&gt;tPos = s-&gt;origPtr;
         s-&gt;nblock_used = 0;
         if (s-&gt;blockRandomised) {
            BZ_RAND_INIT_MASK;
            BZ_GET_SMALL(s-&gt;k0); s-&gt;nblock_used++;
            BZ_RAND_UPD_MASK; s-&gt;k0 ^= BZ_RAND_MASK; 
         } else {
            BZ_GET_SMALL(s-&gt;k0); s-&gt;nblock_used++;
         }

      } else {

         /*-- compute the T^(-1) vector --*/
         for (i = 0; i &lt; nblock; i++) {
            uc = (UChar)(s-&gt;tt[i] &amp; 0xff);
            s-&gt;tt[s-&gt;cftab[uc]] |= (i &lt;&lt; 8);
            s-&gt;cftab[uc]++;
         }

         s-&gt;tPos = s-&gt;tt[s-&gt;origPtr] &gt;&gt; 8;
         s-&gt;nblock_used = 0;
         if (s-&gt;blockRandomised) {
            BZ_RAND_INIT_MASK;
            BZ_GET_FAST(s-&gt;k0); s-&gt;nblock_used++;
            BZ_RAND_UPD_MASK; s-&gt;k0 ^= BZ_RAND_MASK; 
         } else {
            BZ_GET_FAST(s-&gt;k0); s-&gt;nblock_used++;
         }

      }

      RETURN(BZ_OK);



    endhdr_2:

      GET_UCHAR(BZ_X_ENDHDR_2, uc);
      if (uc != 0x72) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_ENDHDR_3, uc);
      if (uc != 0x45) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_ENDHDR_4, uc);
      if (uc != 0x38) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_ENDHDR_5, uc);
      if (uc != 0x50) RETURN(BZ_DATA_ERROR);
      GET_UCHAR(BZ_X_ENDHDR_6, uc);
      if (uc != 0x90) RETURN(BZ_DATA_ERROR);

      s-&gt;storedCombinedCRC = 0;
      GET_UCHAR(BZ_X_CCRC_1, uc);
      s-&gt;storedCombinedCRC = (s-&gt;storedCombinedCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_CCRC_2, uc);
      s-&gt;storedCombinedCRC = (s-&gt;storedCombinedCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_CCRC_3, uc);
      s-&gt;storedCombinedCRC = (s-&gt;storedCombinedCRC &lt;&lt; 8) | ((UInt32)uc);
      GET_UCHAR(BZ_X_CCRC_4, uc);
      s-&gt;storedCombinedCRC = (s-&gt;storedCombinedCRC &lt;&lt; 8) | ((UInt32)uc);

      s-&gt;state = BZ_X_IDLE;
      RETURN(BZ_STREAM_END);

      default: AssertH ( False, 4001 );
   }

   AssertH ( False, 4002 );

   save_state_and_return:

   s-&gt;save_i           = i;
   s-&gt;save_j           = j;
   s-&gt;save_t           = t;
   s-&gt;save_alphaSize   = alphaSize;
   s-&gt;save_nGroups     = nGroups;
   s-&gt;save_nSelectors  = nSelectors;
   s-&gt;save_EOB         = EOB;
   s-&gt;save_groupNo     = groupNo;
   s-&gt;save_groupPos    = groupPos;
   s-&gt;save_nextSym     = nextSym;
   s-&gt;save_nblockMAX   = nblockMAX;
   s-&gt;save_nblock      = nblock;
   s-&gt;save_es          = es;
   s-&gt;save_N           = N;
   s-&gt;save_curr        = curr;
   s-&gt;save_zt          = zt;
   s-&gt;save_zn          = zn;
   s-&gt;save_zvec        = zvec;
   s-&gt;save_zj          = zj;
   s-&gt;save_gSel        = gSel;
   s-&gt;save_gMinlen     = gMinlen;
   s-&gt;save_gLimit      = gLimit;
   s-&gt;save_gBase       = gBase;
   s-&gt;save_gPerm       = gPerm;

   return retVal;   
}


/*-------------------------------------------------------------*/
/*--- end                                      decompress.c ---*/
/*-------------------------------------------------------------*/
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

