<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/calendar.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/calendar.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include &lt;ctype.h&gt;

typedef struct Date	Date;
struct Date {
	Reprog *p;	/* an RE to match this date */
	Date *next;	/* pointer to next in list */
};

enum{
	Secondsperday = 24*60*60
};

Date *Base = nil;
Biobuf in;
int debug, matchyear;

void dates(Tm*);
void upper2lower(char*, char*, int);
void *emalloc(unsigned int);

void
usage(void)
{
	fprint(2, "usage: calendar [-dy] [-p days] [files ...]\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	int i, fd, ahead;
	long now;
	char *line;
	Tm *tm;
	Date *d;
	char buf[1024];

	ahead = 0;
	ARGBEGIN{
	case 'y':
		matchyear = 1;
		break;
	case 'd':
		debug = 1;
		break;
	case 'p':
		ahead = atoi(EARGF(usage()));
		break;
	default:
		usage();
	}ARGEND;

	/* make a list of dates */
	now = time(0);
	tm = localtime(now);
	dates(tm);
	now += Secondsperday;
	tm = localtime(now);
	dates(tm);
	if(tm-&gt;wday == 6){
		now += Secondsperday;
		tm = localtime(now);
		dates(tm);
	}
	if(tm-&gt;wday == 0){
		now += Secondsperday;
		tm = localtime(now);
		dates(tm);
	}
	if(ahead){
		now = time(0);
		now += ahead * Secondsperday;
		tm = localtime(now);
		dates(tm);
	}

	for(i=0; i&lt;argc || (i==0 &amp;&amp; argc==0); i++){
		if(i==0 &amp;&amp; argc==0)
			snprint(buf, sizeof buf,
				"/usr/%s/lib/calendar", getuser());
		else
			strecpy(buf, buf+sizeof buf, argv[i]);
		fd = open(buf, OREAD);
		if(fd&lt;0 || Binit(&amp;in, fd, OREAD)&lt;0){
			fprint(2, "calendar: can't open %s: %r\n", buf);
			exits("open");
		}

		/* go through the file */
		while(line = Brdline(&amp;in, '\n')){
			line[Blinelen(&amp;in) - 1] = 0;
			upper2lower(buf, line, sizeof buf);
			for(d=Base; d; d=d-&gt;next)
				if(regexec(d-&gt;p, buf, 0, 0)){
					print("%s\n", line);
					break;
				}
		}
		close(fd);
	}
	exits("");
}

char *months[] = 
{
	"january",
	"february",
	"march",
	"april",
	"may",
	"june",
	"july",
	"august",
	"september",
	"october",
	"november",
	"december"
};
char *nth[] = {
	"first", 
	"second",
	"third",
	"fourth",
	"fifth"
};
char *days[] = {
	"sunday",
	"monday",
	"tuesday",
	"wednesday",
	"thursday",
	"friday",
	"saturday"
};

/*
 * Generate two Date structures.  First has month followed by day;
 * second has day followed by month.  Link them into list after
 * last, and return the first.
 */
void
dates(Tm *tm)
{
	Date *nd;
	char mo[128], day[128], buf[128];

	if(utflen(days[tm-&gt;wday]) &gt; 3)
		snprint(day, sizeof day, "%3.3s(%s)?",
			days[tm-&gt;wday], days[tm-&gt;wday]+3);
	else
		snprint(day, sizeof day, "%3.3s", days[tm-&gt;wday]);

	if(utflen(months[tm-&gt;mon]) &gt; 3)
		snprint(mo, sizeof mo, "%3.3s(%s)?",
			months[tm-&gt;mon], months[tm-&gt;mon]+3);
	else
		snprint(mo, sizeof mo, "%3.3s", months[tm-&gt;mon]);
	if (matchyear)
		snprint(buf, sizeof buf,
			"^[\t ]*((%s( |\t)+)|(%d/))%d( |\t|$)(((%d|%d|%02d)( |\t|$))|[^0-9]|([0-9]+[^0-9 \t]))",
			mo, tm-&gt;mon+1, tm-&gt;mday, tm-&gt;year+1900, tm-&gt;year%100, tm-&gt;year%100);
	else
		snprint(buf, sizeof buf,
			"^[\t ]*((%s( |\t)+)|(%d/))%d( |\t|$)",
			mo, tm-&gt;mon+1, tm-&gt;mday);
	if(debug)
		print("%s\n", buf);

	nd = emalloc(sizeof(Date));
	nd-&gt;p = regcomp(buf);
	nd-&gt;next = Base;	
	Base = nd;

	if (matchyear)
		snprint(buf, sizeof buf,
			"^[\t ]*%d( |\t)+(%s)( |\t|$)(((%d|%d|%02d)( |\t|$))|[^0-9]|([0-9]+[^0-9 \t]))",
			tm-&gt;mday, mo, tm-&gt;year+1900, tm-&gt;year%100, tm-&gt;year%100);
	else
		snprint(buf, sizeof buf,
			"^[\t ]*%d( |\t)+(%s)( |\t|$)",
			tm-&gt;mday, mo);
	if(debug)
		print("%s\n", buf);
	nd = emalloc(sizeof(Date));
	nd-&gt;p = regcomp(buf);	
	nd-&gt;next = Base;	
	Base = nd;

	snprint(buf, sizeof buf, "^[\t ]*every[ \t]+%s", day);
	if(debug)
		print("%s\n", buf);
	nd = emalloc(sizeof(Date));
	nd-&gt;p = regcomp(buf);	
	nd-&gt;next = Base;	
	Base = nd;

	snprint(buf, sizeof buf, "[\t ]*the[\t ]+%s[\t ]+%s", nth[(tm-&gt;mday-1)/7], day);
	if(debug)
		print("%s\n", buf);
	nd = emalloc(sizeof(Date));
	nd-&gt;p = regcomp(buf);	
	nd-&gt;next = Base;	
	Base = nd;
}

/*
 * Copy 'from' to 'to', converting to lower case
 */
void
upper2lower(char *to, char *from, int len)
{
	while(--len&gt;0 &amp;&amp; *from!='\0')
		*to++ = tolower(*from++);
	*to = 0;
}

/*
 * Call malloc and check for errors
 */
void*
emalloc(unsigned int n)
{
	void *p;

	p = malloc(n);
	if(p == 0){
		fprint(2, "calendar: malloc failed: %r\n");
		exits("malloc");
	}
	return p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

