<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cc/pswt.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cc/pswt.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "gc.h"

int
swcmp(const void *a1, const void *a2)
{
	C1 *p1, *p2;

	p1 = (C1*)a1;
	p2 = (C1*)a2;
	if(p1-&gt;val &lt; p2-&gt;val)
		return -1;
	return p1-&gt;val &gt; p2-&gt;val;
}

void
doswit(Node *n)
{
	Case *c;
	C1 *q, *iq, *iqh, *iql;
	long def, nc, i, j, isv, nh;
	Prog *hsb;
	Node *vr[2];
	int dup;

	def = 0;
	nc = 0;
	isv = 0;
	for(c = cases; c-&gt;link != C; c = c-&gt;link) {
		if(c-&gt;def) {
			if(def)
				diag(n, "more than one default in switch");
			def = c-&gt;label;
			continue;
		}
		isv |= c-&gt;isv;
		nc++;
	}
	if(typev[n-&gt;type-&gt;etype])
		isv = 1;
	else if(isv){
		warn(n, "32-bit switch expression with 64-bit case constant");
		isv = 0;
	}

	iq = alloc(nc*sizeof(C1));
	q = iq;
	for(c = cases; c-&gt;link != C; c = c-&gt;link) {
		if(c-&gt;def)
			continue;
		if(c-&gt;isv &amp;&amp; !isv)
			continue;	/* can never match */
		q-&gt;label = c-&gt;label;
		if(isv)
			q-&gt;val = c-&gt;val;
		else
			q-&gt;val = (long)c-&gt;val;	/* cast ensures correct value for 32-bit switch on 64-bit architecture */
		q++;
	}
	qsort(iq, nc, sizeof(C1), swcmp);
	if(debug['K'])
	for(i=0; i&lt;nc; i++)
		print("case %2ld: = %.8llux\n", i, (vlong)iq[i].val);
	dup = 0;
	for(i=0; i&lt;nc-1; i++)
		if(iq[i].val == iq[i+1].val) {
			diag(n, "duplicate cases in switch %lld", (vlong)iq[i].val);
			dup = 1;
		}
	if(dup)
		return;
	if(def == 0) {
		def = breakpc;
		nbreak++;
	}
	if(!isv || ewidth[TIND] &gt; ewidth[TLONG] || n-&gt;op == OREGISTER) {
		swit1(iq, nc, def, n);
		return;
	}

	/*
	 * 64-bit case on 32-bit machine:
	 * switch on high-order words, and
	 * in each of those, switch on low-order words
	 */
	if(n-&gt;op != OREGPAIR)
		fatal(n, "internal: expected register pair");
	if(thechar == '8'){	/* TO DO: need an enquiry function */
		vr[0] = n-&gt;left;	/* low */
		vr[1] = n-&gt;right;	/* high */
	}else{
		vr[0] = n-&gt;right;
		vr[1] = n-&gt;left;
	}
	vr[0]-&gt;type = types[TLONG];
	vr[1]-&gt;type = types[TLONG];
	gbranch(OGOTO);
	hsb = p;
	iqh = alloc(nc*sizeof(C1));
	iql = alloc(nc*sizeof(C1));
	nh = 0;
	for(i=0; i&lt;nc;){
		iqh[nh].val = iq[i].val &gt;&gt; 32;
		q = iql;
		/* iq is sorted, so equal top halves are adjacent */
		for(j = i; j &lt; nc; j++){
			if((iq[j].val&gt;&gt;32) != iqh[nh].val)
				break;
			q-&gt;val = (long)iq[j].val;
			q-&gt;label = iq[j].label;
			q++;
		}
		qsort(iql,  q-iql, sizeof(C1), swcmp);
if(0){for(int k=0; k&lt;(q-iql); k++)print("nh=%ld k=%d h=%#llux l=%#llux lab=%ld\n", nh, k, (vlong)iqh[nh].val,  (vlong)iql[k].val, iql[k].label);}
		iqh[nh].label = pc;
		nh++;
		swit1(iql, q-iql, def, vr[0]);
		i = j;
	}
	patch(hsb, pc);
if(0){for(int k=0; k&lt;nh; k++)print("k*=%d h=%#llux lab=%ld\n", k, (vlong)iqh[k].val,  iqh[k].label);}
	swit1(iqh, nh, def, vr[1]);
}

void
casf(void)
{
	Case *c;

	c = alloc(sizeof(*c));
	c-&gt;link = cases;
	cases = c;
}

long
outlstring(TRune *s, long n)
{
	char buf[sizeof(TRune)];
	uint c;
	int i;
	long r;

	if(suppress)
		return nstring;
	while(nstring &amp; (sizeof(TRune)-1))
		outstring("", 1);
	r = nstring;
	while(n &gt; 0) {
		c = *s++;
		if(align(0, types[TCHAR], Aarg1)) {
			for(i = 0; i &lt; sizeof(TRune); i++)
				buf[i] = c&gt;&gt;(8*(sizeof(TRune) - i - 1));
		} else {
			for(i = 0; i &lt; sizeof(TRune); i++)
				buf[i] = c&gt;&gt;(8*i);
		}
		outstring(buf, sizeof(TRune));
		n -= sizeof(TRune);
	}
	return r;
}

void
nullwarn(Node *l, Node *r)
{
	warn(Z, "result of operation not used");
	if(l != Z)
		cgen(l, Z);
	if(r != Z)
		cgen(r, Z);
}

void
ieeedtod(Ieee *ieee, double native)
{
	double fr, ho, f;
	int exp;

	if(native &lt; 0) {
		ieeedtod(ieee, -native);
		ieee-&gt;h |= 0x80000000L;
		return;
	}
	if(native == 0) {
		ieee-&gt;l = 0;
		ieee-&gt;h = 0;
		return;
	}
	fr = frexp(native, &amp;exp);
	f = 2097152L;		/* shouldnt use fp constants here */
	fr = modf(fr*f, &amp;ho);
	ieee-&gt;h = ho;
	ieee-&gt;h &amp;= 0xfffffL;
	ieee-&gt;h |= (exp+1022L) &lt;&lt; 20;
	f = 65536L;
	fr = modf(fr*f, &amp;ho);
	ieee-&gt;l = ho;
	ieee-&gt;l &lt;&lt;= 16;
	ieee-&gt;l |= (long)(fr*f);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

