<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cdfs/buf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cdfs/buf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Buffered I/O on block devices.
 * Write buffering ignores offset.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;disk.h&gt;
#include "dat.h"
#include "fns.h"

Buf*
bopen(long (*fn)(Buf*, void*, long, ulong), int omode, int bs, int nblock)
{
	Buf *b;

	assert(omode == OREAD || OWRITE);
	assert(bs &gt; 0 &amp;&amp; nblock &gt; 0);
	assert(fn != nil);

	b = emalloc(sizeof(*b));
	b-&gt;data = emalloc(bs*nblock);
	b-&gt;ndata = 0;
	b-&gt;nblock = nblock;
	b-&gt;bs = bs;
	b-&gt;omode = omode;
	b-&gt;fn = fn;		/* function to read or write bs-byte blocks */

	return b;
}

long
bread(Buf *b, void *v, long n, vlong off)
{
	long m;
	vlong noff;

	assert(b-&gt;omode == OREAD);

	/* Refill buffer */
	if(b-&gt;off &gt; off || off &gt;= b-&gt;off+b-&gt;ndata) {
		noff = off - off % b-&gt;bs;
		if(vflag &gt; 1)
			fprint(2, "try refill at %lld...", noff);
		if((m = b-&gt;fn(b, b-&gt;data, b-&gt;nblock, noff/b-&gt;bs)) &lt;= 0) {
			if (vflag)
				fprint(2, "read failed: %r\n");
			return m;
		}
		b-&gt;ndata = b-&gt;bs * m;
		b-&gt;off = noff;
		if(vflag &gt; 1)
			fprint(2, "got %ld\n", b-&gt;ndata);
	}

//	fprint(2, "read %ld at %ld\n", n, off);
	/* Satisfy request from buffer */
	off -= b-&gt;off;
	if(n &gt; b-&gt;ndata - off)
		n = b-&gt;ndata - off;
	memmove(v, b-&gt;data+off, n);
	return n;
}

long
bwrite(Buf *b, void *v, long n)
{
	long on, m, mdata;
	uchar *p;

	p = v;
	on = n;

	/* Fill buffer */
	mdata = b-&gt;bs*b-&gt;nblock;
	m = mdata - b-&gt;ndata;
	if(m &gt; n)
		m = n;
	memmove(b-&gt;data+b-&gt;ndata, p, m);
	p += m;
	n -= m;
	b-&gt;ndata += m;

	/* Flush buffer */
	if(b-&gt;ndata == mdata) {
		if(b-&gt;fn(b, b-&gt;data, b-&gt;nblock, 0) &lt; 0) {
			if(vflag)
				fprint(2, "write fails: %r\n");
			return -1;
		}
		b-&gt;ndata = 0;
	}

	/* For now, don't worry about big writes; 9P only does 8k */
	assert(n &lt; mdata);

	/* Add remainder to buffer */
	if(n) {
		memmove(b-&gt;data, p, n);
		b-&gt;ndata = n;
	}

	return on;
}

void
bterm(Buf *b)
{
	/* DVD &amp; BD prefer full ecc blocks (tracks), but can cope with less */
	if(b-&gt;omode == OWRITE &amp;&amp; b-&gt;ndata)
		b-&gt;fn(b, b-&gt;data, (b-&gt;ndata + b-&gt;bs - 1)/b-&gt;bs, 0); 

	free(b-&gt;data);
	free(b);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

