<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cdfs/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cdfs/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* cdfs - CD, DVD and BD reader and writer file system */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;disk.h&gt;
#include "dat.h"
#include "fns.h"

typedef struct Aux Aux;
struct Aux {
	int	doff;
	Otrack	*o;
};

ulong	getnwa(Drive *);

static void checktoc(Drive*);

int vflag;

static Drive *drive;
static int nchange;

enum {
	Qdir = 0,
	Qctl = 1,
	Qwa = 2,
	Qwd = 3,
	Qtrack = 4,
};

char*
geterrstr(void)
{
	static char errbuf[ERRMAX];

	rerrstr(errbuf, sizeof errbuf);
	return errbuf;
}

void*
emalloc(ulong sz)
{
	void *v;

	v = mallocz(sz, 1);
	if(v == nil)
		sysfatal("malloc %lud fails", sz);
	return v;
}

static void
fsattach(Req *r)
{
	char *spec;

	spec = r-&gt;ifcall.aname;
	if(spec &amp;&amp; spec[0]) {
		respond(r, "invalid attach specifier");
		return;
	}

	checktoc(drive);
	r-&gt;fid-&gt;qid = (Qid){Qdir, drive-&gt;nchange, QTDIR};
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	r-&gt;fid-&gt;aux = emalloc(sizeof(Aux));
	respond(r, nil);
}

static char*
fsclone(Fid *old, Fid *new)
{
	Aux *na;

	na = emalloc(sizeof(Aux));
	*na = *((Aux*)old-&gt;aux);
	if(na-&gt;o)
		na-&gt;o-&gt;nref++;
	new-&gt;aux = na;
	return nil;
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i;

	checktoc(drive);
	switch((ulong)fid-&gt;qid.path) {
	case Qdir:
		if(strcmp(name, "..") == 0) {
			*qid = (Qid){Qdir, drive-&gt;nchange, QTDIR};
			return nil;
		}
		if(strcmp(name, "ctl") == 0) {
			*qid = (Qid){Qctl, 0, 0};
			return nil;
		}
		if(strcmp(name, "wa") == 0 &amp;&amp; drive-&gt;writeok &amp;&amp;
		    (drive-&gt;mmctype == Mmcnone ||
		     drive-&gt;mmctype == Mmccd)) {
			*qid = (Qid){Qwa, drive-&gt;nchange, QTDIR};
			return nil;
		}
		if(strcmp(name, "wd") == 0 &amp;&amp; drive-&gt;writeok) {
			*qid = (Qid){Qwd, drive-&gt;nchange, QTDIR};
			return nil;
		}
		for(i=0; i&lt;drive-&gt;ntrack; i++)
			if(strcmp(drive-&gt;track[i].name, name) == 0)
				break;
		if(i == drive-&gt;ntrack)
			return "file not found";
		*qid = (Qid){Qtrack+i, 0, 0};
		return nil;

	case Qwa:
	case Qwd:
		if(strcmp(name, "..") == 0) {
			*qid = (Qid){Qdir, drive-&gt;nchange, QTDIR};
			return nil;
		}
		return "file not found";
	default:	/* bug: lib9p could handle this */
		return "walk in non-directory";
	}
}

static void
fscreate(Req *r)
{
	int omode, type;
	Otrack *o;
	Fid *fid;

	fid = r-&gt;fid;
	omode = r-&gt;ifcall.mode;
	
	if(omode != OWRITE) {
		respond(r, "bad mode (use OWRITE)");
		return;
	}

	switch((ulong)fid-&gt;qid.path) {
	case Qdir:
	default:
		respond(r, "permission denied");
		return;

	case Qwa:
		if (drive-&gt;mmctype != Mmcnone &amp;&amp;
		    drive-&gt;mmctype != Mmccd) {
			respond(r, "audio supported only on cd");
			return;
		}
		type = TypeAudio;
		break;

	case Qwd:
		type = TypeData;
		break;
	}

	if((drive-&gt;cap &amp; Cwrite) == 0) {
		respond(r, "drive does not write");
		return;
	}

	o = drive-&gt;create(drive, type);
	if(o == nil) {
		respond(r, geterrstr());
		return;
	}
	drive-&gt;nchange = -1;
	checktoc(drive);	/* update directory info */
	o-&gt;nref = 1;
	((Aux*)fid-&gt;aux)-&gt;o = o;

	fid-&gt;qid = (Qid){Qtrack+(o-&gt;track - drive-&gt;track), drive-&gt;nchange, 0};
	r-&gt;ofcall.qid = fid-&gt;qid;
	respond(r, nil);
}

static void
fsremove(Req *r)
{
	switch((ulong)r-&gt;fid-&gt;qid.path){
	case Qwa:
	case Qwd:
		if(drive-&gt;fixate(drive) &lt; 0)
			respond(r, geterrstr());
// let us see if it can figure this out:	drive-&gt;writeok = No;	
		else
			respond(r, nil);
		checktoc(drive);
		break;
	default:
		respond(r, "permission denied");
		break;
	}
}

/* result is one word, so it can be used as a uid in Dir structs */
char *
disctype(Drive *drive)
{
	char *type, *rw, *laysfx;

	rw = laysfx = "";
	switch (drive-&gt;mmctype) {
	case Mmccd:
		type = "cd-";
		break;
	case Mmcdvdminus:
	case Mmcdvdplus:
		type = drive-&gt;dvdtype;
		break;
	case Mmcbd:
		type = "bd-";
		if (drive-&gt;laysfx)
			laysfx = drive-&gt;laysfx;
		break;
	case Mmcnone:
		type = "no-disc";
		break;
	default:
		type = "**GOK**";		/* traditional */
		break;
	}
	if (drive-&gt;mmctype != Mmcnone &amp;&amp; drive-&gt;dvdtype == nil)
		if (drive-&gt;erasable == Yes)
			rw = drive-&gt;mmctype == Mmcbd? "re": "rw";
		else if (drive-&gt;recordable == Yes)
			rw = "r";
		else
			rw = "rom";
	return smprint("%s%s%s", type, rw, laysfx);
}

int
fillstat(ulong qid, Dir *d)
{
	char *ty;
	Track *t;
	static char buf[32];

	nulldir(d);
	d-&gt;type = L'M';
	d-&gt;dev = 1;
	d-&gt;length = 0;
	ty = disctype(drive);
	strncpy(buf, ty, sizeof buf);
	free(ty);
	d-&gt;uid = d-&gt;gid = buf;
	d-&gt;muid = "";
	d-&gt;qid = (Qid){qid, drive-&gt;nchange, 0};
	d-&gt;atime = time(0);
	d-&gt;mtime = drive-&gt;changetime;

	switch(qid){
	case Qdir:
		d-&gt;name = "/";
		d-&gt;qid.type = QTDIR;
		d-&gt;mode = DMDIR|0777;
		break;

	case Qctl:
		d-&gt;name = "ctl";
		d-&gt;mode = 0666;
		break;

	case Qwa:
		if(drive-&gt;writeok == No ||
		    drive-&gt;mmctype != Mmcnone &amp;&amp;
		    drive-&gt;mmctype != Mmccd)
			return 0;
		d-&gt;name = "wa";
		d-&gt;qid.type = QTDIR;
		d-&gt;mode = DMDIR|0777;
		break;

	case Qwd:
		if(drive-&gt;writeok == No)
			return 0;
		d-&gt;name = "wd";
		d-&gt;qid.type = QTDIR;
		d-&gt;mode = DMDIR|0777;
		break;

	default:
		if(qid-Qtrack &gt;= drive-&gt;ntrack)
			return 0;
		t = &amp;drive-&gt;track[qid-Qtrack];
		if(strcmp(t-&gt;name, "") == 0)
			return 0;
		d-&gt;name = t-&gt;name;
		d-&gt;mode = t-&gt;mode;
		d-&gt;length = t-&gt;size;
		break;
	}
	return 1;
}

static ulong 
cddb_sum(int n)
{
	int ret;
	ret = 0;
	while(n &gt; 0) {
		ret += n%10;
		n /= 10;
	}
	return ret;
}

static ulong
diskid(Drive *d)
{
	int i, n;
	ulong tmp;
	Msf *ms, *me;

	n = 0;
	for(i=0; i &lt; d-&gt;ntrack; i++)
		n += cddb_sum(d-&gt;track[i].mbeg.m*60+d-&gt;track[i].mbeg.s);

	ms = &amp;d-&gt;track[0].mbeg;
	me = &amp;d-&gt;track[d-&gt;ntrack].mbeg;
	tmp = (me-&gt;m*60+me-&gt;s) - (ms-&gt;m*60+ms-&gt;s);

	/*
	 * the spec says n%0xFF rather than n&amp;0xFF.  it's unclear which is
	 * correct.  most CDs are in the database under both entries.
	 */
	return ((n % 0xFF) &lt;&lt; 24 | (tmp &lt;&lt; 8) | d-&gt;ntrack);
}

static void
readctl(Req *r)
{
	int i, isaudio;
	ulong nwa;
	char *p, *e, *ty;
	char s[1024];
	Msf *m;

	isaudio = 0;
	for(i=0; i&lt;drive-&gt;ntrack; i++)
		if(drive-&gt;track[i].type == TypeAudio)
			isaudio = 1;

	p = s;
	e = s + sizeof s;
	*p = '\0';
	if(isaudio){
		p = seprint(p, e, "aux/cddb query %8.8lux %d", diskid(drive),
			drive-&gt;ntrack);
		for(i=0; i&lt;drive-&gt;ntrack; i++){
			m = &amp;drive-&gt;track[i].mbeg;
			p = seprint(p, e, " %d", (m-&gt;m*60 + m-&gt;s)*75 + m-&gt;f);
		}
		m = &amp;drive-&gt;track[drive-&gt;ntrack].mbeg;
		p = seprint(p, e, " %d\n", m-&gt;m*60 + m-&gt;s);
	}

	if(drive-&gt;readspeed == drive-&gt;writespeed)
		p = seprint(p, e, "speed %d\n", drive-&gt;readspeed);
	else
		p = seprint(p, e, "speed read %d write %d\n",
			drive-&gt;readspeed, drive-&gt;writespeed);
	p = seprint(p, e, "maxspeed read %d write %d\n",
		drive-&gt;maxreadspeed, drive-&gt;maxwritespeed);

	if (drive-&gt;Scsi.changetime != 0 &amp;&amp; drive-&gt;ntrack != 0) { /* have disc? */
		ty = disctype(drive);
		p = seprint(p, e, "%s", ty);
		free(ty);
		if (drive-&gt;mmctype != Mmcnone) {
			nwa = getnwa(drive);
			p = seprint(p, e, " next writable sector ");
			if (nwa == ~0ul)
				p = seprint(p, e, "none; disc full");
			else
				p = seprint(p, e, "%lud", nwa);
		}
		seprint(p, e, "\n");
	}
	readstr(r, s);
}

static void
fsread(Req *r)
{
	int j, n, m;
	uchar *p, *ep;
	Dir d;
	Fid *fid;
	Otrack *o;
	vlong offset;
	void *buf;
	long count;
	Aux *a;

	fid = r-&gt;fid;
	offset = r-&gt;ifcall.offset;
	buf = r-&gt;ofcall.data;
	count = r-&gt;ifcall.count;

	switch((ulong)fid-&gt;qid.path) {
	case Qdir:
		checktoc(drive);
		p = buf;
		ep = p+count;
		m = Qtrack+drive-&gt;ntrack;
		a = fid-&gt;aux;
		if(offset == 0)
			a-&gt;doff = 1;	/* skip root */

		for(j=a-&gt;doff; j&lt;m; j++) {
			if(fillstat(j, &amp;d)) {
				if((n = convD2M(&amp;d, p, ep-p)) &lt;= BIT16SZ)
					break;
				p += n;
			}
		}
		a-&gt;doff = j;

		r-&gt;ofcall.count = p - (uchar*)buf;
		break;
	case Qwa:
	case Qwd:
		r-&gt;ofcall.count = 0;
		break;
	case Qctl:
		readctl(r);
		break;
	default:
		/* a disk track; we can only call read for whole blocks */
		o = ((Aux*)fid-&gt;aux)-&gt;o;
		if((count = o-&gt;drive-&gt;read(o, buf, count, offset)) &lt; 0) {
			respond(r, geterrstr());
			return;
		}
		r-&gt;ofcall.count = count;
		break;
	}
	respond(r, nil);
}

static char Ebadmsg[] = "bad cdfs control message";

static char*
writectl(void *v, long count)
{
	char buf[256];
	char *f[10], *p;
	int i, nf, n, r, w, what;

	if(count &gt;= sizeof(buf))
		count = sizeof(buf)-1;
	memmove(buf, v, count);
	buf[count] = '\0';

	nf = tokenize(buf, f, nelem(f));
	if(nf == 0)
		return Ebadmsg;

	if(strcmp(f[0], "speed") == 0){
		what = 0;
		r = w = -1;
		if(nf == 1)
			return Ebadmsg;
		for(i=1; i&lt;nf; i++){
			if(strcmp(f[i], "read") == 0 || strcmp(f[i], "write") == 0){
				if(what!=0 &amp;&amp; what!='?')
					return Ebadmsg;
				what = f[i][0];
			}else{
				if (strcmp(f[i], "best") == 0)
					n = (1&lt;&lt;16) - 1;
				else {
					n = strtol(f[i], &amp;p, 0);
					if(*p != '\0' || n &lt;= 0)
						return Ebadmsg;
				}
				switch(what){
				case 0:
					if(r &gt;= 0 || w &gt;= 0)
						return Ebadmsg;
					r = w = n;
					break;
				case 'r':
					if(r &gt;= 0)
						return Ebadmsg;
					r = n;
					break;
				case 'w':
					if(w &gt;= 0)
						return Ebadmsg;
					w = n;
					break;
				default:
					return Ebadmsg;
				}
				what = '?';
			}
		}
		if(what != '?')
			return Ebadmsg;
		return drive-&gt;setspeed(drive, r, w);
	}
	return drive-&gt;ctl(drive, nf, f);
}

static void
fswrite(Req *r)
{
	Otrack *o;
	Fid *fid;

	fid = r-&gt;fid;
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	if(fid-&gt;qid.path == Qctl) {
		respond(r, writectl(r-&gt;ifcall.data, r-&gt;ifcall.count));
		return;
	}

	if((o = ((Aux*)fid-&gt;aux)-&gt;o) == nil || o-&gt;omode != OWRITE) {
		respond(r, "permission denied");
		return;
	}

	if(o-&gt;drive-&gt;write(o, r-&gt;ifcall.data, r-&gt;ifcall.count) &lt; 0)
		respond(r, geterrstr());
	else
		respond(r, nil);
}

static void
fsstat(Req *r)
{
	fillstat((ulong)r-&gt;fid-&gt;qid.path, &amp;r-&gt;d);
	r-&gt;d.name = estrdup9p(r-&gt;d.name);
	r-&gt;d.uid = estrdup9p(r-&gt;d.uid);
	r-&gt;d.gid = estrdup9p(r-&gt;d.gid);
	r-&gt;d.muid = estrdup9p(r-&gt;d.muid);
	respond(r, nil);
}

static void
fsopen(Req *r)
{
	int omode;
	Fid *fid;
	Otrack *o;

	fid = r-&gt;fid;
	omode = r-&gt;ifcall.mode;
	checktoc(drive);
	r-&gt;ofcall.qid = (Qid){fid-&gt;qid.path, drive-&gt;nchange, fid-&gt;qid.vers};

	switch((ulong)fid-&gt;qid.path){
	case Qdir:
	case Qwa:
	case Qwd:
		if(omode != OREAD) {
			respond(r, "permission denied");
			return;
		}
		break;
	case Qctl:
		if(omode &amp; ~(OTRUNC|OREAD|OWRITE|ORDWR)) {
			respond(r, "permission denied");
			return;
		}
		break;
	default:
		if(fid-&gt;qid.path &gt;= Qtrack+drive-&gt;ntrack) {
			respond(r, "file no longer exists");
			return;
		}

		/*
		 * allow the open with OWRITE or ORDWR if the
		 * drive and disc are both capable?
		 */
		if(omode != OREAD ||
		    (o = drive-&gt;openrd(drive, fid-&gt;qid.path-Qtrack)) == nil) {
			respond(r, "permission denied");
			return;
		}

		o-&gt;nref = 1;
		((Aux*)fid-&gt;aux)-&gt;o = o;
		break;
	}
	respond(r, nil);
}

static void
fsdestroyfid(Fid *fid)
{
	Aux *aux;
	Otrack *o;

	aux = fid-&gt;aux;
	if(aux == nil)
		return;
	o = aux-&gt;o;
	if(o &amp;&amp; --o-&gt;nref == 0) {
		bterm(o-&gt;buf);
		drive-&gt;close(o);
		checktoc(drive);
	}
}

static void
checktoc(Drive *drive)
{
	int i;
	Track *t;

	drive-&gt;gettoc(drive);
	if(drive-&gt;nameok)
		return;

	for(i=0; i&lt;drive-&gt;ntrack; i++) {
		t = &amp;drive-&gt;track[i];
		if(t-&gt;size == 0)	/* being created */
			t-&gt;mode = 0;
		else
			t-&gt;mode = 0444;
		sprint(t-&gt;name, "?%.3d", i);
		switch(t-&gt;type){
		case TypeNone:
			t-&gt;name[0] = 'u';
//			t-&gt;mode = 0;
			break;
		case TypeData:
			t-&gt;name[0] = 'd';
			break;
		case TypeAudio:
			t-&gt;name[0] = 'a';
			break;
		case TypeBlank:
			t-&gt;name[0] = '\0';
			break;
		default:
			print("unknown track type %d\n", t-&gt;type);
			break;
		}
	}

	drive-&gt;nameok = 1;
}

long
bufread(Otrack *t, void *v, long n, vlong off)
{
	return bread(t-&gt;buf, v, n, off);
}

long
bufwrite(Otrack *t, void *v, long n)
{
	return bwrite(t-&gt;buf, v, n);
}

Srv fs = {
.attach=	fsattach,
.destroyfid=	fsdestroyfid,
.clone=		fsclone,
.walk1=		fswalk1,
.open=		fsopen,
.read=		fsread,
.write=		fswrite,
.create=	fscreate,
.remove=	fsremove,
.stat=		fsstat,
};

void
usage(void)
{
	fprint(2, "usage: cdfs [-Dv] [-d /dev/sdC0] [-m mtpt]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	Scsi *s;
	int fd;
	char *dev, *mtpt;

	dev = "/dev/sdD0";
	mtpt = "/mnt/cd";

	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 'd':
		dev = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 'v':
		if((fd = create("/tmp/cdfs.log", OWRITE, 0666)) &gt;= 0) {
			dup(fd, 2);
			dup(fd, 1);
			if(fd != 1 &amp;&amp; fd != 2)
				close(fd);
			vflag++;
			scsiverbose = 2; /* verbose but no Readtoc errs */
		} else
			fprint(2, "%s: can't open /tmp/cdfs.log: %r\n", argv0);
		break;
	default:
		usage();
	}ARGEND

	if(dev == nil || mtpt == nil || argc &gt; 0)
		usage();

	werrstr("");
	if((s = openscsi(dev)) == nil)
		sysfatal("openscsi '%s': %r", dev);
	if((drive = mmcprobe(s)) == nil)
		sysfatal("mmcprobe '%s': %r", dev);
	checktoc(drive);

	postmountsrv(&amp;fs, nil, mtpt, MREPL|MCREATE);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

