<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cec/cec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cec/cec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * cec — coraid ethernet console
 * Copyright © Coraid, Inc. 2006-2008.
 * All Rights Reserved.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;		/* really! */
#include &lt;ctype.h&gt;
#include "cec.h"

enum {
	Tinita		= 0,
	Tinitb,
	Tinitc,
	Tdata,
	Tack,
	Tdiscover,
	Toffer,
	Treset,

	Hdrsz		= 18,
	Eaddrlen	= 6,
};

typedef struct{
	uchar	ea[Eaddrlen];
	int	major;
	char	name[28];
} Shelf;

int 	conn(int);
void 	gettingkilled(int);
int 	pickone(void);
void 	probe(void);
void	sethdr(Pkt *, int);
int	shelfidx(void);

Shelf	*con;
Shelf	tab[1000];

char	*host;
char	*srv;
char	*svc;

char	pflag;

int	ntab;
int	shelf = -1;

uchar	bcast[] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
uchar	contag;
uchar 	esc = '';
uchar	ea[Eaddrlen];
uchar	unsetea[Eaddrlen];

extern 	int fd;		/* set in netopen */

void
post(char *srv, int fd)
{
	char buf[32];
	int f;

	if((f = create(srv, OWRITE, 0666)) == -1)
		sysfatal("create %s: %r", srv);
	snprint(buf, sizeof buf, "%d", fd);
	if(write(f, buf, strlen(buf)) != strlen(buf))
		sysfatal("write %s: %r", srv);
	close(f);
}

void
dosrv(char *s)
{
	int p[2];

	if(pipe(p) &lt; 0)
		sysfatal("pipe: %r");
	if (srv[0] != '/')
		svc = smprint("/srv/%s", s);
	else
		svc = smprint("%s", s);
	post(svc, p[0]);
	close(p[0]);
	dup(p[1], 0);
	dup(p[1], 1);

	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG)){
	case -1:
		sysfatal("fork: %r");
	case 0:
		break;
	default:
		exits("");
	}
	close(2);
}

void
usage(void)
{
	fprint(2, "usage: cec [-dp] [-c esc] [-e ea] [-h host] [-s shelf] "
		"[-S srv] interface\n");
	exits0("usage");
}

void
catch(void*, char *note)
{
	if(strcmp(note, "alarm") == 0)
		noted(NCONT);
	noted(NDFLT);
}

int
nilea(uchar *ea)
{
	return memcmp(ea, unsetea, Eaddrlen) == 0;
}

void
main(int argc, char **argv)
{
	int r, n;

	ARGBEGIN{
	case 'S':
		srv = EARGF(usage());
		break;
	case 'c':
		esc = tolower(*(EARGF(usage()))) - 'a' + 1;
		if(esc == 0 || esc &gt;= ' ')
			usage();
		break;
	case 'd':
		debug++;
		break;
	case 'e':
		if(parseether(ea, EARGF(usage())) == -1)
			usage();
		pflag = 1;
		break;
	case 'h':
		host = EARGF(usage());
		break;
	case 'p':
		pflag = 1;
		break;
	case 's':
		shelf = atoi(EARGF(usage()));
		break;
	default:
		usage();
	}ARGEND
	if(argc == 0)
		*argv = "/net/ether0";
	else if(argc != 1)
		usage();

	fmtinstall('E', eipfmt);
	if(srv != nil)
		dosrv(srv);
	r = netopen(*argv);
	if(r == -1){
		fprint(2, "cec: can't netopen %s\n", *argv);
		exits0("open");
	}
	notify(catch);
	probe();
	for(;;){
		n = 0;
		if(shelf == -1 &amp;&amp; host == 0 &amp;&amp; nilea(ea))
			n = pickone();
		rawon();
		conn(n);
		rawoff();
		if(pflag == 0){
			if(shelf != -1)
				exits0("shelf not found");
			if(host)
				exits0("host not found");
			if(!nilea(ea))
				exits0("ea not found");
		} else if(shelf != -1 || host || !nilea(ea))
			exits0("");
	}
}

void
timewait(int ms)
{
	alarm(ms);
}

int
didtimeout(void)
{
	char buf[ERRMAX];

	rerrstr(buf, sizeof buf);
	if(strcmp(buf, "interrupted") == 0){
		werrstr(buf, 0);
		return 1;
	}
	return 0;
}

ushort
htons(ushort h)
{
	ushort n;
	uchar *p;

	p = (uchar*)&amp;n;
	p[0] = h &gt;&gt; 8;
	p[1] = h;
	return n;
}

ushort
ntohs(int h)
{
	ushort n;
	uchar *p;

	n = h;
	p = (uchar*)&amp;n;
	return p[0] &lt;&lt; 8 | p[1];
}

int
tcmp(void *a, void *b)
{
	Shelf *s, *t;
	int d;

	s = a;
	t = b;
	d = s-&gt;major - t-&gt;major;
	if(d == 0)
		d = strcmp(s-&gt;name, t-&gt;name);
	if(d == 0)
		d = memcmp(s-&gt;ea, t-&gt;ea, Eaddrlen);
	return d;
}

void
probe(void)
{
	char *sh, *other;
	int n;
	Pkt q;
	Shelf *p;

	do {
		ntab = 0;
		memset(q.dst, 0xff, Eaddrlen);
		memset(q.src, 0, Eaddrlen);
		q.etype = htons(Etype);
		q.type = Tdiscover;
		q.len = 0;
		q.conn = 0;
		q.seq = 0;
		netsend(&amp;q, 60);
		timewait(Iowait);
		while((n = netget(&amp;q, sizeof q)) &gt;= 0){
			if((n &lt;= 0 &amp;&amp; didtimeout()) || ntab == nelem(tab))
				break;
			if(n &lt; 60 || q.len == 0 || q.type != Toffer)
				continue;
			q.data[q.len] = 0;
			sh = strtok((char *)q.data, " \t");
			if(sh == nil)
				continue;
			if(!nilea(ea) &amp;&amp; memcmp(ea, q.src, Eaddrlen) != 0)
				continue;
			if(shelf != -1 &amp;&amp; atoi(sh) != shelf)
				continue;
			other = strtok(nil, "\x1");
			if(other == 0)
				other = "";
			if(host &amp;&amp; strcmp(host, other) != 0)
				continue;
			p = tab + ntab++;
			memcpy(p-&gt;ea, q.src, Eaddrlen);
			p-&gt;major = atoi(sh);
			p-&gt;name[0] = 0;
			if(p-&gt;name)
				snprint(p-&gt;name, sizeof p-&gt;name, "%s", other);
		}
		alarm(0);
	} while (ntab == 0 &amp;&amp; pflag);
	if(ntab == 0){
		fprint(2, "none found.\n");
		exits0("none found");
	}
	qsort(tab, ntab, sizeof tab[0], tcmp);
}

void
showtable(void)
{
	int i;

	for(i = 0; i &lt; ntab; i++)
		print("%2d   %5d %E %s\n", i, tab[i].major, tab[i].ea, tab[i].name);
}

int
pickone(void)
{
	char buf[80];
	int n, i;

	for(;;){
		showtable();
		print("[#qp]: ");
		switch(n = read(0, buf, sizeof buf)){
		case 1:
			if(buf[0] == '\n')
				continue;
			/* fall through */
		case 2:
			if(buf[0] == 'p'){
				probe();
				break;
			}
			if(buf[0] == 'q')
				/* fall through */
		case 0:
		case -1:
				exits0(0);
			break;
		}
		if(isdigit(buf[0])){
			buf[n] = 0;
			i = atoi(buf);
			if(i &gt;= 0 &amp;&amp; i &lt; ntab)
				break;
		}
	}
	return i;
}

void
sethdr(Pkt *pp, int type)
{
	memmove(pp-&gt;dst, con-&gt;ea, Eaddrlen);
	memset(pp-&gt;src, 0, Eaddrlen);
	pp-&gt;etype = htons(Etype);
	pp-&gt;type = type;
	pp-&gt;len = 0;
	pp-&gt;conn = contag;
}

void
ethclose(void)
{
	static Pkt msg;

	sethdr(&amp;msg, Treset);
	timewait(Iowait);
	netsend(&amp;msg, 60);
	alarm(0);
	con = 0;
}

int
ethopen(void)
{
	Pkt tpk, rpk;
	int i, n;

	contag = (getpid() &gt;&gt; 8) ^ (getpid() &amp; 0xff);
	sethdr(&amp;tpk, Tinita);
	sethdr(&amp;rpk, 0);
	for(i = 0; i &lt; 3 &amp;&amp; rpk.type != Tinitb; i++){
		netsend(&amp;tpk, 60);
		timewait(Iowait);
		n = netget(&amp;rpk, 1000);
		alarm(0);
		if(n &lt; 0)
			return -1;
	}
	if(rpk.type != Tinitb)
		return -1;
	sethdr(&amp;tpk, Tinitc);
	netsend(&amp;tpk, 60);
	return 0;
}

char
escape(void)
{
	char buf[64];
	int r;

	for(;;){
		fprint(2, "&gt;&gt;&gt; ");
		buf[0] = '.';
		rawoff();
		r = read(0, buf, sizeof buf - 1);
		rawon();
		if(r == -1)
			exits0("kbd: %r");
		switch(buf[0]){
		case 'i':
		case 'q':
		case '.':
			return buf[0];
		}
		fprint(2, "	(q)uit, (i)nterrupt, (.)continue\n");
	}
}

/*
 * this is a bit too aggressive.  it really needs to replace only \n\r with \n.
 */
static uchar crbuf[256];

void
nocrwrite(int fd, uchar *buf, int n)
{
	int i, j, c;

	j = 0;
	for(i = 0; i &lt; n; i++)
		if((c = buf[i]) != '\r')
			crbuf[j++] = c;
	write(fd, crbuf, j);
}

int
doloop(void)
{
	int unacked, retries, set[2];
	uchar c, tseq, rseq;
	uchar ea[Eaddrlen];
	Pkt tpk, spk;
	Mux *m;

	memmove(ea, con-&gt;ea, Eaddrlen);
	retries = 0;
	unacked = 0;
	tseq = 0;
	rseq = -1;
	set[0] = 0;
	set[1] = fd;
top:
	if ((m = mux(set)) == 0)
		exits0("mux: %r");
	for (; ; )
		switch (muxread(m, &amp;spk)) {
		case -1:
			if (unacked == 0)
				break;
			if (retries-- == 0) {
				fprint(2, "Connection timed out\n");
				muxfree(m);
				return 0;
			}
			netsend(&amp;tpk, Hdrsz + unacked);
			break;
		case Fkbd:
			c = spk.data[0];
			if (c == esc) {
				muxfree(m);
				switch (escape()) {
				case 'q':
					tpk.len = 0;
					tpk.type = Treset;
					netsend(&amp;tpk, 60);
					return 0;
				case '.':
					goto top;
				case 'i':
					if ((m = mux(set)) == 0)
						exits0("mux: %r");
					break;
				}
			}
			sethdr(&amp;tpk, Tdata);
			memcpy(tpk.data, spk.data, spk.len);
			tpk.len = spk.len;
			tpk.seq = ++tseq;
			unacked = spk.len;
			retries = 2;
			netsend(&amp;tpk, Hdrsz + spk.len);
			break;
		case Fcec:
			if (memcmp(spk.src, ea, Eaddrlen) != 0 ||
			    ntohs(spk.etype) != Etype)
				continue;
			if (spk.type == Toffer &amp;&amp;
			    memcmp(spk.dst, bcast, Eaddrlen) != 0) {
				muxfree(m);
				return 1;
			}
			if (spk.conn != contag)
				continue;
			switch (spk.type) {
			case Tdata:
				if (spk.seq == rseq)
					break;
				nocrwrite(1, spk.data, spk.len);
				memmove(spk.dst, spk.src, Eaddrlen);
				memset(spk.src, 0, Eaddrlen);
				spk.type = Tack;
				spk.len = 0;
				rseq = spk.seq;
				netsend(&amp;spk, 60);
				break;
			case Tack:
				if (spk.seq == tseq)
					unacked = 0;
				break;
			case Treset:
				muxfree(m);
				return 1;
			}
			break;
		case Ffatal:
			muxfree(m);
			fprint(2, "kbd read error\n");
			exits0("fatal");
		}
}

int
conn(int n)
{
	int r;

	for(;;){
		if(con)
			ethclose();
		con = tab + n;
		if(ethopen() &lt; 0){
			fprint(2, "connection failed\n");
			return 0;
		}
		r = doloop();
		if(r &lt;= 0)
			return r;
	}
}

void
exits0(char *s)
{
	if(con != nil)
		ethclose();
	rawoff();
	if(svc != nil)
		remove(svc);
	exits(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

