<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cec/mux.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cec/mux.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "cec.h"

typedef struct {
	char	type;
	char	pad[3];
	Pkt	p;
} Muxmsg;

typedef struct {
	int	fd;
	int	type;
	int	pid;
} Muxproc;

struct Mux {
	Muxmsg	m;
	Muxproc	p[2];
	int	pfd[2];
	int	inuse;
};

static Mux smux = {
.inuse	= -1,
};

void
muxcec(int, int cfd)
{
	Muxmsg m;
	int l;

	m.type = Fcec;
	while((l = netget(&amp;m.p, sizeof m.p)) &gt; 0)
		if(write(cfd, &amp;m, l+4) != l+4)
			break;
	exits("");
}

void
muxkbd(int kfd, int cfd)
{
	Muxmsg m;

	m.type = Fkbd;
	while((m.p.len = read(kfd, m.p.data, sizeof m.p.data)) &gt; 0)
		if(write(cfd, &amp;m, m.p.len+22) != m.p.len+22)
			break;
	m.type = Ffatal;
	write(cfd, &amp;m, 4);
	exits("");
}

int
muxproc(Mux *m, Muxproc *p, int fd, void (*f)(int, int), int type)
{
	memset(p, 0, sizeof p);
	p-&gt;type = -1;
	switch(p-&gt;pid = rfork(RFPROC|RFFDG)){
	case -1:
		return -1;
	case 0:
		close(m-&gt;pfd[0]);
		f(fd, m-&gt;pfd[1]);
	default:
		p-&gt;fd = fd;
		p-&gt;type = type;
		return p-&gt;pid;
	}
}

void
muxfree(Mux *m)
{
	close(m-&gt;pfd[0]);
	close(m-&gt;pfd[1]);
	postnote(PNPROC, m-&gt;p[0].pid, "this note goes to 11");
	postnote(PNPROC, m-&gt;p[1].pid, "this note goes to 11");
	waitpid();
	waitpid();
	memset(m, 0, sizeof *m);
	m-&gt;inuse = -1;
}

Mux*
mux(int fd[2])
{
	Mux *m;

	if(smux.inuse != -1)
		sysfatal("mux in use");
	m = &amp;smux;
	m-&gt;inuse = 1;
	if(pipe(m-&gt;pfd) == -1)
		sysfatal("pipe: %r");
	muxproc(m, m-&gt;p+0, fd[0], muxkbd, Fkbd);
	muxproc(m, m-&gt;p+1, fd[1], muxcec, Fcec);
	close(m-&gt;pfd[1]);
	return m;
}

int
muxread(Mux *m, Pkt *p)
{
	if(read(m-&gt;pfd[0], &amp;m-&gt;m, sizeof m-&gt;m) == -1)
		return -1;
	memcpy(p, &amp;m-&gt;m.p, sizeof *p);
	return m-&gt;m.type;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

