<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cfs/file.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cfs/file.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "cformat.h"
#include "lru.h"
#include "bcache.h"
#include "disk.h"
#include "inode.h"
#include "file.h"

/*
 *  merge data with that which already exists in a block
 *
 *  we allow only one range per block, always use the new
 *  data if the ranges don't overlap.
 */
void
fmerge(Dptr *p, char *to, char *from, int start, int len)
{
	int end;

	end = start + len;
	memmove(to+start, from, end-start);

	/*
	 *  if ranges do not overlap...
	 */
	if(start&gt;p-&gt;end || p-&gt;start&gt;end){
		/*
		 *  just use the new data
		 */
		p-&gt;start = start;
		p-&gt;end = end;
	} else {
		/*
		 *  merge ranges
		 */
		if(start &lt; p-&gt;start)
			p-&gt;start = start;
		if(end &gt; p-&gt;end)
			p-&gt;end = end;
	}

}

/*
 *  write a block (or less) of data onto a disk, follow it with any necessary
 *  pointer writes.
 *
 *	N.B. ordering is everything
 */
int
fbwrite(Icache *ic, Ibuf *b, char *a, ulong off, int len)
{
	int wrinode;
	ulong fbno;
	Bbuf *dbb;	/* data block */
	Bbuf *ibb;	/* indirect block */
	Dptr *p;
	Dptr t;

	fbno = off / ic-&gt;bsize;
	p = &amp;b-&gt;inode.ptr;
	ibb = 0;
	wrinode = 0;

	/*
	 *  are there any pages for this inode?
	 */
	if(p-&gt;bno == Notabno){
		wrinode = 1;
		goto dowrite;
	}
	
	/*
 	 *  is it an indirect block?
	 */
	if(p-&gt;bno &amp; Indbno){
		ibb = bcread(ic, p-&gt;bno);
		if(ibb == 0)
			return -1;
		p = (Dptr*)ibb-&gt;data;
		p += fbno % ic-&gt;p2b;
		goto dowrite;
	}

	/*
 	 *  is it the wrong direct block?
	 */
	if((p-&gt;fbno%ic-&gt;p2b) != (fbno%ic-&gt;p2b)){
		/*
		 *  yes, make an indirect block
		 */
		t = *p;
		dpalloc(ic, p);
		if(p-&gt;bno == Notabno){
			*p = t;
			return -1;
		}
		ibb = bcalloc(ic, p-&gt;bno);
		if(ibb == 0){
			*p = t;
			return -1;
		}
		p = (Dptr*)ibb-&gt;data;
		p += t.fbno % ic-&gt;p2b;
		*p = t;
		p = (Dptr*)ibb-&gt;data;
		p += fbno % ic-&gt;p2b;
	}
	wrinode = 1;

dowrite:
	/*
	 *  get the data block into the block cache
	 */
	if(p-&gt;bno == Notabno){
		/*
		 *  create a new block
		 */
		dalloc(ic, p);
		if(p-&gt;bno == Notabno)
			return -1;		/* no blocks left (maybe) */
		dbb = bcalloc(ic, p-&gt;bno);
	} else {
		/*
		 *  use what's there
		 */
		dbb = bcread(ic, p-&gt;bno);
	}
	if(dbb == 0)
		return -1;

	/*
	 *  merge in the new data
	 */
	if(p-&gt;fbno != fbno){
		p-&gt;start = p-&gt;end = 0;
		p-&gt;fbno = fbno;
	}
	fmerge(p, dbb-&gt;data, a, off % ic-&gt;bsize, len);

	/*
	 *  write changed blocks back in the
	 *  correct order
	 */
	bcmark(ic, dbb);
	if(ibb)
		bcmark(ic, ibb);
	if(wrinode)
		if(iwrite(ic, b) &lt; 0)
			return -1;
	return len;
}

/*
 *  write `n' bytes to the cache
 *
 *  return number of bytes written
 */
long
fwrite(Icache *ic, Ibuf *b, char *a, ulong off, long n)
{
	int len;
	long sofar;

	for(sofar = 0; sofar &lt; n; sofar += len){
		len = ic-&gt;bsize - ((off+sofar)%ic-&gt;bsize);
		if(len &gt; n - sofar)
			len = n - sofar;
		if(fbwrite(ic, b, a+sofar, off+sofar, len) &lt; 0)
			return sofar;
	}
	return sofar;
}

/*
 *  get a pointer to the next valid data at or after `off'
 */
Dptr *
fpget(Icache *ic, Ibuf *b, ulong off)
{
	ulong fbno;
	long doff;
	Bbuf *ibb;	/* indirect block */
	Dptr *p, *p0, *pf;

	fbno = off / ic-&gt;bsize;
	p = &amp;b-&gt;inode.ptr;

	/*
	 *  are there any pages for this inode?
	 */
	if(p-&gt;bno == Notabno)
		return 0;
	
	/*
 	 *  if it's a direct block, life is easy?
	 */
	if(!(p-&gt;bno &amp; Indbno)){
		/*
		 *  a direct block, return p if it's at least past what we want
		 */
		if(p-&gt;fbno &gt; fbno)
			return p;
		if(p-&gt;fbno &lt; fbno)
			return 0;
		doff = off % ic-&gt;bsize;
		if(doff&gt;=p-&gt;start &amp;&amp; doff&lt;p-&gt;end)
			return p;
		else
			return 0;
	}

	/*
	 *  read the indirect block
	 */
	ibb = bcread(ic, p-&gt;bno);
	if(ibb == 0)
		return 0;

	/*
	 *  find the next valid pointer
	 */
	p0 = (Dptr*)ibb-&gt;data;
	pf = p0 + (fbno % ic-&gt;p2b);
	if(pf-&gt;bno!=Notabno &amp;&amp; pf-&gt;fbno==fbno){
		doff = off % ic-&gt;bsize;
		if(doff&lt;pf-&gt;end)
			return pf;
	}
	for(p = pf+1; p &lt; p0 + ic-&gt;p2b; p++){
		fbno++;
		if(p-&gt;fbno==fbno &amp;&amp; p-&gt;bno!=Notabno &amp;&amp; p-&gt;start&lt;p-&gt;end)
			return p;
	}
	for(p = p0; p &lt; pf; p++){
		fbno++;
		if(p-&gt;fbno==fbno &amp;&amp; p-&gt;bno!=Notabno &amp;&amp; p-&gt;start&lt;p-&gt;end)
			return p;
	}
	return 0;
}

/*
 *  read `n' bytes from the cache.
 *
 *  if we hit a gap and we've read something,
 *  return number of bytes read so far.
 *
 *  if we start with a gap, return minus the number of bytes
 *  to the next data.
 *
 *  if there are no bytes cached, return 0.
 */
long
fread(Icache *ic, Ibuf *b, char *a, ulong off, long n)
{
	int len, start;
	long sofar, gap;
	Dptr *p;
	Bbuf *bb;

	for(sofar = 0; sofar &lt; n; sofar += len, off += len){
		/*
		 *  get pointer to next data
		 */
		len = n - sofar;
		p = fpget(ic, b, off);

		/*
		 *  if no more data, return what we have so far
		 */
		if(p == 0)
			return sofar;

		/*
		 *  if there's a gap, return the size of the gap
		 */
		gap = (ic-&gt;bsize*p-&gt;fbno + p-&gt;start) - off;
		if(gap&gt;0)
			if(sofar == 0)
				return -gap;
			else
				return sofar;

		/*
		 *  return what we have
		 */
		bb = bcread(ic, p-&gt;bno);
		if(bb == 0)
			return sofar;
		start = p-&gt;start - gap;
		if(p-&gt;end - start &lt; len)
			len = p-&gt;end - start;
		memmove(a + sofar, bb-&gt;data + start, len);
	}
	return sofar;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

