<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/doserrstr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/doserrstr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

/*
 * This file is derrived from nterr.h in the samba distribution
 */

/*
   Unix SMB/CIFS implementation.
   DOS error code constants
   Copyright (C) Andrew Tridgell              1992-2000
   Copyright (C) John H Terpstra              1996-2000
   Copyright (C) Luke Kenneth Casson Leighton 1996-2000
   Copyright (C) Paul Ashton                  1998-2000

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


static struct {
	int	err;
	char	*msg;
} DOSerrs[] = {
	/* smb x/open error codes for the errdos error class */
	{ (0&lt;&lt;16)|1,	"no error" },
	{ (1&lt;&lt;16)|1,	"invalid function" },
	{ (2&lt;&lt;16)|1,	"file not found" },
	{ (3&lt;&lt;16)|1,	"directory not found" },
	{ (4&lt;&lt;16)|1,	"too many open files" },
	{ (5&lt;&lt;16)|1,	"access denied" },
	{ (6&lt;&lt;16)|1,	"invalid fid" },
	{ (7&lt;&lt;16)|1,	"memory control blocks destroyed." },
	{ (8&lt;&lt;16)|1,	"out of memory" },
	{ (9&lt;&lt;16)|1,	"invalid memory block address" },
	{ (10&lt;&lt;16)|1,	"invalid environment" },
	{ (12&lt;&lt;16)|1,	"invalid open mode" },
	{ (13&lt;&lt;16)|1,	"invalid data (only from ioctl call)" },
	{ (14&lt;&lt;16)|1,	"reserved" },
	{ (15&lt;&lt;16)|1,	"invalid drive" },
	{ (16&lt;&lt;16)|1,	"attempt to delete current directory" },
	{ (17&lt;&lt;16)|1,	"rename/move across filesystems" },
	{ (18&lt;&lt;16)|1,	"no more files found" },
	{ (31&lt;&lt;16)|1,	"general failure" },
	{ (32&lt;&lt;16)|1,	"share mode conflict with open mode" },
	{ (33&lt;&lt;16)|1,	"lock conflicts" },
	{ (50&lt;&lt;16)|1,	"request unsupported" },
	{ (64&lt;&lt;16)|1,	"network name not available" },
	{ (66&lt;&lt;16)|1,	"ipc unsupported (guess)" },
	{ (67&lt;&lt;16)|1,	"invalid share name" },
	{ (80&lt;&lt;16)|1,	"file already exists" },
	{ (87&lt;&lt;16)|1,	"invalid paramater" },
	{ (110&lt;&lt;16)|1,	"cannot open" },
	{ (122&lt;&lt;16)|1,  "insufficent buffer" },
	{ (123&lt;&lt;16)|1,	"invalid name" },
	{ (124&lt;&lt;16)|1,	"unknown level" },
	{ (158&lt;&lt;16)|1,	"this region already locked" },

	{ (183&lt;&lt;16)|1,	"rename failed" },

	{ (230&lt;&lt;16)|1,	"named pipe invalid" },
	{ (231&lt;&lt;16)|1,	"pipe busy" },
	{ (232&lt;&lt;16)|1,	"close in progress" },
	{ (233&lt;&lt;16)|1,	"no reader of named pipe" },
	{ (234&lt;&lt;16)|1,	"more data to be returned" },
	{ (259&lt;&lt;16)|1,	"no more items" },
	{ (267&lt;&lt;16)|1,	"invalid directory name in a path" },
	{ (282&lt;&lt;16)|1,	"extended attributes" },
	{ (1326&lt;&lt;16)|1,	"authentication failed" },
	{ (2123&lt;&lt;16)|1,	"buffer too small" },
	{ (2142&lt;&lt;16)|1,	"unknown ipc" },
	{ (2151&lt;&lt;16)|1,	"no such print job" },
	{ (2455&lt;&lt;16)|1,	"invalid group" },

	/* Error codes for the ERRSRV class */
	{ (1&lt;&lt;16)|2,	"non specific error" },
	{ (2&lt;&lt;16)|2,	"bad password" },
	{ (3&lt;&lt;16)|2,	"reserved" },
	{ (4&lt;&lt;16)|2,	"permission denied" },
	{ (5&lt;&lt;16)|2,	"tid invalid" },
	{ (6&lt;&lt;16)|2,	"invalid server name" },
	{ (7&lt;&lt;16)|2,	"invalid device" },
	{ (22&lt;&lt;16)|2,	"unknown smb" },
	{ (49&lt;&lt;16)|2,	"print queue full" },
	{ (50&lt;&lt;16)|2,	"queued item too big" },
	{ (52&lt;&lt;16)|2,	"fid invalid in print file" },
	{ (64&lt;&lt;16)|2,	"unrecognised command" },
	{ (65&lt;&lt;16)|2,	"smb server internal error" },
	{ (67&lt;&lt;16)|2,	"fid/pathname invalid" },
	{ (68&lt;&lt;16)|2,	"reserved 68" },
	{ (69&lt;&lt;16)|2,	"access is invalid" },
	{ (70&lt;&lt;16)|2,	"reserved 70" },
	{ (71&lt;&lt;16)|2,	"attribute mode invalid" },
	{ (81&lt;&lt;16)|2,	"message server paused" },
	{ (82&lt;&lt;16)|2,	"not receiving messages" },
	{ (83&lt;&lt;16)|2,	"no room for message" },
	{ (87&lt;&lt;16)|2,	"too many remote usernames" },
	{ (88&lt;&lt;16)|2,	"operation timed out" },
	{ (89&lt;&lt;16)|2,	"no resources" },
	{ (90&lt;&lt;16)|2,	"too many userids" },
	{ (91&lt;&lt;16)|2,	"bad userid" },
	{ (250&lt;&lt;16)|2,	"retry with mpx mode" },
	{ (251&lt;&lt;16)|2,	"retry with standard mode" },
	{ (252&lt;&lt;16)|2,	"resume mpx mode" },
	{ (0xffff&lt;&lt;16)|2, "function not supported" },

	/* Error codes for the ERRHRD class */
	{ (19&lt;&lt;16)|3,	"read only media" },
	{ (20&lt;&lt;16)|3,	"unknown device" },
	{ (21&lt;&lt;16)|3,	"drive not ready" },
	{ (22&lt;&lt;16)|3,	"unknown command" },
	{ (23&lt;&lt;16)|3,	"data (CRC) error" },
	{ (24&lt;&lt;16)|3,	"bad request length" },
	{ (25&lt;&lt;16)|3,	"seek failed" },
	{ (26&lt;&lt;16)|3,	"bad media" },
	{ (27&lt;&lt;16)|3,	"bad sector" },
	{ (28&lt;&lt;16)|3,	"no paper" },
	{ (29&lt;&lt;16)|3,	"write fault" },
	{ (30&lt;&lt;16)|3,	"read fault" },
	{ (31&lt;&lt;16)|3,	"general hardware failure" },
	{ (34&lt;&lt;16)|3,	"wrong disk" },
	{ (35&lt;&lt;16)|3,	"FCB unavailable" },
	{ (36&lt;&lt;16)|3,	"share buffer exceeded" },
	{ (39&lt;&lt;16)|3,	"disk full" },

};

char *
doserrstr(uint err)
{
	int i, match;
	char *class;
	static char buf[0xff];

	switch(err &amp; 0xff){
 	case 1:
		class = "dos";
		break;
	case 2:
		class = "network";
		break;
	case 3:
		class = "hardware";
		break;
	case 4:
		class = "Xos";
		break;
	case 0xe1:
		class = "mx1";
		break;
	case 0xe2:
		class = "mx2";
		break;
	case 0xe3:
		class = "mx3";
		break;
	case 0xff:
		class = "packet";
		break;
	default:
		class = "unknown";
		break;
	}

	match = -1;
	for(i = 0; i &lt; nelem(DOSerrs); i++)
		if(DOSerrs[i].err == err)
			match = i;

	if(match != -1)
		snprint(buf, sizeof(buf), "%s, %s", class, DOSerrs[match].msg);
	else
		snprint(buf, sizeof(buf), "%s, %ud/0x%ux - unknown error",
			class, err &gt;&gt; 16, err &gt;&gt; 16);
	return buf;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

