<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/info.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/info.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "cifs.h"


struct {
	char	*name;
	int	(*func)(Fmt *f);
	char	*buf;
	int	len;
} Infdir[] = {
	{ "Users",	userinfo },	
	{ "Groups",	groupinfo },	
	{ "Shares",	shareinfo },	
	{ "Connection",	conninfo },	
	{ "Sessions",	sessioninfo },	
	{ "Dfsroot",	dfsrootinfo },	
	{ "Dfscache",	dfscacheinfo },	
	{ "Domains",	domaininfo },	
	{ "Openfiles",	openfileinfo },	
	{ "Workstations", workstationinfo },	
	{ "Filetable",	filetableinfo },	
};

int
walkinfo(char *name)
{
	int i;

	for(i = 0; i &lt; nelem(Infdir); i++)
		if(strcmp(Infdir[i].name, name) == 0)
			return(i);
	return -1;
}

int
numinfo(void)
{
	return nelem(Infdir);
}

int
dirgeninfo(int slot, Dir *d)
{
	if(slot &lt; 0 || slot &gt; nelem(Infdir))
		return -1;

	memset(d, 0, sizeof(Dir));
	d-&gt;type = 'N';
	d-&gt;dev = 99;
	d-&gt;name = estrdup9p(Infdir[slot].name);
	d-&gt;uid = estrdup9p("other");
	d-&gt;muid = estrdup9p("other");
	d-&gt;gid = estrdup9p("other");
	d-&gt;mode = 0666;
	d-&gt;atime = time(0);
	d-&gt;mtime = d-&gt;atime;
	d-&gt;qid = mkqid(Infdir[slot].name, 0, 1, Pinfo, slot);
	d-&gt;qid.vers = 1;
	d-&gt;qid.path = slot;
	d-&gt;qid.type = 0;
	return 0;
}

int
makeinfo(int path)
{
	Fmt f;

	if(path &lt; 0 || path &gt; nelem(Infdir))
		return -1;
	if(Infdir[path].buf != nil)
		return 0;
	fmtstrinit(&amp;f);
	if((*Infdir[path].func)(&amp;f) == -1l)
		return -1;
	Infdir[path].buf = fmtstrflush(&amp;f);
	Infdir[path].len = strlen(Infdir[path].buf);
	return 0;
}

int
readinfo(int path, char *buf, int len, int off)
{
	if(path &lt; 0 || path &gt; nelem(Infdir))
		return -1;
	if(off &gt; Infdir[path].len)
		return 0;
	if(len + off &gt; Infdir[path].len)
		len = Infdir[path].len - off;
	memmove(buf, Infdir[path].buf + off, len);
	return len;
}

void
freeinfo(int path)
{
	if(path &lt; 0 || path &gt; nelem(Infdir))
		return;
	free(Infdir[path].buf);
	Infdir[path].buf = nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

