<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;libsec.h&gt;
#include &lt;9p.h&gt;
#include "cifs.h"

#define max(a,b)	(((a) &gt; (b))? (a): (b))
#define min(a,b)	(((a) &lt; (b))? (a): (b))

typedef struct Aux Aux;
struct Aux {
	Aux	*next;
	Aux	*prev;
	char	*path;		/* full path fo file */
	Share	*sp;		/* this share's info */
	long	expire;		/* expiration time of cache */
	long	off;		/* file pos of start of cache */
	long	end;		/* file pos of end of cache */
	char	*cache;
	int	fh;		/* file handle */
	int	sh;		/* search handle */
	long	srch;		/* find first's internal state */
};

extern int chatty9p;

int Checkcase = 1;		/* enforce case significance on filenames */
int Dfstout = 100;		/* timeout (in ms) for ping of dfs servers (assume they are local)  */
int Billtrog = 1;		/* enable file owner/group resolution */
int Attachpid;			/* pid of proc that attaches (ugh !) */
char *Debug = nil;		/* messages */
Qid Root;			/* root of remote system */
Share Ipc;			/* Share info of IPC$ share */
Session *Sess;			/* current session */
int Active = IDLE_TIME;		/* secs until next keepalive is sent */
static int Keeppid;		/* process ID of keepalive thread */
Share Shares[MAX_SHARES]; 	/* table of connected shares */
int Nshares = 0;		/* number of Shares connected */
Aux *Auxroot = nil;		/* linked list of Aux structs */
char *Host = nil;		/* host we are connected to */

static char *Ipcname = "IPC$";

#define ptype(x)	(((x) &amp; 0xf))
#define pindex(x)	(((x) &amp; 0xff0) &gt;&gt; 4)

void
setup(void)
{
	int fd;
	char buf[32];

	/*
	 * This is revolting but I cannot see any other way to get
	 * the pid of the server.  We need this as Windows doesn't
	 * drop the TCP connection when it closes a connection.
	 * Thus we keepalive() to detect when/if we are thrown off.
	 */
	Attachpid = getpid();

	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OWRITE)) &gt;= 0){
		fprint(fd, "%s network", Host);
		close(fd);
	}
}

int
filetableinfo(Fmt *f)
{
	Aux *ap;
	char *type;

	if((ap = Auxroot) != nil)
		do{
			type = "walked";
			if(ap-&gt;sh != -1)
				type = "opendir";
			if(ap-&gt;fh != -1)
				type = "openfile";
			fmtprint(f, "%-9s %s\n", type, ap-&gt;path);
			ap = ap-&gt;next;
		}while(ap != Auxroot);
	return 0;
}

Qid
mkqid(char *s, int is_dir, long vers, int subtype, long path)
{
	Qid q;
	union {				/* align digest suitably */
		uchar	digest[SHA1dlen];
		uvlong	uvl;
	} u;

	sha1((uchar *)s, strlen(s), u.digest, nil);
	q.type = (is_dir)? QTDIR: 0;
	q.vers = vers;
	if(subtype){
		q.path = *((uvlong *)u.digest) &amp; ~0xfffL;
		q.path |= ((path &amp; 0xff) &lt;&lt; 4);
		q.path |= (subtype &amp; 0xf);
	}
	else
		q.path = *((uvlong *)u.digest) &amp; ~0xfL;
	return q;
}

/*
 * used only for root dir and shares
 */
static void
V2D(Dir *d, Qid qid, char *name)
{
	memset(d, 0, sizeof(Dir));
	d-&gt;type = 'C';
	d-&gt;dev = 1;
	d-&gt;name = estrdup9p(name);
	d-&gt;uid = estrdup9p("bill");
	d-&gt;muid = estrdup9p("boyd");
	d-&gt;gid = estrdup9p("trog");
	d-&gt;mode = 0755 | DMDIR;
	d-&gt;atime = time(nil);
	d-&gt;mtime = d-&gt;atime;
	d-&gt;length = 0;
	d-&gt;qid = qid;
}

static void
I2D(Dir *d, Share *sp, char *path, FInfo *fi)
{
	char *name;

	if((name = strrchr(fi-&gt;name, '\\')) != nil)
		name++;
	else
		name = fi-&gt;name;
	d-&gt;name = estrdup9p(name);
	d-&gt;type = 'C';
	d-&gt;dev = sp-&gt;tid;
	d-&gt;uid = estrdup9p("bill");
	d-&gt;gid = estrdup9p("trog");
	d-&gt;muid = estrdup9p("boyd");
	d-&gt;atime = fi-&gt;accessed;
	d-&gt;mtime = fi-&gt;written;

	if(fi-&gt;attribs &amp; ATTR_READONLY)
		d-&gt;mode = 0444;
	else
		d-&gt;mode = 0666;

	d-&gt;length = fi-&gt;size;
	d-&gt;qid = mkqid(path, fi-&gt;attribs &amp; ATTR_DIRECTORY, fi-&gt;changed, 0, 0);

	if(fi-&gt;attribs &amp; ATTR_DIRECTORY){
		d-&gt;length = 0;
		d-&gt;mode |= DMDIR|0111;
	}
}

static void
responderrstr(Req *r)
{
	char e[ERRMAX];

	*e = 0;
	rerrstr(e, sizeof e);
	respond(r, e);
}

static char *
newpath(char *path, char *name)
{
	char *p, *q;

	assert((p = strrchr(path, '/')) != nil);

	if(strcmp(name, "..") == 0){
		if(p == path)
			return estrdup9p("/");
		q = emalloc9p((p-path)+1);
		strecpy(q, q+(p-path)+1, path);
		return q;
	}
	if(strcmp(path, "/") == 0)
		return smprint("/%s", name);
	return smprint("%s/%s", path, name);
}

static int
dirgen(int slot, Dir *d, void *aux)
{
	long off;
	FInfo *fi;
	int rc, got;
	Aux *a = aux;
	char *npath;
	int numinf = numinfo();
	int slots = min(Sess-&gt;mtu, MTU) / sizeof(FInfo);

	if(strcmp(a-&gt;path, "/") == 0){
		if(slot &lt; numinf){
			dirgeninfo(slot, d);
			return 0;
		} else
			slot -= numinf;

		if(slot &gt;= Nshares)
			return -1;
		V2D(d, mkqid(Shares[slot].name, 1, 1, Pshare, slot),
			Shares[slot].name);
		return 0;
	}

	off = slot * sizeof(FInfo);
	if(off &gt;= a-&gt;off &amp;&amp; off &lt; a-&gt;end &amp;&amp; time(nil) &lt; a-&gt;expire)
		goto from_cache;

	if(off == 0){
		fi = (FInfo *)a-&gt;cache;
		npath = smprint("%s/*", mapfile(a-&gt;path));
		a-&gt;sh = T2findfirst(Sess, a-&gt;sp, slots, npath, &amp;got, &amp;a-&gt;srch,
			(FInfo *)a-&gt;cache);
		free(npath);
		if(a-&gt;sh == -1)
			return -1;

		a-&gt;off = 0;
		a-&gt;end = got * sizeof(FInfo);

		if(got &gt;= 2 &amp;&amp; strcmp(fi[0].name, ".") == 0 &amp;&amp;
		    strcmp(fi[1].name, "..") == 0){
			a-&gt;end = (got - 2) * sizeof(FInfo);
			memmove(a-&gt;cache, a-&gt;cache + sizeof(FInfo)*2,
				a-&gt;end - a-&gt;off);
		}
	}

	while(off &gt;= a-&gt;end &amp;&amp; a-&gt;sh != -1){
		fi = (FInfo *)(a-&gt;cache + (a-&gt;end - a-&gt;off) - sizeof(FInfo));
		a-&gt;off = a-&gt;end;
		npath = smprint("%s/%s", mapfile(a-&gt;path), fi-&gt;name);
		rc = T2findnext(Sess, a-&gt;sp, slots, npath,
			&amp;got, &amp;a-&gt;srch, (FInfo *)a-&gt;cache, a-&gt;sh);
		free(npath);
		if(rc == -1 || got == 0)
			break;
		a-&gt;end = a-&gt;off + got * sizeof(FInfo);
	}
	a-&gt;expire = time(nil) + CACHETIME;

	if(got &lt; slots){
		if(a-&gt;sh != -1)
			CIFSfindclose2(Sess, a-&gt;sp, a-&gt;sh);
		a-&gt;sh = -1;
	}

	if(off &gt;= a-&gt;end)
		return -1;

from_cache:
	fi = (FInfo *)(a-&gt;cache + (off - a-&gt;off));
	npath = smprint("%s/%s", mapfile(a-&gt;path), fi-&gt;name);
	I2D(d, a-&gt;sp, npath, fi);
	if(Billtrog == 0)
		upd_names(Sess, a-&gt;sp, npath, d);
	free(npath);
	return 0;
}

static void
fsattach(Req *r)
{
	Aux *a;
	static int first = 1;
	char *spec = r-&gt;ifcall.aname;

	if(first)
		setup();

	if(spec &amp;&amp; *spec){
		respond(r, "invalid attach specifier");
		return;
	}

	r-&gt;ofcall.qid = mkqid("/", 1, 1, Proot, 0);
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;

	a = r-&gt;fid-&gt;aux = emalloc9p(sizeof(Aux));
	memset(a, 0, sizeof(Aux));
	a-&gt;path = estrdup9p("/");
	a-&gt;sp = nil;
	a-&gt;fh = -1;
	a-&gt;sh = -1;

	if(Auxroot){
		a-&gt;prev = Auxroot;
		a-&gt;next = Auxroot-&gt;next;
		Auxroot-&gt;next-&gt;prev = a;
		Auxroot-&gt;next = a;
	} else {
		Auxroot = a;
		a-&gt;next = a;
		a-&gt;prev = a;
	}
	respond(r, nil);
}

static char*
fsclone(Fid *ofid, Fid *fid)
{
	Aux *oa = ofid-&gt;aux;
	Aux *a = emalloc9p(sizeof(Aux));

	fid-&gt;aux = a;

	memset(a, 0, sizeof(Aux));
	a-&gt;sh = -1;
	a-&gt;fh = -1;
	a-&gt;sp = oa-&gt;sp;
	a-&gt;path = estrdup9p(oa-&gt;path);

	if(Auxroot){
		a-&gt;prev = Auxroot;
		a-&gt;next = Auxroot-&gt;next;
		Auxroot-&gt;next-&gt;prev = a;
		Auxroot-&gt;next = a;
	} else {
		Auxroot = a;
		a-&gt;next = a;
		a-&gt;prev = a;
	}
	return nil;
}

/*
 * for some weird reason T2queryall() returns share names
 * in lower case so we have to do an extra test against
 * our share table to validate filename case.
 *
 * on top of this here (snell &amp; Wilcox) most of our
 * redirections point to a share of the same name,
 * but some do not, thus the tail of the filename
 * returned by T2queryall() is not the same as
 * the name we wanted.
 *
 * We work around this by not validating the names
 * or files which resolve to share names as they must
 * be correct, having been enforced in the dfs layer.
 */
static int
validfile(char *found, char *want, char *winpath, Share *sp)
{
	char *share;

	if(strcmp(want, "..") == 0)
		return 1;
	if(strcmp(winpath, "/") == 0){
		share = trimshare(sp-&gt;name);
		if(cistrcmp(want, share) == 0)
			return strcmp(want, share) == 0;
		/*
		 * OK, a DFS redirection points us from a directory XXX
		 * to a share named YYY.  There is no case checking we can
		 * do so we allow either case - it's all we can do.
		 */
		return 1;
	}
	if(cistrcmp(found, want) != 0)
		return 0;
	if(!Checkcase)
		return 1;
	if(strcmp(found, want) == 0)
		return 1;
	return 0;
}


static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	FInfo fi;
	int rc, n, i;
	Aux *a = fid-&gt;aux;
	static char e[ERRMAX];
	char *p, *npath, *winpath;

	*e = 0;
	npath = newpath(a-&gt;path, name);
	if(strcmp(npath, "/") == 0){			/* root dir */
		*qid = mkqid("/", 1, 1, Proot, 0);
		free(a-&gt;path);
		a-&gt;path = npath;
		fid-&gt;qid = *qid;
		return nil;
	}

	if(strrchr(npath, '/') == npath){		/* top level dir */
		if((n = walkinfo(name)) != -1){		/* info file */
			*qid = mkqid(npath, 0, 1, Pinfo, n);
		}
		else {					/* volume name */
			for(i = 0; i &lt; Nshares; i++){
				n = strlen(Shares[i].name);
				if(cistrncmp(npath+1, Shares[i].name, n) != 0)
					continue;
				if(Checkcase &amp;&amp; strncmp(npath+1, Shares[i].name, n) != 0)
					continue;
				if(npath[n+1] != 0 &amp;&amp; npath[n+1] != '/')
					continue;
				break;
			}
			if(i &gt;= Nshares){
				free(npath);
				return "not found";
			}
			a-&gt;sp = Shares+i;
			*qid = mkqid(npath, 1, 1, Pshare, i);
		}
		free(a-&gt;path);
		a-&gt;path = npath;
		fid-&gt;qid = *qid;
		return nil;
	}

	/* must be a vanilla file or directory */
again:
	if(mapshare(npath, &amp;a-&gt;sp) == -1){
		rerrstr(e, sizeof(e));
		free(npath);
		return e;
	}

	winpath = mapfile(npath);
	memset(&amp;fi, 0, sizeof fi);
	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = T2queryall(Sess, a-&gt;sp, winpath, &amp;fi);
	else
		rc = T2querystandard(Sess, a-&gt;sp, winpath, &amp;fi);

	if(rc == -1){
		rerrstr(e, sizeof(e));
		free(npath);
		return e;
	}

	if((a-&gt;sp-&gt;options &amp; SMB_SHARE_IS_IN_DFS) != 0 &amp;&amp;
	    (fi.attribs &amp; ATTR_REPARSE) != 0){
		if(redirect(Sess, a-&gt;sp, npath) != -1)
			goto again;
	}

	if((p = strrchr(fi.name, '/')) == nil &amp;&amp; (p = strrchr(fi.name, '\\')) == nil)
		p = fi.name;
	else
		p++;

	if(! validfile(p, name, winpath, a-&gt;sp)){
		free(npath);
		return "not found";

	}
	*qid = mkqid(npath, fi.attribs &amp; ATTR_DIRECTORY, fi.changed, 0, 0);

	free(a-&gt;path);
	a-&gt;path = npath;
	fid-&gt;qid = *qid;
	return nil;
}

static void
fsstat(Req *r)
{
	int rc;
	FInfo fi;
	Aux *a = r-&gt;fid-&gt;aux;

	if(ptype(r-&gt;fid-&gt;qid.path) == Proot)
		V2D(&amp;r-&gt;d, r-&gt;fid-&gt;qid, "");
	else if(ptype(r-&gt;fid-&gt;qid.path) == Pinfo)
		dirgeninfo(pindex(r-&gt;fid-&gt;qid.path), &amp;r-&gt;d);
	else if(ptype(r-&gt;fid-&gt;qid.path) == Pshare)
		V2D(&amp;r-&gt;d, r-&gt;fid-&gt;qid, a-&gt;path +1);
	else{
		memset(&amp;fi, 0, sizeof fi);
		if(Sess-&gt;caps &amp; CAP_NT_SMBS)
			rc = T2queryall(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;fi);
		else
			rc = T2querystandard(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;fi);
		if(rc == -1){
			responderrstr(r);
			return;
		}
		I2D(&amp;r-&gt;d, a-&gt;sp, a-&gt;path, &amp;fi);
		if(Billtrog == 0)
			upd_names(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;r-&gt;d);
	}
	respond(r, nil);
}

static int
smbcreateopen(Aux *a, char *path, int mode, int perm, int is_create,
	int is_dir, FInfo *fip)
{
	int rc, action, attrs, access, result;

	if(is_create &amp;&amp; is_dir){
		if(CIFScreatedirectory(Sess, a-&gt;sp, path) == -1)
			return -1;
		return 0;
	}

	if(mode &amp; DMAPPEND) {
		werrstr("filesystem does not support DMAPPEND");
		return -1;
	}

	if(is_create)
		action = 0x12;
	else if(mode &amp; OTRUNC)
		action = 0x02;
	else
		action = 0x01;

	if(perm &amp; 0222)
		attrs = ATTR_NORMAL;
	else
		attrs = ATTR_NORMAL|ATTR_READONLY;

	switch (mode &amp; OMASK){
	case OREAD:
		access = 0;
		break;
	case OWRITE:
		access = 1;
		break;
	case ORDWR:
		access = 2;
		break;
	case OEXEC:
		access = 3;
		break;
	default:
		werrstr("%d bad open mode", mode &amp; OMASK);
		return -1;
		break;
	}

	if(mode &amp; DMEXCL == 0)
		access |= 0x10;
	else
		access |= 0x40;

	if((a-&gt;fh = CIFS_SMB_opencreate(Sess, a-&gt;sp, path, access, attrs,
	    action, &amp;result)) == -1)
		return -1;

	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = T2queryall(Sess, a-&gt;sp, mapfile(a-&gt;path), fip);
	else
		rc = T2querystandard(Sess, a-&gt;sp, mapfile(a-&gt;path), fip);
	if(rc == -1){
		fprint(2, "internal error: stat of newly open/created file failed\n");
		return -1;
	}

	if((mode &amp; OEXCL) &amp;&amp; (result &amp; 0x8000) == 0){
		werrstr("%d bad open mode", mode &amp; OMASK);
		return -1;
	}
	return 0;
}

/* Uncle Bill, you have a lot to answer for... */
static int
ntcreateopen(Aux *a, char *path, int mode, int perm, int is_create,
	int is_dir, FInfo *fip)
{
	int options, result, attrs, flags, access, action, share;

	if(mode &amp; DMAPPEND){
		werrstr("CIFSopen, DMAPPEND not supported");
		return -1;
	}

	if(is_create){
		if(mode &amp; OEXCL)
			action = FILE_OPEN;
		else if(mode &amp; OTRUNC)
			action = FILE_CREATE;
		else
			action = FILE_OVERWRITE_IF;
	} else {
		if(mode &amp; OTRUNC)
			action = FILE_OVERWRITE_IF;
		else
			action = FILE_OPEN_IF;
	}

	flags = 0;		/* FIXME: really not sure */

	if(mode &amp; OEXCL)
		share = FILE_NO_SHARE;
	else
		share = FILE_SHARE_ALL;

	switch (mode &amp; OMASK){
	case OREAD:
		access = GENERIC_READ;
		break;
	case OWRITE:
		access = GENERIC_WRITE;
		break;
	case ORDWR:
		access = GENERIC_ALL;
		break;
	case OEXEC:
		access = GENERIC_EXECUTE;
		break;
	default:
		werrstr("%d bad open mode", mode &amp; OMASK);
		return -1;
		break;
	}

	if(is_dir){
		action = FILE_CREATE;
		options = FILE_DIRECTORY_FILE;
		if(perm &amp; 0222)
			attrs = ATTR_DIRECTORY;
		else
			attrs = ATTR_DIRECTORY|ATTR_READONLY;
	} else {
		options = FILE_NON_DIRECTORY_FILE;
		if(perm &amp; 0222)
			attrs = ATTR_NORMAL;
		else
			attrs = ATTR_NORMAL|ATTR_READONLY;
	}

	if(mode &amp; ORCLOSE){
		options |= FILE_DELETE_ON_CLOSE;
		attrs |= ATTR_DELETE_ON_CLOSE;
	}

	if((a-&gt;fh = CIFS_NT_opencreate(Sess, a-&gt;sp, path, flags, options,
	    attrs, access, share, action, &amp;result, fip)) == -1)
		return -1;

	if((mode &amp; OEXCL) &amp;&amp; (result &amp; 0x8000) == 0){
		werrstr("%d bad open mode", mode &amp; OMASK);
		return -1;
	}

	return 0;
}

static void
fscreate(Req *r)
{
	FInfo fi;
	int rc, is_dir;
	char *npath;
	Aux *a = r-&gt;fid-&gt;aux;

	a-&gt;end = a-&gt;off = 0;
	a-&gt;cache = emalloc9p(max(Sess-&gt;mtu, MTU));

	is_dir = (r-&gt;ifcall.perm &amp; DMDIR) == DMDIR;
	npath = smprint("%s/%s", a-&gt;path, r-&gt;ifcall.name);

	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = ntcreateopen(a, mapfile(npath), r-&gt;ifcall.mode,
			r-&gt;ifcall.perm, 1, is_dir, &amp;fi);
	else
		rc = smbcreateopen(a, mapfile(npath), r-&gt;ifcall.mode,
			r-&gt;ifcall.perm, 1, is_dir, &amp;fi);
	if(rc == -1){
		free(npath);
		responderrstr(r);
		return;
	}

	r-&gt;fid-&gt;qid = mkqid(npath, fi.attribs &amp; ATTR_DIRECTORY, fi.changed, 0, 0);

	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	free(a-&gt;path);
	a-&gt;path = npath;

	respond(r, nil);
}

static void
fsopen(Req *r)
{
	int rc;
	FInfo fi;
	Aux *a = r-&gt;fid-&gt;aux;

	a-&gt;end = a-&gt;off = 0;
	a-&gt;cache = emalloc9p(max(Sess-&gt;mtu, MTU));

	if(ptype(r-&gt;fid-&gt;qid.path) == Pinfo){
		if(makeinfo(pindex(r-&gt;fid-&gt;qid.path)) != -1)
			respond(r, nil);
		else
			respond(r, "cannot generate info");
		return;
	}

	if(r-&gt;fid-&gt;qid.type &amp; QTDIR){
		respond(r, nil);
		return;
	}

	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = ntcreateopen(a, mapfile(a-&gt;path), r-&gt;ifcall.mode, 0777,
			0, 0, &amp;fi);
	else
		rc = smbcreateopen(a, mapfile(a-&gt;path), r-&gt;ifcall.mode, 0777,
			0, 0, &amp;fi);
	if(rc == -1){
		responderrstr(r);
		return;
	}
	respond(r, nil);
}

static void
fswrite(Req *r)
{
	vlong n, m, got;
	Aux *a = r-&gt;fid-&gt;aux;
	vlong len = r-&gt;ifcall.count;
	vlong off = r-&gt;ifcall.offset;
	char *buf = r-&gt;ifcall.data;

	got = 0;
	n = Sess-&gt;mtu -OVERHEAD;
	do{
		if(len - got &lt; n)
			n = len - got;
		m = CIFSwrite(Sess, a-&gt;sp, a-&gt;fh, off + got, buf + got, n);
		if(m != -1)
			got += m;
	} while(got &lt; len &amp;&amp; m &gt;= n);

	r-&gt;ofcall.count = got;
	if(m == -1)
		responderrstr(r);
	else
		respond(r, nil);
}

static void
fsread(Req *r)
{
	vlong n, m, got;
	Aux *a = r-&gt;fid-&gt;aux;
	char *buf = r-&gt;ofcall.data;
	vlong len = r-&gt;ifcall.count;
	vlong off = r-&gt;ifcall.offset;

	if(ptype(r-&gt;fid-&gt;qid.path) == Pinfo){
		r-&gt;ofcall.count = readinfo(pindex(r-&gt;fid-&gt;qid.path), buf, len,
			off);
		respond(r, nil);
		return;
	}

	if(r-&gt;fid-&gt;qid.type &amp; QTDIR){
		dirread9p(r, dirgen, a);
		respond(r, nil);
		return;
	}

	got = 0;
	n = Sess-&gt;mtu -OVERHEAD;
	do{
		if(len - got &lt; n)
			n = len - got;
		m = CIFSread(Sess, a-&gt;sp, a-&gt;fh, off + got, buf + got, n, len);
		if(m != -1)
			got += m;
	} while(got &lt; len &amp;&amp; m &gt;= n);

	r-&gt;ofcall.count = got;
	if(m == -1)
		responderrstr(r);
	else
		respond(r, nil);
}

static void
fsdestroyfid(Fid *f)
{
	Aux *a = f-&gt;aux;

	if(ptype(f-&gt;qid.path) == Pinfo)
		freeinfo(pindex(f-&gt;qid.path));
	f-&gt;omode = -1;
	if(! a)
		return;
	if(a-&gt;fh != -1)
		if(CIFSclose(Sess, a-&gt;sp, a-&gt;fh) == -1)
			fprint(2, "%s: close failed fh=%d %r\n", argv0, a-&gt;fh);
	if(a-&gt;sh != -1)
		if(CIFSfindclose2(Sess, a-&gt;sp, a-&gt;sh) == -1)
			fprint(2, "%s: findclose failed sh=%d %r\n",
				argv0, a-&gt;sh);
	if(a-&gt;path)
		free(a-&gt;path);
	if(a-&gt;cache)
		free(a-&gt;cache);

	if(a == Auxroot)
		Auxroot = a-&gt;next;
	a-&gt;prev-&gt;next = a-&gt;next;
	a-&gt;next-&gt;prev = a-&gt;prev;
	if(a-&gt;next == a-&gt;prev)
		Auxroot = nil;
	if(a)
		free(a);
}

int
rdonly(Session *s, Share *sp, char *path, int rdonly)
{
	int rc;
	FInfo fi;

	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = T2queryall(s, sp, path, &amp;fi);
	else
		rc = T2querystandard(s, sp, path, &amp;fi);
	if(rc == -1)
		return -1;

	if((rdonly &amp;&amp; !(fi.attribs &amp; ATTR_READONLY)) ||
	    (!rdonly &amp;&amp; (fi.attribs &amp; ATTR_READONLY))){
		fi.attribs &amp;= ~ATTR_READONLY;
		fi.attribs |= rdonly? ATTR_READONLY: 0;
		rc = CIFSsetinfo(s, sp, path, &amp;fi);
	}
	return rc;
}

static void
fsremove(Req *r)
{
	int try, rc;
	char e[ERRMAX];
	Aux *ap, *a = r-&gt;fid-&gt;aux;

	*e = 0;
	if(ptype(r-&gt;fid-&gt;qid.path) == Proot ||
	   ptype(r-&gt;fid-&gt;qid.path) == Pshare){
		respond(r, "illegal operation");
		return;
	}

	/* close all instences of this file/dir */
	if((ap = Auxroot) != nil)
		do{
			if(strcmp(ap-&gt;path, a-&gt;path) == 0){
				if(ap-&gt;sh != -1)
					CIFSfindclose2(Sess, ap-&gt;sp, ap-&gt;sh);
				ap-&gt;sh = -1;
				if(ap-&gt;fh != -1)
					CIFSclose(Sess, ap-&gt;sp, ap-&gt;fh);
				ap-&gt;fh = -1;
			}
			ap = ap-&gt;next;
		}while(ap != Auxroot);
	try = 0;
again:
	if(r-&gt;fid-&gt;qid.type &amp; QTDIR)
		rc = CIFSdeletedirectory(Sess, a-&gt;sp, mapfile(a-&gt;path));
	else
		rc = CIFSdeletefile(Sess, a-&gt;sp, mapfile(a-&gt;path));

	rerrstr(e, sizeof(e));
	if(rc == -1 &amp;&amp; try++ == 0 &amp;&amp; strcmp(e, "permission denied") == 0 &amp;&amp;
	    rdonly(Sess, a-&gt;sp, mapfile(a-&gt;path), 0) == 0)
		goto again;
	if(rc == -1)
		responderrstr(r);
	else
		respond(r, nil);
}

static void
fswstat(Req *r)
{
	int fh, result, rc;
	FInfo fi, tmpfi;
	char *p, *from, *npath;
	Aux *a = r-&gt;fid-&gt;aux;

	if(ptype(r-&gt;fid-&gt;qid.path) == Proot ||
	   ptype(r-&gt;fid-&gt;qid.path) == Pshare){
		respond(r, "illegal operation");
		return;
	}

	if((r-&gt;d.uid &amp;&amp; r-&gt;d.uid[0]) || (r-&gt;d.gid &amp;&amp; r-&gt;d.gid[0])){
		respond(r, "cannot change ownership");
		return;
	}

	/*
	 * get current info
	 */
	if(Sess-&gt;caps &amp; CAP_NT_SMBS)
		rc = T2queryall(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;fi);
	else
		rc = T2querystandard(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;fi);
	if(rc == -1){
		werrstr("(query) - %r");
		responderrstr(r);
		return;
	}

	/*
	 * always clear the readonly attribute if set,
	 * before trying to set any other fields.
	 * wstat() fails if the file/dir is readonly
	 * and this function is so full of races - who cares about one more?
	 */
	rdonly(Sess, a-&gt;sp, mapfile(a-&gt;path), 0);

	/*
	 * rename - one piece of joy, renaming open files
	 * is legal (sharing permitting).
	 */
	if(r-&gt;d.name &amp;&amp; r-&gt;d.name[0]){
		if((p = strrchr(a-&gt;path, '/')) == nil){
			respond(r, "illegal path");
			return;
		}
		npath = emalloc9p((p-a-&gt;path)+strlen(r-&gt;d.name)+2);
		strecpy(npath, npath+(p- a-&gt;path)+2, a-&gt;path);
		strcat(npath, r-&gt;d.name);

		from = estrdup9p(mapfile(a-&gt;path));
		if(CIFSrename(Sess, a-&gt;sp, from, mapfile(npath)) == -1){
			werrstr("(rename) - %r");
			responderrstr(r);
			free(npath);
			free(from);
			return;
		}
		free(from);
		free(a-&gt;path);
		a-&gt;path = npath;
	}

	/*
	 * set the files length, do this before setting
	 * the file times as open() will alter them
	 */
	if(~r-&gt;d.length){
		fi.size = r-&gt;d.length;

		if(Sess-&gt;caps &amp; CAP_NT_SMBS){
			if((fh = CIFS_NT_opencreate(Sess, a-&gt;sp, mapfile(a-&gt;path),
			    0, FILE_NON_DIRECTORY_FILE,
	    		    ATTR_NORMAL, GENERIC_WRITE, FILE_SHARE_ALL,
			    FILE_OPEN_IF, &amp;result, &amp;tmpfi)) == -1){
				werrstr("(set length, open) - %r");
				responderrstr(r);
				return;
			}
			rc = T2setfilelength(Sess, a-&gt;sp, fh, &amp;fi);
			CIFSclose(Sess, a-&gt;sp, fh);
			if(rc == -1){
				werrstr("(set length), set) - %r");
				responderrstr(r);
				return;
			}
		} else {
			if((fh = CIFS_SMB_opencreate(Sess, a-&gt;sp, mapfile(a-&gt;path),
			    1, ATTR_NORMAL, 1, &amp;result)) == -1){
				werrstr("(set length, open) failed - %r");
				responderrstr(r);
				return;
			}
			rc = CIFSwrite(Sess, a-&gt;sp, fh, fi.size, 0, 0);
			CIFSclose(Sess, a-&gt;sp, fh);
			if(rc == -1){
				werrstr("(set length, write) - %r");
				responderrstr(r);
				return;
			}
		}
	}

	/*
	 * This doesn't appear to set length or
	 * attributes, no idea why, so I do those seperately
	 */
	if(~r-&gt;d.mtime || ~r-&gt;d.atime){
		if(~r-&gt;d.mtime)
			fi.written = r-&gt;d.mtime;
		if(~r-&gt;d.atime)
			fi.accessed = r-&gt;d.atime;
		if(T2setpathinfo(Sess, a-&gt;sp, mapfile(a-&gt;path), &amp;fi) == -1){
			werrstr("(set path info) - %r");
			responderrstr(r);
			return;
		}
	}

	/*
	 * always update the readonly flag as
	 * we may have cleared it above.
	 */
	if(~r-&gt;d.mode){
		if(r-&gt;d.mode &amp; 0222)
			fi.attribs &amp;= ~ATTR_READONLY;
		else
			fi.attribs |= ATTR_READONLY;
	}
	if(rdonly(Sess, a-&gt;sp, mapfile(a-&gt;path), fi.attribs &amp; ATTR_READONLY) == -1){
		werrstr("(set info) - %r");
		responderrstr(r);
		return;
	}

	/*
	 * Win95 has a broken write-behind cache for metadata
	 * on open files (writes go to the cache, reads bypass
	 * the cache), so we must flush the file.
	 */
	if(r-&gt;fid-&gt;omode != -1 &amp;&amp; CIFSflush(Sess, a-&gt;sp, a-&gt;fh) == -1){
		werrstr("(flush) %r");
		responderrstr(r);
		return;
	}
	respond(r, nil);
}

static void
fsend(Srv *srv)
{
	int i;
	USED(srv);

	for(i = 0; i &lt; Nshares; i++)
		CIFStreedisconnect(Sess, Shares+i);
	CIFSlogoff(Sess);
	postnote(PNPROC, Keeppid, "die");
}

Srv fs = {
	.destroyfid =	fsdestroyfid,
	.attach=	fsattach,
	.open=		fsopen,
	.create=	fscreate,
	.read=		fsread,
	.write=		fswrite,
	.remove=	fsremove,
	.stat=		fsstat,
	.wstat=		fswstat,
	.clone= 	fsclone,
	.walk1= 	fswalk1,
	.end=		fsend,
};

void
usage(void)
{
	fprint(2, "usage: %s [-d name] [-Dvb] [-a auth-method] [-s srvname] "
		"[-n called-name] [-k factotum-params] [-m mntpnt] "
		"host [share...]\n", argv0);
	exits("usage");
}

/*
 * SMBecho looks like the function to use for keepalives,
 * sadly the echo packet does not seem to reload the
 * idle timer in Microsoft's servers.  Instead we use
 * "get file system size" on each share until we get one that succeeds.
 */
static void
keepalive(void)
{
	char buf[32];
	uvlong tot, fre;
	int fd, i, slot, rc;

	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OWRITE)) &gt;= 0){
		fprint(fd, "%s keepalive", Host);
		close(fd);
	}

	rc = 0;
	slot = 0;
	do{
		sleep(6000);
		if(Active-- != 0)
			continue;
		for(i = 0; i &lt; Nshares; i++){
			if((rc = T2fssizeinfo(Sess, &amp;Shares[slot], &amp;tot, &amp;fre)) == 0)
				break;
			if(++slot &gt;= Nshares)
				slot = 0;
		}
	}while(rc != -1);
	postnote(PNPROC, Attachpid, "die");
}


static void
ding(void *u, char *msg)
{
	USED(u);
	if(strstr(msg, "alarm") != nil)
		noted(NCONT);
	noted(NDFLT);
}

void
dmpkey(char *s, void *v, int n)
{
	int i;
	unsigned char *p = (unsigned char *)v;

	print("%s", s);
	for(i = 0; i &lt; n; i++)
		print("%02ux ", *p++);
	print("\n");
}

void
main(int argc, char **argv)
{
	int i, n;
	long svrtime;
	char windom[64], cname[64];
	char *method, *sysname, *keyp, *mtpt, *svs;
	static char *sh[1024];

	*cname = 0;
	keyp = "";
	method = nil;
	strcpy(windom, "unknown");
	mtpt = svs = nil;

	notify(ding);

	ARGBEGIN{
	case 'a':
		method = EARGF(autherr());
		break;
	case 'b':
		Billtrog ^= 1;
		break;
	case 'D':
		chatty9p++;
		break;
	case 'd':
		Debug = EARGF(usage());
		break;
	case 'i':
		Checkcase = 0;
		break;
	case 'k':
		keyp = EARGF(usage());
		break;
	case 'm':
		mtpt = EARGF(usage());
		break;
	case 'n':
		strncpy(cname, EARGF(usage()), sizeof(cname));
		cname[sizeof(cname) - 1] = 0;
		break;
	case 's':
		svs = EARGF(usage());
		break;
	case 't':
		Dfstout = atoi(EARGF(usage()));
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc &lt; 1)
		usage();

	Host = argv[0];

	if(mtpt == nil &amp;&amp; svs == nil)
		mtpt = smprint("/n/%s", Host);

	if((sysname = getenv("sysname")) == nil)
		sysname = "unknown";

	if(*cname &amp;&amp; (Sess = cifsdial(Host, cname, sysname)) != nil)
		goto connected;

	if(calledname(Host, cname) == 0 &amp;&amp;
	    (Sess = cifsdial(Host, cname, sysname)) != nil)
		goto connected;

	strcpy(cname, Host);
	if((Sess = cifsdial(Host, Host, sysname)) != nil ||
	   (Sess = cifsdial(Host, "*SMBSERVER", sysname)) != nil)
		goto connected;

	sysfatal("%s - cannot dial, %r\n", Host);
connected:
	if(CIFSnegotiate(Sess, &amp;svrtime, windom, sizeof windom, cname, sizeof cname) == -1)
		sysfatal("%s - cannot negioate common protocol, %r\n", Host);

#ifndef DEBUG_MAC
	Sess-&gt;secmode &amp;= ~SECMODE_SIGN_ENABLED;
#endif

	Sess-&gt;auth = getauth(method, windom, keyp, Sess-&gt;secmode, Sess-&gt;chal,
		Sess-&gt;challen);

	if(CIFSsession(Sess) &lt; 0)
		sysfatal("session authentication failed, %r\n");

	Sess-&gt;slip = svrtime - time(nil);
	Sess-&gt;cname = estrdup9p(cname);

	if(CIFStreeconnect(Sess, cname, Ipcname, &amp;Ipc) == -1)
		fprint(2, "%s, %r - can't connect\n", Ipcname);

	Nshares = 0;
	if(argc == 1){
		Share *sip;

		if((n = RAPshareenum(Sess, &amp;Ipc, &amp;sip)) &lt; 1)
			sysfatal("can't enumerate shares: %r - specify share "
				"names on command line\n");

		for(i = 0; i &lt; n; i++){
#ifdef NO_HIDDEN_SHARES
			int l = strlen(sip[i].name);

			if(l &gt; 1 &amp;&amp; sip[i].name[l-1] == '$'){
				free(sip[i].name);
				continue;
			}
#endif
			memcpy(Shares+Nshares, sip+i, sizeof(Share));
			if(CIFStreeconnect(Sess, Sess-&gt;cname,
			    Shares[Nshares].name, Shares+Nshares) == -1){
				free(Shares[Nshares].name);
				continue;
			}
			Nshares++;
		}
		free(sip);
	} else
		for(i = 1; i &lt; argc; i++){
			if(CIFStreeconnect(Sess, Sess-&gt;cname, argv[i],
			    Shares+Nshares) == -1){
				fprint(2, "%s: %s  %q - can't connect to share"
					", %r\n", argv0, Host, argv[i]);
				continue;
			}
			Shares[Nshares].name = strlwr(estrdup9p(argv[i]));
			Nshares++;
		}

	if(Nshares == 0)
		fprint(2, "no available shares\n");

	if((Keeppid = rfork(RFPROC|RFMEM|RFNOTEG|RFFDG|RFNAMEG)) == 0){
		keepalive();
		exits(nil);
	}
	postmountsrv(&amp;fs, svs, mtpt, MREPL|MCREATE);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

