<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cifs/sid2name.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cifs/sid2name.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "cifs.h"

struct {		/* Well known security IDs */
	char	*name;
	char	*auth;
	char	*rid;
} known[] = {
	/* default local users */
	{ "lu.dialup",			"S-1-5-1",	nil },
	{ "lu.network",			"S-1-5-2",	nil },
	{ "lu.batch",			"S-1-5-3",	nil },
	{ "lu.interactive",		"S-1-5-4",	nil },
	{ "lu.service",			"S-1-5-6",	nil },
	{ "lu.anon",			"S-1-5-7",	nil },
	{ "lu.DC",			"S-1-5-8",	nil },
	{ "lu.enterprise-domain",	"S-1-5-9",	nil },
	{ "lu.self",			"S-1-5-10",	nil },
	{ "lu.authenticated",		"S-1-5-11",	nil },
	{ "lu.restricted",		"S-1-5-12",	nil },
	{ "lu.terminal-services",	"S-1-5-13",	nil },
	{ "lu.remote-desktop",		"S-1-5-14",	nil },
	{ "lu.local-system",		"S-1-5-18",	nil },
	{ "lu.local-service",		"S-1-5-19",	nil },
	{ "lu.network-service",		"S-1-5-20",	nil },
	{ "lu.builtin",			"S-1-5-32",	nil },

	/* default local groups */
	{ "lg.null",			"S-1-0-0",	nil },
	{ "lg.world",			"S-1-1-0",	nil },
	{ "lg.local",			"S-1-2-0",	nil },
	{ "lg.creator-owner",		"S-1-3-0",	nil },
	{ "lg.creator-group",		"S-1-3-1",	nil },
	{ "lg.creator-owner-server",	"S-1-3-2",	nil },
	{ "lg.creator-group-server",	"S-1-3-3",	nil },

	/* default domain users */
	{ "du.admin", 			"S-1-5",	"500" },
	{ "du.guest",			"S-1-5",	"501" },
	{ "du.kerberos",		"S-1-5",	"502" },

	/* default domain groups */
	{ "dg.admins", 			"S-1-5-21",	"512" },
	{ "dg.users",			"S-1-5-21",	"513" },
	{ "dg.guests",			"S-1-5",	"514" },
	{ "dg.computers",		"S-1-5",	"515" },
	{ "dg.controllers",		"S-1-5",	"516" },
	{ "dg.cert-admins",		"S-1-5",	"517" },
	{ "dg.schema-admins",		"S-1-5",	"518" },
	{ "dg.enterprise-admins",	"S-1-5",	"519" },
	{ "dg.group-policy-admins",	"S-1-5",	"520" },
	{ "dg.remote-access",		"S-1-5",	"553" },

	/* default domain aliases */
	{ "da.admins",			"S-1-5",	"544" },
	{ "da.users",			"S-1-5",	"545" },
	{ "da.guests",			"S-1-5",	"546" },
	{ "da.power-users",		"S-1-5",	"547" },
	{ "da.account-operators",	"S-1-5",	"548" },
	{ "da.server-operators",	"S-1-5",	"549" },
	{ "da.print-operators",		"S-1-5",	"550" },
	{ "da.backup-operators",	"S-1-5",	"551" },
	{ "da.replicator",		"S-1-5",	"552" },
	{ "da.RAS-servers",		"S-1-5",	"553" },

};

static char *
sid2name(char *sid)
{
	int i;
	char *rid;

	if(sid == nil || (rid = strrchr(sid, '-')) == nil || *++rid == 0)
		return estrdup9p("-");

	for(i = 0; i &lt; nelem(known); i++){
		if(strcmp(known[i].auth, sid) == 0 &amp;&amp; known[i].rid == nil)
			return estrdup9p(known[i].name);

		if(strlen(known[i].auth) &lt; strlen(sid) &amp;&amp;
		    strncmp(known[i].auth, sid, strlen(known[i].auth)) == 0 &amp;&amp;
		    known[i].rid &amp;&amp; strcmp(known[i].rid, rid) == 0)
			return estrdup9p(known[i].name);
	}

	return estrdup9p(rid);
}

void
upd_names(Session *s, Share *sp, char *path, Dir *d)
{
	int fh, result;
	char *usid, *gsid;
	FInfo fi;

	if(d-&gt;uid)
		free(d-&gt;uid);
	if(d-&gt;gid)
		free(d-&gt;gid);

	if((fh = CIFS_NT_opencreate(s, sp, path, 0, 0, 0, READ_CONTROL,
	    FILE_SHARE_ALL, FILE_OPEN, &amp;result, &amp;fi)) == -1){
		d-&gt;uid = estrdup9p("unknown");
		d-&gt;gid = estrdup9p("unknown");
		return;
	}
	usid = nil;
	gsid = nil;
	TNTquerysecurity(s, sp, fh, &amp;usid, &amp;gsid);
	d-&gt;uid = sid2name(usid);
	d-&gt;gid = sid2name(gsid);
	if(fh != -1)
		CIFSclose(s, sp, fh);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

