<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/colors.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/colors.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

int nbit, npix;
Image *pixel;
Rectangle crect[256];

Image *color[256];

void
eresized(int new)
{
	int x, y, i, n, nx, ny;
	Rectangle r, b;

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0){
		fprint(2, "colors: can't reattach to window: %r\n");
		exits("resized");
	}
	if(screen-&gt;depth &gt; 8){
		n = 256;
		nx = 16;
	}else{
		n = 1&lt;&lt;screen-&gt;depth;
		nx = 1&lt;&lt;(screen-&gt;depth/2);
	}

	ny = n/nx;
	draw(screen, screen-&gt;r, display-&gt;white, nil, ZP);
	r = insetrect(screen-&gt;r, 5);
	r.min.y+=20;
	b.max.y=r.min.y;
	for(i=n-1, y=0; y!=ny; y++){
		b.min.y=b.max.y;
		b.max.y=r.min.y+(r.max.y-r.min.y)*(y+1)/ny;
		b.max.x=r.min.x;
		for(x=0; x!=nx; x++, --i){
			b.min.x=b.max.x;
			b.max.x=r.min.x+(r.max.x-r.min.x)*(x+1)/nx;
			crect[i]=insetrect(b, 1);
			draw(screen, crect[i], color[i], nil, ZP);
		}
	}
	flushimage(display, 1);
}

char *buttons[] =
{
	"exit",
	0
};

ulong
grey(int i)
{
	if(i &lt; 0)
		return grey(0);
	if(i &gt; 255)
		return grey(255);
	return (i&lt;&lt;16)+(i&lt;&lt;8)+i;
}

Menu menu =
{
	buttons
};

int
dither[16] =  {
	0, 8, 2, 10,
	12, 4, 14, 6,
	3, 11, 1, 9,
	15, 7, 13, 5
};

void
main(int argc, char *argv[])
{
	Point p;
	Mouse m;
	int i, j, k, l, n, ramp, prev;
	char buf[100];
	char *fmt;
	Image *dark;
	ulong rgb;

	ramp = 0;

	fmt = "index %3d r %3lud g %3lud b %3lud 0x%.8luX        ";
	ARGBEGIN{
	default:
		goto Usage;
	case 'x':
		fmt = "index %2luX r %3luX g %3luX b %3luX 0x%.8luX       ";
		break;
	case 'r':
		ramp = 1;
		break;
	}ARGEND

	if(argc){
	Usage:
		fprint(2, "Usage: %s [-rx]\n", argv0);
		exits("usage");
	}

	if(initdraw(nil, nil, "colors") &lt; 0)
		sysfatal("initdraw failed: %r");
	einit(Emouse);

	for(i=0; i&lt;256; i++){
		if(ramp){
			if(screen-&gt;chan == CMAP8){
				/* dither the fine grey */
				j = i-(i%17);
				dark = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, (grey(j)&lt;&lt;8)+0xFF);
				color[i] = allocimage(display, Rect(0,0,4,4), screen-&gt;chan, 1, (grey(j+17)&lt;&lt;8)+0xFF);
				for(j=0; j&lt;16; j++){
					k = j%4;
					l = j/4;
					if(dither[j] &gt; (i%17))
						draw(color[i], Rect(k, l, k+1, l+1), dark, nil, ZP);
				}
				freeimage(dark);
			}else
				color[i] = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, (grey(i)&lt;&lt;8)+0xFF);
		}else
			color[i] = allocimage(display, Rect(0,0,1,1), screen-&gt;chan, 1, (cmap2rgb(i)&lt;&lt;8)+0xFF);
		if(color[i] == nil)
			sysfatal("can't allocate image: %r");
	}
	eresized(0);
	prev = -1;
	for(;;){
		m = emouse();
		switch(m.buttons){
		case 1:
			while(m.buttons){
				if(screen-&gt;depth &gt; 8)
					n = 256;
				else
					n = 1&lt;&lt;screen-&gt;depth;
				for(i=0; i!=n; i++)
					if(i!=prev &amp;&amp; ptinrect(m.xy, crect[i])){
						if(ramp)
							rgb = grey(i);
						else
							rgb = cmap2rgb(i);
						sprint(buf, fmt,
							i,
							(rgb&gt;&gt;16)&amp;0xFF,
							(rgb&gt;&gt;8)&amp;0xFF,
							rgb&amp;0xFF,
							(rgb&lt;&lt;8) | 0xFF);
						p = addpt(screen-&gt;r.min, Pt(2,2));
						draw(screen, Rpt(p, addpt(p, stringsize(font, buf))), display-&gt;white, nil, p);
						string(screen, p, display-&gt;black, ZP, font, buf);
						prev=i;
						break;
					}
				m = emouse();
			}
			break;

		case 4:
			switch(emenuhit(3, &amp;m, &amp;menu)){
			case 0:
				exits(0);
			}
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

