<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/con/hayes.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/con/hayes.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

void setspeed(int, int);
int getspeed(char*, int);
void godial(int, int, char*);
int readmsg(int, int);
void punt(char*, ...);

int pulsed;
int verbose;
char msgbuf[128];		/* last message read */

enum
{
	Ok,
	Success,
	Failure,
	Noise,
};

typedef struct Msg	Msg;
struct Msg
{
	char	*text;
	int	type;
};


Msg msgs[] =
{
	{ "OK",			Ok, },
	{ "NO CARRIER", 	Failure, },
	{ "ERROR",		Failure, },
	{ "NO DIALTONE",	Failure, },
	{ "BUSY",		Failure, },
	{ "NO ANSWER",		Failure, },
	{ "CONNECT",		Success, },
	{ 0,			0 },
};

void
usage(void)
{
	punt("usage: hayes [-p] telno [device]");
}

void
main(int argc, char **argv)
{
	int data = -1;
	int ctl = -1;
	char *cname;

	ARGBEGIN{
	case 'p':
		pulsed = 1;
		break;
	case 'v':
		verbose = 1;
		break;
	default:
		usage();
	}ARGEND

	switch(argc){
	case 1:
		data = 1;
		break;
	case 2:
		data = open(argv[1], ORDWR);
		if(data &lt; 0){
			fprint(2, "hayes: %r opening %s\n", argv[1]);
			exits("hayes");
		}
		cname = malloc(strlen(argv[1])+4);
		sprint(cname, "%sctl", argv[1]);
		ctl = open(cname, ORDWR);
		free(cname);
		break;
	default:
		usage();
	}
	godial(data, ctl, argv[0]);
	exits(0);
}

int
send(int fd, char *x)
{
	return write(fd, x, strlen(x));
}

void
godial(int data, int ctl, char *number)
{
	char *dialstr;
	int m;
	int baud;

	/* get the modem's attention */
	if(send(data, "\r+++\r") &lt; 0)
		punt("failed write");
	readmsg(data, 2);
	sleep(1000);

	/* initialize */
	if(send(data, "ATZ\r") &lt; 0)
		punt("failed write");
	m = readmsg(data, 2);
	if(m &lt; 0)
		punt("can't get modem's attention");

	/*
	 *	Q0 = report result codes
	 * 	V1 = full word result codes
	 *	W1 = negotiation progress codes enabled
	 *	E1 = echo commands
	 *	M1 = speaker on until on-line
	 */
	if(send(data, "ATQ0V1E1M1\r") &lt; 0)
		punt("failed write");
	m = readmsg(data, 2);
	if(m != Ok)
		punt("can't get modem's attention");
	if(send(data, "ATW1\r") &lt; 0)
		punt("failed write");
	readmsg(data, 2);
	sleep(1000);

	/* godial */
	dialstr = malloc(6+strlen(number));
	sprint(dialstr, "ATD%c%s\r", pulsed ? 'P' : 'T', number);
	if(send(data, dialstr) &lt; 0) {
		free(dialstr);
		punt("failed write");
	}
	free(dialstr);
	m = readmsg(data, 60);
	if(m != Success)
		punt("dial failed: %s", msgbuf);
	baud = getspeed(msgbuf, 9600);
	setspeed(ctl, baud);
	fprint(2, "hayes: connected at %d baud\n", baud);
}

/*
 *  read until we see a message or we time out
 */
int
readmsg(int f, int secs)
{
	ulong start;
	char *p;
	int len;
	Dir *d;
	Msg *pp;

	p = msgbuf;
	len = sizeof(msgbuf) - 1;
	for(start = time(0); time(0) &lt;= start+secs;){
		if((d = dirfstat(f)) == nil)
			punt("failed read");
		if(d-&gt;length == 0){
			free(d);
			sleep(100);
			continue;
		}
		free(d);
		if(read(f, p, 1) &lt;= 0)
			punt("failed read");
		if(*p == '\n' || *p == '\r' || len == 0){
			*p = 0;
			if(verbose &amp;&amp; p != msgbuf)
				fprint(2, "%s\n", msgbuf);
			for(pp = msgs; pp-&gt;text; pp++)
				if(strncmp(pp-&gt;text, msgbuf, strlen(pp-&gt;text))==0)
					return pp-&gt;type;
			start = time(0);
			p = msgbuf;
			len = sizeof(msgbuf) - 1;
			continue;
		}
		len--;
		p++;
	}
	strcpy(msgbuf, "No response from modem");
	return Noise;
}

/*
 *  get baud rate from a connect message
 */
int
getspeed(char *msg, int speed)
{
	char *p;
	int s;

	p = msg + sizeof("CONNECT") - 1;
	while(*p == ' ' || *p == '\t')
		p++;
	s = atoi(p);
	if(s &lt;= 0)
		return speed;
	else
		return s;
}

/*
 *  set speed and RTS/CTS modem flow control
 */
void
setspeed(int ctl, int baud)
{
	char buf[32];

	if(ctl &lt; 0)
		return;
	sprint(buf, "b%d", baud);
	write(ctl, buf, strlen(buf));
	write(ctl, "m1", 2);
}


void
punt(char *fmt, ...)
{
	char buf[256];
	va_list arg;
	int n;

	strcpy(buf, "hayes: ");
	va_start(arg, fmt);
	n = vseprint(buf+strlen(buf), buf+sizeof(buf), fmt, arg) - buf;
	va_end(arg);
	buf[n] = '\n';
	write(2, buf, n+1);
	exits("hayes");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

