<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/con/xmr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/con/xmr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

enum {
	Soh=	0x1,
	Eot=	0x4,
	Ack=	0x6,
	Nak=	0x15,
	Cancel=	0x18,
};

int notifyf(void*, char*);
int readupto(uchar*, int);
int receive(int, uchar);
void send(int);

int debug, dfd;

void
main(int argc, char **argv)
{
	int fd;
	uchar seqno;
	ulong bytes;

	ARGBEGIN {
	case 'd':
		dfd = 2;
		debug = 1;
		break;
	} ARGEND

	if(argc != 1){
		fprint(2, "usage: xmr filename\n");
		exits("usage");
	}
	fd = open("/dev/consctl", OWRITE);
	if(fd &gt;= 0)
		write(fd, "rawon", 5);
	fd = create(argv[0], ORDWR, 0666);
	if(fd &lt; 0){
		perror("xmr: create");
		exits("create");
	}

	atnotify(notifyf, 1);
	send(Nak);

	/*
	 *  keep receiving till the other side gives up
	 */
	bytes = 0;
	for(seqno = 1; ; seqno++){
		if(receive(fd, seqno) == -1)
			break;
		bytes += 128;
	}
	fprint(2, "xmr: received %ld bytes\n", bytes);
	exits(0);
}

void
send(int byte)
{
	uchar c;

	c = byte;
	if(write(1, &amp;c, 1) != 1){
		fprint(2, "xmr: hungup\n");
		exits("hangup");
	}
}

int
readupto(uchar *a, int len)
{
	int n;
	int sofar;

	for(sofar = 0; sofar &lt; len; sofar += n){
		n = read(0, a, len-sofar);
		if(n &lt;= 0){
			send(Nak);
			return sofar;
		}
		if(*a == Eot || *a == Cancel)
			return sofar + n;
		a += n;
	}
	return sofar;

}

int
receive(int fd, uchar seqno)
{
	uchar buf[128+4];
	uchar sum;
	uchar *p;
	int n;
	int tries;
	int have;

	for(have = 0, tries = 0;; tries++){
		if(debug)
			fprint(dfd, "have == %d\n", have);
		if(tries &gt; 10){
			fprint(2, "xmr: timed out\n");
			if(debug)
				close(dfd);
			exits("timeout");
		}

		/* try to gather up a block */
		alarm(15*1000);
		n = readupto(&amp;buf[have], 132-have);
		alarm(0);
		have += n;
		if(have){
			switch(buf[0]){
			case Eot:
				send(Ack);
				return -1;
			case Cancel:
				fprint(2, "xmr: transfer aborted by sender\n");
				exits("cancel");
			}
		}
		if(have != 132)
			continue;

		/* checksum */
		for(p = buf, sum = 0; p &lt; &amp;buf[128+3]; p++)
			sum += *p;

		/* If invalid block, resynchronize */
		if(buf[0] != Soh || buf[2] != (255-buf[1]) || sum != buf[131]){
			if(debug){
				fprint(dfd, "resync %2.2ux %d %d %ux %ux\n", buf[0],
					buf[1], buf[2], sum, buf[131]);
				write(dfd, (char*)buf+3, 128);
				fprint(dfd, "\n");
			}
			p = memchr(buf+1, Soh, 131);
			if(p){
				have = 132-(p-buf);
				memmove(buf, p, have);
			} else
				have = 0;
			continue;
		}

		/* it's probably a real block, so dump it if there's an error */
		have = 0;

		/* if this is the last block, ack */
		if(buf[1] == seqno-1){
			tries = 0;
			send(Ack);
		}else if(buf[1] == seqno){
			if(debug)
				fprint(dfd, "Ack\n");
			send(Ack);
			if(write(fd, buf+3, 128) != 128){
				fprint(2, "xmr: abort, error writing file\n");
				exits("write");
			}
			return 0;
		} else {
			send(Nak);
		}
	}
}

int
notifyf(void *a, char *msg)
{
	USED(a);
	if(strcmp(msg, "alarm") == 0)
		return 1;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

