<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cpp/cpp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cpp/cpp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "cpp.h"

#define	OUTS	16384
char	outbuf[OUTS];
char	*outp = outbuf;
Source	*cursource;
int	nerrs;
struct	token nltoken = { NL, 0, 0, 0, 1, (uchar*)"\n" };
char	*curtime;
int	incdepth;
int	ifdepth;
int	ifsatisfied[NIF];
int	skipping;

int
main(int argc, char **argv)
{
	Tokenrow tr;
	long t;
	char ebuf[BUFSIZ];

	setbuf(stderr, ebuf);
	t = time(NULL);
	curtime = ctime(t);
	maketokenrow(3, &amp;tr);
	expandlex();
	setup(argc, argv);
	fixlex();
	iniths();
	genline();
	process(&amp;tr);
	flushout();
	fflush(stderr);
	exits(nerrs? "errors" : 0);
	return 0;
}

void
process(Tokenrow *trp)
{
	int anymacros = 0;

	for (;;) {
		if (trp-&gt;tp &gt;= trp-&gt;lp) {
			trp-&gt;tp = trp-&gt;lp = trp-&gt;bp;
			outp = outbuf;
			anymacros |= gettokens(trp, 1);
			trp-&gt;tp = trp-&gt;bp;
		}
		if (trp-&gt;tp-&gt;type == END) {
			if (--incdepth&gt;=0) {
				if (cursource-&gt;ifdepth)
					error(ERROR,
					 "Unterminated conditional in #include");
				unsetsource();
				cursource-&gt;line += cursource-&gt;lineinc;
				trp-&gt;tp = trp-&gt;lp;
				genline();
				continue;
			}
			if (ifdepth)
				error(ERROR, "Unterminated #if/#ifdef/#ifndef");
			break;
		}
		if (trp-&gt;tp-&gt;type==SHARP) {
			trp-&gt;tp += 1;
			control(trp);
		} else if (!skipping &amp;&amp; anymacros)
			expandrow(trp, NULL, Notinmacro);
		if (skipping)
			setempty(trp);
		puttokens(trp);
		anymacros = 0;
		cursource-&gt;line += cursource-&gt;lineinc;
		if (cursource-&gt;lineinc&gt;1) {
			genline();
		}
	}
}
	
void
control(Tokenrow *trp)
{
	Nlist *np;
	Token *tp;

	tp = trp-&gt;tp;
	if (tp-&gt;type!=NAME) {
		if (tp-&gt;type==NUMBER)
			goto kline;
		if (tp-&gt;type != NL)
			error(ERROR, "Unidentifiable control line");
		return;			/* else empty line */
	}
	if ((np = lookup(tp, 0))==NULL || (np-&gt;flag&amp;ISKW)==0 &amp;&amp; !skipping) {
		error(WARNING, "Unknown preprocessor control %t", tp);
		return;
	}
	if (skipping) {
		if ((np-&gt;flag&amp;ISKW)==0)
			return;
		switch (np-&gt;val) {
		case KENDIF:
			if (--ifdepth&lt;skipping)
				skipping = 0;
			--cursource-&gt;ifdepth;
			setempty(trp);
			return;

		case KIFDEF:
		case KIFNDEF:
		case KIF:
			if (++ifdepth &gt;= NIF)
				error(FATAL, "#if too deeply nested");
			++cursource-&gt;ifdepth;
			return;

		case KELIF:
		case KELSE:
			if (ifdepth&lt;=skipping)
				break;
			return;

		default:
			return;
		}
	}
	switch (np-&gt;val) {
	case KDEFINE:
		dodefine(trp);
		break;

	case KUNDEF:
		tp += 1;
		if (tp-&gt;type!=NAME || trp-&gt;lp - trp-&gt;bp != 4) {
			error(ERROR, "Syntax error in #undef");
			break;
		}
		if ((np = lookup(tp, 0))) {
			if (np-&gt;flag&amp;ISUNCHANGE) {
				error(ERROR, "#defined token %t can't be undefined", tp);
				return;
			}
			np-&gt;flag &amp;= ~ISDEFINED;
		}
		break;

	case KPRAGMA:
		return;

	case KIFDEF:
	case KIFNDEF:
	case KIF:
		if (++ifdepth &gt;= NIF)
			error(FATAL, "#if too deeply nested");
		++cursource-&gt;ifdepth;
		ifsatisfied[ifdepth] = 0;
		if (eval(trp, np-&gt;val))
			ifsatisfied[ifdepth] = 1;
		else
			skipping = ifdepth;
		break;

	case KELIF:
		if (ifdepth==0) {
			error(ERROR, "#elif with no #if");
			return;
		}
		if (ifsatisfied[ifdepth]==2)
			error(ERROR, "#elif after #else");
		if (eval(trp, np-&gt;val)) {
			if (ifsatisfied[ifdepth])
				skipping = ifdepth;
			else {
				skipping = 0;
				ifsatisfied[ifdepth] = 1;
			}
		} else
			skipping = ifdepth;
		break;

	case KELSE:
		if (ifdepth==0 || cursource-&gt;ifdepth==0) {
			error(ERROR, "#else with no #if");
			return;
		}
		if (ifsatisfied[ifdepth]==2)
			error(ERROR, "#else after #else");
		if (trp-&gt;lp - trp-&gt;bp != 3)
			error(ERROR, "Syntax error in #else");
		skipping = ifsatisfied[ifdepth]? ifdepth: 0;
		ifsatisfied[ifdepth] = 2;
		break;

	case KENDIF:
		if (ifdepth==0 || cursource-&gt;ifdepth==0) {
			error(ERROR, "#endif with no #if");
			return;
		}
		--ifdepth;
		--cursource-&gt;ifdepth;
		if (trp-&gt;lp - trp-&gt;bp != 3)
			error(WARNING, "Syntax error in #endif");
		break;

	case KERROR:
		trp-&gt;tp = tp+1;
		error(ERROR, "#error directive: %r", trp);
		break;

	case KWARNING:
		trp-&gt;tp = tp+1;
		error(WARNING, "#warning directive: %r", trp);
		break;

	case KLINE:
		trp-&gt;tp = tp+1;
		expandrow(trp, "&lt;line&gt;", Notinmacro);
		tp = trp-&gt;bp+2;
	kline:
		if (tp+1&gt;=trp-&gt;lp || tp-&gt;type!=NUMBER || tp+3&lt;trp-&gt;lp
		 || (tp+3==trp-&gt;lp &amp;&amp; ((tp+1)-&gt;type!=STRING)||*(tp+1)-&gt;t=='L')){
			error(ERROR, "Syntax error in #line");
			return;
		}
		cursource-&gt;line = atol((char*)tp-&gt;t)-1;
		if (cursource-&gt;line&lt;0 || cursource-&gt;line&gt;=32768)
			error(WARNING, "#line specifies number out of range");
		tp = tp+1;
		if (tp+1&lt;trp-&gt;lp)
			cursource-&gt;filename=(char*)newstring(tp-&gt;t+1,tp-&gt;len-2,0);
		return;

	case KDEFINED:
		error(ERROR, "Bad syntax for control line");
		break;

	case KINCLUDE:
		doinclude(trp);
		trp-&gt;lp = trp-&gt;bp;
		return;

	case KEVAL:
		eval(trp, np-&gt;val);
		break;

	default:
		error(ERROR, "Preprocessor control `%t' not yet implemented", tp);
		break;
	}
	setempty(trp);
	return;
}

void *
dorealloc(void *ptr, int size)
{
	void *p = realloc(ptr, size);

	if (p==NULL)
		error(FATAL, "Out of memory from realloc");
	return p;
}

void *
domalloc(int size)
{
	void *p = malloc(size);

	if (p==NULL)
		error(FATAL, "Out of memory from malloc");
	return p;
}

void
dofree(void *p)
{
	free(p);
}

void
error(enum errtype type, char *string, ...)
{
	va_list ap;
	char *cp, *ep;
	Token *tp;
	Tokenrow *trp;
	Source *s;
	int i;
	void *p;

	fprintf(stderr, "cpp: ");
	for (s=cursource; s; s=s-&gt;next)
		if (*s-&gt;filename)
			fprintf(stderr, "%s:%d ", s-&gt;filename, s-&gt;line);
	va_start(ap, string);
	for (ep=string; *ep; ep++) {
		if (*ep=='%') {
			switch (*++ep) {

			case 's':
				cp = va_arg(ap, char *);
				fprintf(stderr, "%s", cp);
				break;
			case 'd':
				i = va_arg(ap, int);
				fprintf(stderr, "%d", i);
				break;
			case 'p':
				p = va_arg(ap, void *);
				fprintf(stderr, "%p", p);
				break;
			case 't':
				tp = va_arg(ap, Token *);
				fprintf(stderr, "%.*s", tp-&gt;len, tp-&gt;t);
				break;

			case 'r':
				trp = va_arg(ap, Tokenrow *);
				for (tp=trp-&gt;tp; tp&lt;trp-&gt;lp&amp;&amp;tp-&gt;type!=NL; tp++) {
					if (tp&gt;trp-&gt;tp &amp;&amp; tp-&gt;wslen)
						fputc(' ', stderr);
					fprintf(stderr, "%.*s", tp-&gt;len, tp-&gt;t);
				}
				break;

			default:
				fputc(*ep, stderr);
				break;
			}
		} else
			fputc(*ep, stderr);
	}
	va_end(ap);
	fputc('\n', stderr);
	if (type==FATAL)
		exits("error");
	if (type!=WARNING)
		nerrs = 1;
	fflush(stderr);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

