<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cpp/lex.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cpp/lex.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "cpp.h"

/*
 * lexical FSM encoding
 *   when in state state, and one of the characters
 *   in ch arrives, enter nextstate.
 *   States &gt;= S_SELF are either final, or at least require special action.
 *   In 'fsm' there is a line for each state X charset X nextstate.
 *   List chars that overwrite previous entries later (e.g. C_ALPH
 *   can be overridden by '_' by a later entry; and C_XX is the
 *   the universal set, and should always be first.
 *   States above S_SELF are represented in the big table as negative values.
 *   S_SELF and S_SELFB encode the resulting token type in the upper bits.
 *   These actions differ in that S_SELF doesn't have a lookahead char,
 *   S_SELFB does.
 *
 *   The encoding is blown out into a big table for time-efficiency.
 *   Entries have
 *      nextstate: 6 bits; ?\ marker: 1 bit; tokentype: 9 bits.
 */

#define	MAXSTATE 32
#define	ACT(tok,act)	((tok&lt;&lt;7)+act)
#define	QBSBIT	0100
#define	GETACT(st)	(st&gt;&gt;7)&amp;0x1ff

#define	UTF2(c)		((c)&gt;=0xA0 &amp;&amp; (c)&lt;0xE0)		/* 2-char UTF seq */
#define	UTF3(c)		((c)&gt;=0xE0 &amp;&amp; (c)&lt;0xF0)		/* 3-char UTF seq */

/* character classes */
#define	C_WS	1
#define	C_ALPH	2
#define	C_NUM	3
#define	C_EOF	4
#define	C_XX	5

enum state {
	START=0, NUM1, NUM2, NUM3, ID1, ST1, ST2, ST3, COM1, COM2, COM3, COM4,
	CC1, CC2, WS1, PLUS1, MINUS1, STAR1, SLASH1, PCT1, SHARP1,
	CIRC1, GT1, GT2, LT1, LT2, OR1, AND1, ASG1, NOT1, DOTS1,
	S_SELF=MAXSTATE, S_SELFB, S_EOF, S_NL, S_EOFSTR,
	S_STNL, S_COMNL, S_EOFCOM, S_COMMENT, S_EOB, S_WS, S_NAME
};

struct	fsm {
	int	state;		/* if in this state */
	uchar	ch[4];		/* and see one of these characters */
	int	nextstate;	/* enter this state if +ve */
};

/*const*/ struct fsm fsm[] = {
	/* start state */
	START,	{ C_XX },	ACT(UNCLASS,S_SELF),
	START,	{ ' ', '\t', '\v', '\r' },	WS1,
	START,	{ C_NUM },	NUM1,
	START,	{ '.' },	NUM3,
	START,	{ C_ALPH },	ID1,
	START,	{ 'L' },	ST1,
	START,	{ '"' },	ST2,
	START,	{ '\'' },	CC1,
	START,	{ '/' },	COM1,
	START,	{ EOFC },	S_EOF,
	START,	{ '\n' },	S_NL,
	START,	{ '-' },	MINUS1,
	START,	{ '+' },	PLUS1,
	START,	{ '&lt;' },	LT1,
	START,	{ '&gt;' },	GT1,
	START,	{ '=' },	ASG1,
	START,	{ '!' },	NOT1,
	START,	{ '&amp;' },	AND1,
	START,	{ '|' },	OR1,
	START,	{ '#' },	SHARP1,
	START,	{ '%' },	PCT1,
	START,	{ '[' },	ACT(SBRA,S_SELF),
	START,	{ ']' },	ACT(SKET,S_SELF),
	START,	{ '(' },	ACT(LP,S_SELF),
	START,	{ ')' },	ACT(RP,S_SELF),
	START,	{ '*' },	STAR1,
	START,	{ ',' },	ACT(COMMA,S_SELF),
	START,	{ '?' },	ACT(QUEST,S_SELF),
	START,	{ ':' },	ACT(COLON,S_SELF),
	START,	{ ';' },	ACT(SEMIC,S_SELF),
	START,	{ '{' },	ACT(CBRA,S_SELF),
	START,	{ '}' },	ACT(CKET,S_SELF),
	START,	{ '~' },	ACT(TILDE,S_SELF),
	START,	{ '^' },	CIRC1,

	/* saw a digit */
	NUM1,	{ C_XX },	ACT(NUMBER,S_SELFB),
	NUM1,	{ C_NUM, C_ALPH, '.' },	NUM1,
	NUM1,	{ 'E', 'e' },	NUM2,
	NUM1,	{ '_' },	ACT(NUMBER,S_SELFB),

	/* saw possible start of exponent, digits-e */
	NUM2,	{ C_XX },	ACT(NUMBER,S_SELFB),
	NUM2,	{ '+', '-' },	NUM1,
	NUM2,	{ C_NUM, C_ALPH },	NUM1,
	NUM2,	{ '_' },	ACT(NUMBER,S_SELFB),

	/* saw a '.', which could be a number or an operator */
	NUM3,	{ C_XX },	ACT(DOT,S_SELFB),
	NUM3,	{ '.' },	DOTS1,
	NUM3,	{ C_NUM },	NUM1,

	DOTS1,	{ C_XX },	ACT(UNCLASS, S_SELFB),
	DOTS1,	{ C_NUM },	NUM1,
	DOTS1,	{ '.' },	ACT(ELLIPS, S_SELF),

	/* saw a letter or _ */
	ID1,	{ C_XX },	ACT(NAME,S_NAME),
	ID1,	{ C_ALPH, C_NUM },	ID1,

	/* saw L (start of wide string?) */
	ST1,	{ C_XX },	ACT(NAME,S_NAME),
	ST1,	{ C_ALPH, C_NUM },	ID1,
	ST1,	{ '"' },	ST2,
	ST1,	{ '\'' },	CC1,

	/* saw " beginning string */
	ST2,	{ C_XX },	ST2,
	ST2,	{ '"' },	ACT(STRING, S_SELF),
	ST2,	{ '\\' },	ST3,
	ST2,	{ '\n' },	S_STNL,
	ST2,	{ EOFC },	S_EOFSTR,

	/* saw \ in string */
	ST3,	{ C_XX },	ST2,
	ST3,	{ '\n' },	S_STNL,
	ST3,	{ EOFC },	S_EOFSTR,

	/* saw ' beginning character const */
	CC1,	{ C_XX },	CC1,
	CC1,	{ '\'' },	ACT(CCON, S_SELF),
	CC1,	{ '\\' },	CC2,
	CC1,	{ '\n' },	S_STNL,
	CC1,	{ EOFC },	S_EOFSTR,

	/* saw \ in ccon */
	CC2,	{ C_XX },	CC1,
	CC2,	{ '\n' },	S_STNL,
	CC2,	{ EOFC },	S_EOFSTR,

	/* saw /, perhaps start of comment */
	COM1,	{ C_XX },	ACT(SLASH, S_SELFB),
	COM1,	{ '=' },	ACT(ASSLASH, S_SELF),
	COM1,	{ '*' },	COM2,
	COM1,	{ '/' },	COM4,

	/* saw "/*", start of comment */
	COM2,	{ C_XX },	COM2,
	COM2,	{ '\n' },	S_COMNL,
	COM2,	{ '*' },	COM3,
	COM2,	{ EOFC },	S_EOFCOM,

	/* saw the * possibly ending a comment */
	COM3,	{ C_XX },	COM2,
	COM3,	{ '\n' },	S_COMNL,
	COM3,	{ '*' },	COM3,
	COM3,	{ '/' },	S_COMMENT,
	COM3,	{ EOFC },	S_EOFCOM,

	/* // comment */
	COM4,	{ C_XX },	COM4,
	COM4,	{ '\n' },	S_NL,
	COM4,	{ EOFC },	S_EOFCOM,

	/* saw white space, eat it up */
	WS1,	{ C_XX },	S_WS,
	WS1,	{ ' ', '\t', '\v', '\r'},	WS1,

	/* saw -, check --, -=, -&gt; */
	MINUS1,	{ C_XX },	ACT(MINUS, S_SELFB),
	MINUS1,	{ '-' },	ACT(MMINUS, S_SELF),
	MINUS1,	{ '=' },	ACT(ASMINUS,S_SELF),
	MINUS1,	{ '&gt;' },	ACT(ARROW,S_SELF),

	/* saw +, check ++, += */
	PLUS1,	{ C_XX },	ACT(PLUS, S_SELFB),
	PLUS1,	{ '+' },	ACT(PPLUS, S_SELF),
	PLUS1,	{ '=' },	ACT(ASPLUS, S_SELF),

	/* saw &lt;, check &lt;&lt;, &lt;&lt;=, &lt;= */
	LT1,	{ C_XX },	ACT(LT, S_SELFB),
	LT1,	{ '&lt;' },	LT2,
	LT1,	{ '=' },	ACT(LEQ, S_SELF),
	LT2,	{ C_XX },	ACT(LSH, S_SELFB),
	LT2,	{ '=' },	ACT(ASLSH, S_SELF),

	/* saw &gt;, check &gt;&gt;, &gt;&gt;=, &gt;= */
	GT1,	{ C_XX },	ACT(GT, S_SELFB),
	GT1,	{ '&gt;' },	GT2,
	GT1,	{ '=' },	ACT(GEQ, S_SELF),
	GT2,	{ C_XX },	ACT(RSH, S_SELFB),
	GT2,	{ '=' },	ACT(ASRSH, S_SELF),

	/* = */
	ASG1,	{ C_XX },	ACT(ASGN, S_SELFB),
	ASG1,	{ '=' },	ACT(EQ, S_SELF),

	/* ! */
	NOT1,	{ C_XX },	ACT(NOT, S_SELFB),
	NOT1,	{ '=' },	ACT(NEQ, S_SELF),

	/* &amp; */
	AND1,	{ C_XX },	ACT(AND, S_SELFB),
	AND1,	{ '&amp;' },	ACT(LAND, S_SELF),
	AND1,	{ '=' },	ACT(ASAND, S_SELF),

	/* | */
	OR1,	{ C_XX },	ACT(OR, S_SELFB),
	OR1,	{ '|' },	ACT(LOR, S_SELF),
	OR1,	{ '=' },	ACT(ASOR, S_SELF),

	/* # */
	SHARP1,	{ C_XX },	ACT(SHARP, S_SELFB),
	SHARP1,	{ '#' },	ACT(DSHARP, S_SELF),

	/* % */
	PCT1,	{ C_XX },	ACT(PCT, S_SELFB),
	PCT1,	{ '=' },	ACT(ASPCT, S_SELF),

	/* * */
	STAR1,	{ C_XX },	ACT(STAR, S_SELFB),
	STAR1,	{ '=' },	ACT(ASSTAR, S_SELF),

	/* ^ */
	CIRC1,	{ C_XX },	ACT(CIRC, S_SELFB),
	CIRC1,	{ '=' },	ACT(ASCIRC, S_SELF),

	-1
};

/* first index is char, second is state */
/* increase #states to power of 2 to encourage use of shift */
short	bigfsm[256][MAXSTATE];

void
expandlex(void)
{
	/*const*/ struct fsm *fp;
	int i, j, nstate;

	for (fp = fsm; fp-&gt;state&gt;=0; fp++) {
		for (i=0; fp-&gt;ch[i]; i++) {
			nstate = fp-&gt;nextstate;
			if (nstate &gt;= S_SELF)
				nstate = ~nstate;
			switch (fp-&gt;ch[i]) {

			case C_XX:		/* random characters */
				for (j=0; j&lt;256; j++)
					bigfsm[j][fp-&gt;state] = nstate;
				continue;
			case C_ALPH:
				for (j=0; j&lt;=256; j++)
					if ('a'&lt;=j&amp;&amp;j&lt;='z' || 'A'&lt;=j&amp;&amp;j&lt;='Z'
					  || UTF2(j) || UTF3(j) || j=='_')
						bigfsm[j][fp-&gt;state] = nstate;
				continue;
			case C_NUM:
				for (j='0'; j&lt;='9'; j++)
					bigfsm[j][fp-&gt;state] = nstate;
				continue;
			default:
				bigfsm[fp-&gt;ch[i]][fp-&gt;state] = nstate;
			}
		}
	}
	/* install special cases for ? (trigraphs),  \ (splicing), runes, and EOB */
	for (i=0; i&lt;MAXSTATE; i++) {
		for (j=0; j&lt;0xFF; j++)
			if (j=='?' || j=='\\' || UTF2(j) || UTF3(j)) {
				if (bigfsm[j][i]&gt;0)
					bigfsm[j][i] = ~bigfsm[j][i];
				bigfsm[j][i] &amp;= ~QBSBIT;
			}
		bigfsm[EOB][i] = ~S_EOB;
		if (bigfsm[EOFC][i]&gt;=0)
			bigfsm[EOFC][i] = ~S_EOF;
	}
}

void
fixlex(void)
{
	/* do C++ comments? */
	if (Cplusplus==0)
		bigfsm['/'][COM1] = bigfsm['x'][COM1];
}

/*
 * fill in a row of tokens from input, terminated by NL or END
 * First token is put at trp-&gt;lp.
 * Reset is non-zero when the input buffer can be "rewound."
 * The value is a flag indicating that possible macros have
 * been seen in the row.
 */
int
gettokens(Tokenrow *trp, int reset)
{
	register int c, state, oldstate;
	register uchar *ip;
	register Token *tp, *maxp;
	int runelen;
	Source *s = cursource;
	int nmac = 0;
	extern char outbuf[];

	tp = trp-&gt;lp;
	ip = s-&gt;inp;
	if (reset) {
		s-&gt;lineinc = 0;
		if (ip&gt;=s-&gt;inl) {		/* nothing in buffer */
			s-&gt;inl = s-&gt;inb;
			fillbuf(s);
			ip = s-&gt;inp = s-&gt;inb;
		} else if (ip &gt;= s-&gt;inb+(3*s-&gt;ins/4)) {
			memmove(s-&gt;inb, ip, 4+s-&gt;inl-ip);
			s-&gt;inl = s-&gt;inb+(s-&gt;inl-ip);
			ip = s-&gt;inp = s-&gt;inb;
		}
	}
	maxp = &amp;trp-&gt;bp[trp-&gt;max];
	runelen = 1;
	for (;;) {
	   continue2:
		if (tp&gt;=maxp) {
			trp-&gt;lp = tp;
			tp = growtokenrow(trp);
			maxp = &amp;trp-&gt;bp[trp-&gt;max];
		}
		tp-&gt;type = UNCLASS;
		tp-&gt;hideset = 0;
		tp-&gt;t = ip;
		tp-&gt;wslen = 0;
		tp-&gt;flag = 0;
		state = START;
		for (;;) {
			oldstate = state;
			c = *ip;
			if ((state = bigfsm[c][state]) &gt;= 0) {
				ip += runelen;
				runelen = 1;
				continue;
			}
			state = ~state;
		reswitch:
			switch (state&amp;0177) {
			case S_SELF:
				ip += runelen;
				runelen = 1;
			case S_SELFB:
				tp-&gt;type = GETACT(state);
				tp-&gt;len = ip - tp-&gt;t;
				tp++;
				goto continue2;

			case S_NAME:	/* like S_SELFB but with nmac check */
				tp-&gt;type = NAME;
				tp-&gt;len = ip - tp-&gt;t;
				nmac |= quicklook(tp-&gt;t[0], tp-&gt;len&gt;1?tp-&gt;t[1]:0);
				tp++;
				goto continue2;

			case S_WS:
				tp-&gt;wslen = ip - tp-&gt;t;
				tp-&gt;t = ip;
				state = START;
				continue;

			default:
				if ((state&amp;QBSBIT)==0) {
					ip += runelen;
					runelen = 1;
					continue;
				}
				state &amp;= ~QBSBIT;
				s-&gt;inp = ip;
				if (c=='?') { 	/* check trigraph */
					if (trigraph(s)) {
						state = oldstate;
						continue;
					}
					goto reswitch;
				}
				if (c=='\\') { /* line-folding */
					if (foldline(s)) {
						s-&gt;lineinc++;
						state = oldstate;
						continue;
					}
					goto reswitch;
				}
				if (UTF2(c)) {
					runelen = 2;
					goto reswitch;
				}
				if (UTF3(c)) {
					runelen = 3;
					goto reswitch;
				}
				error(WARNING, "Lexical botch in cpp");
				ip += runelen;
				runelen = 1;
				continue;

			case S_EOB:
				s-&gt;inp = ip;
				fillbuf(cursource);
				state = oldstate;
				continue;

			case S_EOF:
				tp-&gt;type = END;
				tp-&gt;len = 0;
				s-&gt;inp = ip;
				if (tp!=trp-&gt;bp &amp;&amp; (tp-1)-&gt;type!=NL &amp;&amp; cursource-&gt;fd!=-1)
					error(WARNING,"No newline at end of file");
				trp-&gt;lp = tp+1;
				return nmac;

			case S_STNL:
				error(ERROR, "Unterminated string or char const");
			case S_NL:
				tp-&gt;t = ip;
				tp-&gt;type = NL;
				tp-&gt;len = 1;
				tp-&gt;wslen = 0;
				s-&gt;lineinc++;
				s-&gt;inp = ip+1;
				trp-&gt;lp = tp+1;
				return nmac;

			case S_EOFSTR:
				error(FATAL, "EOF in string or char constant");
				break;

			case S_COMNL:
				s-&gt;lineinc++;
				state = COM2;
				ip += runelen;
				runelen = 1;
 				if (ip &gt;= s-&gt;inb+(7*s-&gt;ins/8)) { /* very long comment */
					memmove(tp-&gt;t, ip, 4+s-&gt;inl-ip);
					s-&gt;inl -= ip-tp-&gt;t;
					ip = tp-&gt;t+1;
				}
				continue;

			case S_EOFCOM:
				error(WARNING, "EOF inside comment");
				--ip;
			case S_COMMENT:
				++ip;
				tp-&gt;t = ip;
				tp-&gt;t[-1] = ' ';
				tp-&gt;wslen = 1;
				state = START;
				continue;
			}
			break;
		}
		ip += runelen;
		runelen = 1;
		tp-&gt;len = ip - tp-&gt;t;
		tp++;
	}
}

/* have seen ?; handle the trigraph it starts (if any) else 0 */
int
trigraph(Source *s)
{
	int c;

	while (s-&gt;inp+2 &gt;= s-&gt;inl &amp;&amp; fillbuf(s)!=EOF)
		;
	if (s-&gt;inp[1]!='?')
		return 0;
	c = 0;
	switch(s-&gt;inp[2]) {
	case '=':
		c = '#'; break;
	case '(':
		c = '['; break;
	case '/':
		c = '\\'; break;
	case ')':
		c = ']'; break;
	case '\'':
		c = '^'; break;
	case '&lt;':
		c = '{'; break;
	case '!':
		c = '|'; break;
	case '&gt;':
		c = '}'; break;
	case '-':
		c = '~'; break;
	}
	if (c) {
		*s-&gt;inp = c;
		memmove(s-&gt;inp+1, s-&gt;inp+3, s-&gt;inl-s-&gt;inp+2);
		s-&gt;inl -= 2;
	}
	return c;
}

int
foldline(Source *s)
{
	int ncr = 0;

recheck:
	while (s-&gt;inp+1 &gt;= s-&gt;inl &amp;&amp; fillbuf(s)!=EOF)
		;
	if (s-&gt;inp[ncr+1] == '\r') {	/* nonstandardly, ignore CR before line-folding */
		ncr++;
		goto recheck;
	}
	if (s-&gt;inp[ncr+1] == '\n') {
		memmove(s-&gt;inp, s-&gt;inp+2+ncr, s-&gt;inl-s-&gt;inp+3-ncr);
		s-&gt;inl -= 2+ncr;
		return 1;
	}
	return 0;
}

int
fillbuf(Source *s)
{
	int n;

	while((char *)s-&gt;inl+s-&gt;ins/8 &gt; (char *)s-&gt;inb+s-&gt;ins) {
		int l = s-&gt;inl - s-&gt;inb;
		int p = s-&gt;inp - s-&gt;inb;
		if(l &lt; 0) 
			error(FATAL, "negative end of input!?");
		if(p &lt; 0)
			error(FATAL, "negative input pointer!?");
		/* double the buffer size and try again */
		s-&gt;ins *= 2;
		s-&gt;inb = dorealloc(s-&gt;inb, s-&gt;ins);
		s-&gt;inl = s-&gt;inb + l;
		s-&gt;inp = s-&gt;inb + p;
	}
	if (s-&gt;fd&lt;0 || (n=read(s-&gt;fd, (char *)s-&gt;inl, s-&gt;ins/8)) &lt;= 0)
		n = 0;
	if ((*s-&gt;inp&amp;0xff) == EOB) /* sentinel character appears in input */
		*s-&gt;inp = EOFC;
	s-&gt;inl += n;
	s-&gt;inl[0] = s-&gt;inl[1]= s-&gt;inl[2]= s-&gt;inl[3] = EOB;
	if (n==0) {
		s-&gt;inl[0] = s-&gt;inl[1]= s-&gt;inl[2]= s-&gt;inl[3] = EOFC;
		return EOF;
	}
	return 0;
}

/*
 * Push down to new source of characters.
 * If fd&gt;0 and str==NULL, then from a file `name';
 * if fd==-1 and str, then from the string.
 */
Source *
setsource(char *name, int fd, char *str)
{
	Source *s = new(Source);
	int len;

	s-&gt;line = 1;
	s-&gt;lineinc = 0;
	s-&gt;fd = fd;
	s-&gt;filename = name;
	s-&gt;next = cursource;
	s-&gt;ifdepth = 0;
	cursource = s;
	/* slop at right for EOB */
	if (str) {
		len = strlen(str);
		s-&gt;inb = domalloc(len+4);
		s-&gt;inp = s-&gt;inb;
		strncpy((char *)s-&gt;inp, str, len);
	} else {
		Dir *d;
		int junk;
		ulong length = 0;
		d = dirfstat(fd);
		if (d != nil) {
			length = d-&gt;length;
			free(d);
		}
		junk = length;
		if (junk&lt;INS)
			junk = INS;
		s-&gt;inb = domalloc((junk)+4);
		s-&gt;inp = s-&gt;inb;
		len = 0;
	}

	s-&gt;ins = INS;	
	s-&gt;inl = s-&gt;inp+len;
	s-&gt;inl[0] = s-&gt;inl[1] = EOB;
	return s;
}

void
unsetsource(void)
{
	Source *s = cursource;

	if (s-&gt;fd&gt;=0) {
		close(s-&gt;fd);
		dofree(s-&gt;inb);
	}
	cursource = s-&gt;next;
	dofree(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

