<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cpp/nlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cpp/nlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "cpp.h"

extern	int getopt(int, char **, char *);
extern	char	*optarg;
extern	int	optind;
int	verbose;
int	Mflag;
int	Cplusplus;
int	nolineinfo;
Nlist	*kwdefined;
char	wd[128];

#define	NLSIZE	128

Nlist	*nlist[NLSIZE];

struct	kwtab {
	char	*kw;
	int	val;
	int	flag;
} kwtab[] = {
	"if",		KIF,		ISKW,
	"ifdef",	KIFDEF,		ISKW,
	"ifndef",	KIFNDEF,	ISKW,
	"elif",		KELIF,		ISKW,
	"else",		KELSE,		ISKW,
	"endif",	KENDIF,		ISKW,
	"include",	KINCLUDE,	ISKW,
	"define",	KDEFINE,	ISKW,
	"undef",	KUNDEF,		ISKW,
	"line",		KLINE,		ISKW,
	"error",	KERROR,		ISKW,
	"warning",	KWARNING,	ISKW,		// extension to ANSI
	"pragma",	KPRAGMA,	ISKW,
	"eval",		KEVAL,		ISKW,
	"defined",	KDEFINED,	ISDEFINED+ISUNCHANGE,
	"__LINE__",	KLINENO,	ISMAC+ISUNCHANGE,
	"__FILE__",	KFILE,		ISMAC+ISUNCHANGE,
	"__DATE__",	KDATE,		ISMAC+ISUNCHANGE,
	"__TIME__",	KTIME,		ISMAC+ISUNCHANGE,
	"__STDC__",	KSTDC,		ISUNCHANGE,
	NULL
};

unsigned long	namebit[077+1];
Nlist 	*np;

void
setup(int argc, char **argv)
{
	struct kwtab *kp;
	Nlist *np;
	Token t;
	int fd, i;
	char *fp, *dp;
	Tokenrow tr;
	char *objtype;
	char *includeenv;
	int firstinclude;
	static char nbuf[40];
	static Token deftoken[1] = {{ NAME, 0, 0, 0, 7, (uchar*)"defined" }};
	static Tokenrow deftr = { deftoken, deftoken, deftoken+1, 1 };
	int debuginclude = 0;
	int nodot = 0;
	char xx[2] = { 0, 0};

	for (kp=kwtab; kp-&gt;kw; kp++) {
		t.t = (uchar*)kp-&gt;kw;
		t.len = strlen(kp-&gt;kw);
		np = lookup(&amp;t, 1);
		np-&gt;flag = kp-&gt;flag;
		np-&gt;val = kp-&gt;val;
		if (np-&gt;val == KDEFINED) {
			kwdefined = np;
			np-&gt;val = NAME;
			np-&gt;vp = &amp;deftr;
			np-&gt;ap = 0;
		}
	}
	/*
	 * For Plan 9, search /objtype/include, then /sys/include
	 * (Note that includelist is searched from high end to low)
	 */
	if ((objtype = getenv("objtype"))){
		snprintf(nbuf, sizeof nbuf, "/%s/include", objtype);
		includelist[1].file = nbuf;
		includelist[1].always = 1;
	} else {
		includelist[1].file = NULL;
		error(WARNING, "Unknown $objtype");
	}
	if (getwd(wd, sizeof(wd))==0)
		wd[0] = '\0';
	includelist[0].file = "/sys/include";
	includelist[0].always = 1;
	firstinclude = NINCLUDE-2;
	if ((includeenv=getenv("include")) != NULL) {
		char *cp;
		includeenv = strdup(includeenv);
		for (;firstinclude&gt;0; firstinclude--) {
			cp = strtok(includeenv, " ");
			if (cp==NULL)
				break;
			includelist[firstinclude].file = cp;
			includelist[firstinclude].always = 1;
			includeenv = NULL;
		}
	}
	setsource("", -1, 0);
	ARGBEGIN {
		case 'N':
			for (i=0; i&lt;NINCLUDE; i++)
				if (includelist[i].always==1)
					includelist[i].deleted = 1;
			break;
		case 'I':
			for (i=firstinclude; i&gt;=0; i--) {
				if (includelist[i].file==NULL) {
					includelist[i].always = 1;
					includelist[i].file = ARGF();
					break;
				}
			}
			if (i&lt;0)
				error(WARNING, "Too many -I directives");
			break;
		case 'D':
		case 'U':
			setsource("&lt;cmdarg&gt;", -1, ARGF());
			maketokenrow(3, &amp;tr);
			gettokens(&amp;tr, 1);
			doadefine(&amp;tr, ARGC());
			unsetsource();
			break;
		case 'M':
			Mflag++;
			break;
		case 'V':
			verbose++;
			break;
		case '+':
			Cplusplus++;
			break;
		case 'i':
			debuginclude++;
			break;
		case 'P':
			nolineinfo++;
			break;
		case '.':
			nodot++;
			break;
		default:
			xx[0] = ARGC();
			error(FATAL, "Unknown argument '%s'", xx);
			break;
	} ARGEND
	dp = ".";
	fp = "&lt;stdin&gt;";
	fd = 0;
	if (argc &gt; 2)
		error(FATAL, "Too many file arguments; see cpp(1)");
	if (argc &gt; 0) {
		if ((fp = strrchr(argv[0], '/')) != NULL) {
			int len = fp - argv[0];
			dp = (char*)newstring((uchar*)argv[0], len+1, 0);
			dp[len] = '\0';
		}
		fp = (char*)newstring((uchar*)argv[0], strlen(argv[0]), 0);
		if ((fd = open(fp, 0)) &lt; 0)
			error(FATAL, "Can't open input file %s", fp);
	}
	if (argc &gt; 1) {
		int fdo = create(argv[1], 1, 0666);
		if (fdo&lt;0)
			error(FATAL, "Can't open output file %s", argv[1]);
		dup(fdo, 1);
	}
	if (Mflag)
		setobjname(fp);
	includelist[NINCLUDE-1].always = 0;
	includelist[NINCLUDE-1].file = dp;
	if(nodot)
		includelist[NINCLUDE-1].deleted = 1;
	setsource(fp, fd, NULL);
	if (debuginclude) {
		for (i=0; i&lt;NINCLUDE; i++)
			if (includelist[i].file &amp;&amp; includelist[i].deleted==0)
				error(WARNING, "Include: %s", includelist[i].file);
	}
}

Nlist *
lookup(Token *tp, int install)
{
	unsigned int h;
	Nlist *np;
	uchar *cp, *cpe;

	h = 0;
	for (cp=tp-&gt;t, cpe=cp+tp-&gt;len; cp&lt;cpe; )
		h += *cp++;
	h %= NLSIZE;
	np = nlist[h];
	while (np) {
		if (*tp-&gt;t==*np-&gt;name &amp;&amp; tp-&gt;len==np-&gt;len 
		 &amp;&amp; strncmp((char*)tp-&gt;t, (char*)np-&gt;name, tp-&gt;len)==0)
			return np;
		np = np-&gt;next;
	}
	if (install) {
		np = new(Nlist);
		np-&gt;val = 0;
		np-&gt;vp = NULL;
		np-&gt;ap = NULL;
		np-&gt;flag = 0;
		np-&gt;len = tp-&gt;len;
		np-&gt;name = newstring(tp-&gt;t, tp-&gt;len, 0);
		np-&gt;next = nlist[h];
		nlist[h] = np;
		quickset(tp-&gt;t[0], tp-&gt;len&gt;1? tp-&gt;t[1]:0);
		return np;
	}
	return NULL;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

