<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/9p1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/9p1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "9p1.h"

extern Nvrsafe	nvr;

typedef struct {
	uchar	chal[CHALLEN];		/* locally generated challenge */
	uchar	rchal[CHALLEN];		/* remotely generated challenge */
	Lock	idlock;
	ulong	idoffset;		/* offset of id vector */
	ulong	idvec;			/* vector of acceptable id's */
} Authinfo;

static void
f_nop(Chan *cp, Fcall*, Fcall*)
{
	if(CHAT(cp))
		print("c_nop %d\n", cp-&gt;chan);
}

static void
f_flush(Chan *cp, Fcall*, Fcall*)
{
	if(CHAT(cp))
		print("c_flush %d\n", cp-&gt;chan);
	runlock(&amp;cp-&gt;reflock);
	wlock(&amp;cp-&gt;reflock);
	wunlock(&amp;cp-&gt;reflock);
	rlock(&amp;cp-&gt;reflock);
}

/*
 *  create a challenge for a fid space
 */
static void
mkchallenge(Authinfo *aip)
{
	int i;

	srand((uintptr)aip + time(nil));
	for(i = 0; i &lt; CHALLEN; i++)
		aip-&gt;chal[i] = nrand(256);

	aip-&gt;idoffset = 0;
	aip-&gt;idvec = 0;
}

static void
f_session(Chan *cp, Fcall *in, Fcall *ou)
{
	Authinfo *aip;

	aip = (Authinfo*)cp-&gt;authinfo;

	if(CHAT(cp))
		print("c_session %d\n", cp-&gt;chan);
	memmove(aip-&gt;rchal, in-&gt;chal, sizeof(aip-&gt;rchal));
	mkchallenge(aip);
	memmove(ou-&gt;chal, aip-&gt;chal, sizeof(ou-&gt;chal));
	if(noauth || wstatallow)
		memset(ou-&gt;authid, 0, sizeof(ou-&gt;authid));
	else
		memmove(ou-&gt;authid, nvr.authid, sizeof(ou-&gt;authid));

	sprint(ou-&gt;authdom, "%s.%s", service, nvr.authdom);
	fileinit(cp);
}

/*
 *  match a challenge from an attach
 */
static int
authorize(Chan *cp, Fcall *in, Fcall *ou)
{
	Ticket t;
	Authenticator a;
	int x;
	ulong bit;
	Authinfo *aip;

	if(noauth || wstatallow)	/* set to allow entry during boot */
		return 1;

	if(strcmp(in-&gt;uname, "none") == 0)
		return 1;

	if(in-&gt;type == Toattach)
		return 0;

	/* decrypt and unpack ticket */
	convM2T9p1(in-&gt;ticket, &amp;t, nvr.machkey);
	if(t.num != AuthTs){
		print("9p1: bad AuthTs num\n");
		return 0;
	}

	/* decrypt and unpack authenticator */
	convM2A9p1(in-&gt;auth, &amp;a, t.key);
	if(a.num != AuthAc){
		print("9p1: bad AuthAc num\n");
		return 0;
	}

	/* challenges must match */
	aip = (Authinfo*)cp-&gt;authinfo;
	if(memcmp(a.chal, aip-&gt;chal, sizeof(a.chal)) != 0){
		print("9p1: bad challenge\n");
		return 0;
	}

	/*
	 *  the id must be in a valid range.  the range is specified by a
	 *  lower bound (idoffset) and a bit vector (idvec) where a
	 *  bit set to 1 means unusable
	 */
	lock(&amp;aip-&gt;idlock);
	x = a.id - aip-&gt;idoffset;
	bit = 1&lt;&lt;x;
	if(x &lt; 0 || x &gt; 31 || (bit&amp;aip-&gt;idvec)){
		unlock(&amp;aip-&gt;idlock);
		print("9p1: id out of range: idoff %ld idvec %lux id %ld\n",
		   aip-&gt;idoffset, aip-&gt;idvec, a.id);
		return 0;
	}
	aip-&gt;idvec |= bit;

	/* normalize the vector */
	while(aip-&gt;idvec&amp;0xffff0001){
		aip-&gt;idvec &gt;&gt;= 1;
		aip-&gt;idoffset++;
	}
	unlock(&amp;aip-&gt;idlock);

	/* ticket name and attach name must match */
	if(memcmp(in-&gt;uname, t.cuid, sizeof(in-&gt;uname)) != 0){
		print("9p1: names don't match\n");
		return 0;
	}

	/* copy translated name into input record */
	memmove(in-&gt;uname, t.suid, sizeof(in-&gt;uname));

	/* craft a reply */
	a.num = AuthAs;
	memmove(a.chal, aip-&gt;rchal, CHALLEN);
	convA2M9p1(&amp;a, ou-&gt;rauth, t.key);

	return 1;
}

/*
 * buggery to give false qid for
 * the top 2 levels of the dump fs
 */
void
mkqid(Qid* qid, Dentry *d, int buggery)
{
	int c;

	if(buggery &amp;&amp; d-&gt;qid.path == (QPDIR|QPROOT)){
		c = d-&gt;name[0];
		if(isascii(c) &amp;&amp; isdigit(c)){
			qid-&gt;path = 3;
			qid-&gt;vers = d-&gt;qid.version;
			qid-&gt;type = QTDIR;

			c = (c-'0')*10 + (d-&gt;name[1]-'0');
			if(c &gt;= 1 &amp;&amp; c &lt;= 12)
				qid-&gt;path = 4;
			return;
		}
	}

	mkqid9p2(qid, &amp;d-&gt;qid, d-&gt;mode);
}

int
mkqidcmp(Qid* qid, Dentry *d)
{
	Qid tmp;

	mkqid(&amp;tmp, d, 1);
	if(qid-&gt;path == tmp.path &amp;&amp; qid-&gt;type == tmp.type)
		return 0;
	return Eqid;
}

static void
f_attach(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;
	int u;
	Filsys *fs;
	Off raddr;

	if(CHAT(cp)) {
		print("c_attach %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\tuid = %s\n", in-&gt;uname);
		print("\targ = %s\n", in-&gt;aname);
	}

	ou-&gt;qid = QID9P1(0,0);
	ou-&gt;fid = in-&gt;fid;
	if(!in-&gt;aname[0])	/* default */
		strncpy(in-&gt;aname, "main", sizeof(in-&gt;aname));
	p = 0;
	f = filep(cp, in-&gt;fid, 1);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}

	u = -1;
	if(cp != cons.chan) {
		if(noattach &amp;&amp; strcmp(in-&gt;uname, "none")) {
			ou-&gt;err = Enoattach;
			goto out;
		}
		if(authorize(cp, in, ou) == 0 || strcmp(in-&gt;uname, "adm") == 0) {
			ou-&gt;err = Eauth;
			goto out;
		}
		u = strtouid(in-&gt;uname);
		if(u &lt; 0) {
			ou-&gt;err = Ebadu;
			goto out;
		}
	}
	f-&gt;uid = u;

	fs = fsstr(in-&gt;aname);
	if(fs == 0) {
		ou-&gt;err = Ebadspc;
		goto out;
	}
	raddr = getraddr(fs-&gt;dev);
	p = getbuf(fs-&gt;dev, raddr, Brd);
	d = getdir(p, 0);
	if(!d || checktag(p, Tdir, QPROOT) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if (iaccess(f, d, DEXEC) ||
	    f-&gt;uid == 0 &amp;&amp; fs-&gt;dev-&gt;type == Devro) {
		/*
		 * 'none' not allowed on dump
		 */
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, f-&gt;uid);
	mkqid(&amp;f-&gt;qid, d, 1);
	f-&gt;fs = fs;
	f-&gt;addr = raddr;
	f-&gt;slot = 0;
	f-&gt;open = 0;
	freewp(f-&gt;wpath);
	f-&gt;wpath = 0;

	mkqid9p1(&amp;ou-&gt;qid, &amp;f-&gt;qid);

	strncpy(cp-&gt;whoname, in-&gt;uname, sizeof(cp-&gt;whoname));
	cp-&gt;whotime = time(nil);
	if(cons.flags &amp; attachflag)
		print("9p1: attach %s %T to \"%s\" C%d\n",
			cp-&gt;whoname, cp-&gt;whotime, fs-&gt;name, cp-&gt;chan);

out:
	if((cons.flags &amp; attachflag) &amp;&amp; ou-&gt;err)
		print("9p1: attach %s %T SUCK EGGS --- %s\n",
			in-&gt;uname, time(nil), errstr9p[ou-&gt;err]);
	if(p)
		putbuf(p);
	if(f) {
		qunlock(f);
		if(ou-&gt;err)
			freefp(f);
	}
}

static void
f_clone(Chan *cp, Fcall *in, Fcall *ou)
{
	File *f1, *f2;
	Wpath *p;
	int fid, fid1;

	if(CHAT(cp)) {
		print("c_clone %d\n", cp-&gt;chan);
		print("\told fid = %d\n", in-&gt;fid);
		print("\tnew fid = %d\n", in-&gt;newfid);
	}

	fid = in-&gt;fid;
	fid1 = in-&gt;newfid;

	f1 = 0;
	f2 = 0;
	if(fid &lt; fid1) {
		f1 = filep(cp, fid, 0);
		f2 = filep(cp, fid1, 1);
	} else
	if(fid1 &lt; fid) {
		f2 = filep(cp, fid1, 1);
		f1 = filep(cp, fid, 0);
	}
	if(!f1 || !f2) {
		ou-&gt;err = Efid;
		goto out;
	}


	f2-&gt;fs = f1-&gt;fs;
	f2-&gt;addr = f1-&gt;addr;
	f2-&gt;open = f1-&gt;open &amp; ~FREMOV;
	f2-&gt;uid = f1-&gt;uid;
	f2-&gt;slot = f1-&gt;slot;
	f2-&gt;qid = f1-&gt;qid;

	freewp(f2-&gt;wpath);
	lock(&amp;wpathlock);
	f2-&gt;wpath = f1-&gt;wpath;
	for(p = f2-&gt;wpath; p; p = p-&gt;up)
		p-&gt;refs++;
	unlock(&amp;wpathlock);

out:
	ou-&gt;fid = fid;
	if(f1)
		qunlock(f1);
	if(f2) {
		qunlock(f2);
		if(ou-&gt;err)
			freefp(f2);
	}
}

static void
f_walk(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *f;
	Wpath *w;
	int slot;
	Off addr, qpath;

	if(CHAT(cp)) {
		print("c_walk %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\tname = %s\n", in-&gt;name);
	}

	ou-&gt;fid = in-&gt;fid;
	ou-&gt;qid = QID9P1(0,0);
	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(!(d-&gt;mode &amp; DDIR)) {
		ou-&gt;err = Edir1;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(cp != cons.chan &amp;&amp; iaccess(f, d, DEXEC)) {
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, f-&gt;uid);
	if(strcmp(in-&gt;name, ".") == 0)
		goto setdot;
	if(strcmp(in-&gt;name, "..") == 0) {
		if(f-&gt;wpath == 0)
			goto setdot;
		putbuf(p);
		p = 0;
		addr = f-&gt;wpath-&gt;addr;
		slot = f-&gt;wpath-&gt;slot;
		p1 = getbuf(f-&gt;fs-&gt;dev, addr, Brd);
		d1 = getdir(p1, slot);
		if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
			if(p1)
				putbuf(p1);
			ou-&gt;err = Ephase;
			goto out;
		}
		lock(&amp;wpathlock);
		f-&gt;wpath-&gt;refs--;
		f-&gt;wpath = f-&gt;wpath-&gt;up;
		unlock(&amp;wpathlock);
		goto found;
	}
	for(addr=0;; addr++) {
		if(p == 0) {
			p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
			d = getdir(p, f-&gt;slot);
			if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
				ou-&gt;err = Ealloc;
				goto out;
			}
		}
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, 0, f-&gt;uid);
		p = 0;
		if(!p1 || checktag(p1, Tdir, qpath) ) {
			if(p1)
				putbuf(p1);
			ou-&gt;err = Eentry;
			goto out;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			if(strncmp(in-&gt;name, d1-&gt;name, sizeof(in-&gt;name)) != 0)
				continue;
			/*
			 * update walk path
			 */
			w = newwp();
			if(!w) {
				ou-&gt;err = Ewalk;
				putbuf(p1);
				goto out;
			}
			w-&gt;addr = f-&gt;addr;
			w-&gt;slot = f-&gt;slot;
			w-&gt;up = f-&gt;wpath;
			f-&gt;wpath = w;
			slot += DIRPERBUF*addr;
			goto found;
		}
		putbuf(p1);
	}

found:
	f-&gt;addr = p1-&gt;addr;
	mkqid(&amp;f-&gt;qid, d1, 1);
	putbuf(p1);
	f-&gt;slot = slot;

setdot:
	mkqid9p1(&amp;ou-&gt;qid, &amp;f-&gt;qid);
	f-&gt;open = 0;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
}

static void
f_open(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;
	Tlock *t;
	Qid qid;
	int ro, fmod, wok;

	if(CHAT(cp)) {
		print("c_open %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\tmode = %o\n", in-&gt;mode);
	}

	wok = 0;
	if(cp == cons.chan || writeallow)
		wok = 1;

	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}

	/*
	 * if remove on close, check access here
	 */
	ro = f-&gt;fs-&gt;dev-&gt;type == Devro;
	if(in-&gt;mode &amp; ORCLOSE) {
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		/*
		 * check on parent directory of file to be deleted
		 */
		if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
			ou-&gt;err = Ephase;
			goto out;
		}
		p = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Brd);
		d = getdir(p, f-&gt;wpath-&gt;slot);
		if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}
		if(iaccess(f, d, DWRITE)) {
			ou-&gt;err = Eaccess;
			goto out;
		}
		putbuf(p);
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	mkqid(&amp;qid, d, 1);
	switch(in-&gt;mode &amp; 7) {

	case OREAD:
		if(iaccess(f, d, DREAD) &amp;&amp; !wok)
			goto badaccess;
		fmod = FREAD;
		break;

	case OWRITE:
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		fmod = FWRITE;
		break;

	case ORDWR:
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DREAD) &amp;&amp; !wok) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
		fmod = FREAD+FWRITE;
		break;

	case OEXEC:
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DEXEC) &amp;&amp; !wok))
			goto badaccess;
		fmod = FREAD;
		break;

	default:
		ou-&gt;err = Emode;
		goto out;
	}
	if(in-&gt;mode &amp; OTRUNC) {
		if((d-&gt;mode &amp; DDIR) ||
		   (iaccess(f, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro) {
			ou-&gt;err = Eronly;
			goto out;
		}
	}
	t = 0;
	if(d-&gt;mode &amp; DLOCK) {
		t = tlocked(p, d);
		if(t == nil) {
			ou-&gt;err = Elocked;
			goto out;
		}
	}
	if(in-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	f-&gt;open = fmod;
	if(in-&gt;mode &amp; OTRUNC)
		if(!(d-&gt;mode &amp; DAPND)) {
			dtrunc(p, d, f-&gt;uid);
			qid.vers = d-&gt;qid.version;
		}
	f-&gt;tlock = t;
	if(t)
		t-&gt;file = f;
	f-&gt;lastra = 1;
	mkqid9p1(&amp;ou-&gt;qid, &amp;qid);
	goto out;

badaccess:
	ou-&gt;err = Eaccess;
	f-&gt;open = 0;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

static void
f_create(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *f;
	int slot, slot1, fmod, wok;
	Off addr, addr1, path;
	Qid qid;
	Tlock *t;
	Wpath *w;

	if(CHAT(cp)) {
		print("c_create %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\tname = %s\n", in-&gt;name);
		print("\tperm = %lx+%lo\n", (in-&gt;perm&gt;&gt;28)&amp;0xf,
				in-&gt;perm&amp;0777);
		print("\tmode = %o\n", in-&gt;mode);
	}

	wok = 0;
	if(cp == cons.chan || writeallow)
		wok = 1;

	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(f-&gt;fs-&gt;dev-&gt;type == Devro) {
		ou-&gt;err = Eronly;
		goto out;
	}

	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(!(d-&gt;mode &amp; DDIR)) {
		ou-&gt;err = Edir2;
		goto out;
	}
	if(iaccess(f, d, DWRITE) &amp;&amp; !wok) {
		ou-&gt;err = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, f-&gt;uid);
	if(!strncmp(in-&gt;name, ".", sizeof(in-&gt;name)) ||
	   !strncmp(in-&gt;name, "..", sizeof(in-&gt;name))) {
		ou-&gt;err = Edot;
		goto out;
	}
	if(checkname(in-&gt;name)) {
		ou-&gt;err = Ename;
		goto out;
	}
	addr1 = 0;
	slot1 = 0;	/* set */
	for(addr=0;; addr++) {
		p1 = dnodebuf(p, d, addr, 0, f-&gt;uid);
		if(!p1) {
			if(addr1)
				break;
			p1 = dnodebuf(p, d, addr, Tdir, f-&gt;uid);
		}
		if(p1 == 0) {
			ou-&gt;err = Efull;
			goto out;
		}
		if(checktag(p1, Tdir, d-&gt;qid.path)) {
			putbuf(p1);
			goto phase;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC)) {
				if(!addr1) {
					addr1 = p1-&gt;addr;
					slot1 = slot + addr*DIRPERBUF;
				}
				continue;
			}
			if(!strncmp(in-&gt;name, d1-&gt;name, sizeof(in-&gt;name))) {
				putbuf(p1);
				ou-&gt;err = Eexist;
				goto out;
			}
		}
		putbuf(p1);
	}
	switch(in-&gt;mode &amp; 7) {
	case OEXEC:
	case OREAD:		/* seems only useful to make directories */
		fmod = FREAD;
		break;

	case OWRITE:
		fmod = FWRITE;
		break;

	case ORDWR:
		fmod = FREAD+FWRITE;
		break;

	default:
		ou-&gt;err = Emode;
		goto out;
	}
	if(in-&gt;perm &amp; PDIR)
		if((in-&gt;mode &amp; OTRUNC) || (in-&gt;perm &amp; PAPND) || (fmod &amp; FWRITE))
			goto badaccess;
	/*
	 * do it
	 */
	path = qidpathgen(f-&gt;fs-&gt;dev);
	p1 = getbuf(f-&gt;fs-&gt;dev, addr1, Brd|Bimm|Bmod);
	d1 = getdir(p1, slot1);
	if(!d1 || checktag(p1, Tdir, d-&gt;qid.path)) {
		if(p1)
			putbuf(p1);
		goto phase;
	}
	if(d1-&gt;mode &amp; DALLOC) {
		putbuf(p1);
		goto phase;
	}

	strncpy(d1-&gt;name, in-&gt;name, sizeof(in-&gt;name));
	if(cp == cons.chan) {
		d1-&gt;uid = cons.uid;
		d1-&gt;gid = cons.gid;
	} else {
		d1-&gt;uid = f-&gt;uid;
		d1-&gt;gid = d-&gt;gid;
		in-&gt;perm &amp;= d-&gt;mode | ~0666;
		if(in-&gt;perm &amp; PDIR)
			in-&gt;perm &amp;= d-&gt;mode | ~0777;
	}
	d1-&gt;qid.path = path;
	d1-&gt;qid.version = 0;
	d1-&gt;mode = DALLOC | (in-&gt;perm &amp; 0777);
	if(in-&gt;perm &amp; PDIR) {
		d1-&gt;mode |= DDIR;
		d1-&gt;qid.path |= QPDIR;
	}
	if(in-&gt;perm &amp; PAPND)
		d1-&gt;mode |= DAPND;
	t = 0;
	if(in-&gt;perm &amp; PLOCK) {
		d1-&gt;mode |= DLOCK;
		t = tlocked(p1, d1);
		/* if nil, out of tlock structures */
	}
	accessdir(p1, d1, FWRITE, f-&gt;uid);
	mkqid(&amp;qid, d1, 0);
	putbuf(p1);
	accessdir(p, d, FWRITE, f-&gt;uid);

	/*
	 * do a walk to new directory entry
	 */
	w = newwp();
	if(!w) {
		ou-&gt;err = Ewalk;
		goto out;
	}
	w-&gt;addr = f-&gt;addr;
	w-&gt;slot = f-&gt;slot;
	w-&gt;up = f-&gt;wpath;
	f-&gt;wpath = w;
	f-&gt;qid = qid;
	f-&gt;tlock = t;
	if(t)
		t-&gt;file = f;
	f-&gt;lastra = 1;
	if(in-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	f-&gt;open = fmod;
	f-&gt;addr = addr1;
	f-&gt;slot = slot1;
	mkqid9p1(&amp;ou-&gt;qid, &amp;qid);
	goto out;

badaccess:
	ou-&gt;err = Eaccess;
	goto out;

phase:
	ou-&gt;err = Ephase;

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

static void
f_read(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p, *p1;
	File *f;
	Dentry *d, *d1;
	Tlock *t;
	Off addr, offset;
	Timet tim;
	int nread, count, n, o, slot;

	if(CHAT(cp)) {
		print("c_read %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\toffset = %lld\n", (Wideoff)in-&gt;offset);
		print("\tcount = %ld\n", in-&gt;count);
	}

	p = 0;
	count = in-&gt;count;
	offset = in-&gt;offset;
	nread = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(!(f-&gt;open &amp; FREAD)) {
		ou-&gt;err = Eopen;
		goto out;
	}
	if(count &lt; 0 || count &gt; MAXDAT) {
		ou-&gt;err = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		ou-&gt;err = Eoffset;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(t = f-&gt;tlock) {
		tim = toytime();
		if(t-&gt;time &lt; tim || t-&gt;file != f) {
			ou-&gt;err = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FREAD, f-&gt;uid);
	if(d-&gt;mode &amp; DDIR) {
		addr = 0;
		goto dread;
	}

	/* XXXX terrible hack to get at raw data XXXX */
	if(rawreadok &amp;&amp; strncmp(d-&gt;name, "--raw--", 7) == 0) {
		Device *dev;
		Devsize boff, bsize;

		dev = p-&gt;dev;
		putbuf(p);
		p = 0;

		boff = number(d-&gt;name + 7, 0, 10) * 100000;
		if(boff &lt; 0)
			boff = 0;
		if(boff &gt; devsize(dev))
			boff = devsize(dev);
		bsize = devsize(dev) - boff;

		if(offset+count &gt;= 100000*RBUFSIZE)
			count = 100000*RBUFSIZE - offset;

		if((offset+count)/RBUFSIZE &gt;= bsize)
			/* will not overflow */
			count = bsize*RBUFSIZE - offset;

		while(count &gt; 0) {
			addr = offset / RBUFSIZE;
			addr += boff;
			o = offset % RBUFSIZE;
			n = RBUFSIZE - o;
			if(n &gt; count)
				n = count;

			p1 = getbuf(dev, addr, Brd);
			if(p1) {
				memmove(ou-&gt;data+nread, p1-&gt;iobuf+o, n);
				putbuf(p1);
			} else
				memset(ou-&gt;data+nread, 0, n);
			count -= n;
			nread += n;
			offset += n;
		}
		goto out;
	}

	if(offset+count &gt; d-&gt;size)
		count = d-&gt;size - offset;
	while(count &gt; 0) {
		if(p == 0) {
			p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
			d = getdir(p, f-&gt;slot);
			if(!d || !(d-&gt;mode &amp; DALLOC)) {
				ou-&gt;err = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		f-&gt;lastra = dbufread(p, d, addr, f-&gt;lastra, f-&gt;uid);
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		p1 = dnodebuf1(p, d, addr, 0, f-&gt;uid);
		p = 0;
		if(p1) {
			if(checktag(p1, Tfile, QPNONE)) {
				ou-&gt;err = Ephase;
				putbuf(p1);
				goto out;
			}
			memmove(ou-&gt;data+nread, p1-&gt;iobuf+o, n);
			putbuf(p1);
		} else
			memset(ou-&gt;data+nread, 0, n);
		count -= n;
		nread += n;
		offset += n;
	}
	goto out;

dread:
	for (;;) {
		if(p == 0) {
			p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
			d = getdir(p, f-&gt;slot);
			if(!d || !(d-&gt;mode &amp; DALLOC)) {
				ou-&gt;err = Ealloc;
				goto out;
			}
		}
		p1 = dnodebuf1(p, d, addr, 0, f-&gt;uid);
		p = 0;
		if(!p1)
			goto out;
		if(checktag(p1, Tdir, QPNONE)) {
			ou-&gt;err = Ephase;
			putbuf(p1);
			goto out;
		}
		n = DIRREC;
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			if(offset &gt;= n) {
				offset -= n;
				continue;
			}
			if(count &lt; n) {
				putbuf(p1);
				goto out;
			}
			if(convD2M9p1(d1, ou-&gt;data+nread) != n)
				print("9p1: dirread convD2M1990\n");
			nread += n;
			count -= n;
		}
		putbuf(p1);
		addr++;
	}
out:
	count = in-&gt;count - nread;
	if(count &gt; 0)
		memset(ou-&gt;data+nread, 0, count);
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
	ou-&gt;count = nread;
	if(CHAT(cp))
		print("\tnread = %d\n", nread);
}

static void
f_write(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d;
	File *f;
	Tlock *t;
	Off offset, addr, qpath;
	Timet tim;
	int count, nwrite, o, n;

	if(CHAT(cp)) {
		print("c_write %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
		print("\toffset = %lld\n", (Wideoff)in-&gt;offset);
		print("\tcount = %ld\n", in-&gt;count);
	}

	offset = in-&gt;offset;
	count = in-&gt;count;
	nwrite = 0;
	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(!(f-&gt;open &amp; FWRITE)) {
		ou-&gt;err = Eopen;
		goto out;
	}
	if(f-&gt;fs-&gt;dev-&gt;type == Devro) {
		ou-&gt;err = Eronly;
		goto out;
	}
	if(count &lt; 0 || count &gt; MAXDAT) {
		ou-&gt;err = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		ou-&gt;err = Eoffset;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd|Bmod);
	d = getdir(p, f-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(t = f-&gt;tlock) {
		tim = toytime();
		if(t-&gt;time &lt; tim || t-&gt;file != f) {
			ou-&gt;err = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FWRITE, f-&gt;uid);
	if(d-&gt;mode &amp; DAPND)
		offset = d-&gt;size;
	if(offset+count &gt; d-&gt;size)
		d-&gt;size = offset+count;
	while(count &gt; 0) {
		if(p == 0) {
			p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd|Bmod);
			d = getdir(p, f-&gt;slot);
			if(!d || !(d-&gt;mode &amp; DALLOC)) {
				ou-&gt;err = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, Tfile, f-&gt;uid);
		p = 0;
		if(p1 == 0) {
			ou-&gt;err = Efull;
			goto out;
		}
		if(checktag(p1, Tfile, qpath)) {
			putbuf(p1);
			ou-&gt;err = Ephase;
			goto out;
		}
		memmove(p1-&gt;iobuf+o, in-&gt;data+nwrite, n);
		p1-&gt;flags |= Bmod;
		putbuf(p1);
		count -= n;
		nwrite += n;
		offset += n;
	}
	if(CHAT(cp))
		print("\tnwrite = %d\n", nwrite);

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
	ou-&gt;count = nwrite;
}

int
doremove(File *f, int wok)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	Off addr;
	int slot, err;

	p = 0;
	p1 = 0;
	if(f-&gt;fs-&gt;dev-&gt;type == Devro) {
		err = Eronly;
		goto out;
	}
	/*
	 * check on parent directory of file to be deleted
	 */
	if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
		err = Ephase;
		goto out;
	}
	p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Brd);
	d1 = getdir(p1, f-&gt;wpath-&gt;slot);
	if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
		err = Ephase;
		goto out;
	}
	if(iaccess(f, d1, DWRITE) &amp;&amp; !wok) {
		err = Eaccess;
		goto out;
	}
	accessdir(p1, d1, FWRITE, f-&gt;uid);
	putbuf(p1);
	p1 = 0;

	/*
	 * check on file to be deleted
	 */
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		err = Ealloc;
		goto out;
	}
	if(err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;

	/*
	 * if deleting a directory, make sure it is empty
	 */
	if((d-&gt;mode &amp; DDIR))
	for(addr=0;; addr++) {
		p1 = dnodebuf(p, d, addr, 0, f-&gt;uid);
		if(!p1)
			break;
		if(checktag(p1, Tdir, d-&gt;qid.path)) {
			err = Ephase;
			goto out;
		}
		for(slot=0; slot&lt;DIRPERBUF; slot++) {
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			err = Eempty;
			goto out;
		}
		putbuf(p1);
	}

	/*
	 * do it
	 */
	dtrunc(p, d, f-&gt;uid);
	memset(d, 0, sizeof(Dentry));
	settag(p, Tdir, QPNONE);

out:
	if(p1)
		putbuf(p1);
	if(p)
		putbuf(p);
	return err;
}

static int
doclunk(File* f, int remove, int wok)
{
	Tlock *t;
	int err;

	err = 0;
	if(t = f-&gt;tlock) {
		if(t-&gt;file == f)
			t-&gt;time = 0;	/* free the lock */
		f-&gt;tlock = 0;
	}
	if(remove)
		err = doremove(f, wok);
	f-&gt;open = 0;
	freewp(f-&gt;wpath);
	freefp(f);

	return err;
}

static void
f_clunk(Chan *cp, Fcall *in, Fcall *ou)
{
	File *f;

	if(CHAT(cp)) {
		print("c_clunk %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f)
		ou-&gt;err = Efid;
	else {
		doclunk(f, f-&gt;open &amp; FREMOV, 0);
		qunlock(f);
	}
	ou-&gt;fid = in-&gt;fid;
}

static void
f_remove(Chan *cp, Fcall *in, Fcall *ou)
{
	File *f;

	if(CHAT(cp)) {
		print("c_remove %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f)
		ou-&gt;err = Efid;
	else {
		ou-&gt;err = doclunk(f, 1, cp==cons.chan);
		qunlock(f);
	}
	ou-&gt;fid = in-&gt;fid;
}

static void
f_stat(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p;
	Dentry *d;
	File *f;

	if(CHAT(cp)) {
		print("c_stat %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	p = 0;
	memset(ou-&gt;stat, 0, sizeof(ou-&gt;stat));
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;
	if(d-&gt;qid.path == QPROOT)	/* stat of root gives time */
		d-&gt;atime = time(nil);
	if(convD2M9p1(d, ou-&gt;stat) != DIRREC)
		print("9p1: stat convD2M\n");

out:
	if(p)
		putbuf(p);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

static void
f_wstat(Chan *cp, Fcall *in, Fcall *ou)
{
	Iobuf *p, *p1;
	Dentry *d, *d1, xd;
	File *f;
	int slot;
	Off addr;

	if(CHAT(cp)) {
		print("c_wstat %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	p = 0;
	p1 = 0;
	d1 = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	if(f-&gt;fs-&gt;dev-&gt;type == Devro) {
		ou-&gt;err = Eronly;
		goto out;
	}

	/*
	 * first get parent
	 */
	if(f-&gt;wpath) {
		p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Brd);
		d1 = getdir(p1, f-&gt;wpath-&gt;slot);
		if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}
	}

	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
		ou-&gt;err = Ealloc;
		goto out;
	}
	if(ou-&gt;err = mkqidcmp(&amp;f-&gt;qid, d))
		goto out;

	convM2D9p1(in-&gt;stat, &amp;xd);
	if(CHAT(cp)) {
		print("\td.name = %s\n", xd.name);
		print("\td.uid  = %d\n", xd.uid);
		print("\td.gid  = %d\n", xd.gid);
		print("\td.mode = %o\n", xd.mode);
	}

	/*
	 * if user none,
	 * cant do anything
	 */
	if(f-&gt;uid == 0) {
		ou-&gt;err = Eaccess;
		goto out;
	}

	/*
	 * if chown,
	 * must be god
	 */
	if(xd.uid != d-&gt;uid &amp;&amp; !wstatallow) { /* set to allow chown during boot */
		ou-&gt;err = Ewstatu;
		goto out;
	}

	/*
	 * if chgroup,
	 * must be either
	 *	a) owner and in new group
	 *	b) leader of both groups
	 */
	if (xd.gid != d-&gt;gid &amp;&amp;
	    (!wstatallow &amp;&amp; !writeallow &amp;&amp;  /* set to allow chgrp during boot */
	     (d-&gt;uid != f-&gt;uid || !ingroup(f-&gt;uid, xd.gid)) &amp;&amp;
	     (!leadgroup(f-&gt;uid, xd.gid) || !leadgroup(f-&gt;uid, d-&gt;gid)))) {
		ou-&gt;err = Ewstatg;
		goto out;
	}

	/*
	 * if rename,
	 * must have write permission in parent
	 */
	if (strncmp(d-&gt;name, xd.name, sizeof(d-&gt;name)) != 0) {
		if (checkname(xd.name) || !d1 ||
		    strcmp(xd.name, ".") == 0 || strcmp(xd.name, "..") == 0) {
			ou-&gt;err = Ename;
			goto out;
		}

		/*
		 * drop entry to prevent lock, then
		 * check that destination name is unique,
		 */
		putbuf(p);
		for(addr=0;; addr++) {
			p = dnodebuf(p1, d1, addr, 0, f-&gt;uid);
			if(!p)
				break;
			if(checktag(p, Tdir, d1-&gt;qid.path)) {
				putbuf(p);
				continue;
			}
			for(slot=0; slot&lt;DIRPERBUF; slot++) {
				d = getdir(p, slot);
				if(!(d-&gt;mode &amp; DALLOC))
					continue;
				if(!strncmp(xd.name, d-&gt;name, sizeof(xd.name))) {
					ou-&gt;err = Eexist;
					goto out;
				}
			}
			putbuf(p);
		}

		/*
		 * reacquire entry
		 */
		p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
		d = getdir(p, f-&gt;slot);
		if(!d || checktag(p, Tdir, QPNONE) || !(d-&gt;mode &amp; DALLOC)) {
			ou-&gt;err = Ephase;
			goto out;
		}

		if (!wstatallow &amp;&amp; !writeallow &amp;&amp; /* set to allow rename during boot */
		    (!d1 || iaccess(f, d1, DWRITE))) {
			ou-&gt;err = Eaccess;
			goto out;
		}
	}

	/*
	 * if mode/time, either
	 *	a) owner
	 *	b) leader of either group
	 */
	if (d-&gt;mtime != xd.mtime ||
	    ((d-&gt;mode^xd.mode) &amp; (DAPND|DLOCK|0777)))
		if (!wstatallow &amp;&amp;	/* set to allow chmod during boot */
		    d-&gt;uid != f-&gt;uid &amp;&amp;
		    !leadgroup(f-&gt;uid, xd.gid) &amp;&amp;
		    !leadgroup(f-&gt;uid, d-&gt;gid)) {
			ou-&gt;err = Ewstatu;
			goto out;
		}
	d-&gt;mtime = xd.mtime;
	d-&gt;uid = xd.uid;
	d-&gt;gid = xd.gid;
	d-&gt;mode = (xd.mode &amp; (DAPND|DLOCK|0777)) | (d-&gt;mode &amp; (DALLOC|DDIR));

	strncpy(d-&gt;name, xd.name, sizeof(d-&gt;name));
	accessdir(p, d, FREAD, f-&gt;uid);

out:
	if(p)
		putbuf(p);
	if(p1)
		putbuf(p1);
	if(f)
		qunlock(f);
	ou-&gt;fid = in-&gt;fid;
}

static void
f_clwalk(Chan *cp, Fcall *in, Fcall *ou)
{
	int er, fid;

	if(CHAT(cp))
		print("c_clwalk macro\n");

	f_clone(cp, in, ou);		/* sets tag, fid */
	if(ou-&gt;err)
		return;
	fid = in-&gt;fid;
	in-&gt;fid = in-&gt;newfid;
	f_walk(cp, in, ou);		/* sets tag, fid, qid */
	er = ou-&gt;err;
	if(er == Eentry) {
		/*
		 * if error is "no entry"
		 * return non error and fid
		 */
		ou-&gt;err = 0;
		f_clunk(cp, in, ou);	/* sets tag, fid */
		ou-&gt;err = 0;
		ou-&gt;fid = fid;
		if(CHAT(cp))
			print("\terror: %s\n", errstr9p[er]);
	} else if(er) {
		/*
		 * if any other error
		 * return an error
		 */
		ou-&gt;err = 0;
		f_clunk(cp, in, ou);	/* sets tag, fid */
		ou-&gt;err = er;
	}
	/*
	 * non error
	 * return newfid
	 */
}

void (*call9p1[MAXSYSCALL])(Chan*, Fcall*, Fcall*) =
{
	[Tnop]		f_nop,
	[Tosession]	f_session,
	[Tsession]	f_session,
	[Tflush]	f_flush,
	[Toattach]	f_attach,
	[Tattach]	f_attach,
	[Tclone]	f_clone,
	[Twalk]		f_walk,
	[Topen]		f_open,
	[Tcreate]	f_create,
	[Tread]		f_read,
	[Twrite]	f_write,
	[Tclunk]	f_clunk,
	[Tremove]	f_remove,
	[Tstat]		f_stat,
	[Twstat]	f_wstat,
	[Tclwalk]	f_clwalk,
};

int
error9p1(Chan* cp, Msgbuf* mb)
{
	Msgbuf *mb1;

	print("type=%d count=%d\n", mb-&gt;data[0], mb-&gt;count);
	print(" %.2x %.2x %.2x %.2x\n",
		mb-&gt;data[1]&amp;0xff, mb-&gt;data[2]&amp;0xff,
		mb-&gt;data[3]&amp;0xff, mb-&gt;data[4]&amp;0xff);
	print(" %.2x %.2x %.2x %.2x\n",
		mb-&gt;data[5]&amp;0xff, mb-&gt;data[6]&amp;0xff,
		mb-&gt;data[7]&amp;0xff, mb-&gt;data[8]&amp;0xff);
	print(" %.2x %.2x %.2x %.2x\n",
		mb-&gt;data[9]&amp;0xff, mb-&gt;data[10]&amp;0xff,
		mb-&gt;data[11]&amp;0xff, mb-&gt;data[12]&amp;0xff);

	mb1 = mballoc(3, cp, Mbreply4);
	mb1-&gt;data[0] = Rnop;	/* your nop was ok */
	mb1-&gt;data[1] = ~0;
	mb1-&gt;data[2] = ~0;
	mb1-&gt;count = 3;
	mb1-&gt;param = mb-&gt;param;
	fs_send(cp-&gt;reply, mb1);

	return 1;
}

int
serve9p1(Msgbuf* mb)
{
	int t, n;
	Chan *cp;
	Msgbuf *mb1;
	Fcall fi, fo;

	assert(mb != nil);
	cp = mb-&gt;chan;
	assert(mb-&gt;data != nil);
	if(convM2S9p1(mb-&gt;data, &amp;fi, mb-&gt;count) == 0){
		assert(cp != nil);
		if(cp-&gt;protocol == nil)
			return 0;
		print("9p1: bad M2S conversion\n");
		return error9p1(cp, mb);
	}

	t = fi.type;
	if(t &lt; 0 || t &gt;= MAXSYSCALL || (t&amp;1) || !call9p1[t]) {
		print("9p1: bad message type\n");
		return error9p1(cp, mb);
	}

	/*
	 * allocate reply message
	 */
	if(t == Tread) {
		mb1 = mballoc(MAXMSG+MAXDAT, cp, Mbreply2);
		fo.data = (char*)(mb1-&gt;data + 8);
	} else
		mb1 = mballoc(MAXMSG, cp, Mbreply3);

	/*
	 * call the file system
	 */
	assert(cp != nil);
	fo.err = 0;

	(*call9p1[t])(cp, &amp;fi, &amp;fo);

	fo.type = t+1;
	fo.tag = fi.tag;

	if(fo.err) {
		if(cons.flags&amp;errorflag)
			print("\ttype %d: error: %s\n", t, errstr9p[fo.err]);
		if(CHAT(cp))
			print("\terror: %s\n", errstr9p[fo.err]);
		fo.type = Rerror;
		strncpy(fo.ename, errstr9p[fo.err], sizeof(fo.ename));
	}

	n = convS2M9p1(&amp;fo, mb1-&gt;data);
	if(n == 0) {
		print("9p1: bad S2M conversion\n");
		mbfree(mb1);
		return error9p1(cp, mb);
	}
	mb1-&gt;count = n;
	mb1-&gt;param = mb-&gt;param;
	fs_send(cp-&gt;reply, mb1);

	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

