<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/9p2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/9p2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include &lt;fcall.h&gt;

enum { MSIZE = MAXDAT+MAXMSG };

static int
mkmode9p1(ulong mode9p2)
{
	int mode;

	/*
	 * Assume this is for an allocated entry.
	 */
	mode = DALLOC|(mode9p2 &amp; 0777);
	if(mode9p2 &amp; DMEXCL)
		mode |= DLOCK;
	if(mode9p2 &amp; DMAPPEND)
		mode |= DAPND;
	if(mode9p2 &amp; DMDIR)
		mode |= DDIR;

	return mode;
}

void
mkqid9p1(Qid9p1* qid9p1, Qid* qid)
{
	if(qid-&gt;path &amp; 0xFFFFFFFF00000000LL)
		panic("mkqid9p1: path %lluX", (Wideoff)qid-&gt;path);
	qid9p1-&gt;path = qid-&gt;path &amp; 0xFFFFFFFF;
	if(qid-&gt;type &amp; QTDIR)
		qid9p1-&gt;path |= QPDIR;
	qid9p1-&gt;version = qid-&gt;vers;
}

static int
mktype9p2(int mode9p1)
{
	int type;

	type = 0;
	if(mode9p1 &amp; DLOCK)
		type |= QTEXCL;
	if(mode9p1 &amp; DAPND)
		type |= QTAPPEND;
	if(mode9p1 &amp; DDIR)
		type |= QTDIR;

	return type;
}

static ulong
mkmode9p2(int mode9p1)
{
	ulong mode;

	mode = mode9p1 &amp; 0777;
	if(mode9p1 &amp; DLOCK)
		mode |= DMEXCL;
	if(mode9p1 &amp; DAPND)
		mode |= DMAPPEND;
	if(mode9p1 &amp; DDIR)
		mode |= DMDIR;

	return mode;
}

void
mkqid9p2(Qid* qid, Qid9p1* qid9p1, int mode9p1)
{
	qid-&gt;path = (ulong)(qid9p1-&gt;path &amp; ~QPDIR);
	qid-&gt;vers = qid9p1-&gt;version;
	qid-&gt;type = mktype9p2(mode9p1);
}

static int
mkdir9p2(Dir* dir, Dentry* dentry, void* strs)
{
	char *op, *p;

	memset(dir, 0, sizeof(Dir));
	mkqid(&amp;dir-&gt;qid, dentry, 1);
	dir-&gt;mode = mkmode9p2(dentry-&gt;mode);
	dir-&gt;atime = dentry-&gt;atime;
	dir-&gt;mtime = dentry-&gt;mtime;
	dir-&gt;length = dentry-&gt;size;

	op = p = strs;
	dir-&gt;name = p;
	p += sprint(p, "%s", dentry-&gt;name)+1;

	dir-&gt;uid = p;
	uidtostr(p, dentry-&gt;uid, 1);
	p += strlen(p)+1;

	dir-&gt;gid = p;
	uidtostr(p, dentry-&gt;gid, 1);
	p += strlen(p)+1;

	dir-&gt;muid = p;
	uidtostr(p, dentry-&gt;muid, 1);
	p += strlen(p)+1;

	return p-op;
}

static int
checkname9p2(char* name)
{
	char *p;

	/*
	 * Return error or 0 if OK.
	 */
	if(name == nil || *name == 0)
		return Ename;

	for(p = name; *p != 0; p++){
		if(p-name &gt;= NAMELEN-1)
			return Etoolong;
		if((*p &amp; 0xFF) &lt;= 040)
			return Ename;
	}
	if(strcmp(name, ".") == 0 || strcmp(name, "..") == 0)
		return Edot;

	return 0;
}

static int
version(Chan* chan, Fcall* f, Fcall* r)
{
	if(chan-&gt;protocol != nil)
		return Eversion;

	if(f-&gt;msize &lt; MSIZE)
		r-&gt;msize = f-&gt;msize;
	else
		r-&gt;msize = MSIZE;

	/*
	 * Should check the '.' stuff here.
	 */
	if(strcmp(f-&gt;version, VERSION9P) == 0){
		r-&gt;version = VERSION9P;
		chan-&gt;protocol = serve9p2;
		chan-&gt;msize = r-&gt;msize;
	} else
		r-&gt;version = "unknown";

	fileinit(chan);
	return 0;
}

struct {
	Lock;
	ulong	hi;
} authpath;

static int
auth(Chan* chan, Fcall* f, Fcall* r)
{
	char *aname;
	File *file;
	Filsys *fs;
	int error;

	if(cons.flags &amp; authdisableflag)
		return Eauthdisabled;

	error = 0;
	aname = f-&gt;aname;

	if(strcmp(f-&gt;uname, "none") == 0)
		return Eauthnone;

	if(!aname[0])	/* default */
		aname = "main";
	file = filep(chan, f-&gt;afid, 1);
	if(file == nil){
		error = Efidinuse;
		goto out;
	}
	fs = fsstr(aname);
	if(fs == nil){
		error = Ebadspc;
		goto out;
	}
	lock(&amp;authpath);
	file-&gt;qid.path = authpath.hi++;
	unlock(&amp;authpath);
	file-&gt;qid.type = QTAUTH;
	file-&gt;qid.vers = 0;
	file-&gt;fs = fs;
	file-&gt;open = FREAD+FWRITE;
	freewp(file-&gt;wpath);
	file-&gt;wpath = 0;
	file-&gt;auth = authnew(f-&gt;uname, f-&gt;aname);
	if(file-&gt;auth == nil){
		error = Eauthfile;
		goto out;
	}
	r-&gt;aqid = file-&gt;qid;

out:
	if((cons.flags &amp; attachflag) &amp;&amp; error)
		print("9p2: auth %s %T SUCK EGGS --- %s\n",
			f-&gt;uname, time(nil), errstr9p[error]);
	if(file != nil){
		qunlock(file);
		if(error)
			freefp(file);
	}
	return error;
}

int
authorize(Chan* chan, Fcall* f)
{
	File* af;
	int db, uid = -1;

	db = cons.flags &amp; authdebugflag;

	if(strcmp(f-&gt;uname, "none") == 0){
		uid = strtouid(f-&gt;uname);
		if(db)
			print("permission granted to none: uid %s = %d\n",
				f-&gt;uname, uid);
		return uid;
	}

	if(cons.flags &amp; authdisableflag){
		uid = strtouid(f-&gt;uname);
		if(db)
			print("permission granted by authdisable uid %s = %d\n",
				f-&gt;uname, uid);
		return uid;
	}

	af = filep(chan, f-&gt;afid, 0);
	if(af == nil){
		if(db)
			print("authorize: af == nil\n");
		return -1;
	}
	if(af-&gt;auth == nil){
		if(db)
			print("authorize: af-&gt;auth == nil\n");
		goto out;
	}
	if(strcmp(f-&gt;uname, authuname(af-&gt;auth)) != 0){
		if(db)
			print("authorize: strcmp(f-&gt;uname, authuname(af-&gt;auth)) != 0\n");
		goto out;
	}
	if(strcmp(f-&gt;aname, authaname(af-&gt;auth)) != 0){
		if(db)
			print("authorize: strcmp(f-&gt;aname, authaname(af-&gt;auth)) != 0\n");
		goto out;
	}
	uid = authuid(af-&gt;auth);
	if(db)
		print("authorize: uid is %d\n", uid);
out:
	qunlock(af);
	return uid;
}

static int
attach(Chan* chan, Fcall* f, Fcall* r)
{
	char *aname;
	Iobuf *p;
	Dentry *d;
	File *file;
	Filsys *fs;
	Off raddr;
	int error, u;

	aname = f-&gt;aname;
	if(!aname[0])	/* default */
		aname = "main";
	p = nil;
	error = 0;
	file = filep(chan, f-&gt;fid, 1);
	if(file == nil){
		error = Efidinuse;
		goto out;
	}

	u = -1;
	if(chan != cons.chan){
		if(noattach &amp;&amp; strcmp(f-&gt;uname, "none")) {
			error = Enoattach;
			goto out;
		}
		u = authorize(chan, f);
		if(u &lt; 0){
			error = Ebadu;
			goto out;
		}
	}
	file-&gt;uid = u;

	fs = fsstr(aname);
	if(fs == nil){
		error = Ebadspc;
		goto out;
	}
	raddr = getraddr(fs-&gt;dev);
	p = getbuf(fs-&gt;dev, raddr, Brd);
	if(p == nil || checktag(p, Tdir, QPROOT)){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, 0);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if (iaccess(file, d, DEXEC) ||
	    file-&gt;uid == 0 &amp;&amp; fs-&gt;dev-&gt;type == Devro) {
		/*
		 * 'none' not allowed on dump
		 */
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, file-&gt;uid);
	mkqid(&amp;file-&gt;qid, d, 1);
	file-&gt;fs = fs;
	file-&gt;addr = raddr;
	file-&gt;slot = 0;
	file-&gt;open = 0;
	freewp(file-&gt;wpath);
	file-&gt;wpath = 0;

	r-&gt;qid = file-&gt;qid;

	strncpy(chan-&gt;whoname, f-&gt;uname, sizeof(chan-&gt;whoname));
	chan-&gt;whotime = time(nil);
	if(cons.flags &amp; attachflag)
		print("9p2: attach %s %T to \"%s\" C%d\n",
			chan-&gt;whoname, chan-&gt;whotime, fs-&gt;name, chan-&gt;chan);

out:
	if((cons.flags &amp; attachflag) &amp;&amp; error)
		print("9p2: attach %s %T SUCK EGGS --- %s\n",
			f-&gt;uname, time(nil), errstr9p[error]);
	if(p != nil)
		putbuf(p);
	if(file != nil){
		qunlock(file);
		if(error)
			freefp(file);
	}
	return error;
}

static int
flush(Chan* chan, Fcall*, Fcall*)
{
	runlock(&amp;chan-&gt;reflock);
	wlock(&amp;chan-&gt;reflock);
	wunlock(&amp;chan-&gt;reflock);
	rlock(&amp;chan-&gt;reflock);

	return 0;
}

static void
clone(File* nfile, File* file)
{
	Wpath *wpath;

	nfile-&gt;qid = file-&gt;qid;

	lock(&amp;wpathlock);
	nfile-&gt;wpath = file-&gt;wpath;
	for(wpath = nfile-&gt;wpath; wpath != nil; wpath = wpath-&gt;up)
		wpath-&gt;refs++;
	unlock(&amp;wpathlock);

	nfile-&gt;fs = file-&gt;fs;
	nfile-&gt;addr = file-&gt;addr;
	nfile-&gt;slot = file-&gt;slot;
	nfile-&gt;uid = file-&gt;uid;
	nfile-&gt;open = file-&gt;open &amp; ~FREMOV;
}

static int
walkname(File* file, char* wname, Qid* wqid)
{
	Wpath *w;
	Iobuf *p, *p1;
	Dentry *d, *d1;
	int error, slot;
	Off addr, qpath;

	p = p1 = nil;

	/*
	 * File must not have been opened for I/O by an open
	 * or create message and must represent a directory.
	 */
	if(file-&gt;open != 0){
		error = Emode;
		goto out;
	}

	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Edir1;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(!(d-&gt;mode &amp; DDIR)){
		error = Edir1;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;

	/*
	 * For walked elements the implied user must
	 * have permission to search the directory.
	 */
	if(file-&gt;cp != cons.chan &amp;&amp; iaccess(file, d, DEXEC)){
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, file-&gt;uid);

	if(strcmp(wname, ".") == 0){
setdot:
		if(wqid != nil)
			*wqid = file-&gt;qid;
		goto out;
	}
	if(strcmp(wname, "..") == 0){
		if(file-&gt;wpath == 0)
			goto setdot;
		putbuf(p);
		p = nil;
		addr = file-&gt;wpath-&gt;addr;
		slot = file-&gt;wpath-&gt;slot;
		p1 = getbuf(file-&gt;fs-&gt;dev, addr, Brd);
		if(p1 == nil || checktag(p1, Tdir, QPNONE)){
			error = Edir1;
			goto out;
		}
		d1 = getdir(p1, slot);
		if(d == nil || !(d1-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}
		lock(&amp;wpathlock);
		file-&gt;wpath-&gt;refs--;
		file-&gt;wpath = file-&gt;wpath-&gt;up;
		unlock(&amp;wpathlock);
		goto found;
	}

	for(addr = 0; ; addr++){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
			if(p == nil || checktag(p, Tdir, QPNONE)){
				error = Ealloc;
				goto out;
			}
			d = getdir(p, file-&gt;slot);
			if(d == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, 0, file-&gt;uid);
		p = nil;
		if(p1 == nil || checktag(p1, Tdir, qpath)){
			error = Eentry;
			goto out;
		}
		for(slot = 0; slot &lt; DIRPERBUF; slot++){
			d1 = getdir(p1, slot);
			if (!(d1-&gt;mode &amp; DALLOC) ||
			    strncmp(wname, d1-&gt;name, NAMELEN) != 0)
				continue;
			/*
			 * update walk path
			 */
			if((w = newwp()) == nil){
				error = Ewalk;
				goto out;
			}
			w-&gt;addr = file-&gt;addr;
			w-&gt;slot = file-&gt;slot;
			w-&gt;up = file-&gt;wpath;
			file-&gt;wpath = w;
			slot += DIRPERBUF*addr;
			goto found;
		}
		putbuf(p1);
		p1 = nil;
	}

found:
	file-&gt;addr = p1-&gt;addr;
	mkqid(&amp;file-&gt;qid, d1, 1);
	putbuf(p1);
	p1 = nil;
	file-&gt;slot = slot;
	if(wqid != nil)
		*wqid = file-&gt;qid;

out:
	if(p1 != nil)
		putbuf(p1);
	if(p != nil)
		putbuf(p);

	return error;
}

static int
walk(Chan* chan, Fcall* f, Fcall* r)
{
	int error, nwname;
	File *file, *nfile, tfile;

	/*
	 * The file identified by f-&gt;fid must be valid in the
	 * current session and must not have been opened for I/O
	 * by an open or create message.
	 */
	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;
	if(file-&gt;open != 0){
		qunlock(file);
		return Emode;
	}

	/*
	 * If newfid is not the same as fid, allocate a new file;
	 * a side effect is checking newfid is not already in use (error);
	 * if there are no names to walk this will be equivalent to a
	 * simple 'clone' operation.
	 * Otherwise, fid and newfid are the same and if there are names
	 * to walk make a copy of 'file' to be used during the walk as
	 * 'file' must only be updated on success.
	 * Finally, it's a no-op if newfid is the same as fid and f-&gt;nwname
	 * is 0.
	 */
	r-&gt;nwqid = 0;
	if(f-&gt;newfid != f-&gt;fid){
		if((nfile = filep(chan, f-&gt;newfid, 1)) == nil){
			qunlock(file);
			return Efidinuse;
		}
	} else if(f-&gt;nwname != 0){
		nfile = &amp;tfile;
		memset(nfile, 0, sizeof(File));
		nfile-&gt;cp = chan;
		nfile-&gt;fid = ~0;
	} else {
		qunlock(file);
		return 0;
	}
	clone(nfile, file);

	/*
	 * Should check name is not too long.
	 */
	error = 0;
	for(nwname = 0; nwname &lt; f-&gt;nwname; nwname++){
		error = walkname(nfile, f-&gt;wname[nwname], &amp;r-&gt;wqid[r-&gt;nwqid]);
		if(error != 0 || ++r-&gt;nwqid &gt;= MAXDAT/sizeof(Qid))
			break;
	}

	if(f-&gt;nwname == 0){
		/*
		 * Newfid must be different to fid (see above)
		 * so this is a simple 'clone' operation - there's
		 * nothing to do except unlock unless there's
		 * an error.
		 */
		if(error){
			freewp(nfile-&gt;wpath);
			qunlock(nfile);
			freefp(nfile);
		} else
			qunlock(nfile);
	} else if(r-&gt;nwqid &lt; f-&gt;nwname){
		/*
		 * Didn't walk all elements, 'clunk' nfile
		 * and leave 'file' alone.
		 * Clear error if some of the elements were
		 * walked OK.
		 */
		freewp(nfile-&gt;wpath);
		if(nfile != &amp;tfile){
			qunlock(nfile);
			freefp(nfile);
		}
		if(r-&gt;nwqid != 0)
			error = 0;
	} else {
		/*
		 * Walked all elements. If newfid is the same
		 * as fid must update 'file' from the temporary
		 * copy used during the walk.
		 * Otherwise just unlock (when using tfile there's
		 * no need to unlock as it's a local).
		 */
		if(nfile == &amp;tfile){
			file-&gt;qid = nfile-&gt;qid;
			freewp(file-&gt;wpath);
			file-&gt;wpath = nfile-&gt;wpath;
			file-&gt;addr = nfile-&gt;addr;
			file-&gt;slot = nfile-&gt;slot;
		} else
			qunlock(nfile);
	}
	qunlock(file);

	return error;
}

static int
fs_open(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p;
	Dentry *d;
	File *file;
	Tlock *t;
	Qid qid;
	int error, ro, fmod, wok;

	wok = 0;
	p = nil;

	if(chan == cons.chan || writeallow)
		wok = 1;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(file-&gt;open != 0){
		error = Emode;
		goto out;
	}

	/*
	 * if remove on close, check access here
	 */
	ro = file-&gt;fs-&gt;dev-&gt;type == Devro;
	if(f-&gt;mode &amp; ORCLOSE){
		if(ro){
			error = Eronly;
			goto out;
		}
		/*
		 * check on parent directory of file to be deleted
		 */
		if(file-&gt;wpath == 0 || file-&gt;wpath-&gt;addr == file-&gt;addr){
			error = Ephase;
			goto out;
		}
		p = getbuf(file-&gt;fs-&gt;dev, file-&gt;wpath-&gt;addr, Brd);
		if(p == nil || checktag(p, Tdir, QPNONE)){
			error = Ephase;
			goto out;
		}
		d = getdir(p, file-&gt;wpath-&gt;slot);
		if(d == nil || !(d-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}
		if(iaccess(file, d, DWRITE)){
			error = Eaccess;
			goto out;
		}
		putbuf(p);
	}
	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	mkqid(&amp;qid, d, 1);
	switch(f-&gt;mode &amp; 7){

	case OREAD:
		if(iaccess(file, d, DREAD) &amp;&amp; !wok)
			goto badaccess;
		fmod = FREAD;
		break;

	case OWRITE:
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
		fmod = FWRITE;
		break;

	case ORDWR:
		if((d-&gt;mode &amp; DDIR)
		|| (iaccess(file, d, DREAD) &amp;&amp; !wok)
		|| (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
		fmod = FREAD+FWRITE;
		break;

	case OEXEC:
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DEXEC) &amp;&amp; !wok))
			goto badaccess;
		fmod = FREAD;
		break;

	default:
		error = Emode;
		goto out;
	}
	if(f-&gt;mode &amp; OTRUNC){
		if((d-&gt;mode &amp; DDIR) || (iaccess(file, d, DWRITE) &amp;&amp; !wok))
			goto badaccess;
		if(ro){
			error = Eronly;
			goto out;
		}
	}
	t = 0;
	if(d-&gt;mode &amp; DLOCK){
		if((t = tlocked(p, d)) == nil){
			error = Elocked;
			goto out;
		}
	}
	if(f-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	file-&gt;open = fmod;
	if((f-&gt;mode &amp; OTRUNC) &amp;&amp; !(d-&gt;mode &amp; DAPND)){
		dtrunc(p, d, file-&gt;uid);
		qid.vers = d-&gt;qid.version;
	}
	r-&gt;qid = qid;
	file-&gt;tlock = t;
	if(t != nil)
		t-&gt;file = file;
	file-&gt;lastra = 1;
	goto out;

badaccess:
	error = Eaccess;
	file-&gt;open = 0;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	r-&gt;iounit = chan-&gt;msize-IOHDRSZ;

	return error;
}

static int
fs_create(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *file;
	int error, slot, slot1, fmod, wok;
	Off addr, addr1, path;
	Tlock *t;
	Wpath *w;

	wok = 0;
	p = nil;

	if(chan == cons.chan || writeallow)
		wok = 1;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(file-&gt;fs-&gt;dev-&gt;type == Devro){
		error = Eronly;
		goto out;
	}
	if(file-&gt;qid.type &amp; QTAUTH){
		error = Emode;
		goto out;
	}

	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(!(d-&gt;mode &amp; DDIR)){
		error = Edir2;
		goto out;
	}
	if(iaccess(file, d, DWRITE) &amp;&amp; !wok) {
		error = Eaccess;
		goto out;
	}
	accessdir(p, d, FREAD, file-&gt;uid);

	/*
	 * Check the name is valid (and will fit in an old
	 * directory entry for the moment).
	 */
	if(error = checkname9p2(f-&gt;name))
		goto out;

	addr1 = 0;
	slot1 = 0;	/* set */
	for(addr = 0; ; addr++){
		if((p1 = dnodebuf(p, d, addr, 0, file-&gt;uid)) == nil){
			if(addr1 != 0)
				break;
			p1 = dnodebuf(p, d, addr, Tdir, file-&gt;uid);
		}
		if(p1 == nil){
			error = Efull;
			goto out;
		}
		if(checktag(p1, Tdir, d-&gt;qid.path)){
			putbuf(p1);
			goto phase;
		}
		for(slot = 0; slot &lt; DIRPERBUF; slot++){
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC)){
				if(addr1 == 0){
					addr1 = p1-&gt;addr;
					slot1 = slot + addr*DIRPERBUF;
				}
				continue;
			}
			if(strncmp(f-&gt;name, d1-&gt;name, sizeof(d1-&gt;name)) == 0){
				putbuf(p1);
				error = Eexist;
				goto out;
			}
		}
		putbuf(p1);
	}

	switch(f-&gt;mode &amp; 7){
	case OEXEC:
	case OREAD:		/* seems only useful to make directories */
		fmod = FREAD;
		break;

	case OWRITE:
		fmod = FWRITE;
		break;

	case ORDWR:
		fmod = FREAD+FWRITE;
		break;

	default:
		error = Emode;
		goto out;
	}
	if(f-&gt;perm &amp; PDIR)
		if((f-&gt;mode &amp; OTRUNC) || (f-&gt;perm &amp; PAPND) || (fmod &amp; FWRITE))
			goto badaccess;
	/*
	 * do it
	 */
	path = qidpathgen(file-&gt;fs-&gt;dev);
	if((p1 = getbuf(file-&gt;fs-&gt;dev, addr1, Brd|Bimm|Bmod)) == nil)
		goto phase;
	d1 = getdir(p1, slot1);
	if(d1 == nil || checktag(p1, Tdir, d-&gt;qid.path)) {
		putbuf(p1);
		goto phase;
	}
	if(d1-&gt;mode &amp; DALLOC){
		putbuf(p1);
		goto phase;
	}

	strncpy(d1-&gt;name, f-&gt;name, sizeof(d1-&gt;name));
	if(chan == cons.chan){
		d1-&gt;uid = cons.uid;
		d1-&gt;gid = cons.gid;
	} else {
		d1-&gt;uid = file-&gt;uid;
		d1-&gt;gid = d-&gt;gid;
		f-&gt;perm &amp;= d-&gt;mode | ~0666;
		if(f-&gt;perm &amp; PDIR)
			f-&gt;perm &amp;= d-&gt;mode | ~0777;
	}
	d1-&gt;qid.path = path;
	d1-&gt;qid.version = 0;
	d1-&gt;mode = DALLOC | (f-&gt;perm &amp; 0777);
	if(f-&gt;perm &amp; PDIR) {
		d1-&gt;mode |= DDIR;
		d1-&gt;qid.path |= QPDIR;
	}
	if(f-&gt;perm &amp; PAPND)
		d1-&gt;mode |= DAPND;
	t = nil;
	if(f-&gt;perm &amp; PLOCK){
		d1-&gt;mode |= DLOCK;
		t = tlocked(p1, d1);
		/* if nil, out of tlock structures */
	}
	accessdir(p1, d1, FWRITE, file-&gt;uid);
	mkqid(&amp;r-&gt;qid, d1, 0);
	putbuf(p1);
	accessdir(p, d, FWRITE, file-&gt;uid);

	/*
	 * do a walk to new directory entry
	 */
	if((w = newwp()) == nil){
		error = Ewalk;
		goto out;
	}
	w-&gt;addr = file-&gt;addr;
	w-&gt;slot = file-&gt;slot;
	w-&gt;up = file-&gt;wpath;
	file-&gt;wpath = w;
	file-&gt;qid = r-&gt;qid;
	file-&gt;tlock = t;
	if(t != nil)
		t-&gt;file = file;
	file-&gt;lastra = 1;
	if(f-&gt;mode &amp; ORCLOSE)
		fmod |= FREMOV;
	file-&gt;open = fmod;
	file-&gt;addr = addr1;
	file-&gt;slot = slot1;
	goto out;

badaccess:
	error = Eaccess;
	goto out;

phase:
	error = Ephase;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	r-&gt;iounit = chan-&gt;msize-IOHDRSZ;

	return error;
}

static int
fs_read(Chan* chan, Fcall* f, Fcall* r, uchar* data)
{
	Iobuf *p, *p1;
	File *file;
	Dentry *d, *d1;
	Tlock *t;
	Off addr, offset, start;
	Timet tim;
	int error, iounit, nread, count, n, o, slot;
	Msgbuf *dmb;
	Dir dir;

	p = nil;

	error = 0;
	count = f-&gt;count;
	offset = f-&gt;offset;
	nread = 0;
	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(!(file-&gt;open &amp; FREAD)){
		error = Eopen;
		goto out;
	}
	iounit = chan-&gt;msize-IOHDRSZ;
	if(count &lt; 0 || count &gt; iounit){
		error = Ecount;
		goto out;
	}
	if(offset &lt; 0){
		error = Eoffset;
		goto out;
	}
	if(file-&gt;qid.type &amp; QTAUTH){
		nread = authread(file, (uchar*)data, count);
		if(nread &lt; 0)
			error = Eauth2;
		goto out;
	}
	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(t = file-&gt;tlock){
		tim = toytime();
		if(t-&gt;time &lt; tim || t-&gt;file != file){
			error = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FREAD, file-&gt;uid);
	if(d-&gt;mode &amp; DDIR)
		goto dread;
	if(offset+count &gt; d-&gt;size)
		count = d-&gt;size - offset;
	while(count &gt; 0){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
			if(p == nil || checktag(p, Tdir, QPNONE)){
				error = Ealloc;
				goto out;
			}
			d = getdir(p, file-&gt;slot);
			if(d == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		file-&gt;lastra = dbufread(p, d, addr, file-&gt;lastra, file-&gt;uid);
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		p1 = dnodebuf1(p, d, addr, 0, file-&gt;uid);
		p = nil;
		if(p1 != nil){
			if(checktag(p1, Tfile, QPNONE)){
				error = Ephase;
				putbuf(p1);
				goto out;
			}
			memmove(data+nread, p1-&gt;iobuf+o, n);
			putbuf(p1);
		} else
			memset(data+nread, 0, n);
		count -= n;
		nread += n;
		offset += n;
	}
	goto out;

dread:
	/*
	 * Pick up where we left off last time if nothing has changed,
	 * otherwise must scan from the beginning.
	 */
	if(offset == file-&gt;doffset /*&amp;&amp; file-&gt;qid.vers == file-&gt;dvers*/){
		addr = file-&gt;dslot/DIRPERBUF;
		slot = file-&gt;dslot%DIRPERBUF;
		start = offset;
	} else {
		addr = 0;
		slot = 0;
		start = 0;
	}

	dmb = mballoc(iounit, chan, Mbreply1);
	for (;;) {
		if(p == nil){
			/*
			 * This is just a check to ensure the entry hasn't
			 * gone away during the read of each directory block.
			 */
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
			if(p == nil || checktag(p, Tdir, QPNONE)){
				error = Ealloc;
				goto out1;
			}
			d = getdir(p, file-&gt;slot);
			if(d == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out1;
			}
		}
		p1 = dnodebuf1(p, d, addr, 0, file-&gt;uid);
		p = nil;
		if(p1 == nil)
			goto out1;
		if(checktag(p1, Tdir, QPNONE)){
			error = Ephase;
			putbuf(p1);
			goto out1;
		}

		for(; slot &lt; DIRPERBUF; slot++){
			d1 = getdir(p1, slot);
			if(!(d1-&gt;mode &amp; DALLOC))
				continue;
			mkdir9p2(&amp;dir, d1, dmb-&gt;data);
			n = convD2M(&amp;dir, data+nread, iounit - nread);
			if(n &lt;= BIT16SZ){
				putbuf(p1);
				goto out1;
			}
			start += n;
			if(start &lt; offset)
				continue;
			if(count &lt; n){
				putbuf(p1);
				goto out1;
			}
			count -= n;
			nread += n;
			offset += n;
		}
		putbuf(p1);
		slot = 0;
		addr++;
	}
out1:
	mbfree(dmb);
	if(error == 0){
		file-&gt;doffset = offset;
		file-&gt;dvers = file-&gt;qid.vers;
		file-&gt;dslot = slot+DIRPERBUF*addr;
	}

out:
	/*
	 * Do we need this any more?
	count = f-&gt;count - nread;
	if(count &gt; 0)
		memset(data+nread, 0, count);
	 */
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);
	r-&gt;count = nread;
	r-&gt;data = (char*)data;

	return error;
}

static int
fs_write(Chan* chan, Fcall* f, Fcall* r)
{
	Iobuf *p, *p1;
	Dentry *d;
	File *file;
	Tlock *t;
	Off offset, addr, qpath;
	Timet tim;
	int count, error, nwrite, o, n;

	error = 0;
	offset = f-&gt;offset;
	count = f-&gt;count;

	nwrite = 0;
	p = nil;

	if((file = filep(chan, f-&gt;fid, 0)) == nil){
		error = Efid;
		goto out;
	}
	if(!(file-&gt;open &amp; FWRITE)){
		error = Eopen;
		goto out;
	}
	if(count &lt; 0 || count &gt; chan-&gt;msize-IOHDRSZ){
		error = Ecount;
		goto out;
	}
	if(offset &lt; 0) {
		error = Eoffset;
		goto out;
	}

	if(file-&gt;qid.type &amp; QTAUTH){
		nwrite = authwrite(file, (uchar*)f-&gt;data, count);
		if(nwrite &lt; 0)
			error = Eauth2;
		goto out;
	} else if(file-&gt;fs-&gt;dev-&gt;type == Devro){
		error = Eronly;
		goto out;
	}

	if ((p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd|Bmod)) == nil ||
	    (d = getdir(p, file-&gt;slot)) == nil || !(d-&gt;mode &amp; DALLOC)) {
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;
	if(t = file-&gt;tlock) {
		tim = toytime();
		if(t-&gt;time &lt; tim || t-&gt;file != file){
			error = Ebroken;
			goto out;
		}
		/* renew the lock */
		t-&gt;time = tim + TLOCK;
	}
	accessdir(p, d, FWRITE, file-&gt;uid);
	if(d-&gt;mode &amp; DAPND)
		offset = d-&gt;size;
	if(offset+count &gt; d-&gt;size)
		d-&gt;size = offset+count;
	while(count &gt; 0){
		if(p == nil){
			p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd|Bmod);
			if(p == nil){
				error = Ealloc;
				goto out;
			}
			d = getdir(p, file-&gt;slot);
			if(d == nil || !(d-&gt;mode &amp; DALLOC)){
				error = Ealloc;
				goto out;
			}
		}
		addr = offset / BUFSIZE;
		o = offset % BUFSIZE;
		n = BUFSIZE - o;
		if(n &gt; count)
			n = count;
		qpath = d-&gt;qid.path;
		p1 = dnodebuf1(p, d, addr, Tfile, file-&gt;uid);
		p = nil;
		if(p1 == nil) {
			error = Efull;
			goto out;
		}
		if(checktag(p1, Tfile, qpath)){
			putbuf(p1);
			error = Ephase;
			goto out;
		}
		memmove(p1-&gt;iobuf+o, f-&gt;data+nwrite, n);
		p1-&gt;flags |= Bmod;
		putbuf(p1);
		count -= n;
		nwrite += n;
		offset += n;
	}

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);
	r-&gt;count = nwrite;

	return error;
}

static int
_clunk(File* file, int remove, int wok)
{
	Tlock *t;
	int error;

	error = 0;
	if(t = file-&gt;tlock){
		if(t-&gt;file == file)
			t-&gt;time = 0;		/* free the lock */
		file-&gt;tlock = 0;
	}
	if(remove &amp;&amp; (file-&gt;qid.type &amp; QTAUTH) == 0)
		error = doremove(file, wok);
	file-&gt;open = 0;
	freewp(file-&gt;wpath);
	authfree(file-&gt;auth);
	freefp(file);
	qunlock(file);

	return error;
}

static int
clunk(Chan* chan, Fcall* f, Fcall*)
{
	File *file;

	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;

	_clunk(file, file-&gt;open &amp; FREMOV, 0);
	return 0;
}

static int
fs_remove(Chan* chan, Fcall* f, Fcall*)
{
	File *file;

	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;

	return _clunk(file, 1, chan == cons.chan);
}

static int
fs_stat(Chan* chan, Fcall* f, Fcall* r, uchar* data)
{
	Dir dir;
	Iobuf *p;
	Dentry *d, dentry;
	File *file;
	int error, len;

	error = 0;
	p = nil;
	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;
	if(file-&gt;qid.type &amp; QTAUTH){
		memset(&amp;dentry, 0, sizeof dentry);
		d = &amp;dentry;
		mkqid9p1(&amp;d-&gt;qid, &amp;file-&gt;qid);
		strcpy(d-&gt;name, "#¿");
		d-&gt;uid = authuid(file-&gt;auth);
		d-&gt;gid = d-&gt;uid;
		d-&gt;muid = d-&gt;uid;
		d-&gt;atime = time(nil);
		d-&gt;mtime = d-&gt;atime;
		d-&gt;size = 0;
	} else {
		p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
		if(p == nil || checktag(p, Tdir, QPNONE)){
			error = Edir1;
			goto out;
		}
		d = getdir(p, file-&gt;slot);
		if(d == nil || !(d-&gt;mode &amp; DALLOC)){
			error = Ealloc;
			goto out;
		}
		if(error = mkqidcmp(&amp;file-&gt;qid, d))
			goto out;

		if(d-&gt;qid.path == QPROOT)	/* stat of root gives time */
			d-&gt;atime = time(nil);
	}
	len = mkdir9p2(&amp;dir, d, data);
	data += len;

	if((r-&gt;nstat = convD2M(&amp;dir, data, chan-&gt;msize - len)) == 0)
		error = Eedge;
	r-&gt;stat = data;

out:
	if(p != nil)
		putbuf(p);
	if(file != nil)
		qunlock(file);

	return error;
}

static int
fs_wstat(Chan* chan, Fcall* f, Fcall*, char* strs)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	File *file;
	int error, err, gid, gl, muid, op, slot, tsync, uid;
	long addr;
	Dir dir;

	if(convM2D(f-&gt;stat, f-&gt;nstat, &amp;dir, strs) == 0)
		return Econvert;

	/*
	 * Get the file.
	 * If user 'none' (uid == 0), can't do anything;
	 * if filesystem is read-only, can't change anything.
	 */
	if((file = filep(chan, f-&gt;fid, 0)) == nil)
		return Efid;
	p = p1 = nil;
	if(file-&gt;uid == 0){
		error = Eaccess;
		goto out;
	}
	if(file-&gt;fs-&gt;dev-&gt;type == Devro){
		error = Eronly;
		goto out;
	}
	if(file-&gt;qid.type &amp; QTAUTH){
		error = Emode;
		goto out;
	}

	/*
	 * Get the current entry and check it is still valid.
	 */
	p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
	if(p == nil || checktag(p, Tdir, QPNONE)){
		error = Ealloc;
		goto out;
	}
	d = getdir(p, file-&gt;slot);
	if(d == nil || !(d-&gt;mode &amp; DALLOC)){
		error = Ealloc;
		goto out;
	}
	if(error = mkqidcmp(&amp;file-&gt;qid, d))
		goto out;

	/*
	 * Run through each of the (sub-)fields in the provided Dir
	 * checking for validity and whether it's a default:
	 * .type, .dev and .atime are completely ignored and not checked;
	 * .qid.path, .qid.vers and .muid are checked for validity but
	 * any attempt to change them is an error.
	 * .qid.type/.mode, .mtime, .name, .length, .uid and .gid can
	 * possibly be changed (and .muid iff wstatallow).
	 *
	 * 'Op' flags there are changed fields, i.e. it's not a no-op.
	 * 'Tsync' flags all fields are defaulted.
	 *
	 * Wstatallow and writeallow are set to allow changes during the
	 * fileserver bootstrap phase.
	 */
	tsync = 1;
	if(dir.qid.path != ~0){
		if(dir.qid.path != file-&gt;qid.path){
			error = Ewstatp;
			goto out;
		}
		tsync = 0;
	}
	if(dir.qid.vers != ~0){
		if(dir.qid.vers != file-&gt;qid.vers){
			error = Ewstatv;
			goto out;
		}
		tsync = 0;
	}

	/*
	 * .qid.type and .mode have some bits in common. Only .mode
	 * is currently needed for comparisons with the old mode but
	 * if there are changes to the bits also encoded in .qid.type
	 * then file-&gt;qid must be updated appropriately later.
	 */
	if(dir.qid.type == (uchar)~0){
		if(dir.mode == ~0)
			dir.qid.type = mktype9p2(d-&gt;mode);
		else
			dir.qid.type = dir.mode&gt;&gt;24;
	} else
		tsync = 0;
	if(dir.mode == ~0)
		dir.mode = mkmode9p2(d-&gt;mode);
	else
		tsync = 0;

	/*
	 * Check dir.qid.type and dir.mode agree, check for any unknown
	 * type/mode bits, check for an attempt to change the directory bit.
	 */
	if(dir.qid.type != ((dir.mode&gt;&gt;24) &amp; 0xFF)){
		error = Ewstatq;
		goto out;
	}
	if(dir.mode &amp; ~(DMDIR|DMAPPEND|DMEXCL|0777)){
		error = Ewstatb;
		goto out;
	}

	op = dir.mode^mkmode9p2(d-&gt;mode);
	if(op &amp; DMDIR){
		error = Ewstatd;
		goto out;
	}

	if(dir.mtime != ~0){
		if(dir.mtime != d-&gt;mtime)
			op = 1;
		tsync = 0;
	} else
		dir.mtime = d-&gt;mtime;

	if(dir.length == ~(Off)0)
		dir.length = d-&gt;size;
	else {
		if (dir.length &lt; 0) {
			error = Ewstatl;
			goto out;
		} else if(dir.length != d-&gt;size)
			op = 1;
		tsync = 0;
	}

	/*
	 * Check for permission to change .mode, .mtime or .length,
	 * must be owner or leader of either group, for which test gid
	 * is needed; permission checks on gid will be done later.
	 * 'Gl' counts whether neither, one or both groups are led.
	 */
	if(dir.gid != nil &amp;&amp; *dir.gid != '\0'){
		gid = strtouid(dir.gid);
		tsync = 0;
	} else
		gid = d-&gt;gid;
	gl = leadgroup(file-&gt;uid, gid) != 0;
	gl += leadgroup(file-&gt;uid, d-&gt;gid) != 0;

	if(op &amp;&amp; !wstatallow &amp;&amp; d-&gt;uid != file-&gt;uid &amp;&amp; !gl){
		error = Ewstato;
		goto out;
	}

	/*
	 * Rename.
	 * Check .name is valid and different to the current.
	 */
	if(dir.name != nil &amp;&amp; *dir.name != '\0'){
		if(error = checkname9p2(dir.name))
			goto out;
		if(strncmp(dir.name, d-&gt;name, NAMELEN))
			op = 1;
		else
			dir.name = d-&gt;name;
		tsync = 0;
	} else
		dir.name = d-&gt;name;

	/*
	 * If the name is really to be changed check it's unique
	 * and there is write permission in the parent.
	 */
	if(dir.name != d-&gt;name){
		/*
		 * First get parent.
		 * Must drop current entry to prevent
		 * deadlock when searching that new name
		 * already exists below.
		 */
		putbuf(p);
		p = nil;

		if(file-&gt;wpath == nil){
			error = Ephase;
			goto out;
		}
		p1 = getbuf(file-&gt;fs-&gt;dev, file-&gt;wpath-&gt;addr, Brd);
		if(p1 == nil || checktag(p1, Tdir, QPNONE)){
			error = Ephase;
			goto out;
		}
		d1 = getdir(p1, file-&gt;wpath-&gt;slot);
		if(d1 == nil || !(d1-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}

		/*
		 * Check entries in parent for new name.
		 */
		for(addr = 0; ; addr++){
			if((p = dnodebuf(p1, d1, addr, 0, file-&gt;uid)) == nil)
				break;
			if(checktag(p, Tdir, d1-&gt;qid.path)){
				putbuf(p);
				continue;
			}
			for(slot = 0; slot &lt; DIRPERBUF; slot++){
				d = getdir(p, slot);
				if(!(d-&gt;mode &amp; DALLOC) ||
				   strncmp(dir.name, d-&gt;name, sizeof d-&gt;name))
					continue;
				error = Eexist;
				goto out;
			}
			putbuf(p);
		}

		/*
		 * Reacquire entry and check it's still OK.
		 */
		p = getbuf(file-&gt;fs-&gt;dev, file-&gt;addr, Brd);
		if(p == nil || checktag(p, Tdir, QPNONE)){
			error = Ephase;
			goto out;
		}
		d = getdir(p, file-&gt;slot);
		if(d == nil || !(d-&gt;mode &amp; DALLOC)){
			error = Ephase;
			goto out;
		}

		/*
		 * Check write permission in the parent.
		 */
		if(!wstatallow &amp;&amp; !writeallow &amp;&amp; iaccess(file, d1, DWRITE)){
			error = Eaccess;
			goto out;
		}
	}

	/*
	 * Check for permission to change owner - must be god.
	 */
	if(dir.uid != nil &amp;&amp; *dir.uid != '\0'){
		uid = strtouid(dir.uid);
		if(uid != d-&gt;uid){
			if(!wstatallow){
				error = Ewstatu;
				goto out;
			}
			op = 1;
		}
		tsync = 0;
	} else
		uid = d-&gt;uid;
	if(dir.muid != nil &amp;&amp; *dir.muid != '\0'){
		muid = strtouid(dir.muid);
		if(muid != d-&gt;muid){
			if(!wstatallow){
				error = Ewstatm;
				goto out;
			}
			op = 1;
		}
		tsync = 0;
	} else
		muid = d-&gt;muid;

	/*
	 * Check for permission to change group, must be
	 * either owner and in new group or leader of both groups.
	 */
	if(gid != d-&gt;gid){
		if(!(wstatallow || writeallow)
		&amp;&amp; !(d-&gt;uid == file-&gt;uid &amp;&amp; ingroup(file-&gt;uid, gid))
		&amp;&amp; !(gl == 2)){
			error = Ewstatg;
			goto out;
		}
		op = 1;
	}

	/*
	 * Checks all done, update if necessary.
	 */
	if(op){
		d-&gt;mode = mkmode9p1(dir.mode);
		file-&gt;qid.type = mktype9p2(d-&gt;mode);
		d-&gt;mtime = dir.mtime;
		if (dir.length &lt; d-&gt;size) {
			err = dtrunclen(p, d, dir.length, uid);
			if (error == 0)
				error = err;
		}
		d-&gt;size = dir.length;
		if(dir.name != d-&gt;name)
			strncpy(d-&gt;name, dir.name, sizeof(d-&gt;name));
		d-&gt;uid = uid;
		d-&gt;gid = gid;
		d-&gt;muid = muid;
	}
	if(!tsync)
		accessdir(p, d, FREAD, file-&gt;uid);

out:
	if(p != nil)
		putbuf(p);
	if(p1 != nil)
		putbuf(p1);
	qunlock(file);

	return error;
}

int
serve9p2(Msgbuf* mb)
{
	Chan *chan;
	Fcall f, r;
	Msgbuf *data, *rmb;
	char ename[64];
	int error, n, type;
	static int once;

	if(once == 0){
		fmtinstall('F', fcallfmt);
		once = 1;
	}

	/*
	 * 0 return means i don't understand this message,
	 * 1 return means i dealt with it, including error
	 * replies.
	 */
	if(convM2S(mb-&gt;data, mb-&gt;count, &amp;f) != mb-&gt;count)
{
print("didn't like %d byte message\n", mb-&gt;count);
		return 0;
}
	type = f.type;
	if(type &lt; Tversion || type &gt;= Tmax || (type &amp; 1) || type == Terror)
		return 0;

	chan = mb-&gt;chan;
	if(CHAT(chan))
		print("9p2: f %F\n", &amp;f);
	r.type = type+1;
	r.tag = f.tag;
	error = 0;
	data = nil;

	switch(type){
	default:
		r.type = Rerror;
		snprint(ename, sizeof(ename), "unknown message: %F", &amp;f);
		r.ename = ename;
		break;
	case Tversion:
		error = version(chan, &amp;f, &amp;r);
		break;
	case Tauth:
		error = auth(chan, &amp;f, &amp;r);
		break;
	case Tattach:
		error = attach(chan, &amp;f, &amp;r);
		break;
	case Tflush:
		error = flush(chan, &amp;f, &amp;r);
		break;
	case Twalk:
		error = walk(chan, &amp;f, &amp;r);
		break;
	case Topen:
		error = fs_open(chan, &amp;f, &amp;r);
		break;
	case Tcreate:
		error = fs_create(chan, &amp;f, &amp;r);
		break;
	case Tread:
		data = mballoc(chan-&gt;msize, chan, Mbreply1);
		error = fs_read(chan, &amp;f, &amp;r, data-&gt;data);
		break;
	case Twrite:
		error = fs_write(chan, &amp;f, &amp;r);
		break;
	case Tclunk:
		error = clunk(chan, &amp;f, &amp;r);
		break;
	case Tremove:
		error = fs_remove(chan, &amp;f, &amp;r);
		break;
	case Tstat:
		data = mballoc(chan-&gt;msize, chan, Mbreply1);
		error = fs_stat(chan, &amp;f, &amp;r, data-&gt;data);
		break;
	case Twstat:
		data = mballoc(chan-&gt;msize, chan, Mbreply1);
		error = fs_wstat(chan, &amp;f, &amp;r, (char*)data-&gt;data);
		break;
	}

	if(error != 0){
		r.type = Rerror;
		if(error &gt;= MAXERR){
			snprint(ename, sizeof(ename), "error %d", error);
			r.ename = ename;
		} else
			r.ename = errstr9p[error];
	}
	if(CHAT(chan))
		print("9p2: r %F\n", &amp;r);

	rmb = mballoc(chan-&gt;msize, chan, Mbreply2);
	n = convS2M(&amp;r, rmb-&gt;data, chan-&gt;msize);
	if(data != nil)
		mbfree(data);
	if(n == 0){
		type = r.type;
		r.type = Rerror;

		/*
		 * If a Tversion has not been seen on the chan then
		 * chan-&gt;msize will be 0. In that case craft a special
		 * Rerror message. It's fortunate that the mballoc above
		 * for rmb will have returned a Msgbuf of MAXMSG size
		 * when given a request with count of 0...
		 */
		if(chan-&gt;msize == 0){
			r.ename = "Tversion not seen";
			n = convS2M(&amp;r, rmb-&gt;data, MAXMSG);
		} else {
			snprint(ename, sizeof(ename), "9p2: convS2M: type %d",
				type);
			r.ename = ename;
			n = convS2M(&amp;r, rmb-&gt;data, chan-&gt;msize);
		}
		print("%s\n", r.ename);
		if(n == 0){
			/*
			 * What to do here, the failure notification failed?
			 */
			mbfree(rmb);
			return 1;
		}
	}
	rmb-&gt;count = n;
	rmb-&gt;param = mb-&gt;param;

	/* done 9P processing, write reply to network */
	fs_send(chan-&gt;reply, rmb);

	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

