<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/auth.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/auth.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "io.h"
#include &lt;authsrv.h&gt;

Nvrsafe	nvr;

static int gotnvr;	/* flag: nvr contains nvram; it could be bad */

char*
nvrgetconfig(void)
{
	return conf.confdev;
}

/*
 * we shouldn't be writing nvram any more.
 * the secstore/config field is now just secstore key.
 * we still use authid, authdom and machkey for authentication.
 */

int
nvrcheck(void)
{
	uchar csum;

	if (readnvram(&amp;nvr, NVread) &lt; 0) {
		print("nvrcheck: can't read nvram\n");
		return 1;
	} else
		gotnvr = 1;
	print("nvr read\n");

	csum = nvcsum(nvr.machkey, sizeof nvr.machkey);
	if(csum != nvr.machsum) {
		print("\n\n ** NVR key checksum is incorrect  **\n");
		print(" ** set password to allow attaches **\n\n");
		memset(nvr.machkey, 0, sizeof nvr.machkey);
		return 1;
	}

	return 0;
}

int
nvrsetconfig(char* word)
{
	/* config block is on device `word' */
	USED(word);
	return 0;
}

int
conslock(void)
{
	char *ln;
	char nkey1[DESKEYLEN];
	static char zeroes[DESKEYLEN];

	if(memcmp(nvr.machkey, zeroes, DESKEYLEN) == 0) {
		print("no password set\n");
		return 0;
	}

	for(;;) {
		print("%s password:", service);
		/* could turn off echo here */

		if ((ln = Brdline(&amp;bin, '\n')) == nil)
			return 0;
		ln[Blinelen(&amp;bin)-1] = '\0';

		/* could turn on echo here */
		memset(nkey1, 0, DESKEYLEN);
		passtokey(nkey1, ln);
		if(memcmp(nkey1, nvr.machkey, DESKEYLEN) == 0) {
			prdate();
			break;
		}

		print("Bad password\n");
		delay(1000);
	}
	return 1;
}

/*
 *  authentication specific to 9P2000
 */

/* authentication states */
enum
{
	HaveProtos=1,
	NeedProto,
	HaveOK,
	NeedCchal,
	HaveSinfo,
	NeedTicket,
	HaveSauthenticator,
	SSuccess,
};

char *phasename[] =
{
[HaveProtos]	"HaveProtos",
[NeedProto]	"NeedProto",
[HaveOK]	"HaveOK",
[NeedCchal]	"NeedCchal",
[HaveSinfo]	"HaveSinfo",
[NeedTicket]	"NeedTicket",
[HaveSauthenticator]	"HaveSauthenticator",
[SSuccess]	"SSuccess",
};

/* authentication structure */
struct	Auth
{
	int	inuse;
	char	uname[NAMELEN];	/* requestor's remote user name */
	char	aname[NAMELEN];	/* requested aname */
	Userid	uid;		/* uid decided on */
	int	phase;
	char	cchal[CHALLEN];
	char	tbuf[TICKETLEN+AUTHENTLEN];	/* server ticket */
	Ticket	t;
	Ticketreq tr;
};

Auth*	auths;
Lock	authlock;

void
authinit(void)
{
	auths = malloc(conf.nauth * sizeof(*auths));
}

static int
failure(Auth *s, char *why)
{
	int i;

if(*why)print("authentication failed: %s: %s\n", phasename[s-&gt;phase], why);
	srand((uintptr)s + time(nil));
	for(i = 0; i &lt; CHALLEN; i++)
		s-&gt;tr.chal[i] = nrand(256);
	s-&gt;uid = -1;
	strncpy(s-&gt;tr.authid, nvr.authid, NAMELEN);
	strncpy(s-&gt;tr.authdom, nvr.authdom, DOMLEN);
	memmove(s-&gt;cchal, s-&gt;tr.chal, sizeof(s-&gt;cchal));
	s-&gt;phase = HaveProtos;
	return -1;
}

Auth*
authnew(char *uname, char *aname)
{
	static int si = 0;
	int i, nwrap;
	Auth *s;

	i = si;
	nwrap = 0;
	for(;;){
		if(i &lt; 0 || i &gt;= conf.nauth){
			if(++nwrap &gt; 1)
				return nil;
			i = 0;
		}
		s = &amp;auths[i++];
		if(s-&gt;inuse)
			continue;
		lock(&amp;authlock);
		if(s-&gt;inuse == 0){
			s-&gt;inuse = 1;
			strncpy(s-&gt;uname, uname, NAMELEN-1);
			strncpy(s-&gt;aname, aname, NAMELEN-1);
			failure(s, "");
			si = i;
			unlock(&amp;authlock);
			break;
		}
		unlock(&amp;authlock);
	}
	return s;
}

void
authfree(Auth *s)
{
	if(s != nil)
		s-&gt;inuse = 0;
}

int
authread(File* file, uchar* data, int n)
{
	Auth *s;
	int m;

	s = file-&gt;auth;
	if(s == nil)
		return -1;

	switch(s-&gt;phase){
	default:
		return failure(s, "unexpected phase");
	case HaveProtos:
		m = snprint((char*)data, n, "v.2 p9sk1@%s", nvr.authdom) + 1;
		s-&gt;phase = NeedProto;
		break;
	case HaveOK:
		m = 3;
		if(n &lt; m)
			return failure(s, "read too short");
		strcpy((char*)data, "OK");
		s-&gt;phase = NeedCchal;
		break;
	case HaveSinfo:
		m = TICKREQLEN;
		if(n &lt; m)
			return failure(s, "read too short");
		convTR2M(&amp;s-&gt;tr, (char*)data);
		s-&gt;phase = NeedTicket;
		break;
	case HaveSauthenticator:
		m = AUTHENTLEN;
		if(n &lt; m)
			return failure(s, "read too short");
		memmove(data, s-&gt;tbuf+TICKETLEN, m);
		s-&gt;phase = SSuccess;
		break;
	}
	return m;
}

int
authwrite(File* file, uchar *data, int n)
{
	Auth *s;
	int m;
	char *p, *d;
	Authenticator a;

	s = file-&gt;auth;
	if(s == nil)
		return -1;

	switch(s-&gt;phase){
	default:
		return failure(s, "unknown phase");
	case NeedProto:
		p = (char*)data;
		if(p[n-1] != 0)
			return failure(s, "proto missing terminator");
		d = strchr(p, ' ');
		if(d == nil)
			return failure(s, "proto missing separator");
		*d++ = 0;
		if(strcmp(p, "p9sk1") != 0)
			return failure(s, "unknown proto");
		if(strcmp(d, nvr.authdom) != 0)
			return failure(s, "unknown domain");
		s-&gt;phase = HaveOK;
		m = n;
		break;
	case NeedCchal:
		m = CHALLEN;
		if(n &lt; m)
			return failure(s, "client challenge too short");
		memmove(s-&gt;cchal, data, sizeof(s-&gt;cchal));
		s-&gt;phase = HaveSinfo;
		break;
	case NeedTicket:
		m = TICKETLEN+AUTHENTLEN;
		if(n &lt; m)
			return failure(s, "ticket+auth too short");

		convM2T((char*)data, &amp;s-&gt;t, nvr.machkey);
		if(s-&gt;t.num != AuthTs
		|| memcmp(s-&gt;t.chal, s-&gt;tr.chal, sizeof(s-&gt;t.chal)) != 0)
			return failure(s, "bad ticket");

		convM2A((char*)data+TICKETLEN, &amp;a, s-&gt;t.key);
		if(a.num != AuthAc
		|| memcmp(a.chal, s-&gt;tr.chal, sizeof(a.chal)) != 0
		|| a.id != 0)
			return failure(s, "bad authenticator");

		/* at this point, we're convinced */
		s-&gt;uid = strtouid(s-&gt;t.suid);
		if(s-&gt;uid &lt; 0)
			return failure(s, "unknown user");
		if(cons.flags &amp; authdebugflag)
			print("user %s = %d authenticated\n",
				s-&gt;t.suid, s-&gt;uid);

		/* create an authenticator to send back */
		a.num = AuthAs;
		memmove(a.chal, s-&gt;cchal, sizeof(a.chal));
		a.id = 0;
		convA2M(&amp;a, s-&gt;tbuf+TICKETLEN, s-&gt;t.key);

		s-&gt;phase = HaveSauthenticator;
		break;
	}
	return m;
}

int
authuid(Auth* s)
{
	return s-&gt;uid;
}

char*
authaname(Auth* s)
{
	return s-&gt;aname;
}

char*
authuname(Auth* s)
{
	return s-&gt;uname;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

