<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/chk.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/chk.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

/* augmented Dentry */
typedef struct {
	Dentry	*d;
	Off	qpath;
	int	ns;
} Extdentry;

static	char*	abits;
static	long	sizabits;
static	char*	qbits;
static	long	sizqbits;

static	char*	name;
static	long	sizname;

static	Off	fstart;
static	Off	fsize;
static	Off	nfiles;
static	Off	maxq;
static	Device*	dev;
static	Off	ndup;
static	Off	nused;
static	Off	nfdup;
static	Off	nqbad;
static	Off	nfree;
static	Off	nbad;
static	int	mod;
static	int	flags;
static	int	ronly;
static	int	cwflag;
static	Devsize	sbaddr;
static	Devsize	oldblock;

static	int	depth;
static	int	maxdepth;
static	uchar	*lowstack, *startstack;

/* local prototypes */
static	int	amark(Off);
static	void*	chkalloc(ulong);
static	void	ckfreelist(Superb*);
static	int	fmark(Off);
static	int	fsck(Dentry*);
static	int	ftest(Off);
static	Dentry*	maked(Off, int, Off);
static	void	missing(void);
static	void	mkfreelist(Superb*);
static	void	modd(Off, int, Dentry*);
static	void	qmark(Off);
static	void	trfreelist(Superb*);
static	void	xaddfree(Device*, Off, Superb*, Iobuf*);
static	void	xflush(Device*, Superb*, Iobuf*);
static	void	xread(Off, Off);
static	Iobuf*	xtag(Off, int, Off);

static void *
chkalloc(ulong n)
{
	char *p = mallocz(n, 1);

	if (p == nil)
		panic("chkalloc: out of memory");
	return p;
}

void
chkfree(void *p)
{
	free(p);
}

/*
 * check flags
 */
enum
{
	Crdall	= (1&lt;&lt;0),	/* read all files */
	Ctag	= (1&lt;&lt;1),	/* rebuild tags */
	Cpfile	= (1&lt;&lt;2),	/* print files */
	Cpdir	= (1&lt;&lt;3),	/* print directories */
	Cfree	= (1&lt;&lt;4),	/* rebuild free list */
//	Csetqid	= (1&lt;&lt;5),	/* resequence qids */
	Cream	= (1&lt;&lt;6),	/* clear all bad tags */
	Cbad	= (1&lt;&lt;7),	/* clear all bad blocks */
	Ctouch	= (1&lt;&lt;8),	/* touch old dir and indir */
	Ctrim	= (1&lt;&lt;9),   /* trim fsize back to fit when checking free list */
};

static struct {
	char*	option;
	long	flag;
} ckoption[] = {
	"rdall",	Crdall,
	"tag",		Ctag,
	"pfile",	Cpfile,
	"pdir",		Cpdir,
	"free",		Cfree,
//	"setqid",	Csetqid,
	"ream",		Cream,
	"bad",		Cbad,
	"touch",	Ctouch,
	"trim",		Ctrim,
	0,
};

void
cmd_check(int argc, char *argv[])
{
	long f, i, flag;
	Off raddr;
	Filsys *fs;
	Iobuf *p;
	Superb *sb;
	Dentry *d;

	flag = 0;
	for(i=1; i&lt;argc; i++) {
		for(f=0; ckoption[f].option; f++)
			if(strcmp(argv[i], ckoption[f].option) == 0)
				goto found;
		print("unknown check option %s\n", argv[i]);
		for(f=0; ckoption[f].option; f++)
			print("\t%s\n", ckoption[f].option);
		return;
	found:
		flag |= ckoption[f].flag;
	}
	fs = cons.curfs;

	dev = fs-&gt;dev;
	ronly = (dev-&gt;type == Devro);
	cwflag = (dev-&gt;type == Devcw) | (dev-&gt;type == Devro);
	if(!ronly)
		wlock(&amp;mainlock);		/* check */
	flags = flag;

	name = abits = qbits = nil;		/* in case of goto */
	sbaddr = superaddr(dev);
	raddr = getraddr(dev);
	p = xtag(sbaddr, Tsuper, QPSUPER);
	if(!p)
		goto out;
	sb = (Superb*)p-&gt;iobuf;
	fstart = 2;
	cons.noage = 1;

	/* 200 is slop since qidgen is likely to be a little bit low */
	sizqbits = (sb-&gt;qidgen+200 + 7) / 8;
	qbits = chkalloc(sizqbits);

	fsize = sb-&gt;fsize;
	sizabits = (fsize-fstart + 7)/8;
	abits = chkalloc(sizabits);

	sizname = 4000;
	name = chkalloc(sizname);
	sizname -= NAMELEN+10;	/* for safety */

	mod = 0;
	nfree = 0;
	nfdup = 0;
	nused = 0;
	nbad = 0;
	ndup = 0;
	nqbad = 0;
	depth = 0;
	maxdepth = 0;

	if(flags &amp; Ctouch) {
		/* round fsize down to start of current side */
		int s;
		Devsize dsize;

		oldblock = 0;
		for (s = 0; dsize = wormsizeside(dev, s),
		     dsize &gt; 0 &amp;&amp; oldblock + dsize &lt; fsize; s++)
			oldblock += dsize;
		print("oldblock = %lld\n", (Wideoff)oldblock);
	}
	amark(sbaddr);
	if(cwflag) {
		amark(sb-&gt;roraddr);
		amark(sb-&gt;next);
	}

	print("checking filsys: %s\n", fs-&gt;name);
	nfiles = 0;
	maxq = 0;

	d = maked(raddr, 0, QPROOT);
	if(d) {
		amark(raddr);
		if(fsck(d))
			modd(raddr, 0, d);
		chkfree(d);
		depth--;
		if(depth)
			print("depth not zero on return\n");
	}

	if(flags &amp; Cfree)
		if(cwflag)
			trfreelist(sb);
		else
			mkfreelist(sb);

	if(sb-&gt;qidgen &lt; maxq)
		print("qid generator low path=%lld maxq=%lld\n",
			(Wideoff)sb-&gt;qidgen, (Wideoff)maxq);
	if(!(flags &amp; Cfree))
		ckfreelist(sb);
	if(mod) {
		sb-&gt;qidgen = maxq;
		print("file system was modified\n");
		settag(p, Tsuper, QPNONE);
	}

	print("nfiles = %lld\n", (Wideoff)nfiles);
	print("fsize  = %lld\n", (Wideoff)fsize);
	print("nused  = %lld\n", (Wideoff)nused);
	print("ndup   = %lld\n", (Wideoff)ndup);
	print("nfree  = %lld\n", (Wideoff)nfree);
	print("tfree  = %lld\n", (Wideoff)sb-&gt;tfree);
	print("nfdup  = %lld\n", (Wideoff)nfdup);
	print("nmiss  = %lld\n", (Wideoff)fsize-fstart-nused-nfree);
	print("nbad   = %lld\n", (Wideoff)nbad);
	print("nqbad  = %lld\n", (Wideoff)nqbad);
	print("maxq   = %lld\n", (Wideoff)maxq);
	print("base stack=%llud\n", (vlong)startstack);
	/* high-water mark of stack usage */
	print("high stack=%llud\n", (vlong)lowstack);
	print("deepest recursion=%d\n", maxdepth-1);	/* one-origin */
	if(!cwflag)
		missing();

out:
	cons.noage = 0;
	putbuf(p);
	chkfree(name);
	chkfree(abits);
	chkfree(qbits);
	name = abits = qbits = nil;
	if(!ronly)
		wunlock(&amp;mainlock);
}

/*
 * if *blkp is already allocated and Cbad is set, zero it.
 * returns *blkp if it's free, else 0.
 */
static Off
blkck(Off *blkp, int *flgp)
{
	Off a = *blkp;

	if(amark(a)) {
		if(flags &amp; Cbad) {
			*blkp = 0;
			*flgp |= Bmod;
		}
		a = 0;
	}
	return a;
}

/*
 * if a block address within a Dentry, *blkp, is already allocated
 * and Cbad is set, zero it.
 * stores 0 into *resp if already allocated, else stores *blkp.
 * returns dmod count.
 */
static int
daddrck(Off *blkp, Off *resp)
{
	int dmod = 0;

	if(amark(*blkp)) {
		if(flags &amp; Cbad) {
			*blkp = 0;
			dmod++;
		}
		*resp = 0;
	} else
		*resp = *blkp;
	return dmod;
}

/*
 * under Ctouch, read block `a' if it's in range.
 * returns dmod count.
 */
static int
touch(Off a)
{
	if((flags&amp;Ctouch) &amp;&amp; a &lt; oldblock) {
		Iobuf *pd = getbuf(dev, a, Brd|Bmod);

		if(pd)
			putbuf(pd);
		return 1;
	}
	return 0;
}

/*
 * if d is a directory, touch it and check all its entries in block a.
 * if not, under Crdall, read a.
 * returns dmod count.
 */
static int
dirck(Extdentry *ed, Off a)
{
	int k, dmod = 0;

	if(ed-&gt;d-&gt;mode &amp; DDIR) {
		dmod += touch(a);
		for(k=0; k&lt;DIRPERBUF; k++) {
			Dentry *nd = maked(a, k, ed-&gt;qpath);

			if(nd == nil)
				break;
			if(fsck(nd)) {
				modd(a, k, nd);
				dmod++;
			}
			chkfree(nd);
			depth--;
			name[ed-&gt;ns] = 0;
		}
	} else if(flags &amp; Crdall)
		xread(a, ed-&gt;qpath);
	return dmod;
}

/*
 * touch a, check a's tag for Tind1, Tind2, etc.
 * if the tag is right, validate each block number in the indirect block,
 * and check each block (mostly in case we are reading a huge directory).
 */
static int
indirck(Extdentry *ed, Off a, int tag)
{
	int i, dmod = 0;
	Iobuf *p1;

	if (a == 0)
		return dmod;
	dmod = touch(a);
	if (p1 = xtag(a, tag, ed-&gt;qpath)) {
		for(i=0; i&lt;INDPERBUF; i++) {
			a = blkck(&amp;((Off *)p1-&gt;iobuf)[i], &amp;p1-&gt;flags);
			if (a)
				/*
				 * check each block named in this
				 * indirect(^n) block (a).
				 */
				if (tag == Tind1)
					dmod +=   dirck(ed, a);
				else
					dmod += indirck(ed, a, tag-1);
		}
		putbuf(p1);
	}
	return dmod;
}

static int
indiraddrck(Extdentry *ed, Off *indirp, int tag)
{
	int dmod;
	Off a;

	dmod = daddrck(indirp, &amp;a);
	return dmod + indirck(ed, a, tag);
}

/* if result is true, *d was modified */
static int
fsck(Dentry *d)
{
	int i, dmod;
	Extdentry edent;

	depth++;
	if(depth &gt;= maxdepth)
		maxdepth = depth;
	if (lowstack == nil)
		startstack = lowstack = (uchar *)&amp;edent;
	/* more precise check, assumes downward-growing stack */
	if ((uchar *)&amp;edent &lt; lowstack)
		lowstack = (uchar *)&amp;edent;

	/* check that entry is allocated */
	if(!(d-&gt;mode &amp; DALLOC))
		return 0;
	nfiles++;

	/* we stash qpath &amp; ns in an Extdentry for eventual use by dirck() */
	memset(&amp;edent, 0, sizeof edent);
	edent.d = d;

	/* check name */
	edent.ns = strlen(name);
	i = strlen(d-&gt;name);
	if(i &gt;= NAMELEN) {
		d-&gt;name[NAMELEN-1] = 0;
		print("%s-&gt;name (%s) not terminated\n", name, d-&gt;name);
		return 0;
	}
	edent.ns += i;
	if(edent.ns &gt;= sizname) {
		print("%s-&gt;name (%s) name too large\n", name, d-&gt;name);
		return 0;
	}
	strcat(name, d-&gt;name);

	if(d-&gt;mode &amp; DDIR) {
		if(edent.ns &gt; 1) {
			strcat(name, "/");
			edent.ns++;
		}
		if(flags &amp; Cpdir) {
			print("%s\n", name);
			prflush();
		}
	} else if(flags &amp; Cpfile) {
		print("%s\n", name);
		prflush();
	}

	/* check qid */
	edent.qpath = d-&gt;qid.path &amp; ~QPDIR;
	qmark(edent.qpath);
	if(edent.qpath &gt; maxq)
		maxq = edent.qpath;

	/* check direct blocks (the common case) */
	dmod = 0;
	{
		Off a;

		for(i=0; i&lt;NDBLOCK; i++) {
			dmod += daddrck(&amp;d-&gt;dblock[i], &amp;a);
			if (a)
				dmod += dirck(&amp;edent, a);
		}
	}
	/* check indirect^n blocks, if any */
	for (i = 0; i &lt; NIBLOCK; i++)
		dmod += indiraddrck(&amp;edent, &amp;d-&gt;iblocks[i], Tind1+i);
	return dmod;
}

enum { XFEN = FEPERBUF + 6 };

typedef struct {
	int	flag;
	int	count;
	int	next;
	Off	addr[XFEN];
} Xfree;

static void
xaddfree(Device *dev, Off a, Superb *sb, Iobuf *p)
{
	Xfree *x;

	x = (Xfree*)p-&gt;iobuf;
	if(x-&gt;count &lt; XFEN) {
		x-&gt;addr[x-&gt;count] = a;
		x-&gt;count++;
		return;
	}
	if(!x-&gt;flag) {
		memset(&amp;sb-&gt;fbuf, 0, sizeof(sb-&gt;fbuf));
		sb-&gt;fbuf.free[0] = 0L;
		sb-&gt;fbuf.nfree = 1;
		sb-&gt;tfree = 0;
		x-&gt;flag = 1;
	}
	addfree(dev, a, sb);
}

static void
xflush(Device *dev, Superb *sb, Iobuf *p)
{
	int i;
	Xfree *x;

	x = (Xfree*)p-&gt;iobuf;
	if(!x-&gt;flag) {
		memset(&amp;sb-&gt;fbuf, 0, sizeof(sb-&gt;fbuf));
		sb-&gt;fbuf.free[0] = 0L;
		sb-&gt;fbuf.nfree = 1;
		sb-&gt;tfree = 0;
	}
	for(i=0; i&lt;x-&gt;count; i++)
		addfree(dev, x-&gt;addr[i], sb);
}

/*
 * make freelist
 * from existing freelist
 * (cw devices)
 */
static void
trfreelist(Superb *sb)
{
	Off a, n;
	int i;
	Iobuf *p, *xp;
	Fbuf *fb;


	xp = getbuf(devnone, Cckbuf, 0);
	memset(xp-&gt;iobuf, 0, BUFSIZE);
	fb = &amp;sb-&gt;fbuf;
	p = 0;
	for(;;) {
		n = fb-&gt;nfree;
		if(n &lt; 0 || n &gt; FEPERBUF)
			break;
		for(i=1; i&lt;n; i++) {
			a = fb-&gt;free[i];
			if(a &amp;&amp; !ftest(a))
				xaddfree(dev, a, sb, xp);
		}
		a = fb-&gt;free[0];
		if(!a)
			break;
		if(ftest(a))
			break;
		xaddfree(dev, a, sb, xp);
		if(p)
			putbuf(p);
		p = xtag(a, Tfree, QPNONE);
		if(!p)
			break;
		fb = (Fbuf*)p-&gt;iobuf;
	}
	if(p)
		putbuf(p);
	xflush(dev, sb, xp);
	putbuf(xp);
	mod++;
	print("%lld blocks free\n", (Wideoff)sb-&gt;tfree);
}

static void
ckfreelist(Superb *sb)
{
	Off a, lo, hi;
	int n, i;
	Iobuf *p;
	Fbuf *fb;

	strcpy(name, "free list");
	print("check %s\n", name);
	fb = &amp;sb-&gt;fbuf;
	a = sbaddr;
	p = 0;
	lo = 0;
	hi = 0;
	for(;;) {
		n = fb-&gt;nfree;
		if(n &lt; 0 || n &gt; FEPERBUF) {
			print("check: nfree bad %lld\n", (Wideoff)a);
			break;
		}
		for(i=1; i&lt;n; i++) {
			a = fb-&gt;free[i];
			if(a &amp;&amp; !fmark(a)) {
				if(!lo || lo &gt; a)
					lo = a;
				if(!hi || hi &lt; a)
					hi = a;
			}
		}
		a = fb-&gt;free[0];
		if(!a)
			break;
		if(fmark(a))
			break;
		if(!lo || lo &gt; a)
			lo = a;
		if(!hi || hi &lt; a)
			hi = a;
		if(p)
			putbuf(p);
		p = xtag(a, Tfree, QPNONE);
		if(!p)
			break;
		fb = (Fbuf*)p-&gt;iobuf;
	}
	if(p)
		putbuf(p);
	if (flags &amp; Ctrim) {
		fsize = hi--;		/* fsize = hi + 1 */
		sb-&gt;fsize = fsize;
		mod++;
		print("set fsize to %lld\n", (Wideoff)fsize);
	}
	print("lo = %lld; hi = %lld\n", (Wideoff)lo, (Wideoff)hi);
}

/*
 * make freelist from scratch
 */
static void
mkfreelist(Superb *sb)
{
	Off a;
	int i, b;

	if(ronly) {
		print("cant make freelist on ronly device\n");
		return;
	}
	strcpy(name, "free list");
	memset(&amp;sb-&gt;fbuf, 0, sizeof(sb-&gt;fbuf));
	sb-&gt;fbuf.free[0] = 0L;
	sb-&gt;fbuf.nfree = 1;
	sb-&gt;tfree = 0;
	for(a=fsize-fstart-1; a &gt;= 0; a--) {
		i = a/8;
		if(i &lt; 0 || i &gt;= sizabits)
			continue;
		b = 1 &lt;&lt; (a&amp;7);
		if(abits[i] &amp; b)
			continue;
		addfree(dev, fstart+a, sb);
	}
	print("%lld blocks free\n", (Wideoff)sb-&gt;tfree);
	mod++;
}

static Dentry*
maked(Off a, int s, Off qpath)
{
	Iobuf *p;
	Dentry *d, *d1;

	p = xtag(a, Tdir, qpath);
	if(!p)
		return 0;
	d = getdir(p, s);
	d1 = chkalloc(sizeof(Dentry));
	memmove(d1, d, sizeof(Dentry));
	putbuf(p);
	return d1;
}

static void
modd(Off a, int s, Dentry *d1)
{
	Iobuf *p;
	Dentry *d;

	if(!(flags &amp; Cbad))
		return;
	p = getbuf(dev, a, Brd);
	d = getdir(p, s);
	if(!d) {
		if(p)
			putbuf(p);
		return;
	}
	memmove(d, d1, sizeof(Dentry));
	p-&gt;flags |= Bmod;
	putbuf(p);
}

static void
xread(Off a, Off qpath)
{
	Iobuf *p;

	p = xtag(a, Tfile, qpath);
	if(p)
		putbuf(p);
}

static Iobuf*
xtag(Off a, int tag, Off qpath)
{
	Iobuf *p;

	if(a == 0)
		return 0;
	p = getbuf(dev, a, Brd);
	if(!p) {
		print("check: \"%s\": xtag: p null\n", name);
		if(flags &amp; (Cream|Ctag)) {
			p = getbuf(dev, a, Bmod);
			if(p) {
				memset(p-&gt;iobuf, 0, RBUFSIZE);
				settag(p, tag, qpath);
				mod++;
				return p;
			}
		}
		return 0;
	}
	if(checktag(p, tag, qpath)) {
		print("check: \"%s\": xtag: checktag\n", name);
		if(flags &amp; (Cream|Ctag)) {
			if(flags &amp; Cream)
				memset(p-&gt;iobuf, 0, RBUFSIZE);
			settag(p, tag, qpath);
			mod++;
			return p;
		}
		return p;
	}
	return p;
}

static int
amark(Off a)
{
	Off i;
	int b;

	if(a &lt; fstart || a &gt;= fsize) {
		if(a == 0)
			return 0;
		print("check: \"%s\": range %lld\n",
			name, (Wideoff)a);
		nbad++;
		return 1;
	}
	a -= fstart;
	i = a/8;
	b = 1 &lt;&lt; (a&amp;7);
	if(abits[i] &amp; b) {
		if(!ronly)
			if(ndup &lt; 10)
				print("check: \"%s\": address dup %lld\n",
					name, (Wideoff)fstart+a);
			else if(ndup == 10)
				print("...");
		ndup++;
		return 1;
	}
	abits[i] |= b;
	nused++;
	return 0;
}

static int
fmark(Off a)
{
	Off i;
	int b;

	if(a &lt; fstart || a &gt;= fsize) {
		print("check: \"%s\": range %lld\n",
			name, (Wideoff)a);
		nbad++;
		return 1;
	}
	a -= fstart;
	i = a/8;
	b = 1 &lt;&lt; (a&amp;7);
	if(abits[i] &amp; b) {
		print("check: \"%s\": address dup %lld\n",
			name, (Wideoff)fstart+a);
		nfdup++;
		return 1;
	}
	abits[i] |= b;
	nfree++;
	return 0;
}

static int
ftest(Off a)
{
	Off i;
	int b;

	if(a &lt; fstart || a &gt;= fsize)
		return 1;
	a -= fstart;
	i = a/8;
	b = 1 &lt;&lt; (a&amp;7);
	if(abits[i] &amp; b)
		return 1;
	abits[i] |= b;
	return 0;
}

static void
missing(void)
{
	Off a, i;
	int b, n;

	n = 0;
	for(a=fsize-fstart-1; a&gt;=0; a--) {
		i = a/8;
		b = 1 &lt;&lt; (a&amp;7);
		if(!(abits[i] &amp; b)) {
			print("missing: %lld\n", (Wideoff)fstart+a);
			n++;
		}
		if(n &gt; 10) {
			print(" ...\n");
			break;
		}
	}
}

static void
qmark(Off qpath)
{
	int b;
	Off i;

	i = qpath/8;
	b = 1 &lt;&lt; (qpath&amp;7);
	if(i &lt; 0 || i &gt;= sizqbits) {
		nqbad++;
		if(nqbad &lt; 20)
			print("check: \"%s\": qid out of range %llux\n",
				name, (Wideoff)qpath);
		return;
	}
	if((qbits[i] &amp; b) &amp;&amp; !ronly) {
		nqbad++;
		if(nqbad &lt; 20)
			print("check: \"%s\": qid dup %llux\n", name,
				(Wideoff)qpath);
	}
	qbits[i] |= b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

