<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/config.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/config.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "io.h"

static void	dowormcopy(void);
static int	dodevcopy(void);

struct {
	char*	icharp;
	char*	charp;
	int	error;
	int	newconf;	/* clear before start */
	int	modconf;	/* write back when done */
	int	nextiter;
	int	lastiter;
	int	diriter;
	Device*	lastcw;
	Device*	devlist;
} f;

static Device* confdev;
static int copyworm = 0, copydev = 0;
static char *src, *dest;

static int resetparams;

Fspar fspar[] = {
	{ "blocksize",	RBUFSIZE, },
	{ "daddrbits",	sizeof(Off)*8, },
	{ "indirblks",	NIBLOCK, },
	{ "dirblks",	NDBLOCK, },
	{ "namelen",	NAMELEN, },
	{ nil, 0, },
};

int
devcmpr(Device *d1, Device *d2)
{
	while (d1 != d2) {
		if(d1 == nil || d2 == nil || d1-&gt;type != d2-&gt;type)
			return 1;

		switch(d1-&gt;type) {
		default:
			print("can't compare dev: %Z\n", d1);
			panic("devcmp");
			return 1;

		case Devmcat:
		case Devmlev:
		case Devmirr:
			d1 = d1-&gt;cat.first;
			d2 = d2-&gt;cat.first;
			while(d1 &amp;&amp; d2) {
				if(devcmpr(d1, d2))
					return 1;
				d1 = d1-&gt;link;
				d2 = d2-&gt;link;
			}
			break;

		case Devnone:
			return 0;

		case Devro:
			d1 = d1-&gt;ro.parent;
			d2 = d2-&gt;ro.parent;
			break;

		case Devjuke:
		case Devcw:
			if(devcmpr(d1-&gt;cw.c, d2-&gt;cw.c))
				return 1;
			d1 = d1-&gt;cw.w;
			d2 = d2-&gt;cw.w;
			break;

		case Devfworm:
			d1 = d1-&gt;fw.fw;
			d2 = d2-&gt;fw.fw;
			break;

		case Devwren:
		case Devworm:
		case Devlworm:
			if(d1-&gt;wren.ctrl == d2-&gt;wren.ctrl)
			if(d1-&gt;wren.targ == d2-&gt;wren.targ)
			if(d1-&gt;wren.lun == d2-&gt;wren.lun)
				return 0;
			return 1;

		case Devpart:
			if(d1-&gt;part.base == d2-&gt;part.base)
			if(d1-&gt;part.size == d2-&gt;part.size) {
				d1 = d1-&gt;part.d;
				d2 = d2-&gt;part.d;
				break;
			}
			return 1;
		}
	}
	return 0;
}

void
cdiag(char *s, int c1)
{

	f.charp--;
	if(f.error == 0) {
		print("config diag: %s -- &lt;%c&gt;\n", s, c1);
		f.error = 1;
	}
}

int
cnumb(void)
{
	int c, n;

	c = *f.charp++;
	if(c == '&lt;') {
		n = f.nextiter;
		if(n &gt;= 0) {
			f.nextiter = n+f.diriter;
			if(n == f.lastiter) {
				f.nextiter = -1;
				f.lastiter = -1;
			}
			do {
				c = *f.charp++;
			} while (c != '&gt;');
			return n;
		}
		n = cnumb();
		if(*f.charp++ != '-') {
			cdiag("- expected", f.charp[-1]);
			return 0;
		}
		c = cnumb();
		if(*f.charp++ != '&gt;') {
			cdiag("&gt; expected", f.charp[-1]);
			return 0;
		}
		f.lastiter = c;
		f.diriter = 1;
		if(n &gt; c)
			f.diriter = -1;
		f.nextiter = n+f.diriter;
		return n;
	}
	if(!isascii(c) || !isdigit(c)) {
		cdiag("number expected", c);
		return 0;
	}
	n = 0;
	while(isascii(c) &amp;&amp; isdigit(c)) {
		n = n*10 + (c-'0');
		c = *f.charp++;
	}
	f.charp--;
	return n;
}

Device*
config1(int c)
{
	Device *d, *t;
	int m;

	d = malloc(sizeof(Device));
	do {
		t = config();
		if(d-&gt;cat.first == 0)
			d-&gt;cat.first = t;
		else
			d-&gt;cat.last-&gt;link = t;
		d-&gt;cat.last = t;
		if(f.error)
			return devnone;
		m = *f.charp;
		if(c == '(' &amp;&amp; m == ')')
			d-&gt;type = Devmcat;
		else if(c == '[' &amp;&amp; m == ']')
			d-&gt;type = Devmlev;
		else if(c == '{' &amp;&amp; m == '}')
			d-&gt;type = Devmirr;
	} while (d-&gt;type == 0);
	f.charp++;
	if(d-&gt;cat.first == d-&gt;cat.last)
		d = d-&gt;cat.first;
	return d;
}

static void
map(Device *d)
{
	Map *map;

	if (d-&gt;type != Devwren || d-&gt;wren.mapped)
		return;
	for (map = devmap; map != nil; map = map-&gt;next)
		if (devcmpr(d, map-&gt;fdev) == 0)
			break;
	if (map == nil)
		return;
	if (access(map-&gt;to, AEXIST) &gt;= 0)
{ print("map: mapped wren %Z to existing file %s\n", d, map-&gt;to); // DEBUG
		d-&gt;wren.file = map-&gt;to;		/* wren -&gt; file mapping */
}
	else if (map-&gt;tdev != nil)
{ print("map: mapped wren %Z to dev %Z\n", d, map-&gt;tdev); // DEBUG
		*d = *map-&gt;tdev;		/* wren -&gt; wren mapping */
}
	else
		print("bad mapping %Z to %s; no such file or device",
			d, map-&gt;to);
	d-&gt;wren.mapped = 1;
}

Device*
config(void)
{
	int c, m;
	Device *d;
	char *icp;

	if(f.error)
		return devnone;
	d = malloc(sizeof(Device));

	c = *f.charp++;
	switch(c) {
	default:
		cdiag("unknown type", c);
		return devnone;

	case '(':	/* (d+) one or multiple cat */
	case '[':	/* [d+] one or multiple interleave */
	case '{':	/* {d+} a mirrored device and optional mirrors */
		return config1(c);

	case 'f':	/* fd fake worm */
		d-&gt;type = Devfworm;
		d-&gt;fw.fw = config();
		break;

	case 'n':
		d-&gt;type = Devnone;
		break;

	case 'w':	/* w[#.]#[.#] wren	[ctrl] unit [lun] */
	case 'r':	/* r# worm side */
	case 'l':	/* l# labelled-worm side */
		icp = f.charp;
		d-&gt;type = Devwren;
		d-&gt;wren.ctrl = 0;
		d-&gt;wren.targ = cnumb();
		d-&gt;wren.lun = 0;
		m = *f.charp;
		if(m == '.') {
			f.charp++;
			d-&gt;wren.lun = cnumb();
			m = *f.charp;
			if(m == '.') {
				f.charp++;
				d-&gt;wren.ctrl = d-&gt;wren.targ;
				d-&gt;wren.targ = d-&gt;wren.lun;
				d-&gt;wren.lun = cnumb();
			}
		}
		if(f.nextiter &gt;= 0)
			f.charp = icp-1;
		if(c == 'r')		/* worms are virtual and not uniqued */
			d-&gt;type = Devworm;
		else if(c == 'l')
			d-&gt;type = Devlworm;
		else
			map(d);		/* subject wrens to optional mapping */
		break;

	case 'o':	/* o ro part of last cw */
		if(f.lastcw == 0) {
			cdiag("no cw to match", c);
			return devnone;
		}
		return f.lastcw-&gt;cw.ro;

	case 'j':	/* DD jukebox */
		d-&gt;type = Devjuke;
		d-&gt;j.j = config();
		d-&gt;j.m = config();
		break;

	case 'c':	/* cache/worm */
		d-&gt;type = Devcw;
		d-&gt;cw.c = config();
		d-&gt;cw.w = config();
		d-&gt;cw.ro = malloc(sizeof(Device));
		d-&gt;cw.ro-&gt;type = Devro;
		d-&gt;cw.ro-&gt;ro.parent = d;
		f.lastcw = d;
		break;

	case 'p':	/* pd#.# partition base% size% */
		d-&gt;type = Devpart;
		d-&gt;part.d = config();
		d-&gt;part.base = cnumb();
		c = *f.charp++;
		if(c != '.')
			cdiag("dot expected", c);
		d-&gt;part.size = cnumb();
		break;

	case 'x':	/* xD swab a device's metadata */
		d-&gt;type = Devswab;
		d-&gt;swab.d = config();
		break;
	}
	d-&gt;dlink = f.devlist;
	f.devlist = d;
	return d;
}

Device*
iconfig(char *s)
{
	Device *d;

	f.nextiter = -1;
	f.lastiter = -1;
	f.error = 0;
	f.icharp = s;
	f.charp = f.icharp;
	d = config();
	if(*f.charp) {
		cdiag("junk on end", *f.charp);
		f.error = 1;
	}
	return d;
}

int
testconfig(char *s)
{
	iconfig(s);
	return f.error;
}

/*
 * if b is a prefix of a, return 0.
 */
int
astrcmp(char *a, char *b)
{
	int n, c;

	n = strlen(b);
	if(memcmp(a, b, n) != 0)
		return 1;
	c = a[n];
	if(c == '\0')
		return 0;
	if(a[n+1])
		return 1;
	if(isascii(c) &amp;&amp; isdigit(c))
		return 0;
	return 1;
}

static Fspar *
getpar(char *name)
{
	Fspar *fsp;

	for (fsp = fspar; fsp-&gt;name != nil; fsp++)
		if (strcmp(name, fsp-&gt;name) == 0)
			return fsp;
	return nil;
}

/*
 * continue to parse obsolete keywords so that old configurations can
 * still work.
 */
void
mergeconf(Iobuf *p)
{
	char word[Maxword+1];
	char *cp;
	Filsys *fs;
	Fspar *fsp;

	for (cp = p-&gt;iobuf; *cp != '\0'; cp++) {
		cp = getwrd(word, cp);
		if(word[0] == '\0')
			break;
		else if (word[0] == '#')
			while (*cp != '\n' &amp;&amp; *cp != '\0')
				cp++;
		else if(strcmp(word, "service") == 0) {
			cp = getwrd(word, cp);
			if(service[0] == 0)
				strncpy(service, word, sizeof service);
		} else if(strcmp(word, "ipauth") == 0)	/* obsolete */
			cp = getwrd(word, cp);
		else if(astrcmp(word, "ip") == 0)	/* obsolete */
			cp = getwrd(word, cp);
		else if(astrcmp(word, "ipgw") == 0)	/* obsolete */
			cp = getwrd(word, cp);
		else if(astrcmp(word, "ipsntp") == 0)	/* obsolete */
			cp = getwrd(word, cp);
		else if(astrcmp(word, "ipmask") == 0)	/* obsolete */
			cp = getwrd(word, cp);
		else if(strcmp(word, "filsys") == 0) {
			cp = getwrd(word, cp);
			for(fs = filsys; fs &lt; filsys + nelem(filsys) - 1 &amp;&amp;
			    fs-&gt;name; fs++)
				if(strcmp(fs-&gt;name, word) == 0)
					break;
			if (fs &gt;= filsys + nelem(filsys) - 1)
				panic("out of filsys structures");
			if (fs-&gt;name &amp;&amp; strcmp(fs-&gt;name, word) == 0 &amp;&amp;
			    fs-&gt;flags &amp; FEDIT)
				cp = getwrd(word, cp);	/* swallow conf */
			else {
				fs-&gt;name = strdup(word);
				cp = getwrd(word, cp);
				if (word[0] == '\0')
					fs-&gt;conf = nil;
				else
					fs-&gt;conf = strdup(word);
			}
		} else if ((fsp = getpar(word)) != nil) {
			cp = getwrd(word, cp);
			if (!isascii(word[0]) || !isdigit(word[0]))
				print("bad %s value: %s", fsp-&gt;name, word);
			else
				fsp-&gt;declared = atol(word);
		} else {
			putbuf(p);
			panic("unknown keyword in config block: %s", word);
		}

		if(*cp != '\n') {
			putbuf(p);
			panic("syntax error in config block at `%s'", word);
		}
	}
}

void
cmd_printconf(int, char *[])
{
	char *p, *s;
	Iobuf *iob;

	iob = getbuf(confdev, 0, Brd);
	if(iob == nil)
		return;
	if(checktag(iob, Tconfig, 0)){
		putbuf(iob);
		return;
	}

	print("config %s\n", nvrgetconfig());
	for(s = p = iob-&gt;iobuf; *p != 0 &amp;&amp; p &lt; iob-&gt;iobuf+BUFSIZE; ){
		if(*p++ != '\n')
			continue;
		if (strncmp(s, "ip", 2) != 0)	/* don't print obsolete cmds */
			print("%.*s", (int)(p-s), s);
		s = p;
	}
	if(p != s)
		print("%.*s", (int)(p-s), s);
	print("end\n");

	putbuf(iob);
}

void
sysinit(void)
{
	int error;
	char *cp, *ep;
	Device *d;
	Filsys *fs;
	Fspar *fsp;
	Iobuf *p;

	cons.chan = fs_chaninit(Devcon, 1, 0);

start:
	/*
	 * part 1 -- read the config file
	 */
	devnone = iconfig("n");

	cp = nvrgetconfig();
	print("config %s\n", cp);

	confdev = d = iconfig(cp);
	devinit(d);
	if(f.newconf) {
		p = getbuf(d, 0, Bmod);
		memset(p-&gt;iobuf, 0, RBUFSIZE);
		settag(p, Tconfig, 0);
	} else
		p = getbuf(d, 0, Brd|Bmod);
	if(!p || checktag(p, Tconfig, 0))
		panic("config io");

	mergeconf(p);

	if (resetparams) {
		for (fsp = fspar; fsp-&gt;name != nil; fsp++)
			fsp-&gt;declared = 0;
		resetparams = 0;
	}

	for (fsp = fspar; fsp-&gt;name != nil; fsp++) {
		/* supply defaults from this cwfs instance */
		if (fsp-&gt;declared == 0) {
			fsp-&gt;declared = fsp-&gt;actual;
			f.modconf = 1;
		}
		/* warn if declared value is not our compiled-in value */
		if (fsp-&gt;declared != fsp-&gt;actual)
			print("warning: config %s %ld != compiled-in %ld\n",
				fsp-&gt;name, fsp-&gt;declared, fsp-&gt;actual);
	}

	if(f.modconf) {
		memset(p-&gt;iobuf, 0, BUFSIZE);
		p-&gt;flags |= Bmod|Bimm;
		cp = p-&gt;iobuf;
		ep = p-&gt;iobuf + RBUFSIZE - 1;
		if(service[0])
			cp = seprint(cp, ep, "service %s\n", service);
		for(fs=filsys; fs-&gt;name; fs++)
			if(fs-&gt;conf &amp;&amp; fs-&gt;conf[0] != '\0')
				cp = seprint(cp, ep, "filsys %s %s\n", fs-&gt;name,
					fs-&gt;conf);

		for (fsp = fspar; fsp-&gt;name != nil; fsp++)
			cp = seprint(cp, ep, "%s %ld\n",
				fsp-&gt;name, fsp-&gt;declared);

		putbuf(p);
		f.modconf = f.newconf = 0;
		print("config block written\n");
		goto start;
	}
	putbuf(p);

	print("service    %s\n", service);

loop:
	/*
	 * part 2 -- squeeze out the deleted filesystems
	 */
	for(fs=filsys; fs-&gt;name; fs++)
		if(fs-&gt;conf == nil || fs-&gt;conf[0] == '\0') {
			for(; fs-&gt;name; fs++)
				*fs = *(fs+1);
			goto loop;
		}
	if(filsys[0].name == nil)
		panic("no filsys");

	/*
	 * part 3 -- compile the device expression
	 */
	error = 0;
	for(fs=filsys; fs-&gt;name; fs++) {
		print("filsys %s %s\n", fs-&gt;name, fs-&gt;conf);
		fs-&gt;dev = iconfig(fs-&gt;conf);
		if(f.error) {
			error = 1;
			continue;
		}
	}
	if(error)
		panic("fs config");

	/*
	 * part 4 -- initialize the devices
	 */
	for(fs=filsys; fs-&gt;name; fs++) {
		delay(3000);
		print("sysinit: %s\n", fs-&gt;name);
		if(fs-&gt;flags &amp; FREAM)
			devream(fs-&gt;dev, 1);
		if(fs-&gt;flags &amp; FRECOVER)
			devrecover(fs-&gt;dev);
		devinit(fs-&gt;dev);
	}

	/*
	 * part 5 -- optionally copy devices or worms
	 */
	if (copyworm) {
		dowormcopy();		/* can return if user quits early */
		panic("copyworm bailed out!");
	}
	if (copydev)
		if (dodevcopy() &lt; 0)
			panic("copydev failed!");
		else
			panic("copydev done.");
}

/* an unfinished idea.  a non-blocking rawchar() would help. */
static int
userabort(char *msg)
{
	USED(msg);
	return 0;
}

static int
blockok(Device *d, Off a)
{
	Iobuf *p = getbuf(d, a, Brd);

	if (p == 0) {
		print("i/o error reading %Z block %lld\n", d, (Wideoff)a);
		return 0;
	}
	putbuf(p);
	return 1;
}

/*
 * special case for fake worms only:
 * we need to size the inner cw's worm device.
 * in particular, we want to avoid copying the fake-worm bitmap
 * at the end of the device.
 *
 * N.B.: for real worms (e.g. cw jukes), we need to compute devsize(cw(juke)),
 * *NOT* devsize(juke).
 */
static Device *
wormof(Device *dev)
{
	Device *worm = dev, *cw;

	if (dev-&gt;type == Devfworm) {
		cw = dev-&gt;fw.fw;
		if (cw != nil &amp;&amp; cw-&gt;type == Devcw)
			worm = cw-&gt;cw.w;
	}
	// print("wormof(%Z)=%Z\n", dev, worm);
	return worm;
}

/*
 * return the number of the highest-numbered block actually written, plus 1.
 * 0 indicates an error.
 */
static Devsize
writtensize(Device *worm)
{
	Devsize lim = devsize(worm);
	Iobuf *p;

	print("devsize(%Z) = %lld\n", worm, (Wideoff)lim);
	if (!blockok(worm, 0) || !blockok(worm, lim-1))
		return 0;
	delay(5*1000);
	if (userabort("sanity checks"))
		return 0;

	/* find worm's last valid block in case "worm" is an (f)worm */
	while (lim &gt; 0) {
		if (userabort("sizing")) {
			lim = 0;		/* you lose */
			break;
		}
		--lim;
		p = getbuf(worm, lim, Brd);
		if (p != 0) {			/* actually read one okay? */
			putbuf(p);
			break;
		}
	}
	print("limit(%Z) = %lld\n", worm, (Wideoff)lim);
	if (lim &lt;= 0)
		return 0;
	return lim + 1;
}

/* copy worm fs from "main"'s inner worm to "output" */
static void
dowormcopy(void)
{
	Filsys *f1, *f2;
	Device *fdev, *from, *to = nil;
	Iobuf *p;
	Off a;
	Devsize lim;

	/*
	 * convert file system names into Filsyss and Devices.
	 */

	f1 = fsstr("main");
	if(f1 == nil)
		panic("main file system missing");
	fdev = f1-&gt;dev;
	from = wormof(fdev);			/* fake worm special */
	if (from-&gt;type != Devfworm &amp;&amp; from-&gt;type != Devcw) {
		print("main file system is not a worm; copyworm may not do what you want!\n");
		print("waiting for 20 seconds...\n");
		delay(20000);
	}

	f2 = fsstr("output");
	if(f2 == nil) {
		print("no output file system - check only\n\n");
		print("reading worm from %Z (worm %Z)\n", fdev, from);
	} else {
		to = f2-&gt;dev;
		print("\ncopying worm from %Z (worm %Z) to %Z, starting in 8 seconds\n",
			fdev, from, to);
		delay(8000);
	}
	if (userabort("preparing to copy"))
		return;

	/*
	 * initialise devices, size them, more sanity checking.
	 */

	devinit(from);
	if (0 &amp;&amp; fdev != from) {
		devinit(fdev);
		print("debugging, sizing %Z first\n", fdev);
		writtensize(fdev);
	}
	lim = writtensize(from);
	if(lim == 0)
		panic("no blocks to copy on %Z", from);
	if (to) {
		print("reaming %Z in 8 seconds\n", to);
		delay(8000);
		if (userabort("preparing to ream &amp; copy"))
			return;
		devream(to, 0);
		devinit(to);
		print("copying worm: %lld blocks from %Z to %Z\n",
			(Wideoff)lim, from, to);
	}
	/* can't read to's blocks in case to is a real WORM device */

	/*
	 * Copy written fs blocks, a block at a time (or just read
	 * if no "output" fs).
	 */

	for (a = 0; a &lt; lim; a++) {
		if (userabort("copy"))
			break;
		p = getbuf(from, a, Brd);
		/*
		 * if from is a real WORM device, we'll get errors trying to
		 * read unwritten blocks, but the unwritten blocks need not
		 * be contiguous.
		 */
		if (p == 0) {
			print("%lld not written yet; can't read\n", (Wideoff)a);
			continue;
		}
		if (to != 0 &amp;&amp; devwrite(to, p-&gt;addr, p-&gt;iobuf) != 0) {
			print("out block %lld: write error; bailing",
				(Wideoff)a);
			break;
		}
		putbuf(p);
		if(a % 20000 == 0)
			print("block %lld %T\n", (Wideoff)a, time(nil));
	}

	/*
	 * wrap up: sync target, loop
	 */
	print("copied %lld blocks from %Z to %Z\n", (Wideoff)a, from, to);
	sync("wormcopy");
	delay(2000);
	print("looping; reset the machine at any time.\n");
	for (; ; )
		continue;		/* await reset */
}

/* copy device from src to dest */
static int
dodevcopy(void)
{
	Device *from, *to;
	Iobuf *p;
	Off a;
	Devsize lim, tosize;

	/*
	 * convert config strings into Devices.
	 */
	from = iconfig(src);
	if(f.error || from == nil) {
		print("bad src device %s\n", src);
		return -1;
	}
	to = iconfig(dest);
	if(f.error || to == nil) {
		print("bad dest device %s\n", dest);
		return -1;
	}

	/*
	 * initialise devices, size them, more sanity checking.
	 */

	devinit(from);
	lim = devsize(from);
	if(lim == 0)
		panic("no blocks to copy on %Z", from);
	devinit(to);
	tosize = devsize(to);
	if(tosize == 0)
		panic("no blocks to copy on %Z", to);

	/* use smaller of the device sizes */
	if (tosize &lt; lim)
		lim = tosize;

	print("copy %Z to %Z in 8 seconds\n", from, to);
	delay(8000);
	if (userabort("preparing to copy"))
		return -1;
	print("copying dev: %lld blocks from %Z to %Z\n", (Wideoff)lim,
		from, to);

	/*
	 * Copy all blocks, a block at a time.
	 */

	for (a = 0; a &lt; lim; a++) {
		if (userabort("copy"))
			break;
		p = getbuf(from, a, Brd);
		/*
		 * if from is a real WORM device, we'll get errors trying to
		 * read unwritten blocks, but the unwritten blocks need not
		 * be contiguous.
		 */
		if (p == 0) {
			print("%lld not written yet; can't read\n", (Wideoff)a);
			continue;
		}
		if (to != 0 &amp;&amp; devwrite(to, p-&gt;addr, p-&gt;iobuf) != 0) {
			print("out block %lld: write error; bailing",
				(Wideoff)a);
			break;
		}
		putbuf(p);
		if(a % 20000 == 0)
			print("block %lld %T\n", (Wideoff)a, time(nil));
	}

	/*
	 * wrap up: sync target
	 */
	print("copied %lld blocks from %Z to %Z\n", (Wideoff)a, from, to);
	sync("devcopy");
	return 0;
}

static void
setconfig(char *dev)
{
	if (dev != nil &amp;&amp; !testconfig(dev))
		nvrsetconfig(dev);	/* if it fails, it will complain */
}

void
arginit(void)
{
	int verb;
	char *line;
	char word[Maxword+1], *cp;
	Filsys *fs;

	if(nvrcheck() == 0) {
		setconfig(conf.confdev);
		if (!conf.configfirst)
			return;
	}

	/* nvr was bad or invoker requested configuration step */
	setconfig(conf.confdev);
	for (;;) {
		print("config: ");
		if ((line = Brdline(&amp;bin, '\n')) == nil)
			return;
		line[Blinelen(&amp;bin)-1] = '\0';

		cp = getwrd(word, line);
		if (word[0] == '\0' || word[0] == '#')
			continue;
		if(strcmp(word, "end") == 0)
			return;
		if(strcmp(word, "halt") == 0)
			exit();
		if(strcmp(word, "queryjuke") == 0) {
			getwrd(word, cp);
			if(testconfig(word) == 0)
				querychanger(iconfig(word));
			continue;
		}

		if(strcmp(word, "allow") == 0) {
			wstatallow = 1;
			writeallow = 1;
			continue;
		}
		if(strcmp(word, "copyworm") == 0) {
			copyworm = 1;
			continue;
		}
		if(strcmp(word, "copydev") == 0) {
			cp = getwrd(word, cp);
			if(testconfig(word))
				continue;
			src = strdup(word);
			getwrd(word, cp);
			if(testconfig(word))
				continue;
			dest = strdup(word);
			copydev = 1;
			continue;
		}
		if(strcmp(word, "noauth") == 0) {
			noauth = !noauth;
			continue;
		}
		if(strcmp(word, "noattach") == 0) {
			noattach = !noattach;
			continue;
		}
		if(strcmp(word, "readonly") == 0) {
			readonly = 1;
			continue;
		}

		if(strcmp(word, "ream") == 0) {
			verb = FREAM;
			goto gfsname;
		}
		if(strcmp(word, "recover") == 0) {
			verb = FRECOVER;
			goto gfsname;
		}
		if(strcmp(word, "filsys") == 0) {
			verb = FEDIT;
			goto gfsname;
		}

		if(strcmp(word, "nvram") == 0) {
			getwrd(word, cp);
			if(testconfig(word))
				continue;
			/* if it fails, it will complain */
			nvrsetconfig(word);
			continue;
		}
		if(strcmp(word, "config") == 0) {
			getwrd(word, cp);
			if(!testconfig(word) &amp;&amp; nvrsetconfig(word) == 0)
				f.newconf = 1;
			continue;
		}
		if(strcmp(word, "service") == 0) {
			getwrd(word, cp);
			strncpy(service, word, sizeof service);
			f.modconf = 1;
			continue;
		}
		if (strcmp(word, "resetparams") == 0) {
			resetparams++;
			continue;
		}

		/*
		 * continue to parse obsolete keywords so that old
		 * configurations can still work.
		 */
		if (strcmp(word, "ipauth") != 0 &amp;&amp;
		    astrcmp(word, "ip") != 0 &amp;&amp;
		    astrcmp(word, "ipgw") != 0 &amp;&amp;
		    astrcmp(word, "ipmask") != 0 &amp;&amp;
		    astrcmp(word, "ipsntp") != 0) {
			print("unknown config command\n");
			print("\ttype end to get out\n");
			continue;
		}

		getwrd(word, cp);
		f.modconf = 1;
		continue;

	gfsname:
		cp = getwrd(word, cp);
		for(fs=filsys; fs-&gt;name; fs++)
			if(strcmp(word, fs-&gt;name) == 0)
				break;
		if (fs-&gt;name == nil) {
			memset(fs, 0, sizeof *fs);
			fs-&gt;name = strdup(word);
		}
		switch(verb) {
		case FREAM:
			if(strcmp(fs-&gt;name, "main") == 0)
				wstatallow = 1;	/* only set, never reset */
			/* fallthrough */
		case FRECOVER:
			fs-&gt;flags |= verb;
			break;
		case FEDIT:
			f.modconf = 1;
			getwrd(word, cp);
			fs-&gt;flags |= verb;
			if(word[0] == 0)
				fs-&gt;conf = nil;
			else if(!testconfig(word))
				fs-&gt;conf = strdup(word);
			break;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

