<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/console.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/console.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

#include	"9p1.h"

void
fcall9p1(Chan *cp, Fcall *in, Fcall *ou)
{
	int t;

	rlock(&amp;mainlock);
	t = in-&gt;type;
	if(t &lt; 0 || t &gt;= MAXSYSCALL || (t&amp;1) || !call9p1[t]) {
		print("bad message type %d\n", t);
		panic("");
	}
	ou-&gt;type = t+1;
	ou-&gt;err = 0;

	rlock(&amp;cp-&gt;reflock);
	(*call9p1[t])(cp, in, ou);
	runlock(&amp;cp-&gt;reflock);

	if(ou-&gt;err &amp;&amp; CHAT(cp))
		print("\terror: %s\n", errstr9p[ou-&gt;err]);
	runlock(&amp;mainlock);
}

int
con_session(void)
{
	Fcall in, ou;

	in.type = Tsession;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_attach(int fid, char *uid, char *arg)
{
	Fcall in, ou;

	in.type = Tattach;
	in.fid = fid;
	strncpy(in.uname, uid, NAMELEN);
	strncpy(in.aname, arg, NAMELEN);
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_clone(int fid1, int fid2)
{
	Fcall in, ou;

	in.type = Tclone;
	in.fid = fid1;
	in.newfid = fid2;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_walk(int fid, char *name)
{
	Fcall in, ou;

	in.type = Twalk;
	in.fid = fid;
	strncpy(in.name, name, NAMELEN);
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_open(int fid, int mode)
{
	Fcall in, ou;

	in.type = Topen;
	in.fid = fid;
	in.mode = mode;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_read(int fid, char *data, Off offset, int count)
{
	Fcall in, ou;

	in.type = Tread;
	in.fid = fid;
	in.offset = offset;
	in.count = count;
	ou.data = data;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	if(ou.err)
		return 0;
	return ou.count;
}

int
con_write(int fid, char *data, Off offset, int count)
{
	Fcall in, ou;

	in.type = Twrite;
	in.fid = fid;
	in.data = data;
	in.offset = offset;
	in.count = count;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	if(ou.err)
		return 0;
	return ou.count;
}

int
con_remove(int fid)
{
	Fcall in, ou;

	in.type = Tremove;
	in.fid = fid;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_create(int fid, char *name, int uid, int gid, long perm, int mode)
{
	Fcall in, ou;

	in.type = Tcreate;
	in.fid = fid;
	strncpy(in.name, name, NAMELEN);
	in.perm = perm;
	in.mode = mode;
	cons.uid = uid;			/* beyond ugly */
	cons.gid = gid;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
doclri(File *f)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	int err;

	err = 0;
	p = 0;
	p1 = 0;
	if(f-&gt;fs-&gt;dev-&gt;type == Devro) {
		err = Eronly;
		goto out;
	}
	/*
	 * check on parent directory of file to be deleted
	 */
	if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
		err = Ephase;
		goto out;
	}
	p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Brd);
	d1 = getdir(p1, f-&gt;wpath-&gt;slot);
	if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
		err = Ephase;
		goto out;
	}

	accessdir(p1, d1, FWRITE, 0);
	putbuf(p1);
	p1 = 0;

	/*
	 * check on file to be deleted
	 */
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);

	/*
	 * do it
	 */
	memset(d, 0, sizeof(Dentry));
	settag(p, Tdir, QPNONE);
	freewp(f-&gt;wpath);
	freefp(f);

out:
	if(p1)
		putbuf(p1);
	if(p)
		putbuf(p);
	return err;
}

void
f_fstat(Chan *cp, Fcall *in, Fcall *ou)
{
	File *f;
	Iobuf *p;
	Dentry *d;
	int i;

	if(CHAT(cp)) {
		print("c_fstat %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	p = 0;
	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Brd);
	d = getdir(p, f-&gt;slot);
	if(d == 0)
		goto out;

	print("name = %.*s\n", NAMELEN, d-&gt;name);
	print("uid = %d; gid = %d; muid = %d\n", d-&gt;uid, d-&gt;gid, d-&gt;muid);
	print("size = %lld; qid = %llux/%lux\n", (Wideoff)d-&gt;size,
		(Wideoff)d-&gt;qid.path, d-&gt;qid.version);
	print("atime = %ld; mtime = %ld\n", d-&gt;atime, d-&gt;mtime);
	print("dblock =");
	for(i=0; i&lt;NDBLOCK; i++)
		print(" %lld", (Wideoff)d-&gt;dblock[i]);
	for (i = 0; i &lt; NIBLOCK; i++)
		print("; iblocks[%d] = %lld", i, (Wideoff)d-&gt;iblocks[i]);
	print("\n\n");

out:
	if(p)
		putbuf(p);
	ou-&gt;fid = in-&gt;fid;
	if(f)
		qunlock(f);
}

void
f_clri(Chan *cp, Fcall *in, Fcall *ou)
{
	File *f;

	if(CHAT(cp)) {
		print("c_clri %d\n", cp-&gt;chan);
		print("\tfid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	ou-&gt;err = doclri(f);

out:
	ou-&gt;fid = in-&gt;fid;
	if(f)
		qunlock(f);
}

int
con_clri(int fid)
{
	Fcall in, ou;
	Chan *cp;

	in.type = Tremove;
	in.fid = fid;
	cp = cons.chan;

	rlock(&amp;mainlock);
	ou.type = Tremove+1;
	ou.err = 0;

	rlock(&amp;cp-&gt;reflock);
	f_clri(cp, &amp;in, &amp;ou);
	runlock(&amp;cp-&gt;reflock);

	runlock(&amp;mainlock);
	return ou.err;
}

int
con_fstat(int fid)
{
	Fcall in, ou;
	Chan *cp;

	in.type = Tstat;
	in.fid = fid;
	cp = cons.chan;

	rlock(&amp;mainlock);
	ou.type = Tstat+1;
	ou.err = 0;

	rlock(&amp;cp-&gt;reflock);
	f_fstat(cp, &amp;in, &amp;ou);
	runlock(&amp;cp-&gt;reflock);

	runlock(&amp;mainlock);
	return ou.err;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

