<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/cw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/cw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * cached-worm device
 */
#include "all.h"

#define	CDEV(d)		((d)-&gt;cw.c)
#define	WDEV(d)		((d)-&gt;cw.w)
#define	RDEV(d)		((d)-&gt;cw.ro)

enum {
	DEBUG		= 0,
	FIRST		= SUPER_ADDR,

	ADDFREE		= 100,
	CACHE_ADDR	= SUPER_ADDR,
	MAXAGE		= 10000,
};

/* cache state */
enum
{
	/* states -- beware these are recorded on the cache */
				/*    cache    worm	*/
	Cnone = 0,		/*	0	?	*/
	Cdirty,			/*	1	0	*/
	Cdump,			/*	1	0-&gt;1	*/
	Cread,			/*	1	1	*/
	Cwrite,			/*	2	1	*/
	Cdump1,			/* inactive form of dump */
	Cerror,

	/* opcodes -- these are not recorded */
	Onone,
	Oread,
	Owrite,
	Ogrow,
	Odump,
	Orele,
	Ofree,
};

typedef	struct	Cw	Cw;
struct	Cw
{
	Device*	dev;
	Device*	cdev;
	Device*	wdev;
	Device*	rodev;
	Cw*	link;

	int	dbucket;	/* last bucket dumped */
	Off	daddr;		/* last block dumped */
	Off	ncopy;
	int	nodump;
/*
 * following are cached variables for dumps
 */
	Off	fsize;
	Off	ndump;
	int	depth;
	int	all;		/* local flag to recur on modified dirs */
	int	allflag;	/* global flag to recur on modified dirs */
	Off	falsehits;	/* times recur found modified blocks */
	struct {
		char	name[500];
		char	namepad[NAMELEN+10];
	};
};

static char* cwnames[] =
{
	[Cnone]		"none",
	[Cdirty]	"dirty",
	[Cdump]		"dump",
	[Cread]		"read",
	[Cwrite]	"write",
	[Cdump1]	"dump1",
	[Cerror]	"error",

	[Onone]		"none",
	[Oread]		"read",
	[Owrite]	"write",
	[Ogrow]		"grow",
	[Odump]		"dump",
	[Orele]		"rele",
};

int oldcachefmt = 1;

Centry*	getcentry(Bucket*, Off);
int	cwio(Device*, Off, void*, int);
void	cmd_cwcmd(int, char*[]);

/*
 * console command
 * initiate a dump
 */
void
cmd_dump(int argc, char *argv[])
{
	Filsys *fs;

	fs = cons.curfs;
	if(argc &gt; 1)
		fs = fsstr(argv[1]);
	if(fs == 0) {
		print("%s: unknown file system\n", argv[1]);
		return;
	}
	cfsdump(fs);
}

/*
 * console command
 * worm stats
 */
static void
cmd_statw(int, char*[])
{
	Filsys *fs;
	Iobuf *p;
	Superb *sb;
	Cache *h;
	Bucket *b;
	Centry *c, *ce;
	Off m, nw, bw, state[Onone];
	Off sbfsize, sbcwraddr, sbroraddr, sblast, sbnext;
	Off hmsize, hmaddr, dsize, dsizepct;
	Device *dev;
	Cw *cw;
	int s;

	fs = cons.curfs;
	dev = fs-&gt;dev;
	if(dev-&gt;type != Devcw) {
		print("curfs not type cw\n");
		return;
	}

	cw = dev-&gt;private;
	if(cw == 0) {
		print("curfs not inited\n");
		return;
	}

	print("cwstats %s\n", fs-&gt;name);

	sbfsize = 0;
	sbcwraddr = 0;
	sbroraddr = 0;
	sblast = 0;
	sbnext = 0;

	print("\tfilesys %s\n", fs-&gt;name);
//	print("\tnio   =%7W%7W%7W\n", cw-&gt;ncwio+0, cw-&gt;ncwio+1, cw-&gt;ncwio+2);
	p = getbuf(dev, cwsaddr(dev), Brd);
	if(!p || checktag(p, Tsuper, QPSUPER)) {
		print("cwstats: checktag super\n");
		if(p) {
			putbuf(p);
			p = 0;
		}
	}
	if(p) {
		sb = (Superb*)p-&gt;iobuf;
		sbfsize = sb-&gt;fsize;
		sbcwraddr = sb-&gt;cwraddr;
		sbroraddr = sb-&gt;roraddr;
		sblast = sb-&gt;last;
		sbnext = sb-&gt;next;
		putbuf(p);
	}

	p = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bres);
	if(!p || checktag(p, Tcache, QPSUPER)) {
		print("cwstats: checktag c bucket\n");
		if(p)
			putbuf(p);
		return;
	}
	h = (Cache*)p-&gt;iobuf;
	hmaddr = h-&gt;maddr;
	hmsize = h-&gt;msize;

	print("\t\tmaddr  = %8lld\n", (Wideoff)hmaddr);
	print("\t\tmsize  = %8lld\n", (Wideoff)hmsize);
	print("\t\tcaddr  = %8lld\n", (Wideoff)h-&gt;caddr);
	print("\t\tcsize  = %8lld\n", (Wideoff)h-&gt;csize);
	print("\t\tsbaddr = %8lld\n", (Wideoff)h-&gt;sbaddr);
	print("\t\tcraddr = %8lld %8lld\n",
		(Wideoff)h-&gt;cwraddr, (Wideoff)sbcwraddr);
	print("\t\troaddr = %8lld %8lld\n",
		(Wideoff)h-&gt;roraddr, (Wideoff)sbroraddr);
	/* print stats in terms of (first-)disc sides */
	dsize = wormsizeside(dev, 0);
	if (dsize &lt; 1) {
		if (DEBUG)
			print("wormsizeside returned size %lld for %Z side 0\n",
				(Wideoff)dsize, dev);
		dsize = h-&gt;wsize;	/* it's probably a fake worm */
		if (dsize &lt; 1)
			dsize = 1000;	/* don't divide by zero */
	}
	dsizepct = dsize/100;
	print("\t\tfsize  = %8lld %8lld %2lld+%2lld%%\n", (Wideoff)h-&gt;fsize,
		(Wideoff)sbfsize, (Wideoff)h-&gt;fsize/dsize,
		(Wideoff)(h-&gt;fsize%dsize)/dsizepct);
	print("\t\tslast  =          %8lld\n", (Wideoff)sblast);
	print("\t\tsnext  =          %8lld\n", (Wideoff)sbnext);
	print("\t\twmax   = %8lld          %2lld+%2lld%%\n",
		(Wideoff)h-&gt;wmax, (Wideoff)h-&gt;wmax/dsize,
		(Wideoff)(h-&gt;wmax%dsize)/dsizepct);
	print("\t\twsize  = %8lld          %2lld+%2lld%%\n",
		(Wideoff)h-&gt;wsize, (Wideoff)h-&gt;wsize/dsize,
		(Wideoff)(h-&gt;wsize%dsize)/dsizepct);
	putbuf(p);

	bw = 0;			/* max filled bucket */
	memset(state, 0, sizeof(state));
	for(m = 0; m &lt; hmsize; m++) {
		p = getbuf(cw-&gt;cdev, hmaddr + m/BKPERBLK, Brd);
		if(!p || checktag(p, Tbuck, hmaddr + m/BKPERBLK)) {
			print("cwstats: checktag c bucket\n");
			if(p)
				putbuf(p);
			return;
		}
		b = (Bucket*)p-&gt;iobuf + m%BKPERBLK;
		ce = b-&gt;entry + CEPERBK;
		nw = 0;
		for(c = b-&gt;entry; c &lt; ce; c++) {
			s = c-&gt;state;
			state[s]++;
			if(s != Cnone &amp;&amp; s != Cread)
				nw++;
		}
		putbuf(p);
		if(nw &gt; bw)
			bw = nw;
	}
	for(s = Cnone; s &lt; Cerror; s++)
		print("\t\t%6lld %s\n", (Wideoff)state[s], cwnames[s]);
	print("\t\tcache %2lld%% full\n", ((Wideoff)bw*100)/CEPERBK);
}

int
dumpblock(Device *dev)
{
	Iobuf *p, *cb, *p1, *p2;
	Cache *h;
	Centry *c, *ce, *bc;
	Bucket *b;
	Off m, a, msize, maddr, wmax, caddr;
	int s1, s2, count;
	Cw *cw;

	cw = dev-&gt;private;
	if(cw == 0 || cw-&gt;nodump)
		return 0;

	cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bres);
	h = (Cache*)cb-&gt;iobuf;
	msize = h-&gt;msize;
	maddr = h-&gt;maddr;
	wmax = h-&gt;wmax;
	caddr = h-&gt;caddr;
	putbuf(cb);

	for(m=msize; m&gt;=0; m--) {
		a = cw-&gt;dbucket + 1;
		if(a &lt; 0 || a &gt;= msize)
			a = 0;
		cw-&gt;dbucket = a;
		p = getbuf(cw-&gt;cdev, maddr + a/BKPERBLK, Brd);
		b = (Bucket*)p-&gt;iobuf + a%BKPERBLK;
		ce = b-&gt;entry + CEPERBK;
		bc = 0;
		for(c = b-&gt;entry; c &lt; ce; c++)
			if(c-&gt;state == Cdump) {
				if(bc == 0) {
					bc = c;
					continue;
				}
				if(c-&gt;waddr &lt; cw-&gt;daddr) {
					if(bc-&gt;waddr &lt; cw-&gt;daddr &amp;&amp;
					   bc-&gt;waddr &gt; c-&gt;waddr)
						bc = c;
					continue;
				}
				if(bc-&gt;waddr &lt; cw-&gt;daddr ||
				   bc-&gt;waddr &gt; c-&gt;waddr)
					bc = c;
			}
		if(bc) {
			c = bc;
			goto found;
		}
		putbuf(p);
	}
	if(cw-&gt;ncopy) {
		print("%lld blocks copied to worm\n", (Wideoff)cw-&gt;ncopy);
		cw-&gt;ncopy = 0;
	}
	cw-&gt;nodump = 1;
	return 0;

found:
	if (oldcachefmt)
		a = a*CEPERBK + (c - b-&gt;entry) + caddr;
	else
		a += (c - b-&gt;entry)*msize + caddr;
	p1 = getbuf(devnone, Cwdump1, 0);
	count = 0;

retry:
	count++;
	if(count &gt; 10 || devread(cw-&gt;cdev, a, p1-&gt;iobuf))
		goto stop;
	m = c-&gt;waddr;
	cw-&gt;daddr = m;
	s1 = devwrite(cw-&gt;wdev, m, p1-&gt;iobuf);
	if(s1) {
		p2 = getbuf(devnone, Cwdump2, 0);
		s2 = devread(cw-&gt;wdev, m, p2-&gt;iobuf);
		if(s2) {
			if(s1 == 0x61 &amp;&amp; s2 == 0x60) {
				putbuf(p2);
				goto retry;
			}
			goto stop1;
		}
		if(memcmp(p1-&gt;iobuf, p2-&gt;iobuf, RBUFSIZE))
			goto stop1;
		putbuf(p2);
	}
	/*
	 * reread and compare
	 */
	if(conf.dumpreread) {
		p2 = getbuf(devnone, Cwdump2, 0);
		s1 = devread(cw-&gt;wdev, m, p2-&gt;iobuf);
		if(s1)
			goto stop1;
		if(memcmp(p1-&gt;iobuf, p2-&gt;iobuf, RBUFSIZE)) {
			print("reread C%lld W%lld didnt compare\n",
				(Wideoff)a, (Wideoff)m);
			goto stop1;
		}
		putbuf(p2);
	}

	putbuf(p1);
	c-&gt;state = Cread;
	p-&gt;flags |= Bmod;
	putbuf(p);

	if(m &gt; wmax) {
		cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bmod|Bres);
		h = (Cache*)cb-&gt;iobuf;
		if(m &gt; h-&gt;wmax)
			h-&gt;wmax = m;
		putbuf(cb);
	}
	cw-&gt;ncopy++;
	return 1;

stop1:
	putbuf(p2);
	putbuf(p1);
	c-&gt;state = Cdump1;
	p-&gt;flags |= Bmod;
	putbuf(p);
	return 1;

stop:
	putbuf(p1);
	putbuf(p);
	print("stopping dump!!\n");
	cw-&gt;nodump = 1;
	return 0;
}

void
cwinit1(Device *dev)
{
	Cw *cw;
	static int first;

	cw = dev-&gt;private;
	if(cw)
		return;

	if(first == 0) {
		cmd_install("dump", "-- make dump backup to worm", cmd_dump);
		cmd_install("statw", "-- cache/worm stats", cmd_statw);
		cmd_install("cwcmd", "subcommand -- cache/worm errata", cmd_cwcmd);
		roflag = flag_install("ro", "-- ro reads and writes");
		first = 1;
	}
	cw = malloc(sizeof(Cw));
	dev-&gt;private = cw;

	cw-&gt;allflag = 0;

	cw-&gt;dev = dev;
	cw-&gt;cdev = CDEV(dev);
	cw-&gt;wdev = WDEV(dev);
	cw-&gt;rodev = RDEV(dev);

	devinit(cw-&gt;cdev);
	devinit(cw-&gt;wdev);
}

void
cwinit(Device *dev)
{
	Cw *cw;
	Cache *h;
	Iobuf *cb, *p;
	Off l, m;

	cwinit1(dev);

	cw = dev-&gt;private;
	l = devsize(cw-&gt;wdev);
	cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bmod|Bres);
	h = (Cache*)cb-&gt;iobuf;
	h-&gt;toytime = toytime() + SECOND(30);
	h-&gt;time = time(nil);
	m = h-&gt;wsize;
	if(l != m) {
		print("wdev changed size %lld to %lld\n",
			(Wideoff)m, (Wideoff)l);
		h-&gt;wsize = l;
		cb-&gt;flags |= Bmod;
	}

	for(m=0; m&lt;h-&gt;msize; m++) {
		p = getbuf(cw-&gt;cdev, h-&gt;maddr + m/BKPERBLK, Brd);
		if(!p || checktag(p, Tbuck, h-&gt;maddr + m/BKPERBLK))
			panic("cwinit: checktag c bucket");
		putbuf(p);
	}
	putbuf(cb);
}

Off
cwsaddr(Device *dev)
{
	Iobuf *cb;
	Off sa;

	cb = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bres);
	sa = ((Cache*)cb-&gt;iobuf)-&gt;sbaddr;
	putbuf(cb);
	return sa;
}

Off
cwraddr(Device *dev)
{
	Iobuf *cb;
	Off ra;

	switch(dev-&gt;type) {
	default:
		print("unknown dev in cwraddr %Z\n", dev);
		return 1;

	case Devcw:
		cb = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bres);
		ra = ((Cache*)cb-&gt;iobuf)-&gt;cwraddr;
		break;

	case Devro:
		cb = getbuf(CDEV(dev-&gt;ro.parent), CACHE_ADDR, Brd|Bres);
		ra = ((Cache*)cb-&gt;iobuf)-&gt;roraddr;
		break;
	}
	putbuf(cb);
	return ra;
}

Devsize
cwsize(Device *dev)
{
	Iobuf *cb;
	Devsize fs;

	cb = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bres);
	fs = ((Cache*)cb-&gt;iobuf)-&gt;fsize;
	putbuf(cb);
	return fs;
}

int
cwread(Device *dev, Off b, void *c)
{
	return cwio(dev, b, c, Oread) == Cerror;
}

int
cwwrite(Device *dev, Off b, void *c)
{
	return cwio(dev, b, c, Owrite) == Cerror;
}

int
roread(Device *dev, Off b, void *c)
{
	Device *d;
	int s;

	/*
	 * maybe better is to try buffer pool first
	 */
	d = dev-&gt;ro.parent;
	if(d == 0 || d-&gt;type != Devcw ||
	   d-&gt;private == 0 || RDEV(d) != dev) {
		print("bad rodev %Z\n", dev);
		return 1;
	}
	s = cwio(d, b, 0, Onone);
	if(s == Cdump || s == Cdump1 || s == Cread) {
		s = cwio(d, b, c, Oread);
		if(s == Cdump || s == Cdump1 || s == Cread) {
			if(cons.flags &amp; roflag)
				print("roread: %Z %lld -&gt; %Z(hit)\n",
					dev, (Wideoff)b, d);
			return 0;
		}
	}
	if(cons.flags &amp; roflag)
		print("roread: %Z %lld -&gt; %Z(miss)\n",
			dev, (Wideoff)b, WDEV(d));
	return devread(WDEV(d), b, c);
}

int
cwio(Device *dev, Off addr, void *buf, int opcode)
{
	Iobuf *p, *p1, *p2, *cb;
	Cache *h;
	Bucket *b;
	Centry *c;
	Off bn, a1, a2, max, newmax;
	int state;
	Cw *cw;

	cw = dev-&gt;private;

	cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bres);
	h = (Cache*)cb-&gt;iobuf;
	if(toytime() &gt;= h-&gt;toytime) {
		cb-&gt;flags |= Bmod;
		h-&gt;toytime = toytime() + SECOND(30);
		h-&gt;time = time(nil);
	}

	if(addr &lt; 0) {
		putbuf(cb);
		return Cerror;
	}

	bn = addr % h-&gt;msize;
	a1 = h-&gt;maddr + bn/BKPERBLK;
	if (oldcachefmt)
		a2 = bn*CEPERBK + h-&gt;caddr;
	else
		a2 = bn + h-&gt;caddr;
	max = h-&gt;wmax;

	putbuf(cb);
	newmax = 0;

	p = getbuf(cw-&gt;cdev, a1, Brd|Bmod);
	if(!p || checktag(p, Tbuck, a1))
		panic("cwio: checktag c bucket");
	b = (Bucket*)p-&gt;iobuf + bn%BKPERBLK;

	c = getcentry(b, addr);
	if(c == 0) {
		putbuf(p);
		print("%Z disk cache bucket %lld is full\n",
			cw-&gt;cdev, (Wideoff)a1);
		return Cerror;
	}
	if (oldcachefmt)
		a2 += c - b-&gt;entry;
	else
		a2 += (c - b-&gt;entry) * h-&gt;msize;

	state = c-&gt;state;
	switch(opcode) {
	default:
		goto bad;

	case Onone:
		break;

	case Oread:
		switch(state) {
		default:
			goto bad;

		case Cread:
			if(!devread(cw-&gt;cdev, a2, buf))
				break;
			c-&gt;state = Cnone;

		case Cnone:
			if(devread(cw-&gt;wdev, addr, buf)) {
				state = Cerror;
				break;
			}
			if(addr &gt; max)
				newmax = addr;
			if(!devwrite(cw-&gt;cdev, a2, buf))
				c-&gt;state = Cread;
			break;

		case Cdirty:
		case Cdump:
		case Cdump1:
		case Cwrite:
			if(devread(cw-&gt;cdev, a2, buf))
				state = Cerror;
			break;
		}
		break;

	case Owrite:
		switch(state) {
		default:
			goto bad;

		case Cdump:
		case Cdump1:
			/*
			 * this is hard part -- a dump block must be
			 * sent to the worm if it is rewritten.
			 * if this causes an error, there is no
			 * place to save the dump1 data. the block
			 * is just reclassified as 'dump1' (botch)
			 */
			p1 = getbuf(devnone, Cwio1, 0);
			if(devread(cw-&gt;cdev, a2, p1-&gt;iobuf)) {
				putbuf(p1);
				print("cwio: write induced dump error - r cache\n");

			casenone:
				if(devwrite(cw-&gt;cdev, a2, buf)) {
					state = Cerror;
					break;
				}
				c-&gt;state = Cdump1;
				break;
			}
			if(devwrite(cw-&gt;wdev, addr, p1-&gt;iobuf)) {
				p2 = getbuf(devnone, Cwio2, 0);
				if(devread(cw-&gt;wdev, addr, p2-&gt;iobuf)) {
					putbuf(p1);
					putbuf(p2);
					print("cwio: write induced dump error - r+w worm\n");
					goto casenone;
				}
				if(memcmp(p1-&gt;iobuf, p2-&gt;iobuf, RBUFSIZE)) {
					putbuf(p1);
					putbuf(p2);
					print("cwio: write induced dump error - w worm\n");
					goto casenone;
				}
				putbuf(p2);
			}
			putbuf(p1);
			c-&gt;state = Cread;
			if(addr &gt; max)
				newmax = addr;
			cw-&gt;ncopy++;

		case Cnone:
		case Cread:
			if(devwrite(cw-&gt;cdev, a2, buf)) {
				state = Cerror;
				break;
			}
			c-&gt;state = Cwrite;
			break;

		case Cdirty:
		case Cwrite:
			if(devwrite(cw-&gt;cdev, a2, buf))
				state = Cerror;
			break;
		}
		break;

	case Ogrow:
		if(state != Cnone) {
			print("%Z for block %lld cwgrow with state = %s\n",
				cw-&gt;cdev, (Wideoff)addr, cwnames[state]);
			break;
		}
		c-&gt;state = Cdirty;
		break;

	case Odump:
		if(state != Cdirty) {	/* BOTCH */
			print("%Z for block %lld cwdump with state = %s\n",
				cw-&gt;cdev, (Wideoff)addr, cwnames[state]);
			break;
		}
		c-&gt;state = Cdump;
		cw-&gt;ndump++;	/* only called from dump command */
		break;

	case Orele:
		if(state != Cwrite) {
			if(state != Cdump1)
				print("%Z for block %lld cwrele with state = %s\n",
					cw-&gt;cdev, (Wideoff)addr, cwnames[state]);
			break;
		}
		c-&gt;state = Cnone;
		break;

	case Ofree:
		if(state == Cwrite || state == Cread)
			c-&gt;state = Cnone;
		break;
	}
	if(DEBUG)
		print("cwio: %Z %lld s=%s o=%s ns=%s\n",
			dev, (Wideoff)addr, cwnames[state],
			cwnames[opcode],
			cwnames[c-&gt;state]);
	putbuf(p);
	if(newmax) {
		cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bmod|Bres);
		h = (Cache*)cb-&gt;iobuf;
		if(newmax &gt; h-&gt;wmax)
			h-&gt;wmax = newmax;
		putbuf(cb);
	}
	return state;

bad:
	print("%Z block %lld cw state = %s; cw opcode = %s",
		dev, (Wideoff)addr, cwnames[state], cwnames[opcode]);
	return Cerror;
}


int
cwgrow(Device *dev, Superb *sb, int uid)
{
	char str[NAMELEN];
	Iobuf *cb;
	Cache *h;
	Filsys *filsys;
	Off fs, nfs, ws;

	cb = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bmod|Bres);
	h = (Cache*)cb-&gt;iobuf;
	ws = h-&gt;wsize;
	fs = h-&gt;fsize;
	if(fs &gt;= ws)
		return 0;
	nfs = fs + ADDFREE;
	if(nfs &gt;= ws)
		nfs = ws;
	h-&gt;fsize = nfs;
	putbuf(cb);

	sb-&gt;fsize = nfs;
	filsys = dev2fs(dev);
	if (filsys == nil)
		print("%Z", dev);
	else
		print("%s", filsys-&gt;name);
	uidtostr(str, uid, 1);
	print(" grow from %lld to %lld limit %lld by %s uid=%d\n",
		(Wideoff)fs, (Wideoff)nfs, (Wideoff)ws, str, uid);
	for(nfs--; nfs&gt;=fs; nfs--)
		switch(cwio(dev, nfs, 0, Ogrow)) {
		case Cerror:
			return 0;
		case Cnone:
			addfree(dev, nfs, sb);
		}
	return 1;
}

int
cwfree(Device *dev, Off addr)
{
	int state;

	if(dev-&gt;type == Devcw) {
		state = cwio(dev, addr, 0, Ofree);
		if(state != Cdirty)
			return 1;	/* do not put in freelist */
	}
	return 0;			/* put in freelist */
}

#ifdef unused
int
bktcheck(Bucket *b)
{
	Centry *c, *c1, *c2, *ce;
	int err;

	err = 0;
	if(b-&gt;agegen &lt; CEPERBK || b-&gt;agegen &gt; MAXAGE) {
		print("agegen %ld\n", b-&gt;agegen);
		err = 1;
	}

	ce = b-&gt;entry + CEPERBK;
	c1 = 0;		/* lowest age last pass */
	for(;;) {
		c2 = 0;		/* lowest age this pass */
		for(c = b-&gt;entry; c &lt; ce; c++) {
			if(c1 != 0 &amp;&amp; c != c1) {
				if(c-&gt;age == c1-&gt;age) {
					print("same age %d\n", c-&gt;age);
					err = 1;
				}
				if(c1-&gt;waddr == c-&gt;waddr)
				if(c1-&gt;state != Cnone)
				if(c-&gt;state != Cnone) {
					print("same waddr %lld\n",
						(Wideoff)c-&gt;waddr);
					err = 1;
				}
			}
			if(c1 != 0 &amp;&amp; c-&gt;age &lt;= c1-&gt;age)
				continue;
			if(c2 == 0 || c-&gt;age &lt; c2-&gt;age)
				c2 = c;
		}
		if(c2 == 0)
			break;
		c1 = c2;
		if(c1-&gt;age &gt;= b-&gt;agegen) {
			print("age &gt;= generator %d %ld\n", c1-&gt;age, b-&gt;agegen);
			err = 1;
		}
	}
	return err;
}
#endif

void
resequence(Bucket *b)
{
	Centry *c, *ce, *cr;
	int age, i;

	ce = b-&gt;entry + CEPERBK;
	for(c = b-&gt;entry; c &lt; ce; c++) {
		c-&gt;age += CEPERBK;
		if(c-&gt;age &lt; CEPERBK)
			c-&gt;age = MAXAGE;
	}
	b-&gt;agegen += CEPERBK;

	age = 0;
	for(i=0;; i++) {
		cr = 0;
		for(c = b-&gt;entry; c &lt; ce; c++) {
			if(c-&gt;age &lt; i)
				continue;
			if(cr == 0 || c-&gt;age &lt; age) {
				cr = c;
				age = c-&gt;age;
			}
		}
		if(cr == 0)
			break;
		cr-&gt;age = i;
	}
	b-&gt;agegen = i;
	cons.nreseq++;
}

Centry*
getcentry(Bucket *b, Off addr)
{
	Centry *c, *ce, *cr;
	int s, age;

	/*
	 * search for cache hit
	 * find oldest block as byproduct
	 */
	ce = b-&gt;entry + CEPERBK;
	age = 0;
	cr = 0;
	for(c = b-&gt;entry; c &lt; ce; c++) {
		s = c-&gt;state;
		if(s == Cnone) {
			cr = c;
			age = 0;
			continue;
		}
		if(c-&gt;waddr == addr)
			goto found;
		if(s == Cread)
			if(cr == 0 || c-&gt;age &lt; age) {
				cr = c;
				age = c-&gt;age;
			}
	}

	/*
	 * remap entry
	 */
	c = cr;
	if(c == 0)
		return 0;	/* bucket is full */

	c-&gt;state = Cnone;
	c-&gt;waddr = addr;

found:
	/*
	 * update the age to get filo cache.
	 * small number in age means old
	 */
	if(!cons.noage || c-&gt;state == Cnone) {
		age = b-&gt;agegen;
		c-&gt;age = age;
		age++;
		b-&gt;agegen = age;
		if(age &lt; 0 || age &gt;= MAXAGE)
			resequence(b);
	}
	return c;
}

/*
 * ream the cache
 * calculate new buckets
 */
Iobuf*
cacheinit(Device *dev)
{
	Iobuf *cb, *p;
	Cache *h;
	Device *cdev;
	Off m;

	print("cache init %Z\n", dev);
	cdev = CDEV(dev);
	devinit(cdev);

	cb = getbuf(cdev, CACHE_ADDR, Bmod|Bres);
	memset(cb-&gt;iobuf, 0, RBUFSIZE);
	settag(cb, Tcache, QPSUPER);
	h = (Cache*)cb-&gt;iobuf;

	/*
	 * calculate csize such that
	 * tsize = msize/BKPERBLK + csize and
	 * msize = csize/CEPERBK
	 */
	h-&gt;maddr = CACHE_ADDR + 1;
	m = devsize(cdev) - h-&gt;maddr;
	h-&gt;csize = ((Devsize)(m-1) * CEPERBK*BKPERBLK) / (CEPERBK*BKPERBLK+1);
	h-&gt;msize = h-&gt;csize/CEPERBK - 5;
	while(!prime(h-&gt;msize))
		h-&gt;msize--;
	h-&gt;csize = h-&gt;msize*CEPERBK;
	h-&gt;caddr = h-&gt;maddr + (h-&gt;msize+BKPERBLK-1)/BKPERBLK;
	h-&gt;wsize = devsize(WDEV(dev));

	if(h-&gt;msize &lt;= 0)
		panic("cache too small");
	if(h-&gt;caddr + h-&gt;csize &gt; m)
		panic("cache size error");

	/*
	 * setup cache map
	 */
	for(m=h-&gt;maddr; m&lt;h-&gt;caddr; m++) {
		p = getbuf(cdev, m, Bmod);
		memset(p-&gt;iobuf, 0, RBUFSIZE);
		settag(p, Tbuck, m);
		putbuf(p);
	}
	print("done cacheinit\n");
	return cb;
}

Off
getstartsb(Device *dev)
{
	Filsys *f;
	Startsb *s;

	for(f=filsys; f-&gt;name; f++)
		if(devcmpr(f-&gt;dev, dev) == 0) {
			for(s=startsb; s-&gt;name; s++)
				if(strcmp(f-&gt;name, s-&gt;name) == 0)
					return s-&gt;startsb;
			print(
		"getstartsb: no special starting superblock for %Z %s\n",
				dev, f-&gt;name);
			return FIRST;
		}
	print("getstartsb: no filsys for device %Z\n", dev);
	return FIRST;
}

/*
 * ream the cache
 * calculate new buckets
 * get superblock from
 * last worm dump block.
 */
void
cwrecover(Device *dev)
{
	Iobuf *p, *cb;
	Cache *h;
	Superb *s;
	Off m, baddr;
	Device *wdev;

//	print("cwrecover %Z\n", dev);	// DEBUG
	cwinit1(dev);
	wdev = WDEV(dev);

	p = getbuf(devnone, Cwxx1, 0);
	s = (Superb*)p-&gt;iobuf;
	baddr = 0;
	m = getstartsb(dev);
	localconfinit();
	if(conf.firstsb)
		m = conf.firstsb;
	for(;;) {
		memset(p-&gt;iobuf, 0, RBUFSIZE);
		if(devread(wdev, m, p-&gt;iobuf) ||
		   checktag(p, Tsuper, QPSUPER))
			break;
		baddr = m;
		m = s-&gt;next;
		print("dump %lld is good; %lld next\n", (Wideoff)baddr, (Wideoff)m);
		if(baddr == conf.recovsb)
			break;
	}
	putbuf(p);
	if(!baddr)
		panic("recover: no superblock");

	p = getbuf(wdev, baddr, Brd);
	s = (Superb*)p-&gt;iobuf;

	cb = cacheinit(dev);
	h = (Cache*)cb-&gt;iobuf;
	h-&gt;sbaddr = baddr;
	h-&gt;cwraddr = s-&gt;cwraddr;
	h-&gt;roraddr = s-&gt;roraddr;
	h-&gt;fsize = s-&gt;fsize + 100;		/* this must be conservative */
	if(conf.recovcw)
		h-&gt;cwraddr = conf.recovcw;
	if(conf.recovro)
		h-&gt;roraddr = conf.recovro;

	putbuf(cb);
	putbuf(p);

	p = getbuf(dev, baddr, Brd|Bmod);
	s = (Superb*)p-&gt;iobuf;

	memset(&amp;s-&gt;fbuf, 0, sizeof(s-&gt;fbuf));
	s-&gt;fbuf.free[0] = 0;
	s-&gt;fbuf.nfree = 1;
	s-&gt;tfree = 0;
	if(conf.recovcw)
		s-&gt;cwraddr = conf.recovcw;
	if(conf.recovro)
		s-&gt;roraddr = conf.recovro;

	putbuf(p);
	print("done recover\n");
}

/*
 * ream the cache
 * calculate new buckets
 * initialize superblock.
 */
void
cwream(Device *dev)
{
	Iobuf *p, *cb;
	Cache *h;
	Superb *s;
	Off m, baddr;
	Device *cdev;

	print("cwream %Z\n", dev);
	cwinit1(dev);
	cdev = CDEV(dev);
	devinit(cdev);

	baddr = FIRST;	/*	baddr   = super addr
				baddr+1 = cw root
				baddr+2 = ro root
				baddr+3 = reserved next superblock */

	cb = cacheinit(dev);
	h = (Cache*)cb-&gt;iobuf;

	h-&gt;sbaddr = baddr;
	h-&gt;cwraddr = baddr+1;
	h-&gt;roraddr = baddr+2;
	h-&gt;fsize = 0;	/* prevents superream from freeing */

	putbuf(cb);

	for(m=0; m&lt;3; m++)
		cwio(dev, baddr+m, 0, Ogrow);
	superream(dev, baddr);
	rootream(dev, baddr+1);			/* cw root */
	rootream(dev, baddr+2);			/* ro root */

	cb = getbuf(cdev, CACHE_ADDR, Brd|Bmod|Bres);
	h = (Cache*)cb-&gt;iobuf;
	h-&gt;fsize = baddr+4;
	putbuf(cb);

	p = getbuf(dev, baddr, Brd|Bmod|Bimm);
	s = (Superb*)p-&gt;iobuf;
	s-&gt;last = baddr;
	s-&gt;cwraddr = baddr+1;
	s-&gt;roraddr = baddr+2;
	s-&gt;next = baddr+3;
	s-&gt;fsize = baddr+4;
	putbuf(p);

	for(m=0; m&lt;3; m++)
		cwio(dev, baddr+m, 0, Odump);
}

Off
rewalk1(Cw *cw, Off addr, int slot, Wpath *up)
{
	Iobuf *p, *p1;
	Dentry *d;

	if(up == 0)
		return cwraddr(cw-&gt;dev);
	up-&gt;addr = rewalk1(cw, up-&gt;addr, up-&gt;slot, up-&gt;up);
	p = getbuf(cw-&gt;dev, up-&gt;addr, Brd|Bmod);
	d = getdir(p, up-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		print("rewalk1 1\n");
		if(p)
			putbuf(p);
		return addr;
	}
	p1 = dnodebuf(p, d, slot/DIRPERBUF, 0, 0);
	if(!p1) {
		print("rewalk1 2\n");
		if(p)
			putbuf(p);
		return addr;
	}
	if(DEBUG)
		print("rewalk1 %lld to %lld \"%s\"\n",
			(Wideoff)addr, (Wideoff)p1-&gt;addr, d-&gt;name);
	addr = p1-&gt;addr;
	p1-&gt;flags |= Bmod;
	putbuf(p1);
	putbuf(p);
	return addr;
}

Off
rewalk2(Cw *cw, Off addr, int slot, Wpath *up)
{
	Iobuf *p, *p1;
	Dentry *d;

	if(up == 0)
		return cwraddr(cw-&gt;rodev);
	up-&gt;addr = rewalk2(cw, up-&gt;addr, up-&gt;slot, up-&gt;up);
	p = getbuf(cw-&gt;rodev, up-&gt;addr, Brd);
	d = getdir(p, up-&gt;slot);
	if(!d || !(d-&gt;mode &amp; DALLOC)) {
		print("rewalk2 1\n");
		if(p)
			putbuf(p);
		return addr;
	}
	p1 = dnodebuf(p, d, slot/DIRPERBUF, 0, 0);
	if(!p1) {
		print("rewalk2 2\n");
		if(p)
			putbuf(p);
		return addr;
	}
	if(DEBUG)
		print("rewalk2 %lld to %lld \"%s\"\n",
			(Wideoff)addr, (Wideoff)p1-&gt;addr, d-&gt;name);
	addr = p1-&gt;addr;
	putbuf(p1);
	putbuf(p);
	return addr;
}

void
rewalk(Cw *cw)
{
	int h;
	File *f;

	for(h=0; h&lt;nelem(flist); h++)
		for(f=flist[h]; f; f=f-&gt;next) {
			if(!f-&gt;fs)
				continue;
			if(cw-&gt;dev == f-&gt;fs-&gt;dev)
				f-&gt;addr = rewalk1(cw, f-&gt;addr, f-&gt;slot, f-&gt;wpath);
			else
			if(cw-&gt;rodev == f-&gt;fs-&gt;dev)
				f-&gt;addr = rewalk2(cw, f-&gt;addr, f-&gt;slot, f-&gt;wpath);
		}
}

Off
split(Cw *cw, Iobuf *p, Off addr)
{
	Off na;
	int state;

	na = 0;
	if(p &amp;&amp; (p-&gt;flags &amp; Bmod)) {
		p-&gt;flags |= Bimm;
		putbuf(p);
		p = 0;
	}
	state = cwio(cw-&gt;dev, addr, 0, Onone);	/* read the state (twice?) */
	switch(state) {
	default:
		panic("split: unknown state %s", cwnames[state]);

	case Cerror:
	case Cnone:
	case Cdump:
	case Cread:
		break;

	case Cdump1:
	case Cwrite:
		/*
		 * botch.. could be done by relabeling
		 */
		if(!p) {
			p = getbuf(cw-&gt;dev, addr, Brd);
			if(!p) {
				print("split: null getbuf\n");
				break;
			}
		}
		na = cw-&gt;fsize;
		cw-&gt;fsize = na+1;
		cwio(cw-&gt;dev, na, 0, Ogrow);
		cwio(cw-&gt;dev, na, p-&gt;iobuf, Owrite);
		cwio(cw-&gt;dev, na, 0, Odump);
		cwio(cw-&gt;dev, addr, 0, Orele);
		break;

	case Cdirty:
		cwio(cw-&gt;dev, addr, 0, Odump);
		break;
	}
	if(p)
		putbuf(p);
	return na;
}

int
isdirty(Cw *cw, Iobuf *p, Off addr, int tag)
{
	int s;

	if(p &amp;&amp; (p-&gt;flags &amp; Bmod))
		return 1;
	s = cwio(cw-&gt;dev, addr, 0, Onone);
	if(s == Cdirty || s == Cwrite)
		return 1;
	if(tag &gt;= Tind1 &amp;&amp; tag &lt;= Tmaxind)
		/* botch, get these modified */
		if(s != Cnone)
			return 1;
	return 0;
}

Off
cwrecur(Cw *cw, Off addr, int tag, int tag1, long qp)
{
	Iobuf *p;
	Dentry *d;
	int i, j, shouldstop;
	Off na;
	char *np;

	shouldstop = 0;
	p = getbuf(cw-&gt;dev, addr, Bprobe);
	if(!isdirty(cw, p, addr, tag)) {
		if(!cw-&gt;all) {
			if(DEBUG)
				print("cwrecur: %lld t=%s not dirty %s\n",
					(Wideoff)addr, tagnames[tag], cw-&gt;name);
			if(p)
				putbuf(p);
			return 0;
		}
		shouldstop = 1;
	}
	if(DEBUG)
		print("cwrecur: %lld t=%s %s\n",
			(Wideoff)addr, tagnames[tag], cw-&gt;name);
	if(cw-&gt;depth &gt;= 100) {
		print("dump depth too great %s\n", cw-&gt;name);
		if(p)
			putbuf(p);
		return 0;
	}
	cw-&gt;depth++;

	switch(tag) {
	default:
		print("cwrecur: unknown tag %d %s\n", tag, cw-&gt;name);

	case Tfile:
		break;

	case Tsuper:
	case Tdir:
		if(!p) {
			p = getbuf(cw-&gt;dev, addr, Brd);
			if(!p) {
				print("cwrecur: Tdir p null %s\n",
					cw-&gt;name);
				break;
			}
		}
		if(tag == Tdir) {
			cw-&gt;namepad[0] = 0;	/* force room */
			np = strchr(cw-&gt;name, 0);
			*np++ = '/';
		} else {
			np = 0;	/* set */
			cw-&gt;name[0] = 0;
		}

		for(i=0; i&lt;DIRPERBUF; i++) {
			d = getdir(p, i);
			if(!(d-&gt;mode &amp; DALLOC))
				continue;
			qp = d-&gt;qid.path &amp; ~QPDIR;
			if(tag == Tdir)
				strncpy(np, d-&gt;name, NAMELEN);
			else
			if(i &gt; 0)
				print("cwrecur: root with &gt;1 directory\n");
			tag1 = Tfile;
			if(d-&gt;mode &amp; DDIR)
				tag1 = Tdir;
			for(j=0; j&lt;NDBLOCK; j++) {
				na = d-&gt;dblock[j];
				if(na) {
					na = cwrecur(cw, na, tag1, 0, qp);
					if(na) {
						d-&gt;dblock[j] = na;
						p-&gt;flags |= Bmod;
					}
				}
			}
			for (j = 0; j &lt; NIBLOCK; j++) {
				na = d-&gt;iblocks[j];
				if(na) {
					na = cwrecur(cw, na, Tind1+j, tag1, qp);
					if(na) {
						d-&gt;iblocks[j] = na;
						p-&gt;flags |= Bmod;
					}
				}
			}
		}
		break;

	case Tind1:
		j = tag1;
		tag1 = 0;
		goto tind;

	case Tind2:
#ifndef COMPAT32
	case Tind3:
	case Tind4:
	/* add more Tind tags here ... */
#endif
		j = tag-1;
	tind:
		if(!p) {
			p = getbuf(cw-&gt;dev, addr, Brd);
			if(!p) {
				print("cwrecur: Tind p null %s\n", cw-&gt;name);
				break;
			}
		}
		for(i=0; i&lt;INDPERBUF; i++) {
			na = ((Off *)p-&gt;iobuf)[i];
			if(na) {
				na = cwrecur(cw, na, j, tag1, qp);
				if(na) {
					((Off *)p-&gt;iobuf)[i] = na;
					p-&gt;flags |= Bmod;
				}
			}
		}
		break;
	}
	na = split(cw, p, addr);
	cw-&gt;depth--;
	if(na &amp;&amp; shouldstop) {
		if(cw-&gt;falsehits &lt; 10)
			print("shouldstop %lld %lld t=%s %s\n",
				(Wideoff)addr, (Wideoff)na,
				tagnames[tag], cw-&gt;name);
		cw-&gt;falsehits++;
	}
	return na;
}

Timet	nextdump(Timet t);

void
cfsdump(Filsys *fs)
{
	long m, n, i;
	Off orba, rba, oroa, roa, sba, a;
	Timet tim;
	char tstr[20];
	Iobuf *pr, *p1, *p;
	Dentry *dr, *d1, *d;
	Cache *h;
	Superb *s;
	Cw *cw;

	if(fs-&gt;dev-&gt;type != Devcw) {
		print("cant dump; not cw device: %Z\n", fs-&gt;dev);
		return;
	}
	cw = fs-&gt;dev-&gt;private;
	if(cw == 0) {
		print("cant dump: has not been inited: %Z\n", fs-&gt;dev);
		return;
	}

	tim = toytime();
	wlock(&amp;mainlock);		/* dump */

	/*
	 * set up static structure
	 * with frequent variables
	 */
	cw-&gt;ndump = 0;
	cw-&gt;name[0] = 0;
	cw-&gt;depth = 0;

	/*
	 * cw root
	 */
	sync("before dump");
	cw-&gt;fsize = cwsize(cw-&gt;dev);
	orba = cwraddr(cw-&gt;dev);
	print("cwroot %lld", (Wideoff)orba);
	cons.noage = 1;
	cw-&gt;all = cw-&gt;allflag;
	rba = cwrecur(cw, orba, Tsuper, 0, QPROOT);
	if(rba == 0)
		rba = orba;
	print("-&gt;%lld\n", (Wideoff)rba);
	sync("after cw");

	/*
	 * partial super block
	 */
	p = getbuf(cw-&gt;dev, cwsaddr(cw-&gt;dev), Brd|Bmod|Bimm);
	s = (Superb*)p-&gt;iobuf;
	s-&gt;fsize = cw-&gt;fsize;
	s-&gt;cwraddr = rba;
	putbuf(p);

	/*
	 * partial cache block
	 */
	p = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bmod|Bimm|Bres);
	h = (Cache*)p-&gt;iobuf;
	h-&gt;fsize = cw-&gt;fsize;
	h-&gt;cwraddr = rba;
	putbuf(p);

	/*
	 * ro root
	 */
	oroa = cwraddr(cw-&gt;rodev);
	pr = getbuf(cw-&gt;dev, oroa, Brd|Bmod);
	dr = getdir(pr, 0);

	datestr(tstr, time(nil));	/* tstr = "yyyymmdd" */
	n = 0;
	for(a=0;; a++) {
		p1 = dnodebuf(pr, dr, a, Tdir, 0);
		if(!p1)
			goto bad;
		n++;
		for(i=0; i&lt;DIRPERBUF; i++) {
			d1 = getdir(p1, i);
			if(!d1)
				goto bad;
			if(!(d1-&gt;mode &amp; DALLOC))
				goto found1;
			if(!memcmp(d1-&gt;name, tstr, 4))
				goto found2;	/* found entry */
		}
		putbuf(p1);
	}

	/*
	 * no year directory, create one
	 */
found1:
	p = getbuf(cw-&gt;dev, rba, Brd);
	d = getdir(p, 0);
	d1-&gt;qid = d-&gt;qid;
	d1-&gt;qid.version += n;
	memmove(d1-&gt;name, tstr, 4);
	d1-&gt;mode = d-&gt;mode;
	d1-&gt;uid = d-&gt;uid;
	d1-&gt;gid = d-&gt;gid;
	putbuf(p);
	accessdir(p1, d1, FWRITE, 0);

	/*
	 * put mmdd[count] in year directory
	 */
found2:
	accessdir(p1, d1, FREAD, 0);
	putbuf(pr);
	pr = p1;
	dr = d1;

	n = 0;
	m = 0;
	for(a=0;; a++) {
		p1 = dnodebuf(pr, dr, a, Tdir, 0);
		if(!p1)
			goto bad;
		n++;
		for(i=0; i&lt;DIRPERBUF; i++) {
			d1 = getdir(p1, i);
			if(!d1)
				goto bad;
			if(!(d1-&gt;mode &amp; DALLOC))
				goto found;
			if(!memcmp(d1-&gt;name, tstr+4, 4))
				m++;
		}
		putbuf(p1);
	}

	/*
	 * empty slot put in root
	 */
found:
	if(m)	/* how many dumps this date */
		sprint(tstr+8, "%ld", m);

	p = getbuf(cw-&gt;dev, rba, Brd);
	d = getdir(p, 0);
	*d1 = *d;				/* qid is QPROOT */
	putbuf(p);
	strcpy(d1-&gt;name, tstr+4);
	d1-&gt;qid.version += n;
	accessdir(p1, d1, FWRITE, 0);
	putbuf(p1);
	putbuf(pr);

	cw-&gt;fsize = cwsize(cw-&gt;dev);
	oroa = cwraddr(cw-&gt;rodev);		/* probably redundant */
	print("roroot %lld", (Wideoff)oroa);

	cons.noage = 0;
	cw-&gt;all = 0;
	roa = cwrecur(cw, oroa, Tsuper, 0, QPROOT);
	if(roa == 0) {
		print("[same]");
		roa = oroa;
	}
	print("-&gt;%lld /%.4s/%s\n", (Wideoff)roa, tstr, tstr+4);
	sync("after ro");

	/*
	 * final super block
	 */
	a = cwsaddr(cw-&gt;dev);
	print("sblock %lld", (Wideoff)a);
	p = getbuf(cw-&gt;dev, a, Brd|Bmod|Bimm);
	s = (Superb*)p-&gt;iobuf;
	s-&gt;last = a;
	sba = s-&gt;next;
	s-&gt;next = cw-&gt;fsize;
	cw-&gt;fsize++;
	s-&gt;fsize = cw-&gt;fsize;
	s-&gt;roraddr = roa;

	cwio(cw-&gt;dev, sba, 0, Ogrow);
	cwio(cw-&gt;dev, sba, p-&gt;iobuf, Owrite);
	cwio(cw-&gt;dev, sba, 0, Odump);
	print("-&gt;%lld (-&gt;%lld)\n", (Wideoff)sba, (Wideoff)s-&gt;next);

	putbuf(p);

	/*
	 * final cache block
	 */
	p = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bmod|Bimm|Bres);
	h = (Cache*)p-&gt;iobuf;
	h-&gt;fsize = cw-&gt;fsize;
	h-&gt;roraddr = roa;
	h-&gt;sbaddr = sba;
	putbuf(p);

	rewalk(cw);
	sync("all done");

	print("%lld blocks queued for worm\n", (Wideoff)cw-&gt;ndump);
	print("%lld falsehits\n", (Wideoff)cw-&gt;falsehits);
	cw-&gt;nodump = 0;

	/*
	 * extend all of the locks
	 */
	tim = toytime() - tim;
	for(i=0; i&lt;NTLOCK; i++)
		if(tlocks[i].time &gt; 0)
			tlocks[i].time += tim;

	wunlock(&amp;mainlock);
	nextdump(time(nil));
	return;

bad:
	panic("dump: bad");
}

void
mvstates(Device *dev, int s1, int s2, int side)
{
	Iobuf *p, *cb;
	Cache *h;
	Bucket *b;
	Centry *c, *ce;
	Off m, lo, hi, msize, maddr;
	Cw *cw;

	cw = dev-&gt;private;
	lo = 0;
	hi = lo + devsize(dev-&gt;cw.w);	/* size of all sides totalled */
	if(side &gt;= 0) {
		/* operate on only a single disc side */
		Sidestarts ss;

		wormsidestarts(dev, side, &amp;ss);
		lo = ss.sstart;
		hi = ss.s1start;
	}
	cb = getbuf(cw-&gt;cdev, CACHE_ADDR, Brd|Bres);
	if(!cb || checktag(cb, Tcache, QPSUPER))
		panic("cwstats: checktag c bucket");
	h = (Cache*)cb-&gt;iobuf;
	msize = h-&gt;msize;
	maddr = h-&gt;maddr;
	putbuf(cb);

	for(m=0; m&lt;msize; m++) {
		p = getbuf(cw-&gt;cdev, maddr + m/BKPERBLK, Brd|Bmod);
		if(!p || checktag(p, Tbuck, maddr + m/BKPERBLK))
			panic("cwtest: checktag c bucket");
		b = (Bucket*)p-&gt;iobuf + m%BKPERBLK;
		ce = b-&gt;entry + CEPERBK;
		for(c=b-&gt;entry; c&lt;ce; c++)
			if(c-&gt;state == s1 &amp;&amp; c-&gt;waddr &gt;= lo &amp;&amp; c-&gt;waddr &lt; hi)
				c-&gt;state = s2;
		putbuf(p);
	}
}

void
prchain(Device *dev, Off m, int flg)
{
	Iobuf *p;
	Superb *s;

	if(m == 0) {
		if(flg)
			m = cwsaddr(dev);
		else
			m = getstartsb(dev);
	}
	p = getbuf(devnone, Cwxx2, 0);
	s = (Superb*)p-&gt;iobuf;
	for(;;) {
		memset(p-&gt;iobuf, 0, RBUFSIZE);
		if(devread(WDEV(dev), m, p-&gt;iobuf) ||
		   checktag(p, Tsuper, QPSUPER))
			break;
		if(flg) {
			print("dump %lld is good; %lld prev\n", (Wideoff)m,
				(Wideoff)s-&gt;last);
			print("\t%lld cwroot; %lld roroot\n",
				(Wideoff)s-&gt;cwraddr, (Wideoff)s-&gt;roraddr);
			if(m &lt;= s-&gt;last)
				break;
			m = s-&gt;last;
		} else {
			print("dump %lld is good; %lld next\n", (Wideoff)m,
				(Wideoff)s-&gt;next);
			print("\t%lld cwroot; %lld roroot\n",
				(Wideoff)s-&gt;cwraddr, (Wideoff)s-&gt;roraddr);
			if(m &gt;= s-&gt;next)
				break;
			m = s-&gt;next;
		}
	}
	putbuf(p);
}

void
touchsb(Device *dev)
{
	Iobuf *p;
	Off m;

	m = cwsaddr(dev);
	p = getbuf(devnone, Cwxx2, 0);

	memset(p-&gt;iobuf, 0, RBUFSIZE);
	if(devread(WDEV(dev), m, p-&gt;iobuf) ||
	   checktag(p, Tsuper, QPSUPER))
		print("%Z block %lld WORM SUPER BLOCK READ FAILED\n",
			WDEV(dev), (Wideoff)m);
	else
		print("%Z touch superblock %lld\n", WDEV(dev), (Wideoff)m);
	putbuf(p);
}

void
storesb(Device *dev, Off last, int doit)
{
	Iobuf *ph, *ps;
	Cache *h;
	Superb *s;
	Off sbaddr, qidgen;

	sbaddr = cwsaddr(dev);

	ps = getbuf(devnone, Cwxx2, 0);
	if(!ps) {
		print("sbstore: getbuf\n");
		return;
	}

	/*
	 * try to read last sb
	 */
	memset(ps-&gt;iobuf, 0, RBUFSIZE);
	if(devread(WDEV(dev), last, ps-&gt;iobuf) ||
	   checktag(ps, Tsuper, QPSUPER))
		print("read last failed\n");
	else
		print("read last succeeded\n");

	s = (Superb*)ps-&gt;iobuf;
	qidgen = s-&gt;qidgen;
	if(qidgen == 0)
		qidgen = 0x31415;
	qidgen += 1000;
	if(s-&gt;next != sbaddr)
		print("next(last) is not sbaddr %lld %lld\n",
			(Wideoff)s-&gt;next, (Wideoff)sbaddr);
	else
		print("next(last) is sbaddr\n");

	/*
	 * read cached superblock
	 */
	ph = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bres);
	if(!ph || checktag(ph, Tcache, QPSUPER)) {
		print("cwstats: checktag c bucket\n");
		if(ph)
			putbuf(ph);
		putbuf(ps);
		return;
	} else
		print("read cached sb succeeded\n");

	h = (Cache*)ph-&gt;iobuf;

	memset(ps-&gt;iobuf, 0, RBUFSIZE);
	settag(ps, Tsuper, QPSUPER);
	ps-&gt;flags = 0;
	s = (Superb*)ps-&gt;iobuf;

	s-&gt;cwraddr = h-&gt;cwraddr;
	s-&gt;roraddr = h-&gt;roraddr;
	s-&gt;fsize = h-&gt;fsize;
	s-&gt;fstart = 2;
	s-&gt;last = last;
	s-&gt;next = h-&gt;roraddr+1;

	s-&gt;qidgen = qidgen;
	putbuf(ph);

	if(s-&gt;fsize-1 != s-&gt;next ||
	   s-&gt;fsize-2 != s-&gt;roraddr ||
	   s-&gt;fsize-5 != s-&gt;cwraddr) {
		print("addrs not in relationship %lld %lld %lld %lld\n",
			(Wideoff)s-&gt;cwraddr, (Wideoff)s-&gt;roraddr,
			(Wideoff)s-&gt;next, (Wideoff)s-&gt;fsize);
		putbuf(ps);
		return;
	} else
		print("addresses in relation\n");

	if(doit)
	if(devwrite(WDEV(dev), sbaddr, ps-&gt;iobuf))
		print("%Z block %lld WORM SUPER BLOCK WRITE FAILED\n",
			WDEV(dev), (Wideoff)sbaddr);
	ps-&gt;flags = 0;
	putbuf(ps);
}

void
savecache(Device *dev)
{
	Iobuf *p, *cb;
	Cache *h;
	Bucket *b;
	Centry *c, *ce;
	long n, left;
	Off m, maddr, msize, *longp, nbyte;
	Device *cdev;

	if(walkto("/adm/cache") || con_open(FID2, OWRITE|OTRUNC)) {
		print("cant open /adm/cache\n");
		return;
	}
	cdev = CDEV(dev);
	cb = getbuf(cdev, CACHE_ADDR, Brd|Bres);
	if(!cb || checktag(cb, Tcache, QPSUPER))
		panic("savecache: checktag c bucket");
	h = (Cache*)cb-&gt;iobuf;
	msize = h-&gt;msize;
	maddr = h-&gt;maddr;
	putbuf(cb);

	n = BUFSIZE;			/* calculate write size */
	if(n &gt; MAXDAT)
		n = MAXDAT;

	cb = getbuf(devnone, Cwxx4, 0);
	longp = (Off *)cb-&gt;iobuf;
	left = n/sizeof(Off);
	cons.offset = 0;

	for(m=0; m&lt;msize; m++) {
		if(left &lt; BKPERBLK) {
			nbyte = (n/sizeof(Off) - left) * sizeof(Off);
			con_write(FID2, cb-&gt;iobuf, cons.offset, nbyte);
			cons.offset += nbyte;
			longp = (Off *)cb-&gt;iobuf;
			left = n/sizeof(Off);
		}
		p = getbuf(cdev, maddr + m/BKPERBLK, Brd);
		if(!p || checktag(p, Tbuck, maddr + m/BKPERBLK))
			panic("cwtest: checktag c bucket");
		b = (Bucket*)p-&gt;iobuf + m%BKPERBLK;
		ce = b-&gt;entry + CEPERBK;
		for(c = b-&gt;entry; c &lt; ce; c++)
			if(c-&gt;state == Cread) {
				*longp++ = c-&gt;waddr;
				left--;
			}
		putbuf(p);
	}
	nbyte = (n/sizeof(Off) - left) * sizeof(Off);
	con_write(FID2, cb-&gt;iobuf, cons.offset, nbyte);
	putbuf(cb);
}

void
loadcache(Device *dev, int dskno)
{
	Iobuf *p, *cb;
	Off m, nbyte, *longp, count;
	Sidestarts ss;

	if(walkto("/adm/cache") || con_open(FID2, OREAD)) {
		print("cant open /adm/cache\n");
		return;
	}

	cb = getbuf(devnone, Cwxx4, 0);
	cons.offset = 0;
	count = 0;

	if (dskno &gt;= 0)
		wormsidestarts(dev, dskno, &amp;ss);
	for(;;) {
		memset(cb-&gt;iobuf, 0, BUFSIZE);
		nbyte = con_read(FID2, cb-&gt;iobuf, cons.offset, 100) / sizeof(Off);
		if(nbyte &lt;= 0)
			break;
		cons.offset += nbyte * sizeof(Off);
		longp = (Off *)cb-&gt;iobuf;
		while(nbyte &gt; 0) {
			m = *longp++;
			nbyte--;
			if(m == 0)
				continue;
			/* if given a diskno, restrict to just that disc side */
			if(dskno &lt; 0 || m &gt;= ss.sstart &amp;&amp; m &lt; ss.s1start) {
				p = getbuf(dev, m, Brd);
				if(p)
					putbuf(p);
				count++;
			}
		}
	}
	putbuf(cb);
	print("%lld blocks loaded from worm %d\n", (Wideoff)count, dskno);
}

void
morecache(Device *dev, int dskno, Off size)
{
	Iobuf *p;
	Off m, ml, mh, mm, count;
	Cache *h;
	Sidestarts ss;

	p = getbuf(CDEV(dev), CACHE_ADDR, Brd|Bres);
	if(!p || checktag(p, Tcache, QPSUPER))
		panic("savecache: checktag c bucket");
	h = (Cache*)p-&gt;iobuf;
	mm = h-&gt;wmax;
	putbuf(p);

	wormsidestarts(dev, dskno, &amp;ss);
	ml = ss.sstart;		/* start at beginning of disc side #dskno */
	mh = ml + size;
	if(mh &gt; mm) {
		mh = mm;
		print("limited to %lld\n", (Wideoff)mh-ml);
	}

	count = 0;
	for(m=ml; m &lt; mh; m++) {
		p = getbuf(dev, m, Brd);
		if(p)
			putbuf(p);
		count++;
	}
	print("%lld blocks loaded from worm %d\n", (Wideoff)count, dskno);
}

void
blockcmp(Device *dev, Off wa, Off ca)
{
	Iobuf *p1, *p2;
	int i, c;

	p1 = getbuf(WDEV(dev), wa, Brd);
	if(!p1) {
		print("blockcmp: wdev error\n");
		return;
	}

	p2 = getbuf(CDEV(dev), ca, Brd);
	if(!p2) {
		print("blockcmp: cdev error\n");
		putbuf(p1);
		return;
	}

	c = 0;
	for(i=0; i&lt;RBUFSIZE; i++)
		if(p1-&gt;iobuf[i] != p2-&gt;iobuf[i]) {
			print("%4d: %.2x %.2x\n",
				i,
				p1-&gt;iobuf[i]&amp;0xff,
				p2-&gt;iobuf[i]&amp;0xff);
			c++;
			if(c &gt;= 10)
				break;
		}

	if(c == 0)
		print("no error\n");
	putbuf(p1);
	putbuf(p2);
}

void
wblock(Device *dev, Off addr)
{
	Iobuf *p1;
	int i;

	p1 = getbuf(dev, addr, Brd);
	if(p1) {
		i = devwrite(WDEV(dev), addr, p1-&gt;iobuf);
		print("i = %d\n", i);
		putbuf(p1);
	}
}

void
cwtest(Device*)
{
}

#ifdef	XXX
/* garbage to change sb size
 * probably will need it someday
 */
	fsz = number(0, 0, 10);
	count = 0;
	if(fsz == number(0, -1, 10))
		count = -1;		/* really do it */
	print("fsize = %ld\n", fsz);
	cdev = CDEV(dev);
	cb = getbuf(cdev, CACHE_ADDR, Brd|Bres);
	if(!cb || checktag(cb, Tcache, QPSUPER))
		panic("cwstats: checktag c bucket");
	h = (Cache*)cb-&gt;iobuf;
	for(m=0; m&lt;h-&gt;msize; m++) {
		p = getbuf(cdev, h-&gt;maddr + m/BKPERBLK, Brd|Bmod);
		if(!p || checktag(p, Tbuck, h-&gt;maddr + m/BKPERBLK))
			panic("cwtest: checktag c bucket");
		b = (Bucket*)p-&gt;iobuf + m%BKPERBLK;
		ce = b-&gt;entry + CEPERBK;
		for(c=b-&gt;entry; c&lt;ce; c++) {
			if(c-&gt;waddr &lt; fsz)
				continue;
			if(count &lt; 0) {
				c-&gt;state = Cnone;
				continue;
			}
			if(c-&gt;state != Cdirty)
				count++;
		}
		putbuf(p);
	}
	if(count &lt; 0) {
		print("old cache hsize = %ld\n", h-&gt;fsize);
		h-&gt;fsize = fsz;
		cb-&gt;flags |= Bmod;
		p = getbuf(dev, h-&gt;sbaddr, Brd|Bmod);
		s = (Superb*)p-&gt;iobuf;
		print("old super hsize = %ld\n", s-&gt;fsize);
		s-&gt;fsize = fsz;
		putbuf(p);
	}
	putbuf(cb);
	print("count = %lld\n", (Wideoff)count);
#endif

int
convstate(char *name)
{
	int i;

	for(i=0; i&lt;nelem(cwnames); i++)
		if(cwnames[i])
			if(strcmp(cwnames[i], name) == 0)
				return i;
	return -1;
}

void
searchtag(Device *d, Off a, int tag, int n)
{
	Iobuf *p;
	Tag *t;
	int i;

	if(a == 0)
		a = getstartsb(d);
	p = getbuf(devnone, Cwxx2, 0);
	t = (Tag*)(p-&gt;iobuf+BUFSIZE);
	for(i=0; i&lt;n; i++) {
		memset(p-&gt;iobuf, 0, RBUFSIZE);
		if(devread(WDEV(d), a+i, p-&gt;iobuf)) {
			if(n == 1000)
				break;
			continue;
		}
		if(t-&gt;tag == tag) {
			print("tag %d found at %Z %lld\n", tag, d, (Wideoff)a+i);
			break;
		}
	}
	putbuf(p);
}

void
cmd_cwcmd(int argc, char *argv[])
{
	Device *dev;
	char *arg;
	char str[28];
	Off s1, s2, a, b, n;
	Cw *cw;

	if(argc &lt;= 1) {
		print("\tcwcmd mvstate state1 state2 [platter]\n");
		print("\tcwcmd prchain [start] [bakflg]\n");
		print("\tcwcmd searchtag [start] [tag] [blocks]\n");
		print("\tcwcmd touchsb\n");
		print("\tcwcmd savecache\n");
		print("\tcwcmd loadcache [dskno]\n");
		print("\tcwcmd morecache dskno [count]\n");
		print("\tcwcmd blockcmp wbno cbno\n");
		print("\tcwcmd startdump [01]\n");
		print("\tcwcmd acct\n");
		print("\tcwcmd clearacct\n");
		return;
	}
	arg = argv[1];

	/*
	 * items not depend on a cw filesystem
	 */
	if(strcmp(arg, "acct") == 0) {
		for(a=0; a&lt;nelem(growacct); a++) {
			b = growacct[a];
			if(b) {
				uidtostr(str, a, 1);
				print("%10lld %s\n",
					((Wideoff)b*ADDFREE*RBUFSIZE+500000)/1000000,
					str);
			}
		}
		return;
	}
	if(strcmp(arg, "clearacct") == 0) {
		memset(growacct, 0, sizeof(growacct));
		return;
	}

	/*
	 * items depend on cw filesystem
	 */
	dev = cons.curfs-&gt;dev;
	if(dev == 0 || dev-&gt;type != Devcw || dev-&gt;private == 0) {
		print("cfs not a cw filesystem: %Z\n", dev);
		return;
	}
	cw = dev-&gt;private;
	if(strcmp(arg, "searchtag") == 0) {
		a = 0;
		if(argc &gt; 2)
			a = number(argv[2], 0, 10);
		b = Tsuper;
		if(argc &gt; 3)
			b = number(argv[3], 0, 10);
		n = 1000;
		if(argc &gt; 4)
			n = number(argv[4], 0, 10);
		searchtag(dev, a, b, n);
	} else if(strcmp(arg, "mvstate") == 0) {
		if(argc &lt; 4)
			goto bad;
		s1 = convstate(argv[2]);
		s2 = convstate(argv[3]);
		if(s1 &lt; 0 || s2 &lt; 0)
			goto bad;
		a = -1;
		if(argc &gt; 4)
			a = number(argv[4], 0, 10);
		mvstates(dev, s1, s2, a);
		return;
	bad:
		print("cwcmd mvstate: bad args\n");
	} else if(strcmp(arg, "prchain") == 0) {
		a = 0;
		if(argc &gt; 2)
			a = number(argv[2], 0, 10);
		s1 = 0;
		if(argc &gt; 3)
			s1 = number(argv[3], 0, 10);
		prchain(dev, a, s1);
	} else if(strcmp(arg, "touchsb") == 0)
		touchsb(dev);
	else if(strcmp(arg, "savecache") == 0)
		savecache(dev);
	else if(strcmp(arg, "loadcache") == 0) {
		s1 = -1;
		if(argc &gt; 2)
			s1 = number(argv[2], 0, 10);
		loadcache(dev, s1);
	} else if(strcmp(arg, "morecache") == 0) {
		if(argc &lt;= 2) {
			print("arg count\n");
			return;
		}
		s1 = number(argv[2], 0, 10);
		if(argc &gt; 3)
			s2 = number(argv[3], 0, 10);
		else
			s2 = wormsizeside(dev, s1); /* default to 1 disc side */
		morecache(dev, s1, s2);
	} else if(strcmp(arg, "blockcmp") == 0) {
		if(argc &lt; 4) {
			print("cannot arg count\n");
			return;
		}
		s1 = number(argv[2], 0, 10);
		s2 = number(argv[3], 0, 10);
		blockcmp(dev, s1, s2);
	} else if(strcmp(arg, "startdump") == 0) {
		if(argc &gt; 2)
			cw-&gt;nodump = number(argv[2], 0, 10);
		cw-&gt;nodump = !cw-&gt;nodump;
		if(cw-&gt;nodump)
			print("dump stopped\n");
		else
			print("dump allowed\n");
	} else if(strcmp(arg, "allflag") == 0) {
		if(argc &gt; 2)
			cw-&gt;allflag = number(argv[2], 0, 10);
		else
			cw-&gt;allflag = !cw-&gt;allflag;
		print("allflag = %d; falsehits = %lld\n",
			cw-&gt;allflag, (Wideoff)cw-&gt;falsehits);
	} else if(strcmp(arg, "storesb") == 0) {
		a = 4168344;
		b = 0;
		if(argc &gt; 2)
			a = number(argv[2], 4168344, 10);
		if(argc &gt; 3)
			b = number(argv[3], 0, 10);
		storesb(dev, a, b);
	} else if(strcmp(arg, "test") == 0)
		cwtest(dev);
	else
		print("unknown cwcmd %s\n", arg);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

