<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/dentry.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/dentry.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

Dentry*
getdir(Iobuf *p, int slot)
{
	if(!p)
		return 0;
	return (Dentry*)p-&gt;iobuf + slot%DIRPERBUF;
}

void
accessdir(Iobuf *p, Dentry *d, int f, int uid)
{
	Timet t;

	if(p &amp;&amp; p-&gt;dev-&gt;type != Devro) {
		p-&gt;flags |= Bmod;
		t = time(nil);
		if(f &amp; (FREAD|FWRITE))
			d-&gt;atime = t;
		if(f &amp; FWRITE) {
			d-&gt;mtime = t;
			d-&gt;muid = uid;
			d-&gt;qid.version++;
		}
	}
}

void
preread(Device *d, Off addr)
{
	Rabuf *rb;

	if(addr == 0)
		return;
	if(raheadq-&gt;count+10 &gt;= raheadq-&gt;size)	/* ugly knowing layout */
		return;
	lock(&amp;rabuflock);
	rb = rabuffree;
	if(rb == 0) {
		unlock(&amp;rabuflock);
		return;
	}
	rabuffree = rb-&gt;link;
	unlock(&amp;rabuflock);
	rb-&gt;dev = d;
	rb-&gt;addr = addr;
	fs_send(raheadq, rb);
}

Off
rel2abs(Iobuf *p, Dentry *d, Off a, int tag, int putb, int uid)
{
	int i;
	Off addr, qpath, indaddrs = 1, div;
	Device *dev;

	if(a &lt; 0) {
		print("rel2abs: neg offset\n");
		if(putb)
			putbuf(p);
		return 0;
	}
	dev = p-&gt;dev;
	qpath = d-&gt;qid.path;

	/* is `a' a direct block? */
	if(a &lt; NDBLOCK) {
		addr = d-&gt;dblock[a];
		if(!addr &amp;&amp; tag) {
			addr = bufalloc(dev, tag, qpath, uid);
			d-&gt;dblock[a] = addr;
			p-&gt;flags |= Bmod|Bimm;
		}
		if(putb)
			putbuf(p);
		return addr;
	}
	a -= NDBLOCK;

	/*
	 * loop through indirect block depths.
	 */
	for (i = 0; i &lt; NIBLOCK; i++) {
		indaddrs *= INDPERBUF;
		/* is a's disk addr in this indir block or one of its kids? */
		if (a &lt; indaddrs) {
			addr = d-&gt;iblocks[i];
			if(!addr &amp;&amp; tag) {
				addr = bufalloc(dev, Tind1+i, qpath, uid);
				d-&gt;iblocks[i] = addr;
				p-&gt;flags |= Bmod|Bimm;
			}
			if(putb)
				putbuf(p);

			div = indaddrs;
			for (; i &gt;= 0; i--) {
				div /= INDPERBUF;
				if (div &lt;= 0)
					panic("rel2abs: non-positive divisor");
				addr = indfetch(dev, qpath, addr,
					(a/div)%INDPERBUF, Tind1+i,
					(i == 0? tag: Tind1+i-1), uid);
			}
			return addr;
		}
		a -= indaddrs;
	}
	if(putb)
		putbuf(p);

	/* quintuple-indirect blocks not implemented. */
	print("rel2abs: no %d-deep indirect\n", NIBLOCK+1);
	return 0;
}

/*
 * read-ahead strategy
 * on second block, read RAGAP blocks,
 * thereafter, read RAGAP ahead of current pos
 */
Off
dbufread(Iobuf *p, Dentry *d, Off a, Off ra, int uid)
{
	Off addr;

	if(a == 0)
		return 1;
	if(a == 1 &amp;&amp; ra == 1) {
		while(ra &lt; a+RAGAP) {
			ra++;
			addr = rel2abs(p, d, ra, 0, 0, uid);
			if(!addr)
				return 0;
			preread(p-&gt;dev, addr);
		}
		return ra+1;
	}
	if(ra == a+RAGAP) {
		addr = rel2abs(p, d, ra, 0, 0, uid);
		if(!addr)
			return 0;
		preread(p-&gt;dev, addr);
		return ra+1;
	}
	return ra;
}

Iobuf*
dnodebuf(Iobuf *p, Dentry *d, Off a, int tag, int uid)
{
	Off addr;

	addr = rel2abs(p, d, a, tag, 0, uid);
	if(addr)
		return getbuf(p-&gt;dev, addr, Brd);
	return 0;
}

/*
 * same as dnodebuf but it calls putbuf(p)
 * to reduce interference.
 */
Iobuf*
dnodebuf1(Iobuf *p, Dentry *d, Off a, int tag, int uid)
{
	Off addr;
	Device *dev;

	dev = p-&gt;dev;
	addr = rel2abs(p, d, a, tag, 1, uid);
	if(addr)
		return getbuf(dev, addr, Brd);
	return 0;

}

Off
indfetch(Device* d, Off qpath, Off addr, Off a, int itag, int tag, int uid)
{
	Iobuf *bp;

	if(!addr)
		return 0;
	bp = getbuf(d, addr, Brd);
	if(!bp || checktag(bp, itag, qpath)) {
		if(!bp) {
			print("ind fetch bp = 0\n");
			return 0;
		}
		print("ind fetch tag\n");
		putbuf(bp);
		return 0;
	}
	addr = ((Off *)bp-&gt;iobuf)[a];
	if(!addr &amp;&amp; tag) {
		addr = bufalloc(d, tag, qpath, uid);
		if(addr) {
			((Off *)bp-&gt;iobuf)[a] = addr;
			bp-&gt;flags |= Bmod;
			if(tag == Tdir)
				bp-&gt;flags |= Bimm;
			settag(bp, itag, qpath);
		}
	}
	putbuf(bp);
	return addr;
}

/* return INDPERBUF^exp */
Off
ibbpow(int exp)
{
	static Off pows[] = {
		1,
		INDPERBUF,
		(Off)INDPERBUF*INDPERBUF,
		(Off)INDPERBUF*(Off)INDPERBUF*INDPERBUF,
		(Off)INDPERBUF*(Off)INDPERBUF*(Off)INDPERBUF*INDPERBUF,
	};

	if (exp &lt; 0)
		return 0;
	else if (exp &gt;= nelem(pows)) {	/* not in table? do it long-hand */
		Off indpow = 1;

		while (exp-- &gt; 0 &amp;&amp; indpow &gt; 0)
			indpow *= INDPERBUF;
		return indpow;
	} else
		return pows[exp];
}

/* return sum of INDPERBUF^n for 1 ≤ n ≤ exp */
Off
ibbpowsum(int exp)
{
	Off indsum = 0;

	for (; exp &gt; 0; exp--)
		indsum += ibbpow(exp);
	return indsum;
}

/* zero bytes past new file length; return an error code */
int
trunczero(Truncstate *ts)
{
	int blkoff = ts-&gt;newsize % BUFSIZE;
	Iobuf *pd;

	pd = dnodebuf(ts-&gt;p, ts-&gt;d, ts-&gt;lastblk, Tfile, ts-&gt;uid);
	if (pd == nil || checktag(pd, Tfile, QPNONE)) {
		if (pd != nil)
			putbuf(pd);
		ts-&gt;err = Ephase;
		return Ephase;
	}
	memset(pd-&gt;iobuf+blkoff, 0, BUFSIZE - blkoff);
	putbuf(pd);
	return 0;
}

/*
 * truncate d (in p) to length `newsize'.
 * if larger, just increase size.
 * if smaller, deallocate blocks after last one
 * still in file at new size.  last byte to keep
 * is newsize-1, due to zero origin.
 * we free in forward order because it's simpler to get right.
 * if the final block at the new size is partially-filled,
 * zero the remainder.
 */
int
dtrunclen(Iobuf *p, Dentry *d, Off newsize, int uid)
{
	int i, pastlast;
	Truncstate trunc;

	if (newsize &lt;= 0) {
		dtrunc(p, d, uid);
		return 0;
	}
	memset(&amp;trunc, 0, sizeof trunc);
	trunc.d = d;
	trunc.p = p;
	trunc.uid = uid;
	trunc.newsize = newsize;
	trunc.lastblk = newsize/BUFSIZE;
	if (newsize % BUFSIZE == 0)
		trunc.lastblk--;
	else
		trunczero(&amp;trunc);
	for (i = 0; i &lt; NDBLOCK; i++)
		if (trunc.pastlast) {
			trunc.relblk = i;
			buffree(p-&gt;dev, d-&gt;dblock[i], 0, &amp;trunc);
			d-&gt;dblock[i] = 0;
		} else if (i == trunc.lastblk)
			trunc.pastlast = 1;
	trunc.relblk = NDBLOCK;
	for (i = 0; i &lt; NIBLOCK; i++) {
		pastlast = trunc.pastlast;
		buffree(p-&gt;dev, d-&gt;iblocks[i], i+1, &amp;trunc);
		if (pastlast)
			d-&gt;iblocks[i] = 0;
	}

	d-&gt;size = newsize;
	p-&gt;flags |= Bmod|Bimm;
	accessdir(p, d, FWRITE, uid);
	return trunc.err;
}

/*
 * truncate d (in p) to zero length.
 * freeing blocks in reverse order is traditional, from Unix,
 * in an attempt to keep the free list contiguous.
 */
void
dtrunc(Iobuf *p, Dentry *d, int uid)
{
	int i;

	for (i = NIBLOCK-1; i &gt;= 0; i--) {
		buffree(p-&gt;dev, d-&gt;iblocks[i], i+1, nil);
		d-&gt;iblocks[i] = 0;
	}
	for (i = NDBLOCK-1; i &gt;= 0; i--) {
		buffree(p-&gt;dev, d-&gt;dblock[i], 0, nil);
		d-&gt;dblock[i] = 0;
	}
	d-&gt;size = 0;
	p-&gt;flags |= Bmod|Bimm;
	accessdir(p, d, FWRITE, uid);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

