<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/juke.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/juke.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * drive HP optical-disc jukeboxes (e.g. HP 1200EX).
 * used to issue SCSI commands directly to the host adapter;
 * now (via scsi.c) it issues them via scsi(2) using
 * /dev/sdXX/raw to run the robotics, and uses normal i/o
 * on /dev/sdXX/data to run the drives.
 */
#include "all.h"
#include "io.h"

enum {
	SCSInone	= SCSIread,
	MAXDRIVE	= 10,
	MAXSIDE		= 500,		/* max. disc sides */

	TWORM		= MINUTE(10),
	THYSTER		= SECOND(10),

	Sectorsz	= 512,		/* usual disk sector size */

	Jukemagic	= 0xbabfece2,
};

typedef	struct	Side	Side;
struct	Side
{
	QLock;			/* protects loading/unloading */
	int	elem;		/* element number */
	int	drive;		/* if loaded, where */
	uchar	status;		/* Sunload, etc */
	uchar	rot;		/* if backside */
	int	ord;		/* ordinal number for labeling */

	Timet	time;		/* time since last access, to unspin */
	Timet	stime;		/* time since last spinup, for hysteresis */
	long	nblock;		/* number of native blocks */
	long	block;		/* bytes per native block */
	long	mult;		/* multiplier to get plan9 blocks */
	long	max;		/* max size in plan9 blocks */
};

typedef	struct	Juke	Juke;
struct	Juke
{
	QLock;				/* protects drive mechanism */
	Side	side[MAXSIDE];
	int	nside;			/* # of storage elements (*2 if rev) */
	int	ndrive;			/* # of transfer elements */
	Device*	juke;			/* devworm of changer */
	Device*	drive[MAXDRIVE];	/* devworm for i/o */
	uchar	offline[MAXDRIVE];	/* drives removed from service */
	int	isfixedsize;		/* flag: one size fits all? */
	long	fixedsize;		/* the one size that fits all */
	int	probeok;		/* wait for init to probe */

	Scsi*	robot;			/* scsi(2) interface to robotics */
	char*	robotdir;		/* /dev/sdXX name */

	/*
	 * geometry returned by mode sense.
	 * a *0 number (such as mt0) is the `element number' of the
	 * first element of that type (e.g., mt, or motor transport).
	 * an n* number is the quantity of them.
	 */
	int	mt0,	nmt;	/* motor transports (robot pickers) */
	int	se0,	nse;	/* storage elements (discs, slots) */
	int	ie0,	nie;	/* interchange elements (mailbox slots) */
	int	dt0,	ndt;	/* drives (data transfer?) */
	int	rot;		/* if true, discs are double-sided */

	ulong	magic;
	Juke*	link;
};
static	Juke*	jukelist;

enum
{
	Sempty = 0,	/* does not exist */
	Sunload,	/* on the shelf */
	Sstart,		/* loaded and spinning */
};

static	int	bestdrive(Juke*, int);
static	void	element(Juke*, int);
static	int	mmove(Juke*, int, int, int, int);
static	void	shelves(void);
static	int	waitready(Juke *, Device*);
static	int	wormsense(Device*);
static	Side*	wormunit(Device*);

/* create a new label and try to write it */
static void
newlabel(Device *d, Off labelblk, char *labelbuf, unsigned vord)
{
	Label *label = (Label *)labelbuf;

	memset(labelbuf, 0, RBUFSIZE);
	label-&gt;magic = Labmagic;
	label-&gt;ord = vord;
	strncpy(label-&gt;service, service, sizeof label-&gt;service);

	if (!okay("write new label"))
		print("NOT writing new label\n");
	else if (wormwrite(d, labelblk, labelbuf))
		/* wormwrite will have complained in detail */
		print("can't write new label on side %d\n", vord);
	else
		print("wrote new label on side %d\n", vord);
}

/* check for label in last block.  call with v qlocked. */
Side*
wormlabel(Device *d, Side *v)
{
	int vord;
	Off labelblk = v-&gt;max - 1;	/* last block */
	char labelbuf[RBUFSIZE];
	Label *label = (Label *)labelbuf;
	Juke *w = d-&gt;private;

	/* wormread calls wormunit, which locks v */
	vord = v-&gt;ord;
	qunlock(v);

	memset(label, 0, sizeof *label);
	if (wormread(d, labelblk, labelbuf)) {
		/*
		 * wormread will have complained in detail about the error;
		 * no need to repeat most of that detail.
		 * probably an unwritten WORM-disc label; write a new one.
		 */
		print("error reading label block of side %d\n", vord);
		newlabel(d, labelblk, labelbuf, vord);
	} else if (label-&gt;magic != Labmagic) {
		swab8(&amp;label-&gt;magic);
		if (label-&gt;magic == Labmagic) {
			print(
"side %d's label magic byte-swapped; filsys should be configured with xD",
				vord);
			swab2(&amp;label-&gt;ord);
			/* could look for Devswab in Juke's filsys */
		} else {
			/*
			 * magic # is wrong in both byte orders, thus
			 * probably the label is empty on RW media,
			 * so create a new one and try to write it.
			 */
			print("bad magic number in label of side %d\n", vord);
			newlabel(d, labelblk, labelbuf, vord);
		}
	}

	qlock(v);
	if (v-&gt;ord != vord)
		panic("wormlabel: side %d switched ordinal to %d underfoot",
			vord, v-&gt;ord);
	if (label-&gt;ord != vord) {
		print(
	"labelled worm side %Z has wrong ordinal in label (%d, want %d)",
			d, label-&gt;ord, vord);
		qunlock(v);
		cmd_wormreset(0, nil);			/* put discs away */
		panic("wrong ordinal in label");
	}

	print("label %Z ordinal %d\n", d, v-&gt;ord);
	qunlock(v);
	/*
	 * wormunit should return without calling us again,
	 * since v is now known.
	 */
	if (w != d-&gt;private)
		panic("wormlabel: w != %Z-&gt;private", d);
	return wormunit(d);
}

/*
 * mounts and spins up the device
 *	locks the structure
 */
static Side*
wormunit(Device *d)			/* d is l0 or r2 (e.g.) */
{
	int p, drive;
	Device *dr;			/* w0 or w1.2.0 (e.g.) */
	Side *v;
	Juke *w;
	Dir *dir;

	w = d-&gt;private;
	if (w == nil)
		panic("wormunit %Z nil juke", d);
	if (w-&gt;magic != Jukemagic)
		panic("bad magic in Juke for %Z", d);
	p = d-&gt;wren.targ;
	if(p &lt; 0 || w &amp;&amp; p &gt;= w-&gt;nside) {
		panic("wormunit: target %d out of range for %Z", p, d);
		return 0;
	}

	/*
	 * if disk is unloaded, must load it
	 * into next (circular) logical unit
	 */
	v = &amp;w-&gt;side[p];
	qlock(v);
	if(v-&gt;status == Sunload) {
		for(;;) {
			qlock(w);
			drive = bestdrive(w, p);
			if(drive &gt;= 0)
				break;
			qunlock(w);
			delay(100);
		}
		print("\tload   r%ld drive %Z\n", v-w-&gt;side, w-&gt;drive[drive]);
		if(mmove(w, w-&gt;mt0, v-&gt;elem, w-&gt;dt0+drive, v-&gt;rot)) {
			qunlock(w);
			goto sbad;
		}
		v-&gt;drive = drive;
		v-&gt;status = Sstart;
		v-&gt;stime = toytime();
		qunlock(w);
		dr = w-&gt;drive[drive];
		if (!waitready(w, dr))
			goto sbad;
		v-&gt;stime = toytime();
	} else
		dr = w-&gt;drive[v-&gt;drive];
	if(v-&gt;status != Sstart) {
		if(v-&gt;status == Sempty)
			print("worm: unit empty %Z\n", d);
		else
			print("worm: not started %Z\n", d);
		goto sbad;
	}

	v-&gt;time = toytime();
	if(v-&gt;block)		/* side is known already */
		return v;

	/*
	 * load and record information about side
	 */

	if (dr-&gt;wren.file)
		dr-&gt;wren.sddata = dataof(dr-&gt;wren.file);
	else {
		if (dr-&gt;wren.sddir == nil) {
			if (dr-&gt;type == Devwren)
				dr-&gt;wren.sddir = sdof(dr);
			if (dr-&gt;wren.sddir == nil)
				panic("wormunit: %Z for %Z not a wren", dr, d);
		}
		dr-&gt;wren.sddata = smprint("%s/data", dr-&gt;wren.sddir);
	}

	if (dr-&gt;wren.fd == 0)
		dr-&gt;wren.fd = open(dr-&gt;wren.sddata, ORDWR);
	if (dr-&gt;wren.fd &lt; 0) {
		print("wormunit: can't open %s for %Z: %r\n", dr-&gt;wren.sddata, d);
		goto sbad;
	}

	v-&gt;block = inqsize(dr-&gt;wren.sddata);
	if(v-&gt;block &lt;= 0) {
		print("\twormunit %Z block size %ld, setting to %d\n",
			d, v-&gt;block, Sectorsz);
		v-&gt;block = Sectorsz;
	}

	dir = dirfstat(dr-&gt;wren.fd);
	v-&gt;nblock = dir-&gt;length / v-&gt;block;
	free(dir);

	v-&gt;mult = (RBUFSIZE + v-&gt;block - 1) / v-&gt;block;
	v-&gt;max = (v-&gt;nblock + 1) / v-&gt;mult;

	print("\tworm %Z: drive %Z (juke drive %d)\n",
		d, w-&gt;drive[v-&gt;drive], v-&gt;drive);
	print("\t\t%,ld %ld-byte sectors, ", v-&gt;nblock, v-&gt;block);
	print("%,ld %d-byte blocks\n", v-&gt;max, RBUFSIZE);
	print("\t\t%ld multiplier\n", v-&gt;mult);
	if(d-&gt;type == Devlworm)
		return wormlabel(d, v);
	else
		return v;

sbad:
	qunlock(v);
	return 0;
}

/* wait 10s for optical drive to spin up */
static int
waitready(Juke *w, Device *d)
{
	int p, e, rv;
	char *datanm;

	if (w-&gt;magic != Jukemagic)
		panic("waitready: bad magic in Juke (d-&gt;private) for %Z", d);
	p = d-&gt;wren.targ;
	if(p &lt; 0 || p &gt;= w-&gt;nside) {
		print("waitready: target %d out of range for %Z\n", p, d);
		return 0;
	}

	if (d-&gt;type == Devwren &amp;&amp; d-&gt;wren.file)
		datanm = strdup(d-&gt;wren.file);
	else {
		if (d-&gt;wren.sddir)
			free(d-&gt;wren.sddir);
		if (d-&gt;type == Devwren)
			d-&gt;wren.sddir = sdof(d);
		if (d-&gt;wren.sddir == nil)
			panic("waitready: d-&gt;wren.sddir not set for %Z", d);

		datanm = smprint("%s/data", d-&gt;wren.sddir);
	}

	rv = 0;
	for(e=0; e &lt; 100; e++) {
		if (e == 10)
			print("waitready: waiting for %s to exist\n", datanm); // DEBUG
		if (access(datanm, AEXIST) &gt;= 0) {
			rv = 1;
			break;
		}
		delay(200);
	}
	if (rv == 0)
		print("waitready: %s for %Z didn't come ready\n", datanm, d);
	free(datanm);
	return rv;
}

static int
bestdrive(Juke *w, int side)
{
	Side *v, *bv[MAXDRIVE];
	int i, e, drive;
	Timet t, t0;

loop:
	/* build table of what platters on what drives */
	for(i=0; i&lt;w-&gt;ndt; i++)
		bv[i] = 0;

	v = &amp;w-&gt;side[0];
	for(i=0; i &lt; w-&gt;nside; i++, v++)
		if(v-&gt;status == Sstart) {
			drive = v-&gt;drive;
			if(drive &gt;= 0 &amp;&amp; drive &lt; w-&gt;ndt)
				bv[drive] = v;
		}

	/*
	 * find oldest drive, but must be
	 * at least THYSTER old.
	 */
	e = w-&gt;side[side].elem;
	t0 = toytime() - THYSTER;
	t = t0;
	drive = -1;
	for(i=0; i&lt;w-&gt;ndt; i++) {
		v = bv[i];
		if(v == 0) {		/* 2nd priority: empty drive */
			if(w-&gt;offline[i])
				continue;
			if(w-&gt;drive[i] != devnone) {
				drive = i;
				t = 0;
			}
			continue;
		}
		if(v-&gt;elem == e) {	/* 1st priority: other side */
			drive = -1;
			if(v-&gt;stime &lt; t0)
				drive = i;
			break;
		}
		if(v-&gt;stime &lt; t) {	/* 3rd priority: by time */
			drive = i;
			t = v-&gt;stime;
		}
	}

	if(drive &gt;= 0) {
		v = bv[drive];
		if(v) {
			qlock(v);
			if(v-&gt;status != Sstart) {
				qunlock(v);
				goto loop;
			}
			print("\tunload r%ld drive %Z\n",
				v-w-&gt;side, w-&gt;drive[drive]);
			if(mmove(w, w-&gt;mt0, w-&gt;dt0+drive, v-&gt;elem, v-&gt;rot)) {
				qunlock(v);
				goto loop;
			}
			v-&gt;status = Sunload;
			qunlock(v);
		}
	}
	return drive;
}

Devsize
wormsize(Device *d)
{
	Side *v;
	Juke *w;
	Devsize size;

	w = d-&gt;private;
	if (w-&gt;magic != Jukemagic)
		print("wormsize: bad magic in Juke (d-&gt;private) for %Z\n", d);
	if(w-&gt;isfixedsize &amp;&amp; w-&gt;fixedsize != 0)
		size = w-&gt;fixedsize;	/* fixed size is now known */
	else {
		if (w != d-&gt;private)
			panic("wormsize: w != %Z-&gt;private", d);
		v = wormunit(d);
		if(v == nil)
			return 0;
		size = v-&gt;max;
		qunlock(v);
		/*
		 * set fixed size for whole Juke from
		 * size of first disc examined.
		 */
		if(w-&gt;isfixedsize)
			w-&gt;fixedsize = size;
	}
	if(d-&gt;type == Devlworm)
		return size-1;		/* lie: last block is for label */
	return size;
}

/*
 * return a Devjuke or an mcat (normally of sides) from within d (or nil).
 * if it's an mcat, the caller must walk it.
 */
static Device *
devtojuke(Device *d, Device *top)
{
	while (d != nil)
		switch(d-&gt;type) {
		default:
			print("devtojuke: type of device %Z of %Z unknown\n",
				d, top);
			return nil;

		case Devjuke:
			/* jackpot!  d-&gt;private is a (Juke *) with nside, &amp;c. */
			/* FALL THROUGH */
		case Devmcat:
		case Devmlev:
		case Devmirr:
			/* squint hard &amp; call an mlev or a mirr an mcat */
			return d;

		case Devworm:
		case Devlworm:
			/*
			 * d-&gt;private is a (Juke *) with nside, etc.,
			 * but we're not supposed to get here.
			 */
			print("devtojuke: (l)worm %Z of %Z encountered\n",
				d, top);
			/* FALL THROUGH */
		case Devwren:
			return nil;

		case Devcw:
			d = d-&gt;cw.w;			/* usually juke */
			break;
		case Devro:
			d = d-&gt;ro.parent;		/* cw */
			break;
		case Devfworm:
			d = d-&gt;fw.fw;
			break;
		case Devpart:
			d = d-&gt;part.d;
			break;
		case Devswab:
			d = d-&gt;swab.d;
			break;
		}
	return d;
}

static int
devisside(Device *d)
{
	return d-&gt;type == Devworm || d-&gt;type == Devlworm;
}

static Device *
findside(Device *juke, int side, Device *top)
{
	int i = 0;
	Device *mcat = juke-&gt;j.m, *x;
	Juke *w = juke-&gt;private;

	for (x = mcat-&gt;cat.first; x != nil; x = x-&gt;link) {
		if (!devisside(x)) {
			print("wormsizeside: %Z of %Z of %Z type not (l)worm\n",
				x, mcat, top);
			return nil;
		}
		i = x-&gt;wren.targ;
		if (i &lt; 0 || i &gt;= w-&gt;nside)
			panic("wormsizeside: side %d in %Z out of range",
				i, mcat);
		if (i == side)
			break;
	}
	if (x == nil)
		return nil;
	if (w-&gt;side[i].time == 0) {
		print("wormsizeside: side %d not in jukebox %Z\n", i, juke);
		return nil;
	}
	return x;
}

typedef struct {
	int	sleft;		/* sides still to visit to reach desired side */
	int	starget;	/* side of topdev we want */
	Device	*topdev;
	int	sawjuke;	/* passed by a jukebox */
	int	sized;		/* flag: asked wormsize for size of starget */
} Visit;

/*
 * walk the Device tree from d looking for Devjukes, counting sides.
 * the main complication is mcats and the like with Devjukes in them.
 * use Devjuke's d-&gt;private as Juke* and see sides.
 */
static Off
visitsides(Device *d, Device *parentj, Visit *vp)
{
	Off size = 0;
	Device *x;
	Juke *w;

	/*
	 * find the first juke or mcat.
	 * d==nil means we couldn't find one; typically harmless, due to a
	 * mirror of dissimilar devices.
	 */
	d = devtojuke(d, vp-&gt;topdev);
	if (d == nil || vp-&gt;sleft &lt; 0)
		return 0;
	if (d-&gt;type == Devjuke) {    /* jackpot!  d-&gt;private is a (Juke *) */
		vp-&gt;sawjuke = 1;
		w = d-&gt;private;
		/*
		 * if there aren't enough sides in this jukebox to reach
		 * the desired one, subtract these sides and pass.
		 */
		if (vp-&gt;sleft &gt;= w-&gt;nside) {
			vp-&gt;sleft -= w-&gt;nside;
			return 0;
		}
		/* else this is the right juke, paw through mcat of sides */
		return visitsides(d-&gt;j.m, d, vp);
	}

	/*
	 * d will usually be an mcat of sides, but it could be an mcat of
	 * jukes, for example.  in that case, we need to walk the mcat,
	 * recursing as needed, until we find the right juke, then stop at
	 * the right side within its mcat of sides, by comparing side
	 * numbers, not just by counting (to allow for unused slots).
	 */
	x = d-&gt;cat.first;
	if (x == nil) {
		print("visitsides: %Z of %Z: empty mcat\n", d, vp-&gt;topdev);
		return 0;
	}
	if (!devisside(x)) {
		for (; x != nil &amp;&amp; !vp-&gt;sized; x = x-&gt;link)
			size = visitsides(x, parentj, vp);
		return size;
	}

	/* the side we want is in this jukebox, thus this mcat (d) */
	if (parentj == nil) {
		print("visitsides: no parent juke for sides mcat %Z\n", d);
		vp-&gt;sleft = -1;
		return 0;
	}
	if (d != parentj-&gt;j.m)
		panic("visitsides: mcat mismatch %Z vs %Z", d, parentj-&gt;j.m);
	x = findside(parentj, vp-&gt;sleft, vp-&gt;topdev);
	if (x == nil) {
		vp-&gt;sleft = -1;
		return 0;
	}

	/* we've turned vp-&gt;starget into the right Device* */
	vp-&gt;sleft = 0;
	vp-&gt;sized = 1;
	return wormsize(x);
}

/*
 * d must be, or be within, a filesystem config that also contains
 * the jukebox that `side' resides on.
 * d is normally a Devcw, but could be Devwren, Devide, Devpart, Devfworm,
 * etc. if called from chk.c Ctouch code.  Note too that the worm part of
 * the Devcw might be other than a Devjuke.
 */
Devsize
wormsizeside(Device *d, int side)
{
	Devsize size;
	Visit visit;

	memset(&amp;visit, 0, sizeof visit);
	visit.starget = visit.sleft = side;
	visit.topdev = d;
	size = visitsides(d, nil, &amp;visit);
	if (visit.sawjuke &amp;&amp; (visit.sleft != 0 || !visit.sized)) {
		print("wormsizeside: fewer than %d sides in %Z\n", side, d);
		return 0;
	}
	return size;
}

/*
 * returns starts (in blocks) of side #side and #(side+1) of dev in *stp.
 * dev should be a Devcw.
 */
void
wormsidestarts(Device *dev, int side, Sidestarts *stp)
{
	int s;
	Devsize dstart;

	for (dstart = s = 0; s &lt; side; s++)
		dstart += wormsizeside(dev, s);
	stp-&gt;sstart = dstart;
	stp-&gt;s1start = dstart + wormsizeside(dev, side);
}

int
wormread(Device *d, Off b, void *c)
{
	int r = 0;
	long max;
	char name[128];
	Side *v = wormunit(d);
	Juke *w = d-&gt;private;
	Device *dr;

	if (v == nil)
		panic("wormread: nil wormunit(%Z)", d);
	dr = w-&gt;drive[v-&gt;drive];
	if (dr-&gt;wren.fd &lt; 0)
		panic("wormread: unopened fd for %Z", d);
	max = (d-&gt;type == Devlworm? v-&gt;max + 1: v-&gt;max);
	if(b &gt;= max) {
		print("wormread: block out of range %Z(%lld)\n", d, (Wideoff)b);
		r = 0x071;
	} else if (pread(dr-&gt;wren.fd, c, RBUFSIZE, (vlong)b*RBUFSIZE) != RBUFSIZE) {
		fd2path(dr-&gt;wren.fd, name, sizeof name);
		print("wormread: error on %Z(%lld) on %s in %s: %r\n",
			d, (Wideoff)b, name, dr-&gt;wren.sddir);
		cons.nwormre++;
		r = 1;
	}
	qunlock(v);
	return r;
}

int
wormwrite(Device *d, Off b, void *c)
{
	int r = 0;
	long max;
	char name[128];
	Side *v = wormunit(d);
	Juke *w = d-&gt;private;
	Device *dr;

	if (v == nil)
		panic("wormwrite: nil wormunit(%Z)", d);
	dr = w-&gt;drive[v-&gt;drive];
	if (dr-&gt;wren.fd &lt; 0)
		panic("wormwrite: unopened fd for %Z", d);
	max = (d-&gt;type == Devlworm? v-&gt;max + 1: v-&gt;max);
	if(b &gt;= max) {
		print("wormwrite: block out of range %Z(%lld)\n",
			d, (Wideoff)b);
		r = 0x071;
	} else if (pwrite(dr-&gt;wren.fd, c, RBUFSIZE, (vlong)b*RBUFSIZE) != RBUFSIZE) {
		fd2path(dr-&gt;wren.fd, name, sizeof name);
		print("wormwrwite: error on %Z(%lld) on %s in %s: %r\n",
			d, (Wideoff)b, name, dr-&gt;wren.sddir);
		cons.nwormwe++;
		r = 1;
	}
	qunlock(v);
	return r;
}

static int
mmove(Juke *w, int trans, int from, int to, int rot)
{
	int s;
	uchar cmd[12], buf[4];
	static int recur = 0;

	memset(cmd, 0, sizeof cmd);
	cmd[0] = 0xa5;		/* move medium */
	cmd[2] = trans&gt;&gt;8;
	cmd[3] = trans;
	cmd[4] = from&gt;&gt;8;
	cmd[5] = from;
	cmd[6] = to&gt;&gt;8;
	cmd[7] = to;
	if(rot)
		cmd[10] = 1;
	s = scsiio(w-&gt;juke, SCSInone, cmd, sizeof cmd, buf, 0);	/* mmove */
	if(s) {
		print("scsio status #%x\n", s);
		print("move medium t=%d fr=%d to=%d rot=%d\n",
			trans, from, to, rot);
//		panic("mmove");
		if(recur == 0) {
			recur = 1;
			print("element from=%d\n", from);
			element(w, from);
			print("element to=%d\n", to);
			element(w, to);
			print("element trans=%d\n", trans);
			element(w, trans);
			recur = 0;
		}
		return 1;
	}
	return 0;
}

static void
geometry(Juke *w)
{
	int s;
	uchar cmd[6], buf[4+20];

	memset(cmd, 0, sizeof cmd);
	memset(buf, 0, sizeof buf);
	cmd[0] = 0x1a;		/* mode sense */
	cmd[2] = 0x1d;		/* element address assignment */
	cmd[4] = sizeof buf;	/* allocation length */

	s = scsiio(w-&gt;juke, SCSIread, cmd, sizeof cmd, buf, sizeof buf); /* mode sense elem addrs */
	if(s)
		panic("geometry #%x", s);

	w-&gt;mt0 = (buf[4+2]&lt;&lt;8) | buf[4+3];
	w-&gt;nmt = (buf[4+4]&lt;&lt;8) | buf[4+5];
	w-&gt;se0 = (buf[4+6]&lt;&lt;8) | buf[4+7];
	w-&gt;nse = (buf[4+8]&lt;&lt;8) | buf[4+9];
	w-&gt;ie0 = (buf[4+10]&lt;&lt;8) | buf[4+11];
	w-&gt;nie = (buf[4+12]&lt;&lt;8) | buf[4+13];
	w-&gt;dt0 = (buf[4+14]&lt;&lt;8) | buf[4+15];
	w-&gt;ndt = (buf[4+16]&lt;&lt;8) | buf[4+17];

	memset(cmd, 0, 6);
	memset(buf, 0, sizeof buf);
	cmd[0] = 0x1a;		/* mode sense */
	cmd[2] = 0x1e;		/* transport geometry */
	cmd[4] = sizeof buf;	/* allocation length */

	s = scsiio(w-&gt;juke, SCSIread, cmd, sizeof cmd, buf, sizeof buf); /* mode sense geometry */
	if(s)
		panic("geometry #%x", s);

	w-&gt;rot = buf[4+2] &amp; 1;

	print("\tmt %d %d\n", w-&gt;mt0, w-&gt;nmt);
	print("\tse %d %d\n", w-&gt;se0, w-&gt;nse);
	print("\tie %d %d\n", w-&gt;ie0, w-&gt;nie);
	print("\tdt %d %d\n", w-&gt;dt0, w-&gt;ndt);
	print("\trot %d\n", w-&gt;rot);
	prflush();
}

/*
 * read element e's status from jukebox w, move any disc in drive back to its
 * slot, and update and print software status.
 */
static void
element(Juke *w, int e)
{
	uchar cmd[12], buf[8+8+88];
	int s, t;

	memset(cmd, 0, sizeof cmd);
	memset(buf, 0, sizeof buf);
	cmd[0] = 0xb8;		/* read element status */
	cmd[2] = e&gt;&gt;8;		/* starting element */
	cmd[3] = e;
	cmd[5] = 1;		/* number of elements */
	cmd[9] = sizeof buf;	/* allocation length */

	s = scsiio(w-&gt;juke, SCSIread, cmd, sizeof cmd, buf, sizeof buf); /* read elem sts */
	if(s) {
		print("scsiio #%x\n", s);
		goto bad;
	}

	s = (buf[0]&lt;&lt;8) | buf[1];
	if(s != e) {
		print("element = %d\n", s);
		goto bad;
	}
	if(buf[3] != 1) {
		print("number reported = %d\n", buf[3]);
		goto bad;
	}
	s = (buf[8+8+0]&lt;&lt;8) | buf[8+8+1];
	if(s != e) {
		print("element1 = %d\n", s);
		goto bad;
	}

	switch(buf[8+0]) {	/* element type */
	default:
		print("unknown element %d: %d\n", e, buf[8+0]);
		goto bad;
	case 1:			/* transport */
		s = e - w-&gt;mt0;
		if(s &lt; 0 || s &gt;= w-&gt;nmt)
			goto bad;
		if(buf[8+8+2] &amp; 1)
			print("transport %d full %d.%d\n", s,
				(buf[8+8+10]&lt;&lt;8) | buf[8+8+11],
				(buf[8+8+9]&gt;&gt;6) &amp; 1);
		break;
	case 2:			/* storage */
		s = e - w-&gt;se0;
		if(s &lt; 0 || s &gt;= w-&gt;nse)
			goto bad;
		w-&gt;side[s].status = Sempty;
		if(buf[8+8+2] &amp; 1)
			w-&gt;side[s].status = Sunload;
		if(w-&gt;rot)
			w-&gt;side[w-&gt;nse+s].status = w-&gt;side[s].status;
		break;
	case 3:			/* import/export */
		s = e - w-&gt;ie0;
		if(s &lt; 0 || s &gt;= w-&gt;nie)
			goto bad;
		print("import/export %d #%.2x %d.%d\n", s,
			buf[8+8+2],
			(buf[8+8+10]&lt;&lt;8) | buf[8+8+11],
			(buf[8+8+9]&gt;&gt;6) &amp; 1);
		break;
	case 4:			/* data transfer */
		s = e - w-&gt;dt0;
		if(s &lt; 0 || s &gt;= w-&gt;ndt)
			goto bad;
		print("data transfer %d #%.2x %d.%d\n", s,
			buf[8+8+2],
			(buf[8+8+10]&lt;&lt;8) | buf[8+8+11],
			(buf[8+8+9]&gt;&gt;6) &amp; 1);
		if(buf[8+8+2] &amp; 1) {
			t = ((buf[8+8+10]&lt;&lt;8) | buf[8+8+11]) - w-&gt;se0;
			if (t &lt; 0 || t &gt;= w-&gt;nse || t &gt;= MAXSIDE ||
			    s &gt;= MAXDRIVE) {
				print(
		"element: juke %Z lies; claims side %d is in drive %d\n",
					w-&gt;juke, t, s);	/* lying sack of ... */
				/*
				 * at minimum, we've avoided corrupting our
				 * data structures.  if we know that numbers
				 * like w-&gt;nside are valid here, we could use
				 * them in more stringent tests.
				 * perhaps should whack the jukebox upside the
				 * head here to knock some sense into it.
				 */
				goto bad;
			}
			print("r%d in drive %d\n", t, s);
			if(mmove(w, w-&gt;mt0, w-&gt;dt0+s, w-&gt;se0+t,
			    (buf[8+8+9]&gt;&gt;6) &amp; 1)) {
				print("mmove initial unload\n");
				goto bad;
			}
			w-&gt;side[t].status = Sunload;
			if(w-&gt;rot)
				w-&gt;side[w-&gt;nse+t].status = Sunload;
		}
		if(buf[8+8+2] &amp; 4) {
			print("drive w%d has exception #%.2x #%.2x\n", s,
				buf[8+8+4], buf[8+8+5]);
			goto bad;
		}
		break;
	}
	return;
bad:
	/* panic("element") */ ;
}

/*
 * read all elements' status from jukebox w, move any discs in drives back
 * to their slots, and update and print software status.
 */
static void
positions(Juke *w)
{
	int i, f;

	/* mark empty shelves */
	for(i=0; i&lt;w-&gt;nse; i++)
		element(w, w-&gt;se0+i);
	for(i=0; i&lt;w-&gt;nmt; i++)
		element(w, w-&gt;mt0+i);
	for(i=0; i&lt;w-&gt;nie; i++)
		element(w, w-&gt;ie0+i);
	for(i=0; i&lt;w-&gt;ndt; i++)
		element(w, w-&gt;dt0+i);

	f = 0;
	for(i=0; i&lt;w-&gt;nse; i++)
		if(w-&gt;side[i].status == Sempty) {
			if(f) {
				print("r%d\n", i-1);
				f = 0;
			}
		} else {
			if(!f) {
				print("\tshelves r%d-", i);
				f = 1;
			}
		}
	if(f)
		print("r%d\n", i-1);
}

static void
jinit(Juke *w, Device *d, int o)
{
	int p;
	Device *dev = d;

	switch(d-&gt;type) {
	default:
		print("juke platter not (devmcat of) dev(l)worm: %Z\n", d);
		panic("jinit: type");

	case Devmcat:
		/*
		 * we don't call mcatinit(d) here, so we have to set d-&gt;cat.ndev
		 * ourselves.
		 */
		for(d=d-&gt;cat.first; d; d=d-&gt;link)
			jinit(w, d, o++);
		dev-&gt;cat.ndev = o;
		break;

	case Devlworm:
		p = d-&gt;wren.targ;
		if(p &lt; 0 || p &gt;= w-&gt;nside)
			panic("jinit partition %Z", d);
		w-&gt;side[p].ord = o;
		/* FALL THROUGH */
	case Devworm:
		if(d-&gt;private) {
			print("juke platter private pointer set %p\n",
				d-&gt;private);
			panic("jinit: private");
		}
		d-&gt;private = w;
		break;
	}
}

Side*
wormi(char *arg)
{
	int i, j;
	Juke *w;
	Side *v;

	i = number(arg, -1, 10) - 1;
	w = jukelist;
	if(i &lt; 0 || i &gt;= w-&gt;nside) {
		print("bad unit number %s (%d)\n", arg, i+1);
		return 0;
	}
	j = i;
	if(j &gt;= w-&gt;nse)
		j -= w-&gt;nse;
	if(j &lt; w-&gt;nside) {
		v = &amp;w-&gt;side[j];
		qlock(v);
		if(v-&gt;status == Sstart) {
			if(mmove(w, w-&gt;mt0, w-&gt;dt0+v-&gt;drive, v-&gt;elem, v-&gt;rot)) {
				qunlock(v);
				return 0;
			}
			v-&gt;status = Sunload;
		}
		qunlock(v);
	}
	j += w-&gt;nse;
	if(j &lt; w-&gt;nside) {
		v = &amp;w-&gt;side[j];
		qlock(v);
		if(v-&gt;status == Sstart) {
			if(mmove(w, w-&gt;mt0, w-&gt;dt0+v-&gt;drive, v-&gt;elem, v-&gt;rot)) {
				qunlock(v);
				return 0;
			}
			v-&gt;status = Sunload;
		}
		qunlock(v);
	}
	v = &amp;w-&gt;side[i];
	qlock(v);
	return v;
}

static void
cmd_wormoffline(int argc, char *argv[])
{
	int u, i;
	Juke *w;

	if(argc &lt;= 1) {
		print("usage: wormoffline drive\n");
		return;
	}
	u = number(argv[1], -1, 10);
	w = jukelist;
	if(u &lt; 0 || u &gt;= w-&gt;ndrive) {
		print("bad drive %s (0&lt;=%d&lt;%d)\n", argv[1], u, w-&gt;ndrive);
		return;
	}
	if(w-&gt;offline[u])
		print("drive %d already offline\n", u);
	w-&gt;offline[u] = 1;
	for(i=0; i&lt;w-&gt;ndrive; i++)
		if(w-&gt;offline[i] == 0)
			return;
	print("that would take all drives offline\n");
	w-&gt;offline[u] = 0;
}

static void
cmd_wormonline(int argc, char *argv[])
{
	int u;
	Juke *w;

	if(argc &lt;= 1) {
		print("usage: wormonline drive\n");
		return;
	}
	u = number(argv[1], -1, 10);
	w = jukelist;
	if(u &lt; 0 || u &gt;= w-&gt;ndrive) {
		print("bad drive %s (0&lt;=%d&lt;%d)\n", argv[1], u, w-&gt;ndrive);
		return;
	}
	if(w-&gt;offline[u] == 0)
		print("drive %d already online\n", u);
	w-&gt;offline[u] = 0;
}

void
cmd_wormreset(int, char *[])
{
	Juke *w;

	for(w=jukelist; w; w=w-&gt;link) {
		qlock(w);
		positions(w);
		qunlock(w);
	}
}

static void
cmd_wormeject(int argc, char *argv[])
{
	Juke *w;
	Side *v;

	if(argc &lt;= 1) {
		print("usage: wormeject unit\n");
		return;
	}
	v = wormi(argv[1]);
	if(v == 0)
		return;
	w = jukelist;
	mmove(w, w-&gt;mt0, v-&gt;elem, w-&gt;ie0, 0);
	qunlock(v);
}

static void
cmd_wormingest(int argc, char *argv[])
{
	Juke *w;
	Side *v;

	if(argc &lt;= 1) {
		print("usage: wormingest unit\n");
		return;
	}
	v = wormi(argv[1]);
	if(v == 0)
		return;
	w = jukelist;
	mmove(w, w-&gt;mt0, w-&gt;ie0, v-&gt;elem, 0);
	qunlock(v);
}

static void
newside(Side *v, int rot, int elem)
{
	qlock(v);
	qunlock(v);
//	v-&gt;name = "shelf";
	v-&gt;elem = elem;
	v-&gt;rot = rot;
	v-&gt;status = Sempty;
	v-&gt;time = toytime();
}

/*
 * query jukebox robotics for geometry;
 * argument is the wren dev of the changer.
 * result is actually Juke*, but that type is only known in this file.
 */
void *
querychanger(Device *xdev)
{
	Juke *w;
	Side *v;
	int i;

	if (xdev == nil)
		panic("querychanger: nil Device");
	if(xdev-&gt;type != Devwren) {
		print("juke changer not wren %Z\n", xdev);
		goto bad;
	}
	for(w=jukelist; w; w=w-&gt;link)
		if(xdev == w-&gt;juke)
			return w;

	/*
	 * allocate a juke structure
	 * no locking problems.
	 */
	w = malloc(sizeof(Juke));
	w-&gt;magic = Jukemagic;
	w-&gt;isfixedsize = FIXEDSIZE;
	w-&gt;link = jukelist;
	jukelist = w;

	print("alloc juke %Z\n", xdev);
	qlock(w);
	qunlock(w);
//	w-&gt;name = "juke";
	w-&gt;juke = xdev;
	w-&gt;robotdir = sdof(xdev);
	w-&gt;robot = openscsi(w-&gt;robotdir);
	if (w-&gt;robot == nil)
		panic("can't openscsi(%s): %r", w-&gt;robotdir);
	newscsi(xdev, w-&gt;robot);
	geometry(w);

	/*
	 * pick up each side
	 */
	w-&gt;nside = w-&gt;nse;
	if(w-&gt;rot)
		w-&gt;nside += w-&gt;nside;
	if(w-&gt;nside &gt; MAXSIDE) {
		print("too many sides: %d max %d\n", w-&gt;nside, MAXSIDE);
		goto bad;
	}
	for(i=0; i &lt; w-&gt;nse; i++) {
		v = &amp;w-&gt;side[i];
		newside(v, 0, w-&gt;se0 + i);
		if(w-&gt;rot)
			newside(v + w-&gt;nse, 1, w-&gt;se0 + i);
	}
	positions(w);

	w-&gt;ndrive = w-&gt;ndt;
	if(w-&gt;ndrive &gt; MAXDRIVE) {
		print("ndrives truncated to %d\n", MAXDRIVE);
		w-&gt;ndrive = MAXDRIVE;
	}

	/*
	 * pick up each drive
	 */
	for(i=0; i&lt;w-&gt;ndrive; i++)
		w-&gt;drive[i] = devnone;
	return w;
bad:
	panic("querychanger: %Z", xdev);
	return nil;
}

void
jukeinit(Device *d)
{
	Juke *w;
	Device *xdev;
	int i;
	static int beenhere = 0;

	/* j(w&lt;changer&gt;w&lt;station0&gt;...)(r&lt;platters&gt;) */
	if (d == nil)
		panic("jukeinit: nil Device");
	xdev = d-&gt;j.j;
	if(xdev == nil || xdev-&gt;type != Devmcat) {
		print("juke union not mcat\n");
		goto bad;
	}

	/*
	 * pick up the changer device
	 */
	xdev = xdev-&gt;cat.first;
	w = querychanger(xdev);

	if (!beenhere) {
		beenhere = 1;
		cmd_install("wormreset",
			"-- put drives back where jukebox thinks they belong",
			cmd_wormreset);
		cmd_install("wormeject", "unit -- shelf to outside",
			cmd_wormeject);
		cmd_install("wormingest", "unit -- outside to shelf",
			cmd_wormingest);
		cmd_install("wormoffline", "unit -- disable drive",
			cmd_wormoffline);
		cmd_install("wormonline", "unit -- enable drive",
			cmd_wormonline);
	}

	/* walk through the worm drives */
	i = 0;
	while(xdev = xdev-&gt;link) {
		if(xdev-&gt;type != Devwren) {
			print("drive not devwren: %Z\n", xdev);
			goto bad;
		}
		if(w-&gt;drive[i]-&gt;type != Devnone &amp;&amp;
		   xdev != w-&gt;drive[i]) {
			print("double init drive %d %Z %Z\n",
				i, w-&gt;drive[i], xdev);
			goto bad;
		}
		if(i &gt;= w-&gt;ndrive) {
			print("too many drives %Z\n", xdev);
			goto bad;
		}
		w-&gt;drive[i++] = xdev;
	}

	if(i &lt;= 0) {
		print("no drives\n");
		goto bad;
	}

	/*
	 * put w pointer in each platter
	 */
	d-&gt;private = w;
	jinit(w, d-&gt;j.m, 0);
	w-&gt;probeok = 1;
	return;

bad:
	panic("juke init");
}

/*
 * called periodically
 */
void
wormprobe(void)
{
	int i, drive;
	Timet t;
	Side *v;
	Juke *w;

	t = toytime() - TWORM;
	for(w=jukelist; w; w=w-&gt;link) {
		if(w-&gt;probeok == 0 || !canqlock(w))
			continue;
		for(i=0; i&lt;w-&gt;nside; i++) {
			v = &amp;w-&gt;side[i];
			if(!canqlock(v))
				continue;
			if(v-&gt;status == Sstart &amp;&amp; t &gt; v-&gt;time) {
				drive = v-&gt;drive;
				print("\ttime   r%ld drive %Z\n",
					v-w-&gt;side, w-&gt;drive[drive]);
				mmove(w, w-&gt;mt0, w-&gt;dt0+drive, v-&gt;elem, v-&gt;rot);
				v-&gt;status = Sunload;
			}
			qunlock(v);
		}
		qunlock(w);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

