<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/mworm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/mworm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

/*
 * multiple cat devices
 */
void
mcatinit(Device *d)
{
	Device *x, **list;

	d-&gt;cat.ndev = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		devinit(x);
		d-&gt;cat.ndev++;
	}

	list = malloc(d-&gt;cat.ndev*sizeof(Device*));
	d-&gt;private = list;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		*list++ = x;
		x-&gt;size = devsize(x);
	}
}

Devsize
mcatsize(Device *d)
{
	Device *x;
	Devsize l, m;

	l = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		m = x-&gt;size;
		if(m == 0) {
			m = devsize(x);
			x-&gt;size = m;
		}
		l += m;
	}
	return l;
}

int
mcatread(Device *d, Off b, void *c)
{
	Device *x;
	Devsize l, m;

	l = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		m = x-&gt;size;
		if(m == 0) {
			m = devsize(x);
			x-&gt;size = m;
		}
		if(b &lt; l+m)
			return devread(x, b-l, c);
		l += m;
	}
	print("mcatread past end: %Z block %lld, %lld beyond end\n",
		d, (Wideoff)b, (Wideoff)l);
	return 1;
}

int
mcatwrite(Device *d, Off b, void *c)
{
	Device *x;
	Devsize l, m;

	l = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		m = x-&gt;size;
		if(m == 0) {
			m = devsize(x);
			x-&gt;size = m;
		}
		if(b &lt; l+m)
			return devwrite(x, b-l, c);
		l += m;
	}
	print("mcatwrite past end: %Z block %lld, %lld beyond end\n",
		d, (Wideoff)b, (Wideoff)l);
	return 1;
}

/*
 * multiple interleave devices
 */
void
mlevinit(Device *d)
{
	Device *x;

	mcatinit(d);
	for(x=d-&gt;cat.first; x; x=x-&gt;link)
		x-&gt;size = devsize(x);
}

Devsize
mlevsize(Device *d)
{
	Device *x;
	int n;
	Devsize m, min;

	min = 0;
	n = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		m = x-&gt;size;
		if(m == 0) {
			m = devsize(x);
			x-&gt;size = m;
		}
		if(min == 0 || m &lt; min)
			min = m;
		n++;
	}
	return n * min;
}

int
mlevread(Device *d, Off b, void *c)
{
	int n;
	Device **list;

	n = d-&gt;cat.ndev;
	list = d-&gt;private;
	return devread(list[b%n], b/n, c);
}

int
mlevwrite(Device *d, Off b, void *c)
{
	int n;
	Device **list;

	n = d-&gt;cat.ndev;
	list = d-&gt;private;
	return devwrite(list[b%n], b/n, c);
}

/*
 * partition device
 */
void
partinit(Device *d)
{

	devinit(d-&gt;part.d);
	d-&gt;part.d-&gt;size = devsize(d-&gt;part.d);
}

Devsize
partsize(Device *d)
{
	Devsize size, l;

	l = d-&gt;part.d-&gt;size / 100;
	size = d-&gt;part.size * l;
	if(size == 0)
		size = l*100;
	return size;
}

int
partread(Device *d, Off b, void *c)
{
	Devsize base, size, l;

	l = d-&gt;part.d-&gt;size / 100;
	base = d-&gt;part.base * l;
	size = d-&gt;part.size * l;
	if(size == 0)
		size = l*100;
	if(b &lt; size)
		return devread(d-&gt;part.d, base+b, c);
	print("partread past end: %Z blk %lld size %lld\n",
		d, (Wideoff)b, (Wideoff)size);
	return 1;
}

int
partwrite(Device *d, Off b, void *c)
{
	Devsize base, size, l;

	l = d-&gt;part.d-&gt;size / 100;
	base = d-&gt;part.base * l;
	size = d-&gt;part.size * l;
	if(size == 0)
		size = l*100;
	if(b &lt; size)
		return devwrite(d-&gt;part.d, base+b, c);
	print("partwrite past end: %Z blk %lld size %lld\n",
		d, (Wideoff)b, (Wideoff)size);
	return 1;
}

/*
 * mirror device
 */
void
mirrinit(Device *d)
{
	Device *x;

	mcatinit(d);
	for(x=d-&gt;cat.first; x; x=x-&gt;link)
		x-&gt;size = devsize(x);
}

Devsize
mirrsize(Device *d)
{
	Device *x;
	int n;
	Devsize m, min;

	min = 0;
	n = 0;
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		m = x-&gt;size;
		if(m == 0) {
			m = devsize(x);
			x-&gt;size = m;
		}
		if(min == 0 || m &lt; min)
			min = m;
		n++;
	}
	return min;
}

int
mirrread(Device *d, Off b, void *c)
{
	Device *x;

	if (d-&gt;cat.first == nil) {
		print("mirrread: empty mirror %Z\n", d);
		return 1;
	}
	for(x=d-&gt;cat.first; x; x=x-&gt;link) {
		if(x-&gt;size == 0)
			x-&gt;size = devsize(x);
		if (devread(x, b, c) == 0)	/* okay? */
			return 0;
	}
	// DANGER WILL ROBINSON
	print("mirrread: all mirrors of %Z block %lld are bad\n",
		d, (Wideoff)b);
	return 1;
}

/*
 * write the mirror(s) first so that a power outage, for example, will
 * find the main device written only if the mirrors are too, thus
 * checking the main device will also correctly check the mirror(s).
 *
 * devread and devwrite are synchronous; all buffering must be
 * implemented at higher levels.
 */
static int
ewrite(Device *x, Off b, void *c)
{
	if(x-&gt;size == 0)
		x-&gt;size = devsize(x);
	if (devwrite(x, b, c) != 0) {
		print("mirrwrite: error at %Z block %lld\n", x, (Wideoff)b);
		return 1;
	}
	return 0;
}

static int
wrmirrs1st(Device *x, Off b, void *c)	// write any mirrors of x, then x
{
	int e;

	if (x == nil)
		return 0;
	e = wrmirrs1st(x-&gt;link, b, c);
	return e | ewrite(x, b, c);
}

int
mirrwrite(Device *d, Off b, void *c)
{
	if (d-&gt;cat.first == nil) {
		print("mirrwrite: empty mirror %Z\n", d);
		return 1;
	}
	return wrmirrs1st(d-&gt;cat.first, b, c);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

