<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/time.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/time.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

Timet
toytime(void)
{
	return time(nil);
}

void
datestr(char *s, Timet t)
{
	Tm *tm;

	tm = localtime(t);
	sprint(s, "%.4d%.2d%.2d", tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday);
}

void
prdate(void)
{
	print("%T\n", time(nil));
}

static void
ct_numb(char *cp, int n)
{
	if(n &gt;= 10)
		cp[0] = (n/10)%10 + '0';
	else
		cp[0] = ' ';
	cp[1] = n%10 + '0';
}

int
Tfmt(Fmt* fmt)
{
	char s[30];
	char *cp;
	Timet t;
	Tm *tm;

	t = va_arg(fmt-&gt;args, Timet);
	if(t == 0)
		return fmtstrcpy(fmt, "The Epoch");

	tm = localtime(t);
	strcpy(s, "Day Mon 00 00:00:00 1900");
	cp = &amp;"SunMonTueWedThuFriSat"[tm-&gt;wday*3];
	s[0] = cp[0];
	s[1] = cp[1];
	s[2] = cp[2];
	cp = &amp;"JanFebMarAprMayJunJulAugSepOctNovDec"[tm-&gt;mon*3];
	s[4] = cp[0];
	s[5] = cp[1];
	s[6] = cp[2];
	ct_numb(s+8, tm-&gt;mday);
	ct_numb(s+11, tm-&gt;hour+100);
	ct_numb(s+14, tm-&gt;min+100);
	ct_numb(s+17, tm-&gt;sec+100);
	if(tm-&gt;year &gt;= 100) {
		s[20] = '2';
		s[21] = '0';
	}
	ct_numb(s+22, tm-&gt;year+100);

	return fmtstrcpy(fmt, s);
}

/*
 * compute the next time after t
 * that has hour hr and is not on
 * day in bitpattern --
 * for automatic dumps
 */
Timet
nextime(Timet t, int hr, int day)
{
	int nhr;
	Tm *tm;

	if(hr &lt; 0 || hr &gt;= 24)
		hr = 5;
	if((day&amp;0x7f) == 0x7f)
		day = 0;
	for (;;) {
		tm = localtime(t);
		t -= tm-&gt;sec;
		t -= tm-&gt;min*60;
		nhr = tm-&gt;hour;
		do {
			t += 60*60;
			nhr++;
		} while(nhr%24 != hr);
		tm = localtime(t);
		if(tm-&gt;hour != hr) {
			t += 60*60;
			tm = localtime(t);
			if(tm-&gt;hour != hr) {
				t -= 60*60;
				tm = localtime(t);
			}
		}
		if(day &amp; (1&lt;&lt;tm-&gt;wday))
			t += 12*60*60;
		else
			return t;
	}
}

/*
 *  delay for l milliseconds more or less.
 */
void
delay(int l)
{
	sleep(l);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

