<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/uidgid.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/uidgid.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

struct {
	char*	name;
	Userid	uid;
	Userid	lead;
} minusers[] = {
	"adm",		-1,	-1,
	"none",		0,	-1,
	"tor",		1,	1,
	"sys",		10000,	0,
	"map",		10001,	10001,
	"doc",		10002,	0,
	"upas",		10003,	10003,
	"font",		10004,	0,
	"bootes",	10005,	10005,
	0
};

static char buf[4096];
static Rune ichar[] = L"?=+-/:";

Uid*	chkuid(char *name, int chk);
void	do_newuser(int, char*[]);
char*	getword(char*, Rune, char*, int);
void	pentry(char*, Uid*);
int	readln(char*, int);
void	setminusers(void);
Uid*	uidtop(int);

void
cmd_users(int argc, char *argv[])
{
	Uid *ui;
	int u, g, o, line;
	char *file, *p, *uname, *ulead, *unext;

	file = "/adm/users";
	if(argc &gt; 1)
		file = argv[1];

	if(strcmp(file, "default") == 0) {
		setminusers();
		return;
	}

	uidgc.uidbuf = getbuf(devnone, Cuidbuf, 0);
	if(walkto(file) || con_open(FID2, 0)) {
		print("cmd_users: cannot access %s\n", file);
		putbuf(uidgc.uidbuf);
		return;
	}

	uidgc.flen = 0;
	uidgc.find = 0;
	cons.offset = 0;
	cons.nuid = 0;

	u = 0;
	line = 0;
	while(readln(buf, sizeof buf) != 0) {
		line++;
		p = getword(buf, L':', "no : after number", line);
		if(p == nil)
			continue;
		ulead = getword(p, L':', "no : after name", line);
		if(ulead == nil)
			continue;

		if(strlen(p) &gt; NAMELEN-1) {
			print("%s: name too long\n", p);
			continue;
		}
		strcpy(uid[u].name, p);
		uid[u].uid = number(buf, 0, 10);
		uid[u].lead = 0;
		uid[u].ngrp = 0;
		u++;
		if(u &gt;= conf.nuid) {
			print("conf.nuid too small (%ld)\n", conf.nuid);
			break;
		}
	}

	/* Sorted by uid for use in uidtostr */
	wlock(&amp;uidgc.uidlock);
	qsort(uid, u, sizeof(uid[0]), byuid);
	cons.nuid = u;
	wunlock(&amp;uidgc.uidlock);

	/* Parse group table */
	uidgc.flen = 0;
	uidgc.find = 0;
	cons.offset = 0;
	cons.ngid = 0;

	g = 0;
	line = 0;
	while(readln(buf, sizeof buf) != 0) {
		line++;
		uname = getword(buf, L':', 0, 0);	/* skip number */
		if(uname == nil)
			continue;

		ulead = getword(uname, L':', 0, 0);	/* skip name */
		if(ulead == nil)
			continue;

		p = getword(ulead, L':', "no : after leader", line);
		if(p == nil)
			continue;

		ui = uidpstr(uname);
		if(ui == nil)
			continue;

		/* set to owner if name not known */
		ui-&gt;lead = 0;
		if(ulead[0]) {
			o = strtouid(ulead);
			if(o &gt;= 0)
				ui-&gt;lead = o;
			else
				ui-&gt;lead = ui-&gt;uid;
		}
		ui-&gt;gtab = &amp;gidspace[g];
		ui-&gt;ngrp = 0;
		while (p != nil) {
			unext = getword(p, L',', 0, 0);
			o = strtouid(p);
			if(o &gt;= 0) {
				gidspace[g++] = o;
				ui-&gt;ngrp++;
			}
			p = unext;
		}
	}

	cons.ngid = g;

	putbuf(uidgc.uidbuf);
	print("%d uids read, %d groups used\n", cons.nuid, cons.ngid);
}

void
cmd_newuser(int argc, char *argv[])
{
	if(argc &lt;= 1) {
		print("usage: newuser args\n");
		print("\tname -- create a new user\n");
		print("\tname : -- create a new group\n");
		print("\tname ? -- show entry for user\n");
		print("\tname name -- rename\n");
		print("\tname =[name] -- add/alter/remove leader\n");
		print("\tname +name -- add member\n");
		print("\tname -name -- delete member\n");
		return;
	}
	do_newuser(argc, argv);
}

void
do_newuser(int argc, char *argv[])
{
	int i, l, n, nuid;
	char *p, *md, *q;
	Rune *r;
	Userid *s;
	Uid *ui, *u2;

	nuid = 10000;
	md = 0;
	if(argc == 2) {
		nuid = 1;
		argv[2] = ":";
	}

	for(r = ichar; *r; r++)
		if(utfrune(argv[1], *r)) {
			print("illegal character in name\n");
			return;
		}
	if(strlen(argv[1]) &gt; NAMELEN-1) {
		print("name %s too long\n", argv[1]);
		return;
	}

	p = argv[2];
	switch(*p) {
	case '?':
		ui = chkuid(argv[1], 1);
		if(ui == 0)
			return;
		pentry(buf, ui);
		n = strlen(buf);
		p = buf;
		while(n &gt; PRINTSIZE-5) {
			q = p;
			p += PRINTSIZE-5;
			n -= PRINTSIZE-5;
			i = *p;
			*p = 0;
			print("%s", q);
			*p = i;
		}
		print("%s\n", p);
		return;

	case ':':
		if(chkuid(argv[1], 0))
			return;
		while(uidtop(nuid) != 0)
			nuid++;
		if(cons.nuid &gt;= conf.nuid) {
			print("conf.nuid too small (%ld)\n", conf.nuid);
			return;
		}

		wlock(&amp;uidgc.uidlock);
		ui = &amp;uid[cons.nuid++];
		ui-&gt;uid = nuid;
		ui-&gt;lead = 0;
		if(nuid &lt; 10000) {
			ui-&gt;lead = ui-&gt;uid;
			md = argv[1];
		}
		strcpy(ui-&gt;name, argv[1]);
		ui-&gt;ngrp = 0;
		qsort(uid, cons.nuid, sizeof(uid[0]), byuid);
		wunlock(&amp;uidgc.uidlock);
		break;

	case '=':
		ui = chkuid(argv[1], 1);
		if(ui == 0)
			return;
		p++;
		if(*p == '\0') {
			ui-&gt;lead = 0;
			break;
		}
		u2 = chkuid(p, 1);
		if(u2 == 0)
			return;
		ui-&gt;lead = u2-&gt;uid;
		break;

	case '+':
		ui = chkuid(argv[1], 1);
		if(ui == 0)
			return;
		p++;
		u2 = chkuid(p, 1);
		if(u2 == 0)
			return;
		if(u2-&gt;uid == ui-&gt;uid)
			return;
		if(cons.ngid+ui-&gt;ngrp+1 &gt;= conf.gidspace) {
			print("conf.gidspace too small (%ld)\n", conf.gidspace);
			return;
		}
		for(i = 0; i &lt; ui-&gt;ngrp; i++) {
			if(ui-&gt;gtab[i] == u2-&gt;uid) {
				print("member already in group\n");
				return;
			}
		}

		wlock(&amp;uidgc.uidlock);
		s = gidspace+cons.ngid;
		memmove(s, ui-&gt;gtab, ui-&gt;ngrp*sizeof(*s));
		ui-&gt;gtab = s;
		s[ui-&gt;ngrp++] = u2-&gt;uid;
		cons.ngid += ui-&gt;ngrp+1;
		wunlock(&amp;uidgc.uidlock);
		break;

	case '-':
		ui = chkuid(argv[1], 1);
		if(ui == 0)
			return;
		p++;
		u2 = chkuid(p, 1);
		if(u2 == 0)
			return;
		for(i = 0; i &lt; ui-&gt;ngrp; i++)
			if(ui-&gt;gtab[i] == u2-&gt;uid)
				break;

		if(i == ui-&gt;ngrp) {
			print("%s not in group\n", p);
			return;
		}

		wlock(&amp;uidgc.uidlock);
		s = ui-&gt;gtab+i;
		ui-&gt;ngrp--;
		memmove(s, s+1, (ui-&gt;ngrp-i)*sizeof(*s));
		wunlock(&amp;uidgc.uidlock);
		break;

	default:
		if(chkuid(argv[2], 0))
			return;

		for(r = ichar; *r; r++)
			if(utfrune(argv[2], *r)) {
				print("illegal character in name\n");
				return;
			}

		ui = chkuid(argv[1], 1);
		if(ui == 0)
			return;

		if(strlen(argv[2]) &gt; NAMELEN-1) {
			print("name %s too long\n", argv[2]);
			return;
		}

		wlock(&amp;uidgc.uidlock);
		strcpy(ui-&gt;name, argv[2]);
		wunlock(&amp;uidgc.uidlock);
		break;
	}


	if(walkto("/adm/users") || con_open(FID2, OWRITE|OTRUNC)) {
		print("can't open /adm/users for write\n");
		return;
	}

	cons.offset = 0;
	for(i = 0; i &lt; cons.nuid; i++) {
		pentry(buf, &amp;uid[i]);
		l = strlen(buf);
		n = con_write(FID2, buf, cons.offset, l);
		if(l != n)
			print("short write on /adm/users\n");
		cons.offset += n;
	}

	if(md != 0) {
		sprint(buf, "create /usr/%s %s %s 755 d", md, md, md);
		print("%s\n", buf);
		cmd_exec(buf);
	}
}

Uid*
chkuid(char *name, int chk)
{
	Uid *u;

	u = uidpstr(name);
	if(chk == 1) {
		if(u == 0)
			print("%s does not exist\n", name);
	}
	else {
		if(u != 0)
			print("%s already exists\n", name);
	}
	return u;
}

void
pentry(char *buf, Uid *u)
{
	int i, posn;
	Uid *p;

	posn = sprint(buf, "%d:%s:", u-&gt;uid, u-&gt;name);
	p = uidtop(u-&gt;lead);
	if(p &amp;&amp; u-&gt;lead != 0)
		posn += sprint(buf+posn, "%s", p-&gt;name);

	posn += sprint(buf+posn, ":");
	for(i = 0; i &lt; u-&gt;ngrp; i++) {
		p = uidtop(u-&gt;gtab[i]);
		if(i != 0)
			posn += sprint(buf+posn, ",");
		if(p != 0)
			posn += sprint(buf+posn, "%s", p-&gt;name);
		else
			posn += sprint(buf+posn, "%d", u-&gt;gtab[i]);
	}
	sprint(buf+posn, "\n");
}

void
setminusers(void)
{
	int u;

	for(u = 0; minusers[u].name; u++) {
		strcpy(uid[u].name, minusers[u].name);
		uid[u].uid = minusers[u].uid;
		uid[u].lead = minusers[u].lead;
	}
	cons.nuid = u;
	qsort(uid, u, sizeof(uid[0]), byuid);
}

Uid*
uidpstr(char *name)
{
	Uid *s, *e;

	s = uid;
	for(e = s+cons.nuid; s &lt; e; s++) {
		if(strcmp(name, s-&gt;name) == 0)
			return s;
	}
	return 0;
}

char*
getword(char *buf, Rune delim, char *error, int line)
{
	char *p;

	p = utfrune(buf, delim);
	if(p == 0) {
		if(error)
			print("cmd_users: %s line %d\n", error, line);
		return 0;
	}
	*p = '\0';
	return p+1;
}

int
strtouid(char *name)
{
	Uid *u;
	int id;

	rlock(&amp;uidgc.uidlock);

	u = uidpstr(name);
	id = -2;
	if(u != 0)
		id = u-&gt;uid;

	runlock(&amp;uidgc.uidlock);

	return id;
}

Uid*
uidtop(int id)
{
	Uid *bot, *top, *new;

	bot = uid;
	top = bot + cons.nuid-1;

	while(bot &lt;= top){
		new = bot + (top - bot)/2;
		if(new-&gt;uid == id)
			return new;
		if(new-&gt;uid &lt; id)
			bot = new + 1;
		else
			top = new - 1;
	}
	return 0;
}

void
uidtostr(char *name, int id, int dolock)
{
	Uid *p;

	if(dolock)
		rlock(&amp;uidgc.uidlock);

	p = uidtop(id);
	if(p == 0)
		strcpy(name, "none");
	else
		strcpy(name, p-&gt;name);

	if(dolock)
		runlock(&amp;uidgc.uidlock);
}

int
ingroup(int u, int g)
{
	Uid *p;
	Userid *s, *e;

	if(u == g)
		return 1;

	rlock(&amp;uidgc.uidlock);
	p = uidtop(g);
	if(p != 0) {
		s = p-&gt;gtab;
		for(e = s + p-&gt;ngrp; s &lt; e; s++) {
			if(*s == u) {
				runlock(&amp;uidgc.uidlock);
				return 1;
			}
		}
	}
	runlock(&amp;uidgc.uidlock);
	return 0;
}

int
leadgroup(int ui, int gi)
{
	int i;
	Uid *u;

	/* user 'none' cannot be a group leader */
	if(ui == 0)
		return 0;

	rlock(&amp;uidgc.uidlock);
	u = uidtop(gi);
	if(u == 0) {
		runlock(&amp;uidgc.uidlock);
		return 0;
	}
	i = u-&gt;lead;
	runlock(&amp;uidgc.uidlock);
	if(i == ui)
		return 1;
	if(i == 0)
		return ingroup(ui, gi);

	return 0;
}

int
byuid(void *a1, void *a2)
{
	Uid *u1, *u2;

	u1 = a1;
	u2 = a2;
	return u1-&gt;uid - u2-&gt;uid;
}

int
fchar(void)
{
	int n;

	n = BUFSIZE;
	if(n &gt; MAXDAT)
		n = MAXDAT;
	if(uidgc.find &gt;= uidgc.flen) {
		uidgc.find = 0;
		uidgc.flen = con_read(FID2, uidgc.uidbuf-&gt;iobuf, cons.offset, n);
		if(uidgc.flen &lt;= 0)
			return -1;
		cons.offset += uidgc.flen;
	}
	return (uchar)uidgc.uidbuf-&gt;iobuf[uidgc.find++];
}

int
readln(char *p, int len)
{
	int n, c;

	n = 0;
	while(len--) {
		c = fchar();
		if(c == -1 || c == '\n')
			break;
		n++;
		*p++ = c;
	}
	*p = '\0';
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

