<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/cwfs/wren.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/cwfs/wren.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * drive disks
 * used to be just scsi disks, and issued scsi commands directly to the host
 * adapter, but now it just does normal i/o.
 */
#include "all.h"

enum { Sectorsz = 512, };		/* usual disk sector size */

typedef	struct	Wren	Wren;
struct	Wren
{
	long	block;			/* size of a block -- from config */
	Devsize	nblock;			/* number of blocks -- from config */
	long	mult;			/* multiplier to get physical blocks */
	Devsize	max;			/* number of logical blocks */

//	char	*sddir;			/* /dev/sdXX name */
};

char *
dataof(char *file)
{
	char *datanm;
	Dir *dir;

	dir = dirstat(file);
	if (dir != nil &amp;&amp; dir-&gt;mode &amp; DMDIR)
		datanm = smprint("%s/data", file);
	else
		datanm = strdup(file);
	free(dir);
	return datanm;
}

void
wreninit(Device *d)
{
	Wren *dr;
	Dir *dir;

	if(d-&gt;private)
		return;
	d-&gt;private = dr = malloc(sizeof(Wren));

	if (d-&gt;wren.file)
		d-&gt;wren.sddata = dataof(d-&gt;wren.file);
	else {
		d-&gt;wren.sddir = sdof(d);
		d-&gt;wren.sddata = smprint("%s/data", d-&gt;wren.sddir);
	}

	assert(d-&gt;wren.fd &lt;= 0);
	d-&gt;wren.fd = open(d-&gt;wren.sddata, ORDWR);
	if (d-&gt;wren.fd &lt; 0)
		panic("wreninit: can't open %s for %Z: %r", d-&gt;wren.sddata, d);

	dr-&gt;block = inqsize(d-&gt;wren.sddata);
	if(dr-&gt;block &lt;= 0 || dr-&gt;block &gt;= 16*1024) {
		print("\twreninit %Z block size %ld, setting to %d\n",
			d, dr-&gt;block, Sectorsz);
		dr-&gt;block = Sectorsz;
	}

	dir = dirfstat(d-&gt;wren.fd);
	dr-&gt;nblock = dir-&gt;length / dr-&gt;block;
	free(dir);

	dr-&gt;mult = (RBUFSIZE + dr-&gt;block - 1) / dr-&gt;block;
	dr-&gt;max = (dr-&gt;nblock + 1) / dr-&gt;mult;
	print("\tdisk drive %Z: %,lld %ld-byte sectors, ",
		d, (Wideoff)dr-&gt;nblock, dr-&gt;block);
	print("%,lld %d-byte blocks\n", (Wideoff)dr-&gt;max, RBUFSIZE);
	print("\t\t%ld multiplier\n", dr-&gt;mult);
}

Devsize
wrensize(Device *d)
{
	return ((Wren *)d-&gt;private)-&gt;max;
}

int
wrenread(Device *d, Off b, void *c)
{
	int r = 0;
	Wren *dr = d-&gt;private;

	if (dr == nil)
		panic("wrenread: no drive (%Z) block %lld", d, (Wideoff)b);
	if(b &gt;= dr-&gt;max) {
		print("wrenread: block out of range %Z(%lld)\n", d, (Wideoff)b);
		r = 0x040;
	} else if (pread(d-&gt;wren.fd, c, RBUFSIZE, (vlong)b*RBUFSIZE) != RBUFSIZE) {
		print("wrenread: error on %Z(%lld): %r\n", d, (Wideoff)b);
		cons.nwrenre++;
		r = 1;
	}
	return r;
}

int
wrenwrite(Device *d, Off b, void *c)
{
	int r = 0;
	Wren *dr = d-&gt;private;

	if (dr == nil)
		panic("wrenwrite: no drive (%Z) block %lld", d, (Wideoff)b);
	if(b &gt;= dr-&gt;max) {
		print("wrenwrite: block out of range %Z(%lld)\n",
			d, (Wideoff)b);
		r = 0x040;
	} else if (pwrite(d-&gt;wren.fd, c, RBUFSIZE, (vlong)b*RBUFSIZE) != RBUFSIZE) {
		print("wrenwrite: error on %Z(%lld): %r\n", d, (Wideoff)b);
		cons.nwrenwe++;
		r = 1;
	}
	return r;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

