<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/db/print.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/db/print.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *
 *	debugger
 *
 */
#include "defs.h"
#include "fns.h"

extern	int	infile;
extern	int	outfile;
extern	int	maxpos;

/* general printing routines ($) */

char	*Ipath = INCDIR;
static	int	tracetype;
static void	printfp(Map*, int);

/*
 *	callback on stack trace
 */
static void
ptrace(Map *map, uvlong pc, uvlong sp, Symbol *sym)
{
	char buf[512];

	USED(map);
	dprint("%s(", sym-&gt;name);
	printparams(sym, sp);
	dprint(") ");
	printsource(sym-&gt;value);
	dprint(" called from ");
	symoff(buf, 512, pc, CTEXT);
	dprint("%s ", buf);
	printsource(pc);
	dprint("\n");
	if(tracetype == 'C')
		printlocals(sym, sp);
}

void
printtrace(int modif)
{
	int i;
	uvlong pc, sp, link;
	ulong w;
	BKPT *bk;
	Symbol s;
	int stack;
	char *fname;
	char buf[512];

	if (cntflg==0)
		cntval = -1;
	switch (modif) {

	case '&lt;':
		if (cntval == 0) {
			while (readchar() != EOR)
				;
			reread();
			break;
		}
		if (rdc() == '&lt;')
			stack = 1;
		else {
			stack = 0;
			reread();
		}
		fname = getfname();
		redirin(stack, fname);
		break;

	case '&gt;':
		fname = getfname();
		redirout(fname);
		break;

	case 'a':
		attachprocess();
		break;

	case 'k':
		kmsys();
		break;

	case 'q':
	case 'Q':
		done();

	case 'w':
		maxpos=(adrflg?adrval:MAXPOS);
		break;

	case 'S':
		printsym();
		break;

	case 's':
		maxoff=(adrflg?adrval:MAXOFF);
		break;

	case 'm':
		printmap("? map", symmap);
		printmap("/ map", cormap);
		break;

	case 0:
	case '?':
		if (pid)
			dprint("pid = %d\n",pid);
		else
			prints("no process\n");
		flushbuf();

	case 'r':
	case 'R':
		printregs(modif);
		return;

	case 'f':
	case 'F':
		printfp(cormap, modif);
		return;

	case 'c':
	case 'C':
		tracetype = modif;
		if (machdata-&gt;ctrace) {
			if (adrflg) {
				/*
				 * trace from jmpbuf for multi-threaded code.
				 * assume sp and pc are in adjacent locations
				 * and mach-&gt;szaddr in size.
				 */
				if (geta(cormap, adrval, &amp;sp) &lt; 0 ||
					geta(cormap, adrval+mach-&gt;szaddr, &amp;pc) &lt; 0)
						error("%r");
			} else {
				sp = rget(cormap, mach-&gt;sp);
				pc = rget(cormap, mach-&gt;pc);
			}
			if(mach-&gt;link)
				link = rget(cormap, mach-&gt;link);
			else
				link = 0;
			if (machdata-&gt;ctrace(cormap, pc, sp, link, ptrace) &lt;= 0)
				error("no stack frame");
		}
		break;

		/*print externals*/
	case 'e':
		for (i = 0; globalsym(&amp;s, i); i++) {
			if (get4(cormap, s.value, &amp;w) &gt; 0)
				dprint("%s/%12t%#lux\n", s.name, w);
		}
		break;

		/*print breakpoints*/
	case 'b':
	case 'B':
		for (bk=bkpthead; bk; bk=bk-&gt;nxtbkpt)
			if (bk-&gt;flag) {
				symoff(buf, 512, (WORD)bk-&gt;loc, CTEXT);
				dprint(buf);
				if (bk-&gt;count != 1)
					dprint(",%d", bk-&gt;count);
				dprint(":%c %s", bk-&gt;flag == BKPTTMP ? 'B' : 'b', bk-&gt;comm);
			}
		break;

	case 'M':
		fname = getfname();
		if (machbyname(fname) == 0)
			dprint("unknown name\n");;
		break;
	default:
		error("bad `$' command");
	}

}

char *
getfname(void)
{
	static char fname[ARB];
	char *p;

	if (rdc() == EOR) {
		reread();
		return (0);
	}
	p = fname;
	do {
		*p++ = lastc;
		if (p &gt;= &amp;fname[ARB-1])
			error("filename too long");
	} while (rdc() != EOR);
	*p = 0;
	reread();
	return (fname);
}

static void
printfp(Map *map, int modif)
{
	Reglist *rp;
	int i;
	int ret;
	char buf[512];

	for (i = 0, rp = mach-&gt;reglist; rp-&gt;rname; rp += ret) {
		ret = 1;
		if (!(rp-&gt;rflags&amp;RFLT))
			continue;
		ret = fpformat(map, rp, buf, sizeof(buf), modif);
		if (ret &lt; 0) {
			werrstr("Register %s: %r", rp-&gt;rname);
			error("%r");
		}
			/* double column print */
		if (i&amp;0x01)
			dprint("%40t%-8s%-12s\n", rp-&gt;rname, buf);
		else
			dprint("\t%-8s%-12s", rp-&gt;rname, buf);
		i++;
	}
}

void
redirin(int stack, char *file)
{
	char *pfile;

	if (file == 0) {
		iclose(-1, 0);
		return;
	}
	iclose(stack, 0);
	if ((infile = open(file, 0)) &lt; 0) {
		pfile = smprint("%s/%s", Ipath, file);
		infile = open(pfile, 0);
		free(pfile);
		if(infile &lt; 0) {
			infile = STDIN;
			error("cannot open");
		}
	}
}

void
printmap(char *s, Map *map)
{
	int i;

	if (!map)
		return;
	if (map == symmap)
		dprint("%s%12t`%s'\n", s, fsym &lt; 0 ? "-" : symfil);
	else if (map == cormap)
		dprint("%s%12t`%s'\n", s, fcor &lt; 0 ? "-" : corfil);
	else
		dprint("%s\n", s);
	for (i = 0; i &lt; map-&gt;nsegs; i++) {
		if (map-&gt;seg[i].inuse)
			dprint("%s%8t%-16#llux %-16#llux %-16#llux\n",
				map-&gt;seg[i].name, map-&gt;seg[i].b,
				map-&gt;seg[i].e, map-&gt;seg[i].f);
	}
}

/*
 *	dump the raw symbol table
 */
void
printsym(void)
{
	int i;
	Sym *sp;

	for (i = 0; sp = getsym(i); i++) {
		switch(sp-&gt;type) {
		case 't':
		case 'l':
			dprint("%16#llux t %s\n", sp-&gt;value, sp-&gt;name);
			break;
		case 'T':
		case 'L':
			dprint("%16#llux T %s\n", sp-&gt;value, sp-&gt;name);
			break;
		case 'D':
		case 'd':
		case 'B':
		case 'b':
		case 'a':
		case 'p':
		case 'm':
			dprint("%16#llux %c %s\n", sp-&gt;value, sp-&gt;type, sp-&gt;name);
			break;
		default:
			break;
		}
	}
}

#define	STRINGSZ	128

/*
 *	print the value of dot as file:line
 */
void
printsource(ADDR dot)
{
	char str[STRINGSZ];

	if (fileline(str, STRINGSZ, dot))
		dprint("%s", str);
}

void
printpc(void)
{
	char buf[512];

	dot = rget(cormap, mach-&gt;pc);
	if(dot){
		printsource((long)dot);
		printc(' ');
		symoff(buf, sizeof(buf), (long)dot, CTEXT);
		dprint("%s/", buf);
		if (machdata-&gt;das(cormap, dot, 'i', buf, sizeof(buf)) &lt; 0)
			error("%r");
		dprint("%16t%s\n", buf);
	}
}

void
printlocals(Symbol *fn, ADDR fp)
{
	int i;
	ulong w;
	Symbol s;

	s = *fn;
	for (i = 0; localsym(&amp;s, i); i++) {
		if (s.class != CAUTO)
			continue;
		if (get4(cormap, fp-s.value, &amp;w) &gt; 0)
			dprint("%8t%s.%s/%10t%#lux\n", fn-&gt;name, s.name, w);
		else
			dprint("%8t%s.%s/%10t?\n", fn-&gt;name, s.name);
	}
}

void
printparams(Symbol *fn, ADDR fp)
{
	int i;
	Symbol s;
	ulong w;
	int first = 0;

	fp += mach-&gt;szaddr;			/* skip saved pc */
	s = *fn;
	for (i = 0; localsym(&amp;s, i); i++) {
		if (s.class != CPARAM)
			continue;
		if (first++)
			dprint(", ");
		if (get4(cormap, fp+s.value, &amp;w) &gt; 0)
			dprint("%s=%#lux", s.name, w);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

