<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/db/runpcs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/db/runpcs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *
 *	debugger
 *
 */

#include "defs.h"
#include "fns.h"

BKPT *bkpthead;

BOOL bpin;

int pid;
int nnote;
int ending;
char note[NNOTE][ERRMAX];

/* service routines for sub process control */

runpcs(int runmode, int keepnote)
{
	int rc;
	BKPT *bkpt;

	rc = 0;
	if (adrflg)
		rput(cormap, mach-&gt;pc, dot);
	dot = rget(cormap, mach-&gt;pc);
	flush();
	while (loopcnt-- &gt; 0) {
		if(loopcnt != 0)
			printpc();
		if (runmode == SINGLE) {
			bkpt = scanbkpt(dot);
			if (bkpt) {
				switch(bkpt-&gt;flag){
				case BKPTTMP:
					bkpt-&gt;flag = BKPTCLR;
					break;
				case BKPTSKIP:
					bkpt-&gt;flag = BKPTSET;
					break;
				}
			}
			runstep(dot, keepnote);
		} else {
			if ((bkpt = scanbkpt(rget(cormap, mach-&gt;pc))) != 0) {
				execbkpt(bkpt, keepnote);
				keepnote = 0;
			}
			setbp();
			runrun(keepnote);
		}
		keepnote = 0;
		delbp();
		dot = rget(cormap, mach-&gt;pc);
		/* real note? */
		if (nnote &gt; 0) {
			keepnote = 1;
			rc = 0;
			continue;
		}
		bkpt = scanbkpt(dot);
		if(bkpt == 0){
			keepnote = 0;
			rc = 0;
			continue;
		}
		/* breakpoint */
		if (bkpt-&gt;flag == BKPTTMP)
			bkpt-&gt;flag = BKPTCLR;
		else if (bkpt-&gt;flag == BKPTSKIP) {
			execbkpt(bkpt, keepnote);
			keepnote = 0;
			loopcnt++;	/* we didn't really stop */
			continue;
		}
		else {
			bkpt-&gt;flag = BKPTSKIP;
			--bkpt-&gt;count;
			if ((bkpt-&gt;comm[0] == EOR || command(bkpt-&gt;comm, ':') != 0)
			&amp;&amp;  bkpt-&gt;count != 0) {
				execbkpt(bkpt, keepnote);
				keepnote = 0;
				loopcnt++;
				continue;
			}
			bkpt-&gt;count = bkpt-&gt;initcnt;
		}
		rc = 1;
	}
	return(rc);
}

/*
 * finish the process off;
 * kill if still running
 */

void
endpcs(void)
{
	BKPT *bk;

	if(ending)
		return;
	ending = 1;
	if (pid) {
		if(pcsactive){
			killpcs();
			pcsactive = 0;
		}
		pid=0;
		nnote=0;
		for (bk=bkpthead; bk; bk = bk-&gt;nxtbkpt)
			if (bk-&gt;flag == BKPTTMP)
				bk-&gt;flag = BKPTCLR;
			else if (bk-&gt;flag != BKPTCLR)
				bk-&gt;flag = BKPTSET;
	}
	bpin = FALSE;
	ending = 0;
}

/*
 * start up the program to be debugged in a child
 */

void
setup(void)
{

	nnote = 0;
	startpcs();
	bpin = FALSE;
	pcsactive = 1;
}

/*
 * skip over a breakpoint:
 * remove breakpoints, then single step
 * so we can put it back
 */
void
execbkpt(BKPT *bk, int keepnote)
{
	runstep(bk-&gt;loc, keepnote);
	bk-&gt;flag = BKPTSET;
}

/*
 * find the breakpoint at adr, if any
 */

BKPT *
scanbkpt(ADDR adr)
{
	BKPT *bk;

	for (bk = bkpthead; bk; bk = bk-&gt;nxtbkpt)
		if (bk-&gt;flag != BKPTCLR &amp;&amp; bk-&gt;loc == adr)
			break;
	return(bk);
}

/*
 * remove all breakpoints from the process' address space
 */

void
delbp(void)
{
	BKPT *bk;

	if (bpin == FALSE || pid == 0)
		return;
	for (bk = bkpthead; bk; bk = bk-&gt;nxtbkpt)
		if (bk-&gt;flag != BKPTCLR)
			bkput(bk, 0);
	bpin = FALSE;
}

/*
 * install all the breakpoints
 */

void
setbp(void)
{
	BKPT *bk;

	if (bpin == TRUE || pid == 0)
		return;
	for (bk = bkpthead; bk; bk = bk-&gt;nxtbkpt)
		if (bk-&gt;flag != BKPTCLR)
			bkput(bk, 1);
	bpin = TRUE;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

