<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dict/ahd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dict/ahd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "dict.h"

/*
 * American Heritage Dictionary (encrypted)
 */

static Rune intab[256] = {
	[0x82] L'é',
	[0x85] L'à',
	[0x89] L'ë',
	[0x8a] L'è',
	[0xa4] L'ñ',
	[0xf8] L'°',
	[0xf9] L'·',
};

static char	tag[64];

enum{
	Run, Openper, Openat, Closeat
};

void
ahdprintentry(Entry e, int cmd)
{
	static int inited;
	long addr;
	char *p, *t = tag;
	int obreaklen;
	int c, state = Run;

	if(!inited){
		for(c=0; c&lt;256; c++)
			if(intab[c] == 0)
				intab[c] = c;
		inited = 1;
	}
	obreaklen = breaklen;
	breaklen = 80;
	addr = e.doff;
	for(p=e.start; p&lt;e.end; p++){
		c = intab[(*p ^ (addr++&gt;&gt;1))&amp;0xff];
		switch(state){
		case Run:
			if(c == '%'){
				t = tag;
				state = Openper;
				break;
			}
		Putchar:
			if(c == '\n')
				outnl(0);
			else if(c &lt; Runeself)
				outchar(c);
			else
				outrune(c);
			break;

		case Openper:
			if(c == '@')
				state = Openat;
			else{
				outchar('%');
				state = Run;
				goto Putchar;
			}
			break;

		case Openat:
			if(c == '@')
				state = Closeat;
			else if(t &lt; &amp;tag[sizeof tag-1])
				*t++ = c;
			break;

		case Closeat:
			if(c == '%'){
				*t = 0;
				switch(cmd){
				case 'h':
					if(strcmp("EH", tag) == 0)
						goto out;
					break;
				case 'r':
					outprint("%%@%s@%%", tag);
					break;
				}
				state = Run;
			}else{
				if(t &lt; &amp;tag[sizeof tag-1])
					*t++ = '@';
				if(t &lt; &amp;tag[sizeof tag-1])
					*t++ = c;
				state = Openat;
			}
			break;
		}
	}
out:
	outnl(0);
	breaklen = obreaklen;
}

long
ahdnextoff(long fromoff)
{
	static char *patterns[] = { "%@NL@%", "%@2@%", 0 };
	int c, k = 0, state = 0;
	char *pat = patterns[0];
	long defoff = -1;

	if(Bseek(bdict, fromoff, 0) &lt; 0)
		return -1;
	while((c = Bgetc(bdict)) &gt;= 0){
		c ^= (fromoff++&gt;&gt;1)&amp;0xff;
		if(c != pat[state]){
			state = 0;
			continue;
		}
		if(pat[++state])
			continue;
		if(pat = patterns[++k]){	/* assign = */
			state = 0;
			defoff = fromoff-6;
			continue;
		}
		return fromoff-5;
	}
	return defoff;
}

void
ahdprintkey(void)
{
	Bprint(bout, "No pronunciations.\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

