<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dict/movie.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dict/movie.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "dict.h"

/* Possible tags */
enum {
	BEG,	/* beginning of entry */
	AB,	/* abstract */
	AN,	/* database serial number */
	AS,	/* author (one at a time) */
	AU,	/* all authors */
	AW,	/* award_awardee */
	BW,	/* bw or c */
	CA,	/* cast: character_actor */
	CN,	/* cinematography */
	CO,	/* country */
	CR,	/* miscellaneous job_name */
	DE,	/* topic keyword */
	DR,	/* director */
	ED,	/* editor */
	MP,	/* MPAA rating (R, PG, etc.) */
	NT,	/* note */
	PR,	/* producer and for ...*/
	PS,	/* producer (repeats info in PR) */
	RA,	/* rating (letter) */
	RD,	/* release date */
	RT,	/* running time */
	RV,	/* review citation */
	ST,	/* production or release company (repeats info in PR) */
	TI,	/* title[; original foreign title] */
	TX,	/* paragraph of descriptive text */
	VD,	/* video information (format_time_company; or "Not Avail.") */
	NTAG	/* number of tags */
};

/* Assoc tables must be sorted on first field */

static char *tagtab[] = {
[BEG]	"$$",
[AB]	"AB",
[AN]	"AN",
[AS]	"AS",
[AU]	"AU",
[AW]	"AW",
[BW]	"BW",
[CA]	"CA",
[CN]	"CN",
[CO]	"CO",
[CR]	"CR",
[DE]	"DE",
[DR]	"DR",
[ED]	"ED",
[MP]	"MP",
[NT]	"NT",
[PR]	"PR",
[PS]	"PS",
[RA]	"RA",
[RD]	"RD",
[RT]	"RT",
[RV]	"RV",
[ST]	"ST",
[TI]	"TI",
[TX]	"TX",
[VD]	"VD",
};

static char	*mget(int, char *, char *, char **);
static void	moutall(int, char *, char *);
static void	moutall2(int, char *, char *);

void
movieprintentry(Entry ent, int cmd)
{
	char *p, *e, *ps, *pe, *pn;
	int n;

	ps = ent.start;
	pe = ent.end;
	if(cmd == 'r') {
		Bwrite(bout, ps, pe-ps);
		return;
	}
	p = mget(TI, ps, pe, &amp;e);
	if(p) {
		outpiece(p, e);
		outnl(0);
	}
	if(cmd == 'h')
		return;
	outnl(2);
	n = 0;
	p = mget(RD, ps, pe, &amp;e);
	if(p) {
		outchars("Released: ");
		outpiece(p, e);
		n++;
	}
	p = mget(CO, ps, pe, &amp;e);
	if(p) {
		if(n)
			outchars(", ");
		outpiece(p, e);
		n++;
	}
	p = mget(RT, ps, pe, &amp;e);
	if(p) {
		if(n)
			outchars(", ");
		outchars("Running time: ");
		outpiece(p, e);
		n++;
	}
	p = mget(MP, ps, pe, &amp;e);
	if(p) {
		if(n)
			outchars(", ");
		outpiece(p, e);
		n++;
	}
	p = mget(BW, ps, pe, &amp;e);
	if(p) {
		if(n)
			outchars(", ");
		if(*p == 'c' || *p == 'C')
			outchars("Color");
		else
			outchars("B&amp;W");
		n++;
	}
	if(n) {
		outchar('.');
		outnl(1);
	}
	p = mget(VD, ps, pe, &amp;e);
	if(p) {
		outchars("Video: ");
		outpiece(p, e);
		outnl(1);
	}
	p = mget(AU, ps, pe, &amp;e);
	if(p) {
		outchars("By: ");
		moutall2(AU, ps, pe);
		outnl(1);
	}
	p = mget(DR, ps, pe, &amp;e);
	if(p) {
		outchars("Director: ");
		outpiece(p, e);
		outnl(1);
	}
	p = mget(PR, ps, pe, &amp;e);
	if(p) {
		outchars("Producer: ");
		outpiece(p, e);
		outnl(1);
	}
	p = mget(CN, ps, pe, &amp;e);
	if(p) {
		outchars("Cinematograpy: ");
		outpiece(p, e);
		outnl(1);
	}
	p = mget(CR, ps, pe, &amp;e);
	if(p) {
		outchars("Other Credits: ");
		moutall2(CR, ps, pe);
	}
	outnl(2);
	p = mget(CA, ps, pe, &amp;e);
	if(p) {
		outchars("Cast: ");
		moutall2(CA, ps, pe);
	}
	outnl(2);
	p = mget(AW, ps, pe, &amp;e);
	if(p) {
		outchars("Awards: ");
		moutall2(AW, ps, pe);
		outnl(2);
	}
	p = mget(NT, ps, pe, &amp;e);
	if(p) {
		outpiece(p, e);
		outnl(2);
	}
	p = mget(AB, ps, pe, &amp;e);
	if(p) {
		outpiece(p, e);
		outnl(2);
	}
	pn = ps;
	n = 0;
	while((p = mget(TX, pn, pe, &amp;pn)) != 0) {
		if(n++)
			outnl(1);
		outpiece(p, pn);
	}
	outnl(0);
}

long
movienextoff(long fromoff)
{
	long a;
	char *p;

	a = Bseek(bdict, fromoff, 0);
	if(a &lt; 0)
		return -1;
	for(;;) {
		p = Brdline(bdict, '\n');
		if(!p)
			break;
		if(p[0] == '$' &amp;&amp; p[1] == '$')
			return (Boffset(bdict)-Blinelen(bdict));
	}
	return -1;
}

void
movieprintkey(void)
{
	Bprint(bout, "No key\n");
}

/*
 * write a comma-separated list of all tag values between b and e
 */
static void
moutall(int tag, char *b, char *e)
{
	char *p, *pn;
	int n;

	n = 0;
	pn = b;
	while((p = mget(tag, pn, e, &amp;pn)) != 0) {
		if(n++)
			outchars(", ");
		outpiece(p, pn);
	}
}

/*
 * like moutall, but values are expected to have form:
 *    field1_field2
 * and we are to output 'field2 (field1)' for each
 * (sometimes field1 has underscores, so search from end)
 */
static void
moutall2(int tag, char *b, char *e)
{
	char *p, *pn, *us, *q;
	int n;

	n = 0;
	pn = b;
	while((p = mget(tag, pn, e, &amp;pn)) != 0) {
		if(n++)
			outchars(", ");
		us = 0;
		for(q = pn-1; q &gt;= p; q--)
			if(*q == '_') {
				us = q;
				break;
			}
		if(us) {
			/*
			 * Hack to fix cast list Himself/Herself
			 */
			if(strncmp(us+1, "Himself", 7) == 0 ||
			   strncmp(us+1, "Herself", 7) == 0) {
				outpiece(p, us);
				outchars(" (");
				outpiece(us+1, pn);
				outchar(')');
			} else {
				outpiece(us+1, pn);
				outchars(" (");
				outpiece(p, us);
				outchar(')');
			}
		} else {
			outpiece(p, pn);
		}
	}
}

/*
 * Starting from b, find next line beginning with tagtab[tag].
 * Don't go past e, but assume *e==0.
 * Return pointer to beginning of value (after tag), and set
 * eptr to point at newline that ends the value
 */
static char *
mget(int tag, char *b, char *e, char **eptr)
{
	char *p, *t, *ans;

	if(tag &lt; 0 || tag &gt;= NTAG)
		return 0;
	t = tagtab[tag];
	ans = 0;
	for(p = b;;) {
		p = strchr(p, '\n');
		if(!p || ++p &gt;= e) {
			if(ans)
				*eptr = e-1;
			break;
		}
		if(!ans) {
			if(p[0] == t[0] &amp;&amp; p[1] == t[1])
				ans = p+3;
		} else {
			if(p[0] != ' ') {
				*eptr = p-1;
				break;
			}
		}
	}
	return ans;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

