<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/cdrdwr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/cdrdwr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;

#include "iso9660.h"

static int readisodesc(Cdimg*, Voldesc*);
static int readjolietdesc(Cdimg*, Voldesc*);

/*
 * It's not strictly conforming; instead it's enough to
 * get us up and running; presumably the real CD writing
 * will take care of being conforming.
 *
 * Things not conforming include:
 *	- no path table
 *	- root directories are of length zero
 */
Cdimg*
createcd(char *file, Cdinfo info)
{
	int fd, xfd;
	Cdimg *cd;

	if(access(file, AEXIST) == 0){
		werrstr("file already exists");
		return nil;
	}

	if((fd = create(file, ORDWR, 0666)) &lt; 0)
		return nil;

	cd = emalloc(sizeof *cd);
	cd-&gt;file = atom(file);

	Binit(&amp;cd-&gt;brd, fd, OREAD);

	if((xfd = open(file, ORDWR)) &lt; 0)
		sysfatal("can't open file again: %r");
	Binit(&amp;cd-&gt;bwr, xfd, OWRITE);

	Crepeat(cd, 0, 16*Blocksize);
	Cputisopvd(cd, info);
	if(info.flags &amp; CDbootable){
		cd-&gt;bootimage = info.bootimage;
		cd-&gt;loader = info.loader;
		cd-&gt;flags |= info.flags &amp; (CDbootable|CDbootnoemu);
		Cputbootvol(cd);
	}

	if(readisodesc(cd, &amp;cd-&gt;iso) &lt; 0)
		assert(0);
	if(info.flags &amp; CDplan9)
		cd-&gt;flags |= CDplan9;
	else if(info.flags &amp; CDrockridge)
		cd-&gt;flags |= CDrockridge;
	if(info.flags &amp; CDjoliet) {
		Cputjolietsvd(cd, info);
		if(readjolietdesc(cd, &amp;cd-&gt;joliet) &lt; 0)
			assert(0);
		cd-&gt;flags |= CDjoliet;
	}
	Cputendvd(cd);

	if(info.flags &amp; CDdump){
		cd-&gt;nulldump = Cputdumpblock(cd);
		cd-&gt;flags |= CDdump;
	}
	if(cd-&gt;flags &amp; CDbootable){
		Cputbootcat(cd);
		Cupdatebootvol(cd);
	}

	if(info.flags &amp; CDconform)
		cd-&gt;flags |= CDconform;

	cd-&gt;flags |= CDnew;
	cd-&gt;nextblock = Cwoffset(cd) / Blocksize;
	assert(cd-&gt;nextblock != 0);

	return cd;
}

Cdimg*
opencd(char *file, Cdinfo info)
{
	int fd, xfd;
	Cdimg *cd;
	Dir *d;

	if((fd = open(file, ORDWR)) &lt; 0) {
		if(access(file, AEXIST) == 0)
			return nil;
		return createcd(file, info);
	}

	if((d = dirfstat(fd)) == nil) {
		close(fd);
		return nil;
	}
	if(d-&gt;length == 0 || d-&gt;length % Blocksize) {
		werrstr("bad length %lld", d-&gt;length);
		close(fd);
		free(d);
		return nil;
	}

	cd = emalloc(sizeof *cd);
	cd-&gt;file = atom(file);
	cd-&gt;nextblock = d-&gt;length / Blocksize;
	assert(cd-&gt;nextblock != 0);
	free(d);

	Binit(&amp;cd-&gt;brd, fd, OREAD);

	if((xfd = open(file, ORDWR)) &lt; 0)
		sysfatal("can't open file again: %r");
	Binit(&amp;cd-&gt;bwr, xfd, OWRITE);

	if(readisodesc(cd, &amp;cd-&gt;iso) &lt; 0) {
		free(cd);
		close(fd);
		close(xfd);
		return nil;
	}

	/* lowercase because of isostring */
	if(strstr(cd-&gt;iso.systemid, "iso9660") == nil 
	&amp;&amp; strstr(cd-&gt;iso.systemid, "utf8") == nil) {
		werrstr("unknown systemid %s", cd-&gt;iso.systemid);
		free(cd);
		close(fd);
		close(xfd);
		return nil;
	}
	
	if(strstr(cd-&gt;iso.systemid, "plan 9"))
		cd-&gt;flags |= CDplan9;
	if(strstr(cd-&gt;iso.systemid, "iso9660"))
		cd-&gt;flags |= CDconform;
	if(strstr(cd-&gt;iso.systemid, "rrip"))
		cd-&gt;flags |= CDrockridge;
	if(strstr(cd-&gt;iso.systemid, "boot"))
		cd-&gt;flags |= CDbootable;
	if(readjolietdesc(cd, &amp;cd-&gt;joliet) == 0)
		cd-&gt;flags |= CDjoliet;
	if(hasdump(cd))
		cd-&gt;flags |= CDdump;

	return cd;
}

ulong
big(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v = (v&lt;&lt;8) | *p++;
	return v;
}

ulong
little(void *a, int n)
{
	uchar *p;
	ulong v;
	int i;

	p = a;
	v = 0;
	for(i=0; i&lt;n; i++)
		v |= (*p++&lt;&lt;(i*8));
	return v;
}

void
Creadblock(Cdimg *cd, void *buf, ulong block, ulong len)
{
	assert(block != 0);	/* nothing useful there */

	Bflush(&amp;cd-&gt;bwr);
	if(Bseek(&amp;cd-&gt;brd, (vlong)block * Blocksize, 0) !=
	    (vlong)block * Blocksize)
		sysfatal("error seeking to block %lud", block);
	if(Bread(&amp;cd-&gt;brd, buf, len) != len)
		sysfatal("error reading %lud bytes at block %lud: %r %lld",
			len, block, Bseek(&amp;cd-&gt;brd, 0, 2));
}

int
parsedir(Cdimg *cd, Direc *d, uchar *buf, int len, char *(*cvtname)(uchar*, int))
{
	enum { NAMELEN = 28 };
	char name[NAMELEN];
	uchar *p;
	Cdir *c;

	memset(d, 0, sizeof *d);

	c = (Cdir*)buf;

	if(c-&gt;len &gt; len) {
		werrstr("buffer too small");
		return -1;
	}

	if(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\0')
		d-&gt;name = atom(".");
	else if(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\001')
		d-&gt;name = atom("..");
	else if(cvtname)
		d-&gt;name = cvtname(c-&gt;name, c-&gt;namelen);

	d-&gt;block = little(c-&gt;dloc, 4);
	d-&gt;length = little(c-&gt;dlen, 4);

	if(c-&gt;flags &amp; 2)
		d-&gt;mode |= DMDIR;

/*BUG: do we really need to parse the plan 9 fields? */
	/* plan 9 use fields */
	if((cd-&gt;flags &amp; CDplan9) &amp;&amp; cvtname == isostring
	&amp;&amp; (c-&gt;namelen != 1 || c-&gt;name[0] &gt; 1)) {
		p = buf+33+c-&gt;namelen;
		if((p-buf)&amp;1)
			p++;
		assert(p &lt; buf+c-&gt;len);
		assert(*p &lt; NAMELEN);
		if(*p != 0) {
			memmove(name, p+1, *p);
			name[*p] = '\0';
			d-&gt;confname = d-&gt;name;
			d-&gt;name = atom(name);
		}
		p += *p+1;
		assert(*p &lt; NAMELEN);
		memmove(name, p+1, *p);
		name[*p] = '\0';
		d-&gt;uid = atom(name);
		p += *p+1;
		assert(*p &lt; NAMELEN);
		memmove(name, p+1, *p);
		name[*p] = '\0';
		d-&gt;gid = atom(name);
		p += *p+1;
		if((p-buf)&amp;1)
			p++;
		d-&gt;mode = little(p, 4);
	}

	// BUG: rock ridge extensions
	return 0;
}

void
setroot(Cdimg *cd, ulong block, ulong dloc, ulong dlen)
{
	assert(block != 0);

	Cwseek(cd, (vlong)block * Blocksize + offsetof(Cvoldesc, rootdir[0]) +
		offsetof(Cdir, dloc[0]));
	Cputn(cd, dloc, 4);
	Cputn(cd, dlen, 4);
}

void
setvolsize(Cdimg *cd, uvlong block, ulong size)
{
	assert(block != 0);

	Cwseek(cd, block * Blocksize + offsetof(Cvoldesc, volsize[0]));
	Cputn(cd, size, 4);			/* size in blocks */
}

void
setpathtable(Cdimg *cd, ulong block, ulong sz, ulong lloc, ulong bloc)
{
	assert(block != 0);

	Cwseek(cd, (vlong)block * Blocksize + offsetof(Cvoldesc, pathsize[0]));
	Cputn(cd, sz, 4);
	Cputnl(cd, lloc, 4);
	Cputnl(cd, 0, 4);
	Cputnm(cd, bloc, 4);
	Cputnm(cd, 0, 4);
	assert(Cwoffset(cd) == (vlong)block * Blocksize +
		offsetof(Cvoldesc, rootdir[0]));
}


static void
parsedesc(Voldesc *v, Cvoldesc *cv, char *(*string)(uchar*, int))
{
	v-&gt;systemid = string(cv-&gt;systemid, sizeof cv-&gt;systemid);

	v-&gt;pathsize = little(cv-&gt;pathsize, 4);
	v-&gt;lpathloc = little(cv-&gt;lpathloc, 4);
	v-&gt;mpathloc = little(cv-&gt;mpathloc, 4);

	v-&gt;volumeset = string(cv-&gt;volumeset, sizeof cv-&gt;volumeset);
	v-&gt;publisher = string(cv-&gt;publisher, sizeof cv-&gt;publisher);
	v-&gt;preparer = string(cv-&gt;preparer, sizeof cv-&gt;preparer);
	v-&gt;application = string(cv-&gt;application, sizeof cv-&gt;application);

	v-&gt;abstract = string(cv-&gt;abstract, sizeof cv-&gt;abstract);
	v-&gt;biblio = string(cv-&gt;biblio, sizeof cv-&gt;biblio);
	v-&gt;notice = string(cv-&gt;notice, sizeof cv-&gt;notice);
}
	
static int
readisodesc(Cdimg *cd, Voldesc *v)
{
	static uchar magic[] = { 0x01, 'C', 'D', '0', '0', '1', 0x01, 0x00 };
	Cvoldesc cv;

	memset(v, 0, sizeof *v);

	Creadblock(cd, &amp;cv, 16, sizeof cv);
	if(memcmp(cv.magic, magic, sizeof magic) != 0) {
		werrstr("bad pvd magic");
		return -1;
	}

	if(little(cv.blocksize, 2) != Blocksize) {
		werrstr("block size not %d", Blocksize);
		return -1;
	}

	cd-&gt;iso9660pvd = 16;
	parsedesc(v, &amp;cv, isostring);

	return parsedir(cd, &amp;v-&gt;root, cv.rootdir, sizeof cv.rootdir, isostring);
}

static int
readjolietdesc(Cdimg *cd, Voldesc *v)
{
	int i;
	static uchar magic[] = { 0x02, 'C', 'D', '0', '0', '1', 0x01, 0x00 };
	Cvoldesc cv;

	memset(v, 0, sizeof *v);

	for(i=16; i&lt;24; i++) {
		Creadblock(cd, &amp;cv, i, sizeof cv);
		if(memcmp(cv.magic, magic, sizeof magic) != 0)
			continue;
		if(cv.charset[0] != 0x25 || cv.charset[1] != 0x2F
		|| (cv.charset[2] != 0x40 &amp;&amp; cv.charset[2] != 0x43 &amp;&amp; cv.charset[2] != 0x45))
			continue;
		break;
	}

	if(i==24) {
		werrstr("could not find Joliet SVD");
		return -1;
	}

	if(little(cv.blocksize, 2) != Blocksize) {
		werrstr("block size not %d", Blocksize);
		return -1;
	}

	cd-&gt;jolietsvd = i;
	parsedesc(v, &amp;cv, jolietstring);

	return parsedir(cd, &amp;v-&gt;root, cv.rootdir, sizeof cv.rootdir, jolietstring);
}

/*
 * CD image buffering routines.
 */
void
Cputc(Cdimg *cd, int c)
{
	assert(Boffset(&amp;cd-&gt;bwr) &gt;= 16*Blocksize || c == 0);

if(Boffset(&amp;cd-&gt;bwr) == 0x9962)
if(c &gt;= 256) abort();
	if(Bputc(&amp;cd-&gt;bwr, c) &lt; 0)
		sysfatal("Bputc: %r");
	Bflush(&amp;cd-&gt;brd);
}

void
Cputnl(Cdimg *cd, uvlong val, int size)
{
	switch(size) {
	default:
		sysfatal("bad size %d in Cputnl", size);
	case 2:
		if(val &gt;= (1&lt;&lt;16))
			sysfatal("value %llud too big for size %d in Cputnl",
				val, size);
		Cputc(cd, val);
		Cputc(cd, val&gt;&gt;8);
		break;
	case 4:
		if(val &gt;= (1ULL&lt;&lt;32))
			sysfatal("value %llud too big for size %d in Cputnl",
				val, size);
		Cputc(cd, val);
		Cputc(cd, val&gt;&gt;8);
		Cputc(cd, val&gt;&gt;16);
		Cputc(cd, val&gt;&gt;24);
		break;
	case 8:
		Cputc(cd, val);
		Cputc(cd, val&gt;&gt;8);
		Cputc(cd, val&gt;&gt;16);
		Cputc(cd, val&gt;&gt;24);
		Cputc(cd, val&gt;&gt;32);
		Cputc(cd, val&gt;&gt;40);
		Cputc(cd, val&gt;&gt;48);
		Cputc(cd, val&gt;&gt;56);
		break;
	}
}

void
Cputnm(Cdimg *cd, uvlong val, int size)
{
	switch(size) {
	default:
		sysfatal("bad size %d in Cputnm", size);
	case 2:
		if(val &gt;= (1&lt;&lt;16))
			sysfatal("value %llud too big for size %d in Cputnl",
				val, size);
		Cputc(cd, val&gt;&gt;8);
		Cputc(cd, val);
		break;
	case 4:
		if(val &gt;= (1ULL&lt;&lt;32))
			sysfatal("value %llud too big for size %d in Cputnl",
				val, size);
		Cputc(cd, val&gt;&gt;24);
		Cputc(cd, val&gt;&gt;16);
		Cputc(cd, val&gt;&gt;8);
		Cputc(cd, val);
		break;
	case 8:
		Cputc(cd, val&gt;&gt;56);
		Cputc(cd, val&gt;&gt;48);
		Cputc(cd, val&gt;&gt;40);
		Cputc(cd, val&gt;&gt;32);
		Cputc(cd, val&gt;&gt;24);
		Cputc(cd, val&gt;&gt;16);
		Cputc(cd, val&gt;&gt;8);
		Cputc(cd, val);
		break;
	}
}

void
Cputn(Cdimg *cd, uvlong val, int size)
{
	Cputnl(cd, val, size);
	Cputnm(cd, val, size);
}

/*
 * ASCII/UTF string writing
 */
void
Crepeat(Cdimg *cd, int c, int n)
{
	while(n-- &gt; 0)
		Cputc(cd, c);
}

void
Cputs(Cdimg *cd, char *s, int size)
{
	int n;

	if(s == nil) {
		Crepeat(cd, ' ', size);
		return;
	}

	for(n=0; n&lt;size &amp;&amp; *s; n++)
		Cputc(cd, *s++);
	if(n&lt;size)
		Crepeat(cd, ' ', size-n);
}

void
Cwrite(Cdimg *cd, void *buf, int n)
{
	assert(Boffset(&amp;cd-&gt;bwr) &gt;= 16*Blocksize);

	if(Bwrite(&amp;cd-&gt;bwr, buf, n) != n)
		sysfatal("Bwrite: %r");
	Bflush(&amp;cd-&gt;brd);
}

void
Cputr(Cdimg *cd, Rune r)
{
	Cputc(cd, r&gt;&gt;8);
	Cputc(cd, r);
}

void
Crepeatr(Cdimg *cd, Rune r, int n)
{
	int i;

	for(i=0; i&lt;n; i++)
		Cputr(cd, r);
}

void
Cputrs(Cdimg *cd, Rune *s, int osize)
{
	int n, size;

	size = osize/2;
	if(s == nil)
		Crepeatr(cd, (Rune)' ', size);
	else {
		for(n=0; *s &amp;&amp; n&lt;size; n++)
			Cputr(cd, *s++);
		if(n&lt;size)
			Crepeatr(cd, ' ', size-n);
	}
	if(osize&amp;1)
		Cputc(cd, 0);	/* what else can we do? */
}

void
Cputrscvt(Cdimg *cd, char *s, int size)
{
	Rune r[256];

	strtorune(r, s);
	Cputrs(cd, strtorune(r, s), size);
}

void
Cpadblock(Cdimg *cd)
{
	int n;
	ulong nb;

	n = Blocksize - (Boffset(&amp;cd-&gt;bwr) % Blocksize);
	if(n != Blocksize)
		Crepeat(cd, 0, n);

	nb = Boffset(&amp;cd-&gt;bwr)/Blocksize;
	assert(nb != 0);
	if(nb &gt; cd-&gt;nextblock)
		cd-&gt;nextblock = nb;
}

void
Cputdate(Cdimg *cd, ulong ust)
{
	Tm *tm;

	if(ust == 0) {
		Crepeat(cd, 0, 7);
		return;
	}
	tm = gmtime(ust);
	Cputc(cd, tm-&gt;year);
	Cputc(cd, tm-&gt;mon+1);
	Cputc(cd, tm-&gt;mday);
	Cputc(cd, tm-&gt;hour);
	Cputc(cd, tm-&gt;min);
	Cputc(cd, tm-&gt;sec);
	Cputc(cd, 0);
}

void
Cputdate1(Cdimg *cd, ulong ust)
{
	Tm *tm;
	char str[20];

	if(ust == 0) {
		Crepeat(cd, '0', 16);
		Cputc(cd, 0);
		return;
	}
	tm = gmtime(ust);
	sprint(str, "%.4d%.2d%.2d%.2d%.2d%.4d",
		tm-&gt;year+1900,
		tm-&gt;mon+1,
		tm-&gt;mday,
		tm-&gt;hour,
		tm-&gt;min,
		tm-&gt;sec*100);
	Cputs(cd, str, 16);
	Cputc(cd, 0);
}

void
Cwseek(Cdimg *cd, vlong offset)
{
	Bseek(&amp;cd-&gt;bwr, offset, 0);
}

uvlong
Cwoffset(Cdimg *cd)
{
	return Boffset(&amp;cd-&gt;bwr);
}

void
Cwflush(Cdimg *cd)
{
	Bflush(&amp;cd-&gt;bwr);
}

uvlong
Croffset(Cdimg *cd)
{
	return Boffset(&amp;cd-&gt;brd);
}

void
Crseek(Cdimg *cd, vlong offset)
{
	Bseek(&amp;cd-&gt;brd, offset, 0);
}

int
Cgetc(Cdimg *cd)
{
	int c;

	Cwflush(cd);
	if((c = Bgetc(&amp;cd-&gt;brd)) == Beof) {
		fprint(2, "getc at %llud\n", Croffset(cd));
		assert(0);
		//sysfatal("Bgetc: %r");
	}
	return c;
}

void
Cread(Cdimg *cd, void *buf, int n)
{
	Cwflush(cd);
	if(Bread(&amp;cd-&gt;brd, buf, n) != n)
		sysfatal("Bread: %r");
}

char*
Crdline(Cdimg *cd, int c)
{
	Cwflush(cd);
	return Brdline(&amp;cd-&gt;brd, c);
}

int
Clinelen(Cdimg *cd)
{
	return Blinelen(&amp;cd-&gt;brd);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

