<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/conform.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/conform.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ctype.h&gt;
#include "iso9660.h"

/*
 * We keep an array sorted by bad atom pointer.
 * The theory is that since we don't free memory very often,
 * the array will be mostly sorted already and insertions will
 * usually be near the end, so we won't spend much time
 * keeping it sorted.
 */

/*
 * Binary search a Tx list.
 * If no entry is found, return a pointer to
 * where a new such entry would go.
 */
static Tx*
txsearch(char *atom, Tx *t, int n)
{
	while(n &gt; 0) {
		if(atom &lt; t[n/2].bad)
			n = n/2;
		else if(atom &gt; t[n/2].bad) {
			t += n/2+1;
			n -= (n/2+1);
		} else
			return &amp;t[n/2];
	}
	return t;
}

void
addtx(char *b, char *g)
{
	Tx *t;
	Conform *c;

	if(map == nil)
		map = emalloc(sizeof(*map));
	c = map;

	if(c-&gt;nt%32 == 0)
		c-&gt;t = erealloc(c-&gt;t, (c-&gt;nt+32)*sizeof(c-&gt;t[0]));
	t = txsearch(b, c-&gt;t, c-&gt;nt);
	if(t &lt; c-&gt;t+c-&gt;nt &amp;&amp; t-&gt;bad == b) {
		fprint(2, "warning: duplicate entry for %s in _conform.map\n", b);
		return;
	}

	if(t != c-&gt;t+c-&gt;nt)
		memmove(t+1, t, (c-&gt;t+c-&gt;nt - t)*sizeof(Tx));
	t-&gt;bad = b;
	t-&gt;good = g;
	c-&gt;nt++;
}

char*
conform(char *s, int isdir)
{
	Tx *t;
	char buf[10], *g;
	Conform *c;

	c = map;
	s = atom(s);
	if(c){
		t = txsearch(s, c-&gt;t, c-&gt;nt);
		if(t &lt; c-&gt;t+c-&gt;nt &amp;&amp; t-&gt;bad == s)
			return t-&gt;good;
	}

	sprint(buf, "%c%.6d", isdir ? 'D' : 'F', c ? c-&gt;nt : 0);
	g = atom(buf);
	addtx(s, g);
	return g;
}

#ifdef NOTUSED
static int
isalldigit(char *s)
{
	while(*s)
		if(!isdigit(*s++))
			return 0;
	return 1;
}
#endif

static int
goodcmp(const void *va, const void *vb)
{
	Tx *a, *b;

	a = (Tx*)va;
	b = (Tx*)vb;
	return strcmp(a-&gt;good, b-&gt;good);
}

static int
badatomcmp(const void *va, const void *vb)
{
	Tx *a, *b;

	a = (Tx*)va;
	b = (Tx*)vb;
	if(a-&gt;good &lt; b-&gt;good)
		return -1;
	if(a-&gt;good &gt; b-&gt;good)
		return 1;
	return 0;
}

void
wrconform(Cdimg *cd, int n, ulong *pblock, uvlong *plength)
{
	char buf[1024];
	int i;
	Conform *c;

	c = map;
	*pblock = cd-&gt;nextblock;
	if(c==nil || n==c-&gt;nt){
		*plength = 0;
		return;
	}

	Cwseek(cd, (vlong)cd-&gt;nextblock * Blocksize);
	qsort(c-&gt;t, c-&gt;nt, sizeof(c-&gt;t[0]), goodcmp);
	for(i=n; i&lt;c-&gt;nt; i++) {
		snprint(buf, sizeof buf, "%s %s\n", c-&gt;t[i].good, c-&gt;t[i].bad);
		Cwrite(cd, buf, strlen(buf));
	}
	qsort(c-&gt;t, c-&gt;nt, sizeof(c-&gt;t[0]), badatomcmp);
	*plength = Cwoffset(cd) - (vlong)*pblock * Blocksize;
	chat("write _conform.map at %lud+%llud\n", *pblock, *plength);
	Cpadblock(cd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

