<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/direc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/direc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;

#include "iso9660.h"

void
mkdirec(Direc *direc, XDir *d)
{
	memset(direc, 0, sizeof(Direc));
	direc-&gt;name = atom(d-&gt;name);
	direc-&gt;uid = atom(d-&gt;uid);
	direc-&gt;gid = atom(d-&gt;gid);
	direc-&gt;uidno = d-&gt;uidno;
	direc-&gt;gidno = d-&gt;gidno;
	direc-&gt;mode = d-&gt;mode;
	direc-&gt;length = d-&gt;length;
	direc-&gt;mtime = d-&gt;mtime;
	direc-&gt;atime = d-&gt;atime;
	direc-&gt;ctime = d-&gt;ctime;
	direc-&gt;symlink = d-&gt;symlink;
}

static int
strecmp(char *a, char *ea, char *b)
{
	int r;

	if((r = strncmp(a, b, ea-a)) != 0)
		return r;

	if(b[ea-a] == '\0')
		return 0;
	return 1;
}

/*
 * Binary search a list of directories for the
 * entry with name name.
 * If no entry is found, return a pointer to
 * where a new such entry would go.
 */
static Direc*
dbsearch(char *name, int nname, Direc *d, int n)
{
	int i;

	while(n &gt; 0) {
		i = strecmp(name, name+nname, d[n/2].name);
		if(i &lt; 0)
			n = n/2;
		else if(i &gt; 0) {
			d += n/2+1;
			n -= (n/2+1);
		} else
			return &amp;d[n/2];
	}
	return d;
}

/*
 * Walk to name, starting at d.
 */
Direc*
walkdirec(Direc *d, char *name)
{
	char *p, *nextp, *slashp;
	Direc *nd;

	for(p=name; p &amp;&amp; *p; p=nextp) {
		if((slashp = strchr(p, '/')) != nil)
			nextp = slashp+1;
		else
			nextp = slashp = p+strlen(p);

		nd = dbsearch(p, slashp-p, d-&gt;child, d-&gt;nchild);
		if(nd &gt;= d-&gt;child+d-&gt;nchild || strecmp(p, slashp, nd-&gt;name) != 0)
			return nil;
		d = nd;
	}
	return d;
}

/*
 * Add the file ``name'' with attributes d to the
 * directory ``root''.  Name may contain multiple
 * elements; all but the last must exist already.
 * 
 * The child lists are kept sorted by utfname.
 */	
Direc*
adddirec(Direc *root, char *name, XDir *d)
{
	char *p;
	Direc *nd;
	int off;

	if(name[0] == '/')
		name++;
	if((p = strrchr(name, '/')) != nil) {
		*p = '\0';
		root = walkdirec(root, name);
		if(root == nil) {
			sysfatal("error in proto file: no entry for /%s but /%s/%s", name, name, p+1);
			return nil;
		}
		*p = '/';
		p++;
	} else
		p = name;

	nd = dbsearch(p, strlen(p), root-&gt;child, root-&gt;nchild);
	off = nd - root-&gt;child;
	if(off &lt; root-&gt;nchild &amp;&amp; strcmp(nd-&gt;name, p) == 0) {
		if ((d-&gt;mode &amp; DMDIR) == 0)
			fprint(2, "warning: proto lists %s twice\n", name);
		return nil;
	}

	if(root-&gt;nchild%Ndirblock == 0) {
		root-&gt;child = erealloc(root-&gt;child, (root-&gt;nchild+Ndirblock)*sizeof(Direc));
		nd = root-&gt;child + off;
	}

	memmove(nd+1, nd, (root-&gt;nchild - off)*sizeof(Direc));
	mkdirec(nd, d);
	nd-&gt;name = atom(p);
	root-&gt;nchild++;
	return nd;
}

/* 
 * Copy the tree src into dst.
 */
void
copydirec(Direc *dst, Direc *src)
{
	int i, n;

	*dst = *src;

	if((src-&gt;mode &amp; DMDIR) == 0)
		return;

	n = (src-&gt;nchild + Ndirblock - 1);
	n -= n%Ndirblock;
	dst-&gt;child = emalloc(n*sizeof(Direc));

	n = dst-&gt;nchild;
	for(i=0; i&lt;n; i++)
		copydirec(&amp;dst-&gt;child[i], &amp;src-&gt;child[i]);
}

/*
 * Turn the Dbadname flag on for any entries
 * that have non-conforming names.
 */
static void
_checknames(Direc *d, int (*isbadname)(char*), int isroot)
{
	int i;

	if(!isroot &amp;&amp; isbadname(d-&gt;name))
		d-&gt;flags |= Dbadname;

	if(strcmp(d-&gt;name, "_conform.map") == 0)
		d-&gt;flags |= Dbadname;

	for(i=0; i&lt;d-&gt;nchild; i++)
		_checknames(&amp;d-&gt;child[i], isbadname, 0);
}

void
checknames(Direc *d, int (*isbadname)(char*))
{
	_checknames(d, isbadname, 1);
}

/*
 * Set the names to conform to 8.3
 * by changing them to numbers.
 * Plan 9 gets the right names from its
 * own directory entry.
 *
 * We used to write a _conform.map file to translate
 * names.  Joliet should take care of most of the
 * interoperability with other systems now.
 */
void
convertnames(Direc *d, char* (*cvt)(char*, char*))
{
	int i;
	char new[1024];

	if(d-&gt;flags &amp; Dbadname)
		cvt(new, conform(d-&gt;name, d-&gt;mode &amp; DMDIR));
	else
		cvt(new, d-&gt;name);
	d-&gt;confname = atom(new);

	for(i=0; i&lt;d-&gt;nchild; i++)
		convertnames(&amp;d-&gt;child[i], cvt);
}

/*
 * Sort a directory with a given comparison function.
 * After this is called on a tree, adddirec should not be,
 * since the entries may no longer be sorted as adddirec expects.
 */
void
dsort(Direc *d, int (*cmp)(const void*, const void*))
{
	int i, n;

	n = d-&gt;nchild;
	qsort(d-&gt;child, n, sizeof(d[0]), cmp);

	for(i=0; i&lt;n; i++)
		dsort(&amp;d-&gt;child[i], cmp);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

