<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/dump9660.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/dump9660.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;disk.h&gt;
#include &lt;libsec.h&gt;
#include "iso9660.h"

ulong now;
int chatty;
int doabort;
int docolon;
int mk9660;
vlong dataoffset;
int blocksize;
Conform *map;

static void addprotofile(char *new, char *old, Dir *d, void *a);
void usage(void);

char *argv0;

void
usage(void)
{
	if(mk9660)
		fprint(2, "usage: disk/mk9660 [-D:] [-9cjr] "
			"[-[bB] bootfile] [-o offset blocksize] "
			"[-p proto] [-s src] cdimage\n");
	else
		fprint(2, "usage: disk/dump9660 [-D:] [-9cjr] "
			"[-m maxsize] [-n now] "
			"[-p proto] [-s src] cdimage\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int fix;
	ulong block, newnull, cblock;
	vlong maxsize;
	uvlong length, clength;
	char buf[256], *dumpname, *proto, *s, *src, *status;
	Cdimg *cd;
	Cdinfo info;
	XDir dir;
	Direc *iconform, idumproot, iroot, *jconform, jdumproot, jroot, *r;
	Dump *dump;

	fix = 0;
	status = nil;
	memset(&amp;info, 0, sizeof info);
	proto = "/sys/lib/sysconfig/proto/allproto";
	src = "./";

	info.volumename = atom("9CD");
	info.volumeset = atom("9VolumeSet");
	info.publisher = atom("9Publisher");
	info.preparer = atom("dump9660");
	info.application = atom("dump9660");
	info.flags = CDdump;
	maxsize = 0;
	mk9660 = 0;
	fmtinstall('H', encodefmt);

	ARGBEGIN{
	case 'D':
		chatty++;
		break;
	case 'M':
		mk9660 = 1;
		argv0 = "disk/mk9660";
		info.flags &amp;= ~CDdump;
		break;
	case '9':
		info.flags |= CDplan9;
		break;
	case ':':
		docolon = 1;
		break;
	case 'a':
		doabort = 1;
		break;
	case 'B':
		info.flags |= CDbootnoemu;
		/* fall through */
	case 'b':
		if(!mk9660)
			usage();
		info.flags |= CDbootable;
		info.bootimage = EARGF(usage());
		break;
	case 'c':
		info.flags |= CDconform;
		break;
	case 'f':
		fix = 1;
		break;
	case 'j':
		info.flags |= CDjoliet;
		break;
	case 'n':
		now = atoi(EARGF(usage()));
		break;
	case 'm':
		maxsize = strtoull(EARGF(usage()), 0, 0);
		break;
	case 'o':
		dataoffset = atoll(EARGF(usage()));
		blocksize = atoi(EARGF(usage()));
		if(blocksize%Blocksize)
			sysfatal("bad block size %d -- must be multiple of 2048", blocksize);
		blocksize /= Blocksize;
		break;
	case 'p':
		proto = EARGF(usage());
		break;
	case 'r':
		info.flags |= CDrockridge;
		break;
	case 's':
		src = EARGF(usage());
		break;
	case 'v':
		info.volumename = atom(EARGF(usage()));
		break;
	case 'x':
		info.flags |= CDpbs;
		info.loader = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(info.flags &amp; CDpbs &amp;&amp; !(info.flags &amp; CDbootnoemu))
		usage();

	if(mk9660 &amp;&amp; (fix || now || maxsize))
		usage();

	if(argc != 1)
		usage();

	if(now == 0)
		now = (ulong)time(0);
	if(mk9660){
		if((cd = createcd(argv[0], info)) == nil)
			sysfatal("cannot create '%s': %r", argv[0]);
	}else{
		if((cd = opencd(argv[0], info)) == nil)
			sysfatal("cannot open '%s': %r", argv[0]);
		if(!(cd-&gt;flags &amp; CDdump))
			sysfatal("not a dump cd");
	}

	/* create ISO9660/Plan 9 tree in memory */
	memset(&amp;dir, 0, sizeof dir);
	dir.name = atom("");
	dir.uid = atom("sys");
	dir.gid = atom("sys");
	dir.uidno = 0;
	dir.gidno = 0;
	dir.mode = DMDIR | 0755;
	dir.mtime = now;
	dir.atime = now;
	dir.ctime = now;

	mkdirec(&amp;iroot, &amp;dir);
	iroot.srcfile = src;

	/*
	 * Read new files into memory
	 */
	if(rdproto(proto, src, addprotofile, nil, &amp;iroot) &lt; 0)
		sysfatal("rdproto: %r");

	if(mk9660){
		dump = emalloc(sizeof *dump);
		dumpname = nil;
	}else{
		/*
		 * Read current dump tree and _conform.map.
		 */
		idumproot = readdumpdirs(cd, &amp;dir, isostring);
		readdumpconform(cd);
		if(cd-&gt;flags &amp; CDjoliet)
			jdumproot = readdumpdirs(cd, &amp;dir, jolietstring);

		if(fix){
			dumpname = nil;
			cd-&gt;nextblock = cd-&gt;nulldump+1;
			cd-&gt;nulldump = 0;
			Cwseek(cd, (vlong)cd-&gt;nextblock * Blocksize);
			goto Dofix;
		}
	
		dumpname = adddumpdir(&amp;idumproot, now, &amp;dir);
		/* note that we assume all names are conforming and thus sorted */
		if(cd-&gt;flags &amp; CDjoliet) {
			s = adddumpdir(&amp;jdumproot, now, &amp;dir);
			if(s != dumpname)
				sysfatal("dumpnames don't match %s %s", dumpname, s);
		}
		dump = dumpcd(cd, &amp;idumproot);
		cd-&gt;nextblock = cd-&gt;nulldump+1;
	}

	/*
	 * Write new files, starting where the dump tree was.
 	 * Must be done before creation of the Joliet tree so that
 	 * blocks and lengths are correct.
	 */
	if(dataoffset &gt; (vlong)cd-&gt;nextblock * Blocksize)
		cd-&gt;nextblock = (dataoffset+Blocksize-1)/Blocksize;
	Cwseek(cd, (vlong)cd-&gt;nextblock * Blocksize);
	writefiles(dump, cd, &amp;iroot);

	if(cd-&gt;bootimage){
		findbootimage(cd, &amp;iroot);
		if(cd-&gt;loader)
			findloader(cd, &amp;iroot);
		Cupdatebootcat(cd);
	}

	/* create Joliet tree */
	if(cd-&gt;flags &amp; CDjoliet)
		copydirec(&amp;jroot, &amp;iroot);

	if(info.flags &amp; CDconform) {
		checknames(&amp;iroot, isbadiso9660);
		convertnames(&amp;iroot, struprcpy);
	} else
		convertnames(&amp;iroot, (void *) strcpy);

//	isoabstract = findconform(&amp;iroot, abstract);
//	isobiblio = findconform(&amp;iroot, biblio);
//	isonotice = findconform(&amp;iroot, notice);

	dsort(&amp;iroot, isocmp);

	if(cd-&gt;flags &amp; CDjoliet) {
	//	jabstract = findconform(&amp;jroot, abstract);
	//	jbiblio = findconform(&amp;jroot, biblio);
	//	jnotice = findconform(&amp;jroot, notice);

		checknames(&amp;jroot, isbadjoliet);
		convertnames(&amp;jroot, (void *) strcpy);
		dsort(&amp;jroot, jolietcmp);
	}

	/*
	 * Write directories.
	 */
	writedirs(cd, &amp;iroot, Cputisodir);
	if(cd-&gt;flags &amp; CDjoliet)
		writedirs(cd, &amp;jroot, Cputjolietdir);

	if(mk9660){
		cblock = 0;
		clength = 0;
		newnull = 0;
	}else{
		/*
		 * Write incremental _conform.map block.
		 */
		wrconform(cd, cd-&gt;nconform, &amp;cblock, &amp;clength);
	
		/* jump here if we're just fixing up the cd */
Dofix:
		/*
		 * Write null dump header block; everything after this will be 
		 * overwritten at the next dump.  Because of this, it needs to be
		 * reconstructable.  We reconstruct the _conform.map and dump trees
		 * from the header blocks in dump.c, and we reconstruct the path 
		 * tables by walking the cd.
		 */
		newnull = Cputdumpblock(cd);
	}
	if(info.flags &amp; CDpbs)
		Cfillpbs(cd);

	/*
	 * Write _conform.map.
	 */
	dir.mode = 0444;
	if(cd-&gt;flags &amp; (CDconform|CDjoliet)) {
		if(!mk9660 &amp;&amp; cd-&gt;nconform == 0){
			block = cblock;	
			length = clength;
		}else
			wrconform(cd, 0, &amp;block, &amp;length);

		if(mk9660) 
{
			idumproot = iroot;
			jdumproot = jroot;
		}
		if(length) {
			/* The ISO9660 name will get turned into uppercase when written. */
			if((iconform = walkdirec(&amp;idumproot, "_conform.map")) == nil)
				iconform = adddirec(&amp;idumproot, "_conform.map", &amp;dir);
			jconform = nil;
			if(cd-&gt;flags &amp; CDjoliet) {
				if((jconform = walkdirec(&amp;jdumproot, "_conform.map")) == nil)
					jconform = adddirec(&amp;jdumproot, "_conform.map", &amp;dir);
			}
			iconform-&gt;block = block;
			iconform-&gt;length = length;
			if(cd-&gt;flags &amp; CDjoliet) {
				jconform-&gt;block = block;
				jconform-&gt;length = length;
			}
		}
		if(mk9660) {
			iroot = idumproot;
			jroot = jdumproot;
		}
	}

	if(mk9660){
		/*
		 * Patch in root directories.
		 */
		setroot(cd, cd-&gt;iso9660pvd, iroot.block, iroot.length);
		setvolsize(cd, cd-&gt;iso9660pvd, cd-&gt;nextblock);
		if(cd-&gt;flags &amp; CDjoliet){
			setroot(cd, cd-&gt;jolietsvd, jroot.block, jroot.length);
			setvolsize(cd, cd-&gt;jolietsvd, cd-&gt;nextblock);
		}
	}else{
		/*
		 * Write dump tree at end.  We assume the name characters
		 * are all conforming, so everything is already sorted properly.
		 */
		convertnames(&amp;idumproot, (info.flags &amp; CDconform) ? (void *) struprcpy : (void *) strcpy);
		if(cd-&gt;nulldump) {
			r = walkdirec(&amp;idumproot, dumpname);
			assert(r != nil);
			copybutname(r, &amp;iroot);
		}
		if(cd-&gt;flags &amp; CDjoliet) {
			convertnames(&amp;jdumproot, (void *) strcpy);
			if(cd-&gt;nulldump) {
				r = walkdirec(&amp;jdumproot, dumpname);
				assert(r != nil);
				copybutname(r, &amp;jroot);
			}
		}
	
		writedumpdirs(cd, &amp;idumproot, Cputisodir);
		if(cd-&gt;flags &amp; CDjoliet)
			writedumpdirs(cd, &amp;jdumproot, Cputjolietdir);

		/*
		 * Patch in new root directory entry.
		 */
		setroot(cd, cd-&gt;iso9660pvd, idumproot.block, idumproot.length);
		setvolsize(cd, cd-&gt;iso9660pvd, cd-&gt;nextblock);
		if(cd-&gt;flags &amp; CDjoliet){
			setroot(cd, cd-&gt;jolietsvd, jdumproot.block, jdumproot.length);
			setvolsize(cd, cd-&gt;jolietsvd, cd-&gt;nextblock);
		}
	}
	writepathtables(cd);	

	if(!mk9660){
		/*
		 * If we've gotten too big, truncate back to what we started with,
		 * fix up the cd, and exit with a non-zero status.
		 */
		Cwflush(cd);
		if(cd-&gt;nulldump &amp;&amp; maxsize &amp;&amp; Cwoffset(cd) &gt; maxsize){
			fprint(2, "too big; writing old tree back\n");
			status = "cd too big; aborted";
	
			rmdumpdir(&amp;idumproot, dumpname);
			rmdumpdir(&amp;jdumproot, dumpname);
	
			cd-&gt;nextblock = cd-&gt;nulldump+1;
			cd-&gt;nulldump = 0;
			Cwseek(cd, (vlong)cd-&gt;nextblock * Blocksize);
			goto Dofix;
		}
	
		/*
		 * Write old null header block; this commits all our changes.
		 */
		if(cd-&gt;nulldump){
			Cwseek(cd, (vlong)cd-&gt;nulldump * Blocksize);
			sprint(buf, "plan 9 dump cd\n");
			sprint(buf+strlen(buf), "%s %lud %lud %lud %llud %lud %lud",
				dumpname, now, newnull, cblock, clength,
				iroot.block, iroot.length);
			if(cd-&gt;flags &amp; CDjoliet)
				sprint(buf+strlen(buf), " %lud %lud",
					jroot.block, jroot.length);
			strcat(buf, "\n");
			Cwrite(cd, buf, strlen(buf));
			Cpadblock(cd);
			Cwflush(cd);
		}
	}
	fdtruncate(cd-&gt;fd, (vlong)cd-&gt;nextblock * Blocksize);
	exits(status);
}

static void
addprotofile(char *new, char *old, Dir *d, void *a)
{
	char *name, *p;
	Direc *direc;
	XDir xd;

	dirtoxdir(&amp;xd, d);
	name = nil;
	if(docolon &amp;&amp; strchr(new, ':')) {
		name = emalloc(strlen(new)+1);
		strcpy(name, new);
		while((p=strchr(name, ':')))
			*p=' ';
		new = name;
	}
	if((direc = adddirec((Direc*)a, new, &amp;xd))) {
		direc-&gt;srcfile = atom(old);

		// BUG: abstract, biblio, notice
	}
	if(name)
		free(name);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

