<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/sysuse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/sysuse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * To understand this code, see Rock Ridge Interchange Protocol
 * standard 1.12 and System Use Sharing Protocol version 1.12
 * (search for rrip112.ps and susp112.ps on the web).
 *
 * Even better, go read something else.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;
#include "iso9660.h"

static long mode(Direc*, int);
static long nlink(Direc*);
static ulong suspdirflags(Direc*, int);
static ulong CputsuspCE(Cdimg *cd, vlong offset);
static int CputsuspER(Cdimg*, int);
static int CputsuspRR(Cdimg*, int, int);
static int CputsuspSP(Cdimg*, int);
//static int CputsuspST(Cdimg*, int);
static int Cputrripname(Cdimg*, char*, int, char*, int);
static int CputrripSL(Cdimg*, int, int, char*, int);
static int CputrripPX(Cdimg*, Direc*, int, int);
static int CputrripTF(Cdimg*, Direc*, int, int);

/*
 * Patch the length field in a CE record.
 */
static void
setcelen(Cdimg *cd, vlong woffset, ulong len)
{
	vlong o;

	o = Cwoffset(cd);
	Cwseek(cd, woffset);
	Cputn(cd, len, 4);
	Cwseek(cd, o);
}

/*
 * Rock Ridge data is put into little blockettes, which can be
 * at most 256 bytes including a one-byte length.  Some number
 * of blockettes get packed together into a normal 2048-byte block.
 * Blockettes cannot cross block boundaries. 
 *
 * A Cbuf is a blockette buffer.  Len contains 
 * the length of the buffer written so far, and we can
 * write up to 254-28.  
 *
 * We only have one active Cbuf at a time; cdimg.rrcontin is the byte
 * offset of the beginning of that Cbuf.
 *
 * The blockette can be at most 255 bytes.  The last 28
 * will be (in the worst case) a CE record pointing at
 * a new blockette.  If we do write 255 bytes though,
 * we'll try to pad it out to be even, and overflow.
 * So the maximum is 254-28.
 *
 * Ceoffset contains the offset to be used with setcelen
 * to patch the CE pointing at the Cbuf once we know how
 * long the Cbuf is.
 */
typedef struct Cbuf Cbuf;
struct Cbuf {
	int	len;		/* written so far, of 254-28 */
	uvlong	ceoffset;
};

static int
freespace(Cbuf *cp)
{
	return (254-28) - cp-&gt;len;
}

static Cbuf*
ensurespace(Cdimg *cd, int n, Cbuf *co, Cbuf *cn, int dowrite)
{
	uvlong end;

	if(co-&gt;len+n &lt;= 254-28) {
		co-&gt;len += n;
		return co;
	}

	co-&gt;len += 28;
	assert(co-&gt;len &lt;= 254);

	if(dowrite == 0) {
		cn-&gt;len = n;
		return cn;
	}

	/*
	 * the current blockette is full; update cd-&gt;rrcontin and then
 	 * write a CE record to finish it.  Unfortunately we need to 
	 * figure out which block will be next before we write the CE.
	 */
	end = Cwoffset(cd)+28;

	/*
	 * if we're in a continuation blockette, update rrcontin.
	 * also, write our length into the field of the CE record
	 * that points at us.
	 */
	if(cd-&gt;rrcontin+co-&gt;len == end) {
		assert(cd-&gt;rrcontin != 0);
		assert(co == cn);
		cd-&gt;rrcontin += co-&gt;len;
		setcelen(cd, co-&gt;ceoffset, co-&gt;len);
	} else
		assert(co != cn);

	/*
	 * if the current continuation block can't fit another
	 * blockette, then start a new continuation block.
	 * rrcontin = 0 (mod Blocksize) means we just finished
	 * one, not that we've just started one.
	 */
	if(cd-&gt;rrcontin%Blocksize == 0
	|| cd-&gt;rrcontin/Blocksize != (cd-&gt;rrcontin+256)/Blocksize) {
		cd-&gt;rrcontin = (vlong)cd-&gt;nextblock * Blocksize;
		cd-&gt;nextblock++;
	}

	cn-&gt;ceoffset = CputsuspCE(cd, cd-&gt;rrcontin);

	assert(Cwoffset(cd) == end);

	cn-&gt;len = n;
	Cwseek(cd, cd-&gt;rrcontin);
	assert(cd-&gt;rrcontin != 0);

	return cn;
}
	
/*
 * Put down the name, but we might need to break it
 * into chunks so that each chunk fits in 254-28-5 bytes.
 * What a crock.
 *
 * The new Plan 9 format uses strings of this form too, 
 * since they're already there.
 */
Cbuf*
Cputstring(Cdimg *cd, Cbuf *cp, Cbuf *cn, char *nm, char *p, int flags, int dowrite)
{
	char buf[256], *q;
	int free;

	for(; p[0] != '\0'; p = q) {
		cp = ensurespace(cd, 5+1, cp, cn, dowrite);
		cp-&gt;len -= 5+1;
		free = freespace(cp);
		assert(5+1 &lt;= free &amp;&amp; free &lt; 256);

		strncpy(buf, p, free-5);
		buf[free-5] = '\0';
		q = p+strlen(buf);
		p = buf;

		ensurespace(cd, 5+strlen(p), cp, nil, dowrite);	/* nil: better not use this. */
		Cputrripname(cd, nm, flags | (q[0] ? NMcontinue : 0), p, dowrite);
	}
	return cp;
}

/*
 * Write a Rock Ridge SUSP set of records for a directory entry.
 */
int
Cputsysuse(Cdimg *cd, Direc *d, int dot, int dowrite, int initlen)
{
	char buf[256], buf0[256], *nextpath, *p, *path, *q;
	int flags, free, m, what;
	uvlong o;
	Cbuf cn, co, *cp;

	assert(cd != nil);
	assert((initlen&amp;1) == 0);

	if(dot == DTroot)
		return 0;

	co.len = initlen;

	o = Cwoffset(cd);

	assert(dowrite==0 || Cwoffset(cd) == o+co.len-initlen);
	cp = &amp;co;

	if (dot == DTrootdot) {
		m = CputsuspSP(cd, 0);
		cp = ensurespace(cd, m, cp, &amp;cn, dowrite);
		CputsuspSP(cd, dowrite);

		m = CputsuspER(cd, 0);
		cp = ensurespace(cd, m, cp, &amp;cn, dowrite);
		CputsuspER(cd, dowrite);
	}

	/*
	 * In a perfect world, we'd be able to omit the NM
	 * entries when our name was all lowercase and conformant,
	 * but OpenBSD insists on uppercasing (really, not lowercasing)
	 * the ISO9660 names.
	 */
	what = RR_PX | RR_TF | RR_NM;
	if(d != nil &amp;&amp; (d-&gt;mode &amp; CHLINK))
		what |= RR_SL;

	m = CputsuspRR(cd, what, 0);
	cp = ensurespace(cd, m, cp, &amp;cn, dowrite);	
	CputsuspRR(cd, what, dowrite);

	if(what &amp; RR_PX) {
		m = CputrripPX(cd, d, dot, 0);
		cp = ensurespace(cd, m, cp, &amp;cn, dowrite);
		CputrripPX(cd, d, dot, dowrite);
	}

	if(what &amp; RR_NM) {
		if(dot == DTiden)
			p = d-&gt;name;
		else if(dot == DTdotdot)
			p = "..";
		else
			p = ".";

		flags = suspdirflags(d, dot);
		assert(dowrite==0 || cp != &amp;co || Cwoffset(cd) == o+co.len-initlen);
		cp = Cputstring(cd, cp, &amp;cn, "NM", p, flags, dowrite);
	}

	/*
	 * Put down the symbolic link.  This is even more of a crock.
	 * Not only are the individual elements potentially split, 
	 * but the whole path itself can be split across SL blocks.
	 * To keep the code simple as possible (really), we write
	 * only one element per SL block, wasting 6 bytes per element.
	 */
	if(what &amp; RR_SL) {
		for(path=d-&gt;symlink; path[0] != '\0'; path=nextpath) {
			/* break off one component */
			if((nextpath = strchr(path, '/')) == nil)
				nextpath = path+strlen(path);
			strncpy(buf0, path, nextpath-path);
			buf0[nextpath-path] = '\0';
			if(nextpath[0] == '/')
				nextpath++;
			p = buf0;

			/* write the name, perhaps broken into pieces */
			if(strcmp(p, "") == 0)
				flags = NMroot;
			else if(strcmp(p, ".") == 0)
				flags = NMcurrent;
			else if(strcmp(p, "..") == 0)
				flags = NMparent;
			else
				flags = 0;

			/* the do-while handles the empty string properly */
			do {
				/* must have room for at least 1 byte of name */
				cp = ensurespace(cd, 7+1, cp, &amp;cn, dowrite);
				cp-&gt;len -= 7+1;
				free = freespace(cp);
				assert(7+1 &lt;= free &amp;&amp; free &lt; 256);

				strncpy(buf, p, free-7);
				buf[free-7] = '\0';
				q = p+strlen(buf);
				p = buf;

				/* nil: better not need to expand */
				assert(7+strlen(p) &lt;= free);
				ensurespace(cd, 7+strlen(p), cp, nil, dowrite);
				CputrripSL(cd, nextpath[0], flags | (q[0] ? NMcontinue : 0), p, dowrite);
				p = q;
			} while(p[0] != '\0');
		}
	}

	assert(dowrite==0 || cp != &amp;co || Cwoffset(cd) == o+co.len-initlen);

	if(what &amp; RR_TF) {
		m = CputrripTF(cd, d, TFcreation|TFmodify|TFaccess|TFattributes, 0);
		cp = ensurespace(cd, m, cp, &amp;cn, dowrite);
		CputrripTF(cd, d, TFcreation|TFmodify|TFaccess|TFattributes, dowrite);
	}
	assert(dowrite==0 || cp != &amp;co || Cwoffset(cd) == o+co.len-initlen);

	if(cp == &amp;cn &amp;&amp; dowrite) {
		/* seek out of continuation, but mark our place */
		cd-&gt;rrcontin = Cwoffset(cd);
		setcelen(cd, cn.ceoffset, cn.len);
		Cwseek(cd, o+co.len-initlen);
	}

	if(co.len &amp; 1) {
		co.len++;
		if(dowrite)
			Cputc(cd, 0);
	}

	if(dowrite) {
		if(Cwoffset(cd) != o+co.len-initlen)
			fprint(2, "offset %llud o+co.len-initlen %llud\n",
				Cwoffset(cd), o+co.len-initlen);
		assert(Cwoffset(cd) == o+co.len-initlen);
	} else
		assert(Cwoffset(cd) == o);

	assert(co.len &lt;= 255);
	return co.len - initlen;
}

static char SUSPrrip[10] = "RRIP_1991A";
static char SUSPdesc[84] = "RRIP &lt;more garbage here&gt;";
static char SUSPsrc[135] = "RRIP &lt;more garbage here&gt;";

static ulong
CputsuspCE(Cdimg *cd, vlong offset)
{
	vlong o, x;

	chat("writing SUSP CE record pointing to %ld, %ld\n",
		offset/Blocksize, offset%Blocksize);
	o = Cwoffset(cd);
	Cputc(cd, 'C');
	Cputc(cd, 'E');
	Cputc(cd, 28);
	Cputc(cd, 1);
	Cputn(cd, offset/Blocksize, 4);
	Cputn(cd, offset%Blocksize, 4);
	x = Cwoffset(cd);
	Cputn(cd, 0, 4);
	assert(Cwoffset(cd) == o+28);

	return x;
}

static int
CputsuspER(Cdimg *cd, int dowrite)
{
	assert(cd != nil);

	if(dowrite) {
		chat("writing SUSP ER record\n");
		Cputc(cd, 'E');           /* ER field marker */
		Cputc(cd, 'R');
		Cputc(cd, 26);            /* Length          */
		Cputc(cd, 1);             /* Version         */
		Cputc(cd, 10);            /* LEN_ID          */
		Cputc(cd, 4);             /* LEN_DESC        */
		Cputc(cd, 4);             /* LEN_SRC         */
		Cputc(cd, 1);             /* EXT_VER         */
		Cputs(cd, SUSPrrip, 10);  /* EXT_ID          */
		Cputs(cd, SUSPdesc, 4);   /* EXT_DESC        */
		Cputs(cd, SUSPsrc, 4);    /* EXT_SRC         */
	}
	return 8+10+4+4;
}

static int
CputsuspRR(Cdimg *cd, int what, int dowrite)
{
	assert(cd != nil);

	if(dowrite) {
		Cputc(cd, 'R');           /* RR field marker */
		Cputc(cd, 'R');
		Cputc(cd, 5);             /* Length          */
		Cputc(cd, 1);		  /* Version number  */
		Cputc(cd, what);          /* Flags           */
	}
	return 5;
}

static int
CputsuspSP(Cdimg *cd, int dowrite)
{
	assert(cd!=0);

	if(dowrite) { 
chat("writing SUSP SP record\n");
		Cputc(cd, 'S');           /* SP field marker */
		Cputc(cd, 'P');
		Cputc(cd, 7);             /* Length          */
		Cputc(cd, 1);             /* Version         */
		Cputc(cd, 0xBE);          /* Magic           */
		Cputc(cd, 0xEF);
		Cputc(cd, 0);
	}

	return 7;
}

#ifdef NOTUSED
static int
CputsuspST(Cdimg *cd, int dowrite)
{
	assert(cd!=0);

	if(dowrite) {
		Cputc(cd, 'S');           /* ST field marker */
		Cputc(cd, 'T');
		Cputc(cd, 4);             /* Length          */
		Cputc(cd, 1);             /* Version         */	
	}
	return 4;
}
#endif

static ulong
suspdirflags(Direc *d, int dot)
{
	uchar flags;

	USED(d);
	flags = 0;
	switch(dot) {
	default:
		assert(0);
	case DTdot:
	case DTrootdot:
		flags |= NMcurrent;
		break;
	case DTdotdot:
		flags |= NMparent;
		break;
	case DTroot:
		flags |= NMvolroot;
		break;
	case DTiden:
		break;
	}
	return flags;
}

static int
Cputrripname(Cdimg *cd, char *nm, int flags, char *name, int dowrite)
{
	int l;

	l = strlen(name);
	if(dowrite) {
		Cputc(cd, nm[0]);                   /* NM field marker */
		Cputc(cd, nm[1]);
		Cputc(cd, l+5);        /* Length          */
		Cputc(cd, 1);                     /* Version         */
		Cputc(cd, flags);                 /* Flags           */
		Cputs(cd, name, l);    /* Alternate name  */
	}
	return 5+l;
}

static int
CputrripSL(Cdimg *cd, int contin, int flags, char *name, int dowrite)
{
	int l;

	l = strlen(name);
	if(dowrite) {
		Cputc(cd, 'S');
		Cputc(cd, 'L');
		Cputc(cd, l+7);
		Cputc(cd, 1);
		Cputc(cd, contin ? 1 : 0);
		Cputc(cd, flags);
		Cputc(cd, l);
		Cputs(cd, name, l);
	}
	return 7+l;
}

static int
CputrripPX(Cdimg *cd, Direc *d, int dot, int dowrite)
{
	assert(cd!=0);

	if(dowrite) {
		Cputc(cd, 'P');             /* PX field marker */
		Cputc(cd, 'X');
		Cputc(cd, 36);              /* Length          */
		Cputc(cd, 1);               /* Version         */
	
		Cputn(cd, mode(d, dot), 4); /* POSIX File mode */
		Cputn(cd, nlink(d), 4);     /* POSIX st_nlink  */
		Cputn(cd, d?d-&gt;uidno:0, 4);  /* POSIX st_uid    */
		Cputn(cd, d?d-&gt;gidno:0, 4);  /* POSIX st_gid    */
	}

	return 36;
}

static int
CputrripTF(Cdimg *cd, Direc *d, int type, int dowrite)
{
	int i, length;

	assert(cd!=0);
	assert(!(type &amp; TFlongform));

	length = 0;
	for(i=0; i&lt;7; i++)
		if (type &amp; (1&lt;&lt;i))
			length++;
	assert(length == 4);

	if(dowrite) {
		Cputc(cd, 'T');				/* TF field marker */
		Cputc(cd, 'F');
		Cputc(cd, 5+7*length);		/* Length		 */
		Cputc(cd, 1);				/* Version		 */
		Cputc(cd, type);					/* Flags (types)	 */
	
		if (type &amp; TFcreation)
			Cputdate(cd, d?d-&gt;ctime:0);
		if (type &amp; TFmodify)
			Cputdate(cd, d?d-&gt;mtime:0);
		if (type &amp; TFaccess)
			Cputdate(cd, d?d-&gt;atime:0);
		if (type &amp; TFattributes)
			Cputdate(cd, d?d-&gt;ctime:0);
	
	//	if (type &amp; TFbackup)
	//		Cputdate(cd, 0);
	//	if (type &amp; TFexpiration)
	//		Cputdate(cd, 0);
	//	if (type &amp; TFeffective)
	//		Cputdate(cd, 0);
	}
	return 5+7*length;
}


#define NONPXMODES  (DMDIR | DMAPPEND | DMEXCL | DMMOUNT)
#define POSIXMODEMASK (0177777)
#ifndef S_IFMT
#define S_IFMT  (0170000)
#endif
#ifndef S_IFDIR
#define S_IFDIR (0040000)
#endif
#ifndef S_IFREG
#define S_IFREG (0100000)
#endif
#ifndef S_IFLNK
#define S_IFLNK (0120000)
#endif
#undef  ISTYPE
#define ISTYPE(mode, mask)  (((mode) &amp; S_IFMT) == (mask))
#ifndef S_ISDIR
#define S_ISDIR(mode) ISTYPE(mode, S_IFDIR)
#endif
#ifndef S_ISREG
#define S_ISREG(mode) ISTYPE(mode, S_IREG)
#endif
#ifndef S_ISLNK
#define S_ISLNK(mode) ISTYPE(mode, S_ILNK)
#endif


static long
mode(Direc *d, int dot)
{
	long mode;
	
	if (!d)
		return 0;

	if ((dot != DTroot) &amp;&amp; (dot != DTrootdot)) {
		mode = (d-&gt;mode &amp; ~(NONPXMODES));
		if (d-&gt;mode &amp; DMDIR)
			mode |= S_IFDIR;
		else if (d-&gt;mode &amp; CHLINK)
			mode |= S_IFLNK;
		else
			mode |= S_IFREG;
	} else
		mode = S_IFDIR | (0755);

	mode &amp;= POSIXMODEMASK;
		
	/* Botch: not all POSIX types supported yet */
	assert(mode &amp; (S_IFDIR|S_IFREG));

chat("writing PX record mode field %ulo with dot %d and name \"%s\"\n", mode, dot, d-&gt;name); 

	return mode;		
}

static long
nlink(Direc *d)   /* Trump up the nlink field for POSIX compliance */
{
	int i;
	long n;

	if (!d)
		return 0;

	n = 1;
	if (d-&gt;mode &amp; DMDIR)   /* One for "." and one more for ".." */
		n++;

	for(i=0; i&lt;d-&gt;nchild; i++)
		if (d-&gt;child[i].mode &amp; DMDIR)
			n++;

	return n;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

