<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/9660/write.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/9660/write.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;

#include "iso9660.h"

static void
writelittlebig4(uchar *buf, ulong x)
{
	buf[0] = buf[7] = x;
	buf[1] = buf[6] = x&gt;&gt;8;
	buf[2] = buf[5] = x&gt;&gt;16;
	buf[3] = buf[4] = x&gt;&gt;24;
}

void
rewritedot(Cdimg *cd, Direc *d)
{
	uchar buf[Blocksize];
	Cdir *c;

	Creadblock(cd, buf, d-&gt;block, Blocksize);
	c = (Cdir*)buf;
	assert(c-&gt;len != 0);
	assert(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\0');	/* dot */
	writelittlebig4(c-&gt;dloc, d-&gt;block);
	writelittlebig4(c-&gt;dlen, d-&gt;length);

	Cwseek(cd, (vlong)d-&gt;block * Blocksize);
	Cwrite(cd, buf, Blocksize);
}

void
rewritedotdot(Cdimg *cd, Direc *d, Direc *dparent)
{
	uchar buf[Blocksize];
	Cdir *c;

	Creadblock(cd, buf, d-&gt;block, Blocksize);
	c = (Cdir*)buf;
	assert(c-&gt;len != 0);
	assert(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\0');	/* dot */

	c = (Cdir*)(buf+c-&gt;len);
	assert(c-&gt;len != 0);
	assert(c-&gt;namelen == 1 &amp;&amp; c-&gt;name[0] == '\001');	/* dotdot*/

	writelittlebig4(c-&gt;dloc, dparent-&gt;block);
	writelittlebig4(c-&gt;dlen, dparent-&gt;length);

	Cwseek(cd, (vlong)d-&gt;block * Blocksize);
	Cwrite(cd, buf, Blocksize);
}

/*
 * Write each non-directory file.  We copy the file to
 * the cd image, and then if it turns out that we've
 * seen this stream of bits before, we push the next block
 * pointer back.  This ensures consistency between the MD5s
 * and the data on the CD image.  MD5 summing on one pass
 * and copying on another would not ensure this.
 */
void
writefiles(Dump *d, Cdimg *cd, Direc *direc)
{
	int i;
	uchar buf[8192], digest[MD5dlen];
	ulong length, n, start;
	Biobuf *b;
	DigestState *s;
	Dumpdir *dd;

	if(direc-&gt;mode &amp; DMDIR) {
		for(i=0; i&lt;direc-&gt;nchild; i++)
			writefiles(d, cd, &amp;direc-&gt;child[i]);
		return;
	}

	assert(direc-&gt;block == 0);

	if((b = Bopen(direc-&gt;srcfile, OREAD)) == nil){
		fprint(2, "warning: cannot open '%s': %r\n", direc-&gt;srcfile);
		direc-&gt;block = 0;
		direc-&gt;length = 0;
		return;
	}

	start = cd-&gt;nextblock;
	assert(start != 0);
	if(blocksize &amp;&amp; start%blocksize)
		start += blocksize-start%blocksize;

	Cwseek(cd, (vlong)start * Blocksize);
	
	s = md5(nil, 0, nil, nil);
	length = 0;
	while((n = Bread(b, buf, sizeof buf)) &gt; 0) {
		md5(buf, n, nil, s);
		Cwrite(cd, buf, n);
		length += n;
	}
	md5(nil, 0, digest, s);
	Bterm(b);
	Cpadblock(cd);

	if(length != direc-&gt;length) {
		fprint(2, "warning: %s changed size underfoot\n", direc-&gt;srcfile);
		direc-&gt;length = length;
	}

	if(length == 0)
		direc-&gt;block = 0;
	else if((dd = lookupmd5(d, digest))) {
		assert(dd-&gt;length == length);
		assert(dd-&gt;block != 0);
		direc-&gt;block = dd-&gt;block;
		cd-&gt;nextblock = start;
	} else {
		direc-&gt;block = start;
		if(chatty &gt; 1)
			fprint(2, "lookup %.16H %lud (%s) failed\n", digest, length, direc-&gt;name);
		insertmd5(d, atom(direc-&gt;name), digest, start, length);
	}
}

/*
 * Write a directory tree.  We work from the leaves, 
 * and patch the dotdot pointers afterward.
 */
static void
_writedirs(Cdimg *cd, Direc *d, int (*put)(Cdimg*, Direc*, int, int, int), int level)
{
	int i, l, ll;
	ulong start, next;

	if((d-&gt;mode &amp; DMDIR) == 0)
		return;

	if(chatty)
		fprint(2, "%*s%s\n", 4*level, "", d-&gt;name);

	for(i=0; i&lt;d-&gt;nchild; i++)
		_writedirs(cd, &amp;d-&gt;child[i], put, level+1);

	l = 0;
	l += put(cd, d, (level == 0) ? DTrootdot : DTdot, 0, l);
	l += put(cd, nil, DTdotdot, 0, l);
	for(i=0; i&lt;d-&gt;nchild; i++)
		l += put(cd, &amp;d-&gt;child[i], DTiden, 0, l);

	start = cd-&gt;nextblock;
	cd-&gt;nextblock += (l+Blocksize-1)/Blocksize;
	next = cd-&gt;nextblock;

	Cwseek(cd, (vlong)start * Blocksize);
	ll = 0;
	ll += put(cd, d, (level == 0) ? DTrootdot : DTdot, 1, ll);
	ll += put(cd, nil, DTdotdot, 1, ll);
	for(i=0; i&lt;d-&gt;nchild; i++)
		ll += put(cd, &amp;d-&gt;child[i], DTiden, 1, ll);
	assert(ll == l);
	Cpadblock(cd);
	assert(Cwoffset(cd) == (vlong)next * Blocksize);

	d-&gt;block = start;
	d-&gt;length = (vlong)(next - start) * Blocksize;
	rewritedot(cd, d);
	rewritedotdot(cd, d, d);

	for(i=0; i&lt;d-&gt;nchild; i++)
		if(d-&gt;child[i].mode &amp; DMDIR)
			rewritedotdot(cd, &amp;d-&gt;child[i], d);
}

void
writedirs(Cdimg *cd, Direc *d, int (*put)(Cdimg*, Direc*, int, int, int))
{
	/*
	 * If we're writing a mk9660 image, then the root really
	 * is the root, so start at level 0.  If we're writing a dump image,
	 * then the "root" is really going to be two levels down once
	 * we patch in the dump hierarchy above it, so start at level non-zero.
	 */
	if(chatty)
		fprint(2, "&gt;&gt;&gt; writedirs\n");
	_writedirs(cd, d, put, mk9660 ? 0 : 1);
}


/*
 * Write the dump tree.  This is like writedirs but once we get to
 * the roots of the individual days we just patch the parent dotdot blocks.
 */
static void
_writedumpdirs(Cdimg *cd, Direc *d, int (*put)(Cdimg*, Direc*, int, int, int), int level)
{
	int i;
	ulong start;

	switch(level) {
	case 0:
		/* write root, list of years, also conform.map */
		for(i=0; i&lt;d-&gt;nchild; i++)
			if(d-&gt;child[i].mode &amp; DMDIR)
				_writedumpdirs(cd, &amp;d-&gt;child[i], put, level+1);
		chat("write dump root dir at %lud\n", cd-&gt;nextblock);
		goto Writedir;

	case 1:	/* write year, list of days */
		for(i=0; i&lt;d-&gt;nchild; i++)
			_writedumpdirs(cd, &amp;d-&gt;child[i], put, level+1);
		chat("write dump %s dir at %lud\n", d-&gt;name, cd-&gt;nextblock);
		goto Writedir;

	Writedir:
		start = cd-&gt;nextblock;
		Cwseek(cd, (vlong)start * Blocksize);

		put(cd, d, (level == 0) ? DTrootdot : DTdot, 1, Cwoffset(cd));
		put(cd, nil, DTdotdot, 1, Cwoffset(cd));
		for(i=0; i&lt;d-&gt;nchild; i++)
			put(cd, &amp;d-&gt;child[i], DTiden, 1, Cwoffset(cd));
		Cpadblock(cd);

		d-&gt;block = start;
		d-&gt;length = (vlong)(cd-&gt;nextblock - start) * Blocksize;

		rewritedot(cd, d);
		rewritedotdot(cd, d, d);

		for(i=0; i&lt;d-&gt;nchild; i++)
			if(d-&gt;child[i].mode &amp; DMDIR)
				rewritedotdot(cd, &amp;d-&gt;child[i], d);
		break;

	case 2:	/* write day: already written, do nothing */
		break;

	default:
		assert(0);
	}
}

void
writedumpdirs(Cdimg *cd, Direc *d, int (*put)(Cdimg*, Direc*, int, int, int))
{
	_writedumpdirs(cd, d, put, 0);
}

static int
Cputplan9(Cdimg *cd, Direc *d, int dot, int dowrite)
{
	int l, n;

	if(dot != DTiden)
		return 0;

	l = 0;
	if(d-&gt;flags &amp; Dbadname) {
		n = strlen(d-&gt;name);
		l += 1+n;
		if(dowrite) {
			Cputc(cd, n);
			Cputs(cd, d-&gt;name, n);
		}
	} else {
		l++;
		if(dowrite)
			Cputc(cd, 0);
	}

	n = strlen(d-&gt;uid);
	l += 1+n;
	if(dowrite) {
		Cputc(cd, n);
		Cputs(cd, d-&gt;uid, n);
	}

	n = strlen(d-&gt;gid);
	l += 1+n;
	if(dowrite) {
		Cputc(cd, n);
		Cputs(cd, d-&gt;gid, n);
	}

	if(l &amp; 1) {
		l++;
		if(dowrite)
			Cputc(cd, 0);
	}
	l += 8;
	if(dowrite)
		Cputn(cd, d-&gt;mode, 4);

	return l;
}

/*
 * Write a directory entry.
 */
static int
genputdir(Cdimg *cd, Direc *d, int dot, int joliet, int dowrite, int offset)
{
	int f, n, l, lp;
	vlong o;

	f = 0;
	if(dot != DTiden || (d-&gt;mode &amp; DMDIR))
		f |= 2;

	n = 1;
	if(dot == DTiden) {
		if(joliet)
			n = 2*utflen(d-&gt;confname);
		else
			n = strlen(d-&gt;confname);
	}

	l = 33+n;
	if(l &amp; 1)
		l++;
	assert(l &lt;= 255);

	if(joliet == 0) {
		if(cd-&gt;flags &amp; CDplan9)
			l += Cputplan9(cd, d, dot, 0);
		else if(cd-&gt;flags &amp; CDrockridge)
			l += Cputsysuse(cd, d, dot, 0, l);
		assert(l &lt;= 255);
	}

	if(dowrite == 0) {
		if(Blocksize - offset%Blocksize &lt; l)
			l += Blocksize - offset%Blocksize;
		return l;
	}

	assert(offset%Blocksize == Cwoffset(cd)%Blocksize);

	o = Cwoffset(cd);
	lp = 0;
	if(Blocksize - Cwoffset(cd)%Blocksize &lt; l) {
		lp = Blocksize - Cwoffset(cd)%Blocksize;
		Cpadblock(cd);
	}

	Cputc(cd, l);			/* length of directory record */
	Cputc(cd, 0);			/* extended attribute record length */
	if(d) {
		if((d-&gt;mode &amp; DMDIR) == 0)
			assert(d-&gt;length == 0 || d-&gt;block &gt;= 18);

		Cputn(cd, d-&gt;block, 4);		/* location of extent */
		Cputn(cd, d-&gt;length, 4);		/* data length */
	} else {
		Cputn(cd, 0, 4);
		Cputn(cd, 0, 4);
	}
	Cputdate(cd, d ? d-&gt;mtime : now);		/* recorded date */
	Cputc(cd, f);			/* file flags */
	Cputc(cd, 0);			/* file unit size */
	Cputc(cd, 0);			/* interleave gap size */
	Cputn(cd, 1, 2);	       	/* volume sequence number */
	Cputc(cd, n);			/* length of file identifier */

	if(dot == DTiden) {		/* identifier */
		if(joliet)
			Cputrscvt(cd, d-&gt;confname, n);
		else
			Cputs(cd, d-&gt;confname, n);
	}else
	if(dot == DTdotdot)
		Cputc(cd, 1);
	else
		Cputc(cd, 0);

	if(Cwoffset(cd) &amp; 1)			/* pad */
		Cputc(cd, 0);

	if(joliet == 0) {
		if(cd-&gt;flags &amp; CDplan9)
			Cputplan9(cd, d, dot, 1);
		else if(cd-&gt;flags &amp; CDrockridge)
			Cputsysuse(cd, d, dot, 1, Cwoffset(cd)-(o+lp));
	}

	assert(o+lp+l == Cwoffset(cd));
	return lp+l;
}

int
Cputisodir(Cdimg *cd, Direc *d, int dot, int dowrite, int offset)
{
	return genputdir(cd, d, dot, 0, dowrite, offset);
}

int
Cputjolietdir(Cdimg *cd, Direc *d, int dot, int dowrite, int offset)
{
	return genputdir(cd, d, dot, 1, dowrite, offset);
}

void
Cputendvd(Cdimg *cd)
{
	Cputc(cd, 255);				/* volume descriptor set terminator */
	Cputs(cd, "CD001", 5);			/* standard identifier */
	Cputc(cd, 1);				/* volume descriptor version */
	Cpadblock(cd);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

