<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/exsort.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/exsort.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;

int	ulcmp(void*, void*);
void	swapem(ulong*, long);

enum
{
	Wormsize	= 157933,
};
int	wflag;

void
main(int argc, char *argv[])
{
	long i, l, x, lobits, hibits, tot;
	int f, j;
	char *file;
	ulong *b, a, lo, hi;

	ARGBEGIN {
	default:
		print("usage: disk/exsort [-w] [file]\n");
		exits("usage");
	case 'w':
		wflag++;
		break;
	} ARGEND;

	file = "/adm/cache";
	if(argc &gt; 0)
		file = argv[0];

	if(wflag)
		f = open(file, ORDWR);
	else
		f = open(file, OREAD);
	if(f &lt; 0) {
		print("cant open %s: %r\n", file);
		exits("open");
	}
	l = seek(f, 0, 2) / sizeof(long);

	b = malloc(l*sizeof(long));
	if(b == 0) {
		print("cant malloc %s: %r\n", file);
		exits("malloc");
	}
	seek(f, 0, 0);
	if(read(f, b, l*sizeof(long)) != l*sizeof(long)) {
		print("short read %s: %r\n", file);
		exits("read");
	}

	lobits = 0;
	hibits = 0;
	for(i=0; i&lt;l; i++) {
		a = b[i];
		if(a &amp; (1L&lt;&lt;7))
			lobits++;
		if(a &amp; (1L&lt;&lt;31))
			hibits++;
	}

	print("lobits = %6ld\n", lobits);
	print("hibits = %6ld\n", hibits);

	if(hibits &gt; lobits) {
		print("swapping\n");
		swapem(b, l);
	}

	qsort(b, l, sizeof(ulong), ulcmp);

	tot = 0;
	for(j=0; j&lt;100; j++) {
		lo = j*Wormsize;
		hi = lo + Wormsize;

		x = 0;
		for(i=0; i&lt;l; i++) {
			a = b[i];
			if(a &gt;= lo &amp;&amp; a &lt; hi)
				x++;
		}
		if(x) {
			print("disk %2d %6ld blocks\n", j, x);
			tot += x;
		}
	}
	print("total   %6ld blocks\n", tot);


	if(wflag) {
		if(hibits &gt; lobits)
			swapem(b, l);
		seek(f, 0, 0);
		if(write(f, b, l*sizeof(long)) != l*sizeof(long)) {
			print("short write %s\n", file);
			exits("write");
		}
	}

	exits(0);
}

int
ulcmp(void *va, void *vb)
{
	ulong *a, *b;

	a = va;
	b = vb;

	if(*a &gt; *b)
		return 1;
	if(*a &lt; *b)
		return -1;
	return 0;
}

void
swapem(ulong *b, long l)
{
	long i;
	ulong x, a;

	for(i=0; i&lt;l; i++, b++) {
		a = *b;
		x = (((a&gt;&gt;0) &amp; 0xff) &lt;&lt; 24) |
			(((a&gt;&gt;8) &amp; 0xff) &lt;&lt; 16) |
			(((a&gt;&gt;16) &amp; 0xff) &lt;&lt; 8) |
			(((a&gt;&gt;24) &amp; 0xff) &lt;&lt; 0);
		*b = x;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

