<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/chk.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/chk.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"

#define	DSIZE		546000
#define	MAXDEPTH	100

static	char*	abits;
static	long	sizabits;
static	char*	qbits;
static	long	sizqbits;
static	char*	name;
static	long	sizname;
static	long	fstart;
static	long	fsize;
static	long	nfiles;
static	long	maxq;
static	char*	fence;
static	char*	fencebase;
static	Device	dev;
static	long	ndup;
static	long	nused;
static	long	nfdup;
static	long	nqbad;
static	long	nfree;
static	long	nbad;
static	int	mod;
static	int	flags;
static	int	ronly;
static	int	cwflag;
static	long	sbaddr;
static	long	oldblock;
static	int	depth;
static	int	maxdepth;

/* local prototypes */
static	int	fsck(Dentry*);
static	void	ckfreelist(Superb*);
static	void	mkfreelist(Superb*);
static	Dentry*	maked(long, int, long);
static	void	modd(long, int, Dentry*);
static	void	xread(long, long);
static	int	amark(long);
static	int	fmark(long);
static	void	missing(void);
static	void	qmark(long);
static	void*	zalloc(ulong);
static	void*	dalloc(ulong);
static	Iobuf*	xtag(long, int, long);

static
void*
zalloc(ulong n)
{
	char *p;

	p = malloc(n);
	if(p == 0)
		panic("zalloc: out of memory\n");
	memset(p, '\0', n);
	return p;
}

static
void*
dalloc(ulong n)
{
	char *p;

	if(fencebase == 0)
		fence = fencebase = zalloc(MAXDEPTH*sizeof(Dentry));
	p = fence;
	fence += n;
	if(fence &gt; fencebase+MAXDEPTH*sizeof(Dentry))
		panic("dalloc too much memory\n");
	return p;
}

void
check(Filsys *fs, long flag)
{
	Iobuf *p;
	Superb *sb;
	Dentry *d;
	long raddr;
	long nqid;

	wlock(&amp;mainlock);
	dev = fs-&gt;dev;
	flags = flag;
	fence = fencebase;

	sizname = 4000;
	name = zalloc(sizname);
	sizname -= NAMELEN+10;	/* for safety */

	sbaddr = superaddr(dev);
	raddr = getraddr(dev);
	p = xtag(sbaddr, Tsuper, QPSUPER);
	if(!p){
		cprint("bad superblock\n");
		goto out;
	}
	sb = (Superb*)p-&gt;iobuf;
	fstart = 1;

	fsize = sb-&gt;fsize;
	sizabits = (fsize-fstart + 7)/8;
	abits = zalloc(sizabits);

	nqid = sb-&gt;qidgen+100;		/* not as much of a botch */
	if(nqid &gt; 1024*1024*8)
		nqid = 1024*1024*8;
	if(nqid &lt; 64*1024)
		nqid = 64*1024;

	sizqbits = (nqid+7)/8;
	qbits = zalloc(sizqbits);

	mod = 0;
	nfree = 0;
	nfdup = 0;
	nused = 0;
	nbad = 0;
	ndup = 0;
	nqbad = 0;
	depth = 0;
	maxdepth = 0;

	if(flags &amp; Ctouch) {
		oldblock = fsize/DSIZE;
		oldblock *= DSIZE;
		if(oldblock &lt; 0)
			oldblock = 0;
		cprint("oldblock = %ld\n", oldblock);
	}
	if(amark(sbaddr))
		{}
	if(cwflag) {
		if(amark(sb-&gt;roraddr))
			{}
		if(amark(sb-&gt;next))
			{}
	}

	if(!(flags &amp; Cquiet))
		cprint("checking file system: %s\n", fs-&gt;name);
	nfiles = 0;
	maxq = 0;

	d = maked(raddr, 0, QPROOT);
	if(d) {
		if(amark(raddr))
			{}
		if(fsck(d))
			modd(raddr, 0, d);
		depth--;
		fence -= sizeof(Dentry);
		if(depth)
			cprint("depth not zero on return\n");
	}

	if(flags &amp; Cfree) {
		mkfreelist(sb);
		sb-&gt;qidgen = maxq;
		settag(p, Tsuper, QPNONE);
	}

	if(sb-&gt;qidgen &lt; maxq)
		cprint("qid generator low path=%ld maxq=%ld\n",
			sb-&gt;qidgen, maxq);
	if(!(flags &amp; Cfree))
		ckfreelist(sb);
	if(mod) {
		cprint("file system was modified\n");
		settag(p, Tsuper, QPNONE);
	}

	if(!(flags &amp; Cquiet)){
		cprint("%8ld files\n", nfiles);
		cprint("%8ld blocks in the file system\n", fsize-fstart);
		cprint("%8ld used blocks\n", nused);
		cprint("%8ld free blocks\n", sb-&gt;tfree);
	}
	if(!(flags &amp; Cfree)){
		if(nfree != sb-&gt;tfree)
			cprint("%8ld free blocks found\n", nfree);
		if(nfdup)
			cprint("%8ld blocks duplicated in the free list\n", nfdup);
		if(fsize-fstart-nused-nfree)
			cprint("%8ld missing blocks\n", fsize-fstart-nused-nfree);
	}
	if(ndup)
		cprint("%8ld address duplications\n", ndup);
	if(nbad)
		cprint("%8ld bad block addresses\n", nbad);
	if(nqbad)
		cprint("%8ld bad qids\n", nqbad);
	if(!(flags &amp; Cquiet))
		cprint("%8ld maximum qid path\n", maxq);
	missing();

out:
	if(p)
		putbuf(p);
	free(abits);
	free(name);
	free(qbits);
	wunlock(&amp;mainlock);
}

static
int
touch(long a)
{
	Iobuf *p;

	if((flags&amp;Ctouch) &amp;&amp; a &amp;&amp; a &lt; oldblock){
		p = getbuf(dev, a, Bread|Bmod);
		if(p)
			putbuf(p);
		return 1;
	}
	return 0;
}

static
int
checkdir(long a, long qpath)
{
	Dentry *nd;
	int i, ns, dmod;

	ns = strlen(name);
	dmod = touch(a);
	for(i=0; i&lt;DIRPERBUF; i++) {
		nd = maked(a, i, qpath);
		if(!nd)
			break;
		if(fsck(nd)) {
			modd(a, i, nd);
			dmod++;
		}
		depth--;
		fence -= sizeof(Dentry);
		name[ns] = 0;
	}
	name[ns] = 0;
	return dmod;
}

static
int
checkindir(long a, Dentry *d, long qpath)
{
	Iobuf *p;
	int i, dmod;

	dmod = touch(a);
	p = xtag(a, Tind1, qpath);
	if(!p)
		return dmod;
	for(i=0; i&lt;INDPERBUF; i++) {
		a = ((long*)p-&gt;iobuf)[i];
		if(!a)
			continue;
		if(amark(a)) {
			if(flags &amp; Cbad) {
				((long*)p-&gt;iobuf)[i] = 0;
				p-&gt;flags |= Bmod;
			}
			continue;
		}
		if(d-&gt;mode &amp; DDIR)
			dmod += checkdir(a, qpath);
		else if(flags &amp; Crdall)
			xread(a, qpath);
	}
	putbuf(p);
	return dmod;
}

static
int
fsck(Dentry *d)
{
	char *s;
	Rune r;
	Iobuf *p;
	int l, i, ns, dmod;
	long a, qpath;

	depth++;
	if(depth &gt;= maxdepth){
		maxdepth = depth;
		if(maxdepth &gt;= MAXDEPTH){
			cprint("max depth exceeded: %s\n", name);
			return 0;
		}
	}
	dmod = 0;
	if(!(d-&gt;mode &amp; DALLOC))
		return 0;
	nfiles++;

	ns = strlen(name);
	i = strlen(d-&gt;name);
	if(i &gt;= NAMELEN){
		d-&gt;name[NAMELEN-1] = 0;
		cprint("%s-&gt;name (%s) not terminated\n", name, d-&gt;name);
		return 0;
	}
	ns += i;
	if(ns &gt;= sizname){
		cprint("%s-&gt;name (%s) name too large\n", name, d-&gt;name);
		return 0;
	}
	for (s = d-&gt;name; *s; s += l){
		l = chartorune(&amp;r, s);
		if (r == Runeerror)
			for (i = 0; i &lt; l; i++){
				s[i] = '_';
				cprint("%s-&gt;name (%s) bad UTF\n", name, d-&gt;name);
				dmod++;
			}
	}
	strcat(name, d-&gt;name);

	if(d-&gt;mode &amp; DDIR){
		if(ns &gt; 1)
			strcat(name, "/");
		if(flags &amp; Cpdir)
			cprint("%s\n", name);
	} else
	if(flags &amp; Cpfile)
		cprint("%s\n", name);

	qpath = d-&gt;qid.path &amp; ~QPDIR;
	qmark(qpath);
	if(qpath &gt; maxq)
		maxq = qpath;
	for(i=0; i&lt;NDBLOCK; i++) {
		a = d-&gt;dblock[i];
		if(!a)
			continue;
		if(amark(a)) {
			d-&gt;dblock[i] = 0;
			dmod++;
			continue;
		}
		if(d-&gt;mode &amp; DDIR)
			dmod += checkdir(a, qpath);
		else if(flags &amp; Crdall)
			xread(a, qpath);
	}
	a = d-&gt;iblock;
	if(a &amp;&amp; amark(a)) {
		d-&gt;iblock = 0;
		dmod++;
	}
	else if(a)
		dmod += checkindir(a, d, qpath);

	a = d-&gt;diblock;
	if(a &amp;&amp; amark(a)) {
		d-&gt;diblock = 0;
		return dmod + 1;
	}
	dmod += touch(a);
	if(p = xtag(a, Tind2, qpath)){
		for(i=0; i&lt;INDPERBUF; i++){
			a = ((long*)p-&gt;iobuf)[i];
			if(!a)
				continue;
			if(amark(a)) {
				if(flags &amp; Cbad) {
					((long*)p-&gt;iobuf)[i] = 0;
					p-&gt;flags |= Bmod;
				}
				continue;
			}
			dmod += checkindir(a, d, qpath);
		}
		putbuf(p);
	}
	return dmod;
}

static
void
ckfreelist(Superb *sb)
{
	long a, lo, hi;
	int n, i;
	Iobuf *p;
	Fbuf *fb;


	strcpy(name, "free list");
	cprint("check %s\n", name);
	fb = &amp;sb-&gt;fbuf;
	a = sbaddr;
	p = 0;
	lo = 0;
	hi = 0;
	for(;;) {
		n = fb-&gt;nfree;
		if(n &lt; 0 || n &gt; FEPERBUF) {
			cprint("check: nfree bad %ld\n", a);
			break;
		}
		for(i=1; i&lt;n; i++) {
			a = fb-&gt;free[i];
			if(a &amp;&amp; !fmark(a)) {
				if(!lo || lo &gt; a)
					lo = a;
				if(!hi || hi &lt; a)
					hi = a;
			}
		}
		a = fb-&gt;free[0];
		if(!a)
			break;
		if(fmark(a))
			break;
		if(!lo || lo &gt; a)
			lo = a;
		if(!hi || hi &lt; a)
			hi = a;
		if(p)
			putbuf(p);
		p = xtag(a, Tfree, QPNONE);
		if(!p)
			break;
		fb = (Fbuf*)p-&gt;iobuf;
	}
	if(p)
		putbuf(p);
	cprint("lo = %ld; hi = %ld\n", lo, hi);
}

/*
 * make freelist from scratch
 */
static
void
mkfreelist(Superb *sb)
{
	long a;
	int i, b;

	strcpy(name, "free list");
	memset(&amp;sb-&gt;fbuf, 0, sizeof(sb-&gt;fbuf));
	sb-&gt;fbuf.nfree = 1;
	sb-&gt;tfree = 0;
	for(a=fsize-fstart-1; a &gt;= 0; a--) {
		i = a/8;
		if(i &lt; 0 || i &gt;= sizabits)
			continue;
		b = 1 &lt;&lt; (a&amp;7);
		if(abits[i] &amp; b)
			continue;
		addfree(dev, fstart+a, sb);
		abits[i] |= b;
	}
}

static
Dentry*
maked(long a, int s, long qpath)
{
	Iobuf *p;
	Dentry *d, *d1;

	p = xtag(a, Tdir, qpath);
	if(!p)
		return 0;
	d = getdir(p, s);
	d1 = dalloc(sizeof(Dentry));
	memmove(d1, d, sizeof(Dentry));
	putbuf(p);
	return d1;
}

static
void
modd(long a, int s, Dentry *d1)
{
	Iobuf *p;
	Dentry *d;

	if(!(flags &amp; Cbad))
		return;
	p = getbuf(dev, a, Bread);
	d = getdir(p, s);
	if(!d) {
		if(p)
			putbuf(p);
		return;
	}
	memmove(d, d1, sizeof(Dentry));
	p-&gt;flags |= Bmod;
	putbuf(p);
}

static
void
xread(long a, long qpath)
{
	Iobuf *p;

	p = xtag(a, Tfile, qpath);
	if(p)
		putbuf(p);
}

static
Iobuf*
xtag(long a, int tag, long qpath)
{
	Iobuf *p;

	if(a == 0)
		return 0;
	p = getbuf(dev, a, Bread);
	if(!p) {
		cprint("check: \"%s\": xtag: p null\n", name);
		if(flags &amp; (Cream|Ctag)) {
			p = getbuf(dev, a, Bmod);
			if(p) {
				memset(p-&gt;iobuf, 0, RBUFSIZE);
				settag(p, tag, qpath);
				mod++;
				return p;
			}
		}
		return 0;
	}
	if(checktag(p, tag, qpath)) {
		cprint("check: \"%s\": xtag: checktag\n", name);
		if(flags &amp; Cream)
			memset(p-&gt;iobuf, 0, RBUFSIZE);
		if(flags &amp; (Cream|Ctag)) {
			settag(p, tag, qpath);
			mod++;
		}
		return p;
	}
	return p;
}

static
int
amark(long a)
{
	long i;
	int b;

	if(a &lt; fstart || a &gt;= fsize) {
		cprint("check: \"%s\": range %ld\n",
			name, a);
		nbad++;
		return 1;
	}
	a -= fstart;
	i = a/8;
	b = 1 &lt;&lt; (a&amp;7);
	if(abits[i] &amp; b) {
		if(!ronly) {
			if(ndup &lt; 10)
				cprint("check: \"%s\": address dup %ld\n",
					name, fstart+a);
			else
			if(ndup == 10)
				cprint("...");
		}
		ndup++;
		return 0;	/* really?? */
	}
	abits[i] |= b;
	nused++;
	return 0;
}

static
int
fmark(long a)
{
	long i;
	int b;

	if(a &lt; fstart || a &gt;= fsize) {
		cprint("check: \"%s\": range %ld\n",
			name, a);
		nbad++;
		return 1;
	}
	a -= fstart;
	i = a/8;
	b = 1 &lt;&lt; (a&amp;7);
	if(abits[i] &amp; b) {
		cprint("check: \"%s\": address dup %ld\n",
			name, fstart+a);
		nfdup++;
		return 1;
	}
	abits[i] |= b;
	nfree++;
	return 0;
}

static
void
missing(void)
{
	long a, i;
	int b, n;

	n = 0;
	for(a=fsize-fstart-1; a&gt;=0; a--) {
		i = a/8;
		b = 1 &lt;&lt; (a&amp;7);
		if(!(abits[i] &amp; b)) {
			cprint("missing: %ld\n", fstart+a);
			n++;
		}
		if(n &gt; 10) {
			cprint(" ...\n");
			break;
		}
	}
}

static
void
qmark(long qpath)
{
	int i, b;

	i = qpath/8;
	b = 1 &lt;&lt; (qpath&amp;7);
	if(i &lt; 0 || i &gt;= sizqbits) {
		nqbad++;
		if(nqbad &lt; 20)
			cprint("check: \"%s\": qid out of range %lux\n",
				name, qpath);
		return;
	}
	if((qbits[i] &amp; b) &amp;&amp; !ronly) {
		nqbad++;
		if(nqbad &lt; 20)
			cprint("check: \"%s\": qid dup %lux\n",
				name, qpath);
	}
	qbits[i] |= b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

