<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/console.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/console.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"all.h"
#include	"9p1.h"

void
fcall9p1(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	int t;

	rlock(&amp;mainlock);
	t = in-&gt;type;
	if(t &lt; 0 || t &gt;= MAXSYSCALL || (t&amp;1) || !call9p1[t]) {
		print("bad message type %d\n", t);
		panic("");
	}
	ou-&gt;type = t+1;
	ou-&gt;err = 0;

	rlock(&amp;cp-&gt;reflock);
	(*call9p1[t])(cp, in, ou);
	runlock(&amp;cp-&gt;reflock);

	if(ou-&gt;err)
		if(CHAT(cp))
			print("	error: %s\n", errstring[ou-&gt;err]);
	cons.work.count++;
	runlock(&amp;mainlock);
}

int
con_session(void)
{
	Oldfcall in, ou;

	in.type = Tsession9p1;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_attach(int fid, char *uid, char *arg)
{
	Oldfcall in, ou;

	in.type = Tattach9p1;
	in.fid = fid;
	strncpy(in.uname, uid, NAMELEN);
	strncpy(in.aname, arg, NAMELEN);
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_clone(int fid1, int fid2)
{
	Oldfcall in, ou;

	in.type = Tclone9p1;
	in.fid = fid1;
	in.newfid = fid2;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_path(int fid, char *path)
{
	Oldfcall in, ou;
	char *p;

	in.type = Twalk9p1;
	in.fid = fid;

loop:
	if(*path == 0)
		return 0;
	strncpy(in.name, path, NAMELEN);
	if(p = strchr(path, '/')) {
		path = p+1;
		if(p = strchr(in.name, '/'))
			*p = 0;
	} else
		path = strchr(path, 0);
	if(in.name[0]) {
		fcall9p1(cons.chan, &amp;in, &amp;ou);
		if(ou.err)
			return ou.err;
	}
	goto loop;
}

int
con_walk(int fid, char *name)
{
	Oldfcall in, ou;

	in.type = Twalk9p1;
	in.fid = fid;
	strncpy(in.name, name, NAMELEN);
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_stat(int fid, char *data)
{
	Oldfcall in, ou;

	in.type = Tstat9p1;
	in.fid = fid;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	if(ou.err == 0)
		memmove(data, ou.stat, sizeof ou.stat);
	return ou.err;
}

int
con_wstat(int fid, char *data)
{
	Oldfcall in, ou;

	in.type = Twstat9p1;
	in.fid = fid;
	memmove(in.stat, data, sizeof in.stat);
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_open(int fid, int mode)
{
	Oldfcall in, ou;

	in.type = Topen9p1;
	in.fid = fid;
	in.mode = mode;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_read(int fid, char *data, long offset, int count)
{
	Oldfcall in, ou;

	in.type = Tread9p1;
	in.fid = fid;
	in.offset = offset;
	in.count = count;
	ou.data = data;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	if(ou.err)
		return 0;
	return ou.count;
}

int
con_write(int fid, char *data, long offset, int count)
{
	Oldfcall in, ou;

	in.type = Twrite9p1;
	in.fid = fid;
	in.data = data;
	in.offset = offset;
	in.count = count;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	if(ou.err)
		return 0;
	return ou.count;
}

int
con_remove(int fid)
{
	Oldfcall in, ou;

	in.type = Tremove9p1;
	in.fid = fid;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
con_create(int fid, char *name, int uid, int gid, long perm, int mode)
{
	Oldfcall in, ou;

	in.type = Tcreate9p1;
	in.fid = fid;
	strncpy(in.name, name, NAMELEN);
	in.perm = perm;
	in.mode = mode;
	cons.uid = uid;			/* beyond ugly */
	cons.gid = gid;
	fcall9p1(cons.chan, &amp;in, &amp;ou);
	return ou.err;
}

int
doclri(File *f)
{
	Iobuf *p, *p1;
	Dentry *d, *d1;
	int err;

	err = 0;
	p = 0;
	p1 = 0;
	if(isro(f-&gt;fs-&gt;dev)) {
		err = Eronly;
		goto out;
	}
	/*
	 * check on parent directory of file to be deleted
	 */
	if(f-&gt;wpath == 0 || f-&gt;wpath-&gt;addr == f-&gt;addr) {
		err = Ephase;
		goto out;
	}
	p1 = getbuf(f-&gt;fs-&gt;dev, f-&gt;wpath-&gt;addr, Bread);
	d1 = getdir(p1, f-&gt;wpath-&gt;slot);
	if(!d1 || checktag(p1, Tdir, QPNONE) || !(d1-&gt;mode &amp; DALLOC)) {
		err = Ephase;
		goto out;
	}

	accessdir(p1, d1, FWRITE);
	putbuf(p1);
	p1 = 0;

	/*
	 * check on file to be deleted
	 */
	p = getbuf(f-&gt;fs-&gt;dev, f-&gt;addr, Bread);
	d = getdir(p, f-&gt;slot);


	/*
	 * do it
	 */
	memset(d, 0, sizeof(Dentry));
	settag(p, Tdir, QPNONE);
	freewp(f-&gt;wpath);
	freefp(f);

out:
	if(p1)
		putbuf(p1);
	if(p)
		putbuf(p);
	return err;
}

void
f_clri(Chan *cp, Oldfcall *in, Oldfcall *ou)
{
	File *f;

	if(CHAT(cp)) {
		print("c_clri %d\n", cp-&gt;chan);
		print("	fid = %d\n", in-&gt;fid);
	}

	f = filep(cp, in-&gt;fid, 0);
	if(!f) {
		ou-&gt;err = Efid;
		goto out;
	}
	ou-&gt;err = doclri(f);

out:
	ou-&gt;fid = in-&gt;fid;
	if(f)
		qunlock(f);
}

int
con_clri(int fid)
{
	Oldfcall in, ou;
	Chan *cp;

	in.type = Tremove9p1;
	in.fid = fid;
	cp = cons.chan;

	rlock(&amp;mainlock);
	ou.type = Tremove9p1+1;
	ou.err = 0;

	rlock(&amp;cp-&gt;reflock);

	f_clri(cp, &amp;in, &amp;ou);

	runlock(&amp;cp-&gt;reflock);

	cons.work.count++;
	runlock(&amp;mainlock);
	return ou.err;
}

int
con_swap(int fid1, int fid2)
{
	int err;
	Iobuf *p1, *p2;
	File *f1, *f2;
	Dentry *d1, *d2;
	Dentry dt1, dt2;
	Chan *cp;

	cp = cons.chan;
	err = 0;
	rlock(&amp;mainlock);
	rlock(&amp;cp-&gt;reflock);

	f2 = nil;
	p1 = p2 = nil;
	f1 = filep(cp, fid1, 0);
	if(!f1){
		err = Efid;
		goto out;
	}
	p1 = getbuf(f1-&gt;fs-&gt;dev, f1-&gt;addr, Bread|Bmod);
	d1 = getdir(p1, f1-&gt;slot);
	if(!d1 || !(d1-&gt;mode&amp;DALLOC)){
		err = Ealloc;
		goto out;
	}

	f2 = filep(cp, fid2, 0);
	if(!f2){
		err = Efid;
		goto out;
	}
	if(memcmp(&amp;f1-&gt;fs-&gt;dev, &amp;f2-&gt;fs-&gt;dev, 4)==0
	&amp;&amp; f2-&gt;addr == f1-&gt;addr)
		p2 = p1;
	else
		p2 = getbuf(f2-&gt;fs-&gt;dev, f2-&gt;addr, Bread|Bmod);
	d2 = getdir(p2, f2-&gt;slot);
	if(!d2 || !(d2-&gt;mode&amp;DALLOC)){
		err = Ealloc;
		goto out;
	}

	dt1 = *d1;
	dt2 = *d2;
	*d1 = dt2;
	*d2 = dt1;
	memmove(d1-&gt;name, dt1.name, NAMELEN);
	memmove(d2-&gt;name, dt2.name, NAMELEN);

	mkqid(&amp;f1-&gt;qid, d1, 1);
	mkqid(&amp;f2-&gt;qid, d2, 1);
out:
	if(f1)
		qunlock(f1);
	if(f2)
		qunlock(f2);
	if(p1)
		putbuf(p1);
	if(p2 &amp;&amp; p2!=p1)
		putbuf(p2);

	runlock(&amp;cp-&gt;reflock);
	cons.work.count++;
	runlock(&amp;mainlock);

	return err;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

