<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/kfs/ofcallfmt.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/kfs/ofcallfmt.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"
#include "9p1.h"

static void dumpsome(char*, char*, long);
static void fdirconv(char*, Dentry*);

int
ofcallfmt(Fmt *f1)
{
	char buf[512];
	Oldfcall *f;
	int fid, type, tag, n;
	Dentry d;

	f = va_arg(f1-&gt;args, Oldfcall*);
	type = f-&gt;type;
	fid = f-&gt;fid;
	tag = f-&gt;tag;
	switch(type){
	case Tnop9p1:	/* 50 */
		sprint(buf, "Tnop9p1 tag %ud", tag);
		break;
	case Rnop9p1:
		sprint(buf, "Rnop9p1 tag %ud", tag);
		break;
	case Tsession9p1:	/* 52 */
		sprint(buf, "Tsession9p1 tag %ud", tag);
		break;
	case Rsession9p1:
		sprint(buf, "Rsession9p1 tag %ud", tag);
		break;
	case Rerror9p1:	/* 55 */
		sprint(buf, "Rerror9p1 tag %ud error %.64s", tag, f-&gt;ename);
		break;
	case Tflush9p1:	/* 56 */
		sprint(buf, "Tflush9p1 tag %ud oldtag %d", tag, f-&gt;oldtag);
		break;
	case Rflush9p1:
		sprint(buf, "Rflush9p1 tag %ud", tag);
		break;
	case Tattach9p1:	/* 58 */
		sprint(buf, "Tattach9p1 tag %ud fid %d uname %.28s aname %.28s auth %.28s",
			tag, f-&gt;fid, f-&gt;uname, f-&gt;aname, f-&gt;auth);
		break;
	case Rattach9p1:
		sprint(buf, "Rattach9p1 tag %ud fid %d qid 0x%lux|0x%lux",
			tag, fid, f-&gt;qid.path, f-&gt;qid.version);
		break;
	case Tclone9p1:	/* 60 */
		sprint(buf, "Tclone9p1 tag %ud fid %d newfid %d", tag, fid, f-&gt;newfid);
		break;
	case Rclone9p1:
		sprint(buf, "Rclone9p1 tag %ud fid %d", tag, fid);
		break;
	case Twalk9p1:	/* 62 */
		sprint(buf, "Twalk9p1 tag %ud fid %d name %.28s", tag, fid, f-&gt;name);
		break;
	case Rwalk9p1:
		sprint(buf, "Rwalk9p1 tag %ud fid %d qid 0x%lux|0x%lux",
			tag, fid, f-&gt;qid.path, f-&gt;qid.version);
		break;
	case Topen9p1:	/* 64 */
		sprint(buf, "Topen9p1 tag %ud fid %d mode %d", tag, fid, f-&gt;mode);
		break;
	case Ropen9p1:
		sprint(buf, "Ropen9p1 tag %ud fid %d qid 0x%lux|0x%lux",
			tag, fid, f-&gt;qid.path, f-&gt;qid.version);
		break;
	case Tcreate9p1:	/* 66 */
		sprint(buf, "Tcreate9p1 tag %ud fid %d name %.28s perm 0x%lux mode %d",
			tag, fid, f-&gt;name, f-&gt;perm, f-&gt;mode);
		break;
	case Rcreate9p1:
		sprint(buf, "Rcreate9p1 tag %ud fid %d qid 0x%lux|0x%lux",
			tag, fid, f-&gt;qid.path, f-&gt;qid.version);
		break;
	case Tread9p1:	/* 68 */
		sprint(buf, "Tread9p1 tag %ud fid %d offset %ld count %ld",
			tag, fid, f-&gt;offset, f-&gt;count);
		break;
	case Rread9p1:
		n = sprint(buf, "Rread9p1 tag %ud fid %d count %ld ", tag, fid, f-&gt;count);
		dumpsome(buf+n, f-&gt;data, f-&gt;count);
		break;
	case Twrite9p1:	/* 70 */
		n = sprint(buf, "Twrite9p1 tag %ud fid %d offset %ld count %ld ",
			tag, fid, f-&gt;offset, f-&gt;count);
		dumpsome(buf+n, f-&gt;data, f-&gt;count);
		break;
	case Rwrite9p1:
		sprint(buf, "Rwrite9p1 tag %ud fid %d count %ld", tag, fid, f-&gt;count);
		break;
	case Tclunk9p1:	/* 72 */
		sprint(buf, "Tclunk9p1 tag %ud fid %d", tag, fid);
		break;
	case Rclunk9p1:
		sprint(buf, "Rclunk9p1 tag %ud fid %d", tag, fid);
		break;
	case Tremove9p1:	/* 74 */
		sprint(buf, "Tremove9p1 tag %ud fid %d", tag, fid);
		break;
	case Rremove9p1:
		sprint(buf, "Rremove9p1 tag %ud fid %d", tag, fid);
		break;
	case Tstat9p1:	/* 76 */
		sprint(buf, "Tstat9p1 tag %ud fid %d", tag, fid);
		break;
	case Rstat9p1:
		n = sprint(buf, "Rstat9p1 tag %ud fid %d", tag, fid);
		convM2D9p1(f-&gt;stat, &amp;d);
		sprint(buf+n, " stat ");
		fdirconv(buf+n+6, &amp;d);
		break;
	case Twstat9p1:	/* 78 */
		convM2D9p1(f-&gt;stat, &amp;d);
		n = sprint(buf, "Twstat9p1 tag %ud fid %d stat ", tag, fid);
		fdirconv(buf+n, &amp;d);
		break;
	case Rwstat9p1:
		sprint(buf, "Rwstat9p1 tag %ud fid %d", tag, fid);
		break;
	case Tclwalk9p1:	/* 81 */
		sprint(buf, "Tclwalk9p1 tag %ud fid %d newfid %d name %.28s",
			tag, fid, f-&gt;newfid, f-&gt;name);
		break;
	case Rclwalk9p1:
		sprint(buf, "Rclwalk9p1 tag %ud fid %d qid 0x%lux|0x%lux",
			tag, fid, f-&gt;qid.path, f-&gt;qid.version);
		break;
	default:
		sprint(buf,  "unknown type %d", type);
	}
	return fmtstrcpy(f1, buf);
}

static void
fdirconv(char *buf, Dentry *d)
{
	sprint(buf, "'%s' uid=%d gid=%d "
		"q %lux|%lux m %uo "
		"at %ld mt %ld l %ld ",
			d-&gt;name, d-&gt;uid, d-&gt;gid,
			d-&gt;qid.path, d-&gt;qid.version, d-&gt;mode,
			d-&gt;atime, d-&gt;mtime, d-&gt;size);
}

/*
 * dump out count (or DUMPL, if count is bigger) bytes from
 * buf to ans, as a string if they are all printable,
 * else as a series of hex bytes
 */
#define DUMPL 24

static void
dumpsome(char *ans, char *buf, long count)
{
	int i, printable;
	char *p;

	printable = 1;
	if(count &gt; DUMPL)
		count = DUMPL;
	for(i=0; i&lt;count &amp;&amp; printable; i++)
		if((buf[i]&lt;32 &amp;&amp; buf[i] !='\n' &amp;&amp; buf[i] !='\t') || (uchar)buf[i]&gt;127)
			printable = 0;
	p = ans;
	*p++ = '\'';
	if(printable){
		memmove(p, buf, count);
		p += count;
	}else{
		for(i=0; i&lt;count; i++){
			if(i&gt;0 &amp;&amp; i%4==0)
				*p++ = ' ';
			sprint(p, "%2.2ux", buf[i]);
			p += 2;
		}
	}
	*p++ = '\'';
	*p = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

