<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/disk/prep/edit.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/disk/prep/edit.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * disk partition editor
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;disk.h&gt;
#include "edit.h"

char*
getline(Edit *edit)
{
	static int inited;
	static Biobuf bin;
	char *p;
	int n;

	if(!inited){
		Binit(&amp;bin, 0, OREAD);
		inited = 1;
	}
	p = Brdline(&amp;bin, '\n');
	n = Blinelen(&amp;bin);
	if(p == nil || n &lt; 1){
		if(edit-&gt;changed)
			fprint(2, "?warning: changes not written\n");
		exits(0);
	}
	p[n - 1] = '\0';
	while(isspace(*p))
		p++;
	return p;
}

Part*
findpart(Edit *edit, char *name)
{
	int i;

	for(i=0; i&lt;edit-&gt;npart; i++)
		if(strcmp(edit-&gt;part[i]-&gt;name, name) == 0)
			return edit-&gt;part[i];
	return nil;
}

static char*
okname(Edit *edit, char *name)
{
	int i;
	static char msg[100];

	if(name[0] == '\0')
		return "partition has no name";

//	if(strlen(name) &gt;= NAMELEN)
//		return "name too long";
//
	for(i=0; i&lt;edit-&gt;npart; i++) {
		if(strcmp(name, edit-&gt;part[i]-&gt;name) == 0) {
			sprint(msg, "already have partition with name \"%s\"", name);
			return msg;
		}
	}
	return nil;
}

char*
addpart(Edit *edit, Part *p)
{
	int i;
	static char msg[100];
	char *err;

	if(err = okname(edit, p-&gt;name))
		return err;

	for(i=0; i&lt;edit-&gt;npart; i++) {
		if(p-&gt;start &lt; edit-&gt;part[i]-&gt;end &amp;&amp; edit-&gt;part[i]-&gt;start &lt; p-&gt;end) {
			sprint(msg, "\"%s\" %lld-%lld overlaps with \"%s\" %lld-%lld",
				p-&gt;name, p-&gt;start, p-&gt;end,
				edit-&gt;part[i]-&gt;name, edit-&gt;part[i]-&gt;start, edit-&gt;part[i]-&gt;end);
		//	return msg;
		}
	}

	if(edit-&gt;npart &gt;= nelem(edit-&gt;part))	
		return "too many partitions";

	edit-&gt;part[i=edit-&gt;npart++] = p;
	for(; i &gt; 0 &amp;&amp; p-&gt;start &lt; edit-&gt;part[i-1]-&gt;start; i--) {
		edit-&gt;part[i] = edit-&gt;part[i-1];
		edit-&gt;part[i-1] = p;
	}

	if(p-&gt;changed)
		edit-&gt;changed = 1;
	return nil;
}

char*
delpart(Edit *edit, Part *p)
{
	int i;

	for(i=0; i&lt;edit-&gt;npart; i++)
		if(edit-&gt;part[i] == p)
			break;
	assert(i &lt; edit-&gt;npart);
	edit-&gt;npart--;
	for(; i&lt;edit-&gt;npart; i++)
		edit-&gt;part[i] = edit-&gt;part[i+1];

	edit-&gt;changed = 1;
	return nil;
}

static char*
editdot(Edit *edit, int argc, char **argv)
{
	char *err;
	vlong ndot;

	if(argc == 1) {
		print("\t. %lld\n", edit-&gt;dot);
		return nil;
	}

	if(argc &gt; 2)
		return "args";

	if(err = parseexpr(argv[1], edit-&gt;dot, edit-&gt;end, edit-&gt;end, &amp;ndot))
		return err;

	edit-&gt;dot = ndot;
	return nil;
}

static char*
editadd(Edit *edit, int argc, char **argv)
{
	char *name, *err, *q;
	static char msg[100];
	vlong start, end, maxend;
	int i;

	if(argc &lt; 2)
		return "args";

	name = estrdup(argv[1]);
	if((err = okname(edit, name)) || (err = edit-&gt;okname(edit, name)))
		return err;

	if(argc &gt;= 3)
		q = argv[2];
	else {
		fprint(2, "start %s: ", edit-&gt;unit);
		q = getline(edit);
	}
	if(err = parseexpr(q, edit-&gt;dot, edit-&gt;end, edit-&gt;end, &amp;start))
		return err;

	if(start &lt; 0 || start &gt;= edit-&gt;end)
		return "start out of range";

	for(i=0; i &lt; edit-&gt;npart; i++) {
		if(edit-&gt;part[i]-&gt;start &lt;= start &amp;&amp; start &lt; edit-&gt;part[i]-&gt;end) {
			sprint(msg, "start %s in partition \"%s\"", edit-&gt;unit, edit-&gt;part[i]-&gt;name);
			return msg;
		}
	}

	maxend = edit-&gt;end;
	for(i=0; i &lt; edit-&gt;npart; i++)
		if(start &lt; edit-&gt;part[i]-&gt;start &amp;&amp; edit-&gt;part[i]-&gt;start &lt; maxend)
			maxend = edit-&gt;part[i]-&gt;start;

	if(argc &gt;= 4)
		q = argv[3];
	else {
		fprint(2, "end [%lld..%lld] ", start, maxend);
		q = getline(edit);
	}
	if(err = parseexpr(q, edit-&gt;dot, maxend, edit-&gt;end, &amp;end))
		return err;

	if(start == end)
		return "size zero partition";

	if(end &lt;= start || end &gt; maxend)
		return "end out of range";

	if(argc &gt; 4)
		return "args";

	if(err = edit-&gt;add(edit, name, start, end))
		return err;

	edit-&gt;dot = end;
	return nil;
}

static char*
editdel(Edit *edit, int argc, char **argv)
{
	Part *p;

	if(argc != 2)
		return "args";

	if((p = findpart(edit, argv[1])) == nil)
		return "no such partition";

	return edit-&gt;del(edit, p);
}

static char *helptext = 
	". [newdot] - display or set value of dot\n"
	"a name [start [end]] - add partition\n"
	"d name - delete partition\n"
	"h - print help message\n"
	"p - print partition table\n"
	"P - print commands to update sd(3) device\n"
	"w - write partition table\n"
	"q - quit\n";

static char*
edithelp(Edit *edit, int, char**)
{
	print("%s", helptext);
	if(edit-&gt;help)
		return edit-&gt;help(edit);
	return nil;
}

static char*
editprint(Edit *edit, int argc, char**)
{
	vlong lastend;
	int i;
	Part **part;

	if(argc != 1)
		return "args";

	lastend = 0;
	part = edit-&gt;part;
	for(i=0; i&lt;edit-&gt;npart; i++) {
		if(lastend &lt; part[i]-&gt;start)
			edit-&gt;sum(edit, nil, lastend, part[i]-&gt;start);
		edit-&gt;sum(edit, part[i], part[i]-&gt;start, part[i]-&gt;end);
		lastend = part[i]-&gt;end;
	}
	if(lastend &lt; edit-&gt;end)
		edit-&gt;sum(edit, nil, lastend, edit-&gt;end);
	return nil;
}

char*
editwrite(Edit *edit, int argc, char**)
{
	int i;
	char *err;

	if(argc != 1)
		return "args";

	if(edit-&gt;disk-&gt;rdonly)
		return "read only";

	err = edit-&gt;write(edit);
	if(err)
		return err;
	for(i=0; i&lt;edit-&gt;npart; i++)
		edit-&gt;part[i]-&gt;changed = 0;
	edit-&gt;changed = 0;
	return nil;
}

static char*
editquit(Edit *edit, int argc, char**)
{
	static int warned;

	if(argc != 1) {
		warned = 0;
		return "args";
	}

	if(edit-&gt;changed &amp;&amp; (!edit-&gt;warned || edit-&gt;lastcmd != 'q')) {
		edit-&gt;warned = 1;
		return "changes unwritten";
	}

	exits(0);
	return nil;	/* not reached */
}

char*
editctlprint(Edit *edit, int argc, char **)
{
	if(argc != 1)
		return "args";

	if(edit-&gt;printctl)
		edit-&gt;printctl(edit, 1);
	else
		ctldiff(edit, 1);
	return nil;
}

typedef struct Cmd Cmd;
struct Cmd {
	char c;
	char *(*fn)(Edit*, int ,char**);
};

Cmd cmds[] = {
	'.',	editdot,
	'a',	editadd,
	'd',	editdel,
	'?',	edithelp,
	'h',	edithelp,
	'P',	editctlprint,
	'p',	editprint,
	'w',	editwrite,
	'q',	editquit,
};

void
runcmd(Edit *edit, char *cmd)
{
	char *f[10], *err;
	int i, nf;

	while(*cmd &amp;&amp; isspace(*cmd))
		cmd++;

	nf = tokenize(cmd, f, nelem(f));
	if(nf &gt;= 10) {
		fprint(2, "?\n");
		return;
	}

	if(nf &lt; 1)
		return;
	if(strlen(f[0]) != 1) {
		fprint(2, "?\n");
		return;
	}

	err = nil;
	for(i=0; i&lt;nelem(cmds); i++) {
		if(cmds[i].c == f[0][0]) {
			err = cmds[i].fn(edit, nf, f);
			break;
		}
	}
	if(i == nelem(cmds)){
		if(edit-&gt;ext)
			err = edit-&gt;ext(edit, nf, f);
		else
			err = "unknown command";
	}
	if(err) 
		fprint(2, "?%s\n", err);
	edit-&gt;lastcmd = f[0][0];
}

static Part*
ctlmkpart(char *name, vlong start, vlong end, int changed)
{
	Part *p;

	p = emalloc(sizeof(*p));
	p-&gt;name = estrdup(name);
	p-&gt;ctlname = estrdup(name);
	p-&gt;start = start;
	p-&gt;end = end;
	p-&gt;changed = changed;
	return p;
}

static void
rdctlpart(Edit *edit)
{
	int i, nline, nf;
	char *line[128];
	char buf[4096];
	vlong a, b;
	char *f[5];
	Disk *disk;

	disk = edit-&gt;disk;
	edit-&gt;nctlpart = 0;
	seek(disk-&gt;ctlfd, 0, 0);
	if(readn(disk-&gt;ctlfd, buf, sizeof buf) &lt;= 0) {
		return;
	}

	nline = getfields(buf, line, nelem(line), 1, "\n");
	for(i=0; i&lt;nline; i++){
		if(strncmp(line[i], "part ", 5) != 0)
			continue;

		nf = getfields(line[i], f, nelem(f), 1, " \t\r");
		if(nf != 4 || strcmp(f[0], "part") != 0)
			break;

		a = strtoll(f[2], 0, 0);
		b = strtoll(f[3], 0, 0);

		if(a &gt;= b)
			break;

		/* only gather partitions contained in the disk partition we are editing */
		if(a &lt; disk-&gt;offset ||  disk-&gt;offset+disk-&gt;secs &lt; b)
			continue;

		a -= disk-&gt;offset;
		b -= disk-&gt;offset;

		/* the partition we are editing does not count */
		if(strcmp(f[1], disk-&gt;part) == 0)
			continue;

		if(edit-&gt;nctlpart &gt;= nelem(edit-&gt;ctlpart)) {
			fprint(2, "?too many partitions in ctl file\n");
			exits("ctlpart");
		}
		edit-&gt;ctlpart[edit-&gt;nctlpart++] = ctlmkpart(f[1], a, b, 0);
	}
}

static vlong
ctlstart(Part *p)
{
	if(p-&gt;ctlstart)
		return p-&gt;ctlstart;
	return p-&gt;start;
}

static vlong
ctlend(Part *p)
{
	if(p-&gt;ctlend)
		return p-&gt;ctlend;
	return p-&gt;end;
}

static int
areequiv(Part *p, Part *q)
{
	if(p-&gt;ctlname[0]=='\0' || q-&gt;ctlname[0]=='\0')
		return 0;

	return strcmp(p-&gt;ctlname, q-&gt;ctlname) == 0
			&amp;&amp; ctlstart(p) == ctlstart(q) &amp;&amp; ctlend(p) == ctlend(q);
}

static void
unchange(Edit *edit, Part *p)
{
	int i;
	Part *q;

	for(i=0; i&lt;edit-&gt;nctlpart; i++) {
		q = edit-&gt;ctlpart[i];
		if(p-&gt;start &lt;= q-&gt;start &amp;&amp; q-&gt;end &lt;= p-&gt;end) {
			q-&gt;changed = 0;
		}
	}
assert(p-&gt;changed == 0);
}

int
ctldiff(Edit *edit, int ctlfd)
{
	int i, j, waserr;
	Part *p;
	vlong offset;

	rdctlpart(edit);

	/* everything is bogus until we prove otherwise */
	for(i=0; i&lt;edit-&gt;nctlpart; i++)
		edit-&gt;ctlpart[i]-&gt;changed = 1;

	/*
	 * partitions with same info have not changed,
	 * and neither have partitions inside them.
	 */
	for(i=0; i&lt;edit-&gt;nctlpart; i++)
		for(j=0; j&lt;edit-&gt;npart; j++)
			if(areequiv(edit-&gt;ctlpart[i], edit-&gt;part[j])) {
				unchange(edit, edit-&gt;ctlpart[i]);
				break;
			}

	waserr = 0;
	/*
	 * delete all the changed partitions except data (we'll add them back if necessary) 
	 */
	for(i=0; i&lt;edit-&gt;nctlpart; i++) {
		p = edit-&gt;ctlpart[i];
		if(p-&gt;changed)
		if(fprint(ctlfd, "delpart %s\n", p-&gt;ctlname)&lt;0) {
			fprint(2, "delpart failed: %s: %r\n", p-&gt;ctlname);
			waserr = -1;
		}
	}

	/*
	 * add all the partitions from the real list;
	 * this is okay since adding a parition with
	 * information identical to what is there is a no-op.
	 */
	offset = edit-&gt;disk-&gt;offset;
	for(i=0; i&lt;edit-&gt;npart; i++) {
		p = edit-&gt;part[i];
		if(p-&gt;ctlname[0]) {
			if(fprint(ctlfd, "part %s %lld %lld\n", p-&gt;ctlname, offset+ctlstart(p), offset+ctlend(p)) &lt; 0) {
				fprint(2, "adding part failed: %s: %r\n", p-&gt;ctlname);
				waserr = -1;
			}
		}
	}
	return waserr;
}

void*
emalloc(ulong sz)
{
	void *v;

	v = malloc(sz);
	if(v == nil)
		sysfatal("malloc %lud fails", sz);
	memset(v, 0, sz);
	return v;
}

char*
estrdup(char *s)
{
	s = strdup(s);
	if(s == nil)
		sysfatal("strdup (%.10s) fails", s);
	return s;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

