<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dossrv/dosfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dossrv/dosfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "iotrack.h"
#include "dat.h"
#include "dosfs.h"
#include "fns.h"

void
rversion(void)
{
	if(req-&gt;msize &gt; Maxiosize)
		rep-&gt;msize = Maxiosize;
	else
		rep-&gt;msize = req-&gt;msize;
	rep-&gt;version = "9P2000";
}

void
rauth(void)
{
	errno = Enoauth;
}

void
rflush(void)
{
}

void
rattach(void)
{
	Xfs *xf;
	Xfile *root;
	Dosptr *dp;

	root = xfile(req-&gt;fid, Clean);
	if(!root){
		errno = Enomem;
		goto error;
	}
	root-&gt;xf = xf = getxfs(req-&gt;uname, req-&gt;aname);
	if(!xf)
		goto error;
	if(xf-&gt;fmt == 0 &amp;&amp; dosfs(xf) &lt; 0){
		errno = Eformat;
		goto error;
	}
	root-&gt;qid.type = QTDIR;
	root-&gt;qid.path = 0;
	root-&gt;qid.vers = 0;
	root-&gt;xf-&gt;rootqid = root-&gt;qid;
	dp = malloc(sizeof(Dosptr));
	if(dp == nil){
		errno = Enomem;
		goto error;
	}
	root-&gt;ptr = dp;
	rootfile(root);
	rep-&gt;qid = root-&gt;qid;
	return;
error:
	if(root)
		xfile(req-&gt;fid, Clunk);
}

Xfile*
doclone(Xfile *of, int newfid)
{
	Xfile *nf, *next;
	Dosptr *dp;

	nf = xfile(newfid, Clean);
	if(!nf){
		errno = Enomem;
		return nil;
	}
	dp = malloc(sizeof(Dosptr));
	if(dp == nil){
		errno = Enomem;
		return nil;
	}
	next = nf-&gt;next;
	*nf = *of;
	nf-&gt;next = next;
	nf-&gt;fid = req-&gt;newfid;
	nf-&gt;ptr = dp;
	refxfs(nf-&gt;xf, 1);
	memmove(dp, of-&gt;ptr, sizeof(Dosptr));
	dp-&gt;p = nil;
	dp-&gt;d = nil;
	return nf;
}

void
rwalk(void)
{
	Xfile *f, *nf;
	Dosptr dp[1], savedp[1];
	int r, longtype;
	Qid saveqid;

	rep-&gt;nwqid = 0;
	nf = nil;
	f = xfile(req-&gt;fid, Asis);
	if(f == nil){
		chat("\tno xfile\n");
		goto error2;
	}
	if(req-&gt;fid != req-&gt;newfid){
		nf = doclone(f, req-&gt;newfid);
		if(nf == nil){
			chat("\tclone failed\n");
			goto error2;
		}
		f = nf;
	}

	saveqid = f-&gt;qid;
	memmove(savedp, f-&gt;ptr, sizeof(Dosptr));
	for(; rep-&gt;nwqid &lt; req-&gt;nwname &amp;&amp; rep-&gt;nwqid &lt; MAXWELEM; rep-&gt;nwqid++){
		chat("\twalking %s\n", req-&gt;wname[rep-&gt;nwqid]);
		if(!(f-&gt;qid.type &amp; QTDIR)){
			chat("\tnot dir: type=%#x\n", f-&gt;qid.type);
			goto error;
		}
		if(strcmp(req-&gt;wname[rep-&gt;nwqid], ".") == 0){
			;
		}else if(strcmp(req-&gt;wname[rep-&gt;nwqid], "..") == 0){
			if(f-&gt;qid.path != f-&gt;xf-&gt;rootqid.path){
				r = walkup(f, dp);
				if(r &lt; 0)
					goto error;
				memmove(f-&gt;ptr, dp, sizeof(Dosptr));
				if(isroot(dp-&gt;addr))
					f-&gt;qid.path = f-&gt;xf-&gt;rootqid.path;
				else
					f-&gt;qid.path = QIDPATH(dp);
			}
		}else{
			fixname(req-&gt;wname[rep-&gt;nwqid]);
			longtype = classifyname(req-&gt;wname[rep-&gt;nwqid]);
			if(longtype==Invalid || getfile(f) &lt; 0)
				goto error;

			/*
			 * always do a search for the long name,
			 * because it could be filed as such
			 */
			r = searchdir(f, req-&gt;wname[rep-&gt;nwqid], dp, 0, longtype);
			putfile(f);
			if(r &lt; 0)
				goto error;
			memmove(f-&gt;ptr, dp, sizeof(Dosptr));
			f-&gt;qid.path = QIDPATH(dp);
			f-&gt;qid.type = QTFILE;
			if(isroot(dp-&gt;addr))
				f-&gt;qid.path = f-&gt;xf-&gt;rootqid.path;
			else if(dp-&gt;d-&gt;attr &amp; DDIR)
				f-&gt;qid.type = QTDIR;
			else if(dp-&gt;d-&gt;attr &amp; DSYSTEM){
				f-&gt;qid.type |= QTEXCL;
				if(iscontig(f-&gt;xf, dp-&gt;d))
					f-&gt;qid.type |= QTAPPEND;
			}
//ZZZ maybe use other bits than qtexcl &amp; qtapppend
			putfile(f);
		}
		rep-&gt;wqid[rep-&gt;nwqid] = f-&gt;qid;
	}
	return;
error:
	f-&gt;qid = saveqid;
	memmove(f-&gt;ptr, savedp, sizeof(Dosptr));
	if(nf != nil)
		xfile(req-&gt;newfid, Clunk);
error2:
	if(!errno &amp;&amp; !rep-&gt;nwqid)
		errno = Enonexist;
}

void
ropen(void)
{
	Xfile *f;
	Iosect *p;
	Dosptr *dp;
	int attr, omode;

	f = xfile(req-&gt;fid, Asis);
	if(!f || (f-&gt;flags&amp;Omodes)){
		errno = Eio;
		return;
	}
	dp = f-&gt;ptr;
	omode = 0;
	if(!isroot(dp-&gt;paddr) &amp;&amp; (req-&gt;mode &amp; ORCLOSE)){
		/*
		 * check on parent directory of file to be deleted
		 */
		p = getsect(f-&gt;xf, dp-&gt;paddr);
		if(p == nil){
			errno = Eio;
			return;
		}
		attr = ((Dosdir *)&amp;p-&gt;iobuf[dp-&gt;poffset])-&gt;attr;
		putsect(p);
		if(attr &amp; DRONLY){
			errno = Eperm;
			return;
		}
		omode |= Orclose;
	}else if(req-&gt;mode &amp; ORCLOSE)
		omode |= Orclose;
	if(getfile(f) &lt; 0){
		errno = Enonexist;
		return;
	}
	if(!isroot(dp-&gt;addr))
		attr = dp-&gt;d-&gt;attr;
	else
		attr = DDIR;
	switch(req-&gt;mode &amp; 7){
	case OREAD:
	case OEXEC:
		omode |= Oread;
		break;
	case ORDWR:
		omode |= Oread;
		/* fall through */
	case OWRITE:
		omode |= Owrite;
		if(attr &amp; DRONLY){
			errno = Eperm;
			goto out;
		}
		break;
	default:
		errno = Eio;
		goto out;
	}
	if(req-&gt;mode &amp; OTRUNC){
		if(attr &amp; DDIR || attr &amp; DRONLY){
			errno = Eperm;
			goto out;
		}
		if(truncfile(f, 0) &lt; 0){
			errno = Eio;
			goto out;
		}
	}
	f-&gt;flags |= omode;
	rep-&gt;qid = f-&gt;qid;
	rep-&gt;iounit = 0;
out:
	putfile(f);
}

static int
mk8dot3name(Xfile *f, Dosptr *ndp, char *name, char *sname)
{
	Dosptr tmpdp;
	int i, longtype;

	if(strcmp(name, ".") == 0 || strcmp(name, "..") == 0)
		return Invalid;

	/*
	 * always do a search for the long name,
	 * because it could be filed as such
	 */
	fixname(name);
	longtype = classifyname(name);
	if(longtype==Invalid || searchdir(f, name, ndp, 1, longtype) &lt; 0)
		return Invalid;

	if(longtype==Short)
		return Short;

	if(longtype==ShortLower){
		/*
		 * alias is the upper-case version, which we
		 * already know does not exist.
		 */
		strcpy(sname, name);
		for(i=0; sname[i]; i++)
			if('a' &lt;= sname[i] &amp;&amp; sname[i] &lt;= 'z')
				sname[i] += 'A'-'a';
		return ShortLower;
	}

	/*
	 * find alias for the long name
	 */
	for(i=1;; i++){
		mkalias(name, sname, i);
		if(searchdir(f, sname, &amp;tmpdp, 0, 0) &lt; 0)
			return Long;
		putsect(tmpdp.p);
	}
}

/*
 * fill in a directory entry for a new file
 */
static int
mkdentry(Xfs *xf, Dosptr *ndp, char *name, char *sname, int longtype, int nattr, long start, long length)
{
	Dosdir *nd;

	/*
	 * fill in the entry
	 */
	ndp-&gt;p = getsect(xf, ndp-&gt;addr);
	if(ndp-&gt;p == nil
	|| longtype!=Short &amp;&amp; putlongname(xf, ndp, name, sname) &lt; 0){
		errno = Eio;
		return -1;
	}

	ndp-&gt;d = (Dosdir *)&amp;ndp-&gt;p-&gt;iobuf[ndp-&gt;offset];
	nd = ndp-&gt;d;
	memset(nd, 0, DOSDIRSIZE);

	if(longtype!=Short)
		name = sname;
	putname(name, nd);

	nd-&gt;attr = nattr;
	puttime(nd, 0);
	putstart(xf, nd, start);
	nd-&gt;length[0] = length;
	nd-&gt;length[1] = length&gt;&gt;8;
	nd-&gt;length[2] = length&gt;&gt;16;
	nd-&gt;length[3] = length&gt;&gt;24;

	ndp-&gt;p-&gt;flags |= BMOD;

	return 0;
}

void
rcreate(void)
{
	Dosbpb *bp;
	Xfile *f;
	Dosptr *pdp, *ndp;
	Iosect *xp;
	Dosdir *pd, *xd;
	char sname[13];
	long start;
	int longtype, attr, omode, nattr;

	f = xfile(req-&gt;fid, Asis);
	if(!f || (f-&gt;flags&amp;Omodes) || getfile(f)&lt;0){
		errno = Eio;
		return;
	}
	pdp = f-&gt;ptr;
	pd = pdp-&gt;d;
	/*
	 * perm check
	 */
	if(isroot(pdp-&gt;addr) &amp;&amp; pd != nil)
		panic("root pd != nil");
	attr = pd ? pd-&gt;attr : DDIR;
	if(!(attr &amp; DDIR) || (attr &amp; DRONLY)){
badperm:
		putfile(f);
		errno = Eperm;
		return;
	}
	omode = 0;
	if(req-&gt;mode &amp; ORCLOSE)
		omode |= Orclose;
	switch(req-&gt;mode &amp; 7){
	case OREAD:
	case OEXEC:
		omode |= Oread;
		break;
	case ORDWR:
		omode |= Oread;
		/* fall through */
	case OWRITE:
		omode |= Owrite;
		if(req-&gt;perm &amp; DMDIR)
			goto badperm;
		break;
	default:
		goto badperm;
	}

	/*
	 * check the name, find the slot for the dentry,
	 * and find a good alias for a long name
	 */
	ndp = malloc(sizeof(Dosptr));
	if(ndp == nil){
		putfile(f);
		errno = Enomem;
		return;
	}
	longtype = mk8dot3name(f, ndp, req-&gt;name, sname);
	chat("rcreate %s longtype %d...\n", req-&gt;name, longtype);
	if(longtype == Invalid){
		free(ndp);
		goto badperm;
	}

	/*
	 * allocate first cluster, if making directory
	 */
	start = 0;
	bp = nil;
	if(req-&gt;perm &amp; DMDIR){
		bp = f-&gt;xf-&gt;ptr;
		mlock(bp);
		start = falloc(f-&gt;xf);
		unmlock(bp);
		if(start &lt;= 0){
			free(ndp);
			putfile(f);
			errno = Eio;
			return;
		}
	}

	/*
	 * make the entry
	 */
	nattr = 0;
	if((req-&gt;perm &amp; 0222) == 0)
		nattr |= DRONLY;
	if(req-&gt;perm &amp; DMDIR)
		nattr |= DDIR;

	if(mkdentry(f-&gt;xf, ndp, req-&gt;name, sname, longtype, nattr, start, 0) &lt; 0){
		if(ndp-&gt;p != nil)
			putsect(ndp-&gt;p);
		free(ndp);
		if(start &gt; 0)
			ffree(f-&gt;xf, start);
		putfile(f);
		return;
	}

	if(pd != nil){
		puttime(pd, 0);
		pdp-&gt;p-&gt;flags |= BMOD;
	}

	/*
	 * fix up the fid
	 */
	f-&gt;ptr = ndp;
	f-&gt;qid.type = QTFILE;
	f-&gt;qid.path = QIDPATH(ndp);

//ZZZ set type for excl, append?
	if(req-&gt;perm &amp; DMDIR){
		f-&gt;qid.type = QTDIR;
		xp = getsect(f-&gt;xf, clust2sect(bp, start));
		if(xp == nil){
			errno = Eio;
			goto badio;
		}
		xd = (Dosdir *)&amp;xp-&gt;iobuf[0];
		memmove(xd, ndp-&gt;d, DOSDIRSIZE);
		memset(xd-&gt;name, ' ', sizeof xd-&gt;name+sizeof xd-&gt;ext);
		xd-&gt;name[0] = '.';
		xd = (Dosdir *)&amp;xp-&gt;iobuf[DOSDIRSIZE];
		if(pd)
			memmove(xd, pd, DOSDIRSIZE);
		else{
			memset(xd, 0, DOSDIRSIZE);
			puttime(xd, 0);
			xd-&gt;attr = DDIR;
		}
		memset(xd-&gt;name, ' ', sizeof xd-&gt;name+sizeof xd-&gt;ext);
		xd-&gt;name[0] = '.';
		xd-&gt;name[1] = '.';
		xp-&gt;flags |= BMOD;
		putsect(xp);
	}

	f-&gt;flags |= omode;
	rep-&gt;qid = f-&gt;qid;
	rep-&gt;iounit = 0;

badio:
	putfile(f);
	putsect(pdp-&gt;p);
	free(pdp);
}

void
rread(void)
{
	Xfile *f;
	int r;

	if (!(f=xfile(req-&gt;fid, Asis)) || !(f-&gt;flags&amp;Oread))
		goto error;
	if(req-&gt;count &gt; sizeof repdata)
		req-&gt;count = sizeof repdata;
	if(f-&gt;qid.type &amp; QTDIR){
		if(getfile(f) &lt; 0)
			goto error;
		r = readdir(f, repdata, req-&gt;offset, req-&gt;count);
	}else{
		if(getfile(f) &lt; 0)
			goto error;
		r = readfile(f, repdata, req-&gt;offset, req-&gt;count);
	}
	putfile(f);
	if(r &lt; 0){
error:
		errno = Eio;
	}else{
		rep-&gt;count = r;
		rep-&gt;data = (char*)repdata;
	}
}

void
rwrite(void)
{
	Xfile *f;
	int r;

	if (!(f=xfile(req-&gt;fid, Asis)) || !(f-&gt;flags&amp;Owrite))
		goto error;
	if(getfile(f) &lt; 0)
		goto error;
	r = writefile(f, req-&gt;data, req-&gt;offset, req-&gt;count);
	putfile(f);
	if(r &lt; 0){
error:
		errno = Eio;
	}else{
		rep-&gt;count = r;
	}
}

void
rclunk(void)
{
	xfile(req-&gt;fid, Clunk);
	sync();
}

/*
 * wipe out a dos directory entry
 */
static void
doremove(Xfs *xf, Dosptr *dp)
{
	Iosect *p;
	int prevdo;

	dp-&gt;p-&gt;iobuf[dp-&gt;offset] = DOSEMPTY;
	dp-&gt;p-&gt;flags |= BMOD;
	for(prevdo = dp-&gt;offset-DOSDIRSIZE; prevdo &gt;= 0; prevdo -= DOSDIRSIZE){
		if(dp-&gt;p-&gt;iobuf[prevdo+11] != 0xf)
			break;
		dp-&gt;p-&gt;iobuf[prevdo] = DOSEMPTY;
	}
	if(prevdo &lt; 0 &amp;&amp; dp-&gt;prevaddr != -1){
		p = getsect(xf, dp-&gt;prevaddr);
		for(prevdo = ((Dosbpb*)xf-&gt;ptr)-&gt;sectsize-DOSDIRSIZE; prevdo &gt;= 0; prevdo -= DOSDIRSIZE){
			if(p-&gt;iobuf[prevdo+11] != 0xf)
				break;
			p-&gt;iobuf[prevdo] = DOSEMPTY;
			p-&gt;flags |= BMOD;
		}
		putsect(p);
	}		
}

void
rremove(void)
{
	Xfile *f;
	Dosptr *dp;
	Iosect *parp;
	Dosdir *pard;

	f = xfile(req-&gt;fid, Asis);
	parp = nil;
	if(f == nil){
		errno = Eio;
		goto out;
	}
	dp = f-&gt;ptr;
	if(isroot(dp-&gt;addr)){
		errno = Eperm;
		goto out;
	}

	/*
	 * can't remove if parent is read only,
	 * it's a non-empty directory,
	 * or it's a read only file in the root directory
	 */
	parp = getsect(f-&gt;xf, dp-&gt;paddr);
	if(parp == nil
	|| getfile(f) &lt; 0){
		errno = Eio;
		goto out;
	}
	pard = (Dosdir *)&amp;parp-&gt;iobuf[dp-&gt;poffset];
	if(!isroot(dp-&gt;paddr) &amp;&amp; (pard-&gt;attr &amp; DRONLY)
	|| (dp-&gt;d-&gt;attr &amp; DDIR) &amp;&amp; emptydir(f) &lt; 0
	|| isroot(dp-&gt;paddr) &amp;&amp; (dp-&gt;d-&gt;attr&amp;DRONLY)){
		errno = Eperm;
		goto out;
	}
	if(truncfile(f, 0) &lt; 0){
		errno = Eio;
		goto out;
	}
	doremove(f-&gt;xf, f-&gt;ptr);
	if(!isroot(dp-&gt;paddr)){
		puttime(pard, 0);
		parp-&gt;flags |= BMOD;
	}
out:
	if(parp != nil)
		putsect(parp);
	if(f != nil)
		putfile(f);
	xfile(req-&gt;fid, Clunk);
	sync();
}

static void
dostat(Xfile *f, Dir *d)
{
	Dosptr *dp;
	Iosect *p;
	char *name, namebuf[DOSNAMELEN];
	int islong, sum, prevdo;

	dp = f-&gt;ptr;
	if(isroot(dp-&gt;addr)){
		memset(d, 0, sizeof(Dir));
		d-&gt;name = "/";
		d-&gt;qid.type = QTDIR;
		d-&gt;qid.path = f-&gt;xf-&gt;rootqid.path;
		d-&gt;mode = DMDIR|0777;
		d-&gt;uid = "bill";
		d-&gt;muid = "bill";
		d-&gt;gid = "trog";
	}else{
		/*
		 * assemble any long file name
		 */
		sum = aliassum(dp-&gt;d);
		islong = 0;
		name = namebuf;
		for(prevdo = dp-&gt;offset-DOSDIRSIZE; prevdo &gt;= 0; prevdo -= DOSDIRSIZE){
			if(dp-&gt;p-&gt;iobuf[prevdo+11] != 0xf)
				break;
			name = getnamesect(namebuf, name, &amp;dp-&gt;p-&gt;iobuf[prevdo], &amp;islong, &amp;sum, -1);
		}
		if(prevdo &lt; 0 &amp;&amp; dp-&gt;prevaddr != -1){
			p = getsect(f-&gt;xf, dp-&gt;prevaddr);
			for(prevdo = ((Dosbpb*)f-&gt;xf-&gt;ptr)-&gt;sectsize-DOSDIRSIZE; prevdo &gt;= 0; prevdo -= DOSDIRSIZE){
				if(p-&gt;iobuf[prevdo+11] != 0xf)
					break;
				name = getnamesect(namebuf, name, &amp;p-&gt;iobuf[prevdo], &amp;islong, &amp;sum, -1);
			}
			putsect(p);
		}
		getdir(f-&gt;xf, d, dp-&gt;d, dp-&gt;addr, dp-&gt;offset);
		if(islong &amp;&amp; sum == -1 &amp;&amp; nameok(namebuf))
			strcpy(d-&gt;name, namebuf);
	}
}

void
rstat(void)
{
	Dir dir;
	Xfile *f;

	f = xfile(req-&gt;fid, Asis);
	if(!f || getfile(f) &lt; 0){
		errno = Eio;
		return;
	}

	dir.name = repdata;
	dostat(f, &amp;dir);

	rep-&gt;nstat = convD2M(&amp;dir, statbuf, sizeof statbuf);
	rep-&gt;stat = statbuf;
	putfile(f);
}

void
rwstat(void)
{
	Dir dir, wdir;
	Xfile *f, pf;
	Dosptr *dp, ndp, pdp;
	Iosect *parp;
	Dosdir *pard, *d, od;
	char sname[13];
	ulong oaddr, ooffset;
	long start, length;
	int i, longtype, changes, attr;

	f = xfile(req-&gt;fid, Asis);
	if(!f || getfile(f) &lt; 0){
		errno = Eio;
		return;
	}
	dp = f-&gt;ptr;

	if(isroot(dp-&gt;addr)){
		errno = Eperm;
		goto out;
	}

	changes = 0;
	dir.name = repdata;
	dostat(f, &amp;dir);
	if(convM2D(req-&gt;stat, req-&gt;nstat, &amp;wdir, (char*)statbuf) != req-&gt;nstat){
		errno = Ebadstat;
		goto out;
	}

	/*
	 * To change length, must have write permission on file.
	 * we only allow truncates for now.
	 */
	if(wdir.length!=~0 &amp;&amp; wdir.length!=dir.length){
		if(wdir.length &gt; dir.length || !dir.mode &amp; 0222){
			errno = Eperm;
			goto out;
		}
	}

	/*
	 * no chown or chgrp
	 */
	if(wdir.uid[0] != '\0' &amp;&amp; strcmp(dir.uid, wdir.uid) != 0
	|| wdir.gid[0] != '\0' &amp;&amp; strcmp(dir.gid, wdir.gid) != 0){
		errno = Eperm;
		goto out;
	}

	/*
	 * mode/mtime allowed
	 */
	if(wdir.mtime != ~0 &amp;&amp; dir.mtime != wdir.mtime)
		changes = 1;

	/*
	 * Setting DMAPPEND (make system file contiguous)
	 * requires setting DMEXCL (system file).
	 */
	if(wdir.mode != ~0){
		if((wdir.mode &amp; 7) != ((wdir.mode &gt;&gt; 3) &amp; 7)
		|| (wdir.mode &amp; 7) != ((wdir.mode &gt;&gt; 6) &amp; 7)){
			errno = Eperm;
			goto out;
		}
		if((dir.mode^wdir.mode) &amp; (DMEXCL|DMAPPEND|0777))
			changes = 1;
		if((dir.mode^wdir.mode) &amp; DMAPPEND) {
			if((wdir.mode &amp; (DMEXCL|DMAPPEND)) == DMAPPEND) {
				errno = Eperm;
				goto out;
			}
			if((wdir.mode &amp; DMAPPEND) &amp;&amp; makecontig(f, 0) &lt; 0) {
				errno = Econtig;
				goto out;
			}
		}
	}


	/*
	 * to rename:
	 *	1) make up a fake clone
	 *	2) walk to parent
	 *	3) remove the old entry
	 *	4) create entry with new name
	 *	5) write correct mode/mtime info
	 * we need to remove the old entry before creating the new one
	 * to avoid a lock loop.
	 */
	if(wdir.name[0] != '\0' &amp;&amp; strcmp(dir.name, wdir.name) != 0){
		if(utflen(wdir.name) &gt;= DOSNAMELEN){
			errno = Etoolong;
			goto out;
		}

		/*
		 * grab parent directory of file to be changed and check for write perm
		 * rename also disallowed for read-only files in root directory
		 */
		parp = getsect(f-&gt;xf, dp-&gt;paddr);
		if(parp == nil){
			errno = Eio;
			goto out;
		}
		pard = (Dosdir *)&amp;parp-&gt;iobuf[dp-&gt;poffset];
		if(!isroot(dp-&gt;paddr) &amp;&amp; (pard-&gt;attr &amp; DRONLY)
		|| isroot(dp-&gt;paddr) &amp;&amp; (dp-&gt;d-&gt;attr&amp;DRONLY)){
			putsect(parp);
			errno = Eperm;
			goto out;
		}

		/*
		 * retrieve info from old entry
		 */
		oaddr = dp-&gt;addr;
		ooffset = dp-&gt;offset;
		d = dp-&gt;d;
		od = *d;
		start = getstart(f-&gt;xf, d);
		length = GLONG(d-&gt;length);
		attr = d-&gt;attr;

		/*
		 * temporarily release file to allow other directory ops:
		 * walk to parent, validate new name
		 * then remove old entry
		 */
		putfile(f);
		pf = *f;
		memset(&amp;pdp, 0, sizeof(Dosptr));
		pdp.prevaddr = -1;
		pdp.naddr = -1;
		pdp.addr = dp-&gt;paddr;
		pdp.offset = dp-&gt;poffset;
		pdp.p = parp;
		if(!isroot(pdp.addr))
			pdp.d = (Dosdir *)&amp;parp-&gt;iobuf[pdp.offset];
		pf.ptr = &amp;pdp;
		longtype = mk8dot3name(&amp;pf, &amp;ndp, wdir.name, sname);
		if(longtype==Invalid){
			putsect(parp);
			errno = Eperm;
			return;
		}
		if(getfile(f) &lt; 0){
			putsect(parp);
			errno = Eio;
			return;
		}
		doremove(f-&gt;xf, dp);
		putfile(f);

		/*
		 * search for dir entry again, since we may be able to use the old slot,
		 * and we need to set up the naddr field if a long name spans the block.
		 * create new entry.
		 */
		if(searchdir(&amp;pf, wdir.name, dp, 1, longtype) &lt; 0
		|| mkdentry(pf.xf, dp, wdir.name, sname, longtype, attr, start, length) &lt; 0){
			putsect(parp);
			errno = Eio;
			goto out;
		}

		/*
		 * copy invisible fields
		 */
		d = dp-&gt;d;
		for(i = 0; i &lt; 2; i++)
			d-&gt;ctime[i] = od.ctime[i];
		for(i = 0; i &lt; nelem(od.cdate); i++)
			d-&gt;cdate[i] = od.cdate[i];
		for(i = 0; i &lt; nelem(od.adate); i++)
			d-&gt;adate[i] = od.adate[i];

		putsect(parp);

		/*
		 * relocate up other fids to the same file, if it moved
		 */
		f-&gt;qid.path = QIDPATH(dp);
		if(oaddr != dp-&gt;addr || ooffset != dp-&gt;offset)
			dosptrreloc(f, dp, oaddr, ooffset);

		/*
		 * copy fields that are not supposed to change
		 */
		if(wdir.mtime == ~0)
			wdir.mtime = dir.mtime;
		if(wdir.mode == ~0)
			wdir.mode = dir.mode;
		changes = 1;
	}

	/*
	 * do the actual truncate
	 */
	if(wdir.length != ~0 &amp;&amp; wdir.length != dir.length &amp;&amp; truncfile(f, wdir.length) &lt; 0)
		errno = Eio;

	if(changes){
		putdir(dp-&gt;d, &amp;wdir);
		dp-&gt;p-&gt;flags |= BMOD;
	}

out:
	putfile(f);
	sync();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

