<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/dossrv/iotrack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/dossrv/iotrack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "iotrack.h"
#include "dat.h"
#include "fns.h"

#define	HIOB		31	/* a prime */
#define	NIOBUF		80

static Iotrack	hiob[HIOB+1];		/* hash buckets + lru list */
static Iotrack	iobuf[NIOBUF];		/* the real ones */

#define	UNLINK(p, nx, pr)	((p)-&gt;pr-&gt;nx = (p)-&gt;nx, (p)-&gt;nx-&gt;pr = (p)-&gt;pr)

#define	LINK(h, p, nx, pr)	((p)-&gt;nx = (h)-&gt;nx, (p)-&gt;pr = (h), \
				 (h)-&gt;nx-&gt;pr = (p), (h)-&gt;nx = (p))

#define	HTOFRONT(h, p)	((h)-&gt;hnext != (p) &amp;&amp; (UNLINK(p,hnext,hprev), LINK(h,p,hnext,hprev)))

#define	TOFRONT(h, p)	((h)-&gt;next  != (p) &amp;&amp; (UNLINK(p, next, prev), LINK(h,p, next, prev)))

Iosect *
getsect(Xfs *xf, long addr)
{
	return getiosect(xf, addr, 1);
}

Iosect *
getosect(Xfs *xf, long addr)
{
	return getiosect(xf, addr, 0);
}

Iosect *
getiosect(Xfs *xf, long addr, int rflag)
{
	Iotrack *t;
	long taddr;
	int toff;
	Iosect *p;

	toff = addr % Sect2trk;
	taddr = addr - toff;
	t = getiotrack(xf, taddr);
	if(rflag &amp;&amp; (t-&gt;flags&amp;BSTALE)){
		if(tread(t) &lt; 0){
			unmlock(&amp;t-&gt;lock);
			return 0;
		}
		t-&gt;flags &amp;= ~BSTALE;
	}
	t-&gt;ref++;
	p = t-&gt;tp-&gt;p[toff];
	if(p == 0){
		p = newsect();
		t-&gt;tp-&gt;p[toff] = p;
		p-&gt;flags = t-&gt;flags&amp;BSTALE;
		p-&gt;lock.key = 0;
		p-&gt;t = t;
		p-&gt;iobuf = t-&gt;tp-&gt;buf[toff];
	}
	unmlock(&amp;t-&gt;lock);
	mlock(&amp;p-&gt;lock);
	return p;
}

void
putsect(Iosect *p)
{
	Iotrack *t;

	if(canmlock(&amp;p-&gt;lock))
		panic("putsect");
	t = p-&gt;t;
	mlock(&amp;t-&gt;lock);
	t-&gt;flags |= p-&gt;flags;
	p-&gt;flags = 0;
	t-&gt;ref--;
	if(t-&gt;flags &amp; BIMM){
		if(t-&gt;flags &amp; BMOD)
			twrite(t);
		t-&gt;flags &amp;= ~(BMOD|BIMM);
	}
	unmlock(&amp;t-&gt;lock);
	unmlock(&amp;p-&gt;lock);
}

Iotrack *
getiotrack(Xfs *xf, long addr)
{
	Iotrack *hp, *p;
	Iotrack *mp = &amp;hiob[HIOB];
	long h;
/*
 *	chat("iotrack %d,%d...", dev, addr);
 */
	h = (xf-&gt;dev&lt;&lt;24) ^ addr;
	if(h &lt; 0)
		h = ~h;
	h %= HIOB;
	hp = &amp;hiob[h];

loop:

/*
 * look for it in the active list
 */
	mlock(&amp;hp-&gt;lock);
	for(p=hp-&gt;hnext; p != hp; p=p-&gt;hnext){
		if(p-&gt;addr != addr || p-&gt;xf != xf)
			continue;
		unmlock(&amp;hp-&gt;lock);
		mlock(&amp;p-&gt;lock);
		if(p-&gt;addr == addr &amp;&amp; p-&gt;xf == xf)
			goto out;
		unmlock(&amp;p-&gt;lock);
		goto loop;
	}
	unmlock(&amp;hp-&gt;lock);
/*
 * not found
 * take oldest unref'd entry
 */
	mlock(&amp;mp-&gt;lock);
	for(p=mp-&gt;prev; p != mp; p=p-&gt;prev)
		if(p-&gt;ref == 0 &amp;&amp; canmlock(&amp;p-&gt;lock)){
			if(p-&gt;ref == 0)
				break;
			unmlock(&amp;p-&gt;lock);
		}
	unmlock(&amp;mp-&gt;lock);
	if(p == mp){
		print("iotrack all ref'd\n");
		goto loop;
	}
	if(p-&gt;flags &amp; BMOD){
		twrite(p);
		p-&gt;flags &amp;= ~(BMOD|BIMM);
		unmlock(&amp;p-&gt;lock);
		goto loop;
	}
	purgetrack(p);
	p-&gt;addr = addr;
	p-&gt;xf = xf;
	p-&gt;flags = BSTALE;
out:
	mlock(&amp;hp-&gt;lock);
	HTOFRONT(hp, p);
	unmlock(&amp;hp-&gt;lock);
	mlock(&amp;mp-&gt;lock);
	TOFRONT(mp, p);
	unmlock(&amp;mp-&gt;lock);
	return p;
}

void
purgetrack(Iotrack *t)
{
	int i, ref = Sect2trk;
	Iosect *p;

	for(i=0; i&lt;Sect2trk; i++){
		p = t-&gt;tp-&gt;p[i];
		if(p == 0){
			--ref;
			continue;
		}
		if(canmlock(&amp;p-&gt;lock)){
			freesect(p);
			--ref;
			t-&gt;tp-&gt;p[i] = 0;
		}
	}
	if(t-&gt;ref != ref)
		panic("purgetrack");
}

int
twrite(Iotrack *t)
{
	int i, ref;

	chat("[twrite %ld...", t-&gt;addr);
	if(t-&gt;flags &amp; BSTALE){
		for(ref=0,i=0; i&lt;Sect2trk; i++)
			if(t-&gt;tp-&gt;p[i])
				++ref;
		if(ref &lt; Sect2trk){
			if(tread(t) &lt; 0){
				chat("error]");
				return -1;
			}
		}else
			t-&gt;flags &amp;= ~BSTALE;
	}
	if(devwrite(t-&gt;xf, t-&gt;addr, t-&gt;tp-&gt;buf, Trksize) &lt; 0){
		chat("error]");
		return -1;
	}
	chat(" done]");
	return 0;
}

int
tread(Iotrack *t)
{
	int i, ref = 0;
	uchar buf[Sect2trk][Sectorsize];

	for(i=0; i&lt;Sect2trk; i++)
		if(t-&gt;tp-&gt;p[i])
			++ref;
	chat("[tread %ld+%ld...", t-&gt;addr, t-&gt;xf-&gt;offset);
	if(ref == 0){
		if(devread(t-&gt;xf, t-&gt;addr, t-&gt;tp-&gt;buf, Trksize) &lt; 0){
			chat("error]");
			return -1;
		}
		chat("done]");
		t-&gt;flags &amp;= ~BSTALE;
		return 0;
	}
	if(devread(t-&gt;xf, t-&gt;addr, buf, Trksize) &lt; 0){
		chat("error]");
		return -1;
	}
	for(i=0; i&lt;Sect2trk; i++)
		if(t-&gt;tp-&gt;p[i] == 0){
			memmove(t-&gt;tp-&gt;buf[i], buf[i], Sectorsize);
			chat("%d ", i);
		}
	chat("done]");
	t-&gt;flags &amp;= ~BSTALE;
	return 0;
}

void
purgebuf(Xfs *xf)
{
	Iotrack *p;

	for(p=&amp;iobuf[0]; p&lt;&amp;iobuf[NIOBUF]; p++){
		if(p-&gt;xf != xf)
			continue;
		mlock(&amp;p-&gt;lock);
		if(p-&gt;xf == xf){
			if(p-&gt;flags &amp; BMOD)
				twrite(p);
			p-&gt;flags = BSTALE;
			purgetrack(p);
		}
		unmlock(&amp;p-&gt;lock);
	}
}

void
sync(void)
{
	Iotrack *p;

	for(p=&amp;iobuf[0]; p&lt;&amp;iobuf[NIOBUF]; p++){
		if(!(p-&gt;flags &amp; BMOD))
			continue;
		mlock(&amp;p-&gt;lock);
		if(p-&gt;flags &amp; BMOD){
			twrite(p);
			p-&gt;flags &amp;= ~(BMOD|BIMM);
		}
		unmlock(&amp;p-&gt;lock);
	}
}

void
iotrack_init(void)
{
	Iotrack *mp, *p;

	for (mp=&amp;hiob[0]; mp&lt;&amp;hiob[HIOB]; mp++)
		mp-&gt;hprev = mp-&gt;hnext = mp;
	mp-&gt;prev = mp-&gt;next = mp;

	for (p=&amp;iobuf[0]; p&lt;&amp;iobuf[NIOBUF]; p++) {
		p-&gt;hprev = p-&gt;hnext = p;
		p-&gt;prev = p-&gt;next = p;
		TOFRONT(mp, p);
		p-&gt;tp = sbrk(sizeof(Track));
		memset(p-&gt;tp-&gt;p, 0, sizeof p-&gt;tp-&gt;p);
	}
}

static MLock	freelock;
static Iosect *	freelist;

Iosect *
newsect(void)
{
	Iosect *p;

	mlock(&amp;freelock);
	if(p = freelist)	/* assign = */
		freelist = p-&gt;next;
	else
		p = malloc(sizeof(Iosect));
	unmlock(&amp;freelock);
	p-&gt;next = 0;
	return p;
}

void
freesect(Iosect *p)
{
	mlock(&amp;freelock);
	p-&gt;next = freelist;
	freelist = p;
	unmlock(&amp;freelock);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

