<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/eqn/tuning.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/eqn/tuning.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "e.h"

/*

This file contains parameter values for many of the
tuning parameters in eqn.  Names are defined words.

Strings are plugged in verbatim.
Floats are usually in ems.

*/

/* In main.c: */

double	BeforeSub = 1.2;	/* line space before a subscript */
double	AfterSub  = 0.2;	/* line space after a subscript */

/* diacrit.c: */

double	Dvshift	= 0.25;		/* vertical shift for diacriticals on tall letters */
double	Dhshift = 0.025;	/* horizontal shift for tall letters */
double	Dh2shift = 0.05;	/* horizontal shift for small letters */
double	Dheight	= 0.25;		/* increment to height for diacriticals */
double	Barv	= 0.68;		/* vertical shift for bar */
double	Barh	= 0.05;		/* 1/2 horizontal shrink for bar */
double	Ubarv	= 0.1;		/* shift underbar up this much ems */
double	Ubarh	= 0.05;		/* 1/2 horizontal shrink for underbar */

/* Also:
	Vec, Dyad, Hat, Tilde, Dot, Dotdot, Utilde */

/* eqnbox.c: */

char	*IRspace = "\\^";	/* space between italic &amp; roman boxes */

/* fat.c: */

double	Fatshift = 0.05;	/* fattening shifts by Fatshift ems */

/* funny.c: */

int	Funnyps	= 5;		/* point size change (== 5 above) */
double	Funnyht = 0.2;		/* height correction */
double	Funnybase = 0.3;	/* base correction */

/* integral.c: */

int	Intps	= 4;		/* point size change for integral (== 4 above) */
double	Intht	= 1.15;		/* ht of integral in ems */
double	Intbase	= 0.3;		/* base in ems */
double	Int1h	= 0.4;		/* lower limit left */
double	Int1v	= 0.2;		/* lower limit down */
double	Int2h	= 0.05;		/* upper limit right was 8 */
double	Int2v	= 0.1;		/* upper limit up */

/* matrix.c: */

char	*Matspace = "\\ \\ ";	/* space between matrix columns */

/* over.c: */

double	Overgap	= 0.3;		/* gap between num and denom */
double	Overwid	= 0.5;		/* extra width of box */
double	Overline = 0.1;		/* extra length of fraction bar */

/* paren.c* */

double	Parenbase = 0.4;	/* shift of base for even count */
double	Parenshift = 0.13;	/* how much to shift parens down in left ... */
				/* ignored unless postscript */
double	Parenheight = 0.3;	/* extra height above builtups */

/* pile.c: */

double	Pilegap	= 0.4;		/* gap between pile elems */
double	Pilebase = 0.5;		/* shift base of even # of piled elems */

/* shift.c: */

double	Subbase	= 0.2;		/* subscript base belowe main base */
double	Supshift = 0.4;		/* superscript .4 up main box */
char	*Sub1space = "\\|";	/* italic sub roman space */
char	*Sup1space = "\\|";	/* italic sup roman space */
char	*Sub2space = "\\^";	/* space after subscripted thing */
char	*SS1space = "\\^";	/* space before sub in x sub i sup j */
char	*SS2space = "\\^";	/* space before sup */

/* sqrt.c: */
	/* sqrt is hard!  punt for now. */
	/* part of the problem is that every typesetter does it differently */
	/* and we have several typesetters to run. */

/* text.c: */
	/* ought to be done by a table */

struct tune {
	char	*name;
	char	*cval;
} tune[]	={
  /* diacrit.c */
	"vec_def",	"\\f1\\v'-.5m'\\s-3\\(-&gt;\\s0\\v'.5m'\\fP",	/* was \s-2 &amp; .45m */
	"dyad_def",	"\\f1\\v'-.5m'\\s-3\\z\\(&lt;-\\|\\(-&gt;\\s0\\v'.5m'\\fP",
	"hat_def",	"\\f1\\v'-.05m'\\s+1^\\s0\\v'.05m'\\fP",	/* was .1 */
	"tilde_def",	"\\f1\\v'-.05m'\\s+1~\\s0\\v'.05m'\\fP",
	"dot_def",	"\\f1\\v'-.67m'.\\v'.67m'\\fP",
	"dotdot_def",	"\\f1\\v'-.67m'..\\v'.67m'\\fP",
	"utilde_def",	"\\f1\\v'1.0m'\\s+2~\\s-2\\v'-1.0m'\\fP",
  /* funny.c */
	"sum_def",	"\\|\\v'.3m'\\s+5\\(*S\\s-5\\v'-.3m'\\|",
	"union_def",	"\\|\\v'.3m'\\s+5\\(cu\\s-5\\v'-.3m'\\|",
	"inter_def",	"\\|\\v'.3m'\\s+5\\(ca\\s-5\\v'-.3m'\\|",
	"prod_def",	"\\|\\v'.3m'\\s+5\\(*P\\s-5\\v'-.3m'\\|",
  /* integral.c */
	"int_def",	"\\v'.1m'\\s+4\\(is\\s-4\\v'-.1m'",
	0, 0
};

tbl	*ftunetbl[TBLSIZE];	/* user-defined names */

char *ftunes[] ={	/* this table intentionally left small */
	"Subbase",
	"Supshift",
	0
};

void init_tune(void)
{
	int i;

	for (i = 0; tune[i].name != NULL; i++)
		install(deftbl, tune[i].name, tune[i].cval, 0);
	for (i = 0; ftunes[i] != NULL; i++)
		install(ftunetbl, ftunes[i], (char *) 0, 0);
}

#define eq(s, t) (strcmp(s,t) == 0)

void ftune(char *s, char *t)	/* brute force for now */
{
	double dummy;
	double f = atof(t);
	double *target;

	while (*t == ' ' || *t == '\t')
		t++;
	if (eq(s, "Subbase"))
		target = &amp;Subbase;
	else if (eq(s, "Supshift"))
		target = &amp;Supshift;
	else
		target = &amp;dummy;
	if (t[0] == '+' || t[0] == '-')
		*target += f;
	else
		*target = f;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

