<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/execnet/client.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/execnet/client.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"

int nclient;
Client **client;
#define Zmsg ((Msg*)~0)
char nocmd[] = "";

static void readthread(void*);
static void writethread(void*);
static void kickwriter(Client*);

int
newclient(void)
{
	int i;
	Client *c;

	for(i=0; i&lt;nclient; i++)
		if(client[i]-&gt;ref==0 &amp;&amp; !client[i]-&gt;moribund)
			return i;

	c = emalloc(sizeof(Client));
	c-&gt;writerkick = chancreate(sizeof(void*), 1);
	c-&gt;execpid = chancreate(sizeof(ulong), 0);
	c-&gt;cmd = nocmd;

	c-&gt;readerproc = ioproc();
	c-&gt;writerproc = ioproc();
	c-&gt;num = nclient;
	if(nclient%16 == 0)
		client = erealloc(client, (nclient+16)*sizeof(client[0]));
	client[nclient++] = c;
	return nclient-1;
}

void
die(Client *c)
{
	Msg *m, *next;
	Req *r, *rnext;

	c-&gt;moribund = 1;
	kickwriter(c);
	iointerrupt(c-&gt;readerproc);
	iointerrupt(c-&gt;writerproc);
	if(--c-&gt;activethread == 0){
		if(c-&gt;cmd != nocmd){
			free(c-&gt;cmd);
			c-&gt;cmd = nocmd;
		}
		c-&gt;pid = 0;
		c-&gt;moribund = 0;
		c-&gt;status = Closed;
		for(m=c-&gt;mq; m &amp;&amp; m != Zmsg; m=next){
			next = m-&gt;link;
			free(m);
		}
		c-&gt;mq = nil;
		if(c-&gt;rq != nil){
			for(r=c-&gt;rq; r; r=rnext){
				rnext = r-&gt;aux;
				respond(r, "hangup");
			}
			c-&gt;rq = nil;
		}
		if(c-&gt;wq != nil){
			for(r=c-&gt;wq; r; r=rnext){
				rnext = r-&gt;aux;
				respond(r, "hangup");
			}
			c-&gt;wq = nil;
		}
		c-&gt;rq = nil;
		c-&gt;wq = nil;
		c-&gt;emq = nil;
		c-&gt;erq = nil;
		c-&gt;ewq = nil;
	}
}

void
closeclient(Client *c)
{
	if(--c-&gt;ref == 0){
		if(c-&gt;pid &gt; 0)
			postnote(PNPROC, c-&gt;pid, "kill");
		c-&gt;status = Hangup;
		close(c-&gt;fd[0]);
		c-&gt;fd[0] = c-&gt;fd[1] = -1;
		c-&gt;moribund = 1;
		kickwriter(c);
		iointerrupt(c-&gt;readerproc);
		iointerrupt(c-&gt;writerproc);		
		c-&gt;activethread++;
		die(c);
	}
}

void
queuerdreq(Client *c, Req *r)
{
	if(c-&gt;rq==nil)
		c-&gt;erq = &amp;c-&gt;rq;
	*c-&gt;erq = r;
	r-&gt;aux = nil;
	c-&gt;erq = (Req**)&amp;r-&gt;aux;
}

void
queuewrreq(Client *c, Req *r)
{
	if(c-&gt;wq==nil)
		c-&gt;ewq = &amp;c-&gt;wq;
	*c-&gt;ewq = r;
	r-&gt;aux = nil;
	c-&gt;ewq = (Req**)&amp;r-&gt;aux;
}

void
queuemsg(Client *c, Msg *m)
{
	if(c-&gt;mq==nil)
		c-&gt;emq = &amp;c-&gt;mq;
	*c-&gt;emq = m;
	if(m != Zmsg){
		m-&gt;link = nil;
		c-&gt;emq = (Msg**)&amp;m-&gt;link;
	}else
		c-&gt;emq = nil;
}

void
matchmsgs(Client *c)
{
	Req *r;
	Msg *m;
	int n, rm;

	while(c-&gt;rq &amp;&amp; c-&gt;mq){
		r = c-&gt;rq;
		c-&gt;rq = r-&gt;aux;

		rm = 0;
		m = c-&gt;mq;
		if(m == Zmsg){
			respond(r, "execnet: no more data");
			break;
		}
		n = r-&gt;ifcall.count;
		if(n &gt;= m-&gt;ep - m-&gt;rp){
			n = m-&gt;ep - m-&gt;rp;
			c-&gt;mq = m-&gt;link;
			rm = 1;
		}
		if(n)
			memmove(r-&gt;ofcall.data, m-&gt;rp, n);
		if(rm)
			free(m);
		else
			m-&gt;rp += n;
		r-&gt;ofcall.count = n;
		respond(r, nil);
	}
}

void
findrdreq(Client *c, Req *r)
{
	Req **l;

	for(l=&amp;c-&gt;rq; *l; l=(Req**)&amp;(*l)-&gt;aux){
		if(*l == r){
			*l = r-&gt;aux;
			if(*l == nil)
				c-&gt;erq = l;
			respond(r, "flushed");
			break;
		}
	}
}

void
findwrreq(Client *c, Req *r)
{
	Req **l;

	for(l=&amp;c-&gt;wq; *l; l=(Req**)&amp;(*l)-&gt;aux){
		if(*l == r){
			*l = r-&gt;aux;
			if(*l == nil)
				c-&gt;ewq = l;
			respond(r, "flushed");
			return;
		}
	}
}

void
dataread(Req *r, Client *c)
{
	queuerdreq(c, r);
	matchmsgs(c);
}

static void
readthread(void *a)
{
	uchar *buf;
	int n;
	Client *c;
	Ioproc *io;
	Msg *m;
	char tmp[32];

	c = a;
	snprint(tmp, sizeof tmp, "read%d", c-&gt;num);
	threadsetname(tmp);

	buf = emalloc(8192);
	io = c-&gt;readerproc;
	while((n = ioread(io, c-&gt;fd[0], buf, 8192)) &gt;= 0){
		m = emalloc(sizeof(Msg)+n);
		m-&gt;rp = (uchar*)&amp;m[1];
		m-&gt;ep = m-&gt;rp + n;
		if(n)
			memmove(m-&gt;rp, buf, n);
		queuemsg(c, m);
		matchmsgs(c);
	}
	queuemsg(c, Zmsg);
	free(buf);
	die(c);
}

static void
kickwriter(Client *c)
{
	nbsendp(c-&gt;writerkick, nil);
}

void
clientflush(Req *or, Client *c)
{
	if(or-&gt;ifcall.type == Tread)
		findrdreq(c, or);
	else{
		if(c-&gt;execreq == or){
			c-&gt;execreq = nil;
			iointerrupt(c-&gt;writerproc);
		}
		findwrreq(c, or);
		if(c-&gt;curw == or){
			c-&gt;curw = nil;
			iointerrupt(c-&gt;writerproc);
			kickwriter(c);
		}
	}
}

void
datawrite(Req *r, Client *c)
{
	queuewrreq(c, r);
	kickwriter(c);
}

static void
writethread(void *a)
{
	char e[ERRMAX];
	uchar *buf;
	int n;
	Ioproc *io;
	Req *r;
	Client *c;
	char tmp[32];

	c = a;
	snprint(tmp, sizeof tmp, "write%d", c-&gt;num);
	threadsetname(tmp);

	buf = emalloc(8192);
	io = c-&gt;writerproc;
	for(;;){
		while(c-&gt;wq == nil){
			if(c-&gt;moribund)
				goto Out;
			recvp(c-&gt;writerkick);
			if(c-&gt;moribund)
				goto Out;
		}
		r = c-&gt;wq;
		c-&gt;wq = r-&gt;aux;
		c-&gt;curw = r;
		n = iowrite(io, c-&gt;fd[1], r-&gt;ifcall.data, r-&gt;ifcall.count);
		if(chatty9p)
			fprint(2, "io-&gt;write returns %d\n", n);
		if(n &gt;= 0){
			r-&gt;ofcall.count = n;
			respond(r, nil);
		}else{
			rerrstr(e, sizeof e);
			respond(r, e);
		}
	}
Out:
	free(buf);
	die(c);
}

static void
execproc(void *a)
{
	int i, fd;
	Client *c;
	char tmp[32];

	c = a;
	snprint(tmp, sizeof tmp, "execproc%d", c-&gt;num);
	threadsetname(tmp);
	if(pipe(c-&gt;fd) &lt; 0){
		rerrstr(c-&gt;err, sizeof c-&gt;err);
		sendul(c-&gt;execpid, -1);
		return;
	}
	rfork(RFFDG);
	fd = c-&gt;fd[1];
	close(c-&gt;fd[0]);
	dup(fd, 0);
	dup(fd, 1);
	for(i=3; i&lt;100; i++)	/* should do better */
		close(i);
	strcpy(c-&gt;err, "exec failed");
	procexecl(c-&gt;execpid, "/bin/rc", "rc", "-c", c-&gt;cmd, nil);
}

static void
execthread(void *a)
{
	Client *c;
	int p;
	char tmp[32];

	c = a;
	snprint(tmp, sizeof tmp, "exec%d", c-&gt;num);
	threadsetname(tmp);
	c-&gt;execpid = chancreate(sizeof(ulong), 0);
	proccreate(execproc, c, STACK);
	p = recvul(c-&gt;execpid);
	chanfree(c-&gt;execpid);
	c-&gt;execpid = nil;
	close(c-&gt;fd[1]);
	c-&gt;fd[1] = c-&gt;fd[0];
	if(p != -1){
		c-&gt;pid = p;
		c-&gt;activethread = 2;
		threadcreate(readthread, c, STACK);
		threadcreate(writethread, c, STACK);
		if(c-&gt;execreq)
			respond(c-&gt;execreq, nil);
	}else{
		if(c-&gt;execreq)
			respond(c-&gt;execreq, c-&gt;err);
	}
}

void
ctlwrite(Req *r, Client *c)
{
	char *f[3], *s, *p;
	int nf;

	s = emalloc(r-&gt;ifcall.count+1);
	memmove(s, r-&gt;ifcall.data, r-&gt;ifcall.count);
	s[r-&gt;ifcall.count] = '\0';

	f[0] = s;
	p = strchr(s, ' ');
	if(p == nil)
		nf = 1;
	else{
		*p++ = '\0';
		f[1] = p;
		nf = 2;
	}

	if(f[0][0] == '\0'){
		free(s);
		respond(r, nil);
		return;
	}

	r-&gt;ofcall.count = r-&gt;ifcall.count;
	if(strcmp(f[0], "hangup") == 0){
		if(c-&gt;pid == 0){
			respond(r, "connection already hung up");
			goto Out;
		}
		postnote(PNPROC, c-&gt;pid, "kill");
		respond(r, nil);
		goto Out;
	}

	if(strcmp(f[0], "connect") == 0){
		if(c-&gt;cmd != nocmd){
			respond(r, "already have connection");
			goto Out;
		}
		if(nf == 1){
			respond(r, "need argument to connect");
			goto Out;
		}
		c-&gt;status = Exec;
		if(p = strrchr(f[1], '!'))
			*p = '\0';
		c-&gt;cmd = emalloc(4+1+strlen(f[1])+1);
		strcpy(c-&gt;cmd, "exec ");
		strcat(c-&gt;cmd, f[1]);
		c-&gt;execreq = r;
		threadcreate(execthread, c, STACK);
		goto Out;
	}

	respond(r, "bad or inappropriate control message");
Out:
	free(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

