<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/execnet/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/execnet/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ``Exec'' network device.  Mounted on net, provides /net/exec.
 *
 *	exec				protocol directory
 *		n 				connection directory
 *			ctl				control messages (like connect)
 *			data				data
 *			err				errors
 *			local				local address (pid of command)
 *			remote			remote address (command)
 *			status			status
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"

int fsdebug;

enum
{
	Qroot,
	Qexec,
	Qclone,
	Qn,
	Qctl,
	Qdata,
	Qlocal,
	Qremote,
	Qstatus,
};

#define PATH(type, n)	((type)|((n)&lt;&lt;8))
#define TYPE(path)		((int)(path) &amp; 0xFF)
#define NUM(path)		((uint)(path)&gt;&gt;8)

typedef struct Tab Tab;
struct Tab
{
	char *name;
	ulong mode;
};

Tab tab[] =
{
	"/",		DMDIR|0555,
	"exec",	DMDIR|0555,
	"clone",	0666,
	nil,		DMDIR|0555,
	"ctl",		0666,
	"data",	0666,
	"local",	0444,
	"remote",	0444,
	"status",	0444,
};

void
setexecname(char *s)
{
	tab[Qexec].name = s;
}

ulong time0;

static void
fillstat(Dir *d, ulong path)
{
	Tab *t;
	int type;
	char buf[32];

	memset(d, 0, sizeof(*d));
	d-&gt;uid = estrdup("exec");
	d-&gt;gid = estrdup("exec");
	d-&gt;qid.path = path;
	d-&gt;atime = d-&gt;mtime = time0;
	d-&gt;length = 0;

	type = TYPE(path);
	t = &amp;tab[type];
	if(t-&gt;name)
		d-&gt;name = estrdup(t-&gt;name);
	else{
		snprint(buf, sizeof buf, "%ud", NUM(path));
		d-&gt;name = estrdup(buf);
	}
	d-&gt;qid.type = t-&gt;mode&gt;&gt;24;
	d-&gt;mode = t-&gt;mode;
}

static void
fsstat(Req *r)
{
	fillstat(&amp;r-&gt;d, r-&gt;fid-&gt;qid.path);
	respond(r, nil);
}

static int
rootgen(int i, Dir *d, void*)
{
	if(i &lt; 1){
		fillstat(d, PATH(Qexec, 0));
		return 0;
	}
	return -1;
}

static int
execgen(int i, Dir *d, void*)
{
	if(i &lt; 1){
		fillstat(d, PATH(Qclone, 0));
		return 0;
	}
	i -= 1;

	if(i &lt; nclient){
		fillstat(d, PATH(Qn, i));
		return 0;
	}
	return -1;
}

static int
conngen(int i, Dir *d, void *aux)
{
	Client *c;

	c = aux;
	i += Qn+1;
	if(i &lt;= Qstatus){
		fillstat(d, PATH(i, c-&gt;num));
		return 0;
	}
	return -1;
}

char *statusstr[] = 
{
	"Closed",
	"Exec",
	"Established",
	"Hangup",
};

static void
fsread(Req *r)
{
	char e[ERRMAX], *s;
	ulong path;

	path = r-&gt;fid-&gt;qid.path;
	switch(TYPE(path)){
	default:
		snprint(e, sizeof e, "bug in execnet path=%lux", path);
		respond(r, e);
		break;

	case Qroot:
		dirread9p(r, rootgen, nil);
		respond(r, nil);
		break;

	case Qexec:
		dirread9p(r, execgen, nil);
		respond(r, nil);
		break;

	case Qn:
		dirread9p(r, conngen, client[NUM(path)]);
		respond(r, nil);
		break;

	case Qctl:
		snprint(e, sizeof e, "%ud", NUM(path));
		readstr(r, e);
		respond(r, nil);
		break;

	case Qdata:
		dataread(r, client[NUM(path)]);
		break;

	case Qlocal:
		snprint(e, sizeof e, "%d", client[NUM(path)]-&gt;pid);
		readstr(r, e);
		respond(r, nil);
		break;

	case Qremote:
		s = client[NUM(path)]-&gt;cmd;
		if(strlen(s) &gt;= 5)	/* "exec " */
			readstr(r, s+5);
		else
			readstr(r, s);
		respond(r, nil);
		break;

	case Qstatus:
		readstr(r, statusstr[client[NUM(path)]-&gt;status]);
		respond(r, nil);
		break;
	}
}

static void
fswrite(Req *r)
{
	char e[ERRMAX];
	ulong path;

	path = r-&gt;fid-&gt;qid.path;
	switch(TYPE(path)){
	default:
		snprint(e, sizeof e, "bug in execnet path=%lux", path);
		respond(r, e);
		break;

	case Qctl:
		ctlwrite(r, client[NUM(path)]);
		break;

	case Qdata:
		datawrite(r, client[NUM(path)]);
		break;
	}
}


static void
fsflush(Req *r)
{
	ulong path;
	Req *or;

	for(or=r; or-&gt;ifcall.type==Tflush; or=or-&gt;oldreq)
		;

	if(or-&gt;ifcall.type != Tread &amp;&amp; or-&gt;ifcall.type != Twrite)
		abort();

	path = or-&gt;fid-&gt;qid.path;
	if(TYPE(path) != Qdata)
		abort();

	clientflush(or, client[NUM(path)]);
	respond(r, nil);
}

static void
fsattach(Req *r)
{
	if(r-&gt;ifcall.aname &amp;&amp; r-&gt;ifcall.aname[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;fid-&gt;qid.path = PATH(Qroot, 0);
	r-&gt;fid-&gt;qid.type = QTDIR;
	r-&gt;fid-&gt;qid.vers = 0;
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	char buf[32];
	int i, n;
	ulong path;

	if(!(fid-&gt;qid.type&amp;QTDIR))
		return "walk in non-directory";

	path = fid-&gt;qid.path;
	if(strcmp(name, "..") == 0){
		switch(TYPE(path)){
		case Qn:
			qid-&gt;path = PATH(Qexec, 0);
			qid-&gt;type = QTDIR;
			return nil;
		case Qroot:
		case Qexec:
			qid-&gt;path = PATH(Qroot, 0);
			qid-&gt;type = QTDIR;
			return nil;
		default:
			return "bug in fswalk1";
		}
	}

	i = TYPE(path)+1;
	for(; i&lt;nelem(tab); i++){
		if(i==Qn){
			n = atoi(name);
			snprint(buf, sizeof buf, "%d", n);
			if(n &lt; nclient &amp;&amp; strcmp(buf, name) == 0){
				qid-&gt;path = PATH(Qn, n);
				qid-&gt;type = QTDIR;
				return nil;
			}
			break;
		}
		if(strcmp(tab[i].name, name) == 0){
			qid-&gt;path = PATH(i, NUM(path));
			qid-&gt;type = tab[i].mode&gt;&gt;24;
			return nil;
		}
		if(tab[i].mode&amp;DMDIR)
			break;
	}
	return "directory entry not found";
}

static void
fsopen(Req *r)
{
	static int need[4] = { 4, 2, 6, 1 };
	ulong path;
	int n;
	Tab *t;

	/*
	 * lib9p already handles the blatantly obvious.
	 * we just have to enforce the permissions we have set.
	 */
	path = r-&gt;fid-&gt;qid.path;
	t = &amp;tab[TYPE(path)];
	n = need[r-&gt;ifcall.mode&amp;3];
	if((n&amp;t-&gt;mode) != n){
		respond(r, "permission denied");
		return;
	}

	switch(TYPE(path)){
	case Qclone:
		n = newclient();
		path = PATH(Qctl, n);
		r-&gt;fid-&gt;qid.path = path;
		r-&gt;ofcall.qid.path = path;
		if(fsdebug)
			fprint(2, "open clone =&gt; path=%lux\n", path);
		t = &amp;tab[Qctl];
		/* fall through */
	default:
		if(t-tab &gt;= Qn)
			client[NUM(path)]-&gt;ref++;
		respond(r, nil);
		break;
	}
}

Channel *cclunk;
Channel *cclunkwait;
Channel *creq;
Channel *creqwait;

static void
fsthread(void*)
{
	ulong path;
	Alt a[3];
	Fid *fid;
	Req *r;

	threadsetname("fsthread");

	a[0].op = CHANRCV;
	a[0].c = cclunk;
	a[0].v = &amp;fid;
	a[1].op = CHANRCV;
	a[1].c = creq;
	a[1].v = &amp;r;
	a[2].op = CHANEND;

	for(;;){
		switch(alt(a)){
		case 0:
			path = fid-&gt;qid.path;
			if(fid-&gt;omode != -1 &amp;&amp; TYPE(path) &gt;= Qn)
				closeclient(client[NUM(path)]);
			sendp(cclunkwait, nil);
			break;
		case 1:
			switch(r-&gt;ifcall.type){
			case Tattach:
				fsattach(r);
				break;
			case Topen:
				fsopen(r);
				break;
			case Tread:
				fsread(r);
				break;
			case Twrite:
				fswrite(r);
				break;
			case Tstat:
				fsstat(r);
				break;
			case Tflush:
				fsflush(r);
				break;
			default:
				respond(r, "bug in fsthread");
				break;
			}
			sendp(creqwait, 0);
			break;
		}
	}
}

static void
fsdestroyfid(Fid *fid)
{
	sendp(cclunk, fid);
	recvp(cclunkwait);
}

static void
fssend(Req *r)
{
	sendp(creq, r);
	recvp(creqwait);	/* avoids need to deal with spurious flushes */
}

void
initfs(void)
{
	time0 = time(0);
	creq = chancreate(sizeof(void*), 0);
	creqwait = chancreate(sizeof(void*), 0);
	cclunk = chancreate(sizeof(void*), 0);
	cclunkwait = chancreate(sizeof(void*), 0);
	procrfork(fsthread, nil, STACK, RFNAMEG);
}

Srv fs = 
{
.attach=		fssend,
.destroyfid=	fsdestroyfid,
.walk1=		fswalk1,
.open=		fssend,
.read=		fssend,
.write=		fssend,
.stat=		fssend,
.flush=		fssend,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

