<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/exportfs/exportsrv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/exportfs/exportsrv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#define Extern	extern
#include "exportfs.h"

extern char *netdir, *local, *remote;

char Ebadfid[] = "Bad fid";
char Enotdir[] = "Not a directory";
char Edupfid[] = "Fid already in use";
char Eopen[] = "Fid already opened";
char Exmnt[] = "Cannot .. past mount point";
char Emip[] = "Mount in progress";
char Enopsmt[] = "Out of pseudo mount points";
char Enomem[] = "No memory";
char Eversion[] = "Bad 9P2000 version";
char Ereadonly[] = "File system read only";

ulong messagesize;
int readonly;

void
Xversion(Fsrpc *t)
{
	Fcall rhdr;

	if(t-&gt;work.msize &gt; messagesize)
		t-&gt;work.msize = messagesize;
	messagesize = t-&gt;work.msize;
	if(strncmp(t-&gt;work.version, "9P2000", 6) != 0){
		reply(&amp;t-&gt;work, &amp;rhdr, Eversion);
		return;
	}
	rhdr.version = "9P2000";
	rhdr.msize = t-&gt;work.msize;
	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	t-&gt;busy = 0;
}

void
Xauth(Fsrpc *t)
{
	Fcall rhdr;

	reply(&amp;t-&gt;work, &amp;rhdr, "exportfs: authentication not required");
	t-&gt;busy = 0;
}

void
Xflush(Fsrpc *t)
{
	Fsrpc *w, *e;
	Fcall rhdr;

	e = &amp;Workq[Nr_workbufs];

	for(w = Workq; w &lt; e; w++) {
		if(w-&gt;work.tag == t-&gt;work.oldtag) {
			DEBUG(DFD, "\tQ busy %d pid %p can %d\n", w-&gt;busy, w-&gt;pid, w-&gt;canint);
			if(w-&gt;busy &amp;&amp; w-&gt;pid) {
				w-&gt;flushtag = t-&gt;work.tag;
				DEBUG(DFD, "\tset flushtag %d\n", t-&gt;work.tag);
				if(w-&gt;canint)
					postnote(PNPROC, w-&gt;pid, "flush");
				t-&gt;busy = 0;
				return;
			}
		}
	}

	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	DEBUG(DFD, "\tflush reply\n");
	t-&gt;busy = 0;
}

void
Xattach(Fsrpc *t)
{
	int i, nfd;
	Fcall rhdr;
	Fid *f;
	char buf[128];

	f = newfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}

	if(srvfd &gt;= 0){
		if(psmpt == 0){
		Nomount:
			reply(&amp;t-&gt;work, &amp;rhdr, Enopsmt);
			t-&gt;busy = 0;
			freefid(t-&gt;work.fid);
			return;
		}
		for(i=0; i&lt;Npsmpt; i++)
			if(psmap[i] == 0)
				break;
		if(i &gt;= Npsmpt)
			goto Nomount;
		sprint(buf, "%d", i);
		f-&gt;f = file(psmpt, buf);
		if(f-&gt;f == nil)
			goto Nomount;
		sprint(buf, "/mnt/exportfs/%d", i);
		nfd = dup(srvfd, -1);
		if(amount(nfd, buf, MREPL|MCREATE, t-&gt;work.aname) &lt; 0){
			errstr(buf, sizeof buf);
			reply(&amp;t-&gt;work, &amp;rhdr, buf);
			t-&gt;busy = 0;
			freefid(t-&gt;work.fid);
			close(nfd);
			return;
		}
		psmap[i] = 1;
		f-&gt;mid = i;
	}else{
		f-&gt;f = root;
		f-&gt;f-&gt;ref++;
	}

	rhdr.qid = f-&gt;f-&gt;qid;
	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	t-&gt;busy = 0;
}

Fid*
clonefid(Fid *f, int new)
{
	Fid *n;

	n = newfid(new);
	if(n == 0) {
		n = getfid(new);
		if(n == 0)
			fatal("inconsistent fids");
		if(n-&gt;fid &gt;= 0)
			close(n-&gt;fid);
		freefid(new);
		n = newfid(new);
		if(n == 0)
			fatal("inconsistent fids2");
	}
	n-&gt;f = f-&gt;f;
	n-&gt;f-&gt;ref++;
	return n;
}

void
Xwalk(Fsrpc *t)
{
	char err[ERRMAX], *e;
	Fcall rhdr;
	Fid *f, *nf;
	File *wf;
	int i;

	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}

	nf = nil;
	if(t-&gt;work.newfid != t-&gt;work.fid){
		nf = clonefid(f, t-&gt;work.newfid);
		f = nf;
	}

	rhdr.nwqid = 0;
	e = nil;
	for(i=0; i&lt;t-&gt;work.nwname; i++){
		if(i == MAXWELEM){
			e = "Too many path elements";
			break;
		}

		if(strcmp(t-&gt;work.wname[i], "..") == 0) {
			if(f-&gt;f-&gt;parent == nil) {
				e = Exmnt;
				break;
			}
			wf = f-&gt;f-&gt;parent;
			wf-&gt;ref++;
			goto Accept;
		}
	
		wf = file(f-&gt;f, t-&gt;work.wname[i]);
		if(wf == 0){
			errstr(err, sizeof err);
			e = err;
			break;
		}
    Accept:
		freefile(f-&gt;f);
		rhdr.wqid[rhdr.nwqid++] = wf-&gt;qid;
		f-&gt;f = wf;
		continue;
	}

	if(nf!=nil &amp;&amp; (e!=nil || rhdr.nwqid!=t-&gt;work.nwname))
		freefid(t-&gt;work.newfid);
	if(rhdr.nwqid &gt; 0)
		e = nil;
	reply(&amp;t-&gt;work, &amp;rhdr, e);
	t-&gt;busy = 0;
}

void
Xclunk(Fsrpc *t)
{
	Fcall rhdr;
	Fid *f;

	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}

	if(f-&gt;fid &gt;= 0)
		close(f-&gt;fid);

	freefid(t-&gt;work.fid);
	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	t-&gt;busy = 0;
}

void
Xstat(Fsrpc *t)
{
	char err[ERRMAX], *path;
	Fcall rhdr;
	Fid *f;
	Dir *d;
	int s;
	uchar *statbuf;

	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}
	if(f-&gt;fid &gt;= 0)
		d = dirfstat(f-&gt;fid);
	else {
		path = makepath(f-&gt;f, "");
		d = dirstat(path);
		free(path);
	}

	if(d == nil) {
		errstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
		t-&gt;busy = 0;
		return;
	}

	d-&gt;qid.path = f-&gt;f-&gt;qidt-&gt;uniqpath;
	s = sizeD2M(d);
	statbuf = emallocz(s);
	s = convD2M(d, statbuf, s);
	free(d);
	rhdr.nstat = s;
	rhdr.stat = statbuf;
	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	free(statbuf);
	t-&gt;busy = 0;
}

static int
getiounit(int fd)
{
	int n;

	n = iounit(fd);
	if(n &gt; messagesize-IOHDRSZ)
		n = messagesize-IOHDRSZ;
	return n;
}

void
Xcreate(Fsrpc *t)
{
	char err[ERRMAX], *path;
	Fcall rhdr;
	Fid *f;
	File *nf;

	if(readonly) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ereadonly);
		t-&gt;busy = 0;
		return;
	}
	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}
	

	path = makepath(f-&gt;f, t-&gt;work.name);
	f-&gt;fid = create(path, t-&gt;work.mode, t-&gt;work.perm);
	free(path);
	if(f-&gt;fid &lt; 0) {
		errstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
		t-&gt;busy = 0;
		return;
	}

	nf = file(f-&gt;f, t-&gt;work.name);
	if(nf == 0) {
		errstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
		t-&gt;busy = 0;
		return;
	}

	f-&gt;mode = t-&gt;work.mode;
	freefile(f-&gt;f);
	f-&gt;f = nf;
	rhdr.qid = f-&gt;f-&gt;qid;
	rhdr.iounit = getiounit(f-&gt;fid);
	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	t-&gt;busy = 0;
}

void
Xremove(Fsrpc *t)
{
	char err[ERRMAX], *path;
	Fcall rhdr;
	Fid *f;

	if(readonly) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ereadonly);
		t-&gt;busy = 0;
		return;
	}
	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}

	path = makepath(f-&gt;f, "");
	DEBUG(DFD, "\tremove: %s\n", path);
	if(remove(path) &lt; 0) {
		free(path);
		errstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
		t-&gt;busy = 0;
		return;
	}
	free(path);

	f-&gt;f-&gt;inval = 1;
	if(f-&gt;fid &gt;= 0)
		close(f-&gt;fid);
	freefid(t-&gt;work.fid);

	reply(&amp;t-&gt;work, &amp;rhdr, 0);
	t-&gt;busy = 0;
}

void
Xwstat(Fsrpc *t)
{
	char err[ERRMAX], *path;
	Fcall rhdr;
	Fid *f;
	int s;
	char *strings;
	Dir d;

	if(readonly) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ereadonly);
		t-&gt;busy = 0;
		return;
	}
	f = getfid(t-&gt;work.fid);
	if(f == 0) {
		reply(&amp;t-&gt;work, &amp;rhdr, Ebadfid);
		t-&gt;busy = 0;
		return;
	}
	strings = emallocz(t-&gt;work.nstat);	/* ample */
	if(convM2D(t-&gt;work.stat, t-&gt;work.nstat, &amp;d, strings) &lt;= BIT16SZ){
		rerrstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
		t-&gt;busy = 0;
		free(strings);
		return;
	}

	if(f-&gt;fid &gt;= 0)
		s = dirfwstat(f-&gt;fid, &amp;d);
	else {
		path = makepath(f-&gt;f, "");
		s = dirwstat(path, &amp;d);
		free(path);
	}
	if(s &lt; 0) {
		rerrstr(err, sizeof err);
		reply(&amp;t-&gt;work, &amp;rhdr, err);
	}
	else {
		/* wstat may really be rename */
		if(strcmp(d.name, f-&gt;f-&gt;name)!=0 &amp;&amp; strcmp(d.name, "")!=0){
			free(f-&gt;f-&gt;name);
			f-&gt;f-&gt;name = estrdup(d.name);
		}
		reply(&amp;t-&gt;work, &amp;rhdr, 0);
	}
	free(strings);
	t-&gt;busy = 0;
}

/*
 * based on libthread's threadsetname, but drags in less library code.
 * actually just sets the arguments displayed.
 */
void
procsetname(char *fmt, ...)
{
	int fd;
	char *cmdname;
	char buf[128];
	va_list arg;

	va_start(arg, fmt);
	cmdname = vsmprint(fmt, arg);
	va_end(arg);
	if (cmdname == nil)
		return;
	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OWRITE)) &gt;= 0){
		write(fd, cmdname, strlen(cmdname)+1);
		close(fd);
	}
	free(cmdname);
}

void
slave(Fsrpc *f)
{
	Proc *p;
	uintptr pid;
	Fcall rhdr;
	static int nproc;

	if(readonly){
		switch(f-&gt;work.type){
		case Twrite:
			reply(&amp;f-&gt;work, &amp;rhdr, Ereadonly);
			f-&gt;busy = 0;
			return;
		case Topen:
		  	if((f-&gt;work.mode&amp;3) == OWRITE || (f-&gt;work.mode&amp;OTRUNC)){
				reply(&amp;f-&gt;work, &amp;rhdr, Ereadonly);
				f-&gt;busy = 0;
				return;
			}
		}
	}
	for(;;) {
		for(p = Proclist; p; p = p-&gt;next) {
			if(p-&gt;busy == 0) {
				f-&gt;pid = p-&gt;pid;
				p-&gt;busy = 1;
				pid = (uintptr)rendezvous((void*)p-&gt;pid, f);
				if(pid != p-&gt;pid)
					fatal("rendezvous sync fail");
				return;
			}	
		}

		if(++nproc &gt; MAXPROC)
			fatal("too many procs");

		pid = rfork(RFPROC|RFMEM);
		switch(pid) {
		case -1:
			fatal("rfork");

		case 0:
			if (local[0] != '\0')
				if (netdir[0] != '\0')
					procsetname("%s: %s -&gt; %s", netdir, 
						local, remote);
				else
					procsetname("%s -&gt; %s", local, remote);
			blockingslave();
			fatal("slave");

		default:
			p = malloc(sizeof(Proc));
			if(p == 0)
				fatal("out of memory");

			p-&gt;busy = 0;
			p-&gt;pid = pid;
			p-&gt;next = Proclist;
			Proclist = p;

			rendezvous((void*)pid, p);
		}
	}
}

void
blockingslave(void)
{
	Fsrpc *p;
	Fcall rhdr;
	Proc *m;
	uintptr pid;

	notify(flushaction);

	pid = getpid();

	m = rendezvous((void*)pid, 0);
	
	for(;;) {
		p = rendezvous((void*)pid, (void*)pid);
		if(p == (void*)~0)			/* Interrupted */
			continue;

		DEBUG(DFD, "\tslave: %p %F b %d p %p\n", pid, &amp;p-&gt;work, p-&gt;busy, p-&gt;pid);
		if(p-&gt;flushtag != NOTAG)
			goto flushme;

		switch(p-&gt;work.type) {
		case Tread:
			slaveread(p);
			break;

		case Twrite:
			slavewrite(p);
			break;

		case Topen:
			slaveopen(p);
			break;

		default:
			reply(&amp;p-&gt;work, &amp;rhdr, "exportfs: slave type error");
		}
		if(p-&gt;flushtag != NOTAG) {
flushme:
			p-&gt;work.type = Tflush;
			p-&gt;work.tag = p-&gt;flushtag;
			reply(&amp;p-&gt;work, &amp;rhdr, 0);
		}
		p-&gt;busy = 0;
		m-&gt;busy = 0;
	}
}

int
openmount(int sfd)
{
	int p[2];
	char *arg[10], fdbuf[20], mbuf[20];

	if(pipe(p) &lt; 0)
		return -1;

	switch(rfork(RFPROC|RFMEM|RFNOWAIT|RFNAMEG|RFFDG)){
	case -1:
		return -1;

	default:
		close(sfd);
		close(p[0]);
		return p[1];

	case 0:
		break;
	}

	close(p[1]);

	arg[0] = "exportfs";
	snprint(fdbuf, sizeof fdbuf, "-S/fd/%d", sfd);
	arg[1] = fdbuf;
	snprint(mbuf, sizeof mbuf, "-m%lud", messagesize-IOHDRSZ);
	arg[2] = mbuf;
	arg[3] = nil;

	close(0);
	close(1);
	dup(p[0], 0);
	dup(p[0], 1);
	exec("/bin/exportfs", arg);
	_exits("whoops: exec failed");	
	return -1;
}

void
slaveopen(Fsrpc *p)
{
	char err[ERRMAX], *path;
	Fcall *work, rhdr;
	Fid *f;
	Dir *d;

	work = &amp;p-&gt;work;

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;rhdr, Ebadfid);
		return;
	}
	if(f-&gt;fid &gt;= 0) {
		close(f-&gt;fid);
		f-&gt;fid = -1;
	}
	
	path = makepath(f-&gt;f, "");
	DEBUG(DFD, "\topen: %s %d\n", path, work-&gt;mode);

	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG){
		free(path);
		return;
	}
	/* There is a race here I ignore because there are no locks */
	f-&gt;fid = open(path, work-&gt;mode);
	free(path);
	p-&gt;canint = 0;
	if(f-&gt;fid &lt; 0 || (d = dirfstat(f-&gt;fid)) == nil) {
	Error:
		errstr(err, sizeof err);
		reply(work, &amp;rhdr, err);
		return;
	}
	f-&gt;f-&gt;qid = d-&gt;qid;
	free(d);
	if(f-&gt;f-&gt;qid.type &amp; QTMOUNT){	/* fork new exportfs for this */
		f-&gt;fid = openmount(f-&gt;fid);
		if(f-&gt;fid &lt; 0)
			goto Error;
	}

	DEBUG(DFD, "\topen: fd %d\n", f-&gt;fid);
	f-&gt;mode = work-&gt;mode;
	f-&gt;offset = 0;
	rhdr.iounit = getiounit(f-&gt;fid);
	rhdr.qid = f-&gt;f-&gt;qid;
	reply(work, &amp;rhdr, 0);
}

void
slaveread(Fsrpc *p)
{
	Fid *f;
	int n, r;
	Fcall *work, rhdr;
	char *data, err[ERRMAX];

	work = &amp;p-&gt;work;

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;rhdr, Ebadfid);
		return;
	}

	n = (work-&gt;count &gt; messagesize-IOHDRSZ) ? messagesize-IOHDRSZ : work-&gt;count;
	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG)
		return;
	data = malloc(n);
	if(data == nil)
		fatal(Enomem);

	/* can't just call pread, since directories must update the offset */
	if(patternfile != nil &amp;&amp; (f-&gt;f-&gt;qid.type&amp;QTDIR))
		r = preaddir(f, (uchar*)data, n, work-&gt;offset);
	else
		r = pread(f-&gt;fid, data, n, work-&gt;offset);
	p-&gt;canint = 0;
	if(r &lt; 0) {
		free(data);
		errstr(err, sizeof err);
		reply(work, &amp;rhdr, err);
		return;
	}

	DEBUG(DFD, "\tread: fd=%d %d bytes\n", f-&gt;fid, r);

	rhdr.data = data;
	rhdr.count = r;
	reply(work, &amp;rhdr, 0);
	free(data);
}

void
slavewrite(Fsrpc *p)
{
	char err[ERRMAX];
	Fcall *work, rhdr;
	Fid *f;
	int n;

	work = &amp;p-&gt;work;

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;rhdr, Ebadfid);
		return;
	}

	n = (work-&gt;count &gt; messagesize-IOHDRSZ) ? messagesize-IOHDRSZ : work-&gt;count;
	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG)
		return;
	n = pwrite(f-&gt;fid, work-&gt;data, n, work-&gt;offset);
	p-&gt;canint = 0;
	if(n &lt; 0) {
		errstr(err, sizeof err);
		reply(work, &amp;rhdr, err);
		return;
	}

	DEBUG(DFD, "\twrite: %d bytes fd=%d\n", n, f-&gt;fid);

	rhdr.count = n;
	reply(work, &amp;rhdr, 0);
}

void
reopen(Fid *f)
{
	USED(f);
	fatal("reopen");
}

void
flushaction(void *a, char *cause)
{
	USED(a);
	if(strncmp(cause, "sys:", 4) == 0 &amp;&amp; !strstr(cause, "pipe")) {
		fprint(2, "exportsrv: note: %s\n", cause);
		exits("noted");
	}
	if(strncmp(cause, "kill", 4) == 0)
		noted(NDFLT);

	noted(NCONT);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

