<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ext2srv/ext2fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ext2srv/ext2fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"

#define thdr	r-&gt;ifcall
#define rhdr	r-&gt;ofcall

extern int	errno;

static void
response(Req *r)
{
	char *err;

	if (errno) {
		err = xerrstr(errno);
		chat("%s\n", err);
		respond(r, err);
	} else {
		chat("OK\n");
		respond(r, nil);
	}
}

static void
rattach(Req *r)
{
	Xfs *xf;
	Xfile *root;

	chat("attach(fid=%d,uname=\"%s\",aname=\"%s\",afid=\"%d\")...",
		thdr.fid, thdr.uname, thdr.aname, thdr.afid);
	
	errno = 0;
	root = xfile(r-&gt;fid, Clean);
	if(!root){
		errno = Enomem;
		goto error;
	}
	root-&gt;xf = xf = getxfs(thdr.aname);
	if(!xf)
		goto error;
	
	/* now attach root inode */
	if( get_inode(root, EXT2_ROOT_INODE) &lt; 0 )
		goto error;
	
	r-&gt;fid-&gt;qid.type = QTDIR;
	r-&gt;fid-&gt;qid.vers = 0;
	root-&gt;xf-&gt;rootqid = r-&gt;fid-&gt;qid;
	root-&gt;pinbr = EXT2_ROOT_INODE;
	root-&gt;root = 1;
	rhdr.qid = r-&gt;fid-&gt;qid;
	
error:
	response(r);
}
static char *
rclone(Fid *fid, Fid *newfid)
{
	Xfile *of = xfile(fid, Asis);
	Xfile *nf = xfile(newfid, Clean);

	chat("clone(fid=%d,newfid=%d)...", fid-&gt;fid, newfid-&gt;fid);
	errno = 0;
	if(!of)
		errno = Eio;
	else if(!nf)
		errno = Enomem;
	else{
		Xfile *next = nf-&gt;next;
		*nf = *of;
		nf-&gt;next = next;
		nf-&gt;fid = newfid-&gt;fid;
		nf-&gt;root = 0;
	}
	chat("%s\n", errno? xerrstr(errno) : "OK");
	return errno ? xerrstr(errno) : 0;
}
static char *
rwalk1(Fid *fid, char *name, Qid *qid)
{
	Xfile *f=xfile(fid, Asis);
	int nr, sinbr = 0;

	chat("walk1(fid=%d,name=\"%s\")...", fid-&gt;fid, name);
	errno = 0;
	if( !f ){
		chat("no xfile...");
		goto error;
	}
	if( !(fid-&gt;qid.type &amp; QTDIR) ){
		chat("qid.type=0x%x...", fid-&gt;qid.type);
		goto error;
	}
	sinbr = f-&gt;pinbr;
	if( name == 0 || name[0] == 0 || !strcmp(name, ".") ){
		*qid = fid-&gt;qid;
		goto ok;
	}else if( !strcmp(name, "..") ){
		if( fid-&gt;qid.path == f-&gt;xf-&gt;rootqid.path ){
			chat("walkup from root...");
			*qid = fid-&gt;qid;
			goto ok;
		}
		if( get_inode(f, f-&gt;pinbr) &lt; 0 )
			goto error;
		if( f-&gt;pinbr == EXT2_ROOT_INODE ){
			*qid = f-&gt;xf-&gt;rootqid;
			f-&gt;pinbr = EXT2_ROOT_INODE;
		} else {
			*qid = (Qid){f-&gt;pinbr,0,QTDIR};
			f-&gt;inbr = f-&gt;pinbr;
			if( (nr = get_file(f, "..")) &lt; 0 )
				goto error;
			f-&gt;pinbr = nr;
		}
	}else{
		f-&gt;pinbr = f-&gt;inbr;
		if( (nr = get_file(f, name)) &lt; 0 )
			goto error;
		if( get_inode(f, nr) &lt; 0 )
			goto error;
		*qid = (Qid){nr,0,0};
		if( nr == EXT2_ROOT_INODE )
			*qid = f-&gt;xf-&gt;rootqid;
		else if( S_ISDIR(getmode(f)) )
			 qid-&gt;type = QTDIR;
		/*strcpy(f-&gt;name, thdr.name);*/
	}
ok:
	chat("OK\n");
	return 0;
error:
	f-&gt;pinbr = sinbr;
	chat("%s\n", xerrstr(Enonexist));
	return xerrstr(Enonexist);
}
static void
rstat(Req *r)
{
	Xfile *f=xfile(r-&gt;fid, Asis);

	chat("stat(fid=%d)...", thdr.fid);
	errno = 0;
	if( !f )
		errno = Eio;
	else{
		dostat(r-&gt;fid-&gt;qid, f, &amp;r-&gt;d);
	}
	response(r);
}
static void
rwstat(Req *r)
{
	Xfile *f=xfile(r-&gt;fid, Asis);

	chat("wstat(fid=%d)...", thdr.fid);
	errno = 0;
	if( !f )
		errno = Eio;
	else
		dowstat(f, &amp;r-&gt;d);
	response(r);	
}
static void
rread(Req *r)
{
	Xfile *f; 
	int nr;

	chat("read(fid=%d,offset=%lld,count=%d)...",
		thdr.fid, thdr.offset, thdr.count);
	errno = 0;
	if ( !(f=xfile(r-&gt;fid, Asis)) )
		goto error;
	if( r-&gt;fid-&gt;qid.type &amp; QTDIR ){
		nr = readdir(f, r-&gt;rbuf, thdr.offset, thdr.count);
	}else
		nr = readfile(f, r-&gt;rbuf, thdr.offset, thdr.count);
	
	if(nr &gt;= 0){
		rhdr.count = nr;
		chat("rcnt=%d...OK\n", nr);
		respond(r, nil);
		return;
	}
error:
	errno = Eio;
	response(r);
}
static void
rwrite(Req *r)
{
	Xfile *f; int nr;
	
	chat("write(fid=%d,offset=%lld,count=%d)...",
		thdr.fid, thdr.offset, thdr.count);

	errno = 0;
	if (!(f=xfile(r-&gt;fid, Asis)) ){
		errno = Eio;
		goto error;
	}
	if( !S_ISREG(getmode(f)) ){
		errno = Elink;
		goto error;
	}
	nr = writefile(f, thdr.data, thdr.offset, thdr.count);
	if(nr &gt;= 0){	
		rhdr.count = nr;
		chat("rcnt=%d...OK\n", nr);
		respond(r, nil);
		return;
	}
	errno = Eio;
error:
	response(r);
}
static void
destroyfid(Fid *fid)
{
	chat("destroy(fid=%d)\n", fid-&gt;fid);
	xfile(fid, Clunk);
	/*syncbuf(xf);*/
}
static void
ropen(Req *r)
{
	Xfile *f;

	chat("open(fid=%d,mode=%d)...", thdr.fid, thdr.mode);

	errno = 0;
	f = xfile(r-&gt;fid, Asis);
	if( !f ){
		errno = Eio;
		goto error;
	}
	
	if(thdr.mode &amp; OTRUNC){
		if( !S_ISREG(getmode(f)) ){
			errno = Eperm;
			goto error;
		}
		if(truncfile(f) &lt; 0){
			goto error;
		}
	}
	chat("f-&gt;qid=0x%8.8lux...", r-&gt;fid-&gt;qid.path);
	rhdr.qid = r-&gt;fid-&gt;qid;
error:
	response(r);
}
static void
rcreate(Req *r)
{
	Xfile *f;
	int inr, perm;

	chat("create(fid=%d,name=\"%s\",perm=%uo,mode=%d)...",
		thdr.fid, thdr.name, thdr.perm, thdr.mode);

	errno = 0;
	if(strcmp(thdr.name, ".") == 0 || strcmp(thdr.name, "..") == 0){
		errno = Eperm;
		goto error;
	}
	f = xfile(r-&gt;fid, Asis);
	if( !f ){
		errno = Eio;
		goto error;
	}
	if( strlen(thdr.name) &gt; EXT2_NAME_LEN ){
		chat("name too long ...");
		errno = Elongname;
		goto error;
	}

	/* create */
	errno = 0;
	if( thdr.perm &amp; DMDIR ){
		perm = (thdr.perm &amp; ~0777) | 
				(getmode(f) &amp; thdr.perm &amp; 0777);
		perm |= S_IFDIR;
		inr = create_dir(f, thdr.name, perm);
	}else{
		perm = (thdr.perm &amp; (~0777|0111)) |
				(getmode(f) &amp; thdr.perm &amp; 0666);
		perm |= S_IFREG;
		inr = create_file(f, thdr.name, perm);
		
	}
	if( inr &lt; 0 )
		goto error;

	/* fill with new inode */
	f-&gt;pinbr = f-&gt;inbr;
	if( get_inode(f, inr) &lt; 0 ){
		errno = Eio;
		goto error;
	}
	r-&gt;fid-&gt;qid = (Qid){inr, 0, 0};
	if( S_ISDIR(getmode(f)) )
		r-&gt;fid-&gt;qid.type |= QTDIR;
	chat("f-&gt;qid=0x%8.8lux...", r-&gt;fid-&gt;qid.path);
	rhdr.qid = r-&gt;fid-&gt;qid;
error:
	response(r);
}
static void
rremove(Req *r)
{
	Xfile *f=xfile(r-&gt;fid, Asis);

	chat("remove(fid=%d) ...", thdr.fid);

	errno = 0;
	if(!f){
		errno = Eio;
		goto error;
	}

	/* check permission here !!!!*/

	unlink(f);

error:
	response(r);
}

Srv ext2srv = {
	.destroyfid =	destroyfid,
	.attach =	rattach,
	.stat =		rstat,
	.wstat =	rwstat,
	.clone =	rclone,
	.walk1 =	rwalk1,
	.open =		ropen,
	.read =		rread,
	.write =	rwrite,
	.create =	rcreate,
	.remove =	rremove,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

