<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ext2srv/xfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ext2srv/xfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"


static Xfs	*xhead;
static Xfile *freelist;
static Lock	xlock, freelock;

int	client;

Xfs *
getxfs(char *name)
{
	int fd;
	Dir *dir;
	Xfs *xf, *fxf;

	if(name==0 || name[0]==0)
		name = deffile;
	if(name == 0){
		errno = Enofilsys;
		return 0;
	}
	fd = open(name, rdonly ? OREAD : ORDWR);
	if(fd &lt; 0){
		errno = Enonexist;
		return 0;
	}
	if((dir = dirfstat(fd)) == 0){
		errno = Eio;
		close(fd);
		return 0;
	}
	lock(&amp;xlock);
	for(fxf=0, xf=xhead; xf; xf=xf-&gt;next){
		if(xf-&gt;ref == 0){
			if(fxf == 0)
				fxf = xf;
			continue;
		}
		if(xf-&gt;qid.path != dir-&gt;qid.path || xf-&gt;qid.vers != dir-&gt;qid.vers)
			continue;
		if(strcmp(xf-&gt;name, name) != 0 || xf-&gt;dev &lt; 0)
			continue;
		chat("incref \"%s\", dev=%d...", xf-&gt;name, xf-&gt;dev);
		++xf-&gt;ref;
		unlock(&amp;xlock);
		close(fd);
		free(dir);
		return xf;
	}
	if(fxf==0){
		fxf = malloc(sizeof(Xfs));
		if(fxf==0){
			unlock(&amp;xlock);
			close(fd);
			free(dir);
			errno = Enomem;
			return 0;
		}
		fxf-&gt;next = xhead;
		xhead = fxf;
	}
	chat("alloc \"%s\", dev=%d...", name, fd);
	fxf-&gt;name = strdup(name);
	fxf-&gt;ref = 1;
	fxf-&gt;qid = dir-&gt;qid;
	fxf-&gt;dev = fd;
	fxf-&gt;fmt = 0;
	fxf-&gt;ptr = 0;
	free(dir);
	if( ext2fs(fxf)&lt;0 ){ 
		xhead = fxf-&gt;next;
		free(fxf);
		unlock(&amp;xlock);
		return 0;
	}
	unlock(&amp;xlock);
	return fxf;
}

void
refxfs(Xfs *xf, int delta)
{
	lock(&amp;xlock);
	xf-&gt;ref += delta;
	if(xf-&gt;ref == 0){
		/*mchat("free \"%s\", dev=%d...", xf-&gt;name, xf-&gt;dev);
		dumpbuf();*/
		CleanSuper(xf);
		syncbuf();
		free(xf-&gt;name);
		purgebuf(xf);
		if(xf-&gt;dev &gt;= 0){
			close(xf-&gt;dev);
			xf-&gt;dev = -1;
		}
	}
	unlock(&amp;xlock);
}

Xfile *
xfile(Fid *fid, int flag)
{
	Xfile *f;

	f = (Xfile*)fid-&gt;aux;
	switch(flag){
	default:
		panic("xfile");
	case Asis:
		return (f &amp;&amp; f-&gt;xf &amp;&amp; f-&gt;xf-&gt;dev &lt; 0) ? 0 : f;
	case Clean:
		if (f) chat("Clean and fid-&gt;aux already exists\n");
		break;
	case Clunk:
		if(f){
			clean(f);
			lock(&amp;freelock);
			f-&gt;next = freelist;
			freelist = f;
			unlock(&amp;freelock);
			fid-&gt;aux = 0;
		}
		return 0;
	}
	if(f)
		return clean(f);
	lock(&amp;freelock);
	if(f = freelist){	/* assign = */
		freelist = f-&gt;next;
		unlock(&amp;freelock);
	} else {
		unlock(&amp;freelock);
		f = malloc(sizeof(Xfile));
	}
	fid-&gt;aux = f;
	f-&gt;fid = fid-&gt;fid;
	f-&gt;client = client;
	f-&gt;xf = 0;
	f-&gt;ptr = 0;
	f-&gt;root = 0;
	return f;
}
Xfile *
clean(Xfile *f)
{
	if(f-&gt;xf &amp;&amp; f-&gt;root){
		refxfs(f-&gt;xf, -1);
		f-&gt;xf = 0;
	}
	f-&gt;xf = 0;
	f-&gt;root = 0;
	f-&gt;dirindex = 0;
	return f;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

