<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fax/file.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fax/file.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "modem.h"

static long wd[5] = {
	1728, 2048, 2432, 1216, 864
};

void
setpageid(char *pageid, char *spool, long time, int pid, int pageno)
{
	sprint(pageid, "%s/%lud.%d.%3.3d", spool, time, pid, pageno);
}

int
createfaxfile(Modem *m, char *spool)
{
	setpageid(m-&gt;pageid, spool, m-&gt;time, m-&gt;pid, m-&gt;pageno);
	verbose("openfaxfile: %s", m-&gt;pageid);
	if((m-&gt;pagefd = create(m-&gt;pageid, OTRUNC|OWRITE, 0666)) &lt; 0)
		return seterror(m, Esys);

	fprint(m-&gt;pagefd, "TYPE=ccitt-g31\n");
	fprint(m-&gt;pagefd, "WINDOW=0 0 %ld -1\n", wd[m-&gt;fdcs[2]]);
	if(m-&gt;valid &amp; Vftsi)
		fprint(m-&gt;pagefd, "FTSI=%s\n", m-&gt;ftsi);
	fprint(m-&gt;pagefd, "FDCS=%lud,%lud,%lud,%lud,%lud,%lud,%lud,%lud\n",
		m-&gt;fdcs[0], m-&gt;fdcs[1], m-&gt;fdcs[2], m-&gt;fdcs[3],
		m-&gt;fdcs[4], m-&gt;fdcs[5], m-&gt;fdcs[6], m-&gt;fdcs[7]);
	fprint(m-&gt;pagefd, "\n");

	return Eok;
}

enum
{
	Gshdrsize=	0x40,
};

int
gsopen(Modem *m)
{
	int n;
	char bytes[Gshdrsize];

	/*
	 *  Is this gs output
	 */
	n = Bread(m-&gt;bp, bytes, Gshdrsize);
	if(n != Gshdrsize)
		return seterror(m, Esys);
	if(bytes[0]!='\0' || strcmp(bytes+1, "PC Research, Inc")!=0){
		Bseek(m-&gt;bp, 0, 0);
		return seterror(m, Esys);
	}

	m-&gt;valid |= Vtype;
	if(bytes[0x1d])
		m-&gt;vr = 1;
	else
		m-&gt;vr = 0;
	m-&gt;wd = 0;
	m-&gt;ln = 2;
	m-&gt;df = 0;
	return Eok;
}

int
picopen(Modem *m)
{
	char *p, *q;
	int i, x;

	/*
	 * Look at the header. Every page should have a valid type.
	 * The first page should have WINDOW.
	 */
	while(p = Brdline(m-&gt;bp, '\n')){
		if(Blinelen(m-&gt;bp) == 1)
			break;
		p[Blinelen(m-&gt;bp)-1] = 0;

		verbose("openfaxfile: %s", p);
		if(strcmp("TYPE=ccitt-g31", p) == 0)
			m-&gt;valid |= Vtype;
		/*
		else if(m-&gt;pageno == 1 &amp;&amp; strncmp("PHONE=", p, 6) == 0){
			strcpy(m-&gt;number, p+6);
			m-&gt;valid |= Vphone;
		}
		 */
		else if(m-&gt;pageno == 1 &amp;&amp; strncmp("WINDOW=", p, 7) == 0){
			p += 7;
			verbose("openfaxfile: WINDOW: %s", p);
			for(i = 0; i &lt; 4; i++){
				x = strtol(p, &amp;q, 10);
				if(i == 2)
					m-&gt;wd = x;
				if((p = q) == 0){
					Bterm(m-&gt;bp);
					return seterror(m, Eproto);
				}
			}
			for(i = 0; i &lt; 5; i++){
				if(m-&gt;wd == wd[i]){
					m-&gt;wd = i;
					m-&gt;valid |= Vwd;
					break;
				}
			}
			if((m-&gt;valid &amp; Vwd) == 0){
				Bterm(m-&gt;bp);
				return seterror(m, Eproto);
			}
		}
		else if(m-&gt;pageno == 1 &amp;&amp; strncmp("FDCS=", p, 5) == 0){
			p += 5;
			m-&gt;df = m-&gt;vr = m-&gt;wd = 0;
			m-&gt;ln = 2;
			for(i = 0; i &lt; 5; i++){
				x = strtol(p, &amp;q, 10);
				switch(i){
				case 0:
					m-&gt;vr = x;
					break;
				case 3:
					m-&gt;ln = x;
					break;
				case 4:
					m-&gt;df = x;
					break;
				}
				if((p = q) == 0){
					Bterm(m-&gt;bp);
					return seterror(m, Eproto);
				}
				if(*p++ != ',')
					break;
			}
		}
	}

	verbose("openfaxfile: valid #%4.4ux", m-&gt;valid);
	if((m-&gt;valid &amp; (Vtype|Vwd)) != (Vtype|Vwd)){
		Bterm(m-&gt;bp);
		return seterror(m, Eproto);
	}

	return Eok;
}

int
openfaxfile(Modem *m, char *file)
{
	if((m-&gt;bp = Bopen(file, OREAD)) == 0)
		return seterror(m, Esys);
	m-&gt;valid &amp;= ~(Vtype);

	if(gsopen(m) == Eok)
		return Eok;
	return picopen(m);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

