<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/9dir.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/9dir.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

#include "9.h"

/* one entry buffer for reading directories */
struct DirBuf {
	DirEntryEnum*	dee;
	int		valid;
	DirEntry	de;
};

static DirBuf*
dirBufAlloc(File* file)
{
	DirBuf *db;

	db = vtMemAllocZ(sizeof(DirBuf));
	db-&gt;dee = deeOpen(file);
	if(db-&gt;dee == nil){
		/* can happen if dir is removed from under us */
		vtMemFree(db);
		return nil;
	}
	return db;
}

void
dirBufFree(DirBuf* db)
{
	if(db == nil)
		return;

	if(db-&gt;valid)
		deCleanup(&amp;db-&gt;de);
	deeClose(db-&gt;dee);
	vtMemFree(db);
}

int
dirDe2M(DirEntry* de, uchar* p, int np)
{
	int n;
	Dir dir;

	memset(&amp;dir, 0, sizeof(Dir));

	dir.qid.path = de-&gt;qid;
	dir.qid.vers = de-&gt;mcount;
	dir.mode = de-&gt;mode &amp; 0777;
	if(de-&gt;mode &amp; ModeAppend){
		dir.qid.type |= QTAPPEND;
		dir.mode |= DMAPPEND;
	}
	if(de-&gt;mode &amp; ModeExclusive){
		dir.qid.type |= QTEXCL;
		dir.mode |= DMEXCL;
	}
	if(de-&gt;mode &amp; ModeDir){
		dir.qid.type |= QTDIR;
		dir.mode |= DMDIR;
	}
	if(de-&gt;mode &amp; ModeSnapshot){
		dir.qid.type |= QTMOUNT;	/* just for debugging */
		dir.mode |= DMMOUNT;
	}
	if(de-&gt;mode &amp; ModeTemporary){
		dir.qid.type |= QTTMP;
		dir.mode |= DMTMP;
	}

	dir.atime = de-&gt;atime;
	dir.mtime = de-&gt;mtime;
	dir.length = de-&gt;size;

	dir.name = de-&gt;elem;
	if((dir.uid = unameByUid(de-&gt;uid)) == nil)
		dir.uid = smprint("(%s)", de-&gt;uid);
	if((dir.gid = unameByUid(de-&gt;gid)) == nil)
		dir.gid = smprint("(%s)", de-&gt;gid);
	if((dir.muid = unameByUid(de-&gt;mid)) == nil)
		dir.muid = smprint("(%s)", de-&gt;mid);

	n = convD2M(&amp;dir, p, np);

	vtMemFree(dir.muid);
	vtMemFree(dir.gid);
	vtMemFree(dir.uid);

	return n;
}

int
dirRead(Fid* fid, uchar* p, int count, vlong offset)
{
	int n, nb;
	DirBuf *db;

	/*
	 * special case of rewinding a directory
	 * otherwise ignore the offset
	 */
	if(offset == 0 &amp;&amp; fid-&gt;db){
		dirBufFree(fid-&gt;db);
		fid-&gt;db = nil;
	}

	if(fid-&gt;db == nil){
		fid-&gt;db = dirBufAlloc(fid-&gt;file);
		if(fid-&gt;db == nil)
			return -1;
	}

	db = fid-&gt;db;

	for(nb = 0; nb &lt; count; nb += n){
		if(!db-&gt;valid){
			n = deeRead(db-&gt;dee, &amp;db-&gt;de);
			if(n &lt; 0)
				return -1;
			if(n == 0)
				break;
			db-&gt;valid = 1;
		}
		n = dirDe2M(&amp;db-&gt;de, p+nb, count-nb);
		if(n &lt;= BIT16SZ)
			break;
		db-&gt;valid = 0;
		deCleanup(&amp;db-&gt;de);
	}

	return nb;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

