<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/9p.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/9p.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"

#include "9.h"

enum {
	OMODE		= 0x7,		/* Topen/Tcreate mode */
};

enum {
	PermX		= 1,
	PermW		= 2,
	PermR		= 4,
};

static char EPermission[] = "permission denied";

static int
permFile(File* file, Fid* fid, int perm)
{
	char *u;
	DirEntry de;

	if(!fileGetDir(file, &amp;de))
		return -1;

	/*
	 * User none only gets other permissions.
	 */
	if(strcmp(fid-&gt;uname, unamenone) != 0){
		/*
		 * There is only one uid&lt;-&gt;uname mapping
		 * and it's already cached in the Fid, but
		 * it might have changed during the lifetime
		 * if this Fid.
		 */
		if((u = unameByUid(de.uid)) != nil){
			if(strcmp(fid-&gt;uname, u) == 0 &amp;&amp; ((perm&lt;&lt;6) &amp; de.mode)){
				vtMemFree(u);
				deCleanup(&amp;de);
				return 1;
			}
			vtMemFree(u);
		}
		if(groupMember(de.gid, fid-&gt;uname) &amp;&amp; ((perm&lt;&lt;3) &amp; de.mode)){
			deCleanup(&amp;de);
			return 1;
		}
	}
	if(perm &amp; de.mode){
		if(perm == PermX &amp;&amp; (de.mode &amp; ModeDir)){
			deCleanup(&amp;de);
			return 1;
		}
		if(!groupMember(uidnoworld, fid-&gt;uname)){
			deCleanup(&amp;de);
			return 1;
		}
	}
	if(fsysNoPermCheck(fid-&gt;fsys) || (fid-&gt;con-&gt;flags&amp;ConNoPermCheck)){
		deCleanup(&amp;de);
		return 1;
	}
	vtSetError(EPermission);

	deCleanup(&amp;de);
	return 0;
}

static int
permFid(Fid* fid, int p)
{
	return permFile(fid-&gt;file, fid, p);
}

static int
permParent(Fid* fid, int p)
{
	int r;
	File *parent;

	parent = fileGetParent(fid-&gt;file);
	r = permFile(parent, fid, p);
	fileDecRef(parent);

	return r;
}

int
validFileName(char* name)
{
	char *p;

	if(name == nil || name[0] == '\0'){
		vtSetError("no file name");
		return 0;
	}
	if(name[0] == '.'){
		if(name[1] == '\0' || (name[1] == '.' &amp;&amp; name[2] == '\0')){
			vtSetError(". and .. illegal as file name");
			return 0;
		}
	}

	for(p = name; *p != '\0'; p++){
		if((*p &amp; 0xFF) &lt; 040){
			vtSetError("bad character in file name");
			return 0;
		}
	}

	return 1;
}

static int
rTwstat(Msg* m)
{
	Dir dir;
	Fid *fid;
	ulong mode, oldmode;
	DirEntry de;
	char *gid, *strs, *uid;
	int gl, op, retval, tsync, wstatallow;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock)) == nil)
		return 0;

	gid = uid = nil;
	retval = 0;

	if(strcmp(fid-&gt;uname, unamenone) == 0 || (fid-&gt;qid.type &amp; QTAUTH)){
		vtSetError(EPermission);
		goto error0;
	}
	if(fileIsRoFs(fid-&gt;file) || !groupWriteMember(fid-&gt;uname)){
		vtSetError("read-only filesystem");
		goto error0;
	}

	if(!fileGetDir(fid-&gt;file, &amp;de))
		goto error0;

	strs = vtMemAlloc(m-&gt;t.nstat);
	if(convM2D(m-&gt;t.stat, m-&gt;t.nstat, &amp;dir, strs) == 0){
		vtSetError("wstat -- protocol botch");
		goto error;
	}

	/*
	 * Run through each of the (sub-)fields in the provided Dir
	 * checking for validity and whether it's a default:
	 * .type, .dev and .atime are completely ignored and not checked;
	 * .qid.path, .qid.vers and .muid are checked for validity but
	 * any attempt to change them is an error.
	 * .qid.type/.mode, .mtime, .name, .length, .uid and .gid can
	 * possibly be changed.
	 *
	 * 'Op' flags there are changed fields, i.e. it's not a no-op.
	 * 'Tsync' flags all fields are defaulted.
	 */
	tsync = 1;
	if(dir.qid.path != ~0){
		if(dir.qid.path != de.qid){
			vtSetError("wstat -- attempt to change qid.path");
			goto error;
		}
		tsync = 0;
	}
	if(dir.qid.vers != ~0){
		if(dir.qid.vers != de.mcount){
			vtSetError("wstat -- attempt to change qid.vers");
			goto error;
		}
		tsync = 0;
	}
	if(dir.muid != nil &amp;&amp; *dir.muid != '\0'){
		if((uid = uidByUname(dir.muid)) == nil){
			vtSetError("wstat -- unknown muid");
			goto error;
		}
		if(strcmp(uid, de.mid) != 0){
			vtSetError("wstat -- attempt to change muid");
			goto error;
		}
		vtMemFree(uid);
		uid = nil;
		tsync = 0;
	}

	/*
	 * Check .qid.type and .mode agree if neither is defaulted.
	 */
	if(dir.qid.type != (uchar)~0 &amp;&amp; dir.mode != ~0){
		if(dir.qid.type != ((dir.mode&gt;&gt;24) &amp; 0xFF)){
			vtSetError("wstat -- qid.type/mode mismatch");
			goto error;
		}
	}

	op = 0;

	oldmode = de.mode;
	if(dir.qid.type != (uchar)~0 || dir.mode != ~0){
		/*
		 * .qid.type or .mode isn't defaulted, check for unknown bits.
		 */
		if(dir.mode == ~0)
			dir.mode = (dir.qid.type&lt;&lt;24)|(de.mode &amp; 0777);
		if(dir.mode &amp; ~(DMDIR|DMAPPEND|DMEXCL|DMTMP|0777)){
			vtSetError("wstat -- unknown bits in qid.type/mode");
			goto error;
		}

		/*
		 * Synthesise a mode to check against the current settings.
		 */
		mode = dir.mode &amp; 0777;
		if(dir.mode &amp; DMEXCL)
			mode |= ModeExclusive;
		if(dir.mode &amp; DMAPPEND)
			mode |= ModeAppend;
		if(dir.mode &amp; DMDIR)
			mode |= ModeDir;
		if(dir.mode &amp; DMTMP)
			mode |= ModeTemporary;

		if((de.mode^mode) &amp; ModeDir){
			vtSetError("wstat -- attempt to change directory bit");
			goto error;
		}

		if((de.mode &amp; (ModeAppend|ModeExclusive|ModeTemporary|0777)) != mode){
			de.mode &amp;= ~(ModeAppend|ModeExclusive|ModeTemporary|0777);
			de.mode |= mode;
			op = 1;
		}
		tsync = 0;
	}

	if(dir.mtime != ~0){
		if(dir.mtime != de.mtime){
			de.mtime = dir.mtime;
			op = 1;
		}
		tsync = 0;
	}

	if(dir.length != ~0){
		if(dir.length != de.size){
			/*
			 * Cannot change length on append-only files.
			 * If we're changing the append bit, it's okay.
			 */
			if(de.mode &amp; oldmode &amp; ModeAppend){
				vtSetError("wstat -- attempt to change length of append-only file");
				goto error;
			}
			if(de.mode &amp; ModeDir){
				vtSetError("wstat -- attempt to change length of directory");
				goto error;
			}
			de.size = dir.length;
			op = 1;
		}
		tsync = 0;
	}

	/*
	 * Check for permission to change .mode, .mtime or .length,
	 * must be owner or leader of either group, for which test gid
	 * is needed; permission checks on gid will be done later.
	 */
	if(dir.gid != nil &amp;&amp; *dir.gid != '\0'){
		if((gid = uidByUname(dir.gid)) == nil){
			vtSetError("wstat -- unknown gid");
			goto error;
		}
		tsync = 0;
	}
	else
		gid = vtStrDup(de.gid);

	wstatallow = (fsysWstatAllow(fid-&gt;fsys) || (m-&gt;con-&gt;flags&amp;ConWstatAllow));

	/*
	 * 'Gl' counts whether neither, one or both groups are led.
	 */
	gl = groupLeader(gid, fid-&gt;uname) != 0;
	gl += groupLeader(de.gid, fid-&gt;uname) != 0;

	if(op &amp;&amp; !wstatallow){
		if(strcmp(fid-&gt;uid, de.uid) != 0 &amp;&amp; !gl){
			vtSetError("wstat -- not owner or group leader");
			goto error;
		}
	}

	/*
	 * Check for permission to change group, must be
	 * either owner and in new group or leader of both groups.
	 * If gid is nil here then
	 */
	if(strcmp(gid, de.gid) != 0){
		if(!wstatallow
		&amp;&amp; !(strcmp(fid-&gt;uid, de.uid) == 0 &amp;&amp; groupMember(gid, fid-&gt;uname))
		&amp;&amp; !(gl == 2)){
			vtSetError("wstat -- not owner and not group leaders");
			goto error;
		}
		vtMemFree(de.gid);
		de.gid = gid;
		gid = nil;
		op = 1;
		tsync = 0;
	}

	/*
	 * Rename.
	 * Check .name is valid and different to the current.
	 * If so, check write permission in parent.
	 */
	if(dir.name != nil &amp;&amp; *dir.name != '\0'){
		if(!validFileName(dir.name))
			goto error;
		if(strcmp(dir.name, de.elem) != 0){
			if(permParent(fid, PermW) &lt;= 0)
				goto error;
			vtMemFree(de.elem);
			de.elem = vtStrDup(dir.name);
			op = 1;
		}
		tsync = 0;
	}

	/*
	 * Check for permission to change owner - must be god.
	 */
	if(dir.uid != nil &amp;&amp; *dir.uid != '\0'){
		if((uid = uidByUname(dir.uid)) == nil){
			vtSetError("wstat -- unknown uid");
			goto error;
		}
		if(strcmp(uid, de.uid) != 0){
			if(!wstatallow){
				vtSetError("wstat -- not owner");
				goto error;
			}
			if(strcmp(uid, uidnoworld) == 0){
				vtSetError(EPermission);
				goto error;
			}
			vtMemFree(de.uid);
			de.uid = uid;
			uid = nil;
			op = 1;
		}
		tsync = 0;
	}

	if(op)
		retval = fileSetDir(fid-&gt;file, &amp;de, fid-&gt;uid);
	else
		retval = 1;

	if(tsync){
		/*
		 * All values were defaulted,
		 * make the state of the file exactly what it
		 * claims to be before returning...
		 */
		USED(tsync);
	}

error:
	deCleanup(&amp;de);
	vtMemFree(strs);
	if(gid != nil)
		vtMemFree(gid);
	if(uid != nil)
		vtMemFree(uid);
error0:
	fidPut(fid);
	return retval;
};

static int
rTstat(Msg* m)
{
	Dir dir;
	Fid *fid;
	DirEntry de;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, 0)) == nil)
		return 0;
	if(fid-&gt;qid.type &amp; QTAUTH){
		memset(&amp;dir, 0, sizeof(Dir));
		dir.qid = fid-&gt;qid;
		dir.mode = DMAUTH;
		dir.atime = time(0L);
		dir.mtime = dir.atime;
		dir.length = 0;
		dir.name = "#¿";
		dir.uid = fid-&gt;uname;
		dir.gid = fid-&gt;uname;
		dir.muid = fid-&gt;uname;

		if((m-&gt;r.nstat = convD2M(&amp;dir, m-&gt;data, m-&gt;con-&gt;msize)) == 0){
			vtSetError("stat QTAUTH botch");
			fidPut(fid);
			return 0;
		}
		m-&gt;r.stat = m-&gt;data;

		fidPut(fid);
		return 1;
	}
	if(!fileGetDir(fid-&gt;file, &amp;de)){
		fidPut(fid);
		return 0;
	}
	fidPut(fid);

	/*
	 * TODO: optimise this copy (in convS2M) away somehow.
	 * This pettifoggery with m-&gt;data will do for the moment.
	 */
	m-&gt;r.nstat = dirDe2M(&amp;de, m-&gt;data, m-&gt;con-&gt;msize);
	m-&gt;r.stat = m-&gt;data;
	deCleanup(&amp;de);

	return 1;
}

static int
_rTclunk(Fid* fid, int remove)
{
	int rok;

	if(fid-&gt;excl)
		exclFree(fid);

	rok = 1;
	if(remove &amp;&amp; !(fid-&gt;qid.type &amp; QTAUTH)){
		if((rok = permParent(fid, PermW)) &gt; 0)
			rok = fileRemove(fid-&gt;file, fid-&gt;uid);
	}
	fidClunk(fid);

	return rok;
}

static int
rTremove(Msg* m)
{
	Fid *fid;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock)) == nil)
		return 0;
	return _rTclunk(fid, 1);
}

static int
rTclunk(Msg* m)
{
	Fid *fid;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock)) == nil)
		return 0;
	_rTclunk(fid, (fid-&gt;open &amp; FidORclose));

	return 1;
}

static int
rTwrite(Msg* m)
{
	Fid *fid;
	int count, n;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, 0)) == nil)
		return 0;
	if(!(fid-&gt;open &amp; FidOWrite)){
		vtSetError("fid not open for write");
		goto error;
	}

	count = m-&gt;t.count;
	if(count &lt; 0 || count &gt; m-&gt;con-&gt;msize-IOHDRSZ){
		vtSetError("write count too big");
		goto error;
	}
	if(m-&gt;t.offset &lt; 0){
		vtSetError("write offset negative");
		goto error;
	}
	if(fid-&gt;excl != nil &amp;&amp; !exclUpdate(fid))
		goto error;

	if(fid-&gt;qid.type &amp; QTDIR){
		vtSetError("is a directory");
		goto error;
	}
	else if(fid-&gt;qid.type &amp; QTAUTH)
		n = authWrite(fid, m-&gt;t.data, count);
	else
		n = fileWrite(fid-&gt;file, m-&gt;t.data, count, m-&gt;t.offset, fid-&gt;uid);
	if(n &lt; 0)
		goto error;


	m-&gt;r.count = n;

	fidPut(fid);
	return 1;

error:
	fidPut(fid);
	return 0;
}

static int
rTread(Msg* m)
{
	Fid *fid;
	uchar *data;
	int count, n;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, 0)) == nil)
		return 0;
	if(!(fid-&gt;open &amp; FidORead)){
		vtSetError("fid not open for read");
		goto error;
	}

	count = m-&gt;t.count;
	if(count &lt; 0 || count &gt; m-&gt;con-&gt;msize-IOHDRSZ){
		vtSetError("read count too big");
		goto error;
	}
	if(m-&gt;t.offset &lt; 0){
		vtSetError("read offset negative");
		goto error;
	}
	if(fid-&gt;excl != nil &amp;&amp; !exclUpdate(fid))
		goto error;

	/*
	 * TODO: optimise this copy (in convS2M) away somehow.
	 * This pettifoggery with m-&gt;data will do for the moment.
	 */
	data = m-&gt;data+IOHDRSZ;
	if(fid-&gt;qid.type &amp; QTDIR)
		n = dirRead(fid, data, count, m-&gt;t.offset);
	else if(fid-&gt;qid.type &amp; QTAUTH)
		n = authRead(fid, data, count);
	else
		n = fileRead(fid-&gt;file, data, count, m-&gt;t.offset);
	if(n &lt; 0)
		goto error;

	m-&gt;r.count = n;
	m-&gt;r.data = (char*)data;

	fidPut(fid);
	return 1;

error:
	fidPut(fid);
	return 0;
}

static int
rTcreate(Msg* m)
{
	Fid *fid;
	File *file;
	ulong mode;
	int omode, open, perm;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock)) == nil)
		return 0;
	if(fid-&gt;open){
		vtSetError("fid open for I/O");
		goto error;
	}
	if(fileIsRoFs(fid-&gt;file) || !groupWriteMember(fid-&gt;uname)){
		vtSetError("read-only filesystem");
		goto error;
	}
	if(!fileIsDir(fid-&gt;file)){
		vtSetError("not a directory");
		goto error;
	}
	if(permFid(fid, PermW) &lt;= 0)
		goto error;
	if(!validFileName(m-&gt;t.name))
		goto error;
	if(strcmp(fid-&gt;uid, uidnoworld) == 0){
		vtSetError(EPermission);
		goto error;
	}

	omode = m-&gt;t.mode &amp; OMODE;
	open = 0;

	if(omode == OREAD || omode == ORDWR || omode == OEXEC)
		open |= FidORead;
	if(omode == OWRITE || omode == ORDWR)
		open |= FidOWrite;
	if((open &amp; (FidOWrite|FidORead)) == 0){
		vtSetError("unknown mode");
		goto error;
	}
	if(m-&gt;t.perm &amp; DMDIR){
		if((m-&gt;t.mode &amp; (ORCLOSE|OTRUNC)) || (open &amp; FidOWrite)){
			vtSetError("illegal mode");
			goto error;
		}
		if(m-&gt;t.perm &amp; DMAPPEND){
			vtSetError("illegal perm");
			goto error;
		}
	}

	mode = fileGetMode(fid-&gt;file);
	perm = m-&gt;t.perm;
	if(m-&gt;t.perm &amp; DMDIR)
		perm &amp;= ~0777|(mode &amp; 0777);
	else
		perm &amp;= ~0666|(mode &amp; 0666);
	mode = perm &amp; 0777;
	if(m-&gt;t.perm &amp; DMDIR)
		mode |= ModeDir;
	if(m-&gt;t.perm &amp; DMAPPEND)
		mode |= ModeAppend;
	if(m-&gt;t.perm &amp; DMEXCL)
		mode |= ModeExclusive;
	if(m-&gt;t.perm &amp; DMTMP)
		mode |= ModeTemporary;

	if((file = fileCreate(fid-&gt;file, m-&gt;t.name, mode, fid-&gt;uid)) == nil){
		fidPut(fid);
		return 0;
	}
	fileDecRef(fid-&gt;file);

	fid-&gt;qid.vers = fileGetMcount(file);
	fid-&gt;qid.path = fileGetId(file);
	fid-&gt;file = file;
	mode = fileGetMode(fid-&gt;file);
	if(mode &amp; ModeDir)
		fid-&gt;qid.type = QTDIR;
	else
		fid-&gt;qid.type = QTFILE;
	if(mode &amp; ModeAppend)
		fid-&gt;qid.type |= QTAPPEND;
	if(mode &amp; ModeExclusive){
		fid-&gt;qid.type |= QTEXCL;
		assert(exclAlloc(fid) != 0);
	}
	if(m-&gt;t.mode &amp; ORCLOSE)
		open |= FidORclose;
	fid-&gt;open = open;

	m-&gt;r.qid = fid-&gt;qid;
	m-&gt;r.iounit = m-&gt;con-&gt;msize-IOHDRSZ;

	fidPut(fid);
	return 1;

error:
	fidPut(fid);
	return 0;
}

static int
rTopen(Msg* m)
{
	Fid *fid;
	int isdir, mode, omode, open, rofs;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock)) == nil)
		return 0;
	if(fid-&gt;open){
		vtSetError("fid open for I/O");
		goto error;
	}

	isdir = fileIsDir(fid-&gt;file);
	open = 0;
	rofs = fileIsRoFs(fid-&gt;file) || !groupWriteMember(fid-&gt;uname);

	if(m-&gt;t.mode &amp; ORCLOSE){
		if(isdir){
			vtSetError("is a directory");
			goto error;
		}
		if(rofs){
			vtSetError("read-only filesystem");
			goto error;
		}
		if(permParent(fid, PermW) &lt;= 0)
			goto error;

		open |= FidORclose;
	}

	omode = m-&gt;t.mode &amp; OMODE;
	if(omode == OREAD || omode == ORDWR){
		if(permFid(fid, PermR) &lt;= 0)
			goto error;
		open |= FidORead;
	}
	if(omode == OWRITE || omode == ORDWR || (m-&gt;t.mode &amp; OTRUNC)){
		if(isdir){
			vtSetError("is a directory");
			goto error;
		}
		if(rofs){
			vtSetError("read-only filesystem");
			goto error;
		}
		if(permFid(fid, PermW) &lt;= 0)
			goto error;
		open |= FidOWrite;
	}
	if(omode == OEXEC){
		if(isdir){
			vtSetError("is a directory");
			goto error;
		}
		if(permFid(fid, PermX) &lt;= 0)
			goto error;
		open |= FidORead;
	}
	if((open &amp; (FidOWrite|FidORead)) == 0){
		vtSetError("unknown mode");
		goto error;
	}

	mode = fileGetMode(fid-&gt;file);
	if((mode &amp; ModeExclusive) &amp;&amp; exclAlloc(fid) == 0)
		goto error;

	/*
	 * Everything checks out, try to commit any changes.
	 */
	if((m-&gt;t.mode &amp; OTRUNC) &amp;&amp; !(mode &amp; ModeAppend))
		if(!fileTruncate(fid-&gt;file, fid-&gt;uid))
			goto error;

	if(isdir &amp;&amp; fid-&gt;db != nil){
		dirBufFree(fid-&gt;db);
		fid-&gt;db = nil;
	}

	fid-&gt;qid.vers = fileGetMcount(fid-&gt;file);
	m-&gt;r.qid = fid-&gt;qid;
	m-&gt;r.iounit = m-&gt;con-&gt;msize-IOHDRSZ;

	fid-&gt;open = open;

	fidPut(fid);
	return 1;

error:
	if(fid-&gt;excl != nil)
		exclFree(fid);
	fidPut(fid);
	return 0;
}

static int
rTwalk(Msg* m)
{
	Qid qid;
	Fcall *r, *t;
	int nwname, wlock;
	File *file, *nfile;
	Fid *fid, *ofid, *nfid;

	t = &amp;m-&gt;t;
	if(t-&gt;fid == t-&gt;newfid)
		wlock = FidFWlock;
	else
		wlock = 0;

	/*
	 * The file identified by t-&gt;fid must be valid in the
	 * current session and must not have been opened for I/O
	 * by an open or create message.
	 */
	if((ofid = fidGet(m-&gt;con, t-&gt;fid, wlock)) == nil)
		return 0;
	if(ofid-&gt;open){
		vtSetError("file open for I/O");
		fidPut(ofid);
		return 0;
	}

	/*
	 * If newfid is not the same as fid, allocate a new file;
	 * a side effect is checking newfid is not already in use (error);
	 * if there are no names to walk this will be equivalent to a
	 * simple 'clone' operation.
	 * It's a no-op if newfid is the same as fid and t-&gt;nwname is 0.
	 */
	nfid = nil;
	if(t-&gt;fid != t-&gt;newfid){
		nfid = fidGet(m-&gt;con, t-&gt;newfid, FidFWlock|FidFCreate);
		if(nfid == nil){
			vtSetError("%s: walk: newfid 0x%ud in use",
				argv0, t-&gt;newfid);
			fidPut(ofid);
			return 0;
		}
		nfid-&gt;open = ofid-&gt;open &amp; ~FidORclose;
		nfid-&gt;file = fileIncRef(ofid-&gt;file);
		nfid-&gt;qid = ofid-&gt;qid;
		nfid-&gt;uid = vtStrDup(ofid-&gt;uid);
		nfid-&gt;uname = vtStrDup(ofid-&gt;uname);
		nfid-&gt;fsys = fsysIncRef(ofid-&gt;fsys);
		fid = nfid;
	}
	else
		fid = ofid;

	r = &amp;m-&gt;r;
	r-&gt;nwqid = 0;

	if(t-&gt;nwname == 0){
		if(nfid != nil)
			fidPut(nfid);
		fidPut(ofid);

		return 1;
	}

	file = fid-&gt;file;
	fileIncRef(file);
	qid = fid-&gt;qid;

	for(nwname = 0; nwname &lt; t-&gt;nwname; nwname++){
		/*
		 * Walked elements must represent a directory and
		 * the implied user must have permission to search
		 * the directory.  Walking .. is always allowed, so that
		 * you can't walk into a directory and then not be able
		 * to walk out of it.
		 */
		if(!(qid.type &amp; QTDIR)){
			vtSetError("not a directory");
			break;
		}
		switch(permFile(file, fid, PermX)){
		case 1:
			break;
		case 0:
			if(strcmp(t-&gt;wname[nwname], "..") == 0)
				break;
		case -1:
			goto Out;
		}
		if((nfile = fileWalk(file, t-&gt;wname[nwname])) == nil)
			break;
		fileDecRef(file);
		file = nfile;
		qid.type = QTFILE;
		if(fileIsDir(file))
			qid.type = QTDIR;
		if(fileIsAppend(file))
			qid.type |= QTAPPEND;
		if(fileIsTemporary(file))
			qid.type |= QTTMP;
		if(fileIsExclusive(file))
			qid.type |= QTEXCL;
		qid.vers = fileGetMcount(file);
		qid.path = fileGetId(file);
		r-&gt;wqid[r-&gt;nwqid++] = qid;
	}

	if(nwname == t-&gt;nwname){
		/*
		 * Walked all elements. Update the target fid
		 * from the temporary qid used during the walk,
		 * and tidy up.
		 */
		fid-&gt;qid = r-&gt;wqid[r-&gt;nwqid-1];
		fileDecRef(fid-&gt;file);
		fid-&gt;file = file;

		if(nfid != nil)
			fidPut(nfid);

		fidPut(ofid);
		return 1;
	}

Out:
	/*
	 * Didn't walk all elements, 'clunk' nfid if it exists
	 * and leave fid untouched.
	 * It's not an error if some of the elements were walked OK.
	 */
	fileDecRef(file);
	if(nfid != nil)
		fidClunk(nfid);

	fidPut(ofid);
	if(nwname == 0)
		return 0;
	return 1;
}

static int
rTflush(Msg* m)
{
	if(m-&gt;t.oldtag != NOTAG)
		msgFlush(m);
	return 1;
}

static void
parseAname(char *aname, char **fsname, char **path)
{
	char *s;

	if(aname &amp;&amp; aname[0])
		s = vtStrDup(aname);
	else
		s = vtStrDup("main/active");
	*fsname = s;
	if((*path = strchr(s, '/')) != nil)
		*(*path)++ = '\0';
	else
		*path = "";
}

/*
 * Check remote IP address against /mnt/ipok.
 * Sources.cs.bell-labs.com uses this to disallow
 * network connections from Sudan, Libya, etc., 
 * following U.S. cryptography export regulations.
 */
static int
conIPCheck(Con* con)
{
	char ok[256], *p;
	int fd;

	if(con-&gt;flags&amp;ConIPCheck){
		if(con-&gt;remote[0] == 0){
			vtSetError("cannot verify unknown remote address");
			return 0;
		}
		if(access("/mnt/ipok/ok", AEXIST) &lt; 0){
			/* mount closes the fd on success */
			if((fd = open("/srv/ipok", ORDWR)) &gt;= 0 
			&amp;&amp; mount(fd, -1, "/mnt/ipok", MREPL, "") &lt; 0)
				close(fd);
			if(access("/mnt/ipok/ok", AEXIST) &lt; 0){
				vtSetError("cannot verify remote address");
				return 0;
			}
		}
		snprint(ok, sizeof ok, "/mnt/ipok/ok/%s", con-&gt;remote);
		if((p = strchr(ok, '!')) != nil)
			*p = 0;
		if(access(ok, AEXIST) &lt; 0){
			vtSetError("restricted remote address");
			return 0;
		}
	}
	return 1;
}

static int
rTattach(Msg* m)
{
	Fid *fid;
	Fsys *fsys;
	char *fsname, *path;

	if((fid = fidGet(m-&gt;con, m-&gt;t.fid, FidFWlock|FidFCreate)) == nil)
		return 0;

	parseAname(m-&gt;t.aname, &amp;fsname, &amp;path);
	if((fsys = fsysGet(fsname)) == nil){
		fidClunk(fid);
		vtMemFree(fsname);
		return 0;
	}
	fid-&gt;fsys = fsys;

	if(m-&gt;t.uname[0] != '\0')
		fid-&gt;uname = vtStrDup(m-&gt;t.uname);
	else
		fid-&gt;uname = vtStrDup(unamenone);

	if((fid-&gt;con-&gt;flags&amp;ConIPCheck) &amp;&amp; !conIPCheck(fid-&gt;con)){
		consPrint("reject %s from %s: %R\n", fid-&gt;uname, fid-&gt;con-&gt;remote);
		fidClunk(fid);
		vtMemFree(fsname);
		return 0;
	}
	if(fsysNoAuthCheck(fsys) || (m-&gt;con-&gt;flags&amp;ConNoAuthCheck)){
		if((fid-&gt;uid = uidByUname(fid-&gt;uname)) == nil)
			fid-&gt;uid = vtStrDup(unamenone);
	}
	else if(!authCheck(&amp;m-&gt;t, fid, fsys)){
		fidClunk(fid);
		vtMemFree(fsname);
		return 0;
	}

	fsysFsRlock(fsys);
	if((fid-&gt;file = fsysGetRoot(fsys, path)) == nil){
		fsysFsRUnlock(fsys);
		fidClunk(fid);
		vtMemFree(fsname);
		return 0;
	}
	fsysFsRUnlock(fsys);
	vtMemFree(fsname);

	fid-&gt;qid = (Qid){fileGetId(fid-&gt;file), 0, QTDIR};
	m-&gt;r.qid = fid-&gt;qid;

	fidPut(fid);
	return 1;
}

static int
rTauth(Msg* m)
{
	int afd;
	Con *con;
	Fid *afid;
	Fsys *fsys;
	char *fsname, *path;

	parseAname(m-&gt;t.aname, &amp;fsname, &amp;path);
	if((fsys = fsysGet(fsname)) == nil){
		vtMemFree(fsname);
		return 0;
	}
	vtMemFree(fsname);

	if(fsysNoAuthCheck(fsys) || (m-&gt;con-&gt;flags&amp;ConNoAuthCheck)){
		m-&gt;con-&gt;aok = 1;
		vtSetError("authentication disabled");
		fsysPut(fsys);
		return 0;
	}
	if(strcmp(m-&gt;t.uname, unamenone) == 0){
		vtSetError("user 'none' requires no authentication");
		fsysPut(fsys);
		return 0;
	}

	con = m-&gt;con;
	if((afid = fidGet(con, m-&gt;t.afid, FidFWlock|FidFCreate)) == nil){
		fsysPut(fsys);
		return 0;
	}
	afid-&gt;fsys = fsys;

	if((afd = open("/mnt/factotum/rpc", ORDWR)) &lt; 0){
		vtSetError("can't open \"/mnt/factotum/rpc\"");
		fidClunk(afid);
		return 0;
	}
	if((afid-&gt;rpc = auth_allocrpc(afd)) == nil){
		close(afd);
		vtSetError("can't auth_allocrpc");
		fidClunk(afid);
		return 0;
	}
	if(auth_rpc(afid-&gt;rpc, "start", "proto=p9any role=server", 23) != ARok){
		vtSetError("can't auth_rpc");
		fidClunk(afid);
		return 0;
	}

	afid-&gt;open = FidOWrite|FidORead;
	afid-&gt;qid.type = QTAUTH;
	afid-&gt;qid.path = m-&gt;t.afid;
	afid-&gt;uname = vtStrDup(m-&gt;t.uname);

	m-&gt;r.qid = afid-&gt;qid;

	fidPut(afid);
	return 1;
}

static int
rTversion(Msg* m)
{
	int v;
	Con *con;
	Fcall *r, *t;

	t = &amp;m-&gt;t;
	r = &amp;m-&gt;r;
	con = m-&gt;con;

	vtLock(con-&gt;lock);
	if(con-&gt;state != ConInit){
		vtUnlock(con-&gt;lock);
		vtSetError("Tversion: down");
		return 0;
	}
	con-&gt;state = ConNew;

	/*
	 * Release the karma of past lives and suffering.
	 * Should this be done before or after checking the
	 * validity of the Tversion?
	 */
	fidClunkAll(con);

	if(t-&gt;tag != NOTAG){
		vtUnlock(con-&gt;lock);
		vtSetError("Tversion: invalid tag");
		return 0;
	}

	if(t-&gt;msize &lt; 256){
		vtUnlock(con-&gt;lock);
		vtSetError("Tversion: message size too small");
		return 0;
	}
	if(t-&gt;msize &lt; con-&gt;msize)
		r-&gt;msize = t-&gt;msize;
	else
		r-&gt;msize = con-&gt;msize;

	r-&gt;version = "unknown";
	if(t-&gt;version[0] == '9' &amp;&amp; t-&gt;version[1] == 'P'){
		/*
		 * Currently, the only defined version
		 * is "9P2000"; ignore any later versions.
		 */
		v = strtol(&amp;t-&gt;version[2], 0, 10);
		if(v &gt;= 2000){
			r-&gt;version = VERSION9P;
			con-&gt;msize = r-&gt;msize;
			con-&gt;state = ConUp;
		}
		else if(strcmp(t-&gt;version, "9PEoF") == 0){
			r-&gt;version = "9PEoF";
			con-&gt;msize = r-&gt;msize;
			con-&gt;state = ConMoribund;

			/*
			 * Don't want to attempt to write this
			 * message as the connection may be already
			 * closed.
			 */
			m-&gt;state = MsgF;
		}
	}
	vtUnlock(con-&gt;lock);

	return 1;
}

int (*rFcall[Tmax])(Msg*) = {
	[Tversion]	= rTversion,
	[Tauth]		= rTauth,
	[Tattach]	= rTattach,
	[Tflush]	= rTflush,
	[Twalk]		= rTwalk,
	[Topen]		= rTopen,
	[Tcreate]	= rTcreate,
	[Tread]		= rTread,
	[Twrite]	= rTwrite,
	[Tclunk]	= rTclunk,
	[Tremove]	= rTremove,
	[Tstat]		= rTstat,
	[Twstat]	= rTwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

