<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/bwatch.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/bwatch.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "error.h"

/*
 * Lock watcher.  Check that locking of blocks is always down.
 *
 * This is REALLY slow, and it won't work when the blocks aren't
 * arranged in a tree (e.g., after the first snapshot).  But it's great
 * for debugging.
 */
enum
{
	MaxLock = 16,
	HashSize = 1009,
};

/*
 * Thread-specific watch state.
 */
typedef struct WThread WThread;
struct WThread
{
	Block *b[MaxLock];	/* blocks currently held */
	uint nb;
	uint pid;
};

typedef struct WMap WMap;
typedef struct WEntry WEntry;

struct WEntry
{
	uchar c[VtScoreSize];
	uchar p[VtScoreSize];
	int off;

	WEntry *cprev;
	WEntry *cnext;
	WEntry *pprev;
	WEntry *pnext;
};

struct WMap
{
	VtLock *lk;

	WEntry *hchild[HashSize];
	WEntry *hparent[HashSize];
};

static WMap map;
static void **wp;
static uint blockSize;
static WEntry *pool;
uint bwatchDisabled;

static uint
hash(uchar score[VtScoreSize])
{
	uint i, h;

	h = 0;
	for(i=0; i&lt;VtScoreSize; i++)
		h = h*37 + score[i];
	return h%HashSize;
}

#include &lt;pool.h&gt;
static void
freeWEntry(WEntry *e)
{
	memset(e, 0, sizeof(WEntry));
	e-&gt;pnext = pool;
	pool = e;
}

static WEntry*
allocWEntry(void)
{
	int i;
	WEntry *w;

	w = pool;
	if(w == nil){
		w = vtMemAllocZ(1024*sizeof(WEntry));
		for(i=0; i&lt;1024; i++)
			freeWEntry(&amp;w[i]);
		w = pool;
	}
	pool = w-&gt;pnext;
	memset(w, 0, sizeof(WEntry));
	return w;
}

/*
 * remove all dependencies with score as a parent
 */
static void
_bwatchResetParent(uchar *score)
{
	WEntry *w, *next;
	uint h;

	h = hash(score);
	for(w=map.hparent[h]; w; w=next){
		next = w-&gt;pnext;
		if(memcmp(w-&gt;p, score, VtScoreSize) == 0){
			if(w-&gt;pnext)
				w-&gt;pnext-&gt;pprev = w-&gt;pprev;
			if(w-&gt;pprev)
				w-&gt;pprev-&gt;pnext = w-&gt;pnext;
			else
				map.hparent[h] = w-&gt;pnext;
			if(w-&gt;cnext)
				w-&gt;cnext-&gt;cprev = w-&gt;cprev;
			if(w-&gt;cprev)
				w-&gt;cprev-&gt;cnext = w-&gt;cnext;
			else
				map.hchild[hash(w-&gt;c)] = w-&gt;cnext;
			freeWEntry(w);
		}
	}
}
/*
 * and child 
 */
static void
_bwatchResetChild(uchar *score)
{
	WEntry *w, *next;
	uint h;

	h = hash(score);
	for(w=map.hchild[h]; w; w=next){
		next = w-&gt;cnext;
		if(memcmp(w-&gt;c, score, VtScoreSize) == 0){
			if(w-&gt;pnext)
				w-&gt;pnext-&gt;pprev = w-&gt;pprev;
			if(w-&gt;pprev)
				w-&gt;pprev-&gt;pnext = w-&gt;pnext;
			else
				map.hparent[hash(w-&gt;p)] = w-&gt;pnext;
			if(w-&gt;cnext)
				w-&gt;cnext-&gt;cprev = w-&gt;cprev;
			if(w-&gt;cprev)
				w-&gt;cprev-&gt;cnext = w-&gt;cnext;
			else
				map.hchild[h] = w-&gt;cnext;
			freeWEntry(w);
		}
	}
}

static uchar*
parent(uchar c[VtScoreSize], int *off)
{
	WEntry *w;
	uint h;

	h = hash(c);
	for(w=map.hchild[h]; w; w=w-&gt;cnext)
		if(memcmp(w-&gt;c, c, VtScoreSize) == 0){
			*off = w-&gt;off;
			return w-&gt;p;
		}
	return nil;
}

static void
addChild(uchar p[VtEntrySize], uchar c[VtEntrySize], int off)
{
	uint h;
	WEntry *w;

	w = allocWEntry();
	memmove(w-&gt;p, p, VtScoreSize);
	memmove(w-&gt;c, c, VtScoreSize);
	w-&gt;off = off;

	h = hash(p);
	w-&gt;pnext = map.hparent[h];
	if(w-&gt;pnext)
		w-&gt;pnext-&gt;pprev = w;
	map.hparent[h] = w;

	h = hash(c);
	w-&gt;cnext = map.hchild[h];
	if(w-&gt;cnext)
		w-&gt;cnext-&gt;cprev = w;
	map.hchild[h] = w;
}

void
bwatchReset(uchar score[VtScoreSize])
{
	vtLock(map.lk);
	_bwatchResetParent(score);
	_bwatchResetChild(score);
	vtUnlock(map.lk);
}

void
bwatchInit(void)
{
	map.lk = vtLockAlloc();
	wp = privalloc();
	*wp = nil;
}

void
bwatchSetBlockSize(uint bs)
{
	blockSize = bs;
}

static WThread*
getWThread(void)
{
	WThread *w;

	w = *wp;
	if(w == nil || w-&gt;pid != getpid()){
		w = vtMemAllocZ(sizeof(WThread));
		*wp = w;
		w-&gt;pid = getpid();
	}
	return w;
}

/*
 * Derive dependencies from the contents of b.
 */
void
bwatchDependency(Block *b)
{
	int i, epb, ppb;
	Entry e;

	if(bwatchDisabled)
		return;

	vtLock(map.lk);
	_bwatchResetParent(b-&gt;score);

	switch(b-&gt;l.type){
	case BtData:
		break;

	case BtDir:
		epb = blockSize / VtEntrySize;
		for(i=0; i&lt;epb; i++){
			entryUnpack(&amp;e, b-&gt;data, i);
			if(!(e.flags &amp; VtEntryActive))
				continue;
			addChild(b-&gt;score, e.score, i);
		}
		break;

	default:
		ppb = blockSize / VtScoreSize;
		for(i=0; i&lt;ppb; i++)
			addChild(b-&gt;score, b-&gt;data+i*VtScoreSize, i);
		break;
	}
	vtUnlock(map.lk);
}

static int
depth(uchar *s)
{
	int d, x;

	d = -1;
	while(s){
		d++;
		s = parent(s, &amp;x);
	}
	return d;
}

static int
lockConflicts(uchar xhave[VtScoreSize], uchar xwant[VtScoreSize])
{
	uchar *have, *want;
	int havedepth, wantdepth, havepos, wantpos;

	have = xhave;
	want = xwant;

	havedepth = depth(have);
	wantdepth = depth(want);

	/*
	 * walk one or the other up until they're both
 	 * at the same level.
	 */
	havepos = -1;
	wantpos = -1;
	have = xhave;
	want = xwant;
	while(wantdepth &gt; havedepth){
		wantdepth--;
		want = parent(want, &amp;wantpos);
	}
	while(havedepth &gt; wantdepth){
		havedepth--;
		have = parent(have, &amp;havepos);
	}

	/*
	 * walk them up simultaneously until we reach
	 * a common ancestor.
	 */
	while(have &amp;&amp; want &amp;&amp; memcmp(have, want, VtScoreSize) != 0){
		have = parent(have, &amp;havepos);
		want = parent(want, &amp;wantpos);
	}

	/*
	 * not part of same tree.  happens mainly with
	 * newly allocated blocks.
	 */
	if(!have || !want)
		return 0;

	/*
	 * never walked want: means we want to lock
	 * an ancestor of have.  no no.
	 */
	if(wantpos == -1)
		return 1;

	/*
	 * never walked have: means we want to lock a
	 * child of have.  that's okay.
	 */
	if(havepos == -1)
		return 0;

	/*
	 * walked both: they're from different places in the tree.
	 * require that the left one be locked before the right one.
	 * (this is questionable, but it puts a total order on the block tree).
	 */
	return havepos &lt; wantpos;
}

static void
stop(void)
{
	int fd;
	char buf[32];

	snprint(buf, sizeof buf, "#p/%d/ctl", getpid());
	fd = open(buf, OWRITE);
	write(fd, "stop", 4);
	close(fd);
}

/*
 * Check whether the calling thread can validly lock b.
 * That is, check that the calling thread doesn't hold
 * locks for any of b's children.
 */
void
bwatchLock(Block *b)
{
	int i;
	WThread *w;

	if(bwatchDisabled)
		return;

	if(b-&gt;part != PartData)
		return;

	vtLock(map.lk);
	w = getWThread();
	for(i=0; i&lt;w-&gt;nb; i++){
		if(lockConflicts(w-&gt;b[i]-&gt;score, b-&gt;score)){
			fprint(2, "%d: have block %V; shouldn't lock %V\n",
				w-&gt;pid, w-&gt;b[i]-&gt;score, b-&gt;score);
			stop();
		}
	}
	vtUnlock(map.lk);
	if(w-&gt;nb &gt;= MaxLock){
		fprint(2, "%d: too many blocks held\n", w-&gt;pid);
		stop();
	}else
		w-&gt;b[w-&gt;nb++] = b;
}

/*
 * Note that the calling thread is about to unlock b.
 */
void
bwatchUnlock(Block *b)
{
	int i;
	WThread *w;

	if(bwatchDisabled)
		return;

	if(b-&gt;part != PartData)
		return;

	w = getWThread();
	for(i=0; i&lt;w-&gt;nb; i++)
		if(w-&gt;b[i] == b)
			break;
	if(i&gt;=w-&gt;nb){
		fprint(2, "%d: unlock of unlocked block %V\n", w-&gt;pid, b-&gt;score);
		stop();
	}else
		w-&gt;b[i] = w-&gt;b[--w-&gt;nb];
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

