<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/pack.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/pack.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "error.h"

/*
 * integer conversion routines
 */
#define	U8GET(p)	((p)[0])
#define	U16GET(p)	(((p)[0]&lt;&lt;8)|(p)[1])
#define	U32GET(p)	(((p)[0]&lt;&lt;24)|((p)[1]&lt;&lt;16)|((p)[2]&lt;&lt;8)|(p)[3])
#define	U48GET(p)	(((uvlong)U16GET(p)&lt;&lt;32)|(uvlong)U32GET((p)+2))
#define	U64GET(p)	(((uvlong)U32GET(p)&lt;&lt;32)|(uvlong)U32GET((p)+4))

#define	U8PUT(p,v)	(p)[0]=(v)
#define	U16PUT(p,v)	(p)[0]=(v)&gt;&gt;8;(p)[1]=(v)
#define	U32PUT(p,v)	(p)[0]=(v)&gt;&gt;24;(p)[1]=(v)&gt;&gt;16;(p)[2]=(v)&gt;&gt;8;(p)[3]=(v)
#define	U48PUT(p,v,t32)	t32=(v)&gt;&gt;32;U16PUT(p,t32);t32=(v);U32PUT((p)+2,t32)
#define	U64PUT(p,v,t32)	t32=(v)&gt;&gt;32;U32PUT(p,t32);t32=(v);U32PUT((p)+4,t32)

void
headerPack(Header *h, uchar *p)
{
	memset(p, 0, HeaderSize);
	U32PUT(p, HeaderMagic);
	U16PUT(p+4, HeaderVersion);
	U16PUT(p+6, h-&gt;blockSize);
	U32PUT(p+8, h-&gt;super);
	U32PUT(p+12, h-&gt;label);
	U32PUT(p+16, h-&gt;data);
	U32PUT(p+20, h-&gt;end);
}

int
headerUnpack(Header *h, uchar *p)
{
	if(U32GET(p) != HeaderMagic){
		vtSetError("vac header bad magic");
		return 0;
	}
	h-&gt;version = U16GET(p+4);
	if(h-&gt;version != HeaderVersion){
		vtSetError("vac header bad version");
		return 0;
	}
	h-&gt;blockSize = U16GET(p+6);
	h-&gt;super = U32GET(p+8);
	h-&gt;label = U32GET(p+12);
	h-&gt;data = U32GET(p+16);
	h-&gt;end = U32GET(p+20);
	return 1;
}

void
labelPack(Label *l, uchar *p, int i)
{
	p += i*LabelSize;
	U8PUT(p, l-&gt;state);
	U8PUT(p+1, l-&gt;type);
	U32PUT(p+2, l-&gt;epoch);
	U32PUT(p+6, l-&gt;epochClose);
	U32PUT(p+10, l-&gt;tag);
}

int
labelUnpack(Label *l, uchar *p, int i)
{
	p += i*LabelSize;
	l-&gt;state = p[0];
	l-&gt;type = p[1];
	l-&gt;epoch = U32GET(p+2);
	l-&gt;epochClose = U32GET(p+6);
	l-&gt;tag = U32GET(p+10);

	if(l-&gt;type &gt; BtMax){
Bad:
		vtSetError(EBadLabel);
		fprint(2, "%s: labelUnpack: bad label: 0x%.2ux 0x%.2ux 0x%.8ux "
			"0x%.8ux 0x%.8ux\n", argv0, l-&gt;state, l-&gt;type, l-&gt;epoch,
			l-&gt;epochClose, l-&gt;tag);
		return 0;
	}
	if(l-&gt;state != BsBad &amp;&amp; l-&gt;state != BsFree){
		if(!(l-&gt;state&amp;BsAlloc) || l-&gt;state &amp; ~BsMask)
			goto Bad;
		if(l-&gt;state&amp;BsClosed){
			if(l-&gt;epochClose == ~(u32int)0)
				goto Bad;
		}else{
			if(l-&gt;epochClose != ~(u32int)0)
				goto Bad;
		}
	}
	return 1;
}

u32int
globalToLocal(uchar score[VtScoreSize])
{
	int i;

	for(i=0; i&lt;VtScoreSize-4; i++)
		if(score[i] != 0)
			return NilBlock;

	return U32GET(score+VtScoreSize-4);
}

void
localToGlobal(u32int addr, uchar score[VtScoreSize])
{
	memset(score, 0, VtScoreSize-4);
	U32PUT(score+VtScoreSize-4, addr);
}

void
entryPack(Entry *e, uchar *p, int index)
{
	ulong t32;
	int flags;

	p += index * VtEntrySize;

	U32PUT(p, e-&gt;gen);
	U16PUT(p+4, e-&gt;psize);
	U16PUT(p+6, e-&gt;dsize);
	flags = e-&gt;flags | ((e-&gt;depth &lt;&lt; VtEntryDepthShift) &amp; VtEntryDepthMask);
	U8PUT(p+8, flags);
	memset(p+9, 0, 5);
	U48PUT(p+14, e-&gt;size, t32);

	if(flags &amp; VtEntryLocal){
		if(globalToLocal(e-&gt;score) == NilBlock)
			abort();
		memset(p+20, 0, 7);
		U8PUT(p+27, e-&gt;archive);
		U32PUT(p+28, e-&gt;snap);
		U32PUT(p+32, e-&gt;tag);
		memmove(p+36, e-&gt;score+16, 4);
	}else
		memmove(p+20, e-&gt;score, VtScoreSize);
}

int
entryUnpack(Entry *e, uchar *p, int index)
{
	p += index * VtEntrySize;

	e-&gt;gen = U32GET(p);
	e-&gt;psize = U16GET(p+4);
	e-&gt;dsize = U16GET(p+6);
	e-&gt;flags = U8GET(p+8);
	e-&gt;depth = (e-&gt;flags &amp; VtEntryDepthMask) &gt;&gt; VtEntryDepthShift;
	e-&gt;flags &amp;= ~VtEntryDepthMask;
	e-&gt;size = U48GET(p+14);

	if(e-&gt;flags &amp; VtEntryLocal){
		e-&gt;archive = p[27];
		e-&gt;snap = U32GET(p+28);
		e-&gt;tag = U32GET(p+32);
		memset(e-&gt;score, 0, 16);
		memmove(e-&gt;score+16, p+36, 4);
	}else{
		e-&gt;archive = 0;
		e-&gt;snap = 0;
		e-&gt;tag = 0;
		memmove(e-&gt;score, p+20, VtScoreSize);
	}

	return 1;
}

int
entryType(Entry *e)
{
	return (((e-&gt;flags &amp; VtEntryDir) != 0) &lt;&lt; 3) | e-&gt;depth;
}


void
superPack(Super *s, uchar *p)
{
	u32int t32;

	memset(p, 0, SuperSize);
	U32PUT(p, SuperMagic);
	assert(s-&gt;version == SuperVersion);
	U16PUT(p+4, s-&gt;version);
	U32PUT(p+6, s-&gt;epochLow);
	U32PUT(p+10, s-&gt;epochHigh);
	U64PUT(p+14, s-&gt;qid, t32);
	U32PUT(p+22, s-&gt;active);
	U32PUT(p+26, s-&gt;next);
	U32PUT(p+30, s-&gt;current);
	memmove(p+34, s-&gt;last, VtScoreSize);
	memmove(p+54, s-&gt;name, sizeof(s-&gt;name));
}

int
superUnpack(Super *s, uchar *p)
{
	memset(s, 0, sizeof(*s));
	if(U32GET(p) != SuperMagic)
		goto Err;
	s-&gt;version = U16GET(p+4);
	if(s-&gt;version != SuperVersion)
		goto Err;
	s-&gt;epochLow = U32GET(p+6);
	s-&gt;epochHigh = U32GET(p+10);
	s-&gt;qid = U64GET(p+14);
	if(s-&gt;epochLow == 0 || s-&gt;epochLow &gt; s-&gt;epochHigh || s-&gt;qid == 0)
		goto Err;
	s-&gt;active = U32GET(p+22);
	s-&gt;next = U32GET(p+26);
	s-&gt;current = U32GET(p+30);
	memmove(s-&gt;last, p+34, VtScoreSize);
	memmove(s-&gt;name, p+54, sizeof(s-&gt;name));
	s-&gt;name[sizeof(s-&gt;name)-1] = 0;
	return 1;
Err:
	memset(s, 0, sizeof(*s));
	vtSetError(EBadSuper);
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

