<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/source.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/source.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "error.h"
#include "9.h"

static int	sizeToDepth(uvlong s, int psize, int dsize);
static u32int 	tagGen(void);
static Block 	*sourceLoad(Source *r, Entry *e);
static int	sourceShrinkDepth(Source*, Block*, Entry*, int);
static int	sourceShrinkSize(Source*, Entry*, uvlong);
static int	sourceGrowDepth(Source*, Block*, Entry*, int);

#define sourceIsLocked(r)	((r)-&gt;b != nil)

static Source *
sourceAlloc(Fs *fs, Block *b, Source *p, u32int offset, int mode, int issnapshot)
{
	int epb;
	u32int epoch;
	char *pname = nil;
	Source *r;
	Entry e;

	assert(p==nil || sourceIsLocked(p));

	if(p == nil){
		assert(offset == 0);
		epb = 1;
	}else
		epb = p-&gt;dsize / VtEntrySize;

	if(b-&gt;l.type != BtDir)
		goto Bad;

	/*
	 * a non-active entry is the only thing that
	 * can legitimately happen here. all the others
	 * get prints.
	 */
	if(!entryUnpack(&amp;e, b-&gt;data, offset % epb)){
		pname = sourceName(p);
		consPrint("%s: %s %V: sourceAlloc: entryUnpack failed\n",
			fs-&gt;name, pname, b-&gt;score);
		goto Bad;
	}
	if(!(e.flags &amp; VtEntryActive)){
		pname = sourceName(p);
		if(0) consPrint("%s: %s %V: sourceAlloc: not active\n",
			fs-&gt;name, pname, e.score);
		goto Bad;
	}
	if(e.psize &lt; 256 || e.dsize &lt; 256){
		pname = sourceName(p);
		consPrint("%s: %s %V: sourceAlloc: psize %ud or dsize %ud &lt; 256\n",
			fs-&gt;name, pname, e.score, e.psize, e.dsize);
		goto Bad;
	}

	if(e.depth &lt; sizeToDepth(e.size, e.psize, e.dsize)){
		pname = sourceName(p);
		consPrint("%s: %s %V: sourceAlloc: depth %ud size %llud "
			"psize %ud dsize %ud\n", fs-&gt;name, pname,
			e.score, e.depth, e.size, e.psize, e.dsize);
		goto Bad;
	}

	if((e.flags &amp; VtEntryLocal) &amp;&amp; e.tag == 0){
		pname = sourceName(p);
		consPrint("%s: %s %V: sourceAlloc: flags %#ux tag %#ux\n",
			fs-&gt;name, pname, e.score, e.flags, e.tag);
		goto Bad;
	}

	if(e.dsize &gt; fs-&gt;blockSize || e.psize &gt; fs-&gt;blockSize){
		pname = sourceName(p);
		consPrint("%s: %s %V: sourceAlloc: psize %ud or dsize %ud "
			"&gt; blocksize %ud\n", fs-&gt;name, pname, e.score,
			e.psize, e.dsize, fs-&gt;blockSize);
		goto Bad;
	}

	epoch = b-&gt;l.epoch;
	if(mode == OReadWrite){
		if(e.snap != 0){
			vtSetError(ESnapRO);
			return nil;
		}
	}else if(e.snap != 0){
		if(e.snap &lt; fs-&gt;elo){
			vtSetError(ESnapOld);
			return nil;
		}
		if(e.snap &gt;= fs-&gt;ehi)
			goto Bad;
		epoch = e.snap;
	}

	r = vtMemAllocZ(sizeof(Source));
	r-&gt;fs = fs;
	r-&gt;mode = mode;
	r-&gt;issnapshot = issnapshot;
	r-&gt;dsize = e.dsize;
	r-&gt;gen = e.gen;
	r-&gt;dir = (e.flags &amp; VtEntryDir) != 0;
	r-&gt;lk = vtLockAlloc();
	r-&gt;ref = 1;
	r-&gt;parent = p;
	if(p){
		vtLock(p-&gt;lk);
		assert(mode == OReadOnly || p-&gt;mode == OReadWrite);
		p-&gt;ref++;
		vtUnlock(p-&gt;lk);
	}
	r-&gt;epoch = epoch;
//	consPrint("sourceAlloc: have %V be.%d fse.%d %s\n", b-&gt;score,
//		b-&gt;l.epoch, r-&gt;fs-&gt;ehi, mode == OReadWrite? "rw": "ro");
	memmove(r-&gt;score, b-&gt;score, VtScoreSize);
	r-&gt;scoreEpoch = b-&gt;l.epoch;
	r-&gt;offset = offset;
	r-&gt;epb = epb;
	r-&gt;tag = b-&gt;l.tag;

//	consPrint("%s: sourceAlloc: %p -&gt; %V %d\n", r, r-&gt;score, r-&gt;offset);

	return r;
Bad:
	free(pname);
	vtSetError(EBadEntry);
	return nil;
}

Source *
sourceRoot(Fs *fs, u32int addr, int mode)
{
	Source *r;
	Block *b;

	b = cacheLocalData(fs-&gt;cache, addr, BtDir, RootTag, mode, 0);
	if(b == nil)
		return nil;

	if(mode == OReadWrite &amp;&amp; b-&gt;l.epoch != fs-&gt;ehi){
		consPrint("sourceRoot: fs-&gt;ehi = %ud, b-&gt;l = %L\n",
			fs-&gt;ehi, &amp;b-&gt;l);
		blockPut(b);
		vtSetError(EBadRoot);
		return nil;
	}

	r = sourceAlloc(fs, b, nil, 0, mode, 0);
	blockPut(b);
	return r;
}

Source *
sourceOpen(Source *r, ulong offset, int mode, int issnapshot)
{
	ulong bn;
	Block *b;

	assert(sourceIsLocked(r));
	if(r-&gt;mode == OReadWrite)
		assert(r-&gt;epoch == r-&gt;b-&gt;l.epoch);
	if(!r-&gt;dir){
		vtSetError(ENotDir);
		return nil;
	}

	bn = offset/(r-&gt;dsize/VtEntrySize);

	b = sourceBlock(r, bn, mode);
	if(b == nil)
		return nil;
	r = sourceAlloc(r-&gt;fs, b, r, offset, mode, issnapshot);
	blockPut(b);
	return r;
}

Source *
sourceCreate(Source *r, int dsize, int dir, u32int offset)
{
	int i, epb, psize;
	u32int bn, size;
	Block *b;
	Entry e;
	Source *rr;

	assert(sourceIsLocked(r));

	if(!r-&gt;dir){
		vtSetError(ENotDir);
		return nil;
	}

	epb = r-&gt;dsize/VtEntrySize;
	psize = (dsize/VtScoreSize)*VtScoreSize;

	size = sourceGetDirSize(r);
	if(offset == 0){
		/*
		 * look at a random block to see if we can find an empty entry
		 */
		offset = lnrand(size+1);
		offset -= offset % epb;
	}

	/* try the given block and then try the last block */
	for(;;){
		bn = offset/epb;
		b = sourceBlock(r, bn, OReadWrite);
		if(b == nil)
			return nil;
		for(i=offset%r-&gt;epb; i&lt;epb; i++){
			entryUnpack(&amp;e, b-&gt;data, i);
			if((e.flags&amp;VtEntryActive) == 0 &amp;&amp; e.gen != ~0)
				goto Found;
		}
		blockPut(b);
		if(offset == size){
			fprint(2, "sourceCreate: cannot happen\n");
			vtSetError("sourceCreate: cannot happen");
			return nil;
		}
		offset = size;
	}

Found:
	/* found an entry - gen already set */
	e.psize = psize;
	e.dsize = dsize;
	assert(psize &amp;&amp; dsize);
	e.flags = VtEntryActive;
	if(dir)
		e.flags |= VtEntryDir;
	e.depth = 0;
	e.size = 0;
	memmove(e.score, vtZeroScore, VtScoreSize);
	e.tag = 0;
	e.snap = 0;
	e.archive = 0;
	entryPack(&amp;e, b-&gt;data, i);
	blockDirty(b);

	offset = bn*epb + i;
	if(offset+1 &gt; size){
		if(!sourceSetDirSize(r, offset+1)){
			blockPut(b);
			return nil;
		}
	}

	rr = sourceAlloc(r-&gt;fs, b, r, offset, OReadWrite, 0);
	blockPut(b);
	return rr;
}

static int
sourceKill(Source *r, int doremove)
{
	Entry e;
	Block *b;
	u32int addr;
	u32int tag;
	int type;

	assert(sourceIsLocked(r));
	b = sourceLoad(r, &amp;e);
	if(b == nil)
		return 0;

	assert(b-&gt;l.epoch == r-&gt;fs-&gt;ehi);

	if(doremove==0 &amp;&amp; e.size == 0){
		/* already truncated */
		blockPut(b);
		return 1;
	}

	/* remember info on link we are removing */
	addr = globalToLocal(e.score);
	type = entryType(&amp;e);
	tag = e.tag;

	if(doremove){
		if(e.gen != ~0)
			e.gen++;
		e.dsize = 0;
		e.psize = 0;
		e.flags = 0;
	}else{
		e.flags &amp;= ~VtEntryLocal;
	}
	e.depth = 0;
	e.size = 0;
	e.tag = 0;
	memmove(e.score, vtZeroScore, VtScoreSize);
	entryPack(&amp;e, b-&gt;data, r-&gt;offset % r-&gt;epb);
	blockDirty(b);
	if(addr != NilBlock)
		blockRemoveLink(b, addr, type, tag, 1);
	blockPut(b);

	if(doremove){
		sourceUnlock(r);
		sourceClose(r);
	}

	return 1;
}

int
sourceRemove(Source *r)
{
	return sourceKill(r, 1);
}

int
sourceTruncate(Source *r)
{
	return sourceKill(r, 0);
}

uvlong
sourceGetSize(Source *r)
{
	Entry e;
	Block *b;

	assert(sourceIsLocked(r));
	b = sourceLoad(r, &amp;e);
	if(b == nil)
		return 0;
	blockPut(b);

	return e.size;
}

static int
sourceShrinkSize(Source *r, Entry *e, uvlong size)
{
	int i, type, ppb;
	uvlong ptrsz;
	u32int addr;
	uchar score[VtScoreSize];
	Block *b;

	type = entryType(e);
	b = cacheGlobal(r-&gt;fs-&gt;cache, e-&gt;score, type, e-&gt;tag, OReadWrite);
	if(b == nil)
		return 0;

	ptrsz = e-&gt;dsize;
	ppb = e-&gt;psize/VtScoreSize;
	for(i=0; i+1&lt;e-&gt;depth; i++)
		ptrsz *= ppb;

	while(type&amp;BtLevelMask){
		if(b-&gt;addr == NilBlock || b-&gt;l.epoch != r-&gt;fs-&gt;ehi){
			/* not worth copying the block just so we can zero some of it */
			blockPut(b);
			return 0;
		}

		/*
		 * invariant: each pointer in the tree rooted at b accounts for ptrsz bytes
		 */

		/* zero the pointers to unnecessary blocks */
		i = (size+ptrsz-1)/ptrsz;
		for(; i&lt;ppb; i++){
			addr = globalToLocal(b-&gt;data+i*VtScoreSize);
			memmove(b-&gt;data+i*VtScoreSize, vtZeroScore, VtScoreSize);
			blockDirty(b);
			if(addr != NilBlock)
				blockRemoveLink(b, addr, type-1, e-&gt;tag, 1);
		}

		/* recurse (go around again) on the partially necessary block */
		i = size/ptrsz;
		size = size%ptrsz;
		if(size == 0){
			blockPut(b);
			return 1;
		}
		ptrsz /= ppb;
		type--;
		memmove(score, b-&gt;data+i*VtScoreSize, VtScoreSize);
		blockPut(b);
		b = cacheGlobal(r-&gt;fs-&gt;cache, score, type, e-&gt;tag, OReadWrite);
		if(b == nil)
			return 0;
	}

	if(b-&gt;addr == NilBlock || b-&gt;l.epoch != r-&gt;fs-&gt;ehi){
		blockPut(b);
		return 0;
	}

	/*
	 * No one ever truncates BtDir blocks.
	 */
	if(type == BtData &amp;&amp; e-&gt;dsize &gt; size){
		memset(b-&gt;data+size, 0, e-&gt;dsize-size);
		blockDirty(b);
	}
	blockPut(b);
	return 1;
}

int
sourceSetSize(Source *r, uvlong size)
{
	int depth;
	Entry e;
	Block *b;

	assert(sourceIsLocked(r));
	if(size == 0)
		return sourceTruncate(r);

	if(size &gt; VtMaxFileSize || size &gt; ((uvlong)MaxBlock)*r-&gt;dsize){
		vtSetError(ETooBig);
		return 0;
	}

	b = sourceLoad(r, &amp;e);
	if(b == nil)
		return 0;

	/* quick out */
	if(e.size == size){
		blockPut(b);
		return 1;
	}

	depth = sizeToDepth(size, e.psize, e.dsize);

	if(depth &lt; e.depth){
		if(!sourceShrinkDepth(r, b, &amp;e, depth)){
			blockPut(b);
			return 0;
		}
	}else if(depth &gt; e.depth){
		if(!sourceGrowDepth(r, b, &amp;e, depth)){
			blockPut(b);
			return 0;
		}
	}

	if(size &lt; e.size)
		sourceShrinkSize(r, &amp;e, size);

	e.size = size;
	entryPack(&amp;e, b-&gt;data, r-&gt;offset % r-&gt;epb);
	blockDirty(b);
	blockPut(b);

	return 1;
}

int
sourceSetDirSize(Source *r, ulong ds)
{
	uvlong size;
	int epb;

	assert(sourceIsLocked(r));
	epb = r-&gt;dsize/VtEntrySize;

	size = (uvlong)r-&gt;dsize*(ds/epb);
	size += VtEntrySize*(ds%epb);
	return sourceSetSize(r, size);
}

ulong
sourceGetDirSize(Source *r)
{
	ulong ds;
	uvlong size;
	int epb;

	assert(sourceIsLocked(r));
	epb = r-&gt;dsize/VtEntrySize;

	size = sourceGetSize(r);
	ds = epb*(size/r-&gt;dsize);
	ds += (size%r-&gt;dsize)/VtEntrySize;
	return ds;
}

int
sourceGetEntry(Source *r, Entry *e)
{
	Block *b;

	assert(sourceIsLocked(r));
	b = sourceLoad(r, e);
	if(b == nil)
		return 0;
	blockPut(b);

	return 1;
}

/*
 * Must be careful with this.  Doesn't record
 * dependencies, so don't introduce any!
 */
int
sourceSetEntry(Source *r, Entry *e)
{
	Block *b;
	Entry oe;

	assert(sourceIsLocked(r));
	b = sourceLoad(r, &amp;oe);
	if(b == nil)
		return 0;
	entryPack(e, b-&gt;data, r-&gt;offset%r-&gt;epb);
	blockDirty(b);
	blockPut(b);

	return 1;
}

static Block *
blockWalk(Block *p, int index, int mode, Fs *fs, Entry *e)
{
	Block *b;
	Cache *c;
	u32int addr;
	int type;
	uchar oscore[VtScoreSize], score[VtScoreSize];
	Entry oe;

	c = fs-&gt;cache;

	if((p-&gt;l.type &amp; BtLevelMask) == 0){
		assert(p-&gt;l.type == BtDir);
		type = entryType(e);
		b = cacheGlobal(c, e-&gt;score, type, e-&gt;tag, mode);
	}else{
		type = p-&gt;l.type - 1;
		b = cacheGlobal(c, p-&gt;data + index*VtScoreSize, type, e-&gt;tag, mode);
	}

	if(b)
		b-&gt;pc = getcallerpc(&amp;p);

	if(b == nil || mode == OReadOnly)
		return b;

	if(p-&gt;l.epoch != fs-&gt;ehi){
		fprint(2, "blockWalk: parent not writable\n");
		abort();
	}
	if(b-&gt;l.epoch == fs-&gt;ehi)
		return b;

	oe = *e;

	/*
	 * Copy on write.
	 */
	if(e-&gt;tag == 0){
		assert(p-&gt;l.type == BtDir);
		e-&gt;tag = tagGen();
		e-&gt;flags |= VtEntryLocal;
	}

	addr = b-&gt;addr;
	b = blockCopy(b, e-&gt;tag, fs-&gt;ehi, fs-&gt;elo);
	if(b == nil)
		return nil;

	b-&gt;pc = getcallerpc(&amp;p);
	assert(b-&gt;l.epoch == fs-&gt;ehi);

	blockDirty(b);
	memmove(score, b-&gt;score, VtScoreSize);
	if(p-&gt;l.type == BtDir){
		memmove(e-&gt;score, b-&gt;score, VtScoreSize);
		entryPack(e, p-&gt;data, index);
		blockDependency(p, b, index, nil, &amp;oe);
	}else{
		memmove(oscore, p-&gt;data+index*VtScoreSize, VtScoreSize);
		memmove(p-&gt;data+index*VtScoreSize, b-&gt;score, VtScoreSize);
		blockDependency(p, b, index, oscore, nil);
	}
	blockDirty(p);

	if(addr != NilBlock)
		blockRemoveLink(p, addr, type, e-&gt;tag, 0);

	return b;
}

/*
 * Change the depth of the source r.
 * The entry e for r is contained in block p.
 */
static int
sourceGrowDepth(Source *r, Block *p, Entry *e, int depth)
{
	Block *b, *bb;
	u32int tag;
	int type;
	Entry oe;

	assert(sourceIsLocked(r));
	assert(depth &lt;= VtPointerDepth);

	type = entryType(e);
	b = cacheGlobal(r-&gt;fs-&gt;cache, e-&gt;score, type, e-&gt;tag, OReadWrite);
	if(b == nil)
		return 0;

	tag = e-&gt;tag;
	if(tag == 0)
		tag = tagGen();

	oe = *e;

	/*
	 * Keep adding layers until we get to the right depth
	 * or an error occurs.
	 */
	while(e-&gt;depth &lt; depth){
		bb = cacheAllocBlock(r-&gt;fs-&gt;cache, type+1, tag, r-&gt;fs-&gt;ehi, r-&gt;fs-&gt;elo);
		if(bb == nil)
			break;
//fprint(2, "alloc %lux grow %V\n", bb-&gt;addr, b-&gt;score);
		memmove(bb-&gt;data, b-&gt;score, VtScoreSize);
		memmove(e-&gt;score, bb-&gt;score, VtScoreSize);
		e-&gt;depth++;
		type++;
		e-&gt;tag = tag;
		e-&gt;flags |= VtEntryLocal;
		blockDependency(bb, b, 0, vtZeroScore, nil);
		blockPut(b);
		b = bb;
		blockDirty(b);
	}

	entryPack(e, p-&gt;data, r-&gt;offset % r-&gt;epb);
	blockDependency(p, b, r-&gt;offset % r-&gt;epb, nil, &amp;oe);
	blockPut(b);
	blockDirty(p);

	return e-&gt;depth == depth;
}

static int
sourceShrinkDepth(Source *r, Block *p, Entry *e, int depth)
{
	Block *b, *nb, *ob, *rb;
	u32int tag;
	int type, d;
	Entry oe;

	assert(sourceIsLocked(r));
	assert(depth &lt;= VtPointerDepth);

	type = entryType(e);
	rb = cacheGlobal(r-&gt;fs-&gt;cache, e-&gt;score, type, e-&gt;tag, OReadWrite);
	if(rb == nil)
		return 0;

	tag = e-&gt;tag;
	if(tag == 0)
		tag = tagGen();

	/*
	 * Walk down to the new root block.
	 * We may stop early, but something is better than nothing.
	 */
	oe = *e;

	ob = nil;
	b = rb;
/* BUG: explain type++.  i think it is a real bug */
	for(d=e-&gt;depth; d &gt; depth; d--, type++){
		nb = cacheGlobal(r-&gt;fs-&gt;cache, b-&gt;data, type-1, tag, OReadWrite);
		if(nb == nil)
			break;
		if(ob!=nil &amp;&amp; ob!=rb)
			blockPut(ob);
		ob = b;
		b = nb;
	}

	if(b == rb){
		blockPut(rb);
		return 0;
	}

	/*
	 * Right now, e points at the root block rb, b is the new root block,
	 * and ob points at b.  To update:
	 *
	 *	(i) change e to point at b
	 *	(ii) zero the pointer ob -&gt; b
	 *	(iii) free the root block
	 *
	 * p (the block containing e) must be written before
	 * anything else.
 	 */

	/* (i) */
	e-&gt;depth = d;
	/* might have been local and now global; reverse cannot happen */
	if(globalToLocal(b-&gt;score) == NilBlock)
		e-&gt;flags &amp;= ~VtEntryLocal;
	memmove(e-&gt;score, b-&gt;score, VtScoreSize);
	entryPack(e, p-&gt;data, r-&gt;offset % r-&gt;epb);
	blockDependency(p, b, r-&gt;offset % r-&gt;epb, nil, &amp;oe);
	blockDirty(p);

	/* (ii) */
	memmove(ob-&gt;data, vtZeroScore, VtScoreSize);
	blockDependency(ob, p, 0, b-&gt;score, nil);
	blockDirty(ob);

	/* (iii) */
	if(rb-&gt;addr != NilBlock)
		blockRemoveLink(p, rb-&gt;addr, rb-&gt;l.type, rb-&gt;l.tag, 1);

	blockPut(rb);
	if(ob!=nil &amp;&amp; ob!=rb)
		blockPut(ob);
	blockPut(b);

	return d == depth;
}

/*
 * Normally we return the block at the given number.
 * If early is set, we stop earlier in the tree.  Setting early
 * to 1 gives us the block that contains the pointer to bn.
 */
Block *
_sourceBlock(Source *r, ulong bn, int mode, int early, ulong tag)
{
	Block *b, *bb;
	int index[VtPointerDepth+1];
	Entry e;
	int i, np;
	int m;

	assert(sourceIsLocked(r));
	assert(bn != NilBlock);

	/* mode for intermediate block */
	m = mode;
	if(m == OOverWrite)
		m = OReadWrite;

	b = sourceLoad(r, &amp;e);
	if(b == nil)
		return nil;
	if(r-&gt;issnapshot &amp;&amp; (e.flags &amp; VtEntryNoArchive)){
		blockPut(b);
		vtSetError(ENotArchived);
		return nil;
	}

	if(tag){
		if(e.tag == 0)
			e.tag = tag;
		else if(e.tag != tag){
			fprint(2, "tag mismatch\n");
			vtSetError("tag mismatch");
			goto Err;
		}
	}

	np = e.psize/VtScoreSize;
	memset(index, 0, sizeof(index));
	for(i=0; bn &gt; 0; i++){
		if(i &gt;= VtPointerDepth){
			vtSetError(EBadAddr);
			goto Err;
		}
		index[i] = bn % np;
		bn /= np;
	}

	if(i &gt; e.depth){
		if(mode == OReadOnly){
			vtSetError(EBadAddr);
			goto Err;
		}
		if(!sourceGrowDepth(r, b, &amp;e, i))
			goto Err;
	}

	index[e.depth] = r-&gt;offset % r-&gt;epb;

	for(i=e.depth; i&gt;=early; i--){
		bb = blockWalk(b, index[i], m, r-&gt;fs, &amp;e);
		if(bb == nil)
			goto Err;
		blockPut(b);
		b = bb;
	}
	b-&gt;pc = getcallerpc(&amp;r);
	return b;
Err:
	blockPut(b);
	return nil;
}

Block*
sourceBlock(Source *r, ulong bn, int mode)
{
	Block *b;

	b = _sourceBlock(r, bn, mode, 0, 0);
	if(b)
		b-&gt;pc = getcallerpc(&amp;r);
	return b;
}

void
sourceClose(Source *r)
{
	if(r == nil)
		return;
	vtLock(r-&gt;lk);
	r-&gt;ref--;
	if(r-&gt;ref){
		vtUnlock(r-&gt;lk);
		return;
	}
	assert(r-&gt;ref == 0);
	vtUnlock(r-&gt;lk);
	if(r-&gt;parent)
		sourceClose(r-&gt;parent);
	vtLockFree(r-&gt;lk);
	memset(r, ~0, sizeof(*r));
	vtMemFree(r);
}

/*
 * Retrieve the block containing the entry for r.
 * If a snapshot has happened, we might need
 * to get a new copy of the block.  We avoid this
 * in the common case by caching the score for
 * the block and the last epoch in which it was valid.
 *
 * We use r-&gt;mode to tell the difference between active
 * file system sources (OReadWrite) and sources for the
 * snapshot file system (OReadOnly).
 */
static Block*
sourceLoadBlock(Source *r, int mode)
{
	u32int addr;
	Block *b;

	switch(r-&gt;mode){
	default:
		assert(0);
	case OReadWrite:
		assert(r-&gt;mode == OReadWrite);
		/*
		 * This needn't be true -- we might bump the low epoch
		 * to reclaim some old blocks, but since this score is
		 * OReadWrite, the blocks must all still be open, so none
		 * are reclaimed.  Thus it's okay that the epoch is so low.
		 * Proceed.
		assert(r-&gt;epoch &gt;= r-&gt;fs-&gt;elo);
		 */
		if(r-&gt;epoch == r-&gt;fs-&gt;ehi){
			b = cacheGlobal(r-&gt;fs-&gt;cache, r-&gt;score, BtDir, r-&gt;tag, OReadWrite);
			if(b == nil)
				return nil;
			assert(r-&gt;epoch == b-&gt;l.epoch);
			return b;
		}
		assert(r-&gt;parent != nil);
		if(!sourceLock(r-&gt;parent, OReadWrite))
			return nil;
		b = sourceBlock(r-&gt;parent, r-&gt;offset/r-&gt;epb, OReadWrite);
		sourceUnlock(r-&gt;parent);
		if(b == nil)
			return nil;
		assert(b-&gt;l.epoch == r-&gt;fs-&gt;ehi);
	//	fprint(2, "sourceLoadBlock %p %V =&gt; %V\n", r, r-&gt;score, b-&gt;score);
		memmove(r-&gt;score, b-&gt;score, VtScoreSize);
		r-&gt;scoreEpoch = b-&gt;l.epoch;
		r-&gt;tag = b-&gt;l.tag;
		r-&gt;epoch = r-&gt;fs-&gt;ehi;
		return b;

	case OReadOnly:
		addr = globalToLocal(r-&gt;score);
		if(addr == NilBlock)
			return cacheGlobal(r-&gt;fs-&gt;cache, r-&gt;score, BtDir, r-&gt;tag, mode);

		b = cacheLocalData(r-&gt;fs-&gt;cache, addr, BtDir, r-&gt;tag, mode, r-&gt;scoreEpoch);
		if(b)
			return b;

		/*
		 * If it failed because the epochs don't match, the block has been
		 * archived and reclaimed.  Rewalk from the parent and get the
		 * new pointer.  This can't happen in the OReadWrite case
		 * above because blocks in the current epoch don't get
		 * reclaimed.  The fact that we're OReadOnly means we're
		 * a snapshot.  (Or else the file system is read-only, but then
		 * the archiver isn't going around deleting blocks.)
		 */
		if(strcmp(vtGetError(), ELabelMismatch) == 0){
			if(!sourceLock(r-&gt;parent, OReadOnly))
				return nil;
			b = sourceBlock(r-&gt;parent, r-&gt;offset/r-&gt;epb, OReadOnly);
			sourceUnlock(r-&gt;parent);
			if(b){
				fprint(2, "sourceAlloc: lost %V found %V\n",
					r-&gt;score, b-&gt;score);
				memmove(r-&gt;score, b-&gt;score, VtScoreSize);
				r-&gt;scoreEpoch = b-&gt;l.epoch;
				return b;
			}
		}
		return nil;
	}
}

int
sourceLock(Source *r, int mode)
{
	Block *b;

	if(mode == -1)
		mode = r-&gt;mode;

	b = sourceLoadBlock(r, mode);
	if(b == nil)
		return 0;
	/*
	 * The fact that we are holding b serves as the
	 * lock entitling us to write to r-&gt;b.
	 */
	assert(r-&gt;b == nil);
	r-&gt;b = b;
	if(r-&gt;mode == OReadWrite)
		assert(r-&gt;epoch == r-&gt;b-&gt;l.epoch);
	return 1;
}

/*
 * Lock two (usually sibling) sources.  This needs special care
 * because the Entries for both sources might be in the same block.
 * We also try to lock blocks in left-to-right order within the tree.
 */
int
sourceLock2(Source *r, Source *rr, int mode)
{
	Block *b, *bb;

	if(rr == nil)
		return sourceLock(r, mode);

	if(mode == -1)
		mode = r-&gt;mode;

	if(r-&gt;parent==rr-&gt;parent &amp;&amp; r-&gt;offset/r-&gt;epb == rr-&gt;offset/rr-&gt;epb){
		b = sourceLoadBlock(r, mode);
		if(b == nil)
			return 0;
		if(memcmp(r-&gt;score, rr-&gt;score, VtScoreSize) != 0){
			memmove(rr-&gt;score, b-&gt;score, VtScoreSize);
			rr-&gt;scoreEpoch = b-&gt;l.epoch;
			rr-&gt;tag = b-&gt;l.tag;
			rr-&gt;epoch = rr-&gt;fs-&gt;ehi;
		}
		blockDupLock(b);
		bb = b;
	}else if(r-&gt;parent==rr-&gt;parent || r-&gt;offset &gt; rr-&gt;offset){
		bb = sourceLoadBlock(rr, mode);
		b = sourceLoadBlock(r, mode);
	}else{
		b = sourceLoadBlock(r, mode);
		bb = sourceLoadBlock(rr, mode);
	}
	if(b == nil || bb == nil){
		if(b)
			blockPut(b);
		if(bb)
			blockPut(bb);
		return 0;
	}

	/*
	 * The fact that we are holding b and bb serves
	 * as the lock entitling us to write to r-&gt;b and rr-&gt;b.
	 */
	r-&gt;b = b;
	rr-&gt;b = bb;
	return 1;
}

void
sourceUnlock(Source *r)
{
	Block *b;

	if(r-&gt;b == nil){
		fprint(2, "sourceUnlock: already unlocked\n");
		abort();
	}
	b = r-&gt;b;
	r-&gt;b = nil;
	blockPut(b);
}

static Block*
sourceLoad(Source *r, Entry *e)
{
	Block *b;

	assert(sourceIsLocked(r));
	b = r-&gt;b;
	if(!entryUnpack(e, b-&gt;data, r-&gt;offset % r-&gt;epb))
		return nil;
	if(e-&gt;gen != r-&gt;gen){
		vtSetError(ERemoved);
		return nil;
	}
	blockDupLock(b);
	return b;
}

static int
sizeToDepth(uvlong s, int psize, int dsize)
{
	int np;
	int d;

	/* determine pointer depth */
	np = psize/VtScoreSize;
	s = (s + dsize - 1)/dsize;
	for(d = 0; s &gt; 1; d++)
		s = (s + np - 1)/np;
	return d;
}

static u32int
tagGen(void)
{
	u32int tag;

	for(;;){
		tag = lrand();
		if(tag &gt;= UserTag)
			break;
	}
	return tag;
}

char *
sourceName(Source *s)
{
	return fileName(s-&gt;file);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

