<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/fossil/srcload.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/fossil/srcload.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include &lt;bio.h&gt;
#include "dat.h"
#include "fns.h"
#include "error.h"

int num = 100;
int length = 20*1024;
int block= 1024;
int bush = 4;
int iter = 100;
Biobuf *bout;
int maxdepth;

Source *mkroot(Cache*);
void new(Source*, int trace, int);
int delete(Source*);
int count(Source *s, int);
void stats(Source *s);
void dump(Source *s, int ident, ulong entry);
static void bench(Source *r);

void
main(int argc, char *argv[])
{
	int i;
	Fs *fs;
	int csize = 1000;
	ulong t;
	Source *r;

	ARGBEGIN{
	case 'i':
		iter = atoi(ARGF());
		break;
	case 'n':
		num = atoi(ARGF());
		break;
	case 'l':
		length = atoi(ARGF());
		break;
	case 'b':	
		block = atoi(ARGF());
		break;
	case 'u':
		bush = atoi(ARGF());
		break;
	case 'c':
		csize = atoi(ARGF());
		break;
	}ARGEND;

	vtAttach();

	bout = vtMemAllocZ(sizeof(Biobuf));
	Binit(bout, 1, OWRITE);

	fmtinstall('V', vtScoreFmt);
	fmtinstall('R', vtErrFmt);

	fs = fsOpen(argv[0], nil, csize, OReadWrite);
	if(fs == nil)
		sysfatal("could not open fs: %r");

	t = time(0);

	srand(0);

	r = fs-&gt;source;
	dump(r, 0, 0);

	fprint(2, "count = %d\n", count(r, 1));
	for(i=0; i&lt;num; i++)
		new(r, 0, 0);

	for(i=0; i&lt;iter; i++){
		if(i % 10000 == 0)
			stats(r);
		new(r, 0, 0);
		delete(r);
	}

//	dump(r, 0, 0);

	fprint(2, "count = %d\n", count(r, 1));
//	cacheCheck(c);

	fprint(2, "deleting\n");
	for(i=0; i&lt;num; i++)
		delete(r);
//	dump(r, 0, 0);

	fprint(2, "count = %d\n", count(r, 1));
	fprint(2, "total time = %ld\n", time(0)-t);
	
	fsClose(fs);
	vtDetach();
	exits(0);
}

static void
bench(Source *r)
{
	vlong t;
	Entry e;
	int i;

	t = nsec();

	for(i=0; i&lt;1000000; i++)
		sourceGetEntry(r, &amp;e);

	fprint(2, "%f\n", 1e-9*(nsec() - t));
}

void
new(Source *s, int trace, int depth)
{
	int i, n;
	Source *ss;
	Entry e;
	
	if(depth &gt; maxdepth)
		maxdepth = depth;

	Bflush(bout);

	n = sourceGetDirSize(s);
	for(i=0; i&lt;n; i++){
		ss = sourceOpen(s, nrand(n), OReadWrite);
		if(ss == nil || !sourceGetEntry(ss, &amp;e))
			continue;
		if((e.flags &amp; VtEntryDir) &amp;&amp; frand() &lt; 1./bush){
			if(trace){
				int j;
				for(j=0; j&lt;trace; j++)
					Bprint(bout, " ");
				Bprint(bout, "decend %d\n", i);
			}
			new(ss, trace?trace+1:0, depth+1);
			sourceClose(ss);
			return;
		}
		sourceClose(ss);
	}
	ss = sourceCreate(s, s-&gt;dsize, 1+frand()&gt;.5, 0);
	if(ss == nil){
		Bprint(bout, "could not create directory: %R\n");
		return;
	}
	if(trace){
		int j;
		for(j=1; j&lt;trace; j++)
			Bprint(bout, " ");
		Bprint(bout, "create %d\n", ss-&gt;offset);
	}
	sourceClose(ss);
}

int
delete(Source *s)
{
	int i, n;
	Source *ss;

	n = sourceGetDirSize(s);
	/* check if empty */
	for(i=0; i&lt;n; i++){
		ss = sourceOpen(s, i, OReadWrite);
		if(ss != nil){
			sourceClose(ss);
			break;
		}
	}
	if(i == n)
		return 0;
		
	for(;;){
		ss = sourceOpen(s, nrand(n), OReadWrite);
		if(ss == nil)
			continue;
		if(s-&gt;dir &amp;&amp; delete(ss)){
			sourceClose(ss);
			return 1;
		}
		if(1)
			break;
		sourceClose(ss);
	}


	sourceRemove(ss);
	return 1;
}

void
dump(Source *s, int ident, ulong entry)
{
	ulong i, n;
	Source *ss;
	Entry e;

	for(i=0; i&lt;ident; i++)
		Bprint(bout, " ");

	if(!sourceGetEntry(s, &amp;e)){
		fprint(2, "sourceGetEntry failed: %r\n");
		return;
	}

	Bprint(bout, "%4lud: gen %4ud depth %d tag=%x score=%V",
		entry, e.gen, e.depth, e.tag, e.score);
	if(!s-&gt;dir){
		Bprint(bout, " data size: %llud\n", e.size);
		return;
	}
	n = sourceGetDirSize(s);
	Bprint(bout, " dir size: %lud\n", n);
	for(i=0; i&lt;n; i++){
		ss = sourceOpen(s, i, 1);
		if(ss == nil)
			continue;
		dump(ss, ident+1, i);
		sourceClose(ss);
	}
	return;
}

int
count(Source *s, int rec)
{
	ulong i, n;
	int c;
	Source *ss;

	n = sourceGetDirSize(s);
	c = 0;
	for(i=0; i&lt;n; i++){
		ss = sourceOpen(s, i, OReadOnly);
		if(ss == nil)
			continue;
		if(rec)
			c += count(ss, rec);
		c++;
		sourceClose(ss);
	}
	return c;
}

void
stats(Source *s)
{
	int n, i, c, cc, max;
	Source *ss;

	cc = 0;
	max = 0;
	n = sourceGetDirSize(s);
	for(i=0; i&lt;n; i++){
		ss = sourceOpen(s, i, 1);
		if(ss == nil)
			continue;
		cc++;
		c = count(ss, 1);
		if(c &gt; max)
			max = c;
		sourceClose(ss);
	}
fprint(2, "count = %d top = %d depth=%d maxcount %d\n", cc, n, maxdepth, max);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

