<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/grap/misc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/grap/misc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
#include &lt;stdlib.h&gt;
#include "grap.h"
#include "y.tab.h"

int	nnum	= 0;	/* number of saved numbers */
double	num[MAXNUM];

int	just;		/* current justification mode (RJUST, etc.) */
int	sizeop;		/* current optional operator for size change */
double	sizexpr;	/* current size change expression */

void savenum(int n, double f)	/* save f in num[n] */
{
	num[n] = f;
	nnum = n+1;
	if (nnum &gt;= MAXNUM)
		ERROR "too many numbers" WARNING;
}

void setjust(int j)
{
	just |= j;
}

void setsize(int op, double expr)
{
	sizeop = op;
	sizexpr = expr;
}

char *tostring(char *s)
{
	register char *p;

	p = malloc(strlen(s)+1);
	if (p == NULL)
		ERROR "out of space in tostring on %s", s FATAL;
	strcpy(p, s);
	return(p);
}

void range(Point pt)	/* update the range for point pt */
{
	Obj *p = pt.obj;

	if (!(p-&gt;coord &amp; XFLAG)) {
		if (pt.x &gt; p-&gt;pt1.x)
			p-&gt;pt1.x = pt.x;
		if (pt.x &lt; p-&gt;pt.x)
			p-&gt;pt.x = pt.x;
	}
	if (!(p-&gt;coord &amp; YFLAG)) {
		if (pt.y &gt; p-&gt;pt1.y)
			p-&gt;pt1.y = pt.y;
		if (pt.y &lt; p-&gt;pt.y)
			p-&gt;pt.y = pt.y;
	}
}

void halfrange(Obj *p, int side, double val)	/* record max and min for one direction */
{
	if (!(p-&gt;coord&amp;XFLAG) &amp;&amp; (side == LEFT || side == RIGHT)) {
		if (val &lt; p-&gt;pt.y)
			p-&gt;pt.y = val;
		if (val &gt; p-&gt;pt1.y)
			p-&gt;pt1.y = val;
	} else if (!(p-&gt;coord&amp;YFLAG) &amp;&amp; (side == TOP || side == BOT)) {
		if (val &lt; p-&gt;pt.x)
			p-&gt;pt.x = val;
		if (val &gt; p-&gt;pt1.x)
			p-&gt;pt1.x = val;
	}
}


Obj *lookup(char *s, int inst)	/* find s in objlist, install if inst */
{
	Obj *p;
	int found = 0;

	for (p = objlist; p; p = p-&gt;next){
		if (strcmp(s, p-&gt;name) == 0) {
			found = 1;
			break;
		}
	}
	if (p == NULL &amp;&amp; inst != 0) {
		p = (Obj *) calloc(1, sizeof(Obj));
		if (p == NULL)
			ERROR "out of space in lookup" FATAL;
		p-&gt;name = tostring(s);
		p-&gt;type = NAME;
		p-&gt;pt = ptmax;
		p-&gt;pt1 = ptmin;
		p-&gt;fval = 0.0;
		p-&gt;next = objlist;
		objlist = p;
	}
	dprintf("lookup(%s,%d) = %d\n", s, inst, found);
	return p;
}

double getvar(Obj *p)	/* return value of variable */
{
	return p-&gt;fval;
}

double setvar(Obj *p, double f)	/* set value of variable to f */
{
	if (strcmp(p-&gt;name, "pointsize") == 0) {	/* kludge */
		pointsize = f;
		ps_set = 1;
	}
	p-&gt;type = VARNAME;
	return p-&gt;fval = f;
}

Point makepoint(Obj *s, double x, double y)	/* make a Point */
{
	Point p;
	
	dprintf("makepoint: %s, %g,%g\n", s-&gt;name, x, y);
	p.obj = s;
	p.x = x;
	p.y = y;
	return p;
}

Attr *makefattr(int type, double fval)	/* set double in attribute */
{
	return makeattr(type, fval, (char *) 0, 0, 0);
}

Attr *makesattr(char *s)		/* make an Attr cell containing s */
{
	Attr *ap = makeattr(STRING, sizexpr, s, just, sizeop);
	just = sizeop = 0;
	sizexpr = 0.0;
	return ap;
}

Attr *makeattr(int type, double fval, char *sval, int just, int op)
{
	Attr *a;

	a = (Attr *) malloc(sizeof(Attr));
	if (a == NULL)
		ERROR "out of space in makeattr" FATAL;
	a-&gt;type = type;
	a-&gt;fval = fval;
	a-&gt;sval = sval;
	a-&gt;just = just;
	a-&gt;op = op;
	a-&gt;next = NULL;
	return a;
}

Attr *addattr(Attr *a1, Attr *ap)	/* add attr ap to end of list a1 */
{
	Attr *p;

	if (a1 == 0)
		return ap;
	if (ap == 0)
		return a1;
	for (p = a1; p-&gt;next; p = p-&gt;next)
		;
	p-&gt;next = ap;
	return a1;
}

void freeattr(Attr *ap)	/* free an attribute list */
{
	Attr *p;

	while (ap) {
		p = ap-&gt;next;	/* save next */
		if (ap-&gt;sval)
			free(ap-&gt;sval);
		free((char *) ap);
		ap = p;
	}
}

char *slprint(Attr *stringlist)	/* print strings from stringlist */
{
	int ntext, n, last_op, last_just;
	double last_fval;
	static char buf[1000];
	Attr *ap;

	buf[0] = '\0';
	last_op = last_just = 0;
	last_fval = 0.0;
	for (ntext = 0, ap = stringlist; ap != NULL; ap = ap-&gt;next)
		ntext++;
	sprintf(buf, "box invis wid 0 ht %d*textht", ntext);
	n = strlen(buf);
	for (ap = stringlist; ap != NULL; ap = ap-&gt;next) {
		if (ap-&gt;op == 0) {	/* propagate last value */
			ap-&gt;op = last_op;
			ap-&gt;fval = last_fval;
		} else {
			last_op = ap-&gt;op;
			last_fval = ap-&gt;fval;
		}
		sprintf(buf+n, " \"%s\"", ps_set || ap-&gt;op ? sizeit(ap) : ap-&gt;sval);
		if (ap-&gt;just)
			last_just = ap-&gt;just;
		if (last_just)
			strcat(buf+n, juststr(last_just));
		n = strlen(buf);
	}
	return buf;	/* watch it:  static */
}

char *juststr(int j)	/* convert RJUST, etc., into string */
{
	static char buf[50];

	buf[0] = '\0';
	if (j &amp; RJUST)
		strcat(buf, " rjust");
	if (j &amp; LJUST)
		strcat(buf, " ljust");
	if (j &amp; ABOVE)
		strcat(buf, " above");
	if (j &amp; BELOW)
		strcat(buf, " below");
	return buf;	/* watch it:  static */
}

char *sprntf(char *s, Attr *ap)	/* sprintf(s, attrlist ap) */
{
	char buf[500];
	int n;
	Attr *p;

	for (n = 0, p = ap; p; p = p-&gt;next)
		n++;
	switch (n) {
	case 0:
		return s;
	case 1:
		sprintf(buf, s, ap-&gt;fval);
		break;
	case 2:
		sprintf(buf, s, ap-&gt;fval, ap-&gt;next-&gt;fval);
		break;
	case 3:
		sprintf(buf, s, ap-&gt;fval, ap-&gt;next-&gt;fval, ap-&gt;next-&gt;next-&gt;fval);
		break;
	case 5:
		ERROR "too many expressions in sprintf" WARNING;
	case 4:
		sprintf(buf, s, ap-&gt;fval, ap-&gt;next-&gt;fval, ap-&gt;next-&gt;next-&gt;fval, ap-&gt;next-&gt;next-&gt;next-&gt;fval);
		break;
	}
	free(s);
	return tostring(buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

