<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/grap/ticks.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/grap/ticks.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;math.h&gt;
#include "grap.h"
#include "y.tab.h"

#define	MAXTICK	200
int	ntick	= 0;
double	tickval[MAXTICK];	/* tick values (one axis at a time */
char	*tickstr[MAXTICK];	/* and labels */

int	tside	= 0;
int	tlist	= 0;		/* 1 =&gt; explicit values given */
int	toffside = 0;		/* no ticks on these sides */
int	goffside = 0;		/* no ticks on grid on these sides */
int	tick_dir = OUT;
double	ticklen	= TICKLEN;	/* default tick length */
int	autoticks = LEFT|BOT;
int	autodir = 0;		/* set LEFT, etc. if automatic ticks go in */

void savetick(double f, char *s)	/* remember tick location and label */
{
	if (ntick &gt;= MAXTICK)
		ERROR "too many ticks (%d)", MAXTICK FATAL;
	tickval[ntick] = f;
	tickstr[ntick] = s;
	ntick++;
}

void dflt_tick(double f)
{
	if (f &gt;= 0.0)
		savetick(f, tostring("%g"));
	else
		savetick(f, tostring("\\%g"));
}

void tickside(int n)	/* remember which side these ticks/gridlines go on */
{
	tside |= n;
}

void tickoff(int side)	/* remember explicit sides */
{
	toffside |= side;
}

void gridtickoff(void)	/* turn grid ticks off on the side previously specified (ugh) */
{
	goffside = tside;
}

void setlist(void)	/* remember that there was an explicit list */
{
	tlist = 1;
}

void tickdir(int dir, double val, int explicit)	/* remember in/out [expr] */
{
	tick_dir = dir;
	if (explicit)
		ticklen = val;
}

void ticks(void)		/* set autoticks after ticks statement */
{
	/* was there an explicit "ticks [side] off"? */
	if (toffside)
		autoticks &amp;= ~toffside;
	/* was there an explicit list? (eg "ticks at ..." or "ticks from ...") */
	if (tlist) {
		if (tside &amp; (BOT|TOP))
			autoticks &amp;= ~(BOT|TOP);
		if (tside &amp; (LEFT|RIGHT))
			autoticks &amp;= ~(LEFT|RIGHT);
	}
	/* was there a side without a list? (eg "ticks left in") */
	if (tside &amp;&amp; !tlist) {
		if (tick_dir == IN)
			autodir |= tside;
		if (tside &amp; (BOT|TOP))
			autoticks = (autoticks &amp; ~(BOT|TOP)) | (tside &amp; (BOT|TOP));
		if (tside &amp; (LEFT|RIGHT))
			autoticks = (autoticks &amp; ~(LEFT|RIGHT)) | (tside &amp; (LEFT|RIGHT));
	}
	tlist = tside = toffside = goffside = 0;
	tick_dir = OUT;
}

double modfloor(double f, double t)
{
	t = fabs(t);
	return floor(f/t) * t;
}

double modceil(double f, double t)
{
	t = fabs(t);
	return ceil(f/t) * t;
}

double	xtmin, xtmax;	/* range of ticks */
double	ytmin, ytmax;
double	xquant, xmult;	/* quantization &amp; scale for auto x ticks */
double	yquant, ymult;
double	lograt = 5;

void do_autoticks(Obj *p)	/* make set of ticks for default coord only */
{
	double x, xl, xu, q;

	if (p == NULL)
		return;
	fprintf(tfd, "Autoticks:\t# x %g..%g, y %g..%g",
		p-&gt;pt.x, p-&gt;pt1.x, p-&gt;pt.y, p-&gt;pt1.y);
	fprintf(tfd, ";   xt %g,%g, yt %g,%g, xq,xm = %g,%g, yq,ym = %g,%g\n",
		xtmin, xtmax, ytmin, ytmax, xquant, xmult, yquant, ymult);
	if ((autoticks &amp; (BOT|TOP)) &amp;&amp; p-&gt;pt1.x &gt;= p-&gt;pt.x) {	/* make x ticks */
		q = xquant;
		xl = p-&gt;pt.x;
		xu = p-&gt;pt1.x;
		if (xl &gt;= xu)
			dflt_tick(xl);
		else if ((p-&gt;log &amp; XFLAG) &amp;&amp; xu/xl &gt;= lograt) {
			for (x = q; x &lt; xu; x *= 10) {
				logtick(x, xl, xu);
				if (xu/xl &lt;= 100) {
					logtick(2*x, xl, xu);
					logtick(5*x, xl, xu);
				}
			}
		} else {
			xl = modceil(xtmin - q/100, q);
			xu = modfloor(xtmax + q/100, q) + q/2;
			for (x = xl; x &lt;= xu; x += q)
				dflt_tick(x);
		}
		tside = autoticks &amp; (BOT|TOP);
		ticklist(p, 0);
	}
	if ((autoticks &amp; (LEFT|RIGHT)) &amp;&amp; p-&gt;pt1.y &gt;= p-&gt;pt.y) {	/* make y ticks */
		q = yquant;
		xl = p-&gt;pt.y;
		xu = p-&gt;pt1.y;
		if (xl &gt;= xu)
			dflt_tick(xl);
		else if ((p-&gt;log &amp; YFLAG) &amp;&amp; xu/xl &gt;= lograt) {
			for (x = q; x &lt; xu; x *= 10) {
				logtick(x, xl, xu);
				if (xu/xl &lt;= 100) {
					logtick(2*x, xl, xu);
					logtick(5*x, xl, xu);
				}
			}
		} else {
			xl = modceil(ytmin - q/100, q);
			xu = modfloor(ytmax + q/100, q) + q/2;
			for (x = xl; x &lt;= xu; x += q)
				dflt_tick(x);
		}
		tside = autoticks &amp; (LEFT|RIGHT);
		ticklist(p, 0);
	}
}

void logtick(double v, double lb, double ub)
{
	float slop = 1.0;	/* was 1.001 */

	if (slop * lb &lt;= v &amp;&amp; ub &gt;= slop * v)
		dflt_tick(v);
}

Obj *setauto(void)	/* compute new min,max, and quant &amp; mult */
{
	Obj *p, *q;

	if ((q = lookup("lograt",0)) != NULL)
		lograt = q-&gt;fval;
	for (p = objlist; p; p = p-&gt;next)
		if (p-&gt;type == NAME &amp;&amp; strcmp(p-&gt;name,dflt_coord) == 0)
			break;
	if (p) {
		if ((p-&gt;log &amp; XFLAG) &amp;&amp; p-&gt;pt1.x/p-&gt;pt.x &gt;= lograt)
			autolog(p, 'x');
		else
			autoside(p, 'x');
		if ((p-&gt;log &amp; YFLAG) &amp;&amp; p-&gt;pt1.y/p-&gt;pt.y &gt;= lograt)
			autolog(p, 'y');
		else
			autoside(p, 'y');
	}
	return p;
}

void autoside(Obj *p, int side)
{
	double r, s, d, ub, lb;

	if (side == 'x') {
		xtmin = lb = p-&gt;pt.x;
		xtmax = ub = p-&gt;pt1.x;
	} else {
		ytmin = lb = p-&gt;pt.y;
		ytmax = ub = p-&gt;pt1.y;
	}
	if (ub &lt;= lb)
		return;	/* cop out on little ranges */
	d = ub - lb;
	r = s = 1;
	while (d * s &lt; 10)
		s *= 10;
	d *= s;
	while (10 * r &lt; d)
		r *= 10;
	if (r &gt; d/3)
		r /= 2;
	else if (r &lt;= d/6)
		r *= 2;
	if (side == 'x') {
		xquant = r / s;
	} else {
		yquant = r / s;
	}
}

void autolog(Obj *p, int side)
{
	double r, s, t, ub, lb;
	int flg;

	if (side == 'x') {
		xtmin = lb = p-&gt;pt.x;
		xtmax = ub = p-&gt;pt1.x;
		flg = p-&gt;coord &amp; XFLAG;
	} else {
		ytmin = lb = p-&gt;pt.y;
		ytmax = ub = p-&gt;pt1.y;
		flg = p-&gt;coord &amp; YFLAG;
	}
	for (s = 1; lb * s &lt; 1; s *= 10)
		;
	lb *= s;
	ub *= s;
	for (r = 1; 10 * r &lt; lb; r *= 10)
		;
	for (t = 1; t &lt; ub; t *= 10)
		;
	if (side == 'x')
		xquant = r / s;
	else
		yquant = r / s;
	if (flg)
		return;
	if (ub / lb &lt; 100) {
		if (lb &gt;= 5 * r)
			r *= 5;
		else if (lb &gt;= 2 * r)
			r *= 2;
		if (ub * 5 &lt;= t)
			t /= 5;
		else if (ub * 2 &lt;= t)
			t /= 2;
		if (side == 'x') {
			xtmin = r / s;
			xtmax = t / s;
		} else {
			ytmin = r / s;
			ytmax = t / s;
		}
	}
}

void iterator(double from, double to, int op, double by, char *fmt)	/* create an iterator */
{
	double x;

	/* should validate limits, etc. */
	/* punt for now */

	dprintf("iterate from %g to %g by %g, op = %c, fmt=%s\n",
		from, to, by, op, fmt ? fmt : "");
	switch (op) {
	case '+':
	case ' ':
		for (x = from; x &lt;= to + (SLOP-1) * by; x += by)
			if (fmt)
				savetick(x, tostring(fmt));
			else
				dflt_tick(x);
		break;
	case '-':
		for (x = from; x &gt;= to; x -= by)
			if (fmt)
				savetick(x, tostring(fmt));
			else
				dflt_tick(x);
		break;
	case '*':
		for (x = from; x &lt;= SLOP * to; x *= by)
			if (fmt)
				savetick(x, tostring(fmt));
			else
				dflt_tick(x);
		break;
	case '/':
		for (x = from; x &gt;= to; x /= by)
			if (fmt)
				savetick(x, tostring(fmt));
			else
				dflt_tick(x);
		break;
	}
	if (fmt)
		free(fmt);
}

void ticklist(Obj *p, int explicit)	/* fire out the accumulated ticks */
					/* 1 =&gt; list, 0 =&gt; auto */
{
	if (p == NULL)
		return;
	fprintf(tfd, "Ticks_%s:\n\tticklen = %g\n", p-&gt;name, ticklen);
	print_ticks(TICKS, explicit, p, "ticklen", "");
}

void print_ticks(int type, int explicit, Obj *p, char *lenstr, char *descstr)
{
	int i, logflag, inside;
	char buf[100];
	double tv;

	for (i = 0; i &lt; ntick; i++)	/* any ticks given explicitly? */
		if (tickstr[i] != NULL)
			break;
	if (i &gt;= ntick &amp;&amp; type == TICKS)	/* no, so use values */
		for (i = 0; i &lt; ntick; i++) {
			if (tickval[i] &gt;= 0.0)
				sprintf(buf, "%g", tickval[i]);
			else
				sprintf(buf, "\\-%g", -tickval[i]);
			tickstr[i] = tostring(buf);
		}
	else
		for (i = 0; i &lt; ntick; i++) {
			if (tickstr[i] != NULL) {
				sprintf(buf, tickstr[i], tickval[i]);
				free(tickstr[i]);
				tickstr[i] = tostring(buf);
			}
		}
	logflag = sidelog(p-&gt;log, tside);
	for (i = 0; i &lt; ntick; i++) {
		tv = tickval[i];
		halfrange(p, tside, tv);
		if (logflag) {
			if (tv &lt;= 0.0)
				ERROR "can't take log of tick value %g", tv FATAL;
			logit(tv);
		}
		if (type == GRID)
			inside = LEFT|RIGHT|TOP|BOT;
		else if (explicit)
			inside = (tick_dir == IN) ? tside : 0;
		else
			inside = autodir;
		if (tside &amp; BOT)
			maketick(type, p-&gt;name, BOT, inside, tv, tickstr[i], lenstr, descstr);
		if (tside &amp; TOP)
			maketick(type, p-&gt;name, TOP, inside, tv, tickstr[i], lenstr, descstr);
		if (tside &amp; LEFT)
			maketick(type, p-&gt;name, LEFT, inside, tv, tickstr[i], lenstr, descstr);
		if (tside &amp; RIGHT)
			maketick(type, p-&gt;name, RIGHT, inside, tv, tickstr[i], lenstr, descstr);
		if (tickstr[i]) {
			free(tickstr[i]);
			tickstr[i] = NULL;
		}
	}
	ntick = 0;
}

void maketick(int type, char *name, int side, int inflag, double val, char *lab, char *lenstr, char *descstr)
{
	char *sidestr, *td;

	fprintf(tfd, "\tline %s ", descstr);
	inflag &amp;= side;
	switch (side) {
	case BOT:
	case 0:
		td = inflag ? "up" : "down";
		fprintf(tfd, "%s %s from (x_%s(%g),0)", td, lenstr, name, val);
		break;
	case TOP:
		td = inflag ? "down" : "up";
		fprintf(tfd, "%s %s from (x_%s(%g),frameht)", td, lenstr, name, val);
		break;
	case LEFT:
		td = inflag ? "right" : "left";
		fprintf(tfd, "%s %s from (0,y_%s(%g))", td, lenstr, name, val);
		break;
	case RIGHT:
		td = inflag ? "left" : "right";
		fprintf(tfd, "%s %s from (framewid,y_%s(%g))", td, lenstr, name, val);
		break;
	}
	fprintf(tfd, "\n");
	if (type == GRID &amp;&amp; (side &amp; goffside))	/* wanted no ticks on grid */
		return;
	sidestr = tick_dir == IN ? "start" : "end";
	if (lab != NULL) {
		/* BUG: should fix size of lab here */
		double wid = strlen(lab)/7.5 + (tick_dir == IN ? 0 : 0.1);	/* estimate width at 15 chars/inch */
		switch (side) {
		case BOT: case 0:
			/* can drop "box invis" with new pic */
			fprintf(tfd, "\tbox invis \"%s\" ht .25 wid 0 with .n at last line.%s",
				lab, sidestr);
			break;
		case TOP:
			fprintf(tfd, "\tbox invis \"%s\" ht .2 wid 0 with .s at last line.%s",
				lab, sidestr);
			break;
		case LEFT:
			fprintf(tfd, "\t\"%s \" wid %.2f rjust at last line.%s",
				lab, wid, sidestr);
			break;
		case RIGHT:
			fprintf(tfd, "\t\" %s\" wid %.2f ljust at last line.%s",
				lab, wid, sidestr);
			break;
		}
		/* BUG: works only if "down x" comes before "at wherever" */
		lab_adjust();
		fprintf(tfd, "\n");
	}
}

Attr	*grid_desc	= 0;

void griddesc(Attr *a)
{
	grid_desc = a;
}

void gridlist(Obj *p)
{
	char *framestr;

	if ((tside &amp; (BOT|TOP)) || tside == 0)
		framestr = "frameht";
	else
		framestr = "framewid";
	fprintf(tfd, "Grid_%s:\n", p-&gt;name);
	tick_dir = IN;
	print_ticks(GRID, 0, p, framestr, desc_str(grid_desc));
	if (grid_desc) {
		freeattr(grid_desc);
		grid_desc = 0;
	}
}

char *desc_str(Attr *a)	/* convert DOT to "dotted", etc. */
{
	static char buf[50], *p;

	if (a == NULL)
		return p = "";
	switch (a-&gt;type) {
	case DOT:	p = "dotted"; break;
	case DASH:	p = "dashed"; break;
	case INVIS:	p = "invis"; break;
	default:	p = "";
	}
	if (a-&gt;fval != 0.0) {
		sprintf(buf, "%s %g", p, a-&gt;fval);
		return buf;
	} else
		return p;
}

sidelog(int logflag, int side)	/* figure out whether to scale a side */
{
	if ((logflag &amp; XFLAG) &amp;&amp; ((side &amp; (BOT|TOP)) || side == 0))
		return 1;
	else if ((logflag &amp; YFLAG) &amp;&amp; (side &amp; (LEFT|RIGHT)))
		return 1;
	else
		return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

