<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/graph/graph.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/graph/graph.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include "iplot.h"
#define	INF	1.e+37
#define	F	.25

struct xy {
	int	xlbf;		/*flag:explicit lower bound*/
	int 	xubf;		/*flag:explicit upper bound*/
	int	xqf;		/*flag:explicit quantum*/
	double (*xf)(double);	/*transform function, e.g. log*/
	float	xa,xb;		/*scaling coefficients*/
	float	xlb,xub;	/*lower and upper bound*/
	float	xquant;		/*quantum*/
	float	xoff;		/*screen offset fraction*/
	float	xsize;		/*screen fraction*/
	int	xbot,xtop;	/*screen coords of border*/	
	float	xmult;		/*scaling constant*/
} xd,yd;
struct val {
	float xv;
	float yv;
	int lblptr;
} *xx;

char *labels;
int labelsiz;

int tick = 50;
int top = 4000;
int bot = 200;
float absbot;
int	n;
int	erasf = 1;
int	gridf = 2;
int	symbf = 0;
int	absf = 0;
int	transf;
int	equf;
int	brkf;
int	ovlay = 1;
float	dx;
char	*plotsymb;

#define BSIZ 80
char	labbuf[BSIZ];
char	titlebuf[BSIZ];

char *modes[] = {
	"disconnected",
	"solid",
	"dotted",
	"dotdashed",
	"shortdashed",
	"longdashed"
};
int mode = 1;
double ident(double x){
	return(x);
}

struct z {
	float lb,ub,mult,quant;
};

struct {
	char *name;
	int next;
} palette[] = {
	['b']	{ "blue", 'b' },
	['c']	{ "cyan", 'c' },
	['g']	{ "green", 'g' },
	['k']	{ "kblack", 'k' },
	['m']	{ "magenta", 'm' },
	['r']	{ "red", 'r' },
	['w']	{ "white", 'w' },
	['y']	{ "yellow", 'y' }
};
int pencolor = 'k';

void init(struct xy *);
void setopt(int, char *[]);
void readin(void);
void transpose(void);
void getlim(struct xy *, struct val *);
void equilibrate(struct xy *, struct xy *);
void scale(struct xy *);
void limread(struct xy *, int *, char ***);
int numb(float *, int *, char ***);
void colread(int *, char ***);
int copystring(int);
struct z setloglim(int, int, float, float);
struct z setlinlim(int, int, float, float);
void axes(void);
int setmark(int *, struct xy *);
void submark(int *, int *, float, struct xy *);
void plot(void);
int getfloat(float *);
int getstring(void);
void title(void);
void badarg(void);
int conv(float, struct xy *, int *);
int symbol(int, int, int);
void axlab(char, struct xy *, char *);

void main(int argc,char *argv[]){

	openpl();
	range(0,0,4096,4096);
	init(&amp;xd);
	init(&amp;yd);
	xd.xsize = yd.xsize = 1.;
	xx = (struct val *)malloc((unsigned)sizeof(struct val));
	labels = malloc(1);
	labels[labelsiz++] = 0;
	setopt(argc,argv);
	if(erasf)
		erase();
	readin();
	transpose();
	getlim(&amp;xd,(struct val *)&amp;xx-&gt;xv);
	getlim(&amp;yd,(struct val *)&amp;xx-&gt;yv);
	if(equf) {
		equilibrate(&amp;xd,&amp;yd);
		equilibrate(&amp;yd,&amp;xd);
	}
	scale(&amp;xd);
	scale(&amp;yd);
	axes();
	title();
	plot();
	closepl();
	exits(0);
}

void init(struct xy *p){
	p-&gt;xf = ident;
	p-&gt;xmult = 1;
}

void setopt(int argc, char *argv[]){
	char *p1, *p2;
	float temp;

	xd.xlb = yd.xlb = INF;
	xd.xub = yd.xub = -INF;
	while(--argc &gt; 0) {
		argv++;
again:		switch(argv[0][0]) {
		case '-':
			argv[0]++;
			goto again;
		case 'l': /* label for plot */
			p1 = titlebuf;
			if (argc&gt;=2) {
				argv++;
				argc--;
				p2 = argv[0];
				while (*p1++ = *p2++);
			}
			break;

		case 'd':	/*disconnected,obsolete option*/
		case 'm': /*line mode*/
			mode = 0;
			if(!numb(&amp;temp,&amp;argc,&amp;argv))
				break;
			if(temp&gt;=sizeof(modes)/sizeof(*modes))
				mode = 1;
			else if(temp&gt;=-1)
				mode = temp;
			break;

		case 'o':
			if(numb(&amp;temp,&amp;argc,&amp;argv) &amp;&amp; temp&gt;=1)
				ovlay = temp;
			break;
		case 'a': /*automatic abscissas*/
			absf = 1;
			dx = 1;
			if(!numb(&amp;dx,&amp;argc,&amp;argv))
				break;
			if(numb(&amp;absbot,&amp;argc,&amp;argv))
				absf = 2;
			break;

		case 's': /*save screen, overlay plot*/
			erasf = 0;
			break;

		case 'g': /*grid style 0 none, 1 ticks, 2 full*/
			gridf = 0;
			if(!numb(&amp;temp,&amp;argc,&amp;argv))
				temp = argv[0][1]-'0';	/*for caompatibility*/
			if(temp&gt;=0&amp;&amp;temp&lt;=2)
				gridf = temp;
			break;

		case 'c': /*character(s) for plotting*/
			if(argc &gt;= 2) {
				symbf = 1;
				plotsymb = argv[1];
				argv++;
				argc--;
			}
			break;

		case 't':	/*transpose*/
			transf = 1;
			break;
		case 'e':	/*equal scales*/
			equf = 1;
			break;
		case 'b':	/*breaks*/
			brkf = 1;
			break;
		case 'x':	/*x limits */
			limread(&amp;xd,&amp;argc,&amp;argv);
			break;
		case 'y':
			limread(&amp;yd,&amp;argc,&amp;argv);
			break;
		case 'h': /*set height of plot */
			if(!numb(&amp;yd.xsize, &amp;argc,&amp;argv))
				badarg();
			break;
		case 'w': /*set width of plot */
			if(!numb(&amp;xd.xsize, &amp;argc, &amp;argv))
				badarg();
			break;
		case 'r': /* set offset to right */
			if(!numb(&amp;xd.xoff, &amp;argc, &amp;argv))
				badarg();
			break;
		case 'u': /*set offset up the screen*/
			if(!numb(&amp;yd.xoff,&amp;argc,&amp;argv))
				badarg();
			break;
		case 'p': /*pen color*/
			colread(&amp;argc, &amp;argv);
			break;
		default:
			badarg();
		}
	}
}

void limread(struct xy *p, int *argcp, char ***argvp){
	if(*argcp&gt;1 &amp;&amp; (*argvp)[1][0]=='l') {
		(*argcp)--;
		(*argvp)++;
		p-&gt;xf = log10;
	}
	if(!numb(&amp;p-&gt;xlb,argcp,argvp))
		return;
	p-&gt;xlbf = 1;
	if(!numb(&amp;p-&gt;xub,argcp,argvp))
		return;
	p-&gt;xubf = 1;
	if(!numb(&amp;p-&gt;xquant,argcp,argvp))
		return;
	p-&gt;xqf = 1;
}

isdigit(char c){
	return '0'&lt;=c &amp;&amp; c&lt;='9';
}
numb(float *np, int *argcp, char ***argvp){
	char c;

	if(*argcp &lt;= 1)
		return(0);
	while((c=(*argvp)[1][0]) == '+')
		(*argvp)[1]++;
	if(!(isdigit(c) || c=='-'&amp;&amp;(*argvp)[1][1]&lt;'A' || c=='.'))
		return(0);
	*np = atof((*argvp)[1]);
	(*argcp)--;
	(*argvp)++;
	return(1);
}

void colread(int *argcp, char ***argvp){
	int c, cnext;
	int i, n;

	if(*argcp&lt;=1)
		return;
	n = strlen((*argvp)[1]);
	if(strspn((*argvp)[1], "bcgkmrwy")!=n)
		return;
	pencolor = cnext = (*argvp)[1][0];
	for(i=0; i&lt;n-1; i++){
		c = (unsigned char)(*argvp)[1][i];
		cnext = (unsigned char)(*argvp)[1][i+1];
		palette[c].next = cnext;
	}
	palette[cnext].next = pencolor;
	(*argcp)--;
	(*argvp)++;
}

void readin(void){
	int i, t;
	struct val *temp;

	if(absf==1) {
		if(xd.xlbf)
			absbot = xd.xlb;
		else if(xd.xf==log10)
			absbot = 1;
	}
	for(;;) {
		temp = (struct val *)realloc((char*)xx,
			(unsigned)(n+ovlay)*sizeof(struct val));
		if(temp==0)
			return;
		xx = temp;
		if(absf)
			xx[n].xv = n*dx/ovlay + absbot;
		else
			if(!getfloat(&amp;xx[n].xv))
				return;
		t = 0;	/* silence compiler */
		for(i=0;i&lt;ovlay;i++) {
			xx[n+i].xv = xx[n].xv;
			if(!getfloat(&amp;xx[n+i].yv))
				return;
			xx[n+i].lblptr = -1;
			t = getstring();
			if(t&gt;0)
				xx[n+i].lblptr = copystring(t);
			if(t&lt;0 &amp;&amp; i+1&lt;ovlay)
				return;
		}
		n += ovlay;
		if(t&lt;0)
			return;
	}
}

void transpose(void){
	int i;
	float f;
	struct xy t;
	if(!transf)
		return;
	t = xd; xd = yd; yd = t;
	for(i= 0;i&lt;n;i++) {
		f = xx[i].xv; xx[i].xv = xx[i].yv; xx[i].yv = f;
	}
}

int copystring(int k){
	char *temp;
	int i;
	int q;

	temp = realloc(labels,(unsigned)(labelsiz+1+k));
	if(temp==0)
		return(0);
	labels = temp;
	q = labelsiz;
	for(i=0;i&lt;=k;i++)
		labels[labelsiz++] = labbuf[i];
	return(q);
}

float modceil(float f, float t){

	t = fabs(t);
	return(ceil(f/t)*t);
}

float
modfloor(float f, float t){
	t = fabs(t);
	return(floor(f/t)*t);
}

void getlim(struct xy *p, struct val *v){
	int i;

	i = 0;
	do {
		if(!p-&gt;xlbf &amp;&amp; p-&gt;xlb&gt;v[i].xv)
			p-&gt;xlb = v[i].xv;
		if(!p-&gt;xubf &amp;&amp; p-&gt;xub&lt;v[i].xv)
			p-&gt;xub = v[i].xv;
		i++;
	} while(i &lt; n);
}

void setlim(struct xy *p){
	float t,delta,sign;
	struct z z;
	int mark[50];
	float lb,ub;
	int lbf,ubf;

	lb = p-&gt;xlb;
	ub = p-&gt;xub;
	delta = ub-lb;
	if(p-&gt;xqf) {
		if(delta*p-&gt;xquant &lt;=0 )
			badarg();
		return;
	}
	sign = 1;
	lbf = p-&gt;xlbf;
	ubf = p-&gt;xubf;
	if(delta &lt; 0) {
		sign = -1;
		t = lb;
		lb = ub;
		ub = t;
		t = lbf;
		lbf = ubf;
		ubf = t;
	}
	else if(delta == 0) {
		if(ub &gt; 0) {
			ub = 2*ub;
			lb = 0;
		} 
		else
			if(lb &lt; 0) {
				lb = 2*lb;
				ub = 0;
			} 
			else {
				ub = 1;
				lb = -1;
			}
	}
	if(p-&gt;xf==log10 &amp;&amp; lb&gt;0 &amp;&amp; ub&gt;lb) {
		z = setloglim(lbf,ubf,lb,ub);
		p-&gt;xlb = z.lb;
		p-&gt;xub = z.ub;
		p-&gt;xmult *= z.mult;
		p-&gt;xquant = z.quant;
		if(setmark(mark,p)&lt;2) {
			p-&gt;xqf = lbf = ubf = 1;
			lb = z.lb; ub = z.ub;
		} else
			return;
	}
	z = setlinlim(lbf,ubf,lb,ub);
	if(sign &gt; 0) {
		p-&gt;xlb = z.lb;
		p-&gt;xub = z.ub;
	} else {
		p-&gt;xlb = z.ub;
		p-&gt;xub = z.lb;
	}
	p-&gt;xmult *= z.mult;
	p-&gt;xquant = sign*z.quant;
}

struct z
setloglim(int lbf, int ubf, float lb, float ub){
	float r,s,t;
	struct z z;

	for(s=1; lb*s&lt;1; s*=10) ;
	lb *= s;
	ub *= s;
	for(r=1; 10*r&lt;=lb; r*=10) ;
	for(t=1; t&lt;ub; t*=10) ;
	z.lb = !lbf ? r : lb;
	z.ub = !ubf ? t : ub;
	if(ub/lb&lt;100) {
		if(!lbf) {
			if(lb &gt;= 5*z.lb)
				z.lb *= 5;
			else if(lb &gt;= 2*z.lb)
				z.lb *= 2;
		}
		if(!ubf) {
			if(ub*5 &lt;= z.ub)
				z.ub /= 5;
			else if(ub*2 &lt;= z.ub)
				z.ub /= 2;
		}
	}
	z.mult = s;
	z.quant = r;
	return(z);
}

struct z
setlinlim(int lbf, int ubf, float xlb, float xub){
	struct z z;
	float r,s,delta;
	float ub,lb;

loop:
	ub = xub;
	lb = xlb;
	delta = ub - lb;
	/*scale up by s, a power of 10, so range (delta) exceeds 1*/
	/*find power of 10 quantum, r, such that delta/10&lt;=r&lt;delta*/
	r = s = 1;
	while(delta*s &lt; 10)
		s *= 10;
	delta *= s;
	while(10*r &lt; delta)
		r *= 10;
	lb *= s;
	ub *= s;
	/*set r=(1,2,5)*10**n so that 3-5 quanta cover range*/
	if(r&gt;=delta/2)
		r /= 2;
	else if(r&lt;delta/5)
		r *= 2;
	z.ub = ubf? ub: modceil(ub,r);
	z.lb = lbf? lb: modfloor(lb,r);
	if(!lbf &amp;&amp; z.lb&lt;=r &amp;&amp; z.lb&gt;0) {
		xlb = 0;
		goto loop;
	}
	else if(!ubf &amp;&amp; z.ub&gt;=-r &amp;&amp; z.ub&lt;0) {
		xub = 0;
		goto loop;
	}
	z.quant = r;
	z.mult = s;
	return(z);
}

void scale(struct xy *p){
	float edge;

	setlim(p);
	edge = top-bot;
	p-&gt;xa = p-&gt;xsize*edge/((*p-&gt;xf)(p-&gt;xub) - (*p-&gt;xf)(p-&gt;xlb));
	p-&gt;xbot = bot + edge*p-&gt;xoff;
	p-&gt;xtop = p-&gt;xbot + (top-bot)*p-&gt;xsize;
	p-&gt;xb = p-&gt;xbot - (*p-&gt;xf)(p-&gt;xlb)*p-&gt;xa + .5;
}

void equilibrate(struct xy *p, struct xy *q){
	if(p-&gt;xlbf||	/* needn't test xubf; it implies xlbf*/
	   q-&gt;xubf&amp;&amp;q-&gt;xlb&gt;q-&gt;xub)
		return;
	if(p-&gt;xlb&gt;q-&gt;xlb) {
		p-&gt;xlb = q-&gt;xlb;
		p-&gt;xlbf = q-&gt;xlbf;
	}
	if(p-&gt;xub&lt;q-&gt;xub) {
		p-&gt;xub = q-&gt;xub;
		p-&gt;xubf = q-&gt;xubf;
	}
}

void axes(void){
	int i;
	int mark[50];
	int xn, yn;
	if(gridf==0)
		return;

	line(xd.xbot,yd.xbot,xd.xtop,yd.xbot);
	vec(xd.xtop,yd.xtop);
	vec(xd.xbot,yd.xtop);
	vec(xd.xbot,yd.xbot);

	xn = setmark(mark,&amp;xd);
	for(i=0; i&lt;xn; i++) {
		if(gridf==2)
			line(mark[i],yd.xbot,mark[i],yd.xtop);
		if(gridf==1) {
			line(mark[i],yd.xbot,mark[i],yd.xbot+tick);
			line(mark[i],yd.xtop-tick,mark[i],yd.xtop);
		}
	}
	yn = setmark(mark,&amp;yd);
	for(i=0; i&lt;yn; i++) {
		if(gridf==2)
			line(xd.xbot,mark[i],xd.xtop,mark[i]);
		if(gridf==1) {
			line(xd.xbot,mark[i],xd.xbot+tick,mark[i]);
			line(xd.xtop-tick,mark[i],xd.xtop,mark[i]);
		}
	}
}

int
setmark(int *xmark, struct xy *p){
	int xn = 0;
	float x,xl,xu;
	float q;
	if(p-&gt;xf==log10&amp;&amp;!p-&gt;xqf) {
		for(x=p-&gt;xquant; x&lt;p-&gt;xub; x*=10) {
			submark(xmark,&amp;xn,x,p);
			if(p-&gt;xub/p-&gt;xlb&lt;=100) {
				submark(xmark,&amp;xn,2*x,p);
				submark(xmark,&amp;xn,5*x,p);
			}
		}
	} else {
		xn = 0;
		q = p-&gt;xquant;
		if(q&gt;0) {
			xl = modceil(p-&gt;xlb+q/6,q);
			xu = modfloor(p-&gt;xub-q/6,q)+q/2;
		} else {
			xl = modceil(p-&gt;xub-q/6,q);
			xu = modfloor(p-&gt;xlb+q/6,q)-q/2;
		}
		for(x=xl; x&lt;=xu; x+=fabs(p-&gt;xquant))
			xmark[xn++] = (*p-&gt;xf)(x)*p-&gt;xa + p-&gt;xb;
	}
	return(xn);
}
void submark(int *xmark, int *pxn, float x, struct xy *p){
	if(1.001*p-&gt;xlb &lt; x &amp;&amp; .999*p-&gt;xub &gt; x)
		xmark[(*pxn)++] = log10(x)*p-&gt;xa + p-&gt;xb;
}

void plot(void){
	int ix,iy;
	int i,j;
	int conn;

	for(j=0;j&lt;ovlay;j++) {
		switch(mode) {
		case -1:
			pen(modes[j%(sizeof modes/sizeof *modes-1)+1]);
			break;
		case 0:
			break;
		default:
			pen(modes[mode]);
		}
		color(palette[pencolor].name);
		conn = 0;
		for(i=j; i&lt;n; i+=ovlay) {
			if(!conv(xx[i].xv,&amp;xd,&amp;ix) ||
			   !conv(xx[i].yv,&amp;yd,&amp;iy)) {
				conn = 0;
				continue;
			}
			if(mode!=0) {
				if(conn != 0)
					vec(ix,iy);
				else
					move(ix,iy);
				conn = 1;
			}
			conn &amp;= symbol(ix,iy,xx[i].lblptr);
		}
		pencolor = palette[pencolor].next;
	}
	pen(modes[1]);
}

int
conv(float xv, struct xy *p, int *ip){
	long ix;
	ix = p-&gt;xa*(*p-&gt;xf)(xv*p-&gt;xmult) + p-&gt;xb;
	if(ix&lt;p-&gt;xbot || ix&gt;p-&gt;xtop)
		return(0);
	*ip = ix;
	return(1);
}

int
getfloat(float *p){
	int i;

	i = scanf("%f",p);
	return(i==1);
}

int
getstring(void){
	int i;
	char junk[20];
	i = scanf("%1s",labbuf);
	if(i==-1)
		return(-1);
	switch(*labbuf) {
	default:
		if(!isdigit(*labbuf)) {
			ungetc(*labbuf,stdin);
			i = scanf("%s",labbuf);
			break;
		}
	case '.':
	case '+':
	case '-':
		ungetc(*labbuf,stdin);
		return(0);
	case '"':
		i = scanf("%[^\"\n]",labbuf);
		scanf("%[\"]",junk);
		break;
	}
	if(i==-1)
		return(-1);
	return(strlen(labbuf));
}

int
symbol(int ix, int iy, int k){

	if(symbf==0&amp;&amp;k&lt;0) {
		if(mode==0)
			point(ix,iy);
		return(1);
	} 
	else {
		move(ix,iy);
		text(k&gt;=0?labels+k:plotsymb);
		move(ix,iy);
		return(!brkf|k&lt;0);
	}
}

void title(void){
	char buf[BSIZ+100];
	buf[0] = ' ';
	buf[1] = ' ';
	buf[2] = ' ';
	strcpy(buf+3,titlebuf);
	if(erasf&amp;&amp;gridf) {
		axlab('x',&amp;xd,buf);
		strcat(buf,",");
		axlab('y',&amp;yd,buf);
	}
	move(xd.xbot,yd.xbot-60);
	text(buf);
}

void axlab(char c, struct xy *p, char *b){
	char *dir;
	dir = p-&gt;xlb&lt;p-&gt;xub? "&lt;=": "&gt;=";
	sprintf(b+strlen(b), " %g %s %c%s %s %g", p-&gt;xlb/p-&gt;xmult,
		dir, c, p-&gt;xf==log10?" (log)":"", dir, p-&gt;xub/p-&gt;xmult);
}

void badarg(void){
	fprintf(stderr,"graph: error in arguments\n");
	closepl();
	exits("bad arg");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

