<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/grep/comp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/grep/comp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"grep.h"

/*
 * incremental compiler.
 * add the branch c to the
 * state s.
 */
void
increment(State *s, int c)
{
	int i;
	State *t, **tt;
	Re *re1, *re2;

	nfollow = 0;
	gen++;
	matched = 0;
	for(i=0; i&lt;s-&gt;count; i++)
		fol1(s-&gt;re[i], c);
	qsort(follow, nfollow, sizeof(*follow), fcmp);
	for(tt=&amp;state0; t = *tt;) {
		if(t-&gt;count &gt; nfollow) {
			tt = &amp;t-&gt;linkleft;
			goto cont;
		}
		if(t-&gt;count &lt; nfollow) {
			tt = &amp;t-&gt;linkright;
			goto cont;
		}
		for(i=0; i&lt;nfollow; i++) {
			re1 = t-&gt;re[i];
			re2 = follow[i];
			if(re1 &gt; re2) {
				tt = &amp;t-&gt;linkleft;
				goto cont;
			}
			if(re1 &lt; re2) {
				tt = &amp;t-&gt;linkright;
				goto cont;
			}
		}
		if(!!matched &amp;&amp; !t-&gt;match) {
			tt = &amp;t-&gt;linkleft;
			goto cont;
		}
		if(!matched &amp;&amp; !!t-&gt;match) {
			tt = &amp;t-&gt;linkright;
			goto cont;
		}
		s-&gt;next[c] = t;
		return;
	cont:;
	}

	t = sal(nfollow);
	*tt = t;
	for(i=0; i&lt;nfollow; i++) {
		re1 = follow[i];
		t-&gt;re[i] = re1;
	}
	s-&gt;next[c] = t;
	t-&gt;match = matched;
}

int
fcmp(void *va, void *vb)
{
	Re **aa, **bb;
	Re *a, *b;

	aa = va;
	bb = vb;
	a = *aa;
	b = *bb;
	if(a &gt; b)
		return 1;
	if(a &lt; b)
		return -1;
	return 0;
}

void
fol1(Re *r, int c)
{
	Re *r1;

loop:
	if(r-&gt;gen == gen)
		return;
	if(nfollow &gt;= maxfollow)
		error("nfollow");
	r-&gt;gen = gen;
	switch(r-&gt;type) {
	default:
		error("fol1");

	case Tcase:
		if(c &gt;= 0 &amp;&amp; c &lt; 256)
		if(r1 = r-&gt;cases[c])
			follow[nfollow++] = r1;
		if(r = r-&gt;next)
			goto loop;
		break;

	case Talt:
	case Tor:
		fol1(r-&gt;alt, c);
		r = r-&gt;next;
		goto loop;

	case Tbegin:
		if(c == '\n' || c == Cbegin)
			follow[nfollow++] = r-&gt;next;
		break;

	case Tend:
		if(c == '\n') {
			if(r-&gt;next == 0) {
				matched = 1;
				break;
			}
			r = r-&gt;next;
			goto loop;
		}
		break;

	case Tclass:
		if(c &gt;= r-&gt;lo &amp;&amp; c &lt;= r-&gt;hi)
			follow[nfollow++] = r-&gt;next;
		break;
	}
}

Rune	tab1[] =
{
	0x007f,
	0x07ff,
};
Rune	tab2[] =
{
	0x003f,
	0x0fff,
};

Re2
rclass(Rune p0, Rune p1)
{
	char xc0[6], xc1[6];
	int i, n, m;
	Re2 x;

	if(p0 &gt; p1)
		return re2char(0xff, 0xff);	// no match

	/*
	 * bust range into same length
	 * character sequences
	 */
	for(i=0; i&lt;nelem(tab1); i++) {
		m = tab1[i];
		if(p0 &lt;= m &amp;&amp; p1 &gt; m)
			return re2or(rclass(p0, m), rclass(m+1, p1));
	}

	/*
	 * bust range into part of a single page
	 * or into full pages
	 */
	for(i=0; i&lt;nelem(tab2); i++) {
		m = tab2[i];
		if((p0 &amp; ~m) != (p1 &amp; ~m)) {
			if((p0 &amp; m) != 0)
				return re2or(rclass(p0, p0|m), rclass((p0|m)+1, p1));
			if((p1 &amp; m) != m)
				return re2or(rclass(p0, (p1&amp;~m)-1), rclass(p1&amp;~m, p1));
		}
	}

	n = runetochar(xc0, &amp;p0);
	i = runetochar(xc1, &amp;p1);
	if(i != n)
		error("length");

	x = re2char(xc0[0], xc1[0]);
	for(i=1; i&lt;n; i++)
		x = re2cat(x, re2char(xc0[i], xc1[i]));
	return x;
}

int
pcmp(void *va, void *vb)
{
	int n;
	Rune *a, *b;

	a = va;
	b = vb;

	n = a[0] - b[0];
	if(n)
		return n;
	return a[1] - b[1];
}

/*
 * convert character chass into
 * run-pair ranges of matches.
 * this is 10646/utf specific and
 * needs to be changed for some
 * other input character set.
 * this is the key to a fast
 * regular search of characters
 * by looking at sequential bytes.
 */
Re2
re2class(char *s)
{
	Rune pairs[200+2], *p, *q, ov;
	int nc;
	Re2 x;

	nc = 0;
	if(*s == '^') {
		nc = 1;
		s++;
	}

	p = pairs;
	s += chartorune(p, s);
	for(;;) {
		if(*p == '\\')
			s += chartorune(p, s);
		if(*p == 0)
			break;
		p[1] = *p;
		p += 2;
		if(p &gt;= pairs + nelem(pairs) - 2)
			error("class too big");
		s += chartorune(p, s);
		if(*p != '-')
			continue;
		s += chartorune(p, s);
		if(*p == '\\')
			s += chartorune(p, s);
		if(*p == 0)
			break;
		p[-1] = *p;
		s += chartorune(p, s);
	}
	*p = 0;
	qsort(pairs, (p-pairs)/2, 2*sizeof(*pairs), pcmp);

	q = pairs;
	for(p=pairs+2; *p; p+=2) {
		if(p[0] &gt; p[1])
			continue;
		if(p[0] &gt; q[1] || p[1] &lt; q[0]) {
			q[2] = p[0];
			q[3] = p[1];
			q += 2;
			continue;
		}
		if(p[0] &lt; q[0])
			q[0] = p[0];
		if(p[1] &gt; q[1])
			q[1] = p[1];
	}
	q[2] = 0;

	p = pairs;
	if(nc) {
		x = rclass(0, p[0]-1);
		ov = p[1]+1;
		for(p+=2; *p; p+=2) {
			x = re2or(x, rclass(ov, p[0]-1));
			ov = p[1]+1;
		}
		x = re2or(x, rclass(ov, Runemask));
	} else {
		x = rclass(p[0], p[1]);
		for(p+=2; *p; p+=2)
			x = re2or(x, rclass(p[0], p[1]));
	}
	return x;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

