<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/jpeg/jcphuff.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/jpeg/jcphuff.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * jcphuff.c
 *
 * Copyright (C) 1995-1997, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains Huffman entropy encoding routines for progressive JPEG.
 *
 * We do not support output suspension in this module, since the library
 * currently does not allow multiple-scan files to be written with output
 * suspension.
 */

#define JPEG_INTERNALS
#include "jinclude.h"
#include "jpeglib.h"
#include "jchuff.h"		/* Declarations shared with jchuff.c */

#ifdef C_PROGRESSIVE_SUPPORTED

/* Expanded entropy encoder object for progressive Huffman encoding. */

typedef struct {
  struct jpeg_entropy_encoder pub; /* public fields */

  /* Mode flag: TRUE for optimization, FALSE for actual data output */
  boolean gather_statistics;

  /* Bit-level coding status.
   * next_output_byte/free_in_buffer are local copies of cinfo-&gt;dest fields.
   */
  JOCTET * next_output_byte;	/* =&gt; next byte to write in buffer */
  size_t free_in_buffer;	/* # of byte spaces remaining in buffer */
  INT32 put_buffer;		/* current bit-accumulation buffer */
  int put_bits;			/* # of bits now in it */
  j_compress_ptr cinfo;		/* link to cinfo (needed for dump_buffer) */

  /* Coding status for DC components */
  int last_dc_val[MAX_COMPS_IN_SCAN]; /* last DC coef for each component */

  /* Coding status for AC components */
  int ac_tbl_no;		/* the table number of the single component */
  unsigned int EOBRUN;		/* run length of EOBs */
  unsigned int BE;		/* # of buffered correction bits before MCU */
  char * bit_buffer;		/* buffer for correction bits (1 per char) */
  /* packing correction bits tightly would save some space but cost time... */

  unsigned int restarts_to_go;	/* MCUs left in this restart interval */
  int next_restart_num;		/* next restart number to write (0-7) */

  /* Pointers to derived tables (these workspaces have image lifespan).
   * Since any one scan codes only DC or only AC, we only need one set
   * of tables, not one for DC and one for AC.
   */
  c_derived_tbl * derived_tbls[NUM_HUFF_TBLS];

  /* Statistics tables for optimization; again, one set is enough */
  long * count_ptrs[NUM_HUFF_TBLS];
} phuff_entropy_encoder;

typedef phuff_entropy_encoder * phuff_entropy_ptr;

/* MAX_CORR_BITS is the number of bits the AC refinement correction-bit
 * buffer can hold.  Larger sizes may slightly improve compression, but
 * 1000 is already well into the realm of overkill.
 * The minimum safe size is 64 bits.
 */

#define MAX_CORR_BITS  1000	/* Max # of correction bits I can buffer */

/* IRIGHT_SHIFT is like RIGHT_SHIFT, but works on int rather than INT32.
 * We assume that int right shift is unsigned if INT32 right shift is,
 * which should be safe.
 */

#ifdef RIGHT_SHIFT_IS_UNSIGNED
#define ISHIFT_TEMPS	int ishift_temp;
#define IRIGHT_SHIFT(x,shft)  \
	((ishift_temp = (x)) &lt; 0 ? \
	 (ishift_temp &gt;&gt; (shft)) | ((~0) &lt;&lt; (16-(shft))) : \
	 (ishift_temp &gt;&gt; (shft)))
#else
#define ISHIFT_TEMPS
#define IRIGHT_SHIFT(x,shft)	((x) &gt;&gt; (shft))
#endif

/* Forward declarations */
METHODDEF(boolean) encode_mcu_DC_first JPP((j_compress_ptr cinfo,
					    JBLOCKROW *MCU_data));
METHODDEF(boolean) encode_mcu_AC_first JPP((j_compress_ptr cinfo,
					    JBLOCKROW *MCU_data));
METHODDEF(boolean) encode_mcu_DC_refine JPP((j_compress_ptr cinfo,
					     JBLOCKROW *MCU_data));
METHODDEF(boolean) encode_mcu_AC_refine JPP((j_compress_ptr cinfo,
					     JBLOCKROW *MCU_data));
METHODDEF(void) finish_pass_phuff JPP((j_compress_ptr cinfo));
METHODDEF(void) finish_pass_gather_phuff JPP((j_compress_ptr cinfo));


/*
 * Initialize for a Huffman-compressed scan using progressive JPEG.
 */

METHODDEF(void)
start_pass_phuff (j_compress_ptr cinfo, boolean gather_statistics)
{  
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  boolean is_DC_band;
  int ci, tbl;
  jpeg_component_info * compptr;

  entropy-&gt;cinfo = cinfo;
  entropy-&gt;gather_statistics = gather_statistics;

  is_DC_band = (cinfo-&gt;Ss == 0);

  /* We assume jcmaster.c already validated the scan parameters. */

  /* Select execution routines */
  if (cinfo-&gt;Ah == 0) {
    if (is_DC_band)
      entropy-&gt;pub.encode_mcu = encode_mcu_DC_first;
    else
      entropy-&gt;pub.encode_mcu = encode_mcu_AC_first;
  } else {
    if (is_DC_band)
      entropy-&gt;pub.encode_mcu = encode_mcu_DC_refine;
    else {
      entropy-&gt;pub.encode_mcu = encode_mcu_AC_refine;
      /* AC refinement needs a correction bit buffer */
      if (entropy-&gt;bit_buffer == NULL)
	entropy-&gt;bit_buffer = (char *)
	  (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				      MAX_CORR_BITS * SIZEOF(char));
    }
  }
  if (gather_statistics)
    entropy-&gt;pub.finish_pass = finish_pass_gather_phuff;
  else
    entropy-&gt;pub.finish_pass = finish_pass_phuff;

  /* Only DC coefficients may be interleaved, so cinfo-&gt;comps_in_scan = 1
   * for AC coefficients.
   */
  for (ci = 0; ci &lt; cinfo-&gt;comps_in_scan; ci++) {
    compptr = cinfo-&gt;cur_comp_info[ci];
    /* Initialize DC predictions to 0 */
    entropy-&gt;last_dc_val[ci] = 0;
    /* Get table index */
    if (is_DC_band) {
      if (cinfo-&gt;Ah != 0)	/* DC refinement needs no table */
	continue;
      tbl = compptr-&gt;dc_tbl_no;
    } else {
      entropy-&gt;ac_tbl_no = tbl = compptr-&gt;ac_tbl_no;
    }
    if (gather_statistics) {
      /* Check for invalid table index */
      /* (make_c_derived_tbl does this in the other path) */
      if (tbl &lt; 0 || tbl &gt;= NUM_HUFF_TBLS)
        ERREXIT1(cinfo, JERR_NO_HUFF_TABLE, tbl);
      /* Allocate and zero the statistics tables */
      /* Note that jpeg_gen_optimal_table expects 257 entries in each table! */
      if (entropy-&gt;count_ptrs[tbl] == NULL)
	entropy-&gt;count_ptrs[tbl] = (long *)
	  (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				      257 * SIZEOF(long));
      MEMZERO(entropy-&gt;count_ptrs[tbl], 257 * SIZEOF(long));
    } else {
      /* Compute derived values for Huffman table */
      /* We may do this more than once for a table, but it's not expensive */
      jpeg_make_c_derived_tbl(cinfo, is_DC_band, tbl,
			      &amp; entropy-&gt;derived_tbls[tbl]);
    }
  }

  /* Initialize AC stuff */
  entropy-&gt;EOBRUN = 0;
  entropy-&gt;BE = 0;

  /* Initialize bit buffer to empty */
  entropy-&gt;put_buffer = 0;
  entropy-&gt;put_bits = 0;

  /* Initialize restart stuff */
  entropy-&gt;restarts_to_go = cinfo-&gt;restart_interval;
  entropy-&gt;next_restart_num = 0;
}


/* Outputting bytes to the file.
 * NB: these must be called only when actually outputting,
 * that is, entropy-&gt;gather_statistics == FALSE.
 */

/* Emit a byte */
#define emit_byte(entropy,val)  \
	{ *(entropy)-&gt;next_output_byte++ = (JOCTET) (val);  \
	  if (--(entropy)-&gt;free_in_buffer == 0)  \
	    dump_buffer(entropy); }


LOCAL(void)
dump_buffer (phuff_entropy_ptr entropy)
/* Empty the output buffer; we do not support suspension in this module. */
{
  struct jpeg_destination_mgr * dest = entropy-&gt;cinfo-&gt;dest;

  if (! (*dest-&gt;empty_output_buffer) (entropy-&gt;cinfo))
    ERREXIT(entropy-&gt;cinfo, JERR_CANT_SUSPEND);
  /* After a successful buffer dump, must reset buffer pointers */
  entropy-&gt;next_output_byte = dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = dest-&gt;free_in_buffer;
}


/* Outputting bits to the file */

/* Only the right 24 bits of put_buffer are used; the valid bits are
 * left-justified in this part.  At most 16 bits can be passed to emit_bits
 * in one call, and we never retain more than 7 bits in put_buffer
 * between calls, so 24 bits are sufficient.
 */

INLINE
LOCAL(void)
emit_bits (phuff_entropy_ptr entropy, unsigned int code, int size)
/* Emit some bits, unless we are in gather mode */
{
  /* This routine is heavily used, so it's worth coding tightly. */
  register INT32 put_buffer = (INT32) code;
  register int put_bits = entropy-&gt;put_bits;

  /* if size is 0, caller used an invalid Huffman table entry */
  if (size == 0)
    ERREXIT(entropy-&gt;cinfo, JERR_HUFF_MISSING_CODE);

  if (entropy-&gt;gather_statistics)
    return;			/* do nothing if we're only getting stats */

  put_buffer &amp;= (((INT32) 1)&lt;&lt;size) - 1; /* mask off any extra bits in code */
  
  put_bits += size;		/* new number of bits in buffer */
  
  put_buffer &lt;&lt;= 24 - put_bits; /* align incoming bits */

  put_buffer |= entropy-&gt;put_buffer; /* and merge with old buffer contents */

  while (put_bits &gt;= 8) {
    int c = (int) ((put_buffer &gt;&gt; 16) &amp; 0xFF);
    
    emit_byte(entropy, c);
    if (c == 0xFF) {		/* need to stuff a zero byte? */
      emit_byte(entropy, 0);
    }
    put_buffer &lt;&lt;= 8;
    put_bits -= 8;
  }

  entropy-&gt;put_buffer = put_buffer; /* update variables */
  entropy-&gt;put_bits = put_bits;
}


LOCAL(void)
flush_bits (phuff_entropy_ptr entropy)
{
  emit_bits(entropy, 0x7F, 7); /* fill any partial byte with ones */
  entropy-&gt;put_buffer = 0;     /* and reset bit-buffer to empty */
  entropy-&gt;put_bits = 0;
}


/*
 * Emit (or just count) a Huffman symbol.
 */

INLINE
LOCAL(void)
emit_symbol (phuff_entropy_ptr entropy, int tbl_no, int symbol)
{
  if (entropy-&gt;gather_statistics)
    entropy-&gt;count_ptrs[tbl_no][symbol]++;
  else {
    c_derived_tbl * tbl = entropy-&gt;derived_tbls[tbl_no];
    emit_bits(entropy, tbl-&gt;ehufco[symbol], tbl-&gt;ehufsi[symbol]);
  }
}


/*
 * Emit bits from a correction bit buffer.
 */

LOCAL(void)
emit_buffered_bits (phuff_entropy_ptr entropy, char * bufstart,
		    unsigned int nbits)
{
  if (entropy-&gt;gather_statistics)
    return;			/* no real work */

  while (nbits &gt; 0) {
    emit_bits(entropy, (unsigned int) (*bufstart), 1);
    bufstart++;
    nbits--;
  }
}


/*
 * Emit any pending EOBRUN symbol.
 */

LOCAL(void)
emit_eobrun (phuff_entropy_ptr entropy)
{
  register int temp, nbits;

  if (entropy-&gt;EOBRUN &gt; 0) {	/* if there is any pending EOBRUN */
    temp = entropy-&gt;EOBRUN;
    nbits = 0;
    while ((temp &gt;&gt;= 1))
      nbits++;
    /* safety check: shouldn't happen given limited correction-bit buffer */
    if (nbits &gt; 14)
      ERREXIT(entropy-&gt;cinfo, JERR_HUFF_MISSING_CODE);

    emit_symbol(entropy, entropy-&gt;ac_tbl_no, nbits &lt;&lt; 4);
    if (nbits)
      emit_bits(entropy, entropy-&gt;EOBRUN, nbits);

    entropy-&gt;EOBRUN = 0;

    /* Emit any buffered correction bits */
    emit_buffered_bits(entropy, entropy-&gt;bit_buffer, entropy-&gt;BE);
    entropy-&gt;BE = 0;
  }
}


/*
 * Emit a restart marker &amp; resynchronize predictions.
 */

LOCAL(void)
emit_restart (phuff_entropy_ptr entropy, int restart_num)
{
  int ci;

  emit_eobrun(entropy);

  if (! entropy-&gt;gather_statistics) {
    flush_bits(entropy);
    emit_byte(entropy, 0xFF);
    emit_byte(entropy, JPEG_RST0 + restart_num);
  }

  if (entropy-&gt;cinfo-&gt;Ss == 0) {
    /* Re-initialize DC predictions to 0 */
    for (ci = 0; ci &lt; entropy-&gt;cinfo-&gt;comps_in_scan; ci++)
      entropy-&gt;last_dc_val[ci] = 0;
  } else {
    /* Re-initialize all AC-related fields to 0 */
    entropy-&gt;EOBRUN = 0;
    entropy-&gt;BE = 0;
  }
}


/*
 * MCU encoding for DC initial scan (either spectral selection,
 * or first pass of successive approximation).
 */

METHODDEF(boolean)
encode_mcu_DC_first (j_compress_ptr cinfo, JBLOCKROW *MCU_data)
{
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  register int temp, temp2;
  register int nbits;
  int blkn, ci;
  int Al = cinfo-&gt;Al;
  JBLOCKROW block;
  jpeg_component_info * compptr;
  ISHIFT_TEMPS

  entropy-&gt;next_output_byte = cinfo-&gt;dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = cinfo-&gt;dest-&gt;free_in_buffer;

  /* Emit restart marker if needed */
  if (cinfo-&gt;restart_interval)
    if (entropy-&gt;restarts_to_go == 0)
      emit_restart(entropy, entropy-&gt;next_restart_num);

  /* Encode the MCU data blocks */
  for (blkn = 0; blkn &lt; cinfo-&gt;blocks_in_MCU; blkn++) {
    block = MCU_data[blkn];
    ci = cinfo-&gt;MCU_membership[blkn];
    compptr = cinfo-&gt;cur_comp_info[ci];

    /* Compute the DC value after the required point transform by Al.
     * This is simply an arithmetic right shift.
     */
    temp2 = IRIGHT_SHIFT((int) ((*block)[0]), Al);

    /* DC differences are figured on the point-transformed values. */
    temp = temp2 - entropy-&gt;last_dc_val[ci];
    entropy-&gt;last_dc_val[ci] = temp2;

    /* Encode the DC coefficient difference per section G.1.2.1 */
    temp2 = temp;
    if (temp &lt; 0) {
      temp = -temp;		/* temp is abs value of input */
      /* For a negative input, want temp2 = bitwise complement of abs(input) */
      /* This code assumes we are on a two's complement machine */
      temp2--;
    }
    
    /* Find the number of bits needed for the magnitude of the coefficient */
    nbits = 0;
    while (temp) {
      nbits++;
      temp &gt;&gt;= 1;
    }
    /* Check for out-of-range coefficient values.
     * Since we're encoding a difference, the range limit is twice as much.
     */
    if (nbits &gt; MAX_COEF_BITS+1)
      ERREXIT(cinfo, JERR_BAD_DCT_COEF);
    
    /* Count/emit the Huffman-coded symbol for the number of bits */
    emit_symbol(entropy, compptr-&gt;dc_tbl_no, nbits);
    
    /* Emit that number of bits of the value, if positive, */
    /* or the complement of its magnitude, if negative. */
    if (nbits)			/* emit_bits rejects calls with size 0 */
      emit_bits(entropy, (unsigned int) temp2, nbits);
  }

  cinfo-&gt;dest-&gt;next_output_byte = entropy-&gt;next_output_byte;
  cinfo-&gt;dest-&gt;free_in_buffer = entropy-&gt;free_in_buffer;

  /* Update restart-interval state too */
  if (cinfo-&gt;restart_interval) {
    if (entropy-&gt;restarts_to_go == 0) {
      entropy-&gt;restarts_to_go = cinfo-&gt;restart_interval;
      entropy-&gt;next_restart_num++;
      entropy-&gt;next_restart_num &amp;= 7;
    }
    entropy-&gt;restarts_to_go--;
  }

  return TRUE;
}


/*
 * MCU encoding for AC initial scan (either spectral selection,
 * or first pass of successive approximation).
 */

METHODDEF(boolean)
encode_mcu_AC_first (j_compress_ptr cinfo, JBLOCKROW *MCU_data)
{
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  register int temp, temp2;
  register int nbits;
  register int r, k;
  int Se = cinfo-&gt;Se;
  int Al = cinfo-&gt;Al;
  JBLOCKROW block;

  entropy-&gt;next_output_byte = cinfo-&gt;dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = cinfo-&gt;dest-&gt;free_in_buffer;

  /* Emit restart marker if needed */
  if (cinfo-&gt;restart_interval)
    if (entropy-&gt;restarts_to_go == 0)
      emit_restart(entropy, entropy-&gt;next_restart_num);

  /* Encode the MCU data block */
  block = MCU_data[0];

  /* Encode the AC coefficients per section G.1.2.2, fig. G.3 */
  
  r = 0;			/* r = run length of zeros */
   
  for (k = cinfo-&gt;Ss; k &lt;= Se; k++) {
    if ((temp = (*block)[jpeg_natural_order[k]]) == 0) {
      r++;
      continue;
    }
    /* We must apply the point transform by Al.  For AC coefficients this
     * is an integer division with rounding towards 0.  To do this portably
     * in C, we shift after obtaining the absolute value; so the code is
     * interwoven with finding the abs value (temp) and output bits (temp2).
     */
    if (temp &lt; 0) {
      temp = -temp;		/* temp is abs value of input */
      temp &gt;&gt;= Al;		/* apply the point transform */
      /* For a negative coef, want temp2 = bitwise complement of abs(coef) */
      temp2 = ~temp;
    } else {
      temp &gt;&gt;= Al;		/* apply the point transform */
      temp2 = temp;
    }
    /* Watch out for case that nonzero coef is zero after point transform */
    if (temp == 0) {
      r++;
      continue;
    }

    /* Emit any pending EOBRUN */
    if (entropy-&gt;EOBRUN &gt; 0)
      emit_eobrun(entropy);
    /* if run length &gt; 15, must emit special run-length-16 codes (0xF0) */
    while (r &gt; 15) {
      emit_symbol(entropy, entropy-&gt;ac_tbl_no, 0xF0);
      r -= 16;
    }

    /* Find the number of bits needed for the magnitude of the coefficient */
    nbits = 1;			/* there must be at least one 1 bit */
    while ((temp &gt;&gt;= 1))
      nbits++;
    /* Check for out-of-range coefficient values */
    if (nbits &gt; MAX_COEF_BITS)
      ERREXIT(cinfo, JERR_BAD_DCT_COEF);

    /* Count/emit Huffman symbol for run length / number of bits */
    emit_symbol(entropy, entropy-&gt;ac_tbl_no, (r &lt;&lt; 4) + nbits);

    /* Emit that number of bits of the value, if positive, */
    /* or the complement of its magnitude, if negative. */
    emit_bits(entropy, (unsigned int) temp2, nbits);

    r = 0;			/* reset zero run length */
  }

  if (r &gt; 0) {			/* If there are trailing zeroes, */
    entropy-&gt;EOBRUN++;		/* count an EOB */
    if (entropy-&gt;EOBRUN == 0x7FFF)
      emit_eobrun(entropy);	/* force it out to avoid overflow */
  }

  cinfo-&gt;dest-&gt;next_output_byte = entropy-&gt;next_output_byte;
  cinfo-&gt;dest-&gt;free_in_buffer = entropy-&gt;free_in_buffer;

  /* Update restart-interval state too */
  if (cinfo-&gt;restart_interval) {
    if (entropy-&gt;restarts_to_go == 0) {
      entropy-&gt;restarts_to_go = cinfo-&gt;restart_interval;
      entropy-&gt;next_restart_num++;
      entropy-&gt;next_restart_num &amp;= 7;
    }
    entropy-&gt;restarts_to_go--;
  }

  return TRUE;
}


/*
 * MCU encoding for DC successive approximation refinement scan.
 * Note: we assume such scans can be multi-component, although the spec
 * is not very clear on the point.
 */

METHODDEF(boolean)
encode_mcu_DC_refine (j_compress_ptr cinfo, JBLOCKROW *MCU_data)
{
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  register int temp;
  int blkn;
  int Al = cinfo-&gt;Al;
  JBLOCKROW block;

  entropy-&gt;next_output_byte = cinfo-&gt;dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = cinfo-&gt;dest-&gt;free_in_buffer;

  /* Emit restart marker if needed */
  if (cinfo-&gt;restart_interval)
    if (entropy-&gt;restarts_to_go == 0)
      emit_restart(entropy, entropy-&gt;next_restart_num);

  /* Encode the MCU data blocks */
  for (blkn = 0; blkn &lt; cinfo-&gt;blocks_in_MCU; blkn++) {
    block = MCU_data[blkn];

    /* We simply emit the Al'th bit of the DC coefficient value. */
    temp = (*block)[0];
    emit_bits(entropy, (unsigned int) (temp &gt;&gt; Al), 1);
  }

  cinfo-&gt;dest-&gt;next_output_byte = entropy-&gt;next_output_byte;
  cinfo-&gt;dest-&gt;free_in_buffer = entropy-&gt;free_in_buffer;

  /* Update restart-interval state too */
  if (cinfo-&gt;restart_interval) {
    if (entropy-&gt;restarts_to_go == 0) {
      entropy-&gt;restarts_to_go = cinfo-&gt;restart_interval;
      entropy-&gt;next_restart_num++;
      entropy-&gt;next_restart_num &amp;= 7;
    }
    entropy-&gt;restarts_to_go--;
  }

  return TRUE;
}


/*
 * MCU encoding for AC successive approximation refinement scan.
 */

METHODDEF(boolean)
encode_mcu_AC_refine (j_compress_ptr cinfo, JBLOCKROW *MCU_data)
{
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  register int temp;
  register int r, k;
  int EOB;
  char *BR_buffer;
  unsigned int BR;
  int Se = cinfo-&gt;Se;
  int Al = cinfo-&gt;Al;
  JBLOCKROW block;
  int absvalues[DCTSIZE2];

  entropy-&gt;next_output_byte = cinfo-&gt;dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = cinfo-&gt;dest-&gt;free_in_buffer;

  /* Emit restart marker if needed */
  if (cinfo-&gt;restart_interval)
    if (entropy-&gt;restarts_to_go == 0)
      emit_restart(entropy, entropy-&gt;next_restart_num);

  /* Encode the MCU data block */
  block = MCU_data[0];

  /* It is convenient to make a pre-pass to determine the transformed
   * coefficients' absolute values and the EOB position.
   */
  EOB = 0;
  for (k = cinfo-&gt;Ss; k &lt;= Se; k++) {
    temp = (*block)[jpeg_natural_order[k]];
    /* We must apply the point transform by Al.  For AC coefficients this
     * is an integer division with rounding towards 0.  To do this portably
     * in C, we shift after obtaining the absolute value.
     */
    if (temp &lt; 0)
      temp = -temp;		/* temp is abs value of input */
    temp &gt;&gt;= Al;		/* apply the point transform */
    absvalues[k] = temp;	/* save abs value for main pass */
    if (temp == 1)
      EOB = k;			/* EOB = index of last newly-nonzero coef */
  }

  /* Encode the AC coefficients per section G.1.2.3, fig. G.7 */
  
  r = 0;			/* r = run length of zeros */
  BR = 0;			/* BR = count of buffered bits added now */
  BR_buffer = entropy-&gt;bit_buffer + entropy-&gt;BE; /* Append bits to buffer */

  for (k = cinfo-&gt;Ss; k &lt;= Se; k++) {
    if ((temp = absvalues[k]) == 0) {
      r++;
      continue;
    }

    /* Emit any required ZRLs, but not if they can be folded into EOB */
    while (r &gt; 15 &amp;&amp; k &lt;= EOB) {
      /* emit any pending EOBRUN and the BE correction bits */
      emit_eobrun(entropy);
      /* Emit ZRL */
      emit_symbol(entropy, entropy-&gt;ac_tbl_no, 0xF0);
      r -= 16;
      /* Emit buffered correction bits that must be associated with ZRL */
      emit_buffered_bits(entropy, BR_buffer, BR);
      BR_buffer = entropy-&gt;bit_buffer; /* BE bits are gone now */
      BR = 0;
    }

    /* If the coef was previously nonzero, it only needs a correction bit.
     * NOTE: a straight translation of the spec's figure G.7 would suggest
     * that we also need to test r &gt; 15.  But if r &gt; 15, we can only get here
     * if k &gt; EOB, which implies that this coefficient is not 1.
     */
    if (temp &gt; 1) {
      /* The correction bit is the next bit of the absolute value. */
      BR_buffer[BR++] = (char) (temp &amp; 1);
      continue;
    }

    /* Emit any pending EOBRUN and the BE correction bits */
    emit_eobrun(entropy);

    /* Count/emit Huffman symbol for run length / number of bits */
    emit_symbol(entropy, entropy-&gt;ac_tbl_no, (r &lt;&lt; 4) + 1);

    /* Emit output bit for newly-nonzero coef */
    temp = ((*block)[jpeg_natural_order[k]] &lt; 0) ? 0 : 1;
    emit_bits(entropy, (unsigned int) temp, 1);

    /* Emit buffered correction bits that must be associated with this code */
    emit_buffered_bits(entropy, BR_buffer, BR);
    BR_buffer = entropy-&gt;bit_buffer; /* BE bits are gone now */
    BR = 0;
    r = 0;			/* reset zero run length */
  }

  if (r &gt; 0 || BR &gt; 0) {	/* If there are trailing zeroes, */
    entropy-&gt;EOBRUN++;		/* count an EOB */
    entropy-&gt;BE += BR;		/* concat my correction bits to older ones */
    /* We force out the EOB if we risk either:
     * 1. overflow of the EOB counter;
     * 2. overflow of the correction bit buffer during the next MCU.
     */
    if (entropy-&gt;EOBRUN == 0x7FFF || entropy-&gt;BE &gt; (MAX_CORR_BITS-DCTSIZE2+1))
      emit_eobrun(entropy);
  }

  cinfo-&gt;dest-&gt;next_output_byte = entropy-&gt;next_output_byte;
  cinfo-&gt;dest-&gt;free_in_buffer = entropy-&gt;free_in_buffer;

  /* Update restart-interval state too */
  if (cinfo-&gt;restart_interval) {
    if (entropy-&gt;restarts_to_go == 0) {
      entropy-&gt;restarts_to_go = cinfo-&gt;restart_interval;
      entropy-&gt;next_restart_num++;
      entropy-&gt;next_restart_num &amp;= 7;
    }
    entropy-&gt;restarts_to_go--;
  }

  return TRUE;
}


/*
 * Finish up at the end of a Huffman-compressed progressive scan.
 */

METHODDEF(void)
finish_pass_phuff (j_compress_ptr cinfo)
{   
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;

  entropy-&gt;next_output_byte = cinfo-&gt;dest-&gt;next_output_byte;
  entropy-&gt;free_in_buffer = cinfo-&gt;dest-&gt;free_in_buffer;

  /* Flush out any buffered data */
  emit_eobrun(entropy);
  flush_bits(entropy);

  cinfo-&gt;dest-&gt;next_output_byte = entropy-&gt;next_output_byte;
  cinfo-&gt;dest-&gt;free_in_buffer = entropy-&gt;free_in_buffer;
}


/*
 * Finish up a statistics-gathering pass and create the new Huffman tables.
 */

METHODDEF(void)
finish_pass_gather_phuff (j_compress_ptr cinfo)
{
  phuff_entropy_ptr entropy = (phuff_entropy_ptr) cinfo-&gt;entropy;
  boolean is_DC_band;
  int ci, tbl;
  jpeg_component_info * compptr;
  JHUFF_TBL **htblptr;
  boolean did[NUM_HUFF_TBLS];

  /* Flush out buffered data (all we care about is counting the EOB symbol) */
  emit_eobrun(entropy);

  is_DC_band = (cinfo-&gt;Ss == 0);

  /* It's important not to apply jpeg_gen_optimal_table more than once
   * per table, because it clobbers the input frequency counts!
   */
  MEMZERO(did, SIZEOF(did));

  for (ci = 0; ci &lt; cinfo-&gt;comps_in_scan; ci++) {
    compptr = cinfo-&gt;cur_comp_info[ci];
    if (is_DC_band) {
      if (cinfo-&gt;Ah != 0)	/* DC refinement needs no table */
	continue;
      tbl = compptr-&gt;dc_tbl_no;
    } else {
      tbl = compptr-&gt;ac_tbl_no;
    }
    if (! did[tbl]) {
      if (is_DC_band)
        htblptr = &amp; cinfo-&gt;dc_huff_tbl_ptrs[tbl];
      else
        htblptr = &amp; cinfo-&gt;ac_huff_tbl_ptrs[tbl];
      if (*htblptr == NULL)
        *htblptr = jpeg_alloc_huff_table((j_common_ptr) cinfo);
      jpeg_gen_optimal_table(cinfo, *htblptr, entropy-&gt;count_ptrs[tbl]);
      did[tbl] = TRUE;
    }
  }
}


/*
 * Module initialization routine for progressive Huffman entropy encoding.
 */

GLOBAL(void)
jinit_phuff_encoder (j_compress_ptr cinfo)
{
  phuff_entropy_ptr entropy;
  int i;

  entropy = (phuff_entropy_ptr)
    (*cinfo-&gt;mem-&gt;alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
				SIZEOF(phuff_entropy_encoder));
  cinfo-&gt;entropy = (struct jpeg_entropy_encoder *) entropy;
  entropy-&gt;pub.start_pass = start_pass_phuff;

  /* Mark tables unallocated */
  for (i = 0; i &lt; NUM_HUFF_TBLS; i++) {
    entropy-&gt;derived_tbls[i] = NULL;
    entropy-&gt;count_ptrs[i] = NULL;
  }
  entropy-&gt;bit_buffer = NULL;	/* needed only in AC refinement scan */
}

#endif /* C_PROGRESSIVE_SUPPORTED */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

