<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/dscparse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/dscparse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2000-2003, Ghostgum Software Pty Ltd.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: dscparse.c,v 1.14 2003/09/13 02:04:15 ghostgum Exp $ */

/*
 * This is a DSC parser, based on the DSC 3.0 spec, 
 * with a few DSC 2.1 additions for page size.
 *
 * Current limitations:
 * %%+ may be used after any comment in the comment or trailer, 
 * but is currently only supported by
 *   %%DocumentMedia
 *
 * DSC 2.1 additions (discontinued in DSC 3.0):
 * %%DocumentPaperColors: 
 * %%DocumentPaperForms: 
 * %%DocumentPaperSizes: 
 * %%DocumentPaperWeights: 
 * %%PaperColor:   (ignored)
 * %%PaperForm:    (ignored)
 * %%PaperSize: 
 * %%PaperWeight:  (ignored)
 *
 * Other additions for defaults or page section
 % %%ViewingOrientation: xx xy yx yy
*/

#include &lt;stdio.h&gt;	/* for sprintf(), not file I/O */
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;ctype.h&gt;

#define MAXSTR 256

#include "dscparse.h"

/* Macros for comparing string literals
 * For maximum speed, the length of the second macro argument is
 * computed at compile time.
 * THE SECOND MACRO ARGUMENT MUST BE A STRING LITERAL.
 */
#define COMPARE(p,str) (strncmp((const char *)(p), (str), sizeof(str)-1)==0)
#define IS_DSC(line, str) (COMPARE((line), (str)))

/* Macros for comparing the first one or two characters */
#define IS_WHITE(ch) (((ch)==' ') || ((ch)=='\t'))
#define IS_EOL(ch) (((ch)=='\r') || ((ch)=='\n'))
#define IS_WHITE_OR_EOL(ch) (IS_WHITE(ch) || IS_EOL(ch))
#define IS_BLANK(str) (IS_EOL(str[0]))
#define NOT_DSC_LINE(str) (((str)[0]!='%') || ((str)[1]!='%'))

/* Macros for document offset to start and end of line */
#define DSC_START(dsc)  ((dsc)-&gt;data_offset + (dsc)-&gt;data_index - (dsc)-&gt;line_length)
#define DSC_END(dsc)  ((dsc)-&gt;data_offset + (dsc)-&gt;data_index)

/* dsc_scan_SECTION() functions return one of 
 * CDSC_ERROR, CDSC_OK, CDSC_NOTDSC 
 * or one of the following
 */
/* The line should be passed on to the next section parser. */
#define CDSC_PROPAGATE	10

/* If document is DOS EPS and we haven't read 30 bytes, ask for more. */
#define CDSC_NEEDMORE 11

/* local prototypes */
dsc_private void * dsc_memalloc(CDSC *dsc, size_t size);
dsc_private void dsc_memfree(CDSC*dsc, void *ptr);
dsc_private CDSC * dsc_init2(CDSC *dsc);
dsc_private void dsc_reset(CDSC *dsc);
dsc_private void dsc_section_join(DSC_OFFSET begin, DSC_OFFSET *pend, DSC_OFFSET **pplast);
dsc_private int dsc_read_line(CDSC *dsc);
dsc_private int dsc_read_doseps(CDSC *dsc);
dsc_private int dsc_read_macbin(CDSC *dsc);
dsc_private int dsc_read_applesingle(CDSC *dsc);
dsc_private char * dsc_alloc_string(CDSC *dsc, const char *str, int len);
dsc_private char * dsc_add_line(CDSC *dsc, const char *line, unsigned int len);
dsc_private char * dsc_copy_string(char *str, unsigned int slen, 
    char *line, unsigned int len, unsigned int *offset);
dsc_private GSDWORD dsc_get_dword(const unsigned char *buf);
dsc_private GSWORD dsc_get_word(const unsigned char *buf);
dsc_private GSDWORD dsc_get_bigendian_dword(const unsigned char *buf);
dsc_private GSWORD dsc_get_bigendian_word(const unsigned char *buf);
dsc_private int dsc_get_int(const char *line, unsigned int len, unsigned int *offset);
dsc_private float dsc_get_real(const char *line, unsigned int len, 
    unsigned int *offset);
dsc_private void dsc_unknown(CDSC *dsc); 
dsc_private GSBOOL dsc_is_section(char *line);
dsc_private int dsc_parse_pages(CDSC *dsc);
dsc_private int dsc_parse_bounding_box(CDSC *dsc, CDSCBBOX** pbbox, int offset);
dsc_private int dsc_parse_float_bounding_box(CDSC *dsc, CDSCFBBOX** pfbbox, int offset);
dsc_private int dsc_parse_orientation(CDSC *dsc, unsigned int *porientation, 
    int offset);
dsc_private int dsc_parse_order(CDSC *dsc);
dsc_private int dsc_parse_media(CDSC *dsc, const CDSCMEDIA **page_media);
dsc_private int dsc_parse_document_media(CDSC *dsc);
dsc_private int dsc_parse_viewing_orientation(CDSC *dsc, CDSCCTM **pctm);
dsc_private int dsc_parse_page(CDSC *dsc);
dsc_private void dsc_save_line(CDSC *dsc);
dsc_private int dsc_scan_type(CDSC *dsc);
dsc_private int dsc_scan_comments(CDSC *dsc);
dsc_private int dsc_scan_preview(CDSC *dsc);
dsc_private int dsc_scan_defaults(CDSC *dsc);
dsc_private int dsc_scan_prolog(CDSC *dsc);
dsc_private int dsc_scan_setup(CDSC *dsc);
dsc_private int dsc_scan_page(CDSC *dsc);
dsc_private int dsc_scan_trailer(CDSC *dsc);
dsc_private int dsc_error(CDSC *dsc, unsigned int explanation, 
    char *line, unsigned int line_len);
dsc_private int dsc_dcs2_fixup(CDSC *dsc);
dsc_private int dsc_parse_platefile(CDSC *dsc);
dsc_private int dsc_parse_dcs1plate(CDSC *dsc);
dsc_private CDSCCOLOUR * dsc_find_colour(CDSC *dsc, const char *colourname);
dsc_private int dsc_parse_process_colours(CDSC *dsc);
dsc_private int dsc_parse_custom_colours(CDSC *dsc);
dsc_private int dsc_parse_cmyk_custom_colour(CDSC *dsc);
dsc_private int dsc_parse_rgb_custom_colour(CDSC *dsc);

/* DSC error reporting */
dsc_private const int dsc_severity[] = {
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_BBOX */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_EARLY_TRAILER */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_EARLY_EOF */
    CDSC_ERROR_ERROR, 	/* CDSC_MESSAGE_PAGE_IN_TRAILER */
    CDSC_ERROR_ERROR, 	/* CDSC_MESSAGE_PAGE_ORDINAL */
    CDSC_ERROR_ERROR, 	/* CDSC_MESSAGE_PAGES_WRONG */
    CDSC_ERROR_ERROR, 	/* CDSC_MESSAGE_EPS_NO_BBOX */
    CDSC_ERROR_ERROR, 	/* CDSC_MESSAGE_EPS_PAGES */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_NO_MEDIA */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_ATEND */
    CDSC_ERROR_INFORM, 	/* CDSC_MESSAGE_DUP_COMMENT */
    CDSC_ERROR_INFORM, 	/* CDSC_MESSAGE_DUP_TRAILER */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_BEGIN_END */
    CDSC_ERROR_INFORM, 	/* CDSC_MESSAGE_BAD_SECTION */
    CDSC_ERROR_INFORM,  /* CDSC_MESSAGE_LONG_LINE */
    CDSC_ERROR_WARN, 	/* CDSC_MESSAGE_INCORRECT_USAGE */
    0
};

#define DSC_MAX_ERROR ((sizeof(dsc_severity) / sizeof(int))-2)

const CDSCMEDIA dsc_known_media[CDSC_KNOWN_MEDIA] = {
    /* These sizes taken from Ghostscript gs_statd.ps */
    {"11x17", 792, 1224, 0, NULL, NULL},
    {"A3", 842, 1190, 0, NULL, NULL},
    {"A4", 595, 842, 0, NULL, NULL},
    {"A5", 421, 595, 0, NULL, NULL},
    {"B4", 709, 1002, 0, NULL, NULL}, /* ISO, but not Adobe standard */
    {"B5", 501, 709, 0, NULL, NULL},  /* ISO, but not Adobe standard */
    {"Ledger", 1224, 792, 0, NULL, NULL},
    {"Legal", 612, 1008, 0, NULL, NULL},
    {"Letter", 612, 792, 0, NULL, NULL},
    {"Note", 612, 792, 0, NULL, NULL},
    {NULL, 0, 0, 0, NULL, NULL}
};

/* parser state */
enum CDSC_SCAN_SECTION {
    scan_none = 0,
    scan_comments = 1,
    scan_pre_preview = 2,
    scan_preview = 3,
    scan_pre_defaults = 4,
    scan_defaults = 5,
    scan_pre_prolog = 6,
    scan_prolog = 7,
    scan_pre_setup = 8,
    scan_setup = 9,
    scan_pre_pages = 10,
    scan_pages = 11,
    scan_pre_trailer = 12,
    scan_trailer = 13,
    scan_eof = 14
};

static const char * const dsc_scan_section_name[15] = {
 "Type", "Comments", 
 "pre-Preview", "Preview",
 "pre-Defaults", "Defaults",
 "pre-Prolog", "Prolog",
 "pre-Setup", "Setup",
 "pre-Page", "Page",
 "pre-Trailer", "Trailer",
 "EOF"
};


/******************************************************************/
/* Public functions                                               */
/******************************************************************/

/* constructor */
CDSC *
dsc_init(void *caller_data)
{
    CDSC *dsc = (CDSC *)malloc(sizeof(CDSC));
    if (dsc == NULL)
	return NULL;
    memset(dsc, 0, sizeof(CDSC));
    dsc-&gt;caller_data = caller_data;
    dsc-&gt;ref_count = 0;
    dsc_ref(dsc);

    return dsc_init2(dsc);
}

/* constructor, with caller supplied memalloc */
CDSC *
dsc_init_with_alloc(
    void *caller_data,
    void *(*memalloc)(size_t size, void *closure_data),
    void (*memfree)(void *ptr, void *closure_data),
    void *closure_data)
{
    CDSC *dsc = (CDSC *)memalloc(sizeof(CDSC), closure_data);
    if (dsc == NULL)
	return NULL;
    memset(dsc, 0, sizeof(CDSC));
    dsc-&gt;caller_data = caller_data;

    dsc-&gt;memalloc = memalloc;
    dsc-&gt;memfree = memfree;
    dsc-&gt;mem_closure_data = closure_data;
    dsc-&gt;ref_count = 0;
    dsc_ref(dsc);
    
    return dsc_init2(dsc);
}



/* destructor */
void 
dsc_free(CDSC *dsc)
{
    if (dsc == NULL)
	return;
    dsc_reset(dsc);
    dsc_memfree(dsc, dsc);
}


CDSC *
dsc_new(void *caller_data)
{
    return dsc_init(caller_data);
}

int
dsc_ref(CDSC *dsc)
{
    return ++(dsc-&gt;ref_count);
}

int 
dsc_unref(CDSC *dsc)
{
    if (dsc-&gt;ref_count &lt;= 0)
	return -1;
    dsc-&gt;ref_count--;
    if (dsc-&gt;ref_count == 0) {
	dsc_free(dsc);
	return 0;
    }
    return dsc-&gt;ref_count;
}


/* Tell DSC parser how long document will be, to allow ignoring
 * of early %%Trailer and %%EOF.  This is optional.
 */
void 
dsc_set_length(CDSC *dsc, DSC_OFFSET len)
{
    dsc-&gt;file_length = len;
}

/* Process a buffer containing DSC comments and PostScript */
/* Return value is &lt; 0 for error, &gt;=0 for OK.
 *  CDSC_ERROR
 *  CDSC_OK
 *  CDSC_NOTDSC (DSC will be ignored)
 *  other values indicate the last DSC comment read
 */ 
int
dsc_scan_data(CDSC *dsc, const char *data, int length)
{
    int bytes_read;
    int code = 0;

    if (dsc == NULL)
	return CDSC_ERROR;

    if (dsc-&gt;id == CDSC_NOTDSC)
	return CDSC_NOTDSC;
    dsc-&gt;id = CDSC_OK;
    if (dsc-&gt;eof)
	return CDSC_OK;	/* ignore */

    if (length == 0) {
	/* EOF, so process what remains */
	dsc-&gt;eof = TRUE;
    }

    do {
	if (dsc-&gt;id == CDSC_NOTDSC)
	    break;

	if (length != 0) {
	    /* move existing data if needed */
	    if (dsc-&gt;data_length &gt; CDSC_DATA_LENGTH/2) {
		memmove(dsc-&gt;data, dsc-&gt;data + dsc-&gt;data_index,
		    dsc-&gt;data_length - dsc-&gt;data_index);
		dsc-&gt;data_offset += dsc-&gt;data_index;
		dsc-&gt;data_length -= dsc-&gt;data_index;
		dsc-&gt;data_index = 0;
	    }
	    /* append to buffer */
	    bytes_read = min(length, (int)(CDSC_DATA_LENGTH - dsc-&gt;data_length));
	    memcpy(dsc-&gt;data + dsc-&gt;data_length, data, bytes_read);
	    dsc-&gt;data_length += bytes_read;
	    data += bytes_read;
	    length -= bytes_read;
	}
	if (dsc-&gt;scan_section == scan_none) {
	    code = dsc_scan_type(dsc);
	    if (code == CDSC_NEEDMORE) {
		/* need more characters before we can identify type */
		code = CDSC_OK;
		break;
	    }
	    dsc-&gt;id = code;
	}

        if (code == CDSC_NOTDSC) {
	    dsc-&gt;id = CDSC_NOTDSC;
	    break;
	}

	while ((code = dsc_read_line(dsc)) &gt; 0) {
	    if (dsc-&gt;id == CDSC_NOTDSC)
		break;
	    if (dsc-&gt;file_length &amp;&amp; 
		(dsc-&gt;data_offset + dsc-&gt;data_index &gt; dsc-&gt;file_length)) {
		/* have read past end of where we need to parse. */
		return CDSC_OK;	/* ignore */
	    }
	    if (dsc-&gt;doseps_end &amp;&amp; 
		(dsc-&gt;data_offset + dsc-&gt;data_index &gt; dsc-&gt;doseps_end)) {
		/* have read past end of DOS EPS or Mac Binary 
		 * PostScript section
		 */
		return CDSC_OK;	/* ignore */
	    }
	    if (dsc-&gt;eof)
		return CDSC_OK;
	    if (dsc-&gt;skip_document)
		continue;	/* embedded document */
	    if (dsc-&gt;skip_lines)
		continue;	/* embedded lines */
	    if (IS_DSC(dsc-&gt;line, "%%BeginData:"))
		continue;
	    if (IS_DSC(dsc-&gt;line, "%%BeginBinary:"))
		continue;
	    if (IS_DSC(dsc-&gt;line, "%%EndDocument"))
		continue;
	    if (IS_DSC(dsc-&gt;line, "%%EndData"))
		continue;
	    if (IS_DSC(dsc-&gt;line, "%%EndBinary"))
		continue;

	    do {
		switch (dsc-&gt;scan_section) {
		    case scan_comments:
			code = dsc_scan_comments(dsc);
			break;
		    case scan_pre_preview:
		    case scan_preview:
			code = dsc_scan_preview(dsc);
			break;
		    case scan_pre_defaults:
		    case scan_defaults:
			code = dsc_scan_defaults(dsc);
			break;
		    case scan_pre_prolog:
		    case scan_prolog:
			code = dsc_scan_prolog(dsc);
			break;
		    case scan_pre_setup:
		    case scan_setup:
			code = dsc_scan_setup(dsc);
			break;
		    case scan_pre_pages:
		    case scan_pages:
			code = dsc_scan_page(dsc);
			break;
		    case scan_pre_trailer:
		    case scan_trailer:
			code = dsc_scan_trailer(dsc);
			break;
		    case scan_eof:
			code = CDSC_OK;
			break;
		    default:
			/* invalid state */
			code = CDSC_ERROR;
		}
		/* repeat if line is start of next section */
	    } while (code == CDSC_PROPAGATE);

	    /* if DOS EPS header not complete, ask for more */
	    if (code == CDSC_NEEDMORE) {
		code = CDSC_OK;
		break;
	    }
	    if (code == CDSC_NOTDSC) {
		dsc-&gt;id = CDSC_NOTDSC;
		break;
	    }
	}
    } while (length != 0);

    return (code &lt; 0) ? code : dsc-&gt;id;
}

/* Tidy up from incorrect DSC comments */
int 
dsc_fixup(CDSC *dsc)
{
    unsigned int i;
    char buf[32];
    DSC_OFFSET *last;

    if (dsc-&gt;id == CDSC_NOTDSC)
	return 0;

    /* flush last partial line */
    dsc_scan_data(dsc, NULL, 0);


    /* Fix DSC error: EOF before end of %%BeginData */
    if (dsc-&gt;eof &amp;&amp; 
	(dsc-&gt;skip_lines || dsc-&gt;skip_bytes || dsc-&gt;skip_document)) {
	switch (dsc-&gt;scan_section) {
	    case scan_comments:
		dsc-&gt;endcomments = DSC_END(dsc);
		break;
	    case scan_preview:
		dsc-&gt;endpreview = DSC_END(dsc);
		break;
	    case scan_defaults:
		dsc-&gt;enddefaults = DSC_END(dsc);
		break;
	    case scan_prolog:
		dsc-&gt;endprolog = DSC_END(dsc);
		break;
	    case scan_setup:
		dsc-&gt;endsetup = DSC_END(dsc);
		break;
	    case scan_pages:
		if (dsc-&gt;page_count)
		    dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_END(dsc);
		break;
	    case scan_trailer:
	    case scan_eof:
		dsc-&gt;endtrailer = DSC_END(dsc);
		break;
	}
    }
    
    /* Fix DSC error: code between %%EndSetup and %%Page */
    if (dsc-&gt;page_count &amp;&amp; (dsc-&gt;page[0].begin != dsc-&gt;endsetup)
		&amp;&amp; (dsc-&gt;endsetup != dsc-&gt;beginsetup)) {
	dsc-&gt;endsetup = dsc-&gt;page[0].begin;
	dsc_debug_print(dsc, "Warning: code included between setup and first page\n");
    }

    /* Last page contained a false trailer, */
    /* so extend last page to start of trailer */
    if (dsc-&gt;page_count &amp;&amp; (dsc-&gt;begintrailer != 0) &amp;&amp;
	(dsc-&gt;page[dsc-&gt;page_count-1].end != dsc-&gt;begintrailer)) {
	dsc_debug_print(dsc, "Ignoring earlier misplaced trailer\n");
	dsc_debug_print(dsc, "and extending last page to start of trailer\n"); 
	dsc-&gt;page[dsc-&gt;page_count-1].end = dsc-&gt;begintrailer;
    }

    /* 
     * Join up all sections.
     * There might be extra code between them, or we might have
     * missed including the \n which followed \r.
     */
    last = &amp;dsc-&gt;endcomments;
    dsc_section_join(dsc-&gt;beginpreview, &amp;dsc-&gt;endpreview, &amp;last);
    dsc_section_join(dsc-&gt;begindefaults, &amp;dsc-&gt;enddefaults, &amp;last);
    dsc_section_join(dsc-&gt;beginprolog, &amp;dsc-&gt;endprolog, &amp;last);
    dsc_section_join(dsc-&gt;beginsetup, &amp;dsc-&gt;endsetup, &amp;last);
    for (i=0; i&lt;dsc-&gt;page_count; i++)
	dsc_section_join(dsc-&gt;page[i].begin, &amp;dsc-&gt;page[i].end, &amp;last);
    if (dsc-&gt;begintrailer)
	*last = dsc-&gt;begintrailer;
	
    if ((dsc-&gt;page_pages == 0) &amp;&amp; (dsc-&gt;page_count == 1)) {
	/* don't flag an error if %%Pages absent but one %%Page found */
	/* adjust incorrect page count */
	dsc-&gt;page_pages = dsc-&gt;page_count;
    }

    /* Warnings and Errors that we can now identify */
    if ((dsc-&gt;page_count != dsc-&gt;page_pages)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_PAGES_WRONG, NULL, 0);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* adjust incorrect page count */
		dsc-&gt;page_pages = dsc-&gt;page_count;
		break;
	    case CDSC_RESPONSE_CANCEL:
		break;;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    if (dsc-&gt;epsf &amp;&amp; (dsc-&gt;bbox == (CDSCBBOX *)NULL)) {
	/* EPS files MUST include a BoundingBox */
	int rc = dsc_error(dsc, CDSC_MESSAGE_EPS_NO_BBOX, NULL, 0);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* Assume that it is EPS */
		break;
	    case CDSC_RESPONSE_CANCEL:
		/* Is NOT an EPS file */
		dsc-&gt;epsf = FALSE;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    if (dsc-&gt;epsf &amp;&amp; ((dsc-&gt;page_count &gt; 1) || (dsc-&gt;page_pages &gt; 1))) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_EPS_PAGES, NULL, 0);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* Is an EPS file */
		break;
	    case CDSC_RESPONSE_CANCEL:
		/* Is NOT an EPS file */
		dsc-&gt;epsf = FALSE;
		break;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    /* convert single file DSC 2.0 into multiple pages */
    dsc_dcs2_fixup(dsc);

    if ((dsc-&gt;media_count == 1) &amp;&amp; (dsc-&gt;page_media == NULL)) {
	/* if one only media was specified, and default page media */
	/* was not specified, assume that default is the only media. */
	dsc-&gt;page_media = dsc-&gt;media[0];
    }

    if ((dsc-&gt;media_count != 0) &amp;&amp; (dsc-&gt;page_media == NULL)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_NO_MEDIA, NULL, 0);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* default media is first listed */
		dsc-&gt;page_media = dsc-&gt;media[0];
		break;
	    case CDSC_RESPONSE_CANCEL:
		/* No default media */
		break;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    /* make sure all pages have a label */
    for (i=0; i&lt;dsc-&gt;page_count; i++) {
	if (strlen(dsc-&gt;page[i].label) == 0) {
	    sprintf(buf, "%d", i+1);
	    if ((dsc-&gt;page[i].label = dsc_alloc_string(dsc, buf, (int)strlen(buf))) 
		== (char *)NULL)
		return CDSC_ERROR;	/* no memory */
	}
    }
    return CDSC_OK;
}

/* Install a function to be used for displaying messages about 
 * DSC errors and warnings, and to request advice from user.
 * Installing an error function is optional.
 */
void 
dsc_set_error_function(CDSC *dsc, 
	int (*fn)(void *caller_data, CDSC *dsc, 
	unsigned int explanation, const char *line, unsigned int line_len))
{
    dsc-&gt;dsc_error_fn = fn;
}


/* Install a function for printing debug messages */
/* This is optional */
void 
dsc_set_debug_function(CDSC *dsc, 
	void (*debug_fn)(void *caller_data, const char *str))
{
    dsc-&gt;debug_print_fn = debug_fn;
}

/* Doesn't need to be public for PostScript documents */
/* Made public so GSview can add pages when processing PDF files */
int 
dsc_add_page(CDSC *dsc, int ordinal, char *label)
{
    dsc-&gt;page[dsc-&gt;page_count].ordinal = ordinal;
    dsc-&gt;page[dsc-&gt;page_count].label = 
	dsc_alloc_string(dsc, label, (int)strlen(label)+1);
    dsc-&gt;page[dsc-&gt;page_count].begin = 0;
    dsc-&gt;page[dsc-&gt;page_count].end = 0;
    dsc-&gt;page[dsc-&gt;page_count].orientation = CDSC_ORIENT_UNKNOWN;
    dsc-&gt;page[dsc-&gt;page_count].media = NULL;
    dsc-&gt;page[dsc-&gt;page_count].bbox = NULL;
    dsc-&gt;page[dsc-&gt;page_count].viewing_orientation = NULL;
    dsc-&gt;page[dsc-&gt;page_count].crop_box = NULL;

    dsc-&gt;page_count++;
    if (dsc-&gt;page_count &gt;= dsc-&gt;page_chunk_length) {
	CDSCPAGE *new_page = (CDSCPAGE *)dsc_memalloc(dsc, 
	    (CDSC_PAGE_CHUNK+dsc-&gt;page_count) * sizeof(CDSCPAGE));
	if (new_page == NULL)
	    return CDSC_ERROR;	/* out of memory */
	memcpy(new_page, dsc-&gt;page, 
	    dsc-&gt;page_count * sizeof(CDSCPAGE));
	dsc_memfree(dsc, dsc-&gt;page);
	dsc-&gt;page= new_page;
	dsc-&gt;page_chunk_length = CDSC_PAGE_CHUNK+dsc-&gt;page_count;
    }
    return CDSC_OK;
}

/* Doesn't need to be public for PostScript documents */
/* Made public so GSview can store PDF MediaBox */
int
dsc_add_media(CDSC *dsc, CDSCMEDIA *media)
{
    CDSCMEDIA **newmedia_array;
    CDSCMEDIA *newmedia;

    /* extend media array  */
    newmedia_array = (CDSCMEDIA **)dsc_memalloc(dsc, 
	(dsc-&gt;media_count + 1) * sizeof(CDSCMEDIA *));
    if (newmedia_array == NULL)
	return CDSC_ERROR;	/* out of memory */
    if (dsc-&gt;media != NULL) {
	memcpy(newmedia_array, dsc-&gt;media, 
	    dsc-&gt;media_count * sizeof(CDSCMEDIA *));
	dsc_memfree(dsc, dsc-&gt;media);
    }
    dsc-&gt;media = newmedia_array;

    /* allocate new media */
    newmedia = dsc-&gt;media[dsc-&gt;media_count] =
	(CDSCMEDIA *)dsc_memalloc(dsc, sizeof(CDSCMEDIA));
    if (newmedia == NULL)
	return CDSC_ERROR;	/* out of memory */
    newmedia-&gt;name = NULL;
    newmedia-&gt;width = 595.0;
    newmedia-&gt;height = 842.0;
    newmedia-&gt;weight = 80.0;
    newmedia-&gt;colour = NULL;
    newmedia-&gt;type = NULL;
    newmedia-&gt;mediabox = NULL;

    dsc-&gt;media_count++;

    if (media-&gt;name) {
	newmedia-&gt;name = dsc_alloc_string(dsc, media-&gt;name,
	    (int)strlen(media-&gt;name));
	if (newmedia-&gt;name == NULL)
	    return CDSC_ERROR;	/* no memory */
    }
    newmedia-&gt;width = media-&gt;width;
    newmedia-&gt;height = media-&gt;height;
    newmedia-&gt;weight = media-&gt;weight;
    if (media-&gt;colour) {
	newmedia-&gt;colour = dsc_alloc_string(dsc, media-&gt;colour, 
	    (int)strlen(media-&gt;colour));
        if (newmedia-&gt;colour == NULL)
	    return CDSC_ERROR;	/* no memory */
    }
    if (media-&gt;type) {
	newmedia-&gt;type = dsc_alloc_string(dsc, media-&gt;type, 
	    (int)strlen(media-&gt;type));
	if (newmedia-&gt;type == NULL)
	    return CDSC_ERROR;	/* no memory */
    }
    newmedia-&gt;mediabox = NULL;

    if (media-&gt;mediabox) {
	newmedia-&gt;mediabox = (CDSCBBOX *)dsc_memalloc(dsc, sizeof(CDSCBBOX));
	if (newmedia-&gt;mediabox == NULL)
	    return CDSC_ERROR;	/* no memory */
	*newmedia-&gt;mediabox = *media-&gt;mediabox;
    }
    return CDSC_OK;
}

/* Doesn't need to be public for PostScript documents */
/* Made public so GSview can store PDF CropBox */
int
dsc_set_page_bbox(CDSC *dsc, unsigned int page_number, 
    int llx, int lly, int urx, int ury)
{
    CDSCBBOX *bbox;
    if (page_number &gt;= dsc-&gt;page_count)
	return CDSC_ERROR;
    bbox = dsc-&gt;page[page_number].bbox;
    if (bbox == NULL)
	dsc-&gt;page[page_number].bbox = bbox = 
	    (CDSCBBOX *)dsc_memalloc(dsc, sizeof(CDSCBBOX));
    if (bbox == NULL)
	return CDSC_ERROR;
    bbox-&gt;llx = llx;
    bbox-&gt;lly = lly;
    bbox-&gt;urx = urx;
    bbox-&gt;ury = ury;
    return CDSC_OK;
}


/******************************************************************/
/* Private functions below here.                                  */
/******************************************************************/

dsc_private void *
dsc_memalloc(CDSC *dsc, size_t size)
{
    if (dsc-&gt;memalloc)
	return dsc-&gt;memalloc(size, dsc-&gt;mem_closure_data);
    return malloc(size);
}

dsc_private void
dsc_memfree(CDSC*dsc, void *ptr)
{
    if (dsc-&gt;memfree) 
	dsc-&gt;memfree(ptr, dsc-&gt;mem_closure_data);
    else
	free(ptr);
}

/* private constructor */
dsc_private CDSC *
dsc_init2(CDSC *dsc)
{
    dsc_reset(dsc);

    dsc-&gt;string_head = (CDSCSTRING *)dsc_memalloc(dsc, sizeof(CDSCSTRING));
    if (dsc-&gt;string_head == NULL) {
	dsc_free(dsc);
	return NULL;	/* no memory */
    }
    dsc-&gt;string = dsc-&gt;string_head;
    dsc-&gt;string-&gt;next = NULL;
    dsc-&gt;string-&gt;data = (char *)dsc_memalloc(dsc, CDSC_STRING_CHUNK);
    if (dsc-&gt;string-&gt;data == NULL) {
	dsc_free(dsc);
	return NULL;	/* no memory */
    }
    dsc-&gt;string-&gt;index = 0;
    dsc-&gt;string-&gt;length = CDSC_STRING_CHUNK;
	
    dsc-&gt;page = (CDSCPAGE *)dsc_memalloc(dsc, CDSC_PAGE_CHUNK * sizeof(CDSCPAGE));
    if (dsc-&gt;page == NULL) {
	dsc_free(dsc);
	return NULL;	/* no memory */
    }
    dsc-&gt;page_chunk_length = CDSC_PAGE_CHUNK;
    dsc-&gt;page_count = 0;
	
    dsc-&gt;line = NULL;
    dsc-&gt;data_length = 0;
    dsc-&gt;data_index = dsc-&gt;data_length;

    return dsc;
}


dsc_private void 
dsc_reset(CDSC *dsc)
{
    unsigned int i;
    /* Clear public members */
    dsc-&gt;dsc = FALSE;
    dsc-&gt;ctrld = FALSE;
    dsc-&gt;pjl = FALSE;
    dsc-&gt;epsf = FALSE;
    dsc-&gt;pdf = FALSE;
    dsc-&gt;epsf = FALSE;
    dsc-&gt;preview = CDSC_NOPREVIEW;
    dsc-&gt;dsc_version = NULL;	/* stored in dsc-&gt;string */
    dsc-&gt;language_level = 0;
    dsc-&gt;document_data = CDSC_DATA_UNKNOWN;
    dsc-&gt;begincomments = 0;
    dsc-&gt;endcomments = 0;
    dsc-&gt;beginpreview = 0;
    dsc-&gt;endpreview = 0;
    dsc-&gt;begindefaults = 0;
    dsc-&gt;enddefaults = 0;
    dsc-&gt;beginprolog = 0;
    dsc-&gt;endprolog = 0;
    dsc-&gt;beginsetup = 0;
    dsc-&gt;endsetup = 0;
    dsc-&gt;begintrailer = 0;
    dsc-&gt;endtrailer = 0;
	
    for (i=0; i&lt;dsc-&gt;page_count; i++) {
	/* page media is pointer to an element of media or dsc_known_media */
	/* do not free it. */

	if (dsc-&gt;page[i].bbox)
	    dsc_memfree(dsc, dsc-&gt;page[i].bbox);
	if (dsc-&gt;page[i].viewing_orientation)
	    dsc_memfree(dsc, dsc-&gt;page[i].viewing_orientation);
	if (dsc-&gt;page[i].crop_box)
	    dsc_memfree(dsc, dsc-&gt;page[i].crop_box);
    }
    if (dsc-&gt;page)
	dsc_memfree(dsc, dsc-&gt;page);
    dsc-&gt;page = NULL;
	
    dsc-&gt;page_count = 0;
    dsc-&gt;page_pages = 0;
    dsc-&gt;page_order = CDSC_ORDER_UNKNOWN;
    dsc-&gt;page_orientation = CDSC_ORIENT_UNKNOWN;
    if (dsc-&gt;viewing_orientation)
	dsc_memfree(dsc, dsc-&gt;viewing_orientation);
    dsc-&gt;viewing_orientation = NULL;
	
    if (dsc-&gt;media) {
	for (i=0; i&lt;dsc-&gt;media_count; i++) {
	    if (dsc-&gt;media[i]) {
		if (dsc-&gt;media[i]-&gt;mediabox)
		    dsc_memfree(dsc, dsc-&gt;media[i]-&gt;mediabox);
		dsc_memfree(dsc, dsc-&gt;media[i]);
	    }
	}
	dsc_memfree(dsc, dsc-&gt;media);
    }
    dsc-&gt;media_count = 0;
    dsc-&gt;media = NULL;

    /* page_media is pointer to an element of media or dsc_known_media */
    /* do not free it. */
    dsc-&gt;page_media = NULL;

    if (dsc-&gt;bbox)
	dsc_memfree(dsc, dsc-&gt;bbox);
    dsc-&gt;bbox = NULL;
    if (dsc-&gt;page_bbox)
	dsc_memfree(dsc, dsc-&gt;page_bbox);
    dsc-&gt;page_bbox = NULL;
    if (dsc-&gt;doseps)
	dsc_memfree(dsc, dsc-&gt;doseps);
    dsc-&gt;doseps = NULL;
	
    dsc-&gt;dsc_title = NULL;
    dsc-&gt;dsc_creator = NULL;
    dsc-&gt;dsc_date = NULL;
    dsc-&gt;dsc_for = NULL;
	

    dsc-&gt;max_error = DSC_MAX_ERROR;
    dsc-&gt;severity = dsc_severity;

    /* Clear private members */
    /* Don't touch dsc-&gt;caller_data */
    dsc-&gt;id = CDSC_OK;
    dsc-&gt;scan_section = scan_none;
    dsc-&gt;doseps_end = 0;
    dsc-&gt;page_chunk_length = 0;
    dsc-&gt;file_length = 0;
    dsc-&gt;skip_document = 0;
    dsc-&gt;skip_bytes = 0;
    dsc-&gt;skip_lines = 0;
    dsc-&gt;skip_pjl = 0;
    dsc-&gt;begin_font_count = 0;
    dsc-&gt;begin_feature_count = 0;
    dsc-&gt;begin_resource_count = 0;
    dsc-&gt;begin_procset_count = 0;

    dsc-&gt;data_length = 0;
    dsc-&gt;data_index = 0;
    dsc-&gt;data_offset = 0;

    dsc-&gt;eof = 0;
	
    dsc-&gt;line = 0;
    dsc-&gt;line_length = 0;
    dsc-&gt;eol = 0;
    dsc-&gt;last_cr = FALSE;
    dsc-&gt;line_count = 1;
    dsc-&gt;long_line = FALSE;
    memset(dsc-&gt;last_line, 0, sizeof(dsc-&gt;last_line));

    dsc-&gt;string = dsc-&gt;string_head;
    while (dsc-&gt;string != (CDSCSTRING *)NULL) {
	if (dsc-&gt;string-&gt;data)
	    dsc_memfree(dsc, dsc-&gt;string-&gt;data);
	dsc-&gt;string_head = dsc-&gt;string;
	dsc-&gt;string = dsc-&gt;string-&gt;next;
	dsc_memfree(dsc, dsc-&gt;string_head);
    }
    dsc-&gt;string_head = NULL;
    dsc-&gt;string = NULL;

    /* don't touch caller functions */

    /* public data */
    if (dsc-&gt;hires_bbox)
	dsc_memfree(dsc, dsc-&gt;hires_bbox);
    dsc-&gt;hires_bbox = NULL;
    if (dsc-&gt;crop_box)
	dsc_memfree(dsc, dsc-&gt;crop_box);
    dsc-&gt;crop_box = NULL;

    if (dsc-&gt;dcs2) {
	CDCS2 *this_dcs, *next_dcs;
	this_dcs = dsc-&gt;dcs2;
	while (this_dcs) {
	    next_dcs = this_dcs-&gt;next;
	    /* strings have already been freed */
	    dsc_memfree(dsc, this_dcs);
	    this_dcs = next_dcs;
	}
	dsc-&gt;dcs2 = NULL;
    }
    if (dsc-&gt;colours) {
	CDSCCOLOUR *this_colour, *next_colour;
	this_colour = dsc-&gt;colours;
	while (this_colour) {
	    next_colour = this_colour-&gt;next;
	    /* strings have already been freed */
	    dsc_memfree(dsc, this_colour);
	    this_colour = next_colour;
	}
	dsc-&gt;colours = NULL;
    }

    if (dsc-&gt;macbin)
	dsc_memfree(dsc, dsc-&gt;macbin);
    dsc-&gt;macbin = NULL;
}

/* 
* Join up all sections.
* There might be extra code between them, or we might have
* missed including the \n which followed \r.
* begin is the start of this section
* pend is a pointer to the end of this section
* pplast is a pointer to a pointer of the end of the previous section
*/
dsc_private void 
dsc_section_join(DSC_OFFSET begin, DSC_OFFSET *pend, DSC_OFFSET **pplast)
{
    if (begin)
	**pplast = begin;
    if (*pend &gt; begin)
	*pplast = pend;
}


/* return value is 0 if no line available, or length of line */
dsc_private int
dsc_read_line(CDSC *dsc)
{
    char *p, *last;
    dsc-&gt;line = NULL;

    if (dsc-&gt;eof) {
	/* return all that remains, even if line incomplete */
	dsc-&gt;line = dsc-&gt;data + dsc-&gt;data_index;
	dsc-&gt;line_length = dsc-&gt;data_length - dsc-&gt;data_index;
	dsc-&gt;data_index = dsc-&gt;data_length;
	return dsc-&gt;line_length;
    }

    if (dsc-&gt;file_length &amp;&amp; 
	(dsc-&gt;data_offset + dsc-&gt;data_index &gt;= dsc-&gt;file_length)) {
	/* Have read past where we need to parse. */
	/* Ignore all that remains. */
	dsc-&gt;line = dsc-&gt;data + dsc-&gt;data_index;
	dsc-&gt;line_length = dsc-&gt;data_length - dsc-&gt;data_index;
	dsc-&gt;data_index = dsc-&gt;data_length;
	return dsc-&gt;line_length;

    }
    if (dsc-&gt;doseps_end &amp;&amp; 
	(dsc-&gt;data_offset + dsc-&gt;data_index &gt;= dsc-&gt;doseps_end)) {
	/* Have read past end of DOS EPS PostScript section. */
	/* Ignore all that remains. */
	dsc-&gt;line = dsc-&gt;data + dsc-&gt;data_index;
	dsc-&gt;line_length = dsc-&gt;data_length - dsc-&gt;data_index;
	dsc-&gt;data_index = dsc-&gt;data_length;
	return dsc-&gt;line_length;
    }

    /* ignore embedded bytes */
    if (dsc-&gt;skip_bytes) {
	int cnt = min(dsc-&gt;skip_bytes,
		     (int)(dsc-&gt;data_length - dsc-&gt;data_index));
	dsc-&gt;skip_bytes -= cnt;
	dsc-&gt;data_index += cnt;
	if (dsc-&gt;skip_bytes != 0)
	    return 0;
    }

    do {
	dsc-&gt;line = dsc-&gt;data + dsc-&gt;data_index;
	last = dsc-&gt;data + dsc-&gt;data_length;
	if (dsc-&gt;data_index == dsc-&gt;data_length) {
	    dsc-&gt;line_length = 0;
	    return 0;
	}
	if (dsc-&gt;eol) {
	    /* if previous line was complete, increment line count */
	    dsc-&gt;line_count++;
	    if (dsc-&gt;skip_lines)
		dsc-&gt;skip_lines--;
	}
	    
	/* skip over \n which followed \r */
	if (dsc-&gt;last_cr &amp;&amp; dsc-&gt;line[0] == '\n') {
	    dsc-&gt;data_index++;
	    dsc-&gt;line++;
	}
	dsc-&gt;last_cr = FALSE;

	/* look for EOL */
	dsc-&gt;eol = FALSE;
	for (p = dsc-&gt;line; p &lt; last; p++) {
	    if (*p == '\r') {
		p++;
		if ((p&lt;last) &amp;&amp; (*p == '\n'))
		    p++;	/* include line feed also */
		else
		    dsc-&gt;last_cr = TRUE; /* we might need to skip \n */
		dsc-&gt;eol = TRUE;	/* dsc-&gt;line is a complete line */
		break;
	    }
	    if (*p == '\n') {
		p++;
		dsc-&gt;eol = TRUE;	/* dsc-&gt;line is a complete line */
		break;
	    }
	    if (*p == '\032') {		/* MS-DOS Ctrl+Z */
		dsc-&gt;eol = TRUE;
	    }
	}
	if (dsc-&gt;eol == FALSE) {
	    /* we haven't got a complete line yet */
	    if (dsc-&gt;data_length - dsc-&gt;data_index &lt; sizeof(dsc-&gt;data)/2) {
		/* buffer is less than half full, ask for some more */
		dsc-&gt;line_length = 0;
		return 0;
	    }
	}
	dsc-&gt;data_index += dsc-&gt;line_length = (int)(p - dsc-&gt;line);
    } while (dsc-&gt;skip_lines &amp;&amp; dsc-&gt;line_length);

    if (dsc-&gt;line_length == 0)
	return 0;
	
    if ((dsc-&gt;line[0]=='%') &amp;&amp; (dsc-&gt;line[1]=='%'))  {
	/* handle recursive %%BeginDocument */
	if ((dsc-&gt;skip_document) &amp;&amp; dsc-&gt;line_length &amp;&amp;
		COMPARE(dsc-&gt;line, "%%EndDocument")) {
	    dsc-&gt;skip_document--;
	}

	/* handle embedded lines or binary data */
	if (COMPARE(dsc-&gt;line, "%%BeginData:")) {
	    /* %%BeginData: &lt;numberof&gt;[ &lt;type&gt; [ &lt;bytesorlines&gt; ] ] 
	     * &lt;numberof&gt; ::= &lt;uint&gt; (Lines or physical bytes) 
	     * &lt;type&gt; ::= Hex | Binary | ASCII (Type of data) 
	     * &lt;bytesorlines&gt; ::= Bytes | Lines (Read in bytes or lines) 
	     */
	    char begindata[MAXSTR+1];
	    int cnt;
	    const char *numberof, *bytesorlines;
	    cnt = dsc-&gt;line_length;
	    if (dsc-&gt;line_length &gt; sizeof(begindata)-1)
		cnt = sizeof(begindata)-1;
	    memcpy(begindata, dsc-&gt;line, cnt);
	    begindata[cnt] = '\0';
	    numberof = strtok(begindata+12, " \r\n");
	    strtok(NULL, " \r\n");	/* dump type */
	    bytesorlines = strtok(NULL, " \r\n");
	    if (bytesorlines == NULL)
		bytesorlines = "Bytes";
	   
	    if ( (numberof == NULL) || (bytesorlines == NULL) ) {
		/* invalid usage of %%BeginData */
		/* ignore that we ever saw it */
		int rc = dsc_error(dsc, CDSC_MESSAGE_INCORRECT_USAGE, 
			    dsc-&gt;line, dsc-&gt;line_length);
		switch (rc) {
		    case CDSC_RESPONSE_OK:
		    case CDSC_RESPONSE_CANCEL:
			break;
		    case CDSC_RESPONSE_IGNORE_ALL:
			return 0;
		}
	    }
	    else {
		cnt = atoi(numberof);
		if (cnt) {
		    if (bytesorlines &amp;&amp; (dsc_stricmp(bytesorlines, "Lines")==0)) {
			/* skip cnt lines */
			if (dsc-&gt;skip_lines == 0) {
			    /* we are not already skipping lines */
			    dsc-&gt;skip_lines = cnt+1;
			}
		    }
		    else {
			/* byte count doesn't includes \n or \r\n  */
			/* or \r of %%BeginData: */
			/* skip cnt bytes */
			if (dsc-&gt;skip_bytes == 0) {
			    /* we are not already skipping lines */
			    dsc-&gt;skip_bytes = cnt;
			}

		    }
		}
	    }
	}
	else if (COMPARE(dsc-&gt;line, "%%BeginBinary:")) {
	    /* byte count doesn't includes \n or \r\n or \r of %%BeginBinary:*/
	    int cnt = dsc_get_int(dsc-&gt;line + 14,
		dsc-&gt;line_length - 14, NULL);
	    if (dsc-&gt;skip_bytes == 0) {
		/* we are not already skipping lines */
		dsc-&gt;skip_bytes = cnt;
	    }
	}
    }
	
    if ((dsc-&gt;line[0]=='%') &amp;&amp; (dsc-&gt;line[1]=='%') &amp;&amp;
	COMPARE(dsc-&gt;line, "%%BeginDocument:") ) {
	/* Skip over embedded document, recursively */
	dsc-&gt;skip_document++;
    }

    if (!dsc-&gt;long_line &amp;&amp; (dsc-&gt;line_length &gt; DSC_LINE_LENGTH)) {
	dsc_error(dsc, CDSC_MESSAGE_LONG_LINE, dsc-&gt;line, dsc-&gt;line_length);
        dsc-&gt;long_line = TRUE;
    }
	
    return dsc-&gt;line_length;
}


/* Save last DSC line, for use with %%+ */
dsc_private void 
dsc_save_line(CDSC *dsc)
{
    int len = min(sizeof(dsc-&gt;last_line), dsc-&gt;line_length);
    memcpy(dsc-&gt;last_line, dsc-&gt;line, len);
}

/* display unknown DSC line */
dsc_private void 
dsc_unknown(CDSC *dsc)
{
    if (dsc-&gt;debug_print_fn) {
	char line[DSC_LINE_LENGTH];
	unsigned int length = min(DSC_LINE_LENGTH-1, dsc-&gt;line_length);
	sprintf(line, "Unknown in %s section at line %d:\n  ", 
	    dsc_scan_section_name[dsc-&gt;scan_section], dsc-&gt;line_count);
	dsc_debug_print(dsc, line);
	strncpy(line, dsc-&gt;line, length);
	line[length] = '\0';
	dsc_debug_print(dsc, line);
	dsc_debug_print(dsc, "\n");
    }
}


dsc_private GSBOOL
dsc_is_section(char *line)
{
    if ( !((line[0]=='%') &amp;&amp; (line[1]=='%')) )
	return FALSE;
    if (IS_DSC(line, "%%BeginPreview"))
	return TRUE;
    if (IS_DSC(line, "%%BeginDefaults"))
	return TRUE;
    if (IS_DSC(line, "%%BeginProlog"))
	return TRUE;
    if (IS_DSC(line, "%%BeginSetup"))
	return TRUE;
    if (IS_DSC(line, "%%Page:"))
	return TRUE;
    if (IS_DSC(line, "%%Trailer"))
	return TRUE;
    if (IS_DSC(line, "%%EOF"))
	return TRUE;
    return FALSE;
}

/* Get little-endian DWORD, used for DOS EPS files */
dsc_private GSDWORD
dsc_get_dword(const unsigned char *buf)
{
    GSDWORD dw;
    dw = (GSDWORD)buf[0];
    dw += ((GSDWORD)buf[1])&lt;&lt;8;
    dw += ((GSDWORD)buf[2])&lt;&lt;16;
    dw += ((GSDWORD)buf[3])&lt;&lt;24;
    return dw;
}

dsc_private GSWORD
dsc_get_word(const unsigned char *buf)
{
    GSWORD w;
    w = (GSWORD)buf[0];
    w |= (GSWORD)(buf[1]&lt;&lt;8);
    return w;
}

/* Get big-endian DWORD, used for Mac Binary files */
dsc_private GSDWORD
dsc_get_bigendian_dword(const unsigned char *buf)
{
    GSDWORD dw;
    dw = (GSDWORD)buf[3];
    dw += ((GSDWORD)buf[2])&lt;&lt;8;
    dw += ((GSDWORD)buf[1])&lt;&lt;16;
    dw += ((GSDWORD)buf[0])&lt;&lt;24;
    return dw;
}

dsc_private GSWORD
dsc_get_bigendian_word(const unsigned char *buf)
{
    GSWORD w;
    w = (GSWORD)buf[1];
    w |= (GSWORD)(buf[0]&lt;&lt;8);
    return w;
}

dsc_private int
dsc_read_doseps(CDSC *dsc)
{
    unsigned char *line = (unsigned char *)dsc-&gt;line;
    if ((dsc-&gt;doseps = (CDSCDOSEPS *)dsc_memalloc(dsc, sizeof(CDSCDOSEPS))) == NULL)
	return CDSC_ERROR;	/* no memory */
	
    dsc-&gt;doseps-&gt;ps_begin = dsc_get_dword(line+4);
    dsc-&gt;doseps-&gt;ps_length = dsc_get_dword(line+8);
    dsc-&gt;doseps-&gt;wmf_begin = dsc_get_dword(line+12);
    dsc-&gt;doseps-&gt;wmf_length = dsc_get_dword(line+16);
    dsc-&gt;doseps-&gt;tiff_begin = dsc_get_dword(line+20);
    dsc-&gt;doseps-&gt;tiff_length = dsc_get_dword(line+24);
    dsc-&gt;doseps-&gt;checksum = dsc_get_word(line+28);

    if (dsc-&gt;file_length &amp;&amp; 
	(dsc-&gt;doseps-&gt;ps_begin + dsc-&gt;doseps-&gt;ps_length &gt; dsc-&gt;file_length)) {
	/* Error in DOS EPS header.
	 * Some files have been seen with a fixed large value as 
	 * the length of the PostScript section.
	 * Correct for these erroneous files.
	 */
	 dsc-&gt;doseps-&gt;ps_length = 
	    (GSDWORD)(dsc-&gt;file_length - dsc-&gt;doseps-&gt;ps_begin);
    }

    dsc-&gt;doseps_end = dsc-&gt;doseps-&gt;ps_begin + dsc-&gt;doseps-&gt;ps_length;

    /* move data_index backwards to byte after doseps header */
    dsc-&gt;data_index -= dsc-&gt;line_length - 30;
    /* we haven't read a line of PostScript code yet */
    dsc-&gt;line_count = 0;
    /* skip from current position to start of PostScript section */
    dsc-&gt;skip_bytes = dsc-&gt;doseps-&gt;ps_begin - 30;

    if (dsc-&gt;doseps-&gt;tiff_begin)
	dsc-&gt;preview = CDSC_TIFF;
    if (dsc-&gt;doseps-&gt;wmf_begin)
	dsc-&gt;preview = CDSC_WMF;

    return CDSC_OK;
}


dsc_private int
dsc_read_macbin(CDSC *dsc)
{
    unsigned char *line = (unsigned char *)dsc-&gt;line;
    if ((dsc-&gt;macbin = 
	(CDSCMACBIN *)dsc_memalloc(dsc, sizeof(CDSCMACBIN))) == NULL)
	return CDSC_ERROR;	/* no memory */
	
    dsc-&gt;macbin-&gt;data_begin = 128;
    dsc-&gt;macbin-&gt;data_length = dsc_get_bigendian_dword(line+83);
    dsc-&gt;macbin-&gt;resource_begin = 
	(dsc-&gt;macbin-&gt;data_begin + dsc-&gt;macbin-&gt;data_length + 127 ) &amp; ~127;
    dsc-&gt;macbin-&gt;resource_length = dsc_get_bigendian_dword(line+87);

    if (dsc-&gt;file_length &amp;&amp; 
	(((dsc-&gt;macbin-&gt;resource_begin + dsc-&gt;macbin-&gt;resource_length 
	  + 127) &amp; ~127) &gt; dsc-&gt;file_length)) {
	return CDSC_ERROR;
    }

    dsc-&gt;doseps_end = dsc-&gt;macbin-&gt;data_begin + dsc-&gt;macbin-&gt;data_length;

    /* move data_index to byte after Mac Binary header */
    dsc-&gt;data_index -= dsc-&gt;line_length - 128;
    /* we haven't read a line of PostScript code yet */
    dsc-&gt;line_count = 0;

    dsc-&gt;preview = CDSC_PICT;

    return CDSC_OK;
}


dsc_private int
dsc_read_applesingle(CDSC *dsc)
{
    GSDWORD EntryID;
    GSDWORD Offset;
    GSDWORD Length;
    GSWORD entries;
    int index;
    int header;
    int i;

    unsigned char *line = (unsigned char *)dsc-&gt;line;
    if ((dsc-&gt;macbin = 
	(CDSCMACBIN *)dsc_memalloc(dsc, sizeof(CDSCMACBIN))) == NULL)
	return CDSC_ERROR;	/* no memory */
    entries = dsc_get_bigendian_word(line+24);
    for (i=0; i&lt;(int)entries; i++) {
	index = 26 + i * 12;
	EntryID = dsc_get_bigendian_dword(line+index);
	Offset = dsc_get_bigendian_dword(line+index+4);
	Length = dsc_get_bigendian_dword(line+index+8);
	if (EntryID == 1) {
	    /* data fork */
	    dsc-&gt;macbin-&gt;data_begin = Offset;
	    dsc-&gt;macbin-&gt;data_length = Length;
	}
	else if (EntryID == 2) {
	    /* resource fork */
	    dsc-&gt;macbin-&gt;resource_begin = Offset;
	    dsc-&gt;macbin-&gt;resource_length = Length;
	}
    }
	
    if (dsc-&gt;file_length &amp;&amp; 
	(dsc-&gt;macbin-&gt;resource_begin + dsc-&gt;macbin-&gt;resource_length
	  &gt; dsc-&gt;file_length)) {
	return CDSC_ERROR;
    }
    if (dsc-&gt;file_length &amp;&amp; 
	(dsc-&gt;macbin-&gt;data_begin + dsc-&gt;macbin-&gt;data_length 
	  &gt; dsc-&gt;file_length)) {
	return CDSC_ERROR;
    }

    dsc-&gt;doseps_end = dsc-&gt;macbin-&gt;data_begin + dsc-&gt;macbin-&gt;data_length;

    header = 26 + entries * 12;
    /* move data_index to byte after AppleSingle/AppleDouble header */
    dsc-&gt;data_index -= dsc-&gt;line_length - header;
    /* we haven't read a line of PostScript code yet */
    dsc-&gt;line_count = 0;
    /* skip from current position to start of PostScript section */
    dsc-&gt;skip_bytes = dsc-&gt;macbin-&gt;data_begin - header;

    dsc-&gt;preview = CDSC_PICT;

    return CDSC_OK;
}

dsc_private int 
dsc_parse_pages(CDSC *dsc)
{
    int ip, io; 
    unsigned int i;
    char *p;
    int n;
    if ((dsc-&gt;page_pages != 0) &amp;&amp; (dsc-&gt;scan_section == scan_comments)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((dsc-&gt;page_pages != 0) &amp;&amp; (dsc-&gt;scan_section == scan_trailer)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_TRAILER, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		break;		/* use duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    n = IS_DSC(dsc-&gt;line, "%%+") ? 3 : 8;
    while (IS_WHITE(dsc-&gt;line[n]))
	n++;
    p = dsc-&gt;line + n;
    if (COMPARE(p, "atend")) {
	if (dsc-&gt;scan_section != scan_comments)
	    dsc_unknown(dsc);
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_ATEND, 
		dsc-&gt;line, dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		    /* assume (atend) */
		    /* we should mark it as deferred */
		    break;
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    else if (COMPARE(p, "(atend)")) {
	if (dsc-&gt;scan_section != scan_comments)
	    dsc_unknown(dsc);
	/* do nothing */
	/* we should mark it as deferred */
    }
    else {
	ip = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
        if (i) {
	    n+=i;
	    dsc-&gt;page_pages = ip;
	    io = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    if (i) {
		/* DSC 2 uses extra integer to indicate page order */
		/* DSC 3 uses %%PageOrder: */
		if (dsc-&gt;page_order == CDSC_ORDER_UNKNOWN)
		    switch (io) {
			case -1:
			    dsc-&gt;page_order = CDSC_DESCEND;
			    break;
			case 0:
			    dsc-&gt;page_order = CDSC_SPECIAL;
			    break;
			case 1:
			    dsc-&gt;page_order = CDSC_ASCEND;
			    break;
		    }
	    }
	}
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_INCORRECT_USAGE, dsc-&gt;line, 
		dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    return CDSC_OK;
}

dsc_private int 
dsc_parse_bounding_box(CDSC *dsc, CDSCBBOX** pbbox, int offset)
{
    unsigned int i, n;
    int llx, lly, urx, ury;
    float fllx, flly, furx, fury;
    char *p;
    /* Process first %%BoundingBox: in comments, and last in trailer */
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_comments)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_pages)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_trailer)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_TRAILER, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		break;		/* use duplicate comments in trailer */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if (*pbbox != NULL) {
	dsc_memfree(dsc, *pbbox);
	*pbbox = NULL;
    }

    /* should only process first %%BoundingBox: */

    while (IS_WHITE(dsc-&gt;line[offset]))
	offset++;
    p = dsc-&gt;line + offset;
    
    if (COMPARE(p, "atend")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_ATEND, dsc-&gt;line, 
		    dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		    /* assume (atend) */
		    /* we should mark it as deferred */
		    break;
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    else if (COMPARE(p, "(atend)")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	/* do nothing */
	/* we should mark it as deferred */
    }
    else {
        /* llx = */ lly = urx = ury = 0;
	n = offset;
	llx = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    lly = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    urx = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    ury = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	if (i) {
	    *pbbox = (CDSCBBOX *)dsc_memalloc(dsc, sizeof(CDSCBBOX));
	    if (*pbbox == NULL)
		return CDSC_ERROR;	/* no memory */
	    (*pbbox)-&gt;llx = llx;
	    (*pbbox)-&gt;lly = lly;
	    (*pbbox)-&gt;urx = urx;
	    (*pbbox)-&gt;ury = ury;
	}
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_BBOX, dsc-&gt;line, 
		dsc-&gt;line_length);
	    switch (rc) {
	      case CDSC_RESPONSE_OK:
		/* fllx = */ flly = furx = fury = 0.0;
		n = offset;
		n += i;
		fllx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
		n += i;
		if (i)
		    flly = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
		n += i;
		if (i)
		    furx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
		n += i;
		if (i)
		    fury = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
		if (i) {
		    *pbbox = (CDSCBBOX *)dsc_memalloc(dsc, sizeof(CDSCBBOX));
		    if (*pbbox == NULL)
			return CDSC_ERROR;	/* no memory */
			(*pbbox)-&gt;llx = (int)fllx;
			(*pbbox)-&gt;lly = (int)flly;
			(*pbbox)-&gt;urx = (int)(furx+0.999);
			(*pbbox)-&gt;ury = (int)(fury+0.999);
		}
		return CDSC_OK;
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	  }
	}
    }
    return CDSC_OK;
}

dsc_private int 
dsc_parse_float_bounding_box(CDSC *dsc, CDSCFBBOX** pbbox, int offset)
{
    unsigned int i, n;
    float fllx, flly, furx, fury;
    char *p;
    /* Process first %%HiResBoundingBox: or %%CropBox: in comments, 
     * and last in trailer.
     */
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_comments)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_pages)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((*pbbox != NULL) &amp;&amp; (dsc-&gt;scan_section == scan_trailer)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_TRAILER, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		break;		/* use duplicate comments in trailer */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if (*pbbox != NULL) {
	dsc_memfree(dsc, *pbbox);
	*pbbox = NULL;
    }

    /* should only process first %%BoundingBox: */

    while (IS_WHITE(dsc-&gt;line[offset]))
	offset++;
    p = dsc-&gt;line + offset;
    
    if (COMPARE(p, "atend")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_ATEND, dsc-&gt;line, 
		    dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		    /* assume (atend) */
		    /* we should mark it as deferred */
		    break;
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    else if (COMPARE(p, "(atend)")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	/* do nothing */
	/* we should mark it as deferred */
    }
    else {
	/* fllx = */ flly = furx = fury = 0.0;
	n = offset;
	fllx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    flly = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    furx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n += i;
	if (i)
	    fury = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	if (i) {
	    *pbbox = (CDSCFBBOX *)dsc_memalloc(dsc, sizeof(CDSCFBBOX));
	    if (*pbbox == NULL)
		return CDSC_ERROR;	/* no memory */
	    (*pbbox)-&gt;fllx = fllx;
	    (*pbbox)-&gt;flly = flly;
	    (*pbbox)-&gt;furx = furx;
	    (*pbbox)-&gt;fury = fury;
	}
    }
    return CDSC_OK;
}

dsc_private int 
dsc_parse_orientation(CDSC *dsc, unsigned int *porientation, int offset)
{
    char *p;
    if ((dsc-&gt;page_orientation != CDSC_ORIENT_UNKNOWN) &amp;&amp; 
	(dsc-&gt;scan_section == scan_comments)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((dsc-&gt;page_orientation != CDSC_ORIENT_UNKNOWN) &amp;&amp; 
	(dsc-&gt;scan_section == scan_trailer)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_TRAILER, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		break;		/* use duplicate comments in header; */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    p = dsc-&gt;line + offset;
    while (IS_WHITE(*p))
	p++;
    if (COMPARE(p, "atend")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_ATEND, 
		dsc-&gt;line, dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		    /* assume (atend) */
		    /* we should mark it as deferred */
		    break;
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    else if (COMPARE(p, "(atend)")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	/* do nothing */
	/* we should mark it as deferred */
    }
    else if (COMPARE(p, "Portrait")) {
	*porientation = CDSC_PORTRAIT;
    }
    else if (COMPARE(p, "Landscape")) {
	*porientation = CDSC_LANDSCAPE;
    }
    else {
	dsc_unknown(dsc);
    }
    return CDSC_OK;
}

dsc_private int 
dsc_parse_order(CDSC *dsc)
{
    char *p;
    if ((dsc-&gt;page_order != CDSC_ORDER_UNKNOWN) &amp;&amp; 
	(dsc-&gt;scan_section == scan_comments)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_COMMENT, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		return CDSC_OK;	/* ignore duplicate comments in header */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    if ((dsc-&gt;page_order != CDSC_ORDER_UNKNOWN) &amp;&amp; 
	(dsc-&gt;scan_section == scan_trailer)) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_DUP_TRAILER, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
	    case CDSC_RESPONSE_CANCEL:
		break;		/* use duplicate comments in trailer */
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    p = dsc-&gt;line + (IS_DSC(dsc-&gt;line, "%%+") ? 3 : 13);
    while (IS_WHITE(*p))
	p++;
    if (COMPARE(p, "atend")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	else {
	    int rc = dsc_error(dsc, CDSC_MESSAGE_ATEND, dsc-&gt;line, 
		    dsc-&gt;line_length);
	    switch (rc) {
		case CDSC_RESPONSE_OK:
		    /* assume (atend) */
		    /* we should mark it as deferred */
		    break;
		case CDSC_RESPONSE_CANCEL:
		    /* ignore it */
		    break;
		case CDSC_RESPONSE_IGNORE_ALL:
		    return CDSC_NOTDSC;
	    }
	}
    }
    else if (COMPARE(p, "(atend)")) {
	if (dsc-&gt;scan_section == scan_trailer)
	    dsc_unknown(dsc);
	/* do nothing */
	/* we should mark it as deferred */
    }
    else if (COMPARE(p, "Ascend")) {
	dsc-&gt;page_order = CDSC_ASCEND;
    }
    else if (COMPARE(p, "Descend")) {
	dsc-&gt;page_order = CDSC_DESCEND;
    }
    else if (COMPARE(p, "Special")) {
	dsc-&gt;page_order = CDSC_SPECIAL;
    }
    else {
	dsc_unknown(dsc);
    }
    return CDSC_OK;
}


dsc_private int 
dsc_parse_media(CDSC *dsc, const CDSCMEDIA **page_media)
{
    char media_name[MAXSTR];
    int n = IS_DSC(dsc-&gt;line, "%%+") ? 3 : 12; /* %%PageMedia: */
    unsigned int i;

    if (dsc_copy_string(media_name, sizeof(media_name)-1, 
	dsc-&gt;line+n, dsc-&gt;line_length-n, NULL)) {
	for (i=0; i&lt;dsc-&gt;media_count; i++) {
	    if (dsc-&gt;media[i]-&gt;name &amp;&amp; 
		(dsc_stricmp(media_name, dsc-&gt;media[i]-&gt;name) == 0)) {
		*page_media = dsc-&gt;media[i];
		return CDSC_OK;
	    }
	}
    }
    dsc_unknown(dsc);
    
    return CDSC_OK;
}


dsc_private int 
dsc_parse_document_media(CDSC *dsc)
{
    unsigned int i, n;
    CDSCMEDIA lmedia;
    GSBOOL blank_line;

    if (IS_DSC(dsc-&gt;line, "%%DocumentMedia:"))
	n = 16;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    /* check for blank remainder of line */
    blank_line = TRUE;
    for (i=n; i&lt;dsc-&gt;line_length; i++) {
	if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
	    blank_line = FALSE;
	    break;
	}
    }

    if (!blank_line) {
	char name[MAXSTR];
	char colour[MAXSTR];
	char type[MAXSTR];
	lmedia.name = lmedia.colour = lmedia.type = (char *)NULL;
	lmedia.width = lmedia.height = lmedia.weight = 0;
	lmedia.mediabox = (CDSCBBOX *)NULL;
	lmedia.name = dsc_copy_string(name, sizeof(name),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    lmedia.width = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    lmedia.height = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    lmedia.weight = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    lmedia.colour = dsc_copy_string(colour, sizeof(colour),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    lmedia.type = dsc_copy_string(type, sizeof(type),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);

	if (i==0)
	    dsc_unknown(dsc); /* we didn't get all fields */
	else {
	    if (dsc_add_media(dsc, &amp;lmedia))
		return CDSC_ERROR;	/* out of memory */
	}
    }
    return CDSC_OK;
}

/* viewing orientation is believed to be the first four elements of
 * a CTM matrix
 */
dsc_private int 
dsc_parse_viewing_orientation(CDSC *dsc, CDSCCTM **pctm)
{
    CDSCCTM ctm;
    unsigned int i, n;

    if (*pctm != NULL) {
	dsc_memfree(dsc, *pctm);
	*pctm = NULL;
    }

    n = IS_DSC(dsc-&gt;line, "%%+") ? 3 : 21;  /* %%ViewingOrientation: */
    while (IS_WHITE(dsc-&gt;line[n]))
	n++;

    /* ctm.xx = */ ctm.xy = ctm.yx = ctm.yy = 0.0;
    ctm.xx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
    n += i;
    if (i)
        ctm.xy = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
    n += i;
    if (i)
        ctm.yx = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
    n += i;
    if (i)
        ctm.yy = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
    if (i==0) {
	dsc_unknown(dsc); /* we didn't get all fields */
    }
    else {
	*pctm = (CDSCCTM *)dsc_memalloc(dsc, sizeof(CDSCCTM));
	if (*pctm == NULL)
	    return CDSC_ERROR;	/* no memory */
	**pctm = ctm;
    }
    return CDSC_OK;
}
   

/* This is called before dsc_read_line(), since we may
 * need to skip a binary header which contains a new line
 * character
 */
dsc_private int 
dsc_scan_type(CDSC *dsc)
{
    unsigned char *p;
    unsigned char *line = (unsigned char *)(dsc-&gt;data + dsc-&gt;data_index);
    int length = dsc-&gt;data_length - dsc-&gt;data_index;

    /* Types that should be known:
     *   DSC
     *   EPSF
     *   PJL + any of above
     *   ^D + any of above
     *   DOS EPS
     *   PDF
     *   non-DSC
     */

    /* First process any non PostScript headers */
    /* At this stage we do not have a complete line */

    if (length == 0)
	return CDSC_NEEDMORE;

    /* If we have already found a DOS EPS header, */
    /* ignore all until the PostScript section */
    if (dsc-&gt;skip_bytes) {
	int cnt = min(dsc-&gt;skip_bytes,
		     (int)(dsc-&gt;data_length - dsc-&gt;data_index));
	dsc-&gt;skip_bytes -= cnt;
	dsc-&gt;data_index += cnt;
	length -= cnt;
	line += cnt;
	if (dsc-&gt;skip_bytes != 0)
	    return CDSC_NEEDMORE;
    }

    if (dsc-&gt;skip_pjl) {
	/* skip until first PostScript comment */
	while (length &gt;= 2) {
	    while (length &amp;&amp; !IS_EOL(line[0])) {
		/* skip until EOL character */
		line++;
		dsc-&gt;data_index++;
		length--;
	    }
	    while ((length &gt;= 2) &amp;&amp; IS_EOL(line[0]) &amp;&amp; IS_EOL(line[1])) {
		/* skip until EOL followed by non-EOL */
		line++;
		dsc-&gt;data_index++;
		length--;
	    }
	    if (length &lt; 2)
		return CDSC_NEEDMORE;

	    if (IS_EOL(line[0]) &amp;&amp; line[1]=='%') {
		line++;
		dsc-&gt;data_index++;
		length--;
		dsc-&gt;skip_pjl = FALSE;
		break;
	    }
	    else {
		line++;
		dsc-&gt;data_index++;
		length--;
	    }
	}
	if (dsc-&gt;skip_pjl)
	    return CDSC_NEEDMORE;
    }

    if (length == 0)
	return CDSC_NEEDMORE;

    if (line[0] == '\004') {
	line++;
	dsc-&gt;data_index++;
	length--;
	dsc-&gt;ctrld = TRUE;
    }

    if (line[0] == '\033') {
	/* possibly PJL */
	if (length &lt; 9)
	    return CDSC_NEEDMORE;
	if (COMPARE(line, "\033%-12345X")) {
	    dsc-&gt;skip_pjl = TRUE;  /* skip until first PostScript comment */
	    dsc-&gt;pjl = TRUE;
	    dsc-&gt;data_index += 9;
	    return dsc_scan_type(dsc);
	}
    }

    if ((line[0]==0x0) &amp;&amp; (length &lt; 2))
	return CDSC_NEEDMORE;	/* Could be Mac Binary EPSF */
    if ((line[0]==0x0) &amp;&amp; (line[1] &gt;= 1) &amp;&amp; (line[1] &lt;= 63) &amp;&amp; (length &lt; 128))
	return CDSC_NEEDMORE;	/* Could be Mac Binary EPSF */
    if ((line[0]==0x0) &amp;&amp; (line[1] == 0x5) &amp;&amp; (length &lt; 4))
	return CDSC_NEEDMORE;	/* Could be Mac AppleSingle/AppleDouble */
    if ((line[0]==0xc5) &amp;&amp; (length &lt; 4))
	return CDSC_NEEDMORE;	/* Could be DOS EPS */

    if ((line[0]==0xc5) &amp;&amp; (line[1]==0xd0) &amp;&amp; 
	 (line[2]==0xd3) &amp;&amp; (line[3]==0xc6) ) {
	/* id is "EPSF" with bit 7 set */
	/* read DOS EPS header, then ignore all bytes until the PS section */
	if (length &lt; 30)
	    return CDSC_NEEDMORE;
	dsc-&gt;line = (char *)line;
	if (dsc_read_doseps(dsc))
	    return CDSC_ERROR;
    }
    else if ((line[0]==0x0) &amp;&amp; (line[1]==0x05) &amp;&amp; 
	 (line[2]==0x16) &amp;&amp; ((line[3]==0x0) || (line[3] == 0x07))) {
	/* Mac AppleSingle or AppleDouble */
	GSDWORD version;
	GSWORD entries;
	if (length &lt; 26)
	    return CDSC_NEEDMORE;
	version = dsc_get_bigendian_dword(line+4);
	entries = dsc_get_bigendian_word(line+24);
	if ((version == 0x00010000) || (version == 0x00020000)) {
	    if (length &lt; (int)(26 + entries * 12))
		return CDSC_NEEDMORE;
	    dsc-&gt;line = (char *)line;
	    if (dsc_read_applesingle(dsc))
		return CDSC_ERROR;
	}
    }
    else if ((line[0]==0x0) &amp;&amp; 
	(line[1] &gt;= 1) &amp;&amp; (line[1] &lt;= 63) &amp;&amp; 
        (line[74]==0x0) &amp;&amp; 
        (line[65]=='E') &amp;&amp; (line[66]=='P') &amp;&amp; 
        (line[67]=='S') &amp;&amp; (line[68]=='F')) {
	/* Mac Binary EPSF */
	dsc-&gt;line = (char *)line;
	if (dsc_read_macbin(dsc))
	    return CDSC_ERROR;
    }
    else {
	if (length &lt; 2)
	    return CDSC_NEEDMORE;
	if ((line[0] == '%') &amp;&amp; (line[1] == 'P')) {
	    if (length &lt; 5)
	        return CDSC_NEEDMORE;
	    if (COMPARE(line, "%PDF-")) {
		dsc-&gt;pdf = TRUE;
		dsc-&gt;scan_section = scan_comments;
		return CDSC_OK;
	    }
	}
    }

    /* Finally process PostScript headers */

    if (dsc_read_line(dsc) &lt;= 0)
	return CDSC_NEEDMORE;
	
    dsc-&gt;dsc_version = dsc_add_line(dsc, dsc-&gt;line, dsc-&gt;line_length);
    if (COMPARE(dsc-&gt;line, "%!PS-Adobe")) {
	dsc-&gt;dsc = TRUE;
	dsc-&gt;begincomments = DSC_START(dsc);
	if (dsc-&gt;dsc_version == NULL)
	    return CDSC_ERROR;	/* no memory */
	p = (unsigned char *)dsc-&gt;line + 14;
	while (IS_WHITE(*p))
	    p++;
	if (COMPARE(p, "EPSF-"))
	    dsc-&gt;epsf = TRUE;
	dsc-&gt;scan_section = scan_comments;
	return CDSC_PSADOBE;
    }
    if (COMPARE(dsc-&gt;line, "%!")) {
	dsc-&gt;scan_section = scan_comments;
	return CDSC_NOTDSC;
    }

    dsc-&gt;scan_section = scan_comments;
    return CDSC_NOTDSC;	/* unrecognised */
}



dsc_private int 
dsc_scan_comments(CDSC *dsc)
{
    /* Comments section ends at */
    /*  %%EndComments */
    /*  another section */
    /*  line that does not start with %% */
    /* Save a few important lines */

    char *line = dsc-&gt;line;
    GSBOOL continued = FALSE;
    dsc-&gt;id = CDSC_OK;
    if (IS_DSC(line, "%%EndComments")) {
	dsc-&gt;id = CDSC_ENDCOMMENTS;
	dsc-&gt;endcomments = DSC_END(dsc);
	dsc-&gt;scan_section = scan_pre_preview;
	return CDSC_OK;
    }
    else if (IS_DSC(line, "%%BeginComments")) {
	/* ignore because we are in this section */
	dsc-&gt;id = CDSC_BEGINCOMMENTS;
    }
    else if (dsc_is_section(line)) {
	dsc-&gt;endcomments = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_preview;
	return CDSC_PROPAGATE;
    }
    else if (line[0] == '%' &amp;&amp; IS_WHITE_OR_EOL(line[1])) {
	dsc-&gt;endcomments = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_preview;
	return CDSC_PROPAGATE;
    }
    else if (line[0] != '%') {
	dsc-&gt;id = CDSC_OK;
	dsc-&gt;endcomments = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_preview;
	return CDSC_PROPAGATE;
    }
    else if (IS_DSC(line, "%%Begin")) {
	dsc-&gt;endcomments = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_preview;
	return CDSC_PROPAGATE;
    }

    /* Handle continuation lines.
     * To simply processing, we assume that contination lines 
     * will only occur if repeat parameters are allowed and that 
     * a complete set of these parameters appears on each line.  
     * This is more restrictive than the DSC specification, but
     * is valid for the DSC comments understood by this parser
     * for all documents that we have seen.
     */
    if (IS_DSC(line, "%%+")) {
	line = dsc-&gt;last_line;
	continued = TRUE;
    }
    else
	dsc_save_line(dsc);

    if (IS_DSC(line, "%%Pages:")) {
	dsc-&gt;id = CDSC_PAGES;
	if (dsc_parse_pages(dsc) != 0)
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%Creator:")) {
	dsc-&gt;id = CDSC_CREATOR;
	dsc-&gt;dsc_creator = dsc_add_line(dsc, dsc-&gt;line+10, dsc-&gt;line_length-10);
	if (dsc-&gt;dsc_creator==NULL)
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%CreationDate:")) {
	dsc-&gt;id = CDSC_CREATIONDATE;
	dsc-&gt;dsc_date = dsc_add_line(dsc, dsc-&gt;line+15, dsc-&gt;line_length-15);
	if (dsc-&gt;dsc_date==NULL)
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%Title:")) {
	dsc-&gt;id = CDSC_TITLE;
	dsc-&gt;dsc_title = dsc_add_line(dsc, dsc-&gt;line+8, dsc-&gt;line_length-8);
	if (dsc-&gt;dsc_title==NULL)
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%For:")) {
	dsc-&gt;id = CDSC_FOR;
	dsc-&gt;dsc_for = dsc_add_line(dsc, dsc-&gt;line+6, dsc-&gt;line_length-6);
	if (dsc-&gt;dsc_for==NULL)
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%LanguageLevel:")) {
	unsigned int n = continued ? 3 : 16;
	unsigned int i;
	int ll;
	dsc-&gt;id = CDSC_LANGUAGELEVEL;
	ll = dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	if (i) {
	    if ( (ll==1) || (ll==2) || (ll==3) )
		dsc-&gt;language_level = ll;
	    else {
		dsc_unknown(dsc);
	    }
	}
	else 
	    dsc_unknown(dsc);
    }
    else if (IS_DSC(line, "%%BoundingBox:")) {
	dsc-&gt;id = CDSC_BOUNDINGBOX;
	if (dsc_parse_bounding_box(dsc, &amp;(dsc-&gt;bbox), continued ? 3 : 14))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%HiResBoundingBox:")) {
	dsc-&gt;id = CDSC_HIRESBOUNDINGBOX;
	if (dsc_parse_float_bounding_box(dsc, &amp;(dsc-&gt;hires_bbox), 
	    continued ? 3 : 19))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%CropBox:")) {
	dsc-&gt;id = CDSC_CROPBOX;
	if (dsc_parse_float_bounding_box(dsc, &amp;(dsc-&gt;crop_box), 
	    continued ? 3 : 10))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%Orientation:")) {
	dsc-&gt;id = CDSC_ORIENTATION;
	if (dsc_parse_orientation(dsc, &amp;(dsc-&gt;page_orientation), 
		continued ? 3 : 14))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%PageOrder:")) {
	dsc-&gt;id = CDSC_PAGEORDER;
	if (dsc_parse_order(dsc))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%DocumentMedia:")) {
	dsc-&gt;id = CDSC_DOCUMENTMEDIA;
	if (dsc_parse_document_media(dsc))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%DocumentPaperSizes:")) {
	/* DSC 2.1 */
	unsigned int n = continued ? 3 : 21;
	unsigned int count = 0;
	unsigned int i = 1;
	char name[MAXSTR];
	char *p;
	dsc-&gt;id = CDSC_DOCUMENTPAPERSIZES;
	while (i &amp;&amp; (dsc-&gt;line[n]!='\r') &amp;&amp; (dsc-&gt;line[n]!='\n')) {
	    p = dsc_copy_string(name, sizeof(name)-1,
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    if (i &amp;&amp; p) {
		const CDSCMEDIA *m = dsc_known_media;
		if (count &gt;= dsc-&gt;media_count) {
		    /* set some default values */
		    CDSCMEDIA lmedia;
		    lmedia.name = p;
		    lmedia.width = 595.0;
		    lmedia.height = 842.0;
		    lmedia.weight = 80.0;
		    lmedia.colour = NULL;
		    lmedia.type = NULL;
		    lmedia.mediabox = NULL;
		    if (dsc_add_media(dsc, &amp;lmedia))
			return CDSC_ERROR;
		}
		else
		    dsc-&gt;media[count]-&gt;name = 
			dsc_alloc_string(dsc, p, (int)strlen(p));
		/* find in list of known media */
		while (m &amp;&amp; m-&gt;name) {
		    if (dsc_stricmp(p, m-&gt;name)==0) {
			dsc-&gt;media[count]-&gt;width = m-&gt;width;
			dsc-&gt;media[count]-&gt;height = m-&gt;height;
			break;
		    }
		    m++;
		}
	    }
	    n+=i;
	    count++;
	}
    }
    else if (IS_DSC(line, "%%DocumentPaperForms:")) {
	/* DSC 2.1 */
	unsigned int n = continued ? 3 : 21;
	unsigned int count = 0;
	unsigned int i = 1;
	char type[MAXSTR];
	char *p;
	dsc-&gt;id = CDSC_DOCUMENTPAPERFORMS;
	while (i &amp;&amp; (dsc-&gt;line[n]!='\r') &amp;&amp; (dsc-&gt;line[n]!='\n')) {
	    p = dsc_copy_string(type, sizeof(type)-1,
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    if (i &amp;&amp; p) {
		if (count &gt;= dsc-&gt;media_count) {
		    /* set some default values */
		    CDSCMEDIA lmedia;
		    lmedia.name = NULL;
		    lmedia.width = 595.0;
		    lmedia.height = 842.0;
		    lmedia.weight = 80.0;
		    lmedia.colour = NULL;
		    lmedia.type = p;
		    lmedia.mediabox = NULL;
		    if (dsc_add_media(dsc, &amp;lmedia))
			return CDSC_ERROR;
		}
		else
		    dsc-&gt;media[count]-&gt;type = 
			dsc_alloc_string(dsc, p, (int)strlen(p));
	    }
	    n+=i;
	    count++;
	}
    }
    else if (IS_DSC(line, "%%DocumentPaperColors:")) {
	/* DSC 2.1 */
	unsigned int n = continued ? 3 : 22;
	unsigned int count = 0;
	unsigned int i = 1;
	char colour[MAXSTR];
	char *p;
	dsc-&gt;id = CDSC_DOCUMENTPAPERCOLORS;
	while (i &amp;&amp; (dsc-&gt;line[n]!='\r') &amp;&amp; (dsc-&gt;line[n]!='\n')) {
	    p = dsc_copy_string(colour, sizeof(colour)-1, 
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    if (i &amp;&amp; p) {
		if (count &gt;= dsc-&gt;media_count) {
		    /* set some default values */
		    CDSCMEDIA lmedia;
		    lmedia.name = NULL;
		    lmedia.width = 595.0;
		    lmedia.height = 842.0;
		    lmedia.weight = 80.0;
		    lmedia.colour = p;
		    lmedia.type = NULL;
		    lmedia.mediabox = NULL;
		    if (dsc_add_media(dsc, &amp;lmedia))
			return CDSC_ERROR;
		}
		else
		    dsc-&gt;media[count]-&gt;colour = 
			dsc_alloc_string(dsc, p, (int)strlen(p));
	    }
	    n+=i;
	    count++;
	}
    }
    else if (IS_DSC(line, "%%DocumentPaperWeights:")) {
	/* DSC 2.1 */
	unsigned int n = continued ? 3 : 23;
	unsigned int count = 0;
	unsigned int i = 1;
	float w;
	dsc-&gt;id = CDSC_DOCUMENTPAPERWEIGHTS;
	while (i &amp;&amp; (dsc-&gt;line[n]!='\r') &amp;&amp; (dsc-&gt;line[n]!='\n')) {
	    w = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    if (i) {
		if (count &gt;= dsc-&gt;media_count) {
		    /* set some default values */
		    CDSCMEDIA lmedia;
		    lmedia.name = NULL;
		    lmedia.width = 595.0;
		    lmedia.height = 842.0;
		    lmedia.weight = w;
		    lmedia.colour = NULL;
		    lmedia.type = NULL;
		    lmedia.mediabox = NULL;
		    if (dsc_add_media(dsc, &amp;lmedia))
			return CDSC_ERROR;
		}
		else
		    dsc-&gt;media[count]-&gt;weight = w;
	    }
	    n+=i;
	    count++;
	}
    }
    else if (IS_DSC(line, "%%DocumentData:")) {
	unsigned int n = continued ? 3 : 15;
	char *p = dsc-&gt;line + n;
        while (IS_WHITE(*p))
	    p++;
	dsc-&gt;id = CDSC_DOCUMENTDATA;
	if (COMPARE(p, "Clean7Bit"))
	    dsc-&gt;document_data = CDSC_CLEAN7BIT;
	else if (COMPARE(p, "Clean8Bit"))
	    dsc-&gt;document_data = CDSC_CLEAN8BIT;
	else if (COMPARE(p, "Binary"))
	    dsc-&gt;document_data = CDSC_BINARY;
	else
	    dsc_unknown(dsc);
    }
    else if (IS_DSC(line, "%%Requirements:")) {
	dsc-&gt;id = CDSC_REQUIREMENTS;
	/* ignore */
    }
    else if (IS_DSC(line, "%%DocumentNeededFonts:")) {
	dsc-&gt;id = CDSC_DOCUMENTNEEDEDFONTS;
	/* ignore */
    }
    else if (IS_DSC(line, "%%DocumentSuppliedFonts:")) {
	dsc-&gt;id = CDSC_DOCUMENTSUPPLIEDFONTS;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PlateFile:")) {
	dsc-&gt;id = CDSC_PLATEFILE;
	if (dsc_parse_platefile(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%CyanPlate:") || 
	IS_DSC(line, "%%MagentaPlate:") || 
	IS_DSC(line, "%%YellowPlate:") ||
	IS_DSC(line, "%%BlackPlate:")) {
	dsc-&gt;id = CDSC_PLATEFILE;
	if (dsc_parse_dcs1plate(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%DocumentProcessColors:")) {
	dsc-&gt;id = CDSC_DOCUMENTPROCESSCOLORS;
	if (dsc_parse_process_colours(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%DocumentCustomColors:")) {
	dsc-&gt;id = CDSC_DOCUMENTCUSTOMCOLORS;
	if (dsc_parse_custom_colours(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%CMYKCustomColor:")) {
	dsc-&gt;id = CDSC_CMYKCUSTOMCOLOR;
	if (dsc_parse_cmyk_custom_colour(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%RGBCustomColor:")) {
	dsc-&gt;id = CDSC_RGBCUSTOMCOLOR;
	if (dsc_parse_rgb_custom_colour(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (dsc-&gt;line[0] == '%' &amp;&amp; IS_WHITE_OR_EOL(dsc-&gt;line[1])) {
	dsc-&gt;id = CDSC_OK;
	/* ignore */
    }
    else {
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	dsc_unknown(dsc);
    }

    dsc-&gt;endcomments = DSC_END(dsc);
    return CDSC_OK;
}


dsc_private int 
dsc_scan_preview(CDSC *dsc)
{
    /* Preview section ends at */
    /*  %%EndPreview */
    /*  another section */
    /* Preview section must start with %%BeginPreview */
    char *line = dsc-&gt;line;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_preview) {
	if (IS_BLANK(line))
	    return CDSC_OK;	/* ignore blank lines before preview */
	else if (IS_DSC(line, "%%BeginPreview")) {
	    dsc-&gt;id = CDSC_BEGINPREVIEW;
	    dsc-&gt;beginpreview = DSC_START(dsc);
	    dsc-&gt;endpreview = DSC_END(dsc);
	    dsc-&gt;scan_section = scan_preview;
	    /* Don't mark the preview as EPSI if a DOS EPS header is present */
	    if (dsc-&gt;preview == CDSC_NOPREVIEW)
		dsc-&gt;preview = CDSC_EPSI;
	    return CDSC_OK;
	}
	else {
	    dsc-&gt;scan_section = scan_pre_defaults;
	    return CDSC_PROPAGATE;
	}
    }

    if (IS_DSC(line, "%%BeginPreview")) {
	/* ignore because we are in this section */
    }
    else if (dsc_is_section(line)) {
	dsc-&gt;endpreview = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_defaults;
	return CDSC_PROPAGATE;
    }
    else if (IS_DSC(line, "%%EndPreview")) {
	dsc-&gt;id = CDSC_ENDPREVIEW;
	dsc-&gt;endpreview = DSC_END(dsc);
	dsc-&gt;scan_section = scan_pre_defaults;
	return CDSC_OK;
    }
    else if (line[0] == '%' &amp;&amp; line[1] != '%') {
	/* Ordinary comments are OK */
    }
    else {
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	/* DSC comments should not occur in preview */
	dsc_unknown(dsc);
    }

    dsc-&gt;endpreview = DSC_END(dsc);
    return CDSC_OK;
}

dsc_private int
dsc_scan_defaults(CDSC *dsc)
{
    /* Defaults section ends at */
    /*  %%EndDefaults */
    /*  another section */
    /* Defaults section must start with %%BeginDefaults */
    char *line = dsc-&gt;line;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_defaults) {
	if (IS_BLANK(line))
	    return CDSC_OK;	/* ignore blank lines before defaults */
	else if (IS_DSC(line, "%%BeginDefaults")) {
	    dsc-&gt;id = CDSC_BEGINDEFAULTS;
	    dsc-&gt;begindefaults = DSC_START(dsc);
	    dsc-&gt;enddefaults = DSC_END(dsc);
	    dsc-&gt;scan_section = scan_defaults;
	    return CDSC_OK;
	}
	else {
	    dsc-&gt;scan_section = scan_pre_prolog;
	    return CDSC_PROPAGATE;
	}
    }

    if (NOT_DSC_LINE(line)) {
	/* ignore */
    }
    else if (IS_DSC(line, "%%BeginPreview")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginDefaults")) {
	/* ignore because we are in this section */
    }
    else if (dsc_is_section(line)) {
	dsc-&gt;enddefaults = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_prolog;
	return CDSC_PROPAGATE;
    }
    else if (IS_DSC(line, "%%EndDefaults")) {
	dsc-&gt;id = CDSC_ENDDEFAULTS;
	dsc-&gt;enddefaults = DSC_END(dsc);
	dsc-&gt;scan_section = scan_pre_prolog;
	return CDSC_OK;
    }
    else if (IS_DSC(line, "%%PageMedia:")) {
	dsc-&gt;id = CDSC_PAGEMEDIA;
	dsc_parse_media(dsc, &amp;dsc-&gt;page_media);
    }
    else if (IS_DSC(line, "%%PageOrientation:")) {
	dsc-&gt;id = CDSC_PAGEORIENTATION;
	/* This can override %%Orientation:  */
	if (dsc_parse_orientation(dsc, &amp;(dsc-&gt;page_orientation), 18))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%PageBoundingBox:")) {
	dsc-&gt;id = CDSC_PAGEBOUNDINGBOX;
	if (dsc_parse_bounding_box(dsc, &amp;(dsc-&gt;page_bbox), 18))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%ViewingOrientation:")) {
	dsc-&gt;id = CDSC_VIEWINGORIENTATION;
	if (dsc_parse_viewing_orientation(dsc, &amp;dsc-&gt;viewing_orientation))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%PageCropBox:")) {
	dsc-&gt;id = CDSC_PAGECROPBOX;
	if (dsc_parse_float_bounding_box(dsc, &amp;dsc-&gt;crop_box, 14))
	    return CDSC_ERROR;
    }
    else {
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	/* All other DSC comments are unknown, but not an error */
	dsc_unknown(dsc);
    }
    dsc-&gt;enddefaults = DSC_END(dsc);
    return CDSC_OK;
}

/* CDSC_RESPONSE_OK and CDSC_RESPONSE_CANCEL mean ignore the 
 * mismatch (default) */
dsc_private int
dsc_check_match_prompt(CDSC *dsc, const char *str, int count)
{
    if (count != 0) {
	char buf[MAXSTR+MAXSTR];
	if (dsc-&gt;line_length &lt; (unsigned int)(sizeof(buf)/2-1))  {
	    strncpy(buf, dsc-&gt;line, dsc-&gt;line_length);
	    buf[dsc-&gt;line_length] = '\0';
	}
	sprintf(buf+strlen(buf), "\n%%%%Begin%.40s: / %%%%End%.40s\n", str, str);
	return dsc_error(dsc, CDSC_MESSAGE_BEGIN_END, buf, (int)strlen(buf));
    }
    return CDSC_RESPONSE_CANCEL;
}

dsc_private int
dsc_check_match_type(CDSC *dsc, const char *str, int count)
{
    if (dsc_check_match_prompt(dsc, str, count) == CDSC_RESPONSE_IGNORE_ALL)
	return CDSC_NOTDSC;
    return CDSC_OK;
}

/* complain if Begin/End blocks didn't match */
/* return non-zero if we should ignore all DSC */
dsc_private int
dsc_check_match(CDSC *dsc)
{
    int rc = 0;
    const char *font = "Font";
    const char *feature = "Feature";
    const char *resource = "Resource";
    const char *procset = "ProcSet";

    if (!rc)
	rc = dsc_check_match_type(dsc, font, dsc-&gt;begin_font_count);
    if (!rc)
	rc = dsc_check_match_type(dsc, feature, dsc-&gt;begin_feature_count);
    if (!rc)
	rc = dsc_check_match_type(dsc, resource, dsc-&gt;begin_resource_count);
    if (!rc)
	rc = dsc_check_match_type(dsc, procset, dsc-&gt;begin_procset_count);

    dsc-&gt;begin_font_count = 0;
    dsc-&gt;begin_feature_count = 0;
    dsc-&gt;begin_resource_count = 0;
    dsc-&gt;begin_procset_count = 0;
    return rc;
}


dsc_private int 
dsc_scan_prolog(CDSC *dsc)
{
    /* Prolog section ends at */
    /*  %%EndProlog */
    /*  another section */
    /* Prolog section may start with %%BeginProlog or non-dsc line */
    char *line = dsc-&gt;line;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_prolog) {
        if (dsc_is_section(line) &amp;&amp; (!IS_DSC(line, "%%BeginProlog"))) {
	    dsc-&gt;scan_section = scan_pre_setup;
	    return CDSC_PROPAGATE;
	}
	dsc-&gt;id = CDSC_BEGINPROLOG;
	dsc-&gt;beginprolog = DSC_START(dsc);
	dsc-&gt;endprolog = DSC_END(dsc);
	dsc-&gt;scan_section = scan_prolog;
	if (IS_DSC(line, "%%BeginProlog"))
	    return CDSC_OK;
    }
   
    if (NOT_DSC_LINE(line)) {
	/* ignore */
    }
    else if (IS_DSC(line, "%%BeginPreview")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginDefaults")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginProlog")) {
	/* ignore because we are in this section */
    }
    else if (dsc_is_section(line)) {
	dsc-&gt;endprolog = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_setup;
	if (dsc_check_match(dsc))
	    return CDSC_NOTDSC;
	return CDSC_PROPAGATE;
    }
    else if (IS_DSC(line, "%%EndProlog")) {
	dsc-&gt;id = CDSC_ENDPROLOG;
	dsc-&gt;endprolog = DSC_END(dsc);
	dsc-&gt;scan_section = scan_pre_setup;
	if (dsc_check_match(dsc))
	    return CDSC_NOTDSC;
	return CDSC_OK;
    }
    else if (IS_DSC(line, "%%BeginFont:")) {
	dsc-&gt;id = CDSC_BEGINFONT;
	/* ignore Begin/EndFont, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_font_count++;
    }
    else if (IS_DSC(line, "%%EndFont")) {
	dsc-&gt;id = CDSC_ENDFONT;
	dsc-&gt;begin_font_count--;
    }
    else if (IS_DSC(line, "%%BeginFeature:")) {
	dsc-&gt;id = CDSC_BEGINFEATURE;
	/* ignore Begin/EndFeature, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_feature_count++;
    }
    else if (IS_DSC(line, "%%EndFeature")) {
	dsc-&gt;id = CDSC_ENDFEATURE;
	dsc-&gt;begin_feature_count--;
    }
    else if (IS_DSC(line, "%%BeginResource:")) {
	dsc-&gt;id = CDSC_BEGINRESOURCE;
	/* ignore Begin/EndResource, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_resource_count++;
    }
    else if (IS_DSC(line, "%%EndResource")) {
	dsc-&gt;id = CDSC_ENDRESOURCE;
	dsc-&gt;begin_resource_count--;
    }
    else if (IS_DSC(line, "%%BeginProcSet:")) {
	dsc-&gt;id = CDSC_BEGINPROCSET;
	/* ignore Begin/EndProcSet, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_procset_count++;
    }
    else if (IS_DSC(line, "%%EndProcSet")) {
	dsc-&gt;id = CDSC_ENDPROCSET;
	dsc-&gt;begin_procset_count--;
    }
    else {
	/* All other DSC comments are unknown, but not an error */
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	dsc_unknown(dsc);
    }

    dsc-&gt;endprolog = DSC_END(dsc);
    return CDSC_OK;
}

dsc_private int
dsc_scan_setup(CDSC *dsc)
{
    /* Setup section ends at */
    /*  %%EndSetup */
    /*  another section */
    /* Setup section must start with %%BeginSetup */

    char *line = dsc-&gt;line;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_setup) {
	if (IS_BLANK(line))
	    return CDSC_OK;	/* ignore blank lines before setup */
	else if (IS_DSC(line, "%%BeginSetup")) {
	    dsc-&gt;id = CDSC_BEGINSETUP;
	    dsc-&gt;beginsetup = DSC_START(dsc);
	    dsc-&gt;endsetup = DSC_END(dsc);
	    dsc-&gt;scan_section = scan_setup;
	    return CDSC_OK;
	}
	else {
	    dsc-&gt;scan_section = scan_pre_pages;
	    return CDSC_PROPAGATE;
	}
    }

    if (NOT_DSC_LINE(line)) {
	/* ignore */
    }
    else if (IS_DSC(line, "%%BeginPreview")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginDefaults")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginProlog")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginSetup")) {
	/* ignore because we are in this section */
    }
    else if (dsc_is_section(line)) {
	dsc-&gt;endsetup = DSC_START(dsc);
	dsc-&gt;scan_section = scan_pre_pages;
	if (dsc_check_match(dsc))
	    return CDSC_NOTDSC;
	return CDSC_PROPAGATE;
    }
    else if (IS_DSC(line, "%%EndSetup")) {
	dsc-&gt;id = CDSC_ENDSETUP;
	dsc-&gt;endsetup = DSC_END(dsc);
	dsc-&gt;scan_section = scan_pre_pages;
	if (dsc_check_match(dsc))
	    return CDSC_NOTDSC;
	return CDSC_OK;
    }
    else if (IS_DSC(line, "%%BeginFeature:")) {
	dsc-&gt;id = CDSC_BEGINFEATURE;
	/* ignore Begin/EndFeature, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_feature_count++;
    }
    else if (IS_DSC(line, "%%EndFeature")) {
	dsc-&gt;id = CDSC_ENDFEATURE;
	dsc-&gt;begin_feature_count--;
    }
    else if (IS_DSC(line, "%%Feature:")) {
	dsc-&gt;id = CDSC_FEATURE;
	/* ignore */
    }
    else if (IS_DSC(line, "%%BeginResource:")) {
	dsc-&gt;id = CDSC_BEGINRESOURCE;
	/* ignore Begin/EndResource, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_resource_count++;
    }
    else if (IS_DSC(line, "%%EndResource")) {
	dsc-&gt;id = CDSC_ENDRESOURCE;
	dsc-&gt;begin_resource_count--;
    }
    else if (IS_DSC(line, "%%PaperColor:")) {
	dsc-&gt;id = CDSC_PAPERCOLOR;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperForm:")) {
	dsc-&gt;id = CDSC_PAPERFORM;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperWeight:")) {
	dsc-&gt;id = CDSC_PAPERWEIGHT;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperSize:")) {
	/* DSC 2.1 */
        GSBOOL found_media = FALSE;
	int i;
	int n = 12;
	char buf[MAXSTR];
	buf[0] = '\0';
	dsc-&gt;id = CDSC_PAPERSIZE;
	dsc_copy_string(buf, sizeof(buf)-1, dsc-&gt;line+n, dsc-&gt;line_length-n, 
		NULL);
 	for (i=0; i&lt;(int)dsc-&gt;media_count; i++) {
	    if (dsc-&gt;media[i] &amp;&amp; dsc-&gt;media[i]-&gt;name &amp;&amp; 
		(dsc_stricmp(buf, dsc-&gt;media[i]-&gt;name)==0)) {
		dsc-&gt;page_media = dsc-&gt;media[i];
		found_media = TRUE;
		break;
	    }
	}
	if (!found_media) {
	    /* It didn't match %%DocumentPaperSizes: */
	    /* Try our known media */
	    const CDSCMEDIA *m = dsc_known_media;
	    while (m-&gt;name) {
		if (dsc_stricmp(buf, m-&gt;name)==0) {
		    dsc-&gt;page_media = m;
		    break;
		}
		m++;
	    }
	    if (m-&gt;name == NULL)
		dsc_unknown(dsc);
	}
    }
    else {
	/* All other DSC comments are unknown, but not an error */
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	dsc_unknown(dsc);
    }

    dsc-&gt;endsetup = DSC_END(dsc);
    return CDSC_OK;
}

dsc_private int 
dsc_scan_page(CDSC *dsc)
{
    /* Page section ends at */
    /*  %%Page */
    /*  %%Trailer */
    /*  %%EOF */
    char *line = dsc-&gt;line;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_pages) {
	if (IS_DSC(line, "%%Page:")) {
	    dsc-&gt;scan_section = scan_pages;
	    /* fall through */
	}
	else  {
	    /* %%Page: didn't follow %%EndSetup
	     * Keep reading until reach %%Page or %%Trailer
	     * and add it to previous section.
	     */
	    DSC_OFFSET *last;
	    if (dsc-&gt;endsetup != 0)
		last = &amp;dsc-&gt;endsetup;
	    else if (dsc-&gt;endprolog != 0)
		last = &amp;dsc-&gt;endprolog;
	    else if (dsc-&gt;enddefaults != 0)
		last = &amp;dsc-&gt;enddefaults;
	    else if (dsc-&gt;endpreview != 0)
		last = &amp;dsc-&gt;endpreview;
	    else if (dsc-&gt;endcomments != 0)
		last = &amp;dsc-&gt;endcomments;
	    else
		last = &amp;dsc-&gt;begincomments;
	    *last = DSC_START(dsc);
	    if (IS_DSC(line, "%%Trailer") || IS_DSC(line, "%%EOF")) {
		dsc-&gt;scan_section = scan_pre_trailer;
		return CDSC_PROPAGATE;
	    }
	    *last = DSC_END(dsc);
	    return CDSC_OK;
	}
    }

    if (NOT_DSC_LINE(line)) {
	/* ignore */
    }
    else if (IS_DSC(line, "%%Page:")) {
	int code;
	dsc-&gt;id = CDSC_PAGE;
	if (dsc-&gt;page_count) {
	    dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_START(dsc);
	    if (dsc_check_match(dsc))
		return CDSC_NOTDSC;
	}

	if ( (code = dsc_parse_page(dsc)) != CDSC_OK)
	    return code;
        if (dsc-&gt;page_count == 0)
	    dsc-&gt;scan_section = scan_pre_pages;
    }
    else if (IS_DSC(line, "%%BeginPreview")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginDefaults")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginProlog")) {
	/* ignore because we have already processed this section */
    }
    else if (IS_DSC(line, "%%BeginSetup")) {
	/* ignore because we have already processed this section */
    }
    else if (dsc_is_section(line)) {
	if (IS_DSC(line, "%%Trailer")) {
	    if (dsc-&gt;page_count)
		dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_START(dsc);
	    if (dsc-&gt;file_length) {
		if ((!dsc-&gt;doseps_end &amp;&amp; 
			((DSC_END(dsc) + 32768) &lt; dsc-&gt;file_length)) ||
		     ((dsc-&gt;doseps_end) &amp;&amp; 
			((DSC_END(dsc) + 32768) &lt; dsc-&gt;doseps_end))) {
		    int rc = dsc_error(dsc, CDSC_MESSAGE_EARLY_TRAILER, 
			dsc-&gt;line, dsc-&gt;line_length);
		    switch (rc) {
			case CDSC_RESPONSE_OK:
			    /* ignore early trailer */
			    break;
			case CDSC_RESPONSE_CANCEL:
			    /* this is the trailer */
			    dsc-&gt;scan_section = scan_pre_trailer;
			    if (dsc_check_match(dsc))
				return CDSC_NOTDSC;
			    return CDSC_PROPAGATE;
			case CDSC_RESPONSE_IGNORE_ALL:
			    return CDSC_NOTDSC;
		    }
		}
		else {
		    dsc-&gt;scan_section = scan_pre_trailer;
		    if (dsc_check_match(dsc))
			return CDSC_NOTDSC;
		    return CDSC_PROPAGATE;
		}
	    }
	    else {
		dsc-&gt;scan_section = scan_pre_trailer;
		if (dsc_check_match(dsc))
		    return CDSC_NOTDSC;
		return CDSC_PROPAGATE;
	    }
	}
	else if (IS_DSC(line, "%%EOF")) {
	    if (dsc-&gt;page_count)
		dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_START(dsc);
	    if (dsc-&gt;file_length) {
		if ((!dsc-&gt;doseps_end &amp;&amp; 
			((DSC_END(dsc) + 100) &lt; dsc-&gt;file_length)) ||
		     ((dsc-&gt;doseps_end) &amp;&amp; 
			((DSC_END(dsc) + 100) &lt; dsc-&gt;doseps_end))) {
		    int rc = dsc_error(dsc, CDSC_MESSAGE_EARLY_EOF, 
			dsc-&gt;line, dsc-&gt;line_length);
		    switch (rc) {
			case CDSC_RESPONSE_OK:
			    /* %%EOF is wrong, ignore it */
			    break;
			case CDSC_RESPONSE_CANCEL:
			    /* %%EOF is correct */
			    dsc-&gt;scan_section = scan_eof;
			    dsc-&gt;eof = TRUE;
			    if (dsc_check_match(dsc))
				return CDSC_NOTDSC;
			    return CDSC_PROPAGATE;
			case CDSC_RESPONSE_IGNORE_ALL:
			    return CDSC_NOTDSC;
		    }
		}
	    }
	    else {
		/* ignore it */
		if (dsc_check_match(dsc))
		    return CDSC_NOTDSC;
		return CDSC_OK;
	    }
	}
	else {
	    /* Section comment, probably from a badly */
	    /* encapsulated EPS file. */
	    int rc = dsc_error(dsc, CDSC_MESSAGE_BAD_SECTION, 
		    dsc-&gt;line, dsc-&gt;line_length);
	    if (rc == CDSC_RESPONSE_IGNORE_ALL)
		return CDSC_NOTDSC;
	}
    }
    else if (IS_DSC(line, "%%PageTrailer")) {
	dsc-&gt;id = CDSC_PAGETRAILER;
	/* ignore */
    }
    else if (IS_DSC(line, "%%BeginPageSetup")) {
	dsc-&gt;id = CDSC_BEGINPAGESETUP;
	/* ignore */
    }
    else if (IS_DSC(line, "%%EndPageSetup")) {
	dsc-&gt;id = CDSC_ENDPAGESETUP;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PageMedia:")) {
	dsc-&gt;id = CDSC_PAGEMEDIA;
	if (dsc-&gt;page_count)
	    dsc_parse_media(dsc, &amp;(dsc-&gt;page[dsc-&gt;page_count-1].media));
    }
    else if (IS_DSC(line, "%%PaperColor:")) {
	dsc-&gt;id = CDSC_PAPERCOLOR;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperForm:")) {
	dsc-&gt;id = CDSC_PAPERFORM;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperWeight:")) {
	dsc-&gt;id = CDSC_PAPERWEIGHT;
	/* ignore */
    }
    else if (IS_DSC(line, "%%PaperSize:")) {
	/* DSC 2.1 */
        GSBOOL found_media = FALSE;
	int i;
	int n = 12;
	char buf[MAXSTR];
	buf[0] = '\0';
	dsc_copy_string(buf, sizeof(buf)-1, dsc-&gt;line+n, 
	    dsc-&gt;line_length-n, NULL);
 	for (i=0; i&lt;(int)dsc-&gt;media_count; i++) {
	    if (dsc-&gt;media[i] &amp;&amp; dsc-&gt;media[i]-&gt;name &amp;&amp; 
		(dsc_stricmp(buf, dsc-&gt;media[i]-&gt;name)==0)) {
		if (dsc-&gt;page_count)
		    dsc-&gt;page[dsc-&gt;page_count-1].media = dsc-&gt;media[i];
		found_media = TRUE;
		break;
	    }
	}
	if (!found_media) {
	    /* It didn't match %%DocumentPaperSizes: */
	    /* Try our known media */
	    const CDSCMEDIA *m = dsc_known_media;
	    while (m-&gt;name) {
		if (dsc_stricmp(buf, m-&gt;name)==0) {
		    if (dsc-&gt;page_count)
			dsc-&gt;page[dsc-&gt;page_count-1].media = m;
		    break;
		}
		m++;
	    }
	    if (m-&gt;name == NULL)
		dsc_unknown(dsc);
	}
    }
    else if (IS_DSC(line, "%%PageOrientation:")) {
	if (dsc-&gt;page_count) {
	    dsc-&gt;id = CDSC_PAGEORIENTATION;
	    if (dsc_parse_orientation(dsc, 
		&amp;(dsc-&gt;page[dsc-&gt;page_count-1].orientation) ,18))
		return CDSC_NOTDSC;
	}
    }
    else if (IS_DSC(line, "%%PageBoundingBox:")) {
	if (dsc-&gt;page_count) {
	    dsc-&gt;id = CDSC_PAGEBOUNDINGBOX;
	    if (dsc_parse_bounding_box(dsc, 
		&amp;dsc-&gt;page[dsc-&gt;page_count-1].bbox, 18))
		return CDSC_NOTDSC;
	}
    }
    else if (IS_DSC(line, "%%ViewingOrientation:")) {
	if (dsc-&gt;page_count) {
	    dsc-&gt;id = CDSC_VIEWINGORIENTATION;
	    if (dsc_parse_viewing_orientation(dsc, 
		&amp;dsc-&gt;page[dsc-&gt;page_count-1].viewing_orientation))
		return CDSC_ERROR;
	}
    }
    else if (IS_DSC(line, "%%PageCropBox:")) {
	if (dsc-&gt;page_count) {
	    dsc-&gt;id = CDSC_PAGECROPBOX;
	    if (dsc_parse_float_bounding_box(dsc, 
		&amp;(dsc-&gt;page[dsc-&gt;page_count-1].crop_box), 14))
		return CDSC_ERROR;
	}
    }
    else if (IS_DSC(line, "%%BeginFont:")) {
	dsc-&gt;id = CDSC_BEGINFONT;
	/* ignore Begin/EndFont, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_font_count++;
    }
    else if (IS_DSC(line, "%%EndFont")) {
	dsc-&gt;id = CDSC_BEGINFONT;
	dsc-&gt;begin_font_count--;
    }
    else if (IS_DSC(line, "%%BeginFeature:")) {
	dsc-&gt;id = CDSC_BEGINFEATURE;
	/* ignore Begin/EndFeature, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_feature_count++;
    }
    else if (IS_DSC(line, "%%EndFeature")) {
	dsc-&gt;id = CDSC_ENDFEATURE;
	dsc-&gt;begin_feature_count--;
    }
    else if (IS_DSC(line, "%%BeginResource:")) {
	dsc-&gt;id = CDSC_BEGINRESOURCE;
	/* ignore Begin/EndResource, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_resource_count++;
    }
    else if (IS_DSC(line, "%%EndResource")) {
	dsc-&gt;id = CDSC_ENDRESOURCE;
	dsc-&gt;begin_resource_count--;
    }
    else if (IS_DSC(line, "%%BeginProcSet:")) {
	dsc-&gt;id = CDSC_BEGINPROCSET;
	/* ignore Begin/EndProcSet, apart form making sure */
	/* that they are matched. */
	dsc-&gt;begin_procset_count++;
    }
    else if (IS_DSC(line, "%%EndProcSet")) {
	dsc-&gt;id = CDSC_ENDPROCSET;
	dsc-&gt;begin_procset_count--;
    }
    else if (IS_DSC(line, "%%IncludeFont:")) {
	dsc-&gt;id = CDSC_INCLUDEFONT;
	/* ignore */
    }
    else {
	/* All other DSC comments are unknown, but not an error */
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	dsc_unknown(dsc);
    }

    if (dsc-&gt;page_count)
	dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_END(dsc);
    return CDSC_OK;
}

/* Valid Trailer comments are
 * %%Trailer
 * %%EOF
 * or the following deferred with (atend)
 * %%BoundingBox:
 * %%DocumentCustomColors:
 * %%DocumentFiles:
 * %%DocumentFonts:
 * %%DocumentNeededFiles:
 * %%DocumentNeededFonts:
 * %%DocumentNeededProcSets:
 * %%DocumentNeededResources:
 * %%DocumentProcSets:
 * %%DocumentProcessColors:
 * %%DocumentSuppliedFiles:
 * %%DocumentSuppliedFonts:
 * %%DocumentSuppliedProcSets: 
 * %%DocumentSuppliedResources: 
 * %%Orientation: 
 * %%Pages: 
 * %%PageOrder: 
 *
 * Our supported subset is
 * %%Trailer
 * %%EOF
 * %%BoundingBox:
 * %%CropBox:
 * %%HiResBoundingBox:
 * %%DocumentCustomColors:
 * %%DocumentProcessColors:
 * %%Orientation: 
 * %%Pages: 
 * %%PageOrder: 
 * In addition to these, we support
 * %%DocumentMedia:
 * 
 * A %%PageTrailer can have the following:
 * %%PageBoundingBox: 
 * %%PageCustomColors: 
 * %%PageFiles: 
 * %%PageFonts: 
 * %%PageOrientation: 
 * %%PageProcessColors: 
 * %%PageResources: 
 */

dsc_private int
dsc_scan_trailer(CDSC *dsc)
{
    /* Trailer section start at */
    /*  %%Trailer */
    /* and ends at */
    /*  %%EOF */
    char *line = dsc-&gt;line;
    GSBOOL continued = FALSE;
    dsc-&gt;id = CDSC_OK;

    if (dsc-&gt;scan_section == scan_pre_trailer) {
	if (IS_DSC(line, "%%Trailer")) {
	    dsc-&gt;id = CDSC_TRAILER;
	    dsc-&gt;begintrailer = DSC_START(dsc);
	    dsc-&gt;endtrailer = DSC_END(dsc);
	    dsc-&gt;scan_section = scan_trailer;
	    return CDSC_OK;
	}
	else if (IS_DSC(line, "%%EOF")) {
	    dsc-&gt;id = CDSC_EOF;
	    dsc-&gt;begintrailer = DSC_START(dsc);
	    dsc-&gt;endtrailer = DSC_END(dsc);
	    dsc-&gt;scan_section = scan_trailer;
	    /* Continue, in case we found %%EOF in an embedded document */
	    return CDSC_OK;
	}
	else {
	    /* %%Page: didn't follow %%EndSetup
	     * Keep reading until reach %%Page or %%Trailer
	     * and add it to setup section
	     */
	    /* append to previous section */
	    if (dsc-&gt;beginsetup)
		dsc-&gt;endsetup = DSC_END(dsc);
	    else if (dsc-&gt;beginprolog)
		dsc-&gt;endprolog = DSC_END(dsc);
	    else {
		/* horribly confused */
	    }
	    return CDSC_OK;
	}
    }

    /* Handle continuation lines.
     * See comment above about our restrictive processing of 
     * continuation lines
     */
    if (IS_DSC(line, "%%+")) {
	line = dsc-&gt;last_line;
	continued = TRUE;
    }
    else
	dsc_save_line(dsc);

    if (NOT_DSC_LINE(line)) {
	/* ignore */
    }
    else if (IS_DSC(dsc-&gt;line, "%%EOF")) {
	/* Keep scanning, in case we have a false trailer */
	dsc-&gt;id = CDSC_EOF;
    }
    else if (IS_DSC(dsc-&gt;line, "%%Trailer")) {
	/* Cope with no pages with code after setup and before trailer. */
	/* Last trailer is the correct one. */
	dsc-&gt;id = CDSC_TRAILER;
	dsc-&gt;begintrailer = DSC_START(dsc);
    }
    else if (IS_DSC(line, "%%Pages:")) {
	dsc-&gt;id = CDSC_PAGES;
	if (dsc_parse_pages(dsc) != 0)
	       return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%BoundingBox:")) {
	dsc-&gt;id = CDSC_BOUNDINGBOX;
	if (dsc_parse_bounding_box(dsc, &amp;(dsc-&gt;bbox), continued ? 3 : 14))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%HiResBoundingBox:")) {
	dsc-&gt;id = CDSC_HIRESBOUNDINGBOX;
	if (dsc_parse_float_bounding_box(dsc, &amp;(dsc-&gt;hires_bbox), 
	    continued ? 3 : 19))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%CropBox:")) {
	dsc-&gt;id = CDSC_CROPBOX;
	if (dsc_parse_float_bounding_box(dsc, &amp;(dsc-&gt;crop_box), 
	    continued ? 3 : 10))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%Orientation:")) {
	dsc-&gt;id = CDSC_ORIENTATION;
	if (dsc_parse_orientation(dsc, &amp;(dsc-&gt;page_orientation), continued ? 3 : 14))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%PageOrder:")) {
	dsc-&gt;id = CDSC_PAGEORDER;
	if (dsc_parse_order(dsc))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(line, "%%DocumentMedia:")) {
	dsc-&gt;id = CDSC_DOCUMENTMEDIA;
	if (dsc_parse_document_media(dsc))
	    return CDSC_ERROR;
    }
    else if (IS_DSC(dsc-&gt;line, "%%Page:")) {
	/* This should not occur in the trailer, but we might see 
	 * this if a document has been incorrectly embedded.
	 */
	int rc = dsc_error(dsc, CDSC_MESSAGE_PAGE_IN_TRAILER, 
		dsc-&gt;line, dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* Assume that we are really in the previous */
		/* page, not the trailer */
		dsc-&gt;scan_section = scan_pre_pages;
		if (dsc-&gt;page_count)
		    dsc-&gt;page[dsc-&gt;page_count-1].end = DSC_START(dsc);
		return CDSC_PROPAGATE;	/* try again */
	    case CDSC_RESPONSE_CANCEL:
		/* ignore pages in trailer */
		break;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }
    else if (IS_DSC(line, "%%DocumentNeededFonts:")) {
	dsc-&gt;id = CDSC_DOCUMENTNEEDEDFONTS;
	/* ignore */
    }
    else if (IS_DSC(line, "%%DocumentSuppliedFonts:")) {
	dsc-&gt;id = CDSC_DOCUMENTSUPPLIEDFONTS;
	/* ignore */
    }
    else if (IS_DSC(line, "%%DocumentProcessColors:")) {
	dsc-&gt;id = CDSC_DOCUMENTPROCESSCOLORS;
	if (dsc_parse_process_colours(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else if (IS_DSC(line, "%%DocumentCustomColors:")) {
	dsc-&gt;id = CDSC_DOCUMENTCUSTOMCOLORS;
	if (dsc_parse_custom_colours(dsc) != CDSC_OK)
	    dsc-&gt;id = CDSC_UNKNOWNDSC;
    }
    else {
	/* All other DSC comments are unknown, but not an error */
	dsc-&gt;id = CDSC_UNKNOWNDSC;
	dsc_unknown(dsc);
    }

    dsc-&gt;endtrailer = DSC_END(dsc);
    return CDSC_OK;
}


dsc_private char *
dsc_alloc_string(CDSC *dsc, const char *str, int len)
{
    char *p;
    if (dsc-&gt;string_head == NULL) {
	dsc-&gt;string_head = (CDSCSTRING *)dsc_memalloc(dsc, sizeof(CDSCSTRING));
	if (dsc-&gt;string_head == NULL)
	    return NULL;	/* no memory */
	dsc-&gt;string = dsc-&gt;string_head;
	dsc-&gt;string-&gt;next = NULL;
	dsc-&gt;string-&gt;data = (char *)dsc_memalloc(dsc, CDSC_STRING_CHUNK);
	if (dsc-&gt;string-&gt;data == NULL) {
	    dsc_reset(dsc);
	    return NULL;	/* no memory */
	}
	dsc-&gt;string-&gt;index = 0;
	dsc-&gt;string-&gt;length = CDSC_STRING_CHUNK;
    }
    if ( dsc-&gt;string-&gt;index + len + 1 &gt; dsc-&gt;string-&gt;length) {
	/* allocate another string block */
	CDSCSTRING *newstring = (CDSCSTRING *)dsc_memalloc(dsc, sizeof(CDSCSTRING));
	if (newstring == NULL) {
	    dsc_debug_print(dsc, "Out of memory\n");
	    return NULL;
	}
        newstring-&gt;next = NULL;
	newstring-&gt;length = 0;
	newstring-&gt;index = 0;
	newstring-&gt;data = (char *)dsc_memalloc(dsc, CDSC_STRING_CHUNK);
	if (newstring-&gt;data == NULL) {
	    dsc_memfree(dsc, newstring);
	    dsc_debug_print(dsc, "Out of memory\n");
	    return NULL;	/* no memory */
	}
	newstring-&gt;length = CDSC_STRING_CHUNK;
	dsc-&gt;string-&gt;next = newstring;
	dsc-&gt;string = newstring;
    }
    if ( dsc-&gt;string-&gt;index + len + 1 &gt; dsc-&gt;string-&gt;length)
	return NULL;	/* failed */
    p = dsc-&gt;string-&gt;data + dsc-&gt;string-&gt;index;
    memcpy(p, str, len);
    *(p+len) = '\0';
    dsc-&gt;string-&gt;index += len + 1;
    return p;
}

/* store line, ignoring leading spaces */
dsc_private char *
dsc_add_line(CDSC *dsc, const char *line, unsigned int len)
{
    char *newline;
    unsigned int i;
    while (len &amp;&amp; (IS_WHITE(*line))) {
	len--;
	line++;
    }
    newline = dsc_alloc_string(dsc, line, len);
    if (newline == NULL)
	return NULL;

    for (i=0; i&lt;len; i++) {
	if (newline[i] == '\r') {
	    newline[i]='\0';
	    break;
	}
	if (newline[i] == '\n') {
	    newline[i]='\0';
	    break;
	}
    }
    return newline;
}


/* Copy string on line to new allocated string str */
/* String is always null terminated */
/* String is no longer than len */
/* Return pointer to string  */
/* Store number of used characters from line */
/* Don't copy enclosing () */
dsc_private char *
dsc_copy_string(char *str, unsigned int slen, char *line, 
	unsigned int len, unsigned int *offset)
{
    int quoted = FALSE;
    int instring=0;
    unsigned int newlength = 0;
    unsigned int i = 0;
    unsigned char ch;
    if (len &gt; slen)
	len = slen-1;
    while ( (i&lt;len) &amp;&amp; IS_WHITE(line[i]))
	i++;	/* skip leading spaces */
    if ((i &lt; len) &amp;&amp; (line[i]=='(')) {
	quoted = TRUE;
	instring++;
	i++; /* don't copy outside () */
    }
    while (i &lt; len) {
	str[newlength] = ch = line[i];
	i++;
	if (quoted) {
	    if (ch == '(')
		    instring++;
	    if (ch == ')')
		    instring--;
	    if (instring==0)
		    break;
	}
	else if (ch == ' ')
	    break;

	if (ch == '\r')
	    break;
	if (ch == '\n')
	    break;
	else if ( (ch == '\\') &amp;&amp; (i+1 &lt; len) ) {
	    ch = line[i];
	    if ((ch &gt;= '0') &amp;&amp; (ch &lt;= '9')) {
		/* octal coded character */
		int j = 3;
		ch = 0;
		while (j &amp;&amp; (i &lt; len) &amp;&amp; line[i]&gt;='0' &amp;&amp; line[i]&lt;='7') {
		    ch = (unsigned char)((ch&lt;&lt;3) + (line[i]-'0'));
		    i++;
		    j--;
		}
		str[newlength] = ch;
	    }
	    else if (ch == '(') {
		str[newlength] = ch;
		i++;
	    }
	    else if (ch == ')') {
		str[newlength] = ch;
		i++;
	    }
	    else if (ch == 'b') {
		str[newlength] = '\b';
		i++;
	    }
	    else if (ch == 'f') {
		str[newlength] = '\b';
		i++;
	    }
	    else if (ch == 'n') {
		str[newlength] = '\n';
		i++;
	    }
	    else if (ch == 'r') {
		str[newlength] = '\r';
		i++;
	    }
	    else if (ch == 't') {
		str[newlength] = '\t';
		i++;
	    }
	    else if (ch == '\\') {
		str[newlength] = '\\';
		i++;
	    }
	}
	newlength++;
    }
    str[newlength] = '\0';
    if (offset != (unsigned int *)NULL)
        *offset = i;
    return str;
}

dsc_private int 
dsc_get_int(const char *line, unsigned int len, unsigned int *offset)
{
    char newline[MAXSTR];
    int newlength = 0;
    unsigned int i = 0;
    unsigned char ch;

    len = min(len, sizeof(newline)-1);
    while ((i&lt;len) &amp;&amp; IS_WHITE(line[i]))
	i++;	/* skip leading spaces */
    while (i &lt; len) {
	newline[newlength] = ch = line[i];
	if (!(isdigit(ch) || (ch=='-') || (ch=='+')))
	    break;  /* not part of an integer number */
	i++;
	newlength++;
    }
    while ((i&lt;len) &amp;&amp; IS_WHITE(line[i]))
	i++;	/* skip trailing spaces */
    newline[newlength] = '\0';
    if (offset != (unsigned int *)NULL)
        *offset = i;
    return atoi(newline);
}

dsc_private float 
dsc_get_real(const char *line, unsigned int len, unsigned int *offset)
{
    char newline[MAXSTR];
    int newlength = 0;
    unsigned int i = 0;
    unsigned char ch;

    len = min(len, sizeof(newline)-1);
    while ((i&lt;len) &amp;&amp; IS_WHITE(line[i]))
	i++;	/* skip leading spaces */
    while (i &lt; len) {
	newline[newlength] = ch = line[i];
	if (!(isdigit(ch) || (ch=='.') || (ch=='-') || (ch=='+') 
	    || (ch=='e') || (ch=='E')))
	    break;  /* not part of a real number */
	i++;
	newlength++;
    }
    while ((i&lt;len) &amp;&amp; IS_WHITE(line[i]))
	i++;	/* skip trailing spaces */

    newline[newlength] = '\0';

    if (offset != (unsigned int *)NULL)
        *offset = i;
    return (float)atof(newline);
}

int
dsc_stricmp(const char *s, const char *t)
{
    while (toupper(*s) == toupper(*t)) {
	if (*s == '\0')
	    return 0;
   	s++;
	t++; 
    }
    return (toupper(*s) - toupper(*t));
}


dsc_private int
dsc_parse_page(CDSC *dsc)
{
    char *p;
    unsigned int i;
    char page_label[MAXSTR];
    char *pl;
    int page_ordinal;
    int page_number;

    p = dsc-&gt;line + 7;
    pl = dsc_copy_string(page_label, sizeof(page_label), p, dsc-&gt;line_length-7, &amp;i);
    if (pl == NULL)
	return CDSC_ERROR;
    p += i;
    if (dsc-&gt;line_length - 7 - i == 0) {
	/* Ordinal missing, or parentheses not matched in label */
	/* Try to find ordinal at end of line */
	while (i &gt; 0) {
	    if (!IS_WHITE_OR_EOL(p[-1])) 
		break;
	    p--;
	    i--;
	}
	while (i &gt; 0) {
	    if (!isdigit((int)p[-1]))
		break;
	    p--;
	    i--;
	}
    }
    page_ordinal = dsc_get_int(p, dsc-&gt;line_length - 7 - i, NULL);

    if ( (page_ordinal == 0) || (strlen(page_label) == 0) ||
       (dsc-&gt;page_count &amp;&amp; 
	    (page_ordinal != dsc-&gt;page[dsc-&gt;page_count-1].ordinal+1)) ) {
	int rc = dsc_error(dsc, CDSC_MESSAGE_PAGE_ORDINAL, dsc-&gt;line, 
		dsc-&gt;line_length);
	switch (rc) {
	    case CDSC_RESPONSE_OK:
		/* ignore this page */
		return CDSC_OK;
	    case CDSC_RESPONSE_CANCEL:
		/* accept the page */
		break;
	    case CDSC_RESPONSE_IGNORE_ALL:
		return CDSC_NOTDSC;
	}
    }

    page_number = dsc-&gt;page_count;
    dsc_add_page(dsc, page_ordinal, page_label);
    dsc-&gt;page[page_number].begin = DSC_START(dsc);
    dsc-&gt;page[page_number].end = DSC_START(dsc);

    if (dsc-&gt;page[page_number].label == NULL)
	return CDSC_ERROR;	/* no memory */
	
    return CDSC_OK;
}



/* DSC error reporting */

void 
dsc_debug_print(CDSC *dsc, const char *str)
{
    if (dsc-&gt;debug_print_fn)
	dsc-&gt;debug_print_fn(dsc-&gt;caller_data, str);
}


/* Display a message about a problem with the DSC comments.
 * 
 * explanation = an index to to a multiline explanation in dsc_message[]
 * line = pointer to the offending DSC line (if any)
 * return code = 
 *   CDSC_RESPONSE_OK 	       DSC was wrong, make a guess about what 
 *                             was really meant.
 *   CDSC_RESPONSE_CANCEL      Assume DSC was correct, ignore if it 
 *                             is misplaced.
 *   CDSC_RESPONSE_IGNORE_ALL  Ignore all DSC.
 */
/* Silent operation.  Don't display errors. */
dsc_private int 
dsc_error(CDSC *dsc, unsigned int explanation, 
	char *line, unsigned int line_len)
{
    /* if error function provided, use it */
    if (dsc-&gt;dsc_error_fn)
	return dsc-&gt;dsc_error_fn(dsc-&gt;caller_data, dsc, 
	    explanation, line, line_len);

    /* treat DSC as being correct */
    return CDSC_RESPONSE_CANCEL;
}


/* Fixup if DCS 2.0 was used */
dsc_private int
dsc_dcs2_fixup(CDSC *dsc)
{
    char composite[] = "Composite";
    /* If DCS 2.0 single file format found, expose the separations
     * as multiple pages.  Treat the initial EPS file as a single
     * page without comments, prolog or trailer.
     */
    if (dsc-&gt;dcs2) {
	int code = CDSC_OK;
	int page_number;
	DSC_OFFSET *pbegin;
	DSC_OFFSET *pend;
        DSC_OFFSET end;
	CDCS2 *pdcs = dsc-&gt;dcs2;
	/* Now treat the initial EPS file as a single page without
	 * headers or trailer, so page extraction will fetch the
	 * the correct separation. */
	if (dsc-&gt;page_count == 0)
	    code = dsc_add_page(dsc, 1, composite);
	else if (dsc-&gt;page_count == 1)
	    dsc-&gt;page[0].label = 
		dsc_alloc_string(dsc, composite, (int)strlen(composite)+1);
	if (code != CDSC_OK)
	    return code; 
	page_number = dsc-&gt;page_count - 1;
	pbegin = &amp;dsc-&gt;page[page_number].begin;
	pend = &amp;dsc-&gt;page[page_number].end;
	if (*pbegin == *pend) {
	    /* no page, so force it to conform to the following sections */
	    *pbegin = 999999999;
	    *pend = 0;
	}

	if (dsc-&gt;begincomments != dsc-&gt;endcomments) {
	    *pbegin = min(dsc-&gt;begincomments, *pbegin);
	    dsc-&gt;begincomments = 0;
	    *pend = max(dsc-&gt;endcomments, *pend);
	    dsc-&gt;endcomments = 0;
	}

	if (dsc-&gt;beginpreview != dsc-&gt;endpreview) {
	    *pbegin = min(dsc-&gt;beginpreview, *pbegin);
	    dsc-&gt;beginpreview = 0;
	    *pend = max(dsc-&gt;endpreview, *pend);
	    dsc-&gt;endpreview = 0;
	}

	if (dsc-&gt;begindefaults != dsc-&gt;enddefaults) {
	    *pbegin = min(dsc-&gt;begindefaults, *pbegin);
	    dsc-&gt;begindefaults = 0;
	    *pend = max(dsc-&gt;enddefaults, *pend);
	    dsc-&gt;enddefaults = 0;
	}

	if (dsc-&gt;beginprolog != dsc-&gt;endprolog) {
	    *pbegin = min(dsc-&gt;beginprolog, *pbegin);
	    dsc-&gt;beginprolog = 0;
	    *pend = max(dsc-&gt;endprolog, *pend);
	    dsc-&gt;endprolog = 0;
	}

	if (dsc-&gt;beginsetup != dsc-&gt;endsetup) {
	    *pbegin = min(dsc-&gt;beginsetup, *pbegin);
	    dsc-&gt;beginsetup = 0;
	    *pend = max(dsc-&gt;endsetup, *pend);
	    dsc-&gt;endsetup = 0;
	}
	
	if (dsc-&gt;begintrailer != dsc-&gt;endtrailer) {
	    *pbegin = min(dsc-&gt;begintrailer, *pbegin);
	    dsc-&gt;begintrailer = 0;
	    *pend = max(dsc-&gt;endtrailer, *pend);
	    dsc-&gt;endtrailer = 0;
	}

	if (*pbegin == 999999999)
	    *pbegin = *pend;
	end = 0;	/* end of composite is start of first separation */
	
	while (pdcs) {
    	    page_number = dsc-&gt;page_count;
	    if ((pdcs-&gt;begin) &amp;&amp; (pdcs-&gt;colourname != NULL)) {
		/* Single file DCS 2.0 */
		code = dsc_add_page(dsc, page_number+1, pdcs-&gt;colourname);
		if (code)
		    return code;
		dsc-&gt;page[page_number].begin = pdcs-&gt;begin;
		dsc-&gt;page[page_number].end = pdcs-&gt;end;
		if (end != 0)
		    end = min(end, pdcs-&gt;begin);
		else
		    end = pdcs-&gt;begin;		/* first separation  */
	    }
	    else {
		/* Multiple file DCS 2.0 */
		if ((pdcs-&gt;location != NULL) &amp;&amp; 
		    (pdcs-&gt;filetype != NULL) &amp;&amp;
		    (pdcs-&gt;colourname != NULL) &amp;&amp;
		    (dsc_stricmp(pdcs-&gt;location, "Local") == 0) &amp;&amp;
		    ((dsc_stricmp(pdcs-&gt;filetype, "EPS") == 0) ||
		     (dsc_stricmp(pdcs-&gt;filetype, "EPSF") == 0))) {
		    code = dsc_add_page(dsc, page_number+1, pdcs-&gt;colourname);
		    if (code)
			return code;
		    dsc-&gt;page[page_number].begin = 0;
		    dsc-&gt;page[page_number].end = 0;
		}
	    }
	    pdcs = pdcs-&gt;next;
	}
	/* end of composite is start of first separation */
	if (end != 0)
	    *pend = end;
	/* According to the DCS2 specification, the size of the composite 
	 * section can be determined by the smallest #offset.
	 * Some incorrect DCS2 files don't put the separations inside
	 * the DOS EPS PostScript section, and have a TIFF separation
	 * between the composite and the first separation.  This
	 * contravenes the DCS2 specification.  If we see one of these 
 	 * files, bring the end of the composite back to the end of 
	 * the DOS EPS PostScript section.
	 */
	if (dsc-&gt;doseps_end &amp;&amp; (*pend &gt; dsc-&gt;doseps_end))
	    *pend = dsc-&gt;doseps_end;
    }
    return 0;
}


dsc_private int
dsc_parse_platefile(CDSC *dsc)
{
    unsigned int i, n;
    CDCS2 dcs2;
    CDCS2 *pdcs2;
    char colourname[MAXSTR];
    char filetype[MAXSTR];
    char location[MAXSTR];
    char *filename = NULL;
    int filename_length = 0;
    GSBOOL blank_line;
    GSBOOL single = FALSE;
    if (IS_DSC(dsc-&gt;line, "%%PlateFile:"))
	n = 12;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    memset(&amp;dcs2, 0, sizeof(dcs2));
    memset(&amp;colourname, 0, sizeof(colourname));
    memset(&amp;filetype, 0, sizeof(filetype));
    memset(&amp;location, 0, sizeof(location));
    memset(&amp;filename, 0, sizeof(filename));

    /* check for blank remainder of line */
    blank_line = TRUE;
    for (i=n; i&lt;dsc-&gt;line_length; i++) {
	if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
	    blank_line = FALSE;
	    break;
	}
    }

    if (!blank_line) {
	dsc_copy_string(colourname, sizeof(colourname),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	if (i)
	    dsc_copy_string(filetype, sizeof(filetype),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	n+=i;
	while (IS_WHITE_OR_EOL(dsc-&gt;line[n]))
	    n++;
	if (dsc-&gt;line[n] == '#') {
	    /* single file DCS 2.0 */
	    single = TRUE;
	    n++;
	    if (i)
		dcs2.begin= dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i)
		dcs2.end= dcs2.begin + 
		    dsc_get_int(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	}
	else {
	    /* multiple file DCS 2.0 */
	    if (i)
		dsc_copy_string(location, sizeof(location),
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i) {
		filename = dsc-&gt;line+n;
		filename_length = dsc-&gt;line_length-n;
	    }
	}
	if (i==0)
	    dsc_unknown(dsc); /* we didn't get all fields */
	else {
	    /* Allocate strings */
	    if (strlen(colourname))
		dcs2.colourname = dsc_alloc_string(dsc, 
		    colourname, (int)strlen(colourname));
	    if (strlen(filetype))
		dcs2.filetype = dsc_alloc_string(dsc, 
		    filetype, (int)strlen(filetype));
	    if (strlen(location))
		dcs2.location = dsc_alloc_string(dsc, 
		    location, (int)strlen(location));
	    if (filename)
		dcs2.filename = dsc_add_line(dsc, filename, filename_length);

	    /* Prevent parser from reading separations */
	    if (single)
	        dsc-&gt;file_length = min(dsc-&gt;file_length, dcs2.begin);
	    /* Allocate it */
	    pdcs2 = (CDCS2 *)dsc_memalloc(dsc, sizeof(CDCS2));
	    if (pdcs2 == NULL)
		return CDSC_ERROR;	/* out of memory */
	    memcpy(pdcs2, &amp;dcs2, sizeof(CDCS2));
	    /* Then add to list of separations */
	    if (dsc-&gt;dcs2 == NULL)
		dsc-&gt;dcs2 = pdcs2;
	    else {
		CDCS2 *this_dcs2 = dsc-&gt;dcs2;
		while (this_dcs2-&gt;next)
		    this_dcs2 = this_dcs2-&gt;next;
		this_dcs2-&gt;next = pdcs2;
	    }
	}
    }
    return CDSC_OK;
}

/* Parse a DCS 1.0 plate comment, storing like a multi file DSC 2.0 */
dsc_private int
dsc_parse_dcs1plate(CDSC *dsc)
{
    unsigned int i, n = 0;
    CDCS2 dcs2;
    CDCS2 *pdcs2;
    const char *colourname;
    char filename[MAXSTR];
    GSBOOL blank_line;
    GSBOOL continued = FALSE;
    char *line = dsc-&gt;line;

    memset(&amp;dcs2, 0, sizeof(dcs2));
    memset(&amp;filename, 0, sizeof(filename));

    if (IS_DSC(line, "%%+")) {
	n = 3;
	line = dsc-&gt;last_line;
	continued = TRUE;
    }

    if (IS_DSC(line, "%%CyanPlate:")) {
	colourname = "Cyan";
	if (!continued)
	    n = 12;
    }
    else if (IS_DSC(line, "%%MagentaPlate:")) {
	colourname = "Magenta";
	if (!continued)
	    n = 15;
    }
    else if (IS_DSC(line, "%%YellowPlate:")) {
	colourname = "Yellow";
	if (!continued)
	    n = 14;
    }
    else if (IS_DSC(line, "%%BlackPlate:")) {
	colourname = "Black";
	if (!continued)
	    n = 13;
    }
    else
	return CDSC_ERROR;	/* error */

    /* check for blank remainder of line */
    blank_line = TRUE;
    for (i=n; i&lt;dsc-&gt;line_length; i++) {
	if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
	    blank_line = FALSE;
	    break;
	}
    }

    if (!blank_line) {
	dsc_copy_string(filename, sizeof(filename),
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	if (i==0)
	    dsc_unknown(dsc); /* we didn't get all fields */
	else {
	    /* Allocate strings */
	    dcs2.colourname = dsc_alloc_string(dsc, 
		    colourname, (int)strlen(colourname));
	    dcs2.filetype = dsc_alloc_string(dsc, "EPS", 3);
	    dcs2.location = dsc_alloc_string(dsc, "Local", 5);
	    if (strlen(filename))
		dcs2.filename = dsc_alloc_string(dsc, 
		    filename, (int)strlen(filename));
	    /* Allocate it */
	    pdcs2 = (CDCS2 *)dsc_memalloc(dsc, sizeof(CDCS2));
	    if (pdcs2 == NULL)
		return CDSC_ERROR;	/* out of memory */
	    memcpy(pdcs2, &amp;dcs2, sizeof(CDCS2));
	    /* Then add to list of separations */
	    if (dsc-&gt;dcs2 == NULL)
		dsc-&gt;dcs2 = pdcs2;
	    else {
		CDCS2 *this_dcs2 = dsc-&gt;dcs2;
		while (this_dcs2-&gt;next)
		    this_dcs2 = this_dcs2-&gt;next;
		this_dcs2-&gt;next = pdcs2;
	    }
	}
    }
    return CDSC_OK;
}


/* Find the filename which corresponds to this separation.
 * Used with multiple file DCS 2.0.
 * Returns NULL if there is no filename, or not DCS 2.0,
 * or single file DCS 2.0.
 * Caller will need to obtain the filesize from the file.
 */
const char *
dsc_find_platefile(CDSC *dsc, int page)
{
    CDCS2 *pdcs = dsc-&gt;dcs2;
    int i = 1;
    while (pdcs) {
	if (pdcs-&gt;begin != pdcs-&gt;end)
	    return NULL;	/* Single file DCS 2.0 */
	if (pdcs-&gt;location &amp;&amp; pdcs-&gt;filetype &amp;&amp; pdcs-&gt;colourname
	    &amp;&amp; (dsc_stricmp(pdcs-&gt;location, "Local") == 0)
	    &amp;&amp; ((dsc_stricmp(pdcs-&gt;filetype, "EPS") == 0) ||
	        (dsc_stricmp(pdcs-&gt;filetype, "EPSF") == 0))) {
	    if (i == page)
		return pdcs-&gt;filename;
	    i++;
	}
	pdcs = pdcs-&gt;next;
    }
    return NULL;
}


dsc_private CDSCCOLOUR *
dsc_find_colour(CDSC *dsc, const char *colourname)
{
    CDSCCOLOUR *colour = dsc-&gt;colours;
    while (colour) {
	if (colour-&gt;name &amp;&amp; (dsc_stricmp(colour-&gt;name, colourname)==0))
	    return colour;
	colour = colour-&gt;next;
    }
    return 0;
}

dsc_private int
dsc_parse_process_colours(CDSC *dsc)
{
    unsigned int i, n;
    CDSCCOLOUR *pcolour;
    char colourname[MAXSTR];
    GSBOOL blank_line;
    if (IS_DSC(dsc-&gt;line, "%%DocumentProcessColors:"))
	n = 24;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    memset(&amp;colourname, 0, sizeof(colourname));

    /* check for blank remainder of line */
    blank_line = TRUE;
    for (i=n; i&lt;dsc-&gt;line_length; i++) {
	if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
	    blank_line = FALSE;
	    break;
	}
    }
    while (IS_WHITE(dsc-&gt;line[n]))
	n++;
    if (COMPARE(dsc-&gt;line+n, "(atend)")) {
	if (dsc-&gt;scan_section == scan_comments)
	    blank_line = TRUE;
	else {
	    dsc_unknown(dsc);
	    return CDSC_NOTDSC;
	}
    }

    if (!blank_line) {
	do {
	    dsc_copy_string(colourname, sizeof(colourname),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i &amp;&amp; strlen(colourname)) {
		if ((pcolour = dsc_find_colour(dsc, colourname)) == NULL) {
		    pcolour = (CDSCCOLOUR *)
			dsc_memalloc(dsc, sizeof(CDSCCOLOUR));
		    if (pcolour == NULL)
			return CDSC_ERROR;	/* out of memory */
		    memset(pcolour, 0, sizeof(CDSCCOLOUR));
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_UNKNOWN;
		    pcolour-&gt;name = dsc_alloc_string(dsc, 
			colourname, (int)strlen(colourname));
		    if (dsc-&gt;colours == NULL)
			dsc-&gt;colours = pcolour;
		    else {
			CDSCCOLOUR *this_colour = dsc-&gt;colours;
			while (this_colour-&gt;next)
			    this_colour = this_colour-&gt;next;
			this_colour-&gt;next = pcolour;
		    }
		}
	        pcolour-&gt;type = CDSC_COLOUR_PROCESS;
		if (dsc_stricmp(colourname, "Cyan")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_CMYK;
		    pcolour-&gt;cyan = 1.0;
		    pcolour-&gt;magenta = pcolour-&gt;yellow = pcolour-&gt;black = 0.0;
		}
		else if (dsc_stricmp(colourname, "Magenta")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_CMYK;
		    pcolour-&gt;magenta = 1.0;
		    pcolour-&gt;cyan = pcolour-&gt;yellow = pcolour-&gt;black = 0.0;
		}
		else if (dsc_stricmp(colourname, "Yellow")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_CMYK;
		    pcolour-&gt;yellow = 1.0;
		    pcolour-&gt;cyan = pcolour-&gt;magenta = pcolour-&gt;black = 0.0;
		}
		else if (dsc_stricmp(colourname, "Black")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_CMYK;
		    pcolour-&gt;black = 1.0;
		    pcolour-&gt;cyan = pcolour-&gt;magenta = pcolour-&gt;yellow = 0.0;
		}
		else if (dsc_stricmp(colourname, "Red")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_RGB;
		    pcolour-&gt;red = 1.0;
		    pcolour-&gt;green = pcolour-&gt;blue = 0.0;
		}
		else if (dsc_stricmp(colourname, "Green")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_RGB;
		    pcolour-&gt;green = 1.0;
		    pcolour-&gt;red = pcolour-&gt;blue = 0.0;
		}
		else if (dsc_stricmp(colourname, "Blue")==0) {
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_RGB;
		    pcolour-&gt;blue = 1.0;
		    pcolour-&gt;red = pcolour-&gt;green = 0.0;
		}
	    }
	} while (i != 0);
    }
    return CDSC_OK;
}

dsc_private int
dsc_parse_custom_colours(CDSC *dsc)
{
    unsigned int i, n;
    CDSCCOLOUR *pcolour;
    char colourname[MAXSTR];
    GSBOOL blank_line;
    if (IS_DSC(dsc-&gt;line, "%%DocumentCustomColors:"))
	n = 23;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    memset(&amp;colourname, 0, sizeof(colourname));

    /* check for blank remainder of line */
    blank_line = TRUE;
    for (i=n; i&lt;dsc-&gt;line_length; i++) {
	if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
	    blank_line = FALSE;
	    break;
	}
    }
    while (IS_WHITE(dsc-&gt;line[n]))
	n++;
    if (COMPARE(dsc-&gt;line+n, "(atend)")) {
	if (dsc-&gt;scan_section == scan_comments)
	    blank_line = TRUE;
	else {
	    dsc_unknown(dsc);
	    return CDSC_NOTDSC;
	}
    }

    if (!blank_line) {
	do {
	    dsc_copy_string(colourname, sizeof(colourname),
		dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i &amp;&amp; strlen(colourname)) {
		if ((pcolour = dsc_find_colour(dsc, colourname)) == NULL) {
		    pcolour = (CDSCCOLOUR *)
			dsc_memalloc(dsc, sizeof(CDSCCOLOUR));
		    if (pcolour == NULL)
			return CDSC_ERROR;	/* out of memory */
		    memset(pcolour, 0, sizeof(CDSCCOLOUR));
		    pcolour-&gt;name = dsc_alloc_string(dsc, 
			colourname, (int)strlen(colourname));
		    pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_UNKNOWN;
		    if (dsc-&gt;colours == NULL)
			dsc-&gt;colours = pcolour;
		    else {
			CDSCCOLOUR *this_colour = dsc-&gt;colours;
			while (this_colour-&gt;next)
			    this_colour = this_colour-&gt;next;
			this_colour-&gt;next = pcolour;
		    }
		}
                pcolour-&gt;type = CDSC_COLOUR_CUSTOM;
	    }
	} while (i != 0);
    }
    return CDSC_OK;
}


dsc_private int
dsc_parse_cmyk_custom_colour(CDSC *dsc)
{
    unsigned int i, n;
    CDSCCOLOUR *pcolour;
    char colourname[MAXSTR];
    float cyan, magenta, yellow, black;
    GSBOOL blank_line;
    if (IS_DSC(dsc-&gt;line, "%%CMYKCustomColor:"))
	n = 18;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    memset(&amp;colourname, 0, sizeof(colourname));

    /* check for blank remainder of line */

    do {
	blank_line = TRUE;
	for (i=n; i&lt;dsc-&gt;line_length; i++) {
	    if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
		blank_line = FALSE;
		break;
	    }
	}
	if (blank_line)
	    break;
	else {
	    cyan = magenta = yellow = black = 0.0;
	    cyan = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		magenta = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		yellow = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		black = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		dsc_copy_string(colourname, sizeof(colourname),
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i &amp;&amp; strlen(colourname)) {
		if ((pcolour = dsc_find_colour(dsc, colourname)) == NULL) {
		    pcolour = (CDSCCOLOUR *)
			dsc_memalloc(dsc, sizeof(CDSCCOLOUR));
		    if (pcolour == NULL)
			return CDSC_ERROR;	/* out of memory */
		    memset(pcolour, 0, sizeof(CDSCCOLOUR));
		    pcolour-&gt;name = dsc_alloc_string(dsc, 
			colourname, (int)strlen(colourname));
	            pcolour-&gt;type = CDSC_COLOUR_UNKNOWN;
		    if (dsc-&gt;colours == NULL)
			dsc-&gt;colours = pcolour;
		    else {
			CDSCCOLOUR *this_colour = dsc-&gt;colours;
			while (this_colour-&gt;next)
			    this_colour = this_colour-&gt;next;
			this_colour-&gt;next = pcolour;
		    }
		}
		pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_CMYK;
		pcolour-&gt;cyan = cyan;
		pcolour-&gt;magenta = magenta;
		pcolour-&gt;yellow = yellow;
		pcolour-&gt;black = black;
	    }
	}
    } while (i != 0);
    return CDSC_OK;
}

dsc_private int
dsc_parse_rgb_custom_colour(CDSC *dsc)
{
    unsigned int i, n;
    CDSCCOLOUR *pcolour;
    char colourname[MAXSTR];
    float red, green, blue;
    GSBOOL blank_line;
    if (IS_DSC(dsc-&gt;line, "%%RGBCustomColor:"))
	n = 17;
    else if (IS_DSC(dsc-&gt;line, "%%+"))
	n = 3;
    else
	return CDSC_ERROR;	/* error */

    memset(&amp;colourname, 0, sizeof(colourname));

    /* check for blank remainder of line */

    do {
	blank_line = TRUE;
	for (i=n; i&lt;dsc-&gt;line_length; i++) {
	    if (!IS_WHITE_OR_EOL(dsc-&gt;line[i])) {
		blank_line = FALSE;
		break;
	    }
	}
	if (blank_line)
	    break;
	else {
	    red = green = blue = 0.0;
	    red = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		green = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		blue = dsc_get_real(dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n += i;
	    if (i)
		dsc_copy_string(colourname, sizeof(colourname),
		    dsc-&gt;line+n, dsc-&gt;line_length-n, &amp;i);
	    n+=i;
	    if (i &amp;&amp; strlen(colourname)) {
		if ((pcolour = dsc_find_colour(dsc, colourname)) == NULL) {
		    pcolour = (CDSCCOLOUR *)
			dsc_memalloc(dsc, sizeof(CDSCCOLOUR));
		    if (pcolour == NULL)
			return CDSC_ERROR;	/* out of memory */
		    memset(pcolour, 0, sizeof(CDSCCOLOUR));
		    pcolour-&gt;name = dsc_alloc_string(dsc, 
			colourname, (int)strlen(colourname));
	            pcolour-&gt;type = CDSC_COLOUR_UNKNOWN;
		    if (dsc-&gt;colours == NULL)
			dsc-&gt;colours = pcolour;
		    else {
			CDSCCOLOUR *this_colour = dsc-&gt;colours;
			while (this_colour-&gt;next)
			    this_colour = this_colour-&gt;next;
			this_colour-&gt;next = pcolour;
		    }
		}
		pcolour-&gt;custom = CDSC_CUSTOM_COLOUR_RGB;
		pcolour-&gt;red = red;
		pcolour-&gt;green = green;
		pcolour-&gt;blue = blue;
	    }
	}
    } while (i != 0);
    return CDSC_OK;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

