<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevpsf2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevpsf2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1999, 2000, 2001 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevpsf2.c,v 1.33 2004/11/19 04:39:11 ray Exp $ */
/* Write an embedded CFF font with either Type 1 or Type 2 CharStrings */
#include "math_.h"		/* for fabs */
#include "memory_.h"
#include "gx.h"
#include "gxarith.h"
#include "gscencs.h"
#include "gserrors.h"
#include "gsccode.h"
#include "gscrypt1.h"
#include "gsmatrix.h"
#include "gsutil.h"
#include "gxfixed.h"
#include "gxfont.h"
#include "gxfont1.h"
#include "gxfcid.h"
#include "stream.h"
#include "sfilter.h"
#include "gdevpsf.h"

/* Define additional opcodes used in Dicts, but not in CharStrings. */
#define CD_LONGINT 29
#define CD_REAL 30

/* Define the count of standard strings. */
#define NUM_STD_STRINGS 391

/* Define whether or not to skip writing an empty Subrs Index. */
#define SKIP_EMPTY_SUBRS

/* Define the structure for the string table. */
typedef struct cff_string_item_s {
    gs_const_string key;
    int index1;		/* index + 1, 0 means empty */
} cff_string_item_t;
typedef struct cff_string_table_s {
    cff_string_item_t *items;
    int count;
    int size;
    uint total;
    int reprobe;
} cff_string_table_t;

/* Define the state of the CFF writer. */
typedef struct cff_writer_s {
    int options;
    stream *strm;
    gs_font_base *pfont;	/* type1 or cid0 */
    glyph_data_proc_t glyph_data;
    int offset_size;
    long start_pos;
    cff_string_table_t std_strings;
    cff_string_table_t strings;
    gs_int_rect FontBBox;
} cff_writer_t;
typedef struct cff_glyph_subset_s {
    psf_outline_glyphs_t glyphs;
    int num_encoded;		/* glyphs.subset_data[1..num_e] are encoded */
    int num_encoded_chars;	/* Encoding has num_e_chars defined entries */
} cff_glyph_subset_t;

/* ---------------- Output utilities ---------------- */

/* ------ String tables ------ */

/* Initialize a string table. */
private void
cff_string_table_init(cff_string_table_t *pcst, cff_string_item_t *items,
		      int size)
{
    int reprobe = 17;

    memset(items, 0, size * sizeof(*items));
    pcst-&gt;items = items;
    pcst-&gt;count = 0;
    pcst-&gt;size = size;
    while (reprobe != 1 &amp;&amp; igcd(size, reprobe) != 1)
	reprobe = (reprobe * 2 + 1) % size;
    pcst-&gt;total = 0;
    pcst-&gt;reprobe = reprobe;
}

/* Add a string to a string table. */
private int
cff_string_add(cff_string_table_t *pcst, const byte *data, uint size)
{
    int index;

    if (pcst-&gt;count &gt;= pcst-&gt;size)
	return_error(gs_error_limitcheck);
    index = pcst-&gt;count++;
    pcst-&gt;items[index].key.data = data;
    pcst-&gt;items[index].key.size = size;
    pcst-&gt;total += size;
    return index;
}

/* Look up a string, optionally adding it. */
/* Return 1 if the string was added. */
private int
cff_string_index(cff_string_table_t *pcst, const byte *data, uint size,
		 bool enter, int *pindex)
{
    /****** FAILS IF TABLE FULL AND KEY MISSING ******/
    int j = (size == 0 ? 0 : data[0] * 23 + data[size - 1] * 59 + size);
    int index, c = 0;

    while ((index = pcst-&gt;items[j %= pcst-&gt;size].index1) != 0) {
	--index;
	if (!bytes_compare(pcst-&gt;items[index].key.data,
			   pcst-&gt;items[index].key.size, data, size)) {
	    *pindex = index;
	    return 0;
	}
	j += pcst-&gt;reprobe;
	if (++c &gt;= pcst-&gt;size)
	    break;
    }
    if (!enter)
	return_error(gs_error_undefined);
    index = cff_string_add(pcst, data, size);
    if (index &lt; 0)
	return index;
    pcst-&gt;items[j].index1 = index + 1;
    *pindex = index;
    return 1;
}

/* Get the SID for a string or a glyph. */
private int
cff_string_sid(cff_writer_t *pcw, const byte *data, uint size)
{
    int index;
    int code = cff_string_index(&amp;pcw-&gt;std_strings, data, size, false, &amp;index);

    if (code &lt; 0) {
	code = cff_string_index(&amp;pcw-&gt;strings, data, size, true, &amp;index);
	if (code &lt; 0)
	    return code;
	index += NUM_STD_STRINGS;
    }
    return index;
}
private int
cff_glyph_sid(cff_writer_t *pcw, gs_glyph glyph)
{
    gs_const_string str;
    int code =
	pcw-&gt;pfont-&gt;procs.glyph_name((gs_font *)pcw-&gt;pfont, glyph, &amp;str);

    if (code &lt; 0)
	return code;
    return cff_string_sid(pcw, str.data, str.size);
}

/* ------ Low level ------ */

private void
put_card16(cff_writer_t *pcw, uint c16)
{
    sputc(pcw-&gt;strm, (byte)(c16 &gt;&gt; 8));
    sputc(pcw-&gt;strm, (byte)c16);
}
private int
offset_size(uint offset)
{
    int size = 1;

    while (offset &gt; 255)
	offset &gt;&gt;= 8, ++size;
    return size;
}
private void
put_offset(cff_writer_t *pcw, int offset)
{
    int i;

    for (i = pcw-&gt;offset_size - 1; i &gt;= 0; --i)
	sputc(pcw-&gt;strm, (byte)(offset &gt;&gt; (i * 8)));
}
private int
put_bytes(stream * s, const byte *ptr, uint count)
{
    uint used;

    sputs(s, ptr, count, &amp;used);
    return (int)used;
}
private int
check_ioerror(stream * s)
{
    uint used;

    return sputs(s, (byte *)&amp;used, 0, &amp;used);
}

/* ------ Data types ------ */

#define CE_OFFSET 32
private void
cff_put_op(cff_writer_t *pcw, int op)
{
    if (op &gt;= CE_OFFSET) {
	sputc(pcw-&gt;strm, cx_escape);
	sputc(pcw-&gt;strm, (byte)(op - CE_OFFSET));
    } else
	sputc(pcw-&gt;strm, (byte)op);
}
private void
cff_put_int(cff_writer_t *pcw, int i)
{
    stream *s = pcw-&gt;strm;

    if (i &gt;= -107 &amp;&amp; i &lt;= 107)
	sputc(s, (byte)(i + 139));
    else if (i &lt;= 1131 &amp;&amp; i &gt;= 0)
	put_card16(pcw, (c_pos2_0 &lt;&lt; 8) + i - 108);
    else if (i &gt;= -1131 &amp;&amp; i &lt; 0)
	put_card16(pcw, (c_neg2_0 &lt;&lt; 8) - i - 108);
    else if (i &gt;= -32768 &amp;&amp; i &lt;= 32767) {
	sputc(s, c2_shortint);
	put_card16(pcw, i &amp; 0xffff);
    } else {
	sputc(s, CD_LONGINT);
	put_card16(pcw, i &gt;&gt; 16);
	put_card16(pcw, i &amp; 0xffff);
    }
}
private void
cff_put_int_value(cff_writer_t *pcw, int i, int op)
{
    cff_put_int(pcw, i);
    cff_put_op(pcw, op);
}
private void
cff_put_int_if_ne(cff_writer_t *pcw, int i, int i_default, int op)
{
    if (i != i_default)
	cff_put_int_value(pcw, i, op);
}
private void
cff_put_bool(cff_writer_t *pcw, bool b)
{
    cff_put_int(pcw, (b ? 1 : 0));
}
private void
cff_put_bool_value(cff_writer_t *pcw, bool b, int op)
{
    cff_put_bool(pcw, b);
    cff_put_op(pcw, op);
}
private void
cff_put_real(cff_writer_t *pcw, floatp f)
{
    if (f == (int)f)
	cff_put_int(pcw, (int)f);
    else {
	/* Use decimal representation. */
	char str[50];
	byte b = 0xff;
	const char *p;

	sprintf(str, "%g", f);
	sputc(pcw-&gt;strm, CD_REAL);
	for (p = str; ; ++p) {
	    int digit;

	    switch (*p) {
	    case 0:
		goto done;
	    case '.':
		digit = 0xa; break;
	    case '-':
		digit = 0xe; break;
	    case 'e': case 'E':
		if (p[1] == '-')
		    digit = 0xc, ++p;
		else
		    digit = 0xb;
		break;
	    case '0': case '1': case '2': case '3': case '4':
	    case '5': case '6': case '7': case '8': case '9':
		digit = *p - '0';
		break;
	    default:		/* can't happen */
		digit = 0xd;	/* invalid */
		break;
	    }
	    if (b == 0xff)
		b = (digit &lt;&lt; 4) + 0xf;
	    else {
		sputc(pcw-&gt;strm, (byte)((b &amp; 0xf0) + digit));
		b = 0xff;
	    }
	}
    done:
	sputc(pcw-&gt;strm, b);
    }
}
private void
cff_put_real_value(cff_writer_t *pcw, floatp f, int op)
{
    cff_put_real(pcw, f);
    cff_put_op(pcw, op);
}
private void
cff_put_real_if_ne(cff_writer_t *pcw, floatp f, floatp f_default, int op)
{
    if ((float)f != (float)f_default)
	cff_put_real_value(pcw, f, op);
}
private void
cff_put_real_deltarray(cff_writer_t *pcw, const float *pf, int count, int op)
{
    float prev = 0;
    int i;

    if (count &lt;= 0)
	return;
    for (i = 0; i &lt; count; ++i) {
	float f = pf[i];

	cff_put_real(pcw, f - prev);
	prev = f;
    }
    cff_put_op(pcw, op);
}
private int
cff_put_string(cff_writer_t *pcw, const byte *data, uint size)
{
    int sid = cff_string_sid(pcw, data, size);

    if (sid &lt; 0)
	return sid;
    cff_put_int(pcw, sid);
    return 0;
}
private int
cff_put_string_value(cff_writer_t *pcw, const byte *data, uint size, int op)
{
    int code = cff_put_string(pcw, data, size);

    if (code &gt;= 0)
	cff_put_op(pcw, op);
    return code;
}
private int
cff_extra_lenIV(const cff_writer_t *pcw, const gs_font_type1 *pfont)
{
    return (pcw-&gt;options &amp; WRITE_TYPE2_NO_LENIV ?
	    max(pfont-&gt;data.lenIV, 0) : 0);
}
private bool
cff_convert_charstrings(const cff_writer_t *pcw, const gs_font_base *pfont)
{
    return (pfont-&gt;FontType != ft_encrypted2 &amp;&amp;
	    (pcw-&gt;options &amp; WRITE_TYPE2_CHARSTRINGS) != 0);
}
private int
cff_put_CharString(cff_writer_t *pcw, const byte *data, uint size,
		   gs_font_type1 *pfont)
{
    int lenIV = pfont-&gt;data.lenIV;
    stream *s = pcw-&gt;strm;

    if (cff_convert_charstrings(pcw, (gs_font_base *)pfont)) {
	gs_glyph_data_t gdata;
	int code;

	gdata.memory = pfont-&gt;memory;
	gs_glyph_data_from_string(&amp;gdata, data, size, NULL);
	code = psf_convert_type1_to_type2(s, &amp;gdata, pfont);
	if (code &lt; 0)
	    return code;
    } else if (lenIV &lt; 0 || !(pcw-&gt;options &amp; WRITE_TYPE2_NO_LENIV))
	put_bytes(s, data, size);
    else if (size &gt;= lenIV) {
	/* Remove encryption. */
	crypt_state state = crypt_charstring_seed;
	byte buf[50];		/* arbitrary */
	uint left, n;

	for (left = lenIV; left &gt; 0; left -= n) {
	    n = min(left, sizeof(buf));
	    gs_type1_decrypt(buf, data + lenIV - left, n, &amp;state);
	}
	for (left = size - lenIV; left &gt; 0; left -= n) {
	    n = min(left, sizeof(buf));
	    gs_type1_decrypt(buf, data + size - left, n, &amp;state);
	    put_bytes(s, buf, n);
	}
    }
    return 0;
}
private uint
cff_Index_size(uint count, uint total)
{
    return (count == 0 ? 2 :
	    3 + offset_size(total + 1) * (count + 1) + total);
}
private void
cff_put_Index_header(cff_writer_t *pcw, uint count, uint total)
{
    put_card16(pcw, count);
    if (count &gt; 0) {
	pcw-&gt;offset_size = offset_size(total + 1);
	sputc(pcw-&gt;strm, (byte)pcw-&gt;offset_size);
	put_offset(pcw, 1);
    }
}
private void
cff_put_Index(cff_writer_t *pcw, const cff_string_table_t *pcst)
{
    uint j, offset;

    if (pcst-&gt;count == 0) {
	put_card16(pcw, 0);
	return;
    }
    cff_put_Index_header(pcw, pcst-&gt;count, pcst-&gt;total);
    for (j = 0, offset = 1; j &lt; pcst-&gt;count; ++j) {
	offset += pcst-&gt;items[j].key.size;
	put_offset(pcw, offset);
    }
    for (j = 0; j &lt; pcst-&gt;count; ++j)
	put_bytes(pcw-&gt;strm, pcst-&gt;items[j].key.data, pcst-&gt;items[j].key.size);
}

/* ---------------- Main code ---------------- */

/* ------ Header ------ */

/* Write the header, setting offset_size. */
private int
cff_write_header(cff_writer_t *pcw, uint end_offset)
{
    pcw-&gt;offset_size = (end_offset &gt; 0x7fff ? 3 : 2);
    put_bytes(pcw-&gt;strm, (const byte *)"\001\000\004", 3);
    sputc(pcw-&gt;strm, (byte)pcw-&gt;offset_size);
    return 0;
}

/* ------ Top Dict ------ */

/*
 * There are 3 variants of this: Type 1 / Type 2 font, CIDFontType 0
 * CIDFont, and FDArray entry for CIDFont.
 */

typedef enum {
    TOP_version = 0,
    TOP_Notice = 1,
    TOP_FullName = 2,
    TOP_FamilyName = 3,
    TOP_Weight = 4,
    TOP_FontBBox = 5,
    TOP_UniqueID = 13,
    TOP_XUID = 14,
    TOP_charset = 15,		/* (offset or predefined index) */
#define charset_ISOAdobe 0
#define charset_Expert 1
#define charset_ExpertSubset 2
#define charset_DEFAULT 0
    TOP_Encoding = 16,		/* (offset or predefined index) */
#define Encoding_Standard 0
#define Encoding_Expert 1
#define Encoding_DEFAULT 0
    TOP_CharStrings = 17,	/* (offset) */
    TOP_Private = 18,		/* (offset) */
    TOP_Copyright = 32,
    TOP_isFixedPitch = 33,
#define isFixedPitch_DEFAULT false
    TOP_ItalicAngle = 34,
#define ItalicAngle_DEFAULT 0
    TOP_UnderlinePosition = 35,
#define UnderlinePosition_DEFAULT (-100)
    TOP_UnderlineThickness = 36,
#define UnderlineThickness_DEFAULT 50
    TOP_PaintType = 37,
#define PaintType_DEFAULT 0
    TOP_CharstringType = 38,
#define CharstringType_DEFAULT 2
    TOP_FontMatrix = 39,	/* default is [0.001 0 0 0.001 0 0] */
    TOP_StrokeWidth = 40,
#define StrokeWidth_DEFAULT 0
    TOP_ROS = 62,
    TOP_CIDFontVersion = 63,
#define CIDFontVersion_DEFAULT 0
    TOP_CIDFontRevision = 64,
#define CIDFontRevision_DEFAULT 0
    TOP_CIDFontType = 65,
#define CIDFontType_DEFAULT 0
    TOP_CIDCount = 66,
#define CIDCount_DEFAULT 8720
    TOP_UIDBase = 67,
    TOP_FDArray = 68,		/* (offset) */
    TOP_FDSelect = 69,		/* (offset) */
    TOP_FontName = 70		/* only used in FDArray "fonts" */
} Top_op;

private int
cff_get_Top_info_common(cff_writer_t *pcw, gs_font_base *pbfont,
			bool full_info, gs_font_info_t *pinfo)
{
    pinfo-&gt;Flags_requested = FONT_IS_FIXED_WIDTH;
    /* Preset defaults */
    pinfo-&gt;members = 0;
    pinfo-&gt;Flags = pinfo-&gt;Flags_returned = 0;
    pinfo-&gt;ItalicAngle = ItalicAngle_DEFAULT;
    pinfo-&gt;UnderlinePosition = UnderlinePosition_DEFAULT;
    pinfo-&gt;UnderlineThickness = UnderlineThickness_DEFAULT;
    return pbfont-&gt;procs.font_info
	((gs_font *)pbfont, NULL,
	 (full_info ?
	  FONT_INFO_FLAGS | FONT_INFO_ITALIC_ANGLE |
	    FONT_INFO_UNDERLINE_POSITION |
	    FONT_INFO_UNDERLINE_THICKNESS : 0) |
	 (FONT_INFO_COPYRIGHT | FONT_INFO_NOTICE |
	  FONT_INFO_FAMILY_NAME | FONT_INFO_FULL_NAME),
	 pinfo);
}
private void
cff_write_Top_common(cff_writer_t *pcw, gs_font_base *pbfont,
		     bool write_FontMatrix, const gs_font_info_t *pinfo)
{
    /*
     * The Adobe documentation doesn't make it at all clear that if the
     * FontMatrix is missing (defaulted) in a CFF CIDFont, all of the
     * FontMatrices of the subfonts in FDArray are multiplied by 1000.
     * (This is documented for ordinary CIDFonts, but not for CFF CIDFonts.)
     * Because of this, the FontMatrix for a CFF CIDFont must be written
     * even if if is the default.  write_FontMatrix controls this.
     */
    /* (version) */
    if (pinfo-&gt;members &amp; FONT_INFO_NOTICE)
	cff_put_string_value(pcw, pinfo-&gt;Notice.data, pinfo-&gt;Notice.size,
			     TOP_Notice);
    if (pinfo-&gt;members &amp; FONT_INFO_FULL_NAME)
	cff_put_string_value(pcw, pinfo-&gt;FullName.data, pinfo-&gt;FullName.size,
			     TOP_FullName);
    if (pinfo-&gt;members &amp; FONT_INFO_FAMILY_NAME)
	cff_put_string_value(pcw, pinfo-&gt;FamilyName.data,
			     pinfo-&gt;FamilyName.size, TOP_FamilyName);
    if (pcw-&gt;FontBBox.p.x != 0 || pcw-&gt;FontBBox.p.y != 0 ||
 	pcw-&gt;FontBBox.q.x != 0 || pcw-&gt;FontBBox.q.y != 0
  	) {
  	/* An omitted FontBBox is equivalent to an empty one. */
 	/*
 	 * Since Acrobat Reader 4 on Solaris doesn't like 
 	 * an omitted FontBBox, we copy it here from
 	 * the font descriptor, because the base font
 	 * is allowed to omit it's FontBBox.
 	 */
 	cff_put_real(pcw, pcw-&gt;FontBBox.p.x);
 	cff_put_real(pcw, pcw-&gt;FontBBox.p.y);
 	cff_put_real(pcw, pcw-&gt;FontBBox.q.x);
 	cff_put_real(pcw, pcw-&gt;FontBBox.q.y);
  	cff_put_op(pcw, TOP_FontBBox);
      }
    if (uid_is_UniqueID(&amp;pbfont-&gt;UID))
	cff_put_int_value(pcw, pbfont-&gt;UID.id, TOP_UniqueID);
    else if (uid_is_XUID(&amp;pbfont-&gt;UID)) {
	int j;

	for (j = 0; j &lt; uid_XUID_size(&amp;pbfont-&gt;UID); ++j)
	    cff_put_int(pcw, uid_XUID_values(&amp;pbfont-&gt;UID)[j]);
	cff_put_op(pcw, TOP_XUID);
    }
    /*
     * Acrobat Reader 3 gives an error if a CFF font includes any of the
     * following opcodes.
     */
    if (!(pcw-&gt;options &amp; WRITE_TYPE2_AR3)) {
	if (pinfo-&gt;members &amp; FONT_INFO_COPYRIGHT)
	    cff_put_string_value(pcw, pinfo-&gt;Copyright.data,
				 pinfo-&gt;Copyright.size, TOP_Copyright);
	if (pinfo-&gt;Flags &amp; pinfo-&gt;Flags_returned &amp; FONT_IS_FIXED_WIDTH)
	    cff_put_bool_value(pcw, true, TOP_isFixedPitch);
	cff_put_real_if_ne(pcw, pinfo-&gt;ItalicAngle, ItalicAngle_DEFAULT,
			   TOP_ItalicAngle);
	cff_put_int_if_ne(pcw, pinfo-&gt;UnderlinePosition,
			  UnderlinePosition_DEFAULT, TOP_UnderlinePosition);
	cff_put_int_if_ne(pcw, pinfo-&gt;UnderlineThickness,
			  UnderlineThickness_DEFAULT, TOP_UnderlineThickness);
	cff_put_int_if_ne(pcw, pbfont-&gt;PaintType, PaintType_DEFAULT,
			  TOP_PaintType);
    }
    {
	static const gs_matrix fm_default = {
	    constant_matrix_body(0.001, 0, 0, 0.001, 0, 0)
	};

	if (write_FontMatrix ||
	    pbfont-&gt;FontMatrix.xx != fm_default.xx ||
	    pbfont-&gt;FontMatrix.xy != 0 || pbfont-&gt;FontMatrix.yx != 0 ||
	    pbfont-&gt;FontMatrix.yy != fm_default.yy ||
	    pbfont-&gt;FontMatrix.tx != 0 || pbfont-&gt;FontMatrix.ty != 0
	    ) {
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.xx);
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.xy);
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.yx);
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.yy);
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.tx);
	    cff_put_real(pcw, pbfont-&gt;FontMatrix.ty);
	    cff_put_op(pcw, TOP_FontMatrix);
	}
    }
    cff_put_real_if_ne(pcw, pbfont-&gt;StrokeWidth, StrokeWidth_DEFAULT,
		       TOP_StrokeWidth);
}

/* Type 1 or Type 2 font */
private void
cff_write_Top_font(cff_writer_t *pcw, uint Encoding_offset,
		   uint charset_offset, uint CharStrings_offset,
		   uint Private_offset, uint Private_size)
{
    gs_font_base *pbfont = (gs_font_base *)pcw-&gt;pfont;
    gs_font_info_t info;

    cff_get_Top_info_common(pcw, pbfont, true, &amp;info);
    cff_write_Top_common(pcw, pbfont, false, &amp;info);
    cff_put_int(pcw, Private_size);
    cff_put_int_value(pcw, Private_offset, TOP_Private);
    cff_put_int_value(pcw, CharStrings_offset, TOP_CharStrings);
    cff_put_int_if_ne(pcw, charset_offset, charset_DEFAULT, TOP_charset);
    cff_put_int_if_ne(pcw, Encoding_offset, Encoding_DEFAULT, TOP_Encoding);
    {
	int type = (pcw-&gt;options &amp; WRITE_TYPE2_CHARSTRINGS ? 2 :
		    pbfont-&gt;FontType == ft_encrypted2 ? 2 : 1);

	cff_put_int_if_ne(pcw, type, CharstringType_DEFAULT,
			  TOP_CharstringType);
    }
}

/* CIDFontType 0 CIDFont */
private void
cff_write_ROS(cff_writer_t *pcw, const gs_cid_system_info_t *pcidsi)
{
    cff_put_string(pcw, pcidsi-&gt;Registry.data, pcidsi-&gt;Registry.size);
    cff_put_string(pcw, pcidsi-&gt;Ordering.data, pcidsi-&gt;Ordering.size);
    cff_put_int_value(pcw, pcidsi-&gt;Supplement, TOP_ROS);
}
private void
cff_write_Top_cidfont(cff_writer_t *pcw, uint charset_offset,
		      uint CharStrings_offset, uint FDSelect_offset,
		      uint Font_offset, const gs_font_info_t *pinfo)
{
    gs_font_base *pbfont = (gs_font_base *)pcw-&gt;pfont;
    gs_font_cid0 *pfont = (gs_font_cid0 *)pbfont;

    cff_write_ROS(pcw, &amp;pfont-&gt;cidata.common.CIDSystemInfo);
    cff_write_Top_common(pcw, pbfont, true, pinfo); /* full_info = true */
    cff_put_int_if_ne(pcw, charset_offset, charset_DEFAULT, TOP_charset);
    cff_put_int_value(pcw, CharStrings_offset, TOP_CharStrings);
    /*
     * CIDFontVersion and CIDFontRevision aren't used consistently,
     * so we don't currently write them.  CIDFontType is always 0.
     */
    cff_put_int_if_ne(pcw, pfont-&gt;cidata.common.CIDCount, CIDCount_DEFAULT,
		      TOP_CIDCount);
    /* We don't use UIDBase. */
    cff_put_int_value(pcw, Font_offset, TOP_FDArray);
    cff_put_int_value(pcw, FDSelect_offset, TOP_FDSelect);
}

/* FDArray Index for CIDFont (offsets only) */
private void
cff_write_FDArray_offsets(cff_writer_t *pcw, uint *FDArray_offsets,
			  int num_fonts)
{
    int j;

    cff_put_Index_header(pcw, num_fonts,
			 FDArray_offsets[num_fonts] - FDArray_offsets[0]);
    for (j = 1; j &lt;= num_fonts; ++j)
	put_offset(pcw, FDArray_offsets[j] - FDArray_offsets[0] + 1);
}

/* FDArray entry for CIDFont */
private void
cff_write_Top_fdarray(cff_writer_t *pcw, gs_font_base *pbfont,
		      uint Private_offset, uint Private_size)
{
    const gs_font_name *pfname = &amp;pbfont-&gt;font_name;
    gs_font_info_t info;

    cff_get_Top_info_common(pcw, pbfont, false, &amp;info);
    cff_write_Top_common(pcw, pbfont, false, &amp;info);
    cff_put_int(pcw, Private_size);
    cff_put_int_value(pcw, Private_offset, TOP_Private);
    if (pfname-&gt;size == 0)
	pfname = &amp;pbfont-&gt;key_name;
    if (pfname-&gt;size) {
	cff_put_string(pcw, pfname-&gt;chars, pfname-&gt;size);
	cff_put_op(pcw, TOP_FontName);
    }
}

/* ------ Private Dict ------ */

/* Defaults are noted in comments. */
typedef enum {
    PRIVATE_BlueValues = 6,	/* (deltarray) */
    PRIVATE_OtherBlues = 7,	/* (deltarray) */
    PRIVATE_FamilyBlues = 8,	/* (deltarray) */
    PRIVATE_FamilyOtherBlues = 9, /* (deltarray) */
    PRIVATE_StdHW = 10,
    PRIVATE_StdVW = 11,
    PRIVATE_Subrs = 19,		/* (offset, relative to Private Dict) */
    PRIVATE_defaultWidthX = 20,
#define defaultWidthX_DEFAULT fixed_0
    PRIVATE_nominalWidthX = 21,
#define nominalWidthX_DEFAULT fixed_0
    PRIVATE_BlueScale = 41,
#define BlueScale_DEFAULT 0.039625
    PRIVATE_BlueShift = 42,
#define BlueShift_DEFAULT 7
    PRIVATE_BlueFuzz = 43,
#define BlueFuzz_DEFAULT 1
    PRIVATE_StemSnapH = 44,	/* (deltarray) */
    PRIVATE_StemSnapV = 45,	/* (deltarray) */
    PRIVATE_ForceBold = 46,
#define ForceBold_DEFAULT false
    PRIVATE_ForceBoldThreshold = 47,
#define ForceBoldThreshold_DEFAULT 0
    PRIVATE_lenIV = 48,
#define lenIV_DEFAULT (-1)
    PRIVATE_LanguageGroup = 49,
#define LanguageGroup_DEFAULT 0
    PRIVATE_ExpansionFactor = 50,
#define ExpansionFactor_DEFAULT 0.06
    PRIVATE_initialRandomSeed = 51
#define initialRandomSeed_DEFAULT 0
} Private_op;

private void
cff_write_Private(cff_writer_t *pcw, uint Subrs_offset,
		  const gs_font_type1 *pfont)
{
#define PUT_FLOAT_TABLE(member, op)\
    cff_put_real_deltarray(pcw, pfont-&gt;data.member.values,\
			   pfont-&gt;data.member.count, op)
				
    PUT_FLOAT_TABLE(BlueValues, PRIVATE_BlueValues);
    PUT_FLOAT_TABLE(OtherBlues, PRIVATE_OtherBlues);
    PUT_FLOAT_TABLE(FamilyBlues, PRIVATE_FamilyBlues);
    PUT_FLOAT_TABLE(FamilyOtherBlues, PRIVATE_FamilyOtherBlues);
    if (pfont-&gt;data.StdHW.count &gt; 0)
	cff_put_real_value(pcw, pfont-&gt;data.StdHW.values[0], PRIVATE_StdHW);
    if (pfont-&gt;data.StdVW.count &gt; 0)
	cff_put_real_value(pcw, pfont-&gt;data.StdVW.values[0], PRIVATE_StdVW);
    if (Subrs_offset)
	cff_put_int_value(pcw, Subrs_offset, PRIVATE_Subrs);
    if (pfont-&gt;FontType != ft_encrypted) {
	if (pfont-&gt;data.defaultWidthX != defaultWidthX_DEFAULT)
	    cff_put_real_value(pcw, fixed2float(pfont-&gt;data.defaultWidthX),
			       PRIVATE_defaultWidthX);
	if (pfont-&gt;data.nominalWidthX != nominalWidthX_DEFAULT)
	    cff_put_real_value(pcw, fixed2float(pfont-&gt;data.nominalWidthX),
			       PRIVATE_nominalWidthX);
	cff_put_int_if_ne(pcw, pfont-&gt;data.initialRandomSeed,
			  initialRandomSeed_DEFAULT,
			  PRIVATE_initialRandomSeed);
    }
    cff_put_real_if_ne(pcw, pfont-&gt;data.BlueScale, BlueScale_DEFAULT,
		       PRIVATE_BlueScale);
    cff_put_real_if_ne(pcw, pfont-&gt;data.BlueShift, BlueShift_DEFAULT,
		       PRIVATE_BlueShift);
    cff_put_int_if_ne(pcw, pfont-&gt;data.BlueFuzz, BlueFuzz_DEFAULT,
		      PRIVATE_BlueFuzz);
    PUT_FLOAT_TABLE(StemSnapH, PRIVATE_StemSnapH);
    PUT_FLOAT_TABLE(StemSnapV, PRIVATE_StemSnapV);
    if (pfont-&gt;data.ForceBold != ForceBold_DEFAULT)
	cff_put_bool_value(pcw, pfont-&gt;data.ForceBold,
			   PRIVATE_ForceBold);
    /* (ForceBoldThreshold) */
    if (!(pcw-&gt;options &amp; WRITE_TYPE2_NO_LENIV))
	cff_put_int_if_ne(pcw, pfont-&gt;data.lenIV, lenIV_DEFAULT,
			  PRIVATE_lenIV);
    cff_put_int_if_ne(pcw, pfont-&gt;data.LanguageGroup, LanguageGroup_DEFAULT,
		      PRIVATE_LanguageGroup);
    cff_put_real_if_ne(pcw, pfont-&gt;data.ExpansionFactor,
		       ExpansionFactor_DEFAULT, PRIVATE_ExpansionFactor);
    /* initialRandomSeed was handled above */

#undef PUT_FLOAT_TABLE
}

/* ------ CharStrings Index ------ */

/* These are separate procedures only for readability. */
private int
cff_write_CharStrings_offsets(cff_writer_t *pcw, psf_glyph_enum_t *penum,
			      uint *pcount)
{
    gs_font_base *pfont = pcw-&gt;pfont;
    int offset;
    gs_glyph glyph;
    uint count;
    stream poss;
    int code;

    s_init(&amp;poss, NULL);
    psf_enumerate_glyphs_reset(penum);
    for (glyph = gs_no_glyph, count = 0, offset = 1;
	 (code = psf_enumerate_glyphs_next(penum, &amp;glyph)) != 1;
	 ++count) {
	gs_glyph_data_t gdata;
	gs_font_type1 *pfd;
	int gcode;

	gdata.memory = pfont-&gt;memory;
	if (code == 0 &amp;&amp;
	    (gcode = pcw-&gt;glyph_data(pfont, glyph, &amp;gdata, &amp;pfd)) &gt;= 0
	    ) {
	    int extra_lenIV;

	    if (gdata.bits.size &gt;= (extra_lenIV = cff_extra_lenIV(pcw, pfd))) {
		if (cff_convert_charstrings(pcw, (gs_font_base *)pfd)) {
		    swrite_position_only(&amp;poss);
		    code = psf_convert_type1_to_type2(&amp;poss, &amp;gdata, pfd);
		    if (code &lt; 0)
			return code;
		    offset += stell(&amp;poss);
		} else
		    offset += gdata.bits.size - extra_lenIV;
	    }
	    gs_glyph_data_free(&amp;gdata, "cff_write_CharStrings_offsets");
	}
	put_offset(pcw, offset);
    }
    *pcount = count;
    return offset - 1;
}
private void
cff_write_CharStrings(cff_writer_t *pcw, psf_glyph_enum_t *penum,
		      uint charstrings_count, uint charstrings_size)
{
    gs_font_base *pfont = pcw-&gt;pfont;
    uint ignore_count;
    gs_glyph glyph;
    int code;

    cff_put_Index_header(pcw, charstrings_count, charstrings_size);
    cff_write_CharStrings_offsets(pcw, penum, &amp;ignore_count);
    psf_enumerate_glyphs_reset(penum);
    for (glyph = gs_no_glyph;
	 (code = psf_enumerate_glyphs_next(penum, &amp;glyph)) != 1;
	 ) {
	gs_glyph_data_t gdata;
	gs_font_type1 *pfd;

	gdata.memory = pfont-&gt;memory;
	if (code == 0 &amp;&amp;
	    (code = pcw-&gt;glyph_data(pfont, glyph, &amp;gdata, &amp;pfd)) &gt;= 0
	    ) {
	    cff_put_CharString(pcw, gdata.bits.data, gdata.bits.size, pfd);
	    gs_glyph_data_free(&amp;gdata, "cff_write_CharStrings");
	}
    }
}

/* ------ [G]Subrs Index ------ */

/*
 * Currently, we always write all the Subrs, even for subsets.
 * We will fix this someday.
 */

private uint
cff_write_Subrs_offsets(cff_writer_t *pcw, uint *pcount, gs_font_type1 *pfont,
			bool global)
{
    int extra_lenIV = cff_extra_lenIV(pcw, pfont);
    int j, offset;
    int code;
    gs_glyph_data_t gdata;

    gdata.memory = pfont-&gt;memory;
    for (j = 0, offset = 1;
	 (code = pfont-&gt;data.procs.subr_data(pfont, j, global, &amp;gdata)) !=
	     gs_error_rangecheck;
	 ++j) {
	if (code &gt;= 0 &amp;&amp; gdata.bits.size &gt;= extra_lenIV)
	    offset += gdata.bits.size - extra_lenIV;
	put_offset(pcw, offset);
	if (code &gt;= 0)
	    gs_glyph_data_free(&amp;gdata, "cff_write_Subrs_offsets");
    }
    *pcount = j;
    return offset - 1;
}

private void
cff_write_Subrs(cff_writer_t *pcw, uint subrs_count, uint subrs_size,
		gs_font_type1 *pfont, bool global)
{
    int j;
    uint ignore_count;
    gs_glyph_data_t gdata;
    int code;

    gdata.memory = pfont-&gt;memory;
    cff_put_Index_header(pcw, subrs_count, subrs_size);
    cff_write_Subrs_offsets(pcw, &amp;ignore_count, pfont, global);
    for (j = 0;
	 (code = pfont-&gt;data.procs.subr_data(pfont, j, global, &amp;gdata)) !=
	     gs_error_rangecheck;
	 ++j) {
	if (code &gt;= 0) {
	    cff_put_CharString(pcw, gdata.bits.data, gdata.bits.size, pfont);
	    gs_glyph_data_free(&amp;gdata, "cff_write_Subrs");
	}
    }
}

/* ------ Encoding/charset ------ */

private uint
cff_Encoding_size(int num_encoded, int num_encoded_chars)
{
    int n = min(num_encoded, 255);

    return 2 + n +
	(num_encoded_chars &gt; n ?
	 1 + (num_encoded_chars - n) * 3 : 0);
}

private int
cff_write_Encoding(cff_writer_t *pcw, cff_glyph_subset_t *pgsub)
{
    stream *s = pcw-&gt;strm;
    /* This procedure is only used for Type 1 / Type 2 fonts. */
    gs_font_type1 *pfont = (gs_font_type1 *)pcw-&gt;pfont;
    byte used[255], index[255], supplement[256];
    int num_enc = min(pgsub-&gt;num_encoded, sizeof(index));
    int num_enc_chars = pgsub-&gt;num_encoded_chars;
    int nsupp = 0;
    int j;

    memset(used, 0, num_enc);
    for (j = 0; j &lt; 256; ++j) {
	gs_glyph glyph = pfont-&gt;procs.encode_char((gs_font *)pfont,
						  (gs_char)j,
						  GLYPH_SPACE_NAME);
	int i;

	if (glyph == gs_no_glyph || glyph == pgsub-&gt;glyphs.notdef)
	    continue;
	i = psf_sorted_glyphs_index_of(pgsub-&gt;glyphs.subset_data + 1,
				       pgsub-&gt;num_encoded, glyph);
	if (i &lt; 0)
	    continue;		/* encoded but not in subset */
	if (i &gt;= sizeof(used) || used[i])
	    supplement[nsupp++] = j;
	else
	    index[i] = j, used[i] = 1;
    }
    sputc(s, (byte)(nsupp ? 0x80 : 0));
    sputc(s, (byte)num_enc);
#ifdef DEBUG
    if (nsupp != num_enc_chars - num_enc)
	lprintf3("nsupp = %d, num_enc_chars = %d, num_enc = %d\n",
		 nsupp, num_enc_chars, num_enc);
    for (j = 0; j &lt; num_enc; ++j)
	if (!used[j])
	    lprintf2("glyph %d = 0x%lx not used\n", j,
		     pgsub-&gt;glyphs.subset_data[j + 1]);
#endif
    put_bytes(s, index, num_enc);
    if (nsupp) {
	/* Write supplementary entries for multiply-encoded glyphs. */
	sputc(s, (byte)nsupp);
	for (j = 0; j &lt; nsupp; ++j) {
	    byte chr = supplement[j];

	    sputc(s, chr);
	    put_card16(pcw,
		cff_glyph_sid(pcw,
			      pfont-&gt;procs.encode_char((gs_font *)pfont,
						       (gs_char)chr,
						       GLYPH_SPACE_NAME)));
	}
    }
    return 0;
}

private int
cff_write_charset(cff_writer_t *pcw, cff_glyph_subset_t *pgsub)
{
    int j;

    sputc(pcw-&gt;strm, 0);
    for (j = 1; j &lt; pgsub-&gt;glyphs.subset_size; ++j)
	put_card16(pcw, cff_glyph_sid(pcw, pgsub-&gt;glyphs.subset_data[j]));
    return 0;
}
private int
cff_write_cidset(cff_writer_t *pcw, psf_glyph_enum_t *penum)
{
    gs_glyph glyph;
    int code;

    sputc(pcw-&gt;strm, 0);
    psf_enumerate_glyphs_reset(penum);
    while ((code = psf_enumerate_glyphs_next(penum, &amp;glyph)) == 0) {
	/* Skip glyph 0 (the .notdef glyph), which is always first. */
	if (glyph != gs_min_cid_glyph)
	    put_card16(pcw, (uint)(glyph - gs_min_cid_glyph));
    }
    return min(code, 0);
}

/* ------ FDSelect ------ */

/* Determine the size of FDSelect. */
private uint
cff_FDSelect_size(cff_writer_t *pcw, psf_glyph_enum_t *penum, uint *pformat)
{
    gs_font_cid0 *const pfont = (gs_font_cid0 *)pcw-&gt;pfont;
    gs_font_base *const pbfont = (gs_font_base *)pfont;
    gs_glyph glyph;
    int prev = -1;
    uint linear_size = 1, range_size = 5;
    int code;

    /* Determine whether format 0 or 3 is more efficient. */
    psf_enumerate_glyphs_reset(penum);
    while ((code = psf_enumerate_glyphs_next(penum, &amp;glyph)) == 0) {
	int font_index;

	code = pfont-&gt;cidata.glyph_data(pbfont, glyph, NULL, &amp;font_index);
	if (code &gt;= 0) {
	    if (font_index != prev)
		range_size += 3, prev = font_index;
	    ++linear_size;
	}
    }
    if (range_size &lt; linear_size) {
	*pformat = 3;
	return range_size;
    } else {
	*pformat = 0;
	return linear_size;
    }
}

/* Write FDSelect.  size and format were returned by cff_FDSelect_size. */
private int
cff_write_FDSelect(cff_writer_t *pcw, psf_glyph_enum_t *penum, uint size,
		   int format)
{
    stream *s = pcw-&gt;strm;
    gs_font_cid0 *const pfont = (gs_font_cid0 *)pcw-&gt;pfont;
    gs_font_base *const pbfont = (gs_font_base *)pfont;
    gs_glyph glyph;
    int prev = -1;
    uint cid_count = 0;
    int code;

    spputc(s, (byte)format);
    psf_enumerate_glyphs_reset(penum);
    switch (format) {
    case 3:			/* ranges */
	put_card16(pcw, (size - 5) / 3);
	while ((code = psf_enumerate_glyphs_next(penum, &amp;glyph)) == 0) {
	    int font_index;

	    code = pfont-&gt;cidata.glyph_data(pbfont, glyph, NULL, &amp;font_index);
	    if (code &gt;= 0) {
		if (font_index != prev) {
		    put_card16(pcw, cid_count);
		    sputc(s, (byte)font_index);
		    prev = font_index;
		}
		++cid_count;
	    }
	}
	put_card16(pcw, cid_count);
	break;
    case 0:			/* linear table */
	while ((code = psf_enumerate_glyphs_next(penum, &amp;glyph)) == 0) {
	    int font_index;

	    code = pfont-&gt;cidata.glyph_data(pbfont, glyph, NULL, &amp;font_index);
	    if (code &gt;= 0)
		sputc(s, (byte)font_index);
	}
	break;
    default:			/* not possible */
	return_error(gs_error_rangecheck);
    }
    return 0;
}

/* ------ Main procedure ------ */

/* Write the CFF definition of a Type 1 or Type 2 font. */
int
psf_write_type2_font(stream *s, gs_font_type1 *pfont, int options,
		      gs_glyph *subset_glyphs, uint subset_size,
		      const gs_const_string *alt_font_name,
		      gs_int_rect *FontBBox)
{
    gs_font_base *const pbfont = (gs_font_base *)pfont;
    cff_writer_t writer;
    cff_glyph_subset_t subset;
    cff_string_item_t *std_string_items;
    cff_string_item_t *string_items;
    gs_const_string font_name;
    stream poss;
    uint charstrings_count, charstrings_size;
    uint subrs_count, subrs_size;
    uint gsubrs_count, gsubrs_size, encoding_size, charset_size;
    uint number_of_glyphs = 0, number_of_strings;
    /*
     * Set the offsets and sizes to the largest reasonable values
     * (see below).
     */
    uint
	Top_size = 0x7fffff,
	GSubrs_offset,
	Encoding_offset,
	charset_offset,
	CharStrings_offset,
	Private_offset,
	Private_size = 0x7fffff,
	Subrs_offset,
	End_offset = 0x7fffff;
    int j;
    psf_glyph_enum_t genum;
    gs_glyph glyph;
    long start_pos;
    uint offset;
    int code;

    /* Allocate the string tables. */
    psf_enumerate_glyphs_begin(&amp;genum, (gs_font *)pfont,
			       NULL, 0, GLYPH_SPACE_NAME);
    while ((code = psf_enumerate_glyphs_next(&amp;genum, &amp;glyph)) != 1)
	number_of_glyphs++;
    subset.glyphs.subset_data = (gs_glyph *)gs_alloc_bytes(pfont-&gt;memory,
		    number_of_glyphs * sizeof(glyph), "psf_write_type2_font");
    number_of_strings = number_of_glyphs + MAX_CFF_MISC_STRINGS;
    std_string_items = (cff_string_item_t *)gs_alloc_bytes(pfont-&gt;memory,
		    (MAX_CFF_STD_STRINGS + number_of_strings) * sizeof(cff_string_item_t), 
		    "psf_write_type2_font");
    if (std_string_items == NULL || subset.glyphs.subset_data == NULL)
	return_error(gs_error_VMerror);
    string_items = std_string_items + MAX_CFF_STD_STRINGS;

    /* Get subset glyphs. */
    code = psf_get_type1_glyphs(&amp;subset.glyphs, pfont, subset_glyphs,
			      subset_size);
    if (code &lt; 0)
	return code;
    if (subset.glyphs.notdef == gs_no_glyph)
	return_error(gs_error_rangecheck); /* notdef is required */

    /* If we're writing Type 2 CharStrings, don't encrypt them. */
    if (options &amp; WRITE_TYPE2_CHARSTRINGS) {
	options |= WRITE_TYPE2_NO_LENIV;
	if (pfont-&gt;FontType != ft_encrypted2)
	    pfont-&gt;data.defaultWidthX = pfont-&gt;data.nominalWidthX = 0;
    }
    writer.options = options;
    s_init(&amp;poss, NULL);
    swrite_position_only(&amp;poss);
    writer.strm = &amp;poss;
    writer.pfont = pbfont;
    writer.glyph_data = psf_type1_glyph_data;
    writer.offset_size = 1;	/* arbitrary */
    writer.start_pos = stell(s);
    writer.FontBBox = *FontBBox;

    /* Initialize the enumeration of the glyphs. */
    psf_enumerate_glyphs_begin(&amp;genum, (gs_font *)pfont,
				subset.glyphs.subset_glyphs,
				(subset.glyphs.subset_glyphs ?
				 subset.glyphs.subset_size : 0),
				GLYPH_SPACE_NAME);

    /* Shuffle the glyphs into the order .notdef, encoded, unencoded. */
    {
	gs_glyph encoded[256];
	int num_enc, num_enc_chars;

	/* Get the list of encoded glyphs. */
	for (j = 0, num_enc_chars = 0; j &lt; 256; ++j) {
	    glyph = pfont-&gt;procs.encode_char((gs_font *)pfont, (gs_char)j,
					     GLYPH_SPACE_NAME);
	    if (glyph != gs_no_glyph &amp;&amp; glyph != subset.glyphs.notdef &amp;&amp;
		(subset.glyphs.subset_glyphs == 0 ||
		 psf_sorted_glyphs_include(subset.glyphs.subset_data,
					    subset.glyphs.subset_size, glyph)))
		encoded[num_enc_chars++] = glyph;
	}
	subset.num_encoded_chars = num_enc_chars;
	subset.num_encoded = num_enc =
	    psf_sort_glyphs(encoded, num_enc_chars);

	/* Get the complete list of glyphs if we don't have it already. */
	if (!subset.glyphs.subset_glyphs) {
	    int num_glyphs = 0;

	    psf_enumerate_glyphs_reset(&amp;genum);
	    while ((code = psf_enumerate_glyphs_next(&amp;genum, &amp;glyph)) != 1)
		if (code == 0) {
		    if (num_glyphs == number_of_glyphs)
			return_error(gs_error_limitcheck);
		    subset.glyphs.subset_data[num_glyphs++] = glyph;
		}
	    subset.glyphs.subset_size =
		psf_sort_glyphs(subset.glyphs.subset_data, num_glyphs);
	    subset.glyphs.subset_glyphs = subset.glyphs.subset_data;
	}

	/* Move the unencoded glyphs to the top of the list. */
	/*
	 * We could do this in time N rather than N log N with a two-finger
	 * algorithm, but it doesn't seem worth the trouble right now.
	 */
	{
	    int from = subset.glyphs.subset_size;
	    int to = from;

	    while (from &gt; 0) {
		glyph = subset.glyphs.subset_data[--from];
		if (glyph != subset.glyphs.notdef &amp;&amp;
		    !psf_sorted_glyphs_include(encoded, num_enc, glyph))
		    subset.glyphs.subset_data[--to] = glyph;
	    }
#ifdef DEBUG
	    if (to != num_enc + 1)
		lprintf2("to = %d, num_enc + 1 = %d\n", to, num_enc + 1);
#endif
	}

	/* Move .notdef and the encoded glyphs to the bottom of the list. */
	subset.glyphs.subset_data[0] = subset.glyphs.notdef;
	memcpy(subset.glyphs.subset_data + 1, encoded,
	       sizeof(encoded[0]) * num_enc);
    }

    /* Set the font name. */
    if (alt_font_name)
	font_name = *alt_font_name;
    else
	font_name.data = pfont-&gt;font_name.chars,
	    font_name.size = pfont-&gt;font_name.size;

    /* Initialize the string tables. */
    cff_string_table_init(&amp;writer.std_strings, std_string_items,
			  MAX_CFF_STD_STRINGS);
    for (j = 0; (glyph = gs_c_known_encode((gs_char)j,
				ENCODING_INDEX_CFFSTRINGS)) != gs_no_glyph;
	 ++j) {
	gs_const_string str;
	int ignore;

	gs_c_glyph_name(glyph, &amp;str);
	cff_string_index(&amp;writer.std_strings, str.data, str.size, true,
			 &amp;ignore);
    }
    cff_string_table_init(&amp;writer.strings, string_items, number_of_strings);

    /* Enter miscellaneous strings in the string table. */
    cff_write_Top_font(&amp;writer, 0, 0, 0, 0, 0);

    /* Enter the glyph names in the string table. */
    /* (Note that we have changed the glyph list.) */
    psf_enumerate_glyphs_begin(&amp;genum, (gs_font *)pfont,
			       subset.glyphs.subset_data,
			       subset.glyphs.subset_size,
			       GLYPH_SPACE_NAME);
    while ((code = psf_enumerate_glyphs_next(&amp;genum, &amp;glyph)) != 1)
	if (code == 0) {
	    code = cff_glyph_sid(&amp;writer, glyph);
	    if (code &lt; 0)
		return code;
	}

    /*
     * The CFF specification says that the Encoding, charset, CharStrings,
     * Private, and Local Subr sections may be in any order.  To minimize
     * the risk of incompatibility with Adobe software, we produce them in
     * the order just mentioned.
     */

    /*
     * Compute the size of the GSubrs Index, if not omitted.
     */
    if ((options &amp; WRITE_TYPE2_NO_GSUBRS) != 0 ||
	cff_convert_charstrings(&amp;writer, pbfont) /* we expand all Subrs */
	)
	gsubrs_count = 0, gsubrs_size = 0;
    else
	gsubrs_size = cff_write_Subrs_offsets(&amp;writer, &amp;gsubrs_count,
					      pfont, true);

    /*
     * Compute the size of the Encoding.  For simplicity, we currently
     * always store the Encoding explicitly.  Note that because CFF stores
     * the Encoding in an "inverted" form, we need to count the number of
     * glyphs that occur at more than one place in the Encoding.
     */
    encoding_size = cff_Encoding_size(subset.num_encoded,
				      subset.num_encoded_chars);

    /*
     * Compute the size of the charset.  For simplicity, we currently
     * always store the charset explicitly.
     */
    charset_size = 1 + (subset.glyphs.subset_size - 1) * 2;

    /* Compute the size of the CharStrings Index. */
    code = cff_write_CharStrings_offsets(&amp;writer, &amp;genum, &amp;charstrings_count);
    if (code &lt; 0)
	return code;
    charstrings_size = (uint)code;

    /* Compute the size of the (local) Subrs Index. */
#ifdef SKIP_EMPTY_SUBRS
    subrs_size =
	(cff_convert_charstrings(&amp;writer, pbfont) ? 0 :
	 cff_write_Subrs_offsets(&amp;writer, &amp;subrs_count, pfont, false));
#else
    if (cff_convert_charstrings(&amp;writer, pbfont))
	subrs_count = 0;	/* we expand all Subrs */
    subrs_size = cff_write_Subrs_offsets(&amp;writer, &amp;subrs_count, pfont, false);
#endif

    /*
     * The offsets of the Private Dict and the CharStrings Index
     * depend on the size of the Top Dict; the offset of the Subrs also
     * depends on the size of the Private Dict.  However, the size of the
     * Top Dict depends on the offsets of the CharStrings Index, the
     * charset, and the Encoding, and on the offset and size of the Private
     * Dict, because of the variable-length encoding of the offsets and
     * size; for the same reason, the size of the Private Dict depends on
     * the offset of the Subrs.  Fortunately, the relationship between the
     * value of an offset or size and the size of its encoding is monotonic.
     * Therefore, we start by assuming the largest reasonable value for all
     * the sizes and iterate until everything converges.
     */
 iter:
    swrite_position_only(&amp;poss);
    writer.strm = &amp;poss;

    /* Compute the offsets. */
    GSubrs_offset = 4 + cff_Index_size(1, font_name.size) +
	cff_Index_size(1, Top_size) +
	cff_Index_size(writer.strings.count, writer.strings.total);
    Encoding_offset = GSubrs_offset +
	cff_Index_size(gsubrs_count, gsubrs_size);
    charset_offset = Encoding_offset + encoding_size;
    CharStrings_offset = charset_offset + charset_size;
    Private_offset = CharStrings_offset +
	cff_Index_size(charstrings_count, charstrings_size);
    Subrs_offset = Private_size;  /* relative to Private Dict */

 write:
    if(check_ioerror(writer.strm))
	return_error(gs_error_ioerror);
    start_pos = stell(writer.strm);
    /* Write the header, setting offset_size. */
    cff_write_header(&amp;writer, End_offset);

    /* Write the names Index. */
    cff_put_Index_header(&amp;writer, 1, font_name.size);
    put_offset(&amp;writer, font_name.size + 1);
    put_bytes(writer.strm, font_name.data, font_name.size);

    /* Write the Top Index. */
    cff_put_Index_header(&amp;writer, 1, Top_size);
    put_offset(&amp;writer, Top_size + 1);
    offset = stell(writer.strm) - start_pos;
    cff_write_Top_font(&amp;writer, Encoding_offset, charset_offset,
		       CharStrings_offset,
		       Private_offset, Private_size);
    Top_size = stell(writer.strm) - start_pos - offset;

    /* Write the strings Index. */
    cff_put_Index(&amp;writer, &amp;writer.strings);
    if(check_ioerror(writer.strm))
	return_error(gs_error_ioerror);

    /* Write the GSubrs Index, if any, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]GSubrs = %u =&gt; %u\n", GSubrs_offset, offset);
    if (offset &gt; GSubrs_offset)
	return_error(gs_error_rangecheck);
    GSubrs_offset = offset;
    if (gsubrs_count == 0 || cff_convert_charstrings(&amp;writer, pbfont))
	cff_put_Index_header(&amp;writer, 0, 0);
    else
	cff_write_Subrs(&amp;writer, gsubrs_count, gsubrs_size, pfont, true);

    /* Write the Encoding. */
    cff_write_Encoding(&amp;writer, &amp;subset);

    /* Write the charset. */
    cff_write_charset(&amp;writer, &amp;subset);

    /* Write the CharStrings Index, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if (offset &gt; CharStrings_offset)
	return_error(gs_error_rangecheck);
    CharStrings_offset = offset;
    cff_write_CharStrings(&amp;writer, &amp;genum, charstrings_count,
			  charstrings_size);
    if(check_ioerror(writer.strm))
	return_error(gs_error_ioerror);

    /* Write the Private Dict, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if (offset &gt; Private_offset)
	return_error(gs_error_rangecheck);
    Private_offset = offset;
    cff_write_Private(&amp;writer, (subrs_size == 0 ? 0 : Subrs_offset), pfont);
    Private_size = stell(writer.strm) - start_pos - offset;

    /* Write the Subrs Index, checking the offset. */
    offset = stell(writer.strm) - (start_pos + Private_offset);
    if (offset &gt; Subrs_offset)
	return_error(gs_error_rangecheck);
    Subrs_offset = offset;
    if (cff_convert_charstrings(&amp;writer, pbfont))
	cff_put_Index_header(&amp;writer, 0, 0);
    else if (subrs_size != 0)
	cff_write_Subrs(&amp;writer, subrs_count, subrs_size, pfont, false);

    /* Check the final offset. */
    if(check_ioerror(writer.strm))
	return_error(gs_error_ioerror);
    offset = stell(writer.strm) - start_pos;
    if (offset &gt; End_offset)
	return_error(gs_error_rangecheck);
    if (offset == End_offset) {
	/* The iteration has converged.  Write the result. */
	if (writer.strm == &amp;poss) {
	    writer.strm = s;
	    goto write;
	}
    } else {
	/* No convergence yet. */
	End_offset = offset;
	goto iter;
    }

    /* All done. */
    gs_free_object(pfont-&gt;memory, std_string_items, "psf_write_type2_font");
    gs_free_object(pfont-&gt;memory, subset.glyphs.subset_data, "psf_write_type2_font");
    return 0;
}

/* Write the CFF definition of a CIDFontType 0 font (CIDFont). */
private int
cid0_glyph_data(gs_font_base *pbfont, gs_glyph glyph, gs_glyph_data_t *pgd,
		gs_font_type1 **ppfont)
{
    gs_font_cid0 *const pfont = (gs_font_cid0 *)pbfont;
    int font_index;
    int code = pfont-&gt;cidata.glyph_data(pbfont, glyph, pgd, &amp;font_index);

    if (code &gt;= 0)
	*ppfont = pfont-&gt;cidata.FDArray[font_index];
    return code;
}
#ifdef DEBUG
private int
offset_error(const char *msg)
{
    if_debug1('l', "[l]%s offset error\n", msg);
    return gs_error_rangecheck;
}
#else
#  define offset_error(msg) gs_error_rangecheck
#endif
int
psf_write_cid0_font(stream *s, gs_font_cid0 *pfont, int options,
		    const byte *subset_cids, uint subset_size,
		    const gs_const_string *alt_font_name)
{
    /*
     * CIDFontType 0 fonts differ from ordinary Type 1 / Type 2 fonts
     * as follows:
     *   The TOP Dict starts with a ROS operator.
     *   The TOP Dict must include FDArray and FDSelect operators.
     *   The TOP Dict may include CIDFontVersion, CIDFontRevision,
     *     CIDFontType, CIDCount, and UIDBase operators.
     *   The TOP Dict must not include an Encoding operator.
     *   The charset is defined in terms of CIDs rather than SIDs.
     *   FDArray references a Font Index in which each element is a Dict
     *     defining a font without charset, Encoding, or CharStrings.
     *   FDSelect references a structure mapping CIDs to font numbers.
     */
    gs_font_base *const pbfont = (gs_font_base *)pfont;
    cff_writer_t writer;
    cff_string_item_t std_string_items[500]; /* 391 entries used */
    /****** HOW TO DETERMINE THE SIZE OF STRINGS? ******/
    cff_string_item_t string_items[500 /* character names */ +
				   40 /* misc. values */];
    gs_const_string font_name;
    stream poss;
    uint charstrings_count, charstrings_size;
    uint gsubrs_count, gsubrs_size;
    uint charset_size, fdselect_size, fdselect_format;
    uint subrs_count[256], subrs_size[256];
    /*
     * Set the offsets and sizes to the largest reasonable values
     * (see below).
     */
    uint
	Top_size = 0x7fffff,
	GSubrs_offset = 0x7fffff,
	charset_offset = 0x7fffff,
	FDSelect_offset = 0x7fffff,
	CharStrings_offset = 0x7fffff,
	Font_offset = 0x7fffff,
	FDArray_offsets[257],
	Private_offsets[257],
	Subrs_offsets[257],
	End_offset = 0x7fffff;
    int j;
    psf_glyph_enum_t genum;
    gs_font_info_t info;
    long start_pos;
    uint offset;
    int num_fonts = pfont-&gt;cidata.FDArray_size;
    int code;


    /* Initialize the enumeration of the glyphs. */
    psf_enumerate_cids_begin(&amp;genum, (gs_font *)pfont, subset_cids,
			     subset_size);

    /* Check that the font can be written. */
    code = psf_check_outline_glyphs((gs_font_base *)pfont, &amp;genum,
				    cid0_glyph_data);
    if (code &lt; 0)
	return code;
    /* The .notdef glyph (glyph 0) must be included. */
    if (subset_cids &amp;&amp; subset_size &gt; 0 &amp;&amp; !(subset_cids[0] &amp; 0x80))
	return_error(gs_error_rangecheck);

    writer.options = options;
    s_init(&amp;poss, NULL);
    swrite_position_only(&amp;poss);
    writer.strm = &amp;poss;
    writer.pfont = pbfont;
    writer.glyph_data = cid0_glyph_data;
    writer.offset_size = 1;	/* arbitrary */
    writer.start_pos = stell(s);
    writer.FontBBox.p.x = writer.FontBBox.p.y = 0;
    writer.FontBBox.q.x = writer.FontBBox.q.y = 0;

    /* Set the font name. */
    if (alt_font_name)
	font_name = *alt_font_name;
    else if (pfont-&gt;font_name.size)
	font_name.data = pfont-&gt;font_name.chars,
	    font_name.size = pfont-&gt;font_name.size;
    else
	font_name.data = pfont-&gt;key_name.chars,
	    font_name.size = pfont-&gt;key_name.size;

    /* Initialize the string tables. */
    cff_string_table_init(&amp;writer.std_strings, std_string_items,
			  countof(std_string_items));
    cff_string_table_init(&amp;writer.strings, string_items,
			  countof(string_items));

    /* Make all entries in the string table. */
    cff_write_ROS(&amp;writer, &amp;pfont-&gt;cidata.common.CIDSystemInfo);
    for (j = 0; j &lt; num_fonts; ++j) {
	gs_font_type1 *pfd = pfont-&gt;cidata.FDArray[j];

	cff_write_Top_fdarray(&amp;writer, (gs_font_base *)pfd, 0, 0);
    }

    /*
     * The CFF specification says that sections after the initial Indexes
     * may be in any order.  To minimize the risk of incompatibility with
     * Adobe software, we produce them in the order illustrated in the
     * specification.
     */

    /* Initialize the offset arrays. */
    for (j = 0; j &lt;= num_fonts; ++j)
	FDArray_offsets[j] = Private_offsets[j] = Subrs_offsets[j] =
	    0x7effffff / num_fonts * j + 0x1000000;

    /*
     * Compute the size of the GSubrs Index, if not omitted.
     * Arbitrarily use FDArray[0] to access the GSubrs and to determine
     * the CharString type.
     */
    if ((options &amp; WRITE_TYPE2_NO_GSUBRS) != 0 ||
	cff_convert_charstrings(&amp;writer,
			(const gs_font_base *)pfont-&gt;cidata.FDArray[0])
				/* we expand all Subrs */
	)
	gsubrs_count = 0, gsubrs_size = 0;
    else
	gsubrs_size = cff_write_Subrs_offsets(&amp;writer, &amp;gsubrs_count,
					      pfont-&gt;cidata.FDArray[0], true);

    /*
     * Compute the size of the charset.  For simplicity, we currently
     * always store the charset explicitly.
     */
    swrite_position_only(&amp;poss);
    cff_write_cidset(&amp;writer, &amp;genum);
    charset_size = stell(&amp;poss);

    /* Compute the size of the FDSelect strucure. */
    fdselect_size = cff_FDSelect_size(&amp;writer, &amp;genum, &amp;fdselect_format);

    /* Compute the size of the CharStrings Index. */
    charstrings_size =
	cff_write_CharStrings_offsets(&amp;writer, &amp;genum, &amp;charstrings_count);

    /* Compute the size of the (local) Subrs Indexes. */
    for (j = 0; j &lt; num_fonts; ++j) {
	gs_font_type1 *pfd = pfont-&gt;cidata.FDArray[j];

#ifdef SKIP_EMPTY_SUBRS
	subrs_size[j] =
	    (cff_convert_charstrings(&amp;writer, (gs_font_base *)pfd) ? 0 :
	     cff_write_Subrs_offsets(&amp;writer, &amp;subrs_count[j], pfd, false));
#else
	if (cff_convert_charstrings(&amp;writer, (gs_font_base *)pfd))
	    subrs_count[j] = 0;  /* we expand all Subrs */
	subrs_size[j] = cff_write_Subrs_offsets(&amp;writer, &amp;subrs_count[j], pfd, false);
#endif
    }

    /* Get the font_info once, since it may be expensive. */
    cff_get_Top_info_common(&amp;writer, (gs_font_base *)pfont, true, &amp;info);

    /*
     * The offsets of the Private Dict and the CharStrings Index
     * depend on the size of the Top Dict; the offset of the Subrs also
     * depends on the size of the Private Dict.  However, the size of the
     * Top Dict depends on the offsets of the CharStrings Index and the
     * charset, and on the offset and size of the Private Dict,
     * because of the variable-length encoding of the offsets and
     * size; for the same reason, the size of the Private Dict depends on
     * the offset of the Subrs.  Fortunately, the relationship between the
     * value of an offset or size and the size of its encoding is monotonic.
     * Therefore, we start by assuming the largest reasonable value for all
     * the sizes and iterate until everything converges.
     */
 iter:
    swrite_position_only(&amp;poss);
    writer.strm = &amp;poss;

    /* Compute the offsets. */
    GSubrs_offset = 4 + cff_Index_size(1, font_name.size) +
	cff_Index_size(1, Top_size) +
	cff_Index_size(writer.strings.count, writer.strings.total);
    charset_offset = GSubrs_offset +
	cff_Index_size(gsubrs_count, gsubrs_size);
    FDSelect_offset = charset_offset + charset_size;
    CharStrings_offset = FDSelect_offset + fdselect_size;
    if_debug4('l', "[l]GSubrs at %u, charset at %u, FDSelect at %u, CharStrings at %u\n",
	      GSubrs_offset, charset_offset, FDSelect_offset, CharStrings_offset);

 write:
    start_pos = stell(writer.strm);
    if_debug1('l', "[l]start_pos = %ld\n", start_pos);
    /* Write the header, setting offset_size. */
    cff_write_header(&amp;writer, End_offset);

    /* Write the names Index. */
    cff_put_Index_header(&amp;writer, 1, font_name.size);
    put_offset(&amp;writer, font_name.size + 1);
    put_bytes(writer.strm, font_name.data, font_name.size);

    /* Write the Top Index. */
    cff_put_Index_header(&amp;writer, 1, Top_size);
    put_offset(&amp;writer, Top_size + 1);
    offset = stell(writer.strm) - start_pos;
    cff_write_Top_cidfont(&amp;writer, charset_offset, CharStrings_offset,
			  FDSelect_offset, Font_offset, &amp;info);
    Top_size = stell(writer.strm) - start_pos - offset;
    if_debug1('l', "[l]Top_size = %u\n", Top_size);

    /* Write the strings Index. */
    cff_put_Index(&amp;writer, &amp;writer.strings);

    /* Write the GSubrs Index, if any, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]GSubrs = %u =&gt; %u\n", GSubrs_offset, offset);
    if (offset &gt; GSubrs_offset)
	return_error(gs_error_rangecheck);
    GSubrs_offset = offset;
    if (gsubrs_count == 0 ||
	cff_convert_charstrings(&amp;writer,
			(const gs_font_base *)pfont-&gt;cidata.FDArray[0])
	)
	cff_put_Index_header(&amp;writer, 0, 0);
    else
	cff_write_Subrs(&amp;writer, gsubrs_count, gsubrs_size,
			pfont-&gt;cidata.FDArray[0], true);

    /* Write the charset. */
    if_debug1('l', "[l]charset = %u\n", stell(writer.strm) - start_pos);
    cff_write_cidset(&amp;writer, &amp;genum);

    /* Write the FDSelect structure, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]FDSelect = %u =&gt; %u\n", FDSelect_offset, offset);
    if (offset &gt; FDSelect_offset)
	return_error(offset_error("FDselect"));
    FDSelect_offset = offset;
    cff_write_FDSelect(&amp;writer, &amp;genum, fdselect_size, fdselect_format);

    /* Write the CharStrings Index, checking the offset. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]CharStrings = %u =&gt; %u\n", CharStrings_offset, offset);
    if (offset &gt; CharStrings_offset)
	return_error(offset_error("CharStrings"));
    CharStrings_offset = offset;
    cff_write_CharStrings(&amp;writer, &amp;genum, charstrings_count,
			  charstrings_size);

    /* Write the Font Dict Index. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]Font = %u =&gt; %u\n", Font_offset, offset);
    if (offset &gt; Font_offset)
	return_error(offset_error("Font"));
    Font_offset = offset;
    cff_write_FDArray_offsets(&amp;writer, FDArray_offsets, num_fonts);
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]FDArray[0] = %u =&gt; %u\n", FDArray_offsets[0], offset);
    if (offset &gt; FDArray_offsets[0])
	return_error(offset_error("FDArray[0]"));
    FDArray_offsets[0] = offset;
    for (j = 0; j &lt; num_fonts; ++j) {
	gs_font_type1 *pfd = pfont-&gt;cidata.FDArray[j];

	/* If we're writing Type 2 CharStrings, don't encrypt them. */
	if (options &amp; WRITE_TYPE2_CHARSTRINGS) {
	    options |= WRITE_TYPE2_NO_LENIV;
	    if (pfd-&gt;FontType != ft_encrypted2)
		pfd-&gt;data.defaultWidthX = pfd-&gt;data.nominalWidthX = 0;
	}
	cff_write_Top_fdarray(&amp;writer, (gs_font_base *)pfd, Private_offsets[j],
			      Private_offsets[j + 1] - Private_offsets[j]);
	offset = stell(writer.strm) - start_pos;
	if_debug3('l', "[l]FDArray[%d] = %u =&gt; %u\n", j + 1,
		  FDArray_offsets[j + 1], offset);
	if (offset &gt; FDArray_offsets[j + 1])
	    return_error(offset_error("FDArray"));
	FDArray_offsets[j + 1] = offset;
    }

    /* Write the Private Dicts, checking the offset. */
    for (j = 0; ; ++j) {
	gs_font_type1 *pfd;

	offset = stell(writer.strm) - start_pos;
	if_debug3('l', "[l]Private[%d] = %u =&gt; %u\n",
		  j, Private_offsets[j], offset);
	if (offset &gt; Private_offsets[j])
	    return_error(offset_error("Private"));
	Private_offsets[j] = offset;
	if (j == num_fonts)
	    break;
	pfd = pfont-&gt;cidata.FDArray[j];
	cff_write_Private(&amp;writer,
			  (subrs_size[j] == 0 ? 0 : Subrs_offsets[j]), pfd);
    }

    /* Write the Subrs Indexes, checking the offsets. */
    for (j = 0; ; ++j) {
	gs_font_type1 *pfd;

	offset = stell(writer.strm) - (start_pos + Private_offsets[j]);
	if_debug3('l', "[l]Subrs[%d] = %u =&gt; %u\n",
		  j, Subrs_offsets[j], offset);
	if (offset &gt; Subrs_offsets[j])
	    return_error(offset_error("Subrs"));
	Subrs_offsets[j] = offset;
	if (j == num_fonts)
	    break;
	pfd = pfont-&gt;cidata.FDArray[j];
	if (cff_convert_charstrings(&amp;writer, (gs_font_base *)pfd))
	    cff_put_Index_header(&amp;writer, 0, 0);
	else if (subrs_size[j] != 0)
	    cff_write_Subrs(&amp;writer, subrs_count[j], subrs_size[j], pfd, false);
    }

    /* Check the final offset. */
    offset = stell(writer.strm) - start_pos;
    if_debug2('l', "[l]End = %u =&gt; %u\n", End_offset, offset);
    if (offset &gt; End_offset)
	return_error(offset_error("End"));
    if (offset == End_offset) {
	/* The iteration has converged.  Write the result. */
	if (writer.strm == &amp;poss) {
	    writer.strm = s;
	    goto write;
	}
    } else {
	/* No convergence yet. */
	End_offset = offset;
	goto iter;
    }

    /* All done. */
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

