<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevsgi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevsgi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * This file is distributed with Ghostscript, but its author,
 * Tanmoy Bhattacharya (tanmoy@qcd.lanl.gov) hereby places it in the
 * public domain.
 */

/* $Id: gdevsgi.c,v 1.6 2004/08/10 13:02:36 stefan Exp $*/
/* SGI raster file driver */
#include "gdevprn.h"
#include "gdevsgi.h"

#define X_DPI 72
#define Y_DPI 72

#define sgi_prn_device(procs, dev_name, num_comp, depth, max_gray, max_color, print_page)\
{prn_device_body(gx_device_printer, procs, dev_name, \
		 DEFAULT_WIDTH_10THS, DEFAULT_HEIGHT_10THS, X_DPI, Y_DPI, \
		 0, 0, 0, 0, \
		 num_comp, depth, max_gray, max_color, max_gray+1, max_color+1, \
		 print_page)}

private dev_proc_map_rgb_color(sgi_map_rgb_color);
private dev_proc_map_color_rgb(sgi_map_color_rgb);

private dev_proc_print_page(sgi_print_page);

private gx_device_procs sgi_procs =
  prn_color_procs(gdev_prn_open, gdev_prn_output_page, gdev_prn_close,
		  sgi_map_rgb_color, sgi_map_color_rgb);

const gx_device_printer far_data gs_sgirgb_device =
  sgi_prn_device(sgi_procs, "sgirgb", 3, 24, 255, 255, sgi_print_page);

private gx_color_index
sgi_map_rgb_color(gx_device * dev, const ushort cv[])
{      ushort bitspercolor = dev-&gt;color_info.depth / 3;
       ulong max_value = (1 &lt;&lt; bitspercolor) - 1;
       ushort red, green, blue;
       red = cv[0]; green = cv[1]; blue = cv[2];

       return ((red*max_value / gx_max_color_value) &lt;&lt; (bitspercolor * 2)) +
	      ((green*max_value / gx_max_color_value) &lt;&lt; bitspercolor) +
	      (blue*max_value / gx_max_color_value);
}

private int
sgi_map_color_rgb(gx_device *dev, gx_color_index color, ushort prgb[3])
{	ushort bitspercolor = dev-&gt;color_info.depth / 3;
	ushort colormask = (1 &lt;&lt; bitspercolor) - 1;

	prgb[0] = (ushort)(((color &gt;&gt; (bitspercolor * 2)) &amp; colormask) *
		(ulong)gx_max_color_value / colormask);
	prgb[1] = (ushort)(((color &gt;&gt; bitspercolor) &amp; colormask) *
		(ulong)gx_max_color_value / colormask);
	prgb[2] = (ushort)((color &amp; colormask) *
		(ulong)gx_max_color_value / colormask);
	return 0;
}

typedef struct sgi_cursor_s {
  gx_device_printer *dev;
  int bpp;
  uint line_size;
  byte *data;
  int lnum;
} sgi_cursor;

private int
sgi_begin_page(gx_device_printer *bdev, FILE *pstream, sgi_cursor *pcur)
{
     uint line_size = gdev_mem_bytes_per_scan_line((gx_device_printer*)bdev);
     byte *data = (byte*)gs_malloc(bdev-&gt;memory, line_size, 1, "sgi_begin_page");
     IMAGE *header= (IMAGE*)gs_malloc(bdev-&gt;memory, sizeof(IMAGE),1,"sgi_begin_page");
     char filler= '\0';
     int i;

     if ((data == (byte*)0)||(header == (IMAGE*)0)) return -1;

     bzero(header,sizeof(IMAGE));
     header-&gt;imagic = IMAGIC;
     header-&gt;type = RLE(1);
     header-&gt;dim = 3;
     header-&gt;xsize=bdev-&gt;width;
     header-&gt;ysize=bdev-&gt;height;
     header-&gt;zsize=3;
     header-&gt;min_color  = 0;
     header-&gt;max_color  = bdev-&gt;color_info.max_color;
     header-&gt;wastebytes = 0;
     strncpy(header-&gt;name,"gs picture",80);
     header-&gt;colormap = CM_NORMAL;
     header-&gt;dorev=0;
     fwrite(header,sizeof(IMAGE),1,pstream);
     for (i=0; i&lt;512-sizeof(IMAGE); i++) fputc(filler,pstream);
     pcur-&gt;dev = bdev;
     pcur-&gt;bpp = bdev-&gt;color_info.depth;
     pcur-&gt;line_size = line_size;
     pcur-&gt;data = data;
     return 0;
}

private int
sgi_next_row(sgi_cursor *pcur)
{    if (pcur-&gt;lnum &lt; 0)
       return 1;
     gdev_prn_copy_scan_lines((gx_device_printer*)pcur-&gt;dev,
			      pcur-&gt;lnum--, pcur-&gt;data, pcur-&gt;line_size);
     return 0;
}

#define bdev ((gx_device_printer *)pdev)

private int
sgi_print_page(gx_device_printer *pdev, FILE *pstream)
{      sgi_cursor cur;
       int code = sgi_begin_page(bdev, pstream, &amp;cur);
       uint bpe, mask;
       int separation;
       long *rowsizes=(long*)gs_malloc(pdev-&gt;memory, 4,3*bdev-&gt;height,"sgi_print_page");
       byte *edata ;
       long lastval;
       int rownumber;
#define aref2(a,b) a*bdev-&gt;height+b
       edata =  (byte*)gs_malloc(pdev-&gt;memory, cur.line_size, 1, "sgi_begin_page");
       if((code&lt;0)||(rowsizes==(long*)NULL)||(edata==(byte*)NULL)) return(-1);
       fwrite(rowsizes,sizeof(long),3*bdev-&gt;height,pstream); /* rowstarts */
       fwrite(rowsizes,sizeof(long),3*bdev-&gt;height,pstream); /* rowsizes */
       lastval = 512+sizeof(long)*6*bdev-&gt;height;
       fseek(pstream,lastval,0);
       for (separation=0; separation &lt; 3; separation++)
	 {
	   cur.lnum = cur.dev-&gt;height-1;
	   rownumber = 0;
	   bpe = cur.bpp/3;
	   mask = (1&lt;&lt;bpe) - 1;
	   while ( !(code=sgi_next_row(&amp;cur)))
	     { byte *bp;
	       uint x;
	       int shift;
	       byte *curcol=cur.data;
	       byte *startcol=edata;
	       int count;
	       byte todo, cc;
	       byte *iptr, *sptr, *optr, *ibufend;
	       for (bp = cur.data, x=0, shift = 8 - cur.bpp;
		    x &lt; bdev-&gt;width;
		    )
		 { ulong pixel = 0;
		   uint r, g, b;
		   switch (cur.bpp &gt;&gt; 3)
		     {
		     case 3: pixel = (ulong)*bp &lt;&lt; 16; bp++;
		     case 2: pixel += (uint)*bp &lt;&lt; 8; bp++;
		     case 1: pixel += *bp; bp++; break;
		     case 0: pixel = *bp &gt;&gt; shift;
		       if ((shift-=cur.bpp) &lt; 0)
			 bp++, shift += 8; break;
		     }
		   ++x;
		   b = pixel &amp; mask; pixel &gt;&gt;= bpe;
		   g = pixel &amp; mask; pixel &gt;&gt;= bpe;
		   r = pixel &amp; mask;
		   switch(separation)
		     {
		     case 0: *curcol++=r; break;
		     case 1: *curcol++=g; break;
		     case 2: *curcol++=b; break;
		     }
		 }
	       iptr=cur.data;
	       optr=startcol;
	       ibufend=curcol-1;
	       while(iptr&lt;ibufend) {
		 sptr = iptr;						
		 iptr += 2;
		 while((iptr&lt;ibufend)&amp;&amp;((iptr[-2]!=iptr[-1])||(iptr[-1]!=iptr[0])))
		   iptr++;
		 iptr -= 2;
		 count = iptr-sptr;
		 while(count) {
		   todo = count&gt;126 ? 126:count;
		   count -= todo;
		   *optr++ = 0x80|todo;
		   while(todo--)
		     *optr++ = *sptr++;
		 }
		 sptr = iptr;
		 cc = *iptr++;
		 while( (iptr&lt;ibufend) &amp;&amp; (*iptr == cc) )
		   iptr++;
		 count = iptr-sptr;
		 while(count) {
		   todo = count&gt;126 ? 126:count;
		   count -= todo;
		   *optr++ = todo;
		   *optr++ = cc;
		 }
	       }
               *optr++ = 0;
	       rowsizes[aref2(separation,rownumber++)] = optr-startcol;
	       fwrite(startcol,1,optr-startcol,pstream);
	     }
	 }
       fseek(pstream,512L,0);
       for(separation=0; separation&lt;3; separation++)
	 for(rownumber=0; rownumber&lt;bdev-&gt;height; rownumber++)
	   {fputc((char)(lastval&gt;&gt;24),pstream);
	    fputc((char)(lastval&gt;&gt;16),pstream);
	    fputc((char)(lastval&gt;&gt;8),pstream);
	    fputc((char)(lastval),pstream);
	    lastval+=rowsizes[aref2(separation,rownumber)];}
       for(separation=0; separation&lt;3; separation++)
	 for(rownumber=0; rownumber&lt;bdev-&gt;height; rownumber++)
	   {lastval=rowsizes[aref2(separation,rownumber)];
	    fputc((char)(lastval&gt;&gt;24),pstream);
	    fputc((char)(lastval&gt;&gt;16),pstream);
	    fputc((char)(lastval&gt;&gt;8),pstream);
	    fputc((char)(lastval),pstream);}
       gs_free(pdev-&gt;memory, (char*)cur.data, cur.line_size, 1,
		 "sgi_print_page(done)");
       gs_free(pdev-&gt;memory, (char*)edata, cur.line_size, 1, "sgi_print_page(done)");
       gs_free(pdev-&gt;memory, (char*)rowsizes,4,3*bdev-&gt;height,"sgi_print_page(done)");
       return (code &lt; 0 ? code : 0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

