<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevstc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevstc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 1996 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevstc.c,v 1.11 2004/11/22 19:25:57 giles Exp $*/
/* Epson Stylus-Color Printer-Driver */

/***
 *** This file was "copied" from gdevcdj.c (ghostscript-3.12), which was
 *** contributed by:
 ***    George Cameron      - g.cameron@biomed.abdn.ac.ukis
 ***    Koert Zeilstra      - koert@zen.cais.com
 ***    Eckhard Rueggeberg  - eckhard@ts.go.dlr.de
 ***
 *** Some of the ESC/P2-code was drawn from gdevescp.c, contributed by
 ***    Richard Brown       - rab@eos.ncsu.edu
 ***
 *** The POSIX-Interrupt-Code is from (Compile-Time-Option -DSTC_SIGNAL)
 ***    Frederic Loyer      - loyer@ensta.fr
 ***
 *** And several improvements are based on discussions with
 ***    Brian Converse      - BCONVERSE@ids.net
 ***    Bill Davidson       - bdavidson@ra.isisnet.com
 ***    Gero Guenther       - gero@cs.tu-berlin.de
 ***    Jason Patterson     - jason@reflections.com.au
 ***    ? Rueschstroer      - rue@ibe.med.uni-muenchen.de
 ***    Steven Singer       - S.Singer@ph.surrey.ac.uk
 ***
 *** And the remaining little rest, mainly the bugs, were written by me:
 *** Gunther Hess           - gunther@elmos.de
 ***
 *** P.S.: there is some documentation, see devices.doc
 ***
 *** Revision-History:
 *** 16-DEC-1994  1.1  - initial Version (GS-Dithering &amp; Plain-Write)
     ...
 *** 30-JAN-1995  1.11 - FS-Improvements, u/sWeave, 1/4/24-Bits
 ***  5-MAR-1995  1.12 - L. Peter Deutsch - updated put_params routine
                         (first distributed version with gs3.33)
 *** 26-APR-1995  1.13 - merged Peters fixes with algorithmic changes:
                         Changed 24Bit-Mode, added 32Bit-Mode (moves colors)
                         [Arrgh: much better than 1.12, but patch was lost]
 ***  5-JUN-1995  1.14 - Added Color-Correction &amp; Transfer-Curves
                         (Several Beta-Testers, but not distributed)
     ...
 *** 24-JUL-1995  1.16 - Made dithering-Algorithms external-functions.
                         (Mailed for Beta-Distribution)
 *** 10-AUG-1995  1.17 - Several Bug-Fixes and some new features:
                         CMYK10-Coding added
                         Readonly Parameters added
                          "Algorithms", "BitsPerComponent", "Version"
                         Parameters Flag0-4, Model, OutputCode
                         (mailed for distribution)
 *** 14-SEP-1995  1.18   Fixes Bugs with Borland C (gs3.47)
 *** 23-SEP-1995  1.19 - reorganized printcode + bug-fixing
 *** 24-SEP-1995  1.20 - Little Cleanup for the release
 *** 25-SEP-1995  1.21 - Readonly-Parameters added to put_params.
 *** 31-Dec-1995  1.22 - Sanitary Engineering on the code
 *** 16-Jan-1996  1.23 - Added String escp_Release
 ***  8-May-1996  1.90 - Reintroduced Deltarow &amp; Fixed MEMORY-BUG!
 ***/

#include "gdevstc.h"
#ifdef    STC_SIGNAL
#  include &lt;signal.h&gt;
#endif /* STC_SIGNAL */
/***
 *** Mode-Table - the various algorithms
 *** (The intention is, that this source can live alone)
 ***/

private stc_proc_dither(stc_gscmyk);   /* resides in this file */
private stc_proc_dither(stc_hscmyk);   /* resides in this file */

#include &lt;stdlib.h&gt; /* for rand, used in stc_hscmyk */

private const stc_dither_t stc_dither[] = {
  {"gscmyk", stc_gscmyk, DeviceCMYK|STC_BYTE|STC_DIRECT,0,{0.0,1.0}},
  {"hscmyk", stc_hscmyk,
  DeviceCMYK|STC_LONG|STC_CMYK10|STC_DIRECT|1*STC_SCAN,1+2*4,
                                                  {0.0,    1023.0}},
  STC_MODI
  { NULL   , NULL      , 0,                  0,{0.0,0.0}}
};

/***
 ***  forward-declarations of routines
 ***/

/* Primary Device functions
 * (I've the idea to rename the driver to stc)
 */
private dev_proc_print_page(stc_print_page);
private dev_proc_open_device(stc_open);
private dev_proc_close_device(stc_close);
private dev_proc_get_params(stc_get_params);
private dev_proc_put_params(stc_put_params);

/*
 * Color-Mapping-functions.
 */

/* routines for monochrome monochrome modi */
private dev_proc_map_rgb_color(stc_map_gray_color);
private dev_proc_map_color_rgb(stc_map_color_gray);

/* routines for RGB-Modi */
private dev_proc_map_rgb_color(stc_map_rgb_color);
private dev_proc_map_color_rgb(stc_map_color_rgb);

/* routines for general CMYK-Modi */
private dev_proc_map_cmyk_color(stc_map_cmyk_color);
private dev_proc_map_color_rgb(stc_map_color_cmyk);

/* routines for 10Bit/Component CMYK */
private dev_proc_map_cmyk_color(stc_map_cmyk10_color);
private dev_proc_map_color_rgb(stc_map_color_cmyk10);

/***
 *** Table of Device-Procedures
 ***/
private gx_device_procs stcolor_procs = {
        stc_open,
        gx_default_get_initial_matrix,
        gx_default_sync_output,
        gdev_prn_output_page,
        stc_close,
        NULL,
        stc_map_color_cmyk,
        NULL,   /* fill_rectangle */
        NULL,   /* tile_rectangle */
        NULL,   /* copy_mono */
        NULL,   /* copy_color */
        NULL,   /* draw_line */
        gx_default_get_bits,
        stc_get_params,
        stc_put_params,
        stc_map_cmyk_color
};

/***
 *** A local dummy-array for extvals
 ***/

private float defext[] = { 0.0, 1.0 };

/***
 *** Main device-control structure
 ***/
stcolor_device far_data gs_stcolor_device = {
   prn_device_body(stcolor_device, stcolor_procs, "stcolor",
      DEFAULT_WIDTH_10THS, DEFAULT_HEIGHT_10THS,
      X_DPI,  Y_DPI,
      STC_L_MARGIN,STC_B_MARGIN,STC_R_MARGIN,STC_T_MARGIN,
      4,  4, 1, 1, 2, 2,            /* default: cmyk-direct */
      stc_print_page),
     {STCNWEAVE,                    /* stcflags:  noWeave/bidirectional */
      1,                            /* stcbits:   matches the default */
      stc_dither,                   /* stcdither: first algorithm */
      NULL,                         /* stcam:     NULL -&gt; not used */
      { NULL, NULL, NULL, NULL},    /* extcode:   none defined yet */
      {    0,    0,    0,    0},    /* sizcode:   0, since no extcode yet */
      { NULL, NULL, NULL, NULL},    /* stccode:   computed by put_params */
      {defext,defext,defext,defext},/* extvals:   default */
      {    2,    2,    2,    2},    /* sizvals:   default countof(defext) */
      { NULL, NULL, NULL, NULL},    /* stcvals:   computed by put_params */
      {    0,    0,    0},          /* white-run */
      {    0,    0,    0},          /* white-end */
      {NULL,0,false},               /* algorithm-table */
      {NULL,0,false},               /* initialization-String (BOP) */
      {NULL,0,false},               /* release-String (EOP) */
      0,0,0,0,                      /* New escp-stuff */
      1}                            /* itemsize used by algorithm */
};
/***
 *** Test for white scan-lines
 ***/
private bool stc_iswhite(stcolor_device *, int, byte *);

/***
 *** Functions used for conversion inside the print-loop
 ***/
#define stc_proc_iconvert(Name) \
byte * Name(stcolor_device *sd,byte *ext_data,int prt_pixels,byte *alg_line)

private stc_proc_iconvert(stc_any_depth);    /* general input-conversion */
private stc_proc_iconvert(stc_rgb24_long);   /* 24Bit RGB  -&gt; long's */

private stc_proc_iconvert(stc_cmyk32_long);  /* 32Bit CMYK -&gt; long's */
private stc_proc_iconvert(stc_any_direct);   /* use ext_data as input */

private stc_proc_iconvert(stc_cmyk10_byte);  /* CMYK10-&gt;vals-&gt; any type */
private stc_proc_iconvert(stc_cmyk10_long);  /* CMYK10-&gt;vals-&gt; any type */
private stc_proc_iconvert(stc_cmyk10_float); /* CMYK10-&gt;vals-&gt; any type */
private stc_proc_iconvert(stc_cmyk10_dbyte); /* CMYK10 direct bytes */
private stc_proc_iconvert(stc_cmyk10_dlong); /* CMYK10 direct longs */

/***
 *** Print-functions
 ***/
private void stc_print_weave(stcolor_device *sd,FILE *prn_stream);
private void stc_print_bands(stcolor_device *sd,FILE *prn_stream);
private void stc_print_delta(stcolor_device *sd,FILE *prn_stream);
private int  stc_print_setup(stcolor_device *sd);

/***
 *** compute the ESC/P2 specific values
 ***/

private int 
stc_print_setup(stcolor_device *sd) 
{

/*
 * Compute the resolution-parameters
 */
   sd-&gt;stc.escp_u = (int)(3600.0 / sd-&gt;y_pixels_per_inch); /* y-units */
   sd-&gt;stc.escp_h = (int)(3600.0 / sd-&gt;x_pixels_per_inch); /* x-units */
   sd-&gt;stc.escp_v = sd-&gt;stc.flags &amp; (STCUWEAVE | STCNWEAVE) ?
                    sd-&gt;stc.escp_u : 40;
/*
 * Initialize color
 */
   sd-&gt;stc.escp_c = 0; /* preselect-black */

/*
 * Band-Width
 */
   if((sd-&gt;stc.flags &amp; STCBAND) == 0) {
      if(sd-&gt;stc.escp_v != sd-&gt;stc.escp_u)            sd-&gt;stc.escp_m = 15;
      else if(STCSTCII == (sd-&gt;stc.flags &amp; STCMODEL)) sd-&gt;stc.escp_m =  1;
      else if(  sd-&gt;stc.flags &amp; STCUWEAVE)            sd-&gt;stc.escp_m =  1;
      else if((sd-&gt;stc.escp_v == sd-&gt;stc.escp_u) &amp;&amp;
              (sd-&gt;stc.escp_u == 5))                  sd-&gt;stc.escp_m =  1;
      else                                            sd-&gt;stc.escp_m =  1;
   }

/*
 * Page-Dimensions
 */
   if((sd-&gt;stc.flags &amp; STCWIDTH ) == 0)
       sd-&gt;stc.escp_width = (int)(sd-&gt;width -
           (dev_l_margin(sd)+dev_r_margin(sd))*sd-&gt;x_pixels_per_inch);

   if((sd-&gt;stc.flags &amp; STCHEIGHT) == 0)
       sd-&gt;stc.escp_height = sd-&gt;height;

   if((sd-&gt;stc.flags &amp; STCTOP) == 0)
       sd-&gt;stc.escp_top = (int)(dev_t_margin(sd)*sd-&gt;y_pixels_per_inch);

   if((sd-&gt;stc.flags &amp; STCBOTTOM) == 0)
      sd-&gt;stc.escp_bottom = (int)(sd-&gt;height - 
	    dev_b_margin(sd)*sd-&gt;y_pixels_per_inch);

   if((sd-&gt;stc.flags &amp; STCINIT) == 0) { /* No Initialization-String defined */
      int need  = 8  /* Reset, Graphics-Mode 1 */
                + 6  /* MicroWeave */
                + 6  /* Select Units */
                + 7  /* Set Page-Length */
                + 9  /* Set Margins */
                + 3; /* Select Unidirectionality */
      byte *bp  = (byte *) (sd-&gt;stc.escp_init.data);

      if(need != sd-&gt;stc.escp_init.size) {  /* Reallocate */

         if(NULL != (bp = gs_malloc(sd-&gt;memory, need,1,"stcolor/init"))) { /* Replace */
            if(0 != sd-&gt;stc.escp_init.size)
               gs_free(sd-&gt;memory, (byte *)sd-&gt;stc.escp_init.data,sd-&gt;stc.escp_init.size,1,
                       "stcolor/init");
            sd-&gt;stc.escp_init.data       = bp;
            sd-&gt;stc.escp_init.size       = need;
            sd-&gt;stc.escp_init.persistent = false;
         }  else {                                             /* Replace */
             return_error(gs_error_VMerror);
         }
      }

      if(need != 39) return_error(gs_error_unregistered);

      memcpy(bp,
/*                       1 1 11  1 11  1   1 1  2 22 2  2 22  2 22 3  3 3333  3 33*/
/* 0 1  2 34  5  6 7  8 90 1 23  4 56  7   8 9  0 12 3  4 56  7 89 0  1 2345  6 78*/
"\033@\033(G\001\0\1\033(i\1\0w\033(U\001\000u\033(C\2\000hh\033(c\4\000ttbb\033U",
             need);


      if((sd-&gt;stc.flags &amp; STCUWEAVE) != 0) bp[13] = '\1';
      else                                 bp[13] = '\0';

      bp[19] =  sd-&gt;stc.escp_u;

      bp[25] =  sd-&gt;stc.escp_height     &amp; 0xff;
      bp[26] = (sd-&gt;stc.escp_height&gt;&gt;8) &amp; 0xff;

      bp[32] =  sd-&gt;stc.escp_top        &amp; 0xff;
      bp[33] = (sd-&gt;stc.escp_top&gt;&gt;8)    &amp; 0xff;
      bp[34] =  sd-&gt;stc.escp_bottom     &amp; 0xff;
      bp[35] = (sd-&gt;stc.escp_bottom&gt;&gt;8) &amp; 0xff;

      if(sd-&gt;stc.flags &amp; STCUNIDIR)        bp[38] = 1;
      else                                 bp[38] = 0;

   }                                    /* No Initialization-String defined */

   if((sd-&gt;stc.flags &amp; STCRELEASE) == 0) { /* No Release-String defined */
      int need  = 3;  /* ESC @ \f */
      byte *bp  = (byte *) (sd-&gt;stc.escp_release.data);

      if(need != sd-&gt;stc.escp_release.size) {  /* Reallocate */

         if(NULL != (bp = gs_malloc(sd-&gt;memory, need,1,"stcolor/release"))) { /* Replace */
            if(0 != sd-&gt;stc.escp_release.size)
               gs_free(sd-&gt;memory, (byte *)sd-&gt;stc.escp_release.data,sd-&gt;stc.escp_release.size,1,
                       "stcolor/release");
            sd-&gt;stc.escp_release.data       = bp;
            sd-&gt;stc.escp_release.size       = need;
            sd-&gt;stc.escp_release.persistent = false;
         }  else {                                             /* Replace */
             return_error(gs_error_VMerror);
         }
      }

      if(need != 3) return_error(gs_error_unregistered);

      memcpy(bp,"\033@\f",need);

   }                                    /* No Release-String defined */

   return 0;
}

/***
 *** stc_print_page: here we go to do the nasty work
 ***/

private int
stc_print_page(gx_device_printer * pdev, FILE * prn_stream)
{
   stcolor_device *sd    = (stcolor_device *) pdev;
   long            flags = sd == NULL ? 0 : sd-&gt;stc.flags;

   int  npass;           /* # of print-passes (softweave) */

   int    ext_size;      /* size of a ghostscript-scanline */
   byte  *ext_line;      /* dyn: for this scanline */

   int    alg_size;      /* size of a scanline for the dithering-algorithm */
   byte  *alg_line;      /* dyn: 1 scanline for the dithering-algorithm */
   int    buf_size;      /* size of the private-buffer for dither-function */
   byte  *buf;           /* dyn: the private buffer */

   int    prt_pixels;    /* Number of pixels printed */
   byte  *col_line;      /* A Line with a byte per pixel */

#define OK4GO        ((flags &amp;   STCOK4GO)              != 0)
#define SORRY        ( flags &amp;= ~STCOK4GO)

   if(0 &gt; (npass = stc_print_setup(sd))) return_error(npass);

   npass = sd-&gt;stc.escp_v / sd-&gt;stc.escp_u;

/***
 *** Allocate dynamic memory
 ***/

   ext_size   = gdev_prn_raster(sd);
   ext_line   = gs_malloc(sd-&gt;memory, ext_size,1,"stc_print_page/ext_line");
   if(ext_line == NULL) SORRY;

   prt_pixels        = sd-&gt;stc.escp_width;
   sd-&gt;stc.prt_size  = (prt_pixels+7)/8;
   prt_pixels        =  sd-&gt;stc.prt_size * 8;

   sd-&gt;stc.prt_scans  = (int)(sd-&gt;height -
      (dev_t_margin(sd)+dev_b_margin(sd))*sd-&gt;y_pixels_per_inch);

   col_line   = gs_malloc(sd-&gt;memory, prt_pixels,1,"stc_print_page/col_line");
   if(col_line == NULL) SORRY;

   alg_size  = prt_pixels;
   alg_size *= sd-&gt;color_info.num_components;

   if((sd-&gt;stc.dither-&gt;flags &amp; STC_DIRECT) ||
      ((sd-&gt;stc.bits                 == 8) &amp;&amp;
       (sd-&gt;stc.alg_item                     == 1)))  {
      alg_line = NULL;
   } else {
      alg_line = gs_malloc(sd-&gt;memory, alg_size,sd-&gt;stc.alg_item,"stc_print_page/alg_line");
      if(alg_line == NULL) SORRY;
   }

   buf_size = sd-&gt;stc.dither-&gt;bufadd
            + alg_size*(sd-&gt;stc.dither-&gt;flags/STC_SCAN);
   if(buf_size &gt; 0) {
      buf    = gs_malloc(sd-&gt;memory, buf_size,sd-&gt;stc.alg_item,"stc_print_page/buf");
      if(buf == NULL) SORRY;
   } else {
      buf = NULL;
   }

/*
 * compute the number of printer-buffers
 */

    for(sd-&gt;stc.prt_buf   = 16; sd-&gt;stc.prt_buf &lt; (sd-&gt;stc.escp_m * npass);
        sd-&gt;stc.prt_buf &lt;&lt;= 1);
    if(sd-&gt;color_info.num_components &gt; 1) sd-&gt;stc.prt_buf *= 4;

    sd-&gt;stc.prt_width = gs_malloc(sd-&gt;memory, sd-&gt;stc.prt_buf,sizeof(int),
                        "stc_print_page/prt_width");
    if(sd-&gt;stc.prt_width == NULL) SORRY;

    sd-&gt;stc.prt_data  = gs_malloc(sd-&gt;memory, sd-&gt;stc.prt_buf,sizeof(byte *),
                        "stc_print_page/prt_data");

    if(sd-&gt;stc.prt_data == NULL) {
       SORRY;
    } else {
       int i;

       for(i = 0; i &lt; sd-&gt;stc.prt_buf; ++i) {
          sd-&gt;stc.prt_data[i] = gs_malloc(sd-&gt;memory, sd-&gt;stc.prt_size,1,
                                "stc_print_page/prt");
          if(sd-&gt;stc.prt_data[i] == NULL) SORRY;
       }
    }

    sd-&gt;stc.seed_size = (sd-&gt;stc.prt_size + 2*sizeof(int) - 1)/sizeof(int);
    {
       int i;
       for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) {
          if((flags &amp; STCCOMP) == STCDELTA) {
             sd-&gt;stc.seed_row[i] = gs_malloc(sd-&gt;memory, sd-&gt;stc.seed_size,sizeof(int),
                                   "stc_print_page/seed_row");
             if(sd-&gt;stc.seed_row[i] == NULL) SORRY;
             else memset(sd-&gt;stc.seed_row[i],0,sd-&gt;stc.seed_size*sizeof(int));
          } else {
             sd-&gt;stc.seed_row[i] = NULL;
          }
       }
       while(i &lt; countof(sd-&gt;stc.seed_row)) sd-&gt;stc.seed_row[i++] = NULL;
    }

    switch(flags &amp; STCCOMP) {
       case STCPLAIN:
          sd-&gt;stc.escp_size = 64 + sd-&gt;stc.prt_size;
          break;
       case STCDELTA:
          sd-&gt;stc.escp_size = 64 + 2 * sd-&gt;stc.prt_size;
          break;
       default:
          sd-&gt;stc.escp_size = 64 +
                              sd-&gt;stc.prt_size + (sd-&gt;stc.prt_size + 127)/128;
          break;
    }

    sd-&gt;stc.escp_data = gs_malloc(sd-&gt;memory, sd-&gt;stc.escp_size,1,
                                  "stc_print_page/escp_data");
    if(sd-&gt;stc.escp_data == NULL) SORRY;

/*
 * If we're still ok, we can print something
 */

   if(OK4GO) {

      int ncolor;
      int buf_i;
      stc_proc_iconvert((*iconvert)) = stc_any_depth;

/*
 * initialize col_line
 */
      if(sd-&gt;color_info.num_components == 3) {
         memset(col_line,RED|GREEN|BLUE,prt_pixels);
      } else {
         memset(col_line,0,             prt_pixels);
      }

/*
 * select proper conversion for input to algorithm
 */
      if(     (sd-&gt;stc.dither-&gt;flags &amp; STC_DIRECT ) ||
              ((sd-&gt;stc.bits                 == 8) &amp;&amp;
               (sd-&gt;stc.alg_item                     == 1)))
         iconvert = stc_any_direct;
      else if((sd-&gt;color_info.num_components ==  3) &amp;&amp;
              (sd-&gt;color_info.depth          == 24) &amp;&amp;
              (sizeof(long)                  == sd-&gt;stc.alg_item))
         iconvert = stc_rgb24_long;
      else if(sd-&gt;stc.flags &amp; STCCMYK10) {
         if(     ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE) &amp;&amp;
                 ( sd-&gt;stc.dither-&gt;minmax[0]         ==    0.0  ))
            iconvert = stc_cmyk10_dbyte;
         else if ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE)
            iconvert = stc_cmyk10_byte;
         else if(((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_LONG) &amp;&amp;
                 ( sd-&gt;stc.dither-&gt;minmax[0]         ==    0.0  ) &amp;&amp;
                 ( sd-&gt;stc.dither-&gt;minmax[1]         &lt;= 1023.0  ))
            iconvert = stc_cmyk10_dlong;
         else if( (sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_LONG)
            iconvert = stc_cmyk10_long;
         else
            iconvert = stc_cmyk10_float;
      }
      else if((sd-&gt;color_info.num_components ==  4) &amp;&amp;
              (sd-&gt;color_info.depth          == 32) &amp;&amp;
              (sizeof(long)                  == sd-&gt;stc.alg_item))
         iconvert = stc_cmyk32_long;

/*
 * initialize the algorithm
 */

      if((*sd-&gt;stc.dither-&gt;fun)(sd,-prt_pixels,alg_line,buf,col_line) &lt; 0)
         SORRY;

/*
 * Main-Print-Loop
 */

      if(OK4GO) {
#ifdef    STC_SIGNAL
         sigset_t stc_int_mask, stc_int_save, stc_int_pending;

         sigemptyset(&amp;stc_int_mask);
         sigaddset(&amp;stc_int_mask,SIGINT);
         sigprocmask(SIG_BLOCK,&amp;stc_int_mask, &amp;stc_int_save);
#endif /* STC_SIGNAL */


         if(sd-&gt;color_info.num_components &gt; 1) ncolor = 4;
         else                                  ncolor = 1;

/*
 * Decide, wether we Adjust Linefeeds or not. (I hate it here)
 */
         if((0   == ((sd-&gt;stc.escp_m*sd-&gt;stc.escp_u) % 10)) &amp;&amp;
            (256  &gt; ((sd-&gt;stc.escp_m*sd-&gt;stc.escp_u) / 10))) sd-&gt;stc.escp_lf = sd-&gt;stc.escp_m;
         else                                                sd-&gt;stc.escp_lf = 0;

/*
 * prepare run-values, then loop over scans
 */
         sd-&gt;stc.stc_y      =  0; /* current printer y-Position */
         sd-&gt;stc.buf_y      =  0; /* Top-Position within the buffer */
         sd-&gt;stc.prt_y      =  0; /* physical position of the printer */
         buf_i              =  0; /* next free line in buffer */
         sd-&gt;stc.flags     &amp;= ~STCPRINT; /* no data yet */

         while(sd-&gt;stc.stc_y &lt; sd-&gt;stc.prt_scans) {  /* Until all scans are processed */
            int need;

            need = sd-&gt;stc.stc_y + npass * sd-&gt;stc.escp_m;

            if(sd-&gt;stc.buf_y &lt; need) { /* Nr. 5 (give me input) */

/* read as much as the buffer can hold */
               if(ncolor == 1) need = sd-&gt;stc.stc_y +  sd-&gt;stc.prt_buf;
               else            need = sd-&gt;stc.stc_y + (sd-&gt;stc.prt_buf&gt;&gt;2);

               for(;sd-&gt;stc.buf_y &lt; need;
                    buf_i = (sd-&gt;stc.prt_buf-1) &amp; (buf_i+ncolor),
                    ++sd-&gt;stc.buf_y) {

                  int color;
                  byte *ext_data;
                  byte *alg_data;

/* initialize output data 1st -&gt; may take shortcut */

                  for(color = 0; color &lt; ncolor; ++color) {
                     memset(sd-&gt;stc.prt_data[buf_i+color],0,sd-&gt;stc.prt_size);
                     sd-&gt;stc.prt_width[buf_i+color] = 0;
                  }


/* "read data", immediately continue if all is white */

                  if(sd-&gt;stc.buf_y &lt; sd-&gt;stc.prt_scans) {  /* Test for White */

                     gdev_prn_get_bits(pdev,sd-&gt;stc.buf_y,ext_line,&amp;ext_data);

                     color = stc_iswhite(sd,prt_pixels,ext_data) ? ext_size : 0;

                  } else {

                     color = ext_size;

                  }                        /* Test for White */

                  if(color &gt;= ext_size) {  /* bypass processing */

                     if(sd-&gt;stc.dither-&gt;flags &amp; STC_WHITE)
                        (*sd-&gt;stc.dither-&gt;fun)(sd,prt_pixels,NULL,buf,col_line);
                     continue;

                  }                        /* bypass processing */

/* convert data for the various cases */

                  alg_data = (*iconvert)(sd,ext_data,prt_pixels,alg_line);


/*
 * invoke the dithering-algorithm
 */

                  (*sd-&gt;stc.dither-&gt;fun)(sd,prt_pixels,alg_data,buf,col_line);
/*
 * convert col_line to printer-format (separate colors)
 */
                  switch(sd-&gt;color_info.num_components) {
                  case 1: /* Black &amp; White: just merge into 8 Bytes */
                  {
                      byte *bytein,*byteout;
                      int   width;

                      bytein  = col_line;
                      byteout = sd-&gt;stc.prt_data[buf_i];

                      for(width = 1; width &lt;= sd-&gt;stc.prt_size; ++width) {
                          byte tmp = 0;
                          byte i;

                          for(i = 128; i; i &gt;&gt;= 1) if(*bytein++) tmp  |= i;

                          if(tmp != 0) sd-&gt;stc.prt_width[buf_i] = width;

                          *byteout++ = tmp;
                      }
                  }
                  break;
                  case 3: /* convert rgb into cmyk */
                  {
                      byte *bytein;
                      int   width;

                      bytein  = col_line;

                      for(width = 0; width &lt; sd-&gt;stc.prt_size; ++width) {
                         byte i,tmp,cmyk[4];

                         memset(cmyk,0,4);

                         for(i = 128; i; i &gt;&gt;= 1) {
                            static const byte rgb2cmyk[] = {
                               BLACK,            /* 0-&gt;Black */
                               CYAN | MAGENTA,   /* 1-&gt;BLUE  */
                               CYAN | YELLOW,    /* 2-&gt;GREEN */
                               CYAN,             /* 3-&gt;CYAN  */
                               MAGENTA | YELLOW, /* 4-&gt;RED   */
                               MAGENTA,          /* 5-&gt;MAGENTA */
                               YELLOW,           /* 6-&gt;YELLOW */
                               0};               /* 7-&gt;WHITE */

                            tmp = rgb2cmyk[(*bytein++) &amp; 7];

                            if(tmp &amp; BLACK)   cmyk[3] |= i;
                            if(tmp &amp; YELLOW)  cmyk[2] |= i;
                            if(tmp &amp; MAGENTA) cmyk[1] |= i;
                            if(tmp &amp; CYAN)    cmyk[0] |= i;
                         }

                         for(i = 0; i &lt; 4; ++i) {
                            if(cmyk[i] != 0) sd-&gt;stc.prt_width[buf_i+i] = width+1;
                            sd-&gt;stc.prt_data[buf_i+i][width] = cmyk[i];
                         }
                      }
                  }
                  break;
                  case 4: /* split cmyk */
                  {
                      byte *bytein;
                      int   width;

                      bytein  = col_line;

                      for(width = 0; width &lt; sd-&gt;stc.prt_size; ++width) {
                         byte i,tmp,cmyk[4];

                         memset(cmyk,0,4);

                         for(i = 128; i; i &gt;&gt;= 1) {
                            tmp = (*bytein++) &amp; 15;
                            if(tmp &amp; BLACK)   cmyk[3] |= i;
                            if(tmp &amp; YELLOW)  cmyk[2] |= i;
                            if(tmp &amp; MAGENTA) cmyk[1] |= i;
                            if(tmp &amp; CYAN)    cmyk[0] |= i;
                         }

                         for(i = 0; i &lt; 4; ++i) {
                            if(cmyk[i] != 0) sd-&gt;stc.prt_width[buf_i+i] = width+1;
                            sd-&gt;stc.prt_data[buf_i+i][width] = cmyk[i];
                         }
                      }
                  }
                  break;
                  default: break;
                  }
               }
            }                  /* Nr. 5 (give me input) */

/*
 *    Nr. 5 has got enough input, now we should print it
 */
            if((flags &amp; STCCOMP) == STCDELTA) stc_print_delta(sd,prn_stream);
            else if(npass &gt; 1)                stc_print_weave(sd,prn_stream);
            else                              stc_print_bands(sd,prn_stream);

#ifdef    STC_SIGNAL
            sigpending(&amp;stc_int_pending);
            if(sigismember(&amp;stc_int_pending,SIGINT)) {
               fputs("\033@[Aborted]\f", prn_stream);
               fflush(prn_stream);
               sigprocmask(SIG_SETMASK,&amp;stc_int_save,NULL);
               break;
            }
#endif /* STC_SIGNAL */

         }                           /* Until all scans are processed */

         if(sd-&gt;stc.flags &amp; STCPRINT) {
            if((flags &amp; STCCOMP) == STCDELTA) fputc(0xe3,prn_stream);
            fwrite(sd-&gt;stc.escp_release.data,1,sd-&gt;stc.escp_release.size,prn_stream);
            fflush(prn_stream);
         }
#ifdef    STC_SIGNAL
         sigprocmask(SIG_SETMASK,&amp;stc_int_save,NULL);
#endif /* STC_DIGNAL */
  
      }
   }

/***
 *** Release the dynamic memory
 ***/

   if(ext_line != NULL)
      gs_free(sd-&gt;memory, ext_line,ext_size,1,"stc_print_page/ext_line");

   if(col_line != NULL)
      gs_free(sd-&gt;memory, col_line,prt_pixels,1,"stc_print_page/col_line");

   if(alg_line != NULL)
      gs_free(sd-&gt;memory, alg_line,alg_size,sd-&gt;stc.alg_item,
         "stc_print_page/alg_line");

   if(buf != NULL)
      gs_free(sd-&gt;memory, buf,buf_size,sd-&gt;stc.alg_item,"stc_print_page/buf");

    if(sd-&gt;stc.prt_width != NULL)
       gs_free(sd-&gt;memory, sd-&gt;stc.prt_width,sd-&gt;stc.prt_buf,sizeof(int),
       "stc_print_page/prt_width");

    if(sd-&gt;stc.prt_data != NULL) {
       int i;

       for(i = 0; i &lt; sd-&gt;stc.prt_buf; ++i) {
          if(sd-&gt;stc.prt_data[i] != NULL)
             gs_free(sd-&gt;memory, sd-&gt;stc.prt_data[i],sd-&gt;stc.prt_size,1,
             "stc_print_page/prt");
       }

       gs_free(sd-&gt;memory, sd-&gt;stc.prt_data,sd-&gt;stc.prt_buf,sizeof(byte *),
       "stc_print_page/prt_data");
    }

    {
       int i;
       for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) {
          if(sd-&gt;stc.seed_row[i] != NULL)
            gs_free(sd-&gt;memory, sd-&gt;stc.seed_row[i],sd-&gt;stc.seed_size,sizeof(int),
            "stc_print_page/seed_row");
       }
    }

    if(sd-&gt;stc.escp_data != NULL)
       gs_free(sd-&gt;memory, sd-&gt;stc.escp_data,sd-&gt;stc.escp_size,1,
       "stc_print_page/escp_data");

   return OK4GO ? 0 : gs_error_undefined;
}

/*
 * white-check
 */
private bool 
stc_iswhite(stcolor_device *sd, int prt_pixels,byte *ext_data)
{
   long  b2do = (prt_pixels*sd-&gt;color_info.depth+7)&gt;&gt;3;
   int   bcmp = 4 * countof(sd-&gt;stc.white_run);
   byte *wht  = (byte *) sd-&gt;stc.white_run;

   while(b2do &gt;= bcmp) {
      if(memcmp(ext_data,wht,bcmp)) break;
      ext_data += bcmp;
      b2do     -= bcmp;
   }

   if((b2do &gt; 0) &amp;&amp; (b2do &lt; bcmp))
      b2do  = memcmp(ext_data,sd-&gt;stc.white_end,b2do);

   return b2do ? false : true;
}

/***
 *** A bunch of routines that convert gslines into algorithms format.
 ***/
private byte *
stc_any_depth(stcolor_device *sd,byte *ext_data,int prt_pixels,byte *alg_line)
{ /* general conversion */

   int p,c,       niext,         nbits;
   gx_color_index ciext,ci,cimsk,cvmsk;
   byte          *ap = alg_line;

   nbits =  sd-&gt;stc.bits;
   cvmsk = ((gx_color_index) 1&lt;&lt;nbits) - 1;

/* it is nonsense to use this algorithm for this cases, but if it claims
 * generality, it should deliver correct results in this cases too */
   if(sd-&gt;color_info.depth == (sd-&gt;color_info.num_components&lt;&lt;3)) nbits = 8;

   cimsk = cvmsk;
   for(c = 1; c &lt; sd-&gt;color_info.num_components; ++c)
       cimsk = (cimsk&lt;&lt;nbits) | cvmsk;

   ciext = 0;
   niext = 0;

   for(p = 0; p &lt; prt_pixels; ++p) { /* over pixels */

      ci = ciext;
      for(c =  sd-&gt;color_info.depth-niext; c &gt;= 8; c -= 8)
         ci  = (ci&lt;&lt;8) | *ext_data++;

      if(c &gt; 0) {         /* partial byte required */

         niext  = 8 - c;
         ciext  = *ext_data++;
         ci     = (ci&lt;&lt;c) | (ciext&gt;&gt;niext);
         ciext &amp;= (1L&lt;&lt;niext)-1;

      } else if(c &lt; 0) { /* some bits left in ciext */

         niext  = -c;
         ciext &amp;= (1L&lt;&lt;niext)-1;
         ci     = ci&gt;&gt;niext;

      } else {           /* entire ciext used */

         niext = 0;
         ciext = 0;

      }                  /* ciext-adjust */

      ci &amp;= cimsk;

#     define stc_storeapc(T) \
         ((T *)ap)[c] = ((T *)(sd-&gt;stc.vals[c]))[ci &amp; cvmsk];

      for(c = sd-&gt;color_info.num_components; c--;) { /* comp */
         STC_TYPESWITCH(sd-&gt;stc.dither,stc_storeapc)
         ci &gt;&gt;= nbits;
      }                                              /* comp */

#     undef  stc_storeapc

      ap += sd-&gt;color_info.num_components * sd-&gt;stc.alg_item;

   }                                 /* over pixels */

   return alg_line;
} /* general conversion */

/*
 * rgb-data with depth=24, can use a faster algorithm
 */
private byte *
stc_rgb24_long(stcolor_device *sd,byte *ext_data,int prt_pixels,byte *alg_line)
{ /* convert 3 bytes into appropriate long-Values */
  register int   p;
  register long *out   = (long *) alg_line;
  register long *rvals = (long *) (sd-&gt;stc.vals[0]);
  register long *gvals = (long *) (sd-&gt;stc.vals[1]);
  register long *bvals = (long *) (sd-&gt;stc.vals[2]);

  for(p = prt_pixels; p; --p) {
     *out++ = rvals[*ext_data++];
     *out++ = gvals[*ext_data++];
     *out++ = bvals[*ext_data++];
  }

  return alg_line;
} /* convert 3 bytes into appropriate long-Values */

/*
 * cmyk-data with depth=32, can use a faster algorithm
 */
private byte *
stc_cmyk32_long(stcolor_device *sd,byte *ext_data,int prt_pixels,byte *alg_line)
{ /* convert 4 bytes into appropriate long-Values */
  register int   p;
  register long *out   = (long *) alg_line;
  register long *cvals = (long *) (sd-&gt;stc.vals[0]);
  register long *mvals = (long *) (sd-&gt;stc.vals[1]);
  register long *yvals = (long *) (sd-&gt;stc.vals[2]);
  register long *kvals = (long *) (sd-&gt;stc.vals[3]);

  for(p = prt_pixels; p; --p) {
     *out++ = cvals[*ext_data++];
     *out++ = mvals[*ext_data++];
     *out++ = yvals[*ext_data++];
     *out++ = kvals[*ext_data++];
  }

  return alg_line;
} /* convert 4 bytes into appropriate long-Values */

/*
 * handle indirect encoded cmyk-data
 */
#define STC_CMYK10_ANY(T)\
                                                                            \
      register int p               = prt_pixels;                            \
      register stc_pixel      ci,k,n,mode;                                  \
      register stc_pixel      *in  = (stc_pixel *) ext_data;                \
      register T              *out = (T *) alg_line;                        \
      register T              *cv  = (T *) sd-&gt;stc.vals[0];                 \
      register T              *mv  = (T *) sd-&gt;stc.vals[1];                 \
      register T              *yv  = (T *) sd-&gt;stc.vals[2];                 \
      register T              *kv  = (T *) sd-&gt;stc.vals[3];                 \
                                                                            \
      while(p--) {                                                          \
         ci   = *in++;                                                      \
         mode = ci &amp; 3;                                                     \
         k    = (ci&gt;&gt;2) &amp; 0x3ff;                                            \
         if(mode == 3) {                                                    \
            *out++ = cv[0];                                                 \
            *out++ = mv[0];                                                 \
            *out++ = yv[0];                                                 \
            *out++ = kv[k];                                                 \
         } else {                                                           \
            out[3] = kv[k];                                                 \
            n = (ci&gt;&gt;12) &amp; 0x3ff;                                           \
            if(mode == 2) { out[2] = yv[k]; }                               \
            else          { out[2] = yv[n]; n = (ci&gt;&gt;22) &amp; 0x3ff; }         \
            if(mode == 1) { out[1] = mv[k]; }                               \
            else          { out[1] = mv[n]; n = (ci&gt;&gt;22) &amp; 0x3ff; }         \
            if(mode == 0)   out[0] = cv[k];                                 \
            else            out[0] = cv[n];                                 \
            out += 4;                                                       \
         }                                                                  \
      }                                                                     \
                                                                            \
      return alg_line;

private byte *
stc_cmyk10_byte(stcolor_device *sd,
                byte *ext_data,int prt_pixels,byte *alg_line)
{
   STC_CMYK10_ANY(byte)
}
private byte *
stc_cmyk10_long(stcolor_device *sd,
                byte *ext_data,int prt_pixels,byte *alg_line)
{
   STC_CMYK10_ANY(long)
}
private byte *
stc_cmyk10_float(stcolor_device *sd,
                byte *ext_data,int prt_pixels,byte *alg_line)
{
   STC_CMYK10_ANY(float)
}

#undef  STC_CMYK10_ANY

#define STC_CMYK10_DANY(T)\
                                                                            \
      register int p               = prt_pixels;                            \
      register stc_pixel       ci,k,n,mode;                                 \
      register stc_pixel      *in  = (stc_pixel *) ext_data;                \
      register T              *out = (T *) alg_line;                        \
                                                                            \
      while(p--) {                                                          \
         ci   = *in++;                                                      \
         mode = ci &amp; 3;                                                     \
         k    = (ci&gt;&gt;2) &amp; 0x3ff;                                            \
         if(mode == 3) {                                                    \
            *out++ = 0;                                                     \
            *out++ = 0;                                                     \
            *out++ = 0;                                                     \
            *out++ = k;                                                     \
         } else {                                                           \
            out[3] = k;                                                     \
            n = (ci&gt;&gt;12) &amp; 0x3ff;                                           \
            if(mode == 2) { out[2] = k; }                                   \
            else          { out[2] = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }             \
            if(mode == 1) { out[1] = k; }                                   \
            else          { out[1] = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }             \
            if(mode == 0)   out[0] = k;                                     \
            else            out[0] = n;                                     \
            out += 4;                                                       \
         }                                                                  \
      }                                                                     \
                                                                            \
      return alg_line;


private byte *
stc_cmyk10_dbyte(stcolor_device *sd,
                byte *ext_data,int prt_pixels,byte *alg_line)
{
   STC_CMYK10_DANY(byte)
}
private byte *
stc_cmyk10_dlong(stcolor_device *sd,
                byte *ext_data,int prt_pixels,byte *alg_line)
{
   STC_CMYK10_DANY(long)
}

#undef  STC_CMYK10_DANY

/*
 * if the algorithm uses bytes &amp; bytes are in ext_data, use them
 */
/*ARGSUSED*/
private byte *
stc_any_direct(stcolor_device *sd,byte *ext_data,int prt_pixels,byte *alg_line)
{ /* return ext_data */
  return ext_data;
} /* return ext_data */

/* ----------------------------------------------------------------------- */
/* stc_rle: epson ESC/P2 RLE-Encoding
 */
private int 
stc_rle(byte *out,const byte *in,int width)
{

   int used = 0;
   int crun,cdata;
   byte run;

   if(in != NULL) { /* Data present */

      crun = 1;

      while(width &gt; 0) { /* something to compress */

         run = in[0];

         while((width &gt; crun) &amp;&amp; (run == in[crun])) if(++crun == 129) break;

         if((crun &gt; 2) || (crun == width)) { /* use this run */

            *out++ = (257 - crun) &amp; 0xff; *out++ = run; used += 2;

            width -= crun; in    += crun;
            crun = 1;

         } else {                            /* ignore this run */

            for(cdata = crun; (width &gt; cdata) &amp;&amp; (crun &lt; 4);) {
               if(run  == in[cdata]) crun += 1;
               else run = in[cdata], crun  = 1;
               if(++cdata == 128) break;
            }

            if(crun &lt; 3) crun   = 0;    /* ignore trailing run */
            else         cdata -= crun;

            *out++ = cdata-1;     used++;
            memcpy(out,in,cdata); used += cdata; out   += cdata;

            width -= cdata; in    += cdata;

         }              /* use/ignore run */

      }                  /* something to compress */

   } else {         /* Empty scans to fill bands */

      while(width &gt; 0) {
         crun   = width &gt; 129 ? 129 : width;
         width -= crun;
         *out++ = (257 - crun) &amp; 0xff;
         *out++ = 0;
         used  += 2;
      }
   }                /* Data present or empty */
   return used;
}


/*
 * Horizontal &amp; vertical positioning, color-selection, "ESC ."
 */
private int 
stc_print_escpcmd(stcolor_device *sd, FILE *prn_stream,
   int escp_used, int color,int m,int wbytes)
{

   int dy  = sd-&gt;stc.stc_y - sd-&gt;stc.prt_y; /* number of units to skip */
   int nlf;

/* ESC-R color codes, used only here */
   static const byte stc_colors[] = { 0x02, 0x01, 0x04, 0x00 }; /* CMYK */

/*
 * initialize the printer, if necessary
 */
   if(0 == (sd-&gt;stc.flags &amp; STCPRINT)) {

      fwrite(sd-&gt;stc.escp_init.data,1,sd-&gt;stc.escp_init.size,prn_stream);

      if(0 &lt; sd-&gt;stc.escp_lf) { /* Adjust Linefeed */
         fputc('\033',        prn_stream);
         fputc('+',           prn_stream);
         fputc(((sd-&gt;stc.escp_m*sd-&gt;stc.escp_u) / 10),prn_stream);
      }                         /* Adjust Linefeed */
      sd-&gt;stc.flags |= STCPRINT;
   }

   sd-&gt;stc.escp_data[escp_used++]  = '\r';     /* leftmost position */

   if(dy) {                                    /* position the printer */
      if(( sd-&gt;stc.escp_lf      &gt;  0) &amp;&amp; /* Linefeed allowed */
         ((dy % sd-&gt;stc.escp_lf) == 0))   /* and possible */
            nlf = dy / sd-&gt;stc.escp_lf;
      else  nlf = 7;
         
      if(nlf &gt; 6) {
         sd-&gt;stc.escp_data[escp_used++]  = '\033';
         sd-&gt;stc.escp_data[escp_used++]  = '(';
         sd-&gt;stc.escp_data[escp_used++]  = 'V';
         sd-&gt;stc.escp_data[escp_used++]  = '\002';
         sd-&gt;stc.escp_data[escp_used++]  = '\000';
         sd-&gt;stc.escp_data[escp_used++]  =  sd-&gt;stc.stc_y       &amp; 0xff;
         sd-&gt;stc.escp_data[escp_used++]  = (sd-&gt;stc.stc_y &gt;&gt; 8) &amp; 0xff;
      } else {
         while(nlf--) sd-&gt;stc.escp_data[escp_used++] = '\n';
      }
      sd-&gt;stc.prt_y = sd-&gt;stc.stc_y;
   }                                           /* position the printer */

   if((sd-&gt;color_info.num_components &gt; 1) &amp;&amp;
      (sd-&gt;stc.escp_c != stc_colors[color])) { /* select color */
       sd-&gt;stc.escp_data[escp_used++]  = '\033';
       sd-&gt;stc.escp_data[escp_used++]  = 'r';
       sd-&gt;stc.escp_c                  = stc_colors[color];
       sd-&gt;stc.escp_data[escp_used++]  = sd-&gt;stc.escp_c;
   }                                           /* select color */

/*
 * Build the command used
 */
   sd-&gt;stc.escp_data[escp_used++] = '\033';
   sd-&gt;stc.escp_data[escp_used++] = '.';
   sd-&gt;stc.escp_data[escp_used++] =
       (sd-&gt;stc.flags &amp; STCCOMP) == STCPLAIN ? 0 : 1;
   sd-&gt;stc.escp_data[escp_used++] = sd-&gt;stc.escp_v;
   sd-&gt;stc.escp_data[escp_used++] = sd-&gt;stc.escp_h;
   sd-&gt;stc.escp_data[escp_used++] = m;
   sd-&gt;stc.escp_data[escp_used++] = (wbytes&lt;&lt;3) &amp; 0xff; /* width in Pixels */
   sd-&gt;stc.escp_data[escp_used++] = (wbytes&gt;&gt;5) &amp; 0xff;

   return escp_used;
}

/*
 * compute width of a group of scanlines
 */
private int 
stc_bandwidth(stcolor_device *sd,int color,int m,int npass)
{
   int ncolor = sd-&gt;color_info.num_components == 1 ? 1 : 4;
   int buf_a  = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor + color);
   int w      = 0;

   while(m-- &gt; 0) { /* check width */
      if(sd-&gt;stc.prt_width[buf_a] &gt; w) w = sd-&gt;stc.prt_width[buf_a];
      buf_a = (sd-&gt;stc.prt_buf-1) &amp; (buf_a + ncolor * npass);
   }                       /* check width */

   return w;
}

/*
 * Multi-Pass Printing-Routine
 */
private void 
stc_print_weave(stcolor_device *sd, FILE *prn_stream)
{

   int escp_used,nprint,nspace,color,buf_a,iprint,w;

   int npass  = sd-&gt;stc.escp_v / sd-&gt;stc.escp_u;
   int ncolor = sd-&gt;color_info.num_components == 1 ? 1 : 4;


   while(sd-&gt;stc.stc_y &lt; sd-&gt;stc.prt_scans) {

/*
 * compute spacing &amp; used heads (seems to work with odd escp_m)
 */
      if(sd-&gt;stc.stc_y &gt;= sd-&gt;stc.escp_m) { /* in normal mode */
         nprint = sd-&gt;stc.escp_m;
         nspace = sd-&gt;stc.escp_m;
      } else if((sd-&gt;stc.stc_y) &lt; npass) {                /* initialisation */
         nprint = sd-&gt;stc.escp_m - sd-&gt;stc.stc_y * ((sd-&gt;stc.escp_m+1)/npass);
         nspace = 1;
      } else {                                   /* switch to normal */
         nprint = sd-&gt;stc.escp_m - sd-&gt;stc.stc_y * ((sd-&gt;stc.escp_m+1)/npass);
         nspace = sd-&gt;stc.escp_m - sd-&gt;stc.stc_y;
      }
      iprint = sd-&gt;stc.stc_y + npass * nprint;
      if(sd-&gt;stc.buf_y &lt; iprint) break;

      escp_used = 0;
      for(color = 0; color &lt; ncolor; ++color) { /* print the colors */

         if(0 == (w = stc_bandwidth(sd,color,nprint,npass))) continue;

         escp_used = stc_print_escpcmd(sd,prn_stream,
                                       escp_used,color,sd-&gt;stc.escp_m,w);

         buf_a = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor + color);
         for(iprint = 0; iprint &lt; nprint; ++iprint) { /* send data */

            if((sd-&gt;stc.flags &amp; STCCOMP) == STCPLAIN) {
               memcpy(sd-&gt;stc.escp_data+escp_used,sd-&gt;stc.prt_data[buf_a],w);
               escp_used += w;
            } else {
               escp_used += stc_rle(sd-&gt;stc.escp_data+escp_used,
                                    sd-&gt;stc.prt_data[buf_a],w);
            }

            fwrite(sd-&gt;stc.escp_data,1,escp_used,prn_stream);
            escp_used = 0;

            buf_a = (sd-&gt;stc.prt_buf-1) &amp; (buf_a + ncolor * npass);

         }                                            /* send data */

         while(iprint++ &lt; sd-&gt;stc.escp_m) {  /* add empty rows */

            if((sd-&gt;stc.flags &amp; STCCOMP) == STCPLAIN) {
               memset(sd-&gt;stc.escp_data+escp_used,0,w);
               escp_used += w;
            } else {
               escp_used += stc_rle(sd-&gt;stc.escp_data+escp_used,NULL,w);
            }

            fwrite(sd-&gt;stc.escp_data,1,escp_used,prn_stream);
            escp_used = 0;
         }                               /* add empty rows */
      }                                             /* print the colors */

      sd-&gt;stc.stc_y += nspace;
   }
}

/*
 * Single-Pass printing-Routine
 */
private void 
stc_print_bands(stcolor_device *sd, FILE *prn_stream)
{

   int escp_used,color,buf_a,iprint,w,m;

   int ncolor = sd-&gt;color_info.num_components == 1 ? 1 : 4;

   while(sd-&gt;stc.stc_y &lt; sd-&gt;stc.prt_scans) {

/*
 * find the begin of the band
 */
      for(w = 0; sd-&gt;stc.stc_y &lt; sd-&gt;stc.buf_y; ++sd-&gt;stc.stc_y) {
         buf_a = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor);
         for(color = 0; color &lt; ncolor; ++color)
            if(sd-&gt;stc.prt_width[buf_a+color] &gt; w)
               w = sd-&gt;stc.prt_width[buf_a+color];
         if(w != 0) break;
      }
      if(w == 0) break;
/*
 * adjust the band-height
 */
      w = sd-&gt;stc.prt_scans - sd-&gt;stc.stc_y;
      if((w &lt; sd-&gt;stc.escp_m) &amp;&amp; (sd-&gt;stc.escp_v != 40)) {
         if(w &lt; 8)       m =  1;
         else if(w &lt; 24) m =  8;
         else            m = 24;
      } else {
         m = sd-&gt;stc.escp_m;
      }

      if(sd-&gt;stc.buf_y &lt; (sd-&gt;stc.stc_y+m)) break;

      escp_used = 0;
      for(color = 0; color &lt; ncolor; ++color) { /* print the colors */

         if(0 == (w = stc_bandwidth(sd,color,m,1))) continue; /* shortcut */

         escp_used = stc_print_escpcmd(sd,prn_stream,escp_used,color,m,w);

         buf_a = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor + color);
         for(iprint = 0; iprint &lt; m; ++iprint) { /* send data */

            if((sd-&gt;stc.flags &amp; STCCOMP) == STCPLAIN) {
               memcpy(sd-&gt;stc.escp_data+escp_used,sd-&gt;stc.prt_data[buf_a],w);
               escp_used += w;
            } else {
               escp_used += stc_rle(sd-&gt;stc.escp_data+escp_used,
                                    sd-&gt;stc.prt_data[buf_a],w);
            }

            fwrite(sd-&gt;stc.escp_data,1,escp_used,prn_stream);
            escp_used = 0;

            buf_a = (sd-&gt;stc.prt_buf-1) &amp; (buf_a + ncolor);

         }                                            /* send data */

      }                                             /* print the colors */

      sd-&gt;stc.stc_y += m;
   }
}
/* ----------------------------------------------------------------------- */

private int 
stc_deltarow(byte *out,const byte *in,int width,byte *seed)
{

   int istop,nmove,ndata,i,j;
   int *wseed = (int *) seed;
   int used   = 0;

   seed += sizeof(int);

   if((in != NULL) &amp;&amp; (width &gt; 0)) { /* Data present */

      istop = width &lt; wseed[0] ? wseed[0] : width;

      i = 0;
      while(i &lt; istop) {

         for(j = i; j &lt; istop; ++j) if(in[j] != seed[j]) break;

         nmove = j - i;

         if(nmove &gt; 0) { /* issue a move */
           i     = j;
           if(i == istop) break;

           if(       nmove &lt;   8) {
              out[used++] = 0x40 | nmove;
           } else if(nmove &lt; 128) {
              out[used++] = 0x51;
              out[used++] = nmove;
           } else {
              out[used++] = 0x52;
              out[used++] = 0xff &amp; nmove;
              out[used++] = 0xff &amp; (nmove&gt;&gt;8);
           }
         }           /* issue a move */

/*
 * find the end of this run
 */
         nmove = 0;
         for(j = i+1; (j &lt; istop) &amp;&amp; ((nmove &lt; 4)); ++j) {
            if(in[j] == seed[j]) nmove += 1;
            else                 nmove  = 0;
         }

         ndata = j-i-nmove;

         nmove = stc_rle(out+used+3,in+i,ndata);
         if(nmove &lt; 16) {
            out[used++] = 0x20 | nmove;
            for(j = 0; j &lt; nmove; ++j) out[used+j] = out[used+j+2];
         } else if(nmove &lt; 256) {
            out[used++] = 0x31;
            out[used++] = nmove;
            for(j = 0; j &lt; nmove; ++j) out[used+j] = out[used+j+1];
         } else {
            out[used++] = 0x32;
            out[used++] = 0xff &amp; nmove;
            out[used++] = 0xff &amp; (nmove&gt;&gt;8);
         }
         used += nmove;
         i    += ndata;
      }

      memcpy(seed,in,istop);
      wseed[0] = width;

   } else if(wseed[0] &gt; 0) { /* blank line, but seed has data */

      out[used++] = 0xe1; /* clear row */
      memset(seed,0,wseed[0]);
      wseed[0] = 0;

   }

   return used;
}

/*
 * Slightly different single-pass printing
 */
private void
stc_print_delta(stcolor_device *sd, FILE *prn_stream)
{

   int color,buf_a,w;
   int escp_used = 0; 
   int ncolor = sd-&gt;color_info.num_components == 1 ? 1 : 4;

   while(sd-&gt;stc.stc_y &lt; sd-&gt;stc.prt_scans) {

/*
 * find the begin of the band
 */
      for(w = 0; sd-&gt;stc.stc_y &lt; sd-&gt;stc.buf_y; ++sd-&gt;stc.stc_y) {
         buf_a = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor);
         for(color = 0; color &lt; ncolor; ++color)
            if(sd-&gt;stc.prt_width[buf_a+color] &gt; w)
               w = sd-&gt;stc.prt_width[buf_a+color];
         if(w != 0) break;
      }

      if(sd-&gt;stc.buf_y == sd-&gt;stc.stc_y) break;

      escp_used = 0;

/*
 * Send Initialization &amp; ESC . 3 once
 */
      if(0 == (sd-&gt;stc.flags &amp; STCPRINT)) {

         sd-&gt;stc.flags |= STCPRINT;

         fwrite(sd-&gt;stc.escp_init.data,1,sd-&gt;stc.escp_init.size,prn_stream);

         sd-&gt;stc.escp_data[escp_used++] = '\033';
         sd-&gt;stc.escp_data[escp_used++] = '.';
         sd-&gt;stc.escp_data[escp_used++] =  3;
         sd-&gt;stc.escp_data[escp_used++] = sd-&gt;stc.escp_v;
         sd-&gt;stc.escp_data[escp_used++] = sd-&gt;stc.escp_h;
         sd-&gt;stc.escp_data[escp_used++] = sd-&gt;stc.escp_m;
         sd-&gt;stc.escp_data[escp_used++] = 0;
         sd-&gt;stc.escp_data[escp_used++] = 0;
         sd-&gt;stc.escp_data[escp_used++] = 0xe4; /* MOVXBYTE */
      }

      if(sd-&gt;stc.stc_y != sd-&gt;stc.prt_y) { /* really position the printer */
         w = sd-&gt;stc.stc_y - sd-&gt;stc.prt_y;
         if(       w &lt;  16) {
            sd-&gt;stc.escp_data[escp_used++] = 0x60 | w;
         } else if(w &lt; 256) {
            sd-&gt;stc.escp_data[escp_used++] = 0x71;
            sd-&gt;stc.escp_data[escp_used++] = w;
         } else {
            sd-&gt;stc.escp_data[escp_used++] = 0x72;
            sd-&gt;stc.escp_data[escp_used++] = 0xff &amp; w;
            sd-&gt;stc.escp_data[escp_used++] = 0xff &amp; (w&gt;&gt;8);
         }
         sd-&gt;stc.prt_y = sd-&gt;stc.stc_y;
      }                                    /* really position the printer */

      for(color = 0; color &lt; ncolor; ++color) { /* print the colors */

/* Color-Selection */
         if(color == (ncolor-1)) {
            sd-&gt;stc.escp_data[escp_used++] = 0x80; /* Black */
         } else {
            switch(color) {
            case 1:  sd-&gt;stc.escp_data[escp_used++] = 0x81; break; /* M */
            case 2:  sd-&gt;stc.escp_data[escp_used++] = 0x84; break; /* Y */
            default: sd-&gt;stc.escp_data[escp_used++] = 0x82; break; /* C */
            }
         }

/* Data-Transfer */
         buf_a = (sd-&gt;stc.prt_buf-1) &amp; (sd-&gt;stc.stc_y * ncolor + color);

         w = stc_deltarow(sd-&gt;stc.escp_data+escp_used,
             sd-&gt;stc.prt_data[buf_a],sd-&gt;stc.prt_width[buf_a],
             sd-&gt;stc.seed_row[color]);

         if(w == 0) escp_used -= 1;
         else       escp_used += w;

         if(escp_used &gt; 0) fwrite(sd-&gt;stc.escp_data,1,escp_used,prn_stream);
         escp_used = 0;

      }                                             /* print the colors */

      sd-&gt;stc.stc_y += 1;

   }

}

/* ----------------------------------------------------------------------- */

/***
 *** Free-Data: release the specific-Arrays
 ***/
private void 
stc_freedata(gs_memory_t *mem, stc_t *stc)
{
   int i,j;

   for(i = 0; i &lt; 4; ++i) {
      if(stc-&gt;code[i] != NULL) {

         for(j = 0; j &lt; i; ++j) if(stc-&gt;code[i] == stc-&gt;code[j]) break;

         if(i == j) gs_free(mem, stc-&gt;code[i],1&lt;&lt;stc-&gt;bits,sizeof(gx_color_value),
                           "stcolor/code");
      }

      if(stc-&gt;vals[i] != NULL) {

         for(j = 0; j &lt; i; ++j)
            if(stc-&gt;vals[i] == stc-&gt;vals[j]) break;

         if(i == j) gs_free(mem, stc-&gt;vals[i],1&lt;&lt;stc-&gt;bits,sd-&gt;stc.alg_item,
                           "stcolor/transfer");
      }
   }

   for(i = 0; i &lt; 4; ++i) {
      stc-&gt;code[i] = NULL;
      stc-&gt;vals[i] = NULL;
   }
}

/***
 *** open the device and initialize margins &amp; arrays
 ***/

private int 
stc_open(gx_device *pdev) /* setup margins &amp; arrays */
{
  stcolor_device *sd = (stcolor_device *) pdev;
  int i,j,code;
  gx_color_index white;
  byte *bpw,*bpm;

  code = 0;
/*
 * Establish Algorithm-Table, if not present
 */
  if(sd-&gt;stc.algorithms.size == 0) {
     gs_param_string *dp;
     for(i = 0; stc_dither[i].name != NULL; ++i); /* count 'em */
     sd-&gt;stc.algorithms.size = i;
     dp = gs_malloc(sd-&gt;memory, i,sizeof(gs_param_string),
                                        "stcolor/algorithms");
     if(dp == NULL) {
        code = gs_error_VMerror;
        sd-&gt;stc.algorithms.size = 0;
     } else {
        sd-&gt;stc.algorithms.data       = dp;
        sd-&gt;stc.algorithms.persistent = true;
        for(i = 0; stc_dither[i].name != NULL; ++i) {
        param_string_from_string(dp[i],stc_dither[i].name);
        }
     }
  }

# define stc_sizeofitem(T) sd-&gt;stc.alg_item = sizeof(T)
  STC_TYPESWITCH(sd-&gt;stc.dither,stc_sizeofitem)

  stc_print_setup(sd);

/*
 * Establish internal Value &amp; Code-Arrays
 */


  for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) { /* comp */

     if((sd-&gt;stc.sizc[i] &gt;  1) &amp;&amp; (sd-&gt;stc.extc[i] != NULL)) { /* code req. */

        for(j = 0; j &lt; i; ++j) if(sd-&gt;stc.extc[i] == sd-&gt;stc.extc[j]) break;

        if(i == j) { /* new one */
           sd-&gt;stc.code[i] = gs_malloc(sd-&gt;memory, 1&lt;&lt;sd-&gt;stc.bits,sizeof(gx_color_value),
                             "stcolor/code");

           if(sd-&gt;stc.code[i] == NULL) { /* error */
              code = gs_error_VMerror;
           } else {                      /* success */
/*
 * Try making things easier:
 *     normalize values to 0.0/1.0-Range
 *     X-Axis:   Color-Values (implied)
 *     Y-Values: Indices      (given)
 */
              unsigned long ly,iy;
              double ystep,xstep,fx,fy;

/* normalize */

              fx =  1e18;
              fy = -1e18;
              for(ly = 0; ly &lt; sd-&gt;stc.sizc[i]; ++ly) {
                 if(sd-&gt;stc.extc[i][ly] &lt; fx) fx = sd-&gt;stc.extc[i][ly];
                 if(sd-&gt;stc.extc[i][ly] &gt; fy) fy = sd-&gt;stc.extc[i][ly];
              }
              if((fx != 0.0) || (fy != 1.0)) {
                 fy = 1.0 / (fy - fx);
                 for(ly = 0; ly &lt; sd-&gt;stc.sizc[i]; ++ly)
                    sd-&gt;stc.extc[i][ly] = fy * (sd-&gt;stc.extc[i][ly]-fx);
              }

/* interpolate */
              ystep = 1.0 / (double)((1&lt;&lt;sd-&gt;stc.bits)-1);
              xstep = 1.0 / (double)( sd-&gt;stc.sizc[i] -1);

              iy = 0;
              for(ly = 0; ly &lt; (1&lt;&lt;sd-&gt;stc.bits); ++ly) {
                 fy = ystep * ly;
                 while(((iy+1) &lt; sd-&gt;stc.sizc[i]) &amp;&amp;
                       (  fy   &gt; sd-&gt;stc.extc[i][iy+1])) ++iy;
                 fx  = iy + (fy - sd-&gt;stc.extc[i][iy])
                            / (sd-&gt;stc.extc[i][iy+1] - sd-&gt;stc.extc[i][iy]);
                 fx *= xstep * gx_max_color_value;

                 fx = fx &lt; 0.0 ? 0.0 :
                      (fx &gt; gx_max_color_value ? gx_max_color_value : fx);

                 sd-&gt;stc.code[i][ly] = (gx_color_value)fx;
                 if((fx-sd-&gt;stc.code[i][ly]) &gt;= 0.5) sd-&gt;stc.code[i][ly] += 1;
              }
           }                             /* error || success */

        } else {     /* shared one */

           sd-&gt;stc.code[i] = sd-&gt;stc.code[j];

        }           /* new || shared one */
     }                                                         /* code req. */

     if((sd-&gt;stc.sizv[i] &gt;  1) &amp;&amp; (sd-&gt;stc.extv[i] != NULL)) { /* vals req. */

        for(j = 0; j &lt; i; ++j)
           if((sd-&gt;stc.extc[i] == sd-&gt;stc.extc[j]) &amp;&amp;
              (sd-&gt;stc.extv[i] == sd-&gt;stc.extv[j])) break;

        if(i == j) { /* new one */

             sd-&gt;stc.vals[i] =
                gs_malloc(sd-&gt;memory, 1&lt;&lt;sd-&gt;stc.bits,sd-&gt;stc.alg_item,"stcolor/transfer");

           if(sd-&gt;stc.vals[i] == NULL) {

              code = gs_error_VMerror;

           } else {                      /* success */


              if(sd-&gt;stc.code[i] == NULL) { /* linear */

                 byte  *Out  = sd-&gt;stc.vals[i];
                 int    Nout = 1&lt;&lt;sd-&gt;stc.bits;
                 double Omin = sd-&gt;stc.dither-&gt;minmax[0];
                 double Omax = sd-&gt;stc.dither-&gt;minmax[1];
                 float *In   = sd-&gt;stc.extv[i];
                 int    Nin  = sd-&gt;stc.sizv[i];
                 unsigned long I,io;
                 double Istep,Ostep,Y;
                 byte   Ovb; long Ovl;

                 Istep = 1.0 / (double) ((Nin)-1);
                 Ostep = 1.0 / (double) ((Nout)-1);

                 for(io = 0; io &lt; (Nout); ++io) {
                    I = (long)(io * ((Nin)-1))/((Nout)-1);

                    if((I+1) &lt; (Nin))
                       Y = In[I] + (In[I+1]-In[I])
                                     * ((double) io * Ostep - (double)I * Istep)
                                               /  (double) Istep;
                    else
                       Y = In[I] + (In[I]-In[I-1])
                                     * ((double) io * Ostep - (double)I * Istep)
                                               /  (double) Istep;

                    Y = Omin + (Omax-Omin) * Y;
                    Y = Y &lt; Omin ? Omin : (Y &gt; Omax ? Omax : Y);


                    switch(sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) {
                       case STC_BYTE:
                          Ovb = (byte)Y;
                          if(((Y-Ovb) &gt;= 0.5) &amp;&amp; ((Ovb+1) &lt;= Omax)) Ovb += 1;
                          Out[io] = Ovb;
                          break;
                       case STC_LONG:
                          Ovl = (long)Y;
                          if(((Y-Ovl) &gt;= 0.5) &amp;&amp; ((Ovl+1) &lt;= Omax)) Ovl += 1;
                          if(((Ovl-Y) &gt;= 0.5) &amp;&amp; ((Ovl-1) &gt;= Omax)) Ovl -= 1;
                          ((long *)Out)[io] = Ovl;
                          break;
                       default:
                          ((float *)Out)[io] = Y;
                          break;
                    }
                 }

              } else {                     /* encoded */
                 unsigned long j,o;
                 double xstep,x,y;

                 xstep = 1.0 / (double) (sd-&gt;stc.sizv[i]-1);

/*
 * The following differs in so far from the previous, that the desired
 * X-Values are stored in another array.
 */
                 for(o = 0; o &lt; (1&lt;&lt;sd-&gt;stc.bits); ++o) { /* code-loop */

                    x = sd-&gt;stc.code[i][o]; x /= gx_max_color_value;

                    j = (unsigned long)(x / xstep);

                    if((j+1) &lt; sd-&gt;stc.sizv[i]) {
                       y  = sd-&gt;stc.extv[i][j];
                       y += (sd-&gt;stc.extv[i][j+1]-y)*(x-(double)j*xstep)/xstep;
                    } else {
                       y  = sd-&gt;stc.extv[i][j];
                       y += (y-sd-&gt;stc.extv[i][j-1])*(x-(double)j*xstep)/xstep;
                    }

                    y = sd-&gt;stc.dither-&gt;minmax[0]
                      +(sd-&gt;stc.dither-&gt;minmax[1]-sd-&gt;stc.dither-&gt;minmax[0])*y;

#                   define stc_adjvals(T)                                             \
                     ((T *)(sd-&gt;stc.vals[i]))[o] = (T)y;                                 \
                                                                                      \
                    if(((y-((T *)(sd-&gt;stc.vals[i]))[o]) &gt;= 0.5) &amp;&amp;                    \
                       ((1+((T *)(sd-&gt;stc.vals[i]))[o]) &lt;= sd-&gt;stc.dither-&gt;minmax[1]))\
                       ((T *)(sd-&gt;stc.vals[i]))[o]      += 1;                         \
                                                                                      \
                    if(((((T *)(sd-&gt;stc.vals[i]))[o]-y) &gt;= 0.5) &amp;&amp;                    \
                       ((((T *)(sd-&gt;stc.vals[i]))[o]-1) &gt;= sd-&gt;stc.dither-&gt;minmax[0]))\
                       ((T *)(sd-&gt;stc.vals[i]))[o]      -= 1;

                    STC_TYPESWITCH(sd-&gt;stc.dither,stc_adjvals)

#                   undef stc_adjvals
                 }                                       /* code-loop */
              }                            /* lineaer / encoded */
           }                             /* error || success */

        } else {     /* shared one */

           sd-&gt;stc.vals[i] = sd-&gt;stc.vals[j];

        }           /* new || shared one */
     }                                                         /* vals req. */
  }                                                    /* comp */

  if(code == 0) {
      gx_color_value cv[4];
      sd-&gt;stc.flags |= STCOK4GO;

/*
 * Arrgh: open-procedure seems to be the right-place, but it is
 *        necessary to establish the defaults for omitted procedures too.
 */

      switch(sd-&gt;color_info.num_components) { /* Establish color-procs */
      case 1:
         set_dev_proc(sd,map_rgb_color, stc_map_gray_color);
         set_dev_proc(sd,map_cmyk_color,gx_default_map_cmyk_color);
         set_dev_proc(sd,map_color_rgb, stc_map_color_gray);
	 set_dev_proc(sd,encode_color, stc_map_gray_color);
         set_dev_proc(sd,decode_color, stc_map_color_gray);
         cv[0] = cv[1] = cv[2] = gx_max_color_value;
         white = stc_map_gray_color((gx_device *) sd, cv);
         break;
      case 3:
         set_dev_proc(sd,map_rgb_color, stc_map_rgb_color);
         set_dev_proc(sd,map_cmyk_color,gx_default_map_cmyk_color);
         set_dev_proc(sd,map_color_rgb, stc_map_color_rgb);
	 set_dev_proc(sd,encode_color, stc_map_rgb_color);
         set_dev_proc(sd,decode_color, stc_map_color_rgb);
         cv[0] = cv[1] = cv[2] = gx_max_color_value;
         white = stc_map_rgb_color((gx_device *) sd, cv);
         break;
      default:
         set_dev_proc(sd,map_rgb_color, gx_default_map_rgb_color);
         if(sd-&gt;stc.flags &amp; STCCMYK10) {
            set_dev_proc(sd,map_cmyk_color,stc_map_cmyk10_color);
            set_dev_proc(sd,map_color_rgb, stc_map_color_cmyk10);
	    set_dev_proc(sd,encode_color,stc_map_cmyk10_color);
            set_dev_proc(sd,decode_color, stc_map_color_cmyk10);
            cv[0] = cv[1] = cv[2] = cv[3] = 0;
            white = stc_map_cmyk10_color((gx_device *) sd, cv);
         } else {
            set_dev_proc(sd,map_cmyk_color,stc_map_cmyk_color);
            set_dev_proc(sd,map_color_rgb, stc_map_color_cmyk);
	    set_dev_proc(sd,encode_color,stc_map_cmyk_color);
            set_dev_proc(sd,decode_color, stc_map_color_cmyk);
            cv[0] = cv[1] = cv[2] = cv[3] = 0;
            white = stc_map_cmyk_color((gx_device *) sd,cv);
         }
         break;                               /* Establish color-procs */
      }


/*
 * create at least a Byte
 */
      if(sd-&gt;color_info.depth &lt; 2) white |= (white&lt;&lt;1);
      if(sd-&gt;color_info.depth &lt; 4) white |= (white&lt;&lt;2);
      if(sd-&gt;color_info.depth &lt; 8) white |= (white&lt;&lt;4);

/*
 * copy the Bytes
 */
      bpw = (byte *) sd-&gt;stc.white_run;

      if(sd-&gt;color_info.depth &lt; 16) {
         for(i = 0; i &lt; sizeof(sd-&gt;stc.white_run); i += 1) {
            bpw[i] = 0xff &amp; white;
         }
      } else if(sd-&gt;color_info.depth &lt; 24) {
         for(i = 0; i &lt; sizeof(sd-&gt;stc.white_run); i += 2) {
            bpw[i]   = 0xff &amp; (white&gt;&gt;8);
            bpw[i+1] = 0xff &amp;  white;
         }
      } else if(sd-&gt;color_info.depth &lt; 32) {
         for(i = 0; i &lt; sizeof(sd-&gt;stc.white_run); i += 3) {
            bpw[i]   = 0xff &amp; (white&gt;&gt;16);
            bpw[i+1] = 0xff &amp; (white&gt;&gt; 8);
            bpw[i+2] = 0xff &amp;  white;
         }
      } else {
         for(i = 0; i &lt; sizeof(sd-&gt;stc.white_run); i += 4) {
            bpw[i]   = 0xff &amp; (white&gt;&gt;24);
            bpw[i+1] = 0xff &amp; (white&gt;&gt;16);
            bpw[i+2] = 0xff &amp; (white&gt;&gt; 8);
            bpw[i+3] = 0xff &amp;  white;
         }
      }
/*
 *    compute the trailer
 */
      j  = (unsigned long)(sd-&gt;width -
          (dev_l_margin(sd)+dev_r_margin(sd))*sd-&gt;x_pixels_per_inch);
      j  = j * sd-&gt;color_info.depth;            /* the Bit-count */
      j  = j % (32*countof(sd-&gt;stc.white_run)); /* remaining Bits */

      bpm = (byte *) sd-&gt;stc.white_end;
      for(i = 0; i &lt; (4*countof(sd-&gt;stc.white_end)); ++i) {
         if(       j &lt;= 0) {
            bpm[i] = 0;
         } else if(j &gt;= 8) {
            bpm[i] = 0xff;
            j -= 8;
         } else {
            bpm[i] = 0xff ^ ((1&lt;&lt;(8-j))-1);
            j  = 0;
         }
         bpm[i] &amp;= bpw[i];
      }

/*
 * Call super-class open
 */

      return gdev_prn_open(pdev);

   } else {

      stc_freedata(sd-&gt;memory, &amp;sd-&gt;stc);

      return_error(code);
   }

}

/***
 *** stc_close: release the internal data
 ***/
private int 
stc_close(gx_device *pdev)
{
   stc_freedata(pdev-&gt;memory, &amp;((stcolor_device *) pdev)-&gt;stc);
   ((stcolor_device *) pdev)-&gt;stc.flags &amp;= ~STCOK4GO;
   return gdev_prn_close(pdev);
}


/***
 *** Function for Bit-Truncation, including direct-byte-transfer
 ***/
private gx_color_value 
stc_truncate(stcolor_device *sd,int i,gx_color_value v)
{

   if(sd-&gt;stc.bits &lt; gx_color_value_bits) {
      if(sd-&gt;stc.code[i] != NULL) {
/*
 * Perform binary search in the code-array
 */
         long  s;
         gx_color_value *p;

         s = sd-&gt;stc.bits &gt; 1 ? 1L&lt;&lt;(sd-&gt;stc.bits-2) : 0L;
         p = sd-&gt;stc.code[i]+(1L&lt;&lt;(sd-&gt;stc.bits-1));

         while(s &gt; 0) {
            if(v &gt; *p) {
               p += s;
            } else if(v &lt; p[-1]) {
               p -= s;
            } else {
               if((v-p[-1]) &lt; (p[0]-v)) p -= 1;
               break;
            }
            s &gt;&gt;= 1;
         }
         if((v-p[-1]) &lt; (p[0]-v)) p -= 1;
         v = p - sd-&gt;stc.code[i];

      } else {

         v &gt;&gt;= gx_color_value_bits-sd-&gt;stc.bits;

      }

/*
      V = (((1L&lt;&lt;D-&gt;stc.bits)-1)*V+(gx_max_color_value&gt;&gt;1))\
          /gx_max_color_value;                             \
*/
   }
   return v;
}

private gx_color_value
stc_truncate1(stcolor_device *sd,int i,gx_color_value v)
{

   return sd-&gt;stc.vals[i][stc_truncate(sd,i,v)];
}

/***
 *** Expansion of indices for reverse-mapping
 ***/
private gx_color_value 
stc_expand(stcolor_device *sd,int i,gx_color_index col)
{

   gx_color_index cv;
   gx_color_index l = (1&lt;&lt;sd-&gt;stc.bits)-1;

   if(sd-&gt;stc.code[i] != NULL) {

      cv  = sd-&gt;stc.code[i][col &amp; l];

   } else if(sd-&gt;stc.bits &lt; gx_color_value_bits) {

      cv  = (col &amp; l)&lt;&lt;(gx_color_value_bits-sd-&gt;stc.bits);
      cv += (col &amp; l)/l * ((1&lt;&lt;(gx_color_value_bits-sd-&gt;stc.bits))-1);

   } else if(sd-&gt;stc.bits &gt; gx_color_value_bits) {

      cv  = (col &amp; l)&gt;&gt;(sd-&gt;stc.bits-gx_color_value_bits);

   } else {

      cv  = col &amp; l;

   }

   return cv;
}

/***
 *** color-mapping of gray-scales
 ***/
private gx_color_index 
stc_map_gray_color(gx_device *pdev, const gx_color_value cv[])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   gx_color_index rv;
   gx_color_value r = cv[0];
   gx_color_value g = cv[1];
   gx_color_value b = cv[2];

   if((r == g) &amp;&amp; (g == b)) {

      rv = gx_max_color_value - r;

   } else if(sd-&gt;stc.am != NULL) {
      float *m,fv;

      m   = sd-&gt;stc.am;

      fv  = gx_max_color_value;
      fv -= *m++ * (float) r; fv -= *m++ * (float) g; fv -= *m   * (float) b;

      if(     fv &lt; 0.0)                      rv = 0;
      else if((fv+0.5) &gt; gx_max_color_value) rv = gx_max_color_value;
      else                                   rv = (gx_color_index)(fv+0.5);

   } else {

      rv  = ((gx_color_index)gx_max_color_value)&lt;&lt;3;
      rv -= (gx_color_index) 3 * r;
      rv -= (gx_color_index) 3 * g;
      rv -= ((gx_color_index)b)&lt;&lt;1;
      rv  = (rv+4)&gt;&gt;3;
      if(rv &gt; gx_max_color_value) rv = gx_max_color_value;

   }

   if(( sd-&gt;stc.bits                      ==    8) &amp;&amp;
      ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE))
      rv = stc_truncate1(sd,0,(gx_color_value)rv);
   else
      rv =  stc_truncate(sd,0,(gx_color_value)rv);

   return rv;
}

private int 
stc_map_color_gray(gx_device *pdev, gx_color_index color,gx_color_value prgb[3])
{
   stcolor_device *sd = (stcolor_device *) pdev;
   gx_color_index l = ((gx_color_index)1&lt;&lt;sd-&gt;stc.bits)-1;

   prgb[0] = gx_max_color_value - stc_expand(sd,0,color &amp; l);
   prgb[1] = prgb[0]; prgb[2] = prgb[0];

   return 0;
}

/***
 *** color-mapping of rgb-values
 ***/
private gx_color_index 
stc_map_rgb_color(gx_device *pdev, const gx_color_value cv[])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   int          shift = sd-&gt;color_info.depth == 24 ? 8 : sd-&gt;stc.bits;
   gx_color_index  rv = 0;
   gx_color_value r = cv[0];
   gx_color_value g = cv[1];
   gx_color_value b = cv[2];
   if((sd-&gt;stc.am != NULL) &amp;&amp; ((r != g) || (g != b))) {
      float *m,fr,fg,fb,fv;

      m  = sd-&gt;stc.am;
      fr = r; fg = g; fb = b;

      fv = *m++ * fr; fv += *m++ * fg; fv += *m++ * fb;

      if(     fv &lt; 0.0)                      r = 0;
      else if((fv+0.5) &gt; gx_max_color_value) r = gx_max_color_value;
      else                                   r = (gx_color_value)(fv+0.5);

      fv = *m++ * fr; fv += *m++ * fg; fv += *m++ * fb;

      if(     fv &lt; 0.0)                      g = 0;
      else if((fv+0.5) &gt; gx_max_color_value) g = gx_max_color_value;
      else                                   g = (gx_color_value)(fv+0.5);

      fv = *m++ * fr; fv += *m++ * fg; fv += *m++ * fb;

      if(     fv &lt; 0.0)                      b = 0;
      else if((fv+0.5) &gt; gx_max_color_value) b = gx_max_color_value;
      else                                   b = (gx_color_value)(fv+0.5);

   }

   if(( sd-&gt;stc.bits                      ==    8) &amp;&amp;
      ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE)) {
      rv =               stc_truncate1(sd,0,r);
      rv = (rv&lt;&lt;shift) | stc_truncate1(sd,1,g);
      rv = (rv&lt;&lt;shift) | stc_truncate1(sd,2,b);
   } else {
      rv =                stc_truncate(sd,0,r);
      rv = (rv&lt;&lt;shift) |  stc_truncate(sd,1,g);
      rv = (rv&lt;&lt;shift) |  stc_truncate(sd,2,b);
   }

   return rv;
}

private int 
stc_map_color_rgb(gx_device *pdev, gx_color_index color,gx_color_value prgb[3])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   int          shift = sd-&gt;color_info.depth == 24 ? 8 : sd-&gt;stc.bits;
   gx_color_index l =   ((gx_color_index)1&lt;&lt;sd-&gt;stc.bits)-1;

   prgb[0] = stc_expand(sd,0,((color&gt;&gt;(shift&lt;&lt;1)) &amp; l));
   prgb[1] = stc_expand(sd,1,((color&gt;&gt; shift    ) &amp; l));
   prgb[2] = stc_expand(sd,2,( color              &amp; l));

   return 0;
}

/***
 *** color-mapping of cmyk-values
 ***/
private gx_color_index 
stc_map_cmyk_color(gx_device *pdev, const gx_color_value cv[])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   int          shift = sd-&gt;color_info.depth == 32 ? 8 : sd-&gt;stc.bits;
   gx_color_index rv = 0;
   gx_color_value c = cv[0];
   gx_color_value m = cv[1];
   gx_color_value y = cv[2];
   gx_color_value k = cv[3];

   if((c == m) &amp;&amp; (m == y)) {

      k = c &gt; k ? c : k;
      c = m = y = 0;

      if(( sd-&gt;stc.bits                      ==    8) &amp;&amp;
      ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE)) {
         k  = stc_truncate1(sd,3,k);
      } else {
         k  =  stc_truncate(sd,3,k);
      }

   } else {

      if(sd-&gt;stc.am != NULL) {

         float *a,fc,fm,fy,fk,fv;

         if(k == 0) { /* no separated black yet */
            k  = c &lt; m ? c : m;
            k  = k &lt; y ? k : y;
            if(k) { /* no black at all */
               c -= k;
               m -= k;
               y -= k;
           }       /* no black at all */
         }            /* no separated black yet */

         a  = sd-&gt;stc.am;
         fc = c; fm = m; fy = y; fk = k;

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      c = 0;
         else if((fv+0.5) &gt; gx_max_color_value) c = gx_max_color_value;
         else                                   c = (gx_color_value)(fv+0.5);

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      m = 0;
         else if((fv+0.5) &gt; gx_max_color_value) m = gx_max_color_value;
         else                                   m = (gx_color_value)(fv+0.5);

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      y = 0;
         else if((fv+0.5) &gt; gx_max_color_value) y = gx_max_color_value;
         else                                   y = (gx_color_value)(fv+0.5);

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      k = 0;
         else if((fv+0.5) &gt; gx_max_color_value) k = gx_max_color_value;
         else                                   k = (gx_color_value)(fv+0.5);

      } else if(k == 0) {

         k  = c &lt; m ? c : m;
         k  = k &lt; y ? k : y;
      }

      if(( sd-&gt;stc.bits                      ==    8) &amp;&amp;
         ((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE)) {
         c = stc_truncate1(sd,0,c);
         m = stc_truncate1(sd,1,m);
         y = stc_truncate1(sd,2,y);
         k = stc_truncate1(sd,3,k);
      } else {
         c = stc_truncate(sd,0,c);
         m = stc_truncate(sd,1,m);
         y = stc_truncate(sd,2,y);
         k = stc_truncate(sd,3,k);
      }
   }

   rv =               c;
   rv = (rv&lt;&lt;shift) | m;
   rv = (rv&lt;&lt;shift) | y;
   rv = (rv&lt;&lt;shift) | k;

   if(rv == gx_no_color_index) rv ^= 1;

   return rv;
}

/* Modified to be a "decode_color" routine */
private int 
stc_map_color_cmyk(gx_device *pdev, gx_color_index color,gx_color_value cv[4])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   int          shift = sd-&gt;color_info.depth == 32 ? 8 : sd-&gt;stc.bits;
   gx_color_index   l = ((gx_color_index)1&lt;&lt;sd-&gt;stc.bits)-1;
   gx_color_value c,m,y,k;

   k = stc_expand(sd,3, color &amp; l); color &gt;&gt;= shift;
   y = stc_expand(sd,2, color &amp; l); color &gt;&gt;= shift;
   m = stc_expand(sd,1, color &amp; l); color &gt;&gt;= shift;
   c = stc_expand(sd,0, color &amp; l);

   
   cv[0] = c;
   cv[1] = m;
   cv[2] = y;
   cv[3] = k;
   
   return 0;
}

/***
 *** color-mapping of cmyk10-values
 ***/
private gx_color_index 
stc_map_cmyk10_color(gx_device *pdev, const gx_color_value cv[])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   int             mode;
   gx_color_index rv  = 0;

   gx_color_value c = cv[0];
   gx_color_value m = cv[1];
   gx_color_value y = cv[2];
   gx_color_value k = cv[3];

   if((c == m) &amp;&amp; (m == y)) {

      k = c &gt; k ? c : k;
      c = m = y = 0;
      mode = 3;

   } else {

      if(sd-&gt;stc.am != NULL) {

         float *a,fc,fm,fy,fk,fv;

         k  = c &lt; m ? c : m;
         k  = k &lt; y ? k : y;
         if(k) { /* no black at all */
            c -= k;
            m -= k;
            y -= k;
         }       /* no black at all */

         a  = sd-&gt;stc.am;
         fc = c; fm = m; fy = y; fk = k;

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      c = 0;
         else if((fv+0.5) &gt; gx_max_color_value) c = gx_max_color_value;
         else                                   c = (gx_color_value)(fv+0.5);

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      m = 0;
         else if((fv+0.5) &gt; gx_max_color_value) m = gx_max_color_value;
         else                                   m = (gx_color_value)(fv+0.5);

         fv = *a++ * fc; fv += *a++ * fm; fv += *a++ * fy; fv += *a++ * fk;
         if(     fv &lt; 0.0)                      y = 0;
         else if((fv+0.5) &gt; gx_max_color_value) y = gx_max_color_value;
         else                                   y = (gx_color_value)(fv+0.5);

      }

      if(c &lt; m) {
        if(c &lt; y) { k = c; c = 0; mode = 0; }
        else      { k = y; y = 0; mode = 2; }
      } else {
        if(m &lt; y) { k = m; m = 0; mode = 1; }
        else      { k = y; y = 0; mode = 2; }
      }
   }

/*
 * truncate only the values that require it
 */
   if(c) c = stc_truncate(sd,0,c);
   if(m) m = stc_truncate(sd,1,m);
   if(y) y = stc_truncate(sd,2,y);
   if(k) k = stc_truncate(sd,3,k);

/*
 * make sure that truncation-white becomes white.
 */
   if((c|m|y) == 0) mode = 3;

/*
 * check wether value-arrays can be bypassed
 */
   if(((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_BYTE) &amp;&amp;
      ( sd-&gt;stc.dither-&gt;minmax[0]         ==    0.0 )) {
      c = sd-&gt;stc.vals[0][c];
      m = sd-&gt;stc.vals[1][m];
      y = sd-&gt;stc.vals[2][y];
      k = sd-&gt;stc.vals[3][k];
   } else if(((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) == STC_LONG) &amp;&amp;
             ( sd-&gt;stc.dither-&gt;minmax[0]         ==     0.0 ) &amp;&amp;
             ( sd-&gt;stc.dither-&gt;minmax[1]         &lt;=  1023.0 )) {
      c = ((long *)(sd-&gt;stc.vals[0]))[c];
      m = ((long *)(sd-&gt;stc.vals[1]))[m];
      y = ((long *)(sd-&gt;stc.vals[2]))[y];
      k = ((long *)(sd-&gt;stc.vals[3]))[k];
   }                                                       /* direct */
/*
 * compute the long-representation of gx_color_index
 */
   switch(mode) {
   case 0:
      rv = (((gx_color_index) m)&lt;&lt;22)|
           (((gx_color_index) y)&lt;&lt;12)|
           (((gx_color_index) k)&lt;&lt; 2)|mode;
      break;
   case 1:
      rv = (((gx_color_index) c)&lt;&lt;22)|
           (((gx_color_index) y)&lt;&lt;12)|
           (((gx_color_index) k)&lt;&lt; 2)|mode;
      break;
   case 2:
      rv = (((gx_color_index) c)&lt;&lt;22)|
           (((gx_color_index) m)&lt;&lt;12)|
           (((gx_color_index) k)&lt;&lt; 2)|mode;
      break;
   default:
      rv = (((gx_color_index) k)&lt;&lt; 2)|mode;
      break;
   }

/*
 * We may need some swapping
 */
#if !arch_is_big_endian
   {
      union { stc_pixel cv; byte bv[4]; } ui,uo;
      ui.cv = rv;
      uo.bv[0] = ui.bv[3];
      uo.bv[1] = ui.bv[2];
      uo.bv[2] = ui.bv[1];
      uo.bv[3] = ui.bv[0];
      rv       = uo.cv;
   }
#endif
   return rv;
}

private int 
stc_map_color_cmyk10(gx_device *pdev, gx_color_index color,
                     gx_color_value cv[3])
{

   stcolor_device *sd = (stcolor_device *) pdev;
   gx_color_value c,m,y;

/*
 * We may need some swapping
 */
#if !arch_is_big_endian
   union { stc_pixel cv; byte bv[4]; } ui,uo;
   ui.cv = color;
   uo.bv[0] = ui.bv[3];
   uo.bv[1] = ui.bv[2];
   uo.bv[2] = ui.bv[1];
   uo.bv[3] = ui.bv[0];
   color    = uo.cv;
#endif

   c    =   stc_expand(sd,3,(color&gt;&gt;2)&amp;0x3ff);

   /* cast the 64 bit switch argument to work around broken HPUX 10 cc */
   switch((int)(color &amp; 3)) {
     case 0:
        m = stc_expand(sd,1,(color&gt;&gt;22) &amp; 0x3ff);
        y = stc_expand(sd,2,(color&gt;&gt;12) &amp; 0x3ff);
        break;
     case 1:
        m = c;
        c = stc_expand(sd,0,(color&gt;&gt;22) &amp; 0x3ff);
        y = stc_expand(sd,2,(color&gt;&gt;12) &amp; 0x3ff);
        break;
     case 2:
        y = c;
        c = stc_expand(sd,0,(color&gt;&gt;22) &amp; 0x3ff);
        m = stc_expand(sd,1,(color&gt;&gt;12) &amp; 0x3ff);
        break;
     default:
        m = c;
        y = c;
        break;
   }

   cv[0] = c;
   cv[1] = m;
   cv[2] = y;

   return 0;
}

/***
 *** Macros for parameter-handling
 ***/

#define set_param_array(A, D, S)\
    {A.data = D; A.size = S; A.persistent = false;}

#define stc_write_null(N)                        \
    set_param_array(pfa,defext,countof(defext))  \
    code = param_write_null(plist,N);            \
    if (code &lt; 0) return code;

#define stc_write_xarray(I,Coding,Transfer)                  \
    if(sd-&gt;stc.sizc[I] &gt; 0) {                                \
       set_param_array(pfa, sd-&gt;stc.extc[I],sd-&gt;stc.sizc[I]) \
       code = param_write_float_array(plist,Coding,&amp;pfa);    \
    } else {                                                 \
       code = param_write_null(plist,Coding);                \
    }                                                        \
    if ( code &lt; 0 ) return code;                             \
                                                             \
    if(sd-&gt;stc.sizv[I] &gt; 0)                                  \
       set_param_array(pfa, sd-&gt;stc.extv[I],sd-&gt;stc.sizv[I]) \
    else                                                     \
       set_param_array(pfa,defext,countof(defext))           \
    code = param_write_float_array(plist,Transfer,&amp;pfa);     \
    if ( code &lt; 0 ) return code;

#define stc_read_null(N)                                   \
    code = param_read_null(plist,N);                       \
    if(code == gs_error_typecheck)                         \
       code = param_read_float_array(plist,N,&amp;pfa);        \
    if(code &lt; 0) param_signal_error(plist,N,code);         \
    error = error &gt; code ? code : error;

#define stc_read_xarray(I,Coding,Transfer)                 \
    code = param_read_float_array(plist,Coding,&amp;pfa);      \
    if((error == 0) &amp;&amp; (code == 0)) {                      \
       if(pfa.size &gt; 1) {                                  \
          sd-&gt;stc.extc[I] = (float *) pfa.data;            \
          sd-&gt;stc.sizc[I] = pfa.size;                      \
       } else {                                            \
          code = gs_error_rangecheck;                      \
       }                                                   \
    } else if(code &lt; 0) {                                  \
       code = param_read_null(plist,Coding);               \
       if(code == 0) {                                     \
          sd-&gt;stc.extc[I] = NULL;                          \
          sd-&gt;stc.sizc[I] = 0;                             \
       }                                                   \
    }                                                      \
    if(code &lt; 0) param_signal_error(plist,Coding,code);    \
    error = error &gt; code ? code : error;                   \
    code = param_read_float_array(plist,Transfer,&amp;pfa);    \
    if((error == 0) &amp;&amp; (code == 0)) {                      \
       sd-&gt;stc.extv[I] = (float *) pfa.data;               \
       sd-&gt;stc.sizv[I] = pfa.size;                         \
    } else if(code &lt; 0) {                                  \
       code = param_read_null(plist,Transfer);             \
       if(code == 0) {                                     \
          sd-&gt;stc.extv[I] = defext;                        \
          sd-&gt;stc.sizv[I] = countof(defext);               \
       }                                                   \
    }                                                      \
    if(code &lt; 0) param_signal_error(plist,Transfer,code);  \
    error = error &gt; code ? code : error;

/***
 *** Get parameters == Make them accessable via PostScript
 ***/

private int 
stc_get_params(gx_device *pdev, gs_param_list *plist)
{
   int code,nc;
   gs_param_string      ps;
   gs_param_float_array pfa;
   bool btmp;
   stcolor_device *sd = (stcolor_device *) pdev;

   code = gdev_prn_get_params(pdev, plist);
   if ( code &lt; 0 ) return code;

/*
 * Export some readonly-Parameters, used by stcinfo.ps
 */
   param_string_from_string(ps,"1.91");
   code = param_write_string(plist,"Version",&amp;ps);
   if ( code &lt; 0 ) return code;

   code = param_write_int(plist,"BitsPerComponent",&amp;sd-&gt;stc.bits);
   if ( code &lt; 0 ) return code;

   if(sd-&gt;stc.algorithms.size &gt; 0) {
     code = param_write_string_array(plist,"Algorithms",&amp;sd-&gt;stc.algorithms);
   } else {
     code = param_write_null(plist,"Algorithms");
   }
   if ( code &lt; 0 ) return code;

/*
 * Export OutputCode
 */
   switch(sd-&gt;stc.flags &amp; STCCOMP) {
   case STCPLAIN: param_string_from_string(ps,"plain");     break;
   case STCDELTA: param_string_from_string(ps,"deltarow");  break;
   default:       param_string_from_string(ps,"runlength"); break;
   }
   code = param_write_string(plist,"OutputCode",&amp;ps);
   if ( code &lt; 0 ) return code;
/*
 * Export Model
 */
   switch(sd-&gt;stc.flags &amp; STCMODEL) {
   case STCST800: param_string_from_string(ps,"st800");   break;
   case STCSTCII: param_string_from_string(ps,"stcii");   break;
   default:       param_string_from_string(ps,"stc");     break;
   }
   code = param_write_string(plist,"Model",&amp;ps);
   if ( code &lt; 0 ) return code;

/*
 * Export the booleans
 */
#define stc_write_flag(Mask,Name)                \
   btmp = sd-&gt;stc.flags &amp; (Mask) ? true : false; \
   code = param_write_bool(plist,Name,&amp;btmp);    \
   if ( code &lt; 0 ) return code;

   stc_write_flag(STCUNIDIR,"Unidirectional")
   stc_write_flag(STCUWEAVE,"Microweave")
   btmp = sd-&gt;stc.flags &amp; (STCUNIDIR|STCUWEAVE) ? false : true;
   code = param_write_bool(plist,"Softweave",&amp;btmp);
   if ( code &lt; 0 ) return code;
   stc_write_flag(STCNWEAVE,"noWeave")
   stc_write_flag(STCDFLAG0, "Flag0")
   stc_write_flag(STCDFLAG1, "Flag1")
   stc_write_flag(STCDFLAG2, "Flag2")
   stc_write_flag(STCDFLAG3, "Flag3")
   stc_write_flag(STCDFLAG4, "Flag4")

#undef stc_write_flag

#  define stc_write_int(Mask,Name,Val)         \
      code = param_write_int(plist,Name,&amp;Val); \
      if ( code &lt; 0 ) return code

   stc_write_int(STCBAND,  "escp_Band",  sd-&gt;stc.escp_m);
   stc_write_int(STCWIDTH, "escp_Width", sd-&gt;stc.escp_width);
   stc_write_int(STCHEIGHT,"escp_Height",sd-&gt;stc.escp_height);
   stc_write_int(STCTOP,   "escp_Top",   sd-&gt;stc.escp_top);
   stc_write_int(STCBOTTOM,"escp_Bottom",sd-&gt;stc.escp_bottom);

#  undef stc_write_int

   code = param_write_string(plist,"escp_Init",&amp;sd-&gt;stc.escp_init);
   code = param_write_string(plist,"escp_Release",&amp;sd-&gt;stc.escp_release);

   if(sd-&gt;stc.dither != NULL) {
      param_string_from_string(ps,sd-&gt;stc.dither-&gt;name);
      code = param_write_string(plist,"Dithering",&amp;ps);
   } else {
      code = param_write_null(plist,"Dithering");
   }
   if ( code &lt; 0 ) return code;

   nc = sd-&gt;color_info.num_components;

   if(sd-&gt;stc.am != NULL) {
      if(     nc == 1) set_param_array(pfa, sd-&gt;stc.am, 3)
      else if(nc == 3) set_param_array(pfa, sd-&gt;stc.am, 9)
      else             set_param_array(pfa, sd-&gt;stc.am,16)
      code = param_write_float_array(plist,"ColorAdjustMatrix",&amp;pfa);
   } else {
      code = param_write_null(plist,"ColorAdjustMatrix");
   }
   if ( code &lt; 0 ) return code;

   if(nc == 1) {        /* DeviceGray */

      stc_write_xarray(0,"Kcoding","Ktransfer");

      stc_write_null("Rcoding"); stc_write_null("Rtransfer");
      stc_write_null("Gcoding"); stc_write_null("Gtransfer");
      stc_write_null("Bcoding"); stc_write_null("Btransfer");

      stc_write_null("Ccoding"); stc_write_null("Ctransfer");
      stc_write_null("Mcoding"); stc_write_null("Mtransfer");
      stc_write_null("Ycoding"); stc_write_null("Ytransfer");

   } else if(nc == 3) { /* DeviceRGB */

      stc_write_xarray(0,"Rcoding","Rtransfer");
      stc_write_xarray(1,"Gcoding","Gtransfer");
      stc_write_xarray(2,"Bcoding","Btransfer");

      stc_write_null("Ccoding"); stc_write_null("Ctransfer");
      stc_write_null("Mcoding"); stc_write_null("Mtransfer");
      stc_write_null("Ycoding"); stc_write_null("Ytransfer");
      stc_write_null("Kcoding"); stc_write_null("Ktransfer");

   } else {             /* DeviceCMYK */

      stc_write_xarray(0,"Ccoding","Ctransfer");
      stc_write_xarray(1,"Mcoding","Mtransfer");
      stc_write_xarray(2,"Ycoding","Ytransfer");
      stc_write_xarray(3,"Kcoding","Ktransfer");

      stc_write_null("Rcoding"); stc_write_null("Rtransfer");
      stc_write_null("Gcoding"); stc_write_null("Gtransfer");
      stc_write_null("Bcoding"); stc_write_null("Btransfer");

   }
   return code;
}

/***
 *** put parameters == Store them in the device-structure
 ***/

private int 
stc_put_params(gx_device *pdev, gs_param_list *plist)
{
   int code,error,i,l;
   bool b1,b2,b3;
   float fv,*fp;
   gs_param_string      ps;
   gs_param_string_array psa;
   gs_param_float_array pfa;
   stcolor_device *sd = (stcolor_device *) pdev;
   gx_device_color_info oldcolor;
   stc_t                oldstc;

/*
 * save old Values
 */
   memcpy(&amp;oldcolor,&amp;sd-&gt;color_info,sizeof(oldcolor));
   memcpy(&amp;oldstc  ,&amp;sd-&gt;stc       ,sizeof(oldstc  ));

/*
 * Arrrgh:
 * With Version 3.4x and above my simple minded read-only Parameters
 * do not work any more. So read them here for heavens sake.
 */
   code = param_read_string(plist,"Version",&amp;ps);
   code = param_read_int(plist,"BitsPerComponent",&amp;i);
   code = param_read_string_array(plist,"Algorithms",&amp;psa);

/*
 * Fetch Major-Parameters (Model, Dithering, BitsPerPixel/BitsPerComponent)
 */
   error = 0;

   code  = param_read_string(plist,"Model",&amp;ps);
   if(code == 0) {   /* Analyze the Model-String */
/*
 * Arrgh: I should have known, that internal strings are not zero-terminated.
 */
      for(l = ps.size; (l &gt; 0) &amp;&amp; (ps.data[l-1] == 0); --l);
#     define stc_putcmp(Name) \
        ((strlen(Name) != l) || (0 != strncmp(Name, (const char *)ps.data,l)))

      sd-&gt;stc.flags &amp;= ~STCMODEL;
      if(     !stc_putcmp("st800"))  sd-&gt;stc.flags |= STCST800;
      else if(!stc_putcmp("stcii"))  sd-&gt;stc.flags |= STCSTCII;

   }                 /* Analyze the Model-String */
   if(code &lt; 0) param_signal_error(plist,"Model",code);
   error = error &gt; code ? code : error;

/* If we're running for st800, #components must be 1 */
   if(((sd-&gt;stc.flags &amp; STCMODEL) == STCST800) &amp;&amp;
      (( sd-&gt;color_info.num_components &gt; 1) ||
       ( sd-&gt;stc.dither                == NULL) ||
       ((sd-&gt;stc.dither-&gt;flags &amp; 7)    &gt; 1))) {
        sd-&gt;color_info.num_components  = 1;
        sd-&gt;stc.dither = NULL;
    }

/* Weaving isn't a feature for the st800 */
   if((sd-&gt;stc.flags &amp; STCMODEL) == STCST800) {
      sd-&gt;stc.flags &amp;= ~STCUWEAVE;
      sd-&gt;stc.flags |=  STCNWEAVE;
   } else if((sd-&gt;stc.flags &amp; STCMODEL) == STCSTCII) { /* no SoftWeave */
      sd-&gt;stc.flags |=  STCNWEAVE;
   }

   code  = param_read_string(plist,"Dithering",&amp;ps);
   if(code == 0) {                     /* lookup new value new value */

      for(l = ps.size; (l &gt; 0) &amp;&amp; (ps.data[l-1] == 0); --l);

      for(i = 0; stc_dither[i].name != NULL; ++i)
         if(!stc_putcmp(stc_dither[i].name)) break;

   } else if(sd-&gt;stc.dither != NULL) {  /* compute index of given value */

      i = sd-&gt;stc.dither - stc_dither;

   } else {                            /* find matching value */

      for(i = 0; stc_dither[i].name != NULL; ++i)
         if((stc_dither[i].flags &amp; 7) == sd-&gt;color_info.num_components) break;

   }                                   /* we've got an index */

   if(stc_dither[i].name != NULL) { /* establish data */

/*
 * Establish new dithering algorithm &amp; color-model
 */
      sd-&gt;stc.dither                = stc_dither+i;
      sd-&gt;color_info.num_components = sd-&gt;stc.dither-&gt;flags &amp; 7;
  STC_TYPESWITCH(sd-&gt;stc.dither,stc_sizeofitem)
# undef stc_sizeofitem
      if(((sd-&gt;stc.flags &amp; STCMODEL)    == STCST800) &amp;&amp;
         ( sd-&gt;color_info.num_components &gt; 1       ))
         code = gs_error_rangecheck;

/*
 * reset Parameters related to the color-model, if it changed
 */

      if(sd-&gt;color_info.num_components != oldcolor.num_components) {

         for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) {
            sd-&gt;stc.extv[i]   = (float *) defext;
            sd-&gt;stc.sizv[i]   = countof(defext);

            sd-&gt;stc.extc[i] = NULL;
            sd-&gt;stc.sizc[i] = 0;

         }

         sd-&gt;stc.am = NULL;

      } else { /* guarantee, that extvals is present */

         for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) {
            if(sd-&gt;stc.sizv[i] &lt; 2) {
               sd-&gt;stc.extv[i]   = (float *) defext;
               sd-&gt;stc.sizv[i]   = countof(defext);
            }
         }
      }

      for(i = sd-&gt;color_info.num_components; i &lt; 4; ++ i) { /* clear unused */
         sd-&gt;stc.extv[i]   = NULL;
         sd-&gt;stc.sizv[i]   = 0;
         sd-&gt;stc.vals[i]   = NULL;

         sd-&gt;stc.extc[i] = NULL;
         sd-&gt;stc.sizc[i] = 0;
         sd-&gt;stc.code[i] = NULL;

      }                                                     /* clear unused */

/*
 * Guess default depth from range of values
 */
      if((sd-&gt;stc.dither != oldstc.dither)||(oldstc.vals[0] == NULL)) {

         if((sd-&gt;stc.dither-&gt;flags &amp; STC_CMYK10) != 0) {

            sd-&gt;stc.flags       |= STCCMYK10;
            sd-&gt;stc.bits         = 10;
            sd-&gt;color_info.depth = 32;

         } else {

            sd-&gt;stc.flags       &amp;= ~STCCMYK10;

            if((sd-&gt;stc.dither-&gt;flags &amp; STC_FLOAT) != STC_FLOAT) {
               fv = 2.0;
               for(i = 1;(i  &lt; gx_color_value_bits) &amp;&amp;
                  (fv &lt;= (sd-&gt;stc.dither-&gt;minmax[1]-sd-&gt;stc.dither-&gt;minmax[0]));
                 ++i) fv *= 2.0;

            } else {
               i = 8; /* arbitrary */
            }

            if((i*sd-&gt;color_info.num_components) &gt; (sizeof(stc_pixel)*8)) {

               sd-&gt;stc.bits         = (sizeof(stc_pixel)*8) /
                                       sd-&gt;color_info.num_components;
               sd-&gt;color_info.depth = sd-&gt;stc.bits * sd-&gt;color_info.num_components;

            } else {

               sd-&gt;stc.bits         = i;
               sd-&gt;color_info.depth = sd-&gt;stc.bits * sd-&gt;color_info.num_components;

            }
         }
      }

   } else {

      code = gs_error_rangecheck;

   }               /* verify new value */
   if(code &lt; 0) param_signal_error(plist,"Dithering",code);
   error = error &gt; code ? code : error;

/*
 * now fetch the desired depth, if the algorithm allows it
 */
/*
 * Arrrgh: We get code == 0, even if nobody sets BitsPerPixel.
 *         The value is the old one, but this may cause trouble
 *         with CMYK10.
 */
   code = param_read_int(plist, "BitsPerPixel", &amp;i);
   if((error == 0) &amp;&amp; (code == 0) &amp;&amp;
      (((sd-&gt;stc.flags &amp; STCCMYK10) == 0) || (i != sd-&gt;color_info.depth))) {

      if((1 &gt; i) || (i &gt; (sizeof(stc_pixel)*8)))
         code = gs_error_rangecheck;
      else
         sd-&gt;color_info.depth = i;

      sd-&gt;stc.bits = i / sd-&gt;color_info.num_components;

      if(1 &gt; sd-&gt;stc.bits) code = gs_error_rangecheck;

      if((sd-&gt;stc.dither-&gt;flags &amp; STC_DIRECT) &amp;&amp;
         (sd-&gt;stc.dither-&gt;flags &amp; STC_CMYK10))
         code           = gs_error_rangecheck;
      else
         sd-&gt;stc.flags &amp;= ~STCCMYK10;

   }
   if(code &lt; 0) param_signal_error(plist,"BitsPerPixel",code);
   error = error &gt; code ? code : error;

/*
 * Fetch OutputCode
 */
   code  = param_read_string(plist,"OutputCode",&amp;ps);
   if(code == 0) {   /* Analyze the OutputCode-String */

      for(l = ps.size; (l &gt; 0) &amp;&amp; (ps.data[l-1] == 0); --l);

      sd-&gt;stc.flags &amp;= ~STCCOMP;
      if(!stc_putcmp("plain"))         sd-&gt;stc.flags |= STCPLAIN;
      else if(!stc_putcmp("deltarow")) sd-&gt;stc.flags |= STCDELTA;

   }                 /* Analyze the OutputCode-String */
   if((sd-&gt;stc.flags &amp; STCCOMP) == STCDELTA) {
      sd-&gt;stc.flags |=  STCUWEAVE;
      sd-&gt;stc.flags &amp;= ~STCNWEAVE;
   }
   if(code &lt; 0) param_signal_error(plist,"OutputCode",code);
   error = error &gt; code ? code : error;

/*
 * fetch the weave-mode (noWeave wins)
 */
   b1 = sd-&gt;stc.flags &amp; STCUWEAVE ? true : false;
   b2 = sd-&gt;stc.flags &amp; STCNWEAVE ? true : false;
   b3 = sd-&gt;stc.flags &amp; (STCUWEAVE|STCNWEAVE) ? false : true;

   code = param_read_bool(plist,"Microweave",&amp;b1);
   if(code &lt; 0) {
      param_signal_error(plist,"Microweave",code);
   } else if(code == 0) {
      if(b1) { b2 = false; b3 = false; }
   }
   error = error &gt; code ? code : error;

   code = param_read_bool(plist,"noWeave",&amp;b2);
   if(code &lt; 0) {
      param_signal_error(plist,"noWeave",code);
   } else if (code == 0) {
      if(b2) { b1 = false; b3 = false; }
   }
   error = error &gt; code ? code : error;

   code = param_read_bool(plist,"Softweave",&amp;b3);
   if(code &lt; 0) {
      param_signal_error(plist,"Softweave",code);
   } else if (code == 0) {
      if(b3) { b1 = false; b2 = false; }
   }
   error = error &gt; code ? code : error;

   if(b1) sd-&gt;stc.flags |=  STCUWEAVE;
   else   sd-&gt;stc.flags &amp;= ~STCUWEAVE;

   if(b2) sd-&gt;stc.flags |=  STCNWEAVE;
   else   sd-&gt;stc.flags &amp;= ~STCNWEAVE;

/*
 * Check the simple Flags
 */
#  define stc_read_flag(Mask,Name)                \
      code = param_read_bool(plist,Name,&amp;b1);     \
      if(code &lt; 0) {                              \
         param_signal_error(plist,Name,code);     \
      } else if(code == 0) {                      \
         if(b1 == true) sd-&gt;stc.flags |=  Mask;   \
         else           sd-&gt;stc.flags &amp;= ~(Mask); \
      }                                           \
      error = error &gt; code ? code : error;

   stc_read_flag(STCUNIDIR,"Unidirectional")
   stc_read_flag(STCDFLAG0, "Flag0")
   stc_read_flag(STCDFLAG1, "Flag1")
   stc_read_flag(STCDFLAG2, "Flag2")
   stc_read_flag(STCDFLAG3, "Flag3")
   stc_read_flag(STCDFLAG4, "Flag4")

/*
 * Now deal with the escp-Stuff
 */
#  define stc_read_int(Mask,Name,Val)             \
      code = param_read_int(plist,Name,&amp;Val);     \
      if(code &lt; 0)                                \
         param_signal_error(plist,Name,code);     \
      else if(code == 0)                          \
         sd-&gt;stc.flags |= Mask;                   \
      error = error &gt; code ? code : error

   stc_read_int(STCBAND,  "escp_Band",  sd-&gt;stc.escp_m);
   stc_read_int(STCWIDTH, "escp_Width", sd-&gt;stc.escp_width);
   stc_read_int(STCHEIGHT,"escp_Height",sd-&gt;stc.escp_height);
   stc_read_int(STCTOP,   "escp_Top",   sd-&gt;stc.escp_top);
   stc_read_int(STCBOTTOM,"escp_Bottom",sd-&gt;stc.escp_bottom);

#  undef stc_read_int

   code = param_read_string(plist,"escp_Init",&amp;sd-&gt;stc.escp_init);
   if(code == 0) sd-&gt;stc.flags |= STCINIT;
   error = error &gt; code ? code : error;

   code = param_read_string(plist,"escp_Release",&amp;sd-&gt;stc.escp_release);
   if(code == 0) sd-&gt;stc.flags |= STCRELEASE;
   error = error &gt; code ? code : error;

/*
 * ColorAdjustMatrix must match the required size,
 * setting it explicitly to null, erases old matrix
 */
   code = param_read_float_array(plist,"ColorAdjustMatrix",&amp;pfa);
   if((error == 0) &amp;&amp; (code == 0)) {
      if(((sd-&gt;color_info.num_components == 1) &amp;&amp; (pfa.size ==  3)) ||
         ((sd-&gt;color_info.num_components == 3) &amp;&amp; (pfa.size ==  9)) ||
         ((sd-&gt;color_info.num_components == 4) &amp;&amp; (pfa.size == 16)))
         sd-&gt;stc.am = (float *) pfa.data;
      else
         code =  gs_error_rangecheck;
   } else if(code &lt; 0) {
      code = param_read_null(plist,"ColorAdjustMatrix");
      if(code == 0) sd-&gt;stc.am = NULL;
   }
   if(code &lt; 0) param_signal_error(plist,"ColorAdjustMatrix",code);
   error = error &gt; code ? code : error;

/*
 * Read the external array-Parameters
 */
   if(sd-&gt;color_info.num_components == 1) {        /* DeviceGray */

      stc_read_xarray(0,"Kcoding","Ktransfer");

      stc_read_null("Rcoding"); stc_read_null("Rtransfer");
      stc_read_null("Gcoding"); stc_read_null("Gtransfer");
      stc_read_null("Bcoding"); stc_read_null("Btransfer");

      stc_read_null("Ccoding"); stc_read_null("Ctransfer");
      stc_read_null("Mcoding"); stc_read_null("Mtransfer");
      stc_read_null("Ycoding"); stc_read_null("Ytransfer");

   } else if(sd-&gt;color_info.num_components == 3) { /* DeviceRGB */

      stc_read_xarray(0,"Rcoding","Rtransfer");
      stc_read_xarray(1,"Gcoding","Gtransfer");
      stc_read_xarray(2,"Bcoding","Btransfer");

      stc_read_null("Ccoding"); stc_read_null("Ctransfer");
      stc_read_null("Mcoding"); stc_read_null("Mtransfer");
      stc_read_null("Ycoding"); stc_read_null("Ytransfer");
      stc_read_null("Kcoding"); stc_read_null("Ktransfer");

   } else {                                        /* DeviceCMYK */

      stc_read_xarray(0,"Ccoding","Ctransfer");
      stc_read_xarray(1,"Mcoding","Mtransfer");
      stc_read_xarray(2,"Ycoding","Ytransfer");
      stc_read_xarray(3,"Kcoding","Ktransfer");

      stc_read_null("Rcoding"); stc_read_null("Rtransfer");
      stc_read_null("Gcoding"); stc_read_null("Gtransfer");
      stc_read_null("Bcoding"); stc_read_null("Btransfer");

   }
/*
 * Update remaining color_info values
 */
   if(error == 0) {

/*    compute #values from the component-bits */
      sd-&gt;color_info.max_gray  = sd-&gt;stc.bits &lt; gx_color_value_bits ?
                            (1&lt;&lt;sd-&gt;stc.bits)-1 : gx_max_color_value;

/*    An integer-algorithm might reduce the number of values */
      if(((sd-&gt;stc.dither-&gt;flags &amp; STC_TYPE) != STC_FLOAT) &amp;&amp;
         ((sd-&gt;stc.dither-&gt;minmax[1]-sd-&gt;stc.dither-&gt;minmax[0]) &lt;
           sd-&gt;color_info.max_gray))
         sd-&gt;color_info.max_gray = (gx_color_value)
                (sd-&gt;stc.dither-&gt;minmax[1]-sd-&gt;stc.dither-&gt;minmax[0]+0.5);

      sd-&gt;color_info.max_color = sd-&gt;color_info.num_components &lt; 3 ? 0 :
                                 sd-&gt;color_info.max_gray;
      sd-&gt;color_info.dither_grays =
          sd-&gt;color_info.max_gray &lt; gx_max_color_value ?
          sd-&gt;color_info.max_gray+1  : gx_max_color_value;
      sd-&gt;color_info.dither_colors  = sd-&gt;color_info.num_components &lt; 3 ? 0 :
          sd-&gt;color_info.dither_grays;
   }

/*
 * Call superclass-Update
 */

   code = gdev_prn_put_params(pdev, plist);
   error = error &gt; code ? code : error;

/*
 * Arrrgh, writing BitsPerPixel is really *VERY* special:
 *    gdev_prn_put_params verifies, that the external value
 *    is written, if not, it raises a rangecheck-error.
 *    On the other hand ghostscript is quite unhappy with odd
 *    values, so we do the necessary rounding *AFTER* the
 *    "superclass-Update".
 */

   if(sd-&gt;color_info.depth ==  3) sd-&gt;color_info.depth = 4;
   else if(sd-&gt;color_info.depth &gt; 4)
      sd-&gt;color_info.depth =  (sd-&gt;color_info.depth+7) &amp; ~7;

/*
 * Allocate the storage for the arrays in memory
 */
   if(error == 0) { /* Allocate new external-arrays */

     for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i){ /* Active components */
        int j;

        if((sd-&gt;stc.extv[i] != oldstc.extv[i]) &amp;&amp;
           (sd-&gt;stc.extv[i] != defext        )) { /* Value-Arrays */

           for(j = 0; j &lt; i; ++j)
              if((sd-&gt;stc.sizv[j] == sd-&gt;stc.sizv[i]) &amp;&amp;
                 (memcmp(sd-&gt;stc.extv[j],sd-&gt;stc.extv[i],
                         sd-&gt;stc.sizv[i]*sizeof(float)) == 0)) break;

           if(j &lt; i) {
              sd-&gt;stc.extv[i] = sd-&gt;stc.extv[j];
           } else {
              fp = gs_malloc(sd-&gt;memory, sd-&gt;stc.sizv[i],sizeof(float),"stc_put_params");
              if(fp != NULL)
                 memcpy(fp,sd-&gt;stc.extv[i],sd-&gt;stc.sizv[i]*sizeof(float));
               else
                 code = gs_error_VMerror;
               sd-&gt;stc.extv[i] = fp;
           }
        }                                         /* Value-Arrays */

        if((sd-&gt;stc.sizc[i] &gt; 1) &amp;&amp;
           (sd-&gt;stc.extc[i] != oldstc.extc[i])) { /* Code-Arrays */

           for(j = 0; j &lt; i; ++j)
              if((sd-&gt;stc.sizc[j] == sd-&gt;stc.sizc[i]) &amp;&amp;
                 (memcmp(sd-&gt;stc.extc[j],sd-&gt;stc.extc[i],
                         sd-&gt;stc.sizc[i]*sizeof(float)) == 0)) break;

           if(j &lt; i) {
              sd-&gt;stc.extc[i] = sd-&gt;stc.extc[j];
           } else {
              fp = gs_malloc(sd-&gt;memory, sd-&gt;stc.sizc[i],sizeof(float),"stc_put_params");
              if(fp != NULL)
                 memcpy(fp,sd-&gt;stc.extc[i],sd-&gt;stc.sizc[i]*sizeof(float));
               else
                 code = gs_error_VMerror;
               sd-&gt;stc.extc[i] = fp;
           }
        }                                         /* Code-Arrays */

     }                                                   /* Active components */

     if((sd-&gt;stc.am != NULL) &amp;&amp; (sd-&gt;stc.am != oldstc.am)) {
        if(     sd-&gt;color_info.num_components == 1) i =  3;
        else if(sd-&gt;color_info.num_components == 3) i =  9;
        else                                        i = 16;
        fp = gs_malloc(sd-&gt;memory, i,sizeof(float),"stc_put_params");
        if(fp != NULL) memcpy(fp,sd-&gt;stc.am,i*sizeof(float));
        else           code = gs_error_VMerror;
        sd-&gt;stc.am = fp;
     }

     if(sd-&gt;stc.escp_init.data != oldstc.escp_init.data) {
        byte *ip = NULL;

        if(sd-&gt;stc.escp_init.size &gt; 0) {
           ip = gs_malloc(sd-&gt;memory, sd-&gt;stc.escp_init.size,1,"stcolor/init");
           if(ip == NULL) {
              code = gs_error_VMerror;
              sd-&gt;stc.escp_init.size = 0;
           } else {
              memcpy(ip,sd-&gt;stc.escp_init.data,sd-&gt;stc.escp_init.size);
           }
        }
        sd-&gt;stc.escp_init.data       = ip;
        sd-&gt;stc.escp_init.persistent = false;
     }

     if(sd-&gt;stc.escp_release.data != oldstc.escp_release.data) {
        byte *ip = NULL;

        if(sd-&gt;stc.escp_release.size &gt; 0) {
           ip = gs_malloc(sd-&gt;memory, sd-&gt;stc.escp_release.size,1,"stcolor/release");
           if(ip == NULL) {
              code = gs_error_VMerror;
              sd-&gt;stc.escp_release.size = 0;
           } else {
              memcpy(ip,sd-&gt;stc.escp_release.data,sd-&gt;stc.escp_release.size);
           }
        }
        sd-&gt;stc.escp_release.data       = ip;
        sd-&gt;stc.escp_release.persistent = false;
     }

     if(code &lt; 0) { /* free newly allocated arrays */

        if((sd-&gt;stc.am != NULL) &amp;&amp; (sd-&gt;stc.am != oldstc.am)) {
           if(     sd-&gt;color_info.num_components == 1) i =  3;
           else if(sd-&gt;color_info.num_components == 3) i =  9;
           else                                        i = 16;
           gs_free(sd-&gt;memory, sd-&gt;stc.am,i,sizeof(float),"stc_put_params");
        }

        if((sd-&gt;stc.escp_init.data != NULL) &amp;&amp;
           (sd-&gt;stc.escp_init.data != oldstc.escp_init.data))
           gs_free(sd-&gt;memory, (byte *) sd-&gt;stc.escp_init.data,sd-&gt;stc.escp_init.size,1,
              "stcolor/init");

        if((sd-&gt;stc.escp_release.data != NULL) &amp;&amp;
           (sd-&gt;stc.escp_release.data != oldstc.escp_release.data))
           gs_free(sd-&gt;memory, (byte *) sd-&gt;stc.escp_release.data,sd-&gt;stc.escp_release.
              size,1,"stcolor/release");

        for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) { /* components */
           int j;

           if((sd-&gt;stc.extc[i] != NULL) &amp;&amp;
              (sd-&gt;stc.extc[i] != defext) &amp;&amp;
              (sd-&gt;stc.extc[i] != oldstc.extc[i])) {

              for(j = 0; j &lt; i; ++j)
                 if(sd-&gt;stc.extc[i] == sd-&gt;stc.extc[j]) break;

              if(i == j) gs_free(sd-&gt;memory, sd-&gt;stc.extc[i],sd-&gt;stc.sizc[i],sizeof(float),
                            "stc_put_params");
           }

           if((sd-&gt;stc.extv[i] != NULL) &amp;&amp;
              (sd-&gt;stc.extv[i] != oldstc.extv[i]) &amp;&amp;
              (sd-&gt;stc.extv[i] != defext)) {

              for(j = 0; j &lt; i; ++j)
                 if(sd-&gt;stc.extv[i] == sd-&gt;stc.extv[j]) break;

              if(i == j) gs_free(sd-&gt;memory, sd-&gt;stc.extv[i],sd-&gt;stc.sizv[i],sizeof(float),
                            "stc_put_params");
           }
        }                                                    /* components */
     }              /* free newly allocated arrays */
   }                /* Allocate new arrays */
   error = error &gt; code ? code : error;

/*
 * finally decide upon restore or release of old, unused data
 */
   if(error != 0) { /* Undo changes */

      memcpy(&amp;sd-&gt;color_info,&amp;oldcolor,sizeof(oldcolor));
      memcpy(&amp;sd-&gt;stc       ,&amp;oldstc  ,sizeof(oldstc  ));
   } else {        /* undo / release */

      if((oldstc.escp_init.data != NULL) &amp;&amp;
         (oldstc.escp_init.data != sd-&gt;stc.escp_init.data)) {
            gs_free(sd-&gt;memory, (byte *)oldstc.escp_init.data,
                            oldstc.escp_init.size,1,"stcolor/init");
      }

      if((oldstc.escp_release.data != NULL) &amp;&amp;
         (oldstc.escp_release.data != sd-&gt;stc.escp_release.data)) {
            gs_free(sd-&gt;memory, (byte *)oldstc.escp_release.data,
                            oldstc.escp_release.size,1,"stcolor/release");
      }

      if((oldstc.am != NULL) &amp;&amp; (oldstc.am != sd-&gt;stc.am)) {
         if(     oldcolor.num_components == 1) i =  3;
         else if(oldcolor.num_components == 3) i =  9;
         else                                  i = 16;
         gs_free(sd-&gt;memory, oldstc.am,i,sizeof(float),"stc_put_params");
      }

      for(i = 0; i &lt; 4; ++i) {
         int j;

         if((oldstc.extc[i] != NULL) &amp;&amp;
            (oldstc.extc[i] != sd-&gt;stc.extc[i]) &amp;&amp;
            (oldstc.dither  != NULL) &amp;&amp;
            (oldstc.extc[i] != defext)) {

            for(j = 0; j &lt; i; ++j) if(oldstc.extc[i] == oldstc.extc[j]) break;

            if(i == j) gs_free(sd-&gt;memory, oldstc.extc[i],oldstc.sizc[i],sizeof(float),
                            "stc_put_params");
         }

         if((oldstc.extv[i] != NULL) &amp;&amp;
            (oldstc.extv[i] != sd-&gt;stc.extv[i]) &amp;&amp;
            (oldstc.extv[i] != defext)) {

            for(j = 0; j &lt; i; ++j) if(oldstc.extv[i] == oldstc.extv[j]) break;

            if(i == j) gs_free(sd-&gt;memory, oldstc.extv[i],oldstc.sizv[i],sizeof(float),
                            "stc_put_params");
         }
      }

/*
 * Close the device if colormodel changed or recomputation
 * of internal arrays is required
 */
      if(sd-&gt;is_open) { /* we might need to close it */
         bool doclose = false;
         if((sd-&gt;color_info.num_components != oldcolor.num_components) ||
            (sd-&gt;color_info.depth          != oldcolor.depth         ) ||
            (sd-&gt;stc.bits                  != oldstc.bits            ) ||
            (sd-&gt;stc.dither                != oldstc.dither          ))
            doclose = true;

         for(i = 0; i &lt; sd-&gt;color_info.num_components; ++i) {
            if(sd-&gt;stc.extv[i] != oldstc.extv[i]) doclose = true;
            if(sd-&gt;stc.extc[i] != oldstc.extc[i]) doclose = true;
         }
         if(doclose) {
            stc_freedata(pdev-&gt;memory, &amp;oldstc);
            for(i = 0; i &lt; 4; ++i) {
               sd-&gt;stc.vals[i] = NULL;
               sd-&gt;stc.code[i] = NULL;
            }

            gs_closedevice(pdev);
         }
      }                 /* we might need to close it */

   }

   return error;
}
/*
 * 1Bit CMYK-Algorithm
 */

private int
stc_gscmyk(stcolor_device *sdev,int npixel,byte *in,byte *buf,byte *out)
{

   byte *ip = in;
   int   error = 0;


/* ============================================================= */
   if(npixel &gt; 0) {  /* npixel &gt;  0 -&gt; scanline-processing       */
/* ============================================================= */

      int p;

/*
 *    simply split the two pixels rsiding in a byte
 */
      for(p = npixel; p &gt; 0; --p) { /* loop over pixels */
         byte tmp =*ip++;

         *out++ = (tmp&gt;&gt;4) &amp; 15;
         if(--p &lt;= 0) break;

         *out++ =  tmp     &amp; 15;

      }                                   /* loop over pixels */

/* ============================================================= */
   } else {          /* npixel &lt;= 0 -&gt; initialisation            */
/* ============================================================= */

/*    we didn't check for the white-calls above, so this may cause errors */
      if(sdev-&gt;stc.dither-&gt;flags &amp; STC_WHITE)              error = -1;

/*    if we're not setup for bytes, this is an error too */
      if((sdev-&gt;stc.dither-&gt;flags &amp; STC_TYPE) != STC_BYTE) error = -2;

/*    This IS a direct-driver, so STC_DIRECT must be set! */
      if((sdev-&gt;stc.dither-&gt;flags &amp; STC_DIRECT) == 0)      error = -3;

/*    and cmyk-mode is the only supported mode */
      if(sdev-&gt;color_info.num_components != 4)             error = -4;

/*    and we support only 4Bit-Depth here */
      if(sdev-&gt;color_info.depth != 4)                      error = -5;

/* ============================================================= */
   } /* scanline-processing or initialisation */
/* ============================================================= */

   return error;
}

/*
 * The following is an algorithm under test
 */
private int
stc_hscmyk(stcolor_device *sdev,int npixel,byte *in,byte *buf,byte *out)
{

/* ============================================================= */
   if(npixel &lt; 0) {  /* npixel &lt;= 0 -&gt; initialisation            */
/* ============================================================= */

      int i,i2do;
      long *lp = (long *) buf;

/* CMYK-only algorithm */
      if( sdev-&gt;color_info.num_components != 4)                      return -1;

/*
 * check wether stcdither &amp; TYPE are correct
 */
      if(( sdev-&gt;stc.dither                    == NULL) ||
         ((sdev-&gt;stc.dither-&gt;flags &amp; STC_TYPE) != STC_LONG))         return -2;

/*
 * check wether the buffer-size is sufficiently large
 */
      if(((sdev-&gt;stc.dither-&gt;flags/STC_SCAN) &lt; 1) ||
         ( sdev-&gt;stc.dither-&gt;bufadd          &lt;
          (1 + 2*sdev-&gt;color_info.num_components)))                  return -3;

/*
 * must have STC_CMYK10, STC_DIRECT, but not STC_WHITE
 */
      if((sdev-&gt;stc.dither-&gt;flags &amp; STC_CMYK10) == 0)                return -4;
      if((sdev-&gt;stc.dither-&gt;flags &amp; STC_DIRECT) == 0)                return -5;
      if((sdev-&gt;stc.dither-&gt;flags &amp; STC_WHITE ) != 0)                return -6;

/*
 * Must have values between 0-1023.0
 */
      if((sdev-&gt;stc.dither-&gt;minmax[0] !=    0.0) ||
         (sdev-&gt;stc.dither-&gt;minmax[1] != 1023.0))                    return -7;
/*
 * initialize buffer
 */

     i2do            = 1 + 8 - 4 * npixel;
     lp[0] = 0;

      if(sdev-&gt;stc.flags &amp; STCDFLAG0) {
        for(i = 1; i &lt; i2do; ++i) lp[i] = 0;
      } else {
        for(i = 1; i &lt; i2do; ++i)  lp[i] = (rand() % 381) - 190;
      }

/* ============================================================= */
   } else {  /* npixel &gt; 0 &amp;&amp; in != NULL  -&gt; scanline-processing */
/* ============================================================= */

      long errc[4],*errv;
      int             step  = buf[0] ? -1 : 1;
      stc_pixel *ip    =  (stc_pixel *) in;

      buf[0] = ~ buf[0];
      errv   =  (long *) buf + 5;

      if(step &lt; 0) {
        ip   += npixel-1;
        out  += npixel-1;
        errv += 4*(npixel-1);
      }

      errc[0] = 0; errc[1] = 0; errc[2] = 0; errc[3] = 0;

      while(npixel-- &gt; 0) {

         register  stc_pixel ci,mode;
         register  long           k,v,n;
         register  int pixel; /* internal pixel-value */

         ci      = *ip; ip += step;

         mode    = ci &amp; 3;
         k       = (ci&gt;&gt;2) &amp; 0x3ff;
         pixel   = 0;

         v       = k+errv[3]+((7*errc[3])&gt;&gt;4);

         if(mode == 3) { /* only Black allowed to fire */

            if(v &gt; 511) {
               v     -= 1023;
               pixel  = BLACK;
            }
            errv[3-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[3]            = ((5*v+errc[3]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[3]            = v;

            errv[0] = errv[0] &lt; -190 ? -190 : errv[0] &lt; 190 ? errv[0] : 190;
            errv[1] = errv[1] &lt; -190 ? -190 : errv[1] &lt; 190 ? errv[1] : 190;
            errv[2] = errv[2] &lt; -190 ? -190 : errv[2] &lt; 190 ? errv[2] : 190;

            errc[0] = 0; errc[1] = 0; errc[2] = 0;

         } else if(v &gt; 511) { /* black known to fire */

            v    -= 1023;
            pixel = BLACK;

            errv[3-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[3]            = ((5*v+errc[3]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[3]            = v;

            n = (ci&gt;&gt;12) &amp; 0x3ff;

            if(mode == 2) { v = k; }
            else          { v = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }

            v += errv[2]+((7*errc[2])&gt;&gt;4)-1023;
            if(v &lt; -511) v = -511;
            errv[2-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[2]            = ((5*v+errc[2]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[2]            = v;

            if(mode == 1) { v = k; }
            else          { v = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }

            v += errv[1]+((7*errc[1])&gt;&gt;4)-1023;
            if(v &lt; -511) v = -511;
            errv[1-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[1]            = ((5*v+errc[1]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[1]            = v;

            if(mode == 0) v = k;
            else          v = n;

            v += errv[0]+((7*errc[0])&gt;&gt;4)-1023;
            if(v &lt; -511) v = -511;
            errv[0-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[0]            = ((5*v+errc[0]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[0]            = v;

         } else { /* Black does not fire initially */

            long kv = v; /* Black computed after colors */

            n = (ci&gt;&gt;12) &amp; 0x3ff;

            if(mode == 2) { v = k; }
            else          { v = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }

            v += errv[2]+((7*errc[2])&gt;&gt;4);
            if(v &gt; 511) {
               pixel |= YELLOW;
               v     -= 1023;
            }
            errv[2-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[2]            = ((5*v+errc[2]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[2]            = v;

            if(mode == 1) { v = k; }
            else          { v = n; n = (ci&gt;&gt;22) &amp; 0x3ff; }

            v += errv[1]+((7*errc[1])&gt;&gt;4);
            if(v &gt; 511) {
               pixel |= MAGENTA;
               v     -= 1023;
            }
            errv[1-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[1]            = ((5*v+errc[1]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[1]            = v;

            if(mode == 0) v = k;
            else          v = n;

            v += errv[0]+((7*errc[0])&gt;&gt;4);
            if(v &gt; 511) {
               pixel |= CYAN;
               v     -= 1023;
            }
            errv[0-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[0]            = ((5*v+errc[0]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[0]            = v;

            v = kv;
            if(pixel == (CYAN|MAGENTA|YELLOW)) {
               pixel = BLACK;
               v     = v &gt; 511 ? v-1023 : -511;
            }
            errv[3-(step&lt;&lt;2)] += ((3*v+8)&gt;&gt;4);        /* 3/16 */
            errv[3]            = ((5*v+errc[3]+8)&gt;&gt;4);/* 5/16 +1/16 (rest) */
            errc[3]            = v;

         }

         errv += step&lt;&lt;2;
         *out  = pixel; out += step;

      }                                         /* loop over pixels */

/* ============================================================= */
   } /* initialisation, white or scanline-processing             */
/* ============================================================= */

   return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

