<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevvec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevvec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1997, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevvec.c,v 1.27 2005/08/23 11:26:26 igor Exp $ */
/* Utilities for "vector" devices */
#include "math_.h"
#include "memory_.h"
#include "string_.h"
#include "gx.h"
#include "gp.h"
#include "gserrors.h"
#include "gsparam.h"
#include "gsutil.h"
#include "gxfixed.h"
#include "gdevvec.h"
#include "gscspace.h"
#include "gxdcolor.h"
#include "gxpaint.h"		/* requires gx_path, ... */
#include "gzpath.h"
#include "gzcpath.h"

/* Structure descriptors */
public_st_device_vector();
public_st_vector_image_enum();

/* ================ Default implementations of vector procs ================ */

int
gdev_vector_setflat(gx_device_vector * vdev, floatp flatness)
{
    return 0;
}

/* Put a path on the output file. */
private bool
coord_between(fixed start, fixed mid, fixed end)
{
    return (start &lt;= end ? start &lt;= mid &amp;&amp; mid &lt;= end :
	    start &gt;= mid &amp;&amp; mid &gt;= end);
}
int
gdev_vector_dopath(gx_device_vector *vdev, const gx_path * ppath,
		   gx_path_type_t type, const gs_matrix *pmat)
{
    bool do_close =
	(type &amp; (gx_path_type_stroke | gx_path_type_always_close)) != 0;
    gs_fixed_rect rbox;
    gx_path_rectangular_type rtype = gx_path_is_rectangular(ppath, &amp;rbox);
    gs_path_enum cenum;
    gdev_vector_dopath_state_t state;
    gs_fixed_point line_start, line_end;
    bool incomplete_line = false;
    bool need_moveto = false;
    int code;

    gdev_vector_dopath_init(&amp;state, vdev, type, pmat);
    /*
     * if the path type is stroke, we only recognize closed
     * rectangles; otherwise, we recognize all rectangles.
     * Note that for stroking with a transformation, we can't use dorect,
     * which requires (untransformed) device coordinates.
     */
    if (rtype != prt_none &amp;&amp;
	(!(type &amp; gx_path_type_stroke) || rtype == prt_closed) &amp;&amp;
	(pmat == 0 || is_xxyy(pmat) || is_xyyx(pmat)) &amp;&amp;
	(state.scale_mat.xx == 1.0 &amp;&amp; state.scale_mat.yy == 1.0 &amp;&amp;
	 is_xxyy(&amp;state.scale_mat) &amp;&amp;
	 is_fzero2(state.scale_mat.tx, state.scale_mat.ty))
	) {
	gs_point p, q;

	gs_point_transform_inverse((floatp)rbox.p.x, (floatp)rbox.p.y,
				   &amp;state.scale_mat, &amp;p);
	gs_point_transform_inverse((floatp)rbox.q.x, (floatp)rbox.q.y,
				   &amp;state.scale_mat, &amp;q);
	code = vdev_proc(vdev, dorect)(vdev, (fixed)p.x, (fixed)p.y,
				       (fixed)q.x, (fixed)q.y, type);
	if (code &gt;= 0)
	    return code;
	/* If the dorect proc failed, use a general path. */
    }
    code = vdev_proc(vdev, beginpath)(vdev, type);
    if (code &lt; 0)
	return code;
    gx_path_enum_init(&amp;cenum, ppath);
    for (;;) {
	gs_fixed_point vs[3];
	int pe_op = gx_path_enum_next(&amp;cenum, vs);

    sw:
	if (type &amp; gx_path_type_optimize) {
	opt:
	    if (pe_op == gs_pe_lineto) {
		if (!incomplete_line) {
		    line_end = vs[0];
		    incomplete_line = true;
		    continue;
		}
		/*
		 * Merge collinear horizontal or vertical line segments
		 * going in the same direction.
		 */
		if (vs[0].x == line_end.x) {
		    if (vs[0].x == line_start.x &amp;&amp;
			coord_between(line_start.y, line_end.y, vs[0].y)
			) {
			line_end.y = vs[0].y;
			continue;
		    }
		} else if (vs[0].y == line_end.y) {
		    if (vs[0].y == line_start.y &amp;&amp;
			coord_between(line_start.x, line_end.x, vs[0].x)
			) {
			line_end.x = vs[0].x;
			continue;
		    }
		}
	    }
	    if (incomplete_line) {
		if (need_moveto) {	/* see gs_pe_moveto case */
		    code = gdev_vector_dopath_segment(&amp;state, gs_pe_moveto,
						      &amp;line_start);
		    if (code &lt; 0)
			return code;
		    need_moveto = false;
		}
		code = gdev_vector_dopath_segment(&amp;state, gs_pe_lineto,
						  &amp;line_end);
		if (code &lt; 0)
		    return code;
		line_start = line_end;
		incomplete_line = false;
		goto opt;
	    }
	}
	switch (pe_op) {
	case 0:		/* done */
	done:
	    code = vdev_proc(vdev, endpath)(vdev, type);
	    return (code &lt; 0 ? code : 0);
	case gs_pe_curveto:
	    if (need_moveto) {	/* see gs_pe_moveto case */
		code = gdev_vector_dopath_segment(&amp;state, gs_pe_moveto,
						  &amp;line_start);
		if (code &lt; 0)
		    return code;
		need_moveto = false;
	    }
	    line_start = vs[2];
	    goto draw;
	case gs_pe_moveto:
	    /*
	     * A bug in Acrobat Reader 4 causes it to draw a single pixel
	     * for a fill with an isolated moveto.  If we're doing a fill
	     * without a stroke, defer emitting a moveto until we know that
	     * the subpath has more elements.
	     */
	    line_start = vs[0];
	    if (!(type &amp; gx_path_type_stroke) &amp;&amp; (type &amp; gx_path_type_fill)) {
		need_moveto = true;
		continue;
	    }
	    goto draw;
	case gs_pe_lineto:
	    if (need_moveto) {	/* see gs_pe_moveto case */
		code = gdev_vector_dopath_segment(&amp;state, gs_pe_moveto,
						  &amp;line_start);
		if (code &lt; 0)
		    return code;
		need_moveto = false;
	    }
	    line_start = vs[0];
	    goto draw;
	case gs_pe_closepath:
	    if (need_moveto) {	/* see gs_pe_moveto case */
		need_moveto = false;
		continue;
	    }
	    if (!do_close) {
		pe_op = gx_path_enum_next(&amp;cenum, vs);
		if (pe_op == 0)
		    goto done;
		code = gdev_vector_dopath_segment(&amp;state, gs_pe_closepath, vs);
		if (code &lt; 0)
		    return code;
		goto sw;
	    }
	    /* falls through */
	draw:
	    code = gdev_vector_dopath_segment(&amp;state, pe_op, vs);
	    if (code &lt; 0)
		return code;
	}
	incomplete_line = false; /* only needed if optimizing */
    }
}

int
gdev_vector_dorect(gx_device_vector * vdev, fixed x0, fixed y0, fixed x1,
		   fixed y1, gx_path_type_t type)
{
    int code = (*vdev_proc(vdev, beginpath)) (vdev, type);

    if (code &lt; 0)
	return code;
    code = gdev_vector_write_rectangle(vdev, x0, y0, x1, y1,
				       (type &amp; gx_path_type_stroke) != 0,
				       gx_rect_x_first);
    if (code &lt; 0)
	return code;
    return (*vdev_proc(vdev, endpath)) (vdev, type);
}

/* ================ Utility procedures ================ */

/* Recompute the cached color values. */
private void
gdev_vector_load_cache(gx_device_vector * vdev)
{
    vdev-&gt;black = gx_device_black((gx_device *)vdev);
    vdev-&gt;white = gx_device_white((gx_device *)vdev);
}

/* Initialize the state. */
void
gdev_vector_init(gx_device_vector * vdev)
{
    gdev_vector_reset(vdev);
    vdev-&gt;scale.x = vdev-&gt;scale.y = 1.0;
    vdev-&gt;in_page = false;
    gdev_vector_load_cache(vdev);
}

/* Reset the remembered graphics state. */
void
gdev_vector_reset(gx_device_vector * vdev)
{
    static const gs_imager_state state_initial =
    {gs_imager_state_initial(1)};

    vdev-&gt;state = state_initial;
    gx_hld_saved_color_init(&amp;vdev-&gt;saved_fill_color);
    gx_hld_saved_color_init(&amp;vdev-&gt;saved_stroke_color);
    vdev-&gt;clip_path_id =
	vdev-&gt;no_clip_path_id = gs_next_ids(vdev-&gt;memory, 1);
}

/* Open the output file and stream. */
int
gdev_vector_open_file_options(gx_device_vector * vdev, uint strmbuf_size,
			      int open_options)
{
    bool binary = !(open_options &amp; VECTOR_OPEN_FILE_ASCII);
    int code = -1;		/* (only for testing, never returned) */

    /* Open the file as seekable or sequential, as requested. */
    if (!(open_options &amp; VECTOR_OPEN_FILE_SEQUENTIAL)) {
	/* Try to open as seekable. */
	code =
	    gx_device_open_output_file((gx_device *)vdev, vdev-&gt;fname,
				       binary, true, &amp;vdev-&gt;file);
    }
    if (code &lt; 0 &amp;&amp; (open_options &amp; (VECTOR_OPEN_FILE_SEQUENTIAL |
				     VECTOR_OPEN_FILE_SEQUENTIAL_OK))) {
	/* Try to open as sequential. */
	code = gx_device_open_output_file((gx_device *)vdev, vdev-&gt;fname,
					  binary, false, &amp;vdev-&gt;file);
    }
    if (code &lt; 0)
	return code;
    if ((vdev-&gt;strmbuf = gs_alloc_bytes(vdev-&gt;v_memory, strmbuf_size,
					"vector_open(strmbuf)")) == 0 ||
	(vdev-&gt;strm = s_alloc(vdev-&gt;v_memory,
			      "vector_open(strm)")) == 0 ||
	((open_options &amp; VECTOR_OPEN_FILE_BBOX) &amp;&amp;
	 (vdev-&gt;bbox_device =
	  gs_alloc_struct_immovable(vdev-&gt;v_memory,
				    gx_device_bbox, &amp;st_device_bbox,
				    "vector_open(bbox_device)")) == 0)
	) {
	if (vdev-&gt;bbox_device)
	    gs_free_object(vdev-&gt;v_memory, vdev-&gt;bbox_device,
			   "vector_open(bbox_device)");
	vdev-&gt;bbox_device = 0;
	if (vdev-&gt;strm)
	    gs_free_object(vdev-&gt;v_memory, vdev-&gt;strm,
			   "vector_open(strm)");
	vdev-&gt;strm = 0;
	if (vdev-&gt;strmbuf)
	    gs_free_object(vdev-&gt;v_memory, vdev-&gt;strmbuf,
			   "vector_open(strmbuf)");
	vdev-&gt;strmbuf = 0;
	fclose(vdev-&gt;file);
	vdev-&gt;file = 0;
	return_error(gs_error_VMerror);
    }
    vdev-&gt;strmbuf_size = strmbuf_size;
    swrite_file(vdev-&gt;strm, vdev-&gt;file, vdev-&gt;strmbuf, strmbuf_size);
    vdev-&gt;open_options = open_options;
    /*
     * We don't want finalization to close the file, but we do want it
     * to flush the stream buffer.
     */
    vdev-&gt;strm-&gt;procs.close = vdev-&gt;strm-&gt;procs.flush;
    if (vdev-&gt;bbox_device) {
	gx_device_bbox_init(vdev-&gt;bbox_device, NULL, vdev-&gt;v_memory);
        rc_increment(vdev-&gt;bbox_device);
	gx_device_set_resolution((gx_device *) vdev-&gt;bbox_device,
				 vdev-&gt;HWResolution[0],
				 vdev-&gt;HWResolution[1]);
	/* Do the right thing about upright vs. inverted. */
	/* (This is dangerous in general, since the procedure */
	/* might reference non-standard elements.) */
	set_dev_proc(vdev-&gt;bbox_device, get_initial_matrix,
		     dev_proc(vdev, get_initial_matrix));
	(*dev_proc(vdev-&gt;bbox_device, open_device))
	    ((gx_device *) vdev-&gt;bbox_device);
    }
    return 0;
}

/* Get the current stream, calling beginpage if in_page is false. */
stream *
gdev_vector_stream(gx_device_vector * vdev)
{
    if (!vdev-&gt;in_page) {
	(*vdev_proc(vdev, beginpage)) (vdev);
	vdev-&gt;in_page = true;
    }
    return vdev-&gt;strm;
}

/* Update the logical operation. */
int
gdev_vector_update_log_op(gx_device_vector * vdev, gs_logical_operation_t lop)
{
    gs_logical_operation_t diff = lop ^ vdev-&gt;state.log_op;

    if (diff != 0) {
	int code = (*vdev_proc(vdev, setlogop)) (vdev, lop, diff);

	if (code &lt; 0)
	    return code;
	vdev-&gt;state.log_op = lop;
    }
    return 0;
}

/* Update color (fill or stroke). */
private int
gdev_vector_update_color(gx_device_vector * vdev,
			      const gs_imager_state * pis,
			      const gx_drawing_color * pdcolor,
			      gx_hl_saved_color *sc,
			      int (*setcolor) (gx_device_vector * vdev, 
			                       const gs_imager_state * pis, 
					       const gx_drawing_color * pdc))
{
    gx_hl_saved_color temp;
    int code;
    bool hl_color = (*vdev_proc(vdev, can_handle_hl_color)) (vdev, pis, pdcolor);
    const gs_imager_state *pis_for_hl_color = (hl_color ? pis : NULL);
    
    gx_hld_save_color(pis_for_hl_color, pdcolor, &amp;temp);
    if (gx_hld_saved_color_equal(&amp;temp, sc))
	return 0;
    code = (*setcolor) (vdev, pis_for_hl_color, pdcolor);
    if (code &lt; 0)
	return code;
    *sc = temp;
    return 0;
}

/* Update the fill color. */
int
gdev_vector_update_fill_color(gx_device_vector * vdev,
			      const gs_imager_state * pis,
			      const gx_drawing_color * pdcolor)
{
    return gdev_vector_update_color(vdev, pis, pdcolor, &amp;vdev-&gt;saved_fill_color, 
                                    vdev_proc(vdev, setfillcolor));
}

/* Update the state for filling a region. */
private int
update_fill(gx_device_vector * vdev, const gs_imager_state * pis, 
	    const gx_drawing_color * pdcolor, gs_logical_operation_t lop)
{
    int code = gdev_vector_update_fill_color(vdev, pis, pdcolor);

    if (code &lt; 0)
	return code;
    return gdev_vector_update_log_op(vdev, lop);
}

/* Bring state up to date for filling. */
int
gdev_vector_prepare_fill(gx_device_vector * vdev, const gs_imager_state * pis,
	    const gx_fill_params * params, const gx_drawing_color * pdcolor)
{
    if (params-&gt;flatness != vdev-&gt;state.flatness) {
	int code = (*vdev_proc(vdev, setflat)) (vdev, params-&gt;flatness);

	if (code &lt; 0)
	    return code;
	vdev-&gt;state.flatness = params-&gt;flatness;
    }
    return update_fill(vdev, pis, pdcolor, pis-&gt;log_op);
}

/* Compare two dash patterns. */
private bool
dash_pattern_eq(const float *stored, const gx_dash_params * set, floatp scale)
{
    int i;

    for (i = 0; i &lt; set-&gt;pattern_size; ++i)
	if (stored[i] != (float)(set-&gt;pattern[i] * scale))
	    return false;
    return true;
}

/* Bring state up to date for stroking. */
int
gdev_vector_prepare_stroke(gx_device_vector * vdev,
			   const gs_imager_state * pis,	/* may be NULL */
			   const gx_stroke_params * params, /* may be NULL */
			   const gx_drawing_color * pdcolor, /* may be NULL */
			   floatp scale)
{
    if (pis) {
	int pattern_size = pis-&gt;line_params.dash.pattern_size;
	float dash_offset = pis-&gt;line_params.dash.offset * scale;
	float half_width = pis-&gt;line_params.half_width * scale;

	if (pattern_size &gt; max_dash)
	    return_error(gs_error_limitcheck);
	if (dash_offset != vdev-&gt;state.line_params.dash.offset ||
	    pattern_size != vdev-&gt;state.line_params.dash.pattern_size ||
	    (pattern_size != 0 &amp;&amp;
	     !dash_pattern_eq(vdev-&gt;dash_pattern, &amp;pis-&gt;line_params.dash,
			      scale))
	    ) {
	    float pattern[max_dash];
	    int i, code;

	    for (i = 0; i &lt; pattern_size; ++i)
		pattern[i] = pis-&gt;line_params.dash.pattern[i] * scale;
	    code = (*vdev_proc(vdev, setdash))
		(vdev, pattern, pattern_size, dash_offset);
	    if (code &lt; 0)
		return code;
	    memcpy(vdev-&gt;dash_pattern, pattern, pattern_size * sizeof(float));

	    vdev-&gt;state.line_params.dash.pattern_size = pattern_size;
	    vdev-&gt;state.line_params.dash.offset = dash_offset;
	}
	if (half_width != vdev-&gt;state.line_params.half_width) {
	    int code = (*vdev_proc(vdev, setlinewidth))
		(vdev, half_width * 2);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;state.line_params.half_width = half_width;
	}
	if (pis-&gt;line_params.miter_limit != vdev-&gt;state.line_params.miter_limit) {
	    int code = (*vdev_proc(vdev, setmiterlimit))
		(vdev, pis-&gt;line_params.miter_limit);

	    if (code &lt; 0)
		return code;
	    gx_set_miter_limit(&amp;vdev-&gt;state.line_params,
			       pis-&gt;line_params.miter_limit);
	}
	if (pis-&gt;line_params.cap != vdev-&gt;state.line_params.cap) {
	    int code = (*vdev_proc(vdev, setlinecap))
		(vdev, pis-&gt;line_params.cap);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;state.line_params.cap = pis-&gt;line_params.cap;
	}
	if (pis-&gt;line_params.join != vdev-&gt;state.line_params.join) {
	    int code = (*vdev_proc(vdev, setlinejoin))
		(vdev, pis-&gt;line_params.join);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;state.line_params.join = pis-&gt;line_params.join;
	} {
	    int code = gdev_vector_update_log_op(vdev, pis-&gt;log_op);

	    if (code &lt; 0)
		return code;
	}
    }
    if (params) {
	if (params-&gt;flatness != vdev-&gt;state.flatness) {
	    int code = (*vdev_proc(vdev, setflat)) (vdev, params-&gt;flatness);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;state.flatness = params-&gt;flatness;
	}
    }
    if (pdcolor) {
	int code = gdev_vector_update_color(vdev, pis, pdcolor, 
		    &amp;vdev-&gt;saved_stroke_color, vdev_proc(vdev, setstrokecolor));

	if (code &lt; 0)
	    return code;
    }
    return 0;
}

/*
 * Compute the scale for transforming the line width and dash pattern for a
 * stroke operation, and, if necessary to handle anisotropic scaling, a full
 * transformation matrix to be inverse-applied to the path elements as well.
 * Return 0 if only scaling, 1 if a full matrix is needed.
 */
int
gdev_vector_stroke_scaling(const gx_device_vector *vdev,
			   const gs_imager_state *pis,
			   double *pscale, gs_matrix *pmat)
{
    bool set_ctm = true;
    double scale = 1;

    /*
     * If the CTM is not uniform, stroke width depends on angle.
     * We'd like to avoid resetting the CTM, so we check for uniform
     * CTMs explicitly.  Note that in PDF, unlike PostScript, it is
     * the CTM at the time of the stroke operation, not the CTM at
     * the time the path was constructed, that is used for transforming
     * the points of the path; so if we have to reset the CTM, we must
     * do it before constructing the path, and inverse-transform all
     * the coordinates.
     */
    if (is_xxyy(&amp;pis-&gt;ctm)) {
	scale = fabs(pis-&gt;ctm.xx);
	set_ctm = fabs(pis-&gt;ctm.yy) != scale;
    } else if (is_xyyx(&amp;pis-&gt;ctm)) {
	scale = fabs(pis-&gt;ctm.xy);
	set_ctm = fabs(pis-&gt;ctm.yx) != scale;
    } else if ((pis-&gt;ctm.xx == pis-&gt;ctm.yy &amp;&amp; pis-&gt;ctm.xy == -pis-&gt;ctm.yx) ||
	       (pis-&gt;ctm.xx == -pis-&gt;ctm.yy &amp;&amp; pis-&gt;ctm.xy == pis-&gt;ctm.yx)
	) {
	scale = hypot(pis-&gt;ctm.xx, pis-&gt;ctm.xy);
	set_ctm = false;
    }
    if (set_ctm) {
	/*
	 * Adobe Acrobat Reader has limitations on the maximum user
	 * coordinate value.  If we scale the matrix down too far, the
	 * coordinates will get too big: limit the scale factor to prevent
	 * this from happening.  (This does no harm for other output
	 * formats.)
	 */
	double
	    mxx = pis-&gt;ctm.xx / vdev-&gt;scale.x,
	    mxy = pis-&gt;ctm.xy / vdev-&gt;scale.y,
	    myx = pis-&gt;ctm.yx / vdev-&gt;scale.x,
	    myy = pis-&gt;ctm.yy / vdev-&gt;scale.y;

	scale = 0.5 * (fabs(mxx) + fabs(mxy) + fabs(myx) + fabs(myy));
	pmat-&gt;xx = mxx / scale, pmat-&gt;xy = mxy / scale;
	pmat-&gt;yx = myx / scale, pmat-&gt;yy = myy / scale;
	pmat-&gt;tx = pmat-&gt;ty = 0;
    }
    *pscale = scale;
    return (int)set_ctm;
}

/* Initialize for writing a path using the default implementation. */
void
gdev_vector_dopath_init(gdev_vector_dopath_state_t *state,
			gx_device_vector *vdev, gx_path_type_t type,
			const gs_matrix *pmat)
{
    state-&gt;vdev = vdev;
    state-&gt;type = type;
    if (pmat) {
	state-&gt;scale_mat = *pmat;
	/*
	 * The path element writing procedures all divide the coordinates
	 * by the scale, so we must compensate for that here.
	 */
	gs_matrix_scale(&amp;state-&gt;scale_mat, 1.0 / vdev-&gt;scale.x,
			1.0 / vdev-&gt;scale.y, &amp;state-&gt;scale_mat);
    } else {
	gs_make_scaling(vdev-&gt;scale.x, vdev-&gt;scale.y, &amp;state-&gt;scale_mat);
    }
    state-&gt;first = true;
}

/*
 * Put a segment of an enumerated path on the output file.
 * pe_op is assumed to be valid and non-zero.
 */
int
gdev_vector_dopath_segment(gdev_vector_dopath_state_t *state, int pe_op,
			   gs_fixed_point vs[3])
{
    gx_device_vector *vdev = state-&gt;vdev;
    const gs_matrix *const pmat = &amp;state-&gt;scale_mat;
    gs_point vp[3];
    int code;

    switch (pe_op) {
	case gs_pe_moveto:
	    code = gs_point_transform_inverse(fixed2float(vs[0].x),
				       fixed2float(vs[0].y), pmat, &amp;vp[0]);
	    if (code &lt; 0)
		return code;
	    if (state-&gt;first)
		state-&gt;start = vp[0], state-&gt;first = false;
	    code = vdev_proc(vdev, moveto)
		(vdev, 0/*unused*/, 0/*unused*/, vp[0].x, vp[0].y,
		 state-&gt;type);
	    state-&gt;prev = vp[0];
	    break;
	case gs_pe_lineto:
	    code = gs_point_transform_inverse(fixed2float(vs[0].x),
				       fixed2float(vs[0].y), pmat, &amp;vp[0]);
	    if (code &lt; 0)
		return code;
	    code = vdev_proc(vdev, lineto)
		(vdev, state-&gt;prev.x, state-&gt;prev.y, vp[0].x, vp[0].y,
		 state-&gt;type);
	    state-&gt;prev = vp[0];
	    break;
	case gs_pe_curveto:
	    code = gs_point_transform_inverse(fixed2float(vs[0].x),
				       fixed2float(vs[0].y), pmat, &amp;vp[0]);
	    if (code &lt; 0)
		return code;
	    code = gs_point_transform_inverse(fixed2float(vs[1].x),
				       fixed2float(vs[1].y), pmat, &amp;vp[1]);
	    if (code &lt; 0)
		return code;
	    gs_point_transform_inverse(fixed2float(vs[2].x),
				       fixed2float(vs[2].y), pmat, &amp;vp[2]);
	    code = vdev_proc(vdev, curveto)
		(vdev, state-&gt;prev.x, state-&gt;prev.y, vp[0].x, vp[0].y,
		 vp[1].x, vp[1].y, vp[2].x, vp[2].y, state-&gt;type);
	    state-&gt;prev = vp[2];
	    break;
	case gs_pe_closepath:
	    code = vdev_proc(vdev, closepath)
		(vdev, state-&gt;prev.x, state-&gt;prev.y, state-&gt;start.x,
		 state-&gt;start.y, state-&gt;type);
	    state-&gt;prev = state-&gt;start;
	    break;
	default:		/* can't happen */
	    return -1;
    }
    return code;
}

/* Write a polygon as part of a path. */
/* May call beginpath, moveto, lineto, closepath, endpath. */
int
gdev_vector_write_polygon(gx_device_vector * vdev, const gs_fixed_point * points,
			  uint count, bool close, gx_path_type_t type)
{
    int code = 0;

    if (type != gx_path_type_none &amp;&amp;
	(code = (*vdev_proc(vdev, beginpath)) (vdev, type)) &lt; 0
	)
	return code;
    if (count &gt; 0) {
	double x = fixed2float(points[0].x) / vdev-&gt;scale.x, y = fixed2float(points[0].y) / vdev-&gt;scale.y;
	double x_start = x, y_start = y, x_prev, y_prev;
	uint i;

	code = (*vdev_proc(vdev, moveto))
	    (vdev, 0.0, 0.0, x, y, type);
	if (code &gt;= 0)
	    for (i = 1; i &lt; count &amp;&amp; code &gt;= 0; ++i) {
		x_prev = x, y_prev = y;
		code = (*vdev_proc(vdev, lineto))
		    (vdev, x_prev, y_prev,
		     (x = fixed2float(points[i].x) / vdev-&gt;scale.x),
		     (y = fixed2float(points[i].y) / vdev-&gt;scale.y),
		     type);
	    }
	if (code &gt;= 0 &amp;&amp; close)
	    code = (*vdev_proc(vdev, closepath))
		(vdev, x, y, x_start, y_start, type);
    }
    return (code &gt;= 0 &amp;&amp; type != gx_path_type_none ?
	    (*vdev_proc(vdev, endpath)) (vdev, type) : code);
}

/* Write a rectangle as part of a path. */
/* May call moveto, lineto, closepath. */
int
gdev_vector_write_rectangle(gx_device_vector * vdev, fixed x0, fixed y0,
	      fixed x1, fixed y1, bool close, gx_rect_direction_t direction)
{
    gs_fixed_point points[4];

    points[0].x = x0, points[0].y = y0;
    points[2].x = x1, points[2].y = y1;
    if (direction == gx_rect_x_first)
	points[1].x = x1, points[1].y = y0,
	    points[3].x = x0, points[3].y = y1;
    else
	points[1].x = x0, points[1].y = y1,
	    points[3].x = x1, points[3].y = y0;
    return gdev_vector_write_polygon(vdev, points, 4, close,
				     gx_path_type_none);
}

/* Write a clipping path by calling the path procedures. */
int
gdev_vector_write_clip_path(gx_device_vector * vdev,
			    const gx_clip_path * pcpath)
{
    const gx_clip_rect *prect;
    gx_clip_rect page_rect;
    int code;

    if (pcpath == 0) {
	/* There's no special provision for initclip. */
	/* Write a rectangle that covers the entire page. */
	page_rect.xmin = page_rect.ymin = 0;
	page_rect.xmax = vdev-&gt;width;
	page_rect.ymax = vdev-&gt;height;
	page_rect.next = 0;
	prect = &amp;page_rect;
    } else if (pcpath-&gt;path_valid) {
	return (*vdev_proc(vdev, dopath))
	    (vdev, &amp;pcpath-&gt;path,
	     (pcpath-&gt;rule &lt;= 0 ?
	      gx_path_type_clip | gx_path_type_winding_number :
	      gx_path_type_clip | gx_path_type_even_odd),
	     NULL);
    } else {
	const gx_clip_list *list = gx_cpath_list(pcpath);

	prect = list-&gt;head;
	if (prect == 0)
	    prect = &amp;list-&gt;single;
    }
    /* Write out the rectangles. */
    code = (*vdev_proc(vdev, beginpath)) (vdev, gx_path_type_clip);
    for (; code &gt;= 0 &amp;&amp; prect != 0; prect = prect-&gt;next)
	if (prect-&gt;xmax &gt; prect-&gt;xmin &amp;&amp; prect-&gt;ymax &gt; prect-&gt;ymin)
	    code = gdev_vector_write_rectangle
		(vdev, int2fixed(prect-&gt;xmin), int2fixed(prect-&gt;ymin),
		 int2fixed(prect-&gt;xmax), int2fixed(prect-&gt;ymax),
		 false, gx_rect_x_first);
    if (code &gt;= 0)
	code = (*vdev_proc(vdev, endpath)) (vdev, gx_path_type_clip);
    return code;
}

/* Update the clipping path if needed. */
int
gdev_vector_update_clip_path(gx_device_vector * vdev,
			     const gx_clip_path * pcpath)
{
    if (pcpath) {
	if (pcpath-&gt;id != vdev-&gt;clip_path_id) {
	    int code = gdev_vector_write_clip_path(vdev, pcpath);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;clip_path_id = pcpath-&gt;id;
	}
    } else {
	if (vdev-&gt;clip_path_id != vdev-&gt;no_clip_path_id) {
	    int code = gdev_vector_write_clip_path(vdev, NULL);

	    if (code &lt; 0)
		return code;
	    vdev-&gt;clip_path_id = vdev-&gt;no_clip_path_id;
	}
    }
    return 0;
}

/* Close the output file and stream. */
int
gdev_vector_close_file(gx_device_vector * vdev)
{
    FILE *f = vdev-&gt;file;
    int err;

    gs_free_object(vdev-&gt;v_memory, vdev-&gt;bbox_device,
		   "vector_close(bbox_device)");
    vdev-&gt;bbox_device = 0;
    sclose(vdev-&gt;strm);
    gs_free_object(vdev-&gt;v_memory, vdev-&gt;strm, "vector_close(strm)");
    vdev-&gt;strm = 0;
    gs_free_object(vdev-&gt;v_memory, vdev-&gt;strmbuf, "vector_close(strmbuf)");
    vdev-&gt;strmbuf = 0;
    vdev-&gt;file = 0;
    err = ferror(f);
    /* We prevented sclose from closing the file. */
    if (gx_device_close_output_file((gx_device *)vdev, vdev-&gt;fname, f) != 0 
	|| err != 0)
	return_error(gs_error_ioerror);
    return 0;
}

/* ---------------- Image enumeration ---------------- */

/* Initialize for enumerating an image. */
int
gdev_vector_begin_image(gx_device_vector * vdev,
			const gs_imager_state * pis, const gs_image_t * pim,
			gs_image_format_t format, const gs_int_rect * prect,
	      const gx_drawing_color * pdcolor, const gx_clip_path * pcpath,
		    gs_memory_t * mem, const gx_image_enum_procs_t * pprocs,
			gdev_vector_image_enum_t * pie)
{
    const gs_color_space *pcs = pim-&gt;ColorSpace;
    int num_components;
    int bits_per_pixel;
    int code;

    if (pim-&gt;ImageMask)
	bits_per_pixel = num_components = 1;
    else
	num_components = gs_color_space_num_components(pcs),
	    bits_per_pixel = pim-&gt;BitsPerComponent;
    code = gx_image_enum_common_init((gx_image_enum_common_t *) pie,
				     (const gs_data_image_t *)pim,
				     pprocs, (gx_device *) vdev,
				     num_components, format);
    if (code &lt; 0)
	return code;
    pie-&gt;bits_per_pixel = bits_per_pixel * num_components /
	pie-&gt;num_planes;
    pie-&gt;default_info = 0;
    pie-&gt;bbox_info = 0;
    if ((code = gdev_vector_update_log_op(vdev, pis-&gt;log_op)) &lt; 0 ||
	(code = gdev_vector_update_clip_path(vdev, pcpath)) &lt; 0 ||
	((pim-&gt;ImageMask ||
	  (pim-&gt;CombineWithColor &amp;&amp; rop3_uses_T(pis-&gt;log_op))) &amp;&amp;
	 (code = gdev_vector_update_fill_color(vdev, pis, pdcolor)) &lt; 0) ||
	(vdev-&gt;bbox_device &amp;&amp;
	 (code = (*dev_proc(vdev-&gt;bbox_device, begin_image))
	  ((gx_device *) vdev-&gt;bbox_device, pis, pim, format, prect,
	   pdcolor, pcpath, mem, &amp;pie-&gt;bbox_info)) &lt; 0)
	)
	return code;
    pie-&gt;memory = mem;
    if (prect)
	pie-&gt;width = prect-&gt;q.x - prect-&gt;p.x,
	    pie-&gt;height = prect-&gt;q.y - prect-&gt;p.y;
    else
	pie-&gt;width = pim-&gt;Width, pie-&gt;height = pim-&gt;Height;
    pie-&gt;bits_per_row = pie-&gt;width * pie-&gt;bits_per_pixel;
    pie-&gt;y = 0;
    return 0;
}

/* End an image, optionally supplying any necessary blank padding rows. */
/* Return 0 if we used the default implementation, 1 if not. */
int
gdev_vector_end_image(gx_device_vector * vdev,
	 gdev_vector_image_enum_t * pie, bool draw_last, gx_color_index pad)
{
    int code;

    if (pie-&gt;default_info) {
	code = gx_default_end_image((gx_device *) vdev, pie-&gt;default_info,
				    draw_last);
	if (code &gt;= 0)
	    code = 0;
    } else {			/* Fill out to the full image height. */
	if (pie-&gt;y &lt; pie-&gt;height &amp;&amp; pad != gx_no_color_index) {
	    uint bytes_per_row = (pie-&gt;bits_per_row + 7) &gt;&gt; 3;
	    byte *row = gs_alloc_bytes(pie-&gt;memory, bytes_per_row,
				       "gdev_vector_end_image(fill)");

	    if (row == 0)
		return_error(gs_error_VMerror);
/****** FILL VALUE IS WRONG ******/
	    memset(row, (byte) pad, bytes_per_row);
	    for (; pie-&gt;y &lt; pie-&gt;height; pie-&gt;y++)
		gx_image_data((gx_image_enum_common_t *) pie,
			      (const byte **)&amp;row, 0,
			      bytes_per_row, 1);
	    gs_free_object(pie-&gt;memory, row,
			   "gdev_vector_end_image(fill)");
	}
	code = 1;
    }
    if (vdev-&gt;bbox_device) {
	int bcode = gx_image_end(pie-&gt;bbox_info, draw_last);

	if (bcode &lt; 0)
	    code = bcode;
    }
    gs_free_object(pie-&gt;memory, pie, "gdev_vector_end_image");
    return code;
}

/* ================ Device procedures ================ */

#define vdev ((gx_device_vector *)dev)

/* Get parameters. */
int
gdev_vector_get_params(gx_device * dev, gs_param_list * plist)
{
    int code = gx_default_get_params(dev, plist);
    int ecode;
    gs_param_string ofns;

    if (code &lt; 0)
	return code;
    ofns.data = (const byte *)vdev-&gt;fname,
	ofns.size = strlen(vdev-&gt;fname),
	ofns.persistent = false;
    if ((ecode = param_write_string(plist, "OutputFile", &amp;ofns)) &lt; 0)
	return ecode;
    return code;
}

/* Put parameters. */
int
gdev_vector_put_params(gx_device * dev, gs_param_list * plist)
{
    int ecode = 0;
    int code;
    gs_param_name param_name;
    gs_param_string ofns;

    switch (code = param_read_string(plist, (param_name = "OutputFile"), &amp;ofns)) {
	case 0:
	    /*
	     * Vector devices typically write header information at the
	     * beginning of the file: changing the file name after writing
	     * any pages should be an error.
	     */
	    if (ofns.size &gt; fname_size)
		ecode = gs_error_limitcheck;
	    else if (!bytes_compare(ofns.data, ofns.size,
				    (const byte *)vdev-&gt;fname,
				    strlen(vdev-&gt;fname))
		     ) {
		/* The new name is the same as the old name.  Do nothing. */
		ofns.data = 0;
		break;
	    } else if (dev-&gt;LockSafetyParams ||
	    		(dev-&gt;is_open &amp;&amp; vdev-&gt;strm != 0 &amp;&amp;
		       stell(vdev-&gt;strm) != 0)
		       )
		ecode = (dev-&gt;LockSafetyParams) ? gs_error_invalidaccess : 
				gs_error_rangecheck;
	    else
		break;
	    goto ofe;
	default:
	    ecode = code;
	  ofe:param_signal_error(plist, param_name, ecode);
	case 1:
	    ofns.data = 0;
	    break;
    }

    if (ecode &lt; 0)
	return ecode;
    {
	bool open = dev-&gt;is_open;

	/* Don't let gx_default_put_params close the device. */
	dev-&gt;is_open = false;
	code = gx_default_put_params(dev, plist);
	dev-&gt;is_open = open;
    }
    if (code &lt; 0)
	return code;

    if (ofns.data != 0) {
	memcpy(vdev-&gt;fname, ofns.data, ofns.size);
	vdev-&gt;fname[ofns.size] = 0;
	if (vdev-&gt;file != 0) {
	    gx_device_bbox *bbdev = vdev-&gt;bbox_device;

	    vdev-&gt;bbox_device = 0; /* don't let it be freed */
	    code = gdev_vector_close_file(vdev);
	    vdev-&gt;bbox_device = bbdev;
	    if (code &lt; 0)
		return code;
	    return gdev_vector_open_file_options(vdev, vdev-&gt;strmbuf_size,
						 vdev-&gt;open_options);
	}
    }
    return 0;
}

/* ---------------- Defaults ---------------- */

int
gdev_vector_fill_rectangle(gx_device * dev, int x, int y, int w, int h,
			   gx_color_index color)
{
    gx_drawing_color dcolor;

    /* Ignore the initial fill with white. */
    if (!vdev-&gt;in_page &amp;&amp; color == vdev-&gt;white)
	return 0;
    /*
     * The original colorspace and client color are unknown so use
     * set_nonclient_dev_color instead of color_set_pure.
     */
    set_nonclient_dev_color(&amp;dcolor, color);
    {
	/* Make sure we aren't being clipped. */
	int code = gdev_vector_update_clip_path(vdev, NULL);

	if (code &lt; 0)
	    return code;
	if ((code = update_fill(vdev, NULL, &amp;dcolor, rop3_T)) &lt; 0)
	    return code;
    }
    if (vdev-&gt;bbox_device) {
	int code = (*dev_proc(vdev-&gt;bbox_device, fill_rectangle))
	((gx_device *) vdev-&gt;bbox_device, x, y, w, h, color);

	if (code &lt; 0)
	    return code;
    }
    return (*vdev_proc(vdev, dorect)) (vdev, int2fixed(x), int2fixed(y),
				       int2fixed(x + w), int2fixed(y + h),
				       gx_path_type_fill);
}

int
gdev_vector_fill_path(gx_device * dev, const gs_imager_state * pis,
		      gx_path * ppath, const gx_fill_params * params,
		 const gx_device_color * pdevc, const gx_clip_path * pcpath)
{
    int code;

    if ((code = gdev_vector_prepare_fill(vdev, pis, params, pdevc)) &lt; 0 ||
	(code = gdev_vector_update_clip_path(vdev, pcpath)) &lt; 0 ||
	(vdev-&gt;bbox_device &amp;&amp;
	 (code = (*dev_proc(vdev-&gt;bbox_device, fill_path))
	  ((gx_device *) vdev-&gt;bbox_device, pis, ppath, params,
	   pdevc, pcpath)) &lt; 0) ||
	(code = (*vdev_proc(vdev, dopath))
	 (vdev, ppath,
	  (params-&gt;rule &gt; 0 ? gx_path_type_even_odd :
	   gx_path_type_winding_number) | gx_path_type_fill |
	   vdev-&gt;fill_options,
	 NULL)) &lt; 0
	)
	return gx_default_fill_path(dev, pis, ppath, params, pdevc, pcpath);
    return code;
}

int
gdev_vector_stroke_path(gx_device * dev, const gs_imager_state * pis,
			gx_path * ppath, const gx_stroke_params * params,
	      const gx_drawing_color * pdcolor, const gx_clip_path * pcpath)
{
    int code;
    double scale;
    int set_ctm;
    gs_matrix mat;

    if ((set_ctm = gdev_vector_stroke_scaling(vdev, pis, &amp;scale, &amp;mat)) != 0 ||
	(code = gdev_vector_prepare_stroke(vdev, pis, params, pdcolor, scale)) &lt; 0 ||
	(code = gdev_vector_update_clip_path(vdev, pcpath)) &lt; 0 ||
	(vdev-&gt;bbox_device &amp;&amp;
	 (code = (*dev_proc(vdev-&gt;bbox_device, stroke_path))
	  ((gx_device *) vdev-&gt;bbox_device, pis, ppath, params,
	   pdcolor, pcpath)) &lt; 0) ||
	(code = (*vdev_proc(vdev, dopath))
	 (vdev, ppath, gx_path_type_stroke | vdev-&gt;stroke_options, NULL)) &lt; 0
	)
	return gx_default_stroke_path(dev, pis, ppath, params, pdcolor, pcpath);
    return code;
}

int
gdev_vector_fill_trapezoid(gx_device * dev, const gs_fixed_edge * left,
	const gs_fixed_edge * right, fixed ybot, fixed ytop, bool swap_axes,
		  const gx_device_color * pdevc, gs_logical_operation_t lop)
{
    fixed xl = left-&gt;start.x;
    fixed wl = left-&gt;end.x - xl;
    fixed yl = left-&gt;start.y;
    fixed hl = left-&gt;end.y - yl;
    fixed xr = right-&gt;start.x;
    fixed wr = right-&gt;end.x - xr;
    fixed yr = right-&gt;start.y;
    fixed hr = right-&gt;end.y - yr;
    fixed x0l = xl + fixed_mult_quo(wl, ybot - yl, hl);
    fixed x1l = xl + fixed_mult_quo(wl, ytop - yl, hl);
    fixed x0r = xr + fixed_mult_quo(wr, ybot - yr, hr);
    fixed x1r = xr + fixed_mult_quo(wr, ytop - yr, hr);

#define y0 ybot
#define y1 ytop
    int code = update_fill(vdev, NULL, pdevc, lop);
    gs_fixed_point points[4];

    if (code &lt; 0)
	return gx_default_fill_trapezoid(dev, left, right, ybot, ytop,
					 swap_axes, pdevc, lop);
    /* Make sure we aren't being clipped. */
    code = gdev_vector_update_clip_path(vdev, NULL);
    if (code &lt; 0)
	return code;
    if (swap_axes)
	points[0].y = x0l, points[1].y = x0r,
	    points[0].x = points[1].x = y0,
	    points[2].y = x1r, points[3].y = x1l,
	    points[2].x = points[3].x = y1;
    else
	points[0].x = x0l, points[1].x = x0r,
	    points[0].y = points[1].y = y0,
	    points[2].x = x1r, points[3].x = x1l,
	    points[2].y = points[3].y = y1;
#undef y0
#undef y1
    if (vdev-&gt;bbox_device) {
	int code = (*dev_proc(vdev-&gt;bbox_device, fill_trapezoid))
	((gx_device *) vdev-&gt;bbox_device, left, right, ybot, ytop,
	 swap_axes, pdevc, lop);

	if (code &lt; 0)
	    return code;
    }
    return gdev_vector_write_polygon(vdev, points, 4, true,
				     gx_path_type_fill);
}

int
gdev_vector_fill_parallelogram(gx_device * dev,
		 fixed px, fixed py, fixed ax, fixed ay, fixed bx, fixed by,
		  const gx_device_color * pdevc, gs_logical_operation_t lop)
{
    fixed pax = px + ax, pay = py + ay;
    int code = update_fill(vdev, NULL, pdevc, lop);
    gs_fixed_point points[4];

    if (code &lt; 0)
	return gx_default_fill_parallelogram(dev, px, py, ax, ay, bx, by,
					     pdevc, lop);
    /* Make sure we aren't being clipped. */
    code = gdev_vector_update_clip_path(vdev, NULL);
    if (code &lt; 0)
	return code;
    if (vdev-&gt;bbox_device) {
	code = (*dev_proc(vdev-&gt;bbox_device, fill_parallelogram))
	    ((gx_device *) vdev-&gt;bbox_device, px, py, ax, ay, bx, by,
	     pdevc, lop);
	if (code &lt; 0)
	    return code;
    }
    points[0].x = px, points[0].y = py;
    points[1].x = pax, points[1].y = pay;
    points[2].x = pax + bx, points[2].y = pay + by;
    points[3].x = px + bx, points[3].y = py + by;
    return gdev_vector_write_polygon(vdev, points, 4, true,
				     gx_path_type_fill);
}

int
gdev_vector_fill_triangle(gx_device * dev,
		 fixed px, fixed py, fixed ax, fixed ay, fixed bx, fixed by,
		  const gx_device_color * pdevc, gs_logical_operation_t lop)
{
    int code = update_fill(vdev, NULL, pdevc, lop);
    gs_fixed_point points[3];

    if (code &lt; 0)
	return gx_default_fill_triangle(dev, px, py, ax, ay, bx, by,
					pdevc, lop);
    /* Make sure we aren't being clipped. */
    code = gdev_vector_update_clip_path(vdev, NULL);
    if (code &lt; 0)
	return code;
    if (vdev-&gt;bbox_device) {
	code = (*dev_proc(vdev-&gt;bbox_device, fill_triangle))
	    ((gx_device *) vdev-&gt;bbox_device, px, py, ax, ay, bx, by,
	     pdevc, lop);
	if (code &lt; 0)
	    return code;
    }
    points[0].x = px, points[0].y = py;
    points[1].x = px + ax, points[1].y = py + ay;
    points[2].x = px + bx, points[2].y = py + by;
    return gdev_vector_write_polygon(vdev, points, 3, true,
				     gx_path_type_fill);
}

#undef vdev
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

