<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevxcmp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevxcmp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevxcmp.c,v 1.9 2004/08/04 19:36:12 stefan Exp $ */
/* X Windows color mapping */
#include "math_.h"
#include "x_.h"
#include "gx.h"			/* for gx_bitmap; includes std.h */
#include "gserrors.h"
#include "gxdevice.h"
#include "gdevx.h"

/* ---------------- Utilities ---------------- */

private void
gs_x_free(gs_memory_t *mem, void *obj, client_name_t cname)
{
    gs_free(mem, obj, 0 /*ignored*/, 0 /*ignored*/, cname);
}

/* ---------------- Color mapping setup / cleanup ---------------- */

#if HaveStdCMap

/* Install a standard color map in the device. */
/* Sets std_cmap.* except for free_map. */
private bool
set_cmap_values(x11_cmap_values_t *values, int maxv, int mult)
{
    int i;

    if (maxv &lt; 1 || maxv &gt; 63 || (maxv &amp; (maxv + 1)) ||
	(mult &amp; (mult - 1))
	)
	return false;
    values-&gt;cv_shift = 16 - small_exact_log2(maxv + 1);
    for (i = 0; i &lt;= maxv; ++i)
	values-&gt;nearest[i] = X_max_color_value * i / maxv;
    for (i = 0; mult != (1 &lt;&lt; i); ++i)
	DO_NOTHING;
    values-&gt;pixel_shift = i;
    return true;
}
private void
set_std_cmap(gx_device_X *xdev, XStandardColormap *map)
{
    xdev-&gt;cman.std_cmap.map = map;
    xdev-&gt;cman.std_cmap.fast =
	set_cmap_values(&amp;xdev-&gt;cman.std_cmap.red, map-&gt;red_max, map-&gt;red_mult) &amp;&amp;
	set_cmap_values(&amp;xdev-&gt;cman.std_cmap.green, map-&gt;green_max, map-&gt;green_mult) &amp;&amp;
	set_cmap_values(&amp;xdev-&gt;cman.std_cmap.blue, map-&gt;blue_max, map-&gt;blue_mult);
}

/* Get the Standard colormap if available. */
/* Uses: dpy, scr, cmap. */
private XStandardColormap *
x_get_std_cmap(gx_device_X * xdev, Atom prop)
{
    int i;
    XStandardColormap *scmap, *sp;
    int nitems;

    if (XGetRGBColormaps(xdev-&gt;dpy, RootWindowOfScreen(xdev-&gt;scr),
			 &amp;scmap, &amp;nitems, prop))
	for (i = 0, sp = scmap; i &lt; nitems; i++, sp++)
	    if (xdev-&gt;cmap == sp-&gt;colormap)
		return sp;

    return NULL;
}

/* Create a Standard colormap for a TrueColor or StaticGray display. */
/* Return true if the allocation was successful. */
/* Uses: vinfo.  Sets: std_cmap.*. */
private bool
alloc_std_cmap(gx_device_X *xdev, bool colored)
{
    XStandardColormap *cmap = XAllocStandardColormap();

    if (cmap == 0)
	return false;		/* can't allocate */
    /*
     * Some buggy X servers (including XFree86) don't set any of the
     * _mask values for StaticGray visuals.  Compensate for that here.
     */
    if ((cmap-&gt;red_max = xdev-&gt;vinfo-&gt;red_mask) == 0) {
	cmap-&gt;red_max = (1 &lt;&lt; xdev-&gt;vinfo-&gt;depth) - 1;
	cmap-&gt;red_mult = 1;
    } else {
	for (cmap-&gt;red_mult = 1; (cmap-&gt;red_max &amp; 1) == 0;) {
	    cmap-&gt;red_max &gt;&gt;= 1;
	    cmap-&gt;red_mult &lt;&lt;= 1;
	}
    }
    if (colored) {
	for (cmap-&gt;green_max = xdev-&gt;vinfo-&gt;green_mask, cmap-&gt;green_mult = 1;
	     (cmap-&gt;green_max &amp; 1) == 0;
	     ) {
	    cmap-&gt;green_max &gt;&gt;= 1;
	    cmap-&gt;green_mult &lt;&lt;= 1;
	}
	for (cmap-&gt;blue_max = xdev-&gt;vinfo-&gt;blue_mask, cmap-&gt;blue_mult = 1;
	     (cmap-&gt;blue_max &amp; 1) == 0;
	     ) {
	    cmap-&gt;blue_max &gt;&gt;= 1;
	    cmap-&gt;blue_mult &lt;&lt;= 1;
	}
    } else {
        cmap-&gt;green_max = cmap-&gt;blue_max = cmap-&gt;red_max;
        cmap-&gt;green_mult = cmap-&gt;blue_mult = cmap-&gt;red_mult;
    }
    set_std_cmap(xdev, cmap);
    xdev-&gt;cman.std_cmap.free_map = true;
    return true;
}

#endif

/* Allocate the dynamic color table, if needed and possible. */
/* Uses: vinfo, cman.num_rgb.  Sets: cman.dynamic.*. */
private void
alloc_dynamic_colors(gx_device_X * xdev, int num_colors)
{
    if (num_colors &gt; 0) {
	xdev-&gt;cman.dynamic.colors = (x11_color_t **)
	    gs_malloc(xdev-&gt;memory, sizeof(x11_color_t *), xdev-&gt;cman.num_rgb,
		      "x11 cman.dynamic.colors");
	if (xdev-&gt;cman.dynamic.colors) {
	    int i;

	    xdev-&gt;cman.dynamic.size = xdev-&gt;cman.num_rgb;
	    xdev-&gt;cman.dynamic.shift = 16 - xdev-&gt;vinfo-&gt;bits_per_rgb;
	    for (i = 0; i &lt; xdev-&gt;cman.num_rgb; i++)
		xdev-&gt;cman.dynamic.colors[i] = NULL;
	    xdev-&gt;cman.dynamic.max_used = min(256, num_colors);
	    xdev-&gt;cman.dynamic.used = 0;
	}
    }
}

/* Allocate an X color, updating the reverse map. */
/* Return true if the allocation was successful. */
private bool
x_alloc_color(gx_device_X *xdev, XColor *xcolor)
{
    x11_rgb_t rgb;

    rgb.rgb[0] = xcolor-&gt;red;
    rgb.rgb[1] = xcolor-&gt;green;
    rgb.rgb[2] = xcolor-&gt;blue;
    if (!XAllocColor(xdev-&gt;dpy, xdev-&gt;cmap, xcolor))
	return false;
    if (xcolor-&gt;pixel &lt; xdev-&gt;cman.color_to_rgb.size) {
	x11_rgb_t *pxrgb = &amp;xdev-&gt;cman.color_to_rgb.values[xcolor-&gt;pixel];

	memcpy(pxrgb-&gt;rgb, rgb.rgb, sizeof(rgb.rgb));
	pxrgb-&gt;defined = true;
    }
    return true;
}

/* Free X colors, updating the reverse map. */
private void
x_free_colors(gx_device_X *xdev, x_pixel *pixels /*[count]*/, int count)
{
    int i;
    x_pixel pixel;

    XFreeColors(xdev-&gt;dpy, xdev-&gt;cmap, pixels, count, 0);
    for (i = 0; i &lt; count; ++i)
	if ((pixel = pixels[i]) &lt; xdev-&gt;cman.color_to_rgb.size)
	    xdev-&gt;cman.color_to_rgb.values[pixel].defined = false;
}

/* Free a partially filled color cube or ramp. */
/* Uses: dpy, cmap.  Uses and sets: cman.dither_ramp. */
private void
free_ramp(gx_device_X * xdev, int num_used, int size)
{
    if (num_used - 1 &gt; 0)
	x_free_colors(xdev, xdev-&gt;cman.dither_ramp + 1, num_used - 1);
    gs_x_free(xdev-&gt;memory, xdev-&gt;cman.dither_ramp, "x11_setup_colors");
    xdev-&gt;cman.dither_ramp = NULL;
}

/* Allocate and fill in a color cube or ramp. */
/* Return true if the operation succeeded. */
/* Uses: dpy, cmap, foreground, background, cman.color_mask. */
/* Sets: cman.dither_ramp. */
private bool
setup_cube(gx_device_X * xdev, int ramp_size, bool colors)
{
    int step, num_entries;
    int max_rgb = ramp_size - 1;
    int index;

    if (colors) {
	num_entries = ramp_size * ramp_size * ramp_size;
	step = 1;		/* all colors */
    } else {
	num_entries = ramp_size;
	step = (ramp_size + 1) * ramp_size + 1;		/* gray only */
    }

    xdev-&gt;cman.dither_ramp =
	(x_pixel *) gs_malloc(xdev-&gt;memory, sizeof(x_pixel), num_entries,
			      "gdevx setup_cube");
    if (xdev-&gt;cman.dither_ramp == NULL)
	return false;

    xdev-&gt;cman.dither_ramp[0] = xdev-&gt;foreground;
    xdev-&gt;cman.dither_ramp[num_entries - 1] = xdev-&gt;background;
    for (index = 1; index &lt; num_entries - 1; index++) {
	int rgb_index = index * step;
	int q = rgb_index / ramp_size,
	    r = q / ramp_size,
	    g = q % ramp_size,
	    b = rgb_index % ramp_size;
	XColor xc;

	xc.red = (X_max_color_value * r / max_rgb) &amp; xdev-&gt;cman.color_mask.red;
	xc.green = (X_max_color_value * g / max_rgb) &amp; xdev-&gt;cman.color_mask.green;
	xc.blue = (X_max_color_value * b / max_rgb) &amp; xdev-&gt;cman.color_mask.blue;
	if (!x_alloc_color(xdev, &amp;xc)) {
	    free_ramp(xdev, index, num_entries);
	    return false;
	}
	xdev-&gt;cman.dither_ramp[index] = xc.pixel;
    }

    return true;
}

/* Setup color mapping. */
int
gdev_x_setup_colors(gx_device_X * xdev)
{
    char palette =
	((xdev-&gt;vinfo-&gt;class != StaticGray) &amp;&amp;
	 (xdev-&gt;vinfo-&gt;class != GrayScale) ? 'C' :	/* Color */
	 (xdev-&gt;vinfo-&gt;colormap_size &gt; 2) ? 'G' :		/* GrayScale */
	 'M');		/* MonoChrome */

    if (xdev-&gt;ghostview) {
	Atom gv_colors = XInternAtom(xdev-&gt;dpy, "GHOSTVIEW_COLORS", False);
	Atom type;
	int format;
	unsigned long nitems, bytes_after;
	char *buf;

	/* Delete property if explicit dest is given */
	if (XGetWindowProperty(xdev-&gt;dpy, xdev-&gt;win, gv_colors, 0,
			       256, (xdev-&gt;dest != 0), XA_STRING,
			       &amp;type, &amp;format, &amp;nitems, &amp;bytes_after,
			       (unsigned char **)&amp;buf) == 0 &amp;&amp;
	    type == XA_STRING) {
	    nitems = sscanf(buf, "%*s %ld %ld", &amp;(xdev-&gt;foreground),
			    &amp;(xdev-&gt;background));
	    if (nitems != 2 || (*buf != 'M' &amp;&amp; *buf != 'G' &amp;&amp; *buf != 'C')) {
		eprintf("Malformed GHOSTVIEW_COLOR property.\n");
		return_error(gs_error_rangecheck);
	    }
	    palette = max(palette, *buf);
	}
    } else {
	if (xdev-&gt;palette[0] == 'c')
	    xdev-&gt;palette[0] = 'C';
	else if (xdev-&gt;palette[0] == 'g')
	    xdev-&gt;palette[0] = 'G';
	else if (xdev-&gt;palette[0] == 'm')
	    xdev-&gt;palette[0] = 'M';
	palette = max(palette, xdev-&gt;palette[0]);
    }

    /* set up color mappings here */
    xdev-&gt;cman.color_mask.red = xdev-&gt;cman.color_mask.green =
	xdev-&gt;cman.color_mask.blue = X_max_color_value -
	  (X_max_color_value &gt;&gt; xdev-&gt;vinfo-&gt;bits_per_rgb);
    xdev-&gt;cman.match_mask = xdev-&gt;cman.color_mask; /* default */
    xdev-&gt;cman.num_rgb = 1 &lt;&lt; xdev-&gt;vinfo-&gt;bits_per_rgb;

#if HaveStdCMap
    xdev-&gt;cman.std_cmap.map = NULL;
    xdev-&gt;cman.std_cmap.free_map = false;
#endif
    xdev-&gt;cman.dither_ramp = NULL;
    xdev-&gt;cman.dynamic.colors = NULL;
    xdev-&gt;cman.dynamic.size = 0;
    xdev-&gt;cman.dynamic.used = 0;
    switch (xdev-&gt;vinfo-&gt;depth) {
    case 1: case 2: case 4: case 8: case 16: case 24: case 32:
	xdev-&gt;color_info.depth = xdev-&gt;vinfo-&gt;depth;
	break;
    case 15:
	xdev-&gt;color_info.depth = 16;
	break;
    default:
	eprintf1("Unsupported X visual depth: %d\n", xdev-&gt;vinfo-&gt;depth);
	return_error(gs_error_rangecheck);
    }
    {	/* Set up the reverse map from pixel values to RGB. */
	int count = 1 &lt;&lt; min(xdev-&gt;color_info.depth, 8);

	xdev-&gt;cman.color_to_rgb.values =
	    (x11_rgb_t *)gs_malloc(xdev-&gt;memory, sizeof(x11_rgb_t), count,
				   "gdevx color_to_rgb");
	if (xdev-&gt;cman.color_to_rgb.values) {
	    int i;

	    for (i = 0; i &lt; count; ++i)
		xdev-&gt;cman.color_to_rgb.values[i].defined = false;
	    xdev-&gt;cman.color_to_rgb.size = count;
	} else
	    xdev-&gt;cman.color_to_rgb.size = 0;
    }
    switch ((int)palette) {
    case 'C':
	xdev-&gt;color_info.num_components = 3;
	xdev-&gt;color_info.max_gray =
	    xdev-&gt;color_info.max_color = xdev-&gt;cman.num_rgb - 1;
#if HaveStdCMap
	/* Get a standard color map if available */
	if (xdev-&gt;vinfo-&gt;visual == DefaultVisualOfScreen(xdev-&gt;scr)) {
	    xdev-&gt;cman.std_cmap.map = x_get_std_cmap(xdev, XA_RGB_DEFAULT_MAP);
	} else {
	    xdev-&gt;cman.std_cmap.map = x_get_std_cmap(xdev, XA_RGB_BEST_MAP);
	}
	if (xdev-&gt;cman.std_cmap.map ||
	    (xdev-&gt;vinfo-&gt;class == TrueColor &amp;&amp; alloc_std_cmap(xdev, true))
	    ) {
	    xdev-&gt;color_info.dither_grays = xdev-&gt;color_info.dither_colors =
		min(xdev-&gt;cman.std_cmap.map-&gt;red_max,
		    min(xdev-&gt;cman.std_cmap.map-&gt;green_max,
			xdev-&gt;cman.std_cmap.map-&gt;blue_max)) + 1;
	    if (xdev-&gt;cman.std_cmap.map)
		set_std_cmap(xdev, xdev-&gt;cman.std_cmap.map);
	} else
#endif
	    /* Otherwise set up a rgb cube of our own */
	    /* The color cube is limited to about 1/2 of the available */
	    /* colormap, the user specified maxRGBRamp (usually 5), */
	    /* or the number of representable colors */
#define CUBE(r) (r*r*r)
#define CBRT(r) pow(r, 1.0/3.0)
	{
	    int ramp_size =
		min((int)CBRT(xdev-&gt;vinfo-&gt;colormap_size / 2.0),
		    min(xdev-&gt;maxRGBRamp, xdev-&gt;cman.num_rgb));

	    while (!xdev-&gt;cman.dither_ramp &amp;&amp; ramp_size &gt;= 2) {
		xdev-&gt;color_info.dither_grays =
		    xdev-&gt;color_info.dither_colors = ramp_size;
		if (!setup_cube(xdev, ramp_size, true)) {
#ifdef DEBUG
		    eprintf3("Warning: failed to allocate %dx%dx%d RGB cube.\n",
			     ramp_size, ramp_size, ramp_size);
#endif
		    ramp_size--;
		    continue;
		}
	    }

	    if (!xdev-&gt;cman.dither_ramp) {
		goto grayscale;
	    }
	}

	/* Allocate the dynamic color table. */
	alloc_dynamic_colors(xdev, CUBE(xdev-&gt;cman.num_rgb) -
			     CUBE(xdev-&gt;color_info.dither_colors));
#undef CUBE
#undef CBRT
	break;
    case 'G':
grayscale:
	xdev-&gt;color_info.num_components = 1;
	xdev-&gt;color_info.max_gray = xdev-&gt;cman.num_rgb - 1;
#if HaveStdCMap
	/* Get a standard color map if available */
	xdev-&gt;cman.std_cmap.map = x_get_std_cmap(xdev, XA_RGB_GRAY_MAP);
	if (xdev-&gt;cman.std_cmap.map ||
	    (xdev-&gt;vinfo-&gt;class == StaticGray &amp;&amp; alloc_std_cmap(xdev, false))
	    ) {
	    xdev-&gt;color_info.dither_grays =
		xdev-&gt;cman.std_cmap.map-&gt;red_max + 1;
	    if (xdev-&gt;cman.std_cmap.map)
		set_std_cmap(xdev, xdev-&gt;cman.std_cmap.map);
	} else
#endif
	    /* Otherwise set up a gray ramp of our own */
	    /* The gray ramp is limited to about 1/2 of the available */
	    /* colormap, the user specified maxGrayRamp (usually 128), */
	    /* or the number of representable grays */
	{
	    int ramp_size = min(xdev-&gt;vinfo-&gt;colormap_size / 2,
				min(xdev-&gt;maxGrayRamp, xdev-&gt;cman.num_rgb));

	    while (!xdev-&gt;cman.dither_ramp &amp;&amp; ramp_size &gt;= 3) {
		xdev-&gt;color_info.dither_grays = ramp_size;
		if (!setup_cube(xdev, ramp_size, false)) {
#ifdef DEBUG
		    eprintf1("Warning: failed to allocate %d level gray ramp.\n",
			     ramp_size);
#endif
		    ramp_size /= 2;
		    continue;
		}
	    }
	    if (!xdev-&gt;cman.dither_ramp) {
		goto monochrome;
	    }
	}

	/* Allocate the dynamic color table. */
	alloc_dynamic_colors(xdev, xdev-&gt;cman.num_rgb -
			     xdev-&gt;color_info.dither_grays);
	break;
    case 'M':
monochrome:
	xdev-&gt;color_info.num_components = 1;
	xdev-&gt;color_info.max_gray = 1;
	xdev-&gt;color_info.dither_grays = 2;
	break;
    default:
	eprintf1("Unknown palette: %s\n", xdev-&gt;palette);
	if (xdev-&gt;cman.color_to_rgb.values) {
	    gs_x_free(xdev-&gt;memory, xdev-&gt;cman.color_to_rgb.values, "gdevx color_to_rgb");
	    xdev-&gt;cman.color_to_rgb.values = 0;
	}
	return_error(gs_error_rangecheck);
    }

#if HaveStdCMap
    /*
     * When comparing colors, if not halftoning, we must only compare as
     * many bits as actually fit in a pixel, even if the hardware has more.
     */
    if (!gx_device_must_halftone(xdev)) {
	if (xdev-&gt;cman.std_cmap.map) {
	    xdev-&gt;cman.match_mask.red &amp;=
		X_max_color_value &lt;&lt; xdev-&gt;cman.std_cmap.red.cv_shift;
	    xdev-&gt;cman.match_mask.green &amp;=
		X_max_color_value &lt;&lt; xdev-&gt;cman.std_cmap.green.cv_shift;
	    xdev-&gt;cman.match_mask.blue &amp;=
		X_max_color_value &lt;&lt; xdev-&gt;cman.std_cmap.blue.cv_shift;
	}
    }
#endif

    return 0;
}

/* Free the dynamic colors when doing an erasepage. */
/* Uses: cman.dynamic.*.  Sets: cman.dynamic.used. */
void
gdev_x_free_dynamic_colors(gx_device_X *xdev)
{
    if (xdev-&gt;cman.dynamic.colors) {
	int i;
	x11_color_t *xcp;
	x11_color_t *next;

	for (i = 0; i &lt; xdev-&gt;cman.dynamic.size; i++) {
	    for (xcp = xdev-&gt;cman.dynamic.colors[i]; xcp; xcp = next) {
		next = xcp-&gt;next;
		if (xcp-&gt;color.pad)
		    x_free_colors(xdev, &amp;xcp-&gt;color.pixel, 1);
		gs_x_free(xdev-&gt;memory, xcp, "x11_dynamic_color");
	    }
	    xdev-&gt;cman.dynamic.colors[i] = NULL;
	}
	xdev-&gt;cman.dynamic.used = 0;
    }
}

/*
 * Free storage and color map entries when closing the device.
 * Uses and sets: cman.{std_cmap.map, dither_ramp, dynamic.colors,
 * color_to_rgb}.  Uses: cman.std_cmap.free_map.
 */
void
gdev_x_free_colors(gx_device_X *xdev)
{
    if (xdev-&gt;cman.std_cmap.free_map) {
	/* XFree is declared as taking a char *, not a void *! */
	XFree((void *)xdev-&gt;cman.std_cmap.map);
	xdev-&gt;cman.std_cmap.free_map = false;
    }
    xdev-&gt;cman.std_cmap.map = 0;
    if (xdev-&gt;cman.dither_ramp)
	gs_x_free(xdev-&gt;memory, xdev-&gt;cman.dither_ramp, "x11 dither_colors");
    if (xdev-&gt;cman.dynamic.colors) {
	gdev_x_free_dynamic_colors(xdev);
	gs_x_free(xdev-&gt;memory, xdev-&gt;cman.dynamic.colors, "x11 cman.dynamic.colors");
	xdev-&gt;cman.dynamic.colors = NULL;
    }
    if (xdev-&gt;cman.color_to_rgb.values) {
	gs_x_free(xdev-&gt;memory, xdev-&gt;cman.color_to_rgb.values, "x11 color_to_rgb");
	xdev-&gt;cman.color_to_rgb.values = NULL;
	xdev-&gt;cman.color_to_rgb.size = 0;
    }
}

/* ---------------- Driver color mapping calls ---------------- */

/* Define a table for computing N * X_max_color_value / D for 0 &lt;= N &lt;= D, */
/* 1 &lt;= D &lt;= 7. */
/* This requires a multiply and a divide otherwise; */
/* integer multiply and divide are slow on all platforms. */
#define CV_FRACTION(n, d) ((X_color_value)(X_max_color_value * (n) / (d)))
#define ND(n, d) CV_FRACTION(n, d)
private const X_color_value cv_tab1[] = {
    ND(0,1), ND(1,1)
};
private const X_color_value cv_tab2[] = {
    ND(0,2), ND(1,2), ND(2,2)
};
private const X_color_value cv_tab3[] = {
    ND(0,3), ND(1,3), ND(2,3), ND(3,3)
};
private const X_color_value cv_tab4[] = {
    ND(0,4), ND(1,4), ND(2,4), ND(3,4), ND(4,4)
};
private const X_color_value cv_tab5[] = {
    ND(0,5), ND(1,5), ND(2,5), ND(3,5), ND(4,5), ND(5,5)
};
private const X_color_value cv_tab6[] = {
    ND(0,6), ND(1,6), ND(2,6), ND(3,6), ND(4,6), ND(5,6), ND(6,6)
};
private const X_color_value cv_tab7[] = {
    ND(0,7), ND(1,7), ND(2,7), ND(3,7), ND(4,7), ND(5,7), ND(6,7), ND(7,7)
};
#undef ND
private const X_color_value *const cv_tables[] =
{
    0, cv_tab1, cv_tab2, cv_tab3, cv_tab4, cv_tab5, cv_tab6, cv_tab7
};

/* Some C compilers don't declare the abs function in math.h. */
/* Provide one of our own. */
private inline int
iabs(int x)
{
    return (x &lt; 0 ? -x : x);
}

/* Map RGB values to a pixel value. */
gx_color_index
gdev_x_map_rgb_color(gx_device * dev, const gx_color_value cv[])
{
    gx_device_X *const xdev = (gx_device_X *) dev;
    gx_color_value r = cv[0];
    gx_color_value g = cv[1];
    gx_color_value b = cv[2];

    /* X and ghostscript both use shorts for color values. */
    /* Set drgb to the nearest color that the device can represent. */
    X_color_value dr = r &amp; xdev-&gt;cman.color_mask.red;
    X_color_value dg = g &amp; xdev-&gt;cman.color_mask.green;
    X_color_value db = b &amp; xdev-&gt;cman.color_mask.blue;

    {
	/* Foreground and background get special treatment: */
	/* They may be mapped to other colors. */
	/* Set mrgb to the color to be used for match testing. */
	X_color_value mr = r &amp; xdev-&gt;cman.match_mask.red;
	X_color_value mg = g &amp; xdev-&gt;cman.match_mask.green;
	X_color_value mb = b &amp; xdev-&gt;cman.match_mask.blue;

	if ((mr | mg | mb) == 0) {	/* i.e., all 0 */
	    if_debug4('C', "[cX]%u,%u,%u =&gt; foreground = %lu\n",
		      r, g, b, (ulong) xdev-&gt;foreground);
	    return xdev-&gt;foreground;
	}
	if (mr == xdev-&gt;cman.match_mask.red &amp;&amp;
	    mg == xdev-&gt;cman.match_mask.green &amp;&amp;
	    mb == xdev-&gt;cman.match_mask.blue
	    ) {
	    if_debug4('C', "[cX]%u,%u,%u =&gt; background = %lu\n",
		      r, g, b, (ulong) xdev-&gt;background);
	    return xdev-&gt;background;
	}
    }

#define CV_DENOM (gx_max_color_value + 1)

#if HaveStdCMap
    /* check the standard colormap first */
    if (xdev-&gt;cman.std_cmap.map) {
	const XStandardColormap *cmap = xdev-&gt;cman.std_cmap.map;

	if (gx_device_has_color(xdev)) {
	    uint cr, cg, cb;	/* rgb cube indices */
	    X_color_value cvr, cvg, cvb;	/* color value on cube */

	    if (xdev-&gt;cman.std_cmap.fast) {
		cr = r &gt;&gt; xdev-&gt;cman.std_cmap.red.cv_shift;
		cvr = xdev-&gt;cman.std_cmap.red.nearest[cr];
		cg = g &gt;&gt; xdev-&gt;cman.std_cmap.green.cv_shift;
		cvg = xdev-&gt;cman.std_cmap.green.nearest[cg];
		cb = b &gt;&gt; xdev-&gt;cman.std_cmap.blue.cv_shift;
		cvb = xdev-&gt;cman.std_cmap.blue.nearest[cb];
	    } else {
		cr = r * (cmap-&gt;red_max + 1) / CV_DENOM;
		cg = g * (cmap-&gt;green_max + 1) / CV_DENOM;
		cb = b * (cmap-&gt;blue_max + 1) / CV_DENOM;
		cvr = X_max_color_value * cr / cmap-&gt;red_max;
		cvg = X_max_color_value * cg / cmap-&gt;green_max;
		cvb = X_max_color_value * cb / cmap-&gt;blue_max;
	    }
	    if ((iabs((int)r - (int)cvr) &amp; xdev-&gt;cman.match_mask.red) == 0 &amp;&amp;
		(iabs((int)g - (int)cvg) &amp; xdev-&gt;cman.match_mask.green) == 0 &amp;&amp;
		(iabs((int)b - (int)cvb) &amp; xdev-&gt;cman.match_mask.blue) == 0) {
		gx_color_index pixel =
		    (xdev-&gt;cman.std_cmap.fast ?
		     (cr &lt;&lt; xdev-&gt;cman.std_cmap.red.pixel_shift) +
		     (cg &lt;&lt; xdev-&gt;cman.std_cmap.green.pixel_shift) +
		     (cb &lt;&lt; xdev-&gt;cman.std_cmap.blue.pixel_shift) :
		     cr * cmap-&gt;red_mult + cg * cmap-&gt;green_mult +
		     cb * cmap-&gt;blue_mult) + cmap-&gt;base_pixel;

		if_debug4('C', "[cX]%u,%u,%u (std cmap) =&gt; %lu\n",
			  r, g, b, pixel);
		return pixel;
	    }
	    if_debug3('C', "[cX]%u,%u,%u (std cmap fails)\n", r, g, b);
	} else {
	    uint cr;
	    X_color_value cvr;

	    cr = r * (cmap-&gt;red_max + 1) / CV_DENOM;
	    cvr = X_max_color_value * cr / cmap-&gt;red_max;
	    if ((iabs((int)r - (int)cvr) &amp; xdev-&gt;cman.match_mask.red) == 0) {
		gx_color_index pixel = cr * cmap-&gt;red_mult + cmap-&gt;base_pixel;

		if_debug2('C', "[cX]%u (std cmap) =&gt; %lu\n", r, pixel);
		return pixel;
	    }
	    if_debug1('C', "[cX]%u (std cmap fails)\n", r);
	}
    } else
#endif

	/* If there is no standard colormap, check the dither cube/ramp */
    if (xdev-&gt;cman.dither_ramp) {
	if (gx_device_has_color(xdev)) {
	    uint cr, cg, cb;	/* rgb cube indices */
	    X_color_value cvr, cvg, cvb;	/* color value on cube */
	    int dither_rgb = xdev-&gt;color_info.dither_colors;
	    uint max_rgb = dither_rgb - 1;

	    cr = r * dither_rgb / CV_DENOM;
	    cg = g * dither_rgb / CV_DENOM;
	    cb = b * dither_rgb / CV_DENOM;
	    if (max_rgb &lt; countof(cv_tables)) {
		const ushort *cv_tab = cv_tables[max_rgb];

		cvr = cv_tab[cr];
		cvg = cv_tab[cg];
		cvb = cv_tab[cb];
	    } else {
		cvr = CV_FRACTION(cr, max_rgb);
		cvg = CV_FRACTION(cg, max_rgb);
		cvb = CV_FRACTION(cb, max_rgb);
	    }
	    if ((iabs((int)r - (int)cvr) &amp; xdev-&gt;cman.match_mask.red) == 0 &amp;&amp;
		(iabs((int)g - (int)cvg) &amp; xdev-&gt;cman.match_mask.green) == 0 &amp;&amp;
		(iabs((int)b - (int)cvb) &amp; xdev-&gt;cman.match_mask.blue) == 0) {
		gx_color_index pixel =
		    xdev-&gt;cman.dither_ramp[CUBE_INDEX(cr, cg, cb)];

		if_debug4('C', "[cX]%u,%u,%u (dither cube) =&gt; %lu\n",
			  r, g, b, pixel);
		return pixel;
	    }
	    if_debug3('C', "[cX]%u,%u,%u (dither cube fails)\n", r, g, b);
	} else {
	    uint cr;
	    X_color_value cvr;
	    int dither_grays = xdev-&gt;color_info.dither_grays;
	    uint max_gray = dither_grays - 1;

	    cr = r * dither_grays / CV_DENOM;
	    cvr = (X_max_color_value * cr / max_gray);
	    if ((iabs((int)r - (int)cvr) &amp; xdev-&gt;cman.match_mask.red) == 0) {
		gx_color_index pixel = xdev-&gt;cman.dither_ramp[cr];

		if_debug2('C', "[cX]%u (dither ramp) =&gt; %lu\n", r, pixel);
		return pixel;
	    }
	    if_debug1('C', "[cX]%u (dither ramp fails)\n", r);
	}
    }

    /* Finally look through the list of dynamic colors */
    if (xdev-&gt;cman.dynamic.colors) {
	int i = (dr ^ dg ^ db) &gt;&gt; xdev-&gt;cman.dynamic.shift;
	x11_color_t *xcp = xdev-&gt;cman.dynamic.colors[i];
	x11_color_t *prev = NULL;
	XColor xc;

	for (; xcp; prev = xcp, xcp = xcp-&gt;next)
	    if (xcp-&gt;color.red == dr &amp;&amp; xcp-&gt;color.green == dg &amp;&amp;
		xcp-&gt;color.blue == db) {
		/* Promote the found entry to the front of the list. */
		if (prev) {
		    prev-&gt;next = xcp-&gt;next;
		    xcp-&gt;next = xdev-&gt;cman.dynamic.colors[i];
		    xdev-&gt;cman.dynamic.colors[i] = xcp;
		}
		if (xcp-&gt;color.pad) {
		    if_debug4('C', "[cX]%u,%u,%u (dynamic) =&gt; %lu\n",
			      r, g, b, (ulong) xcp-&gt;color.pixel);
		    return xcp-&gt;color.pixel;
		} else {
		    if_debug3('C', "[cX]%u,%u,%u (dynamic) =&gt; missing\n",
			      r, g, b);
		    return gx_no_color_index;
		}
	    }

	/* If not in our list of dynamic colors, */
	/* ask the X server and add an entry. */
	/* First check if dynamic table is exhausted */
	if (xdev-&gt;cman.dynamic.used &gt; xdev-&gt;cman.dynamic.max_used) {
	    if_debug3('C', "[cX]%u,%u,%u (dynamic) =&gt; full\n", r, g, b);
	    return gx_no_color_index;
	}
	xcp = (x11_color_t *)
	    gs_malloc(xdev-&gt;memory, sizeof(x11_color_t), 1, "x11_dynamic_color");
	if (!xcp)
	    return gx_no_color_index;
	xc.red = xcp-&gt;color.red = dr;
	xc.green = xcp-&gt;color.green = dg;
	xc.blue = xcp-&gt;color.blue = db;
	xcp-&gt;next = xdev-&gt;cman.dynamic.colors[i];
	xdev-&gt;cman.dynamic.colors[i] = xcp;
	xdev-&gt;cman.dynamic.used++;
	if (x_alloc_color(xdev, &amp;xc)) {
	    xcp-&gt;color.pixel = xc.pixel;
	    xcp-&gt;color.pad = true;
	    if_debug5('c', "[cX]0x%x,0x%x,0x%x (dynamic) =&gt; added [%d]%lu\n",
		      dr, dg, db, xdev-&gt;cman.dynamic.used - 1,
		      (ulong)xc.pixel);
	    return xc.pixel;
	} else {
	    xcp-&gt;color.pad = false;
	    if_debug3('c', "[cX]0x%x,0x%x,0x%x (dynamic) =&gt; can't alloc\n",
		      dr, dg, db);
	    return gx_no_color_index;
	}
    }
    if_debug3('C', "[cX]%u,%u,%u fails\n", r, g, b);
    return gx_no_color_index;
#undef CV_DENOM
}


/* Map a pixel value back to r-g-b. */
int
gdev_x_map_color_rgb(gx_device * dev, gx_color_index color,
		     gx_color_value prgb[3])
{
    const gx_device_X *const xdev = (const gx_device_X *) dev;
#if HaveStdCMap
    const XStandardColormap *cmap = xdev-&gt;cman.std_cmap.map;
#endif

    if (color == xdev-&gt;foreground) {
	prgb[0] = prgb[1] = prgb[2] = 0;
	return 0;
    }
    if (color == xdev-&gt;background) {
	prgb[0] = prgb[1] = prgb[2] = gx_max_color_value;
	return 0;
    }
    if (color &lt; xdev-&gt;cman.color_to_rgb.size) {
	const x11_rgb_t *pxrgb = &amp;xdev-&gt;cman.color_to_rgb.values[color];

	if (pxrgb-&gt;defined) {
	    prgb[0] = pxrgb-&gt;rgb[0];
	    prgb[1] = pxrgb-&gt;rgb[1];
	    prgb[2] = pxrgb-&gt;rgb[2];
	    return 0;
	}
#if HaveStdCMap
    }

    /* Check the standard colormap. */
    if (cmap) {
	if (color &gt;= cmap-&gt;base_pixel) {
	    x_pixel value = color - cmap-&gt;base_pixel;
	    uint r = (value / cmap-&gt;red_mult) % (cmap-&gt;red_max + 1);
	    uint g = (value / cmap-&gt;green_mult) % (cmap-&gt;green_max + 1);
	    uint b = (value / cmap-&gt;blue_mult) % (cmap-&gt;blue_max + 1);

	    if (value == r * cmap-&gt;red_mult + g * cmap-&gt;green_mult +
		b * cmap-&gt;blue_mult) {
		/* When mapping color buckets back to specific colors,
		 * we can choose to map them to the darkest shades
		 * (e.g., 0, 1/3, 2/3), to the lightest shades (e.g.,
		 * 1/3-epsilon, 2/3-epsilon, 1-epsilon), to the middle
		 * shades (e.g., 1/6, 1/2, 5/6), or for maximum range
		 * (e.g., 0, 1/2, 1).  The last of these matches the
		 * assumptions of the halftoning code, so that is what
		 * we choose.
		 */
		prgb[0] = r * gx_max_color_value / cmap-&gt;red_max;
		prgb[1] = g * gx_max_color_value / cmap-&gt;green_max;
		prgb[2] = b * gx_max_color_value / cmap-&gt;blue_max;
		return 0;
	    }
	}
    }
    if (color &lt; xdev-&gt;cman.color_to_rgb.size) {
#endif
	/* Error -- undefined pixel value. */
	return_error(gs_error_unknownerror);
    }
    /*
     * Check the dither cube/ramp.  This is hardly ever used, since if
     * there are few enough colors to require dithering, the pixel values
     * are likely to be small enough to index color_to_rgb.
     */
    if (xdev-&gt;cman.dither_ramp) {
	if (gx_device_has_color(xdev)) {
	    int size = xdev-&gt;color_info.dither_colors;
	    int size3 = size * size * size;
	    int i;

	    for (i = 0; i &lt; size3; ++i)
		if (xdev-&gt;cman.dither_ramp[i] == color) {
		    uint max_rgb = size - 1;
		    uint q = i / size,
			r = q / size,
			g = q % size,
			b = i % size;

		    /*
		     * See above regarding the choice of color mapping
		     * algorithm.
		     */
		    prgb[0] = r * gx_max_color_value / max_rgb;
		    prgb[1] = g * gx_max_color_value / max_rgb;
		    prgb[2] = b * gx_max_color_value / max_rgb;
		    return 0;
		}
	} else {
	    int size = xdev-&gt;color_info.dither_grays;
	    int i;

	    for (i = 0; i &lt; size; ++i)
		if (xdev-&gt;cman.dither_ramp[i] == color) {
		    prgb[0] = prgb[1] = prgb[2] =
			i * gx_max_color_value / (size - 1);
		    return 0;
		}
	}
    }

    /* Finally, search the list of dynamic colors. */
    if (xdev-&gt;cman.dynamic.colors) {
	int i;
	const x11_color_t *xcp;

	for (i = xdev-&gt;cman.dynamic.size; --i &gt;= 0;)
	    for (xcp = xdev-&gt;cman.dynamic.colors[i]; xcp; xcp = xcp-&gt;next)
		if (xcp-&gt;color.pixel == color &amp;&amp; xcp-&gt;color.pad) {
		    prgb[0] = xcp-&gt;color.red;
		    prgb[1] = xcp-&gt;color.green;
		    prgb[2] = xcp-&gt;color.blue;
		    return 0;
		}
    }

    /* Not found -- not possible! */
    return_error(gs_error_unknownerror);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

