<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gdevxini.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gdevxini.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gdevxini.c,v 1.14 2004/05/26 04:10:58 dan Exp $ */
/* X Windows driver initialization/finalization */
#include "memory_.h"
#include "x_.h"
#include "gx.h"
#include "gserrors.h"
#include "gxdevice.h"
#include "gxdevmem.h"
#include "gsparamx.h"
#include "gdevbbox.h"
#include "gdevx.h"

extern char *getenv(const char *);

extern const gx_device_bbox gs_bbox_device;
extern const gx_device_X gs_x11_device;

extern const gx_device_bbox_procs_t gdev_x_box_procs;

/* Define constants for orientation from ghostview */
/* Number represents clockwise rotation of the paper in degrees */
typedef enum {
    Portrait = 0,		/* Normal portrait orientation */
    Landscape = 90,		/* Normal landscape orientation */
    Upsidedown = 180,		/* Don't think this will be used much */
    Seascape = 270		/* Landscape rotated the wrong way */
} orientation;

/* GC descriptors */
private_st_x11fontmap();

/* ---------------- Opening/initialization ---------------- */

/* Forward references */
private void gdev_x_setup_fontmap(gx_device_X *);

/* Catch the alloc error when there is not enough resources for the
 * backing pixmap.  Automatically shut off backing pixmap and let the
 * user know when this happens.
 *
 * Because the X API was designed without adequate thought to reentrancy,
 * these variables must be allocated statically.  We do not see how this
 * code can work reliably in the presence of multi-threading.
 */
private struct xv_ {
    Boolean alloc_error;
    XErrorHandler orighandler;
    XErrorHandler oldhandler;
} x_error_handler;

private int
x_catch_alloc(Display * dpy, XErrorEvent * err)
{
    if (err-&gt;error_code == BadAlloc)
	x_error_handler.alloc_error = True;
    if (x_error_handler.alloc_error)
	return 0;
    return x_error_handler.oldhandler(dpy, err);
}

int
x_catch_free_colors(Display * dpy, XErrorEvent * err)
{
    if (err-&gt;request_code == X_FreeColors)
	return 0;
    return x_error_handler.orighandler(dpy, err);
}

/* Open the X device */
int
gdev_x_open(gx_device_X * xdev)
{
    XSizeHints sizehints;
    char *window_id;
    XEvent event;
    XVisualInfo xvinfo;
    int nitems;
    XtAppContext app_con;
    Widget toplevel;
    Display *dpy;
    XColor xc;
    int zero = 0;
    int xid_height, xid_width;
    int code;

#ifdef DEBUG
# ifdef have_Xdebug
    if (gs_debug['X']) {
	extern int _Xdebug;

	_Xdebug = 1;
    }
# endif
#endif
    if (!(xdev-&gt;dpy = XOpenDisplay((char *)NULL))) {
	char *dispname = getenv("DISPLAY");

	eprintf1("Cannot open X display `%s'.\n",
		 (dispname == NULL ? "(null)" : dispname));
	return_error(gs_error_ioerror);
    }
    xdev-&gt;dest = 0;
    if ((window_id = getenv("GHOSTVIEW"))) {
	if (!(xdev-&gt;ghostview = sscanf(window_id, "%ld %ld",
				       &amp;(xdev-&gt;win), &amp;(xdev-&gt;dest)))) {
	    eprintf("Cannot get Window ID from ghostview.\n");
	    return_error(gs_error_ioerror);
	}
    }
    if (xdev-&gt;pwin != (Window) None) {	/* pick up the destination window parameters if specified */
	XWindowAttributes attrib;

	xdev-&gt;win = xdev-&gt;pwin;
	if (XGetWindowAttributes(xdev-&gt;dpy, xdev-&gt;win, &amp;attrib)) {
	    xdev-&gt;scr = attrib.screen;
	    xvinfo.visual = attrib.visual;
	    xdev-&gt;cmap = attrib.colormap;
	    xid_width = attrib.width;
	    xid_height = attrib.height;
	} else {
	    /* No idea why we can't get the attributes, but */
	    /* we shouldn't let it lead to a failure below. */
	    xid_width = xid_height = 0;
	}
    } else if (xdev-&gt;ghostview) {
	XWindowAttributes attrib;
	Atom type;
	int format;
	unsigned long nitems, bytes_after;
	char *buf;
	Atom ghostview_atom = XInternAtom(xdev-&gt;dpy, "GHOSTVIEW", False);

	if (XGetWindowAttributes(xdev-&gt;dpy, xdev-&gt;win, &amp;attrib)) {
	    xdev-&gt;scr = attrib.screen;
	    xvinfo.visual = attrib.visual;
	    xdev-&gt;cmap = attrib.colormap;
	    xdev-&gt;width = attrib.width;
	    xdev-&gt;height = attrib.height;
	}
	/* Delete property if explicit dest is given */
	if (XGetWindowProperty(xdev-&gt;dpy, xdev-&gt;win, ghostview_atom, 0,
			       256, (xdev-&gt;dest != 0), XA_STRING,
			       &amp;type, &amp;format, &amp;nitems, &amp;bytes_after,
			       (unsigned char **)&amp;buf) == 0 &amp;&amp;
	    type == XA_STRING) {
	    int llx, lly, urx, ury;
	    int left_margin = 0, bottom_margin = 0;
	    int right_margin = 0, top_margin = 0;

	    /* We declare page_orientation as an int so that we can */
	    /* use an int * to reference it for sscanf; compilers */
	    /* might be tempted to use less space to hold it if */
	    /* it were declared as an orientation. */
	    int /*orientation */ page_orientation;
	    float xppp, yppp;	/* pixels per point */

	    nitems = sscanf(buf,
			    "%ld %d %d %d %d %d %f %f %d %d %d %d",
			    &amp;(xdev-&gt;bpixmap), &amp;page_orientation,
			    &amp;llx, &amp;lly, &amp;urx, &amp;ury,
			    &amp;(xdev-&gt;x_pixels_per_inch),
			    &amp;(xdev-&gt;y_pixels_per_inch),
			    &amp;left_margin, &amp;bottom_margin,
			    &amp;right_margin, &amp;top_margin);
	    if (!(nitems == 8 || nitems == 12)) {
		eprintf("Cannot get ghostview property.\n");
		return_error(gs_error_ioerror);
	    }
	    if (xdev-&gt;dest &amp;&amp; xdev-&gt;bpixmap) {
		eprintf("Both destination and backing pixmap specified.\n");
		return_error(gs_error_rangecheck);
	    }
	    if (xdev-&gt;dest) {
		Window root;
		int x, y;
		unsigned int width, height;
		unsigned int border_width, depth;

		if (XGetGeometry(xdev-&gt;dpy, xdev-&gt;dest, &amp;root, &amp;x, &amp;y,
				 &amp;width, &amp;height, &amp;border_width, &amp;depth)) {
		    xdev-&gt;width = width;
		    xdev-&gt;height = height;
		}
	    }
	    xppp = xdev-&gt;x_pixels_per_inch / 72.0;
	    yppp = xdev-&gt;y_pixels_per_inch / 72.0;
	    switch (page_orientation) {
		case Portrait:
		    xdev-&gt;initial_matrix.xx = xppp;
		    xdev-&gt;initial_matrix.xy = 0.0;
		    xdev-&gt;initial_matrix.yx = 0.0;
		    xdev-&gt;initial_matrix.yy = -yppp;
		    xdev-&gt;initial_matrix.tx = -llx * xppp;
		    xdev-&gt;initial_matrix.ty = ury * yppp;
		    break;
		case Landscape:
		    xdev-&gt;initial_matrix.xx = 0.0;
		    xdev-&gt;initial_matrix.xy = yppp;
		    xdev-&gt;initial_matrix.yx = xppp;
		    xdev-&gt;initial_matrix.yy = 0.0;
		    xdev-&gt;initial_matrix.tx = -lly * xppp;
		    xdev-&gt;initial_matrix.ty = -llx * yppp;
		    break;
		case Upsidedown:
		    xdev-&gt;initial_matrix.xx = -xppp;
		    xdev-&gt;initial_matrix.xy = 0.0;
		    xdev-&gt;initial_matrix.yx = 0.0;
		    xdev-&gt;initial_matrix.yy = yppp;
		    xdev-&gt;initial_matrix.tx = urx * xppp;
		    xdev-&gt;initial_matrix.ty = -lly * yppp;
		    break;
		case Seascape:
		    xdev-&gt;initial_matrix.xx = 0.0;
		    xdev-&gt;initial_matrix.xy = -yppp;
		    xdev-&gt;initial_matrix.yx = -xppp;
		    xdev-&gt;initial_matrix.yy = 0.0;
		    xdev-&gt;initial_matrix.tx = ury * xppp;
		    xdev-&gt;initial_matrix.ty = urx * yppp;
		    break;
	    }

	    /* The following sets the imageable area according to the */
	    /* bounding box and margins sent by ghostview.            */
	    /* This code has been patched many times; its current state */
	    /* is per a recommendation by Tim Theisen on 4/28/95. */

	    xdev-&gt;ImagingBBox[0] = llx - left_margin;
	    xdev-&gt;ImagingBBox[1] = lly - bottom_margin;
	    xdev-&gt;ImagingBBox[2] = urx + right_margin;
	    xdev-&gt;ImagingBBox[3] = ury + top_margin;
	    xdev-&gt;ImagingBBox_set = true;

	} else if (xdev-&gt;pwin == (Window) None) {
	    eprintf("Cannot get ghostview property.\n");
	    return_error(gs_error_ioerror);
	}
    } else {
	Screen *scr = DefaultScreenOfDisplay(xdev-&gt;dpy);

	xdev-&gt;scr = scr;
	xvinfo.visual = DefaultVisualOfScreen(scr);
	xdev-&gt;cmap = DefaultColormapOfScreen(scr);
	if (xvinfo.visual-&gt;class != TrueColor) {
	    int scrno = DefaultScreen(xdev-&gt;dpy);
	    if ( XMatchVisualInfo(xdev-&gt;dpy, scrno, 24, TrueColor, &amp;xvinfo) ||
		 XMatchVisualInfo(xdev-&gt;dpy, scrno, 32, TrueColor, &amp;xvinfo) || 
		 XMatchVisualInfo(xdev-&gt;dpy, scrno, 16, TrueColor, &amp;xvinfo) ||
		 XMatchVisualInfo(xdev-&gt;dpy, scrno, 15, TrueColor, &amp;xvinfo)  ) {
		xdev-&gt;cmap = XCreateColormap (xdev-&gt;dpy, 
					      DefaultRootWindow(xdev-&gt;dpy),
					      xvinfo.visual, AllocNone ); 
	    }
	}
    }
    xvinfo.visualid = XVisualIDFromVisual(xvinfo.visual);
    xdev-&gt;vinfo = XGetVisualInfo(xdev-&gt;dpy, VisualIDMask, &amp;xvinfo, &amp;nitems);
    if (xdev-&gt;vinfo == NULL) {
	eprintf("Cannot get XVisualInfo.\n");
	return_error(gs_error_ioerror);
    }
    /* Buggy X servers may cause a Bad Access on XFreeColors. */
    x_error_handler.orighandler = XSetErrorHandler(x_catch_free_colors);

    /* Get X Resources.  Use the toolkit for this. */
    XtToolkitInitialize();
    app_con = XtCreateApplicationContext();
    XtAppSetFallbackResources(app_con, gdev_x_fallback_resources);
    dpy = XtOpenDisplay(app_con, NULL, "ghostscript", "Ghostscript",
			NULL, 0, &amp;zero, NULL);
    toplevel = XtAppCreateShell(NULL, "Ghostscript",
				applicationShellWidgetClass, dpy, NULL, 0);
    XtGetApplicationResources(toplevel, (XtPointer) xdev,
			      gdev_x_resources, gdev_x_resource_count,
			      NULL, 0);

    /* Reserve foreground and background colors under the regular connection. */
    xc.pixel = xdev-&gt;foreground;
    XQueryColor(xdev-&gt;dpy, DefaultColormap(xdev-&gt;dpy,DefaultScreen(xdev-&gt;dpy)), &amp;xc);
    XAllocColor(xdev-&gt;dpy, xdev-&gt;cmap, &amp;xc);
    xdev-&gt;foreground = xc.pixel;
    xc.pixel = xdev-&gt;background;
    XQueryColor(xdev-&gt;dpy, DefaultColormap(xdev-&gt;dpy,DefaultScreen(xdev-&gt;dpy)), &amp;xc);
    XAllocColor(xdev-&gt;dpy, xdev-&gt;cmap, &amp;xc);
    xdev-&gt;background = xc.pixel;

    code = gdev_x_setup_colors(xdev);
    if (code &lt; 0) {
	XCloseDisplay(xdev-&gt;dpy);
	return code;
    }
    /* Now that the color map is setup check if the device is separable. */
    check_device_separable((gx_device *)xdev);

    gdev_x_setup_fontmap(xdev);

    if (!xdev-&gt;ghostview) {
	XWMHints wm_hints;
	XSetWindowAttributes xswa;
	gx_device *dev = (gx_device *) xdev;

	/* Take care of resolution and paper size. */
	if (xdev-&gt;x_pixels_per_inch == FAKE_RES ||
	    xdev-&gt;y_pixels_per_inch == FAKE_RES) {
	    float xsize = (float)xdev-&gt;width / xdev-&gt;x_pixels_per_inch;
	    float ysize = (float)xdev-&gt;height / xdev-&gt;y_pixels_per_inch;

	    if (xdev-&gt;xResolution == 0.0 &amp;&amp; xdev-&gt;yResolution == 0.0) {
		float dpi, xdpi, ydpi;

		xdpi = 25.4 * WidthOfScreen(xdev-&gt;scr) /
		    WidthMMOfScreen(xdev-&gt;scr);
		ydpi = 25.4 * HeightOfScreen(xdev-&gt;scr) /
		    HeightMMOfScreen(xdev-&gt;scr);
		dpi = min(xdpi, ydpi);
		/*
		 * Some X servers provide very large "virtual screens", and
		 * return the virtual screen size for Width/HeightMM but the
		 * physical size for Width/Height.  Attempt to detect and
		 * correct for this now.  This is a KLUDGE required because
		 * the X server provides no way to read the screen
		 * resolution directly.
		 */
		if (dpi &lt; 30)
		    dpi = 75;	/* arbitrary */
		else {
		    while (xsize * dpi &gt; WidthOfScreen(xdev-&gt;scr) - 32 ||
			   ysize * dpi &gt; HeightOfScreen(xdev-&gt;scr) - 32)
			dpi *= 0.95;
		}
		xdev-&gt;x_pixels_per_inch = dpi;
		xdev-&gt;y_pixels_per_inch = dpi;
	    } else {
		xdev-&gt;x_pixels_per_inch = xdev-&gt;xResolution;
		xdev-&gt;y_pixels_per_inch = xdev-&gt;yResolution;
	    }
	    if (xdev-&gt;width &gt; WidthOfScreen(xdev-&gt;scr)) {
		xdev-&gt;width = xsize * xdev-&gt;x_pixels_per_inch;
	    }
	    if (xdev-&gt;height &gt; HeightOfScreen(xdev-&gt;scr)) {
		xdev-&gt;height = ysize * xdev-&gt;y_pixels_per_inch;
	    }
	    xdev-&gt;MediaSize[0] =
		(float)xdev-&gt;width / xdev-&gt;x_pixels_per_inch * 72;
	    xdev-&gt;MediaSize[1] =
		(float)xdev-&gt;height / xdev-&gt;y_pixels_per_inch * 72;
	}
	sizehints.x = 0;
	sizehints.y = 0;
	sizehints.width = xdev-&gt;width;
	sizehints.height = xdev-&gt;height;
	sizehints.flags = 0;

	if (xdev-&gt;geometry != NULL) {
	    /*
	     * Note that border_width must be set first.  We can't use
	     * scr, because that is a Screen*, and XWMGeometry wants
	     * the screen number.
	     */
	    char gstr[40];
	    int bitmask;

	    sprintf(gstr, "%dx%d+%d+%d", sizehints.width,
		    sizehints.height, sizehints.x, sizehints.y);
	    bitmask = XWMGeometry(xdev-&gt;dpy, DefaultScreen(xdev-&gt;dpy),
				  xdev-&gt;geometry, gstr, xdev-&gt;borderWidth,
				  &amp;sizehints,
				  &amp;sizehints.x, &amp;sizehints.y,
				  &amp;sizehints.width, &amp;sizehints.height,
				  &amp;sizehints.win_gravity);

	    if (bitmask &amp; (XValue | YValue))
		sizehints.flags |= USPosition;
	}
	gx_default_get_initial_matrix(dev, &amp;(xdev-&gt;initial_matrix));

	if (xdev-&gt;pwin != (Window) None &amp;&amp; xid_width != 0 &amp;&amp; xid_height != 0) {
#if 0				/*************** */

	    /*
	     * The user who originally implemented the WindowID feature
	     * provided the following code to scale the displayed output
	     * to fit in the window.  We think this is a bad idea,
	     * since it doesn't track window resizing and is generally
	     * completely at odds with the way Ghostscript treats
	     * window or paper size in all other contexts.  We are
	     * leaving the code here in case someone decides that
	     * this really is the behavior they want.
	     */

	    /* Scale to fit in the window. */
	    xdev-&gt;initial_matrix.xx
		= xdev-&gt;initial_matrix.xx *
		(float)xid_width / (float)xdev-&gt;width;
	    xdev-&gt;initial_matrix.yy
		= xdev-&gt;initial_matrix.yy *
		(float)xid_height / (float)xdev-&gt;height;

#endif /*************** */
	    xdev-&gt;width = xid_width;
	    xdev-&gt;height = xid_height;
	    xdev-&gt;initial_matrix.ty = xdev-&gt;height;
	} else {		/* !xdev-&gt;pwin */
	    xswa.event_mask = ExposureMask;
	    xswa.background_pixel = xdev-&gt;background;
	    xswa.border_pixel = xdev-&gt;borderColor;
	    xswa.colormap = xdev-&gt;cmap;
	    xdev-&gt;win = XCreateWindow(xdev-&gt;dpy, RootWindowOfScreen(xdev-&gt;scr),
				      sizehints.x, sizehints.y,		/* upper left */
				      xdev-&gt;width, xdev-&gt;height,
				      xdev-&gt;borderWidth,
				      xdev-&gt;vinfo-&gt;depth,
				      InputOutput,	/* class        */
				      xdev-&gt;vinfo-&gt;visual,	/* visual */
				      CWEventMask | CWBackPixel |
				      CWBorderPixel | CWColormap,
				      &amp;xswa);
	    XStoreName(xdev-&gt;dpy, xdev-&gt;win, "ghostscript");
	    XSetWMNormalHints(xdev-&gt;dpy, xdev-&gt;win, &amp;sizehints);
	    wm_hints.flags = InputHint;
	    wm_hints.input = False;
	    XSetWMHints(xdev-&gt;dpy, xdev-&gt;win, &amp;wm_hints);	/* avoid input focus */
	}
    }
    /***
     *** According to Ricard Torres (torres@upf.es), we have to wait until here
     *** to close the toolkit connection, which we formerly did
     *** just after the calls on XAllocColor above.  I suspect that
     *** this will cause things to be left dangling if an error occurs
     *** anywhere in the above code, but I'm willing to let users
     *** fight over fixing it, since I have no idea what's right.
     ***/

    /* And close the toolkit connection. */
    XtDestroyWidget(toplevel);
    XtCloseDisplay(dpy);
    XtDestroyApplicationContext(app_con);

    xdev-&gt;ht.pixmap = (Pixmap) 0;
    xdev-&gt;ht.id = gx_no_bitmap_id;;
    xdev-&gt;fill_style = FillSolid;
    xdev-&gt;function = GXcopy;
    xdev-&gt;fid = (Font) 0;

    /* Set up a graphics context */
    xdev-&gt;gc = XCreateGC(xdev-&gt;dpy, xdev-&gt;win, 0, (XGCValues *) NULL);
    XSetFunction(xdev-&gt;dpy, xdev-&gt;gc, GXcopy);
    XSetLineAttributes(xdev-&gt;dpy, xdev-&gt;gc, 0,
		       LineSolid, CapButt, JoinMiter);

    gdev_x_clear_window(xdev);

    if (!xdev-&gt;ghostview) {	/* Make the window appear. */
	XMapWindow(xdev-&gt;dpy, xdev-&gt;win);

	/* Before anything else, do a flush and wait for */
	/* an exposure event. */
	XSync(xdev-&gt;dpy, False);
	if (xdev-&gt;pwin == (Window) None) {	/* there isn't a next event for existing windows */
	    XNextEvent(xdev-&gt;dpy, &amp;event);
	}
	/* Now turn off graphics exposure events so they don't queue up */
	/* indefinitely.  Also, since we can't do anything about real */
	/* Expose events, mask them out. */
	XSetGraphicsExposures(xdev-&gt;dpy, xdev-&gt;gc, False);
	XSelectInput(xdev-&gt;dpy, xdev-&gt;win, NoEventMask);
    } else {
	/* Create an unmapped window, that the window manager will ignore.
	 * This invisible window will be used to receive "next page"
	 * events from ghostview */
	XSetWindowAttributes attributes;

	attributes.override_redirect = True;
	xdev-&gt;mwin = XCreateWindow(xdev-&gt;dpy, RootWindowOfScreen(xdev-&gt;scr),
				   0, 0, 1, 1, 0, CopyFromParent,
				   CopyFromParent, CopyFromParent,
				   CWOverrideRedirect, &amp;attributes);
	xdev-&gt;NEXT = XInternAtom(xdev-&gt;dpy, "NEXT", False);
	xdev-&gt;PAGE = XInternAtom(xdev-&gt;dpy, "PAGE", False);
	xdev-&gt;DONE = XInternAtom(xdev-&gt;dpy, "DONE", False);
    }

    xdev-&gt;ht.no_pixmap = XCreatePixmap(xdev-&gt;dpy, xdev-&gt;win, 1, 1,
				       xdev-&gt;vinfo-&gt;depth);

    return 0;
}

/* Set up or take down buffering in a RAM image. */
private int
x_set_buffer(gx_device_X * xdev)
{
    /*
     * We must use the stable memory here, since the existence of the
     * buffer is independent of save/restore.
     */
    gs_memory_t *mem = gs_memory_stable(xdev-&gt;memory);
    bool buffered = xdev-&gt;MaxBitmap &gt; 0;
    const gx_device_procs *procs;

 setup:
    if (buffered) {
	/* We want to buffer. */
	/* Check that we can set up a memory device. */
	gx_device_memory *mdev = (gx_device_memory *)xdev-&gt;target;

	if (mdev == 0 || mdev-&gt;color_info.depth != xdev-&gt;color_info.depth) {
	    const gx_device_memory *mdproto =
		gdev_mem_device_for_bits(xdev-&gt;color_info.depth);

	    if (!mdproto) {
		buffered = false;
		goto setup;
	    }
	    if (mdev) {
		/* Update the pointer we're about to overwrite. */
		gx_device_set_target((gx_device_forward *)mdev, NULL);
	    } else {
		mdev = gs_alloc_struct(mem, gx_device_memory,
				       &amp;st_device_memory, "memory device");
		if (mdev == 0) {
		    buffered = false;
		    goto setup;
		}
	    }
	    /*
	     * We want to forward image drawing to the memory device.
	     * That requires making the memory device forward its color
	     * mapping operations back to the X device, creating a circular
	     * pointer structure.  This is not a disaster, we just need to
	     * be aware that this is going on.
	     */
	    gs_make_mem_device(mdev, mdproto, mem, 0, (gx_device *)xdev);
	    gx_device_set_target((gx_device_forward *)xdev, (gx_device *)mdev);
	    xdev-&gt;is_buffered = true;
	}
	if (mdev-&gt;width != xdev-&gt;width || mdev-&gt;height != xdev-&gt;height) {
	    byte *buffer;
	    ulong space;

	    space = gdev_mem_data_size(mdev, xdev-&gt;width, xdev-&gt;height);
	    if (space &gt; xdev-&gt;MaxBitmap) {
		buffered = false;
		goto setup;
	    }
	    buffer =
		(xdev-&gt;buffer ?
		 (byte *)gs_resize_object(mem, xdev-&gt;buffer, space, "buffer") :
		 gs_alloc_bytes(mem, space, "buffer"));
	    if (!buffer) {
		buffered = false;
		goto setup;
	    }
	    xdev-&gt;buffer_size = space;
	    xdev-&gt;buffer = buffer;
	    mdev-&gt;width = xdev-&gt;width;
	    mdev-&gt;height = xdev-&gt;height;
	    mdev-&gt;color_info = xdev-&gt;color_info;
	    mdev-&gt;base = xdev-&gt;buffer;
	    gdev_mem_open_scan_lines(mdev, xdev-&gt;height);
	}
	xdev-&gt;white = gx_device_white((gx_device *)xdev);
	xdev-&gt;black = gx_device_black((gx_device *)xdev);
	procs = &amp;gs_bbox_device.procs;
    } else {
	/* Not buffering.  Release the buffer and memory device. */
	gs_free_object(mem, xdev-&gt;buffer, "buffer");
	xdev-&gt;buffer = 0;
	xdev-&gt;buffer_size = 0;
	if (!xdev-&gt;is_buffered)
	    return 0;
	gx_device_set_target((gx_device_forward *)xdev-&gt;target, NULL);
	gx_device_set_target((gx_device_forward *)xdev, NULL);
	xdev-&gt;is_buffered = false;
	procs = &amp;gs_x11_device.procs;
    }
    if (dev_proc(xdev, fill_rectangle) != procs-&gt;fill_rectangle) {
#define COPY_PROC(p) set_dev_proc(xdev, p, procs-&gt;p)
	COPY_PROC(fill_rectangle);
	COPY_PROC(copy_mono);
	COPY_PROC(copy_color);
	COPY_PROC(copy_alpha);
	COPY_PROC(fill_path);
	COPY_PROC(stroke_path);
	COPY_PROC(fill_mask);
	COPY_PROC(fill_trapezoid);
	COPY_PROC(fill_parallelogram);
	COPY_PROC(fill_triangle);
	COPY_PROC(draw_thin_line);
	COPY_PROC(strip_tile_rectangle);
	COPY_PROC(strip_copy_rop);
	COPY_PROC(begin_typed_image);
	COPY_PROC(create_compositor);
	COPY_PROC(text_begin);
#undef COPY_PROC
	if (xdev-&gt;is_buffered) {
    	    check_device_separable((gx_device *)xdev);
	    gx_device_forward_fill_in_procs((gx_device_forward *)xdev);
	    xdev-&gt;box_procs = gdev_x_box_procs;
	    xdev-&gt;box_proc_data = xdev;
	} else {
    	    check_device_separable((gx_device *)xdev);
	    gx_device_fill_in_procs((gx_device *)xdev);
	}
    }
    return 0;
}

/* Allocate the backing pixmap, if any, and clear the window. */
void
gdev_x_clear_window(gx_device_X * xdev)
{
    if (!xdev-&gt;ghostview) {
	if (xdev-&gt;useBackingPixmap) {
	    if (xdev-&gt;bpixmap == 0) {
		x_error_handler.oldhandler = XSetErrorHandler(x_catch_alloc);
		x_error_handler.alloc_error = False;
		xdev-&gt;bpixmap =
		    XCreatePixmap(xdev-&gt;dpy, xdev-&gt;win,
				  xdev-&gt;width, xdev-&gt;height,
				  xdev-&gt;vinfo-&gt;depth);
		XSync(xdev-&gt;dpy, False);	/* Force the error */
		if (x_error_handler.alloc_error) {
		    xdev-&gt;useBackingPixmap = False;
#ifdef DEBUG
		    eprintf("Warning: Failed to allocated backing pixmap.\n");
#endif
		    if (xdev-&gt;bpixmap) {
			XFreePixmap(xdev-&gt;dpy, xdev-&gt;bpixmap);
			xdev-&gt;bpixmap = None;
			XSync(xdev-&gt;dpy, False);	/* Force the error */
		    }
		}
		x_error_handler.oldhandler =
		    XSetErrorHandler(x_error_handler.oldhandler);
	    }
	} else {
	    if (xdev-&gt;bpixmap != 0) {
		XFreePixmap(xdev-&gt;dpy, xdev-&gt;bpixmap);
		xdev-&gt;bpixmap = (Pixmap) 0;
	    }
	}
    }
    x_set_buffer(xdev);
    /* Clear the destination pixmap to avoid initializing with garbage. */
    if (xdev-&gt;dest == (Pixmap) 0) {
	xdev-&gt;dest = (xdev-&gt;bpixmap != (Pixmap) 0 ?
		  xdev-&gt;bpixmap : (Pixmap) xdev-&gt;win);
    }
    if (xdev-&gt;dest != (Pixmap) 0) {
	XSetForeground(xdev-&gt;dpy, xdev-&gt;gc, xdev-&gt;background);
	XFillRectangle(xdev-&gt;dpy, xdev-&gt;dest, xdev-&gt;gc,
		       0, 0, xdev-&gt;width, xdev-&gt;height);
    }

    /* Clear the background pixmap to avoid initializing with garbage. */
    if (xdev-&gt;bpixmap != (Pixmap) 0) {
	if (!xdev-&gt;ghostview)
	    XSetWindowBackgroundPixmap(xdev-&gt;dpy, xdev-&gt;win, xdev-&gt;bpixmap);
	XSetForeground(xdev-&gt;dpy, xdev-&gt;gc, xdev-&gt;background);
	XFillRectangle(xdev-&gt;dpy, xdev-&gt;bpixmap, xdev-&gt;gc,
		       0, 0, xdev-&gt;width, xdev-&gt;height);
    }
    /* Initialize foreground and background colors */
    xdev-&gt;back_color = xdev-&gt;background;
    XSetBackground(xdev-&gt;dpy, xdev-&gt;gc, xdev-&gt;background);
    xdev-&gt;fore_color = xdev-&gt;background;
    XSetForeground(xdev-&gt;dpy, xdev-&gt;gc, xdev-&gt;background);
    xdev-&gt;colors_or = xdev-&gt;colors_and = xdev-&gt;background;
}

/* ------ Initialize font mapping ------ */

/* Extract the PostScript font name from the font map resource. */
private const char *
get_ps_name(const char **cpp, int *len)
{
    const char *ret;

    *len = 0;
    /* skip over whitespace and newlines */
    while (**cpp == ' ' || **cpp == '\t' || **cpp == '\n') {
	(*cpp)++;
    }
    /* return font name up to ":", whitespace, or end of string */
    if (**cpp == ':' || **cpp == '\0') {
	return NULL;
    }
    ret = *cpp;
    while (**cpp != ':' &amp;&amp;
	   **cpp != ' ' &amp;&amp; **cpp != '\t' &amp;&amp; **cpp != '\n' &amp;&amp;
	   **cpp != '\0') {
	(*cpp)++;
	(*len)++;
    }
    return ret;
}

/* Extract the X11 font name from the font map resource. */
private const char *
get_x11_name(const char **cpp, int *len)
{
    const char *ret;
    int dashes = 0;

    *len = 0;
    /* skip over whitespace and the colon */
    while (**cpp == ' ' || **cpp == '\t' ||
	   **cpp == ':') {
	(*cpp)++;
    }
    /* return font name up to end of line or string */
    if (**cpp == '\0' || **cpp == '\n') {
	return NULL;
    }
    ret = *cpp;
    while (dashes != 7 &amp;&amp;
	   **cpp != '\0' &amp;&amp; **cpp != '\n') {
	if (**cpp == '-')
	    dashes++;
	(*cpp)++;
	(*len)++;
    }
    while (**cpp != '\0' &amp;&amp; **cpp != '\n') {
	(*cpp)++;
    }
    if (dashes != 7)
	return NULL;
    return ret;
}

/* Scan one resource and build font map records. */
private void
scan_font_resource(const char *resource, x11fontmap **pmaps, gs_memory_t *mem)
{
    const char *ps_name;
    const char *x11_name;
    int ps_name_len;
    int x11_name_len;
    x11fontmap *font;
    const char *cp = resource;

    while ((ps_name = get_ps_name(&amp;cp, &amp;ps_name_len)) != 0) {
	x11_name = get_x11_name(&amp;cp, &amp;x11_name_len);
	if (x11_name) {
	    font = gs_alloc_struct(mem, x11fontmap, &amp;st_x11fontmap,
				   "scan_font_resource(font)");
	    if (font == NULL)
		continue;
	    font-&gt;ps_name = (char *)
		gs_alloc_byte_array(mem, ps_name_len + 1, sizeof(char),
				    "scan_font_resource(ps_name)");
	    if (font-&gt;ps_name == NULL) {
		gs_free_object(mem, font, "scan_font_resource(font)");
		continue;
	    }
	    strncpy(font-&gt;ps_name, ps_name, ps_name_len);
	    font-&gt;ps_name[ps_name_len] = '\0';
	    font-&gt;x11_name = (char *)
		gs_alloc_byte_array(mem, x11_name_len, sizeof(char),
				    "scan_font_resource(x11_name)");
	    if (font-&gt;x11_name == NULL) {
		gs_free_object(mem, font-&gt;ps_name,
			       "scan_font_resource(ps_name)");
		gs_free_object(mem, font, "scan_font_resource(font)");
		continue;
	    }
	    strncpy(font-&gt;x11_name, x11_name, x11_name_len - 1);
	    font-&gt;x11_name[x11_name_len - 1] = '\0';
	    font-&gt;std.names = NULL;
	    font-&gt;std.count = -1;
	    font-&gt;iso.names = NULL;
	    font-&gt;iso.count = -1;
	    font-&gt;next = *pmaps;
	    *pmaps = font;
	}
    }
}

/* Scan all the font resources and set up the maps. */
private void
gdev_x_setup_fontmap(gx_device_X * xdev)
{
    if (!xdev-&gt;useXFonts)
	return;			/* If no external fonts, don't bother */

    scan_font_resource(xdev-&gt;regularFonts, &amp;xdev-&gt;regular_fonts, xdev-&gt;memory);
    scan_font_resource(xdev-&gt;symbolFonts, &amp;xdev-&gt;symbol_fonts, xdev-&gt;memory);
    scan_font_resource(xdev-&gt;dingbatFonts, &amp;xdev-&gt;dingbat_fonts, xdev-&gt;memory);
}

/* Clean up the instance after making a copy. */
int
gdev_x_finish_copydevice(gx_device *dev, const gx_device *from_dev)
{
    gx_device_X *xdev = (gx_device_X *) dev;

    /* Mark the new instance as closed. */
    xdev-&gt;is_open = false;

    /* Prevent dangling references from the *_fonts lists. */
    xdev-&gt;regular_fonts = 0;
    xdev-&gt;symbol_fonts = 0;
    xdev-&gt;dingbat_fonts = 0;

    /* Clear all other pointers. */
    xdev-&gt;target = 0;
    xdev-&gt;buffer = 0;
    xdev-&gt;dpy = 0;
    xdev-&gt;scr = 0;
    xdev-&gt;vinfo = 0;

    /* Clear pointer-like parameters. */
    xdev-&gt;win = (Window)None;
    xdev-&gt;bpixmap = (Pixmap)0;
    xdev-&gt;dest = (Pixmap)0;
    xdev-&gt;cp.pixmap = (Pixmap)0;
    xdev-&gt;ht.pixmap = (Pixmap)0;

    /* Reset pointer-related parameters. */
    xdev-&gt;is_buffered = false;
    /* See x_set_buffer for why we do this: */
    set_dev_proc(xdev, fill_rectangle,
		 dev_proc(&amp;gs_x11_device, fill_rectangle));

    return 0;
}

/* ---------------- Get/put parameters ---------------- */

/* Get the device parameters.  See below. */
int
gdev_x_get_params(gx_device * dev, gs_param_list * plist)
{
    gx_device_X *xdev = (gx_device_X *) dev;
    int code = gx_default_get_params(dev, plist);
    long id = (long)xdev-&gt;pwin;

    if (code &lt; 0 ||
	(code = param_write_long(plist, "WindowID", &amp;id)) &lt; 0 ||
	(code = param_write_bool(plist, ".IsPageDevice", &amp;xdev-&gt;IsPageDevice)) &lt; 0 ||
	(code = param_write_long(plist, "MaxBitmap", &amp;xdev-&gt;MaxBitmap)) &lt; 0 ||
	(code = param_write_int(plist, "MaxTempPixmap", &amp;xdev-&gt;MaxTempPixmap)) &lt; 0 ||
	(code = param_write_int(plist, "MaxTempImage", &amp;xdev-&gt;MaxTempImage)) &lt; 0 ||
	(code = param_write_int(plist, "MaxBufferedTotal", &amp;xdev-&gt;MaxBufferedTotal)) &lt; 0 ||
	(code = param_write_int(plist, "MaxBufferedArea", &amp;xdev-&gt;MaxBufferedArea)) &lt; 0 ||
	(code = param_write_int(plist, "MaxBufferedCount", &amp;xdev-&gt;MaxBufferedCount)) &lt; 0
	)
	DO_NOTHING;
    return code;
}

/* Set the device parameters.  We reimplement this so we can resize */
/* the window and avoid closing and reopening the device, and to add */
/* .IsPageDevice. */
int
gdev_x_put_params(gx_device * dev, gs_param_list * plist)
{
    gx_device_X *xdev = (gx_device_X *) dev;
    /*
     * Provide copies of values of parameters being set:
     * is_open, width, height, HWResolution, IsPageDevice, Max*.
     */
    gx_device_X values;

    long pwin = (long)xdev-&gt;pwin;
    bool save_is_page = xdev-&gt;IsPageDevice;
    int ecode = 0, code;
    bool clear_window = false;

    values = *xdev;

    /* Handle extra parameters */

    ecode = param_put_long(plist, "WindowID", &amp;pwin, ecode);
    ecode = param_put_bool(plist, ".IsPageDevice", &amp;values.IsPageDevice, ecode);
    ecode = param_put_long(plist, "MaxBitmap", &amp;values.MaxBitmap, ecode);
    ecode = param_put_int(plist, "MaxTempPixmap", &amp;values.MaxTempPixmap, ecode);
    ecode = param_put_int(plist, "MaxTempImage", &amp;values.MaxTempImage, ecode);
    ecode = param_put_int(plist, "MaxBufferedTotal", &amp;values.MaxBufferedTotal, ecode);
    ecode = param_put_int(plist, "MaxBufferedArea", &amp;values.MaxBufferedArea, ecode);
    ecode = param_put_int(plist, "MaxBufferedCount", &amp;values.MaxBufferedCount, ecode);

    if (ecode &lt; 0)
	return ecode;

    /* Unless we specified a new window ID, */
    /* prevent gx_default_put_params from closing the device. */
    if (pwin == (long)xdev-&gt;pwin)
	dev-&gt;is_open = false;
    xdev-&gt;IsPageDevice = values.IsPageDevice;
    code = gx_default_put_params(dev, plist);
    dev-&gt;is_open = values.is_open; /* saved value */
    if (code &lt; 0) {		/* Undo setting of .IsPageDevice */
	xdev-&gt;IsPageDevice = save_is_page;
	return code;
    }
    if (pwin != (long)xdev-&gt;pwin) {
	if (xdev-&gt;is_open)
	    gs_closedevice(dev);
	xdev-&gt;pwin = (Window) pwin;
    }
    /* If the device is open, resize the window. */
    /* Don't do this if Ghostview is active. */
    if (xdev-&gt;is_open &amp;&amp; !xdev-&gt;ghostview &amp;&amp;
	(dev-&gt;width != values.width || dev-&gt;height != values.height ||
	 dev-&gt;HWResolution[0] != values.HWResolution[0] ||
	 dev-&gt;HWResolution[1] != values.HWResolution[1])
	) {
	int dw = dev-&gt;width - values.width;
	int dh = dev-&gt;height - values.height;
	double qx = dev-&gt;HWResolution[0] / values.HWResolution[0];
	double qy = dev-&gt;HWResolution[1] / values.HWResolution[1];

	if (dw || dh) {
	    XResizeWindow(xdev-&gt;dpy, xdev-&gt;win,
			  dev-&gt;width, dev-&gt;height);
	    if (xdev-&gt;bpixmap != (Pixmap) 0) {
		XFreePixmap(xdev-&gt;dpy, xdev-&gt;bpixmap);
		xdev-&gt;bpixmap = (Pixmap) 0;
	    }
	    xdev-&gt;dest = 0;
	    clear_window = true;
	}
	/* Attempt to update the initial matrix in a sensible way. */
	/* The whole handling of the initial matrix is a hack! */
	if (xdev-&gt;initial_matrix.xy == 0) {
	    if (xdev-&gt;initial_matrix.xx &lt; 0) {	/* 180 degree rotation */
		xdev-&gt;initial_matrix.tx += dw;
	    } else {		/* no rotation */
		xdev-&gt;initial_matrix.ty += dh;
	    }
	} else {
	    if (xdev-&gt;initial_matrix.xy &lt; 0) {	/* 90 degree rotation */
		xdev-&gt;initial_matrix.tx += dh;
		xdev-&gt;initial_matrix.ty += dw;
	    } else {		/* 270 degree rotation */
	    }
	}
	xdev-&gt;initial_matrix.xx *= qx;
	xdev-&gt;initial_matrix.xy *= qx;
	xdev-&gt;initial_matrix.yx *= qy;
	xdev-&gt;initial_matrix.yy *= qy;
    }
    xdev-&gt;MaxTempPixmap = values.MaxTempPixmap;
    xdev-&gt;MaxTempImage = values.MaxTempImage;
    xdev-&gt;MaxBufferedTotal = values.MaxBufferedTotal;
    xdev-&gt;MaxBufferedArea = values.MaxBufferedArea;
    xdev-&gt;MaxBufferedCount = values.MaxBufferedCount;
    if (clear_window || xdev-&gt;MaxBitmap != values.MaxBitmap) {
	/****** DO MORE FOR RESETTING MaxBitmap ******/
	xdev-&gt;MaxBitmap = values.MaxBitmap;
	if (xdev-&gt;is_open)
	    gdev_x_clear_window(xdev);
    }
    return 0;
}

/* ---------------- Closing/finalization ---------------- */

/* Free fonts when closing the device. */
private void
free_x_fontmaps(x11fontmap **pmaps, gs_memory_t *mem)
{
    while (*pmaps) {
	x11fontmap *font = *pmaps;

	*pmaps = font-&gt;next;
	if (font-&gt;std.names)
	    XFreeFontNames(font-&gt;std.names);
	if (font-&gt;iso.names)
	    XFreeFontNames(font-&gt;iso.names);
	gs_free_object(mem, font-&gt;x11_name, "free_x_fontmaps(x11_name)");
	gs_free_object(mem, font-&gt;ps_name, "free_x_fontmaps(ps_name)");
	gs_free_object(mem, font, "free_x_fontmaps(font)");
    }
}

/* Close the device. */
int
gdev_x_close(gx_device_X *xdev)
{
    if (xdev-&gt;ghostview)
	gdev_x_send_event(xdev, xdev-&gt;DONE);
    if (xdev-&gt;vinfo) {
	XFree((char *)xdev-&gt;vinfo);
	xdev-&gt;vinfo = NULL;
    }
    gdev_x_free_colors(xdev);
    free_x_fontmaps(&amp;xdev-&gt;dingbat_fonts, xdev-&gt;memory);
    free_x_fontmaps(&amp;xdev-&gt;symbol_fonts, xdev-&gt;memory);
    free_x_fontmaps(&amp;xdev-&gt;regular_fonts, xdev-&gt;memory);
    if (xdev-&gt;cmap != DefaultColormapOfScreen(xdev-&gt;scr))
	XFreeColormap(xdev-&gt;dpy, xdev-&gt;cmap);
    XCloseDisplay(xdev-&gt;dpy);
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

