<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/genconf.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/genconf.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993, 1996, 1997, 1998, 1999, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: genconf.c,v 1.10 2004/12/20 22:17:39 igor Exp $ */
/* Generate configuration files */
#include "stdpre.h"
#include &lt;assert.h&gt;
#include &lt;ctype.h&gt;
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;		/* for calloc */
#include &lt;string.h&gt;

/*
 * This program reads .dev files, which contain definitions of modules,
 * and generates merged configuration files.
 *
 * A .dev file specifies a list of "resources" of various kinds (.obj/.o
 * files, other .dev files to be merged in, PostScript files, driver names,
 * compiled fonts, etc.)  that make up the module.  (This is similar in
 * spirit to the Macintosh resource fork, and to PostScript resources, but
 * has nothing to do directly with the latter.)
 *
 * A .dev file consists of a series of switches and resource names.  Most
 * switches specifies the type of the following resources, until the next
 * type switch; there are also a few other switches.
 *
 * genconf recognizes the following resource type switches in .dev files.
 * See the next section on command line switches for the meaning of
 * &lt;name_prefix&gt;.
 *
 *    -comp &lt;name&gt;
 *
 *	Adds compositor_(&lt;name_prefix&gt;_composite_&lt;name&gt;_type) to &lt;gconfig.h&gt;.
 *	Used for gs_composite_type_t structures, whose identity may need to
 *	passed through the command list.
 *
 *    -dev &lt;device&gt;
 *
 *	Adds device_(&lt;name_prefix&gt;&lt;device&gt;_device) to &lt;gconfig.h&gt;.
 *	Used for ordinary devices.
 *
 *    -dev2 &lt;device&gt;
 *
 *	Adds device2_(&lt;name_prefix&gt;&lt;device&gt;_device) to &lt;gconfig.h&gt;.
 *	Used for some newer devices with potentially different structures
 *	or conventions.
 *
 *    -emulator &lt;emulator&gt;
 *
 *	Adds emulator_("&lt;emulator&gt;",&lt;len&gt;), where len is the number of
 *	characters in &lt;emulator&gt;, to &lt;gconfig.h&gt;.
 *	Used for names that should appear as instances of the PostScript
 *	Emulator resource category.
 *
 *    -font &lt;font&gt;
 *
 *	Adds an entry to &lt;gconfigf.h&gt;, as described below.
 *
 *    -functiontype &lt;fntype&gt;
 *
 *	Adds function_type_(&lt;fntype&gt;,&lt;name_prefix&gt;build_function_&lt;fntype&gt;)
 *	to &lt;gconfig.h&gt;.
 *	Used for instances of the PostScript FunctionType resource category,
 *	and also to generate a table of procedures for processing
 *	Function dictionaries.
 *
 *    -halftone &lt;htname&gt;
 *
 *	Adds halftone_(&lt;name_prefix&gt;dht_&lt;htname&gt;) to &lt;gconfig.h&gt;.
 *	Used for halftones that will be compiled into the executable.
 *
 *    -imageclass &lt;iclass&gt;
 *
 *	Adds image_class_(&lt;name_prefix&gt;image_class_&lt;iclass&gt;) to &lt;gconfig.h&gt;.
 *	Used internally for the various cases of rendering images.
 *
 *    -imagetype &lt;itype&gt;
 *
 *	Adds image_type_(&lt;itype&gt;,&lt;name_prefix&gt;image_type_&lt;itype&gt;) to
 *	&lt;gconfig.h&gt;.
 *	Used for instances of the PostScript ImageType resource category,
 *	and also to generate a table of procedures for handling the various
 *	types of images.
 *
 *    -include &lt;module&gt;
 *
 *	Reads the file named &lt;module&gt; (or &lt;module&gt;.dev if &lt;module&gt; doesn't
 *	end with ".dev") as though it were part of the current .dev file.
 *	Used when one module requires the presence of another.
 *
 *    -init &lt;initname&gt;
 *
 *	Adds init_(&lt;name_prefix&gt;&lt;initname&gt;_init) to &lt;gconfig.h&gt;.
 *	Used for initialization procedures to be called when Ghostscript
 *	is started.  By convention, &lt;initname&gt; is (almost always) the name
 *	of the source file in which the procedure is defined.
 *
 *    -iodev &lt;iodev&gt;
 *
 *	Adds io_device_(&lt;name_prefix&gt;iodev_&lt;iodev&gt;) to &lt;gconfig.h&gt;.
 *	Used for instances of the PostScript IODevice resource category.
 *
 *    -lib &lt;lib&gt;
 *
 *	Adds &lt;lib&gt; to the list of libraries to be written by -l.
 *
 *    -libpath &lt;libpath&gt;
 *
 *	Adds &lt;libpath&gt; to the list of library paths to be written by -l.
 *
 *    -link &lt;link&gt;
 *
 *	Adds &lt;link&gt; to the list of switches to be passed to the linker,
 *	to be written by -l.
 *
 *    -obj &lt;obj&gt;
 *
 *	Adds &lt;obj&gt; to the list of files to be linked, to be written by -o.
 *
 *    -oper &lt;opername&gt;
 *
 *	Adds oper_(&lt;opername&gt;_op_defs) to &lt;gconfig.h&gt;.
 *	Used for tables of PostScript operators.  By convention,
 *	&lt;opername&gt; is (usually) the name of the source file in which the
 *	table appears.
 *
 *    -plugin &lt;plugin_name&gt;
 *
 *	Adds plugin_(&lt;name_prefix&gt;&lt;plugin_name&gt;_instantiate) to &lt;gconfig.h&gt;.
 *	Used for plugins to be instantiated when Ghostscript
 *	is started.  By convention, &lt;plugin_name&gt; is (almost always) the name
 *	of the source file in which the plugin is defined.
 *
 *    -ps &lt;psname&gt;
 *
 *	Adds psfile_("&lt;psname&gt;.ps",&lt;len+3&gt;), where &lt;len&gt; is the number of
 *	character in &lt;psname&gt;, to &lt;gconfig.h&gt;.
 *	Used for PostScript files that should be read at initialization.
 *
 * genconf recognizes the following other switches in .dev files:
 *
 *    -replace &lt;module&gt;
 *
 *	This switch declares that &lt;module&gt; has been replaced by another
 *	module (presumably the one defined by the .dev file in which the
 *	switch appears), and should be removed from consideration.
 *	Modules that can be -replaced should not -include other modules.
 *
 * genconf writes the following files if the corresponding switch is used:
 *
 *    -h &lt;gconfig.h&gt;
 *
 *	Writes a list of all the resources as described above.  Each
 *	sublist is surrounded by an #ifdef/#endif in case the
 *	referenced macro (e.g., device_, oper_) is undefined.
 *	Duplicates are eliminated.
 *
 *    -f &lt;gconfigf.h&gt;
 *
 *	Writes a list of all the -font resources, in the form
 *		font_("0.font_&lt;name&gt;",&lt;name_prefix&gt;f_&lt;name&gt;,zf_&lt;name)
 *
 * Other switches specify various options and parameters:
 *
 *    -Z
 *
 *	Turns on debugging output.
 *
 *    -C [&lt;file_prefix&gt;]
 *
 *	Prefixes &lt;file_prefix&gt; to the names of all .dev files read in,
 *	and to the names of all .obj/.o files written in &lt;gconfig.h&gt;.
 *	The default file_prefix is the empty string.
 *	This switch should probably be removed, since nothing in the
 *	current Ghostscript makefiles uses it.
 *
 *    -e &lt;escapechar&gt;
 *
 *	Sets the escape character for patterns.  See below.
 *
 *    -n [&lt;name_prefix&gt; | -]
 *
 *	Prefixes &lt;name_prefix&gt;, or the empty string, to certain items in
 *	the output, as indicated above.
 *	The default name_prefix is "gs_".
 *
 *    -p[l|L][u][e] &lt;pattern&gt;
 *
 *	Sets the pattern (format string) used for writing certain items in
 *	the output, as indicated above.  '%' in the pattern indicates
 *	substitution of the variable data, as for printf except that the
 *	'%' is not followed by a format character -- the data are always
 *	inserted literally.  See below for more information about patterns.
 *
 *    -l[o] &lt;lib.tr&gt;
 *
 *	Writes the list of library paths, links, and library file names
 *	on &lt;lib.tr&gt;.  -lo also writes the list of object file names,
 *	as for -o. This feature is obsolete and is not longer in use.
 *      Use -ol instead.
 *
 *    -o[l] &lt;obj.tr&gt;
 *
 *	Writes the list object file names on &lt;obj.tr&gt;.  -ol also writes
 *	the list of library paths, links, and library file names as for -l.
 *
 * Usage summary:
 *
 *      genconf [-Z] [-C prefix] [-e escapechar] [-n [name_prefix | -]]
 *	  [@]xxx.dev* [-f gconfigf.h] [-h gconfig.h]
 *        [-p[l|L][u][e] pattern] [-l|o|lo|ol lib.tr]
 *
 * Patterns:
 *
 *   The default escape character is &amp;.  When this character appears in a
 *   pattern, it acts as follows:
 *	&amp;p produces a %;
 *	&amp;s produces a space;
 *	&amp;&amp; (i.e., the escape character twice) produces a \;
 *	&amp;- produces a -;
 *	&amp;x, for any other character x, is an error.
 */

#define DEFAULT_FILE_PREFIX ""
#define DEFAULT_NAME_PREFIX "gs_"

#define MAX_STR 120

/* Structures for accumulating information. */
typedef struct string_item_s {
    const char *str;
    int file_index;		/* index of file containing this item */
    int index;
} string_item_t;

/* The values of uniq_mode are bit masks. */
typedef enum {
    uniq_all = 1,		/* keep all occurrences (default) */
    uniq_first = 2,		/* keep only first occurrence */
    uniq_last = 4		/* keep only last occurrence */
} uniq_mode_t;
typedef struct string_list_s {
    /* The following are set at creation time. */
    const char *list_name;	/* only for debugging */
    int max_count;
    uniq_mode_t mode;
    /* The following are updated dynamically. */
    int count;
    string_item_t *items;
} string_list_t;

#define MAX_PATTERN 60
typedef struct string_pattern_s {
    bool upper_case;
    bool drop_extn;
    char pattern[MAX_PATTERN + 1];
} string_pattern_t;
typedef struct config_s {
    int debug;
    const char *name_prefix;
    const char *file_prefix;
    /* Special "resources" */
    string_list_t file_names;
    string_list_t file_contents;
    string_list_t replaces;
    /* Real resources */
    union ru_ {
	struct nu_ {
	    /* These names must parallel config_lists below. */
	    string_list_t sorted_resources;
	    string_list_t resources;
	    string_list_t devs;	/* also includes devs2 */
	    string_list_t compositors;
	    string_list_t fonts;
	    string_list_t libs;
	    string_list_t libpaths;
	    string_list_t links;
	    string_list_t objs;
	} named;
#define NUM_RESOURCE_LISTS 9
	string_list_t indexed[NUM_RESOURCE_LISTS];
    } lists;
    string_pattern_t lib_p;
    string_pattern_t libpath_p;
    string_pattern_t obj_p;
} config_t;

/*
 * These lists grow automatically if needed, so we could start out with
 * small allocations.
 */
static const config_t init_config = {
    0,				/* debug */
    DEFAULT_NAME_PREFIX,	/* name_prefix */
    DEFAULT_FILE_PREFIX,	/* file_prefix */
    {"file name", 200},		/* file_names */
    {"file contents", 200},	/* file_contents */
    {"-replace", 50}
};
static const string_list_t init_config_lists[] = {
    {"resource", 100, uniq_first},
    {"sorted_resource", 20, uniq_first},
    {"-comp", 10, uniq_first},
    {"-dev", 100, uniq_first},
    {"-font", 50, uniq_first},
    {"-lib", 20, uniq_last},
    {"-libpath", 10, uniq_first},
    {"-link", 10, uniq_first},
    {"-obj", 500, uniq_first}
};

/* Forward definitions */
private void *mrealloc(void *, size_t, size_t);
int alloc_list(string_list_t *);
void dev_file_name(char *);
int process_replaces(config_t *);
int read_dev(config_t *, const char *);
int read_token(char *, int, const char **);
int add_entry(config_t *, char *, const char *, int);
string_item_t *add_item(string_list_t *, const char *, int);
void sort_uniq(string_list_t *, bool);
void write_list(FILE *, const string_list_t *, const char *);
void write_list_pattern(FILE *, const string_list_t *, const string_pattern_t *);
bool var_expand(char *, char [MAX_STR], const config_t *);
void add_definition(const char *, const char *, string_list_t *, bool);
string_item_t *lookup(const char *, const string_list_t *);

int
main(int argc, char *argv[])
{
    config_t conf;
    char escape = '&amp;';
    int i;

    /* Allocate string lists. */
    conf = init_config;
    memcpy(conf.lists.indexed, init_config_lists,
	   sizeof(conf.lists.indexed));
    alloc_list(&amp;conf.file_names);
    alloc_list(&amp;conf.file_contents);
    alloc_list(&amp;conf.replaces);
    for (i = 0; i &lt; NUM_RESOURCE_LISTS; ++i)
	alloc_list(&amp;conf.lists.indexed[i]);

    /* Initialize patterns. */
    conf.lib_p.upper_case = false;
    conf.lib_p.drop_extn = false;
    strcpy(conf.lib_p.pattern, "%s\n");
    conf.libpath_p = conf.lib_p;
    conf.obj_p = conf.lib_p;

    /* Process command line arguments. */
    for (i = 1; i &lt; argc; i++) {
	const char *arg = argv[i];
	FILE *out;
	int lib = 0, obj = 0;

	if (*arg != '-') {
	    read_dev(&amp;conf, arg);
	    continue;
	}
	if (i == argc - 1) {
	    fprintf(stderr, "Missing argument after %s.\n",
		    arg);
	    exit(1);
	}
	switch (arg[1]) {
	    case 'C':		/* change directory, by analogy with make */
		conf.file_prefix =
		    (argv[i + 1][0] == '-' ? "" : argv[i + 1]);
		++i;
		continue;
	    case 'e':
		escape = argv[i + 1][0];
		++i;
		continue;
	    case 'n':
		conf.name_prefix =
		    (argv[i + 1][0] == '-' ? "" : argv[i + 1]);
		++i;
		continue;
	    case 'p':
		{
		    string_pattern_t *pat;

		    switch (*(arg += 2)) {
			case 'l':
			    pat = &amp;conf.lib_p;
			    break;
			case 'L':
			    pat = &amp;conf.libpath_p;
			    break;
			default:
			    pat = &amp;conf.obj_p;
			    arg--;
		    }
		    pat-&gt;upper_case = false;
		    pat-&gt;drop_extn = false;
		    if (argv[i + 1][0] == '-')
			strcpy(pat-&gt;pattern, "%s\n");
		    else {
			char *p, *q;

			for (p = pat-&gt;pattern, q = argv[++i];
			     (*p++ = *q++) != 0;
			    )
			    if (p[-1] == escape)
				switch (*q) {
				    case 'p':
					p[-1] = '%'; q++; break;
				    case 's':
					p[-1] = ' '; q++; break;
				    case '-':
					p[-1] = '-'; q++; break;
				    default:
					if (*q == escape) {
					    p[-1] = '\\'; q++; break;
					}
					fprintf(stderr,
					  "%c not followed by p|s|%c|-: &amp;%c\n",
						escape, escape, *q);
					exit(1);
				}
			p[-1] = '\n';
			*p = 0;
		    }
		    for (;;) {
			switch (*++arg) {
			    case 'u':
				pat-&gt;upper_case = true;
				break;
			    case 'e':
				pat-&gt;drop_extn = true;
				break;
			    case 0:
				goto pbreak;
			    default:
				fprintf(stderr, "Unknown switch %s.\n", arg);
				exit(1);
			}
		    }
		  pbreak:if (pat == &amp;conf.obj_p) {
			conf.lib_p = *pat;
			conf.libpath_p = *pat;
		    }
		    continue;
		}
	    case 'Z':
		conf.debug = 1;
		continue;
	}
	/* Must be an output file. */
	out = fopen(argv[++i], "w");
	if (out == 0) {
	    fprintf(stderr, "Can't open %s for output.\n",
		    argv[i]);
	    exit(1);
	}
	switch (arg[1]) {
	    case 'f':
		process_replaces(&amp;conf);
		fputs("/* This file was generated automatically by genconf.c. */\n", out);
		fputs("/* For documentation, see gsconfig.c. */\n", out);
		{
		    char template[80];

		    sprintf(template,
			    "font_(\"0.font_%%s\",%sf_%%s,zf_%%s)\n",
			    conf.name_prefix);
		    write_list(out, &amp;conf.lists.named.fonts, template);
		}
		break;
	    case 'h':
		process_replaces(&amp;conf);
		fputs("/* This file was generated automatically by genconf.c. */\n", out);
		write_list(out, &amp;conf.lists.named.compositors, "%s\n");
		write_list(out, &amp;conf.lists.named.devs, "%s\n");
		sort_uniq(&amp;conf.lists.named.resources, true);
		write_list(out, &amp;conf.lists.named.resources, "%s\n");
		sort_uniq(&amp;conf.lists.named.sorted_resources, false);
		write_list(out, &amp;conf.lists.named.sorted_resources, "%s\n");
		break;
	    case 'l':
		lib = 1;
		obj = arg[2] == 'o';
		goto lo;
	    case 'o':
		obj = 1;
		lib = arg[2] == 'l';
	      lo:process_replaces(&amp;conf);
		if (obj) {
		    sort_uniq(&amp;conf.lists.named.objs, true);
		    write_list_pattern(out, &amp;conf.lists.named.objs, &amp;conf.obj_p);
		}
		if (lib) {
		    sort_uniq(&amp;conf.lists.named.libs, true);
		    sort_uniq(&amp;conf.lists.named.links, true);
		    write_list_pattern(out, &amp;conf.lists.named.libpaths, &amp;conf.libpath_p);
		    write_list_pattern(out, &amp;conf.lists.named.links, &amp;conf.obj_p);
		    write_list_pattern(out, &amp;conf.lists.named.libs, &amp;conf.lib_p);
		}
		break;
	    default:
		fclose(out);
		fprintf(stderr, "Unknown switch %s.\n", argv[i]);
		exit(1);
	}
	fclose(out);
    }

    return 0;
}

/*
 * We would like to use the real realloc, but it doesn't work on all systems
 * (e.g., some Linux versions).  Also, this procedure does the right thing
 * if old_ptr = NULL.
 */
private void *
mrealloc(void *old_ptr, size_t old_size, size_t new_size)
{
    void *new_ptr = malloc(new_size);

    if (new_ptr == NULL)
	return NULL;
    /* We have to pass in the old size, since we have no way to */
    /* determine it otherwise. */
    if (old_ptr)
	memcpy(new_ptr, old_ptr, min(old_size, new_size));
    return new_ptr;
}

/* Allocate and initialize a string list. */
int
alloc_list(string_list_t * list)
{
    list-&gt;count = 0;
    list-&gt;items =
	(string_item_t *) calloc(list-&gt;max_count, sizeof(string_item_t));
    assert(list-&gt;items != NULL);
    return 0;
}

/* If necessary, convert a .dev name to its file name. */
void
dev_file_name(char *str)
{
    int len = strlen(str);

    if (len &lt;= 4 || strcmp(".dev", str + len - 4))
	strcat(str, ".dev");
}

/* Delete any files that are named as -replace "resources". */
int
process_replaces(config_t * pconf)
{
    char bufname[MAX_STR];
    int i;

    for (i = 0; i &lt; pconf-&gt;replaces.count; ++i) {
	int j;

	strcpy(bufname, pconf-&gt;replaces.items[i].str);
	/* See if the file being replaced was included. */
	dev_file_name(bufname);
	for (j = 0; j &lt; pconf-&gt;file_names.count; ++j) {
	    const char *fname = pconf-&gt;file_names.items[j].str;

	    if (!strcmp(fname, bufname)) {
		if (pconf-&gt;debug)
		    printf("Replacing file %s.\n", fname);
		/* Delete all resources associated with this file. */
		{
		    int rn;

		    for (rn = 0; rn &lt; NUM_RESOURCE_LISTS; ++rn) {
			string_item_t *items = pconf-&gt;lists.indexed[rn].items;
			int count = pconf-&gt;lists.indexed[rn].count;
			int tn;

			for (tn = 0; tn &lt; count; ++tn) {
			    if (items[tn].file_index == j) {
				/*
				 * Delete the item.  Since we haven't sorted
				 * the items yet, just replace this item
				 * with the last one, but make sure we don't
				 * miss scanning it.
				 */
				if (pconf-&gt;debug)
				    printf("Replacing %s %s.\n",
					 pconf-&gt;lists.indexed[rn].list_name,
					   items[tn].str);
				items[tn--] = items[--count];
			    }
			}
			pconf-&gt;lists.indexed[rn].count = count;
		    }
		}
		pconf-&gt;file_names.items[j].str = "";
		break;
	    }
	}
    }
    /* Don't process the replaces again. */
    pconf-&gt;replaces.count = 0;
    return 0;
}

/*
 * Read an entire file into memory.
 * We use the 'index' of the file_contents string_item_t to record the union
 * of the uniq_mode_ts of all (direct and indirect) items in the file.
 * Return the file_contents item for the file.
 */
private string_item_t *
read_file(config_t * pconf, const char *fname)
{
    char *cname = malloc(strlen(fname) + strlen(pconf-&gt;file_prefix) + 1);
    int i;
    FILE *in;
    int end, nread;
    char *cont;
    string_item_t *item;

    if (cname == 0) {
	fprintf(stderr, "Can't allocate space for file name %s%s.\n",
		pconf-&gt;file_prefix, fname);
	exit(1);
    }
    strcpy(cname, pconf-&gt;file_prefix);
    strcat(cname, fname);
    for (i = 0; i &lt; pconf-&gt;file_names.count; ++i)
	if (!strcmp(pconf-&gt;file_names.items[i].str, cname)) {
	    free(cname);
	    return &amp;pconf-&gt;file_contents.items[i];
	}
    /* Try to open the file in binary mode, to avoid the overhead */
    /* of unnecessary EOL conversion in the C library. */
    in = fopen(cname, "rb");
    if (in == 0) {
	in = fopen(cname, "r");
	if (in == 0) {
	    fprintf(stderr, "Can't read %s.\n", cname);
	    exit(1);
	}
    }
    fseek(in, 0L, 2 /*SEEK_END */ );
    end = ftell(in);
    cont = malloc(end + 1);
    if (cont == 0) {
	fprintf(stderr, "Can't allocate %d bytes to read %s.\n",
		end + 1, cname);
	exit(1);
    }
    rewind(in);
    nread = fread(cont, 1, end, in);
    fclose(in);
    cont[nread] = 0;
    if (pconf-&gt;debug)
	printf("File %s = %d bytes.\n", cname, nread);
    add_item(&amp;pconf-&gt;file_names, cname, -1);
    item = add_item(&amp;pconf-&gt;file_contents, cont, -1);
    item-&gt;index = 0;		/* union of uniq_mode_ts */
    return item;
}

/* Read and parse a .dev file.  Return the union of all its uniq_mode_ts. */
int
read_dev(config_t * pconf, const char *arg)
{
    string_item_t *item;
    const char *in;

#define MAX_TOKEN 256
    char *token = malloc(MAX_TOKEN + 1);
    char *category = malloc(MAX_TOKEN + 1);
    int file_index;
    int len;

    if (pconf-&gt;debug)
	printf("Reading %s;\n", arg);
    item = read_file(pconf, arg);
    if (item-&gt;index == uniq_first) {	/* Don't need to read the file again. */
	if (pconf-&gt;debug)
	    printf("Skipping duplicate file.\n");
	return uniq_first;
    }
    in = item-&gt;str;
    file_index = item - pconf-&gt;file_contents.items;
    strcpy(category, "obj");
    while ((len = read_token(token, MAX_TOKEN, &amp;in)) &gt; 0)
	item-&gt;index |= add_entry(pconf, category, token, file_index);
    free(category);
#undef MAX_TOKEN
    if (len &lt; 0) {
	fprintf(stderr, "Token too long: %s.\n", token);
	exit(1);
    }
    if (pconf-&gt;debug)
	printf("Finished %s.\n", arg);
    free(token);
    return item-&gt;index;
}

/* Read a token from a string that contains the contents of a file. */
int
read_token(char *token, int max_len, const char **pin)
{
    const char *in = *pin;
    int len = 0;

    while (len &lt; max_len) {
	char ch = *in;

	if (ch == 0)
	    break;
	++in;
	if (isspace(ch)) {
	    if (len &gt; 0)
		break;
	    continue;
	}
	token[len++] = ch;
    }
    token[len] = 0;
    *pin = in;
    return (len &gt;= max_len ? -1 /* token too long */ : len);
}

/* Add an entry to a configuration.  Return its uniq_mode_t. */
int
add_entry(config_t * pconf, char *category, const char *item, int file_index)
{
    if (item[0] == '-' &amp;&amp; islower(item[1])) {	/* set category */
	strcpy(category, item + 1);
	return 0;
    } else {			/* add to current category */
	char str[MAX_STR];
	char template[80];
	const char *pat = 0;
	string_list_t *list = &amp;pconf-&gt;lists.named.resources;

	if (pconf-&gt;debug)
	    printf("Adding %s %s;\n", category, item);
	/* Handle a few resources specially; just queue the rest. */
	switch (category[0]) {
#define IS_CAT(str) !strcmp(category, str)
	    case 'c':
		if (!IS_CAT("comp"))
		    goto err;
		pat = "compositor_(%scomposite_%%s_type)";
		list = &amp;pconf-&gt;lists.named.compositors;
		goto pre;
	    case 'd':
		if (IS_CAT("dev"))
		    pat = "device_(%s%%s_device)";
		else if (IS_CAT("dev2"))
		    pat = "device2_(%s%%s_device)";
		else
		    goto err;
		list = &amp;pconf-&gt;lists.named.devs;
pre:		sprintf(template, pat, pconf-&gt;name_prefix);
		pat = template;
		break;
	    case 'e':
		if (IS_CAT("emulator")) {
		    sprintf(str, "emulator_(\"%s\",%u)",
			    item, (uint)strlen(item));
		    item = str;
		    break;
		}
		goto err;
	    case 'f':
		if (IS_CAT("font")) {
		    list = &amp;pconf-&gt;lists.named.fonts;
		    break;
		} else if (IS_CAT("functiontype")) {
		    pat = "function_type_(%%s,%sbuild_function_%%s)";
		} else
		    goto err;
		goto pre;
	    case 'h':
		if (IS_CAT("halftone")) {
		    pat = "halftone_(%sdht_%%s)";
		} else
		    goto err;
		goto pre;
	    case 'i':
		if (IS_CAT("imageclass")) {
		    list = &amp;pconf-&gt;lists.named.sorted_resources;
		    pat = "image_class_(%simage_class_%%s)";
		} else if (IS_CAT("imagetype")) {
		    pat = "image_type_(%%s,%simage_type_%%s)";
		} else if (IS_CAT("include")) {
		    strcpy(str, item);
		    dev_file_name(str);
		    return read_dev(pconf, str);
		} else if (IS_CAT("init")) {
		    pat = "init_(%s%%s_init)";
		} else if (IS_CAT("iodev")) {
		    pat = "io_device_(%siodev_%%s)";
		} else
		    goto err;
		goto pre;
	    case 'l':
		if (IS_CAT("lib")) {
		    list = &amp;pconf-&gt;lists.named.libs;
		    break;
		} else if (IS_CAT("libpath")) {
		    list = &amp;pconf-&gt;lists.named.libpaths;
		    break;
		} else if (IS_CAT("link")) {
		    list = &amp;pconf-&gt;lists.named.links;
		    break;
		}
		goto err;
	    case 'o':
		if (IS_CAT("obj")) {
		    list = &amp;pconf-&gt;lists.named.objs;
		    strcpy(template, pconf-&gt;file_prefix);
		    strcat(template, "%s");
		    pat = template;
		    break;
		}
		if (IS_CAT("oper")) {
		    pat = "oper_(%s_op_defs)";
		    break;
		}
		goto err;
	    case 'p':
		if (IS_CAT("ps")) {
		    sprintf(str, "psfile_(\"%s.ps\",%u)",
			    item, (uint)(strlen(item) + 3));
		    item = str;
		    break;
		} else if (IS_CAT("plugin")) {
		    pat = "plugin_(%s%%s_instantiate)";
                    goto pre;
                }
		goto err;
	    case 'r':
		if (IS_CAT("replace")) {
		    list = &amp;pconf-&gt;replaces;
		    break;
		}
		goto err;
#undef IS_CAT
	    default:
err:		fprintf(stderr, "Definition not recognized: %s %s.\n",
			category, item);
		exit(1);
	}
	if (pat) {
	    sprintf(str, pat, item, item);
	    assert(strlen(str) &lt; MAX_STR);
	    add_item(list, str, file_index);
	} else
	    add_item(list, item, file_index);
	return list-&gt;mode;
    }
}

/* Add an item to a list. */
string_item_t *
add_item(string_list_t * list, const char *str, int file_index)
{
    char *rstr = malloc(strlen(str) + 1);
    int count = list-&gt;count;
    string_item_t *item;

    if (count &gt;= list-&gt;max_count) {
	list-&gt;max_count &lt;&lt;= 1;
	if (list-&gt;max_count &lt; 20)
	    list-&gt;max_count = 20;
	list-&gt;items =
	    (string_item_t *) mrealloc(list-&gt;items,
				     (list-&gt;max_count &gt;&gt; 1) *
				     sizeof(string_item_t),
				     list-&gt;max_count *
				     sizeof(string_item_t));
	assert(list-&gt;items != NULL);
    }
    item = &amp;list-&gt;items[count];
    item-&gt;str = rstr;
    item-&gt;index = count;
    item-&gt;file_index = file_index;
    strcpy(rstr, str);
    list-&gt;count++;
    return item;
}

/*
 * Remove duplicates from a list of string_item_ts.
 * In case of duplicates, remove all but the earliest (if last = false)
 * or the latest (if last = true).
 */
private int
cmp_index(const void *p1, const void *p2)
{
    const string_item_t *const psi1 = (const string_item_t *)p1;
    const string_item_t *const psi2 = (const string_item_t *)p2;
    int cmp = psi1-&gt;index - psi2-&gt;index;

    return (cmp &lt; 0 ? -1 : cmp &gt; 0 ? 1 : 0);
}
private int
cmp_str(const void *p1, const void *p2)
{
    const string_item_t *const psi1 = (const string_item_t *)p1;
    const string_item_t *const psi2 = (const string_item_t *)p2;

    return strcmp(psi1-&gt;str, psi2-&gt;str);
}
void
sort_uniq(string_list_t * list, bool by_index)
{
    string_item_t *strlist = list-&gt;items;
    int count = list-&gt;count;
    const string_item_t *from;
    string_item_t *to;
    int i;
    bool last = list-&gt;mode == uniq_last;

    if (count == 0)
	return;
    qsort((char *)strlist, count, sizeof(string_item_t), cmp_str);
    for (from = to = strlist + 1, i = 1; i &lt; count; from++, i++)
	if (strcmp(from-&gt;str, to[-1].str))
	    *to++ = *from;
	else if ((last ? from-&gt;index &gt; to[-1].index :
		  from-&gt;index &lt; to[-1].index)
	    )
	    to[-1] = *from;
    count = to - strlist;
    list-&gt;count = count;
    if (by_index)
	qsort((char *)strlist, count, sizeof(string_item_t), cmp_index);
}

/* Write a list of strings using a template. */
void
write_list(FILE * out, const string_list_t * list, const char *pstr)
{
    string_pattern_t pat;

    pat.upper_case = false;
    pat.drop_extn = false;
    strcpy(pat.pattern, pstr);
    write_list_pattern(out, list, &amp;pat);
}
void
write_list_pattern(FILE * out, const string_list_t * list,
		   const string_pattern_t * pat)
{
    int i;
    char macname[40];
    int plen = strlen(pat-&gt;pattern);

    *macname = 0;
    for (i = 0; i &lt; list-&gt;count; i++) {
	const char *lstr = list-&gt;items[i].str;
	int len = strlen(lstr);
	char *str = malloc(len + 1);
	int xlen = plen + len * 3;
	char *xstr = malloc(xlen + 1);
	char *alist;

	strcpy(str, lstr);
	if (pat-&gt;drop_extn) {
	    char *dot = str + len;

	    while (dot &gt; str &amp;&amp; *dot != '.')
		dot--;
	    if (dot &gt; str)
		*dot = 0, len = dot - str;
	}
	if (pat-&gt;upper_case) {
	    char *ptr = str;

	    for (; *ptr; ptr++)
		if (islower(*ptr))
		    *ptr = toupper(*ptr);
	}
	/* We repeat str for the benefit of patterns that */
	/* need the argument substituted in more than one place. */
	sprintf(xstr, pat-&gt;pattern, str, str, str);
	/* Check to make sure the item is within the scope of */
	/* an appropriate #ifdef, if necessary. */
	alist = strchr(xstr, '(');
	if (alist != 0 &amp;&amp; alist != xstr &amp;&amp; alist[-1] == '_') {
	    *alist = 0;
	    if (strcmp(xstr, macname)) {
		if (*macname)
		    fputs("#endif\n", out);
		fprintf(out, "#ifdef %s\n", xstr);
		strcpy(macname, xstr);
	    }
	    *alist = '(';
	} else {
	    if (*macname) {
		fputs("#endif\n", out);
		*macname = 0;
	    }
	}
	fputs(xstr, out);
	free(xstr);
	free(str);
    }
    if (*macname)
	fputs("#endif\n", out);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

