<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gp_unix_cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gp_unix_cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2003-2004 artofcode LLC. All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gp_unix_cache.c,v 1.3 2004/07/14 15:34:25 giles Exp $ */
/* Generic POSIX persistent-cache implementation for Ghostscript */

#include "stdio_.h"
#include "string_.h"
#include "time_.h"
#include &lt;stdlib.h&gt; /* should use gs_malloc() instead */
#include "gconfigd.h"
#include "gp.h"
#include "md5.h"

/* ------ Persistent data cache types ------*/

#define GP_CACHE_VERSION 0

/* cache entry type */
typedef struct gp_cache_entry_s {
    int type;
    int keylen;
    byte *key;
    md5_byte_t hash[16];
    char *filename;
    int len;
    void *buffer;
    int dirty;
    time_t last_used;
} gp_cache_entry;

/* initialize a new gp_cache_entry struct */
private void gp_cache_clear_entry(gp_cache_entry *item)
{
    item-&gt;type = -1;
    item-&gt;key = NULL;
    item-&gt;keylen = 0;
    item-&gt;filename = NULL;
    item-&gt;buffer = NULL;
    item-&gt;len = 0;
    item-&gt;dirty = 0;
    item-&gt;last_used = 0;
}

/* get the cache directory's path */
private char *gp_cache_prefix(void)
{
    char *prefix = NULL;
    int plen = 0;
    
    /* get the cache directory path */
    if (gp_getenv("GS_CACHE_DIR", (char *)NULL, &amp;plen) &lt; 0) {
        prefix = malloc(plen);
        gp_getenv("GS_CACHE_DIR", prefix, &amp;plen);
        plen--;
    } else {
#ifdef GS_CACHE_DIR
        prefix = strdup(GS_CACHE_DIR);
#else
        prefix = strdup(".cache");
#endif
        plen = strlen(prefix);
    }
    
    /* substitute $HOME for '~' */
    if (plen &gt; 1 &amp;&amp; prefix[0] == '~') {
        char *home, *path;
        int hlen = 0;
	unsigned int pathlen = 0;
        gp_file_name_combine_result result;
        
        if (gp_getenv("HOME", (char *)NULL, &amp;hlen) &lt; 0) {
            home = malloc(hlen);
            if (home == NULL) return prefix;
            gp_getenv("HOME", home, &amp;hlen);
            hlen--;
            if (plen == 1) {
                /* only "~" */
                free(prefix);
                return home;
            }
            /* substitue for the initial '~' */
            pathlen = hlen + plen + 1;
            path = malloc(pathlen);
            if (path == NULL) { free(home); return prefix; }
            result = gp_file_name_combine(home, hlen, prefix+2, plen-2, false, path, &amp;pathlen);
            if (result == gp_combine_success) {
                free(prefix);
                prefix = path;
            } else {
                dlprintf1("file_name_combine failed with code %d\n", result);
            }
            free(home);
        }
    }
#ifdef DEBUG_CACHE    
    dlprintf1("cache dir read as '%s'\n", prefix);
#endif
    return prefix;
}

/* compute the cache index file's path */
private char *
gp_cache_indexfilename(const char *prefix)
{
    const char *fn = "gs_cache";
    char *path;
    unsigned int len;
    gp_file_name_combine_result result;
    
    len = strlen(prefix) + strlen(fn) + 2;
    path = malloc(len);
    
    result = gp_file_name_combine(prefix, strlen(prefix), fn, strlen(fn), true, path, &amp;len);
    if (result == gp_combine_small_buffer) {
        /* handle the case when the combination requires more than one extra character */
        free(path);
        path = malloc(++len);
        result = gp_file_name_combine(prefix, strlen(prefix), fn, strlen(fn), true, path, &amp;len);
    }
    if (result != gp_combine_success) {
        dlprintf1("pcache: file_name_combine for indexfilename failed with code %d\n", result);
        free(path);
        return NULL;
    }
    return path;
}

/* compute and set a cache key's hash */
private void gp_cache_hash(gp_cache_entry *entry)
{
    md5_state_t md5;
    
    /* we use md5 hashes of the key */
    md5_init(&amp;md5);
    md5_append(&amp;md5, entry-&gt;key, entry-&gt;keylen);
    md5_finish(&amp;md5, entry-&gt;hash);
}

/* compute and set cache item's filename */
private void gp_cache_filename(const char *prefix, gp_cache_entry *item)
{
    const char hexmap[16] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
    char *fn = malloc(gp_file_name_sizeof), *fni;
    int i;
       
    fni = fn;
    *fni++ = hexmap[item-&gt;type&gt;&gt;4 &amp; 0x0F];
    *fni++ = hexmap[item-&gt;type &amp; 0x0F];
    *fni++ = '.';
    for (i = 0; i &lt; 16; i++) {
        *fni++ = hexmap[(item-&gt;hash[i]&gt;&gt;4 &amp; 0x0F)];
        *fni++ = hexmap[(item-&gt;hash[i] &amp; 0x0F)];
    }
    *fni = '\0';
    
    if (item-&gt;filename) free(item-&gt;filename);
    item-&gt;filename = fn;
}

/* generate an access path for a cache item */
private char *gp_cache_itempath(const char *prefix, gp_cache_entry *item)
{
    const char *fn = item-&gt;filename;
    gp_file_name_combine_result result;
    char *path;
    unsigned int len;
    
    len = strlen(prefix) + strlen(fn) + 2;
    path = malloc(len);
    result = gp_file_name_combine(prefix, strlen(prefix), 
        fn, strlen(fn), false, path, &amp;len);

    if (result != gp_combine_success) {
        dlprintf1("pcache: file_name_combine failed on cache item filename with code %d\n", result);
    }
    
    return path;
}

private int gp_cache_saveitem(FILE *file, gp_cache_entry* item)
{
    unsigned char version = 0;
    int ret;

#ifdef DEBUG_CACHE
    dlprintf2("pcache: saving key with version %d, data length %d\n", version, item-&gt;len);
#endif
    ret = fwrite(&amp;version, 1, 1, file);
    ret = fwrite(&amp;(item-&gt;keylen), 1, sizeof(item-&gt;keylen), file);
    ret = fwrite(item-&gt;key, 1, item-&gt;keylen, file);
    ret = fwrite(&amp;(item-&gt;len), 1, sizeof(item-&gt;len), file);
    ret = fwrite(item-&gt;buffer, 1, item-&gt;len, file);
    item-&gt;dirty = 0;
    return ret;
}

private int gp_cache_loaditem(FILE *file, gp_cache_entry *item, gp_cache_alloc alloc, void *userdata)
{
    unsigned char version;
    unsigned char *filekey = NULL;
    int len, keylen;
    
    fread(&amp;version, 1, 1, file);
    if (version != GP_CACHE_VERSION) {
#ifdef DEBUG_CACHE
        dlprintf2("pcache file version mismatch (%d vs expected %d)\n", version, GP_CACHE_VERSION);
#endif
        return -1;
    }
    fread(&amp;keylen, 1, sizeof(keylen), file);
    if (keylen != item-&gt;keylen) {
#ifdef DEBUG_CACHE
        dlprintf2("pcache file has correct hash but wrong key length (%d vs %d)\n",
            keylen, item-&gt;keylen);
#endif
        return -1;
    }
    filekey = malloc(keylen);
    if (filekey != NULL)
        fread(filekey, 1, keylen, file);
    if (memcmp(filekey, item-&gt;key, keylen)) {
#ifdef DEBUG_CACHE
        dlprintf("pcache file has correct hash but doesn't match the full key\n");
#endif
        free(filekey);
        item-&gt;buffer = NULL;
        item-&gt;len = 0;
        return -1;
    }
    free(filekey);
    
    fread(&amp;len, 1, sizeof(len), file);
#ifdef DEBUG_CACHE
    dlprintf2("key matches file with version %d, data length %d\n", version, len);
#endif
    item-&gt;buffer = alloc(userdata, len);
    if (item-&gt;buffer == NULL) {
        dlprintf("pcache: unable to allocate buffer for file data!\n");
        return -1;
    }
    
    item-&gt;len = fread(item-&gt;buffer, 1, len, file);
    item-&gt;dirty = 1;
    item-&gt;last_used = time(NULL);
    
    return 0;
}

/* convert a two-character hex string to an integer */
private int readhexbyte(const char *s)
{
    const char hexmap[16] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
    int i,r;
    
    for (i = 0; i &lt; 16; i++)
        if (hexmap[i] == *s) break;
    if (i == 16) return -1;
    r = i;
    s++;
    for (i = 0; i &lt; 16; i++)
        if (hexmap[i] == *s) break;
    if (i == 16) return -1;
    r = r&lt;&lt;4 | i;
    return r;
}

private int
gp_cache_read_entry(FILE *file, gp_cache_entry *item)
{
    char line[256];
    char fn[32];
    int i;
    
    if (!fgets(line, 256, file)) return -1;
    
    /* skip comments */
    if (line[0] == '#') return 1;
    
    /* otherwise, parse the line */
    sscanf(line, "%s %ld\n", fn, &amp;item-&gt;last_used);
    /* unpack the type from the filename */
    item-&gt;type = readhexbyte(fn);
    /* unpack the md5 hash from the filename */
    for (i = 0; i &lt; 16; i++)
        item-&gt;hash[i] = readhexbyte(fn + 3 + 2*i);
    /* remember the filename */    
    if (item-&gt;filename) free(item-&gt;filename);
    item-&gt;filename = malloc(strlen(fn) + 1);
    memcpy(item-&gt;filename, fn, strlen(fn));
    /* null other fields */
    item-&gt;key = NULL;
    item-&gt;keylen = 0;
    item-&gt;len = 0;
    item-&gt;buffer = NULL;
        
    return 0;
}

private int
gp_cache_write_entry(FILE *file, gp_cache_entry *item)
{
    fprintf(file, "%s %ld\n", item-&gt;filename, item-&gt;last_used);
    return 0;
}


/* insert a buffer under a (type, key) pair */
int gp_cache_insert(int type, byte *key, int keylen, void *buffer, int buflen)
{
    char *prefix, *path;
    char *infn,*outfn;
    FILE *file, *in, *out;
    gp_cache_entry item, item2;
    int code, hit = 0;
    
    prefix = gp_cache_prefix();
    infn = gp_cache_indexfilename(prefix);
    {
        int len = strlen(infn) + 2;
        outfn = malloc(len);
        memcpy(outfn, infn, len - 2);
        outfn[len-2] = '+';
        outfn[len-1] = '\0';
    }
    
    in = fopen(infn, "r");
    if (in == NULL) {
        dlprintf1("pcache: unable to open '%s'\n", infn);
        return -1;
    }
    out = fopen(outfn, "w");
    if (out == NULL) {
        dlprintf1("pcache: unable to open '%s'\n", outfn);
        return -1;
    }
        
    fprintf(out, "# Ghostscript persistent cache index table\n");

    /* construct our cache item */
    gp_cache_clear_entry(&amp;item);
    item.type = type;
    item.key = key;
    item.keylen = keylen;
    item.buffer = buffer;
    item.len = buflen;
    item.dirty = 1;
    item.last_used = time(NULL);
    gp_cache_hash(&amp;item);
    gp_cache_filename(prefix, &amp;item);
    
    /* save it to disk */
    path = gp_cache_itempath(prefix, &amp;item);
    file = fopen(path, "wb");
    if (file != NULL) {
        gp_cache_saveitem(file, &amp;item);
        fclose(file);
    }
    
    /* now loop through the index to update or insert the entry */
    gp_cache_clear_entry(&amp;item2);
    while ((code = gp_cache_read_entry(in, &amp;item2)) &gt;= 0) {
        if (code == 1) continue;
        if (!memcmp(item.hash, item2.hash, 16)) {
            /* replace the matching line */
            gp_cache_write_entry(out, &amp;item);
            hit = 1;
        } else {
            /* copy out the previous line */
            gp_cache_write_entry(out, &amp;item2);
        }
    }
    if (!hit) {
        /* there was no matching line */
        gp_cache_write_entry(out, &amp;item);
    }
    free(item.filename);
    fclose(out);
    fclose(in);
    
    /* replace the cache index with our new version */
    unlink(infn);
    rename(outfn,infn);
    
    free(prefix);
    free(infn);
    free(outfn);
    
    return 0;
}

int gp_cache_query(int type, byte* key, int keylen, void **buffer,
    gp_cache_alloc alloc, void *userdata)
{
    char *prefix, *path;
    char *infn,*outfn;
    FILE *file, *in, *out;
    gp_cache_entry item, item2;
    int code, hit = 0;
    
    prefix = gp_cache_prefix();
    infn = gp_cache_indexfilename(prefix);
    {
        int len = strlen(infn) + 2;
        outfn = malloc(len);
        memcpy(outfn, infn, len - 2);
        outfn[len-2] = '+';
        outfn[len-1] = '\0';
    }
    
    in = fopen(infn, "r");
    if (in == NULL) {
        dlprintf1("pcache: unable to open '%s'\n", infn);
        return -1;
    }
    out = fopen(outfn, "w");
    if (out == NULL) {
        dlprintf1("pcache: unable to open '%s'\n", outfn);
        return -1;
    }
        
    fprintf(out, "# Ghostscript persistent cache index table\n");

    /* construct our query */
    gp_cache_clear_entry(&amp;item);
    item.type = type;
    item.key = key;
    item.keylen = keylen;
    item.last_used = time(NULL);
    gp_cache_hash(&amp;item);
    gp_cache_filename(prefix, &amp;item);
    
    /* look for it on the disk */
    path = gp_cache_itempath(prefix, &amp;item);
    file = fopen(path, "rb");
    if (file != NULL) {
        hit = gp_cache_loaditem(file, &amp;item, alloc, userdata);
        fclose(file);
    } else {
        hit = -1;
    }
    
    gp_cache_clear_entry(&amp;item2);
    while ((code = gp_cache_read_entry(in, &amp;item2)) &gt;= 0) {
        if (code == 1) continue;
        if (!hit &amp;&amp; !memcmp(item.hash, item2.hash, 16)) {
            /* replace the matching line */
            gp_cache_write_entry(out, &amp;item);
            item.dirty = 0;
        } else {
            /* copy out the previous line */
            gp_cache_write_entry(out, &amp;item2);
        }
    }
    if (item.dirty) {
        /* there was no matching line -- shouldn't happen */
        gp_cache_write_entry(out, &amp;item);
    }
    free(item.filename);
    fclose(out);
    fclose(in);
    
    /* replace the cache index with our new version */
    unlink(infn);
    rename(outfn,infn);
    
    free(prefix);
    free(infn);
    free(outfn);
    
    if (!hit) {
        *buffer = item.buffer;
        return item.len;
    } else {
        *buffer = NULL;
        return -1;
    }
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

