<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gscoord.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gscoord.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gscoord.c,v 1.9 2004/03/13 18:28:52 igor Exp $ */
/* Coordinate system operators for Ghostscript library */
#include "math_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsccode.h"		/* for gxfont.h */
#include "gxfarith.h"
#include "gxfixed.h"
#include "gxmatrix.h"
#include "gxfont.h"		/* for char_tm */
#include "gxpath.h"		/* for gx_path_translate */
#include "gzstate.h"
#include "gxcoord.h"		/* requires gsmatrix, gsstate */
#include "gxdevice.h"

/* Choose whether to enable the rounding code in update_ctm. */
#define ROUND_CTM_FIXED 1

/* Forward declarations */
#ifdef DEBUG
#define trace_ctm(pgs) trace_matrix_fixed(&amp;(pgs)-&gt;ctm)
private void trace_matrix_fixed(const gs_matrix_fixed *);
private void trace_matrix(const gs_matrix *);

#endif

/* Macro for ensuring ctm_inverse is valid */
#ifdef DEBUG
#  define print_inverse(pgs)\
     if ( gs_debug_c('x') )\
       dlprintf("[x]Inverting:\n"), trace_ctm(pgs), trace_matrix(&amp;pgs-&gt;ctm_inverse)
#else
#  define print_inverse(pgs) DO_NOTHING
#endif
#define ensure_inverse_valid(pgs)\
	if ( !pgs-&gt;ctm_inverse_valid )\
	   {	int code = ctm_set_inverse(pgs);\
		if ( code &lt; 0 ) return code;\
	   }

private int
ctm_set_inverse(gs_state * pgs)
{
    int code = gs_matrix_invert(&amp;ctm_only(pgs), &amp;pgs-&gt;ctm_inverse);

    print_inverse(pgs);
    if (code &lt; 0)
	return code;
    pgs-&gt;ctm_inverse_valid = true;
    return 0;
}

/* Machinery for updating fixed version of ctm. */
/*
 * We (conditionally) adjust the floating point translation
 * so that it exactly matches the (rounded) fixed translation.
 * This avoids certain unpleasant rounding anomalies, such as
 * 0 0 moveto currentpoint not returning 0 0, and () stringwidth
 * not returning 0 0.
 */
#if ROUND_CTM_FIXED
#  define update_t_fixed(mat, t, t_fixed, v)\
    (set_float2fixed_vars((mat).t_fixed, v),\
     set_fixed2float_var((mat).t, (mat).t_fixed))
#else /* !ROUND_CTM_FIXED */
#  define update_t_fixed(mat, t, t_fixed, v)\
    ((mat).t = (v),\
     set_float2fixed_vars((mat).t_fixed, (mat).t))
#endif /* (!)ROUND_CTM_FIXED */
#define f_fits_in_fixed(f) f_fits_in_bits(f, fixed_int_bits)
#define update_matrix_fixed(mat, xt, yt)\
  ((mat).txy_fixed_valid = (f_fits_in_fixed(xt) &amp;&amp; f_fits_in_fixed(yt) ?\
			    (update_t_fixed(mat, tx, tx_fixed, xt),\
			     update_t_fixed(mat, ty, ty_fixed, yt), true) :\
			    ((mat).tx = (xt), (mat).ty = (yt), false)))
#define update_ctm(pgs, xt, yt)\
  (pgs-&gt;ctm_inverse_valid = false,\
   pgs-&gt;char_tm_valid = false,\
   update_matrix_fixed(pgs-&gt;ctm, xt, yt))

/* ------ Coordinate system definition ------ */

int
gs_initmatrix(gs_state * pgs)
{
    gs_matrix imat;

    gs_defaultmatrix(pgs, &amp;imat);
    update_ctm(pgs, imat.tx, imat.ty);
    set_ctm_only(pgs, imat);
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf("[x]initmatrix:\n"), trace_ctm(pgs);
#endif
    return 0;
}

int
gs_defaultmatrix(const gs_state * pgs, gs_matrix * pmat)
{
    gx_device *dev;

    if (pgs-&gt;ctm_default_set) {	/* set after Install */
	*pmat = pgs-&gt;ctm_default;
	return 1;
    }
    dev = gs_currentdevice_inline(pgs);
    gs_deviceinitialmatrix(dev, pmat);
    /* Add in the translation for the Margins. */
    pmat-&gt;tx += dev-&gt;Margins[0] *
	dev-&gt;HWResolution[0] / dev-&gt;MarginsHWResolution[0];
    pmat-&gt;ty += dev-&gt;Margins[1] *
	dev-&gt;HWResolution[1] / dev-&gt;MarginsHWResolution[1];
    return 0;
}

int
gs_setdefaultmatrix(gs_state * pgs, const gs_matrix * pmat)
{
    if (pmat == NULL)
	pgs-&gt;ctm_default_set = false;
    else {
	pgs-&gt;ctm_default = *pmat;
	pgs-&gt;ctm_default_set = true;
    }
    return 0;
}

int
gs_currentmatrix(const gs_state * pgs, gs_matrix * pmat)
{
    *pmat = ctm_only(pgs);
    return 0;
}

/* Set the current transformation matrix for rendering text. */
/* Note that this may be based on a font other than the current font. */
int
gs_setcharmatrix(gs_state * pgs, const gs_matrix * pmat)
{
    gs_matrix cmat;
    int code = gs_matrix_multiply(pmat, &amp;ctm_only(pgs), &amp;cmat);

    if (code &lt; 0)
	return code;
    update_matrix_fixed(pgs-&gt;char_tm, cmat.tx, cmat.ty);
    char_tm_only(pgs) = cmat;
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf("[x]setting char_tm:"), trace_matrix_fixed(&amp;pgs-&gt;char_tm);
#endif
    pgs-&gt;char_tm_valid = true;
    return 0;
}

/* Read (after possibly computing) the current transformation matrix */
/* for rendering text.  If force=true, update char_tm if it is invalid; */
/* if force=false, don't update char_tm, and return an error code. */
int
gs_currentcharmatrix(gs_state * pgs, gs_matrix * ptm, bool force)
{
    if (!pgs-&gt;char_tm_valid) {
	int code;

	if (!force)
	    return_error(gs_error_undefinedresult);
	code = gs_setcharmatrix(pgs, &amp;pgs-&gt;font-&gt;FontMatrix);
	if (code &lt; 0)
	    return code;
    }
    if (ptm != NULL)
	*ptm = char_tm_only(pgs);
    return 0;
}

int
gs_setmatrix(gs_state * pgs, const gs_matrix * pmat)
{
    update_ctm(pgs, pmat-&gt;tx, pmat-&gt;ty);
    set_ctm_only(pgs, *pmat);
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf("[x]setmatrix:\n"), trace_ctm(pgs);
#endif
    return 0;
}

int
gs_imager_setmatrix(gs_imager_state * pis, const gs_matrix * pmat)
{
    update_matrix_fixed(pis-&gt;ctm, pmat-&gt;tx, pmat-&gt;ty);
    set_ctm_only(pis, *pmat);
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf("[x]imager_setmatrix:\n"), trace_ctm(pis);
#endif
    return 0;
}

int
gs_settocharmatrix(gs_state * pgs)
{
    if (pgs-&gt;char_tm_valid) {
	pgs-&gt;ctm = pgs-&gt;char_tm;
	pgs-&gt;ctm_inverse_valid = false;
	return 0;
    } else
	return_error(gs_error_undefinedresult);
}

int
gs_translate(gs_state * pgs, floatp dx, floatp dy)
{
    gs_point pt;
    int code;

    if ((code = gs_distance_transform(dx, dy, &amp;ctm_only(pgs), &amp;pt)) &lt; 0)
	return code;
    pt.x += pgs-&gt;ctm.tx;
    pt.y += pgs-&gt;ctm.ty;
    update_ctm(pgs, pt.x, pt.y);
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf4("[x]translate: %f %f -&gt; %f %f\n",
		  dx, dy, pt.x, pt.y),
	    trace_ctm(pgs);
#endif
    return 0;
}

int
gs_scale(gs_state * pgs, floatp sx, floatp sy)
{
    pgs-&gt;ctm.xx *= sx;
    pgs-&gt;ctm.xy *= sx;
    pgs-&gt;ctm.yx *= sy;
    pgs-&gt;ctm.yy *= sy;
    pgs-&gt;ctm_inverse_valid = false, pgs-&gt;char_tm_valid = false;
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf2("[x]scale: %f %f\n", sx, sy), trace_ctm(pgs);
#endif
    return 0;
}

int
gs_rotate(gs_state * pgs, floatp ang)
{
    int code = gs_matrix_rotate(&amp;ctm_only(pgs), ang,
				&amp;ctm_only_writable(pgs));

    pgs-&gt;ctm_inverse_valid = false, pgs-&gt;char_tm_valid = false;
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf1("[x]rotate: %f\n", ang), trace_ctm(pgs);
#endif
    return code;
}

int
gs_concat(gs_state * pgs, const gs_matrix * pmat)
{
    gs_matrix cmat;
    int code = gs_matrix_multiply(pmat, &amp;ctm_only(pgs), &amp;cmat);

    if (code &lt; 0)
	return code;
    update_ctm(pgs, cmat.tx, cmat.ty);
    set_ctm_only(pgs, cmat);
#ifdef DEBUG
    if (gs_debug_c('x'))
	dlprintf("[x]concat:\n"), trace_matrix(pmat), trace_ctm(pgs);
#endif
    return code;
}

/* ------ Coordinate transformation ------ */

#define is_skewed(pmat) (!(is_xxyy(pmat) || is_xyyx(pmat)))

int
gs_transform(gs_state * pgs, floatp x, floatp y, gs_point * pt)
{
    return gs_point_transform(x, y, &amp;ctm_only(pgs), pt);
}

int
gs_dtransform(gs_state * pgs, floatp dx, floatp dy, gs_point * pt)
{
    return gs_distance_transform(dx, dy, &amp;ctm_only(pgs), pt);
}

int
gs_itransform(gs_state * pgs, floatp x, floatp y, gs_point * pt)
{				/* If the matrix isn't skewed, we get more accurate results */
    /* by using transform_inverse than by using the inverse matrix. */
    if (!is_skewed(&amp;pgs-&gt;ctm)) {
	return gs_point_transform_inverse(x, y, &amp;ctm_only(pgs), pt);
    } else {
	ensure_inverse_valid(pgs);
	return gs_point_transform(x, y, &amp;pgs-&gt;ctm_inverse, pt);
    }
}

int
gs_idtransform(gs_state * pgs, floatp dx, floatp dy, gs_point * pt)
{				/* If the matrix isn't skewed, we get more accurate results */
    /* by using transform_inverse than by using the inverse matrix. */
    if (!is_skewed(&amp;pgs-&gt;ctm)) {
	return gs_distance_transform_inverse(dx, dy,
					     &amp;ctm_only(pgs), pt);
    } else {
	ensure_inverse_valid(pgs);
	return gs_distance_transform(dx, dy, &amp;pgs-&gt;ctm_inverse, pt);
    }
}

int
gs_imager_idtransform(const gs_imager_state * pis, floatp dx, floatp dy,
		      gs_point * pt)
{
    return gs_distance_transform_inverse(dx, dy, &amp;ctm_only(pis), pt);
}

/* ------ For internal use only ------ */

/* Set the translation to a fixed value, and translate any existing path. */
/* Used by gschar.c to prepare for a BuildChar or BuildGlyph procedure. */
int
gx_translate_to_fixed(register gs_state * pgs, fixed px, fixed py)
{
    double fpx = fixed2float(px);
    double fdx = fpx - pgs-&gt;ctm.tx;
    double fpy = fixed2float(py);
    double fdy = fpy - pgs-&gt;ctm.ty;
    fixed dx, dy;
    int code;

    if (pgs-&gt;ctm.txy_fixed_valid) {
	dx = float2fixed(fdx);
	dy = float2fixed(fdy);
	code = gx_path_translate(pgs-&gt;path, dx, dy);
	if (code &lt; 0)
	    return code;
	if (pgs-&gt;char_tm_valid &amp;&amp; pgs-&gt;char_tm.txy_fixed_valid)
	    pgs-&gt;char_tm.tx_fixed += dx,
		pgs-&gt;char_tm.ty_fixed += dy;
    } else {
	if (!gx_path_is_null(pgs-&gt;path))
	    return_error(gs_error_limitcheck);
    }
    pgs-&gt;ctm.tx = fpx;
    pgs-&gt;ctm.tx_fixed = px;
    pgs-&gt;ctm.ty = fpy;
    pgs-&gt;ctm.ty_fixed = py;
    pgs-&gt;ctm.txy_fixed_valid = true;
    pgs-&gt;ctm_inverse_valid = false;
    if (pgs-&gt;char_tm_valid) {	/* Update char_tm now, leaving it valid. */
	pgs-&gt;char_tm.tx += fdx;
	pgs-&gt;char_tm.ty += fdy;
    }
#ifdef DEBUG
    if (gs_debug_c('x')) {
	dlprintf2("[x]translate_to_fixed %g, %g:\n",
		  fixed2float(px), fixed2float(py));
	trace_ctm(pgs);
	dlprintf("[x]   char_tm:\n");
	trace_matrix_fixed(&amp;pgs-&gt;char_tm);
    }
#endif
    gx_setcurrentpoint(pgs, fixed2float(pgs-&gt;ctm.tx_fixed), fixed2float(pgs-&gt;ctm.ty_fixed));
    pgs-&gt;current_point_valid = true;
    return 0;
}

/* Scale the CTM and character matrix for oversampling. */
int
gx_scale_char_matrix(register gs_state * pgs, int sx, int sy)
{
#define scale_cxy(s, vx, vy)\
  if ( s != 1 )\
   {	pgs-&gt;ctm.vx *= s;\
	pgs-&gt;ctm.vy *= s;\
	pgs-&gt;ctm_inverse_valid = false;\
	if ( pgs-&gt;char_tm_valid )\
	{	pgs-&gt;char_tm.vx *= s;\
		pgs-&gt;char_tm.vy *= s;\
	}\
   }
    scale_cxy(sx, xx, yx);
    scale_cxy(sy, xy, yy);
#undef scale_cxy
    if_debug2('x', "[x]char scale: %d %d\n", sx, sy);
    return 0;
}

/* Compute the coefficients for fast fixed-point distance transformations */
/* from a transformation matrix. */
/* We should cache the coefficients with the ctm.... */
int
gx_matrix_to_fixed_coeff(const gs_matrix * pmat, register fixed_coeff * pfc,
			 int max_bits)
{
    gs_matrix ctm;
    int scale = -10000;
    int expt, shift;

    ctm = *pmat;
    pfc-&gt;skewed = 0;
    if (!is_fzero(ctm.xx)) {
	discard(frexp(ctm.xx, &amp;scale));
    }
    if (!is_fzero(ctm.xy)) {
	discard(frexp(ctm.xy, &amp;expt));
	if (expt &gt; scale)
	    scale = expt;
	pfc-&gt;skewed = 1;
    }
    if (!is_fzero(ctm.yx)) {
	discard(frexp(ctm.yx, &amp;expt));
	if (expt &gt; scale)
	    scale = expt;
	pfc-&gt;skewed = 1;
    }
    if (!is_fzero(ctm.yy)) {
	discard(frexp(ctm.yy, &amp;expt));
	if (expt &gt; scale)
	    scale = expt;
    }
    /*
     * There are two multiplications in fixed_coeff_mult: one involves a
     * factor that may have max_bits significant bits, the other may have
     * fixed_fraction_bits (_fixed_shift) bits.  Ensure that neither one
     * will overflow.
     */
    if (max_bits &lt; fixed_fraction_bits)
	max_bits = fixed_fraction_bits;
    scale = sizeof(long) * 8 - 1 - max_bits - scale;

    shift = scale - _fixed_shift;
    if (shift &gt; 0) {
	pfc-&gt;shift = shift;
	pfc-&gt;round = (fixed) 1 &lt;&lt; (shift - 1);
    } else {
	pfc-&gt;shift = 0;
	pfc-&gt;round = 0;
	scale -= shift;
    }
#define SET_C(c)\
  if ( is_fzero(ctm.c) ) pfc-&gt;c = 0;\
  else pfc-&gt;c = (long)ldexp(ctm.c, scale)
    SET_C(xx);
    SET_C(xy);
    SET_C(yx);
    SET_C(yy);
#undef SET_C
#ifdef DEBUG
    if (gs_debug_c('x')) {
	dlprintf6("[x]ctm: [%6g %6g %6g %6g %6g %6g]\n",
		  ctm.xx, ctm.xy, ctm.yx, ctm.yy, ctm.tx, ctm.ty);
	dlprintf6("   scale=%d fc: [0x%lx 0x%lx 0x%lx 0x%lx] shift=%d\n",
		  scale, pfc-&gt;xx, pfc-&gt;xy, pfc-&gt;yx, pfc-&gt;yy,
		  pfc-&gt;shift);
    }
#endif
    pfc-&gt;max_bits = max_bits;
    return 0;
}

/*
 * Handle the case of a large value or a value with a fraction part.
 * See gxmatrix.h for more details.
 */
fixed
fixed_coeff_mult(fixed value, long coeff, const fixed_coeff *pfc, int maxb)
{
    int shift = pfc-&gt;shift;

    /*
     * Test if the value is too large for simple long math.
     */
    if ((value + (fixed_1 &lt;&lt; (maxb - 1))) &amp; (-fixed_1 &lt;&lt; maxb)) {
	/* The second argument of fixed_mult_quo must be non-negative. */
	return
	    (coeff &lt; 0 ?
	     -fixed_mult_quo(value, -coeff, fixed_1 &lt;&lt; shift) :
	     fixed_mult_quo(value, coeff, fixed_1 &lt;&lt; shift));
    } else {
	/*
	 * The construction above guarantees that the multiplications
	 * won't overflow the capacity of an int.
	 */
        return (fixed)
	    arith_rshift(fixed2int_var(value) * coeff
			 + fixed2int(fixed_fraction(value) * coeff)
			 + pfc-&gt;round, shift);
    }
}

/* ------ Debugging printout ------ */

#ifdef DEBUG

/* Print a matrix */
private void
trace_matrix_fixed(const gs_matrix_fixed * pmat)
{
    trace_matrix((const gs_matrix *)pmat);
    if (pmat-&gt;txy_fixed_valid) {
	dprintf2("\t\tt_fixed: [%6g %6g]\n",
		 fixed2float(pmat-&gt;tx_fixed),
		 fixed2float(pmat-&gt;ty_fixed));
    } else {
	dputs("\t\tt_fixed not valid\n");
    }
}
private void
trace_matrix(register const gs_matrix * pmat)
{
    dlprintf6("\t[%6g %6g %6g %6g %6g %6g]\n",
	      pmat-&gt;xx, pmat-&gt;xy, pmat-&gt;yx, pmat-&gt;yy, pmat-&gt;tx, pmat-&gt;ty);
}

#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

