<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsdps1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsdps1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 1992, 1994, 1996, 1997, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsdps1.c,v 1.10 2003/09/15 10:04:01 igor Exp $ */
/* Display PostScript graphics additions for Ghostscript library */
#include "math_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsmatrix.h"		/* for gscoord.h */
#include "gscoord.h"
#include "gspaint.h"
#include "gxdevice.h"
#include "gxfixed.h"
#include "gxmatrix.h"
#include "gxhldevc.h"
#include "gspath.h"
#include "gspath2.h"		/* defines interface */
#include "gzpath.h"
#include "gzcpath.h"
#include "gzstate.h"

/*
 * Define how much rounding slop setbbox should leave,
 * in device coordinates.  Because of rounding in transforming
 * path coordinates to fixed point, the minimum realistic value is:
 *
 *      #define box_rounding_slop_fixed (fixed_epsilon)
 *
 * But even this isn't enough to compensate for cumulative rounding error
 * in rmoveto or rcurveto.  Instead, we somewhat arbitrarily use:
 */
#define box_rounding_slop_fixed (fixed_epsilon * 3)

/* ------ Graphics state ------ */

/* Set the bounding box for the current path. */
int
gs_setbbox(gs_state * pgs, floatp llx, floatp lly, floatp urx, floatp ury)
{
    gs_rect ubox, dbox;
    gs_fixed_rect obox, bbox;
    gx_path *ppath = pgs-&gt;path;
    int code;

    if (llx &gt; urx || lly &gt; ury)
	return_error(gs_error_rangecheck);
    /* Transform box to device coordinates. */
    ubox.p.x = llx;
    ubox.p.y = lly;
    ubox.q.x = urx;
    ubox.q.y = ury;
    if ((code = gs_bbox_transform(&amp;ubox, &amp;ctm_only(pgs), &amp;dbox)) &lt; 0)
	return code;
    /* Round the corners in opposite directions. */
    /* Because we can't predict the magnitude of the dbox values, */
    /* we add/subtract the slop after fixing. */
    if (dbox.p.x &lt; fixed2float(min_fixed + box_rounding_slop_fixed) ||
	dbox.p.y &lt; fixed2float(min_fixed + box_rounding_slop_fixed) ||
	dbox.q.x &gt;= fixed2float(max_fixed - box_rounding_slop_fixed + fixed_epsilon) ||
	dbox.q.y &gt;= fixed2float(max_fixed - box_rounding_slop_fixed + fixed_epsilon)
	)
	return_error(gs_error_limitcheck);
    bbox.p.x =
	(fixed) floor(dbox.p.x * fixed_scale) - box_rounding_slop_fixed;
    bbox.p.y =
	(fixed) floor(dbox.p.y * fixed_scale) - box_rounding_slop_fixed;
    bbox.q.x =
	(fixed) ceil(dbox.q.x * fixed_scale) + box_rounding_slop_fixed;
    bbox.q.y =
	(fixed) ceil(dbox.q.y * fixed_scale) + box_rounding_slop_fixed;
    if (gx_path_bbox(ppath, &amp;obox) &gt;= 0) {	/* Take the union of the bboxes. */
	ppath-&gt;bbox.p.x = min(obox.p.x, bbox.p.x);
	ppath-&gt;bbox.p.y = min(obox.p.y, bbox.p.y);
	ppath-&gt;bbox.q.x = max(obox.q.x, bbox.q.x);
	ppath-&gt;bbox.q.y = max(obox.q.y, bbox.q.y);
    } else {			/* empty path *//* Just set the bbox. */
	ppath-&gt;bbox = bbox;
    }
    ppath-&gt;bbox_set = 1;
    return 0;
}

/* ------ Rectangles ------ */

/* Append a list of rectangles to a path. */
int
gs_rectappend(gs_state * pgs, const gs_rect * pr, uint count)
{
    for (; count != 0; count--, pr++) {
	floatp px = pr-&gt;p.x, py = pr-&gt;p.y, qx = pr-&gt;q.x, qy = pr-&gt;q.y;
	int code;

	/* Ensure counter-clockwise drawing. */
	if ((qx &gt;= px) != (qy &gt;= py))
	    qx = px, px = pr-&gt;q.x;	/* swap x values */
	if ((code = gs_moveto(pgs, px, py)) &lt; 0 ||
	    (code = gs_lineto(pgs, qx, py)) &lt; 0 ||
	    (code = gs_lineto(pgs, qx, qy)) &lt; 0 ||
	    (code = gs_lineto(pgs, px, qy)) &lt; 0 ||
	    (code = gs_closepath(pgs)) &lt; 0
	    )
	    return code;
    }
    return 0;
}

/* Clip to a list of rectangles. */
int
gs_rectclip(gs_state * pgs, const gs_rect * pr, uint count)
{
    int code;
    gx_path save;

    gx_path_init_local(&amp;save, pgs-&gt;memory);
    gx_path_assign_preserve(&amp;save, pgs-&gt;path);
    gs_newpath(pgs);
    if ((code = gs_rectappend(pgs, pr, count)) &lt; 0 ||
	(code = gs_clip(pgs)) &lt; 0
	) {
	gx_path_assign_free(pgs-&gt;path, &amp;save);
	return code;
    }
    gx_path_free(&amp;save, "gs_rectclip");
    gs_newpath(pgs);
    return 0;
}

/* Fill a list of rectangles. */
/* We take the trouble to do this efficiently in the simple cases. */
int
gs_rectfill(gs_state * pgs, const gs_rect * pr, uint count)
{
    const gs_rect *rlist = pr;
    gx_clip_path *pcpath;
    uint rcount = count;
    int code;
    gx_device * pdev = pgs-&gt;device;
    gx_device_color *pdc = pgs-&gt;dev_color;
    const gs_imager_state *pis = (const gs_imager_state *)pgs;
    bool hl_color_available = gx_hld_is_hl_color_available(pis, pdc);
    gs_fixed_rect empty = {{0, 0}, {0, 0}};
    bool hl_color = (hl_color_available &amp;&amp; 
		dev_proc(pdev, fill_rectangle_hl_color)(pdev, 
		    	    &amp;empty, pis, pdc, NULL) == 0);

    gx_set_dev_color(pgs);
    if ((is_fzero2(pgs-&gt;ctm.xy, pgs-&gt;ctm.yx) ||
	 is_fzero2(pgs-&gt;ctm.xx, pgs-&gt;ctm.yy)) &amp;&amp;
	gx_effective_clip_path(pgs, &amp;pcpath) &gt;= 0 &amp;&amp;
	clip_list_is_rectangle(gx_cpath_list(pcpath)) &amp;&amp;
	(hl_color ||
	 pdc-&gt;type == gx_dc_type_pure ||
	 pdc-&gt;type == gx_dc_type_ht_binary ||
	 pdc-&gt;type == gx_dc_type_ht_colored
	 /* DeviceN todo: add wts case */) &amp;&amp;
	gs_state_color_load(pgs) &gt;= 0 &amp;&amp;
	(*dev_proc(pdev, get_alpha_bits)) (pdev, go_graphics)
	&lt;= 1 &amp;&amp;
        (!pgs-&gt;overprint || !pgs-&gt;effective_overprint_mode)
	) {
	uint i;
	gs_fixed_rect clip_rect;

	gx_cpath_inner_box(pcpath, &amp;clip_rect);
	for (i = 0; i &lt; count; ++i) {
	    gs_fixed_point p, q;
	    gs_fixed_rect draw_rect;
	    
	    if (gs_point_transform2fixed(&amp;pgs-&gt;ctm, pr[i].p.x, pr[i].p.y, &amp;p) &lt; 0 ||
		gs_point_transform2fixed(&amp;pgs-&gt;ctm, pr[i].q.x, pr[i].q.y, &amp;q) &lt; 0
		) {		/* Switch to the slow algorithm. */
		goto slow;
	    }
	    draw_rect.p.x = min(p.x, q.x);
	    draw_rect.p.y = min(p.y, q.y);
	    draw_rect.q.x = max(p.x, q.x);
	    draw_rect.q.y = max(p.y, q.y);
	    if (hl_color) {
		rect_intersect(draw_rect, clip_rect);
		if (draw_rect.p.x &lt; draw_rect.q.x &amp;&amp;
		    draw_rect.p.y &lt; draw_rect.q.y) {
		    code = dev_proc(pdev, fill_rectangle_hl_color)(pdev,
			     &amp;draw_rect, pis, pdc, pcpath);
		    if (code &lt; 0)
			return code;
		}
	    } else {
		int x, y, w, h;

		draw_rect.p.x -= pgs-&gt;fill_adjust.x;
		draw_rect.p.y -= pgs-&gt;fill_adjust.x;
		draw_rect.q.x += pgs-&gt;fill_adjust.x;
		draw_rect.q.y += pgs-&gt;fill_adjust.x;
		rect_intersect(draw_rect, clip_rect);
		x = fixed2int_pixround(draw_rect.p.x);
		y = fixed2int_pixround(draw_rect.p.y);
		w = fixed2int_pixround(draw_rect.q.x) - x;
		h = fixed2int_pixround(draw_rect.q.y) - y;
		if (w &gt; 0 &amp;&amp; h &gt; 0)
    		    if (gx_fill_rectangle(x, y, w, h, pdc, pgs) &lt; 0)
			goto slow;
	    }
	}
	return 0;
      slow:rlist = pr + i;
	rcount = count - i;
    } {
	bool do_save = !gx_path_is_null(pgs-&gt;path);

	if (do_save) {
	    if ((code = gs_gsave(pgs)) &lt; 0)
		return code;
	    gs_newpath(pgs);
	}
	if ((code = gs_rectappend(pgs, rlist, rcount)) &lt; 0 ||
	    (code = gs_fill(pgs)) &lt; 0
	    )
	    DO_NOTHING;
	if (do_save)
	    gs_grestore(pgs);
	else if (code &lt; 0)
	    gs_newpath(pgs);
    }
    return code;
}

/* Stroke a list of rectangles. */
/* (We could do this a lot more efficiently.) */
int
gs_rectstroke(gs_state * pgs, const gs_rect * pr, uint count,
	      const gs_matrix * pmat)
{
    bool do_save = pmat != NULL || !gx_path_is_null(pgs-&gt;path);
    int code;

    if (do_save) {
	if ((code = gs_gsave(pgs)) &lt; 0)
	    return code;
	gs_newpath(pgs);
    }
    if ((code = gs_rectappend(pgs, pr, count)) &lt; 0 ||
	(pmat != NULL &amp;&amp; (code = gs_concat(pgs, pmat)) &lt; 0) ||
	(code = gs_stroke(pgs)) &lt; 0
	)
	DO_NOTHING;
    if (do_save)
	gs_grestore(pgs);
    else if (code &lt; 0)
	gs_newpath(pgs);
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

