<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gsfemu.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gsfemu.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1996, 1998 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gsfemu.c,v 1.4 2002/02/21 22:24:52 giles Exp $ */
/* Floating point emulator for gcc */

/* We actually only need arch.h + uint and ulong, but because signal.h */
/* may include &lt;sys/types.h&gt;, we have to include std.h to handle (avoid) */
/* redefinition of type names. */
#include "std.h"
#include &lt;signal.h&gt;

/*#define TEST */

/*
 * This package is not a fully general IEEE floating point implementation.
 * It implements only one rounding mode (round to nearest) and does not
 * generate or properly handle NaNs.
 *
 * The names and interfaces of the routines in this package were designed to
 * work with gcc.  This explains some peculiarities such as the presence of
 * single-precision arithmetic (forbidden by the ANSI standard) and the
 * omission of unsigned-to-float conversions (which gcc implements with
 * truly grotesque inline code).
 *
 * The following routines do not yet handle denormalized numbers:
 *      addd3 (operands or result)
 *      __muldf3 (operands or result)
 *      __divdf3 (operands or result)
 *      __truncdfsf2 (result)
 *      __extendsfdf2 (operand)
 */

/*
 * IEEE single-precision floats have the format:
 *      sign(1) exponent(8) mantissa(23)
 * The exponent is biased by +127.
 * The mantissa is a fraction with an implicit integer part of 1,
 * unless the exponent is zero.
 */
#define fx(ia) (((ia) &gt;&gt; 23) &amp; 0xff)
#define fx_bias 127
/*
 * IEEE double-precision floats have the format:
 *      sign(1) exponent(11) mantissa(52)
 * The exponent is biased by +1023.
 */
#define dx(ld) ((ld[msw] &gt;&gt; 20) &amp; 0x7ff)
#define dx_bias 1023

#if arch_is_big_endian
#  define msw 0
#  define lsw 1
#else
#  define msw 1
#  define lsw 0
#endif
/* Double arguments/results */
#define la ((const long *)&amp;a)
#define ula ((const ulong *)&amp;a)
#define lb ((const long *)&amp;b)
#define ulb ((const ulong *)&amp;b)
#define dc (*(const double *)lc)
/* Float arguments/results */
#define ia (*(const long *)&amp;a)
#define ua (*(const ulong *)&amp;a)
#define ib (*(const long *)&amp;b)
#define ub (*(const ulong *)&amp;b)
#define fc (*(const float *)&amp;lc)

/* Round a double-length fraction by adding 1 in the lowest bit and */
/* then shifting right by 1. */
#define roundr1(ms, uls)\
  if ( uls == 0xffffffff ) ms++, uls = 0;\
  else uls++;\
  uls = (uls &gt;&gt; 1) + (ms &lt;&lt; 31);\
  ms &gt;&gt;= 1

/* Extend a non-zero float to a double. */
#define extend(lc, ia)\
  ((lc)[msw] = ((ia) &amp; 0x80000000) + (((ia) &amp; 0x7fffffff) &gt;&gt; 3) + 0x38000000,\
   (lc)[lsw] = (ia) &lt;&lt; 29)

/* ---------------- Arithmetic ---------------- */

/* -------- Add/subtract/negate -------- */

double
__negdf2(double a)
{
    long lc[2];

    lc[msw] = la[msw] ^ 0x80000000;
    lc[lsw] = la[lsw];
    return dc;
}
float
__negsf2(float a)
{
    long lc = ia ^ 0x80000000;

    return fc;
}

double
__adddf3(double a, double b)
{
    long lc[2];
    int expt = dx(la);
    int shift = expt - dx(lb);
    long sign;
    ulong msa, lsa;
    ulong msb, lsb;

    if (shift &lt; 0) {		/* Swap a and b so that expt(a) &gt;= expt(b). */
	double temp = a;

	a = b, b = temp;
	expt += (shift = -shift);
    }
    if (shift &gt;= 54)		/* also picks up most cases where b == 0 */
	return a;
    if (!(lb[msw] &amp; 0x7fffffff))
	return a;
    sign = la[msw] &amp; 0x80000000;
    msa = (la[msw] &amp; 0xfffff) + 0x100000, lsa = la[lsw];
    msb = (lb[msw] &amp; 0xfffff) + 0x100000, lsb = lb[lsw];
    if ((la[msw] ^ lb[msw]) &gt;= 0) {	/* Adding numbers of the same sign. */
	if (shift &gt;= 32)
	    lsb = msb, msb = 0, shift -= 32;
	if (shift) {
	    --shift;
	    lsb = (lsb &gt;&gt; shift) + (msb &lt;&lt; (32 - shift));
	    msb &gt;&gt;= shift;
	    roundr1(msb, lsb);
	}
	if (lsb &gt; (ulong) 0xffffffff - lsa)
	    msa++;
	lsa += lsb;
	msa += msb;
	if (msa &gt; 0x1fffff) {
	    roundr1(msa, lsa);
	    /* In principle, we have to worry about exponent */
	    /* overflow here, but we don't. */
	    ++expt;
	}
    } else {			/* Adding numbers of different signs. */
	if (shift &gt; 53)
	    return a;		/* b can't affect the result, even rounded */
	if (shift == 0 &amp;&amp; (msb &gt; msa || (msb == msa &amp;&amp; lsb &gt;= lsa))) {	/* This is the only case where the sign of the result */
	    /* differs from the sign of the first operand. */
	    sign ^= 0x80000000;
	    msa = msb - msa;
	    if (lsb &lt; lsa)
		msa--;
	    lsa = lsb - lsa;
	} else {
	    if (shift &gt;= 33) {
		lsb = ((msb &gt;&gt; (shift - 32)) + 1) &gt;&gt; 1;		/* round */
		msb = 0;
	    } else if (shift) {
		lsb = (lsb &gt;&gt; (shift - 1)) + (msb &lt;&lt; (33 - shift));
		msb &gt;&gt;= shift - 1;
		roundr1(msb, lsb);
	    }
	    msa -= msb;
	    if (lsb &gt; lsa)
		msa--;
	    lsa -= lsb;
	}
	/* Now renormalize the result. */
	/* For the moment, we do this the slow way. */
	if (!(msa | lsa))
	    return 0;
	while (msa &lt; 0x100000) {
	    msa = (msa &lt;&lt; 1) + (lsa &gt;&gt; 31);
	    lsa &lt;&lt;= 1;
	    expt -= 1;
	}
	if (expt &lt;= 0) {	/* Underflow.  Return 0 rather than a denorm. */
	    lc[msw] = sign;
	    lc[lsw] = 0;
	    return dc;
	}
    }
    lc[msw] = sign + ((ulong) expt &lt;&lt; 20) + (msa &amp; 0xfffff);
    lc[lsw] = lsa;
    return dc;
}
double
__subdf3(double a, double b)
{
    long nb[2];

    nb[msw] = lb[msw] ^ 0x80000000;
    nb[lsw] = lb[lsw];
    return a + *(const double *)nb;
}

float
__addsf3(float a, float b)
{
    long lc;
    int expt = fx(ia);
    int shift = expt - fx(ib);
    long sign;
    ulong ma, mb;

    if (shift &lt; 0) {		/* Swap a and b so that expt(a) &gt;= expt(b). */
	long temp = ia;

	*(long *)&amp;a = ib;
	*(long *)&amp;b = temp;
	expt += (shift = -shift);
    }
    if (shift &gt;= 25)		/* also picks up most cases where b == 0 */
	return a;
    if (!(ib &amp; 0x7fffffff))
	return a;
    sign = ia &amp; 0x80000000;
    ma = (ia &amp; 0x7fffff) + 0x800000;
    mb = (ib &amp; 0x7fffff) + 0x800000;
    if ((ia ^ ib) &gt;= 0) {	/* Adding numbers of the same sign. */
	if (shift) {
	    --shift;
	    mb = ((mb &gt;&gt; shift) + 1) &gt;&gt; 1;
	}
	ma += mb;
	if (ma &gt; 0xffffff) {
	    ma = (ma + 1) &gt;&gt; 1;
	    /* In principle, we have to worry about exponent */
	    /* overflow here, but we don't. */
	    ++expt;
	}
    } else {			/* Adding numbers of different signs. */
	if (shift &gt; 24)
	    return a;		/* b can't affect the result, even rounded */
	if (shift == 0 &amp;&amp; mb &gt;= ma) {
	    /* This is the only case where the sign of the result */
	    /* differs from the sign of the first operand. */
	    sign ^= 0x80000000;
	    ma = mb - ma;
	} else {
	    if (shift) {
		--shift;
		mb = ((mb &gt;&gt; shift) + 1) &gt;&gt; 1;
	    }
	    ma -= mb;
	}
	/* Now renormalize the result. */
	/* For the moment, we do this the slow way. */
	if (!ma)
	    return 0;
	while (ma &lt; 0x800000) {
	    ma &lt;&lt;= 1;
	    expt -= 1;
	}
	if (expt &lt;= 0) {
	    /* Underflow.  Return 0 rather than a denorm. */
	    lc = sign;
	    return fc;
	}
    }
    lc = sign + ((ulong)expt &lt;&lt; 23) + (ma &amp; 0x7fffff);
    return fc;
}

float
__subsf3(float a, float b)
{
    long lc = ib ^ 0x80000000;

    return a + fc;
}

/* -------- Multiplication -------- */

double
__muldf3(double a, double b)
{
    long lc[2];
    ulong sign;
    uint H, I, h, i;
    ulong p0, p1, p2;
    ulong expt;

    if (!(la[msw] &amp; 0x7fffffff) || !(lb[msw] &amp; 0x7fffffff))
	return 0;
    /*
     * We now have to multiply two 53-bit fractions to produce a 53-bit
     * result.  Since the idiots who specified the standard C libraries
     * don't allow us to use the 32 x 32 =&gt; 64 multiply that every
     * 32-bit CPU provides, we have to chop these 53-bit numbers up into
     * 14-bit chunks so we can use 32 x 32 =&gt; 32 multiplies.
     */
#define chop_ms(ulx, h, i)\
  h = ((ulx[msw] &gt;&gt; 7) &amp; 0x1fff) | 0x2000,\
  i = ((ulx[msw] &amp; 0x7f) &lt;&lt; 7) | (ulx[lsw] &gt;&gt; 25)
#define chop_ls(ulx, j, k)\
  j = (ulx[lsw] &gt;&gt; 11) &amp; 0x3fff,\
  k = (ulx[lsw] &amp; 0x7ff) &lt;&lt; 3
    chop_ms(ula, H, I);
    chop_ms(ulb, h, i);
#undef chop
#define prod(m, n) ((ulong)(m) * (n))	/* force long multiply */
    p0 = prod(H, h);
    p1 = prod(H, i) + prod(I, h);
    /* If these doubles were produced from floats or ints, */
    /* all the other products will be zero.  It's worth a check. */
    if ((ula[lsw] | ulb[lsw]) &amp; 0x1ffffff) {	/* No luck. */
	/* We can almost always avoid computing p5 and p6, */
	/* but right now it's not worth the trouble to check. */
	uint J, K, j, k;

	chop_ls(ula, J, K);
	chop_ls(ulb, j, k);
	{
	    ulong p6 = prod(K, k);
	    ulong p5 = prod(J, k) + prod(K, j) + (p6 &gt;&gt; 14);
	    ulong p4 = prod(I, k) + prod(J, j) + prod(K, i) + (p5 &gt;&gt; 14);
	    ulong p3 = prod(H, k) + prod(I, j) + prod(J, i) + prod(K, h) +
	    (p4 &gt;&gt; 14);

	    p2 = prod(H, j) + prod(I, i) + prod(J, h) + (p3 &gt;&gt; 14);
	}
    } else {
	p2 = prod(I, i);
    }
    /* Now p0 through p2 hold the result. */
/****** ASSUME expt IS 32 BITS WIDE. ******/
    expt = (la[msw] &amp; 0x7ff00000) + (lb[msw] &amp; 0x7ff00000) -
	(dx_bias &lt;&lt; 20);
    /* Now expt is in the range [-1023..3071] &lt;&lt; 20. */
    /* Values outside the range [1..2046] are invalid. */
    p1 += p2 &gt;&gt; 14;
    p0 += p1 &gt;&gt; 14;
    /* Now the 56-bit result consists of p0, the low 14 bits of p1, */
    /* and the low 14 bits of p2. */
    /* p0 can be anywhere between 2^26 and almost 2^28, so we might */
    /* need to adjust the exponent by 1. */
    if (p0 &lt; 0x8000000) {
	p0 = (p0 &lt;&lt; 1) + ((p1 &gt;&gt; 13) &amp; 1);
	p1 = (p1 &lt;&lt; 1) + ((p2 &gt;&gt; 13) &amp; 1);
	p2 &lt;&lt;= 1;
    } else
	expt += 0x100000;
    /* The range of expt is now [-1023..3072] &lt;&lt; 20. */
    /* Round the mantissa to 53 bits. */
    if (!((p2 += 4) &amp; 0x3ffc) &amp;&amp; !(++p1 &amp; 0x3fff) &amp;&amp; ++p0 &gt;= 0x10000000) {
	p0 &gt;&gt;= 1, p1 = 0x2000;
	/* Check for exponent overflow, just in case. */
	if ((ulong) expt &lt; 0xc0000000)
	    expt += 0x100000;
    }
    sign = (la[msw] ^ lb[msw]) &amp; 0x80000000;
    if (expt == 0) {		/* Underflow.  Return 0 rather than a denorm. */
	lc[msw] = sign;
	lc[lsw] = 0;
    } else if ((ulong) expt &gt;= 0x7ff00000) {	/* Overflow or underflow. */
	if ((ulong) expt &lt;= 0xc0000000) {	/* Overflow. */
	    raise(SIGFPE);
	    lc[msw] = sign + 0x7ff00000;
	    lc[lsw] = 0;
	} else {		/* Underflow.  See above. */
	    lc[msw] = sign;
	    lc[lsw] = 0;
	}
    } else {
	lc[msw] = sign + expt + ((p0 &gt;&gt; 7) &amp; 0xfffff);
	lc[lsw] = (p0 &lt;&lt; 25) | ((p1 &amp; 0x3fff) &lt;&lt; 11) | ((p2 &gt;&gt; 3) &amp; 0x7ff);
    }
    return dc;
#undef prod
}
float
__mulsf3(float a, float b)
{
    uint au, al, bu, bl, cu, cl, sign;
    long lc;
    uint expt;

    if (!(ia &amp; 0x7fffffff) || !(ib &amp; 0x7fffffff))
	return 0;
    au = ((ia &gt;&gt; 8) &amp; 0x7fff) | 0x8000;
    bu = ((ib &gt;&gt; 8) &amp; 0x7fff) | 0x8000;
    /* Since 0x8000 &lt;= au,bu &lt;= 0xffff, 0x40000000 &lt;= cu &lt;= 0xfffe0001. */
    cu = au * bu;
    if ((al = ia &amp; 0xff) != 0) {
	cl = bu * al;
    } else
	cl = 0;
    if ((bl = ib &amp; 0xff) != 0) {
	cl += au * bl;
	if (al)
	    cl += (al * bl) &gt;&gt; 8;
    }
    cu += cl &gt;&gt; 8;
    sign = (ia ^ ib) &amp; 0x80000000;
    expt = (ia &amp; 0x7f800000) + (ib &amp; 0x7f800000) - (fx_bias &lt;&lt; 23);
    /* expt is now in the range [-127..383] &lt;&lt; 23. */
    /* Values outside [1..254] are invalid. */
    if (cu &lt;= 0x7fffffff)
	cu &lt;&lt;= 1;
    else
	expt += 1 &lt;&lt; 23;
    cu = ((cu &gt;&gt; 7) + 1) &gt;&gt; 1;
    if (expt &lt; 1 &lt;&lt; 23)
	lc = sign;		/* underflow */
    else if (expt &gt; (uint)(254 &lt;&lt; 23)) {
	if (expt &lt;= 0xc0000000) { /* overflow */
	    raise(SIGFPE);
	    lc = sign + 0x7f800000;
	} else {		/* underflow */
	    lc = sign;
	}
    } else
	lc = sign + expt + cu - 0x800000;
    return fc;
}

/* -------- Division -------- */

double
__divdf3(double a, double b)
{
    long lc[2];

    /*
     * Multi-precision division is really, really awful.
     * We generate the result more or less brute force,
     * 11 bits at a time.
     */
    ulong sign = (la[msw] ^ lb[msw]) &amp; 0x80000000;
    ulong msa = (la[msw] &amp; 0xfffff) | 0x100000, lsa = la[lsw];
    ulong msb = (lb[msw] &amp; 0xfffff) | 0x100000, lsb = lb[lsw];
    uint qn[5];
    int i;
    ulong msq, lsq;
    int expt = dx(la) - dx(lb) + dx_bias;

    if (!(lb[msw] &amp; 0x7fffffff)) {	/* Division by zero. */
	raise(SIGFPE);
	lc[lsw] = 0;
	lc[msw] =
	    (la[msw] &amp; 0x7fffffff ?
	     sign + 0x7ff00000 /* infinity */ :
	     0x7ff80000 /* NaN */ );
	return dc;
    }
    if (!(la[msw] &amp; 0x7fffffff))
	return 0;
    for (i = 0; i &lt; 5; ++i) {
	uint q;
	ulong msp, lsp;

	msa = (msa &lt;&lt; 11) + (lsa &gt;&gt; 21);
	lsa &lt;&lt;= 11;
	q = msa / msb;
	/* We know that 2^20 &lt;= msb &lt; 2^21; q could be too high by 1, */
	/* but it can't be too low. */
	/* Set p = d * q. */
	msp = q * msb;
	lsp = q * (lsb &amp; 0x1fffff);
	{
	    ulong midp = q * (lsb &gt;&gt; 21);

	    msp += (midp + (lsp &gt;&gt; 21)) &gt;&gt; 11;
	    lsp += midp &lt;&lt; 21;
	}
	/* Set a = a - p, i.e., the tentative remainder. */
	if (msp &gt; msa || (lsp &gt; lsa &amp;&amp; msp == msa)) {	/* q was too large. */
	    --q;
	    if (lsb &gt; lsp)
		msp--;
	    lsp -= lsb;
	    msp -= msb;
	}
	if (lsp &gt; lsa)
	    msp--;
	lsa -= lsp;
	msa -= msp;
	qn[i] = q;
    }
    /* Pack everything together again. */
    msq = (qn[0] &lt;&lt; 9) + (qn[1] &gt;&gt; 2);
    lsq = (qn[1] &lt;&lt; 30) + (qn[2] &lt;&lt; 19) + (qn[3] &lt;&lt; 8) + (qn[4] &gt;&gt; 3);
    if (msq &lt; 0x100000) {
	msq = (msq &lt;&lt; 1) + (lsq &gt;&gt; 31);
	lsq &lt;&lt;= 1;
	expt--;
    }
    /* We should round the quotient, but we don't. */
    if (expt &lt;= 0) {		/* Underflow.  Return 0 rather than a denorm. */
	lc[msw] = sign;
	lc[lsw] = 0;
    } else if (expt &gt;= 0x7ff) {	/* Overflow. */
	raise(SIGFPE);
	lc[msw] = sign + 0x7ff00000;
	lc[lsw] = 0;
    } else {
	lc[msw] = sign + (expt &lt;&lt; 20) + (msq &amp; 0xfffff);
	lc[lsw] = lsq;
    }
    return dc;
}
float
__divsf3(float a, float b)
{
    return (float)((double)a / (double)b);
}

/* ---------------- Comparisons ---------------- */

static int
compared2(const long *pa, const long *pb)
{
#define upa ((const ulong *)pa)
#define upb ((const ulong *)pb)
    if (pa[msw] == pb[msw]) {
	int result = (upa[lsw] &lt; upb[lsw] ? -1 :
		      upa[lsw] &gt; upb[lsw] ? 1 : 0);

	return (pa[msw] &lt; 0 ? -result : result);
    }
    if ((pa[msw] &amp; pb[msw]) &lt; 0)
	return (pa[msw] &lt; pb[msw] ? 1 : -1);
    /* We have to treat -0 and +0 specially. */
    else if (!((pa[msw] | pb[msw]) &amp; 0x7fffffff) &amp;&amp; !(pa[lsw] | pb[lsw]))
	return 0;
    else
	return (pa[msw] &gt; pb[msw] ? 1 : -1);
#undef upa
#undef upb
}

/* 0 means true */
int
__eqdf2(double a, double b)
{
    return compared2(la, lb);
}

/* !=0 means true */
int
__nedf2(double a, double b)
{
    return compared2(la, lb);
}

/* &gt;0 means true */
int
__gtdf2(double a, double b)
{
    return compared2(la, lb);
}

/* &gt;=0 means true */
int
__gedf2(double a, double b)
{
    return compared2(la, lb);
}

/* &lt;0 means true */
int
__ltdf2(double a, double b)
{
    return compared2(la, lb);
}

/* &lt;=0 means true */
int
__ledf2(double a, double b)
{
    return compared2(la, lb);
}

static int
comparef2(long va, long vb)
{				/* We have to treat -0 and +0 specially. */
    if (va == vb)
	return 0;
    if ((va &amp; vb) &lt; 0)
	return (va &lt; vb ? 1 : -1);
    else if (!((va | vb) &amp; 0x7fffffff))
	return 0;
    else
	return (va &gt; vb ? 1 : -1);
}

/* See the __xxdf2 functions above for the return values. */
int
__eqsf2(float a, float b)
{
    return comparef2(ia, ib);
}
int
__nesf2(float a, float b)
{
    return comparef2(ia, ib);
}
int
__gtsf2(float a, float b)
{
    return comparef2(ia, ib);
}
int
__gesf2(float a, float b)
{
    return comparef2(ia, ib);
}
int
__ltsf2(float a, float b)
{
    return comparef2(ia, ib);
}
int
__lesf2(float a, float b)
{
    return comparef2(ia, ib);
}

/* ---------------- Conversion ---------------- */

long
__fixdfsi(double a)
{				/* This routine does check for overflow. */
    long i = (la[msw] &amp; 0xfffff) + 0x100000;
    int expt = dx(la) - dx_bias;

    if (expt &lt; 0)
	return 0;
    if (expt &lt;= 20)
	i &gt;&gt;= 20 - expt;
    else if (expt &gt;= 31 &amp;&amp;
	     (expt &gt; 31 || i != 0x100000 || la[msw] &gt;= 0 ||
	      ula[lsw] &gt;= 1L &lt;&lt; 21)
	) {
	raise(SIGFPE);
	i = (la[msw] &lt; 0 ? 0x80000000 : 0x7fffffff);
    } else
	i = (i &lt;&lt; (expt - 20)) + (ula[lsw] &gt;&gt; (52 - expt));
    return (la[msw] &lt; 0 ? -i : i);
}

long
__fixsfsi(float a)
{				/* This routine does check for overflow. */
    long i = (ia &amp; 0x7fffff) + 0x800000;
    int expt = fx(ia) - fx_bias;

    if (expt &lt; 0)
	return 0;
    if (expt &lt;= 23)
	i &gt;&gt;= 23 - expt;
    else if (expt &gt;= 31 &amp;&amp; (expt &gt; 31 || i != 0x800000 || ia &gt;= 0)) {
	raise(SIGFPE);
	i = (ia &lt; 0 ? 0x80000000 : 0x7fffffff);
    } else
	i &lt;&lt;= expt - 23;
    return (ia &lt; 0 ? -i : i);
}

double
__floatsidf(long i)
{
    long msc;
    ulong v;
    long lc[2];

    if (i &gt; 0)
	msc = 0x41e00000 - 0x100000, v = i;
    else if (i &lt; 0)
	msc = 0xc1e00000 - 0x100000, v = -i;
    else			/* i == 0 */
	return 0;
    while (v &lt; 0x01000000)
	v &lt;&lt;= 8, msc -= 0x00800000;
    if (v &lt; 0x10000000)
	v &lt;&lt;= 4, msc -= 0x00400000;
    while (v &lt; 0x80000000)
	v &lt;&lt;= 1, msc -= 0x00100000;
    lc[msw] = msc + (v &gt;&gt; 11);
    lc[lsw] = v &lt;&lt; 21;
    return dc;
}

float
__floatsisf(long i)
{
    long lc;

    if (i == 0)
	lc = 0;
    else {
	ulong v;

	if (i &lt; 0)
	    lc = 0xcf000000, v = -i;
	else
	    lc = 0x4f000000, v = i;
	while (v &lt; 0x01000000)
	    v &lt;&lt;= 8, lc -= 0x04000000;
	while (v &lt; 0x80000000)
	    v &lt;&lt;= 1, lc -= 0x00800000;
	v = ((v &gt;&gt; 7) + 1) &gt;&gt; 1;
	if (v &gt; 0xffffff)
	    v &gt;&gt;= 1, lc += 0x00800000;
	lc += v &amp; 0x7fffff;
    }
    return fc;
}

float
__truncdfsf2(double a)
{				/* This routine does check for overflow, but it converts */
    /* underflows to zero rather than to a denormalized number. */
    long lc;

    if ((la[msw] &amp; 0x7ff00000) &lt; 0x38100000)
	lc = la[msw] &amp; 0x80000000;
    else if ((la[msw] &amp; 0x7ff00000) &gt;= 0x47f00000) {
	raise(SIGFPE);
	lc = (la[msw] &amp; 0x80000000) + 0x7f800000;	/* infinity */
    } else {
	lc = (la[msw] &amp; 0xc0000000) +
	    ((la[msw] &amp; 0x07ffffff) &lt;&lt; 3) +
	    (ula[lsw] &gt;&gt; 29);
	/* Round the mantissa.  Simply adding 1 works even if the */
	/* mantissa overflows, because it increments the exponent and */
	/* sets the mantissa to zero! */
	if (ula[lsw] &amp; 0x10000000)
	    ++lc;
    }
    return fc;
}

double
__extendsfdf2(float a)
{
    long lc[2];

    if (!(ia &amp; 0x7fffffff))
	lc[msw] = ia, lc[lsw] = 0;
    else
	extend(lc, ia);
    return dc;
}

/* ---------------- Test program ---------------- */

#ifdef TEST

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

int
test(double v1)
{
    double v3 = v1 * 3;
    double vh = v1 / 2;
    double vd = v3 - vh;
    double vdn = v1 - v3;

    printf("%g=1 %g=3 %g=0.5 %g=2.5 %g=-2\n", v1, v3, vh, vd, vdn);
    return 0;
}

float
randf(void)
{
    int v = rand();

    v = (v &lt;&lt; 16) ^ rand();
    if (!(v &amp; 0x7f800000))
	return 0;
    if ((v &amp; 0x7f800000) == 0x7f800000)
	return randf();
    return *(float *)&amp;v;
}

int
main(int argc, char *argv[])
{
    int i;

    test(1.0);
    for (i = 0; i &lt; 10; ++i) {
	float a = randf(), b = randf(), r;
	int c;

	switch ((rand() &gt;&gt; 12) &amp; 3) {
	    case 0:
		r = a + b;
		c = '+';
		break;
	    case 1:
		r = a - b;
		c = '-';
		break;
	    case 2:
		r = a * b;
		c = '*';
		break;
	    case 3:
		if (b == 0)
		    continue;
		r = a / b;
		c = '/';
		break;
	}
	printf("0x%08x %c 0x%08x = 0x%08x\n",
	       *(int *)&amp;a, c, *(int *)&amp;b, *(int *)&amp;r);
    }
}

/*
   Results from compiling with hardware floating point:

   1=1 3=3 0.5=0.5 2.5=2.5 -2=-2
   0x6f409924 - 0x01faa67a = 0x6f409924
   0x00000000 + 0x75418107 = 0x75418107
   0xe32fab71 - 0xc88f7816 = 0xe32fab71
   0x94809067 * 0x84ddaeee = 0x00000000
   0x2b0a5b7d + 0x38f70f50 = 0x38f70f50
   0xa5efcef3 - 0xc5dc1a2c = 0x45dc1a2c
   0xe7124521 * 0x3f4206d2 = 0xe6ddb891
   0x8d175f17 * 0x2ed2c1c0 = 0x80007c9f
   0x419e7a6d / 0xf2f95a35 = 0x8e22b404
   0xe0b2f48f * 0xc72793fc = 0x686a49f8

 */


#endif
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

