<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gspath.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gspath.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gspath.c,v 1.10 2004/08/31 13:23:16 igor Exp $ */
/* Basic path routines for Ghostscript library */
#include "gx.h"
#include "math_.h"
#include "gserrors.h"
#include "gxfixed.h"
#include "gxmatrix.h"
#include "gscoord.h"		/* requires gsmatrix.h */
#include "gspath.h"		/* for checking prototypes */
#include "gzstate.h"
#include "gzpath.h"
#include "gxdevice.h"		/* for gxcpath.h */
#include "gxdevmem.h"		/* for gs_device_is_memory */
#include "gzcpath.h"

/* ------ Miscellaneous ------ */

int
gs_newpath(gs_state * pgs)
{
    pgs-&gt;current_point_valid = false;
    return gx_path_new(pgs-&gt;path);
}

int
gs_closepath(gs_state * pgs)
{
    gx_path *ppath = pgs-&gt;path;
    int code = gx_path_close_subpath(ppath);

    if (code &lt; 0)
	return code;
    pgs-&gt;current_point = pgs-&gt;subpath_start;
    return code;
}

int
gs_upmergepath(gs_state * pgs)
{
    return gx_path_add_path(pgs-&gt;saved-&gt;path, pgs-&gt;path);
}

/* Get the current path (for internal use only). */
gx_path *
gx_current_path(const gs_state * pgs)
{
    return pgs-&gt;path;
}

/* ------ Points and lines ------ */

/*
 * Define clamped values for out-of-range coordinates.
 * Currently the path drawing routines can't handle values
 * close to the edge of the representable space.
 */
#define max_coord_fixed (max_fixed - int2fixed(1000))	/* arbitrary */
#define min_coord_fixed (-max_coord_fixed)
private inline void
clamp_point(gs_fixed_point * ppt, floatp x, floatp y)
{
#define clamp_coord(xy)\
  ppt-&gt;xy = (xy &gt; fixed2float(max_coord_fixed) ? max_coord_fixed :\
	     xy &lt; fixed2float(min_coord_fixed) ? min_coord_fixed :\
	     float2fixed(xy))
    clamp_coord(x);
    clamp_coord(y);
#undef clamp_coord
}

int
gs_currentpoint(gs_state * pgs, gs_point * ppt)
{
    if (!pgs-&gt;current_point_valid)
	return_error(gs_error_nocurrentpoint);
    return gs_itransform(pgs, pgs-&gt;current_point.x, 
			      pgs-&gt;current_point.y, ppt);
}

private inline int 
gs_point_transform_compat(floatp x, floatp y, const gs_matrix_fixed *m, gs_point *pt)
{
#if !PRECISE_CURRENTPOINT
    gs_fixed_point p;
    int code = gs_point_transform2fixed(m, x, y, &amp;p);

    if (code &lt; 0)
	return code;
    pt-&gt;x = fixed2float(p.x);
    pt-&gt;y = fixed2float(p.y);
    return 0;
#else
    return gs_point_transform(x, y, (const gs_matrix *)m, pt);
#endif
}

private inline int 
gs_distance_transform_compat(floatp x, floatp y, const gs_matrix_fixed *m, gs_point *pt)
{
#if !PRECISE_CURRENTPOINT
    gs_fixed_point p;
    int code = gs_distance_transform2fixed(m, x, y, &amp;p);

    if (code &lt; 0)
	return code;
    pt-&gt;x = fixed2float(p.x);
    pt-&gt;y = fixed2float(p.y);
    return 0;
#else
    return gs_distance_transform(x, y, (const gs_matrix *)m, pt);
#endif
}

private inline int
clamp_point_aux(bool clamp_coordinates, gs_fixed_point *ppt, floatp x, floatp y)
{
    if (!f_fits_in_bits(x, fixed_int_bits) || !f_fits_in_bits(y, fixed_int_bits)) {
	if (!clamp_coordinates)
	    return_error(gs_error_limitcheck);
	clamp_point(ppt, x, y);
    } else {
	/* 181-01.ps" fails with no rounding in 
	   "Verify as last element of a userpath and effect on setbbox." */
	ppt-&gt;x = float2fixed_rounded(x);
	ppt-&gt;y = float2fixed_rounded(y);
    }
    return 0;
}

int
gs_moveto_aux(gs_imager_state *pis, gx_path *ppath, floatp x, floatp y)
{
    gs_fixed_point pt;
    int code;

    code = clamp_point_aux(pis-&gt;clamp_coordinates, &amp;pt, x, y);
    if (code &lt; 0)
	return code;
    code = gx_path_add_point(ppath, pt.x, pt.y);
    if (code &lt; 0)
	return code;
    ppath-&gt;start_flags = ppath-&gt;state_flags;
    gx_setcurrentpoint(pis, x, y);
    pis-&gt;subpath_start = pis-&gt;current_point;
    pis-&gt;current_point_valid = true;
    return 0;
}

int
gs_moveto(gs_state * pgs, floatp x, floatp y)
{
    gs_point pt;
    int code = gs_point_transform_compat(x, y, &amp;pgs-&gt;ctm, &amp;pt);

    if (code &lt; 0)
	return code;
    return gs_moveto_aux((gs_imager_state *)pgs, pgs-&gt;path, pt.x, pt.y);
}

int
gs_rmoveto(gs_state * pgs, floatp x, floatp y)
{
    gs_point dd;
    int code; 

    if (!pgs-&gt;current_point_valid)
	return_error(gs_error_nocurrentpoint);
    code = gs_distance_transform_compat(x, y, &amp;pgs-&gt;ctm, &amp;dd);
    if (code &lt; 0)
	return code;
    /* fixme : check in range. */
    return gs_moveto_aux((gs_imager_state *)pgs, pgs-&gt;path, 
		dd.x + pgs-&gt;current_point.x, dd.y + pgs-&gt;current_point.y);
}

private inline int
gs_lineto_aux(gs_state * pgs, floatp x, floatp y)
{
    gx_path *ppath = pgs-&gt;path;
    gs_fixed_point pt;
    int code;

    code = clamp_point_aux(pgs-&gt;clamp_coordinates, &amp;pt, x, y);
    if (code &lt; 0)
	return code;
    code = gx_path_add_line(ppath, pt.x, pt.y);
    if (code &lt; 0)
	return code;
    gx_setcurrentpoint(pgs, x, y);
    return 0;
}

int
gs_lineto(gs_state * pgs, floatp x, floatp y)
{
    gs_point pt;
    int code = gs_point_transform_compat(x, y, &amp;pgs-&gt;ctm, &amp;pt);

    if (code &lt; 0)
	return code;
    return gs_lineto_aux(pgs, pt.x, pt.y);
}

int
gs_rlineto(gs_state * pgs, floatp x, floatp y)
{
    gs_point dd;
    int code; 

    if (!pgs-&gt;current_point_valid)
	return_error(gs_error_nocurrentpoint);
    code = gs_distance_transform_compat(x, y, &amp;pgs-&gt;ctm, &amp;dd);
    if (code &lt; 0)
	return code;
    /* fixme : check in range. */
    return gs_lineto_aux(pgs, dd.x + pgs-&gt;current_point.x, 
                              dd.y + pgs-&gt;current_point.y);
}

/* ------ Curves ------ */

private inline int
gs_curveto_aux(gs_state * pgs,
	   floatp x1, floatp y1, floatp x2, floatp y2, floatp x3, floatp y3)
{
    gs_fixed_point p1, p2, p3;
    int code;
    gx_path *ppath = pgs-&gt;path;

    code = clamp_point_aux(pgs-&gt;clamp_coordinates, &amp;p1, x1, y1);
    if (code &lt; 0)
	return code;
    code = clamp_point_aux(pgs-&gt;clamp_coordinates, &amp;p2, x2, y2);
    if (code &lt; 0)
	return code;
    code = clamp_point_aux(pgs-&gt;clamp_coordinates, &amp;p3, x3, y3);
    if (code &lt; 0)
	return code;
    code = gx_path_add_curve(ppath, p1.x, p1.y, p2.x, p2.y, p3.x, p3.y);
    if (code &lt; 0)
	return code;
    gx_setcurrentpoint(pgs, x3, y3);
    return 0;
}

int
gs_curveto(gs_state * pgs,
	   floatp x1, floatp y1, floatp x2, floatp y2, floatp x3, floatp y3)
{
    gs_point pt1, pt2, pt3;
    int code;

    code = gs_point_transform_compat(x1, y1, &amp;pgs-&gt;ctm, &amp;pt1);
    if (code &lt; 0)
	return code;
    code = gs_point_transform_compat(x2, y2, &amp;pgs-&gt;ctm, &amp;pt2);
    if (code &lt; 0)
	return code;
    code = gs_point_transform_compat(x3, y3, &amp;pgs-&gt;ctm, &amp;pt3);
    if (code &lt; 0)
	return code;
    return gs_curveto_aux(pgs,   pt1.x, pt1.y,   pt2.x, pt2.y,   pt3.x, pt3.y);
}

int
gs_rcurveto(gs_state * pgs,
     floatp dx1, floatp dy1, floatp dx2, floatp dy2, floatp dx3, floatp dy3)
{
    gs_point dd1, dd2, dd3;
    int code; 

    if (!pgs-&gt;current_point_valid)
	return_error(gs_error_nocurrentpoint);
    code = gs_distance_transform_compat(dx1, dy1, &amp;pgs-&gt;ctm, &amp;dd1);
    if (code &lt; 0)
	return code;
    code = gs_distance_transform_compat(dx2, dy2, &amp;pgs-&gt;ctm, &amp;dd2);
    if (code &lt; 0)
	return code;
    code = gs_distance_transform_compat(dx3, dy3, &amp;pgs-&gt;ctm, &amp;dd3);
    if (code &lt; 0)
	return code;
    /* fixme : check in range. */
    return gs_curveto_aux(pgs, dd1.x + pgs-&gt;current_point.x, dd1.y + pgs-&gt;current_point.y, 
			       dd2.x + pgs-&gt;current_point.x, dd2.y + pgs-&gt;current_point.y, 
			       dd3.x + pgs-&gt;current_point.x, dd3.y + pgs-&gt;current_point.y);
}

/* ------ Clipping ------ */

/* Forward references */
private int common_clip(gs_state *, int);

/*
 * Return the effective clipping path of a graphics state.  Sometimes this
 * is the intersection of the clip path and the view clip path; sometimes it
 * is just the clip path.  We aren't sure what the correct algorithm is for
 * this: for now, we use view clipping unless the current device is a memory
 * device.  This takes care of the most important case, where the current
 * device is a cache device.
 */
int
gx_effective_clip_path(gs_state * pgs, gx_clip_path ** ppcpath)
{
    gs_id view_clip_id =
	(pgs-&gt;view_clip == 0 || pgs-&gt;view_clip-&gt;rule == 0 ? gs_no_id :
	 pgs-&gt;view_clip-&gt;id);

    if (gs_device_is_memory(pgs-&gt;device)) {
	*ppcpath = pgs-&gt;clip_path;
	return 0;
    }
    if (pgs-&gt;effective_clip_id == pgs-&gt;clip_path-&gt;id &amp;&amp;
	pgs-&gt;effective_view_clip_id == view_clip_id
	) {
	*ppcpath = pgs-&gt;effective_clip_path;
	return 0;
    }
    /* Update the cache. */
    if (view_clip_id == gs_no_id) {
	if (!pgs-&gt;effective_clip_shared)
	    gx_cpath_free(pgs-&gt;effective_clip_path, "gx_effective_clip_path");
	pgs-&gt;effective_clip_path = pgs-&gt;clip_path;
	pgs-&gt;effective_clip_shared = true;
    } else {
	gs_fixed_rect cbox, vcbox;

	gx_cpath_inner_box(pgs-&gt;clip_path, &amp;cbox);
	gx_cpath_outer_box(pgs-&gt;view_clip, &amp;vcbox);
	if (rect_within(vcbox, cbox)) {
	    if (!pgs-&gt;effective_clip_shared)
		gx_cpath_free(pgs-&gt;effective_clip_path,
			      "gx_effective_clip_path");
	    pgs-&gt;effective_clip_path = pgs-&gt;view_clip;
	    pgs-&gt;effective_clip_shared = true;
	} else {
	    /* Construct the intersection of the two clip paths. */
	    int code;
	    gx_clip_path ipath;
	    gx_path vpath;
	    gx_clip_path *npath = pgs-&gt;effective_clip_path;

	    if (pgs-&gt;effective_clip_shared) {
		npath = gx_cpath_alloc(pgs-&gt;memory, "gx_effective_clip_path");
		if (npath == 0)
		    return_error(gs_error_VMerror);
	    }
	    gx_cpath_init_local(&amp;ipath, pgs-&gt;memory);
	    code = gx_cpath_assign_preserve(&amp;ipath, pgs-&gt;clip_path);
	    if (code &lt; 0)
		return code;
	    gx_path_init_local(&amp;vpath, pgs-&gt;memory);
	    code = gx_cpath_to_path(pgs-&gt;view_clip, &amp;vpath);
	    if (code &lt; 0 ||
		(code = gx_cpath_clip(pgs, &amp;ipath, &amp;vpath,
				      gx_rule_winding_number)) &lt; 0 ||
		(code = gx_cpath_assign_free(npath, &amp;ipath)) &lt; 0
		)
		DO_NOTHING;
	    gx_path_free(&amp;vpath, "gx_effective_clip_path");
	    gx_cpath_free(&amp;ipath, "gx_effective_clip_path");
	    if (code &lt; 0)
		return code;
	    pgs-&gt;effective_clip_path = npath;
	    pgs-&gt;effective_clip_shared = false;
	}
    }
    pgs-&gt;effective_clip_id = pgs-&gt;effective_clip_path-&gt;id;
    pgs-&gt;effective_view_clip_id = view_clip_id;
    *ppcpath = pgs-&gt;effective_clip_path;
    return 0;
}

#ifdef DEBUG
/* Note that we just set the clipping path (internal). */
private void
note_set_clip_path(const gs_state * pgs)
{
    if (gs_debug_c('P')) {
	dlprintf("[P]Clipping path:\n");
	gx_cpath_print(pgs-&gt;clip_path);
    }
}
#else
#  define note_set_clip_path(pgs) DO_NOTHING
#endif

int
gs_clippath(gs_state * pgs)
{
    gx_path cpath;
    int code;

    gx_path_init_local(&amp;cpath, pgs-&gt;path-&gt;memory);
    code = gx_cpath_to_path(pgs-&gt;clip_path, &amp;cpath);
    if (code &gt;= 0)
	code = gx_path_assign_free(pgs-&gt;path, &amp;cpath);
    if (code &lt; 0)
	gx_path_free(&amp;cpath, "gs_clippath");
    return code;
}

int
gs_initclip(gs_state * pgs)
{
    gs_fixed_rect box;
    int code = gx_default_clip_box(pgs, &amp;box);

    if (code &lt; 0)
	return code;
    return gx_clip_to_rectangle(pgs, &amp;box);
}

int
gs_clip(gs_state * pgs)
{
    return common_clip(pgs, gx_rule_winding_number);
}

int
gs_eoclip(gs_state * pgs)
{
    return common_clip(pgs, gx_rule_even_odd);
}

private int
common_clip(gs_state * pgs, int rule)
{
    int code = gx_cpath_clip(pgs, pgs-&gt;clip_path, pgs-&gt;path, rule);
    if (code &lt; 0)
	return code;
    pgs-&gt;clip_path-&gt;rule = rule;
    note_set_clip_path(pgs);
    return 0;
}

/* Establish a rectangle as the clipping path. */
/* Used by initclip and by the character and Pattern cache logic. */
int
gx_clip_to_rectangle(gs_state * pgs, gs_fixed_rect * pbox)
{
    int code = gx_cpath_from_rectangle(pgs-&gt;clip_path, pbox);

    if (code &lt; 0)
	return code;
    pgs-&gt;clip_path-&gt;rule = gx_rule_winding_number;
    note_set_clip_path(pgs);
    return 0;
}

/* Set the clipping path to the current path, without intersecting. */
/* This is very inefficient right now. */
int
gx_clip_to_path(gs_state * pgs)
{
    gs_fixed_rect bbox;
    int code;

    if ((code = gx_path_bbox(pgs-&gt;path, &amp;bbox)) &lt; 0 ||
	(code = gx_clip_to_rectangle(pgs, &amp;bbox)) &lt; 0 ||
	(code = gs_clip(pgs)) &lt; 0
	)
	return code;
    note_set_clip_path(pgs);
    return 0;
}

/* Get the default clipping box. */
int
gx_default_clip_box(const gs_state * pgs, gs_fixed_rect * pbox)
{
    register gx_device *dev = gs_currentdevice(pgs);
    gs_rect bbox;
    gs_matrix imat;
    int code;

    if (dev-&gt;ImagingBBox_set) {	/* Use the ImagingBBox, relative to default user space. */
	gs_defaultmatrix(pgs, &amp;imat);
	bbox.p.x = dev-&gt;ImagingBBox[0];
	bbox.p.y = dev-&gt;ImagingBBox[1];
	bbox.q.x = dev-&gt;ImagingBBox[2];
	bbox.q.y = dev-&gt;ImagingBBox[3];
    } else {			/* Use the MediaSize indented by the HWMargins, */
	/* relative to unrotated user space adjusted by */
	/* the Margins.  (We suspect this isn't quite right, */
	/* but the whole issue of "margins" is such a mess that */
	/* we don't think we can do any better.) */
	(*dev_proc(dev, get_initial_matrix)) (dev, &amp;imat);
	/* Adjust for the Margins. */
	imat.tx += dev-&gt;Margins[0] * dev-&gt;HWResolution[0] /
	    dev-&gt;MarginsHWResolution[0];
	imat.ty += dev-&gt;Margins[1] * dev-&gt;HWResolution[1] /
	    dev-&gt;MarginsHWResolution[1];
	bbox.p.x = dev-&gt;HWMargins[0];
	bbox.p.y = dev-&gt;HWMargins[1];
	bbox.q.x = dev-&gt;MediaSize[0] - dev-&gt;HWMargins[2];
	bbox.q.y = dev-&gt;MediaSize[1] - dev-&gt;HWMargins[3];
    }
    code = gs_bbox_transform(&amp;bbox, &amp;imat, &amp;bbox);
    if (code &lt; 0)
	return code;
    /* Round the clipping box so that it doesn't get ceilinged. */
    pbox-&gt;p.x = fixed_rounded(float2fixed(bbox.p.x));
    pbox-&gt;p.y = fixed_rounded(float2fixed(bbox.p.y));
    pbox-&gt;q.x = fixed_rounded(float2fixed(bbox.q.x));
    pbox-&gt;q.y = fixed_rounded(float2fixed(bbox.q.y));
    return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

