<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gstype42.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gstype42.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1996, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gstype42.c,v 1.51 2005/03/15 11:36:37 igor Exp $ */
/* Type 42 (TrueType) font library routines */
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsccode.h"
#include "gsline.h"		/* for gs_imager_setflat */
#include "gsmatrix.h"
#include "gsutil.h"
#include "gxchrout.h"
#include "gxfixed.h"		/* for gxpath.h */
#include "gxpath.h"
#include "gxfont.h"
#include "gxfont42.h"
#include "gxttf.h"
#include "gxttfb.h"
#include "gxfcache.h"
#include "gxistate.h"
#include "stream.h"

void abort(void);

/* Structure descriptor */
public_st_gs_font_type42();

/* Forward references */
private int append_outline_fitted(uint glyph_index, const gs_matrix * pmat,
	       gx_path * ppath, cached_fm_pair * pair, 
	       const gs_log2_scale_point * pscale, bool design_grid);
private uint default_get_glyph_index(gs_font_type42 *pfont, gs_glyph glyph);
private int default_get_outline(gs_font_type42 *pfont, uint glyph_index,
				gs_glyph_data_t *pgd);

/* Set up a pointer to a substring of the font data. */
/* Free variables: pfont, string_proc. */
#define ACCESS(base, length, vptr)\
  BEGIN\
    code = (*string_proc)(pfont, (ulong)(base), length, &amp;vptr);\
    if ( code &lt; 0 ) return code;\
    if ( code &gt; 0 ) return_error(gs_error_invalidfont);\
  END

/* Get 2- or 4-byte quantities from a table. */
#define U8(p) ((uint)((p)[0]))
#define S8(p) (int)((U8(p) ^ 0x80) - 0x80)
#define U16(p) (((uint)((p)[0]) &lt;&lt; 8) + (p)[1])
#define S16(p) (int)((U16(p) ^ 0x8000) - 0x8000)
#define u32(p) get_u32_msb(p)

/* ---------------- Font level ---------------- */

GS_NOTIFY_PROC(gs_len_glyphs_release);

/* Get the offset to a glyph using the loca table */
private inline ulong
get_glyph_offset(gs_font_type42 *pfont, uint glyph_index) 
{
    int (*string_proc)(gs_font_type42 *, ulong, uint, const byte **) =
	pfont-&gt;data.string_proc;
    const byte *ploca;
    ulong result;
    int code;		/* hidden variable used by ACCESS */

    if (pfont-&gt;data.indexToLocFormat) {
	ACCESS(pfont-&gt;data.loca + glyph_index * 4, 4, ploca);
	result = u32(ploca);
    } else {
	ACCESS(pfont-&gt;data.loca + glyph_index * 2, 2, ploca);
	result = (ulong) U16(ploca) &lt;&lt; 1;
    }
    return result;
}

/*
 * Initialize the cached values in a Type 42 font.
 * Note that this initializes the type42_data procedures other than
 * string_proc, and the font procedures as well.
 */
int
gs_type42_font_init(gs_font_type42 * pfont)
{
    int (*string_proc)(gs_font_type42 *, ulong, uint, const byte **) =
	pfont-&gt;data.string_proc;
    const byte *OffsetTable;
    uint numTables;
    const byte *TableDirectory;
    uint i;
    int code;
    byte head_box[8];
    ulong loca_size = 0;
    ulong glyph_start, glyph_offset, glyph_length;

    ACCESS(0, 12, OffsetTable);
    {
	static const byte version1_0[4] = {0, 1, 0, 0};
	static const byte version_true[4] = {'t', 'r', 'u', 'e'};

	if (memcmp(OffsetTable, version1_0, 4) &amp;&amp;
	    memcmp(OffsetTable, version_true, 4))
	    return_error(gs_error_invalidfont);
    }
    numTables = U16(OffsetTable + 4);
    ACCESS(12, numTables * 16, TableDirectory);
    /* Clear all non-client-supplied data. */
    {
	void *proc_data = pfont-&gt;data.proc_data;

	memset(&amp;pfont-&gt;data, 0, sizeof(pfont-&gt;data));
	pfont-&gt;data.string_proc = string_proc;
	pfont-&gt;data.proc_data = proc_data;
    }
    for (i = 0; i &lt; numTables; ++i) {
	const byte *tab = TableDirectory + i * 16;
	ulong offset = u32(tab + 8);

	if (!memcmp(tab, "cmap", 4))
	    pfont-&gt;data.cmap = offset;
	else if (!memcmp(tab, "glyf", 4))
	    pfont-&gt;data.glyf = offset;
	else if (!memcmp(tab, "head", 4)) {
	    const byte *head;

	    ACCESS(offset, 54, head);
	    pfont-&gt;data.unitsPerEm = U16(head + 18);
	    memcpy(head_box, head + 36, 8);
	    pfont-&gt;data.indexToLocFormat = U16(head + 50);
	} else if (!memcmp(tab, "hhea", 4)) {
	    const byte *hhea;

	    ACCESS(offset, 36, hhea);
	    pfont-&gt;data.metrics[0].numMetrics = U16(hhea + 34);
	} else if (!memcmp(tab, "hmtx", 4)) {
	    pfont-&gt;data.metrics[0].offset = offset;
	    pfont-&gt;data.metrics[0].length = (uint)u32(tab + 12);
	} else if (!memcmp(tab, "loca", 4)) {
	    pfont-&gt;data.loca = offset;
	    loca_size = u32(tab + 12);
	} else if (!memcmp(tab, "maxp", 4)) {
	    const byte *maxp;

	    ACCESS(offset, 30, maxp);
	    pfont-&gt;data.trueNumGlyphs = U16(maxp + 4);
	} else if (!memcmp(tab, "vhea", 4)) {
	    const byte *vhea;

	    ACCESS(offset, 36, vhea);
	    pfont-&gt;data.metrics[1].numMetrics = U16(vhea + 34);
	} else if (!memcmp(tab, "vmtx", 4)) {
	    pfont-&gt;data.metrics[1].offset = offset;
	    pfont-&gt;data.metrics[1].length = (uint)u32(tab + 12);
	}
    }
    loca_size &gt;&gt;= pfont-&gt;data.indexToLocFormat + 1;
    pfont-&gt;data.numGlyphs = (loca_size == 0 ? 0 : loca_size - 1);
    /* Now build the len_glyphs array since 'loca' may not be properly sorted */
    pfont-&gt;data.len_glyphs = (uint *)gs_alloc_bytes(pfont-&gt;memory, pfont-&gt;data.numGlyphs * sizeof(uint),
	    "gs_type42_font");
    if (pfont-&gt;data.len_glyphs == 0)
	return_error(gs_error_VMerror);
    gs_font_notify_register((gs_font *)pfont, gs_len_glyphs_release, (void *)pfont);
 
    /* The 'loca' may not be in order, so we construct a glyph length array */
    /* Since 'loca' is usually sorted, first try the simple linear scan to  */
    /* avoid the need to perform the more expensive process. */
    glyph_start = get_glyph_offset(pfont, 0);
    for (i=1; i &lt; loca_size; i++) {
	glyph_offset = get_glyph_offset(pfont, i);
	glyph_length = glyph_offset - glyph_start;
	if (glyph_length &gt; 0x80000000)
	    break;				/* out of order loca */
	pfont-&gt;data.len_glyphs[i-1] = glyph_length;
	glyph_start = glyph_offset;
    }
    if (i &lt; loca_size) {
        uint j;
	ulong trial_glyph_length;
        /*
         * loca was out of order, build the len_glyphs the hard way      
	 * Assume that some of the len_glyphs built so far may be wrong 
	 * For each starting offset, find the next higher ending offset
	 * Note that doing this means that there can only be zero length
	 * glyphs that have loca table offset equal to the last 'dummy'
         * entry. Otherwise we assume that it is a duplicated entry.
	 */
	for (i=0; i &lt; loca_size-1; i++) {
	    glyph_start = get_glyph_offset(pfont, i);
	    for (j=1, glyph_length = 0x80000000; j&lt;loca_size; j++) {
		glyph_offset = get_glyph_offset(pfont, j);
		trial_glyph_length = glyph_offset - glyph_start;
		if ((trial_glyph_length &gt; 0) &amp;&amp; (trial_glyph_length &lt; glyph_length))
		    glyph_length = trial_glyph_length;
	    }
	    pfont-&gt;data.len_glyphs[i] = glyph_length &lt; 0x80000000 ? glyph_length : 0;
	}
    }
    /*
     * If the font doesn't have a valid FontBBox, compute one from the
     * 'head' information.  Since the Adobe PostScript driver sometimes
     * outputs garbage FontBBox values, we use a "reasonableness" check
     * here.
     */
    if (pfont-&gt;FontBBox.p.x &gt;= pfont-&gt;FontBBox.q.x ||
	pfont-&gt;FontBBox.p.y &gt;= pfont-&gt;FontBBox.q.y ||
	pfont-&gt;FontBBox.p.x &lt; -0.5 || pfont-&gt;FontBBox.p.x &gt; 0.5 ||
	pfont-&gt;FontBBox.p.y &lt; -0.5 || pfont-&gt;FontBBox.p.y &gt; 0.5
	) {
	float upem = (float)pfont-&gt;data.unitsPerEm;

	if (upem == 0)
		abort(); /* "gs_type42_init_font: 0 pfont-&gt;data.unitsPerEm" */
	pfont-&gt;FontBBox.p.x = S16(head_box) / upem;
	pfont-&gt;FontBBox.p.y = S16(head_box + 2) / upem;
	pfont-&gt;FontBBox.q.x = S16(head_box + 4) / upem;
	pfont-&gt;FontBBox.q.y = S16(head_box + 6) / upem;
    }
    pfont-&gt;data.warning_patented = false;
    pfont-&gt;data.warning_bad_instruction = false;
    pfont-&gt;data.get_glyph_index = default_get_glyph_index;
    pfont-&gt;data.get_outline = default_get_outline;
    pfont-&gt;data.get_metrics = gs_type42_default_get_metrics;
    pfont-&gt;procs.glyph_outline = gs_type42_glyph_outline;
    pfont-&gt;procs.glyph_info = gs_type42_glyph_info;
    pfont-&gt;procs.enumerate_glyph = gs_type42_enumerate_glyph;
    return 0;
}

int
gs_len_glyphs_release(void *data, void *event)
{   
    gs_font_type42 *pfont = (gs_font_type42 *)data;

    gs_font_notify_unregister((gs_font *)pfont, gs_len_glyphs_release, (void *)data);
    gs_free_object(pfont-&gt;memory, pfont-&gt;data.len_glyphs, "gs_len_glyphs_release");
    return 0;
}

/* ---------------- Glyph level ---------------- */

double
recipunitsperem(gs_font_type42 *pfont)
{
	if (pfont-&gt;data.unitsPerEm == 0)
		abort(); /* "recipunitsperem: 0 pfont-&gt;data.unitsPerEm" */
	return 1. / pfont-&gt;data.unitsPerEm;
}

/*
 * Parse the definition of one component of a composite glyph.  We don't
 * bother to parse the component index, since the caller can do this so
 * easily.
 */
private void
parse_component(const byte **pdata, uint *pflags, gs_matrix_fixed *psmat,
		int *pmp /*[2], may be null*/, const gs_font_type42 *pfont,
		const gs_matrix_fixed *pmat)
{
    const byte *gdata = *pdata;
    uint flags;
    double factor = recipunitsperem(pfont);
    gs_matrix_fixed mat;
    gs_matrix scale_mat;

    flags = U16(gdata);
    gdata += 4;
    mat = *pmat;
    if (flags &amp; TT_CG_ARGS_ARE_XY_VALUES) {
	int arg1, arg2;
	gs_fixed_point pt;

	if (flags &amp; TT_CG_ARGS_ARE_WORDS)
	    arg1 = S16(gdata), arg2 = S16(gdata + 2), gdata += 4;
	else
	    arg1 = S8(gdata), arg2 = S8(gdata + 1), gdata += 2;
	if (flags &amp; TT_CG_ROUND_XY_TO_GRID) {
	    /* We should do something here, but we don't. */
	}
	gs_point_transform2fixed(pmat, arg1 * factor,
				 arg2 * factor, &amp;pt);
	/****** HACK: WE KNOW ABOUT FIXED MATRICES ******/
	mat.tx = fixed2float(mat.tx_fixed = pt.x);
	mat.ty = fixed2float(mat.ty_fixed = pt.y);
	if (pmp)
	    pmp[0] = pmp[1] = -1;
    } else {
	if (flags &amp; TT_CG_ARGS_ARE_WORDS) {
	    if (pmp)
		pmp[0] = U16(gdata), pmp[1] = S16(gdata + 2);
	    gdata += 4;
	} else {
	    if (pmp)
		pmp[0] = U8(gdata), pmp[1] = U8(gdata + 1);
	    gdata += 2;
	}
    }
#define S2_14(p) (S16(p) / 16384.0)
    if (flags &amp; TT_CG_HAVE_SCALE) {
	scale_mat.xx = scale_mat.yy = S2_14(gdata);
	scale_mat.xy = scale_mat.yx = 0;
	gdata += 2;
    } else if (flags &amp; TT_CG_HAVE_XY_SCALE) {
	scale_mat.xx = S2_14(gdata);
	scale_mat.yy = S2_14(gdata + 2);
	scale_mat.xy = scale_mat.yx = 0;
	gdata += 4;
    } else if (flags &amp; TT_CG_HAVE_2X2) {
	scale_mat.xx = S2_14(gdata);
	scale_mat.xy = S2_14(gdata + 2);
	scale_mat.yx = S2_14(gdata + 4);
	scale_mat.yy = S2_14(gdata + 6);
	gdata += 8;
    } else
	goto no_scale;
#undef S2_14
    scale_mat.tx = 0;
    scale_mat.ty = 0;
    /* The scale doesn't affect mat.t{x,y}, so we don't */
    /* need to update the fixed components. */
    gs_matrix_multiply(&amp;scale_mat, (const gs_matrix *)&amp;mat,
		       (gs_matrix *)&amp;mat);
no_scale:
    *pdata = gdata;
    *pflags = flags;
    *psmat = mat;
}

/* Compute the total number of points in a (possibly composite) glyph. */
private int
total_points(gs_font_type42 *pfont, uint glyph_index)
{
    gs_glyph_data_t glyph_data;
    int code;
    int ocode;
    const byte *gdata;
    int total;

    glyph_data.memory = pfont-&gt;memory;
    ocode = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;glyph_data);
    if (ocode &lt; 0)
	return ocode;
    if (glyph_data.bits.size == 0)
	return 0;
    gdata = glyph_data.bits.data;
    if (S16(gdata) != -1) {
	/* This is a simple glyph. */
	int numContours = S16(gdata);
	const byte *pends = gdata + 10;
	const byte *pinstr = pends + numContours * 2;

	total = (numContours == 0 ? 0 : U16(pinstr - 2) + 1);
    } else {
	/* This is a composite glyph.  Add up the components. */
	uint flags;
	gs_matrix_fixed mat;

	gdata += 10;
	memset(&amp;mat, 0, sizeof(mat)); /* arbitrary */
	total = 0;
	do {
	    code = total_points(pfont, U16(gdata + 2));
	    if (code &lt; 0)
		return code;
	    total += code;
	    parse_component(&amp;gdata, &amp;flags, &amp;mat, NULL, pfont, &amp;mat);
	}
	while (flags &amp; TT_CG_MORE_COMPONENTS);
    }
    gs_glyph_data_free(&amp;glyph_data, "total_points");
    return total;
}

/*
 * Define the default implementation for getting the glyph index from a
 * gs_glyph.  This is trivial for integer ("CID" but representing a GID)
 * gs_glyph values, and not implemented for name glyphs.
 */
private uint
default_get_glyph_index(gs_font_type42 *pfont, gs_glyph glyph)
{
    return (glyph &lt; GS_MIN_CID_GLYPH ? 0 : /* undefined */
	    glyph - GS_MIN_CID_GLYPH);
}

/* Define the default implementation for getting the outline data for */
/* a glyph, using indexToLocFormat and the loca and glyf tables. */
/* Set pglyph-&gt;data = 0 if the glyph is empty. */
private int
default_get_outline(gs_font_type42 * pfont, uint glyph_index,
		    gs_glyph_data_t *pgd)
{
    int (*string_proc) (gs_font_type42 *, ulong, uint, const byte **) =
	pfont-&gt;data.string_proc;
    ulong glyph_start;
    uint glyph_length;
    int code;

    glyph_start = get_glyph_offset(pfont, glyph_index);
    glyph_length = pfont-&gt;data.len_glyphs[glyph_index];
    if (glyph_length == 0)
	gs_glyph_data_from_null(pgd);
    else {
	const byte *data;
	byte *buf;

	code = (*string_proc)(pfont, (ulong)(pfont-&gt;data.glyf + glyph_start),
			      glyph_length, &amp;data);
	if (code &lt; 0) 
	    return code;
	if (code == 0)
	    gs_glyph_data_from_string(pgd, data, glyph_length, NULL);
	else {
	    /*
	     * The glyph is segmented in sfnts. 
	     * It is not allowed with Type 42 specification.
	     * Perhaps we can handle it (with a low performance),
	     * making a contiguous copy.
	     */
	    uint left = glyph_length;

	    /* 'code' is the returned length */
	    buf = (byte *)gs_alloc_string(pgd-&gt;memory, glyph_length, "default_get_outline");
	    if (buf == 0)
		return_error(gs_error_VMerror);
	    gs_glyph_data_from_string(pgd, buf, glyph_length, (gs_font *)pfont);
	    for (;;) {
		memcpy(buf + glyph_length - left, data, code);
		if (!(left -= code))
		    return 0;
		code = (*string_proc)(pfont, (ulong)(pfont-&gt;data.glyf + glyph_start + 
		              glyph_length - left), left, &amp;data);
		if (code &lt; 0) 
		    return code;
		if (code == 0) 
		    code = left;
	    }
	}
    }
    return 0;
}

/* Take outline data from a True Type font file. */
int
gs_type42_get_outline_from_TT_file(gs_font_type42 * pfont, stream *s, uint glyph_index,
		gs_glyph_data_t *pgd)
{
    uchar lbuf[8];
    ulong glyph_start;
    uint glyph_length, count;

    /* fixme: Since this function is being called multiple times per glyph,
     * we should cache glyph data in a buffer associated with the font.
     */
    if (pfont-&gt;data.indexToLocFormat) {
	sseek(s, pfont-&gt;data.loca + glyph_index * 4);
        sgets(s, lbuf, 8, &amp;count);
	if (count &lt; 8)
	    return_error(gs_error_invalidfont);
	glyph_start = u32(lbuf);
	glyph_length = u32(lbuf + 4) - glyph_start;
    } else {
	sseek(s, pfont-&gt;data.loca + glyph_index * 2);
        sgets(s, lbuf, 4, &amp;count);
	if (count &lt; 4)
	    return_error(gs_error_invalidfont);
	glyph_start = (ulong) U16(lbuf) &lt;&lt; 1;
	glyph_length = ((ulong) U16(lbuf + 2) &lt;&lt; 1) - glyph_start;
    }
    if (glyph_length == 0)
	gs_glyph_data_from_null(pgd);
    else {
	byte *buf;

	sseek(s, pfont-&gt;data.glyf + glyph_start);
	buf = (byte *)gs_alloc_string(pgd-&gt;memory, glyph_length, "default_get_outline");
	if (buf == 0)
	    return_error(gs_error_VMerror);
	gs_glyph_data_from_string(pgd, buf, glyph_length, (gs_font *)pfont);
        sgets(s, buf, glyph_length, &amp;count);
	if (count &lt; glyph_length)
	    return_error(gs_error_invalidfont);
    }
    return 0;
}

/* Parse a glyph into pieces, if any. */
private int
parse_pieces(gs_font_type42 *pfont, gs_glyph glyph, gs_glyph *pieces,
	     int *pnum_pieces)
{
    uint glyph_index = (glyph &gt;= GS_MIN_GLYPH_INDEX 
			? glyph - GS_MIN_GLYPH_INDEX 
			: pfont-&gt;data.get_glyph_index(pfont, glyph));
    gs_glyph_data_t glyph_data;
    int code;

    glyph_data.memory = pfont-&gt;memory;
    code = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;glyph_data);
    if (code &lt; 0)
	return code;
    if (glyph_data.bits.size != 0 &amp;&amp; S16(glyph_data.bits.data) == -1) {
	/* This is a composite glyph. */
	int i = 0;
	uint flags = TT_CG_MORE_COMPONENTS;
	const byte *gdata = glyph_data.bits.data + 10;
	gs_matrix_fixed mat;

	memset(&amp;mat, 0, sizeof(mat)); /* arbitrary */
	for (i = 0; flags &amp; TT_CG_MORE_COMPONENTS; ++i) {
	    if (pieces)
		pieces[i] = U16(gdata + 2) + GS_MIN_GLYPH_INDEX;
	    parse_component(&amp;gdata, &amp;flags, &amp;mat, NULL, pfont, &amp;mat);
	}
	*pnum_pieces = i;
    } else
	*pnum_pieces = 0;
    gs_glyph_data_free(&amp;glyph_data, "parse_pieces");
    return 0;
}

/* Define the font procedures for a Type 42 font. */
int
gs_type42_glyph_outline(gs_font *font, int WMode, gs_glyph glyph, const gs_matrix *pmat,
			gx_path *ppath, double sbw[4])
{
    gs_font_type42 *const pfont = (gs_font_type42 *)font;
    uint glyph_index = (glyph &gt;= GS_MIN_GLYPH_INDEX 
		? glyph - GS_MIN_GLYPH_INDEX 
		: pfont-&gt;data.get_glyph_index(pfont, glyph));
    gs_fixed_point origin;
    int code;
    gs_glyph_info_t info;
    static const gs_matrix imat = { identity_matrix_body };
    bool design_grid = true;
    const gs_log2_scale_point log2_scale = {0, 0}; 
    /* fixme : The subpixel numbers doesn't pass through the font_proc_glyph_outline interface.
       High level devices can't get a proper grid fitting with AlignToPixels = 1.
       Currently font_proc_glyph_outline is only used by pdfwrite for computing a
       character bbox, which doesn't need a grid fitting.
       We apply design grid here.
     */
    cached_fm_pair *pair;
    code = gx_lookup_fm_pair(font, pmat, &amp;log2_scale, design_grid, &amp;pair);

    if (code &lt; 0)
	return code;
    if (pmat == 0)
	pmat = &amp;imat;
    if ((code = gx_path_current_point(ppath, &amp;origin)) &lt; 0 ||
	(code = append_outline_fitted(glyph_index, pmat, ppath, pair, 
					&amp;log2_scale, design_grid)) &lt; 0 ||
	(code = font-&gt;procs.glyph_info(font, glyph, pmat,
				       GLYPH_INFO_WIDTH0 &lt;&lt; WMode, &amp;info)) &lt; 0
	)
	return code;
    return gx_path_add_point(ppath, origin.x + float2fixed(info.width[WMode].x),
			     origin.y + float2fixed(info.width[WMode].y));
}

/* Get glyph info by glyph index. */
int
gs_type42_glyph_info_by_gid(gs_font *font, gs_glyph glyph, const gs_matrix *pmat,
		     int members, gs_glyph_info_t *info, uint glyph_index)
{
    gs_font_type42 *const pfont = (gs_font_type42 *)font;
    int default_members =
	members &amp; ~(GLYPH_INFO_WIDTHS | GLYPH_INFO_NUM_PIECES |
		    GLYPH_INFO_PIECES | GLYPH_INFO_OUTLINE_WIDTHS |
		    GLYPH_INFO_VVECTOR0 | GLYPH_INFO_VVECTOR1);
    gs_glyph_data_t outline;
    int code = 0;

    outline.memory = pfont-&gt;memory;
    if (default_members) {
	code = gs_default_glyph_info(font, glyph, pmat, default_members, info);

	if (code &lt; 0)
	    return code;
    } else if ((code = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;outline)) &lt; 0)
	return code;		/* non-existent glyph */
    else {
	gs_glyph_data_free(&amp;outline, "gs_type42_glyph_info");
	info-&gt;members = 0;
    }
    if (members &amp; GLYPH_INFO_WIDTHS) {
	int i;

	for (i = 0; i &lt; 2; ++i)
	    if (members &amp; (GLYPH_INFO_WIDTH0 &lt;&lt; i)) {
		float sbw[4];

		code = gs_type42_wmode_metrics(pfont, glyph_index, i, sbw);
		if (code &lt; 0) {
		    code = 0;
		    continue;
		}
		if (pmat) {
		    code = gs_point_transform(sbw[2], sbw[3], pmat,
					      &amp;info-&gt;width[i]);
		    if (code &lt; 0)
			return code;
		    code = gs_point_transform(sbw[0], sbw[1], pmat,
					      &amp;info-&gt;v);
		} else {
		    info-&gt;width[i].x = sbw[2], info-&gt;width[i].y = sbw[3];
		    info-&gt;v.x = sbw[0], info-&gt;v.y = sbw[1];
		}
		info-&gt;members |= (GLYPH_INFO_VVECTOR0 &lt;&lt; i);
		info-&gt;members |= (GLYPH_INFO_WIDTH &lt;&lt; i);
	    }
	
    }
    if (members &amp; (GLYPH_INFO_NUM_PIECES | GLYPH_INFO_PIECES)) {
	gs_glyph *pieces =
	    (members &amp; GLYPH_INFO_PIECES ? info-&gt;pieces : (gs_glyph *)0);
	int code = parse_pieces(pfont, glyph, pieces, &amp;info-&gt;num_pieces);

	if (code &lt; 0)
	    return code;
	info-&gt;members |= members &amp; (GLYPH_INFO_NUM_PIECES | GLYPH_INFO_PIECES);
    }
    return code;
}
int
gs_type42_glyph_info(gs_font *font, gs_glyph glyph, const gs_matrix *pmat,
		     int members, gs_glyph_info_t *info)
{
    gs_font_type42 *const pfont = (gs_font_type42 *)font;
    uint glyph_index;
    
    if (glyph &gt;= GS_MIN_GLYPH_INDEX)
	glyph_index = glyph - GS_MIN_GLYPH_INDEX;
    else {
	glyph_index = pfont-&gt;data.get_glyph_index(pfont, glyph);
	if (glyph_index == GS_NO_GLYPH)
	    return_error(gs_error_undefined);
    }
    return gs_type42_glyph_info_by_gid(font, glyph, pmat, members, info, glyph_index);

}
int
gs_type42_enumerate_glyph(gs_font *font, int *pindex,
			  gs_glyph_space_t glyph_space, gs_glyph *pglyph)
{
    gs_font_type42 *const pfont = (gs_font_type42 *)font;

    while (++*pindex &lt;= pfont-&gt;data.numGlyphs) {
	gs_glyph_data_t outline;
	uint glyph_index = *pindex - 1;
	int code;

	outline.memory = pfont-&gt;memory;
	code = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;outline);
	if (code &lt; 0)
	    return code;
	if (outline.bits.data == 0)
	    continue;		/* empty (undefined) glyph */
	*pglyph = glyph_index + GS_MIN_GLYPH_INDEX;
	gs_glyph_data_free(&amp;outline, "gs_type42_enumerate_glyph");
	return 0;
    }
    /* We are done. */
    *pindex = 0;
    return 0;
}

/* Get the metrics of a simple glyph. */
private int
simple_glyph_metrics(gs_font_type42 * pfont, uint glyph_index, int wmode,
		     float sbw[4])
{
    int (*string_proc)(gs_font_type42 *, ulong, uint, const byte **) =
	pfont-&gt;data.string_proc;
    double factor = recipunitsperem(pfont);
    uint width;
    int lsb;
    int code;

    {
	const gs_type42_mtx_t *pmtx = &amp;pfont-&gt;data.metrics[wmode];
	uint num_metrics = pmtx-&gt;numMetrics;
	const byte *pmetrics;

	if (pmtx-&gt;length == 0)
	    return_error(gs_error_rangecheck);
	if (glyph_index &lt; num_metrics) {
	    ACCESS(pmtx-&gt;offset + glyph_index * 4, 4, pmetrics);
	    width = U16(pmetrics);
	    lsb = S16(pmetrics + 2);
	} else {
	    uint offset = pmtx-&gt;offset + num_metrics * 4;
	    uint glyph_offset = (glyph_index - num_metrics) * 2;
	    const byte *plsb;

	    ACCESS(offset - 4, 4, pmetrics);
	    width = U16(pmetrics);
	    if (glyph_offset &gt;= pmtx-&gt;length)
		glyph_offset = pmtx-&gt;length - 2;
	    ACCESS(offset + glyph_offset, 2, plsb);
	    lsb = S16(plsb);
	}
    }
    if (wmode) {
	factor = -factor;	/* lsb and width go down the page */
	sbw[0] = 0, sbw[1] = lsb * factor;
	sbw[2] = 0, sbw[3] = width * factor;
    } else {
	sbw[0] = lsb * factor, sbw[1] = 0;
	sbw[2] = width * factor, sbw[3] = 0;
    }
    return 0;
}

/* Get the metrics of a glyph. */
int
gs_type42_default_get_metrics(gs_font_type42 * pfont, uint glyph_index,
			      int wmode, float sbw[4])
{
    gs_glyph_data_t glyph_data;
    int code;
    int result;

    glyph_data.memory = pfont-&gt;memory;
    code = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;glyph_data);
    if (code &lt; 0)
	return code;
    if (glyph_data.bits.size != 0 &amp;&amp; S16(glyph_data.bits.data) == -1) {
	/* This is a composite glyph. */
	uint flags;
	const byte *gdata = glyph_data.bits.data + 10;
	gs_matrix_fixed mat;

	memset(&amp;mat, 0, sizeof(mat)); /* arbitrary */
	do {
	    uint comp_index = U16(gdata + 2);

	    parse_component(&amp;gdata, &amp;flags, &amp;mat, NULL, pfont, &amp;mat);
	    if (flags &amp; TT_CG_USE_MY_METRICS) {
		result = gs_type42_wmode_metrics(pfont, comp_index, wmode, sbw);
		goto done;
	    }
	}
	while (flags &amp; TT_CG_MORE_COMPONENTS);
    }
    result = simple_glyph_metrics(pfont, glyph_index, wmode, sbw);
 done:
    gs_glyph_data_free(&amp;glyph_data, "gs_type42_default_get_metrics");
    return result;
}
int
gs_type42_wmode_metrics(gs_font_type42 * pfont, uint glyph_index, int wmode,
			float sbw[4])
{
    return pfont-&gt;data.get_metrics(pfont, glyph_index, wmode, sbw);
}
int
gs_type42_get_metrics(gs_font_type42 * pfont, uint glyph_index,
		      float sbw[4])
{
    return gs_type42_wmode_metrics(pfont, glyph_index, pfont-&gt;WMode, sbw);
}

/* Define the bits in the glyph flags. */
#define gf_OnCurve 1
#define gf_xShort 2
#define gf_yShort 4
#define gf_Repeat 8
#define gf_xPos 16		/* xShort */
#define gf_xSame 16		/* !xShort */
#define gf_yPos 32		/* yShort */
#define gf_ySame 32		/* !yShort */

/* Append a TrueType outline to a path. */
/* Note that this does not append the final moveto for the width. */
int
gs_type42_append(uint glyph_index, gs_imager_state * pis,
		 gx_path * ppath, const gs_log2_scale_point * pscale,
		 bool charpath_flag, int paint_type, cached_fm_pair *pair)
{
    int code = append_outline_fitted(glyph_index, &amp;ctm_only(pis), ppath, 
			pair, pscale, charpath_flag);

    if (code &lt; 0)
	return code;
    code = gx_setcurrentpoint_from_path(pis, ppath);
    if (code &lt; 0)
	return code;
    /* Set the flatness for curve rendering. */
    return gs_imager_setflat(pis, gs_char_flatness(pis, 1.0));
}

/* Add 2nd degree Bezier to the path */
private int
add_quadratic_curve(gx_path * const ppath, const gs_fixed_point * const a,
     const gs_fixed_point * const b, const gs_fixed_point * const c)
{
    return gx_path_add_curve(ppath, (a-&gt;x + 2*b-&gt;x)/3, (a-&gt;y + 2*b-&gt;y)/3,
	(c-&gt;x + 2*b-&gt;x)/3, (c-&gt;y + 2*b-&gt;y)/3, c-&gt;x, c-&gt;y);
}

/*
 * Append a simple glyph outline to a path (ppath != 0) and/or return
 * its list of points (ppts != 0).
 */
private int
append_simple(const byte *gdata, float sbw[4], const gs_matrix_fixed *pmat,
	      gx_path *ppath, gs_fixed_point *ppts, gs_font_type42 * pfont,
	      bool subglyph)
{
    int numContours = S16(gdata);
    const byte *pends = gdata + 10;
    const byte *pinstr = pends + numContours * 2;
    const byte *pflags;
    uint npoints;
    const byte *pxc, *pyc;
    int code;

    if (numContours == 0)
	return 0;
    /*
     * It appears that the only way to find the X and Y coordinate
     * tables is to parse the flags.  If this is true, it is an
     * incredible piece of bad design.
     */
    {
	const byte *pf = pflags = pinstr + 2 + U16(pinstr);
	uint xbytes = npoints = U16(pinstr - 2) + 1;
	uint np = npoints;

	while (np &gt; 0) {
	    byte flags = *pf++;
	    uint reps = (flags &amp; gf_Repeat ? *pf++ + 1 : 1);

	    if (!(flags &amp; gf_xShort)) {
		if (flags &amp; gf_xSame)
		    xbytes -= reps;
		else
		    xbytes += reps;
	    }
	    np -= reps;
	}
	pxc = pf;
	pyc = pxc + xbytes;
    }

    /* Interpret the contours. */

    {
	uint i, np;
	float offset = 0;
	gs_fixed_point pt;
	double factor = recipunitsperem(pfont);
	/*
	 * Decode the first flag byte outside the loop, to avoid a
	 * compiler warning about uninitialized variables.
	 */
	byte flags = *pflags++;
	uint reps = (flags &amp; gf_Repeat ? *pflags++ + 1 : 1);

	if (!subglyph) {
	    int xmin = S16(gdata + 2); /* We like to see it with debugger. */

	    offset = sbw[0] - xmin * factor;
	}
	gs_point_transform2fixed(pmat, offset, 0.0, &amp;pt);
	for (i = 0, np = 0; i &lt; numContours; ++i) {
	    bool move = true;
	    bool off_curve = false;
            bool is_start_off = false;
            uint last_point = U16(pends + i * 2);
	    float dx, dy;
	    gs_fixed_point start,pt_start_off;
	    gs_fixed_point cpoints[2];

            if_debug1('1', "[1t]start %d\n", i);
            
            for (; np &lt;= last_point; --reps, ++np) {
		gs_fixed_point dpt;

		if (reps == 0) {
		    flags = *pflags++;
		    reps = (flags &amp; gf_Repeat ? *pflags++ + 1 : 1);
		}
		if (flags &amp; gf_xShort) {
		    /*
		     * A bug in the Watcom compiler prevents us from doing
		     * the following with the obvious conditional expression.
		     */
		    if (flags &amp; gf_xPos)
			dx = *pxc++ * factor;
		    else
			dx = -(int)*pxc++ * factor;
		} else if (!(flags &amp; gf_xSame))
		    dx = S16(pxc) * factor, pxc += 2;
		else
		    dx = 0;
		if (flags &amp; gf_yShort) {
		    /* See above under dx. */
		    if (flags &amp; gf_yPos)
			dy = *pyc++ * factor;
		    else
			dy = -(int)*pyc++ * factor;
		} else if (!(flags &amp; gf_ySame))
		    dy = S16(pyc) * factor, pyc += 2;
		else
		    dy = 0;
		code = gs_distance_transform2fixed(pmat, dx, dy, &amp;dpt);
		if (code &lt; 0)
		    return code;
		pt.x += dpt.x, pt.y += dpt.y;
		
                if (ppts)	/* return the points */
		    ppts[np] = pt;
		
                if (ppath) {
                    /* append to a path */
		    if_debug3('1', "[1t]%s (%g %g)\n",
		    	(flags &amp; gf_OnCurve ? "on " : "off"), fixed2float(pt.x), fixed2float(pt.y));
                    
                    if (move) {
                        if(is_start_off) {
                            if(flags &amp; gf_OnCurve)
                                start = pt;
                            else { 
                                start.x = (pt_start_off.x + pt.x)/2;
			        start.y = (pt_start_off.y + pt.y)/2;
                                cpoints[1]=pt;
			        off_curve=true;
                            }
                            move = false;
                            cpoints[0] = start;
                            code = gx_path_add_point(ppath, start.x, start.y);
                        } else { 
                            if(flags &amp; gf_OnCurve) { 
                                cpoints[0] = start = pt;
			        code = gx_path_add_point(ppath, pt.x, pt.y);
			        move = false;
                            } else { 
                                is_start_off = true;
                                pt_start_off = pt;
                            }
                        }
		    } else if (flags &amp; gf_OnCurve) {
                        if (off_curve)
			    code = add_quadratic_curve(ppath, cpoints, cpoints+1, &amp;pt);
			else
			    code = gx_path_add_line(ppath, pt.x, pt.y);
			cpoints[0] = pt;
			off_curve = false;
		    } else {
                        if(off_curve) {
			    gs_fixed_point p;
                            p.x = (cpoints[1].x + pt.x)/2;
			    p.y = (cpoints[1].y + pt.y)/2;
			    code = add_quadratic_curve(ppath, cpoints, cpoints+1, &amp;p);
			    cpoints[0] = p;
			}
                        off_curve = true;
		        cpoints[1] = pt;
		    }
		    if (code &lt; 0)
			return code;
		}
	    }
	    if (ppath) {
		if (is_start_off) { 
                    if (off_curve) { 
                        gs_fixed_point p;
                        p.x = (cpoints[1].x + pt_start_off.x)/2;
	                p.y = (cpoints[1].y + pt_start_off.y)/2;
                        code = add_quadratic_curve(ppath, cpoints, cpoints+1, &amp;p);
		        if (code &lt; 0)
		            return code;
                        code = add_quadratic_curve(ppath, &amp;p, &amp;pt_start_off, &amp;start);
		        if (code &lt; 0)
		            return code;
                    } else { 
                        code = add_quadratic_curve(ppath, cpoints, &amp;pt_start_off, &amp;start);
		        if (code &lt; 0)
		            return code;
                    }
                } else { 
                    if (off_curve) { 
                        code = add_quadratic_curve(ppath, cpoints, cpoints+1, &amp;start);
		        if (code &lt; 0)
		            return code;
                    }
                }
                code = gx_path_close_subpath(ppath);
		if (code &lt; 0)
		    return code;
	    }
	}
    }
    return 0;
}

/* Append a glyph outline. */
private int
check_component(uint glyph_index, const gs_matrix_fixed *pmat,
		gx_path *ppath, gs_font_type42 *pfont, gs_fixed_point *ppts,
		gs_glyph_data_t *pgd, bool subglyph)
{
    gs_glyph_data_t glyph_data;
    const byte *gdata;
    float sbw[4];
    int numContours;
    int code;

    glyph_data.memory = pfont-&gt;memory;
    code = pfont-&gt;data.get_outline(pfont, glyph_index, &amp;glyph_data);
    if (code &lt; 0)
	return code;
    gdata = glyph_data.bits.data;
    if (gdata == 0 || glyph_data.bits.size == 0)	/* empty glyph */
	return 0;
    numContours = S16(gdata);
    if (numContours &gt;= 0) {
	gs_type42_get_metrics(pfont, glyph_index, sbw);
	code = append_simple(gdata, sbw, pmat, ppath, ppts, pfont, subglyph);
	gs_glyph_data_free(&amp;glyph_data, "check_component");
	return (code &lt; 0 ? code : 0); /* simple */
    }
    if (numContours != -1)
	return_error(gs_error_rangecheck);
    *pgd = glyph_data;
    return 1;			/* composite */
}
private int
append_component(uint glyph_index, const gs_matrix_fixed * pmat,
		 gx_path * ppath, gs_fixed_point *ppts, int point_index,
		 gs_font_type42 * pfont, bool subglyph)
{
    gs_glyph_data_t glyph_data;
    int code;

    glyph_data.memory = pfont-&gt;memory;
    code = check_component(glyph_index, pmat, ppath, pfont, ppts + point_index,
			   &amp;glyph_data, subglyph);
    if (code != 1)
	return code;
    /*
     * This is a composite glyph.  Because of the "point matching" feature,
     * we have to do an extra pass over each component to fill in the
     * table of points.
     */
    {
	uint flags;
	const byte *gdata = glyph_data.bits.data + 10;

	do {
	    uint comp_index = U16(gdata + 2);
	    gs_matrix_fixed mat;
	    int mp[2];

	    parse_component(&amp;gdata, &amp;flags, &amp;mat, mp, pfont, pmat);
	    if (mp[0] &gt;= 0) {
		/* Match up points.  What a nuisance! */
		const gs_fixed_point *const pfrom = ppts + mp[0];
		/*
		 * Contrary to the TrueType documentation, mp[1] is not
		 * relative to the start of the compound glyph, but is
		 * relative to the start of the component.
		 */
		const gs_fixed_point *const pto = ppts + point_index + mp[1];
		gs_fixed_point diff;

		code = append_component(comp_index, &amp;mat, NULL, ppts,
					point_index, pfont, true);
		if (code &lt; 0)
		    break;
		diff.x = pfrom-&gt;x - pto-&gt;x;
		diff.y = pfrom-&gt;y - pto-&gt;y;
		mat.tx = fixed2float(mat.tx_fixed += diff.x);
		mat.ty = fixed2float(mat.ty_fixed += diff.y);
	    }
	    code = append_component(comp_index, &amp;mat, ppath, ppts,
				    point_index, pfont, true);
	    if (code &lt; 0)
		break;
	    point_index += total_points(pfont, comp_index);
	}
	while (flags &amp; TT_CG_MORE_COMPONENTS);
    }
    gs_glyph_data_free(&amp;glyph_data, "append_component");
    return code;
}

private int
append_outline_fitted(uint glyph_index, const gs_matrix * pmat,
	       gx_path * ppath, cached_fm_pair * pair, 
	       const gs_log2_scale_point * pscale, bool design_grid)
{
    gs_font_type42 *pfont = (gs_font_type42 *)pair-&gt;font;
    int code;

    gx_ttfReader__set_font(pair-&gt;ttr, pfont);
    code = gx_ttf_outline(pair-&gt;ttf, pair-&gt;ttr, pfont, (uint)glyph_index, 
	pmat, pscale, ppath, design_grid);
    gx_ttfReader__set_font(pair-&gt;ttr, NULL);
    return code;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

