<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxccman.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxccman.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1997, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxccman.c,v 1.30 2004/12/08 21:35:13 stefan Exp $ */
/* Character cache management routines for Ghostscript library */
#include "gx.h"
#include "memory_.h"
#include "gpcheck.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsbitops.h"
#include "gsutil.h"		/* for gs_next_ids */
#include "gxfixed.h"
#include "gxmatrix.h"
#include "gzstate.h"
#include "gxpath.h"
#include "gxdevice.h"
#include "gxdevmem.h"
#include "gxchar.h"
#include "gxfont.h"
#include "gxfcache.h"
#include "gxxfont.h"
#include "gxttfb.h"
#include "gxfont42.h"
#include &lt;assert.h&gt;

/* Define the descriptors for the cache structures. */
private_st_cached_fm_pair();
private_st_cached_fm_pair_elt();
/*private_st_cached_char(); *//* unused */
private_st_cached_char_ptr();	/* unused */
private_st_cached_char_ptr_elt();
/*
 * Define a descriptor for the cache data.  This is equivalent to st_bytes,
 * but it identifies the cache data as such in a memory dump.
 */
gs_private_st_simple(st_font_cache_bytes, byte, "font cache bytes");
/* GC procedures */
/* We do all the work in font_dir_enum/reloc_ptrs in gsfont.c. */
/* See gxfcache.h for details. */
private 
ENUM_PTRS_BEGIN(cc_ptr_enum_ptrs) return 0;

ENUM_PTRS_END
private RELOC_PTRS_BEGIN(cc_ptr_reloc_ptrs)
{
}
RELOC_PTRS_END

/* Forward references */
private gx_xfont * lookup_xfont_by_name(gx_device *, const gx_xfont_procs *, gs_font_name *, int, const cached_fm_pair *, const gs_matrix *);
private cached_char *alloc_char(gs_font_dir *, ulong);
private cached_char *alloc_char_in_chunk(gs_font_dir *, ulong);
private void hash_remove_cached_char(gs_font_dir *, uint);
private void shorten_cached_char(gs_font_dir *, cached_char *, uint);

/* ====== Initialization ====== */

/* Allocate and initialize the character cache elements of a font directory. */
int
gx_char_cache_alloc(gs_memory_t * struct_mem, gs_memory_t * bits_mem,
	    gs_font_dir * pdir, uint bmax, uint mmax, uint cmax, uint upper)
{				/* Since we use open hashing, we must increase cmax somewhat. */
    uint chsize = (cmax + (cmax &gt;&gt; 1)) | 31;
    cached_fm_pair *mdata;
    cached_char **chars;

    /* Round up chsize to a power of 2. */
    while (chsize &amp; (chsize + 1))
	chsize |= chsize &gt;&gt; 1;
    chsize++;
    mdata = gs_alloc_struct_array(struct_mem, mmax, cached_fm_pair,
				  &amp;st_cached_fm_pair_element,
				  "font_dir_alloc(mdata)");
    chars = gs_alloc_struct_array(struct_mem, chsize, cached_char *,
				  &amp;st_cached_char_ptr_element,
				  "font_dir_alloc(chars)");
    if (mdata == 0 || chars == 0) {
	gs_free_object(struct_mem, chars, "font_dir_alloc(chars)");
	gs_free_object(struct_mem, mdata, "font_dir_alloc(mdata)");
	return_error(gs_error_VMerror);
    }
    pdir-&gt;fmcache.mmax = mmax;
    pdir-&gt;fmcache.mdata = mdata;
    pdir-&gt;ccache.struct_memory = struct_mem;
    pdir-&gt;ccache.bits_memory = bits_mem;
    pdir-&gt;ccache.bmax = bmax;
    pdir-&gt;ccache.cmax = cmax;
    pdir-&gt;ccache.lower = upper / 10;
    pdir-&gt;ccache.upper = upper;
    pdir-&gt;ccache.table = chars;
    pdir-&gt;ccache.table_mask = chsize - 1;
    gx_char_cache_init(pdir);
    return 0;
}

/* Initialize the character cache. */
void
gx_char_cache_init(register gs_font_dir * dir)
{
    int i;
    cached_fm_pair *pair;
    char_cache_chunk *cck = (char_cache_chunk *)
    gs_alloc_bytes_immovable(dir-&gt;ccache.bits_memory,
			     sizeof(char_cache_chunk),
			     "initial_chunk");

    dir-&gt;fmcache.msize = 0;
    dir-&gt;fmcache.mnext = 0;
    gx_bits_cache_chunk_init(cck, NULL, 0);
    gx_bits_cache_init((gx_bits_cache *) &amp; dir-&gt;ccache, cck);
    dir-&gt;ccache.bspace = 0;
    memset((char *)dir-&gt;ccache.table, 0,
	   (dir-&gt;ccache.table_mask + 1) * sizeof(cached_char *));
    for (i = 0, pair = dir-&gt;fmcache.mdata;
	 i &lt; dir-&gt;fmcache.mmax; i++, pair++) {
	pair-&gt;index = i;
	fm_pair_init(pair);
	pair-&gt;ttf = 0;
	pair-&gt;ttr = 0;
    }
}

/* ====== Purging ====== */

/* Purge from the character cache all entries selected by */
/* a client-supplied procedure. */
void
gx_purge_selected_cached_chars(gs_font_dir * dir,
			       bool(*proc) (const gs_memory_t *mem, 
					    cached_char *, void *), 
			       void *proc_data)
{
    int chi;
    int cmax = dir-&gt;ccache.table_mask;

    for (chi = 0; chi &lt;= cmax;) {
	cached_char *cc = dir-&gt;ccache.table[chi];

	if (cc != 0 &amp;&amp; (*proc) (dir-&gt;memory, cc, proc_data)) {
	    hash_remove_cached_char(dir, chi);
	    gx_free_cached_char(dir, cc);
	} else
	    chi++;
    }
}

/* ====== Font-level routines ====== */

/* Add a font/matrix pair to the cache. */
/* (This is only exported for gxccache.c.) */
int
gx_add_fm_pair(register gs_font_dir * dir, gs_font * font, const gs_uid * puid,
	       const gs_matrix * char_tm, const gs_log2_scale_point *log2_scale,
	       bool design_grid, cached_fm_pair **ppair)
{
    float mxx, mxy, myx, myy;
    register cached_fm_pair *pair = dir-&gt;fmcache.mdata + dir-&gt;fmcache.mnext;
    cached_fm_pair *mend = dir-&gt;fmcache.mdata + dir-&gt;fmcache.mmax;

    gx_compute_ccache_key(font, char_tm, log2_scale, design_grid,
			    &amp;mxx, &amp;mxy, &amp;myx, &amp;myy);
    if (dir-&gt;fmcache.msize == dir-&gt;fmcache.mmax) {	/* cache is full *//* Prefer an entry with num_chars == 0, if any. */
	int count;

	for (count = dir-&gt;fmcache.mmax;
	     --count &gt;= 0 &amp;&amp; pair-&gt;num_chars != 0;
	    )
	    if (++pair == mend)
		pair = dir-&gt;fmcache.mdata;
	gs_purge_fm_pair(dir, pair, 0);
    } else {			/* Look for an empty entry.  (We know there is one.) */
	while (!fm_pair_is_free(pair))
	    if (++pair == mend)
		pair = dir-&gt;fmcache.mdata;
    }
    dir-&gt;fmcache.msize++;
    dir-&gt;fmcache.mnext = pair + 1 - dir-&gt;fmcache.mdata;
    if (dir-&gt;fmcache.mnext == dir-&gt;fmcache.mmax)
	dir-&gt;fmcache.mnext = 0;
    pair-&gt;font = font;
    pair-&gt;UID = *puid;
    pair-&gt;FontType = font-&gt;FontType;
    /* The OSF/1 compiler doesn't like casting a pointer to */
    /* a shorter int.... */
    pair-&gt;hash = (uint) (ulong) pair % 549;	/* scramble bits */
    pair-&gt;mxx = mxx, pair-&gt;mxy = mxy;
    pair-&gt;myx = myx, pair-&gt;myy = myy;
    pair-&gt;num_chars = 0;
    pair-&gt;xfont_tried = false;
    pair-&gt;xfont = 0;
    pair-&gt;ttf = 0;
    pair-&gt;ttr = 0;
    pair-&gt;design_grid = false;
    if (font-&gt;FontType == ft_TrueType || font-&gt;FontType == ft_CID_TrueType) 
	if (((gs_font_type42 *)font)-&gt;FAPI==NULL) {
	    int code; 
	    float cxx, cxy, cyx, cyy;
	    gs_matrix m;
	    gx_compute_char_matrix(char_tm, log2_scale, &amp;cxx, &amp;cxy, &amp;cyx, &amp;cyy);

	    pair-&gt;design_grid = design_grid;
	    m.xx = cxx;
	    m.xy = cxy;
	    m.yx = cyx;
	    m.yy = cyy;
	    m.tx = m.ty = 0;
	    pair-&gt;ttr = gx_ttfReader__create(dir-&gt;memory);
	    if (!pair-&gt;ttr)
		return_error(gs_error_VMerror);
	    /*  We could use a single the reader instance for all fonts ... */
	    pair-&gt;ttf = ttfFont__create(dir);
	    if (!pair-&gt;ttf)
		return_error(gs_error_VMerror);
	    gx_ttfReader__set_font(pair-&gt;ttr, (gs_font_type42 *)font);
	    code = ttfFont__Open_aux(pair-&gt;ttf, dir-&gt;tti, pair-&gt;ttr, 
			(gs_font_type42 *)font, &amp;m, log2_scale, design_grid);
	    gx_ttfReader__set_font(pair-&gt;ttr, NULL);
	    if (code &lt; 0)
		return code;
	}
    pair-&gt;memory = 0;
    if_debug8('k', "[k]adding pair 0x%lx: font=0x%lx [%g %g %g %g] UID %ld, 0x%lx\n",
	      (ulong) pair, (ulong) font,
	      pair-&gt;mxx, pair-&gt;mxy, pair-&gt;myx, pair-&gt;myy,
	      (long)pair-&gt;UID.id, (ulong) pair-&gt;UID.xvalues);
    *ppair = pair;
    return 0;
}

/* Look up the xfont for a font/matrix pair. */
/* (This is only exported for gxccache.c.) */
void
gx_lookup_xfont(const gs_state * pgs, cached_fm_pair * pair, int encoding_index)
{
    gx_device *dev = gs_currentdevice(pgs);
    gx_device *fdev = (*dev_proc(dev, get_xfont_device)) (dev);
    gs_font *font = pair-&gt;font;
    const gx_xfont_procs *procs = (*dev_proc(fdev, get_xfont_procs)) (fdev);
    gx_xfont *xf = 0;

    /* We mustn't attempt to use xfonts for stroked characters, */
    /* because such characters go outside their bounding box. */
    if (procs != 0 &amp;&amp; font-&gt;PaintType == 0) {
	gs_matrix mat;

	mat.xx = pair-&gt;mxx, mat.xy = pair-&gt;mxy;
	mat.yx = pair-&gt;myx, mat.yy = pair-&gt;myy;
	mat.tx = 0, mat.ty = 0;
	/* xfonts can outlive their invocations, */
	/* but restore purges them properly. */
	pair-&gt;memory = pgs-&gt;memory;
	if (font-&gt;key_name.size != 0)
	    xf = lookup_xfont_by_name(fdev, procs,
				      &amp;font-&gt;key_name, encoding_index,
				      pair, &amp;mat);
#define font_name_eq(pfn1,pfn2)\
  ((pfn1)-&gt;size == (pfn2)-&gt;size &amp;&amp; (pfn1)-&gt;size != 0 &amp;&amp;\
   !memcmp((char *)(pfn1)-&gt;chars, (char *)(pfn2)-&gt;chars, (pfn1)-&gt;size))
	if (xf == 0 &amp;&amp; font-&gt;font_name.size != 0 &amp;&amp;
	/* Avoid redundant lookup */
	    !font_name_eq(&amp;font-&gt;font_name, &amp;font-&gt;key_name)
	    )
	    xf = lookup_xfont_by_name(fdev, procs,
				      &amp;font-&gt;font_name, encoding_index,
				      pair, &amp;mat);
	if (xf == 0 &amp;&amp; font-&gt;FontType != ft_composite &amp;&amp;
	    uid_is_valid(&amp;((gs_font_base *) font)-&gt;UID)
	    ) {			/* Look for an original font with the same UID. */
	    gs_font_dir *pdir = font-&gt;dir;
	    gs_font *pfont;

	    for (pfont = pdir-&gt;orig_fonts; pfont != 0;
		 pfont = pfont-&gt;next
		) {
		if (pfont-&gt;FontType != ft_composite &amp;&amp;
		    uid_equal(&amp;((gs_font_base *) pfont)-&gt;UID,
			      &amp;((gs_font_base *) font)-&gt;UID) &amp;&amp;
		    pfont-&gt;key_name.size != 0 &amp;&amp;
		    !font_name_eq(&amp;font-&gt;key_name,
				  &amp;pfont-&gt;key_name)
		    ) {
		    xf = lookup_xfont_by_name(fdev, procs,
					      &amp;pfont-&gt;key_name,
					      encoding_index, pair, &amp;mat);
		    if (xf != 0)
			break;
		}
	    }
	}
    }
    pair-&gt;xfont = xf;
}

/* ------ Internal routines ------ */

/* Purge from the caches all references to a given font/matrix pair, */
/* or just characters that depend on its xfont. */
#define cpair ((cached_fm_pair *)vpair)
private bool
purge_fm_pair_char(const gs_memory_t *mem, cached_char * cc, void *vpair)
{
    return cc_pair(cc) == cpair;
}
private bool
purge_fm_pair_char_xfont(const gs_memory_t *mem, cached_char * cc, void *vpair)
{
    return cc_pair(cc) == cpair &amp;&amp; cpair-&gt;xfont == 0 &amp;&amp; !cc_has_bits(cc);
}
#undef cpair
void
gs_purge_fm_pair(gs_font_dir * dir, cached_fm_pair * pair, int xfont_only)
{
    if_debug2('k', "[k]purging pair 0x%lx%s\n",
	      (ulong) pair, (xfont_only ? " (xfont only)" : ""));
    if (pair-&gt;xfont != 0) {
	(*pair-&gt;xfont-&gt;common.procs-&gt;release) (pair-&gt;xfont,
					       pair-&gt;memory);
	pair-&gt;xfont_tried = false;
	pair-&gt;xfont = 0;
    }
    gx_purge_selected_cached_chars(dir,
				   (xfont_only ? purge_fm_pair_char_xfont :
				    purge_fm_pair_char),
				   pair);
    if (pair-&gt;ttr)
	gx_ttfReader__destroy(pair-&gt;ttr);
    pair-&gt;ttr = 0;
    if (pair-&gt;ttf)
	ttfFont__destroy(pair-&gt;ttf, dir);
    pair-&gt;ttf = 0;
    if (!xfont_only) {
#ifdef DEBUG
	if (pair-&gt;num_chars != 0) {
	    lprintf1("Error in gs_purge_fm_pair: num_chars =%d\n",
		     pair-&gt;num_chars);
	}
#endif
	fm_pair_set_free(pair);
	dir-&gt;fmcache.msize--;
    }
}

/* Look up an xfont by name. */
/* The caller must already have done get_xfont_device to get the proper */
/* device to pass as the first argument to lookup_font. */
private gx_xfont *
lookup_xfont_by_name(gx_device * fdev, const gx_xfont_procs * procs,
      gs_font_name * pfstr, int encoding_index, const cached_fm_pair * pair,
		     const gs_matrix * pmat)
{
    gx_xfont *xf;

    if_debug5('k', "[k]lookup xfont %s [%g %g %g %g]\n",
	      pfstr-&gt;chars, pmat-&gt;xx, pmat-&gt;xy, pmat-&gt;yx, pmat-&gt;yy);
    xf = (*procs-&gt;lookup_font) (fdev,
				&amp;pfstr-&gt;chars[0], pfstr-&gt;size,
				encoding_index, &amp;pair-&gt;UID,
				pmat, pair-&gt;memory);
    if_debug1('k', "[k]... xfont=0x%lx\n", (ulong) xf);
    return xf;
}

/* ====== Character-level routines ====== */

/*
 * Allocate storage for caching a rendered character with possible
 * oversampling and/or alpha.  Return the cached_char if OK, 0 if too big.
 * If the character is being oversampled, make the size decision
 * on the basis of the final (scaled-down) size.
 *
 * The iwidth and iheight parameters include scaling up for oversampling
 * (multiplication by 1 &lt;&lt; pscale-&gt;{x,y}.)
 * The depth parameter is the final number of alpha bits;
 * depth &lt;= x scale * y scale.
 * If dev == NULL, this is an xfont-only entry.
 * If dev != NULL, set up the memory device(s); in this case, if dev2 is
 * not NULL, dev should be an alpha-buffer device with dev2 (an alpha
 * device) as target.
 */
cached_char *
gx_alloc_char_bits(gs_font_dir * dir, gx_device_memory * dev,
		   gx_device_memory * dev2, ushort iwidth, ushort iheight,
		   const gs_log2_scale_point * pscale, int depth)
{
    int log2_xscale = pscale-&gt;x;
    int log2_yscale = pscale-&gt;y;
    int log2_depth = ilog2(depth);
    uint nwidth_bits = (iwidth &gt;&gt; log2_xscale) &lt;&lt; log2_depth;
    ulong isize, icdsize;
    uint iraster;
    cached_char *cc;
    gx_device_memory mdev;
    gx_device_memory *pdev = dev;
    gx_device_memory *pdev2;

    if (dev == NULL) {
	mdev.memory = 0;
	mdev.target = 0;
	pdev = &amp;mdev;
    }
    pdev2 = (dev2 == 0 ? pdev : dev2);

    /* Compute the scaled-down bitmap size, and test against */
    /* the maximum cachable character size. */

    iraster = bitmap_raster(nwidth_bits);
    if (iraster != 0 &amp;&amp; iheight &gt;&gt; log2_yscale &gt; dir-&gt;ccache.upper / iraster) {
	if_debug5('k', "[k]no cache bits: scale=%dx%d, raster/scale=%u, height/scale=%u, upper=%u\n",
		  1 &lt;&lt; log2_xscale, 1 &lt;&lt; log2_yscale,
		  iraster, iheight, dir-&gt;ccache.upper);
	return 0;		/* too big */
    }
    /* Compute the actual bitmap size(s) and allocate the bits. */
    if (dev2 == 0) {
	/*
	 * Render to a full (possibly oversampled) bitmap; compress
	 * (if needed) when done.
	 *
	 * HACK: Preserve the reference count and retained flag.
	 */
	rc_header rc;
	bool retained = pdev-&gt;retained;
	gx_device *target = pdev-&gt;target;

	rc = pdev-&gt;rc;
	/* Pass the correct target, but decrement its refct afterwards. */
	gs_make_mem_mono_device(pdev, pdev-&gt;memory, target);
	rc_decrement_only(target, "gx_alloc_char_bits"); /* can't go to 0 */
	pdev-&gt;rc = rc;
	pdev-&gt;retained = retained;
	pdev-&gt;width = iwidth;
	pdev-&gt;height = iheight;
	isize = gdev_mem_bitmap_size(pdev);
    } else {
	/* Use an alpha-buffer device to compress as we go. */
	/* Preserve the reference counts, if any. */
	rc_header rc;

	rc = dev2-&gt;rc;
	gs_make_mem_alpha_device(dev2, dev2-&gt;memory, NULL, depth);
	dev2-&gt;rc = rc;
	dev2-&gt;width = iwidth &gt;&gt; log2_xscale;
	dev2-&gt;height = iheight &gt;&gt; log2_yscale;
	rc = dev-&gt;rc;
	gs_make_mem_abuf_device(dev, dev-&gt;memory, (gx_device *) dev2,
				pscale, depth, 0);
	dev-&gt;rc = rc;
	dev-&gt;width = iwidth;
	dev-&gt;height = 2 &lt;&lt; log2_yscale;
	isize = gdev_mem_bitmap_size(dev) +
	    gdev_mem_bitmap_size(dev2);
    }
    icdsize = isize + sizeof_cached_char;
    cc = alloc_char(dir, icdsize);
    if (cc == 0)
	return 0;
    if_debug4('k', "[k]adding char 0x%lx:%u(%u,%u)\n",
	      (ulong) cc, (uint) icdsize, iwidth, iheight);

    /* Fill in the entry. */

    cc_set_depth(cc, depth);
    cc-&gt;xglyph = gx_no_xglyph;
    /* Set the width and height to those of the device. */
    /* Note that if we are oversampling without an alpha buffer. */
    /* these are not the final unscaled dimensions. */
    cc-&gt;width = pdev2-&gt;width;
    cc-&gt;height = pdev2-&gt;height;
    cc-&gt;shift = 0;
    cc_set_raster(cc, gdev_mem_raster(pdev2));
    cc_set_pair_only(cc, 0);	/* not linked in yet */
    cc-&gt;id = gx_no_bitmap_id;
    cc-&gt;subpix_origin.x = cc-&gt;subpix_origin.y = 0;
    cc-&gt;linked = false;

    /* Open the cache device(s). */

    if (dev2) {			/* The second device is an alpha device that targets */
	/* the real storage for the character. */
	byte *bits = cc_bits(cc);
	uint bsize = (uint) gdev_mem_bitmap_size(dev2);

	memset(bits, 0, bsize);
	dev2-&gt;base = bits;
	(*dev_proc(dev2, open_device)) ((gx_device *) dev2);
	dev-&gt;base = bits + bsize;
	(*dev_proc(dev, open_device)) ((gx_device *) dev);
    } else if (dev)
	gx_open_cache_device(dev, cc);

    return cc;
}

/* Open the cache device. */
void
gx_open_cache_device(gx_device_memory * dev, cached_char * cc)
{
    byte *bits = cc_bits(cc);

    dev-&gt;width = cc-&gt;width;
    dev-&gt;height = cc-&gt;height;
    memset((char *)bits, 0, (uint) gdev_mem_bitmap_size(dev));
    dev-&gt;base = bits;
    (*dev_proc(dev, open_device)) ((gx_device *) dev);	/* initialize */
}

/* Remove a character from the cache. */
void
gx_free_cached_char(gs_font_dir * dir, cached_char * cc)
{
    char_cache_chunk *cck = cc-&gt;chunk;

    dir-&gt;ccache.chunks = cck;
    dir-&gt;ccache.cnext = (byte *) cc - cck-&gt;data;
    if (cc-&gt;linked)
	cc_pair(cc)-&gt;num_chars--;
    if_debug2('k', "[k]freeing char 0x%lx, pair=0x%lx\n",
	      (ulong) cc, (ulong) cc_pair(cc));
    gx_bits_cache_free((gx_bits_cache *) &amp; dir-&gt;ccache, &amp;cc-&gt;head, cck);
}

/* Add a character to the cache */
void
gx_add_cached_char(gs_font_dir * dir, gx_device_memory * dev,
cached_char * cc, cached_fm_pair * pair, const gs_log2_scale_point * pscale)
{
    if_debug5('k', "[k]chaining char 0x%lx: pair=0x%lx, glyph=0x%lx, wmode=%d, depth=%d\n",
	      (ulong) cc, (ulong) pair, (ulong) cc-&gt;code,
	      cc-&gt;wmode, cc_depth(cc));
    if (dev != NULL) {
	static const gs_log2_scale_point no_scale =
	{0, 0};

	/* Close the device, to flush the alpha buffer if any. */
	(*dev_proc(dev, close_device)) ((gx_device *) dev);
	gx_add_char_bits(dir, cc,
			 (gs_device_is_abuf((gx_device *) dev) ?
			  &amp;no_scale : pscale));
    }
    /* Add the new character to the hash table. */
    {
	uint chi = chars_head_index(cc-&gt;code, pair);

	while (dir-&gt;ccache.table[chi &amp;= dir-&gt;ccache.table_mask] != 0)
	    chi++;
	dir-&gt;ccache.table[chi] = cc;
	if (cc-&gt;pair == NULL) {
	    /* gx_show_text_retry could reset it when bbox_draw
	       discovered an insufficient FontBBox and enlarged it. 
	       Glyph raster params could change then. */
	    cc-&gt;pair = pair;
	} else
	    assert(cc-&gt;pair == pair);
	cc-&gt;linked = true;
	cc_set_pair(cc, pair);
	pair-&gt;num_chars++;
    }
}

/* Adjust the bits of a newly-rendered character, by unscaling */
/* and compressing or converting to alpha values if necessary. */
void
gx_add_char_bits(gs_font_dir * dir, cached_char * cc,
		 const gs_log2_scale_point * plog2_scale)
{
    int log2_x = plog2_scale-&gt;x, log2_y = plog2_scale-&gt;y;
    uint raster = cc_raster(cc);
    byte *bits = cc_bits(cc);
    int depth = cc_depth(cc);
    int log2_depth = ilog2(depth);
    uint nwidth_bits, nraster;
    gs_int_rect bbox;

#ifdef DEBUG
    if (cc-&gt;width % (1 &lt;&lt; log2_x) != 0 ||
	cc-&gt;height % (1 &lt;&lt; log2_y) != 0
	) {
	lprintf4("size %d,%d not multiple of scale %d,%d!\n",
		 cc-&gt;width, cc-&gt;height,
		 1 &lt;&lt; log2_x, 1 &lt;&lt; log2_y);
	cc-&gt;width &amp;= -1 &lt;&lt; log2_x;
	cc-&gt;height &amp;= -1 &lt;&lt; log2_y;
    }
#endif

    /*
     * Compute the bounding box before compressing.
     * We may have to scan more bits, but this is a lot faster than
     * compressing the white space.  Note that all bbox values are
     * in bits, not pixels.
     */

    bits_bounding_box(bits, cc-&gt;height, raster, &amp;bbox);

    /*
     * If the character was oversampled, compress it now.
     * In this case we know that log2_depth &lt;= log2_x.
     * If the character was not oversampled, or if we converted
     * oversampling to alpha dynamically (using an alpha buffer
     * intermediate device), log2_x and log2_y are both zero,
     * but in the latter case we may still have depth &gt; 1.
     */

    if ((log2_x | log2_y) != 0) {
	if_debug5('k', "[k]compressing %dx%d by %dx%d to depth=%d\n",
		  cc-&gt;width, cc-&gt;height, 1 &lt;&lt; log2_x, 1 &lt;&lt; log2_y,
		  depth);
	if (gs_debug_c('K'))
	    debug_dump_bitmap(bits, raster, cc-&gt;height,
			      "[K]uncompressed bits");
	/* Truncate/round the bbox to a multiple of the scale. */
	{
	    int scale_x = 1 &lt;&lt; log2_x;

	    bbox.p.x &amp;= -scale_x;
	    bbox.q.x = (bbox.q.x + scale_x - 1) &amp; -scale_x;
	}
	{
	    int scale_y = 1 &lt;&lt; log2_y;

	    bbox.p.y &amp;= -scale_y;
	    bbox.q.y = (bbox.q.y + scale_y - 1) &amp; -scale_y;
	}
	cc-&gt;width = (bbox.q.x - bbox.p.x) &gt;&gt; log2_x;
	cc-&gt;height = (bbox.q.y - bbox.p.y) &gt;&gt; log2_y;
	nwidth_bits = cc-&gt;width &lt;&lt; log2_depth;
	nraster = bitmap_raster(nwidth_bits);
	bits_compress_scaled(bits + raster * bbox.p.y, bbox.p.x,
			     cc-&gt;width &lt;&lt; log2_x,
			     cc-&gt;height &lt;&lt; log2_y,
			     raster,
			     bits, nraster, plog2_scale, log2_depth);
	bbox.p.x &gt;&gt;= log2_x;
	bbox.p.y &gt;&gt;= log2_y;
    } else {
	/* No oversampling, just remove white space on all 4 sides. */
	const byte *from = bits + raster * bbox.p.y + (bbox.p.x &gt;&gt; 3);

	cc-&gt;height = bbox.q.y - bbox.p.y;
	bbox.p.x &amp;= ~7;		/* adjust to byte boundary */
	bbox.p.x &gt;&gt;= log2_depth;	/* bits =&gt; pixels */
	bbox.q.x = (bbox.q.x + depth - 1) &gt;&gt; log2_depth;	/* ditto */
	cc-&gt;width = bbox.q.x - bbox.p.x;
	nwidth_bits = cc-&gt;width &lt;&lt; log2_depth;
	nraster = bitmap_raster(nwidth_bits);
	if (bbox.p.x != 0 || nraster != raster) {
	    /* Move the bits down and over. */
	    byte *to = bits;
	    uint n = cc-&gt;height;

	    /* We'd like to move only 
	       uint nbytes = (nwidth_bits + 7) &gt;&gt; 3;
	       * bytes per scan line, but unfortunately this drops
	       * the guaranteed zero padding at the end.
	     */

	    for (; n--; from += raster, to += nraster)
		memmove(to, from, /*nbytes */ nraster);
	} else if (bbox.p.y != 0) {	/* Just move the bits down. */
	    memmove(bits, from, raster * cc-&gt;height);
	}
    }

    /* Adjust the offsets to account for removed white space. */

    cc-&gt;offset.x -= int2fixed(bbox.p.x);
    cc-&gt;offset.y -= int2fixed(bbox.p.y);

    /* Discard the memory device overhead that follows the bits, */
    /* and any space reclaimed from unscaling or compression. */

    cc_set_raster(cc, nraster);
    {
	uint diff = ROUND_DOWN(cc-&gt;head.size - sizeof_cached_char -
			       nraster * cc-&gt;height,
			       align_cached_char_mod);

	if (diff &gt;= sizeof(cached_char_head)) {
	    shorten_cached_char(dir, cc, diff);
	    if_debug2('K', "[K]shortening char 0x%lx by %u (adding)\n",
		      (ulong) cc, diff);
	}
    }

    /* Assign a bitmap id. */

    cc-&gt;id = gs_next_ids(dir-&gt;orig_fonts-&gt;memory, 1);
}

/* Purge from the caches all references to a given font. */
void
gs_purge_font_from_char_caches(gs_font_dir * dir, const gs_font * font)
{
    cached_fm_pair *pair = dir-&gt;fmcache.mdata;
    int count = dir-&gt;fmcache.mmax;

    if_debug1('k', "[k]purging font 0x%lx\n",
	      (ulong) font);
    while (count--) {
	if (pair-&gt;font == font) {
	    if (uid_is_valid(&amp;pair-&gt;UID)) {	/* Keep the entry. */
		pair-&gt;font = 0;
	    } else
		gs_purge_fm_pair(dir, pair, 0);
	}
	pair++;
    }
}

/* ------ Internal routines ------ */

/* Allocate data space for a cached character, adding a new chunk if needed. */
private cached_char *
alloc_char(gs_font_dir * dir, ulong icdsize)
{				/* Try allocating at the current position first. */
    cached_char *cc = alloc_char_in_chunk(dir, icdsize);

    if (cc == 0) {
	if (dir-&gt;ccache.bspace &lt; dir-&gt;ccache.bmax) {	/* Allocate another chunk. */
	    gs_memory_t *mem = dir-&gt;ccache.bits_memory;
	    char_cache_chunk *cck_prev = dir-&gt;ccache.chunks;
	    char_cache_chunk *cck;
	    uint cksize = dir-&gt;ccache.bmax / 5 + 1;
	    uint tsize = dir-&gt;ccache.bmax - dir-&gt;ccache.bspace;
	    byte *cdata;

	    if (cksize &gt; tsize)
		cksize = tsize;
	    if (icdsize + sizeof(cached_char_head) &gt; cksize) {
		if_debug2('k', "[k]no cache bits: cdsize+head=%lu, cksize=%u\n",
			  icdsize + sizeof(cached_char_head),
			  cksize);
		return 0;	/* wouldn't fit */
	    }
	    cck = (char_cache_chunk *)
		gs_alloc_bytes_immovable(mem, sizeof(*cck),
					 "char cache chunk");
	    if (cck == 0)
		return 0;
	    cdata =
		gs_alloc_struct_array_immovable(mem, cksize, byte,
						&amp;st_font_cache_bytes,
						"char cache chunk(data)");
	    if (cdata == 0) {
		gs_free_object(mem, cck, "char cache chunk");
		return 0;
	    }
	    gx_bits_cache_chunk_init(cck, cdata, cksize);
	    cck-&gt;next = cck_prev-&gt;next;
	    cck_prev-&gt;next = cck;
	    dir-&gt;ccache.bspace += cksize;
	    dir-&gt;ccache.chunks = cck;
	} else {		/* Cycle through existing chunks. */
	    char_cache_chunk *cck_init = dir-&gt;ccache.chunks;
	    char_cache_chunk *cck = cck_init;

	    while ((dir-&gt;ccache.chunks = cck = cck-&gt;next) != cck_init) {
		dir-&gt;ccache.cnext = 0;
		cc = alloc_char_in_chunk(dir, icdsize);
		if (cc != 0)
		    return cc;
	    }
	}
	dir-&gt;ccache.cnext = 0;
	cc = alloc_char_in_chunk(dir, icdsize);
    }
    return cc;
}

/* Allocate a character in the current chunk. */
private cached_char *
alloc_char_in_chunk(gs_font_dir * dir, ulong icdsize)
{
    char_cache_chunk *cck = dir-&gt;ccache.chunks;
    cached_char_head *cch;

#define cc ((cached_char *)cch)

    while (gx_bits_cache_alloc((gx_bits_cache *) &amp; dir-&gt;ccache,
			       icdsize, &amp;cch) &lt; 0
	) {
	if (cch == 0) {		/* Not enough room to allocate in this chunk. */
	    return 0;
	} {			/* Free the character */
	    cached_fm_pair *pair = cc_pair(cc);

	    if (pair != 0) {
		uint chi = chars_head_index(cc-&gt;code, pair);

		while (dir-&gt;ccache.table[chi &amp; dir-&gt;ccache.table_mask] != cc)
		    chi++;
		hash_remove_cached_char(dir, chi);
	    }
	    gx_free_cached_char(dir, cc);
	}
    }
    cc-&gt;chunk = cck;
    cc-&gt;loc = (byte *) cc - cck-&gt;data;
    return cc;
#undef cc
}

/* Remove the cached_char at a given index in the hash table. */
/* In order not to slow down lookup, we relocate following entries. */
private void
hash_remove_cached_char(gs_font_dir * dir, uint chi)
{
    uint mask = dir-&gt;ccache.table_mask;
    uint from = ((chi &amp;= mask) + 1) &amp; mask;
    cached_char *cc;

    dir-&gt;ccache.table[chi] = 0;
    while ((cc = dir-&gt;ccache.table[from]) != 0) {	/* Loop invariants: chars[chi] == 0; */
	/* chars[chi+1..from] != 0. */
	uint fchi = chars_head_index(cc-&gt;code, cc_pair(cc));

	/* If chi &lt;= fchi &lt; from, we relocate the character. */
	/* Note that '&lt;=' must take wraparound into account. */
	if ((chi &lt; from ? chi &lt;= fchi &amp;&amp; fchi &lt; from :
	     chi &lt;= fchi || fchi &lt; from)
	    ) {
	    dir-&gt;ccache.table[chi] = cc;
	    dir-&gt;ccache.table[from] = 0;
	    chi = from;
	}
	from = (from + 1) &amp; mask;
    }
}

/* Shorten a cached character. */
/* diff &gt;= sizeof(cached_char_head). */
private void
shorten_cached_char(gs_font_dir * dir, cached_char * cc, uint diff)
{
    gx_bits_cache_shorten((gx_bits_cache *) &amp; dir-&gt;ccache, &amp;cc-&gt;head,
			  diff, cc-&gt;chunk);
    if_debug2('K', "[K]shortening creates free block 0x%lx(%u)\n",
	      (ulong) ((byte *) cc + cc-&gt;head.size), diff);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

