<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxcpath.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxcpath.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1991, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxcpath.c,v 1.16 2005/07/27 22:34:40 igor Exp $ */
/* Implementation of clipping paths, other than actual clipping */
#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gsutil.h"
#include "gsline.h"
#include "gxdevice.h"
#include "gxfixed.h"
#include "gscoord.h"		/* needs gsmatrix.h */
#include "gxistate.h"
#include "gzpath.h"
#include "gzcpath.h"
#include "gzacpath.h"

/* Forward references */
private void gx_clip_list_from_rectangle(gx_clip_list *, gs_fixed_rect *);

/* Other structure types */
public_st_clip_rect();
private_st_clip_list();
public_st_clip_path();
private_st_clip_rect_list();
public_st_device_clip();
private_st_cpath_enum();
private_st_cpath_path_list();

/* GC procedures for gx_clip_path */
private 
ENUM_PTRS_WITH(clip_path_enum_ptrs, gx_clip_path *cptr) return ENUM_USING(st_path, &amp;cptr-&gt;path, sizeof(cptr-&gt;path), index - 2);

case 0:
return ENUM_OBJ((cptr-&gt;rect_list == &amp;cptr-&gt;local_list ? 0 :
	     cptr-&gt;rect_list));
case 1:
return ENUM_OBJ(cptr-&gt;path_list);
ENUM_PTRS_END
private
RELOC_PTRS_WITH(clip_path_reloc_ptrs, gx_clip_path *cptr)
{
    if (cptr-&gt;rect_list != &amp;cptr-&gt;local_list)
	RELOC_VAR(cptr-&gt;rect_list);
    RELOC_VAR(cptr-&gt;path_list);
    RELOC_USING(st_path, &amp;cptr-&gt;path, sizeof(gx_path));
}
RELOC_PTRS_END

/* GC procedures for gx_device_clip */
private
ENUM_PTRS_WITH(device_clip_enum_ptrs, gx_device_clip *cptr)
{
    if (index &lt; st_clip_list_max_ptrs + 1)
	return ENUM_USING(st_clip_list, &amp;cptr-&gt;list,
			  sizeof(gx_clip_list), index - 1);
    return ENUM_USING(st_device_forward, vptr,
		      sizeof(gx_device_forward),
		      index - (st_clip_list_max_ptrs + 1));
}
case 0:
ENUM_RETURN((cptr-&gt;current == &amp;cptr-&gt;list.single ? NULL :
	     (void *)cptr-&gt;current));
ENUM_PTRS_END
private
RELOC_PTRS_WITH(device_clip_reloc_ptrs, gx_device_clip *cptr)
{
    if (cptr-&gt;current == &amp;cptr-&gt;list.single)
	cptr-&gt;current = &amp;((gx_device_clip *)RELOC_OBJ(vptr))-&gt;list.single;
    else
	RELOC_PTR(gx_device_clip, current);
    RELOC_USING(st_clip_list, &amp;cptr-&gt;list, sizeof(gx_clip_list));
    RELOC_USING(st_device_forward, vptr, sizeof(gx_device_forward));
}
RELOC_PTRS_END

/* Define an empty clip list. */
private const gx_clip_list clip_list_empty = {
    {0, 0, min_int, max_int, 0, 0},
    0, 0, 0, 0, 0
};

/* ------ Clipping path memory management ------ */

private rc_free_proc(rc_free_cpath_list);
private rc_free_proc(rc_free_cpath_list_local);
private rc_free_proc(rc_free_cpath_path_list);

/*
 * Initialize those parts of the contents of a clip path that aren't
 * part of the path.
 */
private void
cpath_init_rectangle(gx_clip_path * pcpath, gs_fixed_rect * pbox)
{
    gx_clip_list_from_rectangle(&amp;pcpath-&gt;rect_list-&gt;list, pbox);
    pcpath-&gt;inner_box = *pbox;
    pcpath-&gt;path_valid = false;
    pcpath-&gt;path.bbox = *pbox;
    gx_cpath_set_outer_box(pcpath);
    pcpath-&gt;id = gs_next_ids(pcpath-&gt;path.memory, 1);	/* path changed =&gt; change id */
}
private void
cpath_init_own_contents(gx_clip_path * pcpath)
{    /* We could make null_rect static, but then it couldn't be const. */
    gs_fixed_rect null_rect;

    null_rect.p.x = null_rect.p.y = null_rect.q.x = null_rect.q.y = 0;
    cpath_init_rectangle(pcpath, &amp;null_rect);
    pcpath-&gt;path_list = NULL;
}
private void
cpath_share_own_contents(gx_clip_path * pcpath, const gx_clip_path * shared)
{
    pcpath-&gt;inner_box = shared-&gt;inner_box;
    pcpath-&gt;path_valid = shared-&gt;path_valid;
    pcpath-&gt;outer_box = shared-&gt;outer_box;
    pcpath-&gt;id = shared-&gt;id;
}

/* Allocate only the segments of a clipping path on the heap. */
private int
cpath_alloc_list(gx_clip_rect_list ** prlist, gs_memory_t * mem,
		 client_name_t cname)
{
    rc_alloc_struct_1(*prlist, gx_clip_rect_list, &amp;st_clip_rect_list, mem,
		      return_error(gs_error_VMerror), cname);
    (*prlist)-&gt;rc.free = rc_free_cpath_list;
    return 0;
}
int
gx_cpath_init_contained_shared(gx_clip_path * pcpath,
	const gx_clip_path * shared, gs_memory_t * mem, client_name_t cname)
{
    if (shared) {
	if (shared-&gt;path.segments == &amp;shared-&gt;path.local_segments) {
	    lprintf1("Attempt to share (local) segments of clip path 0x%lx!\n",
		     (ulong) shared);
	    return_error(gs_error_Fatal);
	}
	*pcpath = *shared;
	pcpath-&gt;path.memory = mem;
	pcpath-&gt;path.allocation = path_allocated_contained;
	rc_increment(pcpath-&gt;path.segments);
	rc_increment(pcpath-&gt;rect_list);
	rc_increment(pcpath-&gt;path_list);
    } else {
	int code = cpath_alloc_list(&amp;pcpath-&gt;rect_list, mem, cname);

	if (code &lt; 0)
	    return code;
	code = gx_path_alloc_contained(&amp;pcpath-&gt;path, mem, cname);
	if (code &lt; 0) {
	    gs_free_object(mem, pcpath-&gt;rect_list, cname);
	    pcpath-&gt;rect_list = 0;
	    return code;
	}
	cpath_init_own_contents(pcpath);
    }
    return 0;
}
#define gx_cpath_alloc_contents(pcpath, shared, mem, cname)\
  gx_cpath_init_contained_shared(pcpath, shared, mem, cname)

/* Allocate all of a clipping path on the heap. */
gx_clip_path *
gx_cpath_alloc_shared(const gx_clip_path * shared, gs_memory_t * mem,
		      client_name_t cname)
{
    gx_clip_path *pcpath =
    gs_alloc_struct(mem, gx_clip_path, &amp;st_clip_path, cname);
    int code;

    if (pcpath == 0)
	return 0;
    code = gx_cpath_alloc_contents(pcpath, shared, mem, cname);
    if (code &lt; 0) {
	gs_free_object(mem, pcpath, cname);
	return 0;
    }
    pcpath-&gt;path.allocation = path_allocated_on_heap;
    return pcpath;
}

/* Initialize a stack-allocated clipping path. */
int
gx_cpath_init_local_shared(gx_clip_path * pcpath, const gx_clip_path * shared,
			   gs_memory_t * mem)
{
    if (shared) {
	if (shared-&gt;path.segments == &amp;shared-&gt;path.local_segments) {
	    lprintf1("Attempt to share (local) segments of clip path 0x%lx!\n",
		     (ulong) shared);
	    return_error(gs_error_Fatal);
	}
	pcpath-&gt;path = shared-&gt;path;
	pcpath-&gt;path.allocation = path_allocated_on_stack;
	rc_increment(pcpath-&gt;path.segments);
	pcpath-&gt;rect_list = shared-&gt;rect_list;
	rc_increment(pcpath-&gt;rect_list);
	pcpath-&gt;path_list = shared-&gt;path_list;
	rc_increment(pcpath-&gt;path_list);
	cpath_share_own_contents(pcpath, shared);
    } else {
	gx_path_init_local(&amp;pcpath-&gt;path, mem);
	rc_init_free(&amp;pcpath-&gt;local_list, mem, 1, rc_free_cpath_list_local);
	pcpath-&gt;rect_list = &amp;pcpath-&gt;local_list;
	cpath_init_own_contents(pcpath);
    }
    return 0;
}

/* Unshare a clipping path. */
int
gx_cpath_unshare(gx_clip_path * pcpath)
{
    int code = gx_path_unshare(&amp;pcpath-&gt;path);
    gx_clip_rect_list *rlist = pcpath-&gt;rect_list;

    if (code &lt; 0)
	return code;
    if (rlist-&gt;rc.ref_count &gt; 1) {
	int code = cpath_alloc_list(&amp;pcpath-&gt;rect_list, pcpath-&gt;path.memory,
				    "gx_cpath_unshare");

	if (code &lt; 0)
	    return code;
	/* Copy the rectangle list. */
/**************** NYI ****************/
	rc_decrement(rlist, "gx_cpath_unshare");
    }
    return code;
}

/* Free a clipping path. */
void
gx_cpath_free(gx_clip_path * pcpath, client_name_t cname)
{
    rc_decrement(pcpath-&gt;rect_list, cname);
    rc_decrement(pcpath-&gt;path_list, cname);
    /* Clean up pointers for GC. */
    pcpath-&gt;rect_list = 0;
    pcpath-&gt;path_list = 0;
    {
	gx_path_allocation_t alloc = pcpath-&gt;path.allocation;

	if (alloc == path_allocated_on_heap) {
	    pcpath-&gt;path.allocation = path_allocated_contained;
	    gx_path_free(&amp;pcpath-&gt;path, cname);
	    gs_free_object(pcpath-&gt;path.memory, pcpath, cname);
	} else
	    gx_path_free(&amp;pcpath-&gt;path, cname);
    }
}

/* Assign a clipping path, preserving the source. */
int
gx_cpath_assign_preserve(gx_clip_path * pcpto, gx_clip_path * pcpfrom)
{
    int code = gx_path_assign_preserve(&amp;pcpto-&gt;path, &amp;pcpfrom-&gt;path);
    gx_clip_rect_list *fromlist = pcpfrom-&gt;rect_list;
    gx_clip_rect_list *tolist = pcpto-&gt;rect_list;
    gx_path path;

    if (code &lt; 0)
	return 0;
    if (fromlist == &amp;pcpfrom-&gt;local_list) {
	/* We can't use pcpfrom's list object. */
	if (tolist == &amp;pcpto-&gt;local_list || tolist-&gt;rc.ref_count &gt; 1) {
	    /* We can't use pcpto's list either.  Allocate a new one. */
	    int code = cpath_alloc_list(&amp;tolist, tolist-&gt;rc.memory,
					"gx_cpath_assign");

	    if (code &lt; 0)
		return code;
	    rc_decrement(pcpto-&gt;rect_list, "gx_cpath_assign");
	} else {
	    /* Use pcpto's list object. */
	    rc_free_cpath_list_local(tolist-&gt;rc.memory, tolist,
				     "gx_cpath_assign");
	}
	tolist-&gt;list = fromlist-&gt;list;
	pcpfrom-&gt;rect_list = tolist;
	rc_increment(tolist);
    } else {
	/* We can use pcpfrom's list object. */
	rc_increment(fromlist);
	rc_decrement(pcpto-&gt;rect_list, "gx_cpath_assign");
    }
    rc_increment(pcpfrom-&gt;path_list);
    path = pcpto-&gt;path, *pcpto = *pcpfrom, pcpto-&gt;path = path;
    return 0;
}

/* Assign a clipping path, releasing the source. */
int
gx_cpath_assign_free(gx_clip_path * pcpto, gx_clip_path * pcpfrom)
{				/* For right now, just do assign + free. */
    int code = gx_cpath_assign_preserve(pcpto, pcpfrom);

    if (code &lt; 0)
	return 0;
    gx_cpath_free(pcpfrom, "gx_cpath_assign_free");
    return 0;
}

/* Free the clipping list when its reference count goes to zero. */
private void
rc_free_cpath_list_local(gs_memory_t * mem, void *vrlist,
			 client_name_t cname)
{
    gx_clip_rect_list *rlist = (gx_clip_rect_list *) vrlist;

    gx_clip_list_free(&amp;rlist-&gt;list, mem);
}
private void
rc_free_cpath_list(gs_memory_t * mem, void *vrlist, client_name_t cname)
{
    rc_free_cpath_list_local(mem, vrlist, cname);
    gs_free_object(mem, vrlist, cname);
}

private void
rc_free_cpath_path_list(gs_memory_t * mem, void *vplist, client_name_t cname)
{
    gx_cpath_path_list *plist = (gx_cpath_path_list *)vplist;
    rc_decrement(plist-&gt;next, cname);
    gx_path_free(&amp;plist-&gt;path, cname);
    gs_free_object(plist-&gt;path.memory, plist, cname);
}

/* Allocate a new clip path list node. The created node has a ref count
   of 1, and "steals" the reference to next (i.e. does not increment
   its reference count). */
private int
gx_cpath_path_list_new(gs_memory_t *mem, gx_clip_path *pcpath, int rule, 
			gx_path *ppfrom, gx_cpath_path_list *next, gx_cpath_path_list **pnew)
{
    int code;
    client_name_t cname = "gx_cpath_path_list_new";
    gx_cpath_path_list *pcplist = gs_alloc_struct(mem, gx_cpath_path_list,
						  &amp;st_cpath_path_list, cname);

    if (pcplist == 0)
	return_error(gs_error_VMerror);
    rc_init_free(pcplist, mem, 1, rc_free_cpath_path_list);
    if (pcpath!=NULL &amp;&amp; !pcpath-&gt;path_valid) {
	code = gx_path_init_contained_shared(&amp;pcplist-&gt;path, NULL, mem, cname);
	if (code &lt; 0)
	    return code;
	code = gx_cpath_to_path(pcpath, &amp;pcplist-&gt;path);
    } else {
	gx_path_init_local(&amp;pcplist-&gt;path, mem);
	code = gx_path_assign_preserve(&amp;pcplist-&gt;path, ppfrom);
    }
    if (code &lt; 0)
	return code;
    pcplist-&gt;next = next;
    pcplist-&gt;rule = rule;
    *pnew = pcplist;
    return 0;
}

/* ------ Clipping path accessing ------ */

/* Return the path of a clipping path. */
int
gx_cpath_to_path(gx_clip_path * pcpath, gx_path * ppath)
{
    if (!pcpath-&gt;path_valid) {
	/* Synthesize a path. */
	gs_cpath_enum cenum;
	gs_fixed_point pts[3];
	gx_path rpath;
	int code;

	gx_path_init_local(&amp;rpath, pcpath-&gt;path.memory);
	gx_cpath_enum_init(&amp;cenum, pcpath);
	while ((code = gx_cpath_enum_next(&amp;cenum, pts)) != 0) {
	    switch (code) {
		case gs_pe_moveto:
		    code = gx_path_add_point(&amp;rpath, pts[0].x, pts[0].y);
		    break;
		case gs_pe_lineto:
		    code = gx_path_add_line_notes(&amp;rpath, pts[0].x, pts[0].y,
					       gx_cpath_enum_notes(&amp;cenum));
		    break;
		case gs_pe_curveto:
		    code = gx_path_add_curve_notes(&amp;rpath, pts[0].x, pts[0].y,
						   pts[1].x, pts[1].y,
						   pts[2].x, pts[2].y,
					       gx_cpath_enum_notes(&amp;cenum));
		    break;
		case gs_pe_closepath:
		    code = gx_path_close_subpath_notes(&amp;rpath,
					       gx_cpath_enum_notes(&amp;cenum));
		    break;
		default:
		    if (code &gt;= 0)
			code = gs_note_error(gs_error_unregistered);
	    }
	    if (code &lt; 0)
		break;
	}
	if (code &gt;= 0)
	    code = gx_path_assign_free(&amp;pcpath-&gt;path, &amp;rpath);
	if (code &lt; 0) {
	    gx_path_free(&amp;rpath, "gx_cpath_to_path error");
	    return code;
	}
	pcpath-&gt;path_valid = true;
    }
    return gx_path_assign_preserve(ppath, &amp;pcpath-&gt;path);
}

/* Return the inner and outer check rectangles for a clipping path. */
/* Return true iff the path is a rectangle. */
bool
gx_cpath_inner_box(const gx_clip_path * pcpath, gs_fixed_rect * pbox)
{
    *pbox = pcpath-&gt;inner_box;
    return clip_list_is_rectangle(gx_cpath_list(pcpath));
}
bool
gx_cpath_outer_box(const gx_clip_path * pcpath, gs_fixed_rect * pbox)
{
    *pbox = pcpath-&gt;outer_box;
    return clip_list_is_rectangle(gx_cpath_list(pcpath));
}

/* Test if a clipping path includes a rectangle. */
/* The rectangle need not be oriented correctly, i.e. x0 &gt; x1 is OK. */
bool
gx_cpath_includes_rectangle(register const gx_clip_path * pcpath,
			    fixed x0, fixed y0, fixed x1, fixed y1)
{
    return
	(x0 &lt;= x1 ?
	 (pcpath-&gt;inner_box.p.x &lt;= x0 &amp;&amp; x1 &lt;= pcpath-&gt;inner_box.q.x) :
	 (pcpath-&gt;inner_box.p.x &lt;= x1 &amp;&amp; x0 &lt;= pcpath-&gt;inner_box.q.x)) &amp;&amp;
	(y0 &lt;= y1 ?
	 (pcpath-&gt;inner_box.p.y &lt;= y0 &amp;&amp; y1 &lt;= pcpath-&gt;inner_box.q.y) :
	 (pcpath-&gt;inner_box.p.y &lt;= y1 &amp;&amp; y0 &lt;= pcpath-&gt;inner_box.q.y));
}

/* Set the outer clipping box to the path bounding box, */
/* expanded to pixel boundaries. */
void
gx_cpath_set_outer_box(gx_clip_path * pcpath)
{
    pcpath-&gt;outer_box.p.x = fixed_floor(pcpath-&gt;path.bbox.p.x);
    pcpath-&gt;outer_box.p.y = fixed_floor(pcpath-&gt;path.bbox.p.y);
    pcpath-&gt;outer_box.q.x = fixed_ceiling(pcpath-&gt;path.bbox.q.x);
    pcpath-&gt;outer_box.q.y = fixed_ceiling(pcpath-&gt;path.bbox.q.y);
}

/* Return the rectangle list of a clipping path (for local use only). */
const gx_clip_list *
gx_cpath_list(const gx_clip_path *pcpath)
{
    return &amp;pcpath-&gt;rect_list-&gt;list;
}
/* Internal non-const version of the same accessor. */
inline private gx_clip_list *
gx_cpath_list_private(gx_clip_path *pcpath)
{
    return &amp;pcpath-&gt;rect_list-&gt;list;
}


/* ------ Clipping path setting ------ */

/* Create a rectangular clipping path. */
/* The supplied rectangle may not be oriented correctly, */
/* but it will be oriented correctly upon return. */
private int
cpath_set_rectangle(gx_clip_path * pcpath, gs_fixed_rect * pbox)
{
    gx_clip_rect_list *rlist = pcpath-&gt;rect_list;

    if (rlist-&gt;rc.ref_count &lt;= 1)
	gx_clip_list_free(&amp;rlist-&gt;list, rlist-&gt;rc.memory);
    else {
	int code = cpath_alloc_list(&amp;pcpath-&gt;rect_list, pcpath-&gt;path.memory,
				    "gx_cpath_from_rectangle");

	if (code &lt; 0)
	    return code;
	rc_decrement(rlist, "gx_cpath_from_rectangle");
	rlist = pcpath-&gt;rect_list;
    }
    cpath_init_rectangle(pcpath, pbox);
    return 0;
}
int
gx_cpath_from_rectangle(gx_clip_path * pcpath, gs_fixed_rect * pbox)
{
    int code = gx_path_new(&amp;pcpath-&gt;path);

    if (code &lt; 0)
	return code;
    return cpath_set_rectangle(pcpath, pbox);
}
int
gx_cpath_reset(gx_clip_path * pcpath)
{
    gs_fixed_rect null_rect;

    null_rect.p.x = null_rect.p.y = null_rect.q.x = null_rect.q.y = 0;
    return gx_cpath_from_rectangle(pcpath, &amp;null_rect);
}

/* If a clipping path is a rectangle, return the rectangle. */
const gs_fixed_rect *
cpath_is_rectangle(const gx_clip_path * pcpath)
{
    if (pcpath-&gt;path_valid)
	return NULL;
    if (pcpath-&gt;inner_box.p.x != pcpath-&gt;path.bbox.p.x ||
	pcpath-&gt;inner_box.p.y != pcpath-&gt;path.bbox.p.y ||
	pcpath-&gt;inner_box.q.x != pcpath-&gt;path.bbox.q.x ||
	pcpath-&gt;inner_box.q.y != pcpath-&gt;path.bbox.q.y)
	return NULL;
    return &amp;pcpath-&gt;inner_box;
}

/* Intersect a new clipping path with an old one. */
/* Flatten the new path first (in a copy) if necessary. */
int
gx_cpath_clip(gs_state *pgs, gx_clip_path *pcpath,
	      /*const*/ gx_path *ppath_orig, int rule)
{
    return gx_cpath_intersect(pcpath, ppath_orig, rule,
			      (gs_imager_state *)pgs);
}
int
gx_cpath_intersect(gx_clip_path *pcpath, /*const*/ gx_path *ppath_orig,
		   int rule, gs_imager_state *pis)
{
    gx_path fpath;
    /*const*/ gx_path *ppath = ppath_orig;
    gs_fixed_rect old_box, new_box;
    int code;

    /* Flatten the path if necessary. */
    if (gx_path_has_curves_inline(ppath)) {
	gx_path_init_local(&amp;fpath, pis-&gt;memory);
	code = gx_path_add_flattened_accurate(ppath, &amp;fpath,
					      gs_currentflat_inline(pis),
					      pis-&gt;accurate_curves);
	if (code &lt; 0)
	    return code;
	ppath = &amp;fpath;
    }

    if (gx_cpath_inner_box(pcpath, &amp;old_box) &amp;&amp;
	((code = gx_path_is_rectangle(ppath, &amp;new_box)) ||
	 gx_path_is_void(ppath))
	) {
	int changed = 0;

	if (!code) {
	    /* The new path is void. */
	    if (gx_path_current_point(ppath, &amp;new_box.p) &lt; 0) {
		/* Use the user space origin (arbitrarily). */
		new_box.p.x = float2fixed(pis-&gt;ctm.tx);
		new_box.p.y = float2fixed(pis-&gt;ctm.ty);
	    }
	    new_box.q = new_box.p;
	    changed = 1;
	} else {
	    /* Intersect the two rectangles if necessary. */
	    if (old_box.p.x &gt; new_box.p.x)
		new_box.p.x = old_box.p.x, ++changed;
	    if (old_box.p.y &gt; new_box.p.y)
		new_box.p.y = old_box.p.y, ++changed;
	    if (old_box.q.x &lt; new_box.q.x)
		new_box.q.x = old_box.q.x, ++changed;
	    if (old_box.q.y &lt; new_box.q.y)
		new_box.q.y = old_box.q.y, ++changed;
	    /* Check for a degenerate rectangle. */
	    if (new_box.q.x &lt; new_box.p.x || new_box.q.y &lt; new_box.p.y)
		new_box.p = new_box.q, changed = 1;
	}
	if (changed == 4) {
	    /* The new box/path is the same as the old. */
	    return 0;
	}
	/* Release the existing path. */
	rc_decrement(pcpath-&gt;path_list, "gx_cpath_intersect");
	pcpath-&gt;path_list = NULL;
	gx_path_new(&amp;pcpath-&gt;path);
	ppath-&gt;bbox = new_box;
	cpath_set_rectangle(pcpath, &amp;new_box);
	if (changed == 0) {
	    /* The path is valid; otherwise, defer constructing it. */
	    gx_path_assign_preserve(&amp;pcpath-&gt;path, ppath);
	    pcpath-&gt;path_valid = true;
	}
    } else {
	/* New clip path is nontrivial.  Intersect the slow way. */
	gx_cpath_path_list *next = pcpath-&gt;path_list;
	bool path_valid =
	    gx_cpath_inner_box(pcpath, &amp;old_box) &amp;&amp;
	    gx_path_bbox(ppath, &amp;new_box) &gt;= 0 &amp;&amp;
	    gx_cpath_includes_rectangle(pcpath,
					new_box.p.x, new_box.p.y,
					new_box.q.x, new_box.q.y);

	if (!path_valid &amp;&amp; next == NULL) {
	    code = gx_cpath_path_list_new(pcpath-&gt;path.memory, pcpath, pcpath-&gt;rule, 
					    &amp;pcpath-&gt;path, NULL, &amp;next);
	    if (code &lt; 0)
		goto ex;
	}
	code = gx_cpath_intersect_path_slow(pcpath, ppath, rule, pis);
	if (code &lt; 0)
	    goto ex;
	if (path_valid) {
	    gx_path_assign_preserve(&amp;pcpath-&gt;path, ppath_orig);
	    pcpath-&gt;path_valid = true;
	} else {
	    code = gx_cpath_path_list_new(pcpath-&gt;path.memory, NULL, rule, 
					    ppath_orig, next, &amp;pcpath-&gt;path_list);
	}
    }
ex:
    if (ppath != ppath_orig)
	gx_path_free(ppath, "gx_cpath_clip");
    return code;
}

/* Scale a clipping path by a power of 2. */
int
gx_cpath_scale_exp2_shared(gx_clip_path * pcpath, int log2_scale_x,
			   int log2_scale_y, bool list_shared,
			   bool segments_shared)
{
    int code =
	(pcpath-&gt;path_valid ?
	 gx_path_scale_exp2_shared(&amp;pcpath-&gt;path, log2_scale_x, log2_scale_y,
				   segments_shared) :
	 0);
    gx_clip_list *list = gx_cpath_list_private(pcpath);
    gx_clip_rect *pr;

    if (code &lt; 0)
	return code;
    /* Scale the fixed entries. */
    gx_rect_scale_exp2(&amp;pcpath-&gt;inner_box, log2_scale_x, log2_scale_y);
    gx_rect_scale_exp2(&amp;pcpath-&gt;outer_box, log2_scale_x, log2_scale_y);
    if (!list_shared) {
	/* Scale the clipping list. */
	pr = list-&gt;head;
	if (pr == 0)
	    pr = &amp;list-&gt;single;
	for (; pr != 0; pr = pr-&gt;next)
	    if (pr != list-&gt;head &amp;&amp; pr != list-&gt;tail) {

#define SCALE_V(v, s)\
  if ( pr-&gt;v != min_int &amp;&amp; pr-&gt;v != max_int )\
    pr-&gt;v = (s &gt;= 0 ? pr-&gt;v &lt;&lt; s : pr-&gt;v &gt;&gt; -s)

		SCALE_V(xmin, log2_scale_x);
		SCALE_V(xmax, log2_scale_x);
		SCALE_V(ymin, log2_scale_y);
		SCALE_V(ymax, log2_scale_y);
#undef SCALE_V
	    }
    }
    pcpath-&gt;id = gs_next_ids(pcpath-&gt;path.memory, 1);	/* path changed =&gt; change id */
    return 0;
}

/* ------ Clipping list routines ------ */

/* Initialize a clip list. */
void
gx_clip_list_init(gx_clip_list * clp)
{
    *clp = clip_list_empty;
}

/* Initialize a clip list to a rectangle. */
/* The supplied rectangle may not be oriented correctly, */
/* but it will be oriented correctly upon return. */
private void
gx_clip_list_from_rectangle(register gx_clip_list * clp,
			    register gs_fixed_rect * rp)
{
    gx_clip_list_init(clp);
    if (rp-&gt;p.x &gt; rp-&gt;q.x) {
	fixed t = rp-&gt;p.x;

	rp-&gt;p.x = rp-&gt;q.x;
	rp-&gt;q.x = t;
    }
    if (rp-&gt;p.y &gt; rp-&gt;q.y) {
	fixed t = rp-&gt;p.y;

	rp-&gt;p.y = rp-&gt;q.y;
	rp-&gt;q.y = t;
    }
    clp-&gt;single.xmin = clp-&gt;xmin = fixed2int_var(rp-&gt;p.x);
    clp-&gt;single.ymin = fixed2int_var(rp-&gt;p.y);
    /* Handle degenerate rectangles specially. */
    clp-&gt;single.xmax = clp-&gt;xmax =
	(rp-&gt;q.x == rp-&gt;p.x ? clp-&gt;single.xmin :
	 fixed2int_var_ceiling(rp-&gt;q.x));
    clp-&gt;single.ymax =
	(rp-&gt;q.y == rp-&gt;p.y ? clp-&gt;single.ymin :
	 fixed2int_var_ceiling(rp-&gt;q.y));
    clp-&gt;count = 1;
}

/* Start enumerating a clipping path. */
int
gx_cpath_enum_init(gs_cpath_enum * penum, gx_clip_path * pcpath)
{
    if ((penum-&gt;using_path = pcpath-&gt;path_valid)) {
	gx_path_enum_init(&amp;penum-&gt;path_enum, &amp;pcpath-&gt;path);
	penum-&gt;rp = penum-&gt;visit = 0;
    } else {
	gx_path empty_path;
	gx_clip_list *clp = gx_cpath_list_private(pcpath);
	gx_clip_rect *head = (clp-&gt;count &lt;= 1 ? &amp;clp-&gt;single : clp-&gt;head);
	gx_clip_rect *rp;

	/* Initialize the pointers in the path_enum properly. */
	gx_path_init_local(&amp;empty_path, pcpath-&gt;path.memory);
	gx_path_enum_init(&amp;penum-&gt;path_enum, &amp;empty_path);
	penum-&gt;visit = head;
	for (rp = head; rp != 0; rp = rp-&gt;next)
	    rp-&gt;to_visit =
		(rp-&gt;xmin &lt; rp-&gt;xmax &amp;&amp; rp-&gt;ymin &lt; rp-&gt;ymax ?
		 visit_left | visit_right : 0);
	penum-&gt;rp = 0;		/* scan will initialize */
	penum-&gt;any_rectangles = false;
	penum-&gt;state = cpe_scan;
	penum-&gt;have_line = false;
    }
    return 0;
}

/* Enumerate the next segment of a clipping path. */
/* In general, this produces a path made up of zillions of tiny lines. */
int
gx_cpath_enum_next(gs_cpath_enum * penum, gs_fixed_point pts[3])
{
    if (penum-&gt;using_path)
	return gx_path_enum_next(&amp;penum-&gt;path_enum, pts);
#define set_pt(xi, yi)\
  (pts[0].x = int2fixed(xi), pts[0].y = int2fixed(yi))
#define set_line(xi, yi)\
  (penum-&gt;line_end.x = (xi), penum-&gt;line_end.y = (yi), penum-&gt;have_line = true)
    if (penum-&gt;have_line) {
	set_pt(penum-&gt;line_end.x, penum-&gt;line_end.y);
	penum-&gt;have_line = false;
	return gs_pe_lineto;
    } {
	gx_clip_rect *visit = penum-&gt;visit;
	gx_clip_rect *rp = penum-&gt;rp;
	cpe_visit_t first_visit = penum-&gt;first_visit;
	cpe_state_t state = penum-&gt;state;
	gx_clip_rect *look;
	int code;

	switch (state) {

	    case cpe_scan:
		/* Look for the start of an edge to trace. */
		for (; visit != 0; visit = visit-&gt;next) {
		    if (visit-&gt;to_visit &amp; visit_left) {
			set_pt(visit-&gt;xmin, visit-&gt;ymin);
			first_visit = visit_left;
			state = cpe_left;
		    } else if (visit-&gt;to_visit &amp; visit_right) {
			set_pt(visit-&gt;xmax, visit-&gt;ymax);
			first_visit = visit_right;
			state = cpe_right;
		    } else
			continue;
		    rp = visit;
		    code = gs_pe_moveto;
		    penum-&gt;any_rectangles = true;
		    goto out;
		}
		/* We've enumerated all the edges. */
		state = cpe_done;
		if (!penum-&gt;any_rectangles) {
		    /* We didn't have any rectangles. */
		    set_pt(fixed_0, fixed_0);
		    code = gs_pe_moveto;
		    break;
		}
		/* falls through */

	    case cpe_done:
		/* All done. */
		code = 0;
		break;

/* We can't use the BEGIN ... END hack here: we need to be able to break. */
#define return_line(px, py)\
  set_pt(px, py); code = gs_pe_lineto; break

	    case cpe_left:

	      left:		/* Trace upward along a left edge. */
		/* We're at the lower left corner of rp. */
		rp-&gt;to_visit &amp;= ~visit_left;
		/* Look for an adjacent rectangle above rp. */
		for (look = rp;
		     (look = look-&gt;next) != 0 &amp;&amp;
		     (look-&gt;ymin == rp-&gt;ymin ||
		      (look-&gt;ymin == rp-&gt;ymax &amp;&amp; look-&gt;xmax &lt;= rp-&gt;xmin));
		    );
		/* Now we know look-&gt;ymin &gt;= rp-&gt;ymax. */
		if (look == 0 || look-&gt;ymin &gt; rp-&gt;ymax ||
		    look-&gt;xmin &gt;= rp-&gt;xmax
		    ) {		/* No adjacent rectangle, switch directions. */
		    state =
			(rp == visit &amp;&amp; first_visit == visit_right ? cpe_close :
			 (set_line(rp-&gt;xmax, rp-&gt;ymax), cpe_right));
		    return_line(rp-&gt;xmin, rp-&gt;ymax);
		}
		/* We found an adjacent rectangle. */
		/* See if it also adjoins a rectangle to the left of rp. */
		{
		    gx_clip_rect *prev = rp-&gt;prev;
		    gx_clip_rect *cur = rp;

		    if (prev != 0 &amp;&amp; prev-&gt;ymax == rp-&gt;ymax &amp;&amp;
			look-&gt;xmin &lt; prev-&gt;xmax
			) {	/* There's an adjoining rectangle as well. */
			/* Switch directions. */
			rp = prev;
			state =
			    (rp == visit &amp;&amp; first_visit == visit_right ? cpe_close :
			     (set_line(prev-&gt;xmax, prev-&gt;ymax), cpe_right));
			return_line(cur-&gt;xmin, cur-&gt;ymax);
		    }
		    rp = look;
		    if (rp == visit &amp;&amp; first_visit == visit_left)
			state = cpe_close;
		    else if (rp-&gt;xmin == cur-&gt;xmin)
			goto left;
		    else
			set_line(rp-&gt;xmin, rp-&gt;ymin);
		    return_line(cur-&gt;xmin, cur-&gt;ymax);
		}

	    case cpe_right:

	      right:		/* Trace downward along a right edge. */
		/* We're at the upper right corner of rp. */
		rp-&gt;to_visit &amp;= ~visit_right;
		/* Look for an adjacent rectangle below rp. */
		for (look = rp;
		     (look = look-&gt;prev) != 0 &amp;&amp;
		     (look-&gt;ymax == rp-&gt;ymax ||
		      (look-&gt;ymax == rp-&gt;ymin &amp;&amp; look-&gt;xmin &gt;= rp-&gt;xmax));
		    );
		/* Now we know look-&gt;ymax &lt;= rp-&gt;ymin. */
		if (look == 0 || look-&gt;ymax &lt; rp-&gt;ymin ||
		    look-&gt;xmax &lt;= rp-&gt;xmin
		    ) {		/* No adjacent rectangle, switch directions. */
		    state =
			(rp == visit &amp;&amp; first_visit == visit_left ? cpe_close :
			 (set_line(rp-&gt;xmin, rp-&gt;ymin), cpe_left));
		    return_line(rp-&gt;xmax, rp-&gt;ymin);
		}
		/* We found an adjacent rectangle. */
		/* See if it also adjoins a rectangle to the right of rp. */
		{
		    gx_clip_rect *next = rp-&gt;next;
		    gx_clip_rect *cur = rp;

		    if (next != 0 &amp;&amp; next-&gt;ymin == rp-&gt;ymin &amp;&amp;
			look-&gt;xmax &gt; next-&gt;xmin
			) {	/* There's an adjoining rectangle as well. */
			/* Switch directions. */
			rp = next;
			state =
			    (rp == visit &amp;&amp; first_visit == visit_left ? cpe_close :
			     (set_line(next-&gt;xmin, next-&gt;ymin), cpe_left));
			return_line(cur-&gt;xmax, cur-&gt;ymin);
		    }
		    rp = look;
		    if (rp == visit &amp;&amp; first_visit == visit_right)
			state = cpe_close;
		    else if (rp-&gt;xmax == cur-&gt;xmax)
			goto right;
		    else
			set_line(rp-&gt;xmax, rp-&gt;ymax);
		    return_line(cur-&gt;xmax, cur-&gt;ymin);
		}

#undef return_line

	    case cpe_close:
		/* We've gone all the way around an edge. */
		code = gs_pe_closepath;
		state = cpe_scan;
		break;

	    default:
		return_error(gs_error_unknownerror);
	}

      out:			/* Store the state before exiting. */
	penum-&gt;visit = visit;
	penum-&gt;rp = rp;
	penum-&gt;first_visit = first_visit;
	penum-&gt;state = state;
	return code;
    }
#undef set_pt
#undef set_line
}
segment_notes
gx_cpath_enum_notes(const gs_cpath_enum * penum)
{
    return sn_none;
}

/* Free a clip list. */
void
gx_clip_list_free(gx_clip_list * clp, gs_memory_t * mem)
{
    gx_clip_rect *rp = clp-&gt;tail;

    while (rp != 0) {
	gx_clip_rect *prev = rp-&gt;prev;

	gs_free_object(mem, rp, "gx_clip_list_free");
	rp = prev;
    }
    gx_clip_list_init(clp);
}

/* ------ Debugging printout ------ */

#ifdef DEBUG

/* Print a clipping list. */
private void
gx_clip_list_print(const gx_clip_list *list)
{
    const gx_clip_rect *pr;

    dlprintf3("   list count=%d xmin=%d xmax=%d\n",
	     list-&gt;count, list-&gt;xmin, list-&gt;xmax);
    switch (list-&gt;count) {
	case 0:
	    pr = 0;
	    break;
	case 1:
	    pr = &amp;list-&gt;single;
	    break;
	default:
	    pr = list-&gt;head;
    }
    for (; pr != 0; pr = pr-&gt;next)
	dlprintf4("   rect: (%d,%d),(%d,%d)\n",
		  pr-&gt;xmin, pr-&gt;ymin, pr-&gt;xmax, pr-&gt;ymax);
}

/* Print a clipping path */
void
gx_cpath_print(const gx_clip_path * pcpath)
{
    if (pcpath-&gt;path_valid)
	gx_path_print(&amp;pcpath-&gt;path);
    else
	dlputs("   (path not valid)\n");
    dlprintf4("   inner_box=(%g,%g),(%g,%g)\n",
	      fixed2float(pcpath-&gt;inner_box.p.x),
	      fixed2float(pcpath-&gt;inner_box.p.y),
	      fixed2float(pcpath-&gt;inner_box.q.x),
	      fixed2float(pcpath-&gt;inner_box.q.y));
    dlprintf4("     outer_box=(%g,%g),(%g,%g)",
	      fixed2float(pcpath-&gt;outer_box.p.x),
	      fixed2float(pcpath-&gt;outer_box.p.y),
	      fixed2float(pcpath-&gt;outer_box.q.x),
	      fixed2float(pcpath-&gt;outer_box.q.y));
    dprintf2("     rule=%d list.refct=%ld\n",
	     pcpath-&gt;rule, pcpath-&gt;rect_list-&gt;rc.ref_count);
    gx_clip_list_print(gx_cpath_list(pcpath));
}

#endif /* DEBUG */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

