<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxfdrop.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxfdrop.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989-2003 artofcode LLC.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxfdrop.c,v 1.16 2004/12/08 21:35:13 stefan Exp $ */
/* Dropout prevention for a character rasterization. */

#include &lt;assert.h&gt;
#include "gx.h"
#include "gserrors.h"
#include "gsstruct.h"
#include "gzpath.h"
#include "gxfixed.h"
#include "gxdevice.h"
#include "gxdcolor.h"
#include "gxfdrop.h"
#include "gxfill.h"
#include "vdtrace.h"

#define INTERTRAP_STEM_BUG 0 /* We're not sure that 1 gives a 
                                better painting with neighbour serifs.
				Need more testing.
				0 is compatible to the old code. */

/*
 * Rather some margins are placed in virtual memory,
 * we never run garbager while some of them are allocated.
 * Therefore we use "st_simple" for margins and sections.
 */
gs_private_st_simple(st_margin, margin, "margin");
gs_public_st_simple(st_section, section, "section");

void init_section(section *sect, int i0, int i1)
{   int i;

    for (i = i0; i &lt; i1; i++) {
#	if ADJUST_SERIF &amp;&amp; CHECK_SPOT_CONTIGUITY
	sect[i].x0 = fixed_1;
	sect[i].x1 = 0;
#	endif
	sect[i].y0 = sect[i].y1 = -1;
    }
}

private margin * alloc_margin(line_list * ll)
{   margin *m;

    assert(ll-&gt;fo-&gt;pseudo_rasterization);
    if (ll-&gt;free_margin_list != 0) {
	m = ll-&gt;free_margin_list;
	ll-&gt;free_margin_list = ll-&gt;free_margin_list-&gt;next;
    } else if (ll-&gt;local_margin_alloc_count &lt; MAX_LOCAL_ACTIVE) {
	m = ll-&gt;local_margins + ll-&gt;local_margin_alloc_count;
	++ ll-&gt;local_margin_alloc_count;
    } else {
	m = gs_alloc_struct(ll-&gt;memory, margin, &amp;st_margin, "filling contiguity margin");
	/* The allocation happens only if ll-&gt;local_margins[MAX_LOCAL_ACTIVE] 
	   is exceeded. We believe it does very seldom. */
    }
    return m;
}

private void release_margin_list(line_list * ll, margin_set *ms)
{   margin * m1 = ms-&gt;margin_list;

    if (m1 == 0)
	return;
    while (m1-&gt;next != 0)
	m1 = m1-&gt;next;
    m1-&gt;next = ll-&gt;free_margin_list;
    ll-&gt;free_margin_list = ms-&gt;margin_list;
    ms-&gt;margin_list = ms-&gt;margin_touched = 0;
}

void free_all_margins(line_list * ll)
{   margin * m = ll-&gt;free_margin_list;

    ll-&gt;free_margin_list = 0;
    while (m != 0)  {
	margin * m1 = m-&gt;next;

	if (m &lt; ll-&gt;local_margins || m &gt;= ll-&gt;local_margins + MAX_LOCAL_ACTIVE)
	    gs_free_object(ll-&gt;memory, m, "filling contiguity margin");
	m = m1;
    }
}

private int store_margin(line_list * ll, margin_set * set, int ii0, int ii1)
{
    /*
     * We need to add margin to the ordered margin list.
     * Contacting margins to be united.
     */
    int i0 = ii0, i1 = ii1;
    margin *m0 = set-&gt;margin_touched, *m1;

    assert(ii0 &gt;= 0 &amp;&amp; ii1 &lt;= ll-&gt;bbox_width);
    set-&gt;margin_touched = 0; /* safety */
    /* Find contacting elements. */
    if (m0 != 0) {
	margin  *m_last = m0, *mb, *me;

	assert(set-&gt;margin_list != 0);
	if (i1 &lt; m0-&gt;ibeg) {
	    do {
		m0 = m0-&gt;prev;
	    } while (m0 != 0 &amp;&amp; i0 &lt;= m0-&gt;iend);
	    /* m0 points to a non-contacting at left. */
	    m1 = (m0 == 0 ? set-&gt;margin_list : m0)-&gt;next;
	    while (m1 != 0 &amp;&amp; m1-&gt;ibeg &lt;= i1) {
		m_last = m1;
		m1 = m1-&gt;next;
	    }
	    /* m1 points to a non-contacting at right. */
	} else if (i0 &gt; m0-&gt;iend) {
	    m1 = m0;
	    do {
		m_last = m1;
		m1 = m1-&gt;next;
	    } while (m1 != 0 &amp;&amp; i1 &gt;= m1-&gt;ibeg);
	    /* m0 points to a non-contacting at right. */
	    m0 = (m1 == 0 ? m_last : m1-&gt;prev);
	    while (m0 != 0 &amp;&amp; m0-&gt;iend &gt;= i0)
		m0 = m0-&gt;prev;
	    /* m1 points to a non-contacting at left. */
	} else {
	    m1 = m0;
	    while (m1 != 0 &amp;&amp; m1-&gt;ibeg &lt;= i1) {
		m_last = m1;
		m1 = m1-&gt;next;
	    }
	    /* m1 points to a non-contacting at right. */
	    while (m0 != 0 &amp;&amp; m0-&gt;iend &gt;= i0)
		m0 = m0-&gt;prev;
	    /* m1 points to a non-contacting at left. */
	}
	/* Remove elements from m0-&gt;next to m1-&gt;prev, excluding the latter.
	   m0 may be NULL if we riched list start. 
	   m1 may be NULL if we riched list end. */
	mb = (m0 == 0 ? set-&gt;margin_list : m0-&gt;next);
	if (mb != 0 &amp;&amp; mb != m1) {
	    me = (m1 == 0 ? m_last : m1-&gt;prev);
	    /* Remove elements from mb to me, excluding the latter.
	       me may be NULL if we riched list start. */
	    if (me != 0) {
		 if (mb != me &amp;&amp; me-&gt;prev != 0) {
		    margin *mf = me-&gt;prev;

		    /* Remove elements from mb to mf. */
		    if (mb-&gt;prev != 0)
			mb-&gt;prev-&gt;next = mf-&gt;next;
		    if (mf-&gt;next != 0)
			mf-&gt;next-&gt;prev = mb-&gt;prev;
		    if (set-&gt;margin_list == mb)
			set-&gt;margin_list = mf-&gt;next;
		    mf-&gt;next = ll-&gt;free_margin_list;
		    ll-&gt;free_margin_list = mb;
		    i0 = min(i0, mb-&gt;ibeg);
		    i1 = max(i1, mf-&gt;iend);
		    /* 'prev' links are not used in ll-&gt;free_margin_list. */
		}
	    }
	} 
	me = (m0 == 0 ? set-&gt;margin_list : m0-&gt;next);
	if (me == 0)
	    m0 = m0; /* Already set. */
	else if (me-&gt;iend &lt; i0)
	    m0 = me; /* Insert after me. */
	else if (me-&gt;ibeg &gt; i1)
	    m0 = me-&gt;prev; /* Insert before me. */
	else if (me-&gt;iend &gt;= i0 &amp;&amp; me-&gt;ibeg &lt;= i1) {
	    /* Intersects with me. Replace me boundaries. */
	    me-&gt;ibeg = min(i0, me-&gt;ibeg);
	    me-&gt;iend = max(i1, me-&gt;iend);
	    set-&gt;margin_touched = me;
	    return 0;
	}
    }
    /* Insert after m0 */
    m1 = alloc_margin(ll);
    if (m1 == 0)
	return_error(gs_error_VMerror);
    if (m0 != 0) {
	m1-&gt;next = m0-&gt;next;
	m1-&gt;prev = m0;
	m0-&gt;next = m1;
	if (m1-&gt;next!= 0)
	    m1-&gt;next-&gt;prev = m1;
    } else {
	m1-&gt;next = set-&gt;margin_list;
	m1-&gt;prev = 0;
	if (set-&gt;margin_list != 0)
	    set-&gt;margin_list-&gt;prev = m1;
	set-&gt;margin_list = m1;
    }
    m1-&gt;ibeg = i0;
    m1-&gt;iend = i1;
    set-&gt;margin_touched = m1;
    return 0;
}

private inline int to_interval(int x, int l, int u)
{   return x &lt; l ? l : x &gt; u ? u : x;
}

private inline fixed Y_AT_X(active_line *alp, fixed xp)
{   return alp-&gt;start.y + fixed_mult_quo(xp - alp-&gt;start.x,  alp-&gt;diff.y, alp-&gt;diff.x);
}

private int margin_boundary(line_list * ll, margin_set * set, active_line * alp, 
			    fixed xx0, fixed xx1, fixed yy0, fixed yy1, int dir, fixed y0, fixed y1)
{   section *sect = set-&gt;sect;
    fixed x0, x1, xmin, xmax;
    int xp0, xp;
    int i0, i;
#   if !CHECK_SPOT_CONTIGUITY
    int i1;
#   endif

    if (yy0 &gt; yy1)
	return 0;
    /* enumerate integral x's in [yy0,yy1] : */

    if (alp == 0)
	x0 = xx0, x1 = xx1;
    else {
	x0 = (yy0 == y0 ? alp-&gt;x_current : AL_X_AT_Y(alp, yy0));
	x1 = (yy1 == y1 ? alp-&gt;x_next : AL_X_AT_Y(alp, yy1));
    }
    xmin = min(x0, x1);
    xmax = max(x0, x1);
#   if !CHECK_SPOT_CONTIGUITY
	xp0 = fixed_floor(xmin) + fixed_half;
	i0 = fixed2int(xp0) - ll-&gt;bbox_left;
	if (xp0 &lt; xmin) {
	    xp0 += fixed_1;
	    i0++;
	}
	assert(i0 &gt;= 0);
	for (i = i0, xp = xp0; xp &lt; xmax &amp;&amp; i &lt; ll-&gt;bbox_width; xp += fixed_1, i++) {
	    fixed y = (alp == 0 ? yy0 : Y_AT_X(alp, xp));
	    fixed dy = y - set-&gt;y;
	    bool ud;
	    short *b, h;
	    section *s = &amp;sect[i];

	    if (dy &lt; 0)
		dy = 0; /* fix rounding errors in Y_AT_X */
	    if (dy &gt;= fixed_1)
		dy = fixed_1; /* safety */
	    vd_circle(xp, y, 2, 0);
	    ud = (alp == 0 ? (dir &gt; 0) : ((alp-&gt;start.x - alp-&gt;end.x) * dir &gt; 0));
	    b = (ud ? &amp;s-&gt;y0 : &amp;s-&gt;y1);
	    h = (short)dy;
	    if (*b == -1 || (*b != -2 &amp;&amp; ( ud ? *b &gt; h : *b &lt; h)))
		*b = h;
	}
#   else
	xp0 = fixed_floor(xmin) + fixed_half;
	i0 = fixed2int(xp0) - ll-&gt;bbox_left;
	if (xp0 &lt; xmin) {
	    i0++;
	    xp0 += fixed_1;
	}
	for (i = i0, xp = xp0; xp &lt; xmax; xp += fixed_1, i++) {
	    section *s = &amp;sect[i];
	    fixed y = (alp==0 ? yy0 : Y_AT_X(alp, xp));
	    fixed dy = y - set-&gt;y;
	    bool ud;
	    short *b, h;

	    if (dy &lt; 0)
		dy = 0; /* fix rounding errors in Y_AT_X */
	    if (dy &gt;= fixed_1)
		dy = fixed_1; /* safety */
	    vd_circle(xp, y, 2, 0);
	    ud = (alp == 0 ? (dir &gt; 0) : ((alp-&gt;start.x - alp-&gt;end.x) * dir &gt; 0));
	    b = (ud ? &amp;s-&gt;y0 : &amp;s-&gt;y1);
	    h = (short)dy;
	    if (*b == -1 || (*b != -2 &amp;&amp; ( ud ? *b &gt; h : *b &lt; h)))
		*b = h;
	}
	assert(i0 &gt;= 0 &amp;&amp; i &lt;= ll-&gt;bbox_width);
#	endif
    if (i &gt; i0)
	return store_margin(ll, set, i0, i);
    return 0;
}

int continue_margin_common(line_list * ll, margin_set * set, active_line * flp, active_line * alp, fixed y0, fixed y1)
{   int code;
#   if ADJUST_SERIF
    section *sect = set-&gt;sect;
    fixed yy0 = max(max(y0, alp-&gt;start.y), set-&gt;y);
    fixed yy1 = min(min(y1, alp-&gt;end.y), set-&gt;y + fixed_1);

    if (yy0 &lt;= yy1) {
	fixed x00 = (yy0 == y0 ? flp-&gt;x_current : AL_X_AT_Y(flp, yy0));
	fixed x10 = (yy0 == y0 ? alp-&gt;x_current : AL_X_AT_Y(alp, yy0));
	fixed x01 = (yy1 == y1 ? flp-&gt;x_next : AL_X_AT_Y(flp, yy1));
	fixed x11 = (yy1 == y1 ? alp-&gt;x_next : AL_X_AT_Y(alp, yy1));
	fixed xmin = min(x00, x01), xmax = max(x10, x11);

	int i0 = fixed2int(xmin) - ll-&gt;bbox_left, i;
	int i1 = fixed2int_ceiling(xmax) - ll-&gt;bbox_left;
   
	for (i = i0; i &lt; i1; i++) {
	    section *s = &amp;sect[i];
	    int x_pixel = int2fixed(i + ll-&gt;bbox_left);
	    int xl = max(xmin - x_pixel, 0);
	    int xu = min(xmax - x_pixel, fixed_1);

	    s-&gt;x0 = min(s-&gt;x0, xl);
	    s-&gt;x1 = max(s-&gt;x1, xu);
	    x_pixel+=0; /* Just a place for breakpoint */
	}
	code = store_margin(ll, set, i0, i1);
	if (code &lt; 0)
	    return code;
	/* fixme : after ADJUST_SERIF becames permanent,
	 * don't call margin_boundary if yy0 &gt; yy1.
	 */
    }
#   endif

    code = margin_boundary(ll, set, flp, 0, 0, yy0, yy1, 1, y0, y1);
    if (code &lt; 0)
	return code;
    return margin_boundary(ll, set, alp, 0, 0, yy0, yy1, -1, y0, y1);
}

private inline int mark_margin_interior(line_list * ll, margin_set * set, active_line * flp, active_line * alp, fixed y, fixed y0, fixed y1)
{
    section *sect = set-&gt;sect;
    fixed x0 = (y == y0 ? flp-&gt;x_current : y == y1 ? flp-&gt;x_next : AL_X_AT_Y(flp, y));
    fixed x1 = (y == y0 ? alp-&gt;x_current : y == y1 ? alp-&gt;x_next : AL_X_AT_Y(alp, y));
    int i0 = fixed2int(x0), ii0, ii1, i, code;

    if (int2fixed(i0) + fixed_half &lt; x0)
	i0++;
    ii0 = i0 - ll-&gt;bbox_left;
    ii1 = fixed2int_var_pixround(x1) - ll-&gt;bbox_left;
    if (ii0 &lt; ii1) {
	assert(ii0 &gt;= 0 &amp;&amp; ii1 &lt;= ll-&gt;bbox_width);
	for (i = ii0; i &lt; ii1; i++) {
	    sect[i].y0 = sect[i].y1 = -2;
	    vd_circle(int2fixed(i + ll-&gt;bbox_left) + fixed_half, y, 3, RGB(255, 0, 0));
	}
	code = store_margin(ll, set, ii0, ii1);
	if (code &lt; 0)
	    return code;
    }
    return 0;
}

int margin_interior(line_list * ll, active_line * flp, active_line * alp, fixed y0, fixed y1)
{   int code;
    fixed yy0, yy1;

    yy0 = ll-&gt;margin_set0.y;
    if (y0 &lt;= yy0 &amp;&amp; yy0 &lt;= y1) {
	code = mark_margin_interior(ll, &amp;ll-&gt;margin_set0, flp, alp, yy0, y0, y1);
	if (code &lt; 0)
	    return code;
    }
    yy1 = ll-&gt;margin_set1.y + fixed_1;
    if (y0 &lt;= yy1 &amp;&amp; yy1 &lt;= y1) {
	code = mark_margin_interior(ll, &amp;ll-&gt;margin_set1, flp, alp, yy1, y0, y1);
	if (code &lt; 0)
	    return code;
    }
    return 0;
}

private inline int process_h_sect(line_list * ll, margin_set * set, active_line * hlp0, 
    active_line * plp, active_line * flp, int side, fixed y0, fixed y1)
{
    active_line *hlp = hlp0;
    fixed y = hlp-&gt;start.y;
    fixed x0 = (plp != 0 ? (y == y0 ? plp-&gt;x_current : y == y1 ? plp-&gt;x_next : AL_X_AT_Y(plp, y)) 
			 : int2fixed(ll-&gt;bbox_left));
    fixed x1 = (flp != 0 ? (y == y0 ? flp-&gt;x_current : y == y1 ? flp-&gt;x_next : AL_X_AT_Y(flp, y))
                         : int2fixed(ll-&gt;bbox_left + ll-&gt;bbox_width));
    int code;

    for (; hlp != 0; hlp = hlp-&gt;next) {
	fixed xx0 = max(x0, min(hlp-&gt;start.x, hlp-&gt;end.x));
	fixed xx1 = min(x1, max(hlp-&gt;start.x, hlp-&gt;end.x));

	if (xx0 &lt; xx1) {
	    vd_bar(xx0, y, xx1, y, 1, RGB(255, 0, 255));
	    code =  margin_boundary(ll, set, 0, xx0, xx1, y, y, side, 0, 0);
	    if (code &lt; 0)
		return code;
	}
    }
    return 0;	
}

private inline int process_h_side(line_list * ll, margin_set * set, active_line * hlp, 
    active_line * plp, active_line * flp, active_line * alp, int side, fixed y0, fixed y1)
{   if (plp != 0 || flp != 0 || (plp == 0 &amp;&amp; flp == 0 &amp;&amp; alp == 0)) {
	/* We don't know here, whether the opposite (-) side is painted with
	 * a trapezoid. mark_margin_interior may rewrite it later.
	 */
	int code = process_h_sect(ll, set, hlp, plp, flp, -side, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    if (flp != 0 &amp;&amp; alp != 0) {
	int code = process_h_sect(ll, set, hlp, flp, alp, side, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    return 0;
}

private inline int process_h_list(line_list * ll, active_line * hlp, active_line * plp, 
    active_line * flp, active_line * alp, int side, fixed y0, fixed y1)
{   fixed y = hlp-&gt;start.y;

    if (ll-&gt;margin_set0.y &lt;= y &amp;&amp; y &lt;= ll-&gt;margin_set0.y + fixed_1) {
	int code = process_h_side(ll, &amp;ll-&gt;margin_set0, hlp, plp, flp, alp, side, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    if (ll-&gt;margin_set1.y &lt;= y &amp;&amp; y &lt;= ll-&gt;margin_set1.y + fixed_1) {
	int code = process_h_side(ll, &amp;ll-&gt;margin_set1, hlp, plp, flp, alp, side, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    return 0;
}

int process_h_lists(line_list * ll, active_line * plp, active_line * flp, active_line * alp,
		    fixed y0, fixed y1)
{   
    if (y0 == y1) {
	/*  fixme : Must not happen. Remove. */
	return 0;
    }
    if (ll-&gt;h_list0 != 0) {
	int code = process_h_list(ll, ll-&gt;h_list0, plp, flp, alp, 1, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    if (ll-&gt;h_list1 != 0) {
	int code = process_h_list(ll, ll-&gt;h_list1, plp, flp, alp, -1, y0, y1);

	if (code &lt; 0)
	    return code;
    }
    return 0;
}

private inline int compute_padding(section *s)
{
    return (s-&gt;y0 &lt; 0 || s-&gt;y1 &lt; 0 ? -2 : /* contacts a trapezoid - don't paint */
	    s-&gt;y1 &lt; fixed_half ? 0 : 
	    s-&gt;y0 &gt; fixed_half ? 1 : 
	    fixed_half - s-&gt;y0 &lt; s-&gt;y1 - fixed_half ? 1 : 0);
}

private int fill_margin(gx_device * dev, const line_list * ll, margin_set *ms, int i0, int i1)
{   /* Returns the new index (positive) or return code (negative). */
    section *sect = ms-&gt;sect;
    int iy = fixed2int_var_pixround(ms-&gt;y);
    int i, ir, h = -2, code;
    const fill_options * const fo = ll-&gt;fo;
    const bool FILL_DIRECT = fo-&gt;fill_direct;

    assert(i0 &gt;= 0 &amp;&amp; i1 &lt;= ll-&gt;bbox_width);
    ir = i0;
    for (i = i0; i &lt; i1; i++) {
	int y0 = sect[i].y0, y1 = sect[i].y1, hh;

	if (y0 == -1) 
	    y0 = 0;
	if (y1 == -1) 
	    y1 = fixed_scale - 1;
	hh = compute_padding(&amp;sect[i]);
#	if ADJUST_SERIF
	    if (hh &gt;= 0) {
#		if !CHECK_SPOT_CONTIGUITY
		    if (i == i0 &amp;&amp; i + 1 &lt; i1) {
			int hhh = compute_padding(&amp;sect[i + 1]);

			hh = hhh;
		    } else if (i == i1 - 1 &amp;&amp; i &gt; i0)
			hh = h; 
		    /* We could optimize it with moving outside the cycle.
		     * Delaying the optimization until the code is well tested.
		     */
#		else
		    if (sect[i].x0 &gt; 0 &amp;&amp; sect[i].x1 == fixed_1 &amp;&amp; i + 1 &lt; i1) {
#			if INTERTRAP_STEM_BUG
			int hhh = hh;
#			endif
			hh = (i + 1 &lt; i1 ? compute_padding(&amp;sect[i + 1]) : -2);
			/* We could cache hh.
			 * Delaying the optimization until the code is well tested.
			 */
#			if INTERTRAP_STEM_BUG
			/* A bug in the old code. */
			if (i &gt; i0 &amp;&amp; i + 1 &lt; i1 &amp;&amp; hh == -2 &amp;&amp; 
				compute_padding(&amp;sect[i - 1]) == -2) {
			    /* It can be either a thin stem going from left to up or down
			       (See 'r' in 01-001.ps in 'General', ppmraw, 72dpi),
			       or a serif from the left.
			       Since it is between 2 trapezoids, it is better to paint it
			       against a dropout. */
			    hh = hhh;
			}
#			endif
		    } else if (sect[i].x0 == 0 &amp;&amp; sect[i].x1 &lt; fixed_1) {
#			if INTERTRAP_STEM_BUG
			int hhh = hh;
#			endif
			hh = h;
#			if INTERTRAP_STEM_BUG
			/* A bug in the old code. */
			if (i &gt; i0 &amp;&amp; i + 1 &lt; i1 &amp;&amp; hh == -2 &amp;&amp; 
				compute_padding(&amp;sect[i - 1]) == -2) {
			    /* It can be either a thin stem going from right to up or down
			       (See 'r' in 01-001.ps in 'General', ppmraw, 72dpi),
			       or a serif from the right.
			       Since it is between 2 trapezoids, it is better to paint it. 
			       against a dropout. */
			    DO_NOTHING;
			}
#			endif
		    }
#		endif
	    }
#	endif
	if (h != hh) {
	    if (h &gt;= 0) {
		VD_RECT(ir + ll-&gt;bbox_left, iy + h, i - ir, 1, VD_MARG_COLOR);
		code = LOOP_FILL_RECTANGLE_DIRECT(fo, ir + ll-&gt;bbox_left, iy + h, i - ir, 1);
		if (code &lt; 0)
		    return code;
	    }
	    ir = i;
	    h = hh;
	}
    }
    if (h &gt;= 0) {
	VD_RECT(ir + ll-&gt;bbox_left, iy + h, i - ir, 1, VD_MARG_COLOR);
	code = LOOP_FILL_RECTANGLE_DIRECT(fo, ir + ll-&gt;bbox_left, iy + h, i - ir, 1);
	if (code &lt; 0)
	    return code;
    }
    init_section(sect, i0, i1);
    return 0;
/*
 *  We added the ADJUST_SERIF feature for small fonts, which are poorly hinted.
 *  An example is 033-52-5873.pdf at 72 dpi.
 *  We either suppress a serif or move it up or down for 1 pixel.
 *  If we would paint it as an entire pixel where it occures, it looks too big
 *  relatively to the character size. Besides, a stem end may
 *  be placed a little bit below the baseline, and our dropout prevention 
 *  method desides to paint a pixel below baseline, so that it looks
 *  fallen down (or fallen up in the case of character top).
 *  
 *  We assume that contacting margins are merged in margin_list.
 *  This implies that areas outside a margin are not painted
 *  (Only useful without CHECK_SPOT_CONTIGUITY).
 *
 *  With no CHECK_SPOT_CONTIGUITY we can't perfectly handle the case when 2 serifs
 *  contact each another inside a margin interior (such as Serif 'n').
 *  Since we don't know the contiguty, we misrecognize them as a stem and 
 *  leave them as they are (possibly still fallen down or up).
 *
 *  CHECK_SPOT_CONTIGUITY computes the contiguity of the intersection of the spot
 *  and the section window. It allows to recognize contacting serifs properly.
 *
 *  If a serif isn't painted with regular trapezoids, 
 *  it appears a small one, so we don't need to measure its size.
 *  This heuristic isn't perfect, but it is very fast.
 *  Meanwhile with CHECK_SPOT_CONTIGUITY we actually have something
 *  like a bbox for a small serif, and a rough estimation is possible.
 * 
 *  We believe that in normal cases this stuff should work idle,
 *  because a perfect rendering should either use anti-aliasing 
 *  (so that the character isn't small in the subpixel grid),
 *  and/or the path must be well fitted into the grid. So please consider
 *  this code as an attempt to do our best for the case of a 
 *  non-well-setup rendering.
 */
}

int close_margins(gx_device * dev, line_list * ll, margin_set *ms)
{   margin *m = ms-&gt;margin_list;
    int code;

    for (; m != 0; m = m-&gt;next) {
	code = fill_margin(dev, ll, ms, m-&gt;ibeg, m-&gt;iend);
	if (code &lt; 0)
	    return code;
    }
    release_margin_list(ll, ms);
    return 0;
}

int start_margin_set(gx_device * dev, line_list * ll, fixed y0)
{   int code;
    fixed ym = fixed_pixround(y0) - fixed_half;
    margin_set s;

    if (ll-&gt;margin_set0.y == ym)
	return 0;
    s = ll-&gt;margin_set1;
    ll-&gt;margin_set1 = ll-&gt;margin_set0;
    ll-&gt;margin_set0 = s;
    code = close_margins(dev, ll, &amp;ll-&gt;margin_set0);
    ll-&gt;margin_set0.y = ym;
    return code;
}



<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

