<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxshade.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxshade.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxshade.c,v 1.22 2005/01/31 03:08:43 igor Exp $ */
/* Shading rendering support */
#include "math_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsrect.h"
#include "gxcspace.h"
#include "gscindex.h"
#include "gscie.h"		/* requires gscspace.h */
#include "gxdevcli.h"
#include "gxistate.h"
#include "gxdht.h"		/* for computing # of different colors */
#include "gxpaint.h"
#include "gxshade.h"
#include "gxshade4.h"
#include "gsicc.h"

/* Define a maximum smoothness value. */
/* smoothness &gt; 0.2 produces severely blocky output. */
#define MAX_SMOOTHNESS 0.2

/* ================ Packed coordinate streams ================ */

/* Forward references */
private int cs_next_packed_value(shade_coord_stream_t *, int, uint *);
private int cs_next_array_value(shade_coord_stream_t *, int, uint *);
private int cs_next_packed_decoded(shade_coord_stream_t *, int,
				   const float[2], float *);
private int cs_next_array_decoded(shade_coord_stream_t *, int,
				  const float[2], float *);
private bool cs_eod(const shade_coord_stream_t * cs);

/* Initialize a packed value stream. */
void
shade_next_init(shade_coord_stream_t * cs,
		const gs_shading_mesh_params_t * params,
		const gs_imager_state * pis)
{
    cs-&gt;params = params;
    cs-&gt;pctm = &amp;pis-&gt;ctm;
    if (data_source_is_stream(params-&gt;DataSource)) {
	/*
	 * Reset the data stream iff it is reusable -- either a reusable
	 * file or a reusable string.
	 */
	stream *s = cs-&gt;s = params-&gt;DataSource.data.strm;

	if ((s-&gt;file != 0 &amp;&amp; s-&gt;file_limit != max_long) ||
	    (s-&gt;file == 0 &amp;&amp; s-&gt;strm == 0)
	    )
	    sreset(s);
    } else {
	sread_string(&amp;cs-&gt;ds, params-&gt;DataSource.data.str.data,
		     params-&gt;DataSource.data.str.size);
	cs-&gt;s = &amp;cs-&gt;ds;
    }
    if (data_source_is_array(params-&gt;DataSource)) {
	cs-&gt;get_value = cs_next_array_value;
	cs-&gt;get_decoded = cs_next_array_decoded;
    } else {
	cs-&gt;get_value = cs_next_packed_value;
	cs-&gt;get_decoded = cs_next_packed_decoded;
    }
    cs-&gt;is_eod = cs_eod;
    cs-&gt;left = 0;
    cs-&gt;ds_EOF = false;
}

/* Check for the End-Of-Data state form a stream. */
private bool
cs_eod(const shade_coord_stream_t * cs)
{
    return cs-&gt;ds_EOF;
}

/* Get the next (integer) value from a packed value stream. */
/* 1 &lt;= num_bits &lt;= sizeof(uint) * 8. */
private int
cs_next_packed_value(shade_coord_stream_t * cs, int num_bits, uint * pvalue)
{
    uint bits = cs-&gt;bits;
    int left = cs-&gt;left;

    if (left &gt;= num_bits) {
	/* We can satisfy this request with the current buffered bits. */
	cs-&gt;left = left -= num_bits;
	*pvalue = (bits &gt;&gt; left) &amp; ((1 &lt;&lt; num_bits) - 1);
    } else {
	/* We need more bits. */
	int needed = num_bits - left;
	uint value = bits &amp; ((1 &lt;&lt; left) - 1);	/* all the remaining bits */

	for (; needed &gt;= 8; needed -= 8) {
	    int b = sgetc(cs-&gt;s);

	    if (b &lt; 0) {
	        cs-&gt;ds_EOF = true;
		return_error(gs_error_rangecheck);
	    }
	    value = (value &lt;&lt; 8) + b;
	}
	if (needed == 0) {
	    cs-&gt;left = 0;
	    *pvalue = value;
	} else {
	    int b = sgetc(cs-&gt;s);

	    if (b &lt; 0) {
	        cs-&gt;ds_EOF = true;
		return_error(gs_error_rangecheck);
	    }
	    cs-&gt;bits = b;
	    cs-&gt;left = left = 8 - needed;
	    *pvalue = (value &lt;&lt; needed) + (b &gt;&gt; left);
	}
    }
    return 0;
}

/*
 * Get the next (integer) value from an unpacked array.  Note that
 * num_bits may be 0 if we are reading a coordinate or color value.
 */
private int
cs_next_array_value(shade_coord_stream_t * cs, int num_bits, uint * pvalue)
{
    float value;
    uint read;

    if (sgets(cs-&gt;s, (byte *)&amp;value, sizeof(float), &amp;read) &lt; 0 ||
	read != sizeof(float)) {
	cs-&gt;ds_EOF = true;
	return_error(gs_error_rangecheck);
    }
    if (value &lt; 0 || (num_bits != 0 &amp;&amp; num_bits &lt; sizeof(uint) * 8 &amp;&amp;
	 value &gt;= (1 &lt;&lt; num_bits)) ||
	value != (uint)value
	)
	return_error(gs_error_rangecheck);
    *pvalue = (uint) value;
    return 0;
}

/* Get the next decoded floating point value. */
private int
cs_next_packed_decoded(shade_coord_stream_t * cs, int num_bits,
		       const float decode[2], float *pvalue)
{
    uint value;
    int code = cs-&gt;get_value(cs, num_bits, &amp;value);
#if ARCH_CAN_SHIFT_FULL_LONG
    double max_value = (double)(uint) ((1 &lt;&lt; num_bits) - 1);
#else
    double max_value = (double)(uint)
	(num_bits == sizeof(uint) * 8 ? ~0 : ((1 &lt;&lt; num_bits) - 1));
#endif

    if (code &lt; 0)
	return code;
    *pvalue =
	(decode == 0 ? value / max_value :
	 decode[0] + value * (decode[1] - decode[0]) / max_value);
    return 0;
}

/* Get the next floating point value from an array, without decoding. */
private int
cs_next_array_decoded(shade_coord_stream_t * cs, int num_bits,
		      const float decode[2], float *pvalue)
{
    float value;
    uint read;

    if (sgets(cs-&gt;s, (byte *)&amp;value, sizeof(float), &amp;read) &lt; 0 ||
	read != sizeof(float)
    ) {
	cs-&gt;ds_EOF = true;
	return_error(gs_error_rangecheck);
    }
    *pvalue = value;
    return 0;
}

/* Get the next flag value. */
/* Note that this always starts a new data byte. */
int
shade_next_flag(shade_coord_stream_t * cs, int BitsPerFlag)
{
    uint flag;
    int code;

    cs-&gt;left = 0;		/* start a new byte if packed */
    code = cs-&gt;get_value(cs, BitsPerFlag, &amp;flag);
    return (code &lt; 0 ? code : flag);
}

/* Get one or more coordinate pairs. */
int
shade_next_coords(shade_coord_stream_t * cs, gs_fixed_point * ppt,
		  int num_points)
{
    int num_bits = cs-&gt;params-&gt;BitsPerCoordinate;
    const float *decode = cs-&gt;params-&gt;Decode;
    int code = 0;
    int i;

    for (i = 0; i &lt; num_points; ++i) {
	float x, y;

	if ((code = cs-&gt;get_decoded(cs, num_bits, decode, &amp;x)) &lt; 0 ||
	    (code = cs-&gt;get_decoded(cs, num_bits, decode + 2, &amp;y)) &lt; 0 ||
	    (code = gs_point_transform2fixed(cs-&gt;pctm, x, y, &amp;ppt[i])) &lt; 0
	    )
	    break;
    }
    return code;
}

/* Get a color.  Currently all this does is look up Indexed colors. */
int
shade_next_color(shade_coord_stream_t * cs, float *pc)
{
    const float *decode = cs-&gt;params-&gt;Decode + 4;	/* skip coord decode */
    const gs_color_space *pcs = cs-&gt;params-&gt;ColorSpace;
    gs_color_space_index index = gs_color_space_get_index(pcs);
    int num_bits = cs-&gt;params-&gt;BitsPerComponent;

    if (index == gs_color_space_index_Indexed) {
	int ncomp = gs_color_space_num_components(gs_cspace_base_space(pcs));
	uint ci;
	int code = cs-&gt;get_value(cs, num_bits, &amp;ci);
	gs_client_color cc;
	int i;

	if (code &lt; 0)
	    return code;
	if (ci &gt;= gs_cspace_indexed_num_entries(pcs))
	    return_error(gs_error_rangecheck);
	code = gs_cspace_indexed_lookup(&amp;pcs-&gt;params.indexed, (int)ci, &amp;cc);
	if (code &lt; 0)
	    return code;
	for (i = 0; i &lt; ncomp; ++i)
	    pc[i] = cc.paint.values[i];
    } else {
	int i, code;
	int ncomp = (cs-&gt;params-&gt;Function != 0 ? 1 :
		     gs_color_space_num_components(pcs));

	for (i = 0; i &lt; ncomp; ++i)
	    if ((code = cs-&gt;get_decoded(cs, num_bits, decode + i * 2, &amp;pc[i])) &lt; 0)
		return code;
    }
    return 0;
}

/* Get the next vertex for a mesh element. */
int
shade_next_vertex(shade_coord_stream_t * cs, shading_vertex_t * vertex)
{
    int code = shade_next_coords(cs, &amp;vertex-&gt;p, 1);

    vertex-&gt;c.cc.paint.values[1] = 0; /* safety. (patch_fill may assume 2 arguments) */
    if (code &gt;= 0)
	code = shade_next_color(cs, vertex-&gt;c.cc.paint.values);
    return code;
}

/* ================ Shading rendering ================ */

/* Initialize the common parts of the recursion state. */
void
shade_init_fill_state(shading_fill_state_t * pfs, const gs_shading_t * psh,
		      gx_device * dev, gs_imager_state * pis)
{
    const gs_color_space *pcs = psh-&gt;params.ColorSpace;
    float max_error = min(pis-&gt;smoothness, MAX_SMOOTHNESS);
    /*
     * There's no point in trying to achieve smoothness beyond what
     * the device can implement, i.e., the number of representable
     * colors times the number of halftone levels.
     */
    long num_colors =
	max(dev-&gt;color_info.max_gray, dev-&gt;color_info.max_color) + 1;
    const gs_range *ranges = 0;
    int ci;

    pfs-&gt;dev = dev;
    pfs-&gt;pis = pis;
top:
    pfs-&gt;direct_space = pcs;
    pfs-&gt;num_components = gs_color_space_num_components(pcs);
    switch ( gs_color_space_get_index(pcs) )
	{
	case gs_color_space_index_Indexed:
	    pcs = gs_cspace_base_space(pcs);
	    goto top;
	case gs_color_space_index_CIEDEFG:
	    ranges = pcs-&gt;params.defg-&gt;RangeDEFG.ranges;
	    break;
	case gs_color_space_index_CIEDEF:
	    ranges = pcs-&gt;params.def-&gt;RangeDEF.ranges;
	    break;
	case gs_color_space_index_CIEABC:
	    ranges = pcs-&gt;params.abc-&gt;RangeABC.ranges;
	    break;
	case gs_color_space_index_CIEA:
	    ranges = &amp;pcs-&gt;params.a-&gt;RangeA;
	    break;
        case gs_color_space_index_CIEICC:
            ranges = pcs-&gt;params.icc.picc_info-&gt;Range.ranges;
	default:
	    break;
	}
    if (num_colors &lt;= 32) {
	gx_ht_order_component *components = pis-&gt;dev_ht-&gt;components;
	if (components &amp;&amp; components[0].corder.wts)
	    num_colors = 256;
	else
	    /****** WRONG FOR MULTI-PLANE HALFTONES ******/
	    num_colors *= pis-&gt;dev_ht-&gt;components[0].corder.num_levels;
    }
    if (psh-&gt;head.type == 2 || psh-&gt;head.type == 3) {
	max_error *= 0.25;
	num_colors *= 2;
    }
    if (max_error &lt; 1.0 / num_colors)
	max_error = 1.0 / num_colors;
    for (ci = 0; ci &lt; pfs-&gt;num_components; ++ci)
	pfs-&gt;cc_max_error[ci] =
	    (ranges == 0 ? max_error :
	     max_error * (ranges[ci].rmax - ranges[ci].rmin));
}

/* Fill one piece of a shading. */
int
shade_fill_path(const shading_fill_state_t * pfs, gx_path * ppath,
		gx_device_color * pdevc, const gs_fixed_point *fill_adjust)
{
    gx_fill_params params;

    params.rule = -1;		/* irrelevant */
    params.adjust = *fill_adjust;
    params.flatness = 0;	/* irrelevant */
    params.fill_zero_width = false;
    return (*dev_proc(pfs-&gt;dev, fill_path)) (pfs-&gt;dev, pfs-&gt;pis, ppath,
					     &amp;params, pdevc, NULL);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

