<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/gxshade4.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/gxshade4.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: gxshade4.c,v 1.30 2005/04/19 12:22:08 igor Exp $ */
/* Rendering for Gouraud triangle shadings */
#include "math_.h"
#include "memory_.h"
#include "gx.h"
#include "gserrors.h"
#include "gsmatrix.h"		/* for gscoord.h */
#include "gscoord.h"
#include "gsptype2.h"
#include "gxcspace.h"
#include "gxdcolor.h"
#include "gxdevcli.h"
#include "gxistate.h"
#include "gxpath.h"
#include "gxshade.h"
#include "gxshade4.h"
#include "vdtrace.h"

#define VD_TRACE_TRIANGLE_PATCH 1

/* Initialize the fill state for triangle shading. */
int
mesh_init_fill_state(mesh_fill_state_t * pfs, const gs_shading_mesh_t * psh,
		     const gs_fixed_rect * rect_clip, gx_device * dev,
		     gs_imager_state * pis)
{
    shade_init_fill_state((shading_fill_state_t *) pfs,
			  (const gs_shading_t *)psh, dev, pis);
    pfs-&gt;pshm = psh;
    pfs-&gt;rect = *rect_clip;
    return 0;
}

/* ---------------- Gouraud triangle shadings ---------------- */

private int
Gt_next_vertex(const gs_shading_mesh_t * psh, shade_coord_stream_t * cs,
	       shading_vertex_t * vertex)
{
    int code = shade_next_vertex(cs, vertex);

    if (code &gt;= 0 &amp;&amp; psh-&gt;params.Function) {
	vertex-&gt;c.t[0] = vertex-&gt;c.cc.paint.values[0];
	vertex-&gt;c.t[1] = 0;
	/* Decode the color with the function. */
	code = gs_function_evaluate(psh-&gt;params.Function, vertex-&gt;c.t,
				    vertex-&gt;c.cc.paint.values);
    }
    return code;
}

inline private int
Gt_fill_triangle(mesh_fill_state_t * pfs, const shading_vertex_t * va,
		 const shading_vertex_t * vb, const shading_vertex_t * vc)
{
    patch_fill_state_t pfs1;
    int code = 0;

    memcpy(&amp;pfs1, (shading_fill_state_t *)pfs, sizeof(shading_fill_state_t));
    pfs1.Function = pfs-&gt;pshm-&gt;params.Function;
    pfs1.rect = pfs-&gt;rect;
    code = init_patch_fill_state(&amp;pfs1);
    if (code &lt; 0)
	return code;
    if (INTERPATCH_PADDING) {
	code = mesh_padding(&amp;pfs1, &amp;va-&gt;p, &amp;vb-&gt;p, &amp;va-&gt;c, &amp;vb-&gt;c);
	if (code &gt;= 0)
	    code = mesh_padding(&amp;pfs1, &amp;vb-&gt;p, &amp;vc-&gt;p, &amp;vb-&gt;c, &amp;vc-&gt;c);
	if (code &gt;= 0)
	    code = mesh_padding(&amp;pfs1, &amp;vc-&gt;p, &amp;va-&gt;p, &amp;vc-&gt;c, &amp;va-&gt;c);
    }
    if (code &gt;= 0)
	code = mesh_triangle(&amp;pfs1, va, vb, vc);
    term_patch_fill_state(&amp;pfs1);
    return code;
}

int
gs_shading_FfGt_fill_rectangle(const gs_shading_t * psh0, const gs_rect * rect,
			       const gs_fixed_rect * rect_clip,
			       gx_device * dev, gs_imager_state * pis)
{
    const gs_shading_FfGt_t * const psh = (const gs_shading_FfGt_t *)psh0;
    mesh_fill_state_t state;
    shade_coord_stream_t cs;
    int num_bits = psh-&gt;params.BitsPerFlag;
    int flag;
    shading_vertex_t va, vb, vc;
    int code;

    if (VD_TRACE_TRIANGLE_PATCH &amp;&amp; vd_allowed('s')) {
	vd_get_dc('s');
	vd_set_shift(0, 0);
	vd_set_scale(0.01);
	vd_set_origin(0, 0);
    }
    code = mesh_init_fill_state(&amp;state, (const gs_shading_mesh_t *)psh, rect_clip,
			 dev, pis);
    if (code &lt; 0)
	return code;
    shade_next_init(&amp;cs, (const gs_shading_mesh_params_t *)&amp;psh-&gt;params,
		    pis);
    while ((flag = shade_next_flag(&amp;cs, num_bits)) &gt;= 0) {
	switch (flag) {
	    default:
		return_error(gs_error_rangecheck);
	    case 0:
		if ((code = Gt_next_vertex(state.pshm, &amp;cs, &amp;va)) &lt; 0 ||
		    (code = shade_next_flag(&amp;cs, num_bits)) &lt; 0 ||
		    (code = Gt_next_vertex(state.pshm, &amp;cs, &amp;vb)) &lt; 0 ||
		    (code = shade_next_flag(&amp;cs, num_bits)) &lt; 0
		    )
		    return code;
		goto v2;
	    case 1:
		va = vb;
	    case 2:
		vb = vc;
v2:		if ((code = Gt_next_vertex(state.pshm, &amp;cs, &amp;vc)) &lt; 0)
		    return code;
		if ((code = Gt_fill_triangle(&amp;state, &amp;va, &amp;vb, &amp;vc)) &lt; 0)
		    return code;
	}
    }
    if (VD_TRACE_TRIANGLE_PATCH &amp;&amp; vd_allowed('s'))
	vd_release_dc;
    if (!cs.is_eod(&amp;cs))
	return_error(gs_error_rangecheck);
    return 0;
}

int
gs_shading_LfGt_fill_rectangle(const gs_shading_t * psh0, const gs_rect * rect,
			       const gs_fixed_rect * rect_clip,
			       gx_device * dev, gs_imager_state * pis)
{
    const gs_shading_LfGt_t * const psh = (const gs_shading_LfGt_t *)psh0;
    mesh_fill_state_t state;
    shade_coord_stream_t cs;
    shading_vertex_t *vertex;
    shading_vertex_t next;
    int per_row = psh-&gt;params.VerticesPerRow;
    int i, code;

    if (VD_TRACE_TRIANGLE_PATCH &amp;&amp; vd_allowed('s')) {
	vd_get_dc('s');
	vd_set_shift(0, 0);
	vd_set_scale(0.01);
	vd_set_origin(0, 0);
    }
    code = mesh_init_fill_state(&amp;state, (const gs_shading_mesh_t *)psh, rect_clip,
			 dev, pis);
    if (code &lt; 0)
	return code;
    shade_next_init(&amp;cs, (const gs_shading_mesh_params_t *)&amp;psh-&gt;params,
		    pis);
    vertex = (shading_vertex_t *)
	gs_alloc_byte_array(pis-&gt;memory, per_row, sizeof(*vertex),
			    "gs_shading_LfGt_render");
    if (vertex == 0)
	return_error(gs_error_VMerror);
    for (i = 0; i &lt; per_row; ++i)
	if ((code = Gt_next_vertex(state.pshm, &amp;cs, &amp;vertex[i])) &lt; 0)
	    goto out;
    while (!seofp(cs.s)) {
	code = Gt_next_vertex(state.pshm, &amp;cs, &amp;next);
	if (code &lt; 0)
	    goto out;
	for (i = 1; i &lt; per_row; ++i) {
	    code = Gt_fill_triangle(&amp;state, &amp;vertex[i - 1], &amp;vertex[i], &amp;next);
	    if (code &lt; 0)
		goto out;
	    vertex[i - 1] = next;
	    code = Gt_next_vertex(state.pshm, &amp;cs, &amp;next);
	    if (code &lt; 0)
		goto out;
	    code = Gt_fill_triangle(&amp;state, &amp;vertex[i], &amp;vertex[i - 1], &amp;next);
	    if (code &lt; 0)
		goto out;
	}
	vertex[per_row - 1] = next;
    }
out:
    if (VD_TRACE_TRIANGLE_PATCH &amp;&amp; vd_allowed('s'))
	vd_release_dc;
    gs_free_object(pis-&gt;memory, vertex, "gs_shading_LfGt_render");
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

