<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/iccfont.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/iccfont.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1992-2004 artofcode LLC.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: iccfont.c,v 1.11 2004/10/26 02:50:56 giles Exp $ */
/* Initialization support for compiled fonts */

#include "string_.h"
#include "ghost.h"
#include "gsstruct.h"		/* for iscan.h */
#include "gscencs.h"
#include "gsmatrix.h"
#include "gxfont.h"		/* for ifont.h */
#include "ccfont.h"
#include "ierrors.h"
#include "ialloc.h"
#include "idict.h"
#include "ifont.h"
#include "iname.h"
#include "isave.h"		/* for ialloc_ref_array */
#include "iutil.h"
#include "oper.h"
#include "ostack.h"		/* for iscan.h */
#include "store.h"
#include "stream.h"		/* for iscan.h */
#include "strimpl.h"		/* for sfilter.h for picky compilers */
#include "sfilter.h"		/* for iscan.h */
#include "iscan.h"

/* ------ Private code ------ */

/* Forward references */
private int cfont_ref_from_string(i_ctx_t *, ref *, const char *, uint);

typedef struct {
    i_ctx_t *i_ctx_p;
    const char *str_array;
    ref next;
} str_enum;

inline private void
init_str_enum(str_enum *pse, i_ctx_t *i_ctx_p, const char *ksa)
{
    pse-&gt;i_ctx_p = i_ctx_p;
    pse-&gt;str_array = ksa;
}

typedef struct {
    cfont_dict_keys keys;
    str_enum strings;
} key_enum;

inline private void
init_key_enum(key_enum *pke, i_ctx_t *i_ctx_p, const cfont_dict_keys *pkeys,
	      const char *ksa)
{
    pke-&gt;keys = *pkeys;
    init_str_enum(&amp;pke-&gt;strings, i_ctx_p, ksa);
}

/* Check for reaching the end of the keys. */
inline private bool
more_keys(const key_enum *pke)
{
    return (pke-&gt;keys.num_enc_keys | pke-&gt;keys.num_str_keys);
}

/* Get the next string from a string array. */
/* Return 1 if it was a string, 0 if it was something else, */
/* or an error code. */
private int
cfont_next_string(str_enum * pse)
{
    const byte *str = (const byte *)pse-&gt;str_array;
    uint len = (str[0] &lt;&lt; 8) + str[1];

    if (len == 0xffff) {
	make_null(&amp;pse-&gt;next);
	pse-&gt;str_array += 2;
	return 0;
    } else if (len &gt;= 0xff00) {
	int code;

	len = ((len &amp; 0xff) &lt;&lt; 8) + str[2];
	code = cfont_ref_from_string(pse-&gt;i_ctx_p, &amp;pse-&gt;next,
				     pse-&gt;str_array + 3, len);
	if (code &lt; 0)
	    return code;
	pse-&gt;str_array += 3 + len;
	return 0;
    }
    make_const_string(&amp;pse-&gt;next, avm_foreign, len, str + 2);
    pse-&gt;str_array += 2 + len;
    return 1;
}

/* Put the next entry into a dictionary. */
/* We know that more_keys(kp) is true. */
private int
cfont_put_next(ref * pdict, key_enum * kep, const ref * pvalue)
{
    i_ctx_t *i_ctx_p = kep-&gt;strings.i_ctx_p;
    cfont_dict_keys * const kp = &amp;kep-&gt;keys;
    ref kname;
    int code;

    if (pdict-&gt;value.pdict == 0) {
	/* First time, create the dictionary. */
	code = dict_create(kp-&gt;num_enc_keys + kp-&gt;num_str_keys +
			   kp-&gt;extra_slots, pdict);
	if (code &lt; 0)
	    return code;
    }
    if (kp-&gt;num_enc_keys) {
	const charindex *skp = kp-&gt;enc_keys++;
	gs_glyph glyph = gs_c_known_encode((gs_char)skp-&gt;charx, skp-&gt;encx);
	gs_const_string gstr;

	if (glyph == GS_NO_GLYPH)
	    code = gs_note_error(e_undefined);
	else if ((code = gs_c_glyph_name(glyph, &amp;gstr)) &gt;= 0)
	    code = name_ref(imemory, gstr.data, gstr.size, &amp;kname, 0);
	kp-&gt;num_enc_keys--;
    } else {			/* must have kp-&gt;num_str_keys != 0 */
	code = cfont_next_string(&amp;kep-&gt;strings);
	if (code != 1)
	    return (code &lt; 0 ? code : gs_note_error(e_Fatal));
	code = name_ref(imemory, kep-&gt;strings.next.value.const_bytes,
			r_size(&amp;kep-&gt;strings.next), &amp;kname, 0);
	kp-&gt;num_str_keys--;
    }
    if (code &lt; 0)
	return code;
    return dict_put(pdict, &amp;kname, pvalue, &amp;i_ctx_p-&gt;dict_stack);
}

/* ------ Routines called from compiled font initialization ------ */

/* Create a dictionary with general ref values. */
private int
cfont_ref_dict_create(i_ctx_t *i_ctx_p, ref *pdict,
		      const cfont_dict_keys *kp, cfont_string_array ksa,
		      const ref *values)
{
    key_enum kenum;
    const ref *vp = values;

    init_key_enum(&amp;kenum, i_ctx_p, kp, ksa);
    pdict-&gt;value.pdict = 0;
    while (more_keys(&amp;kenum)) {
	const ref *pvalue = vp++;
	int code = cfont_put_next(pdict, &amp;kenum, pvalue);

	if (code &lt; 0)
	    return code;
    }
    r_store_attrs(dict_access_ref(pdict), a_all, kp-&gt;dict_attrs);
    return 0;
}

/* Create a dictionary with string/null values. */
private int
cfont_string_dict_create(i_ctx_t *i_ctx_p, ref *pdict,
			 const cfont_dict_keys *kp, cfont_string_array ksa,
			 cfont_string_array kva)
{
    key_enum kenum;
    str_enum senum;
    uint attrs = kp-&gt;value_attrs;

    init_key_enum(&amp;kenum, i_ctx_p, kp, ksa);
    init_str_enum(&amp;senum, i_ctx_p, kva);
    pdict-&gt;value.pdict = 0;
    while (more_keys(&amp;kenum)) {
	int code = cfont_next_string(&amp;senum);

	switch (code) {
	    default:		/* error */
		return code;
	    case 1:		/* string */
		r_set_attrs(&amp;senum.next, attrs);
	    case 0:		/* other */
		;
	}
	code = cfont_put_next(pdict, &amp;kenum, &amp;senum.next);
	if (code &lt; 0)
	    return code;
    }
    r_store_attrs(dict_access_ref(pdict), a_all, kp-&gt;dict_attrs);
    return 0;
}

/* Create a dictionary with number values. */
private int
cfont_num_dict_create(i_ctx_t *i_ctx_p, ref * pdict,
		      const cfont_dict_keys * kp, cfont_string_array ksa,
		      const ref * values, const char *lengths)
{
    key_enum kenum;
    const ref *vp = values;
    const char *lp = lengths;
    ref vnum;

    init_key_enum(&amp;kenum, i_ctx_p, kp, ksa);
    pdict-&gt;value.pdict = 0;
    while (more_keys(&amp;kenum)) {
	int len = (lp == 0 ? 0 : *lp++);
	int code;

	if (len == 0)
	    vnum = *vp++;
	else {
	    --len;
	    make_const_array(&amp;vnum, avm_foreign | a_readonly, len, vp);
	    vp += len;
	}
	code = cfont_put_next(pdict, &amp;kenum, &amp;vnum);
	if (code &lt; 0)
	    return code;
    }
    r_store_attrs(dict_access_ref(pdict), a_all, kp-&gt;dict_attrs);
    return 0;
}

/* Create an array with name values. */
private int
cfont_name_array_create(i_ctx_t *i_ctx_p, ref * parray, cfont_string_array ksa,
			int size)
{
    int code = ialloc_ref_array(parray, a_readonly, size,
				"cfont_name_array_create");
    ref *aptr = parray-&gt;value.refs;
    int i;
    str_enum senum;

    if (code &lt; 0)
	return code;
    init_str_enum(&amp;senum, i_ctx_p, ksa);
    for (i = 0; i &lt; size; i++, aptr++) {
	ref nref;
	int code = cfont_next_string(&amp;senum);

	if (code != 1)
	    return (code &lt; 0 ? code : gs_note_error(e_Fatal));
	code = name_ref(imemory, senum.next.value.const_bytes,
			r_size(&amp;senum.next), &amp;nref, 0);
	if (code &lt; 0)
	    return code;
	ref_assign_new(aptr, &amp;nref);
    }
    return 0;
}

/* Create an array with string/null values. */
private int
cfont_string_array_create(i_ctx_t *i_ctx_p, ref * parray,
			  cfont_string_array ksa, int size, uint attrs)
{
    int code = ialloc_ref_array(parray, a_readonly, size,
				"cfont_string_array_create");
    ref *aptr = parray-&gt;value.refs;
    int i;
    str_enum senum;

    if (code &lt; 0)
	return code;
    init_str_enum(&amp;senum, i_ctx_p, ksa);
    for (i = 0; i &lt; size; i++, aptr++) {
	int code = cfont_next_string(&amp;senum);

	switch (code) {
	    default:		/* error */
		return code;
	    case 1:		/* string */
		r_set_attrs(&amp;senum.next, attrs);
	    case 0:		/* other */
		;
	}
	ref_mark_new(&amp;senum.next);
	*aptr = senum.next;
    }
    return 0;
}

/* Create an array with scalar values. */
private int
cfont_scalar_array_create(i_ctx_t *i_ctx_p, ref * parray,
			  const ref *va, int size, uint attrs)
{
    int code = ialloc_ref_array(parray, attrs, size,
				"cfont_scalar_array_create");
    ref *aptr = parray-&gt;value.refs;
    uint elt_attrs = attrs | ialloc_new_mask;
    int i;

    if (code &lt; 0)
	return code;
    memcpy(aptr, va, size * sizeof(ref));
    for (i = 0; i &lt; size; i++, aptr++)
	r_set_attrs(aptr, elt_attrs);
    return 0;
}

/* Create a name. */
private int
cfont_name_create(i_ctx_t *i_ctx_p, ref * pnref, const char *str)
{
    return name_ref(imemory, (const byte *)str, strlen(str), pnref, 0);
}

/* Create an object by parsing a string. */
private int
cfont_ref_from_string(i_ctx_t *i_ctx_p, ref * pref, const char *str, uint len)
{
    scanner_state sstate;
    stream s;
    int code;

    scanner_state_init(&amp;sstate, false);
    s_init(&amp;s, imemory);
    sread_string(&amp;s, (const byte *)str, len);
    code = scan_token(i_ctx_p, &amp;s, pref, &amp;sstate);
    return (code &lt;= 0 ? code : gs_note_error(e_Fatal));
}

/* ------ Initialization ------ */

/* Procedure vector passed to font initialization procedures. */
private const cfont_procs ccfont_procs = {
    cfont_ref_dict_create,
    cfont_string_dict_create,
    cfont_num_dict_create,
    cfont_name_array_create,
    cfont_string_array_create,
    cfont_scalar_array_create,
    cfont_name_create,
    cfont_ref_from_string
};

/* null    .getccfont    &lt;number-of-fonts&gt; */
/* &lt;int&gt;   .getccfont    &lt;font-object&gt; */
private int
zgetccfont(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    const ccfont_fproc *fprocs;
    int nfonts;
    int index;

    code = ccfont_fprocs(&amp;nfonts, &amp;fprocs);
    if (code != ccfont_version)
	return_error(e_invalidfont);

    if (r_has_type(op, t_null)) {
	make_int(op, nfonts);
	return 0;
    }
    check_type(*op, t_integer);
    index = op-&gt;value.intval;
    if (index &lt; 0 || index &gt;= nfonts)
	return_error(e_rangecheck);

    return (*fprocs[index]) (i_ctx_p, &amp;ccfont_procs, op);
}

/* Operator table initialization */

const op_def ccfonts_op_defs[] =
{
    {"0.getccfont", zgetccfont},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

