<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/mkromfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/mkromfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2005 artofcode LLC.  All rights reserved.

  This software is provided AS-IS with no warranty, either express or
  implied.

  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.

  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: mkromfs.c,v 1.2 2005/09/16 03:59:44 ray Exp $ */
/* Generate source data for the %rom% IODevice */
 
/*
 * For reasons of convenience and footprint reduction, the various postscript
 * source files, resources and fonts required by Ghostscript can be compiled
 * into the executable.
 *
 * This file takes a set of directories, and creates a compressed filesystem
 * image that can be compiled into the executable as static data and accessed
 * through the %rom% iodevice prefix
 */

#include "stdpre.h"
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;

#include &lt;zlib.h&gt;

#define ROMFS_BLOCKSIZE 4096
#define ROMFS_CBUFSIZE ((int)((ROMFS_BLOCKSIZE) * 1.001) + 12)

typedef struct romfs_inode_s {
    char *name;
    struct romfs_inode_s *next, *child;
    unsigned int blocks;
    unsigned long length;
    unsigned long offset;
    unsigned long data_size;
    unsigned char **data;
    unsigned int *data_lengths;
} romfs_inode;

static int put_int32(unsigned char *p, const unsigned int q)
{
    *p++ = (q &gt;&gt; 24) &amp; 0xFF;
    *p++ = (q &gt;&gt; 16) &amp; 0xFF;
    *p++ = (q &gt;&gt;  8) &amp; 0xFF;
    *p++ = (q &gt;&gt;  0) &amp; 0xFF;
    
    return 4;
}

/* clear the internal memory of an inode */
void inode_clear(romfs_inode* node)
{
    int i;
    
    if (node) {
        if (node-&gt;data) {
            for (i = 0; i &lt; node-&gt;blocks; i++) {
                if (node-&gt;data[i]) free(node-&gt;data[i]);
            }
            free(node-&gt;data);
        }
        if (node-&gt;data_lengths) free(node-&gt;data_lengths);
        if (node-&gt;name) free(node-&gt;name);
    }
}

/* write out and inode and its file data */
int
inode_write(FILE *out, romfs_inode *node)
{
    int i, offset = 0;
    unsigned char buf[64];
    unsigned char *p = buf;
    
    /* 4 byte offset to next inode */
    p += put_int32(p, node-&gt;offset);
    /* 4 byte file length */
    p += put_int32(p, node-&gt;length);
    /* 4 byte path length */
    p += put_int32(p, strlen(node-&gt;name));
    
    printf("writing node '%s'...\n", node-&gt;name);
    printf(" offset %ld\n", node-&gt;offset);
    printf(" length %ld\n", node-&gt;length);
    printf(" path length %ld\n", strlen(node-&gt;name));
    
    printf(" %d compressed blocks comprising %ld bytes\n", node-&gt;blocks, node-&gt;data_size);
    
    /* write header */
    offset += fwrite(buf, 3, 4, out);
    /* write path */
    offset += fwrite(node-&gt;name, 1, strlen(node-&gt;name), out);
    /* write block sizes */
    offset += fwrite(node-&gt;data_lengths, node-&gt;blocks, sizeof(*node-&gt;data_lengths), out);
    /* write out compressed data */
    for (i = 0; i &lt; node-&gt;blocks; i++)
        offset += fwrite(node-&gt;data[i], 1, node-&gt;data_lengths[i], out);
    
    printf(" wrote %d bytes in all\n", offset);
    return offset;
}


int
main(int argc, char *argv[])
{
    int i, ret, block;
    romfs_inode *node;
    unsigned char *ubuf, *cbuf;
    unsigned long ulen, clen;
    unsigned long offset = 0;
    FILE *in, *out;

    ubuf = malloc(ROMFS_BLOCKSIZE);
    cbuf = malloc(ROMFS_CBUFSIZE);
    
    printf("compressing with %d byte blocksize (zlib output buffer %d bytes)\n",
        ROMFS_BLOCKSIZE, ROMFS_CBUFSIZE);
    
    out = fopen("gsromfs", "wb");
    
    /* for each path on the commandline, attach an inode */
    for (i = 1; i &lt; argc; i++) {  
        node = calloc(1, sizeof(romfs_inode));
        /* get info for this file */
        node-&gt;name = strdup(argv[i]);
        in = fopen(node-&gt;name, "rb");
        fseek(in, 0, SEEK_END);
        node-&gt;length = ftell(in);
        node-&gt;blocks = (node-&gt;length - 1) / ROMFS_BLOCKSIZE + 1;
        node-&gt;data_lengths = calloc(node-&gt;blocks, sizeof(unsigned int));
        node-&gt;data = calloc(node-&gt;blocks, sizeof(unsigned char *));
        /* compress data here */
        fclose(in);
        in = fopen(node-&gt;name, "rb");
        block = 0;
        while (!feof(in)) {
            ulen = fread(ubuf, 1, ROMFS_BLOCKSIZE, in);
            if (!ulen) break;
            clen = ROMFS_CBUFSIZE;
            ret = compress(cbuf, &amp;clen, ubuf, ulen);
            if (ret != Z_OK) {
                printf("error compressing data block!\n");
            }
            node-&gt;data_lengths[block] = clen; 
            node-&gt;data[block] = malloc(clen);
            memcpy(node-&gt;data[block], cbuf, clen);
            block++;
            node-&gt;data_size += clen;
        }
        fclose(in);
        node-&gt;offset = 12 + 4 * node-&gt;blocks + node-&gt;data_size + strlen(node-&gt;name);
        printf("inode %d (%ld/%ld bytes) '%s'\t%ld%%\n",
            i, node-&gt;data_size, node-&gt;length, node-&gt;name, 100*node-&gt;data_size/node-&gt;length);
        /* write out data for this file */
        inode_write(out, node);
        /* clean up */
        inode_clear(node);
        free(node);
    }
    
    free(ubuf);
    
    fclose(out);
    
    return 0;
}


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

