<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/sdcte.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/sdcte.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1994, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: sdcte.c,v 1.7 2002/02/21 22:24:53 giles Exp $ */
/* DCT encoding filter stream */
#include "memory_.h"
#include "stdio_.h"
#include "jpeglib_.h"
#include "jerror_.h"
#include "gdebug.h"
#include "gsmemory.h"		/* for gsmalloc.h */
#include "gsmalloc.h"		/* for gs_memory_default */
#include "strimpl.h"
#include "sdct.h"
#include "sjpeg.h"

public_st_jpeg_compress_data();

/* ------ DCTEncode ------ */

/* JPEG destination manager procedures */
private void
dcte_init_destination(j_compress_ptr cinfo)
{
}
private boolean
dcte_empty_output_buffer(j_compress_ptr cinfo)
{
    return FALSE;
}
private void
dcte_term_destination(j_compress_ptr cinfo)
{
}

/* Set the defaults for the DCTEncode filter. */
private void
s_DCTE_set_defaults(stream_state * st)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;

    s_DCT_set_defaults(st);
    ss-&gt;QFactor = 1.0;
    ss-&gt;ColorTransform = -1;
    ss-&gt;Markers.data = 0;
    ss-&gt;Markers.size = 0;
    ss-&gt;NoMarker = true;
}

/* Initialize DCTEncode filter */
private int
s_DCTE_init(stream_state * st)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;
    struct jpeg_destination_mgr *dest = &amp;ss-&gt;data.compress-&gt;destination;

    dest-&gt;init_destination = dcte_init_destination;
    dest-&gt;empty_output_buffer = dcte_empty_output_buffer;
    dest-&gt;term_destination = dcte_term_destination;
    ss-&gt;data.common-&gt;memory = ss-&gt;jpeg_memory;
    ss-&gt;data.compress-&gt;cinfo.dest = dest;
    ss-&gt;phase = 0;
    return 0;
}

/* Process a buffer */
private int
s_DCTE_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;
    jpeg_compress_data *jcdp = ss-&gt;data.compress;
    struct jpeg_destination_mgr *dest = jcdp-&gt;cinfo.dest;

    if_debug2('w', "[wde]process avail=%u, last=%d\n",
	      (uint) (pr-&gt;limit - pr-&gt;ptr), last);
    dest-&gt;next_output_byte = pw-&gt;ptr + 1;
    dest-&gt;free_in_buffer = pw-&gt;limit - pw-&gt;ptr;
    switch (ss-&gt;phase) {
	case 0:		/* not initialized yet */
	    if (gs_jpeg_start_compress(ss, TRUE) &lt; 0)
		return ERRC;
	    if_debug4('w', "[wde]width=%u, height=%u, components=%d, scan_line_size=%u\n",
		      jcdp-&gt;cinfo.image_width,
		      jcdp-&gt;cinfo.image_height,
		      jcdp-&gt;cinfo.input_components,
		      ss-&gt;scan_line_size);
	    pw-&gt;ptr = dest-&gt;next_output_byte - 1;
	    ss-&gt;phase = 1;
	    /* falls through */
	case 1:		/* initialized, Markers not written */
	    if (pw-&gt;limit - pw-&gt;ptr &lt; ss-&gt;Markers.size)
		return 1;
	    memcpy(pw-&gt;ptr + 1, ss-&gt;Markers.data, ss-&gt;Markers.size);
	    pw-&gt;ptr += ss-&gt;Markers.size;
	    ss-&gt;phase = 2;
	    /* falls through */
	case 2:		/* still need to write Adobe marker */
	    if (!ss-&gt;NoMarker) {
		static const byte Adobe[] =
		{
		    0xFF, JPEG_APP0 + 14, 0, 14,	/* parameter length */
		    'A', 'd', 'o', 'b', 'e',
		    0, 100,	/* Version */
		    0, 0,	/* Flags0 */
		    0, 0,	/* Flags1 */
		    0		/* ColorTransform */
		};

#define ADOBE_MARKER_LEN sizeof(Adobe)
		if (pw-&gt;limit - pw-&gt;ptr &lt; ADOBE_MARKER_LEN)
		    return 1;
		memcpy(pw-&gt;ptr + 1, Adobe, ADOBE_MARKER_LEN);
		pw-&gt;ptr += ADOBE_MARKER_LEN;
		*pw-&gt;ptr = ss-&gt;ColorTransform;
#undef ADOBE_MARKER_LEN
	    }
	    dest-&gt;next_output_byte = pw-&gt;ptr + 1;
	    dest-&gt;free_in_buffer = pw-&gt;limit - pw-&gt;ptr;
	    ss-&gt;phase = 3;
	    /* falls through */
	case 3:		/* markers written, processing data */
	    while (jcdp-&gt;cinfo.image_height &gt; jcdp-&gt;cinfo.next_scanline) {
		int written;

		/*
		 * The data argument for jpeg_write_scanlines is
		 * declared as a JSAMPARRAY.  There is no corresponding
		 * const type, so we must remove const from the
		 * argument that we are passing here.  (Tom Lane of IJG
		 * judges that providing const analogues of the
		 * interface types wouldn't be worth the trouble.)
		 */
		/*const */ byte *samples = (byte *) (pr-&gt;ptr + 1);

		if_debug1('w', "[wde]next_scanline=%u\n",
			  jcdp-&gt;cinfo.next_scanline);
		if ((uint) (pr-&gt;limit - pr-&gt;ptr) &lt; ss-&gt;scan_line_size) {
		    if (last)
			return ERRC;	/* premature EOD */
		    return 0;	/* need more data */
		}
		written = gs_jpeg_write_scanlines(ss, &amp;samples, 1);
		if (written &lt; 0)
		    return ERRC;
		if_debug3('w', "[wde]write returns %d, used=%u, written=%u\n",
			  written,
			  (uint) (samples - 1 - pr-&gt;ptr),
			  (uint) (dest-&gt;next_output_byte - 1 - pw-&gt;ptr));
		pw-&gt;ptr = dest-&gt;next_output_byte - 1;
		if (!written)
		    return 1;	/* output full */
		pr-&gt;ptr += ss-&gt;scan_line_size;
	    }
	    ss-&gt;phase = 4;
	    /* falls through */
	case 4:		/* all data processed, finishing */
	    /* jpeg_finish_compress can't suspend, so write its output
	     * to a fixed-size internal buffer.
	     */
	    dest-&gt;next_output_byte = jcdp-&gt;finish_compress_buf;
	    dest-&gt;free_in_buffer = sizeof(jcdp-&gt;finish_compress_buf);
	    if (gs_jpeg_finish_compress(ss) &lt; 0)
		return ERRC;
	    jcdp-&gt;fcb_size =
		dest-&gt;next_output_byte - jcdp-&gt;finish_compress_buf;
	    jcdp-&gt;fcb_pos = 0;
	    ss-&gt;phase = 5;
	    /* falls through */
	case 5:		/* copy the final data to the output */
	    if (jcdp-&gt;fcb_pos &lt; jcdp-&gt;fcb_size) {
		int count = min(jcdp-&gt;fcb_size - jcdp-&gt;fcb_pos,
				pw-&gt;limit - pw-&gt;ptr);

		if_debug1('w', "[wde]copying final %d\n", count);
		memcpy(pw-&gt;ptr + 1, jcdp-&gt;finish_compress_buf + jcdp-&gt;fcb_pos,
		       count);
		jcdp-&gt;fcb_pos += count;
		pw-&gt;ptr += count;
		if (jcdp-&gt;fcb_pos &lt; jcdp-&gt;fcb_size)
		    return 1;
	    }
	    return EOFC;
    }
    /* Default case can't happen.... */
    return ERRC;
}

/* Release the stream */
private void
s_DCTE_release(stream_state * st)
{
    stream_DCT_state *const ss = (stream_DCT_state *) st;

    gs_jpeg_destroy(ss);
    gs_free_object(ss-&gt;data.common-&gt;memory, ss-&gt;data.compress,
		   "s_DCTE_release");
    /* Switch the template pointer back in case we still need it. */
    st-&gt;template = &amp;s_DCTE_template;
}

/* Stream template */
const stream_template s_DCTE_template =
{&amp;st_DCT_state, s_DCTE_init, s_DCTE_process, 1000, 4000, s_DCTE_release,
 s_DCTE_set_defaults
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

