<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/siscale.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/siscale.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1995, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: siscale.c,v 1.7 2002/06/16 03:58:15 lpd Exp $ */
/* Image scaling filters */
#include "math_.h"
#include "memory_.h"
#include "stdio_.h"
#include &lt;assert.h&gt;
#include "gconfigv.h"
#include "gdebug.h"
#include "strimpl.h"
#include "siscale.h"

/*
 *    Image scaling code is based on public domain code from
 *      Graphics Gems III (pp. 414-424), Academic Press, 1992.
 */

/* ---------------- ImageScaleEncode/Decode ---------------- */

/* Define whether to accumulate pixels in fixed or floating point. */
#if USE_FPU &lt;= 0

	/* Accumulate pixels in fixed point. */

typedef int PixelWeight;

#  if arch_ints_are_short
typedef long AccumTmp;
#  else
typedef int AccumTmp;
#  endif

/*
 *    The optimal scaling for fixed point arithmetic is a function of the
 *    size of AccumTmp type, the size if the input pixel, the size of the
 *    intermediate pixel (PixelTmp) and the size of the output pixel.  This
 *    is set by these definitions and the fraction_bits variables in the
 *    functions.
 */
#define num_weight_bits\
  ((sizeof(AccumTmp) - maxSizeofPixel) * 8 - (LOG2_MAX_ISCALE_SUPPORT + 1))
#define numScaleBits  ((maxSizeofPixel - sizeof(PixelTmp)) * 8 )
#define fixedScaleFactor  ((int) (1 &lt;&lt; numScaleBits))
#define scale_PixelWeight(factor) ((int)((factor) * (1 &lt;&lt; num_weight_bits)))
#define unscale_AccumTmp(atemp, fraction_bits) arith_rshift(atemp, fraction_bits)
#define NEED_FRACTION_BITS

#else /* USE_FPU &gt; 0 */

	/* Accumulate pixels in floating point. */

typedef float PixelWeight;
typedef double AccumTmp;

#define num_weight_bits 0		/* Not used for floating point */
#define fixedScaleFactor 1		/* Straight scaling for floating point */
#define scale_PixelWeight(factor) (factor)
#define unscale_AccumTmp(atemp, fraction_bits) ((int)(atemp))
/*#undef NEED_FRACTION_BITS*/

#endif /* USE_FPU */

/* Temporary intermediate values */
typedef byte PixelTmp;
typedef int PixelTmp2;		/* extra width for clamping sum */

#define minPixelTmp 0
#define maxPixelTmp 255
#define unitPixelTmp 255

/* Max of all pixel sizes */
#define maxSizeofPixel 2

/* Auxiliary structures. */

typedef struct {
    PixelWeight weight;		/* float or scaled fraction */
} CONTRIB;

typedef struct {
    int index;			/* index of first element in list of */
    /* contributors */
    int n;			/* number of contributors */
    /* (not multiplied by stride) */
    int first_pixel;		/* offset of first value in source data */
} CLIST;

/* ImageScaleEncode / ImageScaleDecode */
typedef struct stream_IScale_state_s {
    /* The client sets the params values before initialization. */
    stream_image_scale_state_common;  /* = state_common + params */
    /* The init procedure sets the following. */
    int sizeofPixelIn;		/* bytes per input value, 1 or 2 */
    int sizeofPixelOut;		/* bytes per output value, 1 or 2 */
    double xscale, yscale;
    void /*PixelIn */ *src;
    void /*PixelOut */ *dst;
    PixelTmp *tmp;
    CLIST *contrib;
    CONTRIB *items;
    /* The following are updated dynamically. */
    int src_y;
    uint src_offset, src_size;
    int dst_y;
    uint dst_offset, dst_size;
    CLIST dst_next_list;	/* for next output value */
    int dst_last_index;		/* highest index used in list */
    CONTRIB dst_items[MAX_ISCALE_SUPPORT];	/* ditto */
} stream_IScale_state;

gs_private_st_ptrs5(st_IScale_state, stream_IScale_state,
    "ImageScaleEncode/Decode state",
    iscale_state_enum_ptrs, iscale_state_reloc_ptrs,
    dst, src, tmp, contrib, items);

/* ------ Digital filter definition ------ */

/* Mitchell filter definition */
#define Mitchell_support 2.0
#define B (1.0 / 3.0)
#define C (1.0 / 3.0)
private double
Mitchell_filter(double t)
{
    double t2 = t * t;

    if (t &lt; 0)
	t = -t;

    if (t &lt; 1)
	return
	    ((12 - 9 * B - 6 * C) * (t * t2) +
	     (-18 + 12 * B + 6 * C) * t2 +
	     (6 - 2 * B)) / 6;
    else if (t &lt; 2)
	return
	    ((-1 * B - 6 * C) * (t * t2) +
	     (6 * B + 30 * C) * t2 +
	     (-12 * B - 48 * C) * t +
	     (8 * B + 24 * C)) / 6;
    else
	return 0;
}

#define filter_support Mitchell_support
#define filter_proc Mitchell_filter
#define fproc(t) filter_proc(t)
#define fWidthIn filter_support

/*
 * The environment provides the following definitions:
 *      typedef PixelTmp, PixelTmp2
 *      double fproc(double t)
 *      double fWidthIn
 *      PixelTmp {min,max,unit}PixelTmp
 */
#define CLAMP(v, mn, mx)\
  (v &lt; mn ? mn : v &gt; mx ? mx : v)

/* ------ Auxiliary procedures ------ */

/* Define the minimum scale. */
#define min_scale ((fWidthIn * 2) / (MAX_ISCALE_SUPPORT - 1.01))

/* Calculate the support for a given scale. */
/* The value is always in the range 1 .. MAX_ISCALE_SUPPORT. */
private int
contrib_pixels(double scale)
{
    return (int)(fWidthIn / (scale &gt;= 1.0 ? 1.0 : max(scale, min_scale))
		 * 2 + 1);
}

/* Pre-calculate filter contributions for a row or a column. */
/* Return the highest input pixel index used. */
private int
calculate_contrib(
	/* Return weight list parameters in contrib[0 .. size-1]. */
		     CLIST * contrib,
	/* Store weights in items[0 .. contrib_pixels(scale)*size-1]. */
	/* (Less space than this may actually be needed.) */
		     CONTRIB * items,
	/* The output image is scaled by 'scale' relative to the input. */
		     double scale,
	/* Start generating weights for input pixel 'input_index'. */
		     int input_index,
	/* Generate 'size' weight lists. */
		     int size,
	/* Limit pixel indices to 'limit', for clamping at the edges */
	/* of the image. */
		     int limit,
	/* Wrap pixel indices modulo 'modulus'. */
		     int modulus,
	/* Successive pixel values are 'stride' distance apart -- */
	/* normally, the number of color components. */
		     int stride,
	/* The unit of output is 'rescale_factor' times the unit of input. */
		     double rescale_factor
)
{
    double scaled_factor = scale_PixelWeight(rescale_factor);
    double WidthIn, fscale;
    bool squeeze;
    int npixels;
    int i, j;
    int last_index = -1;

    if (scale &lt; 1.0) {
	double clamped_scale = max(scale, min_scale);

	WidthIn = fWidthIn / clamped_scale;
	fscale = 1.0 / clamped_scale;
	squeeze = true;
    } else {
	WidthIn = fWidthIn;
	fscale = 1.0;
	squeeze = false;
    }
    npixels = (int)(WidthIn * 2 + 1);

    for (i = 0; i &lt; size; ++i) {
	double center = (input_index + i) / scale;
	int left = (int)ceil(center - WidthIn);
	int right = (int)floor(center + WidthIn);

	/*
	 * In pathological cases, the limit may be much less
	 * than the support.  We do need to deal with this.
	 */
#define clamp_pixel(j)\
  (j &lt; 0 ? (-j &gt;= limit ? limit - 1 : -j) :\
   j &gt;= limit ? (j &gt;&gt; 1 &gt;= limit ? 0 : (limit - j) + limit - 1) :\
   j)
	int lmin =
	(left &lt; 0 ? 0 : left);
	int lmax =
	(left &lt; 0 ? (-left &gt;= limit ? limit - 1 : -left) : left);
	int rmin =
	(right &gt;= limit ?
	 (right &gt;&gt; 1 &gt;= limit ? 0 : (limit - right) + limit - 1) :
	 right);
	int rmax =
	(right &gt;= limit ? limit - 1 : right);
	int first_pixel = min(lmin, rmin);
	int last_pixel = max(lmax, rmax);
	CONTRIB *p;

	if (last_pixel &gt; last_index)
	    last_index = last_pixel;
	contrib[i].first_pixel = (first_pixel % modulus) * stride;
	contrib[i].n = last_pixel - first_pixel + 1;
	contrib[i].index = i * npixels;
	p = items + contrib[i].index;
	for (j = 0; j &lt; npixels; ++j)
	    p[j].weight = 0;
	if (squeeze) {
	    for (j = left; j &lt;= right; ++j) {
		double weight =
		fproc((center - j) / fscale) / fscale;
		int n = clamp_pixel(j);
		int k = n - first_pixel;

		p[k].weight +=
		    (PixelWeight) (weight * scaled_factor);
	    }
	} else {
	    for (j = left; j &lt;= right; ++j) {
		double weight = fproc(center - j);
		int n = clamp_pixel(j);
		int k = n - first_pixel;

		p[k].weight +=
		    (PixelWeight) (weight * scaled_factor);
	    }
	}
    }
    return last_index;
}


/* Apply filter to zoom horizontally from src to tmp. */
private void
zoom_x(PixelTmp * tmp, const void /*PixelIn */ *src, int sizeofPixelIn,
       int tmp_width, int WidthIn, int Colors, const CLIST * contrib,
       const CONTRIB * items)
{
    int c, i;
#ifdef NEED_FRACTION_BITS
    const int fraction_bits =
	(sizeofPixelIn - sizeof(PixelTmp)) * 8 + num_weight_bits;
#endif

    for (c = 0; c &lt; Colors; ++c) {
	PixelTmp *tp = tmp + c;
	const CLIST *clp = contrib;

	if_debug1('W', "[W]zoom_x color %d:", c);

#define zoom_x_loop(PixelIn, PixelIn2)\
		const PixelIn *raster = (const PixelIn *)src + c;\
		for ( i = 0; i &lt; tmp_width; tp += Colors, ++clp, ++i )\
		  {	AccumTmp weight = 0;\
			{ int j = clp-&gt;n;\
			  const PixelIn *pp = raster + clp-&gt;first_pixel;\
			  const CONTRIB *cp = items + clp-&gt;index;\
			  switch ( Colors )\
			  {\
			  case 1:\
			    for ( ; j &gt; 0; pp += 1, ++cp, --j )\
			      weight += *pp * cp-&gt;weight;\
			    break;\
			  case 3:\
			    for ( ; j &gt; 0; pp += 3, ++cp, --j )\
			      weight += *pp * cp-&gt;weight;\
			    break;\
			  default:\
			    for ( ; j &gt; 0; pp += Colors, ++cp, --j )\
			      weight += *pp * cp-&gt;weight;\
			  }\
			}\
			{ PixelIn2 pixel = unscale_AccumTmp(weight, fraction_bits);\
			  if_debug1('W', " %ld", (long)pixel);\
			  *tp =\
			    (PixelTmp)CLAMP(pixel, minPixelTmp, maxPixelTmp);\
			}\
		  }

	if (sizeofPixelIn == 1) {
	    zoom_x_loop(byte, int)
	} else {		/* sizeofPixelIn == 2 */
#if arch_ints_are_short
	    zoom_x_loop(bits16, long)
#else
	    zoom_x_loop(bits16, int)
#endif
	}
	if_debug0('W', "\n");
    }
}


/*
 * Apply filter to zoom vertically from tmp to dst.
 * This is simpler because we can treat all columns identically
 * without regard to the number of samples per pixel.
 */
private void
zoom_y(void /*PixelOut */ *dst, int sizeofPixelOut, uint MaxValueOut,
       const PixelTmp * tmp, int WidthOut, int tmp_width,
       int Colors, const CLIST * contrib, const CONTRIB * items)
{
    int kn = WidthOut * Colors;
    int cn = contrib-&gt;n;
    int first_pixel = contrib-&gt;first_pixel;
    const CONTRIB *cbp = items + contrib-&gt;index;
    int kc;
    PixelTmp2 max_weight = MaxValueOut;
#ifdef NEED_FRACTION_BITS
    const int fraction_bits =
	(sizeof(PixelTmp) - sizeofPixelOut) * 8 + num_weight_bits;
#endif

    if_debug0('W', "[W]zoom_y: ");

#define zoom_y_loop(PixelOut)\
	for ( kc = 0; kc &lt; kn; ++kc ) {\
		AccumTmp weight = 0;\
		{ const PixelTmp *pp = &amp;tmp[kc + first_pixel];\
		  int j = cn;\
		  const CONTRIB *cp = cbp;\
		  for ( ; j &gt; 0; pp += kn, ++cp, --j )\
		    weight += *pp * cp-&gt;weight;\
		}\
		{ PixelTmp2 pixel = unscale_AccumTmp(weight, fraction_bits);\
		  if_debug1('W', " %d", pixel);\
		  ((PixelOut *)dst)[kc] =\
		    (PixelOut)CLAMP(pixel, 0, max_weight);\
		}\
	}

    if (sizeofPixelOut == 1) {
	zoom_y_loop(byte)
    } else {			/* sizeofPixelOut == 2 */
	zoom_y_loop(bits16)
    }
    if_debug0('W', "\n");
}

/* ------ Stream implementation ------ */

#define tmp_width params.WidthOut
#define tmp_height params.HeightIn

/* Forward references */
private void s_IScale_release(stream_state * st);

/* Calculate the weights for an output row. */
private void
calculate_dst_contrib(stream_IScale_state * ss, int y)
{
    uint row_size = ss-&gt;params.WidthOut * ss-&gt;params.Colors;
    int last_index =
    calculate_contrib(&amp;ss-&gt;dst_next_list, ss-&gt;dst_items, ss-&gt;yscale,
		      y, 1, ss-&gt;params.HeightIn, MAX_ISCALE_SUPPORT, row_size,
		      (double)ss-&gt;params.MaxValueOut / (fixedScaleFactor * unitPixelTmp) );
    int first_index_mod = ss-&gt;dst_next_list.first_pixel / row_size;

    ss-&gt;dst_last_index = last_index;
    last_index %= MAX_ISCALE_SUPPORT;
    if (last_index &lt; first_index_mod) {		/* Shuffle the indices to account for wraparound. */
	CONTRIB shuffle[MAX_ISCALE_SUPPORT];
	int i;

	for (i = 0; i &lt; MAX_ISCALE_SUPPORT; ++i)
	    shuffle[i].weight =
		(i &lt;= last_index ?
		 ss-&gt;dst_items[i + MAX_ISCALE_SUPPORT - first_index_mod].weight :
		 i &gt;= first_index_mod ?
		 ss-&gt;dst_items[i - first_index_mod].weight :
		 0);
	memcpy(ss-&gt;dst_items, shuffle, MAX_ISCALE_SUPPORT * sizeof(CONTRIB));
	ss-&gt;dst_next_list.n = MAX_ISCALE_SUPPORT;
	ss-&gt;dst_next_list.first_pixel = 0;
    }
#ifdef DEBUG
    if (gs_debug_c('w')) {
	dprintf1("[w]calc dest contrib for y = %d\n", y);
    }
#endif
}

/* Set default parameter values (actually, just clear pointers). */
private void
s_IScale_set_defaults(stream_state * st)
{
    stream_IScale_state *const ss = (stream_IScale_state *) st;

    ss-&gt;src = 0;
    ss-&gt;dst = 0;
    ss-&gt;tmp = 0;
    ss-&gt;contrib = 0;
    ss-&gt;items = 0;
}

/* Initialize the filter. */
private int
s_IScale_init(stream_state * st)
{
    stream_IScale_state *const ss = (stream_IScale_state *) st;
    gs_memory_t *mem = ss-&gt;memory;

    ss-&gt;sizeofPixelIn = ss-&gt;params.BitsPerComponentIn / 8;
    ss-&gt;sizeofPixelOut = ss-&gt;params.BitsPerComponentOut / 8;
    ss-&gt;xscale = (double)ss-&gt;params.WidthOut / (double)ss-&gt;params.WidthIn;
    ss-&gt;yscale = (double)ss-&gt;params.HeightOut / (double)ss-&gt;params.HeightIn;

    ss-&gt;src_y = 0;
    ss-&gt;src_size = ss-&gt;params.WidthIn * ss-&gt;sizeofPixelIn * ss-&gt;params.Colors;
    ss-&gt;src_offset = 0;
    ss-&gt;dst_y = 0;
    ss-&gt;dst_size = ss-&gt;params.WidthOut * ss-&gt;sizeofPixelOut * ss-&gt;params.Colors;
    ss-&gt;dst_offset = 0;

    /* create intermediate image to hold horizontal zoom */
    ss-&gt;tmp = (PixelTmp *) gs_alloc_byte_array(mem,
					   min(ss-&gt;tmp_height, MAX_ISCALE_SUPPORT),
			      ss-&gt;tmp_width * ss-&gt;params.Colors * sizeof(PixelTmp),
					       "image_scale tmp");
    ss-&gt;contrib = (CLIST *) gs_alloc_byte_array(mem,
					   max(ss-&gt;params.WidthOut, ss-&gt;params.HeightOut),
				      sizeof(CLIST), "image_scale contrib");
    ss-&gt;items = (CONTRIB *) gs_alloc_byte_array(mem,
				  contrib_pixels(ss-&gt;xscale) * ss-&gt;params.WidthOut,
				 sizeof(CONTRIB), "image_scale contrib[*]");
    /* Allocate buffers for 1 row of source and destination. */
    ss-&gt;dst = gs_alloc_byte_array(mem, ss-&gt;params.WidthOut * ss-&gt;params.Colors,
				  ss-&gt;sizeofPixelOut, "image_scale dst");
    ss-&gt;src = gs_alloc_byte_array(mem, ss-&gt;params.WidthIn * ss-&gt;params.Colors,
				  ss-&gt;sizeofPixelIn, "image_scale src");
    if (ss-&gt;tmp == 0 || ss-&gt;contrib == 0 || ss-&gt;items == 0 ||
	ss-&gt;dst == 0 || ss-&gt;src == 0
	) {
	s_IScale_release(st);
	return ERRC;
/****** WRONG ******/
    }
    /* Pre-calculate filter contributions for a row. */
    calculate_contrib(ss-&gt;contrib, ss-&gt;items, ss-&gt;xscale,
		      0, ss-&gt;params.WidthOut, ss-&gt;params.WidthIn, ss-&gt;params.WidthIn,
		      ss-&gt;params.Colors, (double)unitPixelTmp * fixedScaleFactor / ss-&gt;params.MaxValueIn);

    /* Prepare the weights for the first output row. */
    calculate_dst_contrib(ss, 0);

    return 0;

}

/* Process a buffer.  Note that this handles Encode and Decode identically. */
private int
s_IScale_process(stream_state * st, stream_cursor_read * pr,
		 stream_cursor_write * pw, bool last)
{
    stream_IScale_state *const ss = (stream_IScale_state *) st;

    /* Check whether we need to deliver any output. */

  top:while (ss-&gt;src_y &gt; ss-&gt;dst_last_index) {	/* We have enough horizontally scaled temporary rows */
	/* to generate a vertically scaled output row. */
	uint wleft = pw-&gt;limit - pw-&gt;ptr;

	if (ss-&gt;dst_y == ss-&gt;params.HeightOut)
	    return EOFC;
	if (wleft == 0)
	    return 1;
	if (ss-&gt;dst_offset == 0) {
	    byte *row;

	    if (wleft &gt;= ss-&gt;dst_size) {	/* We can scale the row directly into the output. */
		row = pw-&gt;ptr + 1;
		pw-&gt;ptr += ss-&gt;dst_size;
	    } else {		/* We'll have to buffer the row. */
		row = ss-&gt;dst;
	    }
	    /* Apply filter to zoom vertically from tmp to dst. */
	    zoom_y(row, ss-&gt;sizeofPixelOut, ss-&gt;params.MaxValueOut, ss-&gt;tmp,
		   ss-&gt;params.WidthOut, ss-&gt;tmp_width, ss-&gt;params.Colors,
		   &amp;ss-&gt;dst_next_list, ss-&gt;dst_items);
	    /* Idiotic C coercion rules allow T* and void* to be */
	    /* inter-assigned freely, but not compared! */
	    if ((void *)row != ss-&gt;dst)		/* no buffering */
		goto adv;
	} {			/* We're delivering a buffered output row. */
	    uint wcount = ss-&gt;dst_size - ss-&gt;dst_offset;
	    uint ncopy = min(wleft, wcount);

	    memcpy(pw-&gt;ptr + 1, (byte *) ss-&gt;dst + ss-&gt;dst_offset, ncopy);
	    pw-&gt;ptr += ncopy;
	    ss-&gt;dst_offset += ncopy;
	    if (ncopy != wcount)
		return 1;
	    ss-&gt;dst_offset = 0;
	}
	/* Advance to the next output row. */
      adv:++(ss-&gt;dst_y);
	if (ss-&gt;dst_y != ss-&gt;params.HeightOut)
	    calculate_dst_contrib(ss, ss-&gt;dst_y);
    }

    /* Read input data and scale horizontally into tmp. */

    {
	uint rleft = pr-&gt;limit - pr-&gt;ptr;
	uint rcount = ss-&gt;src_size - ss-&gt;src_offset;

	if (rleft == 0)
	    return 0;		/* need more input */
#ifdef DEBUG
	assert(ss-&gt;src_y &lt; ss-&gt;params.HeightIn);
#endif
	if (rleft &gt;= rcount) {	/* We're going to fill up a row. */
	    const byte *row;

	    if (ss-&gt;src_offset == 0) {	/* We have a complete row.  Read the data */
		/* directly from the input. */
		row = pr-&gt;ptr + 1;
	    } else {		/* We're buffering a row in src. */
		row = ss-&gt;src;
		memcpy((byte *) ss-&gt;src + ss-&gt;src_offset, pr-&gt;ptr + 1,
		       rcount);
		ss-&gt;src_offset = 0;
	    }
	    /* Apply filter to zoom horizontally from src to tmp. */
	    if_debug2('w', "[w]zoom_x y = %d to tmp row %d\n",
		      ss-&gt;src_y, (ss-&gt;src_y % MAX_ISCALE_SUPPORT));
	    zoom_x(ss-&gt;tmp + (ss-&gt;src_y % MAX_ISCALE_SUPPORT) *
		   ss-&gt;tmp_width * ss-&gt;params.Colors, row,
		   ss-&gt;sizeofPixelIn, ss-&gt;tmp_width, ss-&gt;params.WidthIn,
		   ss-&gt;params.Colors, ss-&gt;contrib, ss-&gt;items);
	    pr-&gt;ptr += rcount;
	    ++(ss-&gt;src_y);
	    goto top;
	} else {		/* We don't have a complete row.  Copy data to src buffer. */
	    memcpy((byte *) ss-&gt;src + ss-&gt;src_offset, pr-&gt;ptr + 1, rleft);
	    ss-&gt;src_offset += rleft;
	    pr-&gt;ptr += rleft;
	    return 0;
	}
    }
}

/* Release the filter's storage. */
private void
s_IScale_release(stream_state * st)
{
    stream_IScale_state *const ss = (stream_IScale_state *) st;
    gs_memory_t *mem = ss-&gt;memory;

    gs_free_object(mem, (void *)ss-&gt;src, "image_scale src");	/* no longer const */
    ss-&gt;src = 0;
    gs_free_object(mem, ss-&gt;dst, "image_scale dst");
    ss-&gt;dst = 0;
    gs_free_object(mem, ss-&gt;items, "image_scale contrib[*]");
    ss-&gt;items = 0;
    gs_free_object(mem, ss-&gt;contrib, "image_scale contrib");
    ss-&gt;contrib = 0;
    gs_free_object(mem, ss-&gt;tmp, "image_scale tmp");
    ss-&gt;tmp = 0;
}

/* Stream template */
const stream_template s_IScale_template = {
    &amp;st_IScale_state, s_IScale_init, s_IScale_process, 1, 1,
    s_IScale_release, s_IScale_set_defaults
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

