<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/spdiff.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/spdiff.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1994, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: spdiff.c,v 1.9 2005/03/16 14:57:42 igor Exp $ */
/* Pixel differencing filters */
#include "stdio_.h"		/* should be std.h, but needs NULL */
#include "memory_.h"
#include "strimpl.h"
#include "spdiffx.h"

/* ------ PixelDifferenceEncode/Decode ------ */

private_st_PDiff_state();

/* Define values for case dispatch. */
#define cBits1 0
#define cBits2 5
#define cBits4 10
#define cBits8 15
#define cBits16 20
#define cEncode 0
#define cDecode 25

/* Set defaults */
private void
s_PDiff_set_defaults(stream_state * st)
{
    stream_PDiff_state *const ss = (stream_PDiff_state *) st;

    s_PDiff_set_defaults_inline(ss);
}

/* Common (re)initialization. */
private int
s_PDiff_reinit(stream_state * st)
{
    stream_PDiff_state *const ss = (stream_PDiff_state *) st;

    ss-&gt;row_left = 0;
    return 0;
}

/* Initialize PixelDifferenceEncode filter. */
private int
s_PDiffE_init(stream_state * st)
{
    stream_PDiff_state *const ss = (stream_PDiff_state *) st;
    int bits_per_row =
	ss-&gt;Colors * ss-&gt;BitsPerComponent * ss-&gt;Columns;
    static const byte cb_values[] = {
	0, cBits1, cBits2, 0, cBits4, 0, 0, 0, cBits8,
	0, 0, 0, 0, 0, 0, 0, cBits16
    };

    ss-&gt;row_count = (bits_per_row + 7) &gt;&gt; 3;
    ss-&gt;end_mask = (1 &lt;&lt; (-bits_per_row &amp; 7)) - 1;
    ss-&gt;case_index =
	cb_values[ss-&gt;BitsPerComponent] +
	(ss-&gt;Colors &gt; 4 ? 0 : ss-&gt;Colors) + cEncode;
    return s_PDiff_reinit(st);
}

/* Initialize PixelDifferenceDecode filter. */
private int
s_PDiffD_init(stream_state * st)
{
    stream_PDiff_state *const ss = (stream_PDiff_state *) st;

    s_PDiffE_init(st);
    ss-&gt;case_index += cDecode - cEncode;
    return 0;
}

/* Process a buffer.  Note that this handles both Encode and Decode. */
private int
s_PDiff_process(stream_state * st, stream_cursor_read * pr,
		stream_cursor_write * pw, bool last)
{
    stream_PDiff_state *const ss = (stream_PDiff_state *) st;
    const byte *p = pr-&gt;ptr;
    byte *q = pw-&gt;ptr;
    int count;
    int status = 0;
    uint s0 = ss-&gt;prev[0];
    byte t = 0;			/* avoid spurious compiler warnings */
    int  ti;
    const byte end_mask = ss-&gt;end_mask;
    int colors = ss-&gt;Colors;
    int nb = (colors * ss-&gt;BitsPerComponent) &gt;&gt; 3;
    int final;
    int ndone, ci;

row:
    if (ss-&gt;row_left == 0) {
	ss-&gt;row_left = ss-&gt;row_count;
	s0 = 0;
	memset(&amp;ss-&gt;prev[1], 0, sizeof(uint) * (s_PDiff_max_Colors - 1));
    }
    {
	int rcount = pr-&gt;limit - p;
	int wcount = pw-&gt;limit - q;

	if (ss-&gt;row_left &lt; rcount)
	    rcount = ss-&gt;row_left;
	count = (wcount &lt; rcount ? (status = 1, wcount) : rcount);
    }
    final = (last &amp;&amp; !status ? 1 : nb);
    ss-&gt;row_left -= count;

    /*
     * Encoding and decoding are fundamentally different.
     * Encoding computes E[i] = D[i] - D[i-1];
     * decoding computes D[i] = E[i] + D[i-1].
     * Nevertheless, the loop structures are similar enough that
     * we put the code for both functions in the same place.
     *
     * We only optimize BitsPerComponent = 1, 3, and 4, which
     * correspond to the common color spaces.  (In some cases, it's still
     * simpler to provide a separate loop for BPC = 2.)
     */

#define LOOP_BY(n, body)\
  for (; count &gt;= n; count -= n) p += n, q += n, body

    switch (ss-&gt;case_index) {

	    /* 1 bit per component */

#define ENCODE1_LOOP(ee)\
  LOOP_BY(1, (t = *p, *q = ee, s0 = t)); break

#define ENCODE_ALIGNED_LOOP(ee)\
  BEGIN\
    ss-&gt;prev[0] = s0;\
    for (; count &gt;= final; count -= ndone) {\
	ndone = min(count, nb);\
	for (ci = 0; ci &lt; ndone; ++ci)\
	    t = *++p, *++q = ee, ss-&gt;prev[ci] = t;\
    }\
    s0 = ss-&gt;prev[0];\
  END

#define ENCODE_UNALIGNED_LOOP(shift, cshift, de)\
  BEGIN\
    for (; count &gt;= final; count -= ndone) {\
	ndone = min(count, nb);\
	for (ci = 1; ci &lt;= ndone; ++ci) {\
	    ++p;\
	    t = (s0 &lt;&lt; (cshift)) | (ss-&gt;prev[ci] &gt;&gt; (shift));\
	    *++q = de;\
	    s0 = ss-&gt;prev[ci];\
	    ss-&gt;prev[ci] = *p;\
	}\
    }\
  END

	case cEncode + cBits1 + 0:
	case cEncode + cBits1 + 2:
	    if (colors &lt; 8) {	/* 2,5,6,7 */
		int cshift = 8 - colors;

		ENCODE1_LOOP(t ^ ((s0 &lt;&lt; cshift) | (t &gt;&gt; colors)));
	    } else if (colors &amp; 7) {
		int shift = colors &amp; 7;
		int cshift = 8 - shift;

		ENCODE_UNALIGNED_LOOP(shift, cshift, *p ^ t);
	    } else {
		ENCODE_ALIGNED_LOOP(t ^ ss-&gt;prev[ci]);
	    }
	    break;

	case cEncode + cBits1 + 1:
	    ENCODE1_LOOP(t ^ ((s0 &lt;&lt; 7) | (t &gt;&gt; 1)));
	case cEncode + cBits1 + 3:
	    ENCODE1_LOOP(t ^ ((s0 &lt;&lt; 5) | (t &gt;&gt; 3)));
	case cEncode + cBits1 + 4:
	    ENCODE1_LOOP(t ^ ((s0 &lt;&lt; 4) | (t &gt;&gt; 4)));

#define DECODE1_LOOP(te, de)\
  LOOP_BY(1, (t = te, s0 = *q = de)); break

#define DECODE_ALIGNED_LOOP(de)\
  BEGIN\
    ss-&gt;prev[0] = s0;\
    for (; count &gt;= final; count -= ndone) {\
	ndone = min(count, nb);\
	for (ci = 0; ci &lt; ndone; ++ci)\
	    t = *++p, ss-&gt;prev[ci] = *++q = de;\
    }\
    s0 = ss-&gt;prev[0];\
  END

#define DECODE_UNALIGNED_LOOP(shift, cshift, de)\
  BEGIN\
    for (; count &gt;= final; count -= ndone) {\
	ndone = min(count, nb);\
	for (ci = 1; ci &lt;= ndone; ++ci) {\
	    ++p, ++q;\
	    t = (s0 &lt;&lt; (cshift)) | (ss-&gt;prev[ci] &gt;&gt; (shift));\
	    s0 = ss-&gt;prev[ci];\
	    ss-&gt;prev[ci] = *q = de;\
	}\
    }\
  END

	case cDecode + cBits1 + 0:
	    if (colors &lt; 8) {	/* 5,6,7 */
		int cshift = 8 - colors;

		DECODE1_LOOP(*p ^ (s0 &lt;&lt; cshift), t ^ (t &gt;&gt; colors));
	    } else if (colors &amp; 7) {
		int shift = colors &amp; 7;
		int cshift = 8 - shift;

		DECODE_UNALIGNED_LOOP(shift, cshift, *p ^ t);
	    } else {
		DECODE_ALIGNED_LOOP(t ^ ss-&gt;prev[ci]);
	    }
	    break;

	case cDecode + cBits1 + 1:
	    DECODE1_LOOP(*p ^ (s0 &lt;&lt; 7),
			 (t ^= t &gt;&gt; 1, t ^= t &gt;&gt; 2, t ^ (t &gt;&gt; 4)));
	case cDecode + cBits1 + 2:
	    DECODE1_LOOP(*p ^ (s0 &lt;&lt; 6),
			 (t ^= (t &gt;&gt; 2), t ^ (t &gt;&gt; 4)));
	case cDecode + cBits1 + 3:
	    DECODE1_LOOP(*p ^ (s0 &lt;&lt; 5),
			 t ^ (t &gt;&gt; 3) ^ (t &gt;&gt; 6));
	case cDecode + cBits1 + 4:
	    DECODE1_LOOP(*p ^ (s0 &lt;&lt; 4),
			 t ^ (t &gt;&gt; 4));

	    /* 2 bits per component */

#define ADD4X2(a, b) ( (((a) &amp; (b) &amp; 0x55) &lt;&lt; 1) ^ (a) ^ (b) )
/* The following computation looks very implausible, but it is correct. */
#define SUB4X2(a, b) ( ((~(a) &amp; (b) &amp; 0x55) &lt;&lt; 1) ^ (a) ^ (b) )

	case cEncode + cBits2 + 0:
	    if (colors &amp; 7) {
		int shift = (colors &amp; 3) &lt;&lt; 1;
		int cshift = 8 - shift;

		ENCODE_UNALIGNED_LOOP(shift, cshift, SUB4X2(*p, t));
	    } else {
		ENCODE_ALIGNED_LOOP(SUB4X2(t, ss-&gt;prev[ci]));
	    }
	    break;

	case cEncode + cBits2 + 1:
	    ENCODE1_LOOP((s0 = (s0 &lt;&lt; 6) | (t &gt;&gt; 2), SUB4X2(t, s0)));
	case cEncode + cBits2 + 2:
	    ENCODE1_LOOP((s0 = (s0 &lt;&lt; 4) | (t &gt;&gt; 4), SUB4X2(t, s0)));
	case cEncode + cBits2 + 3:
	    ENCODE1_LOOP((s0 = (s0 &lt;&lt; 2) | (t &gt;&gt; 6), SUB4X2(t, s0)));
	case cEncode + cBits2 + 4:
	    ENCODE1_LOOP(SUB4X2(t, s0));

	case cDecode + cBits2 + 0:
	    if (colors &amp; 7) {
		int shift = (colors &amp; 3) &lt;&lt; 1;
		int cshift = 8 - shift;

		DECODE_UNALIGNED_LOOP(shift, cshift, ADD4X2(*p, t));
	    } else {
		DECODE_ALIGNED_LOOP(ADD4X2(t, ss-&gt;prev[ci]));
	    }
	    break;

	case cDecode + cBits2 + 1:
	    DECODE1_LOOP(*p + (s0 &lt;&lt; 6),
			 (t = ADD4X2(t &gt;&gt; 2, t), ADD4X2(t &gt;&gt; 4, t)));
	case cDecode + cBits2 + 2:
	    DECODE1_LOOP(*p, (t = ADD4X2(t, s0 &lt;&lt; 4), ADD4X2(t &gt;&gt; 4, t)));
	case cDecode + cBits2 + 3:
	    DECODE1_LOOP(*p, (t = ADD4X2(t, s0 &lt;&lt; 2), ADD4X2(t &gt;&gt; 6, t)));
	case cDecode + cBits2 + 4:
	    DECODE1_LOOP(*p, ADD4X2(t, s0));

#undef ADD4X2
#undef SUB4X2

	    /* 4 bits per component */

#define ADD2X4(a, b) ( (((a) + (b)) &amp; 0xf) + ((a) &amp; 0xf0) + ((b) &amp; 0xf0) )
#define ADD2X4R4(a) ( (((a) + ((a) &gt;&gt; 4)) &amp; 0xf) + ((a) &amp; 0xf0) )
#define SUB2X4(a, b) ( (((a) - (b)) &amp; 0xf) + ((a) &amp; 0xf0) - ((b) &amp; 0xf0) )
#define SUB2X4R4(a) ( (((a) - ((a) &gt;&gt; 4)) &amp; 0xf) + ((a) &amp; 0xf0) )

	case cEncode + cBits4 + 0:
	case cEncode + cBits4 + 2:
    enc4:
	    if (colors &amp; 1) {
		ENCODE_UNALIGNED_LOOP(4, 4, SUB2X4(*p, t));
	    } else {
		ENCODE_ALIGNED_LOOP(SUB2X4(t, ss-&gt;prev[ci]));
	    }
	    break;

	case cEncode + cBits4 + 1:
	    ENCODE1_LOOP(((t - (s0 &lt;&lt; 4)) &amp; 0xf0) | ((t - (t &gt;&gt; 4)) &amp; 0xf));

	case cEncode + cBits4 + 3: {
	    uint s1 = ss-&gt;prev[1];

	    LOOP_BY(1,
		    (t = *p,
		     *q = ((t - (s0 &lt;&lt; 4)) &amp; 0xf0) | ((t - (s1 &gt;&gt; 4)) &amp; 0xf),
		     s0 = s1, s1 = t));
	    ss-&gt;prev[1] = s1;
	} break;

	case cEncode + cBits4 + 4: {
	    uint s1 = ss-&gt;prev[1];

	    LOOP_BY(2,
		    (t = p[-1], q[-1] = SUB2X4(t, s0), s0 = t,
		     t = *p, *q = SUB2X4(t, s1), s1 = t));
	    ss-&gt;prev[1] = s1;
	    goto enc4;		/* handle leftover bytes */
	}

	case cDecode + cBits4 + 0:
	case cDecode + cBits4 + 2:
    dec4:
	    if (colors &amp; 1) {
		DECODE_UNALIGNED_LOOP(4, 4, ADD2X4(*p, t));
	    } else {
		DECODE_ALIGNED_LOOP(ADD2X4(t, ss-&gt;prev[ci]));
	    }
	    break;

	case cDecode + cBits4 + 1:
	    DECODE1_LOOP(*p + (s0 &lt;&lt; 4), ADD2X4R4(t));

	case cDecode + cBits4 + 3: {
	    uint s1 = ss-&gt;prev[1];

	    LOOP_BY(1, (t = (s0 &lt;&lt; 4) + (s1 &gt;&gt; 4),
			s0 = s1, s1 = *q = ADD2X4(*p, t)));
	    ss-&gt;prev[1] = s1;
	} break;

	case cDecode + cBits4 + 4: {
	    uint s1 = ss-&gt;prev[1];

	    LOOP_BY(2,
		    (t = p[-1], s0 = q[-1] = ADD2X4(s0, t),
		     t = *p, s1 = *q = ADD2X4(s1, t)));
	    ss-&gt;prev[1] = s1;
	    goto dec4;		/* handle leftover bytes */
	}

#undef ADD2X4
#undef ADD2X4R4
#undef SUB2X4
#undef SUB2X4R4

	    /* 8 bits per component */

#define ENCODE8(s, d) (q[d] = p[d] - s, s = p[d])
#define DECODE8(s, d) q[d] = s += p[d]

	case cEncode + cBits8 + 0:
	case cEncode + cBits8 + 2:
	    ss-&gt;prev[0] = s0;
	    for (; count &gt;= colors; count -= colors)
		for (ci = 0; ci &lt; colors; ++ci) {
		    *++q = *++p - ss-&gt;prev[ci];
		    ss-&gt;prev[ci] = *p;
		}
	    s0 = ss-&gt;prev[0];
    enc8:   /* Handle leftover bytes. */
	    if (last &amp;&amp; !status)
		for (ci = 0; ci &lt; count; ++ci)
		    *++q = *++p - ss-&gt;prev[ci],
			ss-&gt;prev[ci] = *p;
	    break;

	case cDecode + cBits8 + 0:
	case cDecode + cBits8 + 2:
	    ss-&gt;prev[0] = s0;
	    for (; count &gt;= colors; count -= colors)
		for (ci = 0; ci &lt; colors; ++ci)
		    *++q = ss-&gt;prev[ci] += *++p;
	    s0 = ss-&gt;prev[0];
    dec8:   /* Handle leftover bytes. */
	    if (last &amp;&amp; !status)
		for (ci = 0; ci &lt; count; ++ci)
		    *++q = ss-&gt;prev[ci] += *++p;
	    break;

	case cEncode + cBits8 + 1:
	    LOOP_BY(1, ENCODE8(s0, 0));
	    break;

	case cDecode + cBits8 + 1:
	    LOOP_BY(1, DECODE8(s0, 0));
	    break;

	case cEncode + cBits8 + 3: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2];

	    LOOP_BY(3, (ENCODE8(s0, -2), ENCODE8(s1, -1),
			ENCODE8(s2, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2;
	    goto enc8;
	}

	case cDecode + cBits8 + 3: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2];

	    LOOP_BY(3, (DECODE8(s0, -2), DECODE8(s1, -1),
			DECODE8(s2, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2;
	    goto dec8;
	} break;

	case cEncode + cBits8 + 4: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2], s3 = ss-&gt;prev[3];

	    LOOP_BY(4, (ENCODE8(s0, -3), ENCODE8(s1, -2),
			ENCODE8(s2, -1), ENCODE8(s3, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2, ss-&gt;prev[3] = s3;
	    goto enc8;
	} break;

	case cDecode + cBits8 + 4: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2], s3 = ss-&gt;prev[3];

	    LOOP_BY(4, (DECODE8(s0, -3), DECODE8(s1, -2),
			DECODE8(s2, -1), DECODE8(s3, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2, ss-&gt;prev[3] = s3;
	    goto dec8;
	} break;

#undef ENCODE8
#undef DECODE8

	    /* 16 bits per component */

#define ENCODE16(s, d) (ti = ((p[d-1] &lt;&lt; 8) + p[d]) - s, \
	    q[d-1] = ti &gt;&gt; 8, q[d] = t &amp; 0xff, s = ti)
#define DECODE16(s, d) (s = 0xffff &amp; (s + ((p[d-1] &lt;&lt; 8) + p[d])), \
	    q[d-1] = s &gt;&gt; 8, q[d] = s &amp;&amp; 0xff)

	case cEncode + cBits16 + 0:
	case cEncode + cBits16 + 2:
	    ss-&gt;prev[0] = s0;
	    for (; count &gt;= colors; count -= colors)
		for (ci = 0; ci &lt; colors; ++ci) {
		    ti = (int)*++p &lt;&lt; 8;
		    ti = (ti + *++p) - ss-&gt;prev[ci];
		    *++q = ti &gt;&gt; 8; *++q = ti &amp; 0xff;
		    ss-&gt;prev[ci] = ti;
		}
	    s0 = ss-&gt;prev[0];
    enc16:   /* Handle leftover bytes. */
	    if (last &amp;&amp; !status)
		for (ci = 0; ci &lt; count; ++ci)
		    *++q = *++p - ss-&gt;prev[ci],
			ss-&gt;prev[ci] = *p;
	    break;

	case cDecode + cBits16 + 0:
	case cDecode + cBits16 + 2:
	    ss-&gt;prev[0] = s0;
	    for (; count &gt;= colors; count -= colors)
		for (ci = 0; ci &lt; colors; ++ci) {
		    ti = *++p &gt;&gt; 8;
		    ss-&gt;prev[ci] += ti + *++p;
		    *++q = ss-&gt;prev[ci] &gt;&gt; 8;
		    *++q = ss-&gt;prev[ci] &amp; 0xff;
		}
	    s0 = ss-&gt;prev[0];
    dec16:   /* Ignore leftover bytes. */
	    break;

	case cEncode + cBits16 + 1:
	    LOOP_BY(2, ENCODE16(s0, 0));
	    break;

	case cDecode + cBits16 + 1:
	    LOOP_BY(2, DECODE16(s0, 0));
	    break;

	case cEncode + cBits16 + 3: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2];

	    LOOP_BY(6, (ENCODE16(s0, -4), ENCODE16(s1, -2),
			ENCODE16(s2, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2;
	    goto enc16;
	}

	case cDecode + cBits16 + 3: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2];

	    LOOP_BY(6, (DECODE16(s0, -4), DECODE16(s1, -2),
			DECODE16(s2, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2;
	    goto dec16;
	} break;

	case cEncode + cBits16 + 4: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2], s3 = ss-&gt;prev[3];

	    LOOP_BY(8, (ENCODE16(s0, -6), ENCODE16(s1, -4),
			ENCODE16(s2, -2), ENCODE16(s3, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2, ss-&gt;prev[3] = s3;
	    goto enc16;
	} break;

	case cDecode + cBits16 + 4: {
	    uint s1 = ss-&gt;prev[1], s2 = ss-&gt;prev[2], s3 = ss-&gt;prev[3];

	    LOOP_BY(8, (DECODE16(s0, -6), DECODE16(s1, -4),
			DECODE16(s2, -2), DECODE16(s3, 0)));
	    ss-&gt;prev[1] = s1, ss-&gt;prev[2] = s2, ss-&gt;prev[3] = s3;
	    goto dec16;
	} break;

#undef ENCODE16
#undef DECODE16

    }
#undef LOOP_BY
#undef ENCODE1_LOOP
#undef DECODE1_LOOP
    ss-&gt;row_left += count;	/* leftover bytes are possible */
    if (ss-&gt;row_left == 0) {
	if (end_mask != 0)
	    *q = (*q &amp; ~end_mask) | (*p &amp; end_mask);
	if (p &lt; pr-&gt;limit &amp;&amp; q &lt; pw-&gt;limit)
	    goto row;
    }
    ss-&gt;prev[0] = s0;
    pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    return status;
}

/* Stream templates */
const stream_template s_PDiffE_template = {
    &amp;st_PDiff_state, s_PDiffE_init, s_PDiff_process, 1, 1, NULL,
    s_PDiff_set_defaults, s_PDiff_reinit
};
const stream_template s_PDiffD_template = {
    &amp;st_PDiff_state, s_PDiffD_init, s_PDiff_process, 1, 1, NULL,
    s_PDiff_set_defaults, s_PDiff_reinit
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

