<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/spngp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/spngp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: spngp.c,v 1.4 2002/02/21 22:24:54 giles Exp $ */
/* PNG pixel prediction filters */
#include "memory_.h"
#include "strimpl.h"
#include "spngpx.h"

/* ------ PNGPredictorEncode/Decode ------ */

private_st_PNGP_state();

/* Define values for case dispatch. */
#define cNone 10
#define cSub 11
#define cUp 12
#define cAverage 13
#define cPaeth 14
#define cOptimum 15
#define cEncode -10
#define cDecode -4
private const byte pngp_case_needs_prev[] = {
    0, 0, 1, 1, 1, 1
};

/* Set defaults */
private void
s_PNGP_set_defaults(stream_state * st)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;

    s_PNGP_set_defaults_inline(ss);
}

/* Common (re)initialization. */
private int
s_PNGP_reinit(stream_state * st)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;

    if (ss-&gt;prev_row != 0)
	memset(ss-&gt;prev_row + ss-&gt;bpp, 0, ss-&gt;row_count);
    ss-&gt;row_left = 0;
    return 0;
}

/* Common initialization. */
private int
s_pngp_init(stream_state * st, bool need_prev)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;
    int bits_per_pixel = ss-&gt;Colors * ss-&gt;BitsPerComponent;
    long bits_per_row = (long)bits_per_pixel * ss-&gt;Columns;
    byte *prev_row = 0;

#if arch_sizeof_long &gt; arch_sizeof_int
    if (bits_per_row &gt; max_uint * 7L)
	return ERRC;	/****** WRONG ******/
#endif
    ss-&gt;row_count = (uint) ((bits_per_row + 7) &gt;&gt; 3);
    ss-&gt;end_mask = (1 &lt;&lt; (-bits_per_row &amp; 7)) - 1;
    ss-&gt;bpp = (bits_per_pixel + 7) &gt;&gt; 3;
    if (need_prev) {
	prev_row = gs_alloc_bytes(st-&gt;memory, ss-&gt;bpp + ss-&gt;row_count,
				  "PNGPredictor prev row");
	if (prev_row == 0)
	    return ERRC;	/****** WRONG ******/
	memset(prev_row, 0, ss-&gt;bpp);
    }
    ss-&gt;prev_row = prev_row;
    /* case_index is only preset for encoding */
    return s_PNGP_reinit(st);
}

/* Initialize PNGPredictorEncode filter. */
private int
s_PNGPE_init(stream_state * st)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;

    return s_pngp_init(st, pngp_case_needs_prev[ss-&gt;Predictor - cNone]);
}

/* Initialize PNGPredictorDecode filter. */
private int
s_PNGPD_init(stream_state * st)
{
    return s_pngp_init(st, true);
}

/* Release a PNGPredictor filter. */
private void
s_PNGP_release(stream_state *st)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;

    if (ss-&gt;prev_row)
	gs_free_object(st-&gt;memory, ss-&gt;prev_row, "PNGPredictor prev row");
}

/*
 * Process a partial buffer.  We pass in current and previous pointers
 * to both the current and preceding scan line.  Note that dprev is
 * p - bpp for encoding, q - bpp for decoding; similarly, the 'up' row
 * is the raw data for encoding, the filtered data for decoding.
 * Note also that the case_index cannot be cOptimum.
 */
private int
paeth_predictor(int a, int b, int c)
{
    /* The definitions of ac and bc are correct, not a typo. */
    int ac = b - c, bc = a - c, abcc = ac + bc;
    int pa = (ac &lt; 0 ? -ac : ac), pb = (bc &lt; 0 ? -bc : bc),
	pc = (abcc &lt; 0 ? -abcc : abcc);

    return (pa &lt;= pb &amp;&amp; pa &lt;= pc ? a : pb &lt;= pc ? b : c);
}
private void
s_pngp_process(stream_state * st, stream_cursor_write * pw,
	       const byte * dprev, stream_cursor_read * pr,
	       const byte * upprev, const byte * up, uint count)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;
    byte *q = pw-&gt;ptr + 1;
    const byte *p = pr-&gt;ptr + 1;

    pr-&gt;ptr += count;
    pw-&gt;ptr += count;
    ss-&gt;row_left -= count;
    switch (ss-&gt;case_index) {
	case cEncode + cNone:
	case cDecode + cNone:
	    memcpy(q, p, count);
	    break;
	case cEncode + cSub:
	    for (; count; ++q, ++dprev, ++p, --count)
		*q = (byte) (*p - *dprev);
	    break;
	case cDecode + cSub:
	    for (; count; ++q, ++dprev, ++p, --count)
		*q = (byte) (*p + *dprev);
	    break;
	case cEncode + cUp:
	    for (; count; ++q, ++up, ++p, --count)
		*q = (byte) (*p - *up);
	    break;
	case cDecode + cUp:
	    for (; count; ++q, ++up, ++p, --count)
		*q = (byte) (*p + *up);
	    break;
	case cEncode + cAverage:
	    for (; count; ++q, ++dprev, ++up, ++p, --count)
		*q = (byte) (*p - arith_rshift_1((int)*dprev + (int)*up));
	    break;
	case cDecode + cAverage:
	    for (; count; ++q, ++dprev, ++up, ++p, --count)
		*q = (byte) (*p + arith_rshift_1((int)*dprev + (int)*up));
	    break;
	case cEncode + cPaeth:
	    for (; count; ++q, ++dprev, ++up, ++upprev, ++p, --count)
		*q = (byte) (*p - paeth_predictor(*dprev, *up, *upprev));
	    break;
	case cDecode + cPaeth:
	    for (; count; ++q, ++dprev, ++up, ++upprev, ++p, --count)
		*q = (byte) (*p + paeth_predictor(*dprev, *up, *upprev));
	    break;
    }
}

/* Calculate the number of bytes for the next processing step, */
/* the min of (input data, output data, remaining row length). */
private uint
s_pngp_count(const stream_state * st_const, const stream_cursor_read * pr,
	     const stream_cursor_write * pw)
{
    const stream_PNGP_state *const ss_const =
	(const stream_PNGP_state *)st_const;
    uint rcount = pr-&gt;limit - pr-&gt;ptr;
    uint wcount = pw-&gt;limit - pw-&gt;ptr;
    uint row_left = ss_const-&gt;row_left;

    if (rcount &lt; row_left)
	row_left = rcount;
    if (wcount &lt; row_left)
	row_left = wcount;
    return row_left;
}

/*
 * Encode a buffer.  Let N = ss-&gt;row_count, P = N - ss-&gt;row_left,
 * and B = ss-&gt;bpp.  Consider that bytes [-B .. -1] of every row are zero.
 * Then:
 *      prev_row[0 .. P - 1] contain bytes -B .. P - B - 1
 *        of the current input row.
 *      ss-&gt;prev[0 .. B - 1] contain bytes P - B .. P - 1
 *        of the current input row.
 *      prev_row[P .. N + B - 1] contain bytes P - B .. N - 1
 *        of the previous input row.
 */
private int
optimum_predictor(const stream_state * st, const stream_cursor_read * pr)
{
    return cSub;
}
private int
s_PNGPE_process(stream_state * st, stream_cursor_read * pr,
		stream_cursor_write * pw, bool last)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;
    int bpp = ss-&gt;bpp;
    int status = 0;

    while (pr-&gt;ptr &lt; pr-&gt;limit) {
	uint count;

	if (ss-&gt;row_left == 0) {
	    /* Beginning of row, write algorithm byte. */
	    int predictor;

	    if (pw-&gt;ptr &gt;= pw-&gt;limit) {
		status = 1;
		break;
	    }
	    predictor =
		(ss-&gt;Predictor == cOptimum ?
		 optimum_predictor(st, pr) :
		 ss-&gt;Predictor);
	    *++(pw-&gt;ptr) = (byte) predictor - cNone;
	    ss-&gt;case_index = predictor + cEncode;
	    ss-&gt;row_left = ss-&gt;row_count;
	    memset(ss-&gt;prev, 0, bpp);
	    continue;
	}
	count = s_pngp_count(st, pr, pw);
	if (count == 0) {
	    /* We know we have input, so output must be full. */
	    status = 1;
	    break;
	} {
	    byte *up = ss-&gt;prev_row + bpp + ss-&gt;row_count - ss-&gt;row_left;
	    uint n = min(count, bpp);

	    /* Process bytes whose predecessors are in prev. */
	    s_pngp_process(st, pw, ss-&gt;prev, pr, up - bpp, up, n);
	    if (ss-&gt;prev_row)
		memcpy(up - bpp, ss-&gt;prev, n);
	    if (ss-&gt;row_left == 0)
		continue;
	    if (n &lt; bpp) {
		/*
		 * We didn't have both enough input data and enough output
		 * space to use up all of prev.  Shift more data into prev
		 * and exit.
		 */
		int prev_left = bpp - n;

		memmove(ss-&gt;prev, ss-&gt;prev + n, prev_left);
		memcpy(ss-&gt;prev + prev_left, pr-&gt;ptr - (n - 1), n);
		if (pw-&gt;ptr &gt;= pw-&gt;limit &amp;&amp; pr-&gt;ptr &lt; pr-&gt;limit)
		    status = 1;
		break;
	    }
	    /* Process bytes whose predecessors are in the input. */
	    /* We know we have at least bpp input and output bytes, */
	    /* and that n = bpp. */
	    count -= bpp;
	    s_pngp_process(st, pw, pr-&gt;ptr - (bpp - 1), pr,
			   up, up + bpp, count);
	    memcpy(ss-&gt;prev, pr-&gt;ptr - (bpp - 1), bpp);
	    if (ss-&gt;prev_row) {
		memcpy(up, pr-&gt;ptr - (bpp + count - 1), count);
		if (ss-&gt;row_left == 0)
		    memcpy(up + count, ss-&gt;prev, bpp);
	    }
	}
    }
    return status;
}

/*
 * Decode a buffer.  Let N = ss-&gt;row_count, P = N - ss-&gt;row_left,
 * and B = ss-&gt;bpp.  Consider that bytes [-B .. -1] of every row are zero.
 * Then:
 *      prev_row[0 .. P - 1] contain bytes -B .. P - B - 1
 *        of the current output row.
 *      ss-&gt;prev[0 .. B - 1] contain bytes P - B .. P - 1
 *        of the current output row.
 *      prev_row[P .. N + B - 1] contain bytes P - B .. N - 1
 *        of the previous output row.
 */
private int
s_PNGPD_process(stream_state * st, stream_cursor_read * pr,
		stream_cursor_write * pw, bool last)
{
    stream_PNGP_state *const ss = (stream_PNGP_state *) st;
    int bpp = ss-&gt;bpp;
    int status = 0;

    while (pr-&gt;ptr &lt; pr-&gt;limit) {
	uint count;

	if (ss-&gt;row_left == 0) {
	    /* Beginning of row, read algorithm byte. */
	    int predictor = pr-&gt;ptr[1];

	    if (predictor &gt;= cOptimum - cNone) {
		status = ERRC;
		break;
	    }
	    pr-&gt;ptr++;
	    ss-&gt;case_index = predictor + cNone + cDecode;
	    ss-&gt;row_left = ss-&gt;row_count;
	    memset(ss-&gt;prev, 0, bpp);
	    continue;
	}
	count = s_pngp_count(st, pr, pw);
	if (count == 0) {
	    /* We know we have input, so output must be full. */
	    status = 1;
	    break;
	} {
	    byte *up = ss-&gt;prev_row + bpp + ss-&gt;row_count - ss-&gt;row_left;
	    uint n = min(count, bpp);

	    /* Process bytes whose predecessors are in prev. */
	    s_pngp_process(st, pw, ss-&gt;prev, pr, up - bpp, up, n);
	    if (ss-&gt;prev_row)
		memcpy(up - bpp, ss-&gt;prev, n);
	    if (ss-&gt;row_left == 0)
		continue;
	    if (n &lt; bpp) {
		/*
		 * We didn't have both enough input data and enough output
		 * space to use up all of prev.  Shift more data into prev
		 * and exit.
		 */
		int prev_left = bpp - n;

		memmove(ss-&gt;prev, ss-&gt;prev + n, prev_left);
		memcpy(ss-&gt;prev + prev_left, pw-&gt;ptr - (n - 1), n);
		if (pw-&gt;ptr &gt;= pw-&gt;limit &amp;&amp; pr-&gt;ptr &lt; pr-&gt;limit)
		    status = 1;
		break;
	    }
	    /* Process bytes whose predecessors are in the output. */
	    /* We know we have at least bpp input and output bytes, */
	    /* and that n = bpp. */
	    count -= bpp;
	    s_pngp_process(st, pw, pw-&gt;ptr - (bpp - 1), pr,
			   up, up + bpp, count);
	    memcpy(ss-&gt;prev, pw-&gt;ptr - (bpp - 1), bpp);
	    if (ss-&gt;prev_row) {
		memcpy(up, pw-&gt;ptr - (bpp + count - 1), count);
		if (ss-&gt;row_left == 0)
		    memcpy(up + count, ss-&gt;prev, bpp);
	    }
	}
    }
    return status;
}

/* Stream templates */
const stream_template s_PNGPE_template = {
    &amp;st_PNGP_state, s_PNGPE_init, s_PNGPE_process, 1, 1, s_PNGP_release,
    s_PNGP_set_defaults, s_PNGP_reinit
};
const stream_template s_PNGPD_template = {
    &amp;st_PNGP_state, s_PNGPD_init, s_PNGPD_process, 1, 1, s_PNGP_release,
    s_PNGP_set_defaults, s_PNGP_reinit
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

