<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/sstring.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/sstring.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1993, 1995, 1996, 1997, 1998, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: sstring.c,v 1.5 2005/04/25 12:28:49 igor Exp $ */
/* String and hexstring streams (filters) */
#include "stdio_.h"		/* includes std.h */
#include "memory_.h"
#include "string_.h"
#include "strimpl.h"
#include "sstring.h"
#include "scanchar.h"

/* ------ ASCIIHexEncode ------ */

private_st_AXE_state();

/* Initialize the state */
private int
s_AXE_init(stream_state * st)
{
    stream_AXE_state *const ss = (stream_AXE_state *) st;

    return s_AXE_init_inline(ss);
}

/* Process a buffer */
private int
s_AXE_process(stream_state * st, stream_cursor_read * pr,
	      stream_cursor_write * pw, bool last)
{
    stream_AXE_state *const ss = (stream_AXE_state *) st;
    const byte *p = pr-&gt;ptr;
    byte *q = pw-&gt;ptr;
    int rcount = pr-&gt;limit - p;
    int wcount = pw-&gt;limit - q;
    int count;
    int pos = ss-&gt;count;
    const char *hex_digits = "0123456789ABCDEF";
    int status = 0;

    if (last &amp;&amp; ss-&gt;EndOfData)
	wcount--;		/* leave room for '&gt;' */
    wcount -= (wcount + 64) / 65;	/* leave room for \n */
    wcount &gt;&gt;= 1;		/* 2 chars per input byte */
    count = (wcount &lt; rcount ? (status = 1, wcount) : rcount);
    while (--count &gt;= 0) {
	*++q = hex_digits[*++p &gt;&gt; 4];
	*++q = hex_digits[*p &amp; 0xf];
	if (!(++pos &amp; 31) &amp;&amp; (count != 0 || !last))
	    *++q = '\n';
    }
    if (last &amp;&amp; status == 0 &amp;&amp; ss-&gt;EndOfData)
	*++q = '&gt;';
    pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    ss-&gt;count = pos &amp; 31;
    return status;
}

/* Stream template */
const stream_template s_AXE_template =
{&amp;st_AXE_state, s_AXE_init, s_AXE_process, 1, 3
};

/* ------ ASCIIHexDecode ------ */

private_st_AXD_state();

/* Initialize the state */
private int
s_AXD_init(stream_state * st)
{
    stream_AXD_state *const ss = (stream_AXD_state *) st;

    return s_AXD_init_inline(ss);
}

/* Process a buffer */
private int
s_AXD_process(stream_state * st, stream_cursor_read * pr,
	      stream_cursor_write * pw, bool last)
{
    stream_AXD_state *const ss = (stream_AXD_state *) st;
    int code = s_hex_process(pr, pw, &amp;ss-&gt;odd, hex_ignore_whitespace);

    switch (code) {
	case 0:
	    if (ss-&gt;odd &gt;= 0 &amp;&amp; last) {
		if (pw-&gt;ptr == pw-&gt;limit)
		    return 1;
		*++(pw-&gt;ptr) = ss-&gt;odd &lt;&lt; 4;
	    }
	    /* falls through */
	case 1:
	    /* We still need to read ahead and check for EOD. */
	    for (; pr-&gt;ptr &lt; pr-&gt;limit; pr-&gt;ptr++)
		if (scan_char_decoder[pr-&gt;ptr[1]] != ctype_space) {
		    if (pr-&gt;ptr[1] == '&gt;') {
			pr-&gt;ptr++;
			goto eod;
		    }
		    return 1;
		}
	    return 0;		/* still need to scan ahead */
	default:
	    return code;
	case ERRC:
	    ;
    }
    /*
     * Check for EOD.  ERRC implies at least one more character
     * was read; we must unread it, since the caller might have
     * invoked the filter with exactly the right count to read all
     * the available data, and we might be reading past the end.
     */
    if (*pr-&gt;ptr != '&gt;') {	/* EOD */
	--(pr-&gt;ptr);
	return ERRC;
    }
  eod:if (ss-&gt;odd &gt;= 0) {
	if (pw-&gt;ptr == pw-&gt;limit)
	    return 1;
	*++(pw-&gt;ptr) = ss-&gt;odd &lt;&lt; 4;
    }
    return EOFC;
}

/* Stream template */
const stream_template s_AXD_template =
{&amp;st_AXD_state, s_AXD_init, s_AXD_process, 2, 1
};

/* ------ PSStringEncode ------ */

/* Process a buffer */
private int
s_PSSE_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    const byte *p = pr-&gt;ptr;
    const byte *rlimit = pr-&gt;limit;
    byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit;
    int status = 0;

    /* This doesn't have to be very efficient. */
    while (p &lt; rlimit) {
	int c = *++p;

	if (c &lt; 32 || c &gt;= 127) {
	    const char *pesc;
	    const char *const esc = "\n\r\t\b\f";

	    if (c &lt; 32 &amp;&amp; c != 0 &amp;&amp; (pesc = strchr(esc, c)) != 0) {
		if (wlimit - q &lt; 2) {
		    --p;
		    status = 1;
		    break;
		}
		*++q = '\\';
		*++q = "nrtbf"[pesc - esc];
		continue;
	    }
	    if (wlimit - q &lt; 4) {
		--p;
		status = 1;
		break;
	    }
	    q[1] = '\\';
	    q[2] = (c &gt;&gt; 6) + '0';
	    q[3] = ((c &gt;&gt; 3) &amp; 7) + '0';
	    q[4] = (c &amp; 7) + '0';
	    q += 4;
	    continue;
	} else if (c == '(' || c == ')' || c == '\\') {
	    if (wlimit - q &lt; 2) {
		--p;
		status = 1;
		break;
	    }
	    *++q = '\\';
	} else {
	    if (q == wlimit) {
		--p;
		status = 1;
		break;
	    }
	}
	*++q = c;
    }
    if (last &amp;&amp; status == 0) {
	if (q == wlimit)
	    status = 1;
	else
	    *++q = ')';
    }
    pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    return status;
}

/* Stream template */
const stream_template s_PSSE_template =
{&amp;st_stream_state, NULL, s_PSSE_process, 1, 4
};

/* ------ PSStringDecode ------ */

private_st_PSSD_state();

/* Initialize the state */
int
s_PSSD_init(stream_state * st)
{
    stream_PSSD_state *const ss = (stream_PSSD_state *) st;

    ss-&gt;from_string = false;
    return s_PSSD_partially_init_inline(ss);
}

/* Process a buffer */
private int
s_PSSD_process(stream_state * st, stream_cursor_read * pr,
	       stream_cursor_write * pw, bool last)
{
    stream_PSSD_state *const ss = (stream_PSSD_state *) st;
    const byte *p = pr-&gt;ptr;
    const byte *rlimit = pr-&gt;limit;
    byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit;
    int status = 0;
    int c;

#define check_p(n)\
  if ( p == rlimit ) { p -= n; goto out; }
#define check_q(n)\
  if ( q == wlimit ) { p -= n; status = 1; goto out; }
    while (p &lt; rlimit) {
	c = *++p;
	if (c == '\\' &amp;&amp; !ss-&gt;from_string) {
	    check_p(1);
	    switch ((c = *++p)) {
		case 'n':
		    c = '\n';
		    goto put;
		case 'r':
		    c = '\r';
		    goto put;
		case 't':
		    c = '\t';
		    goto put;
		case 'b':
		    c = '\b';
		    goto put;
		case 'f':
		    c = '\f';
		    goto put;
		default:	/* ignore the \ */
		  put:check_q(2);
		    *++q = c;
		    continue;
		case char_CR:	/* ignore, check for following \n */
		    check_p(2);
		    if (p[1] == char_EOL)
			p++;
		    continue;
		case char_EOL:	/* ignore */
		    continue;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		    {
			int d;

			check_p(2);
			d = p[1];
			c -= '0';
			if (d &gt;= '0' &amp;&amp; d &lt;= '7') {
			    if (p + 1 == rlimit) {
				p -= 2;
				goto out;
			    }
			    check_q(2);
			    c = (c &lt;&lt; 3) + d - '0';
			    d = p[2];
			    if (d &gt;= '0' &amp;&amp; d &lt;= '7') {
				c = (c &lt;&lt; 3) + d - '0';
				p += 2;
			    } else
				p++;
			} else
			    check_q(2);
			*++q = c;
			continue;
		    }
	    }
	} else
	    switch (c) {
		case '(':
		    check_q(1);
		    ss-&gt;depth++;
		    break;
		case ')':
		    if (ss-&gt;depth == 0) {
			status = EOFC;
			goto out;
		    }
		    check_q(1);
		    ss-&gt;depth--;
		    break;
		case char_CR:	/* convert to \n */
		    check_p(1);
		    check_q(1);
		    if (p[1] == char_EOL)
			p++;
		    *++q = '\n';
		    continue;
		case char_EOL:
		    c = '\n';
		default:
		    check_q(1);
		    break;
	    }
	*++q = c;
    }
#undef check_p
#undef check_q
  out:pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    if (last &amp;&amp; status == 0 &amp;&amp; p != rlimit)
	status = ERRC;
    return status;
}

/* Stream template */
const stream_template s_PSSD_template =
{&amp;st_PSSD_state, s_PSSD_init, s_PSSD_process, 4, 1
};

/* ------ Utilities ------ */

/*
 * Convert hex data to binary.  Return 1 if we filled the string, 0 if
 * we ran out of input data before filling the string, or ERRC on error.
 * The caller must set *odd_digit to -1 before the first call;
 * after each call, if an odd number of hex digits has been read (total),
 * *odd_digit is the odd digit value, otherwise *odd_digit = -1.
 * See strimpl.h for the definition of syntax.
 */
int
s_hex_process(stream_cursor_read * pr, stream_cursor_write * pw,
	      int *odd_digit, hex_syntax syntax)
{
    const byte *p = pr-&gt;ptr;
    const byte *rlimit = pr-&gt;limit;
    byte *q = pw-&gt;ptr;
    byte *wlimit = pw-&gt;limit;
    byte *q0 = q;
    byte val1 = (byte) * odd_digit;
    byte val2;
    uint rcount;
    byte *flimit;
    const byte *const decoder = scan_char_decoder;
    int code = 0;

    if (q &gt;= wlimit)
	return 1;
    if (val1 &lt;= 0xf)
	goto d2;
  d1:if ((rcount = (rlimit - p) &gt;&gt; 1) == 0)
	goto x1;
    /* Set up a fast end-of-loop check, so we don't have to test */
    /* both p and q against their respective limits. */
    flimit = (rcount &lt; wlimit - q ? q + rcount : wlimit);
  f1:if ((val1 = decoder[p[1]]) &lt;= 0xf &amp;&amp;
	(val2 = decoder[p[2]]) &lt;= 0xf
	) {
	p += 2;
	*++q = (val1 &lt;&lt; 4) + val2;
	if (q &lt; flimit)
	    goto f1;
	if (q &gt;= wlimit)
	    goto px;
    }
  x1:if (p &gt;= rlimit)
	goto end1;
    if ((val1 = decoder[*++p]) &gt; 0xf) {
	if (val1 == ctype_space) {
	    switch (syntax) {
		case hex_ignore_whitespace:
		    goto x1;
		case hex_ignore_leading_whitespace:
		    if (q == q0 &amp;&amp; *odd_digit &lt; 0)
			goto x1;
		    --p;
		    code = 1;
		    goto end1;
		case hex_ignore_garbage:
		    goto x1;
	    }
	} else if (syntax == hex_ignore_garbage)
	    goto x1;
	code = ERRC;
	goto end1;
    }
  d2:if (p &gt;= rlimit) {
	*odd_digit = val1;
	goto ended;
    }
    if ((val2 = decoder[*++p]) &gt; 0xf) {
	if (val2 == ctype_space)
	    switch (syntax) {
		case hex_ignore_whitespace:
		    goto d2;
		case hex_ignore_leading_whitespace:
		    if (q == q0)
			goto d2;
		    --p;
		    *odd_digit = val1;
		    code = 1;
		    goto ended;
		case hex_ignore_garbage:	/* pacify compilers */
		    ;
	    }
	if (syntax == hex_ignore_garbage)
	    goto d2;
	*odd_digit = val1;
	code = ERRC;
	goto ended;
    }
    *++q = (val1 &lt;&lt; 4) + val2;
    if (q &lt; wlimit)
	goto d1;
  px:code = 1;
  end1:*odd_digit = -1;
  ended:pr-&gt;ptr = p;
    pw-&gt;ptr = q;
    return code;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

