<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/ttload.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/ttload.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2003 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: ttload.c,v 1.7 2005/08/02 11:12:32 igor Exp $ */

/* Changes after FreeType: cut out the TrueType instruction interpreter. */

/*******************************************************************
 *
 *  ttload.c                                                    1.0
 *
 *    TrueType Tables Loader.                          
 *
 *  Copyright 1996-1998 by
 *  David Turner, Robert Wilhelm, and Werner Lemberg.
 *
 *  This file is part of the FreeType project, and may only be used
 *  modified and distributed under the terms of the FreeType project
 *  license, LICENSE.TXT.  By continuing to use, modify, or distribute
 *  this file you indicate that you have read the license and
 *  understand and accept it fully.
 *
 ******************************************************************/

#include "ttmisc.h"

#include "ttfoutl.h"
#include "tttypes.h"
#include "ttcalc.h"
#include "ttobjs.h"
#include "ttload.h"
#include "ttfinp.h"

#ifdef DEBUG
#  define DebugTrace( font, fmt )  (void)(!font-&gt;DebugPrint ? 0 : font-&gt;DebugPrint(font, fmt))
#  define DebugTrace1( font, fmt, x)  (void)(!font-&gt;DebugPrint ? 0 : font-&gt;DebugPrint(font, fmt, x))
#else
#  define DebugTrace( font, fmt )
#  define DebugTrace1( font, fmt, x)
#endif

/*******************************************************************
 *
 *  Function    :  Load_TrueType_MaxProfile
 *
 *  Description :  Loads the maxp table into face table.
 *
 *  Input  :  face     face table to look for
 *
 *  Output :  Error code.
 *
 ******************************************************************/

  TT_Error  Load_TrueType_MaxProfile( PFace  face )
  {
    ttfReader *r = face-&gt;r;
    ttfFont *font = face-&gt;font;
    PMaxProfile  maxProfile = &amp;face-&gt;maxProfile;

    r-&gt;Seek(r, font-&gt;t_maxp.nPos);

    DebugTrace(font, "MaxProfile " );

    /* read frame data into face table */
    maxProfile-&gt;version               = GET_ULong();

    maxProfile-&gt;numGlyphs             = GET_UShort();

    maxProfile-&gt;maxPoints             = GET_UShort();
    maxProfile-&gt;maxContours           = GET_UShort();
    maxProfile-&gt;maxCompositePoints    = GET_UShort();
    maxProfile-&gt;maxCompositeContours  = GET_UShort();

    maxProfile-&gt;maxZones              = GET_UShort();
    maxProfile-&gt;maxTwilightPoints     = GET_UShort();

    maxProfile-&gt;maxStorage            = GET_UShort();
    maxProfile-&gt;maxFunctionDefs       = GET_UShort();
    maxProfile-&gt;maxInstructionDefs    = GET_UShort();
    maxProfile-&gt;maxStackElements      = GET_UShort();
    maxProfile-&gt;maxSizeOfInstructions = GET_UShort();
    maxProfile-&gt;maxComponentElements  = GET_UShort();
    maxProfile-&gt;maxComponentDepth     = GET_UShort();

    face-&gt;numGlyphs     = maxProfile-&gt;numGlyphs;

    face-&gt;maxPoints     = MAX( maxProfile-&gt;maxCompositePoints, 
                               maxProfile-&gt;maxPoints );
    face-&gt;maxContours   = MAX( maxProfile-&gt;maxCompositeContours,
                               maxProfile-&gt;maxContours );
    face-&gt;maxComponents = maxProfile-&gt;maxComponentElements +
                          maxProfile-&gt;maxComponentDepth;

    DebugTrace(font, "loaded\n");
  
    return TT_Err_Ok;
  }

/*******************************************************************
 *
 *  Function    :  Load_TrueType_CVT
 *
 *  Description :  Loads cvt table into resident table.
 *
 *  Input  :  face     face table to look for
 *
 *  Output :  Error code.
 *
 ******************************************************************/

  TT_Error  Load_TrueType_CVT( PFace  face )
  {
    long  n;
    Int  limit;

    ttfReader *r = face-&gt;r;
    ttfFont *font = face-&gt;font;
    ttfMemory *mem = font-&gt;tti-&gt;ttf_memory;
    r-&gt;Seek(r, font-&gt;t_cvt_.nPos);


    face-&gt;cvt=NULL;

    DebugTrace(font, "CVT ");

    face-&gt;cvtSize = font-&gt;t_cvt_.nLen / 2;

#   if 0
    if(face-&gt;cvtSize &lt; 300)
      face-&gt;cvtSize = 300; /* Work around DynaLab bug in DingBat1. */
#   endif

    if(face-&gt;cvtSize &gt; 0) {  /* allow fonts with a CVT table */
	face-&gt;cvt = mem-&gt;alloc_bytes(mem, face-&gt;cvtSize * sizeof(Short), "Load_TrueType_CVT");
	if (!face-&gt;cvt)
	    return TT_Err_Out_Of_Memory;
    }


    limit = face-&gt;cvtSize;

    for ( n = 0; n &lt; limit &amp;&amp; !r-&gt;Eof(r); n++ )
      face-&gt;cvt[n] = GET_Short();

    DebugTrace(font, "loaded\n");

    return TT_Err_Ok;
  }


/*******************************************************************
 *
 *  Function    :  Load_TrueType_Programs
 *
 *  Description :  Loads the font (fpgm) and cvt programs into the
 *                 face table.
 *
 *  Input  :  face
 *
 *  Output :  Error code.
 *
 ******************************************************************/

  TT_Error  Load_TrueType_Programs( PFace  face )
  {
    ttfReader *r = face-&gt;r;
    ttfFont *font = face-&gt;font;
    ttfMemory *mem = font-&gt;tti-&gt;ttf_memory;

    face-&gt;fontProgram = NULL;
    face-&gt;cvtProgram = NULL;


    DebugTrace(font, "Font program ");

    /* The font program is optional */
    if(!font-&gt;t_fpgm.nPos)
    {
      face-&gt;fontProgram = (Byte*)NULL;
      face-&gt;fontPgmSize = 0;

      DebugTrace(font, "is absent.\n");
    }
    else
    {
      face-&gt;fontPgmSize = font-&gt;t_fpgm.nLen;
      r-&gt;Seek(r, font-&gt;t_fpgm.nPos);
      face-&gt;fontProgram = mem-&gt;alloc_bytes(mem, face-&gt;fontPgmSize, "Load_TrueType_Programs");

      if (!face-&gt;fontProgram)
        return TT_Err_Out_Of_Memory;
      r-&gt;Read(r, face-&gt;fontProgram,face-&gt;fontPgmSize );
      DebugTrace1(font, "loaded, %12d bytes\n", face-&gt;fontPgmSize);
    }

    DebugTrace(font, "Prep program ");

    if (!font-&gt;t_prep.nPos)
    {
      face-&gt;cvtProgram = (Byte*)NULL;
      face-&gt;cvtPgmSize = 0;

      DebugTrace(font, "is missing!\n");
    }
    else
    { face-&gt;cvtPgmSize=font-&gt;t_prep.nLen;
      r-&gt;Seek(r, font-&gt;t_prep.nPos);
      face-&gt;cvtProgram = mem-&gt;alloc_bytes(mem, face-&gt;cvtPgmSize, "Load_TrueType_Programs");
      if (!face-&gt;cvtProgram)
        return TT_Err_Out_Of_Memory;
      r-&gt;Read(r, face-&gt;cvtProgram,face-&gt;cvtPgmSize );
      DebugTrace1(font, "loaded, %12d bytes\n", face-&gt;cvtPgmSize );
    }

    return TT_Err_Ok;
  }



<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

