<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/ttobjs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/ttobjs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 2003 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: ttobjs.c,v 1.9 2004/12/21 20:13:41 igor Exp $ */

/* Changes after FreeType: cut out the TrueType instruction interpreter. */

/*******************************************************************
 *
 *  ttobjs.c                                                     1.0
 *
 *    Objects manager.        
 *
 *  Copyright 1996-1998 by
 *  David Turner, Robert Wilhelm, and Werner Lemberg.
 *
 *  This file is part of the FreeType project, and may only be used
 *  modified and distributed under the terms of the FreeType project
 *  license, LICENSE.TXT.  By continuing to use, modify, or distribute
 *  this file you indicate that you have read the license and
 *  understand and accept it fully.
 *
 ******************************************************************/

#include "ttmisc.h"

#include "ttfoutl.h"
#include "ttobjs.h"
#include "ttcalc.h"
#include "ttload.h"
#include "ttinterp.h"

/* Add extensions definition */
#ifdef TT_EXTEND_ENGINE
#endif



/*******************************************************************
 *                                                                 *
 *                     CODERANGE FUNCTIONS                         *
 *                                                                 *
 *                                                                 *
 *******************************************************************/

/*******************************************************************
 *
 *  Function    :  Goto_CodeRange
 *
 *  Description :  Switch to a new code range (updates Code and IP).
 *
 *  Input  :  exec    target execution context
 *            range   new execution code range       
 *            IP      new IP in new code range       
 *
 *  Output :  SUCCESS on success.  FAILURE on error (no code range).
 *
 *****************************************************************/

  TT_Error  Goto_CodeRange( PExecution_Context  exec, Int  range, Int  IP )
  {
    PCodeRange  cr;


    if ( range &lt; 1 || range &gt; 3 )
      return TT_Err_Bad_Argument;

    cr = &amp;exec-&gt;codeRangeTable[range - 1];

    if ( cr-&gt;Base == NULL )
      return TT_Err_Invalid_CodeRange;

    /* NOTE:  Because the last instruction of a program may be a CALL */
    /*        which will return to the first byte *after* the code    */
    /*        range, we test for IP &lt;= Size, instead of IP &lt; Size.    */

    if ( IP &gt; cr-&gt;Size )
      return TT_Err_Code_Overflow;

    exec-&gt;code     = cr-&gt;Base;
    exec-&gt;codeSize = cr-&gt;Size;
    exec-&gt;IP       = IP;
    exec-&gt;curRange = range;

    return TT_Err_Ok;
  }

/*******************************************************************
 *
 *  Function    :  Unset_CodeRange
 *
 *  Description :  Unsets the code range pointer.
 *
 *  Input  :  exec    target execution context
 *
 *  Output :  
 *
 *  Note   : The pointer must be unset after used to avoid pending pointers
 *           while a garbager invokation.
 *
 *****************************************************************/

  void  Unset_CodeRange( PExecution_Context  exec )
  {
    exec-&gt;code = 0;
    exec-&gt;codeSize = 0;
  }
  
/*******************************************************************
 *
 *  Function    :  Get_CodeRange
 *
 *  Description :  Returns a pointer to a given code range.  Should
 *                 be used only by the debugger.  Returns NULL if
 *                 'range' is out of current bounds.
 *
 *  Input  :  exec    target execution context
 *            range   new execution code range       
 *
 *  Output :  Pointer to the code range record.  NULL on failure.
 *
 *****************************************************************/

  PCodeRange  Get_CodeRange( PExecution_Context  exec, Int  range )
  {
    if ( range &lt; 1 || range &gt; 3 )
      return (PCodeRange)NULL;
    else                /* arrays start with 1 in Pascal, and with 0 in C */
      return &amp;exec-&gt;codeRangeTable[range - 1];
  }


/*******************************************************************
 *
 *  Function    :  Set_CodeRange
 *
 *  Description :  Sets a code range.
 *
 *  Input  :  exec    target execution context
 *            range   code range index
 *            base    new code base
 *            length  sange size in bytes
 *
 *  Output :  SUCCESS on success.  FAILURE on error.
 *
 *****************************************************************/

  TT_Error  Set_CodeRange( PExecution_Context  exec,
                           Int                 range,
                           void*               base,
                           Int                 length )
  {
    if ( range &lt; 1 || range &gt; 3 )
      return TT_Err_Bad_Argument;

    exec-&gt;codeRangeTable[range - 1].Base = (unsigned char*)base;
    exec-&gt;codeRangeTable[range - 1].Size = length;

    return TT_Err_Ok;
  }


/*******************************************************************
 *
 *  Function    :  Clear_CodeRange
 *
 *  Description :  Clears a code range.
 *
 *  Input  :  exec    target execution context
 *            range   code range index
 *
 *  Output :  SUCCESS on success.  FAILURE on error.
 *
 *  Note   : Does not set the Error variable.
 *
 *****************************************************************/

  TT_Error Clear_CodeRange( PExecution_Context  exec, Int  range )
  {
    if ( range &lt; 1 || range &gt; 3 )
      return TT_Err_Bad_Argument;

    exec-&gt;codeRangeTable[range - 1].Base = (Byte*)NULL;
    exec-&gt;codeRangeTable[range - 1].Size = 0;

    return TT_Err_Ok;
  }



/*******************************************************************
 *                                                                 *
 *                EXECUTION CONTEXT ROUTINES                       *
 *                                                                 *
 *                                                                 *
 *******************************************************************/


#define FREE(ptr) { mem-&gt;free(mem, ptr, "ttobjs.c"); ptr = NULL; }
#define ALLOC_ARRAY(ptr, old_count, count, type) \
	(old_count &gt;= count ? 0 : \
	  !(free_aux(mem, ptr),   \
	    ptr = mem-&gt;alloc_bytes(mem, (count) * sizeof(type), "ttobjs.c"))) 
#define SETMAX(a, b) a = (a &gt; b ? a : b)

static int free_aux(ttfMemory *mem, void *ptr)
{
    mem-&gt;free(mem, ptr, "ttobjs.c");
    return 0;
}

/*******************************************************************
 *
 *  Function    :  Context_Destroy
 *
 *****************************************************************/

 TT_Error  Context_Destroy( void*  _context )
 {
   PExecution_Context  exec = (PExecution_Context)_context;
   ttfMemory *mem;

   if ( !exec )
     return TT_Err_Ok;
   if ( !exec-&gt;current_face ) {
     /* This may happen while closing a high level device, when allocator runs out of memory. 
        A test case is 01_001.pdf with pdfwrite and a small vmthreshold.
     */
     return TT_Err_Out_Of_Memory;
   }
   if (--exec-&gt;lock)
     return TT_Err_Ok; /* Still in use */

   mem = exec-&gt;current_face-&gt;font-&gt;tti-&gt;ttf_memory;

   /* points zone */
   FREE( exec-&gt;pts.cur_y );
   FREE( exec-&gt;pts.cur_x );
   FREE( exec-&gt;pts.org_y );
   FREE( exec-&gt;pts.org_x );
   FREE( exec-&gt;pts.touch );
   FREE( exec-&gt;pts.contours );
   exec-&gt;pts.n_points   = 0;
   exec-&gt;pts.n_contours = 0;

   /* twilight zone */
   FREE( exec-&gt;twilight.touch );
   FREE( exec-&gt;twilight.cur_y );
   FREE( exec-&gt;twilight.cur_x );
   FREE( exec-&gt;twilight.org_y );
   FREE( exec-&gt;twilight.org_x );
   FREE( exec-&gt;twilight.contours );
   exec-&gt;twilight.n_points   = 0;
   exec-&gt;twilight.n_contours = 0;

   /* free stack */
   FREE( exec-&gt;stack );
   exec-&gt;stackSize = 0;

   /* free call stack */
   FREE( exec-&gt;callStack );
   exec-&gt;callSize = 0;
   exec-&gt;callTop  = 0;

   /* free glyph code range */
   exec-&gt;glyphSize = 0;
   exec-&gt;maxGlyphSize = 0;

   exec-&gt;current_face    = (PFace)NULL;

   return TT_Err_Ok;
 }

/*******************************************************************
 *
 *  Function    :  Context_Create
 *
 *****************************************************************/

 TT_Error  Context_Create( void*  _context, void*  _face )
 {
   /* Note : The function name is a kind of misleading due to our improvement.
    * Now it adjusts (enhances) the context for the specified face.
    * We keep the old Free Type's name for easier localization of our changes.
    * The context must be initialized with zeros before the first call.
    * (igorm).
    */
   PExecution_Context  exec = (PExecution_Context)_context;

   PFace        face = (PFace)_face;
   ttfMemory   *mem = face-&gt;font-&gt;tti-&gt;ttf_memory;
   TMaxProfile *maxp = &amp;face-&gt;maxProfile;
   Int          n_points, n_twilight;
   Int          callSize, stackSize;

   callSize  = 32;

   /* reserve a little extra for broken fonts like courbs or timesbs */
   stackSize = maxp-&gt;maxStackElements + 32;

   n_points        = face-&gt;maxPoints + 2;
   n_twilight      = maxp-&gt;maxTwilightPoints;

   if ( ALLOC_ARRAY( exec-&gt;callStack, exec-&gt;callSize, callSize, TCallRecord ) ||
        /* reserve interpreter call stack */

        ALLOC_ARRAY( exec-&gt;stack, exec-&gt;stackSize, stackSize, Long )           ||
        /* reserve interpreter stack */

        ALLOC_ARRAY( exec-&gt;pts.org_x, exec-&gt;n_points, n_points, TT_F26Dot6 )        ||
        ALLOC_ARRAY( exec-&gt;pts.org_y, exec-&gt;n_points, n_points, TT_F26Dot6 )        ||
        ALLOC_ARRAY( exec-&gt;pts.cur_x, exec-&gt;n_points, n_points, TT_F26Dot6 )        ||
        ALLOC_ARRAY( exec-&gt;pts.cur_y, exec-&gt;n_points, n_points, TT_F26Dot6 )        ||
        ALLOC_ARRAY( exec-&gt;pts.touch, exec-&gt;n_points, n_points, Byte )                          ||
        /* reserve points zone */

        ALLOC_ARRAY( exec-&gt;twilight.org_x, exec-&gt;twilight.n_points, n_twilight, TT_F26Dot6 ) ||
        ALLOC_ARRAY( exec-&gt;twilight.org_y, exec-&gt;twilight.n_points, n_twilight, TT_F26Dot6 ) ||
        ALLOC_ARRAY( exec-&gt;twilight.cur_x, exec-&gt;twilight.n_points, n_twilight, TT_F26Dot6 ) ||
        ALLOC_ARRAY( exec-&gt;twilight.cur_y, exec-&gt;twilight.n_points, n_twilight, TT_F26Dot6 ) ||
        ALLOC_ARRAY( exec-&gt;twilight.touch, exec-&gt;twilight.n_points, n_twilight, Byte )                   ||
        /* reserve twilight zone */

        ALLOC_ARRAY( exec-&gt;pts.contours, exec-&gt;n_contours, face-&gt;maxContours, UShort ) 
        /* reserve contours array */
      )
     goto Fail_Memory;

     SETMAX(exec-&gt;callSize, callSize);
     SETMAX(exec-&gt;stackSize, stackSize);
     SETMAX(exec-&gt;twilight.n_points, n_twilight);
     SETMAX(exec-&gt;maxGlyphSize, maxp-&gt;maxSizeOfInstructions);
     SETMAX(exec-&gt;n_contours, face-&gt;maxContours);
     SETMAX(exec-&gt;n_points, n_points);
     exec-&gt;lock++;

     return TT_Err_Ok;

  Fail_Memory:
    /* Context_Destroy( exec ); Don't release buffers because the context is shared. */
    return TT_Err_Out_Of_Memory;
 }


/*******************************************************************
 *
 *  Function    :  Context_Load
 *
 *****************************************************************/

 TT_Error Context_Load( PExecution_Context  exec,
                        PInstance           ins )
 {
   Int  i;


   exec-&gt;current_face = ins-&gt;face;

   exec-&gt;numFDefs = ins-&gt;numFDefs;
   exec-&gt;numIDefs = ins-&gt;numIDefs;
   exec-&gt;FDefs    = ins-&gt;FDefs;
   exec-&gt;IDefs    = ins-&gt;IDefs;
   exec-&gt;countIDefs = ins-&gt;countIDefs;
   memcpy(exec-&gt;IDefPtr, ins-&gt;IDefPtr, sizeof(exec-&gt;IDefPtr));

   exec-&gt;metrics  = ins-&gt;metrics;

   for ( i = 0; i &lt; MAX_CODE_RANGES; i++ )
     exec-&gt;codeRangeTable[i] = ins-&gt;codeRangeTable[i];

   exec-&gt;pts.n_points   = 0;
   exec-&gt;pts.n_contours = 0;

   exec-&gt;instruction_trap = FALSE;

   /* set default graphics state */
   exec-&gt;GS = ins-&gt;GS;

   exec-&gt;cvtSize = ins-&gt;cvtSize;
   exec-&gt;cvt     = ins-&gt;cvt;

   exec-&gt;storeSize = ins-&gt;storeSize;
   exec-&gt;storage   = ins-&gt;storage;

   return TT_Err_Ok;
 }


/*******************************************************************
 *
 *  Function    :  Context_Save
 *
 *****************************************************************/

 TT_Error  Context_Save( PExecution_Context  exec,
                         PInstance           ins )
 {
   Int  i;

   for ( i = 0; i &lt; MAX_CODE_RANGES; i++ ) {
     ins-&gt;codeRangeTable[i] = exec-&gt;codeRangeTable[i];
     exec-&gt;codeRangeTable[i].Base = 0;
     exec-&gt;codeRangeTable[i].Size = 0;
   }
   exec-&gt;numFDefs = 0;
   exec-&gt;numIDefs = 0;
   memcpy(ins-&gt;IDefPtr, exec-&gt;IDefPtr, sizeof(ins-&gt;IDefPtr));
   ins-&gt;countIDefs = exec-&gt;countIDefs;
   exec-&gt;countIDefs = 0;
   exec-&gt;FDefs    = 0;
   exec-&gt;IDefs    = 0;
   exec-&gt;cvtSize = 0;
   exec-&gt;cvt     = 0;
   exec-&gt;storeSize = 0;
   exec-&gt;storage   = 0;
   exec-&gt;current_face = 0;

   return TT_Err_Ok;
 }


/*******************************************************************
 *
 *  Function    :  Context_Run
 *
 *****************************************************************/

 TT_Error  Context_Run( PExecution_Context  exec,
                        Bool                debug )
 {
   TT_Error  error;


   if ( ( error = Goto_CodeRange( exec, TT_CodeRange_Glyph, 0 ) ) )
     return error;

   exec-&gt;zp0 = exec-&gt;pts;
   exec-&gt;zp1 = exec-&gt;pts;
   exec-&gt;zp2 = exec-&gt;pts;

   exec-&gt;GS.gep0 = 1;
   exec-&gt;GS.gep1 = 1;
   exec-&gt;GS.gep2 = 1;

   exec-&gt;GS.projVector.x = 0x4000;
   exec-&gt;GS.projVector.y = 0x0000;

   exec-&gt;GS.freeVector = exec-&gt;GS.projVector;
   exec-&gt;GS.dualVector = exec-&gt;GS.projVector;

   exec-&gt;GS.round_state = 1;
   exec-&gt;GS.loop        = 1;

   /* some glyphs leave something on the stack. so we clean it */
   /* before a new execution.                                  */
   exec-&gt;top     = 0;
   exec-&gt;callTop = 0;

   if ( !debug ) {
     error = RunIns( exec );
     Unset_CodeRange(exec);    
     return error;
   } else
     return TT_Err_Ok;
 }


  const TGraphicsState  Default_GraphicsState =
  {
    0, 0, 0, 
    { 0x4000, 0 },
    { 0x4000, 0 },
    { 0x4000, 0 },
    1, 64, 1,
    TRUE, 68, 0, 0, 9, 3,
    0, FALSE, 2, 1, 1, 1
  };



/*******************************************************************
 *                                                                 *
 *                     INSTANCE  FUNCTIONS                         *
 *                                                                 *
 *                                                                 *
 *******************************************************************/

/*******************************************************************
 *
 *  Function    : Instance_Destroy
 *
 *  Description :
 *
 *  Input  :  _instance   the instance object to destroy
 *
 *  Output :  error code.
 *
 ******************************************************************/

  TT_Error  Instance_Destroy( void* _instance )
  {
    PInstance  ins = (PInstance)_instance;
    ttfMemory *mem;

    if ( !_instance )
      return TT_Err_Ok;
    if ( !ins-&gt;face ) {
      /* This may happen while closing a high level device, when allocator runs out of memory. 
         A test case is 01_001.pdf with pdfwrite and a small vmthreshold.
      */
      return TT_Err_Out_Of_Memory;
    }
    mem = ins-&gt;face-&gt;font-&gt;tti-&gt;ttf_memory;

    FREE( ins-&gt;cvt );
    ins-&gt;cvtSize = 0;

    FREE( ins-&gt;FDefs );
    FREE( ins-&gt;IDefs );
    FREE( ins-&gt;storage );
    ins-&gt;numFDefs = 0;
    ins-&gt;numIDefs = 0;

    ins-&gt;face = (PFace)NULL;
    ins-&gt;valid = FALSE;

    return TT_Err_Ok;
  }


/*******************************************************************
 *
 *  Function    : Instance_Create
 *
 *  Description :
 *
 *  Input  :  _instance    instance record to initialize
 *            _face        parent face object
 *
 *  Output :  Error code.  All partially built subtables are
 *            released on error.
 *
 ******************************************************************/

  TT_Error  Instance_Create( void*  _instance,
                             void*  _face )
  {
    PInstance ins  = (PInstance)_instance;
    PFace     face = (PFace)_face;
    ttfMemory *mem = face-&gt;font-&gt;tti-&gt;ttf_memory;
    PMaxProfile  maxp = &amp;face-&gt;maxProfile;
    Int       i;

    ins-&gt;FDefs=NULL;
    ins-&gt;IDefs=NULL;
    ins-&gt;cvt=NULL;
    ins-&gt;storage=NULL;

    ins-&gt;face = face;
    ins-&gt;valid = FALSE;

    ins-&gt;numFDefs = maxp-&gt;maxFunctionDefs;
    ins-&gt;numIDefs = maxp-&gt;maxInstructionDefs;
    ins-&gt;countIDefs = 0;
    if (maxp-&gt;maxInstructionDefs &gt; 255)
	goto Fail_Memory;
    memset(ins-&gt;IDefPtr, (Byte)ins-&gt;numIDefs, sizeof(ins-&gt;IDefPtr));
    if (ins-&gt;numFDefs &lt; 50)
	ins-&gt;numFDefs = 50; /* Bug 687858 */
    ins-&gt;cvtSize  = face-&gt;cvtSize;

    ins-&gt;metrics.pointSize    = 10 * 64;     /* default pointsize  = 10pts */

    ins-&gt;metrics.x_resolution = 96;          /* default resolution = 96dpi */
    ins-&gt;metrics.y_resolution = 96;

    ins-&gt;metrics.x_ppem = 0;
    ins-&gt;metrics.y_ppem = 0;

    ins-&gt;metrics.rotated   = FALSE;
    ins-&gt;metrics.stretched = FALSE;

    ins-&gt;storeSize = maxp-&gt;maxStorage;

    for ( i = 0; i &lt; 4; i++ )
      ins-&gt;metrics.compensations[i] = 0;     /* Default compensations */

    if ( ALLOC_ARRAY( ins-&gt;FDefs, 0, ins-&gt;numFDefs, TDefRecord )  ||
         ALLOC_ARRAY( ins-&gt;IDefs, 0, ins-&gt;numIDefs, TDefRecord )  ||
         ALLOC_ARRAY( ins-&gt;cvt, 0, ins-&gt;cvtSize, Long )           ||
         ALLOC_ARRAY( ins-&gt;storage, 0, ins-&gt;storeSize, Long )     )
      goto Fail_Memory;

    memset (ins-&gt;FDefs, 0, ins-&gt;numFDefs * sizeof(TDefRecord));
    memset (ins-&gt;IDefs, 0, ins-&gt;numIDefs * sizeof(TDefRecord));

    ins-&gt;GS = Default_GraphicsState;

    return TT_Err_Ok;

  Fail_Memory:
    Instance_Destroy( ins );
    return TT_Err_Out_Of_Memory;
  }

/*******************************************************************
 *
 *  Function    : Instance_Init
 *
 *  Description : Initialize a fresh new instance.
 *                Executes the font program if any is found.
 *
 *  Input  :  _instance   the instance object to destroy
 *
 *  Output :  Error code.
 *
 ******************************************************************/

  TT_Error  Instance_Init( PInstance  ins )
  {
    PExecution_Context  exec;

    TT_Error  error;
    PFace     face = ins-&gt;face;

    exec = ins-&gt;face-&gt;font-&gt;exec;
    /* debugging instances have their own context */

    ins-&gt;GS = Default_GraphicsState;

    Context_Load( exec, ins );

    exec-&gt;callTop   = 0;
    exec-&gt;top       = 0;

    exec-&gt;period    = 64;
    exec-&gt;phase     = 0;
    exec-&gt;threshold = 0;

    exec-&gt;metrics.x_ppem    = 0;
    exec-&gt;metrics.y_ppem    = 0;
    exec-&gt;metrics.pointSize = 0;
    exec-&gt;metrics.x_scale1  = 0;
    exec-&gt;metrics.x_scale2  = 1;
    exec-&gt;metrics.y_scale1  = 0;
    exec-&gt;metrics.y_scale2  = 1;

    exec-&gt;metrics.ppem      = 0;
    exec-&gt;metrics.scale1    = 0;
    exec-&gt;metrics.scale2    = 1;
    exec-&gt;metrics.ratio     = 1 &lt;&lt; 16;

    exec-&gt;instruction_trap = FALSE;

    exec-&gt;cvtSize = ins-&gt;cvtSize;
    exec-&gt;cvt     = ins-&gt;cvt;

    exec-&gt;F_dot_P = 0x10000;

    /* allow font program execution */
    Set_CodeRange( exec,
                   TT_CodeRange_Font,
                   face-&gt;fontProgram,
                   face-&gt;fontPgmSize );

    /* disable CVT and glyph programs coderange */
    Clear_CodeRange( exec, TT_CodeRange_Cvt );
    Clear_CodeRange( exec, TT_CodeRange_Glyph );

    if ( face-&gt;fontPgmSize &gt; 0 )
    {
      error = Goto_CodeRange( exec, TT_CodeRange_Font, 0 );
      if ( error )
        goto Fin;

      error = RunIns( exec );
      Unset_CodeRange(exec);    
    }
    else
      error = TT_Err_Ok;

  Fin:
    Context_Save( exec, ins );

    ins-&gt;valid = FALSE;

    return error;
  }


/*******************************************************************
 *
 *  Function    : Instance_Reset
 *
 *  Description : Resets an instance to a new pointsize/transform.
 *                Executes the cvt program if any is found.
 *
 *  Input  :  _instance   the instance object to destroy
 *
 *  Output :  Error code.
 *
 ******************************************************************/

  TT_Error  Instance_Reset( PInstance  ins,
                            Bool       debug )
  {
    TT_Error  error;
    Int       i;
    PFace     face = ins-&gt;face;
    PExecution_Context exec = ins-&gt;face-&gt;font-&gt;exec;

    if ( !ins )
      return TT_Err_Invalid_Instance_Handle;

    if ( ins-&gt;valid )
      return TT_Err_Ok;

    if ( ins-&gt;metrics.x_ppem &lt; 1 ||
         ins-&gt;metrics.y_ppem &lt; 1 )
      return TT_Err_Invalid_PPem;

    /* compute new transformation */
    if ( ins-&gt;metrics.x_ppem &gt;= ins-&gt;metrics.y_ppem )
    {
      ins-&gt;metrics.scale1  = ins-&gt;metrics.x_scale1;
      ins-&gt;metrics.scale2  = ins-&gt;metrics.x_scale2;
      ins-&gt;metrics.ppem    = ins-&gt;metrics.x_ppem;
      ins-&gt;metrics.x_ratio = 1 &lt;&lt; 16;
      ins-&gt;metrics.y_ratio = MulDiv_Round( ins-&gt;metrics.y_ppem,
                                           0x10000,
                                           ins-&gt;metrics.x_ppem );
    }
    else
    {
      ins-&gt;metrics.scale1  = ins-&gt;metrics.y_scale1;
      ins-&gt;metrics.scale2  = ins-&gt;metrics.y_scale2;
      ins-&gt;metrics.ppem    = ins-&gt;metrics.y_ppem;
      ins-&gt;metrics.x_ratio = MulDiv_Round( ins-&gt;metrics.x_ppem,
                                           0x10000,
                                           ins-&gt;metrics.y_ppem );
      ins-&gt;metrics.y_ratio = 1 &lt;&lt; 16;
    }

    /* Scale the cvt values to the new ppem.          */
    /* We use by default the y ppem to scale the CVT. */

    for ( i = 0; i &lt; ins-&gt;cvtSize; i++ )
      ins-&gt;cvt[i] = MulDiv_Round( face-&gt;cvt[i],
                                  ins-&gt;metrics.scale1,
                                  ins-&gt;metrics.scale2 );

    ins-&gt;GS = Default_GraphicsState;

    /* get execution context and run prep program */

    Context_Load( exec, ins );

    Set_CodeRange( exec,
                   TT_CodeRange_Cvt,
                   face-&gt;cvtProgram,
                   face-&gt;cvtPgmSize );

    Clear_CodeRange( exec, TT_CodeRange_Glyph );

    for ( i = 0; i &lt; exec-&gt;storeSize; i++ )
      exec-&gt;storage[i] = 0;

    exec-&gt;instruction_trap = FALSE;

    exec-&gt;top     = 0;
    exec-&gt;callTop = 0;

    /* All twilight points are originally zero */

    for ( i = 0; i &lt; exec-&gt;twilight.n_points; i++ )
    {
      exec-&gt;twilight.org_x[i] = 0;
      exec-&gt;twilight.org_y[i] = 0;
      exec-&gt;twilight.cur_x[i] = 0;
      exec-&gt;twilight.cur_y[i] = 0;
    }

    if ( face-&gt;cvtPgmSize &gt; 0 )
    {
      error = Goto_CodeRange( exec, TT_CodeRange_Cvt, 0 );
      if (error)
        goto Fin;

      error = RunIns( exec );
      Unset_CodeRange(exec);    
    }
    else
      error = TT_Err_Ok;

    ins-&gt;GS = exec-&gt;GS;
    /* save default graphics state */

  Fin:
    Context_Save( exec, ins );

    if ( !error )
      ins-&gt;valid = TRUE;

    return error;
  }


/*******************************************************************
 *                                                                 *
 *                         FACE  FUNCTIONS                         *
 *                                                                 *
 *                                                                 *
 *******************************************************************/

/*******************************************************************
 *
 *  Function    :  Face_Destroy
 *
 *  Description :  The face object destructor.
 *
 *  Input  :  _face   typeless pointer to the face object to destroy
 *
 *  Output :  Error code.                       
 *
 ******************************************************************/

  TT_Error  Face_Destroy( PFace face )
  {
    ttfMemory *mem = face-&gt;font-&gt;tti-&gt;ttf_memory;
    if ( !face )
      return TT_Err_Ok;

    /* freeing the CVT */
    FREE( face-&gt;cvt );
    face-&gt;cvtSize = 0;

    /* freeing the programs */
    FREE( face-&gt;fontProgram );
    FREE( face-&gt;cvtProgram );
    face-&gt;fontPgmSize = 0;
    face-&gt;cvtPgmSize  = 0;

    return TT_Err_Ok;
  }


/*******************************************************************
 *
 *  Function    :  Face_Create
 *
 *  Description :  The face object constructor.
 *
 *  Input  :  _face    face record to build
 *            _input   input stream where to load font data
 *
 *  Output :  Error code.
 *
 *  NOTE : The input stream is kept in the face object.  The
 *         caller shouldn't destroy it after calling Face_Create().
 *
 ******************************************************************/

#define LOAD_( table ) \
          ( error = Load_TrueType_##table (face) )


  TT_Error  Face_Create( PFace  face)
  {
    TT_Error      error;

    /* Load tables */

    if ( /*LOAD_(Header)                      ||*/
         LOAD_(MaxProfile)                  ||
         /*LOAD_(Locations)                   ||*/
         /*LOAD_(CMap)                        ||*/
         LOAD_(CVT)                         ||
         /*LOAD_(Horizontal_Header)           ||*/
         LOAD_(Programs)                    
         /*LOAD_(HMTX)                        ||*/
         /*LOAD_(Gasp)                        ||*/
         /*LOAD_(Names)                       ||*/
         /*LOAD_(OS2)                         ||*/
         /*LOAD_(PostScript)                  ||*/
         /*LOAD_(Hdmx)                        */
        )
      goto Fail;

    return TT_Err_Ok;

  Fail :
    Face_Destroy( face );
    return error;
  }




/*******************************************************************
 *
 *  Function    :  Scale_X
 *
 *  Description :  scale an horizontal distance from font
 *                 units to 26.6 pixels
 *
 *  Input  :  metrics  pointer to metrics
 *            x        value to scale
 *
 *  Output :  scaled value
 *
 ******************************************************************/

 TT_Pos  Scale_X( PIns_Metrics  metrics, TT_Pos  x )
 {
   return MulDiv_Round( x, metrics-&gt;x_scale1, metrics-&gt;x_scale2 );
 }

/*******************************************************************
 *
 *  Function    :  Scale_Y
 *
 *  Description :  scale a vertical distance from font
 *                 units to 26.6 pixels
 *
 *  Input  :  metrics  pointer to metrics
 *            y        value to scale
 *
 *  Output :  scaled value
 *
 ******************************************************************/

 TT_Pos  Scale_Y( PIns_Metrics  metrics, TT_Pos  y )
 {
   return MulDiv_Round( y, metrics-&gt;y_scale1, metrics-&gt;y_scale2 );
 }

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

