<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zbfont.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zbfont.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1996, 1997, 1998, 1999, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zbfont.c,v 1.30 2005/07/27 11:24:38 igor Exp $ */
/* Font creation utilities */
#include "memory_.h"
#include "string_.h"
#include "ghost.h"
#include "oper.h"
#include "gxfixed.h"
#include "gscencs.h"
#include "gsmatrix.h"
#include "gxdevice.h"
#include "gxfont.h"
#include "bfont.h"
#include "ialloc.h"
#include "idict.h"
#include "idparam.h"
#include "ilevel.h"
#include "iname.h"
#include "inamedef.h"		/* for inlining name_index */
#include "interp.h"		/* for initial_enter_name */
#include "ipacked.h"
#include "istruct.h"
#include "store.h"

/* Structure descriptor */
public_st_font_data();

/* &lt;string|name&gt; &lt;font_dict&gt; .buildfont3 &lt;string|name&gt; &lt;font&gt; */
/* Build a type 3 (user-defined) font. */
private int
zbuildfont3(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    build_proc_refs build;
    gs_font_base *pfont;

    check_type(*op, t_dictionary);
    code = build_gs_font_procs(op, &amp;build);
    if (code &lt; 0)
	return code;
    code = build_gs_simple_font(i_ctx_p, op, &amp;pfont, ft_user_defined,
				&amp;st_gs_font_base, &amp;build, bf_options_none);
    if (code &lt; 0)
	return code;
    return define_gs_font((gs_font *) pfont);
}

/* Encode a character. */
gs_glyph
zfont_encode_char(gs_font *pfont, gs_char chr, gs_glyph_space_t gspace)
{
    font_data *pdata = pfont_data(pfont);
    const ref *pencoding = &amp;pdata-&gt;Encoding;
    ulong index = chr;	/* work around VAX widening bug */
    ref cname;
    int code = array_get(pfont-&gt;memory, pencoding, (long)index, &amp;cname);

    if (code &lt; 0 || !r_has_type(&amp;cname, t_name))
	return gs_no_glyph;
    if (pfont-&gt;FontType == ft_user_defined &amp;&amp; r_type(&amp;pdata-&gt;BuildGlyph) == t_null) {
	ref nsref, tname;

	name_string_ref(pfont-&gt;memory, &amp;cname, &amp;nsref);
	if (r_size(&amp;nsref) == 7 &amp;&amp; 
	    !memcmp(nsref.value.const_bytes, ".notdef", r_size(&amp;nsref))) {
	    /* A special support for high level devices.
	       They need a glyph name but the font doesn't provide one
	       due to an instandard BuildChar.
	       Such fonts don't conform to PLRM section 5.3.7,
	       but we've got real examples that we want to handle (Bug 686982).
	       Construct a name here.
	       Low level devices don't pass here, because regular PS interpretation 
	       doesn't need such names.
	    */
	    char buf[20];
	    int code;

	    if (gspace == GLYPH_SPACE_NOGEN)
		return gs_no_glyph;    
	    sprintf(buf, "j%ld", chr); /* 'j' is arbutrary. */
	    code = name_ref(pfont-&gt;memory, (const byte *)buf, strlen(buf), &amp;tname, 1);
	    if (code &lt; 0) {
		/* Can't propagate the error due to interface limitation,
		   return with .notdef */
	    } else
		cname = tname;
	}
    }
    return (gs_glyph)name_index(pfont-&gt;memory, &amp;cname);
}

/* Get the name of a glyph. */
private int
zfont_glyph_name(gs_font *font, gs_glyph index, gs_const_string *pstr)
{
    ref nref, sref;

    if (index &gt;= gs_min_cid_glyph) {	/* Fabricate a numeric name. */
	char cid_name[sizeof(gs_glyph) * 3 + 1];
	int code;

	sprintf(cid_name, "%lu", (ulong) index);
	code = name_ref(font-&gt;memory, (const byte *)cid_name, strlen(cid_name),
			&amp;nref, 1);
	if (code &lt; 0)
	    return code;
    } else
	name_index_ref(font-&gt;memory, index, &amp;nref);
    name_string_ref(font-&gt;memory, &amp;nref, &amp;sref);
    pstr-&gt;data = sref.value.const_bytes;
    pstr-&gt;size = r_size(&amp;sref);
    return 0;
}

private gs_char 
gs_font_map_glyph_by_dict(const gs_memory_t *mem, const ref *map, gs_glyph glyph)
{
    ref *v, n;
    if (glyph &gt;= gs_min_cid_glyph) {
	uint cid = glyph - gs_min_cid_glyph;

	if (dict_find_string(map, "CIDCount", &amp;v) &gt; 0) {
	    /* This is a CIDDEcoding resource. */
	    make_int(&amp;n, cid / 256);
	    if (dict_find(map, &amp;n, &amp;v) &gt; 0) {
		ref vv;

		if (array_get(mem, v, cid % 256, &amp;vv) == 0 &amp;&amp; r_type(&amp;vv) == t_integer)
		    return vv.value.intval;
	    }
	    return GS_NO_CHAR; /* Absent in the map. */
	}
	/* This is GlyphNames2Unicode dictionary. */
	make_int(&amp;n, cid);
    } else
	name_index_ref(mem, glyph, &amp;n);
    if (dict_find(map, &amp;n, &amp;v) &gt; 0) {
	if (r_has_type(v, t_string)) {
	    int i, l = r_size(v);
	    gs_char c = 0;

	    for (i = 0; i &lt; l; i++)
		c = (c &lt;&lt; 8) | v-&gt;value.const_bytes[i];
	    return c;
	}
	if (r_type(v) == t_integer)
	    return v-&gt;value.intval;
    }
    return GS_NO_CHAR; /* Absent in the map. */
}

/* Get Unicode UTF-16 code for a glyph. */
gs_char 
gs_font_map_glyph_to_unicode(gs_font *font, gs_glyph glyph)
{
    font_data *pdata = pfont_data(font);
    const ref *UnicodeDecoding;

    if (r_type(&amp;pdata-&gt;GlyphNames2Unicode) == t_dictionary) {
	gs_char c = gs_font_map_glyph_by_dict(font-&gt;memory, 
					      &amp;pdata-&gt;GlyphNames2Unicode, glyph);

	if (c != GS_NO_CHAR)
	    return c;
	/* 
	 * Fall through, because test.ps for SF bug #529103 requres 
	 * to examine both tables. Due to that the Unicode Decoding resource 
	 * can't be a default value for FontInfo.GlyphNames2Unicode .
	 */
    }
    UnicodeDecoding = zfont_get_to_unicode_map(font-&gt;dir);
    if (UnicodeDecoding != NULL &amp;&amp; r_type(UnicodeDecoding) == t_dictionary)
	return gs_font_map_glyph_by_dict(font-&gt;memory, UnicodeDecoding, glyph);
    return GS_NO_CHAR; /* No map. */
}

/* ------ Initialization procedure ------ */

const op_def zbfont_op_defs[] =
{
    {"2.buildfont3", zbuildfont3},
    op_def_end(0)
};

/* ------ Subroutines ------ */

/* Convert strings to executable names for build_proc_refs. */
int
build_proc_name_refs(const gs_memory_t *mem, build_proc_refs * pbuild,
		     const char *bcstr, const char *bgstr)
{
    int code;

    if (!bcstr)
	make_null(&amp;pbuild-&gt;BuildChar);
    else {
	if ((code = name_ref(mem, (const byte *)bcstr, 
			     strlen(bcstr), &amp;pbuild-&gt;BuildChar, 0)) &lt; 0)
	    return code;
	r_set_attrs(&amp;pbuild-&gt;BuildChar, a_executable);
    }
    if (!bgstr)
	make_null(&amp;pbuild-&gt;BuildGlyph);
    else {
	if ((code = name_ref(mem, (const byte *)bgstr, 
			     strlen(bgstr), &amp;pbuild-&gt;BuildGlyph, 0)) &lt; 0)
	    return code;
	r_set_attrs(&amp;pbuild-&gt;BuildGlyph, a_executable);
    }
    return 0;
}

/* Get the BuildChar and/or BuildGlyph routines from a (base) font. */
int
build_gs_font_procs(os_ptr op, build_proc_refs * pbuild)
{
    int ccode, gcode;
    ref *pBuildChar;
    ref *pBuildGlyph;

    check_type(*op, t_dictionary);
    ccode = dict_find_string(op, "BuildChar", &amp;pBuildChar);
    gcode = dict_find_string(op, "BuildGlyph", &amp;pBuildGlyph);
    if (ccode &lt;= 0) {
	if (gcode &lt;= 0)
	    return_error(e_invalidfont);
	make_null(&amp;pbuild-&gt;BuildChar);
    } else {
	check_proc(*pBuildChar);
	pbuild-&gt;BuildChar = *pBuildChar;
    }
    if (gcode &lt;= 0)
	make_null(&amp;pbuild-&gt;BuildGlyph);
    else {
	check_proc(*pBuildGlyph);
	pbuild-&gt;BuildGlyph = *pBuildGlyph;
    }
    return 0;
}

private int font_with_same_UID_and_another_metrics(const gs_font *pfont0, const gs_font *pfont1)
{
    const gs_font_base *pbfont0 = (const gs_font_base *)pfont0;
    const gs_font_base *pbfont1 = (const gs_font_base *)pfont1;


    if (uid_equal(&amp;pbfont0-&gt;UID, &amp;pbfont1-&gt;UID)) {
	const ref *pfdict0 = &amp;pfont_data(gs_font_parent(pbfont0))-&gt;dict;
	const ref *pfdict1 = &amp;pfont_data(gs_font_parent(pbfont1))-&gt;dict;
	ref *pmdict0, *pmdict1;

	if (pbfont0-&gt;WMode || dict_find_string(pfdict0, "Metrics", &amp;pmdict0) &lt;= 0)
	    pmdict0 = NULL;
	if (pbfont1-&gt;WMode || dict_find_string(pfdict1, "Metrics", &amp;pmdict1) &lt;= 0)
	    pmdict1 = NULL;
	if (!pmdict0 != !pmdict1)
	    return 1;
	if (pmdict0 != NULL &amp;&amp; !obj_eq(pfont0-&gt;memory, pmdict0, pmdict1))
	    return 1;
	if (!pbfont0-&gt;WMode || dict_find_string(pfdict0, "Metrics2", &amp;pmdict0) &lt;= 0)
	    pmdict0 = NULL;
	if (!pbfont0-&gt;WMode || dict_find_string(pfdict1, "Metrics2", &amp;pmdict1) &lt;= 0)
	    pmdict1 = NULL;
	if (!pmdict0 != !pmdict1)
	    return 1;
	if (pmdict0 != NULL &amp;&amp; !obj_eq(pfont0-&gt;memory, pmdict0, pmdict1))
	    return 1;
    }
    return 0;
}

/* Do the common work for building a primitive font -- one whose execution */
/* algorithm is implemented in C (Type 1, Type 2, Type 4, or Type 42). */
/* The caller guarantees that *op is a dictionary. */
int
build_gs_primitive_font(i_ctx_t *i_ctx_p, os_ptr op, gs_font_base ** ppfont,
			font_type ftype, gs_memory_type_ptr_t pstype,
			const build_proc_refs * pbuild,
			build_font_options_t options)
{
    ref *pcharstrings = 0;
    ref CharStrings;
    gs_font_base *pfont;
    font_data *pdata;
    int code;

    if (dict_find_string(op, "CharStrings", &amp;pcharstrings) &lt;= 0) {
	if (!(options &amp; bf_CharStrings_optional))
	    return_error(e_invalidfont);
    } else {
	ref *ignore;

	if (!r_has_type(pcharstrings, t_dictionary))
	    return_error(e_invalidfont);
	if ((options &amp; bf_notdef_required) != 0 &amp;&amp;
	    dict_find_string(pcharstrings, ".notdef", &amp;ignore) &lt;= 0
	    )
	    return_error(e_invalidfont);
	/*
	 * Since build_gs_simple_font may resize the dictionary and cause
	 * pointers to become invalid, save CharStrings.
	 */
	CharStrings = *pcharstrings;
    }
    code = build_gs_outline_font(i_ctx_p, op, ppfont, ftype, pstype, pbuild,
				 options, build_gs_simple_font);
    if (code != 0)
	return code;
    pfont = *ppfont;
    pdata = pfont_data(pfont);
    if (pcharstrings)
	ref_assign(&amp;pdata-&gt;CharStrings, &amp;CharStrings);
    else
	make_null(&amp;pdata-&gt;CharStrings);
    /* Check that the UniqueIDs match.  This is part of the */
    /* Adobe protection scheme, but we may as well emulate it. */
    if (uid_is_valid(&amp;pfont-&gt;UID) &amp;&amp;
	!dict_check_uid_param(op, &amp;pfont-&gt;UID)
	)
	uid_set_invalid(&amp;pfont-&gt;UID);
    if (uid_is_valid(&amp;pfont-&gt;UID)) {
	const gs_font *pfont0 = (const gs_font *)pfont;
	
	code = gs_font_find_similar(ifont_dir, &amp;pfont0, 
		       font_with_same_UID_and_another_metrics);
	if (code &lt; 0)
	    return code; /* Must not happen. */
	if (code)
	    uid_set_invalid(&amp;pfont-&gt;UID);
    }
    return 0;
}

/* Build a FDArray entry for a CIDFontType 0 font. */
/* Note that as of Adobe PostScript version 3011, this may be either */
/* a Type 1 or Type 2 font. */
private int
build_FDArray_sub_font(i_ctx_t *i_ctx_p, ref *op,
		       gs_font_base **ppfont,
		       font_type ftype, gs_memory_type_ptr_t pstype,
		       const build_proc_refs * pbuild,
		       build_font_options_t ignore_options)
{
    gs_font *pfont;
    int code = build_gs_sub_font(i_ctx_p, op, &amp;pfont, ftype, pstype, pbuild,
				 NULL, op);

    if (code &gt;= 0)
	*ppfont = (gs_font_base *)pfont;
    return code;
}
int
build_gs_FDArray_font(i_ctx_t *i_ctx_p, ref *op,
		      gs_font_base **ppfont,
		      font_type ftype, gs_memory_type_ptr_t pstype,
		      const build_proc_refs * pbuild)
{
    gs_font_base *pfont;
    font_data *pdata;
    int code = build_gs_outline_font(i_ctx_p, op, &amp;pfont, ftype, pstype,
				     pbuild, bf_options_none,
				     build_FDArray_sub_font);
    static const double bbox[4] = { 0, 0, 0, 0 };
    gs_uid uid;

    if (code &lt; 0)
	return code;
    pdata = pfont_data(pfont);
    /* Fill in members normally set by build_gs_primitive_font. */
    make_null(&amp;pdata-&gt;CharStrings);
    /* Fill in members normally set by build_gs_simple_font. */
    uid_set_invalid(&amp;uid);
    init_gs_simple_font(pfont, bbox, &amp;uid);
    pfont-&gt;encoding_index = ENCODING_INDEX_UNKNOWN;
    pfont-&gt;nearest_encoding_index = ENCODING_INDEX_UNKNOWN;
    /* Fill in members normally set by build_gs_font. */
    pfont-&gt;key_name = pfont-&gt;font_name;
    *ppfont = pfont;
    return 0;
}

/* Do the common work for building an outline font -- a non-composite font */
/* for which PaintType and StrokeWidth are meaningful. */
/* The caller guarantees that *op is a dictionary. */
int
build_gs_outline_font(i_ctx_t *i_ctx_p, os_ptr op, gs_font_base ** ppfont,
		      font_type ftype, gs_memory_type_ptr_t pstype,
		      const build_proc_refs * pbuild,
		      build_font_options_t options,
		      build_base_font_proc_t build_base_font)
{
    int painttype;
    float strokewidth;
    gs_font_base *pfont;
    int code = dict_int_param(op, "PaintType", 0, 3, 0, &amp;painttype);

    if (code &lt; 0)
	return code;
    code = dict_float_param(op, "StrokeWidth", 0.0, &amp;strokewidth);
    if (code &lt; 0)
	return code;
    code = build_base_font(i_ctx_p, op, ppfont, ftype, pstype, pbuild,
			   options);
    if (code != 0)
	return code;
    pfont = *ppfont;
    pfont-&gt;PaintType = painttype;
    pfont-&gt;StrokeWidth = strokewidth;
    return 0;
}

/* Do the common work for building a font of any non-composite FontType. */
/* The caller guarantees that *op is a dictionary. */
int
build_gs_simple_font(i_ctx_t *i_ctx_p, os_ptr op, gs_font_base ** ppfont,
		     font_type ftype, gs_memory_type_ptr_t pstype,
		     const build_proc_refs * pbuild,
		     build_font_options_t options)
{
    double bbox[4];
    gs_uid uid;
    int code;
    gs_font_base *pfont;
    ref *pfontinfo, *g2u = NULL, Glyph2Unicode;

    if (dict_find_string(op, "FontInfo", &amp;pfontinfo) &lt;= 0 ||
	    !r_has_type(pfontinfo, t_dictionary) ||
	    dict_find_string(pfontinfo, "GlyphNames2Unicode", &amp;g2u) &lt;= 0 ||
	    !r_has_type(pfontinfo, t_dictionary))
	g2u = NULL;
    else
	/*
	 * Since build_gs_font may resize the dictionary and cause
	 * pointers to become invalid, save Glyph2Unicode
	 */
	Glyph2Unicode = *g2u;
    code = font_bbox_param(imemory, op, bbox);
    if (code &lt; 0)
	return code;
    code = dict_uid_param(op, &amp;uid, 0, imemory, i_ctx_p);
    if (code &lt; 0)
	return code;
    if ((options &amp; bf_UniqueID_ignored) &amp;&amp; uid_is_UniqueID(&amp;uid))
	uid_set_invalid(&amp;uid);
    code = build_gs_font(i_ctx_p, op, (gs_font **) ppfont, ftype, pstype,
			 pbuild, options);
    if (code != 0)		/* invalid or scaled font */
	return code;
    pfont = *ppfont;
    pfont-&gt;procs.init_fstack = gs_default_init_fstack;
    pfont-&gt;procs.define_font = gs_no_define_font;
    pfont-&gt;procs.decode_glyph = gs_font_map_glyph_to_unicode;
    pfont-&gt;procs.make_font = zbase_make_font;
    pfont-&gt;procs.next_char_glyph = gs_default_next_char_glyph;
    pfont-&gt;FAPI = 0;
    pfont-&gt;FAPI_font_data = 0;
    init_gs_simple_font(pfont, bbox, &amp;uid);
    lookup_gs_simple_font_encoding(pfont);
    if (g2u != NULL) {
	font_data *pdata = pfont_data(pfont);

	ref_assign_new(&amp;pdata-&gt;GlyphNames2Unicode, &amp;Glyph2Unicode);
    }
    return 0;
}

/* Initialize the FontBBox and UID of a non-composite font. */
void
init_gs_simple_font(gs_font_base *pfont, const double bbox[4],
		    const gs_uid *puid)
{
    pfont-&gt;FontBBox.p.x = bbox[0];
    pfont-&gt;FontBBox.p.y = bbox[1];
    pfont-&gt;FontBBox.q.x = bbox[2];
    pfont-&gt;FontBBox.q.y = bbox[3];
    pfont-&gt;UID = *puid;
}

/* Compare the encoding of a simple font with the registered encodings. */
void
lookup_gs_simple_font_encoding(gs_font_base * pfont)
{
    const ref *pfe = &amp;pfont_data(pfont)-&gt;Encoding;
    int index = -1;

    pfont-&gt;encoding_index = index;
    if (r_type(pfe) == t_array &amp;&amp; r_size(pfe) &lt;= 256) {
	/* Look for an encoding that's "close". */
	uint esize = r_size(pfe);
	int near_index = -1;
	uint best = esize / 3;	/* must match at least this many */
	gs_const_string fstrs[256];
	int i;

	/* Get the string names of the glyphs in the font's Encoding. */
	for (i = 0; i &lt; esize; ++i) {
	    ref fchar;

	    if (array_get(pfont-&gt;memory, pfe, (long)i, &amp;fchar) &lt; 0 ||
		!r_has_type(&amp;fchar, t_name)
		)
		fstrs[i].data = 0, fstrs[i].size = 0;
	    else {
		ref nsref;

		name_string_ref(pfont-&gt;memory, &amp;fchar, &amp;nsref);
		fstrs[i].data = nsref.value.const_bytes;
		fstrs[i].size = r_size(&amp;nsref);
	    }
	}
	/* Compare them against the known encodings. */
	for (index = 0; index &lt; NUM_KNOWN_REAL_ENCODINGS; ++index) {
	    uint match = esize;

	    for (i = esize; --i &gt;= 0;) {
		gs_const_string rstr;

		gs_c_glyph_name(gs_c_known_encode((gs_char)i, index), &amp;rstr);
		if (rstr.size == fstrs[i].size &amp;&amp;
		    !memcmp(rstr.data, fstrs[i].data, rstr.size)
		    )
		    continue;
		if (--match &lt;= best)
		    break;
	    }
	    if (match &gt; best) {
		best = match;
		near_index = index;
		/* If we have a perfect match, stop now. */
		if (best == esize)
		    break;
	    }
	}
	index = near_index;
	if (best == esize)
	    pfont-&gt;encoding_index = index;
    }
    pfont-&gt;nearest_encoding_index = index;
}

/* Get FontMatrix and FontName parameters. */
private int
sub_font_params(const gs_memory_t *mem, const ref *op, gs_matrix *pmat, gs_matrix *pomat, ref *pfname)
{
    ref *pmatrix;
    ref *pfontname;
    ref *porigfont;

    if (dict_find_string(op, "FontMatrix", &amp;pmatrix) &lt;= 0 ||
	read_matrix(mem, pmatrix, pmat) &lt; 0
	)
	return_error(e_invalidfont);
    if (dict_find_string(op, ".OrigFont", &amp;porigfont) &lt;= 0)
	porigfont = NULL;
    if (pomat!= NULL) {
	if (porigfont == NULL ||
	    dict_find_string(porigfont, "FontMatrix", &amp;pmatrix) &lt;= 0 ||
	    read_matrix(mem, pmatrix, pomat) &lt; 0
	    )
	    memset(pomat, 0, sizeof(*pomat));
    }
    /* Use the FontInfo/OrigFontName key preferrentially (created by MS PSCRIPT driver) */
    if ((dict_find_string((porigfont != NULL ? porigfont : op), "FontInfo", &amp;pfontname) &gt; 0) &amp;&amp;
        (dict_find_string(pfontname, "OrigFontName", &amp;pfontname) &gt; 0)) {
	get_font_name(mem, pfname, pfontname);
    } else if (dict_find_string((porigfont != NULL ? porigfont : op), ".Alias", &amp;pfontname) &gt; 0) {
        /* If we emulate the font, we want the requested name rather than a substitute. */
	get_font_name(mem, pfname, pfontname);
    } else if (dict_find_string((porigfont != NULL ? porigfont : op), "FontName", &amp;pfontname) &gt; 0) {
	get_font_name(mem, pfname, pfontname);
    } else
	make_empty_string(pfname, a_readonly);
    return 0;
}

/* Do the common work for building a font of any FontType. */
/* The caller guarantees that *op is a dictionary. */
/* op[-1] must be the key under which the font is being registered */
/* in FontDirectory, normally a name or string. */
/* Return 0 for a new font, 1 for a font made by makefont or scalefont, */
/* or a negative error code. */
int
build_gs_font(i_ctx_t *i_ctx_p, os_ptr op, gs_font ** ppfont, font_type ftype,
	      gs_memory_type_ptr_t pstype, const build_proc_refs * pbuild,
	      build_font_options_t options)
{
    ref kname;			/* t_string */
    ref *pftype;
    ref *pencoding = 0;
    bool bitmapwidths;
    int exactsize, inbetweensize, transformedchar;
    int wmode;
    int code;
    gs_font *pfont;
    ref *pfid;
    ref *aop = dict_access_ref(op);

    get_font_name(imemory, &amp;kname, op - 1);
    if (dict_find_string(op, "FontType", &amp;pftype) &lt;= 0 ||
	!r_has_type(pftype, t_integer) ||
	pftype-&gt;value.intval != (int)ftype
	)
	return_error(e_invalidfont);
    if (dict_find_string(op, "Encoding", &amp;pencoding) &lt;= 0) {
	if (!(options &amp; bf_Encoding_optional))
	    return_error(e_invalidfont);
	pencoding = 0;
    } else {
	if (!r_is_array(pencoding))
	    return_error(e_invalidfont);
    }
    if ((code = dict_int_param(op, "WMode", 0, 1, 0, &amp;wmode)) &lt; 0 ||
	(code = dict_bool_param(op, "BitmapWidths", false, &amp;bitmapwidths)) &lt; 0 ||
	(code = dict_int_param(op, "ExactSize", 0, 2, fbit_use_bitmaps, &amp;exactsize)) &lt; 0 ||
	(code = dict_int_param(op, "InBetweenSize", 0, 2, fbit_use_outlines, &amp;inbetweensize)) &lt; 0 ||
	(code = dict_int_param(op, "TransformedChar", 0, 2, fbit_use_outlines, &amp;transformedchar)) &lt; 0
	)
	return code;
    code = dict_find_string(op, "FID", &amp;pfid);
    if (code &gt; 0) {
	if (!r_has_type(pfid, t_fontID))
	    return_error(e_invalidfont);
	/*
	 * If this font has a FID entry already, it might be a scaled font
	 * made by makefont or scalefont; in a Level 2 environment, it might
	 * be an existing font being registered under a second name, or a
	 * re-encoded font (which was invalid in Level 1, but dvips did it
	 * anyway).
	 */
	pfont = r_ptr(pfid, gs_font);
	if (pfont-&gt;base == pfont) {	/* original font */
	    if (!level2_enabled)
		return_error(e_invalidfont);
	    if (obj_eq(pfont-&gt;memory, pfont_dict(pfont), op)) {
		*ppfont = pfont;
		return 1;
	    }
	    /*
	     * This is a re-encoded font, or some other
	     * questionable situation in which the FID
	     * was preserved.  Pretend the FID wasn't there.
	     */
	} else {		/* This was made by makefont or scalefont. */
	    /* Just insert the new name. */
	    gs_matrix mat;
	    ref fname;			/* t_string */

	    code = sub_font_params(imemory, op, &amp;mat, NULL, &amp;fname);
	    if (code &lt; 0)
		return code;
	    code = 1;
	    copy_font_name(&amp;pfont-&gt;font_name, &amp;fname);
	    goto set_name;
	}
    }
    /* This is a new font. */
    if (!r_has_attr(aop, a_write))
	return_error(e_invalidaccess);
    {
	ref encoding;

	/*
	 * Since add_FID may resize the dictionary and cause
	 * pencoding to become invalid, save the Encoding.
	 */
	if (pencoding) {
	    encoding = *pencoding;
	    pencoding = &amp;encoding;
	}
	code = build_gs_sub_font(i_ctx_p, op, &amp;pfont, ftype, pstype,
				 pbuild, pencoding, op);
	if (code &lt; 0)
	    return code;
    }
    pfont-&gt;BitmapWidths = bitmapwidths;
    pfont-&gt;ExactSize = (fbit_type)exactsize;
    pfont-&gt;InBetweenSize = (fbit_type)inbetweensize;
    pfont-&gt;TransformedChar = (fbit_type)transformedchar;
    pfont-&gt;WMode = wmode;
    pfont-&gt;procs.font_info = zfont_info;
    code = 0;
set_name:
    copy_font_name(&amp;pfont-&gt;key_name, &amp;kname);
    *ppfont = pfont;
    return code;
}

/* Create a sub-font -- a font or an entry in the FDArray of a CIDFontType 0 */
/* font.  Default BitmapWidths, ExactSize, InBetweenSize, TransformedChar, */
/* and WMode; do not fill in key_name. */
/* The caller guarantees that *op is a dictionary. */
int
build_gs_sub_font(i_ctx_t *i_ctx_p, const ref *op, gs_font **ppfont,
		  font_type ftype, gs_memory_type_ptr_t pstype,
		  const build_proc_refs * pbuild, const ref *pencoding,
		  ref *fid_op)
{
    gs_matrix mat, omat;
    ref fname;			/* t_string */
    gs_font *pfont;
    font_data *pdata;
    /*
     * Make sure that we allocate the font data
     * in the same VM as the font dictionary.
     */
    uint space = ialloc_space(idmemory);
    int code = sub_font_params(imemory, op, &amp;mat, &amp;omat, &amp;fname);

    if (code &lt; 0)
	return code;
    ialloc_set_space(idmemory, r_space(op));
    pfont = gs_font_alloc(imemory, pstype, &amp;gs_font_procs_default, NULL,
			  "buildfont(font)");
    pdata = ialloc_struct(font_data, &amp;st_font_data,
			  "buildfont(data)");
    if (pfont == 0 || pdata == 0)
	code = gs_note_error(e_VMerror);
    else if (fid_op)
	code = add_FID(i_ctx_p, fid_op, pfont, iimemory);
    if (code &lt; 0) {
	ifree_object(pdata, "buildfont(data)");
	ifree_object(pfont, "buildfont(font)");
	ialloc_set_space(idmemory, space);
	return code;
    }
    refset_null((ref *) pdata, sizeof(font_data) / sizeof(ref));
    ref_assign_new(&amp;pdata-&gt;dict, op);
    ref_assign_new(&amp;pdata-&gt;BuildChar, &amp;pbuild-&gt;BuildChar);
    ref_assign_new(&amp;pdata-&gt;BuildGlyph, &amp;pbuild-&gt;BuildGlyph);
    if (pencoding)
	ref_assign_new(&amp;pdata-&gt;Encoding, pencoding);
    pfont-&gt;client_data = pdata;
    pfont-&gt;FontType = ftype;
    pfont-&gt;FontMatrix = mat;
    pfont-&gt;orig_FontMatrix = omat;
    pfont-&gt;BitmapWidths = false;
    pfont-&gt;ExactSize = fbit_use_bitmaps;
    pfont-&gt;InBetweenSize = fbit_use_outlines;
    pfont-&gt;TransformedChar = fbit_use_outlines;
    pfont-&gt;WMode = 0;
    pfont-&gt;procs.encode_char = zfont_encode_char;
    pfont-&gt;procs.glyph_name = zfont_glyph_name;
    ialloc_set_space(idmemory, space);
    copy_font_name(&amp;pfont-&gt;font_name, &amp;fname);
    *ppfont = pfont;
    return 0;
}

/* Get the string corresponding to a font name. */
/* If the font name isn't a name or a string, return an empty string. */
void
get_font_name(const gs_memory_t *mem, ref * pfname, const ref * op)
{
    switch (r_type(op)) {
	case t_string:
	    *pfname = *op;
	    break;
	case t_name:
	    name_string_ref(mem, op, pfname);
	    break;
	default:
	    /* This is weird, but legal.... */
	    make_empty_string(pfname, a_readonly);
    }
}

/* Copy a font name into the gs_font structure. */
void
copy_font_name(gs_font_name * pfstr, const ref * pfname)
{
    uint size = r_size(pfname);

    if (size &gt; gs_font_name_max)
	size = gs_font_name_max;
    memcpy(&amp;pfstr-&gt;chars[0], pfname-&gt;value.const_bytes, size);
    /* Following is only for debugging printout. */
    pfstr-&gt;chars[size] = 0;
    pfstr-&gt;size = size;
}

/* Finish building a font, by calling gs_definefont if needed. */
int
define_gs_font(gs_font * pfont)
{
    return (pfont-&gt;base == pfont &amp;&amp; pfont-&gt;dir == 0 ?
	    /* i.e., unregistered original font */
	    gs_definefont(ifont_dir, pfont) :
	    0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

