<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zfcmap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zfcmap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1997, 1998, 1999, 2000 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zfcmap.c,v 1.17 2005/10/04 06:30:02 ray Exp $ */
/* CMap creation operator */
#include "memory_.h"
#include "ghost.h"
#include "oper.h"
#include "gsmatrix.h"		/* for gxfont.h */
#include "gsstruct.h"
#include "gsutil.h"		/* for bytes_compare */
#include "gxfcmap1.h"
#include "gxfont.h"
#include "ialloc.h"
#include "icid.h"
#include "iddict.h"
#include "idparam.h"
#include "ifont.h"		/* for zfont_mark_glyph_name */
#include "iname.h"
#include "store.h"

/* Exported for zfont0.c */
int ztype0_get_cmap(const gs_cmap_t ** ppcmap, const ref * pfdepvector,
		    const ref * op, gs_memory_t *imem);

/*
 * Define whether to check the compatibility of CIDSystemInfo between the
 * CMap and the composite font.  PLRM2 says compatibility is required, but
 * PLRM3 says the interpreter doesn't check it.
 */
/*#define CHECK_CID_SYSTEM_INFO_COMPATIBILITY*/

/* ---------------- Internal procedures ---------------- */

/* Free a code map in case of VMerror. */
private void
free_code_map(gx_code_map_t * pcmap, gs_memory_t * mem)
{
    if (pcmap-&gt;lookup) {
	int i;

	for (i = 0; i &lt; pcmap-&gt;num_lookup; ++i) {
	    gx_cmap_lookup_range_t *pclr = &amp;pcmap-&gt;lookup[i];

	    if (pclr-&gt;value_type == CODE_VALUE_GLYPH)
		gs_free_string(mem, pclr-&gt;values.data, pclr-&gt;values.size,
			       "free_code_map(values)");
	}
	gs_free_object(mem, pcmap-&gt;lookup, "free_code_map(map)");
    }
}

/* Convert code ranges to internal form. */
private int
acquire_code_ranges(gs_cmap_adobe1_t *cmap, const ref *pref, gs_memory_t *mem)
{
    uint num_ranges = 0;
    gx_code_space_range_t *ranges;
    uint i, j, elem_sz;
    ref elem;

    if (!r_is_array(pref))
	return_error(e_rangecheck);
    for (i=0; i &lt; r_size(pref); i++) {
        int code = array_get(mem, pref, i, &amp;elem);
        if (code &lt; 0)
            return code;
        elem_sz = r_size(&amp;elem);
        if (elem_sz &amp; 1)
	    return_error(e_rangecheck);
        num_ranges += elem_sz;
    }
    if (num_ranges == 0)
	return_error(e_rangecheck);
    num_ranges &gt;&gt;= 1;

    ranges = (gx_code_space_range_t *)
	gs_alloc_byte_array(mem, num_ranges, sizeof(gx_code_space_range_t),
			    "acquire_code_ranges");
    if (ranges == 0)
	return_error(e_VMerror);
    cmap-&gt;code_space.ranges = ranges;
    cmap-&gt;code_space.num_ranges = num_ranges;

    for (i = 0; i &lt; r_size(pref); i++) {
        array_get(mem, pref, i, &amp;elem);
        elem_sz = r_size(&amp;elem);
        for (j = 0; j &lt; elem_sz; j += 2) {
	ref rfirst, rlast;
	int size;

	    array_get(mem, &amp;elem, j, &amp;rfirst);
	    array_get(mem, &amp;elem, j + 1, &amp;rlast);
	if (!r_has_type(&amp;rfirst, t_string) ||
	    !r_has_type(&amp;rlast, t_string) ||
	    (size = r_size(&amp;rfirst)) == 0 || size &gt; MAX_CMAP_CODE_SIZE ||
	    r_size(&amp;rlast) != size ||
	    memcmp(rfirst.value.bytes, rlast.value.bytes, size) &gt; 0)
	    return_error(e_rangecheck);
	memcpy(ranges-&gt;first, rfirst.value.bytes, size);
	memcpy(ranges-&gt;last, rlast.value.bytes, size);
	ranges-&gt;size = size;
            ++ranges;
        }
    }
    return 0;
}

/* Convert a code map to internal form. */
private int
acquire_code_map(gx_code_map_t *pcmap, const ref *pref, gs_cmap_adobe1_t *root,
		 gs_memory_t *mem)
{
    uint num_lookup = 0;
    gx_cmap_lookup_range_t *pclr;
    long i;
    ref elem;
    uint elem_sz;

    if (!r_is_array(pref))
	return_error(e_rangecheck);
    for (i=0; i &lt; r_size(pref); i++) {
        int code = array_get(mem, pref, i, &amp;elem);
        if (code &lt; 0)
            return code;
        elem_sz = r_size(&amp;elem);
        if (elem_sz % 5 != 0)
	return_error(e_rangecheck);
        num_lookup += elem_sz;
    }
    num_lookup /= 5;
    pclr = gs_alloc_struct_array(mem, num_lookup, gx_cmap_lookup_range_t,
				 &amp;st_cmap_lookup_range_element,
				 "acquire_code_map(lookup ranges)");
    if (pclr == 0)
	return_error(e_VMerror);
    memset(pclr, 0, sizeof(*pclr) * num_lookup);
    pcmap-&gt;lookup = pclr;
    pcmap-&gt;num_lookup = num_lookup;
    
   
    for (i = 0; i &lt; r_size(pref); i++) {
        uint j;
        array_get(mem, pref, i, &amp;elem);
        elem_sz = r_size(&amp;elem);
        for (j = 0; j &lt; elem_sz; j += 5) {
	ref rprefix, rmisc, rkeys, rvalues, rfxs;

	    array_get(mem, &amp;elem, j, &amp;rprefix);
	    array_get(mem, &amp;elem, j + 1, &amp;rmisc);
	    array_get(mem, &amp;elem, j + 2, &amp;rkeys);
	    array_get(mem, &amp;elem, j + 3, &amp;rvalues);
	    array_get(mem, &amp;elem, j + 4, &amp;rfxs);

	if (!r_has_type(&amp;rprefix, t_string) ||
	    !r_has_type(&amp;rmisc, t_string) ||
	    !r_has_type(&amp;rkeys, t_string) ||
	    !(r_has_type(&amp;rvalues, t_string) || r_is_array(&amp;rvalues)) ||
	    !r_has_type(&amp;rfxs, t_integer)
	    )
	    return_error(e_typecheck);
	if (r_size(&amp;rmisc) != 4 ||
	    rmisc.value.bytes[0] &gt; MAX_CMAP_CODE_SIZE - r_size(&amp;rprefix) ||
	    rmisc.value.bytes[1] &gt; 1 ||
	    rmisc.value.bytes[2] &gt; CODE_VALUE_MAX ||
	    rmisc.value.bytes[3] == 0)
	    return_error(e_rangecheck);
	pclr-&gt;cmap = root;
	pclr-&gt;key_size = rmisc.value.bytes[0];
	pclr-&gt;key_prefix_size = r_size(&amp;rprefix);
	memcpy(pclr-&gt;key_prefix, rprefix.value.bytes, pclr-&gt;key_prefix_size);
	pclr-&gt;key_is_range = rmisc.value.bytes[1];
	if (pclr-&gt;key_size == 0) {
	    /* This is a single entry consisting only of the prefix. */
	    if (r_size(&amp;rkeys) != 0)
		return_error(e_rangecheck);
	    pclr-&gt;num_entries = 1;
	} else {
	    int step = pclr-&gt;key_size * (pclr-&gt;key_is_range ? 2 : 1);

	    if (r_size(&amp;rkeys) % step != 0)
		return_error(e_rangecheck);
	    pclr-&gt;num_entries = r_size(&amp;rkeys) / step;
	}
	pclr-&gt;keys.data = rkeys.value.bytes,
	    pclr-&gt;keys.size = r_size(&amp;rkeys);
	pclr-&gt;value_type = rmisc.value.bytes[2];
	pclr-&gt;value_size = rmisc.value.bytes[3];
	if (r_has_type(&amp;rvalues, t_string)) {
	    if (pclr-&gt;value_type == CODE_VALUE_GLYPH)
		return_error(e_rangecheck);
	    if (r_size(&amp;rvalues) % pclr-&gt;num_entries != 0 ||
		r_size(&amp;rvalues) / pclr-&gt;num_entries != pclr-&gt;value_size)
		return_error(e_rangecheck);
	    pclr-&gt;values.data = rvalues.value.bytes,
		pclr-&gt;values.size = r_size(&amp;rvalues);
	} else {
	    uint values_size = pclr-&gt;num_entries * pclr-&gt;value_size;
	    long k;
	    byte *pvalue;

	    if (pclr-&gt;value_type != CODE_VALUE_GLYPH ||
		r_size(&amp;rvalues) != pclr-&gt;num_entries ||
		pclr-&gt;value_size &gt; sizeof(gs_glyph))
		return_error(e_rangecheck);
	    pclr-&gt;values.data = gs_alloc_string(mem, values_size,
						"acquire_code_map(values)");
	    if (pclr-&gt;values.data == 0)
		return_error(e_VMerror);
	    pclr-&gt;values.size = values_size;
	    pvalue = pclr-&gt;values.data;
	    for (k = 0; k &lt; pclr-&gt;num_entries; ++k) {
		ref rvalue;
		gs_glyph value;
		int i;

		array_get(mem, &amp;rvalues, k, &amp;rvalue);
		if (!r_has_type(&amp;rvalue, t_name))
		    return_error(e_rangecheck);
		value = name_index(mem, &amp;rvalue);
		/*
		 * We need a special check here because some CPUs cannot
		 * shift by the full size of an int or long.
		 */
		if (pclr-&gt;value_size &lt; sizeof(value) &amp;&amp;
		    (value &gt;&gt; (pclr-&gt;value_size * 8)) != 0
		    )
		    return_error(e_rangecheck);
		for (i = pclr-&gt;value_size; --i &gt;= 0; )
		    *pvalue++ = (byte)(value &gt;&gt; (i * 8));
	    }
	}
	check_int_leu_only(rfxs, 0xff);
	pclr-&gt;font_index = (int)rfxs.value.intval;
            ++pclr;
        }
    }
    return 0;
}

/*
 * Acquire the CIDSystemInfo array from a dictionary.  If missing, fabricate
 * a 0-element array and return 1.
 */
private int
acquire_cid_system_info(ref *psia, const ref *op)
{
    ref *prcidsi;

    if (dict_find_string(op, "CIDSystemInfo", &amp;prcidsi) &lt;= 0) {
	make_empty_array(psia, a_readonly);
	return 1;
    }
    if (r_has_type(prcidsi, t_dictionary)) {
	make_array(psia, a_readonly, 1, prcidsi);
	return 0;
    }
    if (!r_is_array(prcidsi))
	return_error(e_typecheck);
    *psia = *prcidsi;
    return 0;
}

/*
 * Get one element of a CIDSystemInfo array.  If the element is missing or
 * null, return 1.
 */
private int
get_cid_system_info(const gs_memory_t *mem, gs_cid_system_info_t *pcidsi, const ref *psia, uint index)
{
    ref rcidsi;
    int code = array_get(mem, psia, (long)index, &amp;rcidsi);

    if (code &lt; 0 || r_has_type(&amp;rcidsi, t_null)) {
	cid_system_info_set_null(pcidsi);
	return 1;
    }
    return cid_system_info_param(pcidsi, &amp;rcidsi);
}

#ifdef CHECK_CID_SYSTEM_INFO_COMPATIBILITY

/* Check compatibility of CIDSystemInfo. */
private bool
bytes_eq(const gs_const_string *pcs1, const gs_const_string *pcs2)
{
    return !bytes_compare(pcs1-&gt;data, pcs1-&gt;size,
			  pcs2-&gt;data, pcs2-&gt;size);
}
private bool
cid_system_info_compatible(const gs_cid_system_info_t * psi1,
			   const gs_cid_system_info_t * psi2)
{
    return bytes_eq(&amp;psi1-&gt;Registry, &amp;psi2-&gt;Registry) &amp;&amp;
	bytes_eq(&amp;psi1-&gt;Ordering, &amp;psi2-&gt;Ordering);
}

#endif /* CHECK_CID_SYSTEM_INFO_COMPATIBILITY */

/* ---------------- (Semi-)public procedures ---------------- */

/* Get the CodeMap from a Type 0 font, and check the CIDSystemInfo of */
/* its subsidiary fonts. */
int
ztype0_get_cmap(const gs_cmap_t **ppcmap, const ref *pfdepvector,
		const ref *op, gs_memory_t *imem)
{
    ref *prcmap;
    ref *pcodemap;
    const gs_cmap_t *pcmap;
    int code;
    uint num_fonts;
    uint i;

    /*
     * We have no way of checking whether the CodeMap is a concrete
     * subclass of gs_cmap_t, so we just check that it is in fact a
     * t_struct and is large enough.
     */
    if (dict_find_string(op, "CMap", &amp;prcmap) &lt;= 0 ||
	!r_has_type(prcmap, t_dictionary) ||
	dict_find_string(prcmap, "CodeMap", &amp;pcodemap) &lt;= 0 ||
	!r_is_struct(pcodemap) ||
	gs_object_size(imem, r_ptr(pcodemap, gs_cmap_t)) &lt; sizeof(gs_cmap_t)
	)
	return_error(e_invalidfont);
    pcmap = r_ptr(pcodemap, gs_cmap_t);
    num_fonts = r_size(pfdepvector);
    for (i = 0; i &lt; num_fonts; ++i) {
	ref rfdep, rfsi;

	array_get(imem, pfdepvector, (long)i, &amp;rfdep);
	code = acquire_cid_system_info(&amp;rfsi, &amp;rfdep);
	if (code &lt; 0)
	    return code;
	if (code == 0) {
	    if (r_size(&amp;rfsi) != 1)
		return_error(e_rangecheck);
#ifdef CHECK_CID_SYSTEM_INFO_COMPATIBILITY
	    {
		gs_cid_system_info_t cidsi;

		get_cid_system_info(&amp;cidsi, &amp;rfsi, 0);
		if (!cid_system_info_is_null(&amp;cidsi) &amp;&amp;
		    !cid_system_info_compatible(&amp;cidsi,
						pcmap-&gt;CIDSystemInfo + i))
		    return_error(e_rangecheck);
	    }
#endif
	}
    }
    *ppcmap = pcmap;
    return 0;
}

/* ---------------- Operators ---------------- */

/* &lt;CMap&gt; .buildcmap &lt;CMap&gt; */
/*
 * Create the internal form of a CMap.  The initial CMap must be read-write
 * and have an entry with key = CodeMap and value = null; the result is
 * read-only and has a real CodeMap.
 *
 * This operator reads the CMapType, CMapName, CIDSystemInfo, CMapVersion,
 * UIDOffset, XUID, WMode, and .CodeMapData elements of the CMap dictionary.
 * For details, see lib/gs_cmap.ps and the Adobe documentation.
 */
private int
zfcmap_glyph_name(const gs_memory_t *mem, 
		  gs_glyph glyph, gs_const_string *pstr, void *proc_data)
{
    ref nref, nsref;
    int code = 0;

    /*code = */name_index_ref(mem, (uint)glyph, &amp;nref);
    if (code &lt; 0)
	return code;
    name_string_ref(mem, &amp;nref, &amp;nsref);
    pstr-&gt;data = nsref.value.const_bytes;
    pstr-&gt;size = r_size(&amp;nsref);
    return 0;
}
private int
zbuildcmap(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    ref *pcmapname;
    ref *puidoffset;
    ref *pcodemapdata;
    ref *pcodemap;
    ref rname, rcidsi, rcoderanges, rdefs, rnotdefs;
    gs_cmap_adobe1_t *pcmap = 0;
    ref rcmap;
    uint i;

    check_type(*op, t_dictionary);
    check_dict_write(*op);
    if ((code = dict_find_string(op, "CMapName", &amp;pcmapname)) &lt;= 0) {
	code = gs_note_error(e_rangecheck);
	goto fail;
    }
    if (!r_has_type(pcmapname, t_name)) {
	code = gs_note_error(e_typecheck);
	goto fail;
    }
    name_string_ref(imemory, pcmapname, &amp;rname);
    if (dict_find_string(op, ".CodeMapData", &amp;pcodemapdata) &lt;= 0 ||
	!r_has_type(pcodemapdata, t_array) ||
	r_size(pcodemapdata) != 3 ||
	dict_find_string(op, "CodeMap", &amp;pcodemap) &lt;= 0 ||
	!r_has_type(pcodemap, t_null)
	) {
	code = gs_note_error(e_rangecheck);
	goto fail;
    }
    if ((code = acquire_cid_system_info(&amp;rcidsi, op)) &lt; 0)
	goto fail;
    if ((code = gs_cmap_adobe1_alloc(&amp;pcmap, 0, rname.value.const_bytes,
				     r_size(&amp;rname), r_size(&amp;rcidsi),
				     0, 0, 0, 0, 0, imemory)) &lt; 0)
	goto fail;
    if ((code = dict_int_param(op, "CMapType", 0, 1, 0, &amp;pcmap-&gt;CMapType)) &lt; 0 ||
	(code = dict_float_param(op, "CMapVersion", 0.0, &amp;pcmap-&gt;CMapVersion)) &lt; 0 ||
	(code = dict_uid_param(op, &amp;pcmap-&gt;uid, 0, imemory, i_ctx_p)) &lt; 0 ||
	(code = dict_int_param(op, "WMode", 0, 1, 0, &amp;pcmap-&gt;WMode)) &lt; 0
	)
	goto fail;
    if (dict_find_string(op, "UIDOffset", &amp;puidoffset) &gt; 0) {
	if (!r_has_type(puidoffset, t_integer)) {
	    code = gs_note_error(e_typecheck);
	    goto fail;
	}
	pcmap-&gt;UIDOffset = puidoffset-&gt;value.intval; /* long, not int */
    }
    for (i = 0; i &lt; r_size(&amp;rcidsi); ++i) {
        code = get_cid_system_info(imemory, pcmap-&gt;CIDSystemInfo + i, &amp;rcidsi, i);
	if (code &lt; 0)
	    goto fail;
    }
    array_get(imemory, pcodemapdata, 0L, &amp;rcoderanges);
    array_get(imemory, pcodemapdata, 1L, &amp;rdefs);
    array_get(imemory, pcodemapdata, 2L, &amp;rnotdefs);
    if ((code = acquire_code_ranges(pcmap, &amp;rcoderanges, imemory)) &lt; 0)
	goto fail;
    if ((code = acquire_code_map(&amp;pcmap-&gt;def, &amp;rdefs, pcmap, imemory)) &lt; 0)
	goto fail;
    if ((code = acquire_code_map(&amp;pcmap-&gt;notdef, &amp;rnotdefs, pcmap, imemory)) &lt; 0)
	goto fail;
    pcmap-&gt;mark_glyph = zfont_mark_glyph_name;
    pcmap-&gt;mark_glyph_data = 0;
    pcmap-&gt;glyph_name = zfcmap_glyph_name;
    pcmap-&gt;glyph_name_data = 0;
    make_istruct_new(&amp;rcmap, a_readonly, pcmap);
    code = idict_put_string(op, "CodeMap", &amp;rcmap);
    if (code &lt; 0)
	goto fail;
    return zreadonly(i_ctx_p);
fail:
    if (pcmap) {
	free_code_map(&amp;pcmap-&gt;notdef, imemory);
	free_code_map(&amp;pcmap-&gt;def, imemory);
	ifree_object(pcmap-&gt;CIDSystemInfo, "zbuildcmap(CIDSystemInfo)");
	ifree_object(pcmap, "zbuildcmap(cmap)");
    }
    return code;
}

/* ------ Initialization procedure ------ */

const op_def zfcmap_op_defs[] =
{
    {"1.buildcmap", zbuildcmap},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

