<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/src/zmatrix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/src/zmatrix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright (C) 1989, 1995, 1997, 1999 Aladdin Enterprises.  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file LICENSE in this distribution.
  
  For more information about licensing, please refer to
  http://www.ghostscript.com/licensing/. For information on
  commercial licensing, go to http://www.artifex.com/licensing/ or
  contact Artifex Software, Inc., 101 Lucas Valley Road #110,
  San Rafael, CA  94903, U.S.A., +1(415)492-9861.
*/

/* $Id: zmatrix.c,v 1.8 2004/08/04 19:36:13 stefan Exp $ */
/* Matrix operators */
#include "ghost.h"
#include "oper.h"
#include "igstate.h"
#include "gsmatrix.h"
#include "gscoord.h"
#include "store.h"

/* Forward references */
private int common_transform(i_ctx_t *,
		int (*)(gs_state *, floatp, floatp, gs_point *),
		int (*)(floatp, floatp, const gs_matrix *, gs_point *));

/* - initmatrix - */
private int
zinitmatrix(i_ctx_t *i_ctx_p)
{
    return gs_initmatrix(igs);
}

/* &lt;matrix&gt; defaultmatrix &lt;matrix&gt; */
private int
zdefaultmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix mat;

    gs_defaultmatrix(igs, &amp;mat);
    return write_matrix(op, &amp;mat);
}

/* - .currentmatrix &lt;xx&gt; &lt;xy&gt; &lt;yx&gt; &lt;yy&gt; &lt;tx&gt; &lt;ty&gt; */
private int
zcurrentmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix mat;
    int code = gs_currentmatrix(igs, &amp;mat);

    if (code &lt; 0)
	return code;
    push(6);
    code = make_floats(op - 5, &amp;mat.xx, 6);
    if (code &lt; 0)
	pop(6);
    return code;
}

/* &lt;xx&gt; &lt;xy&gt; &lt;yx&gt; &lt;yy&gt; &lt;tx&gt; &lt;ty&gt; .setmatrix - */
private int
zsetmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix mat;
    int code = float_params(op, 6, &amp;mat.xx);

    if (code &lt; 0)
	return code;
    if ((code = gs_setmatrix(igs, &amp;mat)) &lt; 0)
	return code;
    pop(6);
    return 0;
}

/* &lt;matrix|null&gt; .setdefaultmatrix - */
private int
zsetdefaultmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;

    if (r_has_type(op, t_null))
	code = gs_setdefaultmatrix(igs, NULL);
    else {
	gs_matrix mat;

	code = read_matrix(imemory, op, &amp;mat);
	if (code &lt; 0)
	    return code;
	code = gs_setdefaultmatrix(igs, &amp;mat);
    }
    if (code &lt; 0)
	return code;
    pop(1);
    return 0;
}

/* &lt;tx&gt; &lt;ty&gt; translate - */
/* &lt;tx&gt; &lt;ty&gt; &lt;matrix&gt; translate &lt;matrix&gt; */
private int
ztranslate(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    double trans[2];

    if ((code = num_params(op, 2, trans)) &gt;= 0) {
	code = gs_translate(igs, trans[0], trans[1]);
	if (code &lt; 0)
	    return code;
    } else {			/* matrix operand */
	gs_matrix mat;

	/* The num_params failure might be a stack underflow. */
	check_op(2);
	if ((code = num_params(op - 1, 2, trans)) &lt; 0 ||
	    (code = gs_make_translation(trans[0], trans[1], &amp;mat)) &lt; 0 ||
	    (code = write_matrix(op, &amp;mat)) &lt; 0
	    ) {			/* Might be a stack underflow. */
	    check_op(3);
	    return code;
	}
	op[-2] = *op;
    }
    pop(2);
    return code;
}

/* &lt;sx&gt; &lt;sy&gt; scale - */
/* &lt;sx&gt; &lt;sy&gt; &lt;matrix&gt; scale &lt;matrix&gt; */
private int
zscale(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    double scale[2];

    if ((code = num_params(op, 2, scale)) &gt;= 0) {
	code = gs_scale(igs, scale[0], scale[1]);
	if (code &lt; 0)
	    return code;
    } else {			/* matrix operand */
	gs_matrix mat;

	/* The num_params failure might be a stack underflow. */
	check_op(2);
	if ((code = num_params(op - 1, 2, scale)) &lt; 0 ||
	    (code = gs_make_scaling(scale[0], scale[1], &amp;mat)) &lt; 0 ||
	    (code = write_matrix(op, &amp;mat)) &lt; 0
	    ) {			/* Might be a stack underflow. */
	    check_op(3);
	    return code;
	}
	op[-2] = *op;
    }
    pop(2);
    return code;
}

/* &lt;angle&gt; rotate - */
/* &lt;angle&gt; &lt;matrix&gt; rotate &lt;matrix&gt; */
private int
zrotate(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    int code;
    double ang;

    if ((code = real_param(op, &amp;ang)) &gt;= 0) {
	code = gs_rotate(igs, ang);
	if (code &lt; 0)
	    return code;
    } else {			/* matrix operand */
	gs_matrix mat;

	/* The num_params failure might be a stack underflow. */
	check_op(1);
	if ((code = num_params(op - 1, 1, &amp;ang)) &lt; 0 ||
	    (code = gs_make_rotation(ang, &amp;mat)) &lt; 0 ||
	    (code = write_matrix(op, &amp;mat)) &lt; 0
	    ) {			/* Might be a stack underflow. */
	    check_op(2);
	    return code;
	}
	op[-1] = *op;
    }
    pop(1);
    return code;
}

/* &lt;matrix&gt; concat - */
private int
zconcat(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix mat;
    int code = read_matrix(imemory, op, &amp;mat);

    if (code &lt; 0)
	return code;
    code = gs_concat(igs, &amp;mat);
    if (code &lt; 0)
	return code;
    pop(1);
    return 0;
}

/* &lt;matrix1&gt; &lt;matrix2&gt; &lt;matrix&gt; concatmatrix &lt;matrix&gt; */
private int
zconcatmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix m1, m2, mp;
    int code;

    if ((code = read_matrix(imemory, op - 2, &amp;m1)) &lt; 0 ||
	(code = read_matrix(imemory, op - 1, &amp;m2)) &lt; 0 ||
	(code = gs_matrix_multiply(&amp;m1, &amp;m2, &amp;mp)) &lt; 0 ||
	(code = write_matrix(op, &amp;mp)) &lt; 0
	)
	return code;
    op[-2] = *op;
    pop(2);
    return code;
}

/* &lt;x&gt; &lt;y&gt; transform &lt;xt&gt; &lt;yt&gt; */
/* &lt;x&gt; &lt;y&gt; &lt;matrix&gt; transform &lt;xt&gt; &lt;yt&gt; */
private int
ztransform(i_ctx_t *i_ctx_p)
{
    return common_transform(i_ctx_p, gs_transform, gs_point_transform);
}

/* &lt;dx&gt; &lt;dy&gt; dtransform &lt;dxt&gt; &lt;dyt&gt; */
/* &lt;dx&gt; &lt;dy&gt; &lt;matrix&gt; dtransform &lt;dxt&gt; &lt;dyt&gt; */
private int
zdtransform(i_ctx_t *i_ctx_p)
{
    return common_transform(i_ctx_p, gs_dtransform, gs_distance_transform);
}

/* &lt;xt&gt; &lt;yt&gt; itransform &lt;x&gt; &lt;y&gt; */
/* &lt;xt&gt; &lt;yt&gt; &lt;matrix&gt; itransform &lt;x&gt; &lt;y&gt; */
private int
zitransform(i_ctx_t *i_ctx_p)
{
    return common_transform(i_ctx_p, gs_itransform, gs_point_transform_inverse);
}

/* &lt;dxt&gt; &lt;dyt&gt; idtransform &lt;dx&gt; &lt;dy&gt; */
/* &lt;dxt&gt; &lt;dyt&gt; &lt;matrix&gt; idtransform &lt;dx&gt; &lt;dy&gt; */
private int
zidtransform(i_ctx_t *i_ctx_p)
{
    return common_transform(i_ctx_p, gs_idtransform, gs_distance_transform_inverse);
}

/* Common logic for [i][d]transform */
private int
common_transform(i_ctx_t *i_ctx_p,
	int (*ptproc)(gs_state *, floatp, floatp, gs_point *),
	int (*matproc)(floatp, floatp, const gs_matrix *, gs_point *))
{
    os_ptr op = osp;
    double opxy[2];
    gs_point pt;
    int code;

    /* Optimize for the non-matrix case */
    switch (r_type(op)) {
	case t_real:
	    opxy[1] = op-&gt;value.realval;
	    break;
	case t_integer:
	    opxy[1] = op-&gt;value.intval;
	    break;
	case t_array:		/* might be a matrix */
	case t_shortarray:
	case t_mixedarray: {
	    gs_matrix mat;
	    gs_matrix *pmat = &amp;mat;

	    if ((code = read_matrix(imemory, op, pmat)) &lt; 0 ||
		(code = num_params(op - 1, 2, opxy)) &lt; 0 ||
		(code = (*matproc) (opxy[0], opxy[1], pmat, &amp;pt)) &lt; 0
		) {		/* Might be a stack underflow. */
		check_op(3);
		return code;
	    }
	    op--;
	    pop(1);
	    goto out;
	}
	default:
	    return_op_typecheck(op);
    }
    switch (r_type(op - 1)) {
	case t_real:
	    opxy[0] = (op - 1)-&gt;value.realval;
	    break;
	case t_integer:
	    opxy[0] = (op - 1)-&gt;value.intval;
	    break;
	default:
	    return_op_typecheck(op - 1);
    }
    if ((code = (*ptproc) (igs, opxy[0], opxy[1], &amp;pt)) &lt; 0)
	return code;
out:
    make_real(op - 1, pt.x);
    make_real(op, pt.y);
    return 0;
}

/* &lt;matrix&gt; &lt;inv_matrix&gt; invertmatrix &lt;inv_matrix&gt; */
private int
zinvertmatrix(i_ctx_t *i_ctx_p)
{
    os_ptr op = osp;
    gs_matrix m;
    int code;

    if ((code = read_matrix(imemory, op - 1, &amp;m)) &lt; 0 ||
	(code = gs_matrix_invert(&amp;m, &amp;m)) &lt; 0 ||
	(code = write_matrix(op, &amp;m)) &lt; 0
	)
	return code;
    op[-1] = *op;
    pop(1);
    return code;
}

/* ------ Initialization procedure ------ */

const op_def zmatrix_op_defs[] =
{
    {"1concat", zconcat},
    {"2dtransform", zdtransform},
    {"3concatmatrix", zconcatmatrix},
    {"0.currentmatrix", zcurrentmatrix},
    {"1defaultmatrix", zdefaultmatrix},
    {"2idtransform", zidtransform},
    {"0initmatrix", zinitmatrix},
    {"2invertmatrix", zinvertmatrix},
    {"2itransform", zitransform},
    {"1rotate", zrotate},
    {"2scale", zscale},
    {"6.setmatrix", zsetmatrix},
    {"1.setdefaultmatrix", zsetdefaultmatrix},
    {"2transform", ztransform},
    {"2translate", ztranslate},
    op_def_end(0)
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

