<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gs/zlib/inffast.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gs/zlib/inffast.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* inffast.c -- fast decoding
 * Copyright (C) 1995-2004 Mark Adler
 * For conditions of distribution and use, see copyright notice in zlib.h
 */

#include "zutil.h"
#include "inftrees.h"
#include "inflate.h"
#include "inffast.h"

#ifndef ASMINF

/* Allow machine dependent optimization for post-increment or pre-increment.
   Based on testing to date,
   Pre-increment preferred for:
   - PowerPC G3 (Adler)
   - MIPS R5000 (Randers-Pehrson)
   Post-increment preferred for:
   - none
   No measurable difference:
   - Pentium III (Anderson)
   - M68060 (Nikl)
 */
#ifdef POSTINC
#  define OFF 0
#  define PUP(a) *(a)++
#else
#  define OFF 1
#  define PUP(a) *++(a)
#endif

/*
   Decode literal, length, and distance codes and write out the resulting
   literal and match bytes until either not enough input or output is
   available, an end-of-block is encountered, or a data error is encountered.
   When large enough input and output buffers are supplied to inflate(), for
   example, a 16K input buffer and a 64K output buffer, more than 95% of the
   inflate execution time is spent in this routine.

   Entry assumptions:

        state-&gt;mode == LEN
        strm-&gt;avail_in &gt;= 6
        strm-&gt;avail_out &gt;= 258
        start &gt;= strm-&gt;avail_out
        state-&gt;bits &lt; 8

   On return, state-&gt;mode is one of:

        LEN -- ran out of enough output space or enough available input
        TYPE -- reached end of block code, inflate() to interpret next block
        BAD -- error in block data

   Notes:

    - The maximum input bits used by a length/distance pair is 15 bits for the
      length code, 5 bits for the length extra, 15 bits for the distance code,
      and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
      Therefore if strm-&gt;avail_in &gt;= 6, then there is enough input to avoid
      checking for available input while decoding.

    - The maximum bytes that a single length/distance pair can output is 258
      bytes, which is the maximum length that can be coded.  inflate_fast()
      requires strm-&gt;avail_out &gt;= 258 for each loop to avoid checking for
      output space.
 */
void inflate_fast(strm, start)
z_streamp strm;
unsigned start;         /* inflate()'s starting value for strm-&gt;avail_out */
{
    struct inflate_state FAR *state;
    unsigned char FAR *in;      /* local strm-&gt;next_in */
    unsigned char FAR *last;    /* while in &lt; last, enough input available */
    unsigned char FAR *out;     /* local strm-&gt;next_out */
    unsigned char FAR *beg;     /* inflate()'s initial strm-&gt;next_out */
    unsigned char FAR *end;     /* while out &lt; end, enough space available */
    unsigned wsize;             /* window size or zero if not using window */
    unsigned whave;             /* valid bytes in the window */
    unsigned write;             /* window write index */
    unsigned char FAR *window;  /* allocated sliding window, if wsize != 0 */
    unsigned long hold;         /* local strm-&gt;hold */
    unsigned bits;              /* local strm-&gt;bits */
    code const FAR *lcode;      /* local strm-&gt;lencode */
    code const FAR *dcode;      /* local strm-&gt;distcode */
    unsigned lmask;             /* mask for first level of length codes */
    unsigned dmask;             /* mask for first level of distance codes */
    code this;                  /* retrieved table entry */
    unsigned op;                /* code bits, operation, extra bits, or */
                                /*  window position, window bytes to copy */
    unsigned len;               /* match length, unused bytes */
    unsigned dist;              /* match distance */
    unsigned char FAR *from;    /* where to copy match from */

    /* copy state to local variables */
    state = (struct inflate_state FAR *)strm-&gt;state;
    in = strm-&gt;next_in - OFF;
    last = in + (strm-&gt;avail_in - 5);
    out = strm-&gt;next_out - OFF;
    beg = out - (start - strm-&gt;avail_out);
    end = out + (strm-&gt;avail_out - 257);
    wsize = state-&gt;wsize;
    whave = state-&gt;whave;
    write = state-&gt;write;
    window = state-&gt;window;
    hold = state-&gt;hold;
    bits = state-&gt;bits;
    lcode = state-&gt;lencode;
    dcode = state-&gt;distcode;
    lmask = (1U &lt;&lt; state-&gt;lenbits) - 1;
    dmask = (1U &lt;&lt; state-&gt;distbits) - 1;

    /* decode literals and length/distances until end-of-block or not enough
       input data or output space */
    do {
        if (bits &lt; 15) {
            hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
            bits += 8;
            hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
            bits += 8;
        }
        this = lcode[hold &amp; lmask];
      dolen:
        op = (unsigned)(this.bits);
        hold &gt;&gt;= op;
        bits -= op;
        op = (unsigned)(this.op);
        if (op == 0) {                          /* literal */
            Tracevv((stderr, this.val &gt;= 0x20 &amp;&amp; this.val &lt; 0x7f ?
                    "inflate:         literal '%c'\n" :
                    "inflate:         literal 0x%02x\n", this.val));
            PUP(out) = (unsigned char)(this.val);
        }
        else if (op &amp; 16) {                     /* length base */
            len = (unsigned)(this.val);
            op &amp;= 15;                           /* number of extra bits */
            if (op) {
                if (bits &lt; op) {
                    hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
                    bits += 8;
                }
                len += (unsigned)hold &amp; ((1U &lt;&lt; op) - 1);
                hold &gt;&gt;= op;
                bits -= op;
            }
            Tracevv((stderr, "inflate:         length %u\n", len));
            if (bits &lt; 15) {
                hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
                bits += 8;
                hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
                bits += 8;
            }
            this = dcode[hold &amp; dmask];
          dodist:
            op = (unsigned)(this.bits);
            hold &gt;&gt;= op;
            bits -= op;
            op = (unsigned)(this.op);
            if (op &amp; 16) {                      /* distance base */
                dist = (unsigned)(this.val);
                op &amp;= 15;                       /* number of extra bits */
                if (bits &lt; op) {
                    hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
                    bits += 8;
                    if (bits &lt; op) {
                        hold += (unsigned long)(PUP(in)) &lt;&lt; bits;
                        bits += 8;
                    }
                }
                dist += (unsigned)hold &amp; ((1U &lt;&lt; op) - 1);
                hold &gt;&gt;= op;
                bits -= op;
                Tracevv((stderr, "inflate:         distance %u\n", dist));
                op = (unsigned)(out - beg);     /* max distance in output */
                if (dist &gt; op) {                /* see if copy from window */
                    op = dist - op;             /* distance back in window */
                    if (op &gt; whave) {
                        strm-&gt;msg = (char *)"invalid distance too far back";
                        state-&gt;mode = BAD;
                        break;
                    }
                    from = window - OFF;
                    if (write == 0) {           /* very common case */
                        from += wsize - op;
                        if (op &lt; len) {         /* some from window */
                            len -= op;
                            do {
                                PUP(out) = PUP(from);
                            } while (--op);
                            from = out - dist;  /* rest from output */
                        }
                    }
                    else if (write &lt; op) {      /* wrap around window */
                        from += wsize + write - op;
                        op -= write;
                        if (op &lt; len) {         /* some from end of window */
                            len -= op;
                            do {
                                PUP(out) = PUP(from);
                            } while (--op);
                            from = window - OFF;
                            if (write &lt; len) {  /* some from start of window */
                                op = write;
                                len -= op;
                                do {
                                    PUP(out) = PUP(from);
                                } while (--op);
                                from = out - dist;      /* rest from output */
                            }
                        }
                    }
                    else {                      /* contiguous in window */
                        from += write - op;
                        if (op &lt; len) {         /* some from window */
                            len -= op;
                            do {
                                PUP(out) = PUP(from);
                            } while (--op);
                            from = out - dist;  /* rest from output */
                        }
                    }
                    while (len &gt; 2) {
                        PUP(out) = PUP(from);
                        PUP(out) = PUP(from);
                        PUP(out) = PUP(from);
                        len -= 3;
                    }
                    if (len) {
                        PUP(out) = PUP(from);
                        if (len &gt; 1)
                            PUP(out) = PUP(from);
                    }
                }
                else {
                    from = out - dist;          /* copy direct from output */
                    do {                        /* minimum length is three */
                        PUP(out) = PUP(from);
                        PUP(out) = PUP(from);
                        PUP(out) = PUP(from);
                        len -= 3;
                    } while (len &gt; 2);
                    if (len) {
                        PUP(out) = PUP(from);
                        if (len &gt; 1)
                            PUP(out) = PUP(from);
                    }
                }
            }
            else if ((op &amp; 64) == 0) {          /* 2nd level distance code */
                this = dcode[this.val + (hold &amp; ((1U &lt;&lt; op) - 1))];
                goto dodist;
            }
            else {
                strm-&gt;msg = (char *)"invalid distance code";
                state-&gt;mode = BAD;
                break;
            }
        }
        else if ((op &amp; 64) == 0) {              /* 2nd level length code */
            this = lcode[this.val + (hold &amp; ((1U &lt;&lt; op) - 1))];
            goto dolen;
        }
        else if (op &amp; 32) {                     /* end-of-block */
            Tracevv((stderr, "inflate:         end of block\n"));
            state-&gt;mode = TYPE;
            break;
        }
        else {
            strm-&gt;msg = (char *)"invalid literal/length code";
            state-&gt;mode = BAD;
            break;
        }
    } while (in &lt; last &amp;&amp; out &lt; end);

    /* return unused bytes (on entry, bits &lt; 8, so in won't go too far back) */
    len = bits &gt;&gt; 3;
    in -= len;
    bits -= len &lt;&lt; 3;
    hold &amp;= (1U &lt;&lt; bits) - 1;

    /* update state and return */
    strm-&gt;next_in = in + OFF;
    strm-&gt;next_out = out + OFF;
    strm-&gt;avail_in = (unsigned)(in &lt; last ? 5 + (last - in) : 5 - (in - last));
    strm-&gt;avail_out = (unsigned)(out &lt; end ?
                                 257 + (end - out) : 257 - (out - end));
    state-&gt;hold = hold;
    state-&gt;bits = bits;
    return;
}

/*
   inflate_fast() speedups that turned out slower (on a PowerPC G3 750CXe):
   - Using bit fields for code structure
   - Different op definition to avoid &amp; for extra bits (do &amp; for table bits)
   - Three separate decoding do-loops for direct, window, and write == 0
   - Special case for distance &gt; 1 copies to do overlapped load and store copy
   - Explicit branch predictions (based on measured branch probabilities)
   - Deferring match copy and interspersed it with decoding subsequent codes
   - Swapping literal/length else
   - Swapping window/direct else
   - Larger unrolled copy loops (three is about right)
   - Moving len -= 3 statement into middle of loop
 */

#endif /* !ASMINF */
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

