<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/gzip/zip.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/gzip/zip.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;flate.h&gt;
#include "zip.h"

enum
{
	HeadAlloc	= 64,
};

static	void	zip(Biobuf *bout, char *file, int stdout);
static	void	zipDir(Biobuf *bout, int fd, ZipHead *zh, int stdout);
static	int	crcread(void *fd, void *buf, int n);
static	int	zwrite(void *bout, void *buf, int n);
static	void	put4(Biobuf *b, ulong v);
static	void	put2(Biobuf *b, int v);
static	void	put1(Biobuf *b, int v);
static	void	header(Biobuf *bout, ZipHead *zh);
static	void	trailer(Biobuf *bout, ZipHead *zh, vlong off);
static	void	putCDir(Biobuf *bout);

static	void	error(char*, ...);
#pragma	varargck	argpos	error	1

static	Biobuf	bout;
static	ulong	crc;
static	ulong	*crctab;
static	int	debug;
static	int	eof;
static	int	level;
static	int	nzheads;
static	ulong	totr;
static	ulong	totw;
static	int	verbose;
static	int	zhalloc;
static	ZipHead	*zheads;
static	jmp_buf	zjmp;

void
usage(void)
{
	fprint(2, "usage: zip [-vD] [-1-9] [-f zipfile] file ...\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	char *zfile;
	int i, fd, err;

	zfile = nil;
	level = 6;
	ARGBEGIN{
	case 'D':
		debug++;
		break;
	case 'f':
		zfile = ARGF();
		if(zfile == nil)
			usage();
		break;
	case 'v':
		verbose++;
		break;
	case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
		level = ARGC() - '0';
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc == 0)
		usage();

	crctab = mkcrctab(ZCrcPoly);
	err = deflateinit();
	if(err != FlateOk)
		sysfatal("deflateinit failed: %s", flateerr(err));

	if(zfile == nil)
		fd = 1;
	else{
		fd = create(zfile, OWRITE, 0664);
		if(fd &lt; 0)
			sysfatal("can't create %s: %r", zfile);
	}
	Binit(&amp;bout, fd, OWRITE);

	if(setjmp(zjmp)){
		if(zfile != nil){
			fprint(2, "zip: removing output file %s\n", zfile);
			remove(zfile);
		}
		exits("errors");
	}

	for(i = 0; i &lt; argc; i++)
		zip(&amp;bout, argv[i], zfile == nil);

	putCDir(&amp;bout);

	exits(nil);
}

static void
zip(Biobuf *bout, char *file, int stdout)
{
	Tm *t;
	ZipHead *zh;
	Dir *dir;
	vlong off;
	int fd, err;

	fd = open(file, OREAD);
	if(fd &lt; 0)
		error("can't open %s: %r", file);
	dir = dirfstat(fd);
	if(dir == nil)
		error("can't stat %s: %r", file);

	/*
	 * create the header
	 */
	if(nzheads &gt;= zhalloc){
		zhalloc += HeadAlloc;
		zheads = realloc(zheads, zhalloc * sizeof(ZipHead));
		if(zheads == nil)
			error("out of memory");
	}
	zh = &amp;zheads[nzheads++];
	zh-&gt;madeos = ZDos;
	zh-&gt;madevers = (2 * 10) + 0;
	zh-&gt;extos = ZDos;
	zh-&gt;extvers = (2 * 10) + 0;
	
	t = localtime(dir-&gt;mtime);
	zh-&gt;modtime = (t-&gt;hour&lt;&lt;11) | (t-&gt;min&lt;&lt;5) | (t-&gt;sec&gt;&gt;1);
	zh-&gt;moddate = ((t-&gt;year-80)&lt;&lt;9) | ((t-&gt;mon+1)&lt;&lt;5) | t-&gt;mday;

	zh-&gt;flags = 0;
	zh-&gt;crc = 0;
	zh-&gt;csize = 0;
	zh-&gt;uncsize = 0;
	zh-&gt;file = strdup(file);
	if(zh-&gt;file == nil)
		error("out of memory");
	zh-&gt;iattr = 0;
	zh-&gt;eattr = ZDArch;
	if((dir-&gt;mode &amp; 0700) == 0)
		zh-&gt;eattr |= ZDROnly;
	zh-&gt;off = Boffset(bout);

	if(dir-&gt;mode &amp; DMDIR){
		zh-&gt;eattr |= ZDDir;
		zh-&gt;meth = 0;
		zipDir(bout, fd, zh, stdout);
	}else{
		zh-&gt;meth = 8;
		if(stdout)
			zh-&gt;flags |= ZTrailInfo;
		off = Boffset(bout);
		header(bout, zh);

		crc = 0;
		eof = 0;
		totr = 0;
		totw = 0;
		err = deflate(bout, zwrite, (void*)fd, crcread, level, debug);
		if(err != FlateOk)
			error("deflate failed: %s: %r", flateerr(err));

		zh-&gt;csize = totw;
		zh-&gt;uncsize = totr;
		zh-&gt;crc = crc;
		trailer(bout, zh, off);
	}
	close(fd);
	free(dir);
}

static void
zipDir(Biobuf *bout, int fd, ZipHead *zh, int stdout)
{
	Dir *dirs;
	char *file, *pfile;
	int i, nf, nd;

	nf = strlen(zh-&gt;file) + 1;
	if(strcmp(zh-&gt;file, ".") == 0){
		nzheads--;
		free(zh-&gt;file);
		pfile = "";
		nf = 1;
	}else{
		nf++;
		pfile = malloc(nf);
		if(pfile == nil)
			error("out of memory");
		snprint(pfile, nf, "%s/", zh-&gt;file);
		free(zh-&gt;file);
		zh-&gt;file = pfile;
		header(bout, zh);
	}

	nf += 256;	/* plenty of room */
	file = malloc(nf);
	if(file == nil)
		error("out of memory");
	while((nd = dirread(fd, &amp;dirs)) &gt; 0){
		for(i = 0; i &lt; nd; i++){
			snprint(file, nf, "%s%s", pfile, dirs[i].name);
			zip(bout, file, stdout);
		}
		free(dirs);
	}
}

static void
header(Biobuf *bout, ZipHead *zh)
{
	int flen;

	if(verbose)
		fprint(2, "adding %s\n", zh-&gt;file);
	put4(bout, ZHeader);
	put1(bout, zh-&gt;extvers);
	put1(bout, zh-&gt;extos);
	put2(bout, zh-&gt;flags);
	put2(bout, zh-&gt;meth);
	put2(bout, zh-&gt;modtime);
	put2(bout, zh-&gt;moddate);
	put4(bout, zh-&gt;crc);
	put4(bout, zh-&gt;csize);
	put4(bout, zh-&gt;uncsize);
	flen = strlen(zh-&gt;file);
	put2(bout, flen);
	put2(bout, 0);
	if(Bwrite(bout, zh-&gt;file, flen) != flen)
		error("write error");
}

static void
trailer(Biobuf *bout, ZipHead *zh, vlong off)
{
	vlong coff;

	coff = -1;
	if(!(zh-&gt;flags &amp; ZTrailInfo)){
		coff = Boffset(bout);
		if(Bseek(bout, off + ZHeadCrc, 0) &lt; 0)
			error("can't seek in archive");
	}
	put4(bout, zh-&gt;crc);
	put4(bout, zh-&gt;csize);
	put4(bout, zh-&gt;uncsize);
	if(!(zh-&gt;flags &amp; ZTrailInfo)){
		if(Bseek(bout, coff, 0) &lt; 0)
			error("can't seek in archive");
	}
}

static void
cheader(Biobuf *bout, ZipHead *zh)
{
	int flen;

	put4(bout, ZCHeader);
	put1(bout, zh-&gt;madevers);
	put1(bout, zh-&gt;madeos);
	put1(bout, zh-&gt;extvers);
	put1(bout, zh-&gt;extos);
	put2(bout, zh-&gt;flags &amp; ~ZTrailInfo);
	put2(bout, zh-&gt;meth);
	put2(bout, zh-&gt;modtime);
	put2(bout, zh-&gt;moddate);
	put4(bout, zh-&gt;crc);
	put4(bout, zh-&gt;csize);
	put4(bout, zh-&gt;uncsize);
	flen = strlen(zh-&gt;file);
	put2(bout, flen);
	put2(bout, 0);
	put2(bout, 0);
	put2(bout, 0);
	put2(bout, zh-&gt;iattr);
	put4(bout, zh-&gt;eattr);
	put4(bout, zh-&gt;off);
	if(Bwrite(bout, zh-&gt;file, flen) != flen)
		error("write error");
}

static void
putCDir(Biobuf *bout)
{
	vlong hoff, ecoff;
	int i;

	hoff = Boffset(bout);

	for(i = 0; i &lt; nzheads; i++)
		cheader(bout, &amp;zheads[i]);

	ecoff = Boffset(bout);

	if(nzheads &gt;= (1 &lt;&lt; 16))
		error("too many entries in zip file: max %d", (1 &lt;&lt; 16) - 1);
	put4(bout, ZECHeader);
	put2(bout, 0);
	put2(bout, 0);
	put2(bout, nzheads);
	put2(bout, nzheads);
	put4(bout, ecoff - hoff);
	put4(bout, hoff);
	put2(bout, 0);
}

static int
crcread(void *fd, void *buf, int n)
{
	int nr, m;

	nr = 0;
	for(; !eof &amp;&amp; n &gt; 0; n -= m){
		m = read((int)(uintptr)fd, (char*)buf+nr, n);
		if(m &lt;= 0){
			eof = 1;
			if(m &lt; 0)
{
fprint(2, "input error %r\n");
				return -1;
}
			break;
		}
		nr += m;
	}
	crc = blockcrc(crctab, crc, buf, nr);
	totr += nr;
	return nr;
}

static int
zwrite(void *bout, void *buf, int n)
{
	if(n != Bwrite(bout, buf, n)){
		eof = 1;
		return -1;
	}
	totw += n;
	return n;
}

static void
put4(Biobuf *b, ulong v)
{
	int i;

	for(i = 0; i &lt; 4; i++){
		if(Bputc(b, v) &lt; 0)
			error("write error");
		v &gt;&gt;= 8;
	}
}

static void
put2(Biobuf *b, int v)
{
	int i;

	for(i = 0; i &lt; 2; i++){
		if(Bputc(b, v) &lt; 0)
			error("write error");
		v &gt;&gt;= 8;
	}
}

static void
put1(Biobuf *b, int v)
{
	if(Bputc(b, v)&lt; 0)
		error("unexpected eof reading file information");
}

static void
error(char *fmt, ...)
{
	va_list arg;

	fprint(2, "zip: ");
	va_start(arg, fmt);
	vfprint(2, fmt, arg);
	va_end(arg);
	fprint(2, "\n");

	longjmp(zjmp, 1);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

