<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/history.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/history.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;

#define	MINUTE(x)	((long)(x)*60L)
#define	HOUR(x)		(MINUTE(x)*60L)
#define	YEAR(x)		(HOUR(x)*24L*360L)

int	verb;
int	uflag;
int	force;
int	diff;
char*	sflag;
char*	dargv[20] = {
	"diff",
};
int	ndargv = 1;

void	usage(void);
void	ysearch(char*, char*);
long	starttime(char*);
void	lastbefore(ulong, char*, char*, char*);
char*	prtime(ulong);
void	darg(char*);

void
main(int argc, char *argv[])
{
	int i;
	char *ndump;

	ndump = nil;
	ARGBEGIN {
	default:
		usage();
	case 'a':
		darg("-a");
		break;
	case 'b':
		darg("-b");
		break;
	case 'c':
		darg("-c");
		break;
	case 'e':
		darg("-e");
		break;
	case 'm':
		darg("-m");
		break;
	case 'n':
		darg("-n");
		break;
	case 'w':
		darg("-w");
		break;
	case 'D':
		diff = 1;
		break;
	case 'd':
		ndump = ARGF();
		break;
	case 'f':
		force = 1;
		break;
	case 's':
		sflag = ARGF();
		break;
	case 'u':
		uflag = 1;
		break;
	case 'v':
		verb = 1;
		break;
	} ARGEND

	if(argc == 0)
		usage();

	for(i=0; i&lt;argc; i++)
		ysearch(argv[i], ndump);
	exits(0);
}

void
darg(char* a)
{
	if(ndargv &gt;= nelem(dargv)-3)
		return;
	dargv[ndargv++] = a;
}

void
usage(void)
{
	fprint(2, "usage: history [-bDfuv] [-d dumpfilesystem] [-s yyyymmdd] files\n");
	exits("usage");
}

void
ysearch(char *file, char *ndump)
{
	char fil[400], buf[500], nbuf[100], pair[2][500], *p;
	Tm *tm;
	Waitmsg *w;
	Dir *dir, *d;
	ulong otime, dt;
	int toggle, started, missing;

	fil[0] = 0;
	if(file[0] != '/') {
		getwd(strchr(fil, 0), 100);
		strcat(fil, "/");
	}
	strcat(fil, file);
	if(memcmp(fil, "/n/", 3) == 0){
		p = strchr(fil+3, '/');
		if(p == nil)
			p = fil+strlen(fil);
		if(ndump == nil){
			if(p-fil &gt;= sizeof nbuf-10){
				fprint(2, "%s: dump name too long", fil);
				return;
			}
			memmove(nbuf, fil+3, p-(fil+3));
			nbuf[p-(fil+3)] = 0;
			strcat(nbuf, "dump");
			ndump = nbuf;
		}
		memmove(fil, p, strlen(p)+1);
	}
	if(ndump == nil)
		ndump = "dump";

	tm = localtime(time(0));
	snprint(buf, sizeof buf, "/n/%s/%.4d/", ndump, tm-&gt;year+1900);
	if(access(buf, AREAD) &lt; 0) {
		if(verb)
			print("mounting dump %s\n", ndump);
		if(rfork(RFFDG|RFPROC) == 0) {
			execl("/bin/rc", "rc", "9fs", ndump, nil);
			exits(0);
		}
		w = wait();
		if(w == nil){
			fprint(2, "history: wait error: %r\n");
			exits("wait");
		}
		if(w-&gt;msg[0] != '\0'){
			fprint(2, "9fs failed: %s\n", w-&gt;msg);
			exits(w-&gt;msg);
		}
		free(w);
	}

	started = 0;
	dir = dirstat(file);
	if(dir == nil)
		fprint(2, "history: warning: %s does not exist\n", file);
	else{
		print("%s %s %lld [%s]\n", prtime(dir-&gt;mtime), file, dir-&gt;length, dir-&gt;muid);
		started = 1;
		strecpy(pair[1], pair[1]+sizeof pair[1], file);
	}
	free(dir);
	otime = starttime(sflag);
	toggle = 0;
	for(;;) {
		lastbefore(otime, fil, buf, ndump);
		dir = dirstat(buf);
		if(dir == nil) {
			if(!force)
				return;
			dir = malloc(sizeof(Dir));
			nulldir(dir);
			dir-&gt;mtime = otime + 1;
		}
		dt = HOUR(12);
		missing = 0;
		while(otime &lt;= dir-&gt;mtime){
			if(verb)
				print("backup %ld, %ld\n", dir-&gt;mtime, otime-dt);
			lastbefore(otime-dt, fil, buf, ndump);
			d = dirstat(buf);
			if(d == nil){
				if(!force)
					return;
				if(!missing)
					print("removed %s\n", buf);
				missing = 1;
			}else{
				free(dir);
				dir = d;
			}
			dt += HOUR(12);
		}
		strcpy(pair[toggle], buf);
		if(diff &amp;&amp; started){
			switch(rfork(RFFDG|RFPROC)){
			case 0:
				dargv[ndargv] = pair[toggle];
				dargv[ndargv+1] = pair[toggle ^ 1];
				exec("/bin/diff", dargv);
				fprint(2, "can't exec diff: %r\n");
				exits(0);
			case -1:
				fprint(2, "can't fork diff: %r\n");
				break;
			default:
				while(waitpid() != -1)
					;
				break;
			}
		}
		print("%s %s %lld [%s]\n", prtime(dir-&gt;mtime), buf, dir-&gt;length, dir-&gt;muid);
		toggle ^= 1;
		started = 1;
		otime = dir-&gt;mtime;
		free(dir);
	}
}

void
lastbefore(ulong t, char *f, char *b, char *ndump)
{
	Tm *tm;
	Dir *dir;
	int vers, try;
	ulong t0, mtime;
	int i, n, fd;

	t0 = t;
	if(verb)
		print("%ld lastbefore %s\n", t0, f);
	mtime = 0;
	for(try=0; try&lt;30; try++) {
		tm = localtime(t);
		sprint(b, "/n/%s/%.4d/%.2d%.2d", ndump,
			tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday);
		dir = dirstat(b);
		if(dir){
			mtime = dir-&gt;mtime;
			free(dir);
		}
		if(dir==nil || mtime &gt; t0) {
			if(verb)
				print("%ld earlier %s\n", mtime, b);
			t -= HOUR(24);
			continue;
		}
		if(strstr(ndump, "snap")){
			fd = open(b, OREAD);
			if(fd &lt; 0)
				continue;
			n = dirreadall(fd, &amp;dir);
			close(fd);
			if(n == 0)
				continue;
			for(i = n-1; i &gt; 0; i--){
				if(dir[i].mtime &gt; t0)
					break;
			}
			sprint(b, "/n/%s/%.4d/%.2d%.2d/%s%s", ndump,
				tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday, dir[i].name, f);
			free(dir);
		} else {
			for(vers=0;; vers++) {
				sprint(b, "/n/%s/%.4d/%.2d%.2d%d", ndump,
					tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday, vers+1);
				dir = dirstat(b);
				if(dir){
					mtime = dir-&gt;mtime;
					free(dir);
				}
				if(dir==nil || mtime &gt; t0)
					break;
				if(verb)
					print("%ld later %s\n", mtime, b);
			}
			sprint(b, "/n/%s/%.4d/%.2d%.2d%s", ndump,
				tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday, f);
			if(vers)
				sprint(b, "/n/%s/%.4d/%.2d%.2d%d%s", ndump,
					tm-&gt;year+1900, tm-&gt;mon+1, tm-&gt;mday, vers, f);
		}
		return;
	}
	strcpy(b, "XXX");	/* error */
}

char*
prtime(ulong t)
{
	static char buf[100];
	char *b;
	Tm *tm;

	if(uflag)
		tm = gmtime(t);
	else
		tm = localtime(t);
	b = asctime(tm);
	memcpy(buf, b+4, 24);
	buf[24] = 0;
	return buf;
}

long
starttime(char *s)
{
	Tm *tm;
	long t, dt;
	int i, yr, mo, da;

	t = time(0);
	if(s == 0)
		return t;
	for(i=0; s[i]; i++)
		if(s[i] &lt; '0' || s[i] &gt; '9') {
			fprint(2, "bad start time: %s\n", s);
			return t;
		}
	if(strlen(s)==6){
		yr = (s[0]-'0')*10 + s[1]-'0';
		mo = (s[2]-'0')*10 + s[3]-'0' - 1;
		da = (s[4]-'0')*10 + s[5]-'0';
		if(yr &lt; 70)
			yr += 100;
	}else if(strlen(s)==8){
		yr = (((s[0]-'0')*10 + s[1]-'0')*10 + s[2]-'0')*10 + s[3]-'0';
		yr -= 1900;
		mo = (s[4]-'0')*10 + s[5]-'0' - 1;
		da = (s[6]-'0')*10 + s[7]-'0';
	}else{
		fprint(2, "bad start time: %s\n", s);
		return t;
	}
	t = 0;
	dt = YEAR(10);
	for(i=0; i&lt;50; i++) {
		tm = localtime(t+dt);
		if(yr &gt; tm-&gt;year ||
		  (yr == tm-&gt;year &amp;&amp; mo &gt; tm-&gt;mon) ||
		  (yr == tm-&gt;year &amp;&amp; mo == tm-&gt;mon) &amp;&amp; da &gt; tm-&gt;mday) {
			t += dt;
			continue;
		}
		dt /= 2;
		if(dt == 0)
			break;
	}
	t += HOUR(12);	/* .5 day to get to noon of argument */
	return t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

