<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/htmlroff/input.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/htmlroff/input.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Read input files.
 */
#include "a.h"

typedef struct Istack Istack;
struct Istack
{
	Rune unget[3];
	int nunget;
	Biobuf *b;
	Rune *p;
	Rune *ep;
	Rune *s;
	int lineno;
	Rune *name;
	Istack *next;
	void (*fn)(void);
};

Istack *istack;
Istack *ibottom;

static void
setname(void)
{
	Rune *r, *p;

	if(istack == nil || istack-&gt;name == nil)
		return;
	_nr(L(".F"), istack-&gt;name);
	r = erunestrdup(istack-&gt;name);
	p = runestrchr(r, '.');
	if(p)
		*p = 0;
	_nr(L(".B"), r);
	free(r);
}

static void
ipush(Istack *is)
{
	if(istack == nil)
		ibottom = is;
	else
		is-&gt;next = istack;
	istack = is;
	setname();
}

static void
iqueue(Istack *is)
{
	if(ibottom == nil){
		istack = is;
		setname();
	}else
		ibottom-&gt;next = is;
	ibottom = is;
}

int
_inputfile(Rune *s, void (*push)(Istack*))
{
	Istack *is;
	Biobuf *b;
	char *t;
	
	t = esmprint("%S", s);
	if((b = Bopen(t, OREAD)) == nil){
		free(t);
		fprint(2, "%s: open %S: %r\n", argv0, s);
		return -1;
	}
	free(t);
	is = emalloc(sizeof *is);
	is-&gt;b = b;
	is-&gt;name = erunestrdup(s);
	is-&gt;lineno = 1;
	push(is);
	return 0;
}

int
pushinputfile(Rune *s)
{
	return _inputfile(s, ipush);
}

int
queueinputfile(Rune *s)
{
	return _inputfile(s, iqueue);
}

int
_inputstdin(void (*push)(Istack*))
{	
	Biobuf *b;
	Istack *is;

	if((b = Bopen("/dev/null", OREAD)) == nil){
		fprint(2, "%s: open /dev/null: %r\n", argv0);
		return -1;
	}
	dup(0, b-&gt;fid);
	is = emalloc(sizeof *is);
	is-&gt;b = b;
	is-&gt;name = erunestrdup(L("stdin"));
	is-&gt;lineno = 1;
	push(is);
	return 0;
}

int
pushstdin(void)
{
	return _inputstdin(ipush);
}

int
queuestdin(void)
{
	return _inputstdin(iqueue);
}

void
_inputstring(Rune *s, void (*push)(Istack*))
{
	Istack *is;
	
	is = emalloc(sizeof *is);
	is-&gt;s = erunestrdup(s);
	is-&gt;p = is-&gt;s;
	is-&gt;ep = is-&gt;p+runestrlen(is-&gt;p);
	push(is);
}

void
pushinputstring(Rune *s)
{
	_inputstring(s, ipush);
}


void
inputnotify(void (*fn)(void))
{
	if(istack)
		istack-&gt;fn = fn;
}

int
popinput(void)
{
	Istack *is;

	is = istack;
	if(is == nil)
		return 0;

	istack = istack-&gt;next;
	if(is-&gt;b)
		Bterm(is-&gt;b);
	free(is-&gt;s);
	free(is-&gt;name);
	if(is-&gt;fn)
		is-&gt;fn();
	free(is);
	setname();
	return 1;
}

int
getrune(void)
{
	Rune r;
	int c;
	
top:
	if(istack == nil)
		return -1;
	if(istack-&gt;nunget)
		return istack-&gt;unget[--istack-&gt;nunget];
	else if(istack-&gt;p){
		if(istack-&gt;p &gt;= istack-&gt;ep){
			popinput();
			goto top;
		}
		r = *istack-&gt;p++;
	}else if(istack-&gt;b){
		if((c = Bgetrune(istack-&gt;b)) &lt; 0){
			popinput();
			goto top;
		}
		r = c;
	}else{
		r = 0;
		sysfatal("getrune - can't happen");
	}
	if(r == '\n')
		istack-&gt;lineno++;	
	return r;
}

void
ungetrune(Rune r)
{
	if(istack == nil || istack-&gt;nunget &gt;= nelem(istack-&gt;unget))
		pushinputstring(L(""));
	istack-&gt;unget[istack-&gt;nunget++] = r;
}

int
linefmt(Fmt *f)
{
	Istack *is;
	
	for(is=istack; is &amp;&amp; !is-&gt;b; is=is-&gt;next)
		;
	if(is)
		return fmtprint(f, "%S:%d", is-&gt;name, is-&gt;lineno);
	else
		return fmtprint(f, "&lt;no input&gt;");
}

void
setlinenumber(Rune *s, int n)
{
	Istack *is;
	
	for(is=istack; is &amp;&amp; !is-&gt;name; is=is-&gt;next)
		;
	if(is){
		if(s){
			free(is-&gt;name);
			is-&gt;name = erunestrdup(s);
		}
		is-&gt;lineno = n;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

