<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/htmlroff/t19.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/htmlroff/t19.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "a.h"

/*
 * 19. Input/output file switching.
 */

/* .so - push new source file */
void
r_so(int argc, Rune **argv)
{
	USED(argc);
	pushinputfile(argv[1]);
}

/* .nx - end this file, switch to arg */
void
r_nx(int argc, Rune **argv)
{
	int n;
	
	if(argc == 1){
		while(popinput())
			;
	}else{
		if(argc &gt; 2)
			warn("too many arguments for .nx");
		while((n=popinput()) &amp;&amp; n != 2)
			;
		pushinputfile(argv[1]);
	}
}

/* .sy - system: run string */
void
r_sy(Rune *name)
{
	USED(name);
	warn(".sy not implemented");
}

/* .pi - pipe output to string */
void
r_pi(Rune *name)
{
	USED(name);
	warn(".pi not implemented");
}

/* .cf - copy contents of filename to output */
void
r_cf(int argc, Rune **argv)
{
	int c;
	char *p;
	Biobuf *b;

	USED(argc);
	p = esmprint("%S", argv[1]);
	if((b = Bopen(p, OREAD)) == nil){
		fprint(2, "%L: open %s: %r\n", p);
		free(p);
		return;
	}
	free(p);

	while((c = Bgetrune(b)) &gt;= 0)
		outrune(c);
	Bterm(b);
}

void
r_inputpipe(Rune *name)
{
	Rune *cmd, *stop, *line;
	int n, pid, p[2], len;
	Waitmsg *w;
	
	USED(name);
	if(pipe(p) &lt; 0){
		warn("pipe: %r");
		return;
	}
	stop = copyarg();
	cmd = readline(CopyMode);
	pid = fork();
	switch(pid){
	case 0:
		if(p[0] != 0){
			dup(p[0], 0);
			close(p[0]);
		}
		close(p[1]);
		execl("/bin/rc", "rc", "-c", esmprint("%S", cmd), nil);
		warn("%Cdp %S: %r", dot, cmd);
		_exits(nil);
	case -1:
		warn("fork: %r");
	default:
		close(p[0]);
		len = runestrlen(stop);
		fprint(p[1], ".ps %d\n", getnr(L(".s")));
		fprint(p[1], ".vs %du\n", getnr(L(".v")));
		fprint(p[1], ".ft %d\n", getnr(L(".f")));
		fprint(p[1], ".ll 8i\n");
		fprint(p[1], ".pl 30i\n");
		while((line = readline(~0)) != nil){
			if(runestrncmp(line, stop, len) == 0 
			&amp;&amp; (line[len]==' ' || line[len]==0 || line[len]=='\t'
				|| (line[len]=='\\' &amp;&amp; line[len+1]=='}')))
				break;
			n = runestrlen(line);
			line[n] = '\n';
			fprint(p[1], "%.*S", n+1, line);
			free(line);
		}
		free(stop);
		close(p[1]);
		w = wait();
		if(w == nil){
			warn("wait: %r");
			return;
		}
		if(w-&gt;msg[0])
			sysfatal("%C%S %S: %s", dot, name, cmd, w-&gt;msg);
		free(cmd);
		free(w);
	}
}	

void
t19init(void)
{
	addreq(L("so"), r_so, 1);
	addreq(L("nx"), r_nx, -1);
	addraw(L("sy"), r_sy);
	addraw(L("inputpipe"), r_inputpipe);
	addraw(L("pi"), r_pi);
	addreq(L("cf"), r_cf, 1);
	
	nr(L("$$"), getpid());
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

