<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/htmlroff/t7.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/htmlroff/t7.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * 7.  Macros, strings, diversion, and position traps.
 *
 * 	macros can override builtins
 *	builtins can be renamed or removed!
 */

#include "a.h"

enum
{
	MAXARG = 10,
	MAXMSTACK = 40
};

/* macro invocation frame */
typedef struct Mac Mac;
struct Mac
{
	int argc;
	Rune *argv[MAXARG];
};

Mac		mstack[MAXMSTACK];
int		nmstack;
void		emitdi(void);
void		flushdi(void);

/*
 * Run a user-defined macro.
 */
void popmacro(void);
int
runmacro(int dot, int argc, Rune **argv)
{
	Rune *p;
	int i;
	Mac *m;
	
if(verbose &amp;&amp; isupperrune(argv[0][0])) fprint(2, "run: %S\n", argv[0]);
	p = getds(argv[0]);
	if(p == nil){
		if(verbose)
			warn("ignoring unknown request %C%S", dot, argv[0]);
		if(verbose &gt; 1){
			for(i=0; i&lt;argc; i++)
				fprint(2, " %S", argv[i]);
			fprint(2, "\n");
		}
		return -1;
	}
	if(nmstack &gt;= nelem(mstack)){
		fprint(2, "%L: macro stack overflow:");
		for(i=0; i&lt;nmstack; i++)
			fprint(2, " %S", mstack[i].argv[0]);
		fprint(2, "\n");
		return -1;
	}
	m = &amp;mstack[nmstack++];
	m-&gt;argc = argc;
	for(i=0; i&lt;argc; i++)
		m-&gt;argv[i] = erunestrdup(argv[i]);
	pushinputstring(p);
	nr(L(".$"), argc-1);
	inputnotify(popmacro);
	return 0;
}

void
popmacro(void)
{
	int i;
	Mac *m;
	
	if(--nmstack &lt; 0){
		fprint(2, "%L: macro stack underflow\n");
		return;
	}
	m = &amp;mstack[nmstack];
	for(i=0; i&lt;m-&gt;argc; i++)
		free(m-&gt;argv[i]);
	if(nmstack &gt; 0)
		nr(L(".$"), mstack[nmstack-1].argc-1);
	else
		nr(L(".$"), 0);
}

void popmacro1(void);
jmp_buf runjb[10];
int nrunjb;

void
runmacro1(Rune *name)
{
	Rune *argv[2];
	int obol;
	
if(verbose) fprint(2, "outcb %p\n", outcb);
	obol = bol;
	argv[0] = name;
	argv[1] = nil;
	bol = 1;
	if(runmacro('.', 1, argv) &gt;= 0){
		inputnotify(popmacro1);
		if(!setjmp(runjb[nrunjb++]))
			runinput();
		else
			if(verbose) fprint(2, "finished %S\n", name);
	}
	bol = obol;
}

void
popmacro1(void)
{
	popmacro();
	if(nrunjb &gt;= 0)
		longjmp(runjb[--nrunjb], 1);
}

/*
 * macro arguments
 *
 *	"" means " inside " "
 *	"" empty string
 *	\newline can be done
 *	argument separator is space (not tab)
 *	number register .$ = number of arguments
 *	no arguments outside macros or in strings
 *
 *	arguments copied in copy mode
 */

/*
 * diversions
 *
 *	processed output diverted 
 *	dn dl registers vertical and horizontal size of last diversion
 *	.z - current diversion name
 */

/*
 * traps
 *
 *	skip most
 *	.t register - distance to next trap
 */
static Rune *trap0;

void
outtrap(void)
{
	Rune *t;

	if(outcb)
		return;
	if(trap0){
if(verbose) fprint(2, "trap: %S\n", trap0);
		t = trap0;
		trap0 = nil;
		runmacro1(t);
		free(t);
	}
}

/* .wh - install trap */
void
r_wh(int argc, Rune **argv)
{
	int i;

	if(argc &lt; 2)
		return;

	i = eval(argv[1]);
	if(argc == 2){
		if(i == 0){
			free(trap0);
			trap0 = nil;
		}else
			if(verbose)
				warn("not removing trap at %d", i);
	}
	if(argc &gt; 2){
		if(i == 0){
			free(trap0);
			trap0 = erunestrdup(argv[2]);
		}else
			if(verbose)
				warn("not installing %S trap at %d", argv[2], i);
	}
}

void
r_ch(int argc, Rune **argv)
{
	int i;
	
	if(argc == 2){
		if(trap0 &amp;&amp; runestrcmp(argv[1], trap0) == 0){
			free(trap0);
			trap0 = nil;
		}else
			if(verbose)
				warn("not removing %S trap", argv[1]);
		return;
	}
	if(argc &gt;= 3){
		i = eval(argv[2]);
		if(i == 0){
			free(trap0);
			trap0 = erunestrdup(argv[1]);
		}else
			if(verbose)
				warn("not moving %S trap to %d", argv[1], i);
	}
}

void
r_dt(int argc, Rune **argv)
{
	USED(argc);
	USED(argv);
	warn("ignoring diversion trap");
}

/* define macro - .de, .am, .ig */
void
r_de(int argc, Rune **argv)
{
	Rune *end, *p;
	Fmt fmt;
	int ignore, len;

	delreq(argv[1]);
	delraw(argv[1]);
	ignore = runestrcmp(argv[0], L("ig")) == 0;
	if(!ignore)
		runefmtstrinit(&amp;fmt);
	end = L("..");
	if(argc &gt;= 3)
		end = argv[2];
	if(runestrcmp(argv[0], L("am")) == 0 &amp;&amp; (p=getds(argv[1])) != nil)
		fmtrunestrcpy(&amp;fmt, p);
	len = runestrlen(end);
	while((p = readline(CopyMode)) != nil){
		if(runestrncmp(p, end, len) == 0 
		&amp;&amp; (p[len]==' ' || p[len]==0 || p[len]=='\t'
			|| (p[len]=='\\' &amp;&amp; p[len+1]=='}'))){
			free(p);
			goto done;
		}
		if(!ignore)
			fmtprint(&amp;fmt, "%S\n", p);
		free(p);
	}
	warn("eof in %C%S %S - looking for %#Q", dot, argv[0], argv[1], end);
done:
	if(ignore)
		return;
	p = runefmtstrflush(&amp;fmt);
	if(p == nil)
		sysfatal("out of memory");
	ds(argv[1], p);
	free(p);
}

/* define string .ds .as */
void
r_ds(Rune *cmd)
{
	Rune *name, *line, *p;
	
	name = copyarg();
	line = readline(CopyMode);
	if(name == nil || line == nil){
		free(name);
		return;
	}
	p = line;
	if(*p == '"')
		p++;
	if(cmd[0] == 'd')
		ds(name, p);
	else
		as(name, p);
	free(name);
	free(line);
}

/* remove request, macro, or string */
void
r_rm(int argc, Rune **argv)
{
	int i;

	emitdi();
	for(i=1; i&lt;argc; i++){
		delreq(argv[i]);
		delraw(argv[i]);
		ds(argv[i], nil);
	}
}

/* .rn - rename request, macro, or string */
void
r_rn(int argc, Rune **argv)
{
	USED(argc);
	renreq(argv[1], argv[2]);
	renraw(argv[1], argv[2]);
	ds(argv[2], getds(argv[1]));
	ds(argv[1], nil);
}

/* .di - divert output to macro xx */
/* .da - divert, appending to macro */
/* page offsetting is not done! */
Fmt difmt;
int difmtinit;
Rune di[20][100];
int ndi;

void
emitdi(void)
{
	flushdi();
	runefmtstrinit(&amp;difmt);
	difmtinit = 1;
	fmtrune(&amp;difmt, Uformatted);
}

void
flushdi(void)
{
	int n;
	Rune *p;
	
	if(ndi == 0 || difmtinit == 0)
		return;
	fmtrune(&amp;difmt, Uunformatted);
	p = runefmtstrflush(&amp;difmt);
	memset(&amp;difmt, 0, sizeof difmt);
	difmtinit = 0;
	if(p == nil)
		warn("out of memory in diversion %C%S", dot, di[ndi-1]);
	else{
		n = runestrlen(p);
		if(n &gt; 0 &amp;&amp; p[n-1] != '\n'){
			p = runerealloc(p, n+2);
			p[n] = '\n';
			p[n+1] = 0;
		}
	}
	as(di[ndi-1], p);
	free(p);
}

void
outdi(Rune r)
{
if(!difmtinit) abort();
	if(r == Uempty)
		return;
	fmtrune(&amp;difmt, r);
}

/* .di, .da */
void
r_di(int argc, Rune **argv)
{
	br();
	if(argc &gt; 2)
		warn("extra arguments to %C%S", dot, argv[0]);
	if(argc == 1){
		/* end diversion */
		if(ndi &lt;= 0){
			// warn("unmatched %C%S", dot, argv[0]);
			return;
		}
		flushdi();
		if(--ndi == 0){
			_nr(L(".z"), nil);
			outcb = nil;
		}else{
			_nr(L(".z"), di[ndi-1]);
			runefmtstrinit(&amp;difmt);
			fmtrune(&amp;difmt, Uformatted);
			difmtinit = 1;
		}
		return;
	}
	/* start diversion */
	/* various register state should be saved, but it's all useless to us */
	flushdi();
	if(ndi &gt;= nelem(di))
		sysfatal("%Cdi overflow", dot);
	if(argv[0][1] == 'i')
		ds(argv[1], nil);
	_nr(L(".z"), argv[1]);
	runestrcpy(di[ndi++], argv[1]);
	runefmtstrinit(&amp;difmt);
	fmtrune(&amp;difmt, Uformatted);
	difmtinit = 1;
	outcb = outdi;
}

/* .wh - install trap */
/* .ch - change trap */
/* .dt - install diversion trap */

/* set input-line count trap */
int itrapcount;
int itrapwaiting;
Rune *itrapname;

void
r_it(int argc, Rune **argv)
{
	if(argc &lt; 3){
		itrapcount = 0;
		return;
	}
	itrapcount = eval(argv[1]);
	free(itrapname);
	itrapname = erunestrdup(argv[2]);
}

void
itrap(void)
{
	itrapset();
	if(itrapwaiting){
		itrapwaiting = 0;
		runmacro1(itrapname);
	}
}

void
itrapset(void)
{
	if(itrapcount &gt; 0 &amp;&amp; --itrapcount == 0)
		itrapwaiting = 1;
}

/* .em - invoke macro when all input is over */
void
r_em(int argc, Rune **argv)
{
	Rune buf[20];
	
	USED(argc);
	runesnprint(buf, nelem(buf), ".%S\n", argv[1]);
	as(L("eof"), buf);
}

int
e_star(void)
{
	Rune *p;
	
	p = getds(getname());
	if(p)
		pushinputstring(p);
	return 0;
}

int
e_t(void)
{
	if(inputmode&amp;CopyMode)
		return '\t';
	return 0;
}

int
e_a(void)
{
	if(inputmode&amp;CopyMode)
		return '\a';
	return 0;
}

int
e_backslash(void)
{
	if(inputmode&amp;ArgMode)
		ungetrune('\\');
	return backslash;
}

int
e_dot(void)
{
	return '.';
}

int
e_dollar(void)
{
	int c;

	c = getnext();
	if(c &lt; '1' || c &gt; '9'){
		ungetnext(c);
		return 0;
	}
	c -= '0';
	if(nmstack &lt;= 0 || mstack[nmstack-1].argc &lt;= c)
		return 0;
	pushinputstring(mstack[nmstack-1].argv[c]);
	return 0;
}

void
t7init(void)
{	
	addreq(L("de"), r_de, -1);
	addreq(L("am"), r_de, -1);
	addreq(L("ig"), r_de, -1);
	addraw(L("ds"), r_ds);
	addraw(L("as"), r_ds);
	addreq(L("rm"), r_rm, -1);
	addreq(L("rn"), r_rn, -1);
	addreq(L("di"), r_di, -1);
	addreq(L("da"), r_di, -1);
	addreq(L("it"), r_it, -1);
	addreq(L("em"), r_em, 1);
	addreq(L("wh"), r_wh, -1);
	addreq(L("ch"), r_ch, -1);
	addreq(L("dt"), r_dt, -1);
	
	addesc('$', e_dollar, CopyMode|ArgMode|HtmlMode);
	addesc('*', e_star, CopyMode|ArgMode|HtmlMode);
	addesc('t', e_t, CopyMode|ArgMode);
	addesc('a', e_a, CopyMode|ArgMode);
	addesc('\\', e_backslash, ArgMode|CopyMode);
	addesc('.', e_dot, CopyMode|ArgMode);
	
	ds(L("eof"), L(".sp 0.5i\n"));
	ds(L(".."), L(""));
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

