<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/iostats/iostats.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/iostats/iostats.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * iostats - Gather file system information
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#define Extern
#include "statfs.h"

void	runprog(char**);

void (*fcalls[])(Fsrpc*) =
{
	[Tversion]	Xversion,
	[Tauth]	Xauth,
	[Tflush]	Xflush,
	[Tattach]	Xattach,
	[Twalk]		Xwalk,
	[Topen]		slave,
	[Tcreate]	Xcreate,
	[Tclunk]	Xclunk,
	[Tread]		slave,
	[Twrite]	slave,
	[Tremove]	Xremove,
	[Tstat]		Xstat,
	[Twstat]	Xwstat,
};

int p[2];

void
usage(void)
{
	fprint(2, "usage: iostats [-d] [-f debugfile] cmds [args ...]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	Fsrpc *r;
	Rpc *rpc;
	Proc *m;
	Frec *fr;
	Fid *fid;
	ulong ttime;
	char *dbfile, *s;
	char buf[128];
	float brpsec, bwpsec, bppsec;
	int type, cpid, fspid, n;

	dbfile = DEBUGFILE;

	ARGBEGIN{
	case 'd':
		dbg++;
		break;
	case 'f':
		dbfile = ARGF();
		break;
	default:
		usage();
	}ARGEND

	if(argc == 0)
		usage();

	if(dbg) {
		close(2);
		create(dbfile, OWRITE, 0666);
	}

	if(pipe(p) &lt; 0)
		fatal("pipe");

	switch(cpid = fork()) {
	case -1:
		fatal("fork");
	case 0:
		close(p[1]);
		if(getwd(buf, sizeof(buf)) == 0)
			fatal("no working directory");

		rfork(RFENVG|RFNAMEG|RFNOTEG);
		if(mount(p[0], -1, "/", MREPL, "") &lt; 0)
			fatal("mount /");

		bind("#c/pid", "/dev/pid", MREPL);
		bind("#e", "/env", MREPL|MCREATE);
		close(0);
		close(1);
		close(2);
		open("/fd/0", OREAD);
		open("/fd/1", OWRITE);
		open("/fd/2", OWRITE);

		if(chdir(buf) &lt; 0)
			fatal("chdir");

		runprog(argv);
	default:
		close(p[0]);
	}

	switch(fspid = fork()) {
	default:
		while(cpid != waitpid())
			;
		postnote(PNPROC, fspid, DONESTR);
		while(fspid != waitpid())
			;
		exits(0);
	case -1:
		fatal("fork");
	case 0:
		break;
	}

	/* Allocate work queues in shared memory */
	malloc(Dsegpad);
	Workq = malloc(sizeof(Fsrpc)*Nr_workbufs);
	stats = malloc(sizeof(Stats));
	fhash = mallocz(sizeof(Fid*)*FHASHSIZE, 1);

	if(Workq == 0 || fhash == 0 || stats == 0)
		fatal("no initial memory");

	memset(Workq, 0, sizeof(Fsrpc)*Nr_workbufs);
	memset(stats, 0, sizeof(Stats));

	stats-&gt;rpc[Tversion].name = "version";
	stats-&gt;rpc[Tauth].name = "auth";
	stats-&gt;rpc[Tflush].name = "flush";
	stats-&gt;rpc[Tattach].name = "attach";
	stats-&gt;rpc[Twalk].name = "walk";
	stats-&gt;rpc[Topen].name = "open";
	stats-&gt;rpc[Tcreate].name = "create";
	stats-&gt;rpc[Tclunk].name = "clunk";
	stats-&gt;rpc[Tread].name = "read";
	stats-&gt;rpc[Twrite].name = "write";
	stats-&gt;rpc[Tremove].name = "remove";
	stats-&gt;rpc[Tstat].name = "stat";
	stats-&gt;rpc[Twstat].name = "wstat";

	for(n = 0; n &lt; Maxrpc; n++)
		stats-&gt;rpc[n].lo = 10000000000LL;

	fmtinstall('M', dirmodefmt);
	fmtinstall('D', dirfmt);
	fmtinstall('F', fcallfmt);

	if(chdir("/") &lt; 0)
		fatal("chdir");

	initroot();

	DEBUG(2, "statfs: %s\n", buf);

	notify(catcher);

	for(;;) {
		r = getsbuf();
		if(r == 0)
			fatal("Out of service buffers");

		n = read9pmsg(p[1], r-&gt;buf, sizeof(r-&gt;buf));
		if(done)
			break;
		if(n &lt; 0)
			fatal("read server");

		if(convM2S(r-&gt;buf, n, &amp;r-&gt;work) == 0)
			fatal("format error");

		stats-&gt;nrpc++;
		stats-&gt;nproto += n;

		DEBUG(2, "%F\n", &amp;r-&gt;work);

		type = r-&gt;work.type;
		rpc = &amp;stats-&gt;rpc[type];
		rpc-&gt;count++;
		rpc-&gt;bin += n;
		(fcalls[type])(r);
	}

	/* Clear away the slave children */
	for(m = Proclist; m; m = m-&gt;next)
		postnote(PNPROC, m-&gt;pid, "kill");

	rpc = &amp;stats-&gt;rpc[Tread];
	brpsec = (float)stats-&gt;totread / (((float)rpc-&gt;time/1e9)+.000001);

	rpc = &amp;stats-&gt;rpc[Twrite];
	bwpsec = (float)stats-&gt;totwrite / (((float)rpc-&gt;time/1e9)+.000001);

	ttime = 0;
	for(n = 0; n &lt; Maxrpc; n++) {
		rpc = &amp;stats-&gt;rpc[n];
		if(rpc-&gt;count == 0)
			continue;
		ttime += rpc-&gt;time;
	}

	bppsec = (float)stats-&gt;nproto / ((ttime/1e9)+.000001);

	fprint(2, "\nread      %lud bytes, %g Kb/sec\n", stats-&gt;totread, brpsec/1024.0);
	fprint(2, "write     %lud bytes, %g Kb/sec\n", stats-&gt;totwrite, bwpsec/1024.0);
	fprint(2, "protocol  %lud bytes, %g Kb/sec\n", stats-&gt;nproto, bppsec/1024.0);
	fprint(2, "rpc       %lud count\n\n", stats-&gt;nrpc);

	fprint(2, "%-10s %5s %5s %5s %5s %5s          T       R\n", 
	      "Message", "Count", "Low", "High", "Time", "Averg");

	for(n = 0; n &lt; Maxrpc; n++) {
		rpc = &amp;stats-&gt;rpc[n];
		if(rpc-&gt;count == 0)
			continue;
		fprint(2, "%-10s %5lud %5llud %5llud %5llud %5llud ms %8lud %8lud bytes\n", 
			rpc-&gt;name, 
			rpc-&gt;count,
			rpc-&gt;lo/1000000,
			rpc-&gt;hi/1000000,
			rpc-&gt;time/1000000,
			rpc-&gt;time/1000000/rpc-&gt;count,
			rpc-&gt;bin,
			rpc-&gt;bout);
	}

	for(n = 0; n &lt; FHASHSIZE; n++)
		for(fid = fhash[n]; fid; fid = fid-&gt;next)
			if(fid-&gt;nread || fid-&gt;nwrite)
				fidreport(fid);
	if(frhead == 0)
		exits(0);

	fprint(2, "\nOpens    Reads  (bytes)   Writes  (bytes) File\n");
	for(fr = frhead; fr; fr = fr-&gt;next) {
		s = fr-&gt;op;
		if(*s) {
			if(strcmp(s, "/fd/0") == 0)
				s = "(stdin)";
			else
			if(strcmp(s, "/fd/1") == 0)
				s = "(stdout)";
			else
			if(strcmp(s, "/fd/2") == 0)
				s = "(stderr)";
		}
		else
			s = "/.";

		fprint(2, "%5lud %8lud %8lud %8lud %8lud %s\n", fr-&gt;opens, fr-&gt;nread, fr-&gt;bread,
							fr-&gt;nwrite, fr-&gt;bwrite, s);
	}

	exits(0);
}

void
reply(Fcall *r, Fcall *t, char *err)
{
	uchar data[IOHDRSZ+Maxfdata];
	int n;

	t-&gt;tag = r-&gt;tag;
	t-&gt;fid = r-&gt;fid;
	if(err) {
		t-&gt;type = Rerror;
		t-&gt;ename = err;
	}
	else 
		t-&gt;type = r-&gt;type + 1;

	DEBUG(2, "\t%F\n", t);

	n = convS2M(t, data, sizeof data);
	if(write(p[1], data, n)!=n)
		fatal("mount write");
	stats-&gt;nproto += n;
	stats-&gt;rpc[t-&gt;type-1].bout += n;
}

Fid *
getfid(int nr)
{
	Fid *f;

	for(f = fidhash(nr); f; f = f-&gt;next)
		if(f-&gt;nr == nr)
			return f;

	return 0;
}

int
freefid(int nr)
{
	Fid *f, **l;

	l = &amp;fidhash(nr);
	for(f = *l; f; f = f-&gt;next) {
		if(f-&gt;nr == nr) {
			*l = f-&gt;next;
			f-&gt;next = fidfree;
			fidfree = f;
			return 1;
		}
		l = &amp;f-&gt;next;
	}

	return 0;	
}

Fid *
newfid(int nr)
{
	Fid *new, **l;
	int i;

	l = &amp;fidhash(nr);
	for(new = *l; new; new = new-&gt;next)
		if(new-&gt;nr == nr)
			return 0;

	if(fidfree == 0) {
		fidfree = mallocz(sizeof(Fid) * Fidchunk, 1);
		if(fidfree == 0)
			fatal("out of memory");

		for(i = 0; i &lt; Fidchunk-1; i++)
			fidfree[i].next = &amp;fidfree[i+1];

		fidfree[Fidchunk-1].next = 0;
	}

	new = fidfree;
	fidfree = new-&gt;next;

	memset(new, 0, sizeof(Fid));
	new-&gt;next = *l;
	*l = new;
	new-&gt;nr = nr;
	new-&gt;fid = -1;
	new-&gt;nread = 0;
	new-&gt;nwrite = 0;
	new-&gt;bread = 0;
	new-&gt;bwrite = 0;

	return new;	
}

Fsrpc *
getsbuf(void)
{
	static int ap;
	int look;
	Fsrpc *wb;

	for(look = 0; look &lt; Nr_workbufs; look++) {
		if(++ap == Nr_workbufs)
			ap = 0;
		if(Workq[ap].busy == 0)
			break;
	}

	if(look == Nr_workbufs)
		fatal("No more work buffers");

	wb = &amp;Workq[ap];
	wb-&gt;pid = 0;
	wb-&gt;canint = 0;
	wb-&gt;flushtag = NOTAG;
	wb-&gt;busy = 1;

	return wb;
}

char *
strcatalloc(char *p, char *n)
{
	char *v;

	v = realloc(p, strlen(p)+strlen(n)+1);
	if(v == 0)
		fatal("no memory");
	strcat(v, n);
	return v;
}

File *
file(File *parent, char *name)
{
	char buf[128];
	File *f, *new;
	Dir *dir;

	DEBUG(2, "\tfile: 0x%p %s name %s\n", parent, parent-&gt;name, name);

	for(f = parent-&gt;child; f; f = f-&gt;childlist)
		if(strcmp(name, f-&gt;name) == 0)
			break;

	if(f != nil &amp;&amp; !f-&gt;inval)
		return f;
	makepath(buf, parent, name);
	dir = dirstat(buf);
	if(dir == nil)
		return 0;
	if(f != nil){
		free(dir);
		f-&gt;inval = 0;
		return f;
	}

	new = malloc(sizeof(File));
	if(new == 0)
		fatal("no memory");

	memset(new, 0, sizeof(File));
	new-&gt;name = strdup(name);
	if(new-&gt;name == nil)
		fatal("can't strdup");
	new-&gt;qid.type = dir-&gt;qid.type;
	new-&gt;qid.vers = dir-&gt;qid.vers;
	new-&gt;qid.path = ++qid;

	new-&gt;parent = parent;
	new-&gt;childlist = parent-&gt;child;
	parent-&gt;child = new;

	free(dir);
	return new;
}

void
initroot(void)
{
	Dir *dir;

	root = malloc(sizeof(File));
	if(root == 0)
		fatal("no memory");

	memset(root, 0, sizeof(File));
	root-&gt;name = strdup("/");
	if(root-&gt;name == nil)
		fatal("can't strdup");
	dir = dirstat(root-&gt;name);
	if(dir == nil)
		fatal("root stat");

	root-&gt;qid.type = dir-&gt;qid.type;
	root-&gt;qid.vers = dir-&gt;qid.vers;
	root-&gt;qid.path = ++qid;
	free(dir);
}

void
makepath(char *as, File *p, char *name)
{
	char *c, *seg[100];
	int i;
	char *s;

	seg[0] = name;
	for(i = 1; i &lt; 100 &amp;&amp; p; i++, p = p-&gt;parent){
		seg[i] = p-&gt;name;
		if(strcmp(p-&gt;name, "/") == 0)
			seg[i] = "";	/* will insert slash later */
	}

	s = as;
	while(i--) {
		for(c = seg[i]; *c; c++)
			*s++ = *c;
		*s++ = '/';
	}
	while(s[-1] == '/')
		s--;
	*s = '\0';
	if(as == s)	/* empty string is root */
		strcpy(as, "/");
}

void
fatal(char *s)
{
	Proc *m;

	fprint(2, "iostats: %s: %r\n", s);

	/* Clear away the slave children */
	for(m = Proclist; m; m = m-&gt;next)
		postnote(PNPROC, m-&gt;pid, "exit");

	exits("fatal");
}

char*
rdenv(char *v, char **end)
{
	int fd, n;
	char *buf;
	Dir *d;
	if((fd = open(v, OREAD)) == -1)
		return nil;
	d = dirfstat(fd);
	if(d == nil || (buf = malloc(d-&gt;length + 1)) == nil)
		return nil;
	n = (int)d-&gt;length;
	n = read(fd, buf, n);
	close(fd);
	if(n &lt;= 0){
		free(buf);
		buf = nil;
	}else{
		if(buf[n-1] != '\0')
			buf[n++] = '\0';
		*end = &amp;buf[n];
	}
	free(d);
	return buf;
}

char Defaultpath[] = ".\0/bin";
void
runprog(char *argv[])
{
	char *path, *ep, *p;
	char arg0[256];

	path = rdenv("/env/path", &amp;ep);
	if(path == nil){
		path = Defaultpath;
		ep = path+sizeof(Defaultpath);
	}
	for(p = path; p &lt; ep; p += strlen(p)+1){
		snprint(arg0, sizeof arg0, "%s/%s", p, argv[0]);
		exec(arg0, argv);
	}
	fatal("exec");
}

void
catcher(void *a, char *msg)
{
	USED(a);
	if(strcmp(msg, DONESTR) == 0) {
		done = 1;
		noted(NCONT);
	}
	if(strcmp(msg, "exit") == 0)
		exits("exit");

	noted(NDFLT);
}

void
fidreport(Fid *f)
{
	char *p, path[128];
	Frec *fr;

	p = path;
	makepath(p, f-&gt;f, "");

	for(fr = frhead; fr; fr = fr-&gt;next) {
		if(strcmp(fr-&gt;op, p) == 0) {
			fr-&gt;nread += f-&gt;nread;
			fr-&gt;nwrite += f-&gt;nwrite;
			fr-&gt;bread += f-&gt;bread;
			fr-&gt;bwrite += f-&gt;bwrite;
			fr-&gt;opens++;
			return;
		}
	}

	fr = malloc(sizeof(Frec));
	if(fr == 0 || (fr-&gt;op = strdup(p)) == 0)
		fatal("no memory");

	fr-&gt;nread = f-&gt;nread;
	fr-&gt;nwrite = f-&gt;nwrite;
	fr-&gt;bread = f-&gt;bread;
	fr-&gt;bwrite = f-&gt;bwrite;
	fr-&gt;opens = 1;
	if(frhead == 0) {
		frhead = fr;
		frtail = fr;
	}
	else {
		frtail-&gt;next = fr;
		frtail = fr;
	}
	fr-&gt;next = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

