<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/iostats/statsrv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/iostats/statsrv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#define Extern	extern
#include "statfs.h"

char Ebadfid[]	= "Bad fid";
char Enotdir[]	="Not a directory";
char Edupfid[]	= "Fid already in use";
char Eopen[]	= "Fid already opened";
char Exmnt[]	= "Cannot .. past mount point";
char Enoauth[]	= "iostats: Authentication failed";
char Ebadver[]	= "Unrecognized 9P version";

int
okfile(char *s, int mode)
{
	if(strncmp(s, "/fd/", 3) == 0){
		/* 0, 1, and 2 we handle ourselves */
		if(s[4]=='/' || atoi(s+4) &gt; 2)
			return 0;
		return 1;
	}
	if(strncmp(s, "/net/ssl", 8) == 0)
		return 0;
	if(strncmp(s, "/net/tls", 8) == 0)
		return 0;
	if(strncmp(s, "/srv/", 5) == 0 &amp;&amp; ((mode&amp;3) == OWRITE || (mode&amp;3) == ORDWR))
		return 0;
	return 1;
}

void
update(Rpc *rpc, vlong t)
{
	vlong t2;

	t2 = nsec();
	t = t2 - t;
	if(t &lt; 0)
		t = 0;

	rpc-&gt;time += t;
	if(t &lt; rpc-&gt;lo)
		rpc-&gt;lo = t;
	if(t &gt; rpc-&gt;hi)
		rpc-&gt;hi = t;
}

void
Xversion(Fsrpc *r)
{
	Fcall thdr;
	vlong t;

	t = nsec();

	if(r-&gt;work.msize &gt; IOHDRSZ+Maxfdata)
		thdr.msize = IOHDRSZ+Maxfdata;
	else
		thdr.msize = r-&gt;work.msize;
	myiounit = thdr.msize - IOHDRSZ;
	if(strncmp(r-&gt;work.version, "9P2000", 6) != 0){
		reply(&amp;r-&gt;work, &amp;thdr, Ebadver);
		r-&gt;busy = 0;
		return;
	}
	thdr.version = "9P2000";
	/* BUG: should clunk all fids */
	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tversion], t);
}

void
Xauth(Fsrpc *r)
{
	Fcall thdr;
	vlong t;

	t = nsec();

	reply(&amp;r-&gt;work, &amp;thdr, Enoauth);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tauth], t);
}

void
Xflush(Fsrpc *r)
{
	Fsrpc *t, *e;
	Fcall thdr;

	e = &amp;Workq[Nr_workbufs];

	for(t = Workq; t &lt; e; t++) {
		if(t-&gt;work.tag == r-&gt;work.oldtag) {
			DEBUG(2, "\tQ busy %d pid %p can %d\n", t-&gt;busy, t-&gt;pid, t-&gt;canint);
			if(t-&gt;busy &amp;&amp; t-&gt;pid) {
				t-&gt;flushtag = r-&gt;work.tag;
				DEBUG(2, "\tset flushtag %d\n", r-&gt;work.tag);
				if(t-&gt;canint)
					postnote(PNPROC, t-&gt;pid, "flush");
				r-&gt;busy = 0;
				return;
			}
		}
	}

	reply(&amp;r-&gt;work, &amp;thdr, 0);
	DEBUG(2, "\tflush reply\n");
	r-&gt;busy = 0;
}

void
Xattach(Fsrpc *r)
{
	Fcall thdr;
	Fid *f;
	vlong t;

	t = nsec();

	f = newfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}

	f-&gt;f = root;
	thdr.qid = f-&gt;f-&gt;qid;
	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tattach], t);
}

void
Xwalk(Fsrpc *r)
{
	char errbuf[ERRMAX], *err;
	Fcall thdr;
	Fid *f, *n;
	File *nf;
	vlong t;
	int i;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}
	n = nil;
	if(r-&gt;work.newfid != r-&gt;work.fid){
		n = newfid(r-&gt;work.newfid);
		if(n == 0) {
			reply(&amp;r-&gt;work, &amp;thdr, Edupfid);
			r-&gt;busy = 0;
			return;
		}
		n-&gt;f = f-&gt;f;
		f = n;	/* walk new guy */
	}

	thdr.nwqid = 0;
	err = nil;
	for(i=0; i&lt;r-&gt;work.nwname; i++){
		if(i &gt;= MAXWELEM)
			break;
		if(strcmp(r-&gt;work.wname[i], "..") == 0) {
			if(f-&gt;f-&gt;parent == 0) {
				err = Exmnt;
				break;
			}
			f-&gt;f = f-&gt;f-&gt;parent;
			thdr.wqid[thdr.nwqid++] = f-&gt;f-&gt;qid;
			continue;
		}
	
		nf = file(f-&gt;f, r-&gt;work.wname[i]);
		if(nf == 0) {
			errstr(errbuf, sizeof errbuf);
			err = errbuf;
			break;
		}

		f-&gt;f = nf;
		thdr.wqid[thdr.nwqid++] = nf-&gt;qid;
		continue;
	}

	if(err == nil &amp;&amp; thdr.nwqid == 0 &amp;&amp; r-&gt;work.nwname &gt; 0)
		err = "file does not exist";

	if(n != nil &amp;&amp; (err != 0 || thdr.nwqid &lt; r-&gt;work.nwname)){
		/* clunk the new fid, which is the one we walked */
		freefid(n-&gt;nr);
	}

	if(thdr.nwqid &gt; 0)
		err = nil;
	reply(&amp;r-&gt;work, &amp;thdr, err);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Twalk], t);
}

void
Xclunk(Fsrpc *r)
{
	Fcall thdr;
	Fid *f;
	vlong t;
	int fid;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}

	if(f-&gt;fid &gt;= 0)
		close(f-&gt;fid);

	fid = r-&gt;work.fid;
	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tclunk], t);

	if(f-&gt;nread || f-&gt;nwrite)
		fidreport(f);

	freefid(fid);
}

void
Xstat(Fsrpc *r)
{
	char err[ERRMAX], path[128];
	uchar statbuf[STATMAX];
	Fcall thdr;
	Fid *f;
	int s;
	vlong t;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}
	makepath(path, f-&gt;f, "");
	if(!okfile(path, -1)){
		snprint(err, sizeof err, "iostats: can't simulate %s", path);
		reply(&amp;r-&gt;work, &amp;thdr, err);
		r-&gt;busy = 0;
		return;
	}

	if(f-&gt;fid &gt;= 0)
		s = fstat(f-&gt;fid, statbuf, sizeof statbuf);
	else
		s = stat(path, statbuf, sizeof statbuf);

	if(s &lt; 0) {
		errstr(err, sizeof err);
		reply(&amp;r-&gt;work, &amp;thdr, err);
		r-&gt;busy = 0;
		return;
	}
	thdr.stat = statbuf;
	thdr.nstat = s;
	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tstat], t);
}

void
Xcreate(Fsrpc *r)
{
	char err[ERRMAX], path[128];
	Fcall thdr;
	Fid *f;
	File *nf;
	vlong t;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}
	

	makepath(path, f-&gt;f, r-&gt;work.name);
	f-&gt;fid = create(path, r-&gt;work.mode, r-&gt;work.perm);
	if(f-&gt;fid &lt; 0) {
		errstr(err, sizeof err);
		reply(&amp;r-&gt;work, &amp;thdr, err);
		r-&gt;busy = 0;
		return;
	}

	nf = file(f-&gt;f, r-&gt;work.name);
	if(nf == 0) {
		errstr(err, sizeof err);
		reply(&amp;r-&gt;work, &amp;thdr, err);
		r-&gt;busy = 0;
		return;
	}

	f-&gt;mode = r-&gt;work.mode;
	f-&gt;f = nf;
	thdr.iounit = myiounit;
	thdr.qid = f-&gt;f-&gt;qid;
	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tcreate], t);
}


void
Xremove(Fsrpc *r)
{
	char err[ERRMAX], path[128];
	Fcall thdr;
	Fid *f;
	vlong t;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}

	makepath(path, f-&gt;f, "");
	DEBUG(2, "\tremove: %s\n", path);
	if(remove(path) &lt; 0) {
		errstr(err, sizeof err);
		reply(&amp;r-&gt;work, &amp;thdr, err);
		freefid(r-&gt;work.fid);
		r-&gt;busy = 0;
		return;
	}

	f-&gt;f-&gt;inval = 1;
	if(f-&gt;fid &gt;= 0)
		close(f-&gt;fid);
	freefid(r-&gt;work.fid);

	reply(&amp;r-&gt;work, &amp;thdr, 0);
	r-&gt;busy = 0;

	update(&amp;stats-&gt;rpc[Tremove], t);
}

void
Xwstat(Fsrpc *r)
{
	char err[ERRMAX], path[128];
	Fcall thdr;
	Fid *f;
	int s;
	vlong t;

	t = nsec();

	f = getfid(r-&gt;work.fid);
	if(f == 0) {
		reply(&amp;r-&gt;work, &amp;thdr, Ebadfid);
		r-&gt;busy = 0;
		return;
	}
	if(f-&gt;fid &gt;= 0)
		s = fwstat(f-&gt;fid, r-&gt;work.stat, r-&gt;work.nstat);
	else {
		makepath(path, f-&gt;f, "");
		s = wstat(path, r-&gt;work.stat, r-&gt;work.nstat);
	}
	if(s &lt; 0) {
		errstr(err, sizeof err);
		reply(&amp;r-&gt;work, &amp;thdr, err);
	}
	else
		reply(&amp;r-&gt;work, &amp;thdr, 0);

	r-&gt;busy = 0;
	update(&amp;stats-&gt;rpc[Twstat], t);
}

void
slave(Fsrpc *f)
{
	int r;
	Proc *p;
	uintptr pid;
	static int nproc;

	for(;;) {
		for(p = Proclist; p; p = p-&gt;next) {
			if(p-&gt;busy == 0) {
				f-&gt;pid = p-&gt;pid;
				p-&gt;busy = 1;
				pid = (uintptr)rendezvous((void*)p-&gt;pid, f);
				if(pid != p-&gt;pid)
					fatal("rendezvous sync fail");
				return;
			}	
		}

		if(++nproc &gt; MAXPROC)
			fatal("too many procs");

		r = rfork(RFPROC|RFMEM);
		if(r &lt; 0)
			fatal("rfork");

		if(r == 0)
			blockingslave();

		p = malloc(sizeof(Proc));
		if(p == 0)
			fatal("out of memory");

		p-&gt;busy = 0;
		p-&gt;pid = r;
		p-&gt;next = Proclist;
		Proclist = p;

		rendezvous((void*)p-&gt;pid, p);
	}
}

void
blockingslave(void)
{
	Proc *m;
	uintptr pid;
	Fsrpc *p;
	Fcall thdr;

	notify(flushaction);

	pid = getpid();

	m = rendezvous((void*)pid, 0);
		
	for(;;) {
		p = rendezvous((void*)pid, (void*)pid);
		if(p == (void*)~0)			/* Interrupted */
			continue;

		DEBUG(2, "\tslave: %p %F b %d p %p\n", pid, &amp;p-&gt;work, p-&gt;busy, p-&gt;pid);
		if(p-&gt;flushtag != NOTAG)
			return;

		switch(p-&gt;work.type) {
		case Tread:
			slaveread(p);
			break;
		case Twrite:
			slavewrite(p);
			break;
		case Topen:
			slaveopen(p);
			break;
		default:
			reply(&amp;p-&gt;work, &amp;thdr, "exportfs: slave type error");
		}
		if(p-&gt;flushtag != NOTAG) {
			p-&gt;work.type = Tflush;
			p-&gt;work.tag = p-&gt;flushtag;
			reply(&amp;p-&gt;work, &amp;thdr, 0);
		}
		p-&gt;busy = 0;	
		m-&gt;busy = 0;
	}
}

void
slaveopen(Fsrpc *p)
{
	char err[ERRMAX], path[128];
	Fcall *work, thdr;
	Fid *f;
	vlong t;

	work = &amp;p-&gt;work;

	t = nsec();

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;thdr, Ebadfid);
		return;
	}
	if(f-&gt;fid &gt;= 0) {
		close(f-&gt;fid);
		f-&gt;fid = -1;
	}
	
	makepath(path, f-&gt;f, "");
	DEBUG(2, "\topen: %s %d\n", path, work-&gt;mode);

	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG)
		return;

	if(!okfile(path, work-&gt;mode)){
		snprint(err, sizeof err, "iostats can't simulate %s", path);
		reply(work, &amp;thdr, err);
		return;
	}

	/* There is a race here I ignore because there are no locks */
	f-&gt;fid = open(path, work-&gt;mode);
	p-&gt;canint = 0;
	if(f-&gt;fid &lt; 0) {
		errstr(err, sizeof err);
		reply(work, &amp;thdr, err);
		return;
	}

	DEBUG(2, "\topen: fd %d\n", f-&gt;fid);
	f-&gt;mode = work-&gt;mode;
	thdr.iounit = myiounit;
	thdr.qid = f-&gt;f-&gt;qid;
	reply(work, &amp;thdr, 0);

	update(&amp;stats-&gt;rpc[Topen], t);
}

void
slaveread(Fsrpc *p)
{
	char data[Maxfdata], err[ERRMAX];
	Fcall *work, thdr;
	Fid *f;
	int n, r;
	vlong t;

	work = &amp;p-&gt;work;

	t = nsec();

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;thdr, Ebadfid);
		return;
	}

	n = (work-&gt;count &gt; Maxfdata) ? Maxfdata : work-&gt;count;
	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG)
		return;
	/* can't just call pread, since directories must update the offset */
	if(f-&gt;f-&gt;qid.type&amp;QTDIR){
		if(work-&gt;offset != f-&gt;offset){
			if(work-&gt;offset != 0){
				snprint(err, sizeof err, "can't seek in directory from %lld to %lld", f-&gt;offset, work-&gt;offset);
				reply(work, &amp;thdr, err);
				return;
			}
			if(seek(f-&gt;fid, 0, 0) != 0){
				errstr(err, sizeof err);
				reply(work, &amp;thdr, err);
				return;	
			}
			f-&gt;offset = 0;
		}
		r = read(f-&gt;fid, data, n);
		if(r &gt; 0)
			f-&gt;offset += r;
	}else
		r = pread(f-&gt;fid, data, n, work-&gt;offset);
	p-&gt;canint = 0;
	if(r &lt; 0) {
		errstr(err, sizeof err);
		reply(work, &amp;thdr, err);
		return;
	}

	DEBUG(2, "\tread: fd=%d %d bytes\n", f-&gt;fid, r);

	thdr.data = data;
	thdr.count = r;
	stats-&gt;totread += r;
	f-&gt;nread++;
	f-&gt;bread += r;
	reply(work, &amp;thdr, 0);

	update(&amp;stats-&gt;rpc[Tread], t);
}

void
slavewrite(Fsrpc *p)
{
	char err[ERRMAX];
	Fcall *work, thdr;
	Fid *f;
	int n;
	vlong t;

	work = &amp;p-&gt;work;

	t = nsec();

	f = getfid(work-&gt;fid);
	if(f == 0) {
		reply(work, &amp;thdr, Ebadfid);
		return;
	}

	n = (work-&gt;count &gt; Maxfdata) ? Maxfdata : work-&gt;count;
	p-&gt;canint = 1;
	if(p-&gt;flushtag != NOTAG)
		return;
	n = pwrite(f-&gt;fid, work-&gt;data, n, work-&gt;offset);
	p-&gt;canint = 0;
	if(n &lt; 0) {
		errstr(err, sizeof err);
		reply(work, &amp;thdr, err);
		return;
	}

	DEBUG(2, "\twrite: %d bytes fd=%d\n", n, f-&gt;fid);

	thdr.count = n;
	f-&gt;nwrite++;
	f-&gt;bwrite += n;
	stats-&gt;totwrite += n;
	reply(work, &amp;thdr, 0);

	update(&amp;stats-&gt;rpc[Twrite], t);
}

void
reopen(Fid *f)
{
	USED(f);
	fatal("reopen");
}

void
flushaction(void *a, char *cause)
{
	USED(a);
	if(strncmp(cause, "kill", 4) == 0)
		noted(NDFLT);

	noted(NCONT);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

