<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/dhcpd/dhcpd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/dhcpd/dhcpd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include "dat.h"

/*
 *	ala rfc2131
 */

enum {
	Maxloglen = 1024,
};

typedef struct Req Req;
struct Req
{
	int	fd;			/* for reply */
	Bootp	*bp;
	Udphdr	*up;
	uchar	*e;			/* end of received message */
	uchar	*p;			/* options pointer */
	uchar	*max;			/* max end of reply */

	/* expanded to v6 */
	uchar	ciaddr[IPaddrlen];
	uchar	giaddr[IPaddrlen];

	/* parsed options */
	int	p9request;		/* flag: this is a bootp with plan9 options */
	int	genrequest;		/* flag: this is a bootp with generic options */
	int	broadcast;		/* flag: request was broadcast */
	int	dhcptype;		/* dhcp message type */
	int	leasetime;		/* dhcp lease */
	uchar	ip[IPaddrlen];		/* requested address */
	uchar	server[IPaddrlen];	/* server address */
	char	msg[ERRMAX];		/* error message */
	char	vci[32];		/* vendor class id */
	char	*id;			/* client id */
	uchar	requested[32];		/* requested params */
	uchar	vendorclass[32];
	char	cputype[32-3];

	Info	gii;			/* about target network */
	Info	ii;			/* about target system */
	int	staticbinding;

	uchar buf[2*1024];		/* message buffer */
};

#define TFTP "/lib/tftpd"

char	*blog = "ipboot";
char	mysysname[64];
Ipifc	*ipifcs;
int	debug;
int	nobootp;
long	now;
int	slowstat, slowdyn;
char	net[256];

int	pptponly;	/* only answer request that came from the pptp server */
int	mute, mutestat;
int	minlease = MinLease;
int	staticlease = StaticLease;

uvlong	start;

static int v6opts;

/* option magic */
char plan9opt[4] = { 'p', '9', ' ', ' ' };
char genericopt[4] = { 0x63, 0x82, 0x53, 0x63 };

/* well known addresses */
uchar zeros[Maxhwlen];

/* option debug buffer */
char optbuf[1024];
char *op;
char *oe = optbuf + sizeof(optbuf);

char *optname[256] =
{
[OBend]			"end",
[OBpad]			"pad",
[OBmask]		"mask",
[OBtimeoff]		"timeoff",
[OBrouter]		"router",
[OBtimeserver]		"time",
[OBnameserver]		"name",
[OBdnserver]		"dns",
[OBlogserver]		"log",
[OBcookieserver]	"cookie",
[OBlprserver]		"lpr",
[OBimpressserver]	"impress",
[OBrlserver]		"rl",
[OBhostname]		"host",
[OBbflen]		"bflen",
[OBdumpfile]		"dumpfile",
[OBdomainname]		"dom",
[OBswapserver]		"swap",
[OBrootpath]		"rootpath",
[OBextpath]		"extpath",
[OBipforward]		"ipforward",
[OBnonlocal]		"nonlocal",
[OBpolicyfilter]	"policyfilter",
[OBmaxdatagram]		"maxdatagram",
[OBttl]			"ttl",
[OBpathtimeout]		"pathtimeout",
[OBpathplateau]		"pathplateau",
[OBmtu]			"mtu",
[OBsubnetslocal]	"subnetslocal",
[OBbaddr]		"baddr",
[OBdiscovermask]	"discovermask",
[OBsupplymask]		"supplymask",
[OBdiscoverrouter]	"discoverrouter",
[OBrsserver]		"rsserver",
[OBstaticroutes]	"staticroutes",
[OBtrailerencap]	"trailerencap",
[OBarptimeout]		"arptimeout",
[OBetherencap]		"etherencap",
[OBtcpttl]		"tcpttl",
[OBtcpka]		"tcpka",
[OBtcpkag]		"tcpkag",
[OBnisdomain]		"nisdomain",
[OBniserver]		"niserver",
[OBntpserver]		"ntpserver",
[OBvendorinfo]		"vendorinfo",
[OBnetbiosns]		"NBns",
[OBnetbiosdds]		"NBdds",
[OBnetbiostype]		"NBtype",
[OBnetbiosscope]	"NBscope",
[OBxfontserver]		"xfont",
[OBxdispmanager]	"xdisp",
[OBnisplusdomain]	"NPdomain",
[OBnisplusserver]	"NP",
[OBhomeagent]		"homeagent",
[OBsmtpserver]		"smtp",
[OBpop3server]		"pop3",
[OBnntpserver]		"nntp",
[OBwwwserver]		"www",
[OBfingerserver]	"finger",
[OBircserver]		"ircserver",
[OBstserver]		"stserver",
[OBstdaserver]		"stdaserver",

/* dhcp options */
[ODipaddr]		"ip",
[ODlease]		"leas",
[ODoverload]		"overload",
[ODtype]		"typ",
[ODserverid]		"sid",
[ODparams]		"params",
[ODmessage]		"message",
[ODmaxmsg]		"maxmsg",
[ODrenewaltime]		"renewaltime",
[ODrebindingtime]	"rebindingtime",
[ODvendorclass]		"vendorclass",
[ODclientid]		"cid",
[ODtftpserver]		"tftpserver",
[ODbootfile]		"bf",
};

void	addropt(Req*, int, uchar*);
void	addrsopt(Req*, int, uchar**, int);
void	arpenter(uchar*, uchar*);
void	bootp(Req*);
void	byteopt(Req*, int, uchar);
void	dhcp(Req*);
void	fatal(int, char*, ...);
void	hexopt(Req*, int, char*);
void	logdhcp(Req*);
void	logdhcpout(Req *, char *);
void	longopt(Req*, int, long);
void	maskopt(Req*, int, uchar*);
void	miscoptions(Req*, uchar*);
int	openlisten(char *net);
void	p9addrsopt(Req *rp, int t, uchar **ip, int i);
void	parseoptions(Req*);
void	proto(Req*, int);
void	rcvdecline(Req*);
void	rcvdiscover(Req*);
void	rcvinform(Req*);
void	rcvrelease(Req*);
void	rcvrequest(Req*);
int	readlast(int, uchar*, int);
char*	readsysname(void);
void	remrequested(Req*, int);
void	sendack(Req*, uchar*, int, int);
void	sendnak(Req*, char*);
void	sendoffer(Req*, uchar*, int);
void	stringopt(Req*, int, char*);
void	termopt(Req*);
int	validip(uchar*);
void	vectoropt(Req*, int, uchar*, int);
void	warning(int, char*, ...);

void
timestamp(char *tag)
{
	uvlong t;

	t = nsec()/1000;
	syslog(0, blog, "%s %lludµs", tag, t - start);
}

void
usage(void)
{
	fprint(2, "usage: dhcp [-dmnprsSZ] [-f directory] [-M minlease] "
		"[-x netmtpt] [-Z staticlease] addr n [addr n] ...\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, n, fd;
	uchar ip[IPaddrlen];
	Req r;

	setnetmtpt(net, sizeof net, nil);

	fmtinstall('E', eipfmt);
	fmtinstall('I', eipfmt);
	fmtinstall('V', eipfmt);
	fmtinstall('M', eipfmt);
	ARGBEGIN {
	case '6':
		v6opts = 1;
		break;
	case 'd':
		debug = 1;
		break;
	case 'f':
		ndbfile = EARGF(usage());
		break;
	case 'm':
		mute = 1;
		break;
	case 'M':
		minlease = atoi(EARGF(usage()));
		if(minlease &lt;= 0)
			minlease = MinLease;
		break;
	case 'n':
		nobootp = 1;
		break;
	case 'p':
		pptponly = 1;
		break;
	case 'r':
		mutestat = 1;
		break;
	case 's':
		slowstat = 1;
		break;
	case 'S':
		slowdyn = 1;
		break;
	case 'x':
		setnetmtpt(net, sizeof net, EARGF(usage()));
		break;
	case 'Z':
		staticlease = atoi(EARGF(usage()));
		if(staticlease &lt;= 0)
			staticlease = StaticLease;
		break;
	default:
		usage();
		break;
	} ARGEND;

	while(argc &gt; 1){
		parseip(ip, argv[0]);
		if(!validip(ip))
			usage();
		n = atoi(argv[1]);
		if(n &lt;= 0)
			usage();
		initbinding(ip, n);
		argc -= 2;
		argv += 2;
	}

	/* for debugging */
	for(i = 0; i &lt; 256; i++)
		if(optname[i] == 0)
			optname[i] = smprint("%d", i);

	/* what is my name? */
	strcpy(mysysname, readsysname());

	/* put process in background */
	if(!debug)
	switch(rfork(RFNOTEG|RFPROC|RFFDG)) {
	case -1:
		fatal(1, "fork");
	case 0:
		break;
	default:
		exits(0);
	}

	if (chdir(TFTP) &lt; 0)
		warning(1, "can't change directory to %s", TFTP);
	fd = openlisten(net);

	for(;;){
		memset(&amp;r, 0, sizeof(r));
		r.fd = fd;
		n = readlast(r.fd, r.buf, sizeof(r.buf));
		if(n &lt; Udphdrsize)
			fatal(1, "error reading requests");
		start = nsec()/1000;
		op = optbuf;
		*op = 0;
		proto(&amp;r, n);
		if(r.id != nil)
			free(r.id);
	}
}

void
proto(Req *rp, int n)
{
	uchar relip[IPaddrlen];
	char buf[64];

	now = time(0);

	rp-&gt;e = rp-&gt;buf + n;
	rp-&gt;bp = (Bootp*)rp-&gt;buf;
	rp-&gt;up = (Udphdr*)rp-&gt;buf;
	if (ipcmp(rp-&gt;up-&gt;laddr, IPv4bcast) == 0){
		ipmove(rp-&gt;up-&gt;laddr, rp-&gt;up-&gt;ifcaddr);
		rp-&gt;broadcast = 1;
	}
	rp-&gt;max = rp-&gt;buf + Udphdrsize + MINSUPPORTED - IPUDPHDRSIZE;
	rp-&gt;p = rp-&gt;bp-&gt;optdata;
	v4tov6(rp-&gt;giaddr, rp-&gt;bp-&gt;giaddr);
	v4tov6(rp-&gt;ciaddr, rp-&gt;bp-&gt;ciaddr);

	if(pptponly &amp;&amp; rp-&gt;bp-&gt;htype != 0)
		return;

	ipifcs = readipifc(net, ipifcs, -1);
	if(validip(rp-&gt;giaddr))
		ipmove(relip, rp-&gt;giaddr);
	else if(validip(rp-&gt;up-&gt;raddr))
		ipmove(relip, rp-&gt;up-&gt;raddr);
	else
		ipmove(relip, rp-&gt;up-&gt;laddr);
	if(rp-&gt;e &lt; (uchar*)rp-&gt;bp-&gt;sname){
		warning(0, "packet too short");
		return;
	}
	if(rp-&gt;bp-&gt;op != Bootrequest){
		warning(0, "not bootrequest");
		return;
	}

	if(rp-&gt;e &gt;= rp-&gt;bp-&gt;optdata){
		if(memcmp(rp-&gt;bp-&gt;optmagic, plan9opt, sizeof(rp-&gt;bp-&gt;optmagic)) == 0)
			rp-&gt;p9request = 1;
		if(memcmp(rp-&gt;bp-&gt;optmagic, genericopt, sizeof(rp-&gt;bp-&gt;optmagic)) == 0) {
			rp-&gt;genrequest = 1;
			parseoptions(rp);
		}
	}
	rp-&gt;p = rp-&gt;bp-&gt;optdata;

	/*  If no id is specified, make one from the hardware address
	 *  of the target.  We assume all zeros is not a hardware address
	 *  which could be a mistake.
	 */
	if(rp-&gt;id == nil){
		if(rp-&gt;bp-&gt;hlen &gt; Maxhwlen){
			warning(0, "hlen %d", rp-&gt;bp-&gt;hlen);
			return;
		}
		if(memcmp(zeros, rp-&gt;bp-&gt;chaddr, rp-&gt;bp-&gt;hlen) == 0){
			warning(0, "no chaddr");
			return;
		}
		sprint(buf, "hwa%2.2ux_", rp-&gt;bp-&gt;htype);
		rp-&gt;id = tohex(buf, rp-&gt;bp-&gt;chaddr, rp-&gt;bp-&gt;hlen);
	}

	/* info about gateway */
	if(lookupip(relip, &amp;rp-&gt;gii, 1) &lt; 0){
		warning(0, "lookupip failed");
		return;
	}

	/* info about target system */
	if(lookup(rp-&gt;bp, &amp;rp-&gt;ii, &amp;rp-&gt;gii) == 0)
		if(rp-&gt;ii.indb &amp;&amp; rp-&gt;ii.dhcpgroup[0] == 0)
			rp-&gt;staticbinding = 1;

	if(rp-&gt;dhcptype)
		dhcp(rp);
	else
		bootp(rp);
	timestamp("done");
}

/*
 * since we are single-threaded, this causes us to effectively
 * stop listening while we sleep.
 */
static void
slowdelay(Req *rp)
{
	if(slowstat &amp;&amp; rp-&gt;staticbinding || slowdyn &amp;&amp; !rp-&gt;staticbinding)
		sleep(1000);
}

void
dhcp(Req *rp)
{
	logdhcp(rp);

	switch(rp-&gt;dhcptype){
	case Discover:
		slowdelay(rp);
		rcvdiscover(rp);
		break;
	case Request:
		rcvrequest(rp);
		break;
	case Decline:
		rcvdecline(rp);
		break;
	case Release:
		rcvrelease(rp);
		break;
	case Inform:
		rcvinform(rp);
		break;
	}
}

void
rcvdiscover(Req *rp)
{
	Binding *b, *nb;

	if(rp-&gt;staticbinding){
		sendoffer(rp, rp-&gt;ii.ipaddr, (staticlease &gt; minlease? staticlease: minlease));
		return;
	}

	/*
	 *  first look for an outstanding offer
	 */
	b = idtooffer(rp-&gt;id, &amp;rp-&gt;gii);

	/*
	 * rfc2131 says:
	 *   If an address is available, the new address
	 *   SHOULD be chosen as follows:
	 *
	 *      o The client's current address as recorded in the client's current
	 *        binding, ELSE
	 *
	 *      o The client's previous address as recorded in the client's (now
	 *        expired or released) binding, if that address is in the server's
	 *        pool of available addresses and not already allocated, ELSE
	 *
	 *      o The address requested in the 'Requested IP Address' option, if that
	 *        address is valid and not already allocated, ELSE
	 *
	 *      o A new address allocated from the server's pool of available
	 *        addresses; the address is selected based on the subnet from which
	 *        the message was received (if 'giaddr' is 0) or on the address of
	 *        the relay agent that forwarded the message ('giaddr' when not 0).
	 */
	if(b == nil){
		b = idtobinding(rp-&gt;id, &amp;rp-&gt;gii, 1);
		if(b &amp;&amp; b-&gt;boundto &amp;&amp; strcmp(b-&gt;boundto, rp-&gt;id) != 0)
		if(validip(rp-&gt;ip) &amp;&amp; samenet(rp-&gt;ip, &amp;rp-&gt;gii)){
			nb = iptobinding(rp-&gt;ip, 0);
			if(nb &amp;&amp; nb-&gt;lease &lt; now)
				b = nb;
		}
	}
	if(b == nil){
		warning(0, "!Discover(%s via %I): no binding %I",
			rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
		return;
	}
	mkoffer(b, rp-&gt;id, rp-&gt;leasetime);
	sendoffer(rp, b-&gt;ip, b-&gt;offer);
}

void
rcvrequest(Req *rp)
{
	Binding *b;

	if(validip(rp-&gt;server)){
		/* this is a reply to an offer - SELECTING */

		/* check for hard assignment */
		if(rp-&gt;staticbinding){
			if(forme(rp-&gt;server))
				sendack(rp, rp-&gt;ii.ipaddr,
					(staticlease &gt; minlease? staticlease:
					minlease), 1);
			else
				warning(0, "!Request(%s via %I): for server %I not me",
					rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;server);
			return;
		}

		b = idtooffer(rp-&gt;id, &amp;rp-&gt;gii);

		/* if we don't have an offer, nak */
		if(b == nil){
			warning(0, "!Request(%s via %I): no offer",
				rp-&gt;id, rp-&gt;gii.ipaddr);
			if(forme(rp-&gt;server))
				sendnak(rp, "no offer for you");
			return;
		}

		/* if not for me, retract offer */
		if(!forme(rp-&gt;server)){
			b-&gt;expoffer = 0;
			warning(0, "!Request(%s via %I): for server %I not me",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;server);
			return;
		}

		/*
		 *  if the client is confused about what we offered, nak.
		 *  client really shouldn't be specifying this when selecting
		 */
		if(validip(rp-&gt;ip) &amp;&amp; ipcmp(rp-&gt;ip, b-&gt;ip) != 0){
			warning(0, "!Request(%s via %I): requests %I, not %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip, b-&gt;ip);
			sendnak(rp, "bad ip address option");
			return;
		}
		if(commitbinding(b) &lt; 0){
			warning(0, "!Request(%s via %I): can't commit %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, b-&gt;ip);
			sendnak(rp, "can't commit binding");
			return;
		}
		sendack(rp, b-&gt;ip, b-&gt;offer, 1);
	} else if(validip(rp-&gt;ip)){
		/*
		 *  checking address/net - INIT-REBOOT
		 *
		 *  This is a rebooting client that remembers its old
		 *  address.
		 */
		/* check for hard assignment */
		if(rp-&gt;staticbinding){
			if(memcmp(rp-&gt;ip, rp-&gt;ii.ipaddr, IPaddrlen) != 0){
				warning(0, "!Request(%s via %I): %I not valid for %E",
					rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip, rp-&gt;bp-&gt;chaddr);
				sendnak(rp, "not valid");
			}
			sendack(rp, rp-&gt;ii.ipaddr, (staticlease &gt; minlease?
				staticlease: minlease), 1);
			return;
		}

		/* make sure the network makes sense */
		if(!samenet(rp-&gt;ip, &amp;rp-&gt;gii)){
			warning(0, "!Request(%s via %I): bad forward of %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
			sendnak(rp, "wrong network");
			return;
		}
		b = iptobinding(rp-&gt;ip, 0);
		if(b == nil){
			warning(0, "!Request(%s via %I): no binding for %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
			return;
		}
		if(memcmp(rp-&gt;ip, b-&gt;ip, IPaddrlen) != 0 || now &gt; b-&gt;lease){
			warning(0, "!Request(%s via %I): %I not valid",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
			sendnak(rp, "not valid");
			return;
		}
		b-&gt;offer = b-&gt;lease - now;
		sendack(rp, b-&gt;ip, b-&gt;offer, 1);
	} else if(validip(rp-&gt;ciaddr)){
		/*
		 *  checking address - RENEWING or REBINDING
		 *
		 *  these states are indistinguishable in our action.  The only
		 *  difference is how close to lease expiration the client is.
		 *  If it is really close, it broadcasts the request hoping that
		 *  some server will answer.
		 */

		/* check for hard assignment */
		if(rp-&gt;staticbinding){
			if(ipcmp(rp-&gt;ciaddr, rp-&gt;ii.ipaddr) != 0){
				warning(0, "!Request(%s via %I): %I not valid",
					rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ciaddr);
				sendnak(rp, "not valid");
			}
			sendack(rp, rp-&gt;ii.ipaddr, (staticlease &gt; minlease?
				staticlease: minlease), 1);
			return;
		}

		/* make sure the network makes sense */
		if(!samenet(rp-&gt;ciaddr, &amp;rp-&gt;gii)){
			warning(0, "!Request(%s via %I): bad forward of %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
			sendnak(rp, "wrong network");
			return;
		}
		b = iptobinding(rp-&gt;ciaddr, 0);
		if(b == nil){
			warning(0, "!Request(%s via %I): no binding for %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ciaddr);
			return;
		}
		if(ipcmp(rp-&gt;ciaddr, b-&gt;ip) != 0){
			warning(0, "!Request(%I via %s): %I not valid",
				rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ciaddr);
			sendnak(rp, "invalid ip address");
			return;
		}
		mkoffer(b, rp-&gt;id, rp-&gt;leasetime);
		if(commitbinding(b) &lt; 0){
			warning(0, "!Request(%s via %I): can't commit %I",
				rp-&gt;id, rp-&gt;gii.ipaddr, b-&gt;ip);
			sendnak(rp, "can't commit binding");
			return;
		}
		sendack(rp, b-&gt;ip, b-&gt;offer, 1);
	}
}

void
rcvdecline(Req *rp)
{
	Binding *b;
	char buf[64];

	if(rp-&gt;staticbinding)
		return;

	b = idtooffer(rp-&gt;id, &amp;rp-&gt;gii);
	if(b == nil){
		warning(0, "!Decline(%s via %I): no binding",
			rp-&gt;id, rp-&gt;gii.ipaddr);
		return;
	}

	/* mark ip address as in use */
	snprint(buf, sizeof(buf), "declined by %s", rp-&gt;id);
	mkoffer(b, buf, 0x7fffffff);
	commitbinding(b);
}

void
rcvrelease(Req *rp)
{
	Binding *b;

	if(rp-&gt;staticbinding)
		return;

	b = idtobinding(rp-&gt;id, &amp;rp-&gt;gii, 0);
	if(b == nil){
		warning(0, "!Release(%s via %I): no binding",
			rp-&gt;id, rp-&gt;gii.ipaddr);
		return;
	}
	if(strcmp(rp-&gt;id, b-&gt;boundto) != 0){
		warning(0, "!Release(%s via %I): invalid release of %I",
			rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
		return;
	}
	warning(0, "Release(%s via %I): releasing %I", b-&gt;boundto, rp-&gt;gii.ipaddr, b-&gt;ip);
	if(releasebinding(b, rp-&gt;id) &lt; 0)
		warning(0, "release: couldn't release");
}

void
rcvinform(Req *rp)
{
	Binding *b;

	if(rp-&gt;staticbinding){
		sendack(rp, rp-&gt;ii.ipaddr, 0, 0);
		return;
	}

	b = iptobinding(rp-&gt;ciaddr, 0);
	if(b == nil){
		warning(0, "!Inform(%s via %I): no binding for %I",
			rp-&gt;id, rp-&gt;gii.ipaddr, rp-&gt;ip);
		return;
	}
	sendack(rp, b-&gt;ip, 0, 0);
}

int
setsiaddr(uchar *siaddr, uchar *saddr, uchar *laddr)
{
	if(ipcmp(saddr, IPnoaddr) != 0){
		v6tov4(siaddr, saddr);
		return 0;
	} else {
		v6tov4(siaddr, laddr);
		return 1;
	}
}

int
ismuted(Req *rp)
{
	return mute || (mutestat &amp;&amp; rp-&gt;staticbinding);
}

void
sendoffer(Req *rp, uchar *ip, int offer)
{
	int n;
	ushort flags;
	Bootp *bp;
	Udphdr *up;

	bp = rp-&gt;bp;
	up = rp-&gt;up;

	/*
	 *  set destination
	 */
	flags = nhgets(bp-&gt;flags);
	if(validip(rp-&gt;giaddr)){
		ipmove(up-&gt;raddr, rp-&gt;giaddr);
		hnputs(up-&gt;rport, 67);
	} else if(flags &amp; Fbroadcast){
		ipmove(up-&gt;raddr, IPv4bcast);
		hnputs(up-&gt;rport, 68);
	} else {
		ipmove(up-&gt;raddr, ip);
		if(bp-&gt;htype == 1)
			arpenter(up-&gt;raddr, bp-&gt;chaddr);
		hnputs(up-&gt;rport, 68);
	}

	/*
	 *  fill in standard bootp part
	 */
	bp-&gt;op = Bootreply;
	bp-&gt;hops = 0;
	hnputs(bp-&gt;secs, 0);
	memset(bp-&gt;ciaddr, 0, sizeof(bp-&gt;ciaddr));
	v6tov4(bp-&gt;giaddr, rp-&gt;giaddr);
	v6tov4(bp-&gt;yiaddr, ip);
	setsiaddr(bp-&gt;siaddr, rp-&gt;ii.tftp, up-&gt;laddr);
	strncpy(bp-&gt;sname, mysysname, sizeof(bp-&gt;sname));
	strncpy(bp-&gt;file, rp-&gt;ii.bootf, sizeof(bp-&gt;file));

	/*
	 *  set options
	 */
	byteopt(rp, ODtype, Offer);
	longopt(rp, ODlease, offer);
	addropt(rp, ODserverid, up-&gt;laddr);
	miscoptions(rp, ip);
	termopt(rp);

	logdhcpout(rp, "Offer");

	/*
	 *  send
	 */
	n = rp-&gt;p - rp-&gt;buf;
	if(!ismuted(rp) &amp;&amp; write(rp-&gt;fd, rp-&gt;buf, n) != n)
		warning(0, "offer: write failed: %r");
}

void
sendack(Req *rp, uchar *ip, int offer, int sendlease)
{
	int n;
	ushort flags;
	Bootp *bp;
	Udphdr *up;

	bp = rp-&gt;bp;
	up = rp-&gt;up;

	/*
	 *  set destination
	 */
	flags = nhgets(bp-&gt;flags);
	if(validip(rp-&gt;giaddr)){
		ipmove(up-&gt;raddr, rp-&gt;giaddr);
		hnputs(up-&gt;rport, 67);
	} else if(flags &amp; Fbroadcast){
		ipmove(up-&gt;raddr, IPv4bcast);
		hnputs(up-&gt;rport, 68);
	} else {
		ipmove(up-&gt;raddr, ip);
		if(bp-&gt;htype == 1)
			arpenter(up-&gt;raddr, bp-&gt;chaddr);
		hnputs(up-&gt;rport, 68);
	}

	/*
	 *  fill in standard bootp part
	 */
	bp-&gt;op = Bootreply;
	bp-&gt;hops = 0;
	hnputs(bp-&gt;secs, 0);
	v6tov4(bp-&gt;giaddr, rp-&gt;giaddr);
	v6tov4(bp-&gt;yiaddr, ip);
	setsiaddr(bp-&gt;siaddr, rp-&gt;ii.tftp, up-&gt;laddr);
	strncpy(bp-&gt;sname, mysysname, sizeof(bp-&gt;sname));
	strncpy(bp-&gt;file, rp-&gt;ii.bootf, sizeof(bp-&gt;file));

	/*
	 *  set options
	 */
	byteopt(rp, ODtype, Ack);
	if(sendlease){
		longopt(rp, ODlease, offer);
	}
	addropt(rp, ODserverid, up-&gt;laddr);
	miscoptions(rp, ip);
	termopt(rp);

	logdhcpout(rp, "Ack");

	/*
	 *  send
	 */
	n = rp-&gt;p - rp-&gt;buf;
	if(!ismuted(rp) &amp;&amp; write(rp-&gt;fd, rp-&gt;buf, n) != n)
		warning(0, "ack: write failed: %r");
}

void
sendnak(Req *rp, char *msg)
{
	int n;
	Bootp *bp;
	Udphdr *up;

	bp = rp-&gt;bp;
	up = rp-&gt;up;

	/*
	 *  set destination (always broadcast)
	 */
	if(validip(rp-&gt;giaddr)){
		ipmove(up-&gt;raddr, rp-&gt;giaddr);
		hnputs(up-&gt;rport, 67);
	} else {
		ipmove(up-&gt;raddr, IPv4bcast);
		hnputs(up-&gt;rport, 68);
	}

	/*
	 *  fill in standard bootp part
	 */
	bp-&gt;op = Bootreply;
	bp-&gt;hops = 0;
	hnputs(bp-&gt;secs, 0);
	v6tov4(bp-&gt;giaddr, rp-&gt;giaddr);
	memset(bp-&gt;ciaddr, 0, sizeof(bp-&gt;ciaddr));
	memset(bp-&gt;yiaddr, 0, sizeof(bp-&gt;yiaddr));
	memset(bp-&gt;siaddr, 0, sizeof(bp-&gt;siaddr));

	/*
	 *  set options
	 */
	byteopt(rp, ODtype, Nak);
	addropt(rp, ODserverid, up-&gt;laddr);
	if(msg)
		stringopt(rp, ODmessage, msg);
	if(strncmp(rp-&gt;id, "id", 2) == 0)
		hexopt(rp, ODclientid, rp-&gt;id+2);
	termopt(rp);

	logdhcpout(rp, "Nak");

	/*
	 *  send nak
	 */
	n = rp-&gt;p - rp-&gt;buf;
	if(!ismuted(rp) &amp;&amp; write(rp-&gt;fd, rp-&gt;buf, n) != n)
		warning(0, "nak: write failed: %r");
}

void
bootp(Req *rp)
{
	int n;
	Bootp *bp;
	Udphdr *up;
	ushort flags;
	Iplifc *lifc;
	Info *iip;

	warning(0, "bootp %s %I-&gt;%I from %s via %I, file %s %s",
		rp-&gt;genrequest? "generic": (rp-&gt;p9request? "p9": ""),
		rp-&gt;up-&gt;raddr, rp-&gt;up-&gt;laddr,
		rp-&gt;id, rp-&gt;gii.ipaddr,
		rp-&gt;bp-&gt;file, rp-&gt;broadcast? "broadcast": "unicast");

	if(nobootp)
		return;

	bp = rp-&gt;bp;
	up = rp-&gt;up;
	iip = &amp;rp-&gt;ii;

	if(rp-&gt;staticbinding == 0){
		warning(0, "bootp from unknown %s via %I", rp-&gt;id, rp-&gt;gii.ipaddr);
		return;
	}

	/* ignore if not for us */
	if(*bp-&gt;sname){
		if(strcmp(bp-&gt;sname, mysysname) != 0){
			bp-&gt;sname[20] = 0;
			warning(0, "bootp for server %s", bp-&gt;sname);
			return;
		}
	} else
		slowdelay(rp);

	/* ignore if we don't know what file to load */
	if(*bp-&gt;file == 0){
		if(rp-&gt;genrequest &amp;&amp; *iip-&gt;bootf2) /* if not plan 9 &amp; have alternate file... */
			strncpy(bp-&gt;file, iip-&gt;bootf2, sizeof(bp-&gt;file));
		else if(*iip-&gt;bootf)
			strncpy(bp-&gt;file, iip-&gt;bootf, sizeof(bp-&gt;file));
		else if(*bp-&gt;sname) /* if we were asked, respond no matter what */
			bp-&gt;file[0] = '\0';
		else {
			warning(0, "no bootfile for %I", iip-&gt;ipaddr);
			return;
		}
	}

	/* ignore if the file is unreadable */
	if((!rp-&gt;genrequest) &amp;&amp; bp-&gt;file[0] &amp;&amp; access(bp-&gt;file, 4) &lt; 0){
		warning(0, "inaccessible bootfile1 %s", bp-&gt;file);
		return;
	}

	bp-&gt;op = Bootreply;
	v6tov4(bp-&gt;yiaddr, iip-&gt;ipaddr);
	if(rp-&gt;p9request){
		warning(0, "p9bootp: %I", iip-&gt;ipaddr);
		memmove(bp-&gt;optmagic, plan9opt, 4);
		if(iip-&gt;gwip == 0)
			v4tov6(iip-&gt;gwip, bp-&gt;giaddr);
		rp-&gt;p += sprint((char*)rp-&gt;p, "%V %I %I %I", iip-&gt;ipmask+IPv4off, iip-&gt;fsip,
				iip-&gt;auip, iip-&gt;gwip);
		sprint(optbuf, "%s", (char*)(bp-&gt;optmagic));
	} else if(rp-&gt;genrequest){
		warning(0, "genericbootp: %I", iip-&gt;ipaddr);
		memmove(bp-&gt;optmagic, genericopt, 4);
		miscoptions(rp, iip-&gt;ipaddr);
		termopt(rp);
	} else if(iip-&gt;vendor[0] != 0) {
		warning(0, "bootp vendor field: %s", iip-&gt;vendor);
		memset(rp-&gt;p, 0, 128-4);
		rp-&gt;p += sprint((char*)bp-&gt;optmagic, "%s", iip-&gt;vendor);
	} else {
		memset(rp-&gt;p, 0, 128-4);
		rp-&gt;p += 128-4;
	}

	/*
	 *  set destination
	 */
	flags = nhgets(bp-&gt;flags);
	if(validip(rp-&gt;giaddr)){
		ipmove(up-&gt;raddr, rp-&gt;giaddr);
		hnputs(up-&gt;rport, 67);
	} else if(flags &amp; Fbroadcast){
		ipmove(up-&gt;raddr, IPv4bcast);
		hnputs(up-&gt;rport, 68);
	} else {
		v4tov6(up-&gt;raddr, bp-&gt;yiaddr);
		if(bp-&gt;htype == 1)
			arpenter(up-&gt;raddr, bp-&gt;chaddr);
		hnputs(up-&gt;rport, 68);
	}

	/*
	 *  select best local address if destination is directly connected
	 */
	lifc = findlifc(up-&gt;raddr);
	if(lifc)
		ipmove(up-&gt;laddr, lifc-&gt;ip);

	/*
	 *  our identity
	 */
	strncpy(bp-&gt;sname, mysysname, sizeof(bp-&gt;sname));

	/*
	 *  set tftp server
	 */
	setsiaddr(bp-&gt;siaddr, iip-&gt;tftp, up-&gt;laddr);
	if(rp-&gt;genrequest &amp;&amp; *iip-&gt;bootf2)
		setsiaddr(bp-&gt;siaddr, iip-&gt;tftp2, up-&gt;laddr);

	/*
	 * RFC 1048 says that we must pad vendor field with
	 * zeros until we have a 64 byte field.
	 */
	n = rp-&gt;p - rp-&gt;bp-&gt;optdata;
	if(n &lt; 64-4) {
		memset(rp-&gt;p, 0, (64-4)-n);
		rp-&gt;p += (64-4)-n;
	}

	/*
	 *  send
	 */
	n = rp-&gt;p - rp-&gt;buf;
	if(!ismuted(rp) &amp;&amp; write(rp-&gt;fd, rp-&gt;buf, n) != n)
		warning(0, "bootp: write failed: %r");

	warning(0, "bootp via %I: file %s xid(%ux)flag(%ux)ci(%V)gi(%V)yi(%V)si(%V) %s",
			up-&gt;raddr, bp-&gt;file, nhgetl(bp-&gt;xid), nhgets(bp-&gt;flags),
			bp-&gt;ciaddr, bp-&gt;giaddr, bp-&gt;yiaddr, bp-&gt;siaddr,
			optbuf);
}

void
parseoptions(Req *rp)
{
	int n, c, code;
	uchar *o, *p;

	p = rp-&gt;p;

	while(p &lt; rp-&gt;e){
		code = *p++;
		if(code == 255)
			break;
		if(code == 0)
			continue;

		/* ignore anything that's too long */
		n = *p++;
		o = p;
		p += n;
		if(p &gt; rp-&gt;e)
			return;

		switch(code){
		case ODipaddr:	/* requested ip address */
			if(n == IPv4addrlen)
				v4tov6(rp-&gt;ip, o);
			break;
		case ODlease:	/* requested lease time */
			rp-&gt;leasetime = nhgetl(o);
			if(rp-&gt;leasetime &gt; MaxLease || rp-&gt;leasetime &lt; 0)
				rp-&gt;leasetime = MaxLease;
			break;
		case ODtype:
			c = *o;
			if(c &lt; 10 &amp;&amp; c &gt; 0)
				rp-&gt;dhcptype = c;
			break;
		case ODserverid:
			if(n == IPv4addrlen)
				v4tov6(rp-&gt;server, o);
			break;
		case ODmessage:
			if(n &gt; sizeof rp-&gt;msg-1)
				n = sizeof rp-&gt;msg-1;
			memmove(rp-&gt;msg, o, n);
			rp-&gt;msg[n] = 0;
			break;
		case ODmaxmsg:
			c = nhgets(o);
			c -= 28;
			c += Udphdrsize;
			if(c &gt; 0)
				rp-&gt;max = rp-&gt;buf + c;
			break;
		case ODclientid:
			if(n &lt;= 1)
				break;
			rp-&gt;id = toid( o, n);
			break;
		case ODparams:
			if(n &gt; sizeof(rp-&gt;requested))
				n = sizeof(rp-&gt;requested);
			memmove(rp-&gt;requested, o, n);
			break;
		case ODvendorclass:
			if(n &gt;= sizeof(rp-&gt;vendorclass))
				n = sizeof(rp-&gt;vendorclass)-1;
			memmove(rp-&gt;vendorclass, o, n);
			rp-&gt;vendorclass[n] = 0;
			if(strncmp((char*)rp-&gt;vendorclass, "p9-", 3) == 0)
				strcpy(rp-&gt;cputype, (char*)rp-&gt;vendorclass+3);
			break;
		case OBend:
			return;
		}
	}
}

void
remrequested(Req *rp, int opt)
{
	uchar *p;

	p = memchr(rp-&gt;requested, opt, sizeof(rp-&gt;requested));
	if(p != nil)
		*p = OBpad;
}

void
miscoptions(Req *rp, uchar *ip)
{
	int i, j, na;
	uchar x[2*IPaddrlen], vopts[Maxoptlen];
	uchar *op, *omax;
	uchar *addrs[2];
	char *p;
	char *attr[100], **a;
	Ndbtuple *t;

	addrs[0] = x;
	addrs[1] = x+IPaddrlen;

	/* always supply these */
	maskopt(rp, OBmask, rp-&gt;gii.ipmask);
	if(validip(rp-&gt;gii.gwip)){
		remrequested(rp, OBrouter);
		addropt(rp, OBrouter, rp-&gt;gii.gwip);
	} else if(validip(rp-&gt;giaddr)){
		remrequested(rp, OBrouter);
		addropt(rp, OBrouter, rp-&gt;giaddr);
	}

	/*
	 * OBhostname for the HP4000M switches
	 * (this causes NT to log infinite errors - tough shit)
	 */
	if(*rp-&gt;ii.domain){
		remrequested(rp, OBhostname);
		stringopt(rp, OBhostname, rp-&gt;ii.domain);
	}
	if(*rp-&gt;ii.rootpath)
		stringopt(rp, OBrootpath, rp-&gt;ii.rootpath);

	/* figure out what we need to lookup */
	na = 0;
	a = attr;
	if(*rp-&gt;ii.domain == 0)
		a[na++] = "dom";
	for(i = 0; i &lt; sizeof(rp-&gt;requested); i++)
		switch(rp-&gt;requested[i]){
		case OBrouter:
			a[na++] = "@ipgw";
			break;
		case OBdnserver:
			a[na++] = "@dns";
			break;
		case OBnetbiosns:
			a[na++] = "@wins";
			break;
		case OBsmtpserver:
			a[na++] = "@smtp";
			break;
		case OBpop3server:
			a[na++] = "@pop3";
			break;
		case OBwwwserver:
			a[na++] = "@www";
			break;
		case OBntpserver:
			a[na++] = "@ntp";
			break;
		case OBtimeserver:
			a[na++] = "@time";
			break;
		}
	if(strncmp((char*)rp-&gt;vendorclass, "plan9_", 6) == 0
	|| strncmp((char*)rp-&gt;vendorclass, "p9-", 3) == 0){
		a[na++] = "@fs";
		a[na++] = "@auth";
	}
	t = lookupinfo(ip, a, na);

	/* lookup anything we might be missing */
	if(*rp-&gt;ii.domain == 0)
		lookupname(rp-&gt;ii.domain, t);

	/* add any requested ones that we know about */
	for(i = 0; i &lt; sizeof(rp-&gt;requested); i++)
		switch(rp-&gt;requested[i]){
		case OBrouter:
			j = lookupserver("ipgw", addrs, t);
			addrsopt(rp, OBrouter, addrs, j);
			break;
		case OBdnserver:
			j = lookupserver("dns", addrs, t);
			addrsopt(rp, OBdnserver, addrs, j);
			break;
		case OBhostname:
			if(*rp-&gt;ii.domain)
				stringopt(rp, OBhostname, rp-&gt;ii.domain);
			break;
		case OBdomainname:
			p = strchr(rp-&gt;ii.domain, '.');
			if(p)
				stringopt(rp, OBdomainname, p+1);
			break;
		case OBnetbiosns:
			j = lookupserver("wins", addrs, t);
			addrsopt(rp, OBnetbiosns, addrs, j);
			break;
		case OBnetbiostype:
			/* p-node: peer to peer WINS queries */
			byteopt(rp, OBnetbiostype, 0x2);
			break;
		case OBsmtpserver:
			j = lookupserver("smtp", addrs, t);
			addrsopt(rp, OBsmtpserver, addrs, j);
			break;
		case OBpop3server:
			j = lookupserver("pop3", addrs, t);
			addrsopt(rp, OBpop3server, addrs, j);
			break;
		case OBwwwserver:
			j = lookupserver("www", addrs, t);
			addrsopt(rp, OBwwwserver, addrs, j);
			break;
		case OBntpserver:
			j = lookupserver("ntp", addrs, t);
			addrsopt(rp, OBntpserver, addrs, j);
			break;
		case OBtimeserver:
			j = lookupserver("time", addrs, t);
			addrsopt(rp, OBtimeserver, addrs, j);
			break;
		case OBttl:
			byteopt(rp, OBttl, 255);
			break;
		}

	/* add plan9 specific options */
	if(strncmp((char*)rp-&gt;vendorclass, "plan9_", 6) == 0
	|| strncmp((char*)rp-&gt;vendorclass, "p9-", 3) == 0){
		/* point to temporary area */
		op = rp-&gt;p;
		omax = rp-&gt;max;
		/* stash encoded options in vopts */
		rp-&gt;p = vopts;
		rp-&gt;max = vopts + sizeof(vopts) - 1;

		/* emit old v4 addresses first to make sure that they fit */
		addrsopt(rp, OP9fsv4, addrs, lookupserver("fs", addrs, t));
		addrsopt(rp, OP9authv4, addrs, lookupserver("auth", addrs, t));

		p9addrsopt(rp, OP9fs, addrs, lookupserver("fs", addrs, t));
		p9addrsopt(rp, OP9auth, addrs, lookupserver("auth", addrs, t));
		p9addrsopt(rp, OP9ipaddr, addrs, lookupserver("ip", addrs, t));
		p9addrsopt(rp, OP9ipmask, addrs, lookupserver("ipmask", addrs, t));
		p9addrsopt(rp, OP9ipgw, addrs, lookupserver("ipgw", addrs, t));

		/* point back to packet, encapsulate vopts into packet */
		j = rp-&gt;p - vopts;
		rp-&gt;p = op;
		rp-&gt;max = omax;
		vectoropt(rp, OBvendorinfo, vopts, j);
	}

	ndbfree(t);
}

int
openlisten(char *net)
{
	int fd, cfd;
	char data[128], devdir[40];

	sprint(data, "%s/udp!*!bootp", net);
	cfd = announce(data, devdir);
	if(cfd &lt; 0)
		fatal(1, "can't announce");
	if(fprint(cfd, "headers") &lt; 0)
		fatal(1, "can't set header mode");

	sprint(data, "%s/data", devdir);
	fd = open(data, ORDWR);
	if(fd &lt; 0)
		fatal(1, "open udp data");
	return fd;
}

void
fatal(int syserr, char *fmt, ...)
{
	char buf[Maxloglen];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	if(syserr)
		syslog(1, blog, "%s: %r", buf);
	else
		syslog(1, blog, "%s", buf);
	exits(buf);
}

void
warning(int syserr, char *fmt, ...)
{
	char buf[Maxloglen];
	va_list arg;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	if(syserr){
		syslog(0, blog, "%s: %r", buf);
		if(debug)
			fprint(2, "%s: %r\n", buf);
	} else {
		syslog(0, blog, "%s", buf);
		if(debug)
			fprint(2, "%s\n", buf);
	}
}

char*
readsysname(void)
{
	static char name[128];
	char *p;
	int n, fd;

	fd = open("/dev/sysname", OREAD);
	if(fd &gt;= 0){
		n = read(fd, name, sizeof(name)-1);
		close(fd);
		if(n &gt; 0){
			name[n] = 0;
			return name;
		}
	}
	p = getenv("sysname");
	if(p == nil || *p == 0)
		return "unknown";
	return p;
}

extern int
validip(uchar *ip)
{
	if(ipcmp(ip, IPnoaddr) == 0)
		return 0;
	if(ipcmp(ip, v4prefix) == 0)
		return 0;
	return 1;
}

void
longopt(Req *rp, int t, long v)
{
	if(rp-&gt;p + 6 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = 4;
	hnputl(rp-&gt;p, v);
	rp-&gt;p += 4;

	op = seprint(op, oe, "%s(%ld)", optname[t], v);
}

void
addropt(Req *rp, int t, uchar *ip)
{
	if(rp-&gt;p + 6 &gt; rp-&gt;max)
		return;
	if (!isv4(ip)) {
		if (debug)
			warning(0, "not a v4 %s server: %I", optname[t], ip);
		return;
	}
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = 4;
	memmove(rp-&gt;p, ip+IPv4off, 4);
	rp-&gt;p += 4;

	op = seprint(op, oe, "%s(%I)", optname[t], ip);
}

void
maskopt(Req *rp, int t, uchar *ip)
{
	if(rp-&gt;p + 6 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = 4;
	memmove(rp-&gt;p, ip+IPv4off, 4);
	rp-&gt;p += 4;

	op = seprint(op, oe, "%s(%M)", optname[t], ip);
}

void
addrsopt(Req *rp, int t, uchar **ip, int i)
{
	int v4s, n;

	if(i &lt;= 0)
		return;
	if(rp-&gt;p + 2 + 4*i &gt; rp-&gt;max)
		return;
	v4s = 0;
	for(n = i; n-- &gt; 0; )
		if (isv4(ip[n]))
			v4s++;
	if (v4s &lt;= 0) {
		if (debug)
			warning(0, "no v4 %s servers", optname[t]);
		return;
	}
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = 4*v4s;
	op = seprint(op, oe, " %s(", optname[t]);
	while(i-- &gt; 0){
		if (!isv4(*ip)) {
			op = seprint(op, oe, " skipping %I ", *ip);
			continue;
		}
		v6tov4(rp-&gt;p, *ip);
		rp-&gt;p += 4;
		op = seprint(op, oe, "%I", *ip);
		ip++;
		if(i &gt; 0)
			op = seprint(op, oe, " ");
	}
	op = seprint(op, oe, ")");
}

void
p9addrsopt(Req *rp, int t, uchar **ip, int i)
{
	char *pkt, *payload;

	if(i &lt;= 0 || !v6opts)
		return;
	pkt = (char *)rp-&gt;p;
	*pkt++ = t;			/* option */
	pkt++;				/* fill in payload length below */
	payload = pkt;
	*pkt++ = i;			/* plan 9 address count */
	op = seprint(op, oe, " %s(", optname[t]);
	while(i-- &gt; 0){
		pkt = seprint(pkt, (char *)rp-&gt;max, "%I", *ip);
		if ((uchar *)pkt+1 &gt;= rp-&gt;max) {
			op = seprint(op, oe, "&lt;out of mem1&gt;)");
			return;
		}
		pkt++;			/* leave NUL as terminator */
		op = seprint(op, oe, "%I", *ip);
		ip++;
		if(i &gt; 0)
			op = seprint(op, oe, " ");
	}
	if ((uchar *)pkt - rp-&gt;p &gt; 0377) {
		op = seprint(op, oe, "&lt;out of mem2&gt;)");
		return;
	}
	op = seprint(op, oe, ")");
	rp-&gt;p[1] = pkt - payload;	/* payload length */
	rp-&gt;p = (uchar *)pkt;
}

void
byteopt(Req *rp, int t, uchar v)
{
	if(rp-&gt;p + 3 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = 1;
	*rp-&gt;p++ = v;

	op = seprint(op, oe, "%s(%d)", optname[t], v);
}

void
termopt(Req *rp)
{
	if(rp-&gt;p + 1 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = OBend;
}

void
stringopt(Req *rp, int t, char *str)
{
	int n;

	n = strlen(str);
	if(n &gt; 255)
		n = 255;
	if(rp-&gt;p+n+2 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = n;
	memmove(rp-&gt;p, str, n);
	rp-&gt;p += n;

	op = seprint(op, oe, "%s(%s)", optname[t], str);
}

void
vectoropt(Req *rp, int t, uchar *v, int n)
{
	int i;

	if(n &gt; 255) {
		n = 255;
		op = seprint(op, oe, "vectoropt len %d &gt; 255 ", n);
	}
	if(rp-&gt;p+n+2 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = n;
	memmove(rp-&gt;p, v, n);
	rp-&gt;p += n;

	op = seprint(op, oe, "%s(", optname[t]);
	if(n &gt; 0)
		op = seprint(op, oe, "%ud", v[0]);
	for(i = 1; i &lt; n; i++)
		op = seprint(op, oe, " %ud", v[i]);
	op = seprint(op, oe, ")");
}

int
fromhex(int x)
{
	if(x &gt;= '0' &amp;&amp; x &lt;= '9')
		return x - '0';
	return x - 'a';
}

void
hexopt(Req *rp, int t, char *str)
{
	int n;

	n = strlen(str);
	n /= 2;
	if(n &gt; 255)
		n = 255;
	if(rp-&gt;p+n+2 &gt; rp-&gt;max)
		return;
	*rp-&gt;p++ = t;
	*rp-&gt;p++ = n;
	while(n-- &gt; 0){
		*rp-&gt;p++ = (fromhex(str[0])&lt;&lt;4)|fromhex(str[1]);
		str += 2;
	}

	op = seprint(op, oe, "%s(%s)", optname[t], str);
}

void
arpenter(uchar *ip, uchar *ether)
{
	int f;
	char buf[256];

	sprint(buf, "%s/arp", net);
	f = open(buf, OWRITE);
	if(f &lt; 0){
		syslog(debug, blog, "open %s: %r", buf);
		return;
	}
	fprint(f, "add ether %I %E", ip, ether);
	close(f);
}

char *dhcpmsgname[] =
{
	[Discover]	"Discover",
	[Offer]		"Offer",
	[Request]	"Request",
	[Decline]	"Decline",
	[Ack]		"Ack",
	[Nak]		"Nak",
	[Release]	"Release",
	[Inform]	"Inform",
};

void
logdhcp(Req *rp)
{
	char buf[4096];
	char *p, *e;
	int i;

	p = buf;
	e = buf + sizeof(buf);
	if(rp-&gt;dhcptype &gt; 0 &amp;&amp; rp-&gt;dhcptype &lt;= Inform)
		p = seprint(p, e, "%s(", dhcpmsgname[rp-&gt;dhcptype]);
	else
		p = seprint(p, e, "%d(", rp-&gt;dhcptype);
	p = seprint(p, e, "%I-&gt;%I) xid(%ux)flag(%ux)", rp-&gt;up-&gt;raddr, rp-&gt;up-&gt;laddr,
		nhgetl(rp-&gt;bp-&gt;xid), nhgets(rp-&gt;bp-&gt;flags));
	if(rp-&gt;bp-&gt;htype == 1)
		p = seprint(p, e, "ea(%E)", rp-&gt;bp-&gt;chaddr);
	if(validip(rp-&gt;ciaddr))
		p = seprint(p, e, "ci(%I)", rp-&gt;ciaddr);
	if(validip(rp-&gt;giaddr))
		p = seprint(p, e, "gi(%I)", rp-&gt;giaddr);
	if(validip(rp-&gt;ip))
		p = seprint(p, e, "ip(%I)", rp-&gt;ip);
	if(rp-&gt;id != nil)
		p = seprint(p, e, "id(%s)", rp-&gt;id);
	if(rp-&gt;leasetime)
		p = seprint(p, e, "leas(%d)", rp-&gt;leasetime);
	if(validip(rp-&gt;server))
		p = seprint(p, e, "sid(%I)", rp-&gt;server);
	p = seprint(p, e, "need(");
	for(i = 0; i &lt; sizeof(rp-&gt;requested); i++)
		if(rp-&gt;requested[i] != 0)
			p = seprint(p, e, "%s ", optname[rp-&gt;requested[i]]);
	p = seprint(p, e, ")");
	p = seprint(p, e, " %s", rp-&gt;broadcast? "broadcast": "unicast");
	USED(p);
	syslog(0, blog, "%s", buf);
}

void
logdhcpout(Req *rp, char *type)
{
	syslog(0, blog, "%s(%I-%I)id(%s)ci(%V)gi(%V)yi(%V)si(%V) %s",
		type, rp-&gt;up-&gt;laddr, rp-&gt;up-&gt;raddr, rp-&gt;id,
		rp-&gt;bp-&gt;ciaddr, rp-&gt;bp-&gt;giaddr, rp-&gt;bp-&gt;yiaddr, rp-&gt;bp-&gt;siaddr, optbuf);
}

/*
 *  if we get behind, it's useless to try answering since the sender
 *  will probably have retransmitted with a differnt sequence number.
 *  So dump all but the last message in the queue.
 */
void
ding(void*, char *msg)
{
	if(strstr(msg, "alarm"))
		noted(NCONT);
	else
		noted(NDFLT);
}

int
readlast(int fd, uchar *buf, int len)
{
	int lastn, n;

	notify(ding);

	lastn = 0;
	for(;;){
		alarm(20);
		n = read(fd, buf, len);
		alarm(0);
		if(n &lt; 0){
			if(lastn &gt; 0)
				return lastn;
			break;
		}
		lastn = n;
	}
	return read(fd, buf, len);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

