<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/dhcpd/ndb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/dhcpd/ndb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  this currently only works for ethernet bootp's -- presotto
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include "dat.h"

static Ndb *db;
char *ndbfile;

/*
 * open ndbfile as db if not already open.  also check for stale data
 * and reload as needed.
 */
static Ndb *
opendb(void)
{
	static ulong lastcheck;

	/* check no more often than once every minute */
	if(db == nil) {
		db = ndbopen(ndbfile);
		if(db != nil)
			lastcheck = now;
	} else if(now &gt;= lastcheck + 60) {
		if (ndbchanged(db))
			ndbreopen(db);
		lastcheck = now;
	}
	return db;
}

Iplifc*
findlifc(uchar *ip)
{
	uchar x[IPaddrlen];
	Ipifc *ifc;
	Iplifc *lifc;

	for(ifc = ipifcs; ifc; ifc = ifc-&gt;next){
		for(lifc = ifc-&gt;lifc; lifc != nil; lifc = lifc-&gt;next){
			if(lifc-&gt;net[0] == 0)
				continue;
			maskip(ip, lifc-&gt;mask, x);
			if(memcmp(x, lifc-&gt;net, IPaddrlen) == 0)
				return lifc;
		}
	}
	return nil;
}

int
forme(uchar *ip)
{
	Ipifc *ifc;
	Iplifc *lifc;

	for(ifc = ipifcs; ifc; ifc = ifc-&gt;next){
		for(lifc = ifc-&gt;lifc; lifc != nil; lifc = lifc-&gt;next)
			if(memcmp(ip, lifc-&gt;ip, IPaddrlen) == 0)
				return 1;
	}
	return 0;
}

uchar noetheraddr[6];

static void
setipaddr(uchar *addr, char *ip)
{
	if(ipcmp(addr, IPnoaddr) == 0)
		parseip(addr, ip);
}

static void
setipmask(uchar *mask, char *ip)
{
	if(ipcmp(mask, IPnoaddr) == 0)
		parseipmask(mask, ip);
}

/*
 *  do an ipinfo with defaults
 */
int
lookupip(uchar *ipaddr, Info *iip, int gate)
{
	char ip[32];
	Ndbtuple *t, *nt;
	char *attrs[32], **p;

	if(opendb() == nil){
		warning(1, "can't open db");
		return -1;
	}

	p = attrs;
	*p++ = "ip";
	*p++ = "ipmask";
	*p++ = "@ipgw";
	if(!gate){
		*p++ = "bootf";
		*p++ = "bootf2";
		*p++ = "@tftp";
		*p++ = "@tftp2";
		*p++ = "rootpath";
		*p++ = "dhcp";
		*p++ = "vendorclass";
		*p++ = "ether";
		*p++ = "dom";
		*p++ = "@fs";
		*p++ = "@auth";
	}
	*p = 0;

	memset(iip, 0, sizeof(*iip));
	snprint(ip, sizeof(ip), "%I", ipaddr);
	t = ndbipinfo(db, "ip", ip, attrs, p - attrs);
	if(t == nil)
		return -1;
	
	for(nt = t; nt != nil; nt = nt-&gt;entry){
		if(strcmp(nt-&gt;attr, "ip") == 0)
			setipaddr(iip-&gt;ipaddr, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "ipmask") == 0)
			setipmask(iip-&gt;ipmask, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "fs") == 0)
			setipaddr(iip-&gt;fsip, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "auth") == 0)
			setipaddr(iip-&gt;auip, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "tftp") == 0)
			setipaddr(iip-&gt;tftp, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "tftp2") == 0)
			setipaddr(iip-&gt;tftp2, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "ipgw") == 0)
			setipaddr(iip-&gt;gwip, nt-&gt;val);
		else
		if(strcmp(nt-&gt;attr, "ether") == 0){
			/*
			 * this is probably wrong for machines with multiple
			 * ethers.  bootp or dhcp requests could come from any
			 * of the ethers listed in the ndb entry.
			 */
			if(memcmp(iip-&gt;etheraddr, noetheraddr, 6) == 0)
				parseether(iip-&gt;etheraddr, nt-&gt;val);
			iip-&gt;indb = 1;
		}
		else
		if(strcmp(nt-&gt;attr, "dhcp") == 0){
			if(iip-&gt;dhcpgroup[0] == 0)
				strcpy(iip-&gt;dhcpgroup, nt-&gt;val);
		}
		else
		if(strcmp(nt-&gt;attr, "bootf") == 0){
			if(iip-&gt;bootf[0] == 0)
				strcpy(iip-&gt;bootf, nt-&gt;val);
		}
		else
		if(strcmp(nt-&gt;attr, "bootf2") == 0){
			if(iip-&gt;bootf2[0] == 0)
				strcpy(iip-&gt;bootf2, nt-&gt;val);
		}
		else
		if(strcmp(nt-&gt;attr, "vendor") == 0){
			if(iip-&gt;vendor[0] == 0)
				strcpy(iip-&gt;vendor, nt-&gt;val);
		}
		else
		if(strcmp(nt-&gt;attr, "dom") == 0){
			if(iip-&gt;domain[0] == 0)
				strcpy(iip-&gt;domain, nt-&gt;val);
		}
		else
		if(strcmp(nt-&gt;attr, "rootpath") == 0){
			if(iip-&gt;rootpath[0] == 0)
				strcpy(iip-&gt;rootpath, nt-&gt;val);
		}
	}
	ndbfree(t);
	maskip(iip-&gt;ipaddr, iip-&gt;ipmask, iip-&gt;ipnet);
	return 0;
}

static uchar zeroes[6];

/*
 *  lookup info about a client in the database.  Find an address on the
 *  same net as riip.
 */
int
lookup(Bootp *bp, Info *iip, Info *riip)
{
	Ndbtuple *t, *nt;
	Ndbs s;
	char *hwattr;
	char *hwval, hwbuf[33];
	uchar ciaddr[IPaddrlen];

	if(opendb() == nil){
		warning(1, "can't open db");
		return -1;
	}

	memset(iip, 0, sizeof(*iip));

	/* client knows its address? */
	v4tov6(ciaddr, bp-&gt;ciaddr);
	if(validip(ciaddr)){
		if(lookupip(ciaddr, iip, 0) &lt; 0) {
			if (debug)
				warning(0, "don't know %I", ciaddr);
			return -1;	/* don't know anything about it */
		}
		if(!samenet(riip-&gt;ipaddr, iip)){
			warning(0, "%I not on %I", ciaddr, riip-&gt;ipnet);
			return -1;
		}

		/*
		 *  see if this is a masquerade, i.e., if the ether
		 *  address doesn't match what we expected it to be.
		 */
		if(memcmp(iip-&gt;etheraddr, zeroes, 6) != 0)
		if(memcmp(bp-&gt;chaddr, iip-&gt;etheraddr, 6) != 0)
			warning(0, "ciaddr %I rcvd from %E instead of %E",
				ciaddr, bp-&gt;chaddr, iip-&gt;etheraddr);

		return 0;
	}

	if(bp-&gt;hlen &gt; Maxhwlen)
		return -1;
	switch(bp-&gt;htype){
	case 1:
		hwattr = "ether";
		hwval = hwbuf;
		snprint(hwbuf, sizeof(hwbuf), "%E", bp-&gt;chaddr);
		break;
	default:
		syslog(0, blog, "not ethernet %E, htype %d, hlen %d",
			bp-&gt;chaddr, bp-&gt;htype, bp-&gt;hlen);
		return -1;
	}

	/*
	 *  use hardware address to find an ip address on
	 *  same net as riip
	 */
	t = ndbsearch(db, &amp;s, hwattr, hwval);
	while(t){
		for(nt = t; nt; nt = nt-&gt;entry){
			if(strcmp(nt-&gt;attr, "ip") != 0)
				continue;
			parseip(ciaddr, nt-&gt;val);
			if(lookupip(ciaddr, iip, 0) &lt; 0)
				continue;
			if(samenet(riip-&gt;ipaddr, iip)){
				ndbfree(t);
				return 0;
			}
		}
		ndbfree(t);
		t = ndbsnext(&amp;s, hwattr, hwval);
	}
	return -1;
}

/*
 *  interface to ndbipinfo
 */
Ndbtuple*
lookupinfo(uchar *ipaddr, char **attr, int n)
{
	char ip[32];

	sprint(ip, "%I", ipaddr);
	return ndbipinfo(db, "ip", ip, attr, n);
}

/*
 *  return the ip addresses for a type of server for system ip
 */
int
lookupserver(char *attr, uchar **ipaddrs, Ndbtuple *t)
{
	Ndbtuple *nt;
	int rv = 0;

	for(nt = t; rv &lt; 2 &amp;&amp; nt != nil; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, attr) == 0){
			parseip(ipaddrs[rv], nt-&gt;val);
			rv++;
		}
	return rv;
}

/*
 *  just lookup the name
 */
void
lookupname(char *val, Ndbtuple *t)
{
	Ndbtuple *nt;

	for(nt = t; nt != nil; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "dom") == 0){
			strcpy(val, nt-&gt;val);
			break;
		}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

