<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/gping.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/gping.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;
#include &lt;ip.h&gt;
#include "icmp.h"

#define	MAXNUM	8	/* maximum number of numbers on data line */

typedef struct Graph	Graph;
typedef struct Machine	Machine;
typedef struct Req	Req;

enum {
	Gmsglen	= 16,
};

struct Graph
{
	int		colindex;
	Rectangle	r;
	long		*data;
	int		ndata;
	char		*label;
	void		(*newvalue)(Machine*, long*, long*, long*);
	void		(*update)(Graph*, long, long, long);
	Machine		*mach;
	int		overflow;
	Image		*overtmp;
	int		overtmplen;
	char		msg[Gmsglen];
	int		cursor;
	int		vmax;
};

enum
{
	MSGLEN		= 64,

	Rttmax		= 50,
};

struct Req
{
	int	seq;	/* sequence number */
	vlong	time;	/* time sent */
//	int	rtt;
	Req	*next;
};

struct Machine
{
	Lock;
	char	*name;
	int	pingfd;
	int	nproc;

	int	rttmsgs;
	ulong	rttsum;
	ulong	lastrtt;

	int	lostmsgs;
	int	rcvdmsgs;
	ulong	lostavg;
	int	unreachable;

	ushort	seq;
	Req	*first;
	Req	*last;
	Req	*rcvd;

	char	buf[1024];
	char	*bufp;
	char	*ebufp;
};

enum
{
	Ncolor		= 6,
	Ysqueeze	= 2,	/* vertical squeezing of label text */
	Labspace	= 2,	/* room around label */
	Dot		= 2,	/* height of dot */
	Opwid		= 5,	/* strlen("add  ") or strlen("drop ") */
	NPROC		= 128,
	NMACH		= 32,
};

enum Menu2
{
	Mrtt,
	Mlost,
	Nmenu2,
};

char	*menu2str[Nmenu2+1] = {
	"add  sec rtt",
	"add  % lost ",
	nil,
};


void	rttval(Machine*, long*, long*, long*);
void	lostval(Machine*, long*, long*, long*);

Menu	menu2 = {menu2str, nil};
int		present[Nmenu2];
void		(*newvaluefn[Nmenu2])(Machine*, long*, long*, long*) = {
	rttval,
	lostval,
};

Image		*cols[Ncolor][3];
Graph		*graph;
Machine		mach[NMACH];
Font		*mediumfont;
int		pids[NPROC];
int		npid;
int 		parity;	/* toggled to avoid patterns in textured background */
int		nmach;
int		ngraph;	/* totaly number is ngraph*nmach */
long		starttime;
int		pinginterval;

void	dropgraph(int);
void	addgraph(int);
void	startproc(void (*)(void*), void*);
void	resize(void);
long	rttscale(long);
int	which2index(int);
int	index2which(int);

void
killall(char *s)
{
	int i, pid;

	pid = getpid();
	for(i=0; i&lt;NPROC; i++)
		if(pids[i] &amp;&amp; pids[i]!=pid)
			postnote(PNPROC, pids[i], "kill");
	exits(s);
}

void*
emalloc(ulong sz)
{
	void *v;
	v = malloc(sz);
	if(v == nil) {
		fprint(2, "%s: out of memory allocating %ld: %r\n", argv0, sz);
		killall("mem");
	}
	memset(v, 0, sz);
	return v;
}

void*
erealloc(void *v, ulong sz)
{
	v = realloc(v, sz);
	if(v == nil) {
		fprint(2, "%s: out of memory reallocating %ld: %r\n", argv0, sz);
		killall("mem");
	}
	return v;
}

char*
estrdup(char *s)
{
	char *t;
	if((t = strdup(s)) == nil) {
		fprint(2, "%s: out of memory in strdup(%.10s): %r\n", argv0, s);
		killall("mem");
	}
	return t;
}

void
mkcol(int i, int c0, int c1, int c2)
{
	cols[i][0] = allocimagemix(display, c0, DWhite);
	cols[i][1] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, c1);
	cols[i][2] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, c2);
}

void
colinit(void)
{
	mediumfont = openfont(display, "/lib/font/bit/pelm/latin1.8.font");
	if(mediumfont == nil)
		mediumfont = font;

	/* Peach */
	mkcol(0, 0xFFAAAAFF, 0xFFAAAAFF, 0xBB5D5DFF);
	/* Aqua */
	mkcol(1, DPalebluegreen, DPalegreygreen, DPurpleblue);
	/* Yellow */
	mkcol(2, DPaleyellow, DDarkyellow, DYellowgreen);
	/* Green */
	mkcol(3, DPalegreen, DMedgreen, DDarkgreen);
	/* Blue */
	mkcol(4, 0x00AAFFFF, 0x00AAFFFF, 0x0088CCFF);
	/* Grey */
	cols[5][0] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0xEEEEEEFF);
	cols[5][1] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0xCCCCCCFF);
	cols[5][2] = allocimage(display, Rect(0,0,1,1), CMAP8, 1, 0x888888FF);
}

int
loadbuf(Machine *m, int *fd)
{
	int n;


	if(*fd &lt; 0)
		return 0;
	seek(*fd, 0, 0);
	n = read(*fd, m-&gt;buf, sizeof m-&gt;buf);
	if(n &lt;= 0){
		close(*fd);
		*fd = -1;
		return 0;
	}
	m-&gt;bufp = m-&gt;buf;
	m-&gt;ebufp = m-&gt;buf+n;
	return 1;
}

void
label(Point p, int dy, char *text)
{
	char *s;
	Rune r[2];
	int w, maxw, maxy;

	p.x += Labspace;
	maxy = p.y+dy;
	maxw = 0;
	r[1] = '\0';
	for(s=text; *s; ){
		if(p.y+mediumfont-&gt;height-Ysqueeze &gt; maxy)
			break;
		w = chartorune(r, s);
		s += w;
		w = runestringwidth(mediumfont, r);
		if(w &gt; maxw)
			maxw = w;
		runestring(screen, p, display-&gt;black, ZP, mediumfont, r);
		p.y += mediumfont-&gt;height-Ysqueeze;
	}
}

void
hashmark(Point p, int dy, long v, long vmax, char *label)
{
	int y;
	int x;

	x = p.x + Labspace;
	y = p.y + (dy*(vmax-v))/vmax;
	draw(screen, Rect(p.x, y-1, p.x+Labspace, y+1), display-&gt;black, nil, ZP);
	if(dy &gt; 5*mediumfont-&gt;height)
		string(screen, Pt(x, y-mediumfont-&gt;height/2),
			display-&gt;black, ZP, mediumfont, label);
}

void
hashmarks(Point p, int dy, int which)
{
	switch(index2which(which)){
	case Mrtt:
		hashmark(p, dy, rttscale(1000000), Rttmax, "1.");
		hashmark(p, dy, rttscale(100000), Rttmax, "0.1");
		hashmark(p, dy, rttscale(10000), Rttmax, "0.01");
		hashmark(p, dy, rttscale(1000), Rttmax, "0.001");
		break;
	case Mlost:
		hashmark(p, dy, 75, 100, " 75%");
		hashmark(p, dy, 50, 100, " 50%");
		hashmark(p, dy, 25, 100, " 25%");
		break;
	}
}

Point
paritypt(int x)
{
	return Pt(x+parity, 0);
}

Point
datapoint(Graph *g, int x, long v, long vmax)
{
	Point p;

	p.x = x;
	p.y = g-&gt;r.max.y - Dy(g-&gt;r)*v/vmax - Dot;
	if(p.y &lt; g-&gt;r.min.y)
		p.y = g-&gt;r.min.y;
	if(p.y &gt; g-&gt;r.max.y-Dot)
		p.y = g-&gt;r.max.y-Dot;
	return p;
}

void
drawdatum(Graph *g, int x, long prev, long v, long vmax)
{
	int c;
	Point p, q;

	c = g-&gt;colindex;
	p = datapoint(g, x, v, vmax);
	q = datapoint(g, x, prev, vmax);
	if(p.y &lt; q.y){
		draw(screen, Rect(p.x, g-&gt;r.min.y, p.x+1, p.y), cols[c][0], nil, paritypt(p.x));
		draw(screen, Rect(p.x, p.y, p.x+1, q.y+Dot), cols[c][2], nil, ZP);
		draw(screen, Rect(p.x, q.y+Dot, p.x+1, g-&gt;r.max.y), cols[c][1], nil, ZP);
	}else{
		draw(screen, Rect(p.x, g-&gt;r.min.y, p.x+1, q.y), cols[c][0], nil, paritypt(p.x));
		draw(screen, Rect(p.x, q.y, p.x+1, p.y+Dot), cols[c][2], nil, ZP);
		draw(screen, Rect(p.x, p.y+Dot, p.x+1, g-&gt;r.max.y), cols[c][1], nil, ZP);
	}
	g-&gt;vmax = vmax;
}

void
drawmark(Graph *g, int x)
{
	int c;

	c = (g-&gt;colindex+1)&amp;Ncolor;
	draw(screen, Rect(x, g-&gt;r.min.y, x+1, g-&gt;r.max.y), cols[c][2], nil, ZP);
}

void
redraw(Graph *g, int vmax)
{
	int i, c;

	c = g-&gt;colindex;
	draw(screen, g-&gt;r, cols[c][0], nil, paritypt(g-&gt;r.min.x));
	for(i=1; i&lt;Dx(g-&gt;r); i++)
		drawdatum(g, g-&gt;r.max.x-i, g-&gt;data[i-1], g-&gt;data[i], vmax);
	drawdatum(g, g-&gt;r.min.x, g-&gt;data[i], g-&gt;data[i], vmax);
}

void
clearmsg(Graph *g)
{
	if(g-&gt;overtmp != nil)
		draw(screen, g-&gt;overtmp-&gt;r, g-&gt;overtmp, nil, g-&gt;overtmp-&gt;r.min);
	g-&gt;overflow = 0;
}

void
drawmsg(Graph *g, char *msg)
{
	if(g-&gt;overtmp == nil)
		return;

	/* save previous contents of screen */
	draw(g-&gt;overtmp, g-&gt;overtmp-&gt;r, screen, nil, g-&gt;overtmp-&gt;r.min);

	/* draw message */
	if(strlen(msg) &gt; g-&gt;overtmplen)
		msg[g-&gt;overtmplen] = 0;
	string(screen, g-&gt;overtmp-&gt;r.min, display-&gt;black, ZP, mediumfont, msg);
}

void
clearcursor(Graph *g)
{
	int x;
	long prev;

	if(g-&gt;overtmp == nil)
		return;

	if(g-&gt;cursor &gt; 0 &amp;&amp; g-&gt;cursor &lt; g-&gt;ndata){
		x = g-&gt;r.max.x - g-&gt;cursor;
		prev = 0;
		if(g-&gt;cursor &gt; 0)
			prev = g-&gt;data[g-&gt;cursor-1];
		drawdatum(g, x, prev, g-&gt;data[g-&gt;cursor], g-&gt;vmax);
		g-&gt;cursor = -1;
	}
}

void
drawcursor(Graph *g, int x)
{
	if(g-&gt;overtmp == nil)
		return;

	draw(screen, Rect(x, g-&gt;r.min.y, x+1, g-&gt;r.max.y), cols[g-&gt;colindex][2], nil, ZP);
}

void
update1(Graph *g, long v, long vmax, long mark)
{
	char buf[Gmsglen];

	/* put back screen value sans message */
	if(g-&gt;overflow || *g-&gt;msg){
		clearmsg(g);
		g-&gt;overflow = 0;
	}

	draw(screen, g-&gt;r, screen, nil, Pt(g-&gt;r.min.x+1, g-&gt;r.min.y));
	drawdatum(g, g-&gt;r.max.x-1, g-&gt;data[0], v, vmax);
	if(mark)
		drawmark(g, g-&gt;r.max.x-1);
	memmove(g-&gt;data+1, g-&gt;data, (g-&gt;ndata-1)*sizeof(g-&gt;data[0]));
	g-&gt;data[0] = v;
	if(v&gt;vmax){
		g-&gt;overflow = 1;
		sprint(buf, "%ld", v);
		drawmsg(g, buf);
	} else if(*g-&gt;msg)
		drawmsg(g, g-&gt;msg);

	if(g-&gt;cursor &gt;= 0){
		g-&gt;cursor++;
		if(g-&gt;cursor &gt;= g-&gt;ndata){
			g-&gt;cursor = -1;
			if(*g-&gt;msg){
				clearmsg(g);
				*g-&gt;msg = 0;
			}
		}
	}

}

void
pinglost(Machine *m, Req*)
{
	m-&gt;lostmsgs++;
}

void
pingreply(Machine *m, Req *r)
{
	ulong x;

	x = r-&gt;time/1000LL;
	m-&gt;rttsum += x;
	m-&gt;rcvdmsgs++;
	m-&gt;rttmsgs++;
}


void
pingclean(Machine *m, ushort seq, vlong now, int)
{
	Req **l, *r;
	vlong x, y;

	y = 10LL*1000000000LL;
	for(l = &amp;m-&gt;first; *l; ){
		r = *l;
		x = now - r-&gt;time;
		if(x &gt; y || r-&gt;seq == seq){
			*l = r-&gt;next;
			r-&gt;time = x;
			if(r-&gt;seq != seq)
				pinglost(m, r);
			else
				pingreply(m, r);
			free(r);
		} else
			l = &amp;(r-&gt;next);
	}
}

/* IPv4 only */
void
pingsend(Machine *m)
{
	int i;
	char buf[128], err[ERRMAX];
	Icmphdr *ip;
	Req *r;

	ip = (Icmphdr *)(buf + IPV4HDR_LEN);
	memset(buf, 0, sizeof buf);
	r = malloc(sizeof *r);
	if(r == nil)
		return;

	for(i = 32; i &lt; MSGLEN; i++)
		buf[i] = i;
	ip-&gt;type = EchoRequest;
	ip-&gt;code = 0;
	ip-&gt;seq[0] = m-&gt;seq;
	ip-&gt;seq[1] = m-&gt;seq&gt;&gt;8;
	r-&gt;seq = m-&gt;seq;
	r-&gt;next = nil;
	lock(m);
	pingclean(m, -1, nsec(), 0);
	if(m-&gt;first == nil)
		m-&gt;first = r;
	else
		m-&gt;last-&gt;next = r;
	m-&gt;last = r;
	r-&gt;time = nsec();
	unlock(m);
	if(write(m-&gt;pingfd, buf, MSGLEN) &lt; MSGLEN){
		errstr(err, sizeof err);
		if(strstr(err, "unreach")||strstr(err, "exceed"))
			m-&gt;unreachable++;
	}
	m-&gt;seq++;
}

/* IPv4 only */
void
pingrcv(void *arg)
{
	int i, n, fd;
	uchar buf[512];
	ushort x;
	vlong now;
	Icmphdr *ip;
	Ip4hdr *ip4;
	Machine *m = arg;

	ip4 = (Ip4hdr *)buf;
	ip = (Icmphdr *)(buf + IPV4HDR_LEN);
	fd = dup(m-&gt;pingfd, -1);
	for(;;){
		n = read(fd, buf, sizeof(buf));
		now = nsec();
		if(n &lt;= 0)
			continue;
		if(n &lt; MSGLEN){
			print("bad len %d/%d\n", n, MSGLEN);
			continue;
		}
		for(i = 32; i &lt; MSGLEN; i++)
			if(buf[i] != (i&amp;0xff))
				continue;
		x = (ip-&gt;seq[1]&lt;&lt;8) | ip-&gt;seq[0];
		if(ip-&gt;type != EchoReply || ip-&gt;code != 0)
			continue;
		lock(m);
		pingclean(m, x, now, ip4-&gt;ttl);
		unlock(m);
	}
}

void
initmach(Machine *m, char *name)
{
	char *p;

	srand(time(0));
	p = strchr(name, '!');
	if(p){
		p++;
		m-&gt;name = estrdup(p+1);
	}else
		p = name;

	m-&gt;name = estrdup(p);
	m-&gt;nproc = 1;
	m-&gt;pingfd = dial(netmkaddr(m-&gt;name, "icmp", "1"), 0, 0, 0);
	if(m-&gt;pingfd &lt; 0)
		sysfatal("dialing %s: %r", m-&gt;name);
	startproc(pingrcv, m);
}

long
rttscale(long x)
{
	if(x == 0)
		return 0;
	x = 10.0*log10(x) - 20.0;
	if(x &lt; 0)
		x = 0;
	return x;
}

double
rttunscale(long x)
{
	double dx;

	x += 20;
	dx = x;
	return pow(10.0, dx/10.0);
}

void
rttval(Machine *m, long *v, long *vmax, long *mark)
{
	ulong x;

	if(m-&gt;rttmsgs == 0){
		x = m-&gt;lastrtt;
	} else {
		x = m-&gt;rttsum/m-&gt;rttmsgs;
		m-&gt;rttsum = m-&gt;rttmsgs = 0;
		m-&gt;lastrtt = x;
	}

	*v = rttscale(x);
	*vmax = Rttmax;
	*mark = 0;
}

void
lostval(Machine *m, long *v, long *vmax, long *mark)
{
	ulong x;

	if(m-&gt;rcvdmsgs+m-&gt;lostmsgs &gt; 0)
		x = (m-&gt;lostavg&gt;&gt;1) + (((m-&gt;lostmsgs*100)/(m-&gt;lostmsgs + m-&gt;rcvdmsgs))&gt;&gt;1);
	else
		x = m-&gt;lostavg;
	m-&gt;lostavg = x;
	m-&gt;lostmsgs = m-&gt;rcvdmsgs = 0;

	if(m-&gt;unreachable){
		m-&gt;unreachable = 0;
		*mark = 100;
	} else
		*mark = 0;

	*v = x;
	*vmax = 100;
}

jmp_buf catchalarm;

void
alarmed(void *a, char *s)
{
	if(strcmp(s, "alarm") == 0)
		notejmp(a, catchalarm, 1);
	noted(NDFLT);
}

void
usage(void)
{
	fprint(2, "usage: %s machine [machine...]\n", argv0);
	exits("usage");
}

void
addgraph(int n)
{
	Graph *g, *ograph;
	int i, j;
	static int nadd;

	if(n &gt; nelem(menu2str))
		abort();
	/* avoid two adjacent graphs of same color */
	if(ngraph&gt;0 &amp;&amp; graph[ngraph-1].colindex==nadd%Ncolor)
		nadd++;
	ograph = graph;
	graph = emalloc(nmach*(ngraph+1)*sizeof(Graph));
	for(i=0; i&lt;nmach; i++)
		for(j=0; j&lt;ngraph; j++)
			graph[i*(ngraph+1)+j] = ograph[i*ngraph+j];
	free(ograph);
	ngraph++;
	for(i=0; i&lt;nmach; i++){
		g = &amp;graph[i*ngraph+(ngraph-1)];
		memset(g, 0, sizeof(Graph));
		g-&gt;label = menu2str[n]+Opwid;
		g-&gt;newvalue = newvaluefn[n];
		g-&gt;update = update1;	/* no other update functions yet */
		g-&gt;mach = &amp;mach[i];
		g-&gt;colindex = nadd%Ncolor;
	}
	present[n] = 1;
	nadd++;
}

int
which2index(int which)
{
	int i, n;

	n = -1;
	for(i=0; i&lt;ngraph; i++){
		if(strcmp(menu2str[which]+Opwid, graph[i].label) == 0){
			n = i;
			break;
		}
	}
	if(n &lt; 0){
		fprint(2, "%s: internal error can't drop graph\n", argv0);
		killall("error");
	}
	return n;
}

int
index2which(int index)
{
	int i, n;

	n = -1;
	for(i=0; i&lt;Nmenu2; i++){
		if(strcmp(menu2str[i]+Opwid, graph[index].label) == 0){
			n = i;
			break;
		}
	}
	if(n &lt; 0){
		fprint(2, "%s: internal error can't identify graph\n", argv0);
		killall("error");
	}
	return n;
}

void
dropgraph(int which)
{
	Graph *ograph;
	int i, j, n;

	if(which &gt; nelem(menu2str))
		abort();
	/* convert n to index in graph table */
	n = which2index(which);
	ograph = graph;
	graph = emalloc(nmach*(ngraph-1)*sizeof(Graph));
	for(i=0; i&lt;nmach; i++){
		for(j=0; j&lt;n; j++)
			graph[i*(ngraph-1)+j] = ograph[i*ngraph+j];
		free(ograph[i*ngraph+j].data);
		freeimage(ograph[i*ngraph+j].overtmp);
		for(j++; j&lt;ngraph; j++)
			graph[i*(ngraph-1)+j-1] = ograph[i*ngraph+j];
	}
	free(ograph);
	ngraph--;
	present[which] = 0;
}

void
addmachine(char *name)
{
	if(ngraph &gt; 0){
		fprint(2, "%s: internal error: ngraph&gt;0 in addmachine()\n", argv0);
		usage();
	}
	if(nmach == NMACH)
		sysfatal("too many machines");
	initmach(&amp;mach[nmach++], name);
}


void
resize(void)
{
	int i, j, n, startx, starty, x, y, dx, dy, hashdx, ondata;
	Graph *g;
	Rectangle machr, r;
	long v, vmax, mark;
	char buf[128];

	draw(screen, screen-&gt;r, display-&gt;white, nil, ZP);

	/* label left edge */
	x = screen-&gt;r.min.x;
	y = screen-&gt;r.min.y + Labspace+mediumfont-&gt;height+Labspace;
	dy = (screen-&gt;r.max.y - y)/ngraph;
	dx = Labspace+stringwidth(mediumfont, "0")+Labspace;
	startx = x+dx+1;
	starty = y;
	for(i=0; i&lt;ngraph; i++,y+=dy){
		draw(screen, Rect(x, y-1, screen-&gt;r.max.x, y), display-&gt;black, nil, ZP);
		draw(screen, Rect(x, y, x+dx, screen-&gt;r.max.y), cols[graph[i].colindex][0], nil, paritypt(x));
		label(Pt(x, y), dy, graph[i].label);
		draw(screen, Rect(x+dx, y, x+dx+1, screen-&gt;r.max.y), cols[graph[i].colindex][2], nil, ZP);
	}

	/* label right edge */
	dx = Labspace+stringwidth(mediumfont, "0.001")+Labspace;
	hashdx = dx;
	x = screen-&gt;r.max.x - dx;
	y = screen-&gt;r.min.y + Labspace+mediumfont-&gt;height+Labspace;
	for(i=0; i&lt;ngraph; i++,y+=dy){
		draw(screen, Rect(x, y-1, screen-&gt;r.max.x, y), display-&gt;black, nil, ZP);
		draw(screen, Rect(x, y, x+dx, screen-&gt;r.max.y), cols[graph[i].colindex][0], nil, paritypt(x));
		hashmarks(Pt(x, y), dy, i);
		draw(screen, Rect(x+dx, y, x+dx+1, screen-&gt;r.max.y), cols[graph[i].colindex][2], nil, ZP);
	}

	/* label top edge */
	dx = (screen-&gt;r.max.x - dx - startx)/nmach;
	for(x=startx, i=0; i&lt;nmach; i++,x+=dx){
		draw(screen, Rect(x-1, starty-1, x, screen-&gt;r.max.y), display-&gt;black, nil, ZP);
		j = dx/stringwidth(mediumfont, "0");
		n = mach[i].nproc;
		if(n&gt;1 &amp;&amp; j&gt;=1+3+(n&gt;10)+(n&gt;100)){	/* first char of name + (n) */
			j -= 3+(n&gt;10)+(n&gt;100);
			if(j &lt;= 0)
				j = 1;
			snprint(buf, sizeof buf, "%.*s(%d)", j, mach[i].name, n);
		}else
			snprint(buf, sizeof buf, "%.*s", j, mach[i].name);
		string(screen, Pt(x+Labspace, screen-&gt;r.min.y + Labspace), display-&gt;black, ZP,
			mediumfont, buf);
	}
	/* draw last vertical line */
	draw(screen,
		Rect(screen-&gt;r.max.x-hashdx-1, starty-1, screen-&gt;r.max.x-hashdx, screen-&gt;r.max.y),
		display-&gt;black, nil, ZP);

	/* create graphs */
	for(i=0; i&lt;nmach; i++){
		machr = Rect(startx+i*dx, starty, screen-&gt;r.max.x, screen-&gt;r.max.y);
		if(i &lt; nmach-1)
			machr.max.x = startx+(i+1)*dx - 1;
		else
			machr.max.x = screen-&gt;r.max.x - hashdx - 1;
		y = starty;
		for(j=0; j&lt;ngraph; j++, y+=dy){
			g = &amp;graph[i*ngraph+j];
			/* allocate data */
			ondata = g-&gt;ndata;
			g-&gt;ndata = Dx(machr)+1;	/* may be too many if label will be drawn here; so what? */
			g-&gt;data = erealloc(g-&gt;data, g-&gt;ndata*sizeof(long));
			if(g-&gt;ndata &gt; ondata)
				memset(g-&gt;data+ondata, 0, (g-&gt;ndata-ondata)*sizeof(long));
			/* set geometry */
			g-&gt;r = machr;
			g-&gt;r.min.y = y;
			g-&gt;r.max.y = y+dy - 1;
			if(j == ngraph-1)
				g-&gt;r.max.y = screen-&gt;r.max.y;
			draw(screen, g-&gt;r, cols[g-&gt;colindex][0], nil, paritypt(g-&gt;r.min.x));
			g-&gt;overflow = 0;
			*g-&gt;msg = 0;
			freeimage(g-&gt;overtmp);
			g-&gt;overtmp = nil;
			g-&gt;overtmplen = 0;
			r = g-&gt;r;
			r.max.y = r.min.y+mediumfont-&gt;height;
			n = (g-&gt;r.max.x - r.min.x)/stringwidth(mediumfont, "9");
			if(n &gt; 4){
				if(n &gt; Gmsglen)
					n = Gmsglen;
				r.max.x = r.min.x+stringwidth(mediumfont, "9")*n;
				g-&gt;overtmplen = n;
				g-&gt;overtmp = allocimage(display, r, screen-&gt;chan, 0, -1);
			}
			g-&gt;newvalue(g-&gt;mach, &amp;v, &amp;vmax, &amp;mark);
			redraw(g, vmax);
		}
	}

	flushimage(display, 1);
}

void
eresized(int new)
{
	lockdisplay(display);
	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0) {
		fprint(2, "%s: can't reattach to window\n", argv0);
		killall("reattach");
	}
	resize();
	unlockdisplay(display);
}

void
dobutton2(Mouse *m)
{
	int i;

	for(i=0; i&lt;Nmenu2; i++)
		if(present[i])
			memmove(menu2str[i], "drop ", Opwid);
		else
			memmove(menu2str[i], "add  ", Opwid);
	i = emenuhit(3, m, &amp;menu2);
	if(i &gt;= 0){
		if(!present[i])
			addgraph(i);
		else if(ngraph &gt; 1)
			dropgraph(i);
		resize();
	}
}

void
dobutton1(Mouse *m)
{
	int i, n, dx, dt;
	Graph *g;
	char *e;
	double f;

	for(i = 0; i &lt; ngraph*nmach; i++){
		if(ptinrect(m-&gt;xy, graph[i].r))
			break;
	}
	if(i == ngraph*nmach)
		return;

	g = &amp;graph[i];
	if(g-&gt;overtmp == nil)
		return;

	/* clear any previous message and cursor */
	if(g-&gt;overflow || *g-&gt;msg){
		clearmsg(g);
		*g-&gt;msg = 0;
		clearcursor(g);
	}

	dx = g-&gt;r.max.x - m-&gt;xy.x;
	g-&gt;cursor = dx;
	dt = dx*pinginterval;
	e = &amp;g-&gt;msg[sizeof(g-&gt;msg)];
	seprint(g-&gt;msg, e, "%s", ctime(starttime-dt/1000)+11);
	g-&gt;msg[8] = 0;
	n = 8;

	switch(index2which(i)){
	case Mrtt:
		f = rttunscale(g-&gt;data[dx]);
		seprint(g-&gt;msg+n, e, " %3.3g", f/1000000);
		break;
	case Mlost:
		seprint(g-&gt;msg+n, e, " %ld%%", g-&gt;data[dx]);
		break;
	}

	drawmsg(g, g-&gt;msg);
	drawcursor(g, m-&gt;xy.x);
}

void
mouseproc(void*)
{
	Mouse mouse;

	for(;;){
		mouse = emouse();
		if(mouse.buttons == 4){
			lockdisplay(display);
			dobutton2(&amp;mouse);
			unlockdisplay(display);
		} else if(mouse.buttons == 1){
			lockdisplay(display);
			dobutton1(&amp;mouse);
			unlockdisplay(display);
		}
	}
}

void
startproc(void (*f)(void*), void *arg)
{
	int pid;

	switch(pid = rfork(RFPROC|RFMEM|RFNOWAIT)){
	case -1:
		fprint(2, "%s: fork failed: %r\n", argv0);
		killall("fork failed");
	case 0:
		f(arg);
		killall("process died");
		exits(nil);
	}
	pids[npid++] = pid;
}

void
main(int argc, char *argv[])
{
	int i, j;
	long v, vmax, mark;
	char flags[10], *f, *p;

	fmtinstall('V', eipfmt);

	f = flags;
	pinginterval = 5000;		/* 5 seconds */
	ARGBEGIN{
	case 'i':
		p = ARGF();
		if(p == nil)
			usage();
		pinginterval = atoi(p);
		break;
	default:
		if(f - flags &gt;= sizeof(flags)-1)
			usage();
		*f++ = ARGC();
		break;
	}ARGEND
	*f = 0;

	for(i=0; i&lt;argc; i++)
		addmachine(argv[i]);

	for(f = flags; *f; f++)
		switch(*f){
		case 'l':
			addgraph(Mlost);
			break;
		case 'r':
			addgraph(Mrtt);
			break;
		}

	if(nmach == 0)
		usage();

	if(ngraph == 0)
		addgraph(Mrtt);

	for(i=0; i&lt;nmach; i++)
		for(j=0; j&lt;ngraph; j++)
			graph[i*ngraph+j].mach = &amp;mach[i];

	if(initdraw(nil, nil, argv0) &lt; 0){
		fprint(2, "%s: initdraw failed: %r\n", argv0);
		exits("initdraw");
	}
	colinit();
	einit(Emouse);
	notify(nil);
	startproc(mouseproc, 0);
	display-&gt;locking = 1;	/* tell library we're using the display lock */

	resize();

	starttime = time(0);

	unlockdisplay(display); /* display is still locked from initdraw() */
	for(j = 0; ; j++){
		lockdisplay(display);
		if(j == nmach){
			parity = 1-parity;
			j = 0;
			for(i=0; i&lt;nmach*ngraph; i++){
				graph[i].newvalue(graph[i].mach, &amp;v, &amp;vmax, &amp;mark);
				graph[i].update(&amp;graph[i], v, vmax, mark);
			}
			starttime = time(0);
		}
		flushimage(display, 1);
		unlockdisplay(display);
		pingsend(&amp;mach[j%nmach]);
		sleep(pinginterval/nmach);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

