<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/content.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/content.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "httpd.h"
#include "httpsrv.h"

typedef struct Suffix	Suffix;
struct Suffix 
{
	Suffix	*next;
	char	*suffix;
	char	*generic;
	char	*specific;
	char	*encoding;
};

Suffix	*suffixes = nil;

static	Suffix*			parsesuffix(char*, Suffix*);
static	char*			skipwhite(char*);
static	HContents		suffixclass(char*);
static	char*			towhite(char*);

int
updateQid(int fd, Qid *q)
{
	Dir *dir;
	Qid dq;

	dir = dirfstat(fd);
	if(dir == nil)
		sysfatal("can't dirfstat");
	dq = dir-&gt;qid;
	free(dir);
	if(q-&gt;path == dq.path &amp;&amp; q-&gt;vers == dq.vers &amp;&amp; q-&gt;type == dq.type)
		return 0;
	*q = dq;
	return 1;
}

void
contentinit(void)
{
	static Biobuf *b = nil;
	static Qid qid;
	char *file, *s;
	Suffix *this;

	file = "/sys/lib/mimetype";
	if(b == nil){ /* first time */
		b = Bopen(file, OREAD);
		if(b == nil)
			sysfatal("can't read from %s", file);
	}
	if(updateQid(Bfildes(b), &amp;qid) == 0)
		return;
	Bseek(b, 0, 0);
	while(suffixes!=nil){
		this = suffixes;
		suffixes = suffixes-&gt;next;
		free(this-&gt;suffix);
		free(this-&gt;generic);
		free(this-&gt;specific);
		free(this-&gt;encoding);
		free(this);
	}

	while((s = Brdline(b, '\n')) != nil){
		s[Blinelen(b) - 1] = 0;
		suffixes = parsesuffix(s, suffixes);
	}
}

static Suffix*
parsesuffix(char *line, Suffix *suffix)
{
	Suffix *s;
	char *p, *fields[5];
	int i, nf;

	p = strchr(line, '#');
	if(p != nil)
		*p = '\0';
	nf = tokenize(line, fields, 5);
	for(i = 0; i &lt; 4; i++)
		if(i &gt;= nf || fields[i][0] == '-')
			fields[i] = nil;

	if(fields[2] == nil)
		fields[1] = nil;
	if(fields[1] == nil &amp;&amp; fields[3] == nil)
		return suffix;
	if(fields[0] == nil)
		return suffix;

	s = ezalloc(sizeof *s);
	s-&gt;next = suffix;
	s-&gt;suffix = estrdup(fields[0]);
	if(fields[1] != nil){
		s-&gt;generic = estrdup(fields[1]);
		s-&gt;specific = estrdup(fields[2]);
	}
	if(fields[3] != nil)
		s-&gt;encoding = estrdup(fields[3]);
	return s;
}

/*
 * classify by file name extensions
 */
HContents
uriclass(HConnect *hc, char *name)
{
	HContents conts;
	Suffix *s;
	HContent *type, *enc;
	char *buf, *p;

	type = nil;
	enc = nil;
	if((p = strrchr(name, '/')) != nil)
		name = p + 1;
	buf = hstrdup(hc, name);
	while((p = strrchr(buf, '.')) != nil){
		for(s = suffixes; s; s = s-&gt;next){
			if(strcmp(p, s-&gt;suffix) == 0){
				if(s-&gt;generic != nil &amp;&amp; type == nil)
					type = hmkcontent(hc, s-&gt;generic, s-&gt;specific, nil);
				if(s-&gt;encoding != nil &amp;&amp; enc == nil)
					enc = hmkcontent(hc, s-&gt;encoding, nil, nil);
			}
		}
		*p = 0;
	}
	conts.type = type;
	conts.encoding = enc;
	return conts;
}

/*
 * classify by initial contents of file
 */
HContents
dataclass(HConnect *hc, char *buf, int n)
{
	HContents conts;
	Rune r;
	int c, m;

	for(; n &gt; 0; n -= m){
		c = *buf;
		if(c &lt; Runeself){
			if(c &lt; 32 &amp;&amp; c != '\n' &amp;&amp; c != '\r' &amp;&amp; c != '\t' &amp;&amp; c != '\v'){
				conts.type = nil;
				conts.encoding = nil;
				return conts;
			}
			m = 1;
		}else{
			m = chartorune(&amp;r, buf);
			if(r == Runeerror){
				conts.type = nil;
				conts.encoding = nil;
				return conts;
			}
		}
		buf += m;
	}
	conts.type = hmkcontent(hc, "text", "plain", nil);
	conts.encoding = nil;
	return conts;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

