<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/httpd/sendfd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/httpd/sendfd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include "httpd.h"
#include "httpsrv.h"

static	void		printtype(Hio *hout, HContent *type, HContent *enc);

/*
 * these should be done better; see the reponse codes in /lib/rfc/rfc2616 for
 * more info on what should be included.
 */
#define UNAUTHED	"You are not authorized to see this area.\n"
#define NOCONTENT	"No acceptable type of data is available.\n"
#define NOENCODE	"No acceptable encoding of the contents is available.\n"
#define UNMATCHED	"The entity requested does not match the existing entity.\n"
#define BADRANGE	"No bytes are avaible for the range you requested.\n"

/*
 * fd references a file which has been authorized &amp; checked for relocations.
 * send back the headers &amp; its contents.
 * includes checks for conditional requests &amp; ranges.
 */
int
sendfd(HConnect *c, int fd, Dir *dir, HContent *type, HContent *enc)
{
	Qid qid;
	HRange *r;
	HContents conts;
	Hio *hout;
	char *boundary, etag[32];
	long mtime;
	ulong tr;
	int n, nw, multir, ok;
	vlong wrote, length;

	hout = &amp;c-&gt;hout;
	length = dir-&gt;length;
	mtime = dir-&gt;mtime;
	qid = dir-&gt;qid;
	free(dir);

	/*
	 * figure out the type of file and send headers
	 */
	n = -1;
	r = nil;
	multir = 0;
	boundary = nil;
	if(c-&gt;req.vermaj){
		if(type == nil &amp;&amp; enc == nil){
			conts = uriclass(c, c-&gt;req.uri);
			type = conts.type;
			enc = conts.encoding;
			if(type == nil &amp;&amp; enc == nil){
				n = read(fd, c-&gt;xferbuf, HBufSize-1);
				if(n &gt; 0){
					c-&gt;xferbuf[n] = '\0';
					conts = dataclass(c, c-&gt;xferbuf, n);
					type = conts.type;
					enc = conts.encoding;
				}
			}
		}
		if(type == nil)
			type = hmkcontent(c, "application", "octet-stream", nil);

		snprint(etag, sizeof(etag), "\"%lluxv%lux\"", qid.path, qid.vers);
		ok = checkreq(c, type, enc, mtime, etag);
		if(ok &lt;= 0){
			close(fd);
			return ok;
		}

		/*
		 * check for if-range requests
		 */
		if(c-&gt;head.range == nil
		|| c-&gt;head.ifrangeetag != nil &amp;&amp; !etagmatch(1, c-&gt;head.ifrangeetag, etag)
		|| c-&gt;head.ifrangedate != 0 &amp;&amp; c-&gt;head.ifrangedate != mtime){
			c-&gt;head.range = nil;
			c-&gt;head.ifrangeetag = nil;
			c-&gt;head.ifrangedate = 0;
		}

		if(c-&gt;head.range != nil){
			c-&gt;head.range = fixrange(c-&gt;head.range, length);
			if(c-&gt;head.range == nil){
				if(c-&gt;head.ifrangeetag == nil &amp;&amp; c-&gt;head.ifrangedate == 0){
					hprint(hout, "%s 416 Request range not satisfiable\r\n", hversion);
					hprint(hout, "Date: %D\r\n", time(nil));
					hprint(hout, "Server: Plan9\r\n");
					hprint(hout, "Content-Range: bytes */%lld\r\n", length);
					hprint(hout, "Content-Length: %d\r\n", STRLEN(BADRANGE));
					hprint(hout, "Content-Type: text/html\r\n");
					if(c-&gt;head.closeit)
						hprint(hout, "Connection: close\r\n");
					else if(!http11(c))
						hprint(hout, "Connection: Keep-Alive\r\n");
					hprint(hout, "\r\n");
					if(strcmp(c-&gt;req.meth, "HEAD") != 0)
						hprint(hout, "%s", BADRANGE);
					hflush(hout);
					writelog(c, "Reply: 416 Request range not satisfiable\n");
					close(fd);
					return 1;
				}
				c-&gt;head.ifrangeetag = nil;
				c-&gt;head.ifrangedate = 0;
			}
		}
		if(c-&gt;head.range == nil)
			hprint(hout, "%s 200 OK\r\n", hversion);
		else
			hprint(hout, "%s 206 Partial Content\r\n", hversion);

		hprint(hout, "Server: Plan9\r\n");
		hprint(hout, "Date: %D\r\n", time(nil));
		hprint(hout, "ETag: %s\r\n", etag);

		/*
		 * can't send some entity headers if partially responding
		 * to an if-range: etag request
		 */
		r = c-&gt;head.range;
		if(r == nil)
			hprint(hout, "Content-Length: %lld\r\n", length);
		else if(r-&gt;next == nil){
			hprint(hout, "Content-Range: bytes %ld-%ld/%lld\r\n", r-&gt;start, r-&gt;stop, length);
			hprint(hout, "Content-Length: %ld\r\n", r-&gt;stop - r-&gt;start);
		}else{
			multir = 1;
			boundary = hmkmimeboundary(c);
			hprint(hout, "Content-Type: multipart/byteranges; boundary=%s\r\n", boundary);
		}
		if(c-&gt;head.ifrangeetag == nil){
			hprint(hout, "Last-Modified: %D\r\n", mtime);
			if(!multir)
				printtype(hout, type, enc);
			if(c-&gt;head.fresh_thresh)
				hintprint(c, hout, c-&gt;req.uri, c-&gt;head.fresh_thresh, c-&gt;head.fresh_have);
		}

		if(c-&gt;head.closeit)
			hprint(hout, "Connection: close\r\n");
		else if(!http11(c))
			hprint(hout, "Connection: Keep-Alive\r\n");
		hprint(hout, "\r\n");
	}
	if(strcmp(c-&gt;req.meth, "HEAD") == 0){
		if(c-&gt;head.range == nil)
			writelog(c, "Reply: 200 file 0\n");
		else
			writelog(c, "Reply: 206 file 0\n");
		hflush(hout);
		close(fd);
		return 1;
	}

	/*
	 * send the file if it's a normal file
	 */
	if(r == nil){
		hflush(hout);

		wrote = 0;
		if(n &gt; 0)
			wrote = write(hout-&gt;fd, c-&gt;xferbuf, n);
		if(n &lt;= 0 || wrote == n){
			while((n = read(fd, c-&gt;xferbuf, HBufSize)) &gt; 0){
				nw = write(hout-&gt;fd, c-&gt;xferbuf, n);
				if(nw != n){
					if(nw &gt; 0)
						wrote += nw;
					break;
				}
				wrote += nw;
			}
		}
		writelog(c, "Reply: 200 file %lld %lld\n", length, wrote);
		close(fd);
		if(length == wrote)
			return 1;
		return -1;
	}

	/*
	 * for multipart/byterange messages,
	 * it is not ok for the boundary string to appear within a message part.
	 * however, it probably doesn't matter, since there are lengths for every part.
	 */
	wrote = 0;
	ok = 1;
	for(; r != nil; r = r-&gt;next){
		if(multir){
			hprint(hout, "\r\n--%s\r\n", boundary);
			printtype(hout, type, enc);
			hprint(hout, "Content-Range: bytes %ld-%ld/%lld\r\n", r-&gt;start, r-&gt;stop, length);
			hprint(hout, "Content-Length: %ld\r\n", r-&gt;stop - r-&gt;start);
			hprint(hout, "\r\n");
		}
		hflush(hout);

		if(seek(fd, r-&gt;start, 0) != r-&gt;start){
			ok = -1;
			break;
		}
		for(tr = r-&gt;stop - r-&gt;start + 1; tr; tr -= n){
			n = tr;
			if(n &gt; HBufSize)
				n = HBufSize;
			if(read(fd, c-&gt;xferbuf, n) != n){
				ok = -1;
				goto breakout;
			}
			nw = write(hout-&gt;fd, c-&gt;xferbuf, n);
			if(nw != n){
				if(nw &gt; 0)
					wrote += nw;
				ok = -1;
				goto breakout;
			}
			wrote += nw;
		}
	}
breakout:;
	if(r == nil){
		if(multir){
			hprint(hout, "--%s--\r\n", boundary);
			hflush(hout);
		}
		writelog(c, "Reply: 206 partial content %lld %lld\n", length, wrote);
	}else
		writelog(c, "Reply: 206 partial content, early termination %lld %lld\n", length, wrote);
	close(fd);
	return ok;
}

static void
printtype(Hio *hout, HContent *type, HContent *enc)
{
	hprint(hout, "Content-Type: %s/%s", type-&gt;generic, type-&gt;specific);
/*
	if(cistrcmp(type-&gt;generic, "text") == 0)
		hprint(hout, ";charset=utf-8");
*/
	hprint(hout, "\r\n");
	if(enc != nil)
		hprint(hout, "Content-Encoding: %s\r\n", enc-&gt;generic);
}

int
etagmatch(int strong, HETag *tags, char *e)
{
	char *s, *t;

	for(; tags != nil; tags = tags-&gt;next){
		if(strong &amp;&amp; tags-&gt;weak)
			continue;
		s = tags-&gt;etag;
		if(s[0] == '*' &amp;&amp; s[1] == '\0')
			return 1;

		t = e + 1;
		while(*t != '"'){
			if(*s != *t)
				break;
			s++;
			t++;
		}

		if(*s == '\0' &amp;&amp; *t == '"')
			return 1;
	}
	return 0;
}

static char *
acceptcont(char *s, char *e, HContent *ok, char *which)
{
	char *sep;

	if(ok == nil)
		return seprint(s, e, "Your browser accepts any %s.&lt;br&gt;\n", which);
	s = seprint(s, e, "Your browser accepts %s: ", which);
	sep = "";
	for(; ok != nil; ok = ok-&gt;next){
		if(ok-&gt;specific)
			s = seprint(s, e, "%s%s/%s", sep, ok-&gt;generic, ok-&gt;specific);
		else
			s = seprint(s, e, "%s%s", sep, ok-&gt;generic);
		sep = ", ";
	}
	return seprint(s, e, ".&lt;br&gt;\n");
}

/*
 * send back a nice error message if the content is unacceptable
 * to get this message in ie, go to tools, internet options, advanced,
 * and turn off Show Friendly HTTP Error Messages under the Browsing category
 */
static int
notaccept(HConnect *c, HContent *type, HContent *enc, char *which)
{
	Hio *hout;
	char *s, *e;

	hout = &amp;c-&gt;hout;
	e = &amp;c-&gt;xferbuf[HBufSize];
	s = c-&gt;xferbuf;
	s = seprint(s, e, "&lt;!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"&gt;\n");
	s = seprint(s, e, "&lt;html&gt;\n&lt;title&gt;Unacceptable %s&lt;/title&gt;\n&lt;body&gt;\n", which);
	s = seprint(s, e, "Your browser will not accept this data, %H, because of its %s.&lt;br&gt;\n", c-&gt;req.uri, which);
	s = seprint(s, e, "Its Content-Type is %s/%s", type-&gt;generic, type-&gt;specific);
	if(enc != nil)
		s = seprint(s, e, ", and Content-Encoding is %s", enc-&gt;generic);
	s = seprint(s, e, ".&lt;br&gt;\n\n");

	s = acceptcont(s, e, c-&gt;head.oktype, "Content-Type");
	s = acceptcont(s, e, c-&gt;head.okencode, "Content-Encoding");
	s = seprint(s, e, "&lt;/body&gt;\n&lt;/html&gt;\n");

	hprint(hout, "%s 406 Not Acceptable\r\n", hversion);
	hprint(hout, "Server: Plan9\r\n");
	hprint(hout, "Date: %D\r\n", time(nil));
	hprint(hout, "Content-Type: text/html\r\n");
	hprint(hout, "Content-Length: %lud\r\n", s - c-&gt;xferbuf);
	if(c-&gt;head.closeit)
		hprint(hout, "Connection: close\r\n");
	else if(!http11(c))
		hprint(hout, "Connection: Keep-Alive\r\n");
	hprint(hout, "\r\n");
	if(strcmp(c-&gt;req.meth, "HEAD") != 0)
		hwrite(hout, c-&gt;xferbuf, s - c-&gt;xferbuf);
	writelog(c, "Reply: 406 Not Acceptable\nReason: %s\n", which);
	return hflush(hout);
}

/*
 * check time and entity tag conditions.
 */
int
checkreq(HConnect *c, HContent *type, HContent *enc, long mtime, char *etag)
{
	Hio *hout;
	int m;

	hout = &amp;c-&gt;hout;
	if(c-&gt;req.vermaj &gt;= 1 &amp;&amp; c-&gt;req.vermin &gt;= 1 &amp;&amp; !hcheckcontent(type, c-&gt;head.oktype, "Content-Type", 0))
		return notaccept(c, type, enc, "Content-Type");
	if(c-&gt;req.vermaj &gt;= 1 &amp;&amp; c-&gt;req.vermin &gt;= 1 &amp;&amp; !hcheckcontent(enc, c-&gt;head.okencode, "Content-Encoding", 0))
		return notaccept(c, type, enc, "Content-Encoding");

	/*
	 * can use weak match only with get or head;
	 * this always uses strong matches
	 */
	m = etagmatch(1, c-&gt;head.ifnomatch, etag);

	if(m &amp;&amp; strcmp(c-&gt;req.meth, "GET") != 0 &amp;&amp; strcmp(c-&gt;req.meth, "HEAD") != 0
	|| c-&gt;head.ifunmodsince &amp;&amp; c-&gt;head.ifunmodsince &lt; mtime
	|| c-&gt;head.ifmatch != nil &amp;&amp; !etagmatch(1, c-&gt;head.ifmatch, etag)){
		hprint(hout, "%s 412 Precondition Failed\r\n", hversion);
		hprint(hout, "Server: Plan9\r\n");
		hprint(hout, "Date: %D\r\n", time(nil));
		hprint(hout, "Content-Type: text/html\r\n");
		hprint(hout, "Content-Length: %d\r\n", STRLEN(UNMATCHED));
		if(c-&gt;head.closeit)
			hprint(hout, "Connection: close\r\n");
		else if(!http11(c))
			hprint(hout, "Connection: Keep-Alive\r\n");
		hprint(hout, "\r\n");
		if(strcmp(c-&gt;req.meth, "HEAD") != 0)
			hprint(hout, "%s", UNMATCHED);
		writelog(c, "Reply: 412 Precondition Failed\n");
		return hflush(hout);
	}

	if(c-&gt;head.ifmodsince &gt;= mtime
	&amp;&amp; (m || c-&gt;head.ifnomatch == nil)){
		/*
		 * can only send back Date, ETag, Content-Location,
		 * Expires, Cache-Control, and Vary entity-headers
		 */
		hprint(hout, "%s 304 Not Modified\r\n", hversion);
		hprint(hout, "Server: Plan9\r\n");
		hprint(hout, "Date: %D\r\n", time(nil));
		hprint(hout, "ETag: %s\r\n", etag);
		if(c-&gt;head.closeit)
			hprint(hout, "Connection: close\r\n");
		else if(!http11(c))
			hprint(hout, "Connection: Keep-Alive\r\n");
		hprint(hout, "\r\n");
		writelog(c, "Reply: 304 Not Modified\n");
		return hflush(hout);
	}
	return 1;
}

/*
 * length is the actual length of the entity requested.
 * discard any range requests which are invalid,
 * ie start after the end, or have stop before start.
 * rewrite suffix requests
 */
HRange*
fixrange(HRange *h, long length)
{
	HRange *r, *rr;

	if(length == 0)
		return nil;

	/*
	 * rewrite each range to reflect the actual length of the file
	 * toss out any invalid ranges
	 */
	rr = nil;
	for(r = h; r != nil; r = r-&gt;next){
		if(r-&gt;suffix){
			r-&gt;start = length - r-&gt;stop;
			if(r-&gt;start &gt;= length)
				r-&gt;start = 0;
			r-&gt;stop = length - 1;
			r-&gt;suffix = 0;
		}
		if(r-&gt;stop &gt;= length)
			r-&gt;stop = length - 1;
		if(r-&gt;start &gt; r-&gt;stop){
			if(rr == nil)
				h = r-&gt;next;
			else
				rr-&gt;next = r-&gt;next;
		}else
			rr = r;
	}

	/*
	 * merge consecutive overlapping or abutting ranges
	 *
	 * not clear from rfc2616 how much merging needs to be done.
	 * this code merges only if a range is adjacent to a later starting,
	 * over overlapping or abutting range.  this allows a client
	 * to request wanted data first, followed by other data.
	 * this may be useful then fetching part of a page, then the adjacent regions.
	 */
	if(h == nil)
		return h;
	r = h;
	for(;;){
		rr = r-&gt;next;
		if(rr == nil)
			break;
		if(r-&gt;start &lt;= rr-&gt;start &amp;&amp; r-&gt;stop + 1 &gt;= rr-&gt;start){
			if(r-&gt;stop &lt; rr-&gt;stop)
				r-&gt;stop = rr-&gt;stop;
			r-&gt;next = rr-&gt;next;
		}else
			r = rr;
	}
	return h;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

