<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/copy.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/copy.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;libsec.h&gt;
#include "imap4d.h"

static int	saveMsg(char *dst, char *digest, int flags, char *head, int nhead, Biobuf *b, long n);
static int	saveb(int fd, DigestState *dstate, char *buf, int nr, int nw);
static long	appSpool(Biobuf *bout, Biobuf *bin, long n);

/*
 * check if the message exists
 */
int
copyCheck(Box *box, Msg *m, int uids, void *v)
{
	int fd;

	USED(box);
	USED(uids);
	USED(v);

	if(m-&gt;expunged)
		return 0;
	fd = msgFile(m, "raw");
	if(fd &lt; 0){
		msgDead(m);
		return 0;
	}
	close(fd);
	return 1;
}

int
copySave(Box *box, Msg *m, int uids, void *vs)
{
	Dir *d;
	Biobuf b;
	vlong length;
	char *head;
	int ok, hfd, bfd, nhead;

	USED(box);
	USED(uids);

	if(m-&gt;expunged)
		return 0;

	hfd = msgFile(m, "unixheader");
	if(hfd &lt; 0){
		msgDead(m);
		return 0;
	}
	head = readFile(hfd);
	if(head == nil){
		close(hfd);
		return 0;
	}

	/*
	 * clear out the header if it doesn't end in a newline,
	 * since it is a runt and the "header" will show up in the raw file.
	 */
	nhead = strlen(head);
	if(nhead &gt; 0 &amp;&amp; head[nhead-1] != '\n')
		nhead = 0;

	bfd = msgFile(m, "raw");
	close(hfd);
	if(bfd &lt; 0){
		msgDead(m);
		return 0;
	}

	d = dirfstat(bfd);
	if(d == nil){
		close(bfd);
		return 0;
	}
	length = d-&gt;length;
	free(d);

	Binit(&amp;b, bfd, OREAD);
	ok = saveMsg(vs, m-&gt;info[IDigest], m-&gt;flags, head, nhead, &amp;b, length);
	Bterm(&amp;b);
	close(bfd);
	return ok;
}

/*
 * first spool the input into a temorary file,
 * and massage the input in the process.
 * then save to real box.
 */
int
appendSave(char *mbox, int flags, char *head, Biobuf *b, long n)
{
	Biobuf btmp;
	int fd, ok;

	fd = imapTmp();
	if(fd &lt; 0)
		return 0;
	Bprint(&amp;bout, "+ Ready for literal data\r\n");
	if(Bflush(&amp;bout) &lt; 0)
		writeErr();
	Binit(&amp;btmp, fd, OWRITE);
	n = appSpool(&amp;btmp, b, n);
	Bterm(&amp;btmp);
	if(n &lt; 0){
		close(fd);
		return 0;
	}

	seek(fd, 0, 0);
	Binit(&amp;btmp, fd, OREAD);
	ok = saveMsg(mbox, nil, flags, head, strlen(head), &amp;btmp, n);
	Bterm(&amp;btmp);
	close(fd);
	return ok;
}

/*
 * copy from bin to bout,
 * mapping "\r\n" to "\n" and "\nFrom " to "\n From "
 * return the number of bytes in the mapped file.
 *
 * exactly n bytes must be read from the input,
 * unless an input error occurs.
 */
static long
appSpool(Biobuf *bout, Biobuf *bin, long n)
{
	int i, c;

	c = '\n';
	while(n &gt; 0){
		if(c == '\n' &amp;&amp; n &gt;= STRLEN("From ")){
			for(i = 0; i &lt; STRLEN("From "); i++){
				c = Bgetc(bin);
				if(c != "From "[i]){
					if(c &lt; 0)
						return -1;
					Bungetc(bin);
					break;
				}
				n--;
			}
			if(i == STRLEN("From "))
				Bputc(bout, ' ');
			Bwrite(bout, "From ", i);
		}
		c = Bgetc(bin);
		n--;
		if(c == '\r' &amp;&amp; n-- &gt; 0){
			c = Bgetc(bin);
			if(c != '\n')
				Bputc(bout, '\r');
		}
		if(c &lt; 0)
			return -1;
		if(Bputc(bout, c) &lt; 0)
			return -1;
	}
	if(c != '\n')
		Bputc(bout, '\n');
	if(Bflush(bout) &lt; 0)
		return -1;
	return Boffset(bout);
}

static int
saveMsg(char *dst, char *digest, int flags, char *head, int nhead, Biobuf *b, long n)
{
	DigestState *dstate;
	MbLock *ml;
	uchar shadig[SHA1dlen];
	char buf[BufSize + 1], digbuf[NDigest + 1];
	int i, fd, nr, nw, ok;

	ml = mbLock();
	if(ml == nil)
		return 0;
	fd = openLocked(mboxDir, dst, OWRITE);
	if(fd &lt; 0){
		mbUnlock(ml);
		return 0;
	}
	seek(fd, 0, 2);

	dstate = nil;
	if(digest == nil)
		dstate = sha1(nil, 0, nil, nil);
	if(!saveb(fd, dstate, head, nhead, nhead)){
		if(dstate != nil)
			sha1(nil, 0, shadig, dstate);
		mbUnlock(ml);
		close(fd);
		return 0;
	}
	ok = 1;
	if(n == 0)
		ok = saveb(fd, dstate, "\n", 0, 1);
	while(n &gt; 0){
		nr = n;
		if(nr &gt; BufSize)
			nr = BufSize;
		nr = Bread(b, buf, nr);
		if(nr &lt;= 0){
			saveb(fd, dstate, "\n\n", 0, 2);
			ok = 0;
			break;
		}
		n -= nr;
		nw = nr;
		if(n == 0){
			if(buf[nw - 1] != '\n')
				buf[nw++] = '\n';
			buf[nw++] = '\n';
		}
		if(!saveb(fd, dstate, buf, nr, nw)){
			ok = 0;
			break;
		}
		mbLockRefresh(ml);
	}
	close(fd);

	if(dstate != nil){
		digest = digbuf;
		sha1(nil, 0, shadig, dstate);
		for(i = 0; i &lt; SHA1dlen; i++)
			snprint(digest+2*i, NDigest+1-2*i, "%2.2ux", shadig[i]);
	}
	if(ok){
		fd = cdOpen(mboxDir, impName(dst), OWRITE);
		if(fd &lt; 0)
			fd = emptyImp(dst);
		if(fd &gt;= 0){
			seek(fd, 0, 2);
			wrImpFlags(buf, flags, 1);
			fprint(fd, "%.*s %.*lud %s\n", NDigest, digest, NUid, 0UL, buf);
			close(fd);
		}
	}
	mbUnlock(ml);
	return 1;
}

static int
saveb(int fd, DigestState *dstate, char *buf, int nr, int nw)
{
	if(dstate != nil)
		sha1((uchar*)buf, nr, nil, dstate);
	if(write(fd, buf, nw) != nw)
		return 0;
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

