<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/folder.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/folder.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

static	int	copyData(int ffd, int tfd, MbLock *ml);
static	MbLock	mLock =
{
	.fd = -1
};

static char curDir[MboxNameLen];

void
resetCurDir(void)
{
	curDir[0] = '\0';
}

int
myChdir(char *dir)
{
	if(strcmp(dir, curDir) == 0)
		return 0;
	if(dir[0] != '/' || strlen(dir) &gt; MboxNameLen)
		return -1;
	strcpy(curDir, dir);
	if(chdir(dir) &lt; 0){
		werrstr("mychdir failed: %r");
		return -1;
	}
	return 0;
}

int
cdCreate(char *dir, char *file, int mode, ulong perm)
{
	if(myChdir(dir) &lt; 0)
		return -1;
	return create(file, mode, perm);
}

Dir*
cdDirstat(char *dir, char *file)
{
	if(myChdir(dir) &lt; 0)
		return nil;
	return dirstat(file);
}

int
cdExists(char *dir, char *file)
{
	Dir *d;

	d = cdDirstat(dir, file);
	if(d == nil)
		return 0;
	free(d);
	return 1;
}

int
cdDirwstat(char *dir, char *file, Dir *d)
{
	if(myChdir(dir) &lt; 0)
		return -1;
	return dirwstat(file, d);
}

int
cdOpen(char *dir, char *file, int mode)
{
	if(myChdir(dir) &lt; 0)
		return -1;
	return open(file, mode);
}

int
cdRemove(char *dir, char *file)
{
	if(myChdir(dir) &lt; 0)
		return -1;
	return remove(file);
}

/*
 * open the one true mail lock file
 */
MbLock*
mbLock(void)
{
	int i;

	if(mLock.fd &gt;= 0)
		bye("mail lock deadlock");
	for(i = 0; i &lt; 5; i++){
		mLock.fd = openLocked(mboxDir, "L.mbox", OREAD);
		if(mLock.fd &gt;= 0)
			return &amp;mLock;
		sleep(1000);
	}
	return nil;
}

void
mbUnlock(MbLock *ml)
{
	if(ml != &amp;mLock)
		bye("bad mail unlock");
	if(ml-&gt;fd &lt; 0)
		bye("mail unlock when not locked");
	close(ml-&gt;fd);
	ml-&gt;fd = -1;
}

void
mbLockRefresh(MbLock *ml)
{
	char buf[1];

	seek(ml-&gt;fd, 0, 0);
	read(ml-&gt;fd, buf, 1);
}

int
mbLocked(void)
{
	return mLock.fd &gt;= 0;
}

char*
impName(char *name)
{
	char *s;
	int n;

	if(cistrcmp(name, "inbox") == 0)
		if(access("msgs", AEXIST) == 0)
			name = "msgs";
		else
			name = "mbox";
	n = strlen(name) + STRLEN(".imp") + 1;
	s = binalloc(&amp;parseBin, n, 0);
	if(s == nil)
		return nil;
	snprint(s, n, "%s.imp", name);
	return s;
}

/*
 * massage the mailbox name into something valid
 * eliminates all .', and ..',s, redundatant and trailing /'s.
 */
char *
mboxName(char *s)
{
	char *ss;

	ss = mutf7str(s);
	if(ss == nil)
		return nil;
	cleanname(ss);
	return ss;
}

char *
strmutf7(char *s)
{
	char *m;
	int n;

	n = strlen(s) * MUtf7Max + 1;
	m = binalloc(&amp;parseBin, n, 0);
	if(m == nil)
		return nil;
	if(encmutf7(m, n, s) &lt; 0)
		return nil;
	return m;
}

char *
mutf7str(char *s)
{
	char *m;
	int n;

	/*
	 * n = strlen(s) * UTFmax / (2.67) + 1
	 * UTFMax / 2.67 == 3 / (8/3) == 9 / 8
	 */
	n = strlen(s);
	n = (n * 9 + 7) / 8 + 1;
	m = binalloc(&amp;parseBin, n, 0);
	if(m == nil)
		return nil;
	if(decmutf7(m, n, s) &lt; 0)
		return nil;
	return m;
}

void
splitr(char *s, int c, char **left, char **right)
{
	char *d;
	int n;

	n = strlen(s);
	d = binalloc(&amp;parseBin, n + 1, 0);
	if(d == nil)
		parseErr("out of memory");
	strcpy(d, s);
	s = strrchr(d, c);
	if(s != nil){
		*left = d;
		*s++ = '\0';
		*right = s;
	}else{
		*right = d;
		*left = d + n;
	}
}

/*
 * create the mailbox and all intermediate components
 * a trailing / implies the new mailbox is a directory;
 * otherwise, it's a file.
 *
 * return with the file open for write, or directory open for read.
 */
int
createBox(char *mbox, int dir)
{
	char *m;
	int fd;

	fd = -1;
	for(m = mbox; *m; m++){
		if(*m == '/'){
			*m = '\0';
			if(access(mbox, AEXIST) &lt; 0){
				if(fd &gt;= 0)
					close(fd);
				fd = cdCreate(mboxDir, mbox, OREAD, DMDIR|0775);
				if(fd &lt; 0)
					return -1;
			}
			*m = '/';
		}
	}
	if(dir)
		fd = cdCreate(mboxDir, mbox, OREAD, DMDIR|0775);
	else
		fd = cdCreate(mboxDir, mbox, OWRITE, 0664);
	return fd;
}

/*
 * move one mail folder to another
 * destination mailbox doesn't exist.
 * the source folder may be a directory or a mailbox,
 * and may be in the same directory as the destination,
 * or a completely different directory.
 */
int
moveBox(char *from, char *to)
{
	Dir *d;
	char *fd, *fe, *td, *te, *fimp;

	splitr(from, '/', &amp;fd, &amp;fe);
	splitr(to, '/', &amp;td, &amp;te);

	/*
	 * in the same directory: try rename
	 */
	d = cdDirstat(mboxDir, from);
	if(d == nil)
		return 0;
	if(strcmp(fd, td) == 0){
		nulldir(d);
		d-&gt;name = te;
		if(cdDirwstat(mboxDir, from, d) &gt;= 0){
			fimp = impName(from);
			d-&gt;name = impName(te);
			cdDirwstat(mboxDir, fimp, d);
			free(d);
			return 1;
		}
	}

	/*
	 * directory copy is too hard for now
	 */
	if(d-&gt;mode &amp; DMDIR)
		return 0;
	free(d);

	return copyBox(from, to, 1);
}

/*
 * copy the contents of one mailbox to another
 * either truncates or removes the source box if it succeeds.
 */
int
copyBox(char *from, char *to, int doremove)
{
	MbLock *ml;
	char *fimp, *timp;
	int ffd, tfd, ok;

	if(cistrcmp(from, "inbox") == 0)
		if(access("msgs", AEXIST) == 0)
			from = "msgs";
		else
			from = "mbox";

	ml = mbLock();
	if(ml == nil)
		return 0;
	ffd = openLocked(mboxDir, from, OREAD);
	if(ffd &lt; 0){
		mbUnlock(ml);
		return 0;
	}
	tfd = createBox(to, 0);
	if(tfd &lt; 0){
		mbUnlock(ml);
		close(ffd);
		return 0;
	}

	ok = copyData(ffd, tfd, ml);
	close(ffd);
	close(tfd);
	if(!ok){
		mbUnlock(ml);
		return 0;
	}

	fimp = impName(from);
	timp = impName(to);
	if(fimp != nil &amp;&amp; timp != nil){
		ffd = cdOpen(mboxDir, fimp, OREAD);
		if(ffd &gt;= 0){
			tfd = cdCreate(mboxDir, timp, OWRITE, 0664);
			if(tfd &gt;= 0){
				copyData(ffd, tfd, ml);
				close(tfd);
			}
			close(ffd);
		}
	}
	cdRemove(mboxDir, fimp);
	if(doremove)
		cdRemove(mboxDir, from);
	else
		close(cdOpen(mboxDir, from, OWRITE|OTRUNC));
	mbUnlock(ml);
	return 1;
}

/*
 * copies while holding the mail lock,
 * then tries to copy permissions and group ownership
 */
static int
copyData(int ffd, int tfd, MbLock *ml)
{
	Dir *fd, td;
	char buf[BufSize];
	int n;

	for(;;){
		n = read(ffd, buf, BufSize);
		if(n &lt;= 0){
			if(n &lt; 0)
				return 0;
			break;
		}
		if(write(tfd, buf, n) != n)
			return 0;
		mbLockRefresh(ml);
	}
	fd = dirfstat(ffd);
	if(fd != nil){
		nulldir(&amp;td);
		td.mode = fd-&gt;mode;
		if(dirfwstat(tfd, &amp;td) &gt;= 0){
			nulldir(&amp;td);
			td.gid = fd-&gt;gid;
			dirfwstat(tfd, &amp;td);
		}
	}
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

