<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/msg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/msg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;libsec.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include "imap4d.h"

static void	body64(int in, int out);
static void	bodystrip(int in, int out);
static void	cleanupHeader(Header *h);
static char	*domBang(char *s);
static void	freeMAddr(MAddr *a);
static void	freeMimeHdr(MimeHdr *mh);
static char	*headAddrSpec(char *e, char *w);
static MAddr	*headAddresses(void);
static MAddr	*headAddress(void);
static char	*headAtom(char *disallowed);
static int	headChar(int eat);
static char	*headDomain(char *e);
static MAddr	*headMAddr(MAddr *old);
static char	*headPhrase(char *e, char *w);
static char	*headQuoted(int start, int stop);
static char	*headSkipWhite(int);
static void	headSkip(void);
static char	*headSubDomain(void);
static char	*headText(void);
static void	headToEnd(void);
static char	*headWord(void);
static void	mimeDescription(Header *h);
static void	mimeDisposition(Header *h);
static void	mimeEncoding(Header *h);
static void	mimeId(Header *h);
static void	mimeLanguage(Header *h);
static void	mimeMd5(Header *h);
static MimeHdr	*mimeParams(void);
static void	mimeType(Header *h);
static MimeHdr	*mkMimeHdr(char *s, char *t, MimeHdr *next);
static void	msgAddDate(Msg *m);
static void	msgAddHead(Msg *m, char *head, char *body);
static int	msgBodySize(Msg *m);
static int	msgHeader(Msg *m, Header *h, char *file);
static long	msgReadFile(Msg *m, char *file, char **ss);
static int	msgUnix(Msg *m, int top);
static void	stripQuotes(char *q);
static MAddr	*unixFrom(char *s);


static char bogusBody[] = 
	"This message contains null characters, so it cannot be displayed correctly.\r\n"
	"Most likely you were sent a bogus message or a binary file.\r\n"
	"\r\n"
	"Each of the following attachments has a different version of the message.\r\n"
	"The first is inlined with all non-printable characters stripped.\r\n"
	"The second contains the message as it was stored in your mailbox.\r\n"
	"The third has the initial header stripped.\r\n";

static char bogusMimeText[] =
	"Content-Disposition: inline\r\n"
	"Content-Type: text/plain; charset=\"US-ASCII\"\r\n"
	"Content-Transfer-Encoding: 7bit\r\n";

static char bogusMimeBinary[] =
	"Content-Disposition: attachment\r\n"
	"Content-Type: application/octet-stream\r\n"
	"Content-Transfer-Encoding: base64\r\n";

/*
 * stop list for header fields
 */
static char	*headFieldStop = ":";
static char	*mimeTokenStop = "()&lt;&gt;@,;:\\\"/[]?=";
static char	*headAtomStop = "()&lt;&gt;@,;:\\\".[]";
static uchar	*headStr;
static uchar	*lastWhite;

long
selectFields(char *dst, long n, char *hdr, SList *fields, int matches)
{
	SList *f;
	uchar *start;
	char *s;
	long m, nf;

	headStr = (uchar*)hdr;
	m = 0;
	for(;;){
		start = headStr;
		s = headAtom(headFieldStop);
		if(s == nil)
			break;
		headSkip();
		for(f = fields; f != nil; f = f-&gt;next){
			if(cistrcmp(s, f-&gt;s) == !matches){
				nf = headStr - start;
				if(m + nf &gt; n)
					return 0;
				memmove(&amp;dst[m], start, nf);
				m += nf;
			}
		}
		free(s);
	}
	if(m + 3 &gt; n)
		return 0;
	dst[m++] = '\r';
	dst[m++] = '\n';
	dst[m] = '\0';
	return m;
}

void
freeMsg(Msg *m)
{
	Msg *k, *last;

	free(m-&gt;iBuf);
	freeMAddr(m-&gt;to);
	if(m-&gt;replyTo != m-&gt;from)
		freeMAddr(m-&gt;replyTo);
	if(m-&gt;sender != m-&gt;from)
		freeMAddr(m-&gt;sender);
	if(m-&gt;from != m-&gt;unixFrom)
		freeMAddr(m-&gt;from);
	freeMAddr(m-&gt;unixFrom);
	freeMAddr(m-&gt;cc);
	freeMAddr(m-&gt;bcc);
	free(m-&gt;unixDate);
	cleanupHeader(&amp;m-&gt;head);
	cleanupHeader(&amp;m-&gt;mime);
	for(k = m-&gt;kids; k != nil; ){
		last = k;
		k = k-&gt;next;
		freeMsg(last);
	}
	free(m-&gt;fs);
	free(m);
}

ulong
msgSize(Msg *m)
{
	return m-&gt;head.size + m-&gt;size;
}

int
infoIsNil(char *s)
{
	return s == nil || s[0] == '\0';
}

char*
maddrStr(MAddr *a)
{
	char *host, *addr;
	int n;

	host = a-&gt;host;
	if(host == nil)
		host = "";
	n = strlen(a-&gt;box) + strlen(host) + 2;
	if(a-&gt;personal != nil)
		n += strlen(a-&gt;personal) + 3;
	addr = emalloc(n);
	if(a-&gt;personal != nil)
		snprint(addr, n, "%s &lt;%s@%s&gt;", a-&gt;personal, a-&gt;box, host);
	else
		snprint(addr, n, "%s@%s", a-&gt;box, host);
	return addr;
}

/*
 * return actual name of f in m's fs directory
 * this is special cased when opening m/rawbody, m/mimeheader, or m/rawheader,
 * if the message was corrupted.  in that case,
 * a temporary file is made to hold the base64 encoding of m/raw.
 */
int
msgFile(Msg *m, char *f)
{
	Msg *parent, *p;
	Dir d;
	Tm tm;
	char buf[64], nbuf[2];
	uchar dbuf[64];
	int i, n, fd, fd1, fd2;

	if(!m-&gt;bogus
	|| strcmp(f, "") != 0 &amp;&amp; strcmp(f, "rawbody") != 0
	&amp;&amp; strcmp(f, "rawheader") != 0 &amp;&amp; strcmp(f, "mimeheader") != 0
	&amp;&amp; strcmp(f, "info") != 0 &amp;&amp; strcmp(f, "unixheader") != 0){
		if(strlen(f) &gt; MsgNameLen)
			bye("internal error: msgFile name too long");
		strcpy(m-&gt;efs, f);
		return cdOpen(m-&gt;fsDir, m-&gt;fs, OREAD);
	}

	/*
	 * walk up the stupid runt message parts for non-multipart messages
	 */
	parent = m-&gt;parent;
	if(parent != nil &amp;&amp; parent-&gt;parent != nil){
		m = parent;
		parent = m-&gt;parent;
	}
	p = m;
	if(parent != nil)
		p = parent;

	if(strcmp(f, "info") == 0 || strcmp(f, "unixheader") == 0){
		strcpy(p-&gt;efs, f);
		return cdOpen(p-&gt;fsDir, p-&gt;fs, OREAD);
	}

	fd = imapTmp();
	if(fd &lt; 0)
		return -1;

	/*
	 * craft the message parts for bogus messages
	 */
	if(strcmp(f, "") == 0){
		/*
		 * make a fake directory for each kid
		 * all we care about is the name
		 */
		if(parent == nil){
			nulldir(&amp;d);
			d.mode = DMDIR|0600;
			d.qid.type = QTDIR;
			d.name = nbuf;
			nbuf[1] = '\0';
			for(i = '1'; i &lt;= '4'; i++){
				nbuf[0] = i;
				n = convD2M(&amp;d, dbuf, sizeof(dbuf));
				if(n &lt;= BIT16SZ)
					fprint(2, "bad convD2M %d\n", n);
				write(fd, dbuf, n);
			}
		}
	}else if(strcmp(f, "mimeheader") == 0){
		if(parent != nil){
			switch(m-&gt;id){
			case 1:
			case 2:
				fprint(fd, "%s", bogusMimeText);
				break;
			case 3:
			case 4:
				fprint(fd, "%s", bogusMimeBinary);
				break;
			}
		}
	}else if(strcmp(f, "rawheader") == 0){
		if(parent == nil){
			date2tm(&amp;tm, m-&gt;unixDate);
			rfc822date(buf, sizeof(buf), &amp;tm);
			fprint(fd,
				"Date: %s\r\n"
				"From: imap4 daemon &lt;%s@%s&gt;\r\n"
				"To: &lt;%s@%s&gt;\r\n"
				"Subject: This message was illegal or corrupted\r\n"
				"MIME-Version: 1.0\r\n"
				"Content-Type: multipart/mixed;\r\n\tboundary=\"upas-%s\"\r\n",
					buf, username, site, username, site, m-&gt;info[IDigest]);
		}
	}else if(strcmp(f, "rawbody") == 0){
		fd1 = msgFile(p, "raw");
		strcpy(p-&gt;efs, "rawbody");
		fd2 = cdOpen(p-&gt;fsDir, p-&gt;fs, OREAD);
		if(fd1 &lt; 0 || fd2 &lt; 0){
			close(fd);
			close(fd1);
			close(fd2);
			return -1;
		}
		if(parent == nil){
			fprint(fd,
				"This is a multi-part message in MIME format.\r\n"
				"--upas-%s\r\n"
				"%s"
				"\r\n"
				"%s"
				"\r\n",
					m-&gt;info[IDigest], bogusMimeText, bogusBody);

			fprint(fd,
				"--upas-%s\r\n"
				"%s"
				"\r\n",
					m-&gt;info[IDigest], bogusMimeText);
			bodystrip(fd1, fd);

			fprint(fd,
				"--upas-%s\r\n"
				"%s"
				"\r\n",
					m-&gt;info[IDigest], bogusMimeBinary);
			seek(fd1, 0, 0);
			body64(fd1, fd);

			fprint(fd,
				"--upas-%s\r\n"
				"%s"
				"\r\n",
					m-&gt;info[IDigest], bogusMimeBinary);
			body64(fd2, fd);

			fprint(fd, "--upas-%s--\r\n", m-&gt;info[IDigest]);
		}else{
			switch(m-&gt;id){
			case 1:
				fprint(fd, "%s", bogusBody);
				break;
			case 2:
				bodystrip(fd1, fd);
				break;
			case 3:
				body64(fd1, fd);
				break;
			case 4:
				body64(fd2, fd);
				break;
			}
		}
		close(fd1);
		close(fd2);
	}
	seek(fd, 0, 0);
	return fd;
}

int
msgIsMulti(Header *h)
{
	return h-&gt;type != nil &amp;&amp; cistrcmp("multipart", h-&gt;type-&gt;s) == 0;
}

int
msgIsRfc822(Header *h)
{
	return h-&gt;type != nil &amp;&amp; cistrcmp("message", h-&gt;type-&gt;s) == 0 &amp;&amp; cistrcmp("rfc822", h-&gt;type-&gt;t) == 0;
}

/*
 * check if a message has been deleted by someone else
 */
void
msgDead(Msg *m)
{
	if(m-&gt;expunged)
		return;
	*m-&gt;efs = '\0';
	if(!cdExists(m-&gt;fsDir, m-&gt;fs))
		m-&gt;expunged = 1;
}

/*
 * make sure the message has valid associated info
 * used for ISubject, IDigest, IInReplyTo, IMessageId.
 */
int
msgInfo(Msg *m)
{
	char *s;
	int i;

	if(m-&gt;info[0] != nil)
		return 1;

	i = msgReadFile(m, "info", &amp;m-&gt;iBuf);
	if(i &lt; 0)
		return 0;

	s = m-&gt;iBuf;
	for(i = 0; i &lt; IMax; i++){
		m-&gt;info[i] = s;
		s = strchr(s, '\n');
		if(s == nil)
			break;
		*s++ = '\0';
	}
	for(; i &lt; IMax; i++)
		m-&gt;info[i] = nil;

	for(i = 0; i &lt; IMax; i++)
		if(infoIsNil(m-&gt;info[i]))
			m-&gt;info[i] = nil;

	return 1;
}

/*
 * make sure the message has valid mime structure
 * and sub-messages
 */
int
msgStruct(Msg *m, int top)
{
	Msg *k, head, *last;
	Dir *d;
	char *s;
	ulong max, id;
	int i, nd, fd, ns;

	if(m-&gt;kids != nil)
		return 1;

	if(m-&gt;expunged
	|| !msgInfo(m)
	|| !msgUnix(m, top)
	|| !msgBodySize(m)
	|| !msgHeader(m, &amp;m-&gt;mime, "mimeheader")
	|| (top || msgIsRfc822(&amp;m-&gt;mime) || msgIsMulti(&amp;m-&gt;mime)) &amp;&amp; !msgHeader(m, &amp;m-&gt;head, "rawheader")){
		if(top &amp;&amp; m-&gt;bogus &amp;&amp; !(m-&gt;bogus &amp; BogusTried)){
			m-&gt;bogus |= BogusTried;
			return msgStruct(m, top);
		}
		msgDead(m);
		return 0;
	}

	/*
	 * if a message has no kids, it has a kid which is just the body of the real message
	 */
	if(!msgIsMulti(&amp;m-&gt;head) &amp;&amp; !msgIsMulti(&amp;m-&gt;mime) &amp;&amp; !msgIsRfc822(&amp;m-&gt;head) &amp;&amp; !msgIsRfc822(&amp;m-&gt;mime)){
		k = MKZ(Msg);
		k-&gt;id = 1;
		k-&gt;fsDir = m-&gt;fsDir;
		k-&gt;bogus = m-&gt;bogus;
		k-&gt;parent = m-&gt;parent;
		ns = m-&gt;efs - m-&gt;fs;
		k-&gt;fs = emalloc(ns + (MsgNameLen + 1));
		memmove(k-&gt;fs, m-&gt;fs, ns);
		k-&gt;efs = k-&gt;fs + ns;
		*k-&gt;efs = '\0';
		k-&gt;size = m-&gt;size;
		m-&gt;kids = k;
		return 1;
	}

	/*
	 * read in all child messages messages
	 */
	fd = msgFile(m, "");
	if(fd &lt; 0){
		msgDead(m);
		return 0;
	}

	max = 0;
	head.next = nil;
	last = &amp;head;
	while((nd = dirread(fd, &amp;d)) &gt; 0){
		for(i = 0; i &lt; nd; i++){
			s = d[i].name;
			id = strtol(s, &amp;s, 10);
			if(id &lt;= max || *s != '\0'
			|| (d[i].mode &amp; DMDIR) != DMDIR)
				continue;

			max = id;

			k = MKZ(Msg);
			k-&gt;id = id;
			k-&gt;fsDir = m-&gt;fsDir;
			k-&gt;bogus = m-&gt;bogus;
			k-&gt;parent = m;
			ns = strlen(m-&gt;fs);
			k-&gt;fs = emalloc(ns + 2 * (MsgNameLen + 1));
			k-&gt;efs = seprint(k-&gt;fs, k-&gt;fs + ns + (MsgNameLen + 1), "%s%lud/", m-&gt;fs, id);
			k-&gt;prev = last;
			k-&gt;size = ~0UL;
			k-&gt;lines = ~0UL;
			last-&gt;next = k;
			last = k;
		}
	}
	close(fd);
	m-&gt;kids = head.next;

	/*
	 * if kids fail, just whack them
	 */
	top = top &amp;&amp; (msgIsRfc822(&amp;m-&gt;head) || msgIsMulti(&amp;m-&gt;head));
	for(k = m-&gt;kids; k != nil; k = k-&gt;next){
		if(!msgStruct(k, top)){
			for(k = m-&gt;kids; k != nil; ){
				last = k;
				k = k-&gt;next;
				freeMsg(last);
			}
			m-&gt;kids = nil;
			break;
		}
	}
	return 1;
}

static long
msgReadFile(Msg *m, char *file, char **ss)
{
	Dir *d;
	char *s, buf[BufSize];
	vlong length;
	long n, nn;
	int fd;

	fd = msgFile(m, file);
	if(fd &lt; 0){
		msgDead(m);
		return -1;
	}

	n = read(fd, buf, BufSize);
	if(n &lt; BufSize){
		close(fd);
		if(n &lt; 0){
			*ss = nil;
			return -1;
		}
		s = emalloc(n + 1);
		memmove(s, buf, n);
		s[n] = '\0';
		*ss = s;
		return n;
	}

	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		return -1;
	}
	length = d-&gt;length;
	free(d);
	nn = length;
	s = emalloc(nn + 1);
	memmove(s, buf, n);
	if(nn &gt; n)
		nn = readn(fd, s+n, nn-n) + n;
	close(fd);
	if(nn != length){
		free(s);
		return -1;
	}
	s[nn] = '\0';
	*ss = s;
	return nn;
}

static void
freeMAddr(MAddr *a)
{
	MAddr *p;

	while(a != nil){
		p = a;
		a = a-&gt;next;
		free(p-&gt;personal);
		free(p-&gt;box);
		free(p-&gt;host);
		free(p);
	}
}

/*
 * the message is corrupted or illegal.
 * reset message fields.  msgStruct will reparse the message,
 * relying on msgFile to make up corrected body parts.
 */
static int
msgBogus(Msg *m, int flags)
{
	if(!(m-&gt;bogus &amp; flags))
		m-&gt;bogus |= flags;
	m-&gt;lines = ~0;
	free(m-&gt;head.buf);
	free(m-&gt;mime.buf);
	memset(&amp;m-&gt;head, 0, sizeof(Header));
	memset(&amp;m-&gt;mime, 0, sizeof(Header));
	return 0;
}

/*
 *  stolen from upas/marshal; base64 encodes from one fd to another.
 *
 *  the size of buf is very important to enc64.  Anything other than
 *  a multiple of 3 will cause enc64 to output a termination sequence.
 *  To ensure that a full buf corresponds to a multiple of complete lines,
 *  we make buf a multiple of 3*18 since that's how many enc64 sticks on
 *  a single line.  This avoids short lines in the output which is pleasing
 *  but not necessary.
 */
static int
enc64x18(char *out, int lim, uchar *in, int n)
{
	int m, mm, nn;

	nn = 0;
	for(; n &gt; 0; n -= m){
		m = 18 * 3;
		if(m &gt; n)
			m = n;
		mm = enc64(out, lim - nn, in, m);
		in += m;
		out += mm;
		*out++ = '\r';
		*out++ = '\n';
		nn += mm + 2;
	}
	return nn;
}

static void
body64(int in, int out)
{
	uchar buf[3*18*54];
	char obuf[3*18*54*2];
	int m, n;

	for(;;){
		n = read(in, buf, sizeof(buf));
		if(n &lt; 0)
			return;
		if(n == 0)
			break;
		m = enc64x18(obuf, sizeof(obuf), buf, n);
		if(write(out, obuf, m) &lt; 0)
			return;
	}
}

/*
 * strip all non-printable characters from a file
 */
static void
bodystrip(int in, int out)
{
	uchar buf[3*18*54];
	int m, n, i, c;

	for(;;){
		n = read(in, buf, sizeof(buf));
		if(n &lt; 0)
			return;
		if(n == 0)
			break;
		m = 0;
		for(i = 0; i &lt; n; i++){
			c = buf[i];
			if(c &gt; 0x1f &amp;&amp; c &lt; 0x7f		/* normal characters */
			|| c &gt;= 0x9 &amp;&amp; c &lt;= 0xd)	/* \t, \n, vertical tab, form feed, \r */
				buf[m++] = c;
		}

		if(m &amp;&amp; write(out, buf, m) &lt; 0)
			return;
	}
}

/*
 * read in the message body to count \n without a preceding \r
 */
static int
msgBodySize(Msg *m)
{
	Dir *d;
	char buf[BufSize + 2], *s, *se;
	vlong length;
	ulong size, lines, bad;
	int n, fd, c;

	if(m-&gt;lines != ~0UL)
		return 1;
	fd = msgFile(m, "rawbody");
	if(fd &lt; 0)
		return 0;
	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		return 0;
	}
	length = d-&gt;length;
	free(d);

	size = 0;
	lines = 0;
	bad = 0;
	buf[0] = ' ';
	for(;;){
		n = read(fd, &amp;buf[1], BufSize);
		if(n &lt;= 0)
			break;
		size += n;
		se = &amp;buf[n + 1];
		for(s = &amp;buf[1]; s &lt; se; s++){
			c = *s;
			if(c == '\0'){
				close(fd);
				return msgBogus(m, BogusBody);
			}
			if(c != '\n')
				continue;
			if(s[-1] != '\r')
				bad++;
			lines++;
		}
		buf[0] = buf[n];
	}
	if(size != length)
		bye("bad length reading rawbody");
	size += bad;
	m-&gt;size = size;
	m-&gt;lines = lines;
	close(fd);
	return 1;
}

/*
 * retrieve information from the unixheader file
 */
static int
msgUnix(Msg *m, int top)
{
	Tm tm;
	char *s, *ss;

	if(m-&gt;unixDate != nil)
		return 1;

	if(!top){
bogus:
		m-&gt;unixDate = estrdup("");
		m-&gt;unixFrom = unixFrom(nil);
		return 1;
	}

	if(msgReadFile(m, "unixheader", &amp;ss) &lt; 0)
		return 0;
	s = ss;
	s = strchr(s, ' ');
	if(s == nil){
		free(ss);
		goto bogus;
	}
	s++;
	m-&gt;unixFrom = unixFrom(s);
	s = (char*)headStr;
	if(date2tm(&amp;tm, s) == nil)
		s = m-&gt;info[IUnixDate];
	if(s == nil){
		free(ss);
		goto bogus;
	}
	m-&gt;unixDate = estrdup(s);
	free(ss);
	return 1;
}

/*
 * parse the address in the unix header
 * last line of defence, so must return something
 */
static MAddr *
unixFrom(char *s)
{
	MAddr *a;
	char *e, *t;

	if(s == nil)
		return nil;
	headStr = (uchar*)s;
	t = emalloc(strlen(s) + 2);
	e = headAddrSpec(t, nil);
	if(e == nil)
		a = nil;
	else{
		if(*e != '\0')
			*e++ = '\0';
		else
			e = site;
		a = MKZ(MAddr);

		a-&gt;box = estrdup(t);
		a-&gt;host = estrdup(e);
	}
	free(t);
	return a;
}

/*
 * read in the entire header,
 * and parse out any existing mime headers
 */
static int
msgHeader(Msg *m, Header *h, char *file)
{
	char *s, *ss, *t, *te;
	ulong lines, n, nn;
	long ns;
	int dated, c;

	if(h-&gt;buf != nil)
		return 1;

	ns = msgReadFile(m, file, &amp;ss);
	if(ns &lt; 0)
		return 0;
	s = ss;
	n = ns;

	/*
	 * count lines ending with \n and \r\n
	 * add an extra line at the end, since upas/fs headers
	 * don't have a terminating \r\n
	 */
	lines = 1;
	te = s + ns;
	for(t = s; t &lt; te; t++){
		c = *t;
		if(c == '\0')
			return msgBogus(m, BogusHeader);
		if(c != '\n')
			continue;
		if(t == s || t[-1] != '\r')
			n++;
		lines++;
	}
	if(t &gt; s &amp;&amp; t[-1] != '\n'){
		if(t[-1] != '\r')
			n++;
		n++;
	}
	n += 2;
	h-&gt;buf = emalloc(n + 1);
	h-&gt;size = n;
	h-&gt;lines = lines;

	/*
	 * make sure all headers end in \r\n
	 */
	nn = 0;
	for(t = s; t &lt; te; t++){
		c = *t;
		if(c == '\n'){
			if(!nn || h-&gt;buf[nn - 1] != '\r')
				h-&gt;buf[nn++] = '\r';
			lines++;
		}
		h-&gt;buf[nn++] = c;
	}
	if(nn &amp;&amp; h-&gt;buf[nn-1] != '\n'){
		if(h-&gt;buf[nn-1] != '\r')
			h-&gt;buf[nn++] = '\r';
		h-&gt;buf[nn++] = '\n';
	}
	h-&gt;buf[nn++] = '\r';
	h-&gt;buf[nn++] = '\n';
	h-&gt;buf[nn] = '\0';
	if(nn != n)
		bye("misconverted header %ld %ld", nn, n);
	free(s);

	/*
	 * and parse some mime headers
	 */
	headStr = (uchar*)h-&gt;buf;
	dated = 0;
	while(s = headAtom(headFieldStop)){
		if(cistrcmp(s, "content-type") == 0)
			mimeType(h);
		else if(cistrcmp(s, "content-transfer-encoding") == 0)
			mimeEncoding(h);
		else if(cistrcmp(s, "content-id") == 0)
			mimeId(h);
		else if(cistrcmp(s, "content-description") == 0)
			mimeDescription(h);
		else if(cistrcmp(s, "content-disposition") == 0)
			mimeDisposition(h);
		else if(cistrcmp(s, "content-md5") == 0)
			mimeMd5(h);
		else if(cistrcmp(s, "content-language") == 0)
			mimeLanguage(h);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "from") == 0)
			m-&gt;from = headMAddr(m-&gt;from);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "to") == 0)
			m-&gt;to = headMAddr(m-&gt;to);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "reply-to") == 0)
			m-&gt;replyTo = headMAddr(m-&gt;replyTo);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "sender") == 0)
			m-&gt;sender = headMAddr(m-&gt;sender);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "cc") == 0)
			m-&gt;cc = headMAddr(m-&gt;cc);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "bcc") == 0)
			m-&gt;bcc = headMAddr(m-&gt;bcc);
		else if(h == &amp;m-&gt;head &amp;&amp; cistrcmp(s, "date") == 0)
			dated = 1;
		headSkip();
		free(s);
	}

	if(h == &amp;m-&gt;head){
		if(m-&gt;from == nil){
			m-&gt;from = m-&gt;unixFrom;
			if(m-&gt;from != nil){
				s = maddrStr(m-&gt;from);
				msgAddHead(m, "From", s);
				free(s);
			}
		}
		if(m-&gt;sender == nil)
			m-&gt;sender = m-&gt;from;
		if(m-&gt;replyTo == nil)
			m-&gt;replyTo = m-&gt;from;

		if(infoIsNil(m-&gt;info[IDate]))
			m-&gt;info[IDate] = m-&gt;unixDate;
		if(!dated &amp;&amp; m-&gt;from != nil)
			msgAddDate(m);
	}
	return 1;
}

/*
 * prepend head: body to the cached header
 */
static void
msgAddHead(Msg *m, char *head, char *body)
{
	char *s;
	long size, n;

	n = strlen(head) + strlen(body) + 4;
	size = m-&gt;head.size + n;
	s = emalloc(size + 1);
	snprint(s, size + 1, "%s: %s\r\n%s", head, body, m-&gt;head.buf);
	free(m-&gt;head.buf);
	m-&gt;head.buf = s;
	m-&gt;head.size = size;
	m-&gt;head.lines++;
}

static void
msgAddDate(Msg *m)
{
	Tm tm;
	char buf[64];

	/* don't bother if we don't have a date */
	if(infoIsNil(m-&gt;info[IDate]))
		return;

	date2tm(&amp;tm, m-&gt;info[IDate]);
	rfc822date(buf, sizeof(buf), &amp;tm);
	msgAddHead(m, "Date", buf);
}

static MimeHdr*
mkMimeHdr(char *s, char *t, MimeHdr *next)
{
	MimeHdr *mh;

	mh = MK(MimeHdr);
	mh-&gt;s = s;
	mh-&gt;t = t;
	mh-&gt;next = next;
	return mh;
}

static void
freeMimeHdr(MimeHdr *mh)
{
	MimeHdr *last;

	while(mh != nil){
		last = mh;
		mh = mh-&gt;next;
		free(last-&gt;s);
		free(last-&gt;t);
		free(last);
	}
}

static void
cleanupHeader(Header *h)
{
	freeMimeHdr(h-&gt;type);
	freeMimeHdr(h-&gt;id);
	freeMimeHdr(h-&gt;description);
	freeMimeHdr(h-&gt;encoding);
	freeMimeHdr(h-&gt;md5);
	freeMimeHdr(h-&gt;disposition);
	freeMimeHdr(h-&gt;language);
}

/*
 * parser for rfc822 &amp; mime header fields
 */

/*
 * type		: 'content-type' ':' token '/' token params
 */
static void
mimeType(Header *h)
{
	char *s, *t;

	if(headChar(1) != ':')
		return;
	s = headAtom(mimeTokenStop);
	if(s == nil || headChar(1) != '/'){
		free(s);
		return;
	}
	t = headAtom(mimeTokenStop);
	if(t == nil){
		free(s);
		return;
	}
	h-&gt;type = mkMimeHdr(s, t, mimeParams());
}

/*
 * params	:
 *		| params ';' token '=' token
 * 		| params ';' token '=' quoted-str
 */
static MimeHdr*
mimeParams(void)
{
	MimeHdr head, *last;
	char *s, *t;

	head.next = nil;
	last = &amp;head;
	for(;;){
		if(headChar(1) != ';')
			break;
		s = headAtom(mimeTokenStop);
		if(s == nil || headChar(1) != '='){
			free(s);
			break;
		}
		if(headChar(0) == '"'){
			t = headQuoted('"', '"');
			stripQuotes(t);
		}else
			t = headAtom(mimeTokenStop);
		if(t == nil){
			free(s);
			break;
		}
		last-&gt;next = mkMimeHdr(s, t, nil);
		last = last-&gt;next;
	}
	return head.next;
}

/*
 * encoding	: 'content-transfer-encoding' ':' token
 */
static void
mimeEncoding(Header *h)
{
	char *s;

	if(headChar(1) != ':')
		return;
	s = headAtom(mimeTokenStop);
	if(s == nil)
		return;
	h-&gt;encoding = mkMimeHdr(s, nil, nil);
}

/*
 * mailaddr	: ':' addresses
 */
static MAddr*
headMAddr(MAddr *old)
{
	MAddr *a;

	if(headChar(1) != ':')
		return old;

	if(headChar(0) == '\n')
		return old;

	a = headAddresses();
	if(a == nil)
		return old;

	freeMAddr(old);
	return a;
}

/*
 * addresses	: address | addresses ',' address
 */
static MAddr*
headAddresses(void)
{
	MAddr *addr, *tail, *a;

	addr = headAddress();
	if(addr == nil)
		return nil;
	tail = addr;
	while(headChar(0) == ','){
		headChar(1);
		a = headAddress();
		if(a == nil){
			freeMAddr(addr);
			return nil;
		}
		tail-&gt;next = a;
		tail = a;
	}
	return addr;
}

/*
 * address	: mailbox | group
 * group	: phrase ':' mboxes ';' | phrase ':' ';'
 * mailbox	: addr-spec
 *		| optphrase '&lt;' addr-spec '&gt;'
 *		| optphrase '&lt;' route ':' addr-spec '&gt;'
 * optphrase	: | phrase
 * route	: '@' domain
 *		| route ',' '@' domain
 * personal names are the phrase before '&lt;',
 * or a comment before or after a simple addr-spec
 */
static MAddr*
headAddress(void)
{
	MAddr *addr;
	uchar *hs;
	char *s, *e, *w, *personal;
	int c;

	s = emalloc(strlen((char*)headStr) + 2);
	e = s;
	personal = headSkipWhite(1);
	c = headChar(0);
	if(c == '&lt;')
		w = nil;
	else{
		w = headWord();
		c = headChar(0);
	}
	if(c == '.' || c == '@' || c == ',' || c == '\n' || c == '\0'){
		lastWhite = headStr;
		e = headAddrSpec(s, w);
		if(personal == nil){
			hs = headStr;
			headStr = lastWhite;
			personal = headSkipWhite(1);
			headStr = hs;
		}
	}else{
		if(c != '&lt;' || w != nil){
			free(personal);
			if(!headPhrase(e, w)){
				free(s);
				return nil;
			}

			/*
			 * ignore addresses with groups,
			 * so the only thing left if &lt;
			 */
			c = headChar(1);
			if(c != '&lt;'){
				free(s);
				return nil;
			}
			personal = estrdup(s);
		}else
			headChar(1);

		/*
		 * after this point, we need to free personal before returning.
		 * set e to nil to everything afterwards fails.
		 *
		 * ignore routes, they are useless, and heavily discouraged in rfc1123.
		 * imap4 reports them up to, but not including, the terminating :
		 */
		e = s;
		c = headChar(0);
		if(c == '@'){
			for(;;){
				c = headChar(1);
				if(c != '@'){
					e = nil;
					break;
				}
				headDomain(e);
				c = headChar(1);
				if(c != ','){
					e = s;
					break;
				}
			}
			if(c != ':')
				e = nil;
		}

		if(e != nil)
			e = headAddrSpec(s, nil);
		if(headChar(1) != '&gt;')
			e = nil;
	}

	/*
	 * e points to @host, or nil if an error occured
	 */
	if(e == nil){
		free(personal);
		addr = nil;
	}else{
		if(*e != '\0')
			*e++ = '\0';
		else
			e = site;
		addr = MKZ(MAddr);

		addr-&gt;personal = personal;
		addr-&gt;box = estrdup(s);
		addr-&gt;host = estrdup(e);
	}
	free(s);
	return addr;
}

/*
 * phrase	: word
 *		| phrase word
 * w is the optional initial word of the phrase
 * returns the end of the phrase, or nil if a failure occured
 */
static char*
headPhrase(char *e, char *w)
{
	int c;

	for(;;){
		if(w == nil){
			w = headWord();
			if(w == nil)
				return nil;
		}
		if(w[0] == '"')
			stripQuotes(w);
		strcpy(e, w);
		free(w);
		w = nil;
		e = strchr(e, '\0');
		c = headChar(0);
		if(c &lt;= ' ' || strchr(headAtomStop, c) != nil &amp;&amp; c != '"')
			break;
		*e++ = ' ';
		*e = '\0';
	}
	return e;
}

/*
 * addr-spec	: local-part '@' domain
 *		| local-part			extension to allow ! and local names
 * local-part	: word
 *		| local-part '.' word
 *
 * if no '@' is present, rewrite d!e!f!u as @d,@e:u@f,
 * where d, e, f are valid domain components.
 * the @d,@e: is ignored, since routes are ignored.
 * perhaps they should be rewritten as e!f!u@d, but that is inconsistent with upas.
 *
 * returns a pointer to '@', the end if none, or nil if there was an error
 */
static char*
headAddrSpec(char *e, char *w)
{
	char *s, *at, *b, *bang, *dom;
	int c;

	s = e;
	for(;;){
		if(w == nil){
			w = headWord();
			if(w == nil)
				return nil;
		}
		strcpy(e, w);
		free(w);
		w = nil;
		e = strchr(e, '\0');
		lastWhite = headStr;
		c = headChar(0);
		if(c != '.')
			break;
		headChar(1);
		*e++ = '.';
		*e = '\0';
	}

	if(c != '@'){
		/*
		 * extenstion: allow name without domain
		 * check for domain!xxx
		 */
		bang = domBang(s);
		if(bang == nil)
			return e;

		/*
		 * if dom1!dom2!xxx, ignore dom1!
		 */
		dom = s;
		for(; b = domBang(bang + 1); bang = b)
			dom = bang + 1;

		/*
		 * convert dom!mbox into mbox@dom
		 */
		*bang = '@';
		strrev(dom, bang);
		strrev(bang+1, e);
		strrev(dom, e);
		bang = &amp;dom[e - bang - 1];
		if(dom &gt; s){
			bang -= dom - s;
			for(e = s; *e = *dom; e++)
				dom++;
		}

		/*
		 * eliminate a trailing '.'
		 */
		if(e[-1] == '.')
			e[-1] = '\0';
		return bang;
	}
	headChar(1);

	at = e;
	*e++ = '@';
	*e = '\0';
	if(!headDomain(e))
		return nil;
	return at;
}

/*
 * find the ! in domain!rest, where domain must have at least
 * one internal '.'
 */
static char*
domBang(char *s)
{
	int dot, c;

	dot = 0;
	for(; c = *s; s++){
		if(c == '!'){
			if(!dot || dot == 1 &amp;&amp; s[-1] == '.' || s[1] == '\0')
				return nil;
			return s;
		}
		if(c == '"')
			break;
		if(c == '.')
			dot++;
	}
	return nil;
}

/*
 * domain	: sub-domain
 *		| domain '.' sub-domain
 * returns the end of the domain, or nil if a failure occured
 */
static char*
headDomain(char *e)
{
	char *w;

	for(;;){
		w = headSubDomain();
		if(w == nil)
			return nil;
		strcpy(e, w);
		free(w);
		e = strchr(e, '\0');
		lastWhite = headStr;
		if(headChar(0) != '.')
			break;
		headChar(1);
		*e++ = '.';
		*e = '\0';
	}
	return e;
}

/*
 * id		: 'content-id' ':' msg-id
 * msg-id	: '&lt;' addr-spec '&gt;'
 */
static void
mimeId(Header *h)
{
	char *s, *e, *w;

	if(headChar(1) != ':')
		return;
	if(headChar(1) != '&lt;')
		return;

	s = emalloc(strlen((char*)headStr) + 3);
	e = s;
	*e++ = '&lt;';
	e = headAddrSpec(e, nil);
	if(e == nil || headChar(1) != '&gt;'){
		free(s);
		return;
	}
	e = strchr(e, '\0');
	*e++ = '&gt;';
	e[0] = '\0';
	w = strdup(s);
	free(s);
	h-&gt;id = mkMimeHdr(w, nil, nil);
}

/*
 * description	: 'content-description' ':' *text
 */
static void
mimeDescription(Header *h)
{
	if(headChar(1) != ':')
		return;
	headSkipWhite(0);
	h-&gt;description = mkMimeHdr(headText(), nil, nil);
}

/*
 * disposition	: 'content-disposition' ':' token params
 */
static void
mimeDisposition(Header *h)
{
	char *s;

	if(headChar(1) != ':')
		return;
	s = headAtom(mimeTokenStop);
	if(s == nil)
		return;
	h-&gt;disposition = mkMimeHdr(s, nil, mimeParams());
}

/*
 * md5		: 'content-md5' ':' token
 */
static void
mimeMd5(Header *h)
{
	char *s;

	if(headChar(1) != ':')
		return;
	s = headAtom(mimeTokenStop);
	if(s == nil)
		return;
	h-&gt;md5 = mkMimeHdr(s, nil, nil);
}

/*
 * language	: 'content-language' ':' langs
 * langs	: token
 *		| langs commas token
 * commas	: ','
 *		| commas ','
 */
static void
mimeLanguage(Header *h)
{
	MimeHdr head, *last;
	char *s;

	head.next = nil;
	last = &amp;head;
	for(;;){
		s = headAtom(mimeTokenStop);
		if(s == nil)
			break;
		last-&gt;next = mkMimeHdr(s, nil, nil);
		last = last-&gt;next;
		while(headChar(0) != ',')
			headChar(1);
	}
	h-&gt;language = head.next;
}

/*
 * token	: 1*&lt;char 33-255, except "()&lt;&gt;@,;:\\\"/[]?=" aka mimeTokenStop&gt;
 * atom		: 1*&lt;chars 33-255, except "()&lt;&gt;@,;:\\\".[]" aka headAtomStop&gt;
 * note this allows 8 bit characters, which occur in utf.
 */
static char*
headAtom(char *disallowed)
{
	char *s;
	int c, ns, as;

	headSkipWhite(0);

	s = emalloc(StrAlloc);
	as = StrAlloc;
	ns = 0;
	for(;;){
		c = *headStr++;
		if(c &lt;= ' ' || strchr(disallowed, c) != nil){
			headStr--;
			break;
		}
		s[ns++] = c;
		if(ns &gt;= as){
			as += StrAlloc;
			s = erealloc(s, as);
		}
	}
	if(ns == 0){
		free(s);
		return 0;
	}
	s[ns] = '\0';
	return s;
}

/*
 * sub-domain	: atom | domain-lit
 */
static char *
headSubDomain(void)
{
	if(headChar(0) == '[')
		return headQuoted('[', ']');
	return headAtom(headAtomStop);
}

/*
 * word	: atom | quoted-str
 */
static char *
headWord(void)
{
	if(headChar(0) == '"')
		return headQuoted('"', '"');
	return headAtom(headAtomStop);
}

/*
 * q is a quoted string.  remove enclosing " and and \ escapes
 */
static void
stripQuotes(char *q)
{
	char *s;
	int c;

	if(q == nil)
		return;
	s = q++;
	while(c = *q++){
		if(c == '\\'){
			c = *q++;
			if(!c)
				return;
		}
		*s++ = c;
	}
	s[-1] = '\0';
}

/*
 * quoted-str	: '"' *(any char but '"\\\r', or '\' any char, or linear-white-space) '"'
 * domain-lit	: '[' *(any char but '[]\\\r', or '\' any char, or linear-white-space) ']'
 */
static char *
headQuoted(int start, int stop)
{
	char *s;
	int c, ns, as;

	if(headChar(1) != start)
		return nil;
	s = emalloc(StrAlloc);
	as = StrAlloc;
	ns = 0;
	s[ns++] = start;
	for(;;){
		c = *headStr;
		if(c == stop){
			headStr++;
			break;
		}
		if(c == '\0'){
			free(s);
			return nil;
		}
		if(c == '\r'){
			headStr++;
			continue;
		}
		if(c == '\n'){
			headStr++;
			while(*headStr == ' ' || *headStr == '\t' || *headStr == '\r' || *headStr == '\n')
				headStr++;
			c = ' ';
		}else if(c == '\\'){
			headStr++;
			s[ns++] = c;
			c = *headStr;
			if(c == '\0'){
				free(s);
				return nil;
			}
			headStr++;
		}else
			headStr++;
		s[ns++] = c;
		if(ns + 1 &gt;= as){	/* leave room for \c or "0 */
			as += StrAlloc;
			s = erealloc(s, as);
		}
	}
	s[ns++] = stop;
	s[ns] = '\0';
	return s;
}

/*
 * headText	: contents of rest of header line
 */
static char *
headText(void)
{
	uchar *v;
	char *s;

	v = headStr;
	headToEnd();
	s = emalloc(headStr - v + 1);
	memmove(s, v, headStr - v);
	s[headStr - v] = '\0';
	return s;
}

/*
 * white space is ' ' '\t' or nested comments.
 * skip white space.
 * if com and a comment is seen,
 * return it's contents and stop processing white space.
 */
static char*
headSkipWhite(int com)
{
	char *s;
	int c, incom, as, ns;

	s = nil;
	as = StrAlloc;
	ns = 0;
	if(com)
		s = emalloc(StrAlloc);
	incom = 0;
	for(; c = *headStr; headStr++){
		switch(c){
		case ' ':
		case '\t':
		case '\r':
			c = ' ';
			break;
		case '\n':
			c = headStr[1];
			if(c != ' ' &amp;&amp; c != '\t')
				goto breakout;
			c = ' ';
			break;
		case '\\':
			if(com &amp;&amp; incom)
				s[ns++] = c;
			c = headStr[1];
			if(c == '\0')
				goto breakout;
			headStr++;
			break;
		case '(':
			incom++;
			if(incom == 1)
				continue;
			break;
		case ')':
			incom--;
			if(com &amp;&amp; !incom){
				s[ns] = '\0';
				return s;
			}
			break;
		default:
			if(!incom)
				goto breakout;
			break;
		}
		if(com &amp;&amp; incom &amp;&amp; (c != ' ' || ns &gt; 0 &amp;&amp; s[ns-1] != ' ')){
			s[ns++] = c;
			if(ns + 1 &gt;= as){	/* leave room for \c or 0 */
				as += StrAlloc;
				s = erealloc(s, as);
			}
		}
	}
breakout:;
	free(s);
	return nil;
}

/*
 * return the next non-white character
 */
static int
headChar(int eat)
{
	int c;

	headSkipWhite(0);
	c = *headStr;
	if(eat &amp;&amp; c != '\0' &amp;&amp; c != '\n')
		headStr++;
	return c;
}

static void
headToEnd(void)
{
	uchar *s;
	int c;

	for(;;){
		s = headStr;
		c = *s++;
		while(c == '\r')
			c = *s++;
		if(c == '\n'){
			c = *s++;
			if(c != ' ' &amp;&amp; c != '\t')
				return;
		}
		if(c == '\0')
			return;
		headStr = s;
	}
}

static void
headSkip(void)
{
	int c;

	while(c = *headStr){
		headStr++;
		if(c == '\n'){
			c = *headStr;
			if(c == ' ' || c == '\t')
				continue;
			return;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

