<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/mutf7.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/mutf7.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

/*
 * modified utf-7, as per imap4 spec
 * like utf-7, but substitues , for / in base 64,
 * does not allow escaped ascii characters.
 *
 * /lib/rfc/rfc2152 is utf-7
 * /lib/rfc/rfc1642 is obsolete utf-7
 *
 * test sequences from rfc1642
 *	'A≢Α.'		'A&amp;ImIDkQ-.'
 *	'Hi Mom ☺!"	'Hi Mom &amp;Jjo-!'
 *	'日本語'		'&amp;ZeVnLIqe-'
 */

static uchar mt64d[256];
static char mt64e[64];

static void
initm64(void)
{
	int c, i;

	memset(mt64d, 255, 256);
	memset(mt64e, '=', 64);
	i = 0;
	for(c = 'A'; c &lt;= 'Z'; c++){
		mt64e[i] = c;
		mt64d[c] = i++;
	}
	for(c = 'a'; c &lt;= 'z'; c++){
		mt64e[i] = c;
		mt64d[c] = i++;
	}
	for(c = '0'; c &lt;= '9'; c++){
		mt64e[i] = c;
		mt64d[c] = i++;
	}
	mt64e[i] = '+';
	mt64d['+'] = i++;
	mt64e[i] = ',';
	mt64d[','] = i;
}

int
encmutf7(char *out, int lim, char *in)
{
	Rune rr;
	ulong r, b;
	char *start = out;
	char *e = out + lim;
	int nb;

	if(mt64e[0] == 0)
		initm64();
	for(;;){
		r = *(uchar*)in;

		if(r &lt; ' ' || r &gt;= Runeself){
			if(r == '\0')
				break;
			if(out + 1 &gt;= e)
				return -1;
			*out++ = '&amp;';
			b = 0;
			nb = 0;
			for(;;){
				in += chartorune(&amp;rr, in);
				r = rr;
				if(r == '\0' || r &gt;= ' ' &amp;&amp; r &lt; Runeself)
					break;
				b = (b &lt;&lt; 16) | r;
				for(nb += 16; nb &gt;= 6; nb -= 6){
					if(out + 1 &gt;= e)
						return -1;
					*out++ = mt64e[(b&gt;&gt;(nb-6))&amp;0x3f];
				}
			}
			for(; nb &gt;= 6; nb -= 6){
				if(out + 1 &gt;= e)
					return -1;
				*out++ = mt64e[(b&gt;&gt;(nb-6))&amp;0x3f];
			}
			if(nb){
				if(out + 1 &gt;= e)
					return -1;
				*out++ = mt64e[(b&lt;&lt;(6-nb))&amp;0x3f];
			}

			if(out + 1 &gt;= e)
				return -1;
			*out++ = '-';
			if(r == '\0')
				break;
		}else
			in++;
		if(out + 1 &gt;= e)
			return -1;
		*out = r;
		out++;
		if(r == '&amp;')
			*out++ = '-';
	}

	if(out &gt;= e)
		return -1;
	*out = '\0';
	return out - start;
}

int
decmutf7(char *out, int lim, char *in)
{
	Rune rr;
	char *start = out;
	char *e = out + lim;
	int c, b, nb;

	if(mt64e[0] == 0)
		initm64();
	for(;;){
		c = *in;

		if(c &lt; ' ' || c &gt;= Runeself){
			if(c == '\0')
				break;
			return -1;
		}
		if(c != '&amp;'){
			if(out + 1 &gt;= e)
				return -1;
			*out++ = c;
			in++;
			continue;
		}
		in++;
		if(*in == '-'){
			if(out + 1 &gt;= e)
				return -1;
			*out++ = '&amp;';
			in++;
			continue;
		}

		b = 0;
		nb = 0;
		while((c = *in++) != '-'){
			c = mt64d[c];
			if(c &gt;= 64)
				return -1;
			b = (b &lt;&lt; 6) | c;
			nb += 6;
			if(nb &gt;= 16){
				rr = b &gt;&gt; (nb - 16);
				nb -= 16;
				if(out + UTFmax + 1 &gt;= e &amp;&amp; out + runelen(rr) + 1 &gt;= e)
					return -1;
				out += runetochar(out, &amp;rr);
			}
		}
		if(b &amp; ((1 &lt;&lt; nb) - 1))
			return -1;
	}

	if(out &gt;= e)
		return -1;
	*out = '\0';
	return out - start;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

