<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/linklocal.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/linklocal.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * linklocal - print ipv6 link-local or 6to4 address of a mac address.
 * eui is ieee's extended unique identifier, per rfc2373.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;

enum {
	Mac0mcast	= 1&lt;&lt;0,		/* multicast address */
	Mac0localadm	= 1&lt;&lt;1,		/* locally-administered address, */
	V60globaladm	= 1&lt;&lt;1,		/* but ipv6 reverses the meaning */
};

static char *v4_6to4;

static void
usage(void)
{
	fprint(2, "usage: %s [-t ipv4] ether...\n", argv0);
	exits("usage");
}

void
ea2eui64(uchar *lla, uchar *ea)
{
	*lla++ = *ea++ | V60globaladm;	/* oui (company id) */
	*lla++ = *ea++;			/* " */
	*lla++ = *ea++;			/* " */
	*lla++ = 0xFF;			/* mac-48 in eui-64 (sic) */
	*lla++ = 0xFE;			/* " */
	*lla++ = *ea++;			/* manufacturer-assigned */
	*lla++ = *ea++;			/* " */
	*lla = *ea;			/* " */
}

void
eaip26to4(uchar *lla, uchar *ea, uchar *ipv4)
{
	*lla++ = 0x20;			/* 6to4 address */
	*lla++ = 0x02;			/* " */
	memmove(lla, ipv4, IPv4addrlen);
	lla += IPv4addrlen;
	memset(lla, 0, 2);
	ea2eui64(lla + 2, ea);
}

void
ea2lla(uchar *lla, uchar *ea)
{
	*lla++ = 0xFE;			/* link-local v6 */
	*lla++ = 0x80;			/* " */
	memset(lla, 0, 6);
	ea2eui64(lla + 6, ea);
}

static void
process(char *ether)
{
	uchar ethaddr[6], ipaddr[IPaddrlen], ipv4[IPv4addrlen];

	if (parseether(ethaddr, ether) &lt; 0)
		sysfatal("%s: not an ether address", ether);
	if (v4_6to4) {
		v4parseip(ipv4, v4_6to4);
		eaip26to4(ipaddr, ethaddr, ipv4);
	} else
		ea2lla(ipaddr, ethaddr);
	print("%I\n", ipaddr);
}

void
main(int argc, char *argv[])
{
	int i;

	ARGBEGIN {
	case 't':
		v4_6to4 = EARGF(usage());
		break;
	default:
		usage();
		break;
	} ARGEND

	fmtinstall('I', eipfmt);
	if (argc &lt;= 0)
		usage();

	for (i = 0; i &lt; argc; i++)
		process(argv[i]);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

