<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/mppc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/mppc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ip.h&gt;
#include &lt;auth.h&gt;
#include "ppp.h"

enum {
	HistorySize=	8*1024,
	Cminmatch	= 3,		/* sintest match possible */
	Chshift		= 4,		/* nice compromise between space &amp; time */
	Cnhash		= 1&lt;&lt;(Chshift*Cminmatch),
	HMASK		= Cnhash-1,
};

typedef struct Carena Carena;
struct Carena
{
	uchar	*pos;			/* current place, also amount of history filled */
	uchar	buf[HistorySize];
};

typedef struct Cstate Cstate;
struct Cstate
{
	QLock;
	int	count;
	int	reset;		/* compressor has been reset */
	int	front;		/* move to begining of history */
	ulong	sreg;		/* output shift reg */
	int	bits;		/* number of bits in sreg */
	Block	*b; 		/* output block */

	/*
	 * state for hashing compressor
	 */
	Carena	arenas[2];
	Carena	*hist;
	Carena	*ohist;
	ulong	hash[Cnhash];
	int	h;
	ulong	me;
	ulong	split;

	int	encrypt;
	uchar	startkey[16];
	uchar	key[16];
	RC4state rc4key;
};

typedef struct Uncstate Uncstate;
struct Uncstate
{
	int	count;	 	/* packet count - detects missing packets */
	int	resetid;	/* id of reset requests */
	uchar	his[HistorySize];
	int	indx;		/* current indx in history */
	int	size;		/* current history size */
	uchar	startkey[16];
	uchar	key[16];
	RC4state rc4key;
};

/* packet flags */
enum {
	Preset=		(1&lt;&lt;15),	/* reset history */
	Pfront=		(1&lt;&lt;14),	/* move packet to front of history */
	Pcompress=	(1&lt;&lt;13),	/* packet is compressed */
	Pencrypt=	(1&lt;&lt;12),	/* packet is encrypted */
};

enum {
	Lit7,		/* seven bit literal */
	Lit8,		/* eight bit literal */
	Off6,		/* six bit offset */
	Off8,		/* eight bit offset */
	Off13,		/* thirteen bit offset */
};

/* decode first four bits */
int decode[16] = {
	Lit7,	
	Lit7,
	Lit7,
	Lit7,
	Lit7,
	Lit7,
	Lit7,
	Lit7,
	Lit8,
	Lit8,	
	Lit8,
	Lit8,	
	Off13,
	Off13,
	Off8,
	Off6,
};
	

static	void		*compinit(PPP*);
static	Block*		comp(PPP*, ushort, Block*, int*);
static	void		comp2(Cstate*, uchar*, int);
static	Block		*compresetreq(void*, Block*);
static	void		compfini(void*);
static	void		complit(Cstate*, int);
static	void		compcopy(Cstate*, int, int);
static	void		compout(Cstate*, ulong, int);
static	void		compfront(Cstate*);
static	void		hashcheck(Cstate*);
static	void		compreset(Cstate*);
static	int		hashit(uchar*);


static	void		*uncinit(PPP*);
static	Block*		uncomp(PPP*, Block*, int *protop, Block**);
static	Block		*uncomp2(Uncstate *s, Block*, ushort);
static	void		uncfini(void*);
static	void		uncresetack(void*, Block*);
static  int		ipcheck(uchar*, int);
static  void		hischeck(Uncstate*);

static	void		setkey(uchar *key, uchar *startkey);

Comptype cmppc = {
	compinit,
	comp,
	compresetreq,
	compfini
};

Uncomptype uncmppc = {
	uncinit,
	uncomp,
	uncresetack,
	uncfini
};

static void *
compinit(PPP *ppp)
{
	Cstate *cs;

	cs = mallocz(sizeof(Cstate), 1);
	cs-&gt;hist = &amp;cs-&gt;arenas[0];
	cs-&gt;ohist = &amp;cs-&gt;arenas[1];
	compreset(cs);
	/*
	 * make reset clear the hash table
	 */
	cs-&gt;me = ~0;
	compreset(cs);

	cs-&gt;reset = 0;

	if(ppp-&gt;sendencrypted) {
		cs-&gt;encrypt = 1;
		memmove(cs-&gt;startkey, ppp-&gt;key, 16);
		memmove(cs-&gt;key, ppp-&gt;key, 16);
		setkey(cs-&gt;key, cs-&gt;startkey);
		setupRC4state(&amp;cs-&gt;rc4key, cs-&gt;key, 16);
	}

	return cs;
}

static void
compfini(void *as)
{
	Cstate *cs;

	cs = as;
	free(cs);
}


static Block*
comp(PPP *ppp, ushort proto, Block *b, int *protop)
{
	Cstate *s;
	int n, n2;
	ushort count;

	s = ppp-&gt;cstate;
	*protop = 0;

	qlock(s);

	/* put protocol into b */
	b-&gt;rptr -= 2;
	if(b-&gt;rptr &lt; b-&gt;base)
		sysfatal("mppc: not enough header in block");
	b-&gt;rptr[0] = proto&gt;&gt;8;
	b-&gt;rptr[1] = proto;

	n = BLEN(b);
	s-&gt;bits = 0;
	s-&gt;b = allocb(n*9/8+20);
	s-&gt;b-&gt;wptr += 2;	/* leave room for mppc header */

	comp2(s, b-&gt;rptr, n);
		
	/* flush sreg */
	if(s-&gt;bits)
		*s-&gt;b-&gt;wptr++ = s-&gt;sreg&lt;&lt;(8-s-&gt;bits);
	if(s-&gt;b-&gt;wptr &gt; s-&gt;b-&gt;lim)
		sysfatal("mppc: comp: output block overflowed");

	n2 = BLEN(s-&gt;b);

	if(n2 &gt; n-2 &amp;&amp; !s-&gt;encrypt) {
		/* expened and not excrypting so send as a regular packet */
//netlog("mppc: comp: expanded\n"); 
		compreset(s);
		freeb(s-&gt;b);
		b-&gt;rptr += 2;
		qunlock(s);
		*protop = proto;
		return b;
	}

	count = s-&gt;count++;
	s-&gt;count &amp;= 0xfff;
	if(s-&gt;front)
		count |= Pfront;
	if(s-&gt;reset)
		count |= Preset;
	s-&gt;reset = 0;
	s-&gt;front = 0;

	if(n2 &gt; n) {
//netlog("mppc: comp: expanded\n"); 
		freeb(s-&gt;b);
		/* make room for count */
		compreset(s);
		b-&gt;rptr -= 2;
	} else {
		freeb(b);
		b = s-&gt;b;
		count |= Pcompress;
	}
	s-&gt;b = nil;

	if(s-&gt;encrypt) {
		count |= Pencrypt;
		if((count&amp;0xff) == 0xff) {
//netlog("mppc: comp: changing key\n"); 
			setkey(s-&gt;key, s-&gt;startkey);
			setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
			rc4(&amp;s-&gt;rc4key, s-&gt;key, 16);
			setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
		} else if(count&amp;Preset)
			setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
		rc4(&amp;s-&gt;rc4key, b-&gt;rptr+2, BLEN(b)-2);
//netlog("mppc: encrypt %ux\n", count);
	}

	b-&gt;rptr[0] = count&gt;&gt;8;
	b-&gt;rptr[1] = count;
	
	qunlock(s);

	*protop = Pcdata;
	return b;
}

static Block *
compresetreq(void *as, Block *b)
{
	Cstate *cs;

	cs = as;
netlog("mppc: comp: reset request\n");
	qlock(cs);
	compreset(cs);
	qunlock(cs);

	freeb(b);

	return nil;
}

static void
comp2(Cstate *cs, uchar *p, int n)
{
	Carena *hist, *ohist;
	ulong *hash, me, split, you, last;
	uchar *s, *t, *et, *buf, *obuf, *pos, *opos;
	int i, h, m;

	/*
	 * check for wrap
	 */
	if(cs-&gt;me + n &lt; cs-&gt;me)
		compreset(cs);

	if(cs-&gt;hist-&gt;pos + n &gt; cs-&gt;hist-&gt;buf + HistorySize)
		compfront(cs);

	hist = cs-&gt;hist;
	ohist = cs-&gt;ohist;

	hash = cs-&gt;hash;
	me = cs-&gt;me;
	split = cs-&gt;split;

	memmove(hist-&gt;pos, p, n);
	p = hist-&gt;pos;
	hist-&gt;pos = pos = p + n;

	m = Cminmatch;
	if(m &gt; n)
		m = n;
	h = cs-&gt;h;
	for(i = 0; i &lt; m; i++) {
		h = (((h)&lt;&lt;Chshift) ^ p[i]) &amp; HMASK;
		last = me + (i - (Cminmatch-1));
		if(last &gt;= split &amp;&amp; last != me)
			hash[h] = last;
	}

	buf = hist-&gt;buf - split;
	obuf = ohist-&gt;buf + HistorySize - split;
	opos = ohist-&gt;pos;
	while(p &lt; pos) {
		you = hash[h];
		if(you &lt; split) {
			if(me - you &gt;= HistorySize)
				t = opos;
			else
				t = obuf + you;
			et = opos;
		} else {
			t = buf + you;
			et = pos;
		}
		m = pos - p;
		if(m &lt; et - t)
			et = t + m;
		for(s = p; t &lt; et; t++) {
			if(*s != *t)
				break;
			s++;
		}
		m = s - p;
		if(m &lt; Cminmatch) {
			complit(cs, *p);
			s = p + 1;
		} else
			compcopy(cs, me - you, m);

		for(; p != s; p++) {
			if(p + Cminmatch &lt;= pos) {
				hash[h] = me;
				if(p + Cminmatch &lt; pos)
					h = (((h)&lt;&lt;Chshift) ^ p[Cminmatch]) &amp; HMASK;
			}
			me++;
		}
	}

	cs-&gt;h = h;
	cs-&gt;me = me;
}

static void
compfront(Cstate *cs)
{
	Carena *th;

	cs-&gt;front = 1;

	th = cs-&gt;ohist;
	cs-&gt;ohist = cs-&gt;hist;
	cs-&gt;hist = th;
	cs-&gt;hist-&gt;pos = cs-&gt;hist-&gt;buf;
	cs-&gt;h = 0;
	cs-&gt;me = cs-&gt;split + HistorySize;
	cs-&gt;split = cs-&gt;me;
}

static void
compreset(Cstate *cs)
{
	ulong me;

	cs-&gt;reset = 1;

	me = cs-&gt;me;
	if(me + 2 * HistorySize &lt; me){
		me = 0;
		memset(cs-&gt;hash, 0, sizeof(cs-&gt;hash));
	}
	cs-&gt;me = me + 2 * HistorySize;
	cs-&gt;split = cs-&gt;me;
	cs-&gt;hist-&gt;pos = cs-&gt;hist-&gt;buf;
	cs-&gt;ohist-&gt;pos = cs-&gt;ohist-&gt;buf;
}

static void
complit(Cstate *s, int c)
{
	if(c&amp;0x80)
		compout(s, 0x100|(c&amp;0x7f), 9);
	else
		compout(s, c, 8);
}

static void
compcopy(Cstate *s, int off, int len)
{
	int i;
	ulong mask;

	if(off&lt;64)
		compout(s, 0x3c0|off, 10);
	else if(off&lt;320)
		compout(s, 0xe00|(off-64), 12);
	else
		compout(s, 0xc000|(off-320), 16);
	if(len &lt; 3)
		sysfatal("compcopy: bad len: %d", len);
	if(len == 3)
		compout(s, 0, 1);
	else {
		for(i=3; (1&lt;&lt;i) &lt;= len; i++)
			;
		mask = (1&lt;&lt;(i-1))-1;
		compout(s, (((1&lt;&lt;(i-2))-1)&lt;&lt;i) | len&amp;mask, (i-1)&lt;&lt;1);
	}
}

static void
compout(Cstate *s, ulong data, int bits)
{
	ulong sreg;

	sreg = s-&gt;sreg;
	sreg &lt;&lt;= bits;
	sreg |= data;
	bits += s-&gt;bits;
	while(bits &gt;= 8) {
		*s-&gt;b-&gt;wptr++ = sreg&gt;&gt;(bits-8);
		bits -= 8;
	}
	s-&gt;sreg = sreg;
	s-&gt;bits = bits;
}

void
printkey(uchar *key)
{
	char buf[200], *p;
	int i;

	p = buf;
	for(i=0; i&lt;16; i++)
		p += sprint(p, "%.2ux ", key[i]);
//netlog("key = %s\n", buf);
}

static	void *
uncinit(PPP *ppp)
{
	Uncstate *s;

	s = mallocz(sizeof(Uncstate), 1);

	s-&gt;count = 0xfff;	/* count of non existant last packet */
	memmove(s-&gt;startkey, ppp-&gt;key, 16);
	memmove(s-&gt;key, ppp-&gt;key, 16);
	setkey(s-&gt;key, s-&gt;startkey);
	setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);

	return s;
}

static	Block*
uncomp(PPP *ppp, Block *b, int *protop, Block **r)
{
	Uncstate *s;
	ushort proto;
	ushort count;
	Lcpmsg *m;

	*r = nil;
	*protop = 0;
	s = ppp-&gt;uncstate;
	if(BLEN(b) &lt; 2){
		syslog(0, "ppp", ": mppc: short packet\n");
		freeb(b);
		return nil;
	}
	count = nhgets(b-&gt;rptr);
	b-&gt;rptr += 2;

	b = uncomp2(s, b, count);

	if(b == nil) {
//netlog("ppp: mppc: reset request\n");
		/* return reset request packet */
		*r = alloclcp(Lresetreq, s-&gt;resetid++, 4, &amp;m);
		hnputs(m-&gt;len, 4);
		*protop = 0;
		return nil;
	}

	if(BLEN(b) &lt; 2){
		syslog(0, "ppp", ": mppc: short packet\n");
		freeb(b);
		*protop = 0;
		return nil;
	}
	proto = nhgets(b-&gt;rptr);
	b-&gt;rptr += 2;

/*
	if(proto == 0x21)
		if(!ipcheck(b-&gt;rptr, BLEN(b)))
			hischeck(s);
*/

	*protop = proto;
	return b;
}

#define NEXTBYTE	sreg = (sreg&lt;&lt;8) | *p++; n--; bits += 8
int	maxoff;
	
static	Block*
uncomp2(Uncstate *s, Block *b, ushort count)
{
	int ecount, n, bits, off, len, ones;
	ulong sreg;
	int t;
	uchar *p, c, *hp, *hs, *he, *hq;

	if(count&amp;Preset) {
//netlog("mppc reset\n");
		s-&gt;indx = 0;
		s-&gt;size = 0;
		setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
	} else {
		ecount = (s-&gt;count+1)&amp;0xfff;
		if((count&amp;0xfff) != ecount) {
netlog("******* bad count - got %ux expected %ux\n", count&amp;0xfff, ecount);
			freeb(b);
			return nil;
		}
		if(count&amp;Pfront) {
			s-&gt;indx = 0;
/*			netlog("ppp: mppc: frount flag set\n"); */
		}
	}

	/* update key */
	n = (((count+1)&gt;&gt;8)&amp;0xf) - (((s-&gt;count+1)&gt;&gt;8)&amp;0xf);
	if(n &lt; 0)
		n += 16;
//netlog("mppc count = %ux oldcount %ux n = %d\n", count, s-&gt;count, n);
	if(n &lt; 0 || n &gt; 1) {
		syslog(0, "ppp", ": mppc bad count %ux, %ux", count, s-&gt;count);
		freeb(b);
		return nil;
	}
	if(n == 1) {
		setkey(s-&gt;key, s-&gt;startkey);
		setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
		rc4(&amp;s-&gt;rc4key, s-&gt;key, 16);
		setupRC4state(&amp;s-&gt;rc4key, s-&gt;key, 16);
	}
	
	s-&gt;count = count;

	n = BLEN(b);
	p = b-&gt;rptr;
	if(count &amp; Pencrypt) {
//netlog("mppc unencrypt count = %ux\n", count);
		rc4(&amp;s-&gt;rc4key, p, n);
	}

	if(!(count &amp; Pcompress)) {
//netlog("uncompress blen = %d\n", BLEN(b));
		return  b;
	}

	bits = 0;
	sreg = 0;
	hs = s-&gt;his;		/* history start */
	hp = hs+s-&gt;indx;	/* write pointer in history */
	he = hs+sizeof(s-&gt;his);	/* hsitory end */
	for(;;) {
		if(bits&lt;4) {
			if(n==0) goto Done;
			NEXTBYTE;
		}
		t = decode[(sreg&gt;&gt;(bits-4))&amp;0xf];
		switch(t) {
		default:
			sysfatal("mppc: bad decode!");
		case Lit7:
			bits -= 1;
			if(bits&lt;7) {
				if(n==0) goto Done;
				NEXTBYTE;
			}
			c = (sreg&gt;&gt;(bits-7))&amp;0x7f;
			bits -= 7;
			if(hp &gt;= he) goto His;
			*hp++ = c;
/* netlog("\tlit7 %.2ux\n", c); */
			continue;
		case Lit8:
			bits -= 2;
			if(bits&lt;7) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			c = 0x80 | ((sreg&gt;&gt;(bits-7))&amp;0x7f);
			bits -= 7;
			if(hp &gt;= he) goto His;
			*hp++ = c;
/* netlog("\tlit8 %.2ux\n", c); */
			continue;
		case Off6:
			bits -= 4;
			if(bits&lt;6) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			off = (sreg&gt;&gt;(bits-6))&amp;0x3f;
			bits -= 6;
			break;
		case Off8:
			bits -= 4;
			if(bits&lt;8) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			off = ((sreg&gt;&gt;(bits-8))&amp;0xff)+64;
			bits -= 8;
			break;
		case Off13:
			bits -= 3;
			while(bits&lt;13) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			off = ((sreg&gt;&gt;(bits-13))&amp;0x1fff)+320;
			bits -= 13;
/* netlog("\toff=%d bits = %d sreg = %ux t = %x\n", off, bits, sreg, t); */
			break;
		}
		for(ones=0;;ones++) {
			if(bits == 0) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			bits--;
			if(!(sreg&amp;(1&lt;&lt;bits)))
				break;
		}
		if(ones&gt;11) {
netlog("ppp: mppc: bad length %d\n", ones);
			freeb(b);
			return nil;
		}
		if(ones == 0) {
			len = 3;
		} else {
			ones++;
			while(bits&lt;ones) {
				if(n==0) goto Eof;
				NEXTBYTE;
			}
			len = (1&lt;&lt;ones) | ((sreg&gt;&gt;(bits-ones))&amp;((1&lt;&lt;ones)-1));
			bits -= ones;
		}

		hq = hp-off;
		if(hq &lt; hs) {
			hq += sizeof(s-&gt;his);
			if(hq-hs+len &gt; s-&gt;size) 
				goto His;
		}
		if(hp+len &gt; he) goto His;
		while(len) {
			*hp++ = *hq++;
			len--;
		}
	}
Done:
	freeb(b);

	/* build up return block */
	hq = hs+s-&gt;indx;
	len = hp-hq;
	b = allocb(len);
	memmove(b-&gt;wptr, hq, len);
	b-&gt;wptr += len;
netlog("ppp: mppc: len %d bits = %d n=%d\n", len, bits, n);
	
	s-&gt;indx += len;
	if(s-&gt;indx &gt; s-&gt;size)
		s-&gt;size = s-&gt;indx;
	
	return b;
Eof:
netlog("*****unexpected end of data\n");
	freeb(b);
	return nil;
His:
netlog("*****bad history\n");
	freeb(b);
	return nil;
}

static	void
uncresetack(void*, Block*)
{
}

static	void
uncfini(void *as)
{
	Uncstate *s;
	
	s = as;	
	free(s);
}

static void
setkey(uchar *key, uchar *startkey)
{
	uchar pad[40];
	SHAstate *s;
	uchar digest[SHA1dlen];

	s = sha1(startkey, 16, nil, nil);
	memset(pad, 0, 40);
	sha1(pad, 40, nil, s);
	sha1(key, 16, nil, s);
	memset(pad, 0xf2, 40);
	sha1(pad, 40, digest, s);
	memmove(key, digest, 16);
}


/* code to check if IP packet looks good */

typedef struct Iphdr Iphdr;
struct Iphdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* Header checksum */
	uchar	src[4];		/* Ip source */
	uchar	dst[4];		/* Ip destination */
};

enum
{
	QMAX		= 64*1024-1,
	IP_TCPPROTO	= 6,
	TCP_IPLEN	= 8,
	TCP_PHDRSIZE	= 12,
	TCP_HDRSIZE	= 20,
	TCP_PKT		= TCP_IPLEN+TCP_PHDRSIZE,
};

enum
{
	UDP_PHDRSIZE	= 12,
	UDP_HDRSIZE	= 20,
	UDP_IPHDR	= 8,
	IP_UDPPROTO	= 17,
	UDP_USEAD	= 12,
	UDP_RELSIZE	= 16,

	Udprxms		= 200,
	Udptickms	= 100,
	Udpmaxxmit	= 10,
};

typedef struct UDPhdr UDPhdr;
struct UDPhdr
{
	/* ip header */
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	Unused;	
	uchar	udpproto;	/* Protocol */
	uchar	udpplen[2];	/* Header plus data length */
	uchar	udpsrc[4];	/* Ip source */
	uchar	udpdst[4];	/* Ip destination */

	/* udp header */
	uchar	udpsport[2];	/* Source port */
	uchar	udpdport[2];	/* Destination port */
	uchar	udplen[2];	/* data length */
	uchar	udpcksum[2];	/* Checksum */
};

typedef struct TCPhdr TCPhdr;
struct TCPhdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	Unused;
	uchar	proto;
	uchar	tcplen[2];
	uchar	tcpsrc[4];
	uchar	tcpdst[4];
	uchar	tcpsport[2];
	uchar	tcpdport[2];
	uchar	tcpseq[4];
	uchar	tcpack[4];
	uchar	tcpflag[2];
	uchar	tcpwin[2];
	uchar	tcpcksum[2];
	uchar	tcpurg[2];
	/* Options segment */
	uchar	tcpopt[2];
	uchar	tcpmss[2];
};

static void
hischeck(Uncstate *s)
{
	uchar *p;
	Iphdr *iph;
	int len;

	p = s-&gt;his;

netlog("***** history check\n");
	while(p &lt; s-&gt;his+s-&gt;size) {
		if(p[0] != 0 || p[1] != 0x21) {
netlog("***** unknown protocol\n");
			return;
		}
		p += 2;
netlog("off = %ld ", p-s-&gt;his);
		iph = (Iphdr*)p;
		len = nhgets(iph-&gt;length);
		ipcheck(p, len);
		p += len;
	}
}


static int
ipcheck(uchar *p, int len)
{
	Iphdr *iph;
	TCPhdr *tcph;
	ushort length;
	UDPhdr *uh;
	Block *bp;
	ushort cksum;
	int good;

	bp = allocb(len);
	memmove(bp-&gt;wptr, p, len);
	bp-&gt;wptr += len;

	good = 1;

	iph = (Iphdr *)(bp-&gt;rptr);
/* netlog("ppp: mppc: ipcheck %I %I len %d proto %d\n", iph-&gt;src, iph-&gt;dst, BLEN(bp), iph-&gt;proto); */

	if(len != nhgets(iph-&gt;length)) {
		netlog("***** bad length! %d %d\n", len, nhgets(iph-&gt;length));
		good = 0;
	}

	cksum = ipcsum(&amp;iph-&gt;vihl);
	if(cksum) {
		netlog("***** IP proto cksum!!! %I %ux\n", iph-&gt;src, cksum);
		good = 0;
	}

	switch(iph-&gt;proto) {
	default:
		break;
	case IP_TCPPROTO:

		tcph = (TCPhdr*)(bp-&gt;rptr);

		length = nhgets(tcph-&gt;length);

		tcph-&gt;Unused = 0;
		hnputs(tcph-&gt;tcplen, length-TCP_PKT);
		cksum = ptclcsum(bp, TCP_IPLEN, length-TCP_IPLEN);
		if(cksum) {
			netlog("***** bad tcp proto cksum %ux!!!\n", cksum);
			good = 0;
		}
		break;
	case IP_UDPPROTO:
		uh = (UDPhdr*)(bp-&gt;rptr);

		/* Put back pseudo header for checksum */
		uh-&gt;Unused = 0;
		len = nhgets(uh-&gt;udplen);
		hnputs(uh-&gt;udpplen, len);

		if(nhgets(uh-&gt;udpcksum)) {
			cksum = ptclcsum(bp, UDP_IPHDR, len+UDP_PHDRSIZE);
			if(cksum) {
				netlog("***** udp: proto cksum!!! %I %ux\n", uh-&gt;udpsrc, cksum);
				good = 0;
			}
		}
		break;
	}
	freeb(bp);
	return good;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

