<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/ppp/ppp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/ppp/ppp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * ppp - point-to-point protocol, rfc1331
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;bio.h&gt;
#include &lt;ip.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ndb.h&gt;
#include "ppp.h"

#define PATH 128

static	int	baud;
static	int	nocompress;
static 	int	pppframing = 1;
static	int	noipcompress;
static	int	server;
static	int noauth;
static	int	nip;		/* number of ip interfaces */
static	int	dying;		/* flag to signal to all threads its time to go */
static	int	primary;	/* this is the primary IP interface */
static	char	*chatfile;

int	debug;
char*	LOG = "ppp";
char*	keyspec = "";

enum
{
	Rmagic=	0x12345
};

/*
 * Calculate FCS - rfc 1331
 */
ushort fcstab[256] =
{
      0x0000, 0x1189, 0x2312, 0x329b, 0x4624, 0x57ad, 0x6536, 0x74bf,
      0x8c48, 0x9dc1, 0xaf5a, 0xbed3, 0xca6c, 0xdbe5, 0xe97e, 0xf8f7,
      0x1081, 0x0108, 0x3393, 0x221a, 0x56a5, 0x472c, 0x75b7, 0x643e,
      0x9cc9, 0x8d40, 0xbfdb, 0xae52, 0xdaed, 0xcb64, 0xf9ff, 0xe876,
      0x2102, 0x308b, 0x0210, 0x1399, 0x6726, 0x76af, 0x4434, 0x55bd,
      0xad4a, 0xbcc3, 0x8e58, 0x9fd1, 0xeb6e, 0xfae7, 0xc87c, 0xd9f5,
      0x3183, 0x200a, 0x1291, 0x0318, 0x77a7, 0x662e, 0x54b5, 0x453c,
      0xbdcb, 0xac42, 0x9ed9, 0x8f50, 0xfbef, 0xea66, 0xd8fd, 0xc974,
      0x4204, 0x538d, 0x6116, 0x709f, 0x0420, 0x15a9, 0x2732, 0x36bb,
      0xce4c, 0xdfc5, 0xed5e, 0xfcd7, 0x8868, 0x99e1, 0xab7a, 0xbaf3,
      0x5285, 0x430c, 0x7197, 0x601e, 0x14a1, 0x0528, 0x37b3, 0x263a,
      0xdecd, 0xcf44, 0xfddf, 0xec56, 0x98e9, 0x8960, 0xbbfb, 0xaa72,
      0x6306, 0x728f, 0x4014, 0x519d, 0x2522, 0x34ab, 0x0630, 0x17b9,
      0xef4e, 0xfec7, 0xcc5c, 0xddd5, 0xa96a, 0xb8e3, 0x8a78, 0x9bf1,
      0x7387, 0x620e, 0x5095, 0x411c, 0x35a3, 0x242a, 0x16b1, 0x0738,
      0xffcf, 0xee46, 0xdcdd, 0xcd54, 0xb9eb, 0xa862, 0x9af9, 0x8b70,
      0x8408, 0x9581, 0xa71a, 0xb693, 0xc22c, 0xd3a5, 0xe13e, 0xf0b7,
      0x0840, 0x19c9, 0x2b52, 0x3adb, 0x4e64, 0x5fed, 0x6d76, 0x7cff,
      0x9489, 0x8500, 0xb79b, 0xa612, 0xd2ad, 0xc324, 0xf1bf, 0xe036,
      0x18c1, 0x0948, 0x3bd3, 0x2a5a, 0x5ee5, 0x4f6c, 0x7df7, 0x6c7e,
      0xa50a, 0xb483, 0x8618, 0x9791, 0xe32e, 0xf2a7, 0xc03c, 0xd1b5,
      0x2942, 0x38cb, 0x0a50, 0x1bd9, 0x6f66, 0x7eef, 0x4c74, 0x5dfd,
      0xb58b, 0xa402, 0x9699, 0x8710, 0xf3af, 0xe226, 0xd0bd, 0xc134,
      0x39c3, 0x284a, 0x1ad1, 0x0b58, 0x7fe7, 0x6e6e, 0x5cf5, 0x4d7c,
      0xc60c, 0xd785, 0xe51e, 0xf497, 0x8028, 0x91a1, 0xa33a, 0xb2b3,
      0x4a44, 0x5bcd, 0x6956, 0x78df, 0x0c60, 0x1de9, 0x2f72, 0x3efb,
      0xd68d, 0xc704, 0xf59f, 0xe416, 0x90a9, 0x8120, 0xb3bb, 0xa232,
      0x5ac5, 0x4b4c, 0x79d7, 0x685e, 0x1ce1, 0x0d68, 0x3ff3, 0x2e7a,
      0xe70e, 0xf687, 0xc41c, 0xd595, 0xa12a, 0xb0a3, 0x8238, 0x93b1,
      0x6b46, 0x7acf, 0x4854, 0x59dd, 0x2d62, 0x3ceb, 0x0e70, 0x1ff9,
      0xf78f, 0xe606, 0xd49d, 0xc514, 0xb1ab, 0xa022, 0x92b9, 0x8330,
      0x7bc7, 0x6a4e, 0x58d5, 0x495c, 0x3de3, 0x2c6a, 0x1ef1, 0x0f78
};

static char *snames[] =
{
	"Sclosed",
	"Sclosing",
	"Sreqsent",
	"Sackrcvd",
	"Sacksent",
	"Sopened",
};

static	void		authtimer(PPP*);
static	void		chapinit(PPP*);
static	void		config(PPP*, Pstate*, int);
static	uchar*		escapeuchar(PPP*, ulong, uchar*, ushort*);
static	void		getchap(PPP*, Block*);
static	Block*		getframe(PPP*, int*);
static	void		getlqm(PPP*, Block*);
static	int		getopts(PPP*, Pstate*, Block*);
static	void		getpap(PPP*, Block*);
static	void		init(PPP*);
static	void		invalidate(Ipaddr);
static	void		ipinproc(PPP*);
static	char*		ipopen(PPP*);
static	void		mediainproc(PPP*);
static	void		newstate(PPP*, Pstate*, int);
static	int		nipifcs(char*);
static	void		papinit(PPP*);
static	void		pinit(PPP*, Pstate*);
static	void		ppptimer(PPP*);
static	void		printopts(Pstate*, Block*, int);
static	void		ptimer(PPP*, Pstate*);
static	int		putframe(PPP*, int, Block*);
static	void		putlqm(PPP*);
static	void		putndb(PPP*, char*);
static	void		putpaprequest(PPP*);
static	void		rcv(PPP*, Pstate*, Block*);
static	void		rejopts(PPP*, Pstate*, Block*, int);
static	void		sendechoreq(PPP*, Pstate*);
static	void		sendtermreq(PPP*, Pstate*);
static	void		setphase(PPP*, int);
static	void		terminate(PPP*, int);
static	int		validv4(Ipaddr);
static  void		dmppkt(char *s, uchar *a, int na);
static	void		getauth(PPP*);

void
pppopen(PPP *ppp, int mediain, int mediaout, char *net,
	Ipaddr ipaddr, Ipaddr remip,
	int mtu, int framing)
{
	ppp-&gt;ipfd = -1;
	ppp-&gt;ipcfd = -1;
	invalidate(ppp-&gt;remote);
	invalidate(ppp-&gt;local);
	invalidate(ppp-&gt;curremote);
	invalidate(ppp-&gt;curlocal);
	invalidate(ppp-&gt;dns[0]);
	invalidate(ppp-&gt;dns[1]);
	invalidate(ppp-&gt;wins[0]);
	invalidate(ppp-&gt;wins[1]);

	ppp-&gt;mediain = mediain;
	ppp-&gt;mediaout = mediaout;
	if(validv4(remip)){
		ipmove(ppp-&gt;remote, remip);
		ppp-&gt;remotefrozen = 1;
	}
	if(validv4(ipaddr)){
		ipmove(ppp-&gt;local, ipaddr);
		ppp-&gt;localfrozen = 1;
	}
	ppp-&gt;mtu = Defmtu;
	ppp-&gt;mru = mtu;
	ppp-&gt;framing = framing;
	ppp-&gt;net = net;

	init(ppp);
	switch(rfork(RFPROC|RFMEM|RFNOWAIT)){
	case -1:
		sysfatal("forking mediainproc");
	case 0:
		mediainproc(ppp);
		terminate(ppp, 1);
		_exits(0);
	}
}

static void
init(PPP* ppp)
{
	if(ppp-&gt;inbuf == nil){
		ppp-&gt;inbuf = allocb(4096);
		if(ppp-&gt;inbuf == nil)
			abort();

		ppp-&gt;outbuf = allocb(4096);
		if(ppp-&gt;outbuf == nil)
			abort();

		ppp-&gt;lcp = mallocz(sizeof(*ppp-&gt;lcp), 1);
		if(ppp-&gt;lcp == nil)
			abort();
		ppp-&gt;lcp-&gt;proto = Plcp;
		ppp-&gt;lcp-&gt;state = Sclosed;

		ppp-&gt;ccp = mallocz(sizeof(*ppp-&gt;ccp), 1);
		if(ppp-&gt;ccp == nil)
			abort();
		ppp-&gt;ccp-&gt;proto = Pccp;
		ppp-&gt;ccp-&gt;state = Sclosed;

		ppp-&gt;ipcp = mallocz(sizeof(*ppp-&gt;ipcp), 1);
		if(ppp-&gt;ipcp == nil)
			abort();
		ppp-&gt;ipcp-&gt;proto = Pipcp;
		ppp-&gt;ipcp-&gt;state = Sclosed;

		ppp-&gt;chap = mallocz(sizeof(*ppp-&gt;chap), 1);
		if(ppp-&gt;chap == nil)
			abort();
		ppp-&gt;chap-&gt;proto = APmschap;
		ppp-&gt;chap-&gt;state = Cunauth;
		auth_freechal(ppp-&gt;chap-&gt;cs);
		ppp-&gt;chap-&gt;cs = nil;

		switch(rfork(RFPROC|RFMEM|RFNOWAIT)){
		case -1:
			sysfatal("forking ppptimer");
		case 0:
			ppptimer(ppp);
			_exits(0);
		}
	}

	ppp-&gt;ctcp = compress_init(ppp-&gt;ctcp);
	pinit(ppp, ppp-&gt;lcp);
	setphase(ppp, Plink);
}

static void
setphase(PPP *ppp, int phase)
{
	int oldphase;

	oldphase = ppp-&gt;phase;

	ppp-&gt;phase = phase;
	switch(phase){
	default:
		sysfatal("ppp: unknown phase %d", phase);
	case Pdead:
		/* restart or exit? */
		pinit(ppp, ppp-&gt;lcp);
		setphase(ppp, Plink);
		break;
	case Plink:
		/* link down */
		switch(oldphase) {
		case Pauth:
			auth_freechal(ppp-&gt;chap-&gt;cs);
			ppp-&gt;chap-&gt;cs = nil;
			ppp-&gt;chap-&gt;state = Cunauth;
			break;
		case Pnet:
			auth_freechal(ppp-&gt;chap-&gt;cs);
			ppp-&gt;chap-&gt;cs = nil;
			ppp-&gt;chap-&gt;state = Cunauth;
			newstate(ppp, ppp-&gt;ccp, Sclosed);
			newstate(ppp, ppp-&gt;ipcp, Sclosed);
		}
		break;
	case Pauth:
		if(server)
			chapinit(ppp);
		else if(ppp-&gt;chap-&gt;proto == APpasswd)
			papinit(ppp);
		else
			setphase(ppp, Pnet);
		break;
	case Pnet:
		pinit(ppp, ppp-&gt;ccp);
		pinit(ppp, ppp-&gt;ipcp);
		break;
	case Pterm:
		/* what? */
		break;
	}
}

static void
pinit(PPP *ppp, Pstate *p)
{
	p-&gt;timeout = 0;

	switch(p-&gt;proto){
	case Plcp:
		ppp-&gt;magic = truerand();
		ppp-&gt;xctlmap = 0xffffffff;
		ppp-&gt;period = 0;
		p-&gt;optmask = 0xffffffff;
		if(!server)
			p-&gt;optmask &amp;=  ~(Fauth|Fmtu);
		ppp-&gt;rctlmap = 0;
		ppp-&gt;ipcp-&gt;state = Sclosed;
		ppp-&gt;ipcp-&gt;optmask = 0xffffffff;

		p-&gt;echotimeout = 0;

		/* quality goo */
		ppp-&gt;timeout = 0;
		memset(&amp;ppp-&gt;in, 0, sizeof(ppp-&gt;in));
		memset(&amp;ppp-&gt;out, 0, sizeof(ppp-&gt;out));
		memset(&amp;ppp-&gt;pin, 0, sizeof(ppp-&gt;pin));
		memset(&amp;ppp-&gt;pout, 0, sizeof(ppp-&gt;pout));
		memset(&amp;ppp-&gt;sin, 0, sizeof(ppp-&gt;sin));
		break;
	case Pccp:
		if(nocompress)
			p-&gt;optmask = 0;
		else
			p-&gt;optmask = Fcmppc;

		if(ppp-&gt;ctype != nil)
			(*ppp-&gt;ctype-&gt;fini)(ppp-&gt;cstate);
		ppp-&gt;ctype = nil;
		ppp-&gt;ctries = 0;
		ppp-&gt;cstate = nil;

		if(ppp-&gt;unctype)
			(*ppp-&gt;unctype-&gt;fini)(ppp-&gt;uncstate);
		ppp-&gt;unctype = nil;
		ppp-&gt;uncstate = nil;
		break;
	case Pipcp:
		p-&gt;optmask = 0xffffffff;
		ppp-&gt;ctcp = compress_init(ppp-&gt;ctcp);
		break;
	}
	p-&gt;confid = p-&gt;rcvdconfid = -1;
	config(ppp, p, 1);
	newstate(ppp, p, Sreqsent);
}

/*
 *  change protocol to a new state.
 */
static void
newstate(PPP *ppp, Pstate *p, int state)
{
	char *err;

	netlog("ppp: %ux %s-&gt;%s ctlmap %lux/%lux flags %lux mtu %ld mru %ld\n",
		p-&gt;proto, snames[p-&gt;state], snames[state], ppp-&gt;rctlmap,
		ppp-&gt;xctlmap, p-&gt;flags,
		ppp-&gt;mtu, ppp-&gt;mru);
	syslog(0, "ppp", "%ux %s-&gt;%s ctlmap %lux/%lux flags %lux mtu %ld mru %ld",
		p-&gt;proto, snames[p-&gt;state], snames[state], ppp-&gt;rctlmap,
		ppp-&gt;xctlmap, p-&gt;flags,
		ppp-&gt;mtu, ppp-&gt;mru);

	if(p-&gt;proto == Plcp) {
		if(state == Sopened)
			setphase(ppp, noauth? Pnet : Pauth);
		else if(state == Sclosed)
			setphase(ppp, Pdead);
		else if(p-&gt;state == Sopened)
			setphase(ppp, Plink);
	}

	if(p-&gt;proto == Pccp &amp;&amp; state == Sopened) {
		if(ppp-&gt;unctype)
			(*ppp-&gt;unctype-&gt;fini)(ppp-&gt;uncstate);
		ppp-&gt;unctype = nil;
		ppp-&gt;uncstate = nil;
		if(p-&gt;optmask &amp; Fcmppc) {
			ppp-&gt;unctype = &amp;uncmppc;
			ppp-&gt;uncstate = (*uncmppc.init)(ppp);
		}
		if(p-&gt;optmask &amp; Fcthwack){
			ppp-&gt;unctype = &amp;uncthwack;
			ppp-&gt;uncstate = (*uncthwack.init)(ppp);
		}
	}

	if(p-&gt;proto == Pipcp &amp;&amp; state == Sopened) {
		if(server &amp;&amp; !noauth &amp;&amp; ppp-&gt;chap-&gt;state != Cauthok)
			abort();

		err = ipopen(ppp);
		if(err != nil)
			sysfatal("%s", err);
	}

	p-&gt;state = state;
}

/* returns (protocol, information) */
static Block*
getframe(PPP *ppp, int *protop)
{
	uchar *p, *from, *to;
	int n, len, proto;
	ulong c;
	ushort fcs;
	Block *buf, *b;

	*protop = 0;
	if(ppp-&gt;framing == 0) {
		/* assume data is already framed */
		b = allocb(2000);
		len = b-&gt;lim - b-&gt;wptr;
		n = read(ppp-&gt;mediain, b-&gt;wptr, len);
 		dmppkt("RX", b-&gt;wptr, n);
		if(n &lt;= 0 || n == len){
			freeb(b);

			return nil;
		}
		b-&gt;wptr += n;

		/* should probably copy to another block if small */

		if(pppframing &amp;&amp; b-&gt;rptr[0] == PPP_addr &amp;&amp; b-&gt;rptr[1] == PPP_ctl)
			b-&gt;rptr += 2;
		proto = *b-&gt;rptr++;
		if((proto &amp; 0x1) == 0)
			proto = (proto&lt;&lt;8) | *b-&gt;rptr++;

		if(b-&gt;rptr &gt;= b-&gt;wptr){
			freeb(b);
			return nil;
		}

		ppp-&gt;in.uchars += n;
		ppp-&gt;in.packets++;
		*protop = proto;
		netlog("getframe 0x%x\n", proto);
		return b;
	}

	buf = ppp-&gt;inbuf;
	for(;;){
		/* read till we hit a frame uchar or run out of room */
		for(p = buf-&gt;rptr; buf-&gt;wptr &lt; buf-&gt;lim;){
			for(; p &lt; buf-&gt;wptr; p++)
				if(*p == HDLC_frame)
					break;
			if(p != buf-&gt;wptr)
				break;

			len = buf-&gt;lim - buf-&gt;wptr;
			n = read(ppp-&gt;mediain, buf-&gt;wptr, len);
			if(n &lt;= 0){
				syslog(0, LOG, "medium read returns %d: %r", n);
				buf-&gt;wptr = buf-&gt;rptr;
				return nil;
			}
 			dmppkt("RX", buf-&gt;wptr, n);
			buf-&gt;wptr += n;
		}

		/* copy into block, undoing escapes, and caculating fcs */
		fcs = PPP_initfcs;
		b = allocb(p - buf-&gt;rptr);
		to = b-&gt;wptr;
		for(from = buf-&gt;rptr; from != p;){
			c = *from++;
			if(c == HDLC_esc){
				if(from == p)
					break;
				c = *from++ ^ 0x20;
			} else if((c &lt; 0x20) &amp;&amp; (ppp-&gt;rctlmap &amp; (1 &lt;&lt; c)))
				continue;
			*to++ = c;
			fcs = (fcs &gt;&gt; 8) ^ fcstab[(fcs ^ c) &amp; 0xff];
		}

		/* copy down what's left in buffer */
		p++;
		memmove(buf-&gt;rptr, p, buf-&gt;wptr - p);
		n = p - buf-&gt;rptr;
		buf-&gt;wptr -= n;
		b-&gt;wptr = to - 2;

		/* return to caller if checksum matches */
		if(fcs == PPP_goodfcs){
			if(b-&gt;rptr[0] == PPP_addr &amp;&amp; b-&gt;rptr[1] == PPP_ctl)
				b-&gt;rptr += 2;
			proto = *b-&gt;rptr++;
			if((proto &amp; 0x1) == 0)
				proto = (proto&lt;&lt;8) | *b-&gt;rptr++;
			if(b-&gt;rptr &lt; b-&gt;wptr){
				ppp-&gt;in.uchars += n;
				ppp-&gt;in.packets++;
				*protop = proto;
				netlog("getframe 0x%x\n", proto);
				return b;
			}
		} else if(BLEN(b) &gt; 0){
			if(ppp-&gt;ctcp)
				compress_error(ppp-&gt;ctcp);
			ppp-&gt;in.discards++;
			netlog("ppp: discard len %ld/%ld cksum %ux (%ux %ux %ux %ux)\n",
				BLEN(b), BLEN(buf), fcs, b-&gt;rptr[0],
				b-&gt;rptr[1], b-&gt;rptr[2], b-&gt;rptr[3]);
		}

		freeb(b);
	}
}

/* send a PPP frame */
static int
putframe(PPP *ppp, int proto, Block *b)
{
	Block *buf;
	uchar *to, *from;
	ushort fcs;
	ulong ctlmap;
	uchar c;
	Block *bp;

	ppp-&gt;out.packets++;

	if(proto == Plcp)
		ctlmap = 0xffffffff;
	else
		ctlmap = ppp-&gt;xctlmap;

	/* make sure we have head room */
	if(b-&gt;rptr - b-&gt;base &lt; 4){
		b = padb(b, 4);
		b-&gt;rptr += 4;
	}

	netlog("ppp: putframe 0x%ux %ld\n", proto, b-&gt;wptr-b-&gt;rptr);

	/* add in the protocol and address, we'd better have left room */
	from = b-&gt;rptr;
	*--from = proto;
	if(!(ppp-&gt;lcp-&gt;flags&amp;Fpc) || proto &gt; 0x100 || proto == Plcp)
		*--from = proto&gt;&gt;8;
	if(pppframing &amp;&amp; (!(ppp-&gt;lcp-&gt;flags&amp;Fac) || proto == Plcp)){
		*--from = PPP_ctl;
		*--from = PPP_addr;
	}

	qlock(&amp;ppp-&gt;outlock);
	buf = ppp-&gt;outbuf;

	if(ppp-&gt;framing == 0) {
		to = buf-&gt;rptr;
		for(bp = b; bp; bp = bp-&gt;next){
			if(bp != b)
				from = bp-&gt;rptr;
			memmove(to, from, bp-&gt;wptr-from);
			to += bp-&gt;wptr-from;
		}
	} else {
		/* escape and checksum the body */
		fcs = PPP_initfcs;
		to = buf-&gt;rptr;
	
		/* add frame marker */
		*to++ = HDLC_frame;

		for(bp = b; bp; bp = bp-&gt;next){
			if(bp != b)
				from = bp-&gt;rptr;
			for(; from &lt; bp-&gt;wptr; from++){
				c = *from;
				if(c == HDLC_frame || c == HDLC_esc
				   || (c &lt; 0x20 &amp;&amp; ((1&lt;&lt;c) &amp; ctlmap))){
					*to++ = HDLC_esc;
					*to++ = c ^ 0x20;
				} else 
					*to++ = c;
				fcs = (fcs &gt;&gt; 8) ^ fcstab[(fcs ^ c) &amp; 0xff];
			}
		}

		/* add on and escape the checksum */
		fcs = ~fcs;
		c = fcs;
		if(c == HDLC_frame || c == HDLC_esc
		   || (c &lt; 0x20 &amp;&amp; ((1&lt;&lt;c) &amp; ctlmap))){
			*to++ = HDLC_esc;
			*to++ = c ^ 0x20;
		} else 
			*to++ = c;
		c = fcs&gt;&gt;8;
		if(c == HDLC_frame || c == HDLC_esc
		   || (c &lt; 0x20 &amp;&amp; ((1&lt;&lt;c) &amp; ctlmap))){
			*to++ = HDLC_esc;
			*to++ = c ^ 0x20;
		} else 
			*to++ = c;
	
		/* add frame marker */
		*to++ = HDLC_frame;
	}

	/* send */
	buf-&gt;wptr = to;
 	dmppkt("TX", buf-&gt;rptr, BLEN(buf));
	if(write(ppp-&gt;mediaout, buf-&gt;rptr, BLEN(buf)) &lt; 0){
		qunlock(&amp;ppp-&gt;outlock);
		return -1;
	}
	ppp-&gt;out.uchars += BLEN(buf);

	qunlock(&amp;ppp-&gt;outlock);
	return 0;
}

Block*
alloclcp(int code, int id, int len, Lcpmsg **mp)
{
	Block *b;
	Lcpmsg *m;

	/*
	 *  leave room for header
	 */
	b = allocb(len);

	m = (Lcpmsg*)b-&gt;wptr;
	m-&gt;code = code;
	m-&gt;id = id;
	b-&gt;wptr += 4;

	*mp = m;
	return b;
}


static void
putlo(Block *b, int type, ulong val)
{
	*b-&gt;wptr++ = type;
	*b-&gt;wptr++ = 6;
	hnputl(b-&gt;wptr, val);
	b-&gt;wptr += 4;
}

static void
putv4o(Block *b, int type, Ipaddr val)
{
	*b-&gt;wptr++ = type;
	*b-&gt;wptr++ = 6;
	v6tov4(b-&gt;wptr, val);
	b-&gt;wptr += 4;
}

static void
putso(Block *b, int type, ulong val)
{
	*b-&gt;wptr++ = type;
	*b-&gt;wptr++ = 4;
	hnputs(b-&gt;wptr, val);
	b-&gt;wptr += 2;
}

static void
puto(Block *b, int type)
{
	*b-&gt;wptr++ = type;
	*b-&gt;wptr++ = 2;
}

/*
 *  send configuration request
 */
static void
config(PPP *ppp, Pstate *p, int newid)
{
	Block *b;
	Lcpmsg *m;
	int id;

	if(newid){
		id = p-&gt;id++;
		p-&gt;confid = id;
		p-&gt;timeout = Timeout;
	} else
		id = p-&gt;confid;
	b = alloclcp(Lconfreq, id, 256, &amp;m);
	USED(m);

	switch(p-&gt;proto){
	case Plcp:
		if(p-&gt;optmask &amp; Fctlmap)
			putlo(b, Octlmap, 0);	/* we don't want anything escaped */
		if(p-&gt;optmask &amp; Fmagic)
			putlo(b, Omagic, ppp-&gt;magic);
		if(p-&gt;optmask &amp; Fmtu)
			putso(b, Omtu, ppp-&gt;mru);
		if(p-&gt;optmask &amp; Fauth) {
			*b-&gt;wptr++ = Oauth;
			*b-&gt;wptr++ = 5;
			hnputs(b-&gt;wptr, Pchap);
			b-&gt;wptr += 2;
			*b-&gt;wptr++ = ppp-&gt;chap-&gt;proto;
		}
		if(p-&gt;optmask &amp; Fpc)
			puto(b, Opc);
		if(p-&gt;optmask &amp; Fac)
			puto(b, Oac);
		break;
	case Pccp:
		if(p-&gt;optmask &amp; Fcthwack)
			puto(b, Octhwack);
		else if(p-&gt;optmask &amp; Fcmppc) {
			*b-&gt;wptr++ = Ocmppc;
			*b-&gt;wptr++ = 6;
			*b-&gt;wptr++ = 0;
			*b-&gt;wptr++ = 0;
			*b-&gt;wptr++ = 0;
			*b-&gt;wptr++ = 0x41;
		}
		break;
	case Pipcp:
		if(p-&gt;optmask &amp; Fipaddr)
{syslog(0, "ppp", "requesting %I", ppp-&gt;local);
			putv4o(b, Oipaddr, ppp-&gt;local);
}
		if(primary &amp;&amp; (p-&gt;optmask &amp; Fipdns))
			putv4o(b, Oipdns, ppp-&gt;dns[0]);
		if(primary &amp;&amp; (p-&gt;optmask &amp; Fipdns2))
			putv4o(b, Oipdns2, ppp-&gt;dns[1]);
		if(primary &amp;&amp; (p-&gt;optmask &amp; Fipwins))
			putv4o(b, Oipwins, ppp-&gt;wins[0]);
		if(primary &amp;&amp; (p-&gt;optmask &amp; Fipwins2))
			putv4o(b, Oipwins2, ppp-&gt;wins[1]);
		/*
		 * don't ask for header compression while data compression is still pending.
		 * perhaps we should restart ipcp negotiation if compression negotiation fails.
		 */
		if(!noipcompress &amp;&amp; !ppp-&gt;ccp-&gt;optmask &amp;&amp; (p-&gt;optmask &amp; Fipcompress)) {
			*b-&gt;wptr++ = Oipcompress;
			*b-&gt;wptr++ = 6;
			hnputs(b-&gt;wptr, Pvjctcp);
			b-&gt;wptr += 2;
			*b-&gt;wptr++ = MAX_STATES-1;
			*b-&gt;wptr++ = 1;
		}
		break;
	}
	hnputs(m-&gt;len, BLEN(b));
	printopts(p, b, 1);
	putframe(ppp, p-&gt;proto, b);
	freeb(b);
}

static void
getipinfo(PPP *ppp)
{
	char *av[3];
	int ndns, nwins;
	char ip[64];
	Ndbtuple *t, *nt;

	if(!validv4(ppp-&gt;local))
		return;

	av[0] = "dns";
	av[1] = "wins";
	sprint(ip, "%I", ppp-&gt;local);
	t = csipinfo(ppp-&gt;net, "ip", ip, av, 2);
	ndns = nwins = 0;
	for(nt = t; nt != nil; nt = nt-&gt;entry){
		if(strcmp(nt-&gt;attr, "dns") == 0){
			if(ndns &lt; 2)
				parseip(ppp-&gt;dns[ndns++], nt-&gt;val);
		} else if(strcmp(nt-&gt;attr, "wins") == 0){
			if(nwins &lt; 2)
				parseip(ppp-&gt;wins[nwins++], nt-&gt;val);
		}
	}
	if(t != nil)
		ndbfree(t);
}

/*
 *  parse configuration request, sends an ack or reject packet
 *
 *	returns:	-1 if request was syntacticly incorrect
 *			 0 if packet was accepted
 *			 1 if packet was rejected
 */
static int
getopts(PPP *ppp, Pstate *p, Block *b)
{
	Lcpmsg *m, *repm;	
	Lcpopt *o;
	uchar *cp, *ap;
	ulong rejecting, nacking, flags, proto, chapproto;
	ulong mtu, ctlmap, period;
	ulong x;
	Block *repb;
	Comptype *ctype;
	Ipaddr ipaddr;

	rejecting = 0;
	nacking = 0;
	flags = 0;

	/* defaults */
	invalidate(ipaddr);
	mtu = ppp-&gt;mtu;
	ctlmap = 0xffffffff;
	period = 0;
	ctype = nil;
	chapproto = 0;

	m = (Lcpmsg*)b-&gt;rptr;
	repb = alloclcp(Lconfack, m-&gt;id, BLEN(b), &amp;repm);

	/* copy options into ack packet */
	memmove(repm-&gt;data, m-&gt;data, b-&gt;wptr - m-&gt;data);
	repb-&gt;wptr += b-&gt;wptr - m-&gt;data;

	/* look for options we don't recognize or like */
	for(cp = m-&gt;data; cp &lt; b-&gt;wptr; cp += o-&gt;len){
		o = (Lcpopt*)cp;
		if(cp + o-&gt;len &gt; b-&gt;wptr || o-&gt;len==0){
			freeb(repb);
			netlog("ppp: bad option length %ux\n", o-&gt;type);
			return -1;
		}

		switch(p-&gt;proto){
		case Plcp:
			switch(o-&gt;type){
			case Oac:
				flags |= Fac;
				continue;
			case Opc:
				flags |= Fpc;
				continue;
			case Omtu:
				mtu = nhgets(o-&gt;data);
				continue;
			case Omagic:
				if(ppp-&gt;magic == nhgetl(o-&gt;data))
					netlog("ppp: possible loop\n");
				continue;
			case Octlmap:
				ctlmap = nhgetl(o-&gt;data);
				continue;
			case Oquality:
				proto = nhgets(o-&gt;data);
				if(proto != Plqm)
					break;
				x = nhgetl(o-&gt;data+2)*10;
				period = (x+Period-1)/Period;
				continue;
			case Oauth:
				proto = nhgets(o-&gt;data);
				if(proto == Ppasswd &amp;&amp; !server){
					chapproto = APpasswd;
					continue;
				}
				if(proto != Pchap)
					break;
				if(o-&gt;data[2] != APmd5 &amp;&amp; o-&gt;data[2] != APmschap)
					break;
				chapproto = o-&gt;data[2];
				continue;
			}
			break;
		case Pccp:
			if(nocompress)
				break;
			switch(o-&gt;type){
			case Octhwack:
				break;
			/*
				if(o-&gt;len == 2){
					ctype = &amp;cthwack;
					continue;
				}
				if(!nacking){
					nacking = 1;
					repb-&gt;wptr = repm-&gt;data;
					repm-&gt;code = Lconfnak;
				}
				puto(repb, Octhwack);
				continue;
			*/
			case Ocmppc:
				x = nhgetl(o-&gt;data);

				// hack for Mac
				// if(x == 0)
				//	continue;

				/* stop ppp loops */
				if((x&amp;0x41) == 0 || ppp-&gt;ctries++ &gt; 5) {
					/*
					 * turn off requests as well - I don't think this
					 * is needed in the standard
					 */
					p-&gt;optmask &amp;= ~Fcmppc;
					break;
				}
				if(rejecting)
					continue;
				if(x &amp; 1) {
					ctype = &amp;cmppc;
					ppp-&gt;sendencrypted = (o-&gt;data[3]&amp;0x40) == 0x40;
					continue;
				}
				if(!nacking){
					nacking = 1;
					repb-&gt;wptr = repm-&gt;data;
					repm-&gt;code = Lconfnak;
				}
				*repb-&gt;wptr++ = Ocmppc;
				*repb-&gt;wptr++ = 6;
				*repb-&gt;wptr++ = 0;
				*repb-&gt;wptr++ = 0;
				*repb-&gt;wptr++ = 0;
				*repb-&gt;wptr++ = 0x41;
				continue;
			}
			break;
		case Pipcp:
			switch(o-&gt;type){
			case Oipaddr:	
				v4tov6(ipaddr, o-&gt;data);
				if(!validv4(ppp-&gt;remote))
					continue;
				if(!validv4(ipaddr) &amp;&amp; !rejecting){
					/* other side requesting an address */
					if(!nacking){
						nacking = 1;
						repb-&gt;wptr = repm-&gt;data;
						repm-&gt;code = Lconfnak;
					}
					putv4o(repb, Oipaddr, ppp-&gt;remote);
				}
				continue;
			case Oipdns:
				ap = ppp-&gt;dns[0];
				goto ipinfo;
			case Oipdns2:	
				ap = ppp-&gt;dns[1];
				goto ipinfo;
			case Oipwins:	
				ap = ppp-&gt;wins[0];
				goto ipinfo;
			case Oipwins2:
				ap = ppp-&gt;wins[1];
				goto ipinfo;
			ipinfo:
				if(!validv4(ap))
					getipinfo(ppp);
				if(!validv4(ap))
					break;
				v4tov6(ipaddr, o-&gt;data);
				if(!validv4(ipaddr) &amp;&amp; !rejecting){
					/* other side requesting an address */
					if(!nacking){
						nacking = 1;
						repb-&gt;wptr = repm-&gt;data;
						repm-&gt;code = Lconfnak;
					}
					putv4o(repb, o-&gt;type, ap);
				}
				continue;
			case Oipcompress:
				/*
				 * don't compress tcp header if we've negotiated data compression.
				 * tcp header compression has very poor performance if there is an error.
				 */
				proto = nhgets(o-&gt;data);
				if(noipcompress || proto != Pvjctcp || ppp-&gt;ctype != nil)
					break;
				if(compress_negotiate(ppp-&gt;ctcp, o-&gt;data+2) &lt; 0)
					break;
				flags |= Fipcompress;
				continue;
			}
			break;
		}

		/* come here if option is not recognized */
		if(!rejecting){
			rejecting = 1;
			repb-&gt;wptr = repm-&gt;data;
			repm-&gt;code = Lconfrej;
		}
		netlog("ppp: bad %ux option %d\n", p-&gt;proto, o-&gt;type);
		memmove(repb-&gt;wptr, o, o-&gt;len);
		repb-&gt;wptr += o-&gt;len;
	}

	/* permanent changes only after we know that we liked the packet */
	if(!rejecting &amp;&amp; !nacking){
		switch(p-&gt;proto){
		case Plcp:
			ppp-&gt;period = period;
			ppp-&gt;xctlmap = ctlmap;
			if(mtu &gt; Maxmtu)
				mtu = Maxmtu;
			if(mtu &lt; Minmtu)
				mtu = Minmtu;
			ppp-&gt;mtu = mtu;
			if(chapproto)
				ppp-&gt;chap-&gt;proto = chapproto;
			
			break;
		case Pccp:
			if(ppp-&gt;ctype != nil){
				(*ppp-&gt;ctype-&gt;fini)(ppp-&gt;cstate);
				ppp-&gt;cstate = nil;
			}
			ppp-&gt;ctype = ctype;
			if(ctype)
				ppp-&gt;cstate = (*ctype-&gt;init)(ppp);
			break;
		case Pipcp:
			if(validv4(ipaddr) &amp;&amp; ppp-&gt;remotefrozen == 0)
 				ipmove(ppp-&gt;remote, ipaddr);
			break;
		}
		p-&gt;flags = flags;
	}

	hnputs(repm-&gt;len, BLEN(repb));
	printopts(p, repb, 1);
	putframe(ppp, p-&gt;proto, repb);
	freeb(repb);

	return rejecting || nacking;
}
static void
dmppkt(char *s, uchar *a, int na)
{
	int i;

	if (debug &lt; 3)
		return;

	fprint(2, "%s", s);
	for(i = 0; i &lt; na; i++)
		fprint(2, " %.2ux", a[i]);
	fprint(2, "\n");
}

static void
dropoption(Pstate *p, Lcpopt *o)
{
	unsigned n = o-&gt;type;

	switch(n){
	case Oipaddr:
		break;
	case Oipdns:
		p-&gt;optmask &amp;= ~Fipdns;
		break;
	case Oipwins:
		p-&gt;optmask &amp;= ~Fipwins;
		break;
	case Oipdns2:
		p-&gt;optmask &amp;= ~Fipdns2;
		break;
	case Oipwins2:
		p-&gt;optmask &amp;= ~Fipwins2;
		break;
	default:
		if(o-&gt;type &lt; 8*sizeof(p-&gt;optmask))
			p-&gt;optmask &amp;= ~(1&lt;&lt;o-&gt;type);
		break;
	}
}

/*
 *  parse configuration rejection, just stop sending anything that they
 *  don't like (except for ipcp address nak).
 */
static void
rejopts(PPP *ppp, Pstate *p, Block *b, int code)
{
	Lcpmsg *m;
	Lcpopt *o;
	uchar newip[IPaddrlen];

	/* just give up trying what the other side doesn't like */
	m = (Lcpmsg*)b-&gt;rptr;
	for(b-&gt;rptr = m-&gt;data; b-&gt;rptr &lt; b-&gt;wptr; b-&gt;rptr += o-&gt;len){
		o = (Lcpopt*)b-&gt;rptr;
		if(b-&gt;rptr + o-&gt;len &gt; b-&gt;wptr){
			netlog("ppp: bad roption length %ux\n", o-&gt;type);
			return;
		}

		if(code == Lconfrej){
			dropoption(p, o);
			netlog("ppp: %ux rejecting %d\n",
					p-&gt;proto, o-&gt;type);
			continue;
		}

		switch(p-&gt;proto){
		case Plcp:
			switch(o-&gt;type){
			case Octlmap:
				ppp-&gt;rctlmap = nhgetl(o-&gt;data);
				break;
			case Oauth:
				/* don't allow client to request no auth */
				/* could try different auth protocol here */
				fprint(2, "ppp: can not reject CHAP\n");
				exits("ppp: CHAP");
				break;
			default:
				if(o-&gt;type &lt; 8*sizeof(p-&gt;optmask))
					p-&gt;optmask &amp;= ~(1&lt;&lt;o-&gt;type);
				break;
			};
			break;
		case Pccp:
			switch(o-&gt;type){
			default:
				dropoption(p, o);
				break;
			}
			break;
		case Pipcp:
			switch(o-&gt;type){
			case Oipaddr:
syslog(0, "ppp", "rejected addr %I with %V", ppp-&gt;local, o-&gt;data);
				/* if we're a server, don't let other end change our addr */
				if(ppp-&gt;localfrozen){
					dropoption(p, o);
					break;
				}

				/* accept whatever server tells us */
				if(!validv4(ppp-&gt;local)){
					v4tov6(ppp-&gt;local, o-&gt;data);
					dropoption(p, o);
					break;
				}

				/* if he didn't like our addr, ask for a generic one */
				v4tov6(newip, o-&gt;data);
				if(!validv4(newip)){
					invalidate(ppp-&gt;local);
					break;
				}

				/* if he gives us something different, use it anyways */
				v4tov6(ppp-&gt;local, o-&gt;data);
				dropoption(p, o);
				break;
			case Oipdns:
				if (!validv4(ppp-&gt;dns[0])){
					v4tov6(ppp-&gt;dns[0], o-&gt;data);
					dropoption(p, o);
					break;
				}
				v4tov6(newip, o-&gt;data);
				if(!validv4(newip)){
					invalidate(ppp-&gt;dns[0]);
					break;
				}
				v4tov6(ppp-&gt;dns[0], o-&gt;data);
				dropoption(p, o);
				break;
			case Oipwins:
				if (!validv4(ppp-&gt;wins[0])){
					v4tov6(ppp-&gt;wins[0], o-&gt;data);
					dropoption(p, o);
					break;
				}
				v4tov6(newip, o-&gt;data);
				if(!validv4(newip)){
					invalidate(ppp-&gt;wins[0]);
					break;
				}
				v4tov6(ppp-&gt;wins[0], o-&gt;data);
				dropoption(p, o);
				break;
			case Oipdns2:
				if (!validv4(ppp-&gt;dns[1])){
					v4tov6(ppp-&gt;dns[1], o-&gt;data);
					dropoption(p, o);
					break;
				}
				v4tov6(newip, o-&gt;data);
				if(!validv4(newip)){
					invalidate(ppp-&gt;dns[1]);
					break;
				}
				v4tov6(ppp-&gt;dns[1], o-&gt;data);
				dropoption(p, o);
				break;
			case Oipwins2:
				if (!validv4(ppp-&gt;wins[1])){
					v4tov6(ppp-&gt;wins[1], o-&gt;data);
					dropoption(p, o);
					break;
				}
				v4tov6(newip, o-&gt;data);
				if(!validv4(newip)){
					invalidate(ppp-&gt;wins[1]);
					break;
				}
				v4tov6(ppp-&gt;wins[1], o-&gt;data);
				dropoption(p, o);
				break;
			default:
				dropoption(p, o);
				break;
			}
			break;
		}
	}
}


/*
 *  put a messages through the lcp or ipcp state machine.  They are
 *  very similar.
 */
static void
rcv(PPP *ppp, Pstate *p, Block *b)
{
	ulong len;
	int err;
	Lcpmsg *m;
	int proto;

	if(BLEN(b) &lt; 4){
		netlog("ppp: short lcp message\n");
		freeb(b);
		return;
	}
	m = (Lcpmsg*)b-&gt;rptr;
	len = nhgets(m-&gt;len);
	if(BLEN(b) &lt; len){
		netlog("ppp: short lcp message\n");
		freeb(b);
		return;
	}

	netlog("ppp: %ux rcv %d len %ld id %d/%d/%d\n",
		p-&gt;proto, m-&gt;code, len, m-&gt;id, p-&gt;confid, p-&gt;id);

	if(p-&gt;proto != Plcp &amp;&amp; ppp-&gt;lcp-&gt;state != Sopened){
		netlog("ppp: non-lcp with lcp not open\n");
		freeb(b);
		return;
	}

	qlock(ppp);
	switch(m-&gt;code){
	case Lconfreq:
		printopts(p, b, 0);
		err = getopts(ppp, p, b);
		if(err &lt; 0)
			break;

		if(m-&gt;id == p-&gt;rcvdconfid)
			break;			/* don't change state for duplicates */

		switch(p-&gt;state){
		case Sackrcvd:
			if(err)
				break;
			newstate(ppp, p, Sopened);
			break;
		case Sclosed:
		case Sopened:
			config(ppp, p, 1);
			if(err == 0)
				newstate(ppp, p, Sacksent);
			else
				newstate(ppp, p, Sreqsent);
			break;
		case Sreqsent:
		case Sacksent:
			if(err == 0)
				newstate(ppp, p, Sacksent);
			else
				newstate(ppp, p, Sreqsent);
			break;
		}
		break;
	case Lconfack:
		if(p-&gt;confid != m-&gt;id){
			/* ignore if it isn't the message we're sending */
			netlog("ppp: dropping confack\n");
			break;
		}
		p-&gt;confid = -1;		/* ignore duplicates */
		p-&gt;id++;		/* avoid sending duplicates */

		netlog("ppp: recv confack\n");
		switch(p-&gt;state){
		case Sopened:
		case Sackrcvd:
			config(ppp, p, 1);
			newstate(ppp, p, Sreqsent);
			break;
		case Sreqsent:
			newstate(ppp, p, Sackrcvd);
			break;
		case Sacksent:
			newstate(ppp, p, Sopened);
			break;
		}
		break;
	case Lconfrej:
	case Lconfnak:
		if(p-&gt;confid != m-&gt;id) {
			/* ignore if it isn't the message we're sending */
			netlog("ppp: dropping confrej or confnak\n");
			break;
		}
		p-&gt;confid = -1;		/* ignore duplicates */
		p-&gt;id++;		/* avoid sending duplicates */

		switch(p-&gt;state){
		case Sopened:
		case Sackrcvd:
			config(ppp, p, 1);
			newstate(ppp, p, Sreqsent);
			break;
		case Sreqsent:
		case Sacksent:
			printopts(p, b, 0);
			rejopts(ppp, p, b, m-&gt;code);
			config(ppp, p, 1);
			break;
		}
		break;
	case Ltermreq:
		m-&gt;code = Ltermack;
		putframe(ppp, p-&gt;proto, b);

		switch(p-&gt;state){
		case Sackrcvd:
		case Sacksent:
			newstate(ppp, p, Sreqsent);
			break;
		case Sopened:
			newstate(ppp, p, Sclosing);
			break;
		}
		break;
	case Ltermack:
		if(p-&gt;termid != m-&gt;id)	/* ignore if it isn't the message we're sending */
			break;

		if(p-&gt;proto == Plcp)
			ppp-&gt;ipcp-&gt;state = Sclosed;
		switch(p-&gt;state){
		case Sclosing:
			newstate(ppp, p, Sclosed);
			break;
		case Sackrcvd:
			newstate(ppp, p, Sreqsent);
			break;
		case Sopened:
			config(ppp, p, 0);
			newstate(ppp, p, Sreqsent);
			break;
		}
		break;
	case Lcoderej:
		//newstate(ppp, p, Sclosed);
		syslog(0, LOG, "code reject %d\n", m-&gt;data[0]);
		break;
	case Lprotorej:
		proto = nhgets(m-&gt;data);
		netlog("ppp: proto reject %ux\n", proto);
		if(proto == Pccp)
			newstate(ppp, ppp-&gt;ccp, Sclosed);
		break;
	case Lechoreq:
		if(BLEN(b) &lt; 8){
			netlog("ppp: short lcp echo request\n");
			freeb(b);
			return;
		}
		m-&gt;code = Lechoack;
		hnputl(m-&gt;data, ppp-&gt;magic);
		putframe(ppp, p-&gt;proto, b);
		break;
	case Lechoack:
		p-&gt;echoack = 1;
		break;
	case Ldiscard:
		/* nothing to do */
		break;
	case Lresetreq:
		if(p-&gt;proto != Pccp)
			break;
		ppp-&gt;stat.compreset++;
		if(ppp-&gt;ctype != nil)
			b = (*ppp-&gt;ctype-&gt;resetreq)(ppp-&gt;cstate, b);
		if(b != nil) {
			m = (Lcpmsg*)b-&gt;rptr;
			m-&gt;code = Lresetack;
			putframe(ppp, p-&gt;proto, b);
		}
		break;
	case Lresetack:
		if(p-&gt;proto != Pccp)
			break;
		if(ppp-&gt;unctype != nil)
			(*ppp-&gt;unctype-&gt;resetack)(ppp-&gt;uncstate, b);
		break;
	}

	qunlock(ppp);
	freeb(b);
}

/*
 *  timer for protocol state machine
 */
static void
ptimer(PPP *ppp, Pstate *p)
{
	if(p-&gt;state == Sopened || p-&gt;state == Sclosed)
		return;

	p-&gt;timeout--;
	switch(p-&gt;state){
	case Sclosing:
		sendtermreq(ppp, p);
		break;
	case Sreqsent:
	case Sacksent:
		if(p-&gt;timeout &lt;= 0)
			newstate(ppp, p, Sclosed);
		else {
			config(ppp, p, 0);
		}
		break;
	case Sackrcvd:
		if(p-&gt;timeout &lt;= 0)
			newstate(ppp, p, Sclosed);
		else {
			config(ppp, p, 0);
			newstate(ppp, p, Sreqsent);
		}
		break;
	}
}

/* paptimer -- pap timer event handler
 *
 * If PAP authorization hasn't come through, resend an authreqst.  If
 * the maximum number of requests have been sent (~ 30 seconds), give
 * up.
 *
 */
static void
authtimer(PPP* ppp)
{
	if(ppp-&gt;chap-&gt;proto != APpasswd)
		return;

	if(ppp-&gt;chap-&gt;id &lt; 21)
		putpaprequest(ppp);
	else {
		terminate(ppp, 0);
		netlog("ppp: pap timed out--not authorized\n");
	}
}


/*
 *  timer for ppp
 */
static void
ppptimer(PPP *ppp)
{
	while(!dying){
		sleep(Period);
		qlock(ppp);

		netlog("ppp: ppptimer\n");
		ptimer(ppp, ppp-&gt;lcp);
		if(ppp-&gt;lcp-&gt;state == Sopened) {
			switch(ppp-&gt;phase){
			case Pnet:
				ptimer(ppp, ppp-&gt;ccp);
				ptimer(ppp, ppp-&gt;ipcp);
				break;
			case Pauth:
				authtimer(ppp);
				break;
			}
		}

		/* link quality measurement */
		if(ppp-&gt;period &amp;&amp; --(ppp-&gt;timeout) &lt;= 0){
			ppp-&gt;timeout = ppp-&gt;period;
			putlqm(ppp);
		}

		qunlock(ppp);
	}
}

static void
setdefroute(char *net, Ipaddr gate)
{
	int fd;
	char path[128];

	snprint(path, sizeof path, "%s/iproute", net);
	fd = open(path, ORDWR);
	if(fd &lt; 0)
		return;
	fprint(fd, "add 0 0 %I", gate);
	close(fd);
}

enum
{
	Mofd=	32,
};
struct
{
	Lock;

	int	fd[Mofd];
	int	cfd[Mofd];
	int	n;
} old;

static char*
ipopen(PPP *ppp)
{
	static int ipinprocpid;
	int n, cfd, fd;
	char path[128];
	char buf[128];

	if(ipinprocpid &lt;= 0){
		snprint(path, sizeof path, "%s/ipifc/clone", ppp-&gt;net);
		cfd = open(path, ORDWR);
		if(cfd &lt; 0)
			return "can't open ip interface";

		n = read(cfd, buf, sizeof(buf) - 1);
		if(n &lt;= 0){
			close(cfd);
			return "can't open ip interface";
		}
		buf[n] = 0;

		netlog("ppp: setting up IP interface local %I remote %I (valid %d)\n",
			ppp-&gt;local, ppp-&gt;remote, validv4(ppp-&gt;remote));
		if(!validv4(ppp-&gt;remote))
			ipmove(ppp-&gt;remote, ppp-&gt;local);

		snprint(path, sizeof path, "%s/ipifc/%s/data", ppp-&gt;net, buf);
		fd = open(path, ORDWR);
		if(fd &lt; 0){
			close(cfd);
			return "can't open ip interface";
		}

		if(fprint(cfd, "bind pkt") &lt; 0)
			return "binding pkt to ip interface";
		if(fprint(cfd, "add %I 255.255.255.255 %I %lud proxy", ppp-&gt;local,
			ppp-&gt;remote, ppp-&gt;mtu-10) &lt; 0){
			close(cfd);
			return "can't set addresses";
		}
		if(primary)
			setdefroute(ppp-&gt;net, ppp-&gt;remote);
		ppp-&gt;ipfd = fd;
		ppp-&gt;ipcfd = cfd;

		/* signal main() that ip is configured */
		rendezvous((void*)Rmagic, 0);

		switch(ipinprocpid = rfork(RFPROC|RFMEM|RFNOWAIT)){
		case -1:
			sysfatal("forking ipinproc");
		case 0:
			ipinproc(ppp);
			terminate(ppp, 1);
			_exits(0);
		}
	} else {
		/* we may have changed addresses */
		if(ipcmp(ppp-&gt;local, ppp-&gt;curlocal) != 0 ||
		   ipcmp(ppp-&gt;remote, ppp-&gt;curremote) != 0){
			snprint(buf, sizeof buf, "remove %I 255.255.255.255 %I",
			    ppp-&gt;curlocal, ppp-&gt;curremote);
			if(fprint(ppp-&gt;ipcfd, "%s", buf) &lt; 0)
				syslog(0, "ppp", "can't %s: %r", buf);
			snprint(buf, sizeof buf, "add %I 255.255.255.255 %I %lud proxy",
			    ppp-&gt;local, ppp-&gt;remote, ppp-&gt;mtu-10);
			if(fprint(ppp-&gt;ipcfd, "%s", buf) &lt; 0)
				syslog(0, "ppp", "can't %s: %r", buf);
		}
		syslog(0, "ppp", "%I/%I -&gt; %I/%I", ppp-&gt;curlocal, ppp-&gt;curremote,
		   ppp-&gt;local, ppp-&gt;remote);
	}
	ipmove(ppp-&gt;curlocal, ppp-&gt;local);
	ipmove(ppp-&gt;curremote, ppp-&gt;remote);

	return nil;
}

/* return next input IP packet */
Block*
pppread(PPP *ppp)
{
	Block *b, *reply;
	int proto, len;
	Lcpmsg *m;

	while(!dying){
		b = getframe(ppp, &amp;proto);
		if(b == nil)
			return nil;

Again:
		switch(proto){
		case Plcp:
			rcv(ppp, ppp-&gt;lcp, b);
			break;
		case Pccp:
			rcv(ppp, ppp-&gt;ccp, b);
			break;
		case Pipcp:
			rcv(ppp, ppp-&gt;ipcp, b);
			break;
		case Pip:
			if(ppp-&gt;ipcp-&gt;state == Sopened)
				return b;
			netlog("ppp: IP recved: link not up\n");
			freeb(b);
			break;
		case Plqm:
			getlqm(ppp, b);
			break;
		case Pchap:
			getchap(ppp, b);
			break;
		case Ppasswd:
			getpap(ppp, b);
			break;
		case Pvjctcp:
		case Pvjutcp:
			if(ppp-&gt;ipcp-&gt;state != Sopened){
				netlog("ppp: VJ tcp recved: link not up\n");
				freeb(b);
				break;
			}
			ppp-&gt;stat.vjin++;
			b = tcpuncompress(ppp-&gt;ctcp, b, proto);
			if(b != nil)
				return b;
			ppp-&gt;stat.vjfail++;
			break;
		case Pcdata:
			ppp-&gt;stat.uncomp++;
			if(ppp-&gt;ccp-&gt;state != Sopened){
				netlog("ppp: compressed data recved: link not up\n");
				freeb(b);
				break;
			}
			if(ppp-&gt;unctype == nil) {
				netlog("ppp: compressed data recved: no compression\n");
				freeb(b);
				break;
			}
			len = BLEN(b);
			b = (*ppp-&gt;unctype-&gt;uncompress)(ppp, b, &amp;proto, &amp;reply);
			if(reply != nil){
				/* send resetreq */
				ppp-&gt;stat.uncompreset++;
				putframe(ppp, Pccp, reply);
				freeb(reply);
			}
			if(b == nil)
				break;
			ppp-&gt;stat.uncompin += len;
			ppp-&gt;stat.uncompout += BLEN(b);
/* netlog("ppp: uncompressed frame %ux %d %d (%d uchars)\n", proto, b-&gt;rptr[0], b-&gt;rptr[1], BLEN(b)); /* */
			goto Again;	
		default:
			syslog(0, LOG, "unknown proto %ux", proto);
			if(ppp-&gt;lcp-&gt;state == Sopened){
				/* reject the protocol */
				b-&gt;rptr -= 6;
				m = (Lcpmsg*)b-&gt;rptr;
				m-&gt;code = Lprotorej;
				m-&gt;id = ++ppp-&gt;lcp-&gt;id;
				hnputs(m-&gt;data, proto);
				hnputs(m-&gt;len, BLEN(b));
				putframe(ppp, Plcp, b);
			}
			freeb(b);
			break;
		}
	}
	return nil;
}

/* transmit an IP packet */
int
pppwrite(PPP *ppp, Block *b)
{
	int proto;
	int len;

	qlock(ppp);
	/* can't send ip packets till we're established */
	if(ppp-&gt;ipcp-&gt;state != Sopened) {
		qunlock(ppp);
		syslog(0, LOG, "IP write: link not up");
		len = blen(b);
		freeb(b);
		return len;
	}

	proto = Pip;
	ppp-&gt;stat.ipsend++;

	if(ppp-&gt;ipcp-&gt;flags &amp; Fipcompress){
		b = compress(ppp-&gt;ctcp, b, &amp;proto);
		if(b == nil){
			qunlock(ppp);
			return 0;
		}
		if(proto != Pip)
			ppp-&gt;stat.vjout++;
	}

	if(ppp-&gt;ctype != nil) {
		len = blen(b);
		b = (*ppp-&gt;ctype-&gt;compress)(ppp, proto, b, &amp;proto);
		if(proto == Pcdata) {
			ppp-&gt;stat.comp++;
			ppp-&gt;stat.compin += len;
			ppp-&gt;stat.compout += blen(b);
		}
	} 

	if(putframe(ppp, proto, b) &lt; 0) {
		qunlock(ppp);
		freeb(b);
		return -1;
	}
	qunlock(ppp);

	len = blen(b);
	freeb(b);
	return len;
}

static void
terminate(PPP *ppp, int kill)
{
	close(ppp-&gt;ipfd);
	ppp-&gt;ipfd = -1;
	close(ppp-&gt;ipcfd);
	ppp-&gt;ipcfd = -1;
	close(ppp-&gt;mediain);
	close(ppp-&gt;mediaout);
	ppp-&gt;mediain = -1;
	ppp-&gt;mediaout = -1;
	dying = 1;

	if(kill)
		postnote(PNGROUP, getpid(), "die");
}

typedef struct Iphdr Iphdr;
struct Iphdr
{
	uchar	vihl;		/* Version and header length */
	uchar	tos;		/* Type of service */
	uchar	length[2];	/* packet length */
	uchar	id[2];		/* Identification */
	uchar	frag[2];	/* Fragment information */
	uchar	ttl;		/* Time to live */
	uchar	proto;		/* Protocol */
	uchar	cksum[2];	/* Header checksum */
	uchar	src[4];		/* Ip source (uchar ordering unimportant) */
	uchar	dst[4];		/* Ip destination (uchar ordering unimportant) */
};

static void
ipinproc(PPP *ppp)
{
	Block *b;
	int m, n;
	Iphdr *ip;

	while(!dying){

		b = allocb(Buflen);
		n = read(ppp-&gt;ipfd, b-&gt;wptr, b-&gt;lim-b-&gt;wptr);
		if(n &lt; 0)
			break;

		/* trim packet if there's padding (e.g. from ether) */
		ip = (Iphdr*)b-&gt;rptr;
		m = nhgets(ip-&gt;length);
		if(m &lt; n &amp;&amp; m &gt; 0)
			n = m;
		b-&gt;wptr += n;

		if(pppwrite(ppp, b) &lt; 0)
			break;
	}
}

static void
catchdie(void*, char *msg)
{
	if(strstr(msg, "die") != nil)
		noted(NCONT);
	else
		noted(NDFLT);
}

static void
hexdump(uchar *a, int na)
{
	int i;
	char buf[80];

	fprint(2, "dump %p %d\n", a, na);
	buf[0] = '\0';
	for(i=0; i&lt;na; i++){
		sprint(buf+strlen(buf), " %.2ux", a[i]);
		if(i%16 == 7)
			sprint(buf+strlen(buf), " --");
		if(i%16==15){
			sprint(buf+strlen(buf), "\n");
			write(2, buf, strlen(buf));
			buf[0] = '\0';
		}
	}
	if(i%16){
		sprint(buf+strlen(buf), "\n");
		write(2, buf, strlen(buf));
	}
}

static void
mediainproc(PPP *ppp)
{
	Block *b;
	Ipaddr remote;

	notify(catchdie);
	while(!dying){
		b = pppread(ppp);
		if(b == nil){
			syslog(0, LOG, "pppread return nil");
			break;
		}
		ppp-&gt;stat.iprecv++;
		if(ppp-&gt;ipcp-&gt;state != Sopened) {
			ppp-&gt;stat.iprecvnotup++;
			freeb(b);
			continue;
		}

		if(server) {
			v4tov6(remote, b-&gt;rptr+12);
			if(ipcmp(remote, ppp-&gt;remote) != 0) {
				ppp-&gt;stat.iprecvbadsrc++;
				freeb(b);
				continue;
			}
		}
		if(debug &gt; 1){
			netlog("ip write pkt %p %d\n", b-&gt;rptr, blen(b));
			hexdump(b-&gt;rptr, blen(b));
		}
		if(write(ppp-&gt;ipfd, b-&gt;rptr, blen(b)) &lt; 0) {
			syslog(0, LOG, "error writing to pktifc");
			freeb(b);
			break;
		}

		freeb(b);
	}

	netlog(": remote=%I: ppp shutting down\n", ppp-&gt;remote);
	syslog(0, LOG, ": remote=%I: ppp shutting down", ppp-&gt;remote);
	syslog(0, LOG, "\t\tppp send = %lud/%lud recv= %lud/%lud",
		ppp-&gt;out.packets, ppp-&gt;out.uchars,
		ppp-&gt;in.packets, ppp-&gt;in.uchars);
	syslog(0, LOG, "\t\tip send=%lud", ppp-&gt;stat.ipsend);
	syslog(0, LOG, "\t\tip recv=%lud notup=%lud badsrc=%lud",
		ppp-&gt;stat.iprecv, ppp-&gt;stat.iprecvnotup, ppp-&gt;stat.iprecvbadsrc);
	syslog(0, LOG, "\t\tcompress=%lud in=%lud out=%lud reset=%lud",
		ppp-&gt;stat.comp, ppp-&gt;stat.compin, ppp-&gt;stat.compout, ppp-&gt;stat.compreset);
	syslog(0, LOG, "\t\tuncompress=%lud in=%lud out=%lud reset=%lud",
		ppp-&gt;stat.uncomp, ppp-&gt;stat.uncompin, ppp-&gt;stat.uncompout,
		ppp-&gt;stat.uncompreset);
	syslog(0, LOG, "\t\tvjin=%lud vjout=%lud vjfail=%lud", 
		ppp-&gt;stat.vjin, ppp-&gt;stat.vjout, ppp-&gt;stat.vjfail);
}

/*
 *  link quality management
 */
static void
getlqm(PPP *ppp, Block *b)
{
	Qualpkt *p;

	p = (Qualpkt*)b-&gt;rptr;
	if(BLEN(b) == sizeof(Qualpkt)){
		ppp-&gt;in.reports++;
		ppp-&gt;pout.reports = nhgetl(p-&gt;peeroutreports);
		ppp-&gt;pout.packets = nhgetl(p-&gt;peeroutpackets);
		ppp-&gt;pout.uchars = nhgetl(p-&gt;peeroutuchars);
		ppp-&gt;pin.reports = nhgetl(p-&gt;peerinreports);
		ppp-&gt;pin.packets = nhgetl(p-&gt;peerinpackets);
		ppp-&gt;pin.discards = nhgetl(p-&gt;peerindiscards);
		ppp-&gt;pin.errors = nhgetl(p-&gt;peerinerrors);
		ppp-&gt;pin.uchars = nhgetl(p-&gt;peerinuchars);

		/* save our numbers at time of reception */
		memmove(&amp;ppp-&gt;sin, &amp;ppp-&gt;in, sizeof(Qualstats));

	}
	freeb(b);
	if(ppp-&gt;period == 0)
		putlqm(ppp);

}

static void
putlqm(PPP *ppp)
{
	Qualpkt *p;
	Block *b;

	b = allocb(sizeof(Qualpkt));
	b-&gt;wptr += sizeof(Qualpkt);
	p = (Qualpkt*)b-&gt;rptr;
	hnputl(p-&gt;magic, 0);

	/* heresay (what he last told us) */
	hnputl(p-&gt;lastoutreports, ppp-&gt;pout.reports);
	hnputl(p-&gt;lastoutpackets, ppp-&gt;pout.packets);
	hnputl(p-&gt;lastoutuchars, ppp-&gt;pout.uchars);

	/* our numbers at time of last reception */
	hnputl(p-&gt;peerinreports, ppp-&gt;sin.reports);
	hnputl(p-&gt;peerinpackets, ppp-&gt;sin.packets);
	hnputl(p-&gt;peerindiscards, ppp-&gt;sin.discards);
	hnputl(p-&gt;peerinerrors, ppp-&gt;sin.errors);
	hnputl(p-&gt;peerinuchars, ppp-&gt;sin.uchars);

	/* our numbers now */
	hnputl(p-&gt;peeroutreports, ppp-&gt;out.reports+1);
	hnputl(p-&gt;peeroutpackets, ppp-&gt;out.packets+1);
	hnputl(p-&gt;peeroutuchars, ppp-&gt;out.uchars+53/*hack*/);

	putframe(ppp, Plqm, b);
	freeb(b);
	ppp-&gt;out.reports++;
}

/*
 * init challenge response dialog
 */
static void
chapinit(PPP *ppp)
{
	Block *b;
	Lcpmsg *m;
	Chap *c;
	int len;
	char *aproto;

	getauth(ppp);

	c = ppp-&gt;chap;
	c-&gt;id++;

	switch(c-&gt;proto){
	default:
		abort();
	case APmd5:
		aproto = "chap";
		break;
	case APmschap:
		aproto = "mschap";
		break;
	}
	if((c-&gt;cs = auth_challenge("proto=%q role=server", aproto)) == nil)
		sysfatal("auth_challenge: %r");
	syslog(0, LOG, ": remote=%I: sending %d byte challenge", ppp-&gt;remote, c-&gt;cs-&gt;nchal);
	len = 4 + 1 + c-&gt;cs-&gt;nchal + strlen(ppp-&gt;chapname);
	b = alloclcp(Cchallenge, c-&gt;id, len, &amp;m);

	*b-&gt;wptr++ = c-&gt;cs-&gt;nchal;
	memmove(b-&gt;wptr, c-&gt;cs-&gt;chal, c-&gt;cs-&gt;nchal);
	b-&gt;wptr += c-&gt;cs-&gt;nchal;
	memmove(b-&gt;wptr, ppp-&gt;chapname, strlen(ppp-&gt;chapname));
	b-&gt;wptr += strlen(ppp-&gt;chapname);
	hnputs(m-&gt;len, len);
	putframe(ppp, Pchap, b);
	freeb(b);

	c-&gt;state = Cchalsent;
}

/*
 * BUG factotum should do this
 */
enum {
	MShashlen = 16,
	MSresplen = 24,
	MSchallen = 8,
};

void
desencrypt(uchar data[8], uchar key[7])
{
	ulong ekey[32];

	key_setup(key, ekey);
	block_cipher(ekey, data, 0);
}

void
nthash(uchar hash[MShashlen], char *passwd)
{
	uchar buf[512];
	int i;
	
	for(i=0; *passwd &amp;&amp; i&lt;sizeof(buf); passwd++) {
		buf[i++] = *passwd;
		buf[i++] = 0;
	}
	memset(hash, 0, 16);
	md4(buf, i, hash, 0);
}

void
mschalresp(uchar resp[MSresplen], uchar hash[MShashlen], uchar chal[MSchallen])
{
	int i;
	uchar buf[21];
	
	memset(buf, 0, sizeof(buf));
	memcpy(buf, hash, MShashlen);

	for(i=0; i&lt;3; i++) {
		memmove(resp+i*MSchallen, chal, MSchallen);
		desencrypt(resp+i*MSchallen, buf+i*7);
	}
}

/*
 *  challenge response dialog
 */
extern	int	_asrdresp(int, uchar*, int);

static void
getchap(PPP *ppp, Block *b)
{
	AuthInfo *ai;
	Lcpmsg *m;
	int len, vlen, i, id, n, nresp;
	char md5buf[512], code;
	Chap *c;
	Chapreply cr;
	MSchapreply mscr;
	char uid[PATH];
	uchar digest[16], *p, *resp, sdigest[SHA1dlen];
	uchar mshash[MShashlen], mshash2[MShashlen];
	DigestState *s;
	uchar msresp[2*MSresplen+1];

	m = (Lcpmsg*)b-&gt;rptr;
	len = nhgets(m-&gt;len);
	if(BLEN(b) &lt; len){
		syslog(0, LOG, "short chap message");
		freeb(b);
		return;
	}

	qlock(ppp);

	switch(m-&gt;code){
	case Cchallenge:
		getauth(ppp);

		vlen = m-&gt;data[0];
		if(vlen &gt; len - 5) {
			netlog("PPP: chap: bad challenge len\n");
			break;
		}

		id = m-&gt;id;
		switch(ppp-&gt;chap-&gt;proto){
		default:
			abort();
		case APmd5:
			md5buf[0] = m-&gt;id;
			strcpy(md5buf+1, ppp-&gt;secret);
			n = strlen(ppp-&gt;secret) + 1;
			memmove(md5buf+n, m-&gt;data+1, vlen);
			n += vlen;
			md5((uchar*)md5buf, n, digest, nil);
			resp = digest;
			nresp = 16;
			break;
		case APmschap:
			nthash(mshash, ppp-&gt;secret);
			memset(msresp, 0, sizeof msresp);
			mschalresp(msresp+MSresplen, mshash, m-&gt;data+1);
			resp = msresp;
			nresp = sizeof msresp;
			nthash(mshash, ppp-&gt;secret);
			md4(mshash, 16, mshash2, 0);
			s = sha1(mshash2, 16, 0, 0);
			sha1(mshash2, 16, 0, s);
			sha1(m-&gt;data+1, 8, sdigest, s);
			memmove(ppp-&gt;key, sdigest, 16);
			break;
		}
		len = 4 + 1 + nresp + strlen(ppp-&gt;chapname);
		freeb(b);
		b = alloclcp(Cresponse, id, len, &amp;m);
		*b-&gt;wptr++ = nresp;
		memmove(b-&gt;wptr, resp, nresp);
		b-&gt;wptr += nresp;
		memmove(b-&gt;wptr, ppp-&gt;chapname, strlen(ppp-&gt;chapname));
		b-&gt;wptr += strlen(ppp-&gt;chapname);
		hnputs(m-&gt;len, len);
		netlog("PPP: sending response len %d\n", len);
		putframe(ppp, Pchap, b);
		break;
	case Cresponse:
		c = ppp-&gt;chap;
		vlen = m-&gt;data[0];
		if(m-&gt;id != c-&gt;id) {
			netlog("PPP: chap: bad response id\n");
			break;
		}
		switch(c-&gt;proto) {
		default:
			sysfatal("unknown chap protocol: %d", c-&gt;proto);
		case APmd5:
			if(vlen &gt; len - 5 || vlen != 16) {
				netlog("PPP: chap: bad response len\n");
				break;
			}

			cr.id = m-&gt;id;
			memmove(cr.resp, m-&gt;data+1, 16);
			memset(uid, 0, sizeof(uid));
			n = len-5-vlen;
			if(n &gt;= PATH)
				n = PATH-1;
			memmove(uid, m-&gt;data+1+vlen, n);
			c-&gt;cs-&gt;user = uid;
			c-&gt;cs-&gt;resp = &amp;cr;
			c-&gt;cs-&gt;nresp = sizeof cr;
			break;
		case APmschap:
			if(vlen &gt; len - 5 || vlen != 49) {
				netlog("PPP: chap: bad response len\n");
				break;
			}
			memset(&amp;mscr, 0, sizeof(mscr));
			memmove(mscr.LMresp, m-&gt;data+1, 24);
			memmove(mscr.NTresp, m-&gt;data+24+1, 24);
			n = len-5-vlen;
			p = m-&gt;data+1+vlen;
			/* remove domain name */
			for(i=0; i&lt;n; i++) {
				if(p[i] == '\\') {
					p += i+1;
					n -= i+1;
					break;
				}
			}
			if(n &gt;= PATH)
				n = PATH-1;
			memset(uid, 0, sizeof(uid));
			memmove(uid, p, n);
			c-&gt;cs-&gt;user = uid;
			c-&gt;cs-&gt;resp = &amp;mscr;
			c-&gt;cs-&gt;nresp = sizeof mscr;
			break;
		} 

		syslog(0, LOG, ": remote=%I vlen %d proto %d response user %s nresp %d", ppp-&gt;remote, vlen, c-&gt;proto, c-&gt;cs-&gt;user, c-&gt;cs-&gt;nresp);
		if((ai = auth_response(c-&gt;cs)) == nil || auth_chuid(ai, nil) &lt; 0){
			c-&gt;state = Cunauth;
			code = Cfailure;
			syslog(0, LOG, ": remote=%I: auth failed: %r, uid=%s", ppp-&gt;remote, uid);
		}else{
			c-&gt;state = Cauthok;
			code = Csuccess;
			syslog(0, LOG, ": remote=%I: auth ok: uid=%s nsecret=%d", ppp-&gt;remote, uid, ai-&gt;nsecret);
			if(c-&gt;proto == APmschap){
				if(ai-&gt;nsecret != sizeof(ppp-&gt;key))
					sysfatal("could not get the encryption key");
				memmove(ppp-&gt;key, ai-&gt;secret, sizeof(ppp-&gt;key));
			}
		}
		auth_freeAI(ai);
		auth_freechal(c-&gt;cs);
		c-&gt;cs = nil;
		freeb(b);

		/* send reply */
		len = 4;
		b = alloclcp(code, c-&gt;id, len, &amp;m);
		hnputs(m-&gt;len, len);
		putframe(ppp, Pchap, b);

		if(c-&gt;state == Cauthok) {
			setphase(ppp, Pnet);
		} else {
			/* restart chapp negotiation */
			chapinit(ppp);
		}
		
		break;
	case Csuccess:
		netlog("ppp: chap succeeded\n");
		break;
	case Cfailure:
		netlog("ppp: chap failed\n");
		break;
	default:
		syslog(0, LOG, "chap code %d?\n", m-&gt;code);
		break;
	}
	qunlock(ppp);
	freeb(b);
}

static void
putpaprequest(PPP *ppp)
{
	Block *b;
	Lcpmsg *m;
	Chap *c;
	int len, nlen, slen;

	getauth(ppp);

	c = ppp-&gt;chap;
	c-&gt;id++;
	netlog("PPP: pap: send authreq %d %s %s\n", c-&gt;id, ppp-&gt;chapname, "****");

	nlen = strlen(ppp-&gt;chapname);
	slen = strlen(ppp-&gt;secret);
	len = 4 + 1 + nlen + 1 + slen;
	b = alloclcp(Pauthreq, c-&gt;id, len, &amp;m);

	*b-&gt;wptr++ = nlen;
	memmove(b-&gt;wptr, ppp-&gt;chapname, nlen);
	b-&gt;wptr += nlen;
	*b-&gt;wptr++ = slen;
	memmove(b-&gt;wptr, ppp-&gt;secret, slen);
	b-&gt;wptr += slen;
	hnputs(m-&gt;len, len);

	putframe(ppp, Ppasswd, b);
	freeb(b);
}

static void
papinit(PPP *ppp)
{
	ppp-&gt;chap-&gt;id = 0;
	putpaprequest(ppp);
}

static void
getpap(PPP *ppp, Block *b)
{
	Lcpmsg *m;
	int len;

	m = (Lcpmsg*)b-&gt;rptr;
	len = 4;
	if(BLEN(b) &lt; 4 || BLEN(b) &lt; (len = nhgets(m-&gt;len))){
		syslog(0, LOG, "short pap message (%ld &lt; %d)", BLEN(b), len);
		freeb(b);
		return;
	}
	if(len &lt; sizeof(Lcpmsg))
		m-&gt;data[0] = 0;

	qlock(ppp);
	switch(m-&gt;code){
	case Pauthreq:
		netlog("PPP: pap auth request, not supported\n");
		break;
	case Pauthack:
		if(ppp-&gt;phase == Pauth
		&amp;&amp; ppp-&gt;chap-&gt;proto == APpasswd
		&amp;&amp; m-&gt;id &lt;= ppp-&gt; chap-&gt;id){
			netlog("PPP: pap succeeded\n");
			setphase(ppp, Pnet);
		}
		break;
	case Pauthnak:
		if(ppp-&gt;phase == Pauth
		&amp;&amp; ppp-&gt;chap-&gt;proto == APpasswd
		&amp;&amp; m-&gt;id &lt;= ppp-&gt; chap-&gt;id){
			netlog("PPP: pap failed (%d:%.*s)\n",
				m-&gt;data[0], m-&gt;data[0], (char*)m-&gt;data+1);
			terminate(ppp, 0);
		}
		break;
	default:
		netlog("PPP: unknown pap messsage %d\n", m-&gt;code);
	}
	qunlock(ppp);
	freeb(b);
}

static void
printopts(Pstate *p, Block *b, int send)
{
	Lcpmsg *m;	
	Lcpopt *o;
	int proto, x, period;
	uchar *cp;
	char *code, *dir;

	m = (Lcpmsg*)b-&gt;rptr;
	switch(m-&gt;code) {
	default: code = "&lt;unknown&gt;"; break;
	case Lconfreq: code = "confrequest"; break;
	case Lconfack: code = "confack"; break;
	case Lconfnak: code = "confnak"; break;
	case Lconfrej: code = "confreject"; break;
	}

	if(send)
		dir = "send";
	else
		dir = "recv";

	netlog("ppp: %s %s: id=%d\n", dir, code, m-&gt;id);

	for(cp = m-&gt;data; cp &lt; b-&gt;wptr; cp += o-&gt;len){
		o = (Lcpopt*)cp;
		if(cp + o-&gt;len &gt; b-&gt;wptr){
			netlog("\tbad option length %ux\n", o-&gt;type);
			return;
		}

		switch(p-&gt;proto){
		case Plcp:
			switch(o-&gt;type){
			default:
				netlog("\tunknown %d len=%d\n", o-&gt;type, o-&gt;len);
				break;
			case Omtu:
				netlog("\tmtu = %d\n", nhgets(o-&gt;data));
				break;
			case Octlmap:
				netlog("\tctlmap = %ux\n", nhgetl(o-&gt;data));
				break;
			case Oauth:
				netlog("\tauth = %ux", nhgetl(o-&gt;data));
				proto = nhgets(o-&gt;data);
				switch(proto) {
				default:
					netlog("unknown auth proto %d\n", proto);
					break;
				case Ppasswd:
					netlog("password\n");
					break;
				case Pchap:
					netlog("chap %ux\n", o-&gt;data[2]);
					break;
				}
				break;
			case Oquality:
				proto = nhgets(o-&gt;data);
				switch(proto) {
				default:
					netlog("\tunknown quality proto %d\n", proto);
					break;
				case Plqm:
					x = nhgetl(o-&gt;data+2)*10;
					period = (x+Period-1)/Period;
					netlog("\tlqm period = %d\n", period);
					break;
				}
			case Omagic:
				netlog("\tmagic = %ux\n", nhgetl(o-&gt;data));
				break;
			case Opc:
				netlog("\tprotocol compress\n");
				break;
			case Oac:
				netlog("\taddr compress\n");
				break;
			}
			break;
		case Pccp:
			switch(o-&gt;type){
			default:
				netlog("\tunknown %d len=%d\n", o-&gt;type, o-&gt;len);
				break;
			case Ocoui:	
				netlog("\tOUI\n");
				break;
			case Ocstac:
				netlog("\tstac LZS\n");
				break;
			case Ocmppc:	
				netlog("\tMicrosoft PPC len=%d %ux\n", o-&gt;len, nhgetl(o-&gt;data));
				break;
			case Octhwack:	
				netlog("\tThwack\n");
				break;
			}
			break;
		case Pecp:
			switch(o-&gt;type){
			default:
				netlog("\tunknown %d len=%d\n", o-&gt;type, o-&gt;len);
				break;
			case Oeoui:	
				netlog("\tOUI\n");
				break;
			case Oedese:
				netlog("\tDES\n");
				break;
			}
			break;
		case Pipcp:
			switch(o-&gt;type){
			default:
				netlog("\tunknown %d len=%d\n", o-&gt;type, o-&gt;len);
				break;
			case Oipaddrs:	
				netlog("\tip addrs - deprecated\n");
				break;
			case Oipcompress:
				netlog("\tip compress\n");
				break;
			case Oipaddr:	
				netlog("\tip addr %V\n", o-&gt;data);
				break;
			case Oipdns:	
				netlog("\tdns addr %V\n", o-&gt;data);
				break;
			case Oipwins:	
				netlog("\twins addr %V\n", o-&gt;data);
				break;
			case Oipdns2:	
				netlog("\tdns2 addr %V\n", o-&gt;data);
				break;
			case Oipwins2:	
				netlog("\twins2 addr %V\n", o-&gt;data);
				break;
			}
			break;
		}
	}
}

static void
sendtermreq(PPP *ppp, Pstate *p)
{
	Block *b;
	Lcpmsg *m;

	p-&gt;termid = ++(p-&gt;id);
	b = alloclcp(Ltermreq, p-&gt;termid, 4, &amp;m);
	hnputs(m-&gt;len, 4);
	putframe(ppp, p-&gt;proto, b);
	freeb(b);
	newstate(ppp, p, Sclosing);
}

static void
sendechoreq(PPP *ppp, Pstate *p)
{
	Block *b;
	Lcpmsg *m;

	p-&gt;termid = ++(p-&gt;id);
	b = alloclcp(Lechoreq, p-&gt;id, 4, &amp;m);
	hnputs(m-&gt;len, 4);
	putframe(ppp, p-&gt;proto, b);
	freeb(b);
}

enum
{
	CtrlD	= 0x4,
	CtrlE	= 0x5,
	CtrlO	= 0xf,
	Cr	= 13,
	View	= 0x80,
};

int conndone;

static void
xfer(int fd)
{
	int i, n;
	uchar xbuf[128];

	for(;;) {
		n = read(fd, xbuf, sizeof(xbuf));
		if(n &lt; 0)
			break;
		if(conndone)
			break;
		for(i = 0; i &lt; n; i++)
			if(xbuf[i] == Cr)
				xbuf[i] = ' ';
		write(1, xbuf, n);
	}
	close(fd);
}

static int
readcr(int fd, char *buf, int nbuf)
{
	char c;
	int n, tot;

	tot = 0;
	while((n=read(fd, &amp;c, 1)) == 1){
		if(c == '\n'){
			buf[tot] = 0;
			return tot;
		}
		buf[tot++] = c;
		if(tot == nbuf)
			sysfatal("line too long in readcr");
	}
	return n;
}

static void
connect(int fd, int cfd)
{
	int n, ctl;
	char xbuf[128];

	if (chatfile) {
		int chatfd, lineno, nb;
		char *buf, *p, *s, response[128];
		Dir *dir;

		if ((chatfd = open(chatfile, OREAD)) &lt; 0)
			sysfatal("cannot open %s: %r", chatfile);

		if ((dir = dirfstat(chatfd)) == nil)
			sysfatal("cannot fstat %s: %r",chatfile);

		buf = (char *)malloc(dir-&gt;length + 1);
		assert(buf);

		if ((nb = read(chatfd, buf, dir-&gt;length)) &lt; 0)
			sysfatal("cannot read chatfile %s: %r", chatfile);
		assert(nb == dir-&gt;length);
		buf[dir-&gt;length] = '\0';
		free(dir);
		close(chatfd);

		p = buf;
		lineno = 0;
		for(;;) {
			char *_args[3];

			if ((s = strchr(p, '\n')) == nil)
				break;
			*s++ = '\0';
		
			lineno++;

			if (*p == '#') {
				p = s; 
				continue;
			}

			if (tokenize(p, _args, 3) != 2)
				sysfatal("invalid line %d (line expected: 'send' 'expect')", 
						lineno);

			if (debug)
				print("sending %s, expecting %s\n", _args[0], _args[1]);

			if(strlen(_args[0])){
				nb = fprint(fd, "%s\r", _args[0]);
				assert(nb &gt; 0);
			}

			if (strlen(_args[1]) &gt; 0) {
				if ((nb = readcr(fd, response, sizeof response-1)) &lt; 0)
					sysfatal("cannot read response from: %r");

				if (debug)
					print("response %s\n", response);

				if (nb == 0)
					sysfatal("eof on input?");

				if (cistrstr(response, _args[1]) == nil)
					sysfatal("expected %s, got %s", _args[1], response);
			}
			p = s;
		}
		free(buf);
		return;
	}

	print("Connect to file system now, type ctrl-d when done.\n");
	print("...(Use the view or down arrow key to send a break)\n");
	print("...(Use ctrl-e to set even parity or ctrl-o for odd)\n");

	ctl = open("/dev/consctl", OWRITE);
	if(ctl &lt; 0)
		sysfatal("opening consctl");
	fprint(ctl, "rawon");

	fd = dup(fd, -1);
	conndone = 0;
	switch(rfork(RFPROC|RFMEM|RFNOWAIT)){
	case -1:
		sysfatal("forking xfer");
	case 0:
		xfer(fd);
		_exits(nil);
	}

	for(;;){
		read(0, xbuf, 1);
		switch(xbuf[0]&amp;0xff) {
		case CtrlD:	/* done */
			conndone = 1;
			close(ctl);
			print("\n");
			return;
		case CtrlE:	/* set even parity */
			fprint(cfd, "pe");
			break;
		case CtrlO:	/* set odd parity */
			fprint(cfd, "po");
			break;
		case View:	/* send a break */
			fprint(cfd, "k500");
			break;
		default:
			n = write(fd, xbuf, 1);
			if(n &lt; 0) {
				errstr(xbuf, sizeof(xbuf));
				conndone = 1;
				close(ctl);
				print("[remote write error (%s)]\n", xbuf);
				return;
			}
		}
	}
}

int interactive;

void
usage(void)
{
	fprint(2, "usage: ppp [-CPSacdfu] [-b baud] [-k keyspec] [-m mtu] "
		"[-M chatfile] [-p dev] [-x netmntpt] [-t modemcmd] "
		"[local-addr [remote-addr]]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int mtu, baud, framing, user, mediain, mediaout, cfd;
	Ipaddr ipaddr, remip;
	char *dev, *modemcmd;
	char net[128];
	PPP *ppp;
	char buf[128];

	rfork(RFREND|RFNOTEG|RFNAMEG);

	fmtinstall('I', eipfmt);
	fmtinstall('V', eipfmt);
	fmtinstall('E', eipfmt);

	dev = nil;

	invalidate(ipaddr);
	invalidate(remip);

	mtu = Defmtu;
	baud = 0;
	framing = 0;
	setnetmtpt(net, sizeof(net), nil);
	user = 0;
	modemcmd = nil;

	ARGBEGIN{
	case 'a':
		noauth = 1;
		break;
	case 'b':
		baud = atoi(EARGF(usage()));
		if(baud &lt; 0)
			baud = 0;
		break;
	case 'c':
		nocompress = 1;
		break;
	case 'C':
		noipcompress = 1;
		break;
	case 'd':
		debug++;
		break;
	case 'f':
		framing = 1;
		break;
	case 'F':
		pppframing = 0;
		break;
	case 'k':
		keyspec = EARGF(usage());
		break;
	case 'm':
		mtu = atoi(EARGF(usage()));
		if(mtu &lt; Minmtu)
			mtu = Minmtu;
		if(mtu &gt; Maxmtu)
			mtu = Maxmtu;
		break;
	case 'M':
		chatfile = EARGF(usage());
		break;
	case 'p':
		dev = EARGF(usage());
		break;
	case 'P':
		primary = 1;
		break;
	case 'S':
		server = 1;
		break;
	case 't':
		modemcmd = EARGF(usage());
		break;
	case 'u':
		user = 1;
		break;
	case 'x':
		setnetmtpt(net, sizeof net, EARGF(usage()));
		break;
	default:
		fprint(2, "unknown option %c\n", ARGC());
		usage();
	}ARGEND;

	switch(argc){
	case 2:
		if (parseip(remip, argv[1]) == -1)
			sysfatal("bad remote ip %s", argv[1]);
	case 1:
		if (parseip(ipaddr, argv[0]) == -1)
			sysfatal("bad ip %s", argv[0]);
	case 0:
		break;
	default:
		usage();
	}

	nip = nipifcs(net);
	if(nip == 0 &amp;&amp; !server)
		primary = 1;

	if(dev != nil){
		mediain = open(dev, ORDWR);
		if(mediain &lt; 0){
			if(strchr(dev, '!')){
				if((mediain = dial(dev, 0, 0, &amp;cfd)) == -1){
					fprint(2, "ppp: couldn't dial %s: %r\n", dev);
					exits(dev);
				}
			} else {
				fprint(2, "ppp: couldn't open %s\n", dev);
				exits(dev);
			}
		} else {
			snprint(buf, sizeof buf, "%sctl", dev);
			cfd = open(buf, ORDWR);
		}
		if(cfd &gt; 0){
			if(baud)
				fprint(cfd, "b%d", baud);
			fprint(cfd, "m1");	/* cts/rts flow control (and fifo's) on */
			fprint(cfd, "q64000");	/* increase q size to 64k */
			fprint(cfd, "n1");	/* nonblocking writes on */
			fprint(cfd, "r1");	/* rts on */
			fprint(cfd, "d1");	/* dtr on */
			fprint(cfd, "c1");	/* dcdhup on */
			if(user || chatfile)
				connect(mediain, cfd);
			close(cfd);
		} else {
			if(user || chatfile)
				connect(mediain, -1);
		}
		mediaout = mediain;
	} else {
		mediain = open("/fd/0", OREAD);
		if(mediain &lt; 0){
			fprint(2, "ppp: couldn't open /fd/0\n");
			exits("/fd/0");
		}
		mediaout = open("/fd/1", OWRITE);
		if(mediaout &lt; 0){
			fprint(2, "ppp: couldn't open /fd/0\n");
			exits("/fd/1");
		}
	}

	if(modemcmd != nil &amp;&amp; mediaout &gt;= 0)
		fprint(mediaout, "%s\r", modemcmd);

	ppp = mallocz(sizeof(*ppp), 1);
	pppopen(ppp, mediain, mediaout, net, ipaddr, remip, mtu, framing);

	/* wait until ip is configured */
	rendezvous((void*)Rmagic, 0);

	if(primary){
		/* create a /net/ndb entry */
		putndb(ppp, net);
	}

	exits(0);
}

void
netlog(char *fmt, ...)
{
	va_list arg;
	char *m;
	static long start;
	long now;

	if(debug == 0)
		return;

	now = time(0);
	if(start == 0)
		start = now;

	va_start(arg, fmt);
	m = vsmprint(fmt, arg);
	fprint(2, "%ld %s", now-start, m);
	free(m);
	va_end(arg);
}

/*
 *  return non-zero if this is a valid v4 address
 */
static int
validv4(Ipaddr addr)
{
	return memcmp(addr, v4prefix, IPv4off) == 0 &amp;&amp; memcmp(addr, v4prefix, IPaddrlen) != 0;
}

static void
invalidate(Ipaddr addr)
{
	ipmove(addr, IPnoaddr);
}

/*
 *  return number of networks
 */
static int
nipifcs(char *net)
{
	static Ipifc *ifc;
	Ipifc *nifc;
	Iplifc *lifc;
	int n;

	n = 0;
	ifc = readipifc(net, ifc, -1);
	for(nifc = ifc; nifc != nil; nifc = nifc-&gt;next)
		for(lifc = ifc-&gt;lifc; lifc != nil; lifc = lifc-&gt;next)
			n++;
	return n;
}

/*
 *   make an ndb entry and put it into /net/ndb for the servers to see
 */
static void
putndb(PPP *ppp, char *net)
{
	char buf[1024];
	char file[64];
	char *p, *e;
	int fd;

	e = buf + sizeof(buf);
	p = buf;
	p = seprint(p, e, "ip=%I ipmask=255.255.255.255 ipgw=%I\n", ppp-&gt;local,
			ppp-&gt;remote);
	if(validv4(ppp-&gt;dns[0]))
		p = seprint(p, e, "\tdns=%I\n", ppp-&gt;dns[0]);
	if(validv4(ppp-&gt;dns[1]))
		p = seprint(p, e, "\tdns=%I\n", ppp-&gt;dns[1]);
	if(validv4(ppp-&gt;wins[0]))
		p = seprint(p, e, "\twins=%I\n", ppp-&gt;wins[0]);
	if(validv4(ppp-&gt;wins[1]))
		p = seprint(p, e, "\twins=%I\n", ppp-&gt;wins[1]);
	seprint(file, file+sizeof file, "%s/ndb", net);
	fd = open(file, OWRITE);
	if(fd &lt; 0)
		return;
	write(fd, buf, p-buf);
	close(fd);
	seprint(file, file+sizeof file, "%s/cs", net);
	fd = open(file, OWRITE);
	write(fd, "refresh", 7);
	close(fd);
	seprint(file, file+sizeof file, "%s/dns", net);
	fd = open(file, OWRITE);
	write(fd, "refresh", 7);
	close(fd);
}

static void
getauth(PPP *ppp)
{
	UserPasswd *up;

	if(*ppp-&gt;chapname)
		return;

	up = auth_getuserpasswd(auth_getkey,"proto=pass service=ppp %s", keyspec);
	if(up != nil){
		strcpy(ppp-&gt;chapname, up-&gt;user);
		strcpy(ppp-&gt;secret, up-&gt;passwd);
	}		
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

