<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/eap.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/eap.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr	Hdr;
struct Hdr
{
	uchar	code;
	uchar	id;
	uchar	len[2];	/* length including this header */

	uchar	tp;	/* optional, only for Request/Response */
};

enum
{
	EAPHDR=	4,	/* sizeof(code)+sizeof(id)+sizeof(len) */
	TPHDR= 1,	/* sizeof(tp) */

	/* eap types */
	Request = 1,
	Response,
	Success,
	Fail,

	/* eap request/response sub-types */
	Identity = 1,		/* Identity */
	Notify,		/* Notification */
	Nak,			/* Nak (Response only) */
	Md5,		/* MD5-challenge */
	Otp,			/* one time password */
	Gtc,			/* generic token card */
	Ttls = 21,		/* tunneled TLS */
	Xpnd = 254,	/* expanded types */
	Xprm,		/* experimental use */
};

enum
{
	Ot,
};

static Mux p_mux[] =
{
	{ "eap_identity", Identity, },
	{ "eap_notify", Notify, },
	{ "eap_nak", Nak, },
	{ "eap_md5", Md5, },
	{ "eap_otp", Otp, },
	{ "eap_gtc", Gtc, },
	{ "ttls", Ttls, },
	{ "eap_xpnd", Xpnd, },
	{ "eap_xprm", Xprm, }, 
	{ 0 }
};

static char *eapsubtype[256] =
{
[Identity]	"Identity",
[Notify]	"Notify",
[Nak]		"Nak",
[Md5]	"Md5",
[Otp]		"Otp",
[Gtc]		"Gtc",
[Ttls]		"Ttls",
[Xpnd]	"Xpnd",
[Xprm]	"Xprm",
};


static void
p_compile(Filter *f)
{
	Mux *m;

	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Ot;
			return;
		}
	sysfatal("unknown eap field or type: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;
	int len;

	if(f-&gt;subop != Ot)
		return 0;

	if(m-&gt;pe - m-&gt;ps &lt; EAPHDR)
		return -1;

	h = (Hdr*)m-&gt;ps;

	/* truncate the message if there's extra */
	/* len includes header */
	len = NetS(h-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;
	m-&gt;ps += EAPHDR;

	if(h-&gt;code != Request &amp;&amp; h-&gt;code != Response)
		return 0;
	m-&gt;ps += TPHDR;

	if(h-&gt;tp == f-&gt;ulv)
		return 1;

	return 0;
}

static char*
op(int i)
{
	static char x[20];

	switch(i){
	case Request:
		return "Request";
	case Response:
		return "Response";
	case Success:
		return "Success";
	case Fail:
		return "Fail";
	default:
		sprint(x, "%1d", i);
		return x;
	}
}

static char*
subop(uchar val)
{
	static char x[20], *p;

	p = eapsubtype[val];
	if(p != nil)
		return p;
	else {
		sprint(x, "%1d", val);
		return x;
	}
}

static int
p_seprint(Msg *m)
{
	Hdr *h;
	int len;
	char *p, *e;

	if(m-&gt;pe - m-&gt;ps &lt; EAPHDR)
		return -1;

	p = m-&gt;p;
	e = m-&gt;e;
	h = (Hdr*)m-&gt;ps;

	/* resize packet (should already be done by eapol) */
	/* len includes header */
	len = NetS(h-&gt;len);
	if(m-&gt;ps+len &lt; m-&gt;pe)
		m-&gt;pe = m-&gt;ps+len;
	else if(m-&gt;ps+len &gt; m-&gt;pe)
		return -1;
	m-&gt;ps += EAPHDR;

	p = seprint(p, e, "id=%1d code=%s", h-&gt;id, op(h-&gt;code));
	switch(h-&gt;code) {
	case Request:
	case Response:
		m-&gt;ps += TPHDR;
		p = seprint(p, e, " type=%s", subop(h-&gt;tp));
		/* special case needed to print eap_notify notification as unicode */
		demux(p_mux, h-&gt;tp, h-&gt;tp, m, &amp;dump);
		break;
	default:
		demux(p_mux, 0, 0, m, &amp;dump);
		break;
	}
	m-&gt;p = seprint(p, e, " len=%1d", len);
	return 0;
}

static int
p_seprintidentity(Msg *m)
{
	char *ps, *pe, *z;
	int len;

	m-&gt;pr = nil;
	ps = (char*)m-&gt;ps;
	pe = (char*)m-&gt;pe;

	/* we would like to do this depending on the 'context':
	 *  - one for eap_identity request and
	 *  - one for eap_identity response
	 * but we've lost the context, or haven't we?
	 * so we treat them the same, so we might erroneously
	 * print a response as if it was a request. too bad. - axel
	 */
	for (z=ps; *z != '\0' &amp;&amp; z+1 &lt; pe; z++)
		;
	if (*z == '\0' &amp;&amp; z+1 &lt; pe) {
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, "prompt=(%s)", ps);
		len = pe - (z+1);
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " options=(%.*s)", len, z+1);
	} else {
		len = pe - ps;
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, "%.*s", len, ps);
	}
	return 0;
}

Proto eap =
{
	"eap",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	nil,
	defaultframer,
};

Proto eap_identity =
{
	"eap_identity",
	p_compile,
	p_filter,
	p_seprintidentity,
	nil,
	nil,
	nil,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

