<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/eapol_key.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/eapol_key.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr
{
	uchar	desc;
} Hdr;

typedef struct Rc4KeyDesc
{
	uchar	ln[2];
	uchar	replay[8];
	uchar	iv[16];
	uchar	idx;
	uchar	md[16];
} Rc4KeyDesc;

enum
{
	HDR=	1,		/* sizeof(Hdr) */
	RC4KEYDESC=	43,	/* sizeof(Rc4KeyDesc) */

	DescTpRC4= 1,
};

enum
{
	Odesc,
};

static Mux p_mux[] =
{
	{ "rc4keydesc", DescTpRC4, },
	{ 0 }
};

static Mux p_muxrc4[] =
{
	{ "dump", 0, },
	{ 0 }
};

static void
p_compile(Filter *f)
{
	Mux *m;

	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Odesc;
			return;
		}
	sysfatal("unknown eap_key field or type: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; HDR)
		return 0;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += HDR;

	switch(f-&gt;subop){
	case Odesc:
		return h-&gt;desc == f-&gt;ulv;
	}
	return 0;
}

static char*
op(int i)
{
	static char x[20];

	switch(i){
	case DescTpRC4:
		return "RC4KeyDesc";
	default:
		sprint(x, "%1d", i);
		return x;
	}
}

static int
p_seprint(Msg *m)
{
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; HDR)
		return -1;

	h = (Hdr*)m-&gt;ps;
	m-&gt;ps += HDR;

	/* next protocol  depending on type*/
	demux(p_mux, h-&gt;desc, h-&gt;desc, m, &amp;dump);

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "desc=%s", op(h-&gt;desc));
	return 0;
}

static int
p_seprintrc4(Msg *m)
{
	Rc4KeyDesc *h;
	int len;

	if(m-&gt;pe - m-&gt;ps &lt; RC4KEYDESC)
		return -1;

	h = (Rc4KeyDesc*)m-&gt;ps;
	m-&gt;ps += RC4KEYDESC;
	m-&gt;pr = nil;
	len = m-&gt;pe - m-&gt;ps;

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "keylen=%1d replay=%1d iv=%1d idx=%1d md=%1d",
			NetS(h-&gt;ln), NetS(h-&gt;replay), NetS(h-&gt;iv), h-&gt;idx, NetS(h-&gt;md));
	m-&gt;p = seprint(m-&gt;p, m-&gt;e, " dataln=%d", len);
	if (len &gt; 0)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " data=%.*H", len, m-&gt;ps);
	return 0;
}

Proto eapol_key =
{
	"eapol_key",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	nil,
	defaultframer,
};

Proto rc4keydesc =
{
	"rc4keydesc",
	p_compile,
	nil,
	p_seprintrc4,
	nil,
	nil,
	nil,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

