<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/gre.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/gre.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

/*
 GRE version 0 is specified in rfc1701.
 GRE version 0 has been respecified in rfc2784 as a subset of rfc1701.
 GRE version 1, as used by pptp, has been specified in rfc2637.
*/


/* GRE flag bits */
enum {
	GRE_chksum	= (1&lt;&lt;15),
	GRE_routing	= (1&lt;&lt;14),
	GRE_key		= (1&lt;&lt;13),
	GRE_seq		= (1&lt;&lt;12),
	GRE_srcrt		= (1&lt;&lt;11),
	GRE_recur	= (7&lt;&lt;8),
	GRE_ack		= (1&lt;&lt;7),
	GRE_version	= 0x7,
};


typedef struct Hdr	Hdr;
struct Hdr
{
	ushort flags;
	ushort proto;
	uchar version;
	ushort chksum;
	ushort offset;
	ulong key;
	ulong seq;
	ulong route;
	ulong ack;
};

enum
{
	Oproto,
};

static Field p_fields[] = 
{
	{"proto",		Fnum,	Oproto,	"encapsulated protocol",	} ,
	{0}
};

static Mux p_mux[] =
{
	{"pup",	0x0200, },
	{"xns",	0x0600, },
	{"ip",		0x0800, },
	{"chaos",	0x0804, },
	{"arp",	0x0806, },
	{"frarp",	0x0808, },
	{"vines",	0x0bad, },
	{"vinesecho",	0x0bae, },
	{"vinesloop",	0x0baf, },
	{"ppp",	0x880b, },
	{"llc",	0x007a, },
	{"dot1q",	0x8100, },
	{"eapol",	0x888e, },
	{0},
};

int
parthdrlen(ushort flags)
{
	return 4 + 
		(flags&amp;GRE_chksum || flags&amp;GRE_routing) ? 4 : 0 +
		flags&amp;GRE_key ? 4 : 0 +
		flags&amp;GRE_seq ? 4 : 0 +
		flags&amp;GRE_ack ? 4 : 0;
}

int
parsehdr(Hdr *h, uchar *s, uchar *e)
{
	uchar *p;
	uchar n;

	if(e - s &lt; 4)
		return -1;

	p = s;

	h-&gt;flags = NetS(p);
	p += 2;
	h-&gt;proto = NetS(p);
	p += 2;
	h-&gt;version = h-&gt;flags&amp;GRE_version;

	if(parthdrlen(h-&gt;flags) &gt; e - s)
		return -1;

	if(h-&gt;flags&amp;(GRE_chksum|GRE_routing)){
		h-&gt;chksum = NetS(p);
		p += 2;
		h-&gt;offset = NetS(p);
		p += 2;
	}
	if(h-&gt;flags&amp;GRE_key){
		h-&gt;key = NetL(p);
		p += 4;
	}
	if(h-&gt;flags&amp;GRE_seq){
		h-&gt;seq = NetL(p);
		p += 4;
	}
	if(h-&gt;flags&amp;GRE_ack){
		h-&gt;ack = NetL(p);
		p += 4;
	}
	if(h-&gt;flags&amp;GRE_routing){
		for(;;){
			if(e - p &lt; 4)
				return -1;
			if((n = p[3]) == 0)
				break;
			p += n;
		}
	}

	return p - s;
}

static void
p_compile(Filter *f)
{
	Mux *m;

	if(f-&gt;op == '='){
		compile_cmp(gre.name, f, p_fields);
		return;
	}
	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Oproto;
			return;
		}
	sysfatal("unknown gre field or protocol: %s", f-&gt;s);
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr h;
	int len;

	len = parsehdr(&amp;h, m-&gt;ps, m-&gt;pe);
	if(len &lt; 0)
		return -1;
	m-&gt;ps += len;

	switch(f-&gt;subop){
	case Oproto:
		return h.proto == f-&gt;ulv;
	}
	return 0;
}

static int
p_seprint(Msg *m)
{
	Hdr h;
	int len;

	len = parsehdr(&amp;h, m-&gt;ps, m-&gt;pe);
	if(len &lt; 0)
		return -1;
	m-&gt;ps += len;

	demux(p_mux, h.proto, h.proto, m, &amp;dump);

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "version=%d proto=%#ux flags=%#.4ux", h.version, h.proto, h.flags);
	if(h.flags&amp;GRE_chksum)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " checksum=%#.4ux", h.chksum);
	if(h.flags&amp;GRE_key)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " key=%#.8ulx", h.key);
	if(h.flags&amp;GRE_seq)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " seq=%#.8ulx", h.seq);
	if(h.flags&amp;GRE_ack)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " ack=%#.8ulx", h.ack);
	if(h.flags&amp;GRE_routing)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " offset=%#ux haverouting", h.offset);
	if(h.version == 0)
		m-&gt;p = seprint(m-&gt;p, m-&gt;e, " recursion=%ud", (h.flags&amp;GRE_recur)&gt;&gt;8);
	
	return 0;
}

Proto gre =
{
	"gre",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%#.4ux",
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

