<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/snoopy/ip6.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/snoopy/ip6.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dat.h"
#include "protos.h"

typedef struct Hdr	Hdr;
struct Hdr
{
	uchar	vcf[4];			/* Version and header length */
	uchar	length[2];		/* packet length */
	uchar	proto;			/* Protocol */
	uchar	ttl;			/* Time to live */
	uchar	src[IPaddrlen];		/* IP source */
	uchar	dst[IPaddrlen];		/* IP destination */
};

enum
{
	IP6HDR		= 40,		/* sizeof(Iphdr) */
	IP_VER		= 0x60,		/* Using IP version 4 */
	HBH_HDR		= 0,
	ROUT_HDR	= 43,
	FRAG_HDR	= 44,
	FRAG_HSZ	= 8, 		/* in bytes */
	DEST_HDR	= 60,
};

static Mux p_mux[] =
{
	{ "igmp", 2, },
	{ "ggp", 3, },
	{ "ip", 4, },
	{ "st", 5, },
	{ "tcp", 6, },
	{ "ucl", 7, },
	{ "egp", 8, },
	{ "igp", 9, },
	{ "bbn-rcc-mon", 10, },
	{ "nvp-ii", 11, },
	{ "pup", 12, },
	{ "argus", 13, },
	{ "emcon", 14, },
	{ "xnet", 15, },
	{ "chaos", 16, },
	{ "udp", 17, },
	{ "mux", 18, },
	{ "dcn-meas", 19, },
	{ "hmp", 20, },
	{ "prm", 21, },
	{ "xns-idp", 22, },
	{ "trunk-1", 23, },
	{ "trunk-2", 24, },
	{ "leaf-1", 25, },
	{ "leaf-2", 26, },
	{ "rdp", 27, },
	{ "irtp", 28, },
	{ "iso-tp4", 29, },
	{ "netblt", 30, },
	{ "mfe-nsp", 31, },
	{ "merit-inp", 32, },
	{ "sep", 33, },
	{ "3pc", 34, },
	{ "idpr", 35, },
	{ "xtp", 36, },
	{ "ddp", 37, },
	{ "idpr-cmtp", 38, },
	{ "tp++", 39, },
	{ "il", 40, },
	{ "sip", 41, },
	{ "sdrp", 42, },
	{ "idrp", 45, },
	{ "rsvp", 46, },
	{ "gre", 47, },
	{ "mhrp", 48, },
	{ "bna", 49, },
	{ "sipp-esp", 50, },
	{ "sipp-ah", 51, },
	{ "i-nlsp", 52, },
	{ "swipe", 53, },
	{ "nhrp", 54, },
	{ "icmp6", 58, },
	{ "any", 61, },
	{ "cftp", 62, },
	{ "any", 63, },
	{ "sat-expak", 64, },
	{ "kryptolan", 65, },
	{ "rvd", 66, },
	{ "ippc", 67, },
	{ "any", 68, },
	{ "sat-mon", 69, },
	{ "visa", 70, },
	{ "ipcv", 71, },
	{ "cpnx", 72, },
	{ "cphb", 73, },
	{ "wsn", 74, },
	{ "pvp", 75, },
	{ "br-sat-mon", 76, },
	{ "sun-nd", 77, },
	{ "wb-mon", 78, },
	{ "wb-expak", 79, },
	{ "iso-ip", 80, },
	{ "vmtp", 81, },
	{ "secure-vmtp", 82, },
	{ "vines", 83, },
	{ "ttp", 84, },
	{ "nsfnet-igp", 85, },
	{ "dgp", 86, },
	{ "tcf", 87, },
	{ "igrp", 88, },
	{ "ospf", 89, },
	{ "sprite-rpc", 90, },
	{ "larp", 91, },
	{ "mtp", 92, },
	{ "ax.25", 93, },
	{ "ipip", 94, },
	{ "micp", 95, },
	{ "scc-sp", 96, },
	{ "etherip", 97, },
	{ "encap", 98, },
	{ "any", 99, },
	{ "gmtp", 100, },
	{ "rudp", 254, },
	{ 0 }
};

enum
{
	Os,	/* source */
	Od,	/* destination */
	Osd,	/* source or destination */
	Ot,	/* type */
};

static Field p_fields[] =
{
	{"s",	Fv6ip,	Os,	"source address",	} ,
	{"d",	Fv6ip,	Od,	"destination address",	} ,
	{"a",	Fv6ip,	Osd,	"source|destination address",} ,
	{"t",	Fnum,	Ot,	"sub protocol number",	} ,
	{0}
};

static void
p_compile(Filter *f)
{
	Mux *m;

	if(f-&gt;op == '='){
		compile_cmp(ip6.name, f, p_fields);
		return;
	}
	for(m = p_mux; m-&gt;name != nil; m++)
		if(strcmp(f-&gt;s, m-&gt;name) == 0){
			f-&gt;pr = m-&gt;pr;
			f-&gt;ulv = m-&gt;val;
			f-&gt;subop = Ot;
			return;
		}
	sysfatal("unknown ip6 field or protocol: %s", f-&gt;s);
}

static int
v6hdrlen(Hdr *h)
{
	int plen, len = IP6HDR;
	int pktlen = IP6HDR + NetS(h-&gt;length);
	uchar nexthdr = h-&gt;proto;
	uchar *pkt = (uchar*) h;

	pkt += len;
	plen = len;

	while (nexthdr == HBH_HDR || nexthdr == ROUT_HDR ||
	    nexthdr == FRAG_HDR || nexthdr == DEST_HDR) {
		if (nexthdr == FRAG_HDR)
			len = FRAG_HSZ;
		else
			len = ((int)*(pkt+1) + 1) * 8;

		if (plen + len &gt; pktlen)
			return -1;

		pkt += len;
		nexthdr = *pkt;
		plen += len;
	}
	return plen;
}

static int
p_filter(Filter *f, Msg *m)
{
	Hdr *h;
	int hlen;

	if(m-&gt;pe - m-&gt;ps &lt; IP6HDR)
		return 0;

	h = (Hdr*)m-&gt;ps;

	if ((hlen = v6hdrlen(h)) &lt; 0)
		return 0;
	else
		m-&gt;ps += hlen;
	switch(f-&gt;subop){
	case Os:
		return memcmp(h-&gt;src, f-&gt;a, IPaddrlen) == 0;
	case Od:
		return memcmp(h-&gt;dst, f-&gt;a, IPaddrlen) == 0;
	case Osd:
		return memcmp(h-&gt;src, f-&gt;a, IPaddrlen) == 0 ||
			memcmp(h-&gt;dst, f-&gt;a, IPaddrlen) == 0;
	case Ot:
		return h-&gt;proto == f-&gt;ulv;
	}
	return 0;
}

static int
v6hdr_seprint(Msg *m)
{
	int plen, len = IP6HDR;
	uchar *pkt = m-&gt;ps;
	Hdr *h = (Hdr *)pkt;
	int pktlen = IP6HDR + NetS(h-&gt;length);
	uchar nexthdr = h-&gt;proto;

	pkt += len;
	plen = len;

	while (nexthdr == HBH_HDR || nexthdr == ROUT_HDR ||
	    nexthdr == FRAG_HDR || nexthdr == DEST_HDR) {
		switch (nexthdr) {
		case FRAG_HDR:
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, "\n	  xthdr=frag id=%d "
				"offset=%d pr=%d more=%d res1=%d res2=%d",
				NetL(pkt+4), NetS(pkt+2) &amp; ~7, (int)*pkt,
				(int)(*(pkt+3) &amp; 0x1), (int)*(pkt+1),
				(int)(*(pkt+3) &amp; 0x6));
			len = FRAG_HSZ;
			break;

		case HBH_HDR:
		case ROUT_HDR:
		case DEST_HDR:
			len = ((int)*(pkt+1) + 1) * 8;
			break;
		}

		if (plen + len &gt; pktlen) {
			m-&gt;p = seprint(m-&gt;p, m-&gt;e, "bad pkt");
			m-&gt;pr = &amp;dump;
			return -1;
		}
		plen += len;
		pkt += len;
		nexthdr = *pkt;
	}

	m-&gt;ps = pkt;
	return 1;
}

static int
p_seprint(Msg *m)
{
	int len;
	Hdr *h;

	if(m-&gt;pe - m-&gt;ps &lt; IP6HDR)
		return -1;
	h = (Hdr*)m-&gt;ps;

	demux(p_mux, h-&gt;proto, h-&gt;proto, m, &amp;dump);

	/* truncate the message if there's extra */
	len = NetS(h-&gt;length) + IP6HDR;
	if(len &lt; m-&gt;pe - m-&gt;ps)
		m-&gt;pe = m-&gt;ps + len;

	m-&gt;p = seprint(m-&gt;p, m-&gt;e, "s=%I d=%I ttl=%3d pr=%d ln=%d",
		h-&gt;src, h-&gt;dst, h-&gt;ttl, h-&gt;proto, NetS(h-&gt;length));
	v6hdr_seprint(m);
	return 0;
}

Proto ip6 =
{
	"ip6",
	p_compile,
	p_filter,
	p_seprint,
	p_mux,
	"%lud",
	p_fields,
	defaultframer,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

