<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/join.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/join.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*	join F1 F2 on stuff */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;

enum {
	F1,
	F2,
	NIN,
	F0,
};

#define	NFLD	100	/* max field per line */
#define comp() runestrcmp(ppi[F1][j1], ppi[F2][j2])

Biobuf *f[NIN];
Rune buf[NIN][Bsize];	/* input lines */
Rune *ppi[NIN][NFLD+1];	/* pointers to fields in lines */
Rune	sep1	= ' ';	/* default field separator */
Rune	sep2	= '\t';
int	j1	= 1;	/* join of this field of file 1 */
int	j2	= 1;	/* join of this field of file 2 */
int	a1;
int 	a2;

int	olist[NIN*NFLD];  /* output these fields */
int	olistf[NIN*NFLD]; /* from these files */
int	no;		/* number of entries in olist */
char *sepstr	= " ";
int	discard;	/* count of truncated lines */
Rune	null[Bsize]	= L"";
Biobuf binbuf, boutbuf;
Biobuf *bin, *bout;

char	*getoptarg(int*, char***);
int	input(int);
void	join(int);
void	oparse(char*);
void	output(int, int);
Rune	*strtorune(Rune *, char *);

void
main(int argc, char **argv)
{
	int i;
	vlong off1, off2;

	bin = &amp;binbuf;
	bout = &amp;boutbuf;
	Binit(bin, 0, OREAD);
	Binit(bout, 1, OWRITE);

	argv0 = argv[0];
	while (argc &gt; 1 &amp;&amp; argv[1][0] == '-') {
		if (argv[1][1] == '\0')
			break;
		switch (argv[1][1]) {
		case '-':
			argc--;
			argv++;
			goto proceed;
		case 'a':
			switch(*getoptarg(&amp;argc, &amp;argv)) {
			case '1':
				a1++;
				break;
			case '2':
				a2++;
				break;
			default:
				sysfatal("incomplete option -a");
			}
			break;
		case 'e':
			strtorune(null, getoptarg(&amp;argc, &amp;argv));
			break;
		case 't':
			sepstr=getoptarg(&amp;argc, &amp;argv);
			chartorune(&amp;sep1, sepstr);
			sep2 = sep1;
			break;
		case 'o':
			if(argv[1][2]!=0 ||
			   argc&gt;2 &amp;&amp; strchr(argv[2],',')!=0)
				oparse(getoptarg(&amp;argc, &amp;argv));
			else for (no = 0; no&lt;2*NFLD &amp;&amp; argc&gt;2; no++){
				if (argv[2][0] == '1' &amp;&amp; argv[2][1] == '.') {
					olistf[no] = F1;
					olist[no] = atoi(&amp;argv[2][2]);
				} else if (argv[2][0] == '2' &amp;&amp; argv[2][1] == '.') {
					olist[no] = atoi(&amp;argv[2][2]);
					olistf[no] = F2;
				} else if (argv[2][0] == '0')
					olistf[no] = F0;
				else
					break;
				argc--;
				argv++;
			}
			break;
		case 'j':
			if(argc &lt;= 2)
				break;
			if (argv[1][2] == '1')
				j1 = atoi(argv[2]);
			else if (argv[1][2] == '2')
				j2 = atoi(argv[2]);
			else
				j1 = j2 = atoi(argv[2]);
			argc--;
			argv++;
			break;
		case '1':
			j1 = atoi(getoptarg(&amp;argc, &amp;argv));
			break;
		case '2':
			j2 = atoi(getoptarg(&amp;argc, &amp;argv));
			break;
		}
		argc--;
		argv++;
	}
proceed:
	for (i = 0; i &lt; no; i++)
		if (olist[i]-- &gt; NFLD)	/* 0 origin */
			sysfatal("field number too big in -o");
	if (argc != 3) {
		fprint(2, "usage: join [-1 x -2 y] [-o list] file1 file2\n");
		exits("usage");
	}
	if (j1 &lt; 1  || j2 &lt; 1)
		sysfatal("invalid field indices");
	j1--;
	j2--;	/* everyone else believes in 0 origin */

	if (strcmp(argv[1], "-") == 0)
		f[F1] = bin;
	else if ((f[F1] = Bopen(argv[1], OREAD)) == 0)
		sysfatal("can't open %s: %r", argv[1]);
	if(strcmp(argv[2], "-") == 0)
		f[F2] = bin;
	else if ((f[F2] = Bopen(argv[2], OREAD)) == 0)
		sysfatal("can't open %s: %r", argv[2]);

	off1 = Boffset(f[F1]);
	off2 = Boffset(f[F2]);
	if(Bseek(f[F2], 0, 2) &gt;= 0){
		Bseek(f[F2], off2, 0);
		join(F2);
	}else if(Bseek(f[F1], 0, 2) &gt;= 0){
		Bseek(f[F1], off1, 0);
		Bseek(f[F2], off2, 0);
		join(F1);
	}else
		sysfatal("neither file is randomly accessible");
	if (discard)
		sysfatal("some input line was truncated");
	exits("");
}

char *
runetostr(char *buf, Rune *r)
{
	char *s;

	for(s = buf; *r; r++)
		s += runetochar(s, r);
	*s = '\0';
	return buf;
}

Rune *
strtorune(Rune *buf, char *s)
{
	Rune *r;

	for (r = buf; *s; r++)
		s += chartorune(r, s);
	*r = '\0';
	return buf;
}

void
readboth(int n[])
{
	n[F1] = input(F1);
	n[F2] = input(F2);
}

void
seekbotreadboth(int seekf, vlong bot, int n[])
{
	Bseek(f[seekf], bot, 0);
	readboth(n);
}

void
join(int seekf)
{
	int cmp, less;
	int n[NIN];
	vlong top, bot;

	less = seekf == F2;
	top = 0;
	bot = Boffset(f[seekf]);
	readboth(n);
	while(n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 || (a1||a2) &amp;&amp; n[F1]+n[F2]&gt;0) {
		cmp = comp();
		if(n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp; cmp&gt;0 || n[F1]==0) {
			if(a2)
				output(0, n[F2]);
			if (seekf == F2)
				bot = Boffset(f[seekf]);
			n[F2] = input(F2);
		} else if(n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp; cmp&lt;0 || n[F2]==0) {
			if(a1)
				output(n[F1], 0);
			if (seekf == F1)
				bot = Boffset(f[seekf]);
			n[F1] = input(F1);
		} else {
			/* n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp; cmp==0 */
			while(n[F2]&gt;0 &amp;&amp; cmp==0) {
				output(n[F1], n[F2]);
				top = Boffset(f[seekf]);
				n[seekf] = input(seekf);
				cmp = comp();
			}
			seekbotreadboth(seekf, bot, n);
			for(;;) {
				cmp = comp();
				if(n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp; cmp==0) {
					output(n[F1], n[F2]);
					n[seekf] = input(seekf);
				} else if(n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp;
				    (less? cmp&lt;0 :cmp&gt;0) || n[seekf]==0)
					seekbotreadboth(seekf, bot, n);
				else {
					/*
					 * n[F1]&gt;0 &amp;&amp; n[F2]&gt;0 &amp;&amp;
					 * (less? cmp&gt;0 :cmp&lt;0) ||
					 * n[seekf==F1? F2: F1]==0
					 */
					Bseek(f[seekf], top, 0);
					bot = top;
					n[seekf] = input(seekf);
					break;
				}
			}
		}
	}
}

int
input(int n)		/* get input line and split into fields */
{
	int c, i, len;
	char *line;
	Rune *bp;
	Rune **pp;

	bp = buf[n];
	pp = ppi[n];
	line = Brdline(f[n], '\n');
	if (line == nil)
		return(0);
	len = Blinelen(f[n]) - 1;
	c = line[len];
	line[len] = '\0';
	strtorune(bp, line);
	line[len] = c;			/* restore delimiter */
	if (c != '\n')
		discard++;

	i = 0;
	do {
		i++;
		if (sep1 == ' ')	/* strip multiples */
			while ((c = *bp) == sep1 || c == sep2)
				bp++;	/* skip blanks */
		*pp++ = bp;		/* record beginning */
		while ((c = *bp) != sep1 &amp;&amp; c != sep2 &amp;&amp; c != '\0')
			bp++;
		*bp++ = '\0';		/* mark end by overwriting blank */
	} while (c != '\0' &amp;&amp; i &lt; NFLD-1);

	*pp = 0;
	return(i);
}

void
prfields(int f, int on, int jn)
{
	int i;
	char buf[Bsize];

	for (i = 0; i &lt; on; i++)
		if (i != jn)
			Bprint(bout, "%s%s", sepstr, runetostr(buf, ppi[f][i]));
}

void
output(int on1, int on2)	/* print items from olist */
{
	int i;
	Rune *temp;
	char buf[Bsize];

	if (no &lt;= 0) {	/* default case */
		Bprint(bout, "%s", runetostr(buf, on1? ppi[F1][j1]: ppi[F2][j2]));
		prfields(F1, on1, j1);
		prfields(F2, on2, j2);
		Bputc(bout, '\n');
	} else {
		for (i = 0; i &lt; no; i++) {
			if (olistf[i]==F0 &amp;&amp; on1&gt;j1)
				temp = ppi[F1][j1];
			else if (olistf[i]==F0 &amp;&amp; on2&gt;j2)
				temp = ppi[F2][j2];
			else {
				temp = ppi[olistf[i]][olist[i]];
				if(olistf[i]==F1 &amp;&amp; on1&lt;=olist[i] ||
				   olistf[i]==F2 &amp;&amp; on2&lt;=olist[i] ||
				   *temp==0)
					temp = null;
			}
			Bprint(bout, "%s", runetostr(buf, temp));
			if (i == no - 1)
				Bputc(bout, '\n');
			else
				Bprint(bout, "%s", sepstr);
		}
	}
}

char *
getoptarg(int *argcp, char ***argvp)
{
	int argc = *argcp;
	char **argv = *argvp;
	if(argv[1][2] != 0)
		return &amp;argv[1][2];
	if(argc&lt;=2 || argv[2][0]=='-')
		sysfatal("incomplete option %s", argv[1]);
	*argcp = argc-1;
	*argvp = ++argv;
	return argv[1];
}

void
oparse(char *s)
{
	for (no = 0; no&lt;2*NFLD &amp;&amp; *s; no++, s++) {
		switch(*s) {
		case 0:
			return;
		case '0':
			olistf[no] = F0;
			break;
		case '1':
		case '2':
			if(s[1] == '.' &amp;&amp; isdigit(s[2])) {
				olistf[no] = *s=='1'? F1: F2;
				olist[no] = atoi(s += 2);
				break;
			}
			/* fall thru */
		default:
			sysfatal("invalid -o list");
		}
		if(s[1] == ',')
			s++;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

