<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/png.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/png.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;
#include "imagefile.h"

extern int	debug;
int	cflag = 0;
int	dflag = 0;
int	eflag = 0;
int	nineflag = 0;
int	threeflag = 0;
int	colorspace = CRGB;
int	output = 0;
ulong	outchan = CMAP8;
Image	*image;
int	defaultcolor = 1;

enum{
	Border	= 2,
	Edge	= 5
};

char	*show(int, char*, int);

void
eresized(int new)
{
	Rectangle r;

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0){
		fprint(2, "png: can't reattach to window\n");
		exits("resize");
	}
	if(image == nil)
		return;
	r = insetrect(screen-&gt;clipr, Edge+Border);
	r.max.x = r.min.x+Dx(image-&gt;r);
	r.max.y = r.min.y+Dy(image-&gt;r);
	border(screen, r, -Border, nil, ZP);
	draw(screen, r, image, nil, image-&gt;r.min);
	flushimage(display, 1);
}

void
main(int argc, char *argv[])
{
	int fd, i;
	char *err;
	char buf[12+1];

	ARGBEGIN{
	case 'c':		/* produce encoded, compressed, bitmap file; no display by default */
		cflag++;
		dflag++;
		output++;
		if(defaultcolor)
			outchan = CMAP8;
		break;
	case 'D':
		debug++;
		break;
	case 'd':		/* suppress display of image */
		dflag++;
		break;
	case 'e':		/* disable floyd-steinberg error diffusion */
		eflag++;
		break;
	case 'k':		/* force black and white */
		defaultcolor = 0;
		outchan = GREY8;
		break;
	case 'r':
		colorspace = CRGB;
		break;
	case '3':		/* produce encoded, compressed, three-color bitmap file; no display by default */
		threeflag++;
		/* fall through */
	case 't':		/* produce encoded, compressed, true-color bitmap file; no display by default */
		cflag++;
		dflag++;
		output++;
		defaultcolor = 0;
		outchan = RGB24;
		break;
	case 'v':		/* force RGBV */
		defaultcolor = 0;
		outchan = CMAP8;
		break;
	case '9':		/* produce plan 9, uncompressed, bitmap file; no display by default */
		nineflag++;
		dflag++;
		output++;
		if(defaultcolor)
			outchan = CMAP8;
		break;
	default:
		fprint(2, "usage: png [-39cdekrtv] [file.png ...]\n");
		exits("usage");
	}ARGEND;

	if(dflag==0 &amp;&amp; colorspace==CYCbCr){	/* see if we should convert right to RGB */
		fd = open("/dev/screen", OREAD);
		if(fd &gt; 0){
			buf[12] = '\0';
			if(read(fd, buf, 12)==12 &amp;&amp; chantodepth(strtochan(buf))&gt;8)
				colorspace = CRGB;
			close(fd);
		}
	}

	err = nil;
	if(argc == 0)
		err = show(0, "&lt;stdin&gt;", outchan);
	else{
		for(i=0; i&lt;argc; i++){
			fd = open(argv[i], OREAD);
			if(fd &lt; 0){
				fprint(2, "png: can't open %s: %r\n", argv[i]);
				err = "open";
			}else{
				err = show(fd, argv[i], outchan);
				close(fd);
			}
			if((nineflag || cflag) &amp;&amp; argc&gt;1 &amp;&amp; err==nil){
				fprint(2, "png: exiting after one file\n");
				break;
			}
		}
	}
	exits(err);
}

char*
show(int fd, char *name, int outc)
{
	Rawimage **array, *r, *c;
	Image *i, *i2;
	int j, ch, outchan;
	long len;
	Biobuf b;
	char buf[32];
	static int inited;

	if(Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	outchan = outc;
	array = Breadpng(&amp;b, colorspace);
	if(array == nil || array[0]==nil){
		fprint(2, "png: decode %s failed: %r\n", name);
		return "decode";
	}
	Bterm(&amp;b);

	r = array[0];
	if(!dflag){
		if (!inited) {
			if(initdraw(0, 0, 0) &lt; 0){
				fprint(2, "png: initdraw failed: %r\n");
				return "initdraw";
			}
			einit(Ekeyboard|Emouse);
			inited++;
		}
		if(defaultcolor &amp;&amp; screen-&gt;depth&gt;8 &amp;&amp; outchan==CMAP8)
			outchan = RGB24;
	}
	if(outchan == CMAP8)
		c = torgbv(r, !eflag);
	else{
		switch(r-&gt;chandesc){
		case CY:
			outchan = GREY8;
			break;
		case CYA16:
			outchan = CHAN2(CGrey, 8, CAlpha, 8);
			break;
		case CRGB24:
			outchan = RGB24;
			break;
		case CRGBA32:
			outchan = RGBA32;
			break;
		}
		c = r;
	}
	if(c == nil){
		fprint(2, "png: conversion of %s failed: %r\n", name);
		return "torgbv";
	}
	if(!dflag){
		i = allocimage(display, c-&gt;r, outchan, 0, 0);
		if(i == nil){
			fprint(2, "png: allocimage %s failed: %r\n", name);
			return "allocimage";
		}
		if(loadimage(i, i-&gt;r, c-&gt;chans[0], c-&gt;chanlen) &lt; 0){
			fprint(2, "png: loadimage %s of %d bytes failed: %r\n",
				name, c-&gt;chanlen);
			return "loadimage";
		}
		i2 = allocimage(display, c-&gt;r, outchan, 0, 0);
		draw(i2, i2-&gt;r, display-&gt;black, nil, ZP);
		draw(i2, i2-&gt;r, i, nil, i-&gt;r.min);
		image = i2;
		eresized(0);
		if((ch=ekbd())=='q' || ch==0x7F || ch==0x04)
			exits(nil);
		draw(screen, screen-&gt;clipr, display-&gt;white, nil, ZP);
		image = nil;
		freeimage(i);
	}
	if(nineflag){
		chantostr(buf, outchan);
		len = (c-&gt;r.max.x - c-&gt;r.min.x) * (c-&gt;r.max.y - c-&gt;r.min.y);
		switch(c-&gt;chandesc){
		case CY:
			// len *= 1;
			break;
		case CYA16:
			len *= 2;
			break;
		case CRGB24:
			len *= 3;
			break;
		case CRGBA32:
			len *= 4;
			break;
		}
		if(c-&gt;chanlen != len)
			fprint(2, "%s: writing %d bytes for len %ld chan %s\n",
				argv0, c-&gt;chanlen, len, buf);
		print("%11s %11d %11d %11d %11d ", buf,
			c-&gt;r.min.x, c-&gt;r.min.y, c-&gt;r.max.x, c-&gt;r.max.y);
		if(write(1, c-&gt;chans[0], c-&gt;chanlen) != c-&gt;chanlen){
			fprint(2, "png: %s: write error %r\n", name);
			return "write";
		}
	}else if(cflag){
		if(writerawimage(1, c) &lt; 0){
			fprint(2, "png: %s: write error: %r\n", name);
			return "write";
		}
	}
	for(j=0; j&lt;r-&gt;nchans; j++)
		free(r-&gt;chans[j]);
	free(r-&gt;cmap);
	free(r);
	free(array);
	if(c &amp;&amp; c != r){
		free(c-&gt;chans[0]);
		free(c);
	}
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

