<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/readtga.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/readtga.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * TGA is a fairly dead standard, however in the video industry
 * it is still used a little for test patterns and the like.
 *
 * Thus we ignore any alpha channels, and colour mapped images.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;ctype.h&gt;
#include "imagefile.h"

enum {
	HdrLen = 18,
};

typedef struct {
	int idlen;		/* length of string after header */
	int cmaptype;		/* 1 =&gt;  datatype = 1 =&gt; colourmapped */
	int datatype;		/* see below */
	int cmaporigin;		/* index of first entry in colour map */
	int cmaplen;		/* length of olour map */
	int cmapbpp;		/* bips per pixel of colour map: 16, 24, or 32 */
	int xorigin;		/* source image origin */
	int yorigin;
	int width;
	int height;
	int bpp;		/* bits per pixel of image: 16, 24, or 32 */
	int descriptor;
	uchar *cmap;		/* colour map (optional) */
} Tga;

/*
 * descriptor:
 * d0-3 = number of attribute bits per pixel
 * d4 	= reserved, always zero
 * d6-7	= origin: 0=lower left, 1=upper left, 2=lower right, 3=upper right
 * d8-9 = interleave: 0=progressive, 1=2 way, 3 = 4 way, 4 = reserved.
 */

char *datatype[] = {
	[0]	"No image data",
	[1]	"color mapped",
	[2]	"RGB",
	[3]	"B&amp;W",
	[9]	"RLE color-mapped",
	[10]	"RLE RGB",
	[11]	"Compressed B&amp;W",
	[32]	"Compressed color",
	[33]	"Quadtree compressed color",
};

static int
Bgeti(Biobuf *bp)
{
	int x, y;

	if((x = Bgetc(bp)) &lt; 0)
		return -1;
	if((y = Bgetc(bp)) &lt; 0)
		return -1;
	return (y&lt;&lt;8)|x;
}

static Tga *
rdhdr(Biobuf *bp)
{
	int n;
	Tga *h;

	if((h = malloc(sizeof(Tga))) == nil)
		return nil;
	if((h-&gt;idlen = Bgetc(bp)) == -1)
		return nil;
	if((h-&gt;cmaptype = Bgetc(bp)) == -1)
		return nil;
	if((h-&gt;datatype = Bgetc(bp)) == -1)
		return nil;
	if((h-&gt;cmaporigin = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;cmaplen = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;cmapbpp = Bgetc(bp)) == -1)
		return nil;
	if((h-&gt;xorigin = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;yorigin = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;width = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;height = Bgeti(bp)) == -1)
		return nil;
	if((h-&gt;bpp = Bgetc(bp)) == -1)
		return nil;
	if((h-&gt;descriptor = Bgetc(bp)) == -1)
		return nil;

	/* skip over ID, usually empty anyway */
	if(Bseek(bp, h-&gt;idlen, 1) &lt; 0){
		free(h);
		return nil;
	}

	if(h-&gt;cmaptype == 0){
		h-&gt;cmap = 0;
		return h;
	}

	n = (h-&gt;cmapbpp/8)*h-&gt;cmaplen;
	if((h-&gt;cmap = malloc(n)) == nil){
		free(h);
		return nil;
	}
	if(Bread(bp, h-&gt;cmap, n) != n){
		free(h);
		free(h-&gt;cmap);
		return nil;
	}
	return h;
}

static int
luma(Biobuf *bp, uchar *l, int num)
{
	return Bread(bp, l, num);
}

static int
luma_rle(Biobuf *bp, uchar *l, int num)
{
	uchar len;
	int i, got;

	for(got = 0; got &lt; num; got += len){
		if(Bread(bp, &amp;len, 1) != 1)
			break;
		if(len &amp; 0x80){
			len &amp;= 0x7f;
			len += 1;	/* run of zero is meaningless */
			if(luma(bp, l, 1) != 1)
				break;
			for(i = 0; i &lt; len &amp;&amp; got &lt; num; i++)
				l[i+1] = *l;
		}
		else{
			len += 1;	/* raw block of zero is meaningless */
			if(luma(bp, l, len) != len)
				break;
		}
		l += len;
	}
	return got;
}


static int
rgba(Biobuf *bp, int bpp, uchar *r, uchar *g, uchar *b, int num)
{
	int i;
	uchar x, y, buf[4];

	switch(bpp){
	case 16:
		for(i = 0; i &lt; num; i++){
			if(Bread(bp, buf, 2) != 2)
				break;
			x = buf[0];
			y = buf[1];
			*b++ = (x&amp;0x1f)&lt;&lt;3;
			*g++ = ((y&amp;0x03)&lt;&lt;6) | ((x&amp;0xe0)&gt;&gt;2);
			*r++ = (y&amp;0x1f)&lt;&lt;3;
		}
		break;
	case 24:
		for(i = 0; i &lt; num; i++){
			if(Bread(bp, buf, 3) != 3)
				break;
			*b++ = buf[0];
			*g++ = buf[1];
			*r++ = buf[2];
		}
		break;
	case 32:
		for(i = 0; i &lt; num; i++){
			if(Bread(bp, buf, 4) != 4)
				break;
			*b++ = buf[0];
			*g++ = buf[1];
			*r++ = buf[2];
		}
		break;
	default:
		i = 0;
		break;
	}
	return i;
}

static int
rgba_rle(Biobuf *bp, int bpp, uchar *r, uchar *g, uchar *b, int num)
{
	uchar len;
	int i, got;

	for(got = 0; got &lt; num; got += len){
		if(Bread(bp, &amp;len, 1) != 1)
			break;
		if(len &amp; 0x80){
			len &amp;= 0x7f;
			len += 1;	/* run of zero is meaningless */
			if(rgba(bp, bpp, r, g, b, 1) != 1)
				break;
			for(i = 0; i &lt; len-1 &amp;&amp; got &lt; num; i++){
				r[i+1] = *r;
				g[i+1] = *g;
				b[i+1] = *b;
			}
		}
		else{
			len += 1;	/* raw block of zero is meaningless */
			if(rgba(bp, bpp, r, g, b, len) != len)
				break;
		}
		r += len;
		g += len;
		b += len;
	}
	return got;
}

int
flip(Rawimage *ar)
{
	int w, h, c, l;
	uchar *t, *s, *d;

	w = Dx(ar-&gt;r);
	h = Dy(ar-&gt;r);
	if((t = malloc(w)) == nil){
		werrstr("ReadTGA: no memory - %r\n");
		return -1;
	}

	for(c = 0; c &lt; ar-&gt;nchans; c++){
		s = ar-&gt;chans[c];
		d = ar-&gt;chans[c] + ar-&gt;chanlen - w;
		for(l = 0; l &lt; (h/2); l++){
			memcpy(t, s, w);
			memcpy(s, d, w);
			memcpy(d, t, w);
			s += w;
			d -= w;
		}
	}
	free(t);
	return 0;
}

int
reflect(Rawimage *ar)
{
	int w, h, c, l, p;
	uchar t, *sol, *eol, *s, *d;

	w = Dx(ar-&gt;r);
	h = Dy(ar-&gt;r);

	for(c = 0; c &lt; ar-&gt;nchans; c++){
		sol = ar-&gt;chans[c];
		eol = ar-&gt;chans[c] +w -1;
		for(l = 0; l &lt; h; l++){
			s = sol;
			d = eol;
			for(p = 0; p &lt; w/2; p++){
				t = *s;
				*s = *d;
				*d = t;
				s++;
				d--;
			}
			sol += w;
			eol += w;
		}
	}
	return 0;
}


Rawimage**
Breadtga(Biobuf *bp)
{
	Tga *h;
	int n, c, num;
	uchar *r, *g, *b;
	Rawimage *ar, **array;

	if((h = rdhdr(bp)) == nil){
		werrstr("ReadTGA: bad header %r");
		return nil;
	}

	if(0){
		fprint(2, "idlen=%d\n", h-&gt;idlen);
		fprint(2, "cmaptype=%d\n", h-&gt;cmaptype);
		fprint(2, "datatype=%s\n", datatype[h-&gt;datatype]);
		fprint(2, "cmaporigin=%d\n", h-&gt;cmaporigin);
		fprint(2, "cmaplen=%d\n", h-&gt;cmaplen);
		fprint(2, "cmapbpp=%d\n", h-&gt;cmapbpp);
		fprint(2, "xorigin=%d\n", h-&gt;xorigin);
		fprint(2, "yorigin=%d\n", h-&gt;yorigin);
		fprint(2, "width=%d\n", h-&gt;width);
		fprint(2, "height=%d\n", h-&gt;height);
		fprint(2, "bpp=%d\n", h-&gt;bpp);
		fprint(2, "descriptor=%d\n", h-&gt;descriptor);
	}

	array = nil;
	if((ar = calloc(sizeof(Rawimage), 1)) == nil){
		werrstr("ReadTGA: no memory - %r\n");
		goto Error;
	}

	if((array = calloc(sizeof(Rawimage *), 2)) == nil){
		werrstr("ReadTGA: no memory - %r\n");
		goto Error;
	}
	array[0] = ar;
	array[1] = nil;

	if(h-&gt;datatype == 3){
		ar-&gt;nchans = 1;
		ar-&gt;chandesc = CY;
	}
	else{
		ar-&gt;nchans = 3;
		ar-&gt;chandesc = CRGB;
	}

	ar-&gt;chanlen = h-&gt;width*h-&gt;height;
	ar-&gt;r = Rect(0, 0, h-&gt;width, h-&gt;height);
	for (c = 0; c &lt; ar-&gt;nchans; c++)
		if ((ar-&gt;chans[c] = malloc(h-&gt;width*h-&gt;height)) == nil){
			werrstr("ReadTGA: no memory - %r\n");
			goto Error;
		}
	r = ar-&gt;chans[0];
	g = ar-&gt;chans[1];
	b = ar-&gt;chans[2];

	num = h-&gt;width*h-&gt;height;
	switch(h-&gt;datatype){
	case 2:
		if(rgba(bp, h-&gt;bpp, r, g, b, num) != num){
			werrstr("ReadTGA: decode fail - %r\n");
			goto Error;
		}
		break;
	case 3:
		if(luma(bp, r, num) != num){
			werrstr("ReadTGA: decode fail - %r\n");
			goto Error;
		}
		break;
	case 10:
		if((n = rgba_rle(bp, h-&gt;bpp, r, g, b, num)) != num){
			werrstr("ReadTGA: decode fail (%d!=%d) - %r\n", n, num);
			goto Error;
		}
		break;
	case 11:
		if(luma_rle(bp, r, num) != num){
			werrstr("ReadTGA: decode fail - %r\n");
			goto Error;
		}
		break;
	default:
		werrstr("ReadTGA: type=%d (%s) unsupported\n", h-&gt;datatype, datatype[h-&gt;datatype]);
		goto Error;	
 	}

	if(h-&gt;xorigin != 0)
		reflect(ar);
	if(h-&gt;yorigin == 0)
		flip(ar);
	
	free(h-&gt;cmap);
	free(h);
	return array;
Error:

	if(ar)
		for (c = 0; c &lt; ar-&gt;nchans; c++)
			free(ar-&gt;chans[c]);
	free(ar);
	free(array);
	free(h-&gt;cmap);
	free(h);
	return nil;
}

Rawimage**
readtga(int fd)
{
	Rawimage * *a;
	Biobuf b;

	if (Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	a = Breadtga(&amp;b);
	Bterm(&amp;b);
	return a;
}


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

