<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/readv210.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/readv210.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * readV210.c - read single uncompressed Quicktime YUV image.
 * http://developer.apple.com/quicktime/icefloe/dispatch019.html#v210
 * Steve Simon, 2009
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;ctype.h&gt;
#include "imagefile.h"

enum {
	Pixels = 720,
	R601pal = 576,
	R601ntsc = 486,
	Shift = 13
};

static int
looksize(char *file, vlong size, int *pixels, int *lines, int *chunk)
{
	Biobuf *bp;
	uvlong l, p, c;
	char *s, *a[12];

	/*
	 * This may not always work, there could be an alias between file
	 * sizes of different standards stored in 8bits and 10 bits.
	 */
	if((bp = Bopen(file, OREAD)) == nil)
		return -1;
	while((s = Brdstr(bp, '\n', 1)) != nil){
		if(tokenize(s, a, nelem(a)) &lt; 3)
			continue;
		if(a[0][0] == '#')
			continue;
		p = atoll(a[3]);
		l = atoll(a[5]);
		l += atoll(a[7]);
		c = 128 * ceil(p/48);
		if(l*c == size){
			*pixels = p;
			*lines = l;
			*chunk = c;
			break;
		}
	}
	Bterm(bp);
	if(s == nil)
		return -1;
	return 0;
}

static int
clip(int x)
{
	x &gt;&gt;= Shift + 2;	/* +2 as we assume all input images are 10 bit */
	if(x &gt; 255)
		return 0xff;
	if(x &lt;= 0)
		return 0;
	return x;
}

Rawimage**
BreadV210(Biobuf *bp, int colourspace)
{
	Dir *d;
	uvlong sz;
	Rawimage *a, **array;
	ushort *mux, *end, *frm, *wr;
	uchar *buf, *r, *g, *b;
	uint i, t;
	int y1, y2, cb, cr, c, l, rd;
	int chunk, lines, pixels;
	int F1, F2, F3, F4;

	buf = nil;
	if(colourspace != CYCbCr){
		werrstr("BreadV210: unknown colour space %d", colourspace);
		return nil;
	}

	if((d = dirfstat(Bfildes(bp))) != nil){
		sz = d-&gt;length;
		free(d);
	}
	else {
		fprint(2, "cannot stat input, assuming pixelsx576x10bit\n");
		sz = Pixels * R601pal * 2L + (pixels * R601pal / 2L);
	}

	if(looksize("/lib/video.specs", sz, &amp;pixels, &amp;lines, &amp;chunk) == -1){
		werrstr("file spec not in /lib/video.specs\n");
		return nil;
	}

	if((a = calloc(sizeof(Rawimage), 1)) == nil)
		sysfatal("no memory");

	if((array = calloc(sizeof(Rawimage * ), 2)) == nil)
		sysfatal("no memory");
	array[0] = a;
	array[1] = nil;

	a-&gt;nchans = 3;
	a-&gt;chandesc = CRGB;
	a-&gt;chanlen = pixels * lines;
	a-&gt;r = Rect(0, 0, pixels, lines);

	if((frm = malloc(pixels*2*lines*sizeof(ushort))) == nil)
		goto Error;

	for(c = 0; c  &lt; 3; c++)
		if((a-&gt;chans[c] = malloc(pixels*lines)) == nil)
			goto Error;

	if((buf = malloc(chunk)) == nil)
		goto Error;

	for(l = 0; l &lt; lines; l++){
		if(Bread(bp, buf, chunk) == -1)
			goto Error;

		rd = 0;
		wr = &amp;frm[l*pixels*2];
		end = &amp;frm[(l+1)*pixels*2];
		while(wr &lt; end){
			t = 0;
			for(i = 0; i &lt; 4; i++)
				t += buf[rd+i] &lt;&lt; 8*i;
			*wr++ = t &amp; 0x3ff;
			*wr++ = t&gt;&gt;10 &amp; 0x3ff;
			*wr++ = t&gt;&gt;20 &amp; 0x3ff;
			rd += 4;
		}
	}

	mux = frm;
	end = frm + pixels * lines * 2;
	r = a-&gt;chans[0];
	g = a-&gt;chans[1];
	b = a-&gt;chans[2];

	if(pixels == Pixels &amp;&amp; lines != R601pal){	// 625
		F1 = floor(1.402 * (1 &lt;&lt; Shift));
		F2 = floor(0.34414 * (1 &lt;&lt; Shift));
		F3 = floor(0.71414 * (1 &lt;&lt; Shift));
		F4 = floor(1.772 * (1 &lt;&lt; Shift));
	}
	else{						// 525 and HD
		F1 = floor(1.5748 * (1 &lt;&lt; Shift));
		F2 = floor(0.1874 * (1 &lt;&lt; Shift));
		F3 = floor(0.4681 * (1 &lt;&lt; Shift));
		F4 = floor(1.8560 * (1 &lt;&lt; Shift));
	}

	/*
	 * Fixme: fixed colourspace conversion at present
	 */
	while(mux &lt; end){

		cb = *mux++ - 512;
		y1 = (int)*mux++ &lt;&lt; Shift;
		cr = *mux++ - 512;
		y2 = (int)*mux++ &lt;&lt; Shift;

		*r++ = clip(y1 + F1*cr);
		*g++ = clip(y1 - F2*cb - F3*cr);
		*b++ = clip((y1 + F4*cb));

		*r++ = clip(y2 + F1*cr);
		*g++ = clip(y2 - F2*cb - F3*cr);
		*b++ = clip((y2 + F4*cb));
	}
	free(frm);
	free(buf);
	return array;

Error:
	for(c = 0; c &lt; 3; c++)
		free(a-&gt;chans[c]);
	free(a-&gt;cmap);
	free(array[0]);
	free(array);
	free(frm);
	free(buf);
	return nil;
}

Rawimage**
readV210(int fd, int colorspace)
{
	Rawimage * *a;
	Biobuf b;

	if(Binit(&amp;b, fd, OREAD) &lt; 0)
		return nil;
	a = BreadV210(&amp;b, colorspace);
	Bterm(&amp;b);
	return a;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

