<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/toico.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/toico.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;

enum
{
	FileHdrLen=	6,
	IconDescrLen=	16,
	IconHdrLen=	40,
};

typedef struct Icon Icon;
struct Icon
{
	Icon	*next;
	char	*file;

	uchar	w;		/* icon width */
	uchar	h;		/* icon height */
	ushort	ncolor;		/* number of colors */
	ushort	nplane;		/* number of bit planes */
	ushort	bits;		/* bits per pixel */
	ulong	len;		/* length of data */
	ulong	offset;		/* file offset to data */
	uchar	map[4*256];	/* color map */

	Image	*img;

	uchar	*xor;
	int	xorlen;
	uchar	*and;
	int	andlen;
};

typedef struct Header Header;
struct Header
{
	uint	n;
	Icon	*first;
	Icon	*last;
};

void
Bputs(Biobuf *b, ushort x)
{
	Bputc(b, x&amp;0xff);
	Bputc(b, x&gt;&gt;8);
}

void
Bputl(Biobuf *b, ulong x)
{
	Bputs(b, x&amp;0xffff);
	Bputs(b, x&gt;&gt;16);
}

Header h;

void*	emalloc(int);
void	mk8bit(Icon*, int);
void	mkxorand(Icon*, int);
void	readicon(char*);

void
main(int argc, char **argv)
{
	int i;
	Biobuf *b, out;
	Icon *icon;
	ulong offset;
	ulong len;

	ARGBEGIN{
	}ARGEND;

	/* read in all the images */
	display = initdisplay(nil, nil, nil);
	if(argc &lt; 1){
		readicon("/fd/0");
	} else {
		for(i = 0; i &lt; argc; i++)
			readicon(argv[i]);
	}

	/* create the .ico file */
	b = &amp;out;
	Binit(b, 1, OWRITE);

	/* offset to first icon */
	offset = FileHdrLen + h.n*IconDescrLen;

	/* file header is */
	Bputs(b, 0);
	Bputs(b, 1);
	Bputs(b, h.n);

	/* icon description */
	for(icon = h.first; icon != nil; icon = icon-&gt;next){
		Bputc(b, icon-&gt;w);
		Bputc(b, icon-&gt;h);
		Bputc(b, icon-&gt;ncolor);
		Bputc(b, 0);
		Bputs(b, icon-&gt;nplane);
		Bputs(b, icon-&gt;bits);
		len = IconHdrLen + icon-&gt;ncolor*4 + icon-&gt;xorlen + icon-&gt;andlen;
		Bputl(b, len);
		Bputl(b, offset);
		offset += len;
	}

	/* icons */
	for(icon = h.first; icon != nil; icon = icon-&gt;next){
		/* icon header (BMP like) */
		Bputl(b, IconHdrLen);
		Bputl(b, icon-&gt;w);
		Bputl(b, 2*icon-&gt;h);
		Bputs(b, icon-&gt;nplane);
		Bputs(b, icon-&gt;bits);
		Bputl(b, 0);	/* compression info */
		Bputl(b, 0);
		Bputl(b, 0);
		Bputl(b, 0);
		Bputl(b, 0);
		Bputl(b, 0);

		/* color map */
		if(Bwrite(b, icon-&gt;map, 4*icon-&gt;ncolor) &lt; 0)
			sysfatal("writing color map: %r");

		/* xor bits */
		if(Bwrite(b, icon-&gt;xor, icon-&gt;xorlen) &lt; 0)
			sysfatal("writing xor bits: %r");

		/* and bits */
		if(Bwrite(b, icon-&gt;and, icon-&gt;andlen) &lt; 0)
			sysfatal("writing and bits: %r");
	}

	Bterm(b);
	exits(0);
}

void
readicon(char *file)
{
	int fd;
	Icon *icon;

	fd = open(file, OREAD);
	if(fd &lt; 0)
		sysfatal("opening %s: %r", file);
	icon = emalloc(sizeof(Icon));
	icon-&gt;img = readimage(display, fd, 0);
	if(icon-&gt;img == nil)
		sysfatal("reading image %s: %r", file);
	close(fd);

	if(h.first)
		h.last-&gt;next = icon;
	else
		h.first = icon;
	h.last = icon;
	h.n++;

	icon-&gt;h = Dy(icon-&gt;img-&gt;r);
	icon-&gt;w = Dx(icon-&gt;img-&gt;r);
	icon-&gt;bits = 1&lt;&lt;icon-&gt;img-&gt;depth;
	icon-&gt;nplane = 1;

	/* convert to 8 bits per pixel */
	switch(icon-&gt;img-&gt;chan){
	case GREY8:
	case CMAP8:
		break;
	case GREY1:
	case GREY2:
	case GREY4:
		mk8bit(icon, 1);
		break;
	default:
		mk8bit(icon, 0);
		break;
	}
	icon-&gt;bits = 8;
	icon-&gt;file = file;

	/* create xor/and masks, minimizing bits per pixel */
	mkxorand(icon, icon-&gt;img-&gt;chan == GREY8);
}

void*
emalloc(int len)
{
	void *x;

	x = mallocz(len, 1);
	if(x == nil)
		sysfatal("memory: %r");
	return x;
}

/* convert to 8 bit */
void
mk8bit(Icon *icon, int grey)
{
	Image *img;

	img = allocimage(display, icon-&gt;img-&gt;r, grey ? GREY8 : CMAP8, 0, DNofill);
	if(img == nil)
		sysfatal("can't allocimage: %r");
	draw(img, img-&gt;r, icon-&gt;img, nil, ZP);
	freeimage(icon-&gt;img);
	icon-&gt;img = img;
}

/* make xor and and mask */
void
mkxorand(Icon *icon, int grey)
{
	int i, x, y, s, sa;
	uchar xx[256];
	uchar *data, *p, *e;
	int ndata;
	uchar *mp;
	int ncolor;
	ulong color;
	int bits;
	uchar andbyte, xorbyte;
	uchar *ato, *xto;
	int xorrl, andrl;

	ndata = icon-&gt;h * icon-&gt;w;
	data = emalloc(ndata);
	if(unloadimage(icon-&gt;img, icon-&gt;img-&gt;r, data, ndata) &lt; 0)
		sysfatal("can't unload %s: %r", icon-&gt;file);
	e = data + ndata;

	/* find colors used */
	memset(xx, 0, sizeof xx);
	for(p = data; p &lt; e; p++)
		xx[*p]++;

	/* count the colors and create a mapping from plan 9 */
	mp = icon-&gt;map;
	ncolor = 0;
	for(i = 0; i &lt; 256; i++){
		if(xx[i] == 0)
			continue;
		if(grey){
			*mp++ = i;
			*mp++ = i;
			*mp++ = i;
			*mp++ = 0;
		} else {
			color = cmap2rgb(i);
			*mp++ = color;
			*mp++ = color&gt;&gt;8;
			*mp++ = color&gt;&gt;16;
			*mp++ = 0;
		}
		xx[i] = ncolor;
		ncolor++;
	}

	/* get minimum number of pixels per bit (with a color map) */
	if(ncolor &lt;= 2){
		ncolor = 2;
		bits = 1;
	} else if(ncolor &lt;= 4){
		ncolor = 4;
		bits = 2;
	} else if(ncolor &lt;= 16){
		ncolor = 16;
		bits = 4;
	} else {
		ncolor = 256;
		bits = 8;
	}
	icon-&gt;bits = bits;
	icon-&gt;ncolor = ncolor;

	/* the xor mask rows are justified to a 32 bit boundary */
	/* the and mask is 1 bit grey */
	xorrl = 4*((bits*icon-&gt;w + 31)/32);
	andrl = 4*((icon-&gt;w + 31)/32);
	icon-&gt;xor = emalloc(xorrl * icon-&gt;h);
	icon-&gt;and = emalloc(andrl * icon-&gt;h);
	icon-&gt;xorlen = xorrl*icon-&gt;h;
	icon-&gt;andlen = andrl*icon-&gt;h;

	/* make both masks.  they're upside down relative to plan9 ones */
	p = data;
	for(y = 0; y &lt; icon-&gt;h; y++){
		andbyte = 0;
		xorbyte = 0;
		sa = s = 0;
		xto = icon-&gt;xor + (icon-&gt;h-1-y)*xorrl;
		ato = icon-&gt;and + (icon-&gt;h-1-y)*andrl;
		for(x = 0; x &lt; icon-&gt;w; x++){
			xorbyte &lt;&lt;= bits;
			xorbyte |= xx[*p];
			s += bits;
			if(s == 8){
				*xto++ = xorbyte;
				xorbyte = 0;
				s = 0;
			}
			andbyte &lt;&lt;= 1;
			if(*p == 0xff)
				andbyte |= 1;
			sa++;
			if(sa == 0){
				*ato++ = andbyte;
				sa = 0;
				andbyte = 0;
			}
			p++;
		}
	}
	free(data);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

