<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/jpg/torgbv.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/jpg/torgbv.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include "imagefile.h"

#include "rgbv.h"
#include "ycbcr.h"

#define	CLAMPOFF 128

static	int	clamp[CLAMPOFF+256+CLAMPOFF];
static	int	inited;

void*
_remaperror(char *fmt, ...)
{
	va_list arg;
	char buf[256];

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof buf, fmt, arg);
	va_end(arg);

	werrstr(buf);
	return nil;
}

Rawimage*
torgbv(Rawimage *i, int errdiff)
{
	int j, k, rgb, x, y, er, eg, eb, col, t;
	int r, g, b, r1, g1, b1;
	int *ered, *egrn, *eblu, *rp, *gp, *bp;
	int bpc;
	uint *map3;
	uchar *closest;
	Rawimage *im;
	int dx, dy;
	char err[ERRMAX];
	uchar *cmap, *cm, *in, *out, *inp, *outp, cmap1[3*256], map[256], *rpic, *bpic, *gpic;

	err[0] = '\0';
	errstr(err, sizeof err);	/* throw it away */
	im = malloc(sizeof(Rawimage));
	if(im == nil)
		return nil;
	memset(im, 0, sizeof(Rawimage));
	im-&gt;chans[0] = malloc(i-&gt;chanlen);
	if(im-&gt;chans[0] == nil){
		free(im);
		return nil;
	}
	im-&gt;r = i-&gt;r;
	im-&gt;nchans = 1;
	im-&gt;chandesc = CRGBV;
	im-&gt;chanlen = i-&gt;chanlen;

	dx = i-&gt;r.max.x-i-&gt;r.min.x;
	dy = i-&gt;r.max.y-i-&gt;r.min.y;
	cmap = i-&gt;cmap;

	if(inited == 0){
		inited = 1;
		for(j=0; j&lt;CLAMPOFF; j++)
			clamp[j] = 0;
		for(j=0; j&lt;256; j++)
			clamp[CLAMPOFF+j] = (j&gt;&gt;4);
		for(j=0; j&lt;CLAMPOFF; j++)
			clamp[CLAMPOFF+256+j] = (255&gt;&gt;4);
	}

	in = i-&gt;chans[0];
	inp = in;
	out = im-&gt;chans[0];
	outp = out;

	ered = malloc((dx+1)*sizeof(int));
	egrn = malloc((dx+1)*sizeof(int));
	eblu = malloc((dx+1)*sizeof(int));
	if(ered==nil || egrn==nil || eblu==nil){
		free(im-&gt;chans[0]);
		free(im);
		free(ered);
		free(egrn);
		free(eblu);
		return _remaperror("remap: malloc failed: %r");
	}
	memset(ered, 0, (dx+1)*sizeof(int));
	memset(egrn, 0, (dx+1)*sizeof(int));
	memset(eblu, 0, (dx+1)*sizeof(int));

	switch(i-&gt;chandesc){
	default:
		return _remaperror("remap: can't recognize channel type %d", i-&gt;chandesc);
	case CRGB1:
		if(cmap == nil)
			return _remaperror("remap: image has no color map");
		if(i-&gt;nchans != 1)
			return _remaperror("remap: can't handle nchans %d", i-&gt;nchans);
		for(j=1; j&lt;=8; j++)
			if(i-&gt;cmaplen == 3*(1&lt;&lt;j))
				break;
		if(j &gt; 8)
			return _remaperror("remap: can't do colormap size 3*%d", i-&gt;cmaplen/3);
		if(i-&gt;cmaplen != 3*256){
			/* to avoid a range check in inner loop below, make a full-size cmap */
			memmove(cmap1, cmap, i-&gt;cmaplen);
			cmap = cmap1;
		}
		if(errdiff == 0){
			k = 0;
			for(j=0; j&lt;256; j++){
				r = cmap[k]&gt;&gt;4;
				g = cmap[k+1]&gt;&gt;4;
				b = cmap[k+2]&gt;&gt;4;
				k += 3;
				map[j] = closestrgb[b+16*(g+16*r)];
			}
			for(j=0; j&lt;i-&gt;chanlen; j++)
				out[j] = map[in[j]];
		}else{
			/* modified floyd steinberg, coefficients (1 0) 3/16, (0, 1) 3/16, (1, 1) 7/16 */
			for(y=0; y&lt;dy; y++){
				er = 0;
				eg = 0;
				eb = 0;
				rp = ered;
				gp = egrn;
				bp = eblu;
				for(x=0; x&lt;dx; x++){
					cm = &amp;cmap[3 * *inp++];
					r = cm[0] +*rp;
					g = cm[1] +*gp;
					b = cm[2] +*bp;

					/* sanity checks are new */
					if(r &gt;= 256+CLAMPOFF)
						r = 0;
					if(g &gt;= 256+CLAMPOFF)
						g = 0;
					if(b &gt;= 256+CLAMPOFF)
						b = 0;
					r1 = clamp[r+CLAMPOFF];
					g1 = clamp[g+CLAMPOFF];
					b1 = clamp[b+CLAMPOFF];
					if(r1 &gt;= 16 || g1 &gt;= 16 || b1 &gt;= 16)
						col = 0;
					else
						col = closestrgb[b1+16*(g1+16*r1)];
					*outp++ = col;

					rgb = rgbmap[col];
					r -= (rgb&gt;&gt;16) &amp; 0xFF;
					t = (3*r)&gt;&gt;4;
					*rp++ = t+er;
					*rp += t;
					er = r-3*t;

					g -= (rgb&gt;&gt;8) &amp; 0xFF;
					t = (3*g)&gt;&gt;4;
					*gp++ = t+eg;
					*gp += t;
					eg = g-3*t;

					b -= rgb &amp; 0xFF;
					t = (3*b)&gt;&gt;4;
					*bp++ = t+eb;
					*bp += t;
					eb = b-3*t;
				}
			}
		}
		break;

	case CYCbCr:
		bpc = 1;
		rpic = i-&gt;chans[0];
		gpic = i-&gt;chans[1];
		bpic = i-&gt;chans[2];
		closest = closestycbcr;
		map3 = ycbcrmap;
		if(i-&gt;nchans != 3)
			return _remaperror("remap: RGB image has %d channels", i-&gt;nchans);
		goto Threecolor;

	case CRGB:
		bpc = 1;
		rpic = i-&gt;chans[0];
		gpic = i-&gt;chans[1];
		bpic = i-&gt;chans[2];
		if(i-&gt;nchans != 3)
			return _remaperror("remap: RGB image has %d channels", i-&gt;nchans);
		goto rgbgen;

	case CRGB24:
		bpc = 3;
		bpic = i-&gt;chans[0];
		gpic = i-&gt;chans[0] + 1;
		rpic = i-&gt;chans[0] + 2;
		goto rgbgen;

	case CRGBA32:
		bpc = 4;
		/* i-&gt;chans[0]+0 is alpha */
		bpic = i-&gt;chans[0] + 1;
		gpic = i-&gt;chans[0] + 2;
		rpic = i-&gt;chans[0] + 3;

	rgbgen:
		closest = closestrgb;
		map3 = rgbmap;

	Threecolor:

		if(errdiff == 0){
			outp = out;
			for(j=0; j&lt;i-&gt;chanlen; j+=bpc){
				r = rpic[j]&gt;&gt;4;
				g = gpic[j]&gt;&gt;4;
				b = bpic[j]&gt;&gt;4;
				*outp++ = closest[b+16*(g+16*r)];
			}
		}else{
			/* modified floyd steinberg, coefficients (1 0) 3/16, (0, 1) 3/16, (1, 1) 7/16 */
			for(y=0; y&lt;dy; y++){
				er = 0;
				eg = 0;
				eb = 0;
				rp = ered;
				gp = egrn;
				bp = eblu;
				for(x=0; x&lt;dx; x++){
					r = *rpic + *rp;
					g = *gpic + *gp;
					b = *bpic + *bp;
					rpic += bpc;
					gpic += bpc;
					bpic += bpc;
					/*
					 * Errors can be uncorrectable if converting from YCbCr,
					 * since we can't guarantee that an extremal value of one of
					 * the components selects a color with an extremal value.
					 * If we don't, the errors accumulate without bound.  This
					 * doesn't happen in RGB because the closest table can guarantee
					 * a color on the edge of the gamut, producing a zero error in
					 * that component.  For the rotation YCbCr space, there may be
					 * no color that can guarantee zero error at the edge.
					 * Therefore we must clamp explicitly rather than by assuming
					 * an upper error bound of CLAMPOFF.  The performance difference
					 * is miniscule anyway.
					 */
					if(r &lt; 0)
						r = 0;
					else if(r &gt; 255)
						r = 255;
					if(g &lt; 0)
						g = 0;
					else if(g &gt; 255)
						g = 255;
					if(b &lt; 0)
						b = 0;
					else if(b &gt; 255)
						b = 255;
					r1 = r&gt;&gt;4;
					g1 = g&gt;&gt;4;
					b1 = b&gt;&gt;4;
					col = closest[b1+16*(g1+16*r1)];
					*outp++ = col;

					rgb = map3[col];
					r -= (rgb&gt;&gt;16) &amp; 0xFF;
					t = (3*r)&gt;&gt;4;
					*rp++ = t+er;
					*rp += t;
					er = r-3*t;

					g -= (rgb&gt;&gt;8) &amp; 0xFF;
					t = (3*g)&gt;&gt;4;
					*gp++ = t+eg;
					*gp += t;
					eg = g-3*t;

					b -= rgb &amp; 0xFF;
					t = (3*b)&gt;&gt;4;
					*bp++ = t+eb;
					*bp += t;
					eb = b-3*t;
				}
			}
		}
		break;

	case CYA16:
		bpc = 2;
		/* i-&gt;chans[0] + 0 is alpha */
		rpic = i-&gt;chans[0] + 1;
		goto greygen;

	case CY:
		bpc = 1;
		rpic = i-&gt;chans[0];
		if(i-&gt;nchans != 1)
			return _remaperror("remap: Y image has %d chans", i-&gt;nchans);

	greygen:
		if(errdiff == 0){
			for(j=0; j&lt;i-&gt;chanlen; j+=bpc){
				r = rpic[j]&gt;&gt;4;
				*outp++ = closestrgb[r+16*(r+16*r)];
			}
		}else{
			/* modified floyd steinberg, coefficients (1 0) 3/16, (0, 1) 3/16, (1, 1) 7/16 */
			for(y=0; y&lt;dy; y++){
				er = 0;
				rp = ered;
				for(x=0; x&lt;dx; x++){
					r = *rpic + *rp;
					rpic += bpc;
					r1 = clamp[r+CLAMPOFF];
					col = closestrgb[r1+16*(r1+16*r1)];
					*outp++ = col;

					rgb = rgbmap[col];
					r -= (rgb&gt;&gt;16) &amp; 0xFF;
					t = (3*r)&gt;&gt;4;
					*rp++ = t+er;
					*rp += t;
					er = r-3*t;
				}
			}
		}
		break;
	}
	free(ered);
	free(egrn);
	free(eblu);
	return im;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

