<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/kc/reg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/kc/reg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "gc.h"

Reg*
rega(void)
{
	Reg *r;

	r = freer;
	if(r == R) {
		r = alloc(sizeof(*r));
	} else
		freer = r-&gt;link;

	*r = zreg;
	return r;
}

int
rcmp(const void *a1, const void *a2)
{
	Rgn *p1, *p2;
	int c1, c2;

	p1 = (Rgn*)a1;
	p2 = (Rgn*)a2;
	c1 = p2-&gt;cost;
	c2 = p1-&gt;cost;
	if(c1 -= c2)
		return c1;
	return p2-&gt;varno - p1-&gt;varno;
}

void
regopt(Prog *p)
{
	Reg *r, *r1, *r2;
	Prog *p1;
	int i, z;
	long initpc, val, npc;
	ulong vreg;
	Bits bit;
	struct
	{
		long	m;
		long	c;
		Reg*	p;
	} log5[6], *lp;

	firstr = R;
	lastr = R;
	nvar = 0;
	regbits = 0;
	for(z=0; z&lt;BITS; z++) {
		externs.b[z] = 0;
		params.b[z] = 0;
		consts.b[z] = 0;
		addrs.b[z] = 0;
	}

	/*
	 * pass 1
	 * build aux data structure
	 * allocate pcs
	 * find use and set of variables
	 */
	val = 5L * 5L * 5L * 5L * 5L;
	lp = log5;
	for(i=0; i&lt;5; i++) {
		lp-&gt;m = val;
		lp-&gt;c = 0;
		lp-&gt;p = R;
		val /= 5L;
		lp++;
	}
	val = 0;
	for(; p != P; p = p-&gt;link) {
		switch(p-&gt;as) {
		case ADATA:
		case AGLOBL:
		case ANAME:
		case ASIGNAME:
			continue;
		}
		r = rega();
		if(firstr == R) {
			firstr = r;
			lastr = r;
		} else {
			lastr-&gt;link = r;
			r-&gt;p1 = lastr;
			lastr-&gt;s1 = r;
			lastr = r;
		}
		r-&gt;prog = p;
		r-&gt;pc = val;
		val++;

		lp = log5;
		for(i=0; i&lt;5; i++) {
			lp-&gt;c--;
			if(lp-&gt;c &lt;= 0) {
				lp-&gt;c = lp-&gt;m;
				if(lp-&gt;p != R)
					lp-&gt;p-&gt;log5 = r;
				lp-&gt;p = r;
				(lp+1)-&gt;c = 0;
				break;
			}
			lp++;
		}

		r1 = r-&gt;p1;
		if(r1 != R)
		switch(r1-&gt;prog-&gt;as) {
		case ARETURN:
		case AJMP:
		case ARETT:
			r-&gt;p1 = R;
			r1-&gt;s1 = R;
		}

		/*
		 * left side always read
		 */
		bit = mkvar(&amp;p-&gt;from, p-&gt;as==AMOVW);
		for(z=0; z&lt;BITS; z++)
			r-&gt;use1.b[z] |= bit.b[z];

		/*
		 * right side depends on opcode
		 */
		bit = mkvar(&amp;p-&gt;to, 0);
		if(bany(&amp;bit))
		switch(p-&gt;as) {
		default:
			diag(Z, "reg: unknown asop: %A", p-&gt;as);
			break;

		/*
		 * right side write
		 */
		case ANOP:
		case AMOVB:
		case AMOVBU:
		case AMOVH:
		case AMOVHU:
		case AMOVW:
		case AFMOVF:
		case AFMOVD:
			for(z=0; z&lt;BITS; z++)
				r-&gt;set.b[z] |= bit.b[z];
			break;

		/*
		 * funny
		 */
		case AJMPL:
			for(z=0; z&lt;BITS; z++)
				addrs.b[z] |= bit.b[z];
			break;
		}
	}
	if(firstr == R)
		return;
	initpc = pc - val;
	npc = val;

	/*
	 * pass 2
	 * turn branch references to pointers
	 * build back pointers
	 */
	for(r = firstr; r != R; r = r-&gt;link) {
		p = r-&gt;prog;
		if(p-&gt;to.type == D_BRANCH) {
			val = p-&gt;to.offset - initpc;
			r1 = firstr;
			while(r1 != R) {
				r2 = r1-&gt;log5;
				if(r2 != R &amp;&amp; val &gt;= r2-&gt;pc) {
					r1 = r2;
					continue;
				}
				if(r1-&gt;pc == val)
					break;
				r1 = r1-&gt;link;
			}
			if(r1 == R) {
				nearln = p-&gt;lineno;
				diag(Z, "ref not found\n%P", p);
				continue;
			}
			if(r1 == r) {
				nearln = p-&gt;lineno;
				diag(Z, "ref to self\n%P", p);
				continue;
			}
			r-&gt;s2 = r1;
			r-&gt;p2link = r1-&gt;p2;
			r1-&gt;p2 = r;
		}
	}
	if(debug['R']) {
		p = firstr-&gt;prog;
		print("\n%L %D\n", p-&gt;lineno, &amp;p-&gt;from);
	}

	/*
	 * pass 2.5
	 * find looping structure
	 */
	for(r = firstr; r != R; r = r-&gt;link)
		r-&gt;active = 0;
	change = 0;
	loopit(firstr, npc);
	if(debug['R'] &amp;&amp; debug['v']) {
		print("\nlooping structure:\n");
		for(r = firstr; r != R; r = r-&gt;link) {
			print("%ld:%P", r-&gt;loop, r-&gt;prog);
			for(z=0; z&lt;BITS; z++)
				bit.b[z] = r-&gt;use1.b[z] |
					r-&gt;use2.b[z] | r-&gt;set.b[z];
			if(bany(&amp;bit)) {
				print("\t");
				if(bany(&amp;r-&gt;use1))
					print(" u1=%B", r-&gt;use1);
				if(bany(&amp;r-&gt;use2))
					print(" u2=%B", r-&gt;use2);
				if(bany(&amp;r-&gt;set))
					print(" st=%B", r-&gt;set);
			}
			print("\n");
		}
	}

	/*
	 * pass 3
	 * iterate propagating usage
	 * 	back until flow graph is complete
	 */
loop1:
	change = 0;
	for(r = firstr; r != R; r = r-&gt;link)
		r-&gt;active = 0;
	for(r = firstr; r != R; r = r-&gt;link)
		if(r-&gt;prog-&gt;as == ARETURN)
			prop(r, zbits, zbits);
loop11:
	/* pick up unreachable code */
	i = 0;
	for(r = firstr; r != R; r = r1) {
		r1 = r-&gt;link;
		if(r1 &amp;&amp; r1-&gt;active &amp;&amp; !r-&gt;active) {
			prop(r, zbits, zbits);
			i = 1;
		}
	}
	if(i)
		goto loop11;
	if(change)
		goto loop1;


	/*
	 * pass 4
	 * iterate propagating register/variable synchrony
	 * 	forward until graph is complete
	 */
loop2:
	change = 0;
	for(r = firstr; r != R; r = r-&gt;link)
		r-&gt;active = 0;
	synch(firstr, zbits);
	if(change)
		goto loop2;


	/*
	 * pass 5
	 * isolate regions
	 * calculate costs (paint1)
	 */
	r = firstr;
	if(r) {
		for(z=0; z&lt;BITS; z++)
			bit.b[z] = (r-&gt;refahead.b[z] | r-&gt;calahead.b[z]) &amp;
			  ~(externs.b[z] | params.b[z] | addrs.b[z] | consts.b[z]);
		if(bany(&amp;bit)) {
			nearln = r-&gt;prog-&gt;lineno;
			warn(Z, "used and not set: %B", bit);
			if(debug['R'] &amp;&amp; !debug['w'])
				print("used and not set: %B\n", bit);
		}
	}
	if(debug['R'] &amp;&amp; debug['v'])
		print("\nprop structure:\n");
	for(r = firstr; r != R; r = r-&gt;link)
		r-&gt;act = zbits;
	rgp = region;
	nregion = 0;
	for(r = firstr; r != R; r = r-&gt;link) {
		if(debug['R'] &amp;&amp; debug['v'])
			print("%P\n	set = %B; rah = %B; cal = %B\n",
				r-&gt;prog, r-&gt;set, r-&gt;refahead, r-&gt;calahead);
		for(z=0; z&lt;BITS; z++)
			bit.b[z] = r-&gt;set.b[z] &amp;
			  ~(r-&gt;refahead.b[z] | r-&gt;calahead.b[z] | addrs.b[z]);
		if(bany(&amp;bit)) {
			nearln = r-&gt;prog-&gt;lineno;
			warn(Z, "set and not used: %B", bit);
			if(debug['R'])
				print("set an not used: %B\n", bit);
			excise(r);
		}
		for(z=0; z&lt;BITS; z++)
			bit.b[z] = LOAD(r) &amp; ~(r-&gt;act.b[z] | addrs.b[z]);
		while(bany(&amp;bit)) {
			i = bnum(bit);
			rgp-&gt;enter = r;
			rgp-&gt;varno = i;
			change = 0;
			if(debug['R'] &amp;&amp; debug['v'])
				print("\n");
			paint1(r, i);
			bit.b[i/32] &amp;= ~(1L&lt;&lt;(i%32));
			if(change &lt;= 0) {
				if(debug['R'])
					print("%L$%d: %B\n",
						r-&gt;prog-&gt;lineno, change, blsh(i));
				continue;
			}
			rgp-&gt;cost = change;
			nregion++;
			if(nregion &gt;= NRGN) {
				warn(Z, "too many regions");
				goto brk;
			}
			rgp++;
		}
	}
brk:
	qsort(region, nregion, sizeof(region[0]), rcmp);

	/*
	 * pass 6
	 * determine used registers (paint2)
	 * replace code (paint3)
	 */
	rgp = region;
	for(i=0; i&lt;nregion; i++) {
		bit = blsh(rgp-&gt;varno);
		vreg = paint2(rgp-&gt;enter, rgp-&gt;varno);
		vreg = allreg(vreg, rgp);
		if(debug['R']) {
			if(rgp-&gt;regno &gt;= NREG)
				print("%L$%d F%d: %B\n",
					rgp-&gt;enter-&gt;prog-&gt;lineno,
					rgp-&gt;cost,
					rgp-&gt;regno-NREG,
					bit);
			else
				print("%L$%d R%d: %B\n",
					rgp-&gt;enter-&gt;prog-&gt;lineno,
					rgp-&gt;cost,
					rgp-&gt;regno,
					bit);
		}
		if(rgp-&gt;regno != 0)
			paint3(rgp-&gt;enter, rgp-&gt;varno, vreg, rgp-&gt;regno);
		rgp++;
	}
	/*
	 * pass 7
	 * peep-hole on basic block
	 */
	if(!debug['R'] || debug['P'])
		peep();

	/*
	 * pass 8
	 * recalculate pc
	 */
	val = initpc;
	for(r = firstr; r != R; r = r1) {
		r-&gt;pc = val;
		p = r-&gt;prog;
		p1 = P;
		r1 = r-&gt;link;
		if(r1 != R)
			p1 = r1-&gt;prog;
		for(; p != p1; p = p-&gt;link) {
			switch(p-&gt;as) {
			default:
				val++;
				break;

			case ANOP:
			case ADATA:
			case AGLOBL:
			case ANAME:
			case ASIGNAME:
				break;
			}
		}
	}
	pc = val;

	/*
	 * fix up branches
	 */
	if(debug['R'])
		if(bany(&amp;addrs))
			print("addrs: %B\n", addrs);

	r1 = 0; /* set */
	for(r = firstr; r != R; r = r-&gt;link) {
		p = r-&gt;prog;
		if(p-&gt;to.type == D_BRANCH)
			p-&gt;to.offset = r-&gt;s2-&gt;pc;
		r1 = r;
	}

	/*
	 * last pass
	 * eliminate nops
	 * free aux structures
	 */
	for(p = firstr-&gt;prog; p != P; p = p-&gt;link){
		while(p-&gt;link &amp;&amp; p-&gt;link-&gt;as == ANOP)
			p-&gt;link = p-&gt;link-&gt;link;
	}
	if(r1 != R) {
		r1-&gt;link = freer;
		freer = firstr;
	}
}

/*
 * add mov b,rn
 * just after r
 */
void
addmove(Reg *r, int bn, int rn, int f)
{
	Prog *p, *p1;
	Adr *a;
	Var *v;

	p1 = alloc(sizeof(*p1));
	*p1 = zprog;
	p = r-&gt;prog;

	p1-&gt;link = p-&gt;link;
	p-&gt;link = p1;
	p1-&gt;lineno = p-&gt;lineno;

	v = var + bn;

	a = &amp;p1-&gt;to;
	a-&gt;sym = v-&gt;sym;
	a-&gt;name = v-&gt;name;
	a-&gt;offset = v-&gt;offset;
	a-&gt;etype = v-&gt;etype;
	a-&gt;type = D_OREG;
	if(a-&gt;etype == TARRAY || a-&gt;sym == S)
		a-&gt;type = D_CONST;

	p1-&gt;as = AMOVW;
	if(v-&gt;etype == TCHAR || v-&gt;etype == TUCHAR)
		p1-&gt;as = AMOVB;
	if(v-&gt;etype == TSHORT || v-&gt;etype == TUSHORT)
		p1-&gt;as = AMOVH;
	if(v-&gt;etype == TFLOAT)
		p1-&gt;as = AFMOVF;
	if(v-&gt;etype == TDOUBLE)
		p1-&gt;as = AFMOVD;

	p1-&gt;from.type = D_REG;
	p1-&gt;from.reg = rn;
	if(rn &gt;= NREG) {
		p1-&gt;from.type = D_FREG;
		p1-&gt;from.reg = rn-NREG;
	}
	if(!f) {
		p1-&gt;from = *a;
		*a = zprog.from;
		a-&gt;type = D_REG;
		a-&gt;reg = rn;
		if(rn &gt;= NREG) {
			a-&gt;type = D_FREG;
			a-&gt;reg = rn-NREG;
		}
		if(v-&gt;etype == TUCHAR)
			p1-&gt;as = AMOVBU;
		if(v-&gt;etype == TUSHORT)
			p1-&gt;as = AMOVHU;
	}
	if(debug['R'])
		print("%P\t.a%P\n", p, p1);
}

Bits
mkvar(Adr *a, int docon)
{
	Var *v;
	int i, t, n, et, z;
	long o;
	Bits bit;
	Sym *s;

	t = a-&gt;type;
	if(t == D_REG &amp;&amp; a-&gt;reg != NREG)
		regbits |= RtoB(a-&gt;reg);
	if(t == D_FREG &amp;&amp; a-&gt;reg != NREG)
		regbits |= FtoB(a-&gt;reg);
	s = a-&gt;sym;
	o = a-&gt;offset;
	et = a-&gt;etype;
	if(s == S) {
		if(t != D_CONST || !docon || a-&gt;reg != NREG)
			goto none;
		et = TLONG;
	}
	if(t == D_CONST) {
		if(s == S &amp;&amp; sval(o))
			goto none;
	}
	n = a-&gt;name;
	v = var;
	for(i=0; i&lt;nvar; i++) {
		if(s == v-&gt;sym)
		if(n == v-&gt;name)
		if(o == v-&gt;offset)
			goto out;
		v++;
	}
	if(s)
		if(s-&gt;name[0] == '.')
			goto none;
	if(nvar &gt;= NVAR) {
		if(debug['w'] &gt; 1 &amp;&amp; s)
			warn(Z, "variable not optimized: %s", s-&gt;name);
		goto none;
	}
	i = nvar;
	nvar++;
	v = &amp;var[i];
	v-&gt;sym = s;
	v-&gt;offset = o;
	v-&gt;etype = et;
	v-&gt;name = n;
	if(debug['R'])
		print("bit=%2d et=%2d %D\n", i, et, a);
out:
	bit = blsh(i);
	if(n == D_EXTERN || n == D_STATIC)
		for(z=0; z&lt;BITS; z++)
			externs.b[z] |= bit.b[z];
	if(n == D_PARAM)
		for(z=0; z&lt;BITS; z++)
			params.b[z] |= bit.b[z];
	if(v-&gt;etype != et || !typechlpfd[et])	/* funny punning */
		for(z=0; z&lt;BITS; z++)
			addrs.b[z] |= bit.b[z];
	if(t == D_CONST) {
		if(s == S) {
			for(z=0; z&lt;BITS; z++)
				consts.b[z] |= bit.b[z];
			return bit;
		}
		if(et != TARRAY)
			for(z=0; z&lt;BITS; z++)
				addrs.b[z] |= bit.b[z];
		for(z=0; z&lt;BITS; z++)
			params.b[z] |= bit.b[z];
		return bit;
	}
	if(t == D_OREG)
		return bit;

none:
	return zbits;
}

void
prop(Reg *r, Bits ref, Bits cal)
{
	Reg *r1, *r2;
	int z;

	for(r1 = r; r1 != R; r1 = r1-&gt;p1) {
		for(z=0; z&lt;BITS; z++) {
			ref.b[z] |= r1-&gt;refahead.b[z];
			if(ref.b[z] != r1-&gt;refahead.b[z]) {
				r1-&gt;refahead.b[z] = ref.b[z];
				change++;
			}
			cal.b[z] |= r1-&gt;calahead.b[z];
			if(cal.b[z] != r1-&gt;calahead.b[z]) {
				r1-&gt;calahead.b[z] = cal.b[z];
				change++;
			}
		}
		switch(r1-&gt;prog-&gt;as) {
		case AJMPL:
			for(z=0; z&lt;BITS; z++) {
				cal.b[z] |= ref.b[z] | externs.b[z];
				ref.b[z] = 0;
			}
			break;

		case ATEXT:
			for(z=0; z&lt;BITS; z++) {
				cal.b[z] = 0;
				ref.b[z] = 0;
			}
			break;

		case ARETURN:
			for(z=0; z&lt;BITS; z++) {
				cal.b[z] = externs.b[z];
				ref.b[z] = 0;
			}
		}
		for(z=0; z&lt;BITS; z++) {
			ref.b[z] = (ref.b[z] &amp; ~r1-&gt;set.b[z]) |
				r1-&gt;use1.b[z] | r1-&gt;use2.b[z];
			cal.b[z] &amp;= ~(r1-&gt;set.b[z] | r1-&gt;use1.b[z] | r1-&gt;use2.b[z]);
			r1-&gt;refbehind.b[z] = ref.b[z];
			r1-&gt;calbehind.b[z] = cal.b[z];
		}
		if(r1-&gt;active)
			break;
		r1-&gt;active = 1;
	}
	for(; r != r1; r = r-&gt;p1)
		for(r2 = r-&gt;p2; r2 != R; r2 = r2-&gt;p2link)
			prop(r2, r-&gt;refbehind, r-&gt;calbehind);
}


/*
 * find looping structure
 *
 * 1) find reverse postordering
 * 2) find approximate dominators,
 *	the actual dominators if the flow graph is reducible
 *	otherwise, dominators plus some other non-dominators.
 *	See Matthew S. Hecht and Jeffrey D. Ullman,
 *	"Analysis of a Simple Algorithm for Global Data Flow Problems",
 *	Conf.  Record of ACM Symp. on Principles of Prog. Langs, Boston, Massachusetts,
 *	Oct. 1-3, 1973, pp.  207-217.
 * 3) find all nodes with a predecessor dominated by the current node.
 *	such a node is a loop head.
 *	recursively, all preds with a greater rpo number are in the loop
 */
long
postorder(Reg *r, Reg **rpo2r, long n)
{
	Reg *r1;

	r-&gt;rpo = 1;
	r1 = r-&gt;s1;
	if(r1 &amp;&amp; !r1-&gt;rpo)
		n = postorder(r1, rpo2r, n);
	r1 = r-&gt;s2;
	if(r1 &amp;&amp; !r1-&gt;rpo)
		n = postorder(r1, rpo2r, n);
	rpo2r[n] = r;
	n++;
	return n;
}

long
rpolca(long *idom, long rpo1, long rpo2)
{
	long t;

	if(rpo1 == -1)
		return rpo2;
	while(rpo1 != rpo2){
		if(rpo1 &gt; rpo2){
			t = rpo2;
			rpo2 = rpo1;
			rpo1 = t;
		}
		while(rpo1 &lt; rpo2){
			t = idom[rpo2];
			if(t &gt;= rpo2)
				fatal(Z, "bad idom");
			rpo2 = t;
		}
	}
	return rpo1;
}

int
doms(long *idom, long r, long s)
{
	while(s &gt; r)
		s = idom[s];
	return s == r;
}

int
loophead(long *idom, Reg *r)
{
	long src;

	src = r-&gt;rpo;
	if(r-&gt;p1 != R &amp;&amp; doms(idom, src, r-&gt;p1-&gt;rpo))
		return 1;
	for(r = r-&gt;p2; r != R; r = r-&gt;p2link)
		if(doms(idom, src, r-&gt;rpo))
			return 1;
	return 0;
}

void
loopmark(Reg **rpo2r, long head, Reg *r)
{
	if(r-&gt;rpo &lt; head || r-&gt;active == head)
		return;
	r-&gt;active = head;
	r-&gt;loop += LOOP;
	if(r-&gt;p1 != R)
		loopmark(rpo2r, head, r-&gt;p1);
	for(r = r-&gt;p2; r != R; r = r-&gt;p2link)
		loopmark(rpo2r, head, r);
}

void
loopit(Reg *r, long nr)
{
	Reg *r1;
	long i, d, me;

	if(nr &gt; maxnr) {
		rpo2r = alloc(nr * sizeof(Reg*));
		idom = alloc(nr * sizeof(long));
		maxnr = nr;
	}

	d = postorder(r, rpo2r, 0);
	if(d &gt; nr)
		fatal(Z, "too many reg nodes");
	nr = d;
	for(i = 0; i &lt; nr / 2; i++){
		r1 = rpo2r[i];
		rpo2r[i] = rpo2r[nr - 1 - i];
		rpo2r[nr - 1 - i] = r1;
	}
	for(i = 0; i &lt; nr; i++)
		rpo2r[i]-&gt;rpo = i;

	idom[0] = 0;
	for(i = 0; i &lt; nr; i++){
		r1 = rpo2r[i];
		me = r1-&gt;rpo;
		d = -1;
		if(r1-&gt;p1 != R &amp;&amp; r1-&gt;p1-&gt;rpo &lt; me)
			d = r1-&gt;p1-&gt;rpo;
		for(r1 = r1-&gt;p2; r1 != nil; r1 = r1-&gt;p2link)
			if(r1-&gt;rpo &lt; me)
				d = rpolca(idom, d, r1-&gt;rpo);
		idom[i] = d;
	}

	for(i = 0; i &lt; nr; i++){
		r1 = rpo2r[i];
		r1-&gt;loop++;
		if(r1-&gt;p2 != R &amp;&amp; loophead(idom, r1))
			loopmark(rpo2r, i, r1);
	}
}

void
synch(Reg *r, Bits dif)
{
	Reg *r1;
	int z;

	for(r1 = r; r1 != R; r1 = r1-&gt;s1) {
		for(z=0; z&lt;BITS; z++) {
			dif.b[z] = (dif.b[z] &amp;
				~(~r1-&gt;refbehind.b[z] &amp; r1-&gt;refahead.b[z])) |
					r1-&gt;set.b[z] | r1-&gt;regdiff.b[z];
			if(dif.b[z] != r1-&gt;regdiff.b[z]) {
				r1-&gt;regdiff.b[z] = dif.b[z];
				change++;
			}
		}
		if(r1-&gt;active)
			break;
		r1-&gt;active = 1;
		for(z=0; z&lt;BITS; z++)
			dif.b[z] &amp;= ~(~r1-&gt;calbehind.b[z] &amp; r1-&gt;calahead.b[z]);
		if(r1-&gt;s2 != R)
			synch(r1-&gt;s2, dif);
	}
}

ulong
allreg(ulong b, Rgn *r)
{
	Var *v;
	int i;

	v = var + r-&gt;varno;
	r-&gt;regno = 0;
	switch(v-&gt;etype) {

	default:
		diag(Z, "unknown etype %d/%d", bitno(b), v-&gt;etype);
		break;

	case TCHAR:
	case TUCHAR:
	case TSHORT:
	case TUSHORT:
	case TINT:
	case TUINT:
	case TLONG:
	case TULONG:
	case TIND:
	case TARRAY:
		i = BtoR(~b);
		if(i &amp;&amp; r-&gt;cost &gt; 0) {
			r-&gt;regno = i;
			return RtoB(i);
		}
		break;

	case TDOUBLE:
	case TFLOAT:
		i = BtoF(~b);
		if(i &amp;&amp; r-&gt;cost &gt; 0) {
			r-&gt;regno = i+NREG;
			return FtoB(i);
		}
		break;
	}
	return 0;
}

void
paint1(Reg *r, int bn)
{
	Reg *r1;
	Prog *p;
	int z;
	ulong bb;

	z = bn/32;
	bb = 1L&lt;&lt;(bn%32);
	if(r-&gt;act.b[z] &amp; bb)
		return;
	for(;;) {
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
		r1 = r-&gt;p1;
		if(r1 == R)
			break;
		if(!(r1-&gt;refahead.b[z] &amp; bb))
			break;
		if(r1-&gt;act.b[z] &amp; bb)
			break;
		r = r1;
	}

	if(LOAD(r) &amp; ~(r-&gt;set.b[z]&amp;~(r-&gt;use1.b[z]|r-&gt;use2.b[z])) &amp; bb) {
		change -= CLOAD * r-&gt;loop;
		if(debug['R'] &amp;&amp; debug['v'])
			print("%ld%P\tld %B $%d\n", r-&gt;loop,
				r-&gt;prog, blsh(bn), change);
	}
	for(;;) {
		r-&gt;act.b[z] |= bb;
		p = r-&gt;prog;

		if(r-&gt;use1.b[z] &amp; bb) {
			change += CREF * r-&gt;loop;
			if(p-&gt;to.type == D_FREG &amp;&amp; p-&gt;as == AMOVW)
				change = -CINF;		/* cant go Rreg to Freg */
			if(debug['R'] &amp;&amp; debug['v'])
				print("%ld%P\tu1 %B $%d\n", r-&gt;loop,
					p, blsh(bn), change);
		}

		if((r-&gt;use2.b[z]|r-&gt;set.b[z]) &amp; bb) {
			change += CREF * r-&gt;loop;
			if(p-&gt;from.type == D_FREG &amp;&amp; p-&gt;as == AMOVW)
				change = -CINF;		/* cant go Rreg to Freg */
			if(debug['R'] &amp;&amp; debug['v'])
				print("%ld%P\tu2 %B $%d\n", r-&gt;loop,
					p, blsh(bn), change);
		}

		if(STORE(r) &amp; r-&gt;regdiff.b[z] &amp; bb) {
			change -= CLOAD * r-&gt;loop;
			if(debug['R'] &amp;&amp; debug['v'])
				print("%ld%P\tst %B $%d\n", r-&gt;loop,
					p, blsh(bn), change);
		}

		if(r-&gt;refbehind.b[z] &amp; bb)
			for(r1 = r-&gt;p2; r1 != R; r1 = r1-&gt;p2link)
				if(r1-&gt;refahead.b[z] &amp; bb)
					paint1(r1, bn);

		if(!(r-&gt;refahead.b[z] &amp; bb))
			break;
		r1 = r-&gt;s2;
		if(r1 != R)
			if(r1-&gt;refbehind.b[z] &amp; bb)
				paint1(r1, bn);
		r = r-&gt;s1;
		if(r == R)
			break;
		if(r-&gt;act.b[z] &amp; bb)
			break;
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
	}
}

ulong
paint2(Reg *r, int bn)
{
	Reg *r1;
	int z;
	ulong bb, vreg;

	z = bn/32;
	bb = 1L &lt;&lt; (bn%32);
	vreg = regbits;
	if(!(r-&gt;act.b[z] &amp; bb))
		return vreg;
	for(;;) {
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
		r1 = r-&gt;p1;
		if(r1 == R)
			break;
		if(!(r1-&gt;refahead.b[z] &amp; bb))
			break;
		if(!(r1-&gt;act.b[z] &amp; bb))
			break;
		r = r1;
	}
	for(;;) {
		r-&gt;act.b[z] &amp;= ~bb;

		vreg |= r-&gt;regu;

		if(r-&gt;refbehind.b[z] &amp; bb)
			for(r1 = r-&gt;p2; r1 != R; r1 = r1-&gt;p2link)
				if(r1-&gt;refahead.b[z] &amp; bb)
					vreg |= paint2(r1, bn);

		if(!(r-&gt;refahead.b[z] &amp; bb))
			break;
		r1 = r-&gt;s2;
		if(r1 != R)
			if(r1-&gt;refbehind.b[z] &amp; bb)
				vreg |= paint2(r1, bn);
		r = r-&gt;s1;
		if(r == R)
			break;
		if(!(r-&gt;act.b[z] &amp; bb))
			break;
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
	}
	return vreg;
}

void
paint3(Reg *r, int bn, long rb, int rn)
{
	Reg *r1;
	Prog *p;
	int z;
	ulong bb;

	z = bn/32;
	bb = 1L &lt;&lt; (bn%32);
	if(r-&gt;act.b[z] &amp; bb)
		return;
	for(;;) {
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
		r1 = r-&gt;p1;
		if(r1 == R)
			break;
		if(!(r1-&gt;refahead.b[z] &amp; bb))
			break;
		if(r1-&gt;act.b[z] &amp; bb)
			break;
		r = r1;
	}

	if(LOAD(r) &amp; ~(r-&gt;set.b[z] &amp; ~(r-&gt;use1.b[z]|r-&gt;use2.b[z])) &amp; bb)
		addmove(r, bn, rn, 0);
	for(;;) {
		r-&gt;act.b[z] |= bb;
		p = r-&gt;prog;

		if(r-&gt;use1.b[z] &amp; bb) {
			if(debug['R'])
				print("%P", p);
			addreg(&amp;p-&gt;from, rn);
			if(debug['R'])
				print("\t.c%P\n", p);
		}
		if((r-&gt;use2.b[z]|r-&gt;set.b[z]) &amp; bb) {
			if(debug['R'])
				print("%P", p);
			addreg(&amp;p-&gt;to, rn);
			if(debug['R'])
				print("\t.c%P\n", p);
		}

		if(STORE(r) &amp; r-&gt;regdiff.b[z] &amp; bb)
			addmove(r, bn, rn, 1);
		r-&gt;regu |= rb;

		if(r-&gt;refbehind.b[z] &amp; bb)
			for(r1 = r-&gt;p2; r1 != R; r1 = r1-&gt;p2link)
				if(r1-&gt;refahead.b[z] &amp; bb)
					paint3(r1, bn, rb, rn);

		if(!(r-&gt;refahead.b[z] &amp; bb))
			break;
		r1 = r-&gt;s2;
		if(r1 != R)
			if(r1-&gt;refbehind.b[z] &amp; bb)
				paint3(r1, bn, rb, rn);
		r = r-&gt;s1;
		if(r == R)
			break;
		if(r-&gt;act.b[z] &amp; bb)
			break;
		if(!(r-&gt;refbehind.b[z] &amp; bb))
			break;
	}
}

void
addreg(Adr *a, int rn)
{

	a-&gt;sym = 0;
	a-&gt;name = D_NONE;
	a-&gt;type = D_REG;
	a-&gt;reg = rn;
	if(rn &gt;= NREG) {
		a-&gt;type = D_FREG;
		a-&gt;reg = rn-NREG;
	}
}

/*
 *	bit	reg
 *	0	R9
 *	1	R10
 *	...	...
 *	4	R13
 *	5	R16
 *	...	...
 *	20	R31
 */
long
RtoB(int r)
{

	if(r &gt;= 9 &amp;&amp; r &lt;= 13)
		return 1L &lt;&lt; (r-9);
	if(r &gt;= 16 &amp;&amp; r &lt;= 31)
		return 1L &lt;&lt; (r-11);
	return 0;
}

int
BtoR(long b)
{
	int r;

	b &amp;= 0x001fffffL;
	if(b == 0)
		return 0;
	r = bitno(b) + 9;
	if(r &gt;= 14)
		r += 2;
	return r;
}

/*
 *	bit	reg
 *	22	F4
 *	23	F6
 *	...	...
 *	31	F22
 */
long
FtoB(int f)
{

	if(f &lt; 4 || f &gt; 22 || (f&amp;1))
		return 0;
	return 1L &lt;&lt; (f/2 + 20);
}

BtoF(long b)
{

	b &amp;= 0xffc00000L;
	if(b == 0)
		return 0;
	return bitno(b)*2 - 40;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

