<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ki/stats.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ki/stats.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "sparc.h"

#define prof profki
#define Percent(num, max)	(((num)*100)/(max))

extern Inst op0[], op2[], op3[];
Inst *tables[] = { op0, op2, op3, 0 };

void
isum(void)
{
	Inst *i;
	int pct, j;
	int total, loads, stores, arith, branch;
	int useddelay, taken, sparcreg, syscall, realarith;

	total = 0;
	loads = 0;
	stores = 0;
	arith = 0;
	branch = 0;
	useddelay = 0;
	taken = 0;
	sparcreg = 0;
	syscall = 0;
	realarith = 0;

	/* Compute the total so we can have percentages */
	for(j = 0; tables[j]; j++)
		for(i = tables[j]; i-&gt;func; i++)
			if(i-&gt;name &amp;&amp; i-&gt;count)
				total += i-&gt;count;

	Bprint(bioout, "\nInstruction summary.\n\n");

	for(j = 0; tables[j]; j++) {
		for(i =tables[j]; i-&gt;func; i++) {
			if(i-&gt;name) {
				if(i-&gt;count == 0)
					continue;
				pct = Percent(i-&gt;count, total);
				if(pct != 0)
					Bprint(bioout, "%-8ud %3d%% %s\n",
					i-&gt;count, Percent(i-&gt;count, total), i-&gt;name);
				else
					Bprint(bioout, "%-8ud      %s\n",
					i-&gt;count, i-&gt;name);
	
				switch(i-&gt;type) {
				default:
					fatal(0, "isum bad stype %d\n", i-&gt;type);
				case Iload:
					loads += i-&gt;count;
					break;
				case Istore:
					stores += i-&gt;count;
					break;
				case Iarith:
					arith += i-&gt;count;
					break;
				case Ibranch:
					branch += i-&gt;count;
					taken += i-&gt;taken;
					useddelay += i-&gt;useddelay;
					break;
				case Ireg:
					sparcreg += i-&gt;count;
					break;
				case Isyscall:
					syscall += i-&gt;count;
					break;
				case Ifloat:
					realarith += i-&gt;count;
					break;
				case Inop:
					arith += i-&gt;count;
					i-&gt;count -= nopcount;
					break;
				}
			}
		}
	}

	total += anulled;
	Bprint(bioout, "\n%-8ud      Memory cycles\n", loads+stores+total);
	
	Bprint(bioout, "%-8ud %3d%% Instruction cycles\n",
				total, Percent(total, loads+stores+total));
	Bprint(bioout, "%-8lud %3ld%% Annulled branch cycles\n",
				anulled, Percent(anulled, total));

	Bprint(bioout, "%-8ud %3d%% Data cycles\n\n",
				loads+stores, Percent(loads+stores, loads+stores+total));	

	Bprint(bioout, "%-8ud %3d%% Stores\n", stores, Percent(stores, total));

	Bprint(bioout, "%-8ud %3d%% Loads\n", loads, Percent(loads, total));

	Bprint(bioout, "   %-8ud Store stall\n", stores*2);

	Bprint(bioout, "   %-8lud Load stall\n", loadlock);

	Bprint(bioout, "%-8ud %3d%% Arithmetic\n", arith, Percent(arith, total));

	Bprint(bioout, "%-8ud %3d%% Floating point\n",
					realarith, Percent(realarith, total));

	Bprint(bioout, "%-8ud %3d%% Sparc special register load/stores\n",
					sparcreg, Percent(sparcreg, total));

	Bprint(bioout, "%-8ud %3d%% System calls\n", syscall, Percent(syscall, total));

	Bprint(bioout, "%-8ud %3d%% Branches\n", branch, Percent(branch, total));

	Bprint(bioout, "   %-8ud %3d%% Branches taken\n",
					taken, Percent(taken, branch));

	Bprint(bioout, "   %-8ud %3d%% Delay slots\n",
					useddelay, Percent(useddelay, branch));

	Bprint(bioout, "   %-8ud %3d%% Unused delay slots\n", 
					nopcount, Percent(nopcount, branch));

	Bprint(bioout, "%-8ud %3d%% Program total delay slots\n",
					nopcount, Percent(nopcount, total));
}

char *stype[] = { "Stack", "Text", "Data", "Bss" };

void
segsum(void)
{
	Segment *s;
	int i;

	Bprint(bioout, "\n\nMemory Summary\n\n");
	Bprint(bioout, "      Base     End      Resident References\n");
	for(i = 0; i &lt; Nseg; i++) {
		s = &amp;memory.seg[i];
		Bprint(bioout, "%-5s %.8lux %.8lux %-8d %-8d\n",
				stype[i], s-&gt;base, s-&gt;end, s-&gt;rss*BY2PG, s-&gt;refs);
	}
}

typedef struct Prof Prof;
struct Prof
{
	Symbol	s;
	long	count;
};
Prof	prof[5000];

int
profcmp(void *va, void *vb)
{
	Prof *a, *b;

	a = va;
	b = vb;
	return b-&gt;count - a-&gt;count;
}

void
iprofile(void)
{
	Prof *p, *n;
	int i, b, e;
	ulong total;
	extern ulong textbase;

	i = 0;
	p = prof;
	if(textsym(&amp;p-&gt;s, i) == 0)
		return;
	i++;
	for(;;) {
		n = p+1;
		if(textsym(&amp;n-&gt;s, i) == 0)
			break;
		b = (p-&gt;s.value-textbase)/PROFGRAN;
		e = (n-&gt;s.value-textbase)/PROFGRAN;
		while(b &lt; e)
			p-&gt;count += iprof[b++];
		i++;
		p = n;
	}

	qsort(prof, i, sizeof(Prof), profcmp);

	total = 0;
	for(b = 0; b &lt; i; b++)
		total += prof[b].count;

	Bprint(bioout, "  cycles     %% symbol          file\n");
	for(b = 0; b &lt; i; b++) {
		if(prof[b].count == 0)
			continue;

		Bprint(bioout, "%8ld %3ld.%ld %-15s ",
			prof[b].count,
			100*prof[b].count/total,
			(1000*prof[b].count/total)%10,
			prof[b].s.name);

		printsource(prof[b].s.value);
		Bputc(bioout, '\n');
	}
	memset(prof, 0, sizeof(Prof)*i);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

