<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/kl/sched.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/kl/sched.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

enum
{
	E_ICC	= 1&lt;&lt;0,
	E_FCC	= 1&lt;&lt;1,
	E_MEM	= 1&lt;&lt;2,
	E_MEMSP	= 1&lt;&lt;3,	/* uses offset and size */
	E_MEMSB	= 1&lt;&lt;4,	/* uses offset and size */
	ANYMEM	= E_MEM|E_MEMSP|E_MEMSB,
	ALL	= ~0
};

typedef	struct	Sch	Sch;
typedef	struct	Dep	Dep;

struct	Dep
{
	ulong	ireg;
	ulong	freg;
	ulong	cc;
};
struct	Sch
{
	Prog	p;
	Dep	set;
	Dep	used;
	long	soffset;
	char	size;
	char	nop;
	char	comp;
};

void	regsused(Sch*, Prog*);
int	depend(Sch*, Sch*);
int	conflict(Sch*, Sch*);
int	offoverlap(Sch*, Sch*);
void	dumpbits(Sch*, Dep*);

void
sched(Prog *p0, Prog *pe)
{
	Prog *p, *q;
	Sch sch[NSCHED], *s, *t, *u, *se, stmp;

	/*
	 * build side structure
	 */
	s = sch;
	for(p=p0;; p=p-&gt;link) {
		memset(s, 0, sizeof(*s));
		s-&gt;p = *p;
		regsused(s, p);
		if(debug['X']) {
			Bprint(&amp;bso, "%P\tset", &amp;s-&gt;p);
			dumpbits(s, &amp;s-&gt;set);
			Bprint(&amp;bso, "; used");
			dumpbits(s, &amp;s-&gt;used);
			if(s-&gt;comp)
				Bprint(&amp;bso, "; compound");
			if(s-&gt;p.mark &amp; LOAD)
				Bprint(&amp;bso, "; load");
			if(s-&gt;p.mark &amp; BRANCH)
				Bprint(&amp;bso, "; branch");
			if(s-&gt;p.mark &amp; FCMP)
				Bprint(&amp;bso, "; fcmp");
			Bprint(&amp;bso, "\n");
		}
		s++;
		if(p == pe)
			break;
	}
	se = s;

	for(s=se-1; s&gt;=sch; s--) {
		/*
		 * branch delay slot
		 */
		if(s-&gt;p.mark &amp; BRANCH) {
			/* t is the trial instruction to use */
			for(t=s-1; t&gt;=sch; t--) {
				if(t-&gt;comp || (t-&gt;p.mark &amp; FCMP))
					goto no1;
				for(u=t+1; u&lt;=s; u++)
					if(depend(u, t))
						goto no1;
				goto out1;
			no1:;
			}
			if(debug['X'])
				Bprint(&amp;bso, "?b%P\n", &amp;s-&gt;p);
			s-&gt;nop = 1;
			continue;

		out1:
			if(debug['X']) {
				Bprint(&amp;bso, "!b%P\n", &amp;t-&gt;p);
				Bprint(&amp;bso, "%P\n", &amp;s-&gt;p);
			}
			stmp = *t;
			memmove(t, t+1, (uchar*)s - (uchar*)t);
			*s = stmp;
			s--;
			continue;
		}

		/*
		 * load delay. interlocked.
		 */
		if(s-&gt;p.mark &amp; LOAD) {
			if(s &gt;= se-1)
				continue;
			if(!conflict(s, (s+1)))
				continue;
			/*
			 * s is load, s+1 is immediate use of result
			 * t is the trial instruction to insert between s and s+1
			 */
			for(t=s-1; t&gt;=sch; t--) {
				if(t-&gt;p.mark &amp; BRANCH)
					goto no2;
				if(t-&gt;p.mark &amp; FCMP)
					if((s+1)-&gt;p.mark &amp; BRANCH)
						goto no2;
				if(t-&gt;p.mark &amp; LOAD)
					if(conflict(t, (s+1)))
						goto no2;
				for(u=t+1; u&lt;=s; u++)
					if(depend(u, t))
						goto no2;
				goto out2;
			no2:;
			}
			if(debug['X'])
				Bprint(&amp;bso, "?l%P\n", &amp;s-&gt;p);
			continue;
		out2:
			if(debug['X']) {
				Bprint(&amp;bso, "!l%P\n", &amp;t-&gt;p);
				Bprint(&amp;bso, "%P\n", &amp;s-&gt;p);
			}
			stmp = *t;
			memmove(t, t+1, (uchar*)s - (uchar*)t);
			*s = stmp;
			s--;
			continue;
		}

		/*
		 * fop2 delay.
		 */
		if(s-&gt;p.mark &amp; FCMP) {
			if(s &gt;= se-1) {
				s-&gt;nop = 1;
				continue;
			}
			if(!((s+1)-&gt;p.mark &amp; BRANCH))
				continue;
			/* t is the trial instruction to use */
			for(t=s-1; t&gt;=sch; t--) {
				for(u=t+1; u&lt;=s; u++)
					if(depend(u, t))
						goto no3;
				goto out3;
			no3:;
			}
			if(debug['X'])
				Bprint(&amp;bso, "?f%P\n", &amp;s-&gt;p);
			s-&gt;nop = 1;
			continue;
		out3:
			if(debug['X']) {
				Bprint(&amp;bso, "!f%P\n", &amp;t-&gt;p);
				Bprint(&amp;bso, "%P\n", &amp;s-&gt;p);
			}
			stmp = *t;
			memmove(t, t+1, (uchar*)s - (uchar*)t);
			*s = stmp;
			s--;
			continue;
		}
	}

	/*
	 * put it all back
	 */
	for(s=sch, p=p0; s&lt;se; s++, p=q) {
		q = p-&gt;link;
		if(q != s-&gt;p.link) {
			*p = s-&gt;p;
			p-&gt;link = q;
		}
		if(s-&gt;nop)
			addnop(p);
	}
	if(debug['X'])
		Bprint(&amp;bso, "\n");
}

void
regsused(Sch *s, Prog *realp)
{
	int c, ar, ad, ld, sz;
	ulong m;
	Prog *p;

	p = &amp;s-&gt;p;
	s-&gt;comp = compound(p);
	s-&gt;nop = 0;
	if(s-&gt;comp) {
		s-&gt;set.ireg |= 1&lt;&lt;REGTMP;
		s-&gt;used.ireg |= 1&lt;&lt;REGTMP;
	}
	ar = 0;		/* dest is really reference */
	ad = 0;		/* source/dest is really address */
	ld = 0;		/* opcode is load instruction */
	sz = 20;		/* size of load/store for overlap computation */

/*
 * flags based on opcode
 */
	switch(p-&gt;as) {
	case ATEXT:
		curtext = realp;
		autosize = p-&gt;to.offset + 4;
		ad = 1;
		break;
	case AJMPL:
		c = p-&gt;reg;
		if(c == NREG)
			c = REGLINK;
		s-&gt;set.ireg |= 1&lt;&lt;c;
		ar = 1;
		ad = 1;
		break;
	case AJMP:
		ar = 1;
		ad = 1;
		break;
	case ACMP:
		s-&gt;set.cc |= E_ICC;
		ar = 1;
		break;
	case AFCMPD:
	case AFCMPED:
	case AFCMPEF:
	case AFCMPEX:
	case AFCMPF:
	case AFCMPX:
		s-&gt;set.cc |= E_FCC;
		ar = 1;
		break;
	case ABE:
	case ABNE:
	case ABLE:
	case ABG:
	case ABL:
	case ABGE:
	case ABLEU:
	case ABGU:
	case ABCS:
	case ABCC:
	case ABNEG:
	case ABPOS:
	case ABVC:
	case ABVS:
		s-&gt;used.cc |= E_ICC;
		ar = 1;
		break;
	case AFBE:
	case AFBLG:
	case AFBG:
	case AFBLE:
	case AFBGE:
	case AFBL:
		s-&gt;used.cc |= E_FCC;
		ar = 1;
		break;
	case AMOVB:
	case AMOVBU:
		sz = 1;
		ld = 1;
		break;
	case AMOVH:
	case AMOVHU:
		sz = 2;
		ld = 1;
		break;
	case AFMOVF:
	case AMOVW:
		sz = 4;
		ld = 1;
		break;
	case AMOVD:
	case AFMOVD:
		sz = 8;
		ld = 1;
		break;
	case AFMOVX:	/* gok */
		sz = 16;
		ld = 1;
		break;
	case AADDCC:
	case AADDXCC:
	case AANDCC:
	case AANDNCC:
	case AORCC:
	case AORNCC:
	case ASUBCC:
	case ASUBXCC:
	case ATADDCC:
	case ATADDCCTV:
	case ATSUBCC:
	case ATSUBCCTV:
	case AXNORCC:
	case AXORCC:
		s-&gt;set.cc |= E_ICC;
		break;
	case ADIV:
	case ADIVL:
	case AMOD:
	case AMODL:
	case AMUL:
	case AMULSCC:
	case ATAS:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		break;
	}

/*
 * flags based on 'to' field
 */
	c = p-&gt;to.class;
	if(c == 0) {
		c = aclass(&amp;p-&gt;to) + 1;
		p-&gt;to.class = c;
	}
	c--;
	switch(c) {
	default:
		print("unknown class %d %D\n", c, &amp;p-&gt;to);

	case C_ZCON:
	case C_SCON:
	case C_UCON:
	case C_LCON:
	case C_NONE:
	case C_SBRA:
	case C_LBRA:
		break;
	case C_CREG:
	case C_FSR:
	case C_FQ:
	case C_PREG:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		break;
	case C_ZOREG:
	case C_SOREG:
	case C_LOREG:
	case C_ASI:
		c = p-&gt;to.reg;
		s-&gt;used.ireg |= 1&lt;&lt;c;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		m = ANYMEM;
		if(c == REGSB)
			m = E_MEMSB;
		if(c == REGSP)
			m = E_MEMSP;

		if(ar)
			s-&gt;used.cc |= m;
		else
			s-&gt;set.cc |= m;
		break;
	case C_SACON:
	case C_LACON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		break;
	case C_SECON:
	case C_LECON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		break;
	case C_REG:
		if(ar)
			s-&gt;used.ireg |= 1&lt;&lt;p-&gt;to.reg;
		else
			s-&gt;set.ireg |= 1&lt;&lt;p-&gt;to.reg;
		break;
	case C_FREG:
		/* do better -- determine double prec */
		if(ar) {
			s-&gt;used.freg |= 1&lt;&lt;p-&gt;to.reg;
			s-&gt;used.freg |= 1&lt;&lt;(p-&gt;to.reg|1);
		} else {
			s-&gt;set.freg |= 1&lt;&lt;p-&gt;to.reg;
			s-&gt;set.freg |= 1&lt;&lt;(p-&gt;to.reg|1);
		}
		break;
	case C_SAUTO:
	case C_LAUTO:
	case C_ESAUTO:
	case C_OSAUTO:
	case C_ELAUTO:
	case C_OLAUTO:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		if(ar)
			s-&gt;used.cc |= E_MEMSP;
		else
			s-&gt;set.cc |= E_MEMSP;
		break;
	case C_SEXT:
	case C_LEXT:
	case C_ESEXT:
	case C_OSEXT:
	case C_ELEXT:
	case C_OLEXT:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;to);

		if(ar)
			s-&gt;used.cc |= E_MEMSB;
		else
			s-&gt;set.cc |= E_MEMSB;
		break;
	}

/*
 * flags based on 'from' field
 */
	c = p-&gt;from.class;
	if(c == 0) {
		c = aclass(&amp;p-&gt;from) + 1;
		p-&gt;from.class = c;
	}
	c--;
	switch(c) {
	default:
		print("unknown class %d %D\n", c, &amp;p-&gt;from);

	case C_ZCON:
	case C_SCON:
	case C_UCON:
	case C_LCON:
	case C_NONE:
	case C_SBRA:
	case C_LBRA:
		c = p-&gt;from.reg;
		if(c != NREG)
			s-&gt;used.ireg |= 1&lt;&lt;c;
		break;
	case C_CREG:
	case C_FSR:
	case C_FQ:
	case C_PREG:
		s-&gt;set.ireg = ALL;
		s-&gt;set.freg = ALL;
		s-&gt;set.cc = ALL;
		break;
	case C_ZOREG:
	case C_SOREG:
	case C_LOREG:
	case C_ASI:
		c = p-&gt;from.reg;
		s-&gt;used.ireg |= 1&lt;&lt;c;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		m = ANYMEM;
		if(c == REGSB)
			m = E_MEMSB;
		if(c == REGSP)
			m = E_MEMSP;

		s-&gt;used.cc |= m;
		break;
	case C_SACON:
	case C_LACON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		break;
	case C_SECON:
	case C_LECON:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		break;
	case C_REG:
		s-&gt;used.ireg |= 1&lt;&lt;p-&gt;from.reg;
		break;
	case C_FREG:
		/* do better -- determine double prec */
		s-&gt;used.freg |= 1&lt;&lt;p-&gt;from.reg;
		s-&gt;used.freg |= 1&lt;&lt;(p-&gt;from.reg|1);
		break;
	case C_SAUTO:
	case C_LAUTO:
	case C_ESAUTO:
	case C_ELAUTO:
	case C_OSAUTO:
	case C_OLAUTO:
		s-&gt;used.ireg |= 1&lt;&lt;REGSP;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		s-&gt;used.cc |= E_MEMSP;
		break;
	case C_SEXT:
	case C_LEXT:
	case C_ESEXT:
	case C_ELEXT:
	case C_OSEXT:
	case C_OLEXT:
		s-&gt;used.ireg |= 1&lt;&lt;REGSB;
		if(ld)
			p-&gt;mark |= LOAD;
		if(ad)
			break;
		s-&gt;size = sz;
		s-&gt;soffset = regoff(&amp;p-&gt;from);

		s-&gt;used.cc |= E_MEMSB;
		break;
	}
	
	c = p-&gt;reg;
	if(c != NREG) {
		if(p-&gt;from.type == D_FREG || p-&gt;to.type == D_FREG) {
			s-&gt;used.freg |= 1&lt;&lt;c;
			s-&gt;used.freg |= 1&lt;&lt;(c|1);
		} else
			s-&gt;used.ireg |= 1&lt;&lt;c;
	}
	s-&gt;set.ireg &amp;= ~(1&lt;&lt;0);		/* R0 cant be set */
}

/*
 * test to see if 2 instrictions can be
 * interchanged without changing semantics
 */
int
depend(Sch *sa, Sch *sb)
{
	ulong x;

	if(sa-&gt;set.ireg &amp; (sb-&gt;set.ireg|sb-&gt;used.ireg))
		return 1;
	if(sb-&gt;set.ireg &amp; sa-&gt;used.ireg)
		return 1;

	if(sa-&gt;set.freg &amp; (sb-&gt;set.freg|sb-&gt;used.freg))
		return 1;
	if(sb-&gt;set.freg &amp; sa-&gt;used.freg)
		return 1;

	x = (sa-&gt;set.cc &amp; (sb-&gt;set.cc|sb-&gt;used.cc)) |
		(sb-&gt;set.cc &amp; sa-&gt;used.cc);
	if(x) {
		/*
		 * allow SB and SP to pass each other.
		 * allow SB to pass SB iff doffsets are ok
		 * anything else conflicts
		 */
		if(x != E_MEMSP &amp;&amp; x != E_MEMSB)
			return 1;
		x = sa-&gt;set.cc | sb-&gt;set.cc |
			sa-&gt;used.cc | sb-&gt;used.cc;
		if(x &amp; E_MEM)
			return 1;
		if(offoverlap(sa, sb))
			return 1;
	}

	return 0; 
}

int
offoverlap(Sch *sa, Sch *sb)
{

	if(sa-&gt;soffset &lt; sb-&gt;soffset) {
		if(sa-&gt;soffset+sa-&gt;size &gt; sb-&gt;soffset)
			return 1;
		return 0;
	}
	if(sb-&gt;soffset+sb-&gt;size &gt; sa-&gt;soffset)
		return 1;
	return 0;
}

/*
 * test 2 adjacent instructions
 * and find out if inserted instructions
 * are desired to prevent stalls.
 * first instruction is a load instruction.
 */
int
conflict(Sch *sa, Sch *sb)
{

	if(sa-&gt;set.ireg &amp; sb-&gt;used.ireg)
		return 1;
	if(sa-&gt;set.freg &amp; sb-&gt;used.freg)
		return 1;
	return 0;
}

int
compound(Prog *p)
{
	Optab *o;

	o = oplook(p);
	if(o-&gt;size != 4)
		return 1;
	if(p-&gt;to.type == D_REG &amp;&amp; p-&gt;to.reg == REGSB)
		return 1;
	return 0;
}

void
dumpbits(Sch *s, Dep *d)
{
	int i;

	for(i=0; i&lt;32; i++)
		if(d-&gt;ireg &amp; (1&lt;&lt;i))
			Bprint(&amp;bso, " R%d", i);
	for(i=0; i&lt;32; i++)
		if(d-&gt;freg &amp; (1&lt;&lt;i))
			Bprint(&amp;bso, " F%d", i);
	for(i=0; i&lt;32; i++)
		switch(d-&gt;cc &amp; (1&lt;&lt;i)) {
		default:
			break;
		case E_ICC:
			Bprint(&amp;bso, " ICC");
			break;
		case E_FCC:
			Bprint(&amp;bso, " FCC");
			break;
		case E_MEM:
			Bprint(&amp;bso, " MEM%d", s-&gt;size);
			break;
		case E_MEMSB:
			Bprint(&amp;bso, " SB%d", s-&gt;size);
			break;
		case E_MEMSP:
			Bprint(&amp;bso, " SP%d", s-&gt;size);
			break;
		}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

