<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/kl/span.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/kl/span.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

void
span(void)
{
	Prog *p;
	Sym *setext;
	Optab *o;
	int m;
	long c;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f span\n", cputime());
	Bflush(&amp;bso);
	c = INITTEXT;
	for(p = firstp; p != P; p = p-&gt;link) {
		p-&gt;pc = c;
		o = oplook(p);
		m = o-&gt;size;
		if(m == 0) {
			if(p-&gt;as == ATEXT) {
				curtext = p;
				autosize = p-&gt;to.offset + 4;
				if(p-&gt;from.sym != S)
					p-&gt;from.sym-&gt;value = c;
				continue;
			}
			if(p-&gt;as != ANOP)
				diag("zero-width instruction\n%P", p);
			continue;
		}
		c += m;
	}
	c = rnd(c, 8);

	setext = lookup("etext", 0);
	if(setext != S) {
		setext-&gt;value = c;
		textsize = c - INITTEXT;
	}
	if(INITRND)
		INITDAT = rnd(c, INITRND);
	if(debug['v'])
		Bprint(&amp;bso, "tsize = %lux\n", textsize);
	Bflush(&amp;bso);
}
		
void
xdefine(char *p, int t, long v)
{
	Sym *s;

	s = lookup(p, 0);
	if(s-&gt;type == 0 || s-&gt;type == SXREF) {
		s-&gt;type = t;
		s-&gt;value = v;
	}
}

long
regoff(Adr *a)
{

	instoffset = 0;
	aclass(a);
	return instoffset;
}

int
aclass(Adr *a)
{
	Sym *s;
	int t;

	switch(a-&gt;type) {
	case D_NONE:
		return C_NONE;

	case D_REG:
		return C_REG;

	case D_FREG:
		return C_FREG;

	case D_CREG:
		return C_CREG;

	case D_PREG:
		if(a-&gt;reg == D_FSR)
			return C_FSR;
		if(a-&gt;reg == D_FPQ)
			return C_FQ;
		return C_PREG;

	case D_OREG:
		switch(a-&gt;name) {
		case D_EXTERN:
		case D_STATIC:
			if(a-&gt;sym == S)
				break;
			t = a-&gt;sym-&gt;type;
			if(t == 0 || t == SXREF) {
				diag("undefined external: %s in %s",
					a-&gt;sym-&gt;name, TNAME);
				a-&gt;sym-&gt;type = SDATA;
			}
			instoffset = a-&gt;sym-&gt;value + a-&gt;offset - BIG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG) {
				if(instoffset &amp; 7)
					return C_OSEXT;
				return C_ESEXT;
			}
			if(instoffset &amp; 7)
				return C_OLEXT;
			return C_ELEXT;
		case D_AUTO:
			instoffset = autosize + a-&gt;offset;
			goto dauto;

		case D_PARAM:
			instoffset = autosize + a-&gt;offset + 4L;
		dauto:
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG) {
				if(instoffset &amp; 7)
					return C_OSAUTO;
				return C_ESAUTO;
			}
			if(instoffset &amp; 7)
				return C_OLAUTO;
			return C_ELAUTO;
		case D_NONE:
			instoffset = a-&gt;offset;
			if(instoffset == 0)
				return C_ZOREG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SOREG;
			return C_LOREG;
		}
		return C_GOK;

	case D_ASI:
		if(a-&gt;name == D_NONE)
			return C_ASI;
		return C_GOK;

	case D_CONST:
		switch(a-&gt;name) {

		case D_NONE:
			instoffset = a-&gt;offset;
		consize:
			if(instoffset == 0)
				return C_ZCON;
			if(instoffset &gt;= -0x1000 &amp;&amp; instoffset &lt;= 0xfff)
				return C_SCON;
			if((instoffset &amp; 0x3ff) == 0)
				return C_UCON;
			return C_LCON;

		case D_EXTERN:
		case D_STATIC:
			s = a-&gt;sym;
			if(s == S)
				break;
			t = s-&gt;type;
			if(t == 0 || t == SXREF) {
				diag("undefined external: %s in %s",
					s-&gt;name, TNAME);
				s-&gt;type = SDATA;
			}
			if(s-&gt;type == STEXT || s-&gt;type == SLEAF) {
				instoffset = s-&gt;value + a-&gt;offset;
				return C_LCON;
			}
			if(s-&gt;type == SCONST) {
				instoffset = s-&gt;value + a-&gt;offset;
				goto consize;
			}
			instoffset = s-&gt;value + a-&gt;offset - BIG;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG &amp;&amp; instoffset != 0)
				return C_SECON;
			instoffset = s-&gt;value + a-&gt;offset + INITDAT;
/* not sure why this barfs */
return C_LCON;
/*
			if(instoffset == 0)
				return C_ZCON;
			if(instoffset &gt;= -0x1000 &amp;&amp; instoffset &lt;= 0xfff)
				return C_SCON;
			if((instoffset &amp; 0x3ff) == 0)
				return C_UCON;
			return C_LCON;
*/

		case D_AUTO:
			instoffset = autosize + a-&gt;offset;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SACON;
			return C_LACON;

		case D_PARAM:
			instoffset = autosize + a-&gt;offset + 4L;
			if(instoffset &gt;= -BIG &amp;&amp; instoffset &lt; BIG)
				return C_SACON;
			return C_LACON;
		}
		return C_GOK;

	case D_BRANCH:
		return C_SBRA;
	}
	return C_GOK;
}

Optab*
oplook(Prog *p)
{
	int a1, a2, a3, r;
	char *c1, *c3;
	Optab *o, *e;

	a1 = p-&gt;optab;
	if(a1)
		return optab+(a1-1);
	a1 = p-&gt;from.class;
	if(a1 == 0) {
		a1 = aclass(&amp;p-&gt;from) + 1;
		p-&gt;from.class = a1;
	}
	a1--;
	a3 = p-&gt;to.class;
	if(a3 == 0) {
		a3 = aclass(&amp;p-&gt;to) + 1;
		p-&gt;to.class = a3;
	}
	a3--;
	a2 = C_NONE;
	if(p-&gt;reg != NREG)
		a2 = C_REG;
	r = p-&gt;as;
	o = oprange[r].start;
	if(o == 0)
		o = oprange[r].stop; /* just generate an error */
	e = oprange[r].stop;
	c1 = xcmp[a1];
	c3 = xcmp[a3];
	for(; o&lt;e; o++)
		if(o-&gt;a2 == a2)
		if(c1[o-&gt;a1])
		if(c3[o-&gt;a3]) {
			p-&gt;optab = (o-optab)+1;
			return o;
		}
	diag("illegal combination %A %d %d %d",
		p-&gt;as, a1, a2, a3);
	if(1||!debug['a'])
		prasm(p);
	if(o == 0)
		errorexit();
	return o;
}

int
cmp(int a, int b)
{

	if(a == b)
		return 1;
	switch(a) {
	case C_LCON:
		if(b == C_ZCON || b == C_SCON || b == C_UCON)
			return 1;
		break;
	case C_UCON:
		if(b == C_ZCON)
			return 1;
		break;
	case C_SCON:
		if(b == C_ZCON)
			return 1;
		break;
	case C_LACON:
		if(b == C_SACON)
			return 1;
		break;
	case C_LBRA:
		if(b == C_SBRA)
			return 1;
		break;
	case C_ELEXT:
		if(b == C_ESEXT)
			return 1;
		break;
	case C_LEXT:
		if(b == C_SEXT ||
		   b == C_ESEXT || b == C_OSEXT ||
		   b == C_ELEXT || b == C_OLEXT)
			return 1;
		break;
	case C_SEXT:
		if(b == C_ESEXT || b == C_OSEXT)
			return 1;
		break;
	case C_ELAUTO:
		if(b == C_ESAUTO)
			return 1;
		break;
	case C_LAUTO:
		if(b == C_SAUTO ||
		   b == C_ESAUTO || b == C_OSAUTO ||
		   b == C_ELAUTO || b == C_OLAUTO)
			return 1;
		break;
	case C_SAUTO:
		if(b == C_ESAUTO || b == C_OSAUTO)
			return 1;
		break;
	case C_REG:
		if(b == C_ZCON)
			return 1;
		break;
	case C_LOREG:
		if(b == C_ZOREG || b == C_SOREG)
			return 1;
		break;
	case C_SOREG:
		if(b == C_ZOREG)
			return 1;
		break;

	case C_ANY:
		return 1;
	}
	return 0;
}

int
ocmp(const void *a1, const void *a2)
{
	Optab *p1, *p2;
	int n;

	p1 = (Optab*)a1;
	p2 = (Optab*)a2;
	n = p1-&gt;as - p2-&gt;as;
	if(n)
		return n;
	n = p1-&gt;a1 - p2-&gt;a1;
	if(n)
		return n;
	n = p1-&gt;a2 - p2-&gt;a2;
	if(n)
		return n;
	n = p1-&gt;a3 - p2-&gt;a3;
	if(n)
		return n;
	return 0;
}

void
buildop(void)
{
	int i, n, r;

	for(i=0; i&lt;C_NCLASS; i++)
		for(n=0; n&lt;C_NCLASS; n++)
			xcmp[i][n] = cmp(n, i);
	for(n=0; optab[n].as != AXXX; n++)
		;
	qsort(optab, n, sizeof(optab[0]), ocmp);
	for(i=0; i&lt;n; i++) {
		r = optab[i].as;
		oprange[r].start = optab+i;
		while(optab[i].as == r)
			i++;
		oprange[r].stop = optab+i;
		i--;
		
		switch(r)
		{
		default:
			diag("unknown op in build: %A", r);
			errorexit();
		case AADD:
			oprange[AADDX] = oprange[r];
			oprange[ASUB] = oprange[r];
			oprange[ASUBX] = oprange[r];
			oprange[AMUL] = oprange[r];
			oprange[AXOR] = oprange[r];
			oprange[AXNOR] = oprange[r];
			oprange[AAND] = oprange[r];
			oprange[AANDN] = oprange[r];
			oprange[AOR] = oprange[r];
			oprange[AORN] = oprange[r];
			oprange[ASLL] = oprange[r];
			oprange[ASRL] = oprange[r];
			oprange[ASRA] = oprange[r];
			oprange[AADDCC] = oprange[r];
			oprange[AADDXCC] = oprange[r];
			oprange[ATADDCC] = oprange[r];
			oprange[ATADDCCTV] = oprange[r];
			oprange[ASUBCC] = oprange[r];
			oprange[ASUBXCC] = oprange[r];
			oprange[ATSUBCC] = oprange[r];
			oprange[ATSUBCCTV] = oprange[r];
			oprange[AXORCC] = oprange[r];
			oprange[AXNORCC] = oprange[r];
			oprange[AANDCC] = oprange[r];
			oprange[AANDNCC] = oprange[r];
			oprange[AORCC] = oprange[r];
			oprange[AORNCC] = oprange[r];
			oprange[AMULSCC] = oprange[r];
			oprange[ASAVE] = oprange[r];
			oprange[ARESTORE] = oprange[r];
			break;
		case AMOVB:
			oprange[AMOVH] = oprange[r];
			oprange[AMOVHU] = oprange[r];
			oprange[AMOVBU] = oprange[r];
			oprange[ASWAP] = oprange[r];
			oprange[ATAS] = oprange[r];
			break;
		case ABA:
			oprange[ABN] = oprange[r];
			oprange[AFBA] = oprange[r];
			oprange[AFBN] = oprange[r];
			break;
		case ABE:
			oprange[ABCC] = oprange[r];
			oprange[ABCS] = oprange[r];
			oprange[ABGE] = oprange[r];
			oprange[ABGU] = oprange[r];
			oprange[ABG] = oprange[r];
			oprange[ABLEU] = oprange[r];
			oprange[ABLE] = oprange[r];
			oprange[ABL] = oprange[r];
			oprange[ABNEG] = oprange[r];
			oprange[ABNE] = oprange[r];
			oprange[ABPOS] = oprange[r];
			oprange[ABVC] = oprange[r];
			oprange[ABVS] = oprange[r];

			oprange[AFBE] = oprange[r];
			oprange[AFBG] = oprange[r];
			oprange[AFBGE] = oprange[r];
			oprange[AFBL] = oprange[r];
			oprange[AFBLE] = oprange[r];
			oprange[AFBLG] = oprange[r];
			oprange[AFBNE] = oprange[r];
			oprange[AFBO] = oprange[r];
			oprange[AFBU] = oprange[r];
			oprange[AFBUE] = oprange[r];
			oprange[AFBUG] = oprange[r];
			oprange[AFBUGE] = oprange[r];
			oprange[AFBUL] = oprange[r];
			oprange[AFBULE] = oprange[r];
			break;
		case ATA:
			oprange[ATCC] = oprange[r];
			oprange[ATCS] = oprange[r];
			oprange[ATE] = oprange[r];
			oprange[ATGE] = oprange[r];
			oprange[ATGU] = oprange[r];
			oprange[ATG] = oprange[r];
			oprange[ATLEU] = oprange[r];
			oprange[ATLE] = oprange[r];
			oprange[ATL] = oprange[r];
			oprange[ATNEG] = oprange[r];
			oprange[ATNE] = oprange[r];
			oprange[ATN] = oprange[r];
			oprange[ATPOS] = oprange[r];
			oprange[ATVC] = oprange[r];
			oprange[ATVS] = oprange[r];
			break;
		case AFADDD:
			oprange[AFADDF] = oprange[r];
			oprange[AFADDX] = oprange[r];
			oprange[AFDIVD] = oprange[r];
			oprange[AFDIVF] = oprange[r];
			oprange[AFDIVX] = oprange[r];
			oprange[AFMULD] = oprange[r];
			oprange[AFMULF] = oprange[r];
			oprange[AFMULX] = oprange[r];
			oprange[AFSUBD] = oprange[r];
			oprange[AFSUBF] = oprange[r];
			oprange[AFSUBX] = oprange[r];
			break;
		case AFCMPD:
			oprange[AFCMPF] = oprange[r];
			oprange[AFCMPX] = oprange[r];
			oprange[AFCMPED] = oprange[r];
			oprange[AFCMPEF] = oprange[r];
			oprange[AFCMPEX] = oprange[r];
			break;
		case AFABSF:
			oprange[AFMOVDF] = oprange[r];
			oprange[AFMOVDW] = oprange[r];
			oprange[AFMOVFD] = oprange[r];
			oprange[AFMOVFW] = oprange[r];
			oprange[AFMOVWD] = oprange[r];
			oprange[AFMOVWF] = oprange[r];
			oprange[AFNEGF] = oprange[r];
			oprange[AFSQRTD] = oprange[r];
			oprange[AFSQRTF] = oprange[r];
			break;
		case AFMOVF:
		case AFMOVD:
		case AMOVW:
		case AMOVD:
		case AWORD:
		case ARETT:
		case AJMPL:
		case AJMP:
		case ACMP:
		case ANOP:
		case ATEXT:
		case ADIV:
		case ADIVL:
		case AMOD:
		case AMODL:
			break;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

