<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/lens.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/lens.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

enum {
	Edge = 5,
	Maxmag = 16
};

enum {
	Mzoom,
	Munzoom,
	Mgrid,
	Mredraw,
	Mexit
};

char *menustr[] = {
	"zoom",
	"unzoom",
	"grid",
	"redraw",
	"exit",
	nil
};

Menu menu = {
	menustr,
	nil,
	-1
};

Point lastp;
Image *red;
Image *tmp;
Image *grid;
Image *chequer;
int	screenfd;
int	mag = 4;
int	showgrid = 0;
Rectangle	screenr;
uchar	*screenbuf;

void	magnify(void);
void makegrid(void);

void
drawit(void)
{
	Rectangle r;
	border(screen, screen-&gt;r, Edge, red, ZP);
	magnify();
	r = insetrect(screen-&gt;r, Edge);
	draw(screen, r, tmp, nil, tmp-&gt;r.min);
	flushimage(display, 1);
}

int bypp;

void
main(int argc, char *argv[])
{
	Event e;
	char buf[5*12];
	ulong chan;
	int d;

	USED(argc, argv);
	if(initdraw(nil, nil, "lens") &lt; 0){
		fprint(2, "lens: initdraw failed: %r\n");
		exits("initdraw");
	}
	einit(Emouse|Ekeyboard);
	red = allocimage(display, Rect(0, 0, 1, 1), CMAP8, 1, DRed);
	chequer = allocimage(display, Rect(0, 0, 2, 2), GREY1, 1, DBlack);
	draw(chequer, Rect(0, 0, 1, 1), display-&gt;white, nil, ZP);
	draw(chequer, Rect(1, 1, 2, 2), display-&gt;white, nil, ZP);
	lastp = divpt(addpt(screen-&gt;r.min, screen-&gt;r.max), 2);
	screenfd = open("/dev/screen", OREAD);
	if(screenfd &lt; 0){
		fprint(2, "lens: can't open /dev/screen: %r\n");
		exits("screen");
	}
	if(read(screenfd, buf, sizeof buf) != sizeof buf){
		fprint(2, "lens: can't read /dev/screen: %r\n");
		exits("screen");
	}
	chan = strtochan(buf);
	d = chantodepth(chan);
	if(d &lt; 8){
		fprint(2, "lens: can't handle screen format %11.11s\n", buf);
		exits("screen");
	}
	bypp = d/8;
	screenr.min.x = atoi(buf+1*12);
	screenr.min.y = atoi(buf+2*12);
	screenr.max.x = atoi(buf+3*12);
	screenr.max.y = atoi(buf+4*12);
	screenbuf = malloc(bypp*Dx(screenr)*Dy(screenr));
	if(screenbuf == nil){
		fprint(2, "lens: buffer malloc failed: %r\n");
		exits("malloc");
	}
	eresized(0);

	for(;;)
		switch(event(&amp;e)){
		case Ekeyboard:
			switch(e.kbdc){
			case 'q':
			case 0x7f:
			case '\04':
			caseexit:
				exits(nil);
			case '=':
			case '+':
			casezoom:
				if(mag &lt; Maxmag){
					mag++;
					makegrid();
					drawit();
				}
				break;
			case 'g':
			casegrid:
				showgrid = !showgrid;
				makegrid();
				drawit();
				break;
			case '-':
			case '_':
			caseunzoom:
				if(mag &gt; 1){
					mag--;
					makegrid();
					drawit();
				}
				break;
			case '.':
			case ' ':
			caseredraw:
				drawit();
				break;
			case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9': case'0':
				mag = e.kbdc-'0';
				if(mag == 0)
					mag = 10;
				makegrid();
				drawit();
				break;
			}
			break;
		case Emouse:
			if(e.mouse.buttons &amp; 1){
				lastp = e.mouse.xy;
				drawit();
			}
			if(e.mouse.buttons &amp; 4)
				switch(emenuhit(3, &amp;e.mouse, &amp;menu)){
				case Mzoom:
					goto casezoom;
				case Munzoom:
					goto caseunzoom;
				case Mgrid:
					goto casegrid;
				case Mredraw:
					goto caseredraw;
				case Mexit:
					goto caseexit;
				}
			break;
		}
}

void
makegrid(void)
{
	int m;
	if (grid != nil) {
		freeimage(grid);
		grid = nil;
	}
	if (showgrid) {
		m = mag;
		if (m &lt; 5)
			m *= 10;
		grid = allocimage(display, Rect(0, 0, m, m),
			CHAN2(CGrey, 8, CAlpha, 8), 1, DTransparent);
		if (grid != nil){
			draw(grid, Rect(0, 0, m, 1), chequer, nil, ZP);
			draw(grid, Rect(0, 1, 1, m), chequer, nil, ZP);
		}
	}
}

void
eresized(int new)
{
	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0){
		fprint(2, "lens: can't reattach to window: %r\n");
		exits("attach");
	}
	freeimage(tmp);
	tmp = allocimage(display, Rect(0, 0, Dx(screen-&gt;r)-Edge, Dy(screen-&gt;r)-Edge+Maxmag), screen-&gt;chan, 0, DNofill);
	if(tmp == nil){
		fprint(2, "lens: allocimage failed: %r\n");
		exits("allocimage");
	}
	drawit();
}

void
magnify(void)
{
	int x, y, xx, yy, dd, i;
	int dx, dy;
	int xoff, yoff;
	uchar out[8192];
	uchar sp[4];

	dx = (Dx(tmp-&gt;r)+mag-1)/mag;
	dy = (Dy(tmp-&gt;r)+mag-1)/mag;
	xoff = lastp.x-Dx(tmp-&gt;r)/(mag*2);
	yoff  = lastp.y-Dy(tmp-&gt;r)/(mag*2);

	yy = yoff;
	dd = dy;
	if(yy &lt; 0){
		dd += dy;
		yy = 0;
	}
	if(yy+dd &gt; Dy(screenr))
		dd = Dy(screenr)-yy;
	seek(screenfd, 5*12+bypp*yy*Dx(screenr), 0);
	if(readn(screenfd, screenbuf+bypp*yy*Dx(screenr), bypp*Dx(screenr)*dd) != bypp*Dx(screenr)*dd){
		fprint(2, "lens: can't read screen: %r\n");
		return;
	}

	for(y=0; y&lt;dy; y++){
		yy = yoff+y;
		if(yy&gt;=0 &amp;&amp; yy&lt;Dy(screenr))
			for(x=0; x&lt;dx; x++){
				xx = xoff+x;
				if(xx&gt;=0 &amp;&amp; xx&lt;Dx(screenr))	/* snarf pixel at xx, yy */
					for(i=0; i&lt;bypp; i++)
						sp[i] = screenbuf[bypp*(yy*Dx(screenr)+xx)+i];
				else
					sp[0] = sp[1] = sp[2] = sp[3] = 0;

				for(xx=0; xx&lt;mag; xx++)
					if(x*mag+xx &lt; tmp-&gt;r.max.x)
						for(i=0; i&lt;bypp; i++)
							out[(x*mag+xx)*bypp+i] = sp[i];
			}
		else
			memset(out, 0, bypp*Dx(tmp-&gt;r));
		for(yy=0; yy&lt;mag &amp;&amp; y*mag+yy&lt;Dy(tmp-&gt;r); yy++){
			werrstr("no error");
			if(loadimage(tmp, Rect(0, y*mag+yy, Dx(tmp-&gt;r), y*mag+yy+1), out, bypp*Dx(tmp-&gt;r)) != bypp*Dx(tmp-&gt;r)){
				exits("load");
			}
		}
	}
	if (showgrid &amp;&amp; mag &amp;&amp; grid)
		draw(tmp, tmp-&gt;r, grid, nil, mulpt(Pt(xoff, yoff), mag));
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

