<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ls.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ls.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;fcall.h&gt;

typedef struct NDir NDir;
struct NDir
{
	Dir *d;
	char	*prefix;
};

int	errs = 0;
int	dflag;
int	lflag;
int	mflag;
int	nflag;
int	pflag;
int	qflag;
int	Qflag;
int	rflag;
int	sflag;
int	tflag;
int	Tflag;
int	uflag;
int	Fflag;
int	ndirbuf;
int	ndir;
NDir*	dirbuf;
int	ls(char*, int);
int	compar(NDir*, NDir*);
char*	asciitime(long);
char*	darwx(long);
void	rwx(long, char*);
void	growto(long);
void	dowidths(Dir*);
void	format(Dir*, char*);
void	output(void);
char*	xcleanname(char*);
ulong	clk;
int	swidth;			/* max width of -s size */
int	qwidth;			/* max width of -q version */
int	vwidth;			/* max width of dev */
int	uwidth;			/* max width of userid */
int	mwidth;			/* max width of muid */
int	lwidth;			/* max width of length */
int	gwidth;			/* max width of groupid */
Biobuf	bin;

void
main(int argc, char *argv[])
{
	int i;

	Binit(&amp;bin, 1, OWRITE);
	ARGBEGIN{
	case 'F':	Fflag++; break;
	case 'd':	dflag++; break;
	case 'l':	lflag++; break;
	case 'm':	mflag++; break;
	case 'n':	nflag++; break;
	case 'p':	pflag++; break;
	case 'q':	qflag++; break;
	case 'Q':	Qflag++; break;
	case 'r':	rflag++; break;
	case 's':	sflag++; break;
	case 't':	tflag++; break;
	case 'T':	Tflag++; break;
	case 'u':	uflag++; break;
	default:	fprint(2, "usage: ls [-dlmnpqrstuFQT] [file ...]\n");
			exits("usage");
	}ARGEND

	doquote = needsrcquote;
	quotefmtinstall();
	fmtinstall('M', dirmodefmt);

	if(lflag)
		clk = time(0);
	if(argc == 0)
		errs = ls(".", 0);
	else for(i=0; i&lt;argc; i++)
		errs |= ls(argv[i], 1);
	output();
	exits(errs? "errors" : 0);
}

int
ls(char *s, int multi)
{
	int fd;
	long i, n;
	char *p;
	Dir *db;

	db = dirstat(s);
	if(db == nil){
    error:
		fprint(2, "ls: %s: %r\n", s);
		return 1;
	}
	if((db-&gt;qid.type&amp;QTDIR) &amp;&amp; dflag==0){
		free(db);
		output();
		fd = open(s, OREAD);
		if(fd == -1)
			goto error;
		n = dirreadall(fd, &amp;db);
		if(n &lt; 0)
			goto error;
		xcleanname(s);
		growto(ndir+n);
		for(i=0; i&lt;n; i++){
			dirbuf[ndir+i].d = db+i;
			dirbuf[ndir+i].prefix = multi? s : 0;
		}
		ndir += n;
		close(fd);
		output();
	}else{
		growto(ndir+1);
		dirbuf[ndir].d = db;
		dirbuf[ndir].prefix = 0;
		xcleanname(s);
		p = utfrrune(s, '/');
		if(p){
			dirbuf[ndir].prefix = s;
			*p = 0;
		}
		ndir++;
	}
	return 0;
}

void
output(void)
{
	int i;
	char buf[4096];
	char *s;

	if(!nflag)
		qsort(dirbuf, ndir, sizeof dirbuf[0], (int (*)(void*, void*))compar);
	for(i=0; i&lt;ndir; i++)
		dowidths(dirbuf[i].d);
	for(i=0; i&lt;ndir; i++) {
		if(!pflag &amp;&amp; (s = dirbuf[i].prefix)) {
			if(strcmp(s, "/") ==0)	/* / is a special case */
				s = "";
			sprint(buf, "%s/%s", s, dirbuf[i].d-&gt;name);
			format(dirbuf[i].d, buf);
		} else
			format(dirbuf[i].d, dirbuf[i].d-&gt;name);
	}
	ndir = 0;
	Bflush(&amp;bin);
}

void
dowidths(Dir *db)
{
	char buf[256];
	int n;

	if(sflag) {
		n = sprint(buf, "%llud", (db-&gt;length+1023)/1024);
		if(n &gt; swidth)
			swidth = n;
	}
	if(qflag) {
		n = sprint(buf, "%lud", db-&gt;qid.vers);
		if(n &gt; qwidth)
			qwidth = n;
	}
	if(mflag) {
		n = snprint(buf, sizeof buf, "[%q]", db-&gt;muid);
		if(n &gt; mwidth)
			mwidth = n;
	}
	if(lflag) {
		n = sprint(buf, "%ud", db-&gt;dev);
		if(n &gt; vwidth)
			vwidth = n;
		n = sprint(buf, "%q", db-&gt;uid);
		if(n &gt; uwidth)
			uwidth = n;
		n = sprint(buf, "%q", db-&gt;gid);
		if(n &gt; gwidth)
			gwidth = n;
		n = sprint(buf, "%llud", db-&gt;length);
		if(n &gt; lwidth)
			lwidth = n;
	}
}

char*
fileflag(Dir *db)
{
	if(Fflag == 0)
		return "";
	if(QTDIR &amp; db-&gt;qid.type)
		return "/";
	if(0111 &amp; db-&gt;mode)
		return "*";
	return "";
}

void
format(Dir *db, char *name)
{
	int i;

	if(sflag)
		Bprint(&amp;bin, "%*llud ",
			swidth, (db-&gt;length+1023)/1024);
	if(mflag){
		Bprint(&amp;bin, "[%q] ", db-&gt;muid);
		for(i=2+strlen(db-&gt;muid); i&lt;mwidth; i++)
			Bprint(&amp;bin, " ");
	}
	if(qflag)
		Bprint(&amp;bin, "(%.16llux %*lud %.2ux) ",
			db-&gt;qid.path,
			qwidth, db-&gt;qid.vers,
			db-&gt;qid.type);
	if(Tflag)
		Bprint(&amp;bin, "%c ", (db-&gt;mode&amp;DMTMP)? 't': '-');

	if(lflag)
		Bprint(&amp;bin, "%M %C %*ud %*q %*q %*llud %s ",
			db-&gt;mode, db-&gt;type,
			vwidth, db-&gt;dev,
			-uwidth, db-&gt;uid,
			-gwidth, db-&gt;gid,
			lwidth, db-&gt;length,
			asciitime(uflag? db-&gt;atime: db-&gt;mtime));
	Bprint(&amp;bin, Qflag? "%s%s\n": "%q%s\n", name, fileflag(db));
}

void
growto(long n)
{
	if(n &lt;= ndirbuf)
		return;
	ndirbuf = n;
	dirbuf=(NDir *)realloc(dirbuf, ndirbuf*sizeof(NDir));
	if(dirbuf == 0){
		fprint(2, "ls: malloc fail\n");
		exits("malloc fail");
	}
}

int
compar(NDir *a, NDir *b)
{
	long i;
	Dir *ad, *bd;

	ad = a-&gt;d;
	bd = b-&gt;d;

	if(tflag){
		if(uflag)
			i = bd-&gt;atime-ad-&gt;atime;
		else
			i = bd-&gt;mtime-ad-&gt;mtime;
	}else{
		if(a-&gt;prefix &amp;&amp; b-&gt;prefix){
			i = strcmp(a-&gt;prefix, b-&gt;prefix);
			if(i == 0)
				i = strcmp(ad-&gt;name, bd-&gt;name);
		}else if(a-&gt;prefix){
			i = strcmp(a-&gt;prefix, bd-&gt;name);
			if(i == 0)
				i = 1;	/* a is longer than b */
		}else if(b-&gt;prefix){
			i = strcmp(ad-&gt;name, b-&gt;prefix);
			if(i == 0)
				i = -1;	/* b is longer than a */
		}else
			i = strcmp(ad-&gt;name, bd-&gt;name);
	}
	if(i == 0)
		i = (a&lt;b? -1 : 1);
	if(rflag)
		i = -i;
	return i;
}

char*
asciitime(long l)
{
	static char buf[32];
	char *t;

	t = ctime(l);
	/* 6 months in the past or a day in the future */
	if(l&lt;clk-180L*24*60*60 || clk+24L*60*60&lt;l){
		memmove(buf, t+4, 7);		/* month and day */
		memmove(buf+7, t+23, 5);		/* year */
	}else
		memmove(buf, t+4, 12);		/* skip day of week */
	buf[12] = 0;
	return buf;
}

/*
 * Compress slashes, remove trailing slash.  Don't worry about . and ..
 */
char*
xcleanname(char *name)
{
	char *r, *w;

	for(r=w=name; *r; r++){
		if(*r=='/' &amp;&amp; r&gt;name &amp;&amp; *(r-1)=='/')
			continue;
		if(w != r)
			*w = *r;
		w++;
	}
	*w = 0;
	while(w-1&gt;name &amp;&amp; *(w-1)=='/')
		*--w = 0;
	return name;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

