<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/bufblock.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/bufblock.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

static Bufblock *freelist;
#define	QUANTA	4096

Bufblock *
newbuf(void)
{
	Bufblock *p;

	if (freelist) {
		p = freelist;
		freelist = freelist-&gt;next;
	} else {
		p = (Bufblock *) Malloc(sizeof(Bufblock));
		p-&gt;start = Malloc(QUANTA*sizeof(*p-&gt;start));
		p-&gt;end = p-&gt;start+QUANTA;
	}
	p-&gt;current = p-&gt;start;
	*p-&gt;start = 0;
	p-&gt;next = 0;
	return p;
}

void
freebuf(Bufblock *p)
{
	p-&gt;next = freelist;
	freelist = p;
}

void
growbuf(Bufblock *p)
{
	int n;
	Bufblock *f;
	char *cp;

	n = p-&gt;end-p-&gt;start+QUANTA;
		/* search the free list for a big buffer */
	for (f = freelist; f; f = f-&gt;next) {
		if (f-&gt;end-f-&gt;start &gt;= n) {
			memcpy(f-&gt;start, p-&gt;start, p-&gt;end-p-&gt;start);
			cp = f-&gt;start;
			f-&gt;start = p-&gt;start;
			p-&gt;start = cp;
			cp = f-&gt;end;
			f-&gt;end = p-&gt;end;
			p-&gt;end = cp;
			f-&gt;current = f-&gt;start;
			break;
		}
	}
	if (!f) {		/* not found - grow it */
		p-&gt;start = Realloc(p-&gt;start, n);
		p-&gt;end = p-&gt;start+n;
	}
	p-&gt;current = p-&gt;start+n-QUANTA;
}

void
bufcpy(Bufblock *buf, char *cp, int n)
{

	while (n--)
		insert(buf, *cp++);
}

void
insert(Bufblock *buf, int c)
{

	if (buf-&gt;current &gt;= buf-&gt;end)
		growbuf(buf);
	*buf-&gt;current++ = c;
}

void
rinsert(Bufblock *buf, Rune r)
{
	int n;

	n = runelen(r);
	if (buf-&gt;current+n &gt; buf-&gt;end)
		growbuf(buf);
	runetochar(buf-&gt;current, &amp;r);
	buf-&gt;current += n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

