<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/env.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/env.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

enum {
	ENVQUANTA=10
};

Envy	*envy;
static int nextv;

static char	*myenv[] =
{
	"target",
	"stem",
	"prereq",
	"pid",
	"nproc",
	"newprereq",
	"alltarget",
	"newmember",
	"stem0",		/* must be in order from here */
	"stem1",
	"stem2",
	"stem3",
	"stem4",
	"stem5",
	"stem6",
	"stem7",
	"stem8",
	"stem9",
	0,
};

void
initenv(void)
{
	char **p;

	for(p = myenv; *p; p++)
		symlook(*p, S_INTERNAL, (void *)"");
	readenv();				/* o.s. dependent */
}

static void
envinsert(char *name, Word *value)
{
	static int envsize;

	if (nextv &gt;= envsize) {
		envsize += ENVQUANTA;
		envy = (Envy *) Realloc((char *) envy, envsize*sizeof(Envy));
	}
	envy[nextv].name = name;
	envy[nextv++].values = value;
}

static void
envupd(char *name, Word *value)
{
	Envy *e;

	for(e = envy; e-&gt;name; e++)
		if(strcmp(name, e-&gt;name) == 0){
			delword(e-&gt;values);
			e-&gt;values = value;
			return;
		}
	e-&gt;name = name;
	e-&gt;values = value;
	envinsert(0,0);
}

static void
ecopy(Symtab *s)
{
	char **p;

	if(symlook(s-&gt;name, S_NOEXPORT, 0))
		return;
	for(p = myenv; *p; p++)
		if(strcmp(*p, s-&gt;name) == 0)
			return;
	envinsert(s-&gt;name, s-&gt;u.ptr);
}

void
execinit(void)
{
	char **p;

	nextv = 0;
	for(p = myenv; *p; p++)
		envinsert(*p, stow(""));

	symtraverse(S_VAR, ecopy);
	envinsert(0, 0);
}

Envy*
buildenv(Job *j, int slot)
{
	char **p, *cp, *qp;
	Word *w, *v, **l;
	int i;
	char buf[256];

	envupd("target", wdup(j-&gt;t));
	if(j-&gt;r-&gt;attr&amp;REGEXP)
		envupd("stem",newword(""));
	else
		envupd("stem", newword(j-&gt;stem));
	envupd("prereq", wdup(j-&gt;p));
	snprint(buf, sizeof buf, "%d", getpid());
	envupd("pid", newword(buf));
	snprint(buf, sizeof buf, "%d", slot);
	envupd("nproc", newword(buf));
	envupd("newprereq", wdup(j-&gt;np));
	envupd("alltarget", wdup(j-&gt;at));
	l = &amp;v;
	v = w = wdup(j-&gt;np);
	while(w){
		cp = strchr(w-&gt;s, '(');
		if(cp){
			qp = strchr(cp+1, ')');
			if(qp){
				*qp = 0;
				strcpy(w-&gt;s, cp+1);
				l = &amp;w-&gt;next;
				w = w-&gt;next;
				continue;
			}
		}
		*l = w-&gt;next;
		free(w-&gt;s);
		free(w);
		w = *l;
	}
	envupd("newmember", v);
		/* update stem0 -&gt; stem9 */
	for(p = myenv; *p; p++)
		if(strcmp(*p, "stem0") == 0)
			break;
	for(i = 0; *p; i++, p++){
		if((j-&gt;r-&gt;attr&amp;REGEXP) &amp;&amp; j-&gt;match[i])
			envupd(*p, newword(j-&gt;match[i]));
		else 
			envupd(*p, newword(""));
	}
	return envy;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

