<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mk/recipe.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mk/recipe.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"mk.h"

int
dorecipe(Node *node)
{
	int did = 0;
	char buf[BIGBLOCK], cwd[256];
	Arc *a, *aa;
	Node *n;
	Rule *r = 0;
	Symtab *s;
	Word head, ahead, lp, ln, *w, *ww, *aw;

	aa = 0;
	/*
		pick up the rule
	*/
	for(a = node-&gt;prereqs; a; a = a-&gt;next)
		if(*a-&gt;r-&gt;recipe)
			r = (aa = a)-&gt;r;
	/*
		no recipe? go to buggery!
	*/
	if(r == 0){
		if(!(node-&gt;flags&amp;VIRTUAL) &amp;&amp; !(node-&gt;flags&amp;NORECIPE)){
			if(getwd(cwd, sizeof cwd))
				fprint(2, "mk: no recipe to make '%s' in directory %s\n", node-&gt;name, cwd);
			else
				fprint(2, "mk: no recipe to make '%s'\n", node-&gt;name);
			Exit();
		}
		if(strchr(node-&gt;name, '(') &amp;&amp; node-&gt;time == 0)
			MADESET(node, MADE);
		else
			update(0, node);
		if(tflag){
			if(!(node-&gt;flags&amp;VIRTUAL))
				touch(node-&gt;name);
			else if(explain)
				Bprint(&amp;bout, "no touch of virtual '%s'\n", node-&gt;name);
		}
		return(did);
	}
	/*
		build the node list
	*/
	node-&gt;next = 0;
	head.next = 0;
	ww = &amp;head;
	ahead.next = 0;
	aw = &amp;ahead;
	if(r-&gt;attr&amp;REGEXP){
		ww-&gt;next = newword(node-&gt;name);
		aw-&gt;next = newword(node-&gt;name);
	} else {
		for(w = r-&gt;alltargets; w; w = w-&gt;next){
			if(r-&gt;attr&amp;META)
				subst(aa-&gt;stem, w-&gt;s, buf, sizeof(buf));
			else
				strecpy(buf, buf + sizeof buf - 1, w-&gt;s);
			aw-&gt;next = newword(buf);
			aw = aw-&gt;next;
			if((s = symlook(buf, S_NODE, 0)) == 0)
				continue;	/* not a node we are interested in */
			n = s-&gt;u.ptr;
			if(aflag == 0 &amp;&amp; n-&gt;time) {
				for(a = n-&gt;prereqs; a; a = a-&gt;next)
					if(a-&gt;n &amp;&amp; outofdate(n, a, 0))
						break;
				if(a == 0)
					continue;
			}
			ww-&gt;next = newword(buf);
			ww = ww-&gt;next;
			if(n == node) continue;
			n-&gt;next = node-&gt;next;
			node-&gt;next = n;
		}
	}
	for(n = node; n; n = n-&gt;next)
		if((n-&gt;flags&amp;READY) == 0)
			return(did);
	/*
		gather the params for the job
	*/
	lp.next = ln.next = 0;
	for(n = node; n; n = n-&gt;next){
		for(a = n-&gt;prereqs; a; a = a-&gt;next){
			if(a-&gt;n){
				addw(&amp;lp, a-&gt;n-&gt;name);
				if(outofdate(n, a, 0)){
					addw(&amp;ln, a-&gt;n-&gt;name);
					if(explain)
						fprint(1, "%s(%ld) &lt; %s(%ld)\n",
							n-&gt;name, n-&gt;time, a-&gt;n-&gt;name, a-&gt;n-&gt;time);
				}
			} else {
				if(explain)
					fprint(1, "%s has no prerequisites\n",
							n-&gt;name);
			}
		}
		MADESET(n, BEINGMADE);
	}
/*	print("lt=%s ln=%s lp=%s\n",wtos(head.next, ' '),wtos(ln.next, ' '),wtos(lp.next, ' '));/**/
	run(newjob(r, node, aa-&gt;stem, aa-&gt;match, lp.next, ln.next, head.next, ahead.next));
	return(1);
}

void
addw(Word *w, char *s)
{
	Word *lw;

	for(lw = w; w = w-&gt;next; lw = w){
		if(strcmp(s, w-&gt;s) == 0)
			return;
	}
	lw-&gt;next = newword(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

