<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/mntgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/mntgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;

static void
usage(void)
{
	fprint(2, "mntgen [-s srvname] [mtpt]\n");
	exits("usage");
}

ulong time0;

typedef struct Tab Tab;
struct Tab
{
	char *name;
	vlong qid;
	ulong time;
	int ref;
};

Tab *tab;
int ntab;
int mtab;

static Tab*
findtab(vlong path)
{
	int i;

	for(i=0; i&lt;ntab; i++)
		if(tab[i].qid == path)
			return &amp;tab[i];
	return nil;
}

static vlong
hash(char *name)
{
	vlong digest[MD5dlen / sizeof(vlong) + 1];
	md5((uchar *)name, strlen(name), (uchar *)digest, nil);
	return digest[0] &amp; ((1ULL&lt;&lt;48)-1);
}

static void
fsopen(Req *r)
{
	if(r-&gt;ifcall.mode != OREAD)
		respond(r, "permission denied");
	else
		respond(r, nil);
}

static int
dirgen(int i, Dir *d, void*)
{
	if(i &gt;= ntab)
		return -1;
	memset(d, 0, sizeof *d);
	d-&gt;qid.type = QTDIR;
	d-&gt;uid = estrdup9p("sys");
	d-&gt;gid = estrdup9p("sys");
	d-&gt;mode = DMDIR|0555;
	d-&gt;length = 0;
	if(i == -1){
		d-&gt;name = estrdup9p("/");
		d-&gt;atime = d-&gt;mtime = time0;
	}else{
		d-&gt;qid.path = tab[i].qid;
		d-&gt;name = estrdup9p(tab[i].name);
		d-&gt;atime = d-&gt;mtime = tab[i].time;
	}
	return 0;
}

static void
fsread(Req *r)
{
	if(r-&gt;fid-&gt;qid.path == 0)
		dirread9p(r, dirgen, nil);
	else
		r-&gt;ofcall.count = 0;
	respond(r, nil);
}

static void
fsstat(Req *r)
{
	Tab *t;
	vlong qid;

	qid = r-&gt;fid-&gt;qid.path;
	if(qid == 0)
		dirgen(-1, &amp;r-&gt;d, nil);
	else{
		if((t = findtab(qid)) == nil){
			respond(r, "path not found (???)");
			return;
		}
		dirgen(t-tab, &amp;r-&gt;d, nil);
	}
	respond(r, nil);
}

static char*
fswalk1(Fid *fid, char *name, void*)
{
	int i;
	Tab *t;
	vlong h;

	if(fid-&gt;qid.path != 0){
		/* nothing in child directory */
		if(strcmp(name, "..") == 0){
			if((t = findtab(fid-&gt;qid.path)) != nil)
				t-&gt;ref--;
			fid-&gt;qid.path = 0;
			return nil;
		}
		return "path not found";
	}
	/* root */
	if(strcmp(name, "..") == 0)
		return nil;
	for(i=0; i&lt;ntab; i++)
		if(strcmp(tab[i].name, name) == 0){
			tab[i].ref++;
			fid-&gt;qid.path = tab[i].qid;
			return nil;
		}
	h = hash(name);
	if(findtab(h) != nil)
		return "hash collision";

	/* create it */
	if(ntab == mtab){
		if(mtab == 0)
			mtab = 16;
		else
			mtab *= 2;
		tab = erealloc9p(tab, sizeof(tab[0])*mtab);
	}
	tab[ntab].qid = h;
	fid-&gt;qid.path = tab[ntab].qid;
	tab[ntab].name = estrdup9p(name);
	tab[ntab].time = time(0);
	tab[ntab].ref = 1;
	ntab++;

	return nil;
}

static char*
fsclone(Fid *fid, Fid*, void*)
{
	Tab *t;

	if((t = findtab(fid-&gt;qid.path)) != nil)
		t-&gt;ref++;
	return nil;
}

static void
fswalk(Req *r)
{
	walkandclone(r, fswalk1, fsclone, nil);
}

static void
fsclunk(Fid *fid)
{
	Tab *t;
	vlong qid;

	qid = fid-&gt;qid.path;
	if(qid == 0)
		return;
	if((t = findtab(qid)) == nil){
		fprint(2, "warning: cannot find %llux\n", qid);
		return;
	}
	if(--t-&gt;ref == 0){
		free(t-&gt;name);
		tab[t-tab] = tab[--ntab];
	}else if(t-&gt;ref &lt; 0)
		fprint(2, "warning: negative ref count for %s\n", t-&gt;name);
}

static void
fsattach(Req *r)
{
	char *spec;

	spec = r-&gt;ifcall.aname;
	if(spec &amp;&amp; spec[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	
	r-&gt;ofcall.qid = (Qid){0, 0, QTDIR};
	r-&gt;fid-&gt;qid = r-&gt;ofcall.qid;
	respond(r, nil);
}

Srv fs=
{
.attach=	fsattach,
.open=	fsopen,
.read=	fsread,
.stat=	fsstat,
.walk=	fswalk,
.destroyfid=	fsclunk
};

void
main(int argc, char **argv)
{
	char *service;

	time0 = time(0);
	service = nil;
	ARGBEGIN{
	case 'D':
		chatty9p++;
		break;
	case 's':
		service = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(argc &gt; 1)
		usage();
	postmountsrv(&amp;fs, service, argc ? argv[0] : "/n", MAFTER);
	exits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

