<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/convDNS2M.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/convDNS2M.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

/*
 *  a dictionary of domain names for packing messages
 */
enum
{
	Ndict=	64,
};
typedef struct Dict	Dict;
struct Dict
{
	struct {
		ushort	offset;		/* pointer to packed name in message */
		char	*name;		/* pointer to unpacked name in buf */
	} x[Ndict];
	int	n;		/* size of dictionary */
	uchar	*start;		/* start of packed message */
	char	buf[16*1024];	/* buffer for unpacked names (was 4k) */
	char	*ep;		/* first free char in buf */
};

#define NAME(x)		p = pname(p, ep, x, dp)
#define SYMBOL(x)	p = psym(p, ep, x)
#define STRING(x)	p = pstr(p, ep, x)
#define BYTES(x, n)	p = pbytes(p, ep, x, n)
#define USHORT(x)	p = pushort(p, ep, x)
#define UCHAR(x)	p = puchar(p, ep, x)
#define ULONG(x)	p = pulong(p, ep, x)
#define V4ADDR(x)	p = pv4addr(p, ep, x)
#define V6ADDR(x)	p = pv6addr(p, ep, x)

static uchar*
psym(uchar *p, uchar *ep, char *np)
{
	int n;

	n = strlen(np);
	if(n &gt;= Strlen)			/* DNS maximum length string */
		n = Strlen - 1;
	if(ep - p &lt; n+1)		/* see if it fits in the buffer */
		return ep+1;
	*p++ = n;
	memmove(p, np, n);
	return p + n;
}

static uchar*
pstr(uchar *p, uchar *ep, char *np)
{
	return psym(p, ep, np);
}

static uchar*
pbytes(uchar *p, uchar *ep, uchar *np, int n)
{
	if(ep - p &lt; n)
		return ep+1;
	memmove(p, np, n);
	return p + n;
}

static uchar*
puchar(uchar *p, uchar *ep, int val)
{
	if(ep - p &lt; 1)
		return ep+1;
	*p++ = val;
	return p;
}

static uchar*
pushort(uchar *p, uchar *ep, int val)
{
	if(ep - p &lt; 2)
		return ep+1;
	*p++ = val&gt;&gt;8;
	*p++ = val;
	return p;
}

static uchar*
pulong(uchar *p, uchar *ep, int val)
{
	if(ep - p &lt; 4)
		return ep+1;
	*p++ = val&gt;&gt;24;
	*p++ = val&gt;&gt;16;
	*p++ = val&gt;&gt;8;
	*p++ = val;
	return p;
}

static uchar*
pv4addr(uchar *p, uchar *ep, char *name)
{
	uchar ip[IPaddrlen];

	if(ep - p &lt; 4)
		return ep+1;
	parseip(ip, name);
	v6tov4(p, ip);
	return p + 4;
}

static uchar*
pv6addr(uchar *p, uchar *ep, char *name)
{
	if(ep - p &lt; IPaddrlen)
		return ep+1;
	parseip(p, name);
	return p + IPaddrlen;
}

static uchar*
pname(uchar *p, uchar *ep, char *np, Dict *dp)
{
	int i;
	char *cp;
	char *last;		/* last component packed */

	if(strlen(np) &gt;= Domlen) /* make sure we don't exceed DNS limits */
		return ep+1;

	last = 0;
	while(*np){
		/* look through every component in the dictionary for a match */
		for(i = 0; i &lt; dp-&gt;n; i++)
			if(strcmp(np, dp-&gt;x[i].name) == 0){
				if(ep - p &lt; 2)
					return ep+1;
				if ((dp-&gt;x[i].offset&gt;&gt;8) &amp; 0xc0)
					dnslog("convDNS2M: offset too big for "
						"DNS packet format");
				*p++ = dp-&gt;x[i].offset&gt;&gt;8 | 0xc0;
				*p++ = dp-&gt;x[i].offset;
				return p;
			}

		/* if there's room, enter this name in dictionary */
		if(dp-&gt;n &lt; Ndict)
			if(last){
				/* the whole name is already in dp-&gt;buf */
				last = strchr(last, '.') + 1;
				dp-&gt;x[dp-&gt;n].name = last;
				dp-&gt;x[dp-&gt;n].offset = p - dp-&gt;start;
				dp-&gt;n++;
			} else {
				/* add to dp-&gt;buf */
				i = strlen(np);
				if(dp-&gt;ep + i + 1 &lt; &amp;dp-&gt;buf[sizeof dp-&gt;buf]){
					strcpy(dp-&gt;ep, np);
					dp-&gt;x[dp-&gt;n].name = dp-&gt;ep;
					last = dp-&gt;ep;
					dp-&gt;x[dp-&gt;n].offset = p - dp-&gt;start;
					dp-&gt;ep += i + 1;
					dp-&gt;n++;
				}
			}

		/* put next component into message */
		cp = strchr(np, '.');
		if(cp == nil){
			i = strlen(np);
			cp = np + i;	/* point to null terminator */
		} else {
			i = cp - np;
			cp++;		/* point past '.' */
		}
		if(ep-p &lt; i+1)
			return ep+1;
		if (i &gt; Labellen)
			return ep+1;
		*p++ = i;		/* count of chars in label */
		memmove(p, np, i);
		np = cp;
		p += i;
	}

	if(p &gt;= ep)
		return ep+1;
	*p++ = 0;	/* add top level domain */

	return p;
}

static uchar*
convRR2M(RR *rp, uchar *p, uchar *ep, Dict *dp)
{
	uchar *lp, *data;
	int len, ttl;
	Txt *t;

	NAME(rp-&gt;owner-&gt;name);
	USHORT(rp-&gt;type);
	USHORT(rp-&gt;owner-&gt;class);

	/* egregious overuse of ttl (it's absolute time in the cache) */
	if(rp-&gt;db)
		ttl = rp-&gt;ttl;
	else
		ttl = rp-&gt;ttl - now;
	if(ttl &lt; 0)
		ttl = 0;
	ULONG(ttl);

	lp = p;			/* leave room for the rdata length */
	p += 2;
	data = p;

	if(data &gt;= ep)
		return p+1;

	switch(rp-&gt;type){
	case Thinfo:
		SYMBOL(rp-&gt;cpu-&gt;name);
		SYMBOL(rp-&gt;os-&gt;name);
		break;
	case Tcname:
	case Tmb:
	case Tmd:
	case Tmf:
	case Tns:
		NAME(rp-&gt;host-&gt;name);
		break;
	case Tmg:
	case Tmr:
		NAME(rp-&gt;mb-&gt;name);
		break;
	case Tminfo:
		NAME(rp-&gt;rmb-&gt;name);
		NAME(rp-&gt;mb-&gt;name);
		break;
	case Tmx:
		USHORT(rp-&gt;pref);
		NAME(rp-&gt;host-&gt;name);
		break;
	case Ta:
		V4ADDR(rp-&gt;ip-&gt;name);
		break;
	case Taaaa:
		V6ADDR(rp-&gt;ip-&gt;name);
		break;
	case Tptr:
		NAME(rp-&gt;ptr-&gt;name);
		break;
	case Tsoa:
		NAME(rp-&gt;host-&gt;name);
		NAME(rp-&gt;rmb-&gt;name);
		ULONG(rp-&gt;soa-&gt;serial);
		ULONG(rp-&gt;soa-&gt;refresh);
		ULONG(rp-&gt;soa-&gt;retry);
		ULONG(rp-&gt;soa-&gt;expire);
		ULONG(rp-&gt;soa-&gt;minttl);
		break;
	case Tsrv:
		USHORT(rp-&gt;srv-&gt;pri);
		USHORT(rp-&gt;srv-&gt;weight);
		USHORT(rp-&gt;port);
		STRING(rp-&gt;host-&gt;name);	/* rfc2782 sez no name compression */
		break;
	case Ttxt:
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next)
			STRING(t-&gt;p);
		break;
	case Tnull:
		BYTES(rp-&gt;null-&gt;data, rp-&gt;null-&gt;dlen);
		break;
	case Trp:
		NAME(rp-&gt;rmb-&gt;name);
		NAME(rp-&gt;rp-&gt;name);
		break;
	case Tkey:
		USHORT(rp-&gt;key-&gt;flags);
		UCHAR(rp-&gt;key-&gt;proto);
		UCHAR(rp-&gt;key-&gt;alg);
		BYTES(rp-&gt;key-&gt;data, rp-&gt;key-&gt;dlen);
		break;
	case Tsig:
		USHORT(rp-&gt;sig-&gt;type);
		UCHAR(rp-&gt;sig-&gt;alg);
		UCHAR(rp-&gt;sig-&gt;labels);
		ULONG(rp-&gt;sig-&gt;ttl);
		ULONG(rp-&gt;sig-&gt;exp);
		ULONG(rp-&gt;sig-&gt;incep);
		USHORT(rp-&gt;sig-&gt;tag);
		NAME(rp-&gt;sig-&gt;signer-&gt;name);
		BYTES(rp-&gt;sig-&gt;data, rp-&gt;sig-&gt;dlen);
		break;
	case Tcert:
		USHORT(rp-&gt;cert-&gt;type);
		USHORT(rp-&gt;cert-&gt;tag);
		UCHAR(rp-&gt;cert-&gt;alg);
		BYTES(rp-&gt;cert-&gt;data, rp-&gt;cert-&gt;dlen);
		break;
	}

	/* stuff in the rdata section length */
	len = p - data;
	*lp++ = len &gt;&gt; 8;
	*lp = len;

	return p;
}

static uchar*
convQ2M(RR *rp, uchar *p, uchar *ep, Dict *dp)
{
	NAME(rp-&gt;owner-&gt;name);
	USHORT(rp-&gt;type);
	USHORT(rp-&gt;owner-&gt;class);
	return p;
}

static uchar*
rrloop(RR *rp, int *countp, uchar *p, uchar *ep, Dict *dp, int quest)
{
	uchar *np;

	*countp = 0;
	for(; rp &amp;&amp; p &lt; ep; rp = rp-&gt;next){
		if(quest)
			np = convQ2M(rp, p, ep, dp);
		else
			np = convRR2M(rp, p, ep, dp);
		if(np &gt; ep)
			break;
		p = np;
		(*countp)++;
	}
	return p;
}

/*
 *  convert into a message
 */
int
convDNS2M(DNSmsg *m, uchar *buf, int len)
{
	ulong trunc = 0;
	uchar *p, *ep, *np;
	Dict d;

	d.n = 0;
	d.start = buf;
	d.ep = d.buf;
	memset(buf, 0, len);
	m-&gt;qdcount = m-&gt;ancount = m-&gt;nscount = m-&gt;arcount = 0;

	/* first pack in the RR's so we can get real counts */
	p = buf + 12;
	ep = buf + len;
	p = rrloop(m-&gt;qd, &amp;m-&gt;qdcount, p, ep, &amp;d, 1);
	p = rrloop(m-&gt;an, &amp;m-&gt;ancount, p, ep, &amp;d, 0);
	p = rrloop(m-&gt;ns, &amp;m-&gt;nscount, p, ep, &amp;d, 0);
	p = rrloop(m-&gt;ar, &amp;m-&gt;arcount, p, ep, &amp;d, 0);
	if(p &gt; ep) {
		trunc = Ftrunc;
		dnslog("udp packet full; truncating my reply");
		p = ep;
	}

	/* now pack the rest */
	np = p;
	p = buf;
	ep = buf + len;
	USHORT(m-&gt;id);
	USHORT(m-&gt;flags | trunc);
	USHORT(m-&gt;qdcount);
	USHORT(m-&gt;ancount);
	USHORT(m-&gt;nscount);
	USHORT(m-&gt;arcount);
	USED(p);
	return np - buf;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

