<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dblookup.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dblookup.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

enum {
	Nibwidth = 4,
	Nibmask = (1&lt;&lt;Nibwidth) - 1,
	V6maxrevdomdepth = 128 / Nibwidth,	/* bits / bits-per-nibble */

	/*
	 * ttl for generated ptr records.  it was zero, which might seem
	 * like a good idea, but some dns implementations seem to be
	 * confused by a zero ttl, and instead of using the data and then
	 * discarding the RR, they conclude that they don't have valid data.
	 */
	Ptrttl = 120,
};

static Ndb *db;
static Lock	dblock;

static RR*	addrrr(Ndbtuple*, Ndbtuple*);
static RR*	cnamerr(Ndbtuple*, Ndbtuple*);
static void	createptrs(void);
static RR*	dblookup1(char*, int, int, int);
static RR*	doaxfr(Ndb*, char*);
static Ndbtuple*look(Ndbtuple*, Ndbtuple*, char*);
static RR*	mxrr(Ndbtuple*, Ndbtuple*);
static RR*	nsrr(Ndbtuple*, Ndbtuple*);
static RR*	nullrr(Ndbtuple*, Ndbtuple*);
static RR*	ptrrr(Ndbtuple*, Ndbtuple*);
static RR*	soarr(Ndbtuple*, Ndbtuple*);
static RR*	srvrr(Ndbtuple*, Ndbtuple*);
static RR*	txtrr(Ndbtuple*, Ndbtuple*);

static int	implemented[Tall] =
{
	[Ta]		1,
	[Taaaa]		1,
	[Tcname]	1,
	[Tmx]		1,
	[Tns]		1,
	[Tnull]		1,
	[Tptr]		1,
	[Tsoa]		1,
	[Tsrv]		1,
	[Ttxt]		1,
};

/* straddle server configuration */
static Ndbtuple *indoms, *innmsrvs, *outnmsrvs;

static void
nstrcpy(char *to, char *from, int len)
{
	strncpy(to, from, len);
	to[len-1] = 0;
}

int
opendatabase(void)
{
	char netdbnm[256];
	Ndb *xdb, *netdb;

	if (db)
		return 0;

	xdb = ndbopen(dbfile);		/* /lib/ndb */

	snprint(netdbnm, sizeof netdbnm, "%s/ndb", mntpt);
	netdb = ndbopen(netdbnm);	/* /net/ndb */
	if(netdb)
		netdb-&gt;nohash = 1;

	db = ndbcat(netdb, xdb);	/* both */
	return db? 0: -1;
}

/*
 *  lookup an RR in the network database, look for matches
 *  against both the domain name and the wildcarded domain name.
 *
 *  the lock makes sure only one process can be accessing the data
 *  base at a time.  This is important since there's a lot of
 *  shared state there.
 *
 *  e.g. for x.research.bell-labs.com, first look for a match against
 *       the x.research.bell-labs.com.  If nothing matches,
 *	 try *.research.bell-labs.com.
 */
RR*
dblookup(char *name, int class, int type, int auth, int ttl)
{
	int err;
	char *wild, *cp;
	char buf[256];
	RR *rp, *tp;
	DN *dp, *ndp;

	/* so far only internet lookups are implemented */
	if(class != Cin)
		return 0;

	err = Rname;
	rp = nil;

	if(type == Tall){
		for (type = Ta; type &lt; Tall; type++)
			if(implemented[type]) {
				tp = dblookup(name, class, type, auth, ttl);
				lock(&amp;dnlock);
				rrcat(&amp;rp, tp);
				unlock(&amp;dnlock);
			}
		return rp;
	}

	lock(&amp;dblock);
	dp = dnlookup(name, class, 1);

	if(opendatabase() &lt; 0)
		goto out;
	if(dp-&gt;rr)
		err = 0;

	/* first try the given name */
	if(cfg.cachedb)
		rp = rrlookup(dp, type, NOneg);
	else
		rp = dblookup1(name, type, auth, ttl);
	if(rp)
		goto out;

	/* try lower case version */
	for(cp = name; *cp; cp++)
		*cp = tolower(*cp);
	if(cfg.cachedb)
		rp = rrlookup(dp, type, NOneg);
	else
		rp = dblookup1(name, type, auth, ttl);
	if(rp)
		goto out;

	/* walk the domain name trying the wildcard '*' at each position */
	for(wild = strchr(name, '.'); wild; wild = strchr(wild+1, '.')){
		snprint(buf, sizeof buf, "*%s", wild);
		ndp = dnlookup(buf, class, 1);
		if(ndp-&gt;rr)
			err = 0;
		if(cfg.cachedb)
			rp = rrlookup(ndp, type, NOneg);
		else
			rp = dblookup1(buf, type, auth, ttl);
		if(rp)
			break;
	}
out:
	/* add owner to uncached records */
	if(rp)
		for(tp = rp; tp; tp = tp-&gt;next)
			tp-&gt;owner = dp;
	else {
		/*
		 * don't call it non-existent if it's not ours
		 * (unless we're a resolver).
		 */
		if(err == Rname &amp;&amp; (!inmyarea(name) || cfg.resolver))
			err = Rserver;
		dp-&gt;respcode = err;
	}

	unlock(&amp;dblock);
	return rp;
}

static ulong
intval(Ndbtuple *entry, Ndbtuple *pair, char *attr, ulong def)
{
	Ndbtuple *t = look(entry, pair, attr);

	return (t? strtoul(t-&gt;val, 0, 10): def);
}

/*
 *  lookup an RR in the network database
 */
static RR*
dblookup1(char *name, int type, int auth, int ttl)
{
	Ndbtuple *t, *nt;
	RR *rp, *list, **l;
	Ndbs s;
	char dname[Domlen];
	char *attr;
	DN *dp;
	RR *(*f)(Ndbtuple*, Ndbtuple*);
	int found, x;

	dp = nil;
	switch(type){
	case Tptr:
		attr = "ptr";
		f = ptrrr;
		break;
	case Ta:
		attr = "ip";
		f = addrrr;
		break;
	case Taaaa:
		attr = "ipv6";
		f = addrrr;
		break;
	case Tnull:
		attr = "nullrr";
		f = nullrr;
		break;
	case Tns:
		attr = "ns";
		f = nsrr;
		break;
	case Tsoa:
		attr = "soa";
		f = soarr;
		break;
	case Tsrv:
		attr = "srv";
		f = srvrr;
		break;
	case Tmx:
		attr = "mx";
		f = mxrr;
		break;
	case Tcname:
		attr = "cname";
		f = cnamerr;
		break;
	case Taxfr:
	case Tixfr:
		return doaxfr(db, name);
	default:
//		dnslog("dnlookup1(%s) bad type", name);
		return nil;
	}

	/*
	 *  find a matching entry in the database
	 */
	t = nil;
	free(ndbgetvalue(db, &amp;s, "dom", name, attr, &amp;t));

	/*
	 *  hack for local names
	 */
	if(t == nil &amp;&amp; strchr(name, '.') == nil)
		free(ndbgetvalue(db, &amp;s, "sys", name, attr, &amp;t));
	if(t == nil) {
//		dnslog("dnlookup1(%s) name not found", name);
		return nil;
	}

	/* search whole entry for default domain name */
	strncpy(dname, name, sizeof dname);
	for(nt = t; nt; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "dom") == 0){
			nstrcpy(dname, nt-&gt;val, sizeof dname);
			break;
		}

	/* ttl is maximum of soa minttl and entry's ttl ala rfc883 */
	x = intval(t, s.t, "ttl", 0);
	if(x &gt; ttl)
		ttl = x;

	/* default ttl is one day */
	if(ttl &lt; 0)
		ttl = DEFTTL;

	/*
	 *  The database has 2 levels of precedence; line and entry.
	 *  Pairs on the same line bind tighter than pairs in the
	 *  same entry, so we search the line first.
	 */
	found = 0;
	list = 0;
	l = &amp;list;
	for(nt = s.t;; ){
		if(found == 0 &amp;&amp; strcmp(nt-&gt;attr, "dom") == 0){
			nstrcpy(dname, nt-&gt;val, sizeof dname);
			found = 1;
		}
		if(cistrcmp(attr, nt-&gt;attr) == 0){
			rp = (*f)(t, nt);
			rp-&gt;auth = auth;
			rp-&gt;db = 1;
			if(ttl)
				rp-&gt;ttl = ttl;
			if(dp == nil)
				dp = dnlookup(dname, Cin, 1);
			rp-&gt;owner = dp;
			*l = rp;
			l = &amp;rp-&gt;next;
			nt-&gt;ptr = 1;
		}
		nt = nt-&gt;line;
		if(nt == s.t)
			break;
	}

	/* search whole entry */
	for(nt = t; nt; nt = nt-&gt;entry)
		if(nt-&gt;ptr == 0 &amp;&amp; cistrcmp(attr, nt-&gt;attr) == 0){
			rp = (*f)(t, nt);
			rp-&gt;db = 1;
			if(ttl)
				rp-&gt;ttl = ttl;
			rp-&gt;auth = auth;
			if(dp == nil)
				dp = dnlookup(dname, Cin, 1);
			rp-&gt;owner = dp;
			*l = rp;
			l = &amp;rp-&gt;next;
		}
	ndbfree(t);

//	dnslog("dnlookup1(%s) -&gt; %#p", name, list);
	return list;
}

/*
 *  make various types of resource records from a database entry
 */
static RR*
addrrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;
	uchar addr[IPaddrlen];

	USED(entry);
	parseip(addr, pair-&gt;val);
	if(isv4(addr))
		rp = rralloc(Ta);
	else
		rp = rralloc(Taaaa);
	rp-&gt;ip = dnlookup(pair-&gt;val, Cin, 1);
	return rp;
}
static RR*
nullrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;

	USED(entry);
	rp = rralloc(Tnull);
	rp-&gt;null-&gt;data = (uchar*)estrdup(pair-&gt;val);
	rp-&gt;null-&gt;dlen = strlen((char*)rp-&gt;null-&gt;data);
	return rp;
}
/*
 *  txt rr strings are at most 255 bytes long.  one
 *  can represent longer strings by multiple concatenated
 *  &lt;= 255 byte ones.
 */
static RR*
txtrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;
	Txt *t, **l;
	int i, len, sofar;

	USED(entry);
	rp = rralloc(Ttxt);
	l = &amp;rp-&gt;txt;
	rp-&gt;txt = nil;
	len = strlen(pair-&gt;val);
	sofar = 0;
	while(len &gt; sofar){
		t = emalloc(sizeof(*t));
		t-&gt;next = nil;

		i = len-sofar;
		if(i &gt; 255)
			i = 255;

		t-&gt;p = emalloc(i+1);
		memmove(t-&gt;p, pair-&gt;val+sofar, i);
		t-&gt;p[i] = 0;
		sofar += i;

		*l = t;
		l = &amp;t-&gt;next;
	}
	return rp;
}
static RR*
cnamerr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;

	USED(entry);
	rp = rralloc(Tcname);
	rp-&gt;host = dnlookup(pair-&gt;val, Cin, 1);
	return rp;
}
static RR*
mxrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;

	rp = rralloc(Tmx);
	rp-&gt;host = dnlookup(pair-&gt;val, Cin, 1);
	rp-&gt;pref = intval(entry, pair, "pref", 1);
	return rp;
}
static RR*
nsrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;
	Ndbtuple *t;

	rp = rralloc(Tns);
	rp-&gt;host = dnlookup(pair-&gt;val, Cin, 1);
	t = look(entry, pair, "soa");
	if(t &amp;&amp; t-&gt;val[0] == 0)
		rp-&gt;local = 1;
	return rp;
}
static RR*
ptrrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;

	USED(entry);
	rp = rralloc(Tns);
	rp-&gt;ptr = dnlookup(pair-&gt;val, Cin, 1);
	return rp;
}
static RR*
soarr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;
	Ndbtuple *ns, *mb, *t;
	char mailbox[Domlen];
	Ndb *ndb;
	char *p;

	rp = rralloc(Tsoa);
	rp-&gt;soa-&gt;serial = 1;
	for(ndb = db; ndb; ndb = ndb-&gt;next)
		if(ndb-&gt;mtime &gt; rp-&gt;soa-&gt;serial)
			rp-&gt;soa-&gt;serial = ndb-&gt;mtime;

	rp-&gt;soa-&gt;retry  = intval(entry, pair, "retry", Hour);
	rp-&gt;soa-&gt;expire = intval(entry, pair, "expire", Day);
	rp-&gt;soa-&gt;minttl = intval(entry, pair, "ttl", Day);
	rp-&gt;soa-&gt;refresh = intval(entry, pair, "refresh", Day);
	rp-&gt;soa-&gt;serial = intval(entry, pair, "serial", rp-&gt;soa-&gt;serial);

	ns = look(entry, pair, "ns");
	if(ns == nil)
		ns = look(entry, pair, "dom");
	rp-&gt;host = dnlookup(ns-&gt;val, Cin, 1);

	/* accept all of:
	 *  mbox=person
	 *  mbox=person@machine.dom
	 *  mbox=person.machine.dom
	 */
	mb = look(entry, pair, "mbox");
	if(mb == nil)
		mb = look(entry, pair, "mb");
	if(mb)
		if(strchr(mb-&gt;val, '.')) {
			p = strchr(mb-&gt;val, '@');
			if(p != nil)
				*p = '.';
			rp-&gt;rmb = dnlookup(mb-&gt;val, Cin, 1);
		} else {
			snprint(mailbox, sizeof mailbox, "%s.%s",
				mb-&gt;val, ns-&gt;val);
			rp-&gt;rmb = dnlookup(mailbox, Cin, 1);
		}
	else {
		snprint(mailbox, sizeof mailbox, "postmaster.%s", ns-&gt;val);
		rp-&gt;rmb = dnlookup(mailbox, Cin, 1);
	}

	/*
	 *  hang dns slaves off of the soa.  this is
	 *  for managing the area.
	 */
	for(t = entry; t != nil; t = t-&gt;entry)
		if(strcmp(t-&gt;attr, "dnsslave") == 0)
			addserver(&amp;rp-&gt;soa-&gt;slaves, t-&gt;val);

	return rp;
}

static RR*
srvrr(Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;

	rp = rralloc(Tsrv);
	rp-&gt;host = dnlookup(pair-&gt;val, Cin, 1);
	rp-&gt;srv-&gt;pri = intval(entry, pair, "pri", 0);
	rp-&gt;srv-&gt;weight = intval(entry, pair, "weight", 0);
	/* TODO: translate service name to port # */
	rp-&gt;port = intval(entry, pair, "port", 0);
	return rp;
}

/*
 *  Look for a pair with the given attribute.  look first on the same line,
 *  then in the whole entry.
 */
static Ndbtuple*
look(Ndbtuple *entry, Ndbtuple *line, char *attr)
{
	Ndbtuple *nt;

	/* first look on same line (closer binding) */
	for(nt = line;;){
		if(cistrcmp(attr, nt-&gt;attr) == 0)
			return nt;
		nt = nt-&gt;line;
		if(nt == line)
			break;
	}
	/* search whole tuple */
	for(nt = entry; nt; nt = nt-&gt;entry)
		if(cistrcmp(attr, nt-&gt;attr) == 0)
			return nt;
	return 0;
}

static RR**
linkrr(RR *rp, DN *dp, RR **l)
{
	rp-&gt;owner = dp;
	rp-&gt;auth = 1;
	rp-&gt;db = 1;
	*l = rp;
	return &amp;rp-&gt;next;
}

/* these are answered specially by the tcp version */
static RR*
doaxfr(Ndb *db, char *name)
{
	USED(db, name);
	return 0;
}


/*
 *  read the all the soa's from the database to determine area's.
 *  this is only used when we're not caching the database.
 */
static void
dbfile2area(Ndb *db)
{
	Ndbtuple *t;

	if(debug)
		dnslog("rereading %s", db-&gt;file);
	Bseek(&amp;db-&gt;b, 0, 0);
	while(t = ndbparse(db))
		ndbfree(t);
}

/*
 *  read the database into the cache
 */
static void
dbpair2cache(DN *dp, Ndbtuple *entry, Ndbtuple *pair)
{
	RR *rp;
	static ulong ord;

	rp = 0;
	if(cistrcmp(pair-&gt;attr, "ip") == 0 ||
	   cistrcmp(pair-&gt;attr, "ipv6") == 0){
		dp-&gt;ordinal = ord++;
		rp = addrrr(entry, pair);
	} else 	if(cistrcmp(pair-&gt;attr, "ns") == 0)
		rp = nsrr(entry, pair);
	else if(cistrcmp(pair-&gt;attr, "soa") == 0) {
		rp = soarr(entry, pair);
		addarea(dp, rp, pair);
	} else if(cistrcmp(pair-&gt;attr, "mx") == 0)
		rp = mxrr(entry, pair);
	else if(cistrcmp(pair-&gt;attr, "srv") == 0)
		rp = srvrr(entry, pair);
	else if(cistrcmp(pair-&gt;attr, "cname") == 0)
		rp = cnamerr(entry, pair);
	else if(cistrcmp(pair-&gt;attr, "nullrr") == 0)
		rp = nullrr(entry, pair);
	else if(cistrcmp(pair-&gt;attr, "txtrr") == 0)
		rp = txtrr(entry, pair);
	if(rp == nil)
		return;

	rp-&gt;owner = dp;
	dnagenever(dp, 1);
	rp-&gt;db = 1;
	rp-&gt;ttl = intval(entry, pair, "ttl", rp-&gt;ttl);
	rrattach(rp, Notauthoritative);
}
static void
dbtuple2cache(Ndbtuple *t)
{
	Ndbtuple *et, *nt;
	DN *dp;

	for(et = t; et; et = et-&gt;entry)
		if(strcmp(et-&gt;attr, "dom") == 0){
			dp = dnlookup(et-&gt;val, Cin, 1);

			/* first same line */
			for(nt = et-&gt;line; nt != et; nt = nt-&gt;line){
				dbpair2cache(dp, t, nt);
				nt-&gt;ptr = 1;
			}

			/* then rest of entry */
			for(nt = t; nt; nt = nt-&gt;entry){
				if(nt-&gt;ptr == 0)
					dbpair2cache(dp, t, nt);
				nt-&gt;ptr = 0;
			}
		}
}
static void
dbfile2cache(Ndb *db)
{
	Ndbtuple *t;

	if(debug)
		dnslog("rereading %s", db-&gt;file);
	Bseek(&amp;db-&gt;b, 0, 0);
	while(t = ndbparse(db)){
		dbtuple2cache(t);
		ndbfree(t);
	}
}

/* called with dblock held */
static void
loaddomsrvs(void)
{
	Ndbs s;

	if (!cfg.inside || !cfg.straddle || !cfg.serve)
		return;
	if (indoms) {
		ndbfree(indoms);
		ndbfree(innmsrvs);
		ndbfree(outnmsrvs);
		indoms = innmsrvs = outnmsrvs = nil;
	}
	if (db == nil)
		opendatabase();
	free(ndbgetvalue(db, &amp;s, "sys", "inside-dom", "dom", &amp;indoms));
	free(ndbgetvalue(db, &amp;s, "sys", "inside-ns",  "ip",  &amp;innmsrvs));
	free(ndbgetvalue(db, &amp;s, "sys", "outside-ns", "ip",  &amp;outnmsrvs));
	dnslog("[%d] ndb changed: reloaded inside-dom, inside-ns, outside-ns",
		getpid());
}

void
db2cache(int doit)
{
	ulong youngest;
	Ndb *ndb;
	Dir *d;
	static ulong lastcheck, lastyoungest;

	/* no faster than once every 2 minutes */
	if(now &lt; lastcheck + 2*Min &amp;&amp; !doit)
		return;

	refresh_areas(owned);

	lock(&amp;dblock);

	if(opendatabase() &lt; 0){
		unlock(&amp;dblock);
		return;
	}

	/*
	 *  file may be changing as we are reading it, so loop till
	 *  mod times are consistent.
	 *
	 *  we don't use the times in the ndb records because they may
	 *  change outside of refreshing our cached knowledge.
	 */
	for(;;){
		lastcheck = now;
		youngest = 0;
		for(ndb = db; ndb; ndb = ndb-&gt;next)
			/* dirfstat avoids walking the mount table each time */
			if((d = dirfstat(Bfildes(&amp;ndb-&gt;b))) != nil ||
			   (d = dirstat(ndb-&gt;file)) != nil){
				if(d-&gt;mtime &gt; youngest)
					youngest = d-&gt;mtime;
				free(d);
			}
		if(!doit &amp;&amp; youngest == lastyoungest)
			break;

		/* forget our area definition */
		freearea(&amp;owned);
		freearea(&amp;delegated);

		/* reopen all the files (to get oldest for time stamp) */
		for(ndb = db; ndb; ndb = ndb-&gt;next)
			ndbreopen(ndb);

		/* reload straddle-server configuration */
		loaddomsrvs();

		if(cfg.cachedb){
			/* mark all db records as timed out */
			dnagedb();

			/* read in new entries */
			for(ndb = db; ndb; ndb = ndb-&gt;next)
				dbfile2cache(ndb);

			/* mark as authoritative anything in our domain */
			dnauthdb();

			/* remove old entries */
			dnageall(1);
		} else
			/* read all the soa's to get database defaults */
			for(ndb = db; ndb; ndb = ndb-&gt;next)
				dbfile2area(ndb);

		doit = 0;
		lastyoungest = youngest;
		createptrs();
	}

	unlock(&amp;dblock);
}

void
dnforceage(void)
{
	lock(&amp;dblock);
	dnageall(1);
	unlock(&amp;dblock);
}

extern uchar	ipaddr[IPaddrlen];	/* my ip address */

/*
 *  get all my xxx
 *  caller ndbfrees the result
 */
Ndbtuple*
lookupinfo(char *attr)
{
	char buf[64];
	char *a[2];
	Ndbtuple *t;

	snprint(buf, sizeof buf, "%I", ipaddr);
	a[0] = attr;

	lock(&amp;dblock);
	if(opendatabase() &lt; 0){
		unlock(&amp;dblock);
		return nil;
	}
	t = ndbipinfo(db, "ip", buf, a, 1);
	unlock(&amp;dblock);
	return t;
}

char *localservers =	  "local#dns#servers";
char *localserverprefix = "local#dns#server";

/*
 *  return non-zero if this is a bad delegation
 */
int
baddelegation(RR *rp, RR *nsrp, uchar *addr)
{
	Ndbtuple *nt;
	static int whined;
	static Ndbtuple *t;

	if(t == nil)
		t = lookupinfo("dom");
	if(t == nil)
		return 0;

	for(; rp; rp = rp-&gt;next){
		if(rp-&gt;type != Tns)
			continue;

		/* see if delegation is looping */
		if(nsrp)
		if(rp-&gt;owner != nsrp-&gt;owner)
		if(subsume(rp-&gt;owner-&gt;name, nsrp-&gt;owner-&gt;name) &amp;&amp;
		   strcmp(nsrp-&gt;owner-&gt;name, localservers) != 0){
			dnslog("delegation loop %R -&gt; %R from %I",
				nsrp, rp, addr);
			return 1;
		}

		/* see if delegating to us what we don't own */
		for(nt = t; nt != nil; nt = nt-&gt;entry)
			if(rp-&gt;host &amp;&amp; cistrcmp(rp-&gt;host-&gt;name, nt-&gt;val) == 0)
				break;
		if(nt != nil &amp;&amp; !inmyarea(rp-&gt;owner-&gt;name)){
			if (!whined) {
				whined = 1;
				dnslog("bad delegation %R from %I; "
					"no further logging of them", rp, addr);
			}
			return 1;
		}
	}

	return 0;
}

int
myaddr(char *addr)
{
	char *name, *line, *sp;
	char buf[64];
	Biobuf *bp;

	snprint(buf, sizeof buf, "%I", ipaddr);
	if (strcmp(addr, buf) == 0) {
		dnslog("rejecting my ip %s as local dns server", addr);
		return 1;
	}

	name = smprint("%s/ipselftab", mntpt);
	bp = Bopen(name, OREAD);
	free(name);
	if (bp != nil) {
		while ((line = Brdline(bp, '\n')) != nil) {
			line[Blinelen(bp) - 1] = '\0';
			sp = strchr(line, ' ');
			if (sp) {
				*sp = '\0';
				if (strcmp(addr, line) == 0) {
					dnslog("rejecting my ip %s as local dns server",
						addr);
					return 1;
				}
			}
		}
		Bterm(bp);
	}
	return 0;
}

static char *locdns[20];
static QLock locdnslck;

static void
addlocaldnsserver(DN *dp, int class, char *ipaddr, int i)
{
	int n;
	DN *nsdp;
	RR *rp;
	char buf[32];
	uchar ip[IPaddrlen];

	/* reject our own ip addresses so we don't query ourselves via udp */
	if (myaddr(ipaddr))
		return;

	qlock(&amp;locdnslck);
	for (n = 0; n &lt; i &amp;&amp; n &lt; nelem(locdns) &amp;&amp; locdns[n]; n++)
		if (strcmp(locdns[n], ipaddr) == 0) {
			dnslog("rejecting duplicate local dns server ip %s",
				ipaddr);
			qunlock(&amp;locdnslck);
			return;
		}
	if (n &lt; nelem(locdns))
		if (locdns[n] == nil || ++n &lt; nelem(locdns))
			locdns[n] = strdup(ipaddr); /* remember 1st few local ns */
	qunlock(&amp;locdnslck);

	/* ns record for name server, make up an impossible name */
	rp = rralloc(Tns);
	snprint(buf, sizeof buf, "%s%d", localserverprefix, i);
	nsdp = dnlookup(buf, class, 1);
	rp-&gt;host = nsdp;
	rp-&gt;owner = dp;			/* e.g., local#dns#servers */
	rp-&gt;local = 1;
	rp-&gt;db = 1;
//	rp-&gt;ttl = 10*Min;		/* seems too short */
	rp-&gt;ttl = (1UL&lt;&lt;31)-1;
	rrattach(rp, Authoritative);	/* will not attach rrs in my area */

	/* A or AAAA record */
	if (parseip(ip, ipaddr) &gt;= 0 &amp;&amp; isv4(ip))
		rp = rralloc(Ta);
	else
		rp = rralloc(Taaaa);
	rp-&gt;ip = dnlookup(ipaddr, class, 1);
	rp-&gt;owner = nsdp;
	rp-&gt;local = 1;
	rp-&gt;db = 1;
//	rp-&gt;ttl = 10*Min;		/* seems too short */
	rp-&gt;ttl = (1UL&lt;&lt;31)-1;
	rrattach(rp, Authoritative);	/* will not attach rrs in my area */

	dnslog("added local dns server %s at %s", buf, ipaddr);
}

/*
 *  return list of dns server addresses to use when
 *  acting just as a resolver.
 */
RR*
dnsservers(int class)
{
	int i, n;
	char *p;
	char *args[5];
	Ndbtuple *t, *nt;
	RR *nsrp;
	DN *dp;

	dp = dnlookup(localservers, class, 1);
	nsrp = rrlookup(dp, Tns, NOneg);
	if(nsrp != nil)
		return nsrp;

	p = getenv("DNSSERVER");		/* list of ip addresses */
	if(p != nil){
		n = tokenize(p, args, nelem(args));
		for(i = 0; i &lt; n; i++)
			addlocaldnsserver(dp, class, args[i], i);
		free(p);
	} else {
		t = lookupinfo("@dns");		/* @dns=ip1 @dns=ip2 ... */
		if(t == nil)
			return nil;
		i = 0;
		for(nt = t; nt != nil; nt = nt-&gt;entry){
			addlocaldnsserver(dp, class, nt-&gt;val, i);
			i++;
		}
		ndbfree(t);
	}

	return rrlookup(dp, Tns, NOneg);
}

static void
addlocaldnsdomain(DN *dp, int class, char *domain)
{
	RR *rp;

	/* ptr record */
	rp = rralloc(Tptr);
	rp-&gt;ptr = dnlookup(domain, class, 1);
	rp-&gt;owner = dp;
	rp-&gt;db = 1;
	rp-&gt;ttl = 10*Min;
	rrattach(rp, Authoritative);
}

/*
 *  return list of domains to use when resolving names without '.'s
 */
RR*
domainlist(int class)
{
	Ndbtuple *t, *nt;
	RR *rp;
	DN *dp;

	dp = dnlookup("local#dns#domains", class, 1);
	rp = rrlookup(dp, Tptr, NOneg);
	if(rp != nil)
		return rp;

	t = lookupinfo("dnsdomain");
	if(t == nil)
		return nil;
	for(nt = t; nt != nil; nt = nt-&gt;entry)
		addlocaldnsdomain(dp, class, nt-&gt;val);
	ndbfree(t);

	return rrlookup(dp, Tptr, NOneg);
}

char *v4ptrdom = ".in-addr.arpa";
char *v6ptrdom = ".ip6.arpa";		/* ip6.int deprecated, rfc 3152 */

char *attribs[] = {
	"ipmask",
	0
};

/*
 *  create ptrs that are in our v4 areas
 */
static void
createv4ptrs(void)
{
	int len, dlen, n;
	char *dom;
	char buf[Domlen+1], ipa[48];
	char *f[40];
	uchar net[IPaddrlen], mask[IPaddrlen];
	Area *s;
	Ndbtuple *t, *nt;

	dlen = strlen(v4ptrdom);
	for(s = owned; s; s = s-&gt;next){
		dom = s-&gt;soarr-&gt;owner-&gt;name;
		len = strlen(dom);
		if((len &lt;= dlen || cistrcmp(dom+len-dlen, v4ptrdom) != 0) &amp;&amp;
		    cistrcmp(dom, v4ptrdom+1) != 0)
			continue;

		/* get mask and net value */
		strncpy(buf, dom, sizeof buf);
		buf[sizeof buf-1] = 0;
		/* buf contains something like 178.204.in-addr.arpa (n==4) */
		n = getfields(buf, f, nelem(f), 0, ".");
		memset(mask, 0xff, IPaddrlen);
		ipmove(net, v4prefix);
		switch(n){
		case 3:			/* /8 */
			net[IPv4off] = atoi(f[0]);
			mask[IPv4off+1] = 0;
			mask[IPv4off+2] = 0;
			mask[IPv4off+3] = 0;
			break;
		case 4:			/* /16 */
			net[IPv4off] = atoi(f[1]);
			net[IPv4off+1] = atoi(f[0]);
			mask[IPv4off+2] = 0;
			mask[IPv4off+3] = 0;
			break;
		case 5:			/* /24 */
			net[IPv4off] = atoi(f[2]);
			net[IPv4off+1] = atoi(f[1]);
			net[IPv4off+2] = atoi(f[0]);
			mask[IPv4off+3] = 0;
			break;
		case 6:		/* rfc2317: classless in-addr.arpa delegation */
			net[IPv4off] = atoi(f[3]);
			net[IPv4off+1] = atoi(f[2]);
			net[IPv4off+2] = atoi(f[1]);
			net[IPv4off+3] = atoi(f[0]);
			sprint(ipa, "%I", net);
			t = ndbipinfo(db, "ip", ipa, attribs, 1);
			if(t == nil)	/* could be a reverse with no forward */
				continue;
			nt = look(t, t, "ipmask");
			if(nt == nil){		/* we're confused */
				ndbfree(t);
				continue;
			}
			parseipmask(mask, nt-&gt;val);
			ndbfree(t);
			n = 5;
			break;
		default:
			continue;
		}

		/*
		 * go through all domain entries looking for RR's
		 * in this network and create ptrs.
		 * +2 for ".in-addr.arpa".
		 */
		dnptr(net, mask, dom, Ta, 4+2-n, Ptrttl);
	}
}

/* convert bytes to nibbles, big-endian */
void
bytes2nibbles(uchar *nibbles, uchar *bytes, int nbytes)
{
	while (nbytes-- &gt; 0) {
		*nibbles++ = *bytes &gt;&gt; Nibwidth;
		*nibbles++ = *bytes++ &amp; Nibmask;
	}
}

void
nibbles2bytes(uchar *bytes, uchar *nibbles, int nnibs)
{
	for (; nnibs &gt;= 2; nnibs -= 2) {
		*bytes++ = nibbles[0] &lt;&lt; Nibwidth | (nibbles[1]&amp;Nibmask);
		nibbles += 2;
	}
	if (nnibs &gt; 0)
		*bytes = nibbles[0] &lt;&lt; Nibwidth;
}

/*
 *  create ptrs that are in our v6 areas.  see rfc3596
 */
static void
createv6ptrs(void)
{
	int len, dlen, i, n, pfxnibs;
	char *dom;
	char buf[Domlen+1];
	char *f[40];
	uchar net[IPaddrlen], mask[IPaddrlen];
	uchar nibnet[IPaddrlen*2], nibmask[IPaddrlen*2];
	Area *s;

	dlen = strlen(v6ptrdom);
	for(s = owned; s; s = s-&gt;next){
		dom = s-&gt;soarr-&gt;owner-&gt;name;
		len = strlen(dom);
		if((len &lt;= dlen || cistrcmp(dom+len-dlen, v6ptrdom) != 0) &amp;&amp;
		    cistrcmp(dom, v6ptrdom+1) != 0)
			continue;

		/* get mask and net value */
		strncpy(buf, dom, sizeof buf);
		buf[sizeof buf-1] = 0;
		/* buf contains something like 2.0.0.2.ip6.arpa (n==6) */
		n = getfields(buf, f, nelem(f), 0, ".");
		pfxnibs = n - 2;		/* 2 for .ip6.arpa */
		if (pfxnibs &lt; 0 || pfxnibs &gt; V6maxrevdomdepth)
			continue;

		memset(net, 0, IPaddrlen);
		memset(mask, 0xff, IPaddrlen);
		bytes2nibbles(nibnet, net, IPaddrlen);
		bytes2nibbles(nibmask, mask, IPaddrlen);

		/* copy prefix of f, in reverse order, to start of net. */
		for (i = 0; i &lt; pfxnibs; i++)
			nibnet[i] = strtol(f[pfxnibs - 1 - i], nil, 16);
		/* zero nibbles of mask after prefix in net */
		memset(nibmask + pfxnibs, 0, V6maxrevdomdepth - pfxnibs);

		nibbles2bytes(net, nibnet, 2*IPaddrlen);
		nibbles2bytes(mask, nibmask, 2*IPaddrlen);

		/*
		 * go through all domain entries looking for RR's
		 * in this network and create ptrs.
		 */
		dnptr(net, mask, dom, Taaaa, V6maxrevdomdepth - pfxnibs, Ptrttl);
	}
}

/*
 *  create ptrs that are in our areas
 */
static void
createptrs(void)
{
	createv4ptrs();
	createv6ptrs();
}

/*
 * is this domain (or DOMAIN or Domain or dOMAIN)
 * internal to our organisation (behind our firewall)?
 * only inside straddling servers care, everybody else gets told `yes',
 * so they'll use mntpt for their queries.
 */
int
insideaddr(char *dom)
{
	int domlen, vallen, rv;
	Ndbtuple *t;

	if (!cfg.inside || !cfg.straddle || !cfg.serve)
		return 1;
	if (dom[0] == '\0' || strcmp(dom, ".") == 0)	/* dns root? */
		return 1;			/* hack for initialisation */

	lock(&amp;dblock);
	if (indoms == nil)
		loaddomsrvs();
	if (indoms == nil) {
		unlock(&amp;dblock);
		return 1;  /* no "inside-dom" sys, try inside nameservers */
	}

	rv = 0;
	domlen = strlen(dom);
	for (t = indoms; t != nil; t = t-&gt;entry) {
		if (strcmp(t-&gt;attr, "dom") != 0)
			continue;
		vallen = strlen(t-&gt;val);
		if (cistrcmp(dom, t-&gt;val) == 0 ||
		    domlen &gt; vallen &amp;&amp;
		     cistrcmp(dom + domlen - vallen, t-&gt;val) == 0 &amp;&amp;
		     dom[domlen - vallen - 1] == '.') {
			rv = 1;
			break;
		}
	}
	unlock(&amp;dblock);
	return rv;
}

int
insidens(uchar *ip)
{
	uchar ipa[IPaddrlen];
	Ndbtuple *t;

	for (t = innmsrvs; t != nil; t = t-&gt;entry)
		if (strcmp(t-&gt;attr, "ip") == 0) {
			parseip(ipa, t-&gt;val);
			if (memcmp(ipa, ip, sizeof ipa) == 0)
				return 1;
		}
	return 0;
}

uchar *
outsidens(int n)
{
	int i;
	Ndbtuple *t;
	static uchar ipa[IPaddrlen];

	i = 0;
	for (t = outnmsrvs; t != nil; t = t-&gt;entry)
		if (strcmp(t-&gt;attr, "ip") == 0 &amp;&amp; i++ == n) {
			parseip(ipa, t-&gt;val);
			return ipa;
		}
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

