<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include &lt;pool.h&gt;
#include &lt;ctype.h&gt;
#include "dns.h"

/*
 *  this comment used to say `our target is 4000 names cached, this should
 *  be larger on large servers'.  dns at Bell Labs starts off with
 *  about 1780 names.
 *
 *  aging corrupts the cache, so raise the trigger to avoid it.
 */
enum {
	Deftarget	= 1&lt;&lt;30,	/* effectively disable aging */
	Minage		= 1&lt;&lt;30,
	Defagefreq	= 1&lt;&lt;30,	/* age names this often (seconds) */

	/* these settings will trigger frequent aging */
//	Deftarget	= 4000,
//	Minage		=  5*60,
//	Defagefreq	= 15*60,	/* age names this often (seconds) */

	Restartmins	= 0,
//	Restartmins	= 600,
};

/*
 *  Hash table for domain names.  The hash is based only on the
 *  first element of the domain name.
 */
DN *ht[HTLEN];

static struct {
	Lock;
	ulong	names;		/* names allocated */
	ulong	oldest;		/* longest we'll leave a name around */
	int	active;
	int	mutex;
	ushort	id;		/* same size as in packet */
} dnvars;

/* names of RR types */
char *rrtname[] =
{
[Ta]		"ip",
[Tns]		"ns",
[Tmd]		"md",
[Tmf]		"mf",
[Tcname]	"cname",
[Tsoa]		"soa",
[Tmb]		"mb",
[Tmg]		"mg",
[Tmr]		"mr",
[Tnull]		"null",
[Twks]		"wks",
[Tptr]		"ptr",
[Thinfo]	"hinfo",
[Tminfo]	"minfo",
[Tmx]		"mx",
[Ttxt]		"txt",
[Trp]		"rp",
[Tafsdb]	"afsdb",
[Tx25]		"x.25",
[Tisdn]		"isdn",
[Trt]		"rt",
[Tnsap]		"nsap",
[Tnsapptr]	"nsap-ptr",
[Tsig]		"sig",
[Tkey]		"key",
[Tpx]		"px",
[Tgpos]		"gpos",
[Taaaa]		"ipv6",
[Tloc]		"loc",
[Tnxt]		"nxt",
[Teid]		"eid",
[Tnimloc]	"nimrod",
[Tsrv]		"srv",
[Tatma]		"atma",
[Tnaptr]	"naptr",
[Tkx]		"kx",
[Tcert]		"cert",
[Ta6]		"a6",
[Tdname]	"dname",
[Tsink]		"sink",
[Topt]		"opt",
[Tapl]		"apl",
[Tds]		"ds",
[Tsshfp]	"sshfp",
[Tipseckey]	"ipseckey",
[Trrsig]	"rrsig",
[Tnsec]		"nsec",
[Tdnskey]	"dnskey",
[Tspf]		"spf",
[Tuinfo]	"uinfo",
[Tuid]		"uid",
[Tgid]		"gid",
[Tunspec]	"unspec",
[Ttkey]		"tkey",
[Ttsig]		"tsig",
[Tixfr]		"ixfr",
[Taxfr]		"axfr",
[Tmailb]	"mailb",
[Tmaila]	"maila",
[Tall]		"all",
		0,
};

/* names of response codes */
char *rname[Rmask+1] =
{
[Rok]			"ok",
[Rformat]		"format error",
[Rserver]		"server failure",
[Rname]			"bad name",
[Runimplimented]	"unimplemented",
[Rrefused]		"we don't like you",
[Ryxdomain]		"name should not exist",
[Ryxrrset]		"rr set should not exist",
[Rnxrrset]		"rr set should exist",
[Rnotauth]		"not authorative",
[Rnotzone]		"not in zone",
[Rbadvers]		"bad opt version",
/* [Rbadsig]		"bad signature", */
[Rbadkey]		"bad key",
[Rbadtime]		"bad signature time",
[Rbadmode]		"bad mode",
[Rbadname]		"duplicate key name",
[Rbadalg]		"bad algorithm",
};
unsigned nrname = nelem(rname);

/* names of op codes */
char *opname[] =
{
[Oquery]	"query",
[Oinverse]	"inverse query (retired)",
[Ostatus]	"status",
[Oupdate]	"update",
};

ulong target = Deftarget;
ulong start;
Lock	dnlock;

static ulong agefreq = Defagefreq;

static int rrequiv(RR *r1, RR *r2);
static int sencodefmt(Fmt*);

static void
ding(void*, char *msg)
{
	if(strstr(msg, "alarm") != nil) {
		stats.alarms++;
		noted(NCONT);		/* resume with system call error */
	} else
		noted(NDFLT);		/* die */
}

void
dninit(void)
{
	fmtinstall('E', eipfmt);
	fmtinstall('I', eipfmt);
	fmtinstall('V', eipfmt);
	fmtinstall('R', rrfmt);
	fmtinstall('Q', rravfmt);
	fmtinstall('H', sencodefmt);

	dnvars.oldest = maxage;
	dnvars.names = 0;
	dnvars.id = truerand();	/* don't start with same id every time */

	notify(ding);
}

/*
 *  hash for a domain name
 */
static ulong
dnhash(char *name)
{
	ulong hash;
	uchar *val = (uchar*)name;

	for(hash = 0; *val; val++)
		hash = hash*13 + tolower(*val)-'a';
	return hash % HTLEN;
}

/*
 *  lookup a symbol.  if enter is not zero and the name is
 *  not found, create it.
 */
DN*
dnlookup(char *name, int class, int enter)
{
	DN **l;
	DN *dp;

	l = &amp;ht[dnhash(name)];
	lock(&amp;dnlock);
	for(dp = *l; dp; dp = dp-&gt;next) {
		assert(dp-&gt;magic == DNmagic);
		if(dp-&gt;class == class &amp;&amp; cistrcmp(dp-&gt;name, name) == 0){
			dp-&gt;referenced = now;
			unlock(&amp;dnlock);
			return dp;
		}
		l = &amp;dp-&gt;next;
	}

	if(!enter){
		unlock(&amp;dnlock);
		return 0;
	}
	dnvars.names++;
	dp = emalloc(sizeof(*dp));
	dp-&gt;magic = DNmagic;
	dp-&gt;name = estrdup(name);
	assert(dp-&gt;name != nil);
	dp-&gt;class = class;
	dp-&gt;rr = 0;
	dp-&gt;referenced = now;
	/* add new DN to tail of the hash list.  *l points to last next ptr. */
	dp-&gt;next = nil;
	*l = dp;
	unlock(&amp;dnlock);

	return dp;
}

static int
rrsame(RR *rr1, RR *rr2)
{
	return rr1 == rr2 || rr2 &amp;&amp; rrequiv(rr1, rr2) &amp;&amp;
		rr1-&gt;db == rr2-&gt;db &amp;&amp; rr1-&gt;auth == rr2-&gt;auth;
}

static int
rronlist(RR *rp, RR *lp)
{
	for(; lp; lp = lp-&gt;next)
		if (rrsame(lp, rp))
			return 1;
	return 0;
}

/*
 * dump the stats
 */
void
dnstats(char *file)
{
	int i, fd;

	fd = create(file, OWRITE, 0666);
	if(fd &lt; 0)
		return;

	qlock(&amp;stats);
	fprint(fd, "# system %s\n", sysname());
	fprint(fd, "# slave procs high-water mark\t%lud\n", stats.slavehiwat);
	fprint(fd, "# queries received by 9p\t%lud\n", stats.qrecvd9p);
	fprint(fd, "# queries received by udp\t%lud\n", stats.qrecvdudp);
	fprint(fd, "# queries answered from memory\t%lud\n", stats.answinmem);
	fprint(fd, "# queries sent by udp\t%lud\n", stats.qsent);
	for (i = 0; i &lt; nelem(stats.under10ths); i++)
		if (stats.under10ths[i] || i == nelem(stats.under10ths) - 1)
			fprint(fd, "# responses arriving within %.1f s.\t%lud\n",
				(double)(i+1)/10, stats.under10ths[i]);
	fprint(fd, "\n# queries sent &amp; timed-out\t%lud\n", stats.tmout);
	fprint(fd, "# cname queries timed-out\t%lud\n", stats.tmoutcname);
	fprint(fd, "# ipv6  queries timed-out\t%lud\n", stats.tmoutv6);
	fprint(fd, "\n# negative answers received\t%lud\n", stats.negans);
	fprint(fd, "# negative answers w Rserver set\t%lud\n", stats.negserver);
	fprint(fd, "# negative answers w bad delegation\t%lud\n",
		stats.negbaddeleg);
	fprint(fd, "# negative answers w bad delegation &amp; no answers\t%lud\n",
		stats.negbdnoans);
	fprint(fd, "# negative answers w no Rname set\t%lud\n", stats.negnorname);
	fprint(fd, "# negative answers cached\t%lud\n", stats.negcached);
	qunlock(&amp;stats);

	lock(&amp;dnlock);
	fprint(fd, "\n# domain names %lud target %lud\n", dnvars.names, target);
	unlock(&amp;dnlock);
	close(fd);
}

/*
 *  dump the cache
 */
void
dndump(char *file)
{
	int i, fd;
	DN *dp;
	RR *rp;

	fd = create(file, OWRITE, 0666);
	if(fd &lt; 0)
		return;

	lock(&amp;dnlock);
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next){
			fprint(fd, "%s\n", dp-&gt;name);
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next) {
				fprint(fd, "\t%R %c%c %lud/%lud\n",
					rp, rp-&gt;auth? 'A': 'U',
					rp-&gt;db? 'D': 'N', rp-&gt;expire, rp-&gt;ttl);
				if (rronlist(rp, rp-&gt;next))
					fprint(fd, "*** duplicate:\n");
			}
		}
	unlock(&amp;dnlock);
	close(fd);
}

/*
 *  purge all records
 */
void
dnpurge(void)
{
	DN *dp;
	RR *rp, *srp;
	int i;

	lock(&amp;dnlock);

	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next){
			srp = rp = dp-&gt;rr;
			dp-&gt;rr = nil;
			for(; rp != nil; rp = rp-&gt;next)
				rp-&gt;cached = 0;
			rrfreelist(srp);
		}

	unlock(&amp;dnlock);
}

/*
 *  delete head of *l and free the old head.
 *  call with dnlock held.
 */
static void
rrdelhead(RR **l)
{
	RR *rp;

	if (canlock(&amp;dnlock))
		abort();	/* rrdelhead called with dnlock not held */
	rp = *l;
	if(rp == nil)
		return;
	*l = rp-&gt;next;		/* unlink head */
	rp-&gt;cached = 0;		/* avoid blowing an assertion in rrfree */
	rrfree(rp);
}

/*
 *  check the age of resource records, free any that have timed out.
 *  call with dnlock held.
 */
void
dnage(DN *dp)
{
	RR **l;
	RR *rp, *next;
	ulong diff;

	if (canlock(&amp;dnlock))
		abort();	/* dnage called with dnlock not held */
	diff = now - dp-&gt;referenced;
	if(diff &lt; Reserved || dp-&gt;keep)
		return;

	l = &amp;dp-&gt;rr;
	for(rp = dp-&gt;rr; rp; rp = next){
		assert(rp-&gt;magic == RRmagic);
		assert(rp-&gt;cached);
		next = rp-&gt;next;
		if(!rp-&gt;db &amp;&amp; (rp-&gt;expire &lt; now || diff &gt; dnvars.oldest))
			rrdelhead(l); /* rp == *l before; *l == rp-&gt;next after */
		else
			l = &amp;rp-&gt;next;
	}
}

#define MARK(dp)	{ if (dp) (dp)-&gt;keep = 1; }

/* mark a domain name and those in its RRs as never to be aged */
void
dnagenever(DN *dp, int dolock)
{
	RR *rp;

	if (dolock)
		lock(&amp;dnlock);

	/* mark all referenced domain names */
	MARK(dp);
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
		MARK(rp-&gt;owner);
		if(rp-&gt;negative){
			MARK(rp-&gt;negsoaowner);
			continue;
		}
		switch(rp-&gt;type){
		case Thinfo:
			MARK(rp-&gt;cpu);
			MARK(rp-&gt;os);
			break;
		case Ttxt:
			break;
		case Tcname:
		case Tmb:
		case Tmd:
		case Tmf:
		case Tns:
		case Tmx:
		case Tsrv:
			MARK(rp-&gt;host);
			break;
		case Tmg:
		case Tmr:
			MARK(rp-&gt;mb);
			break;
		case Tminfo:
			MARK(rp-&gt;rmb);
			MARK(rp-&gt;mb);
			break;
		case Trp:
			MARK(rp-&gt;rmb);
			MARK(rp-&gt;rp);
			break;
		case Ta:
		case Taaaa:
			MARK(rp-&gt;ip);
			break;
		case Tptr:
			MARK(rp-&gt;ptr);
			break;
		case Tsoa:
			MARK(rp-&gt;host);
			MARK(rp-&gt;rmb);
			break;
		}
	}

	if (dolock)
		unlock(&amp;dnlock);
}

/* mark all current domain names as never to be aged */
void
dnageallnever(void)
{
	int i;
	DN *dp;

	lock(&amp;dnlock);

	/* mark all referenced domain names */
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next)
			dnagenever(dp, 0);

	unlock(&amp;dnlock);

	dnslog("%ld initial domain names; target is %ld", dnvars.names, target);
	if(dnvars.names &gt;= target)
		dnslog("more initial domain names (%ld) than target (%ld)",
			dnvars.names, target);
}

#define REF(dp)	{ if (dp) (dp)-&gt;refs++; }

/*
 *  periodicly sweep for old records and remove unreferenced domain names
 *
 *  only called when all other threads are locked out
 */
void
dnageall(int doit)
{
	DN *dp, **l;
	int i;
	RR *rp;
	static ulong nextage;

	if(dnvars.names &lt; target || (now &lt; nextage &amp;&amp; !doit)){
		dnvars.oldest = maxage;
		return;
	}

	if(dnvars.names &gt;= target) {
		dnslog("more names (%lud) than target (%lud)", dnvars.names,
			target);
		dnvars.oldest /= 2;
		if (dnvars.oldest &lt; Minage)
			dnvars.oldest = Minage;		/* don't be silly */
	}
	if (agefreq &gt; dnvars.oldest / 2)
		nextage = now + dnvars.oldest / 2;
	else
		nextage = now + agefreq;

	lock(&amp;dnlock);

	/* time out all old entries (and set refs to 0) */
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next){
			dp-&gt;refs = 0;
			dnage(dp);
		}

	/* mark all referenced domain names */
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next)
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
				REF(rp-&gt;owner);
				if(rp-&gt;negative){
					REF(rp-&gt;negsoaowner);
					continue;
				}
				switch(rp-&gt;type){
				case Thinfo:
					REF(rp-&gt;cpu);
					REF(rp-&gt;os);
					break;
				case Ttxt:
					break;
				case Tcname:
				case Tmb:
				case Tmd:
				case Tmf:
				case Tns:
				case Tmx:
				case Tsrv:
					REF(rp-&gt;host);
					break;
				case Tmg:
				case Tmr:
					REF(rp-&gt;mb);
					break;
				case Tminfo:
					REF(rp-&gt;rmb);
					REF(rp-&gt;mb);
					break;
				case Trp:
					REF(rp-&gt;rmb);
					REF(rp-&gt;rp);
					break;
				case Ta:
				case Taaaa:
					REF(rp-&gt;ip);
					break;
				case Tptr:
					REF(rp-&gt;ptr);
					break;
				case Tsoa:
					REF(rp-&gt;host);
					REF(rp-&gt;rmb);
					break;
				}
			}

	/* sweep and remove unreferenced domain names */
	for(i = 0; i &lt; HTLEN; i++){
		l = &amp;ht[i];
		for(dp = *l; dp; dp = *l){
			if(dp-&gt;rr == 0 &amp;&amp; dp-&gt;refs == 0 &amp;&amp; !dp-&gt;keep){
				assert(dp-&gt;magic == DNmagic);
				*l = dp-&gt;next;

				if(dp-&gt;name)
					free(dp-&gt;name);
				dp-&gt;magic = ~dp-&gt;magic;
				dnvars.names--;
				memset(dp, 0, sizeof *dp); /* cause trouble */
				free(dp);

				continue;
			}
			l = &amp;dp-&gt;next;
		}
	}

	unlock(&amp;dnlock);
}

/*
 *  timeout all database records (used when rereading db)
 */
void
dnagedb(void)
{
	DN *dp;
	int i;
	RR *rp;

	lock(&amp;dnlock);

	/* time out all database entries */
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next) {
			dp-&gt;keep = 0;
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next)
				if(rp-&gt;db)
					rp-&gt;expire = 0;
		}

	unlock(&amp;dnlock);
}

/*
 *  mark all local db records about my area as authoritative,
 *  time out any others
 */
void
dnauthdb(void)
{
	int i;
	ulong minttl;
	Area *area;
	DN *dp;
	RR *rp;

	lock(&amp;dnlock);

	/* time out all database entries */
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next){
			area = inmyarea(dp-&gt;name);
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next)
				if(rp-&gt;db){
					if(area){
						minttl = area-&gt;soarr-&gt;soa-&gt;minttl;
						if(rp-&gt;ttl &lt; minttl)
							rp-&gt;ttl = minttl;
						rp-&gt;auth = 1;
					}
					if(rp-&gt;expire == 0){
						rp-&gt;db = 0;
						dp-&gt;referenced = now-Reserved-1;
					}
				}
		}

	unlock(&amp;dnlock);
}

/*
 *  keep track of other processes to know if we can
 *  garbage collect.  block while garbage collecting.
 */
int
getactivity(Request *req, int recursive)
{
	int rv;

	if(traceactivity)
		dnslog("get: %d active by pid %d from %p",
			dnvars.active, getpid(), getcallerpc(&amp;req));
	lock(&amp;dnvars);
	/*
	 * can't block here if we're already holding one
	 * of the dnvars.active (recursive).  will deadlock.
	 */
	while(!recursive &amp;&amp; dnvars.mutex){
		unlock(&amp;dnvars);
		sleep(100);			/* tune; was 200 */
		lock(&amp;dnvars);
	}
	rv = ++dnvars.active;
	now = time(nil);
	nowns = nsec();
	req-&gt;id = ++dnvars.id;
	unlock(&amp;dnvars);

	return rv;
}
void
putactivity(int recursive)
{
	static ulong lastclean;

	if(traceactivity)
		dnslog("put: %d active by pid %d",
			dnvars.active, getpid());
	lock(&amp;dnvars);
	dnvars.active--;
	assert(dnvars.active &gt;= 0); /* "dnvars.active %d", dnvars.active */

	/*
	 *  clean out old entries and check for new db periodicly
	 *  can't block here if being called to let go a "recursive" lock
	 *  or we'll deadlock waiting for ourselves to give up the dnvars.active.
	 */
	if (recursive || dnvars.mutex ||
	    (needrefresh == 0 &amp;&amp; dnvars.active &gt; 0)){
		unlock(&amp;dnvars);
		return;
	}

	/* wait till we're alone */
	dnvars.mutex = 1;
	while(dnvars.active &gt; 0){
		unlock(&amp;dnvars);
		sleep(100);		/* tune; was 100 */
		lock(&amp;dnvars);
	}
	unlock(&amp;dnvars);

	db2cache(needrefresh);

	/* if we've been running for long enough, restart */
	if(start == 0)
		start = time(nil);
	if(Restartmins &gt; 0 &amp;&amp; time(nil) - start &gt; Restartmins*60){
		dnslog("killing all dns procs for timed restart");
		postnote(PNGROUP, getpid(), "die");
		dnvars.mutex = 0;
		exits("restart");
	}

	dnageall(0);

	/* let others back in */
	lastclean = now;
	needrefresh = 0;
	dnvars.mutex = 0;
}

int
rrlistlen(RR *rp)
{
	int n;

	n = 0;
	for(; rp; rp = rp-&gt;next)
		++n;
	return n;
}

/*
 *  Attach a single resource record to a domain name (new-&gt;owner).
 *	- Avoid duplicates with already present RR's
 *	- Chain all RR's of the same type adjacent to one another
 *	- chain authoritative RR's ahead of non-authoritative ones
 *	- remove any expired RR's
 *  If new is a stale duplicate, rrfree it.
 *  Must be called with dnlock held.
 */
static void
rrattach1(RR *new, int auth)
{
	RR **l;
	RR *rp;
	DN *dp;

	assert(new-&gt;magic == RRmagic);
	assert(!new-&gt;cached);

//	dnslog("rrattach1: %s", new-&gt;owner-&gt;name);
	if(!new-&gt;db) {
		/*
		 * try not to let responses expire before we
		 * can use them to complete this query, by extending
		 * past (or nearly past) expiration time.
		 */
		new-&gt;expire = new-&gt;ttl &gt; now + Min? new-&gt;ttl: now + 10*Min;
	} else
		new-&gt;expire = now + Year;
	dp = new-&gt;owner;
	assert(dp-&gt;magic == DNmagic);
	new-&gt;auth |= auth;
	new-&gt;next = 0;

	/*
	 *  find first rr of the right type
	 */
	l = &amp;dp-&gt;rr;
	for(rp = *l; rp; rp = *l){
		assert(rp-&gt;magic == RRmagic);
		assert(rp-&gt;cached);
		if(rp-&gt;type == new-&gt;type)
			break;
		l = &amp;rp-&gt;next;
	}

	/*
	 *  negative entries replace positive entries
	 *  positive entries replace negative entries
	 *  newer entries replace older entries with the same fields
	 *
	 *  look farther ahead than just the next entry when looking
	 *  for duplicates; RRs of a given type can have different rdata
	 *  fields (e.g. multiple NS servers).
	 */
	while ((rp = *l) != nil){
		assert(rp-&gt;magic == RRmagic);
		assert(rp-&gt;cached);
		if(rp-&gt;type != new-&gt;type)
			break;

		if(rp-&gt;db == new-&gt;db &amp;&amp; rp-&gt;auth == new-&gt;auth){
			/* negative drives out positive and vice versa */
			if(rp-&gt;negative != new-&gt;negative) {
				/* rp == *l before; *l == rp-&gt;next after */
				rrdelhead(l);
				continue;	
			}
			/* all things equal, pick the newer one */
			else if(rp-&gt;arg0 == new-&gt;arg0 &amp;&amp; rp-&gt;arg1 == new-&gt;arg1){
				/* new drives out old */
				if (new-&gt;ttl &lt;= rp-&gt;ttl &amp;&amp;
				    new-&gt;expire &lt;= rp-&gt;expire) {
					rrfree(new);
					return;
				}
				/* rp == *l before; *l == rp-&gt;next after */
				rrdelhead(l);
				continue;
			}
			/*
			 *  Hack for pointer records.  This makes sure
			 *  the ordering in the list reflects the ordering
			 *  received or read from the database
			 */
			else if(rp-&gt;type == Tptr &amp;&amp;
			    !rp-&gt;negative &amp;&amp; !new-&gt;negative &amp;&amp;
			    rp-&gt;ptr-&gt;ordinal &gt; new-&gt;ptr-&gt;ordinal)
				break;
		}
		l = &amp;rp-&gt;next;
	}

	if (rronlist(new, rp)) {
		/* should not happen; duplicates were processed above */
		dnslog("adding duplicate %R to list of %R; aborting", new, rp);
		abort();
	}
	/*
	 *  add to chain
	 */
	new-&gt;cached = 1;
	new-&gt;next = rp;
	*l = new;
}

/*
 *  Attach a list of resource records to a domain name.
 *  May rrfree any stale duplicate RRs; dismembers the list.
 *  Upon return, every RR in the list will have been rrfree-d
 *  or attached to its domain name.
 *  See rrattach1 for properties preserved.
 */
void
rrattach(RR *rp, int auth)
{
	RR *next, *tp;
	DN *dp;

	lock(&amp;dnlock);
	for(; rp; rp = next){
		next = rp-&gt;next;
		rp-&gt;next = nil;
		dp = rp-&gt;owner;

//		dnslog("rrattach: %s", rp-&gt;owner-&gt;name);
		/* avoid any outside spoofing; leave keepers alone */
		if(cfg.cachedb &amp;&amp; !rp-&gt;db &amp;&amp; inmyarea(rp-&gt;owner-&gt;name)
//		    || dp-&gt;keep			/* TODO: make this work */
		    )
			rrfree(rp);
		else {
			/* ameliorate the memory leak (someday delete this) */
			if (0 &amp;&amp; rrlistlen(dp-&gt;rr) &gt; 50 &amp;&amp; !dp-&gt;keep) {
				dnslog("rrattach(%s): rr list too long; "
					"freeing it", dp-&gt;name);
				tp = dp-&gt;rr;
				dp-&gt;rr = nil;
				rrfreelist(tp);
			} else
				USED(dp);
			rrattach1(rp, auth);
		}
	}
	unlock(&amp;dnlock);
}

/* should be called with dnlock held */
RR**
rrcopy(RR *rp, RR **last)
{
	Cert *cert;
	Key *key;
	Null *null;
	RR *nrp;
	SOA *soa;
	Sig *sig;
	Txt *t, *nt, **l;

	if (canlock(&amp;dnlock))
		abort();	/* rrcopy called with dnlock not held */
	nrp = rralloc(rp-&gt;type);
	setmalloctag(nrp, getcallerpc(&amp;rp));
	switch(rp-&gt;type){
	case Ttxt:
		*nrp = *rp;
		l = &amp;nrp-&gt;txt;
		*l = nil;
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next){
			nt = emalloc(sizeof(*nt));
			nt-&gt;p = estrdup(t-&gt;p);
			nt-&gt;next = nil;
			*l = nt;
			l = &amp;nt-&gt;next;
		}
		break;
	case Tsoa:
		soa = nrp-&gt;soa;
		*nrp = *rp;
		nrp-&gt;soa = soa;
		*nrp-&gt;soa = *rp-&gt;soa;
		nrp-&gt;soa-&gt;slaves = copyserverlist(rp-&gt;soa-&gt;slaves);
		break;
	case Tsrv:
		*nrp = *rp;
		nrp-&gt;srv = emalloc(sizeof *nrp-&gt;srv);
		*nrp-&gt;srv = *rp-&gt;srv;
		break;
	case Tkey:
		key = nrp-&gt;key;
		*nrp = *rp;
		nrp-&gt;key = key;
		*key = *rp-&gt;key;
		key-&gt;data = emalloc(key-&gt;dlen);
		memmove(key-&gt;data, rp-&gt;key-&gt;data, rp-&gt;key-&gt;dlen);
		break;
	case Tsig:
		sig = nrp-&gt;sig;
		*nrp = *rp;
		nrp-&gt;sig = sig;
		*sig = *rp-&gt;sig;
		sig-&gt;data = emalloc(sig-&gt;dlen);
		memmove(sig-&gt;data, rp-&gt;sig-&gt;data, rp-&gt;sig-&gt;dlen);
		break;
	case Tcert:
		cert = nrp-&gt;cert;
		*nrp = *rp;
		nrp-&gt;cert = cert;
		*cert = *rp-&gt;cert;
		cert-&gt;data = emalloc(cert-&gt;dlen);
		memmove(cert-&gt;data, rp-&gt;cert-&gt;data, rp-&gt;cert-&gt;dlen);
		break;
	case Tnull:
		null = nrp-&gt;null;
		*nrp = *rp;
		nrp-&gt;null = null;
		*null = *rp-&gt;null;
		null-&gt;data = emalloc(null-&gt;dlen);
		memmove(null-&gt;data, rp-&gt;null-&gt;data, rp-&gt;null-&gt;dlen);
		break;
	default:
		*nrp = *rp;
		break;
	}
	nrp-&gt;cached = 0;
	nrp-&gt;next = 0;
	*last = nrp;
	return &amp;nrp-&gt;next;
}

/*
 *  lookup a resource record of a particular type and
 *  class attached to a domain name.  Return copies.
 *
 *  Priority ordering is:
 *	db authoritative
 *	not timed out network authoritative
 *	not timed out network unauthoritative
 *	unauthoritative db
 *
 *  if flag NOneg is set, don't return negative cached entries.
 *  return nothing instead.
 */
RR*
rrlookup(DN *dp, int type, int flag)
{
	RR *rp, *first, **last;

	assert(dp-&gt;magic == DNmagic);

	first = 0;
	last = &amp;first;
	lock(&amp;dnlock);

	/* try for an authoritative db entry */
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
		assert(rp-&gt;magic == RRmagic);
		assert(rp-&gt;cached);
		if(rp-&gt;db)
		if(rp-&gt;auth)
		if(tsame(type, rp-&gt;type)) {
			last = rrcopy(rp, last);
			// setmalloctag(*last, getcallerpc(&amp;dp));
		}
	}
	if(first)
		goto out;

	/* try for a living authoritative network entry */
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
		if(!rp-&gt;db)
		if(rp-&gt;auth)
		if(rp-&gt;ttl + 60 &gt; now)
		if(tsame(type, rp-&gt;type)){
			if(flag == NOneg &amp;&amp; rp-&gt;negative)
				goto out;
			last = rrcopy(rp, last);
		}
	}
	if(first)
		goto out;

	/* try for a living unauthoritative network entry */
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
		if(!rp-&gt;db)
		if(rp-&gt;ttl + 60 &gt; now)
		if(tsame(type, rp-&gt;type)){
			if(flag == NOneg &amp;&amp; rp-&gt;negative)
				goto out;
			last = rrcopy(rp, last);
		}
	}
	if(first)
		goto out;

	/* try for an unauthoritative db entry */
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
		if(rp-&gt;db)
		if(tsame(type, rp-&gt;type))
			last = rrcopy(rp, last);
	}
	if(first)
		goto out;

	/* otherwise, settle for anything we got (except for negative caches) */
	for(rp = dp-&gt;rr; rp; rp = rp-&gt;next)
		if(tsame(type, rp-&gt;type)){
			if(rp-&gt;negative)
				goto out;
			last = rrcopy(rp, last);
		}

out:
	unique(first);
	unlock(&amp;dnlock);
//	dnslog("rrlookup(%s) -&gt; %#p\t# in-core only", dp-&gt;name, first);
//	if (first)
//		setmalloctag(first, getcallerpc(&amp;dp));
	return first;
}

/*
 *  convert an ascii RR type name to its integer representation
 */
int
rrtype(char *atype)
{
	int i;

	for(i = 0; i &lt;= Tall; i++)
		if(rrtname[i] &amp;&amp; strcmp(rrtname[i], atype) == 0)
			return i;

	/* make any a synonym for all */
	if(strcmp(atype, "any") == 0)
		return Tall;
	else if(isascii(atype[0]) &amp;&amp; isdigit(atype[0]))
		return atoi(atype);
	else
		return -1;
}

/*
 *  return 0 if not a supported rr type
 */
int
rrsupported(int type)
{
	if(type &lt; 0 || type &gt;Tall)
		return 0;
	return rrtname[type] != nil;
}

/*
 *  compare 2 types
 */
int
tsame(int t1, int t2)
{
	return t1 == t2 || t1 == Tall;
}

/*
 *  Add resource records to a list, duplicate them if they are cached
 *  RR's since these are shared.  should be called with dnlock held
 *  to avoid racing down the start chain.
 */
RR*
rrcat(RR **start, RR *rp)
{
	RR *olp, *nlp;
	RR **last;

	if (canlock(&amp;dnlock))
		abort();	/* rrcat called with dnlock not held */
	/* check for duplicates */
	for (olp = *start; 0 &amp;&amp; olp; olp = olp-&gt;next)
		for (nlp = rp; nlp; nlp = nlp-&gt;next)
			if (rrsame(nlp, olp))
				dnslog("rrcat: duplicate RR: %R", nlp);
	USED(olp);

	last = start;
	while(*last != nil)
		last = &amp;(*last)-&gt;next;

	*last = rp;
	return *start;
}

/*
 *  remove negative cache rr's from an rr list
 */
RR*
rrremneg(RR **l)
{
	RR **nl, *rp;
	RR *first;

	if (canlock(&amp;dnlock))
		abort();	/* rrremneg called with dnlock not held */
	first = nil;
	nl = &amp;first;
	while(*l != nil){
		rp = *l;
		if(rp-&gt;negative){
			*l = rp-&gt;next;
			*nl = rp;
			nl = &amp;rp-&gt;next;
			*nl = nil;
		} else
			l = &amp;rp-&gt;next;
	}

	return first;
}

/*
 *  remove rr's of a particular type from an rr list
 */
RR*
rrremtype(RR **l, int type)
{
	RR *first, *rp;
	RR **nl;

	first = nil;
	nl = &amp;first;
	while(*l != nil){
		rp = *l;
		if(rp-&gt;type == type){
			*l = rp-&gt;next;
			*nl = rp;
			nl = &amp;rp-&gt;next;
			*nl = nil;
		} else
			l = &amp;(*l)-&gt;next;
	}

	return first;
}

static char *
dnname(DN *dn)
{
	return dn? dn-&gt;name: "&lt;null&gt;";
}

/*
 *  print conversion for rr records
 */
int
rrfmt(Fmt *f)
{
	int rv;
	char *strp;
	char buf[Domlen];
	Fmt fstr;
	RR *rp;
	Server *s;
	SOA *soa;
	Srv *srv;
	Txt *t;

	fmtstrinit(&amp;fstr);

	rp = va_arg(f-&gt;args, RR*);
	if(rp == nil){
		fmtprint(&amp;fstr, "&lt;null&gt;");
		goto out;
	}

	fmtprint(&amp;fstr, "%s %s", dnname(rp-&gt;owner),
		rrname(rp-&gt;type, buf, sizeof buf));

	if(rp-&gt;negative){
		fmtprint(&amp;fstr, "\tnegative - rcode %d", rp-&gt;negrcode);
		goto out;
	}

	switch(rp-&gt;type){
	case Thinfo:
		fmtprint(&amp;fstr, "\t%s %s", dnname(rp-&gt;cpu), dnname(rp-&gt;os));
		break;
	case Tcname:
	case Tmb:
	case Tmd:
	case Tmf:
	case Tns:
		fmtprint(&amp;fstr, "\t%s", dnname(rp-&gt;host));
		break;
	case Tmg:
	case Tmr:
		fmtprint(&amp;fstr, "\t%s", dnname(rp-&gt;mb));
		break;
	case Tminfo:
		fmtprint(&amp;fstr, "\t%s %s", dnname(rp-&gt;mb), dnname(rp-&gt;rmb));
		break;
	case Tmx:
		fmtprint(&amp;fstr, "\t%lud %s", rp-&gt;pref, dnname(rp-&gt;host));
		break;
	case Ta:
	case Taaaa:
		fmtprint(&amp;fstr, "\t%s", dnname(rp-&gt;ip));
		break;
	case Tptr:
//		fmtprint(&amp;fstr, "\t%s(%lud)", dnname(rp-&gt;ptr),
//			rp-&gt;ptr? rp-&gt;ptr-&gt;ordinal: "&lt;null&gt;");
		fmtprint(&amp;fstr, "\t%s", dnname(rp-&gt;ptr));
		break;
	case Tsoa:
		soa = rp-&gt;soa;
		fmtprint(&amp;fstr, "\t%s %s %lud %lud %lud %lud %lud",
			dnname(rp-&gt;host), dnname(rp-&gt;rmb),
			(soa? soa-&gt;serial: 0),
			(soa? soa-&gt;refresh: 0), (soa? soa-&gt;retry: 0),
			(soa? soa-&gt;expire: 0), (soa? soa-&gt;minttl: 0));
		if (soa)
			for(s = soa-&gt;slaves; s != nil; s = s-&gt;next)
				fmtprint(&amp;fstr, " %s", s-&gt;name);
		break;
	case Tsrv:
		srv = rp-&gt;srv;
		fmtprint(&amp;fstr, "\t%ud %ud %ud %s",
			(srv? srv-&gt;pri: 0), (srv? srv-&gt;weight: 0),
			rp-&gt;port, dnname(rp-&gt;host));
		break;
	case Tnull:
		if (rp-&gt;null == nil)
			fmtprint(&amp;fstr, "\t&lt;null&gt;");
		else
			fmtprint(&amp;fstr, "\t%.*H", rp-&gt;null-&gt;dlen,
				rp-&gt;null-&gt;data);
		break;
	case Ttxt:
		fmtprint(&amp;fstr, "\t");
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next)
			fmtprint(&amp;fstr, "%s", t-&gt;p);
		break;
	case Trp:
		fmtprint(&amp;fstr, "\t%s %s", dnname(rp-&gt;rmb), dnname(rp-&gt;rp));
		break;
	case Tkey:
		if (rp-&gt;key == nil)
			fmtprint(&amp;fstr, "\t&lt;null&gt; &lt;null&gt; &lt;null&gt;");
		else
			fmtprint(&amp;fstr, "\t%d %d %d", rp-&gt;key-&gt;flags,
				rp-&gt;key-&gt;proto, rp-&gt;key-&gt;alg);
		break;
	case Tsig:
		if (rp-&gt;sig == nil)
			fmtprint(&amp;fstr,
		   "\t&lt;null&gt; &lt;null&gt; &lt;null&gt; &lt;null&gt; &lt;null&gt; &lt;null&gt; &lt;null&gt; &lt;null&gt;");
		else
			fmtprint(&amp;fstr, "\t%d %d %d %lud %lud %lud %d %s",
				rp-&gt;sig-&gt;type, rp-&gt;sig-&gt;alg, rp-&gt;sig-&gt;labels,
				rp-&gt;sig-&gt;ttl, rp-&gt;sig-&gt;exp, rp-&gt;sig-&gt;incep,
				rp-&gt;sig-&gt;tag, dnname(rp-&gt;sig-&gt;signer));
		break;
	case Tcert:
		if (rp-&gt;cert == nil)
			fmtprint(&amp;fstr, "\t&lt;null&gt; &lt;null&gt; &lt;null&gt;");
		else
			fmtprint(&amp;fstr, "\t%d %d %d",
				rp-&gt;cert-&gt;type, rp-&gt;cert-&gt;tag, rp-&gt;cert-&gt;alg);
		break;
	}
out:
	strp = fmtstrflush(&amp;fstr);
	rv = fmtstrcpy(f, strp);
	free(strp);
	return rv;
}

/*
 *  print conversion for rr records in attribute value form
 */
int
rravfmt(Fmt *f)
{
	int rv, quote;
	char *strp;
	Fmt fstr;
	RR *rp;
	Server *s;
	SOA *soa;
	Srv *srv;
	Txt *t;

	fmtstrinit(&amp;fstr);

	rp = va_arg(f-&gt;args, RR*);
	if(rp == nil){
		fmtprint(&amp;fstr, "&lt;null&gt;");
		goto out;
	}

	if(rp-&gt;type == Tptr)
		fmtprint(&amp;fstr, "ptr=%s", dnname(rp-&gt;owner));
	else
		fmtprint(&amp;fstr, "dom=%s", dnname(rp-&gt;owner));

	switch(rp-&gt;type){
	case Thinfo:
		fmtprint(&amp;fstr, " cpu=%s os=%s",
			dnname(rp-&gt;cpu), dnname(rp-&gt;os));
		break;
	case Tcname:
		fmtprint(&amp;fstr, " cname=%s", dnname(rp-&gt;host));
		break;
	case Tmb:
	case Tmd:
	case Tmf:
		fmtprint(&amp;fstr, " mbox=%s", dnname(rp-&gt;host));
		break;
	case Tns:
		fmtprint(&amp;fstr,  " ns=%s", dnname(rp-&gt;host));
		break;
	case Tmg:
	case Tmr:
		fmtprint(&amp;fstr, " mbox=%s", dnname(rp-&gt;mb));
		break;
	case Tminfo:
		fmtprint(&amp;fstr, " mbox=%s mbox=%s",
			dnname(rp-&gt;mb), dnname(rp-&gt;rmb));
		break;
	case Tmx:
		fmtprint(&amp;fstr, " pref=%lud mx=%s", rp-&gt;pref, dnname(rp-&gt;host));
		break;
	case Ta:
	case Taaaa:
		fmtprint(&amp;fstr, " ip=%s", dnname(rp-&gt;ip));
		break;
	case Tptr:
		fmtprint(&amp;fstr, " dom=%s", dnname(rp-&gt;ptr));
		break;
	case Tsoa:
		soa = rp-&gt;soa;
		fmtprint(&amp;fstr,
" ns=%s mbox=%s serial=%lud refresh=%lud retry=%lud expire=%lud ttl=%lud",
			dnname(rp-&gt;host), dnname(rp-&gt;rmb),
			(soa? soa-&gt;serial: 0),
			(soa? soa-&gt;refresh: 0), (soa? soa-&gt;retry: 0),
			(soa? soa-&gt;expire: 0), (soa? soa-&gt;minttl: 0));
		for(s = soa-&gt;slaves; s != nil; s = s-&gt;next)
			fmtprint(&amp;fstr, " dnsslave=%s", s-&gt;name);
		break;
	case Tsrv:
		srv = rp-&gt;srv;
		fmtprint(&amp;fstr, " pri=%ud weight=%ud port=%ud target=%s",
			(srv? srv-&gt;pri: 0), (srv? srv-&gt;weight: 0),
			rp-&gt;port, dnname(rp-&gt;host));
		break;
	case Tnull:
		if (rp-&gt;null == nil)
			fmtprint(&amp;fstr, " null=&lt;null&gt;");
		else
			fmtprint(&amp;fstr, " null=%.*H", rp-&gt;null-&gt;dlen,
				rp-&gt;null-&gt;data);
		break;
	case Ttxt:
		fmtprint(&amp;fstr, " txt=");
		quote = 0;
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next)
			if(strchr(t-&gt;p, ' '))
				quote = 1;
		if(quote)
			fmtprint(&amp;fstr, "\"");
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next)
			fmtprint(&amp;fstr, "%s", t-&gt;p);
		if(quote)
			fmtprint(&amp;fstr, "\"");
		break;
	case Trp:
		fmtprint(&amp;fstr, " rp=%s txt=%s",
			dnname(rp-&gt;rmb), dnname(rp-&gt;rp));
		break;
	case Tkey:
		if (rp-&gt;key == nil)
			fmtprint(&amp;fstr, " flags=&lt;null&gt; proto=&lt;null&gt; alg=&lt;null&gt;");
		else
			fmtprint(&amp;fstr, " flags=%d proto=%d alg=%d",
				rp-&gt;key-&gt;flags, rp-&gt;key-&gt;proto, rp-&gt;key-&gt;alg);
		break;
	case Tsig:
		if (rp-&gt;sig == nil)
			fmtprint(&amp;fstr,
" type=&lt;null&gt; alg=&lt;null&gt; labels=&lt;null&gt; ttl=&lt;null&gt; exp=&lt;null&gt; incep=&lt;null&gt; tag=&lt;null&gt; signer=&lt;null&gt;");
		else
			fmtprint(&amp;fstr,
" type=%d alg=%d labels=%d ttl=%lud exp=%lud incep=%lud tag=%d signer=%s",
				rp-&gt;sig-&gt;type, rp-&gt;sig-&gt;alg, rp-&gt;sig-&gt;labels,
				rp-&gt;sig-&gt;ttl, rp-&gt;sig-&gt;exp, rp-&gt;sig-&gt;incep,
				rp-&gt;sig-&gt;tag, dnname(rp-&gt;sig-&gt;signer));
		break;
	case Tcert:
		if (rp-&gt;cert == nil)
			fmtprint(&amp;fstr, " type=&lt;null&gt; tag=&lt;null&gt; alg=&lt;null&gt;");
		else
			fmtprint(&amp;fstr, " type=%d tag=%d alg=%d",
				rp-&gt;cert-&gt;type, rp-&gt;cert-&gt;tag, rp-&gt;cert-&gt;alg);
		break;
	}
out:
	strp = fmtstrflush(&amp;fstr);
	rv = fmtstrcpy(f, strp);
	free(strp);
	return rv;
}

void
warning(char *fmt, ...)
{
	char dnserr[256];
	va_list arg;

	va_start(arg, fmt);
	vseprint(dnserr, dnserr+sizeof(dnserr), fmt, arg);
	va_end(arg);
	syslog(1, logfile, dnserr);		/* on console too */
}

void
dnslog(char *fmt, ...)
{
	char dnserr[256];
	va_list arg;

	va_start(arg, fmt);
	vseprint(dnserr, dnserr+sizeof(dnserr), fmt, arg);
	va_end(arg);
	syslog(0, logfile, dnserr);
}

/*
 * based on libthread's threadsetname, but drags in less library code.
 * actually just sets the arguments displayed.
 */
void
procsetname(char *fmt, ...)
{
	int fd;
	char *cmdname;
	char buf[128];
	va_list arg;

	va_start(arg, fmt);
	cmdname = vsmprint(fmt, arg);
	va_end(arg);
	if (cmdname == nil)
		return;
	snprint(buf, sizeof buf, "#p/%d/args", getpid());
	if((fd = open(buf, OWRITE)) &gt;= 0){
		write(fd, cmdname, strlen(cmdname)+1);
		close(fd);
	}
	free(cmdname);
}

/*
 *  create a slave process to handle a request to avoid one request blocking
 *  another
 */
void
slave(Request *req)
{
	int ppid, procs;

	if(req-&gt;isslave)
		return;		/* we're already a slave process */

	/*
	 * These calls to putactivity cannot block.
	 * After getactivity(), the current process is counted
	 * twice in dnvars.active (one will pass to the child).
	 * If putactivity tries to wait for dnvars.active == 0,
	 * it will never happen.
	 */

	/* limit parallelism */
	procs = getactivity(req, 1);
	if (procs &gt; stats.slavehiwat)
		stats.slavehiwat = procs;
	if(procs &gt; Maxactive){
		if(traceactivity)
			dnslog("[%d] too much activity", getpid());
		putactivity(1);
		return;
	}

	/*
	 * parent returns to main loop, child does the work.
	 * don't change note group.
	 */
	ppid = getpid();
	switch(rfork(RFPROC|RFMEM|RFNOWAIT)){
	case -1:
		putactivity(1);
		break;
	case 0:
		procsetname("request slave of pid %d", ppid);
 		if(traceactivity)
			dnslog("[%d] take activity from %d", getpid(), ppid);
		req-&gt;isslave = 1;	/* why not `= getpid()'? */
		break;
	default:
		/*
		 * this relies on rfork producing separate, initially-identical
		 * stacks, thus giving us two copies of `req', one in each
		 * process.
		 */
		alarm(0);
		longjmp(req-&gt;mret, 1);
	}
}

/*
 *  chasing down double free's
 */
void
dncheck(void *p, int dolock)
{
	int i;
	DN *dp;
	RR *rp;

	if(p != nil){
		dp = p;
		assert(dp-&gt;magic == DNmagic);
	}

	if(!testing)
		return;

	if(dolock)
		lock(&amp;dnlock);
	poolcheck(mainmem);
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next){
			assert(dp != p);
			assert(dp-&gt;magic == DNmagic);
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
				assert(rp-&gt;magic == RRmagic);
				assert(rp-&gt;cached);
				assert(rp-&gt;owner == dp);
				/* also check for duplicate rrs */
				if (dolock &amp;&amp; rronlist(rp, rp-&gt;next)) {
					dnslog("%R duplicates its next chain "
						"(%R); aborting", rp, rp-&gt;next);
					abort();
				}
			}
		}
	if(dolock)
		unlock(&amp;dnlock);
}

static int
rrequiv(RR *r1, RR *r2)
{
	return r1-&gt;owner == r2-&gt;owner
		&amp;&amp; r1-&gt;type == r2-&gt;type
		&amp;&amp; r1-&gt;arg0 == r2-&gt;arg0
		&amp;&amp; r1-&gt;arg1 == r2-&gt;arg1;
}

/* called with dnlock held */
void
unique(RR *rp)
{
	RR **l, *nrp;

	for(; rp; rp = rp-&gt;next){
		l = &amp;rp-&gt;next;
		for(nrp = *l; nrp; nrp = *l)
			if(rrequiv(rp, nrp)){
				*l = nrp-&gt;next;
				rrfree(nrp);
			} else
				l = &amp;nrp-&gt;next;
	}
}

/*
 *  true if second domain is subsumed by the first
 */
int
subsume(char *higher, char *lower)
{
	int hn, ln;

	ln = strlen(lower);
	hn = strlen(higher);
	if (ln &lt; hn || cistrcmp(lower + ln - hn, higher) != 0 ||
	    ln &gt; hn &amp;&amp; hn != 0 &amp;&amp; lower[ln - hn - 1] != '.')
		return 0;
	return 1;
}

/*
 *  randomize the order we return items to provide some
 *  load balancing for servers.
 *
 *  only randomize the first class of entries
 */
RR*
randomize(RR *rp)
{
	RR *first, *last, *x, *base;
	ulong n;

	if(rp == nil || rp-&gt;next == nil)
		return rp;

	/* just randomize addresses, mx's and ns's */
	for(x = rp; x; x = x-&gt;next)
		if(x-&gt;type != Ta &amp;&amp; x-&gt;type != Taaaa &amp;&amp;
		    x-&gt;type != Tmx &amp;&amp; x-&gt;type != Tns)
			return rp;

	base = rp;

	n = rand();
	last = first = nil;
	while(rp != nil){
		/* stop randomizing if we've moved past our class */
		if(base-&gt;auth != rp-&gt;auth || base-&gt;db != rp-&gt;db){
			last-&gt;next = rp;
			break;
		}

		/* unchain */
		x = rp;
		rp = x-&gt;next;
		x-&gt;next = nil;

		if(n&amp;1){
			/* add to tail */
			if(last == nil)
				first = x;
			else
				last-&gt;next = x;
			last = x;
		} else {
			/* add to head */
			if(last == nil)
				last = x;
			x-&gt;next = first;
			first = x;
		}

		/* reroll the dice */
		n &gt;&gt;= 1;
	}

	return first;
}

static int
sencodefmt(Fmt *f)
{
	int i, len, ilen, rv;
	char *out, *buf;
	uchar *b;
	char obuf[64];		/* rsc optimization */

	if(!(f-&gt;flags&amp;FmtPrec) || f-&gt;prec &lt; 1)
		goto error;

	b = va_arg(f-&gt;args, uchar*);
	if(b == nil)
		goto error;

	/* if it's a printable, go for it */
	len = f-&gt;prec;
	for(i = 0; i &lt; len; i++)
		if(!isprint(b[i]))
			break;
	if(i == len){
		if(len &gt;= sizeof obuf)
			len = sizeof(obuf)-1;
		memmove(obuf, b, len);
		obuf[len] = 0;
		fmtstrcpy(f, obuf);
		return 0;
	}

	ilen = f-&gt;prec;
	f-&gt;prec = 0;
	f-&gt;flags &amp;= ~FmtPrec;
	switch(f-&gt;r){
	case '&lt;':
		len = (8*ilen+4)/5 + 3;
		break;
	case '[':
		len = (8*ilen+5)/6 + 4;
		break;
	case 'H':
		len = 2*ilen + 1;
		break;
	default:
		goto error;
	}

	if(len &gt; sizeof(obuf)){
		buf = malloc(len);
		if(buf == nil)
			goto error;
	} else
		buf = obuf;

	/* convert */
	out = buf;
	switch(f-&gt;r){
	case '&lt;':
		rv = enc32(out, len, b, ilen);
		break;
	case '[':
		rv = enc64(out, len, b, ilen);
		break;
	case 'H':
		rv = enc16(out, len, b, ilen);
		break;
	default:
		rv = -1;
		break;
	}
	if(rv &lt; 0)
		goto error;

	fmtstrcpy(f, buf);
	if(buf != obuf)
		free(buf);
	return 0;

error:
	return fmtstrcpy(f, "&lt;encodefmt&gt;");
}

void*
emalloc(int size)
{
	char *x;

	x = mallocz(size, 1);
	if(x == nil)
		abort();
	setmalloctag(x, getcallerpc(&amp;size));
	return x;
}

char*
estrdup(char *s)
{
	int size;
	char *p;

	size = strlen(s)+1;
	p = mallocz(size, 0);
	if(p == nil)
		abort();
	memmove(p, s, size);
	setmalloctag(p, getcallerpc(&amp;s));
	return p;
}

/*
 *  create a pointer record
 */
static RR*
mkptr(DN *dp, char *ptr, ulong ttl)
{
	DN *ipdp;
	RR *rp;

	ipdp = dnlookup(ptr, Cin, 1);

	rp = rralloc(Tptr);
	rp-&gt;ptr = dp;
	rp-&gt;owner = ipdp;
	rp-&gt;db = 1;
	if(ttl)
		rp-&gt;ttl = ttl;
	return rp;
}

void	bytes2nibbles(uchar *nibbles, uchar *bytes, int nbytes);

/*
 *  look for all ip addresses in this network and make
 *  pointer records for them.
 */
void
dnptr(uchar *net, uchar *mask, char *dom, int forwtype, int subdoms, int ttl)
{
	int i, j, len;
	char *p, *e;
	char ptr[Domlen];
	uchar *ipp;
	uchar ip[IPaddrlen], nnet[IPaddrlen];
	uchar nibip[IPaddrlen*2];
	DN *dp;
	RR *rp, *nrp, *first, **l;

	l = &amp;first;
	first = nil;
	for(i = 0; i &lt; HTLEN; i++)
		for(dp = ht[i]; dp; dp = dp-&gt;next)
			for(rp = dp-&gt;rr; rp; rp = rp-&gt;next){
				if(rp-&gt;type != forwtype || rp-&gt;negative)
					continue;
				parseip(ip, rp-&gt;ip-&gt;name);
				maskip(ip, mask, nnet);
				if(ipcmp(net, nnet) != 0)
					continue;

				ipp = ip;
				len = IPaddrlen;
				if (forwtype == Taaaa) {
					bytes2nibbles(nibip, ip, IPaddrlen);
					ipp = nibip;
					len = 2*IPaddrlen;
				}

				p = ptr;
				e = ptr+sizeof(ptr);
				for(j = len - 1; j &gt;= len - subdoms; j--)
					p = seprint(p, e, (forwtype == Ta?
						"%d.": "%x."), ipp[j]);
				seprint(p, e, "%s", dom);

				nrp = mkptr(dp, ptr, ttl);
				*l = nrp;
				l = &amp;nrp-&gt;next;
			}

	for(rp = first; rp != nil; rp = nrp){
		nrp = rp-&gt;next;
		rp-&gt;next = nil;
		rrattach(rp, Authoritative);
	}
}

void
addserver(Server **l, char *name)
{
	Server *s;

	while(*l)
		l = &amp;(*l)-&gt;next;
	s = malloc(sizeof(Server)+strlen(name)+1);
	if(s == nil)
		return;
	s-&gt;name = (char*)(s+1);
	strcpy(s-&gt;name, name);
	s-&gt;next = nil;
	*l = s;
}

Server*
copyserverlist(Server *s)
{
	Server *ns;

	for(ns = nil; s != nil; s = s-&gt;next)
		addserver(&amp;ns, s-&gt;name);
	return ns;
}


/* from here down is copied to ip/snoopy/dns.c periodically to update it */

/*
 *  convert an integer RR type to it's ascii name
 */
char*
rrname(int type, char *buf, int len)
{
	char *t;

	t = nil;
	if(type &gt;= 0 &amp;&amp; type &lt;= Tall)
		t = rrtname[type];
	if(t==nil){
		snprint(buf, len, "%d", type);
		t = buf;
	}
	return t;
}

/*
 *  free a list of resource records and any related structs
 */
void
rrfreelist(RR *rp)
{
	RR *next;

	for(; rp; rp = next){
		next = rp-&gt;next;
		rrfree(rp);
	}
}

void
freeserverlist(Server *s)
{
	Server *next;

	for(; s != nil; s = next){
		next = s-&gt;next;
		free(s);
	}
}

/*
 *  allocate a resource record of a given type
 */
RR*
rralloc(int type)
{
	RR *rp;

	rp = emalloc(sizeof(*rp));
	rp-&gt;magic = RRmagic;
	rp-&gt;pc = getcallerpc(&amp;type);
	rp-&gt;type = type;
	if (rp-&gt;type != type)
		dnslog("rralloc: bogus type %d", type);
	setmalloctag(rp, rp-&gt;pc);
	switch(type){
	case Tsoa:
		rp-&gt;soa = emalloc(sizeof(*rp-&gt;soa));
		rp-&gt;soa-&gt;slaves = nil;
		setmalloctag(rp-&gt;soa, rp-&gt;pc);
		break;
	case Tsrv:
		rp-&gt;srv = emalloc(sizeof(*rp-&gt;srv));
		setmalloctag(rp-&gt;srv, rp-&gt;pc);
		break;
	case Tkey:
		rp-&gt;key = emalloc(sizeof(*rp-&gt;key));
		setmalloctag(rp-&gt;key, rp-&gt;pc);
		break;
	case Tcert:
		rp-&gt;cert = emalloc(sizeof(*rp-&gt;cert));
		setmalloctag(rp-&gt;cert, rp-&gt;pc);
		break;
	case Tsig:
		rp-&gt;sig = emalloc(sizeof(*rp-&gt;sig));
		setmalloctag(rp-&gt;sig, rp-&gt;pc);
		break;
	case Tnull:
		rp-&gt;null = emalloc(sizeof(*rp-&gt;null));
		setmalloctag(rp-&gt;null, rp-&gt;pc);
		break;
	}
	rp-&gt;ttl = 0;
	rp-&gt;expire = 0;
	rp-&gt;next = 0;
	return rp;
}

/*
 *  free a resource record and any related structs
 */
void
rrfree(RR *rp)
{
	DN *dp;
	RR *nrp;
	Txt *t;

	assert(rp-&gt;magic == RRmagic);
	assert(!rp-&gt;cached);

	/* our callers often hold dnlock.  it's needed to examine dp safely. */
	dp = rp-&gt;owner;
	if(dp){
		/* if someone else holds dnlock, skip the sanity check. */
		if (canlock(&amp;dnlock)) {
			assert(dp-&gt;magic == DNmagic);
			for(nrp = dp-&gt;rr; nrp; nrp = nrp-&gt;next)
				assert(nrp != rp);   /* "rrfree of live rr" */
			unlock(&amp;dnlock);
		}
	}

	switch(rp-&gt;type){
	case Tsoa:
		freeserverlist(rp-&gt;soa-&gt;slaves);
		memset(rp-&gt;soa, 0, sizeof *rp-&gt;soa);	/* cause trouble */
		free(rp-&gt;soa);
		break;
	case Tsrv:
		memset(rp-&gt;srv, 0, sizeof *rp-&gt;srv);	/* cause trouble */
		free(rp-&gt;srv);
		break;
	case Tkey:
		free(rp-&gt;key-&gt;data);
		memset(rp-&gt;key, 0, sizeof *rp-&gt;key);	/* cause trouble */
		free(rp-&gt;key);
		break;
	case Tcert:
		free(rp-&gt;cert-&gt;data);
		memset(rp-&gt;cert, 0, sizeof *rp-&gt;cert);	/* cause trouble */
		free(rp-&gt;cert);
		break;
	case Tsig:
		free(rp-&gt;sig-&gt;data);
		memset(rp-&gt;sig, 0, sizeof *rp-&gt;sig);	/* cause trouble */
		free(rp-&gt;sig);
		break;
	case Tnull:
		free(rp-&gt;null-&gt;data);
		memset(rp-&gt;null, 0, sizeof *rp-&gt;null);	/* cause trouble */
		free(rp-&gt;null);
		break;
	case Ttxt:
		while(rp-&gt;txt != nil){
			t = rp-&gt;txt;
			rp-&gt;txt = t-&gt;next;
			free(t-&gt;p);
			memset(t, 0, sizeof *t);	/* cause trouble */
			free(t);
		}
		break;
	}

	rp-&gt;magic = ~rp-&gt;magic;
	memset(rp, 0, sizeof *rp);		/* cause trouble */
	free(rp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

