<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnsdebug.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnsdebug.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ip.h&gt;
#include &lt;ndb.h&gt;
#include "dns.h"

enum {
	Maxrequest=		128,
};

Cfg cfg;

static char *servername;
static RR *serverrr;
static RR *serveraddrs;

char	*dbfile;
int	debug;
uchar	ipaddr[IPaddrlen];	/* my ip address */
char	*logfile = "dnsdebug";
int	maxage  = 60*60;
char	mntpt[Maxpath];
int	needrefresh;
ulong	now;
vlong	nowns;
int	testing;
char	*trace;
int	traceactivity;
char	*zonerefreshprogram;

void	docmd(int, char**);
void	doquery(char*, char*);
void	preloadserveraddrs(void);
int	prettyrrfmt(Fmt*);
int	setserver(char*);
void	squirrelserveraddrs(void);

void
usage(void)
{
	fprint(2, "%s: [-rx] [-f db-file] [[@server] domain [type]]\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	int n;
	Biobuf in;
	char *p;
	char *f[4];

	strcpy(mntpt, "/net");
	cfg.inside = 1;

	ARGBEGIN{
	case 'f':
		dbfile = EARGF(usage());
		break;
	case 'r':
		cfg.resolver = 1;
		break;
	case 'x':
		dbfile = "/lib/ndb/external";
		strcpy(mntpt, "/net.alt");
		break;
	default:
		usage();
	}ARGEND

	now = time(nil);
	nowns = nsec();
	dninit();
	fmtinstall('R', prettyrrfmt);
	if(myipaddr(ipaddr, mntpt) &lt; 0)
		sysfatal("can't read my ip address");
	opendatabase();

	if(cfg.resolver)
		squirrelserveraddrs();

	debug = 1;

	if(argc &gt; 0){
		docmd(argc, argv);
		exits(0);
	}

	Binit(&amp;in, 0, OREAD);
	for(print("&gt; "); p = Brdline(&amp;in, '\n'); print("&gt; ")){
		p[Blinelen(&amp;in)-1] = 0;
		n = tokenize(p, f, 3);
		if(n&gt;=1) {
			dnpurge();		/* flush the cache */
			docmd(n, f);
		}
	}
	exits(0);
}

static char*
longtime(long t)
{
	int d, h, m, n;
	static char x[128];

	for(d = 0; t &gt;= 24*60*60; t -= 24*60*60)
		d++;
	for(h = 0; t &gt;= 60*60; t -= 60*60)
		h++;
	for(m = 0; t &gt;= 60; t -= 60)
		m++;
	n = 0;
	if(d)
		n += sprint(x, "%d day ", d);
	if(h)
		n += sprint(x+n, "%d hr ", h);
	if(m)
		n += sprint(x+n, "%d min ", m);
	if(t || n == 0)
		sprint(x+n, "%ld sec", t);
	return x;
}

int
prettyrrfmt(Fmt *f)
{
	RR *rp;
	char buf[3*Domlen];
	char *p, *e;
	Txt *t;

	rp = va_arg(f-&gt;args, RR*);
	if(rp == 0){
		strcpy(buf, "&lt;null&gt;");
		goto out;
	}

	p = buf;
	e = buf + sizeof(buf);
	p = seprint(p, e, "%-32.32s %-15.15s %-5.5s", rp-&gt;owner-&gt;name,
		longtime(rp-&gt;db? rp-&gt;ttl: (rp-&gt;ttl - now)),
		rrname(rp-&gt;type, buf, sizeof buf));

	if(rp-&gt;negative){
		seprint(p, e, "negative rcode %d", rp-&gt;negrcode);
		goto out;
	}

	switch(rp-&gt;type){
	case Thinfo:
		seprint(p, e, "\t%s %s", rp-&gt;cpu-&gt;name, rp-&gt;os-&gt;name);
		break;
	case Tcname:
	case Tmb:
	case Tmd:
	case Tmf:
	case Tns:
		seprint(p, e, "\t%s", (rp-&gt;host? rp-&gt;host-&gt;name: ""));
		break;
	case Tmg:
	case Tmr:
		seprint(p, e, "\t%s", (rp-&gt;mb? rp-&gt;mb-&gt;name: ""));
		break;
	case Tminfo:
		seprint(p, e, "\t%s %s", (rp-&gt;mb? rp-&gt;mb-&gt;name: ""),
			(rp-&gt;rmb? rp-&gt;rmb-&gt;name: ""));
		break;
	case Tmx:
		seprint(p, e, "\t%lud %s", rp-&gt;pref,
			(rp-&gt;host? rp-&gt;host-&gt;name: ""));
		break;
	case Ta:
	case Taaaa:
		seprint(p, e, "\t%s", (rp-&gt;ip? rp-&gt;ip-&gt;name: ""));
		break;
	case Tptr:
		seprint(p, e, "\t%s", (rp-&gt;ptr? rp-&gt;ptr-&gt;name: ""));
		break;
	case Tsoa:
		seprint(p, e, "\t%s %s %lud %lud %lud %lud %lud",
			rp-&gt;host-&gt;name, rp-&gt;rmb-&gt;name, rp-&gt;soa-&gt;serial,
			rp-&gt;soa-&gt;refresh, rp-&gt;soa-&gt;retry,
			rp-&gt;soa-&gt;expire, rp-&gt;soa-&gt;minttl);
		break;
	case Tsrv:
		seprint(p, e, "\t%ud %ud %ud %s",
			rp-&gt;srv-&gt;pri, rp-&gt;srv-&gt;weight, rp-&gt;port, rp-&gt;host-&gt;name);
		break;
	case Tnull:
		seprint(p, e, "\t%.*H", rp-&gt;null-&gt;dlen, rp-&gt;null-&gt;data);
		break;
	case Ttxt:
		p = seprint(p, e, "\t");
		for(t = rp-&gt;txt; t != nil; t = t-&gt;next)
			p = seprint(p, e, "%s", t-&gt;p);
		break;
	case Trp:
		seprint(p, e, "\t%s %s", rp-&gt;rmb-&gt;name, rp-&gt;rp-&gt;name);
		break;
	case Tkey:
		seprint(p, e, "\t%d %d %d", rp-&gt;key-&gt;flags, rp-&gt;key-&gt;proto,
			rp-&gt;key-&gt;alg);
		break;
	case Tsig:
		seprint(p, e, "\t%d %d %d %lud %lud %lud %d %s",
			rp-&gt;sig-&gt;type, rp-&gt;sig-&gt;alg, rp-&gt;sig-&gt;labels,
			rp-&gt;sig-&gt;ttl, rp-&gt;sig-&gt;exp, rp-&gt;sig-&gt;incep,
			rp-&gt;sig-&gt;tag, rp-&gt;sig-&gt;signer-&gt;name);
		break;
	case Tcert:
		seprint(p, e, "\t%d %d %d",
			rp-&gt;sig-&gt;type, rp-&gt;sig-&gt;tag, rp-&gt;sig-&gt;alg);
		break;
	}
out:
	return fmtstrcpy(f, buf);
}

void
logsection(char *flag, RR *rp)
{
	if(rp == nil)
		return;
	print("\t%s%R\n", flag, rp);
	for(rp = rp-&gt;next; rp != nil; rp = rp-&gt;next)
		print("\t      %R\n", rp);
}

void
logreply(int id, uchar *addr, DNSmsg *mp)
{
	RR *rp;
	char buf[12], resp[32];

	switch(mp-&gt;flags &amp; Rmask){
	case Rok:
		strcpy(resp, "OK");
		break;
	case Rformat:
		strcpy(resp, "Format error");
		break;
	case Rserver:
		strcpy(resp, "Server failed");
		break;
	case Rname:
		strcpy(resp, "Nonexistent");
		break;
	case Runimplimented:
		strcpy(resp, "Unimplemented");
		break;
	case Rrefused:
		strcpy(resp, "Refused");
		break;
	default:
		sprint(resp, "%d", mp-&gt;flags &amp; Rmask);
		break;
	}

	print("%d: rcvd %s from %I (%s%s%s%s%s)\n", id, resp, addr,
		mp-&gt;flags &amp; Fauth? "authoritative": "",
		mp-&gt;flags &amp; Ftrunc? " truncated": "",
		mp-&gt;flags &amp; Frecurse? " recurse": "",
		mp-&gt;flags &amp; Fcanrec? " can_recurse": "",
		(mp-&gt;flags &amp; (Fauth|Rmask)) == (Fauth|Rname)? " nx": "");
	for(rp = mp-&gt;qd; rp != nil; rp = rp-&gt;next)
		print("\tQ:    %s %s\n", rp-&gt;owner-&gt;name,
			rrname(rp-&gt;type, buf, sizeof buf));
	logsection("Ans:  ", mp-&gt;an);
	logsection("Auth: ", mp-&gt;ns);
	logsection("Hint: ", mp-&gt;ar);
}

void
logsend(int id, int subid, uchar *addr, char *sname, char *rname, int type)
{
	char buf[12];

	print("%d.%d: sending to %I/%s %s %s\n", id, subid,
		addr, sname, rname, rrname(type, buf, sizeof buf));
}

RR*
getdnsservers(int class)
{
	RR *rr;

	if(servername == nil)
		return dnsservers(class);

	rr = rralloc(Tns);
	rr-&gt;owner = dnlookup("local#dns#servers", class, 1);
	rr-&gt;host = dnlookup(servername, class, 1);

	return rr;
}

void
squirrelserveraddrs(void)
{
	int v4;
	char *attr;
	RR *rr, *rp, **l;
	Request req;

	/* look up the resolver address first */
	cfg.resolver = 0;
	debug = 0;
	if(serveraddrs)
		rrfreelist(serveraddrs);
	serveraddrs = nil;
	rr = getdnsservers(Cin);
	l = &amp;serveraddrs;
	for(rp = rr; rp != nil; rp = rp-&gt;next){
		attr = ipattr(rp-&gt;host-&gt;name);
		v4 = strcmp(attr, "ip") == 0;
		if(v4 || strcmp(attr, "ipv6") == 0){
			*l = rralloc(v4? Ta: Taaaa);
			(*l)-&gt;owner = rp-&gt;host;
			(*l)-&gt;ip = rp-&gt;host;
			l = &amp;(*l)-&gt;next;
			continue;
		}
		memset(&amp;req, 0, sizeof req);
		req.isslave = 1;
		req.aborttime = NS2MS(nowns) + Maxreqtm;
		*l = dnresolve(rp-&gt;host-&gt;name, Cin, Ta, &amp;req, 0, 0, Recurse, 0, 0);
		if(*l == nil)
			*l = dnresolve(rp-&gt;host-&gt;name, Cin, Taaaa, &amp;req,
				0, 0, Recurse, 0, 0);
		while(*l != nil)
			l = &amp;(*l)-&gt;next;
	}
	cfg.resolver = 1;
	debug = 1;
}

void
preloadserveraddrs(void)
{
	RR *rp, **l, *first;

	l = &amp;first;
	for(rp = serveraddrs; rp != nil; rp = rp-&gt;next){
		lock(&amp;dnlock);
		rrcopy(rp, l);
		unlock(&amp;dnlock);
		rrattach(first, Authoritative);
	}
}

int
setserver(char *server)
{
	if(servername != nil){
		free(servername);
		servername = nil;
		cfg.resolver = 0;
	}
	if(server == nil || *server == 0)
		return 0;
	servername = strdup(server);
	squirrelserveraddrs();
	if(serveraddrs == nil){
		print("can't resolve %s\n", servername);
		cfg.resolver = 0;
	} else
		cfg.resolver = 1;
	return cfg.resolver? 0: -1;
}

void
doquery(char *name, char *tstr)
{
	int len, type, rooted;
	char *p, *np;
	char buf[1024];
	RR *rr, *rp;
	Request req;

	if(cfg.resolver)
		preloadserveraddrs();

	/* default to an "ip" request if alpha, "ptr" if numeric */
	if(tstr == nil || *tstr == 0)
		if(strcmp(ipattr(name), "ip") == 0)
			tstr = "ptr";
		else
			tstr = "ip";

	/* if name end in '.', remove it */
	len = strlen(name);
	if(len &gt; 0 &amp;&amp; name[len-1] == '.'){
		rooted = 1;
		name[len-1] = 0;
	} else
		rooted = 0;

	/* inverse queries may need to be permuted */
	strncpy(buf, name, sizeof buf);
	if(strcmp("ptr", tstr) == 0 &amp;&amp; cistrstr(name, ".arpa") == nil){
		/* TODO: reversing v6 addrs is harder */
		for(p = name; *p; p++)
			;
		*p = '.';
		np = buf;
		len = 0;
		while(p &gt;= name){
			len++;
			p--;
			if(*p == '.'){
				memmove(np, p+1, len);
				np += len;
				len = 0;
			}
		}
		memmove(np, p+1, len);
		np += len;
		strcpy(np, "in-addr.arpa");	/* TODO: ip6.arpa for v6 */
	}

	/* look it up */
	type = rrtype(tstr);
	if(type &lt; 0){
		print("!unknown type %s\n", tstr);
		return;
	}

	memset(&amp;req, 0, sizeof req);
	getactivity(&amp;req, 0);
	req.isslave = 1;
	req.aborttime = NS2MS(nowns) + Maxreqtm;
	rr = dnresolve(buf, Cin, type, &amp;req, 0, 0, Recurse, rooted, 0);
	if(rr){
		print("----------------------------\n");
		for(rp = rr; rp; rp = rp-&gt;next)
			print("answer %R\n", rp);
		print("----------------------------\n");
	}
	rrfreelist(rr);

	putactivity(0);
}

void
docmd(int n, char **f)
{
	int tmpsrv;
	char *name, *type;

	name = type = nil;
	tmpsrv = 0;

	if(*f[0] == '@') {
		if(setserver(f[0]+1) &lt; 0)
			return;

		switch(n){
		case 3:
			type = f[2];
			/* fall through */
		case 2:
			name = f[1];
			tmpsrv = 1;
			break;
		}
	} else
		switch(n){
		case 2:
			type = f[1];
			/* fall through */
		case 1:
			name = f[0];
			break;
		}

	if(name == nil)
		return;

	doquery(name, type);

	if(tmpsrv)
		setserver("");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

