<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnserver.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnserver.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

static RR*	doextquery(DNSmsg*, Request*, int);
static void	hint(RR**, RR*);

/* set in dns.c */
int	norecursion;		/* don't allow recursive requests */

/*
 *  answer a dns request
 */
void
dnserver(DNSmsg *reqp, DNSmsg *repp, Request *req, uchar *srcip, int rcode)
{
	int recursionflag;
	char *cp, *errmsg;
	char tname[32];
	DN *nsdp, *dp;
	Area *myarea;
	RR *tp, *neg, *rp;

	dncheck(nil, 1);

	recursionflag = norecursion? 0: Fcanrec;
	memset(repp, 0, sizeof(*repp));
	repp-&gt;id = reqp-&gt;id;
	repp-&gt;flags = Fresp | recursionflag | Oquery;

	/* move one question from reqp to repp */
	tp = reqp-&gt;qd;
	reqp-&gt;qd = tp-&gt;next;
	tp-&gt;next = nil;
	repp-&gt;qd = tp;

	if (rcode) {
		errmsg = "";
		if (rcode &gt;= 0 &amp;&amp; rcode &lt; nrname)
			errmsg = rname[rcode];
		dnslog("server: response code 0%o (%s), req from %I",
			rcode, errmsg, srcip);
		/* provide feedback to clients who send us trash */
		repp-&gt;flags = (rcode&amp;Rmask) | Fresp | Fcanrec | Oquery;
		return;
	}
	if(!rrsupported(repp-&gt;qd-&gt;type)){
		dnslog("server: unsupported request %s from %I",
			rrname(repp-&gt;qd-&gt;type, tname, sizeof tname), srcip);
		repp-&gt;flags = Runimplimented | Fresp | Fcanrec | Oquery;
		return;
	}

	if(repp-&gt;qd-&gt;owner-&gt;class != Cin){
		dnslog("server: unsupported class %d from %I",
			repp-&gt;qd-&gt;owner-&gt;class, srcip);
		repp-&gt;flags = Runimplimented | Fresp | Fcanrec | Oquery;
		return;
	}

	myarea = inmyarea(repp-&gt;qd-&gt;owner-&gt;name);
	if(myarea != nil) {
		if(repp-&gt;qd-&gt;type == Tixfr || repp-&gt;qd-&gt;type == Taxfr){
			dnslog("server: unsupported xfr request %s for %s from %I",
				rrname(repp-&gt;qd-&gt;type, tname, sizeof tname),
				repp-&gt;qd-&gt;owner-&gt;name, srcip);
			repp-&gt;flags = Runimplimented | Fresp | recursionflag |
				Oquery;
			return;
		}
	} else
		if(norecursion) {
			/* we don't recurse and we're not authoritative */
			repp-&gt;flags = Rok | Fresp | Oquery;
			return;
		}

	/*
	 *  get the answer if we can, in *repp
	 */
	if(reqp-&gt;flags &amp; Frecurse)
		neg = doextquery(repp, req, Recurse);
	else
		neg = doextquery(repp, req, Dontrecurse);

	/* authority is transitive */
	if(myarea != nil || (repp-&gt;an &amp;&amp; repp-&gt;an-&gt;auth))
		repp-&gt;flags |= Fauth;

	/* pass on error codes */
	if(repp-&gt;an == nil){
		dp = dnlookup(repp-&gt;qd-&gt;owner-&gt;name, repp-&gt;qd-&gt;owner-&gt;class, 0);
		if(dp-&gt;rr == nil)
			if(reqp-&gt;flags &amp; Frecurse)
				repp-&gt;flags |= dp-&gt;respcode | Fauth;
	}

	if(myarea == nil)
		/*
		 *  add name server if we know
		 */
		for(cp = repp-&gt;qd-&gt;owner-&gt;name; cp; cp = walkup(cp)){
			nsdp = dnlookup(cp, repp-&gt;qd-&gt;owner-&gt;class, 0);
			if(nsdp == nil)
				continue;

			repp-&gt;ns = rrlookup(nsdp, Tns, OKneg);
			if(repp-&gt;ns){
				/* don't pass on anything we know is wrong */
				if(repp-&gt;ns-&gt;negative){
					lock(&amp;dnlock);
					rp = repp-&gt;ns;
					repp-&gt;ns = nil;
					rrfreelist(rp);
					unlock(&amp;dnlock);
				}
				break;
			}

			if (strncmp(nsdp-&gt;name, "local#", 6) == 0)
				dnslog("returning %s as nameserver", nsdp-&gt;name);
			repp-&gt;ns = dblookup(cp, repp-&gt;qd-&gt;owner-&gt;class, Tns, 0, 0);
			if(repp-&gt;ns)
				break;
		}

	/*
	 *  add ip addresses as hints
	 */
	if(repp-&gt;qd-&gt;type != Taxfr &amp;&amp; repp-&gt;qd-&gt;type != Tixfr){
		for(tp = repp-&gt;ns; tp; tp = tp-&gt;next)
			hint(&amp;repp-&gt;ar, tp);
		for(tp = repp-&gt;an; tp; tp = tp-&gt;next)
			hint(&amp;repp-&gt;ar, tp);
	}

	/* hint calls rrlookup which holds dnlock, so don't lock before this. */

	/*
	 *  add an soa to the authority section to help client
	 *  with negative caching
	 */
	if(repp-&gt;an == nil)
		if(myarea != nil){
			lock(&amp;dnlock);
			rrcopy(myarea-&gt;soarr, &amp;tp);
			rrcat(&amp;repp-&gt;ns, tp);
			unlock(&amp;dnlock);
		} else if(neg != nil) {
			if(neg-&gt;negsoaowner != nil) {
				tp = rrlookup(neg-&gt;negsoaowner, Tsoa, NOneg);
				lock(&amp;dnlock);
				rrcat(&amp;repp-&gt;ns, tp);
				unlock(&amp;dnlock);
			}
			repp-&gt;flags |= neg-&gt;negrcode;
		}

	/*
	 *  get rid of duplicates
	 */
	lock(&amp;dnlock);
	unique(repp-&gt;an);
	unique(repp-&gt;ns);
	unique(repp-&gt;ar);

	rrfreelist(neg);
	unlock(&amp;dnlock);

	dncheck(nil, 1);
}

/*
 *  satisfy a recursive request.  dnlookup will handle cnames.
 */
static RR*
doextquery(DNSmsg *mp, Request *req, int recurse)
{
	ushort type;
	char *name;
	RR *rp, *neg;

	name = mp-&gt;qd-&gt;owner-&gt;name;
	type = mp-&gt;qd-&gt;type;
	rp = dnresolve(name, Cin, type, req, &amp;mp-&gt;an, 0, recurse, 1, 0);

	lock(&amp;dnlock);
	/* don't return soa hints as answers, it's wrong */
	if(rp &amp;&amp; rp-&gt;db &amp;&amp; !rp-&gt;auth &amp;&amp; rp-&gt;type == Tsoa) {
		rrfreelist(rp);
		rp = nil;
	}

	/* don't let negative cached entries escape */
	neg = rrremneg(&amp;rp);
	rrcat(&amp;mp-&gt;an, rp);
	unlock(&amp;dnlock);
	return neg;
}

static void
hint(RR **last, RR *rp)
{
	RR *hp;

	switch(rp-&gt;type){
	case Tns:
	case Tmx:
	case Tmb:
	case Tmf:
	case Tmd:
		assert(rp-&gt;host != nil);
		hp = rrlookup(rp-&gt;host, Ta, NOneg);
		if(hp == nil)
			hp = dblookup(rp-&gt;host-&gt;name, Cin, Ta, 0, 0);
		if(hp == nil)
			hp = rrlookup(rp-&gt;host, Taaaa, NOneg);
		if(hp == nil)
			hp = dblookup(rp-&gt;host-&gt;name, Cin, Taaaa, 0, 0);
		if (hp &amp;&amp; hp-&gt;owner &amp;&amp; hp-&gt;owner-&gt;name &amp;&amp;
		    strncmp(hp-&gt;owner-&gt;name, "local#", 6) == 0)
			dnslog("returning %s as hint", hp-&gt;owner-&gt;name);
		lock(&amp;dnlock);
		rrcat(last, hp);
		unlock(&amp;dnlock);
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

