<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnsquery.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnsquery.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ctype.h&gt;
#include &lt;ndb.h&gt;
#include "dns.h"
#include "ip.h"

static int domount;
static char *mtpt, *dns, *srv;

static int
setup(int argc, char **argv)
{
	int fd;

	if(argc == 1){
		domount = 0;
		mtpt = argv[0];
	}

	fd = open(dns, ORDWR);
	if(fd &lt; 0){
		if(domount == 0)
			sysfatal("can't open %s: %r", dns);
		fd = open(srv, ORDWR);
		if(fd &lt; 0)
			sysfatal("can't open %s: %r", srv);
		if(mount(fd, -1, mtpt, MBEFORE, "") &lt; 0)
			sysfatal("can't mount(%s, %s): %r", srv, mtpt);
		fd = open(dns, ORDWR);
		if(fd &lt; 0)
			sysfatal("can't open %s: %r", dns);
	}
	return fd;
}

static void
querydns(int fd, char *line, int n)
{
	char buf[1024];

	seek(fd, 0, 0);
	if(write(fd, line, n) != n) {
		print("!%r\n");
		return;
	}
	seek(fd, 0, 0);
	buf[0] = '\0';
	while((n = read(fd, buf, sizeof(buf))) &gt; 0){
		buf[n] = '\0';
		print("%s\n", buf);
	}
}

static void
query(int fd)
{
	int n, len;
	char *lp, *p, *np;
	char buf[1024], line[1024];
	Biobuf in;

	Binit(&amp;in, 0, OREAD);
	for(print("&gt; "); lp = Brdline(&amp;in, '\n'); print("&gt; ")){
		n = Blinelen(&amp;in) -1;
		while(isspace(lp[n]))
			lp[n--] = 0;
		n++;
		while(isspace(*lp)){
			lp++;
			n--;
		}
		if(!*lp)
			continue;
		strcpy(line, lp);

		/* default to an "ip" request if alpha, "ptr" if numeric */
		if(strchr(line, ' ') == nil)
			if(strcmp(ipattr(line), "ip") == 0) {
				strcat(line, " ptr");
				n += 4;
			} else {
				strcat(line, " ip");
				n += 3;
			}

		/* inverse queries may need to be permuted */
		if(n &gt; 4 &amp;&amp; strcmp(" ptr", &amp;line[n-4]) == 0 &amp;&amp;
		    cistrstr(line, ".arpa") == nil){
			/* TODO: reversing v6 addrs is harder */
			for(p = line; *p; p++)
				if(*p == ' '){
					*p = '.';
					break;
				}
			np = buf;
			len = 0;
			while(p &gt;= line){
				len++;
				p--;
				if(*p == '.'){
					memmove(np, p+1, len);
					np += len;
					len = 0;
				}
			}
			memmove(np, p+1, len);
			np += len;
			strcpy(np, "in-addr.arpa ptr");	/* TODO: ip6.arpa for v6 */
			strcpy(line, buf);
			n = strlen(line);
		}

		querydns(fd, line, n);
	}
	Bterm(&amp;in);
}

void
main(int argc, char *argv[])
{
	mtpt = "/net";
	dns = "/net/dns";
	srv = "/srv/dns";
	domount = 1;
	ARGBEGIN {
	case 'x':
		mtpt = "/net.alt";
		dns = "/net.alt/dns";
		srv = "/srv/dns_net.alt";
		break;
	default:
		fprint(2, "usage: %s [-x] [dns-mount-point]\n", argv0);
		exits("usage");
	} ARGEND;

	query(setup(argc, argv));
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

