<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/dnudpserver.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/dnudpserver.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

enum {
	Logqueries = 0,
};

static int	udpannounce(char*);
static void	reply(int, uchar*, DNSmsg*, Request*);

typedef struct Inprogress Inprogress;
struct Inprogress
{
	int	inuse;
	Udphdr	uh;
	DN	*owner;
	ushort	type;
	int	id;
};
Inprogress inprog[Maxactive+2];

typedef struct Forwtarg Forwtarg;
struct Forwtarg {
	char	*host;
	uchar	addr[IPaddrlen];
	int	fd;
	ulong	lastdial;
};
Forwtarg forwtarg[10];
int currtarg;

static char *hmsg = "headers";

/*
 *  record client id and ignore retransmissions.
 *  we're still single thread at this point.
 */
static Inprogress*
clientrxmit(DNSmsg *req, uchar *buf)
{
	Inprogress *p, *empty;
	Udphdr *uh;

	uh = (Udphdr *)buf;
	empty = nil;
	for(p = inprog; p &lt; &amp;inprog[Maxactive]; p++){
		if(p-&gt;inuse == 0){
			if(empty == nil)
				empty = p;
			continue;
		}
		if(req-&gt;id == p-&gt;id &amp;&amp; req-&gt;qd != nil &amp;&amp;
		    req-&gt;qd-&gt;owner == p-&gt;owner &amp;&amp; req-&gt;qd-&gt;type == p-&gt;type &amp;&amp;
		    memcmp(uh, &amp;p-&gt;uh, Udphdrsize) == 0)
			return nil;
	}
	if(empty == nil)
		return nil; /* shouldn't happen: see slave() &amp; Maxactive def'n */
	if(req-&gt;qd == nil) {
		dnslog("clientrxmit: nil req-&gt;qd");
		return nil;
	}
	empty-&gt;id = req-&gt;id;
	empty-&gt;owner = req-&gt;qd-&gt;owner;
	empty-&gt;type = req-&gt;qd-&gt;type;
	if (empty-&gt;type != req-&gt;qd-&gt;type)
		dnslog("clientrxmit: bogus req-&gt;qd-&gt;type %d", req-&gt;qd-&gt;type);
	memmove(&amp;empty-&gt;uh, uh, Udphdrsize);
	empty-&gt;inuse = 1;
	return empty;
}

int
addforwtarg(char *host)
{
	Forwtarg *tp;

	if (currtarg &gt;= nelem(forwtarg)) {
		dnslog("too many forwarding targets");
		return -1;
	}
	tp = forwtarg + currtarg;
	if (parseip(tp-&gt;addr, host) &lt; 0) {
		dnslog("can't parse ip %s", host);
		return -1;
	}
	tp-&gt;lastdial = time(nil);
	tp-&gt;fd = udpport(mntpt);
	if (tp-&gt;fd &lt; 0)
		return -1;

	free(tp-&gt;host);
	tp-&gt;host = estrdup(host);
	currtarg++;
	return 0;
}

/*
 * fast forwarding of incoming queries to other dns servers.
 * intended primarily for debugging.
 */
static void
redistrib(uchar *buf, int len)
{
	Forwtarg *tp;
	Udphdr *uh;
	static uchar outpkt[1500];

	assert(len &lt;= sizeof outpkt);
	memmove(outpkt, buf, len);
	uh = (Udphdr *)outpkt;
	for (tp = forwtarg; tp &lt; forwtarg + currtarg; tp++)
		if (tp-&gt;fd &gt; 0) {
			memmove(outpkt, tp-&gt;addr, sizeof tp-&gt;addr);
			hnputs(uh-&gt;rport, Dnsport);
			if (write(tp-&gt;fd, outpkt, len) != len) {
				close(tp-&gt;fd);
				tp-&gt;fd = -1;
			}
		} else if (tp-&gt;host &amp;&amp; time(nil) - tp-&gt;lastdial &gt; 60) {
			tp-&gt;lastdial = time(nil);
			tp-&gt;fd = udpport(mntpt);
		}
}

/*
 *  a process to act as a dns server for outside reqeusts
 */
void
dnudpserver(char *mntpt)
{
	volatile int fd, len, op, rcode;
	char *volatile err;
	volatile char tname[32];
	volatile uchar buf[Udphdrsize + Maxpayload];
	volatile DNSmsg reqmsg, repmsg;
	Inprogress *volatile p;
	volatile Request req;
	Udphdr *volatile uh;

	/*
	 * fork sharing text, data, and bss with parent.
	 * stay in the same note group.
	 */
	switch(rfork(RFPROC|RFMEM|RFNOWAIT)){
	case -1:
		break;
	case 0:
		break;
	default:
		return;
	}

	fd = -1;
restart:
	procsetname("udp server announcing");
	if(fd &gt;= 0)
		close(fd);
	while((fd = udpannounce(mntpt)) &lt; 0)
		sleep(5000);

//	procsetname("udp server");
	memset(&amp;req, 0, sizeof req);
	if(setjmp(req.mret))
		putactivity(0);
	req.isslave = 0;
	req.id = 0;
	req.aborttime = 0;

	/* loop on requests */
	for(;; putactivity(0)){
		procsetname("served %d udp; %d alarms",
			stats.qrecvdudp, stats.alarms);
		memset(&amp;repmsg, 0, sizeof repmsg);
		memset(&amp;reqmsg, 0, sizeof reqmsg);

		alarm(60*1000);
		len = read(fd, buf, sizeof buf);
		alarm(0);
		if(len &lt;= Udphdrsize)
			goto restart;

		redistrib(buf, len);

		uh = (Udphdr*)buf;
		len -= Udphdrsize;

		// dnslog("read received UDP from %I to %I",
		//	((Udphdr*)buf)-&gt;raddr, ((Udphdr*)buf)-&gt;laddr);
		getactivity(&amp;req, 0);
		req.aborttime = timems() + Maxreqtm;
//		req.from = smprint("%I", ((Udphdr*)buf)-&gt;raddr);
		req.from = smprint("%I", buf);
		rcode = 0;
		stats.qrecvdudp++;

		err = convM2DNS(&amp;buf[Udphdrsize], len, &amp;reqmsg, &amp;rcode);
		if(err){
			/* first bytes in buf are source IP addr */
			dnslog("server: input error: %s from %I", err, buf);
			free(err);
			goto freereq;
		}
		if (rcode == 0)
			if(reqmsg.qdcount &lt; 1){
				dnslog("server: no questions from %I", buf);
				goto freereq;
			} else if(reqmsg.flags &amp; Fresp){
				dnslog("server: reply not request from %I", buf);
				goto freereq;
			}
		op = reqmsg.flags &amp; Omask;
		if(op != Oquery &amp;&amp; op != Onotify){
			dnslog("server: op %d from %I", reqmsg.flags &amp; Omask,
				buf);
			goto freereq;
		}

		if(debug || (trace &amp;&amp; subsume(trace, reqmsg.qd-&gt;owner-&gt;name)))
			dnslog("%d: serve (%I/%d) %d %s %s",
				req.id, buf, uh-&gt;rport[0]&lt;&lt;8 | uh-&gt;rport[1],
				reqmsg.id, reqmsg.qd-&gt;owner-&gt;name,
				rrname(reqmsg.qd-&gt;type, tname, sizeof tname));

		p = clientrxmit(&amp;reqmsg, buf);
		if(p == nil){
			if(debug)
				dnslog("%d: duplicate", req.id);
			goto freereq;
		}

		if (Logqueries) {
			RR *rr;

			for (rr = reqmsg.qd; rr; rr = rr-&gt;next)
				syslog(0, "dnsq", "id %d: (%I/%d) %d %s %s",
					req.id, buf, uh-&gt;rport[0]&lt;&lt;8 |
					uh-&gt;rport[1], reqmsg.id,
					reqmsg.qd-&gt;owner-&gt;name,
					rrname(reqmsg.qd-&gt;type, tname,
					sizeof tname));
		}
		/* loop through each question */
		while(reqmsg.qd){
			memset(&amp;repmsg, 0, sizeof repmsg);
			switch(op){
			case Oquery:
				dnserver(&amp;reqmsg, &amp;repmsg, &amp;req, buf, rcode);
				break;
			case Onotify:
				dnnotify(&amp;reqmsg, &amp;repmsg, &amp;req);
				break;
			}
			/* send reply on fd to address in buf's udp hdr */
			reply(fd, buf, &amp;repmsg, &amp;req);
			freeanswers(&amp;repmsg);
		}

		p-&gt;inuse = 0;
freereq:
		free(req.from);
		req.from = nil;
		freeanswers(&amp;reqmsg);
		if(req.isslave){
			putactivity(0);
			_exits(0);
		}
	}
}

/*
 *  announce on well-known dns udp port and set message style interface
 */
static int
udpannounce(char *mntpt)
{
	int data, ctl;
	char dir[64], datafile[64+6];
	static int whined;

	/* get a udp port */
	sprint(datafile, "%s/udp!*!dns", mntpt);
	ctl = announce(datafile, dir);
	if(ctl &lt; 0){
		if(!whined++)
			warning("can't announce on %s", datafile);
		return -1;
	}

	/* turn on header style interface */
	if(write(ctl, hmsg, strlen(hmsg)) != strlen(hmsg))
		abort();			/* hmsg */

	snprint(datafile, sizeof(datafile), "%s/data", dir);
	data = open(datafile, ORDWR);
	if(data &lt; 0){
		close(ctl);
		if(!whined++)
			warning("can't open %s to announce on dns udp port",
				datafile);
		return -1;
	}

	close(ctl);
	return data;
}

static void
reply(int fd, uchar *buf, DNSmsg *rep, Request *reqp)
{
	int len;
	char tname[32];

	if(debug || (trace &amp;&amp; subsume(trace, rep-&gt;qd-&gt;owner-&gt;name)))
		dnslog("%d: reply (%I/%d) %d %s %s qd %R an %R ns %R ar %R",
			reqp-&gt;id, buf, buf[4]&lt;&lt;8 | buf[5],
			rep-&gt;id, rep-&gt;qd-&gt;owner-&gt;name,
			rrname(rep-&gt;qd-&gt;type, tname, sizeof tname),
			rep-&gt;qd, rep-&gt;an, rep-&gt;ns, rep-&gt;ar);

	len = convDNS2M(rep, &amp;buf[Udphdrsize], Maxdnspayload);
	len += Udphdrsize;
	if(write(fd, buf, len) != len)
		dnslog("error sending reply: %r");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

