<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/inform.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/inform.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* RFC2136 DNS inform - necessary for Win2k3 DNS servers */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ip.h&gt;
#include "dns.h"

enum {
	FQDNMAX	= 255,
};

char *errmsgs[] = {
	[0]  "ok",
	[1]  "request format error",
	[2]  "internal server error",
	[3]  "domain name does not exist",
	[4]  "request not supported",
	[5]  "permission denied",
	[6]  "domain name already exists",
	[7]  "resource record already exists",
	[8]  "resource record does not exist",
	[9]  "server not authoritative",
	[10] "domain name not in zone",
};

void
usage(void)
{
	fprint(2, "usage: %s [-x netmtpt]\n", argv0);
	exits("usage");
}

void
ding(void *, char *msg)
{
	if(strstr(msg, "alarm") != nil)
		noted(NCONT);
	noted(NDFLT);
}

int
g16(uchar **p)
{
	int n;

	n  = *(*p)++ &lt;&lt; 8;
	n |= *(*p)++;
	return n;
}

void
p16(uchar **p, int n)
{
	*(*p)++ = n &gt;&gt; 8;
	*(*p)++ = n;
}

void
p32(uchar **p, int n)
{
	*(*p)++ = n &gt;&gt; 24;
	*(*p)++ = n &gt;&gt; 16;
	*(*p)++ = n &gt;&gt; 8;
	*(*p)++ = n;
}

void
pmem(uchar **p, void *v, int len)
{
	memmove(*p, v, len);
	*p += len;
}

void
pname(uchar **p, char *s)
{
	uchar *len;

	while (*s){
		len = (*p)++;
		while(*s &amp;&amp; *s != '.')
			*(*p)++ = *s++;
		*len = *p - len - 1;
		if(*s == '.')
			s++;
	}
	*(*p)++ = 0;
}

void
main(int argc, char *argv[])
{
	int debug, len, fd;
	uint err;
	char *sysname, *dnsdomain, *dom, *inform, *ns, net[32];
	uchar *p, buf[4096], addr[IPv4addrlen], v6addr[IPaddrlen];
	ushort txid;
	Ndb *db;
	Ndbtuple *t, *tt;
	static char *query[] = { "dom", "dnsdomain", "ns", "inform" };

	fmtinstall('I', eipfmt);
	fmtinstall('V', eipfmt);
	setnetmtpt(net, sizeof net, nil);

	debug = 0;
	ns = nil;
	dom = nil;
	inform = nil;
	dnsdomain = nil;
	ARGBEGIN{
	case 'd':
		debug = 1;
		break;
	case 'x':
		setnetmtpt(net, sizeof net, EARGF(usage()));
		break;
	default:
		usage();
	}ARGEND;

	if(argc != 0)
		usage();

	if((sysname = getenv("sysname")) == nil)
		sysfatal("$sysname not set");

	if((db = ndbopen(nil)) == nil)
		sysfatal("can't open ndb: %r");
	tt = ndbipinfo(db, "sys", sysname, query, nelem(query));
	for(t = tt; t; t = t-&gt;entry){
		if(strcmp(t-&gt;attr, "ns") == 0)
			ns = t-&gt;val;
		else if(strcmp(t-&gt;attr, "dom") == 0)
			dom = t-&gt;val;
		else if(strcmp(t-&gt;attr, "dnsdomain") == 0)
			dnsdomain = t-&gt;val;
		else if(strcmp(t-&gt;attr, "inform") == 0)
			inform = t-&gt;val;
	}

	ndbfree(tt);
	ndbclose(db);

	if(inform)
		dom = inform;
	if(!ns)
		sysfatal("no relevant ns=");
	if(!dom)
		sysfatal("no relevant dom=");
	if(!dnsdomain)
		sysfatal("no relevant dnsdomain=");

	myipaddr(v6addr, net);
	memmove(addr, v6addr + IPaddrlen - IPv4addrlen, IPv4addrlen);

	if(debug){
		print("ip=%V\n", addr);
		print("ns=%s\n", ns);
		print("dnsdomain=%s\n", dnsdomain);
		print("dom=%s\n", dom);
	}

	if((fd = dial(netmkaddr(ns, "udp", "dns"), 0, 0, 0)) &lt; 0)
		sysfatal("can't dial %s: %r", ns);

	txid = time(nil) + getpid();

	p = buf;
	p16(&amp;p, txid);		/* ID */
	p16(&amp;p, 5&lt;&lt;11);		/* flags */
	p16(&amp;p, 1);		/* # Zones */
	p16(&amp;p, 0);		/* # prerequisites */
	p16(&amp;p, 2);		/* # updates */
	p16(&amp;p, 0);		/* # additionals */

        pname(&amp;p, dnsdomain);	/* zone */
	p16(&amp;p, Tsoa);		/* zone type */
	p16(&amp;p, Cin);		/* zone class */

	/* delete old name */
        pname(&amp;p, dom);		/* name */
	p16(&amp;p, Ta);		/* type: v4 addr */
	p16(&amp;p, Call);		/* class */
	p32(&amp;p, 0);		/* TTL */
	p16(&amp;p, 0);		/* data len */

	/* add new A record */
	pname(&amp;p, dom);		/* name */
	p16(&amp;p, Ta);		/* type: v4 addr */
	p16(&amp;p, Cin);		/* class */
	p32(&amp;p, 60*60*25);	/* TTL (25 hours) */
	p16(&amp;p, IPv4addrlen);	/* data len */
	pmem(&amp;p, addr, IPv4addrlen);	/* v4 address */

	len = p - buf;
	if(write(fd, buf, len) != len)
		sysfatal("write failed: %r");

	notify(ding);
	alarm(3000);
	do{
		if(read(fd, buf, sizeof buf) &lt; 0)
			sysfatal("timeout");
		p = buf;
	}while(g16(&amp;p) != txid);
	alarm(0);

	close(fd);

	err = g16(&amp;p) &amp; 7;
	if(err != 0 &amp;&amp; err != 7)	/* err==7 is just a "yes, I know" warning */
		if(err &lt; nelem(errmsgs))
			sysfatal("%s", errmsgs[err]);
		else
			sysfatal("unknown dns server error %d", err);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

