<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ndb/mkhosts.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ndb/mkhosts.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;ip.h&gt;

typedef struct x
{
	Ndbtuple *t;
	Ndbtuple *it;
	Ndbtuple *nt;
} X;

X x[4096];
int nx;
char *domname = "research.att.com";
int domnamlen;

char*
upper(char *x)
{
	char *p;
	int c;

	for(p = x; c = *p; p++)
		*p = toupper(c);
	return x;
}

void
printArecord(int fd, X *p)
{
	Ndbtuple *nt;
	char *c;
	char *dom = 0;
	char *curdom = 0;
	int i, cdlen = 0;
	int mxweight = 0;

	if(p-&gt;nt) {
		return;
	}
	for(nt=p-&gt;t; nt; nt = nt-&gt;entry) {
		/* we are only going to handle things in the specified domain */
		c = strchr(nt-&gt;val, '.');
		if (c==0 || strcmp(++c, domname)!=0)
			continue;
		i = c - nt-&gt;val - 1;
		if(strcmp(nt-&gt;attr, "dom") == 0) {
			curdom = nt-&gt;val;
			cdlen = i;
			if (dom == 0) {
				dom = curdom;
				fprint(fd, "%-.*s%.*s	IN A	%s\n", i, nt-&gt;val, 15-i, "               ", p-&gt;it-&gt;val);
			} else
				fprint(fd, "%-.*s%.*s	IN CNAME	%s.\n", i, nt-&gt;val, 15-i, "               ", dom);
		} else if(strcmp(nt-&gt;attr, "mx") == 0) {
			if (curdom != 0)
				fprint(fd, "%-.*s%.*s	MX	%d	%s.\n", cdlen, curdom, 15-cdlen, "               ", mxweight++, nt-&gt;val);
		}
	}
}

void
printentry(int fd, X *p)
{
	Ndbtuple *nt;

	if(p-&gt;nt)
		return;
	fprint(fd, "%s	", p-&gt;it-&gt;val);
	for(nt = p-&gt;t; nt; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "dom") == 0)
			fprint(fd, " %s", nt-&gt;val);
	for(nt = p-&gt;t; nt; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "sys") == 0)
			fprint(fd, " %s", nt-&gt;val);
	fprint(fd, "\n");
}

void
printsys(int fd, X *p)
{
	Ndbtuple *nt;

	for(nt = p-&gt;t; nt; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "dom") == 0)
			fprint(fd, "%s\n", nt-&gt;val);
}

void
printtxt(int fd, X *p)
{
	int i;
	Ndbtuple *nt;

	if(p-&gt;nt){
		for(;;){
			i = strlen(p-&gt;it-&gt;val);
			if(strcmp(p-&gt;it-&gt;val+i-2, ".0") == 0)
				p-&gt;it-&gt;val[i-2] = 0;
			else
				break;
		}
		fprint(fd, "\nNET : %s : %s\n", p-&gt;it-&gt;val, upper(p-&gt;nt-&gt;val));
		return;
	}
	fprint(fd, "HOST : %s :", p-&gt;it-&gt;val);
	i = 0;
	for(nt = p-&gt;t; nt; nt = nt-&gt;entry)
		if(strcmp(nt-&gt;attr, "dom") == 0){
			if(i++ == 0)
				fprint(fd, " %s", upper(nt-&gt;val));
			else
				fprint(fd, ", %s", upper(nt-&gt;val));
		}
	fprint(fd, "\n");
}

void
parse(char *file)
{
	int i;
	Ndb *db;
	Ndbtuple *t, *nt, *tt, *ipnett;
	char *p;

	db = ndbopen(file);
	if(db == 0)
		exits("no database");
	while(t = ndbparse(db)){
		for(nt = t; nt; nt = nt-&gt;entry){
			if(strcmp(nt-&gt;attr, "ip") == 0)
				break;
			if(strcmp(nt-&gt;attr, "flavor") == 0
			&amp;&amp; strcmp(nt-&gt;val, "console") == 0)
				return;
		}
		if(nt == 0){
			ndbfree(t);
			continue;
		}

		/* dump anything not on our nets */
		ipnett = 0;
		for(tt = t; tt; tt = tt-&gt;entry){
			if(strcmp(tt-&gt;attr, "ipnet") == 0){
				ipnett = tt;
				break;
			}
			if(strcmp(tt-&gt;attr, "dom") == 0){
				i = strlen(tt-&gt;val);
				p = tt-&gt;val+i-domnamlen;
				if(p &gt;= tt-&gt;val &amp;&amp; strcmp(p, domname) == 0)
					break;
			}
		}
		if(tt == 0){
			ndbfree(t);
			continue;
		}

		for(; nt; nt = nt-&gt;entry){
			if(strcmp(nt-&gt;attr, "ip") != 0)
				continue;
			x[nx].it = nt;
			x[nx].nt = ipnett;
			x[nx++].t = t;
		}
	}
}

void
main(int argc, char *argv[])
{
	int i, fd;
	char fn[128];

	if (argc&gt;1)
		domname = argv[1];
	domnamlen = strlen(domname);
	if(argc &gt; 2){
		for(i = 2; i &lt; argc; i++)
			parse(argv[i]);
	} else {
		parse("/lib/ndb/local");
		parse("/lib/ndb/friends");
	}
	
//	sprint(fn, "/lib/ndb/hosts.%-.21s", domname);
//	fd = create(fn, OWRITE, 0664);
//	if(fd &lt; 0){
//		fprint(2, "can't create %s: %r\n", fn);
//		exits("boom");
//	}
//	for(i = 0; i &lt; nx; i++)
//		printentry(fd, &amp;x[i]);
//	close(fd);
//

	sprint(fn, "/lib/ndb/db.%-.24s", domname);
	fd = create(fn, OWRITE, 0664);
	if(fd &lt; 0){
		fprint(2, "can't create %s: %r\n", fn);
		exits("boom");
	}
	fprint(fd, "; This file is generated automatically, do not edit!\n");
	for(i = 0; i &lt; nx; i++)
		printArecord(fd, &amp;x[i]);
	close(fd);

	sprint(fn, "/lib/ndb/equiv.%-.21s", domname);
	fd = create(fn, OWRITE, 0664);
	if(fd &lt; 0){
		fprint(2, "can't create %s: %r\n", fn);
		exits("boom");
	}
	for(i = 0; i &lt; nx; i++)
		printsys(fd, &amp;x[i]);
	close(fd);

	sprint(fn, "/lib/ndb/txt.%-.23s", domname);
	fd = create(fn, OWRITE, 0664);
	if(fd &lt; 0){
		fprint(2, "can't create %s: %r\n", fn);
		exits("boom");
	}
	for(i = 0; i &lt; nx; i++)
		printtxt(fd, &amp;x[i]);
	close(fd);

	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

