<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/netstat.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/netstat.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ip.h&gt;
#include &lt;ndb.h&gt;

void	pip(char*, Dir*);
void	nstat(char*, void (*)(char*, Dir*));
void	pipifc(void);

Biobuf	out;
char	*netroot;
char *proto[20];
int nproto;
int	notrans;

void
usage(void)
{
	fprint(2, "usage: %s [-in] [-p proto] [network-dir]\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	int justinterfaces = 0;
	int i, tot, fd;
	Dir *d;
	char buf[128];

	ARGBEGIN{
	case 'i':
		justinterfaces = 1;
		break;
	case 'n':
		notrans = 1;
		break;
	case 'p':
		if(nproto &gt;= nelem(proto))
			sysfatal("too many protos");
		proto[nproto++] = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND;

	netroot = "/net";
	switch(argc){
	case 0:
		break;
	case 1:
		netroot = argv[0];
		break;
	default:
		usage();
	}

	Binit(&amp;out, 1, OWRITE);

	if(justinterfaces){
		pipifc();
		exits(0);
	}

	if(nproto){
		for(i=0; i&lt;nproto; i++)
			nstat(proto[i], pip);
	}else{
		fd = open(netroot, OREAD);
		if(fd &lt; 0)
			sysfatal("open %s: %r", netroot);

		tot = dirreadall(fd, &amp;d);
		for(i=0; i&lt;tot; i++){
			if(strcmp(d[i].name, "ipifc") == 0)
				continue;
			snprint(buf, sizeof buf, "%s/%s/0/local", netroot, d[i].name);
			if(access(buf, 0) &gt;= 0)
				nstat(d[i].name, pip);
		}
	}
	exits(0);
}

void
nstat(char *net, void (*f)(char*, Dir*))
{
	int fdir, i, tot;
	Dir *dir;
	char buf[128];

	snprint(buf, sizeof buf, "%s/%s", netroot, net);
	fdir = open(buf, OREAD);
	if(fdir &lt; 0)
		return;

	tot = dirreadall(fdir, &amp;dir);
	for(i = 0; i &lt; tot; i++) {
		(*f)(net, &amp;dir[i]);
		Bflush(&amp;out);
	}
	free(dir);
	close(fdir);
}

char*
getport(char *net, char *p)
{
	static char port[10];

	strncpy(port, p, sizeof(port)-1);
	port[sizeof(port)-1] = 0;
	if(notrans || (p = csgetvalue(netroot, "port", p, net, nil)) == nil)
		return port;
	strncpy(port, p, sizeof(port)-1);
	port[sizeof(port)-1] = 0;
	free(p);
	return port;
}

void
pip(char *net, Dir *db)
{
	int n, fd;
	char buf[128], *p;
	char *dname;

	if(strcmp(db-&gt;name, "clone") == 0)
		return;
	if(strcmp(db-&gt;name, "stats") == 0)
		return;

	snprint(buf, sizeof buf, "%s/%s/%s/status", netroot, net, db-&gt;name);
	fd = open(buf, OREAD);
	if(fd &lt; 0)
		return;
	n = read(fd, buf, sizeof(buf));
	close(fd);
	if(n &lt; 0)
		return;
	buf[n] = 0;

	p = strchr(buf, ' ');
	if(p != 0)
		*p = 0;
	p = strrchr(buf, '\n');
	if(p != 0)
		*p = 0;
	Bprint(&amp;out, "%-4s %-4s %-10s %-12s ", net, db-&gt;name, db-&gt;uid, buf);

	snprint(buf, sizeof buf, "%s/%s/%s/local", netroot, net, db-&gt;name);
	fd = open(buf, OREAD);
	if(fd &lt; 0) {
		Bprint(&amp;out, "\n");
		return;
	}
	n = read(fd, buf, sizeof(buf));
	close(fd);
	if(n &lt; 0) {
		Bprint(&amp;out, "\n");
		return;
	}
	buf[n-1] = 0;
	p = strchr(buf, '!');
	if(p == 0) {
		Bprint(&amp;out, "\n");
		return;
	}
	*p = '\0';
	Bprint(&amp;out, "%-10s ", getport(net, p+1));

	snprint(buf, sizeof buf, "%s/%s/%s/remote", netroot, net, db-&gt;name);
	fd = open(buf, OREAD);
	if(fd &lt; 0) {
		print("\n");
		return;
	}
	n = read(fd, buf, sizeof(buf));
	close(fd);
	if(n &lt; 0) {
		print("\n");
		return;
	}
	buf[n-1] = 0;
	p = strchr(buf, '!');
	if(p != nil)
		*p++ = '\0';

	if(notrans){
		Bprint(&amp;out, "%-10s %s\n", getport(net, p), buf);
		return;
	}
	dname = csgetvalue(netroot, "ip", buf, "dom", nil);
	if(dname == nil) {
		Bprint(&amp;out, "%-10s %s\n", getport(net, p), buf);
		return;
	}
	Bprint(&amp;out, "%-10s %s\n", getport(net, p), dname);
	Bflush(&amp;out);
	free(dname);
}

void
pipifc(void)
{
	Ipifc *ip, *nip;
	Iplifc *lifc;
	char buf[100];
	int l, i;

	fmtinstall('I', eipfmt);
	fmtinstall('M', eipfmt);

	ip = readipifc(netroot, nil, -1);

	l = 7;
	for(nip = ip; nip; nip = nip-&gt;next){
		for(lifc = nip-&gt;lifc; lifc; lifc = lifc-&gt;next){
			i = snprint(buf, sizeof buf, "%I", lifc-&gt;ip);
			if(i &gt; l)
				l = i;
			i = snprint(buf, sizeof buf, "%I", lifc-&gt;net);
			if(i &gt; l)
				l = i;
		}
	}

	for(nip = ip; nip; nip = nip-&gt;next){
		for(lifc = nip-&gt;lifc; lifc; lifc = lifc-&gt;next)
			Bprint(&amp;out, "%-12s %5d %-*I %5M %-*I %8lud %8lud %8lud %8lud\n",
				nip-&gt;dev, nip-&gt;mtu, 
				l, lifc-&gt;ip, lifc-&gt;mask, l, lifc-&gt;net,
				nip-&gt;pktin, nip-&gt;pktout,
				nip-&gt;errin, nip-&gt;errout);
	}
	Bflush(&amp;out);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

