<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/nfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/nfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* Copyright © 2003 Russ Cox, MIT; see /sys/src/libsunrpc/COPYING */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;sunrpc.h&gt;
#include &lt;nfs3.h&gt;

SunClient *nfscli;
SunClient *mntcli;
char *defaultpath = "/";
Channel *fschan;
char *sys;
int verbose;
int readplus = 0;


typedef struct Auth Auth;
struct Auth
{
	int ref;
	uchar *data;
	int ndata;
};

typedef struct FidAux FidAux;
struct FidAux
{
	Nfs3Handle handle;

	u64int cookie;	/* for continuing directory reads */
	char *name;	/* botch: for remove and rename */
	Nfs3Handle parent;	/* botch: for remove and rename */
	char err[ERRMAX];	/* for walk1 */
	Auth *auth;
};

/*
 * various RPCs.  here is where we'd insert support for NFS v2
 */

void
portCall(SunCall *c, PortCallType type)
{
	c-&gt;rpc.prog = PortProgram;
	c-&gt;rpc.vers = PortVersion;
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.iscall = !(type&amp;1);
	c-&gt;type = type;
}

int
getport(SunClient *client, uint prog, uint vers, uint prot, uint *port)
{
	PortTGetport tx;
	PortRGetport rx;

	memset(&amp;tx, 0, sizeof tx);
	portCall(&amp;tx.call, PortCallTGetport);
	tx.map.prog = prog;
	tx.map.vers = vers;
	tx.map.prot = prot;

	memset(&amp;rx, 0, sizeof rx);
	portCall(&amp;rx.call, PortCallRGetport);

	if(sunClientRpc(client, 0, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	*port = rx.port;
	return 0;
}

void
mountCall(Auth *a, SunCall *c, NfsMount3CallType type)
{
	c-&gt;rpc.iscall = !(type&amp;1);
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.prog = NfsMount3Program;
	c-&gt;rpc.vers = NfsMount3Version;
	if(c-&gt;rpc.iscall &amp;&amp; a){
		c-&gt;rpc.cred.flavor = SunAuthSys;
		c-&gt;rpc.cred.data = a-&gt;data;
		c-&gt;rpc.cred.ndata = a-&gt;ndata;
	}
	c-&gt;type = type;
}

int
mountNull(ulong tag)
{
	NfsMount3TNull tx;
	NfsMount3RNull rx;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(nil, &amp;tx.call, NfsMount3CallTNull);

	memset(&amp;rx, 0, sizeof rx);
	mountCall(nil, &amp;rx.call, NfsMount3CallTNull);

	return sunClientRpc(mntcli, tag, &amp;tx.call, &amp;rx.call, nil);
}

int
mountMnt(Auth *a, ulong tag, char *path, Nfs3Handle *h)
{
	uchar *freeme;
	NfsMount3TMnt tx;
	NfsMount3RMnt rx;

	memset(&amp;tx, 0, sizeof tx);
	mountCall(a, &amp;tx.call, NfsMount3CallTMnt);
	tx.path = path;

	memset(&amp;rx, 0, sizeof rx);
	mountCall(a, &amp;rx.call, NfsMount3CallRMnt);
	if(sunClientRpc(mntcli, tag, &amp;tx.call, &amp;rx.call, &amp;freeme) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
if(verbose)print("handle %.*H\n", rx.len, rx.handle);
	if(rx.len &gt;= Nfs3MaxHandleSize){
		free(freeme);
		werrstr("server-returned handle too long");
		return -1;
	}
	memmove(h-&gt;h, rx.handle, rx.len);
	h-&gt;len = rx.len;
	free(freeme);
	return 0;
}

void
nfs3Call(Auth *a, SunCall *c, Nfs3CallType type)
{
	c-&gt;rpc.iscall = !(type&amp;1);
	c-&gt;rpc.proc = type&gt;&gt;1;
	c-&gt;rpc.prog = Nfs3Program;
	c-&gt;rpc.vers = Nfs3Version;
	if(c-&gt;rpc.iscall &amp;&amp; a){
		c-&gt;rpc.cred.flavor = SunAuthSys;
		c-&gt;rpc.cred.data = a-&gt;data;
		c-&gt;rpc.cred.ndata = a-&gt;ndata;
	}
	c-&gt;type = type;
}

int
nfsNull(ulong tag)
{
	Nfs3TNull tx;
	Nfs3RNull rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(nil, &amp;tx.call, Nfs3CallTNull);

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(nil, &amp;rx.call, Nfs3CallTNull);

	return sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil);
}

int
nfsGetattr(Auth *a, ulong tag, Nfs3Handle *h, Nfs3Attr *attr)
{
	Nfs3TGetattr tx;
	Nfs3RGetattr rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTGetattr);
	tx.handle = *h;	

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRGetattr);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}

	*attr = rx.attr;
	return 0;
}

int
nfsAccess(Auth *a, ulong tag, Nfs3Handle *h, ulong want, ulong *got, u1int *have, Nfs3Attr *attr)
{
	Nfs3TAccess tx;
	Nfs3RAccess rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTAccess);
	tx.handle = *h;
	tx.access = want;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRAccess);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}

	*got = rx.access;

	*have = rx.haveAttr;
	if(rx.haveAttr)
		*attr = rx.attr;
	return 0;
}

int
nfsMkdir(Auth *a, ulong tag, Nfs3Handle *h, char *name, Nfs3Handle *nh, ulong mode, uint gid,
	u1int *have, Nfs3Attr *attr)
{
	Nfs3TMkdir tx;
	Nfs3RMkdir rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTMkdir);
	tx.handle = *h;
	tx.name = name;
	tx.attr.setMode = 1;
	tx.attr.mode = mode;
	tx.attr.setGid = 1;
	tx.attr.gid = gid;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRMkdir);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}

	if(!rx.haveHandle){
		werrstr("nfs mkdir did not return handle");
		return -1;
	}
	*nh = rx.handle;

	*have = rx.haveAttr;
	if(rx.haveAttr)
		*attr = rx.attr;
	return 0;
}

int
nfsCreate(Auth *a, ulong tag, Nfs3Handle *h, char *name, Nfs3Handle *nh, ulong mode, uint gid,
	u1int *have, Nfs3Attr *attr)
{
	Nfs3TCreate tx;
	Nfs3RCreate rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTCreate);
	tx.handle = *h;
	tx.name = name;
	tx.attr.setMode = 1;
	tx.attr.mode = mode;
	tx.attr.setGid = 1;
	tx.attr.gid = gid;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRCreate);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}

	if(!rx.haveHandle){
		werrstr("nfs create did not return handle");
		return -1;
	}
	*nh = rx.handle;

	*have = rx.haveAttr;
	if(rx.haveAttr)
		*attr = rx.attr;
	return 0;
}

int
nfsRead(Auth *a, ulong tag, Nfs3Handle *h, u32int count, u64int offset,
	uchar **pp, u32int *pcount, uchar **pfreeme)
{
	uchar *freeme;
	Nfs3TRead tx;
	Nfs3RRead rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTRead);
	tx.handle = *h;
	tx.count = count;
	tx.offset = offset;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRRead);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, &amp;freeme) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	if(rx.count != rx.ndata){
		werrstr("nfs read returned count=%ud ndata=%ud", (uint)rx.count, (uint)rx.ndata);
		free(freeme);
		return -1;
	}
	*pfreeme = freeme;
	*pcount = rx.count;
	*pp = rx.data;
	return 0;
}

int
nfsWrite(Auth *a, ulong tag, Nfs3Handle *h, uchar *data, u32int count, u64int offset, u32int *pcount)
{
	Nfs3TWrite tx;
	Nfs3RWrite rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTWrite);
	tx.handle = *h;
	tx.count = count;
	tx.offset = offset;
	tx.data = data;
	tx.ndata = count;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRWrite);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}

	*pcount = rx.count;
	return 0;
}

int
nfsRmdir(Auth *a, ulong tag, Nfs3Handle *h, char *name)
{
	Nfs3TRmdir tx;
	Nfs3RRmdir rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTRmdir);
	tx.handle = *h;
	tx.name = name;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRRmdir);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	return 0;
}

int
nfsRemove(Auth *a, ulong tag, Nfs3Handle *h, char *name)
{
	Nfs3TRemove tx;
	Nfs3RRemove rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTRemove);
	tx.handle = *h;
	tx.name = name;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRRemove);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	return 0;
}

int
nfsRename(Auth *a, ulong tag, Nfs3Handle *h, char *name, Nfs3Handle *th, char *tname)
{
	Nfs3TRename tx;
	Nfs3RRename rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTRename);
	tx.from.handle = *h;
	tx.from.name = name;
	tx.to.handle = *th;
	tx.to.name = tname;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRRename);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	return 0;
}

int
nfsSetattr(Auth *a, ulong tag, Nfs3Handle *h, Nfs3SetAttr *attr)
{
	Nfs3TSetattr tx;
	Nfs3RSetattr rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTSetattr);
	tx.handle = *h;
	tx.attr = *attr;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRSetattr);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	return 0;
}

int
nfsCommit(Auth *a, ulong tag, Nfs3Handle *h)
{
	Nfs3TCommit tx;
	Nfs3RCommit rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTCommit);
	tx.handle = *h;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRCommit);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;

	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	return 0;
}

int
nfsLookup(Auth *a, ulong tag, Nfs3Handle *h, char *name, Nfs3Handle *nh, u1int *have, Nfs3Attr *attr)
{
	Nfs3TLookup tx;
	Nfs3RLookup rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTLookup);
	tx.handle = *h;
	tx.name = name;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRLookup);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, nil) &lt; 0)
		return -1;

	if(rx.status != Nfs3Ok){
		nfs3Errstr(rx.status);
		return -1;
	}
	*nh = rx.handle;
	*have = rx.haveAttr;
	if(rx.haveAttr)
		*attr = rx.attr;
	return 0;
}

int
nfsReadDirPlus(Auth *a, ulong tag, Nfs3Handle *h, u32int count, u64int cookie, uchar **pp,
	u32int *pcount, int (**unpack)(uchar*, uchar*, uchar**, Nfs3Entry*), uchar **pfreeme)
{
	Nfs3TReadDirPlus tx;
	Nfs3RReadDirPlus rx;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTReadDirPlus);
	tx.handle = *h;
	tx.maxCount = count;
	tx.dirCount = 1000;
	tx.cookie = cookie;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRReadDirPlus);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, pfreeme) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		free(*pfreeme);
		*pfreeme = 0;
		nfs3Errstr(rx.status);
		return -1;
	}

	*unpack = nfs3EntryPlusUnpack;
	*pcount = rx.count;
	*pp = rx.data;
	return 0;
}

int
nfsReadDir(Auth *a, ulong tag, Nfs3Handle *h, u32int count, u64int cookie, uchar **pp,
	u32int *pcount, int (**unpack)(uchar*, uchar*, uchar**, Nfs3Entry*), uchar **pfreeme)
{
	/* BUG: try readdirplus */
	char e[ERRMAX];
	Nfs3TReadDir tx;
	Nfs3RReadDir rx;

	if(readplus!=-1){
		if(nfsReadDirPlus(a, tag, h, count, cookie, pp, pcount, unpack, pfreeme) == 0){
			readplus = 1;
			return 0;
		}
		if(readplus == 0){
			rerrstr(e, sizeof e);
			if(strstr(e, "procedure unavailable") || strstr(e, "not supported"))
				readplus = -1;
		}
		if(readplus == 0)
			fprint(2, "readdirplus: %r\n");
	}
	if(readplus == 1)
		return -1;

	memset(&amp;tx, 0, sizeof tx);
	nfs3Call(a, &amp;tx.call, Nfs3CallTReadDir);
	tx.handle = *h;
	tx.count = count;
	tx.cookie = cookie;

	memset(&amp;rx, 0, sizeof rx);
	nfs3Call(a, &amp;rx.call, Nfs3CallRReadDir);

	if(sunClientRpc(nfscli, tag, &amp;tx.call, &amp;rx.call, pfreeme) &lt; 0)
		return -1;
	if(rx.status != Nfs3Ok){
		free(*pfreeme);
		*pfreeme = 0;
		nfs3Errstr(rx.status);
		return -1;
	}

	/* readplus failed but read succeeded */
	readplus = -1;

	*unpack = nfs3EntryUnpack;
	*pcount = rx.count;
	*pp = rx.data;
	return 0;
}

/*
 * name &lt;-&gt; int translation
 */
typedef struct Map Map;
typedef struct User User;
typedef struct Group Group;

Map *map;
Map emptymap;

struct User
{
	char *name;
	uint uid;
	uint gid;
	uint g[16];
	uint ng;
	uchar *auth;
	int nauth;
};

struct Group
{
	char *name;	/* same pos as in User struct */
	uint gid;	/* same pos as in User struct */
};

struct Map
{
	int nuser;
	int ngroup;
	User *user;
	User **ubyname;
	User **ubyid;
	Group *group;
	Group **gbyname;
	Group **gbyid;
};

User*
finduser(User **u, int nu, char *s)
{
	int lo, hi, mid, n;

	hi = nu;
	lo = 0;
	while(hi &gt; lo){
		mid = (lo+hi)/2;
		n = strcmp(u[mid]-&gt;name, s);
		if(n == 0)
			return u[mid];
		if(n &lt; 0)
			lo = mid+1;
		else
			hi = mid;
	}
	return nil;
}

int
strtoid(User **u, int nu, char *s, u32int *id)
{
	u32int x;
	char *p;
	User *uu;

	x = strtoul(s, &amp;p, 10);
	if(*s != 0 &amp;&amp; *p == 0){
		*id = x;
		return 0;
	}

	uu = finduser(u, nu, s);
	if(uu == nil)
		return -1;
	*id = uu-&gt;uid;
	return 0;
}

char*
idtostr(User **u, int nu, u32int id)
{
	char buf[32];
	int lo, hi, mid;

	hi = nu;
	lo = 0;
	while(hi &gt; lo){
		mid = (lo+hi)/2;
		if(u[mid]-&gt;uid == id)
			return estrdup9p(u[mid]-&gt;name);
		if(u[mid]-&gt;uid &lt; id)
			lo = mid+1;
		else
			hi = mid;
	}
	snprint(buf, sizeof buf, "%ud", id);	
	return estrdup9p(buf);
}		
char*
uidtostr(u32int uid)
{
	return idtostr(map-&gt;ubyid, map-&gt;nuser, uid);
}

char*
gidtostr(u32int gid)
{
	return idtostr((User**)map-&gt;gbyid, map-&gt;ngroup, gid);
}

int
strtouid(char *s, u32int *id)
{
	return strtoid(map-&gt;ubyname, map-&gt;nuser, s, id);
}

int
strtogid(char *s, u32int *id)
{
	return strtoid((User**)map-&gt;gbyid, map-&gt;ngroup, s, id);
}


int
idcmp(const void *va, const void *vb)
{
	User **a, **b;

	a = (User**)va;
	b = (User**)vb;
	return (*a)-&gt;uid - (*b)-&gt;uid;
}

int
namecmp(const void *va, const void *vb)
{
	User **a, **b;

	a = (User**)va;
	b = (User**)vb;
	return strcmp((*a)-&gt;name, (*b)-&gt;name);
}

void
closemap(Map *m)
{
	int i;

	for(i=0; i&lt;m-&gt;nuser; i++){
		free(m-&gt;user[i].name);
		free(m-&gt;user[i].auth);
	}
	for(i=0; i&lt;m-&gt;ngroup; i++)
		free(m-&gt;group[i].name);
	free(m-&gt;user);
	free(m-&gt;group);
	free(m-&gt;ubyid);
	free(m-&gt;ubyname);
	free(m-&gt;gbyid);
	free(m-&gt;gbyname);
	free(m);
}

Map*
readmap(char *passwd, char *group)
{
	char *s, *f[10], *p, *nextp, *name;
	uchar *q, *eq;
	int i, n, nf, line, uid, gid;
	Biobuf *b;
	Map *m;
	User *u;
	Group *g;
	SunAuthUnix au;

	m = emalloc(sizeof(Map));

	if((b = Bopen(passwd, OREAD)) == nil){
		free(m);
		return nil;
	}
	line = 0;
	for(; (s = Brdstr(b, '\n', 1)) != nil; free(s)){
		line++;
		if(s[0] == '#')
			continue;
		nf = getfields(s, f, nelem(f), 0, ":");
		if(nf &lt; 4)
			continue;
		name = f[0];
		uid = strtol(f[2], &amp;p, 10);
		if(f[2][0] == 0 || *p != 0){
			fprint(2, "%s:%d: non-numeric id in third field\n", passwd, line);
			continue;
		}
		gid = strtol(f[3], &amp;p, 10);
		if(f[3][0] == 0 || *p != 0){
			fprint(2, "%s:%d: non-numeric id in fourth field\n", passwd, line);
			continue;
		}
		if(m-&gt;nuser%32 == 0)
			m-&gt;user = erealloc(m-&gt;user, (m-&gt;nuser+32)*sizeof(m-&gt;user[0]));
		u = &amp;m-&gt;user[m-&gt;nuser++];
		u-&gt;name = estrdup9p(name);
		u-&gt;uid = uid;
		u-&gt;gid = gid;
		u-&gt;ng = 0;
		u-&gt;auth = 0;
		u-&gt;nauth = 0;
	}
	Bterm(b);
	m-&gt;ubyname = emalloc(m-&gt;nuser*sizeof(User*));
	m-&gt;ubyid = emalloc(m-&gt;nuser*sizeof(User*));
	for(i=0; i&lt;m-&gt;nuser; i++){
		m-&gt;ubyname[i] = &amp;m-&gt;user[i];
		m-&gt;ubyid[i] = &amp;m-&gt;user[i];
	}
	qsort(m-&gt;ubyname, m-&gt;nuser, sizeof(m-&gt;ubyname[0]), namecmp);
	qsort(m-&gt;ubyid, m-&gt;nuser, sizeof(m-&gt;ubyid[0]), idcmp);

	if((b = Bopen(group, OREAD)) == nil){
		closemap(m);
		return nil;
	}
	line = 0;
	for(; (s = Brdstr(b, '\n', 1)) != nil; free(s)){
		line++;
		if(s[0] == '#')
			continue;
		nf = getfields(s, f, nelem(f), 0, ":");
		if(nf &lt; 4)
			continue;
		name = f[0];
		gid = strtol(f[2], &amp;p, 10);
		if(f[2][0] == 0 || *p != 0){
			fprint(2, "%s:%d: non-numeric id in third field\n", group, line);
			continue;
		}
		if(m-&gt;ngroup%32 == 0)
			m-&gt;group = erealloc(m-&gt;group, (m-&gt;ngroup+32)*sizeof(m-&gt;group[0]));
		g = &amp;m-&gt;group[m-&gt;ngroup++];
		g-&gt;name = estrdup9p(name);
		g-&gt;gid = gid;

		for(p=f[3]; *p; p=nextp){
			if((nextp = strchr(p, ',')) != nil)
				*nextp++ = 0;
			else
				nextp = p+strlen(p);
			u = finduser(m-&gt;ubyname, m-&gt;nuser, p);
			if(u == nil){
				if(verbose)
					fprint(2, "%s:%d: unknown user %s\n", group, line, p);
				continue;
			}
			if(u-&gt;ng &gt;= nelem(u-&gt;g)){
				fprint(2, "%s:%d: user %s is in too many groups; ignoring %s\n", group, line, p, name);
				continue;
			}
			u-&gt;g[u-&gt;ng++] = gid;
		}
	}
	Bterm(b);
	m-&gt;gbyname = emalloc(m-&gt;ngroup*sizeof(Group*));
	m-&gt;gbyid = emalloc(m-&gt;ngroup*sizeof(Group*));
	for(i=0; i&lt;m-&gt;ngroup; i++){
		m-&gt;gbyname[i] = &amp;m-&gt;group[i];
		m-&gt;gbyid[i] = &amp;m-&gt;group[i];
	}
	qsort(m-&gt;gbyname, m-&gt;ngroup, sizeof(m-&gt;gbyname[0]), namecmp);
	qsort(m-&gt;gbyid, m-&gt;ngroup, sizeof(m-&gt;gbyid[0]), idcmp);

	for(i=0; i&lt;m-&gt;nuser; i++){
		au.stamp = 0;
		au.sysname = sys;
		au.uid = m-&gt;user[i].uid;
		au.gid = m-&gt;user[i].gid;
		memmove(au.g, m-&gt;user[i].g, sizeof au.g);
		au.ng = m-&gt;user[i].ng;
		n = sunAuthUnixSize(&amp;au);
		q = emalloc(n);
		eq = q+n;
		m-&gt;user[i].auth = q;
		m-&gt;user[i].nauth = n;
		if(sunAuthUnixPack(q, eq, &amp;q, &amp;au) &lt; 0 || q != eq){
			fprint(2, "sunAuthUnixPack failed for %s\n", m-&gt;user[i].name);
			free(m-&gt;user[i].auth);
			m-&gt;user[i].auth = 0;
			m-&gt;user[i].nauth = 0;
		}
	}

	return m;
}

Auth*
mkauth(char *user)
{
	Auth *a;
	uchar *p;
	int n;
	SunAuthUnix au;
	User *u;

	u = finduser(map-&gt;ubyname, map-&gt;nuser, user);
	if(u == nil || u-&gt;nauth == 0){
		/* nobody */
		au.stamp = 0;
		au.uid = -1;
		au.gid = -1;
		au.ng = 0;
		au.sysname = sys;
		n = sunAuthUnixSize(&amp;au);
		a = emalloc(sizeof(Auth)+n);
		a-&gt;data = (uchar*)&amp;a[1];
		a-&gt;ndata = n;
		if(sunAuthUnixPack(a-&gt;data, a-&gt;data+a-&gt;ndata, &amp;p, &amp;au) &lt; 0
		|| p != a-&gt;data+a-&gt;ndata){
			free(a);
			return nil;
		}
		a-&gt;ref = 1;
if(verbose)print("creds for %s: %.*H\n", user, a-&gt;ndata, a-&gt;data);
		return a;
	}

	a = emalloc(sizeof(Auth)+u-&gt;nauth);
	a-&gt;data = (uchar*)&amp;a[1];
	a-&gt;ndata = u-&gt;nauth;
	memmove(a-&gt;data, u-&gt;auth, a-&gt;ndata);
	a-&gt;ref = 1;
if(verbose)print("creds for %s: %.*H\n", user, a-&gt;ndata, a-&gt;data);
	return a;
}

void
freeauth(Auth *a)
{
	if(--a-&gt;ref &gt; 0)
		return;
	free(a);
}

/*
 * 9P server
 */
void
responderrstr(Req *r)
{
	char e[ERRMAX];

	rerrstr(e, sizeof e);
	respond(r, e);
}

void
fsdestroyfid(Fid *fid)
{
	FidAux *aux;

	aux = fid-&gt;aux;
	if(aux == nil)
		return;
	freeauth(aux-&gt;auth);
	free(aux-&gt;name);
	free(aux);
}

void
attrToQid(Nfs3Attr *attr, Qid *qid)
{
	qid-&gt;path = attr-&gt;fileid;
	qid-&gt;vers = attr-&gt;mtime.sec;
	qid-&gt;type = 0;
	if(attr-&gt;type == Nfs3FileDir)
		qid-&gt;type |= QTDIR;
}

void
attrToDir(Nfs3Attr *attr, Dir *d)
{
	d-&gt;mode = attr-&gt;mode &amp; 0777;
	if(attr-&gt;type == Nfs3FileDir)
		d-&gt;mode |= DMDIR;
	d-&gt;uid = uidtostr(attr-&gt;uid);
	d-&gt;gid = gidtostr(attr-&gt;gid);
	d-&gt;length = attr-&gt;size;
	attrToQid(attr, &amp;d-&gt;qid);
	d-&gt;mtime = attr-&gt;mtime.sec;
	d-&gt;atime = attr-&gt;atime.sec;
	d-&gt;muid = nil;
}

void
fsattach(Req *r)
{
	char *path;
	Auth *auth;
	FidAux *aux;
	Nfs3Attr attr;
	Nfs3Handle h;

	path = r-&gt;ifcall.aname;
	if(path==nil || path[0]==0)
		path = defaultpath;

	auth = mkauth(r-&gt;ifcall.uname);

	if(mountMnt(auth, r-&gt;tag, path, &amp;h) &lt; 0
	|| nfsGetattr(auth, r-&gt;tag, &amp;h, &amp;attr) &lt; 0){
		freeauth(auth);
		responderrstr(r);
		return;
	}

	aux = emalloc(sizeof(FidAux));
	aux-&gt;auth = auth;
	aux-&gt;handle = h;
	aux-&gt;cookie = 0;
	aux-&gt;name = nil;
	memset(&amp;aux-&gt;parent, 0, sizeof aux-&gt;parent);
	r-&gt;fid-&gt;aux = aux;
	attrToQid(&amp;attr, &amp;r-&gt;fid-&gt;qid);
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

void
fsopen(Req *r)
{
	FidAux *aux;
	Nfs3Attr attr;
	Nfs3SetAttr sa;
	u1int have;
	ulong a, b;

	aux = r-&gt;fid-&gt;aux;
	a = 0;
	switch(r-&gt;ifcall.mode&amp;OMASK){
	case OREAD:
		a = 0x0001;
		break;
	case OWRITE:
		a = 0x0004;
		break;
	case ORDWR:
		a = 0x0001|0x0004;
		break;
	case OEXEC:
		a = 0x20;
		break;
	}
	if(r-&gt;ifcall.mode&amp;OTRUNC)
		a |= 0x0004;

	if(nfsAccess(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, a, &amp;b, &amp;have, &amp;attr) &lt; 0
	|| (!have &amp;&amp; nfsGetattr(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, &amp;attr) &lt; 0)){
    Error:
		responderrstr(r);
		return;
	}
	if(a != b){
		respond(r, "permission denied");
		return;
	}
	if(r-&gt;ifcall.mode&amp;OTRUNC){
		memset(&amp;sa, 0, sizeof sa);
		sa.setSize = 1;
		if(nfsSetattr(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, &amp;sa) &lt; 0)
			goto Error;
	}
	attrToQid(&amp;attr, &amp;r-&gt;fid-&gt;qid);
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

void
fscreate(Req *r)
{
	FidAux *aux;
	u1int have;
	Nfs3Attr attr;
	Nfs3Handle h;
	ulong mode;
	uint gid;
	int (*mk)(Auth*, ulong, Nfs3Handle*, char*, Nfs3Handle*, ulong, uint, u1int*, Nfs3Attr*);

	aux = r-&gt;fid-&gt;aux;

	/*
	 * Plan 9 has no umask, so let's use the
	 * parent directory bits like Plan 9 does.
	 * What the heck, let's inherit the group too.
	 * (Unix will let us set the group to anything
	 * since we're the owner!)
	 */
	if(nfsGetattr(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, &amp;attr) &lt; 0){
		responderrstr(r);
		return;
	}
	mode = r-&gt;ifcall.perm&amp;0777;
	if(r-&gt;ifcall.perm&amp;DMDIR)
		mode &amp;= (attr.mode&amp;0666) | ~0666;
	else
		mode &amp;= (attr.mode&amp;0777) | ~0777;
	gid = attr.gid;

	if(r-&gt;ifcall.perm&amp;DMDIR)
		mk = nfsMkdir;
	else
		mk = nfsCreate;

	if((*mk)(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, r-&gt;ifcall.name, &amp;h, mode, gid, &amp;have, &amp;attr) &lt; 0
	|| (!have &amp;&amp; nfsGetattr(aux-&gt;auth, r-&gt;tag, &amp;h, &amp;attr) &lt; 0)){
		responderrstr(r);
		return;
	}
	attrToQid(&amp;attr, &amp;r-&gt;fid-&gt;qid);
	aux-&gt;parent = aux-&gt;handle;
	aux-&gt;handle = h;
	free(aux-&gt;name);
	aux-&gt;name = estrdup9p(r-&gt;ifcall.name);
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

void
fsreaddir(Req *r)
{
	FidAux *aux;
	uchar *p, *freeme, *ep, *p9, *ep9;
	char *s;
	uint count;
	int n, (*unpack)(uchar*, uchar*, uchar**, Nfs3Entry*);
	Nfs3Entry e;
	u64int cookie;
	Dir d;

	aux = r-&gt;fid-&gt;aux;
	/*
	 * r-&gt;ifcall.count seems a reasonable estimate to
	 * how much NFS entry data we want.  is it?
	 */
	if(r-&gt;ifcall.offset)
		cookie = aux-&gt;cookie;
	else
		cookie = 0;
	if(nfsReadDir(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, r-&gt;ifcall.count, cookie,
		&amp;p, &amp;count, &amp;unpack, &amp;freeme) &lt; 0){
		responderrstr(r);
		return;
	}
	ep = p+count;

	p9 = (uchar*)r-&gt;ofcall.data;
	ep9 = p9+r-&gt;ifcall.count;

	/*
	 * BUG: Issue all of the stat requests in parallel.
	 */
	while(p &lt; ep &amp;&amp; p9 &lt; ep9){
		if((*unpack)(p, ep, &amp;p, &amp;e) &lt; 0)
			break;
		aux-&gt;cookie = e.cookie;
		if(strcmp(e.name, ".") == 0 || strcmp(e.name, "..") == 0)
			continue;
		for(s=e.name; (uchar)*s &gt;= ' '; s++)
			;
		if(*s != 0)	/* bad character in name */
			continue;
		if(!e.haveAttr &amp;&amp; !e.haveHandle)
			if(nfsLookup(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, e.name, &amp;e.handle, &amp;e.haveAttr, &amp;e.attr) &lt; 0)
				continue;
		if(!e.haveAttr)
			if(nfsGetattr(aux-&gt;auth, r-&gt;tag, &amp;e.handle, &amp;e.attr) &lt; 0)
				continue;
		memset(&amp;d, 0, sizeof d);
		attrToDir(&amp;e.attr, &amp;d);
		d.name = e.name;
		if((n = convD2M(&amp;d, p9, ep9-p9)) &lt;= BIT16SZ)
			break;
		p9 += n;
	}
	free(freeme);
	r-&gt;ofcall.count = p9 - (uchar*)r-&gt;ofcall.data;
	respond(r, nil);
}
	
void
fsread(Req *r)
{
	uchar *p, *freeme;
	uint count;
	FidAux *aux;

	if(r-&gt;fid-&gt;qid.type&amp;QTDIR){
		fsreaddir(r);
		return;
	}

	aux = r-&gt;fid-&gt;aux;
	if(nfsRead(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, r-&gt;ifcall.count, r-&gt;ifcall.offset, &amp;p, &amp;count, &amp;freeme) &lt; 0){
		responderrstr(r);
		return;
	}
	r-&gt;ofcall.data = (char*)p;
	r-&gt;ofcall.count = count;
	respond(r, nil);
	free(freeme);
}

void
fswrite(Req *r)
{
	uint count;
	FidAux *aux;

	aux = r-&gt;fid-&gt;aux;
	if(nfsWrite(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, (uchar*)r-&gt;ifcall.data, r-&gt;ifcall.count, r-&gt;ifcall.offset, &amp;count) &lt; 0){
		responderrstr(r);
		return;
	}
	r-&gt;ofcall.count = count;
	respond(r, nil);
}

void
fsremove(Req *r)
{
	int n;
	FidAux *aux;

	aux = r-&gt;fid-&gt;aux;
	if(aux-&gt;name == nil){
		respond(r, "nfs3client botch -- don't know parent handle in remove");
		return;
	}
	if(r-&gt;fid-&gt;qid.type&amp;QTDIR)
		n = nfsRmdir(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;parent, aux-&gt;name);
	else
		n = nfsRemove(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;parent, aux-&gt;name);
	if(n &lt; 0){
		responderrstr(r);
		return;
	}
	respond(r, nil);
}

void
fsstat(Req *r)
{
	FidAux *aux;
	Nfs3Attr attr;

	aux = r-&gt;fid-&gt;aux;
	if(nfsGetattr(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, &amp;attr) &lt; 0){
		responderrstr(r);
		return;
	}
	memset(&amp;r-&gt;d, 0, sizeof r-&gt;d);
	attrToDir(&amp;attr, &amp;r-&gt;d);
	r-&gt;d.name = estrdup9p(aux-&gt;name ? aux-&gt;name : "???");
	respond(r, nil);
}

void
fswstat(Req *r)
{
	int op, sync;
	FidAux *aux;
	Nfs3SetAttr attr;

	memset(&amp;attr, 0, sizeof attr);
	aux = r-&gt;fid-&gt;aux;

	/* Fill out stat first to catch errors */
	op = 0;
	sync = 1;
	if(~r-&gt;d.mode){
		if(r-&gt;d.mode&amp;(DMAPPEND|DMEXCL)){
			respond(r, "wstat -- DMAPPEND and DMEXCL bits not supported");
			return;
		}
		op = 1;
		sync = 0;
		attr.setMode = 1;
		attr.mode = r-&gt;d.mode &amp; 0777;
	}
	if(r-&gt;d.uid &amp;&amp; r-&gt;d.uid[0]){
		attr.setUid = 1;
		if(strtouid(r-&gt;d.uid, &amp;attr.uid) &lt; 0){
			respond(r, "wstat -- unknown uid");
			return;
		}
		op = 1;
		sync = 0;
	}
	if(r-&gt;d.gid &amp;&amp; r-&gt;d.gid[0]){
		attr.setGid = 1;
		if(strtogid(r-&gt;d.gid, &amp;attr.gid) &lt; 0){
			respond(r, "wstat -- unknown gid");
			return;
		}
		op = 1;
		sync = 0;
	}
	if(~r-&gt;d.length){
		attr.setSize = 1;
		attr.size = r-&gt;d.length;
		op = 1;
		sync = 0;
	}
	if(~r-&gt;d.mtime){
		attr.setMtime = Nfs3SetTimeClient;
		attr.mtime.sec = r-&gt;d.mtime;
		op = 1;
		sync = 0;
	}
	if(~r-&gt;d.atime){
		attr.setAtime = Nfs3SetTimeClient;
		attr.atime.sec = r-&gt;d.atime;
		op = 1;
		sync = 0;
	}

	/* Try rename first because it's more likely to fail (?) */
	if(r-&gt;d.name &amp;&amp; r-&gt;d.name[0]){
		if(aux-&gt;name == nil){
			respond(r, "nfsclient botch -- don't know parent handle in rename");
			return;
		}
		if(nfsRename(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;parent, aux-&gt;name, &amp;aux-&gt;parent, r-&gt;d.name) &lt; 0){
			responderrstr(r);
			return;
		}
		free(aux-&gt;name);
		aux-&gt;name = estrdup9p(r-&gt;d.name);
		sync = 0;
	}

	/*
	 * Now we have a problem.  The rename succeeded
	 * but the setattr could fail.  Sic transit atomicity.
	 */
	if(op){
		if(nfsSetattr(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle, &amp;attr) &lt; 0){
			responderrstr(r);
			return;
		}
	}

	if(sync){
		/* NFS commit */
		if(nfsCommit(aux-&gt;auth, r-&gt;tag, &amp;aux-&gt;handle) &lt; 0){
			responderrstr(r);
			return;
		}
	}

	respond(r, nil);
}

char*
fswalk1(Fid *fid, char *name, void *v)
{
	u1int have;
	ulong tag;
	FidAux *aux;
	Nfs3Attr attr;
	Nfs3Handle h;

	tag = *(ulong*)v;
	aux = fid-&gt;aux;

	if(nfsLookup(aux-&gt;auth, tag, &amp;aux-&gt;handle, name, &amp;h, &amp;have, &amp;attr) &lt; 0
	|| (!have &amp;&amp; nfsGetattr(aux-&gt;auth, tag, &amp;h, &amp;attr) &lt; 0)){
		rerrstr(aux-&gt;err, sizeof aux-&gt;err);
		return aux-&gt;err;
	}

	aux-&gt;parent = aux-&gt;handle;
	aux-&gt;handle = h;
	free(aux-&gt;name);
	if(strcmp(name, "..") == 0)
		aux-&gt;name = nil;
	else
		aux-&gt;name = estrdup9p(name);
	attrToQid(&amp;attr, &amp;fid-&gt;qid);
	return nil;
}

char*
fsclone(Fid *fid, Fid *newfid, void*)
{
	FidAux *a, *na;

	a = fid-&gt;aux;
	na = emalloc9p(sizeof(FidAux));
	*na = *a;
	if(na-&gt;name)
		na-&gt;name = estrdup9p(na-&gt;name);
	newfid-&gt;aux = na;
	if(na-&gt;auth)
		na-&gt;auth-&gt;ref++;
	return nil;
}

void
fswalk(Req *r)
{
	walkandclone(r, fswalk1, fsclone, &amp;r-&gt;tag);
}

void
fsflush(Req *r)
{
	Req *or;

	/*
	 * Send on the flush channel(s).
	 * The library will make sure the response
	 * is delayed as necessary.
	 */
	or = r-&gt;oldreq;
	if(nfscli)
		sendul(nfscli-&gt;flushchan, (ulong)or-&gt;tag);
	if(mntcli)
		sendul(mntcli-&gt;flushchan, (ulong)or-&gt;tag);
	respond(r, nil);
}

void
fsdispatch(void *v)
{
	Req *r;

	r = v;
	switch(r-&gt;ifcall.type){
	default:	respond(r, "unknown type");	break;
	case Tattach:	fsattach(r);	break;
	case Topen:	fsopen(r);	break;
	case Tcreate:	fscreate(r);	break;
	case Tread:	fsread(r);	break;
	case Twrite:	fswrite(r);	break;
	case Tremove:	fsremove(r);	break;
	case Tflush:	fsflush(r);	break;
	case Tstat:	fsstat(r);	break;
	case Twstat:	fswstat(r);	break;
	case Twalk:	fswalk(r);	break;
	}
}

void
fsthread(void*)
{
	Req *r;

	while((r = recvp(fschan)) != nil)
		threadcreate(fsdispatch, r, SunStackSize);
}

void
fssend(Req *r)
{
	sendp(fschan, r);
}

void
fsdie(Srv*)
{
	threadexitsall(nil);
}

Srv fs =
{
.destroyfid =	fsdestroyfid,
.attach=		fssend,
.open=		fssend,
.create=		fssend,
.read=		fssend,
.write=		fssend,
.remove=		fssend,
.flush=		fssend,
.stat=		fssend,
.wstat=		fssend,
.walk=		fssend,
.end=		fsdie
};

void
usage(void)
{
	fprint(2, "usage: nfs [-DRv] [-p perm] [-s srvname] [-u passwd group] addr [addr]\n");
	fprint(2, "\taddr - address of portmapper server\n");
	fprint(2, "\taddr addr - addresses of mount server and nfs server\n");
	exits("usage");
}

char*
netchangeport(char *addr, uint port, char *buf, uint nbuf)
{
	char *r;

	strecpy(buf, buf+nbuf, addr);
	r = strrchr(buf, '!');
	if(r == nil)
		return nil;
	r++;
	seprint(r, buf+nbuf, "%ud", port);
	return buf;
}

char mbuf[256], nbuf[256];
char *mountaddr, *nfsaddr;
Channel *csync;
int chattyrpc;
void dialproc(void*);

void
threadmain(int argc, char **argv)
{
	char *srvname, *passwd, *group, *addr, *p;
	SunClient *cli;
	int proto;
	uint mport, nport;
	ulong perm;
	Dir d;

	perm = 0600;
	passwd = nil;
	group = nil;
	srvname = nil;
	sys = sysname();
	if(sys == nil)
		sys = "plan9";
	ARGBEGIN{
	default:
		usage();
	case 'D':
		chatty9p++;
		break;
	case 'R':
		chattyrpc++;
		break;
	case 'p':
		perm = strtol(EARGF(usage()), &amp;p, 8);
		if(perm==0 || *p != 0)
			usage();
		break;
	case 's':
		srvname = EARGF(usage());
		break;
	case 'u':
		passwd = EARGF(usage());
		group = EARGF(usage());
		break;
	case 'v':
		verbose++;
		break;
	}ARGEND

	if(argc != 1 &amp;&amp; argc != 2)
		usage();

	if(srvname == nil)
		srvname = argv[0];

	fmtinstall('B', sunRpcFmt);
	fmtinstall('C', sunCallFmt);
	fmtinstall('H', encodefmt);
	sunFmtInstall(&amp;portProg);
	sunFmtInstall(&amp;nfs3Prog);
	sunFmtInstall(&amp;nfsMount3Prog);

	if(passwd &amp;&amp; (map = readmap(passwd, group)) == nil)
		fprint(2, "warning: reading %s and %s: %r\n", passwd, group);

	if(map == nil)
		map = &amp;emptymap;

	if(argc == 1){
		addr = netmkaddr(argv[0], "udp", "portmap");
		if((cli = sunDial(addr)) == nil)
			sysfatal("dial %s: %r", addr);
		cli-&gt;chatty = chattyrpc;
		sunClientProg(cli, &amp;portProg);
		if(strstr(addr, "udp!"))
			proto = PortProtoUdp;
		else
			proto = PortProtoTcp;
		if(getport(cli, NfsMount3Program, NfsMount3Version, proto, &amp;mport) &lt; 0)
			sysfatal("lookup mount program port: %r");
		if(getport(cli, Nfs3Program, Nfs3Version, proto, &amp;nport) &lt; 0)
			sysfatal("lookup nfs program port: %r");
		sunClientClose(cli);
		mountaddr = netchangeport(addr, mport, mbuf, sizeof mbuf);
		nfsaddr = netchangeport(addr, nport, nbuf, sizeof nbuf);
		strcat(mountaddr, "!r");
		strcat(nfsaddr, "!r");
		if(verbose)
			fprint(2, "nfs %s %s\n", mountaddr, nfsaddr);
	}else{
		mountaddr = argv[0];
		nfsaddr = argv[1];
	}

	/* have to dial in another proc because it creates threads */
	csync = chancreate(sizeof(void*), 0);
	proccreate(dialproc, nil, SunStackSize);
	recvp(csync);

	threadpostmountsrv(&amp;fs, srvname, nil, 0);
	if(perm != 0600){
		p = smprint("/srv/%s", srvname);
		if(p){
			nulldir(&amp;d);
			d.mode = perm;
			dirwstat(p, &amp;d);
		}
	}
	threadexits(nil);
}

void
dialproc(void*)
{
	rfork(RFNAMEG);
	rfork(RFNOTEG);
	if((mntcli = sunDial(mountaddr)) == nil)
		sysfatal("dial mount program at %s: %r", mountaddr);
	mntcli-&gt;chatty = chattyrpc;
	sunClientProg(mntcli, &amp;nfsMount3Prog);
	if(mountNull(0) &lt; 0)
		sysfatal("execute nop with mnt server at %s: %r", mountaddr);
	
	if((nfscli = sunDial(nfsaddr)) == nil)
		sysfatal("dial nfs program at %s: %r", nfsaddr);
	nfscli-&gt;chatty = chattyrpc;
	sunClientProg(nfscli, &amp;nfs3Prog);
	if(nfsNull(0) &lt; 0)
		sysfatal("execute nop with nfs server at %s: %r", nfsaddr);

	fschan = chancreate(sizeof(Req*), 0);
	threadcreate(fsthread, nil, SunStackSize);
	sendp(csync, 0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

