<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/page/gfx.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/page/gfx.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * graphics file reading for page
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;
#include &lt;bio.h&gt;
#include "page.h"

typedef struct Convert	Convert;
typedef struct GfxInfo	GfxInfo;
typedef struct Graphic	Graphic;

struct Convert {
	char *name;
	char *cmd;
	char *truecmd;	/* cmd for true color */
};

struct GfxInfo {
	Graphic *g;
};

struct Graphic {
	int type;
	char *name;
	uchar *buf;	/* if stdin */
	int nbuf;
};

enum {
	Ipic,
	Itiff,
	Ijpeg,
	Igif,
	Iinferno,
	Ifax,
	Icvt2pic,
	Iplan9bm,
	Iccittg4,
	Ippm,
	Ipng,
	Iyuv,
	Ibmp,
};

/*
 * N.B. These commands need to read stdin if %a is replaced
 * with an empty string.
 */
Convert cvt[] = {
[Ipic]		{ "plan9",	"fb/3to1 rgbv %a |fb/pcp -tplan9" },
[Itiff]		{ "tiff",	"fb/tiff2pic %a | fb/3to1 rgbv | fb/pcp -tplan9" },
[Iplan9bm]	{ "plan9bm",	nil },
[Ijpeg]		{ "jpeg",	"jpg -9 %a", "jpg -t9 %a" },
[Igif]		{ "gif",	"gif -9 %a", "gif -t9 %a" },
[Iinferno]	{ "inferno",	nil },
[Ifax]		{ "fax",	"aux/g3p9bit -g %a" },
[Icvt2pic]	{ "unknown",	"fb/cvt2pic %a |fb/3to1 rgbv" },
[Ippm]		{ "ppm",	"ppm -9 %a", "ppm -t9 %a" },
/* ``temporary'' hack for hobby */
[Iccittg4]	{ "ccitt-g4",	"cat %a|rx nslocum /usr/lib/ocr/bin/bcp -M|fb/pcp -tcompressed -l0" },
[Ipng]		{ "png",	"png -9 %a", "png -t9 %a" },
[Iyuv]		{ "yuv",	"yuv -9 %a", "yuv -t9 %a"  },
[Ibmp]		{ "bmp",	"bmp -9 %a", "bmp -t9 %a"  },
};

static Image*	convert(Graphic*);
static Image*	gfxdrawpage(Document *d, int page);
static char*	gfxpagename(Document*, int);
static int	spawnrc(char*, uchar*, int);
static void	waitrc(void);
static int	spawnpost(int);
static int	addpage(Document*, char*);
static int	rmpage(Document*, int);
static int	genaddpage(Document*, char*, uchar*, int);

static char*
gfxpagename(Document *doc, int page)
{
	GfxInfo *gfx = doc-&gt;extra;
	return gfx-&gt;g[page].name;
}

static Image*
gfxdrawpage(Document *doc, int page)
{
	setlabel(gfxpagename(doc, page));
	GfxInfo *gfx = doc-&gt;extra;
	return convert(gfx-&gt;g+page);
}

Document*
initgfx(Biobuf*, int argc, char **argv, uchar *buf, int nbuf)
{
	GfxInfo *gfx;
	Document *doc;
	int i;

	doc = emalloc(sizeof(*doc));
	gfx = emalloc(sizeof(*gfx));
	gfx-&gt;g = nil;
	
	doc-&gt;npage = 0;
	doc-&gt;drawpage = gfxdrawpage;
	doc-&gt;pagename = gfxpagename;
	doc-&gt;addpage = addpage;
	doc-&gt;rmpage = rmpage;
	doc-&gt;extra = gfx;
	doc-&gt;fwdonly = 0;

	fprint(2, "reading through graphics...\n");
	if(argc==0 &amp;&amp; buf)
		genaddpage(doc, nil, buf, nbuf);
	else{
		for(i=0; i&lt;argc; i++)
			if(addpage(doc, argv[i]) &lt; 0)
				fprint(2, "warning: not including %s: %r\n", argv[i]);
	}

	return doc;
}

static int
genaddpage(Document *doc, char *name, uchar *buf, int nbuf)
{
	Graphic *g;
	GfxInfo *gfx;
	Biobuf *b;
	uchar xbuf[32];
	int i, l;

	l = 0;
	gfx = doc-&gt;extra;

	assert((name == nil) ^ (buf == nil));
	assert(name != nil || doc-&gt;npage == 0);

	for(i=0; i&lt;doc-&gt;npage; i++)
		if(strcmp(gfx-&gt;g[i].name, name) == 0)
			return i;

	if(name){
		l = strlen(name);
		if((b = Bopen(name, OREAD)) == nil) {
			werrstr("Bopen: %r");
			return -1;
		}

		if(Bread(b, xbuf, sizeof xbuf) != sizeof xbuf) {
			werrstr("short read: %r");
			return -1;
		}
		Bterm(b);
		buf = xbuf;
		nbuf = sizeof xbuf;
	}


	gfx-&gt;g = erealloc(gfx-&gt;g, (doc-&gt;npage+1)*(sizeof(*gfx-&gt;g)));
	g = &amp;gfx-&gt;g[doc-&gt;npage];

	memset(g, 0, sizeof *g);
	if(memcmp(buf, "GIF", 3) == 0)
		g-&gt;type = Igif;
	else if(memcmp(buf, "\111\111\052\000", 4) == 0) 
		g-&gt;type = Itiff;
	else if(memcmp(buf, "\115\115\000\052", 4) == 0)
		g-&gt;type = Itiff;
	else if(memcmp(buf, "\377\330\377", 3) == 0)
		g-&gt;type = Ijpeg;
	else if(memcmp(buf, "\211PNG\r\n\032\n", 3) == 0)
		g-&gt;type = Ipng;
	else if(memcmp(buf, "compressed\n", 11) == 0)
		g-&gt;type = Iinferno;
	else if(memcmp(buf, "\0PC Research, Inc", 17) == 0)
		g-&gt;type = Ifax;
	else if(memcmp(buf, "TYPE=ccitt-g31", 14) == 0)
		g-&gt;type = Ifax;
	else if(memcmp(buf, "II*", 3) == 0)
		g-&gt;type = Ifax;
	else if(memcmp(buf, "TYPE=ccitt-g4", 13) == 0)
		g-&gt;type = Iccittg4;
	else if(memcmp(buf, "TYPE=", 5) == 0)
		g-&gt;type = Ipic;
	else if(buf[0] == 'P' &amp;&amp; '0' &lt;= buf[1] &amp;&amp; buf[1] &lt;= '9')
		g-&gt;type = Ippm;
	else if(memcmp(buf, "BM", 2) == 0)
		g-&gt;type = Ibmp;
	else if(memcmp(buf, "          ", 10) == 0 &amp;&amp;
		'0' &lt;= buf[10] &amp;&amp; buf[10] &lt;= '9' &amp;&amp;
		buf[11] == ' ')
		g-&gt;type = Iplan9bm;
	else if(strtochan((char*)buf) != 0)
		g-&gt;type = Iplan9bm;
	else if (l &gt; 4 &amp;&amp; strcmp(name + l -4, ".yuv") == 0)
		g-&gt;type = Iyuv;
	else
		g-&gt;type = Icvt2pic;

	if(name)
		g-&gt;name = estrdup(name);
	else{
		g-&gt;name = estrdup("stdin");	/* so it can be freed */
		g-&gt;buf = buf;
		g-&gt;nbuf = nbuf;
	}

	if(chatty) fprint(2, "classified \"%s\" as \"%s\"\n", g-&gt;name, cvt[g-&gt;type].name);
	return doc-&gt;npage++;
}

static int 
addpage(Document *doc, char *name)
{
	return genaddpage(doc, name, nil, 0);
}

static int
rmpage(Document *doc, int n)
{
	int i;
	GfxInfo *gfx;

	if(n &lt; 0 || n &gt;= doc-&gt;npage)
		return -1;

	gfx = doc-&gt;extra;
	doc-&gt;npage--;
	free(gfx-&gt;g[n].name);

	for(i=n; i&lt;doc-&gt;npage; i++)
		gfx-&gt;g[i] = gfx-&gt;g[i+1];

	if(n &lt; doc-&gt;npage)
		return n;
	if(n == 0)
		return 0;
	return n-1;
}


static Image*
convert(Graphic *g)
{
	int fd;
	Convert c;
	char *cmd;
	char *name, buf[1000];
	Image *im;
	int rcspawned = 0;
	Waitmsg *w;

	c = cvt[g-&gt;type];
	if(c.cmd == nil) {
		if(chatty) fprint(2, "no conversion for bitmap \"%s\"...\n", g-&gt;name);
		if(g-&gt;buf == nil){	/* not stdin */
			fd = open(g-&gt;name, OREAD);
			if(fd &lt; 0) {
				fprint(2, "cannot open file: %r\n");
				wexits("open");
			}
		}else
			fd = stdinpipe(g-&gt;buf, g-&gt;nbuf);	
	} else {
		cmd = c.cmd;
		if(truecolor &amp;&amp; c.truecmd)
			cmd = c.truecmd;

		if(g-&gt;buf != nil)	/* is stdin */
			name = "";
		else
			name = g-&gt;name;
		if(strlen(cmd)+strlen(name) &gt; sizeof buf) {
			fprint(2, "command too long\n");
			wexits("convert");
		}
		snprint(buf, sizeof buf, cmd, name);
		if(chatty) fprint(2, "using \"%s\" to convert \"%s\"...\n", buf, g-&gt;name);
		fd = spawnrc(buf, g-&gt;buf, g-&gt;nbuf);
		rcspawned++;
		if(fd &lt; 0) {
			fprint(2, "cannot spawn converter: %r\n");
			wexits("convert");
		}	
	}

	im = readimage(display, fd, 0);
	if(im == nil) {
		fprint(2, "warning: couldn't read image: %r\n");
	}
	close(fd);

	/* for some reason rx doesn't work well with wait */
	/* for some reason 3to1 exits on success with a non-null status of |3to1 */
	if(rcspawned &amp;&amp; g-&gt;type != Iccittg4) {
		if((w=wait())!=nil &amp;&amp; w-&gt;msg[0] &amp;&amp; !strstr(w-&gt;msg, "3to1"))
			fprint(2, "slave wait error: %s\n", w-&gt;msg);
		free(w);
	}
	return im;
}

static int
spawnrc(char *cmd, uchar *stdinbuf, int nstdinbuf)
{
	int pfd[2];
	int pid;

	if(chatty) fprint(2, "spawning(%s)...", cmd);

	if(pipe(pfd) &lt; 0)
		return -1;
	if((pid = fork()) &lt; 0)
		return -1;

	if(pid == 0) {
		close(pfd[1]);
		if(stdinbuf)
			dup(stdinpipe(stdinbuf, nstdinbuf), 0);
		else
			dup(open("/dev/null", OREAD), 0);
		dup(pfd[0], 1);
		//dup(pfd[0], 2);
		execl("/bin/rc", "rc", "-c", cmd, nil);
		wexits("exec");
	}
	close(pfd[0]);
	return pfd[1];
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

