<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/page/view.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/page/view.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * the actual viewer that handles screen stuff
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;cursor.h&gt;
#include &lt;event.h&gt;
#include &lt;bio.h&gt;
#include &lt;plumb.h&gt;
#include &lt;ctype.h&gt;
#include &lt;keyboard.h&gt;
#include "page.h"

Document *doc;
Image *im;
Image *tofree;
int page;
int angle = 0;
int showbottom = 0;		/* on the next showpage, move the image so the bottom is visible. */

Rectangle ulrange;	/* the upper left corner of the image must be in this rectangle */
Point ul;			/* the upper left corner of the image is at this point on the screen */

Point pclip(Point, Rectangle);
Rectangle mkrange(Rectangle screenr, Rectangle imr);
void redraw(Image*);

Cursor reading={
	{-1, -1},
	{0xff, 0x80, 0xff, 0x80, 0xff, 0x00, 0xfe, 0x00, 
	 0xff, 0x00, 0xff, 0x80, 0xff, 0xc0, 0xef, 0xe0, 
	 0xc7, 0xf0, 0x03, 0xf0, 0x01, 0xe0, 0x00, 0xc0, 
	 0x03, 0xff, 0x03, 0xff, 0x03, 0xff, 0x03, 0xff, },
	{0x00, 0x00, 0x7f, 0x00, 0x7e, 0x00, 0x7c, 0x00, 
	 0x7e, 0x00, 0x7f, 0x00, 0x6f, 0x80, 0x47, 0xc0, 
	 0x03, 0xe0, 0x01, 0xf0, 0x00, 0xe0, 0x00, 0x40, 
	 0x00, 0x00, 0x01, 0xb6, 0x01, 0xb6, 0x00, 0x00, }
};

Cursor query = {
	{-7,-7},
	{0x0f, 0xf0, 0x1f, 0xf8, 0x3f, 0xfc, 0x7f, 0xfe, 
	 0x7c, 0x7e, 0x78, 0x7e, 0x00, 0xfc, 0x01, 0xf8, 
	 0x03, 0xf0, 0x07, 0xe0, 0x07, 0xc0, 0x07, 0xc0, 
	 0x07, 0xc0, 0x07, 0xc0, 0x07, 0xc0, 0x07, 0xc0, },
	{0x00, 0x00, 0x0f, 0xf0, 0x1f, 0xf8, 0x3c, 0x3c, 
	 0x38, 0x1c, 0x00, 0x3c, 0x00, 0x78, 0x00, 0xf0, 
	 0x01, 0xe0, 0x03, 0xc0, 0x03, 0x80, 0x03, 0x80, 
	 0x00, 0x00, 0x03, 0x80, 0x03, 0x80, 0x00, 0x00, }
};

enum {
	Left = 1,
	Middle = 2,
	Right = 4,

	RMenu = 3,
};

static void
delayfreeimage(Image *m)
{
	if(m == tofree)
		return;
	if(tofree)
		freeimage(tofree);
	tofree = m;
}

void
unhide(void)
{
	static int wctl = -1;

	if(wctl &lt; 0)
		wctl = open("/dev/wctl", OWRITE);
	if(wctl &lt; 0)
		return;

	write(wctl, "unhide", 6);
}

int 
max(int a, int b)
{
	return a &gt; b ? a : b;
}

int 
min(int a, int b)
{
	return a &lt; b ? a : b;
}


char*
menugen(int n)
{
	static char menustr[32];
	char *p;
	int len;

	if(n == doc-&gt;npage)
		return "exit";
	if(n &gt; doc-&gt;npage)
		return nil;

	if(reverse)
		n = doc-&gt;npage-1-n;

	p = doc-&gt;pagename(doc, n);
	len = (sizeof menustr)-2;

	if(strlen(p) &gt; len &amp;&amp; strrchr(p, '/'))
		p = strrchr(p, '/')+1;
	if(strlen(p) &gt; len)
		p = p+strlen(p)-len;

	strcpy(menustr+1, p);
	if(page == n)
		menustr[0] = '&gt;';
	else
		menustr[0] = ' ';
	return menustr;
}

void
showpage(int page, Menu *m)
{
	if(doc-&gt;fwdonly)
		m-&gt;lasthit = 0;	/* this page */
	else
		m-&gt;lasthit = reverse ? doc-&gt;npage-1-page : page;
	
	esetcursor(&amp;reading);
	delayfreeimage(nil);
	im = cachedpage(doc, angle, page);
	if(im == nil)
		wexits(0);
	if(resizing)
		resize(Dx(im-&gt;r), Dy(im-&gt;r));

	esetcursor(nil);
	if(showbottom){
		ul.y = screen-&gt;r.max.y - Dy(im-&gt;r);
		showbottom = 0;
	}

	redraw(screen);
	flushimage(display, 1);
}

char*
writebitmap(void)
{
	char basename[64];
	char name[64+30];
	static char result[200];
	char *p, *q;
	int fd;

	if(im == nil)
		return "no image";

	memset(basename, 0, sizeof basename);
	if(doc-&gt;docname)
		strncpy(basename, doc-&gt;docname, sizeof(basename)-1);
	else if((p = menugen(page)) &amp;&amp; p[0] != '\0')
		strncpy(basename, p+1, sizeof(basename)-1);

	if(basename[0]) {
		if(q = strrchr(basename, '/'))
			q++;
		else
			q = basename;
		if(p = strchr(q, '.'))
			*p = 0;
		
		memset(name, 0, sizeof name);
		snprint(name, sizeof(name)-1, "%s.%d.bit", q, page+1);
		if(access(name, 0) &gt;= 0) {
			strcat(name, "XXXX");
			mktemp(name);
		}
		if(access(name, 0) &gt;= 0)
			return "couldn't think of a name for bitmap";
	} else {
		strcpy(name, "bitXXXX");
		mktemp(name);
		if(access(name, 0) &gt;= 0) 
			return "couldn't think of a name for bitmap";
	}

	if((fd = create(name, OWRITE, 0666)) &lt; 0) {
		snprint(result, sizeof result, "cannot create %s: %r", name);
		return result;
	}

	if(writeimage(fd, im, 0) &lt; 0) {
		snprint(result, sizeof result, "cannot writeimage: %r");
		close(fd);
		return result;
	}
	close(fd);

	snprint(result, sizeof result, "wrote %s", name);
	return result;
}

static void translate(Point);

static int
showdata(Plumbmsg *msg)
{
	char *s;

	s = plumblookup(msg-&gt;attr, "action");
	return s &amp;&amp; strcmp(s, "showdata")==0;
}

static int
plumbquit(Plumbmsg *msg)
{
	char *s;

	s = plumblookup(msg-&gt;attr, "action");
	return s &amp;&amp; strcmp(s, "quit")==0;
}

/* correspond to entries in miditems[] below,
 * changing one means you need to change
 */
enum{
	Restore = 0,
	Zin,
	Fit,
	Rot,
	Upside,
	Empty1,
	Next,
	Prev,
	Zerox,
	Empty2,
	Reverse,
	Del,
	Write,
	Empty3,
	Exit,
};
 
void
viewer(Document *dd)
{
	int i, fd, n, oldpage;
	int nxt;
	Menu menu, midmenu;
	Mouse m;
	Event e;
	Point dxy, oxy, xy0;
	Rectangle r;
	Image *tmp;
	static char *fwditems[] = { "this page", "next page", "exit", 0 };
 	static char *miditems[] = {
 		"orig size",
 		"zoom in",
 		"fit window",
 		"rotate 90",
 		"upside down",
 		"",
 		"next",
 		"prev",
		"zerox",
 		"", 
 		"reverse",
 		"discard",
 		"write",
 		"", 
 		"quit", 
 		0 
 	};
	char *s;
	enum { Eplumb = 4 };
	Plumbmsg *pm;

	doc = dd;    /* save global for menuhit */
	ul = screen-&gt;r.min;
	einit(Emouse|Ekeyboard);
	if(doc-&gt;addpage != nil)
		eplumb(Eplumb, "image");

	esetcursor(&amp;reading);
	r.min = ZP;

	/*
	 * im is a global pointer to the current image.
	 * eventually, i think we will have a layer between
	 * the display routines and the ps/pdf/whatever routines
	 * to perhaps cache and handle images of different
	 * sizes, etc.
	 */
	im = 0;
	page = reverse ? doc-&gt;npage-1 : 0;

	if(doc-&gt;fwdonly) {
		menu.item = fwditems;
		menu.gen = 0;
		menu.lasthit = 0;
	} else {
		menu.item = 0;
		menu.gen = menugen;
		menu.lasthit = 0;
	}

	midmenu.item = miditems;
	midmenu.gen = 0;
	midmenu.lasthit = Next;

	if(doc-&gt;docname != nil)
		setlabel(doc-&gt;docname);
	showpage(page, &amp;menu);
	esetcursor(nil);

	nxt = 0;
	for(;;) {
		/*
		 * throughout, if doc-&gt;fwdonly is set, we restrict the functionality
		 * a fair amount.  we don't care about doc-&gt;npage anymore, and
		 * all that can be done is select the next page.
		 */
		unlockdisplay(display);
		i = eread(Emouse|Ekeyboard|Eplumb, &amp;e);
		lockdisplay(display);
		switch(i){
		case Ekeyboard:
			if(e.kbdc &lt;= 0xFF &amp;&amp; isdigit(e.kbdc)) {
				nxt = nxt*10+e.kbdc-'0';
				break;
			} else if(e.kbdc != '\n')
				nxt = 0;
			switch(e.kbdc) {
			case 'r':	/* reverse page order */
				if(doc-&gt;fwdonly)
					break;
				reverse = !reverse;
				menu.lasthit = doc-&gt;npage-1-menu.lasthit;

				/*
				 * the theory is that if we are reversing the
				 * document order and are on the first or last
				 * page then we're just starting and really want
		 	 	 * to view the other end.  maybe the if
				 * should be dropped and this should happen always.
				 */
				if(page == 0 || page == doc-&gt;npage-1) {
					page = doc-&gt;npage-1-page;
					showpage(page, &amp;menu);
				}
				break;
			case 'w':	/* write bitmap of current screen */
				esetcursor(&amp;reading);
				s = writebitmap();
				if(s)
					string(screen, addpt(screen-&gt;r.min, Pt(5,5)), display-&gt;black, ZP,
						display-&gt;defaultfont, s);
				esetcursor(nil);
				flushimage(display, 1);
				break;
			case 'd':	/* remove image from working set */
				if(doc-&gt;rmpage &amp;&amp; page &lt; doc-&gt;npage) {
					if(doc-&gt;rmpage(doc, page) &gt;= 0) {
						if(doc-&gt;npage &lt; 0)
							wexits(0);
						if(page &gt;= doc-&gt;npage)
							page = doc-&gt;npage-1;
						showpage(page, &amp;menu);
					}
				}
				break;
			case 'q':
			case 0x04: /* ctrl-d */
				wexits(0);
			case 'u':
				if(im==nil)
					break;
				angle = (angle+180) % 360;
				showpage(page, &amp;menu);
				break;
			case '-':
			case '\b':
			case Kleft:
				if(page &gt; 0 &amp;&amp; !doc-&gt;fwdonly) {
					--page;
					showpage(page, &amp;menu);
				}
				break;
			case '\n':
				if(nxt) {
					nxt--;
					if(nxt &gt;= 0 &amp;&amp; nxt &lt; doc-&gt;npage &amp;&amp; !doc-&gt;fwdonly)
						showpage(page=nxt, &amp;menu);
					nxt = 0;
					break;
				}
				goto Gotonext;
			case Kright:
			case ' ':
			Gotonext:
				if(doc-&gt;npage &amp;&amp; ++page &gt;= doc-&gt;npage &amp;&amp; !doc-&gt;fwdonly)
					wexits(0);
				showpage(page, &amp;menu);
				break;

			/*
			 * The upper y coordinate of the image is at ul.y in screen-&gt;r.
			 * Panning up means moving the upper left corner down.  If the
			 * upper left corner is currently visible, we need to go back a page.
			 */
			case Kup:
				if(screen-&gt;r.min.y &lt;= ul.y &amp;&amp; ul.y &lt; screen-&gt;r.max.y){
					if(page &gt; 0 &amp;&amp; !doc-&gt;fwdonly){
						--page;
						showbottom = 1;
						showpage(page, &amp;menu);
					}
				} else {
					i = Dy(screen-&gt;r)/2;
					if(i &gt; 10)
						i -= 10;
					if(i+ul.y &gt; screen-&gt;r.min.y)
						i = screen-&gt;r.min.y - ul.y;
					translate(Pt(0, i));
				}
				break;

			/*
			 * If the lower y coordinate is on the screen, we go to the next page.
			 * The lower y coordinate is at ul.y + Dy(im-&gt;r).
			 */
			case Kdown:
				i = ul.y + Dy(im-&gt;r);
				if(screen-&gt;r.min.y &lt;= i &amp;&amp; i &lt;= screen-&gt;r.max.y){
					ul.y = screen-&gt;r.min.y;
					goto Gotonext;
				} else {
					i = -Dy(screen-&gt;r)/2;
					if(i &lt; -10)
						i += 10;
					if(i+ul.y+Dy(im-&gt;r) &lt;= screen-&gt;r.max.y)
						i = screen-&gt;r.max.y - Dy(im-&gt;r) - ul.y - 1;
					translate(Pt(0, i));
				}
				break;
			default:
				esetcursor(&amp;query);
				sleep(1000);
				esetcursor(nil);
				break;	
			}
			break;

		case Emouse:
			m = e.mouse;
			switch(m.buttons){
			case Left:
				oxy = m.xy;
				xy0 = oxy;
				do {
					dxy = subpt(m.xy, oxy);
					oxy = m.xy;	
					translate(dxy);
					unlockdisplay(display);
					m = emouse();
					lockdisplay(display);
				} while(m.buttons == Left);
				if(m.buttons) {
					dxy = subpt(xy0, oxy);
					translate(dxy);
				}
				break;
	
			case Middle:
				if(doc-&gt;npage == 0)
					break;

				unlockdisplay(display);
				n = emenuhit(Middle, &amp;m, &amp;midmenu);
				lockdisplay(display);
				if(n == -1)
					break;
				switch(n){
				case Next: 	/* next */
					if(reverse)
						page--;
					else
						page++;
					if(page &lt; 0) {
						if(reverse) return;
						else page = 0;
					}

					if((page &gt;= doc-&gt;npage) &amp;&amp; !doc-&gt;fwdonly)
						return;
	
					showpage(page, &amp;menu);
					nxt = 0;
					break;
				case Prev:	/* prev */
					if(reverse)
						page++;
					else
						page--;
					if(page &lt; 0) {
						if(reverse) return;
						else page = 0;
					}

					if((page &gt;= doc-&gt;npage) &amp;&amp; !doc-&gt;fwdonly &amp;&amp; !reverse)
						return;
	
					showpage(page, &amp;menu);
					nxt = 0;
					break;
				case Zerox:	/* prev */
					zerox();
					break;
				case Zin:	/* zoom in */
					{
						double delta;
						Rectangle r;

						r = egetrect(Middle, &amp;m);
						if((rectclip(&amp;r, rectaddpt(im-&gt;r, ul)) == 0) ||
							Dx(r) == 0 || Dy(r) == 0)
							break;
						/* use the smaller side to expand */
						if(Dx(r) &lt; Dy(r))
							delta = (double)Dx(im-&gt;r)/(double)Dx(r);
						else
							delta = (double)Dy(im-&gt;r)/(double)Dy(r);

						esetcursor(&amp;reading);
						tmp = xallocimage(display, 
								Rect(0, 0, (int)((double)Dx(im-&gt;r)*delta), (int)((double)Dy(im-&gt;r)*delta)), 
								im-&gt;chan, 0, DBlack);
						if(tmp == nil) {
							fprint(2, "out of memory during zoom: %r\n");
							wexits("memory");
						}
						resample(im, tmp);
						im = tmp;
						delayfreeimage(tmp);
						esetcursor(nil);
						ul = screen-&gt;r.min;
						redraw(screen);
						flushimage(display, 1);
						break;
					}
				case Fit:	/* fit */
					{
						double delta;
						Rectangle r;
						
						delta = (double)Dx(screen-&gt;r)/(double)Dx(im-&gt;r);
						if((double)Dy(im-&gt;r)*delta &gt; Dy(screen-&gt;r))
							delta = (double)Dy(screen-&gt;r)/(double)Dy(im-&gt;r);

						r = Rect(0, 0, (int)((double)Dx(im-&gt;r)*delta), (int)((double)Dy(im-&gt;r)*delta));
						esetcursor(&amp;reading);
						tmp = xallocimage(display, r, im-&gt;chan, 0, DBlack);
						if(tmp == nil) {
							fprint(2, "out of memory during fit: %r\n");
							wexits("memory");
						}
						resample(im, tmp);
						im = tmp;
						delayfreeimage(tmp);
						esetcursor(nil);
						ul = screen-&gt;r.min;
						redraw(screen);
						flushimage(display, 1);
						break;
					}
				case Rot:	/* rotate 90 */
					angle = (angle+90) % 360;
					showpage(page, &amp;menu);
					break;
				case Upside: 	/* upside-down */
					angle = (angle+180) % 360;
					showpage(page, &amp;menu);
					break;
				case Restore:	/* restore */
					showpage(page, &amp;menu);
					break;
				case Reverse:	/* reverse */
					if(doc-&gt;fwdonly)
						break;
					reverse = !reverse;
					menu.lasthit = doc-&gt;npage-1-menu.lasthit;
	
					if(page == 0 || page == doc-&gt;npage-1) {
						page = doc-&gt;npage-1-page;
						showpage(page, &amp;menu);
					}
					break;
				case Write: /* write */
					esetcursor(&amp;reading);
					s = writebitmap();
					if(s)
						string(screen, addpt(screen-&gt;r.min, Pt(5,5)), display-&gt;black, ZP,
							display-&gt;defaultfont, s);
					esetcursor(nil);
					flushimage(display, 1);
					break;
				case Del: /* delete */
					if(doc-&gt;rmpage &amp;&amp; page &lt; doc-&gt;npage) {
						if(doc-&gt;rmpage(doc, page) &gt;= 0) {
							if(doc-&gt;npage &lt; 0)
								wexits(0);
							if(page &gt;= doc-&gt;npage)
								page = doc-&gt;npage-1;
							showpage(page, &amp;menu);
						}
					}
					break;
				case Exit:	/* exit */
					return;
				case Empty1:
				case Empty2:
				case Empty3:
					break;

				}; 

	
	
			case Right:
				if(doc-&gt;npage == 0)
					break;

				oldpage = page;
				unlockdisplay(display);
				n = emenuhit(RMenu, &amp;m, &amp;menu);
				lockdisplay(display);
				if(n == -1)
					break;
	
				if(doc-&gt;fwdonly) {
					switch(n){
					case 0:	/* this page */
						break;
					case 1:	/* next page */
						showpage(++page, &amp;menu);
						break;
					case 2:	/* exit */
						return;
					}
					break;
				}
	
				if(n == doc-&gt;npage)
					return;
				else
					page = reverse ? doc-&gt;npage-1-n : n;
	
				if(oldpage != page)
					showpage(page, &amp;menu);
				nxt = 0;
				break;
			}
			break;

		case Eplumb:
			pm = e.v;
			if(pm-&gt;ndata &lt;= 0){
				plumbfree(pm);
				break;
			}
			if(plumbquit(pm))
				exits(nil);
			if(showdata(pm)) {
				s = estrdup("/tmp/pageplumbXXXXXXX");
				fd = opentemp(s);
				write(fd, pm-&gt;data, pm-&gt;ndata);
				/* lose fd reference on purpose; the file is open ORCLOSE */
			} else if(pm-&gt;data[0] == '/') {
				s = estrdup(pm-&gt;data);
			} else {
				s = emalloc(strlen(pm-&gt;wdir)+1+pm-&gt;ndata+1);
				sprint(s, "%s/%s", pm-&gt;wdir, pm-&gt;data);
				cleanname(s);
			}
			if((i = doc-&gt;addpage(doc, s)) &gt;= 0) {
				page = i;
				unhide();
				showpage(page, &amp;menu);
			}
			free(s);
			plumbfree(pm);
			break;
		}
	}
}

Image *gray;

/*
 * A draw operation that touches only the area contained in bot but not in top.
 * mp and sp get aligned with bot.min.
 */
static void
gendrawdiff(Image *dst, Rectangle bot, Rectangle top, 
	Image *src, Point sp, Image *mask, Point mp, int op)
{
	Rectangle r;
	Point origin;
	Point delta;

	USED(op);

	if(Dx(bot)*Dy(bot) == 0)
		return;

	/* no points in bot - top */
	if(rectinrect(bot, top))
		return;

	/* bot - top ≡ bot */
	if(Dx(top)*Dy(top)==0 || rectXrect(bot, top)==0){
		gendrawop(dst, bot, src, sp, mask, mp, op);
		return;
	}

	origin = bot.min;
	/* split bot into rectangles that don't intersect top */
	/* left side */
	if(bot.min.x &lt; top.min.x){
		r = Rect(bot.min.x, bot.min.y, top.min.x, bot.max.y);
		delta = subpt(r.min, origin);
		gendrawop(dst, r, src, addpt(sp, delta), mask, addpt(mp, delta), op);
		bot.min.x = top.min.x;
	}

	/* right side */
	if(bot.max.x &gt; top.max.x){
		r = Rect(top.max.x, bot.min.y, bot.max.x, bot.max.y);
		delta = subpt(r.min, origin);
		gendrawop(dst, r, src, addpt(sp, delta), mask, addpt(mp, delta), op);
		bot.max.x = top.max.x;
	}

	/* top */
	if(bot.min.y &lt; top.min.y){
		r = Rect(bot.min.x, bot.min.y, bot.max.x, top.min.y);
		delta = subpt(r.min, origin);
		gendrawop(dst, r, src, addpt(sp, delta), mask, addpt(mp, delta), op);
		bot.min.y = top.min.y;
	}

	/* bottom */
	if(bot.max.y &gt; top.max.y){
		r = Rect(bot.min.x, top.max.y, bot.max.x, bot.max.y);
		delta = subpt(r.min, origin);
		gendrawop(dst, r, src, addpt(sp, delta), mask, addpt(mp, delta), op);
		bot.max.y = top.max.y;
	}
}

static void
drawdiff(Image *dst, Rectangle bot, Rectangle top, Image *src, Image *mask, Point p, int op)
{
	gendrawdiff(dst, bot, top, src, p, mask, p, op);
}

/*
 * Translate the image in the window by delta.
 */
static void
translate(Point delta)
{
	Point u;
	Rectangle r, or;

	if(im == nil)
		return;

	u = pclip(addpt(ul, delta), ulrange);
	delta = subpt(u, ul);
	if(delta.x == 0 &amp;&amp; delta.y == 0)
		return;

	/*
	 * The upper left corner of the image is currently at ul.
	 * We want to move it to u.
	 */
	or = rectaddpt(Rpt(ZP, Pt(Dx(im-&gt;r), Dy(im-&gt;r))), ul);
	r = rectaddpt(or, delta);

	drawop(screen, r, screen, nil, ul, S);
	ul = u;

	/* fill in gray where image used to be but isn't. */
	drawdiff(screen, insetrect(or, -2), insetrect(r, -2), gray, nil, ZP, S);

	/* fill in black border */
	drawdiff(screen, insetrect(r, -2), r, display-&gt;black, nil, ZP, S);

	/* fill in image where it used to be off the screen. */
	if(rectclip(&amp;or, screen-&gt;r))
		drawdiff(screen, r, rectaddpt(or, delta), im, nil, im-&gt;r.min, S);
	else
		drawop(screen, r, im, nil, im-&gt;r.min, S);
	flushimage(display, 1);
}

void
redraw(Image *screen)
{
	Rectangle r;

	if(im == nil)
		return;

	ulrange.max = screen-&gt;r.max;
	ulrange.min = subpt(screen-&gt;r.min, Pt(Dx(im-&gt;r), Dy(im-&gt;r)));

	ul = pclip(ul, ulrange);
	drawop(screen, screen-&gt;r, im, nil, subpt(im-&gt;r.min, subpt(ul, screen-&gt;r.min)), S);

	if(im-&gt;repl)
		return;

	/* fill in any outer edges */
	/* black border */
	r = rectaddpt(im-&gt;r, subpt(ul, im-&gt;r.min));
	border(screen, r, -2, display-&gt;black, ZP);
	r.min = subpt(r.min, Pt(2,2));
	r.max = addpt(r.max, Pt(2,2));

	/* gray for the rest */
	if(gray == nil) {
		gray = xallocimage(display, Rect(0,0,1,1), RGB24, 1, 0x888888FF);
		if(gray == nil) {
			fprint(2, "g out of memory: %r\n");
			wexits("mem");
		}
	}
	border(screen, r, -4000, gray, ZP);
//	flushimage(display, 0);	
}

void
eresized(int new)
{
	Rectangle r;
	r = screen-&gt;r;
	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		fprint(2,"can't reattach to window");
	ul = addpt(ul, subpt(screen-&gt;r.min, r.min));
	redraw(screen);
}

/* clip p to be in r */
Point
pclip(Point p, Rectangle r)
{
	if(p.x &lt; r.min.x)
		p.x = r.min.x;
	else if(p.x &gt;= r.max.x)
		p.x = r.max.x-1;

	if(p.y &lt; r.min.y)
		p.y = r.min.y;
	else if(p.y &gt;= r.max.y)
		p.y = r.max.y-1;

	return p;
}

/*
 * resize is perhaps a misnomer. 
 * this really just grows the window to be at least dx across
 * and dy high.  if the window hits the bottom or right edge,
 * it is backed up until it hits the top or left edge.
 */
void
resize(int dx, int dy)
{
	static Rectangle sr;
	Rectangle r, or;

	dx += 2*Borderwidth;
	dy += 2*Borderwidth;
	if(wctlfd &lt; 0){
		wctlfd = open("/dev/wctl", OWRITE);
		if(wctlfd &lt; 0)
			return;
	}

	r = insetrect(screen-&gt;r, -Borderwidth);
	if(Dx(r) &gt;= dx &amp;&amp; Dy(r) &gt;= dy)
		return;

	if(Dx(sr)*Dy(sr) == 0)
		sr = screenrect();

	or = r;

	r.max.x = max(r.min.x+dx, r.max.x);
	r.max.y = max(r.min.y+dy, r.max.y);
	if(r.max.x &gt; sr.max.x){
		if(Dx(r) &gt; Dx(sr)){
			r.min.x = 0;
			r.max.x = sr.max.x;
		}else
			r = rectaddpt(r, Pt(sr.max.x-r.max.x, 0));
	}
	if(r.max.y &gt; sr.max.y){
		if(Dy(r) &gt; Dy(sr)){
			r.min.y = 0;
			r.max.y = sr.max.y;
		}else
			r = rectaddpt(r, Pt(0, sr.max.y-r.max.y));
	}

	/*
	 * Sometimes we can't actually grow the window big enough,
	 * and resizing it to the same shape makes it flash.
	 */
	if(Dx(r) == Dx(or) &amp;&amp; Dy(r) == Dy(or))
		return;

	fprint(wctlfd, "resize -minx %d -miny %d -maxx %d -maxy %d\n",
		r.min.x, r.min.y, r.max.x, r.max.y);
}

/*
 * If we allocimage after a resize but before flushing the draw buffer,
 * we won't have seen the reshape event, and we won't have called
 * getwindow, and allocimage will fail.  So we flushimage before every alloc.
 */
Image*
xallocimage(Display *d, Rectangle r, ulong chan, int repl, ulong val)
{
	flushimage(display, 0);
	return allocimage(d, r, chan, repl, val);
}

/* all code below this line should be in the library, but is stolen from colors instead */
static char*
rdenv(char *name)
{
	char *v;
	int fd, size;

	fd = open(name, OREAD);
	if(fd &lt; 0)
		return 0;
	size = seek(fd, 0, 2);
	v = malloc(size+1);
	if(v == 0){
		fprint(2, "page: can't malloc: %r\n");
		wexits("no mem");
	}
	seek(fd, 0, 0);
	read(fd, v, size);
	v[size] = 0;
	close(fd);
	return v;
}

void
newwin(void)
{
	char *srv, *mntsrv;
	char spec[100];
	int srvfd, cons, pid;

	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFENVG|RFNOTEG|RFNOWAIT)){
	case -1:
		fprint(2, "page: can't fork: %r\n");
		wexits("no fork");
	case 0:
		break;
	default:
		wexits(0);
	}

	srv = rdenv("/env/wsys");
	if(srv == 0){
		mntsrv = rdenv("/mnt/term/env/wsys");
		if(mntsrv == 0){
			fprint(2, "page: can't find $wsys\n");
			wexits("srv");
		}
		srv = malloc(strlen(mntsrv)+10);
		sprint(srv, "/mnt/term%s", mntsrv);
		free(mntsrv);
		pid  = 0;			/* can't send notes to remote processes! */
	}else
		pid = getpid();
	srvfd = open(srv, ORDWR);
	if(srvfd == -1){
		fprint(2, "page: can't open %s: %r\n", srv);
		wexits("no srv");
	}
	free(srv);
	sprint(spec, "new -pid %d", pid);
	if(mount(srvfd, -1, "/mnt/wsys", 0, spec) == -1){
		fprint(2, "page: can't mount /mnt/wsys: %r (spec=%s)\n", spec);
		wexits("no mount");
	}
	close(srvfd);
	unmount("/mnt/acme", "/dev");
	bind("/mnt/wsys", "/dev", MBEFORE);
	cons = open("/dev/cons", OREAD);
	if(cons==-1){
	NoCons:
		fprint(2, "page: can't open /dev/cons: %r");
		wexits("no cons");
	}
	dup(cons, 0);
	close(cons);
	cons = open("/dev/cons", OWRITE);
	if(cons==-1)
		goto NoCons;
	dup(cons, 1);
	dup(cons, 2);
	close(cons);
//	wctlfd = open("/dev/wctl", OWRITE);
}

Rectangle
screenrect(void)
{
	int fd;
	char buf[12*5];

	fd = open("/dev/screen", OREAD);
	if(fd == -1)
		fd=open("/mnt/term/dev/screen", OREAD);
	if(fd == -1){
		fprint(2, "page: can't open /dev/screen: %r\n");
		wexits("window read");
	}
	if(read(fd, buf, sizeof buf) != sizeof buf){
		fprint(2, "page: can't read /dev/screen: %r\n");
		wexits("screen read");
	}
	close(fd);
	return Rect(atoi(buf+12), atoi(buf+24), atoi(buf+36), atoi(buf+48));
}

void
zerox(void)
{
	int pfd[2];

	pipe(pfd);
	switch(rfork(RFFDG|RFREND|RFPROC)) {
		case -1:
			wexits("cannot fork in zerox: %r");
		case 0: 
			dup(pfd[1], 0);
			close(pfd[0]);
			execl("/bin/page", "page", "-w", nil);
			wexits("cannot exec in zerox: %r\n");
		default:
			close(pfd[1]);
			writeimage(pfd[0], im, 0);
			close(pfd[0]);
			break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

