<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/paqfs/paqfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/paqfs/paqfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;bio.h&gt;
#include &lt;mp.h&gt;
#include &lt;libsec.h&gt;
#include &lt;flate.h&gt;

#include "paqfs.h"

enum
{
	OPERM	= 0x3,		/* mask of all permission types in open mode */
	OffsetSize = 4,		/* size in bytes of an offset */
};

typedef struct Fid Fid;
typedef struct Paq Paq;
typedef struct Block Block;

struct Fid
{
	short	busy;
	short	open;
	int	fid;
	char	*user;
	ulong	offset;		/* for directory reading */

	Paq	*paq;
	Fid	*next;
};

struct Paq
{	
	int ref;
	Paq *up;
	PaqDir *dir;
	Qid qid;
};

struct Block
{
	int ref;
	ulong addr;	/* block byte address */
	ulong age;
	uchar *data;
};

enum
{
	Pexec =		1,
	Pwrite = 	2,
	Pread = 	4,
	Pother = 	1,
	Pgroup = 	8,
	Powner =	64,
};

int	noauth;
Fid	*fids;
Fcall	rhdr, thdr;
int 	blocksize;
int 	cachesize = 20;
int	mesgsize = 8*1024 + IOHDRSZ;
Paq 	*root, *rootfile;
Block 	*cache;
ulong 	cacheage;
Biobuf	*bin;
int	qflag;

Fid *	newfid(int);
void	paqstat(PaqDir*, char*);
void	io(int fd);
void	*erealloc(void*, ulong);
void	*emalloc(ulong);
void 	*emallocz(ulong n);
char 	*estrdup(char*);
void	usage(void);
ulong	getl(uchar *p);
int	gets(uchar *p);
char 	*getstr(uchar *p);
PaqDir	*getDir(uchar*);
void	getHeader(uchar *p, PaqHeader *b);
void	getBlock(uchar *p, PaqBlock *b);
void	getTrailer(uchar *p, PaqTrailer *b);
void	init(char*, int);
void	paqDirFree(PaqDir*);
Qid	paqDirQid(PaqDir *d);
Paq	*paqCpy(Paq *s);
Paq	*paqLookup(Paq *s, char *name);
void	paqFree(Paq*);
Paq	*paqWalk(Paq *s, char *name);
int	perm(PaqDir *s, char *user, int p);
int	dirRead(Fid*, uchar*, int);
Block	*blockLoad(ulong addr, int type);
void	blockFree(Block*);
int	checkDirSize(uchar *p, uchar *ep);
int	packDir(PaqDir*, uchar*, int);
int	blockRead(uchar *data, ulong addr, int type);
void	readHeader(PaqHeader *hdr, char *name, DigestState *ds);
void	readBlocks(char *name, DigestState *ds);
void	readTrailer(PaqTrailer *tlr, char *name, DigestState *ds);

char	*rflush(Fid*), *rversion(Fid*),
	*rauth(Fid*), *rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tattach]	rattach,
	[Tauth]		rauth,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Erdonly[] = 	"read only file system";
char	Ebadblock[] = 	"bad block";
char	Eversion[] = 	"bad version of P9";
char	Edirtoobig[] = 	"directory entry too big";

int debug;

#pragma varargck	type	"V"	uchar*

static int
sha1fmt(Fmt *f)
{
	int i;
	uchar *v;

	v = va_arg(f-&gt;args, uchar*);
	if(v == nil){
		fmtprint(f, "*");
	}
	else{
		for(i = 0; i &lt; SHA1dlen; i++)
			fmtprint(f, "%2.2ux", v[i]);
	}

	return 0;
}

void
main(int argc, char *argv[])
{
	int pfd[2];
	int fd, mnt, srv, stdio, verify;
	char buf[64], *mntpoint, *srvname, *p;

	fmtinstall('V', sha1fmt);

	mntpoint = "/n/paq";
	srvname = "paqfs";
	mnt = 1;
	srv = stdio = verify = 0;

	ARGBEGIN{
	default:
		usage();
	case 'a':
		noauth = 1;
		break;
	case 'c':
		p = EARGF(usage());
		cachesize = atoi(p);
		break;
	case 'd':
		debug = 1;
		break;
	case 'i':
		mnt = 0;
		stdio = 1;
		pfd[0] = 0;
		pfd[1] = 1;
		break;
	case 'm':
		mntpoint = EARGF(usage());
		break;
	case 'M':
		p = EARGF(usage());
		mesgsize = atoi(p);
		if(mesgsize &lt; 512)
			mesgsize = 512;
		if(mesgsize &gt; 128*1024)
			mesgsize = 128*1024;
		break;
	case 'p':
		srv = 1;
		mnt = 1;
		break;
	case 'q':
		qflag = 1;
		break;
	case 's':
		srv = 1;
		mnt = 0;
		break;
	case 'S':
		srvname = EARGF(usage());
		break;
	case 'v':
		verify = 1;
		break;
	}ARGEND

	if(argc != 1)
		usage();

	init(argv[0], verify);
	
	if(!stdio){
		if(pipe(pfd) &lt; 0)
			sysfatal("pipe: %r");
		if(srv){
			snprint(buf, sizeof buf, "#s/%s", srvname);
			fd = create(buf, OWRITE, 0666);
			if(fd &lt; 0)
				sysfatal("create %s: %r", buf);
			if(fprint(fd, "%d", pfd[0]) &lt; 0)
				sysfatal("write %s: %r", buf);
		}
	}

	if(debug)
		fmtinstall('F', fcallfmt);
	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG)){
	case -1:
		sysfatal("fork");
	case 0:
		close(pfd[0]);
		io(pfd[1]);
		break;
	default:
		close(pfd[1]);	/* don't deadlock if child fails */
		if(mnt &amp;&amp; mount(pfd[0], -1, mntpoint, MREPL|MCREATE, "") &lt; 0)
			sysfatal("mount %s: %r", mntpoint);
	}
	exits(0);
}

char*
rversion(Fid*)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);
	if(rhdr.msize &gt; mesgsize)
		thdr.msize = mesgsize;
	else
		thdr.msize = rhdr.msize;
	if(strcmp(rhdr.version, "9P2000") != 0)
		return Eversion;
	thdr.version = "9P2000";
	return 0;
}

char*
rauth(Fid*)
{
	return Enoauth;
}

char*
rflush(Fid *f)
{
	USED(f);
	return 0;
}

char*
rattach(Fid *f)
{
	/* no authentication! */
	f-&gt;busy = 1;
	f-&gt;paq = paqCpy(root);
	thdr.qid = f-&gt;paq-&gt;qid;
	if(rhdr.uname[0])
		f-&gt;user = estrdup(rhdr.uname);
	else
		f-&gt;user = "none";
	return 0;
}

char*
clone(Fid *f, Fid **res)
{
	Fid *nf;

	if(f-&gt;open)
		return Eisopen;
	if(f-&gt;busy == 0)
		return Enotexist;
	nf = newfid(rhdr.newfid);
	nf-&gt;busy = 1;
	nf-&gt;open = 0;
	nf-&gt;paq = paqCpy(f-&gt;paq);
	nf-&gt;user = strdup(f-&gt;user);
	*res = nf;
	return 0;
}

char*
rwalk(Fid *f)
{
	Paq *paq, *npaq;
	Fid *nf;
	int nqid, nwname;
	Qid qid;
	char *err;

	if(f-&gt;busy == 0)
		return Enotexist;
	nf = nil;
	if(rhdr.fid != rhdr.newfid){
		err = clone(f, &amp;nf);
		if(err)
			return err;
		f = nf;	/* walk the new fid */
	}

	nwname = rhdr.nwname;

	/* easy case */
	if(nwname == 0) {
		thdr.nwqid = 0;
		return 0;
	}

	paq = paqCpy(f-&gt;paq);
	qid = paq-&gt;qid;
	err = nil;

	for(nqid = 0; nqid &lt; nwname; nqid++){
		if((qid.type &amp; QTDIR) == 0){
			err = Enotdir;
			break;
		}
		if(!perm(paq-&gt;dir, f-&gt;user, Pexec)) {
			err = Eperm;
			break;
		}
		npaq = paqWalk(paq, rhdr.wname[nqid]);
		if(npaq == nil) {
			err = Enotexist;
			break;
		}
		paqFree(paq);
		paq = npaq;
		qid = paq-&gt;qid;
		thdr.wqid[nqid] = qid;
	}

	thdr.nwqid = nqid;

	if(nqid == nwname){
		/* success */
		paqFree(f-&gt;paq);
		f-&gt;paq = paq;
		return 0;
	}

	paqFree(paq);
	if(nf != nil)
		rclunk(nf);

	/* only error on the first element */
	if(nqid == 0)
		return err;

	return 0;
}

char *
ropen(Fid *f)
{
	int mode, trunc;

	if(f-&gt;open)
		return Eisopen;
	if(f-&gt;busy == 0)
		return Enotexist;
	mode = rhdr.mode;
	if(f-&gt;paq-&gt;qid.type &amp; QTDIR){
		if(mode != OREAD)
			return Eperm;
		thdr.qid = f-&gt;paq-&gt;qid;
		return 0;
	}
	if(mode &amp; ORCLOSE)
		return Erdonly;
	trunc = mode &amp; OTRUNC;
	mode &amp;= OPERM;
	if(mode==OWRITE || mode==ORDWR || trunc)
		return Erdonly;
	if(mode==OREAD)
		if(!perm(f-&gt;paq-&gt;dir, f-&gt;user, Pread))
			return Eperm;
	if(mode==OEXEC)
		if(!perm(f-&gt;paq-&gt;dir, f-&gt;user, Pexec))
			return Eperm;
	thdr.qid = f-&gt;paq-&gt;qid;
	f-&gt;open = 1;
	return 0;
}

char *
rcreate(Fid *f)
{
	if(f-&gt;open)
		return Eisopen;
	if(f-&gt;busy == 0)
		return Enotexist;
	return Erdonly;
}

char *
readdir(Fid *f)
{
	PaqDir *pd;
	uchar *p, *ep;
	ulong off;
	int n, cnt, i;
	uchar *buf;
	Block *ptr, *b;

	buf = (uchar*)thdr.data;
	cnt = rhdr.count;
	if(rhdr.offset == 0)
		f-&gt;offset = 0;
	off = f-&gt;offset;

	if(rootfile &amp;&amp; f-&gt;paq == root){
		if(off != 0){
			rhdr.count = 0;
			return nil;
		}
		n = packDir(rootfile-&gt;dir, buf, cnt);
		rhdr.count = n;
		return nil;
	}

	ptr = blockLoad(f-&gt;paq-&gt;dir-&gt;offset, PointerBlock);
	if(ptr == nil)
		return Ebadblock;
	i = off/blocksize;
	off -= i*blocksize;

	thdr.count = 0;
	b = blockLoad(getl(ptr-&gt;data + i*4), DirBlock);
	while(b != nil) {
		p = b-&gt;data + off;
		ep = b-&gt;data + blocksize;
		if(checkDirSize(p, ep)) {
			pd = getDir(p);
			n = packDir(pd, buf, cnt);
			paqDirFree(pd);
			if(n == 0) {
				blockFree(b);
				if(thdr.count == 0) {
					blockFree(ptr);
					return Edirtoobig;
				}
				break;
			}
			off += gets(p);
			cnt -= n;
			buf += n;
			thdr.count += n;
		} else {
			off = 0;
			i++;
			blockFree(b);
			b = blockLoad(getl(ptr-&gt;data + i*4), DirBlock);
		}
	}
	f-&gt;offset = i*blocksize + off;
	blockFree(ptr);

	return 0;
}

char*
rread(Fid *f)
{
	PaqDir *pd;
	uchar *buf;
	vlong off;
	ulong uoff;
	int n, cnt, i;
	Block *ptr, *b;

	if(f-&gt;busy == 0)
		return Enotexist;
	if(f-&gt;paq-&gt;qid.type &amp; QTDIR)
		return readdir(f);
	pd = f-&gt;paq-&gt;dir;
	off = rhdr.offset;
	buf = (uchar*)thdr.data;
	cnt = rhdr.count;

	thdr.count = 0;
	if(off &gt;= pd-&gt;length || cnt == 0)
		return 0;

	if(cnt &gt; pd-&gt;length - off)
		cnt = pd-&gt;length - off;

	ptr = blockLoad(pd-&gt;offset, PointerBlock);
	if(ptr == nil)
		return Ebadblock;

	i = off/blocksize;
	uoff = off-i*blocksize;

	while(cnt &gt; 0) {
		b = blockLoad(getl(ptr-&gt;data + i*4), DataBlock);
		if(b == nil) {
			blockFree(ptr);
			return Ebadblock;
		}
		n = blocksize - uoff;
		if(n &gt; cnt)
			n = cnt;
		memmove(buf, b-&gt;data + uoff, n);
		cnt -= n;
		thdr.count += n;
		buf += n;
		uoff = 0;
		i++;
		blockFree(b);
	}
	blockFree(ptr);
	return 0;
}

char*
rwrite(Fid *f)
{
	if(f-&gt;busy == 0)
		return Enotexist;
	return Erdonly;
}

char *
rclunk(Fid *f)
{
	f-&gt;busy = 0;
	f-&gt;open = 0;
	free(f-&gt;user);
	paqFree(f-&gt;paq);
	return 0;
}

char *
rremove(Fid *f)
{
	rclunk(f);
	return Erdonly;
}

char *
rstat(Fid *f)
{
	if(f-&gt;busy == 0)
		return Enotexist;
	thdr.stat = (uchar*)thdr.data;
	thdr.nstat = packDir(f-&gt;paq-&gt;dir, thdr.stat, mesgsize);
	if(thdr.nstat == 0)
		return Edirtoobig;
	return 0;
}

char *
rwstat(Fid *f)
{
	if(f-&gt;busy == 0)
		return Enotexist;
	return Erdonly;
}

Paq*
paqCpy(Paq *s)
{
	s-&gt;ref++;
	return s;
}

void
paqFree(Paq *p)
{
	if(p == nil)
		return;
	p-&gt;ref--;
	if(p-&gt;ref &gt; 0)
		return;
assert(p != root);
	paqFree(p-&gt;up);
	paqDirFree(p-&gt;dir);
	free(p);
}

void
paqDirFree(PaqDir *pd)
{
	if(pd == nil)
		return;
	free(pd-&gt;name);
	free(pd-&gt;uid);
	free(pd-&gt;gid);
	free(pd);
}

Qid
paqDirQid(PaqDir *d)
{
	Qid q;

	q.path = d-&gt;qid;
	q.vers = 0;
	q.type = d-&gt;mode &gt;&gt; 24;

	return q;
}

int
packDir(PaqDir *s, uchar *buf, int n)
{
	Dir dir;

	memset(&amp;dir, 0, sizeof(dir));
	dir.qid = paqDirQid(s);
	dir.mode = s-&gt;mode;
	dir.atime = s-&gt;mtime;
	dir.mtime = s-&gt;mtime;
	dir.length = s-&gt;length;
	dir.name = s-&gt;name;
	dir.uid = s-&gt;uid;
	dir.gid = s-&gt;gid;
	dir.muid = s-&gt;uid;

	n = convD2M(&amp;dir, buf, n);
	if(n &lt; STATFIXLEN)
		return 0;
	return n;
}

Block *
blockLoad(ulong addr, int type)
{
	ulong age;
	int i, j;
	Block *b;

	if(addr == 0)
		return nil;

	cacheage++;

	/* age has wraped */
	if(cacheage == 0) {
		for(i=0; i&lt;cachesize; i++)
			cache[i].age = 0;
	}

	j = -1;
	age = ~0;
	for(i=0; i&lt;cachesize; i++) {
		b = &amp;cache[i];
		if(b-&gt;age &lt; age &amp;&amp; b-&gt;ref == 0) {
			age = b-&gt;age;
			j = i;
		}
		if(b-&gt;addr != addr)
			continue;
		b-&gt;age = cacheage;
		b-&gt;ref++;
		return b;
	}
	if(j &lt; 0)
		sysfatal("no empty spots in cache!");
	b = &amp;cache[j];
	assert(b-&gt;ref == 0);

	if(!blockRead(b-&gt;data, addr, type)) {
		b-&gt;addr = 0;
		b-&gt;age = 0;
		return nil;
	}

	b-&gt;age = cacheage;
	b-&gt;addr = addr;
	b-&gt;ref = 1;
	
	return b;
}

void
blockFree(Block *b)
{
	if(b == nil)
		return;
	if(--b-&gt;ref &gt; 0)
		return;
	assert(b-&gt;ref == 0);
}

Paq*
paqWalk(Paq *s, char *name)
{
	Block *ptr, *b;
	uchar *p, *ep;
	PaqDir *pd;
	int i, n;
	Paq *ss;

	if(strcmp(name, "..") == 0)
		return paqCpy(s-&gt;up);

	if(rootfile &amp;&amp; s == root){
		if(strcmp(name, rootfile-&gt;dir-&gt;name) == 0)
			return paqCpy(rootfile);
		return nil;
	}

	ptr = blockLoad(s-&gt;dir-&gt;offset, PointerBlock);
	if(ptr == nil)
		return nil;

	for(i=0; i&lt;blocksize/4; i++) {
		b = blockLoad(getl(ptr-&gt;data+i*4), DirBlock);
		if(b == nil)
			break;
		p = b-&gt;data;
		ep = p + blocksize;
		while(checkDirSize(p, ep)) {
			n = gets(p);
			pd = getDir(p);
			if(strcmp(pd-&gt;name, name) == 0) {
				ss = emallocz(sizeof(Paq));
				ss-&gt;ref = 1;
				ss-&gt;up = paqCpy(s);
				ss-&gt;dir = pd;
				ss-&gt;qid = paqDirQid(pd);
				blockFree(b);
				blockFree(ptr);
				return ss;
			}
			paqDirFree(pd);
			p += n;
		}
		blockFree(b);
	}

	blockFree(ptr);
	return nil;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emallocz(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(int fd)
{
	char *err;
	int n, pid;
	uchar *mdata;

	mdata = emalloc(mesgsize);

	pid = getpid();

	for(;;){
		n = read9pmsg(fd, mdata, mesgsize);
		if(n &lt; 0)
			sysfatal("mount read");
		if(n == 0)
			break;
		if(convM2S(mdata, n, &amp;rhdr) == 0)
			continue;

		if(debug)
			fprint(2, "paqfs %d:&lt;-%F\n", pid, &amp;rhdr);

		thdr.data = (char*)mdata + IOHDRSZ;
		if(!fcalls[rhdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[rhdr.type])(newfid(rhdr.fid));
		if(err){
			thdr.type = Rerror;
			thdr.ename = err;
		}else{
			thdr.type = rhdr.type + 1;
			thdr.fid = rhdr.fid;
		}
		thdr.tag = rhdr.tag;
		if(debug)
			fprint(2, "paqfs %d:-&gt;%F\n", pid, &amp;thdr);/**/
		n = convS2M(&amp;thdr, mdata, mesgsize);
		if(n == 0)
			sysfatal("convS2M sysfatal on write");
		if(write(fd, mdata, n) != n)
			sysfatal("mount write");
	}
}

int
perm(PaqDir *s, char *user, int p)
{
	ulong perm = s-&gt;mode;

	if((p*Pother) &amp; perm)
		return 1;
	if((noauth || strcmp(user, s-&gt;gid)==0) &amp;&amp; ((p*Pgroup) &amp; perm))
		return 1;
	if((noauth || strcmp(user, s-&gt;uid)==0) &amp;&amp; ((p*Powner) &amp; perm))
		return 1;
	return 0;
}

void
init(char *file, int verify)
{
	PaqHeader hdr;
	PaqTrailer tlr;
	Dir *dir;
	int i;
	uchar *p;
	DigestState *ds = nil;
	PaqDir *r;
	Block *b;
	ulong offset;

	inflateinit();

	bin = Bopen(file, OREAD);
	if(bin == nil)
		sysfatal("could not open file: %s: %r", file);
	if(verify)
		ds = sha1(0, 0, 0, 0);
	
	readHeader(&amp;hdr, file, ds);
	blocksize = hdr.blocksize;

	if(verify) {
		readBlocks(file, ds);
	} else {
		dir = dirstat(file);
		if(dir == nil)
			sysfatal("could not stat file: %s: %r", file);
		offset = dir-&gt;length - TrailerSize;
		free(dir);
		if(Bseek(bin, offset, 0) != offset)
			sysfatal("could not seek to trailer: %s", file);
	}

	readTrailer(&amp;tlr, file, ds);

	/* asctime includes a newline - yuk */
	if(!qflag){
		fprint(2, "%s: %s", hdr.label, asctime(gmtime(hdr.time)));
		fprint(2, "fingerprint: %V\n", tlr.sha1);
	}

	cache = emallocz(cachesize*sizeof(Block));
	p = emalloc(cachesize*blocksize);
	for(i=0; i&lt;cachesize; i++) {
		cache[i].data = p;
		p += blocksize;
	}

	/* hand craft root */
	b = blockLoad(tlr.root, DirBlock);
	if(b == nil || !checkDirSize(b-&gt;data, b-&gt;data+blocksize))
		sysfatal("could not read root block: %s", file);
	r = getDir(b-&gt;data);
	blockFree(b);
	root = emallocz(sizeof(Paq));
	root-&gt;qid = paqDirQid(r);
	root-&gt;ref = 1;
	root-&gt;dir = r;
	root-&gt;up = root;	/* parent of root is root */

	/* craft root directory if root is a normal file */
	if(!(root-&gt;qid.type&amp;QTDIR)){
		rootfile = root;
		root = emallocz(sizeof(Paq));
		root-&gt;qid = rootfile-&gt;qid;
		root-&gt;qid.type |= QTDIR;
		root-&gt;qid.path++;
		root-&gt;ref = 1;
		root-&gt;dir = emallocz(sizeof(PaqDir));
		*root-&gt;dir = *r;
		root-&gt;dir-&gt;mode |= DMDIR|0111;
		root-&gt;up = root;
	}
}

int
blockRead(uchar *data, ulong addr, int type)
{
	uchar buf[BlockSize];
	PaqBlock b;
	uchar *cdat;

	if(Bseek(bin, addr, 0) != addr){
		fprint(2, "paqfs: seek %lud: %r\n", addr);
		return 0;
	}
	if(Bread(bin, buf, BlockSize) != BlockSize){
		fprint(2, "paqfs: read %d at %lud: %r\n", BlockSize, addr);
		return 0;
	}
	getBlock(buf, &amp;b);
	if(b.magic != BlockMagic || b.size &gt; blocksize || b.type != type){
		fprint(2, "paqfs: bad block: magic %.8lux (want %.8ux) size %lud (max %d) type %ud (want %ud)\n",
			b.magic, BlockMagic, b.size, blocksize, b.type, type);
		return 0;
	}

	switch(b.encoding) {
	default:
		return 0;
	case NoEnc:
		if(Bread(bin, data, blocksize) &lt; blocksize)
			return 0;
		break;
	case DeflateEnc:
		cdat = emalloc(b.size);
		if(Bread(bin, cdat, b.size) &lt; b.size) {
			free(cdat);
			return 0;
		}
		if(inflateblock(data, blocksize, cdat, b.size) &lt; 0) {
			fprint(2, "inflate error: %r\n");
			free(cdat);
			return 0;
		}
		free(cdat);
		break;
	}
	if(adler32(0, data, blocksize) != b.adler32)
		return 0;
	return 1;
}

void
readHeader(PaqHeader *hdr, char *name, DigestState *ds)
{
	uchar buf[HeaderSize];
	
	if(Bread(bin, buf, HeaderSize) &lt; HeaderSize)
		sysfatal("could not read header: %s: %r", name);
	if(ds)
		sha1(buf, HeaderSize, 0, ds);
	getHeader(buf, hdr);
	if(hdr-&gt;magic != HeaderMagic)
		sysfatal("bad header magic 0x%lux: %s", hdr-&gt;magic, name);
	if(hdr-&gt;version != Version)
		sysfatal("unknown file version: %s", name);
}

void
readBlocks(char *name, DigestState *ds)
{
	uchar *buf;
	PaqBlock b;

	buf = emalloc(BlockSize+blocksize);

	for(;;) {
		if(Bread(bin, buf, 4) &lt; 4)
			sysfatal("could not read block: %s: %r", name);
		Bseek(bin, -4, 1);
		/* check if it is a data block */

		if(getl(buf) != BlockMagic)
			break;

		if(Bread(bin, buf, BlockSize) &lt; BlockSize)
			sysfatal("could not read block: %s: %r", name);
		if(ds)
			sha1(buf, BlockSize, 0, ds);
		getBlock(buf, &amp;b);

		if(b.size &gt; blocksize)
			sysfatal("bad block size: %lud: %s", b.size, name);
		if(ds) {
			if(Bread(bin, buf, b.size) &lt; b.size)
				sysfatal("sysfatal reading block: %s: %r", name);
			sha1(buf, b.size, 0, ds);
		} else
			Bseek(bin, b.size, 1);
	}

	free(buf);
}

void
readTrailer(PaqTrailer *tlr, char *name, DigestState *ds)
{
	uchar buf[TrailerSize];
	uchar digest[SHA1dlen];

	if(Bread(bin, buf, TrailerSize) &lt; TrailerSize)
		sysfatal("could not read trailer: %s: %r", name);
	getTrailer(buf, tlr);
	if(tlr-&gt;magic != TrailerMagic)
		sysfatal("bad trailer magic: %s", name);
	if(ds) {
		sha1(buf, TrailerSize-SHA1dlen, digest, ds);
		if(memcmp(digest, tlr-&gt;sha1, SHA1dlen) != 0)
			sysfatal("bad sha1 digest: %s", name);
	}
}

void *
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(!p)
		sysfatal("out of memory");
	return p;
}

void *
emallocz(ulong n)
{
	void *p;

	p = emalloc(n);
	memset(p, 0, n);

	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(!p)
		sysfatal("out of memory");
	return p;
}

char *
estrdup(char *s)
{
	s = strdup(s);
	if(s == nil)
		sysfatal("out of memory");
	return s;
}


ulong
getl(uchar *p)
{
	return (p[0]&lt;&lt;24) | (p[1]&lt;&lt;16) | (p[2]&lt;&lt;8) | p[3];
}


int
gets(uchar *p)
{
	return (p[0]&lt;&lt;8) | p[1];
}

int
checkDirSize(uchar *p, uchar *ep)
{
	int n;	
	int i;

	if(ep-p &lt; 2)
		return 0;
	n = gets(p);
	if(p+n &gt; ep)
		return 0;
	ep = p+n;
	p += 22;
	for(i=0; i&lt;3; i++) {
		if(p+2 &gt; ep)
			return 0;
		n = gets(p);
		if(p+n &gt; ep)
			return 0;
		p += n;
	}
	return 1;
}

void
getHeader(uchar *p, PaqHeader *h)
{
	h-&gt;magic = getl(p);
	h-&gt;version = gets(p+4);
	h-&gt;blocksize = gets(p+6);
	if((h-&gt;magic&gt;&gt;16) == BigHeaderMagic){
		h-&gt;magic = HeaderMagic;
		h-&gt;version = gets(p+2);
		h-&gt;blocksize = getl(p+4);
	}
	h-&gt;time = getl(p+8);
	memmove(h-&gt;label, p+12, sizeof(h-&gt;label));
	h-&gt;label[sizeof(h-&gt;label)-1] = 0;
}

void
getTrailer(uchar *p, PaqTrailer *t)
{
	t-&gt;magic = getl(p);
	t-&gt;root = getl(p+4);
	memmove(t-&gt;sha1, p+8, SHA1dlen);
}

void
getBlock(uchar *p, PaqBlock *b)
{
	b-&gt;magic = getl(p);
	b-&gt;size = gets(p+4);
	if((b-&gt;magic&gt;&gt;16) == BigBlockMagic){
		b-&gt;magic = BlockMagic;
		b-&gt;size = getl(p+2);
	}
	b-&gt;type = p[6];
	b-&gt;encoding = p[7];
	b-&gt;adler32 = getl(p+8);
}

PaqDir *
getDir(uchar *p)
{
	PaqDir *pd;

	pd = emallocz(sizeof(PaqDir));
	pd-&gt;qid = getl(p+2);
	pd-&gt;mode = getl(p+6);
	pd-&gt;mtime = getl(p+10);
	pd-&gt;length = getl(p+14);
	pd-&gt;offset = getl(p+18);
	p += 22;
	pd-&gt;name = getstr(p);
	p += gets(p);
	pd-&gt;uid = getstr(p);
	p += gets(p);
	pd-&gt;gid = getstr(p);

	return pd;
}


char *
getstr(uchar *p)
{
	char *s;
	int n;

	n = gets(p);
	s = emalloc(n+1);
	memmove(s, p+2, n);
	s[n] = 0;
	return s;
}

void
usage(void)
{
	fprint(2, "usage: %s [-disv] [-c cachesize] [-m mountpoint] [-M mesgsize] paqfile\n", argv0);
	exits("usage");
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

