<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/arcgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/arcgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;stdio.h&gt;
#include	&lt;math.h&gt;
#include	"pic.h"
#include	"y.tab.h"

void arc_extreme(double, double, double, double, double, double);
int quadrant(double x, double y);

obj *arcgen(int type)	/* handles circular and (eventually) elliptical arcs */
{
	static double prevw = HT10;
	static double prevh = HT5;
	static double prevrad = HT2;
	static int dtox[2][4] ={ 1, -1, -1, 1, 1, 1, -1, -1 };
	static int dtoy[2][4] ={ 1, 1, -1, -1, -1, 1, 1, -1 };
	static int dctrx[2][4] ={ 0, -1, 0, 1, 0, 1, 0, -1 };
	static int dctry[2][4] ={ 1, 0, -1, 0, -1, 0, 1, 0 };
	static int nexthv[2][4] ={ U_DIR, L_DIR, D_DIR, R_DIR, D_DIR, R_DIR, U_DIR, L_DIR };
	double dx2, dy2, ht, phi, r, d;
	int i, head, to, at, cw, invis, ddtype, battr;
	obj *p, *ppos;
	double fromx, fromy, tox, toy, fillval = 0;
	Attr *ap;

	prevrad = getfval("arcrad");
	prevh = getfval("arrowht");
	prevw = getfval("arrowwid");
	fromx = curx;
	fromy = cury;
	head = to = at = cw = invis = ddtype = battr = 0;
	for (i = 0; i &lt; nattr; i++) {
		ap = &amp;attr[i];
		switch (ap-&gt;a_type) {
		case TEXTATTR:
			savetext(ap-&gt;a_sub, ap-&gt;a_val.p);
			break;
		case HEAD:
			head += ap-&gt;a_val.i;
			break;
		case INVIS:
			invis = INVIS;
			break;
		case HEIGHT:	/* length of arrowhead */
			prevh = ap-&gt;a_val.f;
			break;
		case WIDTH:	/* width of arrowhead */
			prevw = ap-&gt;a_val.f;
			break;
		case RADIUS:
			prevrad = ap-&gt;a_val.f;
			break;
		case DIAMETER:
			prevrad = ap-&gt;a_val.f / 2;
			break;
		case CW:
			cw = 1;
			break;
		case FROM:	/* start point of arc */
			ppos = ap-&gt;a_val.o;
			fromx = ppos-&gt;o_x;
			fromy = ppos-&gt;o_y;
			break;
		case TO:	/* end point of arc */
			ppos = ap-&gt;a_val.o;
			tox = ppos-&gt;o_x;
			toy = ppos-&gt;o_y;
			to++;
			break;
		case AT:	/* center of arc */
			ppos = ap-&gt;a_val.o;
			curx = ppos-&gt;o_x;
			cury = ppos-&gt;o_y;
			at = 1;
			break;
		case UP:
			hvmode = U_DIR;
			break;
		case DOWN:
			hvmode = D_DIR;
			break;
		case RIGHT:
			hvmode = R_DIR;
			break;
		case LEFT:
			hvmode = L_DIR;
			break;
		case FILL:
			battr |= FILLBIT;
			if (ap-&gt;a_sub == DEFAULT)
				fillval = getfval("fillval");
			else
				fillval = ap-&gt;a_val.f;
			break;
		}
	}
	if (!at &amp;&amp; !to) {	/* the defaults are mostly OK */
		curx = fromx + prevrad * dctrx[cw][hvmode];
		cury = fromy + prevrad * dctry[cw][hvmode];
		tox = fromx + prevrad * dtox[cw][hvmode];
		toy = fromy + prevrad * dtoy[cw][hvmode];
		hvmode = nexthv[cw][hvmode];
	}
	else if (!at) {
		dx2 = (tox - fromx) / 2;
		dy2 = (toy - fromy) / 2;
		phi = atan2(dy2, dx2) + (cw ? -PI/2 : PI/2);
		if (prevrad &lt;= 0.0)
			prevrad = dx2*dx2+dy2*dy2;
		for (r=prevrad; (d = r*r - (dx2*dx2+dy2*dy2)) &lt;= 0.0; r *= 2)
			;	/* this kludge gets around too-small radii */
		prevrad = r;
		ht = sqrt(d);
		curx = fromx + dx2 + ht * cos(phi);
		cury = fromy + dy2 + ht * sin(phi);
		dprintf("dx2,dy2=%g,%g, phi=%g, r,ht=%g,%g\n",
			dx2, dy2, phi, r, ht);
	}
	else if (at &amp;&amp; !to) {	/* do we have all the cases??? */
		tox = fromx + prevrad * dtox[cw][hvmode];
		toy = fromy + prevrad * dtoy[cw][hvmode];
		hvmode = nexthv[cw][hvmode];
	}
	if (cw) {	/* interchange roles of from-to and heads */
		double temp;
		temp = fromx; fromx = tox; tox = temp;
		temp = fromy; fromy = toy; toy = temp;
		if (head == HEAD1)
			head = HEAD2;
		else if (head == HEAD2)
			head = HEAD1;
	}
	p = makenode(type, 7);
	arc_extreme(fromx, fromy, tox, toy, curx, cury);
	p-&gt;o_val[0] = fromx;
	p-&gt;o_val[1] = fromy;
	p-&gt;o_val[2] = tox;
	p-&gt;o_val[3] = toy;
	if (cw) {
		curx = fromx;
		cury = fromy;
	} else {
		curx = tox;
		cury = toy;
	}
	p-&gt;o_val[4] = prevw;
	p-&gt;o_val[5] = prevh;
	p-&gt;o_val[6] = prevrad;
	p-&gt;o_attr = head | (cw ? CW_ARC : 0) | invis | ddtype | battr;
	p-&gt;o_fillval = fillval;
	if (head)
		p-&gt;o_nhead = getfval("arrowhead");
	dprintf("arc rad %g at %g %g from %g %g to %g %g head %g %g\n",
		prevrad, p-&gt;o_x, p-&gt;o_y,
		p-&gt;o_val[0], p-&gt;o_val[1], p-&gt;o_val[2], p-&gt;o_val[3], p-&gt;o_val[4], p-&gt;o_val[5]);
	return(p);
}

/***************************************************************************
   bounding box of a circular arc             Eric Grosse  24 May 84

Conceptually, this routine generates a list consisting of the start,
end, and whichever north, east, south, and west points lie on the arc.
The bounding box is then the range of this list.
    list = {start,end}
    j = quadrant(start)
    k = quadrant(end)
    if( j==k &amp;&amp; long way 'round )  append north,west,south,east
    else
      while( j != k )
         append center+radius*[j-th of north,west,south,east unit vectors]
         j += 1  (mod 4)
    return( bounding box of list )
The following code implements this, with simple optimizations.
***********************************************************************/


void arc_extreme(double x0, double y0, double x1, double y1, double xc, double yc)
			  /* start, end, center */
{
	/* assumes center isn't too far out */
	double r, xmin, ymin, xmax, ymax;
	int j, k;
	x0 -= xc; y0 -= yc;	/* move to center */
	x1 -= xc; y1 -= yc;
	xmin = (x0&lt;x1)?x0:x1; ymin = (y0&lt;y1)?y0:y1;
	xmax = (x0&gt;x1)?x0:x1; ymax = (y0&gt;y1)?y0:y1;
	r = sqrt(x0*x0 + y0*y0);
	if (r &gt; 0.0) {
		j = quadrant(x0,y0);
		k = quadrant(x1,y1);
		if (j == k &amp;&amp; y1*x0 &lt; x1*y0) {
			/* viewed as complex numbers, if Im(z1/z0)&lt;0, arc is big */
			if( xmin &gt; -r) xmin = -r; if( ymin &gt; -r) ymin = -r;
			if( xmax &lt;  r) xmax =  r; if( ymax &lt;  r) ymax =  r;
		} else {
			while (j != k) {
				switch (j) {
					case 1: if( ymax &lt;  r) ymax =  r; break; /* north */
					case 2: if( xmin &gt; -r) xmin = -r; break; /* west */
					case 3: if( ymin &gt; -r) ymin = -r; break; /* south */
					case 4: if( xmax &lt;  r) xmax =  r; break; /* east */
				}
				j = j%4 + 1;
			}
		}
	}
	xmin += xc; ymin += yc;
	xmax += xc; ymax += yc;
	extreme(xmin, ymin);
	extreme(xmax, ymax);
}

quadrant(double x, double y)
{
	if (     x&gt;=0.0 &amp;&amp; y&gt; 0.0) return(1);
	else if( x&lt; 0.0 &amp;&amp; y&gt;=0.0) return(2);
	else if( x&lt;=0.0 &amp;&amp; y&lt; 0.0) return(3);
	else if( x&gt; 0.0 &amp;&amp; y&lt;=0.0) return(4);
	else			   return 0;	/* shut up lint */
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

