<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/pic/blockgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/pic/blockgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include "pic.h"
#include "y.tab.h"

#define	NBRACK	20	/* depth of [...] */
#define	NBRACE	20	/* depth of {...} */

struct pushstack stack[NBRACK];
int	nstack	= 0;
struct pushstack bracestack[NBRACE];
int	nbstack	= 0;

void blockadj(obj *);

obj *leftthing(int c)	/* called for {... or [... */
			/* really ought to be separate functions */
{
	obj *p;

	if (c == '[') {
		if (nstack &gt;= NBRACK)
			ERROR "[...] nested too deep" FATAL;
		stack[nstack].p_x = curx;
		stack[nstack].p_y = cury;
		stack[nstack].p_hvmode = hvmode;
		curx = cury = 0;
		stack[nstack].p_xmin = xmin;
		stack[nstack].p_xmax = xmax;
		stack[nstack].p_ymin = ymin;
		stack[nstack].p_ymax = ymax;
		nstack++;
		xmin = ymin = 30000;
		xmax = ymax = -30000;
		p = makenode(BLOCK, 7);
		p-&gt;o_val[4] = nobj;	/* 1st item within [...] */
		if (p-&gt;o_nobj != nobj-1)
			fprintf(stderr, "nobjs wrong%d %d\n", p-&gt;o_nobj, nobj);
	} else {
		if (nbstack &gt;= NBRACK)
			ERROR "{...} nested too deep" FATAL;
		bracestack[nbstack].p_x = curx;
		bracestack[nbstack].p_y = cury;
		bracestack[nbstack].p_hvmode = hvmode;
		nbstack++;
		p = NULL;
	}
	return(p);
}

obj *rightthing(obj *p, int c)	/* called for ... ] or ... } */
{
	obj *q;

	if (c == '}') {
		nbstack--;
		curx = bracestack[nbstack].p_x;
		cury = bracestack[nbstack].p_y;
		hvmode = bracestack[nbstack].p_hvmode;
		q = makenode(MOVE, 0);
		dprintf("M %g %g\n", curx, cury);
	} else {
		nstack--;
		curx = stack[nstack].p_x;
		cury = stack[nstack].p_y;
		hvmode = stack[nstack].p_hvmode;
		q = makenode(BLOCKEND, 7);
		q-&gt;o_val[4] = p-&gt;o_nobj + 1;	/* back pointer */
		p-&gt;o_val[5] = q-&gt;o_nobj - 1;	/* forward pointer */
		if (xmin &gt; xmax)	/* nothing happened */
			xmin = xmax;
		if (ymin &gt; ymax)
			ymin = ymax;
		p-&gt;o_val[0] = xmin; p-&gt;o_val[1] = ymin;
		p-&gt;o_val[2] = xmax; p-&gt;o_val[3] = ymax;
		p-&gt;o_symtab = q-&gt;o_symtab = stack[nstack+1].p_symtab;
		xmin = stack[nstack].p_xmin;
		ymin = stack[nstack].p_ymin;
		xmax = stack[nstack].p_xmax;
		ymax = stack[nstack].p_ymax;
	}
	return(q);
}

obj *blockgen(obj *p, obj *q)	/* handles [...] */
{
	int i, invis, at, with;
	double ddval, h, w, xwith, ywith;
	double x0, y0, x1, y1, cx, cy;
	obj *ppos;
	Attr *ap;

	invis = at = 0;
	with = xwith = ywith = 0;
	ddval = 0;
	w = p-&gt;o_val[2] - p-&gt;o_val[0];
	h = p-&gt;o_val[3] - p-&gt;o_val[1];
	cx = (p-&gt;o_val[2] + p-&gt;o_val[0]) / 2;	/* geom ctr of [] wrt local orogin */
	cy = (p-&gt;o_val[3] + p-&gt;o_val[1]) / 2;
	dprintf("cx,cy=%g,%g\n", cx, cy);
	for (i = 0; i &lt; nattr; i++) {
		ap = &amp;attr[i];
		switch (ap-&gt;a_type) {
		case HEIGHT:
			h = ap-&gt;a_val.f;
			break;
		case WIDTH:
			w = ap-&gt;a_val.f;
			break;
		case WITH:
			with = ap-&gt;a_val.i;	/* corner */
			break;
		case PLACE:	/* actually with position ... */
			ppos = ap-&gt;a_val.o;
			xwith = cx - ppos-&gt;o_x;
			ywith = cy - ppos-&gt;o_y;
			with = PLACE;
			break;
		case AT:
		case FROM:
			ppos = ap-&gt;a_val.o;
			curx = ppos-&gt;o_x;
			cury = ppos-&gt;o_y;
			at++;
			break;
		case INVIS:
			invis = INVIS;
			break;
		case TEXTATTR:
			savetext(ap-&gt;a_sub, ap-&gt;a_val.p);
			break;
		}
	}
	if (with) {
		switch (with) {
		case NORTH:	ywith = -h / 2; break;
		case SOUTH:	ywith = h / 2; break;
		case EAST:	xwith = -w / 2; break;
		case WEST:	xwith = w / 2; break;
		case NE:	xwith = -w / 2; ywith = -h / 2; break;
		case SE:	xwith = -w / 2; ywith = h / 2; break;
		case NW:	xwith = w / 2; ywith = -h / 2; break;
		case SW:	xwith = w / 2; ywith = h / 2; break;
		}
		curx += xwith;
		cury += ywith;
	}
	if (!at) {
		if (isright(hvmode))
			curx += w / 2;
		else if (isleft(hvmode))
			curx -= w / 2;
		else if (isup(hvmode))
			cury += h / 2;
		else
			cury -= h / 2;
	}
	x0 = curx - w / 2;
	y0 = cury - h / 2;
	x1 = curx + w / 2;
	y1 = cury + h / 2;
	extreme(x0, y0);
	extreme(x1, y1);
	p-&gt;o_x = curx;
	p-&gt;o_y = cury;
	p-&gt;o_nt1 = ntext1;
	p-&gt;o_nt2 = ntext;
	ntext1 = ntext;
	p-&gt;o_val[0] = w;
	p-&gt;o_val[1] = h;
	p-&gt;o_val[2] = cx;
	p-&gt;o_val[3] = cy;
	p-&gt;o_val[5] = q-&gt;o_nobj - 1;		/* last item in [...] */
	p-&gt;o_ddval = ddval;
	p-&gt;o_attr = invis;
	dprintf("[] %g %g %g %g at %g %g, h=%g, w=%g\n", x0, y0, x1, y1, curx, cury, h, w);
	if (isright(hvmode))
		curx = x1;
	else if (isleft(hvmode))
		curx = x0;
	else if (isup(hvmode))
		cury = y1;
	else
		cury = y0;
	for (i = 0; i &lt;= 5; i++)
		q-&gt;o_val[i] = p-&gt;o_val[i];
	stack[nstack+1].p_symtab = NULL;	/* so won't be found again */
	blockadj(p);	/* fix up coords for enclosed blocks */
	return(p);
}

void blockadj(obj *p)	/* adjust coords in block starting at p */
{
	double dx, dy;
	int n, lev;

	dx = p-&gt;o_x - p-&gt;o_val[2];
	dy = p-&gt;o_y - p-&gt;o_val[3];
	n = p-&gt;o_nobj + 1;
	dprintf("into blockadj: dx,dy=%g,%g\n", dx, dy);
	for (lev = 1; lev &gt; 0; n++) {
		p = objlist[n];
		if (p-&gt;o_type == BLOCK)
			lev++;
		else if (p-&gt;o_type == BLOCKEND)
			lev--;
		dprintf("blockadj: type=%d o_x,y=%g,%g;", p-&gt;o_type, p-&gt;o_x, p-&gt;o_y);
		p-&gt;o_x += dx;
		p-&gt;o_y += dy;
		dprintf(" becomes %g,%g\n", p-&gt;o_x, p-&gt;o_y);
		switch (p-&gt;o_type) {	/* other absolute coords */
		case LINE:
		case ARROW:
		case SPLINE:
			p-&gt;o_val[0] += dx;
			p-&gt;o_val[1] += dy;
			break;
		case ARC:
			p-&gt;o_val[0] += dx;
			p-&gt;o_val[1] += dy;
			p-&gt;o_val[2] += dx;
			p-&gt;o_val[3] += dy;
			break;
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

