<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/plumb/fsys.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/plumb/fsys.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include &lt;thread.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "plumber.h"

enum
{
	Stack = 16*1024
};

typedef struct Dirtab Dirtab;
typedef struct Fid Fid;
typedef struct Holdq Holdq;
typedef struct Readreq Readreq;
typedef struct Sendreq Sendreq;

struct Dirtab
{
	char		*name;
	uchar	type;
	uint		qid;
	uint		perm;
	int		nopen;		/* #fids open on this port */
	Fid		*fopen;
	Holdq	*holdq;
	Readreq	*readq;
	Sendreq	*sendq;
};

struct Fid
{
	int		fid;
	int		busy;
	int		open;
	int		mode;
	Qid		qid;
	Dirtab	*dir;
	long		offset;		/* zeroed at beginning of each message, read or write */
	char		*writebuf;		/* partial message written so far; offset tells how much */
	Fid		*next;
	Fid		*nextopen;
};

struct Readreq
{
	Fid		*fid;
	Fcall		*fcall;
	uchar	*buf;
	Readreq	*next;
};

struct Sendreq
{
	int			nfid;		/* number of fids that should receive this message */
	int			nleft;		/* number left that haven't received it */
	Fid			**fid;	/* fid[nfid] */
	Plumbmsg	*msg;
	char			*pack;	/* plumbpack()ed message */
	int			npack;	/* length of pack */
	Sendreq		*next;
};

struct Holdq
{
	Plumbmsg	*msg;
	Holdq		*next;
};

struct	/* needed because incref() doesn't return value */
{
	Lock;
	int			ref;
} rulesref;

enum
{
	DEBUG	= 0,
	NDIR	= 50,
	Nhash	= 16,

	Qdir		= 0,
	Qrules	= 1,
	Qsend	= 2,
	Qport	= 3,
	NQID	= Qport
};

static Dirtab dir[NDIR] =
{
	{ ".",			QTDIR,	Qdir,			0500|DMDIR },
	{ "rules",		QTFILE,	Qrules,		0600 },
	{ "send",		QTFILE,	Qsend,		0200 },
};
static int	ndir = NQID;

static int		srvfd;
static int		srvclosefd;			/* rock for end of pipe to close */
static int		clockfd;
static int		clock;
static Fid		*fids[Nhash];
static QLock	readlock;
static QLock	queue;
static char	srvfile[128];
static int		messagesize = 8192+IOHDRSZ;	/* good start */

static void	fsysproc(void*);
static void fsysrespond(Fcall*, uchar*, char*);
static Fid*	newfid(int);

static Fcall* fsysflush(Fcall*, uchar*, Fid*);
static Fcall* fsysversion(Fcall*, uchar*, Fid*);
static Fcall* fsysauth(Fcall*, uchar*, Fid*);
static Fcall* fsysattach(Fcall*, uchar*, Fid*);
static Fcall* fsyswalk(Fcall*, uchar*, Fid*);
static Fcall* fsysopen(Fcall*, uchar*, Fid*);
static Fcall* fsyscreate(Fcall*, uchar*, Fid*);
static Fcall* fsysread(Fcall*, uchar*, Fid*);
static Fcall* fsyswrite(Fcall*, uchar*, Fid*);
static Fcall* fsysclunk(Fcall*, uchar*, Fid*);
static Fcall* fsysremove(Fcall*, uchar*, Fid*);
static Fcall* fsysstat(Fcall*, uchar*, Fid*);
static Fcall* fsyswstat(Fcall*, uchar*, Fid*);

Fcall* 	(*fcall[Tmax])(Fcall*, uchar*, Fid*) =
{
	[Tflush]	= fsysflush,
	[Tversion]	= fsysversion,
	[Tauth]	= fsysauth,
	[Tattach]	= fsysattach,
	[Twalk]	= fsyswalk,
	[Topen]	= fsysopen,
	[Tcreate]	= fsyscreate,
	[Tread]	= fsysread,
	[Twrite]	= fsyswrite,
	[Tclunk]	= fsysclunk,
	[Tremove]= fsysremove,
	[Tstat]	= fsysstat,
	[Twstat]	= fsyswstat,
};

char	Ebadfcall[] =	"bad fcall type";
char	Eperm[] = 	"permission denied";
char	Enomem[] =	"malloc failed for buffer";
char	Enotdir[] =	"not a directory";
char	Enoexist[] =	"plumb file does not exist";
char	Eisdir[] =		"file is a directory";
char	Ebadmsg[] =	"bad plumb message format";
char Enosuchport[] ="no such plumb port";
char Enoport[] =	"couldn't find destination for message";
char	Einuse[] = 	"file already open";

/*
 * Add new port.  A no-op if port already exists or is the null string
 */
void
addport(char *port)
{
	int i;

	if(port == nil)
		return;
	for(i=NQID; i&lt;ndir; i++)
		if(strcmp(port, dir[i].name) == 0)
			return;
	if(i == NDIR){
		fprint(2, "plumb: too many ports; max %d\n", NDIR);
		return;
	}
	ndir++;
	dir[i].name = estrdup(port);
	dir[i].qid = i;
	dir[i].perm = 0400;
	nports++;
	ports = erealloc(ports, nports*sizeof(char*));
	ports[nports-1] = dir[i].name;
}

static ulong
getclock(void)
{
	char buf[32];

	seek(clockfd, 0, 0);
	read(clockfd, buf, sizeof buf);
	return atoi(buf);
}

void
startfsys(void)
{
	int p[2], fd;

	fmtinstall('F', fcallfmt);
	clockfd = open("/dev/time", OREAD|OCEXEC);
	clock = getclock();
	if(pipe(p) &lt; 0)
		error("can't create pipe: %r");
	/* 0 will be server end, 1 will be client end */
	srvfd = p[0];
	srvclosefd = p[1];
	sprint(srvfile, "/srv/plumb.%s.%d", user, getpid());
	if(putenv("plumbsrv", srvfile) &lt; 0)
		error("can't write $plumbsrv: %r");
	fd = create(srvfile, OWRITE|OCEXEC|ORCLOSE, 0600);
	if(fd &lt; 0)
		error("can't create /srv file: %r");
	if(fprint(fd, "%d", p[1]) &lt;= 0)
		error("can't write /srv/file: %r");
	/* leave fd open; ORCLOSE will take care of it */

	procrfork(fsysproc, nil, Stack, RFFDG);

	close(p[0]);
	if(mount(p[1], -1, "/mnt/plumb", MREPL, "") &lt; 0)
		error("can't mount /mnt/plumb: %r");
	close(p[1]);
}

static void
fsysproc(void*)
{
	int n;
	Fcall *t;
	Fid *f;
	uchar *buf;

	close(srvclosefd);
	srvclosefd = -1;
	t = nil;
	for(;;){
		buf = malloc(messagesize);	/* avoid memset of emalloc */
		if(buf == nil)
			error("malloc failed: %r");
		qlock(&amp;readlock);
		n = read9pmsg(srvfd, buf, messagesize);
		if(n &lt;= 0){
			if(n &lt; 0)
				error("i/o error on server channel");
			threadexitsall("unmounted");
		}
		if(readlock.head == nil)	/* no other processes waiting to read; start one */
			proccreate(fsysproc, nil, Stack);
		qunlock(&amp;readlock);
		if(t == nil)
			t = emalloc(sizeof(Fcall));
		if(convM2S(buf, n, t) != n)
			error("convert error in convM2S");
		if(DEBUG)
			fprint(2, "&lt;= %F\n", t);
		if(fcall[t-&gt;type] == nil)
			fsysrespond(t, buf, Ebadfcall);
		else{
			if(t-&gt;type==Tversion || t-&gt;type==Tauth)
				f = nil;
			else
				f = newfid(t-&gt;fid);
			t = (*fcall[t-&gt;type])(t, buf, f);
		}
	}
}

static void
fsysrespond(Fcall *t, uchar *buf, char *err)
{
	int n;

	if(err){
		t-&gt;type = Rerror;
		t-&gt;ename = err;
	}else
		t-&gt;type++;
	if(buf == nil)
		buf = emalloc(messagesize);
	n = convS2M(t, buf, messagesize);
	if(n &lt; 0)
		error("convert error in convS2M");
	if(write(srvfd, buf, n) != n)
		error("write error in respond");
	if(DEBUG)
		fprint(2, "=&gt; %F\n", t);
	free(buf);
}

static
Fid*
newfid(int fid)
{
	Fid *f, *ff, **fh;

	qlock(&amp;queue);
	ff = nil;
	fh = &amp;fids[fid&amp;(Nhash-1)];
	for(f=*fh; f; f=f-&gt;next)
		if(f-&gt;fid == fid)
			goto Return;
		else if(ff==nil &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		f = ff;
		goto Return;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = *fh;
	*fh = f;
    Return:
	qunlock(&amp;queue);
	return f;
}

static uint
dostat(Dirtab *dir, uchar *buf, uint nbuf, uint clock)
{
	Dir d;

	d.qid.type = dir-&gt;type;
	d.qid.path = dir-&gt;qid;
	d.qid.vers = 0;
	d.mode = dir-&gt;perm;
	d.length = 0;	/* would be nice to do better */
	d.name = dir-&gt;name;
	d.uid = user;
	d.gid = user;
	d.muid = user;
	d.atime = clock;
	d.mtime = clock;
	return convD2M(&amp;d, buf, nbuf);
}

static void
queuesend(Dirtab *d, Plumbmsg *m)
{
	Sendreq *s, *t;
	Fid *f;
	int i;

	s = emalloc(sizeof(Sendreq));
	s-&gt;nfid = d-&gt;nopen;
	s-&gt;nleft = s-&gt;nfid;
	s-&gt;fid = emalloc(s-&gt;nfid*sizeof(Fid*));
	i = 0;
	/* build array of fids open on this channel */
	for(f=d-&gt;fopen; f!=nil; f=f-&gt;nextopen)
		s-&gt;fid[i++] = f;
	s-&gt;msg = m;
	s-&gt;next = nil;
	/* link to end of queue; drainqueue() searches in sender order so this implements a FIFO */
	for(t=d-&gt;sendq; t!=nil; t=t-&gt;next)
		if(t-&gt;next == nil)
			break;
	if(t == nil)
		d-&gt;sendq = s;
	else
		t-&gt;next = s;
}

static void
queueread(Dirtab *d, Fcall *t, uchar *buf, Fid *f)
{
	Readreq *r;

	r = emalloc(sizeof(Readreq));
	r-&gt;fcall = t;
	r-&gt;buf = buf;
	r-&gt;fid = f;
	r-&gt;next = d-&gt;readq;
	d-&gt;readq = r;
}

static void
drainqueue(Dirtab *d)
{
	Readreq *r, *nextr, *prevr;
	Sendreq *s, *nexts, *prevs;
	int i, n;

	prevs = nil;
	for(s=d-&gt;sendq; s!=nil; s=nexts){
		nexts = s-&gt;next;
		for(i=0; i&lt;s-&gt;nfid; i++){
			prevr = nil;
			for(r=d-&gt;readq; r!=nil; r=nextr){
				nextr = r-&gt;next;
				if(r-&gt;fid == s-&gt;fid[i]){
					/* pack the message if necessary */
					if(s-&gt;pack == nil)
						s-&gt;pack = plumbpack(s-&gt;msg, &amp;s-&gt;npack);
					/* exchange the stuff... */
					r-&gt;fcall-&gt;data = s-&gt;pack+r-&gt;fid-&gt;offset;
					n = s-&gt;npack - r-&gt;fid-&gt;offset;
					if(n &gt; messagesize-IOHDRSZ)
						n = messagesize-IOHDRSZ;
					if(n &gt; r-&gt;fcall-&gt;count)
						n = r-&gt;fcall-&gt;count;
					r-&gt;fcall-&gt;count = n;
					fsysrespond(r-&gt;fcall, r-&gt;buf, nil);
					r-&gt;fid-&gt;offset += n;
					if(r-&gt;fid-&gt;offset &gt;= s-&gt;npack){
						/* message transferred; delete this fid from send queue */
						r-&gt;fid-&gt;offset = 0;
						s-&gt;fid[i] = nil;
						s-&gt;nleft--;
					}
					/* delete read request from queue */
					if(prevr)
						prevr-&gt;next = r-&gt;next;
					else
						d-&gt;readq = r-&gt;next;
					free(r-&gt;fcall);
					free(r);
					break;
				}else
					prevr = r;
			}
		}
		/* if no fids left, delete this send from queue */
		if(s-&gt;nleft == 0){
			free(s-&gt;fid);
			plumbfree(s-&gt;msg);
			free(s-&gt;pack);
			if(prevs)
				prevs-&gt;next = s-&gt;next;
			else
				d-&gt;sendq = s-&gt;next;
			free(s);
		}else
			prevs = s;
	}
}

/* can't flush a send because they are always answered synchronously */
static void
flushqueue(Dirtab *d, int oldtag)
{
	Readreq *r, *prevr;

	prevr = nil;
	for(r=d-&gt;readq; r!=nil; r=r-&gt;next){
		if(oldtag == r-&gt;fcall-&gt;tag){
			/* delete read request from queue */
			if(prevr)
				prevr-&gt;next = r-&gt;next;
			else
				d-&gt;readq = r-&gt;next;
			free(r-&gt;fcall);
			free(r-&gt;buf);
			free(r);
			return;
		}
		prevr = r;
	}
}

/* remove messages awaiting delivery to now-closing fid */
static void
removesenders(Dirtab *d, Fid *fid)
{
	Sendreq *s, *nexts, *prevs;
	int i;

	prevs = nil;
	for(s=d-&gt;sendq; s!=nil; s=nexts){
		nexts = s-&gt;next;
		for(i=0; i&lt;s-&gt;nfid; i++)
			if(fid == s-&gt;fid[i]){
				/* delete this fid from send queue */
				s-&gt;fid[i] = nil;
				s-&gt;nleft--;
				break;
			}
		/* if no fids left, delete this send from queue */
		if(s-&gt;nleft == 0){
			free(s-&gt;fid);
			plumbfree(s-&gt;msg);
			free(s-&gt;pack);
			if(prevs)
				prevs-&gt;next = s-&gt;next;
			else
				d-&gt;sendq = s-&gt;next;
			free(s);
		}else
			prevs = s;
	}
}

static void
hold(Plumbmsg *m, Dirtab *d)
{
	Holdq *h, *q;

	h = emalloc(sizeof(Holdq));
	h-&gt;msg = m;
	/* add to end of queue */
	if(d-&gt;holdq == nil)
		d-&gt;holdq = h;
	else{
		for(q=d-&gt;holdq; q-&gt;next!=nil; q=q-&gt;next)
			;
		q-&gt;next = h;
	}
}

static void
queueheld(Dirtab *d)
{
	Holdq *h;

	while(d-&gt;holdq != nil){
		h = d-&gt;holdq;
		d-&gt;holdq = h-&gt;next;
		queuesend(d, h-&gt;msg);
		/* no need to drain queue because we know no-one is reading yet */
		free(h);
	}
}

static void
dispose(Fcall *t, uchar *buf, Plumbmsg *m, Ruleset *rs, Exec *e)
{
	int i;
	char *err;

	qlock(&amp;queue);
	err = nil;
	if(m-&gt;dst==nil || m-&gt;dst[0]=='\0'){
		err = Enoport;
		if(rs != nil)
			err = startup(rs, e);
		plumbfree(m);
	}else
		for(i=NQID; i&lt;ndir; i++)
			if(strcmp(m-&gt;dst, dir[i].name) == 0){
				if(dir[i].nopen == 0){
					err = startup(rs, e);
					if(e!=nil &amp;&amp; e-&gt;holdforclient)
						hold(m, &amp;dir[i]);
					else
						plumbfree(m);
				}else{
					queuesend(&amp;dir[i], m);
					drainqueue(&amp;dir[i]);
				}
				break;
			}
	freeexec(e);
	qunlock(&amp;queue);
	fsysrespond(t, buf, err);
	free(t);
}

static Fcall*
fsysversion(Fcall *t, uchar *buf, Fid*)
{
	if(t-&gt;msize &lt; 256){
		fsysrespond(t, buf, "version: message size too small");
		return t;
	}
	if(t-&gt;msize &lt; messagesize)
		messagesize = t-&gt;msize;
	t-&gt;msize = messagesize;
	if(strncmp(t-&gt;version, "9P2000", 6) != 0){
		fsysrespond(t, buf, "unrecognized 9P version");
		return t;
	}
	t-&gt;version = "9P2000";
	fsysrespond(t, buf, nil);
	return t;
}

static Fcall*
fsysauth(Fcall *t, uchar *buf, Fid*)
{
	fsysrespond(t, buf, "plumber: authentication not required");
	return t;
}

static Fcall*
fsysattach(Fcall *t, uchar *buf, Fid *f)
{
	Fcall out;

	if(strcmp(t-&gt;uname, user) != 0){
		fsysrespond(&amp;out, buf, Eperm);
		return t;
	}
	f-&gt;busy = 1;
	f-&gt;open = 0;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.path = Qdir;
	f-&gt;qid.vers = 0;
	f-&gt;dir = dir;
	memset(&amp;out, 0, sizeof(Fcall));
	out.type = t-&gt;type;
	out.tag = t-&gt;tag;
	out.fid = f-&gt;fid;
	out.qid = f-&gt;qid;
	fsysrespond(&amp;out, buf, nil);
	return t;
}

static Fcall*
fsysflush(Fcall *t, uchar *buf, Fid*)
{
	int i;

	qlock(&amp;queue);
	for(i=NQID; i&lt;ndir; i++)
		flushqueue(&amp;dir[i], t-&gt;oldtag);
	qunlock(&amp;queue);
	fsysrespond(t, buf, nil);
	return t;
}

static Fcall*
fsyswalk(Fcall *t, uchar *buf, Fid *f)
{
	Fcall out;
	Fid *nf;
	ulong path;
	Dirtab *d, *dir;
	Qid q;
	int i;
	uchar type;
	char *err;

	if(f-&gt;open){
		fsysrespond(t, buf, "clone of an open fid");
		return t;
	}

	nf = nil;
	if(t-&gt;fid  != t-&gt;newfid){
		nf = newfid(t-&gt;newfid);
		if(nf-&gt;busy){
			fsysrespond(t, buf, "clone to a busy fid");
			return t;
		}
		nf-&gt;busy = 1;
		nf-&gt;open = 0;
		nf-&gt;dir = f-&gt;dir;
		nf-&gt;qid = f-&gt;qid;
		f = nf;	/* walk f */
	}

	out.nwqid = 0;
	err = nil;
	dir = f-&gt;dir;
	q = f-&gt;qid;

	if(t-&gt;nwname &gt; 0){
		for(i=0; i&lt;t-&gt;nwname; i++){
			if((q.type &amp; QTDIR) == 0){
				err = Enotdir;
				break;
			}
			if(strcmp(t-&gt;wname[i], "..") == 0){
				type = QTDIR;
				path = Qdir;
	Accept:
				q.type = type;
				q.vers = 0;
				q.path = path;
				out.wqid[out.nwqid++] = q;
				continue;
			}
			d = dir;
			d++;	/* skip '.' */
			for(; d-&gt;name; d++)
				if(strcmp(t-&gt;wname[i], d-&gt;name) == 0){
					type = d-&gt;type;
					path = d-&gt;qid;
					dir = d;
					goto Accept;
				}
			err = Enoexist;
			break;
		}
	}

	out.type = t-&gt;type;
	out.tag = t-&gt;tag;
	if(err!=nil || out.nwqid&lt;t-&gt;nwname){
		if(nf)
			nf-&gt;busy = 0;
	}else if(out.nwqid == t-&gt;nwname){
		f-&gt;qid = q;
		f-&gt;dir = dir;
	}

	fsysrespond(&amp;out, buf, err);
	return t;
}

static Fcall*
fsysopen(Fcall *t, uchar *buf, Fid *f)
{
	int m, clearrules, mode;

	clearrules = 0;
	if(t-&gt;mode &amp; OTRUNC){
		if(f-&gt;qid.path != Qrules)
			goto Deny;
		clearrules = 1;
	}
	/* can't truncate anything, so just disregard */
	mode = t-&gt;mode &amp; ~(OTRUNC|OCEXEC);
	/* can't execute or remove anything */
	if(mode==OEXEC || (mode&amp;ORCLOSE))
		goto Deny;
	switch(mode){
	default:
		goto Deny;
	case OREAD:
		m = 0400;
		break;
	case OWRITE:
		m = 0200;
		break;
	case ORDWR:
		m = 0600;
		break;
	}
	if(((f-&gt;dir-&gt;perm&amp;~(DMDIR|DMAPPEND))&amp;m) != m)
		goto Deny;
	if(f-&gt;qid.path==Qrules &amp;&amp; (mode==OWRITE || mode==ORDWR)){
		lock(&amp;rulesref);
		if(rulesref.ref++ != 0){
			rulesref.ref--;
			unlock(&amp;rulesref);
			fsysrespond(t, buf, Einuse);
			return t;
		}
		unlock(&amp;rulesref);
	}
	if(clearrules){
		writerules(nil, 0);
		rules[0] = nil;
	}
	t-&gt;qid = f-&gt;qid;
	t-&gt;iounit = 0;
	qlock(&amp;queue);
	f-&gt;mode = mode;
	f-&gt;open = 1;
	f-&gt;dir-&gt;nopen++;
	f-&gt;nextopen = f-&gt;dir-&gt;fopen;
	f-&gt;dir-&gt;fopen = f;
	queueheld(f-&gt;dir);
	qunlock(&amp;queue);
	fsysrespond(t, buf, nil);
	return t;

    Deny:
	fsysrespond(t, buf, Eperm);
	return t;
}

static Fcall*
fsyscreate(Fcall *t, uchar *buf, Fid*)
{
	fsysrespond(t, buf, Eperm);
	return t;
}

static Fcall*
fsysreadrules(Fcall *t, uchar *buf)
{
	char *p;
	int n;

	p = printrules();
	n = strlen(p);
	t-&gt;data = p;
	if(t-&gt;offset &gt;= n)
		t-&gt;count = 0;
	else{
		t-&gt;data = p+t-&gt;offset;
		if(t-&gt;offset+t-&gt;count &gt; n)
			t-&gt;count = n-t-&gt;offset;
	}
	fsysrespond(t, buf, nil);
	free(p);
	return t;
}

static Fcall*
fsysread(Fcall *t, uchar *buf, Fid *f)
{
	uchar *b;
	int i, n, o, e;
	uint len;
	Dirtab *d;
	uint clock;

	if(f-&gt;qid.path != Qdir){
		if(f-&gt;qid.path == Qrules)
			return fsysreadrules(t, buf);
		/* read from port */
		if(f-&gt;qid.path &lt; NQID){
			fsysrespond(t, buf, "internal error: unknown read port");
			return t;
		}
		qlock(&amp;queue);
		queueread(f-&gt;dir, t, buf, f);
		drainqueue(f-&gt;dir);
		qunlock(&amp;queue);
		return nil;
	}
	o = t-&gt;offset;
	e = t-&gt;offset+t-&gt;count;
	clock = getclock();
	b = malloc(messagesize-IOHDRSZ);
	if(b == nil){
		fsysrespond(t, buf, Enomem);
		return t;
	}
	n = 0;
	d = dir;
	d++;	/* first entry is '.' */
	for(i=0; d-&gt;name!=nil &amp;&amp; i&lt;e; i+=len){
		len = dostat(d, b+n, messagesize-IOHDRSZ-n, clock);
		if(len &lt;= BIT16SZ)
			break;
		if(i &gt;= o)
			n += len;
		d++;
	}
	t-&gt;data = (char*)b;
	t-&gt;count = n;
	fsysrespond(t, buf, nil);
	free(b);
	return t;
}

static Fcall*
fsyswrite(Fcall *t, uchar *buf, Fid *f)
{
	Plumbmsg *m;
	int i, n;
	long count;
	char *data;
	Exec *e;

	switch((int)f-&gt;qid.path){
	case Qdir:
		fsysrespond(t, buf, Eisdir);
		return t;
	case Qrules:
		clock = getclock();
		fsysrespond(t, buf, writerules(t-&gt;data, t-&gt;count));
		return t;
	case Qsend:
		if(f-&gt;offset == 0){
			data = t-&gt;data;
			count = t-&gt;count;
		}else{
			/* partial message already assembled */
			f-&gt;writebuf = erealloc(f-&gt;writebuf, f-&gt;offset + t-&gt;count);
			memmove(f-&gt;writebuf+f-&gt;offset, t-&gt;data, t-&gt;count);
			data = f-&gt;writebuf;
			count = f-&gt;offset+t-&gt;count;
		}
		m = plumbunpackpartial(data, count, &amp;n);
		if(m == nil){
			if(n == 0){
				f-&gt;offset = 0;
				free(f-&gt;writebuf);
				f-&gt;writebuf = nil;
				fsysrespond(t, buf, Ebadmsg);
				return t;
			}
			/* can read more... */
			if(f-&gt;offset == 0){
				f-&gt;writebuf = emalloc(t-&gt;count);
				memmove(f-&gt;writebuf, t-&gt;data, t-&gt;count);
			}
			/* else buffer has already been grown */
			f-&gt;offset += t-&gt;count;
			fsysrespond(t, buf, nil);
			return t;
		}
		/* release partial buffer */
		f-&gt;offset = 0;
		free(f-&gt;writebuf);
		f-&gt;writebuf = nil;
		for(i=0; rules[i]; i++)
			if((e=matchruleset(m, rules[i])) != nil){
				dispose(t, buf, m, rules[i], e);
				return nil;
			}
		if(m-&gt;dst != nil){
			dispose(t, buf, m, nil, nil);
			return nil;
		}
		fsysrespond(t, buf, "no matching plumb rule");
		return t;
	}
	fsysrespond(t, buf, "internal error: write to unknown file");
	return t;
}

static Fcall*
fsysstat(Fcall *t, uchar *buf, Fid *f)
{
	t-&gt;stat = emalloc(messagesize-IOHDRSZ);
	t-&gt;nstat = dostat(f-&gt;dir, t-&gt;stat, messagesize-IOHDRSZ, clock);
	fsysrespond(t, buf, nil);
	free(t-&gt;stat);
	t-&gt;stat = nil;
	return t;
}

static Fcall*
fsyswstat(Fcall *t, uchar *buf, Fid*)
{
	fsysrespond(t, buf, Eperm);
	return t;
}

static Fcall*
fsysremove(Fcall *t, uchar *buf, Fid*)
{
	fsysrespond(t, buf, Eperm);
	return t;
}

static Fcall*
fsysclunk(Fcall *t, uchar *buf, Fid *f)
{
	Fid *prev, *p;
	Dirtab *d;

	qlock(&amp;queue);
	if(f-&gt;open){
		d = f-&gt;dir;
		d-&gt;nopen--;
		if(d-&gt;qid==Qrules &amp;&amp; (f-&gt;mode==OWRITE || f-&gt;mode==ORDWR)){
			/*
			 * just to be sure last rule is parsed; error messages will be lost, though,
			 * unless last write ended with a blank line
			 */
			writerules(nil, 0);
			lock(&amp;rulesref);
			rulesref.ref--;
			unlock(&amp;rulesref);
		}
		prev = nil;
		for(p=d-&gt;fopen; p; p=p-&gt;nextopen){
			if(p == f){
				if(prev)
					prev-&gt;nextopen = f-&gt;nextopen;
				else
					d-&gt;fopen = f-&gt;nextopen;
				removesenders(d, f);
				break;
			}
			prev = p;
		}
	}
	f-&gt;busy = 0;
	f-&gt;open = 0;
	f-&gt;offset = 0;
	if(f-&gt;writebuf != nil){
		free(f-&gt;writebuf);
		f-&gt;writebuf = nil;
	}
	qunlock(&amp;queue);
	fsysrespond(t, buf, nil);
	return t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

