<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/plumb/match.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/plumb/match.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include &lt;thread.h&gt;
#include &lt;plumb.h&gt;
#include "plumber.h"

static char*
nonnil(char *s)
{
	if(s == nil)
		return "";
	return s;
}

int
verbis(int obj, Plumbmsg *m, Rule *r)
{
	switch(obj){
	default:
		fprint(2, "unimplemented 'is' object %d\n", obj);
		break;
	case OData:
		return strcmp(m-&gt;data, r-&gt;qarg) == 0;
	case ODst:
		return strcmp(m-&gt;dst, r-&gt;qarg) == 0;
	case OType:
		return strcmp(m-&gt;type, r-&gt;qarg) == 0;
	case OWdir:
		return strcmp(m-&gt;wdir, r-&gt;qarg) == 0;
	case OSrc:
		return strcmp(m-&gt;src, r-&gt;qarg) == 0;
	}
	return 0;
}

static void
setvar(Resub rs[10], char *match[10])
{
	int i, n;

	for(i=0; i&lt;10; i++){
		free(match[i]);
		match[i] = nil;
	}
	for(i=0; i&lt;10 &amp;&amp; rs[i].sp!=nil; i++){
		n = rs[i].ep-rs[i].sp;
		match[i] = emalloc(n+1);
		memmove(match[i], rs[i].sp, n);
		match[i][n] = '\0';
	}
}

int
clickmatch(Reprog *re, char *text, Resub rs[10], int click)
{
	char *clickp;
	int i, w;
	Rune r;

	/* click is in characters, not bytes */
	for(i=0; i&lt;click &amp;&amp; text[i]!='\0'; i+=w)
		w = chartorune(&amp;r, text+i);
	clickp = text+i;
	for(i=0; i&lt;=click; i++){
		memset(rs, 0, 10*sizeof(Resub));
		if(regexec(re, text+i, rs, 10))
			if(rs[0].sp&lt;=clickp &amp;&amp; clickp&lt;=rs[0].ep)
				return 1;
	}
	return 0;
}

int
verbmatches(int obj, Plumbmsg *m, Rule *r, Exec *e)
{
	Resub rs[10];
	char *clickval, *alltext;
	int p0, p1, ntext;

	memset(rs, 0, sizeof rs);
	ntext = -1;
	switch(obj){
	default:
		fprint(2, "unimplemented 'matches' object %d\n", obj);
		break;
	case OData:
		clickval = plumblookup(m-&gt;attr, "click");
		if(clickval == nil){
			alltext = m-&gt;data;
			ntext = m-&gt;ndata;
			goto caseAlltext;
		}
		if(!clickmatch(r-&gt;regex, m-&gt;data, rs, atoi(clickval)))
			break;
		p0 = rs[0].sp - m-&gt;data;
		p1 = rs[0].ep - m-&gt;data;
		if(e-&gt;p0 &gt;=0 &amp;&amp; !(p0==e-&gt;p0 &amp;&amp; p1==e-&gt;p1))
			break;
		e-&gt;clearclick = 1;
		e-&gt;setdata = 1;
		e-&gt;p0 = p0;
		e-&gt;p1 = p1;
		setvar(rs, e-&gt;match);
		return 1;
	case ODst:
		alltext = m-&gt;dst;
		goto caseAlltext;
	case OType:
		alltext = m-&gt;type;
		goto caseAlltext;
	case OWdir:
		alltext = m-&gt;wdir;
		goto caseAlltext;
	case OSrc:
		alltext = m-&gt;src;
		/* fall through */
	caseAlltext:
		/* must match full text */
		if(ntext &lt; 0)
			ntext = strlen(alltext);
		if(!regexec(r-&gt;regex, alltext, rs, 10) || rs[0].sp!=alltext || rs[0].ep!=alltext+ntext)
			break;
		setvar(rs, e-&gt;match);
		return 1;
	}
	return 0;
}

int
isfile(char *file, ulong maskon, ulong maskoff)
{
	Dir *d;
	int mode;

	d = dirstat(file);
	if(d == nil)
		return 0;
	mode = d-&gt;mode;
	free(d);
	if((mode &amp; maskon) == 0)
		return 0;
	if(mode &amp; maskoff)
		return 0;
	return 1;
}

char*
absolute(char *dir, char *file)
{
	char *p;

	if(file[0] == '/')
		return estrdup(file);
	p = emalloc(strlen(dir)+1+strlen(file)+1);
	sprint(p, "%s/%s", dir, file);
	return cleanname(p);
}

int
verbisfile(int obj, Plumbmsg *m, Rule *r, Exec *e, ulong maskon, ulong maskoff, char **var)
{
	char *file;

	switch(obj){
	default:
		fprint(2, "unimplemented 'isfile' object %d\n", obj);
		break;
	case OArg:
		file = absolute(m-&gt;wdir, expand(e, r-&gt;arg, nil));
		if(isfile(file, maskon, maskoff)){
			*var = file;
			return 1;
		}
		free(file);
		break;
	case OData:
	case OWdir:
		file = absolute(m-&gt;wdir, obj==OData? m-&gt;data : m-&gt;wdir);
		if(isfile(file, maskon, maskoff)){
			*var = file;
			return 1;
		}
		free(file);
		break;
	}
	return 0;
}

int
verbset(int obj, Plumbmsg *m, Rule *r, Exec *e)
{
	char *new;

	switch(obj){
	default:
		fprint(2, "unimplemented 'is' object %d\n", obj);
		break;
	case OData:
		new = estrdup(expand(e, r-&gt;arg, nil));
		m-&gt;ndata = strlen(new);
		free(m-&gt;data);
		m-&gt;data = new;
		e-&gt;p0 = -1;
		e-&gt;p1 = -1;
		e-&gt;setdata = 0;
		return 1;
	case ODst:
		new = estrdup(expand(e, r-&gt;arg, nil));
		free(m-&gt;dst);
		m-&gt;dst = new;
		return 1;
	case OType:
		new = estrdup(expand(e, r-&gt;arg, nil));
		free(m-&gt;type);
		m-&gt;type = new;
		return 1;
	case OWdir:
		new = estrdup(expand(e, r-&gt;arg, nil));
		free(m-&gt;wdir);
		m-&gt;wdir = new;
		return 1;
	case OSrc:
		new = estrdup(expand(e, r-&gt;arg, nil));
		free(m-&gt;src);
		m-&gt;src = new;
		return 1;
	}
	return 0;
}

int
verbadd(int obj, Plumbmsg *m, Rule *r, Exec *e)
{
	switch(obj){
	default:
		fprint(2, "unimplemented 'add' object %d\n", obj);
		break;
	case OAttr:
		m-&gt;attr = plumbaddattr(m-&gt;attr, plumbunpackattr(expand(e, r-&gt;arg, nil)));
		return 1;
	}
	return 0;
}

int
verbdelete(int obj, Plumbmsg *m, Rule *r, Exec *e)
{
	char *a;

	switch(obj){
	default:
		fprint(2, "unimplemented 'delete' object %d\n", obj);
		break;
	case OAttr:
		a = expand(e, r-&gt;arg, nil);
		if(plumblookup(m-&gt;attr, a) == nil)
			break;
		m-&gt;attr = plumbdelattr(m-&gt;attr, a);
		return 1;
	}
	return 0;
}

int
matchpat(Plumbmsg *m, Exec *e, Rule *r)
{
	switch(r-&gt;verb){
	default:
		fprint(2, "unimplemented verb %d\n", r-&gt;verb);
		break;
	case VAdd:
		return verbadd(r-&gt;obj, m, r, e);
	case VDelete:
		return verbdelete(r-&gt;obj, m, r, e);
	case VIs:
		return verbis(r-&gt;obj, m, r);
	case VIsdir:
		return verbisfile(r-&gt;obj, m, r, e, DMDIR, 0, &amp;e-&gt;dir);
	case VIsfile:
		return verbisfile(r-&gt;obj, m, r, e, ~DMDIR, DMDIR, &amp;e-&gt;file);
	case VMatches:
		return verbmatches(r-&gt;obj, m, r, e);
	case VSet:
		verbset(r-&gt;obj, m, r, e);
		return 1;
	}
	return 0;
}

void
freeexec(Exec *exec)
{
	int i;

	if(exec == nil)
		return;
	free(exec-&gt;dir);
	free(exec-&gt;file);
	for(i=0; i&lt;10; i++)
		free(exec-&gt;match[i]);
	free(exec);
}

Exec*
newexec(Plumbmsg *m)
{
	Exec *exec;
	
	exec = emalloc(sizeof(Exec));
	exec-&gt;msg = m;
	exec-&gt;p0 = -1;
	exec-&gt;p1 = -1;
	return exec;
}

void
rewrite(Plumbmsg *m, Exec *e)
{
	Plumbattr *a, *prev;

	if(e-&gt;clearclick){
		prev = nil;
		for(a=m-&gt;attr; a!=nil; a=a-&gt;next){
			if(strcmp(a-&gt;name, "click") == 0){
				if(prev == nil)
					m-&gt;attr = a-&gt;next;
				else
					prev-&gt;next = a-&gt;next;
				free(a-&gt;name);
				free(a-&gt;value);	
				free(a);
				break;
			}
			prev = a;
		}
		if(e-&gt;setdata){
			free(m-&gt;data);
			m-&gt;data = estrdup(expand(e, "$0", nil));
			m-&gt;ndata = strlen(m-&gt;data);
		}
	}
}

char**
buildargv(char *s, Exec *e)
{
	char **av;
	int ac;

	ac = 0;
	av = nil;
	for(;;){
		av = erealloc(av, (ac+1) * sizeof(char*));
		av[ac] = nil;
		while(*s==' ' || *s=='\t')
			s++;
		if(*s == '\0')
			break;
		av[ac++] = estrdup(expand(e, s, &amp;s));
	}
	return av;
}

Exec*
matchruleset(Plumbmsg *m, Ruleset *rs)
{
	int i;
	Exec *exec;

	if(m-&gt;dst!=nil &amp;&amp; m-&gt;dst[0]!='\0' &amp;&amp; rs-&gt;port!=nil &amp;&amp; strcmp(m-&gt;dst, rs-&gt;port)!=0)
		return nil;
	exec = newexec(m);
	for(i=0; i&lt;rs-&gt;npat; i++)
		if(!matchpat(m, exec, rs-&gt;pat[i])){
			freeexec(exec);
			return nil;
		}
	if(rs-&gt;port!=nil &amp;&amp; (m-&gt;dst==nil || m-&gt;dst[0]=='\0')){
		free(m-&gt;dst);
		m-&gt;dst = estrdup(rs-&gt;port);
	}
	rewrite(m, exec);
	return exec;
}

enum
{
	NARGS		= 100,
	NARGCHAR	= 8*1024,
	EXECSTACK 	= 8192+(NARGS+1)*sizeof(char*)+NARGCHAR
};

/* copy argv to stack and free the incoming strings, so we don't leak argument vectors */
void
stackargv(char **inargv, char *argv[NARGS+1], char args[NARGCHAR])
{
	int i, n;
	char *s, *a;

	s = args;
	for(i=0; i&lt;NARGS; i++){
		a = inargv[i];
		if(a == nil)
			break;
		n = strlen(a)+1;
		if((s-args)+n &gt;= NARGCHAR)	/* too many characters */
			break;
		argv[i] = s;
		memmove(s, a, n);
		s += n;
		free(a);
	}
	argv[i] = nil;
}


void
execproc(void *v)
{
	char **av;
	char buf[1024], *args[NARGS+1], argc[NARGCHAR];

	rfork(RFFDG);
	close(0);
	open("/dev/null", OREAD);
	av = v;
	stackargv(av, args, argc);
	free(av);
	procexec(nil, args[0], args);
	if(args[0][0]!='/' &amp;&amp; strncmp(args[0], "./", 2)!=0 &amp;&amp; strncmp(args[0], "../", 3)!=0)
		snprint(buf, sizeof buf, "/bin/%s", args[0]);
	procexec(nil, buf, args);
	threadexits("can't exec");
}

char*
startup(Ruleset *rs, Exec *e)
{
	char **argv;
	int i;

	if(rs != nil)
		for(i=0; i&lt;rs-&gt;nact; i++){
			if(rs-&gt;act[i]-&gt;verb == VStart)
				goto Found;
			if(rs-&gt;act[i]-&gt;verb == VClient){
				if(e-&gt;msg-&gt;dst==nil || e-&gt;msg-&gt;dst[0]=='\0')
					return "no port for \"client\" rule";
				e-&gt;holdforclient = 1;
				goto Found;
			}
		}
	return "no start action for plumb message";

Found:
	argv = buildargv(rs-&gt;act[i]-&gt;arg, e);
	if(argv[0] == nil)
		return "empty argument list";
	proccreate(execproc, argv, EXECSTACK);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

