<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/buildtables/buildtables.sh - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/buildtables/buildtables.sh</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#
# Builds one or more font width tables or the typesetter description
# file on a PostScript printer. Assumes you have direct access to the
# printer's serial port. No arguments means build a standard collection
# of tables - usually the LaserWriter Plus set. See trofftable and the
# shell library files /usr/lib/font/dev*/shell.lib for more details.
#

set -e

POSTBIN=/usr/lbin/postscript
POSTLIB=/usr/lib/postscript
FONTDIR=/usr/lib/font

POSTIO=$POSTBIN/postio
TROFFTABLE=$POSTBIN/trofftable

BAUDRATE=
DEVICE=
LIBRARY=

while [ -n "$1" ]; do
    case $1 in
	-C)  shift; OPTIONS="$OPTIONS -C$1";;
	-C*) OPTIONS="$OPTIONS $1";;

	-F)  shift; FONTDIR=$1;;
	-F*) FONTDIR=`echo $1 | sed s/-F//`;;

	-H)  shift; OPTIONS="$OPTIONS -H$1";;
	-H*) OPTIONS="$OPTIONS $1";;

	-S)  shift; LIBRARY=$1;;
	-S*) LIBRARY=`echo $1 | sed s/-S//`;;

	-T)  shift; DEVICE=$1;;
	-T*) DEVICE=`echo $1 | sed s/-T//`;;

	-b)  shift; BAUDRATE=$1;;
	-b*) BAUDRATE=`echo $1 | sed s/-b//`;;

	-c)  shift; OPTIONS="$OPTIONS -c$1";;
	-c*) OPTIONS="$OPTIONS $1";;

	-l)  shift; LINE=$1;;
	-l*) LINE=`echo $1 | sed s/-l//`;;

	-s)  shift; OPTIONS="$OPTIONS -s$1";;
	-s*) OPTIONS="$OPTIONS $1";;

	-t)  shift; OPTIONS="$OPTIONS -t$1";;
	-t*) OPTIONS="$OPTIONS $1";;

	-?)  OPTIONS="$OPTIONS $1$2"; shift;;
	-?*) OPTIONS="$OPTIONS $1";;

	*)   break;;
    esac
    shift
done

if [ ! "$DEVICE" -a ! "$LIBRARY" ]; then
    echo "$0: no device or shell library" &gt;&amp;2
    exit 1
fi

LIBRARY=${LIBRARY:-${FONTDIR}/dev${DEVICE}/shell.lib}

#
# No arguments means build everything return by the AllTables function.
#

if [ $# -eq 0 ]; then
    . $LIBRARY
    set -- `AllTables`
fi

for i do
    SHORT=`echo $i | awk '{print $1}'`
    LONG=`echo $i | awk '{print $2}'`

    if [ "$LINE" ]
	then echo "==== Building table $SHORT ===="
	else echo "==== Creating table program $SHORT.ps ===="
    fi

    $TROFFTABLE -S$LIBRARY $OPTIONS $SHORT $LONG &gt;$SHORT.ps

    if [ "$LINE" ]; then
	$POSTIO -t -l$LINE ${BAUDRATE:+-b${BAUDRATE}} $SHORT.ps &gt;$SHORT
	rm -f $SHORT.ps
    fi
done

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

