<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tcpostio/dial.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tcpostio/dial.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#define _BSD_EXTENSION
#define _NET_EXTENSION
#define _POSIX_SOURCE

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;unistd.h&gt;
#include &lt;ctype.h&gt;
#include &lt;string.h&gt;
#include &lt;sys/types.h&gt;
#include &lt;sys/socket.h&gt;
#include &lt;netinet/in.h&gt;
#include &lt;netdb.h&gt;
#include &lt;sys/time.h&gt;

#define	DIALTIMEOUT	30

/* This is a dummy routine for non Plan9 systems.
 * No attempt has been made to be clever, it's just
 * supposed to work in this program.
 */
int dial_debug = 0;

int
dial(char *dest, char *local, char *dir, int *cfdp) {
	int sockconn, lport;
	struct hostent *hp;		/* Pointer to host info */
	struct sockaddr_in sin;		/* Socket address, Internet style */
	struct servent *sp = 0;
	char *tdest, *netname, *hostname, *servname;
	int sock_type;
#ifndef plan9
#define	USED(x)	if(x); else
	int sockoption, sockoptsize;
#endif

	USED(dir);
	USED(cfdp);
	if ((tdest = malloc(strlen(dest)+1)) == NULL) {
		if (dial_debug) fprintf(stderr, "dial: could not allocate memory\n");
		return(-1);
	}
	strcpy(tdest, dest);

	if ((netname = strtok(tdest, "!")) == NULL) {
		fprintf(stderr, "dial: no network name\n");
		return(-1);
	}
	if (strcmp(netname, "tcp") == 0) {
		sock_type = SOCK_STREAM;
	} else if (strcmp(netname, "udp") == 0) {
		sock_type = SOCK_DGRAM;
	} else {
		fprintf(stderr, "dial: network protocol name `%s' is invalid; must be `tcp' or `udp'\n", netname);
		return(-1);
	}
	if ((hostname = strtok(0, "!")) == NULL) {
		fprintf(stderr, "dial: no host name or number\n");
		return(-1);
	}
	if ((servname = strtok(0, "!")) == NULL) {
		fprintf(stderr, "dial: no service name or number\n");
		return(-1);
	}
	hp = gethostbyname(hostname);
	if (hp == (struct hostent *)NULL) {
		if (dial_debug) fprintf(stderr, "host `%s' unknown by local host\n", hostname);
		return(-1);
	}
	if (!isdigit(servname[0]))
		sp = getservbyname(servname, netname);
	sin.sin_addr.s_addr = *(unsigned long*)hp-&gt;h_addr;
	sin.sin_port	= htons((sp==0)?atoi(servname):sp-&gt;s_port);
	sin.sin_family	= AF_INET;
	if (local == NULL) {
		if ((sockconn = socket(AF_INET, sock_type, 0)) &lt; 0) {
			if (dial_debug) perror("dial:socket():");
			return(-1);
		}
		if (dial_debug) fprintf(stderr, "socket FD=%d\n", sockconn);
	} else {
		lport = atoi(local);
		if ((lport &lt; 512) || (lport &gt;= 1024)) {
			fprintf(stderr, "dial:invalid local port %d\n", lport);
			return(-1);
		}
		if ((sockconn = rresvport(&amp;lport)) &lt; 0) {
			if (dial_debug) perror("dial:rresvport():");
			return(-1);
		}
	}
	if (dial_debug) {
		fprintf(stderr, "sin size=%d\n", sizeof(sin));
	}
	alarm(DIALTIMEOUT);
	if ((connect(sockconn, (struct sockaddr *) &amp;sin, sizeof(sin)) &lt; 0)) {
		if (dial_debug) perror("dial:connect():");
		return(-1);
	}
	alarm(0);
#ifndef plan9
	sockoptsize = sizeof(sockoption);
	if (getsockopt(sockconn, SOL_SOCKET, SO_KEEPALIVE, &amp;sockoption, &amp;sockoptsize) &lt; 0) {
		if (dial_debug) perror("dial:getsockopt():");
		return(-1);
	}
	if (sockoptsize == sizeof(sockoption) &amp;&amp; !sockoption) {
		if (setsockopt(sockconn, SOL_SOCKET, SO_KEEPALIVE, &amp;sockoption, sockoptsize) &lt; 0) {
			if (dial_debug) perror("dial:getsockopt():");
			return(-1);
		}
	}
#endif
	return(sockconn);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

