<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/postscript/tr2post/utils.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/postscript/tr2post/utils.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "../common/common.h"
#include "tr2post.h"

int hpos = 0, vpos = 0;
int fontsize, fontpos;

#define MAXSTR	128
int trindex;			/* index into trofftab of current troff font */
static int expecthmot = 0;

void
initialize(void) {
}

void
hgoto(int x) {
	hpos = x;
	if (pageon()) {
		endstring();
/*		Bprint(Bstdout, "%d %d m\n", hpos, vpos); */
	}
}

void
vgoto(int y) {
	vpos = y;
	if (pageon()) {
		endstring();
/*		Bprint(Bstdout, "%d %d m\n", hpos, vpos); */
	}
}

void
hmot(int x) {
	int delta;

	if ((x&lt;expecthmot-1) || (x&gt;expecthmot+1)) {
		delta = x - expecthmot;
		if (curtrofffontid &lt;0 || curtrofffontid &gt;= troffontcnt) {
			fprint(2, "troffontcnt=%d curtrofffontid=%d\n",
				troffontcnt, curtrofffontid);
			exits("");
		}
		if (delta == troffontab[curtrofffontid].spacewidth*fontsize/10 &amp;&amp;
		    isinstring()) {
			if (pageon())
				runeout(' ');
		} else {
			if (pageon()) {
				endstring();
				/* Bprint(Bstdout, " %d 0 rmoveto ", delta); */
/*				Bprint(Bstdout, " %d %d m ", hpos+x, vpos); */
				if (debug)
					fprint(2, "x=%d expecthmot=%d\n",
						x, expecthmot);
			}
		}
	}
	hpos += x;
	expecthmot = 0;
}

void
vmot(int y) {
	endstring();
/*	Bprint(Bstdout, " 0 %d rmoveto ", -y); */
	vpos += y;
}

struct charent **
findglyph(int trfid, Rune rune, char *stoken) {
	struct charent **cp;

	for (cp = &amp;(troffontab[trfid].charent[RUNEGETGROUP(rune)][RUNEGETCHAR(rune)]); *cp != 0; cp = &amp;((*cp)-&gt;next)) {
		if ((*cp)-&gt;name) {
			if (debug) fprint(2, "looking for &lt;%s&gt;, have &lt;%s&gt; in font %s\n", stoken, (*cp)-&gt;name, troffontab[trfid].trfontid);
			if (strcmp((*cp)-&gt;name, stoken) == 0)
				break;
		}
	}
	return(cp);
}

/* output glyph.  Use first rune to look up character (hash)
 * then use stoken UTF string to find correct glyph in linked
 * list of glyphs in bucket.
 */
void
glyphout(Rune rune, char *stoken, BOOLEAN specialflag) {
	struct charent **cp;
	struct troffont *tfp;
	struct psfent *psfp;
	int i, t, mi, wid;
	int fontid;	/* this is the troff font table index, not the mounted font table index */
	Rune r;

	mi = 0;
	settrfont();

	/* check current font for the character, special or not */
	fontid = curtrofffontid;
	if (debug)
		fprint(2, "\tlooking through current font: trying %s\n",
			troffontab[fontid].trfontid);
	cp = findglyph(fontid, rune, stoken);
	if (*cp != 0)
		goto foundit;

	if (specialflag) {
		if (expecthmot)
			hmot(0);

		/* check special fonts for the special character */
		/* cycle through the (troff) mounted fonts starting at the next font */
		for (mi=0; mi&lt;fontmnt; mi++) {
			if (troffontab[fontid].trfontid==0)
				error(WARNING, "glyphout:troffontab[%d].trfontid=0x%x, botch!\n",
					fontid, troffontab[fontid].trfontid);
			if (fontmtab[mi]==0) {
				if (debug)
					fprint(2, "fontmtab[%d]=%#p, fontmnt=%d\n",
						mi, fontmtab[mi], fontmnt);
				continue;
			}
			if (strcmp(troffontab[fontid].trfontid, fontmtab[mi])==0)
				break;
		}
		if (mi==fontmnt)
			error(FATAL, "current troff font is not mounted, botch!\n");
		for (i=(mi+1)%fontmnt; i!=mi; i=(i+1)%fontmnt) {
			if (fontmtab[i]==0) {
				if (debug)
					fprint(2, "fontmtab[%d]=%#p, fontmnt=%d\n",
						i, fontmtab[i], fontmnt);
				continue;
			}
			fontid = findtfn(fontmtab[i], TRUE);
if (debug) fprint(2, "	looking through special fonts: trying %s\n", troffontab[fontid].trfontid);
			if (troffontab[fontid].special) {
				cp = findglyph(fontid, rune, stoken);
				if (*cp != 0)
					goto foundit;
			}
		}

		/* check font 1 (if current font is not font 1) for the special character */
		if (mi != 1) {
				fontid = findtfn(fontmtab[1], TRUE);;
if (debug) fprint(2, "	looking through font at position 1: trying %s\n", troffontab[fontid].trfontid);
				cp = findglyph(fontid, rune, stoken);
				if (*cp != 0) goto foundit;
		}
	}

	if (*cp == 0) {
		error(WARNING, "cannot find glyph, rune=0x%x stoken=&lt;%s&gt; troff font %s\n", rune, stoken,
			troffontab[curtrofffontid].trfontid);
		expecthmot = 0;
	}

	/* use the peter face in lieu of the character that we couldn't find */
	rune = 'p';	stoken = "pw";
	for (i=(mi+1)%fontmnt; i!=mi; i=(i+1)%fontmnt) {
		if (fontmtab[i]==0) {
			if (debug) fprint(2, "fontmtab[%d]=%#p\n", i, fontmtab[i]);
			continue;
		}
		fontid = findtfn(fontmtab[i], TRUE);
if (debug) fprint(2, "	looking through special fonts: trying %s\n", troffontab[fontid].trfontid);
		if (troffontab[fontid].special) {
			cp = findglyph(fontid, rune, stoken);
			if (*cp != 0) goto foundit;
		}
	}

	if (*cp == 0) {
		error(WARNING, "cannot find glyph, rune=0x%x stoken=&lt;%s&gt; troff font %s\n",
			rune, stoken, troffontab[curtrofffontid].trfontid);
		expecthmot = 0;
		return;
	}

foundit:
	t = (((*cp)-&gt;postfontid&amp;0xff)&lt;&lt;8) | ((*cp)-&gt;postcharid&amp;0xff);
	if (debug)
		fprint(2, "runeout(0x%x)&lt;%C&gt; postfontid=0x%x postcharid=0x%x troffcharwidth=%d\n",
			rune, rune, (*cp)-&gt;postfontid, (*cp)-&gt;postcharid,
			(*cp)-&gt;troffcharwidth);

	tfp = &amp;troffontab[fontid];
	psfp = nil;
	for (i=0; i&lt;tfp-&gt;psfmapsize; i++) {
		psfp = &amp;(tfp-&gt;psfmap[i]);
		if(t&gt;=psfp-&gt;start &amp;&amp; t&lt;=psfp-&gt;end)
			break;
	}
	if (i &gt;= tfp-&gt;psfmapsize)
		error(FATAL, "character &lt;0x%x&gt; does not have a Postscript font defined.\n", rune);

	setpsfont(psfp-&gt;psftid, fontsize);

	if (t == 0x0001) {	/* character is in charlib */
		endstring();
		if (pageon()) {
			Bprint(Bstdout, "%d %d m ", hpos, vpos);
			/* if char is unicode character rather than name, clean up for postscript */
			wid = chartorune(&amp;r, (*cp)-&gt;name);
			if(' '&lt;r &amp;&amp; r&lt;0x7F)
				Bprint(Bstdout, "%d build_%s\n",
					(*cp)-&gt;troffcharwidth, (*cp)-&gt;name);
			else{
				if((*cp)-&gt;name[wid] != 0)
					error(FATAL, "character &lt;%s&gt; badly named\n", (*cp)-&gt;name);
				Bprint(Bstdout, "%d build_X%.4x\n",
					(*cp)-&gt;troffcharwidth, r);
			}

			/*
			 * stash charent pointer in a list so that we can
			 * print these character definitions in the prologue.
			 */
			for (i=0; i&lt;build_char_cnt; i++)
				if (*cp == build_char_list[i])
					break;
			if (i == build_char_cnt) {
				build_char_list = galloc(build_char_list,
					sizeof(struct charent *)*++build_char_cnt,
					"build_char_list");
				build_char_list[build_char_cnt-1] = *cp;
			}
		}
		expecthmot = (*cp)-&gt;troffcharwidth * fontsize / unitwidth;
	} else if (isinstring() || rune != ' ') {
		startstring();
		if (pageon())
			if (rune == ' ')
				Bprint(Bstdout, " ");
			else
				Bprint(Bstdout, "%s", charcode[RUNEGETCHAR(t)].str);
		expecthmot = (*cp)-&gt;troffcharwidth * fontsize / unitwidth;
	}
}

/*
 * runeout puts a symbol into a string (queue) to be output.
 * It also has to keep track of the current and last symbol
 * output to check that the spacing is correct by default
 * or needs to be adjusted with a spacing operation.
 */

void
runeout(Rune rune) {
	char stoken[UTFmax+1];
	int i;

	i = runetochar(stoken, &amp;rune);
	stoken[i] = '\0';
	glyphout(rune, stoken, TRUE);
}

void
specialout(char *stoken) {
	Rune rune;

	chartorune(&amp;rune, stoken);
	glyphout(rune, stoken, TRUE);
}

void
graphfunc(Biobufhdr *bp) {
	USED(bp);
}

long
nametorune(char *name) {
	USED(name);
	return(0);
}

void
notavail(char *msg) {
	fprint(2, "%s is not available at this time.\n", msg);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

