<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/qi/mem.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/qi/mem.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#define Extern extern
#include "power.h"

extern ulong	textbase;

ulong
ifetch(ulong addr)
{
	uchar *va;
	ulong px;

	if(addr&amp;3) {
		Bprint(bioout, "instruction_address_not_aligned [addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}

	if(icache.on)
		updateicache(addr);

	va = vaddr(addr);
	px = (addr-textbase)/PROFGRAN;
	if(px &lt; iprofsize)
		iprof[px]++;

	va += addr&amp;(BY2PG-1);

	return va[0]&lt;&lt;24 | va[1]&lt;&lt;16 | va[2]&lt;&lt;8 | va[3];
}

ulong
getmem_4(ulong addr)
{
	ulong val;
	int i;

	val = 0;
	for(i = 0; i &lt; 4; i++)
		val = val&lt;&lt;8 | getmem_b(addr++);
	return val;
}

ulong
getmem_2(ulong addr)
{
	ulong val;

	val = getmem_b(addr);
	val = val&lt;&lt;8 | getmem_b(addr+1);

	return val;
}

uvlong
getmem_v(ulong addr)
{
	if(addr&amp;3) {	/* 7? */
		Bprint(bioout, "mem_address_not_aligned [load addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}

	return ((uvlong)getmem_w(addr) &lt;&lt; 32) | getmem_w(addr+4);
}

ulong
getmem_w(ulong addr)
{
	uchar *va;

	if(addr&amp;3) {
		Bprint(bioout, "mem_address_not_aligned [load addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}
	if(membpt)
		brkchk(addr, Read);

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);

	return va[0]&lt;&lt;24 | va[1]&lt;&lt;16 | va[2]&lt;&lt;8 | va[3];
}

ushort
getmem_h(ulong addr)
{
	uchar *va;

	if(addr&amp;1) {
		Bprint(bioout, "mem_address_not_aligned [load addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}
	if(membpt)
		brkchk(addr, Read);

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);

	return va[0]&lt;&lt;8 | va[1];
}

uchar
getmem_b(ulong addr)
{
	uchar *va;

	if(membpt)
		brkchk(addr, Read);

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);
	return va[0];
}

void
putmem_v(ulong addr, uvlong data)
{
	if(addr&amp;3) {	/* 7? */
		Bprint(bioout, "mem_address_not_aligned [store addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}

	putmem_w(addr, data&gt;&gt;32);	/* two stages, to catch brkchk */
	putmem_w(addr+4, data);
}

void
putmem_w(ulong addr, ulong data)
{
	uchar *va;

	if(addr&amp;3) {
		Bprint(bioout, "mem_address_not_aligned [store addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);

	va[0] = data&gt;&gt;24;
	va[1] = data&gt;&gt;16;
	va[2] = data&gt;&gt;8;
	va[3] = data;
	if(membpt)
		brkchk(addr, Write);
}

void
putmem_b(ulong addr, uchar data)
{
	uchar *va;

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);
	va[0] = data;
	if(membpt)
		brkchk(addr, Write);
}

void
putmem_h(ulong addr, short data)
{
	uchar *va;

	if(addr&amp;1) {
		Bprint(bioout, "mem_address_not_aligned [store addr %.8lux]\n", addr);
		longjmp(errjmp, 0);
	}

	va = vaddr(addr);
	va += addr&amp;(BY2PG-1);
	va[0] = data&gt;&gt;8;
	va[1] = data;
	if(membpt)
		brkchk(addr, Write);
}

char *
memio(char *mb, ulong mem, int size, int dir)
{
	int i;
	char *buf, c;

	if(size &lt; 0) {
		Bprint(bioout, "memio: invalid size: %d\n", size);
		longjmp(errjmp, 0);
	}
	if(mb == 0)
		mb = emalloc(size);

	buf = mb;
	switch(dir) {
	default:
		fatal(0, "memio");
	case MemRead:
		while(size--)
			*mb++ = getmem_b(mem++);
		break;
	case MemReadstring:
		for(;;) {
			if(size-- == 0) {
				Bprint(bioout, "memio: user/kernel copy too long for qi\n");
				longjmp(errjmp, 0);
			}
			c = getmem_b(mem++);
			*mb++ = c;
			if(c == '\0')
				break;
		}
		break;
	case MemWrite:
		for(i = 0; i &lt; size; i++)
			putmem_b(mem++, *mb++);
		break;
	}
	return buf;
}

void *
vaddr(ulong addr)
{
	Segment *s, *es;
	int off, foff, l, n;
	uchar **p, *a;

	es = &amp;memory.seg[Nseg];
	for(s = memory.seg; s &lt; es; s++) {
		if(addr &gt;= s-&gt;base &amp;&amp; addr &lt; s-&gt;end) {
			s-&gt;refs++;
			off = (addr-s-&gt;base)/BY2PG;
			p = &amp;s-&gt;table[off];
			if(*p)
				return *p;
			s-&gt;rss++;
			switch(s-&gt;type) {
			default:
				fatal(0, "vaddr");
			case Text:
				*p = emalloc(BY2PG);
				if(seek(text, s-&gt;fileoff+(off*BY2PG), 0) &lt; 0)
					fatal(1, "vaddr text seek");
				if(read(text, *p, BY2PG) &lt; 0)
					fatal(1, "vaddr text read");
				return *p;
			case Data:
				*p = emalloc(BY2PG);
				foff = s-&gt;fileoff+(off*BY2PG);
				if(seek(text, foff, 0) &lt; 0)
					fatal(1, "vaddr text seek");
				n = read(text, *p, BY2PG);
				if(n &lt; 0)
					fatal(1, "vaddr text read");
				if(foff + n &gt; s-&gt;fileend) {
					l = BY2PG - (s-&gt;fileend-foff);
					a = *p+(s-&gt;fileend-foff);
					memset(a, 0, l);
				}
				return *p;
			case Bss:
			case Stack:
				*p = emalloc(BY2PG);
				return *p;
			}
		}
	}
	Bprint(bioout, "data_access_MMU_miss [addr 0x%.8lux]\n", addr);
	longjmp(errjmp, 0);
	return 0;		/*to stop compiler whining*/
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

