<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/qi/qi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/qi/qi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#include &lt;tos.h&gt;
#define Extern
#include "power.h"

char	*file = "q.out";
int	datasize;
ulong	textbase;
Biobuf	bp, bi;
Fhdr	fhdr;
ulong	bits[32];

void
main(int argc, char **argv)
{
	int pid, i;

	argc--;
	argv++;

	bioout = &amp;bp;
	bin = &amp;bi;
	Binit(bioout, 1, OWRITE);
	Binit(bin, 0, OREAD);

	if(argc) {
		pid = atoi(argv[0]);
		if(pid != 0) {
			procinit(pid);
			cmd();
		}
		file = argv[0];
	}
	argc--;
	argv++;

	text = open(file, OREAD);
	if(text &lt; 0)
		fatal(1, "open text '%s'", file);

	Bprint(bioout, "qi\n");
	inithdr(text);
	initstk(argc, argv);

	for(i=0; i&lt;32; i++)
		bits[i] = 1L &lt;&lt; (31-i);

	fpreginit();
	cmd();
}

/*
 * we're rounding segment boundaries to the nearest 1MB on power now,
 * and mach-&gt;pgsize is actually what to round segment boundaries up to.
 */
#define SEGROUND mach-&gt;pgsize

void
initmap(void)
{

	ulong t, d, b, bssend;
	Segment *s;

	t = (fhdr.txtaddr+fhdr.txtsz+(SEGROUND-1)) &amp; ~(SEGROUND-1);
	d = (t + fhdr.datsz + (SEGROUND-1)) &amp; ~(SEGROUND-1);
	bssend = t + fhdr.datsz + fhdr.bsssz;
	b = (bssend + (SEGROUND-1)) &amp; ~(SEGROUND-1);

	s = &amp;memory.seg[Text];
	s-&gt;type = Text;
	s-&gt;base = fhdr.txtaddr - fhdr.hdrsz;
	s-&gt;end = t;
	s-&gt;fileoff = fhdr.txtoff - fhdr.hdrsz;
	s-&gt;fileend = s-&gt;fileoff + fhdr.txtsz;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	iprofsize = (s-&gt;end-s-&gt;base)/PROFGRAN;
	iprof = emalloc(iprofsize*sizeof(long));
	textbase = s-&gt;base;

	s = &amp;memory.seg[Data];
	s-&gt;type = Data;
	s-&gt;base = t;
	s-&gt;end = t+(d-t);
	s-&gt;fileoff = fhdr.datoff;
	s-&gt;fileend = s-&gt;fileoff + fhdr.datsz;
	datasize = fhdr.datsz;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	s = &amp;memory.seg[Bss];
	s-&gt;type = Bss;
	s-&gt;base = d;
	s-&gt;end = d+(b-d);
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	s = &amp;memory.seg[Stack];
	s-&gt;type = Stack;
	s-&gt;base = STACKTOP-STACKSIZE;
	s-&gt;end = STACKTOP;
	s-&gt;table = emalloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));

	reg.pc = fhdr.entry;
}

void
inithdr(int fd)
{
	Symbol s;

	extern Machdata powermach;

	seek(fd, 0, 0);
	if (!crackhdr(fd, &amp;fhdr))
		fatal(0, "read text header");

	if(fhdr.type != FPOWER)
		fatal(0, "bad magic number");

	if(syminit(fd, &amp;fhdr) &lt; 0)
		fatal(0, "%r\n");
	symmap = loadmap(symmap, fd, &amp;fhdr);
	if (mach-&gt;sbreg &amp;&amp; lookup(0, mach-&gt;sbreg, &amp;s))
		mach-&gt;sb = s.value;
	machdata = &amp;powermach;
}

ulong
greg(int f, ulong off)
{
	int n;
	ulong l;
	uchar wd[BY2WD];
	
	seek(f, off, 0);
	n = read(f, wd, BY2WD);
	if(n != BY2WD)
		fatal(1, "read register");

	l  = wd[0]&lt;&lt;24;
	l |= wd[1]&lt;&lt;16;
	l |= wd[2]&lt;&lt;8;
	l |= wd[3];
	return l;
}

ulong
roff[] = {
	REGOFF(r0),
	REGOFF(r1),	REGOFF(r2),	REGOFF(r3),
	REGOFF(r4),	REGOFF(r5),	REGOFF(r6),
	REGOFF(r7),	REGOFF(r8),	REGOFF(r9),
	REGOFF(r10),	REGOFF(r11),	REGOFF(r12),
	REGOFF(r13),	REGOFF(r14),	REGOFF(r15),
	REGOFF(r16),	REGOFF(r17),	REGOFF(r18),
	REGOFF(r19),	REGOFF(r20),	REGOFF(r21),
	REGOFF(r22),	REGOFF(r23),	REGOFF(r24),
	REGOFF(r25),	REGOFF(r26),	REGOFF(r27),
	REGOFF(r28),	REGOFF(r29),	REGOFF(r30),
	REGOFF(r31),
};

void
seginit(int fd, Segment *s, int idx, ulong vastart, ulong vaend)
{
	int n;

	while(vastart &lt; vaend) {
		seek(fd, vastart, 0);
		s-&gt;table[idx] = emalloc(BY2PG);
		n = read(fd, s-&gt;table[idx], BY2PG);
		if(n != BY2PG)
			fatal(1, "data read");
		vastart += BY2PG;
		idx++;
	}
}

void
procinit(int pid)
{
	char *p;
	Segment *s;
	int n, m, sg, i;
	ulong vastart, vaend;
	char mfile[128], tfile[128], sfile[1024];

	sprint(mfile, "/proc/%d/mem", pid);
	sprint(tfile, "/proc/%d/text", pid);
	sprint(sfile, "/proc/%d/segment", pid);

	text = open(tfile, OREAD);
	if(text &lt; 0)
		fatal(1, "open text %s", tfile);
	inithdr(text);

	sg = open(sfile, OREAD);
	if(sg &lt; 0)
		fatal(1, "open text %s", sfile);

	n = read(sg, sfile, sizeof(sfile));
	if(n &gt;= sizeof(sfile))
		fatal(0, "segment file buffer too small");
	close(sg);

	m = open(mfile, OREAD);
	if(m &lt; 0)
		fatal(1, "open %s", mfile);

	initmap();

	p = strstr(sfile, "Data");
	if(p == 0)
		fatal(0, "no data");

	vastart = strtoul(p+9, 0, 16);
	vaend = strtoul(p+18, 0, 16);
	s = &amp;memory.seg[Data];
	if(s-&gt;base != vastart || s-&gt;end != vaend) {
		s-&gt;base = vastart;
		s-&gt;end = vaend;
		free(s-&gt;table);
		s-&gt;table = malloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));
	}
	seginit(m, s, 0, vastart, vaend);
	
	p = strstr(sfile, "Bss");
	if(p == 0)
		fatal(0, "no bss");

	vastart = strtoul(p+9, 0, 16);
	vaend = strtoul(p+18, 0, 16);
	s = &amp;memory.seg[Bss];
	if(s-&gt;base != vastart || s-&gt;end != vaend) {
		s-&gt;base = vastart;
		s-&gt;end = vaend;
		free(s-&gt;table);
		s-&gt;table = malloc(((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*));
	}
	seginit(m, s, 0, vastart, vaend);

	reg.pc = greg(m, REGOFF(pc));
	reg.r[1] = greg(m, REGOFF(sp));
	reg.r[2] = greg(m, REGOFF(r2));
	reg.r[30] = greg(m, REGOFF(r30));
	reg.r[31] = greg(m, REGOFF(r31));

	for(i = 0; i &lt; 32; i++)
		reg.r[i] = greg(m, roff[i-1]);

	s = &amp;memory.seg[Stack];
	vastart = reg.r[1] &amp; ~(BY2PG-1);
	seginit(m, s, (vastart-s-&gt;base)/BY2PG, vastart, STACKTOP);
	close(m);
	Bprint(bioout, "qi\n"); 
}

void
reset(void)
{
	int i, l, m;
	Segment *s;
	Breakpoint *b;

	memset(&amp;reg, 0, sizeof(Registers));
	fpreginit();
	for(i = 0; i &gt; Nseg; i++) {
		s = &amp;memory.seg[i];
		l = ((s-&gt;end-s-&gt;base)/BY2PG)*sizeof(uchar*);
		for(m = 0; m &lt; l; m++)
			if(s-&gt;table[m])
				free(s-&gt;table[m]);
		free(s-&gt;table);
	}
	free(iprof);
	memset(&amp;memory, 0, sizeof(memory));

	for(b = bplist; b; b = b-&gt;next)
		b-&gt;done = b-&gt;count;
}

void
initstk(int argc, char *argv[])
{
	ulong size, sp, ap, tos;
	int i;
	char *p;

	initmap();
	tos = STACKTOP - sizeof(Tos)*2;	/* we'll assume twice the host's is big enough */
	sp = tos;
	for (i = 0; i &lt; sizeof(Tos)*2; i++)
		putmem_b(tos + i, 0);

	/*
	 * pid is second word from end of tos and needs to be set for nsec().
	 * we know power is a 32-bit cpu, so we'll assume knowledge of the Tos
	 * struct for now, and use our pid.
	 */
	putmem_w(tos + 4*4 + 2*sizeof(ulong) + 3*sizeof(uvlong), getpid());

	/* Build exec stack */
	size = strlen(file)+1+BY2WD+BY2WD+(BY2WD*2);	
	for(i = 0; i &lt; argc; i++)
		size += strlen(argv[i])+BY2WD+1;

	sp -= size;
	sp &amp;= ~7;
	reg.r[1] = sp;
	reg.r[3] = tos;		/* Plan 9 profiling clock, etc. */

	/* Push argc */
	putmem_w(sp, argc+1);
	sp += BY2WD;

	/* Compute sizeof(argv) and push argv[0] */
	ap = sp+((argc+1)*BY2WD)+BY2WD;
	putmem_w(sp, ap);
	sp += BY2WD;
	
	/* Build argv[0] string into stack */
	for(p = file; *p; p++)
		putmem_b(ap++, *p);

	putmem_b(ap++, '\0');

	/* Loop through pushing the arguments */
	for(i = 0; i &lt; argc; i++) {
		putmem_w(sp, ap);
		sp += BY2WD;
		for(p = argv[i]; *p; p++)
			putmem_b(ap++, *p);
		putmem_b(ap++, '\0');
	}
	/* Null terminate argv */
	putmem_w(sp, 0);

}

void
fatal(int syserr, char *fmt, ...)
{
	char buf[ERRMAX], *s;
	va_list ap;

	va_start(ap, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, ap);
	va_end(ap);
	s = "qi: %s\n";
	if(syserr)
		s = "qi: %s: %r\n";
	fprint(2, s, buf);
	exits(buf);
}

void
itrace(char *fmt, ...)
{
	char buf[128];
	va_list ap;

	va_start(ap, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, ap);
	va_end(ap);
	Bprint(bioout, "%8lux %.8lux %s\n", reg.pc, reg.ir, buf);
Bflush(bioout);
}

void
dumpreg(void)
{
	int i;

	Bprint(bioout, "PC  #%-8lux SP  #%-8lux CR #%-8lux LR #%-8lux CTR #%-8lux XER #%-8lux\n",
				reg.pc, reg.r[1], reg.cr, reg.lr, reg.ctr, reg.xer);

	for(i = 0; i &lt; 32; i++) {
		if((i%4) == 0 &amp;&amp; i != 0)
			Bprint(bioout, "\n");
		Bprint(bioout, "R%-2d #%-8lux ", i, reg.r[i]);
	}
	Bprint(bioout, "\n");
}

void
dumpfreg(void)
{
	dumpdreg();
}

void
dumpdreg(void)
{
	int i;
	char buf[64];
	FPdbleword d;

	i = 0;
	while(i &lt; 32) {
		d.x = reg.fd[i];
		ieeedftos(buf, sizeof(buf), d.hi, d.lo);
		Bprint(bioout, "F%-2d %s\t", i, buf);
		i++;
		d.x = reg.fd[i];
		ieeedftos(buf, sizeof(buf), d.hi, d.lo);
		Bprint(bioout, "\tF%-2d %s\n", i, buf);
		i++;
	}
}

void *
emalloc(ulong size)
{
	void *a;

	a = malloc(size);
	if(a == 0)
		fatal(0, "no memory");

	memset(a, 0, size);
	return a;
}

void *
erealloc(void *a, ulong oldsize, ulong size)
{
	void *n;

	n = malloc(size);
	if(n == 0)
		fatal(0, "no memory");
	memset(n, 0, size);
	if(size &gt; oldsize)
		size = oldsize;
	memmove(n, a, size);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

