<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ql/asm.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ql/asm.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"l.h"

#define JMPSZ	sizeof(u32int)		/* size of bootstrap jump section */

#define	LPUT(c)\
	{\
		cbp[0] = (c)&gt;&gt;24;\
		cbp[1] = (c)&gt;&gt;16;\
		cbp[2] = (c)&gt;&gt;8;\
		cbp[3] = (c);\
		cbp += 4;\
		cbc -= 4;\
		if(cbc &lt;= 0)\
			cflush();\
	}

#define	CPUT(c)\
	{\
		cbp[0] = (c);\
		cbp++;\
		cbc--;\
		if(cbc &lt;= 0)\
			cflush();\
	}

void	strnput(char*, int);

long
entryvalue(void)
{
	char *a;
	Sym *s;

	a = INITENTRY;
	if(*a &gt;= '0' &amp;&amp; *a &lt;= '9')
		return atolwhex(a);
	s = lookup(a, 0);
	if(s-&gt;type == 0)
		return INITTEXT;
	if(dlm &amp;&amp; s-&gt;type == SDATA)
		return s-&gt;value+INITDAT;
	if(s-&gt;type != STEXT &amp;&amp; s-&gt;type != SLEAF)
		diag("entry not text: %s", s-&gt;name);
	return s-&gt;value;
}

static void
elf32jmp(Putl putl)
{
	/* describe a tiny text section at end with jmp to start; see below */
	elf32phdr(putl, PT_LOAD, HEADR+textsize-JMPSZ, 0xFFFFFFFC, 0xFFFFFFFC,
		JMPSZ, JMPSZ, R|X, 0);	/* text */
}

void
asmb(void)
{
	Prog *p;
	long t;
	Optab *o;
	long prevpc;

	if(debug['v'])
		Bprint(&amp;bso, "%5.2f asm\n", cputime());
	Bflush(&amp;bso);

	/* emit text segment */
	seek(cout, HEADR, 0);
	prevpc = pc = INITTEXT;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;as == ATEXT) {
			curtext = p;
			autosize = p-&gt;to.offset + 4;
			if(p-&gt;from3.type == D_CONST) {
				for(; pc &lt; p-&gt;pc; pc++)
					CPUT(0);
			}
		}
		if(p-&gt;pc != pc) {
			diag("phase error %lux sb %lux",
				p-&gt;pc, pc);
			if(!debug['a'])
				prasm(curp);
			pc = p-&gt;pc;
		}
		curp = p;
		o = oplook(p);	/* could probably avoid this call */
		if(asmout(p, o, 0)) {
			p = p-&gt;link;
			pc += 4;
		}
		pc += o-&gt;size;
		if (prevpc &amp; (1&lt;&lt;31) &amp;&amp; (pc &amp; (1&lt;&lt;31)) == 0) {
			char *tn;

			tn = "??none??";
			if(curtext != P &amp;&amp; curtext-&gt;from.sym != S)
				tn = curtext-&gt;from.sym-&gt;name;
			Bprint(&amp;bso, "%s: warning: text segment wrapped past 0\n", tn);
		}
		prevpc = pc;
	}

	if(debug['a'])
		Bprint(&amp;bso, "\n");
	Bflush(&amp;bso);
	cflush();

	/* emit data segment */
	curtext = P;
	switch(HEADTYPE) {
	case 6:
		/*
		 * but first, for virtex 4, inject a jmp instruction after
		 * other text: branch to absolute entry address (0xfffe2100).
		 */
		lput((18 &lt;&lt; 26) | (0x03FFFFFC &amp; entryvalue()) | 2);
		textsize += JMPSZ;
		cflush();
		/* fall through */
	case 0:
	case 1:
	case 2:
	case 5:
		seek(cout, HEADR+textsize, 0);
		break;
	case 3:
		seek(cout, rnd(HEADR+textsize, 4), 0);
		break;
	case 4:
		seek(cout, rnd(HEADR+textsize, 4096), 0);
		break;
	}

	if(dlm){
		char buf[8];

		write(cout, buf, INITDAT-textsize);
		textsize = INITDAT;
	}

	for(t = 0; t &lt; datsize; t += sizeof(buf)-100) {
		if(datsize-t &gt; sizeof(buf)-100)
			datblk(t, sizeof(buf)-100);
		else
			datblk(t, datsize-t);
	}

	symsize = 0;
	lcsize = 0;
	if(!debug['s']) {
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f sym\n", cputime());
		Bflush(&amp;bso);
		switch(HEADTYPE) {
		case 0:
		case 1:
		case 2:
		case 5:
		case 6:
			seek(cout, HEADR+textsize+datsize, 0);
			break;
		case 3:
			seek(cout, rnd(HEADR+textsize, 4)+datsize, 0);
			break;
		case 4:
			seek(cout, rnd(HEADR+textsize, 4096)+datsize, 0);
			break;
		}
		if(!debug['s'])
			asmsym();
		if(debug['v'])
			Bprint(&amp;bso, "%5.2f sp\n", cputime());
		Bflush(&amp;bso);
		if(!debug['s'])
			asmlc();
		if(dlm)
			asmdyn();
		if(HEADTYPE == 0 || HEADTYPE == 1)	/* round up file length for boot image */
			if((symsize+lcsize) &amp; 1)
				CPUT(0);
		cflush();
	}
	else if(dlm){
		asmdyn();
		cflush();
	}

	/* back up and write the header */
	seek(cout, 0L, 0);
	switch(HEADTYPE) {
	case 0:
		lput(0x1030107);		/* magic and sections */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(symsize);			/* nsyms */
		lput(entryvalue());		/* va of entry */
		lput(0L);
		lput(lcsize);
		break;
	case 1:
		lput(0x4a6f7921);		/* Joy! */
		lput(0x70656666);		/* peff */
		lput(0x70777063);		/* pwpc */
		lput(1);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0x30002);			/*YY*/
		lput(0);
		lput(~0);
		lput(0);
		lput(textsize+datsize);
		lput(textsize+datsize);
		lput(textsize+datsize);
		lput(0xd0);			/* header size */
		lput(0x10400);
		lput(~0);
		lput(0);
		lput(0xc);
		lput(0xc);
		lput(0xc);
		lput(0xc0);
		lput(0x01010400);
		lput(~0);
		lput(0);
		lput(0x38);
		lput(0x38);
		lput(0x38);
		lput(0x80);
		lput(0x04040400);
		lput(0);
		lput(1);
		lput(0);
		lput(~0);
		lput(0);
		lput(~0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0);
		lput(0x3100);			/* load address */
		lput(0);
		lput(0);
		lput(0);			/* whew! */
		break;
	case 2:
		if(dlm)
			lput(0x80000000 | (4*21*21+7));		/* magic */
		else
			lput(4*21*21+7);	/* magic */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(symsize);			/* nsyms */
		lput(entryvalue());		/* va of entry */
		lput(0L);
		lput(lcsize);
		break;
	case 3:
		break;
	case 4:
		lput((0x1DFL&lt;&lt;16)|3L);		/* magic and sections */
		lput(time(0));			/* time and date */
		lput(rnd(HEADR+textsize, 4096)+datsize);
		lput(symsize);			/* nsyms */
		lput((0x48L&lt;&lt;16)|15L);		/* size of optional hdr and flags */

		lput((0413&lt;&lt;16)|01L);		/* magic and version */
		lput(textsize);			/* sizes */
		lput(datsize);
		lput(bsssize);
		lput(entryvalue());		/* va of entry */
		lput(INITTEXT);			/* va of base of text */
		lput(INITDAT);			/* va of base of data */
		lput(INITDAT);			/* address of TOC */
		lput((1L&lt;&lt;16)|1);		/* sn(entry) | sn(text) */
		lput((2L&lt;&lt;16)|1);		/* sn(data) | sn(toc) */
		lput((0L&lt;&lt;16)|3);		/* sn(loader) | sn(bss) */
		lput((3L&lt;&lt;16)|3);		/* maxalign(text) | maxalign(data) */
		lput(('1'&lt;&lt;24)|('L'&lt;&lt;16)|0);	/* type field, and reserved */
		lput(0);			/* max stack allowed */
		lput(0);			/* max data allowed */
		lput(0); lput(0); lput(0);	/* reserved */

		strnput(".text", 8);		/* text segment */
		lput(INITTEXT);			/* address */
		lput(INITTEXT);
		lput(textsize);
		lput(HEADR);
		lput(0L);
		lput(HEADR+textsize+datsize+symsize);
		lput(lcsize);			/* line number size */
		lput(0x20L);			/* flags */

		strnput(".data", 8);		/* data segment */
		lput(INITDAT);			/* address */
		lput(INITDAT);
		lput(datsize);
		lput(rnd(HEADR+textsize, 4096));/* sizes */
		lput(0L);
		lput(0L);
		lput(0L);
		lput(0x40L);			/* flags */

		strnput(".bss", 8);		/* bss segment */
		lput(INITDAT+datsize);		/* address */
		lput(INITDAT+datsize);
		lput(bsssize);
		lput(0L);
		lput(0L);
		lput(0L);
		lput(0L);
		lput(0x80L);			/* flags */
		break;
	case 5:
		/*
		 * intended for blue/gene
		 */
		elf32(POWER, ELFDATA2MSB, 0, nil);
		break;
	case 6:
		/*
		 * intended for virtex 4 boot
		 */
		debug['S'] = 1;			/* symbol table */
		elf32(POWER, ELFDATA2MSB, 1, elf32jmp);
		break;
	}
	cflush();
}

void
strnput(char *s, int n)
{
	for(; *s; s++){
		CPUT(*s);
		n--;
	}
	for(; n &gt; 0; n--)
		CPUT(0);
}

void
cput(long l)
{
	CPUT(l);
}

void
wput(long l)
{
	cbp[0] = l&gt;&gt;8;
	cbp[1] = l;
	cbp += 2;
	cbc -= 2;
	if(cbc &lt;= 0)
		cflush();
}

void
wputl(long l)
{
	cbp[0] = l;
	cbp[1] = l&gt;&gt;8;
	cbp += 2;
	cbc -= 2;
	if(cbc &lt;= 0)
		cflush();
}

void
lput(long l)
{
	LPUT(l);
}

void
lputl(long c)
{
	cbp[0] = (c);
	cbp[1] = (c)&gt;&gt;8;
	cbp[2] = (c)&gt;&gt;16;
	cbp[3] = (c)&gt;&gt;24;
	cbp += 4;
	cbc -= 4;
	if(cbc &lt;= 0)
		cflush();
}

void
llput(vlong v)
{
	lput(v&gt;&gt;32);
	lput(v);
}

void
llputl(vlong v)
{
	lputl(v);
	lputl(v&gt;&gt;32);
}

void
cflush(void)
{
	int n;

	n = sizeof(buf.cbuf) - cbc;
	if(n)
		write(cout, buf.cbuf, n);
	cbp = buf.cbuf;
	cbc = sizeof(buf.cbuf);
}

void
asmsym(void)
{
	Prog *p;
	Auto *a;
	Sym *s;
	int h;

	s = lookup("etext", 0);
	if(s-&gt;type == STEXT)
		putsymb(s-&gt;name, 'T', s-&gt;value, s-&gt;version);

	for(h=0; h&lt;NHASH; h++)
		for(s=hash[h]; s!=S; s=s-&gt;link)
			switch(s-&gt;type) {
			case SCONST:
				putsymb(s-&gt;name, 'D', s-&gt;value, s-&gt;version);
				continue;

			case SDATA:
				putsymb(s-&gt;name, 'D', s-&gt;value+INITDAT, s-&gt;version);
				continue;

			case SBSS:
				putsymb(s-&gt;name, 'B', s-&gt;value+INITDAT, s-&gt;version);
				continue;

			case SFILE:
				putsymb(s-&gt;name, 'f', s-&gt;value, s-&gt;version);
				continue;
			}

	for(p=textp; p!=P; p=p-&gt;cond) {
		s = p-&gt;from.sym;
		if(s-&gt;type != STEXT &amp;&amp; s-&gt;type != SLEAF)
			continue;

		/* filenames first */
		for(a=p-&gt;to.autom; a; a=a-&gt;link)
			if(a-&gt;type == D_FILE)
				putsymb(a-&gt;sym-&gt;name, 'z', a-&gt;aoffset, 0);
			else
			if(a-&gt;type == D_FILE1)
				putsymb(a-&gt;sym-&gt;name, 'Z', a-&gt;aoffset, 0);

		if(s-&gt;type == STEXT)
			putsymb(s-&gt;name, 'T', s-&gt;value, s-&gt;version);
		else
			putsymb(s-&gt;name, 'L', s-&gt;value, s-&gt;version);

		/* frame, auto and param after */
		putsymb(".frame", 'm', p-&gt;to.offset+4, 0);
		for(a=p-&gt;to.autom; a; a=a-&gt;link)
			if(a-&gt;type == D_AUTO)
				putsymb(a-&gt;sym-&gt;name, 'a', -a-&gt;aoffset, 0);
			else
			if(a-&gt;type == D_PARAM)
				putsymb(a-&gt;sym-&gt;name, 'p', a-&gt;aoffset, 0);
	}
	if(debug['v'] || debug['n'])
		Bprint(&amp;bso, "symsize = %lud\n", symsize);
	Bflush(&amp;bso);
}

void
putsymb(char *s, int t, long v, int ver)
{
	int i, f;

	if(t == 'f')
		s++;
	LPUT(v);
	if(ver)
		t += 'a' - 'A';
	CPUT(t+0x80);			/* 0x80 is variable length */

	if(t == 'Z' || t == 'z') {
		CPUT(s[0]);
		for(i=1; s[i] != 0 || s[i+1] != 0; i += 2) {
			CPUT(s[i]);
			CPUT(s[i+1]);
		}
		CPUT(0);
		CPUT(0);
		i++;
	}
	else {
		for(i=0; s[i]; i++)
			CPUT(s[i]);
		CPUT(0);
	}
	symsize += 4 + 1 + i + 1;

	if(debug['n']) {
		if(t == 'z' || t == 'Z') {
			Bprint(&amp;bso, "%c %.8lux ", t, v);
			for(i=1; s[i] != 0 || s[i+1] != 0; i+=2) {
				f = ((s[i]&amp;0xff) &lt;&lt; 8) | (s[i+1]&amp;0xff);
				Bprint(&amp;bso, "/%x", f);
			}
			Bprint(&amp;bso, "\n");
			return;
		}
		if(ver)
			Bprint(&amp;bso, "%c %.8lux %s&lt;%d&gt;\n", t, v, s, ver);
		else
			Bprint(&amp;bso, "%c %.8lux %s\n", t, v, s);
	}
}

#define	MINLC	4
void
asmlc(void)
{
	long oldpc, oldlc;
	Prog *p;
	long v, s;

	oldpc = INITTEXT;
	oldlc = 0;
	for(p = firstp; p != P; p = p-&gt;link) {
		if(p-&gt;line == oldlc || p-&gt;as == ATEXT || p-&gt;as == ANOP) {
			if(p-&gt;as == ATEXT)
				curtext = p;
			if(debug['V'])
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			continue;
		}
		if(debug['V'])
			Bprint(&amp;bso, "\t\t%6ld", lcsize);
		v = (p-&gt;pc - oldpc) / MINLC;
		while(v) {
			s = 127;
			if(v &lt; 127)
				s = v;
			CPUT(s+128);	/* 129-255 +pc */
			if(debug['V'])
				Bprint(&amp;bso, " pc+%ld*%d(%ld)", s, MINLC, s+128);
			v -= s;
			lcsize++;
		}
		s = p-&gt;line - oldlc;
		oldlc = p-&gt;line;
		oldpc = p-&gt;pc + MINLC;
		if(s &gt; 64 || s &lt; -64) {
			CPUT(0);	/* 0 vv +lc */
			CPUT(s&gt;&gt;24);
			CPUT(s&gt;&gt;16);
			CPUT(s&gt;&gt;8);
			CPUT(s);
			if(debug['V']) {
				if(s &gt; 0)
					Bprint(&amp;bso, " lc+%ld(%d,%ld)\n",
						s, 0, s);
				else
					Bprint(&amp;bso, " lc%ld(%d,%ld)\n",
						s, 0, s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
			lcsize += 5;
			continue;
		}
		if(s &gt; 0) {
			CPUT(0+s);	/* 1-64 +lc */
			if(debug['V']) {
				Bprint(&amp;bso, " lc+%ld(%ld)\n", s, 0+s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
		} else {
			CPUT(64-s);	/* 65-128 -lc */
			if(debug['V']) {
				Bprint(&amp;bso, " lc%ld(%ld)\n", s, 64-s);
				Bprint(&amp;bso, "%6lux %P\n",
					p-&gt;pc, p);
			}
		}
		lcsize++;
	}
	while(lcsize &amp; 1) {
		s = 129;
		CPUT(s);
		lcsize++;
	}
	if(debug['v'] || debug['V'])
		Bprint(&amp;bso, "lcsize = %ld\n", lcsize);
	Bflush(&amp;bso);
}

void
datblk(long s, long n)
{
	Prog *p;
	char *cast;
	long l, fl, j, d;
	int i, c;

	memset(buf.dbuf, 0, n+100);
	for(p = datap; p != P; p = p-&gt;link) {
		curp = p;
		l = p-&gt;from.sym-&gt;value + p-&gt;from.offset - s;
		c = p-&gt;reg;
		i = 0;
		if(l &lt; 0) {
			if(l+c &lt;= 0)
				continue;
			while(l &lt; 0) {
				l++;
				i++;
			}
		}
		if(l &gt;= n)
			continue;
		if(p-&gt;as != AINIT &amp;&amp; p-&gt;as != ADYNT) {
			for(j=l+(c-i)-1; j&gt;=l; j--)
				if(buf.dbuf[j]) {
					print("%P\n", p);
					diag("multiple initialization");
					break;
				}
		}
		switch(p-&gt;to.type) {
		default:
			diag("unknown mode in initialization\n%P", p);
			break;

		case D_FCONST:
			switch(c) {
			default:
			case 4:
				fl = ieeedtof(&amp;p-&gt;to.ieee);
				cast = (char*)&amp;fl;
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i+4]];
					l++;
				}
				break;
			case 8:
				cast = (char*)&amp;p-&gt;to.ieee;
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[fnuxi8[i]];
					l++;
				}
				break;
			}
			break;

		case D_SCONST:
			for(; i&lt;c; i++) {
				buf.dbuf[l] = p-&gt;to.sval[i];
				l++;
			}
			break;

		case D_CONST:
			d = p-&gt;to.offset;
			if(p-&gt;to.sym) {
				if(p-&gt;to.sym-&gt;type == SUNDEF){
					ckoff(p-&gt;to.sym, d);
					d += p-&gt;to.sym-&gt;value;
				}
				if(p-&gt;to.sym-&gt;type == STEXT ||
				   p-&gt;to.sym-&gt;type == SLEAF)
					d += p-&gt;to.sym-&gt;value;
				if(p-&gt;to.sym-&gt;type == SDATA)
					d += p-&gt;to.sym-&gt;value + INITDAT;
				if(p-&gt;to.sym-&gt;type == SBSS)
					d += p-&gt;to.sym-&gt;value + INITDAT;
				if(dlm)
					dynreloc(p-&gt;to.sym, l+s+INITDAT, 1, 0, 0);
			}
			cast = (char*)&amp;d;
			switch(c) {
			default:
				diag("bad nuxi %d %d\n%P", c, i, curp);
				break;
			case 1:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi1[i]];
					l++;
				}
				break;
			case 2:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi2[i]];
					l++;
				}
				break;
			case 4:
				for(; i&lt;c; i++) {
					buf.dbuf[l] = cast[inuxi4[i]];
					l++;
				}
				break;
			}
			break;
		}
	}
	write(cout, buf.dbuf, n);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

