<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ramfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ramfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;

/*
 * Rather than reading /adm/users, which is a lot of work for
 * a toy program, we assume all groups have the form
 *	NNN:user:user:
 * meaning that each user is the leader of his own group.
 */

enum
{
	OPERM	= 0x3,		/* mask of all permission types in open mode */
	Nram	= 4096,
	Maxsize	= 768*1024*1024,
	Maxfdata	= 8192,
	Maxulong= (1ULL &lt;&lt; 32) - 1,
};

typedef struct Fid Fid;
typedef struct Ram Ram;

struct Fid
{
	short	busy;
	short	open;
	short	rclose;
	int	fid;
	Fid	*next;
	char	*user;
	Ram	*ram;
};

struct Ram
{
	short	busy;
	short	open;
	long	parent;		/* index in Ram array */
	Qid	qid;
	long	perm;
	char	*name;
	ulong	atime;
	ulong	mtime;
	char	*user;
	char	*group;
	char	*muid;
	char	*data;
	long	ndata;
};

enum
{
	Pexec =		1,
	Pwrite = 	2,
	Pread = 	4,
	Pother = 	1,
	Pgroup = 	8,
	Powner =	64,
};

ulong	path;		/* incremented for each new file */
Fid	*fids;
Ram	ram[Nram];
int	nram;
int	mfd[2];
char	*user;
uchar	mdata[IOHDRSZ+Maxfdata];
uchar	rdata[Maxfdata];	/* buffer for data in reply */
uchar statbuf[STATMAX];
Fcall thdr;
Fcall	rhdr;
int	messagesize = sizeof mdata;

Fid *	newfid(int);
uint	ramstat(Ram*, uchar*, uint);
void	error(char*);
void	io(void);
void	*erealloc(void*, ulong);
void	*emalloc(ulong);
char	*estrdup(char*);
void	usage(void);
int	perm(Fid*, Ram*, int);

char	*rflush(Fid*), *rversion(Fid*), *rauth(Fid*),
	*rattach(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

int needfid[] = {
	[Tversion] 0,
	[Tflush] 0,
	[Tauth] 0,
	[Tattach] 0,
	[Twalk] 1,
	[Topen] 1,
	[Tcreate] 1,
	[Tread] 1,
	[Twrite] 1,
	[Tclunk] 1,
	[Tremove] 1,
	[Tstat] 1,
	[Twstat] 1,
};

char 	*(*fcalls[])(Fid*) = {
	[Tversion]	rversion,
	[Tflush]	rflush,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"ramfs: authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Eisdir[] =	"file is a directory";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Eversion[] =	"unknown 9P version";
char	Enotempty[] =	"directory not empty";

int debug;
int private;

static int memlim = 1;

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	Ram *r;
	char *defmnt, *service;
	int p[2];
	int fd;
	int stdio = 0;

	service = "ramfs";
	defmnt = "/tmp";
	ARGBEGIN{
	case 'i':
		defmnt = 0;
		stdio = 1;
		mfd[0] = 0;
		mfd[1] = 1;
		break;
	case 'm':
		defmnt = EARGF(usage());
		break;
	case 'p':
		private++;
		break;
	case 's':
		defmnt = 0;
		break;
	case 'u':
		memlim = 0;		/* unlimited memory consumption */
		break;
	case 'D':
		debug = 1;
		break;
	case 'S':
		defmnt = 0;
		service = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(pipe(p) &lt; 0)
		error("pipe failed");
	if(!stdio){
		mfd[0] = p[0];
		mfd[1] = p[0];
		if(defmnt == 0){
			char buf[64];
			snprint(buf, sizeof buf, "#s/%s", service);
			fd = create(buf, OWRITE|ORCLOSE, 0666);
			if(fd &lt; 0)
				error("create failed");
			sprint(buf, "%d", p[1]);
			if(write(fd, buf, strlen(buf)) &lt; 0)
				error("writing service file");
		}
	}

	user = getuser();
	notify(notifyf);
	nram = 1;
	r = &amp;ram[0];
	r-&gt;busy = 1;
	r-&gt;data = 0;
	r-&gt;ndata = 0;
	r-&gt;perm = DMDIR | 0775;
	r-&gt;qid.type = QTDIR;
	r-&gt;qid.path = 0LL;
	r-&gt;qid.vers = 0;
	r-&gt;parent = 0;
	r-&gt;user = user;
	r-&gt;group = user;
	r-&gt;muid = user;
	r-&gt;atime = time(0);
	r-&gt;mtime = r-&gt;atime;
	r-&gt;name = estrdup(".");

	if(debug) {
		fmtinstall('F', fcallfmt);
		fmtinstall('M', dirmodefmt);
	}
	switch(rfork(RFFDG|RFPROC|RFNAMEG|RFNOTEG)){
	case -1:
		error("fork");
	case 0:
		close(p[1]);
		io();
		break;
	default:
		close(p[0]);	/* don't deadlock if child fails */
		if(defmnt &amp;&amp; mount(p[1], -1, defmnt, MREPL|MCREATE, "") &lt; 0)
			error("mount failed");
	}
	exits(0);
}

char*
rversion(Fid*)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);
	if(thdr.msize &gt; sizeof mdata)
		rhdr.msize = sizeof mdata;
	else
		rhdr.msize = thdr.msize;
	messagesize = rhdr.msize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return Eversion;
	rhdr.version = "9P2000";
	return 0;
}

char*
rauth(Fid*)
{
	return "ramfs: no authentication required";
}

char*
rflush(Fid *f)
{
	USED(f);
	return 0;
}

char*
rattach(Fid *f)
{
	/* no authentication! */
	f-&gt;busy = 1;
	f-&gt;rclose = 0;
	f-&gt;ram = &amp;ram[0];
	rhdr.qid = f-&gt;ram-&gt;qid;
	if(thdr.uname[0])
		f-&gt;user = estrdup(thdr.uname);
	else
		f-&gt;user = "none";
	if(strcmp(user, "none") == 0)
		user = f-&gt;user;
	return 0;
}

char*
clone(Fid *f, Fid **nf)
{
	if(f-&gt;open)
		return Eisopen;
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	*nf = newfid(thdr.newfid);
	(*nf)-&gt;busy = 1;
	(*nf)-&gt;open = 0;
	(*nf)-&gt;rclose = 0;
	(*nf)-&gt;ram = f-&gt;ram;
	(*nf)-&gt;user = f-&gt;user;	/* no ref count; the leakage is minor */
	return 0;
}

char*
rwalk(Fid *f)
{
	Ram *r, *fram;
	char *name;
	Ram *parent;
	Fid *nf;
	char *err;
	ulong t;
	int i;

	err = nil;
	nf = nil;
	rhdr.nwqid = 0;
	if(thdr.newfid != thdr.fid){
		err = clone(f, &amp;nf);
		if(err)
			return err;
		f = nf;	/* walk the new fid */
	}
	fram = f-&gt;ram;
	if(thdr.nwname &gt; 0){
		t = time(0);
		for(i=0; i&lt;thdr.nwname &amp;&amp; i&lt;MAXWELEM; i++){
			if((fram-&gt;qid.type &amp; QTDIR) == 0){
				err = Enotdir;
 				break;
			}
			if(fram-&gt;busy == 0){
				err = Enotexist;
				break;
			}
			fram-&gt;atime = t;
			name = thdr.wname[i];
			if(strcmp(name, ".") == 0){
    Found:
				rhdr.nwqid++;
				rhdr.wqid[i] = fram-&gt;qid;
				continue;
			}
			parent = &amp;ram[fram-&gt;parent];
			if(!perm(f, parent, Pexec)){
				err = Eperm;
				break;
			}
			if(strcmp(name, "..") == 0){
				fram = parent;
				goto Found;
			}
			for(r=ram; r &lt; &amp;ram[nram]; r++)
				if(r-&gt;busy &amp;&amp; r-&gt;parent==fram-ram &amp;&amp; strcmp(name, r-&gt;name)==0){
					fram = r;
					goto Found;
				}
			break;
		}
		if(i==0 &amp;&amp; err == nil)
			err = Enotexist;
	}
	if(nf != nil &amp;&amp; (err!=nil || rhdr.nwqid&lt;thdr.nwname)){
		/* clunk the new fid, which is the one we walked */
		f-&gt;busy = 0;
		f-&gt;ram = nil;
	}
	if(rhdr.nwqid &gt; 0)
		err = nil;	/* didn't get everything in 9P2000 right! */
	if(rhdr.nwqid == thdr.nwname)	/* update the fid after a successful walk */
		f-&gt;ram = fram;
	return err;
}

char *
ropen(Fid *f)
{
	Ram *r;
	int mode, trunc;

	if(f-&gt;open)
		return Eisopen;
	r = f-&gt;ram;
	if(r-&gt;busy == 0)
		return Enotexist;
	if(r-&gt;perm &amp; DMEXCL)
		if(r-&gt;open)
			return Excl;
	mode = thdr.mode;
	if(r-&gt;qid.type &amp; QTDIR){
		if(mode != OREAD)
			return Eperm;
		rhdr.qid = r-&gt;qid;
		return 0;
	}
	if(mode &amp; ORCLOSE){
		/* can't remove root; must be able to write parent */
		if(r-&gt;qid.path==0 || !perm(f, &amp;ram[r-&gt;parent], Pwrite))
			return Eperm;
		f-&gt;rclose = 1;
	}
	trunc = mode &amp; OTRUNC;
	mode &amp;= OPERM;
	if(mode==OWRITE || mode==ORDWR || trunc)
		if(!perm(f, r, Pwrite))
			return Eperm;
	if(mode==OREAD || mode==ORDWR)
		if(!perm(f, r, Pread))
			return Eperm;
	if(mode==OEXEC)
		if(!perm(f, r, Pexec))
			return Eperm;
	if(trunc &amp;&amp; (r-&gt;perm&amp;DMAPPEND)==0){
		r-&gt;ndata = 0;
		if(r-&gt;data)
			free(r-&gt;data);
		r-&gt;data = 0;
		r-&gt;qid.vers++;
	}
	rhdr.qid = r-&gt;qid;
	rhdr.iounit = messagesize-IOHDRSZ;
	f-&gt;open = 1;
	r-&gt;open++;
	return 0;
}

char *
rcreate(Fid *f)
{
	Ram *r;
	char *name;
	long parent, prm;

	if(f-&gt;open)
		return Eisopen;
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	parent = f-&gt;ram - ram;
	if((f-&gt;ram-&gt;qid.type&amp;QTDIR) == 0)
		return Enotdir;
	/* must be able to write parent */
	if(!perm(f, f-&gt;ram, Pwrite))
		return Eperm;
	prm = thdr.perm;
	name = thdr.name;
	if(strcmp(name, ".")==0 || strcmp(name, "..")==0)
		return Ename;
	for(r=ram; r&lt;&amp;ram[nram]; r++)
		if(r-&gt;busy &amp;&amp; parent==r-&gt;parent)
		if(strcmp((char*)name, r-&gt;name)==0)
			return Einuse;
	for(r=ram; r-&gt;busy; r++)
		if(r == &amp;ram[Nram-1])
			return "no free ram resources";
	r-&gt;busy = 1;
	r-&gt;qid.path = ++path;
	r-&gt;qid.vers = 0;
	if(prm &amp; DMDIR)
		r-&gt;qid.type |= QTDIR;
	r-&gt;parent = parent;
	free(r-&gt;name);
	r-&gt;name = estrdup(name);
	r-&gt;user = f-&gt;user;
	r-&gt;group = f-&gt;ram-&gt;group;
	r-&gt;muid = f-&gt;ram-&gt;muid;
	if(prm &amp; DMDIR)
		prm = (prm&amp;~0777) | (f-&gt;ram-&gt;perm&amp;prm&amp;0777);
	else
		prm = (prm&amp;(~0777|0111)) | (f-&gt;ram-&gt;perm&amp;prm&amp;0666);
	r-&gt;perm = prm;
	r-&gt;ndata = 0;
	if(r-ram &gt;= nram)
		nram = r - ram + 1;
	r-&gt;atime = time(0);
	r-&gt;mtime = r-&gt;atime;
	f-&gt;ram-&gt;mtime = r-&gt;atime;
	f-&gt;ram = r;
	rhdr.qid = r-&gt;qid;
	rhdr.iounit = messagesize-IOHDRSZ;
	f-&gt;open = 1;
	if(thdr.mode &amp; ORCLOSE)
		f-&gt;rclose = 1;
	r-&gt;open++;
	return 0;
}

char*
rread(Fid *f)
{
	Ram *r;
	uchar *buf;
	vlong off;
	int n, m, cnt;

	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	n = 0;
	rhdr.count = 0;
	rhdr.data = (char*)rdata;
	if (thdr.offset &lt; 0)
		return "negative seek offset";
	off = thdr.offset;
	buf = rdata;
	cnt = thdr.count;
	if(cnt &gt; messagesize)	/* shouldn't happen, anyway */
		cnt = messagesize;
	if(cnt &lt; 0)
		return "negative read count";
	if(f-&gt;ram-&gt;qid.type &amp; QTDIR){
		for(r=ram+1; off &gt; 0; r++){
			if(r-&gt;busy &amp;&amp; r-&gt;parent==f-&gt;ram-ram)
				off -= ramstat(r, statbuf, sizeof statbuf);
			if(r == &amp;ram[nram-1])
				return 0;
		}
		for(; r&lt;&amp;ram[nram] &amp;&amp; n &lt; cnt; r++){
			if(!r-&gt;busy || r-&gt;parent!=f-&gt;ram-ram)
				continue;
			m = ramstat(r, buf+n, cnt-n);
			if(m == 0)
				break;
			n += m;
		}
		rhdr.data = (char*)rdata;
		rhdr.count = n;
		return 0;
	}
	r = f-&gt;ram;
	if(off &gt;= r-&gt;ndata)
		return 0;
	r-&gt;atime = time(0);
	n = cnt;
	if(off+n &gt; r-&gt;ndata)
		n = r-&gt;ndata - off;
	rhdr.data = r-&gt;data+off;
	rhdr.count = n;
	return 0;
}

char*
rwrite(Fid *f)
{
	Ram *r;
	vlong off;
	int cnt;

	r = f-&gt;ram;
	rhdr.count = 0;
	if(r-&gt;busy == 0)
		return Enotexist;
	if (thdr.offset &lt; 0)
		return "negative seek offset";
	off = thdr.offset;
	if(r-&gt;perm &amp; DMAPPEND)
		off = r-&gt;ndata;
	cnt = thdr.count;
	if(cnt &lt; 0)
		return "negative write count";
	if(r-&gt;qid.type &amp; QTDIR)
		return Eisdir;
	if(memlim &amp;&amp; off+cnt &gt;= Maxsize)		/* sanity check */
		return "write too big";
	if(off+cnt &gt; r-&gt;ndata)
		r-&gt;data = erealloc(r-&gt;data, off+cnt);
	if(off &gt; r-&gt;ndata)
		memset(r-&gt;data+r-&gt;ndata, 0, off-r-&gt;ndata);
	if(off+cnt &gt; r-&gt;ndata)
		r-&gt;ndata = off+cnt;
	memmove(r-&gt;data+off, thdr.data, cnt);
	r-&gt;qid.vers++;
	r-&gt;mtime = time(0);
	rhdr.count = cnt;
	return 0;
}

static int
emptydir(Ram *dr)
{
	long didx = dr - ram;
	Ram *r;

	for(r=ram; r&lt;&amp;ram[nram]; r++)
		if(r-&gt;busy &amp;&amp; didx==r-&gt;parent)
			return 0;
	return 1;
}

char *
realremove(Ram *r)
{
	if(r-&gt;qid.type &amp; QTDIR &amp;&amp; !emptydir(r))
		return Enotempty;
	r-&gt;ndata = 0;
	if(r-&gt;data)
		free(r-&gt;data);
	r-&gt;data = 0;
	r-&gt;parent = 0;
	memset(&amp;r-&gt;qid, 0, sizeof r-&gt;qid);
	free(r-&gt;name);
	r-&gt;name = nil;
	r-&gt;busy = 0;
	return nil;
}

char *
rclunk(Fid *f)
{
	char *e = nil;

	if(f-&gt;open)
		f-&gt;ram-&gt;open--;
	if(f-&gt;rclose)
		e = realremove(f-&gt;ram);
	f-&gt;busy = 0;
	f-&gt;open = 0;
	f-&gt;ram = 0;
	return e;
}

char *
rremove(Fid *f)
{
	Ram *r;

	if(f-&gt;open)
		f-&gt;ram-&gt;open--;
	f-&gt;busy = 0;
	f-&gt;open = 0;
	r = f-&gt;ram;
	f-&gt;ram = 0;
	if(r-&gt;qid.path == 0 || !perm(f, &amp;ram[r-&gt;parent], Pwrite))
		return Eperm;
	ram[r-&gt;parent].mtime = time(0);
	return realremove(r);
}

char *
rstat(Fid *f)
{
	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	rhdr.nstat = ramstat(f-&gt;ram, statbuf, sizeof statbuf);
	rhdr.stat = statbuf;
	return 0;
}

char *
rwstat(Fid *f)
{
	Ram *r, *s;
	Dir dir;

	if(f-&gt;ram-&gt;busy == 0)
		return Enotexist;
	convM2D(thdr.stat, thdr.nstat, &amp;dir, (char*)statbuf);
	r = f-&gt;ram;

	/*
	 * To change length, must have write permission on file.
	 */
	if(dir.length!=~0 &amp;&amp; dir.length!=r-&gt;ndata){
	 	if(!perm(f, r, Pwrite))
			return Eperm;
	}

	/*
	 * To change name, must have write permission in parent
	 * and name must be unique.
	 */
	if(dir.name[0]!='\0' &amp;&amp; strcmp(dir.name, r-&gt;name)!=0){
	 	if(!perm(f, &amp;ram[r-&gt;parent], Pwrite))
			return Eperm;
		for(s=ram; s&lt;&amp;ram[nram]; s++)
			if(s-&gt;busy &amp;&amp; s-&gt;parent==r-&gt;parent)
			if(strcmp(dir.name, s-&gt;name)==0)
				return Eexist;
	}

	/*
	 * To change mode, must be owner or group leader.
	 * Because of lack of users file, leader=&gt;group itself.
	 */
	if(dir.mode!=~0 &amp;&amp; r-&gt;perm!=dir.mode){
		if(strcmp(f-&gt;user, r-&gt;user) != 0)
		if(strcmp(f-&gt;user, r-&gt;group) != 0)
			return Enotowner;
	}

	/*
	 * To change group, must be owner and member of new group,
	 * or leader of current group and leader of new group.
	 * Second case cannot happen, but we check anyway.
	 */
	if(dir.gid[0]!='\0' &amp;&amp; strcmp(r-&gt;group, dir.gid)!=0){
		if(strcmp(f-&gt;user, r-&gt;user) == 0)
	//	if(strcmp(f-&gt;user, dir.gid) == 0)
			goto ok;
		if(strcmp(f-&gt;user, r-&gt;group) == 0)
		if(strcmp(f-&gt;user, dir.gid) == 0)
			goto ok;
		return Enotowner;
		ok:;
	}

	/* all ok; do it */
	if(dir.mode != ~0){
		dir.mode &amp;= ~DMDIR;	/* cannot change dir bit */
		dir.mode |= r-&gt;perm&amp;DMDIR;
		r-&gt;perm = dir.mode;
	}
	if(dir.name[0] != '\0'){
		free(r-&gt;name);
		r-&gt;name = estrdup(dir.name);
	}
	if(dir.gid[0] != '\0')
		r-&gt;group = estrdup(dir.gid);
	if(dir.length!=~0 &amp;&amp; dir.length!=r-&gt;ndata){
		r-&gt;data = erealloc(r-&gt;data, dir.length);
		if(r-&gt;ndata &lt; dir.length)
			memset(r-&gt;data+r-&gt;ndata, 0, dir.length-r-&gt;ndata);
		r-&gt;ndata = dir.length;
	}
	ram[r-&gt;parent].mtime = time(0);
	return 0;
}

uint
ramstat(Ram *r, uchar *buf, uint nbuf)
{
	int n;
	Dir dir;

	dir.name = r-&gt;name;
	dir.qid = r-&gt;qid;
	dir.mode = r-&gt;perm;
	dir.length = r-&gt;ndata;
	dir.uid = r-&gt;user;
	dir.gid = r-&gt;group;
	dir.muid = r-&gt;muid;
	dir.atime = r-&gt;atime;
	dir.mtime = r-&gt;mtime;
	n = convD2M(&amp;dir, buf, nbuf);
	if(n &gt; 2)
		return n;
	return 0;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;ram = nil;
	f-&gt;fid = fid;
	f-&gt;next = fids;
	fids = f;
	return f;
}

void
io(void)
{
	char *err, buf[40];
	int n, pid, ctl;
	Fid *fid;

	pid = getpid();
	if(private){
		snprint(buf, sizeof buf, "/proc/%d/ctl", pid);
		ctl = open(buf, OWRITE);
		if(ctl &lt; 0){
			fprint(2, "can't protect ramfs\n");
		}else{
			fprint(ctl, "noswap\n");
			fprint(ctl, "private\n");
			close(ctl);
		}
	}

	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads.
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error.
		 */
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n &lt; 0){
			rerrstr(buf, sizeof buf);
			if(buf[0]=='\0' || strstr(buf, "hungup"))
				exits("");
			error("mount read");
		}
		if(n == 0)
			continue;
		if(convM2S(mdata, n, &amp;thdr) == 0)
			continue;

		if(debug)
			fprint(2, "ramfs %d:&lt;-%F\n", pid, &amp;thdr);

		if(thdr.type&lt;0 || thdr.type&gt;=nelem(fcalls) || !fcalls[thdr.type])
			err = "bad fcall type";
		else if(((fid=newfid(thdr.fid))==nil || !fid-&gt;ram) &amp;&amp; needfid[thdr.type])
			err = "fid not in use";
		else
			err = (*fcalls[thdr.type])(fid);
		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug)
			fprint(2, "ramfs %d:-&gt;%F\n", pid, &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(n == 0)
			error("convS2M error on write");
		if(write(mfd[1], mdata, n) != n)
			error("mount write");
	}
}

int
perm(Fid *f, Ram *r, int p)
{
	if((p*Pother) &amp; r-&gt;perm)
		return 1;
	if(strcmp(f-&gt;user, r-&gt;group)==0 &amp;&amp; ((p*Pgroup) &amp; r-&gt;perm))
		return 1;
	if(strcmp(f-&gt;user, r-&gt;user)==0 &amp;&amp; ((p*Powner) &amp; r-&gt;perm))
		return 1;
	return 0;
}

void
error(char *s)
{
	fprint(2, "%s: %s: %r\n", argv0, s);
	exits(s);
}

void *
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(!p)
		error("out of memory");
	memset(p, 0, n);
	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(!p)
		error("out of memory");
	return p;
}

char *
estrdup(char *q)
{
	char *p;
	int n;

	n = strlen(q)+1;
	p = malloc(n);
	if(!p)
		error("out of memory");
	memmove(p, q, n);
	return p;
}

void
usage(void)
{
	fprint(2, "usage: %s [-Dipsu] [-m mountpoint] [-S srvname]\n", argv0);
	exits("usage");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

