<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ratfs/proto.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ratfs/proto.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "ratfs.h"

/*
 *	9P protocol interface
 */

enum {
	RELOAD = 0,		/* commands written to ctl file */
	RDEBUG,
	RNODEBUG,
	RNONE,
};

static void	rflush(Fcall*),		rnop(Fcall*),
		rauth(Fcall*),	rattach(Fcall*),
		rclone(Fcall*),		rwalk(Fcall*),
		rclwalk(Fcall*),	ropen(Fcall*),
		rcreate(Fcall*),	rread(Fcall*),
		rwrite(Fcall*),		rclunk(Fcall*),
		rremove(Fcall*),	rstat(Fcall*),
		rwstat(Fcall*),	rversion(Fcall*);

static	Fid*	newfid(int);
static	void	reply(Fcall*, char*);

static	void 	(*fcalls[])(Fcall*) = {
	[Tversion]	rversion,
	[Tflush]	rflush,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};


static	Keyword cmds[] = {
	"reload",		RELOAD,
	"debug",		RDEBUG,
	"nodebug",		RNODEBUG,
	0,			RNONE,
};

/*
 *	Main protocol loop
 */
void
io(void)
{
	Fcall	rhdr;
	int n;
	
	for(;;){
		n = read9pmsg(srvfd, rbuf, sizeof rbuf-1);
		if(n &lt;= 0)
			fatal("mount read");
		if(convM2S(rbuf, n, &amp;rhdr) == 0){
			if(debugfd &gt;= 0)
				fprint(2, "%s: malformed message\n", argv0);
			continue;
		}
		
		if(debugfd &gt;= 0)
			fprint(debugfd, "&lt;-%F\n", &amp;rhdr);/**/

		if(!fcalls[rhdr.type])
			reply(&amp;rhdr, "bad fcall type");
		else
			(*fcalls[rhdr.type])(&amp;rhdr);
	}
}

/*
 *	write a protocol reply to the client
 */
static void
reply(Fcall *r, char *error)
{
	int n;

	if(error == nil)
		r-&gt;type++;
	else {
		r-&gt;type = Rerror;
		r-&gt;ename = error;
	}
	if(debugfd &gt;= 0)
		fprint(debugfd, "-&gt;%F\n", r);/**/
	n = convS2M(r, rbuf, sizeof rbuf);
	if(n == 0)
		sysfatal("convS2M: %r");
	if(write(srvfd, rbuf, n) &lt; 0)
		sysfatal("reply: %r");
}


/*
 *  lookup a fid. if not found, create a new one.
 */

static Fid*
newfid(int fid)
{
	Fid *f, *ff;

	static Fid *fids;

	ff = 0;
	for(f = fids; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			if(!f-&gt;busy)
				f-&gt;node = 0;
			return f;
		} else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	}
	if(ff == 0){
		ff = mallocz(sizeof(*f), 1);
		ff-&gt;next = fids;
		fids = ff;
	}
	ff-&gt;node = 0;
	ff-&gt;fid = fid;
	return ff;
}

static void
rversion(Fcall *f)
{
	f-&gt;version = "9P2000";
	if(f-&gt;msize &gt; MAXRPC)
		f-&gt;msize = MAXRPC;
	reply(f, 0);
}

static void
rauth(Fcall *f)
{
	reply(f, "ratfs: authentication not required");
}

static void
rflush(Fcall *f)
{
	reply(f, 0);
}

static void
rattach(Fcall *f)
{
	Fid *fidp;
	Dir *d;

	if((d=dirstat(conffile)) != nil &amp;&amp; d-&gt;mtime &gt; lastconftime)
		getconf();
	free(d);
	if((d=dirstat(ctlfile)) != nil &amp;&amp; d-&gt;mtime &gt; lastctltime)
		reload();
	free(d);
	cleantrusted();

	fidp = newfid(f-&gt;fid);
	fidp-&gt;busy = 1;
	fidp-&gt;node = root;
	fidp-&gt;name = root-&gt;d.name;
	fidp-&gt;uid = atom(f-&gt;uname);
	f-&gt;qid = root-&gt;d.qid;
	reply(f,0);
}

static void
rclone(Fcall *f)
{
	Fid *fidp, *nf;

	fidp = newfid(f-&gt;fid);
	if(fidp-&gt;node &amp;&amp; fidp-&gt;node-&gt;d.type == Dummynode){
		reply(f, "can't clone an address");
		return;
	}
	nf = newfid(f-&gt;newfid);
	nf-&gt;busy = 1;
	nf-&gt;node = fidp-&gt;node;
	nf-&gt;uid = fidp-&gt;uid;
	nf-&gt;name = fidp-&gt;name;
	if(debugfd &gt;= 0)
		printfid(nf);
	reply(f,0);
}

static void
rwalk(Fcall *f)
{
	int i, j;
	Fcall r;
	Fid *fidp, *nf;
	char *err;

	fidp = newfid(f-&gt;fid);
	if(fidp-&gt;node &amp;&amp; fidp-&gt;node-&gt;d.type == Dummynode){
		reply(f, "can't walk an address node");
		return;
	}
	if(f-&gt;fid == f-&gt;newfid)
		nf = fidp;
	else{
		nf = newfid(f-&gt;newfid);
		nf-&gt;busy = 1;
		nf-&gt;node = fidp-&gt;node;
		nf-&gt;uid = fidp-&gt;uid;
		nf-&gt;name = fidp-&gt;name;
		if(debugfd &gt;= 0)
			printfid(nf);
	}

	err = nil;
	for(i=0; i&lt;f-&gt;nwname; i++){
		err = walk(f-&gt;wname[i], nf);
		if(err)
			break;
		r.wqid[i] = nf-&gt;node-&gt;d.qid;
	}
	

	if(i &lt; f-&gt;nwname &amp;&amp; f-&gt;fid != f-&gt;newfid){
		nf-&gt;busy = 0;
		nf-&gt;node = 0;
		nf-&gt;name = 0;
		nf-&gt;uid = 0;
	}
	if(i &gt; 0 &amp;&amp; i &lt; f-&gt;nwname &amp;&amp; f-&gt;fid == f-&gt;newfid){
		/*
		 * try to put things back;
		 * we never get this sort of call from the kernel
		 */
		for(j=0; j&lt;i; j++)
			walk("..", nf);
	}
	memmove(f-&gt;wqid, r.wqid, sizeof f-&gt;wqid);
	f-&gt;nwqid = i;
	if(err &amp;&amp; i==0)
		reply(f, err);
	else
		reply(f, 0);
}

/*
 *	We don't have to do full permission checking because most files
 *	have restricted semantics:
 *		The ctl file is only writable
 *		All others, including directories, are only readable
 */
static void
ropen(Fcall *f)
{
	Fid *fidp;
	int mode;

	fidp = newfid(f-&gt;fid);

	if(debugfd &gt;= 0)
		printfid(fidp);

	mode = f-&gt;mode&amp;(OREAD|OWRITE|ORDWR);
	if(fidp-&gt;node-&gt;d.type == Ctlfile) {
		if(mode != OWRITE) {	
			reply(f, "permission denied");
			return;
		}
	} else
	if (mode != OREAD) {
		reply(f, "permission denied or operation not supported");
		return;
	}

	f-&gt;qid = fidp-&gt;node-&gt;d.qid;
	fidp-&gt;open = 1;
	reply(f, 0);
}

static int
permitted(Fid *fp, Node *np, int mask)
{
	int mode;

	mode = np-&gt;d.mode;
	return (fp-&gt;uid==np-&gt;d.uid &amp;&amp; (mode&amp;(mask&lt;&lt;6)))
		|| (fp-&gt;uid==np-&gt;d.gid &amp;&amp; (mode&amp;(mask&lt;&lt;3)))
		|| (mode&amp;mask);
}

/*
 *	creates are only allowed in the "trusted" subdirectory
 *	we also assume that the groupid == the uid
 */
static void
rcreate(Fcall *f)
{
	Fid *fidp;
	Node *np;

	fidp = newfid(f-&gt;fid);
	np = fidp-&gt;node;
	if((np-&gt;d.mode&amp;DMDIR) == 0){
		reply(f, "not a directory");
		return;
	}

	if(!permitted(fidp, np, AWRITE)) {
		reply(f, "permission denied");
		return;
	}

	/* Ignore the supplied mode and force it to be non-writable */

	np = newnode(np, f-&gt;name, Trustedtemp, 0444, trustedqid++);
	if(trustedqid &gt;= Qaddrfile)			/* wrap QIDs */
		trustedqid = Qtrustedfile;
	cidrparse(&amp;np-&gt;ip, f-&gt;name);
	f-&gt;qid = np-&gt;d.qid;
	np-&gt;d.uid = fidp-&gt;uid;
	np-&gt;d.gid = np-&gt;d.uid;
	np-&gt;d.muid = np-&gt;d.muid;
	fidp-&gt;node = np;
	fidp-&gt;open = 1;
	reply(f, 0);
	return;
}

/*
 *	only directories can be read.  everthing else returns EOF.
 */
static void
rread(Fcall *f)
{
	long cnt;
	Fid *fidp;

	cnt = f-&gt;count;
	f-&gt;count = 0;
	fidp = newfid(f-&gt;fid);
	f-&gt;data = (char*)rbuf+IOHDRSZ;
	if(fidp-&gt;open == 0) {
		reply(f, "file not open");
		return;
	}
	if ((fidp-&gt;node-&gt;d.mode&amp;DMDIR) == 0){
		reply(f, 0);				/*EOF*/
		return;
	}
	if(cnt &gt; MAXRPC)
		cnt = MAXRPC;

	if(f-&gt;offset == 0)
		fidp-&gt;dirindex = 0;

	switch(fidp-&gt;node-&gt;d.type) {
	case Directory:
	case Addrdir:
	case Trusted:
		f-&gt;count = dread(fidp, cnt);
		break;
	case IPaddr:
	case Acctaddr:
		f-&gt;count = hread(fidp, cnt);
		break;
	default:
		reply(f, "can't read this type of file");
		return;
	}
	reply(f, 0);
}


/*
 * 	only the 'ctl' file in the top level directory is writable
 */

static void
rwrite(Fcall *f)
{
	Fid *fidp;
	int n;
	char *err, *argv[10];

	fidp = newfid(f-&gt;fid);
	if(fidp-&gt;node-&gt;d.mode &amp; DMDIR){
		reply(f, "directories are not writable");
		return;
	}
	if(fidp-&gt;open == 0) {
		reply(f, "file not open");
		return;
	}

	if (!permitted(fidp, fidp-&gt;node, AWRITE)) {
		reply(f, "permission denied");
		return;
	}

	f-&gt;data[f-&gt;count] = 0;			/* the extra byte in rbuf leaves room */
	n = tokenize(f-&gt;data, argv, 10);
	err = 0;
	switch(findkey(argv[0], cmds)){
	case RELOAD:
		getconf();
		reload();
		break;
	case RDEBUG:
		if(n &gt; 1){
			debugfd = create(argv[1], OWRITE, 0666);
			if(debugfd &lt; 0)
				err = "create failed";
		} else
			debugfd = 2;
		break;
	case RNODEBUG:
		if(debugfd &gt;= 0)
			close(debugfd);
		debugfd = -1;
		break;
	default:
		err = "unknown command";
		break;
	}
	reply(f, err);
}

static void
rclunk(Fcall *f)
{
	Fid *fidp;

	fidp = newfid(f-&gt;fid);
	fidp-&gt;open = 0;
	fidp-&gt;busy = 0;
	fidp-&gt;node = 0;
	fidp-&gt;name = 0;
	fidp-&gt;uid = 0;
	reply(f, 0);
}

/*
 *  no files or directories are removable; this becomes clunk;
 */
static void
rremove(Fcall *f)
{
	Fid *fidp;
	Node *dir, *np;

	fidp = newfid(f-&gt;fid);
	
	/*
	 * only trusted temporary files can be removed
	 * and only by their owner.
	 */
	if(fidp-&gt;node-&gt;d.type != Trustedtemp){
		reply(f, "can't be removed");
		return;
	}
	if(fidp-&gt;uid != fidp-&gt;node-&gt;d.uid){
		reply(f, "permission denied");
		return;
	}
	dir = fidp-&gt;node-&gt;parent;
	for(np = dir-&gt;children; np; np = np-&gt;sibs)
		if(np-&gt;sibs == fidp-&gt;node)
			break;
	if(np)
		np-&gt;sibs = fidp-&gt;node-&gt;sibs;
	else
		dir-&gt;children = fidp-&gt;node-&gt;sibs;
	dir-&gt;count--;
	free(fidp-&gt;node);
	fidp-&gt;node = 0;
	fidp-&gt;open = 0;
	fidp-&gt;busy = 0;
	fidp-&gt;name = 0;
	fidp-&gt;uid = 0;
	reply(f, 0);
}

static void
rstat(Fcall *f)
{
	Fid *fidp;

	fidp = newfid(f-&gt;fid);
	if (fidp-&gt;node-&gt;d.type == Dummynode)
		dummy.d.name = fidp-&gt;name;
	f-&gt;stat = (uchar*)rbuf+4+1+2+2;	/* knows about stat(5) */
	f-&gt;nstat = convD2M(&amp;fidp-&gt;node-&gt;d, f-&gt;stat, MAXRPC);
	if(f-&gt;nstat &lt;= BIT16SZ)
		reply(f, "ratfs: convD2M");
	else
		reply(f, 0);
	return;
}

static void
rwstat(Fcall *f)
{
	reply(f, "wstat not implemented");
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

