<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rc/exec.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rc/exec.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "rc.h"
#include "getflags.h"
#include "exec.h"
#include "io.h"
#include "fns.h"
/*
 * Start executing the given code at the given pc with the given redirection
 */
char *argv0="rc";

void
start(code *c, int pc, var *local)
{
	struct thread *p = new(struct thread);

	p-&gt;code = codecopy(c);
	p-&gt;pc = pc;
	p-&gt;argv = 0;
	p-&gt;redir = p-&gt;startredir = runq?runq-&gt;redir:0;
	p-&gt;local = local;
	p-&gt;cmdfile = 0;
	p-&gt;cmdfd = 0;
	p-&gt;eof = 0;
	p-&gt;iflag = 0;
	p-&gt;lineno = 1;
	p-&gt;ret = runq;
	runq = p;
}

word*
newword(char *wd, word *next)
{
	word *p = new(word);
	p-&gt;word = strdup(wd);
	p-&gt;next = next;
	return p;
}

void
pushword(char *wd)
{
	if(runq-&gt;argv==0)
		panic("pushword but no argv!", 0);
	runq-&gt;argv-&gt;words = newword(wd, runq-&gt;argv-&gt;words);
}

void
popword(void)
{
	word *p;
	if(runq-&gt;argv==0)
		panic("popword but no argv!", 0);
	p = runq-&gt;argv-&gt;words;
	if(p==0)
		panic("popword but no word!", 0);
	runq-&gt;argv-&gt;words = p-&gt;next;
	efree(p-&gt;word);
	efree((char *)p);
}

void
freelist(word *w)
{
	word *nw;
	while(w){
		nw = w-&gt;next;
		efree(w-&gt;word);
		efree((char *)w);
		w = nw;
	}
}

void
pushlist(void)
{
	list *p = new(list);
	p-&gt;next = runq-&gt;argv;
	p-&gt;words = 0;
	runq-&gt;argv = p;
}

void
poplist(void)
{
	list *p = runq-&gt;argv;
	if(p==0)
		panic("poplist but no argv", 0);
	freelist(p-&gt;words);
	runq-&gt;argv = p-&gt;next;
	efree((char *)p);
}

int
count(word *w)
{
	int n;
	for(n = 0;w;n++) w = w-&gt;next;
	return n;
}

void
pushredir(int type, int from, int to)
{
	redir * rp = new(redir);
	rp-&gt;type = type;
	rp-&gt;from = from;
	rp-&gt;to = to;
	rp-&gt;next = runq-&gt;redir;
	runq-&gt;redir = rp;
}

var*
newvar(char *name, var *next)
{
	var *v = new(var);
	v-&gt;name = name;
	v-&gt;val = 0;
	v-&gt;fn = 0;
	v-&gt;changed = 0;
	v-&gt;fnchanged = 0;
	v-&gt;next = next;
	return v;
}
/*
 * get command line flags, initialize keywords &amp; traps.
 * get values from environment.
 * set $pid, $cflag, $*
 * fabricate bootstrap code and start it (*=(argv);. /usr/lib/rcmain $*)
 * start interpreting code
 */

void
main(int argc, char *argv[])
{
	code bootstrap[17];
	char num[12], *rcmain;
	int i;
	argc = getflags(argc, argv, "SsrdiIlxepvVc:1m:1[command]", 1);
	if(argc==-1)
		usage("[file [arg ...]]");
	if(argv[0][0]=='-')
		flag['l'] = flagset;
	if(flag['I'])
		flag['i'] = 0;
	else if(flag['i']==0 &amp;&amp; argc==1 &amp;&amp; Isatty(0)) flag['i'] = flagset;
	rcmain = flag['m']?flag['m'][0]:Rcmain; 
	err = openfd(2);
	kinit();
	Trapinit();
	Vinit();
	inttoascii(num, mypid = getpid());
	setvar("pid", newword(num, (word *)0));
	setvar("cflag", flag['c']?newword(flag['c'][0], (word *)0)
				:(word *)0);
	setvar("rcname", newword(argv[0], (word *)0));
	i = 0;
	memset(bootstrap, 0, sizeof bootstrap);
	bootstrap[i++].i = 1;
	bootstrap[i++].f = Xmark;
	bootstrap[i++].f = Xword;
	bootstrap[i++].s="*";
	bootstrap[i++].f = Xassign;
	bootstrap[i++].f = Xmark;
	bootstrap[i++].f = Xmark;
	bootstrap[i++].f = Xword;
	bootstrap[i++].s="*";
	bootstrap[i++].f = Xdol;
	bootstrap[i++].f = Xword;
	bootstrap[i++].s = rcmain;
	bootstrap[i++].f = Xword;
	bootstrap[i++].s=".";
	bootstrap[i++].f = Xsimple;
	bootstrap[i++].f = Xexit;
	bootstrap[i].i = 0;
	start(bootstrap, 1, (var *)0);
	/* prime bootstrap argv */
	pushlist();
	argv0 = strdup(argv[0]);
	for(i = argc-1;i!=0;--i) pushword(argv[i]);
	for(;;){
		if(flag['r'])
			pfnc(err, runq);
		runq-&gt;pc++;
		(*runq-&gt;code[runq-&gt;pc-1].f)();
		if(ntrap)
			dotrap();
	}
}
/*
 * Opcode routines
 * Arguments on stack (...)
 * Arguments in line [...]
 * Code in line with jump around {...}
 *
 * Xappend(file)[fd]			open file to append
 * Xassign(name, val)			assign val to name
 * Xasync{... Xexit}			make thread for {}, no wait
 * Xbackq{... Xreturn}			make thread for {}, push stdout
 * Xbang				complement condition
 * Xcase(pat, value){...}		exec code on match, leave (value) on
 * 					stack
 * Xclose[i]				close file descriptor
 * Xconc(left, right)			concatenate, push results
 * Xcount(name)				push var count
 * Xdelfn(name)				delete function definition
 * Xdelhere
 * Xdol(name)				get variable value
 * Xdup[i j]				dup file descriptor
 * Xeflag
 * Xerror
 * Xexit				rc exits with status
 * Xfalse{...}				execute {} if false
 * Xfn(name){... Xreturn}			define function
 * Xfor(var, list){... Xreturn}		for loop
 * Xglob
 * Xif
 * Xifnot
 * Xjump[addr]				goto
 * Xlocal(name, val)			create local variable, assign value
 * Xmark				mark stack
 * Xmatch(pat, str)			match pattern, set status
 * Xpipe[i j]{... Xreturn}{... Xreturn}	construct a pipe between 2 new threads,
 * 					wait for both
 * Xpipefd[type]{... Xreturn}		connect {} to pipe (input or output,
 * 					depending on type), push /dev/fd/??
 * Xpipewait
 * Xpopm(value)				pop value from stack
 * Xpopredir
 * Xrdcmds
 * Xrdfn
 * Xrdwr(file)[fd]			open file for reading and writing
 * Xread(file)[fd]			open file to read
 * Xqdol(name)				concatenate variable components
 * Xreturn				kill thread
 * Xsimple(args)			run command and wait
 * Xsub
 * Xsubshell{... Xexit}			execute {} in a subshell and wait
 * Xtrue{...}				execute {} if true
 * Xunlocal				delete local variable
 * Xwastrue
 * Xword[string]			push string
 * Xwrite(file)[fd]			open file to write
 */

void
Xappend(void)
{
	char *file;
	int f;
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		Xerror1("&gt;&gt; requires singleton");
		return;
	case 0:
		Xerror1("&gt;&gt; requires file");
		return;
	case 1:
		break;
	}
	file = runq-&gt;argv-&gt;words-&gt;word;
	if((f = open(file, 1))&lt;0 &amp;&amp; (f = Creat(file))&lt;0){
		pfmt(err, "%s: ", file);
		Xerror("can't open");
		return;
	}
	Seek(f, 0L, 2);
	pushredir(ROPEN, f, runq-&gt;code[runq-&gt;pc].i);
	runq-&gt;pc++;
	poplist();
}

void
Xsettrue(void)
{
	setstatus("");
}

void
Xbang(void)
{
	setstatus(truestatus()?"false":"");
}

void
Xclose(void)
{
	pushredir(RCLOSE, runq-&gt;code[runq-&gt;pc].i, 0);
	runq-&gt;pc++;
}

void
Xdup(void)
{
	pushredir(RDUP, runq-&gt;code[runq-&gt;pc].i, runq-&gt;code[runq-&gt;pc+1].i);
	runq-&gt;pc+=2;
}

void
Xeflag(void)
{
	if(eflagok &amp;&amp; !truestatus()) Xexit();
}

void
Xexit(void)
{
	struct var *trapreq;
	struct word *starval;
	static int beenhere = 0;
	if(getpid()==mypid &amp;&amp; !beenhere){
		trapreq = vlook("sigexit");
		if(trapreq-&gt;fn){
			beenhere = 1;
			--runq-&gt;pc;
			starval = vlook("*")-&gt;val;
			start(trapreq-&gt;fn, trapreq-&gt;pc, (struct var *)0);
			runq-&gt;local = newvar(strdup("*"), runq-&gt;local);
			runq-&gt;local-&gt;val = copywords(starval, (struct word *)0);
			runq-&gt;local-&gt;changed = 1;
			runq-&gt;redir = runq-&gt;startredir = 0;
			return;
		}
	}
	Exit(getstatus());
}

void
Xfalse(void)
{
	if(truestatus()) runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
	else runq-&gt;pc++;
}
int ifnot;		/* dynamic if not flag */

void
Xifnot(void)
{
	if(ifnot)
		runq-&gt;pc++;
	else
		runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
}

void
Xjump(void)
{
	runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
}

void
Xmark(void)
{
	pushlist();
}

void
Xpopm(void)
{
	poplist();
}

void
Xread(void)
{
	char *file;
	int f;
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		Xerror1("&lt; requires singleton\n");
		return;
	case 0:
		Xerror1("&lt; requires file\n");
		return;
	case 1:
		break;
	}
	file = runq-&gt;argv-&gt;words-&gt;word;
	if((f = open(file, 0))&lt;0){
		pfmt(err, "%s: ", file);
		Xerror("can't open");
		return;
	}
	pushredir(ROPEN, f, runq-&gt;code[runq-&gt;pc].i);
	runq-&gt;pc++;
	poplist();
}

void
Xrdwr(void)
{
	char *file;
	int f;

	switch(count(runq-&gt;argv-&gt;words)){
	default:
		Xerror1("&lt;&gt; requires singleton\n");
		return;
	case 0:
		Xerror1("&lt;&gt; requires file\n");
		return;
	case 1:
		break;
	}
	file = runq-&gt;argv-&gt;words-&gt;word;
	if((f = open(file, ORDWR))&lt;0){
		pfmt(err, "%s: ", file);
		Xerror("can't open");
		return;
	}
	pushredir(ROPEN, f, runq-&gt;code[runq-&gt;pc].i);
	runq-&gt;pc++;
	poplist();
}

void
turfredir(void)
{
	while(runq-&gt;redir!=runq-&gt;startredir)
		Xpopredir();
}

void
Xpopredir(void)
{
	struct redir *rp = runq-&gt;redir;
	if(rp==0)
		panic("turfredir null!", 0);
	runq-&gt;redir = rp-&gt;next;
	if(rp-&gt;type==ROPEN)
		close(rp-&gt;from);
	efree((char *)rp);
}

void
Xreturn(void)
{
	struct thread *p = runq;
	turfredir();
	while(p-&gt;argv) poplist();
	codefree(p-&gt;code);
	runq = p-&gt;ret;
	efree((char *)p);
	if(runq==0)
		Exit(getstatus());
}

void
Xtrue(void)
{
	if(truestatus()) runq-&gt;pc++;
	else runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
}

void
Xif(void)
{
	ifnot = 1;
	if(truestatus()) runq-&gt;pc++;
	else runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
}

void
Xwastrue(void)
{
	ifnot = 0;
}

void
Xword(void)
{
	pushword(runq-&gt;code[runq-&gt;pc++].s);
}

void
Xwrite(void)
{
	char *file;
	int f;
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		Xerror1("&gt; requires singleton\n");
		return;
	case 0:
		Xerror1("&gt; requires file\n");
		return;
	case 1:
		break;
	}
	file = runq-&gt;argv-&gt;words-&gt;word;
	if((f = Creat(file))&lt;0){
		pfmt(err, "%s: ", file);
		Xerror("can't open");
		return;
	}
	pushredir(ROPEN, f, runq-&gt;code[runq-&gt;pc].i);
	runq-&gt;pc++;
	poplist();
}

char*
list2str(word *words)
{
	char *value, *s, *t;
	int len = 0;
	word *ap;
	for(ap = words;ap;ap = ap-&gt;next)
		len+=1+strlen(ap-&gt;word);
	value = emalloc(len+1);
	s = value;
	for(ap = words;ap;ap = ap-&gt;next){
		for(t = ap-&gt;word;*t;) *s++=*t++;
		*s++=' ';
	}
	if(s==value)
		*s='\0';
	else s[-1]='\0';
	return value;
}

void
Xmatch(void)
{
	word *p;
	char *subject;
	subject = list2str(runq-&gt;argv-&gt;words);
	setstatus("no match");
	for(p = runq-&gt;argv-&gt;next-&gt;words;p;p = p-&gt;next)
		if(match(subject, p-&gt;word, '\0')){
			setstatus("");
			break;
		}
	efree(subject);
	poplist();
	poplist();
}

void
Xcase(void)
{
	word *p;
	char *s;
	int ok = 0;
	s = list2str(runq-&gt;argv-&gt;next-&gt;words);
	for(p = runq-&gt;argv-&gt;words;p;p = p-&gt;next){
		if(match(s, p-&gt;word, '\0')){
			ok = 1;
			break;
		}
	}
	efree(s);
	if(ok)
		runq-&gt;pc++;
	else
		runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
	poplist();
}

word*
conclist(word *lp, word *rp, word *tail)
{
	char *buf;
	word *v;
	if(lp-&gt;next || rp-&gt;next)
		tail = conclist(lp-&gt;next==0? lp: lp-&gt;next,
			rp-&gt;next==0? rp: rp-&gt;next, tail);
	buf = emalloc(strlen(lp-&gt;word)+strlen((char *)rp-&gt;word)+1);
	strcpy(buf, lp-&gt;word);
	strcat(buf, rp-&gt;word);
	v = newword(buf, tail);
	efree(buf);
	return v;
}

void
Xconc(void)
{
	word *lp = runq-&gt;argv-&gt;words;
	word *rp = runq-&gt;argv-&gt;next-&gt;words;
	word *vp = runq-&gt;argv-&gt;next-&gt;next-&gt;words;
	int lc = count(lp), rc = count(rp);
	if(lc!=0 || rc!=0){
		if(lc==0 || rc==0){
			Xerror1("null list in concatenation");
			return;
		}
		if(lc!=1 &amp;&amp; rc!=1 &amp;&amp; lc!=rc){
			Xerror1("mismatched list lengths in concatenation");
			return;
		}
		vp = conclist(lp, rp, vp);
	}
	poplist();
	poplist();
	runq-&gt;argv-&gt;words = vp;
}

void
Xassign(void)
{
	var *v;
	if(count(runq-&gt;argv-&gt;words)!=1){
		Xerror1("variable name not singleton!");
		return;
	}
	deglob(runq-&gt;argv-&gt;words-&gt;word);
	v = vlook(runq-&gt;argv-&gt;words-&gt;word);
	poplist();
	globlist();
	freewords(v-&gt;val);
	v-&gt;val = runq-&gt;argv-&gt;words;
	v-&gt;changed = 1;
	runq-&gt;argv-&gt;words = 0;
	poplist();
}
/*
 * copy arglist a, adding the copy to the front of tail
 */

word*
copywords(word *a, word *tail)
{
	word *v = 0, **end;
	for(end=&amp;v;a;a = a-&gt;next,end=&amp;(*end)-&gt;next)
		*end = newword(a-&gt;word, 0);
	*end = tail;
	return v;
}

void
Xdol(void)
{
	word *a, *star;
	char *s, *t;
	int n;
	if(count(runq-&gt;argv-&gt;words)!=1){
		Xerror1("variable name not singleton!");
		return;
	}
	s = runq-&gt;argv-&gt;words-&gt;word;
	deglob(s);
	n = 0;
	for(t = s;'0'&lt;=*t &amp;&amp; *t&lt;='9';t++) n = n*10+*t-'0';
	a = runq-&gt;argv-&gt;next-&gt;words;
	if(n==0 || *t)
		a = copywords(vlook(s)-&gt;val, a);
	else{
		star = vlook("*")-&gt;val;
		if(star &amp;&amp; 1&lt;=n &amp;&amp; n&lt;=count(star)){
			while(--n) star = star-&gt;next;
			a = newword(star-&gt;word, a);
		}
	}
	poplist();
	runq-&gt;argv-&gt;words = a;
}

void
Xqdol(void)
{
	word *a, *p;
	char *s;
	int n;
	if(count(runq-&gt;argv-&gt;words)!=1){
		Xerror1("variable name not singleton!");
		return;
	}
	s = runq-&gt;argv-&gt;words-&gt;word;
	deglob(s);
	a = vlook(s)-&gt;val;
	poplist();
	n = count(a);
	if(n==0){
		pushword("");
		return;
	}
	for(p = a;p;p = p-&gt;next) n+=strlen(p-&gt;word);
	s = emalloc(n);
	if(a){
		strcpy(s, a-&gt;word);
		for(p = a-&gt;next;p;p = p-&gt;next){
			strcat(s, " ");
			strcat(s, p-&gt;word);
		}
	}
	else
		s[0]='\0';
	pushword(s);
	efree(s);
}

word*
copynwords(word *a, word *tail, int n)
{
	word *v, **end;
	
	v = 0;
	end = &amp;v;
	while(n-- &gt; 0){
		*end = newword(a-&gt;word, 0);
		end = &amp;(*end)-&gt;next;
		a = a-&gt;next;
	}
	*end = tail;
	return v;
}

word*
subwords(word *val, int len, word *sub, word *a)
{
	int n, m;
	char *s;
	if(!sub)
		return a;
	a = subwords(val, len, sub-&gt;next, a);
	s = sub-&gt;word;
	deglob(s);
	m = 0;
	n = 0;
	while('0'&lt;=*s &amp;&amp; *s&lt;='9')
		n = n*10+ *s++ -'0';
	if(*s == '-'){
		if(*++s == 0)
			m = len - n;
		else{
			while('0'&lt;=*s &amp;&amp; *s&lt;='9')
				m = m*10+ *s++ -'0';
			m -= n;
		}
	}
	if(n&lt;1 || n&gt;len || m&lt;0)
		return a;
	if(n+m&gt;len)
		m = len-n;
	while(--n &gt; 0)
		val = val-&gt;next;
	return copynwords(val, a, m+1);
}

void
Xsub(void)
{
	word *a, *v;
	char *s;
	if(count(runq-&gt;argv-&gt;next-&gt;words)!=1){
		Xerror1("variable name not singleton!");
		return;
	}
	s = runq-&gt;argv-&gt;next-&gt;words-&gt;word;
	deglob(s);
	a = runq-&gt;argv-&gt;next-&gt;next-&gt;words;
	v = vlook(s)-&gt;val;
	a = subwords(v, count(v), runq-&gt;argv-&gt;words, a);
	poplist();
	poplist();
	runq-&gt;argv-&gt;words = a;
}

void
Xcount(void)
{
	word *a;
	char *s, *t;
	int n;
	char num[12];
	if(count(runq-&gt;argv-&gt;words)!=1){
		Xerror1("variable name not singleton!");
		return;
	}
	s = runq-&gt;argv-&gt;words-&gt;word;
	deglob(s);
	n = 0;
	for(t = s;'0'&lt;=*t &amp;&amp; *t&lt;='9';t++) n = n*10+*t-'0';
	if(n==0 || *t){
		a = vlook(s)-&gt;val;
		inttoascii(num, count(a));
	}
	else{
		a = vlook("*")-&gt;val;
		inttoascii(num, a &amp;&amp; 1&lt;=n &amp;&amp; n&lt;=count(a)?1:0);
	}
	poplist();
	pushword(num);
}

void
Xlocal(void)
{
	if(count(runq-&gt;argv-&gt;words)!=1){
		Xerror1("variable name must be singleton\n");
		return;
	}
	deglob(runq-&gt;argv-&gt;words-&gt;word);
	runq-&gt;local = newvar(strdup(runq-&gt;argv-&gt;words-&gt;word), runq-&gt;local);
	poplist();
	globlist();
	runq-&gt;local-&gt;val = runq-&gt;argv-&gt;words;
	runq-&gt;local-&gt;changed = 1;
	runq-&gt;argv-&gt;words = 0;
	poplist();
}

void
Xunlocal(void)
{
	var *v = runq-&gt;local, *hid;
	if(v==0)
		panic("Xunlocal: no locals!", 0);
	runq-&gt;local = v-&gt;next;
	hid = vlook(v-&gt;name);
	hid-&gt;changed = 1;
	efree(v-&gt;name);
	freewords(v-&gt;val);
	efree((char *)v);
}

void
freewords(word *w)
{
	word *nw;
	while(w){
		efree(w-&gt;word);
		nw = w-&gt;next;
		efree((char *)w);
		w = nw;
	}
}

void
Xfn(void)
{
	var *v;
	word *a;
	int end;
	end = runq-&gt;code[runq-&gt;pc].i;
	globlist();
	for(a = runq-&gt;argv-&gt;words;a;a = a-&gt;next){
		v = gvlook(a-&gt;word);
		if(v-&gt;fn)
			codefree(v-&gt;fn);
		v-&gt;fn = codecopy(runq-&gt;code);
		v-&gt;pc = runq-&gt;pc+2;
		v-&gt;fnchanged = 1;
	}
	runq-&gt;pc = end;
	poplist();
}

void
Xdelfn(void)
{
	var *v;
	word *a;
	for(a = runq-&gt;argv-&gt;words;a;a = a-&gt;next){
		v = gvlook(a-&gt;word);
		if(v-&gt;fn)
			codefree(v-&gt;fn);
		v-&gt;fn = 0;
		v-&gt;fnchanged = 1;
	}
	poplist();
}

char*
concstatus(char *s, char *t)
{
	static char v[NSTATUS+1];
	int n = strlen(s);
	strncpy(v, s, NSTATUS);
	if(n&lt;NSTATUS){
		v[n]='|';
		strncpy(v+n+1, t, NSTATUS-n-1);
	}
	v[NSTATUS]='\0';
	return v;
}

void
Xpipewait(void)
{
	char status[NSTATUS+1];
	if(runq-&gt;pid==-1)
		setstatus(concstatus(runq-&gt;status, getstatus()));
	else{
		strncpy(status, getstatus(), NSTATUS);
		status[NSTATUS]='\0';
		Waitfor(runq-&gt;pid, 1);
		runq-&gt;pid=-1;
		setstatus(concstatus(getstatus(), status));
	}
}

void
Xrdcmds(void)
{
	struct thread *p = runq;
	word *prompt;
	flush(err);
	nerror = 0;
	if(flag['s'] &amp;&amp; !truestatus())
		pfmt(err, "status=%v\n", vlook("status")-&gt;val);
	if(runq-&gt;iflag){
		prompt = vlook("prompt")-&gt;val;
		if(prompt)
			promptstr = prompt-&gt;word;
		else
			promptstr="% ";
	}
	Noerror();
	if(yyparse()){
		if(!p-&gt;iflag || p-&gt;eof &amp;&amp; !Eintr()){
			if(p-&gt;cmdfile)
				efree(p-&gt;cmdfile);
			closeio(p-&gt;cmdfd);
			Xreturn();	/* should this be omitted? */
		}
		else{
			if(Eintr()){
				pchr(err, '\n');
				p-&gt;eof = 0;
			}
			--p-&gt;pc;	/* go back for next command */
		}
	}
	else{
		ntrap = 0;	/* avoid double-interrupts during blocked writes */
		--p-&gt;pc;	/* re-execute Xrdcmds after codebuf runs */
		start(codebuf, 1, runq-&gt;local);
	}
	freenodes();
}

void
Xerror(char *s)
{
	if(strcmp(argv0, "rc")==0 || strcmp(argv0, "/bin/rc")==0)
		pfmt(err, "rc: %s: %r\n", s);
	else
		pfmt(err, "rc (%s): %s: %r\n", argv0, s);
	flush(err);
	setstatus("error");
	while(!runq-&gt;iflag) Xreturn();
}

void
Xerror1(char *s)
{
	if(strcmp(argv0, "rc")==0 || strcmp(argv0, "/bin/rc")==0)
		pfmt(err, "rc: %s\n", s);
	else
		pfmt(err, "rc (%s): %s\n", argv0, s);
	flush(err);
	setstatus("error");
	while(!runq-&gt;iflag) Xreturn();
}

void
setstatus(char *s)
{
	setvar("status", newword(s, (word *)0));
}

char*
getstatus(void)
{
	var *status = vlook("status");
	return status-&gt;val?status-&gt;val-&gt;word:"";
}

int
truestatus(void)
{
	char *s;
	for(s = getstatus();*s;s++)
		if(*s!='|' &amp;&amp; *s!='0')
			return 0;
	return 1;
}

void
Xdelhere(void)
{
	Unlink(runq-&gt;code[runq-&gt;pc++].s);
}

void
Xfor(void)
{
	if(runq-&gt;argv-&gt;words==0){
		poplist();
		runq-&gt;pc = runq-&gt;code[runq-&gt;pc].i;
	}
	else{
		freelist(runq-&gt;local-&gt;val);
		runq-&gt;local-&gt;val = runq-&gt;argv-&gt;words;
		runq-&gt;local-&gt;changed = 1;
		runq-&gt;argv-&gt;words = runq-&gt;argv-&gt;words-&gt;next;
		runq-&gt;local-&gt;val-&gt;next = 0;
		runq-&gt;pc++;
	}
}

void
Xglob(void)
{
	globlist();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

