<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rc/simple.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rc/simple.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Maybe `simple' is a misnomer.
 */
#include "rc.h"
#include "getflags.h"
#include "exec.h"
#include "io.h"
#include "fns.h"
/*
 * Search through the following code to see if we're just going to exit.
 */
int
exitnext(void){
	union code *c=&amp;runq-&gt;code[runq-&gt;pc];
	while(c-&gt;f==Xpopredir) c++;
	return c-&gt;f==Xexit;
}

void
Xsimple(void)
{
	word *a;
	thread *p = runq;
	var *v;
	struct builtin *bp;
	int pid;
	globlist();
	a = runq-&gt;argv-&gt;words;
	if(a==0){
		Xerror1("empty argument list");
		return;
	}
	if(flag['x'])
		pfmt(err, "%v\n", p-&gt;argv-&gt;words); /* wrong, should do redirs */
	v = gvlook(a-&gt;word);
	if(v-&gt;fn)
		execfunc(v);
	else{
		if(strcmp(a-&gt;word, "builtin")==0){
			if(count(a)==1){
				pfmt(err, "builtin: empty argument list\n");
				setstatus("empty arg list");
				poplist();
				return;
			}
			a = a-&gt;next;
			popword();
		}
		for(bp = Builtin;bp-&gt;name;bp++)
			if(strcmp(a-&gt;word, bp-&gt;name)==0){
				(*bp-&gt;fnc)();
				return;
			}
		if(exitnext()){
			/* fork and wait is redundant */
			pushword("exec");
			execexec();
			Xexit();
		}
		else{
			flush(err);
			Updenv();	/* necessary so changes don't go out again */
			if((pid = execforkexec()) &lt; 0){
				Xerror("try again");
				return;
			}

			/* interrupts don't get us out */
			poplist();
			while(Waitfor(pid, 1) &lt; 0)
				;
		}
	}
}
struct word nullpath = { "", 0};

void
doredir(redir *rp)
{
	if(rp){
		doredir(rp-&gt;next);
		switch(rp-&gt;type){
		case ROPEN:
			if(rp-&gt;from!=rp-&gt;to){
				Dup(rp-&gt;from, rp-&gt;to);
				close(rp-&gt;from);
			}
			break;
		case RDUP:
			Dup(rp-&gt;from, rp-&gt;to);
			break;
		case RCLOSE:
			close(rp-&gt;from);
			break;
		}
	}
}

word*
searchpath(char *w)
{
	word *path;
	if(strncmp(w, "/", 1)==0
	|| strncmp(w, "#", 1)==0
	|| strncmp(w, "./", 2)==0
	|| strncmp(w, "../", 3)==0
	|| (path = vlook("path")-&gt;val)==0)
		path=&amp;nullpath;
	return path;
}

void
execexec(void)
{
	popword();	/* "exec" */
	if(runq-&gt;argv-&gt;words==0){
		Xerror1("empty argument list");
		return;
	}
	doredir(runq-&gt;redir);
	Execute(runq-&gt;argv-&gt;words, searchpath(runq-&gt;argv-&gt;words-&gt;word));
	poplist();
}

void
execfunc(var *func)
{
	word *starval;
	popword();
	starval = runq-&gt;argv-&gt;words;
	runq-&gt;argv-&gt;words = 0;
	poplist();
	start(func-&gt;fn, func-&gt;pc, runq-&gt;local);
	runq-&gt;local = newvar(strdup("*"), runq-&gt;local);
	runq-&gt;local-&gt;val = starval;
	runq-&gt;local-&gt;changed = 1;
}

int
dochdir(char *word)
{
	/* report to /dev/wdir if it exists and we're interactive */
	static int wdirfd = -2;
	if(chdir(word)&lt;0) return -1;
	if(flag['i']!=0){
		if(wdirfd==-2)	/* try only once */
			wdirfd = open("/dev/wdir", OWRITE|OCEXEC);
		if(wdirfd&gt;=0) {
			fcntl(wdirfd, F_SETFD, FD_CLOEXEC);
			write(wdirfd, word, strlen(word));
		}
	}
	return 1;
}

static char *
appfile(char *dir, char *comp)
{
	int dirlen, complen;
	char *s, *p;

	dirlen = strlen(dir);
	complen = strlen(comp);
	s = emalloc(dirlen + 1 + complen + 1);
	memmove(s, dir, dirlen);
	p = s + dirlen;
	*p++ = '/';
	memmove(p, comp, complen);
	p[complen] = '\0';
	return s;
}

void
execcd(void)
{
	word *a = runq-&gt;argv-&gt;words;
	word *cdpath;
	char *dir;

	setstatus("can't cd");
	cdpath = vlook("cdpath")-&gt;val;
	switch(count(a)){
	default:
		pfmt(err, "Usage: cd [directory]\n");
		break;
	case 2:
		if(a-&gt;next-&gt;word[0]=='/' || cdpath==0)
			cdpath = &amp;nullpath;
		for(; cdpath; cdpath = cdpath-&gt;next){
			if(cdpath-&gt;word[0] != '\0')
				dir = appfile(cdpath-&gt;word, a-&gt;next-&gt;word);
			else
				dir = strdup(a-&gt;next-&gt;word);

			if(dochdir(dir) &gt;= 0){
				if(cdpath-&gt;word[0] != '\0' &amp;&amp;
				    strcmp(cdpath-&gt;word, ".") != 0)
					pfmt(err, "%s\n", dir);
				free(dir);
				setstatus("");
				break;
			}
			free(dir);
		}
		if(cdpath==0)
			pfmt(err, "Can't cd %s: %r\n", a-&gt;next-&gt;word);
		break;
	case 1:
		a = vlook("home")-&gt;val;
		if(count(a)&gt;=1){
			if(dochdir(a-&gt;word)&gt;=0)
				setstatus("");
			else
				pfmt(err, "Can't cd %s: %r\n", a-&gt;word);
		}
		else
			pfmt(err, "Can't cd -- $home empty\n");
		break;
	}
	poplist();
}

void
execexit(void)
{
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		pfmt(err, "Usage: exit [status]\nExiting anyway\n");
	case 2:
		setstatus(runq-&gt;argv-&gt;words-&gt;next-&gt;word);
	case 1:	Xexit();
	}
}

void
execshift(void)
{
	int n;
	word *a;
	var *star;
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		pfmt(err, "Usage: shift [n]\n");
		setstatus("shift usage");
		poplist();
		return;
	case 2:
		n = atoi(runq-&gt;argv-&gt;words-&gt;next-&gt;word);
		break;
	case 1:
		n = 1;
		break;
	}
	star = vlook("*");
	for(;n &amp;&amp; star-&gt;val;--n){
		a = star-&gt;val-&gt;next;
		efree(star-&gt;val-&gt;word);
		efree((char *)star-&gt;val);
		star-&gt;val = a;
		star-&gt;changed = 1;
	}
	setstatus("");
	poplist();
}

int
octal(char *s)
{
	int n = 0;
	while(*s==' ' || *s=='\t' || *s=='\n') s++;
	while('0'&lt;=*s &amp;&amp; *s&lt;='7') n = n*8+*s++-'0';
	return n;
}

int
mapfd(int fd)
{
	redir *rp;
	for(rp = runq-&gt;redir;rp;rp = rp-&gt;next){
		switch(rp-&gt;type){
		case RCLOSE:
			if(rp-&gt;from==fd)
				fd=-1;
			break;
		case RDUP:
		case ROPEN:
			if(rp-&gt;to==fd)
				fd = rp-&gt;from;
			break;
		}
	}
	return fd;
}
union code rdcmds[4];

void
execcmds(io *f)
{
	static int first = 1;
	if(first){
		rdcmds[0].i = 1;
		rdcmds[1].f = Xrdcmds;
		rdcmds[2].f = Xreturn;
		first = 0;
	}
	start(rdcmds, 1, runq-&gt;local);
	runq-&gt;cmdfd = f;
	runq-&gt;iflast = 0;
}

void
execeval(void)
{
	char *cmdline, *s, *t;
	int len = 0;
	word *ap;
	if(count(runq-&gt;argv-&gt;words)&lt;=1){
		Xerror1("Usage: eval cmd ...");
		return;
	}
	eflagok = 1;
	for(ap = runq-&gt;argv-&gt;words-&gt;next;ap;ap = ap-&gt;next)
		len+=1+strlen(ap-&gt;word);
	cmdline = emalloc(len);
	s = cmdline;
	for(ap = runq-&gt;argv-&gt;words-&gt;next;ap;ap = ap-&gt;next){
		for(t = ap-&gt;word;*t;) *s++=*t++;
		*s++=' ';
	}
	s[-1]='\n';
	poplist();
	execcmds(opencore(cmdline, len));
	efree(cmdline);
}
union code dotcmds[14];

void
execdot(void)
{
	int iflag = 0;
	int fd;
	list *av;
	thread *p = runq;
	char *zero, *file;
	word *path;
	static int first = 1;

	if(first){
		dotcmds[0].i = 1;
		dotcmds[1].f = Xmark;
		dotcmds[2].f = Xword;
		dotcmds[3].s="0";
		dotcmds[4].f = Xlocal;
		dotcmds[5].f = Xmark;
		dotcmds[6].f = Xword;
		dotcmds[7].s="*";
		dotcmds[8].f = Xlocal;
		dotcmds[9].f = Xrdcmds;
		dotcmds[10].f = Xunlocal;
		dotcmds[11].f = Xunlocal;
		dotcmds[12].f = Xreturn;
		first = 0;
	}
	else
		eflagok = 1;
	popword();
	if(p-&gt;argv-&gt;words &amp;&amp; strcmp(p-&gt;argv-&gt;words-&gt;word, "-i")==0){
		iflag = 1;
		popword();
	}
	/* get input file */
	if(p-&gt;argv-&gt;words==0){
		Xerror1("Usage: . [-i] file [arg ...]");
		return;
	}
	zero = strdup(p-&gt;argv-&gt;words-&gt;word);
	popword();
	fd = -1;
	for(path = searchpath(zero); path; path = path-&gt;next){
		if(path-&gt;word[0] != '\0')
			file = appfile(path-&gt;word, zero);
		else
			file = strdup(zero);

		fd = open(file, 0);
		free(file);
		if(fd &gt;= 0)
			break;
		if(strcmp(file, "/dev/stdin")==0){	/* for sun &amp; ucb */
			fd = Dup1(0);
			if(fd&gt;=0)
				break;
		}
	}
	if(fd&lt;0){
		pfmt(err, "%s: ", zero);
		setstatus("can't open");
		Xerror(".: can't open");
		return;
	}
	/* set up for a new command loop */
	start(dotcmds, 1, (struct var *)0);
	pushredir(RCLOSE, fd, 0);
	runq-&gt;cmdfile = zero;
	runq-&gt;cmdfd = openfd(fd);
	runq-&gt;iflag = iflag;
	runq-&gt;iflast = 0;
	/* push $* value */
	pushlist();
	runq-&gt;argv-&gt;words = p-&gt;argv-&gt;words;
	/* free caller's copy of $* */
	av = p-&gt;argv;
	p-&gt;argv = av-&gt;next;
	efree((char *)av);
	/* push $0 value */
	pushlist();
	pushword(zero);
	ndot++;
}

void
execflag(void)
{
	char *letter, *val;
	switch(count(runq-&gt;argv-&gt;words)){
	case 2:
		setstatus(flag[(uchar)runq-&gt;argv-&gt;words-&gt;next-&gt;word[0]]?"":"flag not set");
		break;
	case 3:
		letter = runq-&gt;argv-&gt;words-&gt;next-&gt;word;
		val = runq-&gt;argv-&gt;words-&gt;next-&gt;next-&gt;word;
		if(strlen(letter)==1){
			if(strcmp(val, "+")==0){
				flag[(uchar)letter[0]] = flagset;
				break;
			}
			if(strcmp(val, "-")==0){
				flag[(uchar)letter[0]] = 0;
				break;
			}
		}
	default:
		Xerror1("Usage: flag [letter] [+-]");
		return;
	}
	poplist();
}

void
execwhatis(void){	/* mildly wrong -- should fork before writing */
	word *a, *b, *path;
	var *v;
	struct builtin *bp;
	char *file;
	struct io out[1];
	int found, sep;
	a = runq-&gt;argv-&gt;words-&gt;next;
	if(a==0){
		Xerror1("Usage: whatis name ...");
		return;
	}
	setstatus("");
	memset(out, 0, sizeof out);
	out-&gt;fd = mapfd(1);
	out-&gt;bufp = out-&gt;buf;
	out-&gt;ebuf = &amp;out-&gt;buf[NBUF];
	out-&gt;strp = 0;
	for(;a;a = a-&gt;next){
		v = vlook(a-&gt;word);
		if(v-&gt;val){
			pfmt(out, "%s=", a-&gt;word);
			if(v-&gt;val-&gt;next==0)
				pfmt(out, "%q\n", v-&gt;val-&gt;word);
			else{
				sep='(';
				for(b = v-&gt;val;b &amp;&amp; b-&gt;word;b = b-&gt;next){
					pfmt(out, "%c%q", sep, b-&gt;word);
					sep=' ';
				}
				pfmt(out, ")\n");
			}
			found = 1;
		}
		else
			found = 0;
		v = gvlook(a-&gt;word);
		if(v-&gt;fn)
			pfmt(out, "fn %q %s\n", v-&gt;name, v-&gt;fn[v-&gt;pc-1].s);
		else{
			for(bp = Builtin;bp-&gt;name;bp++)
				if(strcmp(a-&gt;word, bp-&gt;name)==0){
					pfmt(out, "builtin %s\n", a-&gt;word);
					break;
				}
			if(!bp-&gt;name){
				for(path = searchpath(a-&gt;word); path;
				    path = path-&gt;next){
					if(path-&gt;word[0] != '\0')
						file = appfile(path-&gt;word,
							a-&gt;word);
					else
						file = strdup(a-&gt;word);
					if(Executable(file)){
						pfmt(out, "%s\n", file);
						free(file);
						break;
					}
					free(file);
				}
				if(!path &amp;&amp; !found){
					pfmt(err, "%s: not found\n", a-&gt;word);
					setstatus("not found");
				}
			}
		}
	}
	poplist();
	flush(err);
}

void
execwait(void)
{
	switch(count(runq-&gt;argv-&gt;words)){
	default:
		Xerror1("Usage: wait [pid]");
		return;
	case 2:
		Waitfor(atoi(runq-&gt;argv-&gt;words-&gt;next-&gt;word), 0);
		break;
	case 1:
		Waitfor(-1, 0);
		break;
	}
	poplist();
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

