<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/replica/applychanges.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/replica/applychanges.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * push changes from client to server.
 */
#include "all.h"

int douid;
Db *db;
char **x;
int nx;
int justshow;
int verbose;
int conflicts;
char newpath[10000];
char oldpath[10000];
char *clientroot;
char *serverroot;
int copyfile(char*, char*, Dir*, int);
int metafile(char*, Dir*);
char **match;
int nmatch;

int
ismatch(char *s)
{
	int i, len;

	if(nmatch == 0)
		return 1;
	for(i=0; i&lt;nmatch; i++){
		if(strcmp(s, match[i]) == 0)
			return 1;
		len = strlen(match[i]);
		if(strncmp(s, match[i], len) == 0 &amp;&amp; s[len]=='/')
			return 1;
	}
	return 0;
}

void
xlog(char c, char *path, Dir *d)
{
	if(!verbose)
		return;
	print("%c %s %luo %s %s %lud\n", c, path, d-&gt;mode, d-&gt;uid, d-&gt;gid, d-&gt;mtime);
}

void
walk(char *new, char *old, Dir *pd, void*)
{
	int i, len;
	Dir od, d;
	static Dir *xd;

	new = unroot(new, "/");
	old = unroot(old, serverroot);

	if(!ismatch(new))
		return;
	if(xd != nil){
		free(xd);
		xd = nil;
	}

	for(i=0; i&lt;nx; i++){
		if(strcmp(new, x[i]) == 0)
			return;
		len = strlen(x[i]);
		if(strncmp(new, x[i], len)==0 &amp;&amp; new[len]=='/')
			return;
	}

	d = *pd;
	d.name = old;
	memset(&amp;od, 0, sizeof od);
	snprint(newpath, sizeof newpath, "%s/%s", clientroot, new);
	snprint(oldpath, sizeof oldpath, "%s/%s", serverroot, old);

	xd = dirstat(oldpath);
	if(markdb(db, new, &amp;od) &lt; 0){
		if(xd != nil){
			print("x %s create/create conflict\n", new);
			conflicts = 1;
			return;
		}
		xlog('a', new, &amp;d);
		d.muid = "mark";	/* mark bit */
		if(!justshow){
			if(copyfile(newpath, oldpath, &amp;d, 1) == 0)
				insertdb(db, new, &amp;d);
		}
	}else{
		if((d.mode&amp;DMDIR)==0 &amp;&amp; od.mtime!=d.mtime){
			if(xd==nil){
				print("%s update/remove conflict\n", new);
				conflicts = 1;
				return;
			}
			if(xd-&gt;mtime != od.mtime){
				print("%s update/update conflict\n", new);
				conflicts = 1;
				return;
			}
			od.mtime = d.mtime;
			od.muid = "mark";
			xlog('c', new, &amp;od);
			if(!justshow){
				if(copyfile(newpath, oldpath, &amp;od, 0) == 0)
					insertdb(db, new, &amp;od);
			}
		}
		if((douid&amp;&amp;strcmp(od.uid,d.uid)!=0)
		|| strcmp(od.gid,d.gid)!=0 
		|| od.mode!=d.mode){
			if(xd==nil){
				print("%s metaupdate/remove conflict\n", new);
				conflicts = 1;
				return;
			}
			if((douid&amp;&amp;strcmp(od.uid,xd-&gt;uid)!=0)
			|| strcmp(od.uid,xd-&gt;gid)!=0
			|| od.mode!=xd-&gt;mode){
				print("%s metaupdate/metaupdate conflict\n", new);
				conflicts = 1;
				return;
			}
			if(douid)
				od.uid = d.uid;
			od.gid = d.gid;
			od.mode = d.mode;
			od.muid = "mark";
			xlog('m', new, &amp;od);
			if(!justshow){
				if(metafile(oldpath, &amp;od) == 0)
					insertdb(db, new, &amp;od);
			}
		}
	}
}

void
usage(void)
{
	fprint(2, "usage: replica/applychanges [-nuv] [-p proto] [-x path]... clientdb clientroot serverroot [path ...]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char *proto;
	Avlwalk *w;
	Dir *xd, d;
	Entry *e;

	quotefmtinstall();
	proto = "/sys/lib/sysconfig/proto/allproto";
	ARGBEGIN{
	case 'n':
		justshow = 1;
		verbose = 1;
		break;
	case 'p':
		proto = EARGF(usage());
		break;
	case 'u':
		douid = 1;
		break;
	case 'v':
		verbose = 1;
		break;
	case 'x':
		if(nx%16 == 0)
			x = erealloc(x, (nx+16)*sizeof(x[0]));
		x[nx++] = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(argc &lt; 3)
		usage();

	db = opendb(argv[0]);
	clientroot = argv[1];
	serverroot = argv[2];
	match = argv+3;
	nmatch = argc-3;


	if(revrdproto(proto, clientroot, serverroot, walk, nil, nil) &lt; 0)
		sysfatal("rdproto: %r");

	w = avlwalk(db-&gt;avl);
	while(e = (Entry*)avlprev(w)){
		if(!ismatch(e-&gt;name))
			continue;
		if(!e-&gt;d.mark){		/* not visited during walk */
			snprint(newpath, sizeof newpath, "%s/%s", clientroot, e-&gt;name);
			snprint(oldpath, sizeof oldpath, "%s/%s", serverroot, e-&gt;d.name);
			xd = dirstat(oldpath);
			if(xd == nil){
				removedb(db, e-&gt;name);
				continue;
			}
			if(xd-&gt;mtime != e-&gt;d.mtime &amp;&amp; (e-&gt;d.mode&amp;xd-&gt;mode&amp;DMDIR)==0){
				print("x %q remove/update conflict\n", e-&gt;name);
				free(xd);
				continue;
			}
			memset(&amp;d, 0, sizeof d);
			d.name = e-&gt;d.name;
			d.uid = e-&gt;d.uid;
			d.gid = e-&gt;d.gid;
			d.mtime = e-&gt;d.mtime;
			d.mode = e-&gt;d.mode;
			xlog('d', e-&gt;name, &amp;d);
			if(!justshow){
				if(remove(oldpath) == 0)
					removedb(db, e-&gt;name);
			}
			free(xd);
		}
	}

	if(conflicts)
		exits("conflicts");
	exits(nil);
}

enum { DEFB = 8192 };

static int
copy1(int fdf, int fdt, char *from, char *to)
{
	char buf[DEFB];
	long n, n1, rcount;
	int rv;
	char err[ERRMAX];

	/* clear any residual error */
	err[0] = '\0';
	errstr(err, ERRMAX);
	rv = 0;
	for(rcount=0;; rcount++) {
		n = read(fdf, buf, DEFB);
		if(n &lt;= 0)
			break;
		n1 = write(fdt, buf, n);
		if(n1 != n) {
			fprint(2, "error writing %q: %r\n", to);
			rv = -1;
			break;
		}
	}
	if(n &lt; 0) {
		fprint(2, "error reading %q: %r\n", from);
		rv = -1;
	}
	return rv;
}

int
copyfile(char *from, char *to, Dir *d, int dowstat)
{
	Dir nd;
	int rfd, wfd, didcreate;
	
	if((rfd = open(from, OREAD)) &lt; 0)
		return -1;

	didcreate = 0;
	if(d-&gt;mode&amp;DMDIR){
		if((wfd = create(to, OREAD, DMDIR)) &lt; 0){
			fprint(2, "mkdir %q: %r\n", to);
			close(rfd);
			return -1;
		}
	}else{
		if((wfd = open(to, OTRUNC|OWRITE)) &lt; 0){
			if((wfd = create(to, OWRITE, 0)) &lt; 0){
				close(rfd);
				return -1;
			}
			didcreate = 1;
		}
		if(copy1(rfd, wfd, from, to) &lt; 0){
			close(rfd);
			close(wfd);
			return -1;
		}
	}
	close(rfd);
	if(didcreate || dowstat){
		nulldir(&amp;nd);
		nd.mode = d-&gt;mode;
		if(dirfwstat(wfd, &amp;nd) &lt; 0)
			fprint(2, "warning: cannot set mode on %q\n", to);
		nulldir(&amp;nd);
		nd.gid = d-&gt;gid;
		if(dirfwstat(wfd, &amp;nd) &lt; 0)
			fprint(2, "warning: cannot set gid on %q\n", to);
		if(douid){
			nulldir(&amp;nd);
			nd.uid = d-&gt;uid;
			if(dirfwstat(wfd, &amp;nd) &lt; 0)
				fprint(2, "warning: cannot set uid on %q\n", to);
		}
	}
	nulldir(&amp;nd);
	nd.mtime = d-&gt;mtime;
	if(dirfwstat(wfd, &amp;nd) &lt; 0)
		fprint(2, "warning: cannot set mtime on %q\n", to);
	close(wfd);
	return 0;
}

int
metafile(char *path, Dir *d)
{
	Dir nd;

	nulldir(&amp;nd);
	nd.gid = d-&gt;gid;
	nd.mode = d-&gt;mode;
	if(douid)
		nd.uid = d-&gt;uid;
	if(dirwstat(path, &amp;nd) &lt; 0){
		fprint(2, "dirwstat %q: %r\n", path);
		return -1;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

