<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/replica/db.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/replica/db.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "all.h"

static Entry *fe;

static Entry*
allocentry(void)
{
	int i;
	Entry *e;

	if(fe == nil){
		fe = emalloc(128*sizeof(Entry));
		for(i=0; i&lt;128-1; i++)
			fe[i].name = (char*)&amp;fe[i+1];
		fe[i].name = nil;
	}

	e = fe;
	fe = (Entry*)e-&gt;name;
	memset(e, 0, sizeof *e);
	return e;
}

static void
freeentry(Entry *e)
{
	e-&gt;name = (char*)fe;
	fe = e;
}

static void
_removedb(Db *db, char *name)
{
	Entry *e, k;

	memset(&amp;k, 0, sizeof k);
	k.name = name;
	e = nil;
	deleteavl(db-&gt;avl, (Avl*)&amp;k, (Avl**)&amp;e);
	if(e)
		freeentry(e);
}

static void
_insertdb(Db *db, Entry *e)
{
	Entry *o, *ne;

	ne = allocentry();
	*ne = *e;
	o = nil;
	insertavl(db-&gt;avl, (Avl*)ne, (Avl**)&amp;o);
	if(o)
		freeentry(o);
}

static int
entrycmp(Avl *a, Avl *b)
{
	Entry *ea, *eb;
	int r;

	ea = (Entry*)a;
	eb = (Entry*)b;
	r = strcmp(ea-&gt;name, eb-&gt;name);
	return r &gt; 0 ? 1 : r &lt; 0 ? -1 : 0;
}

Db*
opendb(char *file)
{
	char *f[10], *s, *t;
	int i, fd, nf;
	Biobuf b;
	Db *db;
	Entry e;

	if(file == nil)
		fd = -1;
	else if((fd = open(file, ORDWR)) &lt; 0)
		sysfatal("opendb %s: %r", file);
	db = emalloc(sizeof(Db));
	db-&gt;avl = mkavltree(entrycmp);
	db-&gt;fd = fd;
	if(fd &lt; 0)
		return db;
	Binit(&amp;b, fd, OREAD);
	i = 0;
	for(; s=Brdstr(&amp;b, '\n', 1); free(s)){
		t = estrdup(s);
		nf = tokenize(s, f, nelem(f));
		if(nf != 7)
			sysfatal("bad database entry '%s'", t);
		free(t);
		if(strcmp(f[2], "REMOVED") == 0)
			_removedb(db, f[0]);
		else{
			memset(&amp;e, 0, sizeof e);
			e.name = atom(f[0]);
			e.d.name = atom(f[1]);
			if(strcmp(e.d.name, "-")==0)
				e.d.name = e.name;
			e.d.mode = strtoul(f[2], 0, 8);
			e.d.uid = atom(f[3]);
			e.d.gid = atom(f[4]);
			e.d.mtime = strtoul(f[5], 0, 10);
			e.d.length = strtoll(f[6], 0, 10);
			_insertdb(db, &amp;e);
			i++;
		}
	}
	return db;
}

static int
_finddb(Db *db, char *name, Dir *d, int domark)
{
	Entry *e, k;

	memset(&amp;k, 0, sizeof k);
	k.name = name;

	e = (Entry*)lookupavl(db-&gt;avl, (Avl*)&amp;k);
	if(e == nil)
		return -1;
	memset(d, 0, sizeof *d);
	d-&gt;name = e-&gt;d.name;
	d-&gt;uid = e-&gt;d.uid;
	d-&gt;gid = e-&gt;d.gid;
	d-&gt;mtime = e-&gt;d.mtime;
	d-&gt;mode = e-&gt;d.mode;
	d-&gt;length = e-&gt;d.length;
	if(domark)
		e-&gt;d.mark = 1;
	return 0;
}

int
finddb(Db *db, char *name, Dir *d)
{
	return _finddb(db, name, d, 0);
}

int
markdb(Db *db, char *name, Dir *d)
{
	return _finddb(db, name, d, 1);
}

void
removedb(Db *db, char *name)
{
	if(db-&gt;fd&gt;=0 &amp;&amp; fprint(db-&gt;fd, "%q xxx REMOVED xxx xxx 0 0\n", name) &lt; 0)
		sysfatal("appending to db: %r");
	_removedb(db, name);
}

void
insertdb(Db *db, char *name, Dir *d)
{
	char *dname;
	Entry e;

	memset(&amp;e, 0, sizeof e);
	e.name = atom(name);
	e.d.name = atom(d-&gt;name);
	e.d.uid = atom(d-&gt;uid);
	e.d.gid = atom(d-&gt;gid);
	e.d.mtime = d-&gt;mtime;
	e.d.mode = d-&gt;mode;
	e.d.length = d-&gt;length;
	e.d.mark = d-&gt;muid!=0;

	dname = d-&gt;name;
	if(strcmp(name, dname) == 0)
		dname = "-";
	if(db-&gt;fd&gt;=0 &amp;&amp; fprint(db-&gt;fd, "%q %q %luo %q %q %lud %lld\n", name, dname, d-&gt;mode, d-&gt;uid, d-&gt;gid, d-&gt;mtime, d-&gt;length) &lt; 0)
		sysfatal("appending to db: %r");
	_insertdb(db, &amp;e);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

