<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/replica/updatedb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/replica/updatedb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * generate a list of files and their metadata
 * using a given proto file.
 */
#include "all.h"

int changesonly;
char *uid;
Db *db;
Biobuf blog;
ulong now;
int n;
char **x;
int nx;
int justlog;
char *root=".";
char **match;
int nmatch;

int
ismatch(char *s)
{
	int i, len;

	if(nmatch == 0)
		return 1;
	for(i=0; i&lt;nmatch; i++){
		if(strcmp(s, match[i]) == 0)
			return 1;
		len = strlen(match[i]);
		if(strncmp(s, match[i], len) == 0 &amp;&amp; s[len]=='/')
			return 1;
	}
	return 0;
}

void
xlog(int c, char *name, Dir *d)
{
	char *dname;

	dname = d-&gt;name;
	if(strcmp(dname, name) == 0)
		dname = "-";
	if(!justlog)
		Bprint(&amp;blog, "%lud %d ", now, n++);
	Bprint(&amp;blog, "%c %q %q %luo %q %q %lud %lld\n",
		c, name, dname, d-&gt;mode, uid ? uid : d-&gt;uid, d-&gt;gid, d-&gt;mtime, d-&gt;length);
}

void
walk(char *new, char *old, Dir *xd, void*)
{
	int i, change, len;
	Dir od, d;

	new = unroot(new, "/");
	old = unroot(old, root);

	if(!ismatch(new))
		return;
	for(i=0; i&lt;nx; i++){
		if(strcmp(new, x[i]) == 0)
			return;
		len = strlen(x[i]);
		if(strncmp(new, x[i], len)==0 &amp;&amp; new[len]=='/')
			return;
	}

	d = *xd;
	d.name = old;
	memset(&amp;od, 0, sizeof od);
	change = 0;
	if(markdb(db, new, &amp;od) &lt; 0){
		if(!changesonly){
			xlog('a', new, &amp;d);
			change = 1;
		}
	}else{
		if((d.mode&amp;DMDIR)==0 &amp;&amp; (od.mtime!=d.mtime || od.length!=d.length)){
			xlog('c', new, &amp;d);
			change = 1;
		}
		if((!uid&amp;&amp;strcmp(od.uid,d.uid)!=0)
		|| strcmp(od.gid,d.gid)!=0 
		|| od.mode!=d.mode){
			xlog('m', new, &amp;d);
			change = 1;
		}
	}
	if(!justlog &amp;&amp; change){
		if(uid)
			d.uid = uid;
		d.muid = "mark";	/* mark bit */
		insertdb(db, new, &amp;d);
	}
}

void
warn(char *msg, void*)
{
	char *p;

	fprint(2, "warning: %s\n", msg);

	/* find the %r in "can't open foo: %r" */
	p = strstr(msg, ": ");
	if(p)
		p += 2;

	/*
	 * if the error is about a remote server failing,
	 * then there's no point in continuing to look
	 * for changes -- we'll think everything got deleted!
	 *
	 * actual errors i see are:
	 *	"i/o on hungup channel" for a local hangup
	 *	"i/o on hungup channel" for a timeout (yank the network wire)
	 *	"'/n/sources/plan9' Hangup" for a remote hangup
	 * the rest is paranoia.
	 */
	if(p){
		if(cistrstr(p, "hungup") || cistrstr(p, "Hangup")
		|| cistrstr(p, "rpc error")
		|| cistrstr(p, "shut down")
		|| cistrstr(p, "i/o")
		|| cistrstr(p, "connection"))
			sysfatal("suspected network or i/o error - bailing out");
	}
}

void
usage(void)
{
	fprint(2, "usage: replica/updatedb [-c] [-p proto] [-r root] [-t now n] [-u uid] [-x path]... db [paths]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	char *proto;
	Avlwalk *w;
	Dir d;
	Entry *e;

	quotefmtinstall();
	proto = "/sys/lib/sysconfig/proto/allproto";
	now = time(0);
	Binit(&amp;blog, 1, OWRITE);
	ARGBEGIN{
	case 'c':
		changesonly = 1;
		break;
	case 'l':
		justlog = 1;
		break;
	case 'p':
		proto = EARGF(usage());
		break;
	case 'r':
		root = EARGF(usage());
		break;
	case 't':
		now = strtoul(EARGF(usage()), 0, 0);
		n = atoi(EARGF(usage()));
		break;
	case 'u':
		uid = EARGF(usage());
		break;
	case 'x':
		if(nx%16 == 0)
			x = erealloc(x, (nx+16)*sizeof(x[0]));
		x[nx++] = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND

	if(argc &lt;1)
		usage();

	match = argv+1;
	nmatch = argc-1;

	db = opendb(argv[0]);
	if(rdproto(proto, root, walk, warn, nil) &lt; 0)
		sysfatal("rdproto: %r");

	if(!changesonly){
		w = avlwalk(db-&gt;avl);
		while(e = (Entry*)avlprev(w)){
			if(!ismatch(e-&gt;name))
				continue;
			if(!e-&gt;d.mark){		/* not visited during walk */
				memset(&amp;d, 0, sizeof d);
				d.name = e-&gt;d.name;
				d.uid = e-&gt;d.uid;
				d.gid = e-&gt;d.gid;
				d.mtime = e-&gt;d.mtime;
				d.mode = e-&gt;d.mode;
				xlog('d', e-&gt;name, &amp;d);
				if(!justlog)
					removedb(db, e-&gt;name);
			}
		}
	}

	if(Bterm(&amp;blog) &lt; 0)
		sysfatal("writing output: %r");

	exits(nil);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

