<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/rio/xfid.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/rio/xfid.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include &lt;fcall.h&gt;
#include &lt;plumb.h&gt;
#include "dat.h"
#include "fns.h"

#define	MAXSNARF	100*1024

char Einuse[] =		"file in use";
char Edeleted[] =	"window deleted";
char Ebadreq[] =	"bad graphics request";
char Etooshort[] =	"buffer too small";
char Ebadtile[] =	"unknown tile";
char Eshort[] =		"short i/o request";
char Elong[] = 		"snarf buffer too long";
char Eunkid[] = 	"unknown id in attach";
char Ebadrect[] = 	"bad rectangle in attach";
char Ewindow[] = 	"cannot make window";
char Enowindow[] = 	"window has no image";
char Ebadmouse[] = 	"bad format on /dev/mouse";
char Ebadwrect[] = 	"rectangle outside screen";
char Ebadoffset[] = 	"window read not on scan line boundary";
extern char Eperm[];

static	Xfid	*xfidfree;
static	Xfid	*xfid;
static	Channel	*cxfidalloc;	/* chan(Xfid*) */
static	Channel	*cxfidfree;	/* chan(Xfid*) */

static	char	*tsnarf;
static	int	ntsnarf;

void
xfidallocthread(void*)
{
	Xfid *x;
	enum { Alloc, Free, N };
	static Alt alts[N+1];

	alts[Alloc].c = cxfidalloc;
	alts[Alloc].v = nil;
	alts[Alloc].op = CHANRCV;
	alts[Free].c = cxfidfree;
	alts[Free].v = &amp;x;
	alts[Free].op = CHANRCV;
	alts[N].op = CHANEND;
	for(;;){
		switch(alt(alts)){
		case Alloc:
			x = xfidfree;
			if(x)
				xfidfree = x-&gt;free;
			else{
				x = emalloc(sizeof(Xfid));
				x-&gt;c = chancreate(sizeof(void(*)(Xfid*)), 0);
				x-&gt;flushc = chancreate(sizeof(int), 0);	/* notification only; no data */
				x-&gt;flushtag = -1;
				x-&gt;next = xfid;
				xfid = x;
				threadcreate(xfidctl, x, 16384);
			}
			if(x-&gt;ref != 0){
				fprint(2, "%p incref %ld\n", x, x-&gt;ref);
				error("incref");
			}
			if(x-&gt;flushtag != -1)
				error("flushtag in allocate");
			incref(x);
			sendp(cxfidalloc, x);
			break;
		case Free:
			if(x-&gt;ref != 0){
				fprint(2, "%p decref %ld\n", x, x-&gt;ref);
				error("decref");
			}
			if(x-&gt;flushtag != -1)
				error("flushtag in free");
			x-&gt;free = xfidfree;
			xfidfree = x;
			break;
		}
	}
}

Channel*
xfidinit(void)
{
	cxfidalloc = chancreate(sizeof(Xfid*), 0);
	cxfidfree = chancreate(sizeof(Xfid*), 0);
	threadcreate(xfidallocthread, nil, STACK);
	return cxfidalloc;
}

void
xfidctl(void *arg)
{
	Xfid *x;
	void (*f)(Xfid*);
	char buf[64];

	x = arg;
	snprint(buf, sizeof buf, "xfid.%p", x);
	threadsetname(buf);
	for(;;){
		f = recvp(x-&gt;c);
		(*f)(x);
		if(decref(x) == 0)
			sendp(cxfidfree, x);
	}
}

void
xfidflush(Xfid *x)
{
	Fcall t;
	Xfid *xf;

	for(xf=xfid; xf; xf=xf-&gt;next)
		if(xf-&gt;flushtag == x-&gt;oldtag){
			xf-&gt;flushtag = -1;
			xf-&gt;flushing = TRUE;
			incref(xf);	/* to hold data structures up at tail of synchronization */
			if(xf-&gt;ref == 1)
				error("ref 1 in flush");
			if(canqlock(&amp;xf-&gt;active)){
				qunlock(&amp;xf-&gt;active);
				sendul(xf-&gt;flushc, 0);
			}else{
				qlock(&amp;xf-&gt;active);	/* wait for him to finish */
				qunlock(&amp;xf-&gt;active);
			}
			xf-&gt;flushing = FALSE;
			if(decref(xf) == 0)
				sendp(cxfidfree, xf);
			break;
		}
	filsysrespond(x-&gt;fs, x, &amp;t, nil);
}

void
xfidattach(Xfid *x)
{
	Fcall t;
	int id, hideit, scrollit;
	Window *w;
	char *err, *n, *dir, errbuf[ERRMAX];
	int pid, newlymade;
	Rectangle r;
	Image *i;

	t.qid = x-&gt;f-&gt;qid;
	qlock(&amp;all);
	w = nil;
	err = Eunkid;
	newlymade = FALSE;
	hideit = 0;

	if(x-&gt;aname[0] == 'N'){	/* N 100,100, 200, 200 - old syntax */
		n = x-&gt;aname+1;
		pid = strtoul(n, &amp;n, 0);
		if(*n == ',')
			n++;
		r.min.x = strtoul(n, &amp;n, 0);
		if(*n == ',')
			n++;
		r.min.y = strtoul(n, &amp;n, 0);
		if(*n == ',')
			n++;
		r.max.x = strtoul(n, &amp;n, 0);
		if(*n == ',')
			n++;
		r.max.y = strtoul(n, &amp;n, 0);
  Allocate:
		if(!goodrect(r))
			err = Ebadrect;
		else{
			if(hideit)
				i = allocimage(display, r, screen-&gt;chan, 0, DWhite);
			else
				i = allocwindow(wscreen, r, Refbackup, DWhite);
			if(i){
				border(i, r, Selborder, display-&gt;black, ZP);
				if(pid == 0)
					pid = -1;	/* make sure we don't pop a shell! - UGH */
				w = new(i, hideit, scrolling, pid, nil, nil, nil);
				flushimage(display, 1);
				newlymade = TRUE;
			}else
				err = Ewindow;
		}
	}else if(strncmp(x-&gt;aname, "new", 3) == 0){	/* new -dx -dy - new syntax, as in wctl */
		pid = 0;
		if(parsewctl(nil, ZR, &amp;r, &amp;pid, nil, &amp;hideit, &amp;scrollit, &amp;dir, x-&gt;aname, errbuf) &lt; 0)
			err = errbuf;
		else
			goto Allocate;
	}else{
		id = atoi(x-&gt;aname);
		w = wlookid(id);
	}
	x-&gt;f-&gt;w = w;
	if(w == nil){
		qunlock(&amp;all);
		x-&gt;f-&gt;busy = FALSE;
		filsysrespond(x-&gt;fs, x, &amp;t, err);
		return;
	}
	if(!newlymade)	/* counteract dec() in winshell() */
		incref(w);
	qunlock(&amp;all);
	filsysrespond(x-&gt;fs, x, &amp;t, nil);
}

void
xfidopen(Xfid *x)
{
	Fcall t;
	Window *w;

	w = x-&gt;f-&gt;w;
	if(w-&gt;deleted){
		filsysrespond(x-&gt;fs, x, &amp;t, Edeleted);
		return;
	}
	switch(FILE(x-&gt;f-&gt;qid)){
	case Qconsctl:
		if(w-&gt;ctlopen){
			filsysrespond(x-&gt;fs, x, &amp;t, Einuse);
			return;
		}
		w-&gt;ctlopen = TRUE;
		break;
	case Qkbdin:
		if(w !=  wkeyboard){
			filsysrespond(x-&gt;fs, x, &amp;t, Eperm);
			return;
		}
		break;
	case Qmouse:
		if(w-&gt;mouseopen){
			filsysrespond(x-&gt;fs, x, &amp;t, Einuse);
			return;
		}
		/*
		 * Reshaped: there's a race if the appl. opens the
		 * window, is resized, and then opens the mouse,
		 * but that's rare.  The alternative is to generate
		 * a resized event every time a new program starts
		 * up in a window that has been resized since the
		 * dawn of time.  We choose the lesser evil.
		 */
		w-&gt;resized = FALSE;
		w-&gt;mouseopen = TRUE;
		break;
	case Qsnarf:
		if(x-&gt;mode==ORDWR || x-&gt;mode==OWRITE){
			if(tsnarf)
				free(tsnarf);	/* collision, but OK */
			ntsnarf = 0;
			tsnarf = malloc(1);
		}
		break;
	case Qwctl:
		if(x-&gt;mode==OREAD || x-&gt;mode==ORDWR){
			/*
			 * It would be much nicer to implement fan-out for wctl reads,
			 * so multiple people can see the resizings, but rio just isn't
			 * structured for that.  It's structured for /dev/cons, which gives
			 * alternate data to alternate readers.  So to keep things sane for
			 * wctl, we compromise and give an error if two people try to
			 * open it.  Apologies.
			 */
			if(w-&gt;wctlopen){
				filsysrespond(x-&gt;fs, x, &amp;t, Einuse);
				return;
			}
			w-&gt;wctlopen = TRUE;
			w-&gt;wctlready = 1;
			wsendctlmesg(w, Wakeup, ZR, nil);
		}
		break;
	}
	t.qid = x-&gt;f-&gt;qid;
	t.iounit = messagesize-IOHDRSZ;
	x-&gt;f-&gt;open = TRUE;
	x-&gt;f-&gt;mode = x-&gt;mode;
	filsysrespond(x-&gt;fs, x, &amp;t, nil);
}

void
xfidclose(Xfid *x)
{
	Fcall t;
	Window *w;
	int nb, nulls;

	w = x-&gt;f-&gt;w;
	switch(FILE(x-&gt;f-&gt;qid)){
	case Qconsctl:
		if(w-&gt;rawing){
			w-&gt;rawing = FALSE;
			wsendctlmesg(w, Rawoff, ZR, nil);
		}
		if(w-&gt;holding){
			w-&gt;holding = FALSE;
			wsendctlmesg(w, Holdoff, ZR, nil);
		}
		w-&gt;ctlopen = FALSE;
		break;
	case Qcursor:
		w-&gt;cursorp = nil;
		wsetcursor(w, FALSE);
		break;
	case Qmouse:
		w-&gt;resized = FALSE;
		w-&gt;mouseopen = FALSE;
		if(w-&gt;i != nil)
			wsendctlmesg(w, Refresh, w-&gt;i-&gt;r, nil);
		break;
	/* odd behavior but really ok: replace snarf buffer when /dev/snarf is closed */
	case Qsnarf:
		if(x-&gt;f-&gt;mode==ORDWR || x-&gt;f-&gt;mode==OWRITE){
			snarf = runerealloc(snarf, ntsnarf+1);
			cvttorunes(tsnarf, ntsnarf, snarf, &amp;nb, &amp;nsnarf, &amp;nulls);
			free(tsnarf);
			tsnarf = nil;
			ntsnarf = 0;
		}
		break;
	case Qwctl:
		if(x-&gt;f-&gt;mode==OREAD || x-&gt;f-&gt;mode==ORDWR)
			w-&gt;wctlopen = FALSE;
		break;
	}
	wclose(w);
	filsysrespond(x-&gt;fs, x, &amp;t, nil);
}

void
xfidwrite(Xfid *x)
{
	Fcall fc;
	int c, cnt, qid, nb, off, nr;
	char buf[256], *p;
	Point pt;
	Window *w;
	Rune *r;
	Conswritemesg cwm;
	Stringpair pair;
	enum { CWdata, CWflush, NCW };
	Alt alts[NCW+1];

	w = x-&gt;f-&gt;w;
	if(w-&gt;deleted){
		filsysrespond(x-&gt;fs, x, &amp;fc, Edeleted);
		return;
	}
	qid = FILE(x-&gt;f-&gt;qid);
	cnt = x-&gt;count;
	off = x-&gt;offset;
	x-&gt;data[cnt] = 0;
	switch(qid){
	case Qcons:
		nr = x-&gt;f-&gt;nrpart;
		if(nr &gt; 0){
			memmove(x-&gt;data+nr, x-&gt;data, cnt);	/* there's room: see malloc in filsysproc */
			memmove(x-&gt;data, x-&gt;f-&gt;rpart, nr);
			cnt += nr;
			x-&gt;f-&gt;nrpart = 0;
		}
		r = runemalloc(cnt);
		cvttorunes(x-&gt;data, cnt-UTFmax, r, &amp;nb, &amp;nr, nil);
		/* approach end of buffer */
		while(fullrune(x-&gt;data+nb, cnt-nb)){
			c = nb;
			nb += chartorune(&amp;r[nr], x-&gt;data+c);
			if(r[nr])
				nr++;
		}
		if(nb &lt; cnt){
			memmove(x-&gt;f-&gt;rpart, x-&gt;data+nb, cnt-nb);
			x-&gt;f-&gt;nrpart = cnt-nb;
		}
		x-&gt;flushtag = x-&gt;tag;

		alts[CWdata].c = w-&gt;conswrite;
		alts[CWdata].v = &amp;cwm;
		alts[CWdata].op = CHANRCV;
		alts[CWflush].c = x-&gt;flushc;
		alts[CWflush].v = nil;
		alts[CWflush].op = CHANRCV;
		alts[NCW].op = CHANEND;
	
		switch(alt(alts)){
		case CWdata:
			break;
		case CWflush:
			filsyscancel(x);
			return;
		}

		/* received data */
		x-&gt;flushtag = -1;
		if(x-&gt;flushing){
			recv(x-&gt;flushc, nil);	/* wake up flushing xfid */
			pair.s = runemalloc(1);
			pair.ns = 0;
			send(cwm.cw, &amp;pair);		/* wake up window with empty data */
			filsyscancel(x);
			return;
		}
		qlock(&amp;x-&gt;active);
		pair.s = r;
		pair.ns = nr;
		send(cwm.cw, &amp;pair);
		fc.count = x-&gt;count;
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		qunlock(&amp;x-&gt;active);
		return;

	case Qconsctl:
		if(strncmp(x-&gt;data, "holdon", 6)==0){
			if(w-&gt;holding++ == 0)
				wsendctlmesg(w, Holdon, ZR, nil);
			break;
		}
		if(strncmp(x-&gt;data, "holdoff", 7)==0 &amp;&amp; w-&gt;holding){
			if(--w-&gt;holding == FALSE)
				wsendctlmesg(w, Holdoff, ZR, nil);
			break;
		}
		if(strncmp(x-&gt;data, "rawon", 5)==0){
			if(w-&gt;holding){
				w-&gt;holding = FALSE;
				wsendctlmesg(w, Holdoff, ZR, nil);
			}
			if(w-&gt;rawing++ == 0)
				wsendctlmesg(w, Rawon, ZR, nil);
			break;
		}
		if(strncmp(x-&gt;data, "rawoff", 6)==0 &amp;&amp; w-&gt;rawing){
			if(--w-&gt;rawing == 0)
				wsendctlmesg(w, Rawoff, ZR, nil);
			break;
		}
		filsysrespond(x-&gt;fs, x, &amp;fc, "unknown control message");
		return;

	case Qcursor:
		if(cnt &lt; 2*4+2*2*16)
			w-&gt;cursorp = nil;
		else{
			w-&gt;cursor.offset.x = BGLONG(x-&gt;data+0*4);
			w-&gt;cursor.offset.y = BGLONG(x-&gt;data+1*4);
			memmove(w-&gt;cursor.clr, x-&gt;data+2*4, 2*2*16);
			w-&gt;cursorp = &amp;w-&gt;cursor;
		}
		wsetcursor(w, !sweeping);
		break;

	case Qlabel:
		if(off != 0){
			filsysrespond(x-&gt;fs, x, &amp;fc, "non-zero offset writing label");
			return;
		}
		free(w-&gt;label);
		w-&gt;label = emalloc(cnt+1);
		memmove(w-&gt;label, x-&gt;data, cnt);
		w-&gt;label[cnt] = 0;
		break;

	case Qmouse:
		if(w!=input || Dx(w-&gt;screenr)&lt;=0)
			break;
		if(x-&gt;data[0] != 'm'){
			filsysrespond(x-&gt;fs, x, &amp;fc, Ebadmouse);
			return;
		}
		p = nil;
		pt.x = strtoul(x-&gt;data+1, &amp;p, 0);
		if(p == nil){
			filsysrespond(x-&gt;fs, x, &amp;fc, Eshort);
			return;
		}
		pt.y = strtoul(p, nil, 0);
		if(w==input &amp;&amp; wpointto(mouse-&gt;xy)==w)
			wsendctlmesg(w, Movemouse, Rpt(pt, pt), nil);
		break;

	case Qsnarf:
		/* always append only */
		if(ntsnarf &gt; MAXSNARF){	/* avoid thrashing when people cut huge text */
			filsysrespond(x-&gt;fs, x, &amp;fc, Elong);
			return;
		}
		tsnarf = erealloc(tsnarf, ntsnarf+cnt+1);	/* room for NUL */
		memmove(tsnarf+ntsnarf, x-&gt;data, cnt);
		ntsnarf += cnt;
		snarfversion++;
		break;

	case Qwdir:
		if(cnt == 0)
			break;
		if(x-&gt;data[cnt-1] == '\n'){
			if(cnt == 1)
				break;
			x-&gt;data[cnt-1] = '\0';
		}
		/* assume data comes in a single write */
		/*
		  * Problem: programs like dossrv, ftp produce illegal UTF;
		  * we must cope by converting it first.
		  */
		snprint(buf, sizeof buf, "%.*s", cnt, x-&gt;data);
		if(buf[0] == '/'){
			free(w-&gt;dir);
			w-&gt;dir = estrdup(buf);
		}else{
			p = emalloc(strlen(w-&gt;dir) + 1 + strlen(buf) + 1);
			sprint(p, "%s/%s", w-&gt;dir, buf);
			free(w-&gt;dir);
			w-&gt;dir = cleanname(p);
		}
		break;

	case Qkbdin:
		keyboardsend(x-&gt;data, cnt);
		break;

	case Qwctl:
		if(writewctl(x, buf) &lt; 0){
			filsysrespond(x-&gt;fs, x, &amp;fc, buf);
			return;
		}
		flushimage(display, 1);
		break;

	default:
		fprint(2, buf, "unknown qid %d in write\n", qid);
		sprint(buf, "unknown qid in write");
		filsysrespond(x-&gt;fs, x, &amp;fc, buf);
		return;
	}
	fc.count = cnt;
	filsysrespond(x-&gt;fs, x, &amp;fc, nil);
}

int
readwindow(Image *i, char *t, Rectangle r, int offset, int n)
{
	int ww, y;

	offset -= 5*12;
	ww = bytesperline(r, screen-&gt;depth);
	r.min.y += offset/ww;
	if(r.min.y &gt;= r.max.y)
		return 0;
	y = r.min.y + n/ww;
	if(y &lt; r.max.y)
		r.max.y = y;
	if(r.max.y &lt;= r.min.y)
		return 0;
	return unloadimage(i, r, (uchar*)t, n);
}

void
xfidread(Xfid *x)
{
	Fcall fc;
	int n, off, cnt, c;
	uint qid;
	char buf[128], *t;
	char cbuf[30];
	Window *w;
	Mouse ms;
	Rectangle r;
	Image *i;
	Channel *c1, *c2;	/* chan (tuple(char*, int)) */
	Consreadmesg crm;
	Mousereadmesg mrm;
	Consreadmesg cwrm;
	Stringpair pair;
	enum { CRdata, CRflush, NCR };
	enum { MRdata, MRflush, NMR };
	enum { WCRdata, WCRflush, NWCR };
	Alt alts[NCR+1];

	w = x-&gt;f-&gt;w;
	if(w-&gt;deleted){
		filsysrespond(x-&gt;fs, x, &amp;fc, Edeleted);
		return;
	}
	qid = FILE(x-&gt;f-&gt;qid);
	off = x-&gt;offset;
	cnt = x-&gt;count;
	switch(qid){
	case Qcons:
		x-&gt;flushtag = x-&gt;tag;

		alts[CRdata].c = w-&gt;consread;
		alts[CRdata].v = &amp;crm;
		alts[CRdata].op = CHANRCV;
		alts[CRflush].c = x-&gt;flushc;
		alts[CRflush].v = nil;
		alts[CRflush].op = CHANRCV;
		alts[NMR].op = CHANEND;

		switch(alt(alts)){
		case CRdata:
			break;
		case CRflush:
			filsyscancel(x);
			return;
		}

		/* received data */
		x-&gt;flushtag = -1;
		c1 = crm.c1;
		c2 = crm.c2;
		t = malloc(cnt+UTFmax+1);	/* room to unpack partial rune plus */
		pair.s = t;
		pair.ns = cnt;
		send(c1, &amp;pair);
		if(x-&gt;flushing){
			recv(x-&gt;flushc, nil);	/* wake up flushing xfid */
			recv(c2, nil);			/* wake up window and toss data */
			free(t);
			filsyscancel(x);
			return;
		}
		qlock(&amp;x-&gt;active);
		recv(c2, &amp;pair);
		fc.data = pair.s;
		fc.count = pair.ns;
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		free(t);
		qunlock(&amp;x-&gt;active);
		break;

	case Qlabel:
		n = strlen(w-&gt;label);
		if(off &gt; n)
			off = n;
		if(off+cnt &gt; n)
			cnt = n-off;
		fc.data = w-&gt;label+off;
		fc.count = cnt;
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		break;

	case Qmouse:
		x-&gt;flushtag = x-&gt;tag;

		alts[MRdata].c = w-&gt;mouseread;
		alts[MRdata].v = &amp;mrm;
		alts[MRdata].op = CHANRCV;
		alts[MRflush].c = x-&gt;flushc;
		alts[MRflush].v = nil;
		alts[MRflush].op = CHANRCV;
		alts[NMR].op = CHANEND;

		switch(alt(alts)){
		case MRdata:
			break;
		case MRflush:
			filsyscancel(x);
			return;
		}

		/* received data */
		x-&gt;flushtag = -1;
		if(x-&gt;flushing){
			recv(x-&gt;flushc, nil);		/* wake up flushing xfid */
			recv(mrm.cm, nil);			/* wake up window and toss data */
			filsyscancel(x);
			return;
		}
		qlock(&amp;x-&gt;active);
		recv(mrm.cm, &amp;ms);
		c = 'm';
		if(w-&gt;resized)
			c = 'r';
		n = sprint(buf, "%c%11d %11d %11d %11ld ", c, ms.xy.x, ms.xy.y, ms.buttons, ms.msec);
		w-&gt;resized = 0;
		fc.data = buf;
		fc.count = min(n, cnt);
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		qunlock(&amp;x-&gt;active);
		break;

	case Qcursor:
		filsysrespond(x-&gt;fs, x, &amp;fc, "cursor read not implemented");
		break;

	/* The algorithm for snarf and text is expensive but easy and rarely used */
	case Qsnarf:
		getsnarf();
		if(nsnarf)
			t = runetobyte(snarf, nsnarf, &amp;n);
		else {
			t = nil;
			n = 0;
		}
		goto Text;

	case Qtext:
		t = wcontents(w, &amp;n);
		goto Text;

	Text:
		if(off &gt; n){
			off = n;
			cnt = 0;
		}
		if(off+cnt &gt; n)
			cnt = n-off;
		fc.data = t+off;
		fc.count = cnt;
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		free(t);
		break;

	case Qwdir:
		t = estrdup(w-&gt;dir);
		n = strlen(t);
		goto Text;

	case Qwinid:
		n = sprint(buf, "%11d ", w-&gt;id);
		t = estrdup(buf);
		goto Text;


	case Qwinname:
		n = strlen(w-&gt;name);
		if(n == 0){
			filsysrespond(x-&gt;fs, x, &amp;fc, "window has no name");
			break;
		}
		t = estrdup(w-&gt;name);
		goto Text;

	case Qwindow:
		i = w-&gt;i;
		if(i == nil || Dx(w-&gt;screenr)&lt;=0){
			filsysrespond(x-&gt;fs, x, &amp;fc, Enowindow);
			return;
		}
		r = w-&gt;screenr;
		goto caseImage;

	case Qscreen:
		i = display-&gt;image;
		if(i == nil){
			filsysrespond(x-&gt;fs, x, &amp;fc, "no top-level screen");
			break;
		}
		r = i-&gt;r;
		/* fall through */

	caseImage:
		if(off &lt; 5*12){
			n = sprint(buf, "%11s %11d %11d %11d %11d ",
				chantostr(cbuf, screen-&gt;chan),
				i-&gt;r.min.x, i-&gt;r.min.y, i-&gt;r.max.x, i-&gt;r.max.y);
			t = estrdup(buf);
			goto Text;
		}
		t = malloc(cnt);
		fc.data = t;
		n = readwindow(i, t, r, off, cnt);	/* careful; fc.count is unsigned */
		if(n &lt; 0){
			buf[0] = 0;
			errstr(buf, sizeof buf);
			filsysrespond(x-&gt;fs, x, &amp;fc, buf);
		}else{
			fc.count = n;
			filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		}
		free(t);
		return;

	case Qwctl:	/* read returns rectangle, hangs if not resized */
		if(cnt &lt; 4*12){
			filsysrespond(x-&gt;fs, x, &amp;fc, Etooshort);
			break;
		}
		x-&gt;flushtag = x-&gt;tag;

		alts[WCRdata].c = w-&gt;wctlread;
		alts[WCRdata].v = &amp;cwrm;
		alts[WCRdata].op = CHANRCV;
		alts[WCRflush].c = x-&gt;flushc;
		alts[WCRflush].v = nil;
		alts[WCRflush].op = CHANRCV;
		alts[NMR].op = CHANEND;

		switch(alt(alts)){
		case WCRdata:
			break;
		case WCRflush:
			filsyscancel(x);
			return;
		}

		/* received data */
		x-&gt;flushtag = -1;
		c1 = cwrm.c1;
		c2 = cwrm.c2;
		t = malloc(cnt+1);	/* be sure to have room for NUL */
		pair.s = t;
		pair.ns = cnt+1;
		send(c1, &amp;pair);
		if(x-&gt;flushing){
			recv(x-&gt;flushc, nil);	/* wake up flushing xfid */
			recv(c2, nil);			/* wake up window and toss data */
			free(t);
			filsyscancel(x);
			return;
		}
		qlock(&amp;x-&gt;active);
		recv(c2, &amp;pair);
		fc.data = pair.s;
		if(pair.ns &gt; cnt)
			pair.ns = cnt;
		fc.count = pair.ns;
		filsysrespond(x-&gt;fs, x, &amp;fc, nil);
		free(t);
		qunlock(&amp;x-&gt;active);
		break;

	default:
		fprint(2, "unknown qid %d in read\n", qid);
		sprint(buf, "unknown qid in read");
		filsysrespond(x-&gt;fs, x, &amp;fc, buf);
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

