<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/file.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/file.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"

/*
 * Structure of Undo list:
 * 	The Undo structure follows any associated data, so the list
 *	can be read backwards: read the structure, then read whatever
 *	data is associated (insert string, file name) and precedes it.
 *	The structure includes the previous value of the modify bit
 *	and a sequence number; successive Undo structures with the
 *	same sequence number represent simultaneous changes.
 */

typedef struct Undo Undo;
typedef struct Merge Merge;

struct Undo
{
	short	type;		/* Delete, Insert, Filename, Dot, Mark */
	short	mod;		/* modify bit */
	uint	seq;		/* sequence number */
	uint	p0;		/* location of change (unused in f) */
	uint	n;		/* # runes in string or file name */
};

struct Merge
{
	File	*f;
	uint	seq;		/* of logged change */
	uint	p0;		/* location of change (unused in f) */
	uint	n;		/* # runes to delete */
	uint	nbuf;		/* # runes to insert */
	Rune	buf[RBUFSIZE];
};

enum
{
	Maxmerge = 50,
	Undosize = sizeof(Undo)/sizeof(Rune),
};

static Merge	merge;

File*
fileopen(void)
{
	File *f;

	f = emalloc(sizeof(File));
	f-&gt;dot.f = f;
	f-&gt;ndot.f = f;
	f-&gt;seq = 0;
	f-&gt;mod = FALSE;
	f-&gt;unread = TRUE;
	Strinit0(&amp;f-&gt;name);
	return f;
}

int
fileisdirty(File *f)
{
	return f-&gt;seq != f-&gt;cleanseq;
}

static void
wrinsert(Buffer *delta, int seq, int mod, uint p0, Rune *s, uint ns)
{
	Undo u;

	u.type = Insert;
	u.mod = mod;
	u.seq = seq;
	u.p0 = p0;
	u.n = ns;
	bufinsert(delta, delta-&gt;nc, s, ns);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

static void
wrdelete(Buffer *delta, int seq, int mod, uint p0, uint p1)
{
	Undo u;

	u.type = Delete;
	u.mod = mod;
	u.seq = seq;
	u.p0 = p0;
	u.n = p1 - p0;
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

void
flushmerge(void)
{
	File *f;

	f = merge.f;
	if(f == nil)
		return;
	if(merge.seq != f-&gt;seq)
		panic("flushmerge seq mismatch");
	if(merge.n != 0)
		wrdelete(&amp;f-&gt;epsilon, f-&gt;seq, TRUE, merge.p0, merge.p0+merge.n);
	if(merge.nbuf != 0)
		wrinsert(&amp;f-&gt;epsilon, f-&gt;seq, TRUE, merge.p0+merge.n, merge.buf, merge.nbuf);
	merge.f = nil;
	merge.n = 0;
	merge.nbuf = 0;
}

void
mergeextend(File *f, uint p0)
{
	uint mp0n;

	mp0n = merge.p0+merge.n;
	if(mp0n != p0){
		bufread(f, mp0n, merge.buf+merge.nbuf, p0-mp0n);
		merge.nbuf += p0-mp0n;
		merge.n = p0-merge.p0;
	}
}

/*
 * like fileundelete, but get the data from arguments
 */
void
loginsert(File *f, uint p0, Rune *s, uint ns)
{
	if(f-&gt;rescuing)
		return;
	if(ns == 0)
		return;
	if(ns&gt;STRSIZE)
		panic("loginsert");
	if(f-&gt;seq &lt; seq)
		filemark(f);
	if(p0 &lt; f-&gt;hiposn)
		error(Esequence);

	if(merge.f != f
	|| p0-(merge.p0+merge.n)&gt;Maxmerge			/* too far */
	|| merge.nbuf+((p0+ns)-(merge.p0+merge.n))&gt;=RBUFSIZE)	/* too long */
		flushmerge();

	if(ns&gt;=RBUFSIZE){
		if(!(merge.n == 0 &amp;&amp; merge.nbuf == 0 &amp;&amp; merge.f == nil))
			panic("loginsert bad merge state");
		wrinsert(&amp;f-&gt;epsilon, f-&gt;seq, TRUE, p0, s, ns);
	}else{
		if(merge.f != f){
			merge.f = f;
			merge.p0 = p0;
			merge.seq = f-&gt;seq;
		}
		mergeextend(f, p0);

		/* append string to merge */
		runemove(merge.buf+merge.nbuf, s, ns);
		merge.nbuf += ns;
	}

	f-&gt;hiposn = p0;
	if(!f-&gt;unread &amp;&amp; !f-&gt;mod)
		state(f, Dirty);
}

void
logdelete(File *f, uint p0, uint p1)
{
	if(f-&gt;rescuing)
		return;
	if(p0 == p1)
		return;
	if(f-&gt;seq &lt; seq)
		filemark(f);
	if(p0 &lt; f-&gt;hiposn)
		error(Esequence);

	if(merge.f != f
	|| p0-(merge.p0+merge.n)&gt;Maxmerge			/* too far */
	|| merge.nbuf+(p0-(merge.p0+merge.n))&gt;=RBUFSIZE){	/* too long */
		flushmerge();
		merge.f = f;
		merge.p0 = p0;
		merge.seq = f-&gt;seq;
	}

	mergeextend(f, p0);

	/* add to deletion */
	merge.n = p1-merge.p0;

	f-&gt;hiposn = p1;
	if(!f-&gt;unread &amp;&amp; !f-&gt;mod)
		state(f, Dirty);
}

/*
 * like fileunsetname, but get the data from arguments
 */
void
logsetname(File *f, String *s)
{
	Undo u;
	Buffer *delta;

	if(f-&gt;rescuing)
		return;

	if(f-&gt;unread){	/* This is setting initial file name */
		filesetname(f, s);
		return;
	}

	if(f-&gt;seq &lt; seq)
		filemark(f);

	/* undo a file name change by restoring old name */
	delta = &amp;f-&gt;epsilon;
	u.type = Filename;
	u.mod = TRUE;
	u.seq = f-&gt;seq;
	u.p0 = 0;	/* unused */
	u.n = s-&gt;n;
	if(s-&gt;n)
		bufinsert(delta, delta-&gt;nc, s-&gt;s, s-&gt;n);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
	if(!f-&gt;unread &amp;&amp; !f-&gt;mod)
		state(f, Dirty);
}

#ifdef NOTEXT
File*
fileaddtext(File *f, Text *t)
{
	if(f == nil){
		f = emalloc(sizeof(File));
		f-&gt;unread = TRUE;
	}
	f-&gt;text = realloc(f-&gt;text, (f-&gt;ntext+1)*sizeof(Text*));
	f-&gt;text[f-&gt;ntext++] = t;
	f-&gt;curtext = t;
	return f;
}

void
filedeltext(File *f, Text *t)
{
	int i;

	for(i=0; i&lt;f-&gt;ntext; i++)
		if(f-&gt;text[i] == t)
			goto Found;
	panic("can't find text in filedeltext");

    Found:
	f-&gt;ntext--;
	if(f-&gt;ntext == 0){
		fileclose(f);
		return;
	}
	memmove(f-&gt;text+i, f-&gt;text+i+1, (f-&gt;ntext-i)*sizeof(Text*));
	if(f-&gt;curtext == t)
		f-&gt;curtext = f-&gt;text[0];
}
#endif

void
fileuninsert(File *f, Buffer *delta, uint p0, uint ns)
{
	Undo u;

	/* undo an insertion by deleting */
	u.type = Delete;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = p0;
	u.n = ns;
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

void
fileundelete(File *f, Buffer *delta, uint p0, uint p1)
{
	Undo u;
	Rune *buf;
	uint i, n;

	/* undo a deletion by inserting */
	u.type = Insert;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = p0;
	u.n = p1-p0;
	buf = fbufalloc();
	for(i=p0; i&lt;p1; i+=n){
		n = p1 - i;
		if(n &gt; RBUFSIZE)
			n = RBUFSIZE;
		bufread(f, i, buf, n);
		bufinsert(delta, delta-&gt;nc, buf, n);
	}
	fbuffree(buf);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);

}

int
filereadc(File *f, uint q)
{
	Rune r;

	if(q &gt;= f-&gt;nc)
		return -1;
	bufread(f, q, &amp;r, 1);
	return r;
}

void
filesetname(File *f, String *s)
{
	if(!f-&gt;unread)	/* This is setting initial file name */
		fileunsetname(f, &amp;f-&gt;delta);
	Strduplstr(&amp;f-&gt;name, s);
	sortname(f);
	f-&gt;unread = TRUE;
}

void
fileunsetname(File *f, Buffer *delta)
{
	String s;
	Undo u;

	/* undo a file name change by restoring old name */
	u.type = Filename;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = 0;	/* unused */
	Strinit(&amp;s);
	Strduplstr(&amp;s, &amp;f-&gt;name);
	fullname(&amp;s);
	u.n = s.n;
	if(s.n)
		bufinsert(delta, delta-&gt;nc, s.s, s.n);
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
	Strclose(&amp;s);
}

void
fileunsetdot(File *f, Buffer *delta, Range dot)
{
	Undo u;

	u.type = Dot;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = dot.p1;
	u.n = dot.p2 - dot.p1;
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

void
fileunsetmark(File *f, Buffer *delta, Range mark)
{
	Undo u;

	u.type = Mark;
	u.mod = f-&gt;mod;
	u.seq = f-&gt;seq;
	u.p0 = mark.p1;
	u.n = mark.p2 - mark.p1;
	bufinsert(delta, delta-&gt;nc, (Rune*)&amp;u, Undosize);
}

uint
fileload(File *f, uint p0, int fd, int *nulls)
{
	if(f-&gt;seq &gt; 0)
		panic("undo in file.load unimplemented");
	return bufload(f, p0, fd, nulls);
}

int
fileupdate(File *f, int notrans, int toterm)
{
	uint p1, p2;
	int mod;

	if(f-&gt;rescuing)
		return FALSE;

	flushmerge();

	/*
	 * fix the modification bit
	 * subtle point: don't save it away in the log.
	 *
	 * if another change is made, the correct f-&gt;mod
	 * state is saved  in the undo log by filemark
	 * when setting the dot and mark.
	 *
	 * if the change is undone, the correct state is
	 * saved from f in the fileun... routines.
	 */
	mod = f-&gt;mod;
	f-&gt;mod = f-&gt;prevmod;
	if(f == cmd)
		notrans = TRUE;
	else{
		fileunsetdot(f, &amp;f-&gt;delta, f-&gt;prevdot);
		fileunsetmark(f, &amp;f-&gt;delta, f-&gt;prevmark);
	}
	f-&gt;dot = f-&gt;ndot;
	fileundo(f, FALSE, !notrans, &amp;p1, &amp;p2, toterm);
	f-&gt;mod = mod;

	if(f-&gt;delta.nc == 0)
		f-&gt;seq = 0;

	if(f == cmd)
		return FALSE;

	if(f-&gt;mod){
		f-&gt;closeok = 0;
		quitok = 0;
	}else
		f-&gt;closeok = 1;
	return TRUE;
}

long
prevseq(Buffer *b)
{
	Undo u;
	uint up;

	up = b-&gt;nc;
	if(up == 0)
		return 0;
	up -= Undosize;
	bufread(b, up, (Rune*)&amp;u, Undosize);
	return u.seq;
}

long
undoseq(File *f, int isundo)
{
	if(isundo)
		return f-&gt;seq;

	return prevseq(&amp;f-&gt;epsilon);
}

void
fileundo(File *f, int isundo, int canredo, uint *q0p, uint *q1p, int flag)
{
	Undo u;
	Rune *buf;
	uint i, n, up;
	uint stop;
	Buffer *delta, *epsilon;

	if(isundo){
		/* undo; reverse delta onto epsilon, seq decreases */
		delta = &amp;f-&gt;delta;
		epsilon = &amp;f-&gt;epsilon;
		stop = f-&gt;seq;
	}else{
		/* redo; reverse epsilon onto delta, seq increases */
		delta = &amp;f-&gt;epsilon;
		epsilon = &amp;f-&gt;delta;
		stop = 0;	/* don't know yet */
	}

	raspstart(f);
	while(delta-&gt;nc &gt; 0){
		/* rasp and buffer are in sync; sync with wire if needed */
		if(needoutflush())
			raspflush(f);
		up = delta-&gt;nc-Undosize;
		bufread(delta, up, (Rune*)&amp;u, Undosize);
		if(isundo){
			if(u.seq &lt; stop){
				f-&gt;seq = u.seq;
				raspdone(f, flag);
				return;
			}
		}else{
			if(stop == 0)
				stop = u.seq;
			if(u.seq &gt; stop){
				raspdone(f, flag);
				return;
			}
		}
		switch(u.type){
		default:
			panic("undo unknown u.type");
			break;

		case Delete:
			f-&gt;seq = u.seq;
			if(canredo)
				fileundelete(f, epsilon, u.p0, u.p0+u.n);
			f-&gt;mod = u.mod;
			bufdelete(f, u.p0, u.p0+u.n);
			raspdelete(f, u.p0, u.p0+u.n, flag);
			*q0p = u.p0;
			*q1p = u.p0;
			break;

		case Insert:
			f-&gt;seq = u.seq;
			if(canredo)
				fileuninsert(f, epsilon, u.p0, u.n);
			f-&gt;mod = u.mod;
			up -= u.n;
			buf = fbufalloc();
			for(i=0; i&lt;u.n; i+=n){
				n = u.n - i;
				if(n &gt; RBUFSIZE)
					n = RBUFSIZE;
				bufread(delta, up+i, buf, n);
				bufinsert(f, u.p0+i, buf, n);
				raspinsert(f, u.p0+i, buf, n, flag);
			}
			fbuffree(buf);
			*q0p = u.p0;
			*q1p = u.p0+u.n;
			break;

		case Filename:
			f-&gt;seq = u.seq;
			if(canredo)
				fileunsetname(f, epsilon);
			f-&gt;mod = u.mod;
			up -= u.n;

			Strinsure(&amp;f-&gt;name, u.n+1);
			bufread(delta, up, f-&gt;name.s, u.n);
			f-&gt;name.s[u.n] = 0;
			f-&gt;name.n = u.n;
			fixname(&amp;f-&gt;name);
			sortname(f);
			break;
		case Dot:
			f-&gt;seq = u.seq;
			if(canredo)
				fileunsetdot(f, epsilon, f-&gt;dot.r);
			f-&gt;mod = u.mod;
			f-&gt;dot.r.p1 = u.p0;
			f-&gt;dot.r.p2 = u.p0 + u.n;
			break;
		case Mark:
			f-&gt;seq = u.seq;
			if(canredo)
				fileunsetmark(f, epsilon, f-&gt;mark);
			f-&gt;mod = u.mod;
			f-&gt;mark.p1 = u.p0;
			f-&gt;mark.p2 = u.p0 + u.n;
			break;
		}
		bufdelete(delta, up, delta-&gt;nc);
	}
	if(isundo)
		f-&gt;seq = 0;
	raspdone(f, flag);
}

void
filereset(File *f)
{
	bufreset(&amp;f-&gt;delta);
	bufreset(&amp;f-&gt;epsilon);
	f-&gt;seq = 0;
}

void
fileclose(File *f)
{
	Strclose(&amp;f-&gt;name);
	bufclose(f);
	bufclose(&amp;f-&gt;delta);
	bufclose(&amp;f-&gt;epsilon);
	if(f-&gt;rasp)
		listfree(f-&gt;rasp);
	free(f);
}

void
filemark(File *f)
{

	if(f-&gt;unread)
		return;
	if(f-&gt;epsilon.nc)
		bufdelete(&amp;f-&gt;epsilon, 0, f-&gt;epsilon.nc);

	if(f != cmd){
		f-&gt;prevdot = f-&gt;dot.r;
		f-&gt;prevmark = f-&gt;mark;
		f-&gt;prevseq = f-&gt;seq;
		f-&gt;prevmod = f-&gt;mod;
	}

	f-&gt;ndot = f-&gt;dot;
	f-&gt;seq = seq;
	f-&gt;hiposn = 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

