<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/moveto.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/moveto.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"

void
moveto(File *f, Range r)
{
	Posn p1 = r.p1, p2 = r.p2;

	f-&gt;dot.r.p1 = p1;
	f-&gt;dot.r.p2 = p2;
	if(f-&gt;rasp){
		telldot(f);
		outTsl(Hmoveto, f-&gt;tag, f-&gt;dot.r.p1);
	}
}

void
telldot(File *f)
{
	if(f-&gt;rasp == 0)
		panic("telldot");
	if(f-&gt;dot.r.p1==f-&gt;tdot.p1 &amp;&amp; f-&gt;dot.r.p2==f-&gt;tdot.p2)
		return;
	outTsll(Hsetdot, f-&gt;tag, f-&gt;dot.r.p1, f-&gt;dot.r.p2);
	f-&gt;tdot = f-&gt;dot.r;
}

void
tellpat(void)
{
	outTS(Hsetpat, &amp;lastpat);
	patset = FALSE;
}

#define	CHARSHIFT	128

void
lookorigin(File *f, Posn p0, Posn ls)
{
	int nl, nc, c;
	Posn p, oldp0;

	if(p0 &gt; f-&gt;nc)
		p0 = f-&gt;nc;
	oldp0 = p0;
	p = p0;
	for(nl=nc=c=0; c!=-1 &amp;&amp; nl&lt;ls &amp;&amp; nc&lt;ls*CHARSHIFT; nc++)
		if((c=filereadc(f, --p)) == '\n'){
			nl++;
			oldp0 = p0-nc;
		}
	if(c == -1)
		p0 = 0;
	else if(nl==0){
		if(p0&gt;=CHARSHIFT/2)
			p0-=CHARSHIFT/2;
		else
			p0 = 0;
	}else
		p0 = oldp0;
	outTsl(Horigin, f-&gt;tag, p0);
}

int
alnum(int c)
{
	/*
	 * Hard to get absolutely right.  Use what we know about ASCII
	 * and assume anything above the Latin control characters is
	 * potentially an alphanumeric.
	 */
	if(c&lt;=' ')
		return 0;
	if(0x7F&lt;=c &amp;&amp; c&lt;=0xA0)
		return 0;
	if(utfrune("!\"#$%&amp;'()*+,-./:;&lt;=&gt;?@[\\]^`{|}~", c))
		return 0;
	return 1;
}

int
clickmatch(File *f, int cl, int cr, int dir, Posn *p)
{
	int c;
	int nest = 1;

	for(;;){
		if(dir &gt; 0){
			if(*p &gt;= f-&gt;nc)
				break;
			c = filereadc(f, (*p)++);
		}else{
			if(*p == 0)
				break;
			c = filereadc(f, --(*p));
		}
		if(c == cr){
			if(--nest==0)
				return 1;
		}else if(c == cl)
			nest++;
	}
	return cl=='\n' &amp;&amp; nest==1;
}

Rune*
strrune(Rune *s, Rune c)
{
	Rune c1;

	if(c == 0) {
		while(*s++)
			;
		return s-1;
	}

	while(c1 = *s++)
		if(c1 == c)
			return s-1;
	return 0;
}

void
doubleclick(File *f, Posn p1)
{
	int c, i;
	Rune *r, *l;
	Posn p;

	if(p1 &gt; f-&gt;nc)
		return;
	f-&gt;dot.r.p1 = f-&gt;dot.r.p2 = p1;
	for(i=0; left[i]; i++){
		l = left[i];
		r = right[i];
		/* try left match */
		p = p1;
		if(p1 == 0)
			c = '\n';
		else
			c = filereadc(f, p - 1);
		if(strrune(l, c)){
			if(clickmatch(f, c, r[strrune(l, c)-l], 1, &amp;p)){
				f-&gt;dot.r.p1 = p1;
				f-&gt;dot.r.p2 = p-(c!='\n');
			}
			return;
		}
		/* try right match */
		p = p1;
		if(p1 == f-&gt;nc)
			c = '\n';
		else
			c = filereadc(f, p);
		if(strrune(r, c)){
			if(clickmatch(f, c, l[strrune(r, c)-r], -1, &amp;p)){
				f-&gt;dot.r.p1 = p;
				if(c!='\n' || p!=0 || filereadc(f, 0)=='\n')
					f-&gt;dot.r.p1++;
				f-&gt;dot.r.p2 = p1+(p1&lt;f-&gt;nc &amp;&amp; c=='\n');
			}
			return;
		}
	}
	/* try filling out word to right */
	p = p1;
	while(p &lt; f-&gt;nc &amp;&amp; alnum(filereadc(f, p++)))
		f-&gt;dot.r.p2++;
	/* try filling out word to left */
	p = p1;
	while(--p &gt;= 0 &amp;&amp; alnum(filereadc(f, p)))
		f-&gt;dot.r.p1--;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

