<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sam/string.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sam/string.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "sam.h"

#define	MINSIZE	16		/* minimum number of chars allocated */
#define	MAXSIZE	256		/* maximum number of chars for an empty string */


void
Strinit(String *p)
{
	p-&gt;s = emalloc(MINSIZE*RUNESIZE);
	p-&gt;n = 0;
	p-&gt;size = MINSIZE;
}

void
Strinit0(String *p)
{
	p-&gt;s = emalloc(MINSIZE*RUNESIZE);
	p-&gt;s[0] = 0;
	p-&gt;n = 1;
	p-&gt;size = MINSIZE;
}

void
Strclose(String *p)
{
	free(p-&gt;s);
}

void
Strzero(String *p)
{
	if(p-&gt;size &gt; MAXSIZE){
		p-&gt;s = erealloc(p-&gt;s, RUNESIZE*MAXSIZE); /* throw away the garbage */
		p-&gt;size = MAXSIZE;
	}
	p-&gt;n = 0;
}

int
Strlen(Rune *r)
{
	Rune *s;

	for(s=r; *s; s++)
		;
	return s-r;
}

void
Strdupl(String *p, Rune *s)	/* copies the null */
{
	p-&gt;n = Strlen(s)+1;
	Strinsure(p, p-&gt;n);
	memmove(p-&gt;s, s, p-&gt;n*RUNESIZE);
}

void
Strduplstr(String *p, String *q)	/* will copy the null if there's one there */
{
	Strinsure(p, q-&gt;n);
	p-&gt;n = q-&gt;n;
	memmove(p-&gt;s, q-&gt;s, q-&gt;n*RUNESIZE);
}

void
Straddc(String *p, int c)
{
	Strinsure(p, p-&gt;n+1);
	p-&gt;s[p-&gt;n++] = c;
}

void
Strinsure(String *p, ulong n)
{
	if(n &gt; STRSIZE)
		error(Etoolong);
	if(p-&gt;size &lt; n){	/* p needs to grow */
		n += 100;
		p-&gt;s = erealloc(p-&gt;s, n*RUNESIZE);
		p-&gt;size = n;
	}
}

void
Strinsert(String *p, String *q, Posn p0)
{
	Strinsure(p, p-&gt;n+q-&gt;n);
	memmove(p-&gt;s+p0+q-&gt;n, p-&gt;s+p0, (p-&gt;n-p0)*RUNESIZE);
	memmove(p-&gt;s+p0, q-&gt;s, q-&gt;n*RUNESIZE);
	p-&gt;n += q-&gt;n;
}

void
Strdelete(String *p, Posn p1, Posn p2)
{
	memmove(p-&gt;s+p1, p-&gt;s+p2, (p-&gt;n-p2)*RUNESIZE);
	p-&gt;n -= p2-p1;
}

int
Strcmp(String *a, String *b)
{
	int i, c;

	for(i=0; i&lt;a-&gt;n &amp;&amp; i&lt;b-&gt;n; i++)
		if(c = (a-&gt;s[i] - b-&gt;s[i]))	/* assign = */
			return c;
	/* damn NULs confuse everything */
	i = a-&gt;n - b-&gt;n;
	if(i == 1){
		if(a-&gt;s[a-&gt;n-1] == 0)
			return 0;
	}else if(i == -1){
		if(b-&gt;s[b-&gt;n-1] == 0)
			return 0;
	}
	return i;
}

int
Strispre(String *a, String *b)
{
	int i;

	for(i=0; i&lt;a-&gt;n &amp;&amp; i&lt;b-&gt;n; i++){
		if(a-&gt;s[i] - b-&gt;s[i]){	/* assign = */
			if(a-&gt;s[i] == 0)
				return 1;
			return 0;
		}
	}
	return i == a-&gt;n;
}

char*
Strtoc(String *s)
{
	int i;
	char *c, *d;
	Rune *r;
	c = emalloc(s-&gt;n*UTFmax + 1);  /* worst case UTFmax bytes per rune, plus NUL */
	d = c;
	r = s-&gt;s;
	for(i=0; i&lt;s-&gt;n; i++)
		d += runetochar(d, r++);
	if(d==c || d[-1]!=0)
		*d = 0;
	return c;

}

/*
 * Build very temporary String from Rune*
 */
String*
tmprstr(Rune *r, int n)
{
	static String p;

	p.s = r;
	p.n = n;
	p.size = n;
	return &amp;p;
}

/*
 * Convert null-terminated char* into String
 */
String*
tmpcstr(char *s)
{
	String *p;
	Rune *r;
	int i, n;

	n = utflen(s);	/* don't include NUL */
	p = emalloc(sizeof(String));
	r = emalloc(n*RUNESIZE);
	p-&gt;s = r;
	for(i=0; i&lt;n; i++,r++)
		s += chartorune(r, s);
	p-&gt;n = n;
	p-&gt;size = n;
	return p;
}

void
freetmpstr(String *s)
{
	free(s-&gt;s);
	free(s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

