<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/samterm/io.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/samterm/io.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;frame.h&gt;
#include "flayer.h"
#include "samterm.h"

int	cursorfd;
int	plumbfd = -1;
int	input;
int	got;
int	block;
int	kbdc;
int	resized;
uchar	*hostp;
uchar	*hoststop;
uchar	*plumbbase;
uchar	*plumbp;
uchar	*plumbstop;
Channel	*plumbc;
Channel	*hostc;
Mousectl	*mousectl;
Mouse	*mousep;
Keyboardctl *keyboardctl;
void	panic(char*);

void
initio(void)
{
	threadsetname("main");
	mousectl = initmouse(nil, display-&gt;image);
	if(mousectl == nil){
		fprint(2, "samterm: mouse init failed: %r\n");
		threadexitsall("mouse");
	}
	mousep = mousectl;
	keyboardctl = initkeyboard(nil);
	if(keyboardctl == nil){
		fprint(2, "samterm: keyboard init failed: %r\n");
		threadexitsall("kbd");
	}
	hoststart();
	if(plumbstart() &lt; 0)
		extstart();
}

void
getmouse(void)
{
	if(readmouse(mousectl) &lt; 0)
		panic("mouse");
}

void
mouseunblock(void)
{
	got &amp;= ~(1&lt;&lt;RMouse);
}

void
kbdblock(void)
{		/* ca suffit */
	block = (1&lt;&lt;RKeyboard)|(1&lt;&lt;RPlumb);
}

int
button(int but)
{
	getmouse();
	return mousep-&gt;buttons&amp;(1&lt;&lt;(but-1));
}

void
externload(int i)
{
	plumbbase = malloc(plumbbuf[i].n);
	if(plumbbase == 0)
		return;
	memmove(plumbbase, plumbbuf[i].data, plumbbuf[i].n);
	plumbp = plumbbase;
	plumbstop = plumbbase + plumbbuf[i].n;
	got |= 1&lt;&lt;RPlumb;
}

int
waitforio(void)
{
	Alt alts[NRes+1];
	Rune r;
	int i;
	ulong type;

again:

	alts[RPlumb].c = plumbc;
	alts[RPlumb].v = &amp;i;
	alts[RPlumb].op = CHANRCV;
	if((block &amp; (1&lt;&lt;RPlumb)) || plumbc == nil)
		alts[RPlumb].op = CHANNOP;

	alts[RHost].c = hostc;
	alts[RHost].v = &amp;i;
	alts[RHost].op = CHANRCV;
	if(block &amp; (1&lt;&lt;RHost))
		alts[RHost].op = CHANNOP;

	alts[RKeyboard].c = keyboardctl-&gt;c;
	alts[RKeyboard].v = &amp;r;
	alts[RKeyboard].op = CHANRCV;
	if(block &amp; (1&lt;&lt;RKeyboard))
		alts[RKeyboard].op = CHANNOP;

	alts[RMouse].c = mousectl-&gt;c;
	alts[RMouse].v = &amp;mousectl-&gt;Mouse;
	alts[RMouse].op = CHANRCV;
	if(block &amp; (1&lt;&lt;RMouse))
		alts[RMouse].op = CHANNOP;

	alts[RResize].c = mousectl-&gt;resizec;
	alts[RResize].v = nil;
	alts[RResize].op = CHANRCV;
	if(block &amp; (1&lt;&lt;RResize))
		alts[RResize].op = CHANNOP;

	alts[NRes].op = CHANEND;

	if(got &amp; ~block)
		return got &amp; ~block;
	flushimage(display, 1);
	type = alt(alts);
	switch(type){
	case RHost:
		hostp = hostbuf[i].data;
		hoststop = hostbuf[i].data + hostbuf[i].n;
		block = 0;
		break;
	case RPlumb:
		externload(i);
		break;
	case RKeyboard:
		kbdc = r;
		break;
	case RMouse:
		break;
	case RResize:
		resized = 1;
		/* do the resize in line if we've finished initializing and we're not in a blocking state */
		if(hasunlocked &amp;&amp; block==0 &amp;&amp; RESIZED())
			resize();
		goto again;
	}
	got |= 1&lt;&lt;type;
	return got; 
}

int
rcvchar(void)
{
	int c;

	if(!(got &amp; (1&lt;&lt;RHost)))
		return -1;
	c = *hostp++;
	if(hostp == hoststop)
		got &amp;= ~(1&lt;&lt;RHost);
	return c;
}

char*
rcvstring(void)
{
	*hoststop = 0;
	got &amp;= ~(1&lt;&lt;RHost);
	return (char*)hostp;
}

int
getch(void)
{
	int c;

	while((c = rcvchar()) == -1){
		block = ~(1&lt;&lt;RHost);
		waitforio();
		block = 0;
	}
	return c;
}

int
externchar(void)
{
	Rune r;

    loop:
	if(got &amp; ((1&lt;&lt;RPlumb) &amp; ~block)){
		plumbp += chartorune(&amp;r, (char*)plumbp);
		if(plumbp &gt;= plumbstop){
			got &amp;= ~(1&lt;&lt;RPlumb);
			free(plumbbase);
		}
		if(r == 0)
			goto loop;
		return r;
	}
	return -1;
}

int kpeekc = -1;
int
ecankbd(void)
{
	Rune r;

	if(kpeekc &gt;= 0)
		return 1;
	if(nbrecv(keyboardctl-&gt;c, &amp;r) &gt; 0){
		kpeekc = r;
		return 1;
	}
	return 0;
}

int
ekbd(void)
{
	int c;
	Rune r;

	if(kpeekc &gt;= 0){
		c = kpeekc;
		kpeekc = -1;
		return c;
	}
	if(recv(keyboardctl-&gt;c, &amp;r) &lt; 0){
		fprint(2, "samterm: keybard recv error: %r\n");
		panic("kbd");
	}
	return r;
}

int
kbdchar(void)
{
	int c, i;

	c = externchar();
	if(c &gt; 0)
		return c;
	if(got &amp; (1&lt;&lt;RKeyboard)){
		c = kbdc;
		kbdc = -1;
		got &amp;= ~(1&lt;&lt;RKeyboard);
		return c;
	}
	while(plumbc!=nil &amp;&amp; nbrecv(plumbc, &amp;i)&gt;0){
		externload(i);
		c = externchar();
		if(c &gt; 0)
			return c;
	}
	if(!ecankbd())
		return -1;
	return ekbd();
}

int
qpeekc(void)
{
	return kbdc;
}

int
RESIZED(void)
{
	if(resized){
		if(getwindow(display, Refnone) &lt; 0)
			panic("can't reattach to window");
		resized = 0;
		return 1;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

