<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/image.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/image.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;
#include	"sky.h"

char	rad28[] = "0123456789abcdefghijklmnopqr";

Picture*
image(Angle ra, Angle dec, Angle wid, Angle hig)
{
	Pix *p;
	uchar *b, *up;
	int i, j, sx, sy, x, y;
	char file[50];
	Picture *pic;
	Img* ip;
	int lowx, lowy, higx, higy;
	int slowx, slowy, shigx, shigy;
	Header *h;
	Angle d, bd;
	Plate *pp, *bp;

	if(gam.gamma == 0)
		gam.gamma = -1;
	if(gam.max == gam.min) {
		gam.max = 17600;
		gam.min = 2500;
	}
	gam.absgamma = gam.gamma;
	gam.neg = 0;
	if(gam.absgamma &lt; 0) {
		gam.absgamma = -gam.absgamma;
		gam.neg = 1;
	}
	gam.mult1 = 1. / (gam.max - gam.min);
	gam.mult2 = 255. * gam.mult1;

	if(nplate == 0)
		getplates();

	bp = 0;
	bd = 0;
	for(i=0; i&lt;nplate; i++) {
		pp = &amp;plate[i];
		d = dist(ra, dec, pp-&gt;ra, pp-&gt;dec);
		if(bp == 0 || d &lt; bd) {
			bp = pp;
			bd = d;
		}
	}

	if(debug)
		Bprint(&amp;bout, "best plate: %s %s disk %d %s\n",
			hms(bp-&gt;ra), dms(bp-&gt;dec),
			bp-&gt;disk, bp-&gt;rgn);

	h = getheader(bp-&gt;rgn);
	xypos(h, ra, dec, 0, 0);
	if(wid &lt;= 0 || hig &lt;= 0) {
		lowx = h-&gt;x;
		lowy = h-&gt;y;
		lowx = (lowx/500) * 500;
		lowy = (lowy/500) * 500;
		higx = lowx + 500;
		higy = lowy + 500;
	} else {
		lowx = h-&gt;x - wid*ARCSECONDS_PER_RADIAN*1000 /
			(h-&gt;param[Pxpixelsz]*h-&gt;param[Ppltscale]*2);
		lowy = h-&gt;y - hig*ARCSECONDS_PER_RADIAN*1000 /
			(h-&gt;param[Pypixelsz]*h-&gt;param[Ppltscale]*2);
		higx = h-&gt;x + wid*ARCSECONDS_PER_RADIAN*1000 /
			(h-&gt;param[Pxpixelsz]*h-&gt;param[Ppltscale]*2);
		higy = h-&gt;y + hig*ARCSECONDS_PER_RADIAN*1000 /
			(h-&gt;param[Pypixelsz]*h-&gt;param[Ppltscale]*2);
	}
	free(h);

	if(lowx &lt; 0) lowx = 0;
	if(higx &lt; 0) higx = 0;
	if(lowy &lt; 0) lowy = 0;
	if(higy &lt; 0) higy = 0;
	if(lowx &gt; 14000) lowx = 14000;
	if(higx &gt; 14000) higx = 14000;
	if(lowy &gt; 14000) lowy = 14000;
	if(higy &gt; 14000) higy = 14000;

	if(debug)
		Bprint(&amp;bout, "xy on plate: %d,%d %d,%d\n",
			lowx,lowy, higx, higy);

	if(lowx &gt;= higx || lowy &gt;=higy) {
		Bprint(&amp;bout, "no image found\n");
		return 0;
	}

	b = malloc((higx-lowx)*(higy-lowy)*sizeof(*b));
	if(b == 0) {
 emalloc:
		fprint(2, "malloc error\n");
		return 0;
	}
	memset(b, 0, (higx-lowx)*(higy-lowy)*sizeof(*b));

	slowx = lowx/500;
	shigx = (higx-1)/500;
	slowy = lowy/500;
	shigy = (higy-1)/500;

	for(sx=slowx; sx&lt;=shigx; sx++)
	for(sy=slowy; sy&lt;=shigy; sy++) {
		if(sx &lt; 0 || sx &gt;= nelem(rad28) || sy &lt; 0 || sy &gt;= nelem(rad28)) {
			fprint(2, "bad subplate %d %d\n", sy, sx);
			free(b);
			return 0;
		}
		sprint(file, "%s/%s/%s.%c%c",
			dssmount(bp-&gt;disk),
			bp-&gt;rgn, bp-&gt;rgn,
			rad28[sy],
			rad28[sx]);

		ip = dssread(file);
		if(ip == 0) {
			fprint(2, "can't read %s: %r\n", file);
			free(b);
			return 0;
		}

		x = sx*500;
		y = sy*500;
		for(j=0; j&lt;ip-&gt;ny; j++) {
			if(y+j &lt; lowy || y+j &gt;= higy)
				continue;
			p = &amp;ip-&gt;a[j*ip-&gt;ny];
			up = b + (higy - (y+j+1))*(higx-lowx) + (x - lowx);
			for(i=0; i&lt;ip-&gt;nx; i++) {
				if(x+i &gt;= lowx &amp;&amp; x+i &lt; higx)
					*up = dogamma(*p);
				up++;
				p += 1;
			}
		}
		free(ip);
	}

	pic = malloc(sizeof(Picture));
	if(pic == 0){
		free(b);
		goto emalloc;
	}
	pic-&gt;minx = lowx;
	pic-&gt;miny = lowy;
	pic-&gt;maxx = higx;
	pic-&gt;maxy = higy;
	pic-&gt;data = b;
	strcpy(pic-&gt;name, bp-&gt;rgn);
	return pic;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

