<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/patch.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/patch.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include	&lt;bio.h&gt;
#include "sky.h"

/*
 * dec varies from -89 to 89, inclusive.
 * ra varies depending on dec; each patch is about 1 square degree.
 *
 * Northern hemisphere (0&lt;=dec&lt;=89):
 *	from  0&lt;=dec&lt;=59, ra is every 4m,  360 values
 *	from 60&lt;=dec&lt;=69, ra is every 8m,  180 values
 *	from 70&lt;=dec&lt;=79, ra is every 12m, 120 values
 *	from 80&lt;=dec&lt;=84, ra is every 24m,  60 values
 *	at dec=85 and 86, ra is every 48m,  30 values
 *	at dec=87,        ra is every 60m,  24 values
 *	at dec=88,        ra is every 120m, 12 values
 *	at dec=89,        ra is 12h,	     1 value
 *
 * Total number of patches in northern hemisphere is therefore:
 * 	360*60+180*10+120*10+60*5+30*2+24*1+12*1+1 = 24997
 * Total number of patches is therefore
 *	2*24997-360 = 49634	(dec=0 has been counted twice)
 * (cf. 41253 square degrees in the sky)
 */

void
radec(int p, int *rah, int *ram, int *deg)
{
	*deg = (p&amp;255)-90;
	p &gt;&gt;= 8;
	*rah = p/15;
	*ram = (p%15)*4;
	if(*deg&lt;0)
		(*deg)++;
}

long
patcha(Angle ra, Angle dec)
{
	ra = DEG(ra);
	dec = DEG(dec);
	if(dec &gt;= 0)
		return patch(floor(ra/15), ((int)floor(ra*4))%60, floor(dec));
	dec = -dec;
	return patch(floor(ra/15), ((int)floor(ra*4))%60, -floor(dec));
}

char round[91]={	/* extra 0 is to offset the array */
	/*  0 */    0,	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 10 */	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 20 */	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 30 */	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 40 */	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 50 */	 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
	/* 60 */	 2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
	/* 70 */	 3,  3,  3,  3,  3,  3,  3,  3,  3,  3,
	/* 80 */	 6,  6,  6,  6,  6, 12, 12, 15, 30, -1,
	/* 90 */
};

long
patch(int rah, int ram, int deg)
{
	int ra, dec;

	/*
	 * patches go from lower limit &lt;= position &lt; upper limit.
	 * therefore dec ' " can be ignored; always inc. dec degrees.
	 * the computed angle is then the upper limit (ignoring sign).
	 * when done, +ve values are shifted down so 90 (0 degrees) is a value;
	 */
	if(rah&lt;0 || rah&gt;=24 || ram&lt;0 || abs(deg)&gt;=90){
		fprint(2, "scat: patch: bad ra or dec %dh%dm %d\n", rah, ram, deg);
		abort();
	}
	if(deg &lt; 0)
		deg--;
	else if(deg &lt; 90)
		deg++;
	dec = deg+90;
	deg = abs(deg);
	if(deg&lt;1 || deg&gt;90){
		fprint(2, "scat: patch: panic %dh%dm %d\n", rah, ram, deg);
		abort();
	}
	if(deg == 90)
		ra = 180;
	else{
		ra = 15*rah+ram/4;
		ra -= ra%round[deg];
	}
	/* close the hole at 0 */
	if(dec &gt; 90)
		--dec;
	if(ra &gt;= 360)
		ra -= 360;
	return (ra&lt;&lt;8)|dec;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

