<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/posn.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/posn.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;bio.h&gt;
#include	"sky.h"

void
amdinv(Header *h, Angle ra, Angle dec, float mag, float col)
{
	int i, max_iterations;
	float tolerance;
	float object_x, object_y, delta_x, delta_y, f, fx, fy, g, gx, gy;
	float x1, x2, x3, x4;
	float y1, y2, y3, y4;

	/*
	 *  Initialize
	 */
	max_iterations = 50;
	tolerance = 0.0000005;

	/*
	 *  Convert RA and Dec to St.coords
	 */
	traneqstd(h, ra, dec);

	/*
	 *  Set initial value for x,y
	 */
	object_x = h-&gt;xi/h-&gt;param[Ppltscale];
	object_y = h-&gt;eta/h-&gt;param[Ppltscale];

	/*
	 *  Iterate by Newtons method
	 */
	for(i = 0; i &lt; max_iterations; i++) {
		/*
		 *  X plate model
		 */
		x1 = object_x;
		x2 = x1 * object_x;
		x3 = x1 * object_x;
		x4 = x1 * object_x;

		y1 = object_y;
		y2 = y1 * object_y;
		y3 = y1 * object_y;
		y4 = y1 * object_y;

		f =
			h-&gt;param[Pamdx1] * x1 +
			h-&gt;param[Pamdx2] * y1 +
		 	h-&gt;param[Pamdx3] +
			h-&gt;param[Pamdx4] * x2 +
			h-&gt;param[Pamdx5] * x1*y1 +
			h-&gt;param[Pamdx6] * y2 +
		   	h-&gt;param[Pamdx7] * (x2+y2) +
			h-&gt;param[Pamdx8] * x2*x1 +
			h-&gt;param[Pamdx9] * x2*y1 +
			h-&gt;param[Pamdx10] * x1*y2 +
			h-&gt;param[Pamdx11] * y3 +
			h-&gt;param[Pamdx12] * x1* (x2+y2) +
			h-&gt;param[Pamdx13] * x1 * (x2+y2) * (x2+y2) +
			h-&gt;param[Pamdx14] * mag +
			h-&gt;param[Pamdx15] * mag*mag +
			h-&gt;param[Pamdx16] * mag*mag*mag +
			h-&gt;param[Pamdx17] * mag*x1 +
			h-&gt;param[Pamdx18] * mag * (x2+y2) +
			h-&gt;param[Pamdx19] * mag*x1 * (x2+y2) +
			h-&gt;param[Pamdx20] * col;

		/*
		 *  Derivative of X model wrt x
		 */
		fx =
			h-&gt;param[Pamdx1] +
			h-&gt;param[Pamdx4] * 2*x1 +
			h-&gt;param[Pamdx5] * y1 +
			h-&gt;param[Pamdx7] * 2*x1 +
			h-&gt;param[Pamdx8] * 3*x2 +
			h-&gt;param[Pamdx9] * 2*x1*y1 +
			h-&gt;param[Pamdx10] * y2 +
			h-&gt;param[Pamdx12] * (3*x2+y2) +
			h-&gt;param[Pamdx13] * (5*x4 + 6*x2*y2 + y4) +
			h-&gt;param[Pamdx17] * mag +
			h-&gt;param[Pamdx18] * mag*2*x1 +
			h-&gt;param[Pamdx19] * mag*(3*x2+y2);

		/*
		 *  Derivative of X model wrt y
		 */
		fy =
			h-&gt;param[Pamdx2] +
			h-&gt;param[Pamdx5] * x1 +
			h-&gt;param[Pamdx6] * 2*y1 +
			h-&gt;param[Pamdx7] * 2*y1 +
			h-&gt;param[Pamdx9] * x2 +
			h-&gt;param[Pamdx10] * x1*2*y1 +
			h-&gt;param[Pamdx11] * 3*y2 +
			h-&gt;param[Pamdx12] * 2*x1*y1 +
			h-&gt;param[Pamdx13] * 4*x1*y1* (x2+y2) +
			h-&gt;param[Pamdx18] * mag*2*y1 +
			h-&gt;param[Pamdx19] * mag*2*x1*y1;
		/*
		 *  Y plate model
		 */
		g =
			h-&gt;param[Pamdy1] * y1 +
			h-&gt;param[Pamdy2] * x1 +
			h-&gt;param[Pamdy3] +
			h-&gt;param[Pamdy4] * y2 +
			h-&gt;param[Pamdy5] * y1*x1 +
			h-&gt;param[Pamdy6] * x2 +
			h-&gt;param[Pamdy7] * (x2+y2) +
			h-&gt;param[Pamdy8] * y3 +
			h-&gt;param[Pamdy9] * y2*x1 +
			h-&gt;param[Pamdy10] * y1*x3 +
			h-&gt;param[Pamdy11] * x3 +
			h-&gt;param[Pamdy12] * y1 * (x2+y2) +
			h-&gt;param[Pamdy13] * y1 * (x2+y2) * (x2+y2) +
			h-&gt;param[Pamdy14] * mag +
			h-&gt;param[Pamdy15] * mag*mag +
			h-&gt;param[Pamdy16] * mag*mag*mag +
			h-&gt;param[Pamdy17] * mag*y1 +
			h-&gt;param[Pamdy18] * mag * (x2+y2) +
			h-&gt;param[Pamdy19] * mag*y1 * (x2+y2) +
			h-&gt;param[Pamdy20] * col;

		/*
		 *  Derivative of Y model wrt x
		 */
		gx =
			h-&gt;param[Pamdy2] +
			h-&gt;param[Pamdy5] * y1 +
			h-&gt;param[Pamdy6] * 2*x1 +
			h-&gt;param[Pamdy7] * 2*x1 +
			h-&gt;param[Pamdy9] * y2 +
			h-&gt;param[Pamdy10] * y1*2*x1 +
			h-&gt;param[Pamdy11] * 3*x2 +
			h-&gt;param[Pamdy12] * 2*x1*y1 +
			h-&gt;param[Pamdy13] * 4*x1*y1 * (x2+y2) +
			h-&gt;param[Pamdy18] * mag*2*x1 +
			h-&gt;param[Pamdy19] * mag*y1*2*x1;

		/*
		 *  Derivative of Y model wrt y
		 */
		gy =
			h-&gt;param[Pamdy1] +
			h-&gt;param[Pamdy4] * 2*y1 +
			h-&gt;param[Pamdy5] * x1 +
			h-&gt;param[Pamdy7] * 2*y1 +
			h-&gt;param[Pamdy8] * 3*y2 +
			h-&gt;param[Pamdy9] * 2*y1*x1 +
			h-&gt;param[Pamdy10] * x2 +
			h-&gt;param[Pamdy12] * 3*y2 +
			h-&gt;param[Pamdy13] * (5*y4 + 6*x2*y2 + x4) +
			h-&gt;param[Pamdy17] * mag +
			h-&gt;param[Pamdy18] * mag*2*y1 +
			h-&gt;param[Pamdy19] * mag*(x2 + 3*y2);

		f = f - h-&gt;xi;
		g = g - h-&gt;eta;
		delta_x = (-f*gy+g*fy) / (fx*gy-fy*gx);
		delta_y = (-g*fx+f*gx) / (fx*gy-fy*gx);
		object_x = object_x + delta_x;
		object_y = object_y + delta_y;
		if((fabs(delta_x) &lt; tolerance) &amp;&amp; (fabs(delta_y) &lt; tolerance))
			break;
	}

	/*
	 *  Convert mm from plate center to pixels
	 */
	h-&gt;x = (h-&gt;param[Pppo3]-object_x*1000.0)/h-&gt;param[Pxpixelsz];
	h-&gt;y = (h-&gt;param[Pppo6]+object_y*1000.0)/h-&gt;param[Pypixelsz];
}

void
ppoinv(Header *h, Angle ra, Angle dec)
{

	/*
	 *  Convert RA and Dec to standard coords.
	 */
	traneqstd(h, ra, dec);

	/*
	 *  Convert st.coords from arcsec to radians
	 */
	h-&gt;xi  /= ARCSECONDS_PER_RADIAN;
	h-&gt;eta /= ARCSECONDS_PER_RADIAN;

	/*
	 *  Compute PDS coordinates from solution
	 */
	h-&gt;x =
		h-&gt;param[Pppo1]*h-&gt;xi +
		h-&gt;param[Pppo2]*h-&gt;eta +
		h-&gt;param[Pppo3];
	h-&gt;y =
		h-&gt;param[Pppo4]*h-&gt;xi +
		h-&gt;param[Pppo5]*h-&gt;eta +
		h-&gt;param[Pppo6];
	/*
	 * Convert x,y from microns to pixels
	 */
	h-&gt;x /= h-&gt;param[Pxpixelsz];
	h-&gt;y /= h-&gt;param[Pypixelsz];

}

void
traneqstd(Header *h, Angle object_ra, Angle object_dec)
{
	float div;

	/*
	 *  Find divisor
	 */
	div =
		(sin(object_dec)*sin(h-&gt;param[Ppltdec]) +
		cos(object_dec)*cos(h-&gt;param[Ppltdec]) *
		cos(object_ra - h-&gt;param[Ppltra]));

	/*
	 *  Compute standard coords and convert to arcsec
	 */
	h-&gt;xi = cos(object_dec) *
		sin(object_ra - h-&gt;param[Ppltra]) *
		ARCSECONDS_PER_RADIAN/div;

	h-&gt;eta = (sin(object_dec)*cos(h-&gt;param[Ppltdec])-
		cos(object_dec)*sin(h-&gt;param[Ppltdec])*
		cos(object_ra - h-&gt;param[Ppltra]))*
		ARCSECONDS_PER_RADIAN/div;

}

void
xypos(Header *h, Angle ra, Angle dec, float mag, float col)
{
	if (h-&gt;amdflag) {
		amdinv(h, ra, dec, mag, col);
	} else {
		ppoinv(h, ra, dec);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

