<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/scat.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/scat.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;
#include "sky.h"
#include "strings.c"

enum
{
	NNGC=7840,	/* number of NGC numbers [1..NNGC] */
	NIC = 5386,	/* number of IC numbers */
	NNGCrec=NNGC+NIC,	/* number of records in the NGC catalog (including IC's, starting at NNGC */
	NMrec=122,	/* number of M records */
	NM=110,		/* number of M numbers */
	NAbell=2712,	/* number of records in the Abell catalog */
	NName=1000,	/* number of prose names; estimated maximum (read from editable text file) */
	NBayer=1517,	/* number of bayer entries */
	NSAO=258998,	/* number of SAO stars */
	MAXcon=1932,	/* maximum number of patches in a constellation */
	Ncon=88,	/* number of constellations */
	Npatch=92053,	/* highest patch number */
};

char		ngctype[NNGCrec];
Mindexrec	mindex[NMrec];
Namerec		name[NName];
Bayerec		bayer[NBayer];
long		con[MAXcon];
ushort		conindex[Ncon+1];
long		patchaddr[Npatch+1];

Record	*rec;
Record	*orec;
Record	*cur;

char	*dir=DIR;
int	saodb;
int	ngcdb;
int	abelldb;
int	ngctypedb;
int	mindexdb;
int	namedb;
int	bayerdb;
int	condb;
int	conindexdb;
int	patchdb;
char	parsed[3];
long	nrec;
long	nreca;
long	norec;
long	noreca;

Biobuf	bin;
Biobuf	bout;

main(int argc, char *argv[])
{
	char *line;

	Binit(&amp;bin, 0, OREAD);
	Binit(&amp;bout, 1, OWRITE);
	if(argc != 1)
		dir = argv[1];
	astro("", 1);
	while(line = Brdline(&amp;bin, '\n')){
		line[Blinelen(&amp;bin)-1] = 0;
		lookup(line, 1);
		Bflush(&amp;bout);
	}
	if(display != nil){
		closedisplay(display);
		/* automatic refresh of rio window is triggered by mouse */
		close(open("/dev/mouse", OREAD));
	}
	return 0;
}

void
reset(void)
{
	nrec = 0;
	cur = rec;
}

void
grow(void)
{
	nrec++;
	if(nreca &lt; nrec){
		nreca = nrec+50;
		rec = realloc(rec, nreca*sizeof(Record));
		if(rec == 0){
			fprint(2, "scat: realloc fails\n");
			exits("realloc");
		}
	}
	cur = rec+nrec-1;
}

void
copy(void)
{
	if(noreca &lt; nreca){
		noreca = nreca;
		orec = realloc(orec, nreca*sizeof(Record));
		if(orec == 0){
			fprint(2, "scat: realloc fails\n");
			exits("realloc");
		}
	}
	memmove(orec, rec, nrec*sizeof(Record));
	norec = nrec;
}

int
eopen(char *s)
{
	char buf[128];
	int f;

	sprint(buf, "%s/%s.scat", dir, s);
	f = open(buf, 0);
	if(f&lt;0){
		fprint(2, "scat: can't open %s\n", buf);
		exits("open");
	}
	return f;
}


void
Eread(int f, char *name, void *addr, long n)
{
	if(read(f, addr, n) != n){	/* BUG! */
		fprint(2, "scat: read error on %s\n", name);
		exits("read");
	}
}

char*
skipbl(char *s)
{
	while(*s!=0 &amp;&amp; (*s==' ' || *s=='\t'))
		s++;
	return s;
}

char*
skipstr(char *s, char *t)
{
	while(*s &amp;&amp; *s==*t)
		s++, t++;
	return skipbl(s);
}

/* produce little-endian long at address l */
long
Long(long *l)
{
	uchar *p;

	p = (uchar*)l;
	return (long)p[0]|((long)p[1]&lt;&lt;8)|((long)p[2]&lt;&lt;16)|((long)p[3]&lt;&lt;24);
}

/* produce little-endian long at address l */
int
Short(short *s)
{
	uchar *p;

	p = (uchar*)s;
	return p[0]|(p[1]&lt;&lt;8);
}

void
nameopen(void)
{
	Biobuf b;
	int i;
	char *l, *p;

	if(namedb == 0){
		namedb = eopen("name");
		Binit(&amp;b, namedb, OREAD);
		for(i=0; i&lt;NName; i++){
			l = Brdline(&amp;b, '\n');
			if(l == 0)
				break;
			p = strchr(l, '\t');
			if(p == 0){
		Badformat:
				Bprint(&amp;bout, "warning: name.scat bad format; line %d\n", i+1);
				break;
			}
			*p++ = 0;
			strcpy(name[i].name, l);
			if(strncmp(p, "ngc", 3) == 0)
				name[i].ngc = atoi(p+3);
			else if(strncmp(p, "ic", 2) == 0)
				name[i].ngc = atoi(p+2)+NNGC;
			else if(strncmp(p, "sao", 3) == 0)
				name[i].sao = atoi(p+3);
			else if(strncmp(p, "abell", 5) == 0)
				name[i].abell = atoi(p+5);
			else
				goto Badformat;
		}
		if(i == NName)
			Bprint(&amp;bout, "warning: too many names in name.scat (max %d); extra ignored\n", NName);
		close(namedb);

		bayerdb = eopen("bayer");
		Eread(bayerdb, "bayer", bayer, sizeof bayer);
		close(bayerdb);
		for(i=0; i&lt;NBayer; i++)
			bayer[i].sao = Long(&amp;bayer[i].sao);
	}
}

void
saoopen(void)
{
	if(saodb == 0){
		nameopen();
		saodb = eopen("sao");
	}
}

void
ngcopen(void)
{
	if(ngcdb == 0){
		nameopen();
		ngcdb = eopen("ngc2000");
		ngctypedb = eopen("ngc2000type");
		Eread(ngctypedb, "ngctype", ngctype, sizeof ngctype);
		close(ngctypedb);
	}
}

void
abellopen(void)
{
	/* nothing extra to do with abell: it's directly indexed by number */
	if(abelldb == 0)
		abelldb = eopen("abell");
}

void
patchopen(void)
{
	Biobuf *b;
	long l, m;
	char buf[100];

	if(patchdb == 0){
		patchdb = eopen("patch");
		sprint(buf, "%s/patchindex.scat", dir);
		b = Bopen(buf, OREAD);
		if(b == 0){
			fprint(2, "can't open %s\n", buf);
			exits("open");
		}
		for(m=0,l=0; l&lt;=Npatch; l++)
			patchaddr[l] = m += Bgetc(b)*4;
		Bterm(b);
	}
}

void
mopen(void)
{
	int i;

	if(mindexdb == 0){
		mindexdb = eopen("mindex");
		Eread(mindexdb, "mindex", mindex, sizeof mindex);
		close(mindexdb);
		for(i=0; i&lt;NMrec; i++)
			mindex[i].ngc = Short(&amp;mindex[i].ngc);
	}
}

void
constelopen(void)
{
	int i;

	if(condb == 0){
		condb = eopen("con");
		conindexdb = eopen("conindex");
		Eread(conindexdb, "conindex", conindex, sizeof conindex);
		close(conindexdb);
		for(i=0; i&lt;Ncon+1; i++)
			conindex[i] = Short((short*)&amp;conindex[i]);
	}
}

void
lowercase(char *s)
{
	for(; *s; s++)
		if('A'&lt;=*s &amp;&amp; *s&lt;='Z')
			*s += 'a'-'A';
}

int
loadngc(long index)
{
	static int failed;
	long j;

	ngcopen();
	j = (index-1)*sizeof(NGCrec);
	grow();
	cur-&gt;type = NGC;
	cur-&gt;index = index;
	seek(ngcdb, j, 0);
	/* special case: NGC data may not be available */
	if(read(ngcdb, &amp;cur-&gt;ngc, sizeof(NGCrec)) != sizeof(NGCrec)){
		if(!failed){
			fprint(2, "scat: NGC database not available\n");
			failed++;
		}
		cur-&gt;type = NONGC;
		cur-&gt;ngc.ngc = 0;
		cur-&gt;ngc.ra = 0;
		cur-&gt;ngc.dec = 0;
		cur-&gt;ngc.diam = 0;
		cur-&gt;ngc.mag = 0;
		return 0;
	}
	cur-&gt;ngc.ngc = Short(&amp;cur-&gt;ngc.ngc);
	cur-&gt;ngc.ra = Long(&amp;cur-&gt;ngc.ra);
	cur-&gt;ngc.dec = Long(&amp;cur-&gt;ngc.dec);
	cur-&gt;ngc.diam = Long(&amp;cur-&gt;ngc.diam);
	cur-&gt;ngc.mag = Short(&amp;cur-&gt;ngc.mag);
	return 1;
}

int
loadabell(long index)
{
	long j;

	abellopen();
	j = index-1;
	grow();
	cur-&gt;type = Abell;
	cur-&gt;index = index;
	seek(abelldb, j*sizeof(Abellrec), 0);
	Eread(abelldb, "abell", &amp;cur-&gt;abell, sizeof(Abellrec));
	cur-&gt;abell.abell = Short(&amp;cur-&gt;abell.abell);
	if(cur-&gt;abell.abell != index){
		fprint(2, "bad format in abell catalog\n");
		exits("abell");
	}
	cur-&gt;abell.ra = Long(&amp;cur-&gt;abell.ra);
	cur-&gt;abell.dec = Long(&amp;cur-&gt;abell.dec);
	cur-&gt;abell.glat = Long(&amp;cur-&gt;abell.glat);
	cur-&gt;abell.glong = Long(&amp;cur-&gt;abell.glong);
	cur-&gt;abell.rad = Long(&amp;cur-&gt;abell.rad);
	cur-&gt;abell.mag10 = Short(&amp;cur-&gt;abell.mag10);
	cur-&gt;abell.pop = Short(&amp;cur-&gt;abell.pop);
	cur-&gt;abell.dist = Short(&amp;cur-&gt;abell.dist);
	return 1;
}

int
loadsao(int index)
{
	if(index&lt;=0 || index&gt;NSAO)
		return 0;
	saoopen();
	grow();
	cur-&gt;type = SAO;
	cur-&gt;index = index;
	seek(saodb, (index-1)*sizeof(SAOrec), 0);
	Eread(saodb, "sao", &amp;cur-&gt;sao, sizeof(SAOrec));
	cur-&gt;sao.ra = Long(&amp;cur-&gt;sao.ra);
	cur-&gt;sao.dec = Long(&amp;cur-&gt;sao.dec);
	cur-&gt;sao.dra = Long(&amp;cur-&gt;sao.dra);
	cur-&gt;sao.ddec = Long(&amp;cur-&gt;sao.ddec);
	cur-&gt;sao.mag = Short(&amp;cur-&gt;sao.mag);
	cur-&gt;sao.mpg = Short(&amp;cur-&gt;sao.mpg);
	cur-&gt;sao.hd = Long(&amp;cur-&gt;sao.hd);
	return 1;
}

int
loadplanet(int index, Record *r)
{
	if(index&lt;0 || index&gt;NPlanet || planet[index].name[0]=='\0')
		return 0;
	grow();
	cur-&gt;type = Planet;
	cur-&gt;index = index;
	/* check whether to take new or existing record */
	if(r == nil)
		memmove(&amp;cur-&gt;planet, &amp;planet[index], sizeof(Planetrec));
	else
		memmove(&amp;cur-&gt;planet, &amp;r-&gt;planet, sizeof(Planetrec));
	return 1;
}

int
loadpatch(long index)
{
	int i;

	patchopen();
	if(index&lt;=0 || index&gt;Npatch)
		return 0;
	grow();
	cur-&gt;type = Patch;
	cur-&gt;index = index;
	seek(patchdb, patchaddr[index-1], 0);
	cur-&gt;patch.nkey = (patchaddr[index]-patchaddr[index-1])/4;
	Eread(patchdb, "patch", cur-&gt;patch.key, cur-&gt;patch.nkey*4);
	for(i=0; i&lt;cur-&gt;patch.nkey; i++)
		cur-&gt;patch.key[i] = Long(&amp;cur-&gt;patch.key[i]);
	return 1;
}

int
loadtype(int t)
{
	int i;

	ngcopen();
	for(i=0; i&lt;NNGCrec; i++)
		if(t == (ngctype[i])){
			grow();
			cur-&gt;type = NGCN;
			cur-&gt;index = i+1;
		}
	return 1;
}

void
flatten(void)
{
	int i, j, notflat;
	Record *or;
	long key;

    loop:
	copy();
	reset();
	notflat = 0;
	for(i=0,or=orec; i&lt;norec; i++,or++){
		switch(or-&gt;type){
		default:
			fprint(2, "bad type %d in flatten\n", or-&gt;type);
			break;

		case NONGC:
			break;

		case Planet:
		case Abell:
		case NGC:
		case SAO:
			grow();
			memmove(cur, or, sizeof(Record));
			break;

		case NGCN:
			if(loadngc(or-&gt;index))
				notflat = 1;
			break;

		case NamedSAO:
			loadsao(or-&gt;index);
			notflat = 1;
			break;

		case NamedNGC:
			if(loadngc(or-&gt;index))
				notflat = 1;
			break;

		case NamedAbell:
			loadabell(or-&gt;index);
			notflat = 1;
			break;

		case PatchC:
			loadpatch(or-&gt;index);
			notflat = 1;
			break;

		case Patch:
			for(j=1; j&lt;or-&gt;patch.nkey; j++){
				key = or-&gt;patch.key[j];
				if((key&amp;0x3F) == SAO)
					loadsao((key&gt;&gt;8)&amp;0xFFFFFF);
				else if((key&amp;0x3F) == Abell)
					loadabell((key&gt;&gt;8)&amp;0xFFFFFF);
				else
					loadngc((key&gt;&gt;16)&amp;0xFFFF);
			}
			break;
		}
	}
	if(notflat)
		goto loop;
}

int
ism(int index)
{
	int i;

	for(i=0; i&lt;NMrec; i++)
		if(mindex[i].ngc == index)
			return 1;
	return 0;
}

char*
alpha(char *s, char *t)
{
	int n;

	n = strlen(t);
	if(strncmp(s, t, n)==0 &amp;&amp; (s[n]&lt;'a' || 'z'&lt;s[n]))
		return skipbl(s+n);
	return 0;
	
}

char*
text(char *s, char *t)
{
	int n;

	n = strlen(t);
	if(strncmp(s, t, n)==0 &amp;&amp; (s[n]==0 || s[n]==' ' || s[n]=='\t'))
		return skipbl(s+n);
	return 0;
	
}

int
cull(char *s, int keep, int dobbox)
{
	int i, j, nobj, keepthis;
	Record *or;
	char *t;
	int dogrtr, doless, dom, dosao, dongc, doabell;
	int mgrtr, mless;
	char obj[100];

	memset(obj, 0, sizeof(obj));
	nobj = 0;
	dogrtr = 0;
	doless = 0;
	dom = 0;
	dongc = 0;
	dosao = 0;
	doabell = 0;
	mgrtr = mless= 0;
	if(dobbox)
		goto Cull;
	for(;;){
		if(s[0] == '&gt;'){
			dogrtr = 1;
			mgrtr = 10 * strtod(s+1, &amp;t);
			if(mgrtr==0  &amp;&amp; t==s+1){
				fprint(2, "bad magnitude\n");
				return 0;
			}
			s = skipbl(t);
			continue;
		}
		if(s[0] == '&lt;'){
			doless = 1;
			mless = 10 * strtod(s+1, &amp;t);
			if(mless==0  &amp;&amp; t==s+1){
				fprint(2, "bad magnitude\n");
				return 0;
			}
			s = skipbl(t);
			continue;
		}
		if(t = text(s, "m")){
 			dom = 1;
			s = t;
			continue;
		}
		if(t = text(s, "sao")){
			dosao = 1;
			s = t;
			continue;
		}
		if(t = text(s, "ngc")){
			dongc = 1;
			s = t;
			continue;
		}
		if(t = text(s, "abell")){
			doabell = 1;
			s = t;
			continue;
		}
		for(i=0; names[i].name; i++)
			if(t = alpha(s, names[i].name)){
				if(nobj &gt; 100){
					fprint(2, "too many object types\n");
					return 0;
				}
				obj[nobj++] = names[i].type;
				s = t;
				goto Continue;
			}
		break;
	    Continue:;
	}
	if(*s){
		fprint(2, "syntax error in object list\n");
		return 0;
	}

    Cull:
	flatten();
	copy();
	reset();
	if(dom)
		mopen();
	if(dosao)
		saoopen();
	if(dongc || nobj)
		ngcopen();
	if(doabell)
		abellopen();
	for(i=0,or=orec; i&lt;norec; i++,or++){
		keepthis = !keep;
		if(dobbox &amp;&amp; inbbox(or-&gt;ngc.ra, or-&gt;ngc.dec))
			keepthis = keep;
		if(doless &amp;&amp; or-&gt;ngc.mag &lt;= mless)
			keepthis = keep;
		if(dogrtr &amp;&amp; or-&gt;ngc.mag &gt;= mgrtr)
			keepthis = keep;
		if(dom &amp;&amp; (or-&gt;type==NGC &amp;&amp; ism(or-&gt;ngc.ngc)))
			keepthis = keep;
		if(dongc &amp;&amp; or-&gt;type==NGC)
			keepthis = keep;
		if(doabell &amp;&amp; or-&gt;type==Abell)
			keepthis = keep;
		if(dosao &amp;&amp; or-&gt;type==SAO)
			keepthis = keep;
		for(j=0; j&lt;nobj; j++)
			if(or-&gt;type==NGC &amp;&amp; or-&gt;ngc.type==obj[j])
				keepthis = keep;
		if(keepthis){
			grow();
			memmove(cur, or, sizeof(Record));
		}
	}
	return 1;
}

int
compar(void *va, void *vb)
{
	Record *a=va, *b=vb;

	if(a-&gt;type == b-&gt;type)
		return a-&gt;index - b-&gt;index;
	return a-&gt;type - b-&gt;type;
}

void
sort(void)
{
	int i;
	Record *r, *s;

	if(nrec == 0)
		return;
	qsort(rec, nrec, sizeof(Record), compar);
	r = rec+1;
	s = rec;
	for(i=1; i&lt;nrec; i++,r++){
		/* may have multiple instances of a planet in the scene */
		if(r-&gt;type==s-&gt;type &amp;&amp; r-&gt;index==s-&gt;index &amp;&amp; r-&gt;type!=Planet)
			continue;
		memmove(++s, r, sizeof(Record));
	}
	nrec = (s+1)-rec;
}

char	greekbuf[128];

char*
togreek(char *s)
{
	char *t;
	int i, n;
	Rune r;

	t = greekbuf;
	while(*s){
		for(i=1; i&lt;=24; i++){
			n = strlen(greek[i]);
			if(strncmp(s, greek[i], n)==0 &amp;&amp; (s[n]==' ' || s[n]=='\t')){
				s += n;
				t += runetochar(t, &amp;greeklet[i]);
				goto Cont;
			}
		}
		n = chartorune(&amp;r, s);
		for(i=0; i&lt;n; i++)
			*t++ = *s++;
    Cont:;
	}
	*t = 0;
	return greekbuf;
}

char*
fromgreek(char *s)
{
	char *t;
	int i, n;
	Rune r;

	t = greekbuf;
	while(*s){
		n = chartorune(&amp;r, s);
		for(i=1; i&lt;=24; i++){
			if(r == greeklet[i]){
				strcpy(t, greek[i]);
				t += strlen(greek[i]);
				s += n;
				goto Cont;
			}
		}
		for(i=0; i&lt;n; i++)
			*t++ = *s++;
    Cont:;
	}
	*t = 0;
	return greekbuf;
}

#ifdef OLD
/*
 * Old version
 */
int
coords(int deg)
{
	int i;
	int x, y;
	Record *or;
	long dec, ra, ndec, nra;
	int rdeg;

	flatten();
	copy();
	reset();
	deg *= 2;
	for(i=0,or=orec; i&lt;norec; i++,or++){
		if(or-&gt;type == Planet)	/* must keep it here */
			loadplanet(or-&gt;index, or);
		dec = or-&gt;ngc.dec/MILLIARCSEC;
		ra = or-&gt;ngc.ra/MILLIARCSEC;
		rdeg = deg/cos((dec*PI)/180);
		for(y=-deg; y&lt;=+deg; y++){
			ndec = dec*2+y;
			if(ndec/2&gt;=90 || ndec/2&lt;=-90)
				continue;
			/* fp errors hurt here, so we round 1' to the pole */
			if(ndec &gt;= 0)
				ndec = ndec*500*60*60 + 60000;
			else
				ndec = ndec*500*60*60 - 60000;
			for(x=-rdeg; x&lt;=+rdeg; x++){
				nra = ra*2+x;
				if(nra/2 &lt; 0)
					nra += 360*2;
				if(nra/2 &gt;= 360)
					nra -= 360*2;
				/* fp errors hurt here, so we round up 1' */
				nra = nra/2*MILLIARCSEC + 60000;
				loadpatch(patcha(angle(nra), angle(ndec)));
			}
		}
	}
	sort();
	return 1;
}
#endif

/*
 * New version attempts to match the boundaries of the plot better.
 */
int
coords(int deg)
{
	int i;
	int x, y, xx;
	Record *or;
	long min, circle;
	double factor;

	flatten();
	circle = 360*MILLIARCSEC;
	deg *= MILLIARCSEC;

	/* find center */
	folded = 0;
	bbox(0, 0, 0);
	/* now expand */
	factor = cos(angle((decmax+decmin)/2));
	if(factor &lt; .2)
		factor = .2;
	factor = floor(1/factor);
	folded = 0;
	bbox(factor*deg, deg, 1);
	Bprint(&amp;bout, "%s to ", hms(angle(ramin)));
	Bprint(&amp;bout, "%s\n", hms(angle(ramax)));
	Bprint(&amp;bout, "%s to ", dms(angle(decmin)));
	Bprint(&amp;bout, "%s\n", dms(angle(decmax)));
	copy();
	reset();
	for(i=0,or=orec; i&lt;norec; i++,or++)
		if(or-&gt;type == Planet)	/* must keep it here */
			loadplanet(or-&gt;index, or);
	min = ramin;
	if(ramin &gt; ramax)
		min -= circle;
	for(x=min; x&lt;=ramax; x+=250*60*60){
		xx = x;
		if(xx &lt; 0)
			xx += circle;
		for(y=decmin; y&lt;=decmax; y+=250*60*60)
			if(-circle/4 &lt; y &amp;&amp; y &lt; circle/4)
				loadpatch(patcha(angle(xx), angle(y)));
	}
	sort();
	cull(nil, 1, 1);
	return 1;
}

void
pplate(char *flags)
{
	int i;
	long c;
	int na, rah, ram, d1, d2;
	double r0;
	int ra, dec;
	long ramin, ramax, decmin, decmax;	/* all in degrees */
	Record *r;
	int folded;
	Angle racenter, deccenter, rasize, decsize, a[4];
	Picture *pic;

	rasize = -1.0;
	decsize = -1.0;
	na = 0;
	for(;;){
		while(*flags==' ')
			flags++;
		if(('0'&lt;=*flags &amp;&amp; *flags&lt;='9') || *flags=='+' || *flags=='-'){
			if(na &gt;= 3)
				goto err;
			a[na++] = getra(flags);
			while(*flags &amp;&amp; *flags!=' ')
				flags++;
			continue;
		}
		if(*flags){
	err:
			Bprint(&amp;bout, "syntax error in plate\n");
			return;
		}
		break;
	}
	switch(na){
	case 0:
		break;
	case 1:
		rasize = a[0];
		decsize = rasize;
		break;
	case 2:
		rasize = a[0];
		decsize = a[1];
		break;
	case 3:
	case 4:
		racenter = a[0];
		deccenter = a[1];
		rasize = a[2];
		if(na == 4)
			decsize = a[3];
		else
			decsize = rasize;
		if(rasize&lt;0.0 || decsize&lt;0.0){
			Bprint(&amp;bout, "negative sizes\n");
			return;
		}
		goto done;
	}
	folded = 0;
	/* convert to milliarcsec */
	c = 1000*60*60;
    Again:
	if(nrec == 0){
		Bprint(&amp;bout, "empty\n");
		return;
	}
	ramin = 0x7FFFFFFF;
	ramax = -0x7FFFFFFF;
	decmin = 0x7FFFFFFF;
	decmax = -0x7FFFFFFF;
	for(r=rec,i=0; i&lt;nrec; i++,r++){
		if(r-&gt;type == Patch){
			radec(r-&gt;index, &amp;rah, &amp;ram, &amp;dec);
			ra = 15*rah+ram/4;
			r0 = c/cos(RAD(dec));
			ra *= c;
			dec *= c;
			if(dec == 0)
				d1 = c, d2 = c;
			else if(dec &lt; 0)
				d1 = c, d2 = 0;
			else
				d1 = 0, d2 = c;
		}else if(r-&gt;type==SAO || r-&gt;type==NGC || r-&gt;type==Abell){
			ra = r-&gt;ngc.ra;
			dec = r-&gt;ngc.dec;
			d1 = 0, d2 = 0, r0 = 0;
		}else if(r-&gt;type==NGCN){
			loadngc(r-&gt;index);
			continue;
		}else if(r-&gt;type==NamedSAO){
			loadsao(r-&gt;index);
			continue;
		}else if(r-&gt;type==NamedNGC){
			loadngc(r-&gt;index);
			continue;
		}else if(r-&gt;type==NamedAbell){
			loadabell(r-&gt;index);
			continue;
		}else
			continue;
		if(dec+d2 &gt; decmax)
			decmax = dec+d2;
		if(dec-d1 &lt; decmin)
			decmin = dec-d1;
		if(folded){
			ra -= 180*c;
			if(ra &lt; 0)
				ra += 360*c;
		}
		if(ra+r0 &gt; ramax)
			ramax = ra+r0;
		if(ra &lt; ramin)
			ramin = ra;
	}
	if(!folded &amp;&amp; ramax-ramin&gt;270*c){
		folded = 1;
		goto Again;
	}
	racenter = angle(ramin+(ramax-ramin)/2);
	deccenter = angle(decmin+(decmax-decmin)/2);
	if(rasize&lt;0 || decsize&lt;0){
		rasize = angle(ramax-ramin)*cos(deccenter);
		decsize = angle(decmax-decmin);
	}
    done:
	if(DEG(rasize)&gt;1.1 || DEG(decsize)&gt;1.1){
		Bprint(&amp;bout, "plate too big: %s", ms(rasize));
		Bprint(&amp;bout, " x %s\n", ms(decsize));
		Bprint(&amp;bout, "trimming to 30'x30'\n");
		rasize = RAD(0.5);
		decsize = RAD(0.5);
	}
	Bprint(&amp;bout, "%s %s ", hms(racenter), dms(deccenter));
	Bprint(&amp;bout, "%s", ms(rasize));
	Bprint(&amp;bout, " x %s\n", ms(decsize));
	Bflush(&amp;bout);
	flatten();
	pic = image(racenter, deccenter, rasize, decsize);
	if(pic == 0)
		return;
	Bprint(&amp;bout, "plate %s locn %d %d %d %d\n", pic-&gt;name, pic-&gt;minx, pic-&gt;miny, pic-&gt;maxx, pic-&gt;maxy);
	Bflush(&amp;bout);
	displaypic(pic);
}

void
lookup(char *s, int doreset)
{
	int i, j, k;
	int rah, ram, deg;
	char *starts, *inputline=s, *t, *u;
	Record *r;
	long n;
	double x;
	Angle ra;

	lowercase(s);
	s = skipbl(s);

	if(*s == 0)
		goto Print;

	if(t = alpha(s, "flat")){
		if(*t){
			fprint(2, "flat takes no arguments\n");
			return;
		}
		if(nrec == 0){
			fprint(2, "no records\n");
			return;
		}
		flatten();
		goto Print;
	}

	if(t = alpha(s, "print")){
		if(*t){
			fprint(2, "print takes no arguments\n");
			return;
		}
		for(i=0,r=rec; i&lt;nrec; i++,r++)
			prrec(r);
		return;
	}

	if(t = alpha(s, "add")){
		lookup(t, 0);
		return;
	}

	if(t = alpha(s, "sao")){
		n = strtoul(t, &amp;u, 10);
		if(n&lt;=0 || n&gt;NSAO)
			goto NotFound;
		t = skipbl(u);
		if(*t){
			fprint(2, "syntax error in sao\n");
			return;
		}
		if(doreset)
			reset();
		if(!loadsao(n))
			goto NotFound;
		goto Print;
	}

	if(t = alpha(s, "ngc")){
		n = strtoul(t, &amp;u, 10);
		if(n&lt;=0 || n&gt;NNGC)
			goto NotFound;
		t = skipbl(u);
		if(*t){
			fprint(2, "syntax error in ngc\n");
			return;
		}
		if(doreset)
			reset();
		if(!loadngc(n))
			goto NotFound;
		goto Print;
	}

	if(t = alpha(s, "ic")){
		n = strtoul(t, &amp;u, 10);
		if(n&lt;=0 || n&gt;NIC)
			goto NotFound;
		t = skipbl(u);
		if(*t){
			fprint(2, "syntax error in ic\n");
			return;
		}
		if(doreset)
			reset();
		if(!loadngc(n+NNGC))
			goto NotFound;
		goto Print;
	}

	if(t = alpha(s, "abell")){
		n = strtoul(t, &amp;u, 10);
		if(n&lt;=0 || n&gt;NAbell)
			goto NotFound;
		if(doreset)
			reset();
		if(!loadabell(n))
			goto NotFound;
		goto Print;
	}

	if(t = alpha(s, "m")){
		n = strtoul(t, &amp;u, 10);
		if(n&lt;=0 || n&gt;NM)
			goto NotFound;
		mopen();
		for(j=n-1; mindex[j].m&lt;n; j++)
			;
		if(doreset)
			reset();
		while(mindex[j].m == n){
			if(mindex[j].ngc){
				grow();
				cur-&gt;type = NGCN;
				cur-&gt;index = mindex[j].ngc;
			}
			j++;
		}
		goto Print;
	}

	for(i=1; i&lt;=Ncon; i++)
		if(t = alpha(s, constel[i])){
			if(*t){
				fprint(2, "syntax error in constellation\n");
				return;
			}
			constelopen();
			seek(condb, 4L*conindex[i-1], 0);
			j = conindex[i]-conindex[i-1];
			Eread(condb, "con", con, 4*j);
			if(doreset)
				reset();
			for(k=0; k&lt;j; k++){
				grow();
				cur-&gt;type = PatchC;
				cur-&gt;index = Long(&amp;con[k]);
			}
			goto Print;
		}

	if(t = alpha(s, "expand")){
		n = 0;
		if(*t){
			if(*t&lt;'0' &amp;&amp; '9'&lt;*t){
		Expanderr:
				fprint(2, "syntax error in expand\n");
				return;
			}
			n = strtoul(t, &amp;u, 10);
			t = skipbl(u);
			if(*t)
				goto Expanderr;
		}
		coords(n);
		goto Print;
	}

	if(t = alpha(s, "plot")){
		if(nrec == 0){
			Bprint(&amp;bout, "empty\n");
			return;
		}
		plot(t);
		return;
	}

	if(t = alpha(s, "astro")){
		astro(t, 0);
		return;
	}

	if(t = alpha(s, "plate")){
		pplate(t);
		return;
	}

	if(t = alpha(s, "gamma")){
		while(*t==' ')
			t++;
		u = t;
		x = strtod(t, &amp;u);
		if(u &gt; t)
			gam.gamma = x;
		Bprint(&amp;bout, "%.2f\n", gam.gamma);
		return;
	}

	if(t = alpha(s, "keep")){
		if(!cull(t, 1, 0))
			return;
		goto Print;
	}

	if(t = alpha(s, "drop")){
		if(!cull(t, 0, 0))
			return;
		goto Print;
	}

	for(i=0; planet[i].name[0]; i++){
		if(t = alpha(s, planet[i].name)){
			if(doreset)
				reset();
			loadplanet(i, nil);
			goto Print;
		}
	}

	for(i=0; names[i].name; i++){
		if(t = alpha(s, names[i].name)){
			if(*t){
				fprint(2, "syntax error in type\n");
				return;
			}
			if(doreset)
				reset();
			loadtype(names[i].type);
			goto Print;
		}
	}

	switch(s[0]){
	case '"':
		starts = ++s;
		while(*s != '"')
			if(*s++ == 0){
				fprint(2, "bad star name\n");
				return;
			}
		*s = 0;
		if(doreset)
			reset();
		j = nrec;
		saoopen();
		starts = fromgreek(starts);
		for(i=0; i&lt;NName; i++)
			if(equal(starts, name[i].name)){
				grow();
				if(name[i].sao){
					rec[j].type = NamedSAO;
					rec[j].index = name[i].sao;
				}
				if(name[i].ngc){
					rec[j].type = NamedNGC;
					rec[j].index = name[i].ngc;
				}
				if(name[i].abell){
					rec[j].type = NamedAbell;
					rec[j].index = name[i].abell;
				}
				strcpy(rec[j].named.name, name[i].name);
				j++;
			}
		if(parsename(starts))
			for(i=0; i&lt;NBayer; i++)
				if(bayer[i].name[0]==parsed[0] &amp;&amp;
				  (bayer[i].name[1]==parsed[1] || parsed[1]==0) &amp;&amp;
				   bayer[i].name[2]==parsed[2]){
					grow();
					rec[j].type = NamedSAO;
					rec[j].index = bayer[i].sao;
					strncpy(rec[j].named.name, starts, sizeof(rec[j].named.name));
					j++;
				}
		if(j == 0){
			*s = '"';
			goto NotFound;
		}
		break;

	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
		strtoul(s, &amp;t, 10);
		if(*t != 'h'){
	BadCoords:
			fprint(2, "bad coordinates %s\n", inputline);
			break;
		}
		ra = DEG(getra(s));
		while(*s &amp;&amp; *s!=' ' &amp;&amp; *s!='\t')
			s++;
		rah = ra/15;
		ra = ra-rah*15;
		ram = ra*4;
		deg = strtol(s, &amp;t, 10);
		if(t == s)
			goto BadCoords;
		/* degree sign etc. is optional */
		if((uchar)*t == L'°')
			deg = DEG(getra(s));
		if(doreset)
			reset();
		if(abs(deg)&gt;=90 || rah&gt;=24)
			goto BadCoords;
		if(!loadpatch(patch(rah, ram, deg)))
			goto NotFound;
		break;

	default:
		fprint(2, "unknown command %s\n", inputline);
		return;
	}

    Print:
	if(nrec == 0)
		Bprint(&amp;bout, "empty\n");
	else if(nrec &lt;= 2)
		for(i=0; i&lt;nrec; i++)
			prrec(rec+i);
	else
		Bprint(&amp;bout, "%ld items\n", nrec);
	return;

    NotFound:
	fprint(2, "%s not found\n", inputline);
	return;
}

char *ngctypes[] =
{
[Galaxy] 		"Gx",
[PlanetaryN]	"Pl",
[OpenCl]		"OC",
[GlobularCl]	"Gb",
[DiffuseN]		"Nb",
[NebularCl]	"C+N",
[Asterism]		"Ast",
[Knot]		"Kt",
[Triple]		"***",
[Double]		"D*",
[Single]		"*",
[Uncertain]	"?",
[Nonexistent]	"-",
[Unknown]	" ",
[PlateDefect]	"PD",
};

char*
ngcstring(int d)
{
	if(d&lt;Galaxy || d&gt;PlateDefect)
		return "can't happen";
	return ngctypes[d];
}

short	descindex[NINDEX];

void
printnames(Record *r)
{
	int i, ok, done;

	done = 0;
	for(i=0; i&lt;NName; i++){	/* stupid linear search! */
		ok = 0;
		if(r-&gt;type==SAO &amp;&amp; r-&gt;index==name[i].sao)
			ok = 1;
		if(r-&gt;type==NGC &amp;&amp; r-&gt;ngc.ngc==name[i].ngc)
			ok = 1;
		if(r-&gt;type==Abell &amp;&amp; r-&gt;abell.abell==name[i].abell)
			ok = 1;
		if(ok){
			if(done++ == 0)
				Bprint(&amp;bout, "\t");
			Bprint(&amp;bout, " \"%s\"", togreek(name[i].name));
		}
	}
	if(done)
		Bprint(&amp;bout, "\n");
}

int
equal(char *s1, char *s2)
{
	int c;

	while(*s1){
		if(*s1==' '){
			while(*s1==' ')
				s1++;
			continue;
		}
		while(*s2==' ')
			s2++;
		c=*s2;
		if('A'&lt;=*s2 &amp;&amp; *s2&lt;='Z')
			c^=' ';
		if(*s1!=c)
			return 0;
		s1++, s2++;
	}
	return 1;
}

int
parsename(char *s)
{
	char *blank;
	int i;

	blank = strchr(s, ' ');
	if(blank==0 || strchr(blank+1, ' ') || strlen(blank+1)!=3)
		return 0;
	blank++;
	parsed[0] = parsed[1] = parsed[2] = 0;
	if('0'&lt;=s[0] &amp;&amp; s[0]&lt;='9'){
		i = atoi(s);
		parsed[0] = i;
		if(i &gt; 100)
			return 0;
	}else{
		for(i=1; i&lt;=24; i++)
			if(strncmp(greek[i], s, strlen(greek[i]))==0){
				parsed[0]=100+i;
				goto out;
			}
		return 0;
	    out:
		if('0'&lt;=s[strlen(greek[i])] &amp;&amp; s[strlen(greek[i])]&lt;='9')
			parsed[1]=s[strlen(greek[i])]-'0';
	}
	for(i=1; i&lt;=88; i++)
		if(strcmp(constel[i], blank)==0){
			parsed[2] = i;
			return 1;
		}
	return 0;
}

char*
dist_grp(int dg)
{
	switch(dg){
	default:
		return "unknown";
	case 1:
		return "13.3-14.0";
	case 2:
		return "14.1-14.8";
	case 3:
		return "14.9-15.6";
	case 4:
		return "15.7-16.4";
	case 5:
		return "16.5-17.2";
	case 6:
		return "17.3-18.0";
	case 7:
		return "&gt;18.0";
	}
}

char*
rich_grp(int dg)
{
	switch(dg){
	default:
		return "unknown";
	case 0:
		return "30-40";
	case 1:
		return "50-79";
	case 2:
		return "80-129";
	case 3:
		return "130-199";
	case 4:
		return "200-299";
	case 5:
		return "&gt;=300";
	}
}

char*
nameof(Record *r)
{
	NGCrec *n;
	SAOrec *s;
	Abellrec *a;
	static char buf[128];
	int i;

	switch(r-&gt;type){
	default:
		return nil;
	case SAO:
		s = &amp;r-&gt;sao;
		if(s-&gt;name[0] == 0)
			return nil;
		if(s-&gt;name[0] &gt;= 100){
			i = snprint(buf, sizeof buf, "%C", greeklet[s-&gt;name[0]-100]);
			if(s-&gt;name[1])
				i += snprint(buf+i, sizeof buf-i, "%d", s-&gt;name[1]);
		}else
			i = snprint(buf, sizeof buf, " %d", s-&gt;name[0]);
		snprint(buf+i, sizeof buf-i, " %s", constel[s-&gt;name[2]]);
		break;
	case NGC:
		n = &amp;r-&gt;ngc;
		if(n-&gt;type &gt;= Uncertain)
			return nil;
		if(n-&gt;ngc &lt;= NNGC)
			snprint(buf, sizeof buf, "NGC%4d ", n-&gt;ngc);
		else
			snprint(buf, sizeof buf, "IC%4d ", n-&gt;ngc-NNGC);
		break;
	case Abell:
		a = &amp;r-&gt;abell;
		snprint(buf, sizeof buf, "Abell%4d", a-&gt;abell);
		break;
	}
	return buf;
}

void
prrec(Record *r)
{
	NGCrec *n;
	SAOrec *s;
	Abellrec *a;
	Planetrec *p;
	int i, rah, ram, dec, nn;
	long key;

	if(r) switch(r-&gt;type){
	default:
		fprint(2, "can't prrec type %d\n", r-&gt;type);
		exits("type");

	case Planet:
		p = &amp;r-&gt;planet;
		Bprint(&amp;bout, "%s", p-&gt;name);
		Bprint(&amp;bout, "\t%s %s",
			hms(angle(p-&gt;ra)),
			dms(angle(p-&gt;dec)));
		Bprint(&amp;bout, " %3.2f° %3.2f°",
			p-&gt;az/(double)MILLIARCSEC, p-&gt;alt/(double)MILLIARCSEC);
		Bprint(&amp;bout, " %s",
			ms(angle(p-&gt;semidiam)));
		if(r-&gt;index &lt;= 1)
			Bprint(&amp;bout, " %g", p-&gt;phase);
		Bprint(&amp;bout, "\n");
		break;

	case NGC:
		n = &amp;r-&gt;ngc;
		if(n-&gt;ngc &lt;= NNGC)
			Bprint(&amp;bout, "NGC%4d ", n-&gt;ngc);
		else
			Bprint(&amp;bout, "IC%4d ", n-&gt;ngc-NNGC);
		Bprint(&amp;bout, "%s ", ngcstring(n-&gt;type));
		if(n-&gt;mag == UNKNOWNMAG)
			Bprint(&amp;bout, "----");
		else
			Bprint(&amp;bout, "%.1f%c", n-&gt;mag/10.0, n-&gt;magtype);
		Bprint(&amp;bout, "\t%s %s\t%c%.1f'\n",
			hm(angle(n-&gt;ra)),
			dm(angle(n-&gt;dec)),
			n-&gt;diamlim,
			DEG(angle(n-&gt;diam))*60.);
		prdesc(n-&gt;desc, desctab, descindex);
		printnames(r);
		break;

	case Abell:
		a = &amp;r-&gt;abell;
		Bprint(&amp;bout, "Abell%4d  %.1f %.2f° %dMpc", a-&gt;abell, a-&gt;mag10/10.0,
			DEG(angle(a-&gt;rad)), a-&gt;dist);
		Bprint(&amp;bout, "\t%s %s\t%.2f %.2f\n",
			hm(angle(a-&gt;ra)),
			dm(angle(a-&gt;dec)),
			DEG(angle(a-&gt;glat)),
			DEG(angle(a-&gt;glong)));
		Bprint(&amp;bout, "\tdist grp: %s  rich grp: %s  %d galaxies/°²\n",
			dist_grp(a-&gt;distgrp),
			rich_grp(a-&gt;richgrp),
			a-&gt;pop);
		printnames(r);
		break;

	case SAO:
		s = &amp;r-&gt;sao;
		Bprint(&amp;bout, "SAO%6ld  ", r-&gt;index);
		if(s-&gt;mag==UNKNOWNMAG)
			Bprint(&amp;bout, "---");
		else
			Bprint(&amp;bout, "%.1f", s-&gt;mag/10.0);
		if(s-&gt;mpg==UNKNOWNMAG)
			Bprint(&amp;bout, ",---");
		else
			Bprint(&amp;bout, ",%.1f", s-&gt;mpg/10.0);
		Bprint(&amp;bout, "  %s %s  %.4fs %.3f\"",
			hms(angle(s-&gt;ra)),
			dms(angle(s-&gt;dec)),
			DEG(angle(s-&gt;dra))*(4*60),
			DEG(angle(s-&gt;ddec))*(60*60));
		Bprint(&amp;bout, "  %.3s %c %.2s %ld %d",
			s-&gt;spec, s-&gt;code, s-&gt;compid, s-&gt;hd, s-&gt;hdcode);
		if(s-&gt;name[0])
			Bprint(&amp;bout, " \"%s\"", nameof(r));
		Bprint(&amp;bout, "\n");
		printnames(r);
		break;

	case Patch:
		radec(r-&gt;index, &amp;rah, &amp;ram, &amp;dec);
		Bprint(&amp;bout, "%dh%dm %d°", rah, ram, dec);
		key = r-&gt;patch.key[0];
		Bprint(&amp;bout, " %s", constel[key&amp;0xFF]);
		if((key&gt;&gt;=8) &amp; 0xFF)
			Bprint(&amp;bout, " %s", constel[key&amp;0xFF]);
		if((key&gt;&gt;=8) &amp; 0xFF)
			Bprint(&amp;bout, " %s", constel[key&amp;0xFF]);
		if((key&gt;&gt;=8) &amp; 0xFF)
			Bprint(&amp;bout, " %s", constel[key&amp;0xFF]);
		for(i=1; i&lt;r-&gt;patch.nkey; i++){
			key = r-&gt;patch.key[i];
			switch(key&amp;0x3F){
			case SAO:
				Bprint(&amp;bout, " SAO%ld", (key&gt;&gt;8)&amp;0xFFFFFF);
				break;
			case Abell:
				Bprint(&amp;bout, " Abell%ld", (key&gt;&gt;8)&amp;0xFFFFFF);
				break;
			default:	/* NGC */
				nn = (key&gt;&gt;16)&amp;0xFFFF;
				if(nn &gt; NNGC)
					Bprint(&amp;bout, " IC%d", nn-NNGC);
				else
					Bprint(&amp;bout, " NGC%d", nn);
				Bprint(&amp;bout, "(%s)", ngcstring(key&amp;0x3F));
				break;
			}
		}
		Bprint(&amp;bout, "\n");
		break;

	case NGCN:
		if(r-&gt;index &lt;= NNGC)
			Bprint(&amp;bout, "NGC%ld\n", r-&gt;index);
		else
			Bprint(&amp;bout, "IC%ld\n", r-&gt;index-NNGC);
		break;

	case NamedSAO:
		Bprint(&amp;bout, "SAO%ld \"%s\"\n", r-&gt;index, togreek(r-&gt;named.name));
		break;

	case NamedNGC:
		if(r-&gt;index &lt;= NNGC)
			Bprint(&amp;bout, "NGC%ld \"%s\"\n", r-&gt;index, togreek(r-&gt;named.name));
		else
			Bprint(&amp;bout, "IC%ld \"%s\"\n", r-&gt;index-NNGC, togreek(r-&gt;named.name));
		break;

	case NamedAbell:
		Bprint(&amp;bout, "Abell%ld \"%s\"\n", r-&gt;index, togreek(r-&gt;named.name));
		break;

	case PatchC:
		radec(r-&gt;index, &amp;rah, &amp;ram, &amp;dec);
		Bprint(&amp;bout, "%dh%dm %d\n", rah, ram, dec);
		break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

