<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scat/util.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scat/util.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "sky.h"

double	PI_180	= 0.0174532925199432957692369;
double	TWOPI	= 6.2831853071795864769252867665590057683943387987502;
double	LN2	= 0.69314718055994530941723212145817656807550013436025;
static double angledangle=(180./PI)*MILLIARCSEC;

int
rint(char *p, int n)
{
	int i=0;

	while(*p==' ' &amp;&amp; n)
		p++, --n;
	while(n--)
		i=i*10+*p++-'0';
	return i;
}

DAngle
dangle(Angle angle)
{
	return angle*angledangle;
}

Angle
angle(DAngle dangle)
{
	return dangle/angledangle;
}

double
rfloat(char *p, int n)
{
	double i, d=0;

	while(*p==' ' &amp;&amp; n)
		p++, --n;
	if(*p == '+')
		return rfloat(p+1, n-1);
	if(*p == '-')
		return -rfloat(p+1, n-1);
	while(*p == ' ' &amp;&amp; n)
		p++, --n;
	if(n == 0)
		return 0.0;
	while(n-- &amp;&amp; *p!='.')
		d = d*10+*p++-'0';
	if(n &lt;= 0)
		return d;
	p++;
	i = 1;
	while(n--)
		d+=(*p++-'0')/(i*=10.);
	return d;
}

int
sign(int c)
{
	if(c=='-')
		return -1;
	return 1;
}

char*
hms(Angle a)
{
	static char buf[20];
	double x;
	int h, m, s, ts;

	x=DEG(a)/15;
	x += 0.5/36000.;	/* round up half of 0.1 sec */
	h = floor(x);
	x -= h;
	x *= 60;
	m = floor(x);
	x -= m;
	x *= 60;
	s = floor(x);
	x -= s;
	ts = 10*x;
	sprint(buf, "%dh%.2dm%.2d.%ds", h, m, s, ts);
	return buf;
}

char*
dms(Angle a)
{
	static char buf[20];
	double x;
	int sign, d, m, s, ts;

	x = DEG(a);
	sign='+';
	if(a&lt;0){
		sign='-';
		x=-x;
	}
	x += 0.5/36000.;	/* round up half of 0.1 arcsecond */
	d = floor(x);
	x -= d;
	x *= 60;
	m = floor(x);
	x -= m;
	x *= 60;
	s = floor(x);
	x -= s;
	ts = floor(10*x);
	sprint(buf, "%c%d°%.2d'%.2d.%d\"", sign, d, m, s, ts);
	return buf;
}

char*
ms(Angle a)
{
	static char buf[20];
	double x;
	int d, m, s, ts;

	x = DEG(a);
	x += 0.5/36000.;	/* round up half of 0.1 arcsecond */
	d = floor(x);
	x -= d;
	x *= 60;
	m = floor(x);
	x -= m;
	x *= 60;
	s = floor(x);
	x -= s;
	ts = floor(10*x);
	if(d != 0)
		sprint(buf, "%d°%.2d'%.2d.%d\"", d, m, s, ts);
	else
		sprint(buf, "%.2d'%.2d.%d\"", m, s, ts);
	return buf;
}

char*
hm(Angle a)
{
	static char buf[20];
	double x;
	int h, m, n;

	x = DEG(a)/15;
	x += 0.5/600.;	/* round up half of tenth of minute */
	h = floor(x);
	x -= h;
	x *= 60;
	m = floor(x);
	x -= m;
	x *= 10;
	n = floor(x);
	sprint(buf, "%dh%.2d.%1dm", h, m, n);
	return buf;
}

char*
hm5(Angle a)
{
	static char buf[20];
	double x;
	int h, m;

	x = DEG(a)/15;
	x += 2.5/60.;	/* round up 2.5m */
	h = floor(x);
	x -= h;
	x *= 60;
	m = floor(x);
	m -= m % 5;
	sprint(buf, "%dh%.2dm", h, m);
	return buf;
}

char*
dm(Angle a)
{
	static char buf[20];
	double x;
	int sign, d, m, n;

	x = DEG(a);
	sign='+';
	if(a&lt;0){
		sign='-';
		x=-x;
	}
	x += 0.5/600.;	/* round up half of tenth of arcminute */
	d = floor(x);
	x -= d;
	x *= 60;
	m = floor(x);
	x -= m;
	x *= 10;
	n = floor(x);
	sprint(buf, "%c%d°%.2d.%.1d'", sign, d, m, n);
	return buf;
}

char*
deg(Angle a)
{
	static char buf[20];
	double x;
	int sign, d;

	x = DEG(a);
	sign='+';
	if(a&lt;0){
		sign='-';
		x=-x;
	}
	x += 0.5;	/* round up half degree */
	d = floor(x);
	sprint(buf, "%c%d°", sign, d);
	return buf;
}

char*
getword(char *ou, char *in)
{
	int c;

	for(;;) {
		c = *in++;
		if(c == ' ' || c == '\t')
			continue;
		if(c == 0)
			return 0;
		break;
	}

	if(c == '\'')
		for(;;) {
			if(c &gt;= 'A' &amp;&amp; c &lt;= 'Z')
				c += 'a' - 'A';
			*ou++ = c;
			c = *in++;
			if(c == 0)
				return 0;
			if(c == '\'') {
				*ou = 0;
				return in-1;
			}
		}
	for(;;) {
		if(c &gt;= 'A' &amp;&amp; c &lt;= 'Z')
			c += 'a' - 'A';
		*ou++ = c;
		c = *in++;
		if(c == ' ' || c == '\t' || c == 0) {
			*ou = 0;
			return in-1;
		}
	}
}

/*
 * Read formatted angle.  Must contain no embedded blanks
 */
Angle
getra(char *p)
{
	Rune r;
	char *q;
	Angle f, d;
	int neg;

	neg = 0;
	d = 0;
	while(*p == ' ')
		p++;
	for(;;) {
		if(*p == ' ' || *p=='\0')
			goto Return;
		if(*p == '-') {
			neg = 1;
			p++;
		}
		if(*p == '+') {
			neg = 0;
			p++;
		}
		q = p;
		f = strtod(p, &amp;q);
		if(q &gt; p) {
			p = q;
		}
		p += chartorune(&amp;r, p);
		switch(r) {
		default:
		Return:
			if(neg)
				d = -d;
			return RAD(d);
		case 'h':
			d += f*15;
			break;
		case 'm':
			d += f/4;
			break;
		case 's':
			d += f/240;
			break;
		case L'°':
			d += f;
			break;
		case '\'':
			d += f/60;
			break;
		case '\"':
			d += f/3600;
			break;
		}
	}
}

double
xsqrt(double a)
{

	if(a &lt; 0)
		return 0;
	return sqrt(a);
}

Angle
dist(Angle ra1, Angle dec1, Angle ra2, Angle dec2)
{
	double a;

	a = sin(dec1) * sin(dec2) +
		cos(dec1) * cos(dec2) *
		cos(ra1 - ra2);
	a = atan2(xsqrt(1 - a*a), a);
	if(a &lt; 0)
		a = -a;
	return a;
}

int
dogamma(Pix c)
{
	float f;

	f = c - gam.min;
	if(f &lt; 1)
		f = 1;

	if(gam.absgamma == 1)
		c = f * gam.mult2;
	else
		c = exp(log(f*gam.mult1) * gam.absgamma) * 255;
	if(c &gt; 255)
		c = 255;
	if(gam.neg)
		c = 255-c;
	return c;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

