<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scuzz/cdaudio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scuzz/cdaudio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;disk.h&gt;
#include "scsireq.h"

extern Biobuf bout;

long
SRcdpause(ScsiReq *rp, int resume)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdCDpause;
	cmd[8] = resume;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRcdstop(ScsiReq *rp)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdCDstop;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

static long
_SRcdplay(ScsiReq *rp, long lba, long length)
{
	uchar cmd[12];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdCDplay;
	cmd[2] = lba&gt;&gt;24;
	cmd[3] = lba&gt;&gt;16;
	cmd[4] = lba&gt;&gt;8;
	cmd[5] = lba;
	cmd[6] = length&gt;&gt;24;
	cmd[7] = length&gt;&gt;16;
	cmd[8] = length&gt;&gt;8;
	cmd[9] = length;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;

	return SRrequest(rp);
}

static struct {
	int	trackno;
	long	lba;
	long	length;
} tracks[100];
static int ntracks;

long
SRcdplay(ScsiReq *rp, int raw, long start, long length)
{
	uchar d[100*8+4], *p;
	int lba, n, tdl;

	if(raw || start == 0)
		return _SRcdplay(rp, start, length);

	ntracks = 0;
	if(SRTOC(rp, d, sizeof(d), 0, 0) == -1){
		if(rp-&gt;status == STok)
			Bprint(&amp;bout, "\t(probably empty)\n");
		return -1;
	}
	tdl = (d[0]&lt;&lt;8)|d[1];
	for(p = &amp;d[4], n = tdl-2; n; n -= 8, p += 8){
		tracks[ntracks].trackno = p[2];
		lba = (p[4]&lt;&lt;24)|(p[5]&lt;&lt;16)|(p[6]&lt;&lt;8)|p[7];
		tracks[ntracks].lba = lba;
		if(ntracks &gt; 0)
			tracks[ntracks-1].length = lba-tracks[ntracks-1].lba;
		ntracks++;
	}
	if(ntracks &gt; 0)
		tracks[ntracks-1].length = 0xFFFFFFFF;

	for(n = 0; n &lt; ntracks; n++){
		if(start != tracks[n].trackno)
			continue;
		return _SRcdplay(rp, tracks[n].lba, tracks[n].length);
	}

	return -1;
}

long
SRcdload(ScsiReq *rp, int load, int slot)
{
	uchar cmd[12];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdCDload;
	if(load)
		cmd[4] = 0x03;
	else
		cmd[4] = 0x02;
	cmd[8] = slot;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRcdstatus(ScsiReq *rp, uchar *list, int nbytes)
{
	uchar cmd[12];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = ScmdCDstatus;
	cmd[8] = nbytes&gt;&gt;8;
	cmd[9] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRgetconf(ScsiReq *rp, uchar *list, int nbytes)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof(cmd));
	cmd[0] = Scmdgetconf;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof(cmd);
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

