<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/scuzz/scsireq.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/scuzz/scsireq.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
/*
 * BUGS:
 *	no luns
 *	and incomplete in many other ways
 */
#include &lt;disk.h&gt;
#include "scsireq.h"

enum {
	Debug = 0,
};

/*
 * exabyte tape drives, at least old ones like the 8200 and 8505,
 * are dumb: you have to read the exact block size on the tape,
 * they don't take 10-byte SCSI commands, and various other fine points.
 */
extern int exabyte, force6bytecmds;

static int debug = Debug;

long
SRready(ScsiReq *rp)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRrewind(ScsiReq *rp)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdRewind;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	if(SRrequest(rp) &gt;= 0){
		rp-&gt;offset = 0;
		return 0;
	}
	return -1;
}

long
SRreqsense(ScsiReq *rp)
{
	uchar cmd[6];
	ScsiReq req;
	long status;

	if(rp-&gt;status == Status_SD){
		rp-&gt;status = STok;
		return 0;
	}
	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdRsense;
	cmd[4] = sizeof(req.sense);
	memset(&amp;req, 0, sizeof(req));
	if(rp-&gt;flags&amp;Fusb)
		req.flags |= Fusb;
	req.fd = rp-&gt;fd;
	req.umsc = rp-&gt;umsc;
	req.cmd.p = cmd;
	req.cmd.count = sizeof cmd;
	req.data.p = rp-&gt;sense;
	req.data.count = sizeof(rp-&gt;sense);
	req.data.write = 0;
	status = SRrequest(&amp;req);
	rp-&gt;status = req.status;
	return status;
}

long
SRformat(ScsiReq *rp)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdFormat;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 6;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRrblimits(ScsiReq *rp, uchar *list)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdRblimits;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = list;
	rp-&gt;data.count = 6;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

static int
dirdevrw(ScsiReq *rp, uchar *cmd, long nbytes)
{
	long n;

	n = nbytes / rp-&gt;lbsize;
	if(rp-&gt;offset &lt;= Max24off &amp;&amp; n &lt;= 256 &amp;&amp; (rp-&gt;flags &amp; Frw10) == 0){
		PUTBE24(cmd+1, rp-&gt;offset);
		cmd[4] = n;
		cmd[5] = 0;
		return 6;
	}
	cmd[0] |= ScmdExtread;
	cmd[1] = 0;
	PUTBELONG(cmd+2, rp-&gt;offset);
	cmd[6] = 0;
	cmd[7] = n&gt;&gt;8;
	cmd[8] = n;
	cmd[9] = 0;
	return 10;
}

static int
seqdevrw(ScsiReq *rp, uchar *cmd, long nbytes)
{
	long n;

	/* don't set Cmd1sili; we want the ILI bit instead of a fatal error */
	cmd[1] = rp-&gt;flags&amp;Fbfixed? Cmd1fixed: 0;
	n = nbytes / rp-&gt;lbsize;
	PUTBE24(cmd+2, n);
	cmd[5] = 0;
	return 6;
}

long
SRread(ScsiReq *rp, void *buf, long nbytes)
{
	uchar cmd[10];
	long n;

	if((nbytes % rp-&gt;lbsize) || nbytes &gt; maxiosize){
		if(debug)
			if (nbytes % rp-&gt;lbsize)
				fprint(2, "scuzz: i/o size %ld %% %ld != 0\n",
					nbytes, rp-&gt;lbsize);
			else
				fprint(2, "scuzz: i/o size %ld &gt; %ld\n",
					nbytes, maxiosize);
		rp-&gt;status = Status_BADARG;
		return -1;
	}

	/* set up scsi read cmd */
	cmd[0] = ScmdRead;
	if(rp-&gt;flags &amp; Fseqdev)
		rp-&gt;cmd.count = seqdevrw(rp, cmd, nbytes);
	else
		rp-&gt;cmd.count = dirdevrw(rp, cmd, nbytes);
	rp-&gt;cmd.p = cmd;
	rp-&gt;data.p = buf;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;

	/* issue it */
	n = SRrequest(rp);
	if(n != -1){			/* it worked? */
		rp-&gt;offset += n / rp-&gt;lbsize;
		return n;
	}

	/* request failed; maybe we just read a short record? */
	if (exabyte) {
		fprint(2, "read error\n");
		rp-&gt;status = STcheck;
		return n;
	}
	if(rp-&gt;status != Status_SD || !(rp-&gt;sense[0] &amp; Sd0valid))
		return -1;
	/* compute # of bytes not read */
	n = GETBELONG(rp-&gt;sense+3) * rp-&gt;lbsize;
	if (debug)
		fprint(2,
	"SRread: request failed with sense data; sense byte count %ld\n",
			n);
	if(!(rp-&gt;flags &amp; Fseqdev))
		return -1;

	/* device is a tape or something similar */
	if (rp-&gt;sense[2] == Sd2filemark || rp-&gt;sense[2] == 0x08 ||
	    rp-&gt;sense[2] &amp; Sd2ili &amp;&amp; n &gt; 0)
		rp-&gt;data.count = nbytes - n;
	else
		return -1;
	n = rp-&gt;data.count;
	if (!rp-&gt;readblock++ || debug)
		fprint(2, "SRread: tape data count %ld%s\n", n,
			(rp-&gt;sense[2] &amp; Sd2ili? " with ILI": ""));
	rp-&gt;status = STok;
	rp-&gt;offset += n / rp-&gt;lbsize;
	return n;
}

long
SRwrite(ScsiReq *rp, void *buf, long nbytes)
{
	uchar cmd[10];
	long n;

	if((nbytes % rp-&gt;lbsize) || nbytes &gt; maxiosize){
		if(debug)
			if (nbytes % rp-&gt;lbsize)
				fprint(2, "scuzz: i/o size %ld %% %ld != 0\n",
					nbytes, rp-&gt;lbsize);
			else
				fprint(2, "scuzz: i/o size %ld &gt; %ld\n",
					nbytes, maxiosize);
		rp-&gt;status = Status_BADARG;
		return -1;
	}

	/* set up scsi write cmd */
	cmd[0] = ScmdWrite;
	if(rp-&gt;flags &amp; Fseqdev)
		rp-&gt;cmd.count = seqdevrw(rp, cmd, nbytes);
	else
		rp-&gt;cmd.count = dirdevrw(rp, cmd, nbytes);
	rp-&gt;cmd.p = cmd;
	rp-&gt;data.p = buf;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 1;

	/* issue it */
	if((n = SRrequest(rp)) == -1){
		if (exabyte) {
			fprint(2, "write error\n");
			rp-&gt;status = STcheck;
			return n;
		}
		if(rp-&gt;status != Status_SD || rp-&gt;sense[2] != Sd2eom)
			return -1;
		if(rp-&gt;sense[0] &amp; Sd0valid){
			n -= GETBELONG(rp-&gt;sense+3) * rp-&gt;lbsize;
			rp-&gt;data.count = nbytes - n;
		}
		else
			rp-&gt;data.count = nbytes;
		n = rp-&gt;data.count;
	}
	rp-&gt;offset += n / rp-&gt;lbsize;
	return n;
}

long
SRseek(ScsiReq *rp, long offset, int type)
{
	uchar cmd[10];

	switch(type){

	case 0:
		break;

	case 1:
		offset += rp-&gt;offset;
		if(offset &gt;= 0)
			break;
		/*FALLTHROUGH*/

	default:
		if(debug)
			fprint(2, "scuzz: seek failed\n");
		rp-&gt;status = Status_BADARG;
		return -1;
	}
	memset(cmd, 0, sizeof cmd);
	if(offset &lt;= Max24off &amp;&amp; (rp-&gt;flags &amp; Frw10) == 0){
		cmd[0] = ScmdSeek;
		PUTBE24(cmd+1, offset &amp; Max24off);
		rp-&gt;cmd.count = 6;
	}else{
		cmd[0] = ScmdExtseek;
		PUTBELONG(cmd+2, offset);
		rp-&gt;cmd.count = 10;
	}
	rp-&gt;cmd.p = cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	SRrequest(rp);
	if(rp-&gt;status == STok)
		return rp-&gt;offset = offset;
	return -1;
}

long
SRfilemark(ScsiReq *rp, ulong howmany)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdFmark;
	PUTBE24(cmd+2, howmany);
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRspace(ScsiReq *rp, uchar code, long howmany)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdSpace;
	cmd[1] = code;
	PUTBE24(cmd+2, howmany);
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	/*
	 * what about rp-&gt;offset?
	 */
	return SRrequest(rp);
}

long
SRinquiry(ScsiReq *rp)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdInq;
	cmd[4] = sizeof rp-&gt;inquiry;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	memset(rp-&gt;inquiry, 0, sizeof rp-&gt;inquiry);
	rp-&gt;data.p = rp-&gt;inquiry;
	rp-&gt;data.count = sizeof rp-&gt;inquiry;
	rp-&gt;data.write = 0;
	if(SRrequest(rp) &gt;= 0){
		rp-&gt;flags |= Finqok;
		return 0;
	}
	rp-&gt;flags &amp;= ~Finqok;
	return -1;
}

long
SRmodeselect6(ScsiReq *rp, uchar *list, long nbytes)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdMselect6;
	if((rp-&gt;flags &amp; Finqok) &amp;&amp; (rp-&gt;inquiry[2] &amp; 0x07) &gt;= 2)
		cmd[1] = 0x10;
	cmd[4] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRmodeselect10(ScsiReq *rp, uchar *list, long nbytes)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof cmd);
	if((rp-&gt;flags &amp; Finqok) &amp;&amp; (rp-&gt;inquiry[2] &amp; 0x07) &gt;= 2)
		cmd[1] = 0x10;
	cmd[0] = ScmdMselect10;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRmodesense6(ScsiReq *rp, uchar page, uchar *list, long nbytes)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdMsense6;
	cmd[2] = page;
	cmd[4] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRmodesense10(ScsiReq *rp, uchar page, uchar *list, long nbytes)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdMsense10;
	cmd[2] = page;
	cmd[7] = nbytes&gt;&gt;8;
	cmd[8] = nbytes;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = list;
	rp-&gt;data.count = nbytes;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

long
SRstart(ScsiReq *rp, uchar code)
{
	uchar cmd[6];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdStart;
	cmd[4] = code;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = cmd;
	rp-&gt;data.count = 0;
	rp-&gt;data.write = 1;
	return SRrequest(rp);
}

long
SRrcapacity(ScsiReq *rp, uchar *data)
{
	uchar cmd[10];

	memset(cmd, 0, sizeof cmd);
	cmd[0] = ScmdRcapacity;
	rp-&gt;cmd.p = cmd;
	rp-&gt;cmd.count = sizeof cmd;
	rp-&gt;data.p = data;
	rp-&gt;data.count = 8;
	rp-&gt;data.write = 0;
	return SRrequest(rp);
}

static long
request(int fd, ScsiPtr *cmd, ScsiPtr *data, int *status)
{
	long n, r;
	char buf[16];

	/* this was an experiment but it seems to be a good idea */
	*status = STok;

	/* send SCSI command */
	if(write(fd, cmd-&gt;p, cmd-&gt;count) != cmd-&gt;count){
		fprint(2, "scsireq: write cmd: %r\n");
		*status = Status_SW;
		return -1;
	}

	/* read or write actual data */
	werrstr("");
	if(data-&gt;write)
		n = write(fd, data-&gt;p, data-&gt;count);
	else {
		n = read(fd, data-&gt;p, data-&gt;count);
		if (n &lt; 0)
			memset(data-&gt;p, 0, data-&gt;count);
		else if (n &lt; data-&gt;count)
			memset(data-&gt;p + n, 0, data-&gt;count - n);
	}
	if (n != data-&gt;count &amp;&amp; n &lt;= 0) {
		if (debug)
			fprint(2,
	"request: tried to %s %ld bytes of data for cmd 0x%x but got %r\n",
				(data-&gt;write? "write": "read"),
				data-&gt;count, cmd-&gt;p[0]);
	} else if (n != data-&gt;count &amp;&amp; (data-&gt;write || debug))
		fprint(2, "request: %s %ld of %ld bytes of actual data\n",
			(data-&gt;write? "wrote": "read"), n, data-&gt;count);

	/* read status */
	buf[0] = '\0';
	r = read(fd, buf, sizeof buf-1);
	if(exabyte &amp;&amp; r &lt;= 0 || !exabyte &amp;&amp; r &lt; 0){
		fprint(2, "scsireq: read status: %r\n");
		*status = Status_SW;
		return -1;
	}
	if (r &gt;= 0)
		buf[r] = '\0';
	*status = atoi(buf);
	if(n &lt; 0 &amp;&amp; (exabyte || *status != STcheck))
		fprint(2, "scsireq: status 0x%2.2uX: data transfer: %r\n",
			*status);
	return n;
}

long
SRrequest(ScsiReq *rp)
{
	long n;
	int status;

retry:
	if(rp-&gt;flags&amp;Fusb)
		n = umsrequest(rp-&gt;umsc, &amp;rp-&gt;cmd, &amp;rp-&gt;data, &amp;status);
	else
		n = request(rp-&gt;fd, &amp;rp-&gt;cmd, &amp;rp-&gt;data, &amp;status);
	switch(rp-&gt;status = status){

	case STok:
		rp-&gt;data.count = n;
		break;

	case STcheck:
		if(rp-&gt;cmd.p[0] != ScmdRsense &amp;&amp; SRreqsense(rp) != -1)
			rp-&gt;status = Status_SD;
		if (exabyte)
			fprint(2, "SRrequest: STcheck, returning -1\n");
		return -1;

	case STbusy:
		sleep(1000);
		goto retry;

	default:
		fprint(2, "status 0x%2.2uX\n", status);
		return -1;
	}
	return n;
}

int
SRclose(ScsiReq *rp)
{
	if((rp-&gt;flags &amp; Fopen) == 0){
		if(debug)
			fprint(2, "scuzz: closing closed file\n");
		rp-&gt;status = Status_BADARG;
		return -1;
	}
	close(rp-&gt;fd);
	rp-&gt;flags = 0;
	return 0;
}

uint
mkascq(ScsiReq *r)
{
	uchar *u;

	u = r-&gt;sense;
	return u[2]&lt;&lt;16 | u[12]&lt;&lt;8 | u[13];
}

static int
dirdevopen(ScsiReq *rp)
{
	ulong blocks;
	uchar data[8];

	if(SRstart(rp, 1) == -1)
		/*
		 * it's okay for removable media to say
		 * "check condition: medium not present".
		 * 3a is "medium not present".
		 */
		return rp-&gt;inquiry[1] &amp; 0x80 &amp;&amp; (mkascq(rp) &gt;&gt; 8) == 0x023a?
			0: -1;
	memset(data, 0, sizeof data);
	if(SRrcapacity(rp, data) == -1)
		return -1;
	rp-&gt;lbsize = GETBELONG(data+4);
	blocks =     GETBELONG(data);
	if(debug)
		fprint(2, "scuzz: dirdevopen: logical block size %lud, "
			"# blocks %lud\n", rp-&gt;lbsize, blocks);
	/* some newer dev's don't support 6-byte commands */
	if(blocks &gt; Max24off &amp;&amp; !force6bytecmds)
		rp-&gt;flags |= Frw10;
	return 0;
}

static int
seqdevopen(ScsiReq *rp)
{
	uchar mode[16], limits[6];

	if(SRrblimits(rp, limits) == -1)
		return -1;
	if(limits[1] == 0 &amp;&amp; limits[2] == limits[4] &amp;&amp; limits[3] == limits[5]){
		rp-&gt;flags |= Fbfixed;
		rp-&gt;lbsize = limits[4]&lt;&lt;8 | limits[5];
		if(debug)
			fprint(2, "scuzz: seqdevopen: logical block size %lud\n",
				rp-&gt;lbsize);
		return 0;
	}
	/*
	 * On some older hardware the optional 10-byte
	 * modeselect command isn't implemented.
	 */
	if (force6bytecmds)
		rp-&gt;flags |= Fmode6;
	if(!(rp-&gt;flags &amp; Fmode6)){
		/* try 10-byte command first */
		memset(mode, 0, sizeof mode);
		mode[3] = 0x10;		/* device-specific param. */
		mode[7] = 8;		/* block descriptor length */
		/*
		 * exabytes can't handle this, and
		 * modeselect(10) is optional.
		 */
		if(SRmodeselect10(rp, mode, sizeof mode) != -1){
			rp-&gt;lbsize = 1;
			return 0;	/* success */
		}
		/* can't do 10-byte commands, back off to 6-byte ones */
		rp-&gt;flags |= Fmode6;
	}

	/* 6-byte command */
	memset(mode, 0, sizeof mode);
	mode[2] = 0x10;		/* device-specific param. */
	mode[3] = 8;		/* block descriptor length */
	/*
	 * bsd sez exabytes need this bit (NBE: no busy enable) in
	 * vendor-specific page (0), but so far we haven't needed it.
	mode[12] |= 8;
	 */
	if(SRmodeselect6(rp, mode, 4+8) == -1)
		return -1;
	rp-&gt;lbsize = 1;
	return 0;
}

static int
wormdevopen(ScsiReq *rp)
{
	long status;
	uchar list[MaxDirData];

	if (SRstart(rp, 1) == -1 ||
	    (status = SRmodesense10(rp, Allmodepages, list, sizeof list)) == -1)
		return -1;
	/* nbytes = list[0]&lt;&lt;8 | list[1]; */

	/* # of bytes of block descriptors of 8 bytes each; not even 1? */
	if((list[6]&lt;&lt;8 | list[7]) &lt; 8)
		rp-&gt;lbsize = 2048;
	else
		/* last 3 bytes of block 0 descriptor */
		rp-&gt;lbsize = GETBE24(list+13);
	if(debug)
		fprint(2, "scuzz: wormdevopen: logical block size %lud\n",
			rp-&gt;lbsize);
	return status;
}

int
SRopenraw(ScsiReq *rp, char *unit)
{
	char name[128];

	if(rp-&gt;flags &amp; Fopen){
		if(debug)
			fprint(2, "scuzz: opening open file\n");
		rp-&gt;status = Status_BADARG;
		return -1;
	}
	memset(rp, 0, sizeof *rp);
	rp-&gt;unit = unit;

	sprint(name, "%s/raw", unit);

	if((rp-&gt;fd = open(name, ORDWR)) == -1){
		rp-&gt;status = STtimeout;
		return -1;
	}
	rp-&gt;flags = Fopen;
	return 0;
}

int
SRopen(ScsiReq *rp, char *unit)
{
	if(SRopenraw(rp, unit) == -1)
		return -1;
	SRready(rp);
	if(SRinquiry(rp) &gt;= 0){
		switch(rp-&gt;inquiry[0]){

		default:
			fprint(2, "unknown device type 0x%.2x\n", rp-&gt;inquiry[0]);
			rp-&gt;status = Status_SW;
			break;

		case 0x00:	/* Direct access (disk) */
		case 0x05:	/* CD-ROM */
		case 0x07:	/* rewriteable MO */
			if(dirdevopen(rp) == -1)
				break;
			return 0;

		case 0x01:	/* Sequential eg: tape */
			rp-&gt;flags |= Fseqdev;
			if(seqdevopen(rp) == -1)
				break;
			return 0;

		case 0x02:	/* Printer */
			rp-&gt;flags |= Fprintdev;
			return 0;

		case 0x04:	/* Worm */
			rp-&gt;flags |= Fwormdev;
			if(wormdevopen(rp) == -1)
				break;
			return 0;

		case 0x08:	/* medium-changer */
			rp-&gt;flags |= Fchanger;
			return 0;
		}
	}
	SRclose(rp);
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

