<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/sh.C - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/sh.C</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* sh - simple shell - great for early stages of porting */
#include "u.h"
#include "libc.h"

#define MAXLINE 200		/* maximum line length */
#define WORD 256		/* token code for words */
#define EOF -1			/* token code for end of file */
#define ispunct(c)		(c=='|' || c=='&amp;' || c==';' || c=='&lt;' || \
				 c=='&gt;' || c=='(' || c==')' || c=='\n')
#define isspace(c)		(c==' ' || c=='\t')
#define execute(np)		(ignored = (np? (*(np)-&gt;op)(np) : 0))

typedef struct Node	Node;
struct Node{			/* parse tree node */
	int (*op)(Node *); 	/* operator function */
	Node *args[2];		/* argument nodes */
	char *argv[100];	/* argument pointers */
	char *io[3];		/* i/o redirection */
};

Node	nodes[25];		/* node pool */
Node	*nfree;			/* next available node */
char	strspace[10*MAXLINE];	/* string storage */
char	*sfree;			/* next free character in strspace */
int	t;			/* current token code */
char 	*token;			/* current token text (in strspace) */
int	putback = 0;		/* lookahead */
char	status[256];		/* exit status of most recent command */
int	cflag = 0;		/* command is argument to sh */
int	tflag = 0;		/* read only one line */
int	interactive = 0;	/* prompt */
char	*cflagp;		/* command line for cflag */
char	*path[] ={"/bin", 0};
int	ignored;

Node	*alloc(int (*op)(Node *));
int	builtin(Node *np);
Node	*command(void);
int	getch(void);
int	gettoken(void);
Node	*list(void);
void	error(char *s, char *t);
Node	*pipeline(void);
void	redirect(Node *np);
int	setio(Node *np);
Node	*simple(void);
int	xpipeline(Node *np);
int	xsimple(Node *np);
int	xsubshell(Node *np);
int	xnowait(Node *np);
int	xwait(Node *np);

void
main(int argc, char *argv[])
{
	Node *np;

	if(argc&gt;1 &amp;&amp; strcmp(argv[1], "-t")==0)
		tflag++;
	else if(argc&gt;2 &amp;&amp; strcmp(argv[1], "-c")==0){
		cflag++;
		cflagp = argv[2];
	}else if(argc&gt;1){
		close(0);
		if(open(argv[1], 0) != 0){
			error(": can't open", argv[1]);
			exits("argument");
		}
	}else
		interactive = 1;
	for(;;){
		if(interactive)
			fprint(2, "%d$ ", getpid());
		nfree = nodes;
		sfree = strspace;
		if((t=gettoken()) == EOF)
			break;
		if(t != '\n')
			if(np = list())
				execute(np);
			else
				error("syntax error", "");
		while(t!=EOF &amp;&amp; t!='\n')	/* flush syntax errors */
			t = gettoken();
	}
	exits(status);
}

/* alloc - allocate for op and return a node */
Node*
alloc(int (*op)(Node *))
{
	if(nfree &lt; nodes+sizeof(nodes)){
		nfree-&gt;op = op;
		nfree-&gt;args[0] = nfree-&gt;args[1] = 0;
		nfree-&gt;argv[0] = nfree-&gt;argv[1] = 0;
		nfree-&gt;io[0] = nfree-&gt;io[1] = nfree-&gt;io[2] = 0;
		return nfree++;
	}
	error("node storage overflow", "");
	exits("node storage overflow");
	return nil;
}

/* builtin - check np for builtin command and, if found, execute it */
int
builtin(Node *np)
{
	int n = 0;
	char name[MAXLINE];
	Waitmsg *wmsg;

	if(np-&gt;argv[1])
		n = strtoul(np-&gt;argv[1], 0, 0);
	if(strcmp(np-&gt;argv[0], "cd") == 0){
		if(chdir(np-&gt;argv[1]? np-&gt;argv[1] : "/") == -1)
			error(": bad directory", np-&gt;argv[0]);
		return 1;
	}else if(strcmp(np-&gt;argv[0], "exit") == 0)
		exits(np-&gt;argv[1]? np-&gt;argv[1] : status);
	else if(strcmp(np-&gt;argv[0], "bind") == 0){
		if(np-&gt;argv[1]==0 || np-&gt;argv[2]==0)
			error("usage: bind new old", "");
		else if(bind(np-&gt;argv[1], np-&gt;argv[2], 0)==-1)
			error("bind failed", "");
		return 1;
#ifdef asdf
	}else if(strcmp(np-&gt;argv[0], "unmount") == 0){
		if(np-&gt;argv[1] == 0)
			error("usage: unmount [new] old", "");
		else if(np-&gt;argv[2] == 0){
			if(unmount((char *)0, np-&gt;argv[1]) == -1)
				error("unmount:", "");
		}else if(unmount(np-&gt;argv[1], np-&gt;argv[2]) == -1)
			error("unmount", "");
		return 1;
#endif
	}else if(strcmp(np-&gt;argv[0], "wait") == 0){
		while((wmsg = wait()) != nil){
			strncpy(status, wmsg-&gt;msg, sizeof(status)-1);
			if(n &amp;&amp; wmsg-&gt;pid==n){
				n = 0;
				free(wmsg);
				break;
			}
			free(wmsg);
		}
		if(n)
			error("wait error", "");
		return 1;
	}else if(strcmp(np-&gt;argv[0], "rfork") == 0){
		char *p;
		int mask;

		p = np-&gt;argv[1];
		if(p == 0 || *p == 0)
			p = "ens";
		mask = 0;

		while(*p)
			switch(*p++){
			case 'n': mask |= RFNAMEG; break;
			case 'N': mask |= RFCNAMEG; break;
			case 'e': mask |= RFENVG; break;
			case 'E': mask |= RFCENVG; break;
			case 's': mask |= RFNOTEG; break;
			case 'f': mask |= RFFDG; break;
			case 'F': mask |= RFCFDG; break;
			case 'm': mask |= RFNOMNT; break;
			default: error(np-&gt;argv[1], "bad rfork flag");
			}
		rfork(mask);

		return 1;
	}else if(strcmp(np-&gt;argv[0], "exec") == 0){
		redirect(np);
		if(np-&gt;argv[1] == (char *) 0)
			return 1;
		exec(np-&gt;argv[1], &amp;np-&gt;argv[1]);
		n = np-&gt;argv[1][0];
		if(n!='/' &amp;&amp; n!='#' &amp;&amp; (n!='.' || np-&gt;argv[1][1]!='/'))
			for(n = 0; path[n]; n++){
				sprint(name, "%s/%s", path[n], np-&gt;argv[1]);
				exec(name, &amp;np-&gt;argv[1]);
			}
		error(": not found", np-&gt;argv[1]);
		return 1;
	}
	return 0;
}

/* command - ( list ) [ ( &lt; | &gt; | &gt;&gt; ) word ]* | simple */
Node*
command(void)
{
	Node *np;

	if(t != '(')
		return simple();
	np = alloc(xsubshell);
	t = gettoken();
	if((np-&gt;args[0]=list())==0 || t!=')')
		return 0;
	while((t=gettoken())=='&lt;' || t=='&gt;')
		if(!setio(np))
			return 0;
	return np;
}

/* getch - get next, possibly pushed back, input character */
int
getch(void)
{
	unsigned char c;
	static done=0;

	if(putback){
		c = putback;
		putback = 0;
	}else if(tflag){
		if(done || read(0, &amp;c, 1)!=1){
			done = 1;
			return EOF;
		}
		if(c == '\n')
			done = 1;
	}else if(cflag){
		if(done)
			return EOF;
		if((c=*cflagp++) == 0){
			done = 1;
			c = '\n';
		}
	}else if(read(0, &amp;c, 1) != 1)
		return EOF;
	return c;
}

/* gettoken - get next token into string space, return token code */
int
gettoken(void)
{
	int c;

	while((c = getch()) != EOF)
		if(!isspace(c))
			break;
	if(c==EOF || ispunct(c))
		return c;
	token = sfree;
	do{
		if(sfree &gt;= strspace+sizeof(strspace) - 1){
			error("string storage overflow", "");
			exits("string storage overflow");
		}
		*sfree++ = c;
	}while((c=getch()) != EOF &amp;&amp; !ispunct(c) &amp;&amp; !isspace(c));
	*sfree++ = 0;
	putback = c;
	return WORD;
}

/* list - pipeline ( ( ; | &amp; ) pipeline )* [ ; | &amp; ]  (not LL(1), but ok) */
Node*
list(void)
{
	Node *np, *np1;

	np = alloc(0);
	if((np-&gt;args[1]=pipeline()) == 0)
		return 0;
	while(t==';' || t=='&amp;'){
		np-&gt;op = (t==';')? xwait : xnowait;
		t = gettoken();
		if(t==')' || t=='\n')	/* tests ~first(pipeline) */
			break;
		np1 = alloc(0);
		np1-&gt;args[0] = np;
		if((np1-&gt;args[1]=pipeline()) == 0)
			return 0;
		np = np1;
	}
	if(np-&gt;op == 0)
		np-&gt;op = xwait;
	return np;
}

/* error - print error message s, prefixed by t */
void
error(char *s, char *t)
{
	char buf[256];

	fprint(2, "%s%s", t, s);
	errstr(buf, sizeof buf);
	fprint(2, ": %s\n", buf);
}

/* pipeline - command ( | command )* */
Node*
pipeline(void)
{
	Node *np, *np1;

	if((np=command()) == 0)
		return 0;
	while(t == '|'){
		np1 = alloc(xpipeline);
		np1-&gt;args[0] = np;
		t = gettoken();
		if((np1-&gt;args[1]=command()) == 0)
			return 0;
		np = np1;
	}
	return np;
}

/* redirect - redirect i/o according to np-&gt;io[] values */
void
redirect(Node *np)
{
	int fd;

	if(np-&gt;io[0]){
		if((fd = open(np-&gt;io[0], 0)) &lt; 0){
			error(": can't open", np-&gt;io[0]);
			exits("open");
		}
		dup(fd, 0);
		close(fd);
	}
	if(np-&gt;io[1]){
		if((fd = create(np-&gt;io[1], 1, 0666L)) &lt; 0){
			error(": can't create", np-&gt;io[1]);
			exits("create");
		}
		dup(fd, 1);
		close(fd);
	}
	if(np-&gt;io[2]){
		if((fd = open(np-&gt;io[2], 1)) &lt; 0 &amp;&amp; (fd = create(np-&gt;io[2], 1, 0666L)) &lt; 0){
			error(": can't write", np-&gt;io[2]);
			exits("write");
		}
		dup(fd, 1);
		close(fd);
		seek(1, 0, 2);
	}
}

/* setio - ( &lt; | &gt; | &gt;&gt; ) word; fill in np-&gt;io[] */
int
setio(Node *np)
{
	if(t == '&lt;'){
		t = gettoken();
		np-&gt;io[0] = token;
	}else if(t == '&gt;'){
		t = gettoken();
		if(t == '&gt;'){
			t = gettoken();
			np-&gt;io[2] = token;
			}else
			np-&gt;io[1] = token;
	}else
		return 0;
	if(t != WORD)
		return 0;
	return 1;
}
			
/* simple - word ( [ &lt; | &gt; | &gt;&gt; ] word )* */
Node*
simple(void)
{
	Node *np;
	int n = 1;

	if(t != WORD)
		return 0;
	np = alloc(xsimple);
	np-&gt;argv[0] = token;
	while((t = gettoken())==WORD || t=='&lt;' || t=='&gt;')
		if(t == WORD)
			np-&gt;argv[n++] = token;
		else if(!setio(np))
			return 0;
	np-&gt;argv[n] = 0;
	return np;
}

/* xpipeline - execute cmd | cmd */
int
xpipeline(Node *np)
{
	int pid, fd[2];

	if(pipe(fd) &lt; 0){
		error("can't create pipe", "");
		return 0;
	}
	if((pid=fork()) == 0){	/* left side; redirect stdout */
		dup(fd[1], 1);
		close(fd[0]);
		close(fd[1]);
		execute(np-&gt;args[0]);
		exits(status);
	}else if(pid == -1){
		error("can't create process", "");
		return 0;
	}
	if((pid=fork()) == 0){	/* right side; redirect stdin */
		dup(fd[0], 0);
		close(fd[0]);
		close(fd[1]);
		pid = execute(np-&gt;args[1]); /*BUG: this is wrong sometimes*/
		if(pid &gt; 0)
			while(waitpid()!=pid)
				;
		exits(0);
	}else if(pid == -1){
		error("can't create process", "");
		return 0;
	}
	close(fd[0]);	/* avoid using up fd's */
	close(fd[1]);
	return pid;
}

/* xsimple - execute a simple command */
int
xsimple(Node *np)
{
	char name[MAXLINE];
	int pid, i;

	if(builtin(np))
		return 0;
	if(pid = fork()){
		if(pid == -1)
			error(": can't create process", np-&gt;argv[0]);
		return pid;
	}
	redirect(np);	/* child process */
	exec(np-&gt;argv[0], &amp;np-&gt;argv[0]);
	i = np-&gt;argv[0][0];
	if(i!='/' &amp;&amp; i!='#' &amp;&amp; (i!='.' || np-&gt;argv[0][1]!='/'))
		for(i = 0; path[i]; i++){
			sprint(name, "%s/%s", path[i], np-&gt;argv[0]);
			exec(name, &amp;np-&gt;argv[0]);
		}
	error(": not found", np-&gt;argv[0]);
	exits("not found");
	return -1;		// suppress compiler warnings
}

/* xsubshell - execute (cmd) */
int
xsubshell(Node *np)
{
	int pid;

	if(pid = fork()){
		if(pid == -1)
			error("can't create process", "");
		return pid;
	}
	redirect(np);	/* child process */
	execute(np-&gt;args[0]);
	exits(status);
	return -1;		// suppress compiler warnings
}

/* xnowait - execute cmd &amp; */
int
xnowait(Node *np)
{
	int pid;

	execute(np-&gt;args[0]);
	pid = execute(np-&gt;args[1]);
	if(interactive)
		fprint(2, "%d\n", pid);
	return 0;
}

/* xwait - execute cmd ; */
int xwait(Node *np)
{
	int pid;
	Waitmsg *wmsg;

	execute(np-&gt;args[0]);
	pid = execute(np-&gt;args[1]);
	if(pid &gt; 0){
		while((wmsg = wait()) != nil){
			if(wmsg-&gt;pid == pid)
				break;
			free(wmsg);
		}
		if(wmsg == nil)
			error("wait error", "");
		else {
			strncpy(status, wmsg-&gt;msg, sizeof(status)-1);
			free(wmsg);
		}
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

