<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/snap/take.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/snap/take.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;
#include "snap.h"

/* research 16-bit crc.  good enough. */
static ulong
sumr(ulong sum, void *buf, int n)
{
	uchar *s, *send;

	if(buf == 0)
		return sum;
	for(s=buf, send=s+n; s&lt;send; s++)
		if(sum &amp; 1)
			sum = 0xffff &amp; ((sum&gt;&gt;1)+*s+0x8000);
		else
			sum = 0xffff &amp; ((sum&gt;&gt;1)+*s);
	return sum;
}

static int npage;
static Page *pgtab[1&lt;&lt;10];

Page*
datapage(char *p, long len)
{
	Page *pg;
	char *q, *ep;
	long	sum;
	int iszero;

	if(len &gt; Pagesize) {
		fprint(2, "datapage cannot handle pages &gt; 1024\n");
		exits("datapage");
	}

	sum = sumr(0, p, len) &amp; (nelem(pgtab)-1);
	if(sum == 0) {
		iszero = 1;
		for(q=p, ep=p+len; q&lt;ep; q++)
			if(*q != 0) {
				iszero = 0;
				break;
			}
	} else
		iszero = 0;

	for(pg = pgtab[sum]; pg; pg=pg-&gt;link)
		if(pg-&gt;len == len &amp;&amp; memcmp(pg-&gt;data, p, len) == 0)
			break;
	if(pg)
		return pg;

	pg = emalloc(sizeof(*pg)+len);
	pg-&gt;data = (char*)&amp;pg[1];
	pg-&gt;type = 0;
	pg-&gt;len = len;
	memmove(pg-&gt;data, p, len);
	pg-&gt;link = pgtab[sum];
	pgtab[sum] = pg;
	if(iszero) {
		pg-&gt;type = 'z';
		pg-&gt;written = 1;
	}

	++npage;
	return pg;
}

static Data*
readsection(long pid, char *sec)
{
	char buf[8192];
	int n, fd;
	int hdr, tot;
	Data *d = nil;

	snprint(buf, sizeof buf, "/proc/%ld/%s", pid, sec);
	if((fd = open(buf, OREAD)) &lt; 0)
		return nil;

	tot = 0;
	hdr = (int)((Data*)0)-&gt;data;
	while((n = read(fd, buf, sizeof buf)) &gt; 0) {
		d = erealloc(d, tot+n+hdr);
		memmove(d-&gt;data+tot, buf, n);
		tot += n;
	}
	close(fd);
	if(d == nil)
		return nil;
	d-&gt;len = tot;
	return d;
}

static Seg*
readseg(int fd, vlong off, ulong len, char *name)
{
	char buf[Pagesize];
	Page **pg;
	int npg;
	Seg *s;
	ulong i;
	int n;

	s = emalloc(sizeof(*s));
	s-&gt;name = estrdup(name);

	if(seek(fd, off, 0) &lt; 0) {
		fprint(2, "seek fails\n");
		goto Die;
	}

	pg = nil;
	npg = 0;
	for(i=0; i&lt;len; ) {
		n = Pagesize;
		if(n &gt; len-i)
			n = len-i;
		if((n = readn(fd, buf, n)) &lt;= 0)
			break;
		pg = erealloc(pg, sizeof(*pg)*(npg+1));
		pg[npg++] = datapage(buf, n);
		i += n;
		if(n != Pagesize)	/* any short read, planned or otherwise */
			break;
	}

	if(i==0 &amp;&amp; len!=0)
		goto Die;

	s-&gt;offset = off;
	s-&gt;len = i;
	s-&gt;pg = pg;
	s-&gt;npg = npg;
	return s;

Die:
	free(s-&gt;name);
	free(s);
	return nil;
}

/* discover the stack pointer of the given process */
ulong
stackptr(Proc *proc, int fd)
{
	char *q;
	Fhdr f;
	Reglist *r;
	long textoff;
	int i;
	Data *dreg;

	textoff = -1;
	for(i=0; i&lt;proc-&gt;nseg; i++)
		if(proc-&gt;seg[i] &amp;&amp; strcmp(proc-&gt;seg[i]-&gt;name, "Text") == 0)
			textoff = proc-&gt;seg[i]-&gt;offset;

	if(textoff == -1)
		return 0;

	seek(fd, textoff, 0);
	if(crackhdr(fd, &amp;f) == 0)
		return 0;

	machbytype(f.type);
	for(r=mach-&gt;reglist; r-&gt;rname; r++)
		if(strcmp(r-&gt;rname, mach-&gt;sp) == 0)
			break;
	if(r == nil) {
		fprint(2, "couldn't find stack pointer register?\n");
		return 0;
	}
	
	if((dreg = proc-&gt;d[Pregs]) == nil)
		return 0;

	if(r-&gt;roffs+mach-&gt;szreg &gt; dreg-&gt;len) {
		fprint(2, "SP register too far into registers?\n");
		return 0;
	}

	q = dreg-&gt;data+r-&gt;roffs;
	switch(mach-&gt;szreg) {
	case 2:	return machdata-&gt;swab(*(ushort*)q);
	case 4:	return machdata-&gt;swal(*(ulong*)q);
	case 8:	return machdata-&gt;swav(*(uvlong*)q);
	default:
		fprint(2, "register size is %d bytes?\n", mach-&gt;szreg);
		return 0;
	}
}

Proc*
snap(long pid, int usetext)
{
	Data *d;
	Proc *proc;
	Seg **s;
	char *name, *segdat, *q, *f[128+1], buf[128];
	int fd, i, stacki, nf, np;
	uvlong off, len, stackoff, stacklen;
	uvlong sp;

	proc = emalloc(sizeof(*proc));
	proc-&gt;pid = pid;

	np = 0;
	for(i=0; i&lt;Npfile; i++) {
		if(proc-&gt;d[i] = readsection(pid, pfile[i]))
			np++;
		else
			fprint(2, "warning: can't include /proc/%ld/%s\n", pid, pfile[i]);
	}
	if(np == 0)
		return nil;

	if(usetext) {
		snprint(buf, sizeof buf, "/proc/%ld/text", pid);
		if((fd = open(buf, OREAD)) &gt;= 0) {
			werrstr("");
			if((proc-&gt;text = readseg(fd, 0, 1&lt;&lt;31, "textfile")) == nil)
				fprint(2, "warning: can't include %s: %r\n", buf);
			close(fd);
		} else
			fprint(2, "warning: can't include /proc/%ld/text\n", pid);
	}

	if((d=proc-&gt;d[Psegment]) == nil) {
		fprint(2, "warning: no segment table, no memory image\n");
		return proc;
	}

	segdat = emalloc(d-&gt;len+1);
	memmove(segdat, d-&gt;data, d-&gt;len);
	segdat[d-&gt;len] = 0;

	nf = getfields(segdat, f, nelem(f), 1, "\n");
	if(nf == nelem(f)) {
		nf--;
		fprint(2, "process %ld has &gt;%d segments; only using first %d\n",
			pid, nf, nf);
	}
	if(nf &lt;= 0) {
		fprint(2, "warning: couldn't understand segment table, no memory image\n");
		free(segdat);
		return proc;
	}

	snprint(buf, sizeof buf, "/proc/%ld/mem", pid);
	if((fd = open(buf, OREAD)) &lt; 0) {
		fprint(2, "warning: can't include /proc/%ld/mem\n", pid);
		return proc;
	}

	s = emalloc(nf*sizeof(*s));
	stacklen = 0;
	stackoff = 0;
	stacki = 0;
	for(i=0; i&lt;nf; i++) {
		if(q = strchr(f[i], ' ')) 
			*q = 0;
		name = f[i];
		off = strtoull(name+10, &amp;q, 16);
		len = strtoull(q, &amp;q, 16) - off;
		if(strcmp(name, "Stack") == 0) {
			stackoff = off;
			stacklen = len;
			stacki = i;
		} else
			s[i] = readseg(fd, off, len, name);
	}
	proc-&gt;nseg = nf;
	proc-&gt;seg = s;

	/* stack hack: figure sp so don't need to page in the whole segment */
	if(stacklen) {
		sp = stackptr(proc, fd);
		if(stackoff &lt;= sp &amp;&amp; sp &lt; stackoff+stacklen) {
			off = (sp - Pagesize) &amp; ~(Pagesize - 1);
			if(off &lt; stackoff)
				off = stackoff;
			len = stacklen - (off - stackoff);
		} else {	/* stack pointer not in segment.  thread library? */
			off = stackoff + stacklen - 16*1024;
			len = 16*1024;
		}
		s[stacki] = readseg(fd, off, len, "Stack");
	}

	return proc;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

