<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/mesg.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/mesg.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: mesg.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

#ifndef MAXQ
#define MAXQ	2500		/* default max # queues  */
#endif

extern RunList	*X;
extern Symbol	*Fname;
extern Lextok	*Mtype;
extern int	verbose, TstOnly, s_trail, analyze, columns;
extern int	lineno, depth, xspin, m_loss, jumpsteps;
extern int	nproc, nstop;
extern short	Have_claim;

Queue	*qtab = (Queue *) 0;	/* linked list of queues */
Queue	*ltab[MAXQ];		/* linear list of queues */
int	nqs = 0, firstrow = 1;
char	Buf[4096];

static Lextok	*n_rem = (Lextok *) 0;
static Queue	*q_rem = (Queue  *) 0;

static int	a_rcv(Queue *, Lextok *, int);
static int	a_snd(Queue *, Lextok *);
static int	sa_snd(Queue *, Lextok *);
static int	s_snd(Queue *, Lextok *);
extern void	sr_buf(int, int);
extern void	sr_mesg(FILE *, int, int);
extern void	putarrow(int, int);
static void	sr_talk(Lextok *, int, char *, char *, int, Queue *);

int
cnt_mpars(Lextok *n)
{	Lextok *m;
	int i=0;

	for (m = n; m; m = m-&gt;rgt)
		i += Cnt_flds(m);
	return i;
}

int
qmake(Symbol *s)
{	Lextok *m;
	Queue *q;
	int i;

	if (!s-&gt;ini)
		return 0;

	if (nqs &gt;= MAXQ)
	{	lineno = s-&gt;ini-&gt;ln;
		Fname  = s-&gt;ini-&gt;fn;
		fatal("too many queues (%s)", s-&gt;name);
	}
	if (analyze &amp;&amp; nqs &gt;= 255)
	{	fatal("too many channel types", (char *)0);
	}

	if (s-&gt;ini-&gt;ntyp != CHAN)
		return eval(s-&gt;ini);

	q = (Queue *) emalloc(sizeof(Queue));
	q-&gt;qid    = ++nqs;
	q-&gt;nslots = s-&gt;ini-&gt;val;
	q-&gt;nflds  = cnt_mpars(s-&gt;ini-&gt;rgt);
	q-&gt;setat  = depth;

	i = max(1, q-&gt;nslots);	/* 0-slot qs get 1 slot minimum */

	q-&gt;contents  = (int *) emalloc(q-&gt;nflds*i*sizeof(int));
	q-&gt;fld_width = (int *) emalloc(q-&gt;nflds*sizeof(int));
	q-&gt;stepnr = (int *)   emalloc(i*sizeof(int));

	for (m = s-&gt;ini-&gt;rgt, i = 0; m; m = m-&gt;rgt)
	{	if (m-&gt;sym &amp;&amp; m-&gt;ntyp == STRUCT)
			i = Width_set(q-&gt;fld_width, i, getuname(m-&gt;sym));
		else
			q-&gt;fld_width[i++] = m-&gt;ntyp;
	}
	q-&gt;nxt = qtab;
	qtab = q;
	ltab[q-&gt;qid-1] = q;

	return q-&gt;qid;
}

int
qfull(Lextok *n)
{	int whichq = eval(n-&gt;lft)-1;

	if (whichq &lt; MAXQ &amp;&amp; whichq &gt;= 0 &amp;&amp; ltab[whichq])
		return (ltab[whichq]-&gt;qlen &gt;= ltab[whichq]-&gt;nslots);
	return 0;
}

int
qlen(Lextok *n)
{	int whichq = eval(n-&gt;lft)-1;

	if (whichq &lt; MAXQ &amp;&amp; whichq &gt;= 0 &amp;&amp; ltab[whichq])
		return ltab[whichq]-&gt;qlen;
	return 0;
}

int
q_is_sync(Lextok *n)
{	int whichq = eval(n-&gt;lft)-1;

	if (whichq &lt; MAXQ &amp;&amp; whichq &gt;= 0 &amp;&amp; ltab[whichq])
		return (ltab[whichq]-&gt;nslots == 0);
	return 0;
}

int
qsend(Lextok *n)
{	int whichq = eval(n-&gt;lft)-1;

	if (whichq == -1)
	{	printf("Error: sending to an uninitialized chan\n");
		whichq = 0;
		return 0;
	}
	if (whichq &lt; MAXQ &amp;&amp; whichq &gt;= 0 &amp;&amp; ltab[whichq])
	{	ltab[whichq]-&gt;setat = depth;
		if (ltab[whichq]-&gt;nslots &gt; 0)
			return a_snd(ltab[whichq], n);
		else
			return s_snd(ltab[whichq], n);
	}
	return 0;
}

int
qrecv(Lextok *n, int full)
{	int whichq = eval(n-&gt;lft)-1;

	if (whichq == -1)
	{	if (n-&gt;sym &amp;&amp; !strcmp(n-&gt;sym-&gt;name, "STDIN"))
		{	Lextok *m;

			if (TstOnly) return 1;

			for (m = n-&gt;rgt; m; m = m-&gt;rgt)
			if (m-&gt;lft-&gt;ntyp != CONST &amp;&amp; m-&gt;lft-&gt;ntyp != EVAL)
			{	int c = getchar();
				(void) setval(m-&gt;lft, c);
			} else
				fatal("invalid use of STDIN", (char *)0);

			whichq = 0;
			return 1;
		}
		printf("Error: receiving from an uninitialized chan %s\n",
			n-&gt;sym?n-&gt;sym-&gt;name:"");
		whichq = 0;
		return 0;
	}
	if (whichq &lt; MAXQ &amp;&amp; whichq &gt;= 0 &amp;&amp; ltab[whichq])
	{	ltab[whichq]-&gt;setat = depth;
		return a_rcv(ltab[whichq], n, full);
	}
	return 0;
}

static int
sa_snd(Queue *q, Lextok *n)	/* sorted asynchronous */
{	Lextok *m;
	int i, j, k;
	int New, Old;

	for (i = 0; i &lt; q-&gt;qlen; i++)
	for (j = 0, m = n-&gt;rgt; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
	{	New = cast_val(q-&gt;fld_width[j], eval(m-&gt;lft), 0);
		Old = q-&gt;contents[i*q-&gt;nflds+j];
		if (New == Old)
			continue;
		if (New &gt;  Old)
			break;	/* inner loop */
		goto found;	/* New &lt; Old */
	}
found:
	for (j = q-&gt;qlen-1; j &gt;= i; j--)
	for (k = 0; k &lt; q-&gt;nflds; k++)
	{	q-&gt;contents[(j+1)*q-&gt;nflds+k] =
			q-&gt;contents[j*q-&gt;nflds+k];	/* shift up */
		if (k == 0)
			q-&gt;stepnr[j+1] = q-&gt;stepnr[j];
	}
	return i*q-&gt;nflds;				/* new q offset */
}

void
typ_ck(int ft, int at, char *s)
{
	if ((verbose&amp;32) &amp;&amp; ft != at
	&amp;&amp; (ft == CHAN || at == CHAN))
	{	char buf[128], tag1[64], tag2[64];
		(void) sputtype(tag1, ft);
		(void) sputtype(tag2, at);
		sprintf(buf, "type-clash in %s, (%s&lt;-&gt; %s)", s, tag1, tag2);
		non_fatal("%s", buf);
	}
}

static int
a_snd(Queue *q, Lextok *n)
{	Lextok *m;
	int i = q-&gt;qlen*q-&gt;nflds;	/* q offset */
	int j = 0;			/* q field# */

	if (q-&gt;nslots &gt; 0 &amp;&amp; q-&gt;qlen &gt;= q-&gt;nslots)
		return m_loss;	/* q is full */

	if (TstOnly) return 1;

	if (n-&gt;val) i = sa_snd(q, n);	/* sorted insert */

	q-&gt;stepnr[i/q-&gt;nflds] = depth;

	for (m = n-&gt;rgt; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
	{	int New = eval(m-&gt;lft);
		q-&gt;contents[i+j] = cast_val(q-&gt;fld_width[j], New, 0);
		if ((verbose&amp;16) &amp;&amp; depth &gt;= jumpsteps)
			sr_talk(n, New, "Send ", "-&gt;", j, q);
		typ_ck(q-&gt;fld_width[j], Sym_typ(m-&gt;lft), "send");
	}
	if ((verbose&amp;16) &amp;&amp; depth &gt;= jumpsteps)
	{	for (i = j; i &lt; q-&gt;nflds; i++)
			sr_talk(n, 0, "Send ", "-&gt;", i, q);
		if (j &lt; q-&gt;nflds)
			printf("%3d: warning: missing params in send\n",
				depth);
		if (m)
			printf("%3d: warning: too many params in send\n",
				depth);
	}
	q-&gt;qlen++;
	return 1;
}

static int
a_rcv(Queue *q, Lextok *n, int full)
{	Lextok *m;
	int i=0, oi, j, k;
	extern int Rvous;

	if (q-&gt;qlen == 0)
		return 0;	/* q is empty */
try_slot:
	/* test executability */
	for (m = n-&gt;rgt, j=0; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
		if ((m-&gt;lft-&gt;ntyp == CONST
		   &amp;&amp; q-&gt;contents[i*q-&gt;nflds+j] != m-&gt;lft-&gt;val)
		||  (m-&gt;lft-&gt;ntyp == EVAL
		   &amp;&amp; q-&gt;contents[i*q-&gt;nflds+j] != eval(m-&gt;lft-&gt;lft)))
		{	if (n-&gt;val == 0		/* fifo recv */
			||  n-&gt;val == 2		/* fifo poll */
			|| ++i &gt;= q-&gt;qlen)	/* last slot */
				return 0;	/* no match  */
			goto try_slot;
		}
	if (TstOnly) return 1;

	if (verbose&amp;8)
	{	if (j &lt; q-&gt;nflds)
			printf("%3d: warning: missing params in next recv\n",
				depth);
		else if (m)
			printf("%3d: warning: too many params in next recv\n",
				depth);
	}

	/* set the fields */
	if (Rvous)
	{	n_rem = n;
		q_rem = q;
	}

	oi = q-&gt;stepnr[i];
	for (m = n-&gt;rgt, j = 0; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
	{	if (columns &amp;&amp; !full)	/* was columns == 1 */
			continue;
		if ((verbose&amp;8) &amp;&amp; !Rvous &amp;&amp; depth &gt;= jumpsteps)
		{	sr_talk(n, q-&gt;contents[i*q-&gt;nflds+j],
			(full &amp;&amp; n-&gt;val &lt; 2)?"Recv ":"[Recv] ", "&lt;-", j, q);
		}
		if (!full)
			continue;	/* test */
		if (m &amp;&amp; m-&gt;lft-&gt;ntyp != CONST &amp;&amp; m-&gt;lft-&gt;ntyp != EVAL)
		{	(void) setval(m-&gt;lft, q-&gt;contents[i*q-&gt;nflds+j]);
			typ_ck(q-&gt;fld_width[j], Sym_typ(m-&gt;lft), "recv");
		}
		if (n-&gt;val &lt; 2)		/* not a poll */
		for (k = i; k &lt; q-&gt;qlen-1; k++)
		{	q-&gt;contents[k*q-&gt;nflds+j] =
			  q-&gt;contents[(k+1)*q-&gt;nflds+j];
			if (j == 0)
			  q-&gt;stepnr[k] = q-&gt;stepnr[k+1];
		}
	}

	if ((!columns || full)
	&amp;&amp; (verbose&amp;8) &amp;&amp; !Rvous &amp;&amp; depth &gt;= jumpsteps)
	for (i = j; i &lt; q-&gt;nflds; i++)
	{	sr_talk(n, 0,
		(full &amp;&amp; n-&gt;val &lt; 2)?"Recv ":"[Recv] ", "&lt;-", i, q);
	}
	if (columns == 2 &amp;&amp; full &amp;&amp; !Rvous &amp;&amp; depth &gt;= jumpsteps)
		putarrow(oi, depth);

	if (full &amp;&amp; n-&gt;val &lt; 2)
		q-&gt;qlen--;
	return 1;
}

static int
s_snd(Queue *q, Lextok *n)
{	Lextok *m;
	RunList *rX, *sX = X;	/* rX=recvr, sX=sendr */
	int i, j = 0;	/* q field# */

	for (m = n-&gt;rgt; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
	{	q-&gt;contents[j] = cast_val(q-&gt;fld_width[j], eval(m-&gt;lft), 0);
		typ_ck(q-&gt;fld_width[j], Sym_typ(m-&gt;lft), "rv-send");
	}
	q-&gt;qlen = 1;
	if (!complete_rendez())
	{	q-&gt;qlen = 0;
		return 0;
	}
	if (TstOnly)
	{	q-&gt;qlen = 0;
		return 1;
	}
	q-&gt;stepnr[0] = depth;
	if ((verbose&amp;16) &amp;&amp; depth &gt;= jumpsteps)
	{	m = n-&gt;rgt;
		rX = X; X = sX;
		for (j = 0; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
			sr_talk(n, eval(m-&gt;lft), "Sent ", "-&gt;", j, q);
		for (i = j; i &lt; q-&gt;nflds; i++)
			sr_talk(n, 0, "Sent ", "-&gt;", i, q);
		if (j &lt; q-&gt;nflds)
			  printf("%3d: warning: missing params in rv-send\n",
				depth);
		else if (m)
			  printf("%3d: warning: too many params in rv-send\n",
				depth);
		X = rX;	/* restore receiver's context */
		if (!s_trail)
		{	if (!n_rem || !q_rem)
				fatal("cannot happen, s_snd", (char *) 0);
			m = n_rem-&gt;rgt;
			for (j = 0; m &amp;&amp; j &lt; q-&gt;nflds; m = m-&gt;rgt, j++)
			{	if (m-&gt;lft-&gt;ntyp != NAME
				||  strcmp(m-&gt;lft-&gt;sym-&gt;name, "_") != 0)
					i = eval(m-&gt;lft);
				else	i = 0;

				if (verbose&amp;8)
				sr_talk(n_rem,i,"Recv ","&lt;-",j,q_rem);
			}
			if (verbose&amp;8)
			for (i = j; i &lt; q-&gt;nflds; i++)
				sr_talk(n_rem, 0, "Recv ", "&lt;-", j, q_rem);
			if (columns == 2)
				putarrow(depth, depth);
		}
		n_rem = (Lextok *) 0;
		q_rem = (Queue *) 0;
	}
	return 1;
}

static void
channm(Lextok *n)
{	char lbuf[512];

	if (n-&gt;sym-&gt;type == CHAN)
		strcat(Buf, n-&gt;sym-&gt;name);
	else if (n-&gt;sym-&gt;type == NAME)
		strcat(Buf, lookup(n-&gt;sym-&gt;name)-&gt;name);
	else if (n-&gt;sym-&gt;type == STRUCT)
	{	Symbol *r = n-&gt;sym;
		if (r-&gt;context)
		{	r = findloc(r);
			if (!r)
			{	strcat(Buf, "*?*");
				return;
		}	}
		ini_struct(r);
		printf("%s", r-&gt;name);
		strcpy(lbuf, "");
		struct_name(n-&gt;lft, r, 1, lbuf);
		strcat(Buf, lbuf);
	} else
		strcat(Buf, "-");
	if (n-&gt;lft-&gt;lft)
	{	sprintf(lbuf, "[%d]", eval(n-&gt;lft-&gt;lft));
		strcat(Buf, lbuf);
	}
}

static void
difcolumns(Lextok *n, char *tr, int v, int j, Queue *q)
{	extern int pno;

	if (j == 0)
	{	Buf[0] = '\0';
		channm(n);
		strcat(Buf, (strncmp(tr, "Sen", 3))?"?":"!");
	} else
		strcat(Buf, ",");
	if (tr[0] == '[') strcat(Buf, "[");
	sr_buf(v, q-&gt;fld_width[j] == MTYPE);
	if (j == q-&gt;nflds - 1)
	{	int cnr;
		if (s_trail) cnr = pno; else cnr = X?X-&gt;pid - Have_claim:0;
		if (tr[0] == '[') strcat(Buf, "]");
		pstext(cnr, Buf);
	}
}

static void
docolumns(Lextok *n, char *tr, int v, int j, Queue *q)
{	int i;

	if (firstrow)
	{	printf("q\\p");
		for (i = 0; i &lt; nproc-nstop - Have_claim; i++)
			printf(" %3d", i);
		printf("\n");
		firstrow = 0;
	}
	if (j == 0)
	{	printf("%3d", q-&gt;qid);
		if (X)
		for (i = 0; i &lt; X-&gt;pid - Have_claim; i++)
			printf("   .");
		printf("   ");
		Buf[0] = '\0';
		channm(n);
		printf("%s%c", Buf, (strncmp(tr, "Sen", 3))?'?':'!');
	} else
		printf(",");
	if (tr[0] == '[') printf("[");
	sr_mesg(stdout, v, q-&gt;fld_width[j] == MTYPE);
	if (j == q-&gt;nflds - 1)
	{	if (tr[0] == '[') printf("]");
		printf("\n");
	}
}

typedef struct QH {
	int	n;
	struct	QH *nxt;
} QH;
static QH *qh;

void
qhide(int q)
{	QH *p = (QH *) emalloc(sizeof(QH));
	p-&gt;n = q;
	p-&gt;nxt = qh;
	qh = p;
}

int
qishidden(int q)
{	QH *p;
	for (p = qh; p; p = p-&gt;nxt)
		if (p-&gt;n == q)
			return 1;
	return 0;
}

static void
sr_talk(Lextok *n, int v, char *tr, char *a, int j, Queue *q)
{	char s[128];

	if (qishidden(eval(n-&gt;lft)))
		return;

	if (columns)
	{	if (columns == 2)
			difcolumns(n, tr, v, j, q);
		else
			docolumns(n, tr, v, j, q);
		return;
	}
	if (xspin)
	{	if ((verbose&amp;4) &amp;&amp; tr[0] != '[')
		sprintf(s, "(state -)\t[values: %d",
			eval(n-&gt;lft));
		else
		sprintf(s, "(state -)\t[%d", eval(n-&gt;lft));
		if (strncmp(tr, "Sen", 3) == 0)
			strcat(s, "!");
		else
			strcat(s, "?");
	} else
	{	strcpy(s, tr);
	}

	if (j == 0)
	{	char snm[128];
		whoruns(1);
		{	char *ptr = n-&gt;fn-&gt;name;
			char *qtr = snm;
			while (*ptr != '\0')
			{	if (*ptr != '\"')
				{	*qtr++ = *ptr;
				}
				ptr++;
			}
			*qtr = '\0';
			printf("%s:%d %s",
				snm, n-&gt;ln, s);
		}
	} else
		printf(",");
	sr_mesg(stdout, v, q-&gt;fld_width[j] == MTYPE);

	if (j == q-&gt;nflds - 1)
	{	if (xspin)
		{	printf("]\n");
			if (!(verbose&amp;4)) printf("\n");
			return;
		}
		printf("\t%s queue %d (", a, eval(n-&gt;lft));
		Buf[0] = '\0';
		channm(n);
		printf("%s)\n", Buf);
	}
	fflush(stdout);
}

void
sr_buf(int v, int j)
{	int cnt = 1; Lextok *n;
	char lbuf[512];

	for (n = Mtype; n &amp;&amp; j; n = n-&gt;rgt, cnt++)
		if (cnt == v)
		{	if(strlen(n-&gt;lft-&gt;sym-&gt;name) &gt;= sizeof(lbuf))
			{	non_fatal("mtype name %s too long", n-&gt;lft-&gt;sym-&gt;name);
				break;
			}
			sprintf(lbuf, "%s", n-&gt;lft-&gt;sym-&gt;name);
			strcat(Buf, lbuf);
			return;
		}
	sprintf(lbuf, "%d", v);
	strcat(Buf, lbuf);
}

void
sr_mesg(FILE *fd, int v, int j)
{	Buf[0] ='\0';
	sr_buf(v, j);
	fprintf(fd, Buf);
}

void
doq(Symbol *s, int n, RunList *r)
{	Queue *q;
	int j, k;

	if (!s-&gt;val)	/* uninitialized queue */
		return;
	for (q = qtab; q; q = q-&gt;nxt)
	if (q-&gt;qid == s-&gt;val[n])
	{	if (xspin &gt; 0
		&amp;&amp; (verbose&amp;4)
		&amp;&amp; q-&gt;setat &lt; depth)
			continue;
		if (q-&gt;nslots == 0)
			continue; /* rv q always empty */
#if 0
		if (q-&gt;qlen == 0)	/* new 7/10 -- dont show if queue is empty */
		{	continue;
		}
#endif
		printf("\t\tqueue %d (", q-&gt;qid);
		if (r)
		printf("%s(%d):", r-&gt;n-&gt;name, r-&gt;pid - Have_claim);
		if (s-&gt;nel &gt; 1 || s-&gt;isarray)
		  printf("%s[%d]): ", s-&gt;name, n);
		else
		  printf("%s): ", s-&gt;name);
		for (k = 0; k &lt; q-&gt;qlen; k++)
		{	printf("[");
			for (j = 0; j &lt; q-&gt;nflds; j++)
			{	if (j &gt; 0) printf(",");
				sr_mesg(stdout, q-&gt;contents[k*q-&gt;nflds+j],
					q-&gt;fld_width[j] == MTYPE);
			}
			printf("]");
		}
		printf("\n");
		break;
	}
}

void
nochan_manip(Lextok *p, Lextok *n, int d)
{	int e = 1;

	if (d == 0 &amp;&amp; p-&gt;sym &amp;&amp; p-&gt;sym-&gt;type == CHAN)
	{	setaccess(p-&gt;sym, ZS, 0, 'L');

		if (n &amp;&amp; n-&gt;ntyp == CONST)
			fatal("invalid asgn to chan", (char *) 0);

		if (n &amp;&amp; n-&gt;sym &amp;&amp; n-&gt;sym-&gt;type == CHAN)
		{	setaccess(n-&gt;sym, ZS, 0, 'V');
			return;
		}	
	}

	/* ok on the rhs of an assignment: */
	if (!n || n-&gt;ntyp == LEN || n-&gt;ntyp == RUN
	||  n-&gt;ntyp == FULL  || n-&gt;ntyp == NFULL
	||  n-&gt;ntyp == EMPTY || n-&gt;ntyp == NEMPTY)
		return;

	if (n-&gt;sym &amp;&amp; n-&gt;sym-&gt;type == CHAN)
	{	if (d == 1)
			fatal("invalid use of chan name", (char *) 0);
		else
			setaccess(n-&gt;sym, ZS, 0, 'V');	
	}

	if (n-&gt;ntyp == NAME
	||  n-&gt;ntyp == '.')
		e = 0;	/* array index or struct element */

	nochan_manip(p, n-&gt;lft, e);
	nochan_manip(p, n-&gt;rgt, 1);
}

typedef struct BaseName {
	char *str;
	int cnt;
	struct BaseName *nxt;
} BaseName;
BaseName *bsn;

void
newbasename(char *s)
{	BaseName *b;

/*	printf("+++++++++%s\n", s);	*/
	for (b = bsn; b; b = b-&gt;nxt)
		if (strcmp(b-&gt;str, s) == 0)
		{	b-&gt;cnt++;
			return;
		}
	b = (BaseName *) emalloc(sizeof(BaseName));
	b-&gt;str = emalloc(strlen(s)+1);
	b-&gt;cnt = 1;
	strcpy(b-&gt;str, s);
	b-&gt;nxt = bsn;
	bsn = b;
}

void
delbasename(char *s)
{	BaseName *b, *prv = (BaseName *) 0;

	for (b = bsn; b; prv = b, b = b-&gt;nxt)
	{	if (strcmp(b-&gt;str, s) == 0)
		{	b-&gt;cnt--;
			if (b-&gt;cnt == 0)
			{	if (prv)
				{	prv-&gt;nxt = b-&gt;nxt;
				} else
				{	bsn = b-&gt;nxt;
			}	}
/*	printf("---------%s\n", s);	*/
			break;
	}	}
}

void
checkindex(char *s, char *t)
{	BaseName *b;

/*	printf("xxx Check %s (%s)\n", s, t);	*/
	for (b = bsn; b; b = b-&gt;nxt)
	{
/*		printf("	%s\n", b-&gt;str);	*/
		if (strcmp(b-&gt;str, s) == 0)
		{	non_fatal("do not index an array with itself (%s)", t);
			break;
	}	}
}

void
scan_tree(Lextok *t, char *mn, char *mx)
{	char sv[512];
	char tmp[32];
	int oln = lineno;

	if (!t) return;

	lineno = t-&gt;ln;

	if (t-&gt;ntyp == NAME)
	{	strcat(mn, t-&gt;sym-&gt;name);
		strcat(mx, t-&gt;sym-&gt;name);
		if (t-&gt;lft)		/* array index */
		{	strcat(mn, "[]");
			newbasename(mn);
				strcpy(sv, mn);		/* save */
				strcpy(mn, "");		/* clear */
				strcat(mx, "[");
				scan_tree(t-&gt;lft, mn, mx);	/* index */
				strcat(mx, "]");
				checkindex(mn, mx);	/* match against basenames */
				strcpy(mn, sv);		/* restore */
			delbasename(mn);
		}
		if (t-&gt;rgt)	/* structure element */
		{	scan_tree(t-&gt;rgt, mn, mx);
		}
	} else if (t-&gt;ntyp == CONST)
	{	strcat(mn, "1"); /* really: t-&gt;val */
		sprintf(tmp, "%d", t-&gt;val);
		strcat(mx, tmp);
	} else if (t-&gt;ntyp == '.')
	{	strcat(mn, ".");
		strcat(mx, ".");
		scan_tree(t-&gt;lft, mn, mx);
	} else
	{	strcat(mn, "??");
		strcat(mx, "??");
	}
	lineno = oln;
}

void
no_nested_array_refs(Lextok *n)	/* a [ a[1] ] with a[1] = 1, causes trouble in pan.b */
{	char mn[512];
	char mx[512];

/*	printf("==================================ZAP\n");	*/
	bsn = (BaseName *) 0;	/* start new list */
	strcpy(mn, "");
	strcpy(mx, "");

	scan_tree(n, mn, mx);
/*	printf("==&gt; %s\n", mn);	*/
}

void
no_internals(Lextok *n)
{	char *sp;

	if (!n-&gt;sym
	||  !n-&gt;sym-&gt;name)
		return;

	sp = n-&gt;sym-&gt;name;

	if ((strlen(sp) == strlen("_nr_pr") &amp;&amp; strcmp(sp, "_nr_pr") == 0)
	||  (strlen(sp) == strlen("_p") &amp;&amp; strcmp(sp, "_p") == 0))
	{	fatal("attempt to assign value to system variable %s", sp);
	}

	no_nested_array_refs(n);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

