<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen1.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */
/* (c) 2007: small additions for V5.0 to support multi-core verifications */

#include "spin.h"
#include "y.tab.h"
#include "pangen1.h"
#include "pangen3.h"
#include "pangen6.h"
#include &lt;assert.h&gt;

extern FILE	*tc, *th, *tt;
extern Label	*labtab;
extern Ordered	*all_names;
extern ProcList	*rdy;
extern Queue	*qtab;
extern Symbol	*Fname;
extern int	lineno, verbose, Pid, separate, old_scope_rules, nclaims;
extern int	nrRdy, nqs, mst, Mpars, claimnr, eventmapnr;
extern short	has_sorted, has_random, has_provided;
extern Queue	*ltab[];

int	Npars=0, u_sync=0, u_async=0, hastrack = 1;
short	has_io = 0;
short	has_state=0;	/* code contains c_state */

static Symbol	*LstSet=ZS;
static int	acceptors=0, progressors=0, nBits=0;
static int	Types[] = { UNSIGNED, BIT, BYTE, CHAN, MTYPE, SHORT, INT, STRUCT };

static int	doglobal(char *, int);
static void	dohidden(void);
static void	do_init(FILE *, Symbol *);
static void	end_labs(Symbol *, int);
static void	put_ptype(char *, int, int, int, enum btypes);
static void	tc_predef_np(void);
static void	put_pinit(ProcList *);
static void	multi_init(void);
       void	walk_struct(FILE *, int, char *, Symbol *, char *, char *, char *);

static void
reverse_names(ProcList *p)
{
	if (!p) return;
	reverse_names(p-&gt;nxt);
	fprintf(th, "   \"%s\",\n", p-&gt;n-&gt;name);
}
static void
reverse_types(ProcList *p)
{
	if (!p) return;
	reverse_types(p-&gt;nxt);
	fprintf(th, "   %d,	/* %s */\n", p-&gt;b, p-&gt;n-&gt;name);
}

static int
blog(int n)	/* for small log2 without rounding problems */
{	int m=1, r=2;

	while (r &lt; n) { m++; r *= 2; }
	return 1+m;
}

void
genheader(void)
{	ProcList *p; int i;

	if (separate == 2)
	{	putunames(th);
		goto here;
	}
	/* 5.2.3: gcc 3 no longer seems to compute sizeof at compile time */
	fprintf(th, "#define WS		%d /* word size in bytes */\n", (int) sizeof(void *));
	fprintf(th, "#define SYNC	%d\n", u_sync);
	fprintf(th, "#define ASYNC	%d\n\n", u_async);
	fprintf(th, "#ifndef NCORE\n");
	fprintf(th, "	#ifdef DUAL_CORE\n");
	fprintf(th, "		#define NCORE	2\n");
	fprintf(th, "	#elif QUAD_CORE\n");
	fprintf(th, "		#define NCORE	4\n");
	fprintf(th, "	#else\n");
	fprintf(th, "		#define NCORE	1\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#endif\n");

	putunames(th);

	fprintf(tc, "short Air[] = { ");
	for (p = rdy, i=0; p; p = p-&gt;nxt, i++)
		fprintf(tc, "%s (short) Air%d", (p!=rdy)?",":"", i);
	fprintf(tc, ", (short) Air%d", i);	/* np_ */
	if (nclaims &gt; 1)
	{	fprintf(tc, "\n#ifndef NOCLAIM\n");
		fprintf(tc, "	, (short) Air%d", i+1);	/* Multi */
		fprintf(tc, "\n#endif\n\t");
	}
	fprintf(tc, " };\n");

	fprintf(th, "char *procname[] = {\n");
		reverse_names(rdy);
	fprintf(th, "   \":np_:\",\n");
	fprintf(th, "};\n\n");

	fprintf(th, "enum btypes { NONE=%d, N_CLAIM=%d,", NONE, N_CLAIM);
	fprintf(th, " I_PROC=%d, A_PROC=%d,", I_PROC, A_PROC);
	fprintf(th, " P_PROC=%d, E_TRACE=%d, N_TRACE=%d };\n",
		P_PROC, E_TRACE, N_TRACE);
	fprintf(th, "int Btypes[] = {\n");
		reverse_types(rdy);
	fprintf(th, "   0	/* :np_: */\n");
	fprintf(th, "};\n\n");

here:
	for (p = rdy; p; p = p-&gt;nxt)
		put_ptype(p-&gt;n-&gt;name, p-&gt;tn, mst, nrRdy+1, p-&gt;b);
		/* +1 for np_ */
	put_ptype("np_", nrRdy, mst, nrRdy+1, 0);

	if (nclaims &gt; 1)
	{	/* this is the structure that goes into the state-vector
		 * instead of the actual never claims
		 * this assumes that the claims do not have any local variables
		 * this claim records the types and states of all subclaims in an array
		 * NB: not sure if we need the first 3 fields in this structure
		 *     it's here for now to avoid breaking some possible dependence
		 * in the calculations above, we were already taking into account
		 * that there is one never-claim, which will now be this one
		 */

		i = blog(mst);
		fprintf(th, "\n");
		fprintf(th, "#ifndef NOCLAIM\n");
		fprintf(th, "	#undef VERI\n");
		fprintf(th, "	#define VERI	%d\n", nrRdy+1);
		fprintf(th, "	#define Pclaim	P%d\n\n", nrRdy+1);
		fprintf(th, "typedef struct P%d {\n", nrRdy+1);
		fprintf(th, "	unsigned _pid : 8; /* always zero */\n");
		fprintf(th, "	unsigned _t   : %d; /* active-claim type  */\n",
			blog(nrRdy+1));
		fprintf(th, "	unsigned _p   : %d; /* active-claim state */\n",
			i);
		fprintf(th, "	unsigned _n   : %d; /* active-claim index */\n",
			blog(nclaims));
		if (i &lt;= 255)	/* in stdint.h = UCHAR_MAX from limits.h */
		{	fprintf(th, "	uchar c_cur[NCLAIMS]; /* claim-states */\n");
		} else if (i &lt;= 65535)	/* really USHRT_MAX from limits.h */
		{	fprintf(th, "	ushort c_cur[NCLAIMS]; /* claim-states */\n");
		} else	/* the most unlikely case */
		{	fprintf(th, "	uint c_cur[NCLAIMS]; /* claim-states */\n");
		}
		fprintf(th, "} P%d;\n", nrRdy+1);
		fprintf(th, "uchar spin_c_typ[NCLAIMS]; /* claim-types */\n");
		fprintf(th, "	#define Air%d	(0)\n\n", nrRdy+1);
		fprintf(th, "#endif\n");
		/*
		 * find special states as:
		 *	stopstate [ claimnr ][ curstate ] == 1
		 *	accpstate [ claimnr ][ curstate ]
		 *	progstate [ claimnr ][ curstate ]
		 *	reached   [ claimnr ][ curstate ]
		 *	visstate  [ claimnr ][ curstate ]
		 *	loopstate [ claimnr ][ curstate ]
		 *	mapstate  [ claimnr ][ curstate ]
		 */
	} else
	{	fprintf(th, "\n#define Pclaim	P0\n");
		fprintf(th, "#ifndef NCLAIMS\n");
		fprintf(th, "	#define NCLAIMS 1\n");
		fprintf(th, "#endif\n");
		fprintf(th, "uchar spin_c_typ[NCLAIMS]; /* claim-types */\n");
	}

	ntimes(th, 0, 1, Head0);

	if (separate != 2)
	{	extern void c_add_stack(FILE *);
		extern void c_stack_size(FILE *);

		ntimes(th, 0, 1, Header);
		fprintf(th, "#define StackSize	(");
			c_stack_size(th);
		fprintf(th, ")\n");

		c_add_stack(th);
		ntimes(th, 0, 1, Header0);
	}
	ntimes(th, 0, 1, Head1);

	LstSet = ZS;
	(void) doglobal("", PUTV);

	hastrack = c_add_sv(th);

	fprintf(th, "#ifdef TRIX\n");
	fprintf(th, "	/* room for 512 proc+chan ptrs, + safety margin */\n");
	fprintf(th, "	char *_ids_[MAXPROC+MAXQ+4];\n");
	fprintf(th, "#else\n");
	fprintf(th, "	uchar sv[VECTORSZ];\n");
	fprintf(th, "#endif\n");

	fprintf(th, "} State");
#ifdef SOLARIS
	fprintf(th,"\n#ifdef GCC\n");
	fprintf(th, "\t__attribute__ ((aligned(8)))");
	fprintf(th, "\n#endif\n\t");
#endif
	fprintf(th, ";\n\n");

	fprintf(th, "#ifdef TRIX\n");
	fprintf(th, "typedef struct TRIX_v6 {\n");
	fprintf(th, "	uchar *body; /* aligned */\n");
	fprintf(th, "#ifndef BFS\n");
	fprintf(th, "	short modified;\n");
	fprintf(th, "#endif\n");
	fprintf(th, "	short psize;\n");
	fprintf(th, "	short parent_pid;\n");
	fprintf(th, "	struct TRIX_v6 *nxt;\n");
	fprintf(th, "} TRIX_v6;\n");
	fprintf(th, "TRIX_v6 *freebodies;\n");
	fprintf(th, "TRIX_v6 *processes[MAXPROC+1];\n");
	fprintf(th, "TRIX_v6 *channels[MAXQ+1]; \n");
	fprintf(th, "long _p_count[MAXPROC];\n");
	fprintf(th, "long _c_count[MAXPROC];\n");
	fprintf(th, "#endif\n\n");

	fprintf(th, "#define HAS_TRACK	%d\n", hastrack);

	if (separate != 2)
		dohidden();
}

void
genaddproc(void)
{	ProcList *p;
	int i = 0, j;

	if (separate == 2) goto shortcut;

	fprintf(tc, "\n#ifdef TRIX\n");
	fprintf(tc, "int what_p_size(int);\n");
	fprintf(tc, "int what_q_size(int);\n\n");
	/* the number of processes just changed by 1 (up or down) */
	/* this means that the channel indices move up or down by one slot */
	/* not all new channels may have a valid index yet, but we move */
	/* all of them anyway, as if they existed */
	fprintf(tc, "void\nre_mark_all(int whichway)\n");
	fprintf(tc, "{	int j;\n");
	fprintf(tc, "	#ifdef V_TRIX\n");
	fprintf(tc, "		printf(\"%%d: re_mark_all channels %%d\\n\", depth, whichway);\n");
	fprintf(tc, "	#endif\n");
	fprintf(tc, "	#ifndef BFS\n");
	fprintf(tc, "	for (j = 0; j &lt; now._nr_qs; j++)\n");
	fprintf(tc, "		channels[j]-&gt;modified = 1; /* channel index moved */\n");
	fprintf(tc, "	#endif\n");
	fprintf(tc, "	#ifndef TRIX_ORIG\n");
	fprintf(tc, "	if (whichway &gt; 0)\n");
	fprintf(tc, "	{	for (j = now._nr_pr + now._nr_qs - 1; j &gt;= now._nr_pr; j--)\n");
	fprintf(tc, "			now._ids_[j] = now._ids_[j-1];\n");
	fprintf(tc, "	} else\n");
	fprintf(tc, "	{	for (j = now._nr_pr; j &lt; now._nr_pr + now._nr_qs; j++)\n");
	fprintf(tc, "			now._ids_[j] = now._ids_[j+1];\n");
	fprintf(tc, "	}\n");
	fprintf(tc, "	#endif\n");
	fprintf(tc, "}\n");

	fprintf(tc, "#endif\n\n");

	fprintf(tc, "int\naddproc(int calling_pid, int n");
	for (/* i = 0 */; i &lt; Npars; i++)
		fprintf(tc, ", int par%d", i);

	ntimes(tc, 0, 1, Addp0);
	ntimes(tc, 1, nrRdy+1, R5); /* +1 for np_ */

	if (nclaims &gt; 1)
	{	fprintf(tc, "#ifndef NOCLAIM\n");
		ntimes(tc, nrRdy+1, nrRdy+2, R5);
		fprintf(tc, "#endif\n");
	}

	ntimes(tc, 0, 1, Addp1);

	if (has_provided)
	{	fprintf(tt, "\nint\nprovided(int II, unsigned char ot, ");
		fprintf(tt, "int tt, Trans *t)\n");
		fprintf(tt, "{\n\tswitch(ot) {\n");
	}
shortcut:
	if (nclaims &gt; 1)
	{	multi_init();
	}
	tc_predef_np();
	for (p = rdy; p; p = p-&gt;nxt)
	{	Pid = p-&gt;tn;
		put_pinit(p);
	}
	if (separate == 2) return;

	Pid = 0;
	if (has_provided)
	{	fprintf(tt, "\tdefault: return 1; /* e.g., a claim */\n");
		fprintf(tt, "\t}\n\treturn 0;\n}\n");
	}

	ntimes(tc, i, i+1, R6);
	if (separate == 0)
		ntimes(tc, 1, nrRdy+1, R5); /* +1 for np_ */
	else
		ntimes(tc, 1, nrRdy, R5);
	ntimes(tc, 0, 1, R8a);
}

void
do_locinits(FILE *fd)
{	ProcList *p;

	for (p = rdy; p; p = p-&gt;nxt)
		c_add_locinit(fd, p-&gt;tn, p-&gt;n-&gt;name);
}

void
genother(void)
{	ProcList *p;

	switch (separate) {
	case 2:
		if (nclaims &gt; 0)
		{	for (p = rdy; p; p = p-&gt;nxt)
			{	if (p-&gt;b == N_CLAIM)
				{	ntimes(tc, p-&gt;tn, p-&gt;tn+1, R0); /* claims only */
		}	}	}
		break;
	case 1:
		ntimes(tc,     0,    1, Code0);
		for (p = rdy; p; p = p-&gt;nxt)
		{	if (p-&gt;b != N_CLAIM)
			{	ntimes(tc, p-&gt;tn, p-&gt;tn+1, R0); /* all except claims */
		}	}
		break;
	case 0:
		ntimes(tc,     0,    1, Code0);
		ntimes(tc,     0, nrRdy+1, R0); /* +1 for np_ */
		break;
	}

	for (p = rdy; p; p = p-&gt;nxt)
		end_labs(p-&gt;n, p-&gt;tn);

	switch (separate) {
	case 2:
		if (nclaims &gt; 0)
		{	for (p = rdy; p; p = p-&gt;nxt)
			{	if (p-&gt;b == N_CLAIM)
				{	ntimes(tc, p-&gt;tn, p-&gt;tn+1, R0a); /* claims only */
		}	}	}
		return;
	case 1:
		for (p = rdy; p; p = p-&gt;nxt)
		{	if (p-&gt;b != N_CLAIM)
			{	ntimes(tc, p-&gt;tn, p-&gt;tn+1, R0a); /* all except claims */
		}	}
		fprintf(tc, "	if (state_tables)\n");
		fprintf(tc, "		ini_claim(%d, 0);\n", claimnr);	/* the default claim */
		if (acceptors == 0)
		{	acceptors = 1;	/* assume at least 1 acceptstate */
		}
		break;
	case 0:
		ntimes(tc, 0, nrRdy, R0a);	/* all */
		break;
	}

	ntimes(th, acceptors,   acceptors+1,   Code1);
	ntimes(th, progressors, progressors+1, Code3);
	ntimes(th, nrRdy+1, nrRdy+2, R2); /* +1 for np_ */

	ntimes(tc, 0,     1, Code2a);	/* dfs, bfs */
	ntimes(tc, 0,     1, Code2c);	/* multicore */
	ntimes(tc, 0,     1, Code2d);

	fprintf(tc, "void\ndo_reach(void)\n{\n");
	ntimes(tc, 0,     nrRdy, R4);
	fprintf(tc, "}\n\n");

	fprintf(tc, "void\niniglobals(int calling_pid)\n{\n");
	ntimes(tc, 1, u_sync+u_async+1, R3); /* because nqs is still 0 */
	fprintf(tc, "\tMaxbody = max(Maxbody, sizeof(State)-VECTORSZ);\n");
	fprintf(tc, "\tif ((Maxbody %% WS) != 0)\n");
	fprintf(tc, "\t	Maxbody += WS - (Maxbody %% WS);\n\n");

	/* after the value of Maxbody has settled */
	if (doglobal("", INIV) &gt; 0)
	{	fprintf(tc, "#ifdef VAR_RANGES\n");
		(void) doglobal("logval(\"", LOGV);
		fprintf(tc, "#endif\n");
	}
	fprintf(tc, "}\n\n");
}

void
gensvmap(void)
{
	ntimes(tc, 0, 1, SvMap);
}

static struct {
	char *s,	*t;		int n,	m,	p;
} ln[] = {
	{"end",  	"stopstate",	3,	0,	0},
	{"progress",	"progstate",	8,	0,	1},
	{"accept",	"accpstate",	6,	1,	0},
	{0,		0,		0,	0,	0},
};

static void
end_labs(Symbol *s, int i)
{	int oln = lineno;
	Symbol *ofn = Fname;
	Label *l;
	int j; char foo[128];

	if ((pid_is_claim(i) &amp;&amp; separate == 1)
	|| (!pid_is_claim(i) &amp;&amp; separate == 2))
		return;

	for (l = labtab; l; l = l-&gt;nxt)
	for (j = 0; ln[j].n; j++)
	{	if (strncmp(l-&gt;s-&gt;name, ln[j].s, ln[j].n) == 0
		&amp;&amp;  strcmp(l-&gt;c-&gt;name, s-&gt;name) == 0)
		{	fprintf(tc, "\t%s[%d][%d] = 1;\n",
				ln[j].t, i, l-&gt;e-&gt;seqno);
			acceptors += ln[j].m;
			progressors += ln[j].p;
			if (l-&gt;e-&gt;status &amp; D_ATOM)
			{	sprintf(foo, "%s label inside d_step",
					ln[j].s);
				goto complain;
			}
			if (j &gt; 0 &amp;&amp; (l-&gt;e-&gt;status &amp; ATOM))
			{	sprintf(foo, "%s label inside atomic",
					ln[j].s);
		complain:	lineno = l-&gt;e-&gt;n-&gt;ln;
				Fname  = l-&gt;e-&gt;n-&gt;fn;
				printf("spin: %3d:%s, warning, %s - is invisible\n",
					lineno, Fname?Fname-&gt;name:"-", foo);
	}	}	}	
	/* visible states -- through remote refs: */
	for (l = labtab; l; l = l-&gt;nxt)
		if (l-&gt;visible
		&amp;&amp;  strcmp(l-&gt;s-&gt;context-&gt;name, s-&gt;name) == 0)
		fprintf(tc, "\tvisstate[%d][%d] = 1;\n",
				i, l-&gt;e-&gt;seqno);

	lineno = oln;
	Fname  = ofn;
}

void
ntimes(FILE *fd, int n, int m, char *c[])
{
	int i, j;
	for (j = 0; c[j]; j++)
	for (i = n; i &lt; m; i++)
	{	fprintf(fd, c[j], i, i, i, i, i, i);
		fprintf(fd, "\n");
	}
}

void
prehint(Symbol *s)
{	Lextok *n;

	printf("spin: warning, ");
	if (!s) return;

	n = (s-&gt;context != ZS)?s-&gt;context-&gt;ini:s-&gt;ini;
	if (n)
	printf("line %s:%d, ", n-&gt;fn-&gt;name, n-&gt;ln);
}

void
checktype(Symbol *sp, char *s)
{	char buf[128]; int i;

	if (!s
	|| (sp-&gt;type != BYTE
	&amp;&amp;  sp-&gt;type != SHORT
	&amp;&amp;  sp-&gt;type != INT))
		return;

	if (sp-&gt;hidden&amp;16)	/* formal parameter */
	{	ProcList *p; Lextok *f, *t;
		int posnr = 0;
		for (p = rdy; p; p = p-&gt;nxt)
			if (p-&gt;n-&gt;name
			&amp;&amp;  strcmp(s, p-&gt;n-&gt;name) == 0)
				break;
		if (p)
		for (f = p-&gt;p; f; f = f-&gt;rgt) /* list of types */
		for (t = f-&gt;lft; t; t = t-&gt;rgt, posnr++)
			if (t-&gt;sym
			&amp;&amp;  strcmp(t-&gt;sym-&gt;name, sp-&gt;name) == 0)
			{	checkrun(sp, posnr);
				return;
			}

	} else if (!(sp-&gt;hidden&amp;4))
	{	if (!(verbose&amp;32)) return;
		sputtype(buf, sp-&gt;type);
		i = (int) strlen(buf);
		while (i &gt; 0 &amp;&amp; buf[--i] == ' ') buf[i] = '\0';
		prehint(sp);
		if (sp-&gt;context)
			printf("proctype %s:", s);
		else
			printf("global");
		printf(" '%s %s' could be declared 'bit %s'\n",
			buf, sp-&gt;name, sp-&gt;name);
	} else if (sp-&gt;type != BYTE &amp;&amp; !(sp-&gt;hidden&amp;8))
	{	if (!(verbose&amp;32)) return;
		sputtype(buf, sp-&gt;type);
		i = (int) strlen(buf);
		while (buf[--i] == ' ') buf[i] = '\0';
		prehint(sp);
		if (sp-&gt;context)
			printf("proctype %s:", s);
		else
			printf("global");
		printf(" '%s %s' could be declared 'byte %s'\n",
			buf, sp-&gt;name, sp-&gt;name);
	}
}

static int
dolocal(FILE *ofd, char *pre, int dowhat, int p, char *s, enum btypes b)
{	int h, j, k=0; extern int nr_errs;
	Ordered *walk;
	Symbol *sp;
	char buf[128], buf2[128], buf3[128];

	if (dowhat == INIV)
	{	/* initialize in order of declaration */
		for (walk = all_names; walk; walk = walk-&gt;next)
		{	sp = walk-&gt;entry;
			if (sp-&gt;context
			&amp;&amp; !sp-&gt;owner
			&amp;&amp;  strcmp(s, sp-&gt;context-&gt;name) == 0)
			{	checktype(sp, s); /* fall through */
				if (!(sp-&gt;hidden&amp;16))
				{	sprintf(buf, "((P%d *)pptr(h))-&gt;", p);
					do_var(ofd, dowhat, buf, sp, "", " = ", ";\n");
				}
				k++;
		}	}
	} else
	{	for (j = 0; j &lt; 8; j++)
		for (h = 0; h &lt;= 1; h++)
		for (walk = all_names; walk; walk = walk-&gt;next)
		{	sp = walk-&gt;entry;
			if (sp-&gt;context
			&amp;&amp; !sp-&gt;owner
			&amp;&amp;  sp-&gt;type == Types[j]
			&amp;&amp;  ((h == 0 &amp;&amp; (sp-&gt;nel == 1 &amp;&amp; sp-&gt;isarray == 0))
			||   (h == 1 &amp;&amp; (sp-&gt;nel  &gt; 1 || sp-&gt;isarray == 1)))
			&amp;&amp;  strcmp(s, sp-&gt;context-&gt;name) == 0)
			{	switch (dowhat) {
				case LOGV:
					if (sp-&gt;type == CHAN
					&amp;&amp;  verbose == 0)
						break;
					sprintf(buf, "%s%s:", pre, s);
					{ sprintf(buf2, "\", ((P%d *)pptr(h))-&gt;", p);
					  sprintf(buf3, ");\n");
					}
					do_var(ofd, dowhat, "", sp, buf, buf2, buf3);
					break;
				case PUTV:
					sprintf(buf, "((P%d *)pptr(h))-&gt;", p);
					do_var(ofd, dowhat, buf, sp, "", " = ", ";\n");
					k++;
					break;
				}
				if (b == N_CLAIM)
				{	printf("error: %s defines local %s\n",
						s, sp-&gt;name);
					nr_errs++;
	}	}	}	}

	return k;
}

void
c_chandump(FILE *fd)
{	Queue *q;
	char buf[256];
	int i;

	if (!qtab)
	{	fprintf(fd, "void\nc_chandump(int unused) ");
		fprintf(fd, "{ unused++; /* avoid complaints */ }\n");
		return;
	}

	fprintf(fd, "void\nc_chandump(int from)\n");
	fprintf(fd, "{	uchar *z; int slot;\n");

	fprintf(fd, "	from--;\n");
	fprintf(fd, "	if (from &gt;= (int) now._nr_qs || from &lt; 0)\n");
	fprintf(fd, "	{	printf(\"pan: bad qid %%d\\n\", from+1);\n");
	fprintf(fd, "		return;\n");
	fprintf(fd, "	}\n");
	fprintf(fd, "	z = qptr(from);\n");
	fprintf(fd, "	switch (((Q0 *)z)-&gt;_t) {\n");

	for (q = qtab; q; q = q-&gt;nxt)
	{	fprintf(fd, "	case %d:\n\t\t", q-&gt;qid);
		sprintf(buf, "((Q%d *)z)-&gt;", q-&gt;qid);

		fprintf(fd, "for (slot = 0; slot &lt; %sQlen; slot++)\n\t\t", buf);
		fprintf(fd, "{	printf(\" [\");\n\t\t");
		for (i = 0; i &lt; q-&gt;nflds; i++)
		{	if (q-&gt;fld_width[i] == MTYPE)
			{	fprintf(fd, "\tprintm(%scontents[slot].fld%d);\n\t\t",
				buf, i);
			} else
			fprintf(fd, "\tprintf(\"%%d,\", %scontents[slot].fld%d);\n\t\t",
				buf, i);
		}
		fprintf(fd, "	printf(\"],\");\n\t\t");
		fprintf(fd, "}\n\t\t");
		fprintf(fd, "break;\n");
	}
	fprintf(fd, "	}\n");
	fprintf(fd, "	printf(\"\\n\");\n}\n");
}

void
c_var(FILE *fd, char *pref, Symbol *sp)
{	char *ptr, buf[256];
	int i;

	if (!sp)
	{	fatal("cannot happen - c_var", 0);
	}

	ptr = sp?sp-&gt;name:"";
	if (!old_scope_rules)
	{	while (*ptr == '_' || isdigit((int)*ptr))
		{	ptr++;
	}	}

	switch (sp-&gt;type) {
	case STRUCT:
		/* c_struct(fd, pref, sp); */
		fprintf(fd, "\t\tprintf(\"\t(struct %s)\\n\");\n",
			sp-&gt;name);
		sprintf(buf, "%s%s.", pref, sp-&gt;name);
		c_struct(fd, buf, sp);
		break;
	case BIT:   case BYTE:
	case SHORT: case INT:
	case UNSIGNED:
		sputtype(buf, sp-&gt;type);
		if (sp-&gt;nel == 1 &amp;&amp; sp-&gt;isarray == 0)
		{	fprintf(fd, "\tprintf(\"\t%s %s:\t%%d\\n\", %s%s);\n",
				buf, ptr, pref, sp-&gt;name);
		} else
		{	fprintf(fd, "\t{\tint l_in;\n");
			fprintf(fd, "\t\tfor (l_in = 0; l_in &lt; %d; l_in++)\n", sp-&gt;nel);
			fprintf(fd, "\t\t{\n");
			fprintf(fd, "\t\t\tprintf(\"\t%s %s[%%d]:\t%%d\\n\", l_in, %s%s[l_in]);\n",
						buf, ptr, pref, sp-&gt;name);
			fprintf(fd, "\t\t}\n");
			fprintf(fd, "\t}\n");
		}
		break;
	case CHAN:
		if (sp-&gt;nel == 1 &amp;&amp; sp-&gt;isarray == 0)
		{  fprintf(fd, "\tprintf(\"\tchan %s (=%%d):\tlen %%d:\\t\", ", ptr);
		   fprintf(fd, "%s%s, q_len(%s%s));\n",
			pref, sp-&gt;name, pref, sp-&gt;name);
		   fprintf(fd, "\tc_chandump(%s%s);\n", pref, sp-&gt;name);
		} else
		for (i = 0; i &lt; sp-&gt;nel; i++)
		{  fprintf(fd, "\tprintf(\"\tchan %s[%d] (=%%d):\tlen %%d:\\t\", ",
			ptr, i);
		   fprintf(fd, "%s%s[%d], q_len(%s%s[%d]));\n",
			pref, sp-&gt;name, i, pref, sp-&gt;name, i);
		   fprintf(fd, "\tc_chandump(%s%s[%d]);\n",
			pref, sp-&gt;name, i);
		}
		break;
	}
}

int
c_splurge_any(ProcList *p)
{	Ordered *walk;
	Symbol *sp;

	if (p-&gt;b != N_CLAIM &amp;&amp; p-&gt;b != E_TRACE &amp;&amp; p-&gt;b != N_TRACE)
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (!sp-&gt;context
		||  sp-&gt;type == 0
		||  strcmp(sp-&gt;context-&gt;name, p-&gt;n-&gt;name) != 0
		||  sp-&gt;owner || (sp-&gt;hidden&amp;1)
		|| (sp-&gt;type == MTYPE &amp;&amp; ismtype(sp-&gt;name)))
			continue;

		return 1;
	}
	return 0;
}

void
c_splurge(FILE *fd, ProcList *p)
{	Ordered *walk;
	Symbol *sp;
	char pref[64];

	if (p-&gt;b != N_CLAIM &amp;&amp; p-&gt;b != E_TRACE &amp;&amp; p-&gt;b != N_TRACE)
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (!sp-&gt;context
		||  sp-&gt;type == 0
		||  strcmp(sp-&gt;context-&gt;name, p-&gt;n-&gt;name) != 0
		||  sp-&gt;owner || (sp-&gt;hidden&amp;1)
		|| (sp-&gt;type == MTYPE &amp;&amp; ismtype(sp-&gt;name)))
			continue;

		sprintf(pref, "((P%d *)pptr(pid))-&gt;", p-&gt;tn);
		c_var(fd, pref, sp);
	}
}

void
c_wrapper(FILE *fd)	/* allow pan.c to print out global sv entries */
{	Ordered *walk;
	ProcList *p;
	Symbol *sp;
	Lextok *n;
	extern Lextok *Mtype;
	int j;

	fprintf(fd, "void\nc_globals(void)\n{\t/* int i; */\n");
	fprintf(fd, "	printf(\"global vars:\\n\");\n");
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (sp-&gt;context || sp-&gt;owner || (sp-&gt;hidden&amp;1)
		|| (sp-&gt;type == MTYPE &amp;&amp; ismtype(sp-&gt;name)))
			continue;

		c_var(fd, "now.", sp);
	}
	fprintf(fd, "}\n");

	fprintf(fd, "void\nc_locals(int pid, int tp)\n{\t/* int i; */\n");
	fprintf(fd, "	switch(tp) {\n");
	for (p = rdy; p; p = p-&gt;nxt)
	{	fprintf(fd, "	case %d:\n", p-&gt;tn);
		if (c_splurge_any(p))
		{	fprintf(fd, "	\tprintf(\"local vars proc %%d (%s):\\n\", pid);\n",
				p-&gt;n-&gt;name);
			c_splurge(fd, p);
		} else
		{	fprintf(fd, "	\t/* none */\n");
		}
		fprintf(fd, "	\tbreak;\n");
	}
	fprintf(fd, "	}\n}\n");

	fprintf(fd, "void\nprintm(int x)\n{\n");
	fprintf(fd, "	switch (x) {\n");
        for (n = Mtype, j = 1; n &amp;&amp; j; n = n-&gt;rgt, j++)
                fprintf(fd, "\tcase %d: Printf(\"%s\"); break;\n",
			j, n-&gt;lft-&gt;sym-&gt;name);
	fprintf(fd, "	default: Printf(\"%%d\", x);\n");
	fprintf(fd, "	}\n");
	fprintf(fd, "}\n");
}

static int
doglobal(char *pre, int dowhat)
{	Ordered *walk;
	Symbol *sp;
	int j, cnt = 0;

	for (j = 0; j &lt; 8; j++)
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (!sp-&gt;context
		&amp;&amp;  !sp-&gt;owner
		&amp;&amp;  sp-&gt;type == Types[j])
		{	if (Types[j] != MTYPE || !ismtype(sp-&gt;name))
			switch (dowhat) {
			case LOGV:
				if (sp-&gt;type == CHAN
				&amp;&amp;  verbose == 0)
					break;
				if (sp-&gt;hidden&amp;1)
					break;
				do_var(tc, dowhat, "", sp,
					pre, "\", now.", ");\n");
				break;
			case INIV:
				checktype(sp, (char *) 0);
				cnt++; /* fall through */
			case PUTV:
				do_var(tc, dowhat,
					(sp-&gt;hidden&amp;1)?"":"now.", sp,
					"", " = ", ";\n");
				break;
	}	}	}
	return cnt;
}

static void
dohidden(void)
{	Ordered *walk;
	Symbol *sp;
	int j;

	for (j = 0; j &lt; 8; j++)
	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if ((sp-&gt;hidden&amp;1)
		&amp;&amp;  sp-&gt;type == Types[j])
		{	if (sp-&gt;context || sp-&gt;owner)
			fatal("cannot hide non-globals (%s)", sp-&gt;name);
			if (sp-&gt;type == CHAN)
			fatal("cannot hide channels (%s)", sp-&gt;name);
			fprintf(th, "/* hidden variable: */");
			typ2c(sp);
	}	}
	fprintf(th, "int _; /* a predefined write-only variable */\n\n");
}

void
do_var(FILE *ofd, int dowhat, char *s, Symbol *sp,
	char *pre, char *sep, char *ter)
{	int i;
	char *ptr = sp?sp-&gt;name:"";

	if (!sp)
	{	fatal("cannot happen - do_var", 0);
	}

	switch(dowhat) {
	case PUTV:
		if (sp-&gt;hidden&amp;1) break;

		typ2c(sp);
		break;

	case LOGV:
		if (!old_scope_rules)
		{	while (*ptr == '_' || isdigit((int)*ptr))
			{	ptr++;
		}	}
		/* fall thru */
	case INIV:
		if (sp-&gt;type == STRUCT)
		{	/* struct may contain a chan */
			walk_struct(ofd, dowhat, s, sp, pre, sep, ter);
			break;
		}
		if (!sp-&gt;ini &amp;&amp; dowhat != LOGV)	/* it defaults to 0 */
			break;
		if (sp-&gt;nel == 1 &amp;&amp; sp-&gt;isarray == 0)
		{	if (dowhat == LOGV)
			{	fprintf(ofd, "\t\t%s%s%s%s",
					pre, s, ptr, sep);
				fprintf(ofd, "%s%s", s, sp-&gt;name);
			} else
			{	fprintf(ofd, "\t\t%s%s%s%s",
					pre, s, sp-&gt;name, sep);
				do_init(ofd, sp);
			}
			fprintf(ofd, "%s", ter);
		} else
		{	if (sp-&gt;ini &amp;&amp; sp-&gt;ini-&gt;ntyp == CHAN)
			{	for (i = 0; i &lt; sp-&gt;nel; i++)
				{	fprintf(ofd, "\t\t%s%s%s[%d]%s",
						pre, s, sp-&gt;name, i, sep);
					if (dowhat == LOGV)
						fprintf(ofd, "%s%s[%d]",
							s, sp-&gt;name, i);
					else
						do_init(ofd, sp);
					fprintf(ofd, "%s", ter);
				}
			} else
			{	fprintf(ofd, "\t{\tint l_in;\n");
				fprintf(ofd, "\t\tfor (l_in = 0; l_in &lt; %d; l_in++)\n", sp-&gt;nel);
				fprintf(ofd, "\t\t{\n");
				fprintf(ofd, "\t\t\t%s%s%s[l_in]%s",
						pre, s, sp-&gt;name, sep);
				if (dowhat == LOGV)
					fprintf(ofd, "%s%s[l_in]", s, sp-&gt;name);
				else
					putstmnt(ofd, sp-&gt;ini, 0);
				fprintf(ofd, "%s", ter);
				fprintf(ofd, "\t\t}\n");
				fprintf(ofd, "\t}\n");
		}	}
		break;
	}
}

static void
do_init(FILE *ofd, Symbol *sp)
{	int i; 

	if (sp-&gt;ini
	&amp;&amp;  sp-&gt;type == CHAN
	&amp;&amp; ((i = qmake(sp)) &gt; 0))
	{	if (sp-&gt;ini-&gt;ntyp == CHAN)
		{	fprintf(ofd, "addqueue(calling_pid, %d, %d)",
				i, ltab[i-1]-&gt;nslots == 0);
		} else
		{	fprintf(ofd, "%d", i);
		}
	} else
	{	putstmnt(ofd, sp-&gt;ini, 0);
	}
}

static void
put_ptype(char *s, int i, int m0, int m1, enum btypes b)
{	int k;

	if (b == I_PROC)
	{	fprintf(th, "#define Pinit	((P%d *)this)\n", i);
	} else if (b == P_PROC || b == A_PROC)
	{	fprintf(th, "#define P%s	((P%d *)this)\n", s, i);
	}

	fprintf(th, "typedef struct P%d { /* %s */\n", i, s);
	fprintf(th, "	unsigned _pid : 8;  /* 0..255 */\n");
	fprintf(th, "	unsigned _t   : %d; /* proctype */\n", blog(m1));
	fprintf(th, "	unsigned _p   : %d; /* state    */\n", blog(m0));
	LstSet = ZS;
	nBits = 8 + blog(m1) + blog(m0);
	k = dolocal(tc, "", PUTV, i, s, b);	/* includes pars */

	c_add_loc(th, s);

	fprintf(th, "} P%d;\n", i);
	if ((!LstSet &amp;&amp; k &gt; 0) || has_state)
		fprintf(th, "#define Air%d	0\n", i);
	else if (LstSet || k == 0)			/* 5.0, added condition */
	{	fprintf(th, "#define Air%d	(sizeof(P%d) - ", i, i);
		if (k == 0)
		{	fprintf(th, "%d", (nBits+7)/8);
			goto done;
		}
		if ((LstSet-&gt;type != BIT &amp;&amp; LstSet-&gt;type != UNSIGNED)
		||   LstSet-&gt;nel != 1)
		{	fprintf(th, "Offsetof(P%d, %s) - %d*sizeof(",
				i, LstSet-&gt;name, LstSet-&gt;nel);
		}
		switch(LstSet-&gt;type) {
		case UNSIGNED:
			fprintf(th, "%d", (nBits+7)/8);
			break;
		case BIT:
			if (LstSet-&gt;nel == 1)
			{	fprintf(th, "%d", (nBits+7)/8);
				break;
			}	/* else fall through */
		case MTYPE: case BYTE: case CHAN:
			fprintf(th, "uchar)"); break;
		case SHORT:
			fprintf(th, "short)"); break;
		case INT:
			fprintf(th, "int)"); break;
		default:
			fatal("cannot happen Air %s",
				LstSet-&gt;name);
		}
done:		fprintf(th, ")\n");
	}
}

static void
tc_predef_np(void)
{	int i = nrRdy;	/* 1+ highest proctype nr */

	fprintf(th, "#define _NP_	%d\n", i);
/*	if (separate == 2) fprintf(th, "extern ");	*/
	fprintf(th, "uchar reached%d[3];  /* np_ */\n", i);
	fprintf(th, "uchar *loopstate%d;  /* np_ */\n", i);

	fprintf(th, "#define nstates%d	3 /* np_ */\n", i);
	fprintf(th, "#define endstate%d	2 /* np_ */\n\n", i);
	fprintf(th, "#define start%d	0 /* np_ */\n", i);

	fprintf(tc, "\tcase %d:	/* np_ */\n", i);
	if (separate == 1)
	{	fprintf(tc, "\t\tini_claim(%d, h);\n", i);
	} else
	{	fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_t = %d;\n", i, i);
		fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_p = 0;\n", i);
		fprintf(tc, "\t\treached%d[0] = 1;\n", i);
		fprintf(tc, "\t\taccpstate[%d][1] = 1;\n", i);
	}
	fprintf(tc, "\t\tbreak;\n");
}

static void
multi_init(void)
{	ProcList *p;
	Element	*e;
	int i = nrRdy+1;
	int ini, j;
	int nrc = nclaims;

	fprintf(tc, "#ifndef NOCLAIM\n");
	fprintf(tc, "\tcase %d:	/* claim select */\n", i);
	for (p = rdy, j = 0; p; p = p-&gt;nxt, j++)
	{	if (p-&gt;b == N_CLAIM)
		{	e = p-&gt;s-&gt;frst;
			ini = huntele(e, e-&gt;status, -1)-&gt;seqno;

			fprintf(tc, "\t\tspin_c_typ[%d] = %d; /* %s */\n",
				j, p-&gt;tn, p-&gt;n-&gt;name);
			fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;c_cur[%d] = %d;\n",
				i, j, ini);
			fprintf(tc, "\t\treached%d[%d]=1;\n", p-&gt;tn, ini);

			/* the default initial claim is first one in model */
			if (--nrc == 0)	
			{ fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_t = %d;\n", i, p-&gt;tn);
			  fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_p = %d;\n", i, ini);
			  fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_n = %d; /* %s */\n",
				i, j, p-&gt;n-&gt;name);
			  fprintf(tc, "\t\tsrc_claim = src_ln%d;\n", p-&gt;tn);
			  fprintf(tc, "#ifndef BFS\n");
			  fprintf(tc, "\t\tif (whichclaim == -1 &amp;&amp; claimname == NULL)\n");
			  fprintf(tc, "\t\t\tprintf(\"0: Claim %s (%d), from state %d\\n\");\n",
				p-&gt;n-&gt;name, p-&gt;tn, ini);
			  fprintf(tc, "#endif\n");
			}
	}	}
	fprintf(tc, "\t\tif (whichclaim != -1)\n");
	fprintf(tc, "\t\t{	select_claim(whichclaim);\n");
	fprintf(tc, "\t\t}\n");
	fprintf(tc, "\t\tbreak;\n\n");
	fprintf(tc, "#endif\n");
}

static void
put_pinit(ProcList *P)
{	Lextok	*fp, *fpt, *t;
	Element	*e = P-&gt;s-&gt;frst;
	Symbol	*s = P-&gt;n;
	Lextok	*p = P-&gt;p;
	int	 i = P-&gt;tn;
	int	ini, j, k;

	if (pid_is_claim(i)
	&amp;&amp;  separate == 1)
	{	fprintf(tc, "\tcase %d:	/* %s */\n", i, s-&gt;name);
		fprintf(tc, "\t\tini_claim(%d, h);\n", i);
		fprintf(tc, "\t\tbreak;\n");
		return;
	}
	if (!pid_is_claim(i)
	&amp;&amp;  separate == 2)
		return;

	ini = huntele(e, e-&gt;status, -1)-&gt;seqno;
	fprintf(th, "#define start%d	%d\n", i, ini);
	if (i == eventmapnr)
	fprintf(th, "#define start_event	%d\n", ini);

	fprintf(tc, "\tcase %d:	/* %s */\n", i, s-&gt;name);

	fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_t = %d;\n", i, i);
	fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;_p = %d;\n", i, ini);
	fprintf(tc, "\t\treached%d[%d]=1;\n", i, ini);
	if (P-&gt;b == N_CLAIM)
	{	fprintf(tc, "\t\tsrc_claim = src_ln%d;\n", i);
	}

	if (has_provided)
	{	fprintf(tt, "\tcase %d: /* %s */\n\t\t", i, s-&gt;name);
		if (P-&gt;prov)
		{	fprintf(tt, "if (");
			putstmnt(tt, P-&gt;prov, 0);
			fprintf(tt, ")\n\t\t\t");
		}
		fprintf(tt, "return 1;\n");
		if (P-&gt;prov)
			fprintf(tt, "\t\tbreak;\n");
	}

	fprintf(tc, "\t\t/* params: */\n");
	for (fp  = p, j=0; fp; fp = fp-&gt;rgt)
	for (fpt = fp-&gt;lft; fpt; fpt = fpt-&gt;rgt, j++)
	{	t = (fpt-&gt;ntyp == ',') ? fpt-&gt;lft : fpt;
		if (t-&gt;sym-&gt;nel &gt; 1 || t-&gt;sym-&gt;isarray)
		{	lineno = t-&gt;ln;
			Fname  = t-&gt;fn;
			fatal("array in parameter list, %s",
			t-&gt;sym-&gt;name);
		}
		fprintf(tc, "\t\t((P%d *)pptr(h))-&gt;", i);
		if (t-&gt;sym-&gt;type == STRUCT)
		{	if (full_name(tc, t, t-&gt;sym, 1))
			{	lineno = t-&gt;ln;
				Fname  = t-&gt;fn;
				fatal("hidden array in parameter %s",
				t-&gt;sym-&gt;name);
			}
		} else
			fprintf(tc, "%s", t-&gt;sym-&gt;name);
		fprintf(tc, " = par%d;\n", j);
	}
	fprintf(tc, "\t\t/* locals: */\n");
	k = dolocal(tc, "", INIV, i, s-&gt;name, P-&gt;b);
	if (k &gt; 0)
	{	fprintf(tc, "#ifdef VAR_RANGES\n");
		(void) dolocal(tc, "logval(\"", LOGV, i, s-&gt;name, P-&gt;b);
		fprintf(tc, "#endif\n");
	}

	fprintf(tc, "#ifdef HAS_CODE\n");
	fprintf(tc, "\t\tlocinit%d(h);\n", i);
	fprintf(tc, "#endif\n");

	dumpclaims(tc, i, s-&gt;name);
	fprintf(tc, "\t	break;\n");
}

Element *
huntstart(Element *f)
{	Element *e = f;
	Element *elast = (Element *) 0;
	int cnt = 0;

	while (elast != e &amp;&amp; cnt++ &lt; 200)	/* new 4.0.8 */
	{	elast = e;
		if (e-&gt;n)
		{	if (e-&gt;n-&gt;ntyp == '.' &amp;&amp; e-&gt;nxt)
				e = e-&gt;nxt;
			else if (e-&gt;n-&gt;ntyp == UNLESS)
				e = e-&gt;sub-&gt;this-&gt;frst;
	}	}

	if (cnt &gt;= 200 || !e)
		fatal("confusing control structure", (char *) 0);
	return e;
}

Element *
huntele(Element *f, int o, int stopat)
{	Element *g, *e = f;
	int cnt=0; /* a precaution against loops */

	if (e)
	for ( ; cnt &lt; 200 &amp;&amp; e-&gt;n; cnt++)
	{
		if (e-&gt;seqno == stopat)
			break;

		switch (e-&gt;n-&gt;ntyp) {
		case GOTO:
			g = get_lab(e-&gt;n,1);
			cross_dsteps(e-&gt;n, g-&gt;n);
			break;
		case '.':
		case BREAK:
			if (!e-&gt;nxt)
				return e;
			g = e-&gt;nxt;
			break;
		case UNLESS:
			g = huntele(e-&gt;sub-&gt;this-&gt;frst, o, stopat);
			break;
		case D_STEP:
		case ATOMIC:
		case NON_ATOMIC:
		default:
			return e;
		}
		if ((o &amp; ATOM) &amp;&amp; !(g-&gt;status &amp; ATOM))
			return e;
		e = g;
	}
	if (cnt &gt;= 200 || !e)
		fatal("confusing control structure", (char *) 0);
	return e;
}

void
typ2c(Symbol *sp)
{	int wsbits = sizeof(long)*8; /* wordsize in bits */
	switch (sp-&gt;type) {
	case UNSIGNED:
		if (sp-&gt;hidden&amp;1)
			fprintf(th, "\tuchar %s;", sp-&gt;name);
		else
			fprintf(th, "\tunsigned %s : %d",
				sp-&gt;name, sp-&gt;nbits);
		LstSet = sp;
		if (nBits%wsbits &gt; 0
		&amp;&amp;  wsbits - nBits%wsbits &lt; sp-&gt;nbits)
		{	/* must padd to a word-boundary */
			nBits += wsbits - nBits%wsbits;
		}
		nBits += sp-&gt;nbits;
		break;
	case BIT:
		if (sp-&gt;nel == 1 &amp;&amp; sp-&gt;isarray == 0 &amp;&amp; !(sp-&gt;hidden&amp;1))
		{	fprintf(th, "\tunsigned %s : 1", sp-&gt;name);
			LstSet = sp; 
			nBits++;
			break;
		} /* else fall through */
		if (!(sp-&gt;hidden&amp;1) &amp;&amp; (verbose&amp;32))
		printf("spin: warning: bit-array %s[%d] mapped to byte-array\n",
			sp-&gt;name, sp-&gt;nel);
		nBits += 8*sp-&gt;nel; /* mapped onto array of uchars */
	case MTYPE:
	case BYTE:
	case CHAN:	/* good for up to 255 channels */
		fprintf(th, "\tuchar %s", sp-&gt;name);
		LstSet = sp;
		break;
	case SHORT:
		fprintf(th, "\tshort %s", sp-&gt;name);
		LstSet = sp;
		break;
	case INT:
		fprintf(th, "\tint %s", sp-&gt;name);
		LstSet = sp;
		break;
	case STRUCT:
		if (!sp-&gt;Snm)
			fatal("undeclared structure element %s", sp-&gt;name);
		fprintf(th, "\tstruct %s %s",
			sp-&gt;Snm-&gt;name,
			sp-&gt;name);
		LstSet = ZS;
		break;
	case CODE_FRAG:
	case PREDEF:
		return;
	default:
		fatal("variable %s undeclared", sp-&gt;name);
	}

	if (sp-&gt;nel &gt; 1 || sp-&gt;isarray)
		fprintf(th, "[%d]", sp-&gt;nel);
	fprintf(th, ";\n");
}

static void
ncases(FILE *fd, int p, int n, int m, char *c[])
{	int i, j;

	for (j = 0; c[j]; j++)
	for (i = n; i &lt; m; i++)
	{	fprintf(fd, c[j], i, p, i);
		fprintf(fd, "\n");
	}
}

void
qlen_type(int qmax)
{
	fprintf(th, "\t");
	if (qmax &lt; 256)
		fprintf(th, "uchar");
	else if (qmax &lt; 65535)
		fprintf(th, "ushort");
	else
		fprintf(th, "uint");
	fprintf(th, " Qlen;	/* q_size */\n");
}

void
genaddqueue(void)
{	char buf0[256];
	int j, qmax = 0;
	Queue *q;

	ntimes(tc, 0, 1, Addq0);
	if (has_io &amp;&amp; !nqs)
		fprintf(th, "#define NQS	1 /* nqs=%d, but has_io */\n", nqs);
	else
		fprintf(th, "#define NQS	%d\n", nqs);
	fprintf(th, "short q_flds[%d];\n", nqs+1);
	fprintf(th, "short q_max[%d];\n", nqs+1);

	for (q = qtab; q; q = q-&gt;nxt)
		if (q-&gt;nslots &gt; qmax)
			qmax = q-&gt;nslots;

	for (q = qtab; q; q = q-&gt;nxt)
	{	j = q-&gt;qid;
		fprintf(tc, "\tcase %d: j = sizeof(Q%d);", j, j);
		fprintf(tc, " q_flds[%d] = %d;", j, q-&gt;nflds);
		fprintf(tc, " q_max[%d] = %d;", j, max(1,q-&gt;nslots));
		fprintf(tc, " break;\n");

		fprintf(th, "typedef struct Q%d {\n", j);
		qlen_type(qmax);	/* 4.2.2 */
		fprintf(th, "	uchar _t;	/* q_type */\n");
		fprintf(th, "	struct {\n");

		for (j = 0; j &lt; q-&gt;nflds; j++)
		{	switch (q-&gt;fld_width[j]) {
			case BIT:
				if (q-&gt;nflds != 1)
				{	fprintf(th, "\t\tunsigned");
					fprintf(th, " fld%d : 1;\n", j);
					break;
				} /* else fall through: smaller struct */
			case MTYPE:
			case CHAN:
			case BYTE:
				fprintf(th, "\t\tuchar fld%d;\n", j);
				break;
			case SHORT:
				fprintf(th, "\t\tshort fld%d;\n", j);
				break;
			case INT:
				fprintf(th, "\t\tint fld%d;\n", j);
				break;
			default:
				fatal("bad channel spec", "");
			}
		}
		fprintf(th, "	} contents[%d];\n", max(1, q-&gt;nslots));
		fprintf(th, "} Q%d;\n", q-&gt;qid);
	}

	fprintf(th, "typedef struct Q0 {\t/* generic q */\n");
	qlen_type(qmax);	/* 4.2.2 */
	fprintf(th, "	uchar _t;\n");
	fprintf(th, "} Q0;\n");

	ntimes(tc, 0, 1, Addq1);

	fprintf(tc, "#ifdef TRIX\n");
	fprintf(tc, "int\nwhat_p_size(int t)\n{\tint j;\n");
	fprintf(tc, "	switch (t) {\n");
	ntimes(tc, 0, nrRdy+1, R5); /* +1 for np_ */
	fprintf(tc, "	default: Uerror(\"bad proctype\");\n");
	fprintf(tc, "	}\n	return j;\n}\n\n");

	fprintf(tc, "int\nwhat_q_size(int t)\n{\tint j;\n");
	fprintf(tc, "	switch (t) {\n");
	for (j = 0; j &lt; nqs+1; j++)
	{	fprintf(tc, "	case %d: j = sizeof(Q%d); break;\n", j, j);
	}
	fprintf(tc, "	default: Uerror(\"bad qtype\");\n");
	fprintf(tc, "	}\n	return j;\n}\n");
	fprintf(tc, "#endif\n\n");

	if (has_random)
	{	fprintf(th, "int Q_has(int");
		for (j = 0; j &lt; Mpars; j++)
			fprintf(th, ", int, int");
		fprintf(th, ");\n");

		fprintf(tc, "int\nQ_has(int into");
		for (j = 0; j &lt; Mpars; j++)
			fprintf(tc, ", int want%d, int fld%d", j, j);
		fprintf(tc, ")\n");
		fprintf(tc, "{	int i;\n\n");
		fprintf(tc, "	if (!into--)\n");
		fprintf(tc, "	uerror(\"ref to unknown chan ");
		fprintf(tc, "(recv-poll)\");\n\n");
		fprintf(tc, "	if (into &gt;= now._nr_qs || into &lt; 0)\n");
		fprintf(tc, "		Uerror(\"qrecv bad queue#\");\n\n");
		fprintf(tc, "	for (i = 0; i &lt; ((Q0 *)qptr(into))-&gt;Qlen;");
		fprintf(tc, " i++)\n");
		fprintf(tc, "	{\n");
		for (j = 0; j &lt; Mpars; j++)
		{	fprintf(tc, "		if (want%d &amp;&amp; ", j);
			fprintf(tc, "qrecv(into+1, i, %d, 0) != fld%d)\n",
				j, j);
			fprintf(tc, "			continue;\n");
		}
		fprintf(tc, "		return i+1;\n");
		fprintf(tc, "	}\n");
		fprintf(tc, "	return 0;\n");
		fprintf(tc, "}\n");
	}

	fprintf(tc, "#if NQS&gt;0\n");
	fprintf(tc, "void\nqsend(int into, int sorted");
	for (j = 0; j &lt; Mpars; j++)
		fprintf(tc, ", int fld%d", j);
	fprintf(tc, ", int args_given)\n");
	ntimes(tc, 0, 1, Addq11);

	for (q = qtab; q; q = q-&gt;nxt)
	{	sprintf(buf0, "((Q%d *)z)-&gt;", q-&gt;qid);
		fprintf(tc, "\tcase %d:%s\n", q-&gt;qid,
			(q-&gt;nslots)?"":" /* =rv= */");
		if (q-&gt;nslots == 0)	/* reset handshake point */
			fprintf(tc, "\t\t(trpt+2)-&gt;o_m = 0;\n");

		if (has_sorted)
		{	fprintf(tc, "\t\tif (!sorted) goto append%d;\n", q-&gt;qid);
			fprintf(tc, "\t\tfor (j = 0; j &lt; %sQlen; j++)\n", buf0);
			fprintf(tc, "\t\t{\t/* find insertion point */\n");
			sprintf(buf0, "((Q%d *)z)-&gt;contents[j].fld", q-&gt;qid);
			for (j = 0; j &lt; q-&gt;nflds; j++)
			{	fprintf(tc, "\t\t\tif (fld%d &gt; %s%d) continue;\n",
						j, buf0, j);
				fprintf(tc, "\t\t\tif (fld%d &lt; %s%d) ", j, buf0, j);
				fprintf(tc, "goto found%d;\n\n", q-&gt;qid);
			}
			fprintf(tc, "\t\t}\n");
			fprintf(tc, "\tfound%d:\n", q-&gt;qid);
			sprintf(buf0, "((Q%d *)z)-&gt;", q-&gt;qid);
			fprintf(tc, "\t\tfor (k = %sQlen - 1; k &gt;= j; k--)\n", buf0);
			fprintf(tc, "\t\t{\t/* shift up */\n");
			for (j = 0; j &lt; q-&gt;nflds; j++)
			{	fprintf(tc, "\t\t\t%scontents[k+1].fld%d = ",
					buf0, j);
				fprintf(tc, "%scontents[k].fld%d;\n",
					buf0, j);
			}
			fprintf(tc, "\t\t}\n");
			fprintf(tc, "\tappend%d:\t/* insert in slot j */\n", q-&gt;qid);
		}

		fprintf(tc, "#ifdef HAS_SORTED\n");
		fprintf(tc, "\t\t(trpt+1)-&gt;ipt = j;\n");	/* ipt was bup.oval */
		fprintf(tc, "#endif\n");
		fprintf(tc, "\t\t%sQlen = %sQlen + 1;\n", buf0, buf0);
		sprintf(buf0, "((Q%d *)z)-&gt;contents[j].fld", q-&gt;qid);
		for (j = 0; j &lt; q-&gt;nflds; j++)
			fprintf(tc, "\t\t%s%d = fld%d;\n", buf0, j, j);
		fprintf(tc, "\t\tif (args_given != %d)\n", q-&gt;nflds);
		fprintf(tc, "\t\t{	if (args_given &gt; %d)\n", q-&gt;nflds);
		fprintf(tc, "\t\t		uerror(\"too many parameters in send stmnt\");\n");
		fprintf(tc, "\t\t	else\n");
		fprintf(tc, "\t\t		uerror(\"too few parameters in send stmnt\");\n");
		fprintf(tc, "\t\t}\n");
		fprintf(tc, "\t\tbreak;\n");
	}
	ntimes(tc, 0, 1, Addq2);

	for (q = qtab; q; q = q-&gt;nxt)
	fprintf(tc, "\tcase %d: return %d;\n", q-&gt;qid, (!q-&gt;nslots));

	ntimes(tc, 0, 1, Addq3);

	for (q = qtab; q; q = q-&gt;nxt)
	fprintf(tc, "\tcase %d: return (q_sz(from) == %d);\n",
			q-&gt;qid, max(1, q-&gt;nslots));

	ntimes(tc, 0, 1, Addq4);
	for (q = qtab; q; q = q-&gt;nxt)
	{	sprintf(buf0, "((Q%d *)z)-&gt;", q-&gt;qid);
		fprintf(tc, "	case %d:%s\n\t\t",
			q-&gt;qid, (q-&gt;nslots)?"":" /* =rv= */");
		if (q-&gt;nflds == 1)
		{	fprintf(tc, "if (fld == 0) r = %s", buf0);
			fprintf(tc, "contents[slot].fld0;\n");
		} else
		{	fprintf(tc, "switch (fld) {\n");
			ncases(tc, q-&gt;qid, 0, q-&gt;nflds, R12);
			fprintf(tc, "\t\tdefault: Uerror");
			fprintf(tc, "(\"too many fields in recv\");\n");
			fprintf(tc, "\t\t}\n");
		}
		fprintf(tc, "\t\tif (done)\n");
		if (q-&gt;nslots == 0)
		{	fprintf(tc, "\t\t{	j = %sQlen - 1;\n",  buf0);
			fprintf(tc, "\t\t	%sQlen = 0;\n", buf0);
			sprintf(buf0, "\t\t\t((Q%d *)z)-&gt;contents", q-&gt;qid);
		} else
	 	{	fprintf(tc, "\t\t{	j = %sQlen;\n",  buf0);
			fprintf(tc, "\t\t	%sQlen = --j;\n", buf0);
			fprintf(tc, "\t\t	for (k=slot; k&lt;j; k++)\n");
			fprintf(tc, "\t\t	{\n");
			sprintf(buf0, "\t\t\t((Q%d *)z)-&gt;contents", q-&gt;qid);
			for (j = 0; j &lt; q-&gt;nflds; j++)
			{	fprintf(tc, "\t%s[k].fld%d = \n", buf0, j);
				fprintf(tc, "\t\t%s[k+1].fld%d;\n", buf0, j);
			}
			fprintf(tc, "\t\t	}\n");
	 	}

		for (j = 0; j &lt; q-&gt;nflds; j++)
			fprintf(tc, "%s[j].fld%d = 0;\n", buf0, j);
		fprintf(tc, "\t\t\tif (fld+1 != %d)\n\t\t\t", q-&gt;nflds);
		fprintf(tc, "\tuerror(\"missing pars in receive\");\n");
		/* incompletely received msgs cannot be unrecv'ed */
		fprintf(tc, "\t\t}\n");
		fprintf(tc, "\t\tbreak;\n");
	}
	ntimes(tc, 0, 1, Addq5);
	for (q = qtab; q; q = q-&gt;nxt)
	fprintf(tc, "	case %d: j = sizeof(Q%d); break;\n",
		q-&gt;qid, q-&gt;qid);
	ntimes(tc, 0, 1, R8b);

	ntimes(th, 0, 1, Proto);	/* tag on function prototypes */
	fprintf(th, "void qsend(int, int");
	for (j = 0; j &lt; Mpars; j++)
		fprintf(th, ", int");
	fprintf(th, ", int);\n");

	fprintf(th, "#define Addproc(x)	addproc(256, x");
	/* 256 is param outside the range of valid pids */
	for (j = 0; j &lt; Npars; j++)
		fprintf(th, ", 0");
	fprintf(th, ")\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

