<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen2.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen2.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen2.c *****/

/* Copyright (c) 1989-2009 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */
/* (c) 2007: small additions for V5.0 to support multi-core verifications */

#include "spin.h"
#include "version.h"
#include "y.tab.h"
#include "pangen2.h"
#include "pangen4.h"
#include "pangen5.h"

#define DELTA	500	/* sets an upperbound on nr of chan names */

#define blurb(fd, e)	{ fprintf(fd, "\n"); if (!merger) fprintf(fd, "\t\t/* %s:%d */\n", \
				e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln); }
#define tr_map(m, e)	{ if (!merger) fprintf(tt, "\t\ttr_2_src(%d, \"%s\", %d);\n", \
				m, e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln); }

extern ProcList	*rdy;
extern RunList	*run;
extern Symbol	*Fname, *oFname, *context;
extern char	*claimproc, *eventmap;
extern int	lineno, verbose, Npars, Mpars, nclaims;
extern int	m_loss, has_remote, has_remvar, merger, rvopt, separate;
extern int	Ntimeouts, Etimeouts, deadvar, old_scope_rules;
extern int	u_sync, u_async, nrRdy, Unique;
extern int	GenCode, IsGuard, Level, TestOnly;
extern short	has_stack;
extern char	*NextLab[];

FILE	*tc, *th, *tt, *tb;
static FILE	*tm;

int	OkBreak = -1, has_hidden = 0; /* has_hidden set in sym.c and structs.c */
short	nocast=0;	/* to turn off casts in lvalues */
short	terse=0;	/* terse printing of varnames */
short	no_arrays=0;
short	has_last=0;	/* spec refers to _last */
short	has_badelse=0;	/* spec contains else combined with chan refs */
short	has_enabled=0;	/* spec contains enabled() */
short	has_pcvalue=0;	/* spec contains pc_value() */
short	has_np=0;	/* spec contains np_ */
short	has_sorted=0;	/* spec contains `!!' (sorted-send) operator */
short	has_random=0;	/* spec contains `??' (random-recv) operator */
short	has_xu=0;	/* spec contains xr or xs assertions */
short	has_unless=0;	/* spec contains unless statements */
short	has_provided=0;	/* spec contains PROVIDED clauses on procs */
short	has_code=0;	/* spec contains c_code, c_expr, c_state */
short	evalindex=0;	/* evaluate index of var names */
int	mst=0;		/* max nr of state/process */
int	claimnr = -1;	/* claim process, if any */
int	eventmapnr = -1; /* event trace, if any */
int	Pid;		/* proc currently processed */
int	multi_oval;	/* set in merges, used also in pangen4.c */

#define MAXMERGE	256	/* max nr of bups per merge sequence */

static short	CnT[MAXMERGE];
static Lextok	XZ, YZ[MAXMERGE];
static int	didcase, YZmax, YZcnt;

static Lextok	*Nn[2];
static int	Det;	/* set if deterministic */
static int	T_sum, T_mus, t_cyc;
static int	TPE[2], EPT[2];
static int	uniq=1;
static int	multi_needed, multi_undo;
static short	AllGlobal=0;	/* set if process has provided clause */
static short	withprocname=0;	/* prefix local varnames with procname */
static short	_isok=0;	/* checks usage of predefined variable _ */

int	has_global(Lextok *);
void	Fatal(char *, char *);
static int	getweight(Lextok *);
static int	scan_seq(Sequence *);
static void	genconditionals(void);
static void	mark_seq(Sequence *);
static void	patch_atomic(Sequence *);
static void	put_seq(Sequence *, int, int);
static void	putproc(ProcList *);
static void	Tpe(Lextok *);
extern void	spit_recvs(FILE *, FILE*);

static int
fproc(char *s)
{	ProcList *p;

	for (p = rdy; p; p = p-&gt;nxt)
		if (strcmp(p-&gt;n-&gt;name, s) == 0)
			return p-&gt;tn;

	fatal("proctype %s not found", s);
	return -1;
}

int
pid_is_claim(int p)	/* Pid (p-&gt;tn) to type (p-&gt;b) */
{	ProcList *r;

	for (r = rdy; r; r = r-&gt;nxt)
	{	if (r-&gt;tn == p) return (r-&gt;b == N_CLAIM);
	}
	printf("spin: error, cannot find pid %d\n", p);
	return 0;
}

static void
reverse_procs(RunList *q)
{
	if (!q) return;
	reverse_procs(q-&gt;nxt);
	fprintf(tc, "		Addproc(%d);\n", q-&gt;tn);
}

static void
forward_procs(RunList *q)
{
	if (!q) return;
	fprintf(tc, "		Addproc(%d);\n", q-&gt;tn);
	forward_procs(q-&gt;nxt);
}

static void
tm_predef_np(void)
{
	fprintf(th, "#define _T5	%d\n", uniq++);
	fprintf(th, "#define _T2	%d\n", uniq++);

	if (Unique &lt; (1 &lt;&lt; (8*sizeof(unsigned char)) ))	/* was uniq before */
	{	fprintf(th, "#define T_ID	unsigned char\n");
	} else if (Unique &lt; (1 &lt;&lt; (8*sizeof(unsigned short)) ))
	{	fprintf(th, "#define T_ID	unsigned short\n");
	} else
	{	fprintf(th, "#define T_ID	unsigned int\n");
	}

	fprintf(tm, "\tcase  _T5:\t/* np_ */\n");

	if (separate == 2)
	fprintf(tm, "\t\tif (!((!(o_pm&amp;4) &amp;&amp; !(tau&amp;128))))\n");
	else
	fprintf(tm, "\t\tif (!((!(trpt-&gt;o_pm&amp;4) &amp;&amp; !(trpt-&gt;tau&amp;128))))\n");

	fprintf(tm, "\t\t\tcontinue;\n");
	fprintf(tm, "\t\t/* else fall through */\n");
	fprintf(tm, "\tcase  _T2:\t/* true */\n");
	fprintf(tm, "\t\t_m = 3; goto P999;\n");
}

static void
tt_predef_np(void)
{
	fprintf(tt, "\t/* np_ demon: */\n");
	fprintf(tt, "\ttrans[_NP_] = ");
	fprintf(tt, "(Trans **) emalloc(2*sizeof(Trans *));\n");
	fprintf(tt, "\tT = trans[_NP_][0] = ");
	fprintf(tt, "settr(9997,0,1,_T5,0,\"(np_)\", 1,2,0);\n");
	fprintf(tt, "\t    T-&gt;nxt	  = ");
	fprintf(tt, "settr(9998,0,0,_T2,0,\"(1)\",   0,2,0);\n");
	fprintf(tt, "\tT = trans[_NP_][1] = ");
	fprintf(tt, "settr(9999,0,1,_T5,0,\"(np_)\", 1,2,0);\n");
}

static struct {
	char *nm[3];
} Cfile[] = {
	{ { "pan.c", "pan_s.c", "pan_t.c" } },
	{ { "pan.h", "pan_s.h", "pan_t.h" } },
	{ { "pan.t", "pan_s.t", "pan_t.t" } },
	{ { "pan.m", "pan_s.m", "pan_t.m" } },
	{ { "pan.b", "pan_s.b", "pan_t.b" } }
};

void
gensrc(void)
{	ProcList *p;
	int i;

	disambiguate();		/* avoid name-clashes between scopes */

	if (!(tc = fopen(Cfile[0].nm[separate], MFLAGS))		/* main routines */
	||  !(th = fopen(Cfile[1].nm[separate], MFLAGS))		/* header file   */
	||  !(tt = fopen(Cfile[2].nm[separate], MFLAGS))		/* transition matrix */
	||  !(tm = fopen(Cfile[3].nm[separate], MFLAGS))		/* forward  moves */
	||  !(tb = fopen(Cfile[4].nm[separate], MFLAGS)))	/* backward moves */
	{	printf("spin: cannot create pan.[chtmfb]\n");
		alldone(1);
	}

	fprintf(th, "#define SpinVersion	\"%s\"\n", SpinVersion);
	fprintf(th, "#define PanSource	\"");
	for (i = 0; oFname-&gt;name[i] != '\0'; i++)
	{	char c = oFname-&gt;name[i];
		if (c == '\\' || c == ' ') /* Windows path */
		{	fprintf(th, "\\");
		}
		fprintf(th, "%c", c);
	}
	fprintf(th, "\"\n\n");

	fprintf(th, "#define G_long	%d\n", (int) sizeof(long));
	fprintf(th, "#define G_int	%d\n", (int) sizeof(int));

	fprintf(th, "#ifdef WIN64\n");
	fprintf(th, "	#define ONE_L	((unsigned long) 1)\n");
	fprintf(th, "	#define long	long long\n");
	fprintf(th, "#else\n");
	fprintf(th, "	#define ONE_L	(1L)\n");
	fprintf(th, "#endif\n");

	if (separate != 2)
	{	fprintf(th, "char *TrailFile = PanSource; /* default */\n");
		fprintf(th, "char *trailfilename;\n");
	}

	fprintf(th, "#if defined(BFS)\n");
	fprintf(th, "	#ifndef SAFETY\n");
	fprintf(th, "		#define SAFETY\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "	#ifndef XUSAFE\n");
	fprintf(th, "		#define XUSAFE\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#endif\n");

	fprintf(th, "#ifndef uchar\n");
	fprintf(th, "	#define uchar	unsigned char\n");
	fprintf(th, "#endif\n");
	fprintf(th, "#ifndef uint\n");
	fprintf(th, "	#define uint	unsigned int\n");
	fprintf(th, "#endif\n");

	if (sizeof(void *) &gt; 4)	/* 64 bit machine */
	{	fprintf(th, "#if !defined(HASH32) &amp;&amp; !defined(HASH64)\n");
		fprintf(th, "	#define HASH64\n");
		fprintf(th, "#endif\n");
	}

	if (separate == 1 &amp;&amp; !claimproc)
	{	Symbol *n = (Symbol *) emalloc(sizeof(Symbol));
		Sequence *s = (Sequence *) emalloc(sizeof(Sequence));
		claimproc = n-&gt;name = "_:never_template:_";
		ready(n, ZN, s, 0, ZN, N_CLAIM);
	}
	if (separate == 2)
	{	if (has_remote)
		{	printf("spin: warning, make sure that the S1 model\n");
			printf("      includes the same remote references\n");
		}
		fprintf(th, "#ifndef NFAIR\n");
		fprintf(th, "#define NFAIR	2	/* must be &gt;= 2 */\n");
		fprintf(th, "#endif\n");
		if (has_last)
		fprintf(th, "#define HAS_LAST	%d\n", has_last);
		goto doless;
	}

	fprintf(th, "#define DELTA	%d\n", DELTA);
	fprintf(th, "#ifdef MA\n");
	fprintf(th, "	#if NCORE&gt;1 &amp;&amp; !defined(SEP_STATE)\n");
	fprintf(th, "	#define SEP_STATE\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#if MA==1\n"); /* user typed -DMA without size */
	fprintf(th, "	#undef MA\n");
	fprintf(th, "	#define MA	100\n");
	fprintf(th, "#endif\n#endif\n");
	fprintf(th, "#ifdef W_XPT\n");
	fprintf(th, "	#if W_XPT==1\n"); /* user typed -DW_XPT without size */
	fprintf(th, "		#undef W_XPT\n");
	fprintf(th, "		#define W_XPT 1000000\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#endif\n");
	fprintf(th, "#ifndef NFAIR\n");
	fprintf(th, "	#define NFAIR	2	/* must be &gt;= 2 */\n");
	fprintf(th, "#endif\n");
	if (Ntimeouts)
	fprintf(th, "#define NTIM	%d\n", Ntimeouts);
	if (Etimeouts)
	fprintf(th, "#define ETIM	%d\n", Etimeouts);
	if (has_remvar)
	fprintf(th, "#define REM_VARS	1\n");
	if (has_remote)
	fprintf(th, "#define REM_REFS	%d\n", has_remote); /* not yet used */
	if (has_hidden)
	fprintf(th, "#define HAS_HIDDEN	%d\n", has_hidden);
	if (has_last)
	fprintf(th, "#define HAS_LAST	%d\n", has_last);
	if (has_sorted)
	fprintf(th, "#define HAS_SORTED	%d\n", has_sorted);
	if (m_loss)
	fprintf(th, "#define M_LOSS\n");
	if (has_random)
	fprintf(th, "#define HAS_RANDOM	%d\n", has_random);
	fprintf(th, "#define HAS_CODE\n");	/* doesn't seem to cause measurable overhead */
	fprintf(th, "#if defined(RANDSTORE) &amp;&amp; !defined(RANDSTOR)\n");
	fprintf(th, "	#define RANDSTOR	RANDSTORE\n"); /* xspin uses RANDSTORE... */
	fprintf(th, "#endif\n");
	if (has_stack)
	fprintf(th, "#define HAS_STACK	%d\n", has_stack);
	if (has_enabled)
	fprintf(th, "#define HAS_ENABLED	1\n");
	if (has_unless)
	fprintf(th, "#define HAS_UNLESS	%d\n", has_unless);
	if (has_provided)
	fprintf(th, "#define HAS_PROVIDED	%d\n", has_provided);
	if (has_pcvalue)
	fprintf(th, "#define HAS_PCVALUE	%d\n", has_pcvalue);
	if (has_badelse)
	fprintf(th, "#define HAS_BADELSE	%d\n", has_badelse);
	if (has_enabled
	||  has_pcvalue
	||  has_badelse
	||  has_last)
	{	fprintf(th, "#ifndef NOREDUCE\n");
		fprintf(th, "	#define NOREDUCE	1\n");
		fprintf(th, "#endif\n");
	}
	if (has_np)
	fprintf(th, "#define HAS_NP	%d\n", has_np);
	if (merger)
	fprintf(th, "#define MERGED	1\n");

doless:
	fprintf(th, "#if !defined(HAS_LAST) &amp;&amp; defined(BCS)\n");
	fprintf(th, "	#define HAS_LAST	1 /* use it, but */\n");
	fprintf(th, "	#ifndef STORE_LAST\n"); /* unless the user insists */
	fprintf(th, "		#define NO_LAST	1 /* dont store it */\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#endif\n");

	fprintf(th, "#if defined(BCS) &amp;&amp; defined(BITSTATE)\n");
	fprintf(th, "	#ifndef NO_CTX\n");
	fprintf(th, "		#define STORE_CTX	1\n");
	fprintf(th, "	#endif\n");
	fprintf(th, "#endif\n");

	fprintf(th, "#ifdef NP\n");
	if (!has_np)
	fprintf(th, "	#define HAS_NP	2\n");
	fprintf(th, "	#define VERI	%d	/* np_ */\n",	nrRdy);
	fprintf(th, "#endif\n");
	if (claimproc)
	{	claimnr = fproc(claimproc);	/* the default claim */
		fprintf(th, "#ifndef NOCLAIM\n");
		fprintf(th, "	#define NCLAIMS	%d\n", nclaims);
		fprintf(th, "	#ifndef NP\n");
		fprintf(th, "		#define VERI	%d\n", claimnr);
		fprintf(th, "	#endif\n");
		fprintf(th, "#endif\n");
	}
	if (eventmap)
	{	eventmapnr = fproc(eventmap);
		fprintf(th, "#define EVENT_TRACE	%d\n",	eventmapnr);
		fprintf(th, "#define endevent	endstate%d\n",	eventmapnr);
		if (eventmap[2] == 'o')	/* ":notrace:" */
		fprintf(th, "#define NEGATED_TRACE	1\n");
	}

	fprintf(th, "typedef struct S_F_MAP {\n");
	fprintf(th, "	char *fnm; int from; int upto;\n");
	fprintf(th, "} S_F_MAP;\n");

	fprintf(tc, "/*** Generated by %s ***/\n", SpinVersion);
	fprintf(tc, "/*** From source: %s ***/\n\n", oFname-&gt;name);

	ntimes(tc, 0, 1, Pre0);

	plunk_c_decls(tc);	/* types can be refered to in State */

	switch (separate) {
	case 0:	fprintf(tc, "#include \"pan.h\"\n"); break;
	case 1:	fprintf(tc, "#include \"pan_s.h\"\n"); break;
	case 2:	fprintf(tc, "#include \"pan_t.h\"\n"); break;
	}

	fprintf(tc, "#ifdef LOOPSTATE\n");
	fprintf(tc, "double cnt_loops;\n");
	fprintf(tc, "#endif\n");

	fprintf(tc, "State	A_Root;	/* seed-state for cycles */\n");
	fprintf(tc, "State	now;	/* the full state-vector */\n");
	plunk_c_fcts(tc);	/* State can be used in fcts */

	if (separate != 2)
		ntimes(tc, 0, 1, Preamble);
	else
		fprintf(tc, "extern int verbose; extern long depth;\n");

	fprintf(tc, "#ifndef NOBOUNDCHECK\n");
	fprintf(tc, "	#define Index(x, y)\tBoundcheck(x, y, II, tt, t)\n");
	fprintf(tc, "#else\n");
	fprintf(tc, "	#define Index(x, y)\tx\n");
	fprintf(tc, "#endif\n");

	c_preview();	/* sets hastrack */

	for (p = rdy; p; p = p-&gt;nxt)
		mst = max(p-&gt;s-&gt;maxel, mst);

	if (separate != 2)
	{	fprintf(tt, "#ifdef PEG\n");
		fprintf(tt, "struct T_SRC {\n");
		fprintf(tt, "	char *fl; int ln;\n");
		fprintf(tt, "} T_SRC[NTRANS];\n\n");
		fprintf(tt, "void\ntr_2_src(int m, char *file, int ln)\n");
		fprintf(tt, "{	T_SRC[m].fl = file;\n");
		fprintf(tt, "	T_SRC[m].ln = ln;\n");
		fprintf(tt, "}\n\n");
		fprintf(tt, "void\nputpeg(int n, int m)\n");
		fprintf(tt, "{	printf(\"%%5d\ttrans %%4d \", m, n);\n");
		fprintf(tt, "	printf(\"%%s:%%d\\n\",\n");
		fprintf(tt, "		T_SRC[n].fl, T_SRC[n].ln);\n");
		fprintf(tt, "}\n");
		if (!merger)
		{	fprintf(tt, "#else\n");
			fprintf(tt, "#define tr_2_src(m,f,l)\n");
		}
		fprintf(tt, "#endif\n\n");
		fprintf(tt, "void\nsettable(void)\n{\tTrans *T;\n");
		fprintf(tt, "\tTrans *settr(int, int, int, int, int,");
		fprintf(tt, " char *, int, int, int);\n\n");
		fprintf(tt, "\ttrans = (Trans ***) ");
		fprintf(tt, "emalloc(%d*sizeof(Trans **));\n", nrRdy+1);
				/* +1 for np_ automaton */

		if (separate == 1)
		{
		fprintf(tm, "	if (II == 0)\n");
		fprintf(tm, "	{ _m = step_claim(trpt-&gt;o_pm, trpt-&gt;tau, tt, ot, t);\n");
		fprintf(tm, "	  if (_m) goto P999; else continue;\n");
		fprintf(tm, "	} else\n");
		}

		fprintf(tm, "#define rand	pan_rand\n");
		fprintf(tm, "#if defined(HAS_CODE) &amp;&amp; defined(VERBOSE)\n");
		fprintf(tm, "	cpu_printf(\"Pr: %%d Tr: %%d\\n\", II, t-&gt;forw);\n");
		fprintf(tm, "#endif\n");
		fprintf(tm, "	switch (t-&gt;forw) {\n");
	} else
	{	fprintf(tt, "#ifndef PEG\n");
		fprintf(tt, "	#define tr_2_src(m,f,l)\n");
		fprintf(tt, "#endif\n");
		fprintf(tt, "void\nset_claim(void)\n{\tTrans *T;\n");
		fprintf(tt, "\textern Trans ***trans;\n");
		fprintf(tt, "\textern Trans *settr(int, int, int, int, int,");
		fprintf(tt, " char *, int, int, int);\n\n");

		fprintf(tm, "#define rand	pan_rand\n");
		fprintf(tm, "#if defined(HAS_CODE) &amp;&amp; defined(VERBOSE)\n");
		fprintf(tm, "	cpu_printf(\"Pr: %%d Tr: %%d\\n\", II, forw);\n");
		fprintf(tm, "#endif\n");
		fprintf(tm, "	switch (forw) {\n");
	}

	fprintf(tm, "	default: Uerror(\"bad forward move\");\n");
	fprintf(tm, "	case 0:	/* if without executable clauses */\n");
	fprintf(tm, "		continue;\n");
	fprintf(tm, "	case 1: /* generic 'goto' or 'skip' */\n");
	if (separate != 2)
		fprintf(tm, "		IfNotBlocked\n");
	fprintf(tm, "		_m = 3; goto P999;\n");
	fprintf(tm, "	case 2: /* generic 'else' */\n");
	if (separate == 2)
		fprintf(tm, "		if (o_pm&amp;1) continue;\n");
	else
	{	fprintf(tm, "		IfNotBlocked\n");
		fprintf(tm, "		if (trpt-&gt;o_pm&amp;1) continue;\n");
	}
	fprintf(tm, "		_m = 3; goto P999;\n");
	uniq = 3;

	if (separate == 1)
		fprintf(tb, "	if (II == 0) goto R999;\n");

	fprintf(tb, "	switch (t-&gt;back) {\n");
	fprintf(tb, "	default: Uerror(\"bad return move\");\n");
	fprintf(tb, "	case  0: goto R999; /* nothing to undo */\n");

	for (p = rdy; p; p = p-&gt;nxt)
	{	putproc(p);
	}

	if (separate != 2)
	{
		fprintf(th, "struct {\n");
		fprintf(th, "	int tp; short *src;\n");
		fprintf(th, "} src_all[] = {\n");
		for (p = rdy; p; p = p-&gt;nxt)
			fprintf(th, "	{ %d, &amp;src_ln%d[0] },\n",
				p-&gt;tn, p-&gt;tn);
		fprintf(th, "	{ 0, (short *) 0 }\n");
		fprintf(th, "};\n");

		fprintf(th, "S_F_MAP *flref[] = {\n");	/* 5.3.0 */
		for (p = rdy; p; p = p-&gt;nxt)
		{	fprintf(th, "	src_file%d%c\n", p-&gt;tn, p-&gt;nxt?',':' ');
		}
		fprintf(th, "};\n");
	}

	gencodetable(th);

	if (separate != 1)
	{	tm_predef_np();
		tt_predef_np();
	}
	fprintf(tt, "}\n\n");	/* end of settable() */

	fprintf(tm, "#undef rand\n");
	fprintf(tm, "	}\n\n");
	fprintf(tb, "	}\n\n");

	if (separate != 2)
	{	ntimes(tt, 0, 1, Tail);
		genheader();
		if (separate == 1)
		{	fprintf(th, "#define FORWARD_MOVES\t\"pan_s.m\"\n");
			fprintf(th, "#define REVERSE_MOVES\t\"pan_s.b\"\n");
			fprintf(th, "#define SEPARATE\n");
			fprintf(th, "#define TRANSITIONS\t\"pan_s.t\"\n");
			fprintf(th, "extern void ini_claim(int, int);\n");
		} else
		{	fprintf(th, "#define FORWARD_MOVES\t\"pan.m\"\n");
			fprintf(th, "#define REVERSE_MOVES\t\"pan.b\"\n");
			fprintf(th, "#define TRANSITIONS\t\"pan.t\"\n");
		}
		genaddproc();
		genother();
		genaddqueue();
		genunio();
		genconditionals();
		gensvmap();
		if (!run) fatal("no runable process", (char *)0);
		fprintf(tc, "void\n");
		fprintf(tc, "active_procs(void)\n{\n");
#if 1
		fprintf(tc, "	if (!permuted) {\n");
			reverse_procs(run);
		fprintf(tc, "	} else {\n");
			forward_procs(run);
		fprintf(tc, "	}\n");
#else
			reverse_procs(run);
#endif
		fprintf(tc, "}\n");
		ntimes(tc, 0, 1, Dfa);
		ntimes(tc, 0, 1, Xpt);

		fprintf(th, "#define NTRANS	%d\n", uniq);
		fprintf(th, "#ifdef PEG\n");
		fprintf(th, "	long peg[NTRANS];\n");
		fprintf(th, "#endif\n");
		fprintf(th, "void select_claim(int);\n");
		if (u_sync &amp;&amp; !u_async)
		{	spit_recvs(th, tc);
		}
	} else
	{	genheader();
		fprintf(th, "#define FORWARD_MOVES\t\"pan_t.m\"\n");
		fprintf(th, "#define REVERSE_MOVES\t\"pan_t.b\"\n");
		fprintf(th, "#define TRANSITIONS\t\"pan_t.t\"\n");
		fprintf(tc, "extern int Maxbody;\n");
		fprintf(tc, "#if VECTORSZ&gt;32000\n");
		fprintf(tc, "	extern int proc_offset[];\n");
		fprintf(tc, "#else\n");
		fprintf(tc, "	extern short proc_offset[];\n");
		fprintf(tc, "#endif\n");
		fprintf(tc, "extern uchar proc_skip[];\n");
		fprintf(tc, "extern uchar *reached[];\n");
		fprintf(tc, "extern uchar *accpstate[];\n");
		fprintf(tc, "extern uchar *progstate[];\n");
		fprintf(tc, "extern uchar *stopstate[];\n");
		fprintf(tc, "extern uchar *visstate[];\n\n");
		fprintf(tc, "extern short *mapstate[];\n");

		fprintf(tc, "void\nini_claim(int n, int h)\n{");
		fprintf(tc, "\textern State now;\n");
		fprintf(tc, "\textern void set_claim(void);\n\n");
		fprintf(tc, "#ifdef PROV\n");
		fprintf(tc, "	#include PROV\n");
		fprintf(tc, "#endif\n");
		fprintf(tc, "\tset_claim();\n");
		genother();
		fprintf(tc, "\n\tswitch (n) {\n");
		genaddproc();
		fprintf(tc, "\t}\n");
		fprintf(tc, "\n}\n");
		fprintf(tc, "int\nstep_claim(int o_pm, int tau, int tt, int ot, Trans *t)\n");
		fprintf(tc, "{	int forw = t-&gt;forw; int _m = 0; extern char *noptr; int II=0;\n");
		fprintf(tc, "	extern State now;\n");
		fprintf(tc, "#define continue	return 0\n");
		fprintf(tc, "#include \"pan_t.m\"\n");
		fprintf(tc, "P999:\n\treturn _m;\n}\n");
		fprintf(tc, "#undef continue\n");
		fprintf(tc, "int\nrev_claim(int backw)\n{ return 0; }\n");
		fprintf(tc, "#include TRANSITIONS\n");
	}

	if (separate != 2)
	{	c_wrapper(tc);
		c_chandump(tc);
	}
}

static int
find_id(Symbol *s)
{	ProcList *p;

	if (s)
	for (p = rdy; p; p = p-&gt;nxt)
		if (s == p-&gt;n)
			return p-&gt;tn;
	return 0;
}

static void
dolen(Symbol *s, char *pre, int pid, int ai, int qln)
{
	if (ai &gt; 0)
		fprintf(tc, "\n\t\t\t ||    ");
	fprintf(tc, "%s(", pre);
	if (!(s-&gt;hidden&amp;1))
	{	if (s-&gt;context)
			fprintf(tc, "(int) ( ((P%d *)this)-&gt;", pid);
		else
			fprintf(tc, "(int) ( now.");
	}
	fprintf(tc, "%s", s-&gt;name);
	if (qln &gt; 1 || s-&gt;isarray) fprintf(tc, "[%d]", ai);
	fprintf(tc, ") )");
}

struct AA {	char TT[9];	char CC[8]; };

static struct AA BB[4] = {
	{ "Q_FULL_F",	" q_full" },
	{ "Q_FULL_T",	"!q_full" },
	{ "Q_EMPT_F",	" !q_len" },
	{ "Q_EMPT_T",	"  q_len" }
	};

static struct AA DD[4] = {
	{ "Q_FULL_F",	" q_e_f" },	/* empty or full */
	{ "Q_FULL_T",	"!q_full" },
	{ "Q_EMPT_F",	" q_e_f" },
	{ "Q_EMPT_T",	" q_len" }
	};
	/* this reduces the number of cases where 's' and 'r'
	   are considered conditionally safe under the
	   partial order reduction rules;  as a price for
	   this simple implementation, it also affects the
	   cases where nfull and nempty can be considered
	   safe -- since these are labeled the same way as
	   's' and 'r' respectively
	   it only affects reduction, not functionality
	 */

void
bb_or_dd(int j, int which)
{
	if (which)
	{	if (has_unless)
			fprintf(tc, "%s", DD[j].CC);
		else
			fprintf(tc, "%s", BB[j].CC);
	} else
	{	if (has_unless)
			fprintf(tc, "%s", DD[j].TT);
		else
			fprintf(tc, "%s", BB[j].TT);
	}
}

void
Done_case(char *nm, Symbol *z)
{	int j, k;
	int nid = z-&gt;Nid;
	int qln = z-&gt;nel;

	fprintf(tc, "\t\tcase %d: if (", nid);
	for (j = 0; j &lt; 4; j++)
	{	fprintf(tc, "\t(t-&gt;ty[i] == ");
		bb_or_dd(j, 0);
		fprintf(tc, " &amp;&amp; (");
		for (k = 0; k &lt; qln; k++)
		{	if (k &gt; 0)
				fprintf(tc, "\n\t\t\t ||    ");
			bb_or_dd(j, 1);
			fprintf(tc, "(%s%s", nm, z-&gt;name);
			if (qln &gt; 1)
				fprintf(tc, "[%d]", k);
			fprintf(tc, ")");
		}
		fprintf(tc, "))\n\t\t\t ");
		if (j &lt; 3)
			fprintf(tc, "|| ");
		else
			fprintf(tc, "   ");
	}
	fprintf(tc, ") return 0; break;\n");
}

static void
Docase(Symbol *s, int pid, int nid)
{	int i, j;

	fprintf(tc, "\t\tcase %d: if (", nid);
	for (j = 0; j &lt; 4; j++)
	{	fprintf(tc, "\t(t-&gt;ty[i] == ");
		bb_or_dd(j, 0);
		fprintf(tc, " &amp;&amp; (");
		if (has_unless)
		{	for (i = 0; i &lt; s-&gt;nel; i++)
				dolen(s, DD[j].CC, pid, i, s-&gt;nel);
		} else
		{	for (i = 0; i &lt; s-&gt;nel; i++)
				dolen(s, BB[j].CC, pid, i, s-&gt;nel);
		}
		fprintf(tc, "))\n\t\t\t ");
		if (j &lt; 3)
			fprintf(tc, "|| ");
		else
			fprintf(tc, "   ");
	}
	fprintf(tc, ") return 0; break;\n");
}

static void
genconditionals(void)
{	Symbol *s;
	int last=0, j;
	extern Ordered	*all_names;
	Ordered *walk;

	fprintf(th, "#define LOCAL	1\n");
	fprintf(th, "#define Q_FULL_F	2\n");
	fprintf(th, "#define Q_EMPT_F	3\n");
	fprintf(th, "#define Q_EMPT_T	4\n");
	fprintf(th, "#define Q_FULL_T	5\n");
	fprintf(th, "#define TIMEOUT_F	6\n");
	fprintf(th, "#define GLOBAL	7\n");
	fprintf(th, "#define BAD	8\n");
	fprintf(th, "#define ALPHA_F	9\n");

	fprintf(tc, "int\n");
	fprintf(tc, "q_cond(short II, Trans *t)\n");
	fprintf(tc, "{	int i = 0;\n");
	fprintf(tc, "	for (i = 0; i &lt; 6; i++)\n");
	fprintf(tc, "	{	if (t-&gt;ty[i] == TIMEOUT_F) return %s;\n",
					(Etimeouts)?"(!(trpt-&gt;tau&amp;1))":"1");
	fprintf(tc, "		if (t-&gt;ty[i] == ALPHA_F)\n");
	fprintf(tc, "#ifdef GLOB_ALPHA\n");
	fprintf(tc, "			return 0;\n");
	fprintf(tc, "#else\n\t\t\treturn ");
	fprintf(tc, "(II+1 == (short) now._nr_pr &amp;&amp; II+1 &lt; MAXPROC);\n");
	fprintf(tc, "#endif\n");

	/* we switch on the chan name from the spec (as identified by
	 * the corresponding Nid number) rather than the actual qid
	 * because we cannot predict at compile time which specific qid
	 * will be accessed by the statement at runtime.  that is:
	 * we do not know which qid to pass to q_cond at runtime
	 * but we do know which name is used.  if it's a chan array, we
	 * must check all elements of the array for compliance (bummer)
	 */
	fprintf(tc, "		switch (t-&gt;qu[i]) {\n");
	fprintf(tc, "		case 0: break;\n");

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	s = walk-&gt;entry;
		if (s-&gt;owner) continue;
		j = find_id(s-&gt;context);
		if (s-&gt;type == CHAN)
		{	if (last == s-&gt;Nid) continue;	/* chan array */
			last = s-&gt;Nid;
			Docase(s, j, last);
		} else if (s-&gt;type == STRUCT)
		{	/* struct may contain a chan */
			char pregat[128];
			extern void walk2_struct(char *, Symbol *);
			strcpy(pregat, "");
			if (!(s-&gt;hidden&amp;1))
			{	if (s-&gt;context)
					sprintf(pregat, "((P%d *)this)-&gt;",j);
				else
					sprintf(pregat, "now.");
			}
			walk2_struct(pregat, s);
		}
	}
	fprintf(tc, "	\tdefault: Uerror(\"unknown qid - q_cond\");\n");
	fprintf(tc, "	\t\t\treturn 0;\n");
	fprintf(tc, "	\t}\n");
	fprintf(tc, "	}\n");
	fprintf(tc, "	return 1;\n");
	fprintf(tc, "}\n");
}

static void
putproc(ProcList *p)
{	Pid = p-&gt;tn;
	Det = p-&gt;det;

	if (pid_is_claim(Pid)
	&amp;&amp;  separate == 1)
	{	fprintf(th, "extern uchar reached%d[];\n", Pid);
#if 0
		fprintf(th, "extern short nstates%d;\n", Pid);
#else
		fprintf(th, "\n#define nstates%d	%d\t/* %s */\n",
			Pid, p-&gt;s-&gt;maxel, p-&gt;n-&gt;name);
#endif
		fprintf(th, "extern short src_ln%d[];\n", Pid);
		fprintf(th, "extern uchar *loopstate%d;\n", Pid);
		fprintf(th, "extern S_F_MAP src_file%d[];\n", Pid);
		fprintf(th, "#define endstate%d	%d\n",
			Pid, p-&gt;s-&gt;last?p-&gt;s-&gt;last-&gt;seqno:0);
		return;
	}
	if (!pid_is_claim(Pid)
	&amp;&amp;  separate == 2)
	{	fprintf(th, "extern short src_ln%d[];\n", Pid);
		fprintf(th, "extern uchar *loopstate%d;\n", Pid);
		return;
	}

	AllGlobal = (p-&gt;prov)?1:0;	/* process has provided clause */

	fprintf(th, "\n#define nstates%d	%d\t/* %s */\n",
		Pid, p-&gt;s-&gt;maxel, p-&gt;n-&gt;name);
	if (Pid == eventmapnr)
	fprintf(th, "#define nstates_event	nstates%d\n", Pid);

	fprintf(th, "#define endstate%d	%d\n", Pid, p-&gt;s-&gt;last?p-&gt;s-&gt;last-&gt;seqno:0);

	if (p-&gt;b == N_CLAIM || p-&gt;b == E_TRACE || p-&gt;b == N_TRACE)
	{	fprintf(tm, "\n		 /* CLAIM %s */\n", p-&gt;n-&gt;name);
		fprintf(tb, "\n		 /* CLAIM %s */\n", p-&gt;n-&gt;name);
	}
	else
	{	fprintf(tm, "\n		 /* PROC %s */\n", p-&gt;n-&gt;name);
		fprintf(tb, "\n		 /* PROC %s */\n", p-&gt;n-&gt;name);
	}
	fprintf(tt, "\n	/* proctype %d: %s */\n", Pid, p-&gt;n-&gt;name);
	fprintf(tt, "\n	trans[%d] = (Trans **)", Pid);
	fprintf(tt, " emalloc(%d*sizeof(Trans *));\n\n", p-&gt;s-&gt;maxel);

	if (Pid == eventmapnr)
	{	fprintf(th, "\n#define in_s_scope(x_y3_)	0");
		fprintf(tc, "\n#define in_r_scope(x_y3_)	0");
	}
	put_seq(p-&gt;s, 2, 0);
	if (Pid == eventmapnr)
	{	fprintf(th, "\n\n");
		fprintf(tc, "\n\n");
	}
	dumpsrc(p-&gt;s-&gt;maxel, Pid);
}

static void
addTpe(int x)
{	int i;

	if (x &lt;= 2) return;

	for (i = 0; i &lt; T_sum; i++)
		if (TPE[i] == x)
			return;
	TPE[(T_sum++)%2] = x;
}

static void
cnt_seq(Sequence *s)
{	Element *f;
	SeqList *h;

	if (s)
	for (f = s-&gt;frst; f; f = f-&gt;nxt)
	{	Tpe(f-&gt;n);	/* sets EPT */
		addTpe(EPT[0]);
		addTpe(EPT[1]);
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
			cnt_seq(h-&gt;this);
		if (f == s-&gt;last)
			break;
	}
}

static void
typ_seq(Sequence *s)
{
	T_sum = 0;
	TPE[0] = 2; TPE[1] = 0;
	cnt_seq(s);
	if (T_sum &gt; 2)		/* more than one type */
	{	TPE[0] = 5*DELTA;	/* non-mixing */
		TPE[1] = 0;
	}
}

static int
hidden(Lextok *n)
{
	if (n)
	switch (n-&gt;ntyp) {
	case  FULL: case  EMPTY:
	case NFULL: case NEMPTY: case TIMEOUT:
		Nn[(T_mus++)%2] = n;
		break;
	case '!': case UMIN: case '~': case ASSERT: case 'c':
		(void) hidden(n-&gt;lft);
		break;
	case '/': case '*': case '-': case '+':
	case '%': case LT:  case GT: case '&amp;': case '^':
	case '|': case LE:  case GE:  case NE: case '?':
	case EQ:  case OR:  case AND: case LSHIFT: case RSHIFT:
		(void) hidden(n-&gt;lft);
		(void) hidden(n-&gt;rgt);
		break;
	}
	return T_mus;
}

static int
getNid(Lextok *n)
{
	if (n-&gt;sym
	&amp;&amp;  n-&gt;sym-&gt;type == STRUCT
	&amp;&amp;  n-&gt;rgt &amp;&amp; n-&gt;rgt-&gt;lft)
		return getNid(n-&gt;rgt-&gt;lft);

	if (!n-&gt;sym || n-&gt;sym-&gt;Nid == 0)
	{	fatal("bad channel name '%s'",
		(n-&gt;sym)?n-&gt;sym-&gt;name:"no name");
	}
	return n-&gt;sym-&gt;Nid;
}

static int
valTpe(Lextok *n)
{	int res = 2;
	/*
	2 = local
	2+1	    .. 2+1*DELTA = nfull,  's'	- require q_full==false
	2+1+1*DELTA .. 2+2*DELTA = nempty, 'r'	- require q_len!=0
	2+1+2*DELTA .. 2+3*DELTA = empty	- require q_len==0
	2+1+3*DELTA .. 2+4*DELTA = full		- require q_full==true
	5*DELTA = non-mixing (i.e., always makes the selection global)
	6*DELTA = timeout (conditionally safe)
	7*DELTA = @, process deletion (conditionally safe)
	 */
	switch (n-&gt;ntyp) { /* a series of fall-thru cases: */
	case   FULL:	res += DELTA;		/* add 3*DELTA + chan nr */
	case  EMPTY:	res += DELTA;		/* add 2*DELTA + chan nr */
	case    'r':
	case NEMPTY:	res += DELTA;		/* add 1*DELTA + chan nr */
	case    's':
	case  NFULL:	res += getNid(n-&gt;lft);	/* add channel nr */
			break;

	case TIMEOUT:	res = 6*DELTA; break;
	case '@':	res = 7*DELTA; break;
	default:	break;
	}
	return res;
}

static void
Tpe(Lextok *n)	/* mixing in selections */
{
	EPT[0] = 2; EPT[1] = 0;

	if (!n) return;

	T_mus = 0;
	Nn[0] = Nn[1] = ZN;

	if (n-&gt;ntyp == 'c')
	{	if (hidden(n-&gt;lft) &gt; 2)
		{	EPT[0] = 5*DELTA; /* non-mixing */
			EPT[1] = 0;
			return;
		}
	} else
		Nn[0] = n;

	if (Nn[0]) EPT[0] = valTpe(Nn[0]);
	if (Nn[1]) EPT[1] = valTpe(Nn[1]);
}

static void
put_escp(Element *e)
{	int n;
	SeqList *x;

	if (e-&gt;esc /* &amp;&amp; e-&gt;n-&gt;ntyp != GOTO */ &amp;&amp; e-&gt;n-&gt;ntyp != '.')
	{	for (x = e-&gt;esc, n = 0; x; x = x-&gt;nxt, n++)
		{	int i = huntele(x-&gt;this-&gt;frst, e-&gt;status, -1)-&gt;seqno;
			fprintf(tt, "\ttrans[%d][%d]-&gt;escp[%d] = %d;\n",
				Pid, e-&gt;seqno, n, i);
			fprintf(tt, "\treached%d[%d] = 1;\n",
				Pid, i);
		}
		for (x = e-&gt;esc, n=0; x; x = x-&gt;nxt, n++)
		{	fprintf(tt, "	/* escape #%d: %d */\n", n,
				huntele(x-&gt;this-&gt;frst, e-&gt;status, -1)-&gt;seqno);
			put_seq(x-&gt;this, 2, 0);	/* args?? */
		}
		fprintf(tt, "	/* end-escapes */\n");
	}
}

static void
put_sub(Element *e, int Tt0, int Tt1)
{	Sequence *s = e-&gt;n-&gt;sl-&gt;this;
	Element *g = ZE;
	int a;

	patch_atomic(s);
	putskip(s-&gt;frst-&gt;seqno);
	g = huntstart(s-&gt;frst);
	a = g-&gt;seqno;

	if (0) printf("put_sub %d -&gt; %d -&gt; %d\n", e-&gt;seqno, s-&gt;frst-&gt;seqno, a);

	if ((e-&gt;n-&gt;ntyp == ATOMIC
	||  e-&gt;n-&gt;ntyp == D_STEP)
	&amp;&amp;  scan_seq(s))
		mark_seq(s);
	s-&gt;last-&gt;nxt = e-&gt;nxt;

	typ_seq(s);	/* sets TPE */

	if (e-&gt;n-&gt;ntyp == D_STEP)
	{	int inherit = (e-&gt;status&amp;(ATOM|L_ATOM));
		fprintf(tm, "\tcase %d: ", uniq++);
		fprintf(tm, "/* STATE %d - %s:%d - [",
			e-&gt;seqno, e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln);
		comment(tm, e-&gt;n, 0);
		fprintf(tm, "] */\n\t\t");

		if (s-&gt;last-&gt;n-&gt;ntyp == BREAK)
			OkBreak = target(huntele(s-&gt;last-&gt;nxt,
				s-&gt;last-&gt;status, -1))-&gt;Seqno;
		else
			OkBreak = -1;

		if (!putcode(tm, s, e-&gt;nxt, 0, e-&gt;n-&gt;ln, e-&gt;seqno))
		{
			fprintf(tm, "\n#if defined(C_States) &amp;&amp; (HAS_TRACK==1)\n");
			fprintf(tm, "\t\tc_update((uchar *) &amp;(now.c_state[0]));\n");
			fprintf(tm, "#endif\n");

			fprintf(tm, "\t\t_m = %d", getweight(s-&gt;frst-&gt;n));
			if (m_loss &amp;&amp; s-&gt;frst-&gt;n-&gt;ntyp == 's')
				fprintf(tm, "+delta_m; delta_m = 0");
			fprintf(tm, "; goto P999;\n\n");
		}
	
		fprintf(tb, "\tcase %d: ", uniq-1);
		fprintf(tb, "/* STATE %d */\n", e-&gt;seqno);
		fprintf(tb, "\t\tsv_restor();\n");
		fprintf(tb, "\t\tgoto R999;\n");
		if (e-&gt;nxt)
			a = huntele(e-&gt;nxt, e-&gt;status, -1)-&gt;seqno;
		else
			a = 0;
		tr_map(uniq-1, e);
		fprintf(tt, "/*-&gt;*/\ttrans[%d][%d]\t= ",
			Pid, e-&gt;seqno);
		fprintf(tt, "settr(%d,%d,%d,%d,%d,\"",
			e-&gt;Seqno, D_ATOM|inherit, a, uniq-1, uniq-1);
		comment(tt, e-&gt;n, e-&gt;seqno);
		fprintf(tt, "\", %d, ", (s-&gt;frst-&gt;status&amp;I_GLOB)?1:0);
		fprintf(tt, "%d, %d);\n", TPE[0], TPE[1]);
		put_escp(e);
	} else
	{	/* ATOMIC or NON_ATOMIC */
		fprintf(tt, "\tT = trans[ %d][%d] = ", Pid, e-&gt;seqno);
		fprintf(tt, "settr(%d,%d,0,0,0,\"",
			e-&gt;Seqno, (e-&gt;n-&gt;ntyp == ATOMIC)?ATOM:0);
		comment(tt, e-&gt;n, e-&gt;seqno);
		if ((e-&gt;status&amp;CHECK2)
		||  (g-&gt;status&amp;CHECK2))
			s-&gt;frst-&gt;status |= I_GLOB;
		fprintf(tt, "\", %d, %d, %d);",
			(s-&gt;frst-&gt;status&amp;I_GLOB)?1:0, Tt0, Tt1);
		blurb(tt, e);
		fprintf(tt, "\tT-&gt;nxt\t= ");
		fprintf(tt, "settr(%d,%d,%d,0,0,\"",
			e-&gt;Seqno, (e-&gt;n-&gt;ntyp == ATOMIC)?ATOM:0, a);
		comment(tt, e-&gt;n, e-&gt;seqno);
		fprintf(tt, "\", %d, ", (s-&gt;frst-&gt;status&amp;I_GLOB)?1:0);
		if (e-&gt;n-&gt;ntyp == NON_ATOMIC)
		{	fprintf(tt, "%d, %d);", Tt0, Tt1);
			blurb(tt, e);
			put_seq(s, Tt0, Tt1);
		} else
		{	fprintf(tt, "%d, %d);", TPE[0], TPE[1]);
			blurb(tt, e);
			put_seq(s, TPE[0], TPE[1]);
		}
	}
}

typedef struct CaseCache {
	int m, b, owner;
	Element *e;
	Lextok *n;
	FSM_use *u;
	struct CaseCache *nxt;
} CaseCache;

static CaseCache *casing[6];

static int
identical(Lextok *p, Lextok *q)
{
	if ((!p &amp;&amp; q) || (p &amp;&amp; !q))
		return 0;
	if (!p)
		return 1;

	if (p-&gt;ntyp    != q-&gt;ntyp
	||  p-&gt;ismtyp  != q-&gt;ismtyp
	||  p-&gt;val     != q-&gt;val
	||  p-&gt;indstep != q-&gt;indstep
	||  p-&gt;sym     != q-&gt;sym
	||  p-&gt;sq      != q-&gt;sq
	||  p-&gt;sl      != q-&gt;sl)
		return 0;

	return	identical(p-&gt;lft, q-&gt;lft)
	&amp;&amp;	identical(p-&gt;rgt, q-&gt;rgt);
}

static int
samedeads(FSM_use *a, FSM_use *b)
{	FSM_use *p, *q;

	for (p = a, q = b; p &amp;&amp; q; p = p-&gt;nxt, q = q-&gt;nxt)
		if (p-&gt;var != q-&gt;var
		||  p-&gt;special != q-&gt;special)
			return 0;
	return (!p &amp;&amp; !q);
}

static Element *
findnext(Element *f)
{	Element *g;

	if (f-&gt;n-&gt;ntyp == GOTO)
	{	g = get_lab(f-&gt;n, 1);
		return huntele(g, f-&gt;status, -1);
	}
	return f-&gt;nxt;
}

static Element *
advance(Element *e, int stopat)
{	Element *f = e;

	if (stopat)
	while (f &amp;&amp; f-&gt;seqno != stopat)
	{	f = findnext(f);
		if (!f)
		{	break;
		}
		switch (f-&gt;n-&gt;ntyp) {
		case GOTO:
		case '.':
		case PRINT:
		case PRINTM:
			break;
		default:
			return f;
	}	}
	return (Element *) 0;
}

static int
equiv_merges(Element *a, Element *b)
{	Element *f, *g;
	int stopat_a, stopat_b;

	if (a-&gt;merge_start)
		stopat_a = a-&gt;merge_start;
	else
		stopat_a = a-&gt;merge;

	if (b-&gt;merge_start)
		stopat_b = b-&gt;merge_start;
	else
		stopat_b = b-&gt;merge;

	if (!stopat_a &amp;&amp; !stopat_b)
		return 1;

	f = advance(a, stopat_a);
	g = advance(b, stopat_b);

	if (!f &amp;&amp; !g)
		return 1;

	if (f &amp;&amp; g)
		return identical(f-&gt;n, g-&gt;n);

	return 0;
}

static CaseCache *
prev_case(Element *e, int owner)
{	int j; CaseCache *nc;

	switch (e-&gt;n-&gt;ntyp) {
	case 'r':	j = 0; break;
	case 's':	j = 1; break;
	case 'c':	j = 2; break;
	case ASGN:	j = 3; break;
	case ASSERT:	j = 4; break;
	default:	j = 5; break;
	}
	for (nc = casing[j]; nc; nc = nc-&gt;nxt)
		if (identical(nc-&gt;n, e-&gt;n)
		&amp;&amp;  samedeads(nc-&gt;u, e-&gt;dead)
		&amp;&amp;  equiv_merges(nc-&gt;e, e)
		&amp;&amp;  nc-&gt;owner == owner)
			return nc;

	return (CaseCache *) 0;
}

static void
new_case(Element *e, int m, int b, int owner)
{	int j; CaseCache *nc;

	switch (e-&gt;n-&gt;ntyp) {
	case 'r':	j = 0; break;
	case 's':	j = 1; break;
	case 'c':	j = 2; break;
	case ASGN:	j = 3; break;
	case ASSERT:	j = 4; break;
	default:	j = 5; break;
	}
	nc = (CaseCache *) emalloc(sizeof(CaseCache));
	nc-&gt;owner = owner;
	nc-&gt;m = m;
	nc-&gt;b = b;
	nc-&gt;e = e;
	nc-&gt;n = e-&gt;n;
	nc-&gt;u = e-&gt;dead;
	nc-&gt;nxt = casing[j];
	casing[j] = nc;
}

static int
nr_bup(Element *e)
{	FSM_use *u;
	Lextok *v;
	int nr = 0;

	switch (e-&gt;n-&gt;ntyp) {
	case ASGN:
		nr++;
		break;
	case  'r':
		if (e-&gt;n-&gt;val &gt;= 1)
			nr++;	/* random recv */
		for (v = e-&gt;n-&gt;rgt; v; v = v-&gt;rgt)
		{	if ((v-&gt;lft-&gt;ntyp == CONST
			||   v-&gt;lft-&gt;ntyp == EVAL))
				continue;
			nr++;
		}
		break;
	default:
		break;
	}
	for (u = e-&gt;dead; u; u = u-&gt;nxt)
	{	switch (u-&gt;special) {
		case 2:		/* dead after write */
			if (e-&gt;n-&gt;ntyp == ASGN
			&amp;&amp;  e-&gt;n-&gt;rgt-&gt;ntyp == CONST
			&amp;&amp;  e-&gt;n-&gt;rgt-&gt;val == 0)
				break;
			nr++;
			break;
		case 1:		/* dead after read */
			nr++;
			break;
	}	}
	return nr;
}

static int
nrhops(Element *e)
{	Element *f = e, *g;
	int cnt = 0;
	int stopat;

	if (e-&gt;merge_start)
		stopat = e-&gt;merge_start;
	else
		stopat = e-&gt;merge;
#if 0
	printf("merge: %d merge_start %d - seqno %d\n",
		e-&gt;merge, e-&gt;merge_start, e-&gt;seqno);
#endif
	do {
		cnt += nr_bup(f);

		if (f-&gt;n-&gt;ntyp == GOTO)
		{	g = get_lab(f-&gt;n, 1);
			if (g-&gt;seqno == stopat)
				f = g;
			else
				f = huntele(g, f-&gt;status, stopat);
		} else
		{
			f = f-&gt;nxt;
		}

		if (f &amp;&amp; !f-&gt;merge &amp;&amp; !f-&gt;merge_single &amp;&amp; f-&gt;seqno != stopat)
		{	fprintf(tm, "\n\t\tbad hop %s:%d -- at %d, &lt;",
				f-&gt;n-&gt;fn-&gt;name,f-&gt;n-&gt;ln, f-&gt;seqno);
			comment(tm, f-&gt;n, 0);
			fprintf(tm, "&gt; looking for %d -- merge %d:%d:%d\n\t\t",
				stopat, f-&gt;merge, f-&gt;merge_start, f-&gt;merge_single);
		 	break;
		}
	} while (f &amp;&amp; f-&gt;seqno != stopat);

	return cnt;
}

static void
check_needed(void)
{
	if (multi_needed)
	{	fprintf(tm, "(trpt+1)-&gt;bup.ovals = grab_ints(%d);\n\t\t",
			multi_needed);
		multi_undo = multi_needed;
		multi_needed = 0;
	}
}

static void
doforward(FILE *tm_fd, Element *e)
{	FSM_use *u;

	putstmnt(tm_fd, e-&gt;n, e-&gt;seqno);

	if (e-&gt;n-&gt;ntyp != ELSE &amp;&amp; Det)
	{	fprintf(tm_fd, ";\n\t\tif (trpt-&gt;o_pm&amp;1)\n\t\t");
		fprintf(tm_fd, "\tuerror(\"non-determinism in D_proctype\")");
	}
	if (deadvar &amp;&amp; !has_code)
	for (u = e-&gt;dead; u; u = u-&gt;nxt)
	{	fprintf(tm_fd, ";\n\t\t/* dead %d: %s */  ",
			u-&gt;special, u-&gt;var-&gt;name);

		switch (u-&gt;special) {
		case 2:		/* dead after write -- lval already bupped */
			if (e-&gt;n-&gt;ntyp == ASGN)	/* could be recv or asgn */
			{	if (e-&gt;n-&gt;rgt-&gt;ntyp == CONST
				&amp;&amp;  e-&gt;n-&gt;rgt-&gt;val == 0)
					continue;	/* already set to 0 */
			}
			if (e-&gt;n-&gt;ntyp != 'r')
			{	XZ.sym = u-&gt;var;
				fprintf(tm_fd, "\n#ifdef HAS_CODE\n");
				fprintf(tm_fd, "\t\tif (!readtrail)\n");
				fprintf(tm_fd, "#endif\n\t\t\t");
				putname(tm_fd, "", &amp;XZ, 0, " = 0");
				break;
			} /* else fall through */
		case 1:		/* dead after read -- add asgn of rval -- needs bup */
			YZ[YZmax].sym = u-&gt;var;	/* store for pan.b */
			CnT[YZcnt]++;		/* this step added bups */
			if (multi_oval)
			{	check_needed();
				fprintf(tm_fd, "(trpt+1)-&gt;bup.ovals[%d] = ",
					multi_oval-1);
				multi_oval++;
			} else
				fprintf(tm_fd, "(trpt+1)-&gt;bup.oval = ");
			putname(tm_fd, "", &amp;YZ[YZmax], 0, ";\n");
			fprintf(tm_fd, "#ifdef HAS_CODE\n");
			fprintf(tm_fd, "\t\tif (!readtrail)\n");
			fprintf(tm_fd, "#endif\n\t\t\t");
			putname(tm_fd, "", &amp;YZ[YZmax], 0, " = 0");
			YZmax++;
			break;
	}	}
	fprintf(tm_fd, ";\n\t\t");
}

static int
dobackward(Element *e, int casenr)
{
	if (!any_undo(e-&gt;n) &amp;&amp; CnT[YZcnt] == 0)
	{	YZcnt--;
		return 0;
	}

	if (!didcase)
	{	fprintf(tb, "\n\tcase %d: ", casenr);
		fprintf(tb, "/* STATE %d */\n\t\t", e-&gt;seqno);
		didcase++;
	}

	_isok++;
	while (CnT[YZcnt] &gt; 0)	/* undo dead variable resets */
	{	CnT[YZcnt]--;
		YZmax--;
		if (YZmax &lt; 0)
			fatal("cannot happen, dobackward", (char *)0);
		fprintf(tb, ";\n\t/* %d */\t", YZmax);
		putname(tb, "", &amp;YZ[YZmax], 0, " = trpt-&gt;bup.oval");
		if (multi_oval &gt; 0)
		{	multi_oval--;
			fprintf(tb, "s[%d]", multi_oval-1);
		}
	}

	if (e-&gt;n-&gt;ntyp != '.')
	{	fprintf(tb, ";\n\t\t");
		undostmnt(e-&gt;n, e-&gt;seqno);
	}
	_isok--;

	YZcnt--;
	return 1;
}

static void
lastfirst(int stopat, Element *fin, int casenr)
{	Element *f = fin, *g;

	if (f-&gt;n-&gt;ntyp == GOTO)
	{	g = get_lab(f-&gt;n, 1);
		if (g-&gt;seqno == stopat)
			f = g;
		else
			f = huntele(g, f-&gt;status, stopat);
	} else
		f = f-&gt;nxt;

	if (!f || f-&gt;seqno == stopat
	|| (!f-&gt;merge &amp;&amp; !f-&gt;merge_single))
		return;
	lastfirst(stopat, f, casenr);
#if 0
	fprintf(tb, "\n\t/* merge %d -- %d:%d %d:%d:%d (casenr %d)	",
		YZcnt,
		f-&gt;merge_start, f-&gt;merge,
		f-&gt;seqno, f?f-&gt;seqno:-1, stopat,
		casenr);
	comment(tb, f-&gt;n, 0);
	fprintf(tb, " */\n");
	fflush(tb);
#endif
	dobackward(f, casenr);
}

static int modifier;

static void
lab_transfer(Element *to, Element *from)
{	Symbol *ns, *s = has_lab(from, (1|2|4));
	Symbol *oc;
	int ltp, usedit=0;

	if (!s) return;

	/* "from" could have all three labels -- rename
	 * to prevent jumps to the transfered copies
	 */
	oc = context;	/* remember */
	for (ltp = 1; ltp &lt; 8; ltp *= 2)	/* 1, 2, and 4 */
		if ((s = has_lab(from, ltp)) != (Symbol *) 0)
		{	ns = (Symbol *) emalloc(sizeof(Symbol));
			ns-&gt;name = (char *) emalloc((int) strlen(s-&gt;name) + 4);
			sprintf(ns-&gt;name, "%s%d", s-&gt;name, modifier);

			context = s-&gt;context;
			set_lab(ns, to);
			usedit++;
		}
	context = oc;	/* restore */
	if (usedit)
	{	if (modifier++ &gt; 990)
			fatal("modifier overflow error", (char *) 0);
	}
}

static int
case_cache(Element *e, int a)
{	int bupcase = 0, casenr = uniq, fromcache = 0;
	CaseCache *Cached = (CaseCache *) 0;
	Element *f, *g;
	int j, nrbups, mark, ntarget;
	extern int ccache;

	mark = (e-&gt;status&amp;ATOM); /* could lose atomicity in a merge chain */

	if (e-&gt;merge_mark &gt; 0
	||  (merger &amp;&amp; e-&gt;merge_in == 0))
	{	/* state nominally unreachable (part of merge chains) */
		if (e-&gt;n-&gt;ntyp != '.'
		&amp;&amp;  e-&gt;n-&gt;ntyp != GOTO)
		{	fprintf(tt, "\ttrans[%d][%d]\t= ", Pid, e-&gt;seqno);
			fprintf(tt, "settr(0,0,0,0,0,\"");
			comment(tt, e-&gt;n, e-&gt;seqno);
			fprintf(tt, "\",0,0,0);\n");
		} else
		{	fprintf(tt, "\ttrans[%d][%d]\t= ", Pid, e-&gt;seqno);
			casenr = 1; /* mhs example */
			j = a;
			goto haveit; /* pakula's example */
		}

		return -1;
	}

	fprintf(tt, "\ttrans[%d][%d]\t= ", Pid, e-&gt;seqno);

	if (ccache
	&amp;&amp;  !pid_is_claim(Pid)
	&amp;&amp;  Pid != eventmapnr
	&amp;&amp; (Cached = prev_case(e, Pid)))
	{	bupcase = Cached-&gt;b;
		casenr  = Cached-&gt;m;
		fromcache = 1;

		fprintf(tm, "/* STATE %d - %s:%d - [",
			e-&gt;seqno, e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln);
		comment(tm, e-&gt;n, 0);
		fprintf(tm, "] (%d:%d - %d) same as %d (%d:%d - %d) */\n",
			e-&gt;merge_start, e-&gt;merge, e-&gt;merge_in,
			casenr,
			Cached-&gt;e-&gt;merge_start, Cached-&gt;e-&gt;merge, Cached-&gt;e-&gt;merge_in);

		goto gotit;
	}

	fprintf(tm, "\tcase %d: /* STATE %d - %s:%d - [",
		uniq++, e-&gt;seqno, e-&gt;n-&gt;fn-&gt;name, e-&gt;n-&gt;ln);
	comment(tm, e-&gt;n, 0);
	nrbups = (e-&gt;merge || e-&gt;merge_start) ? nrhops(e) : nr_bup(e);
	fprintf(tm, "] (%d:%d:%d - %d) */\n\t\t",
		e-&gt;merge_start, e-&gt;merge, nrbups, e-&gt;merge_in);

	if (nrbups &gt; MAXMERGE-1)
		fatal("merge requires more than 256 bups", (char *)0);

	if (e-&gt;n-&gt;ntyp != 'r' &amp;&amp; !pid_is_claim(Pid) &amp;&amp; Pid != eventmapnr)
		fprintf(tm, "IfNotBlocked\n\t\t");

	if (multi_needed != 0 || multi_undo != 0)
		fatal("cannot happen, case_cache", (char *) 0);

	if (nrbups &gt; 1)
	{	multi_oval = 1;
		multi_needed = nrbups; /* allocated after edge condition */
	} else
		multi_oval = 0;

	memset(CnT, 0, sizeof(CnT));
	YZmax = YZcnt = 0;

/* new 4.2.6, revised 6.0.0 */
	if (pid_is_claim(Pid))
	{	fprintf(tm, "\n#if defined(VERI) &amp;&amp; !defined(NP)\n");
fprintf(tm, "#if NCLAIMS&gt;1\n");
		fprintf(tm, "\t\t{	static int reported%d = 0;\n", e-&gt;seqno);
		fprintf(tm, "\t\t	int nn = (int) ((Pclaim *)this)-&gt;_n;\n\t\t");
		fprintf(tm, "	if (verbose &amp;&amp; !reported%d)\n\t\t", e-&gt;seqno);
		fprintf(tm, "	{\tprintf(\"depth %%ld: Claim %%s (%%d), state %%d (line %%d)\\n\",\n\t\t");
		fprintf(tm, "	\t\tdepth, procname[spin_c_typ[nn]], nn, ");
		fprintf(tm, "(int) ((Pclaim *)this)-&gt;_p, src_claim[ (int) ((Pclaim *)this)-&gt;_p ]);\n\t\t");
		fprintf(tm, "		reported%d = 1;\n\t\t", e-&gt;seqno);
		fprintf(tm, "		fflush(stdout);\n\t\t");
		fprintf(tm, "}	}\n");
fprintf(tm, "#else\n");
		fprintf(tm, "{	static int reported%d = 0;\n\t\t", e-&gt;seqno);
		fprintf(tm, "	if (verbose &amp;&amp; !reported%d)\n\t\t", e-&gt;seqno);
		fprintf(tm, "	{	printf(\"depth %%d: Claim, state %%d (line %%d)\\n\",\n\t\t");
		fprintf(tm, "			(int) depth, (int) ((Pclaim *)this)-&gt;_p, ");
		fprintf(tm, "src_claim[ (int) ((Pclaim *)this)-&gt;_p ]);\n\t\t");
		fprintf(tm, "		reported%d = 1;\n\t\t", e-&gt;seqno);
		fprintf(tm, "		fflush(stdout);\n\t\t");
		fprintf(tm, "}	}\n");
fprintf(tm, "#endif\n");
		fprintf(tm, "#endif\n\t\t");
	}
/* end */

	/* the src xrefs have the numbers in e-&gt;seqno builtin */
	fprintf(tm, "reached[%d][%d] = 1;\n\t\t", Pid, e-&gt;seqno);

	doforward(tm, e);

	if (e-&gt;merge_start)
		ntarget = e-&gt;merge_start;
	else
		ntarget = e-&gt;merge;

	if (ntarget)
	{	f = e;

more:		if (f-&gt;n-&gt;ntyp == GOTO)
		{	g = get_lab(f-&gt;n, 1);
			if (g-&gt;seqno == ntarget)
				f = g;
			else
				f = huntele(g, f-&gt;status, ntarget);
		} else
			f = f-&gt;nxt;


		if (f &amp;&amp; f-&gt;seqno != ntarget)
		{	if (!f-&gt;merge &amp;&amp; !f-&gt;merge_single)
			{	fprintf(tm, "/* stop at bad hop %d, %d */\n\t\t",
					f-&gt;seqno, ntarget);
				goto out;
			}
			fprintf(tm, "/* merge: ");
			comment(tm, f-&gt;n, 0);
			fprintf(tm,  "(%d, %d, %d) */\n\t\t", f-&gt;merge, f-&gt;seqno, ntarget);
			fprintf(tm, "reached[%d][%d] = 1;\n\t\t", Pid, f-&gt;seqno);
			YZcnt++;
			lab_transfer(e, f);
			mark = f-&gt;status&amp;(ATOM|L_ATOM); /* last step wins */
			doforward(tm, f);
			if (f-&gt;merge_in == 1) f-&gt;merge_mark++;

			goto more;
	}	}
out:
	fprintf(tm, "_m = %d", getweight(e-&gt;n));
	if (m_loss &amp;&amp; e-&gt;n-&gt;ntyp == 's') fprintf(tm, "+delta_m; delta_m = 0");
	fprintf(tm, "; goto P999; /* %d */\n", YZcnt);

	multi_needed = 0;
	didcase = 0;

	if (ntarget)
		lastfirst(ntarget, e, casenr); /* mergesteps only */

	dobackward(e, casenr);			/* the original step */

	fprintf(tb, ";\n\t\t");

	if (e-&gt;merge || e-&gt;merge_start)
	{	if (!didcase)
		{	fprintf(tb, "\n\tcase %d: ", casenr);
			fprintf(tb, "/* STATE %d */", e-&gt;seqno);
			didcase++;
		} else
			fprintf(tb, ";");
	} else
		fprintf(tb, ";");
	fprintf(tb, "\n\t\t");

	if (multi_undo)
	{	fprintf(tb, "ungrab_ints(trpt-&gt;bup.ovals, %d);\n\t\t",
			multi_undo);
		multi_undo = 0;
	}
	if (didcase)
	{	fprintf(tb, "goto R999;\n");
		bupcase = casenr;
	}

	if (!e-&gt;merge &amp;&amp; !e-&gt;merge_start)
		new_case(e, casenr, bupcase, Pid);

gotit:
	j = a;
	if (e-&gt;merge_start)
		j = e-&gt;merge_start;
	else if (e-&gt;merge)
		j = e-&gt;merge;
haveit:
	fprintf(tt, "%ssettr(%d,%d,%d,%d,%d,\"", fromcache?"/* c */ ":"",
		e-&gt;Seqno, mark, j, casenr, bupcase);

	return (fromcache)?0:casenr;
}

static void
put_el(Element *e, int Tt0, int Tt1)
{	int a, casenr, Global_ref;
	Element *g = ZE;

	if (e-&gt;n-&gt;ntyp == GOTO)
	{	g = get_lab(e-&gt;n, 1);
		g = huntele(g, e-&gt;status, -1);
		cross_dsteps(e-&gt;n, g-&gt;n);
		a = g-&gt;seqno;
	} else if (e-&gt;nxt)
	{	g = huntele(e-&gt;nxt, e-&gt;status, -1);
		a = g-&gt;seqno;
	} else
		a = 0;
	if (g
	&amp;&amp;  (g-&gt;status&amp;CHECK2	/* entering remotely ref'd state */
	||   e-&gt;status&amp;CHECK2))	/* leaving  remotely ref'd state */
		e-&gt;status |= I_GLOB;

	/* don't remove dead edges in here, to preserve structure of fsm */
	if (e-&gt;merge_start || e-&gt;merge)
		goto non_generic;

	/*** avoid duplicate or redundant cases in pan.m ***/
	switch (e-&gt;n-&gt;ntyp) {
	case ELSE:
		casenr = 2; /* standard else */
		putskip(e-&gt;seqno);
		goto generic_case;
		/* break; */
	case '.':
	case GOTO:
	case BREAK:
		putskip(e-&gt;seqno); 
		casenr = 1; /* standard goto */
generic_case:	fprintf(tt, "\ttrans[%d][%d]\t= ", Pid, e-&gt;seqno);
		fprintf(tt, "settr(%d,%d,%d,%d,0,\"",
			e-&gt;Seqno, e-&gt;status&amp;ATOM, a, casenr);
		break;
#ifndef PRINTF
	case PRINT:
		goto non_generic;
	case PRINTM:
		goto non_generic;
#endif
	case 'c':
		if (e-&gt;n-&gt;lft-&gt;ntyp == CONST
		&amp;&amp;  e-&gt;n-&gt;lft-&gt;val == 1)	/* skip or true */
		{	casenr = 1;
			putskip(e-&gt;seqno);
			goto generic_case;
		}
		goto non_generic;

	default:
non_generic:
		casenr = case_cache(e, a);
		if (casenr &lt; 0) return;	/* unreachable state */
		break;
	}
	/* tailend of settr(...); */
	Global_ref = (e-&gt;status&amp;I_GLOB)?1:has_global(e-&gt;n);
	comment(tt, e-&gt;n, e-&gt;seqno);
	fprintf(tt, "\", %d, ", Global_ref);
	if (Tt0 != 2)
	{	fprintf(tt, "%d, %d);", Tt0, Tt1);
	} else
	{	Tpe(e-&gt;n);	/* sets EPT */
		fprintf(tt, "%d, %d);", EPT[0], EPT[1]);
	}
	if ((e-&gt;merge_start &amp;&amp; e-&gt;merge_start != a)
	||  (e-&gt;merge &amp;&amp; e-&gt;merge != a))
	{	fprintf(tt, " /* m: %d -&gt; %d,%d */\n",
			a, e-&gt;merge_start, e-&gt;merge);
		fprintf(tt, "	reached%d[%d] = 1;",
			Pid, a); /* Sheinman's example */
	}
	fprintf(tt, "\n");

	if (casenr &gt; 2)
		tr_map(casenr, e);
	put_escp(e);
}

static void
nested_unless(Element *e, Element *g)
{	struct SeqList *y = e-&gt;esc, *z = g-&gt;esc;

	for ( ; y &amp;&amp; z; y = y-&gt;nxt, z = z-&gt;nxt)
		if (z-&gt;this != y-&gt;this)
			break;
	if (!y &amp;&amp; !z)
		return;

	if (g-&gt;n-&gt;ntyp != GOTO
	&amp;&amp;  g-&gt;n-&gt;ntyp != '.'
	&amp;&amp;  e-&gt;sub-&gt;nxt)
	{	printf("error: (%s:%d) saw 'unless' on a guard:\n",
			(e-&gt;n)?e-&gt;n-&gt;fn-&gt;name:"-",
			(e-&gt;n)?e-&gt;n-&gt;ln:0);
		printf("=====&gt;instead of\n");
		printf("	do (or if)\n");
		printf("	:: ...\n");
		printf("	:: stmnt1 unless stmnt2\n");
		printf("	od (of fi)\n");
		printf("=====&gt;use\n");
		printf("	do (or if)\n");
		printf("	:: ...\n");
		printf("	:: stmnt1\n");
		printf("	od (or fi) unless stmnt2\n");
		printf("=====&gt;or rewrite\n");
	}
}

static void
put_seq(Sequence *s, int Tt0, int Tt1)
{	SeqList *h;
	Element *e, *g;
	int a, deadlink;

	if (0) printf("put_seq %d\n", s-&gt;frst-&gt;seqno);

	for (e = s-&gt;frst; e; e = e-&gt;nxt)
	{
		if (0) printf("	step %d\n", e-&gt;seqno);
		if (e-&gt;status &amp; DONE)
		{
			if (0) printf("		done before\n");
			goto checklast;
		}
		e-&gt;status |= DONE;

		if (e-&gt;n-&gt;ln)
			putsrc(e);

		if (e-&gt;n-&gt;ntyp == UNLESS)
		{
			if (0) printf("		an unless\n");
			put_seq(e-&gt;sub-&gt;this, Tt0, Tt1);
		} else if (e-&gt;sub)
		{
			if (0) printf("		has sub\n");
			fprintf(tt, "\tT = trans[%d][%d] = ",
				Pid, e-&gt;seqno);
			fprintf(tt, "settr(%d,%d,0,0,0,\"",
				e-&gt;Seqno, e-&gt;status&amp;ATOM);
			comment(tt, e-&gt;n, e-&gt;seqno);
			if (e-&gt;status&amp;CHECK2)
				e-&gt;status |= I_GLOB;
			fprintf(tt, "\", %d, %d, %d);",
				(e-&gt;status&amp;I_GLOB)?1:0, Tt0, Tt1);
			blurb(tt, e);
			for (h = e-&gt;sub; h; h = h-&gt;nxt)
			{	putskip(h-&gt;this-&gt;frst-&gt;seqno);
				g = huntstart(h-&gt;this-&gt;frst);
				if (g-&gt;esc)
					nested_unless(e, g);
				a = g-&gt;seqno;

				if (g-&gt;n-&gt;ntyp == 'c'
				&amp;&amp;  g-&gt;n-&gt;lft-&gt;ntyp == CONST
				&amp;&amp;  g-&gt;n-&gt;lft-&gt;val == 0		/* 0 or false */
				&amp;&amp; !g-&gt;esc)
				{	fprintf(tt, "#if 0\n\t/* dead link: */\n");
					deadlink = 1;
					if (verbose&amp;32)
					printf("spin: warning, %s:%d: condition is always false\n",
						g-&gt;n-&gt;fn?g-&gt;n-&gt;fn-&gt;name:"", g-&gt;n-&gt;ln);
				} else
					deadlink = 0;
				if (0) printf("			settr %d %d\n", a, 0);
				if (h-&gt;nxt)
					fprintf(tt, "\tT = T-&gt;nxt\t= ");
				else
					fprintf(tt, "\t    T-&gt;nxt\t= ");
				fprintf(tt, "settr(%d,%d,%d,0,0,\"",
					e-&gt;Seqno, e-&gt;status&amp;ATOM, a);
				comment(tt, e-&gt;n, e-&gt;seqno);
				if (g-&gt;status&amp;CHECK2)
					h-&gt;this-&gt;frst-&gt;status |= I_GLOB;
				fprintf(tt, "\", %d, %d, %d);",
					(h-&gt;this-&gt;frst-&gt;status&amp;I_GLOB)?1:0,
					Tt0, Tt1);
				blurb(tt, e);
				if (deadlink)
					fprintf(tt, "#endif\n");
			}
			for (h = e-&gt;sub; h; h = h-&gt;nxt)
				put_seq(h-&gt;this, Tt0, Tt1);
		} else
		{
			if (0) printf("		[non]atomic %d\n", e-&gt;n-&gt;ntyp);
			if (e-&gt;n-&gt;ntyp == ATOMIC
			||  e-&gt;n-&gt;ntyp == D_STEP
			||  e-&gt;n-&gt;ntyp == NON_ATOMIC)
				put_sub(e, Tt0, Tt1);
			else 
			{
				if (0) printf("			put_el %d\n", e-&gt;seqno);
				put_el(e, Tt0, Tt1);
			}
		}
checklast:	if (e == s-&gt;last)
			break;
	}
	if (0) printf("put_seq done\n");
}

static void
patch_atomic(Sequence *s)	/* catch goto's that break the chain */
{	Element *f, *g;
	SeqList *h;

	for (f = s-&gt;frst; f ; f = f-&gt;nxt)
	{
		if (f-&gt;n &amp;&amp; f-&gt;n-&gt;ntyp == GOTO)
		{	g = get_lab(f-&gt;n,1);
			cross_dsteps(f-&gt;n, g-&gt;n);
			if ((f-&gt;status &amp; (ATOM|L_ATOM))
			&amp;&amp; !(g-&gt;status &amp; (ATOM|L_ATOM)))
			{	f-&gt;status &amp;= ~ATOM;
				f-&gt;status |= L_ATOM;
			}
			/* bridge atomics */
			if ((f-&gt;status &amp; L_ATOM)
			&amp;&amp;  (g-&gt;status &amp; (ATOM|L_ATOM)))
			{	f-&gt;status &amp;= ~L_ATOM;
				f-&gt;status |= ATOM;
			}
		} else
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
			patch_atomic(h-&gt;this);
		if (f == s-&gt;extent)
			break;
	}
}

static void
mark_seq(Sequence *s)
{	Element *f;
	SeqList *h;

	for (f = s-&gt;frst; f; f = f-&gt;nxt)
	{	f-&gt;status |= I_GLOB;

		if (f-&gt;n-&gt;ntyp == ATOMIC
		||  f-&gt;n-&gt;ntyp == NON_ATOMIC
		||  f-&gt;n-&gt;ntyp == D_STEP)
			mark_seq(f-&gt;n-&gt;sl-&gt;this);

		for (h = f-&gt;sub; h; h = h-&gt;nxt)
			mark_seq(h-&gt;this);
		if (f == s-&gt;last)
			return;
	}
}

static Element *
find_target(Element *e)
{	Element *f;

	if (!e) return e;

	if (t_cyc++ &gt; 32)
	{	fatal("cycle of goto jumps", (char *) 0);
	}
	switch (e-&gt;n-&gt;ntyp) {
	case  GOTO:
		f = get_lab(e-&gt;n,1);
		cross_dsteps(e-&gt;n, f-&gt;n);
		f = find_target(f);
		break;
	case BREAK:
		if (e-&gt;nxt)
		{	f = find_target(huntele(e-&gt;nxt, e-&gt;status, -1));
			break;	/* new 5.0 -- was missing */
		}
		/* else fall through */
	default:
		f = e;
		break;
	}
	return f;
}

Element *
target(Element *e)
{
	if (!e) return e;
	lineno = e-&gt;n-&gt;ln;
	Fname  = e-&gt;n-&gt;fn;
	t_cyc = 0;
	return find_target(e);
}

static int
seq_has_el(Sequence *s, Element *g)		/* new to version 5.0 */
{	Element *f;
	SeqList *h;

	for (f = s-&gt;frst; f; f = f-&gt;nxt)	/* g in same atomic? */
	{	if (f == g)
		{	return 1;
		}
		if (f-&gt;status &amp; CHECK3)
		{	continue;
		}
		f-&gt;status |= CHECK3; /* protect against cycles */
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
		{	if (h-&gt;this &amp;&amp; seq_has_el(h-&gt;this, g))
			{	return 1;
	}	}	}
	return 0;
}

static int
scan_seq(Sequence *s)
{	Element *f, *g;
	SeqList *h;

	for (f = s-&gt;frst; f; f = f-&gt;nxt)
	{	if ((f-&gt;status&amp;CHECK2)
		||  has_global(f-&gt;n))
			return 1;
		if  (f-&gt;n-&gt;ntyp == GOTO	/* may exit or reach other atomic */
		&amp;&amp; !(f-&gt;status &amp; D_ATOM))	/* cannot jump from d_step */
		{	/* consider jump from an atomic without globals into
			 * an atomic with globals
			 * example by Claus Traulsen, 22 June 2007
			 */
			g = target(f);
#if 1
			if (g &amp;&amp; !seq_has_el(s, g)) /* not internal to this atomic/dstep */

#else
			if (g
			&amp;&amp; !(f-&gt;status &amp; L_ATOM)
			&amp;&amp; !(g-&gt;status &amp; (ATOM|L_ATOM)))
#endif
			{	fprintf(tt, "\t/* mark-down line %d status %d = %d */\n", f-&gt;n-&gt;ln, f-&gt;status, (f-&gt;status &amp; D_ATOM));
				return 1; /* assume worst case */
		}	}
		for (h = f-&gt;sub; h; h = h-&gt;nxt)
			if (scan_seq(h-&gt;this))
				return 1;
		if (f == s-&gt;last)
			break;
	}
	return 0;
}

static int
glob_args(Lextok *n)
{	int result = 0;
	Lextok *v;

	for (v = n-&gt;rgt; v; v = v-&gt;rgt)
	{	if (v-&gt;lft-&gt;ntyp == CONST)
			continue;
		if (v-&gt;lft-&gt;ntyp == EVAL)
			result += has_global(v-&gt;lft-&gt;lft);
		else
			result += has_global(v-&gt;lft);
	}
	return result;
}

static int
proc_is_safe(const Lextok *n)
{	ProcList *p;
	/* not safe unless no local var inits are used */
	/* note that a local variable init could refer to a global */

	for (p = rdy; p; p = p-&gt;nxt)
	{	if (strcmp(n-&gt;sym-&gt;name, p-&gt;n-&gt;name) == 0)
		{	/* printf("proc %s safety: %d\n", p-&gt;n-&gt;name, p-&gt;unsafe); */
			return (p-&gt;unsafe != 0);
	}	}
/*	non_fatal("bad call to proc_is_safe", (char *) 0);	*/
	/* cannot happen */
	return 0;
}

int
has_global(Lextok *n)
{	Lextok *v;

	if (!n) return 0;
	if (AllGlobal) return 1;	/* global provided clause */

	switch (n-&gt;ntyp) {
	case ATOMIC:
	case D_STEP:
	case NON_ATOMIC:
		return scan_seq(n-&gt;sl-&gt;this);

	case '.':
	case BREAK:
	case GOTO:
	case CONST:
		return 0;

	case   ELSE: return n-&gt;val; /* true if combined with chan refs */

	case    's': return glob_args(n)!=0 || ((n-&gt;sym-&gt;xu&amp;(XS|XX)) != XS);
	case    'r': return glob_args(n)!=0 || ((n-&gt;sym-&gt;xu&amp;(XR|XX)) != XR);
	case    'R': return glob_args(n)!=0 || (((n-&gt;sym-&gt;xu)&amp;(XR|XS|XX)) != (XR|XS));
	case NEMPTY: return ((n-&gt;sym-&gt;xu&amp;(XR|XX)) != XR);
	case  NFULL: return ((n-&gt;sym-&gt;xu&amp;(XS|XX)) != XS);
	case   FULL: return ((n-&gt;sym-&gt;xu&amp;(XR|XX)) != XR);
	case  EMPTY: return ((n-&gt;sym-&gt;xu&amp;(XS|XX)) != XS);
	case  LEN:   return (((n-&gt;sym-&gt;xu)&amp;(XR|XS|XX)) != (XR|XS));

	case   NAME:
		if (n-&gt;sym-&gt;context
		|| (n-&gt;sym-&gt;hidden&amp;64)
		||  strcmp(n-&gt;sym-&gt;name, "_pid") == 0
		||  strcmp(n-&gt;sym-&gt;name, "_") == 0)
			return 0;
		return 1;

	case RUN:
		return proc_is_safe(n);

	case C_CODE: case C_EXPR:
		return glob_inline(n-&gt;sym-&gt;name);

	case ENABLED: case PC_VAL: case NONPROGRESS:
	case 'p': case 'q':
	case TIMEOUT:
		return 1;

	/* 	@ was 1 (global) since 2.8.5
		in 3.0 it is considered local and
		conditionally safe, provided:
			II is the youngest process
			and nrprocs &lt; MAXPROCS
	*/
	case '@': return 0;

	case '!': case UMIN: case '~': case ASSERT:
		return has_global(n-&gt;lft);

	case '/': case '*': case '-': case '+':
	case '%': case LT:  case GT: case '&amp;': case '^':
	case '|': case LE:  case GE:  case NE: case '?':
	case EQ:  case OR:  case AND: case LSHIFT:
	case RSHIFT: case 'c': case ASGN:
		return has_global(n-&gt;lft) || has_global(n-&gt;rgt);

	case PRINT:
		for (v = n-&gt;lft; v; v = v-&gt;rgt)
			if (has_global(v-&gt;lft)) return 1;
		return 0;
	case PRINTM:
		return has_global(n-&gt;lft);
	}
	return 0;
}

static void
Bailout(FILE *fd, char *str)
{
	if (!GenCode)
		fprintf(fd, "continue%s", str);
	else if (IsGuard)
		fprintf(fd, "%s%s", NextLab[Level], str);
	else
		fprintf(fd, "Uerror(\"block in d_step seq\")%s", str);
}

#define cat0(x)   	putstmnt(fd,now-&gt;lft,m); fprintf(fd, x); \
			putstmnt(fd,now-&gt;rgt,m)
#define cat1(x)		fprintf(fd,"("); cat0(x); fprintf(fd,")")
#define cat2(x,y)  	fprintf(fd,x); putstmnt(fd,y,m)
#define cat3(x,y,z)	fprintf(fd,x); putstmnt(fd,y,m); fprintf(fd,z)

void
putstmnt(FILE *fd, Lextok *now, int m)
{	Lextok *v;
	int i, j;

	if (!now) { fprintf(fd, "0"); return; }
	lineno = now-&gt;ln;
	Fname  = now-&gt;fn;

	switch (now-&gt;ntyp) {
	case CONST:	fprintf(fd, "%d", now-&gt;val); break;
	case '!':	cat3(" !(", now-&gt;lft, ")"); break;
	case UMIN:	cat3(" -(", now-&gt;lft, ")"); break;
	case '~':	cat3(" ~(", now-&gt;lft, ")"); break;

	case '/':	cat1("/");  break;
	case '*':	cat1("*");  break;
	case '-':	cat1("-");  break;
	case '+':	cat1("+");  break;
	case '%':	cat1("%%"); break;
	case '&amp;':	cat1("&amp;");  break;
	case '^':	cat1("^");  break;
	case '|':	cat1("|");  break;
	case LT:	cat1("&lt;");  break;
	case GT:	cat1("&gt;");  break;
	case LE:	cat1("&lt;="); break;
	case GE:	cat1("&gt;="); break;
	case NE:	cat1("!="); break;
	case EQ:	cat1("=="); break;
	case OR:	cat1("||"); break;
	case AND:	cat1("&amp;&amp;"); break;
	case LSHIFT:	cat1("&lt;&lt;"); break;
	case RSHIFT:	cat1("&gt;&gt;"); break;

	case TIMEOUT:
		if (separate == 2)
			fprintf(fd, "((tau)&amp;1)");
		else
			fprintf(fd, "((trpt-&gt;tau)&amp;1)");
		if (GenCode)
		 printf("spin: warning, %s:%d, 'timeout' in d_step sequence\n",
			Fname-&gt;name, lineno);
		/* is okay as a guard */
		break;

	case RUN:
		if (now-&gt;sym == NULL)
			Fatal("internal error pangen2.c", (char *) 0);
		if (claimproc
		&amp;&amp;  strcmp(now-&gt;sym-&gt;name, claimproc) == 0)
			fatal("claim %s, (not runnable)", claimproc);
		if (eventmap
		&amp;&amp;  strcmp(now-&gt;sym-&gt;name, eventmap) == 0)
			fatal("eventmap %s, (not runnable)", eventmap);

		if (GenCode)
		  fatal("'run' in d_step sequence (use atomic)",
			(char *)0);

		fprintf(fd,"addproc(II, %d", fproc(now-&gt;sym-&gt;name));
		for (v = now-&gt;lft, i = 0; v; v = v-&gt;rgt, i++)
		{	cat2(", ", v-&gt;lft);
		}
		check_param_count(i, now);

		if (i &gt; Npars)
		{	/* printf("\t%d parameters used, max %d expected\n", i, Npars); */
			fatal("too many parameters in run %s(...)", now-&gt;sym-&gt;name);
		}
		for ( ; i &lt; Npars; i++)
			fprintf(fd, ", 0");
		fprintf(fd, ")");
		break;

	case ENABLED:
		cat3("enabled(II, ", now-&gt;lft, ")");
		break;

	case NONPROGRESS:
		/* o_pm&amp;4=progress, tau&amp;128=claim stutter */
		if (separate == 2)
		fprintf(fd, "(!(o_pm&amp;4) &amp;&amp; !(tau&amp;128))");
		else
		fprintf(fd, "(!(trpt-&gt;o_pm&amp;4) &amp;&amp; !(trpt-&gt;tau&amp;128))");
		break;

	case PC_VAL:
		cat3("((P0 *) Pptr(", now-&gt;lft, "+BASE))-&gt;_p");
		break;

	case LEN:
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;1) || ");
			putname(fd, "q_R_check(", now-&gt;lft, m, "");
			fprintf(fd, ", II)) &amp;&amp;\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;2) || ");
			putname(fd, "q_S_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		putname(fd, "q_len(", now-&gt;lft, m, ")");
		break;

	case FULL:
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;1) || ");
			putname(fd, "q_R_check(", now-&gt;lft, m, "");
			fprintf(fd, ", II)) &amp;&amp;\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;2) || ");
			putname(fd, "q_S_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		putname(fd, "q_full(", now-&gt;lft, m, ")");
		break;

	case EMPTY:
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;1) || ");
			putname(fd, "q_R_check(", now-&gt;lft, m, "");
			fprintf(fd, ", II)) &amp;&amp;\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;2) || ");
			putname(fd, "q_S_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		putname(fd, "(q_len(", now-&gt;lft, m, ")==0)");
		break;

	case NFULL:
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;2) || ");
			putname(fd, "q_S_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		putname(fd, "(!q_full(", now-&gt;lft, m, "))");
		break;

	case NEMPTY:
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;1) || ");
			putname(fd, "q_R_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		putname(fd, "(q_len(", now-&gt;lft, m, ")&gt;0)");
		break;

	case 's':
		if (Pid == eventmapnr)
		{	fprintf(fd, "if ((II == -EVENT_TRACE &amp;&amp; _tp != 's') ");
			putname(fd, "|| _qid+1 != ", now-&gt;lft, m, "");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp != CONST
				&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL)
					continue;
				fprintf(fd, " \\\n\t\t|| qrecv(");
				putname(fd, "", now-&gt;lft, m, ", ");
				putname(fd, "q_len(", now-&gt;lft, m, ")-1, ");
				fprintf(fd, "%d, 0) != ", i);
				if (v-&gt;lft-&gt;ntyp == CONST)
					putstmnt(fd, v-&gt;lft, m);
				else /* EVAL */
					putstmnt(fd, v-&gt;lft-&gt;lft, m);
			}
			fprintf(fd, ")\n");
			fprintf(fd, "\t\t	continue");
			putname(th, " || (x_y3_ == ", now-&gt;lft, m, ")");
			break;
		}
		if (TestOnly)
		{	if (m_loss)
				fprintf(fd, "1");
			else
				putname(fd, "!q_full(", now-&gt;lft, m, ")");
			break;
		}
		if (has_xu)
		{	fprintf(fd, "\n#if !defined(XUSAFE) &amp;&amp; !defined(NOREDUCE)\n\t\t");
			putname(fd, "if (q_claim[", now-&gt;lft, m, "]&amp;2)\n\t\t");
			putname(fd, "{	q_S_check(", now-&gt;lft, m, ", II);\n\t\t");
			fprintf(fd, "}\n");
			if (has_sorted &amp;&amp; now-&gt;val == 1)
			{	putname(fd, "\t\tif (q_claim[", now-&gt;lft, m, "]&amp;1)\n\t\t"); /* &amp;1 iso &amp;2 */
				fprintf(fd, "{	uerror(\"sorted send on xr channel violates po reduction\");\n\t\t");
				fprintf(fd, "}\n");
			}
			fprintf(fd, "#endif\n\t\t");
		}
		fprintf(fd, "if (q_%s",
			(u_sync &gt; 0 &amp;&amp; u_async == 0)?"len":"full");
		putname(fd, "(", now-&gt;lft, m, "))\n");

		if (m_loss)
			fprintf(fd, "\t\t{ nlost++; delta_m = 1; } else {");
		else
		{	fprintf(fd, "\t\t\t");
			Bailout(fd, ";");
		}

		if (has_enabled)
			fprintf(fd, "\n\t\tif (TstOnly) return 1;");

		if (u_sync &amp;&amp; !u_async &amp;&amp; rvopt)
			fprintf(fd, "\n\n\t\tif (no_recvs(II)) continue;\n");

		fprintf(fd, "\n#ifdef HAS_CODE\n");
		fprintf(fd, "\t\tif (readtrail &amp;&amp; gui) {\n");
		fprintf(fd, "\t\t\tchar simtmp[32];\n");
		putname(fd, "\t\t\tsprintf(simvals, \"%%d!\", ", now-&gt;lft, m, ");\n");
		_isok++;
		for (v = now-&gt;rgt, i = 0; v; v = v-&gt;rgt, i++)
		{	cat3("\t\tsprintf(simtmp, \"%%d\", ", v-&gt;lft, "); strcat(simvals, simtmp);");
			if (v-&gt;rgt)
			fprintf(fd, "\t\tstrcat(simvals, \",\");\n");
		}
		_isok--;
		fprintf(fd, "\t\t}\n");
		fprintf(fd, "#endif\n\t\t");

		putname(fd, "\n\t\tqsend(", now-&gt;lft, m, "");
		fprintf(fd, ", %d", now-&gt;val);
		for (v = now-&gt;rgt, i = 0; v; v = v-&gt;rgt, i++)
		{	cat2(", ", v-&gt;lft);
		}
		if (i &gt; Mpars)
		{	terse++;
			putname(stdout, "channel name: ", now-&gt;lft, m, "\n");
			terse--;
			printf("	%d msg parameters sent, %d expected\n", i, Mpars);
			fatal("too many pars in send", "");
		}
		for (j = i; i &lt; Mpars; i++)
			fprintf(fd, ", 0");
		fprintf(fd, ", %d)", j);
		if (u_sync)
		{	fprintf(fd, ";\n\t\t");
			if (u_async)
			  putname(fd, "if (q_zero(", now-&gt;lft, m, ")) ");
			putname(fd, "{ boq = ", now-&gt;lft, m, "");
			if (GenCode)
			  fprintf(fd, "; Uerror(\"rv-attempt in d_step\")");
			fprintf(fd, "; }");
		}
		if (m_loss)
			fprintf(fd, ";\n\t\t}\n\t\t"); /* end of m_loss else */
		break;

	case 'r':
		if (Pid == eventmapnr)
		{	fprintf(fd, "if ((II == -EVENT_TRACE &amp;&amp; _tp != 'r') ");
			putname(fd, "|| _qid+1 != ", now-&gt;lft, m, "");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp != CONST
				&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL)
					continue;
				fprintf(fd, " \\\n\t\t|| qrecv(");
				putname(fd, "", now-&gt;lft, m, ", ");
				fprintf(fd, "0, %d, 0) != ", i);
				if (v-&gt;lft-&gt;ntyp == CONST)
					putstmnt(fd, v-&gt;lft, m);
				else /* EVAL */
					putstmnt(fd, v-&gt;lft-&gt;lft, m);
			}
			fprintf(fd, ")\n");
			fprintf(fd, "\t\t	continue");

			putname(tc, " || (x_y3_ == ", now-&gt;lft, m, ")");

			break;
		}
		if (TestOnly)
		{	fprintf(fd, "((");
			if (u_sync) fprintf(fd, "(boq == -1 &amp;&amp; ");

			putname(fd, "q_len(", now-&gt;lft, m, ")");

			if (u_sync &amp;&amp; now-&gt;val &lt;= 1)
			{ putname(fd, ") || (boq == ",  now-&gt;lft,m," &amp;&amp; ");
			  putname(fd, "q_zero(", now-&gt;lft,m,"))");
			}

			fprintf(fd, ")");
			if (now-&gt;val == 0 || now-&gt;val == 2)
			{	for (v = now-&gt;rgt, i=j=0; v; v = v-&gt;rgt, i++)
				{ if (v-&gt;lft-&gt;ntyp == CONST)
				  { cat3("\n\t\t&amp;&amp; (", v-&gt;lft, " == ");
				    putname(fd, "qrecv(", now-&gt;lft, m, ", ");
				    fprintf(fd, "0, %d, 0))", i);
				  } else if (v-&gt;lft-&gt;ntyp == EVAL)
				  { cat3("\n\t\t&amp;&amp; (", v-&gt;lft-&gt;lft, " == ");
				    putname(fd, "qrecv(", now-&gt;lft, m, ", ");
				    fprintf(fd, "0, %d, 0))", i);
				  } else
				  {	j++; continue;
				  }
				}
			} else
			{	fprintf(fd, "\n\t\t&amp;&amp; Q_has(");
				putname(fd, "", now-&gt;lft, m, "");
				for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
				{	if (v-&gt;lft-&gt;ntyp == CONST)
					{	fprintf(fd, ", 1, ");
						putstmnt(fd, v-&gt;lft, m);
					} else if (v-&gt;lft-&gt;ntyp == EVAL)
					{	fprintf(fd, ", 1, ");
						putstmnt(fd, v-&gt;lft-&gt;lft, m);
					} else
					{	fprintf(fd, ", 0, 0");
				}	}
				for ( ; i &lt; Mpars; i++)
					fprintf(fd, ", 0, 0");
				fprintf(fd, ")");
			}
			fprintf(fd, ")");
			break;
		}
		if (has_xu)
		{	fprintf(fd, "\n#if !defined(XUSAFE) &amp;&amp; !defined(NOREDUCE)\n\t\t");
			putname(fd, "if (q_claim[", now-&gt;lft, m, "]&amp;1)\n\t\t");
			putname(fd, "{	q_R_check(", now-&gt;lft, m, ", II);\n\t\t");
			if (has_random &amp;&amp; now-&gt;val != 0)
			fprintf(fd, "	uerror(\"rand receive on xr channel violates po reduction\");\n\t\t");
			fprintf(fd, "}\n");
			fprintf(fd, "#endif\n\t\t");
		}
		if (u_sync)
		{	if (now-&gt;val &gt;= 2)
			{	if (u_async)
				{ fprintf(fd, "if (");
				  putname(fd, "q_zero(", now-&gt;lft,m,"))");
				  fprintf(fd, "\n\t\t{\t");
				}
				fprintf(fd, "uerror(\"polling ");
				fprintf(fd, "rv chan\");\n\t\t");
				if (u_async)
				  fprintf(fd, "	continue;\n\t\t}\n\t\t");
				fprintf(fd, "IfNotBlocked\n\t\t");
			} else
			{	fprintf(fd, "if (");
				if (u_async == 0)
				  putname(fd, "boq != ", now-&gt;lft,m,") ");
				else
				{ putname(fd, "q_zero(", now-&gt;lft,m,"))");
				  fprintf(fd, "\n\t\t{\tif (boq != ");
				  putname(fd, "",  now-&gt;lft,m,") ");
				  Bailout(fd, ";\n\t\t} else\n\t\t");
				  fprintf(fd, "{\tif (boq != -1) ");
				}
				Bailout(fd, ";\n\t\t");
				if (u_async)
					fprintf(fd, "}\n\t\t");
		}	}
		putname(fd, "if (q_len(", now-&gt;lft, m, ") == 0) ");
		Bailout(fd, "");

		for (v = now-&gt;rgt, j=0; v; v = v-&gt;rgt)
		{	if (v-&gt;lft-&gt;ntyp != CONST
			&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL)
				j++;	/* count settables */
		}
		fprintf(fd, ";\n\n\t\tXX=1");
/* test */	if (now-&gt;val == 0 || now-&gt;val == 2)
		{	for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp == CONST)
				{ fprintf(fd, ";\n\t\t");
				  cat3("if (", v-&gt;lft, " != ");
				  putname(fd, "qrecv(", now-&gt;lft, m, ", ");
				  fprintf(fd, "0, %d, 0)) ", i);
				  Bailout(fd, "");
				} else if (v-&gt;lft-&gt;ntyp == EVAL)
				{ fprintf(fd, ";\n\t\t");
				  cat3("if (", v-&gt;lft-&gt;lft, " != ");
				  putname(fd, "qrecv(", now-&gt;lft, m, ", ");
				  fprintf(fd, "0, %d, 0)) ", i);
				  Bailout(fd, "");
			}	}
		} else	/* random receive: val 1 or 3 */
		{	fprintf(fd, ";\n\t\tif (!(XX = Q_has(");
			putname(fd, "", now-&gt;lft, m, "");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp == CONST)
				{	fprintf(fd, ", 1, ");
					putstmnt(fd, v-&gt;lft, m);
				} else if (v-&gt;lft-&gt;ntyp == EVAL)
				{	fprintf(fd, ", 1, ");
					putstmnt(fd, v-&gt;lft-&gt;lft, m);
				} else
				{	fprintf(fd, ", 0, 0");
			}	}
			for ( ; i &lt; Mpars; i++)
				fprintf(fd, ", 0, 0");
			fprintf(fd, "))) ");
			Bailout(fd, "");
 if (!GenCode) {
			fprintf(fd, ";\n\t\t");
			if (multi_oval)
			{	check_needed();
				fprintf(fd, "(trpt+1)-&gt;bup.ovals[%d] = ",
					multi_oval-1);
				multi_oval++;
			} else
				fprintf(fd, "(trpt+1)-&gt;bup.oval = ");
			fprintf(fd, "XX");
 }
		}

		if (has_enabled)
			fprintf(fd, ";\n\t\tif (TstOnly) return 1");

		if (j == 0 &amp;&amp; now-&gt;val &gt;= 2)
		{	fprintf(fd, ";\n\t\t");
			break;	/* poll without side-effect */
		}

		if (!GenCode)
		{	int jj = 0;
			fprintf(fd, ";\n\t\t");
			/* no variables modified */
			if (j == 0 &amp;&amp; now-&gt;val == 0)
			{	fprintf(fd, "if (q_flds[((Q0 *)qptr(");
				putname(fd, "", now-&gt;lft, m, "-1))-&gt;_t]");
				fprintf(fd, " != %d)\n\t", i);
				fprintf(fd, "\t\tUerror(\"wrong nr of msg fields in rcv\");\n\t\t");
			}

			for (v = now-&gt;rgt; v; v = v-&gt;rgt)
				if ((v-&gt;lft-&gt;ntyp != CONST
				&amp;&amp;   v-&gt;lft-&gt;ntyp != EVAL))
					jj++;	/* nr of vars needing bup */

			if (jj)
			for (v = now-&gt;rgt, i = 0; v; v = v-&gt;rgt, i++)
			{	char tempbuf[64];

				if ((v-&gt;lft-&gt;ntyp == CONST
				||   v-&gt;lft-&gt;ntyp == EVAL))
					continue;

				if (multi_oval)
				{	check_needed();
					sprintf(tempbuf, "(trpt+1)-&gt;bup.ovals[%d] = ",
						multi_oval-1);
					multi_oval++;
				} else
					sprintf(tempbuf, "(trpt+1)-&gt;bup.oval = ");

				if (v-&gt;lft-&gt;sym &amp;&amp; !strcmp(v-&gt;lft-&gt;sym-&gt;name, "_"))
				{	fprintf(fd, tempbuf);
					putname(fd, "qrecv(", now-&gt;lft, m, "");
					fprintf(fd, ", XX-1, %d, 0);\n\t\t", i);
				} else
				{	_isok++;
					cat3(tempbuf, v-&gt;lft, ";\n\t\t");
					_isok--;
				}
			}

			if (jj)	/* check for double entries q?x,x */
			{	Lextok *w;

				for (v = now-&gt;rgt; v; v = v-&gt;rgt)
				{	if (v-&gt;lft-&gt;ntyp != CONST
					&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL
					&amp;&amp;  v-&gt;lft-&gt;sym
					&amp;&amp;  v-&gt;lft-&gt;sym-&gt;type != STRUCT	/* not a struct */
					&amp;&amp;  (v-&gt;lft-&gt;sym-&gt;nel == 1 &amp;&amp; v-&gt;lft-&gt;sym-&gt;isarray == 0) /* not array */
					&amp;&amp;  strcmp(v-&gt;lft-&gt;sym-&gt;name, "_") != 0)
					for (w = v-&gt;rgt; w; w = w-&gt;rgt)
						if (v-&gt;lft-&gt;sym == w-&gt;lft-&gt;sym)
						{	fatal("cannot use var ('%s') in multiple msg fields",
								v-&gt;lft-&gt;sym-&gt;name);
			}	}		}
		}
/* set */	for (v = now-&gt;rgt, i = 0; v; v = v-&gt;rgt, i++)
		{	if ((v-&gt;lft-&gt;ntyp == CONST
			||   v-&gt;lft-&gt;ntyp == EVAL) &amp;&amp; v-&gt;rgt)
				continue;
			fprintf(fd, ";\n\t\t");

			if (v-&gt;lft-&gt;ntyp != CONST
			&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL
			&amp;&amp;  v-&gt;lft-&gt;sym != NULL
			&amp;&amp;  strcmp(v-&gt;lft-&gt;sym-&gt;name, "_") != 0)
			{	nocast=1;
				_isok++;
				putstmnt(fd, v-&gt;lft, m);
				_isok--;
				nocast=0;
				fprintf(fd, " = ");
			}
			putname(fd, "qrecv(", now-&gt;lft, m, ", ");
			fprintf(fd, "XX-1, %d, ", i);
			fprintf(fd, "%d)", (v-&gt;rgt || now-&gt;val &gt;= 2)?0:1);

			if (v-&gt;lft-&gt;ntyp != CONST
			&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL
			&amp;&amp;  v-&gt;lft-&gt;sym != NULL
			&amp;&amp; strcmp(v-&gt;lft-&gt;sym-&gt;name, "_") != 0
			&amp;&amp;  (v-&gt;lft-&gt;ntyp != NAME
			||   v-&gt;lft-&gt;sym-&gt;type != CHAN))
			{	fprintf(fd, ";\n#ifdef VAR_RANGES");
				fprintf(fd, "\n\t\tlogval(\"");
				withprocname = terse = nocast = 1;
				_isok++;
				putstmnt(fd,v-&gt;lft,m);
				withprocname = terse = nocast = 0;
				fprintf(fd, "\", ");
				putstmnt(fd,v-&gt;lft,m);
				_isok--;
				fprintf(fd, ");\n#endif\n");
				fprintf(fd, "\t\t");
			}
		}
		fprintf(fd, ";\n\t\t");

		fprintf(fd, "\n#ifdef HAS_CODE\n");
		fprintf(fd, "\t\tif (readtrail &amp;&amp; gui) {\n");
		fprintf(fd, "\t\t\tchar simtmp[32];\n");
		putname(fd, "\t\t\tsprintf(simvals, \"%%d?\", ", now-&gt;lft, m, ");\n");
		_isok++;
		for (v = now-&gt;rgt, i = 0; v; v = v-&gt;rgt, i++)
		{	if (v-&gt;lft-&gt;ntyp != EVAL)
			{ cat3("\t\tsprintf(simtmp, \"%%d\", ", v-&gt;lft, "); strcat(simvals, simtmp);");
			} else
			{ cat3("\t\tsprintf(simtmp, \"%%d\", ", v-&gt;lft-&gt;lft, "); strcat(simvals, simtmp);");
			}
			if (v-&gt;rgt)
			fprintf(fd, "\t\tstrcat(simvals, \",\");\n");
		}
		_isok--;
		fprintf(fd, "\t\t}\n");
		fprintf(fd, "#endif\n\t\t");

		if (u_sync)
		{	putname(fd, "if (q_zero(", now-&gt;lft, m, "))");
			fprintf(fd, "\n\t\t{	boq = -1;\n");

			fprintf(fd, "#ifndef NOFAIR\n"); /* NEW 3.0.8 */
			fprintf(fd, "\t\t\tif (fairness\n");
			fprintf(fd, "\t\t\t&amp;&amp; !(trpt-&gt;o_pm&amp;32)\n");
			fprintf(fd, "\t\t\t&amp;&amp; (now._a_t&amp;2)\n");
			fprintf(fd, "\t\t\t&amp;&amp;  now._cnt[now._a_t&amp;1] == II+2)\n");
			fprintf(fd, "\t\t\t{	now._cnt[now._a_t&amp;1] -= 1;\n");
			fprintf(fd, "#ifdef VERI\n");
			fprintf(fd, "\t\t\t	if (II == 1)\n");
			fprintf(fd, "\t\t\t		now._cnt[now._a_t&amp;1] = 1;\n");
			fprintf(fd, "#endif\n");
			fprintf(fd, "#ifdef DEBUG\n");
			fprintf(fd, "\t\t\tprintf(\"%%3d: proc %%d fairness \", depth, II);\n");
			fprintf(fd, "\t\t\tprintf(\"Rule 2: --cnt to %%d (%%d)\\n\",\n");
			fprintf(fd, "\t\t\t	now._cnt[now._a_t&amp;1], now._a_t);\n");
			fprintf(fd, "#endif\n");
			fprintf(fd, "\t\t\t	trpt-&gt;o_pm |= (32|64);\n");
			fprintf(fd, "\t\t\t}\n");
			fprintf(fd, "#endif\n");

			fprintf(fd, "\n\t\t}");
		}
		break;

	case 'R':
		if (!terse &amp;&amp; !TestOnly &amp;&amp; has_xu)
		{	fprintf(fd, "\n#ifndef XUSAFE\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;1) || ");
			fprintf(fd, "q_R_check(");
			putname(fd, "", now-&gt;lft, m, ", II)) &amp;&amp;\n\t\t");
			putname(fd, "(!(q_claim[", now-&gt;lft, m, "]&amp;2) || ");
			putname(fd, "q_S_check(", now-&gt;lft, m, ", II)) &amp;&amp;");
			fprintf(fd, "\n#endif\n\t\t");
		}
		if (u_sync&gt;0)
			putname(fd, "not_RV(", now-&gt;lft, m, ") &amp;&amp; \\\n\t\t");

		for (v = now-&gt;rgt, i=j=0; v; v = v-&gt;rgt, i++)
			if (v-&gt;lft-&gt;ntyp != CONST
			&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL)
			{	j++; continue;
			}
		if (now-&gt;val == 0 || i == j)
		{	putname(fd, "(q_len(", now-&gt;lft, m, ") &gt; 0");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp != CONST
				&amp;&amp;  v-&gt;lft-&gt;ntyp != EVAL)
					continue;
				fprintf(fd, " \\\n\t\t&amp;&amp; qrecv(");
				putname(fd, "", now-&gt;lft, m, ", ");
				fprintf(fd, "0, %d, 0) == ", i);
				if (v-&gt;lft-&gt;ntyp == CONST)
					putstmnt(fd, v-&gt;lft, m);
				else /* EVAL */
					putstmnt(fd, v-&gt;lft-&gt;lft, m);
			}
			fprintf(fd, ")");
		} else
		{	putname(fd, "Q_has(", now-&gt;lft, m, "");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v-&gt;lft-&gt;ntyp == CONST)
				{	fprintf(fd, ", 1, ");
					putstmnt(fd, v-&gt;lft, m);
				} else if (v-&gt;lft-&gt;ntyp == EVAL)
				{	fprintf(fd, ", 1, ");
					putstmnt(fd, v-&gt;lft-&gt;lft, m);
				} else
					fprintf(fd, ", 0, 0");
			}	
			for ( ; i &lt; Mpars; i++)
				fprintf(fd, ", 0, 0");
			fprintf(fd, ")");
		}
		break;

	case 'c':
		preruse(fd, now-&gt;lft);	/* preconditions */
		cat3("if (!(", now-&gt;lft, "))\n\t\t\t");
		Bailout(fd, "");
		break;

	case  ELSE:
		if (!GenCode)
		{	if (separate == 2)
				fprintf(fd, "if (o_pm&amp;1)\n\t\t\t");
			else
				fprintf(fd, "if (trpt-&gt;o_pm&amp;1)\n\t\t\t");
			Bailout(fd, "");
		} else
		{	fprintf(fd, "/* else */");
		}
		break;

	case '?':
		if (now-&gt;lft)
		{	cat3("( (", now-&gt;lft, ") ? ");
		}
		if (now-&gt;rgt)
		{	cat3("(", now-&gt;rgt-&gt;lft, ") : ");
			cat3("(", now-&gt;rgt-&gt;rgt, ") )");
		}
		break;

	case ASGN:
		if (has_enabled)
		fprintf(fd, "if (TstOnly) return 1;\n\t\t");
		_isok++;

		if (!GenCode)
		{	if (multi_oval)
			{	char tempbuf[64];
				check_needed();
				sprintf(tempbuf, "(trpt+1)-&gt;bup.ovals[%d] = ",
					multi_oval-1);
				multi_oval++;
				cat3(tempbuf, now-&gt;lft, ";\n\t\t");
			} else
			{	cat3("(trpt+1)-&gt;bup.oval = ", now-&gt;lft, ";\n\t\t");
		}	}
		nocast = 1; putstmnt(fd,now-&gt;lft,m); nocast = 0;
		fprintf(fd," = ");
		_isok--;
		putstmnt(fd,now-&gt;rgt,m);

		if (now-&gt;sym-&gt;type != CHAN
		||  verbose &gt; 0)
		{	fprintf(fd, ";\n#ifdef VAR_RANGES");
			fprintf(fd, "\n\t\tlogval(\"");
			withprocname = terse = nocast = 1;
			_isok++;
			putstmnt(fd,now-&gt;lft,m);
			withprocname = terse = nocast = 0;
			fprintf(fd, "\", ");
			putstmnt(fd,now-&gt;lft,m);
			_isok--;
			fprintf(fd, ");\n#endif\n");
			fprintf(fd, "\t\t");
		}
		break;

	case PRINT:
		if (has_enabled)
		fprintf(fd, "if (TstOnly) return 1;\n\t\t");
#ifdef PRINTF
		fprintf(fd, "printf(%s", now-&gt;sym-&gt;name);
#else
		fprintf(fd, "Printf(%s", now-&gt;sym-&gt;name);
#endif
		for (v = now-&gt;lft; v; v = v-&gt;rgt)
		{	cat2(", ", v-&gt;lft);
		}
		fprintf(fd, ")");
		break;

	case PRINTM:
		if (has_enabled)
		fprintf(fd, "if (TstOnly) return 1;\n\t\t");
		fprintf(fd, "printm(");
		if (now-&gt;lft &amp;&amp; now-&gt;lft-&gt;ismtyp)
			fprintf(fd, "%d", now-&gt;lft-&gt;val);
		else
			putstmnt(fd, now-&gt;lft, m);
		fprintf(fd, ")");
		break;

	case NAME:
		if (!nocast &amp;&amp; now-&gt;sym &amp;&amp; Sym_typ(now) &lt; SHORT)
			putname(fd, "((int)", now, m, ")");
		else
			putname(fd, "", now, m, "");
		break;

	case   'p':
		putremote(fd, now, m);
		break;

	case   'q':
		if (terse)
			fprintf(fd, "%s", now-&gt;sym-&gt;name);
		else
			fprintf(fd, "%d", remotelab(now));
		break;

	case C_EXPR:
		fprintf(fd, "(");
		plunk_expr(fd, now-&gt;sym-&gt;name);
#if 1
		fprintf(fd, ")");
#else
		fprintf(fd, ") /* %s */ ", now-&gt;sym-&gt;name);
#endif
		break;

	case C_CODE:
		if (now-&gt;sym)
			fprintf(fd, "/* %s */\n\t\t", now-&gt;sym-&gt;name);
		if (has_enabled)
			fprintf(fd, "if (TstOnly) return 1;\n\t\t");

		if (now-&gt;sym)
			plunk_inline(fd, now-&gt;sym-&gt;name, 1, GenCode);
		else
			Fatal("internal error pangen2.c", (char *) 0);

		if (!GenCode)
		{	fprintf(fd, "\n");	/* state changed, capture it */
			fprintf(fd, "#if defined(C_States) &amp;&amp; (HAS_TRACK==1)\n");
			fprintf(fd, "\t\tc_update((uchar *) &amp;(now.c_state[0]));\n");
			fprintf(fd, "#endif\n");
		}
		break;

	case ASSERT:
		if (has_enabled)
			fprintf(fd, "if (TstOnly) return 1;\n\t\t");

		cat3("spin_assert(", now-&gt;lft, ", ");
		terse = nocast = 1;
		cat3("\"", now-&gt;lft, "\", II, tt, t)");
		terse = nocast = 0;
		break;

	case '.':
	case BREAK:
	case GOTO:
		if (Pid == eventmapnr)
			fprintf(fd, "Uerror(\"cannot get here\")");
		putskip(m);
		break;

	case '@':
		if (Pid == eventmapnr)
		{	fprintf(fd, "return 0");
			break;
		}

		if (has_enabled)
		{	fprintf(fd, "if (TstOnly)\n\t\t\t");
			fprintf(fd, "return (II+1 == now._nr_pr);\n\t\t");
		}
		fprintf(fd, "if (!delproc(1, II)) ");
		Bailout(fd, "");
		break;

	default:
		printf("spin: error, %s:%d, bad node type %d (.m)\n",
			now-&gt;fn-&gt;name, now-&gt;ln, now-&gt;ntyp);
		fflush(tm);
		alldone(1);
	}
}

char *
simplify_name(char *s)
{	char *t = s;

	if (!old_scope_rules)
	{	while (*t == '_' || isdigit((int)*t))
		{	t++;
	}	}

	return t;
}

void
putname(FILE *fd, char *pre, Lextok *n, int m, char *suff) /* varref */
{	Symbol *s = n-&gt;sym;
	char *ptr;

	lineno = n-&gt;ln; Fname = n-&gt;fn;

	if (!s)
		fatal("no name - putname", (char *) 0);

	if (s-&gt;context &amp;&amp; context &amp;&amp; s-&gt;type)
		s = findloc(s);		/* it's a local var */

	if (!s)
	{	fprintf(fd, "%s%s%s", pre, n-&gt;sym-&gt;name, suff);
		return;
	}
	if (!s-&gt;type)	/* not a local name */
		s = lookup(s-&gt;name);	/* must be a global */

	if (!s-&gt;type)
	{	if (strcmp(pre, ".") != 0)
			fatal("undeclared variable '%s'", s-&gt;name);
		s-&gt;type = INT;
	}

	if (s-&gt;type == PROCTYPE)
		fatal("proctype-name '%s' used as array-name", s-&gt;name);

	fprintf(fd, pre);
	if (!terse &amp;&amp; !s-&gt;owner &amp;&amp; evalindex != 1)
	{	if (s-&gt;context
		||  strcmp(s-&gt;name, "_p") == 0
		||  strcmp(s-&gt;name, "_pid") == 0)
		{	fprintf(fd, "((P%d *)this)-&gt;", Pid);
		} else
		{	int x = strcmp(s-&gt;name, "_");
			if (!(s-&gt;hidden&amp;1) &amp;&amp; x != 0)
				fprintf(fd, "now.");
			if (x == 0 &amp;&amp; _isok == 0)
				fatal("attempt to read value of '_'", 0);
	}	}

	ptr = s-&gt;name;

	if (s-&gt;type != PREDEF)	/* new 6.0.2 */
	{	if (withprocname
		&amp;&amp;  s-&gt;context
		&amp;&amp;  strcmp(pre, "."))
		{	fprintf(fd, "%s:", s-&gt;context-&gt;name);
			ptr = simplify_name(ptr);
		} else
		{	if (terse)
			{	ptr = simplify_name(ptr);
	}	}	}

	if (evalindex != 1)
		fprintf(fd, "%s", ptr);

	if (s-&gt;nel &gt; 1 || s-&gt;isarray == 1)
	{	if (no_arrays)
		{	non_fatal("ref to array element invalid in this context",
				(char *)0);
			printf("\thint: instead of, e.g., x[rs] qu[3], use\n");
			printf("\tchan nm_3 = qu[3]; x[rs] nm_3;\n");
			printf("\tand use nm_3 in sends/recvs instead of qu[3]\n");
		}
		/* an xr or xs reference to an array element
		 * becomes an exclusion tag on the array itself -
		 * which could result in invalidly labeling
		 * operations on other elements of this array to
		 * be also safe under the partial order reduction
		 * (see procedure has_global())
		 */

		if (evalindex == 2)
		{	fprintf(fd, "[%%d]");
		} else if (evalindex == 1)
		{	evalindex = 0;		/* no good if index is indexed array */
			fprintf(fd, ", ");
			putstmnt(fd, n-&gt;lft, m);
			evalindex = 1;
		} else
		{	if (terse
			|| (n-&gt;lft
			&amp;&amp;  n-&gt;lft-&gt;ntyp == CONST
			&amp;&amp;  n-&gt;lft-&gt;val &lt; s-&gt;nel)
			|| (!n-&gt;lft &amp;&amp; s-&gt;nel &gt; 0))
			{	cat3("[", n-&gt;lft, "]");
			} else
			{	/* attempt to catch arrays that are indexed with an array element in the same array
				 * this causes trouble in the verifier in the backtracking
				 * e.g., restoring a[?] in the assignment: a [a[1]] = x where a[1] == 1
				 * but it is hard when the array is inside a structure, so the names dont match
				 */
#if 0
				if (n-&gt;lft-&gt;ntyp == NAME)
				{	printf("%4d: Basename %s	index %s\n",
						n-&gt;lft-&gt;ln, s-&gt;name, n-&gt;lft-&gt;sym-&gt;name);
				}
#endif
				cat3("[ Index(", n-&gt;lft, ", ");
				fprintf(fd, "%d) ]", s-&gt;nel);
		}	}
	} else
	{	if (n-&gt;lft	/* effectively a scalar, but with an index */
		&amp;&amp; (n-&gt;lft-&gt;ntyp != CONST
		||  n-&gt;lft-&gt;val != 0))
		{	fatal("ref to scalar '%s' using array index", (char *) ptr);
	}	}

	if (s-&gt;type == STRUCT &amp;&amp; n-&gt;rgt &amp;&amp; n-&gt;rgt-&gt;lft)
	{	putname(fd, ".", n-&gt;rgt-&gt;lft, m, "");
	}
	fprintf(fd, suff);
}

void
putremote(FILE *fd, Lextok *n, int m)	/* remote reference */
{	int promoted = 0;
	int pt;

	if (terse)
	{	fprintf(fd, "%s", n-&gt;lft-&gt;sym-&gt;name);	/* proctype name */
		if (n-&gt;lft-&gt;lft)
		{	fprintf(fd, "[");
			putstmnt(fd, n-&gt;lft-&gt;lft, m);	/* pid */
			fprintf(fd, "]");
		}
		fprintf(fd, ".%s", n-&gt;sym-&gt;name);
	} else
	{	if (Sym_typ(n) &lt; SHORT)
		{	promoted = 1;
			fprintf(fd, "((int)");
		}

		pt = fproc(n-&gt;lft-&gt;sym-&gt;name);
		fprintf(fd, "((P%d *)Pptr(", pt);
		if (n-&gt;lft-&gt;lft)
		{	fprintf(fd, "BASE+");
			putstmnt(fd, n-&gt;lft-&gt;lft, m);
		} else
			fprintf(fd, "f_pid(%d)", pt);
		fprintf(fd, "))-&gt;%s", n-&gt;sym-&gt;name);
	}
	if (n-&gt;rgt)
	{	fprintf(fd, "[");
		putstmnt(fd, n-&gt;rgt, m);	/* array var ref */
		fprintf(fd, "]");
	}
	if (promoted) fprintf(fd, ")");
}

static int
getweight(Lextok *n)
{	/* this piece of code is a remnant of early versions
	 * of the verifier -- in the current version of Spin
	 * only non-zero values matter - so this could probably
	 * simply return 1 in all cases.
	 */
	switch (n-&gt;ntyp) {
	case 'r':     return 4;
	case 's':     return 2;
	case TIMEOUT: return 1;
	case 'c':     if (has_typ(n-&gt;lft, TIMEOUT)) return 1;
	}
	return 3;
}

int
has_typ(Lextok *n, int m)
{
	if (!n) return 0;
	if (n-&gt;ntyp == m) return 1;
	return (has_typ(n-&gt;lft, m) || has_typ(n-&gt;rgt, m));
}

static int runcount, opcount;

static void
do_count(Lextok *n, int checkop)
{
	if (!n) return;

	switch (n-&gt;ntyp) {
	case RUN:
		runcount++;
		break;
	default:
		if (checkop) opcount++;
		break;
	}
	do_count(n-&gt;lft, checkop &amp;&amp; (n-&gt;ntyp != RUN));
	do_count(n-&gt;rgt, checkop);
}

void
count_runs(Lextok *n)
{
	runcount = opcount = 0;
	do_count(n, 1);
	if (runcount &gt; 1)
		fatal("more than one run operator in expression", "");
	if (runcount == 1 &amp;&amp; opcount &gt; 1)
		fatal("use of run operator in compound expression", "");
}

void
any_runs(Lextok *n)
{
	runcount = opcount = 0;
	do_count(n, 0);
	if (runcount &gt;= 1)
		fatal("run operator used in invalid context", "");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

