<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen3.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen3.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen3.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

extern FILE	*th;
extern int	eventmapnr;

typedef struct SRC {
	int ln, st;	/* linenr, statenr */
	Symbol *fn;	/* filename */
	struct SRC *nxt;
} SRC;

static int	col;
static Symbol	*lastfnm;
static Symbol	lastdef;
static int	lastfrom;
static SRC	*frst = (SRC *) 0;
static SRC	*skip = (SRC *) 0;

extern int	ltl_mode;

extern void	sr_mesg(FILE *, int, int);

static void
putnr(int n)
{
	if (col++ == 8)
	{	fprintf(th, "\n\t");
		col = 1;
	}
	fprintf(th, "%3d, ", n);
}

static void
putfnm(int j, Symbol *s)
{
	if (lastfnm &amp;&amp; lastfnm == s &amp;&amp; j != -1)
		return;

	if (lastfnm)
		fprintf(th, "{ \"%s\", %d, %d },\n\t",
			lastfnm-&gt;name,
			lastfrom,
			j-1);
	lastfnm = s;
	lastfrom = j;
}

static void
putfnm_flush(int j)
{
	if (lastfnm)
		fprintf(th, "{ \"%s\", %d, %d }\n",
			lastfnm-&gt;name,
			lastfrom, j);
}

void
putskip(int m)	/* states that need not be reached */
{	SRC *tmp;

	for (tmp = skip; tmp; tmp = tmp-&gt;nxt)
		if (tmp-&gt;st == m)
			return;
	tmp = (SRC *) emalloc(sizeof(SRC));
	tmp-&gt;st  = m;
	tmp-&gt;nxt = skip;
	skip = tmp;
}

void
unskip(int m)	/* a state that needs to be reached after all */
{	SRC *tmp, *lst=(SRC *)0;

	for (tmp = skip; tmp; lst = tmp, tmp = tmp-&gt;nxt)
		if (tmp-&gt;st == m)
		{	if (tmp == skip)
				skip = skip-&gt;nxt;
			else if (lst)	/* always true, but helps coverity */
				lst-&gt;nxt = tmp-&gt;nxt;
			break;
		}
}

void
putsrc(Element *e)	/* match states to source lines */
{	SRC *tmp;
	int n, m;

	if (!e || !e-&gt;n) return;

	n = e-&gt;n-&gt;ln;
	m = e-&gt;seqno;

	for (tmp = frst; tmp; tmp = tmp-&gt;nxt)
		if (tmp-&gt;st == m)
		{	if (tmp-&gt;ln != n || tmp-&gt;fn != e-&gt;n-&gt;fn)
			printf("putsrc mismatch seqno %d, line %d - %d, file %s\n", m, n,
				tmp-&gt;ln, tmp-&gt;fn-&gt;name);
			return;
		}
	tmp = (SRC *) emalloc(sizeof(SRC));
	tmp-&gt;ln = n;
	tmp-&gt;st = m;
	tmp-&gt;fn = e-&gt;n-&gt;fn;
	tmp-&gt;nxt = frst;
	frst = tmp;
}

static void
dumpskip(int n, int m)
{	SRC *tmp, *lst;
	int j;

	fprintf(th, "uchar reached%d [] = {\n\t", m);
	for (j = 0, col = 0; j &lt;= n; j++)
	{	lst = (SRC *) 0;
		for (tmp = skip; tmp; lst = tmp, tmp = tmp-&gt;nxt)
			if (tmp-&gt;st == j)
			{	putnr(1);
				if (lst)
					lst-&gt;nxt = tmp-&gt;nxt;
				else
					skip = tmp-&gt;nxt;
				break;
			}
		if (!tmp)
			putnr(0);
	}
	fprintf(th, "};\n");

	fprintf(th, "uchar *loopstate%d;\n", m);

	if (m == eventmapnr)
		fprintf(th, "#define reached_event	reached%d\n", m);

	skip = (SRC *) 0;
}

void
dumpsrc(int n, int m)
{	SRC *tmp, *lst;
	int j;
	static int did_claim = 0;

	fprintf(th, "short src_ln%d [] = {\n\t", m);
	for (j = 0, col = 0; j &lt;= n; j++)
	{	lst = (SRC *) 0;
		for (tmp = frst; tmp; lst = tmp, tmp = tmp-&gt;nxt)
			if (tmp-&gt;st == j)
			{	putnr(tmp-&gt;ln);
				break;
			}
		if (!tmp)
			putnr(0);
	}
	fprintf(th, "};\n");

	lastfnm = (Symbol *) 0;
	lastdef.name = "-";
	fprintf(th, "S_F_MAP src_file%d [] = {\n\t", m);
	for (j = 0, col = 0; j &lt;= n; j++)
	{	lst = (SRC *) 0;
		for (tmp = frst; tmp; lst = tmp, tmp = tmp-&gt;nxt)
			if (tmp-&gt;st == j)
			{	putfnm(j, tmp-&gt;fn);
				if (lst)
					lst-&gt;nxt = tmp-&gt;nxt;
				else
					frst = tmp-&gt;nxt;
				break;
			}
		if (!tmp)
			putfnm(j, &amp;lastdef);
	}
	putfnm_flush(j);
	fprintf(th, "};\n");

	if (pid_is_claim(m) &amp;&amp; !did_claim)
	{	fprintf(th, "short *src_claim;\n");
		did_claim++;
	}
	if (m == eventmapnr)
		fprintf(th, "#define src_event	src_ln%d\n", m);

	frst = (SRC *) 0;
	dumpskip(n, m);
}

#define Cat0(x)   	comwork(fd,now-&gt;lft,m); fprintf(fd, x); \
			comwork(fd,now-&gt;rgt,m)
#define Cat1(x)		fprintf(fd,"("); Cat0(x); fprintf(fd,")")
#define Cat2(x,y)  	fprintf(fd,x); comwork(fd,y,m)
#define Cat3(x,y,z)	fprintf(fd,x); comwork(fd,y,m); fprintf(fd,z)

static int
symbolic(FILE *fd, Lextok *tv)
{	Lextok *n; extern Lextok *Mtype;
	int cnt = 1;

	if (tv-&gt;ismtyp)
	for (n = Mtype; n; n = n-&gt;rgt, cnt++)
		if (cnt == tv-&gt;val)
		{	fprintf(fd, "%s", n-&gt;lft-&gt;sym-&gt;name);
			return 1;
		}
	return 0;
}

static void
comwork(FILE *fd, Lextok *now, int m)
{	Lextok *v;
	int i, j;

	if (!now) { fprintf(fd, "0"); return; }
	switch (now-&gt;ntyp) {
	case CONST:	sr_mesg(fd, now-&gt;val, now-&gt;ismtyp); break;
	case '!':	Cat3("!(", now-&gt;lft, ")"); break;
	case UMIN:	Cat3("-(", now-&gt;lft, ")"); break;
	case '~':	Cat3("~(", now-&gt;lft, ")"); break;

	case '/':	Cat1("/");  break;
	case '*':	Cat1("*");  break;
	case '-':	Cat1("-");  break;
	case '+':	Cat1("+");  break;
	case '%':	Cat1("%%"); break;
	case '&amp;':	Cat1("&amp;");  break;
	case '^':	Cat1("^");  break;
	case '|':	Cat1("|");  break;
	case LE:	Cat1("&lt;="); break;
	case GE:	Cat1("&gt;="); break;
	case GT:	Cat1("&gt;"); break;
	case LT:	Cat1("&lt;"); break;
	case NE:	Cat1("!="); break;
	case EQ:
			if (ltl_mode
			&amp;&amp;  now-&gt;lft-&gt;ntyp == 'p'
			&amp;&amp;  now-&gt;rgt-&gt;ntyp == 'q')	/* remote ref */
			{	Lextok *p = now-&gt;lft-&gt;lft;

				fprintf(fd, "(");
				fprintf(fd, "%s", p-&gt;sym-&gt;name);
				if (p-&gt;lft)
				{	fprintf(fd, "[");
					putstmnt(fd, p-&gt;lft, 0); /* pid */
					fprintf(fd, "]");
				}
				fprintf(fd, "@");
				fprintf(fd, "%s", now-&gt;rgt-&gt;sym-&gt;name);
				fprintf(fd, ")");
				break;
			}
			Cat1("==");
			break;

	case OR:	Cat1("||"); break;
	case AND:	Cat1("&amp;&amp;"); break;
	case LSHIFT:	Cat1("&lt;&lt;"); break;
	case RSHIFT:	Cat1("&gt;&gt;"); break;

	case RUN:	fprintf(fd, "run %s(", now-&gt;sym-&gt;name);
			for (v = now-&gt;lft; v; v = v-&gt;rgt)
				if (v == now-&gt;lft)
				{	comwork(fd, v-&gt;lft, m);
				} else
				{	Cat2(",", v-&gt;lft);
				}
			fprintf(fd, ")");
			break;

	case LEN:	putname(fd, "len(", now-&gt;lft, m, ")");
			break;
	case FULL:	putname(fd, "full(", now-&gt;lft, m, ")");
			break;
	case EMPTY:	putname(fd, "empty(", now-&gt;lft, m, ")");
			break;
	case NFULL:	putname(fd, "nfull(", now-&gt;lft, m, ")");
			break;
	case NEMPTY:	putname(fd, "nempty(", now-&gt;lft, m, ")");
			break;

	case 's':	putname(fd, "", now-&gt;lft, m, now-&gt;val?"!!":"!");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v != now-&gt;rgt) fprintf(fd,",");
				if (!symbolic(fd, v-&gt;lft))
					comwork(fd,v-&gt;lft,m);
			}
			break;
	case 'r':	putname(fd, "", now-&gt;lft, m, "?");
			switch (now-&gt;val) {
			case 0: break;
			case 1: fprintf(fd, "?");  break;
			case 2: fprintf(fd, "&lt;");  break;
			case 3: fprintf(fd, "?&lt;"); break;
			}
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v != now-&gt;rgt) fprintf(fd,",");
				if (!symbolic(fd, v-&gt;lft))
					comwork(fd,v-&gt;lft,m);
			}
			if (now-&gt;val &gt;= 2)
				fprintf(fd, "&gt;");
			break;
	case 'R':	putname(fd, "", now-&gt;lft, m,  now-&gt;val?"??[":"?[");
			for (v = now-&gt;rgt, i=0; v; v = v-&gt;rgt, i++)
			{	if (v != now-&gt;rgt) fprintf(fd,",");
				if (!symbolic(fd, v-&gt;lft))
					comwork(fd,v-&gt;lft,m);
			}
			fprintf(fd, "]");
			break;

	case ENABLED:	Cat3("enabled(", now-&gt;lft, ")");
			break;

	case EVAL:	Cat3("eval(", now-&gt;lft, ")");
			break;

	case NONPROGRESS:
			fprintf(fd, "np_");
			break;

	case PC_VAL:	Cat3("pc_value(", now-&gt;lft, ")");
			break;

	case 'c':	Cat3("(", now-&gt;lft, ")");
			break;

	case '?':	if (now-&gt;lft)
			{	Cat3("( (", now-&gt;lft, ") -&gt; ");
			}
			if (now-&gt;rgt)
			{	Cat3("(", now-&gt;rgt-&gt;lft, ") : ");
				Cat3("(", now-&gt;rgt-&gt;rgt, ") )");
			}
			break;	

	case ASGN:	comwork(fd,now-&gt;lft,m);
			fprintf(fd," = ");
			comwork(fd,now-&gt;rgt,m);
			break;

	case PRINT:	{	char c, buf[512];
				strncpy(buf, now-&gt;sym-&gt;name, 510);
				for (i = j = 0; i &lt; 510; i++, j++)
				{	c = now-&gt;sym-&gt;name[i];
					buf[j] = c;
					if (c == '\\') buf[++j] = c;
					if (c == '\"') buf[j] = '\'';
					if (c == '\0') break;
				}
				if (now-&gt;ntyp == PRINT)
					fprintf(fd, "printf");
				else
					fprintf(fd, "annotate");
				fprintf(fd, "(%s", buf);
			}
			for (v = now-&gt;lft; v; v = v-&gt;rgt)
			{	Cat2(",", v-&gt;lft);
			}
			fprintf(fd, ")");
			break;
	case PRINTM:	fprintf(fd, "printm(");
			comwork(fd, now-&gt;lft, m);
			fprintf(fd, ")");
			break;
	case NAME:
			putname(fd, "", now, m, "");
			break;

	case   'p':	if (ltl_mode)
			{	fprintf(fd, "%s", now-&gt;lft-&gt;sym-&gt;name); /* proctype */
				if (now-&gt;lft-&gt;lft)
				{	fprintf(fd, "[");
					putstmnt(fd, now-&gt;lft-&gt;lft, 0); /* pid */
					fprintf(fd, "]");
				}
				fprintf(fd, ":");	/* remote varref */
				fprintf(fd, "%s", now-&gt;sym-&gt;name);	/* varname */
				break;
			}
			putremote(fd, now, m);
			break;
	case   'q':	fprintf(fd, "%s", now-&gt;sym-&gt;name);
			break;
	case C_EXPR:	
	case C_CODE:	fprintf(fd, "{%s}", now-&gt;sym-&gt;name);
			break;
	case ASSERT:	Cat3("assert(", now-&gt;lft, ")");
			break;
	case   '.':	fprintf(fd, ".(goto)"); break;
	case  GOTO:	fprintf(fd, "goto %s", now-&gt;sym-&gt;name); break;
	case BREAK:	fprintf(fd, "break"); break;
	case  ELSE:	fprintf(fd, "else"); break;
	case   '@':	fprintf(fd, "-end-"); break;

	case D_STEP:	fprintf(fd, "D_STEP"); break;
	case ATOMIC:	fprintf(fd, "ATOMIC"); break;
	case NON_ATOMIC: fprintf(fd, "sub-sequence"); break;
	case IF:	fprintf(fd, "IF"); break;
	case DO:	fprintf(fd, "DO"); break;
	case UNLESS:	fprintf(fd, "unless"); break;
	case TIMEOUT:	fprintf(fd, "timeout"); break;
	default:	if (isprint(now-&gt;ntyp))
				fprintf(fd, "'%c'", now-&gt;ntyp);
			else
				fprintf(fd, "%d", now-&gt;ntyp);
			break;
	}
}

void
comment(FILE *fd, Lextok *now, int m)
{	extern short terse, nocast;

	terse=nocast=1;
	comwork(fd, now, m);
	terse=nocast=0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

