<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/pangen7.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/pangen7.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: pangen7.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */
/* pangen7.c: Version 5.3.0 2010, synchronous product of never claims     */

#include &lt;stdlib.h&gt;
#include "spin.h"
#include "y.tab.h"
#include &lt;assert.h&gt;
#ifdef PC
extern int unlink(const char *);
#else
#include &lt;unistd.h&gt;
#endif

extern ProcList	*rdy;
extern Element *Al_El;
extern int nclaims, verbose, Strict;

typedef struct Succ_List Succ_List;
typedef struct SQueue SQueue;
typedef struct OneState OneState;
typedef struct State_Stack State_Stack;
typedef struct Guard Guard;

struct Succ_List {
	SQueue	*s;
	Succ_List *nxt;
};

struct OneState {
	int	*combo;	/* the combination of claim states */
	Succ_List	*succ;	/* list of ptrs to immediate successor states */
};

struct SQueue {
	OneState	state;
	SQueue	*nxt;
};

struct State_Stack {
	int *n;
	State_Stack *nxt;
};

struct Guard {
	Lextok *t;
	Guard *nxt;
};

SQueue	*sq, *sd, *render;	/* states move from sq to sd to render to holding */
SQueue	*holding, *lasthold;
State_Stack *dsts;

int nst;		/* max nr of states in claims */
int *Ist;		/* initial states */
int *Nacc;		/* number of accept states in claim */
int *Nst;		/* next states */
int **reached;		/* n claims x states */
int unfolding;		/* to make sure all accept states are reached */
int is_accept;		/* remember if the current state is accepting in any claim */
int not_printing;	/* set during explore_product */

Element ****matrix;	/* n x two-dimensional arrays state x state */
Element **Selfs;	/* self-loop states at end of claims */

static void get_seq(int, Sequence *);
static void set_el(int n, Element *e);
static void gen_product(void);
static void print_state_nm(char *, int *, char *);
static SQueue *find_state(int *);
static SQueue *retrieve_state(int *);

static int
same_state(int *a, int *b)
{	int i;

	for (i = 0; i &lt; nclaims; i++)
	{	if (a[i] != b[i])
		{	return 0;
	}	}
	return 1;
}

static int
in_stack(SQueue *s, SQueue *in)
{	SQueue *q;

	for (q = in; q; q = q-&gt;nxt)
	{	if (same_state(q-&gt;state.combo, s-&gt;state.combo))
		{	return 1;
	}	}
	return 0;
}

static void
to_render(SQueue *s)
{	SQueue *a, *q, *last; /* find in sd/sq and move to render, if not already there */
	int n;

	for (n = 0; n &lt; nclaims; n++)
	{	reached[n][ s-&gt;state.combo[n] ] |= 2;
	}

	for (q = render; q; q = q-&gt;nxt)
	{	if (same_state(q-&gt;state.combo, s-&gt;state.combo))
		{	return;
	}	}
	for (q = holding; q; q = q-&gt;nxt)
	{	if (same_state(q-&gt;state.combo, s-&gt;state.combo))
		{	return;
	}	}

	a = sd;
more:
	for (q = a, last = 0; q; last = q, q = q-&gt;nxt)
	{	if (same_state(q-&gt;state.combo, s-&gt;state.combo))
		{	if (!last)
			{	if (a == sd)
				{	sd = q-&gt;nxt;
				} else if (a == sq)
				{	sq = q-&gt;nxt;
				} else
				{	holding = q-&gt;nxt;
				}
			} else
			{	last-&gt;nxt = q-&gt;nxt;
			}
			q-&gt;nxt = render;
			render = q;
			return;
	}	}
	if (verbose)
	{	print_state_nm("looking for: ", s-&gt;state.combo, "\n");
	}
	(void) find_state(s-&gt;state.combo);	/* creates it in sq */
	if (a != sq)
	{	a = sq;
		goto more;
	}
	fatal("cannot happen, to_render", 0);
}

static void
wrap_text(char *pre, Lextok *t, char *post)
{
	printf(pre);
	comment(stdout, t, 0);
	printf(post);
}

static State_Stack *
push_dsts(int *n)
{	State_Stack *s;
	int i;

	for (s = dsts; s; s = s-&gt;nxt)
	{	if (same_state(s-&gt;n, n))
		{	if (verbose&amp;64)
			{	printf("\n");
				for (s = dsts; s; s = s-&gt;nxt)
				{	print_state_nm("\t", s-&gt;n, "\n");
				}
				print_state_nm("\t", n, "\n");
			}
			return s;
	}	}

	s = (State_Stack *) emalloc(sizeof(State_Stack));
	s-&gt;n = (int *) emalloc(nclaims * sizeof(int));
	for (i = 0; i &lt; nclaims; i++)
		s-&gt;n[i] = n[i];
	s-&gt;nxt = dsts;
	dsts = s;
	return 0;
}

static void
pop_dsts(void)
{
	assert(dsts);
	dsts = dsts-&gt;nxt;
}

static void
complete_transition(Succ_List *sl, Guard *g)
{	Guard *w;
	int cnt = 0;

	printf("	:: ");
	for (w = g; w; w = w-&gt;nxt)
	{	if (w-&gt;t-&gt;ntyp == CONST
		&amp;&amp;  w-&gt;t-&gt;val == 1)
		{	continue;
		} else if (w-&gt;t-&gt;ntyp == 'c'
		&amp;&amp;  w-&gt;t-&gt;lft-&gt;ntyp == CONST
		&amp;&amp;  w-&gt;t-&gt;lft-&gt;val == 1)
		{	continue; /* 'true' */
		}

		if (cnt &gt; 0)
		{	printf(" &amp;&amp; ");
		}
		wrap_text("", w-&gt;t, "");
		cnt++;
	}
	if (cnt == 0)
	{	printf("true");
	}
	print_state_nm(" -&gt; goto ", sl-&gt;s-&gt;state.combo, "");

	if (is_accept &gt; 0)
	{	printf("_U%d\n", (unfolding+1)%nclaims);
	} else
	{	printf("_U%d\n", unfolding);
	}
}

static void
state_body(OneState *s, Guard *guard)
{	Succ_List *sl;
	State_Stack *y;
	Guard *g;
	int i, once;

	for (sl = s-&gt;succ; sl; sl = sl-&gt;nxt)
	{	once = 0;

		for (i = 0; i &lt; nclaims; i++)
		{	Element *e;
			e = matrix[i][s-&gt;combo[i]][sl-&gt;s-&gt;state.combo[i]];

			/* if one of the claims has a DO or IF move
			   then pull its target state forward, once
			 */

			if (!e
			|| e-&gt;n-&gt;ntyp == NON_ATOMIC
			||  e-&gt;n-&gt;ntyp == DO
			||  e-&gt;n-&gt;ntyp == IF)
			{	s = &amp;(sl-&gt;s-&gt;state);
				y = push_dsts(s-&gt;combo);
				if (!y)
				{	if (once++ == 0)
					{	assert(s-&gt;succ);
						state_body(s, guard);
					}
					pop_dsts();
				} else if (!y-&gt;nxt)	/* self-loop transition */
				{	if (!not_printing) printf(" /* self-loop */\n");
				} else
				{	/* non_fatal("loop in state body", 0); ** maybe ok */
				}
				continue;
			} else
			{	g = (Guard *) emalloc(sizeof(Guard));
				g-&gt;t = e-&gt;n;
				g-&gt;nxt = guard;
				guard = g;
		}	}

		if (guard &amp;&amp; !once)
		{	if (!not_printing) complete_transition(sl, guard);
			to_render(sl-&gt;s);
	}	}
}

static struct X {
	char *s;	int n;
} spl[] = {
	{"end",		3 },
	{"accept",	6 },
	{0,		0 },
};

static int slcnt;
extern Label *labtab;

static ProcList *
locate_claim(int n)
{	ProcList *p;
	int i;

	for (p = rdy, i = 0; p; p = p-&gt;nxt, i++) /* find claim name */
	{	if (i == n)
		{	break;
	}	}
	assert(p &amp;&amp; p-&gt;b == N_CLAIM);

	return p;
}

static void
elim_lab(Element *e)
{	Label *l, *lst;

	for (l = labtab, lst = NULL; l; lst = l, l = l-&gt;nxt)
	{	if (l-&gt;e == e)
		{	if (lst)
			{	lst-&gt;nxt = l-&gt;nxt;
			} else
			{	labtab = l-&gt;nxt;
			}
			break;
	}	}
}

static int
claim_has_accept(ProcList *p)
{	Label *l;

	for (l = labtab; l; l = l-&gt;nxt)
	{	if (strcmp(l-&gt;c-&gt;name, p-&gt;n-&gt;name) == 0
		&amp;&amp;  strncmp(l-&gt;s-&gt;name, "accept", 6) == 0)
		{	return 1;
	}	}
	return 0;
}

static void
prune_accept(void)
{	int n;

	for (n = 0; n &lt; nclaims; n++)
	{	if ((reached[n][Selfs[n]-&gt;seqno] &amp; 2) == 0)
		{	if (verbose)
			{	printf("claim %d: selfloop not reachable\n", n);
			}
			elim_lab(Selfs[n]);
			Nacc[n] = claim_has_accept(locate_claim(n));
	}	}
}

static void
mk_accepting(int n, Element *e)
{	ProcList *p;
	Label *l;
	int i;

	assert(!Selfs[n]);
	Selfs[n] = e;

	l = (Label *) emalloc(sizeof(Label));
	l-&gt;s = (Symbol *) emalloc(sizeof(Symbol));
	l-&gt;s-&gt;name = "accept00";
	l-&gt;c = (Symbol *) emalloc(sizeof(Symbol));
	l-&gt;uiid = 0;	/* this is not in an inline */

	for (p = rdy, i = 0; p; p = p-&gt;nxt, i++) /* find claim name */
	{	if (i == n)
		{	l-&gt;c-&gt;name = p-&gt;n-&gt;name;
			break;
	}	}
	assert(p &amp;&amp; p-&gt;b == N_CLAIM);
	Nacc[n] = 1;

	l-&gt;e = e;
	l-&gt;nxt = labtab;
	labtab = l;
}

static void
check_special(int *nrs)
{	ProcList *p;
	Label *l;
	int i, j, nmatches;
	int any_accepts = 0;

	for (i = 0; i &lt; nclaims; i++)
	{	any_accepts += Nacc[i];
	}

	is_accept = 0;
	for (j = 0; spl[j].n; j++) /* 2 special label prefixes */
	{	nmatches = 0;
		for (p = rdy, i = 0; p; p = p-&gt;nxt, i++) /* check each claim */
		{	if (p-&gt;b != N_CLAIM)
			{	continue;
			}
			/* claim i in state nrs[i], type p-&gt;tn, name p-&gt;n-&gt;name
			 * either the state has an accept label, or the claim has none,
			 * so that all its states should be considered accepting
			 * --- but only if other claims do have accept states!
			 */
			if (Strict == 0 &amp;&amp; j == 1 &amp;&amp; Nacc[i] == 0 &amp;&amp; any_accepts &gt; 0)
			{	if ((verbose&amp;32) &amp;&amp; i == unfolding)
				{	printf("	/* claim %d pseudo-accept */\n", i);
				}
				goto is_accepting;
			}
			for (l = labtab; l; l = l-&gt;nxt)	/* check its labels */
			{	if (strcmp(l-&gt;c-&gt;name, p-&gt;n-&gt;name) == 0  /* right claim */
				&amp;&amp;  l-&gt;e-&gt;seqno == nrs[i]		 /* right state */
				&amp;&amp;  strncmp(l-&gt;s-&gt;name, spl[j].s, spl[j].n) == 0)
				{	if (j == 1)	/* accept state */
					{	char buf[32];
is_accepting:					if (strchr(p-&gt;n-&gt;name, ':'))
						{	sprintf(buf, "N%d", i);
						} else
						{	strcpy(buf, p-&gt;n-&gt;name);
						}
						if (unfolding == 0 &amp;&amp; i == 0)
						{	if (!not_printing)
							printf("%s_%s_%d:\n",	/* true accept */
								spl[j].s, buf, slcnt++);
						} else if (verbose&amp;32)
						{	if (!not_printing)
							printf("%s_%s%d:\n",
								buf, spl[j].s, slcnt++);
						}
						if (i == unfolding)
						{	is_accept++; /* move to next unfolding */
						}
					} else
					{	nmatches++;
					}
					break;
		}	}	}
		if (j == 0 &amp;&amp; nmatches == nclaims)	/* end-state */
		{	if (!not_printing)
			{	printf("%s%d:\n", spl[j].s, slcnt++);
	}	}	}
}

static int
render_state(SQueue *q)
{
	if (!q || !q-&gt;state.succ)
	{	if (verbose&amp;64)
		{	printf("	no exit\n");
		}
		return 0;
	}

	check_special(q-&gt;state.combo); /* accept or end-state labels */

	dsts = (State_Stack *) 0;
	push_dsts(q-&gt;state.combo);	/* to detect loops */

	if (!not_printing)
	{	print_state_nm("", q-&gt;state.combo, "");	/* the name */
		printf("_U%d:\n\tdo\n", unfolding);
	}

	state_body(&amp;(q-&gt;state), (Guard *) 0);

	if (!not_printing)
	{	printf("\tod;\n");
	}
	pop_dsts();
	return 1;
}

static void
explore_product(void)
{	SQueue *q;

	/* all states are in the sd queue */

	q = retrieve_state(Ist);	/* retrieve from the sd q */
	q-&gt;nxt = render;		/* put in render q */
	render = q;
	do {
		q = render;
		render = render-&gt;nxt;
		q-&gt;nxt = 0;		/* remove from render q */

		if (verbose&amp;64)
		{	print_state_nm("explore: ", q-&gt;state.combo, "\n");
		}

		not_printing = 1;
		render_state(q);	/* may add new states */
		not_printing = 0;

		if (lasthold)
		{	lasthold-&gt;nxt = q;
			lasthold = q;
		} else
		{	holding = lasthold = q;
		}
	} while (render);
	assert(!dsts);
	
}

static void
print_product(void)
{	SQueue *q;
	int cnt;

	if (unfolding == 0)
	{	printf("never Product {\n");	/* name expected by iSpin */
		q = find_state(Ist);	/* should find it in the holding q */
		assert(q);
		q-&gt;nxt = holding;	/* put it at the front */
		holding = q;
	}
	render = holding;
	holding = lasthold = 0;

	printf("/* ============= U%d ============= */\n", unfolding);
	cnt = 0;
	do {
		q = render;
		render = render-&gt;nxt;
		q-&gt;nxt = 0;
		if (verbose&amp;64)
		{	print_state_nm("print: ", q-&gt;state.combo, "\n");
		}
		cnt += render_state(q);

		if (lasthold)
		{	lasthold-&gt;nxt = q;
			lasthold = q;
		} else
		{	holding = lasthold = q;
		}
	} while (render);
	assert(!dsts);

	if (cnt == 0)
	{	printf("	0;\n");
	}

	if (unfolding == nclaims-1)
	{	printf("}\n");
	}
}

static void
prune_dead(void)
{	Succ_List *sl, *last;
	SQueue *q;
	int cnt;

	do {	cnt = 0;
		for (q = sd; q; q = q-&gt;nxt)
		{	/* if successor is deadend, remove it
			 * unless it's a move to the end-state of the claim
			 */
			last = (Succ_List *) 0;
			for (sl = q-&gt;state.succ; sl; last = sl, sl = sl-&gt;nxt)
			{	if (!sl-&gt;s-&gt;state.succ)	/* no successor */
				{	if (!last)
					{	q-&gt;state.succ = sl-&gt;nxt;
					} else
					{	last-&gt;nxt = sl-&gt;nxt;
					}
					cnt++;
		}	}	}
	} while (cnt &gt; 0);
}

static void
print_raw(void)
{	int i, j, n;

	printf("#if 0\n");
	for (n = 0; n &lt; nclaims; n++)
	{	printf("C%d:\n", n);
		for (i = 0; i &lt; nst; i++)
		{	if (reached[n][i])
			for (j = 0; j &lt; nst; j++)
			{	if (matrix[n][i][j])
				{	if (reached[n][i] &amp; 2) printf("+");
					if (i == Ist[n]) printf("*");
					printf("\t%d", i);
					wrap_text(" -[", matrix[n][i][j]-&gt;n, "]-&gt;\t");
					printf("%d\n", j);
	}	}	}	}
	printf("#endif\n\n");
	fflush(stdout);
}

void
sync_product(void)
{	ProcList *p;
	Element *e;
	int n, i;

	if (nclaims &lt;= 1) return;

	(void) unlink("pan.pre");

	Ist  = (int *) emalloc(sizeof(int) * nclaims);
	Nacc = (int *) emalloc(sizeof(int) * nclaims);
	Nst  = (int *) emalloc(sizeof(int) * nclaims);
	reached = (int **) emalloc(sizeof(int *) * nclaims);
	Selfs   = (Element **) emalloc(sizeof(Element *) * nclaims);
	matrix  = (Element ****) emalloc(sizeof(Element ***) * nclaims); /* claims */

	for (p = rdy, i = 0; p; p = p-&gt;nxt, i++)
	{	if (p-&gt;b == N_CLAIM)
		{	nst = max(p-&gt;s-&gt;maxel, nst);
			Nacc[i] = claim_has_accept(p);
	}	}

	for (n = 0; n &lt; nclaims; n++)
	{	reached[n] = (int *) emalloc(sizeof(int) * nst);
		matrix[n] = (Element ***) emalloc(sizeof(Element **) * nst);	/* rows */
		for (i = 0; i &lt; nst; i++)					/* cols */
		{	matrix[n][i] = (Element **) emalloc(sizeof(Element *) * nst);
	}	}

	for (e = Al_El; e; e = e-&gt;Nxt)
	{	e-&gt;status &amp;= ~DONE;
	}

	for (p = rdy, n=0; p; p = p-&gt;nxt, n++)
	{	if (p-&gt;b == N_CLAIM)
		{	/* fill in matrix[n] */
			e = p-&gt;s-&gt;frst;
			Ist[n] = huntele(e, e-&gt;status, -1)-&gt;seqno;

			reached[n][Ist[n]] = 1|2;
			get_seq(n, p-&gt;s);
	}	}

	if (verbose)	/* show only the input automata */
	{	print_raw();
	}

	gen_product();	/* create product automaton */
}

static int
nxt_trans(int n, int cs, int frst)
{	int j;

	for (j = frst; j &lt; nst; j++)
	{	if (reached[n][cs]
		&amp;&amp;  matrix[n][cs][j])
		{	return j;
	}	}
	return -1;
}

static void
print_state_nm(char *p, int *s, char *a)
{	int i;
	printf("%sP", p);
	for (i = 0; i &lt; nclaims; i++)
	{	printf("_%d", s[i]);
	}
	printf("%s", a);
}

static void
create_transition(OneState *s, SQueue *it)
{	int n, from, upto;
	int *F = s-&gt;combo;
	int *T = it-&gt;state.combo;
	Succ_List *sl;
	Lextok *t;

	if (verbose&amp;64)
	{	print_state_nm("", F, " ");
		print_state_nm("-&gt; ", T, "\t");
	}

	/* check if any of the claims is blocked */
	/* which makes the state a dead-end */
	for (n = 0; n &lt; nclaims; n++)
	{	from = F[n];
		upto = T[n];
		t = matrix[n][from][upto]-&gt;n;
		if (verbose&amp;64)
		{	wrap_text("", t, " ");
		}
		if (t-&gt;ntyp == 'c'
		&amp;&amp;  t-&gt;lft-&gt;ntyp == CONST)
		{	if (t-&gt;lft-&gt;val == 0)	/* i.e., false */
			{	goto done;
	}	}	}

	sl = (Succ_List *) emalloc(sizeof(Succ_List));
	sl-&gt;s = it;
	sl-&gt;nxt = s-&gt;succ;
	s-&gt;succ = sl;
done:
	if (verbose&amp;64)
	{	printf("\n");
	}
}

static SQueue *
find_state(int *cs)
{	SQueue *nq, *a = sq;
	int i;

again:	/* check in nq, sq, and then in the render q */
	for (nq = a; nq; nq = nq-&gt;nxt)
	{	if (same_state(nq-&gt;state.combo, cs))
		{	return nq;	/* found */
	}	}
	if (a == sq &amp;&amp; sd)
	{	a = sd;
		goto again; /* check the other stack too */
	} else if (a == sd &amp;&amp; render)
	{	a = render;
		goto again;
	}

	nq = (SQueue *) emalloc(sizeof(SQueue));
	nq-&gt;state.combo = (int *) emalloc(nclaims * sizeof(int));
	for (i = 0; i &lt; nclaims; i++)
	{	nq-&gt;state.combo[i] = cs[i];
	}
	nq-&gt;nxt = sq;	/* add to sq stack */
	sq = nq;

	return nq;
}

static SQueue *
retrieve_state(int *s)
{	SQueue *nq, *last = NULL;

	for (nq = sd; nq; last = nq, nq = nq-&gt;nxt)
	{	if (same_state(nq-&gt;state.combo, s))
		{	if (last)
			{	last-&gt;nxt = nq-&gt;nxt;
			} else
			{	sd = nq;
			}
			return nq;	/* found */
	}	}

	fatal("cannot happen: retrieve_state", 0);
	return (SQueue *) 0;
}

static void
all_successors(int n, OneState *cur)
{	int i, j = 0;

	if (n &gt;= nclaims)
	{	create_transition(cur, find_state(Nst));
	} else
	{	i = cur-&gt;combo[n];
		for (;;)
		{	j = nxt_trans(n, i, j);
			if (j &lt; 0) break;
			Nst[n] = j;
			all_successors(n+1, cur);
			j++;
	}	}
}

static void
gen_product(void)
{	OneState *cur_st;
	SQueue *q;

	find_state(Ist);	/* create initial state */

	while (sq)
	{	if (in_stack(sq, sd))
		{	sq = sq-&gt;nxt;
			continue;
		}
		cur_st = &amp;(sq-&gt;state);

		q = sq;
		sq = sq-&gt;nxt;	/* delete from sq stack */
		q-&gt;nxt = sd;	/* and move to done stack */
		sd = q;

		all_successors(0, cur_st);
	}
	/* all states are in the sd queue now */
	prune_dead();
	explore_product();	/* check if added accept-self-loops are reachable */
	prune_accept();

	if (verbose)
	{	print_raw();
	}

	/* PM: merge states with identical successor lists */

	/* all outgoing transitions from accept-states
	   from claim n in copy n connect to states in copy (n+1)%nclaims
	   only accept states from claim 0 in copy 0 are true accept states
	   in the product

	   PM: what about claims that have no accept states (e.g., restrictions)
	*/

	for (unfolding = 0; unfolding &lt; nclaims; unfolding++)
	{	print_product();
	}
}

static void
t_record(int n, Element *e, Element *g)
{	int from = e-&gt;seqno, upto = g?g-&gt;seqno:0;

	assert(from &gt;= 0 &amp;&amp; from &lt; nst);
	assert(upto &gt;= 0 &amp;&amp; upto &lt; nst);

	matrix[n][from][upto] = e;
	reached[n][upto] |= 1;
}

static void
get_sub(int n, Element *e)
{
	if (e-&gt;n-&gt;ntyp == D_STEP
	||  e-&gt;n-&gt;ntyp == ATOMIC)
	{	fatal("atomic or d_step in never claim product", 0);
	} 
	/* NON_ATOMIC */
	e-&gt;n-&gt;sl-&gt;this-&gt;last-&gt;nxt = e-&gt;nxt;
	get_seq(n, e-&gt;n-&gt;sl-&gt;this);

	t_record(n, e, e-&gt;n-&gt;sl-&gt;this-&gt;frst);

}

static void
set_el(int n, Element *e)
{	Element *g;

	if (e-&gt;n-&gt;ntyp == '@')	/* change to self-loop */
	{	e-&gt;n-&gt;ntyp = CONST;
		e-&gt;n-&gt;val = 1;	/* true */
		e-&gt;nxt = e;
		g = e;
		mk_accepting(n, e);
	} else

	if (e-&gt;n-&gt;ntyp == GOTO)
	{	g = get_lab(e-&gt;n, 1);
		g = huntele(g, e-&gt;status, -1);
	} else if (e-&gt;nxt)
	{	g = huntele(e-&gt;nxt, e-&gt;status, -1);
	} else
	{	g = NULL;
	}

	t_record(n, e, g);
}

static void
get_seq(int n, Sequence *s)
{	SeqList *h;
	Element *e;

	e = huntele(s-&gt;frst, s-&gt;frst-&gt;status, -1);
	for ( ; e; e = e-&gt;nxt)
	{	if (e-&gt;status &amp; DONE)
		{	goto checklast;
		}
		e-&gt;status |= DONE;

		if (e-&gt;n-&gt;ntyp == UNLESS)
		{	fatal("unless stmnt in never claim product", 0);
		}

		if (e-&gt;sub)	/* IF or DO */
		{	Lextok *x = NULL;
			Lextok *y = NULL;
			Lextok *haselse = NULL;

			for (h = e-&gt;sub; h; h = h-&gt;nxt)
			{	Lextok *t = h-&gt;this-&gt;frst-&gt;n;
				if (t-&gt;ntyp == ELSE)
				{	if (verbose&amp;64) printf("else at line %d\n", t-&gt;ln);
					haselse = t;
					continue;
				}
				if (t-&gt;ntyp != 'c')
				{	fatal("product, 'else' combined with non-condition", 0);
				}

				if (t-&gt;lft-&gt;ntyp == CONST	/* true */
				&amp;&amp;  t-&gt;lft-&gt;val == 1
				&amp;&amp;  y == NULL)
				{	y = nn(ZN, CONST, ZN, ZN);
					y-&gt;val = 0;
				} else
				{	if (!x)
						x = t;
					else
						x = nn(ZN, OR, x, t);
					if (verbose&amp;64)
					{	wrap_text(" [", x, "]\n");
			}	}	}
			if (haselse)
			{	if (!y)
				{	y = nn(ZN, '!', x, ZN);
				}
				if (verbose&amp;64)
				{	wrap_text(" [else: ", y, "]\n");
				}
				haselse-&gt;ntyp = 'c';	/* replace else */
				haselse-&gt;lft = y;
			}

			for (h = e-&gt;sub; h; h = h-&gt;nxt)
			{	t_record(n, e, h-&gt;this-&gt;frst);
				get_seq(n, h-&gt;this);
			}
		} else
		{	if (e-&gt;n-&gt;ntyp == ATOMIC
			||  e-&gt;n-&gt;ntyp == D_STEP
			||  e-&gt;n-&gt;ntyp == NON_ATOMIC)
			{	get_sub(n, e);
			} else 
			{	set_el(n, e);
			}
		}
checklast:	if (e == s-&gt;last)
			break;
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

