<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/reprosrc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/reprosrc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: reprosrc.c *****/

/* Copyright (c) 2002-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include &lt;stdio.h&gt;
#include "spin.h"
#include "y.tab.h"

static int indent = 1;

extern ProcList	*rdy;
void repro_seq(Sequence *);

void
doindent(void)
{	int i;
	for (i = 0; i &lt; indent; i++)
		printf("   ");
}

void
repro_sub(Element *e)
{
	doindent();
	switch (e-&gt;n-&gt;ntyp) {
	case D_STEP:
		printf("d_step {\n");
		break;
	case ATOMIC:
		printf("atomic {\n");
		break;
	case NON_ATOMIC:
		printf(" {\n");
		break;
	}
	indent++;
	repro_seq(e-&gt;n-&gt;sl-&gt;this);
	indent--;

	doindent();
	printf(" };\n");
}

void
repro_seq(Sequence *s)
{	Element *e;
	Symbol *v;
	SeqList *h;

	for (e = s-&gt;frst; e; e = e-&gt;nxt)
	{
		v = has_lab(e, 0);
		if (v) printf("%s:\n", v-&gt;name);

		if (e-&gt;n-&gt;ntyp == UNLESS)
		{	printf("/* normal */ {\n");
			repro_seq(e-&gt;n-&gt;sl-&gt;this);
			doindent();
			printf("} unless {\n");
			repro_seq(e-&gt;n-&gt;sl-&gt;nxt-&gt;this);
			doindent();
			printf("}; /* end unless */\n");
		} else if (e-&gt;sub)
		{
			switch (e-&gt;n-&gt;ntyp) {
			case DO: doindent(); printf("do\n"); indent++; break;
			case IF: doindent(); printf("if\n"); indent++; break;
			}

			for (h = e-&gt;sub; h; h = h-&gt;nxt)
			{	indent--; doindent(); indent++; printf("::\n");
				repro_seq(h-&gt;this);
				printf("\n");
			}

			switch (e-&gt;n-&gt;ntyp) {
			case DO: indent--; doindent(); printf("od;\n"); break;
			case IF: indent--; doindent(); printf("fi;\n"); break;
			}
		} else
		{	if (e-&gt;n-&gt;ntyp == ATOMIC
			||  e-&gt;n-&gt;ntyp == D_STEP
			||  e-&gt;n-&gt;ntyp == NON_ATOMIC)
				repro_sub(e);
			else if (e-&gt;n-&gt;ntyp != '.'
			     &amp;&amp;  e-&gt;n-&gt;ntyp != '@'
			     &amp;&amp;  e-&gt;n-&gt;ntyp != BREAK)
			{
				doindent();
				if (e-&gt;n-&gt;ntyp == C_CODE)
				{	printf("c_code ");
					plunk_inline(stdout, e-&gt;n-&gt;sym-&gt;name, 1, 1);
				} else if (e-&gt;n-&gt;ntyp == 'c'
				       &amp;&amp;  e-&gt;n-&gt;lft-&gt;ntyp == C_EXPR)
				{	printf("c_expr { ");
					plunk_expr(stdout, e-&gt;n-&gt;lft-&gt;sym-&gt;name);
					printf("} -&gt;\n");
				} else
				{	comment(stdout, e-&gt;n, 0);
					printf(";\n");
			}	}
		}
		if (e == s-&gt;last)
			break;
	}
}

void
repro_proc(ProcList *p)
{
	if (!p) return;
	if (p-&gt;nxt) repro_proc(p-&gt;nxt);

	if (p-&gt;det) printf("D");	/* deterministic */
	printf("proctype %s()", p-&gt;n-&gt;name);
	if (p-&gt;prov)
	{	printf(" provided ");
		comment(stdout, p-&gt;prov, 0);
	}
	printf("\n{\n");
	repro_seq(p-&gt;s);
	printf("}\n");
}

void
repro_src(void)
{
	repro_proc(rdy);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

