<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/run.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/run.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: run.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include &lt;stdlib.h&gt;
#include "spin.h"
#include "y.tab.h"

extern RunList	*X, *run;
extern Symbol	*Fname;
extern Element	*LastStep;
extern int	Rvous, lineno, Tval, interactive, MadeChoice;
extern int	TstOnly, verbose, s_trail, xspin, jumpsteps, depth;
extern int	analyze, nproc, nstop, no_print, like_java;

static long	Seed = 1;
static int	E_Check = 0, Escape_Check = 0;

static int	eval_sync(Element *);
static int	pc_enabled(Lextok *n);
extern void	sr_buf(int, int);

void
Srand(unsigned int s)
{	Seed = s;
}

long
Rand(void)
{	/* CACM 31(10), Oct 1988 */
	Seed = 16807*(Seed%127773) - 2836*(Seed/127773);
	if (Seed &lt;= 0) Seed += 2147483647;
	return Seed;
}

Element *
rev_escape(SeqList *e)
{	Element *r;

	if (!e)
		return (Element *) 0;

	if ((r = rev_escape(e-&gt;nxt)) != ZE) /* reversed order */
		return r;

	return eval_sub(e-&gt;this-&gt;frst);		
}

Element *
eval_sub(Element *e)
{	Element *f, *g;
	SeqList *z;
	int i, j, k, only_pos;

	if (!e || !e-&gt;n)
		return ZE;
#ifdef DEBUG
	printf("\n\teval_sub(%d %s: line %d) ",
		e-&gt;Seqno, e-&gt;esc?"+esc":"", e-&gt;n?e-&gt;n-&gt;ln:0);
	comment(stdout, e-&gt;n, 0);
	printf("\n");
#endif
	if (e-&gt;n-&gt;ntyp == GOTO)
	{	if (Rvous) return ZE;
		LastStep = e;
		f = get_lab(e-&gt;n, 1);
		f = huntele(f, e-&gt;status, -1); /* 5.2.3: was missing */
		cross_dsteps(e-&gt;n, f-&gt;n);
#ifdef DEBUG
		printf("GOTO leads to %d\n", f-&gt;seqno);
#endif
		return f;
	}
	if (e-&gt;n-&gt;ntyp == UNLESS)
	{	/* escapes were distributed into sequence */
		return eval_sub(e-&gt;sub-&gt;this-&gt;frst);
	} else if (e-&gt;sub)	/* true for IF, DO, and UNLESS */
	{	Element *has_else = ZE;
		Element *bas_else = ZE;
		int nr_else = 0, nr_choices = 0;
		only_pos = -1;

		if (interactive
		&amp;&amp; !MadeChoice &amp;&amp; !E_Check
		&amp;&amp; !Escape_Check
		&amp;&amp; !(e-&gt;status&amp;(D_ATOM))
		&amp;&amp; depth &gt;= jumpsteps)
		{	printf("Select stmnt (");
			whoruns(0); printf(")\n");
			if (nproc-nstop &gt; 1)
			{	printf("\tchoice 0: other process\n");
				nr_choices++;
				only_pos = 0;
		}	}
		for (z = e-&gt;sub, j=0; z; z = z-&gt;nxt)
		{	j++;
			if (interactive
			&amp;&amp; !MadeChoice &amp;&amp; !E_Check
			&amp;&amp; !Escape_Check
			&amp;&amp; !(e-&gt;status&amp;(D_ATOM))
			&amp;&amp; depth &gt;= jumpsteps
			&amp;&amp; z-&gt;this-&gt;frst
			&amp;&amp; (xspin || (verbose&amp;32) || Enabled0(z-&gt;this-&gt;frst)))
			{	if (z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ELSE)
				{	has_else = (Rvous)?ZE:z-&gt;this-&gt;frst-&gt;nxt;
					nr_else = j;
					continue;
				}
				printf("\tchoice %d: ", j);
#if 0
				if (z-&gt;this-&gt;frst-&gt;n)
					printf("line %d, ", z-&gt;this-&gt;frst-&gt;n-&gt;ln);
#endif
				if (!Enabled0(z-&gt;this-&gt;frst))
					printf("unexecutable, ");
				else
				{	nr_choices++;
					only_pos = j;
				}
				comment(stdout, z-&gt;this-&gt;frst-&gt;n, 0);
				printf("\n");
		}	}

		if (nr_choices == 0 &amp;&amp; has_else)
		{	printf("\tchoice %d: (else)\n", nr_else);
			only_pos = nr_else;
		}

		if (nr_choices &lt;= 1 &amp;&amp; only_pos != -1 &amp;&amp; !MadeChoice)
		{	MadeChoice = only_pos;
		}

		if (interactive &amp;&amp; depth &gt;= jumpsteps
		&amp;&amp; !Escape_Check
		&amp;&amp; !(e-&gt;status&amp;(D_ATOM))
		&amp;&amp; !E_Check)
		{	if (!MadeChoice)
			{	char buf[256];
				if (xspin)
					printf("Make Selection %d\n\n", j);
				else
					printf("Select [0-%d]: ", j);
				fflush(stdout);
				if (scanf("%64s", buf) &lt;= 0)
				{	printf("no input\n");
					return ZE;
				}
				if (isdigit((int)buf[0]))
					k = atoi(buf);
				else
				{	if (buf[0] == 'q')
						alldone(0);
					k = -1;
				}
			} else
			{	k = MadeChoice;
				MadeChoice = 0;
			}
			if (k &lt; 1 || k &gt; j)
			{	if (k != 0) printf("\tchoice outside range\n");
				return ZE;
			}
			k--;
		} else
		{	if (e-&gt;n &amp;&amp; e-&gt;n-&gt;indstep &gt;= 0)
				k = 0;	/* select 1st executable guard */
			else
				k = Rand()%j;	/* nondeterminism */
		}

		has_else = ZE;
		bas_else = ZE;
		for (i = 0, z = e-&gt;sub; i &lt; j+k; i++)
		{	if (z-&gt;this-&gt;frst
			&amp;&amp;  z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ELSE)
			{	bas_else = z-&gt;this-&gt;frst;
				has_else = (Rvous)?ZE:bas_else-&gt;nxt;
				if (!interactive || depth &lt; jumpsteps
				|| Escape_Check
				|| (e-&gt;status&amp;(D_ATOM)))
				{	z = (z-&gt;nxt)?z-&gt;nxt:e-&gt;sub;
					continue;
				}
			}
			if (z-&gt;this-&gt;frst
			&amp;&amp;  ((z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ATOMIC
			  ||  z-&gt;this-&gt;frst-&gt;n-&gt;ntyp == D_STEP)
			  &amp;&amp;  z-&gt;this-&gt;frst-&gt;n-&gt;sl-&gt;this-&gt;frst-&gt;n-&gt;ntyp == ELSE))
			{	bas_else = z-&gt;this-&gt;frst-&gt;n-&gt;sl-&gt;this-&gt;frst;
				has_else = (Rvous)?ZE:bas_else-&gt;nxt;
				if (!interactive || depth &lt; jumpsteps
				|| Escape_Check
				|| (e-&gt;status&amp;(D_ATOM)))
				{	z = (z-&gt;nxt)?z-&gt;nxt:e-&gt;sub;
					continue;
				}
			}
			if (i &gt;= k)
			{	if ((f = eval_sub(z-&gt;this-&gt;frst)) != ZE)
					return f;
				else if (interactive &amp;&amp; depth &gt;= jumpsteps
				&amp;&amp; !(e-&gt;status&amp;(D_ATOM)))
				{	if (!E_Check &amp;&amp; !Escape_Check)
						printf("\tunexecutable\n");
					return ZE;
			}	}
			z = (z-&gt;nxt)?z-&gt;nxt:e-&gt;sub;
		}
		LastStep = bas_else;
		return has_else;
	} else
	{	if (e-&gt;n-&gt;ntyp == ATOMIC
		||  e-&gt;n-&gt;ntyp == D_STEP)
		{	f = e-&gt;n-&gt;sl-&gt;this-&gt;frst;
			g = e-&gt;n-&gt;sl-&gt;this-&gt;last;
			g-&gt;nxt = e-&gt;nxt;
			if (!(g = eval_sub(f)))	/* atomic guard */
				return ZE;
			return g;
		} else if (e-&gt;n-&gt;ntyp == NON_ATOMIC)
		{	f = e-&gt;n-&gt;sl-&gt;this-&gt;frst;
			g = e-&gt;n-&gt;sl-&gt;this-&gt;last;
			g-&gt;nxt = e-&gt;nxt;		/* close it */
			return eval_sub(f);
		} else if (e-&gt;n-&gt;ntyp == '.')
		{	if (!Rvous) return e-&gt;nxt;
			return eval_sub(e-&gt;nxt);
		} else
		{	SeqList *x;
			if (!(e-&gt;status &amp; (D_ATOM))
			&amp;&amp;  e-&gt;esc &amp;&amp; verbose&amp;32)
			{	printf("Stmnt [");
				comment(stdout, e-&gt;n, 0);
				printf("] has escape(s): ");
				for (x = e-&gt;esc; x; x = x-&gt;nxt)
				{	printf("[");
					g = x-&gt;this-&gt;frst;
					if (g-&gt;n-&gt;ntyp == ATOMIC
					||  g-&gt;n-&gt;ntyp == NON_ATOMIC)
						g = g-&gt;n-&gt;sl-&gt;this-&gt;frst;
					comment(stdout, g-&gt;n, 0);
					printf("] ");
				}
				printf("\n");
			}
#if 0
			if (!(e-&gt;status &amp; D_ATOM))	/* escapes don't reach inside d_steps */
			/* 4.2.4: only the guard of a d_step can have an escape */
#endif
#if 1
			if (!s_trail)	/* trail determines selections, new 5.2.5 */
#endif
			{	Escape_Check++;
				if (like_java)
				{	if ((g = rev_escape(e-&gt;esc)) != ZE)
					{	if (verbose&amp;4)
							printf("\tEscape taken\n");
						Escape_Check--;
						return g;
					}
				} else
				{	for (x = e-&gt;esc; x; x = x-&gt;nxt)
					{	if ((g = eval_sub(x-&gt;this-&gt;frst)) != ZE)
						{	if (verbose&amp;4)
							{	printf("\tEscape taken ");
								if (g-&gt;n &amp;&amp; g-&gt;n-&gt;fn)
									printf("%s:%d", g-&gt;n-&gt;fn-&gt;name, g-&gt;n-&gt;ln);
								printf("\n");
							}
							Escape_Check--;
							return g;
				}	}	}
				Escape_Check--;
			}
		
			switch (e-&gt;n-&gt;ntyp) {
			case TIMEOUT: case RUN:
			case PRINT: case PRINTM:
			case C_CODE: case C_EXPR:
			case ASGN: case ASSERT:
			case 's': case 'r': case 'c':
				/* toplevel statements only */
				LastStep = e;
			default:
				break;
			}
			if (Rvous)
			{
				return (eval_sync(e))?e-&gt;nxt:ZE;
			}
			return (eval(e-&gt;n))?e-&gt;nxt:ZE;
		}
	}
	return ZE; /* not reached */
}

static int
eval_sync(Element *e)
{	/* allow only synchronous receives
	   and related node types    */
	Lextok *now = (e)?e-&gt;n:ZN;

	if (!now
	||  now-&gt;ntyp != 'r'
	||  now-&gt;val &gt;= 2	/* no rv with a poll */
	||  !q_is_sync(now))
	{
		return 0;
	}

	LastStep = e;
	return eval(now);
}

static int
assign(Lextok *now)
{	int t;

	if (TstOnly) return 1;

	switch (now-&gt;rgt-&gt;ntyp) {
	case FULL:	case NFULL:
	case EMPTY:	case NEMPTY:
	case RUN:	case LEN:
		t = BYTE;
		break;
	default:
		t = Sym_typ(now-&gt;rgt);
		break;
	}
	typ_ck(Sym_typ(now-&gt;lft), t, "assignment"); 
	return setval(now-&gt;lft, eval(now-&gt;rgt));
}

static int
nonprogress(void)	/* np_ */
{	RunList	*r;

	for (r = run; r; r = r-&gt;nxt)
	{	if (has_lab(r-&gt;pc, 4))	/* 4=progress */
			return 0;
	}
	return 1;
}

int
eval(Lextok *now)
{
	if (now) {
	lineno = now-&gt;ln;
	Fname  = now-&gt;fn;
#ifdef DEBUG
	printf("eval ");
	comment(stdout, now, 0);
	printf("\n");
#endif
	switch (now-&gt;ntyp) {
	case CONST: return now-&gt;val;
	case   '!': return !eval(now-&gt;lft);
	case  UMIN: return -eval(now-&gt;lft);
	case   '~': return ~eval(now-&gt;lft);

	case   '/': return (eval(now-&gt;lft) / eval(now-&gt;rgt));
	case   '*': return (eval(now-&gt;lft) * eval(now-&gt;rgt));
	case   '-': return (eval(now-&gt;lft) - eval(now-&gt;rgt));
	case   '+': return (eval(now-&gt;lft) + eval(now-&gt;rgt));
	case   '%': return (eval(now-&gt;lft) % eval(now-&gt;rgt));
	case    LT: return (eval(now-&gt;lft) &lt;  eval(now-&gt;rgt));
	case    GT: return (eval(now-&gt;lft) &gt;  eval(now-&gt;rgt));
	case   '&amp;': return (eval(now-&gt;lft) &amp;  eval(now-&gt;rgt));
	case   '^': return (eval(now-&gt;lft) ^  eval(now-&gt;rgt));
	case   '|': return (eval(now-&gt;lft) |  eval(now-&gt;rgt));
	case    LE: return (eval(now-&gt;lft) &lt;= eval(now-&gt;rgt));
	case    GE: return (eval(now-&gt;lft) &gt;= eval(now-&gt;rgt));
	case    NE: return (eval(now-&gt;lft) != eval(now-&gt;rgt));
	case    EQ: return (eval(now-&gt;lft) == eval(now-&gt;rgt));
	case    OR: return (eval(now-&gt;lft) || eval(now-&gt;rgt));
	case   AND: return (eval(now-&gt;lft) &amp;&amp; eval(now-&gt;rgt));
	case LSHIFT: return (eval(now-&gt;lft) &lt;&lt; eval(now-&gt;rgt));
	case RSHIFT: return (eval(now-&gt;lft) &gt;&gt; eval(now-&gt;rgt));
	case   '?': return (eval(now-&gt;lft) ? eval(now-&gt;rgt-&gt;lft)
					   : eval(now-&gt;rgt-&gt;rgt));

	case     'p': return remotevar(now);	/* _p for remote reference */
	case     'q': return remotelab(now);
	case     'R': return qrecv(now, 0);	/* test only    */
	case     LEN: return qlen(now);
	case    FULL: return (qfull(now));
	case   EMPTY: return (qlen(now)==0);
	case   NFULL: return (!qfull(now));
	case  NEMPTY: return (qlen(now)&gt;0);
	case ENABLED: if (s_trail) return 1;
		      return pc_enabled(now-&gt;lft);
	case    EVAL: return eval(now-&gt;lft);
	case  PC_VAL: return pc_value(now-&gt;lft);
	case NONPROGRESS: return nonprogress();
	case    NAME: return getval(now);

	case TIMEOUT: return Tval;
	case     RUN: return TstOnly?1:enable(now);

	case   's': return qsend(now);		/* send         */
	case   'r': return qrecv(now, 1);	/* receive or poll */
	case   'c': return eval(now-&gt;lft);	/* condition    */
	case PRINT: return TstOnly?1:interprint(stdout, now);
	case PRINTM: return TstOnly?1:printm(stdout, now);
	case  ASGN: return assign(now);

	case C_CODE: if (!analyze)
		     {	printf("%s:\t", now-&gt;sym-&gt;name);
		     	plunk_inline(stdout, now-&gt;sym-&gt;name, 0, 1);
		     }
		     return 1; /* uninterpreted */

	case C_EXPR: if (!analyze)
		     {	printf("%s:\t", now-&gt;sym-&gt;name);
		     	plunk_expr(stdout, now-&gt;sym-&gt;name);
		     	printf("\n");
		     }
		     return 1; /* uninterpreted */

	case ASSERT: if (TstOnly || eval(now-&gt;lft)) return 1;
		     non_fatal("assertion violated", (char *) 0);
			printf("spin: text of failed assertion: assert(");
			comment(stdout, now-&gt;lft, 0);
			printf(")\n");
		     if (s_trail &amp;&amp; !xspin) return 1;
		     wrapup(1); /* doesn't return */

	case  IF: case DO: case BREAK: case UNLESS:	/* compound */
	case   '.': return 1;	/* return label for compound */
	case   '@': return 0;	/* stop state */
	case  ELSE: return 1;	/* only hit here in guided trails */
	default   : printf("spin: bad node type %d (run)\n", now-&gt;ntyp);
		    if (s_trail) printf("spin: trail file doesn't match spec?\n");
		    fatal("aborting", 0);
	}}
	return 0;
}

int
printm(FILE *fd, Lextok *n)
{	extern char Buf[];
	int j;

	Buf[0] = '\0';
	if (!no_print)
	if (!s_trail || depth &gt;= jumpsteps) {
		if (n-&gt;lft-&gt;ismtyp)
			j = n-&gt;lft-&gt;val;
		else
			j = eval(n-&gt;lft);
		sr_buf(j, 1);
		dotag(fd, Buf);
	}
	return 1;
}

int
interprint(FILE *fd, Lextok *n)
{	Lextok *tmp = n-&gt;lft;
	char c, *s = n-&gt;sym-&gt;name;
	int i, j; char lbuf[512]; /* matches value in sr_buf() */
	extern char Buf[];	/* global, size 4096 */
	char tBuf[4096];	/* match size of global Buf[] */

	Buf[0] = '\0';
	if (!no_print)
	if (!s_trail || depth &gt;= jumpsteps) {
	for (i = 0; i &lt; (int) strlen(s); i++)
		switch (s[i]) {
		case '\"': break; /* ignore */
		case '\\':
			 switch(s[++i]) {
			 case 't': strcat(Buf, "\t"); break;
			 case 'n': strcat(Buf, "\n"); break;
			 default:  goto onechar;
			 }
			 break;
		case  '%':
			 if ((c = s[++i]) == '%')
			 {	strcat(Buf, "%"); /* literal */
				break;
			 }
			 if (!tmp)
			 {	non_fatal("too few print args %s", s);
				break;
			 }
			 j = eval(tmp-&gt;lft);
			 tmp = tmp-&gt;rgt;
			 switch(c) {
			 case 'c': sprintf(lbuf, "%c", j); break;
			 case 'd': sprintf(lbuf, "%d", j); break;

			 case 'e': strcpy(tBuf, Buf);	/* event name */
				   Buf[0] = '\0';
				   sr_buf(j, 1);
				   strcpy(lbuf, Buf);
				   strcpy(Buf, tBuf);
				   break;

			 case 'o': sprintf(lbuf, "%o", j); break;
			 case 'u': sprintf(lbuf, "%u", (unsigned) j); break;
			 case 'x': sprintf(lbuf, "%x", j); break;
			 default:  non_fatal("bad print cmd: '%s'", &amp;s[i-1]);
				   lbuf[0] = '\0'; break;
			 }
			 goto append;
		default:
onechar:		 lbuf[0] = s[i]; lbuf[1] = '\0';
append:			 strcat(Buf, lbuf);
			 break;
		}
		dotag(fd, Buf);
	}
	if (strlen(Buf) &gt;= 4096) fatal("printf string too long", 0);
	return 1;
}

static int
Enabled1(Lextok *n)
{	int i; int v = verbose;

	if (n)
	switch (n-&gt;ntyp) {
	case 'c':
		if (has_typ(n-&gt;lft, RUN))
			return 1;	/* conservative */
		/* else fall through */
	default:	/* side-effect free */
		verbose = 0;
		E_Check++;
		i = eval(n);
		E_Check--;
		verbose = v;
		return i;

	case C_CODE: case C_EXPR:
	case PRINT: case PRINTM:
	case   ASGN: case ASSERT:
		return 1;

	case 's':
		if (q_is_sync(n))
		{	if (Rvous) return 0;
			TstOnly = 1; verbose = 0;
			E_Check++;
			i = eval(n);
			E_Check--;
			TstOnly = 0; verbose = v;
			return i;
		}
		return (!qfull(n));
	case 'r':
		if (q_is_sync(n))
			return 0;	/* it's never a user-choice */
		n-&gt;ntyp = 'R'; verbose = 0;
		E_Check++;
		i = eval(n);
		E_Check--;
		n-&gt;ntyp = 'r'; verbose = v;
		return i;
	}
	return 0;
}

int
Enabled0(Element *e)
{	SeqList *z;

	if (!e || !e-&gt;n)
		return 0;

	switch (e-&gt;n-&gt;ntyp) {
	case '@':
		return X-&gt;pid == (nproc-nstop-1);
	case '.':
		return 1;
	case GOTO:
		if (Rvous) return 0;
		return 1;
	case UNLESS:
		return Enabled0(e-&gt;sub-&gt;this-&gt;frst);
	case ATOMIC:
	case D_STEP:
	case NON_ATOMIC:
		return Enabled0(e-&gt;n-&gt;sl-&gt;this-&gt;frst);
	}
	if (e-&gt;sub)	/* true for IF, DO, and UNLESS */
	{	for (z = e-&gt;sub; z; z = z-&gt;nxt)
			if (Enabled0(z-&gt;this-&gt;frst))
				return 1;
		return 0;
	}
	for (z = e-&gt;esc; z; z = z-&gt;nxt)
	{	if (Enabled0(z-&gt;this-&gt;frst))
			return 1;
	}
#if 0
	printf("enabled1 ");
	comment(stdout, e-&gt;n, 0);
	printf(" ==&gt; %s\n", Enabled1(e-&gt;n)?"yes":"nope");
#endif
	return Enabled1(e-&gt;n);
}

int
pc_enabled(Lextok *n)
{	int i = nproc - nstop;
	int pid = eval(n);
	int result = 0;
	RunList *Y, *oX;

	if (pid == X-&gt;pid)
		fatal("used: enabled(pid=thisproc) [%s]", X-&gt;n-&gt;name);

	for (Y = run; Y; Y = Y-&gt;nxt)
		if (--i == pid)
		{	oX = X; X = Y;
			result = Enabled0(Y-&gt;pc);
			X = oX;
			break;
		}
	return result;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

