<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/sym.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/sym.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: sym.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

extern Symbol	*Fname, *owner;
extern int	lineno, depth, verbose, NamesNotAdded, deadvar;
extern int	has_hidden, m_loss, old_scope_rules;
extern short	has_xu;
extern char	CurScope[MAXSCOPESZ];

Symbol	*context = ZS;
Ordered	*all_names = (Ordered *)0;
int	Nid = 0;

Lextok *Mtype = (Lextok *) 0;

static Ordered	*last_name = (Ordered *)0;
static Symbol	*symtab[Nhash+1];
static Lextok *runstmnts = ZN;

static int
samename(Symbol *a, Symbol *b)
{
	if (!a &amp;&amp; !b) return 1;
	if (!a || !b) return 0;
	return !strcmp(a-&gt;name, b-&gt;name);
}

int
hash(char *s)
{	int h=0;

	while (*s)
	{	h += *s++;
		h &lt;&lt;= 1;
		if (h&amp;(Nhash+1))
			h |= 1;
	}
	return h&amp;Nhash;
}

void
disambiguate(void)
{	Ordered *walk;
	Symbol *sp;

	if (old_scope_rules)
		return;

	/* if the same name appears in two different scopes,
	   prepend the scope_prefix to the names */

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (sp-&gt;type != 0
		&amp;&amp;  sp-&gt;type != LABEL
		&amp;&amp;  strlen((const char *)sp-&gt;bscp) &gt; 1)
		{	char *n = (char *) emalloc(strlen((const char *)sp-&gt;name)
				+ strlen((const char *)sp-&gt;bscp) + 1);
			sprintf(n, "%s%s", sp-&gt;bscp, sp-&gt;name);
			sp-&gt;name = n;	/* discord the old memory */
	}	}
}

Symbol *
lookup(char *s)
{	Symbol *sp; Ordered *no;
	int h = hash(s);

	if (old_scope_rules)
	{	/* same scope - global refering to global or local to local */
		for (sp = symtab[h]; sp; sp = sp-&gt;next)
		{	if (strcmp(sp-&gt;name, s) == 0
			&amp;&amp;  samename(sp-&gt;context, context)
			&amp;&amp;  samename(sp-&gt;owner, owner))
			{	return sp;		/* found */
		}	}
	} else
	{	/* added 6.0.0: more traditional, scope rule */
		for (sp = symtab[h]; sp; sp = sp-&gt;next)
		{	if (strcmp(sp-&gt;name, s) == 0
			&amp;&amp;  samename(sp-&gt;context, context)
			&amp;&amp;  (strcmp((const char *)sp-&gt;bscp, CurScope) == 0
			||   strncmp((const char *)sp-&gt;bscp, CurScope, strlen((const char *)sp-&gt;bscp)) == 0)
			&amp;&amp;  samename(sp-&gt;owner, owner))
			{
				if (!samename(sp-&gt;owner, owner))
				{	printf("spin: different container %s\n", sp-&gt;name);
					printf("	old: %s\n", sp-&gt;owner?sp-&gt;owner-&gt;name:"--");
					printf("	new: %s\n", owner?owner-&gt;name:"--");
				/*	alldone(1);	*/
				}
				return sp;		/* found */
	}	}	}

	if (context)				/* in proctype, refers to global */
	for (sp = symtab[h]; sp; sp = sp-&gt;next)
	{	if (strcmp(sp-&gt;name, s) == 0
		&amp;&amp; !sp-&gt;context
		&amp;&amp;  samename(sp-&gt;owner, owner))
		{	return sp;		/* global */
	}	}

	sp = (Symbol *) emalloc(sizeof(Symbol));
	sp-&gt;name = (char *) emalloc(strlen(s) + 1);
	strcpy(sp-&gt;name, s);
	sp-&gt;nel = 1;
	sp-&gt;setat = depth;
	sp-&gt;context = context;
	sp-&gt;owner = owner;			/* if fld in struct */
	sp-&gt;bscp = (unsigned char *) emalloc(strlen((const char *)CurScope)+1);
	strcpy((char *)sp-&gt;bscp, CurScope);

	if (NamesNotAdded == 0)
	{	sp-&gt;next = symtab[h];
		symtab[h] = sp;
		no = (Ordered *) emalloc(sizeof(Ordered));
		no-&gt;entry = sp;
		if (!last_name)
			last_name = all_names = no;
		else
		{	last_name-&gt;next = no;
			last_name = no;
	}	}

	return sp;
}

void
trackvar(Lextok *n, Lextok *m)
{	Symbol *sp = n-&gt;sym;

	if (!sp) return;	/* a structure list */
	switch (m-&gt;ntyp) {
	case NAME:
		if (m-&gt;sym-&gt;type != BIT)
		{	sp-&gt;hidden |= 4;
			if (m-&gt;sym-&gt;type != BYTE)
				sp-&gt;hidden |= 8;
		}
		break;
	case CONST:
		if (m-&gt;val != 0 &amp;&amp; m-&gt;val != 1)
			sp-&gt;hidden |= 4;
		if (m-&gt;val &lt; 0 || m-&gt;val &gt; 256)
			sp-&gt;hidden |= 8; /* ditto byte-equiv */
		break;
	default:	/* unknown */
		sp-&gt;hidden |= (4|8); /* not known bit-equiv */
	}
}

void
trackrun(Lextok *n)
{
	runstmnts = nn(ZN, 0, n, runstmnts);
}

void
checkrun(Symbol *parnm, int posno)
{	Lextok *n, *now, *v; int i, m;
	int res = 0; char buf[16], buf2[16];

	for (n = runstmnts; n; n = n-&gt;rgt)
	{	now = n-&gt;lft;
		if (now-&gt;sym != parnm-&gt;context)
			continue;
		for (v = now-&gt;lft, i = 0; v; v = v-&gt;rgt, i++)
			if (i == posno)
			{	m = v-&gt;lft-&gt;ntyp;
				if (m == CONST)
				{	m = v-&gt;lft-&gt;val;
					if (m != 0 &amp;&amp; m != 1)
						res |= 4;
					if (m &lt; 0 || m &gt; 256)
						res |= 8;
				} else if (m == NAME)
				{	m = v-&gt;lft-&gt;sym-&gt;type;
					if (m != BIT)
					{	res |= 4;
						if (m != BYTE)
							res |= 8;
					}
				} else
					res |= (4|8); /* unknown */
				break;
	}		}
	if (!(res&amp;4) || !(res&amp;8))
	{	if (!(verbose&amp;32)) return;
		strcpy(buf2, (!(res&amp;4))?"bit":"byte");
		sputtype(buf, parnm-&gt;type);
		i = (int) strlen(buf);
		while (i &gt; 0 &amp;&amp; buf[--i] == ' ') buf[i] = '\0';
		if (i == 0 || strcmp(buf, buf2) == 0) return;
		prehint(parnm);
		printf("proctype %s, '%s %s' could be declared",
			parnm-&gt;context?parnm-&gt;context-&gt;name:"", buf, parnm-&gt;name);
		printf(" '%s %s'\n", buf2, parnm-&gt;name);
	}
}

void
trackchanuse(Lextok *m, Lextok *w, int t)
{	Lextok *n = m; int cnt = 1;
	while (n)
	{	if (n-&gt;lft
		&amp;&amp;  n-&gt;lft-&gt;sym
		&amp;&amp;  n-&gt;lft-&gt;sym-&gt;type == CHAN)
			setaccess(n-&gt;lft-&gt;sym, w?w-&gt;sym:ZS, cnt, t);
		n = n-&gt;rgt; cnt++;
	}
}

void
setptype(Lextok *n, int t, Lextok *vis)	/* predefined types */
{	int oln = lineno, cnt = 1; extern int Expand_Ok;

	while (n)
	{	if (n-&gt;sym-&gt;type &amp;&amp; !(n-&gt;sym-&gt;hidden&amp;32))
		{	lineno = n-&gt;ln; Fname = n-&gt;fn;
			fatal("redeclaration of '%s'", n-&gt;sym-&gt;name);
			lineno = oln;
		}
		n-&gt;sym-&gt;type = (short) t;

		if (Expand_Ok)
		{	n-&gt;sym-&gt;hidden |= (4|8|16); /* formal par */
			if (t == CHAN)
			setaccess(n-&gt;sym, ZS, cnt, 'F');
		}
		if (t == UNSIGNED)
		{	if (n-&gt;sym-&gt;nbits &lt; 0 || n-&gt;sym-&gt;nbits &gt;= 32)
			fatal("(%s) has invalid width-field", n-&gt;sym-&gt;name);
			if (n-&gt;sym-&gt;nbits == 0)
			{	n-&gt;sym-&gt;nbits = 16;
				non_fatal("unsigned without width-field", 0);
			}
		} else if (n-&gt;sym-&gt;nbits &gt; 0)
		{	non_fatal("(%s) only an unsigned can have width-field",
				n-&gt;sym-&gt;name);
		}
		if (vis)
		{	if (strncmp(vis-&gt;sym-&gt;name, ":hide:", (size_t) 6) == 0)
			{	n-&gt;sym-&gt;hidden |= 1;
				has_hidden++;
				if (t == BIT)
				fatal("bit variable (%s) cannot be hidden",
					n-&gt;sym-&gt;name);
			} else if (strncmp(vis-&gt;sym-&gt;name, ":show:", (size_t) 6) == 0)
			{	n-&gt;sym-&gt;hidden |= 2;
			} else if (strncmp(vis-&gt;sym-&gt;name, ":local:", (size_t) 7) == 0)
			{	n-&gt;sym-&gt;hidden |= 64;
			}
		}
		if (t == CHAN)
			n-&gt;sym-&gt;Nid = ++Nid;
		else
		{	n-&gt;sym-&gt;Nid = 0;
			if (n-&gt;sym-&gt;ini
			&amp;&amp;  n-&gt;sym-&gt;ini-&gt;ntyp == CHAN)
			{	Fname = n-&gt;fn;
				lineno = n-&gt;ln;
				fatal("chan initializer for non-channel %s",
				n-&gt;sym-&gt;name);
			}
		}
		if (n-&gt;sym-&gt;nel &lt;= 0)
		{ lineno = n-&gt;ln; Fname = n-&gt;fn;
		  non_fatal("bad array size for '%s'", n-&gt;sym-&gt;name);
		  lineno = oln;
		}
		n = n-&gt;rgt; cnt++;
	}
}

static void
setonexu(Symbol *sp, int t)
{
	sp-&gt;xu |= t;
	if (t == XR || t == XS)
	{	if (sp-&gt;xup[t-1]
		&amp;&amp;  strcmp(sp-&gt;xup[t-1]-&gt;name, context-&gt;name))
		{	printf("error: x[rs] claims from %s and %s\n",
				sp-&gt;xup[t-1]-&gt;name, context-&gt;name);
			non_fatal("conflicting claims on chan '%s'",
				sp-&gt;name);
		}
		sp-&gt;xup[t-1] = context;
	}
}

static void
setallxu(Lextok *n, int t)
{	Lextok *fp, *tl;

	for (fp = n; fp; fp = fp-&gt;rgt)
	for (tl = fp-&gt;lft; tl; tl = tl-&gt;rgt)
	{	if (tl-&gt;sym-&gt;type == STRUCT)
			setallxu(tl-&gt;sym-&gt;Slst, t);
		else if (tl-&gt;sym-&gt;type == CHAN)
			setonexu(tl-&gt;sym, t);
	}
}

Lextok *Xu_List = (Lextok *) 0;

void
setxus(Lextok *p, int t)
{	Lextok *m, *n;

	has_xu = 1;

	if (m_loss &amp;&amp; t == XS)
	{	printf("spin: warning, %s:%d, xs tag not compatible with -m (message loss)\n",
			(p-&gt;fn != NULL) ? p-&gt;fn-&gt;name : "stdin", p-&gt;ln);
	}

	if (!context)
	{	lineno = p-&gt;ln;
		Fname = p-&gt;fn;
		fatal("non-local x[rs] assertion", (char *)0);
	}
	for (m = p; m; m = m-&gt;rgt)
	{	Lextok *Xu_new = (Lextok *) emalloc(sizeof(Lextok));
		Xu_new-&gt;uiid = p-&gt;uiid;
		Xu_new-&gt;val = t;
		Xu_new-&gt;lft = m-&gt;lft;
		Xu_new-&gt;sym = context;
		Xu_new-&gt;rgt = Xu_List;
		Xu_List = Xu_new;

		n = m-&gt;lft;
		if (n-&gt;sym-&gt;type == STRUCT)
			setallxu(n-&gt;sym-&gt;Slst, t);
		else if (n-&gt;sym-&gt;type == CHAN)
			setonexu(n-&gt;sym, t);
		else
		{	int oln = lineno;
			lineno = n-&gt;ln; Fname = n-&gt;fn;
			non_fatal("xr or xs of non-chan '%s'",
				n-&gt;sym-&gt;name);
			lineno = oln;
		}
	}
}

void
setmtype(Lextok *m)
{	Lextok *n;
	int cnt, oln = lineno;

	if (m) { lineno = m-&gt;ln; Fname = m-&gt;fn; }

	if (!Mtype)
		Mtype = m;
	else
	{	for (n = Mtype; n-&gt;rgt; n = n-&gt;rgt)
			;
		n-&gt;rgt = m;	/* concatenate */
	}

	for (n = Mtype, cnt = 1; n; n = n-&gt;rgt, cnt++)	/* syntax check */
	{	if (!n-&gt;lft || !n-&gt;lft-&gt;sym
		||   n-&gt;lft-&gt;ntyp != NAME
		||   n-&gt;lft-&gt;lft)	/* indexed variable */
			fatal("bad mtype definition", (char *)0);

		/* label the name */
		if (n-&gt;lft-&gt;sym-&gt;type != MTYPE)
		{	n-&gt;lft-&gt;sym-&gt;hidden |= 128;	/* is used */
			n-&gt;lft-&gt;sym-&gt;type = MTYPE;
			n-&gt;lft-&gt;sym-&gt;ini = nn(ZN,CONST,ZN,ZN);
			n-&gt;lft-&gt;sym-&gt;ini-&gt;val = cnt;
		} else if (n-&gt;lft-&gt;sym-&gt;ini-&gt;val != cnt)
			non_fatal("name %s appears twice in mtype declaration",
				n-&gt;lft-&gt;sym-&gt;name);
	}
	lineno = oln;
	if (cnt &gt; 256)
		fatal("too many mtype elements (&gt;255)", (char *)0);
}

int
ismtype(char *str)	/* name to number */
{	Lextok *n;
	int cnt = 1;

	for (n = Mtype; n; n = n-&gt;rgt)
	{	if (strcmp(str, n-&gt;lft-&gt;sym-&gt;name) == 0)
			return cnt;
		cnt++;
	}
	return 0;
}

int
sputtype(char *foo, int m)
{
	switch (m) {
	case UNSIGNED:	strcpy(foo, "unsigned "); break;
	case BIT:	strcpy(foo, "bit   "); break;
	case BYTE:	strcpy(foo, "byte  "); break;
	case CHAN:	strcpy(foo, "chan  "); break;
	case SHORT:	strcpy(foo, "short "); break;
	case INT:	strcpy(foo, "int   "); break;
	case MTYPE:	strcpy(foo, "mtype "); break;
	case STRUCT:	strcpy(foo, "struct"); break;
	case PROCTYPE:	strcpy(foo, "proctype"); break;
	case LABEL:	strcpy(foo, "label "); return 0;
	default:	strcpy(foo, "value "); return 0;
	}
	return 1;
}


static int
puttype(int m)
{	char buf[128];

	if (sputtype(buf, m))
	{	printf("%s", buf);
		return 1;
	}
	return 0;
}

void
symvar(Symbol *sp)
{	Lextok *m;

	if (!puttype(sp-&gt;type))
		return;

	printf("\t");
	if (sp-&gt;owner) printf("%s.", sp-&gt;owner-&gt;name);
	printf("%s", sp-&gt;name);
	if (sp-&gt;nel &gt; 1 || sp-&gt;isarray == 1) printf("[%d]", sp-&gt;nel);

	if (sp-&gt;type == CHAN)
		printf("\t%d", (sp-&gt;ini)?sp-&gt;ini-&gt;val:0);
	else if (sp-&gt;type == STRUCT &amp;&amp; sp-&gt;Snm != NULL) /* Frank Weil, 2.9.8 */
		printf("\t%s", sp-&gt;Snm-&gt;name);
	else
		printf("\t%d", eval(sp-&gt;ini));

	if (sp-&gt;owner)
		printf("\t&lt;:struct-field:&gt;");
	else
	if (!sp-&gt;context)
		printf("\t&lt;:global:&gt;");
	else
		printf("\t&lt;%s&gt;", sp-&gt;context-&gt;name);

	if (sp-&gt;Nid &lt; 0)	/* formal parameter */
		printf("\t&lt;parameter %d&gt;", -(sp-&gt;Nid));
	else if (sp-&gt;type == MTYPE)
		printf("\t&lt;constant&gt;");
	else if (sp-&gt;isarray)
		printf("\t&lt;array&gt;");
	else
		printf("\t&lt;variable&gt;");

	if (sp-&gt;type == CHAN &amp;&amp; sp-&gt;ini)
	{	int i;
		for (m = sp-&gt;ini-&gt;rgt, i = 0; m; m = m-&gt;rgt)
			i++;
		printf("\t%d\t", i);
		for (m = sp-&gt;ini-&gt;rgt; m; m = m-&gt;rgt)
		{	if (m-&gt;ntyp == STRUCT)
				printf("struct %s", m-&gt;sym-&gt;name);
			else
				(void) puttype(m-&gt;ntyp);
			if (m-&gt;rgt) printf("\t");
		}
	}

if (1)	printf("\t{scope %s}", sp-&gt;bscp);

	printf("\n");
}

void
symdump(void)
{	Ordered *walk;

	for (walk = all_names; walk; walk = walk-&gt;next)
		symvar(walk-&gt;entry);
}

void
chname(Symbol *sp)
{	printf("chan ");
	if (sp-&gt;context) printf("%s-", sp-&gt;context-&gt;name);
	if (sp-&gt;owner) printf("%s.", sp-&gt;owner-&gt;name);
	printf("%s", sp-&gt;name);
	if (sp-&gt;nel &gt; 1 || sp-&gt;isarray == 1) printf("[%d]", sp-&gt;nel);
	printf("\t");
}

static struct X {
	int typ; char *nm;
} xx[] = {
	{ 'A', "exported as run parameter" },
	{ 'F', "imported as proctype parameter" },
	{ 'L', "used as l-value in asgnmnt" },
	{ 'V', "used as r-value in asgnmnt" },
	{ 'P', "polled in receive stmnt" },
	{ 'R', "used as parameter in receive stmnt" },
	{ 'S', "used as parameter in send stmnt" },
	{ 'r', "received from" },
	{ 's', "sent to" },
};

static void
chan_check(Symbol *sp)
{	Access *a; int i, b=0, d;

	if (verbose&amp;1) goto report;	/* -C -g */

	for (a = sp-&gt;access; a; a = a-&gt;lnk)
		if (a-&gt;typ == 'r')
			b |= 1;
		else if (a-&gt;typ == 's')
			b |= 2;
	if (b == 3 || (sp-&gt;hidden&amp;16))	/* balanced or formal par */
		return;
report:
	chname(sp);
	for (i = d = 0; i &lt; (int) (sizeof(xx)/sizeof(struct X)); i++)
	{	b = 0;
		for (a = sp-&gt;access; a; a = a-&gt;lnk)
			if (a-&gt;typ == xx[i].typ) b++;
		if (b == 0) continue; d++;
		printf("\n\t%s by: ", xx[i].nm);
		for (a = sp-&gt;access; a; a = a-&gt;lnk)
		  if (a-&gt;typ == xx[i].typ)
		  {	printf("%s", a-&gt;who-&gt;name);
			if (a-&gt;what) printf(" to %s", a-&gt;what-&gt;name);
			if (a-&gt;cnt)  printf(" par %d", a-&gt;cnt);
			if (--b &gt; 0) printf(", ");
		  }
	}
	printf("%s\n", (!d)?"\n\tnever used under this name":"");
}

void
chanaccess(void)
{	Ordered *walk;
	char buf[128];
	extern int Caccess, separate;
	extern short has_code;

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	if (!walk-&gt;entry-&gt;owner)
		switch (walk-&gt;entry-&gt;type) {
		case CHAN:
			if (Caccess) chan_check(walk-&gt;entry);
			break;
		case MTYPE:
		case BIT:
		case BYTE:
		case SHORT:
		case INT:
		case UNSIGNED:
			if ((walk-&gt;entry-&gt;hidden&amp;128))	/* was: 32 */
				continue;

			if (!separate
			&amp;&amp;  !walk-&gt;entry-&gt;context
			&amp;&amp;  !has_code
			&amp;&amp;   deadvar)
				walk-&gt;entry-&gt;hidden |= 1; /* auto-hide */

			if (!(verbose&amp;32) || has_code) continue;

			printf("spin: warning, %s, ", Fname-&gt;name);
			sputtype(buf, walk-&gt;entry-&gt;type);
			if (walk-&gt;entry-&gt;context)
				printf("proctype %s",
					walk-&gt;entry-&gt;context-&gt;name);
			else
				printf("global");
			printf(", '%s%s' variable is never used\n",
				buf, walk-&gt;entry-&gt;name);
	}	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

