<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/tl_buchi.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/tl_buchi.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** tl_spin: tl_buchi.c *****/

/* Copyright (c) 1995-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Based on the translation algorithm by Gerth, Peled, Vardi, and Wolper, */
/* presented at the PSTV Conference, held in 1995, Warsaw, Poland 1995.   */

#include "tl.h"

extern int tl_verbose, tl_clutter, Total, Max_Red;
extern char *claim_name;

FILE	*tl_out;	/* if standalone: = stdout; */

typedef struct Transition {
	Symbol *name;
	Node *cond;
	int redundant, merged, marked;
	struct Transition *nxt;
} Transition;

typedef struct State {
	Symbol	*name;
	Transition *trans;
	Graph	*colors;
	unsigned char redundant;
	unsigned char accepting;
	unsigned char reachable;
	struct State *nxt;
} State;

static State *never = (State *) 0;
static int hitsall;

void
ini_buchi(void)
{
	never = (State *) 0;
	hitsall = 0;
}

static int
sametrans(Transition *s, Transition *t)
{
	if (strcmp(s-&gt;name-&gt;name, t-&gt;name-&gt;name) != 0)
		return 0;
	return isequal(s-&gt;cond, t-&gt;cond);
}

static Node *
Prune(Node *p)
{
	if (p)
	switch (p-&gt;ntyp) {
	case PREDICATE:
	case NOT:
	case FALSE:
	case TRUE:
#ifdef NXT
	case NEXT:
#endif
		return p;
	case OR:
		p-&gt;lft = Prune(p-&gt;lft);
		if (!p-&gt;lft)
		{	releasenode(1, p-&gt;rgt);
			return ZN;
		}
		p-&gt;rgt = Prune(p-&gt;rgt);
		if (!p-&gt;rgt)
		{	releasenode(1, p-&gt;lft);
			return ZN;
		}
		return p;
	case AND:
		p-&gt;lft = Prune(p-&gt;lft);
		if (!p-&gt;lft)
			return Prune(p-&gt;rgt);
		p-&gt;rgt = Prune(p-&gt;rgt);
		if (!p-&gt;rgt)
			return p-&gt;lft;
		return p;
	}
	releasenode(1, p);
	return ZN;
}

static State *
findstate(char *nm)
{	State *b;
	for (b = never; b; b = b-&gt;nxt)
		if (!strcmp(b-&gt;name-&gt;name, nm))
			return b;
	if (strcmp(nm, "accept_all"))
	{	if (strncmp(nm, "accept", 6))
		{	int i; char altnm[64];
			for (i = 0; i &lt; 64; i++)
				if (nm[i] == '_')
					break;
			if (i &gt;= 64)
				Fatal("name too long %s", nm);
			sprintf(altnm, "accept%s", &amp;nm[i]);
			return findstate(altnm);
		}
	/*	Fatal("buchi: no state %s", nm); */
	}
	return (State *) 0;
}

static void
Dfs(State *b)
{	Transition *t;

	if (!b || b-&gt;reachable) return;
	b-&gt;reachable = 1;

	if (b-&gt;redundant)
		printf("/* redundant state %s */\n",
			b-&gt;name-&gt;name);
	for (t = b-&gt;trans; t; t = t-&gt;nxt)
	{	if (!t-&gt;redundant)
		{	Dfs(findstate(t-&gt;name-&gt;name));
			if (!hitsall
			&amp;&amp;  strcmp(t-&gt;name-&gt;name, "accept_all") == 0)
				hitsall = 1;
		}
	}
}

void
retarget(char *from, char *to)
{	State *b;
	Transition *t;
	Symbol *To = tl_lookup(to);

	if (tl_verbose) printf("replace %s with %s\n", from, to);

	for (b = never; b; b = b-&gt;nxt)
	{	if (!strcmp(b-&gt;name-&gt;name, from))
			b-&gt;redundant = 1;
		else
		for (t = b-&gt;trans; t; t = t-&gt;nxt)
		{	if (!strcmp(t-&gt;name-&gt;name, from))
				t-&gt;name = To;
	}	}
}

#ifdef NXT
static Node *
nonxt(Node *n)
{
	switch (n-&gt;ntyp) {
	case U_OPER:
	case V_OPER:
	case NEXT:
		return ZN;
	case OR:
		n-&gt;lft = nonxt(n-&gt;lft);
		n-&gt;rgt = nonxt(n-&gt;rgt);
		if (!n-&gt;lft || !n-&gt;rgt)
			return True;
		return n;
	case AND:
		n-&gt;lft = nonxt(n-&gt;lft);
		n-&gt;rgt = nonxt(n-&gt;rgt);
		if (!n-&gt;lft)
		{	if (!n-&gt;rgt)
				n = ZN;
			else
				n = n-&gt;rgt;
		} else if (!n-&gt;rgt)
			n = n-&gt;lft;
		return n;
	}
	return n;
}
#endif

static Node *
combination(Node *s, Node *t)
{	Node *nc;
#ifdef NXT
	Node *a = nonxt(s);
	Node *b = nonxt(t);

	if (tl_verbose)
	{	printf("\tnonxtA: "); dump(a);
		printf("\n\tnonxtB: "); dump(b);
		printf("\n");
	}
	/* if there's only a X(f), its equivalent to true */
	if (!a || !b)
		nc = True;
	else
		nc = tl_nn(OR, a, b);
#else
	nc = tl_nn(OR, s, t);
#endif
	if (tl_verbose)
	{	printf("\tcombo: "); dump(nc);
		printf("\n");
	}
	return nc;
}

Node *
unclutter(Node *n, char *snm)
{	Node *t, *s, *v, *u;
	Symbol *w;

	/* check only simple cases like !q &amp;&amp; q */
	for (t = n; t; t = t-&gt;rgt)
	{	if (t-&gt;rgt)
		{	if (t-&gt;ntyp != AND || !t-&gt;lft)
				return n;
			if (t-&gt;lft-&gt;ntyp != PREDICATE
#ifdef NXT
			&amp;&amp;  t-&gt;lft-&gt;ntyp != NEXT
#endif
			&amp;&amp;  t-&gt;lft-&gt;ntyp != NOT)
				return n;
		} else
		{	if (t-&gt;ntyp != PREDICATE
#ifdef NXT
			&amp;&amp;  t-&gt;ntyp != NEXT
#endif
			&amp;&amp;  t-&gt;ntyp != NOT)
				return n;
		}
	}

	for (t = n; t; t = t-&gt;rgt)
	{	if (t-&gt;rgt)
			v = t-&gt;lft;
		else
			v = t;
		if (v-&gt;ntyp == NOT
		&amp;&amp;  v-&gt;lft-&gt;ntyp == PREDICATE)
		{	w = v-&gt;lft-&gt;sym;
			for (s = n; s; s = s-&gt;rgt)
			{	if (s == t) continue;
				if (s-&gt;rgt)
					u = s-&gt;lft;
				else
					u = s;
				if (u-&gt;ntyp == PREDICATE
				&amp;&amp;  strcmp(u-&gt;sym-&gt;name, w-&gt;name) == 0)
				{	if (tl_verbose)
					{	printf("BINGO %s:\t", snm);
						dump(n);
						printf("\n");
					}
					return False;
				}
			}
	}	}
	return n;
}

static void
clutter(void)
{	State *p;
	Transition *s;

	for (p = never; p; p = p-&gt;nxt)
	for (s = p-&gt;trans; s; s = s-&gt;nxt)
	{	s-&gt;cond = unclutter(s-&gt;cond, p-&gt;name-&gt;name);
		if (s-&gt;cond
		&amp;&amp;  s-&gt;cond-&gt;ntyp == FALSE)
		{	if (s != p-&gt;trans 
			||  s-&gt;nxt)
				s-&gt;redundant = 1;
		}
	}
}

static void
showtrans(State *a)
{	Transition *s;

	for (s = a-&gt;trans; s; s = s-&gt;nxt)
	{	printf("%s ", s-&gt;name?s-&gt;name-&gt;name:"-");
		dump(s-&gt;cond);
		printf(" %d %d %d\n", s-&gt;redundant, s-&gt;merged, s-&gt;marked);
	}
}

static int
mergetrans(void)
{	State *b;
	Transition *s, *t;
	Node *nc; int cnt = 0;

	for (b = never; b; b = b-&gt;nxt)
	{	if (!b-&gt;reachable) continue;

		for (s = b-&gt;trans; s; s = s-&gt;nxt)
		{	if (s-&gt;redundant) continue;

			for (t = s-&gt;nxt; t; t = t-&gt;nxt)
			if (!t-&gt;redundant
			&amp;&amp;  !strcmp(s-&gt;name-&gt;name, t-&gt;name-&gt;name))
			{	if (tl_verbose)
				{	printf("===\nstate %s, trans to %s redundant\n",
					b-&gt;name-&gt;name, s-&gt;name-&gt;name);
					showtrans(b);
					printf(" conditions ");
					dump(s-&gt;cond); printf(" &lt;-&gt; ");
					dump(t-&gt;cond); printf("\n");
				}

				if (!s-&gt;cond) /* same as T */
				{	releasenode(1, t-&gt;cond); /* T or t */
					nc = True;
				} else if (!t-&gt;cond)
				{	releasenode(1, s-&gt;cond);
					nc = True;
				} else
				{	nc = combination(s-&gt;cond, t-&gt;cond);
				}
				t-&gt;cond = rewrite(nc);
				t-&gt;merged = 1;
				s-&gt;redundant = 1;
				cnt++;
				break;
	}	}	}
	return cnt;
}

static int
all_trans_match(State *a, State *b)
{	Transition *s, *t;
	int found, result = 0;

	if (a-&gt;accepting != b-&gt;accepting)
		goto done;

	for (s = a-&gt;trans; s; s = s-&gt;nxt)
	{	if (s-&gt;redundant) continue;
		found = 0;
		for (t = b-&gt;trans; t; t = t-&gt;nxt)
		{	if (t-&gt;redundant) continue;
			if (sametrans(s, t))
			{	found = 1;
				t-&gt;marked = 1;
				break;
		}	}
		if (!found)
			goto done;
	}
	for (s = b-&gt;trans; s; s = s-&gt;nxt)
	{	if (s-&gt;redundant || s-&gt;marked) continue;
		found = 0;
		for (t = a-&gt;trans; t; t = t-&gt;nxt)
		{	if (t-&gt;redundant) continue;
			if (sametrans(s, t))
			{	found = 1;
				break;
		}	}
		if (!found)
			goto done;
	}
	result = 1;
done:
	for (s = b-&gt;trans; s; s = s-&gt;nxt)
		s-&gt;marked = 0;
	return result;
}

#ifndef NO_OPT
#define BUCKY
#endif

#ifdef BUCKY
static int
all_bucky(State *a, State *b)
{	Transition *s, *t;
	int found, result = 0;

	for (s = a-&gt;trans; s; s = s-&gt;nxt)
	{	if (s-&gt;redundant) continue;
		found = 0;
		for (t = b-&gt;trans; t; t = t-&gt;nxt)
		{	if (t-&gt;redundant) continue;

			if (isequal(s-&gt;cond, t-&gt;cond))
			{	if (strcmp(s-&gt;name-&gt;name, b-&gt;name-&gt;name) == 0
				&amp;&amp;  strcmp(t-&gt;name-&gt;name, a-&gt;name-&gt;name) == 0)
				{	found = 1;	/* they point to each other */
					t-&gt;marked = 1;
					break;
				}
				if (strcmp(s-&gt;name-&gt;name, t-&gt;name-&gt;name) == 0
				&amp;&amp;  strcmp(s-&gt;name-&gt;name, "accept_all") == 0)
				{	found = 1;
					t-&gt;marked = 1;
					break;
				/* same exit from which there is no return */
				}
			}
		}
		if (!found)
			goto done;
	}
	for (s = b-&gt;trans; s; s = s-&gt;nxt)
	{	if (s-&gt;redundant || s-&gt;marked) continue;
		found = 0;
		for (t = a-&gt;trans; t; t = t-&gt;nxt)
		{	if (t-&gt;redundant) continue;

			if (isequal(s-&gt;cond, t-&gt;cond))
			{	if (strcmp(s-&gt;name-&gt;name, a-&gt;name-&gt;name) == 0
				&amp;&amp;  strcmp(t-&gt;name-&gt;name, b-&gt;name-&gt;name) == 0)
				{	found = 1;
					t-&gt;marked = 1;
					break;
				}
				if (strcmp(s-&gt;name-&gt;name, t-&gt;name-&gt;name) == 0
				&amp;&amp;  strcmp(s-&gt;name-&gt;name, "accept_all") == 0)
				{	found = 1;
					t-&gt;marked = 1;
					break;
				}
			}
		}
		if (!found)
			goto done;
	}
	result = 1;
done:
	for (s = b-&gt;trans; s; s = s-&gt;nxt)
		s-&gt;marked = 0;
	return result;
}

static int
buckyballs(void)
{	State *a, *b, *c, *d;
	int m, cnt=0;

	do {
		m = 0; cnt++;
		for (a = never; a; a = a-&gt;nxt)
		{	if (!a-&gt;reachable) continue;

			if (a-&gt;redundant) continue;

			for (b = a-&gt;nxt; b; b = b-&gt;nxt)
			{	if (!b-&gt;reachable) continue;

				if (b-&gt;redundant) continue;

				if (all_bucky(a, b))
				{	m++;
					if (tl_verbose)
					{	printf("%s bucky match %s\n",
						a-&gt;name-&gt;name, b-&gt;name-&gt;name);
					}

					if (a-&gt;accepting &amp;&amp; !b-&gt;accepting)
					{	if (strcmp(b-&gt;name-&gt;name, "T0_init") == 0)
						{	c = a; d = b;
							b-&gt;accepting = 1;
						} else
						{	c = b; d = a;
						}
					} else
					{	c = a; d = b;
					}

					retarget(c-&gt;name-&gt;name, d-&gt;name-&gt;name);
					if (!strncmp(c-&gt;name-&gt;name, "accept", 6)
					&amp;&amp;  Max_Red == 0)
					{	char buf[64];
						sprintf(buf, "T0%s", &amp;(c-&gt;name-&gt;name[6]));
						retarget(buf, d-&gt;name-&gt;name);
					}
					break;
				}
		}	}
	} while (m &amp;&amp; cnt &lt; 10);
	return cnt-1;
}
#endif

static int
mergestates(int v)
{	State *a, *b;
	int m, cnt=0;

	if (tl_verbose)
		return 0;

	do {
		m = 0; cnt++;
		for (a = never; a; a = a-&gt;nxt)
		{	if (v &amp;&amp; !a-&gt;reachable) continue;

			if (a-&gt;redundant) continue; /* 3.3.10 */

			for (b = a-&gt;nxt; b; b = b-&gt;nxt)
			{	if (v &amp;&amp; !b-&gt;reachable) continue;

				if (b-&gt;redundant) continue; /* 3.3.10 */

				if (all_trans_match(a, b))
				{	m++;
					if (tl_verbose)
					{	printf("%d: state %s equals state %s\n",
						cnt, a-&gt;name-&gt;name, b-&gt;name-&gt;name);
						showtrans(a);
						printf("==\n");
						showtrans(b);
					}
					retarget(a-&gt;name-&gt;name, b-&gt;name-&gt;name);
					if (!strncmp(a-&gt;name-&gt;name, "accept", 6)
					&amp;&amp;  Max_Red == 0)
					{	char buf[64];
						sprintf(buf, "T0%s", &amp;(a-&gt;name-&gt;name[6]));
						retarget(buf, b-&gt;name-&gt;name);
					}
					break;
				}
#if 0
				else if (tl_verbose)
				{	printf("\n%d: state %s differs from state %s [%d,%d]\n",
						cnt, a-&gt;name-&gt;name, b-&gt;name-&gt;name,
						a-&gt;accepting, b-&gt;accepting);
					showtrans(a);
					printf("==\n");
					showtrans(b);
					printf("\n");
				}
#endif
		}	}
	} while (m &amp;&amp; cnt &lt; 10);
	return cnt-1;
}

static int tcnt;

static void
rev_trans(Transition *t) /* print transitions  in reverse order... */
{
	if (!t) return;
	rev_trans(t-&gt;nxt);

	if (t-&gt;redundant &amp;&amp; !tl_verbose) return;
	fprintf(tl_out, "\t:: (");
	if (dump_cond(t-&gt;cond, t-&gt;cond, 1))
		fprintf(tl_out, "1");
	fprintf(tl_out, ") -&gt; goto %s\n", t-&gt;name-&gt;name);
	tcnt++;
}

static void
printstate(State *b)
{
	if (!b || (!tl_verbose &amp;&amp; !b-&gt;reachable)) return;

	b-&gt;reachable = 0;	/* print only once */
	fprintf(tl_out, "%s:\n", b-&gt;name-&gt;name);

	if (tl_verbose)
	{	fprintf(tl_out, "	/* ");
		dump(b-&gt;colors-&gt;Other);
		fprintf(tl_out, " */\n");
	}

	if (strncmp(b-&gt;name-&gt;name, "accept", 6) == 0
	&amp;&amp;  Max_Red == 0)
		fprintf(tl_out, "T0%s:\n", &amp;(b-&gt;name-&gt;name[6]));

	fprintf(tl_out, "\tif\n");
	tcnt = 0;
	rev_trans(b-&gt;trans);
	if (!tcnt) fprintf(tl_out, "\t:: false\n");
	fprintf(tl_out, "\tfi;\n");
	Total++;
}

void
addtrans(Graph *col, char *from, Node *op, char *to)
{	State *b;
	Transition *t;

	t = (Transition *) tl_emalloc(sizeof(Transition));
	t-&gt;name = tl_lookup(to);
	t-&gt;cond = Prune(dupnode(op));

	if (tl_verbose)
	{	printf("\n%s &lt;&lt;\t", from); dump(op);
		printf("\n\t"); dump(t-&gt;cond);
		printf("&gt;&gt; %s\n", t-&gt;name-&gt;name);
	}
	if (t-&gt;cond) t-&gt;cond = rewrite(t-&gt;cond);

	for (b = never; b; b = b-&gt;nxt)
		if (!strcmp(b-&gt;name-&gt;name, from))
		{	t-&gt;nxt = b-&gt;trans;
			b-&gt;trans = t;
			return;
		}
	b = (State *) tl_emalloc(sizeof(State));
	b-&gt;name   = tl_lookup(from);
	b-&gt;colors = col;
	b-&gt;trans  = t;
	if (!strncmp(from, "accept", 6))
		b-&gt;accepting = 1;
	b-&gt;nxt = never;
	never  = b;
}

static void
clr_reach(void)
{	State *p;
	for (p = never; p; p = p-&gt;nxt)
		p-&gt;reachable = 0;
	hitsall = 0;
}

void
fsm_print(void)
{	State *b; int cnt1, cnt2=0;
	extern void put_uform(void);

	if (tl_clutter) clutter();

	b = findstate("T0_init");
	if (b &amp;&amp; (Max_Red == 0))
		b-&gt;accepting = 1;

	mergestates(0); 
	b = findstate("T0_init");

	fprintf(tl_out, "never %s {    /* ", claim_name?claim_name:"");
		put_uform();
	fprintf(tl_out, " */\n");

	do {
		clr_reach();
		Dfs(b);
		cnt1 = mergetrans();
		cnt2 = mergestates(1);
		if (tl_verbose)
			printf("/* &gt;&gt;%d,%d&lt;&lt; */\n", cnt1, cnt2);
	} while (cnt2 &gt; 0);

#ifdef BUCKY
	buckyballs();
	clr_reach();
	Dfs(b);
#endif
	if (b &amp;&amp; b-&gt;accepting)
		fprintf(tl_out, "accept_init:\n");

	if (!b &amp;&amp; !never)
	{	fprintf(tl_out, "	0 /* false */;\n");
	} else
	{	printstate(b);	/* init state must be first */
		for (b = never; b; b = b-&gt;nxt)
			printstate(b);
	}
	if (hitsall)
	fprintf(tl_out, "accept_all:\n	skip\n");
	fprintf(tl_out, "}\n");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

