<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/tl_cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/tl_cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** tl_spin: tl_cache.c *****/

/* Copyright (c) 1995-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Based on the translation algorithm by Gerth, Peled, Vardi, and Wolper, */
/* presented at the PSTV Conference, held in 1995, Warsaw, Poland 1995.   */

#include "tl.h"

typedef struct Cache {
	Node *before;
	Node *after;
	int same;
	struct Cache *nxt;
} Cache;

static Cache	*stored = (Cache *) 0;
static unsigned long	Caches, CacheHits;

static int	ismatch(Node *, Node *);
extern void fatal(char *, char *);
int	sameform(Node *, Node *);

void
ini_cache(void)
{
	stored = (Cache *) 0;
	Caches = 0;
	CacheHits = 0;
}

#if 0
void
cache_dump(void)
{	Cache *d; int nr=0;

	printf("\nCACHE DUMP:\n");
	for (d = stored; d; d = d-&gt;nxt, nr++)
	{	if (d-&gt;same) continue;
		printf("B%3d: ", nr); dump(d-&gt;before); printf("\n");
		printf("A%3d: ", nr); dump(d-&gt;after); printf("\n");
	}
	printf("============\n");
}
#endif

Node *
in_cache(Node *n)
{	Cache *d; int nr=0;

	for (d = stored; d; d = d-&gt;nxt, nr++)
		if (isequal(d-&gt;before, n))
		{	CacheHits++;
			if (d-&gt;same &amp;&amp; ismatch(n, d-&gt;before)) return n;
			return dupnode(d-&gt;after);
		}
	return ZN;
}

Node *
cached(Node *n)
{	Cache *d;
	Node *m;

	if (!n) return n;
	if ((m = in_cache(n)) != ZN)
		return m;

	Caches++;
	d = (Cache *) tl_emalloc(sizeof(Cache));
	d-&gt;before = dupnode(n);
	d-&gt;after  = Canonical(n); /* n is released */

	if (ismatch(d-&gt;before, d-&gt;after))
	{	d-&gt;same = 1;
		releasenode(1, d-&gt;after);
		d-&gt;after = d-&gt;before;
	}
	d-&gt;nxt = stored;
	stored = d;
	return dupnode(d-&gt;after);
}

void
cache_stats(void)
{
	printf("cache stores     : %9ld\n", Caches);
	printf("cache hits       : %9ld\n", CacheHits);
}

void
releasenode(int all_levels, Node *n)
{
	if (!n) return;

	if (all_levels)
	{	releasenode(1, n-&gt;lft);
		n-&gt;lft = ZN;
		releasenode(1, n-&gt;rgt);
		n-&gt;rgt = ZN;
	}
	tfree((void *) n);
}

Node *
tl_nn(int t, Node *ll, Node *rl)
{	Node *n = (Node *) tl_emalloc(sizeof(Node));

	n-&gt;ntyp = (short) t;
	n-&gt;lft  = ll;
	n-&gt;rgt  = rl;

	return n;
}

Node *
getnode(Node *p)
{	Node *n;

	if (!p) return p;

	n =  (Node *) tl_emalloc(sizeof(Node));
	n-&gt;ntyp = p-&gt;ntyp;
	n-&gt;sym  = p-&gt;sym; /* same name */
	n-&gt;lft  = p-&gt;lft;
	n-&gt;rgt  = p-&gt;rgt;

	return n;
}

Node *
dupnode(Node *n)
{	Node *d;

	if (!n) return n;
	d = getnode(n);
	d-&gt;lft = dupnode(n-&gt;lft);
	d-&gt;rgt = dupnode(n-&gt;rgt);
	return d;
}

int
one_lft(int ntyp, Node *x, Node *in)
{
	if (!x)  return 1;
	if (!in) return 0;

	if (sameform(x, in))
		return 1;

	if (in-&gt;ntyp != ntyp)
		return 0;

	if (one_lft(ntyp, x, in-&gt;lft))
		return 1;

	return one_lft(ntyp, x, in-&gt;rgt);
}

int
all_lfts(int ntyp, Node *from, Node *in)
{
	if (!from) return 1;

	if (from-&gt;ntyp != ntyp)
		return one_lft(ntyp, from, in);

	if (!one_lft(ntyp, from-&gt;lft, in))
		return 0;

	return all_lfts(ntyp, from-&gt;rgt, in);
}

int
sametrees(int ntyp, Node *a, Node *b)
{	/* toplevel is an AND or OR */
	/* both trees are right-linked, but the leafs */
	/* can be in different places in the two trees */

	if (!all_lfts(ntyp, a, b))
		return 0;

	return all_lfts(ntyp, b, a);
}

int	/* a better isequal() */
sameform(Node *a, Node *b)
{
	if (!a &amp;&amp; !b) return 1;
	if (!a || !b) return 0;
	if (a-&gt;ntyp != b-&gt;ntyp) return 0;

	if (a-&gt;sym
	&amp;&amp;  b-&gt;sym
	&amp;&amp;  strcmp(a-&gt;sym-&gt;name, b-&gt;sym-&gt;name) != 0)
		return 0;

	switch (a-&gt;ntyp) {
	case TRUE:
	case FALSE:
		return 1;
	case PREDICATE:
		if (!a-&gt;sym || !b-&gt;sym) fatal("sameform...", (char *) 0);
		return !strcmp(a-&gt;sym-&gt;name, b-&gt;sym-&gt;name);

	case NOT:
#ifdef NXT
	case NEXT:
#endif
		return sameform(a-&gt;lft, b-&gt;lft);
	case U_OPER:
	case V_OPER:
		if (!sameform(a-&gt;lft, b-&gt;lft))
			return 0;
		if (!sameform(a-&gt;rgt, b-&gt;rgt))
			return 0;
		return 1;

	case AND:
	case OR:	/* the hard case */
		return sametrees(a-&gt;ntyp, a, b);

	default:
		printf("type: %d\n", a-&gt;ntyp);
		fatal("cannot happen, sameform", (char *) 0);
	}

	return 0;
}

int
isequal(Node *a, Node *b)
{
	if (!a &amp;&amp; !b)
		return 1;

	if (!a || !b)
	{	if (!a)
		{	if (b-&gt;ntyp == TRUE)
				return 1;
		} else
		{	if (a-&gt;ntyp == TRUE)
				return 1;
		}
		return 0;
	}
	if (a-&gt;ntyp != b-&gt;ntyp)
		return 0;

	if (a-&gt;sym
	&amp;&amp;  b-&gt;sym
	&amp;&amp;  strcmp(a-&gt;sym-&gt;name, b-&gt;sym-&gt;name) != 0)
		return 0;

	if (isequal(a-&gt;lft, b-&gt;lft)
	&amp;&amp;  isequal(a-&gt;rgt, b-&gt;rgt))
		return 1;

	return sameform(a, b);
}

static int
ismatch(Node *a, Node *b)
{
	if (!a &amp;&amp; !b) return 1;
	if (!a || !b) return 0;
	if (a-&gt;ntyp != b-&gt;ntyp) return 0;

	if (a-&gt;sym
	&amp;&amp;  b-&gt;sym
	&amp;&amp;  strcmp(a-&gt;sym-&gt;name, b-&gt;sym-&gt;name) != 0)
		return 0;

	if (ismatch(a-&gt;lft, b-&gt;lft)
	&amp;&amp;  ismatch(a-&gt;rgt, b-&gt;rgt))
		return 1;

	return 0;
}

int
any_term(Node *srch, Node *in)
{
	if (!in) return 0;

	if (in-&gt;ntyp == AND)
		return	any_term(srch, in-&gt;lft) ||
			any_term(srch, in-&gt;rgt);

	return isequal(in, srch);
}

int
any_and(Node *srch, Node *in)
{
	if (!in) return 0;

	if (srch-&gt;ntyp == AND)
		return	any_and(srch-&gt;lft, in) &amp;&amp;
			any_and(srch-&gt;rgt, in);

	return any_term(srch, in);
}

int
any_lor(Node *srch, Node *in)
{
	if (!in) return 0;

	if (in-&gt;ntyp == OR)
		return	any_lor(srch, in-&gt;lft) ||
			any_lor(srch, in-&gt;rgt);

	return isequal(in, srch);
}

int
anywhere(int tok, Node *srch, Node *in)
{
	if (!in) return 0;

	switch (tok) {
	case AND:	return any_and(srch, in);
	case  OR:	return any_lor(srch, in);
	case   0:	return any_term(srch, in);
	}
	fatal("cannot happen, anywhere", (char *) 0);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

