<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/tl_parse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/tl_parse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** tl_spin: tl_parse.c *****/

/* Copyright (c) 1995-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Based on the translation algorithm by Gerth, Peled, Vardi, and Wolper, */
/* presented at the PSTV Conference, held in 1995, Warsaw, Poland 1995.   */

#include "tl.h"

extern int	tl_yylex(void);
extern int	tl_verbose, tl_errs;

int	tl_yychar = 0;
YYSTYPE	tl_yylval;

static Node	*tl_formula(void);
static Node	*tl_factor(void);
static Node	*tl_level(int);

static int	prec[2][4] = {
	{ U_OPER,  V_OPER, 0, 0 },	/* left associative */
	{ OR, AND, IMPLIES, EQUIV, },	/* left associative */
};

static Node *
tl_factor(void)
{	Node *ptr = ZN;

	switch (tl_yychar) {
	case '(':
		ptr = tl_formula();
		if (tl_yychar != ')')
			tl_yyerror("expected ')'");
		tl_yychar = tl_yylex();
		break;
	case NOT:
		ptr = tl_yylval;
		tl_yychar = tl_yylex();
		ptr-&gt;lft = tl_factor();
		ptr = push_negation(ptr);
		break;
	case ALWAYS:
		tl_yychar = tl_yylex();
		ptr = tl_factor();
#ifndef NO_OPT
		if (ptr-&gt;ntyp == FALSE
		||  ptr-&gt;ntyp == TRUE)
			break;	/* [] false == false */

		if (ptr-&gt;ntyp == V_OPER)
		{	if (ptr-&gt;lft-&gt;ntyp == FALSE)
				break;	/* [][]p = []p */

			ptr = ptr-&gt;rgt;	/* [] (p V q) = [] q */
		}
#endif
		ptr = tl_nn(V_OPER, False, ptr);
		break;
#ifdef NXT
	case NEXT:
		tl_yychar = tl_yylex();
		ptr = tl_factor();
		if (ptr-&gt;ntyp == TRUE)
			break;	/* X true = true */
		ptr = tl_nn(NEXT, ptr, ZN);
		break;
#endif
	case EVENTUALLY:
		tl_yychar = tl_yylex();

		ptr = tl_factor();
#ifndef NO_OPT
		if (ptr-&gt;ntyp == TRUE
		||  ptr-&gt;ntyp == FALSE)
			break;	/* &lt;&gt; true == true */

		if (ptr-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == TRUE)
			break;	/* &lt;&gt;&lt;&gt;p = &lt;&gt;p */

		if (ptr-&gt;ntyp == U_OPER)
		{	/* &lt;&gt; (p U q) = &lt;&gt; q */
			ptr = ptr-&gt;rgt;
			/* fall thru */
		}
#endif
		ptr = tl_nn(U_OPER, True, ptr);

		break;
	case PREDICATE:
		ptr = tl_yylval;
		tl_yychar = tl_yylex();
		break;
	case TRUE:
	case FALSE:
		ptr = tl_yylval;
		tl_yychar = tl_yylex();
		break;
	}
	if (!ptr) tl_yyerror("expected predicate");
#if 0
	printf("factor:	");
	tl_explain(ptr-&gt;ntyp);
	printf("\n");
#endif
	return ptr;
}

static Node *
bin_simpler(Node *ptr)
{	Node *a, *b;

	if (ptr)
	switch (ptr-&gt;ntyp) {
	case U_OPER:
#ifndef NO_OPT
		if (ptr-&gt;rgt-&gt;ntyp == TRUE
		||  ptr-&gt;rgt-&gt;ntyp == FALSE
		||  ptr-&gt;lft-&gt;ntyp == FALSE)
		{	ptr = ptr-&gt;rgt;
			break;
		}
		if (isequal(ptr-&gt;lft, ptr-&gt;rgt))
		{	/* p U p = p */	
			ptr = ptr-&gt;rgt;
			break;
		}
		if (ptr-&gt;lft-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;lft, ptr-&gt;rgt))
		{	/* (p U q) U p = (q U p) */
			ptr-&gt;lft = ptr-&gt;lft-&gt;rgt;
			break;
		}
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;rgt-&gt;lft-&gt;ntyp == TRUE)
		{	/* p U (T U q)  = (T U q) */
			ptr = ptr-&gt;rgt;
			break;
		}
#ifdef NXT
		/* X p U X q == X (p U q) */
		if (ptr-&gt;rgt-&gt;ntyp == NEXT
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == NEXT)
		{	ptr = tl_nn(NEXT,
				tl_nn(U_OPER,
					ptr-&gt;lft-&gt;lft,
					ptr-&gt;rgt-&gt;lft), ZN);
		}
#endif
#endif
		break;
	case V_OPER:
#ifndef NO_OPT
		if (ptr-&gt;rgt-&gt;ntyp == FALSE
		||  ptr-&gt;rgt-&gt;ntyp == TRUE
		||  ptr-&gt;lft-&gt;ntyp == TRUE)
		{	ptr = ptr-&gt;rgt;
			break;
		}
		if (isequal(ptr-&gt;lft, ptr-&gt;rgt))
		{	/* p V p = p */	
			ptr = ptr-&gt;rgt;
			break;
		}
		/* F V (p V q) == F V q */
		if (ptr-&gt;lft-&gt;ntyp == FALSE
		&amp;&amp;  ptr-&gt;rgt-&gt;ntyp == V_OPER)
		{	ptr-&gt;rgt = ptr-&gt;rgt-&gt;rgt;
			break;
		}
		/* p V (F V q) == F V q */
		if (ptr-&gt;rgt-&gt;ntyp == V_OPER
		&amp;&amp;  ptr-&gt;rgt-&gt;lft-&gt;ntyp == FALSE)
		{	ptr-&gt;lft = False;
			ptr-&gt;rgt = ptr-&gt;rgt-&gt;rgt;
			break;
		}
#endif
		break;
	case IMPLIES:
#ifndef NO_OPT
		if (isequal(ptr-&gt;lft, ptr-&gt;rgt))
		{	ptr = True;
			break;
		}
#endif
		ptr = tl_nn(OR, Not(ptr-&gt;lft), ptr-&gt;rgt);
		ptr = rewrite(ptr);
		break;
	case EQUIV:
#ifndef NO_OPT
		if (isequal(ptr-&gt;lft, ptr-&gt;rgt))
		{	ptr = True;
			break;
		}
#endif
		a = rewrite(tl_nn(AND,
			dupnode(ptr-&gt;lft),
			dupnode(ptr-&gt;rgt)));
		b = rewrite(tl_nn(AND,
			Not(ptr-&gt;lft),
			Not(ptr-&gt;rgt)));
		ptr = tl_nn(OR, a, b);
		ptr = rewrite(ptr);
		break;
	case AND:
#ifndef NO_OPT
		/* p &amp;&amp; (q U p) = p */
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;rgt, ptr-&gt;lft))
		{	ptr = ptr-&gt;lft;
			break;
		}
		if (ptr-&gt;lft-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt))
		{	ptr = ptr-&gt;rgt;
			break;
		}

		/* p &amp;&amp; (q V p) == q V p */
		if (ptr-&gt;rgt-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;rgt, ptr-&gt;lft))
		{	ptr = ptr-&gt;rgt;
			break;
		}
		if (ptr-&gt;lft-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt))
		{	ptr = ptr-&gt;lft;
			break;
		}

		/* (p U q) &amp;&amp; (r U q) = (p &amp;&amp; r) U q*/
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;rgt, ptr-&gt;lft-&gt;rgt))
		{	ptr = tl_nn(U_OPER,
				tl_nn(AND, ptr-&gt;lft-&gt;lft, ptr-&gt;rgt-&gt;lft),
				ptr-&gt;lft-&gt;rgt);
			break;
		}

		/* (p V q) &amp;&amp; (p V r) = p V (q &amp;&amp; r) */
		if (ptr-&gt;rgt-&gt;ntyp == V_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;lft, ptr-&gt;lft-&gt;lft))
		{	ptr = tl_nn(V_OPER,
				ptr-&gt;rgt-&gt;lft,
				tl_nn(AND, ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt-&gt;rgt));
			break;
		}
#ifdef NXT
		/* X p &amp;&amp; X q == X (p &amp;&amp; q) */
		if (ptr-&gt;rgt-&gt;ntyp == NEXT
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == NEXT)
		{	ptr = tl_nn(NEXT,
				tl_nn(AND,
					ptr-&gt;rgt-&gt;lft,
					ptr-&gt;lft-&gt;lft), ZN);
			break;
		}
#endif

		if (isequal(ptr-&gt;lft, ptr-&gt;rgt)	/* (p &amp;&amp; p) == p */
		||  ptr-&gt;rgt-&gt;ntyp == FALSE	/* (p &amp;&amp; F) == F */
		||  ptr-&gt;lft-&gt;ntyp == TRUE)	/* (T &amp;&amp; p) == p */
		{	ptr = ptr-&gt;rgt;
			break;
		}	
		if (ptr-&gt;rgt-&gt;ntyp == TRUE	/* (p &amp;&amp; T) == p */
		||  ptr-&gt;lft-&gt;ntyp == FALSE)	/* (F &amp;&amp; p) == F */
		{	ptr = ptr-&gt;lft;
			break;
		}

		/* (p V q) &amp;&amp; (r U q) == p V q */
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt-&gt;rgt))
		{	ptr = ptr-&gt;lft;
			break;
		}
#endif
		break;

	case OR:
#ifndef NO_OPT
		/* p || (q U p) == q U p */
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;rgt, ptr-&gt;lft))
		{	ptr = ptr-&gt;rgt;
			break;
		}

		/* p || (q V p) == p */
		if (ptr-&gt;rgt-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;rgt, ptr-&gt;lft))
		{	ptr = ptr-&gt;lft;
			break;
		}

		/* (p U q) || (p U r) = p U (q || r) */
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == U_OPER
		&amp;&amp;  isequal(ptr-&gt;rgt-&gt;lft, ptr-&gt;lft-&gt;lft))
		{	ptr = tl_nn(U_OPER,
				ptr-&gt;rgt-&gt;lft,
				tl_nn(OR, ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt-&gt;rgt));
			break;
		}

		if (isequal(ptr-&gt;lft, ptr-&gt;rgt)	/* (p || p) == p */
		||  ptr-&gt;rgt-&gt;ntyp == FALSE	/* (p || F) == p */
		||  ptr-&gt;lft-&gt;ntyp == TRUE)	/* (T || p) == T */
		{	ptr = ptr-&gt;lft;
			break;
		}	
		if (ptr-&gt;rgt-&gt;ntyp == TRUE	/* (p || T) == T */
		||  ptr-&gt;lft-&gt;ntyp == FALSE)	/* (F || p) == p */
		{	ptr = ptr-&gt;rgt;
			break;
		}

		/* (p V q) || (r V q) = (p || r) V q */
		if (ptr-&gt;rgt-&gt;ntyp == V_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt-&gt;rgt))
		{	ptr = tl_nn(V_OPER,
				tl_nn(OR, ptr-&gt;lft-&gt;lft, ptr-&gt;rgt-&gt;lft),
				ptr-&gt;rgt-&gt;rgt);
			break;
		}

		/* (p V q) || (r U q) == r U q */
		if (ptr-&gt;rgt-&gt;ntyp == U_OPER
		&amp;&amp;  ptr-&gt;lft-&gt;ntyp == V_OPER
		&amp;&amp;  isequal(ptr-&gt;lft-&gt;rgt, ptr-&gt;rgt-&gt;rgt))
		{	ptr = ptr-&gt;rgt;
			break;
		}		
#endif
		break;
	}
	return ptr;
}

static Node *
tl_level(int nr)
{	int i; Node *ptr = ZN;

	if (nr &lt; 0)
		return tl_factor();

	ptr = tl_level(nr-1);
again:
	for (i = 0; i &lt; 4; i++)
		if (tl_yychar == prec[nr][i])
		{	tl_yychar = tl_yylex();
			ptr = tl_nn(prec[nr][i],
				ptr, tl_level(nr-1));
			ptr = bin_simpler(ptr);
			goto again;
		}
	if (!ptr) tl_yyerror("syntax error");
#if 0
	printf("level %d:	", nr);
	tl_explain(ptr-&gt;ntyp);
	printf("\n");
#endif
	return ptr;
}

static Node *
tl_formula(void)
{	tl_yychar = tl_yylex();
	return tl_level(1);	/* 2 precedence levels, 1 and 0 */	
}

void
tl_parse(void)
{	Node *n;

	/* tl_verbose = 1; */
	n = tl_formula();
	if (tl_verbose)
	{	printf("formula: ");
		dump(n);
		printf("\n");
	}
	if (tl_Getchar() != -1)
	{	tl_yyerror("syntax error");
		tl_errs++;
		return;
	}
	trans(n);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

