<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/tl_trans.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/tl_trans.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** tl_spin: tl_trans.c *****/

/* Copyright (c) 1995-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

/* Based on the translation algorithm by Gerth, Peled, Vardi, and Wolper, */
/* presented at the PSTV Conference, held in 1995, Warsaw, Poland 1995.   */

#include "tl.h"

extern FILE	*tl_out;
extern int	tl_errs, tl_verbose, tl_terse, newstates, state_cnt;

int	Stack_mx=0, Max_Red=0, Total=0;

static Mapping	*Mapped = (Mapping *) 0;
static Graph	*Nodes_Set = (Graph *) 0;
static Graph	*Nodes_Stack = (Graph *) 0;

static char	dumpbuf[2048];
static int	Red_cnt  = 0;
static int	Lab_cnt  = 0;
static int	Base     = 0;
static int	Stack_sz = 0;

static Graph	*findgraph(char *);
static Graph	*pop_stack(void);
static Node	*Duplicate(Node *);
static Node	*flatten(Node *);
static Symbol	*catSlist(Symbol *, Symbol *);
static Symbol	*dupSlist(Symbol *);
static char	*newname(void);
static int	choueka(Graph *, int);
static int	not_new(Graph *);
static int	set_prefix(char *, int, Graph *);
static void	Addout(char *, char *);
static void	fsm_trans(Graph *, int, char *);
static void	mkbuchi(void);
static void	expand_g(Graph *);
static void	fixinit(Node *);
static void	liveness(Node *);
static void	mk_grn(Node *);
static void	mk_red(Node *);
static void	ng(Symbol *, Symbol *, Node *, Node *, Node *);
static void	push_stack(Graph *);
static void	sdump(Node *);

void
ini_trans(void)
{
	Stack_mx = 0;
	Max_Red = 0;
	Total = 0;

	Mapped = (Mapping *) 0;
	Nodes_Set = (Graph *) 0;
	Nodes_Stack = (Graph *) 0;

	memset(dumpbuf, 0, sizeof(dumpbuf));
	Red_cnt  = 0;
	Lab_cnt  = 0;
	Base     = 0;
	Stack_sz = 0;
}

static void
dump_graph(Graph *g)
{	Node *n1;

	printf("\n\tnew:\t");
	for (n1 = g-&gt;New; n1; n1 = n1-&gt;nxt)
	{ dump(n1); printf(", "); }
	printf("\n\told:\t");
	for (n1 = g-&gt;Old; n1; n1 = n1-&gt;nxt)
	{ dump(n1); printf(", "); }
	printf("\n\tnxt:\t");
	for (n1 = g-&gt;Next; n1; n1 = n1-&gt;nxt)
	{ dump(n1); printf(", "); }
	printf("\n\tother:\t");
	for (n1 = g-&gt;Other; n1; n1 = n1-&gt;nxt)
	{ dump(n1); printf(", "); }
	printf("\n");
}

static void
push_stack(Graph *g)
{
	if (!g) return;

	g-&gt;nxt = Nodes_Stack;
	Nodes_Stack = g;
	if (tl_verbose)
	{	Symbol *z;
		printf("\nPush %s, from ", g-&gt;name-&gt;name);
		for (z = g-&gt;incoming; z; z = z-&gt;next)
			printf("%s, ", z-&gt;name);
		dump_graph(g);
	}
	Stack_sz++;
	if (Stack_sz &gt; Stack_mx) Stack_mx = Stack_sz;
}

static Graph *
pop_stack(void)
{	Graph *g = Nodes_Stack;

	if (g) Nodes_Stack = g-&gt;nxt;

	Stack_sz--;

	return g;
}

static char *
newname(void)
{	static char buf[32];
	sprintf(buf, "S%d", state_cnt++);
	return buf;
}

static int
has_clause(int tok, Graph *p, Node *n)
{	Node *q, *qq;

	switch (n-&gt;ntyp) {
	case AND:
		return	has_clause(tok, p, n-&gt;lft) &amp;&amp;
			has_clause(tok, p, n-&gt;rgt);
	case OR:
		return	has_clause(tok, p, n-&gt;lft) ||
			has_clause(tok, p, n-&gt;rgt);
	}

	for (q = p-&gt;Other; q; q = q-&gt;nxt)
	{	qq = right_linked(q);
		if (anywhere(tok, n, qq))
			return 1;
	}
	return 0;
}

static void
mk_grn(Node *n)
{	Graph *p;

	n = right_linked(n);
more:
	for (p = Nodes_Set; p; p = p-&gt;nxt)
		if (p-&gt;outgoing
		&amp;&amp;  has_clause(AND, p, n))
		{	p-&gt;isgrn[p-&gt;grncnt++] =
				(unsigned char) Red_cnt;
			Lab_cnt++;
		}

	if (n-&gt;ntyp == U_OPER)	/* 3.4.0 */
	{	n = n-&gt;rgt;
		goto more;
	}
}

static void
mk_red(Node *n)
{	Graph *p;

	n = right_linked(n);
	for (p = Nodes_Set; p; p = p-&gt;nxt)
	{	if (p-&gt;outgoing
		&amp;&amp;  has_clause(0, p, n))
		{	if (p-&gt;redcnt &gt;= 63)
				Fatal("too many Untils", (char *)0);
			p-&gt;isred[p-&gt;redcnt++] =
				(unsigned char) Red_cnt;
			Lab_cnt++; Max_Red = Red_cnt;
	}	}
}

static void
liveness(Node *n)
{
	if (n)
	switch (n-&gt;ntyp) {
#ifdef NXT
	case NEXT:
		liveness(n-&gt;lft);
		break;
#endif
	case U_OPER:
		Red_cnt++;
		mk_red(n);
		mk_grn(n-&gt;rgt);
		/* fall through */
	case V_OPER:
	case OR: case AND:
		liveness(n-&gt;lft);
		liveness(n-&gt;rgt);
		break;
	}
}

static Graph *
findgraph(char *nm)
{	Graph	*p;
	Mapping *m;

	for (p = Nodes_Set; p; p = p-&gt;nxt)
		if (!strcmp(p-&gt;name-&gt;name, nm))
			return p;
	for (m = Mapped; m; m = m-&gt;nxt)
		if (strcmp(m-&gt;from, nm) == 0)
			return m-&gt;to;

	printf("warning: node %s not found\n", nm);
	return (Graph *) 0;
}

static void
Addout(char *to, char *from)
{	Graph	*p = findgraph(from);
	Symbol	*s;

	if (!p) return;
	s = getsym(tl_lookup(to));
	s-&gt;next = p-&gt;outgoing;
	p-&gt;outgoing = s;
}

#ifdef NXT
int
only_nxt(Node *n)
{
	switch (n-&gt;ntyp) {
	case NEXT:
		return 1;
	case OR:
	case AND:
		return only_nxt(n-&gt;rgt) &amp;&amp; only_nxt(n-&gt;lft);
	default:
		return 0;
	}
}
#endif

int
dump_cond(Node *pp, Node *r, int first)
{	Node *q;
	int frst = first;

	if (!pp) return frst;

	q = dupnode(pp);
	q = rewrite(q);

	if (q-&gt;ntyp == PREDICATE
	||  q-&gt;ntyp == NOT
#ifndef NXT
	||  q-&gt;ntyp == OR
#endif
	||  q-&gt;ntyp == FALSE)
	{	if (!frst) fprintf(tl_out, " &amp;&amp; ");
		dump(q);
		frst = 0;
#ifdef NXT
	} else if (q-&gt;ntyp == OR)
	{	if (!frst) fprintf(tl_out, " &amp;&amp; ");
		fprintf(tl_out, "((");
		frst = dump_cond(q-&gt;lft, r, 1);

		if (!frst)
			fprintf(tl_out, ") || (");
		else
		{	if (only_nxt(q-&gt;lft))
			{	fprintf(tl_out, "1))");
				return 0;
			}
		}

		frst = dump_cond(q-&gt;rgt, r, 1);

		if (frst)
		{	if (only_nxt(q-&gt;rgt))
				fprintf(tl_out, "1");
			else
				fprintf(tl_out, "0");
			frst = 0;
		}

		fprintf(tl_out, "))");
#endif
	} else  if (q-&gt;ntyp == V_OPER
		&amp;&amp; !anywhere(AND, q-&gt;rgt, r))
	{	frst = dump_cond(q-&gt;rgt, r, frst);
	} else  if (q-&gt;ntyp == AND)
	{
		frst = dump_cond(q-&gt;lft, r, frst);
		frst = dump_cond(q-&gt;rgt, r, frst);
	}

	return frst;
}

static int
choueka(Graph *p, int count)
{	int j, k, incr_cnt = 0;

	for (j = count; j &lt;= Max_Red; j++) /* for each acceptance class */
	{	int delta = 0;

		/* is state p labeled Grn-j OR not Red-j ? */

		for (k = 0; k &lt; (int) p-&gt;grncnt; k++)
			if (p-&gt;isgrn[k] == j)
			{	delta = 1;
				break;
			}
		if (delta)
		{	incr_cnt++;
			continue;
		}
		for (k = 0; k &lt; (int) p-&gt;redcnt; k++)
			if (p-&gt;isred[k] == j)
			{	delta = 1;
				break;
			}

		if (delta) break;

		incr_cnt++;
	}
	return incr_cnt;
}

static int
set_prefix(char *pref, int count, Graph *r2)
{	int incr_cnt = 0;	/* acceptance class 'count' */

	if (Lab_cnt == 0
	||  Max_Red == 0)
		sprintf(pref, "accept");	/* new */
	else if (count &gt;= Max_Red)
		sprintf(pref, "T0");		/* cycle */
	else
	{	incr_cnt = choueka(r2, count+1);
		if (incr_cnt + count &gt;= Max_Red)
			sprintf(pref, "accept"); /* last hop */
		else
			sprintf(pref, "T%d", count+incr_cnt);
	}
	return incr_cnt;
}

static void
fsm_trans(Graph *p, int count, char *curnm)
{	Graph	*r;
	Symbol	*s;
	char	prefix[128], nwnm[256];

	if (!p-&gt;outgoing)
		addtrans(p, curnm, False, "accept_all");

	for (s = p-&gt;outgoing; s; s = s-&gt;next)
	{	r = findgraph(s-&gt;name);
		if (!r) continue;
		if (r-&gt;outgoing)
		{	(void) set_prefix(prefix, count, r);
			sprintf(nwnm, "%s_%s", prefix, s-&gt;name);
		} else
			strcpy(nwnm, "accept_all");

		if (tl_verbose)
		{	printf("maxred=%d, count=%d, curnm=%s, nwnm=%s ",
				Max_Red, count, curnm, nwnm);
			printf("(greencnt=%d,%d, redcnt=%d,%d)\n",
				r-&gt;grncnt, r-&gt;isgrn[0],
				r-&gt;redcnt, r-&gt;isred[0]);
		}
		addtrans(p, curnm, r-&gt;Old, nwnm);
	}
}

static void
mkbuchi(void)
{	Graph	*p;
	int	k;
	char	curnm[64];

	for (k = 0; k &lt;= Max_Red; k++)
	for (p = Nodes_Set; p; p = p-&gt;nxt)
	{	if (!p-&gt;outgoing)
			continue;
		if (k != 0
		&amp;&amp; !strcmp(p-&gt;name-&gt;name, "init")
		&amp;&amp;  Max_Red != 0)
			continue;

		if (k == Max_Red
		&amp;&amp;  strcmp(p-&gt;name-&gt;name, "init") != 0)
			strcpy(curnm, "accept_");
		else
			sprintf(curnm, "T%d_", k);

		strcat(curnm, p-&gt;name-&gt;name);

		fsm_trans(p, k, curnm);
	}
	fsm_print();
}

static Symbol *
dupSlist(Symbol *s)
{	Symbol *p1, *p2, *p3, *d = ZS;

	for (p1 = s; p1; p1 = p1-&gt;next)
	{	for (p3 = d; p3; p3 = p3-&gt;next)
		{	if (!strcmp(p3-&gt;name, p1-&gt;name))
				break;
		}
		if (p3) continue;	/* a duplicate */

		p2 = getsym(p1);
		p2-&gt;next = d;
		d = p2;
	}
	return d;
}

static Symbol *
catSlist(Symbol *a, Symbol *b)
{	Symbol *p1, *p2, *p3, *tmp;

	/* remove duplicates from b */
	for (p1 = a; p1; p1 = p1-&gt;next)
	{	p3 = ZS;
		for (p2 = b; p2; p2 = p2-&gt;next)
		{	if (strcmp(p1-&gt;name, p2-&gt;name))
			{	p3 = p2;
				continue;
			}
			tmp = p2-&gt;next;
			tfree((void *) p2);
			if (p3)
				p3-&gt;next = tmp;
			else
				b = tmp;
	}	}
	if (!a) return b;
	if (!b) return a;
	if (!b-&gt;next)
	{	b-&gt;next = a;
		return b;
	}
	/* find end of list */
	for (p1 = a; p1-&gt;next; p1 = p1-&gt;next)
		;
	p1-&gt;next = b;
	return a;
}

static void
fixinit(Node *orig)
{	Graph	*p1, *g;
	Symbol	*q1, *q2 = ZS;

	ng(tl_lookup("init"), ZS, ZN, ZN, ZN);
	p1 = pop_stack();
	p1-&gt;nxt = Nodes_Set;
	p1-&gt;Other = p1-&gt;Old = orig;
	Nodes_Set = p1;

	for (g = Nodes_Set; g; g = g-&gt;nxt)
	{	for (q1 = g-&gt;incoming; q1; q1 = q2)
		{	q2 = q1-&gt;next;
			Addout(g-&gt;name-&gt;name, q1-&gt;name);
			tfree((void *) q1);
		}
		g-&gt;incoming = ZS;
	}
}

static Node *
flatten(Node *p)
{	Node *q, *r, *z = ZN;

	for (q = p; q; q = q-&gt;nxt)
	{	r = dupnode(q);
		if (z)
			z = tl_nn(AND, r, z);
		else
			z = r;
	}
	if (!z) return z;
	z = rewrite(z);
	return z;
}

static Node *
Duplicate(Node *n)
{	Node *n1, *n2, *lst = ZN, *d = ZN;

	for (n1 = n; n1; n1 = n1-&gt;nxt)
	{	n2 = dupnode(n1);
		if (lst)
		{	lst-&gt;nxt = n2;
			lst = n2;
		} else
			d = lst = n2;
	}
	return d;
}

static void
ng(Symbol *s, Symbol *in, Node *isnew, Node *isold, Node *next)
{	Graph *g = (Graph *) tl_emalloc(sizeof(Graph));

	if (s)     g-&gt;name = s;
	else       g-&gt;name = tl_lookup(newname());

	if (in)    g-&gt;incoming = dupSlist(in);
	if (isnew) g-&gt;New  = flatten(isnew);
	if (isold) g-&gt;Old  = Duplicate(isold);
	if (next)  g-&gt;Next = flatten(next);

	push_stack(g);
}

static void
sdump(Node *n)
{
	switch (n-&gt;ntyp) {
	case PREDICATE:	strcat(dumpbuf, n-&gt;sym-&gt;name);
			break;
	case U_OPER:	strcat(dumpbuf, "U");
			goto common2;
	case V_OPER:	strcat(dumpbuf, "V");
			goto common2;
	case OR:	strcat(dumpbuf, "|");
			goto common2;
	case AND:	strcat(dumpbuf, "&amp;");
common2:		sdump(n-&gt;rgt);
common1:		sdump(n-&gt;lft);
			break;
#ifdef NXT
	case NEXT:	strcat(dumpbuf, "X");
			goto common1;
#endif
	case NOT:	strcat(dumpbuf, "!");
			goto common1;
	case TRUE:	strcat(dumpbuf, "T");
			break;
	case FALSE:	strcat(dumpbuf, "F");
			break;
	default:	strcat(dumpbuf, "?");
			break;
	}
}

Symbol *
DoDump(Node *n)
{
	if (!n) return ZS;

	if (n-&gt;ntyp == PREDICATE)
		return n-&gt;sym;

	dumpbuf[0] = '\0';
	sdump(n);
	return tl_lookup(dumpbuf);
}

static int
not_new(Graph *g)
{	Graph	*q1; Node *tmp, *n1, *n2;
	Mapping	*map;

	tmp = flatten(g-&gt;Old);	/* duplicate, collapse, normalize */
	g-&gt;Other = g-&gt;Old;	/* non normalized full version */
	g-&gt;Old = tmp;

	g-&gt;oldstring = DoDump(g-&gt;Old);

	tmp = flatten(g-&gt;Next);
	g-&gt;nxtstring = DoDump(tmp);

	if (tl_verbose) dump_graph(g);

	Debug2("\tformula-old: [%s]\n", g-&gt;oldstring?g-&gt;oldstring-&gt;name:"true");
	Debug2("\tformula-nxt: [%s]\n", g-&gt;nxtstring?g-&gt;nxtstring-&gt;name:"true");
	for (q1 = Nodes_Set; q1; q1 = q1-&gt;nxt)
	{	Debug2("	compare old to: %s", q1-&gt;name-&gt;name);
		Debug2(" [%s]", q1-&gt;oldstring?q1-&gt;oldstring-&gt;name:"true");

		Debug2("	compare nxt to: %s", q1-&gt;name-&gt;name);
		Debug2(" [%s]", q1-&gt;nxtstring?q1-&gt;nxtstring-&gt;name:"true");

		if (q1-&gt;oldstring != g-&gt;oldstring
		||  q1-&gt;nxtstring != g-&gt;nxtstring)
		{	Debug(" =&gt; different\n");
			continue;
		}
		Debug(" =&gt; match\n");

		if (g-&gt;incoming)
			q1-&gt;incoming = catSlist(g-&gt;incoming, q1-&gt;incoming);

		/* check if there's anything in g-&gt;Other that needs
		   adding to q1-&gt;Other
		*/
		for (n2 = g-&gt;Other; n2; n2 = n2-&gt;nxt)
		{	for (n1 = q1-&gt;Other; n1; n1 = n1-&gt;nxt)
				if (isequal(n1, n2))
					break;
			if (!n1)
			{	Node *n3 = dupnode(n2);
				/* don't mess up n2-&gt;nxt */
				n3-&gt;nxt = q1-&gt;Other;
				q1-&gt;Other = n3;
		}	}

		map = (Mapping *) tl_emalloc(sizeof(Mapping));
	  	map-&gt;from = g-&gt;name-&gt;name;
	  	map-&gt;to   = q1;
	  	map-&gt;nxt = Mapped;
	  	Mapped = map;

		for (n1 = g-&gt;Other; n1; n1 = n2)
		{	n2 = n1-&gt;nxt;
			releasenode(1, n1);
		}
		for (n1 = g-&gt;Old; n1; n1 = n2)
		{	n2 = n1-&gt;nxt;
			releasenode(1, n1);
		}
		for (n1 = g-&gt;Next; n1; n1 = n2)
		{	n2 = n1-&gt;nxt;
			releasenode(1, n1);
		}
		return 1;
	}

	if (newstates) tl_verbose=1;
	Debug2("	New Node %s [", g-&gt;name-&gt;name);
	for (n1 = g-&gt;Old; n1; n1 = n1-&gt;nxt)
	{ Dump(n1); Debug(", "); }
	Debug2("] nr %d\n", Base);
	if (newstates) tl_verbose=0;

	Base++;
	g-&gt;nxt = Nodes_Set;
	Nodes_Set = g;

	return 0;
}

static void
expand_g(Graph *g)
{	Node *now, *n1, *n2, *nx;
	int can_release;

	if (!g-&gt;New)
	{	Debug2("\nDone with %s", g-&gt;name-&gt;name);
		if (tl_verbose) dump_graph(g);
		if (not_new(g))
		{	if (tl_verbose) printf("\tIs Not New\n");
			return;
		}
		if (g-&gt;Next)
		{	Debug("	Has Next [");
			for (n1 = g-&gt;Next; n1; n1 = n1-&gt;nxt)
			{ Dump(n1); Debug(", "); }
			Debug("]\n");

			ng(ZS, getsym(g-&gt;name), g-&gt;Next, ZN, ZN);
		}
		return;
	}

	if (tl_verbose)
	{	Symbol *z;
		printf("\nExpand %s, from ", g-&gt;name-&gt;name);
		for (z = g-&gt;incoming; z; z = z-&gt;next)
			printf("%s, ", z-&gt;name);
		printf("\n\thandle:\t"); Explain(g-&gt;New-&gt;ntyp);
		dump_graph(g);
	}

	if (g-&gt;New-&gt;ntyp == AND)
	{	if (g-&gt;New-&gt;nxt)
		{	n2 = g-&gt;New-&gt;rgt;
			while (n2-&gt;nxt)
				n2 = n2-&gt;nxt;
			n2-&gt;nxt = g-&gt;New-&gt;nxt;
		}
		n1 = n2 = g-&gt;New-&gt;lft;
		while (n2-&gt;nxt)
			n2 = n2-&gt;nxt;
		n2-&gt;nxt = g-&gt;New-&gt;rgt;

		releasenode(0, g-&gt;New);

		g-&gt;New = n1;
		push_stack(g);
		return;
	}

	can_release = 0;	/* unless it need not go into Old */
	now = g-&gt;New;
	g-&gt;New = g-&gt;New-&gt;nxt;
	now-&gt;nxt = ZN;

	if (now-&gt;ntyp != TRUE)
	{	if (g-&gt;Old)
		{	for (n1 = g-&gt;Old; n1-&gt;nxt; n1 = n1-&gt;nxt)
				if (isequal(now, n1))
				{	can_release = 1;
					goto out;
				}
			n1-&gt;nxt = now;
		} else
			g-&gt;Old = now;
	}
out:
	switch (now-&gt;ntyp) {
	case FALSE:
		push_stack(g);
		break;
	case TRUE:
		releasenode(1, now);
		push_stack(g);
		break;
	case PREDICATE:
	case NOT:
		if (can_release) releasenode(1, now);
		push_stack(g);
		break;
	case V_OPER:
		Assert(now-&gt;rgt != ZN, now-&gt;ntyp);
		Assert(now-&gt;lft != ZN, now-&gt;ntyp);
		Assert(now-&gt;rgt-&gt;nxt == ZN, now-&gt;ntyp);
		Assert(now-&gt;lft-&gt;nxt == ZN, now-&gt;ntyp);
		n1 = now-&gt;rgt;
		n1-&gt;nxt = g-&gt;New;

		if (can_release)
			nx = now;
		else
			nx = getnode(now); /* now also appears in Old */
		nx-&gt;nxt = g-&gt;Next;

		n2 = now-&gt;lft;
		n2-&gt;nxt = getnode(now-&gt;rgt);
		n2-&gt;nxt-&gt;nxt = g-&gt;New;
		g-&gt;New = flatten(n2);
		push_stack(g);
		ng(ZS, g-&gt;incoming, n1, g-&gt;Old, nx);
		break;

	case U_OPER:
		Assert(now-&gt;rgt-&gt;nxt == ZN, now-&gt;ntyp);
		Assert(now-&gt;lft-&gt;nxt == ZN, now-&gt;ntyp);
		n1 = now-&gt;lft;

		if (can_release)
			nx = now;
		else
			nx = getnode(now); /* now also appears in Old */
		nx-&gt;nxt = g-&gt;Next;

		n2 = now-&gt;rgt;
		n2-&gt;nxt = g-&gt;New;

		goto common;

#ifdef NXT
	case NEXT:
		Assert(now-&gt;lft != ZN, now-&gt;ntyp);
		nx = dupnode(now-&gt;lft);
		nx-&gt;nxt = g-&gt;Next;
		g-&gt;Next = nx;
		if (can_release) releasenode(0, now);
		push_stack(g);
		break;
#endif

	case OR:
		Assert(now-&gt;rgt-&gt;nxt == ZN, now-&gt;ntyp);
		Assert(now-&gt;lft-&gt;nxt == ZN, now-&gt;ntyp);
		n1 = now-&gt;lft;
		nx = g-&gt;Next;

		n2 = now-&gt;rgt;
		n2-&gt;nxt = g-&gt;New;
common:
		n1-&gt;nxt = g-&gt;New;

		ng(ZS, g-&gt;incoming, n1, g-&gt;Old, nx);
		g-&gt;New = flatten(n2);

		if (can_release) releasenode(1, now);

		push_stack(g);
		break;
	}
}

Node *
twocases(Node *p)
{	Node *q;
	/* 1: ([]p1 &amp;&amp; []p2) == [](p1 &amp;&amp; p2) */
	/* 2: (&lt;&gt;p1 || &lt;&gt;p2) == &lt;&gt;(p1 || p2) */

	if (!p) return p;

	switch(p-&gt;ntyp) {
	case AND:
	case OR:
	case U_OPER:
	case V_OPER:
		p-&gt;lft = twocases(p-&gt;lft);
		p-&gt;rgt = twocases(p-&gt;rgt);
		break;
#ifdef NXT
	case NEXT:
#endif
	case NOT:
		p-&gt;lft = twocases(p-&gt;lft);
		break;

	default:
		break;
	}
	if (p-&gt;ntyp == AND	/* 1 */
	&amp;&amp;  p-&gt;lft-&gt;ntyp == V_OPER
	&amp;&amp;  p-&gt;lft-&gt;lft-&gt;ntyp == FALSE
	&amp;&amp;  p-&gt;rgt-&gt;ntyp == V_OPER
	&amp;&amp;  p-&gt;rgt-&gt;lft-&gt;ntyp == FALSE)
	{	q = tl_nn(V_OPER, False,
			tl_nn(AND, p-&gt;lft-&gt;rgt, p-&gt;rgt-&gt;rgt));
	} else
	if (p-&gt;ntyp == OR	/* 2 */
	&amp;&amp;  p-&gt;lft-&gt;ntyp == U_OPER
	&amp;&amp;  p-&gt;lft-&gt;lft-&gt;ntyp == TRUE
	&amp;&amp;  p-&gt;rgt-&gt;ntyp == U_OPER
	&amp;&amp;  p-&gt;rgt-&gt;lft-&gt;ntyp == TRUE)
	{	q = tl_nn(U_OPER, True,
			tl_nn(OR, p-&gt;lft-&gt;rgt, p-&gt;rgt-&gt;rgt));
	} else
		q = p;
	return q;
}

void
trans(Node *p)
{	Node	*op;
	Graph	*g;

	if (!p || tl_errs) return;

	p = twocases(p);

	if (tl_verbose || tl_terse)
	{	fprintf(tl_out, "\t/* Normlzd: ");
		dump(p);
		fprintf(tl_out, " */\n");
	}
	if (tl_terse)
		return;

	op = dupnode(p);

	ng(ZS, getsym(tl_lookup("init")), p, ZN, ZN);
	while ((g = Nodes_Stack) != (Graph *) 0)
	{	Nodes_Stack = g-&gt;nxt;
		expand_g(g);
	}
	if (newstates)
		return;

	fixinit(p);
	liveness(flatten(op));	/* was: liveness(op); */

	mkbuchi();
	if (tl_verbose)
	{	printf("/*\n");
		printf(" * %d states in Streett automaton\n", Base);
		printf(" * %d Streett acceptance conditions\n", Max_Red);
		printf(" * %d Buchi states\n", Total);
		printf(" */\n");
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

