<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/spin/vars.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/spin/vars.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/***** spin: vars.c *****/

/* Copyright (c) 1989-2003 by Lucent Technologies, Bell Laboratories.     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* No guarantee whatsoever is expressed or implied by the distribution of */
/* this code.  Permission is given to distribute this code provided that  */
/* this introductory message is not removed and no monies are exchanged.  */
/* Software written by Gerard J. Holzmann.  For tool documentation see:   */
/*             http://spinroot.com/                                       */
/* Send all bug-reports and/or questions to: bugs@spinroot.com            */

#include "spin.h"
#include "y.tab.h"

extern Ordered	*all_names;
extern RunList	*X, *LastX;
extern Symbol	*Fname;
extern char	Buf[];
extern int	lineno, depth, verbose, xspin, limited_vis;
extern int	analyze, jumpsteps, nproc, nstop, columns;
extern short	no_arrays, Have_claim;
extern void	sr_mesg(FILE *, int, int);
extern void	sr_buf(int, int);

static int	getglobal(Lextok *);
static int	setglobal(Lextok *, int);
static int	maxcolnr = 1;

int
getval(Lextok *sn)
{	Symbol *s = sn-&gt;sym;

	if (strcmp(s-&gt;name, "_") == 0)
	{	non_fatal("attempt to read value of '_'", 0);
		return 0;
	}
	if (strcmp(s-&gt;name, "_last") == 0)
		return (LastX)?LastX-&gt;pid:0;
	if (strcmp(s-&gt;name, "_p") == 0)
		return (X &amp;&amp; X-&gt;pc)?X-&gt;pc-&gt;seqno:0;
	if (strcmp(s-&gt;name, "_pid") == 0)
	{	if (!X) return 0;
		return X-&gt;pid - Have_claim;
	}
	if (strcmp(s-&gt;name, "_nr_pr") == 0)
		return nproc-nstop;	/* new 3.3.10 */

	if (s-&gt;context &amp;&amp; s-&gt;type)
		return getlocal(sn);

	if (!s-&gt;type)	/* not declared locally */
	{	s = lookup(s-&gt;name); /* try global */
		sn-&gt;sym = s;	/* fix it */
	}
	return getglobal(sn);
}

int
setval(Lextok *v, int n)
{
	if (v-&gt;sym-&gt;context &amp;&amp; v-&gt;sym-&gt;type)
		return setlocal(v, n);
	if (!v-&gt;sym-&gt;type)
		v-&gt;sym = lookup(v-&gt;sym-&gt;name);
	return setglobal(v, n);
}

void
rm_selfrefs(Symbol *s, Lextok *i)
{
	if (!i) return;

	if (i-&gt;ntyp == NAME
	&amp;&amp;  strcmp(i-&gt;sym-&gt;name, s-&gt;name) == 0
	&amp;&amp; (	(!i-&gt;sym-&gt;context &amp;&amp; !s-&gt;context)
	   ||	( i-&gt;sym-&gt;context &amp;&amp;  s-&gt;context
		&amp;&amp; strcmp(i-&gt;sym-&gt;context-&gt;name, s-&gt;context-&gt;name) == 0)))
	{	lineno  = i-&gt;ln;
		Fname   = i-&gt;fn;
		non_fatal("self-reference initializing '%s'", s-&gt;name);
		i-&gt;ntyp = CONST;
		i-&gt;val  = 0;
	} else
	{	rm_selfrefs(s, i-&gt;lft);
		rm_selfrefs(s, i-&gt;rgt);
	}
}

int
checkvar(Symbol *s, int n)
{	int	i, oln = lineno;	/* calls on eval() change it */
	Symbol	*ofnm = Fname;

	if (!in_bound(s, n))
		return 0;

	if (s-&gt;type == 0)
	{	non_fatal("undecl var %s (assuming int)", s-&gt;name);
		s-&gt;type = INT;
	}
	/* not a STRUCT */
	if (s-&gt;val == (int *) 0)	/* uninitialized */
	{	s-&gt;val = (int *) emalloc(s-&gt;nel*sizeof(int));
		for (i = 0; i &lt; s-&gt;nel; i++)
		{	if (s-&gt;type != CHAN)
			{	rm_selfrefs(s, s-&gt;ini);
				s-&gt;val[i] = eval(s-&gt;ini);
			} else if (!analyze)
				s-&gt;val[i] = qmake(s);
	}	}
	lineno = oln;
	Fname  = ofnm;

	return 1;
}

static int
getglobal(Lextok *sn)
{	Symbol *s = sn-&gt;sym;
	int i, n = eval(sn-&gt;lft);

	if (s-&gt;type == 0 &amp;&amp; X &amp;&amp; (i = find_lab(s, X-&gt;n, 0)))
	{	printf("findlab through getglobal on %s\n", s-&gt;name);
		return i;	/* can this happen? */
	}
	if (s-&gt;type == STRUCT)
		return Rval_struct(sn, s, 1); /* 1 = check init */
	if (checkvar(s, n))
		return cast_val(s-&gt;type, s-&gt;val[n], s-&gt;nbits);
	return 0;
}

int
cast_val(int t, int v, int w)
{	int i=0; short s=0; unsigned int u=0;

	if (t == PREDEF || t == INT || t == CHAN) i = v;	/* predef means _ */
	else if (t == SHORT) s = (short) v;
	else if (t == BYTE || t == MTYPE)  u = (unsigned char)v;
	else if (t == BIT)   u = (unsigned char)(v&amp;1);
	else if (t == UNSIGNED)
	{	if (w == 0)
			fatal("cannot happen, cast_val", (char *)0);
	/*	u = (unsigned)(v&amp; ((1&lt;&lt;w)-1));		problem when w=32	*/
		u = (unsigned)(v&amp; (~0u&gt;&gt;(8*sizeof(unsigned)-w)));	/* doug */
	}

	if (v != i+s+ (int) u)
	{	char buf[64]; sprintf(buf, "%d-&gt;%d (%d)", v, i+s+u, t);
		non_fatal("value (%s) truncated in assignment", buf);
	}
	return (int)(i+s+u);
}

static int
setglobal(Lextok *v, int m)
{
	if (v-&gt;sym-&gt;type == STRUCT)
		(void) Lval_struct(v, v-&gt;sym, 1, m);
	else
	{	int n = eval(v-&gt;lft);
		if (checkvar(v-&gt;sym, n))
		{	int oval = v-&gt;sym-&gt;val[n];
			int nval = cast_val(v-&gt;sym-&gt;type, m, v-&gt;sym-&gt;nbits);
			v-&gt;sym-&gt;val[n] = nval;
			if (oval != nval)
			{	v-&gt;sym-&gt;setat = depth;
	}	}	}
	return 1;
}

void
dumpclaims(FILE *fd, int pid, char *s)
{	extern Lextok *Xu_List; extern int Pid;
	extern short terse;
	Lextok *m; int cnt = 0; int oPid = Pid;

	for (m = Xu_List; m; m = m-&gt;rgt)
		if (strcmp(m-&gt;sym-&gt;name, s) == 0)
		{	cnt=1;
			break;
		}
	if (cnt == 0) return;

	Pid = pid;
	fprintf(fd, "#ifndef XUSAFE\n");
	for (m = Xu_List; m; m = m-&gt;rgt)
	{	if (strcmp(m-&gt;sym-&gt;name, s) != 0)
			continue;
		no_arrays = 1;
		putname(fd, "\t\tsetq_claim(", m-&gt;lft, 0, "");
		no_arrays = 0;
		fprintf(fd, ", %d, ", m-&gt;val);
		terse = 1;
		putname(fd, "\"", m-&gt;lft, 0, "\", h, ");
		terse = 0;
		fprintf(fd, "\"%s\");\n", s);
	}
	fprintf(fd, "#endif\n");
	Pid = oPid;
}

void
dumpglobals(void)
{	Ordered *walk;
	static Lextok *dummy = ZN;
	Symbol *sp;
	int j;

	if (!dummy)
		dummy = nn(ZN, NAME, nn(ZN,CONST,ZN,ZN), ZN);

	for (walk = all_names; walk; walk = walk-&gt;next)
	{	sp = walk-&gt;entry;
		if (!sp-&gt;type || sp-&gt;context || sp-&gt;owner
		||  sp-&gt;type == PROCTYPE  || sp-&gt;type == PREDEF
		||  sp-&gt;type == CODE_FRAG || sp-&gt;type == CODE_DECL
		||  (sp-&gt;type == MTYPE &amp;&amp; ismtype(sp-&gt;name)))
			continue;

		if (sp-&gt;type == STRUCT)
		{	if ((verbose&amp;4) &amp;&amp; !(verbose&amp;64)
			&amp;&amp;  (sp-&gt;setat &lt; depth
			&amp;&amp;   jumpsteps != depth))
			{	continue;
			}
			dump_struct(sp, sp-&gt;name, 0);
			continue;
		}
		for (j = 0; j &lt; sp-&gt;nel; j++)
		{	int prefetch;
			if (sp-&gt;type == CHAN)
			{	doq(sp, j, 0);
				continue;
			}
			if ((verbose&amp;4) &amp;&amp; !(verbose&amp;64)
			&amp;&amp;  (sp-&gt;setat &lt; depth
			&amp;&amp;   jumpsteps != depth))
			{	continue;
			}

			dummy-&gt;sym = sp;
			dummy-&gt;lft-&gt;val = j;
			/* in case of cast_val warnings, do this first: */
			prefetch = getglobal(dummy);
			printf("\t\t%s", sp-&gt;name);
			if (sp-&gt;nel &gt; 1 || sp-&gt;isarray) printf("[%d]", j);
			printf(" = ");
			sr_mesg(stdout, prefetch,
				sp-&gt;type == MTYPE);
			printf("\n");
			if (limited_vis &amp;&amp; (sp-&gt;hidden&amp;2))
			{	int colpos;
				Buf[0] = '\0';
				if (!xspin)
				{	if (columns == 2)
					sprintf(Buf, "~G%s = ", sp-&gt;name);
					else
					sprintf(Buf, "%s = ", sp-&gt;name);
				}
				sr_buf(prefetch, sp-&gt;type == MTYPE);
				if (sp-&gt;colnr == 0)
				{	sp-&gt;colnr = maxcolnr;
					maxcolnr = 1+(maxcolnr%10);
				}
				colpos = nproc+sp-&gt;colnr-1;
				if (columns == 2)
				{	pstext(colpos, Buf);
					continue;
				}
				if (!xspin)
				{	printf("\t\t%s\n", Buf);
					continue;
				}
				printf("MSC: ~G %s %s\n", sp-&gt;name, Buf);
				printf("%3d:\tproc %3d (TRACK) line   1 \"var\" ",
					depth, colpos);
				printf("(state 0)\t[printf('MSC: globvar\\\\n')]\n");
				printf("\t\t%s", sp-&gt;name);
				if (sp-&gt;nel &gt; 1 || sp-&gt;isarray) printf("[%d]", j);
				printf(" = %s\n", Buf);
	}	}	}
}

void
dumplocal(RunList *r)
{	static Lextok *dummy = ZN;
	Symbol *z, *s;
	int i;

	if (!r) return;

	s = r-&gt;symtab;

	if (!dummy)
		dummy = nn(ZN, NAME, nn(ZN,CONST,ZN,ZN), ZN);

	for (z = s; z; z = z-&gt;next)
	{	if (z-&gt;type == STRUCT)
		{	dump_struct(z, z-&gt;name, r);
			continue;
		}
		for (i = 0; i &lt; z-&gt;nel; i++)
		{	if (z-&gt;type == CHAN)
			{	doq(z, i, r);
				continue;
			}
			if ((verbose&amp;4) &amp;&amp; !(verbose&amp;64)
			&amp;&amp;  (z-&gt;setat &lt; depth
			&amp;&amp;   jumpsteps != depth))
				continue;

			dummy-&gt;sym = z;
			dummy-&gt;lft-&gt;val = i;

			printf("\t\t%s(%d):%s",
				r-&gt;n-&gt;name, r-&gt;pid - Have_claim, z-&gt;name);
			if (z-&gt;nel &gt; 1 || z-&gt;isarray) printf("[%d]", i);
			printf(" = ");
			sr_mesg(stdout, getval(dummy), z-&gt;type == MTYPE);
			printf("\n");
			if (limited_vis &amp;&amp; (z-&gt;hidden&amp;2))
			{	int colpos;
				Buf[0] = '\0';
				if (!xspin)
				{	if (columns == 2)
					sprintf(Buf, "~G%s(%d):%s = ",
					r-&gt;n-&gt;name, r-&gt;pid, z-&gt;name);
					else
					sprintf(Buf, "%s(%d):%s = ",
					r-&gt;n-&gt;name, r-&gt;pid, z-&gt;name);
				}
				sr_buf(getval(dummy), z-&gt;type==MTYPE);
				if (z-&gt;colnr == 0)
				{	z-&gt;colnr = maxcolnr;
					maxcolnr = 1+(maxcolnr%10);
				}
				colpos = nproc+z-&gt;colnr-1;
				if (columns == 2)
				{	pstext(colpos, Buf);
					continue;
				}
				if (!xspin)
				{	printf("\t\t%s\n", Buf);
					continue;
				}
				printf("MSC: ~G %s(%d):%s %s\n",
					r-&gt;n-&gt;name, r-&gt;pid, z-&gt;name, Buf);

				printf("%3d:\tproc %3d (TRACK) line   1 \"var\" ",
					depth, colpos);
				printf("(state 0)\t[printf('MSC: locvar\\\\n')]\n");
				printf("\t\t%s(%d):%s",
					r-&gt;n-&gt;name, r-&gt;pid, z-&gt;name);
				if (z-&gt;nel &gt; 1 || z-&gt;isarray) printf("[%d]", i);
				printf(" = %s\n", Buf);
	}	}	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

