<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/srvold9p/srvold9p.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/srvold9p/srvold9p.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;libsec.h&gt;
#include "9p1.h"

char	*user;
int	newfd;
int	roldfd;
int	woldfd;
int	debug;
int	dofcall;
QLock	servelock;
QLock	fidlock;
QLock	taglock;
int	mainpid;
int	ntag;
int	nfork;
char FLUSHED[] = "FLUSHED";

enum{
	Maxfdata = 8192
};

enum{
	Command,
	Network,
	File,
	Stdio,
};

typedef struct Tag Tag;
struct Tag
{
	int	tag;
	int	flushed;
	int	received;
	int	ref;
	Tag	*next;
};

typedef struct Message Message;
struct Message
{
	char	*data;
	int	n;
};

typedef struct Fid Fid;

struct Fid
{
	short	busy;
	short	allocated;
	int	fid;
	Qid	qid;
	ulong	newoffset;
	ulong	oldoffset;
	Fid	*next;
};

Fid	*fids;
Tag	*tags;

char	*rflush(Fcall*, Fcall*, char*),
	*rversion(Fcall*, Fcall*, char*),
	*rauth(Fcall*, Fcall*, char*),
	*rattach(Fcall*, Fcall*, char*),
	*rwalk(Fcall*, Fcall*, char*),
	*ropen(Fcall*, Fcall*, char*),
	*rcreate(Fcall*, Fcall*, char*),
	*rread(Fcall*, Fcall*, char*),
	*rwrite(Fcall*, Fcall*, char*),
	*rclunk(Fcall*, Fcall*, char*),
	*rremove(Fcall*, Fcall*, char*),
	*rstat(Fcall*, Fcall*, char*),
	*rwstat(Fcall*, Fcall*, char*);

char 	*(*fcalls[])(Fcall*, Fcall*, char*) = {
	[Tversion]	rversion,
	[Tflush]	rflush,
	[Tauth]	rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char Etoolong[] = "name too long";

void	connect(int, char*);
void	post(int, char*);
void	serve(void);
void	demux(void);
void*	emalloc(ulong);
char*	transact9p1(Fcall9p1*, Fcall9p1*, char*);
Fid*	newfid(int);

struct
{
	char	chal[CHALLEN];		/* my challenge */
	char	rchal[CHALLEN];		/* his challenge */
	char	authid[NAMEREC];
	char	authdom[DOMLEN];
	int	id;
} ai;

void
usage(void)
{
	fprint(2, "usage: srvold9p [-abcCd] [-u user] [-s | [-m mountpoint]] [-x 'command' | -n network-addr | -f file] [-F] [-p servicename]\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	int method;
	char *oldstring;
	char *mountpoint, *postname;
	int mountflag, mountfd;
	int p[2];
int i;

	fmtinstall('F', fcallfmt);
	fmtinstall('G', fcallfmt9p1);
	fmtinstall('D', dirfmt);

	user = getuser();
	mountpoint = nil;
	mountflag = 0;
	postname = nil;
	oldstring = nil;
	method = -1;
	mountfd = -1;

	ARGBEGIN{
	case 'a':
		mountflag |= MAFTER;
		break;
	case 'b':
		mountflag |= MBEFORE;
		break;
	case 'c':
		mountflag |= MCREATE;
		break;
	case 'C':
		mountflag |= MCACHE;
		break;
	case 'd':
		debug++;
		break;
	case 'f':
		method = File;
		oldstring = ARGF();
		break;
	case 'F':
		dofcall++;
		break;
	case 'm':
		mountpoint = EARGF(usage());
		break;
	case 'n':
		method = Network;
		oldstring = ARGF();
		break;
	case 'p':
		postname = ARGF();
		if(postname == nil)
			usage();
		break;
	case 's':
		method = Stdio;
		break;
	case 'u':
		user = EARGF(usage());
		break;
	case 'x':
		method = Command;
		oldstring = ARGF();
		break;
	default:
		usage();
	}ARGEND;

	if(method == Stdio){
		if(mountpoint!=nil || argc!=0)
			usage();
	}else{
		if(oldstring == nil || argc != 0 || (mountflag!=0 &amp;&amp; mountpoint==nil))
			usage();
	}

	rfork(RFNOTEG|RFREND);

	connect(method, oldstring);

	if(method == Stdio)
		newfd = 0;
	else{
		if(pipe(p) &lt; 0)
			fatal("pipe: %r");
		if(postname != nil)
			post(p[0], postname);
		mountfd = p[0];
		newfd = p[1];
	}
	if(debug)
		fprint(2, "connected and posted\n");

	switch(rfork(RFPROC|RFMEM|RFNAMEG|RFFDG)){
	case 0:
		mainpid = getpid();
		/* child does all the work */
		if(mountfd &gt;= 0)
			close(mountfd);
		switch(rfork(RFPROC|RFMEM|RFFDG)){
		case 0:
			for(i = 0; i &lt; 20; i++)
				if (i != roldfd) close(i);
			demux();
			return;
		case -1:
			fatal("fork error: %r");
			break;
		}
		for(i = 0; i &lt; 20; i++)
			if (i != newfd &amp;&amp; i != woldfd &amp;&amp; (debug == 0 || i != 2)) close(i);
		serve();
		break;
	case -1:
		fatal("fork error: %r");
		break;
	default:
		/* parent mounts if required, then exits */
		if(mountpoint){
			if(mount(mountfd, -1, mountpoint, mountflag, "") &lt; 0)
				fatal("can't mount: %r");
		}
		break;
	}
	exits(nil);
}

void
connect(int method, char *oldstring)
{
	char *s;
	char dir[256];

	switch(method){
	default:
		roldfd = -1;
		woldfd = -1;
		fatal("can't handle method type %d", method);
		break;
	case Network:
		s = netmkaddr(oldstring, 0, "9fs");
		roldfd = dial(s, 0, dir, 0);
		if(roldfd &lt; 0)
			fatal("dial %s: %r", s);
		woldfd = roldfd;
		if(dofcall)
			roldfd = fcall(woldfd);
		break;
	case File:
		roldfd = open(oldstring, ORDWR);
		if(roldfd &lt; 0)
			fatal("can't open %s: %r", oldstring);
		woldfd = roldfd;
		if(dofcall)
			roldfd = fcall(woldfd);
		break;
	case Stdio:
		roldfd = fcall(1);
		woldfd = 1;
		break;
	}
}

void
post(int fd, char *srv)
{
	int f;
	char buf[128];

	snprint(buf, sizeof buf, "/srv/%s", srv);
	f = create(buf, OWRITE, 0666);
	if(f &lt; 0)
		fatal("can't create %s: %r", buf);
	sprint(buf, "%d", fd);
	if(write(f, buf, strlen(buf)) != strlen(buf))
		fatal("post write: %r");
	close(f);
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	qlock(&amp;fidlock);
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid){
			f-&gt;allocated = 1;
			qunlock(&amp;fidlock);
			return f;
		}
		else if(!ff &amp;&amp; !f-&gt;allocated)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		ff-&gt;allocated = 1;
		qunlock(&amp;fidlock);
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = fids;
	f-&gt;allocated = 1;
	fids = f;
	qunlock(&amp;fidlock);
	return f;
}

/*
 * Reads returning 9P1 messages and demultiplexes them.
 * BUG: assumes one read per message.
 */
void
demux(void)
{
	int m, n;
	char *data;
	Fcall9p1 r;
	Message *msg;
	Tag *t;

	for(;;){
		data = malloc(IOHDRSZ+Maxfdata);	/* no need to clear memory */
		if(data == nil)
			fatal("demux malloc: %r");
		m = read(roldfd, data, IOHDRSZ+Maxfdata);
		if(m &lt;= 0)
			fatal("read error talking to old system: %r");
		n = convM2S9p1(data, &amp;r, m);
		if(n == 0)
			fatal("bad conversion receiving from old system");
		if(debug)
			fprint(2, "srvold9p:&lt;=%G\n", &amp;r);
		qlock(&amp;taglock);
		for(t=tags; t!=nil; t=t-&gt;next)
			if(t-&gt;tag == r.tag){
				t-&gt;received = 1;
				break;
			}
		qunlock(&amp;taglock);
		/*
		 * Fcall9p1 tag is used to rendezvous.
		 * Recipient converts message a second time, but that's OK.
		 */
		msg = emalloc(sizeof(Message));
		msg-&gt;data = data;
		msg-&gt;n = n;
		rendezvous((void*)r.tag, msg);
	}
}

Tag*
newtag(int tag)
{
	Tag *t;

	t = emalloc(sizeof(Tag));
	t-&gt;tag = tag;
	t-&gt;flushed = 0;
	t-&gt;received = 0;
	t-&gt;ref = 1;
	qlock(&amp;taglock);
	t-&gt;next = tags;
	tags = t;
	qunlock(&amp;taglock);
	return t;
}

void
freetag(Tag *tag)	/* called with taglock set */
{
	Tag *t, *prev;

	if(tag-&gt;ref-- == 1){
		prev = nil;
		for(t=tags; t!=nil; t=t-&gt;next){
			if(t == tag){
				if(prev == nil)
					tags = t-&gt;next;
				else
					prev-&gt;next = t-&gt;next;
				break;
			}
			prev = t;
		}
		if(t == nil)
			sysfatal("freetag");
		free(tag);
	}
}

void
serve(void)
{
	char *err;
	int n;
	Fcall thdr;
	Fcall	rhdr;
	uchar mdata[IOHDRSZ+Maxfdata];
	char mdata9p1[IOHDRSZ+Maxfdata];
	Tag *tag;

	for(;;){
		qlock(&amp;servelock);
		for(;;){
			n = read9pmsg(newfd, mdata, sizeof mdata);

			if(n == 0)
				continue;
			if(n &lt; 0)
				break;
			if(n &gt; 0 &amp;&amp; convM2S(mdata, n, &amp;thdr) &gt; 0)
				break;
		}
		if(n&gt;0 &amp;&amp; servelock.head==nil)	/* no other processes waiting to read */
			switch(rfork(RFPROC|RFMEM)){
			case 0:
				/* child starts serving */
				continue;
				break;
			case -1:
				fatal("fork error: %r");
				break;
			default:
				break;
			}
		qunlock(&amp;servelock);

		if(n &lt; 0)
			fatal(nil);	/* exit quietly; remote end has just hung up */

		if(debug)
			fprint(2, "srvold9p:&lt;-%F\n", &amp;thdr);

		tag = newtag(thdr.tag);

		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(&amp;thdr, &amp;rhdr, mdata9p1);

		qlock(&amp;taglock);
		if(tag-&gt;flushed){
			freetag(tag);
			qunlock(&amp;taglock);
			continue;
		}
		qunlock(&amp;taglock);

		if(err){
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		if(debug)
			fprint(2, "srvold9p:-&gt;%F\n", &amp;rhdr);/**/
		n = convS2M(&amp;rhdr, mdata, sizeof mdata);
		if(n == 0)
			fatal("convS2M error on write");
		if(write(newfd, mdata, n) != n)
			fatal("mount write");

		qlock(&amp;taglock);
		freetag(tag);
		qunlock(&amp;taglock);
	}
}

void
send9p1(Fcall9p1 *t, char *data)
{
	int m, n;

	if(debug)
		fprint(2, "srvold9p:=&gt;%G\n", t);
	n = convS2M9p1(t, data);
	if(n == 0)
		fatal("bad conversion sending to old system");
	m = write(woldfd, data, n);
	if(m != n)
		fatal("wrote %d to old system; should be %d", m, n);
}

int
recv9p1(Fcall9p1 *r, int tag, char *data)
{
	int n;
	Message *msg;

	msg = rendezvous((void*)tag, 0);
	if(msg == (void*)~0)
		fatal("rendezvous: %r");
	if(msg == nil){
		if(debug)
			fprint(2, "recv flushed\n");
		return -1;
	}
	/* copy data to local buffer */
	memmove(data, msg-&gt;data, msg-&gt;n);
	n = convM2S9p1(data, r, msg-&gt;n);
	if(n == 0)
		fatal("bad conversion receiving from old system");
	free(msg-&gt;data);
	free(msg);
	return 1;
}

char*
transact9p1(Fcall9p1 *t, Fcall9p1 *r, char *mdata9p1)
{
	send9p1(t, mdata9p1);
	if(recv9p1(r, t-&gt;tag, mdata9p1) &lt; 0)
		return FLUSHED;
	if(r-&gt;type == Rerror9p1)
		return r-&gt;ename;
	if(r-&gt;type != t-&gt;type+1)
		fatal("bad message type; expected %d got %d", t-&gt;type+1, r-&gt;type);
	return nil;
}

char*
rflush(Fcall *t, Fcall *, char *mdata9p1)
{
	Fcall9p1 t9, r9;
	Tag *oldt;

	t9.type = Tflush9p1;
	t9.tag = t-&gt;tag;
	t9.oldtag = t-&gt;oldtag;
	qlock(&amp;taglock);
	for(oldt=tags; oldt!=nil; oldt=oldt-&gt;next)
		if(oldt-&gt;tag == t-&gt;oldtag){
			oldt-&gt;flushed = 1;
			oldt-&gt;ref++;
			break;
		}
	qunlock(&amp;taglock);

	if(oldt == nil){	/* nothing to flush */
		if(debug)
			fprint(2, "no such tag to flush\n");
		return 0;
	}

	transact9p1(&amp;t9, &amp;r9, mdata9p1);	/* can't error */

	qlock(&amp;taglock);
	if(oldt-&gt;received == 0){	/* wake up receiver */
		if(debug)
			fprint(2, "wake up receiver\n");
		oldt-&gt;received = 1;
		rendezvous((void*)t-&gt;oldtag, 0);
	}
	freetag(oldt);
	qunlock(&amp;taglock);
	return 0;
}

char*
rversion(Fcall *t, Fcall *r, char*)
{
	Fid *f;

	/* just ack; this one doesn't go to old service */
	if(t-&gt;msize &gt; IOHDRSZ+Maxfdata)
		r-&gt;msize = IOHDRSZ+Maxfdata;
	else
		r-&gt;msize = t-&gt;msize;
	if(strncmp(t-&gt;version, "9P2000", 6) != 0)
		return "unknown 9P version";
	r-&gt;version = "9P2000";

	qlock(&amp;fidlock);
	for(f = fids; f; f = f-&gt;next){
		f-&gt;busy = 0;
		f-&gt;allocated = 0;
	}
	qunlock(&amp;fidlock);

	return 0;
}

char*
rauth(Fcall *, Fcall *, char *)
{
	return "srvold9p: authentication not supported";
}

#ifdef asdf

void
memrandom(void *p, int n)
{
	ulong *lp;
	uchar *cp;

	for(lp = p; n &gt;= sizeof(ulong); n -= sizeof(ulong))
		*lp++ = fastrand();
	for(cp = (uchar*)lp; n &gt; 0; n--)
		*cp++ = fastrand();
}

char*
rsession(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	t9.type = Tsession9p1;
	t9.tag = t-&gt;tag;
	if(doauth)
		memrandom(t9.chal, sizeof t9.chal);
	else
		memset(t9.chal, 0, sizeof t9.chal);
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	qlock(&amp;fidlock);
	for(f = fids; f; f = f-&gt;next){
		f-&gt;busy = 0;
		f-&gt;allocated = 0;
	}
	qunlock(&amp;fidlock);

	if(doauth){
		memmove(ai.authid, r9.authid, sizeof ai.authid);
		memmove(ai.authdom, r9.authdom, sizeof ai.authid);
		memmove(ai.rchal, r9.chal, sizeof ai.rchal);
		memmove(ai.chal, t9.chal, sizeof ai.chal);
		r-&gt;authid = ai.authid;
		r-&gt;authdom = ai.authdom;
		r-&gt;chal = (uchar*)ai.rchal;
		r-&gt;nchal = CHALLEN;
	} else {
		r-&gt;authid = "";
		r-&gt;authdom = "";
		r-&gt;nchal = 0;
		r-&gt;chal = nil;
	}
	return 0;
}
#endif

char*
rattach(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(f-&gt;busy)
		return "attach: fid in use";
	/* no authentication! */
	t9.type = Tattach9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	strncpy(t9.uname, t-&gt;uname, NAMEREC);
	if(strcmp(user, "none") == 0)
		strncpy(t9.uname, user, NAMEREC);
	strncpy(t9.aname, t-&gt;aname, NAMEREC);
	memset(t9.ticket, 0, sizeof t9.ticket);
	memset(t9.auth, 0, sizeof t9.auth);
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	r-&gt;qid.path = r9.qid.path &amp; ~0x80000000;
	r-&gt;qid.vers = r9.qid.version;
	r-&gt;qid.type = QTDIR;
	f-&gt;busy = 1;
	f-&gt;qid = r-&gt;qid;
	return 0;
}

char*
rwalk(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	int i, fid;
	Qid *q;
	Fid *f, *nf;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "walk: bad fid";

	fid = t-&gt;fid;
	nf = nil;
	if(t-&gt;fid != t-&gt;newfid){
		nf = newfid(t-&gt;newfid);
		if(nf-&gt;busy)
			return "walk: newfid in use";
		t9.type = Tclone9p1;
		t9.tag = t-&gt;tag;
		t9.fid = t-&gt;fid;
		t9.newfid = t-&gt;newfid;
		err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
		if(err){
			nf-&gt;busy = 0;
			nf-&gt;allocated = 0;
			return err;
		}
		fid = t-&gt;newfid;
		nf-&gt;busy = 1;
	}

	err = nil;
	r-&gt;nwqid = 0;
	for(i=0; i&lt;t-&gt;nwname &amp;&amp; err==nil; i++){
		if(i &gt; MAXWELEM)
			break;
		t9.type = Twalk9p1;
		t9.tag = t-&gt;tag;
		t9.fid = fid;
		strncpy(t9.name, t-&gt;wname[i], NAMEREC);
		err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
		if(err == FLUSHED){
			i = -1;	/* guarantee cleanup */
			break;
		}
		if(err == nil){
			q = &amp;r-&gt;wqid[r-&gt;nwqid++];
			q-&gt;type = QTFILE;
			if(r9.qid.path &amp; 0x80000000)
				q-&gt;type = QTDIR;
			q-&gt;vers = r9.qid.version;
			q-&gt;path = r9.qid.path &amp; ~0x80000000;
		}
	}

	if(nf!=nil &amp;&amp; (err!=nil || i&lt;t-&gt;nwname)){
		/* clunk the new fid */
		t9.type = Tclunk9p1;
		t9.tag = t-&gt;tag;
		t9.fid = t-&gt;newfid;
		transact9p1(&amp;t9, &amp;r9, mdata9p1);
		/* ignore more errors */
		nf-&gt;busy = 0;
		nf-&gt;allocated = 0;
	}

	if(i&gt;0 &amp;&amp; i==t-&gt;nwname &amp;&amp; err==nil)
		f-&gt;qid = r-&gt;wqid[r-&gt;nwqid-1];
	if(i &gt; 0)
		return 0;
	return err;
}

char*
ropen(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "open: bad fid";

	t9.type = Topen9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	t9.mode = t-&gt;mode;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	r-&gt;qid.path = r9.qid.path &amp; ~0x80000000;
	r-&gt;qid.vers = r9.qid.version;
	r-&gt;qid.type = QTFILE;
	if(r9.qid.path &amp; 0x80000000)
		r-&gt;qid.type = QTDIR;
	f-&gt;qid = r-&gt;qid;
	f-&gt;newoffset = 0;
	f-&gt;oldoffset = 0;
	r-&gt;iounit = 0;
	return 0;
}

char*
rcreate(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "create: bad fid";

	t9.type = Tcreate9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	if(strlen(t-&gt;name)+1 &gt;= NAMEREC)
		return "file name element too long";
	strncpy(t9.name, t-&gt;name, NAMEREC);
	t9.perm = t-&gt;perm;
	t9.mode = t-&gt;mode;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	r-&gt;qid.path = r9.qid.path &amp; ~0x80000000;
	r-&gt;qid.vers = r9.qid.version;
	r-&gt;qid.type = QTFILE;
	if(r9.qid.path &amp; 0x80000000)
		r-&gt;qid.type = QTDIR;
	if(r9.qid.path &amp; 0x40000000)
		r-&gt;qid.type |= QTAPPEND;
	if(r9.qid.path &amp; 0x20000000)
		r-&gt;qid.type |= QTEXCL;
	f-&gt;qid = r-&gt;qid;
	r-&gt;iounit = 0;
	return 0;
}

char*
dirrread(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;
	int i, ndir, n, count;
	Dir d;
	uchar buf[Maxfdata];
	char *old;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "dirread: bad fid";

	if(f-&gt;newoffset != t-&gt;offset)
		return "seek in directory disallowed";

	t9.type = Tread9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	t9.offset = f-&gt;oldoffset;
	t9.count = t-&gt;count;	/* new directories tend to be smaller, so this may overshoot */
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	ndir = r9.count/DIRREC;
	old = r9.data;
	count = 0;
	for(i=0; i&lt;ndir; i++){
		if(convM2D9p1(old, &amp;d) != DIRREC)
			return "bad dir conversion in read";
		n = convD2M(&amp;d, buf+count, sizeof buf-count);
		if(n&lt;=BIT16SZ || count+n&gt;t-&gt;count)
			break;
		old += DIRREC;
		f-&gt;oldoffset += DIRREC;
		f-&gt;newoffset += n;
		count += n;
	}
	memmove(r9.data, buf, count);	/* put it back in stable storage */
	r-&gt;data = r9.data;
	r-&gt;count = count;
	return 0;
}

char*
rread(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "read: bad fid";

	if(f-&gt;qid.type &amp; QTDIR)
		return dirrread(t, r, mdata9p1);

	t9.type = Tread9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	t9.offset = t-&gt;offset;
	t9.count = t-&gt;count;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	r-&gt;count = r9.count;
	r-&gt;data = r9.data;	/* points to stable storage */
	return 0;
}

char*
rwrite(Fcall *t, Fcall *r, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "write: bad fid";

	t9.type = Twrite9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	t9.offset = t-&gt;offset;
	t9.count = t-&gt;count;
	t9.data = t-&gt;data;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	r-&gt;count = r9.count;
	return 0;
}

char*
rclunk(Fcall *t, Fcall *, char *mdata9p1)
{
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "clunk: bad fid";
	t9.type = Tclunk9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	transact9p1(&amp;t9, &amp;r9, mdata9p1);
	f-&gt;busy = 0;
	f-&gt;allocated = 0;
	/* disregard error */
	return 0;
}

char*
rremove(Fcall *t, Fcall*, char *mdata9p1)
{
	char *err;
	Fcall9p1 t9, r9;
	Fid *f;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "remove: bad fid";
	t9.type = Tremove9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	f-&gt;busy = 0;
	f-&gt;allocated = 0;
	return err;
}

char*
rstat(Fcall *t, Fcall *r, char *mdata9p1)
{
	Fcall9p1 t9, r9;
	char *err;
	Fid *f;
	Dir d;
	uchar buf[256];	/* big enough; there's no long names */

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "stat: bad fid";

	t9.type = Tstat9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;

	if(convM2D9p1(r9.stat, &amp;d) != DIRREC)
		return "bad conversion in stat";
	r-&gt;stat = buf;
	r-&gt;nstat = convD2M(&amp;d, buf, sizeof buf);
	return 0;
}

int
anydefault(Dir *d)
{
	if(d-&gt;name[0] == '\0')
		return 1;
	if(d-&gt;uid[0] == '\0')
		return 1;
	if(d-&gt;gid[0] == '\0')
		return 1;
	if(d-&gt;mode == ~0)
		return 1;
	if(d-&gt;mtime == ~0)
		return 1;
	return 0;
}

char*
rwstat(Fcall *t, Fcall *, char *mdata9p1)
{
	Fcall9p1 t9, r9;
	char strs[DIRREC];
	char *err;
	Fid *f;
	Dir d, cd;

	f = newfid(t-&gt;fid);
	if(!f-&gt;busy)
		return "wstat: bad fid";

	convM2D(t-&gt;stat, t-&gt;nstat, &amp;d, strs);
	cd = d;
	if(anydefault(&amp;d)){
		/* must first stat file so we can copy current values */
		t9.type = Tstat9p1;
		t9.tag = t-&gt;tag;
		t9.fid = t-&gt;fid;
		err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
		if(err)
			return err;
		if(convM2D9p1(r9.stat, &amp;cd) != DIRREC)
			return "bad in conversion in wstat";
	
		/* fill in default values */
		if(d.name[0] != '\0'){
			if(strlen(d.name) &gt;= NAMEREC)
				return Etoolong;
			cd.name = d.name;
		}
		if(d.uid[0] != '\0'){
			if(strlen(d.uid) &gt;= NAMEREC)
				return Etoolong;
			cd.uid = d.uid;
		}
		if(d.gid[0] != '\0'){
			if(strlen(d.gid) &gt;= NAMEREC)
				return Etoolong;
			cd.gid = d.gid;
		}
		if(d.mode != ~0)
			cd.mode = d.mode;
		if(d.mtime != ~0)
			cd.mtime = d.mtime;
		if(d.length != ~0LL)
			cd.length = d.length;
	}

	if(convD2M9p1(&amp;cd, t9.stat) != DIRREC)
		return "bad out conversion in wstat";

	t9.type = Twstat9p1;
	t9.tag = t-&gt;tag;
	t9.fid = t-&gt;fid;
	err = transact9p1(&amp;t9, &amp;r9, mdata9p1);
	if(err)
		return err;
	return 0;
}

void *
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(!p)
		fatal("out of memory: %r");
	memset(p, 0, n);
	return p;
}

void
fatal(char *fmt, ...)
{
	char buf[1024];
	va_list arg;

	if(fmt){
		va_start(arg, fmt);
		vseprint(buf, buf+sizeof(buf), fmt, arg);
		va_end(arg);
		fprint(2, "%s: (pid %d) %s\n", argv0, getpid(), buf);
	}else
		buf[0] = '\0';
	if(mainpid){
		/* two hits are sometimes needed */
		postnote(PNGROUP, mainpid, "die1 - from srvold9p");
		postnote(PNGROUP, mainpid, "die2 - from srvold9p");
	}
	exits(buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

