<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ssh1/util.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ssh1/util.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "ssh.h"
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;

char Edecode[] = "error decoding input packet";
char Eencode[] = "out of space encoding output packet (BUG)";
char Ehangup[] = "hungup connection";
char Ememory[] = "out of memory";

int debuglevel;
int doabort;

void
error(char *fmt, ...)
{
	va_list arg;
	char buf[2048];

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	fprint(2, "%s: %s\n", argv0, buf);
	if(doabort)
		abort();
	exits(buf);
}

void
debug(int level, char *fmt, ...)
{
	va_list arg;

	if((level&amp;debuglevel) == 0)
		return;
	va_start(arg, fmt);
	vfprint(2, fmt, arg);
	va_end(arg);
}

void*
emalloc(long n)
{
	void *a;

	a = mallocz(n, 1);
	if(a == nil)
		error(Ememory);
	setmalloctag(a, getcallerpc(&amp;n));
	return a;
}

void*
erealloc(void *v, long n)
{
	v = realloc(v, n);
	if(v == nil)
		error(Ememory);
	setrealloctag(v, getcallerpc(&amp;v));
	return v;
}


static int killpid[32];
static int nkillpid;
void
atexitkiller(void)
{
	int i, pid;

	pid = getpid();
	debug(DBG, "atexitkiller: nkillpid=%d mypid=%d\n", nkillpid, pid);
	for(i=0; i&lt;nkillpid; i++)
		if(pid != killpid[i]){
			debug(DBG, "killing %d\n", killpid[i]);
			postnote(PNPROC, killpid[i], "kill");
		}
}
void
atexitkill(int pid)
{
	killpid[nkillpid++] = pid;
}

int
readstrnl(int fd, char *buf, int nbuf)
{
	int i;

	for(i=0; i&lt;nbuf; i++){
		switch(read(fd, buf+i, 1)){
		case -1:
			return -1;
		case 0:
			werrstr("unexpected EOF");
			return -1;
		default:
			if(buf[i]=='\n'){
				buf[i] = '\0';
				return 0;
			}
			break;
		}
	}
	werrstr("line too long");
	return -1;
}

void
calcsessid(Conn *c)
{
	int n;
	uchar buf[1024];

	n = mptobe(c-&gt;hostkey-&gt;n, buf, sizeof buf, nil);
	n += mptobe(c-&gt;serverkey-&gt;n, buf+n, sizeof buf-n, nil);
	memmove(buf+n, c-&gt;cookie, COOKIELEN);
	n += COOKIELEN;
	md5(buf, n, c-&gt;sessid, nil);
}

void
sshlog(char *f, ...)
{
	char *s;
	va_list arg;
	Fmt fmt;
	static int pid;

	if(pid == 0)
		pid = getpid();

	va_start(arg, f);
	va_end(arg);

	if(fmtstrinit(&amp;fmt) &lt; 0)
		sysfatal("fmtstrinit: %r");

	fmtprint(&amp;fmt, "[%d] ", pid);
	fmtvprint(&amp;fmt, f, arg);

	s = fmtstrflush(&amp;fmt);
	if(s == nil)
		sysfatal("fmtstrflush: %r");
	syslog(0, "ssh", "%s", s);
	free(s);
}

/*
 * this is far too smart.
 */
static int
pstrcmp(const void *a, const void *b)
{
	return strcmp(*(char**)a, *(char**)b);
}

static char*
trim(char *s)
{
	char *t;
	int i, last, n, nf;
	char **f;
	char *p;

	t = emalloc(strlen(s)+1);
	t[0] = '\0';
	n = 1;
	for(p=s; *p; p++)
		if(*p == ' ')
			n++;
	f = emalloc((n+1)*sizeof(f[0]));
	nf = tokenize(s, f, n+1);
	qsort(f, nf, sizeof(f[0]), pstrcmp);
	last=-1;
	for(i=0; i&lt;nf; i++){
		if(last==-1 || strcmp(f[last], f[i])!=0){
			if(last &gt;= 0)
				strcat(t, ",");
			strcat(t, f[i]);
			last = i;
		}
	}
	return t;	
}

static void
usetuple(Conn *c, Ndbtuple *t, int scanentries)
{
	int first;
	Ndbtuple *l, *e;
	char *s;

	first=1;
	s = c-&gt;host;
	for(l=t; first||l!=t; l=l-&gt;line, first=0){
		if(scanentries){
			for(e=l; e; e=e-&gt;entry){
				if(strcmp(e-&gt;val, c-&gt;host) != 0 &amp;&amp;
				  (strcmp(e-&gt;attr, "ip")==0 || strcmp(e-&gt;attr, "dom")==0 || strcmp(e-&gt;attr, "sys")==0)){
					s = smprint("%s %s", s, e-&gt;val);
					if(s == nil)
						error("out of memory");
				}
			}
		}
		if(strcmp(l-&gt;val, c-&gt;host) != 0 &amp;&amp;
		  (strcmp(l-&gt;attr, "ip")==0 || strcmp(l-&gt;attr, "dom")==0 || strcmp(l-&gt;attr, "sys")==0)){
			s = smprint("%s %s", s, l-&gt;val);
			if(s == nil)
				error("out of memory");
		}
	}
	s = trim(s);
	c-&gt;aliases = s;
}

void
setaliases(Conn *c, char *name)
{
	char *p, *net;
	char *attr[2];
	Ndbtuple *t;

	net = "/net";
	if(name[0]=='/'){
		p = strchr(name+1, '/');
		if(p){
			net = emalloc(p-name+1);
			memmove(net, name, p-name);
		}
	}
	if(p = strchr(name, '!'))
		name = p+1;

	c-&gt;host = emalloc(strlen(name)+1);
	strcpy(c-&gt;host, name);

	c-&gt;aliases = c-&gt;host;
	attr[0] = "dom";
	attr[1] = "ip";
	t = csipinfo(nil, ipattr(name), name, attr, 2);
	if(t != nil){
		usetuple(c, t, 0);
		ndbfree(t);
	}else{
		t = dnsquery(net, name, "ip");
		if(t != nil){
			usetuple(c, t, 1);
			ndbfree(t);
		}
	}
}

void
privatefactotum(void)
{
	char *user;
	Dir *d;

	if((user=getuser()) &amp;&amp; (d=dirstat("/mnt/factotum/rpc")) &amp;&amp; strcmp(user, d-&gt;uid)!=0){
		/* grab the terminal's factotum */
		rfork(RFNAMEG);	/* was RFNOTEG, which makes little sense */
		if(access("/mnt/term/mnt/factotum", AEXIST) &gt;= 0){
//			fprint(2, "binding terminal's factotum\n");
			if(bind("/mnt/term/mnt/factotum", "/mnt/factotum", MREPL) &lt; 0)
				sysfatal("cannot find factotum");
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

