<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ssh2/transport.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ssh2/transport.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;mp.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;libsec.h&gt;
#include &lt;ip.h&gt;
#include "netssh.h"

extern Cipher *cryptos[];

Packet *
new_packet(Conn *c)
{
	Packet *p;

	p = emalloc9p(sizeof(Packet));
	init_packet(p);
	p-&gt;c = c;
	return p;
}

void
init_packet(Packet *p)
{
	memset(p, 0, sizeof(Packet));
	p-&gt;rlength = 1;
}

void
add_byte(Packet *p, char c)
{
	p-&gt;payload[p-&gt;rlength-1] = c;
	p-&gt;rlength++;
}

void
add_uint32(Packet *p, ulong l)
{
	hnputl(p-&gt;payload+p-&gt;rlength-1, l);
	p-&gt;rlength += 4;
}

ulong
get_uint32(Packet *, uchar **data)
{
	ulong x;
	x = nhgetl(*data);
	*data += 4;
	return x;
}

int
add_packet(Packet *p, void *data, int len)
{
	if(p-&gt;rlength + len &gt; Maxpayload)
		return -1;
	memmove(p-&gt;payload + p-&gt;rlength - 1, data, len);
	p-&gt;rlength += len;
	return 0;
}

void
add_block(Packet *p, void *data, int len)
{
	hnputl(p-&gt;payload + p-&gt;rlength - 1, len);
	p-&gt;rlength += 4;
	add_packet(p, data, len);
}

void 
add_string(Packet *p, char *s)
{
	uchar *q;
	int n;
	uchar nn[4];

	n = strlen(s);
	hnputl(nn, n);
	q = p-&gt;payload + p-&gt;rlength - 1;
	memmove(q, nn, 4);
	memmove(q+4, s, n);
	p-&gt;rlength += n + 4;
}

uchar *
get_string(Packet *p, uchar *q, char *s, int lim, int *len)
{
	int n, m;

	if (p &amp;&amp; q &gt; p-&gt;payload + p-&gt;rlength)
		s[0] = '\0';
	m = nhgetl(q);
	q += 4;
	if(m &lt; lim)
		n = m;
	else
		n = lim - 1;
	memmove(s, q, n);
	s[n] = '\0';
	q += m;
	if(len)
		*len = n;
	return q;
}

void
add_mp(Packet *p, mpint *x)
{
	uchar *q;
	int n;

	q = p-&gt;payload + p-&gt;rlength - 1;
	n = mptobe(x, q + 4, Maxpktpay - p-&gt;rlength + 1 - 4, nil);
	if(q[4] &amp; 0x80){
		memmove(q + 5, q + 4, n);
		q[4] = 0;
		n++;
	}
	hnputl(q, n);
	p-&gt;rlength += n + 4;
}

mpint *
get_mp(uchar *q)
{
	return betomp(q + 4, nhgetl(q), nil);
}

int
finish_packet(Packet *p)
{
	Conn *c;
	uchar *q, *buf;
	int blklen, i, n2, n1, maclen;

	c = p-&gt;c;
	blklen = 8;
	if(c &amp;&amp; debug &gt; 1)
		fprint(2, "%s: in finish_packet: enc %d outmac %d len %ld\n",
			argv0, c-&gt;encrypt, c-&gt;outmac, p-&gt;rlength);
	if(c &amp;&amp; c-&gt;encrypt != -1){
		blklen = cryptos[c-&gt;encrypt]-&gt;blklen;
		if(blklen &lt; 8)
			blklen = 8;
	}
	n1 = p-&gt;rlength - 1;
	n2 = blklen - (n1 + 5) % blklen;
	if(n2 &lt; 4)
		n2 += blklen;
	p-&gt;pad_len = n2;
	for(i = 0, q = p-&gt;payload + n1; i &lt; n2; ++i, ++q)
		*q = fastrand();
	p-&gt;rlength = n1 + n2 + 1;
	hnputl(p-&gt;nlength, p-&gt;rlength);
	maclen = 0;
	if(c &amp;&amp; c-&gt;outmac != -1){
		maclen = SHA1dlen;
		buf = emalloc9p(Maxpktpay);
		hnputl(buf, c-&gt;outseq);
		memmove(buf + 4, p-&gt;nlength, p-&gt;rlength + 4);
		hmac_sha1(buf, p-&gt;rlength + 8, c-&gt;outik, maclen, q, nil);
		free(buf);
	}
	if(c &amp;&amp; c-&gt;encrypt != -1)
		cryptos[c-&gt;encrypt]-&gt;encrypt(c-&gt;enccs, p-&gt;nlength, p-&gt;rlength + 4);
	if (c)
		c-&gt;outseq++;
	if(debug &gt; 1)
		fprint(2, "%s: leaving finish packet: len %ld n1 %d n2 %d maclen %d\n",
			argv0, p-&gt;rlength, n1, n2, maclen);
	return p-&gt;rlength + 4 + maclen;
}

/*
 * The first blklen bytes are already decrypted so we could find the
 * length.
 */
int
undo_packet(Packet *p)
{
	Conn *c;
	long nlength;
	int nb;
	uchar rmac[SHA1dlen], *buf;

	c = p-&gt;c;
	nb = 4;
	if(c-&gt;decrypt != -1)
		nb = cryptos[c-&gt;decrypt]-&gt;blklen;
	if(c-&gt;inmac != -1)
		p-&gt;rlength -= SHA1dlen;			/* was magic 20 */
	nlength = nhgetl(p-&gt;nlength);
	if(c-&gt;decrypt != -1)
		cryptos[c-&gt;decrypt]-&gt;decrypt(c-&gt;deccs, p-&gt;nlength + nb,
			p-&gt;rlength + 4 - nb);
	if(c-&gt;inmac != -1){
		buf = emalloc9p(Maxpktpay);
		hnputl(buf, c-&gt;inseq);
		memmove(buf + 4, p-&gt;nlength, nlength + 4);
		hmac_sha1(buf, nlength + 8, c-&gt;inik, SHA1dlen, rmac, nil);
		free(buf);
		if(memcmp(rmac, p-&gt;payload + nlength - 1, SHA1dlen) != 0){
			fprint(2, "%s: received MAC verification failed: seq=%d\n",
				argv0, c-&gt;inseq);
			return -1;
		}
	}
	c-&gt;inseq++;
	p-&gt;rlength -= p-&gt;pad_len;
	p-&gt;pad_len = 0;
	return p-&gt;rlength - 1;
}

void
dump_packet(Packet *p)
{
	int i;
	char *buf, *q, *e;

	fprint(2, "Length: %ld, Padding length: %d\n", p-&gt;rlength, p-&gt;pad_len);
	q = buf = emalloc9p(Copybufsz);
	e = buf + Copybufsz;
	for(i = 0; i &lt; p-&gt;rlength - 1; ++i){
		q = seprint(q, e, " %02x", p-&gt;payload[i]);
		if(i % 16 == 15)
			q = seprint(q, e, "\n");
		if(q - buf &gt; Copybufsz - 4){
			fprint(2, "%s", buf);
			q = buf;
		}
	}
	fprint(2, "%s\n", buf);
	free(buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

