<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/strip.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/strip.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

void
error(char* fmt, ...)
{
	va_list arg;
	char *e, s[256];

	va_start(arg, fmt);
	e = seprint(s, s+sizeof(s), "%s: ", argv0);
	e = vseprint(e, s+sizeof(s), fmt, arg);
	e = seprint(e, s+sizeof(s), "\n");
	va_end(arg);

	write(2, s, e-s);
}

static void
usage(void)
{
	error("usage: %s -o ofile file\n\t%s file ...\n", argv0, argv0);
	exits("usage");
}

static int
strip(char* file, char* out)
{
	Dir *dir;
	int fd, i;
	Fhdr fhdr;
	Exec *exec;
	ulong mode;
	void *data;
	vlong length;

	if((fd = open(file, OREAD)) &lt; 0){
		error("%s: open: %r", file);
		return 1;
	}

	if(!crackhdr(fd, &amp;fhdr)){
		error("%s: %r", file);
		close(fd);
		return 1;
	}
	for(i = MIN_MAGIC; i &lt;= MAX_MAGIC; i++){
		if(fhdr.magic == _MAGIC(0, i) || fhdr.magic == _MAGIC(HDR_MAGIC, i))
			break;
	}
	if(i &gt; MAX_MAGIC){
		error("%s: not a recognizeable binary", file);
		close(fd);
		return 1;
	}

	if((dir = dirfstat(fd)) == nil){
		error("%s: stat: %r", file);
		close(fd);
		return 1;
	}

	length = fhdr.datoff+fhdr.datsz;
	if(length == dir-&gt;length){
		if(out == nil){	/* nothing to do */
			error("%s: already stripped", file);
			free(dir);
			close(fd);
			return 0;
		}
	}
	if(length &gt; dir-&gt;length){
		error("%s: strange length", file);
		close(fd);
		free(dir);
		return 1;
	}

	mode = dir-&gt;mode;
	free(dir);

	if((data = malloc(length)) == nil){
		error("%s: malloc failure", file);
		close(fd);
		return 1;
	}
	seek(fd, 0LL, 0);
	if(read(fd, data, length) != length){
		error("%s: read: %r", file);
		close(fd);
		free(data);
		return 1;
	}
	close(fd);

	exec = data;
	exec-&gt;syms = 0;
	exec-&gt;spsz = 0;
	exec-&gt;pcsz = 0;

	if(out == nil){
		if(remove(file) &lt; 0) {
			error("%s: remove: %r", file);
			free(data);
			return 1;
		}
		out = file;
	}
	if((fd = create(out, OWRITE, mode)) &lt; 0){
		error("%s: create: %r", out);
		free(data);
		return 1;
	}
	if(write(fd, data, length) != length){
		error("%s: write: %r", out);
		close(fd);
		free(data);
		return 1;
	}
	close(fd);
	free(data);

	return 0;
}

void
main(int argc, char* argv[])
{
	int r;
	char *p;

	p = nil;

	ARGBEGIN{
	default:
		usage();
		break;
	case 'o':
		p = ARGF();
		if(p == nil)
			usage();
		break;
	}ARGEND;

	switch(argc){
	case 0:
		usage();
		return;
	case 1:
		if(p != nil){
			r = strip(*argv, p);
			break;
		}
		/*FALLTHROUGH*/
	default:
		r = 0;
		while(argc &gt; 0){
			r |= strip(*argv, nil);
			argc--;
			argv++;
		}
		break;
	}

	if(r)
		exits("error");
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

