<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tarsplit/tarsplit.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tarsplit/tarsplit.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * tarsplit [-d] [-p pfx] [-s size] - split a tar archive into independent
 *	tar archives under some size
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include "tar.h"

enum {
	Stdin,
	Endsize	= 2 * Tblock,		/* size of zero blocks at archive end */
};

/* private data */
static char *filenm;
static char *prefix = "ts.";
static vlong size = 512*1024*1024;	/* fits on a CD with room to spare */

static int
opennext(int out, char *prefix)
{
	static int filenum = 0;

	if (out &gt;= 0) {
		fprint(2, "%s: opennext called with file open\n", argv0);
		exits("open botch");
	}
	free(filenm);
	filenm = smprint("%s%.5d", prefix, filenum++);
	fprint(2, "%s: %s ...", filenm, thisnm);
	out = create(filenm, OWRITE, 0666);
	if (out &lt; 0)
		sysfatal("%s: %r", filenm);
	newarch();
	return out;
}

static int
split(int in, int out, char * /* inname */)
{
	vlong len, membsz;
	uvlong outoff = 0;
	static Hblock hdr;
	Hblock *hp = &amp;hdr;

	while (getdir(hp, in, &amp;len)) {
		membsz = Tblock + ROUNDUP((uvlong)len, Tblock);
		if (outoff + membsz + Endsize &gt; size) {	/* won't fit? */
			out = closeout(out, filenm, 1);
			if (membsz + Endsize &gt; size)
				sysfatal("archive member %s (%,lld) + overhead "
					"exceeds size limit %,lld", hp-&gt;name,
					len, size);
		}
		if (out &lt; 0)
			out = opennext(out, prefix);
		/* write directory block */
		writetar(out, (char *)hp, Tblock);
		outoff = passtar(hp, in, out, len);
	}
	return out;
}

void
usage(void)
{
	fprint(2, "usage: %s [-p pfx] [-s size] [file]...\n", argv0);
	exits("usage");
}

void
main(int argc, char **argv)
{
	int out = -1;

	ARGBEGIN {
	case 'p':
		prefix = EARGF(usage());
		break;
	case 's':
		size = atoll(EARGF(usage()));
		if (size &lt; Tblock + Endsize)
			sysfatal("implausible max size of %lld bytes", size);
		break;
	default:
		usage();
	} ARGEND

	if (argc &lt;= 0)
		out = split(Stdin, out, "/fd/0");
	else
		for (; argc-- &gt; 0; argv++) {
			int in = open(argv[0], OREAD);

			if (in &lt; 0)
				sysfatal("%s: %r", argv[0]);
			out = split(in, out, argv[0]);
			close(in);
		}
	closeout(out, filenm, 1);
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

