<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tarsplit/tarsub.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tarsplit/tarsub.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * tar archive manipulation functions
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include "tar.h"

enum {
	Blocksxfr = 32,
};

/* exports */
char *thisnm, *lastnm;

/* private data */
static uvlong outoff = 0;		/* maintained by newarch, writetar */

unsigned
checksum(Hblock *hp)
{
	int i;
	uchar *cp, *csum, *end;

	i = ' ' * sizeof hp-&gt;chksum;	/* pretend blank chksum field */
	csum = (uchar *)hp-&gt;chksum;
	end = &amp;hp-&gt;dummy[Tblock];
	/*
	 * Unixware gets this wrong; it adds *signed* chars.
	 *	i += (Uflag? *(schar *)cp: *cp);
	 */
	for (cp = hp-&gt;dummy; cp &lt; csum; )
		i += *cp++;
	/* skip checksum field */
	for (cp += sizeof hp-&gt;chksum; cp &lt; end; )
		i += *cp++;
	return i;
}

void
readtar(int in, char *buffer, long size)
{
	int i;
	unsigned bytes;

	bytes = i = readn(in, buffer, size);
	if (i &lt;= 0)
		sysfatal("archive read error: %r");
	if (bytes % Tblock != 0)
		sysfatal("archive blocksize error");
	if (bytes != size) {
		/*
		 * buffering would be screwed up by only partially
		 * filling tbuf, yet this might be the last (short)
		 * record in a tar disk archive, so just zero the rest.
		 */
		fprint(2, "%s: warning: short archive block\n", argv0);
		memset(buffer + bytes, '\0', size - bytes);
	}
}

void
newarch(void)
{
	outoff = 0;
}

uvlong
writetar(int outf, char *buffer, ulong size)
{
	if (write(outf, buffer, size) &lt; size) {
		fprint(2, "%s: archive write error: %r\n", argv0);
		fprint(2, "%s: archive seek offset: %llud\n", argv0, outoff);
		exits("write");
	}
	outoff += size;
	return outoff;
}

ulong
otoi(char *s)
{
	int c;
	ulong ul = 0;

	while (isascii(*s) &amp;&amp; isspace(*s))
		s++;
	while ((c = *s++) &gt;= '0' &amp;&amp; c &lt;= '7') {
		ul &lt;&lt;= 3;
		ul |= c - '0';
	}
	return ul;
}

int
getdir(Hblock *hp, int in, vlong *lenp)
{
	*lenp = 0;
	readtar(in, (char*)hp, Tblock);
	if (hp-&gt;name[0] == '\0') { /* zero block indicates end-of-archive */
		lastnm = strdup(thisnm);
		return 0;
	}
	*lenp = otoi(hp-&gt;size);
	if (otoi(hp-&gt;chksum) != checksum(hp))
		sysfatal("directory checksum error");
	if (lastnm != nil)
		free(lastnm);
	lastnm = thisnm;
	thisnm = strdup(hp-&gt;name);
	return 1;
}

uvlong 
passtar(Hblock *hp, int in, int outf, vlong len)
{
	ulong bytes;
	vlong off;
	uvlong blks;
	char bigbuf[Blocksxfr*Tblock];		/* 2*(8192 == MAXFDATA) */

	off = outoff;
	if (islink(hp-&gt;linkflag))
		return off;
	for (blks = TAPEBLKS((uvlong)len); blks &gt;= Blocksxfr;
	    blks -= Blocksxfr) {
		readtar(in, bigbuf, sizeof bigbuf);
		off = writetar(outf, bigbuf, sizeof bigbuf);
	}
	if (blks &gt; 0) {
		bytes = blks*Tblock;
		readtar(in, bigbuf, bytes);
		off = writetar(outf, bigbuf, bytes);
	}
	return off;
}

void
putempty(int out)
{
	static char buf[Tblock];

	writetar(out, buf, sizeof buf);
}

/* emit zero blocks at end */
int
closeout(int outf, char *, int prflag)
{
	if (outf &lt; 0)
		return -1;
	putempty(outf);
	putempty(outf);
	if (lastnm &amp;&amp; prflag)
		fprint(2, " %s\n", lastnm);
	close(outf);		/* guaranteed to succeed on plan 9 */
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

