<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tcs/font/merge.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tcs/font/merge.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;libg.h&gt;
#include	&lt;bio.h&gt;

static void usage(void);
static void snarf(char *, int);
static void choose(Fontchar *, Bitmap *, int, int, int);
struct {
	char *name;
	Bitmap *bm;
	Subfont *sf;
} ft[1024];
int nf;

void
main(int argc, char **argv)
{
	int i, errs;
	Fontchar *fc;
	Bitmap *b;
	int nc, ht, as;
	Subfont *f;

	binit(0, 0, "font merge");
	if(argc &lt; 1)
		usage();
	nf = argc-1;
	for(i = 0; i &lt; nf; i++)
		snarf(argv[i+1], i);
	nc = ft[0].sf-&gt;n;
	ht = ft[0].sf-&gt;height;
	as = ft[0].sf-&gt;ascent;
	errs = 0;
	for(i = 0; i &lt; nf; i++){
		if(nc &lt; ft[i].sf-&gt;n) nc = ft[i].sf-&gt;n;
		if(ht != ft[1].sf-&gt;height){
			fprint(2, "%s: %s.height=%d (!= %s.height=%d)\n", argv[0],
				ft[i].name, ft[i].sf-&gt;height, ft[0].name, ht);
			errs = 1;
		}
		if(as != ft[1].sf-&gt;ascent){
			fprint(2, "%s: %s.ascent=%d (!= %s.ascent=%d)\n", argv[0],
				ft[i].name, ft[i].sf-&gt;ascent, ft[0].name, ht);
			errs = 1;
		}
	}
	if(errs)
		exits("param mismatch");
	fc = (Fontchar *)malloc(nc*sizeof(Fontchar));
	b = balloc(Rect(0, 0, nc*64, ht), ft[0].bm-&gt;ldepth);
	if(b == 0 || fc == 0){
		fprint(2, "%s: couldn't malloc %d chars\n", argv0, nc);
		exits("out of memory");
	}
	bitblt(b, b-&gt;r.min, b, b-&gt;r, Zero);
	choose(fc, b, nc, ht, as);
	wrbitmapfile(1, b);
bitblt(&amp;screen, screen.r.min, b, b-&gt;r, S); bflush();sleep(5000);
	f = subfalloc(nc, ht, as, fc, b, ~0, ~0);
	wrsubfontfile(1, f);
	exits(0);
}

static void
usage(void)
{
	fprint(2, "Usage: %s file ...\n", argv0);
	exits("usage");
}

static void
snarf(char *name, int i)
{
	int fd;
	Bitmap *b;

	ft[i].name = name;
	if((fd = open(name, OREAD)) &lt; 0){
		perror(name);
		exits("font read");
	}
	if((b = rdbitmapfile(fd)) == 0){
		fprint(2, "rdbitmapfile failed\n");
		exits("font read");
	}
	if((ft[i].bm = balloc(b-&gt;r, b-&gt;ldepth)) == 0){
		fprint(2, "ballocsnarf failed\n");
		exits("font read");
	}
	bitblt(ft[i].bm, b-&gt;r.min, b, b-&gt;r, S);
	if((ft[i].sf = rdsubfontfile(fd, b)) == 0){
		fprint(2, "rdsubfontfile failed\n");
		exits("font read");
	}
	close(fd);
}

static void
choose(Fontchar *f, Bitmap *b, int nc, int ht, int as)
{
	int j;
	Fontchar *info;
	int lastx = 0;
	int w, n;

	for(n = 0; n &lt; nc; n++, f++){
		f-&gt;x = lastx;
		for(j = 0; j &lt; nf; j++){
			if(n &gt;= ft[j].sf-&gt;n)
				continue;
			info = ft[j].sf-&gt;info;
			if(info[n+1].x != info[n].x)
				goto found;
		}
		continue;
	found:
		f-&gt;left = info[n].left;
		f-&gt;top = info[n].top;
		f-&gt;bottom = info[n].bottom;
		f-&gt;width = info[n].width;
		w = info[n+1].x - info[n].x;
		bitblt(b, Pt(0, lastx), ft[j].bm, Rect(0, info[n].x, ht, info[n+1].x), S);
		lastx += w;
	}
	f-&gt;x = lastx;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

