<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/telco/telco.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/telco/telco.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;

#define LOGFILE "telco"

/*
 * Rather than reading /adm/users, which is a lot of work for
 * a toy progdev, we assume all groups have the form
 *	NNN:user:user:
 * meaning that each user is the leader of his own group.
 */

enum
{
	OPERM	= 0x3,		/* mask of all permission types in open mode */
	Ndev	= 8,
	Nreq	= (Ndev*3)/2,
	Nrbuf	= 32*1024,
};

typedef struct Fid Fid;
typedef struct Dev Dev;
typedef struct Request Request;
typedef struct Type Type;

struct Fid
{
	Qid	qid;
	short	busy;
	short	open;
	int	fid;
	Fid	*next;
	char	*user;
};

struct Request
{
	Request	*next;

	Fid	*fid;
	ulong	tag;
	int	count;
	int	flushed;
};

struct Dev
{
	Lock;

	/* device state */
	int	ctl;		/* control fd */
	int	data;		/* data fd */
	char	*path;		/* to device */
	Type	*t;
	Type	*baset;
	int	speed;
	int	fclass;

	/* fs emulation */
	int	open;
	long	perm;
	char	*name;
	char	*user;
	char	msgbuf[128];
	Request	*r;
	Request *rlast;

	/* input reader */
	int	monitoring;	/* monitor pid */
	char	rbuf[Nrbuf];
	char	*rp;
	char	*wp;
	long	pid;
};

enum
{
	Devmask=	(Ndev-1)&lt;&lt;8,
	
	Qlvl1=		0,
	Qlvl2=		1,
	Qclone=		2,
	Qlvl3=		3,
	Qdata=		4,
	Qctl=		5,

	Pexec =		1,
	Pwrite = 	2,
	Pread = 	4,
	Pother = 	1,
	Pgroup = 	8,
	Powner =	64,
};

char *names[] =
{
[Qlvl1]		"/",
[Qlvl2]		"telco",
[Qclone]	"clone",
[Qlvl3]		"",
[Qdata]		"data",
[Qctl]		"ctl",
};

#define DEV(q) ((((ulong)(q).path)&amp;Devmask)&gt;&gt;8)
#define TYPE(q) (((ulong)(q).path)&amp;((1&lt;&lt;8)-1))
#define MKQID(t, i) ((((i)&lt;&lt;8)&amp;Devmask) | (t))

enum
{
	/*
	 *  modem specific commands
	 */
	Cerrorcorrection	= 0,	/* error correction */
	Ccompression,			/* compression */
	Cflowctl,			/* CTS/RTS */
	Crateadjust,			/* follow line speed */
	Cfclass2,			/* set up for fax */
	Cfclass0,			/* set up for data */
	Ncommand,
};

struct Type
{
	char	*name;
	char	*ident;		/* inquire request */
	char	*response;	/* inquire response (strstr) */
	char	*basetype;	/* name of base type */

	char	*commands[Ncommand];
};

/*
 *  Fax setup summary
 *
 *	FCLASS=2	- set to service class 2, i.e., one where the fax handles timing 
 *	FTBC=0		- ???
 *	FREL=1		- ???
 *	FCQ=1		- receive copy quality checking enabled
 *	FBOR=1		- set reversed bit order for phase C data
 *	FCR=1		- the DCE can receive message data, bit 10 in the DIS or
 *			  DTC frame will be set
 *	FDIS=,3		- limit com speed to 9600 baud
 */

Type typetab[] =
{
 {	"Rockwell",		0,	0,	0,
	"AT\\N7",	/* auto reliable (V.42, fall back to MNP, to none) */
	"AT%C1\\J0",	/* negotiate for compression, don't change port baud rate */
	"AT\\Q3",	/* CTS/RTS flow control */
 	"AT\\J1",
	"AT+FCLASS=2\rAT+FCR=1\r",
	"AT+FCLASS=0",
 },

 {	"ATT2400",	"ATI9",	"E2400",	"Rockwell",
	"AT\\N3",	/* auto reliable (MNP, fall back to none) */
	0,	
	0,
	0,
	0,
 	0,
 },

 {	"ATT14400",	"ATI9",	"E14400",	"Rockwell",
	0,
	0,	
	0,
	0,
	0,
 	0,
 },

 {	"MT1432",	"ATI2",	"MT1432",	0,
	"AT&amp;E1",	/* auto reliable (V.42, fall back to none) */
	"AT&amp;E15$BA0",	/* negotiate for compression */
	"AT&amp;E4",	/* CTS/RTS flow control */
	"AT$BA1",	/* don't change port baud rate */
	"AT+FCLASS=2\rAT+FTBC=0\rAT+FREL=1\rAT+FCQ=1\rAT+FBOR=1\rAT+FCR=1\rAT+FDIS=,3",
	"AT+FCLASS=0",
 },

 {	"MT2834",	"ATI2",	"MT2834",	"MT1432",
	0,
	0,
	0,
	0,
 	"AT+FCLASS=2\rAT+FTBC=0\rAT+FREL=1\rAT+FCQ=1\rAT+FBOR=1\rAT+FCR=1",
	0,
 },

 {	"VOCAL",	"ATI6",	"144DPL+FAX",	"Rockwell",
	"AT\\N3",	/* auto reliable (V.42, fall back to MNP, fall back to none) */
	"AT%C3\\J0",	/* negotiate for compression, don't change port baud rate */	
	0,
	0,
 	"AT+FCLASS=2\rAT+FTBC=0\rAT+FREL=1\rAT+FCQ=1\rAT+FBOR=1\rAT+FCR=1",
	"AT+FCLASS=0",
 },

 { 0, },
};

/*
 *  modem return codes
 */
enum
{
	Ok,
	Success,
	Failure,
	Noise,
	Found,
};

/*
 *  modem return messages
 */
typedef struct Msg	Msg;
struct Msg
{
	char	*text;
	int	type;
};

Msg msgs[] =
{
	{ "OK",			Ok, },
	{ "NO CARRIER", 	Failure, },
	{ "ERROR",		Failure, },
	{ "NO DIALTONE",	Failure, },
	{ "BUSY",		Failure, },
	{ "NO ANSWER",		Failure, },
	{ "CONNECT",		Success, },
	{ 0,			0 },
};

Fid	*fids;
Dev	*dev;
int	ndev;
int	mfd[2];
char	*user;
uchar	mdata[8192+IOHDRSZ];
int	messagesize = sizeof mdata;
Fcall	thdr;
Fcall	rhdr;
char	errbuf[ERRMAX];
uchar	statbuf[STATMAX];
int	pulsed;
int	verbose;
int	maxspeed = 56000;
char	*srcid = "plan9";
int	answer = 1;

Fid	*newfid(int);
int	devstat(Dir*, uchar*, int);
int	devgen(Qid, int, Dir*, uchar*, int);
void	error(char*);
void	io(void);
void	*erealloc(void*, ulong);
void	*emalloc(ulong);
void	usage(void);
int	perm(Fid*, Dev*, int);
void	setspeed(Dev*, int);
int	getspeed(char*, int);
char	*dialout(Dev*, char*);
void	onhook(Dev*);
int	readmsg(Dev*, int, char*);
void	monitor(Dev*);
int	getinput(Dev*, char*, int);
void	serve(Dev*);
void	receiver(Dev*);
char*	modemtype(Dev*, int, int);


char	*rflush(Fid*), *rversion(Fid*),
	*rattach(Fid*), *rauth(Fid*), *rwalk(Fid*),
	*ropen(Fid*), *rcreate(Fid*),
	*rread(Fid*), *rwrite(Fid*), *rclunk(Fid*),
	*rremove(Fid*), *rstat(Fid*), *rwstat(Fid*);

char 	*(*fcalls[])(Fid*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tattach]	rattach,
	[Tauth]	rauth,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enotexist[] =	"file does not exist";
char	Ebadaddr[] = 	"bad address";
char	Eattn[] = 	"can't get modem's attention";
char	Edial[] = 	"can't dial";
char	Enoauth[] =	"telco: authentication not required";
char	Eisopen[] = 	"file already open for I/O";
char	Enodev[] = 	"no free modems";
char	Enostream[] =	"stream closed prematurely";

void
usage(void)
{
	fprint(2, "usage: %s [-vp] [-i srcid] dev ...\n", argv0);
	exits("usage");
}

void
notifyf(void *a, char *s)
{
	USED(a);
	if(strncmp(s, "interrupt", 9) == 0)
		noted(NCONT);
	noted(NDFLT);
}

void
main(int argc, char *argv[])
{
	int p[2];
	int fd;
	char buf[10];
	Dev *d;

	ARGBEGIN{
	case 'p':
		pulsed = 1;
		break;
	case 'v':
		verbose = 1;
		break;
	case 'i':
		srcid = ARGF();
		break;
	case 's':
		maxspeed = atoi(ARGF());
		break;
	case 'n':
		answer = 0;
		break;
	default:
		usage();
	}ARGEND

	if(argc == 0)
		usage();
	if(argc &gt; Ndev)
		argc = Ndev;

	if(pipe(p) &lt; 0)
		error("pipe failed");

	notify(notifyf);
	fmtinstall('F', fcallfmt);
	user = getuser();

	switch(rfork(RFFDG|RFPROC|RFREND|RFNOTEG)){
	case -1:
		error("fork");
	case 0:
		close(p[1]);
		mfd[0] = mfd[1] = p[0];
		break;
	default:
		close(p[0]);
		fd = create("/srv/telco", OWRITE, 0666);
		if(fd &lt; 0)
			error("create of /srv/telco failed");
		sprint(buf, "%d", p[1]);
		if(write(fd, buf, strlen(buf)) &lt; 0)
			error("writing /srv/telco");
		close(fd);
		if(mount(p[1], -1, "/net", MBEFORE, "") &lt; 0)
			error("mount failed");
		exits(0);
	}

	dev = mallocz(argc*sizeof(Dev), 1);
	for(ndev = 0; ndev &lt; argc; ndev++){
		d = &amp;dev[ndev];
		d-&gt;path = argv[ndev];
		d-&gt;rp = d-&gt;wp = d-&gt;rbuf;
		monitor(d);
		d-&gt;open++;
		onhook(d);
		d-&gt;open--;
	}

	io();
}

/*
 *  generate a stat structure for a qid
 */
int
devstat(Dir *dir, uchar *buf, int nbuf)
{
	Dev *d;
	int t;
	static char tmp[10][32];
	static int ntmp;

	t = TYPE(dir-&gt;qid);
	if(t != Qlvl3)
		dir-&gt;name = names[t];
	else{
		dir-&gt;name = tmp[ntmp % nelem(tmp)];
		sprint(dir-&gt;name, "%lud", DEV(dir-&gt;qid));
		ntmp++;
	}
	dir-&gt;mode = 0755;
	dir-&gt;uid = user;
	dir-&gt;gid = user;
	dir-&gt;muid = user;
	if(t &gt;= Qlvl3){
		d = &amp;dev[DEV(dir-&gt;qid)];
		if(d-&gt;open){
			dir-&gt;mode = d-&gt;perm;
			dir-&gt;uid = d-&gt;user;
		}
	}
	if(dir-&gt;qid.type &amp; QTDIR)
		dir-&gt;mode |= DMDIR;
	if(t == Qdata){
		d = &amp;dev[DEV(dir-&gt;qid)];
		dir-&gt;length = d-&gt;wp - d-&gt;rp;
		if(dir-&gt;length &lt; 0)
			dir-&gt;length += Nrbuf;
	} else
		dir-&gt;length = 0;
	dir-&gt;atime = time(0);
	dir-&gt;mtime = dir-&gt;atime;
	if(buf)
		return convD2M(dir, buf, nbuf);
	return 0;
}

/*
 *  enumerate file's we can walk to from q
 */
int
devgen(Qid q, int i, Dir *d, uchar *buf, int nbuf)
{
	static ulong v;

	d-&gt;qid.vers = v++;
	switch(TYPE(q)){
	case Qlvl1:
		if(i != 0)
			return -1;
		d-&gt;qid.type = QTDIR;
		d-&gt;qid.path = Qlvl2;
		break;
	case Qlvl2:
		switch(i){
		case -1:
			d-&gt;qid.type = QTDIR;
			d-&gt;qid.path = Qlvl1;
			break;
		case 0:
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = Qclone;
			break;
		default:
			if(i &gt; ndev)
				return -1;
			d-&gt;qid.type = QTDIR;
			d-&gt;qid.path = MKQID(Qlvl3, i-1);
			break;
		}
		break;
	case Qlvl3:
		switch(i){
		case -1:
			d-&gt;qid.type = QTDIR;
			d-&gt;qid.path = Qlvl2;
			break;
		case 0:
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = MKQID(Qdata, DEV(q));
			break;
		case 1:
			d-&gt;qid.type = QTFILE;
			d-&gt;qid.path = MKQID(Qctl, DEV(q));
			break;
		default:
			return -1;
		}
		break;
	default:
		return -1;
	}
	return devstat(d, buf, nbuf);
}

char*
rversion(Fid *)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;busy)
			rclunk(f);

	if(thdr.msize &lt; 256)
		return "version: message size too small";
	messagesize = thdr.msize;
	if(messagesize &gt; sizeof mdata)
		messagesize = sizeof mdata;
	rhdr.msize = messagesize;
	if(strncmp(thdr.version, "9P2000", 6) != 0)
		return "unrecognized 9P version";
	rhdr.version = "9P2000";
	return 0;
}

char*
rflush(Fid *f)
{
	Request *r, **l;
	Dev *d;

	USED(f);
	for(d = dev; d &lt; &amp;dev[ndev]; d++){
		lock(d);
		for(l = &amp;d-&gt;r; r = *l; l = &amp;r-&gt;next)
			if(r-&gt;tag == thdr.oldtag){
				*l = r-&gt;next;
				free(r);
				break;
			}
		unlock(d);
	}
	return 0;
}

char *
rauth(Fid *f)
{
	USED(f);
	return Enoauth;
}

char*
rattach(Fid *f)
{
	f-&gt;busy = 1;
	f-&gt;qid.type = QTDIR;
	f-&gt;qid.path = Qlvl1;
	f-&gt;qid.vers = 0;
	rhdr.qid = f-&gt;qid;
	if(thdr.uname[0])
		f-&gt;user = strdup(thdr.uname);
	else
		f-&gt;user = "none";
	return 0;
}

char*
rwalk(Fid *f)
{
	Fid *nf;
	int i, nqid;
	char *name, *err;
	Dir dir;
	Qid q;

	nf = nil;
	if(thdr.fid != thdr.newfid){
		if(f-&gt;open)
			return Eisopen;
		if(f-&gt;busy == 0)
			return Enotexist;
		nf = newfid(thdr.newfid);
		nf-&gt;busy = 1;
		nf-&gt;open = 0;
		nf-&gt;qid = f-&gt;qid;
		nf-&gt;user = strdup(f-&gt;user);
		f = nf;	/* walk f */
	}

	err = nil;
	dir.qid = f-&gt;qid;
	nqid = 0;
	if(thdr.nwname &gt; 0){
		for(; nqid &lt; thdr.nwname; nqid++) {
			if((dir.qid.type &amp; QTDIR) == 0){
				err = Enotdir;
				break;
			}
			name = thdr.wname[nqid];
			if(strcmp(name, ".") == 0){
				/* nothing to do */
			}else if(strcmp(name, "..") == 0) {
				if(devgen(f-&gt;qid, -1, &amp;dir, 0, 0) &lt; 0)
					break;
			}
			else{
				q = dir.qid;
				for(i = 0;; i++){
					if(devgen(q, i, &amp;dir, 0, 0) &lt; 0)
						goto Out;
					if(strcmp(name, dir.name) == 0)
						break;
				}
			}
			rhdr.wqid[nqid] = dir.qid;
		}
    Out:
		if(nqid == 0 &amp;&amp; err == nil)
			err = Enotexist;
		if(nf != nil &amp;&amp; thdr.fid != thdr.newfid &amp;&amp; nqid &lt; thdr.nwname)
			rclunk(nf);
	}

	rhdr.nwqid = nqid;
	if(nqid &gt; 0 &amp;&amp; nqid == thdr.nwname)
		f-&gt;qid = dir.qid;
	return err;
}

char *
ropen(Fid *f)
{
	Dev *d;
	int mode, t;

	if(f-&gt;open)
		return Eisopen;
	mode = thdr.mode;
	mode &amp;= OPERM;
	if(f-&gt;qid.type &amp; QTDIR){
		if(mode != OREAD)
			return Eperm;
		rhdr.qid = f-&gt;qid;
		return 0;
	}
	if(mode==OEXEC)
		return Eperm;
	t = TYPE(f-&gt;qid);
	if(t == Qclone){
		for(d = dev; d &lt; &amp;dev[ndev]; d++)
			if(d-&gt;open == 0)
				break;
		if(d == &amp;dev[ndev])
			return Enodev;
		f-&gt;qid.path = MKQID(Qctl, d-dev);
		t = Qctl;
	}
	switch(t){
	case Qdata:
	case Qctl:
		d = &amp;dev[DEV(f-&gt;qid)];
		if(d-&gt;open == 0){
			d-&gt;user = strdup(f-&gt;user);
			d-&gt;perm = 0660;
		}else {
			if(mode==OWRITE || mode==ORDWR)
				if(!perm(f, d, Pwrite))
					return Eperm;
			if(mode==OREAD || mode==ORDWR)
				if(!perm(f, d, Pread))
					return Eperm;
		}
		d-&gt;open++;
		break;
	}
	rhdr.qid = f-&gt;qid;
	rhdr.iounit = messagesize - IOHDRSZ;
	f-&gt;open = 1;
	return 0;
}

char *
rcreate(Fid *f)
{
	USED(f);
	return Eperm;
}

/*
 *  intercept a note
 */
void
takeanote(void *u, char *note)
{
	USED(u);
	if(strstr(note, "flushed"))
		noted(NCONT);
	noted(NDFLT);
}

char*
rread(Fid *f)
{
	char *buf;
	long off, start;
	int i, m, n, cnt, t;
	Dir dir;
	char num[32];
	Dev *d;
	Request *r;

	n = 0;
	rhdr.count = 0;
	off = thdr.offset;
	cnt = thdr.count;
	buf = rhdr.data;
	t = TYPE(f-&gt;qid);
	switch(t){
	default:
		start = 0;
		for(i = 0; n &lt; cnt; i++){
			m = devgen(f-&gt;qid, i, &amp;dir, (uchar*)buf+n, cnt-n);
			if(m &lt;= BIT16SZ)
				break;
			if(start &gt;= off)
				n += m;
			start += m;
		}
		break;
	case Qctl:
		i = sprint(num, "%lud", DEV(f-&gt;qid));
		if(off &lt; i){
			n = cnt;
			if(off + n &gt; i)
				n = i - off;
			memmove(buf, num + off, n);
		} else
			n = 0;
		break;
	case Qdata:
		d = &amp;dev[DEV(f-&gt;qid)];
		r = mallocz(sizeof(Request), 1);
		r-&gt;tag = thdr.tag;
		r-&gt;count = thdr.count;
		r-&gt;fid = f;
		r-&gt;flushed = 0;
		lock(d);
		if(d-&gt;r)
			d-&gt;rlast-&gt;next = r;
		else
			d-&gt;r = r;
		d-&gt;rlast = r;
		serve(d);
		unlock(d);
		return "";
	}
	rhdr.count = n;
	return 0;
}

char *cmsg = "connect ";
int clen;

char*
rwrite(Fid *f)
{
	Dev *d;
	ulong off;
	int cnt;
	char *cp;
	char buf[64];

	off = thdr.offset;
	cnt = thdr.count;
	switch(TYPE(f-&gt;qid)){
	default:
		return "file is a directory";
	case Qctl:
		d = &amp;dev[DEV(f-&gt;qid)];
		clen = strlen(cmsg);
		if(cnt &lt; clen || strncmp(thdr.data, cmsg, clen) != 0){
			/*
			 *  send control message to real control file
			 */
			if(seek(d-&gt;ctl, off, 0) &lt; 0 || write(d-&gt;ctl, thdr.data, cnt) &lt; 0){
				errstr(errbuf, sizeof errbuf);
				return errbuf;
			}
		} else {
			/*
			 *  connect
			 */
			cnt -= clen;
			if(cnt &gt;= sizeof(buf))
				cnt = sizeof(buf) - 1;
			if(cnt &lt; 0)
				return Ebadaddr;
			strncpy(buf, &amp;thdr.data[clen], cnt);
			buf[cnt] = 0;
			cp = dialout(d, buf);
			if(cp)
				return cp;
		}
		rhdr.count = cnt;
		break;
	case Qdata:
		d = &amp;dev[DEV(f-&gt;qid)];
		if(write(d-&gt;data, thdr.data, cnt) &lt; 0){
			errstr(errbuf, sizeof errbuf);
			return errbuf;
		}
		rhdr.count = cnt;
		break;
	}
	return 0;
}

char *
rclunk(Fid *f)
{
	Dev *d;

	if(f-&gt;open)
		switch(TYPE(f-&gt;qid)){
		case Qdata:
		case Qctl:
			d = &amp;dev[DEV(f-&gt;qid)];
			if(d-&gt;open == 1)
				onhook(d);
			d-&gt;open--;
			break;
		}
	free(f-&gt;user);
	f-&gt;busy = 0;
	f-&gt;open = 0;
	return 0;
}

char *
rremove(Fid *f)
{
	USED(f);
	return Eperm;
}

char *
rstat(Fid *f)
{
	Dir d;

	d.qid = f-&gt;qid;
	rhdr.stat = statbuf;
	rhdr.nstat = devstat(&amp;d, statbuf, sizeof statbuf);
	return 0;
}

char *
rwstat(Fid *f)
{
	Dev *d;
	Dir dir;

	if(TYPE(f-&gt;qid) &lt; Qlvl3)
		return Eperm;

	convM2D(thdr.stat, thdr.nstat, &amp;dir, rhdr.data);	/* rhdr.data is a known place to scribble */
	d = &amp;dev[DEV(f-&gt;qid)];

	/*
	 * To change mode, must be owner
	 */
	if(d-&gt;perm != dir.mode){
		if(strcmp(f-&gt;user, d-&gt;user) != 0)
		if(strcmp(f-&gt;user, user) != 0)
			return Eperm;
	}

	/* all ok; do it */
	d-&gt;perm = dir.mode &amp; ~DMDIR;
	return 0;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = 0;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
		else if(!ff &amp;&amp; !f-&gt;busy)
			ff = f;
	if(ff){
		ff-&gt;fid = fid;
		return ff;
	}
	f = emalloc(sizeof *f);
	f-&gt;fid = fid;
	f-&gt;next = fids;
	fids = f;
	return f;
}

/*
 *  read fs requests and dispatch them
 */
void
io(void)
{
	char *err;
	int n;

	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(mfd[0], mdata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0)
			error("mount read");
		if(convM2S(mdata, n, &amp;thdr) != n)
			error("convM2S error");

		rhdr.data = (char*)mdata + IOHDRSZ;
		if(!fcalls[thdr.type])
			err = "bad fcall type";
		else
			err = (*fcalls[thdr.type])(newfid(thdr.fid));
		if(err){
			if(*err == 0)
				continue;	/* assigned to a slave */
			rhdr.type = Rerror;
			rhdr.ename = err;
		}else{
			rhdr.type = thdr.type + 1;
			rhdr.fid = thdr.fid;
		}
		rhdr.tag = thdr.tag;
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			error("mount write");
	}
}


int
perm(Fid *f, Dev *d, int p)
{
	if((p*Pother) &amp; d-&gt;perm)
		return 1;
	if(strcmp(f-&gt;user, user)==0 &amp;&amp; ((p*Pgroup) &amp; d-&gt;perm))
		return 1;
	if(strcmp(f-&gt;user, d-&gt;user)==0 &amp;&amp; ((p*Powner) &amp; d-&gt;perm))
		return 1;
	return 0;
}

void
error(char *s)
{
	fprint(2, "%s: %s: %r\n", argv0, s);
	syslog(0, LOGFILE, "%s: %r", s);
	remove("/srv/telco");
	postnote(PNGROUP, getpid(), "exit");
	exits(s);
}

void *
emalloc(ulong n)
{
	void *p;

	p = mallocz(n, 1);
	if(!p)
		error("out of memory");
	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(!p)
		error("out of memory");
	return p;
}

/*
 *  send bytes to modem
 */
int
send(Dev *d, char *x)
{
	if(verbose)
		syslog(0, LOGFILE, "-&gt;%s", x);
	return write(d-&gt;data, x, strlen(x));
}

/*
 *  apply a string of commands to modem
 */
int
apply(Dev *d, char *s, char *substr, int secs)
{
	char buf[128];
	char *p;
	int c, m;

	p = buf;
	m = Ok;
	while(*s){
		c = *p++ = *s++;
		if(c == '\r' || *s == 0){
			if(c != '\r')
				*p++ = '\r';
			*p = 0;
			if(send(d, buf) &lt; 0)
				return Failure;
			m = readmsg(d, secs, substr);
			p = buf;
		}
	}
	return m;
}

/*
 *  apply a command type
 */
int
applyspecial(Dev *d, int index)
{
	char *cmd;

	cmd = d-&gt;t-&gt;commands[index];
	if(cmd == 0 &amp;&amp; d-&gt;baset)
		cmd = d-&gt;baset-&gt;commands[index];
	if(cmd == 0)
		return Failure;

	return apply(d, cmd, 0, 2);
}

/*
 *  get modem into command mode if it isn't already
 */
int
attention(Dev *d)
{
	int i;

	for(i = 0; i &lt; 2; i++){
		sleep(250);
		if(send(d, "+") &lt; 0)
			continue;
		sleep(250);
		if(send(d, "+") &lt; 0)
			continue;
		sleep(250);
		if(send(d, "+") &lt; 0)
			continue;
		sleep(250);
		readmsg(d, 0, 0);
		if(apply(d, "ATZH0", 0, 2) == Ok)
			return Ok;
	}
	return Failure;
}

int portspeed[] = { 56000, 38400, 19200, 14400, 9600, 4800, 2400, 1200, 600, 300, 0 };

/*
 *  get the modem's type and speed
 */
char*
modemtype(Dev *d, int limit,  int fax)
{
	int *p;
	Type *t, *bt;
	char buf[28];

	d-&gt;t = typetab;
	d-&gt;baset = 0;

	/* assume we're at a good speed, try getting attention a few times */
	attention(d);

	/* find a common port rate */
	for(p = portspeed; *p; p++){
		if(*p &gt; limit)
			continue;
		setspeed(d, *p);
		if(attention(d) == Ok)
			break;
	}
	if(*p == 0)
		return Eattn;
	d-&gt;speed = *p;
	if(verbose)
		syslog(0, LOGFILE, "port speed %d", *p);

	/*
	 *  basic Hayes commands everyone implements (we hope)
	 *	Q0 = report result codes
	 * 	V1 = full word result codes
	 *	E0 = don't echo commands
	 *	M1 = speaker on until on-line
	 *	S0=0 = autoanswer off
	 */
	if(apply(d, "ATQ0V1E0M1S0=0", 0, 2) != Ok)
		return Eattn;

	/* find modem type */
	for(t = typetab; t-&gt;name; t++){
		if(t-&gt;ident == 0 || t-&gt;response == 0)
			continue;
		if(apply(d, t-&gt;ident, t-&gt;response, 2) == Found)
			break;
		readmsg(d, 0, 0);
	}
	readmsg(d, 0, 0);
	if(t-&gt;name){
		d-&gt;t = t;
		if(t-&gt;basetype){
			for(bt = typetab; bt-&gt;name; bt++)
				if(strcmp(bt-&gt;name, t-&gt;basetype) == 0)
					break;
			if(bt-&gt;name)
				d-&gt;baset = bt;
		}
	}
	if(verbose)
		syslog(0, LOGFILE, "modem %s", d-&gt;t-&gt;name);

	/* try setting fax modes */
	d-&gt;fclass = 0;
	if(fax){
		/* set up fax parameters */
		if(applyspecial(d, Cfclass2) != Failure)
			d-&gt;fclass = 2;

		/* setup a source id */
		if(srcid){
			sprint(buf, "AT+FLID=\"%s\"", srcid);
			apply(d, buf, 0, 2);
		}

		/* allow both data and fax calls in */
		apply(d, "AT+FAA=1", 0, 2);
	} else
		applyspecial(d, Cfclass0);
	return 0;
}

/*
 *  a process to read input from a modem.
 */
void
monitor(Dev *d)
{
	int n;
	char *p;
	char file[256];
	int background;

	background = 0;
	d-&gt;ctl = d-&gt;data = -1;

	for(;;){
		lock(d);
		sprint(file, "%sctl", d-&gt;path);
		d-&gt;ctl = open(file, ORDWR);
		if(d-&gt;ctl &lt; 0)
			error("opening ctl");
		d-&gt;data = open(d-&gt;path, ORDWR);
		if(d-&gt;data &lt; 0)
			error("opening data");
		d-&gt;wp = d-&gt;rp = d-&gt;rbuf;
		unlock(d);

		if(!background){
			background = 1;
			switch(d-&gt;pid = rfork(RFPROC|RFMEM)){
			case -1:
				error("out of processes");
			case 0:
				break;
			default:
				return;
			}
		}

		/* wait for ring or off hook */
		while(d-&gt;open == 0){
			d-&gt;rp = d-&gt;rbuf;
			p = d-&gt;wp;
			n = read(d-&gt;data, p, 1);
			if(n &lt; 1)
				continue;
			if(p &lt; &amp;d-&gt;rbuf[Nrbuf] - 2)
				d-&gt;wp++;
			if(*p == '\r' || *p == '\n'){
				*(p+1) = 0;
				if(verbose)
					syslog(0, LOGFILE, "&lt;:-%s", d-&gt;rp);
				if(answer &amp;&amp; strncmp(d-&gt;rp, "RING", 4) == 0){
					receiver(d);
					continue;
				}
				if(d-&gt;open == 0)
					d-&gt;wp = d-&gt;rbuf;
			}
		}

		/* shuttle bytes till on hook */
		while(d-&gt;open){
			if(d-&gt;wp &gt;= d-&gt;rp)
				n = &amp;d-&gt;rbuf[Nrbuf] - d-&gt;wp;
			else
				n = d-&gt;rp - d-&gt;wp - 1;
			if(n &gt; 0)
				n = read(d-&gt;data, d-&gt;wp, n);
			else {
				read(d-&gt;data, file, sizeof(file));
				continue;
			}
			if(n &lt; 0)
				break;
			lock(d);
			if(d-&gt;wp + n &gt;= &amp;d-&gt;rbuf[Nrbuf])
				d-&gt;wp = d-&gt;rbuf;
			else
				d-&gt;wp += n;
			serve(d);
			unlock(d);
		}

		close(d-&gt;ctl);
		close(d-&gt;data);
	}
}

/*
 *  get bytes input by monitor() (only routine that changes d-&gt;rp)
 */
int
getinput(Dev *d, char *buf, int n)
{
	char *p;
	int i;

	p = buf;
	while(n &gt; 0){
		if(d-&gt;wp == d-&gt;rp)
			break;
		if(d-&gt;wp &lt; d-&gt;rp)
			i = &amp;d-&gt;rbuf[Nrbuf] - d-&gt;rp;
		else
			i = d-&gt;wp - d-&gt;rp;
		if(i &gt; n)
			i = n;
		memmove(p, d-&gt;rp, i);
		if(d-&gt;rp + i == &amp;d-&gt;rbuf[Nrbuf])
			d-&gt;rp = d-&gt;rbuf;
		else
			d-&gt;rp += i;
		n -= i;
		p += i;
	}
	return p - buf;
}

/*
 *  fulfill a read request (we assume d is locked)
 */
void
serve(Dev *d)
{
	Request *r;
	int n;
	Fcall rhdr;
	uchar *mdata;
	char *buf;

	mdata = malloc(messagesize);
	buf = malloc(messagesize-IOHDRSZ);

	for(;;){
		if(d-&gt;r == 0 || d-&gt;rp == d-&gt;wp)
			break;
		r = d-&gt;r;
		if(r-&gt;count &gt; sizeof(buf))
			r-&gt;count = sizeof(buf);

		n = getinput(d, buf, r-&gt;count);
		if(n == 0)
			break;
		d-&gt;r = r-&gt;next;

		rhdr.type = Rread;
		rhdr.fid = r-&gt;fid-&gt;fid;
		rhdr.tag = r-&gt;tag;
		rhdr.data = buf;
		rhdr.count = n;
		n = convS2M(&amp;rhdr, mdata, messagesize);
		if(write(mfd[1], mdata, n) != n)
			fprint(2, "telco: error writing\n");
		free(r);
	}
	free(mdata);
	free(buf);
}

/*
 *  dial a number
 */
char*
dialout(Dev *d, char *number)
{
	int i, m, compress, rateadjust, speed, fax;
	char *err;
	char *field[5];
	char dialstr[128];

	compress = Ok;
	rateadjust = Failure;
	speed = maxspeed;
	fax = Failure;

	m = getfields(number, field, 5, 1, "!");
	for(i = 1; i &lt; m; i++){
		if(field[i][0] &gt;= '0' &amp;&amp; field[i][0] &lt;= '9')
			speed = atoi(field[i]);
		else if(strcmp(field[i], "nocompress") == 0)
			compress = Failure;
		else if(strcmp(field[i], "fax") == 0)
			fax = Ok;
	}

	syslog(0, LOGFILE, "dialing %s speed=%d %s", number, speed, fax==Ok?"fax":"");
	
	err = modemtype(d, speed, fax == Ok);
	if(err)
		return err;

	/*
	 *  extented Hayes commands, meaning depends on modem (VGA all over again)
	 */
	if(fax != Ok){
		if(d-&gt;fclass != 0)
			applyspecial(d, Cfclass0);
		applyspecial(d, Cerrorcorrection);
		if(compress == Ok)
			compress = applyspecial(d, Ccompression);
		if(compress != Ok)
			rateadjust = applyspecial(d, Crateadjust);
	}
	applyspecial(d, Cflowctl);

	/* dialout */
	sprint(dialstr, "ATD%c%s\r", pulsed ? 'P' : 'T', number);
	if(send(d, dialstr) &lt; 0)
		return Edial;

	if(fax == Ok)
		return 0;		/* fax sender worries about the rest */

	switch(readmsg(d, 120, 0)){
	case Success:
		break;
	default:
		return d-&gt;msgbuf;
	}

	/* change line rate if not compressing */
	if(rateadjust == Ok)
		setspeed(d, getspeed(d-&gt;msgbuf, d-&gt;speed));

	return 0;
}

/*
 *  start a receiving process
 */
void
receiver(Dev *d)
{
	int fd;
	char file[256];
	char *argv[8];
	int argc;
	int pfd[2];
	char *prog;

	pipe(pfd);
	switch(rfork(RFPROC|RFMEM|RFFDG|RFNAMEG)){
	case -1:
		return;
	case 0:
		fd = open("/srv/telco", ORDWR);
		if(fd &lt; 0){
			syslog(0, LOGFILE, "can't open telco: %r");
			exits(0);
		}
		if(mount(fd, -1, "/net", MAFTER, "") &lt; 0){
			syslog(0, LOGFILE, "can't mount: %r");
			exits(0);
		}
		close(fd);

		/* open connection through the file system interface */
		sprint(file, "/net/telco/%ld/data", d - dev);
		fd = open(file, ORDWR);
		if(fd &lt; 0){
			syslog(0, LOGFILE, "can't open %s: %r", file);
			exits(0);
		}

		/* let parent continue */
		close(pfd[0]);
		close(pfd[1]);

		/* answer the phone and see what flavor call this is */
		prog = "/bin/service/telcodata";
		switch(apply(d, "ATA", "+FCON", 30)){
		case Success:
			break;
		case Found:
			prog = "/bin/service/telcofax";
			break;
		default:
			syslog(0, LOGFILE, "bad ATA response");
			exits(0);
		}

		/* fork a receiving process */
		dup(fd, 0);
		dup(fd, 1);
		close(fd);
		argc = 0;
		argv[argc++] = strrchr(prog, '/')+1;
		argv[argc++] = file;
		argv[argc++] = dev-&gt;t-&gt;name;
		argv[argc] = 0;
		exec(prog, argv);
		syslog(0, LOGFILE, "can't exec %s: %r\n", prog);
		exits(0);
	default:
		/* wait till child gets the device open */
		close(pfd[1]);
		read(pfd[0], file, 1);
		close(pfd[0]);
		break;
	}
}

/*
 *  hang up an connections in progress
 */
void
onhook(Dev *d)
{
	write(d-&gt;ctl, "d0", 2);
	write(d-&gt;ctl, "r0", 2);
	sleep(250);
	write(d-&gt;ctl, "r1", 2);
	write(d-&gt;ctl, "d1", 2);
	modemtype(d, maxspeed, 1);
}

/*
 *  read till we see a message or we time out
 */
int
readmsg(Dev *d, int secs, char *substr)
{
	ulong start;
	char *p;
	int i, len;
	Msg *pp;
	int found = 0;

	p = d-&gt;msgbuf;
	len = sizeof(d-&gt;msgbuf) - 1;
	for(start = time(0); time(0) &lt;= start+secs;){
		if(len &amp;&amp; d-&gt;rp == d-&gt;wp){
			sleep(100);
			continue;
		}
		i = getinput(d, p, 1);
		if(i == 0)
			continue;
		if(*p == '\n' || *p == '\r' || len == 0){
			*p = 0;
			if(verbose &amp;&amp; p != d-&gt;msgbuf)
				syslog(0, LOGFILE, "&lt;-%s", d-&gt;msgbuf);
			if(substr &amp;&amp; strstr(d-&gt;msgbuf, substr))
				found = 1;
			for(pp = msgs; pp-&gt;text; pp++)
				if(strncmp(pp-&gt;text, d-&gt;msgbuf, strlen(pp-&gt;text))==0)
					return found ? Found : pp-&gt;type;
			start = time(0);
			p = d-&gt;msgbuf;
			len = sizeof(d-&gt;msgbuf) - 1;
			continue;
		}
		len--;
		p++;
	}
	strcpy(d-&gt;msgbuf, "No response from modem");
	return found ? Found : Noise;
}

/*
 *  get baud rate from a connect message
 */
int
getspeed(char *msg, int speed)
{
	char *p;
	int s;

	p = msg + sizeof("CONNECT") - 1;
	while(*p == ' ' || *p == '\t')
		p++;
	s = atoi(p);
	if(s &lt;= 0)
		return speed;
	else
		return s;
}

/*
 *  set speed and RTS/CTS modem flow control
 */
void
setspeed(Dev *d, int baud)
{
	char buf[32];

	if(d-&gt;ctl &lt; 0)
		return;
	sprint(buf, "b%d", baud);
	write(d-&gt;ctl, buf, strlen(buf));
	write(d-&gt;ctl, "m1", 2);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

