<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/tr.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/tr.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include 	&lt;u.h&gt;
#include 	&lt;libc.h&gt;

typedef struct PCB	/* Control block controlling specification parse */
{
	char	*base;		/* start of specification */
	char	*current;	/* current parse point */
	long	last;		/* last Rune returned */
	long	final;		/* final Rune in a span */
} Pcb;

uchar	bits[] = { 1, 2, 4, 8, 16, 32, 64, 128 };

#define	SETBIT(a, c)		((a)[(c)/8] |= bits[(c)&amp;07])
#define	CLEARBIT(a,c)		((a)[(c)/8] &amp;= ~bits[(c)&amp;07])
#define	BITSET(a,c)		((a)[(c)/8] &amp; bits[(c)&amp;07])

uchar	f[(Runemax+1)/8];
uchar	t[(Runemax+1)/8];
char 	wbuf[4096];
char	*wptr;

Pcb pfrom, pto;

int cflag;
int dflag;
int sflag;

void	complement(void);
void	delete(void);
void	squeeze(void);
void	translit(void);
long	canon(Pcb*);
char	*getrune(char*, Rune*);
void	Pinit(Pcb*, char*);
void	Prewind(Pcb *p);
int	readrune(int, long*);
void	wflush(int);
void	writerune(int, Rune);

static void
usage(void)
{
	fprint(2, "usage: %s [-cds] [string1 [string2]]\n", argv0);
	exits("usage");
}

void
main(int argc, char **argv)
{
	ARGBEGIN{
	case 's':	sflag++; break;
	case 'd':	dflag++; break;
	case 'c':	cflag++; break;
	default:	usage();
	}ARGEND
	if(argc&gt;0)
		Pinit(&amp;pfrom, argv[0]);
	if(argc&gt;1)
		Pinit(&amp;pto, argv[1]);
	if(argc&gt;2)
		usage();
	if(dflag) {
		if ((sflag &amp;&amp; argc != 2) || (!sflag &amp;&amp; argc != 1))
			usage();
		delete();
	} else {
		if (argc != 2)
			usage();
		if (cflag)
			complement();
		else translit();
	}
	exits(0);
}

void
delete(void)
{
	long c, last;

	if (cflag) {
		memset((char *) f, 0xff, sizeof f);
		while ((c = canon(&amp;pfrom)) &gt;= 0)
			CLEARBIT(f, c);
	} else {
		while ((c = canon(&amp;pfrom)) &gt;= 0)
			SETBIT(f, c);
	}
	if (sflag) {
		while ((c = canon(&amp;pto)) &gt;= 0)
			SETBIT(t, c);
	}

	last = 0x10000;
	while (readrune(0, &amp;c) &gt; 0) {
		if(!BITSET(f, c) &amp;&amp; (c != last || !BITSET(t,c))) {
			last = c;
			writerune(1, (Rune) c);
		}
	}
	wflush(1);
}

void
complement(void)
{
	Rune *p;
	int i;
	long from, to, lastc, high;

	lastc = 0;
	high = 0;
	while ((from = canon(&amp;pfrom)) &gt;= 0) {
		if (from &gt; high) high = from;
		SETBIT(f, from);
	}
	while ((to = canon(&amp;pto)) &gt; 0) {
		if (to &gt; high) high = to;
		SETBIT(t,to);
	}
	Prewind(&amp;pto);
	if ((p = (Rune *) malloc((high+1)*sizeof(Rune))) == 0)
		sysfatal("no memory");
	for (i = 0; i &lt;= high; i++){
		if (!BITSET(f,i)) {
			if ((to = canon(&amp;pto)) &lt; 0)
				to = lastc;
			else lastc = to;
			p[i] = to;
		}
		else p[i] = i;
	}
	if (sflag){
		lastc = 0x10000;
		while (readrune(0, &amp;from) &gt; 0) {
			if (from &gt; high)
				from = to;
			else
				from = p[from];
			if (from != lastc || !BITSET(t,from)) {
				lastc = from;
				writerune(1, (Rune) from);
			}
		}
				
	} else {
		while (readrune(0, &amp;from) &gt; 0){
			if (from &gt; high)
				from = to;
			else
				from = p[from];
			writerune(1, (Rune) from);
		}
	}
	wflush(1);
}

void
translit(void)
{
	Rune *p;
	int i;
	long from, to, lastc, high;

	lastc = 0;
	high = 0;
	while ((from = canon(&amp;pfrom)) &gt;= 0)
		if (from &gt; high) high = from;
	Prewind(&amp;pfrom);
	if ((p = (Rune *) malloc((high+1)*sizeof(Rune))) == 0)
		sysfatal("no memory");
	for (i = 0; i &lt;= high; i++)
		p[i] = i;
	while ((from = canon(&amp;pfrom)) &gt;= 0) {
		if ((to = canon(&amp;pto)) &lt; 0)
			to = lastc;
		else lastc = to;
		if (BITSET(f,from) &amp;&amp; p[from] != to)
			sysfatal("ambiguous translation");
		SETBIT(f,from);
		p[from] = to;
		SETBIT(t,to);
	}
	while ((to = canon(&amp;pto)) &gt;= 0) {
		SETBIT(t,to);
	}
	if (sflag){
		lastc = 0x10000;
		while (readrune(0, &amp;from) &gt; 0) {
			if (from &lt;= high)
				from = p[from];
			if (from != lastc || !BITSET(t,from)) {
				lastc = from;
				writerune(1, (Rune) from);
			}
		}
				
	} else {
		while (readrune(0, &amp;from) &gt; 0) {
			if (from &lt;= high)
				from = p[from];
			writerune(1, (Rune) from);
		}
	}
	wflush(1);
}

int
readrune(int fd, long *rp)
{
	Rune r;
	int j;
	static int i, n;
	static char buf[4096];

	j = i;
	for (;;) {
		if (i &gt;= n) {
			wflush(1);
			if (j != i)
				memcpy(buf, buf+j, n-j);
			i = n-j;
			n = read(fd, &amp;buf[i], sizeof(buf)-i);
			if (n &lt; 0)
				sysfatal("read error: %r");
			if (n == 0)
				return 0;
			j = 0;
			n += i;
		}
		i++;
		if (fullrune(&amp;buf[j], i-j))
			break;
	}
	chartorune(&amp;r, &amp;buf[j]);
	*rp = r;
	return 1;
}

void
writerune(int fd, Rune r)
{
	char buf[UTFmax];
	int n;

	if (!wptr)
		wptr = wbuf;
	n = runetochar(buf, (Rune*)&amp;r);
	if (wptr+n &gt;= wbuf+sizeof(wbuf))
		wflush(fd);
	memcpy(wptr, buf, n);
	wptr += n;
}

void
wflush(int fd)
{
	if (wptr &amp;&amp; wptr &gt; wbuf)
		if (write(fd, wbuf, wptr-wbuf) != wptr-wbuf)
			sysfatal("write error: %r");
	wptr = wbuf;
}

char *
getrune(char *s, Rune *rp)
{
	Rune r;
	char *save;
	int i, n;

	s += chartorune(rp, s);
	if((r = *rp) == '\\' &amp;&amp; *s){
		n = 0;
		if (*s == 'x') {
			s++;
			for (i = 0; i &lt; 4; i++) {
				save = s;
				s += chartorune(&amp;r, s);
				if ('0' &lt;= r &amp;&amp; r &lt;= '9')
					n = 16*n + r - '0';
				else if ('a' &lt;= r &amp;&amp; r &lt;= 'f')
					n = 16*n + r - 'a' + 10;
				else if ('A' &lt;= r &amp;&amp; r &lt;= 'F')
					n = 16*n + r - 'A' + 10;
				else {
					if (i == 0)
						*rp = 'x';
					else *rp = n;
					return save;
				}
			}
		} else {
			for(i = 0; i &lt; 3; i++) {
				save = s;
				s += chartorune(&amp;r, s);
				if('0' &lt;= r &amp;&amp; r &lt;= '7')
					n = 8*n + r - '0';
				else {
					if (i == 0)
					{
						*rp = r;
						return s;
					}
					*rp = n;
					return save;
				}
			}
			if(n &gt; 0377)
				sysfatal("character &gt; 0377");
		}
		*rp = n;
	}
	return s;
}

long
canon(Pcb *p)
{
	Rune r;

	if (p-&gt;final &gt;= 0) {
		if (p-&gt;last &lt; p-&gt;final)
			return ++p-&gt;last;
		p-&gt;final = -1;
	}
	if (*p-&gt;current == '\0')
		return -1;
	if(*p-&gt;current == '-' &amp;&amp; p-&gt;last &gt;= 0 &amp;&amp; p-&gt;current[1]){
		p-&gt;current = getrune(p-&gt;current+1, &amp;r);
		if (r &lt; p-&gt;last)
			sysfatal("invalid range specification");
		if (r &gt; p-&gt;last) {
			p-&gt;final = r;
			return ++p-&gt;last;
		}
	}
	p-&gt;current = getrune(p-&gt;current, &amp;r);
	p-&gt;last = r;
	return p-&gt;last;
}

void
Pinit(Pcb *p, char *cp)
{
	p-&gt;current = p-&gt;base = cp;
	p-&gt;last = p-&gt;final = -1;
}
void
Prewind(Pcb *p)
{
	p-&gt;current = p-&gt;base;
	p-&gt;last = p-&gt;final = -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

