<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/exportfs/exportfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/exportfs/exportfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * exportfs - Export a plan 9 name space across a network
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;libsec.h&gt;
#include "drawterm.h"
#define Extern
#include "exportfs.h"

/* #define QIDPATH	((1LL&lt;&lt;48)-1) */
#define QIDPATH	((((vlong)1)&lt;&lt;48)-1)
vlong newqid = 0;

void (*fcalls[256])(Fsrpc*);

/* accounting and debugging counters */
int	filecnt;
int	freecnt;
int	qidcnt;
int	qfreecnt;
int	ncollision;
int	netfd;

int
exportfs(int fd, int msgsz)
{
	char buf[ERRMAX], ebuf[ERRMAX];
	Fsrpc *r;
	int i, n;

	fcalls[Tversion] = Xversion;
	fcalls[Tauth] = Xauth;
	fcalls[Tflush] = Xflush;
	fcalls[Tattach] = Xattach;
	fcalls[Twalk] = Xwalk;
	fcalls[Topen] = slave;
	fcalls[Tcreate] = Xcreate;
	fcalls[Tclunk] = Xclunk;
	fcalls[Tread] = slave;
	fcalls[Twrite] = slave;
	fcalls[Tremove] = Xremove;
	fcalls[Tstat] = Xstat;
	fcalls[Twstat] = Xwstat;

	srvfd = -1;
	netfd = fd;
	//dbg = 1;

	strcpy(buf, "this is buf");
	strcpy(ebuf, "this is ebuf");
	DEBUG(DFD, "exportfs: started\n");

//	rfork(RFNOTEG);

	messagesize = msgsz;
	if(messagesize == 0){
		messagesize = iounit(netfd);
		if(messagesize == 0)
			messagesize = 8*8192+IOHDRSZ;
	}

	Workq = emallocz(sizeof(Fsrpc)*Nr_workbufs);
//	for(i=0; i&lt;Nr_workbufs; i++)
//		Workq[i].buf = emallocz(messagesize);
	fhash = emallocz(sizeof(Fid*)*FHASHSIZE);

	fmtinstall('F', fcallfmt);

	initroot();

	DEBUG(DFD, "exportfs: %s\n", buf);

	/*
	 * Start serving file requests from the network
	 */
	for(;;) {
		r = getsbuf();
		if(r == 0)
			fatal("Out of service buffers");
			
		DEBUG(DFD, "read9p...");
		n = read9pmsg(netfd, r-&gt;buf, messagesize);
		if(n &lt;= 0)
			fatal("eof: n=%d %r", n);

		if(convM2S(r-&gt;buf, n, &amp;r-&gt;work) == 0){
			iprint("convM2S %d byte message\n", n);
			for(i=0; i&lt;n; i++){
				iprint(" %.2ux", r-&gt;buf[i]);
				if(i%16 == 15)
					iprint("\n");
			}
			if(i%16)
				iprint("\n");
			fatal("convM2S format error");
		}

if(0) iprint("&lt;- %F\n", &amp;r-&gt;work);
		DEBUG(DFD, "%F\n", &amp;r-&gt;work);
		(fcalls[r-&gt;work.type])(r);
	}
}

void
reply(Fcall *r, Fcall *t, char *err)
{
	uchar *data;
	int m, n;

	t-&gt;tag = r-&gt;tag;
	t-&gt;fid = r-&gt;fid;
	if(err) {
		t-&gt;type = Rerror;
		t-&gt;ename = err;
	}
	else 
		t-&gt;type = r-&gt;type + 1;

if(0) iprint("-&gt; %F\n", t);
	DEBUG(DFD, "\t%F\n", t);

	data = malloc(messagesize);	/* not mallocz; no need to clear */
	if(data == nil)
		fatal(Enomem);
	n = convS2M(t, data, messagesize);
	if((m=write(netfd, data, n))!=n){
		iprint("wrote %d got %d (%r)\n", n, m);
		fatal("write");
	}
	free(data);
}

Fid *
getfid(int nr)
{
	Fid *f;

	for(f = fidhash(nr); f; f = f-&gt;next)
		if(f-&gt;nr == nr)
			return f;

	return 0;
}

int
freefid(int nr)
{
	Fid *f, **l;
	char buf[128];

	l = &amp;fidhash(nr);
	for(f = *l; f; f = f-&gt;next) {
		if(f-&gt;nr == nr) {
			if(f-&gt;mid) {
				sprint(buf, "/mnt/exportfs/%d", f-&gt;mid);
				unmount(0, buf);
				psmap[f-&gt;mid] = 0;
			}
			if(f-&gt;f) {
				freefile(f-&gt;f);
				f-&gt;f = nil;
			}
			*l = f-&gt;next;
			f-&gt;next = fidfree;
			fidfree = f;
			return 1;
		}
		l = &amp;f-&gt;next;
	}

	return 0;	
}

Fid *
newfid(int nr)
{
	Fid *new, **l;
	int i;

	l = &amp;fidhash(nr);
	for(new = *l; new; new = new-&gt;next)
		if(new-&gt;nr == nr)
			return 0;

	if(fidfree == 0) {
		fidfree = emallocz(sizeof(Fid) * Fidchunk);

		for(i = 0; i &lt; Fidchunk-1; i++)
			fidfree[i].next = &amp;fidfree[i+1];

		fidfree[Fidchunk-1].next = 0;
	}

	new = fidfree;
	fidfree = new-&gt;next;

	memset(new, 0, sizeof(Fid));
	new-&gt;next = *l;
	*l = new;
	new-&gt;nr = nr;
	new-&gt;fid = -1;
	new-&gt;mid = 0;

	return new;	
}

Fsrpc *
getsbuf(void)
{
	static int ap;
	int look, rounds;
	Fsrpc *wb;
	int small_instead_of_fast = 1;

	if(small_instead_of_fast)
		ap = 0;	/* so we always start looking at the beginning and reuse buffers */

	for(rounds = 0; rounds &lt; 10; rounds++) {
		for(look = 0; look &lt; Nr_workbufs; look++) {
			if(++ap == Nr_workbufs)
				ap = 0;
			if(Workq[ap].busy == 0)
				break;
		}

		if(look == Nr_workbufs){
			sleep(10 * rounds);
			continue;
		}

		wb = &amp;Workq[ap];
		wb-&gt;pid = 0;
		wb-&gt;canint = 0;
		wb-&gt;flushtag = NOTAG;
		wb-&gt;busy = 1;
		if(wb-&gt;buf == nil)	/* allocate buffers dynamically to keep size down */
			wb-&gt;buf = emallocz(messagesize);
		return wb;
	}
	fatal("No more work buffers");
	return nil;
}

void
freefile(File *f)
{
	File *parent, *child;

Loop:
	f-&gt;ref--;
	if(f-&gt;ref &gt; 0)
		return;
	freecnt++;
	if(f-&gt;ref &lt; 0) abort();
	DEBUG(DFD, "free %s\n", f-&gt;name);
	/* delete from parent */
	parent = f-&gt;parent;
	if(parent-&gt;child == f)
		parent-&gt;child = f-&gt;childlist;
	else{
		for(child=parent-&gt;child; child-&gt;childlist!=f; child=child-&gt;childlist)
			if(child-&gt;childlist == nil)
				fatal("bad child list");
		child-&gt;childlist = f-&gt;childlist;
	}
	freeqid(f-&gt;qidt);
	free(f-&gt;name);
	f-&gt;name = nil;
	free(f);
	f = parent;
	if(f != nil)
		goto Loop;
}

File *
file(File *parent, char *name)
{
	Dir *dir;
	char *path;
	File *f;

	DEBUG(DFD, "\tfile: 0x%p %s name %s\n", parent, parent-&gt;name, name);

	path = makepath(parent, name);
	dir = dirstat(path);
	free(path);
	if(dir == nil)
		return nil;

	for(f = parent-&gt;child; f; f = f-&gt;childlist)
		if(strcmp(name, f-&gt;name) == 0)
			break;

	if(f == nil){
		f = emallocz(sizeof(File));
		f-&gt;name = estrdup(name);

		f-&gt;parent = parent;
		f-&gt;childlist = parent-&gt;child;
		parent-&gt;child = f;
		parent-&gt;ref++;
		f-&gt;ref = 0;
		filecnt++;
	}
	f-&gt;ref++;
	f-&gt;qid.type = dir-&gt;qid.type;
	f-&gt;qid.vers = dir-&gt;qid.vers;
	f-&gt;qidt = uniqueqid(dir);
	f-&gt;qid.path = f-&gt;qidt-&gt;uniqpath;

	f-&gt;inval = 0;

	free(dir);

	return f;
}

void
initroot(void)
{
	Dir *dir;

	root = emallocz(sizeof(File));
	root-&gt;name = estrdup(".");

	dir = dirstat(root-&gt;name);
	if(dir == nil)
		fatal("root stat");

	root-&gt;ref = 1;
	root-&gt;qid.vers = dir-&gt;qid.vers;
	root-&gt;qidt = uniqueqid(dir);
	root-&gt;qid.path = root-&gt;qidt-&gt;uniqpath;
	root-&gt;qid.type = QTDIR;
	free(dir);

	psmpt = emallocz(sizeof(File));
	psmpt-&gt;name = estrdup("/");

	dir = dirstat(psmpt-&gt;name);
	if(dir == nil)
		return;

	psmpt-&gt;ref = 1;
	psmpt-&gt;qid.vers = dir-&gt;qid.vers;
	psmpt-&gt;qidt = uniqueqid(dir);
	psmpt-&gt;qid.path = psmpt-&gt;qidt-&gt;uniqpath;
	free(dir);

	psmpt = file(psmpt, "mnt");
	if(psmpt == 0)
		return;
	psmpt = file(psmpt, "exportfs");
}

char*
makepath(File *p, char *name)
{
	int i, n;
	char *c, *s, *path, *seg[256];

	seg[0] = name;
	n = strlen(name)+2;
	for(i = 1; i &lt; 256 &amp;&amp; p; i++, p = p-&gt;parent){
		seg[i] = p-&gt;name;
		n += strlen(p-&gt;name)+1;
	}
	path = malloc(n);
	if(path == nil)
		fatal("out of memory");
	s = path;

	while(i--) {
		for(c = seg[i]; *c; c++)
			*s++ = *c;
		*s++ = '/';
	}
	while(s[-1] == '/')
		s--;
	*s = '\0';

	return path;
}

int
qidhash(vlong path)
{
	int h, n;

	h = 0;
	for(n=0; n&lt;64; n+=Nqidbits){
		h ^= path;
		path &gt;&gt;= Nqidbits;
	}
	return h &amp; (Nqidtab-1);
}

void
freeqid(Qidtab *q)
{
	ulong h;
	Qidtab *l;

	q-&gt;ref--;
	if(q-&gt;ref &gt; 0)
		return;
	qfreecnt++;
	h = qidhash(q-&gt;path);
	if(qidtab[h] == q)
		qidtab[h] = q-&gt;next;
	else{
		for(l=qidtab[h]; l-&gt;next!=q; l=l-&gt;next)
			if(l-&gt;next == nil)
				fatal("bad qid list");
		l-&gt;next = q-&gt;next;
	}
	free(q);
}

Qidtab*
qidlookup(Dir *d)
{
	ulong h;
	Qidtab *q;

	h = qidhash(d-&gt;qid.path);
	for(q=qidtab[h]; q!=nil; q=q-&gt;next)
		if(q-&gt;type==d-&gt;type &amp;&amp; q-&gt;dev==d-&gt;dev &amp;&amp; q-&gt;path==d-&gt;qid.path)
			return q;
	return nil;
}

int
qidexists(vlong path)
{
	int h;
	Qidtab *q;

	for(h=0; h&lt;Nqidtab; h++)
		for(q=qidtab[h]; q!=nil; q=q-&gt;next)
			if(q-&gt;uniqpath == path)
				return 1;
	return 0;
}

Qidtab*
uniqueqid(Dir *d)
{
	ulong h;
	vlong path;
	Qidtab *q;

	q = qidlookup(d);
	if(q != nil){
		q-&gt;ref++;
		return q;
	}
	path = d-&gt;qid.path;
	while(qidexists(path)){
		DEBUG(DFD, "collision on %s\n", d-&gt;name);
		/* collision: find a new one */
		ncollision++;
		path &amp;= QIDPATH;
		++newqid;
		if(newqid &gt;= (1&lt;&lt;16)){
			DEBUG(DFD, "collision wraparound\n");
			newqid = 1;
		}
		path |= newqid&lt;&lt;48;
		DEBUG(DFD, "assign qid %.16llux\n", path);
	}
	q = mallocz(sizeof(Qidtab), 1);
	if(q == nil)
		fatal("no memory for qid table");
	qidcnt++;
	q-&gt;ref = 1;
	q-&gt;type = d-&gt;type;
	q-&gt;dev = d-&gt;dev;
	q-&gt;path = d-&gt;qid.path;
	q-&gt;uniqpath = path;
	h = qidhash(d-&gt;qid.path);
	q-&gt;next = qidtab[h];
	qidtab[h] = q;
	return q;
}

void
fatal(char *s, ...)
{
	char buf[ERRMAX];
	va_list arg;

	if (s) {
		va_start(arg, s);
		vsnprint(buf, ERRMAX, s, arg);
		va_end(arg);
	}

	/* Clear away the slave children */
//	for(m = Proclist; m; m = m-&gt;next)
//		postnote(PNPROC, m-&gt;pid, "kill");

	DEBUG(DFD, "%s\n", buf);
	if (s) 
		sysfatal(buf);
	else
		sysfatal("");
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

