<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/allocb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/allocb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

enum
{
	Hdrspc		= 64,		/* leave room for high-level headers */
	Bdead		= 0x51494F42,	/* "QIOB" */
};

struct
{
	Lock	lk;
	ulong	bytes;
} ialloc;

static Block*
_allocb(int size)
{
	Block *b;
	uintptr addr;

	if((b = mallocz(sizeof(Block)+size+Hdrspc, 0)) == nil)
		return nil;

	b-&gt;next = nil;
	b-&gt;list = nil;
	b-&gt;free = 0;
	b-&gt;flag = 0;

	/* align start of data portion by rounding up */
	addr = (uintptr)b;
	addr = ROUND(addr + sizeof(Block), BLOCKALIGN);
	b-&gt;base = (uchar*)addr;

	/* align end of data portion by rounding down */
	b-&gt;lim = ((uchar*)b) + sizeof(Block)+size+Hdrspc;
	addr = (uintptr)(b-&gt;lim);
	addr = addr &amp; ~(BLOCKALIGN-1);
	b-&gt;lim = (uchar*)addr;

	/* leave sluff at beginning for added headers */
	b-&gt;rp = b-&gt;lim - ROUND(size, BLOCKALIGN);
	if(b-&gt;rp &lt; b-&gt;base)
		panic("_allocb");
	b-&gt;wp = b-&gt;rp;

	return b;
}

Block*
allocb(int size)
{
	Block *b;

	/*
	 * Check in a process and wait until successful.
	 * Can still error out of here, though.
	 */
	if(up == nil)
		panic("allocb without up: %p\n", getcallerpc(&amp;size));
	if((b = _allocb(size)) == nil){
		panic("allocb: no memory for %d bytes\n", size);
	}
	setmalloctag(b, getcallerpc(&amp;size));

	return b;
}

Block*
iallocb(int size)
{
	Block *b;
	static int m1, m2;

	if(ialloc.bytes &gt; conf.ialloc){
		if((m1++%10000)==0)
			print("iallocb: limited %lud/%lud\n",
				ialloc.bytes, conf.ialloc);
		return 0;
	}

	if((b = _allocb(size)) == nil){
		if((m2++%10000)==0)
			print("iallocb: no memory %lud/%lud\n",
				ialloc.bytes, conf.ialloc);
		return nil;
	}
	setmalloctag(b, getcallerpc(&amp;size));
	b-&gt;flag = BINTR;

	ilock(&amp;ialloc.lk);
	ialloc.bytes += b-&gt;lim - b-&gt;base;
	iunlock(&amp;ialloc.lk);

	return b;
}

void
freeb(Block *b)
{
	void *dead = (void*)Bdead;

	if(b == nil)
		return;

	/*
	 * drivers which perform non cache coherent DMA manage their own buffer
	 * pool of uncached buffers and provide their own free routine.
	 */
	if(b-&gt;free) {
		b-&gt;free(b);
		return;
	}
	if(b-&gt;flag &amp; BINTR) {
		ilock(&amp;ialloc.lk);
		ialloc.bytes -= b-&gt;lim - b-&gt;base;
		iunlock(&amp;ialloc.lk);
	}

	/* poison the block in case someone is still holding onto it */
	b-&gt;next = dead;
	b-&gt;rp = dead;
	b-&gt;wp = dead;
	b-&gt;lim = dead;
	b-&gt;base = dead;

	free(b);
}

void
checkb(Block *b, char *msg)
{
	void *dead = (void*)Bdead;

	if(b == dead)
		panic("checkb b %s %lux", msg, b);
	if(b-&gt;base == dead || b-&gt;lim == dead || b-&gt;next == dead
	  || b-&gt;rp == dead || b-&gt;wp == dead){
		print("checkb: base 0x%8.8luX lim 0x%8.8luX next 0x%8.8luX\n",
			b-&gt;base, b-&gt;lim, b-&gt;next);
		print("checkb: rp 0x%8.8luX wp 0x%8.8luX\n", b-&gt;rp, b-&gt;wp);
		panic("checkb dead: %s\n", msg);
	}

	if(b-&gt;base &gt; b-&gt;lim)
		panic("checkb 0 %s %lux %lux", msg, b-&gt;base, b-&gt;lim);
	if(b-&gt;rp &lt; b-&gt;base)
		panic("checkb 1 %s %lux %lux", msg, b-&gt;base, b-&gt;rp);
	if(b-&gt;wp &lt; b-&gt;base)
		panic("checkb 2 %s %lux %lux", msg, b-&gt;base, b-&gt;wp);
	if(b-&gt;rp &gt; b-&gt;lim)
		panic("checkb 3 %s %lux %lux", msg, b-&gt;rp, b-&gt;lim);
	if(b-&gt;wp &gt; b-&gt;lim)
		panic("checkb 4 %s %lux %lux", msg, b-&gt;wp, b-&gt;lim);

}

void
iallocsummary(void)
{
	print("ialloc %lud/%lud\n", ialloc.bytes, conf.ialloc);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

