<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/chan.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/chan.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

int chandebug=0;		/* toggled by sysr1 */
QLock chanprint;		/* probably asking for trouble (deadlocks) -rsc */

int domount(Chan**, Mhead**);

void
dumpmount(void)		/* DEBUGGING */
{
	Pgrp *pg;
	Mount *t;
	Mhead **h, **he, *f;

	if(up == nil){
		print("no process for dumpmount\n");
		return;
	}
	pg = up-&gt;pgrp;
	if(pg == nil){
		print("no pgrp for dumpmount\n");
		return;
	}
	rlock(&amp;pg-&gt;ns);
	if(waserror()) {
		runlock(&amp;pg-&gt;ns);
		nexterror();
	}

	he = &amp;pg-&gt;mnthash[MNTHASH];
	for(h = pg-&gt;mnthash; h &lt; he; h++) {
		for(f = *h; f; f = f-&gt;hash) {
			print("head: %p: %s 0x%llux.%lud %C %lud -&gt; \n", f,
				f-&gt;from-&gt;name-&gt;s, f-&gt;from-&gt;qid.path,
				f-&gt;from-&gt;qid.vers, devtab[f-&gt;from-&gt;type]-&gt;dc,
				f-&gt;from-&gt;dev);
			for(t = f-&gt;mount; t; t = t-&gt;next)
				print("\t%p: %s (umh %p) (path %.8llux dev %C %lud)\n", t, t-&gt;to-&gt;name-&gt;s, t-&gt;to-&gt;umh, t-&gt;to-&gt;qid.path, devtab[t-&gt;to-&gt;type]-&gt;dc, t-&gt;to-&gt;dev);
		}
	}
	poperror();
	runlock(&amp;pg-&gt;ns);
}


char*
c2name(Chan *c)		/* DEBUGGING */
{
	if(c == nil)
		return "&lt;nil chan&gt;";
	if(c-&gt;name == nil)
		return "&lt;nil name&gt;";
	if(c-&gt;name-&gt;s == nil)
		return "&lt;nil name.s&gt;";
	return c-&gt;name-&gt;s;
}

enum
{
	CNAMESLOP	= 20
};

struct
{
	Lock lk;
	int	fid;
	Chan	*free;
	Chan	*list;
}chanalloc;

typedef struct Elemlist Elemlist;

struct Elemlist
{
	char	*name;	/* copy of name, so '/' can be overwritten */
	int	nelems;
	char	**elems;
	int	*off;
	int	mustbedir;
};

#define SEP(c) ((c) == 0 || (c) == '/')
void cleancname(Cname*);

int
isdotdot(char *p)
{
	return p[0]=='.' &amp;&amp; p[1]=='.' &amp;&amp; p[2]=='\0';
}

int
incref(Ref *r)
{
	int x;

	lock(&amp;r-&gt;lk);
	x = ++r-&gt;ref;
	unlock(&amp;r-&gt;lk);
	return x;
}

int
decref(Ref *r)
{
	int x;

	lock(&amp;r-&gt;lk);
	x = --r-&gt;ref;
	unlock(&amp;r-&gt;lk);
	if(x &lt; 0)
		panic("decref, pc=0x%p", getcallerpc(&amp;r));

	return x;
}

/*
 * Rather than strncpy, which zeros the rest of the buffer, kstrcpy
 * truncates if necessary, always zero terminates, does not zero fill,
 * and puts ... at the end of the string if it's too long.  Usually used to
 * save a string in up-&gt;genbuf;
 */
void
kstrcpy(char *s, char *t, int ns)
{
	int nt;

	nt = strlen(t);
	if(nt+1 &lt;= ns){
		memmove(s, t, nt+1);
		return;
	}
	/* too long */
	if(ns &lt; 4){
		/* but very short! */
		strncpy(s, t, ns);
		return;
	}
	/* truncate with ... at character boundary (very rare case) */
	memmove(s, t, ns-4);
	ns -= 4;
	s[ns] = '\0';
	/* look for first byte of UTF-8 sequence by skipping continuation bytes */
	while(ns&gt;0 &amp;&amp; (s[--ns]&amp;0xC0)==0x80)
		;
	strcpy(s+ns, "...");
}

int
emptystr(char *s)
{
	if(s == nil)
		return 1;
	if(s[0] == '\0')
		return 1;
	return 0;
}

/*
 * Atomically replace *p with copy of s
 */
void
kstrdup(char **p, char *s)
{
	int n;
	char *t, *prev;

	n = strlen(s)+1;
	/* if it's a user, we can wait for memory; if not, something's very wrong */
	if(up){
		t = smalloc(n);
		setmalloctag(t, getcallerpc(&amp;p));
	}else{
		t = malloc(n);
		if(t == nil)
			panic("kstrdup: no memory");
	}
	memmove(t, s, n);
	prev = *p;
	*p = t;
	free(prev);
}

void
chandevreset(void)
{
	int i;

	for(i=0; devtab[i] != nil; i++)
		devtab[i]-&gt;reset();
}

void
chandevinit(void)
{
	int i;

	for(i=0; devtab[i] != nil; i++)
		devtab[i]-&gt;init();
}

void
chandevshutdown(void)
{
	int i;
	
	/* shutdown in reverse order */
	for(i=0; devtab[i] != nil; i++)
		;
	for(i--; i &gt;= 0; i--)
		devtab[i]-&gt;shutdown();
}

Chan*
newchan(void)
{
	Chan *c;

	lock(&amp;chanalloc.lk);
	c = chanalloc.free;
	if(c != 0)
		chanalloc.free = c-&gt;next;
	unlock(&amp;chanalloc.lk);

	if(c == nil) {
		c = smalloc(sizeof(Chan));
		lock(&amp;chanalloc.lk);
		c-&gt;fid = ++chanalloc.fid;
		c-&gt;link = chanalloc.list;
		chanalloc.list = c;
		unlock(&amp;chanalloc.lk);
	}

	/* if you get an error before associating with a dev,
	   close calls rootclose, a nop */
	c-&gt;type = 0;
	c-&gt;flag = 0;
	c-&gt;ref.ref = 1;
	c-&gt;dev = 0;
	c-&gt;offset = 0;
	c-&gt;iounit = 0;
	c-&gt;umh = 0;
	c-&gt;uri = 0;
	c-&gt;dri = 0;
	c-&gt;aux = 0;
	c-&gt;mchan = 0;
	c-&gt;mcp = 0;
	c-&gt;mux = 0;
	memset(&amp;c-&gt;mqid, 0, sizeof(c-&gt;mqid));
	c-&gt;name = 0;
	return c;
}

static Ref ncname;

Cname*
newcname(char *s)
{
	Cname *n;
	int i;

	n = smalloc(sizeof(Cname));
	i = strlen(s);
	n-&gt;len = i;
	n-&gt;alen = i+CNAMESLOP;
	n-&gt;s = smalloc(n-&gt;alen);
	memmove(n-&gt;s, s, i+1);
	n-&gt;ref.ref = 1;
	incref(&amp;ncname);
	return n;
}

void
cnameclose(Cname *n)
{
	if(n == nil)
		return;
	if(decref(&amp;n-&gt;ref))
		return;
	decref(&amp;ncname);
	free(n-&gt;s);
	free(n);
}

Cname*
addelem(Cname *n, char *s)
{
	int i, a;
	char *t;
	Cname *new;

	if(s[0]=='.' &amp;&amp; s[1]=='\0')
		return n;

	if(n-&gt;ref.ref &gt; 1){
		/* copy on write */
		new = newcname(n-&gt;s);
		cnameclose(n);
		n = new;
	}

	i = strlen(s);
	if(n-&gt;len+1+i+1 &gt; n-&gt;alen){
		a = n-&gt;len+1+i+1 + CNAMESLOP;
		t = smalloc(a);
		memmove(t, n-&gt;s, n-&gt;len+1);
		free(n-&gt;s);
		n-&gt;s = t;
		n-&gt;alen = a;
	}
	if(n-&gt;len&gt;0 &amp;&amp; n-&gt;s[n-&gt;len-1]!='/' &amp;&amp; s[0]!='/')	/* don't insert extra slash if one is present */
		n-&gt;s[n-&gt;len++] = '/';
	memmove(n-&gt;s+n-&gt;len, s, i+1);
	n-&gt;len += i;
	if(isdotdot(s))
		cleancname(n);
	return n;
}

void
chanfree(Chan *c)
{
	c-&gt;flag = CFREE;

	if(c-&gt;umh != nil){
		putmhead(c-&gt;umh);
		c-&gt;umh = nil;
	}
	if(c-&gt;umc != nil){
		cclose(c-&gt;umc);
		c-&gt;umc = nil;
	}
	if(c-&gt;mux != nil){
		muxclose(c-&gt;mux);
		c-&gt;mux = nil;
	}
	if(c-&gt;mchan != nil){
		cclose(c-&gt;mchan);
		c-&gt;mchan = nil;
	}

	cnameclose(c-&gt;name);

	lock(&amp;chanalloc.lk);
	c-&gt;next = chanalloc.free;
	chanalloc.free = c;
	unlock(&amp;chanalloc.lk);
}

void
cclose(Chan *c)
{
	if(c-&gt;flag&amp;CFREE)
		panic("cclose %p", getcallerpc(&amp;c));

	if(decref(&amp;c-&gt;ref))
		return;

	if(!waserror()){
		devtab[c-&gt;type]-&gt;close(c);
		poperror();
	}
	chanfree(c);
}

/*
 * Make sure we have the only copy of c.  (Copy on write.)
 */
Chan*
cunique(Chan *c)
{
	Chan *nc;

	if(c-&gt;ref.ref != 1) {
		nc = cclone(c);
		cclose(c);
		c = nc;
	}

	return c;
}

int
eqqid(Qid a, Qid b)
{
	return a.path==b.path &amp;&amp; a.vers==b.vers;
}

int
eqchan(Chan *a, Chan *b, int pathonly)
{
	if(a-&gt;qid.path != b-&gt;qid.path)
		return 0;
	if(!pathonly &amp;&amp; a-&gt;qid.vers!=b-&gt;qid.vers)
		return 0;
	if(a-&gt;type != b-&gt;type)
		return 0;
	if(a-&gt;dev != b-&gt;dev)
		return 0;
	return 1;
}

int
eqchantdqid(Chan *a, int type, int dev, Qid qid, int pathonly)
{
	if(a-&gt;qid.path != qid.path)
		return 0;
	if(!pathonly &amp;&amp; a-&gt;qid.vers!=qid.vers)
		return 0;
	if(a-&gt;type != type)
		return 0;
	if(a-&gt;dev != dev)
		return 0;
	return 1;
}

Mhead*
newmhead(Chan *from)
{
	Mhead *mh;

	mh = smalloc(sizeof(Mhead));
	mh-&gt;ref.ref = 1;
	mh-&gt;from = from;
	incref(&amp;from-&gt;ref);

/*
	n = from-&gt;name-&gt;len;
	if(n &gt;= sizeof(mh-&gt;fromname))
		n = sizeof(mh-&gt;fromname)-1;
	memmove(mh-&gt;fromname, from-&gt;name-&gt;s, n);
	mh-&gt;fromname[n] = 0;
*/
	return mh;
}

int
cmount(Chan **newp, Chan *old, int flag, char *spec)
{
	Pgrp *pg;
	int order, flg;
	Mhead *m, **l, *mh;
	Mount *nm, *f, *um, **h;
	Chan *new;

	if(QTDIR &amp; (old-&gt;qid.type^(*newp)-&gt;qid.type))
		error(Emount);

if(old-&gt;umh)print("cmount old extra umh\n");

	order = flag&amp;MORDER;

	if((old-&gt;qid.type&amp;QTDIR)==0 &amp;&amp; order != MREPL)
		error(Emount);

	new = *newp;
	mh = new-&gt;umh;

	/*
	 * Not allowed to bind when the old directory
	 * is itself a union.  (Maybe it should be allowed, but I don't see
	 * what the semantics would be.)
	 *
	 * We need to check mh-&gt;mount-&gt;next to tell unions apart from
	 * simple mount points, so that things like
	 *	mount -c fd /root
	 *	bind -c /root /
	 * work.  The check of mount-&gt;mflag catches things like
	 *	mount fd /root
	 *	bind -c /root /
	 * 
	 * This is far more complicated than it should be, but I don't
	 * see an easier way at the moment.		-rsc
	 */
	if((flag&amp;MCREATE) &amp;&amp; mh &amp;&amp; mh-&gt;mount
	&amp;&amp; (mh-&gt;mount-&gt;next || !(mh-&gt;mount-&gt;mflag&amp;MCREATE)))
		error(Emount);

	pg = up-&gt;pgrp;
	wlock(&amp;pg-&gt;ns);

	l = &amp;MOUNTH(pg, old-&gt;qid);
	for(m = *l; m; m = m-&gt;hash) {
		if(eqchan(m-&gt;from, old, 1))
			break;
		l = &amp;m-&gt;hash;
	}

	if(m == nil) {
		/*
		 *  nothing mounted here yet.  create a mount
		 *  head and add to the hash table.
		 */
		m = newmhead(old);
		*l = m;

		/*
		 *  if this is a union mount, add the old
		 *  node to the mount chain.
		 */
		if(order != MREPL)
			m-&gt;mount = newmount(m, old, 0, 0);
	}
	wlock(&amp;m-&gt;lock);
	if(waserror()){
		wunlock(&amp;m-&gt;lock);
		nexterror();
	}
	wunlock(&amp;pg-&gt;ns);

	nm = newmount(m, new, flag, spec);
	if(mh != nil &amp;&amp; mh-&gt;mount != nil) {
		/*
		 *  copy a union when binding it onto a directory
		 */
		flg = order;
		if(order == MREPL)
			flg = MAFTER;
		h = &amp;nm-&gt;next;
		um = mh-&gt;mount;
		for(um = um-&gt;next; um; um = um-&gt;next) {
			f = newmount(m, um-&gt;to, flg, um-&gt;spec);
			*h = f;
			h = &amp;f-&gt;next;
		}
	}

	if(m-&gt;mount &amp;&amp; order == MREPL) {
		mountfree(m-&gt;mount);
		m-&gt;mount = 0;
	}

	if(flag &amp; MCREATE)
		nm-&gt;mflag |= MCREATE;

	if(m-&gt;mount &amp;&amp; order == MAFTER) {
		for(f = m-&gt;mount; f-&gt;next; f = f-&gt;next)
			;
		f-&gt;next = nm;
	}
	else {
		for(f = nm; f-&gt;next; f = f-&gt;next)
			;
		f-&gt;next = m-&gt;mount;
		m-&gt;mount = nm;
	}

	wunlock(&amp;m-&gt;lock);
	poperror();
	return nm-&gt;mountid;
}

void
cunmount(Chan *mnt, Chan *mounted)
{
	Pgrp *pg;
	Mhead *m, **l;
	Mount *f, **p;

	if(mnt-&gt;umh)	/* should not happen */
		print("cunmount newp extra umh %p has %p\n", mnt, mnt-&gt;umh);

	/*
	 * It _can_ happen that mounted-&gt;umh is non-nil, 
	 * because mounted is the result of namec(Aopen)
	 * (see sysfile.c:/^sysunmount).
	 * If we open a union directory, it will have a umh.
	 * Although surprising, this is okay, since the
	 * cclose will take care of freeing the umh.
	 */

	pg = up-&gt;pgrp;
	wlock(&amp;pg-&gt;ns);

	l = &amp;MOUNTH(pg, mnt-&gt;qid);
	for(m = *l; m; m = m-&gt;hash) {
		if(eqchan(m-&gt;from, mnt, 1))
			break;
		l = &amp;m-&gt;hash;
	}

	if(m == 0) {
		wunlock(&amp;pg-&gt;ns);
		error(Eunmount);
	}

	wlock(&amp;m-&gt;lock);
	if(mounted == 0) {
		*l = m-&gt;hash;
		wunlock(&amp;pg-&gt;ns);
		mountfree(m-&gt;mount);
		m-&gt;mount = nil;
		cclose(m-&gt;from);
		wunlock(&amp;m-&gt;lock);
		putmhead(m);
		return;
	}

	p = &amp;m-&gt;mount;
	for(f = *p; f; f = f-&gt;next) {
		/* BUG: Needs to be 2 pass */
		if(eqchan(f-&gt;to, mounted, 1) ||
		  (f-&gt;to-&gt;mchan &amp;&amp; eqchan(f-&gt;to-&gt;mchan, mounted, 1))) {
			*p = f-&gt;next;
			f-&gt;next = 0;
			mountfree(f);
			if(m-&gt;mount == nil) {
				*l = m-&gt;hash;
				cclose(m-&gt;from);
				wunlock(&amp;m-&gt;lock);
				wunlock(&amp;pg-&gt;ns);
				putmhead(m);
				return;
			}
			wunlock(&amp;m-&gt;lock);
			wunlock(&amp;pg-&gt;ns);
			return;
		}
		p = &amp;f-&gt;next;
	}
	wunlock(&amp;m-&gt;lock);
	wunlock(&amp;pg-&gt;ns);
	error(Eunion);
}

Chan*
cclone(Chan *c)
{
	Chan *nc;
	Walkqid *wq;

	wq = devtab[c-&gt;type]-&gt;walk(c, nil, nil, 0);
	if(wq == nil)
		error("clone failed");
	nc = wq-&gt;clone;
	free(wq);
	nc-&gt;name = c-&gt;name;
	if(c-&gt;name)
		incref(&amp;c-&gt;name-&gt;ref);
	return nc;
}

int
findmount(Chan **cp, Mhead **mp, int type, int dev, Qid qid)
{
	Pgrp *pg;
	Mhead *m;

	pg = up-&gt;pgrp;
	rlock(&amp;pg-&gt;ns);
	for(m = MOUNTH(pg, qid); m; m = m-&gt;hash){
		rlock(&amp;m-&gt;lock);
if(m-&gt;from == nil){
	print("m %p m-&gt;from 0\n", m);
	runlock(&amp;m-&gt;lock);
	continue;
}
		if(eqchantdqid(m-&gt;from, type, dev, qid, 1)) {
			runlock(&amp;pg-&gt;ns);
			if(mp != nil){
				incref(&amp;m-&gt;ref);
				if(*mp != nil)
					putmhead(*mp);
				*mp = m;
			}
			if(*cp != nil)
				cclose(*cp);
			incref(&amp;m-&gt;mount-&gt;to-&gt;ref);
			*cp = m-&gt;mount-&gt;to;
			runlock(&amp;m-&gt;lock);
			return 1;
		}
		runlock(&amp;m-&gt;lock);
	}

	runlock(&amp;pg-&gt;ns);
	return 0;
}

int
domount(Chan **cp, Mhead **mp)
{
	return findmount(cp, mp, (*cp)-&gt;type, (*cp)-&gt;dev, (*cp)-&gt;qid);
}

Chan*
undomount(Chan *c, Cname *name)
{
	Chan *nc;
	Pgrp *pg;
	Mount *t;
	Mhead **h, **he, *f;

	pg = up-&gt;pgrp;
	rlock(&amp;pg-&gt;ns);
	if(waserror()) {
		runlock(&amp;pg-&gt;ns);
		nexterror();
	}

	he = &amp;pg-&gt;mnthash[MNTHASH];
	for(h = pg-&gt;mnthash; h &lt; he; h++) {
		for(f = *h; f; f = f-&gt;hash) {
			if(strcmp(f-&gt;from-&gt;name-&gt;s, name-&gt;s) != 0)
				continue;
			for(t = f-&gt;mount; t; t = t-&gt;next) {
				if(eqchan(c, t-&gt;to, 1)) {
					/*
					 * We want to come out on the left hand side of the mount
					 * point using the element of the union that we entered on.
					 * To do this, find the element that has a from name of
					 * c-&gt;name-&gt;s.
					 */
					if(strcmp(t-&gt;head-&gt;from-&gt;name-&gt;s, name-&gt;s) != 0)
						continue;
					nc = t-&gt;head-&gt;from;
					incref(&amp;nc-&gt;ref);
					cclose(c);
					c = nc;
					break;
				}
			}
		}
	}
	poperror();
	runlock(&amp;pg-&gt;ns);
	return c;
}

/*
 * Either walks all the way or not at all.  No partial results in *cp.
 * *nerror is the number of names to display in an error message.
 */
static char Edoesnotexist[] = "does not exist";
int
walk(Chan **cp, char **names, int nnames, int nomount, int *nerror)
{
	int dev, dotdot, i, n, nhave, ntry, type;
	Chan *c, *nc;
	Cname *cname;
	Mount *f;
	Mhead *mh, *nmh;
	Walkqid *wq;

	c = *cp;
	incref(&amp;c-&gt;ref);
	cname = c-&gt;name;
	incref(&amp;cname-&gt;ref);
	mh = nil;

	/*
	 * While we haven't gotten all the way down the path:
	 *    1. step through a mount point, if any
	 *    2. send a walk request for initial dotdot or initial prefix without dotdot
	 *    3. move to the first mountpoint along the way.
	 *    4. repeat.
	 *
	 * An invariant is that each time through the loop, c is on the undomount
	 * side of the mount point, and c's name is cname.
	 */
	for(nhave=0; nhave&lt;nnames; nhave+=n){
		if((c-&gt;qid.type&amp;QTDIR)==0){
			if(nerror)
				*nerror = nhave;
			cnameclose(cname);
			cclose(c);
			strcpy(up-&gt;errstr, Enotdir);
			if(mh != nil)
{print("walk 1\n");
				putmhead(mh);
}
			return -1;
		}
		ntry = nnames - nhave;
		if(ntry &gt; MAXWELEM)
			ntry = MAXWELEM;
		dotdot = 0;
		for(i=0; i&lt;ntry; i++){
			if(isdotdot(names[nhave+i])){
				if(i==0) {
					dotdot = 1;
					ntry = 1;
				} else
					ntry = i;
				break;
			}
		}

		if(!dotdot &amp;&amp; !nomount)
			domount(&amp;c, &amp;mh);

		type = c-&gt;type;
		dev = c-&gt;dev;

		if((wq = devtab[type]-&gt;walk(c, nil, names+nhave, ntry)) == nil){
			/* try a union mount, if any */
			if(mh &amp;&amp; !nomount){
				/*
				 * mh-&gt;mount == c, so start at mh-&gt;mount-&gt;next
				 */
				rlock(&amp;mh-&gt;lock);
				for(f = mh-&gt;mount-&gt;next; f; f = f-&gt;next)
					if((wq = devtab[f-&gt;to-&gt;type]-&gt;walk(f-&gt;to, nil, names+nhave, ntry)) != nil)
						break;
				runlock(&amp;mh-&gt;lock);
				if(f != nil){
					type = f-&gt;to-&gt;type;
					dev = f-&gt;to-&gt;dev;
				}
			}
			if(wq == nil){
				cclose(c);
				cnameclose(cname);
				if(nerror)
					*nerror = nhave+1;
				if(mh != nil)
					putmhead(mh);
				return -1;
			}
		}

		nmh = nil;
		if(dotdot) {
			assert(wq-&gt;nqid == 1);
			assert(wq-&gt;clone != nil);

			cname = addelem(cname, "..");
			nc = undomount(wq-&gt;clone, cname);
			n = 1;
		} else {
			nc = nil;
			if(!nomount)
				for(i=0; i&lt;wq-&gt;nqid &amp;&amp; i&lt;ntry-1; i++)
					if(findmount(&amp;nc, &amp;nmh, type, dev, wq-&gt;qid[i]))
						break;
			if(nc == nil){	/* no mount points along path */
				if(wq-&gt;clone == nil){
					cclose(c);
					cnameclose(cname);
					if(wq-&gt;nqid==0 || (wq-&gt;qid[wq-&gt;nqid-1].type&amp;QTDIR)){
						if(nerror)
							*nerror = nhave+wq-&gt;nqid+1;
						strcpy(up-&gt;errstr, Edoesnotexist);
					}else{
						if(nerror)
							*nerror = nhave+wq-&gt;nqid;
						strcpy(up-&gt;errstr, Enotdir);
					}
					free(wq);
					if(mh != nil)
						putmhead(mh);
					return -1;
				}
				n = wq-&gt;nqid;
				nc = wq-&gt;clone;
			}else{		/* stopped early, at a mount point */
				if(wq-&gt;clone != nil){
					cclose(wq-&gt;clone);
					wq-&gt;clone = nil;
				}
				n = i+1;
			}
			for(i=0; i&lt;n; i++)
				cname = addelem(cname, names[nhave+i]);
		}
		cclose(c);
		c = nc;
		putmhead(mh);
		mh = nmh;
		free(wq);
	}

	putmhead(mh);

	c = cunique(c);

	if(c-&gt;umh != nil){	//BUG
		print("walk umh\n");
		putmhead(c-&gt;umh);
		c-&gt;umh = nil;
	}

	cnameclose(c-&gt;name);
	c-&gt;name = cname;

	cclose(*cp);
	*cp = c;
	if(nerror)
		*nerror = 0;
	return 0;
}

/*
 * c is a mounted non-creatable directory.  find a creatable one.
 */
Chan*
createdir(Chan *c, Mhead *m)
{
	Chan *nc;
	Mount *f;

	rlock(&amp;m-&gt;lock);
	if(waserror()) {
		runlock(&amp;m-&gt;lock);
		nexterror();
	}
	for(f = m-&gt;mount; f; f = f-&gt;next) {
		if(f-&gt;mflag&amp;MCREATE) {
			nc = cclone(f-&gt;to);
			runlock(&amp;m-&gt;lock);
			poperror();
			cclose(c);
			return nc;
		}
	}
	error(Enocreate);
	return 0;
}

void
saveregisters(void)
{
}

/*
 * In place, rewrite name to compress multiple /, eliminate ., and process ..
 */
void
cleancname(Cname *n)
{
	char *p;

	if(n-&gt;s[0] == '#'){
		p = strchr(n-&gt;s, '/');
		if(p == nil)
			return;
		cleanname(p);

		/*
		 * The correct name is #i rather than #i/,
		 * but the correct name of #/ is #/.
		 */
		if(strcmp(p, "/")==0 &amp;&amp; n-&gt;s[1] != '/')
			*p = '\0';
	}else
		cleanname(n-&gt;s);
	n-&gt;len = strlen(n-&gt;s);
}

static void
growparse(Elemlist *e)
{
	char **new;
	int *inew;
	enum { Delta = 8 };

	if(e-&gt;nelems % Delta == 0){
		new = smalloc((e-&gt;nelems+Delta) * sizeof(char*));
		memmove(new, e-&gt;elems, e-&gt;nelems*sizeof(char*));
		free(e-&gt;elems);
		e-&gt;elems = new;
		inew = smalloc((e-&gt;nelems+Delta+1) * sizeof(int));
		memmove(inew, e-&gt;off, e-&gt;nelems*sizeof(int));
		free(e-&gt;off);
		e-&gt;off = inew;
	}
}

/*
 * The name is known to be valid.
 * Copy the name so slashes can be overwritten.
 * An empty string will set nelem=0.
 * A path ending in / or /. or /.//./ etc. will have
 * e.mustbedir = 1, so that we correctly
 * reject, e.g., "/adm/users/." when /adm/users is a file
 * rather than a directory.
 */
static void
parsename(char *name, Elemlist *e)
{
	char *slash;

	kstrdup(&amp;e-&gt;name, name);
	name = e-&gt;name;
	e-&gt;nelems = 0;
	e-&gt;elems = nil;
	e-&gt;off = smalloc(sizeof(int));
	e-&gt;off[0] = skipslash(name) - name;
	for(;;){
		name = skipslash(name);
		if(*name=='\0'){
			e-&gt;mustbedir = 1;
			break;
		}
		growparse(e);
		e-&gt;elems[e-&gt;nelems++] = name;
		slash = utfrune(name, '/');
		if(slash == nil){
			e-&gt;off[e-&gt;nelems] = name+strlen(name) - e-&gt;name;
			e-&gt;mustbedir = 0;
			break;
		}
		e-&gt;off[e-&gt;nelems] = slash - e-&gt;name;
		*slash++ = '\0';
		name = slash;
	}
}

void*
mymemrchr(void *va, int c, long n)
{
	uchar *a, *e;

	a = va;
	for(e=a+n-1; e&gt;a; e--)
		if(*e == c)
			return e;
	return nil;
}

/*
 * Turn a name into a channel.
 * &amp;name[0] is known to be a valid address.  It may be a kernel address.
 *
 * Opening with amode Aopen, Acreate, or Aremove guarantees
 * that the result will be the only reference to that particular fid.
 * This is necessary since we might pass the result to
 * devtab[]-&gt;remove().
 *
 * Opening Atodir, Amount, or Aaccess does not guarantee this.
 *
 * Opening Aaccess can, under certain conditions, return a
 * correct Chan* but with an incorrect Cname attached.
 * Since the functions that open Aaccess (sysstat, syswstat, sys_stat)
 * do not use the Cname*, this avoids an unnecessary clone.
 */
Chan*
namec(char *aname, int amode, int omode, ulong perm)
{
	int n, prefix, len, t, nomount, npath;
	Chan *c, *cnew;
	Cname *cname;
	Elemlist e;
	Rune r;
	Mhead *m;
	char *createerr, tmperrbuf[ERRMAX];
	char *name;

	name = aname;
	if(name[0] == '\0')
		error("empty file name");
	validname(name, 1);

	/*
	 * Find the starting off point (the current slash, the root of
	 * a device tree, or the current dot) as well as the name to
	 * evaluate starting there.
	 */
	nomount = 0;
	switch(name[0]){
	case '/':
		c = up-&gt;slash;
		incref(&amp;c-&gt;ref);
		break;
	
	case '#':
		nomount = 1;
		up-&gt;genbuf[0] = '\0';
		n = 0;
		while(*name!='\0' &amp;&amp; (*name != '/' || n &lt; 2)){
			if(n &gt;= sizeof(up-&gt;genbuf)-1)
				error(Efilename);
			up-&gt;genbuf[n++] = *name++;
		}
		up-&gt;genbuf[n] = '\0';
		/*
		 *  noattach is sandboxing.
		 *
		 *  the OK exceptions are:
		 *	|  it only gives access to pipes you create
		 *	d  this process's file descriptors
		 *	e  this process's environment
		 *  the iffy exceptions are:
		 *	c  time and pid, but also cons and consctl
		 *	p  control of your own processes (and unfortunately
		 *	   any others left unprotected)
		 */
		n = chartorune(&amp;r, up-&gt;genbuf+1)+1;
		/* actually / is caught by parsing earlier */
		if(utfrune("M", r))
			error(Enoattach);
		if(up-&gt;pgrp-&gt;noattach &amp;&amp; utfrune("|decp", r)==nil)
			error(Enoattach);
		t = devno(r, 1);
		if(t == -1)
			error(Ebadsharp);
		c = devtab[t]-&gt;attach(up-&gt;genbuf+n);
		break;

	default:
		c = up-&gt;dot;
		incref(&amp;c-&gt;ref);
		break;
	}
	prefix = name - aname;

	e.name = nil;
	e.elems = nil;
	e.off = nil;
	e.nelems = 0;
	if(waserror()){
		cclose(c);
		free(e.name);
		free(e.elems);
		free(e.off);
//dumpmount();
		nexterror();
	}

	/*
	 * Build a list of elements in the path.
	 */
	parsename(name, &amp;e);

	/*
	 * On create, ....
	 */
	if(amode == Acreate){
		/* perm must have DMDIR if last element is / or /. */
		if(e.mustbedir &amp;&amp; !(perm&amp;DMDIR)){
			npath = e.nelems;
			strcpy(tmperrbuf, "create without DMDIR");
			goto NameError;
		}

		/* don't try to walk the last path element just yet. */
		if(e.nelems == 0)
			error(Eexist);
		e.nelems--;
	}

	if(walk(&amp;c, e.elems, e.nelems, nomount, &amp;npath) &lt; 0){
		if(npath &lt; 0 || npath &gt; e.nelems){
			print("namec %s walk error npath=%d\n", aname, npath);
			nexterror();
		}
		strcpy(tmperrbuf, up-&gt;errstr);
	NameError:
		len = prefix+e.off[npath];
		if(len &lt; ERRMAX/3 || (name=mymemrchr(aname, '/', len))==nil || name==aname)
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "%.*s", len, aname);
		else
			snprint(up-&gt;genbuf, sizeof up-&gt;genbuf, "...%.*s", (int)(len-(name-aname)), name);
		snprint(up-&gt;errstr, ERRMAX, "%#q %s", up-&gt;genbuf, tmperrbuf);
		nexterror();
	}

	if(e.mustbedir &amp;&amp; !(c-&gt;qid.type&amp;QTDIR)){
		npath = e.nelems;
		strcpy(tmperrbuf, "not a directory");
		goto NameError;
	}

	if(amode == Aopen &amp;&amp; (omode&amp;3) == OEXEC &amp;&amp; (c-&gt;qid.type&amp;QTDIR)){
		npath = e.nelems;
		error("cannot exec directory");
	}

	switch(amode){
	case Aaccess:
		if(!nomount)
			domount(&amp;c, nil);
		break;

	case Abind:
		m = nil;
		if(!nomount)
			domount(&amp;c, &amp;m);
		if(c-&gt;umh != nil)
			putmhead(c-&gt;umh);
		c-&gt;umh = m;
		break;

	case Aremove:
	case Aopen:
	Open:
		/* save the name; domount might change c */
		cname = c-&gt;name;
		incref(&amp;cname-&gt;ref);
		m = nil;
		if(!nomount)
			domount(&amp;c, &amp;m);

		/* our own copy to open or remove */
		c = cunique(c);

		/* now it's our copy anyway, we can put the name back */
		cnameclose(c-&gt;name);
		c-&gt;name = cname;

		switch(amode){
		case Aremove:
			putmhead(m);
			break;

		case Aopen:
		case Acreate:
if(c-&gt;umh != nil){
	print("cunique umh Open\n");
	putmhead(c-&gt;umh);
	c-&gt;umh = nil;
}

			/* only save the mount head if it's a multiple element union */
			if(m &amp;&amp; m-&gt;mount &amp;&amp; m-&gt;mount-&gt;next)
				c-&gt;umh = m;
			else
				putmhead(m);

			/* save registers else error() in open has wrong value of c saved */
			saveregisters();

			if(omode == OEXEC)
				c-&gt;flag &amp;= ~CCACHE;

			c = devtab[c-&gt;type]-&gt;open(c, omode&amp;~OCEXEC);

			if(omode &amp; OCEXEC)
				c-&gt;flag |= CCEXEC;
			if(omode &amp; ORCLOSE)
				c-&gt;flag |= CRCLOSE;
			break;
		}
		break;

	case Atodir:
		/*
		 * Directories (e.g. for cd) are left before the mount point,
		 * so one may mount on / or . and see the effect.
		 */
		if(!(c-&gt;qid.type &amp; QTDIR))
			error(Enotdir);
		break;

	case Amount:
		/*
		 * When mounting on an already mounted upon directory,
		 * one wants subsequent mounts to be attached to the
		 * original directory, not the replacement.  Don't domount.
		 */
		break;

	case Acreate:
		/*
		 * We've already walked all but the last element.
		 * If the last exists, try to open it OTRUNC.
		 * If omode&amp;OEXCL is set, just give up.
		 */
		e.nelems++;
		if(walk(&amp;c, e.elems+e.nelems-1, 1, nomount, nil) == 0){
			if(omode&amp;OEXCL)
				error(Eexist);
			omode |= OTRUNC;
			goto Open;
		}

		/*
		 * The semantics of the create(2) system call are that if the
		 * file exists and can be written, it is to be opened with truncation.
		 * On the other hand, the create(5) message fails if the file exists.
		 * If we get two create(2) calls happening simultaneously, 
		 * they might both get here and send create(5) messages, but only 
		 * one of the messages will succeed.  To provide the expected create(2)
		 * semantics, the call with the failed message needs to try the above
		 * walk again, opening for truncation.  This correctly solves the 
		 * create/create race, in the sense that any observable outcome can
		 * be explained as one happening before the other.
		 * The create/create race is quite common.  For example, it happens
		 * when two rc subshells simultaneously update the same
		 * environment variable.
		 *
		 * The implementation still admits a create/create/remove race:
		 * (A) walk to file, fails
		 * (B) walk to file, fails
		 * (A) create file, succeeds, returns 
		 * (B) create file, fails
		 * (A) remove file, succeeds, returns
		 * (B) walk to file, return failure.
		 *
		 * This is hardly as common as the create/create race, and is really
		 * not too much worse than what might happen if (B) got a hold of a
		 * file descriptor and then the file was removed -- either way (B) can't do
		 * anything with the result of the create call.  So we don't care about this race.
		 *
		 * Applications that care about more fine-grained decision of the races
		 * can use the OEXCL flag to get at the underlying create(5) semantics;
		 * by default we provide the common case.
		 *
		 * We need to stay behind the mount point in case we
		 * need to do the first walk again (should the create fail).
		 *
		 * We also need to cross the mount point and find the directory
		 * in the union in which we should be creating.
		 *
		 * The channel staying behind is c, the one moving forward is cnew.
		 */
		m = nil;
		cnew = nil;	/* is this assignment necessary? */
		if(!waserror()){	/* try create */
			if(!nomount &amp;&amp; findmount(&amp;cnew, &amp;m, c-&gt;type, c-&gt;dev, c-&gt;qid))
				cnew = createdir(cnew, m);
			else{
				cnew = c;
				incref(&amp;cnew-&gt;ref);
			}

			/*
			 * We need our own copy of the Chan because we're
			 * about to send a create, which will move it.  Once we have
			 * our own copy, we can fix the name, which might be wrong
			 * if findmount gave us a new Chan.
			 */
			cnew = cunique(cnew);
			cnameclose(cnew-&gt;name);
			cnew-&gt;name = c-&gt;name;
			incref(&amp;cnew-&gt;name-&gt;ref);

			devtab[cnew-&gt;type]-&gt;create(cnew, e.elems[e.nelems-1], omode&amp;~(OEXCL|OCEXEC), perm);
			poperror();
			if(omode &amp; OCEXEC)
				cnew-&gt;flag |= CCEXEC;
			if(omode &amp; ORCLOSE)
				cnew-&gt;flag |= CRCLOSE;
			if(m)
				putmhead(m);
			cclose(c);
			c = cnew;
			c-&gt;name = addelem(c-&gt;name, e.elems[e.nelems-1]);
			break;
		}else{		/* create failed */
			cclose(cnew);
			if(m)
				putmhead(m);
			if(omode &amp; OEXCL)
				nexterror();
			/* save error */
			createerr = up-&gt;errstr;
			up-&gt;errstr = tmperrbuf;
			/* note: we depend that walk does not error */
			if(walk(&amp;c, e.elems+e.nelems-1, 1, nomount, nil) &lt; 0){
				up-&gt;errstr = createerr;
				error(createerr);	/* report true error */
			}
			up-&gt;errstr = createerr;
			omode |= OTRUNC;
			goto Open;
		}
		panic("namec: not reached");				

	default:
		panic("unknown namec access %d\n", amode);
	}

	poperror();

	/* place final element in genbuf for e.g. exec */
	if(e.nelems &gt; 0)
		kstrcpy(up-&gt;genbuf, e.elems[e.nelems-1], sizeof up-&gt;genbuf);
	else
		kstrcpy(up-&gt;genbuf, ".", sizeof up-&gt;genbuf);
	free(e.name);
	free(e.elems);
	free(e.off);

	return c;
}

/*
 * name is valid. skip leading / and ./ as much as possible
 */
char*
skipslash(char *name)
{
	while(name[0]=='/' || (name[0]=='.' &amp;&amp; (name[1]==0 || name[1]=='/')))
		name++;
	return name;
}

char isfrog[256]={
	/*NUL*/	1, 1, 1, 1, 1, 1, 1, 1,	/* 0 */
	/*BKS*/	1, 1, 1, 1, 1, 1, 1, 1, /* 0x08 */
	/*DLE*/	1, 1, 1, 1, 1, 1, 1, 1, /* 0x10 */
	/*CAN*/	1, 1, 1, 1, 1, 1, 1, 1, /* 0x18 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x20 */
		0, 0, 0, 0, 0, 0, 0, 1, /* 0x28 (1 is '/', 0x2F) */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x30 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x38 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x40 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x48 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x50 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x58 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x60 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x68 */
		0, 0, 0, 0, 0, 0, 0, 0, /* 0x70 */
		0, 0, 0, 0, 0, 0, 0, 1, /* 0x78 (1 is DEL, 0x7F) */
};

/*
 * Check that the name
 *  a) is in valid memory.
 *  b) is shorter than 2^16 bytes, so it can fit in a 9P string field.
 *  c) contains no frogs.
 * The first byte is known to be addressible by the requester, so the
 * routine works for kernel and user memory both.
 * The parameter slashok flags whether a slash character is an error
 * or a valid character.
 */
void
validname(char *aname, int slashok)
{
	char *ename, *name;
	int c;
	Rune r;

	name = aname;
/*
	if(((ulong)name &amp; KZERO) != KZERO) {
		p = name;
		t = BY2PG-((ulong)p&amp;(BY2PG-1));
		while((ename=vmemchr(p, 0, t)) == nil) {
			p += t;
			t = BY2PG;
		}
	}else
*/
		ename = memchr(name, 0, (1&lt;&lt;16));

	if(ename==nil || ename-name&gt;=(1&lt;&lt;16))
		error("name too long");

	while(*name){
		/* all characters above '~' are ok */
		c = *(uchar*)name;
		if(c &gt;= Runeself)
			name += chartorune(&amp;r, name);
		else{
			if(isfrog[c])
				if(!slashok || c!='/'){
					snprint(up-&gt;genbuf, sizeof(up-&gt;genbuf), "%s: %q", Ebadchar, aname);
					error(up-&gt;genbuf);
			}
			name++;
		}
	}
}

void
isdir(Chan *c)
{
	if(c-&gt;qid.type &amp; QTDIR)
		return;
	error(Enotdir);
}

/*
 * This is necessary because there are many
 * pointers to the top of a given mount list:
 *
 *	- the mhead in the namespace hash table
 *	- the mhead in chans returned from findmount:
 *	  used in namec and then by unionread.
 *	- the mhead in chans returned from createdir:
 *	  used in the open/create race protect, which is gone.
 *
 * The RWlock in the Mhead protects the mount list it contains.
 * The mount list is deleted when we cunmount.
 * The RWlock ensures that nothing is using the mount list at that time.
 *
 * It is okay to replace c-&gt;mh with whatever you want as 
 * long as you are sure you have a unique reference to it.
 *
 * This comment might belong somewhere else.
 */
void
putmhead(Mhead *m)
{
	if(m &amp;&amp; decref(&amp;m-&gt;ref) == 0){
		m-&gt;mount = (Mount*)0xCafeBeef;
		free(m);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

