<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/dev.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/dev.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

extern ulong	kerndate;

void
mkqid(Qid *q, vlong path, ulong vers, int type)
{
	q-&gt;type = type;
	q-&gt;vers = vers;
	q-&gt;path = path;
}

int
devno(int c, int user)
{
	int i;

	for(i = 0; devtab[i] != nil; i++) {
		if(devtab[i]-&gt;dc == c)
			return i;
	}
	if(user == 0)
		panic("devno %C 0x%ux", c, c);

	return -1;
}

void
devdir(Chan *c, Qid qid, char *n, vlong length, char *user, long perm, Dir *db)
{
	db-&gt;name = n;
	if(c-&gt;flag&amp;CMSG)
		qid.type |= QTMOUNT;
	db-&gt;qid = qid;
	db-&gt;type = devtab[c-&gt;type]-&gt;dc;
	db-&gt;dev = c-&gt;dev;
	db-&gt;mode = perm;
	db-&gt;mode |= qid.type &lt;&lt; 24;
	db-&gt;atime = seconds();
	db-&gt;mtime = kerndate;
	db-&gt;length = length;
	db-&gt;uid = user;
	db-&gt;gid = eve;
	db-&gt;muid = user;
}

/*
 * (here, Devgen is the prototype; devgen is the function in dev.c.)
 * 
 * a Devgen is expected to return the directory entry for ".."
 * if you pass it s==DEVDOTDOT (-1).  otherwise...
 * 
 * there are two contradictory rules.
 * 
 * (i) if c is a directory, a Devgen is expected to list its children
 * as you iterate s.
 * 
 * (ii) whether or not c is a directory, a Devgen is expected to list
 * its siblings as you iterate s.
 * 
 * devgen always returns the list of children in the root
 * directory.  thus it follows (i) when c is the root and (ii) otherwise.
 * many other Devgens follow (i) when c is a directory and (ii) otherwise.
 * 
 * devwalk assumes (i).  it knows that devgen breaks (i)
 * for children that are themselves directories, and explicitly catches them.
 * 
 * devstat assumes (ii).  if the Devgen in question follows (i)
 * for this particular c, devstat will not find the necessary info.
 * with our particular Devgen functions, this happens only for
 * directories, so devstat makes something up, assuming
 * c-&gt;name, c-&gt;qid, eve, DMDIR|0555.
 * 
 * devdirread assumes (i).  the callers have to make sure
 * that the Devgen satisfies (i) for the chan being read.
 */
/*
 * the zeroth element of the table MUST be the directory itself for ..
*/
int
devgen(Chan *c, char *name, Dirtab *tab, int ntab, int i, Dir *dp)
{
	if(tab == 0)
		return -1;
	if(i == DEVDOTDOT){
		/* nothing */
	}else if(name){
		for(i=1; i&lt;ntab; i++)
			if(strcmp(tab[i].name, name) == 0)
				break;
		if(i==ntab)
			return -1;
		tab += i;
	}else{
		/* skip over the first element, that for . itself */
		i++;
		if(i &gt;= ntab)
			return -1;
		tab += i;
	}
	devdir(c, tab-&gt;qid, tab-&gt;name, tab-&gt;length, eve, tab-&gt;perm, dp);
	return 1;
}

void
devreset(void)
{
}

void
devinit(void)
{
}

void
devshutdown(void)
{
}

Chan*
devattach(int tc, char *spec)
{
	Chan *c;
	char *buf;

	c = newchan();
	mkqid(&amp;c-&gt;qid, 0, 0, QTDIR);
	c-&gt;type = devno(tc, 0);
	if(spec == nil)
		spec = "";
	buf = smalloc(4+strlen(spec)+1);
	sprint(buf, "#%C%s", tc, spec);
	c-&gt;name = newcname(buf);
	free(buf);
	return c;
}


Chan*
devclone(Chan *c)
{
	Chan *nc;

	if(c-&gt;flag &amp; COPEN)
		panic("clone of open file type %C\n", devtab[c-&gt;type]-&gt;dc);

	nc = newchan();

	nc-&gt;type = c-&gt;type;
	nc-&gt;dev = c-&gt;dev;
	nc-&gt;mode = c-&gt;mode;
	nc-&gt;qid = c-&gt;qid;
	nc-&gt;offset = c-&gt;offset;
	nc-&gt;umh = nil;
	nc-&gt;mountid = c-&gt;mountid;
	nc-&gt;aux = c-&gt;aux;
	nc-&gt;pgrpid = c-&gt;pgrpid;
	nc-&gt;mid = c-&gt;mid;
	nc-&gt;mqid = c-&gt;mqid;
	nc-&gt;mcp = c-&gt;mcp;
	return nc;
}

Walkqid*
devwalk(Chan *c, Chan *nc, char **name, int nname, Dirtab *tab, int ntab, Devgen *gen)
{
	int i, j, alloc;
	Walkqid *wq;
	char *n;
	Dir dir;

	if(nname &gt; 0)
		isdir(c);

	alloc = 0;
	wq = smalloc(sizeof(Walkqid)+(nname-1)*sizeof(Qid));
	if(waserror()){
		if(alloc &amp;&amp; wq-&gt;clone!=nil)
			cclose(wq-&gt;clone);
		free(wq);
		return nil;
	}
	if(nc == nil){
		nc = devclone(c);
		nc-&gt;type = 0;	/* device doesn't know about this channel yet */
		alloc = 1;
	}
	wq-&gt;clone = nc;

	for(j=0; j&lt;nname; j++){
		if(!(nc-&gt;qid.type&amp;QTDIR)){
			if(j==0)
				error(Enotdir);
			goto Done;
		}
		n = name[j];
		if(strcmp(n, ".") == 0){
    Accept:
			wq-&gt;qid[wq-&gt;nqid++] = nc-&gt;qid;
			continue;
		}
		if(strcmp(n, "..") == 0){
			if((*gen)(nc, nil, tab, ntab, DEVDOTDOT, &amp;dir) != 1){
				print("devgen walk .. in dev%s %llux broken\n",
					devtab[nc-&gt;type]-&gt;name, nc-&gt;qid.path);
				error("broken devgen");
			}
			nc-&gt;qid = dir.qid;
			goto Accept;
		}
		/*
		 * Ugly problem: If we're using devgen, make sure we're
		 * walking the directory itself, represented by the first
		 * entry in the table, and not trying to step into a sub-
		 * directory of the table, e.g. /net/net. Devgen itself
		 * should take care of the problem, but it doesn't have
		 * the necessary information (that we're doing a walk).
		 */
		if(gen==devgen &amp;&amp; nc-&gt;qid.path!=tab[0].qid.path)
			goto Notfound;
		for(i=0;; i++) {
			switch((*gen)(nc, n, tab, ntab, i, &amp;dir)){
			case -1:
			Notfound:
				if(j == 0)
					error(Enonexist);
				kstrcpy(up-&gt;errstr, Enonexist, ERRMAX);
				goto Done;
			case 0:
				continue;
			case 1:
				if(strcmp(n, dir.name) == 0){
					nc-&gt;qid = dir.qid;
					goto Accept;
				}
				continue;
			}
		}
	}
	/*
	 * We processed at least one name, so will return some data.
	 * If we didn't process all nname entries succesfully, we drop
	 * the cloned channel and return just the Qids of the walks.
	 */
Done:
	poperror();
	if(wq-&gt;nqid &lt; nname){
		if(alloc)
			cclose(wq-&gt;clone);
		wq-&gt;clone = nil;
	}else if(wq-&gt;clone){
		/* attach cloned channel to same device */
		wq-&gt;clone-&gt;type = c-&gt;type;
	}
	return wq;
}

int
devstat(Chan *c, uchar *db, int n, Dirtab *tab, int ntab, Devgen *gen)
{
	int i;
	Dir dir;
	char *p, *elem;

	for(i=0;; i++)
		switch((*gen)(c, nil, tab, ntab, i, &amp;dir)){
		case -1:
			if(c-&gt;qid.type &amp; QTDIR){
				if(c-&gt;name == nil)
					elem = "???";
				else if(strcmp(c-&gt;name-&gt;s, "/") == 0)
					elem = "/";
				else
					for(elem=p=c-&gt;name-&gt;s; *p; p++)
						if(*p == '/')
							elem = p+1;
				devdir(c, c-&gt;qid, elem, 0, eve, DMDIR|0555, &amp;dir);
				n = convD2M(&amp;dir, db, n);
				if(n == 0)
					error(Ebadarg);
				return n;
			}
			print("devstat %C %llux\n", devtab[c-&gt;type]-&gt;dc, c-&gt;qid.path);

			error(Enonexist);
		case 0:
			break;
		case 1:
			if(c-&gt;qid.path == dir.qid.path) {
				if(c-&gt;flag&amp;CMSG)
					dir.mode |= DMMOUNT;
				n = convD2M(&amp;dir, db, n);
				if(n == 0)
					error(Ebadarg);
				return n;
			}
			break;
		}
	error(Egreg);	/* not reached? */
	return -1;
}

long
devdirread(Chan *c, char *d, long n, Dirtab *tab, int ntab, Devgen *gen)
{
	long m, dsz;
	struct{
		Dir d;
		char slop[100];
	}dir;

	for(m=0; m&lt;n; c-&gt;dri++) {
		switch((*gen)(c, nil, tab, ntab, c-&gt;dri, &amp;dir.d)){
		case -1:
			return m;

		case 0:
			break;

		case 1:
			dsz = convD2M(&amp;dir.d, (uchar*)d, n-m);
			if(dsz &lt;= BIT16SZ){	/* &lt;= not &lt; because this isn't stat; read is stuck */
				if(m == 0)
					error(Eshort);
				return m;
			}
			m += dsz;
			d += dsz;
			break;
		}
	}

	return m;
}

/*
 * error(Eperm) if open permission not granted for up-&gt;user.
 */
void
devpermcheck(char *fileuid, ulong perm, int omode)
{
	ulong t;
	static int access[] = { 0400, 0200, 0600, 0100 };

	if(strcmp(up-&gt;user, fileuid) == 0)
		perm &lt;&lt;= 0;
	else
	if(strcmp(up-&gt;user, eve) == 0)
		perm &lt;&lt;= 3;
	else
		perm &lt;&lt;= 6;

	t = access[omode&amp;3];
	if((t&amp;perm) != t)
		error(Eperm);
}

Chan*
devopen(Chan *c, int omode, Dirtab *tab, int ntab, Devgen *gen)
{
	int i;
	Dir dir;

	for(i=0;; i++) {
		switch((*gen)(c, nil, tab, ntab, i, &amp;dir)){
		case -1:
			goto Return;
		case 0:
			break;
		case 1:
			if(c-&gt;qid.path == dir.qid.path) {
				devpermcheck(dir.uid, dir.mode, omode);
				goto Return;
			}
			break;
		}
	}
Return:
	c-&gt;offset = 0;
	if((c-&gt;qid.type&amp;QTDIR) &amp;&amp; omode!=OREAD)
		error(Eperm);
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	return c;
}

void
devcreate(Chan *c, char *name, int mode, ulong perm)
{
	USED(c);
	USED(name);
	USED(mode);
	USED(perm);

	error(Eperm);
}

Block*
devbread(Chan *c, long n, ulong offset)
{
	Block *bp;

	bp = allocb(n);
	if(bp == 0)
		error(Enomem);
	if(waserror()) {
		freeb(bp);
		nexterror();
	}
	bp-&gt;wp += devtab[c-&gt;type]-&gt;read(c, bp-&gt;wp, n, offset);
	poperror();
	return bp;
}

long
devbwrite(Chan *c, Block *bp, ulong offset)
{
	long n;

	if(waserror()) {
		freeb(bp);
		nexterror();
	}
	n = devtab[c-&gt;type]-&gt;write(c, bp-&gt;rp, BLEN(bp), offset);
	poperror();
	freeb(bp);

	return n;
}

void
devremove(Chan *c)
{
	USED(c);
	error(Eperm);
}

int
devwstat(Chan *c, uchar *a, int n)
{
	USED(c);
	USED(a);
	USED(n);

	error(Eperm);
	return 0;
}

void
devpower(int a)
{
	USED(a);
	error(Eperm);
}

int
devconfig(int a, char *b, DevConf *c)
{
	USED(a);
	USED(b);
	USED(c);
	error(Eperm);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

