<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devaudio-unix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devaudio-unix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Linux and BSD
 */
#include &lt;sys/ioctl.h&gt;
#ifdef __linux__
#include &lt;linux/soundcard.h&gt;
#else
#include &lt;sys/soundcard.h&gt;
#endif
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"
#include	"devaudio.h"

enum
{
	Channels = 2,
	Rate = 44100,
	Bits = 16,
	Bigendian = 1,
};

static int afd = -1;
static int cfd= -1;
static int speed;

/* maybe this should return -1 instead of sysfatal */
void
audiodevopen(void)
{
	int t;
	ulong ul;

	afd = -1;
	cfd = -1;
	if((afd = open("/dev/dsp", OWRITE)) &lt; 0)
		goto err;
	if((cfd = open("/dev/mixer", ORDWR)) &lt; 0)
		goto err;
	
	t = Bits;
	if(ioctl(afd, SNDCTL_DSP_SAMPLESIZE, &amp;t) &lt; 0)
		goto err;
	
	t = Channels-1;
	if(ioctl(afd, SNDCTL_DSP_STEREO, &amp;t) &lt; 0)
		goto err;
	
	speed = Rate;
	ul = Rate;
	if(ioctl(afd, SNDCTL_DSP_SPEED, &amp;ul) &lt; 0)
		goto err;

	return;

err:
	if(afd &gt;= 0)
		close(afd);
	afd = -1;
	oserror();
}

void
audiodevclose(void)
{
	close(afd);
	close(cfd);
	afd = -1;
	cfd = -1;
}

static struct {
	int id9;
	int id;
} names[] = {
	Vaudio,	SOUND_MIXER_VOLUME,
	Vbass, 		SOUND_MIXER_BASS,
	Vtreb, 		SOUND_MIXER_TREBLE,
	Vline, 		SOUND_MIXER_LINE,
	Vpcm, 		SOUND_MIXER_PCM,
	Vsynth, 		SOUND_MIXER_SYNTH,
	Vcd, 		SOUND_MIXER_CD,
	Vmic, 		SOUND_MIXER_MIC,
//	"record", 		SOUND_MIXER_RECLEV,
//	"mix",		SOUND_MIXER_IMIX,
//	"pcm2",		SOUND_MIXER_ALTPCM,
	Vspeaker,	SOUND_MIXER_SPEAKER
//	"line1",		SOUND_MIXER_LINE1,
//	"line2",		SOUND_MIXER_LINE2,
//	"line3",		SOUND_MIXER_LINE3,
//	"digital1",	SOUND_MIXER_DIGITAL1,
//	"digital2",	SOUND_MIXER_DIGITAL2,
//	"digital3",	SOUND_MIXER_DIGITAL3,
//	"phonein",		SOUND_MIXER_PHONEIN,
//	"phoneout",		SOUND_MIXER_PHONEOUT,
//	"radio",		SOUND_MIXER_RADIO,
//	"video",		SOUND_MIXER_VIDEO,
//	"monitor",	SOUND_MIXER_MONITOR,
//	"igain",		SOUND_MIXER_IGAIN,
//	"ogain",		SOUND_MIXER_OGAIN,
};

static int
lookname(int id9)
{
	int i;
	
	for(i=0; i&lt;nelem(names); i++)
		if(names[i].id9 == id9)
			return names[i].id;
	return -1;
}

void
audiodevsetvol(int what, int left, int right)
{
	int id;
	ulong x;
	int can, v;
	
	if(cfd &lt; 0)
		error("audio device not open");
	if(what == Vspeed){
		x = left;
		if(ioctl(afd, SNDCTL_DSP_SPEED, &amp;x) &lt; 0)
			oserror();
		speed = x;
		return;
	}
	if((id = lookname(what)) &lt; 0)
		return;
	if(ioctl(cfd, SOUND_MIXER_READ_DEVMASK, &amp;can) &lt; 0)
		can = ~0;
	if(!(can &amp; (1&lt;&lt;id)))
		return;
	v = left | (right&lt;&lt;8);
	if(ioctl(cfd, MIXER_WRITE(id), &amp;v) &lt; 0)
		oserror();
}

void
audiodevgetvol(int what, int *left, int *right)
{
	int id;
	int can, v;
	
	if(cfd &lt; 0)
		error("audio device not open");
	if(what == Vspeed){
		*left = *right = speed;
		return;
	}
	if((id = lookname(what)) &lt; 0)
		return;
	if(ioctl(cfd, SOUND_MIXER_READ_DEVMASK, &amp;can) &lt; 0)
		can = ~0;
	if(!(can &amp; (1&lt;&lt;id)))
		return;
	if(ioctl(cfd, MIXER_READ(id), &amp;v) &lt; 0)
		oserror();
	*left = v&amp;0xFF;
	*right = (v&gt;&gt;8)&amp;0xFF;
}

int
audiodevwrite(void *v, int n)
{
	int m, tot;
	
	for(tot=0; tot&lt;n; tot+=m)
		if((m = write(afd, (uchar*)v+tot, n-tot)) &lt;= 0)
			oserror();
	return tot;
}

int
audiodevread(void *v, int n)
{
	error("no reading");
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

