<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devaudio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devaudio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"
#include	"devaudio.h"

enum
{
	Qdir		= 0,
	Qaudio,
	Qvolume,

	Aclosed		= 0,
	Aread,
	Awrite,

	Speed		= 44100,
	Ncmd		= 50,		/* max volume command words */
};

Dirtab
audiodir[] =
{
	".",	{Qdir, 0, QTDIR},		0,	DMDIR|0555,
	"audio",	{Qaudio},		0,	0666,
	"volume",	{Qvolume},		0,	0666,
};

static	struct
{
	QLock	lk;
	Rendez	vous;
	int	amode;		/* Aclosed/Aread/Awrite for /audio */
} audio;

#define aqlock(a) qlock(&amp;(a)-&gt;lk)
#define aqunlock(a) qunlock(&amp;(a)-&gt;lk)

static	struct
{
	char*	name;
	int	flag;
	int	ilval;		/* initial values */
	int	irval;
} volumes[] =
{
	"audio",	Fout, 		50,	50,
	"synth",	Fin|Fout,	0,	0,
	"cd",		Fin|Fout,	0,	0,
	"line",	Fin|Fout,	0,	0,
	"mic",	Fin|Fout|Fmono,	0,	0,
	"speaker",	Fout|Fmono,	0,	0,

	"treb",		Fout, 		50,	50,
	"bass",		Fout, 		50,	50,

	"speed",	Fin|Fout|Fmono,	Speed,	Speed,
	0
};

static	char	Emode[]		= "illegal open mode";
static	char	Evolume[]	= "illegal volume specifier";

static	void
resetlevel(void)
{
	int i;

	for(i=0; volumes[i].name; i++)
		audiodevsetvol(i, volumes[i].ilval, volumes[i].irval);
}

static void
audioinit(void)
{
}

static Chan*
audioattach(char *param)
{
	return devattach('A', param);
}

static Walkqid*
audiowalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, audiodir, nelem(audiodir), devgen);
}

static int
audiostat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, audiodir, nelem(audiodir), devgen);
}

static Chan*
audioopen(Chan *c, int omode)
{
	int amode;

	switch((ulong)c-&gt;qid.path) {
	default:
		error(Eperm);
		break;

	case Qvolume:
	case Qdir:
		break;

	case Qaudio:
		amode = Awrite;
		if((omode&amp;7) == OREAD)
			amode = Aread;
		aqlock(&amp;audio);
		if(waserror()){
			aqunlock(&amp;audio);
			nexterror();
		}
		if(audio.amode != Aclosed)
			error(Einuse);
		audiodevopen();
		audio.amode = amode;
		poperror();
		aqunlock(&amp;audio);
		break;
	}
	c = devopen(c, omode, audiodir, nelem(audiodir), devgen);
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;

	return c;
}

static void
audioclose(Chan *c)
{
	switch((ulong)c-&gt;qid.path) {
	default:
		error(Eperm);
		break;

	case Qdir:
	case Qvolume:
		break;

	case Qaudio:
		if(c-&gt;flag &amp; COPEN) {
			aqlock(&amp;audio);
			audiodevclose();
			audio.amode = Aclosed;
			aqunlock(&amp;audio);
		}
		break;
	}
}

static long
audioread(Chan *c, void *v, long n, vlong off)
{
	int liv, riv, lov, rov;
	long m;
	char buf[300];
	int j;
	ulong offset = off;
	char *a;

	a = v;
	switch((ulong)c-&gt;qid.path) {
	default:
		error(Eperm);
		break;

	case Qdir:
		return devdirread(c, a, n, audiodir, nelem(audiodir), devgen);

	case Qaudio:
		if(audio.amode != Aread)
			error(Emode);
		aqlock(&amp;audio);
		if(waserror()){
			aqunlock(&amp;audio);
			nexterror();
		}
		n = audiodevread(v, n);
		poperror();
		aqunlock(&amp;audio);
		break;

	case Qvolume:
		j = 0;
		buf[0] = 0;
		for(m=0; volumes[m].name; m++){
			audiodevgetvol(m, &amp;lov, &amp;rov);
			liv = lov;
			riv = rov;
			j += snprint(buf+j, sizeof(buf)-j, "%s", volumes[m].name);
			if((volumes[m].flag &amp; Fmono) || (liv==riv &amp;&amp; lov==rov)){
				if((volumes[m].flag&amp;(Fin|Fout))==(Fin|Fout) &amp;&amp; liv==lov)
					j += snprint(buf+j, sizeof(buf)-j, " %d", liv);
				else{
					if(volumes[m].flag &amp; Fin)
						j += snprint(buf+j, sizeof(buf)-j,
							" in %d", liv);
					if(volumes[m].flag &amp; Fout)
						j += snprint(buf+j, sizeof(buf)-j,
							" out %d", lov);
				}
			}else{
				if((volumes[m].flag&amp;(Fin|Fout))==(Fin|Fout) &amp;&amp;
				    liv==lov &amp;&amp; riv==rov)
					j += snprint(buf+j, sizeof(buf)-j,
						" left %d right %d",
						liv, riv);
				else{
					if(volumes[m].flag &amp; Fin)
						j += snprint(buf+j, sizeof(buf)-j,
							" in left %d right %d",
							liv, riv);
					if(volumes[m].flag &amp; Fout)
						j += snprint(buf+j, sizeof(buf)-j,
							" out left %d right %d",
							lov, rov);
				}
			}
			j += snprint(buf+j, sizeof(buf)-j, "\n");
		}
		return readstr(offset, a, n, buf);
	}
	return n;
}

static long
audiowrite(Chan *c, void *vp, long n, vlong off)
{
	long m;
	int i, v, left, right, in, out;
	Cmdbuf *cb;
	char *a;

	USED(off);
	a = vp;
	switch((ulong)c-&gt;qid.path) {
	default:
		error(Eperm);
		break;

	case Qvolume:
		v = Vaudio;
		left = 1;
		right = 1;
		in = 1;
		out = 1;
		cb = parsecmd(vp, n);
		if(waserror()){
			free(cb);
			nexterror();
		}

		for(i = 0; i &lt; cb-&gt;nf; i++){
			/*
			 * a number is volume
			 */
			if(cb-&gt;f[i][0] &gt;= '0' &amp;&amp; cb-&gt;f[i][0] &lt;= '9') {
				m = strtoul(cb-&gt;f[i], 0, 10);
				if(!out)
					goto cont0;
				if(left &amp;&amp; right)
					audiodevsetvol(v, m, m);
				else if(left)
					audiodevsetvol(v, m, -1);
				else if(right)
					audiodevsetvol(v, -1, m);
				goto cont0;
			}

			for(m=0; volumes[m].name; m++) {
				if(strcmp(cb-&gt;f[i], volumes[m].name) == 0) {
					v = m;
					in = 1;
					out = 1;
					left = 1;
					right = 1;
					goto cont0;
				}
			}

			if(strcmp(cb-&gt;f[i], "reset") == 0) {
				resetlevel();
				goto cont0;
			}
			if(strcmp(cb-&gt;f[i], "in") == 0) {
				in = 1;
				out = 0;
				goto cont0;
			}
			if(strcmp(cb-&gt;f[i], "out") == 0) {
				in = 0;
				out = 1;
				goto cont0;
			}
			if(strcmp(cb-&gt;f[i], "left") == 0) {
				left = 1;
				right = 0;
				goto cont0;
			}
			if(strcmp(cb-&gt;f[i], "right") == 0) {
				left = 0;
				right = 1;
				goto cont0;
			}
			error(Evolume);
			break;
		cont0:;
		}
		free(cb);
		poperror();
		break;

	case Qaudio:
		if(audio.amode != Awrite)
			error(Emode);
		aqlock(&amp;audio);
		if(waserror()){
			aqunlock(&amp;audio);
			nexterror();
		}
		n = audiodevwrite(vp, n);
		poperror();
		aqunlock(&amp;audio);
		break;
	}
	return n;
}

void
audioswab(uchar *a, uint n)
{
	ulong *p, *ep, b;

	p = (ulong*)a;
	ep = p + (n&gt;&gt;2);
	while(p &lt; ep) {
		b = *p;
		b = (b&gt;&gt;24) | (b&lt;&lt;24) |
			((b&amp;0xff0000) &gt;&gt; 8) |
			((b&amp;0x00ff00) &lt;&lt; 8);
		*p++ = b;
	}
}

Dev audiodevtab = {
	'A',
	"audio",

	devreset,
	audioinit,
	devshutdown,
	audioattach,
	audiowalk,
	audiostat,
	audioopen,
	devcreate,
	audioclose,
	audioread,
	devbread,
	audiowrite,
	devbwrite,
	devremove,
	devwstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

