<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devfs-win32.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devfs-win32.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Disable Unicode until the calls to FindFirstFile etc
 * are changed to use wide character strings.
 */
#undef UNICODE
#include	&lt;windows.h&gt;
#include	&lt;sys/types.h&gt;
#include	&lt;sys/stat.h&gt;
#include	&lt;fcntl.h&gt;

#ifndef NAME_MAX
#	define NAME_MAX 256
#endif
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

typedef struct DIR	DIR;
typedef	struct Ufsinfo	Ufsinfo;

enum
{
	NUID	= 256,
	NGID	= 256,
	MAXPATH	= 1024,
	MAXCOMP	= 128
};

struct DIR
{
	HANDLE	handle;
	char*	path;
	int	index;
	WIN32_FIND_DATA	wfd;
};

struct Ufsinfo
{
	int	mode;
	int	fd;
	int	uid;
	int	gid;
	DIR*	dir;
	ulong	offset;
	QLock	oq;
	char nextname[NAME_MAX];
};

DIR*	opendir(char*);
int	readdir(char*, DIR*);
void	closedir(DIR*);
void	rewinddir(DIR*);

char	*base = "c:/.";

static	Qid	fsqid(char*, struct stat *);
static	void	fspath(Chan*, char*, char*);
// static	void	fsperm(Chan*, int);
static	ulong	fsdirread(Chan*, uchar*, int, ulong);
static	int	fsomode(int);
static  int	chown(char *path, int uid, int);

/* clumsy hack, but not worse than the Path stuff in the last one */
static char*
uc2name(Chan *c)
{
	char *s;

	if(c-&gt;name == nil)
		return "/";
	s = c2name(c);
	if(s[0]=='#' &amp;&amp; s[1]=='U')
		return s+2;
	return s;
}

static char*
lastelem(Chan *c)
{
	char *s, *t;

	s = uc2name(c);
	if((t = strrchr(s, '/')) == nil)
		return s;
	if(t[1] == 0)
		return t;
	return t+1;
}
	
static Chan*
fsattach(char *spec)
{
	Chan *c;
	struct stat stbuf;
	static int devno;
	Ufsinfo *uif;

	if(stat(base, &amp;stbuf) &lt; 0)
		error(strerror(errno));

	c = devattach('U', spec);

	uif = mallocz(sizeof(Ufsinfo), 1);
	uif-&gt;gid = stbuf.st_gid;
	uif-&gt;uid = stbuf.st_uid;
	uif-&gt;mode = stbuf.st_mode;

	c-&gt;aux = uif;
	c-&gt;dev = devno++;
	c-&gt;qid.type = QTDIR;
/*print("fsattach %s\n", c2name(c));*/

	return c;
}

static Chan*
fsclone(Chan *c, Chan *nc)
{
	Ufsinfo *uif;

	uif = mallocz(sizeof(Ufsinfo), 1);
	*uif = *(Ufsinfo*)c-&gt;aux;
	nc-&gt;aux = uif;

	return nc;
}

static int
fswalk1(Chan *c, char *name)
{
	struct stat stbuf;
	char path[MAXPATH];
	Ufsinfo *uif;

	fspath(c, name, path);

	/*	print("** fs walk '%s' -&gt; %s\n", path, name); */

	if(stat(path, &amp;stbuf) &lt; 0)
		return 0;

	uif = c-&gt;aux;

	uif-&gt;gid = stbuf.st_gid;
	uif-&gt;uid = stbuf.st_uid;
	uif-&gt;mode = stbuf.st_mode;

	c-&gt;qid = fsqid(path, &amp;stbuf);

	return 1;
}

extern Cname* addelem(Cname*, char*);

static Walkqid*
fswalk(Chan *c, Chan *nc, char **name, int nname)
{
	int i;
	Cname *cname;
	Walkqid *wq;

	if(nc != nil)
		panic("fswalk: nc != nil");
	wq = smalloc(sizeof(Walkqid)+(nname-1)*sizeof(Qid));
	nc = devclone(c);
	cname = c-&gt;name;
	incref(&amp;cname-&gt;ref);

	fsclone(c, nc);
	wq-&gt;clone = nc;
	for(i=0; i&lt;nname; i++){
		nc-&gt;name = cname;
		if(fswalk1(nc, name[i]) == 0)
			break;
		cname = addelem(cname, name[i]);
		wq-&gt;qid[i] = nc-&gt;qid;
	}
	nc-&gt;name = cname;
	if(i != nname){
		cclose(nc);
		wq-&gt;clone = nil;
	}
	wq-&gt;nqid = i;
	return wq;
}
	
static int
fsstat(Chan *c, uchar *buf, int n)
{
	Dir d;
	struct stat stbuf;
	char path[MAXPATH];

	if(n &lt; BIT16SZ)
		error(Eshortstat);

	fspath(c, 0, path);
	if(stat(path, &amp;stbuf) &lt; 0)
		error(strerror(errno));

	d.name = lastelem(c);
	d.uid = "unknown";
	d.gid = "unknown";
	d.muid = "unknown";
	d.qid = c-&gt;qid;
	d.mode = (c-&gt;qid.type&lt;&lt;24)|(stbuf.st_mode&amp;0777);
	d.atime = stbuf.st_atime;
	d.mtime = stbuf.st_mtime;
	d.length = stbuf.st_size;
	d.type = 'U';
	d.dev = c-&gt;dev;
	return convD2M(&amp;d, buf, n);
}

static Chan*
fsopen(Chan *c, int mode)
{
	char path[MAXPATH];
	int m, isdir;
	Ufsinfo *uif;

/*print("fsopen %s\n", c2name(c));*/
	m = mode &amp; (OTRUNC|3);
	switch(m) {
	case 0:
		break;
	case 1:
	case 1|16:
		break;
	case 2:	
	case 0|16:
	case 2|16:
		break;
	case 3:
		break;
	default:
		error(Ebadarg);
	}

	isdir = c-&gt;qid.type &amp; QTDIR;

	if(isdir &amp;&amp; mode != OREAD)
		error(Eperm);

	m = fsomode(m &amp; 3);
	c-&gt;mode = openmode(mode);

	uif = c-&gt;aux;

	fspath(c, 0, path);
	if(isdir) {
		uif-&gt;dir = opendir(path);
		if(uif-&gt;dir == 0)
			error(strerror(errno));
	}	
	else {
		if(mode &amp; OTRUNC)
			m |= O_TRUNC;
		uif-&gt;fd = open(path, m|_O_BINARY, 0666);

		if(uif-&gt;fd &lt; 0)
			error(strerror(errno));
	}
	uif-&gt;offset = 0;

	c-&gt;offset = 0;
	c-&gt;flag |= COPEN;
	return c;
}

static void
fscreate(Chan *c, char *name, int mode, ulong perm)
{
	int fd, m;
	char path[MAXPATH];
	struct stat stbuf;
	Ufsinfo *uif;

	m = fsomode(mode&amp;3);

	fspath(c, name, path);

	uif = c-&gt;aux;

	if(perm &amp; DMDIR) {
		if(m)
			error(Eperm);

		if(mkdir(path) &lt; 0)
			error(strerror(errno));

		fd = open(path, 0);
		if(fd &gt;= 0) {
			chmod(path, perm &amp; 0777);
			chown(path, uif-&gt;uid, uif-&gt;uid);
		}
		close(fd);

		uif-&gt;dir = opendir(path);
		if(uif-&gt;dir == 0)
			error(strerror(errno));
	}
	else {
		fd = open(path, _O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC, 0666);
		if(fd &gt;= 0) {
			if(m != 1) {
				close(fd);
				fd = open(path, m|_O_BINARY);
			}
			chmod(path, perm &amp; 0777);
			chown(path, uif-&gt;uid, uif-&gt;gid);
		}
		if(fd &lt; 0)
			error(strerror(errno));
		uif-&gt;fd = fd;
	}

	if(stat(path, &amp;stbuf) &lt; 0)
		error(strerror(errno));
	c-&gt;qid = fsqid(path, &amp;stbuf);
	c-&gt;offset = 0;
	c-&gt;flag |= COPEN;
	c-&gt;mode = openmode(mode);
}

static void
fsclose(Chan *c)
{
	Ufsinfo *uif;

	uif = c-&gt;aux;

	if(c-&gt;flag &amp; COPEN) {
		if(c-&gt;qid.type &amp; QTDIR)
			closedir(uif-&gt;dir);
		else
			close(uif-&gt;fd);
	}

	free(uif);
}

static long
fsread(Chan *c, void *va, long n, vlong offset)
{
	int fd, r;
	Ufsinfo *uif;

/*print("fsread %s\n", c2name(c));*/
	if(c-&gt;qid.type &amp; QTDIR)
		return fsdirread(c, va, n, offset);

	uif = c-&gt;aux;
	qlock(&amp;uif-&gt;oq);
	if(waserror()) {
		qunlock(&amp;uif-&gt;oq);
		nexterror();
	}
	fd = uif-&gt;fd;
	if(uif-&gt;offset != offset) {
		r = lseek(fd, offset, 0);
		if(r &lt; 0)
			error(strerror(errno));
		uif-&gt;offset = offset;
	}

	n = read(fd, va, n);
	if(n &lt; 0)
		error(strerror(errno));

	uif-&gt;offset += n;
	qunlock(&amp;uif-&gt;oq);
	poperror();

	return n;
}

static long
fswrite(Chan *c, void *va, long n, vlong offset)
{
	int fd, r;
	Ufsinfo *uif;

	uif = c-&gt;aux;

	qlock(&amp;uif-&gt;oq);
	if(waserror()) {
		qunlock(&amp;uif-&gt;oq);
		nexterror();
	}
	fd = uif-&gt;fd;
	if(uif-&gt;offset != offset) {
		r = lseek(fd, offset, 0);
		if(r &lt; 0)
			error(strerror(errno));
		uif-&gt;offset = offset;
	}

	n = write(fd, va, n);
	if(n &lt; 0)
		error(strerror(errno));

	uif-&gt;offset += n;
	qunlock(&amp;uif-&gt;oq);
	poperror();

	return n;
}

static void
fsremove(Chan *c)
{
	int n;
	char path[MAXPATH];

	fspath(c, 0, path);
	if(c-&gt;qid.type &amp; QTDIR)
		n = rmdir(path);
	else
		n = remove(path);
	if(n &lt; 0)
		error(strerror(errno));
}

static int
fswstat(Chan *c, uchar *buf, int n)
{
	Dir d;
	struct stat stbuf;
	char old[MAXPATH], new[MAXPATH];
	char strs[MAXPATH*3], *p;
	Ufsinfo *uif;

	if (convM2D(buf, n, &amp;d, strs) != n)
		error(Ebadstat);
	
	fspath(c, 0, old);
	if(stat(old, &amp;stbuf) &lt; 0)
		error(strerror(errno));

	uif = c-&gt;aux;

//	if(uif-&gt;uid != stbuf.st_uid)
//		error(Eowner);

	if(d.name[0] &amp;&amp; strcmp(d.name, lastelem(c)) != 0) {
		fspath(c, 0, old);
		strcpy(new, old);
		p = strrchr(new, '/');
		strcpy(p+1, d.name);
		if(rename(old, new) &lt; 0)
			error(strerror(errno));
	}

	fspath(c, 0, old);
	if(~d.mode != 0 &amp;&amp; (int)(d.mode&amp;0777) != (int)(stbuf.st_mode&amp;0777)) {
		if(chmod(old, d.mode&amp;0777) &lt; 0)
			error(strerror(errno));
		uif-&gt;mode &amp;= ~0777;
		uif-&gt;mode |= d.mode&amp;0777;
	}
/*
	p = name2pass(gid, d.gid);
	if(p == 0)
		error(Eunknown);

	if(p-&gt;id != stbuf.st_gid) {
		if(chown(old, stbuf.st_uid, p-&gt;id) &lt; 0)
			error(sys_errlist[errno]);

		uif-&gt;gid = p-&gt;id;
	}
*/
	return n;
}

static Qid
fsqid(char *p, struct stat *st)
{
	Qid q;
	int dev;
	ulong h;
	static int nqdev;
	static uchar *qdev;

	if(qdev == 0)
		qdev = mallocz(65536U, 1);

	q.type = 0;
	if((st-&gt;st_mode&amp;S_IFMT) ==  S_IFDIR)
		q.type = QTDIR;

	dev = st-&gt;st_dev &amp; 0xFFFFUL;
	if(qdev[dev] == 0)
		qdev[dev] = ++nqdev;

	h = 0;
	while(*p != '\0')
		h += *p++ * 13;
	
	q.path = (vlong)qdev[dev]&lt;&lt;32;
	q.path |= h;
	q.vers = st-&gt;st_mtime;

	return q;
}

static void
fspath(Chan *c, char *ext, char *path)
{
	strcpy(path, base);
	strcat(path, "/");
	strcat(path, uc2name(c));
	if(ext) {
		strcat(path, "/");
		strcat(path, ext);
	}
	cleanname(path);
}

static int
isdots(char *name)
{
	if(name[0] != '.')
		return 0;
	if(name[1] == '\0')
		return 1;
	if(name[1] != '.')
		return 0;
	if(name[2] == '\0')
		return 1;
	return 0;
}

static int
p9readdir(char *name, Ufsinfo *uif)
{
	if(uif-&gt;nextname[0]){
		strcpy(name, uif-&gt;nextname);
		uif-&gt;nextname[0] = 0;
		return 1;
	}

	return readdir(name, uif-&gt;dir);
}

static ulong
fsdirread(Chan *c, uchar *va, int count, ulong offset)
{
	int i;
	Dir d;
	long n;
	char de[NAME_MAX];
	struct stat stbuf;
	char path[MAXPATH], dirpath[MAXPATH];
	Ufsinfo *uif;

/*print("fsdirread %s\n", c2name(c));*/
	i = 0;
	uif = c-&gt;aux;

	errno = 0;
	if(uif-&gt;offset != offset) {
		if(offset != 0)
			error("bad offset in fsdirread");
		uif-&gt;offset = offset;  /* sync offset */
		uif-&gt;nextname[0] = 0;
		rewinddir(uif-&gt;dir);
	}

	fspath(c, 0, dirpath);

	while(i+BIT16SZ &lt; count) {
		if(!p9readdir(de, uif))
			break;

		if(de[0]==0 || isdots(de))
			continue;

		d.name = de;
		sprint(path, "%s/%s", dirpath, de);
		memset(&amp;stbuf, 0, sizeof stbuf);

		if(stat(path, &amp;stbuf) &lt; 0) {
			print("dir: bad path %s\n", path);
			/* but continue... probably a bad symlink */
		}

		d.uid = "unknown";
		d.gid = "unknown";
		d.muid = "unknown";
		d.qid = fsqid(path, &amp;stbuf);
		d.mode = (d.qid.type&lt;&lt;24)|(stbuf.st_mode&amp;0777);
		d.atime = stbuf.st_atime;
		d.mtime = stbuf.st_mtime;
		d.length = stbuf.st_size;
		d.type = 'U';
		d.dev = c-&gt;dev;
		n = convD2M(&amp;d, (uchar*)va+i, count-i);
		if(n == BIT16SZ){
			strcpy(uif-&gt;nextname, de);
			break;
		}
		i += n;
	}
/*print("got %d\n", i);*/
	uif-&gt;offset += i;
	return i;
}

static int
fsomode(int m)
{
	switch(m) {
	case 0:			/* OREAD */
	case 3:			/* OEXEC */
		return 0;
	case 1:			/* OWRITE */
		return 1;
	case 2:			/* ORDWR */
		return 2;
	}
	error(Ebadarg);
	return 0;
}
void
closedir(DIR *d)
{
	FindClose(d-&gt;handle);
	free(d-&gt;path);
}

int
readdir(char *name, DIR *d)
{
	if(d-&gt;index != 0) {
		if(FindNextFile(d-&gt;handle, &amp;d-&gt;wfd) == FALSE)
			return 0;
	}
	strcpy(name, (char*)d-&gt;wfd.cFileName);
	d-&gt;index++;

	return 1;
}

void
rewinddir(DIR *d)
{
	FindClose(d-&gt;handle);
	d-&gt;handle = FindFirstFile(d-&gt;path, &amp;d-&gt;wfd);
	d-&gt;index = 0;
}

static int
chown(char *path, int uid, int perm)
{
/*	panic("chown"); */
	return 0;
}

DIR*
opendir(char *p)
{
	DIR *d;
	char path[MAX_PATH];

	
	snprint(path, sizeof(path), "%s/*.*", p);

	d = mallocz(sizeof(DIR), 1);
	if(d == 0)
		return 0;

	d-&gt;index = 0;

	d-&gt;handle = FindFirstFile(path, &amp;d-&gt;wfd);
	if(d-&gt;handle == INVALID_HANDLE_VALUE) {
		free(d);
		return 0;
	}

	d-&gt;path = strdup(path);
	return d;
}

Dev fsdevtab = {
	'U',
	"fs",

	devreset,
	devinit,
	devshutdown,
	fsattach,
	fswalk,
	fsstat,
	fsopen,
	fscreate,
	fsclose,
	fsread,
	devbread,
	fswrite,
	devbwrite,
	fsremove,
	fswstat,
};
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

