<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devip-posix.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devip-posix.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;sys/types.h&gt;
#include &lt;sys/socket.h&gt;
#include &lt;netinet/in.h&gt;
#include &lt;netinet/tcp.h&gt;
#include &lt;netdb.h&gt;
#include &lt;arpa/inet.h&gt;

#include "u.h"
#include "lib.h"
#include "dat.h"
#include "fns.h"
#include "error.h"
#include "ip.h"

#include "devip.h"

#undef listen
#undef accept
#undef bind

static int
family(unsigned char *addr)
{
	if(isv4(addr))
		return AF_INET;
	return AF_INET6;
}

static int
addrlen(struct sockaddr_storage *ss)
{
	switch(ss-&gt;ss_family){
	case AF_INET:
		return sizeof(struct sockaddr_in);
	case AF_INET6:
		return sizeof(struct sockaddr_in6);
	}
	return 0;
}

void
osipinit(void)
{
	char buf[1024];
	gethostname(buf, sizeof(buf));
	kstrdup(&amp;sysname, buf);

}

int
so_socket(int type, unsigned char *addr)
{
	int fd, one;

	switch(type) {
	default:
		error("bad protocol type");
	case S_TCP:
		type = SOCK_STREAM;
		break;
	case S_UDP:
		type = SOCK_DGRAM;
		break;
	}

	fd = socket(family(addr), type, 0);
	if(fd &lt; 0)
		oserror();

	one = 1;
	if(setsockopt(fd, IPPROTO_TCP, TCP_NODELAY, (char*)&amp;one, sizeof(one)) &gt; 0){
		oserrstr();
		print("setsockopt: %r");
	}

	return fd;
}

void
so_connect(int fd, unsigned char *raddr, unsigned short rport)
{
	struct sockaddr_storage ss;

	memset(&amp;ss, 0, sizeof(ss));

	ss.ss_family = family(raddr);

	switch(ss.ss_family){
	case AF_INET:
		hnputs(&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_port, rport);
		v6tov4((unsigned char*)&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_addr.s_addr, raddr);
		break;
	case AF_INET6:
		hnputs(&amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_port, rport);
		memcpy(&amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_addr.s6_addr, raddr, sizeof(struct in6_addr));
		break;
	}

	if(connect(fd, (struct sockaddr*)&amp;ss, addrlen(&amp;ss)) &lt; 0)
		oserror();
}

void
so_getsockname(int fd, unsigned char *laddr, unsigned short *lport)
{
	socklen_t len;
	struct sockaddr_storage ss;

	len = sizeof(ss);
	if(getsockname(fd, (struct sockaddr*)&amp;ss, &amp;len) &lt; 0)
		oserror();

	switch(ss.ss_family){
	case AF_INET:
		v4tov6(laddr, (unsigned char*)&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_addr.s_addr);
		*lport = nhgets(&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_port);
		break;
	case AF_INET6:
		memcpy(laddr, &amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_addr.s6_addr, sizeof(struct in6_addr));
		*lport = nhgets(&amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_port);
		break;
	default:
		error("not AF_INET or AF_INET6");
	}
}

void
so_listen(int fd)
{
	if(listen(fd, 5) &lt; 0)
		oserror();
}

int
so_accept(int fd, unsigned char *raddr, unsigned short *rport)
{
	int nfd;
	socklen_t len;
	struct sockaddr_storage ss;

	len = sizeof(ss);
	nfd = accept(fd, (struct sockaddr*)&amp;ss, &amp;len);
	if(nfd &lt; 0)
		oserror();

	switch(ss.ss_family){
	case AF_INET:
		v4tov6(raddr, (unsigned char*)&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_addr.s_addr);
		*rport = nhgets(&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_port);
		break;
	case AF_INET6:
		memcpy(raddr, &amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_addr.s6_addr, sizeof(struct in6_addr));
		*rport = nhgets(&amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_port);
		break;
	default:
		error("not AF_INET or AF_INET6");
	}
	return nfd;
}

void
so_bind(int fd, int su, unsigned short port, unsigned char *addr)
{
	int i, one;
	struct sockaddr_storage ss;

	one = 1;
	if(setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char*)&amp;one, sizeof(one)) &lt; 0){
		oserrstr();
		print("setsockopt: %r");
	}

	if(su) {
		for(i = 600; i &lt; 1024; i++) {
			memset(&amp;ss, 0, sizeof(ss));
			ss.ss_family = family(addr);

			switch(ss.ss_family){
			case AF_INET:
				((struct sockaddr_in*)&amp;ss)-&gt;sin_port = i;
				break;
			case AF_INET6:
				((struct sockaddr_in6*)&amp;ss)-&gt;sin6_port = i;
				break;
			}

			if(bind(fd, (struct sockaddr*)&amp;ss, addrlen(&amp;ss)) &gt;= 0)	
				return;
		}
		oserror();
	}

	memset(&amp;ss, 0, sizeof(ss));
	ss.ss_family = family(addr);

	switch(ss.ss_family){
	case AF_INET:
		hnputs(&amp;((struct sockaddr_in*)&amp;ss)-&gt;sin_port, port);
		break;
	case AF_INET6:
		hnputs(&amp;((struct sockaddr_in6*)&amp;ss)-&gt;sin6_port, port);
		break;
	}

	if(bind(fd, (struct sockaddr*)&amp;ss, addrlen(&amp;ss)) &lt; 0)
		oserror();
}

int
so_gethostbyname(char *host, char**hostv, int n)
{
	int i;
	char buf[32];
	unsigned char *p;
	struct hostent *hp;

	hp = gethostbyname(host);
	if(hp == 0)
		return 0;

	for(i = 0; hp-&gt;h_addr_list[i] &amp;&amp; i &lt; n; i++) {
		p = (unsigned char*)hp-&gt;h_addr_list[i];
		sprint(buf, "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
		hostv[i] = strdup(buf);
		if(hostv[i] == 0)
			break;
	}
	return i;
}

char*
hostlookup(char *host)
{
	char buf[INET6_ADDRSTRLEN];
	uchar *p;
	struct hostent *he;
	struct addrinfo *result;

	he = gethostbyname(host);
	if(he != 0 &amp;&amp; he-&gt;h_addr_list[0]) {
		p = (uchar*)he-&gt;h_addr_list[0];
		sprint(buf, "%ud.%ud.%ud.%ud", p[0], p[1], p[2], p[3]);
	} else if(getaddrinfo(host, NULL, NULL, &amp;result) == 0) {
		switch (result-&gt;ai_family) {
		case AF_INET:
			inet_ntop(AF_INET, &amp;((struct sockaddr_in*)result-&gt;ai_addr)-&gt;sin_addr, buf, sizeof(buf));
			break;
		case AF_INET6:
			inet_ntop(AF_INET6, &amp;((struct sockaddr_in6*)result-&gt;ai_addr)-&gt;sin6_addr, buf, sizeof(buf));
			break;
		default:
			return nil;
		}
	} else
		return nil;

	return strdup(buf);
}

int
so_getservbyname(char *service, char *net, char *port)
{
	struct servent *s;

	s = getservbyname(service, net);
	if(s == 0)
		return -1;

	sprint(port, "%d", nhgets(&amp;s-&gt;s_port));
	return 0;
}

int
so_send(int fd, void *d, int n, int f)
{
	return send(fd, d, n, f);
}

int
so_recv(int fd, void *d, int n, int f)
{
	return recv(fd, d, n, f);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

