<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devip.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devip.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "u.h"
#include "lib.h"
#include "dat.h"
#include "fns.h"
#include "error.h"
#include "ip.h"

#include "devip.h"

void	csclose(Chan*);
long	csread(Chan*, void*, long, vlong);
long	cswrite(Chan*, void*, long, vlong);

void osipinit(void);

enum
{
	Qtopdir		= 1,	/* top level directory */
	Qcs,
	Qprotodir,		/* directory for a protocol */
	Qclonus,
	Qconvdir,		/* directory for a conversation */
	Qdata,
	Qctl,
	Qstatus,
	Qremote,
	Qlocal,
	Qlisten,

	MAXPROTO	= 4
};
#define TYPE(x) 	((int)((x).path &amp; 0xf))
#define CONV(x) 	((int)(((x).path &gt;&gt; 4)&amp;0xfff))
#define PROTO(x) 	((int)(((x).path &gt;&gt; 16)&amp;0xff))
#define QID(p, c, y) 	(((p)&lt;&lt;16) | ((c)&lt;&lt;4) | (y))
#define ipzero(x)	memset(x, 0, IPaddrlen)

typedef struct Proto	Proto;
typedef struct Conv	Conv;
struct Conv
{
	int	x;
	Ref	r;
	int	sfd;
	int	perm;
	char	owner[KNAMELEN];
	char*	state;
	uchar	laddr[IPaddrlen];
	ushort	lport;
	uchar	raddr[IPaddrlen];
	ushort	rport;
	int	restricted;
	char	cerr[KNAMELEN];
	Proto*	p;
};

struct Proto
{
	Lock	l;
	int	x;
	int	stype;
	char	name[KNAMELEN];
	int	nc;
	int	maxconv;
	Conv**	conv;
	Qid	qid;
};

static	int	np;
static	Proto	proto[MAXPROTO];

static	Conv*	protoclone(Proto*, char*, int);
static	void	setladdr(Conv*);

int
ipgen(Chan *c, char *nname, Dirtab *d, int nd, int s, Dir *dp)
{
	Qid q;
	Conv *cv;
	char *p;

	USED(nname);
	q.vers = 0;
	q.type = 0;
	switch(TYPE(c-&gt;qid)) {
	case Qtopdir:
		if(s &gt;= 1+np)
			return -1;

		if(s == 0){
			q.path = QID(s, 0, Qcs);
			devdir(c, q, "cs", 0, "network", 0666, dp);
		}else{
			s--;
			q.path = QID(s, 0, Qprotodir);
			q.type = QTDIR;
			devdir(c, q, proto[s].name, 0, "network", DMDIR|0555, dp);
		}
		return 1;
	case Qprotodir:
		if(s &lt; proto[PROTO(c-&gt;qid)].nc) {
			cv = proto[PROTO(c-&gt;qid)].conv[s];
			sprint(up-&gt;genbuf, "%d", s);
			q.path = QID(PROTO(c-&gt;qid), s, Qconvdir);
			q.type = QTDIR;
			devdir(c, q, up-&gt;genbuf, 0, cv-&gt;owner, DMDIR|0555, dp);
			return 1;
		}
		s -= proto[PROTO(c-&gt;qid)].nc;
		switch(s) {
		default:
			return -1;
		case 0:
			p = "clone";
			q.path = QID(PROTO(c-&gt;qid), 0, Qclonus);
			break;
		}
		devdir(c, q, p, 0, "network", 0555, dp);
		return 1;
	case Qconvdir:
		cv = proto[PROTO(c-&gt;qid)].conv[CONV(c-&gt;qid)];
		switch(s) {
		default:
			return -1;
		case 0:
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qdata);
			devdir(c, q, "data", 0, cv-&gt;owner, cv-&gt;perm, dp);
			return 1;
		case 1:
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qctl);
			devdir(c, q, "ctl", 0, cv-&gt;owner, cv-&gt;perm, dp);
			return 1;
		case 2:
			p = "status";
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qstatus);
			break;
		case 3:
			p = "remote";
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qremote);
			break;
		case 4:
			p = "local";
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qlocal);
			break;
		case 5:
			p = "listen";
			q.path = QID(PROTO(c-&gt;qid), CONV(c-&gt;qid), Qlisten);
			break;
		}
		devdir(c, q, p, 0, cv-&gt;owner, 0444, dp);
		return 1;
	}
	return -1;
}

static void
newproto(char *name, int type, int maxconv)
{
	int l;
	Proto *p;

	if(np &gt;= MAXPROTO) {
		print("no %s: increase MAXPROTO", name);
		return;
	}

	p = &amp;proto[np];
	strcpy(p-&gt;name, name);
	p-&gt;stype = type;
	p-&gt;qid.path = QID(np, 0, Qprotodir);
	p-&gt;qid.type = QTDIR;
	p-&gt;x = np++;
	p-&gt;maxconv = maxconv;
	l = sizeof(Conv*)*(p-&gt;maxconv+1);
	p-&gt;conv = mallocz(l, 1);
	if(p-&gt;conv == 0)
		panic("no memory");
}

void
ipinit(void)
{
	osipinit();

	newproto("udp", S_UDP, 10);
	newproto("tcp", S_TCP, 30);

	fmtinstall('I', eipfmt);
	fmtinstall('E', eipfmt);
	
}

Chan *
ipattach(char *spec)
{
	Chan *c;

	c = devattach('I', spec);
	c-&gt;qid.path = QID(0, 0, Qtopdir);
	c-&gt;qid.type = QTDIR;
	c-&gt;qid.vers = 0;
	return c;
}

static Walkqid*
ipwalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, 0, 0, ipgen);
}

int
ipstat(Chan *c, uchar *dp, int n)
{
	return devstat(c, dp, n, 0, 0, ipgen);
}

Chan *
ipopen(Chan *c, int omode)
{
	Proto *p;
	uchar raddr[IPaddrlen];
	ushort rport;
	int perm, sfd;
	Conv *cv, *lcv;

	omode &amp;= 3;
	perm = 0;
	switch(omode) {
	case OREAD:
		perm = 4;
		break;
	case OWRITE:
		perm = 2;
		break;
	case ORDWR:
		perm = 6;
		break;
	}

	switch(TYPE(c-&gt;qid)) {
	default:
		break;
	case Qtopdir:
	case Qprotodir:
	case Qconvdir:
	case Qstatus:
	case Qremote:
	case Qlocal:
		if(omode != OREAD)
			error(Eperm);
		break;
	case Qclonus:
		p = &amp;proto[PROTO(c-&gt;qid)];
		cv = protoclone(p, up-&gt;user, -1);
		if(cv == 0)
			error(Enodev);
		c-&gt;qid.path = QID(p-&gt;x, cv-&gt;x, Qctl);
		c-&gt;qid.vers = 0;
		break;
	case Qdata:
	case Qctl:
		p = &amp;proto[PROTO(c-&gt;qid)];
		lock(&amp;p-&gt;l);
		cv = p-&gt;conv[CONV(c-&gt;qid)];
		lock(&amp;cv-&gt;r.lk);
		if((perm &amp; (cv-&gt;perm&gt;&gt;6)) != perm) {
			if(strcmp(up-&gt;user, cv-&gt;owner) != 0 ||
		 	  (perm &amp; cv-&gt;perm) != perm) {
				unlock(&amp;cv-&gt;r.lk);
				unlock(&amp;p-&gt;l);
				error(Eperm);
			}
		}
		cv-&gt;r.ref++;
		if(cv-&gt;r.ref == 1) {
			memmove(cv-&gt;owner, up-&gt;user, KNAMELEN);
			cv-&gt;perm = 0660;
		}
		unlock(&amp;cv-&gt;r.lk);
		unlock(&amp;p-&gt;l);
		break;
	case Qlisten:
		p = &amp;proto[PROTO(c-&gt;qid)];
		lcv = p-&gt;conv[CONV(c-&gt;qid)];
		sfd = so_accept(lcv-&gt;sfd, raddr, &amp;rport);
		cv = protoclone(p, up-&gt;user, sfd);
		if(cv == 0) {
			close(sfd);
			error(Enodev);
		}
		ipmove(cv-&gt;raddr, raddr);
		cv-&gt;rport = rport;
		setladdr(cv);
		cv-&gt;state = "Established";
		c-&gt;qid.path = QID(p-&gt;x, cv-&gt;x, Qctl);
		break;
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

void
ipclose(Chan *c)
{
	Conv *cc;

	switch(TYPE(c-&gt;qid)) {
	case Qcs:
		csclose(c);
		break;
	case Qdata:
	case Qctl:
		if((c-&gt;flag &amp; COPEN) == 0)
			break;
		cc = proto[PROTO(c-&gt;qid)].conv[CONV(c-&gt;qid)];
		if(decref(&amp;cc-&gt;r) != 0)
			break;
		strcpy(cc-&gt;owner, "network");
		cc-&gt;perm = 0666;
		cc-&gt;state = "Closed";
		ipzero(cc-&gt;laddr);
		ipzero(cc-&gt;raddr);
		cc-&gt;lport = 0;
		cc-&gt;rport = 0;
		close(cc-&gt;sfd);
		break;
	}
}

long
ipread(Chan *ch, void *a, long n, vlong offset)
{
	int r;
	Conv *c;
	Proto *x;
	uchar ip[IPaddrlen];
	char buf[128], *p;

/*print("ipread %s %lux\n", c2name(ch), (long)ch-&gt;qid.path);*/
	p = a;
	switch(TYPE(ch-&gt;qid)) {
	default:
		error(Eperm);
	case Qcs:
		return csread(ch, a, n, offset);
	case Qprotodir:
	case Qtopdir:
	case Qconvdir:
		return devdirread(ch, a, n, 0, 0, ipgen);
	case Qctl:
		sprint(buf, "%d", CONV(ch-&gt;qid));
		return readstr(offset, p, n, buf);
	case Qremote:
		c = proto[PROTO(ch-&gt;qid)].conv[CONV(ch-&gt;qid)];
		ipmove(ip, c-&gt;raddr);
		sprint(buf, "%I!%d\n", ip, c-&gt;rport);
		return readstr(offset, p, n, buf);
	case Qlocal:
		c = proto[PROTO(ch-&gt;qid)].conv[CONV(ch-&gt;qid)];
		ipmove(ip, c-&gt;laddr);
		sprint(buf, "%I!%d\n", ip, c-&gt;lport);
		return readstr(offset, p, n, buf);
	case Qstatus:
		x = &amp;proto[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		sprint(buf, "%s/%d %d %s \n",
			c-&gt;p-&gt;name, c-&gt;x, c-&gt;r.ref, c-&gt;state);
		return readstr(offset, p, n, buf);
	case Qdata:
		c = proto[PROTO(ch-&gt;qid)].conv[CONV(ch-&gt;qid)];
		r = so_recv(c-&gt;sfd, a, n, 0);
		if(r &lt; 0){
			oserrstr();
			nexterror();
		}
		return r;
	}
}

static void
setladdr(Conv *c)
{
	so_getsockname(c-&gt;sfd, c-&gt;laddr, &amp;c-&gt;lport);
}

static void
setlport(Conv *c)
{
	if(c-&gt;restricted == 0 &amp;&amp; c-&gt;lport == 0)
		return;

	if(c-&gt;sfd == -1)
		c-&gt;sfd = so_socket(c-&gt;p-&gt;stype, c-&gt;laddr);

	so_bind(c-&gt;sfd, c-&gt;restricted, c-&gt;lport, c-&gt;laddr);
}

static void
setladdrport(Conv *c, char *str)
{
	char *p;
	uchar addr[IPaddrlen];

	p = strchr(str, '!');
	if(p == 0) {
		p = str;
		ipzero(c-&gt;laddr);
	}
	else {
		*p++ = 0;
		parseip(addr, str);
		ipmove(c-&gt;laddr, addr);
	}
	if(*p == '*')
		c-&gt;lport = 0;
	else
		c-&gt;lport = atoi(p);

	setlport(c);
}

static char*
setraddrport(Conv *c, char *str)
{
	char *p;
	uchar addr[IPaddrlen];

	p = strchr(str, '!');
	if(p == 0)
		return "malformed address";
	*p++ = 0;
	parseip(addr, str);
	ipmove(c-&gt;raddr, addr);
	c-&gt;rport = atoi(p);
	p = strchr(p, '!');
	if(p) {
		if(strcmp(p, "!r") == 0)
			c-&gt;restricted = 1;
	}
	return 0;
}

long
ipwrite(Chan *ch, void *a, long n, vlong offset)
{
	Conv *c;
	Proto *x;
	int r, nf;
	char *p, *fields[3], buf[128];

	switch(TYPE(ch-&gt;qid)) {
	default:
		error(Eperm);
	case Qcs:
		return cswrite(ch, a, n, offset);
	case Qctl:
		x = &amp;proto[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		if(n &gt; sizeof(buf)-1)
			n = sizeof(buf)-1;
		memmove(buf, a, n);
		buf[n] = '\0';

		nf = tokenize(buf, fields, 3);
		if(strcmp(fields[0], "connect") == 0){
			switch(nf) {
			default:
				error("bad args to connect");
			case 2:
				p = setraddrport(c, fields[1]);
				if(p != 0)
					error(p);
				break;
			case 3:
				p = setraddrport(c, fields[1]);
				if(p != 0)
					error(p);
				c-&gt;lport = atoi(fields[2]);
				setlport(c);
				break;
			}
			if(c-&gt;sfd == -1)
				c-&gt;sfd = so_socket(c-&gt;p-&gt;stype, c-&gt;raddr);
			so_connect(c-&gt;sfd, c-&gt;raddr, c-&gt;rport);
			setladdr(c);
			c-&gt;state = "Established";
			return n;
		}
		if(strcmp(fields[0], "announce") == 0) {
			switch(nf){
			default:
				error("bad args to announce");
			case 2:
				setladdrport(c, fields[1]);
				break;
			}
			so_listen(c-&gt;sfd);
			c-&gt;state = "Announced";
			return n;
		}
		if(strcmp(fields[0], "bind") == 0){
			switch(nf){
			default:
				error("bad args to bind");
			case 2:
				c-&gt;lport = atoi(fields[1]);
				break;
			}
			setlport(c);
			return n;
		}
		error("bad control message");
	case Qdata:
		x = &amp;proto[PROTO(ch-&gt;qid)];
		c = x-&gt;conv[CONV(ch-&gt;qid)];
		r = so_send(c-&gt;sfd, a, n, 0);
		if(r &lt; 0){
			oserrstr();
			nexterror();
		}
		return r;
	}
	return n;
}

static Conv*
protoclone(Proto *p, char *user, int nfd)
{
	Conv *c, **pp, **ep;

	c = 0;
	lock(&amp;p-&gt;l);
	if(waserror()) {
		unlock(&amp;p-&gt;l);
		nexterror();
	}
	ep = &amp;p-&gt;conv[p-&gt;maxconv];
	for(pp = p-&gt;conv; pp &lt; ep; pp++) {
		c = *pp;
		if(c == 0) {
			c = mallocz(sizeof(Conv), 1);
			if(c == 0)
				error(Enomem);
			lock(&amp;c-&gt;r.lk);
			c-&gt;r.ref = 1;
			c-&gt;p = p;
			c-&gt;x = pp - p-&gt;conv;
			p-&gt;nc++;
			*pp = c;
			break;
		}
		lock(&amp;c-&gt;r.lk);
		if(c-&gt;r.ref == 0) {
			c-&gt;r.ref++;
			break;
		}
		unlock(&amp;c-&gt;r.lk);
	}
	if(pp &gt;= ep) {
		unlock(&amp;p-&gt;l);
		poperror();
		return 0;
	}

	strcpy(c-&gt;owner, user);
	c-&gt;perm = 0660;
	c-&gt;state = "Closed";
	c-&gt;restricted = 0;
	ipzero(c-&gt;laddr);
	ipzero(c-&gt;raddr);
	c-&gt;lport = 0;
	c-&gt;rport = 0;
	c-&gt;sfd = nfd;

	unlock(&amp;c-&gt;r.lk);
	unlock(&amp;p-&gt;l);
	poperror();
	return c;
}

void
csclose(Chan *c)
{
	free(c-&gt;aux);
}

long
csread(Chan *c, void *a, long n, vlong offset)
{
	if(c-&gt;aux == nil)
		return 0;
	return readstr(offset, a, n, c-&gt;aux);
}

static struct
{
	char *name;
	uint num;
} tab[] = {
	"cs", 1,
	"echo", 7,
	"discard", 9,
	"systat", 11,
	"daytime", 13,
	"netstat", 15,
	"chargen", 19,
	"ftp-data", 20,
	"ftp", 21,
	"ssh", 22,
	"telnet", 23,
	"smtp", 25,
	"time", 37,
	"whois", 43,
	"dns", 53,
	"domain", 53,
	"uucp", 64,
	"gopher", 70,
	"rje", 77,
	"finger", 79,
	"http", 80,
	"link", 87,
	"supdup", 95,
	"hostnames", 101,
	"iso-tsap", 102,
	"x400", 103,
	"x400-snd", 104,
	"csnet-ns", 105,
	"pop-2", 109,
	"pop3", 110,
	"portmap", 111,
	"uucp-path", 117,
	"nntp", 119,
	"netbios", 139,
	"imap4", 143,
	"NeWS", 144,
	"print-srv", 170,
	"z39.50", 210,
	"fsb", 400,
	"sysmon", 401,
	"proxy", 402,
	"proxyd", 404,
	"https", 443,
	"cifs", 445,
	"ssmtp", 465,
	"rexec", 512,
	"login", 513,
	"shell", 514,
	"printer", 515,
	"courier", 530,
	"cscan", 531,
	"uucp", 540,
	"snntp", 563,
	"9fs", 564,
	"whoami", 565,
	"guard", 566,
	"ticket", 567,
	"dlsftp", 666,
	"fmclient", 729,
	"imaps", 993,
	"pop3s", 995,
	"ingreslock", 1524,
	"pptp", 1723,
	"nfs", 2049,
	"webster", 2627,
	"weather", 3000,
	"secstore", 5356,
	"Xdisplay", 6000,
	"styx", 6666,
	"mpeg", 6667,
	"rstyx", 6668,
	"infdb", 6669,
	"infsigner", 6671,
	"infcsigner", 6672,
	"inflogin", 6673,
	"bandt", 7330,
	"face", 32000,
	"dhashgate", 11978,
	"exportfs", 17007,
	"rexexec", 17009,
	"ncpu", 17010,
	"cpu", 17013,
	"glenglenda1", 17020,
	"glenglenda2", 17021,
	"glenglenda3", 17022,
	"glenglenda4", 17023,
	"glenglenda5", 17024,
	"glenglenda6", 17025,
	"glenglenda7", 17026,
	"glenglenda8", 17027,
	"glenglenda9", 17028,
	"glenglenda10", 17029,
	"flyboy", 17032,
	"dlsftp", 17033,
	"venti", 17034,
	"wiki", 17035,
	"vica", 17036,
	0
};

static int
lookupport(char *s)
{
	int i;
	char buf[10], *p;

	i = strtol(s, &amp;p, 0);
	if(*s &amp;&amp; *p == 0)
		return i;

	i = so_getservbyname(s, "tcp", buf);
	if(i != -1)
		return atoi(buf);
	for(i=0; tab[i].name; i++)
		if(strcmp(s, tab[i].name) == 0)
			return tab[i].num;
	return 0;
}

static int
lookuphost(char *s, uchar *to)
{
	ipzero(to);
	if(parseip(to, s) != -1)
		return 0;
	if((s = hostlookup(s)) == nil)
		return -1;
	parseip(to, s);
	free(s);
	return 0;
}

long
cswrite(Chan *c, void *a, long n, vlong offset)
{
	char *f[4];
	char *s, *ns;
	uchar ip[IPaddrlen];
	int nf, port;

	s = malloc(n+1);
	if(s == nil)
		error(Enomem);
	if(waserror()){
		free(s);
		nexterror();
	}
	memmove(s, a, n);
	s[n] = 0;
	nf = getfields(s, f, nelem(f), 0, "!");
	if(nf != 3)
		error("can't translate");

	port = lookupport(f[2]);
	if(port &lt;= 0)
		error("no translation for port found");

	if(lookuphost(f[1], ip) &lt; 0)
		error("no translation for host found");

	ns = smprint("/net/%s/clone %I!%d", f[0], ip, port);
	if(ns == nil)
		error(Enomem);
	free(c-&gt;aux);
	c-&gt;aux = ns;
	poperror();
	free(s);
	return n;
}

Dev ipdevtab = 
{
	'I',
	"ip",

	devreset,
	ipinit,
	devshutdown,
	ipattach,
	ipwalk,
	ipstat,
	ipopen,
	devcreate,
	ipclose,
	ipread,
	devbread,
	ipwrite,
	devbwrite,
	devremove,
	devwstat,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

