<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devtls.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/devtls.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  devtls - record layer for transport layer security 1.0 and secure sockets layer 3.0
 */
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

#include	"libsec.h"

typedef struct OneWay	OneWay;
typedef struct Secret		Secret;
typedef struct TlsRec	TlsRec;
typedef struct TlsErrs	TlsErrs;

enum {
	Statlen=	1024,		/* max. length of status or stats message */
	/* buffer limits */
	MaxRecLen		= 1&lt;&lt;14,	/* max payload length of a record layer message */
	MaxCipherRecLen	= MaxRecLen + 2048,
	RecHdrLen		= 5,
	MaxMacLen		= SHA1dlen,

	/* protocol versions we can accept */
	TLSVersion		= 0x0301,
	SSL3Version		= 0x0300,
	ProtocolVersion	= 0x0301,	/* maximum version we speak */
	MinProtoVersion	= 0x0300,	/* limits on version we accept */
	MaxProtoVersion	= 0x03ff,

	/* connection states */
	SHandshake	= 1 &lt;&lt; 0,	/* doing handshake */
	SOpen		= 1 &lt;&lt; 1,	/* application data can be sent */
	SRClose		= 1 &lt;&lt; 2,	/* remote side has closed down */
	SLClose		= 1 &lt;&lt; 3,	/* sent a close notify alert */
	SAlert		= 1 &lt;&lt; 5,	/* sending or sent a fatal alert */
	SError		= 1 &lt;&lt; 6,	/* some sort of error has occured */
	SClosed		= 1 &lt;&lt; 7,	/* it is all over */

	/* record types */
	RChangeCipherSpec = 20,
	RAlert,
	RHandshake,
	RApplication,

	SSL2ClientHello = 1,
	HSSL2ClientHello = 9,  /* local convention;  see tlshand.c */

	/* alerts */
	ECloseNotify 			= 0,
	EUnexpectedMessage 	= 10,
	EBadRecordMac 		= 20,
	EDecryptionFailed 		= 21,
	ERecordOverflow 		= 22,
	EDecompressionFailure 	= 30,
	EHandshakeFailure 		= 40,
	ENoCertificate 			= 41,
	EBadCertificate 		= 42,
	EUnsupportedCertificate 	= 43,
	ECertificateRevoked 		= 44,
	ECertificateExpired 		= 45,
	ECertificateUnknown 	= 46,
	EIllegalParameter 		= 47,
	EUnknownCa 			= 48,
	EAccessDenied 		= 49,
	EDecodeError 			= 50,
	EDecryptError 			= 51,
	EExportRestriction 		= 60,
	EProtocolVersion 		= 70,
	EInsufficientSecurity 	= 71,
	EInternalError 			= 80,
	EUserCanceled 			= 90,
	ENoRenegotiation 		= 100,

	EMAX = 256
};

struct Secret
{
	char		*encalg;	/* name of encryption alg */
	char		*hashalg;	/* name of hash alg */
	int		(*enc)(Secret*, uchar*, int);
	int		(*dec)(Secret*, uchar*, int);
	int		(*unpad)(uchar*, int, int);
	DigestState	*(*mac)(uchar*, ulong, uchar*, ulong, uchar*, DigestState*);
	int		block;		/* encryption block len, 0 if none */
	int		maclen;
	void		*enckey;
	uchar	mackey[MaxMacLen];
};

struct OneWay
{
	QLock		io;		/* locks io access */
	QLock		seclock;	/* locks secret paramaters */
	ulong		seq;
	Secret		*sec;		/* cipher in use */
	Secret		*new;		/* cipher waiting for enable */
};

struct TlsRec
{
	Chan	*c;				/* io channel */
	int		ref;				/* serialized by tdlock for atomic destroy */
	int		version;			/* version of the protocol we are speaking */
	char		verset;			/* version has been set */
	char		opened;			/* opened command every issued? */
	char		err[ERRMAX];		/* error message to return to handshake requests */
	vlong	handin;			/* bytes communicated by the record layer */
	vlong	handout;
	vlong	datain;
	vlong	dataout;

	Lock		statelk;
	int		state;
	int		debug;

	/* record layer mac functions for different protocol versions */
	void		(*packMac)(Secret*, uchar*, uchar*, uchar*, uchar*, int, uchar*);

	/* input side -- protected by in.io */
	OneWay		in;
	Block		*processed;	/* next bunch of application data */
	Block		*unprocessed;	/* data read from c but not parsed into records */

	/* handshake queue */
	Lock		hqlock;			/* protects hqref, alloc &amp; free of handq, hprocessed */
	int		hqref;
	Queue		*handq;		/* queue of handshake messages */
	Block		*hprocessed;	/* remainder of last block read from handq */
	QLock		hqread;		/* protects reads for hprocessed, handq */

	/* output side */
	OneWay		out;

	/* protections */
	char		*user;
	int		perm;
};

struct TlsErrs{
	int	err;
	int	sslerr;
	int	tlserr;
	int	fatal;
	char	*msg;
};

static TlsErrs tlserrs[] = {
	{ECloseNotify,			ECloseNotify,			ECloseNotify,			0, 	"close notify"},
	{EUnexpectedMessage,	EUnexpectedMessage,	EUnexpectedMessage, 	1, "unexpected message"},
	{EBadRecordMac,		EBadRecordMac,		EBadRecordMac, 		1, "bad record mac"},
	{EDecryptionFailed,		EIllegalParameter,		EDecryptionFailed,		1, "decryption failed"},
	{ERecordOverflow,		EIllegalParameter,		ERecordOverflow,		1, "record too long"},
	{EDecompressionFailure,	EDecompressionFailure,	EDecompressionFailure,	1, "decompression failed"},
	{EHandshakeFailure,		EHandshakeFailure,		EHandshakeFailure,		1, "could not negotiate acceptable security parameters"},
	{ENoCertificate,		ENoCertificate,			ECertificateUnknown,	1, "no appropriate certificate available"},
	{EBadCertificate,		EBadCertificate,		EBadCertificate,		1, "corrupted or invalid certificate"},
	{EUnsupportedCertificate,	EUnsupportedCertificate,	EUnsupportedCertificate,	1, "unsupported certificate type"},
	{ECertificateRevoked,	ECertificateRevoked,		ECertificateRevoked,		1, "revoked certificate"},
	{ECertificateExpired,		ECertificateExpired,		ECertificateExpired,		1, "expired certificate"},
	{ECertificateUnknown,	ECertificateUnknown,	ECertificateUnknown,	1, "unacceptable certificate"},
	{EIllegalParameter,		EIllegalParameter,		EIllegalParameter,		1, "illegal parameter"},
	{EUnknownCa,			EHandshakeFailure,		EUnknownCa,			1, "unknown certificate authority"},
	{EAccessDenied,		EHandshakeFailure,		EAccessDenied,		1, "access denied"},
	{EDecodeError,			EIllegalParameter,		EDecodeError,			1, "error decoding message"},
	{EDecryptError,			EIllegalParameter,		EDecryptError,			1, "error decrypting message"},
	{EExportRestriction,		EHandshakeFailure,		EExportRestriction,		1, "export restriction violated"},
	{EProtocolVersion,		EIllegalParameter,		EProtocolVersion,		1, "protocol version not supported"},
	{EInsufficientSecurity,	EHandshakeFailure,		EInsufficientSecurity,	1, "stronger security routines required"},
	{EInternalError,			EHandshakeFailure,		EInternalError,			1, "internal error"},
	{EUserCanceled,		ECloseNotify,			EUserCanceled,			0, "handshake canceled by user"},
	{ENoRenegotiation,		EUnexpectedMessage,	ENoRenegotiation,		0, "no renegotiation"},
};

enum
{
	/* max. open tls connections */
	MaxTlsDevs	= 1024
};

static	Lock	tdlock;
static	int	tdhiwat;
static	int	maxtlsdevs = 128;
static	TlsRec	**tlsdevs;
static	char	**trnames;
static	char	*encalgs;
static	char	*hashalgs;

enum{
	Qtopdir		= 1,	/* top level directory */
	Qprotodir,
	Qclonus,
	Qencalgs,
	Qhashalgs,
	Qconvdir,		/* directory for a conversation */
	Qdata,
	Qctl,
	Qhand,
	Qstatus,
	Qstats,
};

#define TYPE(x) 	((x).path &amp; 0xf)
#define CONV(x) 	(((x).path &gt;&gt; 5)&amp;(MaxTlsDevs-1))
#define QID(c, y) 	(((c)&lt;&lt;5) | (y))

static void	checkstate(TlsRec *, int, int);
static void	ensure(TlsRec*, Block**, int);
static void	consume(Block**, uchar*, int);
static Chan*	buftochan(char*);
static void	tlshangup(TlsRec*);
static void	tlsError(TlsRec*, char *);
static void	alertHand(TlsRec*, char *);
static TlsRec	*newtls(Chan *c);
static TlsRec	*mktlsrec(void);
static DigestState*sslmac_md5(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s);
static DigestState*sslmac_sha1(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s);
static DigestState*nomac(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s);
static void	sslPackMac(Secret *sec, uchar *mackey, uchar *seq, uchar *header, uchar *body, int len, uchar *mac);
static void	tlsPackMac(Secret *sec, uchar *mackey, uchar *seq, uchar *header, uchar *body, int len, uchar *mac);
static void	put64(uchar *p, vlong x);
static void	put32(uchar *p, u32int);
static void	put24(uchar *p, int);
static void	put16(uchar *p, int);
/* static u32int	get32(uchar *p); */
static int	get16(uchar *p);
static void	tlsSetState(TlsRec *tr, int new, int old);
static void	rcvAlert(TlsRec *tr, int err);
static void	sendAlert(TlsRec *tr, int err);
static void	rcvError(TlsRec *tr, int err, char *msg, ...);
static int	rc4enc(Secret *sec, uchar *buf, int n);
static int	des3enc(Secret *sec, uchar *buf, int n);
static int	des3dec(Secret *sec, uchar *buf, int n);
static int	noenc(Secret *sec, uchar *buf, int n);
static int	sslunpad(uchar *buf, int n, int block);
static int	tlsunpad(uchar *buf, int n, int block);
static void	freeSec(Secret *sec);
static char	*tlsstate(int s);
static void	pdump(int, void*, char*);

static char *tlsnames[] = {
	/* unused */ 0,
	/* topdir */ 0,
	/* protodir */ 0,
	"clone",
	"encalgs",
	"hashalgs",
	/* convdir */ 0,
	"data",
	"ctl",
	"hand",
	"status",
	"stats",
};

static int convdir[] = { Qctl, Qdata, Qhand, Qstatus, Qstats };

static int
tlsgen(Chan *c, char*unused1, Dirtab *unused2, int unused3, int s, Dir *dp)
{
	Qid q;
	TlsRec *tr;
	char *name, *nm;
	int perm, t;

	q.vers = 0;
	q.type = QTFILE;

	t = TYPE(c-&gt;qid);
	switch(t) {
	case Qtopdir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, "#a", 0, eve, 0555, dp);
			return 1;
		}
		if(s &gt; 0)
			return -1;
		q.path = QID(0, Qprotodir);
		q.type = QTDIR;
		devdir(c, q, "tls", 0, eve, 0555, dp);
		return 1;
	case Qprotodir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qtopdir);
			q.type = QTDIR;
			devdir(c, q, ".", 0, eve, 0555, dp);
			return 1;
		}
		if(s &lt; 3){
			switch(s) {
			default:
				return -1;
			case 0:
				q.path = QID(0, Qclonus);
				break;
			case 1:
				q.path = QID(0, Qencalgs);
				break;
			case 2:
				q.path = QID(0, Qhashalgs);
				break;
			}
			perm = 0444;
			if(TYPE(q) == Qclonus)
				perm = 0555;
			devdir(c, q, tlsnames[TYPE(q)], 0, eve, perm, dp);
			return 1;
		}
		s -= 3;
		if(s &gt;= tdhiwat)
			return -1;
		q.path = QID(s, Qconvdir);
		q.type = QTDIR;
		lock(&amp;tdlock);
		tr = tlsdevs[s];
		if(tr != nil)
			nm = tr-&gt;user;
		else
			nm = eve;
		if((name = trnames[s]) == nil){
			name = trnames[s] = smalloc(16);
			sprint(name, "%d", s);
		}
		devdir(c, q, name, 0, nm, 0555, dp);
		unlock(&amp;tdlock);
		return 1;
	case Qconvdir:
		if(s == DEVDOTDOT){
			q.path = QID(0, Qprotodir);
			q.type = QTDIR;
			devdir(c, q, "tls", 0, eve, 0555, dp);
			return 1;
		}
		if(s &lt; 0 || s &gt;= nelem(convdir))
			return -1;
		lock(&amp;tdlock);
		tr = tlsdevs[CONV(c-&gt;qid)];
		if(tr != nil){
			nm = tr-&gt;user;
			perm = tr-&gt;perm;
		}else{
			perm = 0;
			nm = eve;
		}
		t = convdir[s];
		if(t == Qstatus || t == Qstats)
			perm &amp;= 0444;
		q.path = QID(CONV(c-&gt;qid), t);
		devdir(c, q, tlsnames[t], 0, nm, perm, dp);
		unlock(&amp;tdlock);
		return 1;
	case Qclonus:
	case Qencalgs:
	case Qhashalgs:
		perm = 0444;
		if(t == Qclonus)
			perm = 0555;
		devdir(c, c-&gt;qid, tlsnames[t], 0, eve, perm, dp);
		return 1;
	default:
		lock(&amp;tdlock);
		tr = tlsdevs[CONV(c-&gt;qid)];
		if(tr != nil){
			nm = tr-&gt;user;
			perm = tr-&gt;perm;
		}else{
			perm = 0;
			nm = eve;
		}
		if(t == Qstatus || t == Qstats)
			perm &amp;= 0444;
		devdir(c, c-&gt;qid, tlsnames[t], 0, nm, perm, dp);
		unlock(&amp;tdlock);
		return 1;
	}
	return -1;
}

static Chan*
tlsattach(char *spec)
{
	Chan *c;

	c = devattach('a', spec);
	c-&gt;qid.path = QID(0, Qtopdir);
	c-&gt;qid.type = QTDIR;
	c-&gt;qid.vers = 0;
	return c;
}

static Walkqid*
tlswalk(Chan *c, Chan *nc, char **name, int nname)
{
	return devwalk(c, nc, name, nname, nil, 0, tlsgen);
}

static int
tlsstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, nil, 0, tlsgen);
}

static Chan*
tlsopen(Chan *c, int omode)
{
	TlsRec *tr, **pp;
	int t, perm;

	perm = 0;
	omode &amp;= 3;
	switch(omode) {
	case OREAD:
		perm = 4;
		break;
	case OWRITE:
		perm = 2;
		break;
	case ORDWR:
		perm = 6;
		break;
	}

	t = TYPE(c-&gt;qid);
	switch(t) {
	default:
		panic("tlsopen");
	case Qtopdir:
	case Qprotodir:
	case Qconvdir:
		if(omode != OREAD)
			error(Eperm);
		break;
	case Qclonus:
		tr = newtls(c);
		if(tr == nil)
			error(Enodev);
		break;
	case Qctl:
	case Qdata:
	case Qhand:
	case Qstatus:
	case Qstats:
		if((t == Qstatus || t == Qstats) &amp;&amp; omode != OREAD)
			error(Eperm);
		if(waserror()) {
			unlock(&amp;tdlock);
			nexterror();
		}
		lock(&amp;tdlock);
		pp = &amp;tlsdevs[CONV(c-&gt;qid)];
		tr = *pp;
		if(tr == nil)
			error("must open connection using clone");
		if((perm &amp; (tr-&gt;perm&gt;&gt;6)) != perm
		&amp;&amp; (strcmp(up-&gt;user, tr-&gt;user) != 0
		    || (perm &amp; tr-&gt;perm) != perm))
			error(Eperm);
		if(t == Qhand){
			if(waserror()){
				unlock(&amp;tr-&gt;hqlock);
				nexterror();
			}
			lock(&amp;tr-&gt;hqlock);
			if(tr-&gt;handq != nil)
				error(Einuse);
			tr-&gt;handq = qopen(2 * MaxCipherRecLen, 0, 0, nil);
			if(tr-&gt;handq == nil)
				error("cannot allocate handshake queue");
			tr-&gt;hqref = 1;
			unlock(&amp;tr-&gt;hqlock);
			poperror();
		}
		tr-&gt;ref++;
		unlock(&amp;tdlock);
		poperror();
		break;
	case Qencalgs:
	case Qhashalgs:
		if(omode != OREAD)
			error(Eperm);
		break;
	}
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	c-&gt;iounit = qiomaxatomic;
	return c;
}

static int
tlswstat(Chan *c, uchar *dp, int n)
{
	Dir *d;
	TlsRec *tr;
	int rv;

	d = nil;
	if(waserror()){
		free(d);
		unlock(&amp;tdlock);
		nexterror();
	}

	lock(&amp;tdlock);
	tr = tlsdevs[CONV(c-&gt;qid)];
	if(tr == nil)
		error(Ebadusefd);
	if(strcmp(tr-&gt;user, up-&gt;user) != 0)
		error(Eperm);

	d = smalloc(n + sizeof *d);
	rv = convM2D(dp, n, &amp;d[0], (char*) &amp;d[1]);
	if(rv == 0)
		error(Eshortstat);
	if(!emptystr(d-&gt;uid))
		kstrdup(&amp;tr-&gt;user, d-&gt;uid);
	if(d-&gt;mode != ~0UL)
		tr-&gt;perm = d-&gt;mode;

	free(d);
	poperror();
	unlock(&amp;tdlock);

	return rv;
}

static void
dechandq(TlsRec *tr)
{
	lock(&amp;tr-&gt;hqlock);
	if(--tr-&gt;hqref == 0){
		if(tr-&gt;handq != nil){
			qfree(tr-&gt;handq);
			tr-&gt;handq = nil;
		}
		if(tr-&gt;hprocessed != nil){
			freeb(tr-&gt;hprocessed);
			tr-&gt;hprocessed = nil;
		}
	}
	unlock(&amp;tr-&gt;hqlock);
}

static void
tlsclose(Chan *c)
{
	TlsRec *tr;
	int t;

	t = TYPE(c-&gt;qid);
	switch(t) {
	case Qctl:
	case Qdata:
	case Qhand:
	case Qstatus:
	case Qstats:
		if((c-&gt;flag &amp; COPEN) == 0)
			break;

		tr = tlsdevs[CONV(c-&gt;qid)];
		if(tr == nil)
			break;

		if(t == Qhand)
			dechandq(tr);

		lock(&amp;tdlock);
		if(--tr-&gt;ref &gt; 0) {
			unlock(&amp;tdlock);
			return;
		}
		tlsdevs[CONV(c-&gt;qid)] = nil;
		unlock(&amp;tdlock);

		if(tr-&gt;c != nil &amp;&amp; !waserror()){
			checkstate(tr, 0, SOpen|SHandshake|SRClose);
			sendAlert(tr, ECloseNotify);
			poperror();
		}
		tlshangup(tr);
		if(tr-&gt;c != nil)
			cclose(tr-&gt;c);
		freeSec(tr-&gt;in.sec);
		freeSec(tr-&gt;in.new);
		freeSec(tr-&gt;out.sec);
		freeSec(tr-&gt;out.new);
		free(tr-&gt;user);
		free(tr);
		break;
	}
}

/*
 *  make sure we have at least 'n' bytes in list 'l'
 */
static void
ensure(TlsRec *s, Block **l, int n)
{
	int sofar, i;
	Block *b, *bl;

	sofar = 0;
	for(b = *l; b; b = b-&gt;next){
		sofar += BLEN(b);
		if(sofar &gt;= n)
			return;
		l = &amp;b-&gt;next;
	}

	while(sofar &lt; n){
		bl = devtab[s-&gt;c-&gt;type]-&gt;bread(s-&gt;c, MaxCipherRecLen + RecHdrLen, 0);
		if(bl == 0)
			error(Ehungup);
		*l = bl;
		i = 0;
		for(b = bl; b; b = b-&gt;next){
			i += BLEN(b);
			l = &amp;b-&gt;next;
		}
		if(i == 0)
			error(Ehungup);
		sofar += i;
	}
if(s-&gt;debug) pprint("ensure read %d\n", sofar);
}

/*
 *  copy 'n' bytes from 'l' into 'p' and free
 *  the bytes in 'l'
 */
static void
consume(Block **l, uchar *p, int n)
{
	Block *b;
	int i;

	for(; *l &amp;&amp; n &gt; 0; n -= i){
		b = *l;
		i = BLEN(b);
		if(i &gt; n)
			i = n;
		memmove(p, b-&gt;rp, i);
		b-&gt;rp += i;
		p += i;
		if(BLEN(b) &lt; 0)
			panic("consume");
		if(BLEN(b))
			break;
		*l = b-&gt;next;
		freeb(b);
	}
}

/*
 *  give back n bytes
 */
static void
regurgitate(TlsRec *s, uchar *p, int n)
{
	Block *b;

	if(n &lt;= 0)
		return;
	b = s-&gt;unprocessed;
	if(s-&gt;unprocessed == nil || b-&gt;rp - b-&gt;base &lt; n) {
		b = allocb(n);
		memmove(b-&gt;wp, p, n);
		b-&gt;wp += n;
		b-&gt;next = s-&gt;unprocessed;
		s-&gt;unprocessed = b;
	} else {
		b-&gt;rp -= n;
		memmove(b-&gt;rp, p, n);
	}
}

/*
 *  remove at most n bytes from the queue
 */
static Block*
qgrab(Block **l, int n)
{
	Block *bb, *b;
	int i;

	b = *l;
	if(BLEN(b) == n){
		*l = b-&gt;next;
		b-&gt;next = nil;
		return b;
	}

	i = 0;
	for(bb = b; bb != nil &amp;&amp; i &lt; n; bb = bb-&gt;next)
		i += BLEN(bb);
	if(i &gt; n)
		i = n;

	bb = allocb(i);
	consume(l, bb-&gt;wp, i);
	bb-&gt;wp += i;
	return bb;
}

static void
tlsclosed(TlsRec *tr, int new)
{
	lock(&amp;tr-&gt;statelk);
	if(tr-&gt;state == SOpen || tr-&gt;state == SHandshake)
		tr-&gt;state = new;
	else if((new | tr-&gt;state) == (SRClose|SLClose))
		tr-&gt;state = SClosed;
	unlock(&amp;tr-&gt;statelk);
	alertHand(tr, "close notify");
}

/*
 *  read and process one tls record layer message
 *  must be called with tr-&gt;in.io held
 *  We can't let Eintrs lose data, since doing so will get
 *  us out of sync with the sender and break the reliablity
 *  of the channel.  Eintr only happens during the reads in
 *  consume.  Therefore we put back any bytes consumed before
 *  the last call to ensure.
 */
static void
tlsrecread(TlsRec *tr)
{
	OneWay *volatile in;
	Block *volatile b;
	uchar *p, seq[8], header[RecHdrLen], hmac[MD5dlen];
	int volatile nconsumed;
	int len, type, ver, unpad_len;

	nconsumed = 0;
	if(waserror()){
		if(strcmp(up-&gt;errstr, Eintr) == 0 &amp;&amp; !waserror()){
			regurgitate(tr, header, nconsumed);
			poperror();
		}else
			tlsError(tr, "channel error");
		nexterror();
	}
	ensure(tr, &amp;tr-&gt;unprocessed, RecHdrLen);
	consume(&amp;tr-&gt;unprocessed, header, RecHdrLen);
if(tr-&gt;debug)pprint("consumed %d header\n", RecHdrLen);
	nconsumed = RecHdrLen;

	if((tr-&gt;handin == 0) &amp;&amp; (header[0] &amp; 0x80)){
		/* Cope with an SSL3 ClientHello expressed in SSL2 record format.
			This is sent by some clients that we must interoperate
			with, such as Java's JSSE and Microsoft's Internet Explorer. */
		len = (get16(header) &amp; ~0x8000) - 3;
		type = header[2];
		ver = get16(header + 3);
		if(type != SSL2ClientHello || len &lt; 22)
			rcvError(tr, EProtocolVersion, "invalid initial SSL2-like message");
	}else{  /* normal SSL3 record format */
		type = header[0];
		ver = get16(header+1);
		len = get16(header+3);
	}
	if(ver != tr-&gt;version &amp;&amp; (tr-&gt;verset || ver &lt; MinProtoVersion || ver &gt; MaxProtoVersion))
		rcvError(tr, EProtocolVersion, "devtls expected ver=%x%s, saw (len=%d) type=%x ver=%x '%.12s'",
			tr-&gt;version, tr-&gt;verset?"/set":"", len, type, ver, (char*)header);
	if(len &gt; MaxCipherRecLen || len &lt; 0)
		rcvError(tr, ERecordOverflow, "record message too long %d", len);
	ensure(tr, &amp;tr-&gt;unprocessed, len);
	nconsumed = 0;
	poperror();

	/*
	 * If an Eintr happens after this, we'll get out of sync.
	 * Make sure nothing we call can sleep.
	 * Errors are ok, as they kill the connection.
	 * Luckily, allocb won't sleep, it'll just error out.
	 */
	b = nil;
	if(waserror()){
		if(b != nil)
			freeb(b);
		tlsError(tr, "channel error");
		nexterror();
	}
	b = qgrab(&amp;tr-&gt;unprocessed, len);
if(tr-&gt;debug) pprint("consumed unprocessed %d\n", len);

	in = &amp;tr-&gt;in;
	if(waserror()){
		qunlock(&amp;in-&gt;seclock);
		nexterror();
	}
	qlock(&amp;in-&gt;seclock);
	p = b-&gt;rp;
	if(in-&gt;sec != nil) {
		/* to avoid Canvel-Hiltgen-Vaudenay-Vuagnoux attack, all errors here
		        should look alike, including timing of the response. */
		unpad_len = (*in-&gt;sec-&gt;dec)(in-&gt;sec, p, len);
		if(unpad_len &gt;= in-&gt;sec-&gt;maclen)
			len = unpad_len - in-&gt;sec-&gt;maclen;
if(tr-&gt;debug) pprint("decrypted %d\n", unpad_len);
if(tr-&gt;debug) pdump(unpad_len, p, "decrypted:");

		/* update length */
		put16(header+3, len);
		put64(seq, in-&gt;seq);
		in-&gt;seq++;
		(*tr-&gt;packMac)(in-&gt;sec, in-&gt;sec-&gt;mackey, seq, header, p, len, hmac);
		if(unpad_len &lt; in-&gt;sec-&gt;maclen)
			rcvError(tr, EBadRecordMac, "short record mac");
		if(memcmp(hmac, p+len, in-&gt;sec-&gt;maclen) != 0)
			rcvError(tr, EBadRecordMac, "record mac mismatch");
		b-&gt;wp = b-&gt;rp + len;
	}
	qunlock(&amp;in-&gt;seclock);
	poperror();
	if(len &lt; 0)
		rcvError(tr, EDecodeError, "runt record message");

	switch(type) {
	default:
		rcvError(tr, EIllegalParameter, "invalid record message 0x%x", type);
		break;
	case RChangeCipherSpec:
		if(len != 1 || p[0] != 1)
			rcvError(tr, EDecodeError, "invalid change cipher spec");
		qlock(&amp;in-&gt;seclock);
		if(in-&gt;new == nil){
			qunlock(&amp;in-&gt;seclock);
			rcvError(tr, EUnexpectedMessage, "unexpected change cipher spec");
		}
		freeSec(in-&gt;sec);
		in-&gt;sec = in-&gt;new;
		in-&gt;new = nil;
		in-&gt;seq = 0;
		qunlock(&amp;in-&gt;seclock);
		break;
	case RAlert:
		if(len != 2)
			rcvError(tr, EDecodeError, "invalid alert");
		if(p[0] == 2)
			rcvAlert(tr, p[1]);
		if(p[0] != 1)
			rcvError(tr, EIllegalParameter, "invalid alert fatal code");

		/*
		 * propate non-fatal alerts to handshaker
		 */
		if(p[1] == ECloseNotify) {
			tlsclosed(tr, SRClose);
			if(tr-&gt;opened)
				error("tls hungup");
			error("close notify");
		}
		if(p[1] == ENoRenegotiation)
			alertHand(tr, "no renegotiation");
		else if(p[1] == EUserCanceled)
			alertHand(tr, "handshake canceled by user");
		else
			rcvError(tr, EIllegalParameter, "invalid alert code");
		break;
	case RHandshake:
		/*
		 * don't worry about dropping the block
		 * qbwrite always queues even if flow controlled and interrupted.
		 *
		 * if there isn't any handshaker, ignore the request,
		 * but notify the other side we are doing so.
		 */
		lock(&amp;tr-&gt;hqlock);
		if(tr-&gt;handq != nil){
			tr-&gt;hqref++;
			unlock(&amp;tr-&gt;hqlock);
			if(waserror()){
				dechandq(tr);
				nexterror();
			}
			b = padblock(b, 1);
			*b-&gt;rp = RHandshake;
			qbwrite(tr-&gt;handq, b);
			b = nil;
			poperror();
			dechandq(tr);
		}else{
			unlock(&amp;tr-&gt;hqlock);
			if(tr-&gt;verset &amp;&amp; tr-&gt;version != SSL3Version &amp;&amp; !waserror()){
				sendAlert(tr, ENoRenegotiation);
				poperror();
			}
		}
		break;
	case SSL2ClientHello:
		lock(&amp;tr-&gt;hqlock);
		if(tr-&gt;handq != nil){
			tr-&gt;hqref++;
			unlock(&amp;tr-&gt;hqlock);
			if(waserror()){
				dechandq(tr);
				nexterror();
			}
			/* Pass the SSL2 format data, so that the handshake code can compute
				the correct checksums.  HSSL2ClientHello = HandshakeType 9 is
				unused in RFC2246. */
			b = padblock(b, 8);
			b-&gt;rp[0] = RHandshake;
			b-&gt;rp[1] = HSSL2ClientHello;
			put24(&amp;b-&gt;rp[2], len+3);
			b-&gt;rp[5] = SSL2ClientHello;
			put16(&amp;b-&gt;rp[6], ver);
			qbwrite(tr-&gt;handq, b);
			b = nil;
			poperror();
			dechandq(tr);
		}else{
			unlock(&amp;tr-&gt;hqlock);
			if(tr-&gt;verset &amp;&amp; tr-&gt;version != SSL3Version &amp;&amp; !waserror()){
				sendAlert(tr, ENoRenegotiation);
				poperror();
			}
		}
		break;
	case RApplication:
		if(!tr-&gt;opened)
			rcvError(tr, EUnexpectedMessage, "application message received before handshake completed");
		if(BLEN(b) &gt; 0){
			tr-&gt;processed = b;
			b = nil;
		}
		break;
	}
	if(b != nil)
		freeb(b);
	poperror();
}

/*
 * got a fatal alert message
 */
static void
rcvAlert(TlsRec *tr, int err)
{
	char *s;
	int i;

	s = "unknown error";
	for(i=0; i &lt; nelem(tlserrs); i++){
		if(tlserrs[i].err == err){
			s = tlserrs[i].msg;
			break;
		}
	}
if(tr-&gt;debug) pprint("rcvAlert: %s\n", s);

	tlsError(tr, s);
	if(!tr-&gt;opened)
		error(s);
	error("tls error");
}

/*
 * found an error while decoding the input stream
 */
static void
rcvError(TlsRec *tr, int err, char *fmt, ...)
{
	char msg[ERRMAX];
	va_list arg;

	va_start(arg, fmt);
	vseprint(msg, msg+sizeof(msg), fmt, arg);
	va_end(arg);
if(tr-&gt;debug) pprint("rcvError: %s\n", msg);

	sendAlert(tr, err);

	if(!tr-&gt;opened)
		error(msg);
	error("tls error");
}

/*
 * make sure the next hand operation returns with a 'msg' error
 */
static void
alertHand(TlsRec *tr, char *msg)
{
	Block *b;
	int n;

	lock(&amp;tr-&gt;hqlock);
	if(tr-&gt;handq == nil){
		unlock(&amp;tr-&gt;hqlock);
		return;
	}
	tr-&gt;hqref++;
	unlock(&amp;tr-&gt;hqlock);

	n = strlen(msg);
	if(waserror()){
		dechandq(tr);
		nexterror();
	}
	b = allocb(n + 2);
	*b-&gt;wp++ = RAlert;
	memmove(b-&gt;wp, msg, n + 1);
	b-&gt;wp += n + 1;

	qbwrite(tr-&gt;handq, b);

	poperror();
	dechandq(tr);
}

static void
checkstate(TlsRec *tr, int ishand, int ok)
{
	int state;

	lock(&amp;tr-&gt;statelk);
	state = tr-&gt;state;
	unlock(&amp;tr-&gt;statelk);
	if(state &amp; ok)
		return;
	switch(state){
	case SHandshake:
	case SOpen:
		break;
	case SError:
	case SAlert:
		if(ishand)
			error(tr-&gt;err);
		error("tls error");
	case SRClose:
	case SLClose:
	case SClosed:
		error("tls hungup");
	}
	error("tls improperly configured");
}

static Block*
tlsbread(Chan *c, long n, ulong offset)
{
	int ty;
	Block *b;
	TlsRec *volatile tr;

	ty = TYPE(c-&gt;qid);
	switch(ty) {
	default:
		return devbread(c, n, offset);
	case Qhand:
	case Qdata:
		break;
	}

	tr = tlsdevs[CONV(c-&gt;qid)];
	if(tr == nil)
		panic("tlsbread");

	if(waserror()){
		qunlock(&amp;tr-&gt;in.io);
		nexterror();
	}
	qlock(&amp;tr-&gt;in.io);
	if(ty == Qdata){
		checkstate(tr, 0, SOpen);
		while(tr-&gt;processed == nil)
			tlsrecread(tr);

		/* return at most what was asked for */
		b = qgrab(&amp;tr-&gt;processed, n);
if(tr-&gt;debug) pprint("consumed processed %d\n", BLEN(b));
if(tr-&gt;debug) pdump(BLEN(b), b-&gt;rp, "consumed:");
		qunlock(&amp;tr-&gt;in.io);
		poperror();
		tr-&gt;datain += BLEN(b);
	}else{
		checkstate(tr, 1, SOpen|SHandshake|SLClose);

		/*
		 * it's ok to look at state without the lock
		 * since it only protects reading records,
		 * and we have that tr-&gt;in.io held.
		 */
		while(!tr-&gt;opened &amp;&amp; tr-&gt;hprocessed == nil &amp;&amp; !qcanread(tr-&gt;handq))
			tlsrecread(tr);

		qunlock(&amp;tr-&gt;in.io);
		poperror();

		if(waserror()){
			qunlock(&amp;tr-&gt;hqread);
			nexterror();
		}
		qlock(&amp;tr-&gt;hqread);
		if(tr-&gt;hprocessed == nil){
			b = qbread(tr-&gt;handq, MaxRecLen + 1);
			if(*b-&gt;rp++ == RAlert){
				kstrcpy(up-&gt;errstr, (char*)b-&gt;rp, ERRMAX);
				freeb(b);
				nexterror();
			}
			tr-&gt;hprocessed = b;
		}
		b = qgrab(&amp;tr-&gt;hprocessed, n);
		poperror();
		qunlock(&amp;tr-&gt;hqread);
		tr-&gt;handin += BLEN(b);
	}

	return b;
}

static long
tlsread(Chan *c, void *a, long n, vlong off)
{
	Block *volatile b;
	Block *nb;
	uchar *va;
	int i, ty;
	char *buf, *s, *e;
	ulong offset = off;
	TlsRec * tr;

	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, 0, 0, tlsgen);

	tr = tlsdevs[CONV(c-&gt;qid)];
	ty = TYPE(c-&gt;qid);
	switch(ty) {
	default:
		error(Ebadusefd);
	case Qstatus:
		buf = smalloc(Statlen);
		qlock(&amp;tr-&gt;in.seclock);
		qlock(&amp;tr-&gt;out.seclock);
		s = buf;
		e = buf + Statlen;
		s = seprint(s, e, "State: %s\n", tlsstate(tr-&gt;state));
		s = seprint(s, e, "Version: 0x%x\n", tr-&gt;version);
		if(tr-&gt;in.sec != nil)
			s = seprint(s, e, "EncIn: %s\nHashIn: %s\n", tr-&gt;in.sec-&gt;encalg, tr-&gt;in.sec-&gt;hashalg);
		if(tr-&gt;in.new != nil)
			s = seprint(s, e, "NewEncIn: %s\nNewHashIn: %s\n", tr-&gt;in.new-&gt;encalg, tr-&gt;in.new-&gt;hashalg);
		if(tr-&gt;out.sec != nil)
			s = seprint(s, e, "EncOut: %s\nHashOut: %s\n", tr-&gt;out.sec-&gt;encalg, tr-&gt;out.sec-&gt;hashalg);
		if(tr-&gt;out.new != nil)
			seprint(s, e, "NewEncOut: %s\nNewHashOut: %s\n", tr-&gt;out.new-&gt;encalg, tr-&gt;out.new-&gt;hashalg);
		qunlock(&amp;tr-&gt;in.seclock);
		qunlock(&amp;tr-&gt;out.seclock);
		n = readstr(offset, a, n, buf);
		free(buf);
		return n;
	case Qstats:
		buf = smalloc(Statlen);
		s = buf;
		e = buf + Statlen;
		s = seprint(s, e, "DataIn: %lld\n", tr-&gt;datain);
		s = seprint(s, e, "DataOut: %lld\n", tr-&gt;dataout);
		s = seprint(s, e, "HandIn: %lld\n", tr-&gt;handin);
		seprint(s, e, "HandOut: %lld\n", tr-&gt;handout);
		n = readstr(offset, a, n, buf);
		free(buf);
		return n;
	case Qctl:
		buf = smalloc(Statlen);
		snprint(buf, Statlen, "%llud", CONV(c-&gt;qid));
		n = readstr(offset, a, n, buf);
		free(buf);
		return n;
	case Qdata:
	case Qhand:
		b = tlsbread(c, n, offset);
		break;
	case Qencalgs:
		return readstr(offset, a, n, encalgs);
	case Qhashalgs:
		return readstr(offset, a, n, hashalgs);
	}

	if(waserror()){
		freeblist(b);
		nexterror();
	}

	n = 0;
	va = a;
	for(nb = b; nb; nb = nb-&gt;next){
		i = BLEN(nb);
		memmove(va+n, nb-&gt;rp, i);
		n += i;
	}

	freeblist(b);
	poperror();

	return n;
}

/*
 *  write a block in tls records
 */
static void
tlsrecwrite(TlsRec *tr, int type, Block *b)
{
	Block *volatile bb;
	Block *nb;
	uchar *p, seq[8];
	OneWay *volatile out;
	int n, maclen, pad, ok;

	out = &amp;tr-&gt;out;
	bb = b;
	if(waserror()){
		qunlock(&amp;out-&gt;io);
		if(bb != nil)
			freeb(bb);
		nexterror();
	}
	qlock(&amp;out-&gt;io);
if(tr-&gt;debug)pprint("send %d\n", BLEN(b));
if(tr-&gt;debug)pdump(BLEN(b), b-&gt;rp, "sent:");


	ok = SHandshake|SOpen|SRClose;
	if(type == RAlert)
		ok |= SAlert;
	while(bb != nil){
		checkstate(tr, type != RApplication, ok);

		/*
		 * get at most one maximal record's input,
		 * with padding on the front for header and
		 * back for mac and maximal block padding.
		 */
		if(waserror()){
			qunlock(&amp;out-&gt;seclock);
			nexterror();
		}
		qlock(&amp;out-&gt;seclock);
		maclen = 0;
		pad = 0;
		if(out-&gt;sec != nil){
			maclen = out-&gt;sec-&gt;maclen;
			pad = maclen + out-&gt;sec-&gt;block;
		}
		n = BLEN(bb);
		if(n &gt; MaxRecLen){
			n = MaxRecLen;
			nb = allocb(n + pad + RecHdrLen);
			memmove(nb-&gt;wp + RecHdrLen, bb-&gt;rp, n);
			bb-&gt;rp += n;
		}else{
			/*
			 * carefully reuse bb so it will get freed if we're out of memory
			 */
			bb = padblock(bb, RecHdrLen);
			if(pad)
				nb = padblock(bb, -pad);
			else
				nb = bb;
			bb = nil;
		}

		p = nb-&gt;rp;
		p[0] = type;
		put16(p+1, tr-&gt;version);
		put16(p+3, n);

		if(out-&gt;sec != nil){
			put64(seq, out-&gt;seq);
			out-&gt;seq++;
			(*tr-&gt;packMac)(out-&gt;sec, out-&gt;sec-&gt;mackey, seq, p, p + RecHdrLen, n, p + RecHdrLen + n);
			n += maclen;

			/* encrypt */
			n = (*out-&gt;sec-&gt;enc)(out-&gt;sec, p + RecHdrLen, n);
			nb-&gt;wp = p + RecHdrLen + n;

			/* update length */
			put16(p+3, n);
		}
		if(type == RChangeCipherSpec){
			if(out-&gt;new == nil)
				error("change cipher without a new cipher");
			freeSec(out-&gt;sec);
			out-&gt;sec = out-&gt;new;
			out-&gt;new = nil;
			out-&gt;seq = 0;
		}
		qunlock(&amp;out-&gt;seclock);
		poperror();

		/*
		 * if bwrite error's, we assume the block is queued.
		 * if not, we're out of sync with the receiver and will not recover.
		 */
		if(waserror()){
			if(strcmp(up-&gt;errstr, "interrupted") != 0)
				tlsError(tr, "channel error");
			nexterror();
		}
		devtab[tr-&gt;c-&gt;type]-&gt;bwrite(tr-&gt;c, nb, 0);
		poperror();
	}
	qunlock(&amp;out-&gt;io);
	poperror();
}

static long
tlsbwrite(Chan *c, Block *b, ulong offset)
{
	int ty;
	ulong n;
	TlsRec *tr;

	n = BLEN(b);

	tr = tlsdevs[CONV(c-&gt;qid)];
	if(tr == nil)
		panic("tlsbread");

	ty = TYPE(c-&gt;qid);
	switch(ty) {
	default:
		return devbwrite(c, b, offset);
	case Qhand:
		tlsrecwrite(tr, RHandshake, b);
		tr-&gt;handout += n;
		break;
	case Qdata:
		checkstate(tr, 0, SOpen);
		tlsrecwrite(tr, RApplication, b);
		tr-&gt;dataout += n;
		break;
	}

	return n;
}

typedef struct Hashalg Hashalg;
struct Hashalg
{
	char	*name;
	int	maclen;
	void	(*initkey)(Hashalg *, int, Secret *, uchar*);
};

static void
initmd5key(Hashalg *ha, int version, Secret *s, uchar *p)
{
	s-&gt;maclen = ha-&gt;maclen;
	if(version == SSL3Version)
		s-&gt;mac = sslmac_md5;
	else
		s-&gt;mac = hmac_md5;
	memmove(s-&gt;mackey, p, ha-&gt;maclen);
}

static void
initclearmac(Hashalg *unused1, int unused2, Secret *s, uchar *unused3)
{
	s-&gt;maclen = 0;
	s-&gt;mac = nomac;
}

static void
initsha1key(Hashalg *ha, int version, Secret *s, uchar *p)
{
	s-&gt;maclen = ha-&gt;maclen;
	if(version == SSL3Version)
		s-&gt;mac = sslmac_sha1;
	else
		s-&gt;mac = hmac_sha1;
	memmove(s-&gt;mackey, p, ha-&gt;maclen);
}

static Hashalg hashtab[] =
{
	{ "clear", 0, initclearmac, },
	{ "md5", MD5dlen, initmd5key, },
	{ "sha1", SHA1dlen, initsha1key, },
	{ 0 }
};

static Hashalg*
parsehashalg(char *p)
{
	Hashalg *ha;

	for(ha = hashtab; ha-&gt;name; ha++)
		if(strcmp(p, ha-&gt;name) == 0)
			return ha;
	error("unsupported hash algorithm");
	return nil;
}

typedef struct Encalg Encalg;
struct Encalg
{
	char	*name;
	int	keylen;
	int	ivlen;
	void	(*initkey)(Encalg *ea, Secret *, uchar*, uchar*);
};

static void
initRC4key(Encalg *ea, Secret *s, uchar *p, uchar *unused1)
{
	s-&gt;enckey = smalloc(sizeof(RC4state));
	s-&gt;enc = rc4enc;
	s-&gt;dec = rc4enc;
	s-&gt;block = 0;
	setupRC4state(s-&gt;enckey, p, ea-&gt;keylen);
}

static void
initDES3key(Encalg *unused1, Secret *s, uchar *p, uchar *iv)
{
	s-&gt;enckey = smalloc(sizeof(DES3state));
	s-&gt;enc = des3enc;
	s-&gt;dec = des3dec;
	s-&gt;block = 8;
	setupDES3state(s-&gt;enckey, (uchar(*)[8])p, iv);
}

static void
initclearenc(Encalg *unused1, Secret *s, uchar *unused2, uchar *unused3)
{
	s-&gt;enc = noenc;
	s-&gt;dec = noenc;
	s-&gt;block = 0;
}

static Encalg encrypttab[] =
{
	{ "clear", 0, 0, initclearenc },
	{ "rc4_128", 128/8, 0, initRC4key },
	{ "3des_ede_cbc", 3 * 8, 8, initDES3key },
	{ 0 }
};

static Encalg*
parseencalg(char *p)
{
	Encalg *ea;

	for(ea = encrypttab; ea-&gt;name; ea++)
		if(strcmp(p, ea-&gt;name) == 0)
			return ea;
	error("unsupported encryption algorithm");
	return nil;
}

static long
tlswrite(Chan *c, void *a, long n, vlong off)
{
	Encalg *ea;
	Hashalg *ha;
	TlsRec *volatile tr;
	Secret *volatile tos, *volatile toc;
	Block *volatile b;
	Cmdbuf *volatile cb;
	int m, ty;
	char *p, *e;
	uchar *volatile x;
	ulong offset = off;

	tr = tlsdevs[CONV(c-&gt;qid)];
	if(tr == nil)
		panic("tlswrite");

	ty = TYPE(c-&gt;qid);
	switch(ty){
	case Qdata:
	case Qhand:
		p = a;
		e = p + n;
		do{
			m = e - p;
			if(m &gt; MaxRecLen)
				m = MaxRecLen;

			b = allocb(m);
			if(waserror()){
				freeb(b);
				nexterror();
			}
			memmove(b-&gt;wp, p, m);
			poperror();
			b-&gt;wp += m;

			tlsbwrite(c, b, offset);

			p += m;
		}while(p &lt; e);
		return n;
	case Qctl:
		break;
	default:
		error(Ebadusefd);
		return -1;
	}

	cb = parsecmd(a, n);
	if(waserror()){
		free(cb);
		nexterror();
	}
	if(cb-&gt;nf &lt; 1)
		error("short control request");

	/* mutex with operations using what we're about to change */
	if(waserror()){
		qunlock(&amp;tr-&gt;in.seclock);
		qunlock(&amp;tr-&gt;out.seclock);
		nexterror();
	}
	qlock(&amp;tr-&gt;in.seclock);
	qlock(&amp;tr-&gt;out.seclock);

	if(strcmp(cb-&gt;f[0], "fd") == 0){
		if(cb-&gt;nf != 3)
			error("usage: fd open-fd version");
		if(tr-&gt;c != nil)
			error(Einuse);
		m = strtol(cb-&gt;f[2], nil, 0);
		if(m &lt; MinProtoVersion || m &gt; MaxProtoVersion)
			error("unsupported version");
		tr-&gt;c = buftochan(cb-&gt;f[1]);
		tr-&gt;version = m;
		tlsSetState(tr, SHandshake, SClosed);
	}else if(strcmp(cb-&gt;f[0], "version") == 0){
		if(cb-&gt;nf != 2)
			error("usage: version vers");
		if(tr-&gt;c == nil)
			error("must set fd before version");
		if(tr-&gt;verset)
			error("version already set");
		m = strtol(cb-&gt;f[1], nil, 0);
		if(m == SSL3Version)
			tr-&gt;packMac = sslPackMac;
		else if(m == TLSVersion)
			tr-&gt;packMac = tlsPackMac;
		else
			error("unsupported version");
		tr-&gt;verset = 1;
		tr-&gt;version = m;
	}else if(strcmp(cb-&gt;f[0], "secret") == 0){
		if(cb-&gt;nf != 5)
			error("usage: secret hashalg encalg isclient secretdata");
		if(tr-&gt;c == nil || !tr-&gt;verset)
			error("must set fd and version before secrets");

		if(tr-&gt;in.new != nil){
			freeSec(tr-&gt;in.new);
			tr-&gt;in.new = nil;
		}
		if(tr-&gt;out.new != nil){
			freeSec(tr-&gt;out.new);
			tr-&gt;out.new = nil;
		}

		ha = parsehashalg(cb-&gt;f[1]);
		ea = parseencalg(cb-&gt;f[2]);

		p = cb-&gt;f[4];
		m = (strlen(p)*3)/2;
		x = smalloc(m);
		tos = nil;
		toc = nil;
		if(waserror()){
			freeSec(tos);
			freeSec(toc);
			free(x);
			nexterror();
		}
		m = dec64(x, m, p, strlen(p));
		if(m &lt; 2 * ha-&gt;maclen + 2 * ea-&gt;keylen + 2 * ea-&gt;ivlen)
			error("not enough secret data provided");

		tos = smalloc(sizeof(Secret));
		toc = smalloc(sizeof(Secret));
		if(!ha-&gt;initkey || !ea-&gt;initkey)
			error("misimplemented secret algorithm");
		(*ha-&gt;initkey)(ha, tr-&gt;version, tos, &amp;x[0]);
		(*ha-&gt;initkey)(ha, tr-&gt;version, toc, &amp;x[ha-&gt;maclen]);
		(*ea-&gt;initkey)(ea, tos, &amp;x[2 * ha-&gt;maclen], &amp;x[2 * ha-&gt;maclen + 2 * ea-&gt;keylen]);
		(*ea-&gt;initkey)(ea, toc, &amp;x[2 * ha-&gt;maclen + ea-&gt;keylen], &amp;x[2 * ha-&gt;maclen + 2 * ea-&gt;keylen + ea-&gt;ivlen]);

		if(!tos-&gt;mac || !tos-&gt;enc || !tos-&gt;dec
		|| !toc-&gt;mac || !toc-&gt;enc || !toc-&gt;dec)
			error("missing algorithm implementations");
		if(strtol(cb-&gt;f[3], nil, 0) == 0){
			tr-&gt;in.new = tos;
			tr-&gt;out.new = toc;
		}else{
			tr-&gt;in.new = toc;
			tr-&gt;out.new = tos;
		}
		if(tr-&gt;version == SSL3Version){
			toc-&gt;unpad = sslunpad;
			tos-&gt;unpad = sslunpad;
		}else{
			toc-&gt;unpad = tlsunpad;
			tos-&gt;unpad = tlsunpad;
		}
		toc-&gt;encalg = ea-&gt;name;
		toc-&gt;hashalg = ha-&gt;name;
		tos-&gt;encalg = ea-&gt;name;
		tos-&gt;hashalg = ha-&gt;name;

		free(x);
		poperror();
	}else if(strcmp(cb-&gt;f[0], "changecipher") == 0){
		if(cb-&gt;nf != 1)
			error("usage: changecipher");
		if(tr-&gt;out.new == nil)
			error("cannot change cipher spec without setting secret");

		qunlock(&amp;tr-&gt;in.seclock);
		qunlock(&amp;tr-&gt;out.seclock);
		poperror();
		free(cb);
		poperror();

		/*
		 * the real work is done as the message is written
		 * so the stream is encrypted in sync.
		 */
		b = allocb(1);
		*b-&gt;wp++ = 1;
		tlsrecwrite(tr, RChangeCipherSpec, b);
		return n;
	}else if(strcmp(cb-&gt;f[0], "opened") == 0){
		if(cb-&gt;nf != 1)
			error("usage: opened");
		if(tr-&gt;in.sec == nil || tr-&gt;out.sec == nil)
			error("cipher must be configured before enabling data messages");
		lock(&amp;tr-&gt;statelk);
		if(tr-&gt;state != SHandshake &amp;&amp; tr-&gt;state != SOpen){
			unlock(&amp;tr-&gt;statelk);
			error("cannot enable data messages");
		}
		tr-&gt;state = SOpen;
		unlock(&amp;tr-&gt;statelk);
		tr-&gt;opened = 1;
	}else if(strcmp(cb-&gt;f[0], "alert") == 0){
		if(cb-&gt;nf != 2)
			error("usage: alert n");
		if(tr-&gt;c == nil)
			error("must set fd before sending alerts");
		m = strtol(cb-&gt;f[1], nil, 0);

		qunlock(&amp;tr-&gt;in.seclock);
		qunlock(&amp;tr-&gt;out.seclock);
		poperror();
		free(cb);
		poperror();

		sendAlert(tr, m);

		if(m == ECloseNotify)
			tlsclosed(tr, SLClose);

		return n;
	} else if(strcmp(cb-&gt;f[0], "debug") == 0){
		if(cb-&gt;nf == 2){
			if(strcmp(cb-&gt;f[1], "on") == 0)
				tr-&gt;debug = 1;
			else
				tr-&gt;debug = 0;
		} else
			tr-&gt;debug = 1;
	} else
		error(Ebadarg);

	qunlock(&amp;tr-&gt;in.seclock);
	qunlock(&amp;tr-&gt;out.seclock);
	poperror();
	free(cb);
	poperror();

	return n;
}

static void
tlsinit(void)
{
	struct Encalg *e;
	struct Hashalg *h;
	int n;
	char *cp;
	static int already;

	if(!already){
		fmtinstall('H', encodefmt);
		already = 1;
	}

	tlsdevs = smalloc(sizeof(TlsRec*) * maxtlsdevs);
	trnames = smalloc((sizeof *trnames) * maxtlsdevs);

	n = 1;
	for(e = encrypttab; e-&gt;name != nil; e++)
		n += strlen(e-&gt;name) + 1;
	cp = encalgs = smalloc(n);
	for(e = encrypttab;;){
		strcpy(cp, e-&gt;name);
		cp += strlen(e-&gt;name);
		e++;
		if(e-&gt;name == nil)
			break;
		*cp++ = ' ';
	}
	*cp = 0;

	n = 1;
	for(h = hashtab; h-&gt;name != nil; h++)
		n += strlen(h-&gt;name) + 1;
	cp = hashalgs = smalloc(n);
	for(h = hashtab;;){
		strcpy(cp, h-&gt;name);
		cp += strlen(h-&gt;name);
		h++;
		if(h-&gt;name == nil)
			break;
		*cp++ = ' ';
	}
	*cp = 0;
}

Dev tlsdevtab = {
	'a',
	"tls",

	devreset,
	tlsinit,
	devshutdown,
	tlsattach,
	tlswalk,
	tlsstat,
	tlsopen,
	devcreate,
	tlsclose,
	tlsread,
	tlsbread,
	tlswrite,
	tlsbwrite,
	devremove,
	tlswstat,
};

/* get channel associated with an fd */
static Chan*
buftochan(char *p)
{
	Chan *c;
	int fd;

	if(p == 0)
		error(Ebadarg);
	fd = strtoul(p, 0, 0);
	if(fd &lt; 0)
		error(Ebadarg);
	c = fdtochan(fd, -1, 0, 1);	/* error check and inc ref */
	return c;
}

static void
sendAlert(TlsRec *tr, int err)
{
	Block *b;
	int i, fatal;
	char *msg;

if(tr-&gt;debug)pprint("sendAlert %d\n", err);
	fatal = 1;
	msg = "tls unknown alert";
	for(i=0; i &lt; nelem(tlserrs); i++) {
		if(tlserrs[i].err == err) {
			msg = tlserrs[i].msg;
			if(tr-&gt;version == SSL3Version)
				err = tlserrs[i].sslerr;
			else
				err = tlserrs[i].tlserr;
			fatal = tlserrs[i].fatal;
			break;
		}
	}

	if(!waserror()){
		b = allocb(2);
		*b-&gt;wp++ = fatal + 1;
		*b-&gt;wp++ = err;
		if(fatal)
			tlsSetState(tr, SAlert, SOpen|SHandshake|SRClose);
		tlsrecwrite(tr, RAlert, b);
		poperror();
	}
	if(fatal)
		tlsError(tr, msg);
}

static void
tlsError(TlsRec *tr, char *msg)
{
	int s;

if(tr-&gt;debug)pprint("tleError %s\n", msg);
	lock(&amp;tr-&gt;statelk);
	s = tr-&gt;state;
	tr-&gt;state = SError;
	if(s != SError){
		strncpy(tr-&gt;err, msg, ERRMAX - 1);
		tr-&gt;err[ERRMAX - 1] = '\0';
	}
	unlock(&amp;tr-&gt;statelk);
	if(s != SError)
		alertHand(tr, msg);
}

static void
tlsSetState(TlsRec *tr, int new, int old)
{
	lock(&amp;tr-&gt;statelk);
	if(tr-&gt;state &amp; old)
		tr-&gt;state = new;
	unlock(&amp;tr-&gt;statelk);
}

/* hand up a digest connection */
static void
tlshangup(TlsRec *tr)
{
	Block *b;

	qlock(&amp;tr-&gt;in.io);
	for(b = tr-&gt;processed; b; b = tr-&gt;processed){
		tr-&gt;processed = b-&gt;next;
		freeb(b);
	}
	if(tr-&gt;unprocessed != nil){
		freeb(tr-&gt;unprocessed);
		tr-&gt;unprocessed = nil;
	}
	qunlock(&amp;tr-&gt;in.io);

	tlsSetState(tr, SClosed, ~0);
}

static TlsRec*
newtls(Chan *ch)
{
	TlsRec **pp, **ep, **np;
	char **nmp;
	int t, newmax;

	if(waserror()) {
		unlock(&amp;tdlock);
		nexterror();
	}
	lock(&amp;tdlock);
	ep = &amp;tlsdevs[maxtlsdevs];
	for(pp = tlsdevs; pp &lt; ep; pp++)
		if(*pp == nil)
			break;
	if(pp &gt;= ep) {
		if(maxtlsdevs &gt;= MaxTlsDevs) {
			unlock(&amp;tdlock);
			poperror();
			return nil;
		}
		newmax = 2 * maxtlsdevs;
		if(newmax &gt; MaxTlsDevs)
			newmax = MaxTlsDevs;
		np = smalloc(sizeof(TlsRec*) * newmax);
		memmove(np, tlsdevs, sizeof(TlsRec*) * maxtlsdevs);
		tlsdevs = np;
		pp = &amp;tlsdevs[maxtlsdevs];
		memset(pp, 0, sizeof(TlsRec*)*(newmax - maxtlsdevs));

		nmp = smalloc(sizeof *nmp * newmax);
		memmove(nmp, trnames, sizeof *nmp * maxtlsdevs);
		trnames = nmp;

		maxtlsdevs = newmax;
	}
	*pp = mktlsrec();
	if(pp - tlsdevs &gt;= tdhiwat)
		tdhiwat++;
	t = TYPE(ch-&gt;qid);
	if(t == Qclonus)
		t = Qctl;
	ch-&gt;qid.path = QID(pp - tlsdevs, t);
	ch-&gt;qid.vers = 0;
	unlock(&amp;tdlock);
	poperror();
	return *pp;
}

static TlsRec *
mktlsrec(void)
{
	TlsRec *tr;

	tr = mallocz(sizeof(*tr), 1);
	if(tr == nil)
		error(Enomem);
	tr-&gt;state = SClosed;
	tr-&gt;ref = 1;
	kstrdup(&amp;tr-&gt;user, up-&gt;user);
	tr-&gt;perm = 0660;
	return tr;
}

static char*
tlsstate(int s)
{
	switch(s){
	case SHandshake:
		return "Handshaking";
	case SOpen:
		return "Established";
	case SRClose:
		return "RemoteClosed";
	case SLClose:
		return "LocalClosed";
	case SAlert:
		return "Alerting";
	case SError:
		return "Errored";
	case SClosed:
		return "Closed";
	}
	return "Unknown";
}

static void
freeSec(Secret *s)
{
	if(s != nil){
		free(s-&gt;enckey);
		free(s);
	}
}

static int
noenc(Secret *unused1, uchar *unused2, int n)
{
	return n;
}

static int
rc4enc(Secret *sec, uchar *buf, int n)
{
	rc4(sec-&gt;enckey, buf, n);
	return n;
}

static int
tlsunpad(uchar *buf, int n, int block)
{
	int pad, nn;

	pad = buf[n - 1];
	nn = n - 1 - pad;
	if(nn &lt;= 0 || n % block)
		return -1;
	while(--n &gt; nn)
		if(pad != buf[n - 1])
			return -1;
	return nn;
}

static int
sslunpad(uchar *buf, int n, int block)
{
	int pad, nn;

	pad = buf[n - 1];
	nn = n - 1 - pad;
	if(nn &lt;= 0 || n % block)
		return -1;
	return nn;
}

static int
blockpad(uchar *buf, int n, int block)
{
	int pad, nn;

	nn = n + block;
	nn -= nn % block;
	pad = nn - (n + 1);
	while(n &lt; nn)
		buf[n++] = pad;
	return nn;
}
		
static int
des3enc(Secret *sec, uchar *buf, int n)
{
	n = blockpad(buf, n, 8);
	des3CBCencrypt(buf, n, sec-&gt;enckey);
	return n;
}

static int
des3dec(Secret *sec, uchar *buf, int n)
{
	des3CBCdecrypt(buf, n, sec-&gt;enckey);
	return (*sec-&gt;unpad)(buf, n, 8);
}
static DigestState*
nomac(uchar *unused1, ulong unused2, uchar *unused3, ulong unused4,
	uchar *unused5, DigestState *unused6)
{
	return nil;
}

/*
 * sslmac: mac calculations for ssl 3.0 only; tls 1.0 uses the standard hmac.
 */
static DigestState*
sslmac_x(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s,
	DigestState*(*x)(uchar*, ulong, uchar*, DigestState*), int xlen, int padlen)
{
	int i;
	uchar pad[48], innerdigest[20];

	if(xlen &gt; sizeof(innerdigest)
	|| padlen &gt; sizeof(pad))
		return nil;

	if(klen&gt;64)
		return nil;

	/* first time through */
	if(s == nil){
		for(i=0; i&lt;padlen; i++)
			pad[i] = 0x36;
		s = (*x)(key, klen, nil, nil);
		s = (*x)(pad, padlen, nil, s);
		if(s == nil)
			return nil;
	}

	s = (*x)(p, len, nil, s);
	if(digest == nil)
		return s;

	/* last time through */
	for(i=0; i&lt;padlen; i++)
		pad[i] = 0x5c;
	(*x)(nil, 0, innerdigest, s);
	s = (*x)(key, klen, nil, nil);
	s = (*x)(pad, padlen, nil, s);
	(*x)(innerdigest, xlen, digest, s);
	return nil;
}

static DigestState*
sslmac_sha1(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s)
{
	return sslmac_x(p, len, key, klen, digest, s, sha1, SHA1dlen, 40);
}

static DigestState*
sslmac_md5(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest, DigestState *s)
{
	return sslmac_x(p, len, key, klen, digest, s, md5, MD5dlen, 48);
}

static void
sslPackMac(Secret *sec, uchar *mackey, uchar *seq, uchar *header, uchar *body, int len, uchar *mac)
{
	DigestState *s;
	uchar buf[11];

	memmove(buf, seq, 8);
	buf[8] = header[0];
	buf[9] = header[3];
	buf[10] = header[4];

	s = (*sec-&gt;mac)(buf, 11, mackey, sec-&gt;maclen, 0, 0);
	(*sec-&gt;mac)(body, len, mackey, sec-&gt;maclen, mac, s);
}

static void
tlsPackMac(Secret *sec, uchar *mackey, uchar *seq, uchar *header, uchar *body, int len, uchar *mac)
{
	DigestState *s;
	uchar buf[13];

	memmove(buf, seq, 8);
	memmove(&amp;buf[8], header, 5);

	s = (*sec-&gt;mac)(buf, 13, mackey, sec-&gt;maclen, 0, 0);
	(*sec-&gt;mac)(body, len, mackey, sec-&gt;maclen, mac, s);
}

static void
put32(uchar *p, u32int x)
{
	p[0] = x&gt;&gt;24;
	p[1] = x&gt;&gt;16;
	p[2] = x&gt;&gt;8;
	p[3] = x;
}

static void
put64(uchar *p, vlong x)
{
	put32(p, (u32int)(x &gt;&gt; 32));
	put32(p+4, (u32int)x);
}

static void
put24(uchar *p, int x)
{
	p[0] = x&gt;&gt;16;
	p[1] = x&gt;&gt;8;
	p[2] = x;
}

static void
put16(uchar *p, int x)
{
	p[0] = x&gt;&gt;8;
	p[1] = x;
}

/*
static u32int
get32(uchar *p)
{
	return (p[0]&lt;&lt;24)|(p[1]&lt;&lt;16)|(p[2]&lt;&lt;8)|p[3];
}
*/

static int
get16(uchar *p)
{
	return (p[0]&lt;&lt;8)|p[1];
}

static char *charmap = "0123456789abcdef";

static void
pdump(int len, void *a, char *tag)
{
	uchar *p;
	int i;
	char buf[65+32];
	char *q;

	p = a;
	strcpy(buf, tag);
	while(len &gt; 0){
		q = buf + strlen(tag);
		for(i = 0; len &gt; 0 &amp;&amp; i &lt; 32; i++){
			if(*p &gt;= ' ' &amp;&amp; *p &lt; 0x7f){
				*q++ = ' ';
				*q++ = *p;
			} else {
				*q++ = charmap[*p&gt;&gt;4];
				*q++ = charmap[*p &amp; 0xf];
			}
			len--;
			p++;
		}
		*q = 0;

		if(len &gt; 0)
			pprint("%s...\n", buf);
		else
			pprint("%s\n", buf);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

