<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/kern/sysfile.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/kern/sysfile.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	"u.h"
#include	"lib.h"
#include	"dat.h"
#include	"fns.h"
#include	"error.h"

#include	"user.h"
#undef open
#undef mount
#undef read
#undef write
#undef seek
#undef stat
#undef wstat
#undef remove
#undef close
#undef fstat
#undef fwstat

/*
 * The sys*() routines needn't poperror() as they return directly to syscall().
 */

static void
unlockfgrp(Fgrp *f)
{
	int ex;

	ex = f-&gt;exceed;
	f-&gt;exceed = 0;
	unlock(&amp;f-&gt;ref.lk);
	if(ex)
		pprint("warning: process exceeds %d file descriptors\n", ex);
}

int
growfd(Fgrp *f, int fd)	/* fd is always &gt;= 0 */
{
	Chan **newfd, **oldfd;

	if(fd &lt; f-&gt;nfd)
		return 0;
	if(fd &gt;= f-&gt;nfd+DELTAFD)
		return -1;	/* out of range */
	/*
	 * Unbounded allocation is unwise; besides, there are only 16 bits
	 * of fid in 9P
	 */
	if(f-&gt;nfd &gt;= 5000){
    Exhausted:
		print("no free file descriptors\n");
		return -1;
	}
	newfd = malloc((f-&gt;nfd+DELTAFD)*sizeof(Chan*));
	if(newfd == 0)
		goto Exhausted;
	oldfd = f-&gt;fd;
	memmove(newfd, oldfd, f-&gt;nfd*sizeof(Chan*));
	f-&gt;fd = newfd;
	free(oldfd);
	f-&gt;nfd += DELTAFD;
	if(fd &gt; f-&gt;maxfd){
		if(fd/100 &gt; f-&gt;maxfd/100)
			f-&gt;exceed = (fd/100)*100;
		f-&gt;maxfd = fd;
	}
	return 1;
}

/*
 *  this assumes that the fgrp is locked
 */
int
findfreefd(Fgrp *f, int start)
{
	int fd;

	for(fd=start; fd&lt;f-&gt;nfd; fd++)
		if(f-&gt;fd[fd] == 0)
			break;
	if(fd &gt;= f-&gt;nfd &amp;&amp; growfd(f, fd) &lt; 0)
		return -1;
	return fd;
}

int
newfd(Chan *c)
{
	int fd;
	Fgrp *f;

	f = up-&gt;fgrp;
	lock(&amp;f-&gt;ref.lk);
	fd = findfreefd(f, 0);
	if(fd &lt; 0){
		unlockfgrp(f);
		return -1;
	}
	if(fd &gt; f-&gt;maxfd)
		f-&gt;maxfd = fd;
	f-&gt;fd[fd] = c;
	unlockfgrp(f);
	return fd;
}

int
newfd2(int fd[2], Chan *c[2])
{
	Fgrp *f;

	f = up-&gt;fgrp;
	lock(&amp;f-&gt;ref.lk);
	fd[0] = findfreefd(f, 0);
	if(fd[0] &lt; 0){
		unlockfgrp(f);
		return -1;
	}
	fd[1] = findfreefd(f, fd[0]+1);
	if(fd[1] &lt; 0){
		unlockfgrp(f);
		return -1;
	}
	if(fd[1] &gt; f-&gt;maxfd)
		f-&gt;maxfd = fd[1];
	f-&gt;fd[fd[0]] = c[0];
	f-&gt;fd[fd[1]] = c[1];
	unlockfgrp(f);

	return 0;
}

Chan*
fdtochan(int fd, int mode, int chkmnt, int iref)
{
	Chan *c;
	Fgrp *f;

	c = 0;
	f = up-&gt;fgrp;

	lock(&amp;f-&gt;ref.lk);
	if(fd&lt;0 || f-&gt;nfd&lt;=fd || (c = f-&gt;fd[fd])==0) {
		unlock(&amp;f-&gt;ref.lk);
		error(Ebadfd);
	}
	if(iref)
		incref(&amp;c-&gt;ref);
	unlock(&amp;f-&gt;ref.lk);

	if(chkmnt &amp;&amp; (c-&gt;flag&amp;CMSG)) {
		if(iref)
			cclose(c);
		error(Ebadusefd);
	}

	if(mode&lt;0 || c-&gt;mode==ORDWR)
		return c;

	if((mode&amp;OTRUNC) &amp;&amp; c-&gt;mode==OREAD) {
		if(iref)
			cclose(c);
		error(Ebadusefd);
	}

	if((mode&amp;~OTRUNC) != c-&gt;mode) {
		if(iref)
			cclose(c);
		error(Ebadusefd);
	}

	return c;
}

int
openmode(ulong o)
{
	o &amp;= ~(OTRUNC|OCEXEC|ORCLOSE);
	if(o &gt; OEXEC)
		error(Ebadarg);
	if(o == OEXEC)
		return OREAD;
	return o;
}

long
_sysfd2path(int fd, char *buf, uint nbuf)
{
	Chan *c;

	c = fdtochan(fd, -1, 0, 1);

	if(c-&gt;name == nil)
		snprint(buf, nbuf, "&lt;null&gt;");
	else
		snprint(buf, nbuf, "%s", c-&gt;name-&gt;s);
	cclose(c);
	return 0;
}

long
_syspipe(int fd[2])
{
	Chan *c[2];
	Dev *d;
	static char *datastr[] = {"data", "data1"};

	d = devtab[devno('|', 0)];
	c[0] = namec("#|", Atodir, 0, 0);
	c[1] = 0;
	fd[0] = -1;
	fd[1] = -1;

	if(waserror()){
		cclose(c[0]);
		if(c[1])
			cclose(c[1]);
		nexterror();
	}
	c[1] = cclone(c[0]);
	if(walk(&amp;c[0], datastr+0, 1, 1, nil) &lt; 0)
		error(Egreg);
	if(walk(&amp;c[1], datastr+1, 1, 1, nil) &lt; 0)
		error(Egreg);
	c[0] = d-&gt;open(c[0], ORDWR);
	c[1] = d-&gt;open(c[1], ORDWR);
	if(newfd2(fd, c) &lt; 0)
		error(Enofd);
	poperror();

	return 0;
}

long
_sysdup(int fd0, int fd1)
{
	int fd;
	Chan *c, *oc;
	Fgrp *f = up-&gt;fgrp;

	/*
	 * Close after dup'ing, so date &gt; #d/1 works
	 */
	c = fdtochan(fd0, -1, 0, 1);
	fd = fd1;
	if(fd != -1){
		lock(&amp;f-&gt;ref.lk);
		if(fd&lt;0 || growfd(f, fd)&lt;0) {
			unlockfgrp(f);
			cclose(c);
			error(Ebadfd);
		}
		if(fd &gt; f-&gt;maxfd)
			f-&gt;maxfd = fd;

		oc = f-&gt;fd[fd];
		f-&gt;fd[fd] = c;
		unlockfgrp(f);
		if(oc)
			cclose(oc);
	}else{
		if(waserror()) {
			cclose(c);
			nexterror();
		}
		fd = newfd(c);
		if(fd &lt; 0)
			error(Enofd);
		poperror();
	}

	return fd;
}

long
_sysopen(char *name, int mode)
{
	int fd;
	Chan *c = 0;

	openmode(mode);	/* error check only */
	if(waserror()){
		if(c)
			cclose(c);
		nexterror();
	}
	c = namec(name, Aopen, mode, 0);
	fd = newfd(c);
	if(fd &lt; 0)
		error(Enofd);
	poperror();
	return fd;
}

void
fdclose(int fd, int flag)
{
	int i;
	Chan *c;
	Fgrp *f = up-&gt;fgrp;

	lock(&amp;f-&gt;ref.lk);
	c = f-&gt;fd[fd];
	if(c == 0){
		/* can happen for users with shared fd tables */
		unlock(&amp;f-&gt;ref.lk);
		return;
	}
	if(flag){
		if(c==0 || !(c-&gt;flag&amp;flag)){
			unlock(&amp;f-&gt;ref.lk);
			return;
		}
	}
	f-&gt;fd[fd] = 0;
	if(fd == f-&gt;maxfd)
		for(i=fd; --i&gt;=0 &amp;&amp; f-&gt;fd[i]==0; )
			f-&gt;maxfd = i;

	unlock(&amp;f-&gt;ref.lk);
	cclose(c);
}

long
_sysclose(int fd)
{
	fdtochan(fd, -1, 0, 0);
	fdclose(fd, 0);

	return 0;
}

long
unionread(Chan *c, void *va, long n)
{
	int i;
	long nr;
	Mhead *m;
	Mount *mount;

	qlock(&amp;c-&gt;umqlock);
	m = c-&gt;umh;
	rlock(&amp;m-&gt;lock);
	mount = m-&gt;mount;
	/* bring mount in sync with c-&gt;uri and c-&gt;umc */
	for(i = 0; mount != nil &amp;&amp; i &lt; c-&gt;uri; i++)
		mount = mount-&gt;next;

	nr = 0;
	while(mount != nil) {
		/* Error causes component of union to be skipped */
		if(mount-&gt;to &amp;&amp; !waserror()) {
			if(c-&gt;umc == nil){
				c-&gt;umc = cclone(mount-&gt;to);
				c-&gt;umc = devtab[c-&gt;umc-&gt;type]-&gt;open(c-&gt;umc, OREAD);
			}
	
			nr = devtab[c-&gt;umc-&gt;type]-&gt;read(c-&gt;umc, va, n, c-&gt;umc-&gt;offset);
			c-&gt;umc-&gt;offset += nr;
			poperror();
		}
		if(nr &gt; 0)
			break;

		/* Advance to next element */
		c-&gt;uri++;
		if(c-&gt;umc) {
			cclose(c-&gt;umc);
			c-&gt;umc = nil;
		}
		mount = mount-&gt;next;
	}
	runlock(&amp;m-&gt;lock);
	qunlock(&amp;c-&gt;umqlock);
	return nr;
}

static long
kread(int fd, void *buf, long n, vlong *offp)
{
	int dir;
	Chan *c;
	vlong off;

	c = fdtochan(fd, OREAD, 1, 1);

	if(waserror()) {
		cclose(c);
		nexterror();
	}

	dir = c-&gt;qid.type&amp;QTDIR;
	/*
	 * The offset is passed through on directories, normally. sysseek complains but
	 * pread is used by servers and e.g. exportfs that shouldn't need to worry about this issue.
	 */

	if(offp == nil)	/* use and maintain channel's offset */
		off = c-&gt;offset;
	else
		off = *offp;

	if(off &lt; 0)
		error(Enegoff);

	if(dir &amp;&amp; c-&gt;umh)
		n = unionread(c, buf, n);
	else
		n = devtab[c-&gt;type]-&gt;read(c, buf, n, off);

	if(offp == nil){
		lock(&amp;c-&gt;ref.lk);
		c-&gt;offset += n;
		unlock(&amp;c-&gt;ref.lk);
	}

	poperror();
	cclose(c);

	return n;
}

/* name conflicts with netbsd
long
_sys_read(int fd, void *buf, long n)
{
	return kread(fd, buf, n, nil);
}
*/

long
_syspread(int fd, void *buf, long n, vlong off)
{
	if(off == ((uvlong) ~0))
		return kread(fd, buf, n, nil);
	return kread(fd, buf, n, &amp;off);
}

static long
kwrite(int fd, void *buf, long nn, vlong *offp)
{
	Chan *c;
	long m, n;
	vlong off;

	n = 0;
	c = fdtochan(fd, OWRITE, 1, 1);
	if(waserror()) {
		if(offp == nil){
			lock(&amp;c-&gt;ref.lk);
			c-&gt;offset -= n;
			unlock(&amp;c-&gt;ref.lk);
		}
		cclose(c);
		nexterror();
	}

	if(c-&gt;qid.type &amp; QTDIR)
		error(Eisdir);

	n = nn;

	if(offp == nil){	/* use and maintain channel's offset */
		lock(&amp;c-&gt;ref.lk);
		off = c-&gt;offset;
		c-&gt;offset += n;
		unlock(&amp;c-&gt;ref.lk);
	}else
		off = *offp;

	if(off &lt; 0)
		error(Enegoff);

	m = devtab[c-&gt;type]-&gt;write(c, buf, n, off);

	if(offp == nil &amp;&amp; m &lt; n){
		lock(&amp;c-&gt;ref.lk);
		c-&gt;offset -= n - m;
		unlock(&amp;c-&gt;ref.lk);
	}

	poperror();
	cclose(c);

	return m;
}

long
sys_write(int fd, void *buf, long n)
{
	return kwrite(fd, buf, n, nil);
}

long
_syspwrite(int fd, void *buf, long n, vlong off)
{
	if(off == ((uvlong) ~0))
		return kwrite(fd, buf, n, nil);
	return kwrite(fd, buf, n, &amp;off);
}

static vlong
_sysseek(int fd, vlong off, int whence)
{
	Chan *c;
	uchar buf[sizeof(Dir)+100];
	Dir dir;
	int n;

	c = fdtochan(fd, -1, 1, 1);
	if(waserror()){
		cclose(c);
		nexterror();
	}
	if(devtab[c-&gt;type]-&gt;dc == '|')
		error(Eisstream);

	switch(whence){
	case 0:
		if((c-&gt;qid.type &amp; QTDIR) &amp;&amp; off != 0)
			error(Eisdir);
		if(off &lt; 0)
			error(Enegoff);
		c-&gt;offset = off;
		break;

	case 1:
		if(c-&gt;qid.type &amp; QTDIR)
			error(Eisdir);
		lock(&amp;c-&gt;ref.lk);	/* lock for read/write update */
		off = off + c-&gt;offset;
		if(off &lt; 0)
			error(Enegoff);
		c-&gt;offset = off;
		unlock(&amp;c-&gt;ref.lk);
		break;

	case 2:
		if(c-&gt;qid.type &amp; QTDIR)
			error(Eisdir);
		n = devtab[c-&gt;type]-&gt;stat(c, buf, sizeof buf);
		if(convM2D(buf, n, &amp;dir, nil) == 0)
			error("internal error: stat error in seek");
		off = dir.length + off;
		if(off &lt; 0)
			error(Enegoff);
		c-&gt;offset = off;
		break;

	default:
		error(Ebadarg);
	}
	c-&gt;uri = 0;
	c-&gt;dri = 0;
	cclose(c);
	poperror();
	return off;
}

void
validstat(uchar *s, int n)
{
	int m;
	char buf[64];

	if(statcheck(s, n) &lt; 0)
		error(Ebadstat);
	/* verify that name entry is acceptable */
	s += STATFIXLEN - 4*BIT16SZ;	/* location of first string */
	/*
	 * s now points at count for first string.
	 * if it's too long, let the server decide; this is
	 * only for his protection anyway. otherwise
	 * we'd have to allocate and waserror.
	 */
	m = GBIT16(s);
	s += BIT16SZ;
	if(m+1 &gt; sizeof buf)
		return;
	memmove(buf, s, m);
	buf[m] = '\0';
	/* name could be '/' */
	if(strcmp(buf, "/") != 0)
		validname(buf, 0);
}

long
_sysfstat(int fd, void *buf, long n)
{
	Chan *c;
	uint l;

	l = n;
	validaddr(buf, l, 1);
	c = fdtochan(fd, -1, 0, 1);
	if(waserror()) {
		cclose(c);
		nexterror();
	}
	l = devtab[c-&gt;type]-&gt;stat(c, buf, l);
	poperror();
	cclose(c);
	return l;
}

long
_sysstat(char *name, void *buf, long n)
{
	Chan *c;
	uint l;

	l = n;
	validaddr(buf, l, 1);
	validaddr(name, 1, 0);
	c = namec(name, Aaccess, 0, 0);
	if(waserror()){
		cclose(c);
		nexterror();
	}
	l = devtab[c-&gt;type]-&gt;stat(c, buf, l);
	poperror();
	cclose(c);
	return l;
}

long
_syschdir(char *name)
{
	Chan *c;

	validaddr(name, 1, 0);

	c = namec(name, Atodir, 0, 0);
	cclose(up-&gt;dot);
	up-&gt;dot = c;
	return 0;
}

long
bindmount(int ismount, int fd, int afd, char* arg0, char* arg1, ulong flag, char* spec)
{
	int ret;
	Chan *c0, *c1, *ac, *bc;
	struct{
		Chan	*chan;
		Chan	*authchan;
		char	*spec;
		int	flags;
	}bogus;

	if((flag&amp;~MMASK) || (flag&amp;MORDER)==(MBEFORE|MAFTER))
		error(Ebadarg);

	bogus.flags = flag &amp; MCACHE;

	if(ismount){
		if(up-&gt;pgrp-&gt;noattach)
			error(Enoattach);

		ac = nil;
		bc = fdtochan(fd, ORDWR, 0, 1);
		if(waserror()) {
			if(ac)
				cclose(ac);
			cclose(bc);
			nexterror();
		}

		if(afd &gt;= 0)
			ac = fdtochan(afd, ORDWR, 0, 1);

		bogus.chan = bc;
		bogus.authchan = ac;

		validaddr((ulong)spec, 1, 0);
		bogus.spec = spec;
		if(waserror())
			error(Ebadspec);
		validname(spec, 1);
		poperror();

		ret = devno('M', 0);
		c0 = devtab[ret]-&gt;attach((char*)&amp;bogus);

		poperror();
		if(ac)
			cclose(ac);
		cclose(bc);
	}else{
		bogus.spec = 0;
		validaddr((ulong)arg0, 1, 0);
		c0 = namec(arg0, Abind, 0, 0);
	}

	if(waserror()){
		cclose(c0);
		nexterror();
	}

	validaddr((ulong)arg1, 1, 0);
	c1 = namec(arg1, Amount, 0, 0);
	if(waserror()){
		cclose(c1);
		nexterror();
	}

	ret = cmount(&amp;c0, c1, flag, bogus.spec);

	poperror();
	cclose(c1);
	poperror();
	cclose(c0);
	if(ismount)
		fdclose(fd, 0);

	return ret;
}

long
_sysbind(char *old, char *new, int flag)
{
	return bindmount(0, -1, -1, old, new, flag, nil);
}

long
_sysmount(int fd, int afd, char *new, int flag, char *spec)
{
	return bindmount(1, fd, afd, nil, new, flag, spec);
}

long
_sysunmount(char *old, char *new)
{
	Chan *cmount, *cmounted;

	cmounted = 0;

	cmount = namec(new, Amount, 0, 0);

	if(old) {
		if(waserror()) {
			cclose(cmount);
			nexterror();
		}
		validaddr(old, 1, 0);
		/*
		 * This has to be namec(..., Aopen, ...) because
		 * if arg[0] is something like /srv/cs or /fd/0,
		 * opening it is the only way to get at the real
		 * Chan underneath.
		 */
		cmounted = namec(old, Aopen, OREAD, 0);
		poperror();
	}

	if(waserror()) {
		cclose(cmount);
		if(cmounted)
			cclose(cmounted);
		nexterror();
	}

	cunmount(cmount, cmounted);
	cclose(cmount);
	if(cmounted)
		cclose(cmounted);
	poperror();
	return 0;
}

long
_syscreate(char *name, int mode, ulong perm)
{
	int fd;
	Chan *c = 0;

	openmode(mode&amp;~OEXCL);	/* error check only; OEXCL okay here */
	if(waserror()) {
		if(c)
			cclose(c);
		nexterror();
	}
	validaddr(name, 1, 0);
	c = namec(name, Acreate, mode, perm);
	fd = newfd(c);
	if(fd &lt; 0)
		error(Enofd);
	poperror();
	return fd;
}

long
_sysremove(char *name)
{
	Chan *c;

	c = namec(name, Aremove, 0, 0);
	if(waserror()){
		c-&gt;type = 0;	/* see below */
		cclose(c);
		nexterror();
	}
	devtab[c-&gt;type]-&gt;remove(c);
	/*
	 * Remove clunks the fid, but we need to recover the Chan
	 * so fake it up.  rootclose() is known to be a nop.
	 */
	c-&gt;type = 0;
	poperror();
	cclose(c);
	return 0;
}

long
_syswstat(char *name, void *buf, long n)
{
	Chan *c;
	uint l;

	l = n;
	validstat(buf, l);
	validaddr(name, 1, 0);
	c = namec(name, Aaccess, 0, 0);
	if(waserror()){
		cclose(c);
		nexterror();
	}
	l = devtab[c-&gt;type]-&gt;wstat(c, buf, l);
	poperror();
	cclose(c);
	return l;
}

long
_sysfwstat(int fd, void *buf, long n)
{
	Chan *c;
	uint l;

	l = n;
	validaddr(buf, l, 0);
	validstat(buf, l);
	c = fdtochan(fd, -1, 1, 1);
	if(waserror()) {
		cclose(c);
		nexterror();
	}
	l = devtab[c-&gt;type]-&gt;wstat(c, buf, l);
	poperror();
	cclose(c);
	return l;
}


static void
starterror(void)
{
	assert(up-&gt;nerrlab == 0);
}

static void
_syserror(void)
{
	char *p;

	p = up-&gt;syserrstr;
	up-&gt;syserrstr = up-&gt;errstr;
	up-&gt;errstr = p;
}

static void
enderror(void)
{
	assert(up-&gt;nerrlab == 1);
	poperror();
}

int
sysbind(char *old, char *new, int flag)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysbind(old, new, flag);
	enderror();
	return n;
}

int
syschdir(char *path)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syschdir(path);
	enderror();
	return n;
}

int
sysclose(int fd)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysclose(fd);
	enderror();
	return n;
}

int
syscreate(char *name, int mode, ulong perm)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syscreate(name, mode, perm);
	enderror();
	return n;
}

int
sysdup(int fd0, int fd1)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysdup(fd0, fd1);
	enderror();
	return n;
}

int
sysfstat(int fd, uchar *buf, int n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysfstat(fd, buf, n);
	enderror();
	return n;
}

int
sysfwstat(int fd, uchar *buf, int n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysfwstat(fd, buf, n);
	enderror();
	return n;
}

int
sysmount(int fd, int afd, char *new, int flag, char *spec)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysmount(fd, afd, new, flag, spec);
	enderror();
	return n;
}

int
sysunmount(char *old, char *new)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysunmount(old, new);
	enderror();
	return n;
}

int
sysopen(char *name, int mode)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysopen(name, mode);
	enderror();
	return n;
}

int
syspipe(int *fd)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syspipe(fd);
	enderror();
	return n;
}

long
syspread(int fd, void *buf, long n, vlong off)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syspread(fd, buf, n, off);
	enderror();
	return n;
}

long
syspwrite(int fd, void *buf, long n, vlong off)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syspwrite(fd, buf, n, off);
	enderror();
	return n;
}

long
sysread(int fd, void *buf, long n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syspread(fd, buf, n, (uvlong) ~0);
	enderror();
	return n;
}

int
sysremove(char *path)
{
	int n;

	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysremove(path);
	enderror();
	return n;
}

vlong
sysseek(int fd, vlong off, int whence)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	off = _sysseek(fd, off, whence);
	enderror();
	return off;
}

int
sysstat(char *name, uchar *buf, int n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _sysstat(name, buf, n);
	enderror();
	return n;
}

long
syswrite(int fd, void *buf, long n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syspwrite(fd, buf, n, (uvlong) ~0);
	enderror();
	return n;
}

int
syswstat(char *name, uchar *buf, int n)
{
	starterror();
	if(waserror()){
		_syserror();
		return -1;
	}
	n = _syswstat(name, buf, n);
	enderror();
	return n;
}

void
werrstr(char *f, ...)
{
	char buf[ERRMAX];
	va_list arg;

	va_start(arg, f);
	vsnprint(buf, sizeof buf, f, arg);
	va_end(arg);

	if(up-&gt;nerrlab)
		strecpy(up-&gt;errstr, up-&gt;errstr+ERRMAX, buf);
	else
		strecpy(up-&gt;syserrstr, up-&gt;syserrstr+ERRMAX, buf);
}

int
__errfmt(Fmt *fmt)
{
	if(up-&gt;nerrlab)
		return fmtstrcpy(fmt, up-&gt;errstr);
	else
		return fmtstrcpy(fmt, up-&gt;syserrstr);
}

int
errstr(char *buf, uint n)
{
	char tmp[ERRMAX];
	char *p;

	p = up-&gt;nerrlab ? up-&gt;errstr : up-&gt;syserrstr;
	memmove(tmp, p, ERRMAX);
	utfecpy(p, p+ERRMAX, buf);
	utfecpy(buf, buf+n, tmp);
	return strlen(buf);
}

int
rerrstr(char *buf, uint n)
{
	char *p;

	p = up-&gt;nerrlab ? up-&gt;errstr : up-&gt;syserrstr;
	utfecpy(buf, buf+n, p);
	return strlen(buf);
}

void*
_sysrendezvous(void* arg0, void* arg1)
{
	void *tag, *val;
	Proc *p, **l;

	tag = arg0;
	l = &amp;REND(up-&gt;rgrp, (uintptr)tag);
	up-&gt;rendval = (void*)~0;

	lock(&amp;up-&gt;rgrp-&gt;ref.lk);
	for(p = *l; p; p = p-&gt;rendhash) {
		if(p-&gt;rendtag == tag) {
			*l = p-&gt;rendhash;
			val = p-&gt;rendval;
			p-&gt;rendval = arg1;

			while(p-&gt;mach != 0)
				;
			procwakeup(p);
			unlock(&amp;up-&gt;rgrp-&gt;ref.lk);
			return val;
		}
		l = &amp;p-&gt;rendhash;
	}

	/* Going to sleep here */
	up-&gt;rendtag = tag;
	up-&gt;rendval = arg1;
	up-&gt;rendhash = *l;
	*l = up;
	up-&gt;state = Rendezvous;
	unlock(&amp;up-&gt;rgrp-&gt;ref.lk);

	procsleep();

	return up-&gt;rendval;
}

void*
sysrendezvous(void *tag, void *val)
{
	void *n;

	starterror();
	if(waserror()){
		_syserror();
		return (void*)~0;
	}
	n = _sysrendezvous(tag, val);
	enderror();
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

