<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libc/rune.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libc/rune.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;

#define Bit(i) (7-(i))
/* N 0's preceded by i 1's, T(Bit(2)) is 1100 0000 */
#define T(i) (((1 &lt;&lt; (Bit(i)+1))-1) ^ 0xFF)
/* 0000 0000 0000 0111 1111 1111 */
#define	RuneX(i) ((1 &lt;&lt; (Bit(i) + ((i)-1)*Bitx))-1)

enum
{
	Bitx	= Bit(1),

	Tx	= T(1),			/* 1000 0000 */
	Rune1 = (1&lt;&lt;(Bit(0)+0*Bitx))-1,	/* 0000 0000 0000 0000 0111 1111 */

	Maskx	= (1&lt;&lt;Bitx)-1,		/* 0011 1111 */
	Testx	= Maskx ^ 0xFF,		/* 1100 0000 */

	SurrogateMin	= 0xD800,
	SurrogateMax	= 0xDFFF,

	Bad	= Runeerror,
};

int
chartorune(Rune *rune, char *str)
{
	int c[UTFmax], i;
	Rune l;

	/*
	 * N character sequence
	 *	00000-0007F =&gt; T1
	 *	00080-007FF =&gt; T2 Tx
	 *	00800-0FFFF =&gt; T3 Tx Tx
	 *	10000-10FFFF =&gt; T4 Tx Tx Tx
	 */

	c[0] = *(uchar*)(str);
	if(c[0] &lt; Tx){
		*rune = c[0];
		return 1;
	}
	l = c[0];

	for(i = 1; i &lt; UTFmax; i++) {
		c[i] = *(uchar*)(str+i);
		c[i] ^= Tx;
		if(c[i] &amp; Testx)
			goto bad;
		l = (l &lt;&lt; Bitx) | c[i];
		if(c[0] &lt; T(i + 2)) {
			l &amp;= RuneX(i + 1);
			if(i == 1) {
				if(c[0] &lt; T(2) || l &lt;= Rune1)
					goto bad;
			} else if(l &lt;= RuneX(i) || l &gt; Runemax)
				goto bad;
			if (i == 2 &amp;&amp; SurrogateMin &lt;= l &amp;&amp; l &lt;= SurrogateMax)
				goto bad;
			*rune = l;
			return i + 1;
		}
	}

	/*
	 * bad decoding
	 */
bad:
	*rune = Bad;
	return 1;
}

int
runetochar(char *str, Rune *rune)
{
	int i, j;
	Rune c;

	c = *rune;
	if(c &lt;= Rune1) {
		str[0] = c;
		return 1;
	}

	/*
	 * one character sequence
	 *	00000-0007F =&gt; 00-7F
	 * two character sequence
	 *	0080-07FF =&gt; T2 Tx
	 * three character sequence
	 *	0800-FFFF =&gt; T3 Tx Tx
	 * four character sequence (21-bit value)
	 *     10000-1FFFFF =&gt; T4 Tx Tx Tx
	 * If the Rune is out of range or a surrogate half,
	 * convert it to the error rune.
	 * Do this test when i==3 because the error rune encodes to three bytes.
	 * Doing it earlier would duplicate work, since an out of range
	 * Rune wouldn't have fit in one or two bytes.
	 */
	for(i = 2; i &lt; UTFmax + 1; i++){
		if(i == 3){
			if(c &gt; Runemax)
				c = Runeerror;
			if(SurrogateMin &lt;= c &amp;&amp; c &lt;= SurrogateMax)
				c = Runeerror;
		}
		if (c &lt;= RuneX(i) || i == UTFmax ) {
			str[0] = T(i) |  (c &gt;&gt; (i - 1)*Bitx);
			for(j = 1; j &lt; i; j++)
				str[j] = Tx | ((c &gt;&gt; (i - j - 1)*Bitx) &amp; Maskx);
			return i;
		}
	}
	return UTFmax;
}

int
runelen(long c)
{
	Rune rune;
	char str[10];

	rune = c;
	return runetochar(str, &amp;rune);
}

int
runenlen(Rune *r, int nrune)
{
	int nb, i;
	Rune c;

	nb = 0;
	while(nrune--) {
		c = *r++;
		if(c &lt;= Rune1){
			nb++;
		} else {
			for(i = 2; i &lt; UTFmax + 1; i++)
				if(c &lt;= RuneX(i) || i == UTFmax){
					nb += i;
					break;
				}
		}
	}
	return nb;
}

int
fullrune(char *str, int n)
{
	int  i;
	Rune c;

	if(n &lt;= 0)
		return 0;
	c = *(uchar*)str;
	if(c &lt; Tx)
		return 1;
	for(i = 3; i &lt; UTFmax + 1; i++)
		if(c &lt; T(i))
			return n &gt;= i - 1;
	return n &gt;= UTFmax;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

