<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/drawterm/libmemdraw/fillpoly.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/drawterm/libmemdraw/fillpoly.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;memdraw.h&gt;
#include &lt;memlayer.h&gt;

typedef struct Seg	Seg;

struct Seg
{
	Point	p0;
	Point	p1;
	long	num;
	long	den;
	long	dz;
	long	dzrem;
	long	z;
	long	zerr;
	long	d;
};

static	void	zsort(Seg **seg, Seg **ep);
static	int	ycompare(const void*, const void*);
static	int	xcompare(const void*, const void*);
static	int	zcompare(const void*, const void*);
static	void	xscan(Memimage *dst, Seg **seg, Seg *segtab, int nseg, int wind, Memimage *src, Point sp, int, int, int, int);
static	void	yscan(Memimage *dst, Seg **seg, Seg *segtab, int nseg, int wind, Memimage *src, Point sp, int, int);

#ifdef NOT
static void
fillcolor(Memimage *dst, int left, int right, int y, Memimage *src, Point p)
{
	int srcval;

	USED(src);
	srcval = p.x;
	p.x = left;
	p.y = y;
	memset(byteaddr(dst, p), srcval, right-left);
}
#endif

static void
fillline(Memimage *dst, int left, int right, int y, Memimage *src, Point p, int op)
{
	Rectangle r;

	r.min.x = left;
	r.min.y = y;
	r.max.x = right;
	r.max.y = y+1;
	p.x += left;
	p.y += y;
	memdraw(dst, r, src, p, memopaque, p, op);
}

static void
fillpoint(Memimage *dst, int x, int y, Memimage *src, Point p, int op)
{
	Rectangle r;

	r.min.x = x;
	r.min.y = y;
	r.max.x = x+1;
	r.max.y = y+1;
	p.x += x;
	p.y += y;
	memdraw(dst, r, src, p, memopaque, p, op);
}

void
memfillpoly(Memimage *dst, Point *vert, int nvert, int w, Memimage *src, Point sp, int op)
{
	_memfillpolysc(dst, vert, nvert, w, src, sp, 0, 0, 0, op);
}

void
_memfillpolysc(Memimage *dst, Point *vert, int nvert, int w, Memimage *src, Point sp, int detail, int fixshift, int clipped, int op)
{
	Seg **seg, *segtab;
	Point p0;
	int i;

	if(nvert == 0)
		return;

	seg = malloc((nvert+2)*sizeof(Seg*));
	if(seg == nil)
		return;
	segtab = malloc((nvert+1)*sizeof(Seg));
	if(segtab == nil) {
		free(seg);
		return;
	}

	sp.x = (sp.x - vert[0].x) &gt;&gt; fixshift;
	sp.y = (sp.y - vert[0].y) &gt;&gt; fixshift;
	p0 = vert[nvert-1];
	if(!fixshift) {
		p0.x &lt;&lt;= 1;
		p0.y &lt;&lt;= 1;
	}
	for(i = 0; i &lt; nvert; i++) {
		segtab[i].p0 = p0;
		p0 = vert[i];
		if(!fixshift) {
			p0.x &lt;&lt;= 1;
			p0.y &lt;&lt;= 1;
		}
		segtab[i].p1 = p0;
		segtab[i].d = 1;
	}
	if(!fixshift)
		fixshift = 1;

	xscan(dst, seg, segtab, nvert, w, src, sp, detail, fixshift, clipped, op);
	if(detail)
		yscan(dst, seg, segtab, nvert, w, src, sp, fixshift, op);

	free(seg);
	free(segtab);
}

static long
mod(long x, long y)
{
	long z;

	z = x%y;
	if((long)(((ulong)z)^((ulong)y)) &gt; 0 || z == 0)
		return z;
	return z + y;
}

static long
sdiv(long x, long y)
{
	if((long)(((ulong)x)^((ulong)y)) &gt;= 0 || x == 0)
		return x/y;

	return (x+((y&gt;&gt;30)|1))/y-1;
}

static long
smuldivmod(long x, long y, long z, long *mod)
{
	vlong vx;

	if(x == 0 || y == 0){
		*mod = 0;
		return 0;
	}
	vx = x;
	vx *= y;
	*mod = vx % z;
	if(*mod &lt; 0)
		*mod += z;	/* z is always &gt;0 */
	if((vx &lt; 0) == (z &lt; 0))
		return vx/z;
	return -((-vx)/z);
}

static void
xscan(Memimage *dst, Seg **seg, Seg *segtab, int nseg, int wind, Memimage *src, Point sp, int detail, int fixshift, int clipped, int op)
{
	long y, maxy, x, x2, xerr, xden, onehalf;
	Seg **ep, **next, **p, **q, *s;
	long n, i, iy, cnt, ix, ix2, minx, maxx;
	Point pt;
	void	(*fill)(Memimage*, int, int, int, Memimage*, Point, int);

	fill = fillline;
/*
 * This can only work on 8-bit destinations, since fillcolor is
 * just using memset on sp.x.
 *
 * I'd rather not even enable it then, since then if the general
 * code is too slow, someone will come up with a better improvement
 * than this sleazy hack.	-rsc
 *
	if(clipped &amp;&amp; (src-&gt;flags&amp;Frepl) &amp;&amp; src-&gt;depth==8 &amp;&amp; Dx(src-&gt;r)==1 &amp;&amp; Dy(src-&gt;r)==1) {
		fill = fillcolor;
		sp.x = membyteval(src);
	}
 *
 */
	USED(clipped);


	for(i=0, s=segtab, p=seg; i&lt;nseg; i++, s++) {
		*p = s;
		if(s-&gt;p0.y == s-&gt;p1.y)
			continue;
		if(s-&gt;p0.y &gt; s-&gt;p1.y) {
			pt = s-&gt;p0;
			s-&gt;p0 = s-&gt;p1;
			s-&gt;p1 = pt;
			s-&gt;d = -s-&gt;d;
		}
		s-&gt;num = s-&gt;p1.x - s-&gt;p0.x;
		s-&gt;den = s-&gt;p1.y - s-&gt;p0.y;
		s-&gt;dz = sdiv(s-&gt;num, s-&gt;den) &lt;&lt; fixshift;
		s-&gt;dzrem = mod(s-&gt;num, s-&gt;den) &lt;&lt; fixshift;
		s-&gt;dz += sdiv(s-&gt;dzrem, s-&gt;den);
		s-&gt;dzrem = mod(s-&gt;dzrem, s-&gt;den);
		p++;
	}
	n = p-seg;
	if(n == 0)
		return;
	*p = 0;
	qsort(seg, p-seg , sizeof(Seg*), ycompare);

	onehalf = 0;
	if(fixshift)
		onehalf = 1 &lt;&lt; (fixshift-1);

	minx = dst-&gt;clipr.min.x;
	maxx = dst-&gt;clipr.max.x;

	y = seg[0]-&gt;p0.y;
	if(y &lt; (dst-&gt;clipr.min.y &lt;&lt; fixshift))
		y = dst-&gt;clipr.min.y &lt;&lt; fixshift;
	iy = (y + onehalf) &gt;&gt; fixshift;
	y = (iy &lt;&lt; fixshift) + onehalf;
	maxy = dst-&gt;clipr.max.y &lt;&lt; fixshift;

	ep = next = seg;

	while(y&lt;maxy) {
		for(q = p = seg; p &lt; ep; p++) {
			s = *p;
			if(s-&gt;p1.y &lt; y)
				continue;
			s-&gt;z += s-&gt;dz;
			s-&gt;zerr += s-&gt;dzrem;
			if(s-&gt;zerr &gt;= s-&gt;den) {
				s-&gt;z++;
				s-&gt;zerr -= s-&gt;den;
				if(s-&gt;zerr &lt; 0 || s-&gt;zerr &gt;= s-&gt;den)
					print("bad ratzerr1: %ld den %ld dzrem %ld\n", s-&gt;zerr, s-&gt;den, s-&gt;dzrem);
			}
			*q++ = s;
		}

		for(p = next; *p; p++) {
			s = *p;
			if(s-&gt;p0.y &gt;= y)
				break;
			if(s-&gt;p1.y &lt; y)
				continue;
			s-&gt;z = s-&gt;p0.x;
			s-&gt;z += smuldivmod(y - s-&gt;p0.y, s-&gt;num, s-&gt;den, &amp;s-&gt;zerr);
			if(s-&gt;zerr &lt; 0 || s-&gt;zerr &gt;= s-&gt;den)
				print("bad ratzerr2: %ld den %ld ratdzrem %ld\n", s-&gt;zerr, s-&gt;den, s-&gt;dzrem);
			*q++ = s;
		}
		ep = q;
		next = p;

		if(ep == seg) {
			if(*next == 0)
				break;
			iy = (next[0]-&gt;p0.y + onehalf) &gt;&gt; fixshift;
			y = (iy &lt;&lt; fixshift) + onehalf;
			continue;
		}

		zsort(seg, ep);

		for(p = seg; p &lt; ep; p++) {
			cnt = 0;
			x = p[0]-&gt;z;
			xerr = p[0]-&gt;zerr;
			xden = p[0]-&gt;den;
			ix = (x + onehalf) &gt;&gt; fixshift;
			if(ix &gt;= maxx)
				break;
			if(ix &lt; minx)
				ix = minx;
			cnt += p[0]-&gt;d;
			p++;
			for(;;) {
				if(p == ep) {
					print("xscan: fill to infinity");
					return;
				}
				cnt += p[0]-&gt;d;
				if((cnt&amp;wind) == 0)
					break;
				p++;
			}
			x2 = p[0]-&gt;z;
			ix2 = (x2 + onehalf) &gt;&gt; fixshift;
			if(ix2 &lt;= minx)
				continue;
			if(ix2 &gt; maxx)
				ix2 = maxx;
			if(ix == ix2 &amp;&amp; detail) {
				if(xerr*p[0]-&gt;den + p[0]-&gt;zerr*xden &gt; p[0]-&gt;den*xden)
					x++;
				ix = (x + x2) &gt;&gt; (fixshift+1);
				ix2 = ix+1;
			}
			(*fill)(dst, ix, ix2, iy, src, sp, op);
		}
		y += (1&lt;&lt;fixshift);
		iy++;
	}
}

static void
yscan(Memimage *dst, Seg **seg, Seg *segtab, int nseg, int wind, Memimage *src, Point sp, int fixshift, int op)
{
	long x, maxx, y, y2, yerr, yden, onehalf;
	Seg **ep, **next, **p, **q, *s;
	int n, i, ix, cnt, iy, iy2, miny, maxy;
	Point pt;

	for(i=0, s=segtab, p=seg; i&lt;nseg; i++, s++) {
		*p = s;
		if(s-&gt;p0.x == s-&gt;p1.x)
			continue;
		if(s-&gt;p0.x &gt; s-&gt;p1.x) {
			pt = s-&gt;p0;
			s-&gt;p0 = s-&gt;p1;
			s-&gt;p1 = pt;
			s-&gt;d = -s-&gt;d;
		}
		s-&gt;num = s-&gt;p1.y - s-&gt;p0.y;
		s-&gt;den = s-&gt;p1.x - s-&gt;p0.x;
		s-&gt;dz = sdiv(s-&gt;num, s-&gt;den) &lt;&lt; fixshift;
		s-&gt;dzrem = mod(s-&gt;num, s-&gt;den) &lt;&lt; fixshift;
		s-&gt;dz += sdiv(s-&gt;dzrem, s-&gt;den);
		s-&gt;dzrem = mod(s-&gt;dzrem, s-&gt;den);
		p++;
	}
	n = p-seg;
	if(n == 0)
		return;
	*p = 0;
	qsort(seg, n , sizeof(Seg*), xcompare);

	onehalf = 0;
	if(fixshift)
		onehalf = 1 &lt;&lt; (fixshift-1);

	miny = dst-&gt;clipr.min.y;
	maxy = dst-&gt;clipr.max.y;

	x = seg[0]-&gt;p0.x;
	if(x &lt; (dst-&gt;clipr.min.x &lt;&lt; fixshift))
		x = dst-&gt;clipr.min.x &lt;&lt; fixshift;
	ix = (x + onehalf) &gt;&gt; fixshift;
	x = (ix &lt;&lt; fixshift) + onehalf;
	maxx = dst-&gt;clipr.max.x &lt;&lt; fixshift;

	ep = next = seg;

	while(x&lt;maxx) {
		for(q = p = seg; p &lt; ep; p++) {
			s = *p;
			if(s-&gt;p1.x &lt; x)
				continue;
			s-&gt;z += s-&gt;dz;
			s-&gt;zerr += s-&gt;dzrem;
			if(s-&gt;zerr &gt;= s-&gt;den) {
				s-&gt;z++;
				s-&gt;zerr -= s-&gt;den;
				if(s-&gt;zerr &lt; 0 || s-&gt;zerr &gt;= s-&gt;den)
					print("bad ratzerr1: %ld den %ld ratdzrem %ld\n", s-&gt;zerr, s-&gt;den, s-&gt;dzrem);
			}
			*q++ = s;
		}

		for(p = next; *p; p++) {
			s = *p;
			if(s-&gt;p0.x &gt;= x)
				break;
			if(s-&gt;p1.x &lt; x)
				continue;
			s-&gt;z = s-&gt;p0.y;
			s-&gt;z += smuldivmod(x - s-&gt;p0.x, s-&gt;num, s-&gt;den, &amp;s-&gt;zerr);
			if(s-&gt;zerr &lt; 0 || s-&gt;zerr &gt;= s-&gt;den)
				print("bad ratzerr2: %ld den %ld ratdzrem %ld\n", s-&gt;zerr, s-&gt;den, s-&gt;dzrem);
			*q++ = s;
		}
		ep = q;
		next = p;

		if(ep == seg) {
			if(*next == 0)
				break;
			ix = (next[0]-&gt;p0.x + onehalf) &gt;&gt; fixshift;
			x = (ix &lt;&lt; fixshift) + onehalf;
			continue;
		}

		zsort(seg, ep);

		for(p = seg; p &lt; ep; p++) {
			cnt = 0;
			y = p[0]-&gt;z;
			yerr = p[0]-&gt;zerr;
			yden = p[0]-&gt;den;
			iy = (y + onehalf) &gt;&gt; fixshift;
			if(iy &gt;= maxy)
				break;
			if(iy &lt; miny)
				iy = miny;
			cnt += p[0]-&gt;d;
			p++;
			for(;;) {
				if(p == ep) {
					print("yscan: fill to infinity");
					return;
				}
				cnt += p[0]-&gt;d;
				if((cnt&amp;wind) == 0)
					break;
				p++;
			}
			y2 = p[0]-&gt;z;
			iy2 = (y2 + onehalf) &gt;&gt; fixshift;
			if(iy2 &lt;= miny)
				continue;
			if(iy2 &gt; maxy)
				iy2 = maxy;
			if(iy == iy2) {
				if(yerr*p[0]-&gt;den + p[0]-&gt;zerr*yden &gt; p[0]-&gt;den*yden)
					y++;
				iy = (y + y2) &gt;&gt; (fixshift+1);
				fillpoint(dst, ix, iy, src, sp, op);
			}
		}
		x += (1&lt;&lt;fixshift);
		ix++;
	}
}

static void
zsort(Seg **seg, Seg **ep)
{
	int done;
	Seg **q, **p, *s;

	if(ep-seg &lt; 20) {
		/* bubble sort by z - they should be almost sorted already */
		q = ep;
		do {
			done = 1;
			q--;
			for(p = seg; p &lt; q; p++) {
				if(p[0]-&gt;z &gt; p[1]-&gt;z) {
					s = p[0];
					p[0] = p[1];
					p[1] = s;
					done = 0;
				}
			}
		} while(!done);
	} else {
		q = ep-1;
		for(p = seg; p &lt; q; p++) {
			if(p[0]-&gt;z &gt; p[1]-&gt;z) {
				qsort(seg, ep-seg, sizeof(Seg*), zcompare);
				break;
			}
		}
	}
}

static int
ycompare(const void *a, const void *b)
{
	Seg **s0, **s1;
	long y0, y1;

	s0 = (Seg**)a;
	s1 = (Seg**)b;
	y0 = (*s0)-&gt;p0.y;
	y1 = (*s1)-&gt;p0.y;

	if(y0 &lt; y1)
		return -1;
	if(y0 == y1)
		return 0;
	return 1;
}

static int
xcompare(const void *a, const void *b)
{
	Seg **s0, **s1;
	long x0, x1;

	s0 = (Seg**)a;
	s1 = (Seg**)b;
	x0 = (*s0)-&gt;p0.x;
	x1 = (*s1)-&gt;p0.x;

	if(x0 &lt; x1)
		return -1;
	if(x0 == x1)
		return 0;
	return 1;
}

static int
zcompare(const void *a, const void *b)
{
	Seg **s0, **s1;
	long z0, z1;

	s0 = (Seg**)a;
	s1 = (Seg**)b;
	z0 = (*s0)-&gt;z;
	z1 = (*s1)-&gt;z;

	if(z0 &lt; z1)
		return -1;
	if(z0 == z1)
		return 0;
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

