<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/u9fs/doprint.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/u9fs/doprint.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;plan9.h&gt;

#define lock(x)
#define unlock(x)

enum
{
	IDIGIT	= 40,
	MAXCONV	= 40,
	FDIGIT	= 30,
	FDEFLT	= 6,
	NONE	= -1000,
	MAXFMT	= 512,

	FPLUS	= 1&lt;&lt;0,
	FMINUS	= 1&lt;&lt;1,
	FSHARP	= 1&lt;&lt;2,
	FLONG	= 1&lt;&lt;3,
	FUNSIGN	= 1&lt;&lt;5,
	FVLONG	= 1&lt;&lt;6,
	FPOINTER= 1&lt;&lt;7
};

int	printcol;

static struct
{
/*	Lock;	*/
	int	convcount;
	char	index[MAXFMT];
	int	(*conv[MAXCONV])(va_list*, Fconv*);
} fmtalloc;

static	int	noconv(va_list*, Fconv*);
static	int	flags(va_list*, Fconv*);

static	int	cconv(va_list*, Fconv*);
static	int	sconv(va_list*, Fconv*);
static	int	percent(va_list*, Fconv*);
static	int	column(va_list*, Fconv*);

extern	int	numbconv(va_list*, Fconv*);


static	void
initfmt(void)
{
	int cc;

	lock(&amp;fmtalloc);
	if(fmtalloc.convcount &lt;= 0) {
		cc = 0;
		fmtalloc.conv[cc] = noconv;
		cc++;

		fmtalloc.conv[cc] = flags;
		fmtalloc.index['+'] = cc;
		fmtalloc.index['-'] = cc;
		fmtalloc.index['#'] = cc;
		fmtalloc.index['l'] = cc;
		fmtalloc.index['u'] = cc;
		cc++;

		fmtalloc.conv[cc] = numbconv;
		fmtalloc.index['d'] = cc;
		fmtalloc.index['o'] = cc;
		fmtalloc.index['x'] = cc;
		fmtalloc.index['X'] = cc;
		fmtalloc.index['p'] = cc;
		cc++;


		fmtalloc.conv[cc] = cconv;
		fmtalloc.index['c'] = cc;
		fmtalloc.index['C'] = cc;
		cc++;

		fmtalloc.conv[cc] = sconv;
		fmtalloc.index['s'] = cc;
		fmtalloc.index['S'] = cc;
		cc++;

		fmtalloc.conv[cc] = percent;
		fmtalloc.index['%'] = cc;
		cc++;

		fmtalloc.conv[cc] = column;
		fmtalloc.index['|'] = cc;
		cc++;

		fmtalloc.convcount = cc;
	}
	unlock(&amp;fmtalloc);
}

int
fmtinstall(int c, int (*f)(va_list*, Fconv*))
{

	if(fmtalloc.convcount &lt;= 0)
		initfmt();

	lock(&amp;fmtalloc);
	if(c &lt; 0 || c &gt;= MAXFMT) {
		unlock(&amp;fmtalloc);
		return -1;
	}
	if(fmtalloc.convcount &gt;= MAXCONV) {
		unlock(&amp;fmtalloc);
		return -1;
	}
	fmtalloc.conv[fmtalloc.convcount] = f;
	fmtalloc.index[c] = fmtalloc.convcount;
	fmtalloc.convcount++;

	unlock(&amp;fmtalloc);
	return 0;
}

static	void
pchar(Rune c, Fconv *fp)
{
	int n;

	n = fp-&gt;eout - fp-&gt;out;
	if(n &gt; 0) {
		if(c &lt; Runeself) {
			*fp-&gt;out++ = c;
			return;
		}
		if(n &gt;= UTFmax || n &gt;= runelen(c)) {
			n = runetochar(fp-&gt;out, &amp;c);
			fp-&gt;out += n;
			return;
		}
		fp-&gt;eout = fp-&gt;out;
	}
}

char*
doprint(char *s, char *es, char *fmt, va_list *argp)
{
	int n, c;
	Rune rune;
	Fconv local;

	if(fmtalloc.convcount &lt;= 0)
		initfmt();

	if(s &gt;= es)
		return s;
	local.out = s;
	local.eout = es-1;

loop:
	c = *fmt &amp; 0xff;
	if(c &gt;= Runeself) {
		n = chartorune(&amp;rune, fmt);
		fmt += n;
		c = rune;
	} else
		fmt++;
	switch(c) {
	case 0:
		*local.out = 0;
		return local.out;
	
	default:
		printcol++;
		goto common;

	case '\n':
		printcol = 0;
		goto common;

	case '\t':
		printcol = (printcol+8) &amp; ~7;
		goto common;

	common:
		pchar(c, &amp;local);
		goto loop;

	case '%':
		break;
	}
	local.f1 = NONE;
	local.f2 = NONE;
	local.f3 = 0;

	/*
	 * read one of the following
	 *	1. number, =&gt; f1, f2 in order.
	 *	2. '*' same as number (from args)
	 *	3. '.' ignored (separates numbers)
	 *	4. flag =&gt; f3
	 *	5. verb and terminate
	 */
l0:
	c = *fmt &amp; 0xff;
	if(c &gt;= Runeself) {
		n = chartorune(&amp;rune, fmt);
		fmt += n;
		c = rune;
	} else
		fmt++;

l1:
	if(c == 0) {
		fmt--;
		goto loop;
	}
	if(c == '.') {
		if(local.f1 == NONE)
			local.f1 = 0;
		local.f2 = 0;
		goto l0;
	}
	if((c &gt;= '1' &amp;&amp; c &lt;= '9') ||
	   (c == '0' &amp;&amp; local.f1 != NONE)) {	/* '0' is a digit for f2 */
		n = 0;
		while(c &gt;= '0' &amp;&amp; c &lt;= '9') {
			n = n*10 + c-'0';
			c = *fmt++;
		}
		if(local.f1 == NONE)
			local.f1 = n;
		else
			local.f2 = n;
		goto l1;
	}
	if(c == '*') {
		n = va_arg(*argp, int);
		if(local.f1 == NONE)
			local.f1 = n;
		else
			local.f2 = n;
		goto l0;
	}
	n = 0;
	if(c &gt;= 0 &amp;&amp; c &lt; MAXFMT)
		n = fmtalloc.index[c];
	local.chr = c;
	n = (*fmtalloc.conv[n])(argp, &amp;local);
	if(n &lt; 0) {
		local.f3 |= -n;
		goto l0;
	}
	goto loop;
}

int
numbconv(va_list *arg, Fconv *fp)
{
	char s[IDIGIT];
	int i, f, n, b, ucase;
	long v;
	vlong vl;

	SET(v);
	SET(vl);

	ucase = 0;
	b = fp-&gt;chr;
	switch(fp-&gt;chr) {
	case 'u':
		fp-&gt;f3 |= FUNSIGN;
	case 'd':
		b = 10;
		break;

	case 'b':
		b = 2;
		break;

	case 'o':
		b = 8;
		break;

	case 'X':
		ucase = 1;
	case 'x':
		b = 16;
		break;
	case 'p':
		fp-&gt;f3 |= FPOINTER|FUNSIGN;
		b = 16;
		break;
	}

	f = 0;
	switch(fp-&gt;f3 &amp; (FVLONG|FLONG|FUNSIGN|FPOINTER)) {
	case FVLONG|FLONG:
		vl = va_arg(*arg, vlong);
		break;

	case FUNSIGN|FVLONG|FLONG:
		vl = va_arg(*arg, uvlong);
		break;

	case FUNSIGN|FPOINTER:
		v = (ulong)va_arg(*arg, void*);
		break;

	case FLONG:
		v = va_arg(*arg, long);
		break;

	case FUNSIGN|FLONG:
		v = va_arg(*arg, ulong);
		break;

	default:
		v = va_arg(*arg, int);
		break;

	case FUNSIGN:
		v = va_arg(*arg, unsigned);
		break;
	}
	if(fp-&gt;f3 &amp; FVLONG) {
		if(!(fp-&gt;f3 &amp; FUNSIGN) &amp;&amp; vl &lt; 0) {
			vl = -vl;
			f = 1;
		}
	} else {
		if(!(fp-&gt;f3 &amp; FUNSIGN) &amp;&amp; v &lt; 0) {
			v = -v;
			f = 1;
		}
	}
	s[IDIGIT-1] = 0;
	for(i = IDIGIT-2;; i--) {
		if(fp-&gt;f3 &amp; FVLONG)
			n = (uvlong)vl % b;
		else
			n = (ulong)v % b;
		n += '0';
		if(n &gt; '9') {
			n += 'a' - ('9'+1);
			if(ucase)
				n += 'A'-'a';
		}
		s[i] = n;
		if(i &lt; 2)
			break;
		if(fp-&gt;f3 &amp; FVLONG)
			vl = (uvlong)vl / b;
		else
			v = (ulong)v / b;
		if(fp-&gt;f2 != NONE &amp;&amp; i &gt;= IDIGIT-fp-&gt;f2)
			continue;
		if(fp-&gt;f3 &amp; FVLONG) {
			if(vl &lt;= 0)
				break;
			continue;
		}
		if(v &lt;= 0)
			break;
	}

	if(fp-&gt;f3 &amp; FSHARP) {
		if(b == 8 &amp;&amp; s[i] != '0')
			s[--i] = '0';
		if(b == 16) {
			if(ucase)
				s[--i] = 'X';
			else
				s[--i] = 'x';
			s[--i] = '0';
		}
	}
	if(f)
		s[--i] = '-';
	else if(fp-&gt;f3 &amp; FPLUS)
		s[--i] = '+';

	fp-&gt;f2 = NONE;
	strconv(s+i, fp);
	return 0;
}

void
Strconv(Rune *s, Fconv *fp)
{
	int n, c;

	if(fp-&gt;f3 &amp; FMINUS)
		fp-&gt;f1 = -fp-&gt;f1;
	n = 0;
	if(fp-&gt;f1 != NONE &amp;&amp; fp-&gt;f1 &gt;= 0) {
		for(; s[n]; n++)
			;
		while(n &lt; fp-&gt;f1) {
			pchar(' ', fp);
			printcol++;
			n++;
		}
	}
	for(;;) {
		c = *s++;
		if(c == 0)
			break;
		n++;
		if(fp-&gt;f2 == NONE || fp-&gt;f2 &gt; 0) {
			pchar(c, fp);
			if(fp-&gt;f2 != NONE)
				fp-&gt;f2--;
			switch(c) {
			default:
				printcol++;
				break;
			case '\n':
				printcol = 0;
				break;
			case '\t':
				printcol = (printcol+8) &amp; ~7;
				break;
			}
		}
	}
	if(fp-&gt;f1 != NONE &amp;&amp; fp-&gt;f1 &lt; 0) {
		fp-&gt;f1 = -fp-&gt;f1;
		while(n &lt; fp-&gt;f1) {
			pchar(' ', fp);
			printcol++;
			n++;
		}
	}
}

void
strconv(char *s, Fconv *fp)
{
	int n, c, i;
	Rune rune;

	if(fp-&gt;f3 &amp; FMINUS)
		fp-&gt;f1 = -fp-&gt;f1;
	n = 0;
	if(fp-&gt;f1 != NONE &amp;&amp; fp-&gt;f1 &gt;= 0) {
		n = utflen(s);
		while(n &lt; fp-&gt;f1) {
			pchar(' ', fp);
			printcol++;
			n++;
		}
	}
	for(;;) {
		c = *s &amp; 0xff;
		if(c &gt;= Runeself) {
			i = chartorune(&amp;rune, s);
			s += i;
			c = rune;
		} else
			s++;
		if(c == 0)
			break;
		n++;
		if(fp-&gt;f2 == NONE || fp-&gt;f2 &gt; 0) {
			pchar(c, fp);
			if(fp-&gt;f2 != NONE)
				fp-&gt;f2--;
			switch(c) {
			default:
				printcol++;
				break;
			case '\n':
				printcol = 0;
				break;
			case '\t':
				printcol = (printcol+8) &amp; ~7;
				break;
			}
		}
	}
	if(fp-&gt;f1 != NONE &amp;&amp; fp-&gt;f1 &lt; 0) {
		fp-&gt;f1 = -fp-&gt;f1;
		while(n &lt; fp-&gt;f1) {
			pchar(' ', fp);
			printcol++;
			n++;
		}
	}
}

static int
noconv(va_list *va, Fconv *fp)
{
	char s[10];

	USED(va);
	s[0] = '*';
	s[1] = fp-&gt;chr;
	s[2] = '*';
	s[3] = 0;
	fp-&gt;f1 = 0;
	fp-&gt;f2 = NONE;
	fp-&gt;f3 = 0;
	strconv(s, fp);
	return 0;
}

static int
cconv(va_list *arg, Fconv *fp)
{
	char s[10];
	Rune rune;

	rune = va_arg(*arg, int);
	if(fp-&gt;chr == 'c')
		rune &amp;= 0xff;
	s[runetochar(s, &amp;rune)] = 0;

	fp-&gt;f2 = NONE;
	strconv(s, fp);
	return 0;
}

static Rune null[] = { L'&lt;', L'n', L'u', L'l', L'l', L'&gt;', L'\0' };

static	int
sconv(va_list *arg, Fconv *fp)
{
	char *s;
	Rune *r;

	if(fp-&gt;chr == 's') {
		s = va_arg(*arg, char*);
		if(s == 0)
			s = "&lt;null&gt;";
		strconv(s, fp);
	} else {
		r = va_arg(*arg, Rune*);
		if(r == 0)
			r = null;
		Strconv(r, fp);
	}
	return 0;
}

static	int
percent(va_list *va, Fconv *fp)
{
	USED(va);

	pchar('%', fp);
	printcol++;
	return 0;
}

static	int
column(va_list *arg, Fconv *fp)
{
	int col, pc;

	col = va_arg(*arg, int);
	while(printcol &lt; col) {
		pc = (printcol+8) &amp; ~7;
		if(pc &lt;= col) {
			pchar('\t', fp);
			printcol = pc;
		} else {
			pchar(' ', fp);
			printcol++;
		}
	}
	return 0;
}

static int
flags(va_list *va, Fconv *fp)
{
	int f;

	USED(va);
	f = 0;
	switch(fp-&gt;chr) {
	case '+':
		f = FPLUS;
		break;

	case '-':
		f = FMINUS;
		break;

	case '#':
		f = FSHARP;
		break;

	case 'l':
		f = FLONG;
		if(fp-&gt;f3 &amp; FLONG)
			f = FVLONG;
		break;

	case 'u':
		f = FUNSIGN;
		break;
	}
	return -f;
}

/*
 * This code is superseded by the more accurate (but more complex)
 * algorithm in fltconv.c and dtoa.c.  Uncomment this routine to avoid
 * using the more complex code.
 *
 */

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

