<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/unix/u9fs/u9fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/unix/u9fs/u9fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/* already in plan9.h #include &lt;sys/types.h&gt; *//* for struct passwd, struct group, struct stat ... */
/* plan9.h is first to get the large file support definitions as early as possible */
#include &lt;plan9.h&gt;
#include &lt;sys/stat.h&gt;	/* for stat, umask */
#include &lt;stdlib.h&gt;	/* for malloc */
#include &lt;string.h&gt;	/* for strcpy, memmove */
#include &lt;pwd.h&gt;	/* for getpwnam, getpwuid */
#include &lt;grp.h&gt;	/* for getgrnam, getgrgid */
#include &lt;unistd.h&gt;	/* for gethostname, pread, pwrite, read, write */
#include &lt;utime.h&gt;	/* for utime */
#include &lt;dirent.h&gt;	/* for readdir */
#include &lt;errno.h&gt;	/* for errno */
#include &lt;stdio.h&gt;	/* for remove [sic] */
#include &lt;fcntl.h&gt;	/* for O_RDONLY, etc. */

#include &lt;sys/socket.h&gt;	/* various networking crud */
#include &lt;netinet/in.h&gt;
#include &lt;netdb.h&gt;

#include &lt;fcall.h&gt;
#include &lt;oldfcall.h&gt;
#include &lt;u9fs.h&gt;

/* #ifndef because can be given in makefile */
#ifndef DEFAULTLOG
#define DEFAULTLOG "/tmp/u9fs.log"
#endif

char *logfile = DEFAULTLOG;

#define S_ISSPECIAL(m) (S_ISCHR(m) || S_ISBLK(m) || S_ISFIFO(m))

enum {
	Tdot = 1,
	Tdotdot
};

enum {
	P9P1,
	P9P2000
};

typedef struct User User;
struct User {
	int id;
	gid_t defaultgid;
	char *name;
	char **mem;	/* group members */
	int nmem;
	User *next;
};

struct Fid {
	int fid;
	char *path;
	struct stat st;
	User *u;
	int omode;
	DIR *dir;
	int diroffset;
	int fd;
	struct dirent *dirent;
	int direof;
	Fid *next;
	Fid *prev;
	int auth;
	void *authmagic;
};

void*	emalloc(size_t);
void*	erealloc(void*, size_t);
char*	estrdup(char*);
char*	estrpath(char*, char*, int);
void	sysfatal(char*, ...);
int	okuser(char*);

void	rversion(Fcall*, Fcall*);
void	rauth(Fcall*, Fcall*);
void	rattach(Fcall*, Fcall*);
void	rflush(Fcall*, Fcall*);
void	rclone(Fcall*, Fcall*);
void	rwalk(Fcall*, Fcall*);
void	ropen(Fcall*, Fcall*);
void	rcreate(Fcall*, Fcall*);
void	rread(Fcall*, Fcall*);
void	rwrite(Fcall*, Fcall*);
void	rclunk(Fcall*, Fcall*);
void	rstat(Fcall*, Fcall*);
void	rwstat(Fcall*, Fcall*);
void	rclwalk(Fcall*, Fcall*);
void	rremove(Fcall*, Fcall*);

User*	uname2user(char*);
User*	gname2user(char*);
User*	uid2user(int);
User*	gid2user(int);

Fid*	newfid(int, char**);
Fid*	oldfidex(int, int, char**);
Fid*	oldfid(int, char**);
int	fidstat(Fid*, char**);
void	freefid(Fid*);

int	userchange(User*, char**);
int	userwalk(User*, char**, char*, Qid*, char**);
int	useropen(Fid*, int, char**);
int	usercreate(Fid*, char*, int, long, char**);
int	userremove(Fid*, char**);
int	userperm(User*, char*, int, int);
int	useringroup(User*, User*);

Qid	stat2qid(struct stat*);

void	getfcallold(int, Fcall*, int);
void	putfcallold(int, Fcall*);

char	Eauth[] =	"authentication failed";
char	Ebadfid[] =	"fid unknown or out of range";
char	Ebadoffset[] =	"bad offset in directory read";
char	Ebadusefid[] =	"bad use of fid";
char	Edirchange[] =	"wstat can't convert between files and directories";
char	Eexist[] =	"file or directory already exists";
char	Efidactive[] =	"fid already in use";
char	Enotdir[] =	"not a directory";
char	Enotingroup[] =	"not a member of proposed group";
char	Enotowner[] = 	"only owner can change group in wstat";
char	Eperm[] =	"permission denied";
char	Especial0[] =	"already attached without access to special files";
char	Especial1[] =	"already attached with access to special files";
char	Especial[] =	"no access to special file";
char	Etoolarge[] =	"i/o count too large";
char	Eunknowngroup[] = "unknown group";
char	Eunknownuser[] = "unknown user";
char	Ewstatbuffer[] = "bogus wstat buffer";

ulong	msize = IOHDRSZ+8192;
uchar*	rxbuf;
uchar*	txbuf;
void*	databuf;
int	connected;
int	devallowed;
char*	autharg;
char*	defaultuser;
char	hostname[256];
char	remotehostname[256];
int	chatty9p = 0;
int	network = 1;
int	old9p = -1;
int	authed;
User*	none;

Auth *authmethods[] = {	/* first is default */
	&amp;authrhosts,
	&amp;authp9any,
	&amp;authnone,
};

Auth *auth;

/*
 * frogs: characters not valid in plan9
 * filenames, keep this list in sync with
 * /sys/src/9/port/chan.c:1656
 */
char isfrog[256]={
	/*NUL*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*BKS*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*DLE*/	1, 1, 1, 1, 1, 1, 1, 1,
	/*CAN*/	1, 1, 1, 1, 1, 1, 1, 1,
	['/']	1,
	[0x7f]	1,
};

void
getfcallnew(int fd, Fcall *fc, int have)
{
	int len;

	if(have &gt; BIT32SZ)
		sysfatal("cannot happen");

	if(have &lt; BIT32SZ &amp;&amp; readn(fd, rxbuf+have, BIT32SZ-have) != BIT32SZ-have)
		sysfatal("couldn't read message");

	len = GBIT32(rxbuf);
	if(len &lt;= BIT32SZ)
		sysfatal("bogus message");

	len -= BIT32SZ;
	if(readn(fd, rxbuf+BIT32SZ, len) != len)
		sysfatal("short message");

	if(convM2S(rxbuf, len+BIT32SZ, fc) != len+BIT32SZ)
		sysfatal("badly sized message type %d", rxbuf[0]);
}

void
getfcallold(int fd, Fcall *fc, int have)
{
	int len, n;

	if(have &gt; 3)
		sysfatal("cannot happen");

	if(have &lt; 3 &amp;&amp; readn(fd, rxbuf, 3-have) != 3-have)
		sysfatal("couldn't read message");

	len = oldhdrsize(rxbuf[0]);
	if(len &lt; 3)
		sysfatal("bad message %d", rxbuf[0]);
	if(len &gt; 3 &amp;&amp; readn(fd, rxbuf+3, len-3) != len-3)
		sysfatal("couldn't read message");

	n = iosize(rxbuf);
	if(readn(fd, rxbuf+len, n) != n)
		sysfatal("couldn't read message");
	len += n;

	if(convM2Sold(rxbuf, len, fc) != len)
		sysfatal("badly sized message type %d", rxbuf[0]);
}

void
putfcallnew(int wfd, Fcall *tx)
{
	uint n;

	if((n = convS2M(tx, txbuf, msize)) == 0)
		sysfatal("couldn't format message type %d", tx-&gt;type);
	if(write(wfd, txbuf, n) != n)
		sysfatal("couldn't send message");
}

void
putfcallold(int wfd, Fcall *tx)
{
	uint n;

	if((n = convS2Mold(tx, txbuf, msize)) == 0)
		sysfatal("couldn't format message type %d", tx-&gt;type);
	if(write(wfd, txbuf, n) != n)
		sysfatal("couldn't send message");
}

void
getfcall(int fd, Fcall *fc)
{
	if(old9p == 1){
		getfcallold(fd, fc, 0);
		return;
	}
	if(old9p == 0){
		getfcallnew(fd, fc, 0);
		return;
	}

	/* auto-detect */
	if(readn(fd, rxbuf, 3) != 3)
		sysfatal("couldn't read message");

	/* is it an old (9P1) message? */
	if(50 &lt;= rxbuf[0] &amp;&amp; rxbuf[0] &lt;= 87 &amp;&amp; (rxbuf[0]&amp;1)==0 &amp;&amp; GBIT16(rxbuf+1) == 0xFFFF){
		old9p = 1;
		getfcallold(fd, fc, 3);
		return;
	}

	getfcallnew(fd, fc, 3);
	old9p = 0;
}

void
seterror(Fcall *f, char *error)
{
	f-&gt;type = Rerror;
	f-&gt;ename = error ? error : "programmer error";
}

int
isowner(User *u, Fid *f)
{
	return u-&gt;id == f-&gt;st.st_uid;
}



void
serve(int rfd, int wfd)
{
	Fcall rx, tx;

	for(;;){
		getfcall(rfd, &amp;rx);

		if(chatty9p)
			fprint(2, "&lt;- %F\n", &amp;rx);

		memset(&amp;tx, 0, sizeof tx);
		tx.type = rx.type+1;
		tx.tag = rx.tag;
		switch(rx.type){
		case Tflush:
			break;
		case Tversion:
			rversion(&amp;rx, &amp;tx);
			break;
		case Tauth:
			rauth(&amp;rx, &amp;tx);
			break;
		case Tattach:
			rattach(&amp;rx, &amp;tx);
			break;
		case Twalk:
			rwalk(&amp;rx, &amp;tx);
			break;
		case Tstat:
			tx.stat = databuf;
			rstat(&amp;rx, &amp;tx);
			break;
		case Twstat:
			rwstat(&amp;rx, &amp;tx);
			break;
		case Topen:
			ropen(&amp;rx, &amp;tx);
			break;
		case Tcreate:
			rcreate(&amp;rx, &amp;tx);
			break;
		case Tread:
			tx.data = databuf;
			rread(&amp;rx, &amp;tx);
			break;
		case Twrite:
			rwrite(&amp;rx, &amp;tx);
			break;
		case Tclunk:
			rclunk(&amp;rx, &amp;tx);
			break;
		case Tremove:
			rremove(&amp;rx, &amp;tx);
			break;
		default:
			fprint(2, "unknown message %F\n", &amp;rx);
			seterror(&amp;tx, "bad message");
			break;
		}

		if(chatty9p)
			fprint(2, "-&gt; %F\n", &amp;tx);

		(old9p ? putfcallold : putfcallnew)(wfd, &amp;tx);
	}
}

void
rversion(Fcall *rx, Fcall *tx)
{
	if(msize &gt; rx-&gt;msize)
		msize = rx-&gt;msize;
	tx-&gt;msize = msize;
	if(strncmp(rx-&gt;version, "9P", 2) != 0)
		tx-&gt;version = "unknown";
	else
		tx-&gt;version = "9P2000";
}

void
rauth(Fcall *rx, Fcall *tx)
{
	char *e;

	if((e = auth-&gt;auth(rx, tx)) != nil)
		seterror(tx, e);
}

void
rattach(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;
	User *u;

	if(rx-&gt;aname == nil)
		rx-&gt;aname = "";

	if(strcmp(rx-&gt;aname, "device") == 0){
		if(connected &amp;&amp; !devallowed){
			seterror(tx, Especial0);
			return;
		}
		devallowed = 1;
	}else{
		if(connected &amp;&amp; devallowed){
			seterror(tx, Especial1);
			return;
		}
	}

	if(strcmp(rx-&gt;uname, "none") == 0){
		if(authed == 0){
			seterror(tx, Eauth);
			return;
		}
		if (none != nil)
			rx-&gt;uname = none-&gt;name;
	} else {
		if((e = auth-&gt;attach(rx, tx)) != nil){
			seterror(tx, e);
			return;
		}
		authed++;
	}

	if((fid = newfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}
	fid-&gt;path = estrdup("/");
	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		freefid(fid);
		return;
	}

	if(defaultuser)
		rx-&gt;uname = defaultuser;

	if((u = uname2user(rx-&gt;uname)) == nil
	|| (!defaultuser &amp;&amp; u-&gt;id == 0)){
		/* we don't know anyone named root... */
		seterror(tx, Eunknownuser);
		freefid(fid);
		return;
	}

	fid-&gt;u = u;
	tx-&gt;qid = stat2qid(&amp;fid-&gt;st);
	return;
}

void
rwalk(Fcall *rx, Fcall *tx)
{
	int i;
	char *path, *e;
	Fid *fid, *nfid;

	e = nil;
	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if(fid-&gt;omode != -1){
		seterror(tx, Ebadusefid);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	if(!S_ISDIR(fid-&gt;st.st_mode) &amp;&amp; rx-&gt;nwname){
		seterror(tx, Enotdir);
		return;
	}

	nfid = nil;
	if(rx-&gt;newfid != rx-&gt;fid &amp;&amp; (nfid = newfid(rx-&gt;newfid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	path = estrdup(fid-&gt;path);
	e = nil;
	for(i=0; i&lt;rx-&gt;nwname; i++)
		if(userwalk(fid-&gt;u, &amp;path, rx-&gt;wname[i], &amp;tx-&gt;wqid[i], &amp;e) &lt; 0)
			break;

	if(i == rx-&gt;nwname){		/* successful clone or walk */
		tx-&gt;nwqid = i;
		if(nfid){
			nfid-&gt;path = path;
			nfid-&gt;u = fid-&gt;u;
		}else{
			free(fid-&gt;path);
			fid-&gt;path = path;
		}
	}else{
		if(i &gt; 0)		/* partial walk? */
			tx-&gt;nwqid = i;
		else
			seterror(tx, e);

		if(nfid)		/* clone implicit new fid */
			freefid(nfid);
		free(path);
	}
	return;
}

void
ropen(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;

	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if(fid-&gt;omode != -1){
		seterror(tx, Ebadusefid);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	if(!devallowed &amp;&amp; S_ISSPECIAL(fid-&gt;st.st_mode)){
		seterror(tx, Especial);
		return;
	}

	if(useropen(fid, rx-&gt;mode, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	tx-&gt;iounit = 0;
	tx-&gt;qid = stat2qid(&amp;fid-&gt;st);
}

void
rcreate(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;

	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if(fid-&gt;omode != -1){
		seterror(tx, Ebadusefid);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	if(!S_ISDIR(fid-&gt;st.st_mode)){
		seterror(tx, Enotdir);
		return;
	}

	if(usercreate(fid, rx-&gt;name, rx-&gt;mode, rx-&gt;perm, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	tx-&gt;iounit = 0;
	tx-&gt;qid = stat2qid(&amp;fid-&gt;st);
}

uchar
modebyte(struct stat *st)
{
	uchar b;

	b = 0;

	if(S_ISDIR(st-&gt;st_mode))
		b |= QTDIR;

	/* no way to test append-only */
	/* no real way to test exclusive use, but mark devices as such */
	if(S_ISSPECIAL(st-&gt;st_mode))
		b |= QTEXCL;

	return b;
}

ulong
plan9mode(struct stat *st)
{
	return ((ulong)modebyte(st)&lt;&lt;24) | (st-&gt;st_mode &amp; 0777);
}

/* 
 * this is for chmod, so don't worry about S_IFDIR
 */
mode_t
unixmode(Dir *d)
{
	return (mode_t)(d-&gt;mode&amp;0777);
}

Qid
stat2qid(struct stat *st)
{
	uchar *p, *ep, *q;
	Qid qid;

	/*
	 * For now, ignore the device number.
	 */
	qid.path = 0;
	p = (uchar*)&amp;qid.path;
	ep = p+sizeof(qid.path);
	q = p+sizeof(ino_t);
	if(q &gt; ep){
		fprint(2, "warning: inode number too big\n");
		q = ep;
	}
	memmove(p, &amp;st-&gt;st_ino, q-p);
	q = q+sizeof(dev_t);
	if(q &gt; ep){
/*
 *		fprint(2, "warning: inode number + device number too big %d+%d\n",
 *			sizeof(ino_t), sizeof(dev_t));
 */
		q = ep - sizeof(dev_t);
		if(q &lt; p)
			fprint(2, "warning: device number too big by itself\n");
		else
			*(dev_t*)q ^= st-&gt;st_dev;
	}

	qid.vers = st-&gt;st_mtime ^ (st-&gt;st_size &lt;&lt; 8);
	qid.type = modebyte(st);
	return qid;
}

char *
enfrog(char *src)
{
	char *d, *dst;
	uchar *s;

	d = dst = emalloc(strlen(src)*3 + 1);
	for (s = (uchar *)src; *s; s++)
		if(isfrog[*s] || *s == '\\')
			d += sprintf(d, "\\%02x", *s);
		else
			*d++ = *s;
	*d = 0;
	return dst;
}

char *
defrog(char *s)
{
	char *d, *dst, buf[3];

	d = dst = emalloc(strlen(s) + 1);
	for(; *s; s++)
		if(*s == '\\' &amp;&amp; strlen(s) &gt;= 3){
			buf[0] = *++s;			/* skip \ */
			buf[1] = *++s;
			buf[2] = 0;
			*d++ = strtoul(buf, NULL, 16);
		} else
			*d++ = *s;
	*d = 0;
	return dst;
}

void
stat2dir(char *path, struct stat *st, Dir *d)
{
	User *u;
	char *q, *p, *npath;

	memset(d, 0, sizeof(*d));
	d-&gt;qid = stat2qid(st);
	d-&gt;mode = plan9mode(st);
	d-&gt;atime = st-&gt;st_atime;
	d-&gt;mtime = st-&gt;st_mtime;
	d-&gt;length = st-&gt;st_size;

	d-&gt;uid = (u = uid2user(st-&gt;st_uid)) ? u-&gt;name : "???";
	d-&gt;gid = (u = gid2user(st-&gt;st_gid)) ? u-&gt;name : "???";
	d-&gt;muid = "";

	if((q = strrchr(path, '/')) != nil)
		d-&gt;name = enfrog(q+1);
	else
		d-&gt;name = enfrog(path);
}

void
rread(Fcall *rx, Fcall *tx)
{
	char *e, *path;
	uchar *p, *ep;
	int n;
	Fid *fid;
	Dir d;
	struct stat st;

	if(rx-&gt;count &gt; msize-IOHDRSZ){
		seterror(tx, Etoolarge);
		return;
	}

	if((fid = oldfidex(rx-&gt;fid, -1, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if (fid-&gt;auth) {
		char *e;
		e = auth-&gt;read(rx, tx);
		if (e)
			seterror(tx, e);
		return;
	}

	if(fid-&gt;omode == -1 || (fid-&gt;omode&amp;3) == OWRITE){
		seterror(tx, Ebadusefid);
		return;
	}

	if(fid-&gt;dir){
		if(rx-&gt;offset != fid-&gt;diroffset){
			if(rx-&gt;offset != 0){
				seterror(tx, Ebadoffset);
				return;
			}
			rewinddir(fid-&gt;dir);
			fid-&gt;diroffset = 0;
			fid-&gt;direof = 0;
		}
		if(fid-&gt;direof){
			tx-&gt;count = 0;
			return;
		}

		p = (uchar*)tx-&gt;data;
		ep = (uchar*)tx-&gt;data+rx-&gt;count;
		for(;;){
			if(p+BIT16SZ &gt;= ep)
				break;
			if(fid-&gt;dirent == nil)	/* one entry cache for when convD2M fails */
				if((fid-&gt;dirent = readdir(fid-&gt;dir)) == nil){
					fid-&gt;direof = 1;
					break;
				}
			if(strcmp(fid-&gt;dirent-&gt;d_name, ".") == 0
			|| strcmp(fid-&gt;dirent-&gt;d_name, "..") == 0){
				fid-&gt;dirent = nil;
				continue;
			}
			path = estrpath(fid-&gt;path, fid-&gt;dirent-&gt;d_name, 0);
			memset(&amp;st, 0, sizeof st);
			if(stat(path, &amp;st) &lt; 0){
				fprint(2, "dirread: stat(%s) failed: %s\n", path, strerror(errno));
				fid-&gt;dirent = nil;
				free(path);
				continue;
			}
			free(path);
			stat2dir(fid-&gt;dirent-&gt;d_name, &amp;st, &amp;d);
			if((n=(old9p ? convD2Mold : convD2M)(&amp;d, p, ep-p)) &lt;= BIT16SZ)
				break;
			p += n;
			fid-&gt;dirent = nil;
		}
		tx-&gt;count = p - (uchar*)tx-&gt;data;
		fid-&gt;diroffset += tx-&gt;count;
	}else{
		if((n = pread(fid-&gt;fd, tx-&gt;data, rx-&gt;count, rx-&gt;offset)) &lt; 0){
			seterror(tx, strerror(errno));
			return;
		}
		tx-&gt;count = n;
	}
}

void
rwrite(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;
	int n;

	if(rx-&gt;count &gt; msize-IOHDRSZ){
		seterror(tx, Etoolarge);
		return;
	}

	if((fid = oldfidex(rx-&gt;fid, -1, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if (fid-&gt;auth) {
		char *e;
		e = auth-&gt;write(rx, tx);
		if (e)
			seterror(tx, e);
		return;
	}

	if(fid-&gt;omode == -1 || (fid-&gt;omode&amp;3) == OREAD || (fid-&gt;omode&amp;3) == OEXEC){
		seterror(tx, Ebadusefid);
		return;
	}

	if((n = pwrite(fid-&gt;fd, rx-&gt;data, rx-&gt;count, rx-&gt;offset)) &lt; 0){
		seterror(tx, strerror(errno));
		return;
	}
	tx-&gt;count = n;
}

void
rclunk(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;

	if((fid = oldfidex(rx-&gt;fid, -1, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}
	if (fid-&gt;auth) {
		if (auth-&gt;clunk) {
			e = (*auth-&gt;clunk)(rx, tx);
			if (e) {
				seterror(tx, e);
				return;
			}
		}
	}
	else if(fid-&gt;omode != -1 &amp;&amp; fid-&gt;omode&amp;ORCLOSE)
		remove(fid-&gt;path);
	freefid(fid);
}

void
rremove(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;

	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}
	if(userremove(fid, &amp;e) &lt; 0)
		seterror(tx, e);
	freefid(fid);
}

void
rstat(Fcall *rx, Fcall *tx)
{
	char *e;
	Fid *fid;
	Dir d;

	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	stat2dir(fid-&gt;path, &amp;fid-&gt;st, &amp;d);
	if((tx-&gt;nstat=(old9p ? convD2Mold : convD2M)(&amp;d, tx-&gt;stat, msize)) &lt;= BIT16SZ)
		seterror(tx, "convD2M fails");
}

void
rwstat(Fcall *rx, Fcall *tx)
{
	char *e;
	char *p, *old, *new, *dir;
	gid_t gid;
	Dir d;
	Fid *fid;

	if((fid = oldfid(rx-&gt;fid, &amp;e)) == nil){
		seterror(tx, e);
		return;
	}

	/*
	 * wstat is supposed to be atomic.
	 * we check all the things we can before trying anything.
	 * still, if we are told to truncate a file and rename it and only
	 * one works, we're screwed.  in such cases we leave things
	 * half broken and return an error.  it's hardly perfect.
	 */
	if((old9p ? convM2Dold : convM2D)(rx-&gt;stat, rx-&gt;nstat, &amp;d, (char*)rx-&gt;stat) &lt;= BIT16SZ){
		seterror(tx, Ewstatbuffer);
		return;
	}

	if(fidstat(fid, &amp;e) &lt; 0){
		seterror(tx, e);
		return;
	}

	/*
	 * The casting is necessary because d.mode is ulong and might,
	 * on some systems, be 64 bits.  We only want to compare the
	 * bottom 32 bits, since that's all that gets sent in the protocol.
	 * 
	 * Same situation for d.mtime and d.length (although that last check
	 * is admittedly superfluous, given the current lack of 128-bit machines).
	 */
	gid = (gid_t)-1;
	if(d.gid[0] != '\0'){
		User *g;

		g = gname2user(d.gid);
		if(g == nil){
			seterror(tx, Eunknowngroup);
			return;
		}
		gid = (gid_t)g-&gt;id;

		if(groupchange(fid-&gt;u, gid2user(gid), &amp;e) &lt; 0){
			seterror(tx, e);
			return;
		}		
	}

	if((u32int)d.mode != (u32int)~0 &amp;&amp; (((d.mode&amp;DMDIR)!=0) ^ (S_ISDIR(fid-&gt;st.st_mode)!=0))){
		seterror(tx, Edirchange);
		return;
	}

	if(strcmp(fid-&gt;path, "/") == 0){
		seterror(tx, "no wstat of root");
		return;
	}

	/*
	 * try things in increasing order of harm to the file.
	 * mtime should come after truncate so that if you
	 * do both the mtime actually takes effect, but i'd rather
	 * leave truncate until last.
	 * (see above comment about atomicity).
	 */
	if((u32int)d.mode != (u32int)~0 &amp;&amp; chmod(fid-&gt;path, unixmode(&amp;d)) &lt; 0){
		if(chatty9p)
			fprint(2, "chmod(%s, 0%luo) failed\n", fid-&gt;path, unixmode(&amp;d));
		seterror(tx, strerror(errno));
		return;
	}

	if((u32int)d.mtime != (u32int)~0){
		struct utimbuf t;

		t.actime = 0;
		t.modtime = d.mtime;
		if(utime(fid-&gt;path, &amp;t) &lt; 0){
			if(chatty9p)
				fprint(2, "utime(%s) failed\n", fid-&gt;path);
			seterror(tx, strerror(errno));
			return;
		}
	}

	if(gid != (gid_t)-1 &amp;&amp; gid != fid-&gt;st.st_gid){
		if(chown(fid-&gt;path, (uid_t)-1, gid) &lt; 0){
			if(chatty9p)
				fprint(2, "chgrp(%s, %d) failed\n", fid-&gt;path, gid);
			seterror(tx, strerror(errno));
			return;
		}
	}

	if(d.name[0]){
		old = fid-&gt;path;
		dir = estrdup(fid-&gt;path);
		if((p = strrchr(dir, '/')) &gt; dir)
			*p = '\0';
		else{
			seterror(tx, "whoops: can't happen in u9fs");
			return;
		}
		new = estrpath(dir, d.name, 1);
		if(strcmp(old, new) != 0 &amp;&amp; rename(old, new) &lt; 0){
			if(chatty9p)
				fprint(2, "rename(%s, %s) failed\n", old, new);
			seterror(tx, strerror(errno));
			free(new);
			free(dir);
			return;
		}
		fid-&gt;path = new;
		free(old);
		free(dir);
	}

	if((u64int)d.length != (u64int)~0 &amp;&amp; truncate(fid-&gt;path, d.length) &lt; 0){
		fprint(2, "truncate(%s, %lld) failed\n", fid-&gt;path, d.length);
		seterror(tx, strerror(errno));
		return;
	}
}

/*
 * we keep a table by numeric id.  by name lookups happen infrequently
 * while by-number lookups happen once for every directory entry read
 * and every stat request.
 */
User *utab[64];
User *gtab[64];

User*
adduser(struct passwd *p)
{
	User *u;

	u = emalloc(sizeof(*u));
	u-&gt;id = p-&gt;pw_uid;
	u-&gt;name = estrdup(p-&gt;pw_name);
	u-&gt;next = utab[p-&gt;pw_uid%nelem(utab)];
	u-&gt;defaultgid = p-&gt;pw_gid;
	utab[p-&gt;pw_uid%nelem(utab)] = u;
	return u;
}

int
useringroup(User *u, User *g)
{
	int i;

	for(i=0; i&lt;g-&gt;nmem; i++)
		if(strcmp(g-&gt;mem[i], u-&gt;name) == 0)
			return 1;

	/*
	 * Hack around common Unix problem that everyone has
	 * default group "user" but /etc/group lists no members.
	 */
	if(u-&gt;defaultgid == g-&gt;id)
		return 1;
	return 0;
}

User*
addgroup(struct group *g)
{
	User *u;
	char **p;
	int n;

	u = emalloc(sizeof(*u));
	n = 0;
	for(p=g-&gt;gr_mem; *p; p++)
		n++;
	u-&gt;mem = emalloc(sizeof(u-&gt;mem[0])*n);
	n = 0;
	for(p=g-&gt;gr_mem; *p; p++)
		u-&gt;mem[n++] = estrdup(*p);
	u-&gt;nmem = n;
	u-&gt;id = g-&gt;gr_gid;
	u-&gt;name = estrdup(g-&gt;gr_name);
	u-&gt;next = gtab[g-&gt;gr_gid%nelem(gtab)];
	gtab[g-&gt;gr_gid%nelem(gtab)] = u;
	return u;
}

User*
uname2user(char *name)
{
	int i;
	User *u;
	struct passwd *p;

	for(i=0; i&lt;nelem(utab); i++)
		for(u=utab[i]; u; u=u-&gt;next)
			if(strcmp(u-&gt;name, name) == 0)
				return u;

	if((p = getpwnam(name)) == nil)
		return nil;
	return adduser(p);
}

User*
uid2user(int id)
{
	User *u;
	struct passwd *p;

	for(u=utab[id%nelem(utab)]; u; u=u-&gt;next)
		if(u-&gt;id == id)
			return u;

	if((p = getpwuid(id)) == nil)
		return nil;
	return adduser(p);
}

User*
gname2user(char *name)
{
	int i;
	User *u;
	struct group *g;

	for(i=0; i&lt;nelem(gtab); i++)
		for(u=gtab[i]; u; u=u-&gt;next)
			if(strcmp(u-&gt;name, name) == 0)
				return u;

	if((g = getgrnam(name)) == nil)
		return nil;
	return addgroup(g);
}

User*
gid2user(int id)
{
	User *u;
	struct group *g;

	for(u=gtab[id%nelem(gtab)]; u; u=u-&gt;next)
		if(u-&gt;id == id)
			return u;

	if((g = getgrgid(id)) == nil)
		return nil;
	return addgroup(g);
}

void
sysfatal(char *fmt, ...)
{
	char buf[1024];
	va_list va, temp;

	va_start(va, fmt);
	va_copy(temp, va);
	doprint(buf, buf+sizeof buf, fmt, &amp;temp);
	va_end(temp);
	va_end(va);
	fprint(2, "u9fs: %s\n", buf);
	fprint(2, "last unix error: %s\n", strerror(errno));
	exit(1);
}

void*
emalloc(size_t n)
{
	void *p;

	if(n == 0)
		n = 1;
	p = malloc(n);
	if(p == 0)
		sysfatal("malloc(%ld) fails", (long)n);
	memset(p, 0, n);
	return p;
}

void*
erealloc(void *p, size_t n)
{
	if(p == 0)
		p = malloc(n);
	else
		p = realloc(p, n);
	if(p == 0)
		sysfatal("realloc(..., %ld) fails", (long)n);
	return p;
}

char*
estrdup(char *p)
{
	p = strdup(p);
	if(p == 0)
		sysfatal("strdup(%.20s) fails", p);
	return p;
}

char*
estrpath(char *p, char *q, int frog)
{
	char *r, *s;

	if(strcmp(q, "..") == 0){
		r = estrdup(p);
		if((s = strrchr(r, '/')) &amp;&amp; s &gt; r)
			*s = '\0';
		else if(s == r)
			s[1] = '\0';
		return r;
	}

	if(frog)
		q = defrog(q);
	else
		q = strdup(q);
	r = emalloc(strlen(p)+1+strlen(q)+1);
	strcpy(r, p);
	if(r[0]=='\0' || r[strlen(r)-1] != '/')
		strcat(r, "/");
	strcat(r, q);
	free(q);
	return r;
}

Fid *fidtab[1];

Fid*
lookupfid(int fid)
{
	Fid *f;

	for(f=fidtab[fid%nelem(fidtab)]; f; f=f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
	return nil;
}

Fid*
newfid(int fid, char **ep)
{
	Fid *f;

	if(lookupfid(fid) != nil){
		*ep = Efidactive;
		return nil;
	}

	f = emalloc(sizeof(*f));
	f-&gt;next = fidtab[fid%nelem(fidtab)];
	if(f-&gt;next)
		f-&gt;next-&gt;prev = f;
	fidtab[fid%nelem(fidtab)] = f;
	f-&gt;fid = fid;
	f-&gt;fd = -1;
	f-&gt;omode = -1;
	return f;
}

Fid*
newauthfid(int fid, void *magic, char **ep)
{
	Fid *af;
	af = newfid(fid, ep);
	if (af == nil)
		return nil;
	af-&gt;auth = 1;
	af-&gt;authmagic = magic;
	return af;
}

Fid*
oldfidex(int fid, int auth, char **ep)
{
	Fid *f;

	if((f = lookupfid(fid)) == nil){
		*ep = Ebadfid;
		return nil;
	}

	if (auth != -1 &amp;&amp; f-&gt;auth != auth) {
		*ep = Ebadfid;
		return nil;
	}

	if (!f-&gt;auth) {
		if(userchange(f-&gt;u, ep) &lt; 0)
			return nil;
	}

	return f;
}

Fid*
oldfid(int fid, char **ep)
{
	return oldfidex(fid, 0, ep);
}

Fid*
oldauthfid(int fid, void **magic, char **ep)
{
	Fid *af;
	af = oldfidex(fid, 1, ep);
	if (af == nil)
		return nil;
	*magic = af-&gt;authmagic;
	return af;
}

void
freefid(Fid *f)
{
	if(f-&gt;prev)
		f-&gt;prev-&gt;next = f-&gt;next;
	else
		fidtab[f-&gt;fid%nelem(fidtab)] = f-&gt;next;
	if(f-&gt;next)
		f-&gt;next-&gt;prev = f-&gt;prev;
	if(f-&gt;dir)
		closedir(f-&gt;dir);
	if(f-&gt;fd)
		close(f-&gt;fd);
	free(f-&gt;path);
	free(f);
}

int
fidstat(Fid *fid, char **ep)
{
	if(stat(fid-&gt;path, &amp;fid-&gt;st) &lt; 0){
		fprint(2, "fidstat(%s) failed\n", fid-&gt;path);
		if(ep)
			*ep = strerror(errno);
		return -1;
	}
	if(S_ISDIR(fid-&gt;st.st_mode))
		fid-&gt;st.st_size = 0;
	return 0;
}

int
userchange(User *u, char **ep)
{
	if(defaultuser)
		return 0;

	if(setreuid(0, 0) &lt; 0){
		fprint(2, "setreuid(0, 0) failed\n");
		*ep = "cannot setuid back to root";
		return -1;
	}

	/*
	 * Initgroups does not appear to be SUSV standard.
	 * But it exists on SGI and on Linux, which makes me
	 * think it's standard enough.  We have to do something
	 * like this, and the closest other function I can find is
	 * setgroups (which initgroups eventually calls).
	 * Setgroups is the same as far as standardization though,
	 * so we're stuck using a non-SUSV call.  Sigh.
	 */
	if(initgroups(u-&gt;name, u-&gt;defaultgid) &lt; 0)
		fprint(2, "initgroups(%s) failed: %s\n", u-&gt;name, strerror(errno));

	if(setreuid(-1, u-&gt;id) &lt; 0){
		fprint(2, "setreuid(-1, %s) failed\n", u-&gt;name);
		*ep = strerror(errno);
		return -1;
	}

	return 0;
}

/*
 * We do our own checking here, then switch to root temporarily
 * to set our gid.  In a perfect world, you'd be allowed to set your
 * egid to any of the supplemental groups of your euid, but this
 * is not the case on Linux 2.2.14 (and perhaps others).
 *
 * This is a race, of course, but it's a race against processes
 * that can edit the group lists.  If you can do that, you can
 * change your own group without our help.
 */
int
groupchange(User *u, User *g, char **ep)
{
	if(g == nil)
		return -1;
	if(!useringroup(u, g)){
		if(chatty9p)
			fprint(2, "%s not in group %s\n", u-&gt;name, g-&gt;name);
		*ep = Enotingroup;
		return -1;
	}

	setreuid(0,0);
	if(setregid(-1, g-&gt;id) &lt; 0){
		fprint(2, "setegid(%s/%d) failed in groupchange\n", g-&gt;name, g-&gt;id);
		*ep = strerror(errno);
		return -1;
	}
	if(userchange(u, ep) &lt; 0)
		return -1;

	return 0;
}


/*
 * An attempt to enforce permissions by looking at the 
 * file system.  Separation of checking permission and
 * actually performing the action is a terrible idea, of 
 * course, so we use setreuid for most of the permission
 * enforcement.  This is here only so we can give errors
 * on open(ORCLOSE) in some cases.
 */
int
userperm(User *u, char *path, int type, int need)
{
	char *p, *q;
	int i, have;
	struct stat st;
	User *g;

	switch(type){
	default:
		fprint(2, "bad type %d in userperm\n", type);
		return -1;
	case Tdot:
		if(stat(path, &amp;st) &lt; 0){
			fprint(2, "userperm: stat(%s) failed\n", path);
			return -1;
		}
		break;
	case Tdotdot:
		p = estrdup(path);
		if((q = strrchr(p, '/'))==nil){
			fprint(2, "userperm(%s, ..): bad path\n", p);
			free(p);
			return -1;
		}
		if(q &gt; p)
			*q = '\0';
		else
			*(q+1) = '\0';
		if(stat(p, &amp;st) &lt; 0){
			fprint(2, "userperm: stat(%s) (dotdot of %s) failed\n",
				p, path);
			free(p);
			return -1;
		}
		free(p);
		break;
	}

	if(u == none){
		fprint(2, "userperm: none wants %d in 0%luo\n", need, st.st_mode);
		have = st.st_mode&amp;7;
		if((have&amp;need)==need)
			return 0;
		return -1;
	}
	have = st.st_mode&amp;7;
	if((uid_t)u-&gt;id == st.st_uid)
		have |= (st.st_mode&gt;&gt;6)&amp;7;
	if((have&amp;need)==need)
		return 0;
	if(((have|((st.st_mode&gt;&gt;3)&amp;7))&amp;need) != need)	/* group won't help */
		return -1;
	g = gid2user(st.st_gid);
	for(i=0; i&lt;g-&gt;nmem; i++){
		if(strcmp(g-&gt;mem[i], u-&gt;name) == 0){
			have |= (st.st_mode&gt;&gt;3)&amp;7;
			break;
		}
	}
	if((have&amp;need)==need)
		return 0;
	return -1;
}

int
userwalk(User *u, char **path, char *elem, Qid *qid, char **ep)
{
	char *npath;
	struct stat st;

	npath = estrpath(*path, elem, 1);
	if(stat(npath, &amp;st) &lt; 0){
		free(npath);
		*ep = strerror(errno);
		return -1;
	}
	*qid = stat2qid(&amp;st);
	free(*path);
	*path = npath;
	return 0;
}

int
useropen(Fid *fid, int omode, char **ep)
{
	int a, o;

	/*
	 * Check this anyway, to try to head off problems later.
	 */
	if((omode&amp;ORCLOSE) &amp;&amp; userperm(fid-&gt;u, fid-&gt;path, Tdotdot, W_OK) &lt; 0){
		*ep = Eperm;
		return -1;
	}

	switch(omode&amp;3){
	default:
		*ep = "programmer error";
		return -1;
	case OREAD:
		a = R_OK;
		o = O_RDONLY;
		break;
	case ORDWR:
		a = R_OK|W_OK;
		o = O_RDWR;
		break;
	case OWRITE:
		a = W_OK;
		o = O_WRONLY;
		break;
	case OEXEC:
		a = X_OK;
		o = O_RDONLY;
		break;
	}
	if(omode &amp; OTRUNC){
		a |= W_OK;
		o |= O_TRUNC;
	}

	if(S_ISDIR(fid-&gt;st.st_mode)){
		if(a != R_OK){
			fprint(2, "attempt by %s to open dir %d\n", fid-&gt;u-&gt;name, omode);
			*ep = Eperm;
			return -1;
		}
		if((fid-&gt;dir = opendir(fid-&gt;path)) == nil){
			*ep = strerror(errno);
			return -1;
		}
	}else{
		/*
		 * This is wrong because access used the real uid
		 * and not the effective uid.  Let the open sort it out.
		 *
		if(access(fid-&gt;path, a) &lt; 0){
			*ep = strerror(errno);
			return -1;
		}
		 *
		 */
		if((fid-&gt;fd = open(fid-&gt;path, o)) &lt; 0){
			*ep = strerror(errno);
			return -1;
		}
	}
	fid-&gt;omode = omode;
	return 0;
}

int
usercreate(Fid *fid, char *elem, int omode, long perm, char **ep)
{
	int o, m;
	char *opath, *npath;
	struct stat st, parent;

	if(stat(fid-&gt;path, &amp;parent) &lt; 0){
		*ep = strerror(errno);
		return -1;
	}

	/*
	 * Change group so that created file has expected group
	 * by Plan 9 semantics.  If that fails, might as well go
	 * with the user's default group.
	 */
	if(groupchange(fid-&gt;u, gid2user(parent.st_gid), ep) &lt; 0
	&amp;&amp; groupchange(fid-&gt;u, gid2user(fid-&gt;u-&gt;defaultgid), ep) &lt; 0)
		return -1;

	m = (perm &amp; DMDIR) ? 0777 : 0666;
	perm = perm &amp; (~m | (fid-&gt;st.st_mode &amp; m));

	npath = estrpath(fid-&gt;path, elem, 1);
	if(perm &amp; DMDIR){
		if((omode&amp;~ORCLOSE) != OREAD){
			*ep = Eperm;
			free(npath);
			return -1;
		}
		if(stat(npath, &amp;st) &gt;= 0 || errno != ENOENT){
			*ep = Eexist;
			free(npath);
			return -1;
		}
		/* race */
		if(mkdir(npath, (perm|0400)&amp;0777) &lt; 0){
			*ep = strerror(errno);
			free(npath);
			return -1;
		}
		if((fid-&gt;dir = opendir(npath)) == nil){
			*ep = strerror(errno);
			remove(npath);		/* race */
			free(npath);
			return -1;
		}
	}else{
		o = O_CREAT|O_EXCL;
		switch(omode&amp;3){
		default:
			*ep = "programmer error";
			return -1;
		case OREAD:
		case OEXEC:
			o |= O_RDONLY;
			break;
		case ORDWR:
			o |= O_RDWR;
			break;
		case OWRITE:
			o |= O_WRONLY;
			break;
		}
		if(omode &amp; OTRUNC)
			o |= O_TRUNC;
		if((fid-&gt;fd = open(npath, o, perm&amp;0777)) &lt; 0){
			if(chatty9p)
				fprint(2, "create(%s, 0x%x, 0%o) failed\n", npath, o, perm&amp;0777);
			*ep = strerror(errno);
			free(npath);
			return -1;
		}
	}

	opath = fid-&gt;path;
	fid-&gt;path = npath;
	if(fidstat(fid, ep) &lt; 0){
		fprint(2, "stat after create on %s failed\n", npath);
		remove(npath);	/* race */
		free(npath);
		fid-&gt;path = opath;
		if(fid-&gt;fd &gt;= 0){
			close(fid-&gt;fd);
			fid-&gt;fd = -1;
		}else{
			closedir(fid-&gt;dir);
			fid-&gt;dir = nil;
		}
		return -1;
	}
	fid-&gt;omode = omode;
	free(opath);
	return 0;
}

int
userremove(Fid *fid, char **ep)
{
	if(remove(fid-&gt;path) &lt; 0){
		*ep = strerror(errno);
		return -1;
	}
	return 0;
}

void
usage(void)
{
	fprint(2, "usage: u9fs [-Dnz] [-a authmethod] [-m msize] [-u user] [root]\n");
	exit(1);
}

int
main(int argc, char **argv)
{
	char *authtype;
	int i;
	int fd;
	int logflag;

	auth = authmethods[0];
	logflag = O_WRONLY|O_APPEND|O_CREAT;
	ARGBEGIN{
	case 'D':
		chatty9p = 1;
		break;
	case 'a':
		authtype = EARGF(usage());
		auth = nil;
		for(i=0; i&lt;nelem(authmethods); i++)
			if(strcmp(authmethods[i]-&gt;name, authtype)==0)
				auth = authmethods[i];
		if(auth == nil)
			sysfatal("unknown auth type '%s'", authtype);
		break;
	case 'A':
		autharg = EARGF(usage());
		break;
	case 'l':
		logfile = EARGF(usage());
		break;
	case 'm':
		msize = strtol(EARGF(usage()), 0, 0);
		break;
	case 'n':
		network = 0;
		break;
	case 'u':
		defaultuser = EARGF(usage());
		break;
	case 'z':
		logflag |= O_TRUNC;
	}ARGEND

	if(argc &gt; 1)
		usage();

	fd = open(logfile, logflag, 0666);
	if(fd &lt; 0)
		sysfatal("cannot open log '%s'", logfile);

	if(dup2(fd, 2) &lt; 0)
		sysfatal("cannot dup fd onto stderr");
	fprint(2, "u9fs\nkill %d\n", (int)getpid());

	fmtinstall('F', fcallconv);
	fmtinstall('D', dirconv);
	fmtinstall('M', dirmodeconv);

	rxbuf = emalloc(msize);
	txbuf = emalloc(msize);
	databuf = emalloc(msize);

	if(auth-&gt;init)
		auth-&gt;init();

	if(network)
		getremotehostname(remotehostname, sizeof remotehostname);

	if(gethostname(hostname, sizeof hostname) &lt; 0)
		strcpy(hostname, "gnot");

	umask(0);

	if(argc == 1)
		if(chroot(argv[0]) &lt; 0)
			sysfatal("chroot '%s' failed", argv[0]);

	none = uname2user("none");
	if(none == nil)
		none = uname2user("nobody");

	serve(0, 1);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

