<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/bayes/bayes.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/bayes/bayes.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;regexp.h&gt;
#include "hash.h"

enum
{
	MAXTAB = 256,
	MAXBEST = 32,
};

typedef struct Table Table;
struct Table
{
	char *file;
	Hash *hash;
	int nmsg;
};

typedef struct Word Word;
struct Word
{
	Stringtab *s;	/* from hmsg */
	int count[MAXTAB];	/* counts from each table */
	double p[MAXTAB];	/* probabilities from each table */
	double mp;	/* max probability */
	int mi;		/* w.p[w.mi] = w.mp */
};

Table tab[MAXTAB];
int ntab;

Word best[MAXBEST];
int mbest;
int nbest;

int debug;

void
usage(void)
{
	fprint(2, "usage: bayes [-D] [-m maxword] boxhash ... ~ msghash ...\n");
	exits("usage");
}

void*
emalloc(int n)
{
	void *v;

	v = mallocz(n, 1);
	if(v == nil)
		sysfatal("out of memory");
	return v;
}

void
noteword(Word *w)
{
	int i;

	for(i=nbest-1; i&gt;=0; i--)
		if(w-&gt;mp &lt; best[i].mp)
			break;
	i++;

	if(i &gt;= mbest)
		return;
	if(nbest == mbest)
		nbest--;
	if(i &lt; nbest)
		memmove(&amp;best[i+1], &amp;best[i], (nbest-i)*sizeof(best[0]));
	best[i] = *w;
	nbest++;
}

Hash*
hread(char *s)
{
	Hash *h;
	Biobuf *b;

	if((b = Bopenlock(s, OREAD)) == nil)
		sysfatal("open %s: %r", s);

	h = emalloc(sizeof(Hash));
	Breadhash(b, h, 1);
	Bterm(b);
	return h;
}

void
main(int argc, char **argv)
{
	int i, j, a, mi, oi, tot, keywords;
	double totp, p, xp[MAXTAB];
	Hash *hmsg;
	Word w;
	Stringtab *s, *t;
	Biobuf bout;

	mbest = 15;
	keywords = 0;
	ARGBEGIN{
	case 'D':
		debug = 1;
		break;
	case 'k':
		keywords = 1;
		break;
	case 'm':
		mbest = atoi(EARGF(usage()));
		if(mbest &gt; MAXBEST)
			sysfatal("cannot keep more than %d words", MAXBEST);
		break;
	default:
		usage();
	}ARGEND

	for(i=0; i&lt;argc; i++)
		if(strcmp(argv[i], "~") == 0)
			break;

	if(i &gt; MAXTAB)
		sysfatal("cannot handle more than %d tables", MAXTAB);

	if(i+1 &gt;= argc)
		usage();

	for(i=0; i&lt;argc; i++){
		if(strcmp(argv[i], "~") == 0)
			break;
		tab[ntab].file = argv[i];
		tab[ntab].hash = hread(argv[i]);
		s = findstab(tab[ntab].hash, "*nmsg*", 6, 1);
		if(s == nil || s-&gt;count == 0)
			tab[ntab].nmsg = 1;
		else
			tab[ntab].nmsg = s-&gt;count;
		ntab++;
	}

	Binit(&amp;bout, 1, OWRITE);

	oi = ++i;
	for(a=i; a&lt;argc; a++){
		hmsg = hread(argv[a]);
		nbest = 0;
		for(s=hmsg-&gt;all; s; s=s-&gt;link){
			w.s = s;
			tot = 0;
			totp = 0.0;
			for(i=0; i&lt;ntab; i++){
				t = findstab(tab[i].hash, s-&gt;str, s-&gt;n, 0);
				if(t == nil)
					w.count[i] = 0;
				else
					w.count[i] = t-&gt;count;
				tot += w.count[i];
				p = w.count[i]/(double)tab[i].nmsg;
				if(p &gt;= 1.0)
					p = 1.0;
				w.p[i] = p;
				totp += p;
			}

			if(tot &lt; 5){		/* word does not appear enough; give to box 0 */
				w.p[0] = 0.5;
				for(i=1; i&lt;ntab; i++)
					w.p[i] = 0.1;
				w.mp = 0.5;
				w.mi = 0;
				noteword(&amp;w);
				continue;
			}

			w.mp = 0.0;
			for(i=0; i&lt;ntab; i++){
				p = w.p[i];
				p /= totp;
				if(p &lt; 0.01)
					p = 0.01;
				else if(p &gt; 0.99)
					p = 0.99;
				if(p &gt; w.mp){
					w.mp = p;
					w.mi = i;
				}
				w.p[i] = p;
			}
			noteword(&amp;w);
		}

		totp = 0.0;
		for(i=0; i&lt;ntab; i++){
			p = 1.0;
			for(j=0; j&lt;nbest; j++)
				p *= best[j].p[i];
			xp[i] = p;
			totp += p;
		}
		for(i=0; i&lt;ntab; i++)
			xp[i] /= totp;
		mi = 0;
		for(i=1; i&lt;ntab; i++)
			if(xp[i] &gt; xp[mi])
				mi = i;
		if(oi != argc-1)
			Bprint(&amp;bout, "%s: ", argv[a]);
		Bprint(&amp;bout, "%s %f", tab[mi].file, xp[mi]);
		if(keywords){
			for(i=0; i&lt;nbest; i++){
				Bprint(&amp;bout, " ");
				Bwrite(&amp;bout, best[i].s-&gt;str, best[i].s-&gt;n);
				Bprint(&amp;bout, " %f", best[i].p[mi]);
			}
		}
		freehash(hmsg);
		Bprint(&amp;bout, "\n");
		if(debug){
			for(i=0; i&lt;nbest; i++){
				Bwrite(&amp;bout, best[i].s-&gt;str, best[i].s-&gt;n);
				Bprint(&amp;bout, " %f", best[i].p[mi]);
				if(best[i].p[mi] &lt; best[i].mp)
					Bprint(&amp;bout, " (%f %s)", best[i].mp, tab[best[i].mi].file);
				Bprint(&amp;bout, "\n");
			}
		}
	}
	Bterm(&amp;bout);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

