<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/bayes/hash.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/bayes/hash.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "hash.h"

/***
 * String hash tables.
 */

Stringtab *tfree;

Stringtab*
taballoc(void)
{
	static Stringtab *t;
	static uint nt;

	if(tfree){
		Stringtab *tt = tfree;
		tfree = tt-&gt;link;
		return tt;
	}

	if(nt == 0){
		t = malloc(64000*sizeof(Stringtab));
		if(t == 0)
			sysfatal("out of memory");
		nt = 64000;
	}
	nt--;
	return t++;
}

void
tabfree(Stringtab *tt)
{
	tt-&gt;link = tfree;
	tfree = tt;
}

char*
xstrdup(char *s, int len)
{
	char *r;
	static char *t;
	static int nt;

	if(nt &lt; len){
		t = malloc(512*1024+len);
		if(t == 0)
			sysfatal("out of memory");
		nt = 512*1024;
	}
	r = t;
	t += len;
	nt -= len;
	memmove(r, s, len);
	return r;
}

static uint
hash(char *s, int n)
{
	uint h;
	uchar *p, *ep;
	h = 0;
	for(p=(uchar*)s, ep=p+n; p&lt;ep; p++)
		h = h*37 + *p;
	return h;
}

static void
rehash(Hash *hh)
{
	int h;
	Stringtab *s;

	if(hh-&gt;nstab == 0)
		hh-&gt;nstab = 1024;
	else
		hh-&gt;nstab = hh-&gt;ntab*2;

	free(hh-&gt;stab);
	hh-&gt;stab = mallocz(hh-&gt;nstab*sizeof(Stringtab*), 1);
	if(hh-&gt;stab == nil)
		sysfatal("out of memory");

	for(s=hh-&gt;all; s; s=s-&gt;link){
		h = hash(s-&gt;str, s-&gt;n) % hh-&gt;nstab;
		s-&gt;hash = hh-&gt;stab[h];
		hh-&gt;stab[h] = s;
	}
}

Stringtab*
findstab(Hash *hh, char *str, int n, int create)
{
	uint h;
	Stringtab *tab, **l;

	if(hh-&gt;nstab == 0)
		rehash(hh);

	h = hash(str, n) % hh-&gt;nstab;
	for(tab=hh-&gt;stab[h], l=&amp;hh-&gt;stab[h]; tab; l=&amp;tab-&gt;hash, tab=tab-&gt;hash)
		if(n==tab-&gt;n &amp;&amp; memcmp(str, tab-&gt;str, n) == 0){
			*l = tab-&gt;hash;
			tab-&gt;hash = hh-&gt;stab[h];
			hh-&gt;stab[h] = tab;
			return tab;
		}

	if(!create)
		return nil;

	hh-&gt;sorted = 0;
	tab = taballoc();
	tab-&gt;str = xstrdup(str, n);
	tab-&gt;hash = hh-&gt;stab[h];
	tab-&gt;link = hh-&gt;all;
	hh-&gt;all = tab;
	tab-&gt;n = n;
	tab-&gt;count = 0;
	tab-&gt;date = 0;
	hh-&gt;stab[h] = tab;

	hh-&gt;ntab++;
	if(hh-&gt;ntab &gt; 2*hh-&gt;nstab &amp;&amp; !(hh-&gt;ntab&amp;(hh-&gt;ntab-1)))
		rehash(hh);
	return tab;
}

int
scmp(Stringtab *a, Stringtab *b)
{
	int n, x;

	if(a == 0)
		return 1;
	if(b == 0)
		return -1;
	n = a-&gt;n;
	if(n &gt; b-&gt;n)
		n = b-&gt;n;
	x = memcmp(a-&gt;str, b-&gt;str, n);
	if(x != 0)
		return x;
	if(a-&gt;n &lt; b-&gt;n)
		return -1;
	if(a-&gt;n &gt; b-&gt;n)
		return 1;
	return 0;	/* shouldn't happen */
}

Stringtab*
merge(Stringtab *a, Stringtab *b)
{
	Stringtab *s, **l;

	l = &amp;s;
	while(a || b){
		if(scmp(a, b) &lt; 0){
			*l = a;
			l = &amp;a-&gt;link;
			a = a-&gt;link;
		}else{
			*l = b;
			l = &amp;b-&gt;link;
			b = b-&gt;link;
		}
	}
	*l = 0;
	return s;
}

Stringtab*
mergesort(Stringtab *s)
{
	Stringtab *a, *b;
	int delay;

	if(s == nil)
		return nil;
	if(s-&gt;link == nil)
		return s;

	a = b = s;
	delay = 1;
	while(a &amp;&amp; b){
		if(delay)	/* easy way to handle 2-element list */
			delay = 0;
		else
			a = a-&gt;link;
		if(b = b-&gt;link)
			b = b-&gt;link;
	}

	b = a-&gt;link;
	a-&gt;link = nil;

	a = mergesort(s);
	b = mergesort(b);

	return merge(a, b);
}

Stringtab*
sortstab(Hash *hh)
{
	if(!hh-&gt;sorted){
		hh-&gt;all = mergesort(hh-&gt;all);
		hh-&gt;sorted = 1;
	}
	return hh-&gt;all;
}

int
Bwritehash(Biobuf *b, Hash *hh)
{
	Stringtab *s;
	int now;

	now = time(0);
	s = sortstab(hh);
	Bprint(b, "# hash table\n");
	for(; s; s=s-&gt;link){
		if(s-&gt;count &lt;= 0)
			continue;
		/*
		 * Entries that haven't been updated in thirty days get tossed.
		 */
		if(s-&gt;date+30*86400 &lt; now)
			continue;
		Bwrite(b, s-&gt;str, s-&gt;n);
		Bprint(b, "\t%d %d\n", s-&gt;count, s-&gt;date);
	}
	if(Bflush(b) == Beof)
		return -1;
	return 0;
}

void
Breadhash(Biobuf *b, Hash *hh, int scale)
{
	char *s;
	char *t;
	int n;
	int date;
	Stringtab *st;

	s = Brdstr(b, '\n', 1);
	if(s == nil)
		return;
	if(strcmp(s, "# hash table") != 0)
		sysfatal("bad hash table format");

	while(s = Brdline(b, '\n')){
		s[Blinelen(b)-1] = 0;
		t = strrchr(s, '\t');
		if(t == nil)
			sysfatal("bad hash table format");
		*t++ = '\0';
		if(*t &lt; '0' || *t &gt; '9')
			sysfatal("bad hash table format");
		n = strtol(t, &amp;t, 10);
		date = time(0);
		if(*t != 0){
			if(*t == ' '){
				t++;
				date = strtol(t, &amp;t, 10);
			}
			if(*t != 0)
				sysfatal("bad hash table format");
		}
		st = findstab(hh, s, strlen(s), 1);
		if(date &gt; st-&gt;date)
			st-&gt;date = date;
		st-&gt;count += n*scale;
	}
}

void
freehash(Hash *h)
{
	Stringtab *s, *next;

	for(s=h-&gt;all; s; s=next){
		next = s-&gt;link;
		tabfree(s);
	}
	free(h-&gt;stab);
	free(h);
}

Biobuf*
Bopenlock(char *file, int mode)
{
	int i;
	Biobuf *b;
	char err[ERRMAX];

	b = nil;
	for(i=0; i&lt;120; i++){
		if((b = Bopen(file, mode)) != nil)
			break;
		rerrstr(err, sizeof err);
		if(strstr(err, "file is locked")==nil &amp;&amp; strstr(err, "exclusive lock")==nil)
			break;
		sleep(1000);
	}
	return b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

