<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/common/appendfiletombox.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/common/appendfiletombox.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"

enum {
	Buffersize = 64*1024,
};

typedef struct Inbuf Inbuf;
struct Inbuf
{
	char buf[Buffersize];
	char *wp;
	char *rp;
	int eof;
	int in;
	int out;
	int last;
	ulong bytes;
};

static Inbuf*
allocinbuf(int in, int out)
{
	Inbuf *b;

	b = mallocz(sizeof(Inbuf), 1);
	if(b == nil)
		sysfatal("reading mailbox: %r");
	b-&gt;rp = b-&gt;wp = b-&gt;buf;
	b-&gt;in = in;
	b-&gt;out = out;
	return b;
}

/* should only be called at start of file or when b-&gt;rp[-1] == '\n' */
static int
fill(Inbuf *b, int addspace)
{
	int i, n;

	if(b-&gt;eof &amp;&amp; b-&gt;wp - b-&gt;rp == 0)
		return 0;

	n = b-&gt;rp - b-&gt;buf;
	if(n &gt; 0){
		i = write(b-&gt;out, b-&gt;buf, n);
		if(i != n)
			return -1;
		b-&gt;last = b-&gt;buf[n-1];
		b-&gt;bytes += n;
	}
	if(addspace){
		if(write(b-&gt;out, " ", 1) != 1)
			return -1;
		b-&gt;last = ' ';
		b-&gt;bytes++;
	}

	n = b-&gt;wp - b-&gt;rp;
	memmove(b-&gt;buf, b-&gt;rp, n);
	b-&gt;rp = b-&gt;buf;
	b-&gt;wp = b-&gt;rp + n;

	i = read(b-&gt;in, b-&gt;buf+n, sizeof(b-&gt;buf)-n);
	if(i &lt; 0)
		return -1;
	b-&gt;wp += i;

	return b-&gt;wp - b-&gt;rp;
}

enum { Fromlen = sizeof "From " - 1, };

/* code to escape ' '*From' ' at the beginning of a line */
int
appendfiletombox(int in, int out)
{
	int addspace, n, sol;
	char *p;
	Inbuf *b;

	seek(out, 0, 2);

	b = allocinbuf(in, out);
	addspace = 0;
	sol = 1;

	for(;;){
		if(b-&gt;wp - b-&gt;rp &lt; Fromlen){
			/*
			 * not enough unread bytes in buffer to match "From ",
			 * so get some more.  We must only inject a space at
			 * the start of a line (one that begins with "From ").
			 */
			if (b-&gt;rp == b-&gt;buf || b-&gt;rp[-1] == '\n') {
				n = fill(b, addspace);
				addspace = 0;
			} else
				n = fill(b, 0);
			if(n &lt; 0)
				goto error;
			if(n == 0)
				break;
			if(n &lt; Fromlen){	/* still can't match? */
				b-&gt;rp = b-&gt;wp;
				continue;
			}
		}

		/* state machine looking for ' '*From' ' */
		if(!sol){
			p = memchr(b-&gt;rp, '\n', b-&gt;wp - b-&gt;rp);
			if(p == nil)
				b-&gt;rp = b-&gt;wp;
			else{
				b-&gt;rp = p+1;
				sol = 1;
			}
			continue;
		} else {
			if(*b-&gt;rp == ' ' || strncmp(b-&gt;rp, "From ", Fromlen) != 0){
				b-&gt;rp++;
				continue;
			}
			addspace = 1;
			sol = 0;
		}
	}

	/* mailbox entries always terminate with two newlines */
	n = b-&gt;last == '\n' ? 1 : 2;
	if(write(out, "\n\n", n) != n)
		goto error;
	n += b-&gt;bytes;
	free(b);
	return n;
error:
	free(b);
	return -1;
}

int
appendfiletofile(int in, int out)
{
	int n;
	Inbuf *b;

	seek(out, 0, 2);

	b = allocinbuf(in, out);
	for(;;){
		n = fill(b, 0);
		if(n &lt; 0)
			goto error;
		if(n == 0)
			break;
		b-&gt;rp = b-&gt;wp;
	}
	n = b-&gt;bytes;
	free(b);
	return n;
error:
	free(b);
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

