<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/imap4.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/imap4.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include &lt;libsec.h&gt;
#include &lt;auth.h&gt;
#include "dat.h"

#pragma varargck argpos imap4cmd 2
#pragma varargck	type	"Z"	char*

int	doublequote(Fmt*);
int	pipeline = 1;

static char Eio[] = "i/o error";

typedef struct Imap Imap;
struct Imap {
	char *freep;	// free this to free the strings below

	char *host;
	char *user;
	char *mbox;

	int mustssl;
	int refreshtime;
	int debug;

	ulong tag;
	ulong validity;
	int nmsg;
	int size;
	char *base;
	char *data;

	vlong *uid;
	int nuid;
	int muid;

	Thumbprint *thumb;

	// open network connection
	Biobuf bin;
	Biobuf bout;
	int fd;
};

static char*
removecr(char *s)
{
	char *r, *w;

	for(r=w=s; *r; r++)
		if(*r != '\r')
			*w++ = *r;
	*w = '\0';
	return s;
}

//
// send imap4 command
//
static void
imap4cmd(Imap *imap, char *fmt, ...)
{
	char buf[128], *p;
	va_list va;

	va_start(va, fmt);
	p = buf+sprint(buf, "9X%lud ", imap-&gt;tag);
	vseprint(p, buf+sizeof(buf), fmt, va);
	va_end(va);

	p = buf+strlen(buf);
	if(p &gt; (buf+sizeof(buf)-3))
		sysfatal("imap4 command too long");

	if(imap-&gt;debug)
		fprint(2, "-&gt; %s\n", buf);
	strcpy(p, "\r\n");
	Bwrite(&amp;imap-&gt;bout, buf, strlen(buf));
	Bflush(&amp;imap-&gt;bout);
}

enum {
	OK,
	NO,
	BAD,
	BYE,
	EXISTS,
	STATUS,
	FETCH,
	UNKNOWN,
};

static char *verblist[] = {
[OK]		"OK",
[NO]		"NO",
[BAD]	"BAD",
[BYE]	"BYE",
[EXISTS]	"EXISTS",
[STATUS]	"STATUS",
[FETCH]	"FETCH",
};

static int
verbcode(char *verb)
{
	int i;
	char *q;

	if(q = strchr(verb, ' '))
		*q = '\0';

	for(i=0; i&lt;nelem(verblist); i++)
		if(verblist[i] &amp;&amp; strcmp(verblist[i], verb)==0){
			if(q)
				*q = ' ';
			return i;
		}
	if(q)
		*q = ' ';
	return UNKNOWN;
}

static void
strupr(char *s)
{
	for(; *s; s++)
		if('a' &lt;= *s &amp;&amp; *s &lt;= 'z')
			*s += 'A'-'a';
}

static void
imapgrow(Imap *imap, int n)
{
	int i;

	if(imap-&gt;data == nil){
		imap-&gt;base = emalloc(n+1);	
		imap-&gt;data = imap-&gt;base;
		imap-&gt;size = n+1;
	}
	if(n &gt;= imap-&gt;size){
		// friggin microsoft - reallocate
		i = imap-&gt;data - imap-&gt;base;
		imap-&gt;base = erealloc(imap-&gt;base, i+n+1);
		imap-&gt;data = imap-&gt;base + i;
		imap-&gt;size = n+1;
	}
}


//
// get imap4 response line.  there might be various 
// data or other informational lines mixed in.
//
static char*
imap4resp(Imap *imap)
{
	char *line, *p, *ep, *op, *q, *r, *en, *verb;
	int i, n;
	static char error[256];

	while(p = Brdline(&amp;imap-&gt;bin, '\n')){
		ep = p+Blinelen(&amp;imap-&gt;bin);
		while(ep &gt; p &amp;&amp; (ep[-1]=='\n' || ep[-1]=='\r'))
			*--ep = '\0';
		
		if(imap-&gt;debug)
			fprint(2, "&lt;- %s\n", p);
		strupr(p);

		switch(p[0]){
		case '+':
			if(imap-&gt;tag == 0)
				fprint(2, "unexpected: %s\n", p);
			break;

		// ``unsolicited'' information; everything happens here.
		case '*':
			if(p[1]!=' ')
				continue;
			p += 2;
			line = p;
			n = strtol(p, &amp;p, 10);
			if(*p==' ')
				p++;
			verb = p;
			
			if(p = strchr(verb, ' '))
				p++;
			else
				p = verb+strlen(verb);

			switch(verbcode(verb)){
			case OK:
			case NO:
			case BAD:
				// human readable text at p;
				break;
			case BYE:
				// early disconnect
				// human readable text at p;
				break;

			// * 32 EXISTS
			case EXISTS:
				imap-&gt;nmsg = n;
				break;

			// * STATUS Inbox (MESSAGES 2 UIDVALIDITY 960164964)
			case STATUS:
				if(q = strstr(p, "MESSAGES"))
					imap-&gt;nmsg = atoi(q+8);
				if(q = strstr(p, "UIDVALIDITY"))
					imap-&gt;validity = strtoul(q+11, 0, 10);
				break;

			case FETCH:
				// * 1 FETCH (uid 8889 RFC822.SIZE 3031 body[] {3031}
				// &lt;3031 bytes of data&gt;
 				// )
				if(strstr(p, "RFC822.SIZE") &amp;&amp; strstr(p, "BODY[]")){
					if((q = strchr(p, '{')) 
					&amp;&amp; (n=strtol(q+1, &amp;en, 0), *en=='}')){
						if(imap-&gt;data == nil || n &gt;= imap-&gt;size)
							imapgrow(imap, n);
						if((i = Bread(&amp;imap-&gt;bin, imap-&gt;data, n)) != n){
							snprint(error, sizeof error,
								"short read %d != %d: %r\n",
								i, n);
							return error;
						}
						if(imap-&gt;debug)
							fprint(2, "&lt;- read %d bytes\n", n);
						imap-&gt;data[n] = '\0';
						if(imap-&gt;debug)
							fprint(2, "&lt;- %s\n", imap-&gt;data);
						imap-&gt;data += n;
						imap-&gt;size -= n;
						p = Brdline(&amp;imap-&gt;bin, '\n');
						if(imap-&gt;debug)
							fprint(2, "&lt;- ignoring %.*s\n",
								Blinelen(&amp;imap-&gt;bin), p);
					}else if((q = strchr(p, '"')) &amp;&amp; (r = strchr(q+1, '"'))){
						*r = '\0';
						q++;
						n = r-q;
						if(imap-&gt;data == nil || n &gt;= imap-&gt;size)
							imapgrow(imap, n);
						memmove(imap-&gt;data, q, n);
						imap-&gt;data[n] = '\0';
						imap-&gt;data += n;
						imap-&gt;size -= n;
					}else
						return "confused about FETCH response";
					break;
				}

				// * 1 FETCH (UID 1 RFC822.SIZE 511)
				if(q=strstr(p, "RFC822.SIZE")){
					imap-&gt;size = atoi(q+11);
					break;
				}

				// * 1 FETCH (UID 1 RFC822.HEADER {496}
				// &lt;496 bytes of data&gt;
 				// )
				// * 1 FETCH (UID 1 RFC822.HEADER "data")
				if(strstr(p, "RFC822.HEADER") || strstr(p, "RFC822.TEXT")){
					if((q = strchr(p, '{')) 
					&amp;&amp; (n=strtol(q+1, &amp;en, 0), *en=='}')){
						if(imap-&gt;data == nil || n &gt;= imap-&gt;size)
							imapgrow(imap, n);
						if((i = Bread(&amp;imap-&gt;bin, imap-&gt;data, n)) != n){
							snprint(error, sizeof error,
								"short read %d != %d: %r\n",
								i, n);
							return error;
						}
						if(imap-&gt;debug)
							fprint(2, "&lt;- read %d bytes\n", n);
						imap-&gt;data[n] = '\0';
						if(imap-&gt;debug)
							fprint(2, "&lt;- %s\n", imap-&gt;data);
						imap-&gt;data += n;
						imap-&gt;size -= n;
						p = Brdline(&amp;imap-&gt;bin, '\n');
						if(imap-&gt;debug)
							fprint(2, "&lt;- ignoring %.*s\n",
								Blinelen(&amp;imap-&gt;bin), p);
					}else if((q = strchr(p, '"')) &amp;&amp; (r = strchr(q+1, '"'))){
						*r = '\0';
						q++;
						n = r-q;
						if(imap-&gt;data == nil || n &gt;= imap-&gt;size)
							imapgrow(imap, n);
						memmove(imap-&gt;data, q, n);
						imap-&gt;data[n] = '\0';
						imap-&gt;data += n;
						imap-&gt;size -= n;
					}else
						return "confused about FETCH response";
					break;
				}

				// * 1 FETCH (UID 1)
				// * 2 FETCH (UID 6)
				if(q = strstr(p, "UID")){
					if(imap-&gt;nuid &lt; imap-&gt;muid)
						imap-&gt;uid[imap-&gt;nuid++] = ((vlong)imap-&gt;validity&lt;&lt;32)|strtoul(q+3, nil, 10);
					break;
				}
			}

			if(imap-&gt;tag == 0)
				return line;
			break;

		case '9':		// response to our message
			op = p;
			if(p[1]=='X' &amp;&amp; strtoul(p+2, &amp;p, 10)==imap-&gt;tag){
				while(*p==' ')
					p++;
				imap-&gt;tag++;
				return p;
			}
			fprint(2, "expected %lud; got %s\n", imap-&gt;tag, op);
			break;

		default:
			if(imap-&gt;debug || *p)
				fprint(2, "unexpected line: %s\n", p);
		}
	}
	snprint(error, sizeof error, "i/o error: %r\n");
	return error;
}

static int
isokay(char *resp)
{
	return strncmp(resp, "OK", 2)==0;
}

//
// log in to IMAP4 server, select mailbox, no SSL at the moment
//
static char*
imap4login(Imap *imap)
{
	char *s;
	UserPasswd *up;

	imap-&gt;tag = 0;
	s = imap4resp(imap);
	if(!isokay(s))
		return "error in initial IMAP handshake";

	if(imap-&gt;user != nil)
		up = auth_getuserpasswd(auth_getkey, "proto=pass service=imap server=%q user=%q", imap-&gt;host, imap-&gt;user);
	else
		up = auth_getuserpasswd(auth_getkey, "proto=pass service=imap server=%q", imap-&gt;host);
	if(up == nil)
		return "cannot find IMAP password";

	imap-&gt;tag = 1;
	imap4cmd(imap, "LOGIN %Z %Z", up-&gt;user, up-&gt;passwd);
	free(up);
	if(!isokay(s = imap4resp(imap)))
		return s;

	imap4cmd(imap, "SELECT %Z", imap-&gt;mbox);
	if(!isokay(s = imap4resp(imap)))
		return s;

	return nil;
}

static char*
imaperrstr(char *host, char *port)
{
	/*
	 * make mess big enough to hold a TLS certificate fingerprint
	 * plus quite a bit of slop.
	 */
	static char mess[3 * Errlen];
	char err[Errlen];

	err[0] = '\0';
	errstr(err, sizeof(err));
	snprint(mess, sizeof(mess), "%s/%s:%s", host, port, err);
	return mess;
}

static int
starttls(Imap *imap, TLSconn *connp)
{
	int sfd;
	uchar digest[SHA1dlen];

	fmtinstall('H', encodefmt);
	memset(connp, 0, sizeof *connp);
	sfd = tlsClient(imap-&gt;fd, connp);
	if(sfd &lt; 0) {
		werrstr("tlsClient: %r");
		return -1;
	}
	if(connp-&gt;cert==nil || connp-&gt;certlen &lt;= 0) {
		close(sfd);
		werrstr("server did not provide TLS certificate");
		return -1;
	}
	sha1(connp-&gt;cert, connp-&gt;certlen, digest, nil);
	/*
	 * don't do this any more.  our local it people are rotating their
	 * certificates faster than we can keep up.
	 */
	if(0 &amp;&amp; (!imap-&gt;thumb || !okThumbprint(digest, imap-&gt;thumb))){
		close(sfd);
		werrstr("server certificate %.*H not recognized",
			SHA1dlen, digest);
		return -1;
	}
	close(imap-&gt;fd);
	imap-&gt;fd = sfd;
	return sfd;
}

//
// dial and handshake with the imap server
//
static char*
imap4dial(Imap *imap)
{
	char *err, *port;
	int sfd;
	TLSconn conn;

	if(imap-&gt;fd &gt;= 0){
		imap4cmd(imap, "noop");
		if(isokay(imap4resp(imap)))
			return nil;
		close(imap-&gt;fd);
		imap-&gt;fd = -1;
	}

	if(imap-&gt;mustssl)
		port = "imaps";
	else
		port = "imap";

	if((imap-&gt;fd = dial(netmkaddr(imap-&gt;host, "net", port), 0, 0, 0)) &lt; 0)
		return imaperrstr(imap-&gt;host, port);

	if(imap-&gt;mustssl){
		sfd = starttls(imap, &amp;conn);
		if (sfd &lt; 0) {
			free(conn.cert);
			return imaperrstr(imap-&gt;host, port);
		}
		if(imap-&gt;debug){
			char fn[128];
			int fd;

			snprint(fn, sizeof fn, "%s/ctl", conn.dir);
			fd = open(fn, ORDWR);
			if(fd &lt; 0)
				fprint(2, "opening ctl: %r\n");
			if(fprint(fd, "debug") &lt; 0)
				fprint(2, "writing ctl: %r\n");
			close(fd);
		}
	}
	Binit(&amp;imap-&gt;bin, imap-&gt;fd, OREAD);
	Binit(&amp;imap-&gt;bout, imap-&gt;fd, OWRITE);

	if(err = imap4login(imap)) {
		close(imap-&gt;fd);
		return err;
	}

	return nil;
}

//
// close connection
//
static void
imap4hangup(Imap *imap)
{
	imap4cmd(imap, "LOGOUT");
	imap4resp(imap);
	close(imap-&gt;fd);
}

//
// download a single message
//
static char*
imap4fetch(Mailbox *mb, Message *m)
{
	int i;
	char *p, *s, sdigest[2*SHA1dlen+1];
	Imap *imap;

	imap = mb-&gt;aux;

	imap-&gt;size = 0;

	if(!isokay(s = imap4resp(imap)))
		return s;

	p = imap-&gt;base;
	if(p == nil)
		return "did not get message body";

	removecr(p);
	free(m-&gt;start);
	m-&gt;start = p;
	m-&gt;end = p+strlen(p);
	m-&gt;bend = m-&gt;rbend = m-&gt;end;
	m-&gt;header = m-&gt;start;

	imap-&gt;base = nil;
	imap-&gt;data = nil;

	parse(m, 0, mb, 1);

	// digest headers
	sha1((uchar*)m-&gt;start, m-&gt;end - m-&gt;start, m-&gt;digest, nil);
	for(i = 0; i &lt; SHA1dlen; i++)
		sprint(sdigest+2*i, "%2.2ux", m-&gt;digest[i]);
	m-&gt;sdigest = s_copy(sdigest);

	return nil;
}

//
// check for new messages on imap4 server
// download new messages, mark deleted messages
//
static char*
imap4read(Imap *imap, Mailbox *mb, int doplumb)
{
	char *s;
	int i, ignore, nnew, t;
	Message *m, *next, **l;

	imap4cmd(imap, "STATUS %Z (MESSAGES UIDVALIDITY)", imap-&gt;mbox);
	if(!isokay(s = imap4resp(imap)))
		return s;

	imap-&gt;nuid = 0;
	imap-&gt;uid = erealloc(imap-&gt;uid, imap-&gt;nmsg*sizeof(imap-&gt;uid[0]));
	imap-&gt;muid = imap-&gt;nmsg;

	if(imap-&gt;nmsg &gt; 0){
		imap4cmd(imap, "UID FETCH 1:* UID");
		if(!isokay(s = imap4resp(imap)))
			return s;
	}

	l = &amp;mb-&gt;root-&gt;part;
	for(i=0; i&lt;imap-&gt;nuid; i++){
		ignore = 0;
		while(*l != nil){
			if((*l)-&gt;imapuid == imap-&gt;uid[i]){
				ignore = 1;
				l = &amp;(*l)-&gt;next;
				break;
			}else{
				// old mail, we don't have it anymore
				if(doplumb)
					mailplumb(mb, *l, 1);
				(*l)-&gt;inmbox = 0;
				(*l)-&gt;deleted = 1;
				l = &amp;(*l)-&gt;next;
			}
		}
		if(ignore)
			continue;

		// new message
		m = newmessage(mb-&gt;root);
		m-&gt;mallocd = 1;
		m-&gt;inmbox = 1;
		m-&gt;imapuid = imap-&gt;uid[i];

		// add to chain, will download soon
		*l = m;
		l = &amp;m-&gt;next;
	}

	// whatever is left at the end of the chain is gone
	while(*l != nil){
		if(doplumb)
			mailplumb(mb, *l, 1);
		(*l)-&gt;inmbox = 0;
		(*l)-&gt;deleted = 1;
		l = &amp;(*l)-&gt;next;
	}

	// download new messages
	t = imap-&gt;tag;
	if(pipeline)
	switch(rfork(RFPROC|RFMEM)){
	case -1:
		sysfatal("rfork: %r");
	default:
		break;
	case 0:
		for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next){
			if(m-&gt;start != nil)
				continue;
			if(imap-&gt;debug)
				fprint(2, "9X%d UID FETCH %lud (UID RFC822.SIZE BODY[])\r\n",
					t, (ulong)m-&gt;imapuid);
			Bprint(&amp;imap-&gt;bout, "9X%d UID FETCH %lud (UID RFC822.SIZE BODY[])\r\n",
				t++, (ulong)m-&gt;imapuid);
		}
		Bflush(&amp;imap-&gt;bout);
		_exits(nil);
	}

	nnew = 0;
	for(m=mb-&gt;root-&gt;part; m!=nil; m=next){
		next = m-&gt;next;
		if(m-&gt;start != nil)
			continue;

		if(!pipeline){
			Bprint(&amp;imap-&gt;bout, "9X%lud UID FETCH %lud (UID RFC822.SIZE BODY[])\r\n",
				(ulong)imap-&gt;tag, (ulong)m-&gt;imapuid);
			Bflush(&amp;imap-&gt;bout);
		}

		if(s = imap4fetch(mb, m)){
			// message disappeared?  unchain
			fprint(2, "download %lud: %s\n", (ulong)m-&gt;imapuid, s);
			delmessage(mb, m);
			mb-&gt;root-&gt;subname--;
			continue;
		}
		nnew++;
		if(doplumb)
			mailplumb(mb, m, 0);
	}
	if(pipeline)
		waitpid();

	if(nnew || mb-&gt;vers == 0){
		mb-&gt;vers++;
		henter(PATH(0, Qtop), mb-&gt;name,
			(Qid){PATH(mb-&gt;id, Qmbox), mb-&gt;vers, QTDIR}, nil, mb);
	}
	return nil;
}

//
// sync mailbox
//
static void
imap4purge(Imap *imap, Mailbox *mb)
{
	int ndel;
	Message *m, *next;

	ndel = 0;
	for(m=mb-&gt;root-&gt;part; m!=nil; m=next){
		next = m-&gt;next;
		if(m-&gt;deleted &amp;&amp; m-&gt;refs==0){
			if(m-&gt;inmbox &amp;&amp; (ulong)(m-&gt;imapuid&gt;&gt;32)==imap-&gt;validity){
				imap4cmd(imap, "UID STORE %lud +FLAGS (\\Deleted)", (ulong)m-&gt;imapuid);
				if(isokay(imap4resp(imap))){
					ndel++;
					delmessage(mb, m);
				}
			}else
				delmessage(mb, m);
		}
	}

	if(ndel){
		imap4cmd(imap, "EXPUNGE");
		imap4resp(imap);
	}
}

//
// connect to imap4 server, sync mailbox
//
static char*
imap4sync(Mailbox *mb, int doplumb)
{
	char *err;
	Imap *imap;

	imap = mb-&gt;aux;

	if(err = imap4dial(imap)){
		mb-&gt;waketime = time(0) + imap-&gt;refreshtime;
		return err;
	}

	if((err = imap4read(imap, mb, doplumb)) == nil){
		imap4purge(imap, mb);
		mb-&gt;d-&gt;atime = mb-&gt;d-&gt;mtime = time(0);
	}
	/*
	 * don't hang up; leave connection open for next time.
	 */
	// imap4hangup(imap);
	mb-&gt;waketime = time(0) + imap-&gt;refreshtime;
	return err;
}

static char Eimap4ctl[] = "bad imap4 control message";

static char*
imap4ctl(Mailbox *mb, int argc, char **argv)
{
	int n;
	Imap *imap;

	imap = mb-&gt;aux;
	if(argc &lt; 1)
		return Eimap4ctl;

	if(argc==1 &amp;&amp; strcmp(argv[0], "debug")==0){
		imap-&gt;debug = 1;
		return nil;
	}

	if(argc==1 &amp;&amp; strcmp(argv[0], "nodebug")==0){
		imap-&gt;debug = 0;
		return nil;
	}

	if(argc==1 &amp;&amp; strcmp(argv[0], "thumbprint")==0){
		if(imap-&gt;thumb)
			freeThumbprints(imap-&gt;thumb);
		imap-&gt;thumb = initThumbprints("/sys/lib/tls/mail", "/sys/lib/tls/mail.exclude");
	}
	if(strcmp(argv[0], "refresh")==0){
		if(argc==1){
			imap-&gt;refreshtime = 60;
			return nil;
		}
		if(argc==2){
			n = atoi(argv[1]);
			if(n &lt; 15)
				return Eimap4ctl;
			imap-&gt;refreshtime = n;
			return nil;
		}
	}

	return Eimap4ctl;
}

//
// free extra memory associated with mb
//
static void
imap4close(Mailbox *mb)
{
	Imap *imap;

	imap = mb-&gt;aux;
	free(imap-&gt;freep);
	free(imap-&gt;base);
	free(imap-&gt;uid);
	if(imap-&gt;fd &gt;= 0)
		close(imap-&gt;fd);
	free(imap);
}

//
// open mailboxes of the form /imap/host/user
//
char*
imap4mbox(Mailbox *mb, char *path)
{
	char *f[10];
	int mustssl, nf;
	Imap *imap;

	quotefmtinstall();
	fmtinstall('Z', doublequote);
	if(strncmp(path, "/imap/", 6) != 0 &amp;&amp; strncmp(path, "/imaps/", 7) != 0)
		return Enotme;
	mustssl = (strncmp(path, "/imaps/", 7) == 0);

	path = strdup(path);
	if(path == nil)
		return "out of memory";

	nf = getfields(path, f, 5, 0, "/");
	if(nf &lt; 3){
		free(path);
		return "bad imap path syntax /imap[s]/system[/user[/mailbox]]";
	}

	imap = emalloc(sizeof(*imap));
	imap-&gt;fd = -1;
	imap-&gt;debug = debug;
	imap-&gt;freep = path;
	imap-&gt;mustssl = mustssl;
	imap-&gt;host = f[2];
	if(nf &lt; 4)
		imap-&gt;user = nil;
	else
		imap-&gt;user = f[3];
	if(nf &lt; 5)
		imap-&gt;mbox = "Inbox";
	else
		imap-&gt;mbox = f[4];
	imap-&gt;thumb = initThumbprints("/sys/lib/tls/mail", "/sys/lib/tls/mail.exclude");

	mb-&gt;aux = imap;
	mb-&gt;sync = imap4sync;
	mb-&gt;close = imap4close;
	mb-&gt;ctl = imap4ctl;
	mb-&gt;d = emalloc(sizeof(*mb-&gt;d));
	//mb-&gt;fetch = imap4fetch;

	return nil;
}

//
// Formatter for %"
// Use double quotes to protect white space, frogs, \ and "
//
enum
{
	Qok = 0,
	Qquote,
	Qbackslash,
};

static int
needtoquote(Rune r)
{
	if(r &gt;= Runeself)
		return Qquote;
	if(r &lt;= ' ')
		return Qquote;
	if(r=='\\' || r=='"')
		return Qbackslash;
	return Qok;
}

int
doublequote(Fmt *f)
{
	char *s, *t;
	int w, quotes;
	Rune r;

	s = va_arg(f-&gt;args, char*);
	if(s == nil || *s == '\0')
		return fmtstrcpy(f, "\"\"");

	quotes = 0;
	for(t=s; *t; t+=w){
		w = chartorune(&amp;r, t);
		quotes |= needtoquote(r);
	}
	if(quotes == 0)
		return fmtstrcpy(f, s);

	fmtrune(f, '"');
	for(t=s; *t; t+=w){
		w = chartorune(&amp;r, t);
		if(needtoquote(r) == Qbackslash)
			fmtrune(f, '\\');
		fmtrune(f, r);
	}
	return fmtrune(f, '"');
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

