<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/mbox.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/mbox.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include &lt;libsec.h&gt;
#include "dat.h"

typedef struct Header Header;

struct Header {
	char *type;
	void (*f)(Message*, Header*, char*);
	int len;
};

/* headers */
static	void	ctype(Message*, Header*, char*);
static	void	cencoding(Message*, Header*, char*);
static	void	cdisposition(Message*, Header*, char*);
static	void	date822(Message*, Header*, char*);
static	void	from822(Message*, Header*, char*);
static	void	to822(Message*, Header*, char*);
static	void	sender822(Message*, Header*, char*);
static	void	replyto822(Message*, Header*, char*);
static	void	subject822(Message*, Header*, char*);
static	void	inreplyto822(Message*, Header*, char*);
static	void	cc822(Message*, Header*, char*);
static	void	bcc822(Message*, Header*, char*);
static	void	messageid822(Message*, Header*, char*);
static	void	mimeversion(Message*, Header*, char*);
static	void	nullsqueeze(Message*);
enum
{
	Mhead=	11,	/* offset of first mime header */
};

Header head[] =
{
	{ "date:", date822, },
	{ "from:", from822, },
	{ "to:", to822, },
	{ "sender:", sender822, },
	{ "reply-to:", replyto822, },
	{ "subject:", subject822, },
	{ "cc:", cc822, },
	{ "bcc:", bcc822, },
	{ "in-reply-to:", inreplyto822, },
	{ "mime-version:", mimeversion, },
	{ "message-id:", messageid822, },

[Mhead]	{ "content-type:", ctype, },
	{ "content-transfer-encoding:", cencoding, },
	{ "content-disposition:", cdisposition, },
	{ 0, },
};

static	void	fatal(char *fmt, ...);
static	void	initquoted(void);
static	void	startheader(Message*);
static	void	startbody(Message*);
static	char*	skipwhite(char*);
static	char*	skiptosemi(char*);
static	char*	getstring(char*, String*, int);
static	void	setfilename(Message*, char*);
static	char*	lowercase(char*);
static	int	is8bit(Message*);
static	int	headerline(char**, String*);
static	void	initheaders(void);
static void	parseattachments(Message*, Mailbox*);

int		debug;

char *Enotme = "path not served by this file server";

enum
{
	Chunksize = 1024,
};

Mailboxinit *boxinit[] = {
	imap4mbox,
	pop3mbox,
	planbmbox,
	planbvmbox,
	plan9mbox,
};

char*
syncmbox(Mailbox *mb, int doplumb)
{
	return (*mb-&gt;sync)(mb, doplumb);
}

/* create a new mailbox */
char*
newmbox(char *path, char *name, int std)
{
	Mailbox *mb, **l;
	char *p, *rv;
	int i;

	initheaders();

	mb = emalloc(sizeof(*mb));
	strncpy(mb-&gt;path, path, sizeof(mb-&gt;path)-1);
	if(name == nil){
		p = strrchr(path, '/');
		if(p == nil)
			p = path;
		else
			p++;
		if(*p == 0){
			free(mb);
			return "bad mbox name";
		}
		strncpy(mb-&gt;name, p, sizeof(mb-&gt;name)-1);
	} else {
		strncpy(mb-&gt;name, name, sizeof(mb-&gt;name)-1);
	}

	rv = nil;
	// check for a mailbox type
	for(i=0; i&lt;nelem(boxinit); i++)
		if((rv = (*boxinit[i])(mb, path)) != Enotme)
			break;
	if(i == nelem(boxinit)){
		free(mb);
		return "bad path";
	}

	// on error, give up
	if(rv){
		free(mb);
		return rv;
	}

	// make sure name isn't taken
	qlock(&amp;mbllock);
	for(l = &amp;mbl; *l != nil; l = &amp;(*l)-&gt;next){
		if(strcmp((*l)-&gt;name, mb-&gt;name) == 0){
			if(strcmp(path, (*l)-&gt;path) == 0)
				rv = nil;
			else
				rv = "mbox name in use";
			if(mb-&gt;close)
				(*mb-&gt;close)(mb);
			free(mb);
			qunlock(&amp;mbllock);
			return rv;
		}
	}

	// always try locking
	mb-&gt;dolock = 1;

	mb-&gt;refs = 1;
	mb-&gt;next = nil;
	mb-&gt;id = newid();
	mb-&gt;root = newmessage(nil);
	mb-&gt;std = std;
	*l = mb;
	qunlock(&amp;mbllock);

	qlock(mb);
	if(mb-&gt;ctl){
		henter(PATH(mb-&gt;id, Qmbox), "ctl",
			(Qid){PATH(mb-&gt;id, Qmboxctl), 0, QTFILE}, nil, mb);
	}
	rv = syncmbox(mb, 0);
	qunlock(mb);

	return rv;
}

// close the named mailbox
void
freembox(char *name)
{
	Mailbox **l, *mb;

	qlock(&amp;mbllock);
	for(l=&amp;mbl; *l != nil; l=&amp;(*l)-&gt;next){
		if(strcmp(name, (*l)-&gt;name) == 0){
			mb = *l;
			*l = mb-&gt;next;
			mboxdecref(mb);
			break;
		}
	}
	hfree(PATH(0, Qtop), name);
	qunlock(&amp;mbllock);
}

static void
initheaders(void)
{
	Header *h;
	static int already;

	if(already)
		return;
	already = 1;

	for(h = head; h-&gt;type != nil; h++)
		h-&gt;len = strlen(h-&gt;type);
}

/*
 *  parse a Unix style header
 */
void
parseunix(Message *m)
{
	char *p;
	String *h;

	h = s_new();
	for(p = m-&gt;start + 5; *p &amp;&amp; *p != '\r' &amp;&amp; *p != '\n'; p++)
		s_putc(h, *p);
	s_terminate(h);
	s_restart(h);

	m-&gt;unixfrom = s_parse(h, s_reset(m-&gt;unixfrom));
	m-&gt;unixdate = s_append(s_reset(m-&gt;unixdate), h-&gt;ptr);

	s_free(h);
}

/*
 *  parse a message
 */
void
parseheaders(Message *m, int justmime, Mailbox *mb, int addfrom)
{
	String *hl;
	Header *h;
	char *p, *q;
	int i;

	if(m-&gt;whole == m-&gt;whole-&gt;whole){
		henter(PATH(mb-&gt;id, Qmbox), m-&gt;name,
			(Qid){PATH(m-&gt;id, Qdir), 0, QTDIR}, m, mb);
	} else {
		henter(PATH(m-&gt;whole-&gt;id, Qdir), m-&gt;name,
			(Qid){PATH(m-&gt;id, Qdir), 0, QTDIR}, m, mb);
	}
	for(i = 0; i &lt; Qmax; i++)
		henter(PATH(m-&gt;id, Qdir), dirtab[i],
			(Qid){PATH(m-&gt;id, i), 0, QTFILE}, m, mb);

	// parse mime headers
	p = m-&gt;header;
	hl = s_new();
	while(headerline(&amp;p, hl)){
		if(justmime)
			h = &amp;head[Mhead];
		else
			h = head;
		for(; h-&gt;type; h++){
			if(cistrncmp(s_to_c(hl), h-&gt;type, h-&gt;len) == 0){
				(*h-&gt;f)(m, h, s_to_c(hl));
				break;
			}
		}
		s_reset(hl);
	}
	s_free(hl);

	// the blank line isn't really part of the body or header
	if(justmime){
		m-&gt;mhend = p;
		m-&gt;hend = m-&gt;header;
	} else {
		m-&gt;hend = p;
	}
	if(*p == '\n')
		p++;
	m-&gt;rbody = m-&gt;body = p;

	// if type is text, get any nulls out of the body.  This is
	// for the two seans and imap clients that get confused.
	if(strncmp(s_to_c(m-&gt;type), "text/", 5) == 0)
		nullsqueeze(m);

	//
	// cobble together Unix-style from line
	// for local mailbox messages, we end up recreating the
	// original header.
	// for pop3 messages, the best we can do is 
	// use the From: information and the RFC822 date.
	//
	if(m-&gt;unixdate == nil || strcmp(s_to_c(m-&gt;unixdate), "???") == 0
	|| strcmp(s_to_c(m-&gt;unixdate), "Thu Jan 1 00:00:00 GMT 1970") == 0){
		if(m-&gt;unixdate){
			s_free(m-&gt;unixdate);
			m-&gt;unixdate = nil;
		}
		// look for the date in the first Received: line.
		// it's likely to be the right time zone (it's
	 	// the local system) and in a convenient format.
		if(cistrncmp(m-&gt;header, "received:", 9)==0){
			if((q = strchr(m-&gt;header, ';')) != nil){
				p = q;
				while((p = strchr(p, '\n')) != nil){
					if(p[1] != ' ' &amp;&amp; p[1] != '\t' &amp;&amp; p[1] != '\n')
						break;
					p++;
				}
				if(p){
					*p = '\0';
					m-&gt;unixdate = date822tounix(q+1);
					*p = '\n';
				}
			}
		}

		// fall back on the rfc822 date	
		if(m-&gt;unixdate==nil &amp;&amp; m-&gt;date822)
			m-&gt;unixdate = date822tounix(s_to_c(m-&gt;date822));
	}

	if(m-&gt;unixheader != nil)
		s_free(m-&gt;unixheader);

	// only fake header for top-level messages for pop3 and imap4
	// clients (those protocols don't include the unix header).
	// adding the unix header all the time screws up mime-attached
	// rfc822 messages.
	if(!addfrom &amp;&amp; !m-&gt;unixfrom){
		m-&gt;unixheader = nil;
		return;
	}

	m-&gt;unixheader = s_copy("From ");
	if(m-&gt;unixfrom &amp;&amp; strcmp(s_to_c(m-&gt;unixfrom), "???") != 0)
		s_append(m-&gt;unixheader, s_to_c(m-&gt;unixfrom));
	else if(m-&gt;from822)
		s_append(m-&gt;unixheader, s_to_c(m-&gt;from822));
	else
		s_append(m-&gt;unixheader, "???");

	s_append(m-&gt;unixheader, " ");
	if(m-&gt;unixdate)
		s_append(m-&gt;unixheader, s_to_c(m-&gt;unixdate));
	else
		s_append(m-&gt;unixheader, "Thu Jan  1 00:00:00 GMT 1970");

	s_append(m-&gt;unixheader, "\n");
}

String*
promote(String **sp)
{
	String *s;

	if(*sp != nil)
		s = s_clone(*sp);
	else
		s = nil;
	return s;
}

void
parsebody(Message *m, Mailbox *mb)
{
	Message *nm;

	// recurse
	if(strncmp(s_to_c(m-&gt;type), "multipart/", 10) == 0){
		parseattachments(m, mb);
	} else if(strcmp(s_to_c(m-&gt;type), "message/rfc822") == 0){
		decode(m);
		parseattachments(m, mb);
		nm = m-&gt;part;

		// promote headers
		if(m-&gt;replyto822 == nil &amp;&amp; m-&gt;from822 == nil &amp;&amp; m-&gt;sender822 == nil){
			m-&gt;from822 = promote(&amp;nm-&gt;from822);
			m-&gt;to822 = promote(&amp;nm-&gt;to822);
			m-&gt;date822 = promote(&amp;nm-&gt;date822);
			m-&gt;sender822 = promote(&amp;nm-&gt;sender822);
			m-&gt;replyto822 = promote(&amp;nm-&gt;replyto822);
			m-&gt;subject822 = promote(&amp;nm-&gt;subject822);
			m-&gt;unixdate = promote(&amp;nm-&gt;unixdate);
		}
	}
}

void
parse(Message *m, int justmime, Mailbox *mb, int addfrom)
{
	parseheaders(m, justmime, mb, addfrom);
	parsebody(m, mb);
}

static void
parseattachments(Message *m, Mailbox *mb)
{
	Message *nm, **l;
	char *p, *x;

	// if there's a boundary, recurse...
	if(m-&gt;boundary != nil){
		p = m-&gt;body;
		nm = nil;
		l = &amp;m-&gt;part;
		for(;;){
			x = strstr(p, s_to_c(m-&gt;boundary));

			/* no boundary, we're done */
			if(x == nil){
				if(nm != nil)
					nm-&gt;rbend = nm-&gt;bend = nm-&gt;end = m-&gt;bend;
				break;
			}

			/* boundary must be at the start of a line */
			if(x != m-&gt;body &amp;&amp; *(x-1) != '\n'){
				p = x+1;
				continue;
			}

			if(nm != nil)
				nm-&gt;rbend = nm-&gt;bend = nm-&gt;end = x;
			x += strlen(s_to_c(m-&gt;boundary));

			/* is this the last part? ignore anything after it */
			if(strncmp(x, "--", 2) == 0)
				break;

			p = strchr(x, '\n');
			if(p == nil)
				break;
			nm = newmessage(m);
			nm-&gt;start = nm-&gt;header = nm-&gt;body = nm-&gt;rbody = ++p;
			nm-&gt;mheader = nm-&gt;header;
			*l = nm;
			l = &amp;nm-&gt;next;
		}
		for(nm = m-&gt;part; nm != nil; nm = nm-&gt;next)
			parse(nm, 1, mb, 0);
		return;
	}

	// if we've got an rfc822 message, recurse...
	if(strcmp(s_to_c(m-&gt;type), "message/rfc822") == 0){
		nm = newmessage(m);
		m-&gt;part = nm;
		nm-&gt;start = nm-&gt;header = nm-&gt;body = nm-&gt;rbody = m-&gt;body;
		nm-&gt;end = nm-&gt;bend = nm-&gt;rbend = m-&gt;bend;
		parse(nm, 0, mb, 0);
	}
}

/*
 *  pick up a header line
 */
static int
headerline(char **pp, String *hl)
{
	char *p, *x;

	s_reset(hl);
	p = *pp;
	x = strpbrk(p, ":\n");
	if(x == nil || *x == '\n')
		return 0;
	for(;;){
		x = strchr(p, '\n');
		if(x == nil)
			x = p + strlen(p);
		s_nappend(hl, p, x-p);
		p = x;
		if(*p != '\n' || *++p != ' ' &amp;&amp; *p != '\t')
			break;
		while(*p == ' ' || *p == '\t')
			p++;
		s_putc(hl, ' ');
	}
	*pp = p;
	return 1;
}

/* returns nil iff there are no addressees */
static String*
addr822(char *p)
{
	String *s, *list;
	int incomment, addrdone, inanticomment, quoted;
	int n;
	int c;

	list = s_new();
	s = s_new();
	quoted = incomment = addrdone = inanticomment = 0;
	n = 0;
	for(; *p; p++){
		c = *p;

		// whitespace is ignored
		if(!quoted &amp;&amp; isspace(c) || c == '\r')
			continue;

		// strings are always treated as atoms
		if(!quoted &amp;&amp; c == '"'){
			if(!addrdone &amp;&amp; !incomment)
				s_putc(s, c);
			for(p++; *p; p++){
				if(!addrdone &amp;&amp; !incomment)
					s_putc(s, *p);
				if(!quoted &amp;&amp; *p == '"')
					break;
				if(*p == '\\')
					quoted = 1;
				else
					quoted = 0;
			}
			if(*p == 0)
				break;
			quoted = 0;
			continue;
		}

		// ignore everything in an expicit comment
		if(!quoted &amp;&amp; c == '('){
			incomment = 1;
			continue;
		}
		if(incomment){
			if(!quoted &amp;&amp; c == ')')
				incomment = 0;
			quoted = 0;
			continue;
		}

		// anticomments makes everything outside of them comments
		if(!quoted &amp;&amp; c == '&lt;' &amp;&amp; !inanticomment){
			inanticomment = 1;
			s = s_reset(s);
			continue;
		}
		if(!quoted &amp;&amp; c == '&gt;' &amp;&amp; inanticomment){
			addrdone = 1;
			inanticomment = 0;
			continue;
		}

		// commas separate addresses
		if(!quoted &amp;&amp; c == ',' &amp;&amp; !inanticomment){
			s_terminate(s);
			addrdone = 0;
			if(n++ != 0)
				s_append(list, " ");
			s_append(list, s_to_c(s));
			s = s_reset(s);
			continue;
		}

		// what's left is part of the address
		s_putc(s, c);

		// quoted characters are recognized only as characters
		if(c == '\\')
			quoted = 1;
		else
			quoted = 0;

	}

	if(*s_to_c(s) != 0){
		s_terminate(s);
		if(n++ != 0)
			s_append(list, " ");
		s_append(list, s_to_c(s));
	}
	s_free(s);

	if(n == 0){		/* no addressees given, just the keyword */
		s_free(list);
		return nil;
	}
	return list;
}

/*
 * per rfc2822 §4.5.3, permit multiple to, cc and bcc headers by
 * concatenating their values.
 */

static void
to822(Message *m, Header *h, char *p)
{
	String *s;

	p += strlen(h-&gt;type);
	s = addr822(p);
	if (m-&gt;to822 == nil)
		m-&gt;to822 = s;
	else if (s != nil) {
		s_append(m-&gt;to822, " ");
		s_append(m-&gt;to822, s_to_c(s));
		s_free(s);
	}
}

static void
cc822(Message *m, Header *h, char *p)
{
	String *s;

	p += strlen(h-&gt;type);
	s = addr822(p);
	if (m-&gt;cc822 == nil)
		m-&gt;cc822 = s;
	else if (s != nil) {
		s_append(m-&gt;cc822, " ");
		s_append(m-&gt;cc822, s_to_c(s));
		s_free(s);
	}
}

static void
bcc822(Message *m, Header *h, char *p)
{
	String *s;

	p += strlen(h-&gt;type);
	s = addr822(p);
	if (m-&gt;bcc822 == nil)
		m-&gt;bcc822 = s;
	else if (s != nil) {
		s_append(m-&gt;bcc822, " ");
		s_append(m-&gt;bcc822, s_to_c(s));
		s_free(s);
	}
}

static void
from822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	s_free(m-&gt;from822);
	m-&gt;from822 = addr822(p);
}

static void
sender822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	s_free(m-&gt;sender822);
	m-&gt;sender822 = addr822(p);
}

static void
replyto822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	s_free(m-&gt;replyto822);
	m-&gt;replyto822 = addr822(p);
}

static void
mimeversion(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	s_free(m-&gt;mimeversion);
	m-&gt;mimeversion = addr822(p);
}

static void
killtrailingwhite(char *p)
{
	char *e;

	e = p + strlen(p) - 1;
	while(e &gt; p &amp;&amp; isspace(*e))
		*e-- = 0;
}

static void
date822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	p = skipwhite(p);
	s_free(m-&gt;date822);
	m-&gt;date822 = s_copy(p);
	p = s_to_c(m-&gt;date822);
	killtrailingwhite(p);
}

static void
subject822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	p = skipwhite(p);
	s_free(m-&gt;subject822);
	m-&gt;subject822 = s_copy(p);
	p = s_to_c(m-&gt;subject822);
	killtrailingwhite(p);
}

static void
inreplyto822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	p = skipwhite(p);
	s_free(m-&gt;inreplyto822);
	m-&gt;inreplyto822 = s_copy(p);
	p = s_to_c(m-&gt;inreplyto822);
	killtrailingwhite(p);
}

static void
messageid822(Message *m, Header *h, char *p)
{
	p += strlen(h-&gt;type);
	p = skipwhite(p);
	s_free(m-&gt;messageid822);
	m-&gt;messageid822 = s_copy(p);
	p = s_to_c(m-&gt;messageid822);
	killtrailingwhite(p);
}

static int
isattribute(char **pp, char *attr)
{
	char *p;
	int n;

	n = strlen(attr);
	p = *pp;
	if(cistrncmp(p, attr, n) != 0)
		return 0;
	p += n;
	while(*p == ' ')
		p++;
	if(*p++ != '=')
		return 0;
	while(*p == ' ')
		p++;
	*pp = p;
	return 1;
}

static void
ctype(Message *m, Header *h, char *p)
{
	String *s;

	p += h-&gt;len;
	p = skipwhite(p);

	p = getstring(p, m-&gt;type, 1);
	
	while(*p){
		if(isattribute(&amp;p, "boundary")){
			s = s_new();
			p = getstring(p, s, 0);
			m-&gt;boundary = s_reset(m-&gt;boundary);
			s_append(m-&gt;boundary, "--");
			s_append(m-&gt;boundary, s_to_c(s));
			s_free(s);
		} else if(cistrncmp(p, "multipart", 9) == 0){
			/*
			 *  the first unbounded part of a multipart message,
			 *  the preamble, is not displayed or saved
			 */
		} else if(isattribute(&amp;p, "name")){
			if(m-&gt;filename == nil)
				setfilename(m, p);
		} else if(isattribute(&amp;p, "charset")){
			p = getstring(p, s_reset(m-&gt;charset), 0);
		}
		
		p = skiptosemi(p);
	}
}

static void
cencoding(Message *m, Header *h, char *p)
{
	p += h-&gt;len;
	p = skipwhite(p);
	if(cistrncmp(p, "base64", 6) == 0)
		m-&gt;encoding = Ebase64;
	else if(cistrncmp(p, "quoted-printable", 16) == 0)
		m-&gt;encoding = Equoted;
}

static void
cdisposition(Message *m, Header *h, char *p)
{
	p += h-&gt;len;
	p = skipwhite(p);
	while(*p){
		if(cistrncmp(p, "inline", 6) == 0){
			m-&gt;disposition = Dinline;
		} else if(cistrncmp(p, "attachment", 10) == 0){
			m-&gt;disposition = Dfile;
		} else if(cistrncmp(p, "filename=", 9) == 0){
			p += 9;
			setfilename(m, p);
		}
		p = skiptosemi(p);
	}

}

ulong msgallocd, msgfreed;

Message*
newmessage(Message *parent)
{
	static int id;
	Message *m;

	msgallocd++;

	m = emalloc(sizeof(*m));
	memset(m, 0, sizeof(*m));
	m-&gt;disposition = Dnone;
	m-&gt;type = s_copy("text/plain");
	m-&gt;charset = s_copy("iso-8859-1");
	m-&gt;id = newid();
	if(parent)
		sprint(m-&gt;name, "%d", ++(parent-&gt;subname));
	if(parent == nil)
		parent = m;
	m-&gt;whole = parent;
	m-&gt;hlen = -1;
	return m;
}

// delete a message from a mailbox
void
delmessage(Mailbox *mb, Message *m)
{
	Message **l;
	int i;

	mb-&gt;vers++;
	msgfreed++;

	if(m-&gt;whole != m){
		// unchain from parent
		for(l = &amp;m-&gt;whole-&gt;part; *l &amp;&amp; *l != m; l = &amp;(*l)-&gt;next)
			;
		if(*l != nil)
			*l = m-&gt;next;

		// clear out of name lookup hash table
		if(m-&gt;whole-&gt;whole == m-&gt;whole)
			hfree(PATH(mb-&gt;id, Qmbox), m-&gt;name);
		else
			hfree(PATH(m-&gt;whole-&gt;id, Qdir), m-&gt;name);
		for(i = 0; i &lt; Qmax; i++)
			hfree(PATH(m-&gt;id, Qdir), dirtab[i]);
	}

	/* recurse through sub-parts */
	while(m-&gt;part)
		delmessage(mb, m-&gt;part);

	/* free memory */
	if(m-&gt;mallocd)
		free(m-&gt;start);
	if(m-&gt;hallocd)
		free(m-&gt;header);
	if(m-&gt;ballocd)
		free(m-&gt;body);
	s_free(m-&gt;unixfrom);
	s_free(m-&gt;unixdate);
	s_free(m-&gt;unixheader);
	s_free(m-&gt;from822);
	s_free(m-&gt;sender822);
	s_free(m-&gt;to822);
	s_free(m-&gt;bcc822);
	s_free(m-&gt;cc822);
	s_free(m-&gt;replyto822);
	s_free(m-&gt;date822);
	s_free(m-&gt;inreplyto822);
	s_free(m-&gt;subject822);
	s_free(m-&gt;messageid822);
	s_free(m-&gt;addrs);
	s_free(m-&gt;mimeversion);
	s_free(m-&gt;sdigest);
	s_free(m-&gt;boundary);
	s_free(m-&gt;type);
	s_free(m-&gt;charset);
	s_free(m-&gt;filename);

	free(m);
}

// mark messages (identified by path) for deletion
void
delmessages(int ac, char **av)
{
	Mailbox *mb;
	Message *m;
	int i, needwrite;

	qlock(&amp;mbllock);
	for(mb = mbl; mb != nil; mb = mb-&gt;next)
		if(strcmp(av[0], mb-&gt;name) == 0){
			qlock(mb);
			break;
		}
	qunlock(&amp;mbllock);
	if(mb == nil)
		return;

	needwrite = 0;
	for(i = 1; i &lt; ac; i++){
		for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next)
			if(strcmp(m-&gt;name, av[i]) == 0){
				if(!m-&gt;deleted){
					mailplumb(mb, m, 1);
					needwrite = 1;
					m-&gt;deleted = 1;
					logmsg("deleting", m);
				}
				break;
			}
	}
	if(needwrite)
		syncmbox(mb, 1);
	qunlock(mb);
}

/*
 *  the following are called with the mailbox qlocked
 */
void
msgincref(Message *m)
{
	m-&gt;refs++;
}
void
msgdecref(Mailbox *mb, Message *m)
{
	m-&gt;refs--;
	if(m-&gt;refs == 0 &amp;&amp; m-&gt;deleted)
		syncmbox(mb, 1);
}

/*
 *  the following are called with mbllock'd
 */
void
mboxincref(Mailbox *mb)
{
	assert(mb-&gt;refs &gt; 0);
	mb-&gt;refs++;
}
void
mboxdecref(Mailbox *mb)
{
	assert(mb-&gt;refs &gt; 0);
	qlock(mb);
	mb-&gt;refs--;
	if(mb-&gt;refs == 0){
		delmessage(mb, mb-&gt;root);
		if(mb-&gt;ctl)
			hfree(PATH(mb-&gt;id, Qmbox), "ctl");
		if(mb-&gt;close)
			(*mb-&gt;close)(mb);
		free(mb);
	} else
		qunlock(mb);
}

int
cistrncmp(char *a, char *b, int n)
{
	while(n-- &gt; 0){
		if(tolower(*a++) != tolower(*b++))
			return -1;
	}
	return 0;
}

int
cistrcmp(char *a, char *b)
{
	for(;;){
		if(tolower(*a) != tolower(*b++))
			return -1;
		if(*a++ == 0)
			break;
	}
	return 0;
}

static char*
skipwhite(char *p)
{
	while(isspace(*p))
		p++;
	return p;
}

static char*
skiptosemi(char *p)
{
	while(*p &amp;&amp; *p != ';')
		p++;
	while(*p == ';' || isspace(*p))
		p++;
	return p;
}

static char*
getstring(char *p, String *s, int dolower)
{
	s = s_reset(s);
	p = skipwhite(p);
	if(*p == '"'){
		p++;
		for(;*p &amp;&amp; *p != '"'; p++)
			if(dolower)
				s_putc(s, tolower(*p));
			else
				s_putc(s, *p);
		if(*p == '"')
			p++;
		s_terminate(s);

		return p;
	}

	for(; *p &amp;&amp; !isspace(*p) &amp;&amp; *p != ';'; p++)
		if(dolower)
			s_putc(s, tolower(*p));
		else
			s_putc(s, *p);
	s_terminate(s);

	return p;
}

static void
setfilename(Message *m, char *p)
{
	m-&gt;filename = s_reset(m-&gt;filename);
	getstring(p, m-&gt;filename, 0);
	for(p = s_to_c(m-&gt;filename); *p; p++)
		if(*p == ' ' || *p == '\t' || *p == ';')
			*p = '_';
}

//
// undecode message body
//
void
decode(Message *m)
{
	int i, len;
	char *x;

	if(m-&gt;decoded)
		return;
	switch(m-&gt;encoding){
	case Ebase64:
		len = m-&gt;bend - m-&gt;body;
		i = (len*3)/4+1;	// room for max chars + null
		x = emalloc(i);
		len = dec64((uchar*)x, i, m-&gt;body, len);
		if(m-&gt;ballocd)
			free(m-&gt;body);
		m-&gt;body = x;
		m-&gt;bend = x + len;
		m-&gt;ballocd = 1;
		break;
	case Equoted:
		len = m-&gt;bend - m-&gt;body;
		x = emalloc(len+2);	// room for null and possible extra nl
		len = decquoted(x, m-&gt;body, m-&gt;bend, 0);
		if(m-&gt;ballocd)
			free(m-&gt;body);
		m-&gt;body = x;
		m-&gt;bend = x + len;
		m-&gt;ballocd = 1;
		break;
	default:
		break;
	}
	m-&gt;decoded = 1;
}

// convert latin1 to utf
void
convert(Message *m)
{
	int len;
	char *x;

	// don't convert if we're not a leaf, not text, or already converted
	if(m-&gt;converted)
		return;
	if(m-&gt;part != nil)
		return;
	if(cistrncmp(s_to_c(m-&gt;type), "text", 4) != 0)
		return;

	len = xtoutf(s_to_c(m-&gt;charset), &amp;x, m-&gt;body, m-&gt;bend);
	if(len &gt; 0){
		if(m-&gt;ballocd)
			free(m-&gt;body);
		m-&gt;body = x;
		m-&gt;bend = x + len;
		m-&gt;ballocd = 1;
	}
	m-&gt;converted = 1;
}

static int
hex2int(int x)
{
	if(x &gt;= '0' &amp;&amp; x &lt;= '9')
		return x - '0';
	if(x &gt;= 'A' &amp;&amp; x &lt;= 'F')
		return (x - 'A') + 10;
	if(x &gt;= 'a' &amp;&amp; x &lt;= 'f')
		return (x - 'a') + 10;
	return -1;
}

// underscores are translated in 2047 headers (uscores=1) 
// but not in the body (uscores=0)
static char*
decquotedline(char *out, char *in, char *e, int uscores)
{
	int c, c2, soft;

	/* dump trailing white space */
	while(e &gt;= in &amp;&amp; (*e == ' ' || *e == '\t' || *e == '\r' || *e == '\n'))
		e--;

	/* trailing '=' means no newline */
	if(*e == '='){
		soft = 1;
		e--;
	} else
		soft = 0;

	while(in &lt;= e){
		c = (*in++) &amp; 0xff;
		switch(c){
		case '_':
			if(uscores){
				*out++ = ' ';
				break;
			}
		default:
			*out++ = c;
			break;
		case '=':
			c  = hex2int(*in++);
			c2 = hex2int(*in++);
			if (c != -1 &amp;&amp; c2 != -1)
				*out++ = c&lt;&lt;4 | c2;
			else {
				*out++ = '=';
				in -= 2;
			}
			break;
		}
	}
	if(!soft)
		*out++ = '\n';
	*out = 0;

	return out;
}

int
decquoted(char *out, char *in, char *e, int uscores)
{
	char *p, *nl;

	p = out;
	while((nl = strchr(in, '\n')) != nil &amp;&amp; nl &lt; e){
		p = decquotedline(p, in, nl, uscores);
		in = nl + 1;
	}
	if(in &lt; e)
		p = decquotedline(p, in, e-1, uscores);

	// make sure we end with a new line
	if(*(p-1) != '\n'){
		*p++ = '\n';
		*p = 0;
	}

	return p - out;
}

static char*
lowercase(char *p)
{
	char *op;
	int c;

	for(op = p; c = *p; p++)
		if(isupper(c))
			*p = tolower(c);
	return op;
}

// translate latin1 directly since it fits neatly in utf
static int
latin1toutf(char **out, char *in, char *e)
{
	int n;
	char *p;
	Rune r;

	n = 0;
	for(p = in; p &lt; e; p++)
		if(*p &amp; 0x80)
			n++;
	if(n == 0)
		return 0;

	n += e-in;
	*out = p = malloc(n+1);
	if(p == nil)
		return 0;

	for(; in &lt; e; in++){
		r = (uchar)*in;
		p += runetochar(p, &amp;r);
	}
	*p = 0;
	return p - *out;
}

// translate any thing using the tcs program
int
xtoutf(char *charset, char **out, char *in, char *e)
{
	char *av[4];
	int totcs[2];
	int fromtcs[2];
	int n, len, sofar;
	char *p;

	// might not need to convert
	if(cistrcmp(charset, "us-ascii") == 0 || cistrcmp(charset, "utf-8") == 0)
		return 0;
	if(cistrcmp(charset, "iso-8859-1") == 0)
		return latin1toutf(out, in, e);

	len = e-in+1;
	sofar = 0;
	*out = p = malloc(len+1);
	if(p == nil)
		return 0;

	av[0] = charset;
	av[1] = "-f";
	av[2] = charset;
	av[3] = 0;
	if(pipe(totcs) &lt; 0)
		goto error;
	if(pipe(fromtcs) &lt; 0){
		close(totcs[0]); close(totcs[1]);
		goto error;
	}
	switch(rfork(RFPROC|RFFDG|RFNOWAIT)){
	case -1:
		close(fromtcs[0]); close(fromtcs[1]);
		close(totcs[0]); close(totcs[1]);
		goto error;
	case 0:
		close(fromtcs[0]); close(totcs[1]);
		dup(fromtcs[1], 1);
		dup(totcs[0], 0);
		close(fromtcs[1]); close(totcs[0]);
		dup(open("/dev/null", OWRITE), 2);
		exec("/bin/tcs", av);
		_exits(0);
	default:
		close(fromtcs[1]); close(totcs[0]);
		switch(rfork(RFPROC|RFFDG|RFNOWAIT)){
		case -1:
			close(fromtcs[0]); close(totcs[1]);
			goto error;
		case 0:
			close(fromtcs[0]);
			while(in &lt; e){
				n = write(totcs[1], in, e-in);
				if(n &lt;= 0)
					break;
				in += n;
			}
			close(totcs[1]);
			_exits(0);
		default:
			close(totcs[1]);
			for(;;){
				n = read(fromtcs[0], &amp;p[sofar], len-sofar);
				if(n &lt;= 0)
					break;
				sofar += n;
				p[sofar] = 0;
				if(sofar == len){
					len += 1024;
					p = realloc(p, len+1);
					if(p == nil)
						goto error;
					*out = p;
				}
			}
			close(fromtcs[0]);
			break;
		}
		break;
	}
	if(sofar == 0)
		goto error;
	return sofar;

error:
	free(*out);
	*out = nil;
	return 0;
}

void *
emalloc(ulong n)
{
	void *p;

	p = mallocz(n, 1);
	if(!p){
		fprint(2, "%s: out of memory alloc %lud\n", argv0, n);
		exits("out of memory");
	}
	setmalloctag(p, getcallerpc(&amp;n));
	return p;
}

void *
erealloc(void *p, ulong n)
{
	if(n == 0)
		n = 1;
	p = realloc(p, n);
	if(!p){
		fprint(2, "%s: out of memory realloc %lud\n", argv0, n);
		exits("out of memory");
	}
	setrealloctag(p, getcallerpc(&amp;p));
	return p;
}

void
mailplumb(Mailbox *mb, Message *m, int delete)
{
	Plumbmsg p;
	Plumbattr a[7];
	char buf[256];
	int ai;
	char lenstr[10], *from, *subject, *date;
	static int fd = -1;

	if(m-&gt;subject822 == nil)
		subject = "";
	else
		subject = s_to_c(m-&gt;subject822);

	if(m-&gt;from822 != nil)
		from = s_to_c(m-&gt;from822);
	else if(m-&gt;unixfrom != nil)
		from = s_to_c(m-&gt;unixfrom);
	else
		from = "";

	if(m-&gt;unixdate != nil)
		date = s_to_c(m-&gt;unixdate);
	else
		date = "";

	sprint(lenstr, "%ld", m-&gt;end-m-&gt;start);

	if(biffing &amp;&amp; !delete)
		print("[ %s / %s / %s ]\n", from, subject, lenstr);

	if(!plumbing)
		return;

	if(fd &lt; 0)
		fd = plumbopen("send", OWRITE);
	if(fd &lt; 0)
		return;

	p.src = "mailfs";
	p.dst = "seemail";
	p.wdir = "/mail/fs";
	p.type = "text";

	ai = 0;
	a[ai].name = "filetype";
	a[ai].value = "mail";

	a[++ai].name = "sender";
	a[ai].value = from;
	a[ai-1].next = &amp;a[ai];

	a[++ai].name = "length";
	a[ai].value = lenstr;
	a[ai-1].next = &amp;a[ai];

	a[++ai].name = "mailtype";
	a[ai].value = delete?"delete":"new";
	a[ai-1].next = &amp;a[ai];

	a[++ai].name = "date";
	a[ai].value = date;
	a[ai-1].next = &amp;a[ai];

	if(m-&gt;sdigest){
		a[++ai].name = "digest";
		a[ai].value = s_to_c(m-&gt;sdigest);
		a[ai-1].next = &amp;a[ai];
	}

	a[ai].next = nil;

	p.attr = a;
	snprint(buf, sizeof(buf), "%s/%s/%s",
		mntpt, mb-&gt;name, m-&gt;name);
	p.ndata = strlen(buf);
	p.data = buf;

	plumbsend(fd, &amp;p);
}

//
// count the number of lines in the body (for imap4)
//
void
countlines(Message *m)
{
	int i;
	char *p;

	i = 0;
	for(p = strchr(m-&gt;rbody, '\n'); p != nil &amp;&amp; p &lt; m-&gt;rbend; p = strchr(p+1, '\n'))
		i++;
	sprint(m-&gt;lines, "%d", i);
}

char *LOG = "fs";

void
logmsg(char *s, Message *m)
{
	int pid;

	if(!logging)
		return;
	pid = getpid();
	if(m == nil)
		syslog(0, LOG, "%s.%d: %s", user, pid, s);
	else
		syslog(0, LOG, "%s.%d: %s msg from %s digest %s",
			user, pid, s,
			m-&gt;from822 ? s_to_c(m-&gt;from822) : "?",
			s_to_c(m-&gt;sdigest));
}

/*
 *  squeeze nulls out of the body
 */
static void
nullsqueeze(Message *m)
{
	char *p, *q;

	q = memchr(m-&gt;body, 0, m-&gt;end-m-&gt;body);
	if(q == nil)
		return;

	for(p = m-&gt;body; q &lt; m-&gt;end; q++){
		if(*q == 0)
			continue;
		*p++ = *q;
	}
	m-&gt;bend = m-&gt;rbend = m-&gt;end = p;
}


//
// convert an RFC822 date into a Unix style date
// for when the Unix From line isn't there (e.g. POP3).
// enough client programs depend on having a Unix date
// that it's easiest to write this conversion code once, right here.
//
// people don't follow RFC822 particularly closely,
// so we use strtotm, which is a bunch of heuristics.
//

extern int strtotm(char*, Tm*);
String*
date822tounix(char *s)
{
	char *p, *q;
	Tm tm;

	if(strtotm(s, &amp;tm) &lt; 0)
		return nil;

	p = asctime(&amp;tm);
	if(q = strchr(p, '\n'))
		*q = '\0';
	return s_copy(p);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

