<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/fs/planb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/fs/planb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Plan B (mail2fs) mail box format.
 *
 * BUG: this does not reconstruct the
 * raw text for attachments.  So imap and others
 * will be unable to access any attachment using upas/fs.
 * As an aid, we add the path to the message directory
 * to the message body, so the user could build the path
 * for any attachment and open it.
 */

#include "common.h"
#include &lt;ctype.h&gt;
#include &lt;plumb.h&gt;
#include &lt;libsec.h&gt;
#include "dat.h"

static int
readmessage(Message *m, char *msg)
{
	int fd, i, n;
	char *buf, *name, *p;
	char hdr[128], sdigest[SHA1dlen*2+1];
	Dir *d;

	buf = nil;
	d = nil;
	name = smprint("%s/raw", msg);
	if(name == nil)
		return -1;
	if(m-&gt;filename != nil)
		s_free(m-&gt;filename);
	m-&gt;filename = s_copy(name);
	fd = open(name, OREAD);
	if(fd &lt; 0)
		goto Fail;
	n = read(fd, hdr, sizeof(hdr)-1);
	if(n &lt;= 0)
		goto Fail;
	hdr[n] = 0;
	close(fd);
	fd = -1;
	p = strchr(hdr, '\n');
	if(p != nil)
		*++p = 0;
	if(strncmp(hdr, "From ", 5) != 0)
		goto Fail;
	free(name);
	name = smprint("%s/text", msg);
	if(name == nil)
		goto Fail;
	fd = open(name, OREAD);
	if(fd &lt; 0)
		goto Fail;
	d = dirfstat(fd);
	if(d == nil)
		goto Fail;
	buf = malloc(strlen(hdr) + d-&gt;length + strlen(msg) + 10); /* few extra chars */
	if(buf == nil)
		goto Fail;
	strcpy(buf, hdr);
	p = buf+strlen(hdr);
	n = readn(fd, p, d-&gt;length);
	if(n &lt; 0)
		goto Fail;
	sprint(p+n, "\n[%s]\n", msg);
	n += 2 + strlen(msg) + 2;
	close(fd);
	free(name);
	free(d);
	free(m-&gt;start);
	m-&gt;start = buf;
	m-&gt;lim = m-&gt;end = p+n;
	if(*(m-&gt;end-1) == '\n')
		m-&gt;end--;
	*m-&gt;end = 0;
	m-&gt;bend = m-&gt;rbend = m-&gt;end;
	sha1((uchar*)m-&gt;start, m-&gt;end - m-&gt;start, m-&gt;digest, nil);
	for(i = 0; i &lt; SHA1dlen; i++)
		sprint(sdigest+2*i, "%2.2ux", m-&gt;digest[i]);
	m-&gt;sdigest = s_copy(sdigest);
	return 0;
Fail:
	if(fd &gt;= 0)
		close(fd);
	free(name);
	free(buf);
	free(d);
	return -1;
}

/*
 * Deleted messages are kept as spam instead.
 */
static void
archive(Message *m)
{
	char *dir, *p, *nname;
	Dir d;

	dir = strdup(s_to_c(m-&gt;filename));
	nname = nil;
	if(dir == nil)
		return;
	p = strrchr(dir, '/');
	if(p == nil)
		goto Fail;
	*p = 0;
	p = strrchr(dir, '/');
	if(p == nil)
		goto Fail;
	p++;
	if(*p &lt; '0' || *p &gt; '9')
		goto Fail;
	nname = smprint("s.%s", p);
	if(nname == nil)
		goto Fail;
	nulldir(&amp;d);
	d.name = nname;
	dirwstat(dir, &amp;d);
Fail:
	free(dir);
	free(nname);
}

int
purgembox(Mailbox *mb, int virtual)
{
	Message *m, *next;
	int newdels;

	/* forget about what's no longer in the mailbox */
	newdels = 0;
	for(m = mb-&gt;root-&gt;part; m != nil; m = next){
		next = m-&gt;next;
		if(m-&gt;deleted &gt; 0 &amp;&amp; m-&gt;refs == 0){
			if(m-&gt;inmbox){
				newdels++;
				/*
				 * virtual folders are virtual,
				 * we do not archive
				 */
				if(virtual == 0)
					archive(m);
			}
			delmessage(mb, m);
		}
	}
	return newdels;
}

static int
mustshow(char* name)
{
	if(isdigit(name[0]))
		return 1;
	if(0 &amp;&amp; name[0] == 'a' &amp;&amp; name[1] == '.')
		return 1;
	if(0 &amp;&amp; name[0] == 's' &amp;&amp; name[1] == '.')
		return 1;
	return 0;
}

static int
readpbmessage(Mailbox *mb, char *msg, int doplumb)
{
	Message *m, **l;
	char *x;

	m = newmessage(mb-&gt;root);
	m-&gt;mallocd = 1;
	m-&gt;inmbox = 1;
	if(readmessage(m, msg) &lt; 0){
		delmessage(mb, m);
		mb-&gt;root-&gt;subname--;
		return -1;
	}
	for(l = &amp;mb-&gt;root-&gt;part; *l != nil; l = &amp;(*l)-&gt;next)
		if(strcmp(s_to_c((*l)-&gt;filename), s_to_c(m-&gt;filename)) == 0 &amp;&amp;
		    *l != m){
			if((*l)-&gt;deleted &lt; 0)
				(*l)-&gt;deleted = 0;
			delmessage(mb, m);
			mb-&gt;root-&gt;subname--;
			return -1;
		}
	x = strchr(m-&gt;start, '\n');
	if(x == nil)
		m-&gt;header = m-&gt;end;
	else
		m-&gt;header = x + 1;
	m-&gt;mheader = m-&gt;mhend = m-&gt;header;
	parseunix(m);
	parse(m, 0, mb, 0);
	logmsg("new", m);

	/* chain in */
	*l = m;
	if(doplumb)
		mailplumb(mb, m, 0);
	return 0;
}

static int
dcmp(Dir *a, Dir *b)
{
	char *an, *bn;

	an = a-&gt;name;
	bn = b-&gt;name;
	if(an[0] != 0 &amp;&amp; an[1] == '.')
		an += 2;
	if(bn[0] != 0 &amp;&amp; bn[1] == '.')
		bn += 2;
	return strcmp(an, bn);
}

static void
readpbmbox(Mailbox *mb, int doplumb)
{
	int fd, i, j, nd, nmd;
	char *month, *msg;
	Dir *d, *md;

	fd = open(mb-&gt;path, OREAD);
	if(fd &lt; 0){
		fprint(2, "%s: %s: %r\n", argv0, mb-&gt;path);
		return;
	}
	nd = dirreadall(fd, &amp;d);
	close(fd);
	if(nd &gt; 0)
		qsort(d, nd, sizeof d[0], (int (*)(void*, void*))dcmp);
	for(i = 0; i &lt; nd; i++){
		month = smprint("%s/%s", mb-&gt;path, d[i].name);
		if(month == nil)
			break;
		fd = open(month, OREAD);
		if(fd &lt; 0){
			fprint(2, "%s: %s: %r\n", argv0, month);
			free(month);
			continue;
		}
		md = dirfstat(fd);
		if(md != nil &amp;&amp; (md-&gt;qid.type &amp; QTDIR) != 0){
			free(md);
			md = nil;
			nmd = dirreadall(fd, &amp;md);
			for(j = 0; j &lt; nmd; j++)
				if(mustshow(md[j].name)){
					msg = smprint("%s/%s", month, md[j].name);
					readpbmessage(mb, msg, doplumb);
					free(msg);
				}
		}
		close(fd);
		free(month);
		free(md);
		md = nil;
	}
	free(d);
}

static void
readpbvmbox(Mailbox *mb, int doplumb)
{
	int fd, nr;
	long sz;
	char *data, *ln, *p, *nln, *msg;
	Dir *d;

	fd = open(mb-&gt;path, OREAD);
	if(fd &lt; 0){
		fprint(2, "%s: %s: %r\n", argv0, mb-&gt;path);
		return;
	}
	d = dirfstat(fd);
	if(d == nil){
		fprint(2, "%s: %s: %r\n", argv0, mb-&gt;path);
		close(fd);
		return;
	}
	sz = d-&gt;length;
	free(d);
	if(sz &gt; 2 * 1024 * 1024){
		sz = 2 * 1024 * 1024;
		fprint(2, "%s: %s: bug: folder too big\n", argv0, mb-&gt;path);
	}
	data = malloc(sz+1);
	if(data == nil){
		close(fd);
		fprint(2, "%s: no memory\n", argv0);
		return;
	}
	nr = readn(fd, data, sz);
	close(fd);
	if(nr &lt; 0){
		fprint(2, "%s: %s: %r\n", argv0, mb-&gt;path);
		free(data);
		return;
	}
	data[nr] = 0;

	for(ln = data; *ln != 0; ln = nln){
		nln = strchr(ln, '\n');
		if(nln != nil)
			*nln++ = 0;
		else
			nln = ln + strlen(ln);
		p = strchr(ln , ' ');
		if(p != nil)
			*p = 0;
		p = strchr(ln, '\t');
		if(p != nil)
			*p = 0;
		p = strstr(ln, "/text");
		if(p != nil)
			*p = 0;
		msg = smprint("/mail/box/%s/msgs/%s", user, ln);
		if(msg == nil){
			fprint(2, "%s: no memory\n", argv0);
			continue;
		}
		readpbmessage(mb, msg, doplumb);
		free(msg);
	}
	free(data);
}

static char*
readmbox(Mailbox *mb, int doplumb, int virt)
{
	int fd;
	Dir *d;
	Message *m;
	static char err[Errlen];

	if(debug)
		fprint(2, "read mbox %s\n", mb-&gt;path);
	fd = open(mb-&gt;path, OREAD);
	if(fd &lt; 0){
		errstr(err, sizeof(err));
		return err;
	}

	d = dirfstat(fd);
	if(d == nil){
		close(fd);
		errstr(err, sizeof(err));
		return err;
	}
	if(mb-&gt;d != nil){
		if(d-&gt;qid.path == mb-&gt;d-&gt;qid.path &amp;&amp;
		   d-&gt;qid.vers == mb-&gt;d-&gt;qid.vers){
			close(fd);
			free(d);
			return nil;
		}
		free(mb-&gt;d);
	}
	close(fd);
	mb-&gt;d = d;
	mb-&gt;vers++;
	henter(PATH(0, Qtop), mb-&gt;name,
		(Qid){PATH(mb-&gt;id, Qmbox), mb-&gt;vers, QTDIR}, nil, mb);
	snprint(err, sizeof err, "reading '%s'", mb-&gt;path);
	logmsg(err, nil);

	for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next)
		if(m-&gt;deleted == 0)
			m-&gt;deleted = -1;
	if(virt == 0)
		readpbmbox(mb, doplumb);
	else
		readpbvmbox(mb, doplumb);

	/*
	 * messages removed from the mbox; flag them to go.
	 */
	for(m = mb-&gt;root-&gt;part; m != nil; m = m-&gt;next)
		if(m-&gt;deleted &lt; 0 &amp;&amp; doplumb){
			m-&gt;inmbox = 0;
			m-&gt;deleted = 1;
			mailplumb(mb, m, 1);
		}
	logmsg("mbox read", nil);
	return nil;
}

static char*
mbsync(Mailbox *mb, int doplumb)
{
	char *rv;

	rv = readmbox(mb, doplumb, 0);
	purgembox(mb, 0);
	return rv;
}

static char*
mbvsync(Mailbox *mb, int doplumb)
{
	char *rv;

	rv = readmbox(mb, doplumb, 1);
	purgembox(mb, 1);
	return rv;
}

char*
planbmbox(Mailbox *mb, char *path)
{
	char *list;
	static char err[64];

	if(access(path, AEXIST) &lt; 0)
		return Enotme;
	list = smprint("%s/list", path);
	if(access(list, AEXIST) &lt; 0){
		free(list);
		return Enotme;
	}
	free(list);
	mb-&gt;sync = mbsync;
	if(debug)
		fprint(2, "planb mbox %s\n", path);
	return nil;
}

char*
planbvmbox(Mailbox *mb, char *path)
{
	int fd, nr, i;
	char buf[64];
	static char err[64];

	fd = open(path, OREAD);
	if(fd &lt; 0)
		return Enotme;
	nr = read(fd, buf, sizeof(buf)-1);
	close(fd);
	if(nr &lt; 7)
		return Enotme;
	buf[nr] = 0;
	for(i = 0; i &lt; 6; i++)
		if(buf[i] &lt; '0' || buf[i] &gt; '9')
			return Enotme;
	if(buf[6] != '/')
		return Enotme;
	mb-&gt;sync = mbvsync;
	if(debug)
		fprint(2, "planb virtual mbox %s\n", path);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

