<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/bind.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/bind.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

static int forward_loop(char *, char *);

/* bind the destinations to the commands to be executed */
extern dest *
up_bind(dest *destp, message *mp, int checkforward)
{
	dest *list[2];		/* lists of unbound destinations */
	int li;			/* index into list[2] */
	dest *bound=0;	/* bound destinations */
	dest *dp;
	int i;

	list[0] = destp;
	list[1] = 0;

	/*
	 *  loop once to check for:
	 *	- forwarding rights
	 *	- addressing loops
	 *	- illegal characters
	 *	- characters that need escaping
	 */
	for (dp = d_rm(&amp;list[0]); dp != 0; dp = d_rm(&amp;list[0])) {
		if (!checkforward)
			dp-&gt;authorized = 1;
		dp-&gt;addr = escapespecial(dp-&gt;addr);
		if (forward_loop(s_to_c(dp-&gt;addr), thissys)) {
			dp-&gt;status = d_eloop;
			d_same_insert(&amp;bound, dp);
		} else if(forward_loop(s_to_c(mp-&gt;sender), thissys)) {
			dp-&gt;status = d_eloop;
			d_same_insert(&amp;bound, dp);
		} else if(shellchars(s_to_c(dp-&gt;addr))) {
			dp-&gt;status = d_syntax;
			d_same_insert(&amp;bound, dp);
		} else
			d_insert(&amp;list[1], dp);
	}
	li = 1;

	/* Loop until all addresses are bound or address loop detected */
	for (i=0; list[li]!=0 &amp;&amp; i&lt;32; ++i, li ^= 1) {
		/* Traverse the current list.  Bound items are put on the
		 * `bound' list.  Unbound items are put on the next list to
		 * traverse, `list[li^1]'.
		 */
		for (dp = d_rm(&amp;list[li]); dp != 0; dp = d_rm(&amp;list[li])){
			dest *newlist;

			rewrite(dp, mp);
			if(debug)
				fprint(2, "%s -&gt; %s\n", s_to_c(dp-&gt;addr),
					dp-&gt;repl1 ? s_to_c(dp-&gt;repl1):"");
			switch (dp-&gt;status) {
			case d_auth:
				/* authorize address if not already authorized */
				if(!dp-&gt;authorized){
					authorize(dp);
					if(dp-&gt;status==d_auth)
						d_insert(&amp;list[li^1], dp);
					else
						d_insert(&amp;bound, dp);
				}
				break;
			case d_cat:
				/* address -&gt; local */
				newlist = expand_local(dp);
				if (newlist == 0) {
					/* append to mailbox (or error) */
					d_same_insert(&amp;bound, dp);
				} else if (newlist-&gt;status == d_undefined) {
					/* Forward to ... */
					d_insert(&amp;list[li^1], newlist);
				} else {
					/* Pipe to ... */
					d_same_insert(&amp;bound, newlist);
				}
				break;
			case d_pipe:
				/* address -&gt; command */
				d_same_insert(&amp;bound, dp);
				break;
			case d_alias:
				/* address -&gt; rewritten address */
				newlist = s_to_dest(dp-&gt;repl1, dp);
				if(newlist != 0)
					d_insert(&amp;list[li^1], newlist);
				else
					d_same_insert(&amp;bound, dp);
				break;
			case d_translate:
				/* pipe to a translator */
				newlist = translate(dp);
				if (newlist != 0)
					d_insert(&amp;list[li^1], newlist);
				else
					d_same_insert(&amp;bound, dp);
				break;
			default:
				/* error */
				d_same_insert(&amp;bound, dp);
				break;
			}
		}
	}

	/* mark remaining comands as "forwarding loops" */
	for (dp = d_rm(&amp;list[li]); dp != 0; dp = d_rm(&amp;list[li])) {
		dp-&gt;status = d_loop;
		d_same_insert(&amp;bound, dp);
	}

	return bound;
}

/* Return TRUE if a forwarding loop exists, i.e., the String `system'
 * is found more than 4 times in the return address.
 */
static int
forward_loop(char *addr, char *system)
{
	int len = strlen(system), found = 0;

	while (addr = strchr(addr, '!'))
		if (!strncmp(++addr, system, len)
		 &amp;&amp; addr[len] == '!' &amp;&amp; ++found == 4)
			return 1;
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

