<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/filter.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/filter.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

Biobuf	bin;
int rmail, tflg;
char *subjectarg;

char *findbody(char*);

void
usage(void)
{
	fprint(2, "usage: upas/filter [-bh] rcvr mailbox [regexp file] ...\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	message *mp;
	dest *dp;
	Reprog *p;
	Resub match[10];
	char file[MAXPATHLEN];
	Biobuf *fp;
	char *rcvr, *cp;
	Mlock *l;
	String *tmp;
	int i;
	int header, body;

	header = body = 0;
	ARGBEGIN {
	case 'h':
		header = 1;
		break;
	case 'b':
		header = 1;
		body = 1;
		break;
	default:
		usage();
	} ARGEND

	Binit(&amp;bin, 0, OREAD);
	if(argc &lt; 2)
		usage();
	mp = m_read(&amp;bin, 1, 0);

	/* get rid of local system name */
	cp = strchr(s_to_c(mp-&gt;sender), '!');
	if(cp){
		cp++;
		mp-&gt;sender = s_copy(cp);
	}

	dp = d_new(s_copy(argv[0]));
	strecpy(file, file+sizeof file, argv[1]);
	cp = findbody(s_to_c(mp-&gt;body));
	for(i = 2; i &lt; argc; i += 2){
		p = regcomp(argv[i]);
		if(p == 0)
			continue;
		if(regexec(p, s_to_c(mp-&gt;sender), match, 10)){
			regsub(argv[i+1], file, sizeof(file), match, 10);
			break;
		}
		if(header == 0 &amp;&amp; body == 0)
			continue;
		if(regexec(p, s_to_c(mp-&gt;body), match, 10)){
			if(body == 0 &amp;&amp; match[0].sp &gt;= cp)
				continue;
			regsub(argv[i+1], file, sizeof(file), match, 10);
			break;
		}
	}

	/*
	 *  always lock the normal mail file to avoid too many lock files
	 *  lying about.  This isn't right but it's what the majority prefers.
	 */
	l = syslock(argv[1]);
	if(l == 0){
		fprint(2, "can't lock mail file %s\n", argv[1]);
		exit(1);
	}

	/*
	 *  open the destination mail file
	 */
	fp = sysopen(file, "ca", MBOXMODE);
	if (fp == 0){
		tmp = s_append(0, file);
		s_append(tmp, ".tmp");
		fp = sysopen(s_to_c(tmp), "cal", MBOXMODE);
		if(fp == 0){
			sysunlock(l);
			fprint(2, "can't open mail file %s\n", file);
			exit(1);
		}
		syslog(0, "mail", "error: used %s", s_to_c(tmp));
		s_free(tmp);
	}
	Bseek(fp, 0, 2);
	if(m_print(mp, fp, (char *)0, 1) &lt; 0
	|| Bprint(fp, "\n") &lt; 0
	|| Bflush(fp) &lt; 0){
		sysclose(fp);
		sysunlock(l);
		fprint(2, "can't write mail file %s\n", file);
		exit(1);
	}
	sysclose(fp);

	sysunlock(l);
	rcvr = argv[0];
	if(cp = strrchr(rcvr, '!'))
		rcvr = cp+1;
	logdelivery(dp, rcvr, mp);
	exit(0);
}

char*
findbody(char *p)
{
	if(*p == '\n')
		return p;

	while(*p){
		if(*p == '\n' &amp;&amp; *(p+1) == '\n')
			return p+1;
		p++;
	}
	return p;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

