<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/upas/send/message.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/upas/send/message.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "common.h"
#include "send.h"

#include "../smtp/smtp.h"
#include "../smtp/y.tab.h"

/* global to this file */
static Reprog *rfprog;
static Reprog *fprog;

#define VMLIMIT (64*1024)
#define MSGLIMIT (128*1024*1024)

int received;	/* from rfc822.y */

static String*	getstring(Node *p);
static String*	getaddr(Node *p);

extern int
default_from(message *mp)
{
	char *cp, *lp;

	cp = getenv("upasname");
	lp = getlog();
	if(lp == nil)
		return -1;

	if(cp &amp;&amp; *cp)
		s_append(mp-&gt;sender, cp);
	else
		s_append(mp-&gt;sender, lp);
	s_append(mp-&gt;date, thedate());
	return 0;
}

extern message *
m_new(void)
{
	message *mp;

	mp = (message *)mallocz(sizeof(message), 1);
	if (mp == 0) {
		perror("message:");
		exit(1);
	}
	mp-&gt;sender = s_new();
	mp-&gt;replyaddr = s_new();
	mp-&gt;date = s_new();
	mp-&gt;body = s_new();
	mp-&gt;size = 0;
	mp-&gt;fd = -1;
	return mp;
}

extern void
m_free(message *mp)
{
	if(mp-&gt;fd &gt;= 0){
		close(mp-&gt;fd);
		sysremove(s_to_c(mp-&gt;tmp));
		s_free(mp-&gt;tmp);
	}
	s_free(mp-&gt;sender);
	s_free(mp-&gt;date);
	s_free(mp-&gt;body);
	s_free(mp-&gt;havefrom);
	s_free(mp-&gt;havesender);
	s_free(mp-&gt;havereplyto);
	s_free(mp-&gt;havesubject);
	free((char *)mp);
}

/* read a message into a temp file, return an open fd to it in mp-&gt;fd */
static int
m_read_to_file(Biobuf *fp, message *mp)
{
	int fd;
	int n;
	String *file;
	char buf[4*1024];

	file = s_new();
	/*
	 *  create temp file to be removed on close
	 */
	abspath("mtXXXXXX", UPASTMP, file);
	mktemp(s_to_c(file));
	if((fd = syscreate(s_to_c(file), ORDWR|ORCLOSE, 0600))&lt;0){
		s_free(file);
		return -1;
	}
	mp-&gt;tmp = file;

	/*
	 *  read the rest into the temp file
	 */
	while((n = Bread(fp, buf, sizeof(buf))) &gt; 0){
		if(write(fd, buf, n) != n){
			close(fd);
			return -1;
		}
		mp-&gt;size += n;
		if(mp-&gt;size &gt; MSGLIMIT){
			mp-&gt;size = -1;
			break;
		}
	}

	mp-&gt;fd = fd;
	return 0;
}

/* get the first address from a node */
static String*
getaddr(Node *p)
{
	for(; p; p = p-&gt;next)
		if(p-&gt;s &amp;&amp; p-&gt;addr)
			return s_copy(s_to_c(p-&gt;s));
	return nil;
}

/* get the text of a header line minus the field name */
static String*
getstring(Node *p)
{
	String *s;

	s = s_new();
	if(p == nil)
		return s;

	for(p = p-&gt;next; p; p = p-&gt;next){
		if(p-&gt;s){
			s_append(s, s_to_c(p-&gt;s));
		}else{
			s_putc(s, p-&gt;c);
			s_terminate(s);
		}
		if(p-&gt;white)
			s_append(s, s_to_c(p-&gt;white));
	}
	return s;
}

static char *fieldname[] =
{
[WORD-WORD]	"WORD",
[DATE-WORD]	"DATE",
[RESENT_DATE-WORD]	"RESENT_DATE",
[RETURN_PATH-WORD]	"RETURN_PATH",
[FROM-WORD]	"FROM",
[SENDER-WORD]	"SENDER",
[REPLY_TO-WORD]	"REPLY_TO",
[RESENT_FROM-WORD]	"RESENT_FROM",
[RESENT_SENDER-WORD]	"RESENT_SENDER",
[RESENT_REPLY_TO-WORD]	"RESENT_REPLY_TO",
[SUBJECT-WORD]	"SUBJECT",
[TO-WORD]	"TO",
[CC-WORD]	"CC",
[BCC-WORD]	"BCC",
[RESENT_TO-WORD]	"RESENT_TO",
[RESENT_CC-WORD]	"RESENT_CC",
[RESENT_BCC-WORD]	"RESENT_BCC",
[REMOTE-WORD]	"REMOTE",
[PRECEDENCE-WORD]	"PRECEDENCE",
[MIMEVERSION-WORD]	"MIMEVERSION",
[CONTENTTYPE-WORD]	"CONTENTTYPE",
[MESSAGEID-WORD]	"MESSAGEID",
[RECEIVED-WORD]	"RECEIVED",
[MAILER-WORD]	"MAILER",
[BADTOKEN-WORD]	"BADTOKEN",
};

/* fix 822 addresses */
static void
rfc822cruft(message *mp)
{
	Field *f;
	Node *p;
	String *body, *s;
	char *cp;

	/*
	 *  parse headers in in-core part
	 */
	yyinit(s_to_c(mp-&gt;body), s_len(mp-&gt;body));
	mp-&gt;rfc822headers = 0;
	yyparse();
	mp-&gt;rfc822headers = 1;
	mp-&gt;received = received;

	/*
	 *  remove equivalent systems in all addresses
	 */
	body = s_new();
	cp = s_to_c(mp-&gt;body);
	for(f = firstfield; f; f = f-&gt;next){
		if(f-&gt;node-&gt;c == MIMEVERSION)
			mp-&gt;havemime = 1;
		if(f-&gt;node-&gt;c == FROM)
			mp-&gt;havefrom = getaddr(f-&gt;node);
		if(f-&gt;node-&gt;c == SENDER)
			mp-&gt;havesender = getaddr(f-&gt;node);
		if(f-&gt;node-&gt;c == REPLY_TO)
			mp-&gt;havereplyto = getaddr(f-&gt;node);
		if(f-&gt;node-&gt;c == TO)
			mp-&gt;haveto = 1;
		if(f-&gt;node-&gt;c == DATE)
			mp-&gt;havedate = 1;
		if(f-&gt;node-&gt;c == SUBJECT)
			mp-&gt;havesubject = getstring(f-&gt;node);
		if(f-&gt;node-&gt;c == PRECEDENCE &amp;&amp; f-&gt;node-&gt;next &amp;&amp; f-&gt;node-&gt;next-&gt;next){
			s = f-&gt;node-&gt;next-&gt;next-&gt;s;
			if(s &amp;&amp; (strcmp(s_to_c(s), "bulk") == 0
				|| strcmp(s_to_c(s), "Bulk") == 0))
					mp-&gt;bulk = 1;
		}
		for(p = f-&gt;node; p; p = p-&gt;next){
			if(p-&gt;s){
				if(p-&gt;addr){
					cp = skipequiv(s_to_c(p-&gt;s));
					s_append(body, cp);
				} else 
					s_append(body, s_to_c(p-&gt;s));
			}else{
				s_putc(body, p-&gt;c);
				s_terminate(body);
			}
			if(p-&gt;white)
				s_append(body, s_to_c(p-&gt;white));
			cp = p-&gt;end+1;
		}
		s_append(body, "\n");
	}

	if(*s_to_c(body) == 0){
		s_free(body);
		return;
	}

	if(*cp != '\n')
		s_append(body, "\n");
	s_memappend(body, cp, s_len(mp-&gt;body) - (cp - s_to_c(mp-&gt;body)));
	s_terminate(body);

	firstfield = 0;
	mp-&gt;size += s_len(body) - s_len(mp-&gt;body);
	s_free(mp-&gt;body);
	mp-&gt;body = body;
}

/* read in a message, interpret the 'From' header */
extern message *
m_read(Biobuf *fp, int rmail, int interactive)
{
	message *mp;
	Resub subexp[10];
	char *line;
	int first;
	int n;

	mp = m_new();

	/* parse From lines if remote */
	if (rmail) {
		/* get remote address */
		String *sender=s_new();

		if (rfprog == 0)
			rfprog = regcomp(REMFROMRE);
		first = 1;
		while(s_read_line(fp, s_restart(mp-&gt;body)) != 0) {
			memset(subexp, 0, sizeof(subexp));
			if (regexec(rfprog, s_to_c(mp-&gt;body), subexp, 10) == 0){
				if(first == 0)
					break;
				if (fprog == 0)
					fprog = regcomp(FROMRE);
				memset(subexp, 0, sizeof(subexp));
				if(regexec(fprog, s_to_c(mp-&gt;body), subexp,10) == 0)
					break;
				s_restart(mp-&gt;body);
				append_match(subexp, s_restart(sender), SENDERMATCH);
				append_match(subexp, s_restart(mp-&gt;date), DATEMATCH);
				break;
			}
			append_match(subexp, s_restart(sender), REMSENDERMATCH);
			append_match(subexp, s_restart(mp-&gt;date), REMDATEMATCH);
			if(subexp[REMSYSMATCH].sp!=subexp[REMSYSMATCH].ep){
				append_match(subexp, mp-&gt;sender, REMSYSMATCH);
				s_append(mp-&gt;sender, "!");
			}
			first = 0;
		}
		s_append(mp-&gt;sender, s_to_c(sender));

		s_free(sender);
	}
	if(*s_to_c(mp-&gt;sender)=='\0')
		default_from(mp);

	/* if sender address is unreturnable, treat message as bulk mail */
	if(!returnable(s_to_c(mp-&gt;sender)))
		mp-&gt;bulk = 1;

	/* get body */
	if(interactive &amp;&amp; !rmail){
		/* user typing on terminal: terminator == '.' or EOF */
		for(;;) {
			line = s_read_line(fp, mp-&gt;body);
			if (line == 0)
				break;
			if (strcmp(".\n", line)==0) {
				mp-&gt;body-&gt;ptr -= 2;
				*mp-&gt;body-&gt;ptr = '\0';
				break;
			}
		}
		mp-&gt;size = mp-&gt;body-&gt;ptr - mp-&gt;body-&gt;base;
	} else {
		/*
		 *  read up to VMLIMIT bytes (more or less) into main memory.
		 *  if message is longer put the rest in a tmp file.
		 */
		mp-&gt;size = mp-&gt;body-&gt;ptr - mp-&gt;body-&gt;base;
		n = s_read(fp, mp-&gt;body, VMLIMIT);
		if(n &lt; 0){
			perror("m_read");
			exit(1);
		}
		mp-&gt;size += n;
		if(n == VMLIMIT){
			if(m_read_to_file(fp, mp) &lt; 0){
				perror("m_read");
				exit(1);
			}
		}

	}

	/*
	 *  ignore 0 length messages from a terminal
	 */
	if (!rmail &amp;&amp; mp-&gt;size == 0)
		return 0;

	rfc822cruft(mp);

	return mp;
}

/* return a piece of message starting at `offset' */
extern int
m_get(message *mp, long offset, char **pp)
{
	static char buf[4*1024];

	/*
	 *  are we past eof?
	 */
	if(offset &gt;= mp-&gt;size)
		return 0;

	/*
	 *  are we in the virtual memory portion?
	 */
	if(offset &lt; s_len(mp-&gt;body)){
		*pp = mp-&gt;body-&gt;base + offset;
		return mp-&gt;body-&gt;ptr - mp-&gt;body-&gt;base - offset;
	}

	/*
	 *  read it from the temp file
	 */
	offset -= s_len(mp-&gt;body);
	if(mp-&gt;fd &lt; 0)
		return -1;
	if(seek(mp-&gt;fd, offset, 0)&lt;0)
		return -1;
	*pp = buf;
	return read(mp-&gt;fd, buf, sizeof buf);
}

/* output the message body without ^From escapes */
static int
m_noescape(message *mp, Biobuf *fp)
{
	long offset;
	int n;
	char *p;

	for(offset = 0; offset &lt; mp-&gt;size; offset += n){
		n = m_get(mp, offset, &amp;p);
		if(n &lt;= 0){
			Bflush(fp);
			return -1;
		}
		if(Bwrite(fp, p, n) &lt; 0)
			return -1;
	}
	return Bflush(fp);
}

/*
 *  Output the message body with '^From ' escapes.
 *  Ensures that any line starting with a 'From ' gets a ' ' stuck
 *  in front of it.
 */
static int
m_escape(message *mp, Biobuf *fp)
{
	char *p, *np;
	char *end;
	long offset;
	int m, n;
	char *start;

	for(offset = 0; offset &lt; mp-&gt;size; offset += n){
		n = m_get(mp, offset, &amp;start);
		if(n &lt; 0){
			Bflush(fp);
			return -1;
		}

		p = start;
		for(end = p+n; p &lt; end; p += m){
			np = memchr(p, '\n', end-p);
			if(np == 0){
				Bwrite(fp, p, end-p);
				break;
			}
			m = np - p + 1;
			if(m &gt; 5 &amp;&amp; strncmp(p, "From ", 5) == 0)
				Bputc(fp, ' ');
			Bwrite(fp, p, m);
		}
	}
	Bflush(fp);
	return 0;
}

static int
printfrom(message *mp, Biobuf *fp)
{
	String *s;
	int rv;

	if(!returnable(s_to_c(mp-&gt;sender)))
		return Bprint(fp, "From: Postmaster\n");

	s = username(mp-&gt;sender);
	if(s) {
		s_append(s, " &lt;");
		s_append(s, s_to_c(mp-&gt;sender));
		s_append(s, "&gt;");
	} else {
		s = s_copy(s_to_c(mp-&gt;sender));
	}
	s = unescapespecial(s);
	rv = Bprint(fp, "From: %s\n", s_to_c(s));
	s_free(s);
	return rv;
}

static char *
rewritezone(char *z)
{
	int mindiff;
	char s;
	Tm *tm;
	static char x[7];

	tm = localtime(time(0));
	mindiff = tm-&gt;tzoff/60;

	/* if not in my timezone, don't change anything */
	if(strcmp(tm-&gt;zone, z) != 0)
		return z;

	if(mindiff &lt; 0){
		s = '-';
		mindiff = -mindiff;
	} else
		s = '+';

	sprint(x, "%c%.2d%.2d", s, mindiff/60, mindiff%60);
	return x;
}

int
isutf8(String *s)
{
	char *p;
	
	for(p = s_to_c(s);  *p; p++)
		if(*p&amp;0x80)
			return 1;
	return 0;
}

void
printutf8mime(Biobuf *b)
{
	Bprint(b, "MIME-Version: 1.0\n");
	Bprint(b, "Content-Type: text/plain; charset=\"UTF-8\"\n");
	Bprint(b, "Content-Transfer-Encoding: 8bit\n");
}

/* output a message */
extern int
m_print(message *mp, Biobuf *fp, char *remote, int mbox)
{
	String *date, *sender;
	char *f[6];
	int n;

	sender = unescapespecial(s_clone(mp-&gt;sender));

	if (remote != 0){
		if(print_remote_header(fp,s_to_c(sender),s_to_c(mp-&gt;date),remote) &lt; 0){
			s_free(sender);
			return -1;
		}
	} else {
		if(print_header(fp, s_to_c(sender), s_to_c(mp-&gt;date)) &lt; 0){
			s_free(sender);
			return -1;
		}
	}
	s_free(sender);
	if(!rmail &amp;&amp; !mp-&gt;havedate){
		/* add a date: line Date: Sun, 19 Apr 1998 12:27:52 -0400 */
		date = s_copy(s_to_c(mp-&gt;date));
		n = getfields(s_to_c(date), f, 6, 1, " \t");
		if(n == 6)
			Bprint(fp, "Date: %s, %s %s %s %s %s\n", f[0], f[2], f[1],
			 f[5], f[3], rewritezone(f[4]));
	}
	if(!rmail &amp;&amp; !mp-&gt;havemime &amp;&amp; isutf8(mp-&gt;body))
		printutf8mime(fp);
	if(mp-&gt;to){
		/* add the to: line */
		if (Bprint(fp, "%s\n", s_to_c(mp-&gt;to)) &lt; 0)
			return -1;
		/* add the from: line */
		if (!mp-&gt;havefrom &amp;&amp; printfrom(mp, fp) &lt; 0)
			return -1;
		if(!mp-&gt;rfc822headers &amp;&amp; *s_to_c(mp-&gt;body) != '\n')
			if (Bprint(fp, "\n") &lt; 0)
				return -1;
	} else if(!rmail){
		/* add the from: line */
		if (!mp-&gt;havefrom &amp;&amp; printfrom(mp, fp) &lt; 0)
			return -1;
		if(!mp-&gt;rfc822headers &amp;&amp; *s_to_c(mp-&gt;body) != '\n')
			if (Bprint(fp, "\n") &lt; 0)
				return -1;
	}

	if (!mbox)
		return m_noescape(mp, fp);
	return m_escape(mp, fp);
}

/* print just the message body */
extern int
m_bprint(message *mp, Biobuf *fp)
{
	return m_noescape(mp, fp);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

