<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/audio/audio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/audio/audio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * USB audio driver for Plan 9
 * This needs a full rewrite.
 * As it is, it does not check for all errors,
 * mixes the audio data structures with the usb configuration,
 * may cross nil pointers, and is hard to debug and fix.
 * Also, it does not issue a dettach request to the endpoint
 * after the device is unplugged. This means that the old
 * endpoint would still be around until manually reclaimed.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "audio.h"
#include "audioctl.h"

#define STACKSIZE 16*1024

extern char* srvpost;
char * mntpt;

Channel *controlchan;

int verbose;
int setrec = 0;
int defaultspeed[2] = {44100, 44100};
Dev *buttondev;
Dev *epdev[2];

static void
audio_endpoint(Dev *, Desc *dd)
{
	byte *b = (uchar*)&amp;dd-&gt;data;
	int n = dd-&gt;data.bLength;
	char *hd;

	switch(b[2]){
	case 0x01:
		if(usbdebug){
			fprint(2, "CS_ENDPOINT for attributes 0x%x, lockdelayunits %d, lockdelay %#ux, ",
				b[3], b[4], b[5] | (b[6]&lt;&lt;8));
			if(b[3] &amp; has_setspeed)
				fprint(2, "has sampling-frequency control");
			else
				fprint(2, "does not have sampling-frequency control");
			if(b[3] &amp; 0x1&lt;&lt;1)
				fprint(2, ", has pitch control");
			else
				fprint(2, ", does not have pitch control");
			if(b[3] &amp; 0x1&lt;&lt;7)
				fprint(2, ", max packets only");
			fprint(2, "\n");
		}
		if(dd-&gt;conf == nil)
			sysfatal("conf == nil");
		if(dd-&gt;iface == nil)
			sysfatal("iface == nil");
		if(dd-&gt;altc == nil)
			sysfatal("alt == nil");
		if(dd-&gt;altc-&gt;aux == nil)
			dd-&gt;altc-&gt;aux= mallocz(sizeof(Audioalt),1);
		((Audioalt*)dd-&gt;altc-&gt;aux)-&gt;caps |= b[3];
		break;
	case 0x02:
		if(usbdebug){
			fprint(2, "CS_INTERFACE FORMAT_TYPE %d, channels %d, subframesize %d, resolution %d, freqtype %d, ",
				b[3], b[4], b[5], b[6], b[7]);
			fprint(2, "freq0 %d, freq1 %d\n",
				b[8] | (b[9]&lt;&lt;8) | (b[10]&lt;&lt;16), b[11] | (b[12]&lt;&lt;8) | (b[13]&lt;&lt;16));
		}
		break;
	default:
		if(usbdebug){
			hd = hexstr(b, n);
			fprint(2, "CS_INTERFACE: %s\n", hd);
			free(hd);
		}
	}
}

enum {
	None,
	Volumeset,
	Volumeget,
	Altset,
	Altget,
	Speedget,
};

void
controlproc(void *)
{
	/* Proc that looks after /dev/usb/%d/ctl */
	int i, nf;
	char *req, *args[8];
	Audiocontrol *c;
	long value[8];
	Channel *replchan;

	while(req = recvp(controlchan)){
		int rec;

		nf = tokenize(req, args, nelem(args));
		if(nf &lt; 3)
			sysfatal("controlproc: not enough arguments");
		replchan = (Channel*)strtol(args[0], nil, 0);
		if(strcmp(args[2], "playback") == 0)
			rec = Play;
		else if(strcmp(args[2], "record") == 0)
			rec = Record;
		else{
			/* illegal request */
			dprint(2, "%s must be record or playback", args[2]);
			if(replchan) chanprint(replchan, "%s must be record or playback", args[2]);
			free(req);
			continue;
		}
		c = nil;
		for(i = 0; i &lt; Ncontrol; i++){
			c = &amp;controls[rec][i];
			if(strcmp(args[1], c-&gt;name) == 0)
				break;
		}
		if(i == Ncontrol){
			dprint(2, "Illegal control name: %s", args[1]);
			if(replchan) chanprint(replchan, "Illegal control name: %s", args[1]);
		}else if(!c-&gt;settable){
			dprint(2, "%s %s is not settable", args[1], args[2]);
			if(replchan)
				chanprint(replchan, "%s %s is not settable", args[1], args[2]);
		}else if(nf &lt; 4){
			dprint(2, "insufficient arguments for %s %s", args[1], args[2]);
			if(replchan)
				chanprint(replchan, "insufficient arguments for %s %s",
					args[1], args[2]);
		}else if(ctlparse(args[3], c, value) &lt; 0){
			if(replchan)
				chanprint(replchan, "parse error in %s %s", args[1], args[2]);
		}else{
			dprint(2, "controlproc: setcontrol %s %s %s\n",
					rec?"in":"out", args[1], args[3]);
			if(setcontrol(rec, args[1], value) &lt; 0){
				if(replchan)
					chanprint(replchan, "setting %s %s failed", args[1], args[2]);
			}else{
				if(replchan) chanprint(replchan, "ok");
			}
			ctlevent();
		}
		free(req);
	}
}

void
buttonproc(void *)
{
	int	i, fd, b;
	char err[32];
	byte buf[1];
	Audiocontrol *c;

	fd = buttondev-&gt;dfd;

	c = &amp;controls[Play][Volume_control];
	for(;;){
		if((b = read(fd, buf, 1)) &lt; 0){
			rerrstr(err, sizeof err);
			if(strcmp(err, "interrupted") == 0){
				dprint(2, "read interrupted\n");
				continue;
			}
			sysfatal("read %s/data: %r", buttondev-&gt;dir);
		}
		if(b == 0 || buf[0] == 0){
			continue;
		}else if(buf[0] == 1){
			if(c-&gt;chans == 0)
				c-&gt;value[0] += c-&gt;step;
			else
				for(i = 1; i &lt; 8; i++)
					if(c-&gt;chans &amp; 1 &lt;&lt; i)
						c-&gt;value[i] += c-&gt;step;
			chanprint(controlchan, "0 volume playback %A", c);
		}else if(buf[0] == 2){
			if(c-&gt;chans == 0)
				c-&gt;value[0] -= c-&gt;step;
			else
				for(i = 1; i &lt; 8; i++)
					if(c-&gt;chans &amp; 1 &lt;&lt; i)
						c-&gt;value[i] -= c-&gt;step;
			chanprint(controlchan, "0 volume playback %A", c);
		}else if(usbdebug){
			fprint(2, "button");
			for(i = 0; i &lt; b; i++)
				fprint(2, " %#2.2x", buf[i]);
			fprint(2, "\n");
		}
	}
}


void
usage(void)
{
	fprint(2, "usage: usbaudio [-dpV] [-N nb] [-m mountpoint] [-s srvname] "
		"[-v volume] [dev]\n");
	threadexitsall("usage");
}

void
threadmain(int argc, char **argv)
{
	char *devdir;
	int i;
	long value[8], volume[8];
	Audiocontrol *c;
	char *p;
	extern int attachok;
	Ep *ep;
	int csps[] = { Audiocsp, 0};

	devdir = nil;
	volume[0] = Undef;
	for(i = 0; i&lt;8; i++)
		value[i] = 0;
	fmtinstall('A', Aconv);
	fmtinstall('U', Ufmt);
	quotefmtinstall();

	ARGBEGIN{
	case 'N':
		p = EARGF(usage());	/* ignore dev nb */
		break;
	case 'd':
		usbdebug++;
		verbose++;
		break;
	case 'm':
		mntpt = EARGF(usage());
		break;
	case 'p':
		attachok++;
		break;
	case 's':
		srvpost = EARGF(usage());
		break;
	case 'v':
		volume[0] = strtol(EARGF(usage()), &amp;p, 0);
		for(i = 1; i &lt; 8; i++)
			volume[i] = volume[0];
		break;
	case 'V':
		verbose++;
		break;
	default:
		usage();
	}ARGEND
	switch(argc){
	case 0:
		break;
	case 1:
		devdir = argv[0];
		break;
	default:
		usage();
	}
	if(devdir == nil)
		if(finddevs(matchdevcsp, csps, &amp;devdir, 1) &lt; 1){
			fprint(2, "No usb audio\n");
			threadexitsall("usbaudio not found");
		}
	ad = opendev(devdir);
	if(ad == nil)
		sysfatal("opendev: %r");
	if(configdev(ad) &lt; 0)
		sysfatal("configdev: %r");
	
	for(i = 0; i &lt; nelem(ad-&gt;usb-&gt;ddesc); i++)
		if(ad-&gt;usb-&gt;ddesc[i] != nil)
		switch(ad-&gt;usb-&gt;ddesc[i]-&gt;data.bDescriptorType){
		case AUDIO_INTERFACE:
			audio_interface(ad, ad-&gt;usb-&gt;ddesc[i]);
			break;
		case AUDIO_ENDPOINT:
			audio_endpoint(ad, ad-&gt;usb-&gt;ddesc[i]);
			break;
		}

	controlchan = chancreate(sizeof(char*), 8);

	for(i = 0; i &lt; nelem(ad-&gt;usb-&gt;ep); i++)
		if((ep = ad-&gt;usb-&gt;ep[i]) != nil){
			if(ep-&gt;iface-&gt;csp == CSP(Claudio, 2, 0) &amp;&amp; ep-&gt;dir == Eout)
				endpt[0] = ep-&gt;id;
			if(ep-&gt;iface-&gt;csp == CSP(Claudio, 2, 0) &amp;&amp; ep-&gt;dir == Ein)
				endpt[1] = ep-&gt;id;
			if(buttonendpt&lt;0 &amp;&amp; Class(ep-&gt;iface-&gt;csp) == Clhid)
				buttonendpt = ep-&gt;id;
		}
	if(endpt[0] != -1){
		if(verbose)
			fprint(2, "usb/audio: playback on ep %d\n", endpt[0]);
		interface[0] = ad-&gt;usb-&gt;ep[endpt[0]]-&gt;iface-&gt;id;
	}
	if(endpt[1] != -1){
		if(verbose)
			fprint(2, "usb/audio: record on ep %d\n", endpt[0]);
		interface[1] = ad-&gt;usb-&gt;ep[endpt[1]]-&gt;iface-&gt;id;
	}
	if(verbose &amp;&amp; buttonendpt &gt;= 0)
		fprint(2, "usb/audio: buttons on ep %d\n", buttonendpt);

	if(endpt[Play] &gt;= 0){
		if(verbose)
			fprint(2, "Setting default play parameters: %d Hz, %d channels at %d bits\n",
				defaultspeed[Play], 2, 16);
		if(findalt(Play, 2, 16, defaultspeed[Play]) &lt; 0){
			if(findalt(Play, 2, 16, 48000) &lt; 0)
				sysfatal("Can't configure playout for %d or %d Hz", defaultspeed[Play], 48000);
			fprint(2, "Warning, can't configure playout for %d Hz, configuring for %d Hz instead\n",
				defaultspeed[Play], 48000);
			defaultspeed[Play] = 48000;
		}
		value[0] = 2;
		if(setcontrol(Play, "channels", value) == Undef)
			sysfatal("Can't set play channels");
		value[0] = 16;
		if(setcontrol(Play, "resolution", value) == Undef)
			sysfatal("Can't set play resolution");
	}

	if(endpt[Record] &gt;= 0){
		setrec = 1;
		if(verbose)
			fprint(2, "Setting default record parameters: "
				"%d Hz, %d channels at %d bits\n",
				defaultspeed[Record], 2, 16);
		i = 2;
		while(findalt(Record, i, 16, defaultspeed[Record]) &lt; 0)
			if(i == 2 &amp;&amp; controls[Record][Channel_control].max == 1){
				fprint(2, "Warning, can't configure stereo "
					"recording, configuring mono instead\n");
				i = 1;
			}else
				break;
		if(findalt(Record, i, 16, 48000) &lt; 0){
			endpt[Record] = -1;	/* disable recording */
			setrec = 0;
			fprint(2, "Warning, can't configure record for %d Hz or %d Hz\n",
				defaultspeed[Record], 48000);
		}else
			fprint(2, "Warning, can't configure record for %d Hz, "
				"configuring for %d Hz instead\n",
				defaultspeed[Record], 48000);
		defaultspeed[Record] = 48000;
		if(setrec){
			value[0] = i;
			if(setcontrol(Record, "channels", value) == Undef)
				sysfatal("Can't set record channels");
			value[0] = 16;
			if(setcontrol(Record, "resolution", value) == Undef)
				sysfatal("Can't set record resolution");
		}
	}

	getcontrols();	/* Get the initial value of all controls */
	value[0] = defaultspeed[Play];
	if(endpt[Play] &gt;= 0 &amp;&amp; setcontrol(Play, "speed", value) &lt; 0)
		sysfatal("can't set play speed");
	value[0] = defaultspeed[Record];
	if(endpt[Record] &gt;= 0 &amp;&amp; setcontrol(Record, "speed", value) &lt; 0)
		fprint(2, "%s: can't set record speed\n", argv0);
	value[0] = 0;
	setcontrol(Play, "mute", value);

	if(volume[0] != Undef){
		c = &amp;controls[Play][Volume_control];
		if(*p == '%' &amp;&amp; c-&gt;min != Undef)
			for(i = 0; i &lt; 8; i++)
				volume[i] = (volume[i]*c-&gt;max + (100-volume[i])*c-&gt;min)/100;
		if(c-&gt;settable)
			setcontrol(Play, "volume", volume);
		c = &amp;controls[Record][Volume_control];
		if(c-&gt;settable &amp;&amp; setrec)
			setcontrol(Record, "volume", volume);
	}

	if(buttonendpt &gt; 0){
		buttondev = openep(ad, buttonendpt);
		if(buttondev == nil)
			sysfatal("openep: buttons: %r");
		if(opendevdata(buttondev, OREAD) &lt; 0)
			sysfatal("open buttons fd: %r");
		proccreate(buttonproc, nil, STACKSIZE);
	}
	proccreate(controlproc, nil, STACKSIZE);
	proccreate(serve, nil, STACKSIZE);

	threadexits(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

