<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/ether/smsc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/ether/smsc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * SMSC LAN95XX
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "usbfs.h"
#include "ether.h"

enum {
	Doburst		= 1,
	Resettime	= 1000,
	E2pbusytime	= 1000,
	Afcdefault	= 0xF830A1,
//	Hsburst		= 37,	/* from original linux driver */
	Hsburst		= 8,
	Fsburst		= 129,
	Defbulkdly	= 0x2000,

	Ethp8021q	= 0x8100,
	MACoffset 	= 1,
	PHYinternal	= 1,
	Rxerror		= 0x8000,
	Txfirst		= 0x2000,
	Txlast		= 0x1000,

	/* USB vendor requests */
	Writereg	= 0xA0,
	Readreg		= 0xA1,

	/* device registers */
	Intsts		= 0x08,
	Txcfg		= 0x10,
		Txon	= 1&lt;&lt;2,
	Hwcfg		= 0x14,
		Bir	= 1&lt;&lt;12,
		Rxdoff	= 3&lt;&lt;9,
		Mef	= 1&lt;&lt;5,
		Lrst	= 1&lt;&lt;3,
		Bce	= 1&lt;&lt;1,
	Pmctrl		= 0x20,
		Phyrst	= 1&lt;&lt;4,
	Ledgpio		= 0x24,
		Ledspd	= 1&lt;&lt;24,
		Ledlnk	= 1&lt;&lt;20,
		Ledfdx	= 1&lt;&lt;16,
	Afccfg		= 0x2C,
	E2pcmd		= 0x30,
		Busy	= 1&lt;&lt;31,
		Timeout	= 1&lt;&lt;10,
		Read	= 0,
	E2pdata		= 0x34,
	Burstcap	= 0x38,
	Intepctl	= 0x68,
		Phyint	= 1&lt;&lt;15,
	Bulkdelay	= 0x6C,
	Maccr		= 0x100,
		Mcpas	= 1&lt;&lt;19,
		Prms	= 1&lt;&lt;18,
		Hpfilt	= 1&lt;&lt;13,
		Txen	= 1&lt;&lt;3,
		Rxen	= 1&lt;&lt;2,
	Addrh		= 0x104,
	Addrl		= 0x108,
	Hashh		= 0x10C,
	Hashl		= 0x110,
	MIIaddr		= 0x114,
		MIIwrite= 1&lt;&lt;1,
		MIIread	= 0&lt;&lt;1,
		MIIbusy	= 1&lt;&lt;0,
	MIIdata		= 0x118,
	Flow		= 0x11C,
	Vlan1		= 0x120,
	Coecr		= 0x130,
		Txcoe	= 1&lt;&lt;16,
		Rxcoemd	= 1&lt;&lt;1,
		Rxcoe	= 1&lt;&lt;0,

	/* MII registers */
	Bmcr		= 0,
		Bmcrreset= 1&lt;&lt;15,
		Speed100= 1&lt;&lt;13,
		Anenable= 1&lt;&lt;12,
		Anrestart= 1&lt;&lt;9,
		Fulldpx	= 1&lt;&lt;8,
	Bmsr		= 1,
	Advertise	= 4,
		Adcsma	= 0x0001,
		Ad10h	= 0x0020,
		Ad10f	= 0x0040,
		Ad100h	= 0x0080,
		Ad100f	= 0x0100,
		Adpause	= 0x0400,
		Adpauseasym= 0x0800,
		Adall	= Ad10h|Ad10f|Ad100h|Ad100f,
	Phyintsrc	= 29,
	Phyintmask	= 30,
		Anegcomp= 1&lt;&lt;6,
		Linkdown= 1&lt;&lt;4,
};

static int
wr(Dev *d, int reg, int val)
{
	int ret;

	ret = usbcmd(d, Rh2d|Rvendor|Rdev, Writereg, 0, reg,
		(uchar*)&amp;val, sizeof(val));
	if(ret &lt; 0)
		deprint(2, "%s: wr(%x, %x): %r", argv0, reg, val);
	return ret;
}

static int
rr(Dev *d, int reg)
{
	int ret, rval;

	ret = usbcmd(d, Rd2h|Rvendor|Rdev, Readreg, 0, reg,
		(uchar*)&amp;rval, sizeof(rval));
	if(ret &lt; 0){
		fprint(2, "%s: rr(%x): %r", argv0, reg);
		return 0;
	}
	return rval;
}

static int
miird(Dev *d, int idx)
{
	while(rr(d, MIIaddr) &amp; MIIbusy)
		;
	wr(d, MIIaddr, PHYinternal&lt;&lt;11 | idx&lt;&lt;6 | MIIread);
	while(rr(d, MIIaddr) &amp; MIIbusy)
		;
	return rr(d, MIIdata);
}

static void
miiwr(Dev *d, int idx, int val)
{
	while(rr(d, MIIaddr) &amp; MIIbusy)
		;
	wr(d, MIIdata, val);
	wr(d, MIIaddr, PHYinternal&lt;&lt;11 | idx&lt;&lt;6 | MIIwrite);
	while(rr(d, MIIaddr) &amp; MIIbusy)
		;
}

static int
eepromr(Dev *d, int off, uchar *buf, int len)
{
	int i, v;

	for(i = 0; i &lt; E2pbusytime; i++)
		if((rr(d, E2pcmd) &amp; Busy) == 0)
			break;
	if(i == E2pbusytime)
		return -1;
	for(i = 0; i &lt; len; i++){
		wr(d, E2pcmd, Busy|Read|(i+off));
		while((v = rr(d, E2pcmd) &amp; (Busy|Timeout)) == Busy)
			;
		if(v &amp; Timeout)
			return -1;
		buf[i] = rr(d, E2pdata);
	}
	return 0;
}

static void
phyinit(Dev *d)
{
	int i;

	miiwr(d, Bmcr, Bmcrreset|Anenable);
	for(i = 0; i &lt; Resettime/10; i++){
		if((miird(d, Bmcr) &amp; Bmcrreset) == 0)
			break;
		sleep(10);
	}
	miiwr(d, Advertise, Adcsma|Adall|Adpause|Adpauseasym);
//	miiwr(d, Advertise, Adcsma|Ad10f|Ad10h|Adpause|Adpauseasym);
	miird(d, Phyintsrc);
	miiwr(d, Phyintmask, Anegcomp|Linkdown);
	miiwr(d, Bmcr, miird(d, Bmcr)|Anenable|Anrestart);
}


static int
doreset(Dev *d, int reg, int bit)
{
	int i;

	if(wr(d, reg, bit) &lt; 0)
		return -1;
	for(i = 0; i &lt; Resettime/10; i++){
		 if((rr(d, reg) &amp; bit) == 0)
			return 1;
		sleep(10);
	}
	return 0;
}

static int
getmac(Dev *d, uchar buf[])
{
	int i;
	uchar ea[Eaddrlen];

	if(eepromr(d, MACoffset, ea, Eaddrlen) &lt; 0)
		return -1;
	for(i = 0; i &lt; Eaddrlen; i++)
		if(ea[i] != 0 &amp;&amp; ea[i] != 0xFF){
			memmove(buf, ea, Eaddrlen);
			break;
		}
	return Eaddrlen;
}

static int
smscinit(Ether *ether)
{
	Dev *d;

	if(ether-&gt;cid != S95xx)
		return -1;
	d = ether-&gt;dev;
	deprint(2, "%s: setting up SMSC95XX\n", argv0);
	if(!doreset(d, Hwcfg, Lrst) || !doreset(d, Pmctrl, Phyrst))
		return -1;
	if(getmac(d, ether-&gt;addr) &lt; 0)
		return -1;
	wr(d, Addrl, GET4(ether-&gt;addr));
	wr(d, Addrh, GET2(ether-&gt;addr+4));
	if(Doburst){
		wr(d, Hwcfg, (rr(d,Hwcfg)&amp;~Rxdoff)|Bir|Mef|Bce);
		wr(d, Burstcap, Hsburst);
	}else{
		wr(d, Hwcfg, (rr(d,Hwcfg)&amp;~(Rxdoff|Mef|Bce))|Bir);
		wr(d, Burstcap, 0);
	}
	wr(d, Bulkdelay, Defbulkdly);
	wr(d, Intsts, ~0);
	wr(d, Ledgpio, Ledspd|Ledlnk|Ledfdx);
	wr(d, Flow, 0);
	wr(d, Afccfg, Afcdefault);
	wr(d, Vlan1, Ethp8021q);
	wr(d, Coecr, rr(d,Coecr)&amp;~(Txcoe|Rxcoe)); /* TODO could offload checksums? */

	wr(d, Hashh, 0);
	wr(d, Hashl, 0);
	wr(d, Maccr, rr(d,Maccr)&amp;~(Prms|Mcpas|Hpfilt));

	phyinit(d);

	wr(d, Intepctl, rr(d, Intepctl)|Phyint);
	wr(d, Maccr, rr(d, Maccr)|Txen|Rxen);
	wr(d, Txcfg, Txon);

	return 0;
}

static long
smscbread(Ether *e, Buf *bp)
{
	uint hd;
	int n, m;
	Buf *rbp;

	rbp = e-&gt;aux;
	if(rbp-&gt;ndata &lt; 4){
		rbp-&gt;rp = rbp-&gt;data;
		rbp-&gt;ndata = read(e-&gt;epin-&gt;dfd, rbp-&gt;rp, Doburst? Hsburst*512:
			Maxpkt);
		if(rbp-&gt;ndata &lt; 0)
			return -1;
	}
	if(rbp-&gt;ndata &lt; 4){
		werrstr("short frame");
		fprint(2, "smsc short frame %d bytes\n", rbp-&gt;ndata);
		return 0;
	}
	hd = GET4(rbp-&gt;rp);
	n = hd &gt;&gt; 16;
	m = (n + 4 + 3) &amp; ~3;
	if(n &lt; 6 || m &gt; rbp-&gt;ndata){
		werrstr("frame length");
		fprint(2, "smsc length error packet %d buf %d\n", n, rbp-&gt;ndata);
		rbp-&gt;ndata = 0;
		return 0;
	}
	if(hd &amp; Rxerror){
		fprint(2, "smsc rx error %8.8ux\n", hd);
		n = 0;
	}else{
		bp-&gt;rp = bp-&gt;data + Hdrsize;
		memmove(bp-&gt;rp, rbp-&gt;rp+4, n);
	}
	bp-&gt;ndata = n;
	rbp-&gt;rp += m;
	rbp-&gt;ndata -= m;
	return n;
}

static long
smscbwrite(Ether *e, Buf *bp)
{
	int n;

	n = bp-&gt;ndata &amp; 0x7FF;
	bp-&gt;rp -= 8;
	bp-&gt;ndata += 8;
	PUT4(bp-&gt;rp, n | Txfirst | Txlast);
	PUT4(bp-&gt;rp+4, n);
	n = write(e-&gt;epout-&gt;dfd, bp-&gt;rp, bp-&gt;ndata);
	return n;
}

static int
smscpromiscuous(Ether *e, int on)
{
	USED(on, e);
#ifdef TODO		/* copied from asix */
	int rxctl;

	deprint(2, "%s: smscpromiscuous %d\n", argv0, on);
	rxctl = getrxctl(e-&gt;dev);
	if(on != 0)
		rxctl |= Rxctlprom;
	else
		rxctl &amp;= ~Rxctlprom;
	return wr(e-&gt;dev, Cwrxctl, rxctl);
#endif
	return -1;
}

static int
smscmulticast(Ether *e, uchar *addr, int on)
{
	USED(addr, on, e);
#ifdef TODO		/* needed for ipv6; copied from asix */
	int rxctl;

	/* BUG: should write multicast filter */
	rxctl = getrxctl(e-&gt;dev);
	if(e-&gt;nmcasts != 0)
		rxctl |= Rxctlamall;
	else
		rxctl &amp;= ~Rxctlamall;
	deprint(2, "%s: smscmulticast %d\n", argv0, e-&gt;nmcasts);
	return wr(e-&gt;dev, Cwrxctl, rxctl);
#endif
	return -1;
}

static void
smscfree(Ether *ether)
{
	free(ether-&gt;aux);
	ether-&gt;aux = nil;
}

int
smscreset(Ether *ether)
{
	Cinfo *ip;
	Dev *dev;

	dev = ether-&gt;dev;
	for(ip = cinfo; ip-&gt;vid != 0; ip++)
		if(ip-&gt;vid == dev-&gt;usb-&gt;vid &amp;&amp; ip-&gt;did == dev-&gt;usb-&gt;did){
			ether-&gt;cid = ip-&gt;cid;
			if(smscinit(ether) &lt; 0){
				deprint(2, "%s: smsc init failed: %r\n", argv0);
				return -1;
			}
			deprint(2, "%s: smsc reset done\n", argv0);
			ether-&gt;name = "smsc";
			if(Doburst){
				ether-&gt;bufsize = Hsburst*512;
				ether-&gt;aux = emallocz(sizeof(Buf) +
					ether-&gt;bufsize - Maxpkt, 1);
			}else{
				ether-&gt;bufsize = Maxpkt;
				ether-&gt;aux = emallocz(sizeof(Buf), 1);
			}
			ether-&gt;free = smscfree;
			ether-&gt;bread = smscbread;
			ether-&gt;bwrite = smscbwrite;
			ether-&gt;promiscuous = smscpromiscuous;
			ether-&gt;multicast = smscmulticast;
			ether-&gt;mbps = 100;	/* BUG */
			return 0;
		}
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

