<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/devs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/devs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"

typedef struct Parg Parg;

enum {
	Ndevs = 32,
	Arglen = 500,
	Nargs = 64,
	Stack = 16 * 1024,
};

struct Parg {
	char*	args;
	Dev*	dev;
	int 	(*f)(Dev*,int,char**);
	Channel*rc;
};

static void
workproc(void *a)
{
	Parg *pa;
	char args[Arglen];
	char *argv[Nargs];
	int argc;
	Channel *rc;
	Dev *d;
	int (*f)(Dev*,int,char**);

	pa = a;
	threadsetname("workproc %s", pa-&gt;dev-&gt;dir);
	strecpy(args, args+sizeof(args), pa-&gt;args);	/* don't leak */
	d = pa-&gt;dev;
	f = pa-&gt;f;
	rc = pa-&gt;rc;
	free(pa-&gt;args);
	free(pa);
	argc = tokenize(args, argv, nelem(argv)-1);
	argv[argc] = nil;
	if(f(d, argc, argv) &lt; 0){
		closedev(d);
		fprint(2, "%s: devmain: %r\n", argv0);
		sendul(rc, -1);
		threadexits("devmain: %r");
	}
	sendul(rc, 0);
	threadexits(nil);
	
}

int
matchdevcsp(char *info, void *a)
{
	char sbuf[40];
	int *csps;

	csps = a;
	for(; *csps != 0; csps++){
		snprint(sbuf, sizeof(sbuf), "csp %#08ux", *csps);
		if(strstr(info, sbuf) != nil)
			return 0;
	}
	return -1;
}

int
finddevs(int (*matchf)(char*,void*), void *farg, char** dirs, int ndirs)
{
	int fd, i, n, nd, nr;
	char *nm;
	char dbuf[512], fbuf[40];
	Dir *d;

	fd = open("/dev/usb", OREAD);
	if(fd &lt; 0)
		sysfatal("/dev/usb: %r");
	nd = dirreadall(fd, &amp;d);
	close(fd);
	if(nd &lt; 2)
		sysfatal("/dev/usb: no devs");
	for(i = n = 0; i &lt; nd &amp;&amp; n &lt; ndirs; i++){
		nm = d[i].name;
		if(strcmp(nm, "ctl") == 0 || strstr(nm, ".0") == nil)
			continue;
		snprint(fbuf, sizeof(fbuf), "/dev/usb/%s/ctl", nm);
		fd = open(fbuf, OREAD);
		if(fd &lt; 0)
			continue;	/* may be gone */
		nr = read(fd, dbuf, sizeof(dbuf)-1);
		close(fd);
		if(nr &lt; 0)
			continue;
		dbuf[nr] = 0;
		if(strstr(dbuf, "enabled ") != nil &amp;&amp; strstr(dbuf, " busy") == nil)
			if(matchf(dbuf, farg) == 0)
				dirs[n++] = smprint("/dev/usb/%s", nm);
	}
	free(d);
	if(usbdebug &gt; 1)
		for(nd = 0; nd &lt; n; nd++)
			fprint(2, "finddevs: %s\n", dirs[nd]);
	return n;
}

void
startdevs(char *args, char *argv[], int argc, int (*mf)(char*, void*),
	void *ma, int (*df)(Dev*, int, char**))
{
	int i, ndirs, ndevs;
	char *dirs[Ndevs];
	char **dp;
	Parg *parg;
	Dev *dev;
	Channel *rc;

	if(access("/dev/usb", AEXIST) &lt; 0 &amp;&amp; bind("#u", "/dev", MBEFORE) &lt; 0)
		sysfatal("#u: %r");

	if(argc &gt; 0){
		ndirs = argc;
		dp = argv;
	}else{
		dp = dirs;
		ndirs = finddevs(mf, ma, dp, Ndevs);
		if(ndirs == nelem(dirs))
			fprint(2, "%s: too many devices\n", argv0);
	}
	ndevs = 0;
	rc = chancreate(sizeof(ulong), 0);
	if(rc == nil)
		sysfatal("no memory");
	for(i = 0; i &lt; ndirs; i++){
		fprint(2, "%s: startdevs: opening #%d %s\n", argv0, i, dp[i]);
		dev = opendev(dp[i]);
		if(dev == nil)
			fprint(2, "%s: %s: %r\n", argv0, dp[i]);
		else if(configdev(dev) &lt; 0){
			fprint(2, "%s: %s: config: %r\n", argv0, dp[i]);
			closedev(dev);
		}else{
			dprint(2, "%s: %U", argv0, dev);
			parg = emallocz(sizeof(Parg), 0);
			parg-&gt;args = estrdup(args);
			parg-&gt;dev = dev;
			parg-&gt;rc = rc;
			parg-&gt;f = df;
			proccreate(workproc, parg, Stack);
			if(recvul(rc) == 0)
				ndevs++;
		}
		if(dp != argv)
			free(dirs[i]);
	}
	chanfree(rc);
	if(ndevs == 0)
		sysfatal("no unhandled devices found");
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

