<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Framework for USB devices that provide a file tree.
 * The main process (usbd or the driver's main proc)
 * calls fsinit() to start FS operation.
 *
 * One or more drivers call fsstart/fsend to register
 * or unregister their operations for their subtrees.
 *
 * root dir has qids with 0 in high 32 bits.
 * for other files we keep the device id in there.
 * The low 32 bits for directories at / must be 0.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include "usb.h"
#include "usbfs.h"

#undef dprint
#define dprint if(usbfsdebug)fprint

typedef struct Rpc Rpc;

enum
{
	Nproc = 3,		/* max nb. of cached FS procs */

	Nofid = ~0,		/* null value for fid number */
	Notag = ~0,		/* null value for tags */
	Dietag = 0xdead,		/* fake tag to ask outproc to die */

	Stack = 16 * 1024,

	/* Fsproc requests */
	Run = 0,		/* call f(r) */
	Exit,			/* terminate */

};

struct Rpc
{
	Fcall	t;
	Fcall	r;
	Fid*	fid;
	int	flushed;
	Rpc*	next;
	char	data[Bufsize];
};

int usbfsdebug;

char Enotfound[] = "file not found";
char Etoosmall[] = "parameter too small";
char Eio[] = "i/o error";
char Eperm[] = "permission denied";
char Ebadcall[] = "unknown fs call";
char Ebadfid[] = "fid not found";
char Einuse[] = "fid already in use";
char Eisopen[] = "it is already open";
char Ebadctl[] = "unknown control request";

static char *user;
static ulong epoch;
static ulong msgsize = Msgsize;
static int fsfd = -1;
static Channel *outc;	/* of Rpc* */

static QLock rpclck;	/* protect vars in this block */
static Fid *freefids;
static Fid *fids;
static Rpc *freerpcs;
static Rpc *rpcs;

static Channel*procc;
static Channel*endc;

static Usbfs* fsops;

static void fsioproc(void*);

static void
schedproc(void*)
{
	Channel *proc[Nproc];
	int nproc;
	Channel *p;

	Alt a[] =
	{
		{procc, &amp;proc[0], CHANSND},
		{endc, &amp;p, CHANRCV},
		{nil, nil, CHANEND}
	};
	memset(proc, 0, sizeof(proc));
	nproc = 0;
	for(;;){
		if(nproc == 0){
			proc[0] = chancreate(sizeof(Rpc*), 0);
			proccreate(fsioproc, proc[0], Stack);
			nproc++;
		}
		switch(alt(a)){
		case 0:
			proc[0] = nil;
			if(nproc &gt; 1){
				proc[0] = proc[nproc-1];
				proc[nproc-1] = nil;
			}
			nproc--;
			break;
		case 1:
			if(nproc &lt; nelem(proc))
				proc[nproc++] = p;
			else
				sendp(p, nil);
			break;
		default:
			sysfatal("alt");
		}
	}
}

static void
dump(void)
{
	Rpc *rpc;
	Fid *fid;

	qlock(&amp;rpclck);
	fprint(2, "dump:\n");
	for(rpc = rpcs; rpc != nil; rpc = rpc-&gt;next)
		fprint(2, "rpc %#p %F next %#p\n", rpc, &amp;rpc-&gt;t, rpc-&gt;next);
	for(fid = fids; fid != nil; fid = fid-&gt;next)
		fprint(2, "fid %d qid %#llux omode %d aux %#p\n",
			fid-&gt;fid, fid-&gt;qid.path, fid-&gt;omode, fid-&gt;aux);
	fprint(2, "\n");
	qunlock(&amp;rpclck);
}

static Rpc*
newrpc(void)
{
	Rpc *r;

	qlock(&amp;rpclck);
	r = freerpcs;
	if(r != nil)
		freerpcs = r-&gt;next;
	else
		r = emallocz(sizeof(Rpc), 0);
	r-&gt;next = rpcs;
	rpcs = r;
	r-&gt;t.tag = r-&gt;r.tag = Notag;
	r-&gt;t.fid = r-&gt;r.fid = Nofid;
	r-&gt;t.type = r-&gt;r.type = 0;
	r-&gt;flushed = 0;
	r-&gt;fid = nil;
	r-&gt;r.data = (char*)r-&gt;data;
	qunlock(&amp;rpclck);
	return r;
}

static void
freerpc(Rpc *r)
{
	Rpc **l;
	if(r == nil)
		return;
	qlock(&amp;rpclck);
	for(l = &amp;rpcs; *l != nil &amp;&amp; *l != r; l = &amp;(*l)-&gt;next)
		;
	assert(*l == r);
	*l = r-&gt;next;
	r-&gt;next = freerpcs;
	freerpcs = r;
	r-&gt;t.type = 0;
	r-&gt;t.tag = 0x77777777;
	qunlock(&amp;rpclck);
}

static void
flushrpc(int tag)
{
	Rpc *r;

	qlock(&amp;rpclck);
	for(r = rpcs; r != nil; r = r-&gt;next)
		if(r-&gt;t.tag == tag){
			r-&gt;flushed = 1;
			break;
		}
	qunlock(&amp;rpclck);
}

static Fid*
getfid(int fid, int alloc)
{
	Fid *f;

	qlock(&amp;rpclck);
	for(f = fids; f != nil &amp;&amp; f-&gt;fid != fid; f = f-&gt;next)
		;
	if(f != nil &amp;&amp; alloc != 0){	/* fid in use */
		qunlock(&amp;rpclck);
		return nil;
	}
	if(f == nil &amp;&amp; alloc != 0){
		if(freefids != nil){
			f = freefids;
			freefids = freefids-&gt;next;
		}else
			f = emallocz(sizeof(Fid), 1);
		f-&gt;fid = fid;
		f-&gt;aux = nil;
		f-&gt;omode = ONONE;
		f-&gt;next = fids;
		fids = f;
	}
	qunlock(&amp;rpclck);
	return f;
}

static void
freefid(Fid *f)
{
	Fid **l;

	if(f == nil)
		return;
	if(fsops-&gt;clunk != nil)
		fsops-&gt;clunk(fsops, f);
	qlock(&amp;rpclck);
	for(l = &amp;fids; *l != nil &amp;&amp; *l != f; l = &amp;(*l)-&gt;next)
		;
	assert(*l == f);
	*l = f-&gt;next;
	f-&gt;next = freefids;
	freefids = f;
	qunlock(&amp;rpclck);
}

static Rpc*
fserror(Rpc *rpc, char* fmt, ...)
{
	va_list arg;
	char *c;

	va_start(arg, fmt);
	c = (char*)rpc-&gt;data;
	vseprint(c, c+sizeof(rpc-&gt;data), fmt, arg);
	va_end(arg);
	rpc-&gt;r.type = Rerror;
	rpc-&gt;r.ename = (char*)rpc-&gt;data;
	return rpc;
}

static Rpc*
fsversion(Rpc *r)
{
	if(r-&gt;t.msize &lt; 256)
		return fserror(r, Etoosmall);
	if(strncmp(r-&gt;t.version, "9P2000", 6) != 0)
		return fserror(r, "wrong version");
	if(r-&gt;t.msize &lt; msgsize)
		msgsize = r-&gt;t.msize;
	r-&gt;r.msize = msgsize;
	r-&gt;r.version = "9P2000";
	return r;
}

static Rpc*
fsattach(Rpc *r)
{
	static int already;

	/* Reload user because at boot it could be still none */
	user=getuser();
	if(already++ &gt; 0 &amp;&amp; strcmp(r-&gt;t.uname, user) != 0)
		return fserror(r, Eperm);
	if(r-&gt;fid == nil)
		return fserror(r, Einuse);

	r-&gt;r.qid.type = QTDIR;
	r-&gt;r.qid.path = fsops-&gt;qid;
	r-&gt;r.qid.vers = 0;
	r-&gt;fid-&gt;qid = r-&gt;r.qid;
	return r;
}

static Rpc*
fswalk(Rpc *r)
{
	int i;
	Fid *nfid, *ofid;

	if(r-&gt;fid-&gt;omode != ONONE)
		return fserror(r, Eisopen);

	nfid = nil;
	ofid = r-&gt;fid;
	if(r-&gt;t.newfid != r-&gt;t.fid){
		nfid = getfid(r-&gt;t.newfid, 1);
		if(nfid == nil)
			return fserror(r, Einuse);
		nfid-&gt;qid = r-&gt;fid-&gt;qid;
		if(fsops-&gt;clone != nil)
			fsops-&gt;clone(fsops, ofid, nfid);
		else
			nfid-&gt;aux = r-&gt;fid-&gt;aux;
		r-&gt;fid = nfid;
	}
	r-&gt;r.nwqid = 0;
	for(i = 0; i &lt; r-&gt;t.nwname; i++)
		if(fsops-&gt;walk(fsops, r-&gt;fid, r-&gt;t.wname[i]) &lt; 0)
			break;
		else
			r-&gt;r.wqid[i] = r-&gt;fid-&gt;qid;
	r-&gt;r.nwqid = i;
	if(i != r-&gt;t.nwname &amp;&amp; r-&gt;t.nwname &gt; 0){
		if(nfid != nil)
			freefid(nfid);
		r-&gt;fid = ofid;
	}
	if(i == 0 &amp;&amp; r-&gt;t.nwname &gt; 0)
		return fserror(r, "%r");
	return r;
}

static void
fsioproc(void* a)
{
	long rc;
	Channel *p = a;
	Rpc *rpc;
	Fcall *t, *r;
	Fid *fid;

	threadsetname("fsioproc");
	dprint(2, "%s: fsioproc pid %d\n", argv0, getpid());
	while((rpc = recvp(p)) != nil){
		t = &amp;rpc-&gt;t;
		r = &amp;rpc-&gt;r;
		fid = rpc-&gt;fid;
		rc = -1;
		dprint(2, "%s: fsioproc pid %d: req %d\n", argv0, getpid(), t-&gt;type);
		switch(t-&gt;type){
		case Topen:
			rc = fsops-&gt;open(fsops, fid, t-&gt;mode);
			if(rc &gt;= 0){
				r-&gt;iounit = 0;
				r-&gt;qid = fid-&gt;qid;
				fid-&gt;omode = t-&gt;mode &amp; 3;
			}
			break;
		case Tread:
			rc = fsops-&gt;read(fsops, fid, r-&gt;data, t-&gt;count, t-&gt;offset);
			if(rc &gt;= 0){
				if(rc &gt; t-&gt;count)
					print("%s: bug: read %ld bytes &gt; %ud wanted\n",
						argv0, rc, t-&gt;count);
				r-&gt;count = rc;
			}
			/*
			 * TODO: if we encounter a long run of continuous read
			 * errors, we should do something more drastic so that
			 * our caller doesn't just spin its wheels forever.
			 */
			break;
		case Twrite:
			rc = fsops-&gt;write(fsops, fid, t-&gt;data, t-&gt;count, t-&gt;offset);
			r-&gt;count = rc;
			break;
		default:
			sysfatal("fsioproc: bad type");
		}
		if(rc &lt; 0)
			sendp(outc, fserror(rpc, "%r"));
		else
			sendp(outc, rpc);
		sendp(endc, p);
	}
	chanfree(p);
	dprint(2, "%s: fsioproc %d exiting\n", argv0, getpid());
	threadexits(nil);
}

static Rpc*
fsopen(Rpc *r)
{
	Channel *p;

	if(r-&gt;fid-&gt;omode != ONONE)
		return fserror(r, Eisopen);
	if((r-&gt;t.mode &amp; 3) != OREAD &amp;&amp; (r-&gt;fid-&gt;qid.type &amp; QTDIR) != 0)
		return fserror(r, Eperm);
	p = recvp(procc);
	sendp(p, r);
	return nil;
}

int
usbdirread(Usbfs*f, Qid q, char *data, long cnt, vlong off, Dirgen gen, void *arg)
{
	int i, n, nd;
	char name[Namesz];
	Dir d;

	memset(&amp;d, 0, sizeof(d));
	d.name = name;
	d.uid = d.gid = d.muid = user;
	d.atime = time(nil);
	d.mtime = epoch;
	d.length = 0;
	for(i = n = 0; gen(f, q, i, &amp;d, arg) &gt;= 0; i++){
		if(usbfsdebug &gt; 1)
			fprint(2, "%s: dir %d q %#llux: %D\n", argv0, i, q.path, &amp;d);
		nd = convD2M(&amp;d, (uchar*)data+n, cnt-n);
		if(nd &lt;= BIT16SZ)
			break;
		if(off &gt; 0)
			off -= nd;
		else
			n += nd;
		d.name = name;
		d.uid = d.gid = d.muid = user;
		d.atime = time(nil);
		d.mtime = epoch;
		d.length = 0;
	}
	return n;
}

long
usbreadbuf(void *data, long count, vlong offset, void *buf, long n)
{
	if(offset &gt;= n)
		return 0;
	if(offset + count &gt; n)
		count = n - offset;
	memmove(data, (char*)buf + offset, count);
	return count;
}

static Rpc*
fsread(Rpc *r)
{
	Channel *p;

	if(r-&gt;fid-&gt;omode != OREAD &amp;&amp; r-&gt;fid-&gt;omode != ORDWR)
		return fserror(r, Eperm);
	p = recvp(procc);
	sendp(p, r);
	return nil;
}

static Rpc*
fswrite(Rpc *r)
{
	Channel *p;

	if(r-&gt;fid-&gt;omode != OWRITE &amp;&amp; r-&gt;fid-&gt;omode != ORDWR)
		return fserror(r, Eperm);
	p = recvp(procc);
	sendp(p, r);
	return nil;
}

static Rpc*
fsclunk(Rpc *r)
{
	freefid(r-&gt;fid);
	return r;
}

static Rpc*
fsno(Rpc *r)
{
	return fserror(r, Eperm);
}

static Rpc*
fsstat(Rpc *r)
{
	Dir d;
	char name[Namesz];

	memset(&amp;d, 0, sizeof(d));
	d.name = name;
	d.uid = d.gid = d.muid = user;
	d.atime = time(nil);
	d.mtime = epoch;
	d.length = 0;
	if(fsops-&gt;stat(fsops, r-&gt;fid-&gt;qid, &amp;d) &lt; 0)
		return fserror(r, "%r");
	r-&gt;r.stat = (uchar*)r-&gt;data;
	r-&gt;r.nstat = convD2M(&amp;d, (uchar*)r-&gt;data, msgsize);
	return r;
}

static Rpc*
fsflush(Rpc *r)
{
	/*
	 * Flag it as flushed and respond.
	 * Either outproc will reply to the flushed request
	 * before responding to flush, or it will never reply to it.
	 * Note that we do NOT abort the ongoing I/O.
	 * That might leave the affected endpoints in a failed
	 * state. Instead, we pretend the request is aborted.
	 *
	 * Only open, read, and write are processed
	 * by auxiliary processes and other requests wil never be
	 * flushed in practice.
	 */
	flushrpc(r-&gt;t.oldtag);
	return r;
}

Rpc* (*fscalls[])(Rpc*) = {
	[Tversion]	fsversion,
	[Tauth]		fsno,
	[Tattach]	fsattach,
	[Twalk]		fswalk,
	[Topen]		fsopen,
	[Tcreate]	fsno,
	[Tread]		fsread,
	[Twrite]	fswrite,
	[Tclunk]	fsclunk,
	[Tremove]	fsno,
	[Tstat]		fsstat,
	[Twstat]	fsno,
	[Tflush]	fsflush,
};

static void
outproc(void*)
{
	static uchar buf[Bufsize];
	Rpc *rpc;
	int nw;
	static int once = 0;

	if(once++ != 0)
		sysfatal("more than one outproc");
	threadsetname("outproc");
	for(;;){
		do
			rpc = recvp(outc);
		while(rpc == nil);		/* a delayed reply */
		if(rpc-&gt;t.tag == Dietag)
			break;
		if(rpc-&gt;flushed){
			dprint(2, "outproc: tag %d flushed\n", rpc-&gt;t.tag);
			freerpc(rpc);
			continue;
		}
		dprint(2, "-&gt; %F\n", &amp;rpc-&gt;r);
		nw = convS2M(&amp;rpc-&gt;r, buf, sizeof(buf));
		if(nw == sizeof(buf))
			fprint(2, "%s: outproc: buffer is too small\n", argv0);
		if(nw &lt;= BIT16SZ)
			fprint(2, "%s: conS2M failed\n", argv0);
		else if(write(fsfd, buf, nw) != nw){
			fprint(2, "%s: outproc: write: %r", argv0);
			/* continue and let the reader abort us */
		}
		if(usbfsdebug &gt; 1)
			dump();
		freerpc(rpc);
	}
	dprint(2, "%s: outproc: exiting\n", argv0);
}

static void
usbfs(void*)
{
	Rpc *rpc;
	int nr;
	static int once = 0;

	if(once++ != 0)
		sysfatal("more than one usbfs proc");

	threadsetname("usbfs");
	outc = chancreate(sizeof(Rpc*), 1);
	procc = chancreate(sizeof(Channel*), 0);
	endc = chancreate(sizeof(Channel*), 0);
	if(outc == nil || procc == nil || endc == nil)
		sysfatal("chancreate: %r");
	threadcreate(schedproc, nil, Stack);
	proccreate(outproc, nil, Stack);
	for(;;){
		rpc = newrpc();
		do{
			nr = read9pmsg(fsfd, rpc-&gt;data, sizeof(rpc-&gt;data));
		}while(nr == 0);
		if(nr &lt; 0){
			dprint(2, "%s: usbfs: read: '%r'", argv0);
			if(fsops-&gt;end != nil)
				fsops-&gt;end(fsops);
			else
				closedev(fsops-&gt;dev);
			rpc-&gt;t.tag = Dietag;
			sendp(outc, rpc);
			break;
		}
		if(convM2S((uchar*)rpc-&gt;data, nr, &amp;rpc-&gt;t) &lt;=0){
			dprint(2, "%s: convM2S failed\n", argv0);
			freerpc(rpc);
			continue;
		}
		dprint(2, "&lt;- %F\n", &amp;rpc-&gt;t);
		rpc-&gt;r.tag = rpc-&gt;t.tag;
		rpc-&gt;r.type = rpc-&gt;t.type + 1;
		rpc-&gt;r.fid = rpc-&gt;t.fid;
		if(fscalls[rpc-&gt;t.type] == nil){
			sendp(outc, fserror(rpc, Ebadcall));
			continue;
		}
		if(rpc-&gt;t.fid != Nofid){
			if(rpc-&gt;t.type == Tattach)
				rpc-&gt;fid = getfid(rpc-&gt;t.fid, 1);
			else
				rpc-&gt;fid = getfid(rpc-&gt;t.fid, 0);
			if(rpc-&gt;fid == nil){
				sendp(outc, fserror(rpc, Ebadfid));
				continue;
			}
		}
		sendp(outc, fscalls[rpc-&gt;t.type](rpc));
	}
	dprint(2, "%s: ubfs: eof: exiting\n", argv0);
}

void
usbfsinit(char* srv, char *mnt, Usbfs *f, int flag)
{
	int fd[2];
	int sfd;
	int afd;
	char sfile[40];

	fsops = f;
	if(pipe(fd) &lt; 0)
		sysfatal("pipe: %r");
	user = getuser();
	epoch = time(nil);

	fmtinstall('D', dirfmt);
	fmtinstall('M', dirmodefmt);
	fmtinstall('F', fcallfmt);
	fsfd = fd[1];
	procrfork(usbfs, nil, Stack, RFNAMEG);	/* no RFFDG */
	if(srv != nil){
		snprint(sfile, sizeof(sfile), "#s/%s", srv);
		remove(sfile);
		sfd = create(sfile, OWRITE, 0660);
		if(sfd &lt; 0)
			sysfatal("post: %r");
		snprint(sfile, sizeof(sfile), "%d", fd[0]);
		if(write(sfd, sfile, strlen(sfile)) != strlen(sfile))
			sysfatal("post: %r");
		close(sfd);
	}
	if(mnt != nil){
		sfd = dup(fd[0], -1);	/* debug */
		afd = fauth(sfd, "");
		if(afd &gt;= 0)
			sysfatal("authentication required??");
		if(mount(sfd, -1, mnt, flag, "") &lt; 0)
			sysfatal("mount: %r");
	}
	close(fd[0]);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

