<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/fsdir.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/fsdir.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include "usb.h"
#include "usbfs.h"

typedef struct Rpc Rpc;

enum
{
	Incr = 3,	/* increments for fs array */
	Dtop = 0,	/* high 32 bits for / 	*/
	Qdir = 0,	/* low 32 bits for /devdir */
};

QLock fslck;
static Usbfs** fs;
static int nfs;
static int fsused;
static int exitonclose = 1;

void
usbfsexits(int y)
{
	exitonclose = y;
}

static int
qiddev(uvlong path)
{
	return (int)(path&gt;&gt;32) &amp; 0xFF;
}

static int
qidfile(uvlong path)
{
	return (int)(path &amp; 0xFFFFFFFFULL);
}

static uvlong
mkqid(int qd, int qf)
{
	return ((uvlong)qd &lt;&lt; 32) | (uvlong)qf;
}

void
usbfsdirdump(void)
{
	int i;

	qlock(&amp;fslck);
	fprint(2, "%s: fs list: (%d used %d total)\n", argv0, fsused, nfs);
	for(i = 1; i &lt; nfs; i++)
		if(fs[i] != nil)
			if(fs[i]-&gt;dev != nil)
				fprint(2, "%s\t%s dev %#p refs %ld\n",
					argv0, fs[i]-&gt;name, fs[i]-&gt;dev, fs[i]-&gt;dev-&gt;ref);
			else
				fprint(2, "%s:\t%s\n", argv0, fs[i]-&gt;name);
	qunlock(&amp;fslck);
}

void
usbfsadd(Usbfs *dfs)
{
	int i, j;

	dprint(2, "%s: fsadd %s\n", argv0, dfs-&gt;name);
	qlock(&amp;fslck);
	for(i = 1; i &lt; nfs; i++)
		if(fs[i] == nil)
			break;
	if(i &gt;= nfs){
		if((nfs%Incr) == 0){
			fs = realloc(fs, sizeof(Usbfs*) * (nfs+Incr));
			if(fs == nil)
				sysfatal("realloc: %r");
			for(j = nfs; j &lt; nfs+Incr; j++)
				fs[j] = nil;
		}
		if(nfs == 0)	/* do not use entry 0 */
			nfs++;
		fs[nfs++] = dfs;
	}else
		fs[i] = dfs;
	dfs-&gt;qid = mkqid(i, 0);
	fsused++;
	qunlock(&amp;fslck);
}

static void
usbfsdelnth(int i)
{
	if(fs[i] != nil){
		dprint(2, "%s: fsdel %s", argv0, fs[i]-&gt;name);
		if(fs[i]-&gt;dev != nil){
			dprint(2, " dev %#p ref %ld\n",
				fs[i]-&gt;dev, fs[i]-&gt;dev-&gt;ref);
		}else
			dprint(2, "no dev\n");
		if(fs[i]-&gt;end != nil)
			fs[i]-&gt;end(fs[i]);
		closedev(fs[i]-&gt;dev);
		fsused--;
	}
	fs[i] = nil;
	if(fsused == 0 &amp;&amp; exitonclose != 0){
		fprint(2, "%s: all file systems gone: exiting\n", argv0);
		threadexitsall(nil);
	}
}

void
usbfsdel(Usbfs *dfs)
{
	int i;

	qlock(&amp;fslck);
	for(i = 0; i &lt; nfs; i++)
		if(dfs == nil || fs[i] == dfs){
			usbfsdelnth(i);
			if(dfs != nil)
				break;
		}
	qunlock(&amp;fslck);
}

static void
fsend(Usbfs*)
{
	dprint(2, "%s: fsend\n", argv0);
	usbfsdel(nil);
}

void
usbfsgone(char *dir)
{
	int i;

	qlock(&amp;fslck);
	/* devices may have more than one fs */
	for(i = 0; i &lt; nfs; i++)
		if(fs[i] != nil &amp;&amp; fs[i]-&gt;dev != nil)
		if(strcmp(fs[i]-&gt;dev-&gt;dir, dir) == 0)
			usbfsdelnth(i);
	qunlock(&amp;fslck);
}

static void
fsclone(Usbfs*, Fid *o, Fid *n)
{
	int qd;
	Dev *dev;
	void (*xfsclone)(Usbfs *fs, Fid *of, Fid *nf);

	xfsclone = nil;
	dev = nil;
	qd = qiddev(o-&gt;qid.path);
	qlock(&amp;fslck);
	if(qd != Dtop &amp;&amp; fs[qd] != nil &amp;&amp; fs[qd]-&gt;clone != nil){
		dev = fs[qd]-&gt;dev;
		if(dev != nil)
			incref(dev);
		xfsclone = fs[qd]-&gt;clone;
	}
	qunlock(&amp;fslck);
	if(xfsclone != nil){
		xfsclone(fs[qd], o, n);
	}
	if(dev != nil)
		closedev(dev);
}

static int
fswalk(Usbfs*, Fid *fid, char *name)
{
	Qid q;
	int qd, qf;
	int i;
	int rc;
	Dev *dev;
	Dir d;
	int (*xfswalk)(Usbfs *fs, Fid *f, char *name);

	q = fid-&gt;qid;
	qd = qiddev(q.path);
	qf = qidfile(q.path);

	q.type = QTDIR;
	q.vers = 0;
	if(strcmp(name, "..") == 0)
		if(qd == Dtop || qf == Qdir){
			q.path = mkqid(Dtop, Qdir);
			fid-&gt;qid = q;
			return 0;
		}
	if(qd != 0){
		qlock(&amp;fslck);
		if(fs[qd] == nil){
			qunlock(&amp;fslck);
			werrstr(Eio);
			return -1;
		}
		dev = fs[qd]-&gt;dev;
		if(dev != nil)
			incref(dev);
		xfswalk = fs[qd]-&gt;walk;
		qunlock(&amp;fslck);
		rc = xfswalk(fs[qd], fid, name);
		if(dev != nil)
			closedev(dev);
		return rc;
	}
	qlock(&amp;fslck);
	for(i = 0; i &lt; nfs; i++)
		if(fs[i] != nil &amp;&amp; strcmp(name, fs[i]-&gt;name) == 0){
			q.path = mkqid(i, Qdir);
			fs[i]-&gt;stat(fs[i], q, &amp;d); /* may be a file */
			fid-&gt;qid = d.qid;
			qunlock(&amp;fslck);
			return 0;
		}
	qunlock(&amp;fslck);
	werrstr(Enotfound);
	return -1;
}

static int
fsopen(Usbfs*, Fid *fid, int mode)
{
	int qd;
	int rc;
	Dev *dev;
	int (*xfsopen)(Usbfs *fs, Fid *f, int mode);

	qd = qiddev(fid-&gt;qid.path);
	if(qd == Dtop)
		return 0;
	qlock(&amp;fslck);
	if(fs[qd] == nil){
		qunlock(&amp;fslck);
		werrstr(Eio);
		return -1;
	}
	dev = fs[qd]-&gt;dev;
	if(dev != nil)
		incref(dev);
	xfsopen = fs[qd]-&gt;open;
	qunlock(&amp;fslck);
	if(xfsopen != nil)
		rc = xfsopen(fs[qd], fid, mode);
	else
		rc = 0;
	if(dev != nil)
		closedev(dev);
	return rc;
}

static int
dirgen(Usbfs*, Qid, int n, Dir *d, void *)
{
	int i;
	Dev *dev;
	char *nm;

	qlock(&amp;fslck);
	for(i = 0; i &lt; nfs; i++)
		if(fs[i] != nil &amp;&amp; n-- == 0){
			d-&gt;qid.type = QTDIR;
			d-&gt;qid.path = mkqid(i, Qdir);
			d-&gt;qid.vers = 0;
			dev = fs[i]-&gt;dev;
			if(dev != nil)
				incref(dev);
			nm = d-&gt;name;
			fs[i]-&gt;stat(fs[i], d-&gt;qid, d);
			d-&gt;name = nm;
			strncpy(d-&gt;name, fs[i]-&gt;name, Namesz);
			if(dev != nil)
				closedev(dev);
			qunlock(&amp;fslck);
			return 0;
		}
	qunlock(&amp;fslck);
	return -1;
}

static long
fsread(Usbfs*, Fid *fid, void *data, long cnt, vlong off)
{
	int qd;
	int rc;
	Dev *dev;
	Qid q;
	long (*xfsread)(Usbfs *fs, Fid *f, void *data, long count, vlong );

	q = fid-&gt;qid;
	qd = qiddev(q.path);
	if(qd == Dtop)
		return usbdirread(nil, q, data, cnt, off, dirgen, nil);
	qlock(&amp;fslck);
	if(fs[qd] == nil){
		qunlock(&amp;fslck);
		werrstr(Eio);
		return -1;
	}
	dev = fs[qd]-&gt;dev;
	if(dev != nil)
		incref(dev);
	xfsread = fs[qd]-&gt;read;
	qunlock(&amp;fslck);
	rc = xfsread(fs[qd], fid, data, cnt, off);
	if(dev != nil)
		closedev(dev);
	return rc;
}

static long
fswrite(Usbfs*, Fid *fid, void *data, long cnt, vlong off)
{
	int qd;
	int rc;
	Dev *dev;
	long (*xfswrite)(Usbfs *fs, Fid *f, void *data, long count, vlong );

	qd = qiddev(fid-&gt;qid.path);
	if(qd == Dtop)
		sysfatal("fswrite: not for usbd /");
	qlock(&amp;fslck);
	if(fs[qd] == nil){
		qunlock(&amp;fslck);
		werrstr(Eio);
		return -1;
	}
	dev = fs[qd]-&gt;dev;
	if(dev != nil)
		incref(dev);
	xfswrite = fs[qd]-&gt;write;
	qunlock(&amp;fslck);
	rc = xfswrite(fs[qd], fid, data, cnt, off);
	if(dev != nil)
		closedev(dev);
	return rc;
}


static void
fsclunk(Usbfs*, Fid* fid)
{
	int qd;
	Dev *dev;
	void (*xfsclunk)(Usbfs *fs, Fid *f);

	dev = nil;
	qd = qiddev(fid-&gt;qid.path);
	qlock(&amp;fslck);
	if(qd != Dtop &amp;&amp; fs[qd] != nil){
		dev=fs[qd]-&gt;dev;
		if(dev != nil)
			incref(dev);
		xfsclunk = fs[qd]-&gt;clunk;
	}else
		xfsclunk = nil;
	qunlock(&amp;fslck);
	if(xfsclunk != nil){
		xfsclunk(fs[qd], fid);
	}
	if(dev != nil)
		closedev(dev);
}

static int
fsstat(Usbfs*, Qid qid, Dir *d)
{
	int qd;
	int rc;
	Dev *dev;
	int (*xfsstat)(Usbfs *fs, Qid q, Dir *d);

	qd = qiddev(qid.path);
	if(qd == Dtop){
		d-&gt;qid = qid;
		d-&gt;name = "usb";
		d-&gt;length = 0;
		d-&gt;mode = 0555|DMDIR;
		return 0;
	}
	qlock(&amp;fslck);
	if(fs[qd] == nil){
		qunlock(&amp;fslck);
		werrstr(Eio);
		return -1;
	}
	xfsstat = fs[qd]-&gt;stat;
	dev = fs[qd]-&gt;dev;
	if(dev != nil)
		incref(dev);
	qunlock(&amp;fslck);
	rc = xfsstat(fs[qd], qid, d);
	if(dev != nil)
		closedev(dev);
	return rc;
}

Usbfs usbdirfs =
{
	.walk = fswalk,
	.clone = fsclone,
	.clunk = fsclunk,
	.open = fsopen,
	.read = fsread,
	.write = fswrite,
	.stat = fsstat,
	.end = fsend,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

