<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/lib/parse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/lib/parse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;bio.h&gt;
#include "usb.h"

int
parsedev(Dev *xd, uchar *b, int n)
{
	Usbdev *d;
	DDev *dd;
	char *hd;

	d = xd-&gt;usb;
	assert(d != nil);
	dd = (DDev*)b;
	if(usbdebug&gt;1){
		hd = hexstr(b, Ddevlen);
		fprint(2, "%s: parsedev %s: %s\n", argv0, xd-&gt;dir, hd);
		free(hd);
	}
	if(dd-&gt;bLength &lt; Ddevlen){
		werrstr("short dev descr. (%d &lt; %d)", dd-&gt;bLength, Ddevlen);
		return -1;
	}
	if(dd-&gt;bDescriptorType != Ddev){
		werrstr("%d is not a dev descriptor", dd-&gt;bDescriptorType);
		return -1;
	}
	d-&gt;csp = CSP(dd-&gt;bDevClass, dd-&gt;bDevSubClass, dd-&gt;bDevProtocol);
	d-&gt;ep[0]-&gt;maxpkt = xd-&gt;maxpkt = dd-&gt;bMaxPacketSize0;
	d-&gt;class = dd-&gt;bDevClass;
	d-&gt;nconf = dd-&gt;bNumConfigurations;
	if(d-&gt;nconf == 0)
		dprint(2, "%s: %s: no configurations\n", argv0, xd-&gt;dir);
	d-&gt;vid = GET2(dd-&gt;idVendor);
	d-&gt;did = GET2(dd-&gt;idProduct);
	d-&gt;dno = GET2(dd-&gt;bcdDev);
	d-&gt;vsid = dd-&gt;iManufacturer;
	d-&gt;psid = dd-&gt;iProduct;
	d-&gt;ssid = dd-&gt;iSerialNumber;
	if(n &gt; Ddevlen &amp;&amp; usbdebug&gt;1)
		fprint(2, "%s: %s: parsedev: %d bytes left",
			argv0, xd-&gt;dir, n - Ddevlen);
	return Ddevlen;
}

static int
parseiface(Usbdev *d, Conf *c, uchar *b, int n, Iface **ipp, Altc **app)
{
	int class, subclass, proto;
	int ifid, altid;
	DIface *dip;
	Iface *ip;

	assert(d != nil &amp;&amp; c != nil);
	if(n &lt; Difacelen){
		werrstr("short interface descriptor");
		return -1;
	}
	dip = (DIface *)b;
	ifid = dip-&gt;bInterfaceNumber;
	if(ifid &lt; 0 || ifid &gt;= nelem(c-&gt;iface)){
		werrstr("bad interface number %d", ifid);
		return -1;
	}
	if(c-&gt;iface[ifid] == nil)
		c-&gt;iface[ifid] = emallocz(sizeof(Iface), 1);
	ip = c-&gt;iface[ifid];
	class = dip-&gt;bInterfaceClass;
	subclass = dip-&gt;bInterfaceSubClass;
	proto = dip-&gt;bInterfaceProtocol;
	ip-&gt;csp = CSP(class, subclass, proto);
	if(d-&gt;csp == 0)				/* use csp from 1st iface */
		d-&gt;csp = ip-&gt;csp;		/* if device has none */
	if(d-&gt;class == 0)
		d-&gt;class = class;
	ip-&gt;id = ifid;
	if(c == d-&gt;conf[0] &amp;&amp; ifid == 0)	/* ep0 was already there */
		d-&gt;ep[0]-&gt;iface = ip;
	altid = dip-&gt;bAlternateSetting;
	if(altid &lt; 0 || altid &gt;= nelem(ip-&gt;altc)){
		werrstr("bad alternate conf. number %d", altid);
		return -1;
	}
	if(ip-&gt;altc[altid] == nil)
		ip-&gt;altc[altid] = emallocz(sizeof(Altc), 1);
	*ipp = ip;
	*app = ip-&gt;altc[altid];
	return Difacelen;
}

extern Ep* mkep(Usbdev *, int);

static int
parseendpt(Usbdev *d, Conf *c, Iface *ip, Altc *altc, uchar *b, int n, Ep **epp)
{
	int i, dir, epid;
	Ep *ep;
	DEp *dep;

	assert(d != nil &amp;&amp; c != nil &amp;&amp; ip != nil &amp;&amp; altc != nil);
	if(n &lt; Deplen){
		werrstr("short endpoint descriptor");
		return -1;
	}
	dep = (DEp *)b;
	altc-&gt;attrib = dep-&gt;bmAttributes;	/* here? */
	altc-&gt;interval = dep-&gt;bInterval;

	epid = dep-&gt;bEndpointAddress &amp; 0xF;
	assert(epid &lt; nelem(d-&gt;ep));
	if(dep-&gt;bEndpointAddress &amp; 0x80)
		dir = Ein;
	else
		dir = Eout;
	ep = d-&gt;ep[epid];
	if(ep == nil){
		ep = mkep(d, epid);
		ep-&gt;dir = dir;
	}else if((ep-&gt;addr &amp; 0x80) != (dep-&gt;bEndpointAddress &amp; 0x80))
		ep-&gt;dir = Eboth;
	ep-&gt;maxpkt = GET2(dep-&gt;wMaxPacketSize);
	ep-&gt;ntds = 1 + ((ep-&gt;maxpkt &gt;&gt; 11) &amp; 3);
	ep-&gt;maxpkt &amp;= 0x7FF;
	ep-&gt;addr = dep-&gt;bEndpointAddress;
	ep-&gt;type = dep-&gt;bmAttributes &amp; 0x03;
	ep-&gt;isotype = (dep-&gt;bmAttributes&gt;&gt;2) &amp; 0x03;
	ep-&gt;conf = c;
	ep-&gt;iface = ip;
	for(i = 0; i &lt; nelem(ip-&gt;ep); i++)
		if(ip-&gt;ep[i] == nil)
			break;
	if(i == nelem(ip-&gt;ep)){
		werrstr("parseendpt: bug: too many end points on interface "
			"with csp %#lux", ip-&gt;csp);
		fprint(2, "%s: %r\n", argv0);
		return -1;
	}
	*epp = ip-&gt;ep[i] = ep;
	return Dep;
}

static char*
dname(int dtype)
{
	switch(dtype){
	case Ddev:	return "device";
	case Dconf: 	return "config";
	case Dstr: 	return "string";
	case Diface:	return "interface";
	case Dep:	return "endpoint";
	case Dreport:	return "report";
	case Dphysical:	return "phys";
	default:	return "desc";
	}
}

int
parsedesc(Usbdev *d, Conf *c, uchar *b, int n)
{
	int	len, nd, tot;
	Iface	*ip;
	Ep 	*ep;
	Altc	*altc;
	char	*hd;

	assert(d != nil &amp;&amp; c != nil);
	tot = 0;
	ip = nil;
	ep = nil;
	altc = nil;
	for(nd = 0; nd &lt; nelem(d-&gt;ddesc); nd++)
		if(d-&gt;ddesc[nd] == nil)
			break;

	while(n &gt; 2 &amp;&amp; b[0] != 0 &amp;&amp; b[0] &lt;= n){
		len = b[0];
		if(usbdebug&gt;1){
			hd = hexstr(b, len);
			fprint(2, "%s:\t\tparsedesc %s %x[%d] %s\n",
				argv0, dname(b[1]), b[1], b[0], hd);
			free(hd);
		}
		switch(b[1]){
		case Ddev:
		case Dconf:
			werrstr("unexpected descriptor %d", b[1]);
			ddprint(2, "%s\tparsedesc: %r", argv0);
			break;
		case Diface:
			if(parseiface(d, c, b, n, &amp;ip, &amp;altc) &lt; 0){
				ddprint(2, "%s\tparsedesc: %r\n", argv0);
				return -1;
			}
			break;
		case Dep:
			if(ip == nil || altc == nil){
				werrstr("unexpected endpoint descriptor");
				break;
			}
			if(parseendpt(d, c, ip, altc, b, n, &amp;ep) &lt; 0){
				ddprint(2, "%s\tparsedesc: %r\n", argv0);
				return -1;
			}
			break;
		default:
			if(nd == nelem(d-&gt;ddesc)){
				fprint(2, "%s: parsedesc: too many "
					"device-specific descriptors for device"
					" %s %s\n",
					argv0, d-&gt;vendor, d-&gt;product);
				break;
			}
			d-&gt;ddesc[nd] = emallocz(sizeof(Desc)+b[0], 0);
			d-&gt;ddesc[nd]-&gt;iface = ip;
			d-&gt;ddesc[nd]-&gt;ep = ep;
			d-&gt;ddesc[nd]-&gt;altc = altc;
			d-&gt;ddesc[nd]-&gt;conf = c;
			memmove(&amp;d-&gt;ddesc[nd]-&gt;data, b, len);
			++nd;
		}
		n -= len;
		b += len;
		tot += len;
	}
	return tot;
}

int
parseconf(Usbdev *d, Conf *c, uchar *b, int n)
{
	DConf* dc;
	int	l;
	int	nr;
	char	*hd;

	assert(d != nil &amp;&amp; c != nil);
	dc = (DConf*)b;
	if(usbdebug&gt;1){
		hd = hexstr(b, Dconflen);
		fprint(2, "%s:\tparseconf  %s\n", argv0, hd);
		free(hd);
	}
	if(dc-&gt;bLength &lt; Dconflen){
		werrstr("short configuration descriptor");
		return -1;
	}
	if(dc-&gt;bDescriptorType != Dconf){
		werrstr("not a configuration descriptor");
		return -1;
	}
	c-&gt;cval = dc-&gt;bConfigurationValue;
	c-&gt;attrib = dc-&gt;bmAttributes;
	c-&gt;milliamps = dc-&gt;MaxPower*2;
	l = GET2(dc-&gt;wTotalLength);
	if(n &lt; l){
		werrstr("truncated configuration info");
		return -1;
	}
	n -= Dconflen;
	b += Dconflen;
	nr = 0;
	if(n &gt; 0 &amp;&amp; (nr=parsedesc(d, c, b, n)) &lt; 0)
		return -1;
	n -= nr;
	if(n &gt; 0 &amp;&amp; usbdebug&gt;1)
		fprint(2, "%s:\tparseconf: %d bytes left\n", argv0, n);
	return l;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

