<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/print/print.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/print/print.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * usb/print - usb printer file server
 * BUG: Assumes the printer will be always connected and
 * not hot-plugged. (Otherwise should stay running and
 * listen to errors to keep the device there as long as it has
 * not failed). Also, this is untested and done ad-hoc to
 * replace the print script.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"

enum
{
	Qdir = 0,
	Qctl,
	Qraw,
	Qdata,
	Qmax,
};

int
findendpoints(Dev *dev, int devid)
{
	Ep *ep;
	Dev *d;
	Usbdev *ud;
	int i, epout;

	epout = -1;
	ud = dev-&gt;usb;
	for(i = 0; i &lt; nelem(ud-&gt;ep); i++){
		if((ep = ud-&gt;ep[i]) == nil)
			break;
		if(ep-&gt;iface-&gt;csp != 0x020107)
			continue;
		if(ep-&gt;type == Ebulk &amp;&amp; (ep-&gt;dir == Eboth || ep-&gt;dir == Eout))
			if(epout == -1)
				epout = ep-&gt;id;
	}
	dprint(2, "print: ep ids: out %d\n", epout);
	if(epout == -1)
		return -1;
	d = openep(dev, epout);
	if(d == nil){
		fprint(2, "print: openep %d: %r\n", epout);
		return -1;
	}
	opendevdata(d, OWRITE);
	if(d-&gt;dfd &lt; 0){
		fprint(2, "print: open i/o ep data: %r\n");
		closedev(d);
		return -1;
	}
	dprint(2, "print: ep out %s\n", d-&gt;dir);
	if(usbdebug &gt; 1)
		devctl(d, "debug 1");
	devctl(d, "name lp%d", devid);
	return 0;
}

static int
usage(void)
{
	werrstr("usage: usb/print [-N id]");
	return -1;
}

int
printmain(Dev *dev, int argc, char **argv)
{
	int devid;

	devid = dev-&gt;id;
	ARGBEGIN{
	case 'N':
		devid = atoi(EARGF(usage()));
		break;
	default:
		return usage();
	}ARGEND
	if(argc != 0)
		return usage();

	if(findendpoints(dev, devid) &lt; 0){
		werrstr("print: endpoints not found");
		return -1;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

