<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/serial/serial.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/serial/serial.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * This part takes care of locking except for initialization and
 * other threads created by the hw dep. drivers.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "usbfs.h"
#include "serial.h"
#include "prolific.h"
#include "ucons.h"
#include "ftdi.h"
#include "silabs.h"

int serialdebug;

enum {
	/* Qids. Maintain order (relative to dirtabs structs) */
	Qroot	= 0,
	Qctl,
	Qdata,
	Qmax,
};

typedef struct Dirtab Dirtab;
struct Dirtab {
	char	*name;
	int	mode;
};

static Dirtab dirtab[] = {
	[Qroot]	"/",		DMDIR|0555,
	[Qdata]	"%s",		0660,
	[Qctl]	"%sctl",	0664,
};

static int sdebug;

static void
serialfatal(Serial *ser)
{
	Serialport *p;
	int i;

	dsprint(2, "serial: fatal error, detaching\n");
	devctl(ser-&gt;dev, "detach");

	for(i = 0; i &lt; ser-&gt;nifcs; i++){
		p = &amp;ser-&gt;p[i];
		usbfsdel(&amp;p-&gt;fs);
		if(p-&gt;w4data != nil)
			chanclose(p-&gt;w4data);
		if(p-&gt;gotdata != nil)
			chanclose(p-&gt;gotdata);
		if(p-&gt;readc)
			chanclose(p-&gt;readc);
	}
}

/* I sleep with the lock... only way to drain in general */
static void
serialdrain(Serialport *p)
{
	Serial *ser;
	uint baud, pipesize;

	ser = p-&gt;s;
	baud = p-&gt;baud;

	if(p-&gt;baud == ~0)
		return;
	if(ser-&gt;maxwtrans &lt; 256)
		pipesize = 256;
	else
		pipesize = ser-&gt;maxwtrans;
	/* wait for the at least 256-byte pipe to clear */
	sleep(10 + pipesize/((1 + baud)*1000));
	if(ser-&gt;clearpipes != nil)
		ser-&gt;clearpipes(p);
}

int
serialreset(Serial *ser)
{
	Serialport *p;
	int i, res;

	res = 0;
	/* cmd for reset */
	for(i = 0; i &lt; ser-&gt;nifcs; i++){
		p = &amp;ser-&gt;p[i];
		serialdrain(p);
	}
	if(ser-&gt;reset != nil)
		res = ser-&gt;reset(ser, nil);
	return res;
}

/* call this if something goes wrong, must be qlocked */
int
serialrecover(Serial *ser, Serialport *p, Dev *ep, char *err)
{
	if(p != nil)
		dprint(2, "serial[%d], %s: %s, level %d\n", p-&gt;interfc,
			p-&gt;name, err, ser-&gt;recover);
	else
		dprint(2, "serial[%s], global error, level %d\n",
			ser-&gt;p[0].name, ser-&gt;recover);
	ser-&gt;recover++;
	if(strstr(err, "detached") != nil)
		return -1;
	if(ser-&gt;recover &lt; 3){
		if(p != nil){	
			if(ep != nil){
				if(ep == p-&gt;epintr)
					unstall(ser-&gt;dev, p-&gt;epintr, Ein);
				if(ep == p-&gt;epin)
					unstall(ser-&gt;dev, p-&gt;epin, Ein);
				if(ep == p-&gt;epout)
					unstall(ser-&gt;dev, p-&gt;epout, Eout);
				return 0;
			}

			if(p-&gt;epintr != nil)
				unstall(ser-&gt;dev, p-&gt;epintr, Ein);
			if(p-&gt;epin != nil)
				unstall(ser-&gt;dev, p-&gt;epin, Ein);
			if(p-&gt;epout != nil)
				unstall(ser-&gt;dev, p-&gt;epout, Eout);
		}
		return 0;
	}
	if(ser-&gt;recover &gt; 4 &amp;&amp; ser-&gt;recover &lt; 8)
		serialfatal(ser);
	if(ser-&gt;recover &gt; 8){
		ser-&gt;reset(ser, p);
		return 0;
	}
	if(serialreset(ser) &lt; 0)
		return -1;
	return 0;
}

static int
serialctl(Serialport *p, char *cmd)
{
	Serial *ser;
	int c, i, n, nf, nop, nw, par, drain, set, lines;
	char *f[16];
	uchar x;

	ser = p-&gt;s;
	drain = set = lines = 0;
	nf = tokenize(cmd, f, nelem(f));
	for(i = 0; i &lt; nf; i++){
		if(strncmp(f[i], "break", 5) == 0){
			if(ser-&gt;setbreak != nil)
				ser-&gt;setbreak(p, 1);
			continue;
		}

		nop = 0;
		n = atoi(f[i]+1);
		c = *f[i];
		if (isascii(c) &amp;&amp; isupper(c))
			c = tolower(c);
		switch(c){
		case 'b':
			drain++;
			p-&gt;baud = n;
			set++;
			break;
		case 'c':
			p-&gt;dcd = n;
			// lines++;
			++nop;
			break;
		case 'd':
			p-&gt;dtr = n;
			lines++;
			break;
		case 'e':
			p-&gt;dsr = n;
			// lines++;
			++nop;
			break;
		case 'f':		/* flush the pipes */
			drain++;
			break;
		case 'h':		/* hangup?? */
			p-&gt;rts = p-&gt;dtr = 0;
			lines++;
			fprint(2, "serial: %c, unsure ctl\n", c);
			break;
		case 'i':
			++nop;
			break;
		case 'k':
			drain++;
			ser-&gt;setbreak(p, 1);
			sleep(n);
			ser-&gt;setbreak(p, 0);
			break;
		case 'l':
			drain++;
			p-&gt;bits = n;
			set++;
			break;
		case 'm':
			drain++;
			if(ser-&gt;modemctl != nil)
				ser-&gt;modemctl(p, n);
			if(n == 0)
				p-&gt;cts = 0;
			break;
		case 'n':
			p-&gt;blocked = n;
			++nop;
			break;
		case 'p':		/* extended... */
			if(strlen(f[i]) != 2)
				return -1;
			drain++;
			par = f[i][1];
			if(par == 'n')
				p-&gt;parity = 0;
			else if(par == 'o')
				p-&gt;parity = 1;
			else if(par == 'e')
				p-&gt;parity = 2;
			else if(par == 'm')	/* mark parity */
				p-&gt;parity = 3;
			else if(par == 's')	/* space parity */
				p-&gt;parity = 4;
			else
				return -1;
			set++;
			break;
		case 'q':
			// drain++;
			p-&gt;limit = n;
			++nop;
			break;
		case 'r':
			drain++;
			p-&gt;rts = n;
			lines++;
			break;
		case 's':
			drain++;
			p-&gt;stop = n;
			set++;
			break;
		case 'w':
			/* ?? how do I put this */
			p-&gt;timer = n * 100000LL;
			++nop;
			break;
		case 'x':
			if(n == 0)
				x = CTLS;
			else
				x = CTLQ;
			if(ser-&gt;wait4write != nil)
				nw = ser-&gt;wait4write(p, &amp;x, 1);
			else
				nw = write(p-&gt;epout-&gt;dfd, &amp;x, 1);
			if(nw != 1){
				serialrecover(ser, p, p-&gt;epout, "");
				return -1;
			}
			break;
		}
		/*
		 * don't print.  the condition is harmless and the print
		 * splatters all over the display.
		 */
		USED(nop);
		if (0 &amp;&amp; nop)
			fprint(2, "serial: %c, unsupported nop ctl\n", c);
	}
	if(drain)
		serialdrain(p);
	if(lines &amp;&amp; !set){
		if(ser-&gt;sendlines != nil &amp;&amp; ser-&gt;sendlines(p) &lt; 0)
			return -1;
	} else if(set){
		if(ser-&gt;setparam != nil &amp;&amp; ser-&gt;setparam(p) &lt; 0)
			return -1;
	}
	ser-&gt;recover = 0;
	return 0;
}

char *pformat = "noems";

char *
serdumpst(Serialport *p, char *buf, int bufsz)
{
	char *e, *s;
	Serial *ser;

	ser = p-&gt;s;

	e = buf + bufsz;
	s = seprint(buf, e, "b%d ", p-&gt;baud);
	s = seprint(s, e, "c%d ", p-&gt;dcd);	/* unimplemented */
	s = seprint(s, e, "d%d ", p-&gt;dtr);
	s = seprint(s, e, "e%d ", p-&gt;dsr);	/* unimplemented */
	s = seprint(s, e, "l%d ", p-&gt;bits);
	s = seprint(s, e, "m%d ", p-&gt;mctl);
	if(p-&gt;parity &gt;= 0 || p-&gt;parity &lt; strlen(pformat))
		s = seprint(s, e, "p%c ", pformat[p-&gt;parity]);
	else
		s = seprint(s, e, "p%c ", '?');
	s = seprint(s, e, "r%d ", p-&gt;rts);
	s = seprint(s, e, "s%d ", p-&gt;stop);
	s = seprint(s, e, "i%d ", p-&gt;fifo);
	s = seprint(s, e, "\ndev(%d) ", 0);
	s = seprint(s, e, "type(%d)  ", ser-&gt;type);
	s = seprint(s, e, "framing(%d) ", p-&gt;nframeerr);
	s = seprint(s, e, "overruns(%d) ", p-&gt;novererr);
	s = seprint(s, e, "berr(%d) ", p-&gt;nbreakerr);
	s = seprint(s, e, " serr(%d)\n", p-&gt;nparityerr);
	return s;
}

static int
serinit(Serialport *p)
{
	int res;
	res = 0;
	Serial *ser;

	ser = p-&gt;s;

	if(ser-&gt;init != nil)
		res = ser-&gt;init(p);
	if(ser-&gt;getparam != nil)
		ser-&gt;getparam(p);
	p-&gt;nframeerr = p-&gt;nparityerr = p-&gt;nbreakerr = p-&gt;novererr = 0;

	return res;
}

static int
dwalk(Usbfs *fs, Fid *fid, char *name)
{
	int i;
	char *dname;
	Qid qid;
	Serialport *p;

	qid = fid-&gt;qid;
	if((qid.type &amp; QTDIR) == 0){
		werrstr("walk in non-directory");
		return -1;
	}

	if(strcmp(name, "..") == 0){
		/* must be /eiaU%d; i.e. our root dir. */
		fid-&gt;qid.path = Qroot | fs-&gt;qid;
		fid-&gt;qid.vers = 0;
		fid-&gt;qid.type = QTDIR;
		return 0;
	}

	p = fs-&gt;aux;
	for(i = 1; i &lt; nelem(dirtab); i++){
		dname = smprint(dirtab[i].name, p-&gt;name);
		if(strcmp(name, dname) == 0){
			qid.path = i | fs-&gt;qid;
			qid.vers = 0;
			qid.type = dirtab[i].mode &gt;&gt; 24;
			fid-&gt;qid = qid;
			free(dname);
			return 0;
		} else
			free(dname);
	}
	werrstr(Enotfound);
	return -1;
}

static void
dostat(Usbfs *fs, int path, Dir *d)
{
	Dirtab *t;
	Serialport *p;

	t = &amp;dirtab[path];
	d-&gt;qid.path = path;
	d-&gt;qid.type = t-&gt;mode &gt;&gt; 24;
	d-&gt;mode = t-&gt;mode;
	p = fs-&gt;aux;

	if(strcmp(t-&gt;name, "/") == 0)
		d-&gt;name = t-&gt;name;
	else
		snprint(d-&gt;name, Namesz, t-&gt;name, p-&gt;fs.name);
	d-&gt;length = 0;
}

static int
dstat(Usbfs *fs, Qid qid, Dir *d)
{
	int path;

	path = qid.path &amp; ~fs-&gt;qid;
	dostat(fs, path, d);
	d-&gt;qid.path |= fs-&gt;qid;
	return 0;
}

static int
dopen(Usbfs *fs, Fid *fid, int)
{
	ulong path;
	Serialport *p;

	path = fid-&gt;qid.path &amp; ~fs-&gt;qid;
	p = fs-&gt;aux;
	switch(path){		/* BUG: unneeded? */
	case Qdata:
		dsprint(2, "serial, opened data\n");
		break;
	case Qctl:
		dsprint(2, "serial, opened ctl\n");
		if(p-&gt;isjtag)
			return 0;
		serialctl(p, "l8 i1");	/* default line parameters */
		break;
	}
	return 0;
}


static void
filldir(Usbfs *fs, Dir *d, Dirtab *tab, int i, void *v)
{
	Serialport *p;

	p = v;
	d-&gt;qid.path = i | fs-&gt;qid;
	d-&gt;mode = tab-&gt;mode;
	if((d-&gt;mode &amp; DMDIR) != 0)
		d-&gt;qid.type = QTDIR;
	else
		d-&gt;qid.type = QTFILE;
	sprint(d-&gt;name, tab-&gt;name, p-&gt;name);	/* hope it fits */
}

static int
dirgen(Usbfs *fs, Qid, int i, Dir *d, void *p)
{
	i++;				/* skip root */
	if(i &gt;= nelem(dirtab))
		return -1;
	filldir(fs, d, &amp;dirtab[i], i, p);
	return 0;
}

enum {
	Serbufsize	= 256,
};

static long
dread(Usbfs *fs, Fid *fid, void *data, long count, vlong offset)
{
	int dfd;
	long rcount;
	ulong path;
	char *e, *buf, *err;	/* change */
	Qid q;
	Serialport *p;
	Serial *ser;
	static int errrun, good;

	q = fid-&gt;qid;
	path = fid-&gt;qid.path &amp; ~fs-&gt;qid;
	p = fs-&gt;aux;
	ser = p-&gt;s;

	buf = emallocz(Serbufsize, 1);
	err = emallocz(Serbufsize, 1);
	qlock(ser);
	switch(path){
	case Qroot:
		count = usbdirread(fs, q, data, count, offset, dirgen, p);
		break;
	case Qdata:
		if(count &gt; ser-&gt;maxread)
			count = ser-&gt;maxread;

		dsprint(2, "serial: reading from data\n");
		do {
			err[0] = 0;
			dfd = p-&gt;epin-&gt;dfd;
			if(usbdebug &gt;= 3)
				dsprint(2, "serial: reading: %ld\n", count);

			assert(count &gt; 0);
			if(ser-&gt;wait4data != nil)
				rcount = ser-&gt;wait4data(p, data, count);
			else{
				qunlock(ser);
				rcount = read(dfd, data, count);
				qlock(ser);
			}
			/*
			 * if we encounter a long run of continuous read
			 * errors, do something drastic so that our caller
			 * doesn't just spin its wheels forever.
			 */
			if(rcount &lt; 0) {
				snprint(err, Serbufsize, "%r");
				++errrun;
				sleep(20);
				if (good &gt; 0 &amp;&amp; errrun &gt; 10000) {
					/* the line has been dropped; give up */
					qunlock(ser);
					fprint(2, "%s: line %s is gone: %r\n",
						argv0, p-&gt;fs.name);
					threadexitsall("serial line gone");
				}
			} else {
				errrun = 0;
				good++;
			}
			if(usbdebug &gt;= 3)
				dsprint(2, "serial: read: %s %ld\n", err, rcount);
		} while(rcount &lt; 0 &amp;&amp; strstr(err, "timed out") != nil);

		dsprint(2, "serial: read from bulk %ld, %10.10s\n", rcount, err);
		if(rcount &lt; 0){
			dsprint(2, "serial: need to recover, data read %ld %r\n",
				count);
			serialrecover(ser, p, p-&gt;epin, err);
		}
		dsprint(2, "serial: read from bulk %ld\n", rcount);
		count = rcount;
		break;
	case Qctl:
		if(offset != 0 || p-&gt;isjtag)
			count = 0;
		else {
			e = serdumpst(p, buf, Serbufsize);
			count = usbreadbuf(data, count, 0, buf, e - buf);
		}
		break;
	}
	if(count &gt;= 0)
		ser-&gt;recover = 0;
	qunlock(ser);
	free(err);
	free(buf);
	return count;
}

static long
altwrite(Serialport *p, uchar *buf, long count)
{
	int nw, dfd;
	char err[128];
	Serial *ser;

	ser = p-&gt;s;
	do{
		dsprint(2, "serial: write to bulk %ld\n", count);

		if(ser-&gt;wait4write != nil)
			/* unlocked inside later */
			nw = ser-&gt;wait4write(p, buf, count);
		else{
			dfd = p-&gt;epout-&gt;dfd;
			qunlock(ser);
			nw = write(dfd, buf, count);
			qlock(ser);
		}
		rerrstr(err, sizeof err);
		dsprint(2, "serial: written %s %d\n", err, nw);
	} while(nw &lt; 0 &amp;&amp; strstr(err, "timed out") != nil);

	if(nw != count){
		dsprint(2, "serial: need to recover, status in write %d %r\n",
			nw);
		snprint(err, sizeof err, "%r");
		serialrecover(p-&gt;s, p, p-&gt;epout, err);
	}
	return nw;
}

static long
dwrite(Usbfs *fs, Fid *fid, void *buf, long count, vlong)
{
	ulong path;
	char *cmd;
	Serialport *p;
	Serial *ser;

	p = fs-&gt;aux;
	ser = p-&gt;s;
	path = fid-&gt;qid.path &amp; ~fs-&gt;qid;

	qlock(ser);
	switch(path){
	case Qdata:
		count = altwrite(p, (uchar *)buf, count);
		break;
	case Qctl:
		if(p-&gt;isjtag)
			break;
		cmd = emallocz(count+1, 1);
		memmove(cmd, buf, count);
		cmd[count] = 0;
		if(serialctl(p, cmd) &lt; 0){
			qunlock(ser);
			werrstr(Ebadctl);
			free(cmd);
			return -1;
		}
		free(cmd);
		break;
	default:
		qunlock(ser);
		werrstr(Eperm);
		return -1;
	}
	if(count &gt;= 0)
		ser-&gt;recover = 0;
	else
		serialrecover(ser, p, p-&gt;epout, "writing");
	qunlock(ser);
	return count;
}

static int
openeps(Serialport *p, int epin, int epout, int epintr)
{
	Serial *ser;

	ser = p-&gt;s;
	p-&gt;epin = openep(ser-&gt;dev, epin);
	if(p-&gt;epin == nil){
		fprint(2, "serial: openep %d: %r\n", epin);
		return -1;
	}
	if(epout == epin){
		incref(p-&gt;epin);
		p-&gt;epout = p-&gt;epin;
	}else
		p-&gt;epout = openep(ser-&gt;dev, epout);
	if(p-&gt;epout == nil){
		fprint(2, "serial: openep %d: %r\n", epout);
		closedev(p-&gt;epin);
		return -1;
	}

	if(!p-&gt;isjtag){
		devctl(p-&gt;epin,  "timeout 1000");
		devctl(p-&gt;epout, "timeout 1000");
	}

	if(ser-&gt;hasepintr){
		p-&gt;epintr = openep(ser-&gt;dev, epintr);
		if(p-&gt;epintr == nil){
			fprint(2, "serial: openep %d: %r\n", epintr);
			closedev(p-&gt;epin);
			closedev(p-&gt;epout);
			return -1;
		}
		opendevdata(p-&gt;epintr, OREAD);
		devctl(p-&gt;epintr, "timeout 1000");
	}

	if(ser-&gt;seteps!= nil)
		ser-&gt;seteps(p);
	if(p-&gt;epin == p-&gt;epout)
		opendevdata(p-&gt;epin, ORDWR);
	else{
		opendevdata(p-&gt;epin, OREAD);
		opendevdata(p-&gt;epout, OWRITE);
	}
	if(p-&gt;epin-&gt;dfd &lt; 0 ||p-&gt;epout-&gt;dfd &lt; 0 ||
	    (ser-&gt;hasepintr &amp;&amp; p-&gt;epintr-&gt;dfd &lt; 0)){
		fprint(2, "serial: open i/o ep data: %r\n");
		closedev(p-&gt;epin);
		closedev(p-&gt;epout);
		if(ser-&gt;hasepintr)
			closedev(p-&gt;epintr);
		return -1;
	}
	return 0;
}

static int
findendpoints(Serial *ser, int ifc)
{
	int i, epin, epout, epintr;
	Ep *ep, **eps;

	epintr = epin = epout = -1;

	/*
	 * interfc 0 means start from the start which is equiv to
	 * iterate through endpoints probably, could be done better
	 */
	eps = ser-&gt;dev-&gt;usb-&gt;conf[0]-&gt;iface[ifc]-&gt;ep;

	for(i = 0; i &lt; Niface; i++){
		if((ep = eps[i]) == nil)
			continue;
		if(ser-&gt;hasepintr &amp;&amp; ep-&gt;type == Eintr &amp;&amp;
		    ep-&gt;dir == Ein &amp;&amp; epintr == -1)
			epintr = ep-&gt;id;
		if(ep-&gt;type == Ebulk){
			if((ep-&gt;dir == Ein || ep-&gt;dir == Eboth) &amp;&amp; epin == -1)
				epin = ep-&gt;id;
			if((ep-&gt;dir == Eout || ep-&gt;dir == Eboth) &amp;&amp; epout == -1)
				epout = ep-&gt;id;
		}
	}
	dprint(2, "serial[%d]: ep ids: in %d out %d intr %d\n", ifc, epin, epout, epintr);
	if(epin == -1 || epout == -1 || (ser-&gt;hasepintr &amp;&amp; epintr == -1))
		return -1;

	if(openeps(&amp;ser-&gt;p[ifc], epin, epout, epintr) &lt; 0)
		return -1;

	dprint(2, "serial: ep in %s out %s\n", ser-&gt;p[ifc].epin-&gt;dir, ser-&gt;p[ifc].epout-&gt;dir);
	if(ser-&gt;hasepintr)
		dprint(2, "serial: ep intr %s\n", ser-&gt;p[ifc].epintr-&gt;dir);

	if(usbdebug &gt; 1 || serialdebug &gt; 2){
		devctl(ser-&gt;p[ifc].epin,  "debug 1");
		devctl(ser-&gt;p[ifc].epout, "debug 1");
		if(ser-&gt;hasepintr)
			devctl(ser-&gt;p[ifc].epintr, "debug 1");
		devctl(ser-&gt;dev, "debug 1");
	}
	return 0;
}

/* keep in sync with main.c */
static int
usage(void)
{
	werrstr("usage: usb/serial [-dD] [-m mtpt] [-s srv]");
	return -1;
}

static void
serdevfree(void *a)
{
	Serial *ser = a;
	Serialport *p;
	int i;

	if(ser == nil)
		return;

	for(i = 0; i &lt; ser-&gt;nifcs; i++){
		p = &amp;ser-&gt;p[i];

		if(ser-&gt;hasepintr)
			closedev(p-&gt;epintr);
		closedev(p-&gt;epin);
		closedev(p-&gt;epout);
		p-&gt;epintr = p-&gt;epin = p-&gt;epout = nil;
		if(p-&gt;w4data != nil)
			chanfree(p-&gt;w4data);
		if(p-&gt;gotdata != nil)
			chanfree(p-&gt;gotdata);
		if(p-&gt;readc)
			chanfree(p-&gt;readc);

	}
	free(ser);
}

static Usbfs serialfs = {
	.walk =	dwalk,
	.open =	dopen,
	.read =	dread,
	.write=	dwrite,
	.stat =	dstat,
};

static void
serialfsend(Usbfs *fs)
{
	Serialport *p;

	p = fs-&gt;aux;

	if(p-&gt;w4data != nil)
		chanclose(p-&gt;w4data);
	if(p-&gt;gotdata != nil)
		chanclose(p-&gt;gotdata);
	if(p-&gt;readc)
		chanclose(p-&gt;readc);
}

int
serialmain(Dev *dev, int argc, char* argv[])
{
	Serial *ser;
	Serialport *p;
	char buf[50];
	int i, devid;

	devid = dev-&gt;id;
	ARGBEGIN{
	case 'd':
		serialdebug++;
		break;
	case 'N':
		devid = atoi(EARGF(usage()));
		break;
	default:
		return usage();
	}ARGEND
	if(argc != 0)
		return usage();

	ser = dev-&gt;aux = emallocz(sizeof(Serial), 1);
	ser-&gt;maxrtrans = ser-&gt;maxwtrans = sizeof ser-&gt;p[0].data;
	ser-&gt;maxread = ser-&gt;maxwrite = sizeof ser-&gt;p[0].data;
	ser-&gt;dev = dev;
	dev-&gt;free = serdevfree;
	ser-&gt;jtag = -1;
	ser-&gt;nifcs = 1;

	snprint(buf, sizeof buf, "vid %#06x did %#06x",
		dev-&gt;usb-&gt;vid, dev-&gt;usb-&gt;did);
	if(plmatch(buf) == 0){
		ser-&gt;hasepintr = 1;
		ser-&gt;Serialops = plops;
	} else if(uconsmatch(buf) == 0)
		ser-&gt;Serialops = uconsops;
	else if(ftmatch(ser, buf) == 0)
		ser-&gt;Serialops = ftops;
	else if(slmatch(buf) == 0)
		ser-&gt;Serialops = slops;
	else {
		werrstr("serial: no serial devices found");
		return -1;
	}
	for(i = 0; i &lt; ser-&gt;nifcs; i++){
		p = &amp;ser-&gt;p[i];
		p-&gt;interfc = i;
		p-&gt;s = ser;
		p-&gt;fs = serialfs;
		if(i == ser-&gt;jtag){
			p-&gt;isjtag++;
		}
		if(findendpoints(ser, i) &lt; 0){
			werrstr("serial: no endpoints found for ifc %d", i);
			return -1;
		}
		p-&gt;w4data  = chancreate(sizeof(ulong), 0);
		p-&gt;gotdata = chancreate(sizeof(ulong), 0);
	}

	qlock(ser);
	serialreset(ser);
	for(i = 0; i &lt; ser-&gt;nifcs; i++){
		p = &amp;ser-&gt;p[i];
		dprint(2, "serial: valid interface, calling serinit\n");
		if(serinit(p) &lt; 0){
			dprint(2, "serial: serinit: %r\n");
			return -1;
		}

		dsprint(2, "serial: adding interface %d, %p\n", p-&gt;interfc, p);
		if(p-&gt;isjtag){
			snprint(p-&gt;name, sizeof p-&gt;name, "jtag");
			dsprint(2, "serial: JTAG interface %d %p\n", i, p);
			snprint(p-&gt;fs.name, sizeof p-&gt;fs.name, "jtag%d.%d", devid, i);
		} else {
			snprint(p-&gt;name, sizeof p-&gt;name, "eiaU");
			if(i == 0)
				snprint(p-&gt;fs.name, sizeof p-&gt;fs.name, "eiaU%d", devid);
			else
				snprint(p-&gt;fs.name, sizeof p-&gt;fs.name, "eiaU%d.%d", devid, i);
		}
		fprint(2, "%s...", p-&gt;fs.name);
		p-&gt;fs.dev = dev;
		incref(dev);
		p-&gt;fs.aux = p;
		p-&gt;fs.end = serialfsend;
		usbfsadd(&amp;p-&gt;fs);
	}

	qunlock(ser);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

