<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/usbd/dev.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/usbd/dev.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Framework for USB devices.
 * Some of them may be embedded into usbd and some of
 * them may exist as /bin/usb/* binaries on their own.
 *
 * When embedded, devmain() is given a ref of an already
 * configured and open Dev. If devmain()
 * does not fail it should release this ref when done and
 * use incref to add further refs to it.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "usb.h"
#include "usbd.h"

static Lock masklck;
extern Devtab devtab[];
static char* cputype;

int
getdevnb(uvlong *maskp)
{
	int i;

	lock(&amp;masklck);
	for(i = 0; i &lt; 8 * sizeof *maskp; i++)
		if((*maskp &amp; (1ULL&lt;&lt;i)) == 0){
			*maskp |= 1ULL&lt;&lt;i;
			unlock(&amp;masklck);
			return i;
		}
	unlock(&amp;masklck);
	return -1;
}

void
putdevnb(uvlong *maskp, int id)
{
	lock(&amp;masklck);
	if(id &gt;= 0)
		*maskp &amp;= ~(1ULL&lt;&lt;id);
	unlock(&amp;masklck);
}
		
static int
cspmatch(Devtab *dt, int dcsp)
{
	int	i;
	int	csp;

	for(i = 0; i &lt; nelem(dt-&gt;csps); i++)
		if((csp=dt-&gt;csps[i]) != 0)
		if(csp == dcsp)
			return 1;
		else if((csp&amp;DCL) &amp;&amp; (csp&amp;~DCL) == Class(dcsp))
			return 1;
	return 0;
}

static int
devmatch(Devtab *dt, Usbdev *d)
{
	int i;
	int c;
	Conf *cp;

	if(dt-&gt;noauto)
		return 0;
	if(dt-&gt;vid != -1 &amp;&amp; d-&gt;vid != dt-&gt;vid)
		return 0;
	if(dt-&gt;did != -1 &amp;&amp; d-&gt;did != dt-&gt;did)
		return 0;
	if(cspmatch(dt, d-&gt;csp))
		return 1;
	for(c = 0; c &lt; Nconf; c++)
		if((cp=d-&gt;conf[c]) != nil)
			for(i = 0; i &lt; Niface; i++)
				if(cp-&gt;iface[i] != nil)
					if(cspmatch(dt, cp-&gt;iface[i]-&gt;csp))
						return 1;
	return 0;
}

/* We can't use procexec to execute drivers, because
 * procexec mounts #| at /mnt/temp and we do *not*
 * have /mnt/temp at boot time.
 * Instead, we use access to guess if we can execute the file.
 * and reply as procexec. Be careful that the child inherits
 * all the shared state of the thread library. It should run unnoticed.
 */
static void
xexec(Channel *c, char *nm, char *args[])
{
	int	pid;

	if(access(nm, AEXEC) == 0){
		pid = rfork(RFFDG|RFREND|RFPROC);
		switch(pid){
		case 0:
			exec(nm, args);
			_exits("exec");
		case -1:
			break;
		default:
			sendul(c, pid);
			threadexits(nil);
		}
	}
}

typedef struct Sarg Sarg;
struct Sarg{
	Port *pp;
	Devtab* dt;
	Channel*rc;
	char fname[80];
	char	args[128];
	char	*argv[40];
};

static void
startdevproc(void *a)
{
	Sarg	*sa = a;
	Dev	*d;
	Devtab *dt;
	int	argc;
	char *args, *argse, **argv;
	char *fname;

	threadsetgrp(threadid());
	d = sa-&gt;pp-&gt;dev;
	dt = sa-&gt;dt;
	args = sa-&gt;args;
	argse = sa-&gt;args + sizeof sa-&gt;args;
	argv = sa-&gt;argv;
	fname = sa-&gt;fname;
	sa-&gt;pp-&gt;devmaskp = &amp;dt-&gt;devmask;
	sa-&gt;pp-&gt;devnb = getdevnb(&amp;dt-&gt;devmask);
	if(sa-&gt;pp-&gt;devnb &lt; 0){
		sa-&gt;pp-&gt;devmaskp = nil;
		sa-&gt;pp-&gt;devnb = 0;
	}else
		args = seprint(args, argse, "-N %d", sa-&gt;pp-&gt;devnb);
	if(dt-&gt;args != nil)
		seprint(args, argse, " %s", dt-&gt;args);
	args = sa-&gt;args;
	dprint(2, "%s: start: %s %s\n", argv0, dt-&gt;name, args);
	argv[0] = dt-&gt;name;
	argc = 1;
	if(args[0] != 0)
		argc += tokenize(args, argv+1, nelem(sa-&gt;argv)-2);
	argv[argc] = nil;
	if(dt-&gt;init == nil){
		if(d-&gt;dfd &gt; 0 ){
			close(d-&gt;dfd);
			d-&gt;dfd = -1;
		}
		rfork(RFCFDG);
		open("/dev/null", OREAD);
		open("/dev/cons", OWRITE);
		open("/dev/cons", OWRITE);

		xexec(sa-&gt;rc, argv[0], argv);
		snprint(fname, sizeof(sa-&gt;fname), "/bin/usb/%s", dt-&gt;name);
		xexec(sa-&gt;rc, fname, argv);
		snprint(fname, sizeof(sa-&gt;fname), "/boot/%s", dt-&gt;name);
		xexec(sa-&gt;rc, fname, argv);
		if(cputype == nil)
			cputype = getenv("cputype");
		if(cputype != nil){
			snprint(fname, sizeof(sa-&gt;fname), "/%s/bin/%s",
				cputype, dt-&gt;name);
			argv[0] = fname;
			xexec(sa-&gt;rc, fname, argv);
		}
		fprint(2, "%s: %s: not found. can't exec\n", argv0, dt-&gt;name);
		sendul(sa-&gt;rc, -1);
		threadexits("exec");
	}else{
		sa-&gt;pp-&gt;dev = opendev(d-&gt;dir);
		sendul(sa-&gt;rc, 0);
		if(dt-&gt;init(d, argc, argv) &lt; 0)
			fprint(2, "%s: %s: %r\n", argv0, dt-&gt;name);
		closedev(d);
		free(sa);
	}
	threadexits(nil);
}

static void
writeinfo(Dev *d)
{
	char buf[128];
	char *s;
	char *se;
	Usbdev *ud;
	Conf *c;
	Iface *ifc;
	int i, j;

	ud = d-&gt;usb;
	s = buf;
	se = buf+sizeof(buf);
	s = seprint(s, se, "info %s csp %#08ulx", classname(ud-&gt;class), ud-&gt;csp);
	for(i = 0; i &lt; ud-&gt;nconf; i++){
		c = ud-&gt;conf[i];
		if(c == nil)
			break;
		for(j = 0; j &lt; nelem(c-&gt;iface); j++){
			ifc = c-&gt;iface[j];
			if(ifc == nil)
				break;
			if(ifc-&gt;csp != ud-&gt;csp)
				s = seprint(s, se, " csp %#08ulx", ifc-&gt;csp);
		}
	}
	s = seprint(s, se, " vid %06#x did %06#x", ud-&gt;vid, ud-&gt;did);
	seprint(s, se, " %q %q", ud-&gt;vendor, ud-&gt;product);
	devctl(d, "%s", buf);
}

int
startdev(Port *pp)
{
	Dev *d;
	Usbdev *ud;
	Devtab *dt;
	Sarg *sa;
	Channel *rc;

	d = pp-&gt;dev;
	assert(d);
	ud = d-&gt;usb;
	assert(ud != nil);

	writeinfo(d);

	if(ud-&gt;class == Clhub){
		/*
		 * Hubs are handled directly by this process avoiding
		 * concurrent operation so that at most one device
		 * has the config address in use.
		 * We cancel kernel debug for these eps. too chatty.
		 */
		pp-&gt;hub = newhub(d-&gt;dir, d);
		if(pp-&gt;hub == nil)
			fprint(2, "%s: %s: %r\n", argv0, d-&gt;dir);
		else
			fprint(2, "usb/hub... ");
		if(usbdebug &gt; 1)
			devctl(d, "debug 0");	/* polled hubs are chatty */
		return pp-&gt;hub == nil ? -1 : 0;
	}

	for(dt = devtab; dt-&gt;name != nil; dt++)
		if(devmatch(dt, ud))
			break;
	/*
	 * From here on the device is for the driver.
	 * When we return pp-&gt;dev contains a Dev just for us
	 * with only the ctl open. Both devs are released on the last closedev:
	 * driver's upon I/O errors and ours upon port dettach.
	 */
	if(dt-&gt;name == nil){
		dprint(2, "%s: no configured entry for %s (csp %#08lx)\n",
			argv0, d-&gt;dir, ud-&gt;csp);
		close(d-&gt;dfd);
		d-&gt;dfd = -1;
		return 0;
	}
	sa = emallocz(sizeof(Sarg), 1);
	sa-&gt;pp = pp;
	sa-&gt;dt = dt;
	rc = sa-&gt;rc = chancreate(sizeof(ulong), 1);
	procrfork(startdevproc, sa, Stack, RFNOTEG);
	if(recvul(rc) != 0)
		free(sa);
	chanfree(rc);
	fprint(2, "usb/%s... ", dt-&gt;name);

	sleep(Spawndelay);		/* in case we re-spawn too fast */
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

