<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/usb/usbd/usbd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/usb/usbd/usbd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include "usb.h"
#include "usbfs.h"
#include "usbd.h"

static Channel *portc;
static int win;
static int verbose;

int mainstacksize = Stack;
static Hub *hubs;
static int nhubs;
static int mustdump;
static int pollms = Pollms;

static char *dsname[] = { "disabled", "attached", "configed" };

static int
hubfeature(Hub *h, int port, int f, int on)
{
	int cmd;

	if(on)
		cmd = Rsetfeature;
	else
		cmd = Rclearfeature;
	return usbcmd(h-&gt;dev, Rh2d|Rclass|Rother, cmd, f, port, nil, 0);
}

/*
 * This may be used to detect overcurrent on the hub
 */
static void
checkhubstatus(Hub *h)
{
	uchar buf[4];
	int sts;

	if(h-&gt;isroot)	/* not for root hubs */
		return;
	if(usbcmd(h-&gt;dev, Rd2h|Rclass|Rdev, Rgetstatus, 0, 0, buf, 4) &lt; 0){
		dprint(2, "%s: get hub status: %r\n", h-&gt;dev-&gt;dir);
		return;
	}
	sts = GET2(buf);
	dprint(2, "hub %s: status %#ux\n", h-&gt;dev-&gt;dir, sts);
}

static int
confighub(Hub *h)
{
	int type;
	uchar buf[128];	/* room for extra descriptors */
	int i;
	Usbdev *d;
	DHub *dd;
	Port *pp;
	int nr;
	int nmap;
	uchar *PortPwrCtrlMask;
	int offset;
	int mask;

	d = h-&gt;dev-&gt;usb;
	for(i = 0; i &lt; nelem(d-&gt;ddesc); i++)
		if(d-&gt;ddesc[i] == nil)
			break;
		else if(d-&gt;ddesc[i]-&gt;data.bDescriptorType == Dhub){
			dd = (DHub*)&amp;d-&gt;ddesc[i]-&gt;data;
			nr = Dhublen;
			goto Config;
		}
	type = Rd2h|Rclass|Rdev;
	nr = usbcmd(h-&gt;dev, type, Rgetdesc, Dhub&lt;&lt;8|0, 0, buf, sizeof buf);
	if(nr &lt; Dhublen){
		dprint(2, "%s: %s: getdesc hub: %r\n", argv0, h-&gt;dev-&gt;dir);
		return -1;
	}
	dd = (DHub*)buf;
Config:
	h-&gt;nport = dd-&gt;bNbrPorts;
	nmap = 1 + h-&gt;nport/8;
	if(nr &lt; 7 + 2*nmap){
		fprint(2, "%s: %s: descr. too small\n", argv0, h-&gt;dev-&gt;dir);
		return -1;
	}
	h-&gt;port = emallocz((h-&gt;nport+1)*sizeof(Port), 1);
	h-&gt;pwrms = dd-&gt;bPwrOn2PwrGood*2;
	if(h-&gt;pwrms &lt; Powerdelay)
		h-&gt;pwrms = Powerdelay;
	h-&gt;maxcurrent = dd-&gt;bHubContrCurrent;
	h-&gt;pwrmode = dd-&gt;wHubCharacteristics[0] &amp; 3;
	h-&gt;compound = (dd-&gt;wHubCharacteristics[0] &amp; (1&lt;&lt;2))!=0;
	h-&gt;leds = (dd-&gt;wHubCharacteristics[0] &amp; (1&lt;&lt;7)) != 0;
	PortPwrCtrlMask = dd-&gt;DeviceRemovable + nmap;
	for(i = 1; i &lt;= h-&gt;nport; i++){
		pp = &amp;h-&gt;port[i];
		offset = i/8;
		mask = 1&lt;&lt;(i%8);
		pp-&gt;removable = (dd-&gt;DeviceRemovable[offset] &amp; mask) != 0;
		pp-&gt;pwrctl = (PortPwrCtrlMask[offset] &amp; mask) != 0;
	}
	return 0;
}

static void
configroothub(Hub *h)
{
	Dev *d;
	char buf[128];
	char *p;
	int nr;

	d = h-&gt;dev;
	h-&gt;nport = 2;
	h-&gt;maxpkt = 8;
	seek(d-&gt;cfd, 0, 0);
	nr = read(d-&gt;cfd, buf, sizeof(buf)-1);
	if(nr &lt; 0)
		goto Done;
	buf[nr] = 0;

	p = strstr(buf, "ports ");
	if(p == nil)
		fprint(2, "%s: %s: no port information\n", argv0, d-&gt;dir);
	else
		h-&gt;nport = atoi(p+6);
	p = strstr(buf, "maxpkt ");
	if(p == nil)
		fprint(2, "%s: %s: no maxpkt information\n", argv0, d-&gt;dir);
	else
		h-&gt;maxpkt = atoi(p+7);
Done:
	h-&gt;port = emallocz((h-&gt;nport+1)*sizeof(Port), 1);
	dprint(2, "%s: %s: ports %d maxpkt %d\n", argv0, d-&gt;dir, h-&gt;nport, h-&gt;maxpkt);
}

Hub*
newhub(char *fn, Dev *d)
{
	Hub *h;
	int i;
	Usbdev *ud;

	h = emallocz(sizeof(Hub), 1);
	h-&gt;isroot = (d == nil);
	if(h-&gt;isroot){
		h-&gt;dev = opendev(fn);
		if(h-&gt;dev == nil){
			fprint(2, "%s: opendev: %s: %r", argv0, fn);
			goto Fail;
		}
		if(opendevdata(h-&gt;dev, ORDWR) &lt; 0){
			fprint(2, "%s: opendevdata: %s: %r\n", argv0, fn);
			goto Fail;
		}
		configroothub(h);	/* never fails */
	}else{
		h-&gt;dev = d;
		if(confighub(h) &lt; 0){
			fprint(2, "%s: %s: config: %r\n", argv0, fn);
			goto Fail;
		}
	}
	if(h-&gt;dev == nil){
		fprint(2, "%s: opendev: %s: %r\n", argv0, fn);
		goto Fail;
	}
	devctl(h-&gt;dev, "hub");
	ud = h-&gt;dev-&gt;usb;
	if(h-&gt;isroot)
		devctl(h-&gt;dev, "info roothub csp %#08ux ports %d",
			0x000009, h-&gt;nport);
	else{
		devctl(h-&gt;dev, "info hub csp %#08ulx ports %d %q %q",
			ud-&gt;csp, h-&gt;nport, ud-&gt;vendor, ud-&gt;product);
		for(i = 1; i &lt;= h-&gt;nport; i++)
			if(hubfeature(h, i, Fportpower, 1) &lt; 0)
				fprint(2, "%s: %s: power: %r\n", argv0, fn);
		sleep(h-&gt;pwrms);
		for(i = 1; i &lt;= h-&gt;nport; i++)
			if(h-&gt;leds != 0)
				hubfeature(h, i, Fportindicator, 1);
	}
	h-&gt;next = hubs;
	hubs = h;
	nhubs++;
	dprint(2, "%s: hub %#p allocated:", argv0, h);
	dprint(2, " ports %d pwrms %d max curr %d pwrm %d cmp %d leds %d\n",
		h-&gt;nport, h-&gt;pwrms, h-&gt;maxcurrent,
		h-&gt;pwrmode, h-&gt;compound, h-&gt;leds);
	incref(h-&gt;dev);
	return h;
Fail:
	if(d != nil)
		devctl(d, "detach");
	free(h-&gt;port);
	free(h);
	dprint(2, "%s: hub %#p failed to start:", argv0, h);
	return nil;
}

static void portdetach(Hub *h, int p);

/*
 * If during enumeration we get an I/O error the hub is gone or
 * in pretty bad shape. Because of retries of failed usb commands
 * (and the sleeps they include) it can take a while to detach all
 * ports for the hub. This detaches all ports and makes the hub void.
 * The parent hub will detect a detach (probably right now) and
 * close it later.
 */
static void
hubfail(Hub *h)
{
	int i;

	for(i = 1; i &lt;= h-&gt;nport; i++)
		portdetach(h, i);
	h-&gt;failed = 1;
}

static void
closehub(Hub *h)
{
	Hub **hl;

	dprint(2, "%s: closing hub %#p\n", argv0, h);
	for(hl = &amp;hubs; *hl != nil; hl = &amp;(*hl)-&gt;next)
		if(*hl == h)
			break;
	if(*hl == nil)
		sysfatal("closehub: no hub");
	*hl = h-&gt;next;
	nhubs--;
	hubfail(h);		/* detach all ports */
	free(h-&gt;port);
	assert(h-&gt;dev != nil);
	devctl(h-&gt;dev, "detach");
	closedev(h-&gt;dev);
	free(h);
}

static int
portstatus(Hub *h, int p)
{
	Dev *d;
	uchar buf[4];
	int t;
	int sts;
	int dbg;

	dbg = usbdebug;
	if(dbg != 0 &amp;&amp; dbg &lt; 4)
		usbdebug = 1;	/* do not be too chatty */
	d = h-&gt;dev;
	t = Rd2h|Rclass|Rother;
	if(usbcmd(d, t, Rgetstatus, 0, p, buf, sizeof(buf)) &lt; 0)
		sts = -1;
	else
		sts = GET2(buf);
	usbdebug = dbg;
	return sts;
}

static char*
stsstr(int sts)
{
	static char s[80];
	char *e;

	e = s;
	if(sts&amp;PSsuspend)
		*e++ = 'z';
	if(sts&amp;PSreset)
		*e++ = 'r';
	if(sts&amp;PSslow)
		*e++ = 'l';
	if(sts&amp;PShigh)
		*e++ = 'h';
	if(sts&amp;PSchange)
		*e++ = 'c';
	if(sts&amp;PSenable)
		*e++ = 'e';
	if(sts&amp;PSstatuschg)
		*e++ = 's';
	if(sts&amp;PSpresent)
		*e++ = 'p';
	if(e == s)
		*e++ = '-';
	*e = 0;
	return s;
}

static int
getmaxpkt(Dev *d, int islow)
{
	uchar buf[64];	/* More room to try to get device-specific descriptors */
	DDev *dd;

	dd = (DDev*)buf;
	if(islow)
		dd-&gt;bMaxPacketSize0 = 8;
	else
		dd-&gt;bMaxPacketSize0 = 64;
	if(usbcmd(d, Rd2h|Rstd|Rdev, Rgetdesc, Ddev&lt;&lt;8|0, 0, buf, sizeof(buf)) &lt; 0)
		return -1;
	return dd-&gt;bMaxPacketSize0;
}

/*
 * BUG: does not consider max. power avail.
 */
static Dev*
portattach(Hub *h, int p, int sts)
{
	Dev *d;
	Port *pp;
	Dev *nd;
	char fname[80];
	char buf[40];
	char *sp;
	int mp;
	int nr;

	d = h-&gt;dev;
	pp = &amp;h-&gt;port[p];
	nd = nil;
	pp-&gt;state = Pattached;
	dprint(2, "%s: %s: port %d attach sts %#ux\n", argv0, d-&gt;dir, p, sts);
	sleep(Connectdelay);
	if(hubfeature(h, p, Fportenable, 1) &lt; 0)
		dprint(2, "%s: %s: port %d: enable: %r\n", argv0, d-&gt;dir, p);
	sleep(Enabledelay);
	if(hubfeature(h, p, Fportreset, 1) &lt; 0){
		dprint(2, "%s: %s: port %d: reset: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	sleep(Resetdelay);
	sts = portstatus(h, p);
	if(sts &lt; 0)
		goto Fail;
	if((sts &amp; PSenable) == 0){
		dprint(2, "%s: %s: port %d: not enabled?\n", argv0, d-&gt;dir, p);
		hubfeature(h, p, Fportenable, 1);
		sts = portstatus(h, p);
		if((sts &amp; PSenable) == 0)
			goto Fail;
	}
	sp = "full";
	if(sts &amp; PSslow)
		sp = "low";
	if(sts &amp; PShigh)
		sp = "high";
	dprint(2, "%s: %s: port %d: attached status %#ux\n", argv0, d-&gt;dir, p, sts);

	if(devctl(d, "newdev %s %d", sp, p) &lt; 0){
		fprint(2, "%s: %s: port %d: newdev: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	seek(d-&gt;cfd, 0, 0);
	nr = read(d-&gt;cfd, buf, sizeof(buf)-1);
	if(nr == 0){
		fprint(2, "%s: %s: port %d: newdev: eof\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	if(nr &lt; 0){
		fprint(2, "%s: %s: port %d: newdev: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	buf[nr] = 0;
	snprint(fname, sizeof(fname), "/dev/usb/%s", buf);
	nd = opendev(fname);
	if(nd == nil){
		fprint(2, "%s: %s: port %d: opendev: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	if(usbdebug &gt; 2)
		devctl(nd, "debug 1");
	if(opendevdata(nd, ORDWR) &lt; 0){
		fprint(2, "%s: %s: opendevdata: %r\n", argv0, nd-&gt;dir);
		goto Fail;
	}
	if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetaddress, nd-&gt;id, 0, nil, 0) &lt; 0){
		dprint(2, "%s: %s: port %d: setaddress: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	if(devctl(nd, "address") &lt; 0){
		dprint(2, "%s: %s: port %d: set address: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}

	mp=getmaxpkt(nd, strcmp(sp, "low") == 0);
	if(mp &lt; 0){
		dprint(2, "%s: %s: port %d: getmaxpkt: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}else{
		dprint(2, "%s; %s: port %d: maxpkt %d\n", argv0, d-&gt;dir, p, mp);
		devctl(nd, "maxpkt %d", mp);
	}
	if((sts &amp; PSslow) != 0 &amp;&amp; strcmp(sp, "full") == 0)
		dprint(2, "%s: %s: port %d: %s is full speed when port is low\n",
			argv0, d-&gt;dir, p, nd-&gt;dir);
	if(configdev(nd) &lt; 0){
		dprint(2, "%s: %s: port %d: configdev: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	/*
	 * We always set conf #1. BUG.
	 */
	if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetconf, 1, 0, nil, 0) &lt; 0){
		dprint(2, "%s: %s: port %d: setconf: %r\n", argv0, d-&gt;dir, p);
		unstall(nd, nd, Eout);
		if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetconf, 1, 0, nil, 0) &lt; 0)
			goto Fail;
	}
	dprint(2, "%s: %U", argv0, nd);
	pp-&gt;state = Pconfiged;
	dprint(2, "%s: %s: port %d: configed: %s\n",
			argv0, d-&gt;dir, p, nd-&gt;dir);
	return pp-&gt;dev = nd;
Fail:
	pp-&gt;state = Pdisabled;
	pp-&gt;sts = 0;
	if(pp-&gt;hub != nil)
		pp-&gt;hub = nil;	/* hub closed by enumhub */
	hubfeature(h, p, Fportenable, 0);
	if(nd != nil)
		devctl(nd, "detach");
	closedev(nd);
	return nil;
}

static void
portdetach(Hub *h, int p)
{
	Dev *d;
	Port *pp;
	extern void usbfsgone(char*);
	d = h-&gt;dev;
	pp = &amp;h-&gt;port[p];

	/*
	 * Clear present, so that we detect an attach on reconnects.
	 */
	pp-&gt;sts &amp;= ~(PSpresent|PSenable);

	if(pp-&gt;state == Pdisabled)
		return;
	pp-&gt;state = Pdisabled;
	dprint(2, "%s: %s: port %d: detached\n", argv0, d-&gt;dir, p);

	if(pp-&gt;hub != nil){
		closehub(pp-&gt;hub);
		pp-&gt;hub = nil;
	}
	if(pp-&gt;devmaskp != nil)
		putdevnb(pp-&gt;devmaskp, pp-&gt;devnb);
	pp-&gt;devmaskp = nil;
	if(pp-&gt;dev != nil){
		devctl(pp-&gt;dev, "detach");
		usbfsgone(pp-&gt;dev-&gt;dir);
		closedev(pp-&gt;dev);
		pp-&gt;dev = nil;
	}
}

/*
 * The next two functions are included to
 * perform a port reset asked for by someone (usually a driver).
 * This must be done while no other device is in using the
 * configuration address and with care to keep the old address.
 * To keep drivers decoupled from usbd they write the reset request
 * to the #u/usb/epN.0/ctl file and then exit.
 * This is unfortunate because usbd must now poll twice as much.
 *
 * An alternative to this reset process would be for the driver to detach
 * the device. The next function could see that, issue a port reset, and
 * then restart the driver once to see if it's a temporary error.
 *
 * The real fix would be to use interrupt endpoints for non-root hubs
 * (would probably make some hubs fail) and add an events file to
 * the kernel to report events to usbd. This is a severe change not
 * yet implemented.
 */
static int
portresetwanted(Hub *h, int p)
{
	char buf[5];
	Port *pp;
	Dev *nd;

	pp = &amp;h-&gt;port[p];
	nd = pp-&gt;dev;
	if(nd != nil &amp;&amp; nd-&gt;cfd &gt;= 0 &amp;&amp; pread(nd-&gt;cfd, buf, 5, 0LL) == 5)
		return strncmp(buf, "reset", 5) == 0;
	else
		return 0;
}

static void
portreset(Hub *h, int p)
{
	int sts;
	Dev *d, *nd;
	Port *pp;

	d = h-&gt;dev;
	pp = &amp;h-&gt;port[p];
	nd = pp-&gt;dev;
	dprint(2, "%s: %s: port %d: resetting\n", argv0, d-&gt;dir, p);
	if(hubfeature(h, p, Fportreset, 1) &lt; 0){
		dprint(2, "%s: %s: port %d: reset: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	sleep(Resetdelay);
	sts = portstatus(h, p);
	if(sts &lt; 0)
		goto Fail;
	if((sts &amp; PSenable) == 0){
		dprint(2, "%s: %s: port %d: not enabled?\n", argv0, d-&gt;dir, p);
		hubfeature(h, p, Fportenable, 1);
		sts = portstatus(h, p);
		if((sts &amp; PSenable) == 0)
			goto Fail;
	}
	nd = pp-&gt;dev;
	opendevdata(nd, ORDWR);
	if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetaddress, nd-&gt;id, 0, nil, 0) &lt; 0){
		dprint(2, "%s: %s: port %d: setaddress: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	if(devctl(nd, "address") &lt; 0){
		dprint(2, "%s: %s: port %d: set address: %r\n", argv0, d-&gt;dir, p);
		goto Fail;
	}
	if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetconf, 1, 0, nil, 0) &lt; 0){
		dprint(2, "%s: %s: port %d: setconf: %r\n", argv0, d-&gt;dir, p);
		unstall(nd, nd, Eout);
		if(usbcmd(nd, Rh2d|Rstd|Rdev, Rsetconf, 1, 0, nil, 0) &lt; 0)
			goto Fail;
	}
	if(nd-&gt;dfd &gt;= 0)
		close(nd-&gt;dfd);
	return;
Fail:
	pp-&gt;state = Pdisabled;
	pp-&gt;sts = 0;
	if(pp-&gt;hub != nil)
		pp-&gt;hub = nil;	/* hub closed by enumhub */
	hubfeature(h, p, Fportenable, 0);
	if(nd != nil)
		devctl(nd, "detach");
	closedev(nd);
}

static int
portgone(Port *pp, int sts)
{
	if(sts &lt; 0)
		return 1;
	/*
	 * If it was enabled and it's not now then it may be reconnect.
	 * We pretend it's gone and later we'll see it as attached.
	 */
	if((pp-&gt;sts &amp; PSenable) != 0 &amp;&amp; (sts &amp; PSenable) == 0)
		return 1;
	return (pp-&gt;sts &amp; PSpresent) != 0 &amp;&amp; (sts &amp; PSpresent) == 0;
}

static int
enumhub(Hub *h, int p)
{
	int sts;
	Dev *d;
	Port *pp;
	int onhubs;

	if(h-&gt;failed)
		return 0;
	d = h-&gt;dev;
	if(usbdebug &gt; 3)
		fprint(2, "%s: %s: port %d enumhub\n", argv0, d-&gt;dir, p);

	sts = portstatus(h, p);
	if(sts &lt; 0){
		hubfail(h);		/* avoid delays on detachment */
		return -1;
	}
	pp = &amp;h-&gt;port[p];
	onhubs = nhubs;
	if((sts &amp; PSsuspend) != 0){
		if(hubfeature(h, p, Fportenable, 1) &lt; 0)
			dprint(2, "%s: %s: port %d: enable: %r\n", argv0, d-&gt;dir, p);
		sleep(Enabledelay);
		sts = portstatus(h, p);
		fprint(2, "%s: %s: port %d: resumed (sts %#ux)\n", argv0, d-&gt;dir, p, sts);
	}
	if((pp-&gt;sts &amp; PSpresent) == 0 &amp;&amp; (sts &amp; PSpresent) != 0){
		if(portattach(h, p, sts) != nil)
			if(startdev(pp) &lt; 0)
				portdetach(h, p);
	}else if(portgone(pp, sts))
		portdetach(h, p);
	else if(portresetwanted(h, p))
		portreset(h, p);
	else if(pp-&gt;sts != sts){
		dprint(2, "%s: %s port %d: sts %s %#x -&gt;",
			argv0, d-&gt;dir, p, stsstr(pp-&gt;sts), pp-&gt;sts);
		dprint(2, " %s %#x\n",stsstr(sts), sts);
	}
	pp-&gt;sts = sts;
	if(onhubs != nhubs)
		return -1;
	return 0;
}

static void
dump(void)
{
	Hub *h;
	int i;

	mustdump = 0;
	for(h = hubs; h != nil; h = h-&gt;next)
		for(i = 1; i &lt;= h-&gt;nport; i++)
			fprint(2, "%s: hub %#p %s port %d: %U",
				argv0, h, h-&gt;dev-&gt;dir, i, h-&gt;port[i].dev);
	usbfsdirdump();

}

static void
work(void *a)
{
	Channel *portc;
	char *fn;
	Hub *h;
	int i;

	portc = a;
	threadsetname("work");
	hubs = nil;
	/*
	 * Receive requests for root hubs
	 */
	while((fn = recvp(portc)) != nil){
		dprint(2, "%s: %s starting\n", argv0, fn);
		h = newhub(fn, nil);
		if(h == nil)
			fprint(2, "%s: %s: newhub failed: %r\n", argv0, fn);
		free(fn);
	}
	/*
	 * Enumerate (and acknowledge after first enumeration).
	 * Do NOT perform enumeration concurrently for the same
	 * controller. new devices attached respond to a default
	 * address (0) after reset, thus enumeration has to work
	 * one device at a time at least before addresses have been
	 * assigned.
	 * Do not use hub interrupt endpoint because we
	 * have to poll the root hub(s) in any case.
	 */
	for(;;){
Again:
		for(h = hubs; h != nil; h = h-&gt;next)
			for(i = 1; i &lt;= h-&gt;nport; i++)
				if(enumhub(h, i) &lt; 0){
					/* changes in hub list; repeat */
					goto Again;
				}
		if(portc != nil){
			sendp(portc, nil);
			portc = nil;
		}
		sleep(pollms);
		if(mustdump)
			dump();
	}
}

static int
cfswalk(Usbfs*, Fid *, char *)
{
	werrstr(Enotfound);
	return -1;
}

static int
cfsopen(Usbfs*, Fid *, int)
{
	return 0;
}

static long
cfsread(Usbfs*, Fid *, void *, long , vlong )
{
	return 0;
}

static void
setdrvargs(char *name, char *args)
{
	Devtab *dt;
	extern Devtab devtab[];

	for(dt = devtab; dt-&gt;name != nil; dt++)
		if(strstr(dt-&gt;name, name) != nil)
			dt-&gt;args = estrdup(args);
}

static void
setdrvauto(char *name, int on)
{
	Devtab *dt;
	extern Devtab devtab[];

	for(dt = devtab; dt-&gt;name != nil; dt++)
		if(strstr(dt-&gt;name, name) != nil)
			dt-&gt;noauto = !on;
}

static long
cfswrite(Usbfs*, Fid *, void *data, long cnt, vlong )
{
	char *cmd, *arg;
	char buf[80];
	char *toks[4];

	if(cnt &gt; sizeof(buf))
		cnt = sizeof(buf) - 1;
	strncpy(buf, data, cnt);
	buf[cnt] = 0;
	if(cnt &gt; 0 &amp;&amp; buf[cnt-1] == '\n')
		buf[cnt-1] = 0;
	if(strncmp(buf, "dump", 4) == 0){
		mustdump = 1;
		return cnt;
	}
	if(strncmp(buf, "reset", 5) == 0){
		werrstr("reset not implemented");
		return -1;
	}
	if(strncmp(buf, "exit", 4) == 0){
		threadexitsall(nil);
		return cnt;
	}
	if(tokenize(buf, toks, nelem(toks)) != 2){
		werrstr("usage: auto|debug|diskargs|fsdebug|kbargs|noauto n");
		return -1;
	}
	cmd = toks[0];
	arg = toks[1];
	if(strcmp(cmd, "auto") == 0)
		setdrvauto(arg, 1);
	else if(strcmp(cmd, "debug") == 0)
		usbdebug = atoi(arg);
	else if(strcmp(cmd, "diskargs") == 0)
		setdrvargs("disk", arg);
	else if(strcmp(cmd, "etherargs") == 0)
		setdrvargs("ether", arg);
	else if(strcmp(cmd, "fsdebug") == 0)
		usbfsdebug = atoi(arg);
	else if(strcmp(cmd, "kbargs") == 0)
		setdrvargs("kb", arg);
	else if(strcmp(cmd, "noauto") == 0)
		setdrvauto(arg, 0);
	else{
		werrstr("unknown ctl '%s'", buf);
		return -1;
	}
	fprint(2, "%s: debug %d fsdebug %d\n", argv0, usbdebug, usbfsdebug);
	return cnt;
}

static int
cfsstat(Usbfs* fs, Qid qid, Dir *d)
{
	d-&gt;qid = qid;
	d-&gt;qid.path |= fs-&gt;qid;
	d-&gt;qid.type = 0;
	d-&gt;qid.vers = 0;
	d-&gt;name = "usbdctl";
	d-&gt;length = 0;
	d-&gt;mode = 0664;
	return 0;
}

static Usbfs ctlfs =
{
	.walk = cfswalk,
	.open = cfsopen,
	.read = cfsread,
	.write = cfswrite,
	.stat = cfsstat
};

static void
getenvint(char *env, int *lp)
{
	char *s;

	s = getenv(env);
	if (s != nil)
		*lp = atoi(s);
	free(s);
}

static void
getenvdrvargs(char *env, char *argname)
{
	char *s;

	s = getenv(env);
	if(s != nil)
		setdrvargs(argname, s);
	free(s);
}

static void
args(void)
{
	getenvint("usbdebug",	&amp;usbdebug);
	getenvint("usbfsdebug",	&amp;usbfsdebug);
	getenvdrvargs("kbargs",    "kb");
	getenvdrvargs("diskargs",  "disk");
	getenvdrvargs("etherargs", "ether");
}

static void
usage(void)
{
	fprint(2, "usage: %s [-Dd] [-s srv] [-m mnt] [dev...]\n", argv0);
	threadexitsall("usage");
}

extern void usbfsexits(int);

void
threadmain(int argc, char **argv)
{
	int fd, i, nd;
	char *err, *mnt, *srv;
	Dir *d;

	srv = "usb";
	mnt = "/dev";
	ARGBEGIN{
	case 'D':
		usbfsdebug++;
		break;
	case 'd':
		usbdebug++;
		break;
	case 's':
		srv = EARGF(usage());
		break;
	case 'i':
		pollms = atoi(EARGF(usage()));
		break;
	case 'm':
		mnt = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND;
	if(access("/dev/usb", AEXIST) &lt; 0 &amp;&amp; bind("#u", "/dev", MBEFORE) &lt; 0)
		sysfatal("#u: %r");

	args();

	fmtinstall('U', Ufmt);
	quotefmtinstall();
	rfork(RFNOTEG);
	portc = chancreate(sizeof(char *), 0);
	if(portc == nil)
		sysfatal("chancreate");
	proccreate(work, portc, Stack);
	if(argc == 0){
		fd = open("/dev/usb", OREAD);
		if(fd &lt; 0)
			sysfatal("/dev/usb: %r");
		nd = dirreadall(fd, &amp;d);
		close(fd);
		if(nd &lt; 2)
			sysfatal("/dev/usb: no hubs");
		for(i = 0; i &lt; nd; i++)
			if(strcmp(d[i].name, "ctl") != 0)
				sendp(portc, smprint("/dev/usb/%s", d[i].name));
		free(d);
	}else
		for(i = 0; i &lt; argc; i++)
			sendp(portc, strdup(argv[i]));
	sendp(portc, nil);
	err = recvp(portc);
	chanfree(portc);
	usbfsexits(0);
	usbfsinit(srv, mnt, &amp;usbdirfs, MAFTER);
	snprint(ctlfs.name, sizeof(ctlfs.name), "usbdctl");
	usbfsadd(&amp;ctlfs);
	threadexits(err);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

