<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vc/sgen.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vc/sgen.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "gc.h"

void
noretval(int n)
{

	if(n &amp; 1) {
		gins(ANOP, Z, Z);
		p-&gt;to.type = D_REG;
		p-&gt;to.reg = REGRET;
	}
	if(n &amp; 2) {
		gins(ANOP, Z, Z);
		p-&gt;to.type = D_FREG;
		p-&gt;to.reg = FREGRET;
	}
}

/*
 *	calculate addressability as follows
 *		CONST ==&gt; 20		$value
 *		NAME ==&gt; 10		name
 *		REGISTER ==&gt; 11		register
 *		INDREG ==&gt; 12		*[(reg)+offset]
 *		&amp;10 ==&gt; 2		$name
 *		ADD(2, 20) ==&gt; 2	$name+offset
 *		ADD(3, 20) ==&gt; 3	$(reg)+offset
 *		&amp;12 ==&gt; 3		$(reg)+offset
 *		*11 ==&gt; 11		??
 *		*2 ==&gt; 10		name
 *		*3 ==&gt; 12		*(reg)+offset
 *	calculate complexity (number of registers)
 */
void
xcom(Node *n)
{
	Node *l, *r;
	int t;

	if(n == Z)
		return;
	l = n-&gt;left;
	r = n-&gt;right;
	n-&gt;addable = 0;
	n-&gt;complex = 0;
	switch(n-&gt;op) {
	case OCONST:
		n-&gt;addable = 20;
		return;

	case OREGISTER:
		n-&gt;addable = 11;
		return;

	case OINDREG:
		n-&gt;addable = 12;
		return;

	case ONAME:
		n-&gt;addable = 10;
		return;

	case OADDR:
		xcom(l);
		if(l-&gt;addable == 10)
			n-&gt;addable = 2;
		if(l-&gt;addable == 12)
			n-&gt;addable = 3;
		break;

	case OIND:
		xcom(l);
		if(l-&gt;addable == 11)
			n-&gt;addable = 12;
		if(l-&gt;addable == 3)
			n-&gt;addable = 12;
		if(l-&gt;addable == 2)
			n-&gt;addable = 10;
		break;

	case OADD:
		xcom(l);
		xcom(r);
		if(l-&gt;addable == 20) {
			if(r-&gt;addable == 2)
				n-&gt;addable = 2;
			if(r-&gt;addable == 3)
				n-&gt;addable = 3;
		}
		if(r-&gt;addable == 20) {
			if(l-&gt;addable == 2)
				n-&gt;addable = 2;
			if(l-&gt;addable == 3)
				n-&gt;addable = 3;
		}
		break;

	case OASLMUL:
	case OASMUL:
		xcom(l);
		xcom(r);
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OASASHL;
			r-&gt;vconst = t;
			r-&gt;type = types[TINT];
		}
		break;

	case OMUL:
	case OLMUL:
		xcom(l);
		xcom(r);
		t = vlog(l);
		if(t &gt;= 0) {
			n-&gt;left = r;
			n-&gt;right = l;
			l = r;
			r = n-&gt;right;
		}
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OASHL;
			r-&gt;vconst = t;
			r-&gt;type = types[TINT];
			simplifyshift(n);
		}
		break;

	case OASLDIV:
		xcom(l);
		xcom(r);
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OASLSHR;
			r-&gt;vconst = t;
			r-&gt;type = types[TINT];
		}
		break;

	case OLDIV:
		xcom(l);
		xcom(r);
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OLSHR;
			r-&gt;vconst = t;
			r-&gt;type = types[TINT];
			simplifyshift(n);
		}
		break;

	case OASLMOD:
		xcom(l);
		xcom(r);
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OASAND;
			r-&gt;vconst--;
		}
		break;

	case OLMOD:
		xcom(l);
		xcom(r);
		t = vlog(r);
		if(t &gt;= 0) {
			n-&gt;op = OAND;
			r-&gt;vconst--;
		}
		break;

	case OLSHR:
	case OASHL:
	case OASHR:
		xcom(l);
		xcom(r);
		simplifyshift(n);
		break;

	default:
		if(l != Z)
			xcom(l);
		if(r != Z)
			xcom(r);
		break;
	}
	if(n-&gt;addable &gt;= 10)
		return;

	if(l != Z)
		n-&gt;complex = l-&gt;complex;
	if(r != Z) {
		if(r-&gt;complex == n-&gt;complex)
			n-&gt;complex = r-&gt;complex+1;
		else
		if(r-&gt;complex &gt; n-&gt;complex)
			n-&gt;complex = r-&gt;complex;
	}
	if(n-&gt;complex == 0)
		n-&gt;complex++;

	if(com64(n))
		return;

	switch(n-&gt;op) {
	case OFUNC:
		n-&gt;complex = FNX;
		break;

	case OADD:
	case OXOR:
	case OAND:
	case OOR:
	case OEQ:
	case ONE:
		/*
		 * immediate operators, make const on right
		 */
		if(l-&gt;op == OCONST) {
			n-&gt;left = r;
			n-&gt;right = l;
		}
		break;
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

