<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/readlist.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/readlist.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;venti.h&gt;
#include &lt;bio.h&gt;

char *host;
Biobuf b;
VtConn *z;
uchar *buf;
void run(Biobuf*);
int nn;

void
usage(void)
{
	fprint(2, "usage: readlist [-h host] list\n");
	threadexitsall("usage");
}

int
parsescore(uchar *score, char *buf, int n)
{
	int i, c;

	memset(score, 0, VtScoreSize);

	if(n != VtScoreSize*2){
		werrstr("score wrong length %d", n);
		return -1;
	}
	for(i=0; i&lt;VtScoreSize*2; i++) {
		if(buf[i] &gt;= '0' &amp;&amp; buf[i] &lt;= '9')
			c = buf[i] - '0';
		else if(buf[i] &gt;= 'a' &amp;&amp; buf[i] &lt;= 'f')
			c = buf[i] - 'a' + 10;
		else if(buf[i] &gt;= 'A' &amp;&amp; buf[i] &lt;= 'F')
			c = buf[i] - 'A' + 10;
		else {
			c = buf[i];
			werrstr("bad score char %d '%c'", c, c);
			return -1;
		}

		if((i &amp; 1) == 0)
			c &lt;&lt;= 4;
	
		score[i&gt;&gt;1] |= c;
	}
	return 0;
}

void
threadmain(int argc, char *argv[])
{
	int fd, i;

	ARGBEGIN{
	case 'h':
		host = EARGF(usage());
		break;
	default:
		usage();
		break;
	}ARGEND

	fmtinstall('V', vtscorefmt);
	buf = vtmallocz(VtMaxLumpSize);
	z = vtdial(host);
	if(z == nil)
		sysfatal("could not connect to server: %r");
	if(vtconnect(z) &lt; 0)
		sysfatal("vtconnect: %r");

	if(argc == 0){
		Binit(&amp;b, 0, OREAD);
		run(&amp;b);
	}else{
		for(i=0; i&lt;argc; i++){
			if((fd = open(argv[i], OREAD)) &lt; 0)
				sysfatal("open %s: %r", argv[i]);
			Binit(&amp;b, fd, OREAD);
			run(&amp;b);
		}
	}
	threadexitsall(nil);
}

void
run(Biobuf *b)
{
	char *p, *f[10];
	int nf;
	uchar score[20];
	int type, n;

	while((p = Brdline(b, '\n')) != nil){
		p[Blinelen(b)-1] = 0;
		nf = tokenize(p, f, nelem(f));
		if(nf != 2)
			sysfatal("syntax error in work list");
		if(parsescore(score, f[0], strlen(f[0])) &lt; 0)
			sysfatal("bad score %s in work list", f[0]);
		type = atoi(f[1]);
		n = vtread(z, score, type, buf, VtMaxLumpSize);
		if(n &lt; 0)
			sysfatal("could not read %s %s: %r", f[0], f[1]);
		/* write(1, buf, n); */
		if(++nn%1000 == 0)
			print("%d...", nn);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

