<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/checkindex.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/checkindex.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static int extra, missing, wrong;

static void
phdr(DBlock *eb)
{
	static int did;

	if(!did){
		did = 1;
		print("# diff actual correct\n");
	}
	print("%s block 0x%llux\n", eb-&gt;part-&gt;name, eb-&gt;addr);
}

static void
pie(IEntry *ie, char c)
{
	print("%c %V %22lld %3d %5d %3d\n",
		c, ie-&gt;score, ie-&gt;ia.addr, ie-&gt;ia.type, ie-&gt;ia.size, ie-&gt;ia.blocks);
}

static int
checkbucket(Index *ix, u32int buck, IBucket *ib)
{
	ISect *is;
	DBlock *eb;
	IBucket eib;
	IEntry ie, eie;
	int i, ei, ok, c, hdr;

	is = ix-&gt;sects[indexsect0(ix, buck)];
	if(buck &lt; is-&gt;start || buck &gt;= is-&gt;stop){
		seterr(EAdmin, "cannot find index section for bucket %lud\n", (ulong)buck);
		return -1;
	}
	buck -= is-&gt;start;
	eb = getdblock(is-&gt;part, is-&gt;blockbase + ((u64int)buck &lt;&lt; is-&gt;blocklog), OREAD);
	if(eb == nil)
		return -1;
	unpackibucket(&amp;eib, eb-&gt;data, is-&gt;bucketmagic);

	ok = 0;
	ei = 0;
	hdr = 0;
	for(i = 0; i &lt; ib-&gt;n; i++){
		while(ei &lt; eib.n){
			c = ientrycmp(&amp;ib-&gt;data[i * IEntrySize], &amp;eib.data[ei * IEntrySize]);
			if(c == 0){
				unpackientry(&amp;ie, &amp;ib-&gt;data[i * IEntrySize]);
				unpackientry(&amp;eie, &amp;eib.data[ei * IEntrySize]);
				if(iaddrcmp(&amp;ie.ia, &amp;eie.ia) != 0){
					if(!hdr){
						phdr(eb);
						hdr = 1;
					}
					wrong++;
					pie(&amp;eie, '&lt;');
					pie(&amp;ie, '&gt;');
				}
				ei++;
				goto cont;
			}
			if(c &lt; 0)
				break;
			if(!hdr){
				phdr(eb);
				hdr = 1;
			}
			unpackientry(&amp;eie, &amp;eib.data[ei*IEntrySize]);
			extra++;
			pie(&amp;eie, '&lt;');
			ei++;
			ok = -1;
		}
		if(!hdr){
			phdr(eb);
			hdr = 1;
		}
		unpackientry(&amp;ie, &amp;ib-&gt;data[i*IEntrySize]);
		missing++;
		pie(&amp;ie, '&gt;');
		ok = -1;
	cont:;
	}
	for(; ei &lt; eib.n; ei++){
		if(!hdr){
			phdr(eb);
			hdr = 1;
		}
		unpackientry(&amp;eie, &amp;eib.data[ei*IEntrySize]);
		pie(&amp;eie, '&lt;');
		ok = -1;
	}
	putdblock(eb);
	return ok;
}

int
checkindex(Index *ix, Part *part, u64int off, u64int clumps, int zero)
{
	IEStream *ies;
	IBucket ib, zib;
	ZBlock *z, *b;
	u32int next, buck;
	int ok, bok;
u64int found = 0;

/* ZZZ make buffer size configurable */
	b = alloczblock(ix-&gt;blocksize, 0, ix-&gt;blocksize);
	z = alloczblock(ix-&gt;blocksize, 1, ix-&gt;blocksize);
	ies = initiestream(part, off, clumps, 64*1024);
	if(b == nil || z == nil || ies == nil){
		werrstr("allocating: %r");
		ok = -1;
		goto out;
	}
	ok = 0;
	next = 0;
	memset(&amp;ib, 0, sizeof ib);
	ib.data = b-&gt;data;
	zib.data = z-&gt;data;
	zib.n = 0;
	zib.buck = 0;
	for(;;){
		buck = buildbucket(ix, ies, &amp;ib, ix-&gt;blocksize-IBucketSize);
		found += ib.n;
		if(zero){
			for(; next != buck; next++){
				if(next == ix-&gt;buckets){
					if(buck != TWID32){
						ok = -1;
						werrstr("internal error: bucket out of range");
					}
					if(ok &lt; 0)
						werrstr("%d spurious entries, %d missing, %d wrong", extra, missing, wrong);
					goto out;
				}
				bok = checkbucket(ix, next, &amp;zib);
				if(bok &lt; 0)
					ok = -1;
			}
		}
		if(buck &gt;= ix-&gt;buckets){
			if(buck == TWID32)
				break;
			werrstr("internal error: bucket out of range");
			ok = -1;
			goto out;
		}
		bok = checkbucket(ix, buck, &amp;ib);
		if(bok &lt; 0)
			ok = -1;
		next = buck + 1;
	}
out:
	freeiestream(ies);
	freezblock(z);
	freezblock(b);
	return ok;
}

int
checkbloom(Bloom *b1, Bloom *b2, int fix)
{
	u32int *a1, *a2;
	int i, n, extra, missing;

	if(b1==nil &amp;&amp; b2==nil)
		return 0;
	if(b1==nil || b2==nil){
		werrstr("nil/non-nil");
		return -1;
	}
	wbbloomhead(b1);
	wbbloomhead(b2);
	if(memcmp(b1-&gt;data, b2-&gt;data, BloomHeadSize) != 0){
		werrstr("bloom header mismatch");
		return -1;
	}
	a1 = (u32int*)b1-&gt;data;
	a2 = (u32int*)b2-&gt;data;
	n = b1-&gt;size/4;
	extra = 0;
	missing = 0;
	for(i=BloomHeadSize/4; i&lt;n; i++){
		if(a1[i] != a2[i]){
// print("%.8ux/%.8ux.", a1[i], a2[i]);
			extra   += countbits(a1[i] &amp; ~a2[i]);
			missing += countbits(a2[i] &amp; ~a1[i]);
		}
	}
	if(extra || missing)
		fprint(2, "bloom filter: %d spurious bits, %d missing bits\n",
			extra, missing);
	else
		fprint(2, "bloom filter: correct\n");
	if(!fix &amp;&amp; missing){
		werrstr("missing bits");
		return -1;
	}
	if(fix &amp;&amp; (missing || extra)){
		memmove(b1-&gt;data, b2-&gt;data, b1-&gt;size);
		return writebloom(b1);
	}
	return 0;
}


void
usage(void)
{
	fprint(2, "usage: checkindex [-f] [-B blockcachesize] config tmp\n");
	threadexitsall(0);
}

Config conf;

void
threadmain(int argc, char *argv[])
{
	Bloom *oldbloom, *newbloom;
	Part *part;
	u64int clumps, base;
	u32int bcmem;
	int fix, skipz, ok;

	fix = 0;
	bcmem = 0;
	skipz = 0;
	ARGBEGIN{
	case 'B':
		bcmem = unittoull(ARGF());
		break;
	case 'f':
		fix++;
		break;
	case 'Z':
		skipz = 1;
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc != 2)
		usage();

	ventifmtinstall();

	part = initpart(argv[1], ORDWR|ODIRECT);
	if(part == nil)
		sysfatal("can't initialize temporary partition: %r");

	if(!fix)
		readonly = 1;

	if(initventi(argv[0], &amp;conf) &lt; 0)
		sysfatal("can't init venti: %r");
	if(mainindex-&gt;bloom &amp;&amp; loadbloom(mainindex-&gt;bloom) &lt; 0)
		sysfatal("can't load bloom filter: %r");
	oldbloom = mainindex-&gt;bloom;
	newbloom = nil;
	if(oldbloom){
		newbloom = vtmallocz(sizeof *newbloom);
		bloominit(newbloom, oldbloom-&gt;size, nil);
		newbloom-&gt;data = vtmallocz(oldbloom-&gt;size);
	}
	if(bcmem &lt; maxblocksize * (mainindex-&gt;narenas + mainindex-&gt;nsects * 4 + 16))
		bcmem = maxblocksize * (mainindex-&gt;narenas + mainindex-&gt;nsects * 4 + 16);
	if(0) fprint(2, "initialize %d bytes of disk block cache\n", bcmem);
	initdcache(bcmem);

	fprint(2, "checkindex: building entry list\n");
	clumps = sortrawientries(mainindex, part, &amp;base, newbloom);
	if(clumps == TWID64)
		sysfatal("can't build sorted index: %r");
	fprint(2, "checkindex: checking %lld entries at %lld\n", clumps, base);
	ok = 0;
	if(checkindex(mainindex, part, base, clumps, !skipz) &lt; 0){
		fprint(2, "checkindex: %r\n");
		ok = -1;
	}
	if(checkbloom(oldbloom, newbloom, fix) &lt; 0){
		fprint(2, "checkbloom: %r\n");
		ok = -1;
	}
	if(ok &lt; 0)
		sysfatal("errors found");
	fprint(2, "checkindex: index is correct\n");
	threadexitsall(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

