<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/clump.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/clump.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "whack.h"

/*
 * Write a lump to disk.  Updates ia with an index address
 * for the newly-written lump.  Upon return, the lump will
 * have been placed in the disk cache but will likely not be on disk yet.
 */
int
storeclump(Index *ix, ZBlock *zb, u8int *sc, int type, u32int creator, IAddr *ia)
{
	ZBlock *cb;
	Clump cl;
	u64int a;
	u8int bh[VtScoreSize];
	int size, dsize;

	trace(TraceLump, "storeclump enter", sc, type);
	size = zb-&gt;len;
	if(size &gt; VtMaxLumpSize){
		seterr(EStrange, "lump too large");
		return -1;
	}
	if(vttypevalid(type) &lt; 0){
		seterr(EStrange, "invalid lump type");
		return -1;
	}

	if(0){
		scoremem(bh, zb-&gt;data, size);
		if(scorecmp(sc, bh) != 0){
			seterr(ECorrupt, "storing clump: corrupted; expected=%V got=%V, size=%d", sc, bh, size);
			return -1;
		}
	}

	cb = alloczblock(size + ClumpSize + U32Size, 0, 0);
	if(cb == nil)
		return -1;

	cl.info.type = type;
	cl.info.uncsize = size;
	cl.creator = creator;
	cl.time = now();
	scorecp(cl.info.score, sc);

	trace(TraceLump, "storeclump whackblock");
	dsize = whackblock(&amp;cb-&gt;data[ClumpSize], zb-&gt;data, size);
	if(dsize &gt; 0 &amp;&amp; dsize &lt; size){
		cl.encoding = ClumpECompress;
	}else{
		if(dsize &gt; size){
			fprint(2, "whack error: dsize=%d size=%d\n", dsize, size);
			abort();
		}
		cl.encoding = ClumpENone;
		dsize = size;
		memmove(&amp;cb-&gt;data[ClumpSize], zb-&gt;data, size);
	}
	memset(cb-&gt;data+ClumpSize+dsize, 0, 4);
	cl.info.size = dsize;

	a = writeiclump(ix, &amp;cl, cb-&gt;data);
	trace(TraceLump, "storeclump exit %lld", a);
	freezblock(cb);
	if(a == TWID64)
		return -1;

	ia-&gt;addr = a;
	ia-&gt;type = type;
	ia-&gt;size = size;
	ia-&gt;blocks = (dsize + ClumpSize + (1 &lt;&lt; ABlockLog) - 1) &gt;&gt; ABlockLog;

/*
	qlock(&amp;stats.lock);
	stats.clumpwrites++;
	stats.clumpbwrites += size;
	stats.clumpbcomp += dsize;
	qunlock(&amp;stats.lock);
*/

	return 0;
}

u32int
clumpmagic(Arena *arena, u64int aa)
{
	u8int buf[U32Size];

	if(readarena(arena, aa, buf, U32Size) == TWID32)
		return TWID32;
	return unpackmagic(buf);
}

/*
 * fetch a block based at addr.
 * score is filled in with the block's score.
 * blocks is roughly the length of the clump on disk;
 * if zero, the length is unknown.
 */
ZBlock*
loadclump(Arena *arena, u64int aa, int blocks, Clump *cl, u8int *score, int verify)
{
	Unwhack uw;
	ZBlock *zb, *cb;
	u8int bh[VtScoreSize], *buf;
	u32int n;
	int nunc;

/*
	qlock(&amp;stats.lock);
	stats.clumpreads++;
	qunlock(&amp;stats.lock);
*/

	if(blocks &lt;= 0)
		blocks = 1;

	trace(TraceLump, "loadclump enter");

	cb = alloczblock(blocks &lt;&lt; ABlockLog, 0, 0);
	if(cb == nil)
		return nil;
	n = readarena(arena, aa, cb-&gt;data, blocks &lt;&lt; ABlockLog);
	if(n &lt; ClumpSize){
		if(n != 0)
			seterr(ECorrupt, "loadclump read less than a header");
		freezblock(cb);
		return nil;
	}
	trace(TraceLump, "loadclump unpack");
	if(unpackclump(cl, cb-&gt;data, arena-&gt;clumpmagic) &lt; 0){
		seterr(ECorrupt, "loadclump %s %llud: %r", arena-&gt;name, aa);
		freezblock(cb);
		return nil;
	}
	if(cl-&gt;info.type == VtCorruptType){
		seterr(EOk, "clump is marked corrupt");
		freezblock(cb);
		return nil;
	}
	n -= ClumpSize;
	if(n &lt; cl-&gt;info.size){
		freezblock(cb);
		n = cl-&gt;info.size;
		cb = alloczblock(n, 0, 0);
		if(cb == nil)
			return nil;
		if(readarena(arena, aa + ClumpSize, cb-&gt;data, n) != n){
			seterr(ECorrupt, "loadclump read too little data");
			freezblock(cb);
			return nil;
		}
		buf = cb-&gt;data;
	}else
		buf = cb-&gt;data + ClumpSize;

	scorecp(score, cl-&gt;info.score);

	zb = alloczblock(cl-&gt;info.uncsize, 0, 0);
	if(zb == nil){
		freezblock(cb);
		return nil;
	}
	switch(cl-&gt;encoding){
	case ClumpECompress:
		trace(TraceLump, "loadclump decompress");
		unwhackinit(&amp;uw);
		nunc = unwhack(&amp;uw, zb-&gt;data, cl-&gt;info.uncsize, buf, cl-&gt;info.size);
		if(nunc != cl-&gt;info.uncsize){
			if(nunc &lt; 0)
				seterr(ECorrupt, "decompression of %llud failed: %s", aa, uw.err);
			else
				seterr(ECorrupt, "decompression of %llud gave partial block: %d/%d\n", aa, nunc, cl-&gt;info.uncsize);
			freezblock(cb);
			freezblock(zb);
			return nil;
		}
		break;
	case ClumpENone:
		if(cl-&gt;info.size != cl-&gt;info.uncsize){
			seterr(ECorrupt, "loading clump: bad uncompressed size for uncompressed block %llud", aa);
			freezblock(cb);
			freezblock(zb);
			return nil;
		}
		scoremem(bh, buf, cl-&gt;info.uncsize);
		if(scorecmp(cl-&gt;info.score, bh) != 0)
			seterr(ECorrupt, "pre-copy sha1 wrong at %s %llud: expected=%V got=%V", arena-&gt;name, aa, cl-&gt;info.score, bh);
		memmove(zb-&gt;data, buf, cl-&gt;info.uncsize);
		break;
	default:
		seterr(ECorrupt, "unknown encoding in loadlump %llud", aa);
		freezblock(cb);
		freezblock(zb);
		return nil;
	}
	freezblock(cb);

	if(verify){
		trace(TraceLump, "loadclump verify");
		scoremem(bh, zb-&gt;data, cl-&gt;info.uncsize);
		if(scorecmp(cl-&gt;info.score, bh) != 0){
			seterr(ECorrupt, "loading clump: corrupted at %s %llud; expected=%V got=%V", arena-&gt;name, aa, cl-&gt;info.score, bh);
			freezblock(zb);
			return nil;
		}
		if(vttypevalid(cl-&gt;info.type) &lt; 0){
			seterr(ECorrupt, "loading lump at %s %llud: invalid lump type %d", arena-&gt;name, aa, cl-&gt;info.type);
			freezblock(zb);
			return nil;
		}
	}

	trace(TraceLump, "loadclump exit");
/*
	qlock(&amp;stats.lock);
	stats.clumpbreads += cl-&gt;info.size;
	stats.clumpbuncomp += cl-&gt;info.uncsize;
	qunlock(&amp;stats.lock);
*/
	return zb;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

