<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/config.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/config.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

Index			*mainindex;
int			paranoid = 1;		/* should verify hashes on disk read */

static ArenaPart	*configarenas(char *file);
static ISect		*configisect(char *file);
static Bloom		*configbloom(char *file);

int
initventi(char *file, Config *conf)
{
	statsinit();

	if(file == nil){
		seterr(EOk, "no configuration file");
		return -1;
	}
	if(runconfig(file, conf) &lt; 0){
		seterr(EOk, "can't initialize venti: %r");
		return -1;
	}
	mainindex = initindex(conf-&gt;index, conf-&gt;sects, conf-&gt;nsects);
	if(mainindex == nil)
		return -1;
	mainindex-&gt;bloom = conf-&gt;bloom;
	return 0;
}

static int
numok(char *s)
{
	char *p;

	strtoull(s, &amp;p, 0);
	if(p == s)
		return -1;
	if(*p == 0)
		return 0;
	if(p[1] == 0 &amp;&amp; strchr("MmGgKk", *p))
		return 0;
	return 0;
}

/*
 * configs	:
 *		| configs config
 * config	: "isect" filename
 *		| "arenas" filename
 *		| "index" name
 *		| "bcmem" num
 *		| "mem" num
 *		| "icmem" num
 *		| "queuewrites"
 *		| "httpaddr" address
 *		| "addr" address
 *
 * '#' and \n delimit comments
 */
enum
{
	MaxArgs	= 2
};
int
runconfig(char *file, Config *config)
{
	ArenaPart **av;
	ISect **sv;
	IFile f;
	char *s, *line, *flds[MaxArgs + 1];
	int i, ok;

	if(readifile(&amp;f, file) &lt; 0)
		return -1;
	memset(config, 0, sizeof *config);
	config-&gt;mem = Unspecified;
	ok = -1;
	line = nil;
	for(;;){
		s = ifileline(&amp;f);
		if(s == nil){
			ok = 0;
			break;
		}
		line = estrdup(s);
		i = getfields(s, flds, MaxArgs + 1, 1, " \t\r");
		if(i == 2 &amp;&amp; strcmp(flds[0], "isect") == 0){
			sv = MKN(ISect*, config-&gt;nsects + 1);
			for(i = 0; i &lt; config-&gt;nsects; i++)
				sv[i] = config-&gt;sects[i];
			free(config-&gt;sects);
			config-&gt;sects = sv;
			config-&gt;sects[config-&gt;nsects] = configisect(flds[1]);
			if(config-&gt;sects[config-&gt;nsects] == nil)
				break;
			config-&gt;nsects++;
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "arenas") == 0){
			av = MKN(ArenaPart*, config-&gt;naparts + 1);
			for(i = 0; i &lt; config-&gt;naparts; i++)
				av[i] = config-&gt;aparts[i];
			free(config-&gt;aparts);
			config-&gt;aparts = av;
			config-&gt;aparts[config-&gt;naparts] = configarenas(flds[1]);
			if(config-&gt;aparts[config-&gt;naparts] == nil)
				break;
			config-&gt;naparts++;
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "bloom") == 0){
			if(config-&gt;bloom){
				seterr(EAdmin, "duplicate bloom lines in configuration file %s", file);
				break;
			}
			if((config-&gt;bloom = configbloom(flds[1])) == nil)
				break;
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "index") == 0){
			if(nameok(flds[1]) &lt; 0){
				seterr(EAdmin, "illegal index name %s in config file %s", flds[1], file);
				break;
			}
			if(config-&gt;index != nil){
				seterr(EAdmin, "duplicate indices in config file %s", file);
				break;
			}
			config-&gt;index = estrdup(flds[1]);
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "bcmem") == 0){
			if(numok(flds[1]) &lt; 0){
				seterr(EAdmin, "illegal size %s in config file %s",
					flds[1], file);
				break;
			}
			if(config-&gt;bcmem != 0){
				seterr(EAdmin, "duplicate bcmem lines in config file %s", file);
				break;
			}
			config-&gt;bcmem = unittoull(flds[1]);
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "mem") == 0){
			if(numok(flds[1]) &lt; 0){
				seterr(EAdmin, "illegal size %s in config file %s",
					flds[1], file);
				break;
			}
			if(config-&gt;mem != Unspecified){
				seterr(EAdmin, "duplicate mem lines in config file %s", file);
				break;
			}
			config-&gt;mem = unittoull(flds[1]);
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "icmem") == 0){
			if(numok(flds[1]) &lt; 0){
				seterr(EAdmin, "illegal size %s in config file %s",
					flds[1], file);
				break;
			}
			if(config-&gt;icmem != 0){
				seterr(EAdmin, "duplicate icmem lines in config file %s", file);
				break;
			}
			config-&gt;icmem = unittoull(flds[1]);
		}else if(i == 1 &amp;&amp; strcmp(flds[0], "queuewrites") == 0){
			config-&gt;queuewrites = 1;
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "httpaddr") == 0){
			if(config-&gt;haddr){
				seterr(EAdmin, "duplicate httpaddr lines in configuration file %s", file);
				break;
			}
			config-&gt;haddr = estrdup(flds[1]);
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "webroot") == 0){
			if(config-&gt;webroot){
				seterr(EAdmin, "duplicate webroot lines in configuration file %s", file);
				break;
			}
			config-&gt;webroot = estrdup(flds[1]);
		}else if(i == 2 &amp;&amp; strcmp(flds[0], "addr") == 0){
			if(config-&gt;vaddr){
				seterr(EAdmin, "duplicate addr lines in configuration file %s", file);
				break;
			}
			config-&gt;vaddr = estrdup(flds[1]);
		}else{
			/*
			 * this is insanely paranoid.  a single typo should not
			 * prevent venti from starting.
			 */
			seterr(EAdmin, "illegal line '%s' in configuration file %s", line, file);
			break;
		}
		free(line);
		line = nil;
	}
	free(line);
	freeifile(&amp;f);
	if(ok &lt; 0){
		free(config-&gt;sects);
		config-&gt;sects = nil;
		free(config-&gt;aparts);
		config-&gt;aparts = nil;
	}
	return ok;
}

static ISect*
configisect(char *file)
{
	Part *part;
	ISect *is;
	
	if(0) fprint(2, "configure index section in %s\n", file);

	part = initpart(file, ORDWR|ODIRECT);
	if(part == nil)
		return nil;
	is = initisect(part);
	if(is == nil)
		werrstr("%s: %r", file);
	return is;
}

static ArenaPart*
configarenas(char *file)
{
	ArenaPart *ap;
	Part *part;

	if(0) fprint(2, "configure arenas in %s\n", file);
	part = initpart(file, ORDWR|ODIRECT);
	if(part == nil)
		return nil;
	ap = initarenapart(part);
	if(ap == nil)
		werrstr("%s: %r", file);
	return ap;
}

static Bloom*
configbloom(char *file)
{
	Bloom *b;
	Part *part;

	if(0) fprint(2, "configure bloom in %s\n", file);
	part = initpart(file, ORDWR|ODIRECT);
	if(part == nil)
		return nil;
	b = readbloom(part);
	if(b == nil){
		werrstr("%s: %r", file);
		freepart(part);
	}
	return b;
}

/* for OS X linker, which only resolves functions, not data */
void
needmainindex(void)
{
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

