<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/hdisk.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/hdisk.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"
#include "whack.h"

static int disksummary(HConnect*);
static int diskarenapart(HConnect*, char*, Part*);
static int diskbloom(HConnect*, char*, Part*);
static int diskisect(HConnect*, char*, Part*);

int
hdisk(HConnect *c)
{
	char *disk, *type;
	Part *p;
	int ret;
	
	if(hsethtml(c) &lt; 0)
		return -1;

	disk = hargstr(c, "disk", "");
	if(!disk[0])
		return disksummary(c);
	if((p = initpart(disk, OREAD)) == nil){
		hprint(&amp;c-&gt;hout, "open %s: %r", disk);
		return 0;
	}

	type = hargstr(c, "type", "");
	switch(type[0]){
	case 'a':
		ret = diskarenapart(c, disk, p);
		break;
	case 'b':
		ret = diskbloom(c, disk, p);
		break;
	case 'i':
		ret = diskisect(c, disk, p);
		break;
	default:
		hprint(&amp;c-&gt;hout, "unknown disk type %s", type);
		return 0;
	}
	freepart(p);
	return ret;	
}

static int
disksummary(HConnect *c)
{
	int i;
	Index *ix;
	Part *p;
	
	hprint(&amp;c-&gt;hout, "&lt;h1&gt;venti disks&lt;/h1&gt;\n");
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	ix = mainindex;
	p = nil;
	for(i=0; i&lt;ix-&gt;narenas; i++){
		if(ix-&gt;arenas[i]-&gt;part == p)
			continue;
		p = ix-&gt;arenas[i]-&gt;part;
		hprint(&amp;c-&gt;hout, "&lt;a href=\"/disk?disk=%s&amp;type=a\"&gt;%s&lt;/a&gt; %s\n", p-&gt;name, p-&gt;name, ix-&gt;arenas[i]-&gt;name);
	}
	hprint(&amp;c-&gt;hout, "\n");
	p = nil;
	for(i=0; i&lt;ix-&gt;nsects; i++){
		if(ix-&gt;sects[i]-&gt;part == p)
			continue;
		p = ix-&gt;sects[i]-&gt;part;
		hprint(&amp;c-&gt;hout, "&lt;a href=\"/disk?disk=%s&amp;type=i\"&gt;%s&lt;/a&gt; %s\n", p-&gt;name, p-&gt;name, ix-&gt;sects[i]-&gt;name);
	}
	hprint(&amp;c-&gt;hout, "\n");
	if(ix-&gt;bloom){
		p = ix-&gt;bloom-&gt;part;
		hprint(&amp;c-&gt;hout, "&lt;a href=\"/disk?disk=%s&amp;type=b\"&gt;%s&lt;/a&gt; %s\n", p-&gt;name, p-&gt;name, "bloom filter");
	}
	return 0;
}

static char*
readap(Part *p, ArenaPart *ap)
{
	uchar *blk;
	char *table;
	
	blk = vtmalloc(8192);
	if(readpart(p, PartBlank, blk, 8192) != 8192)
		return nil;
	if(unpackarenapart(ap, blk) &lt; 0){
		werrstr("corrupt arena part header: %r");
		return nil;
	}
	vtfree(blk);
	ap-&gt;tabbase = (PartBlank+HeadSize+ap-&gt;blocksize-1)&amp;~(ap-&gt;blocksize-1);
	ap-&gt;tabsize = ap-&gt;arenabase - ap-&gt;tabbase;
	table = vtmalloc(ap-&gt;tabsize+1);
	if(readpart(p, ap-&gt;tabbase, (uchar*)table, ap-&gt;tabsize) != ap-&gt;tabsize){
		werrstr("reading arena part directory: %r");
		return nil;
	}
	table[ap-&gt;tabsize] = 0;
	return table;
}

static int
xfindarena(char *table, char *name, vlong *start, vlong *end)
{
	int i, nline;
	char *p, *q, *f[4], line[256];
	
	nline = atoi(table);
	p = strchr(table, '\n');
	if(p)
		p++;
	for(i=0; i&lt;nline; i++){
		if(p == nil)
			break;
		q = strchr(p, '\n');
		if(q)
			*q++ = 0;
		if(strlen(p) &gt;= sizeof line){
			p = q;
			continue;
		}
		strcpy(line, p);
		memset(f, 0, sizeof f);
		if(tokenize(line, f, nelem(f)) &lt; 3){
			p = q;
			continue;
		}
		if(strcmp(f[0], name) == 0){
			*start = strtoull(f[1], 0, 0);
			*end = strtoull(f[2], 0, 0);
			return 0;
		}
		p = q;
	}
	return -1;
}

static void
diskarenatable(HConnect *c, char *disk, char *table)
{
	char *p, *q;
	int i, nline;
	char *f[4], line[256], base[256];

	hprint(&amp;c-&gt;hout, "&lt;h2&gt;table&lt;/h2&gt;\n");
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	nline = atoi(table);
	snprint(base, sizeof base, "/disk?disk=%s&amp;type=a", disk);
	p = strchr(table, '\n');
	if(p)
		p++;
	for(i=0; i&lt;nline; i++){
		if(p == nil){
			hprint(&amp;c-&gt;hout, "&lt;b&gt;&lt;i&gt;unexpected end of table&lt;/i&gt;&lt;/b&gt;\n");
			break;
		}
		q = strchr(p, '\n');
		if(q)
			*q++ = 0;
		if(strlen(p) &gt;= sizeof line){
			hprint(&amp;c-&gt;hout, "%s\n", p);
			p = q;
			continue;
		}
		strcpy(line, p);
		memset(f, 0, sizeof f);
		if(tokenize(line, f, 3) &lt; 3){
			hprint(&amp;c-&gt;hout, "%s\n", p);
			p = q;
			continue;
		}
		p = q;
		hprint(&amp;c-&gt;hout, "&lt;a href=\"%s&amp;arena=%s\"&gt;%s&lt;/a&gt; %s %s\n",
			base, f[0], f[0], f[1], f[2]);
	}
	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;\n");
}

static char*
fmttime(char *buf, ulong time)
{
	strcpy(buf, ctime(time));
	buf[28] = 0;
	return buf;
}


static int diskarenaclump(HConnect*, Arena*, vlong, char*);
static int diskarenatoc(HConnect*, Arena*);

static int
diskarenapart(HConnect *c, char *disk, Part *p)
{
	char *arenaname;
	ArenaPart ap;
	ArenaHead head;
	Arena arena;
	char *table;
	char *score;
	char *clump;
	uchar *blk;
	vlong start, end, off;
	char tbuf[60];

	hprint(&amp;c-&gt;hout, "&lt;h1&gt;arena partition %s&lt;/h1&gt;\n", disk);

	if((table = readap(p, &amp;ap)) == nil){
		hprint(&amp;c-&gt;hout, "%r\n");
		goto out;
	}
	
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	hprint(&amp;c-&gt;hout, "version=%d blocksize=%d base=%d\n",
		ap.version, ap.blocksize, ap.arenabase);
	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;\n");

	arenaname = hargstr(c, "arena", "");
	if(arenaname[0] == 0){
		diskarenatable(c, disk, table);
		goto out;
	}
	
	if(xfindarena(table, arenaname, &amp;start, &amp;end) &lt; 0){
		hprint(&amp;c-&gt;hout, "no such arena %s\n", arenaname);
		goto out;
	}
	
	hprint(&amp;c-&gt;hout, "&lt;h2&gt;arena %s&lt;/h2&gt;\n", arenaname);
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;start=%#llx end=%#llx&lt;pre&gt;\n", start, end);
	if(end &lt; start || end - start &lt; HeadSize){
		hprint(&amp;c-&gt;hout, "bad size %#llx\n", end - start);
		goto out;
	}

	// read arena header, tail
	blk = vtmalloc(HeadSize);
	if(readpart(p, start, blk, HeadSize) != HeadSize){
		hprint(&amp;c-&gt;hout, "reading header: %r\n");
		vtfree(blk);
		goto out;
	}
	if(unpackarenahead(&amp;head, blk) &lt; 0){
		hprint(&amp;c-&gt;hout, "corrupt arena header: %r\n");
		// hhex(blk, HeadSize);
		vtfree(blk);
		goto out;
	}
	vtfree(blk);

	hprint(&amp;c-&gt;hout, "head:\n&lt;pre&gt;\n");
	hprint(&amp;c-&gt;hout, "version=%d name=%s blocksize=%d size=%#llx clumpmagic=%#ux\n",
		head.version, head.name, head.blocksize, head.size, 
		head.clumpmagic);
	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;&lt;br&gt;&lt;br&gt;\n");

	if(head.blocksize &gt; MaxIoSize || head.blocksize &gt;= end - start){
		hprint(&amp;c-&gt;hout, "corrupt block size %d\n", head.blocksize);
		goto out;
	}

	blk = vtmalloc(head.blocksize);
	if(readpart(p, end - head.blocksize, blk, head.blocksize) &lt; 0){
		hprint(&amp;c-&gt;hout, "reading tail: %r\n");
		vtfree(blk);
		goto out;
	}
	memset(&amp;arena, 0, sizeof arena);
	arena.part = p;
	arena.blocksize = head.blocksize;
	arena.clumpmax = head.blocksize / ClumpInfoSize;
	arena.base = start + head.blocksize;
	arena.size = end - start - 2 * head.blocksize;
	if(unpackarena(&amp;arena, blk) &lt; 0){
		vtfree(blk);
		goto out;
	}
	scorecp(arena.score, blk+head.blocksize - VtScoreSize);

	vtfree(blk);
	
	hprint(&amp;c-&gt;hout, "tail:\n&lt;pre&gt;\n");
	hprint(&amp;c-&gt;hout, "version=%d name=%s\n", arena.version, arena.name);
	hprint(&amp;c-&gt;hout, "ctime=%d %s\n", arena.ctime, fmttime(tbuf, arena.ctime));
	hprint(&amp;c-&gt;hout, "wtime=%d %s\n", arena.wtime, fmttime(tbuf, arena.wtime));
	hprint(&amp;c-&gt;hout, "clumpmagic=%#ux\n", arena.clumpmagic);
	hprint(&amp;c-&gt;hout, "score %V\n", arena.score);
	hprint(&amp;c-&gt;hout, "diskstats:\n");
	hprint(&amp;c-&gt;hout, "\tclumps=%,d cclumps=%,d used=%,lld uncsize=%,lld sealed=%d\n",
		arena.diskstats.clumps, arena.diskstats.cclumps,
		arena.diskstats.used, arena.diskstats.uncsize,
		arena.diskstats.sealed);
	hprint(&amp;c-&gt;hout, "memstats:\n");
	hprint(&amp;c-&gt;hout, "\tclumps=%,d cclumps=%,d used=%,lld uncsize=%,lld sealed=%d\n",
		arena.memstats.clumps, arena.memstats.cclumps,
		arena.memstats.used, arena.memstats.uncsize,
		arena.memstats.sealed);
	if(arena.clumpmax == 0){
		hprint(&amp;c-&gt;hout, "bad clumpmax\n");
		goto out;
	}

	score = hargstr(c, "score", "");
	clump = hargstr(c, "clump", "");

	if(clump[0]){
		off = strtoull(clump, 0, 0);
		diskarenaclump(c, &amp;arena, off, score[0] ? score : nil);
	}else if(score[0]){
		diskarenaclump(c, &amp;arena, -1, score);
	}else{
		diskarenatoc(c, &amp;arena);
	}

out:
	free(table);
	return 0;
}

static vlong
findintoc(HConnect *c, Arena *arena, uchar *score)
{
	uchar *blk;
	int i;
	vlong off;
	vlong coff;
	ClumpInfo ci;

	blk = vtmalloc(arena-&gt;blocksize);
	off = arena-&gt;base + arena-&gt;size;
	coff = 0;
	for(i=0; i&lt;arena-&gt;memstats.clumps; i++){
		if(i%arena-&gt;clumpmax == 0){
			off -= arena-&gt;blocksize;
			if(readpart(arena-&gt;part, off, blk, arena-&gt;blocksize) != arena-&gt;blocksize){
				if(c)
					hprint(&amp;c-&gt;hout, "&lt;i&gt;clump info directory at %#llx: %r&lt;/i&gt;\n&lt;br&gt;\n",
						off);
				break;
			}
		}
		unpackclumpinfo(&amp;ci, blk+(i%arena-&gt;clumpmax)*ClumpInfoSize);
		if(scorecmp(ci.score, score) == 0){
			vtfree(blk);
			return coff;
		}
		coff += ClumpSize + ci.size;
	}
	vtfree(blk);
	return -1;
}


static int
diskarenatoc(HConnect *c, Arena *arena)
{
	uchar *blk;
	int i;
	vlong off;
	vlong coff;
	ClumpInfo ci;
	char base[512];
	int cib;

	snprint(base, sizeof base, "/disk?disk=%s&amp;type=a&amp;arena=%s",
		arena-&gt;part-&gt;name, arena-&gt;name);

	blk = vtmalloc(arena-&gt;blocksize);
	off = arena-&gt;base + arena-&gt;size;
	hprint(&amp;c-&gt;hout, "&lt;h2&gt;table of contents&lt;/h2&gt;\n");
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	hprint(&amp;c-&gt;hout, "%5s %6s %7s %s\n", "type", "size", "uncsize", "score");
	coff = 0;
	cib = hargint(c, "cib", 0);

	for(i=0; i&lt;arena-&gt;memstats.clumps; i++){
		if(i%arena-&gt;clumpmax == 0){
			off -= arena-&gt;blocksize;
			if(readpart(arena-&gt;part, off, blk, arena-&gt;blocksize) != arena-&gt;blocksize){
				hprint(&amp;c-&gt;hout, "&lt;i&gt;clump info directory at %#llx: %r&lt;/i&gt;\n&lt;br&gt;\n",
					off);
				i += arena-&gt;clumpmax-1;
				coff = -1;
				continue;
			}
		}
		unpackclumpinfo(&amp;ci, blk+(i%arena-&gt;clumpmax)*ClumpInfoSize);
		if(i/arena-&gt;clumpmax == cib || i%arena-&gt;clumpmax == 0){
			hprint(&amp;c-&gt;hout, "%5d %6d %7d %V", 
				ci.type, ci.size, ci.uncsize, ci.score);
			if(coff &gt;= 0)
				hprint(&amp;c-&gt;hout, " at &lt;a href=\"%s&amp;clump=%#llx&amp;score=%V\"&gt;%#llx&lt;/a&gt;", 
					base, coff, ci.score, coff);
			if(i/arena-&gt;clumpmax != cib)
				hprint(&amp;c-&gt;hout, "  &lt;font size=-1&gt;&lt;a href=\"%s&amp;cib=%d\"&gt;more&lt;/a&gt;&lt;/font&gt;", base, i/arena-&gt;clumpmax);
			hprint(&amp;c-&gt;hout, "\n");
		}
		if(coff &gt;= 0)
			coff += ClumpSize + ci.size;
	}
	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;\n");
	return 0;
}

#define	U32GET(p)	((u32int)(((p)[0]&lt;&lt;24)|((p)[1]&lt;&lt;16)|((p)[2]&lt;&lt;8)|(p)[3]))
static int
diskarenaclump(HConnect *c, Arena *arena, vlong off, char *scorestr)
{
	uchar *blk, *blk2;
	Clump cl;
	char err[ERRMAX];
	uchar xscore[VtScoreSize], score[VtScoreSize];
	Unwhack uw;
	int n;
	
	if(scorestr){
		if(vtparsescore(scorestr, nil, score) &lt; 0){
			hprint(&amp;c-&gt;hout, "bad score %s: %r\n", scorestr);
			return -1;
		}
		if(off &lt; 0){
			off = findintoc(c, arena, score);
			if(off &lt; 0){
				hprint(&amp;c-&gt;hout, "score %V not found in arena %s\n", score, arena-&gt;name);
				return -1;
			}
			hprint(&amp;c-&gt;hout, "score %V at %#llx\n", score, off);
		}
	}else
		memset(score, 0, sizeof score);

	if(off &lt; 0){
		hprint(&amp;c-&gt;hout, "bad offset %#llx\n", off);
		return -1;
	}
	
	off += arena-&gt;base;

	blk = vtmalloc(ClumpSize + VtMaxLumpSize);
	if(readpart(arena-&gt;part, off, blk, ClumpSize + VtMaxLumpSize) != ClumpSize + VtMaxLumpSize){
		hprint(&amp;c-&gt;hout, "reading at %#llx: %r\n", off);
		vtfree(blk);
		return -1;
	}

	if(unpackclump(&amp;cl, blk, arena-&gt;clumpmagic) &lt; 0){
		hprint(&amp;c-&gt;hout, "unpackclump: %r\n&lt;br&gt;");
		rerrstr(err, sizeof err);
		if(strstr(err, "magic")){
			hprint(&amp;c-&gt;hout, "trying again with magic=%#ux&lt;br&gt;\n", U32GET(blk));
			if(unpackclump(&amp;cl, blk, U32GET(blk)) &lt; 0){
				hprint(&amp;c-&gt;hout, "unpackclump: %r\n&lt;br&gt;\n");
				goto error;
			}
		}else
			goto error;
	}

	hprint(&amp;c-&gt;hout, "&lt;pre&gt;type=%d size=%d uncsize=%d score=%V\n", cl.info.type, cl.info.size, cl.info.uncsize, cl.info.score);
	hprint(&amp;c-&gt;hout, "encoding=%d creator=%d time=%d %s&lt;/pre&gt;\n", cl.encoding, cl.creator, cl.time, fmttime(err, cl.time));
	
	if(cl.info.type == VtCorruptType)
		hprint(&amp;c-&gt;hout, "clump is marked corrupt&lt;br&gt;\n");
	
	if(cl.info.size &gt;= VtMaxLumpSize){
		hprint(&amp;c-&gt;hout, "clump too big\n");
		goto error;
	}
	
	switch(cl.encoding){
	case ClumpECompress:
		blk2 = vtmalloc(VtMaxLumpSize);
		unwhackinit(&amp;uw);
		n = unwhack(&amp;uw, blk2, cl.info.uncsize, blk+ClumpSize, cl.info.size);
		if(n &lt; 0){
			hprint(&amp;c-&gt;hout, "decompression failed\n");
			vtfree(blk2);
			goto error;
		}
		if(n != cl.info.uncsize){
			hprint(&amp;c-&gt;hout, "got wrong amount: %d wanted %d\n", n, cl.info.uncsize);
			// hhex(blk2, n);
			vtfree(blk2);
			goto error;
		}
		scoremem(xscore, blk2, cl.info.uncsize);
		vtfree(blk2);
		break;
	case ClumpENone:
		scoremem(xscore, blk+ClumpSize, cl.info.size);
		break;
	}
	
	hprint(&amp;c-&gt;hout, "score=%V&lt;br&gt;\n", xscore);
	if(scorestr &amp;&amp; scorecmp(score, xscore) != 0)
		hprint(&amp;c-&gt;hout, "score does NOT match expected %V\n", score);

	vtfree(blk);
	return 0;

error:
	// hhex(blk, ClumpSize + VtMaxLumpSize);
	vtfree(blk);
	return -1;
}

static int
diskbloom(HConnect *c, char *disk, Part *p)
{
	USED(c);
	USED(disk);
	USED(p);
	return 0;
}

static int
diskisect(HConnect *c, char *disk, Part *p)
{
	USED(c);
	USED(disk);
	USED(p);
	return 0;
}

static void
debugamap(HConnect *c)
{
	int i;
	AMap *amap;

	hprint(&amp;c-&gt;hout, "&lt;h2&gt;arena map&lt;/h2&gt;\n");
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");

	amap = mainindex-&gt;amap;
	for(i=0; i&lt;mainindex-&gt;narenas; i++)
		hprint(&amp;c-&gt;hout, "%s %#llx %#llx\n", 
			amap[i].name, amap[i].start, amap[i].stop);
}

static void
debugread(HConnect *c, u8int *score)
{
	int type;
	Lump *u;
	IAddr ia;
	IEntry ie;
	int i;
	Arena *arena;
	u64int aa;
	ZBlock *zb;
	Clump cl;
	vlong off;
	u8int sc[VtScoreSize];

	if(scorecmp(score, zeroscore) == 0){
		hprint(&amp;c-&gt;hout, "zero score\n");
		return;
	}
	
	hprint(&amp;c-&gt;hout, "&lt;h2&gt;index search %V&lt;/h2&gt;&lt;pre&gt;\n", score);
	if(icachelookup(score, -1, &amp;ia) &lt; 0)
		hprint(&amp;c-&gt;hout, "  icache: not found\n");
	else
		hprint(&amp;c-&gt;hout, "  icache: addr=%#llx size=%d type=%d blocks=%d\n",
			ia.addr, ia.size, ia.type, ia.blocks);
	
	if(loadientry(mainindex, score, -1, &amp;ie) &lt; 0)
		hprint(&amp;c-&gt;hout, "  idisk: not found\n");
	else
		hprint(&amp;c-&gt;hout, "  idisk: addr=%#llx size=%d type=%d blocks=%d\n",
			ie.ia.addr, ie.ia.size, ie.ia.type, ie.ia.blocks);
	
	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;&lt;h2&gt;lookup %V&lt;/h2&gt;\n", score);
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	
	for(type=0; type &lt; VtMaxType; type++){
		hprint(&amp;c-&gt;hout, "%V type %d:", score, type);
		u = lookuplump(score, type);
		if(u-&gt;data != nil)
			hprint(&amp;c-&gt;hout, " +cache");
		else
			hprint(&amp;c-&gt;hout, " -cache");
		putlump(u);
		
		if(lookupscore(score, type, &amp;ia) &lt; 0){
			hprint(&amp;c-&gt;hout, " -lookup\n");
			continue;
		}
		hprint(&amp;c-&gt;hout, "\n  lookupscore: addr=%#llx size=%d blocks=%d\n",
			ia.addr, ia.size, ia.blocks);
		
		arena = amapitoa(mainindex, ia.addr, &amp;aa);
		if(arena == nil){
			hprint(&amp;c-&gt;hout, "  amapitoa failed: %r\n");
			continue;
		}

		hprint(&amp;c-&gt;hout, "  amapitoa: aa=%#llx arena="
			"&lt;a href=\"/disk?disk=%s&amp;type=a&amp;arena=%s&amp;score=%V\"&gt;%s&lt;/a&gt;\n",
			aa, arena-&gt;part-&gt;name, arena-&gt;name, score, arena-&gt;name);
		zb = loadclump(arena, aa, ia.blocks, &amp;cl, sc, 1);
		if(zb == nil){
			hprint(&amp;c-&gt;hout, "  loadclump failed: %r\n");
			continue;
		}
		
		hprint(&amp;c-&gt;hout, "  loadclump: uncsize=%d type=%d score=%V\n",
			cl.info.uncsize, cl.info.type, sc);
		if(ia.size != cl.info.uncsize || ia.type != cl.info.type || scorecmp(score, sc) != 0){
			hprint(&amp;c-&gt;hout, "    clump info mismatch\n");
			continue;
		}
	}
	
	if(hargstr(c, "brute", "")[0] == 'y'){
		hprint(&amp;c-&gt;hout, "&lt;/pre&gt;\n");
		hprint(&amp;c-&gt;hout, "&lt;h2&gt;brute force arena search %V&lt;/h2&gt;\n", score);
		hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
		
		for(i=0; i&lt;mainindex-&gt;narenas; i++){
			arena = mainindex-&gt;arenas[i];
			hprint(&amp;c-&gt;hout, "%s...\n", arena-&gt;name);
			hflush(&amp;c-&gt;hout);
			off = findintoc(nil, arena, score);
			if(off &gt;= 0)
				hprint(&amp;c-&gt;hout, "%s %#llx (%#llx)\n", arena-&gt;name, off, mainindex-&gt;amap[i].start + off);
		}
	}

	hprint(&amp;c-&gt;hout, "&lt;/pre&gt;\n");
}

static void
debugmem(HConnect *c)
{
	Index *ix;
	
	ix = mainindex;
	hprint(&amp;c-&gt;hout, "&lt;h2&gt;memory&lt;/h2&gt;\n");
	
	hprint(&amp;c-&gt;hout, "&lt;pre&gt;\n");
	hprint(&amp;c-&gt;hout, "ix=%p\n", ix);
	hprint(&amp;c-&gt;hout, "\tarenas=%p\n", ix-&gt;arenas);
	if(ix-&gt;narenas &gt; 0)
		hprint(&amp;c-&gt;hout, "\tarenas[...] = %p...%p\n", ix-&gt;arenas[0], ix-&gt;arenas[ix-&gt;narenas-1]);
	hprint(&amp;c-&gt;hout, "\tsmap=%p\n", ix-&gt;smap);
	hprint(&amp;c-&gt;hout, "\tamap=%p\n", ix-&gt;amap);
	hprint(&amp;c-&gt;hout, "\tbloom=%p\n", ix-&gt;bloom);
	hprint(&amp;c-&gt;hout, "\tbloom-&gt;data=%p\n", ix-&gt;bloom ? ix-&gt;bloom-&gt;data : nil);
	hprint(&amp;c-&gt;hout, "\tisects=%p\n", ix-&gt;sects);
	if(ix-&gt;nsects &gt; 0)
		hprint(&amp;c-&gt;hout, "\tsects[...] = %p...%p\n", ix-&gt;sects[0], ix-&gt;sects[ix-&gt;nsects-1]);
}

int
hdebug(HConnect *c)
{
	char *scorestr, *op;
	u8int score[VtScoreSize];
	
	if(hsethtml(c) &lt; 0)
		return -1;
	hprint(&amp;c-&gt;hout, "&lt;h1&gt;venti debug&lt;/h1&gt;\n");

	op = hargstr(c, "op", "");
	if(!op[0]){
		hprint(&amp;c-&gt;hout, "no op\n");
		return 0;
	}
	
	if(strcmp(op, "amap") == 0){
		debugamap(c);
		return 0;
	}

	if(strcmp(op, "mem") == 0){
		debugmem(c);
		return 0;
	}

	if(strcmp(op, "read") == 0){
		scorestr = hargstr(c, "score", "");
		if(vtparsescore(scorestr, nil, score) &lt; 0){
			hprint(&amp;c-&gt;hout, "bad score %s: %r\n", scorestr);
			return 0;
		}
		debugread(c, score);
		return 0;
	}
	
	hprint(&amp;c-&gt;hout, "unknown op %s", op);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

