<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/index.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/index.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Index, mapping scores to log positions. 
 *
 * The index is made up of some number of index sections, each of
 * which is typically stored on a different disk.  The blocks in all the 
 * index sections are logically numbered, with each index section 
 * responsible for a range of blocks.  Blocks are typically 8kB.
 *
 * The N index blocks are treated as a giant hash table.  The top 32 bits
 * of score are used as the key for a lookup.  Each index block holds
 * one hash bucket, which is responsible for ceil(2^32 / N) of the key space.
 * 
 * The index is sized so that a particular bucket is extraordinarily 
 * unlikely to overflow: assuming compressed data blocks are 4kB 
 * on disk, and assuming each block has a 40 byte index entry,
 * the index data will be 1% of the total data.  Since scores are essentially
 * random, all buckets should be about the same fullness.
 * A factor of 5 gives us a wide comfort boundary to account for 
 * random variation.  So the index disk space should be 5% of the arena disk space.
 */

#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static int	initindex1(Index*);
static ISect	*initisect1(ISect *is);

#define KEY(k,d)	((d) ? (k)&gt;&gt;(32-(d)) : 0)

static char IndexMagic[] = "venti index configuration";

Index*
initindex(char *name, ISect **sects, int n)
{
	IFile f;
	Index *ix;
	ISect *is;
	u32int last, blocksize, tabsize;
	int i;

	if(n &lt;= 0){
fprint(2, "bad n\n");
		seterr(EOk, "no index sections to initialize index");
		return nil;
	}
	ix = MKZ(Index);
	if(ix == nil){
fprint(2, "no mem\n");
		seterr(EOk, "can't initialize index: out of memory");
		freeindex(ix);
		return nil;
	}

	tabsize = sects[0]-&gt;tabsize;
	if(partifile(&amp;f, sects[0]-&gt;part, sects[0]-&gt;tabbase, tabsize) &lt; 0)
		return nil;
	if(parseindex(&amp;f, ix) &lt; 0){
		freeifile(&amp;f);
		freeindex(ix);
		return nil;
	}
	freeifile(&amp;f);
	if(namecmp(ix-&gt;name, name) != 0){
		seterr(ECorrupt, "mismatched index name: found %s expected %s", ix-&gt;name, name);
		return nil;
	}
	if(ix-&gt;nsects != n){
		seterr(ECorrupt, "mismatched number index sections: found %d expected %d", n, ix-&gt;nsects);
		freeindex(ix);
		return nil;
	}
	ix-&gt;sects = sects;
	last = 0;
	blocksize = ix-&gt;blocksize;
	for(i = 0; i &lt; ix-&gt;nsects; i++){
		is = sects[i];
		if(namecmp(ix-&gt;name, is-&gt;index) != 0
		|| is-&gt;blocksize != blocksize
		|| is-&gt;tabsize != tabsize
		|| namecmp(is-&gt;name, ix-&gt;smap[i].name) != 0
		|| is-&gt;start != ix-&gt;smap[i].start
		|| is-&gt;stop != ix-&gt;smap[i].stop
		|| last != is-&gt;start
		|| is-&gt;start &gt; is-&gt;stop){
			seterr(ECorrupt, "inconsistent index sections in %s", ix-&gt;name);
			freeindex(ix);
			return nil;
		}
		last = is-&gt;stop;
	}
	ix-&gt;tabsize = tabsize;
	ix-&gt;buckets = last;

	if(initindex1(ix) &lt; 0){
		freeindex(ix);
		return nil;
	}

	ix-&gt;arenas = MKNZ(Arena*, ix-&gt;narenas);
	if(maparenas(ix-&gt;amap, ix-&gt;arenas, ix-&gt;narenas, ix-&gt;name) &lt; 0){
		freeindex(ix);
		return nil;
	}

	return ix;
}

static int
initindex1(Index *ix)
{
	u32int buckets;

	ix-&gt;div = (((u64int)1 &lt;&lt; 32) + ix-&gt;buckets - 1) / ix-&gt;buckets;
	buckets = (((u64int)1 &lt;&lt; 32) - 1) / ix-&gt;div + 1;
	if(buckets != ix-&gt;buckets){
		seterr(ECorrupt, "inconsistent math for divisor and buckets in %s", ix-&gt;name);
		return -1;
	}

	return 0;
}

int
wbindex(Index *ix)
{
	Fmt f;
	ZBlock *b;
	int i;

	if(ix-&gt;nsects == 0){
		seterr(EOk, "no sections in index %s", ix-&gt;name);
		return -1;
	}
	b = alloczblock(ix-&gt;tabsize, 1, ix-&gt;blocksize);
	if(b == nil){
		seterr(EOk, "can't write index configuration: out of memory");
		return -1;
	}
	fmtzbinit(&amp;f, b);
	if(outputindex(&amp;f, ix) &lt; 0){
		seterr(EOk, "can't make index configuration: table storage too small %d", ix-&gt;tabsize);
		freezblock(b);
		return -1;
	}
	for(i = 0; i &lt; ix-&gt;nsects; i++){
		if(writepart(ix-&gt;sects[i]-&gt;part, ix-&gt;sects[i]-&gt;tabbase, b-&gt;data, ix-&gt;tabsize) &lt; 0
		|| flushpart(ix-&gt;sects[i]-&gt;part) &lt; 0){
			seterr(EOk, "can't write index: %r");
			freezblock(b);
			return -1;
		}
	}
	freezblock(b);

	for(i = 0; i &lt; ix-&gt;nsects; i++)
		if(wbisect(ix-&gt;sects[i]) &lt; 0)
			return -1;

	return 0;
}

/*
 * index: IndexMagic '\n' version '\n' name '\n' blocksize '\n' [V2: bitblocks '\n'] sections arenas
 * version, blocksize: u32int
 * name: max. ANameSize string
 * sections, arenas: AMap
 */
int
outputindex(Fmt *f, Index *ix)
{
	if(fmtprint(f, "%s\n%ud\n%s\n%ud\n", IndexMagic, ix-&gt;version, ix-&gt;name, ix-&gt;blocksize) &lt; 0
	|| outputamap(f, ix-&gt;smap, ix-&gt;nsects) &lt; 0
	|| outputamap(f, ix-&gt;amap, ix-&gt;narenas) &lt; 0)
		return -1;
	return 0;
}

int
parseindex(IFile *f, Index *ix)
{
	AMapN amn;
	u32int v;
	char *s;

	/*
	 * magic
	 */
	s = ifileline(f);
	if(s == nil || strcmp(s, IndexMagic) != 0){
		seterr(ECorrupt, "bad index magic for %s", f-&gt;name);
		return -1;
	}

	/*
	 * version
	 */
	if(ifileu32int(f, &amp;v) &lt; 0){
		seterr(ECorrupt, "syntax error: bad version number in %s", f-&gt;name);
		return -1;
	}
	ix-&gt;version = v;
	if(ix-&gt;version != IndexVersion){
		seterr(ECorrupt, "bad version number in %s", f-&gt;name);
		return -1;
	}

	/*
	 * name
	 */
	if(ifilename(f, ix-&gt;name) &lt; 0){
		seterr(ECorrupt, "syntax error: bad index name in %s", f-&gt;name);
		return -1;
	}

	/*
	 * block size
	 */
	if(ifileu32int(f, &amp;v) &lt; 0){
		seterr(ECorrupt, "syntax error: bad block size number in %s", f-&gt;name);
		return -1;
	}
	ix-&gt;blocksize = v;

	if(parseamap(f, &amp;amn) &lt; 0)
		return -1;
	ix-&gt;nsects = amn.n;
	ix-&gt;smap = amn.map;

	if(parseamap(f, &amp;amn) &lt; 0)
		return -1;
	ix-&gt;narenas = amn.n;
	ix-&gt;amap = amn.map;

	return 0;
}

/*
 * initialize an entirely new index
 */
Index *
newindex(char *name, ISect **sects, int n)
{
	Index *ix;
	AMap *smap;
	u64int nb;
	u32int div, ub, xb, start, stop, blocksize, tabsize;
	int i, j;

	if(n &lt; 1){
		seterr(EOk, "creating index with no index sections");
		return nil;
	}

	/*
	 * compute the total buckets available in the index,
	 * and the total buckets which are used.
	 */
	nb = 0;
	blocksize = sects[0]-&gt;blocksize;
	tabsize = sects[0]-&gt;tabsize;
	for(i = 0; i &lt; n; i++){
		/*
		 * allow index, start, and stop to be set if index is correct
		 * and start and stop are what we would have picked.
		 * this allows calling fmtindex to reformat the index after
		 * replacing a bad index section with a freshly formatted one.
		 * start and stop are checked below.
		 */
		if(sects[i]-&gt;index[0] != '\0' &amp;&amp; strcmp(sects[i]-&gt;index, name) != 0){
			seterr(EOk, "creating new index using non-empty section %s", sects[i]-&gt;name);
			return nil;
		}
		if(blocksize != sects[i]-&gt;blocksize){
			seterr(EOk, "mismatched block sizes in index sections");
			return nil;
		}
		if(tabsize != sects[i]-&gt;tabsize){
			seterr(EOk, "mismatched config table sizes in index sections");
			return nil;
		}
		nb += sects[i]-&gt;blocks;
	}

	/*
	 * check for duplicate names
	 */
	for(i = 0; i &lt; n; i++){
		for(j = i + 1; j &lt; n; j++){
			if(namecmp(sects[i]-&gt;name, sects[j]-&gt;name) == 0){
				seterr(EOk, "duplicate section name %s for index %s", sects[i]-&gt;name, name);
				return nil;
			}
		}
	}

	if(nb &gt;= ((u64int)1 &lt;&lt; 32)){
		fprint(2, "%s: index is 2^32 blocks or more; ignoring some of it\n",
			argv0);
		nb = ((u64int)1 &lt;&lt; 32) - 1;
	}

	div = (((u64int)1 &lt;&lt; 32) + nb - 1) / nb;
	if(div &lt; 100){
		fprint(2, "%s: index divisor %d too coarse; "
			"index larger than needed, ignoring some of it\n",
			argv0, div);
		div = 100;
		nb = (((u64int)1 &lt;&lt; 32) - 1) / (100 - 1);
	}
	ub = (((u64int)1 &lt;&lt; 32) - 1) / div + 1;
	if(ub &gt; nb){
		seterr(EBug, "index initialization math wrong");
		return nil;
	}
	xb = nb - ub;

	/*
	 * initialize each of the index sections
	 * and the section map table
	 */
	smap = MKNZ(AMap, n);
	if(smap == nil){
		seterr(EOk, "can't create new index: out of memory");
		return nil;
	}
	start = 0;
	for(i = 0; i &lt; n; i++){
		stop = start + sects[i]-&gt;blocks - xb / n;
		if(i == n - 1)
			stop = ub;

		if(sects[i]-&gt;start != 0 || sects[i]-&gt;stop != 0)
		if(sects[i]-&gt;start != start || sects[i]-&gt;stop != stop){
			seterr(EOk, "creating new index using non-empty section %s", sects[i]-&gt;name);
			return nil;
		}

		sects[i]-&gt;start = start;
		sects[i]-&gt;stop = stop;
		namecp(sects[i]-&gt;index, name);

		smap[i].start = start;
		smap[i].stop = stop;
		namecp(smap[i].name, sects[i]-&gt;name);
		start = stop;
	}

	/*
	 * initialize the index itself
	 */
	ix = MKZ(Index);
	if(ix == nil){
		seterr(EOk, "can't create new index: out of memory");
		free(smap);
		return nil;
	}
	ix-&gt;version = IndexVersion;
	namecp(ix-&gt;name, name);
	ix-&gt;sects = sects;
	ix-&gt;smap = smap;
	ix-&gt;nsects = n;
	ix-&gt;blocksize = blocksize;
	ix-&gt;buckets = ub;
	ix-&gt;tabsize = tabsize;
	ix-&gt;div = div;

	if(initindex1(ix) &lt; 0){
		free(smap);
		return nil;
	}

	return ix;
}

ISect*
initisect(Part *part)
{
	ISect *is;
	ZBlock *b;
	int ok;

	b = alloczblock(HeadSize, 0, 0);
	if(b == nil || readpart(part, PartBlank, b-&gt;data, HeadSize) &lt; 0){
		seterr(EAdmin, "can't read index section header: %r");
		return nil;
	}

	is = MKZ(ISect);
	if(is == nil){
		freezblock(b);
		return nil;
	}
	is-&gt;part = part;
	ok = unpackisect(is, b-&gt;data);
	freezblock(b);
	if(ok &lt; 0){
		seterr(ECorrupt, "corrupted index section header: %r");
		freeisect(is);
		return nil;
	}

	if(is-&gt;version != ISectVersion1 &amp;&amp; is-&gt;version != ISectVersion2){
		seterr(EAdmin, "unknown index section version %d", is-&gt;version);
		freeisect(is);
		return nil;
	}

	return initisect1(is);
}

ISect*
newisect(Part *part, u32int vers, char *name, u32int blocksize, u32int tabsize)
{
	ISect *is;
	u32int tabbase;

	is = MKZ(ISect);
	if(is == nil)
		return nil;

	namecp(is-&gt;name, name);
	is-&gt;version = vers;
	is-&gt;part = part;
	is-&gt;blocksize = blocksize;
	is-&gt;start = 0;
	is-&gt;stop = 0;
	tabbase = (PartBlank + HeadSize + blocksize - 1) &amp; ~(blocksize - 1);
	is-&gt;blockbase = (tabbase + tabsize + blocksize - 1) &amp; ~(blocksize - 1);
	is-&gt;blocks = is-&gt;part-&gt;size / blocksize - is-&gt;blockbase / blocksize;
	is-&gt;bucketmagic = 0;
	if(is-&gt;version == ISectVersion2){
		do{
			is-&gt;bucketmagic = fastrand();
		}while(is-&gt;bucketmagic==0);
	}
	is = initisect1(is);
	if(is == nil)
		return nil;

	return is;
}

/*
 * initialize the computed parameters for an index
 */
static ISect*
initisect1(ISect *is)
{
	u64int v;

	is-&gt;buckmax = (is-&gt;blocksize - IBucketSize) / IEntrySize;
	is-&gt;blocklog = u64log2(is-&gt;blocksize);
	if(is-&gt;blocksize != (1 &lt;&lt; is-&gt;blocklog)){
		seterr(ECorrupt, "illegal non-power-of-2 bucket size %d\n", is-&gt;blocksize);
		freeisect(is);
		return nil;
	}
	partblocksize(is-&gt;part, is-&gt;blocksize);
	is-&gt;tabbase = (PartBlank + HeadSize + is-&gt;blocksize - 1) &amp; ~(is-&gt;blocksize - 1);
	if(is-&gt;tabbase &gt;= is-&gt;blockbase){
		seterr(ECorrupt, "index section config table overlaps bucket storage");
		freeisect(is);
		return nil;
	}
	is-&gt;tabsize = is-&gt;blockbase - is-&gt;tabbase;
	v = is-&gt;part-&gt;size &amp; ~(u64int)(is-&gt;blocksize - 1);
	if(is-&gt;blockbase + (u64int)is-&gt;blocks * is-&gt;blocksize != v){
		seterr(ECorrupt, "invalid blocks in index section %s", is-&gt;name);
		/* ZZZ what to do? 
		freeisect(is);
		return nil;
		*/
	}

	if(is-&gt;stop - is-&gt;start &gt; is-&gt;blocks){
		seterr(ECorrupt, "index section overflows available space");
		freeisect(is);
		return nil;
	}
	if(is-&gt;start &gt; is-&gt;stop){
		seterr(ECorrupt, "invalid index section range");
		freeisect(is);
		return nil;
	}

	return is;
}

int
wbisect(ISect *is)
{
	ZBlock *b;

	b = alloczblock(HeadSize, 1, 0);
	if(b == nil){
		/* ZZZ set error? */
		return -1;
	}

	if(packisect(is, b-&gt;data) &lt; 0){
		seterr(ECorrupt, "can't make index section header: %r");
		freezblock(b);
		return -1;
	}
	if(writepart(is-&gt;part, PartBlank, b-&gt;data, HeadSize) &lt; 0 || flushpart(is-&gt;part) &lt; 0){
		seterr(EAdmin, "can't write index section header: %r");
		freezblock(b);
		return -1;
	}
	freezblock(b);

	return 0;
}

void
freeisect(ISect *is)
{
	if(is == nil)
		return;
	free(is);
}

void
freeindex(Index *ix)
{
	int i;

	if(ix == nil)
		return;
	free(ix-&gt;amap);
	free(ix-&gt;arenas);
	if(ix-&gt;sects)
		for(i = 0; i &lt; ix-&gt;nsects; i++)
			freeisect(ix-&gt;sects[i]);
	free(ix-&gt;sects);
	free(ix-&gt;smap);
	free(ix);
}

/*
 * write a clump to an available arena in the index
 * and return the address of the clump within the index.
ZZZ question: should this distinguish between an arena
filling up and real errors writing the clump?
 */
u64int
writeiclump(Index *ix, Clump *c, u8int *clbuf)
{
	u64int a;
	int i;
	IAddr ia;
	AState as;

	trace(TraceLump, "writeiclump enter");
	qlock(&amp;ix-&gt;writing);
	for(i = ix-&gt;mapalloc; i &lt; ix-&gt;narenas; i++){
		a = writeaclump(ix-&gt;arenas[i], c, clbuf);
		if(a != TWID64){
			ix-&gt;mapalloc = i;
			ia.addr = ix-&gt;amap[i].start + a;
			ia.type = c-&gt;info.type;
			ia.size = c-&gt;info.uncsize;
			ia.blocks = (c-&gt;info.size + ClumpSize + (1&lt;&lt;ABlockLog) - 1) &gt;&gt; ABlockLog;
			as.arena = ix-&gt;arenas[i];
			as.aa = ia.addr;
			as.stats = as.arena-&gt;memstats;
			insertscore(c-&gt;info.score, &amp;ia, IEDirty, &amp;as);
			qunlock(&amp;ix-&gt;writing);
			trace(TraceLump, "writeiclump exit");
			return ia.addr;
		}
	}
	qunlock(&amp;ix-&gt;writing);

	seterr(EAdmin, "no space left in arenas");
	trace(TraceLump, "writeiclump failed");
	return TWID64;
}

/*
 * convert an arena index to an relative arena address
 */
Arena*
amapitoa(Index *ix, u64int a, u64int *aa)
{
	int i, r, l, m;

	l = 1;
	r = ix-&gt;narenas - 1;
	while(l &lt;= r){
		m = (r + l) / 2;
		if(ix-&gt;amap[m].start &lt;= a)
			l = m + 1;
		else
			r = m - 1;
	}
	l--;

	if(a &gt; ix-&gt;amap[l].stop){
for(i=0; i&lt;ix-&gt;narenas; i++)
	print("arena %d: %llux - %llux\n", i, ix-&gt;amap[i].start, ix-&gt;amap[i].stop);
print("want arena %d for %llux\n", l, a);
		seterr(ECrash, "unmapped address passed to amapitoa");
		return nil;
	}

	if(ix-&gt;arenas[l] == nil){
		seterr(ECrash, "unmapped arena selected in amapitoa");
		return nil;
	}
	*aa = a - ix-&gt;amap[l].start;
	return ix-&gt;arenas[l];
}

/*
 * convert an arena index to the bounds of the containing arena group.
 */
Arena*
amapitoag(Index *ix, u64int a, u64int *gstart, u64int *glimit, int *g)
{
	u64int aa;
	Arena *arena;
	
	arena = amapitoa(ix, a, &amp;aa);
	if(arena == nil)
		return nil;
	if(arenatog(arena, aa, gstart, glimit, g) &lt; 0)
		return nil;
	*gstart += a - aa;
	*glimit += a - aa;
	return arena;
}

int
iaddrcmp(IAddr *ia1, IAddr *ia2)
{
	return ia1-&gt;type != ia2-&gt;type
		|| ia1-&gt;size != ia2-&gt;size
		|| ia1-&gt;blocks != ia2-&gt;blocks
		|| ia1-&gt;addr != ia2-&gt;addr;
}

/*
 * lookup the score in the partition
 *
 * nothing needs to be explicitly locked:
 * only static parts of ix are used, and
 * the bucket is locked by the DBlock lock.
 */
int
loadientry(Index *ix, u8int *score, int type, IEntry *ie)
{
	ISect *is;
	DBlock *b;
	IBucket ib;
	u32int buck;
	int h, ok;

	ok = -1;

	trace(TraceLump, "loadientry enter");

	/*
	qlock(&amp;stats.lock);
	stats.indexreads++;
	qunlock(&amp;stats.lock);
	*/

	if(!inbloomfilter(mainindex-&gt;bloom, score)){
		trace(TraceLump, "loadientry bloomhit");
		return -1;
	}

	trace(TraceLump, "loadientry loadibucket");
	b = loadibucket(ix, score, &amp;is, &amp;buck, &amp;ib);
	trace(TraceLump, "loadientry loadedibucket");
	if(b == nil)
		return -1;

	if(okibucket(&amp;ib, is) &lt; 0){
		trace(TraceLump, "loadientry badbucket");
		goto out;
	}

	h = bucklook(score, type, ib.data, ib.n);
	if(h &amp; 1){
		h ^= 1;
		trace(TraceLump, "loadientry found");
		unpackientry(ie, &amp;ib.data[h]);
		ok = 0;
		goto out;
	}
	trace(TraceLump, "loadientry notfound");
	addstat(StatBloomFalseMiss, 1);
out:
	putdblock(b);
	trace(TraceLump, "loadientry exit");
	return ok;
}

int
okibucket(IBucket *ib, ISect *is)
{
	if(ib-&gt;n &lt;= is-&gt;buckmax)
		return 0;

	seterr(EICorrupt, "corrupted disk index bucket: n=%ud max=%ud, range=[%lud,%lud)",
		ib-&gt;n, is-&gt;buckmax, is-&gt;start, is-&gt;stop);
	return -1;
}

/*
 * look for score within data;
 * return 1 | byte index of matching index,
 * or 0 | index of least element &gt; score
 */
int
bucklook(u8int *score, int otype, u8int *data, int n)
{
	int i, r, l, m, h, c, cc, type;

	if(otype == -1)
		type = -1;
	else
		type = vttodisktype(otype);
	l = 0;
	r = n - 1;
	while(l &lt;= r){
		m = (r + l) &gt;&gt; 1;
		h = m * IEntrySize;
		for(i = 0; i &lt; VtScoreSize; i++){
			c = score[i];
			cc = data[h + i];
			if(c != cc){
				if(c &gt; cc)
					l = m + 1;
				else
					r = m - 1;
				goto cont;
			}
		}
		cc = data[h + IEntryTypeOff];
		if(type != cc &amp;&amp; type != -1){
			if(type &gt; cc)
				l = m + 1;
			else
				r = m - 1;
			goto cont;
		}
		return h | 1;
	cont:;
	}

	return l * IEntrySize;
}

/*
 * compare two IEntries; consistent with bucklook
 */
int
ientrycmp(const void *vie1, const void *vie2)
{
	u8int *ie1, *ie2;
	int i, v1, v2;

	ie1 = (u8int*)vie1;
	ie2 = (u8int*)vie2;
	for(i = 0; i &lt; VtScoreSize; i++){
		v1 = ie1[i];
		v2 = ie2[i];
		if(v1 != v2){
			if(v1 &lt; v2)
				return -1;
			return 1;
		}
	}
	v1 = ie1[IEntryTypeOff];
	v2 = ie2[IEntryTypeOff];
	if(v1 != v2){
		if(v1 &lt; v2)
			return -1;
		return 1;
	}
	return 0;
}

/*
 * find the number of the index section holding bucket #buck
 */
int
indexsect0(Index *ix, u32int buck)
{
	int r, l, m;

	l = 1;
	r = ix-&gt;nsects - 1;
	while(l &lt;= r){
		m = (r + l) &gt;&gt; 1;
		if(ix-&gt;sects[m]-&gt;start &lt;= buck)
			l = m + 1;
		else
			r = m - 1;
	}
	return l - 1;
}

/*
 * load the index block at bucket #buck
 */
static DBlock*
loadibucket0(Index *ix, u32int buck, ISect **pis, u32int *pbuck, IBucket *ib, int mode)
{
	ISect *is;
	DBlock *b;

	is = ix-&gt;sects[indexsect0(ix, buck)];
	if(buck &lt; is-&gt;start || is-&gt;stop &lt;= buck){
		seterr(EAdmin, "index lookup out of range: %ud not found in index\n", buck);
		return nil;
	}

	buck -= is-&gt;start;
	if((b = getdblock(is-&gt;part, is-&gt;blockbase + ((u64int)buck &lt;&lt; is-&gt;blocklog), mode)) == nil)
		return nil;

	if(pis)
		*pis = is;
	if(pbuck)
		*pbuck = buck;
	if(ib)
		unpackibucket(ib, b-&gt;data, is-&gt;bucketmagic);
	return b;
}

/*
 * find the number of the index section holding score
 */
int
indexsect1(Index *ix, u8int *score)
{
	return indexsect0(ix, hashbits(score, 32) / ix-&gt;div);
}

/*
 * load the index block responsible for score.
 */
static DBlock*
loadibucket1(Index *ix, u8int *score, ISect **pis, u32int *pbuck, IBucket *ib)
{
	return loadibucket0(ix, hashbits(score, 32)/ix-&gt;div, pis, pbuck, ib, OREAD);
}

int
indexsect(Index *ix, u8int *score)
{
	return indexsect1(ix, score);
}

DBlock*
loadibucket(Index *ix, u8int *score, ISect **pis, u32int *pbuck, IBucket *ib)
{
	return loadibucket1(ix, score, pis, pbuck, ib);
}


<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

