<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/lumpqueue.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/lumpqueue.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

typedef struct LumpQueue	LumpQueue;
typedef struct WLump		WLump;

enum
{
	MaxLumpQ	= 1 &lt;&lt; 3	/* max. lumps on a single write queue, must be pow 2 */
};

struct WLump
{
	Lump	*u;
	Packet	*p;
	int	creator;
	int	gen;
	uint	ms;
};

struct LumpQueue
{
	QLock	lock;
	Rendez 	flush;
	Rendez	full;
	Rendez	empty;
	WLump	q[MaxLumpQ];
	int	w;
	int	r;
};

static LumpQueue	*lumpqs;
static int		nqs;

static QLock		glk;
static int		gen;

static void	queueproc(void *vq);

int
initlumpqueues(int nq)
{
	LumpQueue *q;

	int i;
	nqs = nq;

	lumpqs = MKNZ(LumpQueue, nq);

	for(i = 0; i &lt; nq; i++){
		q = &amp;lumpqs[i];
		q-&gt;full.l = &amp;q-&gt;lock;
		q-&gt;empty.l = &amp;q-&gt;lock;
		q-&gt;flush.l = &amp;q-&gt;lock;

		if(vtproc(queueproc, q) &lt; 0){
			seterr(EOk, "can't start write queue slave: %r");
			return -1;
		}
	}

	return 0;
}

/*
 * queue a lump &amp; it's packet data for writing
 */
int
queuewrite(Lump *u, Packet *p, int creator, uint ms)
{
	LumpQueue *q;
	int i;

	trace(TraceProc, "queuewrite");
	i = indexsect(mainindex, u-&gt;score);
	if(i &lt; 0 || i &gt;= nqs){
		seterr(EBug, "internal error: illegal index section in queuewrite");
		return -1;
	}

	q = &amp;lumpqs[i];

	qlock(&amp;q-&gt;lock);
	while(q-&gt;r == ((q-&gt;w + 1) &amp; (MaxLumpQ - 1))){
		trace(TraceProc, "queuewrite sleep");
		rsleep(&amp;q-&gt;full);
	}

	q-&gt;q[q-&gt;w].u = u;
	q-&gt;q[q-&gt;w].p = p;
	q-&gt;q[q-&gt;w].creator = creator;
	q-&gt;q[q-&gt;w].ms = ms;
	q-&gt;q[q-&gt;w].gen = gen;
	q-&gt;w = (q-&gt;w + 1) &amp; (MaxLumpQ - 1);

	trace(TraceProc, "queuewrite wakeup");
	rwakeup(&amp;q-&gt;empty);

	qunlock(&amp;q-&gt;lock);

	return 0;
}

void
flushqueue(void)
{
	int i;
	LumpQueue *q;

	if(!lumpqs)
		return;

	trace(TraceProc, "flushqueue");

	qlock(&amp;glk);
	gen++;
	qunlock(&amp;glk);

	for(i=0; i&lt;mainindex-&gt;nsects; i++){
		q = &amp;lumpqs[i];
		qlock(&amp;q-&gt;lock);
		while(q-&gt;w != q-&gt;r &amp;&amp; gen - q-&gt;q[q-&gt;r].gen &gt; 0){
			trace(TraceProc, "flushqueue sleep q%d", i);
			rsleep(&amp;q-&gt;flush);
		}
		qunlock(&amp;q-&gt;lock);
	}
}
	
static void
queueproc(void *vq)
{
	LumpQueue *q;
	Lump *u;
	Packet *p;
	int creator;
	uint ms;

	threadsetname("queueproc");

	q = vq;
	for(;;){
		qlock(&amp;q-&gt;lock);
		while(q-&gt;w == q-&gt;r){
			trace(TraceProc, "queueproc sleep empty");
			rsleep(&amp;q-&gt;empty);
		}

		u = q-&gt;q[q-&gt;r].u;
		p = q-&gt;q[q-&gt;r].p;
		creator = q-&gt;q[q-&gt;r].creator;
		ms = q-&gt;q[q-&gt;r].ms;

		q-&gt;r = (q-&gt;r + 1) &amp; (MaxLumpQ - 1);
		trace(TraceProc, "queueproc wakeup flush");
		rwakeupall(&amp;q-&gt;flush);

		trace(TraceProc, "queueproc wakeup full");
		rwakeup(&amp;q-&gt;full);

		qunlock(&amp;q-&gt;lock);

		trace(TraceProc, "queueproc writelump %V", u-&gt;score);
		if(writeqlump(u, p, creator, ms) &lt; 0)
			fprint(2, "failed to write lump for %V: %r", u-&gt;score);
		trace(TraceProc, "queueproc wrotelump %V", u-&gt;score);

		putlump(u);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

