<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/mirrorarenas.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/mirrorarenas.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Mirror one arena partition onto another.  
 * Be careful to copy only new data.
 */

#include "stdinc.h"
#include "dat.h"
#include "fns.h"

Channel *writechan;

typedef struct Write Write;
struct Write
{
	uchar *p;
	int n;
	uvlong o;
	int error;
};

Part *src;
Part *dst;
int force;
int verbose;
int dosha1 = 1;
char *status;
uvlong astart, aend;

void
usage(void)
{
	fprint(2, "usage: mirrorarenas [-sv] src dst [ranges]\n");
	threadexitsall("usage");
}

char *tagged;

void
tag(char *fmt, ...)
{
	va_list arg;
	
	if(tagged){
		free(tagged);
		tagged = nil;
	}
	va_start(arg, fmt);
	tagged = vsmprint(fmt, arg);
	va_end(arg);
}

void
chat(char *fmt, ...)
{
	va_list arg;

	if(tagged){
		write(1, tagged, strlen(tagged));
		free(tagged);
		tagged = nil;
	}
	va_start(arg, fmt);
	vfprint(1, fmt, arg);
	va_end(arg);
}

#pragma varargck argpos tag 1
#pragma varargck argpos chat 1


int
ereadpart(Part *p, u64int offset, u8int *buf, u32int count)
{
	if(readpart(p, offset, buf, count) != count){
		chat("%T readpart %s at %#llux+%ud: %r\n", p-&gt;name, offset, count);
		return -1;
	}
	return 0;
}
		
int
ewritepart(Part *p, u64int offset, u8int *buf, u32int count)
{
	if(writepart(p, offset, buf, count) != count || flushpart(p) &lt; 0){
		chat("%T writepart %s at %#llux+%ud: %r\n", p-&gt;name, offset, count);
		return -1;
	}
	return 0;
}

/*
 * Extra proc to do writes to dst, so that we can overlap reading
 * src with writing dst during copy.  This is an easy factor of two
 * (almost) in performance.
 */
static Write wsync;
static void
writeproc(void *v)
{
	Write *w;
	
	USED(v);
	while((w = recvp(writechan)) != nil){
		if(w == &amp;wsync)
			continue;
		if(ewritepart(dst, w-&gt;o, w-&gt;p, w-&gt;n) &lt; 0)
			w-&gt;error = 1;
	}
}

int
copy(uvlong start, uvlong end, char *what, DigestState *ds)
{
	int i, n;
	uvlong o;
	static uchar tmp[2][1024*1024];
	Write w[2];
	
	assert(start &lt;= end);
	assert(astart &lt;= start &amp;&amp; start &lt; aend);
	assert(astart &lt;= end &amp;&amp; end &lt;= aend);

	if(verbose &amp;&amp; start != end)
		chat("%T   copy %,llud-%,llud %s\n", start, end, what);

	i = 0;
	memset(w, 0, sizeof w);
	for(o=start; o&lt;end; o+=n){
		if(w[i].error)
			goto error;
		n = sizeof tmp[i];
		if(o+n &gt; end)
			n = end - o;
		if(ereadpart(src, o, tmp[i], n) &lt; 0)
			goto error;
		w[i].p = tmp[i];
		w[i].o = o;
		w[i].n = n;
		w[i].error = 0;
		sendp(writechan, &amp;w[i]);
		if(ds)
			sha1(tmp[i], n, nil, ds);
		i = 1-i;
	}
	if(w[i].error)
		goto error;

	/*
	 * wait for queued write to finish
	 */
	sendp(writechan, &amp;wsync);
	i = 1-i;
	if(w[i].error)
		return -1;
	return 0;

error:
	/*
	 * sync with write proc
	 */
	w[i].p = nil;
	w[i].o = 0;
	w[i].n = 0;
	w[i].error = 0;
	sendp(writechan, &amp;w[i]);
	return -1;
}

/* single-threaded, for reference */
int
copy1(uvlong start, uvlong end, char *what, DigestState *ds)
{
	int n;
	uvlong o;
	static uchar tmp[1024*1024];
	
	assert(start &lt;= end);
	assert(astart &lt;= start &amp;&amp; start &lt; aend);
	assert(astart &lt;= end &amp;&amp; end &lt;= aend);

	if(verbose &amp;&amp; start != end)
		chat("%T   copy %,llud-%,llud %s\n", start, end, what);

	for(o=start; o&lt;end; o+=n){
		n = sizeof tmp;
		if(o+n &gt; end)
			n = end - o;
		if(ereadpart(src, o, tmp, n) &lt; 0)
			return -1;
		if(ds)
			sha1(tmp, n, nil, ds);
		if(ewritepart(dst, o, tmp, n) &lt; 0)
			return -1;
	}
	return 0;
}

int
asha1(Part *p, uvlong start, uvlong end, DigestState *ds)
{
	int n;
	uvlong o;
	static uchar tmp[1024*1024];

	if(start == end)
		return 0;
	assert(start &lt; end);

	if(verbose)
		chat("%T   sha1 %,llud-%,llud\n", start, end);

	for(o=start; o&lt;end; o+=n){
		n = sizeof tmp;
		if(o+n &gt; end)
			n = end - o;
		if(ereadpart(p, o, tmp, n) &lt; 0)
			return -1;
		sha1(tmp, n, nil, ds);
	}
	return 0;
}

uvlong
rdown(uvlong a, int b)
{
	return a-a%b;
}

uvlong
rup(uvlong a, int b)
{
	if(a%b == 0)
		return a;
	return a+b-a%b;
}

void
mirror(Arena *sa, Arena *da)
{
	vlong v, si, di, end;
	int clumpmax, blocksize, sealed;
	static uchar buf[MaxIoSize];
	ArenaHead h;
	DigestState xds, *ds;
	vlong shaoff, base;
	
	base = sa-&gt;base;
	blocksize = sa-&gt;blocksize;
	end = sa-&gt;base + sa-&gt;size;
	
	astart = base - blocksize;
	aend = end + blocksize;

	tag("%T %s (%,llud-%,llud)\n", sa-&gt;name, astart, aend);
	
	if(force){
		copy(astart, aend, "all", nil);
		return;
	}

	if(sa-&gt;diskstats.sealed &amp;&amp; da-&gt;diskstats.sealed &amp;&amp; scorecmp(da-&gt;score, zeroscore) != 0){
		if(scorecmp(sa-&gt;score, da-&gt;score) == 0){
			if(verbose)
				chat("%T %s: %V sealed mirrored\n", sa-&gt;name, sa-&gt;score);
			return;
		}
		chat("%T %s: warning: sealed score mismatch %V vs %V\n", sa-&gt;name, sa-&gt;score, da-&gt;score);
		/* Keep executing; will correct seal if possible. */
	}
	if(!sa-&gt;diskstats.sealed &amp;&amp; da-&gt;diskstats.sealed &amp;&amp; scorecmp(da-&gt;score, zeroscore) != 0){
		chat("%T %s: dst is sealed, src is not\n", sa-&gt;name);
		status = "errors";
		return;
	}
	if(sa-&gt;diskstats.used &lt; da-&gt;diskstats.used){
		chat("%T %s: src used %,lld &lt; dst used %,lld\n", sa-&gt;name, sa-&gt;diskstats.used, da-&gt;diskstats.used);
		status = "errors";
		return;
	}

	if(da-&gt;clumpmagic != sa-&gt;clumpmagic){
		/*
		 * Write this now to reduce the window in which
		 * the head and tail disagree about clumpmagic.
		 */
		da-&gt;clumpmagic = sa-&gt;clumpmagic;
		memset(buf, 0, sizeof buf);
		packarena(da, buf);
		if(ewritepart(dst, end, buf, blocksize) &lt; 0)
			return;
	}
	
	memset(&amp;h, 0, sizeof h);
	h.version = da-&gt;version;
	strcpy(h.name, da-&gt;name);
	h.blocksize = da-&gt;blocksize;
	h.size = da-&gt;size + 2*da-&gt;blocksize;
	h.clumpmagic = da-&gt;clumpmagic;
	memset(buf, 0, sizeof buf);
	packarenahead(&amp;h, buf);
	if(ewritepart(dst, base - blocksize, buf, blocksize) &lt; 0)
		return;

	shaoff = 0;
	ds = nil;
	sealed = sa-&gt;diskstats.sealed &amp;&amp; scorecmp(sa-&gt;score, zeroscore) != 0;
	if(sealed &amp;&amp; dosha1){
		/* start sha1 state with header */
		memset(&amp;xds, 0, sizeof xds);
		ds = &amp;xds;
		sha1(buf, blocksize, nil, ds);
		shaoff = base;
	}
	
	if(sa-&gt;diskstats.used != da-&gt;diskstats.used){
		di = base+rdown(da-&gt;diskstats.used, blocksize);
		si = base+rup(sa-&gt;diskstats.used, blocksize);
		if(ds &amp;&amp; asha1(dst, shaoff, di, ds) &lt; 0)
			return;
		if(copy(di, si, "data", ds) &lt; 0)
			return;
		shaoff = si;
	}
	
	clumpmax = sa-&gt;clumpmax;
	di = end - da-&gt;diskstats.clumps/clumpmax * blocksize;
	si = end - (sa-&gt;diskstats.clumps+clumpmax-1)/clumpmax * blocksize;

	if(sa-&gt;diskstats.sealed){
		/*
		 * might be a small hole between the end of the 
		 * data and the beginning of the directory.
		 */
		v = base+rup(sa-&gt;diskstats.used, blocksize);
		if(ds &amp;&amp; asha1(dst, shaoff, v, ds) &lt; 0)
			return;
		if(copy(v, si, "hole", ds) &lt; 0)
			return;
		shaoff = si;
	}

	if(da-&gt;diskstats.clumps != sa-&gt;diskstats.clumps){
		if(ds &amp;&amp; asha1(dst, shaoff, si, ds) &lt; 0)
			return;
		if(copy(si, di, "directory", ds) &lt; 0)	/* si &lt; di  because clumpinfo blocks grow down */
			return;
		shaoff = di;
	}

	da-&gt;ctime = sa-&gt;ctime;
	da-&gt;wtime = sa-&gt;wtime;
	da-&gt;diskstats = sa-&gt;diskstats;
	da-&gt;diskstats.sealed = 0;
	
	/*
	 * Repack the arena tail information
	 * and save it for next time...
	 */
	memset(buf, 0, sizeof buf);
	packarena(da, buf);
	if(ewritepart(dst, end, buf, blocksize) &lt; 0)
		return;

	if(sealed){
		/*
		 * ... but on the final pass, copy the encoding
		 * of the tail information from the source
		 * arena itself.  There are multiple possible
		 * ways to write the tail info out (the exact
		 * details have changed as venti went through
		 * revisions), and to keep the SHA1 hash the
		 * same, we have to use what the disk uses.
		 */
		if(asha1(dst, shaoff, end, ds) &lt; 0
		|| copy(end, end+blocksize-VtScoreSize, "tail", ds) &lt; 0)
			return;
		if(dosha1){
			memset(buf, 0, VtScoreSize);
			sha1(buf, VtScoreSize, da-&gt;score, ds);
			if(scorecmp(sa-&gt;score, da-&gt;score) == 0){
				if(verbose)
					chat("%T %s: %V sealed mirrored\n", sa-&gt;name, sa-&gt;score);
				if(ewritepart(dst, end+blocksize-VtScoreSize, da-&gt;score, VtScoreSize) &lt; 0)
					return;
			}else{
				chat("%T %s: sealing dst: score mismatch: %V vs %V\n", sa-&gt;name, sa-&gt;score, da-&gt;score);
				memset(&amp;xds, 0, sizeof xds);
				asha1(dst, base-blocksize, end+blocksize-VtScoreSize, &amp;xds);
				sha1(buf, VtScoreSize, 0, &amp;xds);
				chat("%T   reseal: %V\n", da-&gt;score);
				status = "errors";
			}
		}else{
			if(verbose)
				chat("%T %s: %V mirrored\n", sa-&gt;name, sa-&gt;score);
			if(ewritepart(dst, end+blocksize-VtScoreSize, sa-&gt;score, VtScoreSize) &lt; 0)
				return;
		}
	}else{
		chat("%T %s: %,lld used mirrored\n",
			sa-&gt;name, sa-&gt;diskstats.used);
	}
}

void
mirrormany(ArenaPart *sp, ArenaPart *dp, char *range)
{
	int i, lo, hi;
	char *s, *t;
	Arena *sa, *da;

	if(range == nil){
		for(i=0; i&lt;sp-&gt;narenas; i++){
			sa = sp-&gt;arenas[i];
			da = dp-&gt;arenas[i];
			mirror(sa, da);
		}
		return;
	}
	if(strcmp(range, "none") == 0)
		return;

	for(s=range; *s; s=t){
		t = strchr(s, ',');
		if(t)
			*t++ = 0;
		else
			t = s+strlen(s);
		if(*s == '-')
			lo = 0;
		else
			lo = strtol(s, &amp;s, 0);
		hi = lo;
		if(*s == '-'){
			s++;
			if(*s == 0)
				hi = sp-&gt;narenas-1;
			else
				hi = strtol(s, &amp;s, 0);
		}
		if(*s != 0){
			chat("%T bad arena range: %s\n", s);
			continue;
		}
		for(i=lo; i&lt;=hi; i++){
			sa = sp-&gt;arenas[i];
			da = dp-&gt;arenas[i];
			mirror(sa, da);
		}
	}	
}


void
threadmain(int argc, char **argv)
{
	int i;
	Arena *sa, *da;
	ArenaPart *s, *d;
	char *ranges;
	
	ventifmtinstall();

	ARGBEGIN{
	case 'F':
		force = 1;
		break;
	case 'v':
		verbose++;
		break;
	case 's':
		dosha1 = 0;
		break;
	default:
		usage();
	}ARGEND
	
	if(argc != 2 &amp;&amp; argc != 3)
		usage();
	ranges = nil;
	if(argc == 3)
		ranges = argv[2];

	if((src = initpart(argv[0], OREAD)) == nil)
		sysfatal("initpart %s: %r", argv[0]);
	if((dst = initpart(argv[1], ORDWR)) == nil)
		sysfatal("initpart %s: %r", argv[1]);
	if((s = initarenapart(src)) == nil)
		sysfatal("initarenapart %s: %r", argv[0]);
	for(i=0; i&lt;s-&gt;narenas; i++)
		delarena(s-&gt;arenas[i]);
	if((d = initarenapart(dst)) == nil)
		sysfatal("loadarenapart %s: %r", argv[1]);
	for(i=0; i&lt;d-&gt;narenas; i++)
		delarena(d-&gt;arenas[i]);
	
	/*
	 * The arena geometries must match or all bets are off.
	 */
	if(s-&gt;narenas != d-&gt;narenas)
		sysfatal("arena count mismatch: %d vs %d", s-&gt;narenas, d-&gt;narenas);
	for(i=0; i&lt;s-&gt;narenas; i++){
		sa = s-&gt;arenas[i];
		da = d-&gt;arenas[i];
		if(sa-&gt;version != da-&gt;version)
			sysfatal("arena %d: version mismatch: %d vs %d", i, sa-&gt;version, da-&gt;version);
		if(sa-&gt;blocksize != da-&gt;blocksize)
			sysfatal("arena %d: blocksize mismatch: %d vs %d", i, sa-&gt;blocksize, da-&gt;blocksize);
		if(sa-&gt;size != da-&gt;size)
			sysfatal("arena %d: size mismatch: %,lld vs %,lld", i, sa-&gt;size, da-&gt;size);
		if(strcmp(sa-&gt;name, da-&gt;name) != 0)
			sysfatal("arena %d: name mismatch: %s vs %s", i, sa-&gt;name, da-&gt;name);
	}
	
	/*
	 * Mirror one arena at a time.
	 */
	writechan = chancreate(sizeof(void*), 0);
	vtproc(writeproc, nil);
	mirrormany(s, d, ranges);
	sendp(writechan, nil);
	threadexitsall(status);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

