<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/reseal.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/reseal.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static uchar	*data;
static uchar	*data1;
static int	blocksize;
static int	sleepms;
static int	fd;
static int	force;
static vlong	offset0;

void
usage(void)
{
	fprint(2, "usage: reseal [-f] [-b blocksize] [-s ms] arenapart1 [name...]]\n");
	threadexitsall(0);
}

static int
pwriteblock(uchar *buf, int n, vlong off)
{
	int nr, m;

	for(nr = 0; nr &lt; n; nr += m){
		m = n - nr;
		m = pwrite(fd, &amp;buf[nr], m, offset0+off+nr);
		if(m &lt;= 0)
			return -1;
	}
	return 0;
}

static int
preadblock(uchar *buf, int n, vlong off)
{
	int nr, m;

	for(nr = 0; nr &lt; n; nr += m){
		m = n - nr;
		m = pread(fd, &amp;buf[nr], m, offset0+off+nr);
		if(m &lt;= 0){
			if(m == 0)
				werrstr("early eof");
			return -1;
		}
	}
	return 0;
}

static int
loadheader(char *name, ArenaHead *head, Arena *arena, vlong off)
{
	if(preadblock(data, head-&gt;blocksize, off + head-&gt;size - head-&gt;blocksize) &lt; 0){
		fprint(2, "%s: reading arena tail: %r\n", name);
		return -1;
	}

	memset(arena, 0, sizeof *arena);
	if(unpackarena(arena, data) &lt; 0){
		fprint(2, "%s: unpack arena tail: %r\n", name);
		return -1;
	}
	arena-&gt;blocksize = head-&gt;blocksize;
	arena-&gt;base = off + head-&gt;blocksize;
	arena-&gt;clumpmax = arena-&gt;blocksize / ClumpInfoSize;
	arena-&gt;size = head-&gt;size - 2*head-&gt;blocksize;

	if(arena-&gt;diskstats.sealed)
		scorecp(arena-&gt;score, data + head-&gt;blocksize - VtScoreSize);
	return 0;
}

uchar zero[VtScoreSize];

static int
verify(Arena *arena, void *data, uchar *newscore)
{
	vlong e, bs, n, o;
	DigestState ds, ds1;
	uchar score[VtScoreSize];

	/*
	 * now we know how much to read
	 * read everything but the last block, which is special
	 */
	e = arena-&gt;size + arena-&gt;blocksize;
	o = arena-&gt;base - arena-&gt;blocksize;
	bs = arena-&gt;blocksize;
	memset(&amp;ds, 0, sizeof ds);
	for(n = 0; n &lt; e; n += bs){
		if(preadblock(data, bs, o + n) &lt; 0){
			werrstr("read: %r");
			return -1;
		}
		if(n + bs &gt; e)
			bs = e - n;
		sha1(data, bs, nil, &amp;ds);
	}
	
	/* last block */
	if(preadblock(data, arena-&gt;blocksize, o + e) &lt; 0){
		werrstr("read: %r");
		return -1;
	}
	ds1 = ds;
	sha1(data, bs - VtScoreSize, nil, &amp;ds);
	sha1(zero, VtScoreSize, score, &amp;ds);
	if(scorecmp(score, arena-&gt;score) != 0){
		if(!force){
			werrstr("score mismatch: %V != %V", score, arena-&gt;score);
			return -1;
		}
		fprint(2, "warning: score mismatch %V != %V\n", score, arena-&gt;score);
	}
	
	/* prepare new last block */
	memset(data, 0, arena-&gt;blocksize);
	packarena(arena, data);
	sha1(data, bs, newscore, &amp;ds1);
	scorecp((uchar*)data + arena-&gt;blocksize - VtScoreSize, newscore);

	return 0;
}

static void
resealarena(char *name, vlong len)
{
	ArenaHead head;
	Arena arena;
	DigestState s;
	u64int off;
	uchar newscore[VtScoreSize];

	fprint(2, "%s: begin reseal\n", name);

	memset(&amp;s, 0, sizeof s);

	off = seek(fd, 0, 1);

	/*
	 * read a little bit, which will include the header
	 */
	if(preadblock(data, HeadSize, off) &lt; 0){
		fprint(2, "%s: reading header: %r\n", name);
		return;
	}
	if(unpackarenahead(&amp;head, data) &lt; 0){
		fprint(2, "%s: corrupt arena header: %r\n", name);
		return;
	}
	if(head.version != ArenaVersion4 &amp;&amp; head.version != ArenaVersion5)
		fprint(2, "%s: warning: unknown arena version %d\n", name, head.version);
	if(len != 0 &amp;&amp; len != head.size)
		fprint(2, "%s: warning: unexpected length %lld != %lld\n", name, head.size, len);
	if(strcmp(name, "&lt;stdin&gt;") != 0 &amp;&amp; strcmp(head.name, name) != 0)
		fprint(2, "%s: warning: unexpected name %s\n", name, head.name);

	if(loadheader(name, &amp;head, &amp;arena, off) &lt; 0)
		return;
	
	if(!arena.diskstats.sealed){
		fprint(2, "%s: not sealed\n", name);
		return;
	}
	
	if(verify(&amp;arena, data, newscore) &lt; 0){
		fprint(2, "%s: failed to verify before reseal: %r\n", name);
		return;
	}
	
	if(pwriteblock(data, arena.blocksize, arena.base + arena.size) &lt; 0){
		fprint(2, "%s: writing new tail: %r\n", name);
		return;
	}
	scorecp(arena.score, newscore);
	fprint(2, "%s: resealed: %V\n", name, newscore);

	if(verify(&amp;arena, data, newscore) &lt; 0){
		fprint(2, "%s: failed to verify after reseal!: %r\n", name);
		return;
	}

	fprint(2, "%s: verified: %V\n", name, newscore);
}

static int
shouldcheck(char *name, char **s, int n)
{
	int i;
	
	if(n == 0)
		return 1;

	for(i=0; i&lt;n; i++){
		if(s[i] &amp;&amp; strcmp(name, s[i]) == 0){
			s[i] = nil;
			return 1;
		}
	}
	return 0;
}

char *
readap(ArenaPart *ap)
{
	char *table;
	
	if(preadblock(data, 8192, PartBlank) &lt; 0)
		sysfatal("read arena part header: %r");
	if(unpackarenapart(ap, data) &lt; 0)
		sysfatal("corrupted arena part header: %r");
	fprint(2, "# arena part version=%d blocksize=%d arenabase=%d\n",
		ap-&gt;version, ap-&gt;blocksize, ap-&gt;arenabase);
	ap-&gt;tabbase = (PartBlank+HeadSize+ap-&gt;blocksize-1)&amp;~(ap-&gt;blocksize-1);
	ap-&gt;tabsize = ap-&gt;arenabase - ap-&gt;tabbase;
	table = malloc(ap-&gt;tabsize+1);
	if(preadblock((uchar*)table, ap-&gt;tabsize, ap-&gt;tabbase) &lt; 0)
		sysfatal("reading arena part directory: %r");
	table[ap-&gt;tabsize] = 0;
	return table;
}

void
threadmain(int argc, char *argv[])
{
	int i, nline;
	char *p, *q, *table, *f[10], line[256];
	vlong start, stop;
	ArenaPart ap;
	Part *part;
	
	ventifmtinstall();
	blocksize = MaxIoSize;
	ARGBEGIN{
	case 'b':
		blocksize = unittoull(EARGF(usage()));
		break;
	case 'f':
		force = 1;
		break;
	case 's':
		sleepms = atoi(EARGF(usage()));
		break;
	default:
		usage();
		break;
	}ARGEND

	if(argc &lt; 2)
		usage();

	data = vtmalloc(blocksize);
	if((part = initpart(argv[0], ORDWR)) == nil)
		sysfatal("open partition %s: %r", argv[0]);
	fd = part-&gt;fd;
	offset0 = part-&gt;offset;

	table = readap(&amp;ap);

	nline = atoi(table);
	p = strchr(table, '\n');
	if(p)
		p++;
	for(i=0; i&lt;nline; i++){
		if(p == nil){
			fprint(2, "warning: unexpected arena table end\n");
			break;
		}
		q = strchr(p, '\n');
		if(q)
			*q++ = 0;
		if(strlen(p) &gt;= sizeof line){
			fprint(2, "warning: long arena table line: %s\n", p);
			p = q;
			continue;
		}
		strcpy(line, p);
		memset(f, 0, sizeof f);
		if(tokenize(line, f, nelem(f)) &lt; 3){
			fprint(2, "warning: bad arena table line: %s\n", p);
			p = q;
			continue;
		}
		p = q;
		if(shouldcheck(f[0], argv+1, argc-1)){
			start = strtoull(f[1], 0, 0);
			stop = strtoull(f[2], 0, 0);
			if(stop &lt;= start){
				fprint(2, "%s: bad start,stop %lld,%lld\n", f[0], stop, start);
				continue;
			}
			if(seek(fd, start, 0) &lt; 0)
				fprint(2, "%s: seek to start: %r\n", f[0]);
			resealarena(f[0], stop - start);
		}
	}
	for(i=2; i&lt;argc; i++)
		if(argv[i] != 0)
			fprint(2, "%s: did not find arena\n", argv[i]);

	threadexitsall(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

