<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/syncarena.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/syncarena.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static int	writeclumphead(Arena *arena, u64int aa, Clump *cl);
static int	writeclumpmagic(Arena *arena, u64int aa, u32int magic);

int
clumpinfocmp(ClumpInfo *c, ClumpInfo *d)
{
	return c-&gt;type != d-&gt;type
		|| c-&gt;size != d-&gt;size
		|| c-&gt;uncsize != d-&gt;uncsize
		|| scorecmp(c-&gt;score, d-&gt;score)!=0;
}

/*
 * synchronize the clump info directory with
 * with the clumps actually stored in the arena.
 * the directory should be at least as up to date
 * as the arena's trailer.
 *
 * checks/updates at most n clumps.
 *
 * returns 0 if ok, flags if error occurred
 */
int
syncarena(Arena *arena, u32int n, int zok, int fix)
{
	ZBlock *lump;
	Clump cl;
	ClumpInfo ci;
	static ClumpInfo zci = { .type = -1 };
	u8int score[VtScoreSize];
	u64int uncsize, used, aa;
	u32int clump, clumps, cclumps, magic;
	int err, flush, broken;

	used = arena-&gt;memstats.used;
	clumps = arena-&gt;memstats.clumps;
	cclumps = arena-&gt;memstats.cclumps;
	uncsize = arena-&gt;memstats.uncsize;
	trace(TraceProc, "syncarena start");
	flush = 0;
	err = 0;
	for(; n; n--){
		aa = arena-&gt;memstats.used;
		clump = arena-&gt;memstats.clumps;
		magic = clumpmagic(arena, aa);
		if(magic == ClumpFreeMagic)
			break;
		if(magic != arena-&gt;clumpmagic){
			fprint(2, "%s: illegal clump magic number=%#8.8ux at clump=%d\n", arena-&gt;name, magic, clump);
			/* err |= SyncDataErr; */
			if(fix &amp;&amp; writeclumpmagic(arena, aa, ClumpFreeMagic) &lt; 0){
				fprint(2, "%s: can't write corrected clump free magic: %r", arena-&gt;name);
				err |= SyncFixErr;
			}
			break;
		}

		broken = 0;
		lump = loadclump(arena, aa, 0, &amp;cl, score, 0);
		if(lump == nil){
			fprint(2, "%s: clump=%d failed to read correctly: %r\n", arena-&gt;name, clump);
			break;
		}else if(cl.info.type != VtCorruptType){
			scoremem(score, lump-&gt;data, cl.info.uncsize);
			if(scorecmp(cl.info.score, score) != 0){
				/* ignore partially written block */
				if(cl.encoding == ClumpENone)
					break;
				fprint(2, "%s: clump=%d has mismatched score\n", arena-&gt;name, clump);
				err |= SyncDataErr;
				broken = 1;
			}else if(vttypevalid(cl.info.type) &lt; 0){
				fprint(2, "%s: clump=%d has invalid type %d", arena-&gt;name, clump, cl.info.type);
				err |= SyncDataErr;
				broken = 1;
			}
			if(broken &amp;&amp; fix){
				cl.info.type = VtCorruptType;
				if(writeclumphead(arena, aa, &amp;cl) &lt; 0){
					fprint(2, "%s: can't write corrected clump header: %r", arena-&gt;name);
					err |= SyncFixErr;
				}
			}
		}
		freezblock(lump);
		arena-&gt;memstats.used += ClumpSize + cl.info.size;

		arena-&gt;memstats.clumps++;
		if(!broken &amp;&amp; readclumpinfo(arena, clump, &amp;ci)&lt;0){
			fprint(2, "%s: arena directory read failed\n", arena-&gt;name);
			broken = 1;
		}else if(!broken &amp;&amp; clumpinfocmp(&amp;ci, &amp;cl.info)!=0){
			if(clumpinfocmp(&amp;ci, &amp;zci) == 0){
				err |= SyncCIZero;
				if(!zok)
					fprint(2, "%s: unwritten clump info for clump=%d\n", arena-&gt;name, clump);
			}else{
				err |= SyncCIErr;
				fprint(2, "%s: bad clump info for clump=%d\n", arena-&gt;name, clump);
				fprint(2, "\texpected score=%V type=%d size=%d uncsize=%d\n",
					cl.info.score, cl.info.type, cl.info.size, cl.info.uncsize);
				fprint(2, "\tfound score=%V type=%d size=%d uncsize=%d\n",
					ci.score, ci.type, ci.size, ci.uncsize);
			}
			broken = 1;
		}
		if(broken &amp;&amp; fix){
			flush = 1;
			ci = cl.info;
			if(writeclumpinfo(arena, clump, &amp;ci) &lt; 0){
				fprint(2, "%s: can't write correct clump directory: %r\n", arena-&gt;name);
				err |= SyncFixErr;
			}
		}
		trace(TraceProc, "syncarena unindexed clump %V %d", cl.info.score, arena-&gt;memstats.clumps);

		arena-&gt;memstats.uncsize += cl.info.uncsize;
		if(cl.info.size &lt; cl.info.uncsize)
			arena-&gt;memstats.cclumps++;
	}

	if(flush){
		trace(TraceProc, "syncarena flush");
		arena-&gt;wtime = now();
		if(arena-&gt;ctime == 0 &amp;&amp; arena-&gt;memstats.clumps)
			arena-&gt;ctime = arena-&gt;wtime;
		flushdcache();
	}

	if(used != arena-&gt;memstats.used
	|| clumps != arena-&gt;memstats.clumps
	|| cclumps != arena-&gt;memstats.cclumps
	|| uncsize != arena-&gt;memstats.uncsize){
		err |= SyncHeader;
		fprint(2, "arena %s: fix=%d flush=%d %lld-&gt;%lld %ud-&gt;%ud %ud-&gt;%ud %lld-&gt;%lld\n",
			arena-&gt;name,
			fix,
			flush,
			used, arena-&gt;memstats.used,
			clumps, arena-&gt;memstats.clumps,
			cclumps, arena-&gt;memstats.cclumps,
			uncsize, arena-&gt;memstats.uncsize);
	}

	return err;
}

static int
writeclumphead(Arena *arena, u64int aa, Clump *cl)
{
	ZBlock *zb;
	int bad;

	zb = alloczblock(ClumpSize, 0, arena-&gt;blocksize);
	if(zb == nil)
		return -1;
	bad = packclump(cl, zb-&gt;data, arena-&gt;clumpmagic)&lt;0
		|| writearena(arena, aa, zb-&gt;data, ClumpSize) != ClumpSize;
	freezblock(zb);
	return bad ? -1 : 0;
}

static int
writeclumpmagic(Arena *arena, u64int aa, u32int magic)
{
	u8int buf[U32Size];

	packmagic(magic, buf);
	return writearena(arena, aa, buf, U32Size) == U32Size;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

