<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/venti/srv/verifyarena.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/venti/srv/verifyarena.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "stdinc.h"
#include "dat.h"
#include "fns.h"

static int	verbose;
static int	fd;
static uchar	*data;
static int	blocksize;
static int	sleepms;
static vlong offset0;

void
usage(void)
{
	fprint(2, "usage: verifyarena [-b blocksize] [-s ms] [-v] [arenapart [name...]]\n");
	threadexitsall(0);
}

static int
preadblock(uchar *buf, int n, vlong off)
{
	int nr, m;

	for(nr = 0; nr &lt; n; nr += m){
		m = n - nr;
		m = pread(fd, &amp;buf[nr], m, offset0+off+nr);
		if(m &lt;= 0){
			if(m == 0)
				werrstr("early eof");
			return -1;
		}
	}
	return 0;
}

static int
readblock(uchar *buf, int n)
{
	int nr, m;

	for(nr = 0; nr &lt; n; nr += m){
		m = n - nr;
		m = read(fd, &amp;buf[nr], m);
		if(m &lt;= 0){
			if(m == 0)
				werrstr("early eof");
			return -1;
		}
	}
	return 0;
}

static void
verifyarena(char *name, vlong len)
{
	Arena arena;
	ArenaHead head;
	DigestState s;
	u64int n, e;
	u32int bs;
	u8int score[VtScoreSize];

	fprint(2, "%T verify %s\n", name);

	memset(&amp;arena, 0, sizeof arena);
	memset(&amp;s, 0, sizeof s);

	/*
	 * read a little bit, which will include the header
	 */
	if(readblock(data, HeadSize) &lt; 0){
		fprint(2, "%T %s: reading header: %r\n", name);
		return;
	}
	sha1(data, HeadSize, nil, &amp;s);
	if(unpackarenahead(&amp;head, data) &lt; 0){
		fprint(2, "%T %s: corrupt arena header: %r\n", name);
		return;
	}
	if(head.version != ArenaVersion4 &amp;&amp; head.version != ArenaVersion5)
		fprint(2, "%T %s: warning: unknown arena version %d\n", name, head.version);
	if(len != 0 &amp;&amp; len != head.size)
		fprint(2, "%T %s: warning: unexpected length %lld != %lld\n", name, head.size, len);
	if(strcmp(name, "&lt;stdin&gt;") != 0 &amp;&amp; strcmp(head.name, name) != 0)
		fprint(2, "%T %s: warning: unexpected name %s\n", name, head.name);

	/*
	 * now we know how much to read
	 * read everything but the last block, which is special
	 */
	e = head.size - head.blocksize;
	bs = blocksize;
	for(n = HeadSize; n &lt; e; n += bs){
		if(n + bs &gt; e)
			bs = e - n;
		if(readblock(data, bs) &lt; 0){
			fprint(2, "%T %s: read data: %r\n", name);
			return;
		}
		sha1(data, bs, nil, &amp;s);
		if(sleepms)
			sleep(sleepms);
	}

	/*
	 * read the last block update the sum.
	 * the sum is calculated assuming the slot for the sum is zero.
	 */
	bs = head.blocksize;
	if(readblock(data, bs) &lt; 0){
		fprint(2, "%T %s: read last block: %r\n", name);
		return;
	}
	sha1(data, bs-VtScoreSize, nil, &amp;s);
	sha1(zeroscore, VtScoreSize, nil, &amp;s);
	sha1(nil, 0, score, &amp;s);

	/*
	 * validity check on the trailer
	 */
	arena.blocksize = head.blocksize;
	if(unpackarena(&amp;arena, data) &lt; 0){
		fprint(2, "%T %s: corrupt arena trailer: %r\n", name);
		return;
	}
	scorecp(arena.score, &amp;data[arena.blocksize - VtScoreSize]);

	if(namecmp(arena.name, head.name) != 0){
		fprint(2, "%T %s: wrong name in trailer: %s vs. %s\n", 
			name, head.name, arena.name);
		return;
	}
	if(arena.version != head.version){
		fprint(2, "%T %s: wrong version in trailer: %d vs. %d\n", 
			name, head.version, arena.version);
		return;
	}
	arena.size = head.size - 2 * head.blocksize;

	/*
	 * check for no checksum or the same
	 */
	if(scorecmp(score, arena.score) == 0)
		fprint(2, "%T %s: verified score\n", name);
	else if(scorecmp(zeroscore, arena.score) == 0)
		fprint(2, "%T %s: unsealed\n", name);
	else{
		fprint(2, "%T %s: mismatch checksum - found=%V calculated=%V\n",
			name, arena.score, score);
		return;
	}
	printarena(2, &amp;arena);
}

static int
shouldcheck(char *name, char **s, int n)
{
	int i;
	
	if(n == 0)
		return 1;

	for(i=0; i&lt;n; i++){
		if(s[i] &amp;&amp; strcmp(name, s[i]) == 0){
			s[i] = nil;
			return 1;
		}
	}
	return 0;
}

void
threadmain(int argc, char *argv[])
{
	int i, nline;
	char *p, *q, *table, *f[10], line[256];
	vlong start, stop;
	ArenaPart ap;
	Part *part;

	needzeroscore();
	ventifmtinstall();
	blocksize = MaxIoSize;
	ARGBEGIN{
	case 'b':
		blocksize = unittoull(EARGF(usage()));
		break;
	case 's':
		sleepms = atoi(EARGF(usage()));
		break;
	case 'v':
		verbose++;
		break;
	default:
		usage();
		break;
	}ARGEND

	data = vtmalloc(blocksize);
	if(argc == 0){
		fd = 0;
		verifyarena("&lt;stdin&gt;", 0);
		threadexitsall(nil);
	}
	
	if((part = initpart(argv[0], OREAD)) == nil)
		sysfatal("open partition %s: %r", argv[0]);
	fd = part-&gt;fd;
	offset0 = part-&gt;offset;

	if(preadblock(data, 8192, PartBlank) &lt; 0)
		sysfatal("read arena part header: %r");
	if(unpackarenapart(&amp;ap, data) &lt; 0)
		sysfatal("corrupted arena part header: %r");
	fprint(2, "%T # arena part version=%d blocksize=%d arenabase=%d\n",
		ap.version, ap.blocksize, ap.arenabase);
	ap.tabbase = (PartBlank+HeadSize+ap.blocksize-1)&amp;~(ap.blocksize-1);
	ap.tabsize = ap.arenabase - ap.tabbase;
	table = malloc(ap.tabsize+1);
	if(preadblock((uchar*)table, ap.tabsize, ap.tabbase) &lt; 0)
		sysfatal("reading arena part directory: %r");
	table[ap.tabsize] = 0;
	
	nline = atoi(table);
	p = strchr(table, '\n');
	if(p)
		p++;
	for(i=0; i&lt;nline; i++){
		if(p == nil){
			fprint(2, "%T warning: unexpected arena table end\n");
			break;
		}
		q = strchr(p, '\n');
		if(q)
			*q++ = 0;
		if(strlen(p) &gt;= sizeof line){
			fprint(2, "%T warning: long arena table line: %s\n", p);
			p = q;
			continue;
		}
		strcpy(line, p);
		memset(f, 0, sizeof f);
		if(tokenize(line, f, nelem(f)) &lt; 3){
			fprint(2, "%T warning: bad arena table line: %s\n", p);
			p = q;
			continue;
		}
		p = q;
		if(shouldcheck(f[0], argv+1, argc-1)){
			start = strtoull(f[1], 0, 0);
			stop = strtoull(f[2], 0, 0);
			if(stop &lt;= start){
				fprint(2, "%T %s: bad start,stop %lld,%lld\n", f[0], stop, start);
				continue;
			}
			if(seek(fd, offset0+start, 0) &lt; 0)
				fprint(2, "%T %s: seek to start: %r\n", f[0]);
			verifyarena(f[0], stop - start);
		}
	}
	for(i=1; i&lt;argc; i++)
		if(argv[i] != 0)
			fprint(2, "%T %s: did not find arena\n", argv[i]);

	threadexitsall(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

