<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/dev.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/dev.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;fcall.h&gt;
#include	"compat.h"
#include	"error.h"

extern ulong	kerndate;

void
mkqid(Qid *q, vlong path, ulong vers, int type)
{
	q-&gt;type = type;
	q-&gt;vers = vers;
	q-&gt;path = path;
}

int
devno(int c, int user)
{
	int i;

	for(i = 0; devtab[i] != nil; i++){
		if(devtab[i]-&gt;dc == c)
			return i;
	}
	if(user == 0)
		panic("devno %C 0x%ux", c, c);

	return -1;
}

void
devdir(Chan *c, Qid qid, char *n, vlong length, char *user, long perm, Dir *db)
{
	db-&gt;name = n;
	db-&gt;qid = qid;
	db-&gt;type = devtab[c-&gt;type]-&gt;dc;
	db-&gt;dev = c-&gt;dev;
	db-&gt;mode = (qid.type &lt;&lt; 24) | perm;
	db-&gt;atime = seconds();
	db-&gt;mtime = kerndate;
	db-&gt;length = length;
	db-&gt;uid = user;
	db-&gt;gid = eve;
	db-&gt;muid = user;
}

/*
 * the zeroth element of the table MUST be the directory itself for ..
*/
int
devgen(Chan *c, Dirtab *tab, int ntab, int i, Dir *dp)
{
	if(tab == 0)
		return -1;
	if(i != DEVDOTDOT){
		i++; /* skip first element for . itself */
		if(i &gt;= ntab)
			return -1;
		tab += i;
	}
	devdir(c, tab-&gt;qid, tab-&gt;name, tab-&gt;length, eve, tab-&gt;perm, dp);
	return 1;
}

void
devreset(void)
{
}

void
devinit(void)
{
}

Chan*
devattach(int tc, char *spec)
{
	Chan *c;
	char *buf;

	c = newchan();
	mkqid(&amp;c-&gt;qid, 0, 0, QTDIR);
	c-&gt;type = devno(tc, 0);
	if(spec == nil)
		spec = "";
	buf = smalloc(4+strlen(spec)+1);
	sprint(buf, "#%C%s", tc, spec);
	c-&gt;name = newcname(buf);
	free(buf);
	return c;
}


Chan*
devclone(Chan *c)
{
	Chan *nc;

	if(c-&gt;flag &amp; COPEN)
		panic("clone of open file type %C\n", devtab[c-&gt;type]-&gt;dc);

	nc = newchan();

	nc-&gt;type = c-&gt;type;
	nc-&gt;dev = c-&gt;dev;
	nc-&gt;mode = c-&gt;mode;
	nc-&gt;qid = c-&gt;qid;
	nc-&gt;offset = c-&gt;offset;
	nc-&gt;aux = c-&gt;aux;
	return nc;
}

Walkqid*
devwalk(Chan *c, Chan *nc, char **name, int nname, Dirtab *tab, int ntab, Devgen *gen)
{
	int i, j, alloc;
	Walkqid *wq;
	char *n;
	Dir dir;

	isdir(c);

	alloc = 0;
	wq = smalloc(sizeof(Walkqid)+(nname-1)*sizeof(Qid));
	if(waserror()){
		if(alloc &amp;&amp; wq-&gt;clone!=nil)
			cclose(wq-&gt;clone);
		free(wq);
		return nil;
	}
	if(nc == nil){
		nc = devclone(c);
		nc-&gt;type = 0;	/* device doesn't know about this channel yet */
		alloc = 1;
	}
	wq-&gt;clone = nc;

	for(j=0; j&lt;nname; j++){
		isdir(nc);
		n = name[j];
		if(strcmp(n, ".") == 0){
    Accept:
			wq-&gt;qid[wq-&gt;nqid++] = nc-&gt;qid;
			continue;
		}
		if(strcmp(n, "..") == 0){
			(*gen)(nc, tab, ntab, DEVDOTDOT, &amp;dir);
			nc-&gt;qid = dir.qid;
			goto Accept;
		}
		for(i=0;; i++){
			switch((*gen)(nc, tab, ntab, i, &amp;dir)){
			case -1:
				if(j == 0)
					error(Enonexist);
				strncpy(up-&gt;error, Enonexist, ERRMAX);
				goto Done;
			case 0:
				continue;
			case 1:
				if(strcmp(n, dir.name) == 0){
					nc-&gt;qid = dir.qid;
					goto Accept;
				}
				continue;
			}
		}
	}
	/*
	 * We processed at least one name, so will return some data.
	 * If we didn't process all nname entries succesfully, we drop
	 * the cloned channel and return just the Qids of the walks.
	 */
Done:
	poperror();
	if(wq-&gt;nqid &lt; nname){
		if(alloc)
			cclose(wq-&gt;clone);
		wq-&gt;clone = nil;
	}else if(wq-&gt;clone){
		/* attach cloned channel to same device */
		wq-&gt;clone-&gt;type = c-&gt;type;
	}
	return wq;
}

int
devstat(Chan *c, uchar *db, int n, Dirtab *tab, int ntab, Devgen *gen)
{
	int i;
	Dir dir;
	char *p, *elem;

	for(i=0;; i++)
		switch((*gen)(c, tab, ntab, i, &amp;dir)){
		case -1:
			if(c-&gt;qid.type &amp; QTDIR){
				if(c-&gt;name == nil)
					elem = "???";
				else if(strcmp(c-&gt;name-&gt;s, "/") == 0)
					elem = "/";
				else
					for(elem=p=c-&gt;name-&gt;s; *p; p++)
						if(*p == '/')
							elem = p+1;
				devdir(c, c-&gt;qid, elem, 0, eve, DMDIR|0555, &amp;dir);
				return convD2M(&amp;dir, db, n);
			}

			error(Enonexist);
		case 0:
			break;
		case 1:
			if(c-&gt;qid.path == dir.qid.path){
				return convD2M(&amp;dir, db, n);
			}
			break;
		}
}

long
devdirread(Chan *c, char *d, long n, Dirtab *tab, int ntab, Devgen *gen)
{
	long k, m, dsz;
	struct{
		Dir;
		char slop[100];
	}dir;

	k = c-&gt;offset;
	for(m=0; m&lt;n; k++){
		switch((*gen)(c, tab, ntab, k, &amp;dir)){
		case -1:
			return m;

		case 0:
			c-&gt;offset++;	/* BUG??? (was DIRLEN: skip entry) */
			break;

		case 1:
			dsz = convD2M(&amp;dir, (uchar*)d, n-m);
			if(dsz &lt;= BIT16SZ){	/* &lt;= not &lt; because this isn't stat; read is stuck */
				if(m == 0)
					return -1;
				return m;
			}
			m += dsz;
			d += dsz;
			break;
		}
	}

	return m;
}

/*
 * error(Eperm) if open permission not granted for up-&gt;user.
 */
void
devpermcheck(char *fileuid, ulong perm, int omode)
{
	ulong t;
	static int access[] = { 0400, 0200, 0600, 0100 };

	if(strcmp(up-&gt;user, fileuid) == 0)
		perm &lt;&lt;= 0;
	else
	if(strcmp(up-&gt;user, eve) == 0)
		perm &lt;&lt;= 3;
	else
		perm &lt;&lt;= 6;

	t = access[omode&amp;3];
	if((t&amp;perm) != t)
		error(Eperm);
}

Chan*
devopen(Chan *c, int omode, Dirtab *tab, int ntab, Devgen *gen)
{
	int i;
	Dir dir;

	for(i=0;; i++){
		switch((*gen)(c, tab, ntab, i, &amp;dir)){
		case -1:
			goto Return;
		case 0:
			break;
		case 1:
			if(c-&gt;qid.path == dir.qid.path){
				devpermcheck(dir.uid, dir.mode, omode);
				goto Return;
			}
			break;
		}
	}
Return:
	c-&gt;offset = 0;
	if((c-&gt;qid.type&amp;QTDIR) &amp;&amp; omode!=OREAD)
		error(Eperm);
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	return c;
}

void
devcreate(Chan*, char*, int, ulong)
{
	error(Eperm);
}

Block*
devbread(Chan *, long, ulong)
{
	panic("no block read");
	return nil;
}

long
devbwrite(Chan *, Block *, ulong)
{
	panic("no block write");
	return 0;
}

void
devremove(Chan*)
{
	error(Eperm);
}

int
devwstat(Chan*, uchar*, int)
{
	error(Eperm);
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

