<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/devdraw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/devdraw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	"compat.h"
#include	"error.h"

#define	Image	IMAGE
#include	&lt;draw.h&gt;
#include	&lt;memdraw.h&gt;
#include	&lt;memlayer.h&gt;
#include	&lt;cursor.h&gt;
#include	"screen.h"

enum
{
	Qtopdir		= 0,
	Qnew,
	Q3rd,
	Q2nd,
	Qcolormap,
	Qctl,
	Qdata,
	Qrefresh,
};

/*
 * Qid path is:
 *	 4 bits of file type (qids above)
 *	24 bits of mux slot number +1; 0 means not attached to client
 */
#define	QSHIFT	4	/* location in qid of client # */

#define	QID(q)		((((ulong)(q).path)&amp;0x0000000F)&gt;&gt;0)
#define	CLIENTPATH(q)	((((ulong)q)&amp;0x7FFFFFF0)&gt;&gt;QSHIFT)
#define	CLIENT(q)	CLIENTPATH((q).path)

#define	NHASH		(1&lt;&lt;5)
#define	HASHMASK	(NHASH-1)

typedef struct Client Client;
typedef struct Draw Draw;
typedef struct DImage DImage;
typedef struct DScreen DScreen;
typedef struct CScreen CScreen;
typedef struct FChar FChar;
typedef struct Refresh Refresh;
typedef struct Refx Refx;
typedef struct DName DName;

ulong blanktime = 30;	/* in minutes; a half hour */

struct Draw
{
	QLock;
	int		clientid;
	int		nclient;
	Client**	client;
	int		nname;
	DName*	name;
	int		vers;
	int		softscreen;
	int		blanked;	/* screen turned off */
	ulong		blanktime;	/* time of last operation */
	ulong		savemap[3*256];
};

struct Client
{
	Ref		r;
	DImage*		dimage[NHASH];
	CScreen*	cscreen;
	Refresh*	refresh;
	Rendez		refrend;
	uchar*		readdata;
	int		nreaddata;
	int		busy;
	int		clientid;
	int		slot;
	int		refreshme;
	int		infoid;
	int		op;
};

struct Refresh
{
	DImage*		dimage;
	Rectangle	r;
	Refresh*	next;
};

struct Refx
{
	Client*		client;
	DImage*		dimage;
};

struct DName
{
	char			*name;
	Client	*client;
	DImage*		dimage;
	int			vers;
};

struct FChar
{
	int		minx;	/* left edge of bits */
	int		maxx;	/* right edge of bits */
	uchar		miny;	/* first non-zero scan-line */
	uchar		maxy;	/* last non-zero scan-line + 1 */
	schar		left;	/* offset of baseline */
	uchar		width;	/* width of baseline */
};

/*
 * Reference counts in DImages:
 *	one per open by original client
 *	one per screen image or fill
 * 	one per image derived from this one by name
 */
struct DImage
{
	int		id;
	int		ref;
	char		*name;
	int		vers;
	Memimage*	image;
	int		ascent;
	int		nfchar;
	FChar*		fchar;
	DScreen*	dscreen;	/* 0 if not a window */
	DImage*	fromname;	/* image this one is derived from, by name */
	DImage*		next;
};

struct CScreen
{
	DScreen*	dscreen;
	CScreen*	next;
};

struct DScreen
{
	int		id;
	int		public;
	int		ref;
	DImage	*dimage;
	DImage	*dfill;
	Memscreen*	screen;
	Client*		owner;
	DScreen*	next;
};

static	Draw		sdraw;
static	Memimage	*screenimage;
static	Memdata	screendata;
static	Rectangle	flushrect;
static	int		waste;
static	DScreen*	dscreen;
extern	void		flushmemscreen(Rectangle);
	void		drawmesg(Client*, void*, int);
	void		drawuninstall(Client*, int);
	void		drawfreedimage(DImage*);
	Client*		drawclientofpath(ulong);

static	char Enodrawimage[] =	"unknown id for draw image";
static	char Enodrawscreen[] =	"unknown id for draw screen";
static	char Eshortdraw[] =	"short draw message";
static	char Eshortread[] =	"draw read too short";
static	char Eimageexists[] =	"image id in use";
static	char Escreenexists[] =	"screen id in use";
static	char Edrawmem[] =	"image memory allocation failed";
static	char Ereadoutside[] =	"readimage outside image";
static	char Ewriteoutside[] =	"writeimage outside image";
static	char Enotfont[] =	"image not a font";
static	char Eindex[] =		"character index out of range";
static	char Enoclient[] =	"no such draw client";
static	char Edepth[] =	"image has bad depth";
static	char Enameused[] =	"image name in use";
static	char Enoname[] =	"no image with that name";
static	char Eoldname[] =	"named image no longer valid";
static	char Enamed[] = 	"image already has name";
static	char Ewrongname[] = 	"wrong name for image";

void
drawlock(void)
{
	qlock(&amp;sdraw);
}

void
drawunlock(void)
{
	qunlock(&amp;sdraw);
}

int
candrawlock(void)
{
	return canqlock(&amp;sdraw);
}

static int
drawgen(Chan *c, Dirtab*, int, int s, Dir *dp)
{
	int t;
	Qid q;
	ulong path;
	Client *cl;

	q.vers = 0;

	if(s == DEVDOTDOT){
		switch(QID(c-&gt;qid)){
		case Qtopdir:
		case Q2nd:
			mkqid(&amp;q, Qtopdir, 0, QTDIR);
			devdir(c, q, "#i", 0, eve, 0500, dp);
			break;
		case Q3rd:
			cl = drawclientofpath(c-&gt;qid.path);
			if(cl == nil)
				strcpy(up-&gt;genbuf, "??");
			else
				sprint(up-&gt;genbuf, "%d", cl-&gt;clientid);
			mkqid(&amp;q, Q2nd, 0, QTDIR);
			devdir(c, q, up-&gt;genbuf, 0, eve, 0500, dp);
			break;
		default:
			panic("drawwalk %#llux", c-&gt;qid.path);
		}
		return 1;
	}

	/*
	 * Top level directory contains the name of the device.
	 */
	t = QID(c-&gt;qid);
	if(t == Qtopdir){
		switch(s){
		case 0:
			mkqid(&amp;q, Q2nd, 0, QTDIR);
			devdir(c, q, "draw", 0, eve, 0555, dp);
			break;
		default:
			return -1;
		}
		return 1;
	}

	/*
	 * Second level contains "new" plus all the clients.
	 */
	if(t == Q2nd || t == Qnew){
		if(s == 0){
			mkqid(&amp;q, Qnew, 0, QTFILE);
			devdir(c, q, "new", 0, eve, 0666, dp);
		}
		else if(s &lt;= sdraw.nclient){
			cl = sdraw.client[s-1];
			if(cl == 0)
				return 0;
			sprint(up-&gt;genbuf, "%d", cl-&gt;clientid);
			mkqid(&amp;q, (s&lt;&lt;QSHIFT)|Q3rd, 0, QTDIR);
			devdir(c, q, up-&gt;genbuf, 0, eve, 0555, dp);
			return 1;
		}
		else
			return -1;
		return 1;
	}

	/*
	 * Third level.
	 */
	path = c-&gt;qid.path&amp;~(((1&lt;&lt;QSHIFT)-1));	/* slot component */
	q.vers = c-&gt;qid.vers;
	q.type = QTFILE;
	switch(s){
	case 0:
		q.path = path|Qcolormap;
		devdir(c, q, "colormap", 0, eve, 0600, dp);
		break;
	case 1:
		q.path = path|Qctl;
		devdir(c, q, "ctl", 0, eve, 0600, dp);
		break;
	case 2:
		q.path = path|Qdata;
		devdir(c, q, "data", 0, eve, 0600, dp);
		break;
	case 3:
		q.path = path|Qrefresh;
		devdir(c, q, "refresh", 0, eve, 0400, dp);
		break;
	default:
		return -1;
	}
	return 1;
}

static
int
drawrefactive(void *a)
{
	Client *c;

	c = a;
	return c-&gt;refreshme || c-&gt;refresh!=0;
}

static
void
drawrefreshscreen(DImage *l, Client *client)
{
	while(l != nil &amp;&amp; l-&gt;dscreen == nil)
		l = l-&gt;fromname;
	if(l != nil &amp;&amp; l-&gt;dscreen-&gt;owner != client)
		l-&gt;dscreen-&gt;owner-&gt;refreshme = 1;
}

static
void
drawrefresh(Memimage *l, Rectangle r, void *v)
{
	Refx *x;
	DImage *d;
	Client *c;
	Refresh *ref;

	USED(l);
	if(v == 0)
		return;
	x = v;
	c = x-&gt;client;
	d = x-&gt;dimage;
	for(ref=c-&gt;refresh; ref; ref=ref-&gt;next)
		if(ref-&gt;dimage == d){
			combinerect(&amp;ref-&gt;r, r);
			return;
		}
	ref = malloc(sizeof(Refresh));
	if(ref){
		ref-&gt;dimage = d;
		ref-&gt;r = r;
		ref-&gt;next = c-&gt;refresh;
		c-&gt;refresh = ref;
	}
}

static void
addflush(Rectangle r)
{
	int abb, ar, anbb;
	Rectangle nbb;

	if(sdraw.softscreen==0 || !rectclip(&amp;r, screenimage-&gt;r))
		return;

	if(flushrect.min.x &gt;= flushrect.max.x){
		flushrect = r;
		waste = 0;
		return;
	}
	/* VNC uses a region to compute the minimum bounding area.
	 * The waste is far less than that of a bounding box. see region.c
	 */
	if(1){
		flushmemscreen(flushrect);
		flushrect = r;
		return;
	}
	nbb = flushrect;
	combinerect(&amp;nbb, r);
	ar = Dx(r)*Dy(r);
	abb = Dx(flushrect)*Dy(flushrect);
	anbb = Dx(nbb)*Dy(nbb);
	/*
	 * Area of new waste is area of new bb minus area of old bb,
	 * less the area of the new segment, which we assume is not waste.
	 * This could be negative, but that's OK.
	 */
	waste += anbb-abb - ar;
	if(waste &lt; 0)
		waste = 0;
	/*
	 * absorb if:
	 *	total area is small
	 *	waste is less than half total area
	 * 	rectangles touch
	 */
	if(anbb&lt;=1024 || waste*2&lt;anbb || rectXrect(flushrect, r)){
		flushrect = nbb;
		return;
	}
	/* emit current state */
	flushmemscreen(flushrect);
	flushrect = r;
	waste = 0;
}

static
void
dstflush(int dstid, Memimage *dst, Rectangle r)
{
	Memlayer *l;

	if(dstid == 0){
		//combinerect(&amp;flushrect, r);
		addflush(r); // for VNC, see comments in addflush
		return;
	}
	l = dst-&gt;layer;
	if(l == nil)
		return;
	do{
		if(l-&gt;screen-&gt;image-&gt;data != screenimage-&gt;data)
			return;
		r = rectaddpt(r, l-&gt;delta);
		l = l-&gt;screen-&gt;image-&gt;layer;
	}while(l);
	addflush(r);
}

static
void
drawflush(void)
{
	flushmemscreen(flushrect);
	flushrect = Rect(10000, 10000, -10000, -10000);
}

static
int
drawcmp(char *a, char *b, int n)
{
	if(strlen(a) != n)
		return 1;
	return memcmp(a, b, n);
}

DName*
drawlookupname(int n, char *str)
{
	DName *name, *ename;

	name = sdraw.name;
	ename = &amp;name[sdraw.nname];
	for(; name&lt;ename; name++)
		if(drawcmp(name-&gt;name, str, n) == 0)
			return name;
	return 0;
}

int
drawgoodname(DImage *d)
{
	DName *n;

	/* if window, validate the screen's own images */
	if(d-&gt;dscreen)
		if(drawgoodname(d-&gt;dscreen-&gt;dimage) == 0
		|| drawgoodname(d-&gt;dscreen-&gt;dfill) == 0)
			return 0;
	if(d-&gt;name == nil)
		return 1;
	n = drawlookupname(strlen(d-&gt;name), d-&gt;name);
	if(n==nil || n-&gt;vers!=d-&gt;vers)
		return 0;
	return 1;
}

DImage*
drawlookup(Client *client, int id, int checkname)
{
	DImage *d;

	d = client-&gt;dimage[id&amp;HASHMASK];
	while(d){
		if(d-&gt;id == id){
			if(checkname &amp;&amp; !drawgoodname(d))
				error(Eoldname);
			return d;
		}
		d = d-&gt;next;
	}
	return 0;
}

DScreen*
drawlookupdscreen(int id)
{
	DScreen *s;

	s = dscreen;
	while(s){
		if(s-&gt;id == id)
			return s;
		s = s-&gt;next;
	}
	return 0;
}

DScreen*
drawlookupscreen(Client *client, int id, CScreen **cs)
{
	CScreen *s;

	s = client-&gt;cscreen;
	while(s){
		if(s-&gt;dscreen-&gt;id == id){
			*cs = s;
			return s-&gt;dscreen;
		}
		s = s-&gt;next;
	}
	error(Enodrawscreen);
	return 0;
}

Memimage*
drawinstall(Client *client, int id, Memimage *i, DScreen *dscreen)
{
	DImage *d;

	d = malloc(sizeof(DImage));
	if(d == 0)
		return 0;
	d-&gt;id = id;
	d-&gt;ref = 1;
	d-&gt;name = 0;
	d-&gt;vers = 0;
	d-&gt;image = i;
	d-&gt;nfchar = 0;
	d-&gt;fchar = 0;
	d-&gt;fromname = 0;
	d-&gt;dscreen = dscreen;
	d-&gt;next = client-&gt;dimage[id&amp;HASHMASK];
	client-&gt;dimage[id&amp;HASHMASK] = d;
	return i;
}

Memscreen*
drawinstallscreen(Client *client, DScreen *d, int id, DImage *dimage, DImage *dfill, int public)
{
	Memscreen *s;
	CScreen *c;

	c = malloc(sizeof(CScreen));
	if(dimage &amp;&amp; dimage-&gt;image &amp;&amp; dimage-&gt;image-&gt;chan == 0)
		panic("bad image %p in drawinstallscreen", dimage-&gt;image);

	if(c == 0)
		return 0;
	if(d == 0){
		d = malloc(sizeof(DScreen));
		if(d == 0){
			free(c);
			return 0;
		}
		s = malloc(sizeof(Memscreen));
		if(s == 0){
			free(c);
			free(d);
			return 0;
		}
		s-&gt;frontmost = 0;
		s-&gt;rearmost = 0;
		d-&gt;dimage = dimage;
		if(dimage){
			s-&gt;image = dimage-&gt;image;
			dimage-&gt;ref++;
		}
		d-&gt;dfill = dfill;
		if(dfill){
			s-&gt;fill = dfill-&gt;image;
			dfill-&gt;ref++;
		}
		d-&gt;ref = 0;
		d-&gt;id = id;
		d-&gt;screen = s;
		d-&gt;public = public;
		d-&gt;next = dscreen;
		d-&gt;owner = client;
		dscreen = d;
	}
	c-&gt;dscreen = d;
	d-&gt;ref++;
	c-&gt;next = client-&gt;cscreen;
	client-&gt;cscreen = c;
	return d-&gt;screen;
}

void
drawdelname(DName *name)
{
	int i;

	i = name-sdraw.name;
	memmove(name, name+1, (sdraw.nname-(i+1))*sizeof(DName));
	sdraw.nname--;
}

void
drawfreedscreen(DScreen *this)
{
	DScreen *ds, *next;

	this-&gt;ref--;
	if(this-&gt;ref &lt; 0)
		print("negative ref in drawfreedscreen\n");
	if(this-&gt;ref &gt; 0)
		return;
	ds = dscreen;
	if(ds == this){
		dscreen = this-&gt;next;
		goto Found;
	}
	while(next = ds-&gt;next){	/* assign = */
		if(next == this){
			ds-&gt;next = this-&gt;next;
			goto Found;
		}
		ds = next;
	}
	error(Enodrawimage);

    Found:
	if(this-&gt;dimage)
		drawfreedimage(this-&gt;dimage);
	if(this-&gt;dfill)
		drawfreedimage(this-&gt;dfill);
	free(this-&gt;screen);
	free(this);
}

void
drawfreedimage(DImage *dimage)
{
	int i;
	Memimage *l;
	DScreen *ds;

	dimage-&gt;ref--;
	if(dimage-&gt;ref &lt; 0)
		print("negative ref in drawfreedimage\n");
	if(dimage-&gt;ref &gt; 0)
		return;

	/* any names? */
	for(i=0; i&lt;sdraw.nname; )
		if(sdraw.name[i].dimage == dimage)
			drawdelname(sdraw.name+i);
		else
			i++;
	if(dimage-&gt;fromname){	/* acquired by name; owned by someone else*/
		drawfreedimage(dimage-&gt;fromname);
		goto Return;
	}
	if(dimage-&gt;image == screenimage)	/* don't free the display */
		goto Return;
	ds = dimage-&gt;dscreen;
	if(ds){
		l = dimage-&gt;image;
		if(l-&gt;data == screenimage-&gt;data)
			addflush(l-&gt;layer-&gt;screenr);
		if(l-&gt;layer-&gt;refreshfn == drawrefresh)	/* else true owner will clean up */
			free(l-&gt;layer-&gt;refreshptr);
		l-&gt;layer-&gt;refreshptr = nil;
		if(drawgoodname(dimage))
			memldelete(l);
		else
			memlfree(l);
		drawfreedscreen(ds);
	}else
		freememimage(dimage-&gt;image);
    Return:
	free(dimage-&gt;fchar);
	free(dimage);
}

void
drawuninstallscreen(Client *client, CScreen *this)
{
	CScreen *cs, *next;

	cs = client-&gt;cscreen;
	if(cs == this){
		client-&gt;cscreen = this-&gt;next;
		drawfreedscreen(this-&gt;dscreen);
		free(this);
		return;
	}
	while(next = cs-&gt;next){	/* assign = */
		if(next == this){
			cs-&gt;next = this-&gt;next;
			drawfreedscreen(this-&gt;dscreen);
			free(this);
			return;
		}
		cs = next;
	}
}

void
drawuninstall(Client *client, int id)
{
	DImage *d, *next;

	d = client-&gt;dimage[id&amp;HASHMASK];
	if(d == 0)
		error(Enodrawimage);
	if(d-&gt;id == id){
		client-&gt;dimage[id&amp;HASHMASK] = d-&gt;next;
		drawfreedimage(d);
		return;
	}
	while(next = d-&gt;next){	/* assign = */
		if(next-&gt;id == id){
			d-&gt;next = next-&gt;next;
			drawfreedimage(next);
			return;
		}
		d = next;
	}
	error(Enodrawimage);
}

void
drawaddname(Client *client, DImage *di, int n, char *str)
{
	DName *name, *ename, *new, *t;

	name = sdraw.name;
	ename = &amp;name[sdraw.nname];
	for(; name&lt;ename; name++)
		if(drawcmp(name-&gt;name, str, n) == 0)
			error(Enameused);
	t = smalloc((sdraw.nname+1)*sizeof(DName));
	memmove(t, sdraw.name, sdraw.nname*sizeof(DName));
	free(sdraw.name);
	sdraw.name = t;
	new = &amp;sdraw.name[sdraw.nname++];
	new-&gt;name = smalloc(n+1);
	memmove(new-&gt;name, str, n);
	new-&gt;name[n] = 0;
	new-&gt;dimage = di;
	new-&gt;client = client;
	new-&gt;vers = ++sdraw.vers;
}

Client*
drawnewclient(void)
{
	Client *cl, **cp;
	int i;

	for(i=0; i&lt;sdraw.nclient; i++){
		cl = sdraw.client[i];
		if(cl == 0)
			break;
	}
	if(i == sdraw.nclient){
		cp = malloc((sdraw.nclient+1)*sizeof(Client*));
		if(cp == 0)
			return 0;
		memmove(cp, sdraw.client, sdraw.nclient*sizeof(Client*));
		free(sdraw.client);
		sdraw.client = cp;
		sdraw.nclient++;
		cp[i] = 0;
	}
	cl = malloc(sizeof(Client));
	if(cl == 0)
		return 0;
	memset(cl, 0, sizeof(Client));
	cl-&gt;slot = i;
	cl-&gt;clientid = ++sdraw.clientid;
	cl-&gt;op = SoverD;
	sdraw.client[i] = cl;
	return cl;
}

static int
drawclientop(Client *cl)
{
	int op;

	op = cl-&gt;op;
	cl-&gt;op = SoverD;
	return op;
}

int
drawhasclients(void)
{
	/*
	 * if draw has ever been used, we can't resize the frame buffer,
	 * even if all clients have exited (nclients is cumulative); it's too
	 * hard to make work.
	 */
	return sdraw.nclient != 0;
}

Client*
drawclientofpath(ulong path)
{
	Client *cl;
	int slot;

	slot = CLIENTPATH(path);
	if(slot == 0)
		return nil;
	cl = sdraw.client[slot-1];
	if(cl==0 || cl-&gt;clientid==0)
		return nil;
	return cl;
}


Client*
drawclient(Chan *c)
{
	Client *client;

	client = drawclientofpath(c-&gt;qid.path);
	if(client == nil)
		error(Enoclient);
	return client;
}

Memimage*
drawimage(Client *client, uchar *a)
{
	DImage *d;

	d = drawlookup(client, BGLONG(a), 1);
	if(d == nil)
		error(Enodrawimage);
	return d-&gt;image;
}

void
drawrectangle(Rectangle *r, uchar *a)
{
	r-&gt;min.x = BGLONG(a+0*4);
	r-&gt;min.y = BGLONG(a+1*4);
	r-&gt;max.x = BGLONG(a+2*4);
	r-&gt;max.y = BGLONG(a+3*4);
}

void
drawpoint(Point *p, uchar *a)
{
	p-&gt;x = BGLONG(a+0*4);
	p-&gt;y = BGLONG(a+1*4);
}

Point
drawchar(Memimage *dst, Point p, Memimage *src, Point *sp, DImage *font, int index, int op)
{
	FChar *fc;
	Rectangle r;
	Point sp1;

	fc = &amp;font-&gt;fchar[index];
	r.min.x = p.x+fc-&gt;left;
	r.min.y = p.y-(font-&gt;ascent-fc-&gt;miny);
	r.max.x = r.min.x+(fc-&gt;maxx-fc-&gt;minx);
	r.max.y = r.min.y+(fc-&gt;maxy-fc-&gt;miny);
	sp1.x = sp-&gt;x+fc-&gt;left;
	sp1.y = sp-&gt;y+fc-&gt;miny;
	memdraw(dst, r, src, sp1, font-&gt;image, Pt(fc-&gt;minx, fc-&gt;miny), op);
	p.x += fc-&gt;width;
	sp-&gt;x += fc-&gt;width;
	return p;
}

static int
initscreenimage(void)
{
	int width, depth;
	ulong chan;
	Rectangle r;

	if(screenimage != nil)
		return 1;

	screendata.base = nil;
	screendata.bdata = attachscreen(&amp;r, &amp;chan, &amp;depth, &amp;width, &amp;sdraw.softscreen);
	if(screendata.bdata == nil)
{fprint(2, "bad bdata\n");
		return 0;
}
	screendata.ref = 1;

	screenimage = allocmemimaged(r, chan, &amp;screendata);
	if(screenimage == nil){
fprint(2, "bad memimaged: %r\n");
		/* RSC: BUG: detach screen */
		return 0;
	}

	screenimage-&gt;width = width;
	screenimage-&gt;clipr  = screenimage-&gt;r;
	return 1;
}

void
deletescreenimage(void)
{
	qlock(&amp;sdraw);
	/* RSC: BUG: detach screen */
	if(screenimage)
		freememimage(screenimage);
	screenimage = nil;
	qunlock(&amp;sdraw);
}

Chan*
drawattach(char *spec)
{
	qlock(&amp;sdraw);
	if(!initscreenimage()){
		qunlock(&amp;sdraw);
		error("no frame buffer");
	}
	qunlock(&amp;sdraw);
	return devattach('i', spec);
}

Walkqid*
drawwalk(Chan *c, Chan *nc, char **name, int nname)
{
	if(screendata.bdata == nil)
		error("no frame buffer");
	return devwalk(c, nc, name, nname, 0, 0, drawgen);
}

static int
drawstat(Chan *c, uchar *db, int n)
{
	return devstat(c, db, n, 0, 0, drawgen);
}

static Chan*
drawopen(Chan *c, int omode)
{
	Client *cl;

	if(c-&gt;qid.type &amp; QTDIR)
		return devopen(c, omode, 0, 0, drawgen);

	qlock(&amp;sdraw);
	if(waserror()){
		qunlock(&amp;sdraw);
		nexterror();
	}

	if(QID(c-&gt;qid) == Qnew){
		cl = drawnewclient();
		if(cl == 0)
			error(Enodev);
		c-&gt;qid.path = Qctl|((cl-&gt;slot+1)&lt;&lt;QSHIFT);
	}

	switch(QID(c-&gt;qid)){
	case Qnew:
		break;

	case Qctl:
		cl = drawclient(c);
		if(cl-&gt;busy)
			error(Einuse);
		cl-&gt;busy = 1;
		flushrect = Rect(10000, 10000, -10000, -10000);
		drawinstall(cl, 0, screenimage, 0);
		incref(&amp;cl-&gt;r);
		break;
	case Qcolormap:
	case Qdata:
	case Qrefresh:
		cl = drawclient(c);
		incref(&amp;cl-&gt;r);
		break;
	}
	qunlock(&amp;sdraw);
	poperror();
	c-&gt;mode = openmode(omode);
	c-&gt;flag |= COPEN;
	c-&gt;offset = 0;
	return c;
}

static void
drawclose(Chan *c)
{
	int i;
	DImage *d, **dp;
	Client *cl;
	Refresh *r;

	if(c-&gt;qid.type &amp; QTDIR)
		return;
	qlock(&amp;sdraw);
	if(waserror()){
		qunlock(&amp;sdraw);
		nexterror();
	}

	cl = drawclient(c);
	if(QID(c-&gt;qid) == Qctl)
		cl-&gt;busy = 0;
	if((c-&gt;flag&amp;COPEN) &amp;&amp; (decref(&amp;cl-&gt;r)==0)){
		while(r = cl-&gt;refresh){	/* assign = */
			cl-&gt;refresh = r-&gt;next;
			free(r);
		}
		/* free names */
		for(i=0; i&lt;sdraw.nname; )
			if(sdraw.name[i].client == cl)
				drawdelname(sdraw.name+i);
			else
				i++;
		while(cl-&gt;cscreen)
			drawuninstallscreen(cl, cl-&gt;cscreen);
		/* all screens are freed, so now we can free images */
		dp = cl-&gt;dimage;
		for(i=0; i&lt;NHASH; i++){
			while((d = *dp) != nil){
				*dp = d-&gt;next;
				drawfreedimage(d);
			}
			dp++;
		}
		sdraw.client[cl-&gt;slot] = 0;
		drawflush();	/* to erase visible, now dead windows */
		free(cl);
	}
	qunlock(&amp;sdraw);
	poperror();
}

long
drawread(Chan *c, void *a, long n, vlong off)
{
	int index, m;
	ulong red, green, blue;
	Client *cl;
	uchar *p;
	Refresh *r;
	DImage *di;
	Memimage *i;
	ulong offset = off;
	char buf[16];

	USED(offset);
	if(c-&gt;qid.type &amp; QTDIR)
		return devdirread(c, a, n, 0, 0, drawgen);
	cl = drawclient(c);
	qlock(&amp;sdraw);
	if(waserror()){
		qunlock(&amp;sdraw);
		nexterror();
	}
	switch(QID(c-&gt;qid)){
	case Qctl:
		if(n &lt; 12*12)
			error(Eshortread);
		if(cl-&gt;infoid &lt; 0)
			error(Enodrawimage);
		if(cl-&gt;infoid == 0){
			i = screenimage;
			if(i == nil)
				error(Enodrawimage);
		}else{
			di = drawlookup(cl, cl-&gt;infoid, 1);
			if(di == nil)
				error(Enodrawimage);
			i = di-&gt;image;
		}
		n = sprint(a, "%11d %11d %11s %11d %11d %11d %11d %11d %11d %11d %11d %11d ",
			cl-&gt;clientid, cl-&gt;infoid, chantostr(buf, i-&gt;chan), (i-&gt;flags&amp;Frepl)==Frepl,
			i-&gt;r.min.x, i-&gt;r.min.y, i-&gt;r.max.x, i-&gt;r.max.y,
			i-&gt;clipr.min.x, i-&gt;clipr.min.y, i-&gt;clipr.max.x, i-&gt;clipr.max.y);
		cl-&gt;infoid = -1;
		break;

	case Qcolormap:
		drawactive(1);	/* to restore map from backup */
		p = malloc(4*12*256+1);
		if(p == 0)
			error(Enomem);
		m = 0;
		for(index = 0; index &lt; 256; index++){
			getcolor(index, &amp;red, &amp;green, &amp;blue);
			m += sprint((char*)p+m, "%11d %11lud %11lud %11lud\n", index, red&gt;&gt;24, green&gt;&gt;24, blue&gt;&gt;24);
		}
		n = readstr(offset, a, n, (char*)p);
		free(p);
		break;

	case Qdata:
		if(cl-&gt;readdata == nil)
			error("no draw data");
		if(n &lt; cl-&gt;nreaddata)
			error(Eshortread);
		n = cl-&gt;nreaddata;
		memmove(a, cl-&gt;readdata, cl-&gt;nreaddata);
		free(cl-&gt;readdata);
		cl-&gt;readdata = nil;
		break;

	case Qrefresh:
		if(n &lt; 5*4)
			error(Ebadarg);
		for(;;){
			if(cl-&gt;refreshme || cl-&gt;refresh)
				break;
			qunlock(&amp;sdraw);
			if(waserror()){
				qlock(&amp;sdraw);	/* restore lock for waserror() above */
				nexterror();
			}
			rendsleep(&amp;cl-&gt;refrend, drawrefactive, cl);
			poperror();
			qlock(&amp;sdraw);
		}
		p = a;
		while(cl-&gt;refresh &amp;&amp; n&gt;=5*4){
			r = cl-&gt;refresh;
			BPLONG(p+0*4, r-&gt;dimage-&gt;id);
			BPLONG(p+1*4, r-&gt;r.min.x);
			BPLONG(p+2*4, r-&gt;r.min.y);
			BPLONG(p+3*4, r-&gt;r.max.x);
			BPLONG(p+4*4, r-&gt;r.max.y);
			cl-&gt;refresh = r-&gt;next;
			free(r);
			p += 5*4;
			n -= 5*4;
		}
		cl-&gt;refreshme = 0;
		n = p-(uchar*)a;
	}
	qunlock(&amp;sdraw);
	poperror();
	return n;
}

void
drawwakeall(void)
{
	Client *cl;
	int i;

	for(i=0; i&lt;sdraw.nclient; i++){
		cl = sdraw.client[i];
		if(cl &amp;&amp; (cl-&gt;refreshme || cl-&gt;refresh))
			rendwakeup(&amp;cl-&gt;refrend);
	}
}

static long
drawwrite(Chan *c, void *a, long n, vlong off)
{
	char buf[128], *fields[4], *q;
	Client *cl;
	int i, m, red, green, blue, x;
	ulong offset = off;

	USED(offset);
	if(c-&gt;qid.type &amp; QTDIR)
		error(Eisdir);
	cl = drawclient(c);
	qlock(&amp;sdraw);
	if(waserror()){
		drawwakeall();
		qunlock(&amp;sdraw);
		nexterror();
	}
	switch(QID(c-&gt;qid)){
	case Qctl:
		if(n != 4)
			error("unknown draw control request");
		cl-&gt;infoid = BGLONG((uchar*)a);
		break;

	case Qcolormap:
		drawactive(1);	/* to restore map from backup */
		m = n;
		n = 0;
		while(m &gt; 0){
			x = m;
			if(x &gt; sizeof(buf)-1)
				x = sizeof(buf)-1;
			q = memccpy(buf, a, '\n', x);
			if(q == 0)
				break;
			i = q-buf;
			n += i;
			a = (char*)a + i;
			m -= i;
			*q = 0;
			if(getfields(buf, fields, nelem(fields), 1, " ") != 4)
				error(Ebadarg);
			i = strtoul(fields[0], 0, 0);
			red = strtoul(fields[1], 0, 0);
			green = strtoul(fields[2], 0, 0);
			blue = strtoul(fields[3], &amp;q, 0);
			if(fields[3] == q)
				error(Ebadarg);
			if(red&gt;255 || green&gt;255 || blue&gt;255 || i&lt;0 || i&gt;255)
				error(Ebadarg);
			red |= red&lt;&lt;8;
			red |= red&lt;&lt;16;
			green |= green&lt;&lt;8;
			green |= green&lt;&lt;16;
			blue |= blue&lt;&lt;8;
			blue |= blue&lt;&lt;16;
			setcolor(i, red, green, blue);
		}
		break;

	case Qdata:
		drawmesg(cl, a, n);
		drawwakeall();
		break;

	default:
		error(Ebadusefd);
	}
	qunlock(&amp;sdraw);
	poperror();
	return n;
}

uchar*
drawcoord(uchar *p, uchar *maxp, int oldx, int *newx)
{
	int b, x;

	if(p &gt;= maxp)
		error(Eshortdraw);
	b = *p++;
	x = b &amp; 0x7F;
	if(b &amp; 0x80){
		if(p+1 &gt;= maxp)
			error(Eshortdraw);
		x |= *p++ &lt;&lt; 7;
		x |= *p++ &lt;&lt; 15;
		if(x &amp; (1&lt;&lt;22))
			x |= ~0&lt;&lt;23;
	}else{
		if(b &amp; 0x40)
			x |= ~0&lt;&lt;7;
		x += oldx;
	}
	*newx = x;
	return p;
}

static void
printmesg(char *fmt, uchar *a, int plsprnt)
{
	char buf[256];
	char *p, *q;
	int s;

	if(1|| plsprnt==0){
		SET(s,q,p);
		USED(fmt, a, buf, p, q, s);
		return;
	}
	q = buf;
	*q++ = *a++;
	for(p=fmt; *p; p++){
		switch(*p){
		case 'l':
			q += sprint(q, " %ld", (long)BGLONG(a));
			a += 4;
			break;
		case 'L':
			q += sprint(q, " %.8lux", (ulong)BGLONG(a));
			a += 4;
			break;
		case 'R':
			q += sprint(q, " [%d %d %d %d]", BGLONG(a), BGLONG(a+4), BGLONG(a+8), BGLONG(a+12));
			a += 16;
			break;
		case 'P':
			q += sprint(q, " [%d %d]", BGLONG(a), BGLONG(a+4));
			a += 8;
			break;
		case 'b':
			q += sprint(q, " %d", *a++);
			break;
		case 's':
			q += sprint(q, " %d", BGSHORT(a));
			a += 2;
			break;
		case 'S':
			q += sprint(q, " %.4ux", BGSHORT(a));
			a += 2;
			break;
		}
	}
	*q++ = '\n';
	*q = 0;
	iprint("%.*s", (int)(q-buf), buf);
}

void
drawmesg(Client *client, void *av, int n)
{
	int c, repl, m, y, dstid, scrnid, ni, ci, j, nw, e0, e1, op, ox, oy, oesize, esize, doflush;
	uchar *u, *a, refresh;
	char *fmt;
	ulong value, chan;
	Rectangle r, clipr;
	Point p, q, *pp, sp;
	Memimage *i, *dst, *src, *mask;
	Memimage *l, **lp;
	Memscreen *scrn;
	DImage *font, *ll, *di, *ddst, *dsrc;
	DName *dn;
	DScreen *dscrn;
	FChar *fc;
	Refx *refx;
	CScreen *cs;
	Refreshfn reffn;

	a = av;
	m = 0;
	fmt = nil;
	if(waserror()){
		if(fmt) printmesg(fmt, a, 1);
	/*	iprint("error: %s\n", up-&gt;error);	*/
		nexterror();
	}
	while((n-=m) &gt; 0){
		USED(fmt);
		a += m;
		switch(*a){
		default:
			error("bad draw command");
		/* new allocate: 'b' id[4] screenid[4] refresh[1] chan[4] repl[1] R[4*4] clipR[4*4] rrggbbaa[4] */
		case 'b':
			printmesg(fmt="LLbLbRRL", a, 0);
			m = 1+4+4+1+4+1+4*4+4*4+4;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			scrnid = BGSHORT(a+5);
			refresh = a[9];
			chan = BGLONG(a+10);
			repl = a[14];
			drawrectangle(&amp;r, a+15);
			drawrectangle(&amp;clipr, a+31);
			value = BGLONG(a+47);
			if(drawlookup(client, dstid, 0))
				error(Eimageexists);
			if(scrnid){
				dscrn = drawlookupscreen(client, scrnid, &amp;cs);
				scrn = dscrn-&gt;screen;
				if(repl || chan!=scrn-&gt;image-&gt;chan)
					error("image parameters incompatible with screen");
				reffn = nil;
				switch(refresh){
				case Refbackup:
					break;
				case Refnone:
					reffn = memlnorefresh;
					break;
				case Refmesg:
					reffn = drawrefresh;
					break;
				default:
					error("unknown refresh method");
				}
				l = memlalloc(scrn, r, reffn, 0, value);
				if(l == 0)
					error(Edrawmem);
				addflush(l-&gt;layer-&gt;screenr);
				l-&gt;clipr = clipr;
				rectclip(&amp;l-&gt;clipr, r);
				if(drawinstall(client, dstid, l, dscrn) == 0){
					memldelete(l);
					error(Edrawmem);
				}
				dscrn-&gt;ref++;
				if(reffn){
					refx = nil;
					if(reffn == drawrefresh){
						refx = malloc(sizeof(Refx));
						if(refx == 0){
							drawuninstall(client, dstid);
							error(Edrawmem);
						}
						refx-&gt;client = client;
						refx-&gt;dimage = drawlookup(client, dstid, 1);
					}
					memlsetrefresh(l, reffn, refx);
				}
				continue;
			}
			i = allocmemimage(r, chan);
			if(i == 0)
				error(Edrawmem);
			if(repl)
				i-&gt;flags |= Frepl;
			i-&gt;clipr = clipr;
			if(!repl)
				rectclip(&amp;i-&gt;clipr, r);
			if(drawinstall(client, dstid, i, 0) == 0){
				freememimage(i);
				error(Edrawmem);
			}
			memfillcolor(i, value);
			continue;

		/* allocate screen: 'A' id[4] imageid[4] fillid[4] public[1] */
		case 'A':
			printmesg(fmt="LLLb", a, 1);
			m = 1+4+4+4+1;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			if(dstid == 0)
				error(Ebadarg);
			if(drawlookupdscreen(dstid))
				error(Escreenexists);
			ddst = drawlookup(client, BGLONG(a+5), 1);
			dsrc = drawlookup(client, BGLONG(a+9), 1);
			if(ddst==0 || dsrc==0)
				error(Enodrawimage);
			if(drawinstallscreen(client, 0, dstid, ddst, dsrc, a[13]) == 0)
				error(Edrawmem);
			continue;

		/* set repl and clip: 'c' dstid[4] repl[1] clipR[4*4] */
		case 'c':
			printmesg(fmt="LbR", a, 0);
			m = 1+4+1+4*4;
			if(n &lt; m)
				error(Eshortdraw);
			ddst = drawlookup(client, BGLONG(a+1), 1);
			if(ddst == nil)
				error(Enodrawimage);
			if(ddst-&gt;name)
				error("can't change repl/clipr of shared image");
			dst = ddst-&gt;image;
			if(a[5])
				dst-&gt;flags |= Frepl;
			drawrectangle(&amp;dst-&gt;clipr, a+6);
			continue;

		/* draw: 'd' dstid[4] srcid[4] maskid[4] R[4*4] P[2*4] P[2*4] */
		case 'd':
			printmesg(fmt="LLLRPP", a, 0);
			m = 1+4+4+4+4*4+2*4+2*4;
			if(n &lt; m)
				error(Eshortdraw);
			dst = drawimage(client, a+1);
			dstid = BGLONG(a+1);
			src = drawimage(client, a+5);
			mask = drawimage(client, a+9);
			drawrectangle(&amp;r, a+13);
			drawpoint(&amp;p, a+29);
			drawpoint(&amp;q, a+37);
			op = drawclientop(client);
			memdraw(dst, r, src, p, mask, q, op);
			dstflush(dstid, dst, r);
			continue;

		/* toggle debugging: 'D' val[1] */
		case 'D':
			printmesg(fmt="b", a, 0);
			m = 1+1;
			if(n &lt; m)
				error(Eshortdraw);
			drawdebug = a[1];
			continue;

		/* ellipse: 'e' dstid[4] srcid[4] center[2*4] a[4] b[4] thick[4] sp[2*4] alpha[4] phi[4]*/
		case 'e':
		case 'E':
			printmesg(fmt="LLPlllPll", a, 0);
			m = 1+4+4+2*4+4+4+4+2*4+2*4;
			if(n &lt; m)
				error(Eshortdraw);
			dst = drawimage(client, a+1);
			dstid = BGLONG(a+1);
			src = drawimage(client, a+5);
			drawpoint(&amp;p, a+9);
			e0 = BGLONG(a+17);
			e1 = BGLONG(a+21);
			if(e0&lt;0 || e1&lt;0)
				error("invalid ellipse semidiameter");
			j = BGLONG(a+25);
			if(j &lt; 0)
				error("negative ellipse thickness");
			drawpoint(&amp;sp, a+29);
			c = j;
			if(*a == 'E')
				c = -1;
			ox = BGLONG(a+37);
			oy = BGLONG(a+41);
			op = drawclientop(client);
			/* high bit indicates arc angles are present */
			if(ox &amp; (1&lt;&lt;31)){
				if((ox &amp; (1&lt;&lt;30)) == 0)
					ox &amp;= ~(1&lt;&lt;31);
				memarc(dst, p, e0, e1, c, src, sp, ox, oy, op);
			}else
				memellipse(dst, p, e0, e1, c, src, sp, op);
			dstflush(dstid, dst, Rect(p.x-e0-j, p.y-e1-j, p.x+e0+j+1, p.y+e1+j+1));
			continue;

		/* free: 'f' id[4] */
		case 'f':
			printmesg(fmt="L", a, 1);
			m = 1+4;
			if(n &lt; m)
				error(Eshortdraw);
			ll = drawlookup(client, BGLONG(a+1), 0);
			if(ll &amp;&amp; ll-&gt;dscreen &amp;&amp; ll-&gt;dscreen-&gt;owner != client)
				ll-&gt;dscreen-&gt;owner-&gt;refreshme = 1;
			drawuninstall(client, BGLONG(a+1));
			continue;

		/* free screen: 'F' id[4] */
		case 'F':
			printmesg(fmt="L", a, 1);
			m = 1+4;
			if(n &lt; m)
				error(Eshortdraw);
			drawlookupscreen(client, BGLONG(a+1), &amp;cs);
			drawuninstallscreen(client, cs);
			continue;

		/* initialize font: 'i' fontid[4] nchars[4] ascent[1] */
		case 'i':
			printmesg(fmt="Llb", a, 1);
			m = 1+4+4+1;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			if(dstid == 0)
				error("can't use display as font");
			font = drawlookup(client, dstid, 1);
			if(font == 0)
				error(Enodrawimage);
			if(font-&gt;image-&gt;layer)
				error("can't use window as font");
			free(font-&gt;fchar);	/* should we complain if non-zero? */
			ni = BGLONG(a+5);
			font-&gt;fchar = malloc(ni*sizeof(FChar));
			if(font-&gt;fchar == 0)
				error("no memory for font");
			memset(font-&gt;fchar, 0, ni*sizeof(FChar));
			font-&gt;nfchar = ni;
			font-&gt;ascent = a[9];
			continue;

		/* load character: 'l' fontid[4] srcid[4] index[2] R[4*4] P[2*4] left[1] width[1] */
		case 'l':
			printmesg(fmt="LLSRPbb", a, 0);
			m = 1+4+4+2+4*4+2*4+1+1;
			if(n &lt; m)
				error(Eshortdraw);
			font = drawlookup(client, BGLONG(a+1), 1);
			if(font == 0)
				error(Enodrawimage);
			if(font-&gt;nfchar == 0)
				error(Enotfont);
			src = drawimage(client, a+5);
			ci = BGSHORT(a+9);
			if(ci &gt;= font-&gt;nfchar)
				error(Eindex);
			drawrectangle(&amp;r, a+11);
			drawpoint(&amp;p, a+27);
			memdraw(font-&gt;image, r, src, p, memopaque, p, S);
			fc = &amp;font-&gt;fchar[ci];
			fc-&gt;minx = r.min.x;
			fc-&gt;maxx = r.max.x;
			fc-&gt;miny = r.min.y;
			fc-&gt;maxy = r.max.y;
			fc-&gt;left = a[35];
			fc-&gt;width = a[36];
			continue;

		/* draw line: 'L' dstid[4] p0[2*4] p1[2*4] end0[4] end1[4] radius[4] srcid[4] sp[2*4] */
		case 'L':
			printmesg(fmt="LPPlllLP", a, 0);
			m = 1+4+2*4+2*4+4+4+4+4+2*4;
			if(n &lt; m)
				error(Eshortdraw);
			dst = drawimage(client, a+1);
			dstid = BGLONG(a+1);
			drawpoint(&amp;p, a+5);
			drawpoint(&amp;q, a+13);
			e0 = BGLONG(a+21);
			e1 = BGLONG(a+25);
			j = BGLONG(a+29);
			if(j &lt; 0)
				error("negative line width");
			src = drawimage(client, a+33);
			drawpoint(&amp;sp, a+37);
			op = drawclientop(client);
			memline(dst, p, q, e0, e1, j, src, sp, op);
			/* avoid memlinebbox if possible */
			if(dstid==0 || dst-&gt;layer!=nil){
				/* BUG: this is terribly inefficient: update maximal containing rect*/
				r = memlinebbox(p, q, e0, e1, j);
				dstflush(dstid, dst, insetrect(r, -(1+1+j)));
			}
			continue;

		/* create image mask: 'm' newid[4] id[4] */
/*
 *
		case 'm':
			printmesg("LL", a, 0);
			m = 4+4;
			if(n &lt; m)
				error(Eshortdraw);
			break;
 *
 */

		/* attach to a named image: 'n' dstid[4] j[1] name[j] */
		case 'n':
			printmesg(fmt="Lz", a, 0);
			m = 1+4+1;
			if(n &lt; m)
				error(Eshortdraw);
			j = a[5];
			if(j == 0)	/* give me a non-empty name please */
				error(Eshortdraw);
			m += j;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			if(drawlookup(client, dstid, 0))
				error(Eimageexists);
			dn = drawlookupname(j, (char*)a+6);
			if(dn == nil)
				error(Enoname);
			if(drawinstall(client, dstid, dn-&gt;dimage-&gt;image, 0) == 0)
				error(Edrawmem);
			di = drawlookup(client, dstid, 0);
			if(di == 0)
				error("draw: can't happen");
			di-&gt;vers = dn-&gt;vers;
			di-&gt;name = smalloc(j+1);
			di-&gt;fromname = dn-&gt;dimage;
			di-&gt;fromname-&gt;ref++;
			memmove(di-&gt;name, a+6, j);
			di-&gt;name[j] = 0;
			client-&gt;infoid = dstid;
			continue;

		/* name an image: 'N' dstid[4] in[1] j[1] name[j] */
		case 'N':
			printmesg(fmt="Lbz", a, 0);
			m = 1+4+1+1;
			if(n &lt; m)
				error(Eshortdraw);
			c = a[5];
			j = a[6];
			if(j == 0)	/* give me a non-empty name please */
				error(Eshortdraw);
			m += j;
			if(n &lt; m)
				error(Eshortdraw);
			di = drawlookup(client, BGLONG(a+1), 0);
			if(di == 0)
				error(Enodrawimage);
			if(di-&gt;name)
				error(Enamed);
			if(c)
				drawaddname(client, di, j, (char*)a+7);
			else{
				dn = drawlookupname(j, (char*)a+7);
				if(dn == nil)
					error(Enoname);
				if(dn-&gt;dimage != di)
					error(Ewrongname);
				drawdelname(dn);
			}
			continue;

		/* position window: 'o' id[4] r.min [2*4] screenr.min [2*4] */
		case 'o':
			printmesg(fmt="LPP", a, 0);
			m = 1+4+2*4+2*4;
			if(n &lt; m)
				error(Eshortdraw);
			dst = drawimage(client, a+1);
			if(dst-&gt;layer){
				drawpoint(&amp;p, a+5);
				drawpoint(&amp;q, a+13);
				r = dst-&gt;layer-&gt;screenr;
				ni = memlorigin(dst, p, q);
				if(ni &lt; 0)
					error("image origin failed");
				if(ni &gt; 0){
					addflush(r);
					addflush(dst-&gt;layer-&gt;screenr);
					ll = drawlookup(client, BGLONG(a+1), 1);
					drawrefreshscreen(ll, client);
				}
			}
			continue;

		/* set compositing operator for next draw operation: 'O' op */
		case 'O':
			printmesg(fmt="b", a, 0);
			m = 1+1;
			if(n &lt; m)
				error(Eshortdraw);
			client-&gt;op = a[1];
			continue;

		/* filled polygon: 'P' dstid[4] n[2] wind[4] ignore[2*4] srcid[4] sp[2*4] p0[2*4] dp[2*2*n] */
		/* polygon: 'p' dstid[4] n[2] end0[4] end1[4] radius[4] srcid[4] sp[2*4] p0[2*4] dp[2*2*n] */
		case 'p':
		case 'P':
			printmesg(fmt="LslllLPP", a, 0);
			m = 1+4+2+4+4+4+4+2*4;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			dst = drawimage(client, a+1);
			ni = BGSHORT(a+5);
			if(ni &lt; 0)
				error("negative count in polygon");
			e0 = BGLONG(a+7);
			e1 = BGLONG(a+11);
			j = 0;
			if(*a == 'p'){
				j = BGLONG(a+15);
				if(j &lt; 0)
					error("negative polygon line width");
			}
			src = drawimage(client, a+19);
			drawpoint(&amp;sp, a+23);
			drawpoint(&amp;p, a+31);
			ni++;
			pp = malloc(ni*sizeof(Point));
			if(pp == nil)
				error(Enomem);
			doflush = 0;
			if(dstid==0 || (dst-&gt;layer &amp;&amp; dst-&gt;layer-&gt;screen-&gt;image-&gt;data == screenimage-&gt;data))
				doflush = 1;	/* simplify test in loop */
			ox = oy = 0;
			esize = 0;
			u = a+m;
			for(y=0; y&lt;ni; y++){
				q = p;
				oesize = esize;
				u = drawcoord(u, a+n, ox, &amp;p.x);
				u = drawcoord(u, a+n, oy, &amp;p.y);
				ox = p.x;
				oy = p.y;
				if(doflush){
					esize = j;
					if(*a == 'p'){
						if(y == 0){
							c = memlineendsize(e0);
							if(c &gt; esize)
								esize = c;
						}
						if(y == ni-1){
							c = memlineendsize(e1);
							if(c &gt; esize)
								esize = c;
						}
					}
					if(*a=='P' &amp;&amp; e0!=1 &amp;&amp; e0 !=~0)
						r = dst-&gt;clipr;
					else if(y &gt; 0){
						r = Rect(q.x-oesize, q.y-oesize, q.x+oesize+1, q.y+oesize+1);
						combinerect(&amp;r, Rect(p.x-esize, p.y-esize, p.x+esize+1, p.y+esize+1));
					}
					if(rectclip(&amp;r, dst-&gt;clipr))		/* should perhaps be an arg to dstflush */
						dstflush(dstid, dst, r);
				}
				pp[y] = p;
			}
			if(y == 1)
				dstflush(dstid, dst, Rect(p.x-esize, p.y-esize, p.x+esize+1, p.y+esize+1));
			op = drawclientop(client);
			if(*a == 'p')
				mempoly(dst, pp, ni, e0, e1, j, src, sp, op);
			else
				memfillpoly(dst, pp, ni, e0, src, sp, op);
			free(pp);
			m = u-a;
			continue;

		/* read: 'r' id[4] R[4*4] */
		case 'r':
			printmesg(fmt="LR", a, 0);
			m = 1+4+4*4;
			if(n &lt; m)
				error(Eshortdraw);
			i = drawimage(client, a+1);
			if(0 &amp;&amp; i-&gt;layer)
				error("readimage from window unimplemented");
			drawrectangle(&amp;r, a+5);
			if(!rectinrect(r, i-&gt;r))
				error(Ereadoutside);
			c = bytesperline(r, i-&gt;depth);
			c *= Dy(r);
			free(client-&gt;readdata);
			client-&gt;readdata = mallocz(c, 0);
			if(client-&gt;readdata == nil)
				error("readimage malloc failed");
			client-&gt;nreaddata = unloadmemimage(i, r, client-&gt;readdata, c);
			if(client-&gt;nreaddata &lt; 0){
				free(client-&gt;readdata);
				client-&gt;readdata = nil;
				error("bad readimage call");
			}
			continue;

		/* string: 's' dstid[4] srcid[4] fontid[4] P[2*4] clipr[4*4] sp[2*4] ni[2] ni*(index[2]) */
		/* stringbg: 'x' dstid[4] srcid[4] fontid[4] P[2*4] clipr[4*4] sp[2*4] ni[2] bgid[4] bgpt[2*4] ni*(index[2]) */
		case 's':
		case 'x':
			printmesg(fmt="LLLPRPs", a, 0);
			m = 1+4+4+4+2*4+4*4+2*4+2;
			if(*a == 'x')
				m += 4+2*4;
			if(n &lt; m)
				error(Eshortdraw);

			dst = drawimage(client, a+1);
			dstid = BGLONG(a+1);
			src = drawimage(client, a+5);
			font = drawlookup(client, BGLONG(a+9), 1);
			if(font == 0)
				error(Enodrawimage);
			if(font-&gt;nfchar == 0)
				error(Enotfont);
			drawpoint(&amp;p, a+13);
			drawrectangle(&amp;r, a+21);
			drawpoint(&amp;sp, a+37);
			ni = BGSHORT(a+45);
			u = a+m;
			m += ni*2;
			if(n &lt; m)
				error(Eshortdraw);
			clipr = dst-&gt;clipr;
			dst-&gt;clipr = r;
			op = drawclientop(client);
			if(*a == 'x'){
				/* paint background */
				l = drawimage(client, a+47);
				drawpoint(&amp;q, a+51);
				r.min.x = p.x;
				r.min.y = p.y-font-&gt;ascent;
				r.max.x = p.x;
				r.max.y = r.min.y+Dy(font-&gt;image-&gt;r);
				j = ni;
				while(--j &gt;= 0){
					ci = BGSHORT(u);
					if(ci&lt;0 || ci&gt;=font-&gt;nfchar){
						dst-&gt;clipr = clipr;
						error(Eindex);
					}
					r.max.x += font-&gt;fchar[ci].width;
					u += 2;
				}
				memdraw(dst, r, l, q, memopaque, ZP, op);
				u -= 2*ni;
			}
			q = p;
			while(--ni &gt;= 0){
				ci = BGSHORT(u);
				if(ci&lt;0 || ci&gt;=font-&gt;nfchar){
					dst-&gt;clipr = clipr;
					error(Eindex);
				}
				q = drawchar(dst, q, src, &amp;sp, font, ci, op);
				u += 2;
			}
			dst-&gt;clipr = clipr;
			p.y -= font-&gt;ascent;
			dstflush(dstid, dst, Rect(p.x, p.y, q.x, p.y+Dy(font-&gt;image-&gt;r)));
			continue;

		/* use public screen: 'S' id[4] chan[4] */
		case 'S':
			printmesg(fmt="Ll", a, 0);
			m = 1+4+4;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			if(dstid == 0)
				error(Ebadarg);
			dscrn = drawlookupdscreen(dstid);
			if(dscrn==0 || (dscrn-&gt;public==0 &amp;&amp; dscrn-&gt;owner!=client))
				error(Enodrawscreen);
			if(dscrn-&gt;screen-&gt;image-&gt;chan != BGLONG(a+5))
				error("inconsistent chan");
			if(drawinstallscreen(client, dscrn, 0, 0, 0, 0) == 0)
				error(Edrawmem);
			continue;

		/* top or bottom windows: 't' top[1] nw[2] n*id[4] */
		case 't':
			printmesg(fmt="bsL", a, 0);
			m = 1+1+2;
			if(n &lt; m)
				error(Eshortdraw);
			nw = BGSHORT(a+2);
			if(nw &lt; 0)
				error(Ebadarg);
			if(nw == 0)
				continue;
			m += nw*4;
			if(n &lt; m)
				error(Eshortdraw);
			lp = malloc(nw*sizeof(Memimage*));
			if(lp == 0)
				error(Enomem);
			if(waserror()){
				free(lp);
				nexterror();
			}
			for(j=0; j&lt;nw; j++)
				lp[j] = drawimage(client, a+1+1+2+j*4);
			if(lp[0]-&gt;layer == 0)
				error("images are not windows");
			for(j=1; j&lt;nw; j++)
				if(lp[j]-&gt;layer-&gt;screen != lp[0]-&gt;layer-&gt;screen)
					error("images not on same screen");
			if(a[1])
				memltofrontn(lp, nw);
			else
				memltorearn(lp, nw);
			if(lp[0]-&gt;layer-&gt;screen-&gt;image-&gt;data == screenimage-&gt;data)
				for(j=0; j&lt;nw; j++)
					addflush(lp[j]-&gt;layer-&gt;screenr);
			ll = drawlookup(client, BGLONG(a+1+1+2), 1);
			drawrefreshscreen(ll, client);
			poperror();
			free(lp);
			continue;

		/* visible: 'v' */
		case 'v':
			printmesg(fmt="", a, 0);
			m = 1;
			drawflush();
			continue;

		/* write: 'y' id[4] R[4*4] data[x*1] */
		/* write from compressed data: 'Y' id[4] R[4*4] data[x*1] */
		case 'y':
		case 'Y':
			printmesg(fmt="LR", a, 0);
		//	iprint("load %c\n", *a);
			m = 1+4+4*4;
			if(n &lt; m)
				error(Eshortdraw);
			dstid = BGLONG(a+1);
			dst = drawimage(client, a+1);
			drawrectangle(&amp;r, a+5);
			if(!rectinrect(r, dst-&gt;r))
				error(Ewriteoutside);
			y = memload(dst, r, a+m, n-m, *a=='Y');
			if(y &lt; 0)
				error("bad writeimage call");
			dstflush(dstid, dst, r);
			m += y;
			continue;
		}
	}
	poperror();
}

Dev drawdevtab = {
	'i',
	"draw",

	devreset,
	devinit,
	drawattach,
	drawwalk,
	drawstat,
	drawopen,
	devcreate,
	drawclose,
	drawread,
	devbread,
	drawwrite,
	devbwrite,
	devremove,
	devwstat,
};

/*
 * On 8 bit displays, load the default color map
 */
void
drawcmap(void)
{
	int r, g, b, cr, cg, cb, v;
	int num, den;
	int i, j;

	drawactive(1);	/* to restore map from backup */
	for(r=0,i=0; r!=4; r++)
	    for(v=0; v!=4; v++,i+=16){
		for(g=0,j=v-r; g!=4; g++)
		    for(b=0;b!=4;b++,j++){
			den = r;
			if(g &gt; den)
				den = g;
			if(b &gt; den)
				den = b;
			if(den == 0)	/* divide check -- pick grey shades */
				cr = cg = cb = v*17;
			else{
				num = 17*(4*den+v);
				cr = r*num/den;
				cg = g*num/den;
				cb = b*num/den;
			}
			setcolor(i+(j&amp;15),
				cr*0x01010101, cg*0x01010101, cb*0x01010101);
		    }
	}
}

void
drawblankscreen(int blank)
{
	int i, nc;
	ulong *p;

	if(blank == sdraw.blanked)
		return;
	if(!canqlock(&amp;sdraw))
		return;
	if(!initscreenimage()){
		qunlock(&amp;sdraw);
		return;
	}
	p = sdraw.savemap;
	nc = screenimage-&gt;depth &gt; 8 ? 256 : 1&lt;&lt;screenimage-&gt;depth;

	/*
	 * blankscreen uses the hardware to blank the screen
	 * when possible.  to help in cases when it is not possible,
	 * we set the color map to be all black.
	 */
	if(blank == 0){	/* turn screen on */
		for(i=0; i&lt;nc; i++, p+=3)
			setcolor(i, p[0], p[1], p[2]);
		blankscreen(0);
	}else{	/* turn screen off */
		blankscreen(1);
		for(i=0; i&lt;nc; i++, p+=3){
			getcolor(i, &amp;p[0], &amp;p[1], &amp;p[2]);
			setcolor(i, 0, 0, 0);
		}
	}
	sdraw.blanked = blank;
	qunlock(&amp;sdraw);
}

/*
 * record activity on screen, changing blanking as appropriate
 */
void
drawactive(int active)
{
	if(active){
		drawblankscreen(0);
		sdraw.blanktime = 0;
	}else
		sdraw.blanktime++;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

