<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/vnc/exportfs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/vnc/exportfs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;fcall.h&gt;
#include	"compat.h"
#include	"error.h"

typedef	struct Fid	Fid;
typedef	struct Export	Export;
typedef	struct Exq	Exq;
typedef	struct Exwork	Exwork;

enum
{
	Nfidhash	= 32,
	Maxfdata	= 8192,
	Maxrpc		= IOHDRSZ + Maxfdata,
};

struct Export
{
	Ref	r;
	Exq*	work;
	Lock	fidlock;
	Fid*	fid[Nfidhash];
	int	io;		/* fd to read/write */
	int	iounit;
	int	nroots;
	Chan	**roots;
};

struct Fid
{
	Fid*	next;
	Fid**	last;
	Chan*	chan;
	long	offset;
	int	fid;
	int	ref;		/* fcalls using the fid; locked by Export.Lock */
	int	attached;	/* fid attached or cloned but not clunked */
};

struct Exq
{
	Lock	lk;
	int	responding;	/* writing out reply message */
	int	noresponse;	/* don't respond to this one */
	Exq*	next;
	int	shut;		/* has been noted for shutdown */
	Export*	export;
	void*	slave;
	Fcall	rpc;
	uchar	buf[Maxrpc];
};

struct Exwork
{
	Lock	l;

	int	ref;

	int	nwaiters;	/* queue of slaves waiting for work */
	QLock	qwait;
	Rendez	rwait;

	Exq	*head;		/* work waiting for a slave */
	Exq	*tail;
};

Exwork exq;

static void	exshutdown(Export*);
static void	exflush(Export*, int, int);
static void	exslave(void*);
static void	exfree(Export*);
static void	exportproc(Export*);

static char*	Exattach(Export*, Fcall*, uchar*);
static char*	Exauth(Export*, Fcall*, uchar*);
static char*	Exclunk(Export*, Fcall*, uchar*);
static char*	Excreate(Export*, Fcall*, uchar*);
static char*	Exversion(Export*, Fcall*, uchar*);
static char*	Exopen(Export*, Fcall*, uchar*);
static char*	Exread(Export*, Fcall*, uchar*);
static char*	Exremove(Export*, Fcall*, uchar*);
static char*	Exsession(Export*, Fcall*, uchar*);
static char*	Exstat(Export*, Fcall*, uchar*);
static char*	Exwalk(Export*, Fcall*, uchar*);
static char*	Exwrite(Export*, Fcall*, uchar*);
static char*	Exwstat(Export*, Fcall*, uchar*);

static char	*(*fcalls[Tmax])(Export*, Fcall*, uchar*);

static char	Enofid[]   = "no such fid";
static char	Eseekdir[] = "can't seek on a directory";
static char	Ereaddir[] = "unaligned read of a directory";
static int	exdebug = 0;

int
sysexport(int fd, Chan **roots, int nroots)
{
	Export *fs;

	fs = smalloc(sizeof(Export));
	fs-&gt;r.ref = 1;
	fs-&gt;io = fd;
	fs-&gt;roots = roots;
	fs-&gt;nroots = nroots;

	exportproc(fs);

	return 0;
}

static void
exportinit(void)
{
	lock(&amp;exq.l);
	exq.ref++;
	if(fcalls[Tversion] != nil){
		unlock(&amp;exq.l);
		return;
	}

	fmtinstall('F', fcallfmt);
	fcalls[Tversion] = Exversion;
	fcalls[Tauth] = Exauth;
	fcalls[Tattach] = Exattach;
	fcalls[Twalk] = Exwalk;
	fcalls[Topen] = Exopen;
	fcalls[Tcreate] = Excreate;
	fcalls[Tread] = Exread;
	fcalls[Twrite] = Exwrite;
	fcalls[Tclunk] = Exclunk;
	fcalls[Tremove] = Exremove;
	fcalls[Tstat] = Exstat;
	fcalls[Twstat] = Exwstat;
	unlock(&amp;exq.l);
}

static void
exportproc(Export *fs)
{
	Exq *q;
	int n, ed;

	exportinit();
	ed = errdepth(-1);
	for(;;){
		errdepth(ed);
		q = smalloc(sizeof(Exq));

		n = read9pmsg(fs-&gt;io, q-&gt;buf, Maxrpc);
		if(n &lt;= 0 || convM2S(q-&gt;buf, n, &amp;q-&gt;rpc) != n)
			goto bad;

		if(exdebug)
			print("export %d &lt;- %F\n", getpid(), &amp;q-&gt;rpc);

		if(q-&gt;rpc.type == Tflush){
			exflush(fs, q-&gt;rpc.tag, q-&gt;rpc.oldtag);
			free(q);
			continue;
		}

		q-&gt;export = fs;
		incref(&amp;fs-&gt;r);

		lock(&amp;exq.l);
		if(exq.head == nil)
			exq.head = q;
		else
			exq.tail-&gt;next = q;
		q-&gt;next = nil;
		exq.tail = q;
		n = exq.nwaiters;
		if(n)
			exq.nwaiters = n - 1;
		unlock(&amp;exq.l);
		if(!n)
			kproc("exportfs", exslave, nil);
		rendwakeup(&amp;exq.rwait);
	}
bad:
	free(q);
	if(exdebug)
		fprint(2, "export proc shutting down: %r\n");
	exshutdown(fs);
	exfree(fs);
}

static void
exflush(Export *fs, int flushtag, int tag)
{
	Exq *q, **last;
	Fcall fc;
	uchar buf[Maxrpc];
	int n;

	/* hasn't been started? */
	lock(&amp;exq.l);
	last = &amp;exq.head;
	for(q = exq.head; q != nil; q = q-&gt;next){
		if(q-&gt;export == fs &amp;&amp; q-&gt;rpc.tag == tag){
			*last = q-&gt;next;
			unlock(&amp;exq.l);
			exfree(fs);
			free(q);
			goto Respond;
		}
		last = &amp;q-&gt;next;
	}
	unlock(&amp;exq.l);

	/* in progress? */
	lock(&amp;fs-&gt;r);
	for(q = fs-&gt;work; q != nil; q = q-&gt;next){
		if(q-&gt;rpc.tag == tag){
			lock(&amp;q-&gt;lk);
			q-&gt;noresponse = 1;
			if(!q-&gt;responding)
				rendintr(q-&gt;slave);
			unlock(&amp;q-&gt;lk);
			break;
		}
	}
	unlock(&amp;fs-&gt;r);

Respond:
	fc.type = Rflush;
	fc.tag = flushtag;

	n = convS2M(&amp;fc, buf, Maxrpc);
	if(n == 0)
		panic("convS2M error on write");
	if(write(fs-&gt;io, buf, n) != n)
		panic("mount write");
}

static void
exshutdown(Export *fs)
{
	Exq *q, **last;

	lock(&amp;exq.l);
	last = &amp;exq.head;
	for(q = exq.head; q != nil; q = *last){
		if(q-&gt;export == fs){
			*last = q-&gt;next;
			exfree(fs);
			free(q);
			continue;
		}
		last = &amp;q-&gt;next;
	}

	/*
	 * cleanly shut down the slaves if this is the last fs around
	 */
	exq.ref--;
	if(!exq.ref)
		rendwakeup(&amp;exq.rwait);
	unlock(&amp;exq.l);

	/*
	 * kick any sleepers
	 */
	lock(&amp;fs-&gt;r);
	for(q = fs-&gt;work; q != nil; q = q-&gt;next){
		lock(&amp;q-&gt;lk);
		q-&gt;noresponse = 1;
		if(!q-&gt;responding)
			rendintr(q-&gt;slave);
		unlock(&amp;q-&gt;lk);
	}
	unlock(&amp;fs-&gt;r);
}

static void
exfree(Export *fs)
{
	Fid *f, *n;
	int i;

	if(decref(&amp;fs-&gt;r) != 0)
		return;
	for(i = 0; i &lt; Nfidhash; i++){
		for(f = fs-&gt;fid[i]; f != nil; f = n){
			if(f-&gt;chan != nil)
				cclose(f-&gt;chan);
			n = f-&gt;next;
			free(f);
		}
	}
	free(fs);
}

static int
exwork(void *)
{
	int work;

	lock(&amp;exq.l);
	work = exq.head != nil || !exq.ref;
	unlock(&amp;exq.l);
	return work;
}

static void
exslave(void *)
{
	Export *fs;
	Exq *q, *t, **last;
	char *volatile err;
	int n, ed;

	while(waserror())
		fprint(2, "exslave %d errored out of loop -- heading back in!\n", getpid());
	ed = errdepth(-1);
	for(;;){
		errdepth(ed);
		qlock(&amp;exq.qwait);
		if(waserror()){
			qunlock(&amp;exq.qwait);
			nexterror();
		}
		rendsleep(&amp;exq.rwait, exwork, nil);

		lock(&amp;exq.l);
		if(!exq.ref){
			unlock(&amp;exq.l);
			poperror();
			qunlock(&amp;exq.qwait);
			break;
		}
		q = exq.head;
		if(q == nil){
			unlock(&amp;exq.l);
			poperror();
			qunlock(&amp;exq.qwait);
			continue;
		}
		exq.head = q-&gt;next;
		if(exq.head == nil)
			exq.tail = nil;
		poperror();
		qunlock(&amp;exq.qwait);

		/*
		 * put the job on the work queue before it's
		 * visible as off of the head queue, so it's always
		 * findable for flushes and shutdown
		 */
		q-&gt;slave = up;
		q-&gt;noresponse = 0;
		q-&gt;responding = 0;
		rendclearintr();
		fs = q-&gt;export;
		lock(&amp;fs-&gt;r);
		q-&gt;next = fs-&gt;work;
		fs-&gt;work = q;
		unlock(&amp;fs-&gt;r);

		unlock(&amp;exq.l);

		if(exdebug &gt; 1)
			print("exslave dispatch %d %F\n", getpid(), &amp;q-&gt;rpc);

		if(waserror()){
			print("exslave err %r\n");
			err = up-&gt;error;
		}else{
			if(q-&gt;rpc.type &gt;= Tmax || !fcalls[q-&gt;rpc.type])
				err = "bad fcall type";
			else
				err = (*fcalls[q-&gt;rpc.type])(fs, &amp;q-&gt;rpc, &amp;q-&gt;buf[IOHDRSZ]);
			poperror();
		}

		q-&gt;rpc.type++;
		if(err){
			q-&gt;rpc.type = Rerror;
			q-&gt;rpc.ename = err;
		}
		n = convS2M(&amp;q-&gt;rpc, q-&gt;buf, Maxrpc);

		if(exdebug)
			print("exslave %d -&gt; %F\n", getpid(), &amp;q-&gt;rpc);

		lock(&amp;q-&gt;lk);
		if(!q-&gt;noresponse){
			q-&gt;responding = 1;
			unlock(&amp;q-&gt;lk);
			write(fs-&gt;io, q-&gt;buf, n);
		}else
			unlock(&amp;q-&gt;lk);

		/*
		 * exflush might set noresponse at this point, but
		 * setting noresponse means don't send a response now;
		 * it's okay that we sent a response already.
		 */
		if(exdebug &gt; 1)
			print("exslave %d written %d\n", getpid(), q-&gt;rpc.tag);

		lock(&amp;fs-&gt;r);
		last = &amp;fs-&gt;work;
		for(t = fs-&gt;work; t != nil; t = t-&gt;next){
			if(t == q){
				*last = q-&gt;next;
				break;
			}
			last = &amp;t-&gt;next;
		}
		unlock(&amp;fs-&gt;r);

		exfree(q-&gt;export);
		free(q);

		rendclearintr();
		lock(&amp;exq.l);
		exq.nwaiters++;
		unlock(&amp;exq.l);
	}
	if(exdebug)
		fprint(2, "export slaveshutting down\n");
	kexit();
}

Fid*
Exmkfid(Export *fs, int fid)
{
	ulong h;
	Fid *f, *nf;

	nf = mallocz(sizeof(Fid), 1);
	if(nf == nil)
		return nil;
	lock(&amp;fs-&gt;fidlock);
	h = fid % Nfidhash;
	for(f = fs-&gt;fid[h]; f != nil; f = f-&gt;next){
		if(f-&gt;fid == fid){
			unlock(&amp;fs-&gt;fidlock);
			free(nf);
			return nil;
		}
	}

	nf-&gt;next = fs-&gt;fid[h];
	if(nf-&gt;next != nil)
		nf-&gt;next-&gt;last = &amp;nf-&gt;next;
	nf-&gt;last = &amp;fs-&gt;fid[h];
	fs-&gt;fid[h] = nf;

	nf-&gt;fid = fid;
	nf-&gt;ref = 1;
	nf-&gt;attached = 1;
	nf-&gt;offset = 0;
	nf-&gt;chan = nil;
	unlock(&amp;fs-&gt;fidlock);
	return nf;
}

Fid*
Exgetfid(Export *fs, int fid)
{
	Fid *f;
	ulong h;

	lock(&amp;fs-&gt;fidlock);
	h = fid % Nfidhash;
	for(f = fs-&gt;fid[h]; f; f = f-&gt;next){
		if(f-&gt;fid == fid){
			if(f-&gt;attached == 0)
				break;
			f-&gt;ref++;
			unlock(&amp;fs-&gt;fidlock);
			return f;
		}
	}
	unlock(&amp;fs-&gt;fidlock);
	return nil;
}

void
Exputfid(Export *fs, Fid *f)
{
	lock(&amp;fs-&gt;fidlock);
	f-&gt;ref--;
	if(f-&gt;ref == 0 &amp;&amp; f-&gt;attached == 0){
		if(f-&gt;chan != nil)
			cclose(f-&gt;chan);
		f-&gt;chan = nil;
		*f-&gt;last = f-&gt;next;
		if(f-&gt;next != nil)
			f-&gt;next-&gt;last = f-&gt;last;
		unlock(&amp;fs-&gt;fidlock);
		free(f);
		return;
	}
	unlock(&amp;fs-&gt;fidlock);
}

static char*
Exversion(Export *fs, Fcall *rpc, uchar *)
{
	if(rpc-&gt;msize &gt; Maxrpc)
		rpc-&gt;msize = Maxrpc;
	if(strncmp(rpc-&gt;version, "9P", 2) != 0){
		rpc-&gt;version = "unknown";
		return nil;
	}

	fs-&gt;iounit = rpc-&gt;msize - IOHDRSZ;
	rpc-&gt;version = "9P2000";
	return nil;
}

static char*
Exauth(Export *, Fcall *, uchar *)
{
	return "vnc: authentication not required";
}

static char*
Exattach(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;
	int w;

	w = 0;
	if(rpc-&gt;aname != nil)
		w = strtol(rpc-&gt;aname, nil, 10);
	if(w &lt; 0 || w &gt; fs-&gt;nroots)
		error(Ebadspec);
	f = Exmkfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Einuse;
	if(waserror()){
		f-&gt;attached = 0;
		Exputfid(fs, f);
		return up-&gt;error;
	}
	f-&gt;chan = cclone(fs-&gt;roots[w]);
	poperror();
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	Exputfid(fs, f);
	return nil;
}

static char*
Exclunk(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f != nil){
		f-&gt;attached = 0;
		Exputfid(fs, f);
	}
	return nil;
}

static char*
Exwalk(Export *fs, Fcall *rpc, uchar *)
{
	Fid *volatile f, *volatile nf;
	Walkqid *wq;
	Chan *c;
	int i, nwname;
	int volatile isnew;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	nf = nil;
	if(waserror()){
		Exputfid(fs, f);
		if(nf != nil)
			Exputfid(fs, nf);
		return up-&gt;error;
	}

	/*
	 * optional clone, but don't attach it until the walk succeeds.
	 */
	if(rpc-&gt;fid != rpc-&gt;newfid){
		nf = Exmkfid(fs, rpc-&gt;newfid);
		if(nf == nil)
			error(Einuse);
		nf-&gt;attached = 0;
		isnew = 1;
	}else{
		nf = Exgetfid(fs, rpc-&gt;fid);
		isnew = 0;
	}

	/*
	 * let the device do the work
	 */
	c = f-&gt;chan;
	nwname = rpc-&gt;nwname;
	wq = (*devtab[c-&gt;type]-&gt;walk)(c, nf-&gt;chan, rpc-&gt;wname, nwname);
	if(wq == nil)
		error(Enonexist);

	poperror();

	/*
	 * copy qid array
	 */
	for(i = 0; i &lt; wq-&gt;nqid; i++)
		rpc-&gt;wqid[i] = wq-&gt;qid[i];
	rpc-&gt;nwqid = wq-&gt;nqid;

	/*
	 * update the channel if everything walked correctly.
	 */
	if(isnew &amp;&amp; wq-&gt;nqid == nwname){
		nf-&gt;chan = wq-&gt;clone;
		nf-&gt;attached = 1;
	}

	free(wq);
	Exputfid(fs, f);
	Exputfid(fs, nf);
	return nil;
}

static char*
Exopen(Export *fs, Fcall *rpc, uchar *)
{
	Fid *volatile f;
	Chan *c;
	int iou;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	c = (*devtab[c-&gt;type]-&gt;open)(c, rpc-&gt;mode);
	poperror();

	f-&gt;chan = c;
	f-&gt;offset = 0;
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	iou = f-&gt;chan-&gt;iounit;
	if(iou &gt; fs-&gt;iounit)
		iou = fs-&gt;iounit;
	rpc-&gt;iounit = iou;
	Exputfid(fs, f);
	return nil;
}

static char*
Excreate(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;
	Chan *c;
	int iou;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type]-&gt;create)(c, rpc-&gt;name, rpc-&gt;mode, rpc-&gt;perm);
	poperror();

	f-&gt;chan = c;
	rpc-&gt;qid = f-&gt;chan-&gt;qid;
	iou = f-&gt;chan-&gt;iounit;
	if(iou &gt; fs-&gt;iounit)
		iou = fs-&gt;iounit;
	rpc-&gt;iounit = iou;
	Exputfid(fs, f);
	return nil;
}

static char*
Exread(Export *fs, Fcall *rpc, uchar *buf)
{
	Fid *f;
	Chan *c;
	long off;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;

	c = f-&gt;chan;

	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}

	rpc-&gt;data = (char*)buf;
	off = rpc-&gt;offset;
	c-&gt;offset = off;
	rpc-&gt;count = (*devtab[c-&gt;type]-&gt;read)(c, rpc-&gt;data, rpc-&gt;count, off);
	poperror();
	Exputfid(fs, f);
	return nil;
}

static char*
Exwrite(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	if(c-&gt;qid.type &amp; QTDIR)
		error(Eisdir);
	rpc-&gt;count = (*devtab[c-&gt;type]-&gt;write)(c, rpc-&gt;data, rpc-&gt;count, rpc-&gt;offset);
	poperror();
	Exputfid(fs, f);
	return nil;
}

static char*
Exstat(Export *fs, Fcall *rpc, uchar *buf)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	rpc-&gt;stat = buf;
	rpc-&gt;nstat = (*devtab[c-&gt;type]-&gt;stat)(c, rpc-&gt;stat, Maxrpc);
	poperror();
	Exputfid(fs, f);
	return nil;
}

static char*
Exwstat(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type]-&gt;wstat)(c, rpc-&gt;stat, rpc-&gt;nstat);
	poperror();
	Exputfid(fs, f);
	return nil;
}

static char*
Exremove(Export *fs, Fcall *rpc, uchar *)
{
	Fid *f;
	Chan *c;

	f = Exgetfid(fs, rpc-&gt;fid);
	if(f == nil)
		return Enofid;
	if(waserror()){
		Exputfid(fs, f);
		return up-&gt;error;
	}
	c = f-&gt;chan;
	(*devtab[c-&gt;type]-&gt;remove)(c);
	poperror();

	/*
	 * chan is already clunked by remove.
	 * however, we need to recover the chan,
	 * and follow sysremove's lead in making to point to root.
	 */
	c-&gt;type = 0;

	f-&gt;attached = 0;
	Exputfid(fs, f);
	return nil;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

