<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/wc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/wc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Count bytes within runes, if it fits in a uvlong, and other things.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

/* flags, per-file counts, and total counts */
static int pline, pword, prune, pbadr, pchar;
static uvlong nline, nword, nrune, nbadr, nchar;
static uvlong tnline, tnword, tnrune, tnbadr, tnchar;

enum{Space, Word};

static void
wc(Biobuf *bin)
{
	int where;
	long r;

	nline = 0;
	nword = 0;
	nrune = 0;
	nbadr = 0;
	where = Space;
	while ((long)(r = Bgetrune(bin)) &gt;= 0) {
		nrune++;
		if(r == Runeerror) {
			nbadr++;
			continue;
		}
		if(r == '\n')
			nline++;
		if(where == Word){
			if(isspacerune(r))
				where = Space;
		}else
			if(isspacerune(r) == 0){
				where = Word;
				nword++;
			}
	}
	nchar = Boffset(bin);
	tnline += nline;
	tnword += nword;
	tnrune += nrune;
	tnbadr += nbadr;
	tnchar += nchar;
}

static void
report(uvlong nline, uvlong nword, uvlong nrune, uvlong nbadr, uvlong nchar, char *fname)
{
	char line[1024], *s, *e;

	s = line;
	e = line + sizeof line;
	line[0] = 0;
	if(pline)
		s = seprint(s, e, " %7llud", nline);
	if(pword)
		s = seprint(s, e, " %7llud", nword);
	if(prune)
		s = seprint(s, e, " %7llud", nrune);
	if(pbadr)
		s = seprint(s, e, " %7llud", nbadr);
	if(pchar)
		s = seprint(s, e, " %7llud", nchar);
	if(fname != nil)
		seprint(s, e, " %s",   fname);
	print("%s\n", line+1);
}

void
main(int argc, char *argv[])
{
	char *sts;
	Biobuf sin, *bin;
	int i;

	sts = nil;
	ARGBEGIN {
	case 'l': pline++; break;
	case 'w': pword++; break;
	case 'r': prune++; break;
	case 'b': pbadr++; break;
	case 'c': pchar++; break;
	default:
		fprint(2, "Usage: %s [-lwrbc] [file ...]\n", argv0);
		exits("usage");
	} ARGEND
	if(pline+pword+prune+pbadr+pchar == 0){
		pline = 1;
		pword = 1;
		pchar = 1;
	}
	if(argc == 0){
		Binit(&amp;sin, 0, OREAD);
		wc(&amp;sin);
		report(nline, nword, nrune, nbadr, nchar, nil);
		Bterm(&amp;sin);
	}else{
		for(i = 0; i &lt; argc; i++){
			bin = Bopen(argv[i], OREAD);
			if(bin == nil){
				perror(argv[i]);
				sts = "can't open";
				continue;
			}
			wc(bin);
			report(nline, nword, nrune, nbadr, nchar, argv[i]);
			Bterm(bin);
		}
		if(argc&gt;1)
			report(tnline, tnword, tnrune, tnbadr, tnchar, "total");
	}
	exits(sts);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

