<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/webfs/cookies.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/webfs/cookies.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ndb.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;
#include &lt;ctype.h&gt;
#include "dat.h"
#include "fns.h"

int cookiedebug;

typedef struct Cookie Cookie;
typedef struct Jar Jar;

struct Cookie
{
	/* external info */
	char*	name;
	char*	value;
	char*	dom;		/* starts with . */
	char*	path;
	char*	version;
	char*	comment;		/* optional, may be nil */

	uint		expire;		/* time of expiration: ~0 means when webcookies dies */
	int		secure;
	int		explicitdom;	/* dom was explicitly set */
	int		explicitpath;	/* path was explicitly set */
	int		netscapestyle;

	/* internal info */
	int		deleted;
	int		mark;
	int		ondisk;
};

struct Jar
{
	Cookie	*c;
	int		nc;
	int		mc;

	Qid		qid;
	int		dirty;
	char		*file;
	char		*lockfile;
};

struct {
	char *s;
	int	offset;
	int	ishttp;
} stab[] = {
	"domain",		offsetof(Cookie, dom),		1,
	"path",		offsetof(Cookie, path),		1,
	"name",		offsetof(Cookie, name),		0,
	"value",		offsetof(Cookie, value),		0,
	"comment",	offsetof(Cookie, comment),	1,
	"version",		offsetof(Cookie, version),		1,
};

struct {
	char *s;
	int	offset;
} itab[] = {
	"expire",			offsetof(Cookie, expire),
	"secure",			offsetof(Cookie, secure),
	"explicitdomain",	offsetof(Cookie, explicitdom),
	"explicitpath",		offsetof(Cookie, explicitpath),
	"netscapestyle",	offsetof(Cookie, netscapestyle),
};

#pragma varargck type "J"	Jar*
#pragma varargck type "K"	Cookie*

/* HTTP format */
static int
jarfmt(Fmt *fp)
{
	int i;
	Jar *jar;

	jar = va_arg(fp-&gt;args, Jar*);

	if(jar == nil || jar-&gt;nc == 0)
		return 0;

	fmtstrcpy(fp, "Cookie: ");
	if(jar-&gt;c[0].version)
		fmtprint(fp, "$Version=%s; ", jar-&gt;c[0].version);
	for(i=0; i&lt;jar-&gt;nc; i++)
		fmtprint(fp, "%s%s=%s", i ? "; ": "", jar-&gt;c[i].name, jar-&gt;c[i].value);
	fmtstrcpy(fp, "\r\n");
	return 0;
}

/* individual cookie */
static int
cookiefmt(Fmt *fp)
{
	int j, k, first;
	char *t;
	Cookie *c;

	c = va_arg(fp-&gt;args, Cookie*);

	first = 1;
	for(j=0; j&lt;nelem(stab); j++){
		t = *(char**)((uintptr)c+stab[j].offset);
		if(t == nil)
			continue;
		if(first)
			first = 0;
		else
			fmtstrcpy(fp, " ");
		fmtprint(fp, "%s=%q", stab[j].s, t);
	}
	for(j=0; j&lt;nelem(itab); j++){
		k = *(int*)((uintptr)c+itab[j].offset);
		if(k == 0)
			continue;
		if(first)
			first = 0;
		else
			fmtstrcpy(fp, " ");
		fmtprint(fp, "%s=%ud", itab[j].s, k);
	}
	return 0;
}

/*
 * sort cookies:
 *	- alpha by name
 *	- alpha by domain
 *	- longer paths first, then alpha by path (RFC2109 4.3.4)
 */
static int
cookiecmp(Cookie *a, Cookie *b)
{
	int i;

	if((i = strcmp(a-&gt;name, b-&gt;name)) != 0)
		return i;
	if((i = cistrcmp(a-&gt;dom, b-&gt;dom)) != 0)
		return i;
	if((i = strlen(b-&gt;path) - strlen(a-&gt;path)) != 0)
		return i;
	if((i = strcmp(a-&gt;path, b-&gt;path)) != 0)
		return i;
	return 0;
}

static int
exactcookiecmp(Cookie *a, Cookie *b)
{
	int i;

	if((i = cookiecmp(a, b)) != 0)
		return i;
	if((i = strcmp(a-&gt;value, b-&gt;value)) != 0)
		return i;
	if(a-&gt;version || b-&gt;version){
		if(!a-&gt;version)
			return -1;
		if(!b-&gt;version)
			return 1;
		if((i = strcmp(a-&gt;version, b-&gt;version)) != 0)
			return i;
	}
	if(a-&gt;comment || b-&gt;comment){
		if(!a-&gt;comment)
			return -1;
		if(!b-&gt;comment)
			return 1;
		if((i = strcmp(a-&gt;comment, b-&gt;comment)) != 0)
			return i;
	}
	if((i = b-&gt;expire - a-&gt;expire) != 0)
		return i;
	if((i = b-&gt;secure - a-&gt;secure) != 0)
		return i;
	if((i = b-&gt;explicitdom - a-&gt;explicitdom) != 0)
		return i;
	if((i = b-&gt;explicitpath - a-&gt;explicitpath) != 0)
		return i;
	if((i = b-&gt;netscapestyle - a-&gt;netscapestyle) != 0)
		return i;

	return 0;
}

static void
freecookie(Cookie *c)
{
	int i;

	for(i=0; i&lt;nelem(stab); i++)
		free(*(char**)((uintptr)c+stab[i].offset));
}

static void
copycookie(Cookie *c)
{
	int i;
	char **ps;

	for(i=0; i&lt;nelem(stab); i++){
		ps = (char**)((uintptr)c+stab[i].offset);
		if(*ps)
			*ps = estrdup9p(*ps);
	}
}

static void
delcookie(Jar *j, Cookie *c)
{
	int i;

	j-&gt;dirty = 1;
	i = c - j-&gt;c;
	if(i &lt; 0 || i &gt;= j-&gt;nc)
		abort();
	c-&gt;deleted = 1;
}

static void
addcookie(Jar *j, Cookie *c)
{
	int i;

	if(!c-&gt;name || !c-&gt;value || !c-&gt;path || !c-&gt;dom){
		fprint(2, "not adding incomplete cookie\n");
		return;
	}

	if(cookiedebug)
		fprint(2, "add %K\n", c);

	for(i=0; i&lt;j-&gt;nc; i++)
		if(cookiecmp(&amp;j-&gt;c[i], c) == 0){
			if(cookiedebug)
				fprint(2, "cookie %K matches %K\n", &amp;j-&gt;c[i], c);
			if(exactcookiecmp(&amp;j-&gt;c[i], c) == 0){
				if(cookiedebug)
					fprint(2, "\texactly\n");
				j-&gt;c[i].mark = 0;
				return;
			}
			delcookie(j, &amp;j-&gt;c[i]);
		}

	j-&gt;dirty = 1;
	if(j-&gt;nc == j-&gt;mc){
		j-&gt;mc += 16;
		j-&gt;c = erealloc9p(j-&gt;c, j-&gt;mc*sizeof(Cookie));
	}
	j-&gt;c[j-&gt;nc] = *c;
	copycookie(&amp;j-&gt;c[j-&gt;nc]);
	j-&gt;nc++;
}

static void
purgejar(Jar *j)
{
	int i;

	for(i=j-&gt;nc-1; i&gt;=0; i--){
		if(!j-&gt;c[i].deleted)
			continue;
		freecookie(&amp;j-&gt;c[i]);
		--j-&gt;nc;
		j-&gt;c[i] = j-&gt;c[j-&gt;nc];
	}
}

static void
addtojar(Jar *jar, char *line, int ondisk)
{
	Cookie c;
	int i, j, nf, *pint;
	char *f[20], *attr, *val, **pstr;
	
	memset(&amp;c, 0, sizeof c);
	c.expire = ~0;
	c.ondisk = ondisk;
	nf = tokenize(line, f, nelem(f));
	for(i=0; i&lt;nf; i++){
		attr = f[i];
		if((val = strchr(attr, '=')) != nil)
			*val++ = '\0';
		else
			val = "";
		/* string attributes */
		for(j=0; j&lt;nelem(stab); j++){
			if(strcmp(stab[j].s, attr) == 0){
				pstr = (char**)((uintptr)&amp;c+stab[j].offset);
				*pstr = val;
			}
		}
		/* integer attributes */
		for(j=0; j&lt;nelem(itab); j++){
			if(strcmp(itab[j].s, attr) == 0){
				pint = (int*)((uintptr)&amp;c+itab[j].offset);
				if(val[0]=='\0')
					*pint = 1;
				else
					*pint = strtoul(val, 0, 0);
			}
		}
	}
	if(c.name==nil || c.value==nil || c.dom==nil || c.path==nil){
		if(cookiedebug)
			fprint(2, "ignoring fractional cookie %K\n", &amp;c);
		return;
	}
	addcookie(jar, &amp;c);
}

static Jar*
newjar(void)
{
	Jar *jar;

	jar = emalloc9p(sizeof(Jar));
	return jar;
}

static int
expirejar(Jar *jar, int exiting)
{
	int i, n;
	uint now;

	now = time(0);
	n = 0;
	for(i=0; i&lt;jar-&gt;nc; i++){
		if(jar-&gt;c[i].expire &lt; now || (exiting &amp;&amp; jar-&gt;c[i].expire==~0)){
			delcookie(jar, &amp;jar-&gt;c[i]);
			n++;
		}
	}
	return n;
}

static void
dumpjar(Jar *jar, char *desc)
{
	int i;
	Biobuf *b;
	char *s;

	print("%s\n", desc);
	print("\tin memory:\n");
	
	for(i=0; i&lt;jar-&gt;nc; i++)
		print("\t%K%s%s%s\n", &amp;jar-&gt;c[i],
			jar-&gt;c[i].ondisk ? " ondisk" : "",
			jar-&gt;c[i].deleted ? " deleted" : "",
			jar-&gt;c[i].mark ? " mark" : "");
	print("\n\ton disk:\n");
	if((b = Bopen(jar-&gt;file, OREAD)) == nil){
		print("\tno file\n");
	}else{
		while((s = Brdstr(b, '\n', 1)) != nil){
			print("\t%s\n", s);
			free(s);
		}
		Bterm(b);
	}
	print("\n");
}

static int
syncjar(Jar *jar)
{
	int i, fd;
	char *line;
	Dir *d;
	Biobuf *b;
	Qid q;

	if(jar-&gt;file==nil)
		return 0;

	memset(&amp;q, 0, sizeof q);
	if((d = dirstat(jar-&gt;file)) != nil){
		q = d-&gt;qid;
		if(d-&gt;qid.path != jar-&gt;qid.path || d-&gt;qid.vers != jar-&gt;qid.vers)
			jar-&gt;dirty = 1;
		free(d);
	}

	if(jar-&gt;dirty == 0)
		return 0;

	fd = -1;
	for(i=0; i&lt;50; i++){
		if((fd = create(jar-&gt;lockfile, OWRITE, DMEXCL|0666)) &lt; 0){
			sleep(100);
			continue;
		}
		break;
	}
	if(fd &lt; 0){
		if(cookiedebug)
			fprint(2, "open %s: %r", jar-&gt;lockfile);
		werrstr("cannot acquire jar lock: %r");
		return -1;
	}

	for(i=0; i&lt;jar-&gt;nc; i++)	/* mark is cleared by addcookie */
		jar-&gt;c[i].mark = jar-&gt;c[i].ondisk;

	if((b = Bopen(jar-&gt;file, OREAD)) == nil){
		if(cookiedebug)
			fprint(2, "Bopen %s: %r", jar-&gt;file);
		werrstr("cannot read cookie file %s: %r", jar-&gt;file);
		close(fd);
		return -1;
	}
	for(; (line = Brdstr(b, '\n', 1)) != nil; free(line)){
		if(*line == '#')
			continue;
		addtojar(jar, line, 1);
	}
	Bterm(b);

	for(i=0; i&lt;jar-&gt;nc; i++)
		if(jar-&gt;c[i].mark &amp;&amp; jar-&gt;c[i].expire != ~0)
			delcookie(jar, &amp;jar-&gt;c[i]);

	purgejar(jar);

	b = Bopen(jar-&gt;file, OWRITE);
	if(b == nil){
		if(cookiedebug)
			fprint(2, "Bopen write %s: %r", jar-&gt;file);
		close(fd);
		return -1;
	}
	Bprint(b, "# webcookies cookie jar\n");
	Bprint(b, "# comments and non-standard fields will be lost\n");
	for(i=0; i&lt;jar-&gt;nc; i++){
		if(jar-&gt;c[i].expire == ~0)
			continue;
		Bprint(b, "%K\n", &amp;jar-&gt;c[i]);
		jar-&gt;c[i].ondisk = 1;
	}
	Bterm(b);

	jar-&gt;dirty = 0;
	close(fd);
	if((d = dirstat(jar-&gt;file)) != nil){
		jar-&gt;qid = d-&gt;qid;
		free(d);
	}
	return 0;
}

static Jar*
readjar(char *file)
{
	char *lock, *p;
	Jar *jar;

	jar = newjar();
	lock = emalloc9p(strlen(file)+10);
	strcpy(lock, file);
	if((p = strrchr(lock, '/')) != nil)
		p++;
	else
		p = lock;
	memmove(p+2, p, strlen(p)+1);
	p[0] = 'L';
	p[1] = '.';
	jar-&gt;lockfile = lock;
	jar-&gt;file = file;
	jar-&gt;dirty = 1;

	if(syncjar(jar) &lt; 0){
		free(jar-&gt;file);
		free(jar-&gt;lockfile);
		free(jar);
		return nil;
	}
	return jar;
}

static void
closejar(Jar *jar)
{
	int i;

	if(jar == nil)
		return;
	expirejar(jar, 0);
	if(syncjar(jar) &lt; 0)
		fprint(2, "warning: cannot rewrite cookie jar: %r\n");

	for(i=0; i&lt;jar-&gt;nc; i++)
		freecookie(&amp;jar-&gt;c[i]);

	free(jar-&gt;file);
	free(jar);	
}

/*
 * Domain name matching is per RFC2109, section 2:
 *
 * Hosts names can be specified either as an IP address or a FQHN
 * string.  Sometimes we compare one host name with another.  Host A's
 * name domain-matches host B's if
 *
 * * both host names are IP addresses and their host name strings match
 *   exactly; or
 *
 * * both host names are FQDN strings and their host name strings match
 *   exactly; or
 *
 * * A is a FQDN string and has the form NB, where N is a non-empty name
 *   string, B has the form .B', and B' is a FQDN string.  (So, x.y.com
 *   domain-matches .y.com but not y.com.)
 *
 * Note that domain-match is not a commutative operation: a.b.c.com
 * domain-matches .c.com, but not the reverse.
 *
 * (This does not verify that IP addresses and FQDN's are well-formed.)
 */
static int
isdomainmatch(char *name, char *pattern)
{
	int lname, lpattern;

	if(cistrcmp(name, pattern)==0)
		return 1;

	if(strcmp(ipattr(name), "dom")==0 &amp;&amp; pattern[0]=='.'){
		lname = strlen(name);
		lpattern = strlen(pattern);
		/* e.g., name: www.google.com &amp;&amp; pattern: .google.com */
		if(lname &gt;= lpattern &amp;&amp; cistrcmp(name+lname-lpattern, pattern)==0)
			return 1;
		/* e.g., name: google.com &amp;&amp; pattern: .google.com */
		if(lpattern &gt; lname &amp;&amp;
		    cistrcmp(pattern+lpattern-lname, name) == 0)
			return 1;
	}
	return 0;
}

/*
 * RFC2109 4.3.4:
 *	- domain must match
 *	- path in cookie must be a prefix of request path
 *	- cookie must not have expired
 */
static int
iscookiematch(Cookie *c, char *dom, char *path, uint now)
{
	return isdomainmatch(dom, c-&gt;dom)
		&amp;&amp; strncmp(c-&gt;path, path, strlen(c-&gt;path))==0
		&amp;&amp; (c-&gt;expire == 0 || c-&gt;expire &gt;= now);
}

/* 
 * Produce a subjar of matching cookies.
 * Secure cookies are only included if secure is set.
 */
static Jar*
cookiesearch(Jar *jar, char *dom, char *path, int issecure)
{
	int i;
	Jar *j;
	uint now;

	if(cookiedebug)
		fprint(2, "cookiesearch %s %s %d\n", dom, path, issecure);
	now = time(0);
	j = newjar();
	for(i=0; i&lt;jar-&gt;nc; i++){
		if(cookiedebug)
			fprint(2, "\ttry %s %s %d %s\n", jar-&gt;c[i].dom,
				jar-&gt;c[i].path, jar-&gt;c[i].secure,
				jar-&gt;c[i].name);
		if((issecure || !jar-&gt;c[i].secure) &amp;&amp;
		    iscookiematch(&amp;jar-&gt;c[i], dom, path, now)){
			if(cookiedebug)
				fprint(2, "\tmatched\n");
			addcookie(j, &amp;jar-&gt;c[i]);
		}
	}
	if(j-&gt;nc == 0){
		closejar(j);
		werrstr("no cookies found");
		return nil;
	}
	qsort(j-&gt;c, j-&gt;nc, sizeof(j-&gt;c[0]), (int(*)(void*, void*))cookiecmp);
	return j;
}

/*
 * RFC2109 4.3.2 security checks
 */
static char*
isbadcookie(Cookie *c, char *dom, char *path)
{
	int lcdom, ldom;

	if(strncmp(c-&gt;path, path, strlen(c-&gt;path)) != 0)
		return "cookie path is not a prefix of the request path";

	/*
	 * fgb says omitting this test is necessary to get some sites to work,
	 * but it seems dubious.
	 */
	if(c-&gt;explicitdom &amp;&amp; c-&gt;dom[0] != '.')
		return "cookie domain doesn't start with dot";

	lcdom = strlen(c-&gt;dom);
	if(memchr(c-&gt;dom+1, '.', lcdom-1-1) == nil)
		return "cookie domain doesn't have embedded dots";

	if(!isdomainmatch(dom, c-&gt;dom))
		return "request host does not match cookie domain";

	ldom = strlen(dom);
	if(strcmp(ipattr(dom), "dom")==0 &amp;&amp; lcdom &gt; ldom &amp;&amp;
	    memchr(dom, '.', lcdom - ldom) != nil)
		return "request host contains dots before cookie domain";

	return 0;
}

/*
 * Sunday, 25-Jan-2002 12:24:36 GMT
 * Sunday, 25 Jan 2002 12:24:36 GMT
 * Sun, 25 Jan 02 12:24:36 GMT
 */
static int
isleap(int year)
{
	return year%4==0 &amp;&amp; (year%100!=0 || year%400==0);
}

static uint
strtotime(char *s)
{
	char *os;
	int i;
	Tm tm;

	static int mday[2][12] = {
		31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,
		31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31,
	};
	static char *wday[] = {
		"Sunday", "Monday", "Tuesday", "Wednesday",
		"Thursday", "Friday", "Saturday",
	};
	static char *mon[] = {
		"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
	};

	os = s;
	/* Sunday, */
	for(i=0; i&lt;nelem(wday); i++){
		if(cistrncmp(s, wday[i], strlen(wday[i])) == 0){
			s += strlen(wday[i]);
			break;
		}
		if(cistrncmp(s, wday[i], 3) == 0){
			s += 3;
			break;
		}
	}
	if(i==nelem(wday)){
		if(cookiedebug)
			fprint(2, "bad wday (%s)\n", os);
		return -1;
	}
	if(*s++ != ',' || *s++ != ' '){
		if(cookiedebug)
			fprint(2, "bad wday separator (%s)\n", os);
		return -1;
	}

	/* 25- */
	if(!isdigit(s[0]) || !isdigit(s[1]) || (s[2]!='-' &amp;&amp; s[2]!=' ')){
		if(cookiedebug)
			fprint(2, "bad day of month (%s)\n", os);
		return -1;
	}
	tm.mday = strtol(s, 0, 10);
	s += 3;

	/* Jan- */
	for(i=0; i&lt;nelem(mon); i++)
		if(cistrncmp(s, mon[i], 3) == 0){
			tm.mon = i;
			s += 3;
			break;
		}
	if(i==nelem(mon)){
		if(cookiedebug)
			fprint(2, "bad month (%s)\n", os);
		return -1;
	}
	if(s[0] != '-' &amp;&amp; s[0] != ' '){
		if(cookiedebug)
			fprint(2, "bad month separator (%s)\n", os);
		return -1;
	}
	s++;

	/* 2002 */
	if(!isdigit(s[0]) || !isdigit(s[1])){
		if(cookiedebug)
			fprint(2, "bad year (%s)\n", os);
		return -1;
	}
	tm.year = strtol(s, 0, 10);
	s += 2;
	if(isdigit(s[0]) &amp;&amp; isdigit(s[1]))
		s += 2;
	else{
		if(tm.year &lt;= 68)
			tm.year += 2000;
		else
			tm.year += 1900;
	}
	if(tm.mday==0 || tm.mday &gt; mday[isleap(tm.year)][tm.mon]){
		if(cookiedebug)
			fprint(2, "invalid day of month (%s)\n", os);
		return -1;
	}
	tm.year -= 1900;
	if(*s++ != ' '){
		if(cookiedebug)
			fprint(2, "bad year separator (%s)\n", os);
		return -1;
	}

	if(!isdigit(s[0]) || !isdigit(s[1]) || s[2]!=':'
	|| !isdigit(s[3]) || !isdigit(s[4]) || s[5]!=':'
	|| !isdigit(s[6]) || !isdigit(s[7]) || s[8]!=' '){
		if(cookiedebug)
			fprint(2, "bad time (%s)\n", os);
		return -1;
	}

	tm.hour = atoi(s);
	tm.min = atoi(s+3);
	tm.sec = atoi(s+6);
	if(tm.hour &gt;= 24 || tm.min &gt;= 60 || tm.sec &gt;= 60){
		if(cookiedebug)
			fprint(2, "invalid time (%s)\n", os);
		return -1;
	}
	s += 9;

	if(cistrcmp(s, "GMT") != 0){
		if(cookiedebug)
			fprint(2, "time zone not GMT (%s)\n", os);
		return -1;
	}
	strcpy(tm.zone, "GMT");
	tm.yday = 0;
	return tm2sec(&amp;tm);
}

/*
 * skip linear whitespace.  we're a bit more lenient than RFC2616 2.2.
 */
static char*
skipspace(char *s)
{
	while(*s=='\r' || *s=='\n' || *s==' ' || *s=='\t')
		s++;
	return s;
}

/*
 * Try to identify old netscape headers.
 * The old headers:
 *	- didn't allow spaces around the '='
 *	- used an 'Expires' attribute
 *	- had no 'Version' attribute
 *	- had no quotes
 *	- allowed whitespace in values
 *	- apparently separated attr/value pairs with ';' exclusively
 */
static int
isnetscape(char *hdr)
{
	char *s;

	for(s=hdr; (s=strchr(s, '=')) != nil; s++){
		if(isspace(s[1]) || (s &gt; hdr &amp;&amp; isspace(s[-1])))
			return 0;
		if(s[1]=='"')
			return 0;
	}
	if(cistrstr(hdr, "version="))
		return 0;
	return 1;
}

/*
 * Parse HTTP response headers, adding cookies to jar.
 * Overwrites the headers.  May overwrite path.
 */
static char* parsecookie(Cookie*, char*, char**, int, char*, char*);
static int
parsehttp(Jar *jar, char *hdr, char *dom, char *path)
{
	static char setcookie[] = "Set-Cookie:";
	char *e, *p, *nextp;
	Cookie c;
	int isns, n;

	isns = isnetscape(hdr);
	n = 0;
	for(p=hdr; p; p=nextp){
		p = skipspace(p);
		if(*p == '\0')
			break;
		nextp = strchr(p, '\n');
		if(nextp != nil)
			*nextp++ = '\0';
		if(cistrncmp(p, setcookie, strlen(setcookie)) != 0)
			continue;
		if(cookiedebug)
			fprint(2, "%s\n", p);
		p = skipspace(p+strlen(setcookie));
		for(; *p; p=skipspace(p)){
			if((e = parsecookie(&amp;c, p, &amp;p, isns, dom, path)) != nil){
				if(cookiedebug)
					fprint(2, "parse cookie: %s\n", e);
				break;
			}
			if((e = isbadcookie(&amp;c, dom, path)) != nil){
				if(cookiedebug)
					fprint(2, "reject cookie; %s\n", e);
				continue;
			}
			addcookie(jar, &amp;c);
			n++;
		}
	}
	return n;
}

static char*
skipquoted(char *s)
{
	/*
	 * Sec 2.2 of RFC2616 defines a "quoted-string" as:
	 *
	 *  quoted-string  = ( &lt;"&gt; *(qdtext | quoted-pair ) &lt;"&gt; )
	 *  qdtext         = &lt;any TEXT except &lt;"&gt;&gt;
	 *  quoted-pair    = "\" CHAR
	 *
	 * TEXT is any octet except CTLs, but including LWS;
	 * LWS is [CR LF] 1*(SP | HT);
	 * CHARs are ASCII octets 0-127;  (NOTE: we reject 0's)
	 * CTLs are octets 0-31 and 127;
	 */
	if(*s != '"')
		return s;

	for(s++; 32 &lt;= *s &amp;&amp; *s &lt; 127 &amp;&amp; *s != '"'; s++)
		if(*s == '\\' &amp;&amp; *(s+1) != '\0')
			s++;
	return s;
}

static char*
skiptoken(char *s)
{
	/*
	 * Sec 2.2 of RFC2616 defines a "token" as
 	 *  1*&lt;any CHAR except CTLs or separators&gt;;
	 * CHARs are ASCII octets 0-127;
	 * CTLs are octets 0-31 and 127;
	 * separators are "()&lt;&gt;@,;:\/[]?={}", double-quote, SP (32), and HT (9)
	 */
	while(32 &lt;= *s &amp;&amp; *s &lt; 127 &amp;&amp; strchr("()&lt;&gt;@,;:[]?={}\" \t\\", *s)==nil)
		s++;

	return s;
}

static char*
skipvalue(char *s, int isns)
{
	char *t;

	/*
	 * An RFC2109 value is an HTTP token or an HTTP quoted string.
	 * Netscape servers ignore the spec and rely on semicolons, apparently.
	 */
	if(isns){
		if((t = strchr(s, ';')) == nil)
			t = s+strlen(s);
		return t;
	}
	if(*s == '"')
		return skipquoted(s);
	return skiptoken(s);
}

/*
 * RMID=80b186bb64c03c65fab767f8; expires=Monday, 10-Feb-2003 04:44:39 GMT; 
 *	path=/; domain=.nytimes.com
 */
static char*
parsecookie(Cookie *c, char *p, char **e, int isns, char *dom, char *path)
{
	int i, done;
	char *t, *u, *attr, *val;

	c-&gt;expire = ~0;
	memset(c, 0, sizeof *c);

	/* NAME=VALUE */
	t = skiptoken(p);
	c-&gt;name = p;
	p = skipspace(t);
	if(*p != '='){
	Badname:
		return "malformed cookie: no NAME=VALUE";
	}
	*t = '\0';
	p = skipspace(p+1);
	t = skipvalue(p, isns);
	if(*t)
		*t++ = '\0';
	c-&gt;value = p;
	p = skipspace(t);
	if(c-&gt;name[0]=='\0' || c-&gt;value[0]=='\0')
		goto Badname;

	done = 0;
	for(; *p &amp;&amp; !done; p=skipspace(p)){
		attr = p;
		t = skiptoken(p);
		u = skipspace(t);
		switch(*u){
		case '\0':
			*t = '\0';
			val = p = u;
			break;
		case ';':
			*t = '\0';
			val = "";
			p = u+1;
			break;
		case '=':
			*t = '\0';
			val = skipspace(u+1);
			p = skipvalue(val, isns);
			if(*p==',')
				done = 1;
			if(*p)
				*p++ = '\0';
			break;
		case ',':
			if(!isns){
				val = "";
				p = u;
				*p++ = '\0';
				done = 1;
				break;
			}
		default:
			if(cookiedebug)
				fprint(2, "syntax: %s\n", p);
			return "syntax error";
		}
		for(i=0; i&lt;nelem(stab); i++)
			if(stab[i].ishttp &amp;&amp; cistrcmp(stab[i].s, attr)==0)
				*(char**)((uintptr)c+stab[i].offset) = val;
		if(cistrcmp(attr, "expires") == 0){
			if(!isns)
				return "non-netscape cookie has Expires tag";
			if(!val[0])
				return "bad expires tag";
			c-&gt;expire = strtotime(val);
			if(c-&gt;expire == ~0)
				return "cannot parse netscape expires tag";
		}
		if(cistrcmp(attr, "max-age") == 0)
			c-&gt;expire = time(0)+atoi(val);
		if(cistrcmp(attr, "secure") == 0)
			c-&gt;secure = 1;
	}

	if(c-&gt;dom)
		c-&gt;explicitdom = 1;
	else
		c-&gt;dom = dom;
	if(c-&gt;path)
		c-&gt;explicitpath = 1;
	else{
		c-&gt;path = path;
		if((t = strchr(c-&gt;path, '?')) != 0)
			*t = '\0';
		if((t = strrchr(c-&gt;path, '/')) != 0)
			*t = '\0';
	}	
	c-&gt;netscapestyle = isns;
	*e = p;

	return nil;
}

Jar *jar;

typedef struct Aux Aux;
struct Aux
{
	char *dom;
	char *path;
	char *inhttp;
	char *outhttp;
	char *ctext;
	int rdoff;
};
enum
{
	AuxBuf = 4096,
	MaxCtext = 16*1024*1024,
};

void
cookieopen(Req *r)
{
	char *s, *es;
	int i, sz;
	Aux *a;

	syncjar(jar);
	a = emalloc9p(sizeof(Aux));
	r-&gt;fid-&gt;aux = a;
	if(r-&gt;ifcall.mode&amp;OTRUNC){
		a-&gt;ctext = emalloc9p(1);
		a-&gt;ctext[0] = '\0';
	}else{
		sz = 256*jar-&gt;nc+1024;	/* BUG should do better */
		a-&gt;ctext = emalloc9p(sz);
		a-&gt;ctext[0] = '\0';
		s = a-&gt;ctext;
		es = s+sz;
		for(i=0; i&lt;jar-&gt;nc; i++)
			s = seprint(s, es, "%K\n", &amp;jar-&gt;c[i]);
	}
	respond(r, nil);
}

void
cookieread(Req *r)
{
	Aux *a;

	a = r-&gt;fid-&gt;aux;
	readstr(r, a-&gt;ctext);
	respond(r, nil);
}

void
cookiewrite(Req *r)
{
	Aux *a;
	int sz;

	a = r-&gt;fid-&gt;aux;
	sz = r-&gt;ifcall.count+r-&gt;ifcall.offset;
	if(sz &gt; strlen(a-&gt;ctext)){
		if(sz &gt;= MaxCtext){
			respond(r, "cookie file too large");
			return;
		}
		a-&gt;ctext = erealloc9p(a-&gt;ctext, sz+1);
		a-&gt;ctext[sz] = '\0';
	}
	memmove(a-&gt;ctext+r-&gt;ifcall.offset, r-&gt;ifcall.data, r-&gt;ifcall.count);
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	respond(r, nil);
}

void
cookieclunk(Fid *fid)
{
	char *p, *nextp;
	Aux *a;
	int i;

	a = fid-&gt;aux;
	if(a == nil)
		return;
	for(i=0; i&lt;jar-&gt;nc; i++)
		jar-&gt;c[i].mark = 1;
	for(p=a-&gt;ctext; *p; p=nextp){
		if((nextp = strchr(p, '\n')) != nil)
			*nextp++ = '\0';
		else
			nextp = "";
		addtojar(jar, p, 0);
	}
	for(i=0; i&lt;jar-&gt;nc; i++)
		if(jar-&gt;c[i].mark)
			delcookie(jar, &amp;jar-&gt;c[i]);
	syncjar(jar);
	free(a-&gt;dom);
	free(a-&gt;path);
	free(a-&gt;inhttp);
	free(a-&gt;outhttp);
	free(a-&gt;ctext);
	free(a);
}

void
closecookies(void)
{
	closejar(jar);
}

void
initcookies(char *file)
{
	char *home;

	fmtinstall('J', jarfmt);
	fmtinstall('K', cookiefmt);

	if(file == nil){
		home = getenv("home");
		if(home == nil)
			sysfatal("no cookie file specified and no $home");
		file = emalloc9p(strlen(home)+30);
		strcpy(file, home);
		strcat(file, "/lib/webcookies");
	}
	jar = readjar(file);
	if(jar == nil)
		sysfatal("readjar: %r");
}

void
httpsetcookie(char *hdr, char *dom, char *path)
{
	if(path == nil)
		path = "/";

	parsehttp(jar, hdr, dom, path);
	syncjar(jar);
}

char*
httpcookies(char *dom, char *path, int issecure)
{
	char buf[1024];
	Jar *j;

	syncjar(jar);
	j = cookiesearch(jar, dom, path, issecure);
	snprint(buf, sizeof buf, "%J", j);
	closejar(j);
	return estrdup(buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

