<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/webfs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/webfs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Web file system.  Conventionally mounted at /mnt/web
 *
 *	ctl				send control messages (might go away)
 *	cookies			list of cookies, editable
 *	clone			open and read to obtain new connection
 *	n				connection directory
 *		ctl				control messages (like get url)
 *		body				retrieved data
 *		content-type		mime content-type of body
 *		postbody			data to be posted
 *		parsed			parsed version of url
 * 			url				entire url
 *			scheme			http, ftp, etc.
 *			host				hostname
 *			path				path on host
 *			query			query after path
 *			fragment			#foo anchor reference
 *			user				user name (ftp)
 *			password			password (ftp)
 *			ftptype			transfer mode (ftp)
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;ip.h&gt;
#include &lt;plumb.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include &lt;9p.h&gt;
#include "dat.h"
#include "fns.h"

int fsdebug;

enum
{
	Qroot,
	Qrootctl,
	Qclone,
	Qcookies,
	Qclient,
	Qctl,
	Qbody,
	Qbodyext,
	Qcontenttype,
	Qpostbody,
	Qparsed,
	Qurl,
	Qscheme,
	Qschemedata,
	Quser,
	Qpasswd,
	Qhost,
	Qport,
	Qpath,
	Qquery,
	Qfragment,
	Qftptype,
	Qend,
};

#define PATH(type, n)	((type)|((n)&lt;&lt;8))
#define TYPE(path)		((int)(path) &amp; 0xFF)
#define NUM(path)		((uint)(path)&gt;&gt;8)

Channel *creq;
Channel *creqwait;
Channel *cclunk;
Channel *cclunkwait;

typedef struct Tab Tab;
struct Tab
{
	char *name;
	ulong mode;
	int offset;
};

Tab tab[] =
{
	"/",			DMDIR|0555,		0,
	"ctl",			0666,			0,
	"clone",		0666,			0,
	"cookies",		0666,			0,
	"XXX",		DMDIR|0555,		0,
	"ctl",			0666,			0,
	"body",		0444,			0,
	"XXX",		0444,			0,
	"contenttype",	0444,			0,
	"postbody",	0666,			0,
	"parsed",		DMDIR|0555,		0,
	"url",			0444,			offsetof(Url, url),
	"scheme",		0444,			offsetof(Url, scheme),
	"schemedata",	0444,			offsetof(Url, schemedata),
	"user",		0444,			offsetof(Url, user),
	"passwd",		0444,			offsetof(Url, passwd),
	"host",		0444,			offsetof(Url, host),
	"port",		0444,			offsetof(Url, port),
	"path",		0444,			offsetof(Url, path),
	"query",		0444,			offsetof(Url, query),
	"fragment",	0444,			offsetof(Url, fragment),
	"ftptype",		0444,			offsetof(Url, ftp.type),
};

ulong time0;

static void
fillstat(Dir *d, uvlong path, ulong length, char *ext)
{
	Tab *t;
	int type;
	char buf[32];

	memset(d, 0, sizeof(*d));
	d-&gt;uid = estrdup("web");
	d-&gt;gid = estrdup("web");
	d-&gt;qid.path = path;
	d-&gt;atime = d-&gt;mtime = time0;
	d-&gt;length = length;
	type = TYPE(path);
	t = &amp;tab[type];
	if(type == Qbodyext) {
		snprint(buf, sizeof buf, "body.%s", ext == nil ? "xxx" : ext);
		d-&gt;name = estrdup(buf);
	}
	else if(t-&gt;name)
		d-&gt;name = estrdup(t-&gt;name);
	else{	/* client directory */
		snprint(buf, sizeof buf, "%ud", NUM(path));
		d-&gt;name = estrdup(buf);
	}
	d-&gt;qid.type = t-&gt;mode&gt;&gt;24;
	d-&gt;mode = t-&gt;mode;
}

static void
fsstat(Req *r)
{
	fillstat(&amp;r-&gt;d, r-&gt;fid-&gt;qid.path, 0, nil);
	respond(r, nil);
}

static int
rootgen(int i, Dir *d, void*)
{
	char buf[32];

	i += Qroot+1;
	if(i &lt; Qclient){
		fillstat(d, i, 0, nil);
		return 0;
	}
	i -= Qclient;
	if(i &lt; nclient){
		fillstat(d, PATH(Qclient, i), 0, nil);
		snprint(buf, sizeof buf, "%d", i);
		free(d-&gt;name);
		d-&gt;name = estrdup(buf);
		return 0;
	}
	return -1;
}

static int
clientgen(int i, Dir *d, void *aux)
{
	Client *c;

	c = aux;
	i += Qclient+1;
	if(i &lt;= Qparsed){
		fillstat(d, PATH(i, c-&gt;num), 0, c-&gt;ext);
		return 0;
	}
	return -1;
}

static int
parsedgen(int i, Dir *d, void *aux)
{
	Client *c;

	c = aux;
	i += Qparsed+1;
	if(i &lt; Qend){
		fillstat(d, PATH(i, c-&gt;num), 0, nil);
		return 0;
	}
	return -1;
}

static void
fsread(Req *r)
{
	char *s;
	char e[ERRMAX];
	Client *c;
	ulong path;

	path = r-&gt;fid-&gt;qid.path;
	switch(TYPE(path)){
	default:
		snprint(e, sizeof e, "bug in webfs path=%lux\n", path);
		respond(r, e);
		break;

	case Qroot:
		dirread9p(r, rootgen, nil);
		respond(r, nil);
		break;

	case Qrootctl:
		globalctlread(r);
		break;

	case Qcookies:
		cookieread(r);
		break;

	case Qclient:
		dirread9p(r, clientgen, client[NUM(path)]);
		respond(r, nil);
		break;

	case Qctl:
		ctlread(r, client[NUM(path)]);
		break;

	case Qcontenttype:
		c = client[NUM(path)];
		if(c-&gt;contenttype == nil)
			r-&gt;ofcall.count = 0;
		else
			readstr(r, c-&gt;contenttype);
		respond(r, nil);
		break;

	case Qpostbody:
		c = client[NUM(path)];
		readbuf(r, c-&gt;postbody, c-&gt;npostbody);
		respond(r, nil);
		break;
		
	case Qbody:
	case Qbodyext:
		c = client[NUM(path)];
		if(c-&gt;iobusy){
			respond(r, "already have i/o pending");
			break;
		}
		c-&gt;iobusy = 1;
		sendp(c-&gt;creq, r);
		break;

	case Qparsed:
		dirread9p(r, parsedgen, client[NUM(path)]);
		respond(r, nil);
		break;

	case Qurl:
	case Qscheme:
	case Qschemedata:
	case Quser:
	case Qpasswd:
	case Qhost:
	case Qport:
	case Qpath:
	case Qquery:
	case Qfragment:
	case Qftptype:
		c = client[NUM(path)];
		r-&gt;ofcall.count = 0;
		if(c-&gt;url != nil
		&amp;&amp; (s = *(char**)((uintptr)c-&gt;url+tab[TYPE(path)].offset)) != nil)
			readstr(r, s);
		respond(r, nil);
		break;
	}
}

static void
fswrite(Req *r)
{
	int m;
	ulong path;
	char e[ERRMAX], *buf, *cmd, *arg;
	Client *c;

	path = r-&gt;fid-&gt;qid.path;
	switch(TYPE(path)){
	default:
		snprint(e, sizeof e, "bug in webfs path=%lux\n", path);
		respond(r, e);
		break;

	case Qcookies:
		cookiewrite(r);
		break;

	case Qrootctl:
	case Qctl:
		if(r-&gt;ifcall.count &gt;= 1024){
			respond(r, "ctl message too long");
			return;
		}
		buf = estredup(r-&gt;ifcall.data, (char*)r-&gt;ifcall.data+r-&gt;ifcall.count);
		cmd = buf;
		arg = strpbrk(cmd, "\t ");
		if(arg){
			*arg++ = '\0';
			arg += strspn(arg, "\t ");
		}else
			arg = "";
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		if(TYPE(path)==Qrootctl){
			if(!ctlwrite(r, &amp;globalctl, cmd, arg)
			&amp;&amp; !globalctlwrite(r, cmd, arg))
				respond(r, "unknown control command");
		}else{
			c = client[NUM(path)];
			if(!ctlwrite(r, &amp;c-&gt;ctl, cmd, arg)
			&amp;&amp; !clientctlwrite(r, c, cmd, arg))
				respond(r, "unknown control command");
		}
		free(buf);
		break;

	case Qpostbody:
		c = client[NUM(path)];
		if(c-&gt;bodyopened){
			respond(r, "cannot write postbody after opening body");
			break;
		}
		if(r-&gt;ifcall.offset &gt;= 128*1024*1024){	/* &gt;128MB is probably a mistake */
			respond(r, "offset too large");
			break;
		}
		m = r-&gt;ifcall.offset + r-&gt;ifcall.count;
		if(c-&gt;npostbody &lt; m){
			c-&gt;postbody = erealloc(c-&gt;postbody, m);
			memset(c-&gt;postbody+c-&gt;npostbody, 0, m-c-&gt;npostbody);
			c-&gt;npostbody = m;
		}
		memmove(c-&gt;postbody+r-&gt;ifcall.offset, r-&gt;ifcall.data, r-&gt;ifcall.count);
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		respond(r, nil);
		break;
	}
}

static void
fsopen(Req *r)
{
	static int need[4] = { 4, 2, 6, 1 };
	ulong path;
	int n;
	Client *c;
	Tab *t;

	/*
	 * lib9p already handles the blatantly obvious.
	 * we just have to enforce the permissions we have set.
	 */
	path = r-&gt;fid-&gt;qid.path;
	t = &amp;tab[TYPE(path)];
	n = need[r-&gt;ifcall.mode&amp;3];
	if((n&amp;t-&gt;mode) != n){
		respond(r, "permission denied");
		return;
	}

	switch(TYPE(path)){
	case Qcookies:
		cookieopen(r);
		break;

	case Qpostbody:
		c = client[NUM(path)];
		c-&gt;havepostbody++;
		c-&gt;ref++;
		respond(r, nil);
		break;

	case Qbody:
	case Qbodyext:
		c = client[NUM(path)];
		if(c-&gt;url == nil){
			respond(r, "url is not yet set");
			break;
		}
		c-&gt;bodyopened = 1;
		c-&gt;ref++;
		sendp(c-&gt;creq, r);
		break;

	case Qclone:
		n = newclient(0);
		path = PATH(Qctl, n);
		r-&gt;fid-&gt;qid.path = path;
		r-&gt;ofcall.qid.path = path;
		if(fsdebug)
			fprint(2, "open clone =&gt; path=%lux\n", path);
		t = &amp;tab[Qctl];
		/* fall through */
	default:
		if(t-tab &gt;= Qclient)
			client[NUM(path)]-&gt;ref++;
		respond(r, nil);
		break;
	}
}

static void
fsdestroyfid(Fid *fid)
{
	sendp(cclunk, fid);
	recvp(cclunkwait);
}

static void
fsattach(Req *r)
{
	if(r-&gt;ifcall.aname &amp;&amp; r-&gt;ifcall.aname[0]){
		respond(r, "invalid attach specifier");
		return;
	}
	r-&gt;fid-&gt;qid.path = PATH(Qroot, 0);
	r-&gt;fid-&gt;qid.type = QTDIR;
	r-&gt;fid-&gt;qid.vers = 0;
	r-&gt;ofcall.qid = r-&gt;fid-&gt;qid;
	respond(r, nil);
}

static char*
fswalk1(Fid *fid, char *name, Qid *qid)
{
	int i, n;
	ulong path;
	char buf[32], *ext;

	path = fid-&gt;qid.path;
	if(!(fid-&gt;qid.type&amp;QTDIR))
		return "walk in non-directory";

	if(strcmp(name, "..") == 0){
		switch(TYPE(path)){
		case Qparsed:
			qid-&gt;path = PATH(Qclient, NUM(path));
			qid-&gt;type = tab[Qclient].mode&gt;&gt;24;
			return nil;
		case Qclient:
		case Qroot:
			qid-&gt;path = PATH(Qroot, 0);
			qid-&gt;type = tab[Qroot].mode&gt;&gt;24;
			return nil;
		default:
			return "bug in fswalk1";
		}
	}

	i = TYPE(path)+1;
	for(; i&lt;nelem(tab); i++){
		if(i==Qclient){
			n = atoi(name);
			snprint(buf, sizeof buf, "%d", n);
			if(n &lt; nclient &amp;&amp; strcmp(buf, name) == 0){
				qid-&gt;path = PATH(i, n);
				qid-&gt;type = tab[i].mode&gt;&gt;24;
				return nil;
			}
			break;
		}
		if(i==Qbodyext){
			ext = client[NUM(path)]-&gt;ext;
			snprint(buf, sizeof buf, "body.%s", ext == nil ? "xxx" : ext);
			if(strcmp(buf, name) == 0){
				qid-&gt;path = PATH(i, NUM(path));
				qid-&gt;type = tab[i].mode&gt;&gt;24;
				return nil;
			}
		}
		else if(strcmp(name, tab[i].name) == 0){
			qid-&gt;path = PATH(i, NUM(path));
			qid-&gt;type = tab[i].mode&gt;&gt;24;
			return nil;
		}
		if(tab[i].mode&amp;DMDIR)
			break;
	}
	return "directory entry not found";
}

static void
fsflush(Req *r)
{
	Req *or;
	int t;
	Client *c;
	ulong path;

	or=r;
	while(or-&gt;ifcall.type==Tflush)
		or = or-&gt;oldreq;

	if(or-&gt;ifcall.type != Tread &amp;&amp; or-&gt;ifcall.type != Topen)
		abort();

	path = or-&gt;fid-&gt;qid.path;
	t = TYPE(path);
	if(t != Qbody &amp;&amp; t != Qbodyext)
		abort();

	c = client[NUM(path)];
	sendp(c-&gt;creq, r);
	iointerrupt(c-&gt;io);
}

static void
fsthread(void*)
{
	ulong path;
	Alt a[3];
	Fid *fid;
	Req *r;

	threadsetname("fsthread");
	plumbstart();

	a[0].op = CHANRCV;
	a[0].c = cclunk;
	a[0].v = &amp;fid;
	a[1].op = CHANRCV;
	a[1].c = creq;
	a[1].v = &amp;r;
	a[2].op = CHANEND;

	for(;;){
		switch(alt(a)){
		case 0:
			path = fid-&gt;qid.path;
			if(TYPE(path)==Qcookies)
				cookieclunk(fid);
			if(fid-&gt;omode != -1 &amp;&amp; TYPE(path) &gt;= Qclient)
				closeclient(client[NUM(path)]);
			sendp(cclunkwait, nil);
			break;
		case 1:
			switch(r-&gt;ifcall.type){
			case Tattach:
				fsattach(r);
				break;
			case Topen:
				fsopen(r);
				break;
			case Tread:
				fsread(r);
				break;
			case Twrite:
				fswrite(r);
				break;
			case Tstat:
				fsstat(r);
				break;
			case Tflush:
				fsflush(r);
				break;
			default:
				respond(r, "bug in fsthread");
				break;
			}
			sendp(creqwait, 0);
			break;
		}
	}
}

static void
fssend(Req *r)
{
	sendp(creq, r);
	recvp(creqwait);	/* avoids need to deal with spurious flushes */
}

void
initfs(void)
{
	time0 = time(0);
	creq = chancreate(sizeof(void*), 0);
	creqwait = chancreate(sizeof(void*), 0);
	cclunk = chancreate(sizeof(void*), 0);
	cclunkwait = chancreate(sizeof(void*), 0);
	procrfork(fsthread, nil, STACK, RFNAMEG);
}

void
takedown(Srv*)
{
	closecookies();
	threadexitsall("done");
}

Srv fs = 
{
.attach=		fssend,
.destroyfid=	fsdestroyfid,
.walk1=		fswalk1,
.open=		fssend,
.read=		fssend,
.write=		fssend,
.stat=		fssend,
.flush=		fssend,
.end=		takedown,
};

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

