<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/webfs/plumb.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/webfs/plumb.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;plumb.h&gt;
#include &lt;9p.h&gt;

#include "dat.h"
#include "fns.h"

static int		plumbsendfd;
static int		plumbwebfd;
static Channel	*plumbchan;

static void	plumbwebproc(void*);
static void	plumbwebthread(void*);
static void plumbsendproc(void*);

void
plumbinit(void)
{
	plumbsendfd = plumbopen("send", OWRITE|OCEXEC);
	plumbwebfd = plumbopen("web", OREAD|OCEXEC);
}

void
plumbstart(void)
{
	plumbchan = chancreate(sizeof(Plumbmsg*), 0);
	proccreate(plumbwebproc, nil, STACK);
	threadcreate(plumbwebthread, nil, STACK);
}

static void
plumbwebthread(void*)
{
	char *base;
	Plumbmsg *m;

	for(;;){
		m = recvp(plumbchan);
		if(m == nil)
			threadexits(nil);
		base = plumblookup(m-&gt;attr, "baseurl");
		if(base == nil)
			base = m-&gt;wdir;
		plumburl(m-&gt;data, base);
		plumbfree(m);
	}
}

static void
plumbwebproc(void*)
{
	Plumbmsg *m;

	for(;;){
		m = plumbrecv(plumbwebfd);
		sendp(plumbchan, m);
		if(m == nil)
			threadexits(nil);
	}
}

static void
addattr(Plumbmsg *m, char *name, char *value)
{
	Plumbattr *a;

	a = malloc(sizeof(Plumbattr));
	a-&gt;name = name;
	a-&gt;value = value;
	a-&gt;next = m-&gt;attr;
	m-&gt;attr = a;
}

static void
freeattrs(Plumbmsg *m)
{
	Plumbattr *a, *next;

	a = m-&gt;attr;
	while(a != nil) {
		next = a-&gt;next;
		free(a);
		a = next;
	}
}

static struct
{
	char	*ctype;
	char	*ext;
}
ctypes[] =
{
	{ "application/msword", "doc" },
	{ "application/pdf", "pdf" },
	{ "application/postscript", "ps" },
	{ "application/rtf", "rtf" },
	{ "image/gif", "gif" },
	{ "image/jpeg", "jpg" },
	{ "image/png", "png" },
	{ "image/ppm", "ppm" },
	{ "image/tiff", "tiff" },
	{ "text/html", "html" },
	{ "text/plain", "txt" },
	{ "text/xml", "xml" },
};

void
replumb(Client *c)
{
	int i;
	Plumbmsg *m;
	char name[128], *ctype, *ext, *p;

	if(!c-&gt;plumbed)
		return;
	m = emalloc(sizeof(Plumbmsg));
	m-&gt;src = "webfs";
	m-&gt;dst = nil;
	m-&gt;wdir = "/";
	m-&gt;type = "text";
	m-&gt;attr = nil;
	addattr(m, "url", c-&gt;url-&gt;url);
	ctype = c-&gt;contenttype;
	ext = nil;
	if(ctype != nil) {
		addattr(m, "content-type", ctype);
		for(i = 0; i &lt; nelem(ctypes); i++) {
			if(strcmp(ctype, ctypes[i].ctype) == 0) {
				ext = ctypes[i].ext;
				break;
			}
		}
	}
	if(ext == nil) {
		p = strrchr(c-&gt;url-&gt;url, '/');
		if(p != nil)
			p = strrchr(p+1, '.');
		if(p != nil &amp;&amp; strlen(p) &lt;= 5)
			ext = p+1;
		else
			ext = "txt";		/* punt */
	}
	c-&gt;ext = ext;
if(0)fprint(2, "content type %s -&gt; extension .%s\n", ctype, ext);
	m-&gt;ndata = snprint(name, sizeof name, "/mnt/web/%d/body.%s", c-&gt;num, ext);
	m-&gt;data = estrdup(name);
	proccreate(plumbsendproc, m, STACK);	/* separate proc to avoid a deadlock */
}

static void
plumbsendproc(void *x)
{
	Plumbmsg *m;

	m = x;
	plumbsend(plumbsendfd, m);
	freeattrs(m);
	free(m-&gt;data);
	free(m);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

