<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/xd.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/xd.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

uchar		odata[16];
uchar		data[32];
int		ndata;
int		nread;
ulong		addr;
int		repeats;
int		swizzle;
int		flush;
int		abase=2;
int		xd(char *, int);
void		xprint(char *, ...);
void		initarg(void), swizz(void);
enum{
	Narg=10,

	TNone=0,
	TAscii,
	TRune,
};
typedef struct Arg Arg;
typedef void fmtfn(char *);
struct Arg
{
	int	chartype;		/* TNone, TAscii, TRunes */
	int	loglen;		/* 0==1, 1==2, 2==4, 3==8 */
	int	base;		/* 0==8, 1==10, 2==16 */
	fmtfn	*fn;		/* function to call with data */
	char	*afmt;		/* format to use to print address */
	char	*fmt;		/* format to use to print data */
}arg[Narg];
int	narg;

fmtfn	fmt0, fmt1, fmt2, fmt3, fmtc, fmtr;
fmtfn *fmt[4] = {
	fmt0,
	fmt1,
	fmt2,
	fmt3
};

char *dfmt[4][3] = {
	" %.3uo",	" %.3ud",	" %.2ux",
	" %.6uo",	" %.5ud",	" %.4ux",
	" %.11luo",	" %.10lud",	" %.8lux",
	" %.22lluo",	" %.20llud",	" %.16llux",
};

char *cfmt[3][3] = {
	"   %c",	"   %c", 	"  %c",
	" %.3s",	" %.3s",	" %.2s",
	" %.3uo",	" %.3ud",	" %.2ux",
};

char *rfmt[1][1] = {
	" %2.2C",
};

char *afmt[2][3] = {
	"%.7luo ",	"%.7lud ",	"%.7lux ",
	"%7luo ",	"%7lud ",	"%7lux ",
};

Biobuf	bin;
Biobuf	bout;

void
main(int argc, char *argv[])
{
	int i, err;
	Arg *ap;

	Binit(&amp;bout, 1, OWRITE);
	err = 0;
	ap = 0;
	while(argc&gt;1 &amp;&amp; argv[1][0]=='-' &amp;&amp; argv[1][1]){
		--argc;
		argv++;
		argv[0]++;
		if(argv[0][0] == 'r'){
			repeats = 1;
			if(argv[0][1])
				goto Usage;
			continue;
		}
		if(argv[0][0] == 's'){
			swizzle = 1;
			if(argv[0][1])
				goto Usage;
			continue;
		}
		if(argv[0][0] == 'u'){
			flush = 1;
			if(argv[0][1])
				goto Usage;
			continue;
		}
		if(argv[0][0] == 'a'){
			argv[0]++;
			switch(argv[0][0]){
			case 'o':
				abase = 0;
				break;
			case 'd':
				abase = 1;
				break;
			case 'x':
				abase = 2;
				break;
			default:
				goto Usage;
			}
			if(argv[0][1])
				goto Usage;
			continue;
		}
		ap = &amp;arg[narg];
		initarg();
		while(argv[0][0]){
			switch(argv[0][0]){
			case 'c':
				ap-&gt;chartype = TAscii;
				ap-&gt;loglen = 0;
				if(argv[0][1] || argv[0][-1]!='-')
					goto Usage;
				break;
			case 'R':
				ap-&gt;chartype = TRune;
				ap-&gt;loglen = 0;
				if(argv[0][1] || argv[0][-1]!='-')
					goto Usage;
				break;
			case 'o':
				ap-&gt;base = 0;
				break;
			case 'd':
				ap-&gt;base = 1;
				break;
			case 'x':
				ap-&gt;base = 2;
				break;
			case 'b':
			case '1':
				ap-&gt;loglen = 0;
				break;
			case 'w':
			case '2':
				ap-&gt;loglen = 1;
				break;
			case 'l':
			case '4':
				ap-&gt;loglen = 2;
				break;
			case 'v':
			case '8':
				ap-&gt;loglen = 3;
				break;
			default:
			Usage:
   fprint(2, "usage: xd [-u] [-r] [-s] [-a{odx}] [-c|{b1w2l4v8}{odx}] ... file ...\n");
				exits("usage");
			}
			argv[0]++;
		}
		if(ap-&gt;chartype == TRune)
			ap-&gt;fn = fmtr;
		else if(ap-&gt;chartype == TAscii)
			ap-&gt;fn = fmtc;
		else
			ap-&gt;fn = fmt[ap-&gt;loglen];
		ap-&gt;fmt = dfmt[ap-&gt;loglen][ap-&gt;base];
		ap-&gt;afmt = afmt[ap&gt;arg][abase];
	}
	if(narg == 0)
		initarg();
	if(argc == 1)
		err = xd(0, 0);
	else if(argc == 2)
		err = xd(argv[1], 0);
	else for(i=1; i&lt;argc; i++)
		err |= xd(argv[i], 1);
	exits(err? "error" : 0);
}

void
initarg(void)
{
	Arg *ap;

	ap = &amp;arg[narg++];
	if(narg &gt;= Narg){
		fprint(2, "xd: too many formats (max %d)\n", Narg);
		exits("usage");
	}
	ap-&gt;chartype = TNone;
	ap-&gt;loglen = 2;
	ap-&gt;base = 2;
	ap-&gt;fn = fmt2;
	ap-&gt;fmt = dfmt[ap-&gt;loglen][ap-&gt;base];
	ap-&gt;afmt = afmt[narg&gt;1][abase];
}

int
xd(char *name, int title)
{
	int fd;
	int i, star, nsee, nleft;
	Arg *ap;
	Biobuf *bp;

	fd = 0;
	if(name){
		bp = Bopen(name, OREAD);
		if(bp == 0){
			fprint(2, "xd: can't open %s\n", name);
			return 1;
		}
	}else{
		bp = &amp;bin;
		Binit(bp, fd, OREAD);
	}
	if(title)
		xprint("%s\n", name);
	addr = 0;
	star = 0;
	nsee = 16;
	nleft = 0;
	/* read 32 but see only 16 so that runes are happy */
	while((ndata=Bread(bp, data + nleft, 32 - nleft)) &gt;= 0){
		ndata += nleft;
		nleft = 0;
		nread = ndata;
		if(ndata&gt;nsee)
			ndata = nsee;
		else if(ndata&lt;nsee)
			for(i=ndata; i&lt;nsee; i++)
				data[i] = 0;
		if(swizzle)
			swizz();
		if(ndata==nsee &amp;&amp; repeats){
			if(addr&gt;0 &amp;&amp; data[0]==odata[0]){
				for(i=1; i&lt;nsee; i++)
					if(data[i] != odata[i])
						break;
				if(i == nsee){
					addr += nsee;
					if(star == 0){
						star++;
						xprint("*\n", 0);
					}
					continue;
				}
			}
			for(i=0; i&lt;nsee; i++)
				odata[i] = data[i];
			star = 0;
		}
		for(ap=arg; ap&lt;&amp;arg[narg]; ap++){
			xprint(ap-&gt;afmt, addr);
			(*ap-&gt;fn)(ap-&gt;fmt);
			xprint("\n", 0);
			if(flush)
				Bflush(&amp;bout);
		}
		addr += ndata;
		if(ndata&lt;nsee){
			xprint(afmt[0][abase], addr);
			xprint("\n", 0);
			if(flush)
				Bflush(&amp;bout);
			break;
		}
		if(nread&gt;nsee){
			nleft = nread - nsee;
			memmove(data, data + nsee, nleft);
		}
	}
	Bterm(bp);
	return 0;
}

void
swizz(void)
{
	uchar *p, *q;
	int i;
	uchar swdata[16];

	p = data;
	q = swdata;
	for(i=0; i&lt;16; i++)
		*q++ = *p++;
	p = data;
	q = swdata;
	for(i=0; i&lt;4; i++){
		p[0] = q[3];
		p[1] = q[2];
		p[2] = q[1];
		p[3] = q[0];
		p += 4;
		q += 4;
	}
}

void
fmt0(char *f)
{
	int i;
	for(i=0; i&lt;ndata; i++)
		xprint(f, data[i]);
}

void
fmt1(char *f)
{
	int i;
	for(i=0; i&lt;ndata; i+=sizeof(ushort))
		xprint(f, (data[i]&lt;&lt;8)|data[i+1]);
}

void
fmt2(char *f)
{
	int i;
	for(i=0; i&lt;ndata; i+=sizeof(ulong))
		xprint(f, (data[i]&lt;&lt;24)|(data[i+1]&lt;&lt;16)|(data[i+2]&lt;&lt;8)|data[i+3]);
}

void
fmt3(char *f)
{
	int i;
	uvlong v;

	for(i=0; i&lt;ndata; i+=sizeof(uvlong)){
		v = (data[i]&lt;&lt;24)|(data[i+1]&lt;&lt;16)|(data[i+2]&lt;&lt;8)|data[i+3];
		v &lt;&lt;= 32;
		v |= (data[i+4]&lt;&lt;24)|(data[i+1+4]&lt;&lt;16)|(data[i+2+4]&lt;&lt;8)|data[i+3+4];
		if(Bprint(&amp;bout, f, v)&lt;0){
			fprint(2, "xd: i/o error\n");
			exits("i/o error");
		}
	}
}

void
onefmtc(uchar c)
{
	switch(c){
	case '\t':
		xprint(cfmt[1][2], "\\t");
		break;
	case '\r':
		xprint(cfmt[1][2], "\\r");
		break;
	case '\n':
		xprint(cfmt[1][2], "\\n");
		break;
	case '\b':
		xprint(cfmt[1][2], "\\b");
		break;
	default:
		if(c&gt;=0x7F || ' '&gt;c)
			xprint(cfmt[2][2], c);
		else
			xprint(cfmt[0][2], c);
		break;
	}
}

void
fmtc(char *f)
{
	int i;

	USED(f);
	for(i=0; i&lt;ndata; i++)
		onefmtc(data[i]);
}

void
fmtr(char *f)
{
	int i, w, cw;
	Rune r;
	static int nstart;

	USED(f);
	if(nstart)	
		xprint("%*c", 3*nstart, ' ');
	for(i=nstart; i&lt;ndata; )
		if(data[i] &lt; Runeself)
			onefmtc(data[i++]);
		else{
			w = chartorune(&amp;r, (char *)data+i);
			if(w == 1 || i + w&gt;nread)
				onefmtc(data[i++]);
			else{
				cw = w;
				if(i + w&gt;ndata)
					cw = ndata - i;
				xprint(rfmt[0][0], r);	
				xprint("%*c", 3*cw-3, ' ');
				i += w;
			}
		}
	if(i &gt; ndata)
		nstart = i - ndata;
	else
		nstart = 0;
}

void
xprint(char *fmt, ...)
{
	va_list arglist;

	va_start(arglist, fmt);
	if(Bvprint(&amp;bout, fmt, arglist)&lt;0){
		fprint(2, "xd: i/o error\n");
		exits("i/o error");
	}
	va_end(arglist);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

