<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mahjongg/level.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mahjongg/level.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;

#include "mahjongg.h"

void
consumeline(Biobuf *b)
{
	while(Bgetc(b) != '\n')
		;
}

/* parse a level file */
int
parse(char *layout)
{
	int x = 0, y = 0, depth = 0;
	char c;
	Biobuf *b;

	b = Bopen(layout, OREAD);
	if(b == nil) {
		fprint(2, "could not open file %s: %r\n", layout);
		return 0;
	}

	level.remaining = 0;

	while((c = Bgetc(b)) &gt; 0) {
		switch(c)  {
		case '\n':
			x = 0;
			y = (y+1) % Ly;
			if(!y)
				depth++;
			break;
		case '.':
			orig.board[depth][x][y].which = 0;
			x++;
			break;
		case '1':
			orig.remaining++;
		case '2':
		case '3':
		case '4':
			orig.board[depth][x++][y].which = c-48;
			break;
		default:
			consumeline(b);
			break;
		}
	}
	Bterm(b);

	return 1;
}

int
indextype(int type)
{
	int t;

	if(type &lt; 108)
		t = (type/36)*Facey * 9 + ((type%36)/4)*Facex;
	else if(type &lt; 112)
		t = Seasons;
	else if(type &lt; 128)
		t = 3*Facey + (((type+12)%36)/4)*Facex;
	else if(type &lt; 132)
		t = Flowers;
	else
		t = 4*Facey + (((type+28)%36)/4)*Facex;

	return t;

}

Point
indexpt(int type)
{
	Point p;

	/*
	 * the first 108 bricks are 4 of each, 36 per line:
	 * 	x = (index%36)/4
	 *	y = (index)/36
	 * then multiply by the size of a single tile.
	 * the next 4 are the seasons, so x = index%4...
	 * and so on...
	 */

	if(type &lt; 108)
		p = Pt(((type%36)/4)*Facex, (type/36)*Facey);
	else if(type &lt; 112)
		p = Pt((type%4)*Facex, 3*Facey);
	else if(type &lt; 128)
		p = Pt((((type+12)%36)/4)*Facex, 3*Facey);
	else if(type &lt; 132)
		p = Pt(((type+4)%4)*Facex, 4*Facey);
	else
		p = Pt((((type+28)%36)/4)*Facex, 4*Facey);
	return p;
}

/* use the seed to generate a replayable game */
void
generate(uint seed)
{
	int x, y, d, n;
	int order[144];
	Point p;

	srand(seed);

	for (x = 0; x &lt; Tiles; x++)
		order[x] = x;

	for(x = 0; x &lt; Tiles; x++) {
		n = order[x];
		y = nrand(Tiles);
		order[x] = order[y];
		order[y] = n;
	}

	n = 0;
	for(d = 0; d &lt; Depth; d++)
		for(y = 0; y &lt; Ly; y++)
			for(x = 0; x &lt; Lx; x++)
				if(orig.board[d][x][y].which == 1) {

					orig.board[d][x][y].type = indextype(order[n]);
					p = indexpt(order[n++]);
					orig.board[d][x][y].start = p;
					orig.board[d][x+1][y].start = p;
					orig.board[d][x][y+1].start = p;
					orig.board[d][x+1][y+1].start = p;
				}

	if(n != orig.remaining)
		fprint(2, "level improperly generated: %d elements, "
			"should have %d\n", n, orig.remaining);

	orig.c = NC;
	orig.l = NC;
	orig.done = 0;
	level = orig;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

