<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3dec/main.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3dec/main.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Simple mp3 player.  Derived from libmad's example minimad.c.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include "mad.h"

/* Current input file */
char *name;
vlong offset;
int rate = 44100;

char *outfile;
int vfd; /* /dev/volume */

static enum mad_flow
input(void *data, struct mad_stream *stream)
{
	int fd, n, m;
	static uchar buf[32768];

	fd = (int)data;
	n = stream-&gt;bufend - stream-&gt;next_frame;
	memmove(buf, stream-&gt;next_frame, n);
	m = read(fd, buf+n, sizeof buf-n);
	offset += m;
	if(m &lt; 0)
		sysfatal("reading input: %r");
	if(m == 0)
		return MAD_FLOW_STOP;
	n += m;
	mad_stream_buffer(stream, buf, n);
	return MAD_FLOW_CONTINUE;
}

/*
 * Dither 28-bit down to 16-bit.  From mpg321. 
 * I'm skeptical, but it's supposed to make the
 * samples sound better than just truncation.
 */
typedef struct Dither Dither;
struct Dither
{
	mad_fixed_t error[3];
	mad_fixed_t random;
};

#define PRNG(x) (((x)*0x19660dL + 0x3c6ef35fL) &amp; 0xffffffffL)

enum
{
	FracBits = MAD_F_FRACBITS,
	OutBits = 16,
	Round = 1 &lt;&lt; (FracBits+1-OutBits-1),	// sic
	ScaleBits = FracBits + 1 - OutBits,
	LowMask  = (1&lt;&lt;ScaleBits) - 1,
	Min = -MAD_F_ONE,
	Max = MAD_F_ONE - 1,
};

int
audiodither(mad_fixed_t v, Dither *d)
{
	int out;
	mad_fixed_t random;

	/* noise shape */
	v += d-&gt;error[0] - d-&gt;error[1] + d-&gt;error[2];
	d-&gt;error[2] = d-&gt;error[1];
	d-&gt;error[1] = d-&gt;error[0] / 2;
	
	/* bias */
	out = v + Round;
	
	/* dither */
	random = PRNG(d-&gt;random);
	out += (random &amp; LowMask) - (d-&gt;random &amp; LowMask);
	d-&gt;random = random;
	
	/* clip */
	if(out &gt; Max){
		out = Max;
		if(v &gt; Max)
			v = Max;
	}else if(out &lt; Min){
		out = Min;
		if(v &lt; Min)
			v = Min;
	}
	
	/* quantize */
	out &amp;= ~LowMask;
	
	/* error feedback */
	d-&gt;error[0] = v - out;
	
	/* scale */
	return out &gt;&gt; ScaleBits;
}

static enum mad_flow
output(void *data, struct mad_header const* header, struct mad_pcm *pcm)
{
	int i, n, v;
	mad_fixed_t const *left, *right;
	static Dither d;
	static uchar buf[16384], *p;

	if(pcm-&gt;samplerate != rate){
		rate = pcm-&gt;samplerate;
		if(vfd &lt; 0)
			fprint(2, "warning: audio sample rate is %d Hz\n", rate);
		else
			fprint(vfd, "speed %d", rate);
	}
	p = buf;
	memset(&amp;d, 0, sizeof d);
	n = pcm-&gt;length;
	switch(pcm-&gt;channels){
	case 1:
		left = pcm-&gt;samples[0];
		for(i=0; i&lt;n; i++){
			v = audiodither(*left++, &amp;d);
			/* stereoize */
			*p++ = v;
			*p++ = v&gt;&gt;8;
			*p++ = v;
			*p++ = v&gt;&gt;8;
		}
		break;
	case 2:
		left = pcm-&gt;samples[0];
		right = pcm-&gt;samples[1];
		for(i=0; i&lt;n; i++){
			v = audiodither(*left++, &amp;d);
			*p++ = v;
			*p++ = v&gt;&gt;8;
			v = audiodither(*right++, &amp;d);
			*p++ = v;
			*p++ = v&gt;&gt;8;
		}
		break;
	}
	assert(p&lt;=buf+sizeof buf);
	write(1, buf, p-buf);
	return MAD_FLOW_CONTINUE;
}

static enum mad_flow
error(void *data, struct mad_stream *stream, struct mad_frame *frame)
{
	if(stream-&gt;error == MAD_ERROR_LOSTSYNC)
		return MAD_FLOW_CONTINUE;
	sysfatal("%s:#%lld: %s",
		name, offset-(stream-&gt;bufend-stream-&gt;next_frame),
		mad_stream_errorstr(stream));
	return 0;
}

void
play(int fd, char *nam)
{
	struct mad_decoder decoder;
	
	name = nam;
	mad_decoder_init(&amp;decoder, (void*)fd, input, nil, nil, output, error, nil);
	mad_decoder_run(&amp;decoder, MAD_DECODER_MODE_SYNC);
	mad_decoder_finish(&amp;decoder);
}

void
usage(void)
{
	fprint(2, "usage: mp3dec [-o outfile] [file...]\n");
	exits("usage");
}

void
main(int argc, char **argv)
{
	int i, fd;
	char *p;

	ARGBEGIN{
	case 'o':
		outfile = EARGF(usage());
		break;
	default:
		usage();
	}ARGEND
	
	if(outfile){
		if((fd = create(outfile, OWRITE, 0666)) &lt; 0)
			sysfatal("create %s: %r", outfile);
	}else{
		if((fd = open("/dev/audio", OWRITE)) &lt; 0)
			sysfatal("open /dev/audio: %r");
		vfd = open("/dev/volume", OWRITE);
	}
	if(fd != 1){
		dup(fd, 1);
		close(fd);
	}

	if(argc == 0){
		play(0, "standard input");
	}else{
		for(i=0; i&lt;argc; i++){
			if((fd = open(argv[i], OREAD)) &lt; 0)
				sysfatal("open %s: %r", argv[i]);
			play(fd, argv[i]);
			close(fd);
		}
	}
	exits(0);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

