<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/mp3enc/encoder.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/mp3enc/encoder.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *	LAME MP3 encoding engine
 *
 *	Copyright (c) 1999 Mark Taylor
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* $Id: encoder.c,v 1.43 2001/03/12 04:38:35 markt Exp $ */

#ifdef HAVE_CONFIG_H
#include &lt;config.h&gt;
#endif

#include &lt;assert.h&gt;

#include "lame.h"
#include "util.h"
#include "newmdct.h"
#include "psymodel.h"
#include "quantize.h"
#include "quantize_pvt.h"
#include "bitstream.h"
#include "VbrTag.h"

#ifdef WITH_DMALLOC
#include &lt;dmalloc.h&gt;
#endif


/*
 * auto-adjust of ATH, useful for low volume
 * Gabriel Bouvigne 3 feb 2001
 *
 * modifies some values in
 *   gfp-&gt;internal_flags-&gt;ATH
 *   (gfc-&gt;ATH)
 */
void
adjust_ATH( lame_global_flags* const  gfp,
            FLOAT8              tot_ener[2][4] )
{
    lame_internal_flags* const  gfc = gfp-&gt;internal_flags;
    int gr, channel;

    if (gfc-&gt;ATH-&gt;use_adjust) {
        FLOAT8 max_val = 0;

	for ( gr = 0; gr &lt; gfc-&gt;mode_gr; ++gr ) 
	    for ( channel = 0; channel &lt; gfc-&gt;channels_out; ++channel ) 
	        max_val = Max( max_val, tot_ener[gr][channel] );
	/* scale to 0..1, and then rescale to 0..32767 */
	max_val *= 32767/1e13;

        /*  adjust ATH depending on range of maximum value
         */
        if (vbr_mtrh == gfp-&gt;VBR) {
            /*  this code reduces slowly the ATH (speed of 12 dB per second)
             *  with some supporting stages to limit the reduction
             *    640  -&gt;  ~17 dB
             *         :
             *  32640  -&gt;  ~0.01 dB
             */
            FLOAT8 
            x = Max (640, 320*(int)(max_val/320));
            x = x/32768;
            gfc-&gt;ATH-&gt;adjust *= gfc-&gt;ATH-&gt;decay;
            if (gfc-&gt;ATH-&gt;adjust &lt; x)       /* but not more than f(x) dB */
                gfc-&gt;ATH-&gt;adjust = x;
        }
        else {
#ifdef OLD_ATH_AUTO_ADJUST
            if      (0.5 &lt; max_val / 32768) {       /* value above 50 % */
                    gfc-&gt;ATH-&gt;adjust = 1.0;         /* do not reduce ATH */
            }
            else if (0.3 &lt; max_val / 32768) {       /* value above 30 % */
                    gfc-&gt;ATH-&gt;adjust *= 0.955;      /* reduce by ~0.2 dB */
                    if (gfc-&gt;ATH-&gt;adjust &lt; 0.3)     /* but ~5 dB in maximum */
                        gfc-&gt;ATH-&gt;adjust = 0.3;            
            }
            else {                                  /* value below 30 % */
                    gfc-&gt;ATH-&gt;adjust *= 0.93;       /* reduce by ~0.3 dB */
                    if (gfc-&gt;ATH-&gt;adjust &lt; 0.01)    /* but 20 dB in maximum */
                        gfc-&gt;ATH-&gt;adjust = 0.01;
            }
#else				/* jd - 27 feb 2001 */
				/* continuous curves based on approximation */
				/* to GB's original values */
	  FLOAT8 max_val_n = max_val / 32768;
	  FLOAT8 adj_lim_new;
				/* For an increase in approximate loudness, */
				/* set ATH adjust to adjust_limit immediately*/
				/* after a delay of one frame. */
				/* For a loudness decrease, reduce ATH adjust*/
				/* towards adjust_limit gradually. */
	  if( max_val_n &gt; 0.25) { /* sqrt((1 - 0.01) / 15.84) from curve below*/
	    if( gfc-&gt;ATH-&gt;adjust &gt;= 1.0) {
	      gfc-&gt;ATH-&gt;adjust = 1.0;
	    } else {		/* preceding frame has lower ATH adjust; */
				/* ascend only to the preceding adjust_limit */
				/* in case there is leading low volume */
	      if( gfc-&gt;ATH-&gt;adjust &lt; gfc-&gt;ATH-&gt;adjust_limit) {
		gfc-&gt;ATH-&gt;adjust = gfc-&gt;ATH-&gt;adjust_limit;
	      }
	    }
	    gfc-&gt;ATH-&gt;adjust_limit = 1.0;
	  } else {		/* adjustment curve (parabolic) */
	    adj_lim_new = 15.84 * (max_val_n * max_val_n) + 0.01;
	    if( gfc-&gt;ATH-&gt;adjust &gt;= adj_lim_new) { /* descend gradually */
	      gfc-&gt;ATH-&gt;adjust *= adj_lim_new * 0.075 + 0.925;
	      if( gfc-&gt;ATH-&gt;adjust &lt; adj_lim_new) { /* stop descent */
		gfc-&gt;ATH-&gt;adjust = adj_lim_new;
	      }
	    } else {		/* ascend */
	      if( gfc-&gt;ATH-&gt;adjust_limit &gt;= adj_lim_new) {
		gfc-&gt;ATH-&gt;adjust = adj_lim_new;
	      } else {		/* preceding frame has lower ATH adjust; */
				/* ascend only to the preceding adjust_limit */
		if( gfc-&gt;ATH-&gt;adjust &lt; gfc-&gt;ATH-&gt;adjust_limit) {
		  gfc-&gt;ATH-&gt;adjust = gfc-&gt;ATH-&gt;adjust_limit;
		}
	      }
	    }
	    gfc-&gt;ATH-&gt;adjust_limit = adj_lim_new;
	  }
#endif
        }
    }
}

/************************************************************************
*
* encodeframe()           Layer 3
*
* encode a single frame
*
************************************************************************
lame_encode_frame()


                       gr 0            gr 1
inbuf:           |--------------|---------------|-------------|
MDCT output:  |--------------|---------------|-------------|

FFT's                    &lt;---------1024----------&gt;
                                         &lt;---------1024--------&gt;



    inbuf = buffer of PCM data size=MP3 framesize
    encoder acts on inbuf[ch][0], but output is delayed by MDCTDELAY
    so the MDCT coefficints are from inbuf[ch][-MDCTDELAY]

    psy-model FFT has a 1 granule delay, so we feed it data for the 
    next granule.
    FFT is centered over granule:  224+576+224
    So FFT starts at:   576-224-MDCTDELAY

    MPEG2:  FFT ends at:  BLKSIZE+576-224-MDCTDELAY
    MPEG1:  FFT ends at:  BLKSIZE+2*576-224-MDCTDELAY    (1904)

    FFT starts at 576-224-MDCTDELAY (304)  = 576-FFTOFFSET

*/

typedef FLOAT8 chgrdata[2][2];

int  lame_encode_mp3_frame (				// Output
	lame_global_flags* const  gfp,			// Context
	sample_t*                 inbuf_l,              // Input
	sample_t*                 inbuf_r,              // Input
	unsigned char*            mp3buf, 		// Output
	int                    mp3buf_size )		// Output
{
#ifdef macintosh /* PLL 14/04/2000 */
  static FLOAT8 xr[2][2][576];
  static int l3_enc[2][2][576];
#else
  FLOAT8 xr[2][2][576];
  int l3_enc[2][2][576];
#endif
  int mp3count;
  III_psy_ratio masking_LR[2][2];    /*LR masking &amp; energy */
  III_psy_ratio masking_MS[2][2]; /*MS masking &amp; energy */
  III_psy_ratio (*masking)[2][2];  /*pointer to selected maskings*/
  III_scalefac_t scalefac[2][2];
  const sample_t *inbuf[2];
  lame_internal_flags *gfc=gfp-&gt;internal_flags;

  FLOAT8 tot_ener[2][4];   
  FLOAT8 ms_ener_ratio[2]={.5,.5};
  chgrdata pe,pe_MS;
  chgrdata *pe_use;

  int ch,gr,mean_bits;
  int bitsPerFrame;

  int check_ms_stereo;
  FLOAT8 ms_ratio_next = 0.;
  FLOAT8 ms_ratio_prev = 0.;


  memset((char *) masking_LR, 0, sizeof(masking_LR));
  memset((char *) masking_MS, 0, sizeof(masking_MS));
  memset((char *) scalefac, 0, sizeof(scalefac));
  inbuf[0]=inbuf_l;
  inbuf[1]=inbuf_r;

  check_ms_stereo =  (gfp-&gt;mode == JOINT_STEREO);
  gfc-&gt;mode_ext = MPG_MD_LR_LR;

  if (gfc-&gt;lame_encode_frame_init==0 )  {
    gfc-&gt;lame_encode_frame_init=1;
    
    /* padding method as described in 
     * "MPEG-Layer3 / Bitstream Syntax and Decoding"
     * by Martin Sieler, Ralph Sperschneider
     *
     * note: there is no padding for the very first frame
     *
     * Robert.Hegemann@gmx.de 2000-06-22
     */
        
    gfc-&gt;frac_SpF = ((gfp-&gt;version+1)*72000L*gfp-&gt;brate) % gfp-&gt;out_samplerate;
    gfc-&gt;slot_lag  = gfc-&gt;frac_SpF;
    
    /* check FFT will not use a negative starting offset */
#if 576 &lt; FFTOFFSET
# error FFTOFFSET greater than 576: FFT uses a negative offset
#endif
    /* check if we have enough data for FFT */
    assert(gfc-&gt;mf_size&gt;=(BLKSIZE+gfp-&gt;framesize-FFTOFFSET));
    /* check if we have enough data for polyphase filterbank */
    /* it needs 1152 samples + 286 samples ignored for one granule */
    /*          1152+576+286 samples for two granules */
    assert(gfc-&gt;mf_size&gt;=(286+576*(1+gfc-&gt;mode_gr)));

    /* prime the MDCT/polyphase filterbank with a short block */
    { 
      int i,j;
      sample_t primebuff0[286+1152+576];
      sample_t primebuff1[286+1152+576];
      for (i=0, j=0; i&lt;286+576*(1+gfc-&gt;mode_gr); ++i) {
	if (i&lt;576*gfc-&gt;mode_gr) {
	  primebuff0[i]=0;
	  if (gfc-&gt;channels_out==2) 
	    primebuff1[i]=0;
	}else{
	  primebuff0[i]=inbuf[0][j];
	  if (gfc-&gt;channels_out==2) 
	    primebuff1[i]=inbuf[1][j];
	  ++j;
	}
      }
      /* polyphase filtering / mdct */
      for ( gr = 0; gr &lt; gfc-&gt;mode_gr; gr++ ) {
	for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
	  gfc-&gt;l3_side.gr[gr].ch[ch].tt.block_type=SHORT_TYPE;
	}
      }
      mdct_sub48(gfc, primebuff0, primebuff1, xr);
    }
    
    iteration_init(gfp);
    
    /*  prepare for ATH auto adjustment:
     *  we want to decrease the ATH by 12 dB per second
     */ {
        FLOAT8 frame_duration = 576. * gfc-&gt;mode_gr / gfp-&gt;out_samplerate;
        gfc-&gt;ATH-&gt;decay = pow(10., -12./10. * frame_duration);
        gfc-&gt;ATH-&gt;adjust = 1.0;
        gfc-&gt;ATH-&gt;adjust_limit = 0.01;
    }
  }


  /********************** padding *****************************/
  switch (gfp-&gt;padding_type) {
  case 0:
    gfc-&gt;padding=0;
    break;
  case 1:
    gfc-&gt;padding=1;
    break;
  case 2:
  default:
    if (gfp-&gt;VBR!=vbr_off) {
      gfc-&gt;padding=0;
    } else {
      if (gfp-&gt;disable_reservoir) {
	gfc-&gt;padding = 0;
	/* if the user specified --nores, dont very gfc-&gt;padding either */
	/* tiny changes in frac_SpF rounding will cause file differences */
      }else{
        /* padding method as described in 
         * "MPEG-Layer3 / Bitstream Syntax and Decoding"
         * by Martin Sieler, Ralph Sperschneider
         *
         * note: there is no padding for the very first frame
         *
         * Robert.Hegemann@gmx.de 2000-06-22
         */

        gfc-&gt;slot_lag -= gfc-&gt;frac_SpF;
        if (gfc-&gt;slot_lag &lt; 0) {
          gfc-&gt;slot_lag += gfp-&gt;out_samplerate;
          gfc-&gt;padding = 1;
        } else {
          gfc-&gt;padding = 0;
        }
      } /* reservoir enabled */
    }
  }


  if (gfc-&gt;psymodel) {
    /* psychoacoustic model
     * psy model has a 1 granule (576) delay that we must compensate for
     * (mt 6/99).
     */
    int ret;
    const sample_t *bufp[2];  /* address of beginning of left &amp; right granule */
    int blocktype[2];

    ms_ratio_prev=gfc-&gt;ms_ratio[gfc-&gt;mode_gr-1];
    for (gr=0; gr &lt; gfc-&gt;mode_gr ; gr++) {

      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ )
	bufp[ch] = &amp;inbuf[ch][576 + gr*576-FFTOFFSET];

      if (gfc-&gt;nsPsy.use) {
	ret=L3psycho_anal_ns( gfp, bufp, gr, 
			      &amp;gfc-&gt;ms_ratio[gr],&amp;ms_ratio_next,
			      masking_LR, masking_MS,
			      pe[gr],pe_MS[gr],tot_ener[gr],blocktype);
      } else {
	ret=L3psycho_anal( gfp, bufp, gr, 
			   &amp;gfc-&gt;ms_ratio[gr],&amp;ms_ratio_next,
			   masking_LR, masking_MS,
			   pe[gr],pe_MS[gr],tot_ener[gr],blocktype);
      }
      if (ret!=0) return -4;

      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ )
	gfc-&gt;l3_side.gr[gr].ch[ch].tt.block_type=blocktype[ch];

      if (check_ms_stereo) {
	  ms_ener_ratio[gr] = tot_ener[gr][2]+tot_ener[gr][3];
	  if (ms_ener_ratio[gr]&gt;0)
	      ms_ener_ratio[gr] = tot_ener[gr][3]/ms_ener_ratio[gr];
      }

    }
  }else{
    for (gr=0; gr &lt; gfc-&gt;mode_gr ; gr++)
      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
	gfc-&gt;l3_side.gr[gr].ch[ch].tt.block_type=NORM_TYPE;
	pe_MS[gr][ch]=pe[gr][ch]=700;
      }
  }



  /* auto-adjust of ATH, useful for low volume */
  adjust_ATH( gfp, tot_ener );



  /* block type flags */
  for( gr = 0; gr &lt; gfc-&gt;mode_gr; gr++ ) {
    for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
      gr_info *cod_info = &amp;gfc-&gt;l3_side.gr[gr].ch[ch].tt;
      cod_info-&gt;mixed_block_flag = 0;     /* never used by this model */
      if (cod_info-&gt;block_type == NORM_TYPE )
	cod_info-&gt;window_switching_flag = 0;
      else
	cod_info-&gt;window_switching_flag = 1;
    }
  }


  /* polyphase filtering / mdct */
  mdct_sub48(gfc, inbuf[0], inbuf[1], xr);
  /* re-order the short blocks, for more efficient encoding below */
  for (gr = 0; gr &lt; gfc-&gt;mode_gr; gr++) {
    for (ch = 0; ch &lt; gfc-&gt;channels_out; ch++) {
      gr_info *cod_info = &amp;gfc-&gt;l3_side.gr[gr].ch[ch].tt;
      if (cod_info-&gt;block_type==SHORT_TYPE) {
	freorder(gfc-&gt;scalefac_band.s,xr[gr][ch]);
      }
    }
  }
  

  /* use m/s gfc-&gt;channels_out? */
  if (check_ms_stereo) {
    int gr0 = 0, gr1 = gfc-&gt;mode_gr-1;
    /* make sure block type is the same in each channel */
    check_ms_stereo =
      (gfc-&gt;l3_side.gr[gr0].ch[0].tt.block_type==gfc-&gt;l3_side.gr[gr0].ch[1].tt.block_type) &amp;&amp;
      (gfc-&gt;l3_side.gr[gr1].ch[0].tt.block_type==gfc-&gt;l3_side.gr[gr1].ch[1].tt.block_type);
  }
  
  /* Here will be selected MS or LR coding of the 2 stereo channels */

  assert (  gfc-&gt;mode_ext == MPG_MD_LR_LR );
  gfc-&gt;mode_ext = MPG_MD_LR_LR;
  
  if (gfp-&gt;force_ms) {
    gfc-&gt;mode_ext = MPG_MD_MS_LR;
  } else if (check_ms_stereo) {
      /* ms_ratio = is scaled, for historical reasons, to look like
	 a ratio of side_channel / total.  
         0 = signal is 100% mono
         .5 = L &amp; R uncorrelated
      */
      
      /* [0] and [1] are the results for the two granules in MPEG-1,
       * in MPEG-2 it's only a faked averaging of the same value
       * _prev is the value of the last granule of the previous frame
       * _next is the value of the first granule of the next frame
       */
      FLOAT8  ms_ratio_ave1;
      FLOAT8  ms_ratio_ave2;
      FLOAT8  threshold1    = 0.35;
      FLOAT8  threshold2    = 0.45;

      /* take an average */
      if (gfc-&gt;mode_gr==1) {
	  /* MPEG2 - no second granule */
	  ms_ratio_ave1 = 0.33 * ( gfc-&gt;ms_ratio[0] + ms_ratio_prev + ms_ratio_next );
	  ms_ratio_ave2 = gfc-&gt;ms_ratio[0];
      }else{
	  ms_ratio_ave1 = 0.25 * ( gfc-&gt;ms_ratio[0] + gfc-&gt;ms_ratio[1] + ms_ratio_prev + ms_ratio_next );
	  ms_ratio_ave2 = 0.50 * ( gfc-&gt;ms_ratio[0] + gfc-&gt;ms_ratio[1] );
      }
      
      if (gfp-&gt;mode_automs) {
	  if ( gfp-&gt;compression_ratio &lt; 11.025 ) {
	      /* 11.025 =&gt; 1, 6.3 =&gt; 0 */
	      double thr = (gfp-&gt;compression_ratio - 6.3) / (11.025 - 6.3);
	      if (thr&lt;0) thr=0;
	      threshold1   *= thr;
	      threshold2   *= thr;
	  }
      }
      
      if ((ms_ratio_ave1 &lt; threshold1  &amp;&amp;  ms_ratio_ave2 &lt; threshold2) || gfc-&gt;nsPsy.use) {
	  int  sum_pe_MS = pe_MS[0][0] + pe_MS[0][1] + pe_MS[1][0] + pe_MS[1][1];
	  int  sum_pe_LR = pe   [0][0] + pe   [0][1] + pe   [1][0] + pe   [1][1];
	  
	  /* based on PE: M/S coding would not use much more bits than L/R coding */
	  
	  if (sum_pe_MS &lt;= 1.07 * sum_pe_LR &amp;&amp; !gfc-&gt;nsPsy.use) gfc-&gt;mode_ext = MPG_MD_MS_LR;
	  if (sum_pe_MS &lt;= 1.00 * sum_pe_LR &amp;&amp;  gfc-&gt;nsPsy.use) gfc-&gt;mode_ext = MPG_MD_MS_LR;
      }
  }


  /* copy data for MP3 frame analyzer */
  if (gfp-&gt;analysis &amp;&amp; gfc-&gt;pinfo != NULL) {
    for ( gr = 0; gr &lt; gfc-&gt;mode_gr; gr++ ) {
      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
	gfc-&gt;pinfo-&gt;ms_ratio[gr]=gfc-&gt;ms_ratio[gr];
	gfc-&gt;pinfo-&gt;ms_ener_ratio[gr]=ms_ener_ratio[gr];
	gfc-&gt;pinfo-&gt;blocktype[gr][ch]=
	  gfc-&gt;l3_side.gr[gr].ch[ch].tt.block_type;
	memcpy(gfc-&gt;pinfo-&gt;xr[gr][ch],xr[gr][ch],sizeof(xr[gr][ch]));
	/* in psymodel, LR and MS data was stored in pinfo.  
	   switch to MS data: */
	if (gfc-&gt;mode_ext==MPG_MD_MS_LR) {
	  gfc-&gt;pinfo-&gt;pe[gr][ch]=gfc-&gt;pinfo-&gt;pe[gr][ch+2];
	  gfc-&gt;pinfo-&gt;ers[gr][ch]=gfc-&gt;pinfo-&gt;ers[gr][ch+2];
	  memcpy(gfc-&gt;pinfo-&gt;energy[gr][ch],gfc-&gt;pinfo-&gt;energy[gr][ch+2],
		 sizeof(gfc-&gt;pinfo-&gt;energy[gr][ch]));
	}
      }
    }
  }




  /* bit and noise allocation */
  if (MPG_MD_MS_LR == gfc-&gt;mode_ext) {
    masking = &amp;masking_MS;    /* use MS masking */
    pe_use = &amp;pe_MS;
  } else {
    masking = &amp;masking_LR;    /* use LR masking */
    pe_use = &amp;pe;
  }


  if (gfc-&gt;nsPsy.use &amp;&amp; (gfp-&gt;VBR == vbr_off || gfp-&gt;VBR == vbr_abr)) {
    static FLOAT fircoef[19] = {
      -0.0207887,-0.0378413,-0.0432472,-0.031183,
      7.79609e-18,0.0467745,0.10091,0.151365,
      0.187098,0.2,0.187098,0.151365,
      0.10091,0.0467745,7.79609e-18,-0.031183,
      -0.0432472,-0.0378413,-0.0207887,
    };
    int i;
    FLOAT8 f;

    for(i=0;i&lt;18;i++) gfc-&gt;nsPsy.pefirbuf[i] = gfc-&gt;nsPsy.pefirbuf[i+1];

    i=0;
    gfc-&gt;nsPsy.pefirbuf[18] = 0;
    for ( gr = 0; gr &lt; gfc-&gt;mode_gr; gr++ ) {
      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
	gfc-&gt;nsPsy.pefirbuf[18] += (*pe_use)[gr][ch];
	i++;
      }
    }

    gfc-&gt;nsPsy.pefirbuf[18] = gfc-&gt;nsPsy.pefirbuf[18] / i;
    f = 0;
    for(i=0;i&lt;19;i++) f += gfc-&gt;nsPsy.pefirbuf[i] * fircoef[i];

    for ( gr = 0; gr &lt; gfc-&gt;mode_gr; gr++ ) {
      for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
	(*pe_use)[gr][ch] *= 670 / f;
      }
    }
  }

  switch (gfp-&gt;VBR){ 
  default:
  case vbr_off:
    iteration_loop( gfp,*pe_use,ms_ener_ratio, xr, *masking, l3_enc, scalefac);
    break;
  case vbr_mt:
    VBR_quantize( gfp,*pe_use,ms_ener_ratio, xr, *masking, l3_enc, scalefac);
    break;
  case vbr_rh:
  case vbr_mtrh:
    VBR_iteration_loop( gfp,*pe_use,ms_ener_ratio, xr, *masking, l3_enc, scalefac);
    break;
  case vbr_abr:
    ABR_iteration_loop( gfp,*pe_use,ms_ener_ratio, xr, *masking, l3_enc, scalefac);
    break;
  }

  /*  write the frame to the bitstream  */
  getframebits(gfp, &amp;bitsPerFrame, &amp;mean_bits);

  format_bitstream( gfp, bitsPerFrame, l3_enc, scalefac);

  /* copy mp3 bit buffer into array */
  mp3count = copy_buffer(mp3buf,mp3buf_size,&amp;gfc-&gt;bs);

  if (gfp-&gt;bWriteVbrTag) AddVbrFrame(gfp);


  /* copy data for MP3 frame analyzer */
  if (gfp-&gt;analysis &amp;&amp; gfc-&gt;pinfo != NULL) {
    int j;
    for ( ch = 0; ch &lt; gfc-&gt;channels_out; ch++ ) {
      for ( j = 0; j &lt; FFTOFFSET; j++ )
	gfc-&gt;pinfo-&gt;pcmdata[ch][j] = gfc-&gt;pinfo-&gt;pcmdata[ch][j+gfp-&gt;framesize];
      for ( j = FFTOFFSET; j &lt; 1600; j++ ) {
	gfc-&gt;pinfo-&gt;pcmdata[ch][j] = inbuf[ch][j-FFTOFFSET];
      }
    }
    set_frame_pinfo (gfp, xr, *masking, l3_enc, scalefac);
  }
  
  updateStats( gfc );

  return mp3count;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

