<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/jukebox/music.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/jukebox/music.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;draw.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;mouse.h&gt;
#include &lt;control.h&gt;
#include "colors.h"
#include "client.h"
#include "playlist.h"
#include "../debug.h"

enum {
	STACKSIZE = 2048 * sizeof(void*),
};

int	debug = 0; //DBGSERVER|DBGPUMP|DBGSTATE|DBGPICKLE|DBGPLAY;

char	usage[] = "Usage: %s [-d mask] [-t] [-w]\n";

typedef struct But {
	char	*name;
	Control	*ctl;
} But;

typedef struct Simpleitem {
	char	*address;
	char	*data;
} Simpleitem;

typedef struct Multiitem {
	char	*address;
	int	ndata;
	char	**data;
} Multiitem;

enum {
	WinBrowse,
	WinPlay,
	WinPlaylist,
	WinError,
	Topselect = 0x7fffffff,

	Browsedepth = 63,
};

typedef enum {
	PlayIdle,
	PlayStart,
	Playing,
	PlayPause,
} Playstate;

typedef enum {
	User,
	Troot,
	Rroot,
	Tchildren,
	Rchildren,
	Tparent,
	Rparent,
	Tinfo,
	Rinfo,
	Tparentage,
	Rparentage,
	Tplay,
	Rplay,
} Srvstate;

enum {
	Exitbutton,
	Pausebutton,
	Playbutton,
	Stopbutton,
	Prevbutton,
	Nextbutton,
	Rootbutton,
	Deletebutton,
	Helpbutton,
	Volume,
	Browsetopwin,
	Browsebotwin,
	Browsebotscr,
	Playevent,
	Playlistwin,
	Nalt,
};

But buts[] = {
	[Exitbutton] =		{"skull", nil},
	[Pausebutton] =		{"pause", nil},
	[Playbutton] =		{"play", nil},
	[Stopbutton] =		{"stop", nil},
	[Prevbutton] =		{"prev", nil},
	[Nextbutton] =		{"next", nil},
	[Rootbutton] =		{"root", nil},
	[Deletebutton] =	{"trash", nil},
	[Helpbutton] =		{"question", nil},
};

struct tab {
	char *tabname;
	char *winname;
	Control *tab;
	Control *win;
} tabs[4] = {
	[WinBrowse] =	{"Browse",	"browsewin",	nil, nil},
	[WinPlay] =	{"Playing",	"playwin",	nil, nil},
	[WinPlaylist] =	{"Playlist",	"listwin",	nil, nil},
	[WinError] =	{"Errors",	"errorwin",	nil, nil},
};

char *helptext[] = {
	"Buttons, left to right:",
	"    Exit: exit jukebox",
	"    Pause: pause/resume playback",
	"    Play: play selection in Playlist",
	"    Stop: stop playback",
	"    Prev: play previous item in Playlist",
	"    Next: play next item in Playlist",
	"    Root: browse to root of database tree",
	"    Delete: empty Playlist, reread database",
	"    Help: show this window",
	"",
	"Browse window: (click tab to bring forward)",
	"  Top window displays current item",
	"  Bottom window displays selectable subitems",
	"  Mouse commands:",
	"    Left: selected subitem becomes current",
	"    Right: parent of current item becomes current",
	"    Middle: add item or subitem to Playlist",
	"",
	"Playing window",
	"  Displays item currently playing",
	"",
	"Playlist window",
	"  Displays contents of Playlist",
	"  Mouse commands:",
	"    Left: select item",
	"    (then click the play button)",
	"",
	"Error window",
	"  Displays error messages received from player",
	"  (e.g., can't open file)",
	nil,
};

struct Browsestack {
	char	*onum;
	int	scrollpos;
} browsestack[Browsedepth];
int browsesp;	/* browse stack pointer */
int browseline;	/* current browse position */

Control		*vol;
Control		*browsetopwin;
Control		*browsebotwin;
Control		*playlistwin;
Control		*errortext;
Control		*browsetopscr;
Control		*browsebotscr;

Playstate	playstate;

ulong		playingbuts = 1&lt;&lt;Pausebutton | 1&lt;&lt;Stopbutton | 1&lt;&lt;Prevbutton | 1&lt;&lt;Nextbutton;
ulong		activebuts;

int		tabht;
Image		*vol1img;
Image		*vol2img;

int		resizeready;
int		borderwidth = 1;
int		butht, butwid;
int		errorlines;

int		tflag;
int		pflag;

Controlset	*cs;

char		*root;
Multiitem	parent;
Simpleitem	children[2048];
int		nchildren;

int		selected;

Channel		*playevent;

void
readbuts(void)
{
	static char str[32], file[64];
	But *b;
	int fd;
	Image *img, *mask;

	for(b = buts; b &lt; &amp;buts[nelem(buts)]; b++){
		sprint(file, "%s/%s.bit", ICONPATH, b-&gt;name);
		if((fd = open(file, OREAD)) &lt; 0)
			sysfatal("open: %s: %r", file);
		mask = readimage(display, fd, 0);
		close(fd);
		butwid = Dx(mask-&gt;r);
		butht = Dy(mask-&gt;r);
		b-&gt;ctl = createbutton(cs, b-&gt;name);
		chanprint(cs-&gt;ctl, "%q align center", b-&gt;name);
		chanprint(cs-&gt;ctl, "%q border 0", b-&gt;name);

		img = allocimage(display, mask-&gt;r, screen-&gt;chan, 0, 0xe0e0ffff);
		draw(img, img-&gt;r, darkgreen, mask, mask-&gt;r.min);
		sprint(str, "%s.active", b-&gt;name);
		namectlimage(img, str);

		img = allocimage(display, mask-&gt;r, screen-&gt;chan, 0, 0xe0e0ffff);
		draw(img, img-&gt;r, lightblue, mask, mask-&gt;r.min);
		sprint(str, "%s.passive", b-&gt;name);
		namectlimage(img, str);

		chanprint(cs-&gt;ctl, "%q image %q", b-&gt;name, str);
		sprint(str, "%s.mask", b-&gt;name);
		namectlimage(mask, str);
		chanprint(cs-&gt;ctl, "%q mask %q", b-&gt;name, str);
		chanprint(cs-&gt;ctl, "%q light red", b-&gt;name);
		chanprint(cs-&gt;ctl, "%q size %d %d %d %d", b-&gt;name, butwid, butht, butwid, butht);
	}
}

void
activatebuttons(ulong mask)
{	// mask bit i corresponds to buts[i];
	ulong bit;
	But *b;
	static char str[40];
	int i;

	for(i = 0; i &lt; nelem(buts); i++){
		b = &amp;buts[i];
		bit = 1 &lt;&lt; i;
		if((mask &amp; bit) &amp;&amp; (activebuts &amp; bit) == 0){
			// button was `deactive'
			activate(b-&gt;ctl);
			activebuts |= bit;
			sprint(str, "%s.active", b-&gt;name);
			chanprint(cs-&gt;ctl, "%q image %q", b-&gt;name, str);
			chanprint(cs-&gt;ctl, "%q show", b-&gt;name);
		}
	}
}

void
deactivatebuttons(ulong mask)
{	// mask bit i corresponds with buts[i];
	ulong bit;
	But *b;
	static char str[40];
	int i;

	for(i = 0; i &lt; nelem(buts); i++){
		b = &amp;buts[i];
		bit = 1 &lt;&lt; i;
		if((mask &amp; bit) &amp;&amp; (activebuts &amp; bit)){
			// button was active
			deactivate(b-&gt;ctl);
			activebuts &amp;= ~bit;
			sprint(str, "%s.passive", b-&gt;name);
			chanprint(cs-&gt;ctl, "%q image %q", b-&gt;name, str);
			chanprint(cs-&gt;ctl, "%q show", b-&gt;name);
		}
	}
}

void
resizecontrolset(Controlset *){
	static Point pol[3];
	char *p;

	if(getwindow(display, Refbackup) &lt; 0)
		sysfatal("getwindow");
	draw(screen, screen-&gt;r, bordercolor, nil, screen-&gt;r.min);
	if(!resizeready)
		return;
#ifndef REPLACESEMANTICS
	if(vol1img)
		chanprint(cs-&gt;ctl, "volume image darkgreen");
	if(vol2img)
		chanprint(cs-&gt;ctl, "volume indicatorcolor red");
	chanprint(cs-&gt;ctl, "wholewin size");
	chanprint(cs-&gt;ctl, "wholewin rect %R", screen-&gt;r);

	chanprint(cs-&gt;ctl, "sync");
	p = recvp(cs-&gt;data);
	if(strcmp(p, "sync"))
		sysfatal("huh?");
	free(p);

	if(vol1img){
		freectlimage("volume.img");
		freeimage(vol1img);
	}
	if(vol2img){
		freectlimage("indicator.img");
		freeimage(vol2img);
	}
	vol1img = allocimage(display, vol-&gt;rect, screen-&gt;chan, 0, 0xe0e0ffff);
	vol2img = allocimage(display, vol-&gt;rect, screen-&gt;chan, 0, 0xe0e0ffff);
	pol[0] = Pt(vol-&gt;rect.min.x, vol-&gt;rect.max.y);
	pol[1] = Pt(vol-&gt;rect.max.x, vol-&gt;rect.min.y);
	pol[2] = vol-&gt;rect.max;
	fillpoly(vol1img, pol, 3, 0, darkgreen, ZP);
	fillpoly(vol2img, pol, 3, 0, red, ZP);
	namectlimage(vol1img, "volume.img");
	namectlimage(vol2img, "indicator.img");
	chanprint(cs-&gt;ctl, "volume image volume.img");
	chanprint(cs-&gt;ctl, "volume indicatorcolor indicator.img");
#else
	chanprint(cs-&gt;ctl, "wholewin size");
	chanprint(cs-&gt;ctl, "wholewin rect %R", screen-&gt;r);

	chanprint(cs-&gt;ctl, "sync");
	p = recvp(cs-&gt;data);
	if(strcmp(p, "sync"))
		sysfatal("huh?");
	free(p);

	new1img = allocimage(display, vol-&gt;rect, screen-&gt;chan, 0, 0xe0e0ffff);
	new2img = allocimage(display, vol-&gt;rect, screen-&gt;chan, 0, 0xe0e0ffff);
	pol[0] = Pt(vol-&gt;rect.min.x, vol-&gt;rect.max.y);
	pol[1] = Pt(vol-&gt;rect.max.x, vol-&gt;rect.min.y);
	pol[2] = vol-&gt;rect.max;
	fillpoly(new1img, pol, 3, 0, darkgreen, ZP);
	fillpoly(new2img, pol, 3, 0, red, ZP);
	namectlimage(new1img, "volume.img");
	namectlimage(new2img, "indicator.img");
	if(vol1img)
		freeimage(vol1img);
	else
		chanprint(cs-&gt;ctl, "volume image volume.img");
	if(vol2img)
		freeimage(vol2img);
	else
		chanprint(cs-&gt;ctl, "volume indicatorcolor indicator.img");
	vol1img = new1img;
	vol2img = new2img;
#endif
	chanprint(cs-&gt;ctl, "browsetopscr vis '%d'",
		Dy(controlcalled("browsetopscr")-&gt;rect)/romanfont-&gt;height);
	chanprint(cs-&gt;ctl, "browsebotscr vis '%d'",
		Dy(controlcalled("browsebotscr")-&gt;rect)/romanfont-&gt;height);
	chanprint(cs-&gt;ctl, "playscr vis '%d'",
		Dy(controlcalled("playscr")-&gt;rect)/romanfont-&gt;height);
	chanprint(cs-&gt;ctl, "playlistscr vis '%d'",
		Dy(controlcalled("playlistscr")-&gt;rect)/romanfont-&gt;height);
	chanprint(cs-&gt;ctl, "wholewin show");
}

void
maketab(void)
{
	int i;

	tabht = boldfont-&gt;height + 1 + borderwidth;

	createtab(cs, "tabs");

	for(i = 0; i &lt; nelem(tabs); i++){
		tabs[i].tab = createtextbutton(cs, tabs[i].tabname);
		chanprint(cs-&gt;ctl, "%q size %d %d %d %d", tabs[i].tab-&gt;name,
			stringwidth(boldfont, tabs[i].tabname), tabht, 1024, tabht);
		chanprint(cs-&gt;ctl, "%q align uppercenter", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q font boldfont", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q image background", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q light background", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q pressedtextcolor red", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q textcolor darkgreen", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q mask transparent", tabs[i].tab-&gt;name);
		chanprint(cs-&gt;ctl, "%q text %q", tabs[i].tab-&gt;name, tabs[i].tabname);

		chanprint(cs-&gt;ctl, "tabs add %s %s", tabs[i].tabname, tabs[i].winname);
	}

	chanprint(cs-&gt;ctl, "tabs separation %d", 2);
	chanprint(cs-&gt;ctl, "tabs image background");
	chanprint(cs-&gt;ctl, "tabs value 0");
}

void
makeplaycontrols(void)
{
	int w;
	Control *playscr;

	w = stringwidth(romanfont, "Roll over Beethoven");
	playscr = createslider(cs, "playscr");
	chanprint(cs-&gt;ctl, "playscr size 12, 24, 12, 1024");
	createtext(cs, "playtext");
	chanprint(cs-&gt;ctl, "playtext size %d %d %d %d",
		w, 5*romanfont-&gt;height, 2048, 1024);

	chanprint(cs-&gt;ctl, "playscr format '%%s: playtext topline %%d'");
	controlwire(playscr, "event", cs-&gt;ctl);

	tabs[WinPlay].win = createrow(cs, tabs[WinPlay].winname);
	chanprint(cs-&gt;ctl, "%q add playscr playtext", tabs[WinPlay].win-&gt;name);
}

void
makebrowsecontrols(void)
{
	int w;

	w = stringwidth(romanfont, "Roll over Beethoven");
	browsetopscr = createslider(cs, "browsetopscr");
	chanprint(cs-&gt;ctl, "browsetopscr size 12, 24, 12, %d", 12*romanfont-&gt;height);
	browsetopwin = createtext(cs, "browsetopwin");
	chanprint(cs-&gt;ctl, "browsetopwin size %d %d %d %d",
		w, 3*romanfont-&gt;height, 2048, 12*romanfont-&gt;height);
	createrow(cs, "browsetop");
	chanprint(cs-&gt;ctl, "browsetop add browsetopscr browsetopwin");

	browsebotscr = createslider(cs, "browsebotscr");
	chanprint(cs-&gt;ctl, "browsebotscr size 12, 24, 12, 1024");
	browsebotwin = createtext(cs, "browsebotwin");
	chanprint(cs-&gt;ctl, "browsebotwin size %d %d %d %d",
		w, 3*romanfont-&gt;height, 2048, 1024);
	createrow(cs, "browsebot");
	chanprint(cs-&gt;ctl, "browsebot add browsebotscr browsebotwin");

	chanprint(cs-&gt;ctl, "browsetopscr format '%%s: browsetopwin topline %%d'");
	controlwire(browsetopscr, "event", cs-&gt;ctl);
//	chanprint(cs-&gt;ctl, "browsebotscr format '%%s: browsebotwin topline %%d'");
//	controlwire(browsebotscr, "event", cs-&gt;ctl);

	tabs[WinBrowse].win = createcolumn(cs, tabs[WinBrowse].winname);
	chanprint(cs-&gt;ctl, "%q add browsetop browsebot", tabs[WinBrowse].win-&gt;name);
}

void
makeplaylistcontrols(void)
{
	int w;
	Control *playlistscr;

	w = stringwidth(romanfont, "Roll over Beethoven");
	playlistscr = createslider(cs, "playlistscr");
	chanprint(cs-&gt;ctl, "playlistscr size 12, 24, 12, 1024");
	playlistwin = createtext(cs, "playlistwin");
	chanprint(cs-&gt;ctl, "playlistwin size %d %d %d %d",
		w, 5*romanfont-&gt;height, 2048, 1024);
//	chanprint(cs-&gt;ctl, "playlistwin selectmode multi");

	chanprint(cs-&gt;ctl, "playlistscr format '%%s: playlistwin topline %%d'");
	controlwire(playlistscr, "event", cs-&gt;ctl);

	tabs[WinPlaylist].win = createrow(cs, tabs[WinPlaylist].winname);
	chanprint(cs-&gt;ctl, "%q add playlistscr playlistwin", tabs[WinPlaylist].win-&gt;name);
}

void
makeerrorcontrols(void)
{
	int w;
	Control *errorscr;

	w = stringwidth(romanfont, "Roll over Beethoven");
	errorscr = createslider(cs, "errorscr");
	chanprint(cs-&gt;ctl, "errorscr size 12, 24, 12, 1024");
	errortext = createtext(cs, "errortext");
	chanprint(cs-&gt;ctl, "errortext size %d %d %d %d",
		w, 5*romanfont-&gt;height, 2048, 1024);
	chanprint(cs-&gt;ctl, "errortext selectmode multi");

	chanprint(cs-&gt;ctl, "errorscr format '%%s: errortext topline %%d'");
	controlwire(errorscr, "event", cs-&gt;ctl);

	tabs[WinError].win = createrow(cs, tabs[WinError].winname);
	chanprint(cs-&gt;ctl, "%q add errorscr errortext", tabs[WinError].win-&gt;name);
}

void
makecontrols(void)
{
	int i;

	cs = newcontrolset(screen, nil, nil, nil);

	// make shared buttons
	readbuts();

	vol = createslider(cs, "volume");
	chanprint(cs-&gt;ctl, "volume size %d %d %d %d", 2*butwid, butht, 2048, butht);
	chanprint(cs-&gt;ctl, "volume absolute 1");
	chanprint(cs-&gt;ctl, "volume indicatorcolor red");
	chanprint(cs-&gt;ctl, "volume max 100");
	chanprint(cs-&gt;ctl, "volume orient hor");
	chanprint(cs-&gt;ctl, "volume clamp low 1");
	chanprint(cs-&gt;ctl, "volume clamp high 0");
	chanprint(cs-&gt;ctl, "volume format '%%s volume %%d'");

	createrow(cs, "buttonrow");
	for(i = 0; i &lt; nelem(buts); i++)
		chanprint(cs-&gt;ctl, "buttonrow add %s", buts[i].name);
	chanprint(cs-&gt;ctl, "buttonrow add volume");
	chanprint(cs-&gt;ctl, "buttonrow separation %d", borderwidth);
	chanprint(cs-&gt;ctl, "buttonrow image darkgreen");

	makebrowsecontrols();
	makeplaycontrols();
	makeplaylistcontrols();
	makeerrorcontrols();

	maketab();

	chanprint(cs-&gt;ctl, "%q image background", "text slider");
	chanprint(cs-&gt;ctl, "text font romanfont");
	chanprint(cs-&gt;ctl, "slider indicatorcolor darkgreen");
	chanprint(cs-&gt;ctl, "row separation %d", borderwidth);
	chanprint(cs-&gt;ctl, "row image darkgreen");
	chanprint(cs-&gt;ctl, "column separation %d", 2);
	chanprint(cs-&gt;ctl, "column image darkgreen");

	createcolumn(cs, "wholewin");
	chanprint(cs-&gt;ctl, "wholewin separation %d", borderwidth);
	chanprint(cs-&gt;ctl, "wholewin add buttonrow tabs");
	chanprint(cs-&gt;ctl, "wholewin image darkgreen");
	chanprint(cs-&gt;ctl, "%q image darkgreen", "column row");
}

void
makewindow(int dx, int dy, int wflag){
	int mountfd, fd, n;
	static char aname[128];
	static char rio[128] = "/mnt/term";
	char *args[6];

	if(wflag){
		/* find out screen size */
		fd = open("/mnt/wsys/screen", OREAD);
		if(fd &gt;= 0 &amp;&amp; read(fd, aname, 60) == 60){
			aname[60] = '\0';
			n = tokenize(aname, args, nelem(args));
			if(n != 5)
				fprint(2, "Not an image: /mnt/wsys/screen\n");
			else{
				n = atoi(args[3]) - atoi(args[1]);
				if(n &lt;= 0 || n &gt; 2048)
					fprint(2, "/mnt/wsys/screen very wide: %d\n", n);
				else
					if(n &lt; dx) dx = n-1;
				n = atoi(args[4]) - atoi(args[2]);
				if(n &lt;= 0 || n &gt; 2048)
					fprint(2, "/mnt/wsys/screen very high: %d\n", n);
				else
					if(n &lt; dy) dy = n-1;
			}
			close(fd);
		}
		n = 0;
		if((fd = open("/env/wsys", OREAD)) &lt; 0){
			n = strlen(rio);
			fd = open("/mnt/term/env/wsys", OREAD);
			if(fd &lt; 0)
				sysfatal("/env/wsys");
		}
		if(read(fd, rio+n, sizeof(rio)-n-1) &lt;= 0)
			sysfatal("/env/wsys");
		mountfd = open(rio, ORDWR);
		if(mountfd &lt; 0)
			sysfatal("open %s: %r", rio);
		snprint(aname, sizeof aname, "new -dx %d -dy %d", dx, dy);
		rfork(RFNAMEG);
		if(mount(mountfd, -1, "/mnt/wsys", MREPL, aname) &lt; 0)
			sysfatal("mount: %r");
		if(bind("/mnt/wsys", "/dev", MBEFORE) &lt; 0)
			sysfatal("mount: %r");
	}

	if(initdraw(nil, nil, "music") &lt; 0)
		sysfatal("initdraw: %r");

	initcontrols();
	if(dx &lt;= 320)
		colorinit("/lib/font/bit/lucidasans/unicode.6.font",
			"/lib/font/bit/lucidasans/boldunicode.8.font");
	else
		colorinit("/lib/font/bit/lucidasans/unicode.8.font",
			"/lib/font/bit/lucidasans/boldunicode.10.font");
	makecontrols();
	resizeready = 1;

	resizecontrolset(cs);
	if(debug &amp; DBGCONTROL)
		fprint(2, "resize done\n");
}

void
setparent(char *addr)
{
	int i;

	if(parent.address)
		free(parent.address);
	parent.address = strdup(addr);
	for(i = 0; i &lt; parent.ndata; i++)
		if(parent.data[i])
			free(parent.data[i]);
	parent.ndata = 0;
	if(parent.data){
		free(parent.data);
		parent.data = nil;
	}
	chanprint(cs-&gt;ctl, "browsetopwin clear");
	chanprint(cs-&gt;ctl, "browsetopscr max 0");
	chanprint(cs-&gt;ctl, "browsetopscr value 0");
}

void
addparent(char *str)
{
	parent.data = realloc(parent.data, (parent.ndata+1)*sizeof(char*));
	parent.data[parent.ndata] = strdup(str);
	parent.ndata++;
	chanprint(cs-&gt;ctl, "browsetopwin accumulate %q", str);
	chanprint(cs-&gt;ctl, "browsetopscr max %d", parent.ndata);
}

void
clearchildren(void)
{
	int i;

	for(i = 0; i &lt; nchildren; i++){
		if(children[i].address)
			free(children[i].address);
		if(children[i].data)
			free(children[i].data);
	}
	nchildren= 0;
	chanprint(cs-&gt;ctl, "browsebotwin clear");
	chanprint(cs-&gt;ctl, "browsebotwin topline 0");
	chanprint(cs-&gt;ctl, "browsebotscr max 0");
	chanprint(cs-&gt;ctl, "browsebotscr value 0");
	selected = -1;
}

void
addchild(char *addr, char *data)
{
	children[nchildren].address = addr;
	children[nchildren].data = data;
	nchildren++;
	chanprint(cs-&gt;ctl, "browsebotwin accumulate %q", data);
	chanprint(cs-&gt;ctl, "browsebotscr max %d", nchildren);
}

static void
playlistselect(int n)
{
	if(playlist.selected &gt;= 0 &amp;&amp; playlist.selected &lt; playlist.nentries){
		chanprint(cs-&gt;ctl, "playlistwin select %d 0", playlist.selected);
		deactivatebuttons(1&lt;&lt;Playbutton);
	}
	playlist.selected = n;
	if(playlist.selected &lt; 0 || playlist.selected &gt;= playlist.nentries)
		return;
	activatebuttons(1&lt;&lt;Playbutton);
	chanprint(cs-&gt;ctl, "playlistwin select %d 1", n);
	if(n &gt;= 0 &amp;&amp; n &lt;= playlist.nentries - Dy(playlistwin-&gt;rect)/romanfont-&gt;height)
		n--;
	else
		n = playlist.nentries - Dy(playlistwin-&gt;rect)/romanfont-&gt;height + 1;
	if(n &lt; 0) n = 0;
	if(n &lt; playlist.nentries){
		chanprint(cs-&gt;ctl, "playlistwin topline %d",  n);
		chanprint(cs-&gt;ctl, "playlistscr value %d",  n);
	}
	chanprint(cs-&gt;ctl, "playlist show");
}

void
updateplaylist(int trunc)
{
	char *s;
	int fd;

	while(cs-&gt;ctl-&gt;s - cs-&gt;ctl-&gt;n &lt; cs-&gt;ctl-&gt;s/4)
		sleep(100);
	if(trunc){
		playlistselect(-1);
		chanprint(cs-&gt;ctl, "playlistwin clear");
		chanprint(cs-&gt;ctl, "playlistwin topline 0");
		chanprint(cs-&gt;ctl, "playlistscr max 0");
		chanprint(cs-&gt;ctl, "playlistscr value 0");
		deactivatebuttons(1&lt;&lt;Playbutton | 1&lt;&lt;Deletebutton);
		chanprint(cs-&gt;ctl, "playlistwin show");
		chanprint(cs-&gt;ctl, "playlistscr show");
		s = smprint("%s/ctl", srvmount);
		if((fd = open(s, OWRITE)) &gt;= 0){
			fprint(fd, "reread");
			close(fd);
		}
		free(s);
		return;
	}
	if(playlist.entry[playlist.nentries].onum){
		s = getoneliner(playlist.entry[playlist.nentries].onum);
		chanprint(cs-&gt;ctl, "playlistwin accumulate %q", s);
		free(s);
	}else
		chanprint(cs-&gt;ctl, "playlistwin accumulate %q", playlist.entry[playlist.nentries].file);
	playlist.nentries++;
	chanprint(cs-&gt;ctl, "playlistscr max %d", playlist.nentries);
	if(playlist.selected == playlist.nentries - 1)
		playlistselect(playlist.selected);
	activatebuttons(1&lt;&lt;Playbutton|1&lt;&lt;Deletebutton);
	chanprint(cs-&gt;ctl, "playlistscr show");
	chanprint(cs-&gt;ctl, "playlistwin show");
}

void
browseto(char *onum, int line)
{
	onum = strdup(onum);
	setparent(onum);
	clearchildren();
	fillbrowsetop(onum);
	chanprint(cs-&gt;ctl, "browsetop show");
	fillbrowsebot(onum);
	if(line){
		chanprint(cs-&gt;ctl, "browsebotscr value %d", line);
		chanprint(cs-&gt;ctl, "browsebotwin topline %d", line);
	}
	chanprint(cs-&gt;ctl, "browsebot show");
	free(onum);
}

void
browsedown(char *onum)
{
	if(browsesp == 0){
		/* Make room for an entry by deleting the last */
		free(browsestack[Browsedepth-1].onum);
		memmove(browsestack + 1, browsestack, (Browsedepth-1) * sizeof(browsestack[0]));
		browsesp++;
	}
	/* Store current position in current stack frame */
	assert(browsesp &gt; 0 &amp;&amp; browsesp &lt; Browsedepth);
	browsestack[browsesp].onum = strdup(parent.address);
	browsestack[browsesp].scrollpos = browseline;
	browsesp--;
	browseline = 0;
	if(browsestack[browsesp].onum &amp;&amp; strcmp(browsestack[browsesp].onum, onum) == 0)
		browseline = browsestack[browsesp].scrollpos;
	browseto(onum, browseline);
}

void
browseup(char *onum)
{
	if(browsesp == Browsedepth){
		/* Make room for an entry by deleting the first */
		free(browsestack[0].onum);
		memmove(browsestack, browsestack + 1, browsesp * sizeof(browsestack[0]));
		browsesp--;
	}
	/* Store current position in current stack frame */
	assert(browsesp &gt;= 0 &amp;&amp; browsesp &lt; Browsedepth);
	browsestack[browsesp].onum = strdup(parent.address);
	browsestack[browsesp].scrollpos = browseline;
	browsesp++;
	browseline = 0;
	if(browsestack[browsesp].onum &amp;&amp; strcmp(browsestack[browsesp].onum, onum) == 0)
		browseline = browsestack[browsesp].scrollpos;
	browseto(onum, browseline);
}

void
addplaytext(char *s)
{
	chanprint(cs-&gt;ctl, "playtext accumulate %q", s);
}

void
work(void)
{
	static char *eventstr, *args[64], *s;
	static char buf[4096];
	int a, n, i;
	Alt alts[] = {
	[Exitbutton] =		{buts[Exitbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Pausebutton] =		{buts[Pausebutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Playbutton] =		{buts[Playbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Stopbutton] =		{buts[Stopbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Prevbutton] =		{buts[Prevbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Nextbutton] =		{buts[Nextbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Rootbutton] =		{buts[Rootbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Deletebutton] =	{buts[Deletebutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Helpbutton] =		{buts[Helpbutton].ctl-&gt;event, &amp;eventstr, CHANRCV},
	[Volume] =		{vol-&gt;event, &amp;eventstr, CHANRCV},
	[Browsetopwin] =	{browsetopwin-&gt;event, &amp;eventstr, CHANRCV},
	[Browsebotwin] =	{browsebotwin-&gt;event, &amp;eventstr, CHANRCV},
	[Browsebotscr] =	{browsebotscr-&gt;event, &amp;eventstr, CHANRCV},
	[Playevent] =		{playevent, &amp;eventstr, CHANRCV},
	[Playlistwin] =		{playlistwin-&gt;event, &amp;eventstr, CHANRCV},
	[Nalt] =		{nil, nil, CHANEND}
	};

	activate(vol);
	activate(controlcalled("tabs"));
	activatebuttons(1 &lt;&lt; Exitbutton | 1 &lt;&lt; Rootbutton | 1 &lt;&lt; Helpbutton);
	
	root = getroot();
	setparent(root);
	clearchildren();
	addparent("Root");
	chanprint(cs-&gt;ctl, "browsetop show");
	fillbrowsebot(root);
	chanprint(cs-&gt;ctl, "browsebot show");

	eventstr = nil;
	selected = -1;

	for(;;){
		a = alt(alts);
		if(debug &amp; DBGCONTROL)
			fprint(2, "Event: %s\n", eventstr);
		n = tokenize(eventstr, args, nelem(args));
		switch(a){
		default:
			sysfatal("Illegal event %d in work", a);
		case Volume:
			if(n != 3 || strcmp(args[0], "volume") || strcmp(args[1], "volume"))
				sysfatal("Bad Volume event[%d]: %s %s", n, args[0], args[1]);
			setvolume(args[2]);
			break;
		case Exitbutton:
			return;
		case Pausebutton:
			if(n != 3 || strcmp(args[0], "pause:") || strcmp(args[1], "value"))
				sysfatal("Bad Pausebutton event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[2], "0") == 0)
				fprint(playctlfd, "resume");
			else
				fprint(playctlfd, "pause");
			break;
		case Playbutton:
			if(n != 3 || strcmp(args[0], "play:") || strcmp(args[1], "value"))
				sysfatal("Bad Playbutton event[%d]: %s %s", n, args[0], args[1]);
			if(playlist.selected &gt;= 0){
				fprint(playctlfd, "play %d", playlist.selected);
			}else
				fprint(playctlfd, "play");
			break;
		case Stopbutton:
			if(n != 3 || strcmp(args[0], "stop:") || strcmp(args[1], "value"))
				sysfatal("Bad Stopbutton event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[2], "0") == 0)
				chanprint(cs-&gt;ctl, "%q value 1", buts[Stopbutton].ctl-&gt;name);
			fprint(playctlfd, "stop");
			break;
		case Prevbutton:
			if(n != 3 || strcmp(args[0], "prev:") || strcmp(args[1], "value"))
				sysfatal("Bad Prevbutton event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[2], "0") == 0)
				break;
			chanprint(cs-&gt;ctl, "%q value 0", buts[Prevbutton].ctl-&gt;name);
			fprint(playctlfd, "skip -1");
			break;
		case Nextbutton:
			if(n != 3 || strcmp(args[0], "next:") || strcmp(args[1], "value"))
				sysfatal("Bad Nextbutton event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[2], "0") == 0)
				break;
			chanprint(cs-&gt;ctl, "%q value 0", buts[Nextbutton].ctl-&gt;name);
			fprint(playctlfd, "skip 1");
			break;
		case Playlistwin:
			if(debug &amp; (DBGCONTROL|DBGPLAY))
				fprint(2, "Playlistevent: %s %s\n", args[0], args[1]);
			if(n != 4 || strcmp(args[0], "playlistwin:") || strcmp(args[1], "select"))
				sysfatal("Bad Playlistwin event[%d]: %s %s", n, args[0], args[1]);
			n = atoi(args[2]);
			if(n &lt; 0 || n &gt;= playlist.nentries)
				sysfatal("Selecting line %d of %d", n, playlist.nentries);
			if(playlist.selected &gt;= 0 &amp;&amp; playlist.selected &lt; playlist.nentries){
				chanprint(cs-&gt;ctl, "playlistwin select %d 0", playlist.selected);
				chanprint(cs-&gt;ctl, "playlistwin show");
			}
			playlist.selected = -1;
			deactivatebuttons(1&lt;&lt;Playbutton);
			if(strcmp(args[3], "1") == 0)
				playlistselect(n);
			break;
		case Rootbutton:
			chanprint(cs-&gt;ctl, "%q value 0", buts[Rootbutton].ctl-&gt;name);
			setparent(root);
			clearchildren();
			addparent("Root");
			chanprint(cs-&gt;ctl, "browsetop show");
			fillbrowsebot(root);
			chanprint(cs-&gt;ctl, "browsebot show");
			break;
		case Deletebutton:
			if(n != 3 || strcmp(args[0], "trash:") || strcmp(args[1], "value"))
				sysfatal("Bad Deletebutton event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[2], "0") == 0)
				break;
			chanprint(cs-&gt;ctl, "%q value 0", buts[Deletebutton].ctl-&gt;name);
			sendplaylist(nil, nil);
			break;
		case Helpbutton:
			chanprint(cs-&gt;ctl, "%q value 0", buts[Helpbutton].ctl-&gt;name);
			if(errorlines &gt; 0){
				chanprint(cs-&gt;ctl, "errortext clear");
				chanprint(cs-&gt;ctl, "errortext topline 0");
				chanprint(cs-&gt;ctl, "errorscr max 0");
				chanprint(cs-&gt;ctl, "errorscr value 0");
			}
			if(errorlines &gt;= 0){
				for(i = 0; helptext[i]; i++)
					chanprint(cs-&gt;ctl, "errortext accumulate %q", helptext[i]);
				chanprint(cs-&gt;ctl, "errorscr max %d", i);
			}
			chanprint(cs-&gt;ctl, "errortext topline 0");
			chanprint(cs-&gt;ctl, "errorscr value 0");
			errorlines = -1;
			chanprint(cs-&gt;ctl, "tabs value %d", WinError);
			break;
		case Browsetopwin:
			if(n != 4 || strcmp(args[0], "browsetopwin:") || strcmp(args[1], "select"))
				sysfatal("Bad Browsetopwin event[%d]: %s %s", n, args[0], args[1]);
			if(strcmp(args[3], "0") == 0)
				break;
			chanprint(cs-&gt;ctl, "browsetopwin select %s 0", args[2]);
			selected = -1;
			if(strcmp(args[3], "2") == 0)
				doplay(parent.address);
			else if(strcmp(args[3], "4") == 0){
				s = getparent(parent.address);
				browsedown(s);
			}
			break;
		case Browsebotwin:
			if(n != 4 || strcmp(args[0], "browsebotwin:") || strcmp(args[1], "select"))
				sysfatal("Bad Browsebotwin event[%d]: %s %s", n, args[0], args[1]);
			n = atoi(args[2]);
			if(n &lt; 0 || n &gt;= nchildren)
				sysfatal("Selection out of range: %d [%d]", n, nchildren);
			if(strcmp(args[3], "0") == 0){
				selected = -1;
				break;
			}
			if(n &lt; 0)
				break;
			chanprint(cs-&gt;ctl, "browsebotwin select %d 0", n);
			selected = n;
			if(selected &gt;= nchildren)
				sysfatal("Select out of range: %d [0⋯%d)", selected, nchildren);
			if(strcmp(args[3], "1") == 0){
				browseup(children[selected].address);
			}else if(strcmp(args[3], "2") == 0)
				doplay(children[selected].address);
			else if(strcmp(args[3], "4") == 0)
				browsedown(getparent(parent.address));
			break;
		case Browsebotscr:
			browseline = atoi(args[2]);
			chanprint(cs-&gt;ctl, "browsebotwin topline %d", browseline);
			break;
		case Playevent:
			if(n &lt; 3 || strcmp(args[0], "playctlproc:"))
				sysfatal("Bad Playevent event[%d]: %s", n, args[0]);
			if(debug &amp; (DBGCONTROL|DBGPLAY))
				fprint(2, "Playevent: %s %s\n", args[1], args[2]);
			if(strcmp(args[1], "error") ==0){
				if(n != 4){
					fprint(2, "Playevent: %s: arg count: %d\n", args[1], n);
					break;
				}
				if(errorlines &lt; 0){
					chanprint(cs-&gt;ctl, "errortext clear");
					chanprint(cs-&gt;ctl, "errortext topline 0");
					chanprint(cs-&gt;ctl, "errorscr max 0");
					chanprint(cs-&gt;ctl, "errorscr value 0");
					errorlines = 0;
				}
				n = errorlines;
				chanprint(cs-&gt;ctl, "errortext accumulate %q", args[3]);
				chanprint(cs-&gt;ctl, "errorscr max %d", ++errorlines);
				if(n &gt;= 0 &amp;&amp; n &lt;= errorlines - Dy(errortext-&gt;rect)/romanfont-&gt;height)
					n--;
				else
					n = errorlines - Dy(errortext-&gt;rect)/romanfont-&gt;height + 1;
				if(n &lt; 0) n = 0;
				if(n &lt; errorlines){
					chanprint(cs-&gt;ctl, "errortext topline %d",  n);
					chanprint(cs-&gt;ctl, "errorscr value %d",  n);
				}
				chanprint(cs-&gt;ctl, "tabs value %d", WinError);
			}else if(strcmp(args[1], "play") ==0){
				chanprint(cs-&gt;ctl, "%q value 1", buts[Playbutton].ctl-&gt;name);
				chanprint(cs-&gt;ctl, "%q value 0", buts[Stopbutton].ctl-&gt;name);
				chanprint(cs-&gt;ctl, "%q value 0", buts[Pausebutton].ctl-&gt;name);
				playlistselect(strtoul(args[2], nil, 0));
				chanprint(cs-&gt;ctl, "playtext clear");
				chanprint(cs-&gt;ctl, "playtext topline 0");
				chanprint(cs-&gt;ctl, "playscr max 0");
				chanprint(cs-&gt;ctl, "playscr value 0");
				playstate = Playing;
				activatebuttons(playingbuts);
				qlock(&amp;playlist);
				if(playlist.selected &lt; playlist.nentries){
					fillplaytext(playlist.entry[playlist.selected].onum);
					chanprint(cs-&gt;ctl, "playscr max %d", n);
				}
				qunlock(&amp;playlist);
				chanprint(cs-&gt;ctl, "playwin show");
			}else if(strcmp(args[1], "stop") ==0){
				chanprint(cs-&gt;ctl, "%q value 0", buts[Playbutton].ctl-&gt;name);
				chanprint(cs-&gt;ctl, "%q value 1", buts[Stopbutton].ctl-&gt;name);
				chanprint(cs-&gt;ctl, "%q value 0", buts[Pausebutton].ctl-&gt;name);
				playlistselect(strtoul(args[2], nil, 0));
				chanprint(cs-&gt;ctl, "%q show", tabs[WinPlaylist].winname);
				playstate = PlayIdle;
				deactivatebuttons(playingbuts);
			}else if(strcmp(args[1], "pause") ==0){
				activatebuttons(playingbuts);
				chanprint(cs-&gt;ctl, "%q value 1", buts[Playbutton].ctl-&gt;name);
				chanprint(cs-&gt;ctl, "%q value 0", buts[Stopbutton].ctl-&gt;name);
				if(playstate == PlayPause){
					chanprint(cs-&gt;ctl, "%q value 0", buts[Pausebutton].ctl-&gt;name);
					playstate = Playing;
				}else{
					chanprint(cs-&gt;ctl, "%q value 1", buts[Pausebutton].ctl-&gt;name);
					playstate = PlayPause;
				}
			}else if(strcmp(args[1], "exits") ==0){
				threadexits("exitevent");
			}else{
				fprint(2, "Unknown play event:");
				for(i=0; i&lt;n; i++)
					fprint(2, " %s", args[i]);
				fprint(2, "\n");
			}
			break;
		}
		if(eventstr){
			free(eventstr);
			eventstr = nil;
		}
	}
}

void
threadmain(int argc, char *argv[]){
	int wflag;

	wflag = 0;
	ARGBEGIN{
	case 'd':
		debug = strtol(ARGF(), nil, 0);
		break;
	case 't':
		tflag = 1;
		break;
	case 'w':
		wflag = 1;
		break;
	default:
		sysfatal(usage, argv0);
	}ARGEND

	quotefmtinstall();

	if(tflag)
		makewindow(320, 320, wflag);
	else
		makewindow(480, 480, wflag);

	playlist.selected = -1;

	playctlfd = open(playctlfile, OWRITE);
	if(playctlfd &lt; 0)
		sysfatal("%s: %r", playctlfile);
	proccreate(playlistproc, nil, STACKSIZE);
	playevent = chancreate(sizeof(char *), 1);
	proccreate(playctlproc, playevent, STACKSIZE);
	proccreate(playvolproc, cs-&gt;ctl, STACKSIZE);

	work();

	closecontrolset(cs);
	threadexitsall(nil);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

