<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/jukefs/catset.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/jukefs/catset.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;

#include "object.h"
#include "catset.h"

static int debug = 0;

int
catsetneeded(int v)
{
	return (v / 8) + 1;
}

static void
catsetprint(int f, Catset*cs)
{
	int i;
	fprint(2, "(%p %d:", cs-&gt;bitpiece, cs-&gt;nbitpiece);
	for (i = 0; i &lt; cs-&gt;nbitpiece; i++)
		fprint(f, "[%d]=%x", i, cs-&gt;bitpiece[i]);
	fprint(2, ")");
}

void
catsetrealloc(Catset *cs, int sz)
{
	if (debug) fprint(2, "catsetrealloc %p %d (%p %d)", cs, sz, cs-&gt;bitpiece, cs-&gt;nbitpiece);
	if (sz &gt; cs-&gt;nbitpiece) {
		cs-&gt;bitpiece = realloc(cs-&gt;bitpiece, sz*sizeof(uchar));
		memset(cs-&gt;bitpiece + cs-&gt;nbitpiece, 0, sz - cs-&gt;nbitpiece);
		cs-&gt;nbitpiece = sz;
	}
	if (debug) fprint(2, " -&gt; %p %d\n", cs-&gt;bitpiece, cs-&gt;nbitpiece);
}

void
catsetfree(Catset *cs)
{
	free(cs-&gt;bitpiece);
	cs-&gt;bitpiece = 0;
	cs-&gt;nbitpiece = 0;
}

void
catsetinit(Catset*cs, int v)
{
	int n;

	n = catsetneeded(v);
	if (debug) fprint(2, "catsetinit %p %d -&gt; ", cs, v);
	catsetrealloc(cs, n);
	catsetset(cs, v);
	if (debug) catsetprint(2, cs);
	if (debug) fprint(2, "\n");
}

void
catsetcopy(Catset*dst, Catset*src)
{
	if (debug) fprint(2, "catsetcopy %p %p ", dst, src);
	if (debug) catsetprint(2, dst);
	if (debug) fprint(2, " ");
	if (debug) catsetprint(2, src);
	if (dst-&gt;nbitpiece &lt; src-&gt;nbitpiece)
		catsetrealloc(dst, src-&gt;nbitpiece);
	else
		memset(dst-&gt;bitpiece, 0, dst-&gt;nbitpiece);
	memcpy(dst-&gt;bitpiece, src-&gt;bitpiece, src-&gt;nbitpiece);
	dst-&gt;nbitpiece = src-&gt;nbitpiece;
	if (debug) fprint(2, "-&gt; ");
	if (debug) catsetprint(2, dst);
	if (debug) fprint(2, "\n");
}

void
catsetset(Catset*cs, int v)
{
	int p = v / 8;
	int b = v % 8;
	if (debug) fprint(2, "catsetset %p %d ", cs, v);
	if (debug) catsetprint(2, cs);
	cs-&gt;bitpiece[p] = 1 &lt;&lt; b;
	if (debug) fprint(2, "-&gt; ");
	if (debug) catsetprint(2, cs);
	if (debug) fprint(2, "\n");
}

int
catsetisset(Catset*cs)
{
	int i;

	if (debug) fprint(2, "catsetisset %p ", cs);
	if (debug) catsetprint(2, cs);
	if (debug) fprint(2, "\n");
	for (i =0; i &lt; cs-&gt;nbitpiece; i++) {
		if (cs-&gt;bitpiece[i])
			return 1;
	}
	return 0;
}

void
catsetorset(Catset*dst, Catset*src)
{
	int i;

	if (debug) fprint(2, "catsetorset %p %p ", dst, src);
	if (debug) catsetprint(2, dst);
	if (debug) fprint(2, " ");
	if (debug) catsetprint(2, src);
	if (src-&gt;nbitpiece &gt; dst-&gt;nbitpiece)
		catsetrealloc(dst, src-&gt;nbitpiece);

	for (i =0; i &lt; src-&gt;nbitpiece; i++) {
		dst-&gt;bitpiece[i] |= src-&gt;bitpiece[i];
	}
	if (debug) fprint(2, "-&gt; ");
	if (debug) catsetprint(2, dst);
	if (debug) fprint(2, "\n");
}

int
catseteq(Catset*cs1, Catset*cs2)
{
	int i;
	Catset *css, * csl;

	if (debug) fprint(2, "catseteq %p %p ", cs1, cs2);
	if (debug) catsetprint(2, cs1);
	if (debug) fprint(2, " ");
	if (debug) catsetprint(2, cs2);
	if (debug) fprint(2, "\n");
	if (cs1-&gt;nbitpiece &gt; cs2-&gt;nbitpiece) {
		csl = cs1;
		css = cs2;
	} else {
		csl = cs2;
		css = cs1;
	}
	for (i =0; i &lt; css-&gt;nbitpiece; i++) {
		if (css-&gt;bitpiece[i] != csl-&gt;bitpiece[i])
			return 0;
	}
	for (i = css-&gt;nbitpiece; i &lt; csl-&gt;nbitpiece; i++) {
		if (csl-&gt;bitpiece[i])
			return 0;
	}
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

