<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/music/playlistfs/fs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/music/playlistfs/fs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;fcall.h&gt;
#include "pool.h"
#include "playlist.h"

typedef struct Wmsg Wmsg;

enum {
	Busy =	0x01,
	Open =	0x02,
	Trunc =	0x04,
	Eof =	0x08,
};

File files[] = {
[Qdir] =	{.dir = {0,0,{Qdir, 0,QTDIR},		0555|DMDIR,	0,0,0,	"."}},
[Qplayctl] =	{.dir = {0,0,{Qplayctl, 0,QTFILE},	0666,		0,0,0,	"playctl"}},
[Qplaylist] =	{.dir = {0,0,{Qplaylist, 0,QTFILE},	0666|DMAPPEND,	0,0,0,	"playlist"}},
[Qplayvol] =	{.dir = {0,0,{Qplayvol, 0,QTFILE},	0666,		0,0,0,	"playvol"}},
[Qplaystat] =	{.dir = {0,0,{Qplaystat, 0,QTFILE},	0444,		0,0,0,	"playstat"}},
};

Channel		*reqs;
Channel		*workers;
Channel		*volumechan;
Channel		*playchan;
Channel		*playlistreq;
Playlist	playlist;
int		volume[8];

char *statetxt[] = {
	[Nostate] =	"panic!",
	[Error] =	"error",
	[Stop] =	"stop",
	[Pause] =	"pause",
	[Play] =	"play",
	[Resume] =	"resume",
	[Skip] =	"skip",
	nil
};

// low-order bits: position in play list, high-order: play state:
Pmsg	playstate = {Stop, 0};

char	*rflush(Worker*), *rauth(Worker*),
	*rattach(Worker*), *rwalk(Worker*),
	*ropen(Worker*), *rcreate(Worker*),
	*rread(Worker*), *rwrite(Worker*), *rclunk(Worker*),
	*rremove(Worker*), *rstat(Worker*), *rwstat(Worker*),
	*rversion(Worker*);

char 	*(*fcalls[])(Worker*) = {
	[Tflush]	rflush,
	[Tversion]	rversion,
	[Tauth]		rauth,
	[Tattach]	rattach,
	[Twalk]		rwalk,
	[Topen]		ropen,
	[Tcreate]	rcreate,
	[Tread]		rread,
	[Twrite]	rwrite,
	[Tclunk]	rclunk,
	[Tremove]	rremove,
	[Tstat]		rstat,
	[Twstat]	rwstat,
};

int	messagesize = Messagesize;
Fid	*fids;


char	Eperm[] =	"permission denied";
char	Enotdir[] =	"not a directory";
char	Enoauth[] =	"authentication not required";
char	Enotexist[] =	"file does not exist";
char	Einuse[] =	"file in use";
char	Eexist[] =	"file exists";
char	Enotowner[] =	"not owner";
char	Eisopen[] = 	"file already open for I/O";
char	Excl[] = 	"exclusive use file already open";
char	Ename[] = 	"illegal name";
char	Ebadctl[] =	"unknown control message";
char	Epast[] =	"reading past eof";

Fid	*oldfid(int);
Fid	*newfid(int);
void	volumeupdater(void*);
void	playupdater(void*);

char *playerror;

static int
lookup(char *cmd, char *list[])
{
	int i;

	for (i = 0; list[i] != nil; i++)
		if (strcmp(cmd, list[i]) == 0)
			return i;
	return -1;
}

char*
rversion(Worker *w)
{
	Req *r;
	Fid *f;

	r = w-&gt;r;
	if(r-&gt;ifcall.msize &lt; 256)
		return "max messagesize too small";
	if(r-&gt;ifcall.msize &lt; messagesize)
		messagesize = r-&gt;ifcall.msize;
	r-&gt;ofcall.msize = messagesize;
	if(strncmp(r-&gt;ifcall.version, "9P2000", 6) != 0)
		return "unknown 9P version";
	else
		r-&gt;ofcall.version = "9P2000";
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;flags &amp; Busy)
			f-&gt;flags &amp;= ~(Open|Busy);
	return nil;
}

char*
rauth(Worker*)
{
	return Enoauth;
}

char*
rflush(Worker *w)
{
	Wmsg m;
	int i;
	Req *r;

	r = w-&gt;r;
	m.cmd = Flush;
	m.off = r-&gt;ifcall.oldtag;
	m.arg = nil;
	for(i = 1; i &lt; nelem(files); i++)
		bcastmsg(files[i].workers, &amp;m);
	if (debug &amp; DbgWorker)
		fprint(2, "flush done on tag %d\n", r-&gt;ifcall.oldtag);
	return 0;
}

char*
rattach(Worker *w)
{
	Fid *f;
	Req *r;

	r = w-&gt;r;
	r-&gt;fid = newfid(r-&gt;ifcall.fid);
	f = r-&gt;fid;
	f-&gt;flags |= Busy;
	f-&gt;file = &amp;files[Qdir];
	r-&gt;ofcall.qid = f-&gt;file-&gt;dir.qid;
	if(!aflag &amp;&amp; strcmp(r-&gt;ifcall.uname, user) != 0)
		return Eperm;
	return 0;
}

static Fid*
doclone(Fid *f, int nfid)
{
	Fid *nf;

	nf = newfid(nfid);
	if(nf-&gt;flags &amp; Busy)
		return nil;
	nf-&gt;flags |= Busy;
	nf-&gt;flags &amp;= ~(Open);
	nf-&gt;file = f-&gt;file;
	return nf;
}

char*
dowalk(Fid *f, char *name)
{
	int t;

	if (strcmp(name, ".") == 0)
		return nil;
	if (strcmp(name, "..") == 0){
		f-&gt;file = &amp;files[Qdir];
		return nil;
	}
	if(f-&gt;file != &amp;files[Qdir])
		return Enotexist;
	for (t = 1; t &lt; Nqid; t++){
		if(strcmp(name, files[t].dir.name) == 0){
			f-&gt;file = &amp;files[t];
			return nil;
		}
	}
	return Enotexist;
}

char*
rwalk(Worker *w)
{
	Fid *f, *nf;
	char *rv;
	int i;
	File *savefile;
	Req *r;

	r = w-&gt;r;
	r-&gt;fid = oldfid(r-&gt;ifcall.fid);
	if((f = r-&gt;fid) == nil)
		return Enotexist;
	if(f-&gt;flags &amp; Open)
		return Eisopen;

	r-&gt;ofcall.nwqid = 0;
	nf = nil;
	savefile = f-&gt;file;
	/* clone if requested */
	if(r-&gt;ifcall.newfid != r-&gt;ifcall.fid){
		nf = doclone(f, r-&gt;ifcall.newfid);
		if(nf == nil)
			return "new fid in use";
		f = nf;
	}

	/* if it's just a clone, return */
	if(r-&gt;ifcall.nwname == 0 &amp;&amp; nf != nil)
		return nil;

	/* walk each element */
	rv = nil;
	for(i = 0; i &lt; r-&gt;ifcall.nwname; i++){
		rv = dowalk(f, r-&gt;ifcall.wname[i]);
		if(rv != nil){
			if(nf != nil)	
				nf-&gt;flags &amp;= ~(Open|Busy);
			else
				f-&gt;file = savefile;
			break;
		}
		r-&gt;ofcall.wqid[i] = f-&gt;file-&gt;dir.qid;
	}
	r-&gt;ofcall.nwqid = i;

	/* we only error out if no walk  */
	if(i &gt; 0)
		rv = nil;

	return rv;
}

char *
ropen(Worker *w)
{
	Fid *f, *ff;
	Wmsg m;
	Req *r;

	r = w-&gt;r;
	r-&gt;fid = oldfid(r-&gt;ifcall.fid);
	if((f = r-&gt;fid) == nil)
		return Enotexist;
	if(f-&gt;flags &amp; Open)
		return Eisopen;

	if(r-&gt;ifcall.mode != OREAD)
		if((f-&gt;file-&gt;dir.mode &amp; 0x2) == 0)
			return Eperm;
	if((r-&gt;ifcall.mode &amp; OTRUNC) &amp;&amp; f-&gt;file == &amp;files[Qplaylist]){
		playlist.nlines = 0;
		playlist.ndata = 0;
		free(playlist.lines);
		free(playlist.data);
		playlist.lines = nil;
		playlist.data = nil;
		f-&gt;file-&gt;dir.length = 0;
		f-&gt;file-&gt;dir.qid.vers++;
		/* Mark all fids for this file `Trunc'ed */
		for(ff = fids; ff; ff = ff-&gt;next)
			if(ff-&gt;file == &amp;files[Qplaylist] &amp;&amp; (ff-&gt;flags &amp; Open))
				ff-&gt;flags |= Trunc;
		m.cmd = Check;
		m.off = 0;
		m.arg = nil;
		bcastmsg(f-&gt;file-&gt;workers, &amp;m);
	}
	r-&gt;ofcall.iounit = 0;
	r-&gt;ofcall.qid = f-&gt;file-&gt;dir.qid;
	f-&gt;flags |= Open;
	return nil;
}

char *
rcreate(Worker*)
{
	return Eperm;
}

int
readtopdir(Fid*, uchar *buf, long off, int cnt, int blen)
{
	int i, m, n;
	long pos;

	n = 0;
	pos = 0;
	for (i = 1; i &lt; Nqid; i++){
		m = convD2M(&amp;files[i].dir, &amp;buf[n], blen-n);
		if(off &lt;= pos){
			if(m &lt;= BIT16SZ || m &gt; cnt)
				break;
			n += m;
			cnt -= m;
		}
		pos += m;
	}
	return n;
}

char*
rread(Worker *w)
{
	Fid *f;
	Req *r;
	long off, cnt;
	int n, i;
	Wmsg m;
	char *p;

	r = w-&gt;r;
	r-&gt;fid = oldfid(r-&gt;ifcall.fid);
	if((f = r-&gt;fid) == nil)
		return Enotexist;
	r-&gt;ofcall.count = 0;
	off = r-&gt;ifcall.offset;
	cnt = r-&gt;ifcall.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	if(f-&gt;file == &amp;files[Qdir]){
		n = readtopdir(f, r-&gt;indata, off, cnt, messagesize - IOHDRSZ);
		r-&gt;ofcall.count = n;
		return nil;
	}

	if(f-&gt;file == files + Qplaystat){
		p = getplaystat(r-&gt;ofcall.data, r-&gt;ofcall.data + sizeof r-&gt;indata);
		readbuf(r, r-&gt;ofcall.data, p - r-&gt;ofcall.data);
		return nil;
	}

	m.cmd = 0;
	while(f-&gt;vers == f-&gt;file-&gt;dir.qid.vers &amp;&amp; (f-&gt;flags &amp; Eof)){
		/* Wait until file state changes (f-&gt;file-&gt;dir.qid.vers is incremented) */
		m = waitmsg(w, f-&gt;file-&gt;workers);
		if(m.cmd == Flush &amp;&amp; m.off == r-&gt;ifcall.tag)
			return (char*)~0;	/* no answer needed */
		assert(m.cmd != Work);
		yield();
	}
	if(f-&gt;file == files + Qplaylist){
		f-&gt;flags &amp;= ~Eof;
		if((f-&gt;flags &amp; Trunc) &amp;&amp; r-&gt;ifcall.offset != 0){
			f-&gt;flags &amp;= ~Trunc;
			return Epast;
		}
		f-&gt;flags &amp;= ~Trunc;
		if(r-&gt;ifcall.offset &lt; playlist.ndata)
			readbuf(r, playlist.data, playlist.ndata);
		else if(r-&gt;ifcall.offset == playlist.ndata){
			r-&gt;ofcall.count = 0;
			/* Arrange for this fid to wait next time: */
			f-&gt;vers = f-&gt;file-&gt;dir.qid.vers;
			f-&gt;flags |= Eof;
		}else{
			/* Beyond eof, bad seek? */
			return Epast;
		}
	}else if(f-&gt;file == files + Qplayctl){
		f-&gt;flags &amp;= ~Eof;
		if(m.cmd == Error){
			snprint(r-&gt;ofcall.data, sizeof r-&gt;indata, "%s %ud %q",
				statetxt[m.cmd], m.off, m.arg);
			free(m.arg);
		}else if(f-&gt;vers == f-&gt;file-&gt;dir.qid.vers){
			r-&gt;ofcall.count = 0;
			/* Arrange for this fid to wait next time: */
			f-&gt;flags |= Eof;
			return nil;
		}else{
			snprint(r-&gt;ofcall.data, sizeof r-&gt;indata, "%s %ud",
				statetxt[playstate.cmd], playstate.off);
			f-&gt;vers = f-&gt;file-&gt;dir.qid.vers;
		}
		r-&gt;ofcall.count = strlen(r-&gt;ofcall.data);
		if(r-&gt;ofcall.count &gt; r-&gt;ifcall.count)
			r-&gt;ofcall.count = r-&gt;ifcall.count;
	}else if(f-&gt;file == files + Qplayvol){
		f-&gt;flags &amp;= ~Eof;
		if(f-&gt;vers == f-&gt;file-&gt;dir.qid.vers){
			r-&gt;ofcall.count = 0;
			/* Arrange for this fid to wait next time: */
			f-&gt;flags |= Eof;
		}else{
			p = seprint(r-&gt;ofcall.data, r-&gt;ofcall.data + sizeof r-&gt;indata, "volume	'");
			for(i = 0; i &lt; nelem(volume); i++){
				if(volume[i] == Undef)
					break;
				p = seprint(p, r-&gt;ofcall.data + sizeof r-&gt;indata, "%d ", volume[i]);
			}
			p = seprint(p, r-&gt;ofcall.data + sizeof r-&gt;indata, "'");
			r-&gt;ofcall.count = p - r-&gt;ofcall.data;
			if(r-&gt;ofcall.count &gt; r-&gt;ifcall.count)
				r-&gt;ofcall.count = r-&gt;ifcall.count;
			f-&gt;vers = f-&gt;file-&gt;dir.qid.vers;
		}
	}else
		abort();
	return nil;
}

char*
rwrite(Worker *w)
{
	long cnt, i, nf, cmd;
	Pmsg newstate;
	char *fields[3], *p, *q;
	Wmsg m;
	Fid *f;
	Req *r;

	r = w-&gt;r;
	r-&gt;fid = oldfid(r-&gt;ifcall.fid);
	if((f = r-&gt;fid) == nil)
		return Enotexist;
	r-&gt;ofcall.count = 0;
	cnt = r-&gt;ifcall.count;

	if(cnt &gt; messagesize - IOHDRSZ)
		cnt = messagesize - IOHDRSZ;

	if(f-&gt;file == &amp;files[Qplayctl]){
		r-&gt;ifcall.data[cnt] = '\0';
		if (debug &amp; DbgPlayer)
			fprint(2, "rwrite playctl: %s\n", r-&gt;ifcall.data);
		nf = tokenize(r-&gt;ifcall.data, fields, 4);
		if (nf == 0){
			r-&gt;ofcall.count = r-&gt;ifcall.count;
			return nil;
		}
		if (nf == 2)
			i = strtol(fields[1], nil, 0);
		else
			i = playstate.off;
		newstate = playstate;
		if ((cmd = lookup(fields[0], statetxt)) &lt; 0)
			return  Ebadctl;
		switch(cmd){
		case Play:
			newstate.cmd = cmd;
			newstate.off = i;
			break;
		case Pause:
			if (playstate.cmd != Play)
				break;
			// fall through
		case Stop:
			newstate.cmd = cmd;
			newstate.off = playstate.off;
			break;
		case Resume:
			if(playstate.cmd == Stop)
				break;
			newstate.cmd = Resume;
			newstate.off = playstate.off;
			break;
		case Skip:
			if (nf == 2)
				i += playstate.off;
			else
				i = playstate.off +1;
			if(i &lt; 0)
				i = 0;
			else if (i &gt;= playlist.nlines)
				i = playlist.nlines - 1;
			newstate.cmd = Play;
			newstate.off = i;
		}
		if (newstate.off &gt;= playlist.nlines){
			newstate.cmd = Stop;
			newstate.off = playlist.nlines;
		}
		if (debug &amp; DbgPlayer)
			fprint(2, "new state %s-%ud\n",
				statetxt[newstate.cmd], newstate.off);
		if (newstate.m != playstate.m)
			sendul(playc, newstate.m);
		f-&gt;file-&gt;dir.qid.vers++;
	} else if(f-&gt;file == &amp;files[Qplayvol]){
		char *subfields[nelem(volume)];
		int v[nelem(volume)];

		r-&gt;ifcall.data[cnt] = '\0';
		if (debug &amp; DbgPlayer)
			fprint(2, "rwrite playvol: %s\n", r-&gt;ifcall.data);
		nf = tokenize(r-&gt;ifcall.data, fields, 4);
		if (nf == 0){
			r-&gt;ofcall.count = r-&gt;ifcall.count;
			return nil;
		}
		if (nf != 2 || strcmp(fields[0], "volume") != 0)
			return Ebadctl;
		if (debug &amp; DbgPlayer)
			fprint(2, "new volume '");
		nf = tokenize(fields[1], subfields, nelem(subfields));
		if (nf &lt;= 0 || nf &gt; nelem(volume))
			return "volume";
		for (i = 0; i &lt; nf; i++){
			v[i] = strtol(subfields[i], nil, 0);
			if (debug &amp; DbgPlayer)
				fprint(2, " %d", v[i]);
		}
		if (debug &amp; DbgPlayer)
			fprint(2, "'\n");
		while (i &lt; nelem(volume))
			v[i++] = Undef;
		volumeset(v);
		r-&gt;ofcall.count = r-&gt;ifcall.count;
		return nil;
	} else if(f-&gt;file == &amp;files[Qplaylist]){
		if (debug &amp; DbgPlayer){
			fprint(2, "rwrite playlist: `");
			write(2, r-&gt;ifcall.data, cnt);
			fprint(2, "'\n");
		}
		playlist.data = realloc(playlist.data, playlist.ndata + cnt + 2);
		if (playlist.data == 0)
			sysfatal("realloc: %r");
		memmove(playlist.data + playlist.ndata, r-&gt;ifcall.data, cnt);
		if (playlist.data[playlist.ndata + cnt-1] != '\n')
			playlist.data[playlist.ndata + cnt++] = '\n';
		playlist.data[playlist.ndata + cnt] = '\0';
		p = playlist.data + playlist.ndata;
		while (*p){
			playlist.lines = realloc(playlist.lines, (playlist.nlines+1)*sizeof(playlist.lines[0]));
			if(playlist.lines == nil)
				sysfatal("realloc: %r");
			playlist.lines[playlist.nlines] = playlist.ndata;
			q = strchr(p, '\n');
			if (q == nil)
				break;
			if(debug &amp; DbgPlayer)
				fprint(2, "[%lud]: ", playlist.nlines);
			playlist.nlines++;
			q++;
			if(debug &amp; DbgPlayer)
				write(2, p, q-p);
			playlist.ndata += q - p;
			p = q;
		}
		f-&gt;file-&gt;dir.length = playlist.ndata;
		f-&gt;file-&gt;dir.qid.vers++;
	}else
		return Eperm;
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	m.cmd = Check;
	m.off = 0;
	m.arg = nil;
	bcastmsg(f-&gt;file-&gt;workers, &amp;m);
	return nil;
}

char *
rclunk(Worker *w)
{
	Fid *f;

	f = oldfid(w-&gt;r-&gt;ifcall.fid);
	if(f == nil)
		return Enotexist;
	f-&gt;flags &amp;= ~(Open|Busy);
	return 0;
}

char *
rremove(Worker*)
{
	return Eperm;
}

char *
rstat(Worker *w)
{
	Req *r;

	r = w-&gt;r;
	r-&gt;fid = oldfid(r-&gt;ifcall.fid);
	if(r-&gt;fid == nil)
		return Enotexist;
	r-&gt;ofcall.nstat = convD2M(&amp;r-&gt;fid-&gt;file-&gt;dir, r-&gt;indata, messagesize - IOHDRSZ);
	r-&gt;ofcall.stat = r-&gt;indata;
	return 0;
}

char *
rwstat(Worker*)
{
	return Eperm;
}

Fid *
oldfid(int fid)
{
	Fid *f;

	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid)
			return f;
	return nil;
}

Fid *
newfid(int fid)
{
	Fid *f, *ff;

	ff = nil;
	for(f = fids; f; f = f-&gt;next)
		if(f-&gt;fid == fid){
			return f;
		}else if(ff == nil &amp;&amp; (f-&gt;flags &amp; Busy) == 0)
			ff = f;
	if(ff == nil){
		ff = mallocz(sizeof *ff, 1);
		if (ff == nil)
			sysfatal("malloc: %r");
		ff-&gt;next = fids;
		ff-&gt;readers = 0;
		fids = ff;
	}
	ff-&gt;fid = fid;
	ff-&gt;file = nil;
	ff-&gt;vers = ~0;
	return ff;
}

void
work(Worker *w)
{
	Req *r;
	char *err;
	int n;

	r = w-&gt;r;
	r-&gt;ofcall.data = (char*)r-&gt;indata;
	if(!fcalls[r-&gt;ifcall.type])
		err = "bad fcall type";
	else
		err = (*fcalls[r-&gt;ifcall.type])(w);
	if(err != (char*)~0){	/* ~0 indicates Flush received */
		if(err){
			r-&gt;ofcall.type = Rerror;
			r-&gt;ofcall.ename = err;
		}else{
			r-&gt;ofcall.type = r-&gt;ifcall.type + 1;
			r-&gt;ofcall.fid = r-&gt;ifcall.fid;
		}
		r-&gt;ofcall.tag = r-&gt;ifcall.tag;
		if(debug &amp; DbgFs)
			fprint(2, "io:-&gt;%F\n", &amp;r-&gt;ofcall);/**/
		n = convS2M(&amp;r-&gt;ofcall, r-&gt;outdata, messagesize);
		if(write(srvfd[0], r-&gt;outdata, n) != n)
			sysfatal("mount write");
	}
	reqfree(r);
	w-&gt;r = nil;
}

void
worker(void *arg)
{
	Worker *w;
	Wmsg m;

	w = arg;
	recv(w-&gt;eventc, &amp;m);
	for(;;){
		assert(m.cmd == Work);
		w-&gt;r = m.arg;
		if(debug &amp; DbgWorker)
			fprint(2, "worker 0x%p:&lt;-%F\n", w, &amp;w-&gt;r-&gt;ifcall);
		work(w);
		if(debug &amp; DbgWorker)
			fprint(2, "worker 0x%p wait for next\n", w);
		m = waitmsg(w, workers);
	}
}

void
allocwork(Req *r)
{
	Worker *w;
	Wmsg m;

	m.cmd = Work;
	m.off = 0;
	m.arg = r;
	if(sendmsg(workers, &amp;m))
		return;
	/* No worker ready to accept request, allocate one */
	w = malloc(sizeof(Worker));
	w-&gt;eventc = chancreate(sizeof(Wmsg), 1);
	if(debug &amp; DbgWorker)
		fprint(2, "new worker 0x%p\n", w);/**/
	threadcreate(worker, w, STACKSIZE);
	send(w-&gt;eventc, &amp;m);
}

void
srvio(void *arg)
{
	char e[32];
	int n;
	Req *r;
	Channel *dispatchc;

	threadsetname("file server IO");
	dispatchc = arg;

	r = reqalloc();
	for(;;){
		/*
		 * reading from a pipe or a network device
		 * will give an error after a few eof reads
		 * however, we cannot tell the difference
		 * between a zero-length read and an interrupt
		 * on the processes writing to us,
		 * so we wait for the error
		 */
		n = read9pmsg(srvfd[0], r-&gt;indata, messagesize);
		if(n == 0)
			continue;
		if(n &lt; 0){
			rerrstr(e, sizeof e);
			if (strcmp(e, "interrupted") == 0){
				if (debug &amp; DbgFs) fprint(2, "read9pmsg interrupted\n");
				continue;
			}
			sysfatal("srvio: %s", e);
		}
		if(convM2S(r-&gt;indata, n, &amp;r-&gt;ifcall) == 0)
			continue;

		if(debug &amp; DbgFs)
			fprint(2, "io:&lt;-%F\n", &amp;r-&gt;ifcall);
		sendp(dispatchc, r);
		r = reqalloc();
	}
}

char *
getplaylist(int n)
{
	Wmsg m;

	m.cmd = Preq;
	m.off = n;
	m.arg = nil;
	send(playlistreq, &amp;m);
	recv(playlistreq, &amp;m);
	if(m.cmd == Error)
		return nil;
	assert(m.cmd == Prep);
	assert(m.arg);
	return m.arg;
}

void
playlistsrv(void*)
{
	Wmsg m;
	char *p, *q, *r;
	char *fields[2];
	int n;
	/* Runs in the srv proc */

	threadsetname("playlistsrv");
	while(recv(playlistreq, &amp;m)){
		assert(m.cmd == Preq);
		m.cmd = Error;
		if(m.off &lt; playlist.nlines){
			p = playlist.data + playlist.lines[m.off];
			q = strchr(p, '\n');
			if (q == nil)
				sysfatal("playlistsrv: no newline character found");
			n = q-p;
			r = malloc(n+1);
			memmove(r, p, n);
			r[n] = 0;
			tokenize(r, fields, nelem(fields));
			assert(fields[0] == r);
			m.cmd = Prep;
			m.arg = r;
		}
		send(playlistreq, &amp;m);
	}
}

void
srv(void*)
{
	Req *r;
	Channel *dispatchc;
	/*
	 * This is the proc with all the action.
	 * When a file request comes in, it is dispatched to this proc
	 * for processing.  Two extra threads field changes in play state
	 * and volume state.
	 * By keeping all the action in this proc, we won't need locks
	 */

	threadsetname("srv");
	close(srvfd[1]);

	dispatchc = chancreate(sizeof(Req*), 1);
	procrfork(srvio, dispatchc, STACKSIZE, RFFDG);

	threadcreate(volumeupdater, nil, STACKSIZE);
	threadcreate(playupdater, nil, STACKSIZE);
	threadcreate(playlistsrv, nil, STACKSIZE);

	while(r = recvp(dispatchc))
		allocwork(r);
		
}

void
playupdater(void*)
{
	Wmsg m;
	/* This is a thread in the srv proc */

	while(recv(playchan, &amp;m)){
		if(debug &amp; DbgPlayer)
			fprint(2, "playupdate: %s %d %s\n", statetxt[m.cmd], m.off, m.arg?m.arg:"");
		if(playstate.m == m.m)
			continue;
		if(m.cmd == Stop &amp;&amp; m.off == 0xffff)
			m.off = playlist.nlines;
		if(m.cmd != Error){
			playstate.m = m.m;
			m.cmd = Check;
			assert(m.arg == nil);
		}
		files[Qplayctl].dir.qid.vers++;
		bcastmsg(files[Qplayctl].workers, &amp;m);
	}
}

void
volumeupdater(void*)
{
	Wmsg m;
	int v[nelem(volume)];
	/* This is a thread in the srv proc */

	while(recv(volumechan, v)){
		if(debug &amp; DbgPlayer)
			fprint(2, "volumeupdate: volume now %d %d %d %d\n", volume[0], volume[1], volume[2], volume[3]);
		memmove(volume, v, sizeof(volume));
		files[Qplayvol].dir.qid.vers++;
		m.cmd = Check;
		m.arg = nil;
		bcastmsg(files[Qplayvol].workers, &amp;m);
	}
}

void
playupdate(Pmsg p, char *s)
{
	Wmsg m;

	m.m = p.m;
	m.arg = s ? strdup(s) : nil;
	send(playchan, &amp;m);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

