<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/sokoban/sokoban.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/sokoban/sokoban.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;event.h&gt;

#include "sokoban.h"

#define SOKOTREE "/sys/games/lib/sokoban/"

char *LEasy = SOKOTREE "levels/easy.slc";
char *LHard = SOKOTREE "levels/hard.slc";
char *levelfile;

#define SOKOIMG SOKOTREE "images/"

char	*GRImage =	SOKOIMG "right.bit";
char	*GLImage =	SOKOIMG "left.bit";
char	*WallImage =	SOKOIMG "wall.bit";
char	*EmptyImage =	SOKOIMG "empty.bit";
char	*CargoImage =	SOKOIMG "cargo.bit";
char	*GoalCargoImage= SOKOIMG "goalcargo.bit";
char	*GoalImage =	SOKOIMG "goal.bit";
char	*WinImage =	SOKOIMG "win.bit";

char *buttons[] = 
{
	"restart",
	"easy",
	"hard",
	"noanimate", /* this menu string initialized in main */
	"exit",
	0
};

char **levelnames;

Menu menu = 
{
	buttons,
};

Menu lmenu =
{
	levelnames,
};

void
buildmenu(void)
{
	int i;

	if (levelnames != nil) {
		for(i=0; levelnames[i] != 0; i++)
			free(levelnames[i]);
	}
	levelnames = realloc(levelnames, sizeof(char*)*(numlevels+1));
	if (levelnames == nil)
		sysfatal("cannot allocate levelnames");
	for(i=0; i &lt; numlevels; i++)
		levelnames[i] = genlevels(i);
	levelnames[numlevels] = 0;
	lmenu.item = levelnames;
}

Image *
eallocimage(Rectangle r, int repl, uint color)
{
	Image *tmp;

	tmp = allocimage(display, r, screen-&gt;chan, repl, color);
	if(tmp == nil)
		sysfatal("cannot allocate buffer image: %r");

	return tmp;
}

Image *
eloadfile(char *path)
{
	Image *img;
	int fd;

	fd = open(path, OREAD);
	if(fd &lt; 0) {
		fprint(2, "cannot open image file %s: %r\n", path);
		exits("image");
	}
	img = readimage(display, fd, 0);
	if(img == nil)
		sysfatal("cannot load image: %r");
	close(fd);
	
	return img;
}


void
allocimages(void)
{
	Rectangle one = Rect(0, 0, 1, 1);
	
	bg		= eallocimage(one, 1, DDarkyellow);
	text 		= eallocimage(one, 1, DBluegreen);

	gright = eloadfile(GRImage);
	gleft = eloadfile(GLImage);
	wall = eloadfile(WallImage);
	empty = eloadfile(EmptyImage);
	empty-&gt;repl = 1;
	goalcargo = eloadfile(GoalCargoImage);
	cargo = eloadfile(CargoImage);
	goal = eloadfile(GoalImage);
	win = eloadfile(WinImage);
}

int
key2move(int key)
{
	int k = 0;

	switch(key) {
	case 61454:
		k = Up;
		break;
	case 63488:
		k = Down;
		break;
	case 61457:
		k = Left;
		break;
	case 61458:
		k = Right;
		break;
	}

	return k;
}

static Route*
mouse2route(Mouse m)
{
	Point p, q;
	Route *r;

	p = subpt(m.xy, screen-&gt;r.min);
	p.x /= BoardX;
	p.y /= BoardY;

	q = subpt(p, level.glenda);
	// fprint(2, "x=%d y=%d\n", q.x, q.y);

	if (q.x == 0 &amp;&amp; q.y ==  0)
		return nil;

	if (q.x == 0 || q.y ==  0) {
		if (q.x &lt; 0)
			r = extend(nil, Left, -q.x, Pt(level.glenda.x, p.y));
		else if (q.x &gt; 0)
			r = extend(nil, Right, q.x, Pt(level.glenda.x, p.y));
		else if (q.y &lt; 0)
			r = extend(nil, Up, -q.y, level.glenda);
		else if (q.y &gt; 0)
			r = extend(nil, Down, q.y, level.glenda);
		else
			r = nil;

		if (r != nil &amp;&amp; isvalid(level.glenda, r, validpush))
			return r;
		freeroute(r);
	}

	return findroute(level.glenda, p);
}

char *
genlevels(int i)
{
	
	if(i &gt;= numlevels)
		return 0;

	return smprint("level %d", i+1);
}


int
finished(void)
{
	int x, y;
	for(x = 0; x &lt; MazeX; x++)
		for(y = 0; y &lt; MazeY; y++)
			if(level.board[x][y] == Goal)
				return 0;

	return 1;
}

void
eresized(int new)
{
	Point p;

	if(new &amp;&amp; getwindow(display, Refnone) &lt; 0)
		sysfatal("can't reattach to window");
	
	p = Pt(Dx(screen-&gt;r), Dy(screen-&gt;r));

	if(!new || !eqpt(p, boardsize(level.max))) {
		drawlevel();
	}
	drawscreen();
}

void 
main(int argc, char **argv)
{
	Mouse m;
	Event ev;
	int e;
	Route *r;
	int timer;
	Animation a;
	int animate;


	if(argc == 2) 
		levelfile = argv[1];
	else
		levelfile = LEasy;
		
	if(! loadlevels(levelfile)) {
		fprint(2, "usage: %s [levelfile]\n", argv[0]);
		exits("usage");
	}
	buildmenu();

	animate = 0;
	buttons[3] = animate ? "noanimate" : "animate";

	if(initdraw(nil, nil, "sokoban") &lt; 0)
		sysfatal("initdraw failed: %r");
	einit(Emouse|Ekeyboard);

	timer = etimer(0, 200);
	initanimation(&amp;a);

	allocimages();
	glenda = gright;
	eresized(0);

	for(;;) {
		e = event(&amp;ev);
		switch(e) {
		case Emouse:
			m = ev.mouse;
			if(m.buttons&amp;1) {
				stopanimation(&amp;a);
				r = mouse2route(m);
				if (r)
					setupanimation(&amp;a, r);
				if (! animate) {
					while(onestep(&amp;a))
						;
					drawscreen();
				}
			}
			if(m.buttons&amp;2) {
				int l;
				/* levels start from 1 */
				lmenu.lasthit = level.index;
				l=emenuhit(2, &amp;m, &amp;lmenu);
				if(l&gt;=0){
					stopanimation(&amp;a);
					level = levels[l];
					drawlevel();
					drawscreen();
				}
			}
			if(m.buttons&amp;4)
				switch(emenuhit(3, &amp;m, &amp;menu)) {
				case 0:
					stopanimation(&amp;a);
					level = levels[level.index];
					drawlevel();
					drawscreen();
					break;
				case 1:
					stopanimation(&amp;a);
					loadlevels(LEasy);
					buildmenu();
					drawlevel();
					drawscreen();
					break;
				case 2:
					stopanimation(&amp;a);
					loadlevels(LHard);
					buildmenu();
					drawlevel();
					drawscreen();
					break;
				case 3:
					animate = !animate;
					buttons[3] = animate ? "noanimate" : "animate";
					break;
				case 4:
					exits(nil);
				}
			break;

		case Ekeyboard:
			if(level.done)
				break;

			stopanimation(&amp;a);

			switch(ev.kbdc) {
			case 127:
			case 'q':
			case 'Q':
				exits(nil);
			case 'n':
			case 'N':
				if(level.index &lt; numlevels - 1) {
					level = levels[++level.index];
					drawlevel();
					drawscreen();
				}
				break;
			case 'p':
			case 'P':
				if(level.index &gt; 0) {
					level = levels[--level.index];
					drawlevel();
					drawscreen();
				}
				break;
			case 'r':
			case 'R':
				level = levels[level.index];
				drawlevel();
				drawscreen();
				break;
			case 61454:
			case 63488:
			case 61457:
			case 61458:
			case ' ':
				move(key2move(ev.kbdc));
				drawscreen();
				break;
			default:
				// fprint(2, "key: %d]\n", e.kbdc);
				break;
			}
			break;

		default:
			if (e == timer) {
				if (animate)
					onestep(&amp;a);
				else
					while(onestep(&amp;a))
						;
				drawscreen();
			}
			break;
		}

		if(finished()) {
			level.done = 1;
			drawwin();
			drawscreen();
			sleep(3000);
			if(level.index &lt; numlevels - 1) {
				level = levels[++level.index];
				drawlevel();
				drawscreen();
			}
		}
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

