<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/games/sudoku/levels.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/games/sudoku/levels.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;draw.h&gt;

#include "sudoku.h"

void
consumeline(Biobuf *b)
{
	while(Bgetc(b) != '\n')
		;
}

void
fprettyprintbrd(Cell *board)
{
	int x, y, fd;

	fd = create("/tmp/sudoku-print", OWRITE|OTRUNC, 0600);
	if(fd &lt; 0) {
		perror("can not open save file /tmp/sudoku-save");
		return;
	}

	for(x = 0; x &lt; Brdsize; x++) {
		for(y = 0; y &lt; Brdsize; y++) {
			fprint(fd, " ");
			if(board[y*Brdsize + x].digit == -1)
				fprint(fd, ".");
			else
				fprint(fd, "%d", board[y*Brdsize + x].digit+1);

			if(((x*Brdsize + y + 1) % Brdsize) == 0 || (x*Brdsize + y + 1) == Psize)
				fprint(fd, "\n");

			if(((x*Brdsize + y + 1) % 3) == 0 &amp;&amp; ((x*Brdsize + y + 1) % Brdsize) != 0)
				fprint(fd, "|");

			if(((x*Brdsize + y + 1) % 27) == 0 &amp;&amp; ((x*Brdsize + y + 1) % Psize) != 0)
				fprint(fd, " -------------------\n");

		}
	}
	close(fd);
}

void
fprintbrd(int fd, Cell *board)
{
	int i;
	
	for(i = 0; i &lt; Psize; i++) {
		if(board[i].digit == -1)
			fprint(fd, ".");
		else
			fprint(fd, "%d", board[i].digit+1);

		if((i + 1) % Brdsize == 0)
			fprint(fd, "\n");
	}
	for(i = 0; i &lt; Psize; i++) {
		fprint(fd, "%d", board[i].solve+1);
		if((i + 1) % Brdsize == 0)
			fprint(fd, "\n");
	}

	close(fd);
}

int
loadlevel(char *name, Cell *board)
{
	Biobuf *b;
	char c;
	int i;
	
	b = Bopen(name, OREAD);
	if(b == nil) {
		fprint(2, "could not open file %s: %r\n", name);
		return -1;
	}

	i = 0;
	while((c = Bgetc(b)) &gt; 0) {
		switch(c) {
		case '.':
			board[i].digit = -1;
			board[i].locked = 0;
			if(++i == 81)
				goto next;
			break;
		case 0x31:
		case 0x32:
		case 0x33:
		case 0x34:
		case 0x35:
		case 0x36:
		case 0x37:
		case 0x38:
		case 0x39:
			board[i].digit = c - 0x31;
			board[i].locked = 1;
			if(++i == 81)
				goto next;
			break;
		case '\n':
			break;
		default:
			fprint(2, "unknown character in initial board: %c\n", c);
			goto done;
		}
	}
next:
	i = 0;
	while((c = Bgetc(b)) &gt; 0) {
		switch(c) {
		case 0x31:
		case 0x32:
		case 0x33:
		case 0x34:
		case 0x35:
		case 0x36:
		case 0x37:
		case 0x38:
		case 0x39:
			board[i].solve = c - 0x31;
			if(++i == 81)
				goto done;
			break;
		case '\n':
			break;
		default:
			fprint(2, "unknown character in board solution: %c\n", c);
			goto done;
		}
	}

done:
	Bterm(b);

	return i &lt; 81 ? 0 : 1;
}

void
printboard(Cell *board)
{
	int fd;
	
	fd = create("/tmp/sudoku-board", OWRITE|OTRUNC, 0600);
	if(fd &lt; 0) {
		perror("can not open save file /tmp/sudoku-save");
		return;
	}

	fprintbrd(fd, board);

	close(fd);
}

void
savegame(Cell *board)
{
	int fd;
	
	fd = create("/tmp/sudoku-save", OWRITE|OTRUNC, 0600);
	if(fd &lt; 0) {
		perror("can not open save file /tmp/sudoku-save");
		return;
	}

	if(write(fd, board, Psize * sizeof(Cell)) != Psize * sizeof(Cell)) {
		perror("could not save to file");
		close(fd);
	}

	close(fd);
}

int
loadgame(Cell *board)
{
	int fd;

	fd = open("/tmp/sudoku-save", OREAD);
	if(fd &lt; 0) {
		perror("can not open save file /tmp/sudoku-save");
		return -1;
	}

	if(read(fd, board, Psize * sizeof(Cell)) != Psize * sizeof(Cell)) {
		perror("insufficient data in save file");
		close(fd);
		return -1;
	}
	
	close(fd);

	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

