<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/lib9p/auth.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/lib9p/auth.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

typedef struct Afid Afid;

struct Afid
{
	AuthRpc *rpc;
	char *uname;
	char *aname;
	int authok;
	int afd;
};

static uvlong authgen = 1ULL&lt;&lt;63;

void
auth9p(Req *r)
{
	char *spec;
	Afid *afid;
	
	afid = emalloc9p(sizeof(Afid));
	afid-&gt;afd = open("/mnt/factotum/rpc", ORDWR);
	if(afid-&gt;afd &lt; 0)
		goto error;

	if((afid-&gt;rpc = auth_allocrpc(afid-&gt;afd)) == nil)
		goto error;

	if(r-&gt;ifcall.uname[0] == 0)
		goto error;
	afid-&gt;uname = estrdup9p(r-&gt;ifcall.uname);
	afid-&gt;aname = estrdup9p(r-&gt;ifcall.aname);

	spec = r-&gt;srv-&gt;keyspec;
	if(spec == nil)
		spec = "proto=p9any role=server";

	if(auth_rpc(afid-&gt;rpc, "start", spec, strlen(spec)) != ARok)
		goto error;

	r-&gt;afid-&gt;qid.type = QTAUTH;
	r-&gt;afid-&gt;qid.path = ++authgen;
	r-&gt;afid-&gt;qid.vers = 0;
	r-&gt;afid-&gt;omode = ORDWR;
	r-&gt;ofcall.qid = r-&gt;afid-&gt;qid;
	r-&gt;afid-&gt;aux = afid;
	respond(r, nil);
	return;

error:
	if(afid-&gt;rpc)
		auth_freerpc(afid-&gt;rpc);
	if(afid-&gt;uname)
		free(afid-&gt;uname);
	if(afid-&gt;aname)
		free(afid-&gt;aname);
	if(afid-&gt;afd &gt;= 0)
		close(afid-&gt;afd);
	free(afid);
	responderror(r);
}

static int
_authread(Afid *afid, void *data, int count)
{
	AuthInfo *ai;
	
	switch(auth_rpc(afid-&gt;rpc, "read", nil, 0)){
	case ARdone:
		ai = auth_getinfo(afid-&gt;rpc);
		if(ai == nil)
			return -1;
		auth_freeAI(ai);
		if(chatty9p)
			fprint(2, "authenticate %s/%s: ok\n", afid-&gt;uname, afid-&gt;aname);
		afid-&gt;authok = 1;
		return 0;

	case ARok:
		if(count &lt; afid-&gt;rpc-&gt;narg){
			werrstr("authread count too small");
			return -1;
		}
		count = afid-&gt;rpc-&gt;narg;
		memmove(data, afid-&gt;rpc-&gt;arg, count);
		return count;
	
	case ARphase:
	default:
		werrstr("authrpc botch");
		return -1;
	}
}

void
authread(Req *r)
{
	int n;
	Afid *afid;
	Fid *fid;
	
	fid = r-&gt;fid;
	afid = fid-&gt;aux;
	if(afid == nil || r-&gt;fid-&gt;qid.type != QTAUTH){
		respond(r, "not an auth fid");
		return;
	}
	n = _authread(afid, r-&gt;ofcall.data, r-&gt;ifcall.count);
	if(n &lt; 0){
		responderror(r);
		return;
	}
	r-&gt;ofcall.count = n;
	respond(r, nil);
}

void
authwrite(Req *r)
{
	Afid *afid;
	Fid *fid;
	
	fid = r-&gt;fid;
	afid = fid-&gt;aux;
	if(afid == nil || r-&gt;fid-&gt;qid.type != QTAUTH){
		respond(r, "not an auth fid");
		return;
	}
	if(auth_rpc(afid-&gt;rpc, "write", r-&gt;ifcall.data, r-&gt;ifcall.count) != ARok){
		responderror(r);
		return;
	}
	r-&gt;ofcall.count = r-&gt;ifcall.count;
	respond(r, nil);
}

void
authdestroy(Fid *fid)
{
	Afid *afid;
	
	if((fid-&gt;qid.type &amp; QTAUTH) &amp;&amp; (afid = fid-&gt;aux) != nil){
		if(afid-&gt;rpc)
			auth_freerpc(afid-&gt;rpc);
		close(afid-&gt;afd);
		free(afid-&gt;uname);
		free(afid-&gt;aname);
		free(afid);
		fid-&gt;aux = nil;
	}
}

int
authattach(Req *r)
{
	Afid *afid;
	char buf[ERRMAX];
	
	if(r-&gt;afid == nil){
		respond(r, "not authenticated");
		return -1;
	}

	afid = r-&gt;afid-&gt;aux;
	if((r-&gt;afid-&gt;qid.type&amp;QTAUTH) == 0 || afid == nil){
		respond(r, "not an auth fid");
		return -1;
	}

	if(!afid-&gt;authok){
		if(_authread(afid, buf, 0) &lt; 0){
			responderror(r);
			return -1;
		}
	}
	
	if(strcmp(afid-&gt;uname, r-&gt;ifcall.uname) != 0){
		snprint(buf, sizeof buf, "auth uname mismatch: %s vs %s", 
			afid-&gt;uname, r-&gt;ifcall.uname);
		respond(r, buf);
		return -1;
	}

	if(strcmp(afid-&gt;aname, r-&gt;ifcall.aname) != 0){
		snprint(buf, sizeof buf, "auth aname mismatch: %s vs %s", 
			afid-&gt;aname, r-&gt;ifcall.aname);
		respond(r, buf);
		return -1;
	}
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

