<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/lib9p/file.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/lib9p/file.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

/*
 * To avoid deadlock, the following rules must be followed.
 * Always lock child then parent, never parent then child.
 * If holding the free file lock, do not lock any Files.
 */
struct Filelist
{
	File *f;
	Filelist *link;
};

struct Readdir
{
	File *dir;
	Filelist *fl;
};

static QLock filelk;
static File *freefilelist;

static File*
allocfile(void)
{
	int i, a;
	File *f;
	enum { N = 16 };

	qlock(&amp;filelk);
	if(freefilelist == nil){
		f = emalloc9p(N*sizeof(*f));
		for(i=0; i&lt;N-1; i++)
			f[i].aux = &amp;f[i+1];
		f[N-1].aux = nil;
		f[0].allocd = 1;
		freefilelist = f;
	}

	f = freefilelist;
	freefilelist = f-&gt;aux;
	qunlock(&amp;filelk);

	a = f-&gt;allocd;
	memset(f, 0, sizeof *f);
	f-&gt;allocd = a;
	return f;
}

static void
freefile(File *f)
{
	Filelist *fl, *flnext;

	for(fl=f-&gt;filelist; fl; fl=flnext){
		flnext = fl-&gt;link;
		assert(fl-&gt;f == nil);
		free(fl);
	}

	free(f-&gt;name);
	free(f-&gt;uid);
	free(f-&gt;gid);
	free(f-&gt;muid);
	qlock(&amp;filelk);
	assert(f-&gt;ref == 0);
	f-&gt;aux = freefilelist;
	freefilelist = f;
	qunlock(&amp;filelk);
}

static void
cleanfilelist(File *f)
{
	Filelist **l;
	Filelist *fl;
	
	/*
	 * can't delete filelist structures while there
	 * are open readers of this directory, because
	 * they might have references to the structures.
	 * instead, just leave the empty refs in the list
	 * until there is no activity and then clean up.
	 */
	if(f-&gt;readers.ref != 0)
		return;
	if(f-&gt;nxchild == 0)
		return;

	/*
	 * no dir readers, file is locked, and
	 * there are empty entries in the file list.
	 * clean them out.
	 */
	for(l=&amp;f-&gt;filelist; fl=*l; ){
		if(fl-&gt;f == nil){
			*l = (*l)-&gt;link;
			free(fl);
		}else
			l = &amp;(*l)-&gt;link;
	}
	f-&gt;nxchild = 0;
}

void
closefile(File *f)
{
	if(decref(f) == 0){
		f-&gt;tree-&gt;destroy(f);
		freefile(f);
	}
}

static void
nop(File*)
{
}

int
removefile(File *f)
{
	File *fp;
	Filelist *fl;
	
	fp = f-&gt;parent;
	if(fp == nil){
		werrstr("no parent");
		closefile(f);
		return -1;
	}

	if(fp == f){
		werrstr("cannot remove root");
		closefile(f);
		return -1;
	}

	wlock(f);
	wlock(fp);
	if(f-&gt;nchild != 0){
		werrstr("has children");
		wunlock(fp);
		wunlock(f);
		closefile(f);
		return -1;
	}

	if(f-&gt;parent != fp){
		werrstr("parent changed underfoot");
		wunlock(fp);
		wunlock(f);
		closefile(f);
		return -1;
	}

	for(fl=fp-&gt;filelist; fl; fl=fl-&gt;link)
		if(fl-&gt;f == f)
			break;
	assert(fl != nil &amp;&amp; fl-&gt;f == f);

	fl-&gt;f = nil;
	fp-&gt;nchild--;
	fp-&gt;nxchild++;
	f-&gt;parent = nil;
	wunlock(f);

	cleanfilelist(fp);
	wunlock(fp);

	closefile(fp);	/* reference from child */
	closefile(f);	/* reference from tree */
	closefile(f);
	return 0;
}

File*
createfile(File *fp, char *name, char *uid, ulong perm, void *aux)
{
	File *f;
	Filelist **l, *fl;
	Tree *t;

	if((fp-&gt;qid.type&amp;QTDIR) == 0){
		werrstr("create in non-directory");
		return nil;
	}

	wlock(fp);
	/*
	 * We might encounter blank spots along the
	 * way due to deleted files that have not yet
	 * been flushed from the file list.  Don't reuse
	 * those - some apps (e.g., omero) depend on
	 * the file order reflecting creation order. 
	 * Always create at the end of the list.
	 */
	for(l=&amp;fp-&gt;filelist; fl=*l; l=&amp;fl-&gt;link){
		if(fl-&gt;f &amp;&amp; strcmp(fl-&gt;f-&gt;name, name) == 0){
			wunlock(fp);
			werrstr("file already exists");
			return nil;
		}
	}
	
	fl = emalloc9p(sizeof *fl);
	*l = fl;

	f = allocfile();
	f-&gt;name = estrdup9p(name);
	f-&gt;uid = estrdup9p(uid ? uid : fp-&gt;uid);
	f-&gt;gid = estrdup9p(fp-&gt;gid);
	f-&gt;muid = estrdup9p(uid ? uid : "unknown");
	f-&gt;aux = aux;
	f-&gt;mode = perm;

	t = fp-&gt;tree;
	lock(&amp;t-&gt;genlock);
	f-&gt;qid.path = t-&gt;qidgen++;
	unlock(&amp;t-&gt;genlock);
	if(perm &amp; DMDIR)
		f-&gt;qid.type |= QTDIR;
	if(perm &amp; DMAPPEND)
		f-&gt;qid.type |= QTAPPEND;
	if(perm &amp; DMEXCL)
		f-&gt;qid.type |= QTEXCL;

	f-&gt;mode = perm;
	f-&gt;atime = f-&gt;mtime = time(0);
	f-&gt;length = 0;
	f-&gt;parent = fp;
	incref(fp);
	f-&gt;tree = fp-&gt;tree;

	incref(f);	/* being returned */
	incref(f);	/* for the tree */
	fl-&gt;f = f;
	fp-&gt;nchild++;
	wunlock(fp);

	return f;
}

static File*
walkfile1(File *dir, char *elem)
{
	File *fp;
	Filelist *fl;

	rlock(dir);
	if(strcmp(elem, "..") == 0){
		fp = dir-&gt;parent;
		incref(fp);
		runlock(dir);
		closefile(dir);
		return fp;
	}

	fp = nil;
	for(fl=dir-&gt;filelist; fl; fl=fl-&gt;link)
		if(fl-&gt;f &amp;&amp; strcmp(fl-&gt;f-&gt;name, elem)==0){
			fp = fl-&gt;f;
			incref(fp);
			break;
		}

	runlock(dir);
	closefile(dir);
	return fp;
}

File*
walkfile(File *f, char *path)
{
	char *os, *s, *nexts;

	if(strchr(path, '/') == nil)
		return walkfile1(f, path);	/* avoid malloc */

	os = s = estrdup9p(path);
	for(; *s; s=nexts){
		if(nexts = strchr(s, '/'))
			*nexts++ = '\0';
		else
			nexts = s+strlen(s);
		f = walkfile1(f, s);
		if(f == nil)
			break;
	}
	free(os);
	return f;
}
			
Tree*
alloctree(char *uid, char *gid, ulong mode, void (*destroy)(File*))
{
	char *muid;
	Tree *t;
	File *f;

	t = emalloc9p(sizeof *t);
	f = allocfile();
	f-&gt;name = estrdup9p("/");
	if(uid == nil){
		uid = getuser();
		if(uid == nil)
			uid = "none";
	}
	uid = estrdup9p(uid);

	if(gid == nil)
		gid = estrdup9p(uid);
	else
		gid = estrdup9p(gid);

	muid = estrdup9p(uid);

	f-&gt;qid = (Qid){0, 0, QTDIR};
	f-&gt;length = 0;
	f-&gt;atime = f-&gt;mtime = time(0);
	f-&gt;mode = DMDIR | mode;
	f-&gt;tree = t;
	f-&gt;parent = f;
	f-&gt;uid = uid;
	f-&gt;gid = gid;
	f-&gt;muid = muid;

	incref(f);
	t-&gt;root = f;
	t-&gt;qidgen = 0;
	t-&gt;dirqidgen = 1;
	if(destroy == nil)
		destroy = nop;
	t-&gt;destroy = destroy;

	return t;
}

static void
_freefiles(File *f)
{
	Filelist *fl, *flnext;

	for(fl=f-&gt;filelist; fl; fl=flnext){
		flnext = fl-&gt;link;
		_freefiles(fl-&gt;f);
		free(fl);
	}

	f-&gt;tree-&gt;destroy(f);
	freefile(f);
}

void
freetree(Tree *t)
{
	_freefiles(t-&gt;root);
	free(t);
}

Readdir*
opendirfile(File *dir)
{
	Readdir *r;

	rlock(dir);
	if((dir-&gt;mode &amp; DMDIR)==0){
		runlock(dir);
		return nil;
	}
	r = emalloc9p(sizeof(*r));

	/*
	 * This reference won't go away while we're 
	 * using it because file list entries are not freed
	 * until the directory is removed and all refs to
	 * it (our fid is one!) have gone away.
	 */
	r-&gt;fl = dir-&gt;filelist;
	r-&gt;dir = dir;
	incref(&amp;dir-&gt;readers);
	runlock(dir);
	return r;
}

long
readdirfile(Readdir *r, uchar *buf, long n)
{
	long x, m;
	Filelist *fl;

	for(fl=r-&gt;fl, m=0; fl &amp;&amp; m+2&lt;=n; fl=fl-&gt;link, m+=x){
		if(fl-&gt;f == nil)
			x = 0;
		else if((x=convD2M(fl-&gt;f, buf+m, n-m)) &lt;= BIT16SZ)
			break;
	}
	r-&gt;fl = fl;
	return m;
}

void
closedirfile(Readdir *r)
{
	if(decref(&amp;r-&gt;dir-&gt;readers) == 0){
		wlock(r-&gt;dir);
		cleanfilelist(r-&gt;dir);
		wunlock(r-&gt;dir);
	}
	free(r);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

