<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/lib9p/req.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/lib9p/req.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;thread.h&gt;
#include &lt;9p.h&gt;

static void
increqref(void *v)
{
	Req *r;

	r = v;
	if(r){
if(chatty9p &gt; 1)
	fprint(2, "increfreq %p %ld\n", r, r-&gt;ref.ref);
		incref(&amp;r-&gt;ref);
	}
}

Reqpool*
allocreqpool(void (*destroy)(Req*))
{
	Reqpool *f;

	f = emalloc9p(sizeof *f);
	f-&gt;map = allocmap(increqref);
	f-&gt;destroy = destroy;
	return f;
}

void
freereqpool(Reqpool *p)
{
	freemap(p-&gt;map, (void(*)(void*))p-&gt;destroy);
	free(p);
}	

Req*
allocreq(Reqpool *pool, ulong tag)
{
	Req *r;

	r = emalloc9p(sizeof *r);
	r-&gt;tag = tag;
	r-&gt;pool = pool;

	increqref(r);
	increqref(r);
	if(caninsertkey(pool-&gt;map, tag, r) == 0){
		closereq(r);
		closereq(r);
		return nil;
	}

	return r;
}

Req*
lookupreq(Reqpool *pool, ulong tag)
{
if(chatty9p &gt; 1)
	fprint(2, "lookupreq %lud\n", tag);
	return lookupkey(pool-&gt;map, tag);
}

void
closereq(Req *r)
{
	int i;

	if(r == nil)
		return;

if(chatty9p &gt; 1)
	fprint(2, "closereq %p %ld\n", r, r-&gt;ref.ref);

	if(decref(&amp;r-&gt;ref) == 0){
		if(r-&gt;fid)
			closefid(r-&gt;fid);
		if(r-&gt;newfid)
			closefid(r-&gt;newfid);
		if(r-&gt;afid)
			closefid(r-&gt;afid);
		if(r-&gt;oldreq)
			closereq(r-&gt;oldreq);
		for(i=0; i&lt;r-&gt;nflush; i++)
			respond(r-&gt;flush[i], nil);
		free(r-&gt;flush);
		switch(r-&gt;ifcall.type){
		case Tstat:
			free(r-&gt;ofcall.stat);
			free(r-&gt;d.name);
			free(r-&gt;d.uid);
			free(r-&gt;d.gid);
			free(r-&gt;d.muid);
			break;
		}
		if(r-&gt;pool-&gt;destroy)
			r-&gt;pool-&gt;destroy(r);
		free(r-&gt;buf);
		free(r-&gt;rbuf);
		free(r);
	}
}

Req*
removereq(Reqpool *pool, ulong tag)
{
if(chatty9p &gt; 1)
	fprint(2, "removereq %lud\n", tag);
	return deletekey(pool-&gt;map, tag);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

