<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/9sys/convM2S.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/9sys/convM2S.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;fcall.h&gt;

static
uchar*
gstring(uchar *p, uchar *ep, char **s)
{
	uint n;

	if(p+BIT16SZ &gt; ep)
		return nil;
	n = GBIT16(p);
	p += BIT16SZ - 1;
	if(p+n+1 &gt; ep)
		return nil;
	/* move it down, on top of count, to make room for '\0' */
	memmove(p, p + 1, n);
	p[n] = '\0';
	*s = (char*)p;
	p += n+1;
	return p;
}

static
uchar*
gqid(uchar *p, uchar *ep, Qid *q)
{
	if(p+QIDSZ &gt; ep)
		return nil;
	q-&gt;type = GBIT8(p);
	p += BIT8SZ;
	q-&gt;vers = GBIT32(p);
	p += BIT32SZ;
	q-&gt;path = GBIT64(p);
	p += BIT64SZ;
	return p;
}

/*
 * no syntactic checks.
 * three causes for error:
 *  1. message size field is incorrect
 *  2. input buffer too short for its own data (counts too long, etc.)
 *  3. too many names or qids
 * gqid() and gstring() return nil if they would reach beyond buffer.
 * main switch statement checks range and also can fall through
 * to test at end of routine.
 */
uint
convM2S(uchar *ap, uint nap, Fcall *f)
{
	uchar *p, *ep;
	uint i, size;

	p = ap;
	ep = p + nap;

	if(p+BIT32SZ+BIT8SZ+BIT16SZ &gt; ep)
		return 0;
	size = GBIT32(p);
	p += BIT32SZ;

	if(size &lt; BIT32SZ+BIT8SZ+BIT16SZ)
		return 0;

	f-&gt;type = GBIT8(p);
	p += BIT8SZ;
	f-&gt;tag = GBIT16(p);
	p += BIT16SZ;

	switch(f-&gt;type)
	{
	default:
		return 0;

	case Tversion:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;msize = GBIT32(p);
		p += BIT32SZ;
		p = gstring(p, ep, &amp;f-&gt;version);
		break;

	case Tflush:
		if(p+BIT16SZ &gt; ep)
			return 0;
		f-&gt;oldtag = GBIT16(p);
		p += BIT16SZ;
		break;

	case Tauth:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;afid = GBIT32(p);
		p += BIT32SZ;
		p = gstring(p, ep, &amp;f-&gt;uname);
		if(p == nil)
			break;
		p = gstring(p, ep, &amp;f-&gt;aname);
		if(p == nil)
			break;
		break;

	case Tattach:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;afid = GBIT32(p);
		p += BIT32SZ;
		p = gstring(p, ep, &amp;f-&gt;uname);
		if(p == nil)
			break;
		p = gstring(p, ep, &amp;f-&gt;aname);
		if(p == nil)
			break;
		break;

	case Twalk:
		if(p+BIT32SZ+BIT32SZ+BIT16SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;newfid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;nwname = GBIT16(p);
		p += BIT16SZ;
		if(f-&gt;nwname &gt; MAXWELEM)
			return 0;
		for(i=0; i&lt;f-&gt;nwname; i++){
			p = gstring(p, ep, &amp;f-&gt;wname[i]);
			if(p == nil)
				break;
		}
		break;

	case Topen:
		if(p+BIT32SZ+BIT8SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;mode = GBIT8(p);
		p += BIT8SZ;
		break;

	case Tcreate:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		p = gstring(p, ep, &amp;f-&gt;name);
		if(p == nil)
			break;
		if(p+BIT32SZ+BIT8SZ &gt; ep)
			return 0;
		f-&gt;perm = GBIT32(p);
		p += BIT32SZ;
		f-&gt;mode = GBIT8(p);
		p += BIT8SZ;
		break;

	case Tread:
		if(p+BIT32SZ+BIT64SZ+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;offset = GBIT64(p);
		p += BIT64SZ;
		f-&gt;count = GBIT32(p);
		p += BIT32SZ;
		break;

	case Twrite:
		if(p+BIT32SZ+BIT64SZ+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;offset = GBIT64(p);
		p += BIT64SZ;
		f-&gt;count = GBIT32(p);
		p += BIT32SZ;
		if(p+f-&gt;count &gt; ep)
			return 0;
		f-&gt;data = (char*)p;
		p += f-&gt;count;
		break;

	case Tclunk:
	case Tremove:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		break;

	case Tstat:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		break;

	case Twstat:
		if(p+BIT32SZ+BIT16SZ &gt; ep)
			return 0;
		f-&gt;fid = GBIT32(p);
		p += BIT32SZ;
		f-&gt;nstat = GBIT16(p);
		p += BIT16SZ;
		if(p+f-&gt;nstat &gt; ep)
			return 0;
		f-&gt;stat = p;
		p += f-&gt;nstat;
		break;

/*
 */
	case Rversion:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;msize = GBIT32(p);
		p += BIT32SZ;
		p = gstring(p, ep, &amp;f-&gt;version);
		break;

	case Rerror:
		p = gstring(p, ep, &amp;f-&gt;ename);
		break;

	case Rflush:
		break;

	case Rauth:
		p = gqid(p, ep, &amp;f-&gt;aqid);
		if(p == nil)
			break;
		break;

	case Rattach:
		p = gqid(p, ep, &amp;f-&gt;qid);
		if(p == nil)
			break;
		break;

	case Rwalk:
		if(p+BIT16SZ &gt; ep)
			return 0;
		f-&gt;nwqid = GBIT16(p);
		p += BIT16SZ;
		if(f-&gt;nwqid &gt; MAXWELEM)
			return 0;
		for(i=0; i&lt;f-&gt;nwqid; i++){
			p = gqid(p, ep, &amp;f-&gt;wqid[i]);
			if(p == nil)
				break;
		}
		break;

	case Ropen:
	case Rcreate:
		p = gqid(p, ep, &amp;f-&gt;qid);
		if(p == nil)
			break;
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;iounit = GBIT32(p);
		p += BIT32SZ;
		break;

	case Rread:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;count = GBIT32(p);
		p += BIT32SZ;
		if(p+f-&gt;count &gt; ep)
			return 0;
		f-&gt;data = (char*)p;
		p += f-&gt;count;
		break;

	case Rwrite:
		if(p+BIT32SZ &gt; ep)
			return 0;
		f-&gt;count = GBIT32(p);
		p += BIT32SZ;
		break;

	case Rclunk:
	case Rremove:
		break;

	case Rstat:
		if(p+BIT16SZ &gt; ep)
			return 0;
		f-&gt;nstat = GBIT16(p);
		p += BIT16SZ;
		if(p+f-&gt;nstat &gt; ep)
			return 0;
		f-&gt;stat = p;
		p += f-&gt;nstat;
		break;

	case Rwstat:
		break;
	}

	if(p==nil || p&gt;ep)
		return 0;
	if(ap+size == p)
		return size;
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

