<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/9sys/convS2M.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/9sys/convS2M.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include	&lt;u.h&gt;
#include	&lt;libc.h&gt;
#include	&lt;fcall.h&gt;

static
uchar*
pstring(uchar *p, char *s)
{
	uint n;

	if(s == nil){
		PBIT16(p, 0);
		p += BIT16SZ;
		return p;
	}

	n = strlen(s);
	/*
	 * We are moving the string before the length,
	 * so you can S2M a struct into an existing message
	 */
	memmove(p + BIT16SZ, s, n);
	PBIT16(p, n);
	p += n + BIT16SZ;
	return p;
}

static
uchar*
pqid(uchar *p, Qid *q)
{
	PBIT8(p, q-&gt;type);
	p += BIT8SZ;
	PBIT32(p, q-&gt;vers);
	p += BIT32SZ;
	PBIT64(p, q-&gt;path);
	p += BIT64SZ;
	return p;
}

static
uint
stringsz(char *s)
{
	if(s == nil)
		return BIT16SZ;

	return BIT16SZ+strlen(s);
}

uint
sizeS2M(Fcall *f)
{
	uint n;
	int i;

	n = 0;
	n += BIT32SZ;	/* size */
	n += BIT8SZ;	/* type */
	n += BIT16SZ;	/* tag */

	switch(f-&gt;type)
	{
	default:
		return 0;

	case Tversion:
		n += BIT32SZ;
		n += stringsz(f-&gt;version);
		break;

	case Tflush:
		n += BIT16SZ;
		break;

	case Tauth:
		n += BIT32SZ;
		n += stringsz(f-&gt;uname);
		n += stringsz(f-&gt;aname);
		break;

	case Tattach:
		n += BIT32SZ;
		n += BIT32SZ;
		n += stringsz(f-&gt;uname);
		n += stringsz(f-&gt;aname);
		break;

	case Twalk:
		n += BIT32SZ;
		n += BIT32SZ;
		n += BIT16SZ;
		for(i=0; i&lt;f-&gt;nwname; i++)
			n += stringsz(f-&gt;wname[i]);
		break;

	case Topen:
		n += BIT32SZ;
		n += BIT8SZ;
		break;

	case Tcreate:
		n += BIT32SZ;
		n += stringsz(f-&gt;name);
		n += BIT32SZ;
		n += BIT8SZ;
		break;

	case Tread:
		n += BIT32SZ;
		n += BIT64SZ;
		n += BIT32SZ;
		break;

	case Twrite:
		n += BIT32SZ;
		n += BIT64SZ;
		n += BIT32SZ;
		n += f-&gt;count;
		break;

	case Tclunk:
	case Tremove:
		n += BIT32SZ;
		break;

	case Tstat:
		n += BIT32SZ;
		break;

	case Twstat:
		n += BIT32SZ;
		n += BIT16SZ;
		n += f-&gt;nstat;
		break;
/*
 */

	case Rversion:
		n += BIT32SZ;
		n += stringsz(f-&gt;version);
		break;

	case Rerror:
		n += stringsz(f-&gt;ename);
		break;

	case Rflush:
		break;

	case Rauth:
		n += QIDSZ;
		break;

	case Rattach:
		n += QIDSZ;
		break;

	case Rwalk:
		n += BIT16SZ;
		n += f-&gt;nwqid*QIDSZ;
		break;

	case Ropen:
	case Rcreate:
		n += QIDSZ;
		n += BIT32SZ;
		break;

	case Rread:
		n += BIT32SZ;
		n += f-&gt;count;
		break;

	case Rwrite:
		n += BIT32SZ;
		break;

	case Rclunk:
		break;

	case Rremove:
		break;

	case Rstat:
		n += BIT16SZ;
		n += f-&gt;nstat;
		break;

	case Rwstat:
		break;
	}
	return n;
}

uint
convS2M(Fcall *f, uchar *ap, uint nap)
{
	uchar *p;
	uint i, size;

	size = sizeS2M(f);
	if(size == 0)
		return 0;
	if(size &gt; nap)
		return 0;

	p = (uchar*)ap;

	PBIT32(p, size);
	p += BIT32SZ;
	PBIT8(p, f-&gt;type);
	p += BIT8SZ;
	PBIT16(p, f-&gt;tag);
	p += BIT16SZ;

	switch(f-&gt;type)
	{
	default:
		return 0;

	case Tversion:
		PBIT32(p, f-&gt;msize);
		p += BIT32SZ;
		p = pstring(p, f-&gt;version);
		break;

	case Tflush:
		PBIT16(p, f-&gt;oldtag);
		p += BIT16SZ;
		break;

	case Tauth:
		PBIT32(p, f-&gt;afid);
		p += BIT32SZ;
		p  = pstring(p, f-&gt;uname);
		p  = pstring(p, f-&gt;aname);
		break;

	case Tattach:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT32(p, f-&gt;afid);
		p += BIT32SZ;
		p  = pstring(p, f-&gt;uname);
		p  = pstring(p, f-&gt;aname);
		break;

	case Twalk:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT32(p, f-&gt;newfid);
		p += BIT32SZ;
		PBIT16(p, f-&gt;nwname);
		p += BIT16SZ;
		if(f-&gt;nwname &gt; MAXWELEM)
			return 0;
		for(i=0; i&lt;f-&gt;nwname; i++)
			p = pstring(p, f-&gt;wname[i]);
		break;

	case Topen:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT8(p, f-&gt;mode);
		p += BIT8SZ;
		break;

	case Tcreate:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		p = pstring(p, f-&gt;name);
		PBIT32(p, f-&gt;perm);
		p += BIT32SZ;
		PBIT8(p, f-&gt;mode);
		p += BIT8SZ;
		break;

	case Tread:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT64(p, f-&gt;offset);
		p += BIT64SZ;
		PBIT32(p, f-&gt;count);
		p += BIT32SZ;
		break;

	case Twrite:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT64(p, f-&gt;offset);
		p += BIT64SZ;
		PBIT32(p, f-&gt;count);
		p += BIT32SZ;
		memmove(p, f-&gt;data, f-&gt;count);
		p += f-&gt;count;
		break;

	case Tclunk:
	case Tremove:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		break;

	case Tstat:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		break;

	case Twstat:
		PBIT32(p, f-&gt;fid);
		p += BIT32SZ;
		PBIT16(p, f-&gt;nstat);
		p += BIT16SZ;
		memmove(p, f-&gt;stat, f-&gt;nstat);
		p += f-&gt;nstat;
		break;
/*
 */

	case Rversion:
		PBIT32(p, f-&gt;msize);
		p += BIT32SZ;
		p = pstring(p, f-&gt;version);
		break;

	case Rerror:
		p = pstring(p, f-&gt;ename);
		break;

	case Rflush:
		break;

	case Rauth:
		p = pqid(p, &amp;f-&gt;aqid);
		break;

	case Rattach:
		p = pqid(p, &amp;f-&gt;qid);
		break;

	case Rwalk:
		PBIT16(p, f-&gt;nwqid);
		p += BIT16SZ;
		if(f-&gt;nwqid &gt; MAXWELEM)
			return 0;
		for(i=0; i&lt;f-&gt;nwqid; i++)
			p = pqid(p, &amp;f-&gt;wqid[i]);
		break;

	case Ropen:
	case Rcreate:
		p = pqid(p, &amp;f-&gt;qid);
		PBIT32(p, f-&gt;iounit);
		p += BIT32SZ;
		break;

	case Rread:
		PBIT32(p, f-&gt;count);
		p += BIT32SZ;
		memmove(p, f-&gt;data, f-&gt;count);
		p += f-&gt;count;
		break;

	case Rwrite:
		PBIT32(p, f-&gt;count);
		p += BIT32SZ;
		break;

	case Rclunk:
		break;

	case Rremove:
		break;

	case Rstat:
		PBIT16(p, f-&gt;nstat);
		p += BIT16SZ;
		memmove(p, f-&gt;stat, f-&gt;nstat);
		p += f-&gt;nstat;
		break;

	case Rwstat:
		break;
	}
	if(size != p-ap)
		return 0;
	return size;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

