<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/port/cleanname.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/port/cleanname.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

/*
 * In place, rewrite name to compress multiple /, eliminate ., and process ..
 */
#define SEP(x)	((x)=='/' || (x) == 0)
char*
cleanname(char *name)
{
	char *s;	/* source of copy */
	char *d;	/* destination of copy */
	char *d0;	/* start of path afer the root name */
	Rune r;
	int rooted;

	if(name[0] == 0)
		return strcpy(name, ".");
	rooted = 0;
	d0 = name;
	if(d0[0] == '#'){
		if(d0[1] == 0)
			return d0;
		d0  += 1 + chartorune(&amp;r, d0+1); /* ignore slash: #/ */
		while(!SEP(*d0))
			d0 += chartorune(&amp;r, d0);
		if(d0 == 0)
			return name;
		d0++;	/* keep / after #&lt;name&gt; */
		rooted = 1;
	}else if(d0[0] == '/'){
		rooted = 1;
		d0++;
	}

	s = d0;
	if(rooted){
		/* skip extra '/' at root name */
		for(; *s == '/'; s++)
			;
	}
	/* remove dup slashes */
	for(d = d0; *s != 0; s++){
		*d++ = *s;
		if(*s == '/')
			while(s[1] == '/')
				s++;
	}
	*d = 0;

	d = d0;
	s = d0;
	while(*s != 0){
		if(s[0] == '.' &amp;&amp; SEP(s[1])){
			if(s[1] == 0)
				break;
			s+= 2;
			continue;
		}
		if(s[0] == '.' &amp;&amp; s[1] == '.' &amp;&amp; SEP(s[2])){
			if(d == d0){
				if(rooted){
					/* /../x -&gt; /x */
					if(s[2] == 0)
						break;
					s += 3;
					continue;
				}else{
					/* ../x -&gt; ../x; and never collect ../ */
					d0 += 3;
				}
			}
			if(d &gt; d0){
				/* a/../x -&gt; x */
				assert(d-2 &gt;= d0 &amp;&amp; d[-1] == '/');
				for(d -= 2; d &gt; d0 &amp;&amp; d[-1] != '/'; d--)
						;
				if(s[2] == 0)
					break;
				s += 3;
				continue;
			}
		}
		while(!SEP(*s))
			*d++ = *s++;
		if(*s == 0)
			break;
		
		*d++ = *s++;
	}
	*d = 0;
	if(d-1 &gt; name &amp;&amp; d[-1] == '/')	/* thanks to #/ */
		*--d = 0;
	if(name[0] == 0)
		strcpy(name, ".");
	return name;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

