<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/port/frexp.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/port/frexp.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

/*
 * this is big/little endian non-portable
 * it gets the endian from the FPdbleword
 * union in u.h.
 */
#define	MASK	0x7ffL
#define	SHIFT	20
#define	BIAS	1022L
#define	SIG	52

double
frexp(double d, int *ep)
{
	FPdbleword x, a;

	*ep = 0;
	/* order matters: only isNaN can operate on NaN */
	if(isNaN(d) || isInf(d, 0) || d == 0)
		return d;
	x.x = d;
	a.x = fabs(d);
	if((a.hi &gt;&gt; SHIFT) == 0){	/* normalize subnormal numbers */
		x.x = (double)(1ULL&lt;&lt;SIG) * d;
		*ep = -SIG;
	}
	*ep += ((x.hi &gt;&gt; SHIFT) &amp; MASK) - BIAS;
	x.hi &amp;= ~(MASK &lt;&lt; SHIFT);
	x.hi |= BIAS &lt;&lt; SHIFT;
	return x.x;
}

double
ldexp(double d, int deltae)
{
	int e, bits;
	FPdbleword x;
	ulong z;

	if(d == 0)
		return 0;
	x.x = d;
	e = (x.hi &gt;&gt; SHIFT) &amp; MASK;
	if(deltae &gt;= 0 || e+deltae &gt;= 1){	/* no underflow */
		e += deltae;
		if(e &gt;= MASK){		/* overflow */
			if(d &lt; 0)
				return Inf(-1);
			return Inf(1);
		}
	}else{	/* underflow gracefully */
		deltae = -deltae;
		/* need to shift d right deltae */
		if(e &gt; 1){		/* shift e-1 by exponent manipulation */
			deltae -= e-1;
			e = 1;
		}
		if(deltae &gt; 0 &amp;&amp; e==1){	/* shift 1 by switch from 1.fff to 0.1ff */
			deltae--;
			e = 0;
			x.lo &gt;&gt;= 1;
			x.lo |= (x.hi&amp;1)&lt;&lt;31;
			z = x.hi &amp; ((1&lt;&lt;SHIFT)-1);
			x.hi &amp;= ~((1&lt;&lt;SHIFT)-1);
			x.hi |= (1&lt;&lt;(SHIFT-1)) | (z&gt;&gt;1);
		}
		while(deltae &gt; 0){		/* shift bits down */
			bits = deltae;
			if(bits &gt; SHIFT)
				bits = SHIFT;
			x.lo &gt;&gt;= bits;
			x.lo |= (x.hi&amp;((1&lt;&lt;bits)-1)) &lt;&lt; (32-bits);
			z = x.hi &amp; ((1&lt;&lt;SHIFT)-1);
			x.hi &amp;= ~((1&lt;&lt;SHIFT)-1);
			x.hi |= z&gt;&gt;bits;
			deltae -= bits;
		}
	}
	x.hi &amp;= ~(MASK &lt;&lt; SHIFT);
	x.hi |= (long)e &lt;&lt; SHIFT;
	return x.x;
}

double
modf(double d, double *ip)
{
	FPdbleword x;
	int e;

	x.x = d;
	e = (x.hi &gt;&gt; SHIFT) &amp; MASK;
	if(e == MASK){
		*ip = d;
		if(x.lo != 0 || (x.hi &amp; 0xfffffL) != 0)	/* NaN */
			return d;
		/* ±Inf */
		x.hi &amp;= 0x80000000L;
		return x.x;
	}
	if(d &lt; 1) {
		if(d &lt; 0) {
			x.x = modf(-d, ip);
			*ip = -*ip;
			return -x.x;
		}
		*ip = 0;
		return d;
	}
	e -= BIAS;
	if(e &lt;= SHIFT+1) {
		x.hi &amp;= ~(0x1fffffL &gt;&gt; e);
		x.lo = 0;
	} else
	if(e &lt;= SHIFT+33)
		x.lo &amp;= ~(0x7fffffffL &gt;&gt; (e-SHIFT-2));
	*ip = x.x;
	return d - x.x;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

