<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libc/port/u32.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libc/port/u32.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;

int
dec32(uchar *dest, int ndest, char *src, int nsrc)
{
	char *s, *tab;
	uchar *start;
	int i, u[8];

	if(ndest+1 &lt; (5*nsrc+7)/8)
		return -1;
	start = dest;
	tab = "23456789abcdefghijkmnpqrstuvwxyz";
	while(nsrc&gt;=8){
		for(i=0; i&lt;8; i++){
			s = strchr(tab,(int)src[i]);
			u[i] = s ? s-tab : 0;
		}
		*dest++ = (u[0]&lt;&lt;3) | (0x7 &amp; (u[1]&gt;&gt;2));
		*dest++ = ((0x3 &amp; u[1])&lt;&lt;6) | (u[2]&lt;&lt;1) | (0x1 &amp; (u[3]&gt;&gt;4));
		*dest++ = ((0xf &amp; u[3])&lt;&lt;4) | (0xf &amp; (u[4]&gt;&gt;1));
		*dest++ = ((0x1 &amp; u[4])&lt;&lt;7) | (u[5]&lt;&lt;2) | (0x3 &amp; (u[6]&gt;&gt;3));
		*dest++ = ((0x7 &amp; u[6])&lt;&lt;5) | u[7];
		src  += 8;
		nsrc -= 8;
	}
	if(nsrc &gt; 0){
		if(nsrc == 1 || nsrc == 3 || nsrc == 6)
			return -1;
		for(i=0; i&lt;nsrc; i++){
			s = strchr(tab,(int)src[i]);
			u[i] = s ? s-tab : 0;
		}
		*dest++ = (u[0]&lt;&lt;3) | (0x7 &amp; (u[1]&gt;&gt;2));
		if(nsrc == 2)
			goto out;
		*dest++ = ((0x3 &amp; u[1])&lt;&lt;6) | (u[2]&lt;&lt;1) | (0x1 &amp; (u[3]&gt;&gt;4));
		if(nsrc == 4)
			goto out;
		*dest++ = ((0xf &amp; u[3])&lt;&lt;4) | (0xf &amp; (u[4]&gt;&gt;1));
		if(nsrc == 5)
			goto out;
		*dest++ = ((0x1 &amp; u[4])&lt;&lt;7) | (u[5]&lt;&lt;2) | (0x3 &amp; (u[6]&gt;&gt;3));
	}
out:
	return dest-start;
}

int
enc32(char *dest, int ndest, uchar *src, int nsrc)
{
	char *tab, *start;
	int j;

	if(ndest &lt;= (8*nsrc+4)/5 )
		return -1;
	start = dest;
	tab = "23456789abcdefghijkmnpqrstuvwxyz";
	while(nsrc&gt;=5){
		j = (0x1f &amp; (src[0]&gt;&gt;3));
		*dest++ = tab[j];
		j = (0x1c &amp; (src[0]&lt;&lt;2)) | (0x03 &amp; (src[1]&gt;&gt;6));
		*dest++ = tab[j];
		j = (0x1f &amp; (src[1]&gt;&gt;1));
		*dest++ = tab[j];
		j = (0x10 &amp; (src[1]&lt;&lt;4)) | (0x0f &amp; (src[2]&gt;&gt;4));
		*dest++ = tab[j];
		j = (0x1e &amp; (src[2]&lt;&lt;1)) | (0x01 &amp; (src[3]&gt;&gt;7));
		*dest++ = tab[j];
		j = (0x1f &amp; (src[3]&gt;&gt;2));
		*dest++ = tab[j];
		j = (0x18 &amp; (src[3]&lt;&lt;3)) | (0x07 &amp; (src[4]&gt;&gt;5));
		*dest++ = tab[j];
		j = (0x1f &amp; (src[4]));
		*dest++ = tab[j];
		src  += 5;
		nsrc -= 5;
	}
	if(nsrc){
		j = (0x1f &amp; (src[0]&gt;&gt;3));
		*dest++ = tab[j];
		j = (0x1c &amp; (src[0]&lt;&lt;2));
		if(nsrc == 1)
			goto out;
		j |= (0x03 &amp; (src[1]&gt;&gt;6));
		*dest++ = tab[j];
		j = (0x1f &amp; (src[1]&gt;&gt;1));
		if(nsrc == 2)
			goto out;
		*dest++ = tab[j];
		j = (0x10 &amp; (src[1]&lt;&lt;4));
		if(nsrc == 3)
			goto out;
		j |= (0x0f &amp; (src[2]&gt;&gt;4));
		*dest++ = tab[j];
		j = (0x1e &amp; (src[2]&lt;&lt;1));
		if(nsrc == 4)
			goto out;
		j |= (0x01 &amp; (src[3]&gt;&gt;7));
		*dest++ = tab[j];
		j = (0x1f &amp; (src[3]&gt;&gt;2));
		*dest++ = tab[j];
		j = (0x18 &amp; (src[3]&lt;&lt;3));
out:
		*dest++ = tab[j];
	}
	*dest = 0;
	return dest-start;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

