<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/button.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/button.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Button Button;

struct Button
{
	Control;
	CImage	*image;
	CImage	*mask;
	CImage	*light;
	CImage	*pale;
	CImage	*bordercolor;
	int		pressed;
	int		lastbut;
	int		lastshow;
	int		border;
	int		align;
	int		off;
	int		prepress;
};

enum{
	EAlign,
	EBorder,
	EBordercolor,
	EFocus,
	EFormat,
	EHide,
	EImage,
	ELight,
	EMask,
	EPale,
	ERect,
	EReveal,
	EShow,
	ESize,
	EValue,
};

static char *cmds[] = {
	[EAlign] = 		"align",
	[EBorder] = 	"border",
	[EBordercolor] = "bordercolor",
	[EFocus] = 	"focus",
	[EFormat] = 	"format",
	[EHide] =		"hide",
	[EImage] =	"image",
	[ELight] =		"light",
	[EMask] =		"mask",
	[EPale] =		"pale",
	[ERect] =		"rect",
	[EReveal] =	"reveal",
	[EShow] =		"show",
	[ESize] =		"size",
	[EValue] =		"value",
	nil
};

static void
buttonfree(Control *c)
{
	Button *b;

	b = (Button *)c;
	_putctlimage(b-&gt;image);
	_putctlimage(b-&gt;mask);
	_putctlimage(b-&gt;light);
	_putctlimage(b-&gt;pale);
	_putctlimage(b-&gt;bordercolor);
}

static void
buttonshow(Button *b)
{
	Rectangle r;

	if (b-&gt;hidden)
		return;
	r = b-&gt;rect;
	if(b-&gt;border &gt; 0){
		border(b-&gt;screen, r, b-&gt;border, b-&gt;bordercolor-&gt;image, ZP);
		r = insetrect(b-&gt;rect, b-&gt;border);
	}
	draw(b-&gt;screen, r, b-&gt;image-&gt;image, nil, b-&gt;image-&gt;image-&gt;r.min);
	if(b-&gt;off)
		draw(b-&gt;screen, r, b-&gt;pale-&gt;image, b-&gt;mask-&gt;image, b-&gt;mask-&gt;image-&gt;r.min);
	else if(b-&gt;pressed)
		draw(b-&gt;screen, r, b-&gt;light-&gt;image, b-&gt;mask-&gt;image, b-&gt;mask-&gt;image-&gt;r.min);
	b-&gt;lastshow = b-&gt;pressed;
	flushimage(display, 1);
}

static void
buttonmouse(Control *c, Mouse *m)
{
	Button *b;

	b = (Button*)c;

	if(m-&gt;buttons&amp;7) {
		if (ptinrect(m-&gt;xy,b-&gt;rect)) {
			if (b-&gt;off) {
				b-&gt;off = 0;
				buttonshow(b);
			}
		} else {
			if (!b-&gt;off) {
				b-&gt;off = 1;
				buttonshow(b);
			}
		}
	}
	if((m-&gt;buttons&amp;7) != b-&gt;lastbut){
		if(m-&gt;buttons &amp; 7){
			b-&gt;prepress = b-&gt;pressed;
			if (b-&gt;pressed)
				b-&gt;pressed = 0;
			else
				b-&gt;pressed = m-&gt;buttons &amp; 7;
			buttonshow(b);
		}else	/* generate event on button up */
			if (ptinrect(m-&gt;xy,b-&gt;rect))
				chanprint(b-&gt;event, b-&gt;format, b-&gt;name, b-&gt;pressed);
			else {
				b-&gt;off = 0;
				b-&gt;pressed = b-&gt;prepress;
				buttonshow(b);
			}
	}
	b-&gt;lastbut = m-&gt;buttons &amp; 7;
}

static void
buttonctl(Control *c, CParse *cp)
{
	int cmd;
	Rectangle r;
	Button *b;

	b = (Button*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", b-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(b, cp, 2);
		b-&gt;align = _ctlalignment(cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EBorder:
		_ctlargcount(b, cp, 2);
		b-&gt;border = cp-&gt;iargs[1];
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EBordercolor:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;bordercolor, cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EFormat:
		_ctlargcount(b, cp, 2);
		b-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(b, cp, 1);
		b-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;image, cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case ELight:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;light, cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EMask:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;mask, cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EPale:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;pale, cp-&gt;args[1]);
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case ERect:
		_ctlargcount(b, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;0 || Dy(r)&lt;0)
			ctlerror("%q: bad rectangle: %s", b-&gt;name, cp-&gt;str);
		b-&gt;rect = r;
		b-&gt;lastshow = -1;	/* force redraw */
		break;
	case EReveal:
		_ctlargcount(b, cp, 1);
		b-&gt;hidden = 0;
		buttonshow(b);
		break;
	case EShow:
		_ctlargcount(b, cp, 1);
		buttonshow(b);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(b, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", b-&gt;name, cp-&gt;str);
		b-&gt;size.min = r.min;
		b-&gt;size.max = r.max;
		break;
	case EValue:
		_ctlargcount(b, cp, 2);
		if((cp-&gt;iargs[1]!=0) != b-&gt;pressed){
			b-&gt;pressed ^= 1;
			buttonshow(b);
		}
		break;
	}
}

Control*
createbutton(Controlset *cs, char *name)
{
	Button *b;
	b = (Button*)_createctl(cs, "button", sizeof(Button), name);
	b-&gt;image = _getctlimage("white");
	b-&gt;mask = _getctlimage("opaque");
	b-&gt;light = _getctlimage("yellow");
	b-&gt;pale = _getctlimage("paleyellow");
	b-&gt;bordercolor = _getctlimage("black");
	b-&gt;format = ctlstrdup("%q: value %d");
	b-&gt;lastshow = -1;
	b-&gt;border = 0;
	b-&gt;align = Aupperleft;
	b-&gt;ctl = buttonctl;
	b-&gt;mouse = buttonmouse;
	b-&gt;key = nil;
	b-&gt;exit = buttonfree;
	b-&gt;off = 0;
	b-&gt;prepress = 0;
	return (Control*)b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

