<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/cache.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/cache.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Cache Cache;

struct Cache
{
	char		*name;
	CCache	**cache;
	int		ncache;
};

static struct Cache imagecache = {"image"};
static struct Cache fontcache = {"font"};

static CCache*
getcacheitem(Cache *c, char *name)
{
	int i;

	for(i=0; i&lt;c-&gt;ncache; i++)
		if(c-&gt;cache[i]!=nil &amp;&amp; strcmp(c-&gt;cache[i]-&gt;name, name)==0){
			c-&gt;cache[i]-&gt;ref++;
			return c-&gt;cache[i];
		}
	return nil;
}

static int
namecacheitem(Cache *c, void *image, char *name)
{
	int i, free;
	CCache *cc;

	free = -1;
	for(i=0; i&lt;c-&gt;ncache; i++){
		if(c-&gt;cache[i] == nil){
			free = i;
			continue;
		}
		if(strcmp(c-&gt;cache[i]-&gt;name, name) == 0){
			werrstr("%s name %q already in use", c-&gt;name, name);
			return -1;
		}
	}
	cc = ctlmalloc(sizeof(CCache));
	cc-&gt;image = image;
	cc-&gt;name = ctlstrdup(name);
	if(free &gt;= 0){
		cc-&gt;index = free;
		c-&gt;cache[free] = cc;
	}else{
		cc-&gt;index = c-&gt;ncache;
		c-&gt;cache = ctlrealloc(c-&gt;cache, (c-&gt;ncache+1)*sizeof(CCache*));
		c-&gt;cache[c-&gt;ncache++] = cc;
	}
	cc-&gt;ref = 1;
	return 1;
}

static int
freecacheitem(Cache *c, char *name)
{
	CCache	*cc;

	cc = getcacheitem(c, name);
	if(cc == nil){
		werrstr("%s name %q not in use", c-&gt;name, name);
		return -1;
	}
	cc-&gt;ref--;	/* getcacheitem increments ref */
	if(cc-&gt;ref-- == 1){
		/* client must free object itself */
		free(cc-&gt;name);
		c-&gt;cache[cc-&gt;index] = nil;
		free(cc);
	}
	return 0;
}

static void
putcacheitem(CCache *cc)
{
	if(cc == nil)
		return;
	cc-&gt;ref--;
}

static void
setcacheitemptr(Cache *c, Control *ctl, CCache **cp, char *s)
{
	CCache *ci;

	ci = getcacheitem(c, s);
	if(ci == nil)
		ctlerror("%q: %s name %q not defined", ctl-&gt;name, c-&gt;name, s);
	putcacheitem(*cp);
	*cp = ci;
}

/* Images */

CImage*
_getctlimage(char *name)
{
	return getcacheitem(&amp;imagecache, name);
}

void
_putctlimage(CImage *c)
{
	putcacheitem(c);
}

int
namectlimage(Image *image, char *name)
{
	return namecacheitem(&amp;imagecache, image, name);
}

int
freectlimage(char *name)
{
	return freecacheitem(&amp;imagecache, name);
}

void
_setctlimage(Control *c, CImage **cp, char *s)
{
	setcacheitemptr(&amp;imagecache, c, cp, s);
}

/* Fonts */

CFont*
_getctlfont(char *name)
{
	return getcacheitem(&amp;fontcache, name);
}

void
_putctlfont(CFont *c)
{
	putcacheitem(c);
}

int
namectlfont(Font *font, char *name)
{
	return namecacheitem(&amp;fontcache, font, name);
}

int
freectlfont(char *name)
{
	return freecacheitem(&amp;fontcache, name);
}

void
_setctlfont(Control *c, CFont **cp, char *s)
{
	setcacheitemptr(&amp;fontcache, c, cp, s);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

