<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/entry.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/entry.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Entry Entry;

struct Entry
{
	Control;
	int		border;
	CFont	*font;
	CImage	*image;
	CImage	*textcolor;
	CImage	*bordercolor;
	Rune		*text;
	int		ntext;
	int		cursor;
	int		align;
	int		hasfocus;
	int		lastbut;
};

enum{
	EAlign,
	EBorder,
	EBordercolor,
	EData,
	EFocus,
	EFont,
	EFormat,
	EHide,
	EImage,
	ERect,
	EReveal,
	EShow,
	ESize,
	ETextcolor,
	EValue,
};

static char *cmds[] = {
	[EAlign] =			"align",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EData] = 			"data",
	[EFocus] = 		"focus",
	[EFont] =			"font",
	[EFormat] = 		"format",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[EShow] =			"show",
	[ESize] =			"size",
	[ETextcolor] =		"textcolor",
	[EValue] =			"value",
	nil
};

static void
entryfree(Control *c)
{
	Entry *e;

	e = (Entry *)c;
	_putctlfont(e-&gt;font);
	_putctlimage(e-&gt;image);
	_putctlimage(e-&gt;textcolor);
	_putctlimage(e-&gt;bordercolor);
	free(e-&gt;text);
}

static Point
entrypoint(Entry *e, int c)
{
	Point p;
	Rectangle r;

	r = e-&gt;rect;
	if(e-&gt;border &gt; 0)
		r = insetrect(r, e-&gt;border);
	p = _ctlalignpoint(r,
		runestringnwidth(e-&gt;font-&gt;font, e-&gt;text, e-&gt;ntext),
		e-&gt;font-&gt;font-&gt;height, e-&gt;align);
	if(c &gt; e-&gt;ntext)
		c = e-&gt;ntext;
	p.x += runestringnwidth(e-&gt;font-&gt;font, e-&gt;text, c);
	return p;
}

static void
entryshow(Entry *e)
{
	Rectangle r, dr;
	Point p;

	if (e-&gt;hidden)
		return;
	r = e-&gt;rect;
	draw(e-&gt;screen, r, e-&gt;image-&gt;image, nil, e-&gt;image-&gt;image-&gt;r.min);
	if(e-&gt;border &gt; 0){
		border(e-&gt;screen, r, e-&gt;border, e-&gt;bordercolor-&gt;image, e-&gt;bordercolor-&gt;image-&gt;r.min);
		dr = insetrect(r, e-&gt;border);
	}else
		dr = r;
	p = entrypoint(e, 0);
	_string(e-&gt;screen, p, e-&gt;textcolor-&gt;image,
		ZP, e-&gt;font-&gt;font, nil, e-&gt;text, e-&gt;ntext,
		dr, nil, ZP, SoverD);
	if(e-&gt;hasfocus){
		p = entrypoint(e, e-&gt;cursor);
		r.min = p;
		r.max.x = p.x+1;
		r.max.y = p.y+e-&gt;font-&gt;font-&gt;height;
		if(rectclip(&amp;r, dr))
			draw(e-&gt;screen, r, e-&gt;textcolor-&gt;image, nil, ZP);
	}
	flushimage(display, 1);
}

static void
entrysetpoint(Entry *e, Point cp)
{
	Point p;
	int i;

	if(!ptinrect(cp, insetrect(e-&gt;rect, e-&gt;border)))
		return;
	p = entrypoint(e, 0);
	for(i=0; i&lt;e-&gt;ntext; i++){
		p.x += runestringnwidth(e-&gt;font-&gt;font, e-&gt;text+i, 1);
		if(p.x &gt; cp.x)
			break;
	}
	e-&gt;cursor = i;
	entryshow(e);
}

static void
entrymouse(Control *c, Mouse *m)
{
	Entry *e;

	e = (Entry*)c;
	if(m-&gt;buttons==1 &amp;&amp; e-&gt;lastbut==0)
		entrysetpoint(e, m-&gt;xy);
	e-&gt;lastbut = m-&gt;buttons;
}

static void
entryctl(Control *c, CParse *cp)
{
	int cmd;
	Rectangle r;
	Entry *e;
	Rune *rp;

	e = (Entry*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", e-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(e, cp, 2);
		e-&gt;align = _ctlalignment(cp-&gt;args[1]);
		break;
	case EBorder:
		_ctlargcount(e, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", e-&gt;name, cp-&gt;str);
		e-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(e, cp, 2);
		_setctlimage(e, &amp;e-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EData:
		_ctlargcount(e, cp, 1);
		chanprint(e-&gt;data, "%S", e-&gt;text);
		break;
	case EFocus:
		_ctlargcount(e, cp, 2);
		e-&gt;hasfocus = cp-&gt;iargs[1];
		e-&gt;lastbut = 0;
		entryshow(e);
		break;
	case EFont:
		_ctlargcount(e, cp, 2);
		_setctlfont(e, &amp;e-&gt;font, cp-&gt;args[1]);
		break;
	case EFormat:
		_ctlargcount(e, cp, 2);
		e-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(e, cp, 1);
		e-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(e, cp, 2);
		_setctlimage(e, &amp;e-&gt;image, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(e, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", e-&gt;name, cp-&gt;str);
		e-&gt;rect = r;
		break;
	case EReveal:
		_ctlargcount(e, cp, 1);
		e-&gt;hidden = 0;
		entryshow(e);
		break;
	case EShow:
		_ctlargcount(e, cp, 1);
		entryshow(e);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(e, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", e-&gt;name, cp-&gt;str);
		e-&gt;size.min = r.min;
		e-&gt;size.max = r.max;
		break;
	case ETextcolor:
		_ctlargcount(e, cp, 2);
		_setctlimage(e, &amp;e-&gt;textcolor, cp-&gt;args[1]);
		break;
	case EValue:
		_ctlargcount(e, cp, 2);
		rp = _ctlrunestr(cp-&gt;args[1]);
		if(runestrcmp(rp, e-&gt;text) != 0){
			free(e-&gt;text);
			e-&gt;text = rp;
			e-&gt;ntext = runestrlen(e-&gt;text);
			e-&gt;cursor = e-&gt;ntext;
			entryshow(e);
		}else
			free(rp);
		break;
	}
}

static void
entrykey(Entry *e, Rune r)
{
	Rune *s;
	int n;
	char *p;

	switch(r){
	default:
		e-&gt;text = ctlrealloc(e-&gt;text, (e-&gt;ntext+1+1)*sizeof(Rune));
		memmove(e-&gt;text+e-&gt;cursor+1, e-&gt;text+e-&gt;cursor,
			(e-&gt;ntext+1-e-&gt;cursor)*sizeof(Rune));
		e-&gt;text[e-&gt;cursor++] = r;
		e-&gt;ntext++;
		break;
	case L'\n':	/* newline: return value */
		p = _ctlstrrune(e-&gt;text);
		chanprint(e-&gt;event, e-&gt;format, e-&gt;name, p);
		free(p);
		return;
	case L'\b':
		if(e-&gt;cursor &gt; 0){
			memmove(e-&gt;text+e-&gt;cursor-1, e-&gt;text+e-&gt;cursor,
				(e-&gt;ntext+1-e-&gt;cursor)*sizeof(Rune));
			e-&gt;cursor--;
			e-&gt;ntext--;
		}
		break;
	case Kright:
		if(e-&gt;cursor &lt; e-&gt;ntext)
			e-&gt;cursor++;
		break;
	case Kleft:
		if(e-&gt;cursor &gt; 0)
			e-&gt;cursor--;
		break;
	case 0x01:	/* control A: beginning of line */
		e-&gt;cursor = 0;
		break;
	case 0x05:	/* control E: end of line */
		e-&gt;cursor = e-&gt;ntext;
		break;
	case 0x15:	/* control U: kill line */
		e-&gt;cursor = 0;
		e-&gt;ntext = 0;
		break;
	case 0x16:	/* control V: paste (append snarf buffer) */
		s = _ctlgetsnarf();
		if(s != nil){
			n = runestrlen(s);
			e-&gt;text = ctlrealloc(e-&gt;text, (e-&gt;ntext+n+1)*sizeof(Rune));
			memmove(e-&gt;text+e-&gt;cursor+n, e-&gt;text+e-&gt;cursor,
				(e-&gt;ntext+1-e-&gt;cursor)*sizeof(Rune));
			memmove(e-&gt;text+e-&gt;cursor, s, n*sizeof(Rune));
			e-&gt;cursor += n;
			e-&gt;ntext += n;
		}
		break;
	}
	e-&gt;text[e-&gt;ntext] = L'\0';
}

static void
entrykeys(Control *c, Rune *rp)
{
	Entry *e;
	int i;

	e = (Entry *)c;
	for(i=0; rp[i]!=L'\0'; i++)
		entrykey(e, rp[i]);
	entryshow(e);
}

Control*
createentry(Controlset *cs, char *name)
{
	Entry *e;

	e = (Entry*) _createctl(cs, "entry", sizeof(Entry), name);
	e-&gt;text = ctlmalloc(sizeof(Rune));
	e-&gt;ntext = 0;
	e-&gt;image = _getctlimage("white");
	e-&gt;textcolor = _getctlimage("black");
	e-&gt;bordercolor = _getctlimage("black");
	e-&gt;font = _getctlfont("font");
	e-&gt;format = ctlstrdup("%q: value %q");
	e-&gt;border = 0;
	e-&gt;ctl = entryctl;
	e-&gt;mouse = entrymouse;
	e-&gt;key = entrykeys;
	e-&gt;exit = entryfree;
	return (Control *)e;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

