<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/keyboard.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/keyboard.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Keyboard Keyboard;

enum{
	SRegular	= 0,
	SShift	= 1,
	SCaps	= 2,
	SMask	= 3,
	Nstate	= 4,
	SControl	= 4,
};

struct Keyboard
{
	Control;
	CImage	*image;
	CImage	*mask;
	CImage	*light;
	CImage	*textcolor;
	CImage	*bordercolor;
	CFont	*font;
	CFont	*ctlfont;
	Image	*im[Nstate];
	int		border;
	int		lastbut;
	int		state;
	char		*key;
};

enum{
	EBorder,
	EBordercolor,
	EFocus,
	EFont,
	EFormat,
	EHide,
	EImage,
	ELight,
	EMask,
	ERect,
	EReveal,
	EShow,
	ESize,
};

static char *cmds[] = {
	[EBorder] =	"border",
	[EBordercolor] = "bordercolor",
	[EFocus] = 	"focus",
	[EFont] =		"font",
	[EFormat] = 	"format",
	[EHide] =		"hide",
	[EImage] =	"image",
	[ELight] =		"light",
	[EMask] =		"mask",
	[ERect] =		"rect",
	[EReveal] =	"reveal",
	[EShow] =		"show",
	[ESize] =		"size",
	nil
};

enum
{
	Nrow = 5
};

static uchar wid [Nrow][16] = {
	{16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 30, },
	{24, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 24, },
	{32, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, },
	{40, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, },
	{30, 30, 80, 40, 42, 24, },
};

static char *keyregular[Nrow] = {
	"`\0001\0002\0003\0004\0005\0006\0007\0008\0009\0000\0-\0=\0\\\0&lt;-\0\0",
	"-&gt;\0q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0[\0]\0Del\0\0",
	"Caps\0a\0s\0d\0f\0g\0h\0j\0k\0l\0;\0'\0Enter\0\0",
	"Shift\0z\0x\0c\0v\0b\0n\0m\0,\0.\0/\0Shift\0\0",
	"Ctrl\0Alt\0 \0Scrib\0Menu\0Esc\0\0"
};

static char *keyshift[Nrow] = {
	"~\0!\0@\0#\0$\0%\0^\0&amp;\0*\0(\0)\0_\0+\0|\0&lt;-\0\0",
	"-&gt;\0Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0{\0}\0Del\0\0",
	"Caps\0A\0S\0D\0F\0G\0H\0J\0K\0L\0:\0\"\0Enter\0\0",
	"Shift\0Z\0X\0C\0V\0B\0N\0M\0&lt;\0&gt;\0?\0Shift\0\0",
	"Ctrl\0Alt\0 \0Scrib\0Menu\0Esc\0\0"
};

static char *keycaps[Nrow] = {
	"`\0001\0002\0003\0004\0005\0006\0007\0008\0009\0000\0-\0=\0\\\0&lt;-\0\0",
	"-&gt;\0Q\0W\0E\0R\0T\0Y\0U\0I\0O\0P\0[\0]\0Del\0\0",
	"Caps\0A\0S\0D\0F\0G\0H\0J\0K\0L\0;\0'\0Enter\0\0",
	"Shift\0Z\0X\0C\0V\0B\0N\0M\0,\0.\0/\0Shift\0\0",
	"Ctrl\0Alt\0 \0Scrib\0Menu\0Esc\0\0"
};

static char *keycapsshift[Nrow] = {
	"~\0!\0@\0#\0$\0%\0^\0&amp;\0*\0(\0)\0_\0+\0|\0&lt;-\0\0",
	"-&gt;\0q\0w\0e\0r\0t\0y\0u\0i\0o\0p\0{\0}\0Del\0\0",
	"Caps\0a\0s\0d\0f\0g\0h\0j\0k\0l\0:\0\"\0Enter\0\0",
	"Shift\0z\0x\0c\0v\0b\0n\0m\0&lt;\0&gt;\0?\0Shift\0\0",
	"Ctrl\0Alt\0 \0Scrib\0Menu\0Esc\0\0"
};

struct{
	char	*name;
	int	val;
}keytab[] = {
	"Shift",	0,
	"Ctrl",	0,
	"Alt",		0,
	"Caps",	0,
	"Del",	'\177',
	"Enter",	'\n',
	"Esc",	'\033',
	"&lt;-",		'\b',
	"-&gt;",		'\t',
	"Scrib",	0x10000,
	"Menu",	0x10001,
	nil,		0,
};

static char **keyset[Nstate] = {
	keyregular,
	keyshift,
	keycaps,
	keycapsshift,
};

static void	keyboardshow(Keyboard*);
static void	keyup(Keyboard*, Point);
static void	keydown(Keyboard*, Point);
static void	keyresize(Keyboard*);

static void
keyboardmouse(Control *c, Mouse *m)
{
	Keyboard *k;

	k = (Keyboard *)c;
	if(m-&gt;buttons==1)
		keydown(k, m-&gt;xy);
	else if(k-&gt;lastbut==1 &amp;&amp; m-&gt;buttons==0)
		keyup(k, m-&gt;xy);
	k-&gt;lastbut = m-&gt;buttons;
}

static void
keyboardfree(Control *c)
{
	int i;
	Keyboard *k;

	k = (Keyboard *)c;
	_putctlimage(k-&gt;image);
	_putctlimage(k-&gt;mask);
	_putctlimage(k-&gt;light);
	_putctlimage(k-&gt;textcolor);
	_putctlimage(k-&gt;bordercolor);
	_putctlfont(k-&gt;font);
	_putctlfont(k-&gt;ctlfont);
	for(i=0; i&lt;nelem(k-&gt;im); i++)
		freeimage(k-&gt;im[i]);
	free(k-&gt;format);
}

static int
keyboardy(Keyboard *k, int row)
{
	int dy;

	if(row &gt;= Nrow)
		return k-&gt;rect.max.y-k-&gt;border;
	dy = Dy(k-&gt;rect)-2*k-&gt;border;
	return k-&gt;rect.min.y+k-&gt;border+(row*dy+Nrow-1)/Nrow;
}

static char*
whichkey(Keyboard *k, Point p, int *rowp, int *colp, Rectangle *rp)
{
	uchar *wp;
	char *kp;
	int row, col, dx, dy, x, n, maxx;
	Rectangle r;

	r = insetrect(k-&gt;rect, k-&gt;border);
	if(!ptinrect(p, r))
		return nil;
	maxx = r.max.x;
	dx = Dx(r);
	dy = Dy(r);
	row = (p.y - r.min.y)*Nrow/dy;
	if(row &gt;= Nrow)
		row = Nrow-1;
	r.min.y = keyboardy(k, row);
	r.max.y = keyboardy(k, row+1);
	x = r.min.x;
	kp = keyset[k-&gt;state&amp;SMask][row];
	wp = wid[row];
	for(col=0; *kp; col++,kp+=n+1){
		n = strlen(kp);
		r.min.x = x;
		r.max.x = x + (wp[col]*dx+255)/256;
		if(kp[n+1] == '\0')
			r.max.x = maxx;
		if(r.max.x &gt; p.x)
			break;
		x = r.max.x;
	}
	*rp = insetrect(r, 1);
	*rowp = row;
	*colp = col;
	return kp;
}

static Rectangle
keyrect(Keyboard *k, int row, int col)
{
	uchar *wp;
	char *kp;
	int i, x, n, dx;
	Rectangle r;
	Point p;

	r = insetrect(k-&gt;rect, k-&gt;border);
	p = r.min;
	dx = Dx(r);
	r.min.y = keyboardy(k, row);
	r.max.y = keyboardy(k, row+1);
	x = r.min.x;
	kp = keyset[0][row];
	wp = wid[row];
	for(i=0; *kp; i++,kp+=n+1){
		n = strlen(kp);
		r.min.x = x;
		r.max.x = x + (wp[i]*dx+255)/256;
		if(kp[n+1] == '\0')
			r.max.x = p.x+dx;
		if(i &gt;= col)
			break;
		x = r.max.x;
	}
	return insetrect(r, 1);
}

static void
keydraw(Keyboard *k, int state)
{
	Point p, q;
	int row, col, x, dx, dy, nexty, n;
	uchar *wp;
	char *kp;
	Rectangle r;
	Font *f, *f1, *f2;
	Image *im;

	freeimage(k-&gt;im[state]);
	k-&gt;im[state] = nil;
	if(Dx(k-&gt;rect)-2*k-&gt;border &lt;= 0)
		return;

	im = allocimage(display, k-&gt;rect, screen-&gt;chan, 0, ~0);
	if(im == nil)
		return;
	k-&gt;im[state] = im;

	r = insetrect(k-&gt;rect, k-&gt;border);
	border(im, k-&gt;rect, k-&gt;border, k-&gt;bordercolor-&gt;image, ZP);
	draw(im, r, k-&gt;image-&gt;image, nil, ZP);
	dx = Dx(r);
	dy = Dy(r);
	p = r.min;
	f1 = k-&gt;font-&gt;font;
	f2 = k-&gt;ctlfont-&gt;font;
	nexty = p.y;
	for(row=0; row&lt;Nrow; row++){
		x = p.x;
		kp = keyset[state][row];
		wp = wid[row];
		r.min.y = nexty;
		nexty = keyboardy(k, row+1);
		r.max.y = nexty;
		for(col=0; *kp; col++,kp+=n+1){
			r.min.x = x;
			r.max.x = x + (wp[col]*dx+255)/256;
			n = strlen(kp);
			if(kp[n+1] == '\0')
				r.max.x = p.x+dx;
			if(row == Nrow-1)
				r.max.y = p.y+dy;
			if(n &gt; 1)
				f = f2;
			else
				f = f1;
			q = _ctlalignpoint(r, stringnwidth(f, kp, n), f-&gt;height, Acenter);
			_string(im, q, k-&gt;textcolor-&gt;image,
				ZP, f, kp, nil, n, r,
				nil, ZP, SoverD);
			x = r.max.x;
			if(kp[n+1])
				draw(im, Rect(x, r.min.y, x+1, r.max.y),
					k-&gt;textcolor-&gt;image, nil, ZP);
		}
		if(row != Nrow-1)
			draw(im, Rect(p.x, r.max.y, p.x+dx, r.max.y+1),
				k-&gt;textcolor-&gt;image, nil, ZP);
	}
}

static void
keyresize(Keyboard *k)
{
	int i;

	for(i=0; i&lt;Nstate; i++)
		keydraw(k, i);
}

static void
keyboardshow(Keyboard *k)
{
	Rectangle r;

	if (k-&gt;hidden)
		return;
	if(k-&gt;im[0]==nil || !eqrect(k-&gt;im[0]-&gt;r, k-&gt;rect))
		keyresize(k);
	if(k-&gt;im[k-&gt;state&amp;SMask] == nil)
		return;
	draw(k-&gt;screen, k-&gt;rect, k-&gt;im[k-&gt;state&amp;SMask], nil, k-&gt;rect.min);
	if(k-&gt;state &amp; SShift){
		r = keyrect(k, 3, 0);
		draw(k-&gt;screen, r, k-&gt;light-&gt;image, k-&gt;mask-&gt;image, ZP);
		r = keyrect(k, 3, 11);
		draw(k-&gt;screen, r, k-&gt;light-&gt;image, k-&gt;mask-&gt;image, ZP);
	}
	if(k-&gt;state &amp; SCaps){
		r = keyrect(k, 2, 0);
		draw(k-&gt;screen, r, k-&gt;light-&gt;image, k-&gt;mask-&gt;image, ZP);
	}
	if(k-&gt;state &amp; SControl){
		r = keyrect(k, 4, 0);
		draw(k-&gt;screen, r, k-&gt;light-&gt;image, k-&gt;mask-&gt;image, ZP);
	}
	flushimage(display, 1);
}

static void
keydown(Keyboard *k, Point p)
{
	int row, col;
	Rectangle r;
	char *s;

	s = whichkey(k, p, &amp;row, &amp;col, &amp;r);
	if(s == k-&gt;key)
		return;
	keyboardshow(k);
	if(s != nil)
		draw(k-&gt;screen, r, k-&gt;light-&gt;image, k-&gt;mask-&gt;image, ZP);
	flushimage(display, 1);
	k-&gt;key = s;
}

static int
keylookup(char *s)
{
	int i;

	for(i=0; keytab[i].name; i++)
		if(strcmp(s, keytab[i].name) == 0)
			return keytab[i].val;
	return s[0];
}

static void
keyup(Keyboard *k, Point p)
{
	int row, col;
	Rectangle r;
	char *s;
	int val;

	s = whichkey(k, p, &amp;row, &amp;col, &amp;r);
	if(s == nil)
		return;
	val = keylookup(s);
	if(k-&gt;state &amp; SControl)
		if(' '&lt;val &amp;&amp; val&lt;0177)
			val &amp;= ~0x60;
	if(strcmp(s, "Alt") == 0)
		{;}
	if(strcmp(s, "Ctrl") == 0){
		k-&gt;state ^= SControl;
	}else
		k-&gt;state &amp;= ~SControl;
	if(strcmp(s, "Shift")==0 || strcmp(s, "Caps")==0){
		if(strcmp(s, "Shift") == 0)
			k-&gt;state ^= SShift;
		if(strcmp(s, "Caps") == 0)
			k-&gt;state ^= SCaps;
	}else
		k-&gt;state &amp;= ~SShift;
	keyboardshow(k);
	if(val)
		chanprint(k-&gt;event, k-&gt;format, k-&gt;name, val);
	k-&gt;key = nil;
}

static void
keyboardctl(Control *c, CParse *cp)
{
	int cmd;
	Rectangle r;
	Keyboard *k;

	k = (Keyboard*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", k-&gt;name, cp-&gt;str);
		break;
	case EBorder:
		_ctlargcount(k, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", k-&gt;name, cp-&gt;str);
		k-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(k, cp, 2);
		_setctlimage(k, &amp;k-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EFont:
		if(cp-&gt;nargs!=2 &amp;&amp; cp-&gt;nargs!=3)
			ctlerror("%q: bad font message '%s'", k-&gt;name, cp-&gt;str);
		_setctlfont(k, &amp;k-&gt;font, cp-&gt;args[1]);
		if(cp-&gt;nargs == 3)
			_setctlfont(k, &amp;k-&gt;ctlfont, cp-&gt;args[2]);
		else
			_setctlfont(k, &amp;k-&gt;ctlfont, cp-&gt;args[1]);
		break;
	case EFormat:
		_ctlargcount(k, cp, 2);
		k-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(k, cp, 1);
		k-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(k, cp, 2);
		_setctlimage(k, &amp;k-&gt;image, cp-&gt;args[1]);
		break;
	case ELight:
		_ctlargcount(k, cp, 2);
		_setctlimage(k, &amp;k-&gt;light, cp-&gt;args[1]);
		break;
	case EMask:
		_ctlargcount(k, cp, 2);
		_setctlimage(k, &amp;k-&gt;mask, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(k, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;0 || Dy(r)&lt;0)
			ctlerror("%q: bad rectangle: %s", k-&gt;name, cp-&gt;str);
		k-&gt;rect = r;
		keyboardshow(k);
		break;
	case EReveal:
		_ctlargcount(k, cp, 1);
		k-&gt;hidden = 0;
		keyboardshow(k);
		break;
	case EShow:
		_ctlargcount(k, cp, 1);
		keyboardshow(k);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(k, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", k-&gt;name, cp-&gt;str);
		k-&gt;size.min = r.min;
		k-&gt;size.max = r.max;
		break;
	}
}

Control*
createkeyboard(Controlset *cs, char *name)
{
	Keyboard *k;

	k = (Keyboard *)_createctl(cs, "keyboard", sizeof(Keyboard), name);
	k-&gt;image = _getctlimage("white");
	k-&gt;mask = _getctlimage("opaque");
	k-&gt;light = _getctlimage("yellow");
	k-&gt;bordercolor = _getctlimage("black");
	k-&gt;textcolor = _getctlimage("black");
	k-&gt;font = _getctlfont("font");
	k-&gt;ctlfont = _getctlfont("font");
	k-&gt;format = ctlstrdup("%q: value 0x%x");
	k-&gt;border = 0;
	k-&gt;lastbut = 0;
	k-&gt;key = nil;
	k-&gt;state = SRegular;
	k-&gt;ctl = keyboardctl;
	k-&gt;mouse = keyboardmouse;
	k-&gt;exit = keyboardfree;
	k-&gt;size = Rect(246, 2 + 5 * (k-&gt;font-&gt;font-&gt;height + 1), 512, 256);
	return k;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

