<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/scribble.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/scribble.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;
#include &lt;scribble.h&gt;

typedef struct Scrib Scrib;

struct Scrib
{
	Control;
	int		border;
	CImage	*image;
	CImage	*color;
	CImage	*bordercolor;
	CFont	*font;
	int		align;
	int		lastbut;
	char		lastchar[8];
	Scribble	*scrib;
};

enum{
	EAlign,
	EBorder,
	EBordercolor,
	EFocus,
	EFont,
	EHide,
	EImage,
	ELinecolor,
	ERect,
	EReveal,
	EShow,
	ESize,
};

static char *cmds[] = {
	[EAlign] =		"align",
	[EBorder] =	"border",
	[EBordercolor] ="bordercolor",
	[EFocus] = 	"focus",
	[EFont] =		"font",
	[EHide] =		"hide",
	[EImage] =	"image",
	[ELinecolor] =	"linecolor",
	[ERect] =		"rect",
	[EReveal] =	"reveal",
	[EShow] =		"show",
	[ESize] =		"size",
	nil
};

static void	scribshow(Scrib*);
static void scribchar(Scrib*, Rune);

static void	resetstroke(Scrib *w);
static void	displaystroke(Scrib *w);
static void	displaylast(Scrib *w);
static void	addpoint(Scrib *w, Point p);

static void
scribmouse(Control *c, Mouse *m)
{
	Scrib *b;
	Rune r;

	b = (Scrib*)c;
	if (m-&gt;buttons &amp; 0x1) {
		if ((b-&gt;lastbut &amp; 0x1) == 0) {
			/* mouse went down */
			resetstroke(b);
		}
		/* mouse is down */
		if (ptinrect(m-&gt;xy,b-&gt;rect))
			addpoint(b, m-&gt;xy);
	} else if (b-&gt;lastbut &amp; 0x1) {
		/* mouse went up */
		if (ptinrect(m-&gt;xy,b-&gt;rect)) {
			r = recognize(b-&gt;scrib);
			scribchar(b, r);
			scribshow(b);
			if (r) chanprint(b-&gt;event, b-&gt;format, b-&gt;name, r);
		}
	}
	b-&gt;lastbut = m-&gt;buttons;
}

static void
scribfree(Control *c)
{
	Scrib *b;

	b = (Scrib*)c;
	_putctlimage(b-&gt;image);
	_putctlimage(b-&gt;color);
	_putctlimage(b-&gt;bordercolor);
	_putctlfont(b-&gt;font);
//	scribblefree(b-&gt;scrib);
}

static void
scribchar(Scrib *b, Rune r)
{
	if(r == 0)
		b-&gt;lastchar[0] = '\0';
	else if(r == ' ')
		strcpy(b-&gt;lastchar, "' '");
	else if(r &lt; ' ')
		sprint(b-&gt;lastchar, "ctl-%c", r+'@');
	else
		sprint(b-&gt;lastchar, "%C", r);
}


static void
scribshow(Scrib *b)
{
	Image *i;
	Rectangle r;
	char *mode;
	Scribble *s = b-&gt;scrib;
	char buf[32];

	if (b-&gt;hidden)
		return;
	if(b-&gt;border &gt; 0){
		r = insetrect(b-&gt;rect, b-&gt;border);
		border(b-&gt;screen, b-&gt;rect, b-&gt;border, b-&gt;bordercolor-&gt;image, ZP);
	}else
		r = b-&gt;rect;

	i = b-&gt;image-&gt;image;
	draw(b-&gt;screen, r, i, nil, i-&gt;r.min);

	if (s-&gt;ctrlShift)
		mode = " ^C";
	else if (s-&gt;puncShift)
		mode = " #&amp;^";
	else if (s-&gt;curCharSet == CS_DIGITS)
		mode = " 123";
	else if (s-&gt;capsLock)
		mode = " ABC";
	else if (s-&gt;tmpShift)
		mode = " Abc";
	else
		mode = " abc";

	snprint(buf, sizeof buf, "%s %s", mode, b-&gt;lastchar);

	string(b-&gt;screen, r.min, b-&gt;color-&gt;image, ZP, b-&gt;font-&gt;font, buf);
	flushimage(display, 1);
}

static void
scribctl(Control *c, CParse *cp)
{
	int cmd;
	Rectangle r;
	Scrib *b;

	b = (Scrib*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		abort();
		ctlerror("%q: unrecognized message '%s'", b-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(b, cp, 2);
		b-&gt;align = _ctlalignment(cp-&gt;args[1]);
		break;
	case EBorder:
		_ctlargcount(b, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", b-&gt;name, cp-&gt;str);
		b-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EFocus:
		break;
	case EImage:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;image, cp-&gt;args[1]);
		break;
	case ELinecolor:
		_ctlargcount(b, cp, 2);
		_setctlimage(b, &amp;b-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case ERect:
		_ctlargcount(b, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;0 || Dy(r)&lt;0)
			ctlerror("%q: bad rectangle: %s", b-&gt;name, cp-&gt;str);
		b-&gt;rect = r;
		break;
	case EReveal:
		_ctlargcount(b, cp, 1);
		b-&gt;hidden = 0;
		scribshow(b);
		break;
	case EShow:
		_ctlargcount(b, cp, 1);
		scribshow(b);
		break;
	case EFont:
		_ctlargcount(b, cp, 2);
		_setctlfont(b, &amp;b-&gt;font, cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(b, cp, 1);
		b-&gt;hidden = 1;
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(b, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", b-&gt;name, cp-&gt;str);
		b-&gt;size.min = r.min;
		b-&gt;size.max = r.max;
		break;
	}
}

static void
resetstroke(Scrib *w)
{
	Scribble *s = w-&gt;scrib;

	s-&gt;ps.npts = 0;
	scribshow(w);
}

static void
displaystroke(Scrib *b)
{
	Scribble *s = b-&gt;scrib;

	poly(b-&gt;screen, s-&gt;pt, s-&gt;ps.npts, Endsquare, Endsquare, 0, b-&gt;color-&gt;image, ZP);
	flushimage(display, 1);
}

static void
displaylast(Scrib *w)
{
	int	    npt;
	Scribble *s = w-&gt;scrib;

	npt = s-&gt;ps.npts;
	if (npt &gt; 2)
		npt = 2;
	poly(w-&gt;screen, s-&gt;pt + (s-&gt;ps.npts - npt), npt, Endsquare, Endsquare,
		0, w-&gt;color-&gt;image, ZP);
	flushimage(display, 1);
}

static void
addpoint(Scrib *w, Point p)
{
	pen_point	*ppa;
	Point	*pt;
	int		ppasize;
	Scribble	*s = w-&gt;scrib;

	if (s-&gt;ps.npts == s-&gt;ppasize) {
		ppasize = s-&gt;ppasize + 100;
		ppa = malloc ((sizeof (pen_point) + sizeof (Point)) * ppasize);
		if (!ppa)
			return;
		pt = (Point *) (ppa + ppasize);
		memmove(ppa, s-&gt;ps.pts, s-&gt;ppasize * sizeof (pen_point));
		memmove(pt, s-&gt;pt, s-&gt;ppasize * sizeof (Point));
		free (s-&gt;ps.pts);
		s-&gt;ps.pts = ppa;
		s-&gt;pt = pt;
		s-&gt;ppasize = ppasize;
	}
	ppa = &amp;s-&gt;ps.pts[s-&gt;ps.npts];
	ppa-&gt;Point = p;

	pt = &amp;s-&gt;pt[s-&gt;ps.npts];
	*pt = p;

	s-&gt;ps.npts++;
	
	displaylast(w);
}

Control*
createscribble(Controlset *cs, char *name)
{
	Scrib *b;

	b = (Scrib*)_createctl(cs, "scribble", sizeof(Scrib), name);
	b-&gt;image = _getctlimage("white");
	b-&gt;color = _getctlimage("black");
	b-&gt;bordercolor = _getctlimage("black");
	b-&gt;align = Aupperleft;
	b-&gt;format = ctlstrdup("%q: value 0x%x");
	b-&gt;font = _getctlfont("font");
	b-&gt;scrib = scribblealloc();
	b-&gt;lastbut = 0;
	b-&gt;bordercolor = _getctlimage("black");
	b-&gt;border = 0;
	b-&gt;ctl = scribctl;
	b-&gt;mouse = scribmouse;
	b-&gt;exit = scribfree;
	return (Control*)b;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

