<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/tabs.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/tabs.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;draw.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;
#include "group.h"

typedef struct Tab Tab;

struct Tab {
	Control;
	int		border;
	int		selected;
	int		separation;
	char		*format;
	CImage	*bordercolor;
	CImage	*image;
	Control	*tabrow;
	Control	*tabstack;
	Control	*tabcolumn;
	int		ntabs;
	int		nbuttons;
	Control	**buttons;
};

enum{
	EAdd,
	EBorder,
	EBordercolor,
	EButton,
	EFocus,
	EFormat,
	EHide,
	EImage,
	ERect,
	EReveal,
	ESeparation,
	ESeparatorcolor,
	EShow,
	ESize,
	EValue,
};

static char *cmds[] = {
	[EAdd] =			"add",
	[EBorder] =		"border",
	[EBordercolor] =	"bordercolor",
	[EButton] =		"button",
	[EFocus] = 		"focus",
	[EFormat] = 		"format",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[ESeparation] =		"separation",
	[ESeparatorcolor] =	"separatorcolor",
	[EShow] =			"show",
	[ESize] =			"size",
	[EValue] =			"value",
};

static void
tabshow(Tab *t)
{
	int i;
	Rectangle r;
	Group *g;

	if (t-&gt;hidden)
		return;
	for(i=0; i&lt;t-&gt;nbuttons; i++){
		_ctlprint(t-&gt;buttons[i], "value %d", (t-&gt;selected==i));
	}
	_ctlprint(t-&gt;tabstack, "reveal %d", t-&gt;selected);
	_ctlprint(t-&gt;tabcolumn, "show");
	if (t-&gt;selected &lt; 0)
		return;
	g = (Group*)t-&gt;tabcolumn;
	if (g-&gt;nseparators == 0){
		return;
	}
	r = g-&gt;separators[0];
	r.min.x = t-&gt;buttons[t-&gt;selected]-&gt;rect.min.x;
	r.max.x = t-&gt;buttons[t-&gt;selected]-&gt;rect.max.x;
	draw(t-&gt;screen, r, t-&gt;image-&gt;image, nil, t-&gt;image-&gt;image-&gt;r.min);
	flushimage(display, 1);
}

static void
tabsize(Control *c)
{
	Tab *t = (Tab*)c;
	if (t-&gt;tabcolumn &amp;&amp; t-&gt;tabcolumn-&gt;setsize)
		t-&gt;tabcolumn-&gt;setsize((Control*)t-&gt;tabcolumn);
}

static void
tabctl(Control *c, CParse *cp)
{
	int cmd, i;
	Control *cbut, *cwin;
	Tab *t;
	Rectangle r;

	t = (Tab*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	case EAdd:
		if ((cp-&gt;nargs &amp; 1) == 0)
			ctlerror("%q: arg count: %s", t-&gt;name, cp-&gt;args[1]);
		for (i = 1; i &lt; cp-&gt;nargs; i += 2){
			cbut = controlcalled(cp-&gt;args[i]);
			if (cbut == nil)
				ctlerror("%q: no such control: %s", t-&gt;name, cp-&gt;args[i]);
			cwin = controlcalled(cp-&gt;args[i+1]);
			if (cwin == nil)
				ctlerror("%q: no such control: %s", t-&gt;name, cp-&gt;args[i+1]);
			_ctladdgroup(t-&gt;tabrow, cbut);
			_ctlprint(t-&gt;tabstack, "add %q", cp-&gt;args[i+1]);
			_ctlprint(cbut, "format '%%s: %q button %%d'", t-&gt;name);
			controlwire(cbut, "event", t-&gt;controlset-&gt;ctl);
			t-&gt;buttons = ctlrealloc(t-&gt;buttons, (t-&gt;nbuttons+1)*sizeof(Control*));
			t-&gt;buttons[t-&gt;nbuttons] = cbut;
			t-&gt;nbuttons++;
			t-&gt;selected = -1;
		}
		_ctlprint(t-&gt;tabcolumn, "size");
		t-&gt;size = t-&gt;tabcolumn-&gt;size;
		break;
	case EBorder:
		_ctlargcount(t, cp, 2);
		if(cp-&gt;iargs[1] &lt; 0)
			ctlerror("%q: bad border: %c", t-&gt;name, cp-&gt;str);
		t-&gt;border = cp-&gt;iargs[1];
		break;
	case EBordercolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;bordercolor, cp-&gt;args[1]);
		break;
	case EButton:
		_ctlargcount(t, cp, 2);
		if (cp-&gt;sender == nil)
			ctlerror("%q: senderless buttonevent: %q", t-&gt;name, cp-&gt;str);
		cbut = controlcalled(cp-&gt;sender);
		for(i=0; i&lt;t-&gt;nbuttons; i++)
			if (cbut == t-&gt;buttons[i])
				break;
		if (i == t-&gt;nbuttons)
			ctlerror("%q: not my event: %q", t-&gt;name, cp-&gt;str);
		if(cp-&gt;iargs[1] == 0){
			/* button was turned off; turn it back on */
			_ctlprint(cbut, "value 1");
		}else{
			t-&gt;selected = i;
			if (t-&gt;format)
				chanprint(t-&gt;event, t-&gt;format, t-&gt;name, i);
			tabshow(t);
		}
		break;
	case EFocus:
		/* ignore focus change */
		break;
	case EFormat:
		_ctlargcount(t, cp, 2);
		t-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EImage:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;image, cp-&gt;args[1]);
		break;
	case ESeparation:
		t-&gt;tabrow-&gt;ctl(t-&gt;tabrow, cp);
		t-&gt;tabcolumn-&gt;ctl(t-&gt;tabcolumn, cp);
		break;
	case ERect:
		_ctlargcount(t, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", t-&gt;name, cp-&gt;str);
		t-&gt;rect = r;
		r = insetrect(r, t-&gt;border);
		_ctlprint(t-&gt;tabcolumn, "rect %R", r);
		break;
	case EReveal:
		_ctlargcount(t, cp, 1);
	case EHide:
	case ESize:
		t-&gt;tabcolumn-&gt;ctl(t-&gt;tabcolumn, cp);
		break;
	case EShow:
		tabshow(t);
		break;
	case EValue:
		_ctlargcount(t, cp, 2);
		if (cp-&gt;iargs[1] &lt; 0 || cp-&gt;iargs[1] &gt;= t-&gt;nbuttons)
			ctlerror("%q: illegal value '%s'", t-&gt;name, cp-&gt;str);
		t-&gt;selected = cp-&gt;iargs[1];
		tabshow(t);
		break;
	default:
		ctlerror("%q: unrecognized message '%s'", t-&gt;name, cp-&gt;str);
		break;
	}
}

static void
tabfree(Control*c)
{
	Tab *t = (Tab*)c;
	t-&gt;nbuttons = 0;
	free(t-&gt;buttons);
	t-&gt;buttons = 0;
}

static void
activatetab(Control *c, int act)
{
	Tab *t;

	t = (Tab*)c;
	if (act)
		activate(t-&gt;tabcolumn);
	else
		deactivate(t-&gt;tabcolumn);
}
	
Control *
createtab(Controlset *cs, char *name)
{
	char s[128];

	Tab *t;
	t = (Tab*)_createctl(cs, "tab", sizeof(Tab), name);
	t-&gt;selected = -1;
	t-&gt;nbuttons = 0;
	t-&gt;ctl = tabctl;
	t-&gt;mouse = nil;
	t-&gt;exit = tabfree;
	snprint(s, sizeof s, "_%s-row", name);
	t-&gt;tabrow = createrow(cs, s);
	snprint(s, sizeof s, "_%s-stack", name);
	t-&gt;tabstack = createstack(cs, s);
	snprint(s, sizeof s, "_%s-column", name);
	t-&gt;tabcolumn = createcolumn(cs, s);
	ctlprint(t-&gt;tabcolumn, "add %q %q", t-&gt;tabrow-&gt;name, t-&gt;tabstack-&gt;name);
	t-&gt;bordercolor = _getctlimage("black");
	t-&gt;image = _getctlimage("white");
	t-&gt;setsize = tabsize;
	t-&gt;activate = activatetab;
	return (Control*)t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

