<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libcontrol/textbutton.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libcontrol/textbutton.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;keyboard.h&gt;
#include &lt;control.h&gt;

typedef struct Textbutton Textbutton;

struct Textbutton
{
	Control;
	CFont	*font;
	CImage	*image;
	CImage	*mask;
	CImage	*light;
	CImage	*bordercolor;
	CImage	*textcolor;
	CImage	*pressedtextcolor;
	CImage	*paletextcolor;
	int		pressed;
	int		lastbut;
	int		lastshow;
	char		**line;
	int		nline;
	int		align;
	int		border;
	int		off;
	int		showoff;
	int		prepress;
};

enum{
	EAlign,
	EBorder,
	EBordercolor,
	EFocus,
	EFont,
	EFormat,
	EHide,
	EImage,
	ELight,
	EMask,
	EPaletextcolor,
	EPressedtextcolor,
	ERect,
	EReveal,
	EShow,
	ESize,
	EText,
	ETextcolor,
	EValue,
};

static char *cmds[] = {
	[EAlign] =			"align",
	[EBorder] =		"border",
	[EBordercolor] = 	"bordercolor",
	[EFocus] = 		"focus",
	[EFont] =			"font",
	[EFormat] = 		"format",
	[EHide] =			"hide",
	[EImage] =		"image",
	[ELight] =			"light",
	[EMask] =			"mask",
	[EPaletextcolor] ="paletextcolor",
	[EPressedtextcolor] ="pressedtextcolor",
	[ERect] =			"rect",
	[EReveal] =		"reveal",
	[EShow] =			"show",
	[ESize] =			"size",
	[EText] =			"text",
	[ETextcolor] =		"textcolor",
	[EValue] =			"value",
	nil
};

static void	textbuttonshow(Textbutton*);

static void
textbuttonmouse(Control *c, Mouse *m)
{
	Textbutton *t;

	t = (Textbutton *)c;
	if(m-&gt;buttons&amp;7) {
		if (ptinrect(m-&gt;xy,t-&gt;rect)) {
			if (t-&gt;off) {
				t-&gt;off = 0;
				textbuttonshow(t);
			}
		} else {
			if (!t-&gt;off) {
				t-&gt;off = 1;
				textbuttonshow(t);
			}
		}
	}
	if((m-&gt;buttons&amp;7) != t-&gt;lastbut){
		if(m-&gt;buttons &amp; 7){
			t-&gt;prepress = t-&gt;pressed;
			if (t-&gt;pressed)
				t-&gt;pressed = 0;
			else
				t-&gt;pressed = 1;
			textbuttonshow(t);
		}else{	/* generate event on button up */
			if (ptinrect(m-&gt;xy,t-&gt;rect))
				chanprint(t-&gt;event, t-&gt;format, t-&gt;name, t-&gt;pressed);
			else {
				t-&gt;off = 0;
				t-&gt;pressed = t-&gt;prepress;
				textbuttonshow(t);
			}
		}
	}
	t-&gt;lastbut = m-&gt;buttons &amp; 7;
}

static void
textbuttonfree(Control *c)
{
	int i;
	Textbutton *t;

	t = (Textbutton*)c;
	_putctlfont(t-&gt;font);
	_putctlimage(t-&gt;image);
	_putctlimage(t-&gt;light);
	_putctlimage(t-&gt;mask);
	_putctlimage(t-&gt;textcolor);
	_putctlimage(t-&gt;bordercolor);
	_putctlimage(t-&gt;paletextcolor);
	_putctlimage(t-&gt;pressedtextcolor);
	for(i=0; i&lt;t-&gt;nline; i++)
		free(t-&gt;line[i]);
	free(t-&gt;line);
}

static void
textbuttonshow(Textbutton *t)
{
	Rectangle r, clipr;
	int i, dx, dy, w;
	Font *f;
	Point p, q;
	Image *im;

	if(t-&gt;hidden || (t-&gt;lastshow == t-&gt;pressed &amp;&amp; t-&gt;showoff == t-&gt;off))
		return;
	f = t-&gt;font-&gt;font;
	draw(t-&gt;screen, t-&gt;rect, t-&gt;image-&gt;image, nil, t-&gt;image-&gt;image-&gt;r.min);
	if(t-&gt;border &gt; 0)
		border(t-&gt;screen, t-&gt;rect, t-&gt;border, t-&gt;bordercolor-&gt;image, ZP);
	/* text goes here */
	dx = 0;
	for(i=0; i&lt;t-&gt;nline; i++){
		w = stringwidth(f, t-&gt;line[i]);
		if(dx &lt; w)
			dx = w;
	}
	dy = t-&gt;nline*f-&gt;height;
	clipr = insetrect(t-&gt;rect, t-&gt;border);
	p = _ctlalignpoint(clipr, dx, dy, t-&gt;align);
	im = t-&gt;textcolor-&gt;image;
	if(t-&gt;off)
		im = t-&gt;paletextcolor-&gt;image;
	else if(t-&gt;pressed)
		im = t-&gt;pressedtextcolor-&gt;image;
	for(i=0; i&lt;t-&gt;nline; i++){
		r.min = p;
		r.max.x = p.x+dx;
		r.max.y = p.y+f-&gt;height;
		q = _ctlalignpoint(r, stringwidth(f, t-&gt;line[i]), f-&gt;height, t-&gt;align%3);
		_string(t-&gt;screen, q, im,
			ZP, f, t-&gt;line[i], nil, strlen(t-&gt;line[i]),
			clipr, nil, ZP, SoverD);
		p.y += f-&gt;height;
	}
	if(t-&gt;off || t-&gt;pressed)
		draw(t-&gt;screen, t-&gt;rect, t-&gt;light-&gt;image, t-&gt;mask-&gt;image, t-&gt;mask-&gt;image-&gt;r.min);
	t-&gt;lastshow = t-&gt;pressed;
	t-&gt;showoff = t-&gt;off;
	flushimage(display, 1);
}

static void
textbuttonctl(Control *c, CParse *cp)
{
	int cmd, i;
	Rectangle r;
	Textbutton *t;

	t = (Textbutton*)c;
	cmd = _ctllookup(cp-&gt;args[0], cmds, nelem(cmds));
	switch(cmd){
	default:
		ctlerror("%q: unrecognized message '%s'", t-&gt;name, cp-&gt;str);
		break;
	case EAlign:
		_ctlargcount(t, cp, 2);
		t-&gt;align = _ctlalignment(cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EBorder:
		_ctlargcount(t, cp, 2);
		t-&gt;border = cp-&gt;iargs[1];
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EBordercolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;bordercolor, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EFocus:
		break;
	case EFont:
		_ctlargcount(t, cp, 2);
		_setctlfont(t, &amp;t-&gt;font, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EFormat:
		_ctlargcount(t, cp, 2);
		t-&gt;format = ctlstrdup(cp-&gt;args[1]);
		break;
	case EHide:
		_ctlargcount(t, cp, 1);
		t-&gt;hidden = 1;
		break;
	case EImage:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;image, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case ELight:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;light, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EMask:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;mask, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EPaletextcolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;paletextcolor, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EPressedtextcolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;pressedtextcolor, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case ERect:
		_ctlargcount(t, cp, 5);
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		r.max.x = cp-&gt;iargs[3];
		r.max.y = cp-&gt;iargs[4];
		if(Dx(r)&lt;=0 || Dy(r)&lt;=0)
			ctlerror("%q: bad rectangle: %s", t-&gt;name, cp-&gt;str);
		t-&gt;rect = r;
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EReveal:
		_ctlargcount(t, cp, 1);
		t-&gt;hidden = 0;
		t-&gt;lastshow = -1;	/* force redraw */
		textbuttonshow(t);
		break;
	case EShow:
		_ctlargcount(t, cp, 1);
		t-&gt;lastshow = -1;	/* force redraw */
		textbuttonshow(t);
		break;
	case ESize:
		if (cp-&gt;nargs == 3)
			r.max = Pt(0x7fffffff, 0x7fffffff);
		else{
			_ctlargcount(t, cp, 5);
			r.max.x = cp-&gt;iargs[3];
			r.max.y = cp-&gt;iargs[4];
		}
		r.min.x = cp-&gt;iargs[1];
		r.min.y = cp-&gt;iargs[2];
		if(r.min.x&lt;=0 || r.min.y&lt;=0 || r.max.x&lt;=0 || r.max.y&lt;=0 || r.max.x &lt; r.min.x || r.max.y &lt; r.min.y)
			ctlerror("%q: bad sizes: %s", t-&gt;name, cp-&gt;str);
		t-&gt;size.min = r.min;
		t-&gt;size.max = r.max;
		break;
	case EText:
		/* free existing text */
		for(i=0; i&lt;t-&gt;nline; i++)
			free(t-&gt;line[i]);
		t-&gt;nline = cp-&gt;nargs-1;
		t-&gt;line = ctlrealloc(t-&gt;line, t-&gt;nline*sizeof(char*));
		for(i=0; i&lt;t-&gt;nline; i++)
			t-&gt;line[i] = ctlstrdup(cp-&gt;args[i+1]);
		t-&gt;lastshow = -1;	/* force redraw */
		textbuttonshow(t);
		break;
	case ETextcolor:
		_ctlargcount(t, cp, 2);
		_setctlimage(t, &amp;t-&gt;textcolor, cp-&gt;args[1]);
		t-&gt;lastshow = -1;	/* force redraw */
		break;
	case EValue:
		_ctlargcount(t, cp, 2);
		if((cp-&gt;iargs[1]!=0) != t-&gt;pressed){
			t-&gt;pressed ^= 1;
			textbuttonshow(t);
		}
		break;
	}
}

Control*
createtextbutton(Controlset *cs, char *name)
{
	Textbutton *t;

	t = (Textbutton *)_createctl(cs, "textbutton", sizeof(Textbutton), name);
	t-&gt;line = ctlmalloc(sizeof(char*));
	t-&gt;nline = 0;
	t-&gt;image = _getctlimage("white");
	t-&gt;light = _getctlimage("yellow");
	t-&gt;mask = _getctlimage("opaque");
	t-&gt;bordercolor = _getctlimage("black");
	t-&gt;textcolor = _getctlimage("black");
	t-&gt;pressedtextcolor = _getctlimage("black");
	t-&gt;paletextcolor = _getctlimage("paleyellow");
	t-&gt;font = _getctlfont("font");
	t-&gt;format = ctlstrdup("%q: value %d");
	t-&gt;lastshow = -1;
	t-&gt;mouse = textbuttonmouse;
	t-&gt;ctl = textbuttonctl;
	t-&gt;exit = textbuttonfree;
	t-&gt;prepress = 0;
	t-&gt;off = 0;
	t-&gt;showoff = -1;
	return (Control *)t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

