<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdisk/proto.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdisk/proto.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include &lt;fcall.h&gt;
#include &lt;disk.h&gt;

enum {
	LEN	= 8*1024,
	HUNKS	= 128,
};

typedef struct File File;
struct File{
	char	*new;
	char	*elem;
	char	*old;
	char	*uid;
	char	*gid;
	ulong	mode;
};

typedef void Mkfserr(char*, void*);
typedef void Mkfsenum(char*, char*, Dir*, void*);

typedef struct Name Name;
struct Name {
	int n;
	char *s;
};

typedef struct Mkaux Mkaux;
struct Mkaux {
	Mkfserr *warn;
	Mkfsenum *mkenum;
	char *root;
	char *proto;
	jmp_buf jmp;
	Biobuf *b;

	Name oldfile;
	Name fullname;
	int	lineno;
	int	indent;

	void *a;
};

static void domkfs(Mkaux *mkaux, File *me, int level);

static int	copyfile(Mkaux*, File*, Dir*, int);
static void	freefile(File*);
static File*	getfile(Mkaux*, File*);
static char*	getmode(Mkaux*, char*, ulong*);
static char*	getname(Mkaux*, char*, char**);
static char*	getpath(Mkaux*, char*);
static int	mkfile(Mkaux*, File*);
static char*	mkpath(Mkaux*, char*, char*);
static void	mktree(Mkaux*, File*, int);
static void	setnames(Mkaux*, File*);
static void	skipdir(Mkaux*);
static void	warn(Mkaux*, char *, ...);

//static void
//mprint(char *new, char *old, Dir *d, void*)
//{
//	print("%s %s %D\n", new, old, d);
//}

int
rdproto(char *proto, char *root, Mkfsenum *mkenum, Mkfserr *mkerr, void *a)
{
	Mkaux mx, *m;
	File file;
	int rv;

	m = &amp;mx;
	memset(&amp;mx, 0, sizeof mx);
	if(root == nil)
		root = "/";

	m-&gt;root = root;
	m-&gt;warn = mkerr;
	m-&gt;mkenum = mkenum;
	m-&gt;a = a;
	m-&gt;proto = proto;
	m-&gt;lineno = 0;
	m-&gt;indent = 0;
	if((m-&gt;b = Bopen(proto, OREAD)) == nil) {
		werrstr("open '%s': %r", proto);
		return -1;
	}

	memset(&amp;file, 0, sizeof file);
	file.new = "";
	file.old = nil;

	rv = 0;
	if(setjmp(m-&gt;jmp) == 0)
		domkfs(m, &amp;file, -1);
	else
		rv = -1;
	free(m-&gt;oldfile.s);
	free(m-&gt;fullname.s);
	return rv;
}

static void*
emalloc(Mkaux *mkaux, ulong n)
{
	void *v;

	v = malloc(n);
	if(v == nil)
		longjmp(mkaux-&gt;jmp, 1);	/* memory leak */
	memset(v, 0, n);
	return v;
}

static char*
estrdup(Mkaux *mkaux, char *s)
{
	s = strdup(s);
	if(s == nil)
		longjmp(mkaux-&gt;jmp, 1);	/* memory leak */
	return s;
}

static void
domkfs(Mkaux *mkaux, File *me, int level)
{
	File *child;
	int rec;

	child = getfile(mkaux, me);
	if(!child)
		return;
	if((child-&gt;elem[0] == '+' || child-&gt;elem[0] == '*') &amp;&amp; child-&gt;elem[1] == '\0'){
		rec = child-&gt;elem[0] == '+';
		free(child-&gt;new);
		child-&gt;new = estrdup(mkaux, me-&gt;new);
		setnames(mkaux, child);
		mktree(mkaux, child, rec);
		freefile(child);
		child = getfile(mkaux, me);
	}
	while(child &amp;&amp; mkaux-&gt;indent &gt; level){
		if(mkfile(mkaux, child))
			domkfs(mkaux, child, mkaux-&gt;indent);
		freefile(child);
		child = getfile(mkaux, me);
	}
	if(child){
		freefile(child);
		Bseek(mkaux-&gt;b, -Blinelen(mkaux-&gt;b), 1);
		mkaux-&gt;lineno--;
	}
}

static void
mktree(Mkaux *mkaux, File *me, int rec)
{
	File child;
	Dir *d;
	int i, n, fd;

	fd = open(mkaux-&gt;oldfile.s, OREAD);
	if(fd &lt; 0){
		warn(mkaux, "can't open %s: %r", mkaux-&gt;oldfile.s);
		return;
	}

	child = *me;
	while((n = dirread(fd, &amp;d)) &gt; 0){
		for(i = 0; i &lt; n; i++){
			child.new = mkpath(mkaux, me-&gt;new, d[i].name);
			if(me-&gt;old)
				child.old = mkpath(mkaux, me-&gt;old, d[i].name);
			child.elem = d[i].name;
			setnames(mkaux, &amp;child);
			if((!(d[i].mode&amp;DMDIR) || rec) &amp;&amp; copyfile(mkaux, &amp;child, &amp;d[i], 1) &amp;&amp; rec)
				mktree(mkaux, &amp;child, rec);
			free(child.new);
			if(child.old)
				free(child.old);
		}
	}
	close(fd);
}

static int
mkfile(Mkaux *mkaux, File *f)
{
	Dir *d;

	if((d = dirstat(mkaux-&gt;oldfile.s)) == nil){
		warn(mkaux, "can't stat file %s: %r", mkaux-&gt;oldfile.s);
		skipdir(mkaux);
		return 0;
	}
	return copyfile(mkaux, f, d, 0);
}

enum {
	SLOP = 30
};

static void
setname(Mkaux *mkaux, Name *name, char *s1, char *s2)
{
	int l;

	l = strlen(s1)+strlen(s2)+1;
	if(name-&gt;n &lt; l+SLOP/2) {
		free(name-&gt;s);
		name-&gt;s = emalloc(mkaux, l+SLOP);
		name-&gt;n = l+SLOP;
	}
	snprint(name-&gt;s, name-&gt;n, "%s%s%s", s1, s1[0]==0 || s1[strlen(s1)-1]!='/' ? "/" : "", s2);
}

static int
copyfile(Mkaux *mkaux, File *f, Dir *d, int permonly)
{
	Dir *nd;
	ulong xmode;
	char *p;

	setname(mkaux, &amp;mkaux-&gt;fullname, mkaux-&gt;root, f-&gt;old ? f-&gt;old : f-&gt;new);
	/*
	 * Extra stat here is inefficient but accounts for binds.
	 */
	if((nd = dirstat(mkaux-&gt;fullname.s)) != nil)
		d = nd;

	d-&gt;name = f-&gt;elem;
	if(d-&gt;type != 'M'){
		d-&gt;uid = "sys";
		d-&gt;gid = "sys";
		xmode = (d-&gt;mode &gt;&gt; 6) &amp; 7;
		d-&gt;mode |= xmode | (xmode &lt;&lt; 3);
	}
	if(strcmp(f-&gt;uid, "-") != 0)
		d-&gt;uid = f-&gt;uid;
	if(strcmp(f-&gt;gid, "-") != 0)
		d-&gt;gid = f-&gt;gid;
	if(f-&gt;mode != ~0){
		if(permonly)
			d-&gt;mode = (d-&gt;mode &amp; ~0666) | (f-&gt;mode &amp; 0666);
		else if((d-&gt;mode&amp;DMDIR) != (f-&gt;mode&amp;DMDIR))
			warn(mkaux, "inconsistent mode for %s", f-&gt;new);
		else
			d-&gt;mode = f-&gt;mode;
	}

	if(p = strrchr(f-&gt;new, '/'))
		d-&gt;name = p+1;
	else
		d-&gt;name = f-&gt;new;

	mkaux-&gt;mkenum(f-&gt;new, mkaux-&gt;fullname.s, d, mkaux-&gt;a);
	xmode = d-&gt;mode;
	free(nd);
	return (xmode&amp;DMDIR) != 0;
}

static char *
mkpath(Mkaux *mkaux, char *prefix, char *elem)
{
	char *p;
	int n;

	n = strlen(prefix) + strlen(elem) + 2;
	p = emalloc(mkaux, n);
	strcpy(p, prefix);
	strcat(p, "/");
	strcat(p, elem);
	return p;
}

static void
setnames(Mkaux *mkaux, File *f)
{
	
	if(f-&gt;old){
		if(f-&gt;old[0] == '/')
			setname(mkaux, &amp;mkaux-&gt;oldfile, f-&gt;old, "");
		else
			setname(mkaux, &amp;mkaux-&gt;oldfile, mkaux-&gt;root, f-&gt;old);
	} else
		setname(mkaux, &amp;mkaux-&gt;oldfile, mkaux-&gt;root, f-&gt;new);
}

static void
freefile(File *f)
{
	if(f-&gt;old)
		free(f-&gt;old);
	if(f-&gt;new)
		free(f-&gt;new);
	free(f);
}

/*
 * skip all files in the proto that
 * could be in the current dir
 */
static void
skipdir(Mkaux *mkaux)
{
	char *p, c;
	int level;

	if(mkaux-&gt;indent &lt; 0)
		return;
	level = mkaux-&gt;indent;
	for(;;){
		mkaux-&gt;indent = 0;
		p = Brdline(mkaux-&gt;b, '\n');
		mkaux-&gt;lineno++;
		if(!p){
			mkaux-&gt;indent = -1;
			return;
		}
		while((c = *p++) != '\n')
			if(c == ' ')
				mkaux-&gt;indent++;
			else if(c == '\t')
				mkaux-&gt;indent += 8;
			else
				break;
		if(mkaux-&gt;indent &lt;= level){
			Bseek(mkaux-&gt;b, -Blinelen(mkaux-&gt;b), 1);
			mkaux-&gt;lineno--;
			return;
		}
	}
}

static File*
getfile(Mkaux *mkaux, File *old)
{
	File *f;
	char *elem;
	char *p;
	int c;

	if(mkaux-&gt;indent &lt; 0)
		return 0;
loop:
	mkaux-&gt;indent = 0;
	p = Brdline(mkaux-&gt;b, '\n');
	mkaux-&gt;lineno++;
	if(!p){
		mkaux-&gt;indent = -1;
		return 0;
	}
	while((c = *p++) != '\n')
		if(c == ' ')
			mkaux-&gt;indent++;
		else if(c == '\t')
			mkaux-&gt;indent += 8;
		else
			break;
	if(c == '\n' || c == '#')
		goto loop;
	p--;
	f = emalloc(mkaux, sizeof *f);
	p = getname(mkaux, p, &amp;elem);
	if(p == nil)
		return nil;

	f-&gt;new = mkpath(mkaux, old-&gt;new, elem);
	free(elem);
	f-&gt;elem = utfrrune(f-&gt;new, L'/') + 1;
	p = getmode(mkaux, p, &amp;f-&gt;mode);
	p = getname(mkaux, p, &amp;f-&gt;uid);	/* LEAK */
	if(p == nil)
		return nil;

	if(!*f-&gt;uid)
		strcpy(f-&gt;uid, "-");
	p = getname(mkaux, p, &amp;f-&gt;gid);	/* LEAK */
	if(p == nil)
		return nil;

	if(!*f-&gt;gid)
		strcpy(f-&gt;gid, "-");
	f-&gt;old = getpath(mkaux, p);
	if(f-&gt;old &amp;&amp; strcmp(f-&gt;old, "-") == 0){
		free(f-&gt;old);
		f-&gt;old = 0;
	}
	setnames(mkaux, f);

	return f;
}

static char*
getpath(Mkaux *mkaux, char *p)
{
	char *q, *new;
	int c, n;

	while((c = *p) == ' ' || c == '\t')
		p++;
	q = p;
	while((c = *q) != '\n' &amp;&amp; c != ' ' &amp;&amp; c != '\t')
		q++;
	if(q == p)
		return 0;
	n = q - p;
	new = emalloc(mkaux, n + 1);
	memcpy(new, p, n);
	new[n] = 0;
	return new;
}

static char*
getname(Mkaux *mkaux, char *p, char **buf)
{
	char *s, *start;
	int c;

	while((c = *p) == ' ' || c == '\t')
		p++;

	start = p;
	while((c = *p) != '\n' &amp;&amp; c != ' ' &amp;&amp; c != '\t')
		p++;

	*buf = malloc(p+2-start);	/* +2: need at least 2 bytes; might strcpy "-" into buf */
	if(*buf == nil)
		return nil;
	memmove(*buf, start, p-start);

	(*buf)[p-start] = '\0';

	if(**buf == '$'){
		s = getenv(*buf+1);
		if(s == 0){
			warn(mkaux, "can't read environment variable %s", *buf+1);
			skipdir(mkaux);
			free(*buf);
			return nil;
		}
		free(*buf);
		*buf = s;
	}
	return p;
}

static char*
getmode(Mkaux *mkaux, char *p, ulong *xmode)
{
	char *buf, *s;
	ulong m;

	*xmode = ~0;
	p = getname(mkaux, p, &amp;buf);
	if(p == nil)
		return nil;

	s = buf;
	if(!*s || strcmp(s, "-") == 0)
		return p;
	m = 0;
	if(*s == 'd'){
		m |= DMDIR;
		s++;
	}
	if(*s == 'a'){
		m |= DMAPPEND;
		s++;
	}
	if(*s == 'l'){
		m |= DMEXCL;
		s++;
	}
	if(s[0] &lt; '0' || s[0] &gt; '7'
	|| s[1] &lt; '0' || s[1] &gt; '7'
	|| s[2] &lt; '0' || s[2] &gt; '7'
	|| s[3]){
		warn(mkaux, "bad mode specification %s", buf);
		free(buf);
		return p;
	}
	*xmode = m | strtoul(s, 0, 8);
	free(buf);
	return p;
}

static void
warn(Mkaux *mkaux, char *fmt, ...)
{
	char buf[256];
	va_list va;

	va_start(va, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, va);
	va_end(va);

	if(mkaux-&gt;warn)
		mkaux-&gt;warn(buf, mkaux-&gt;a);
	else
		fprint(2, "warning: %s\n", buf);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

