<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/buildfont.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/buildfont.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;

static char*
skip(char *s)
{
	while(*s==' ' || *s=='\n' || *s=='\t')
		s++;
	return s;
}

Font*
buildfont(Display *d, char *buf, char *name)
{
	Font *fnt;
	Cachefont *c;
	char *s, *t;
	ulong min, max;
	int offset;
	char badform[] = "bad font format: number expected (char position %d)";

	s = buf;
	fnt = malloc(sizeof(Font));
	if(fnt == 0)
		return 0;
	memset(fnt, 0, sizeof(Font));
	fnt-&gt;display = d;
	fnt-&gt;name = strdup(name);
	fnt-&gt;ncache = NFCACHE+NFLOOK;
	fnt-&gt;nsubf = NFSUBF;
	fnt-&gt;cache = malloc(fnt-&gt;ncache * sizeof(fnt-&gt;cache[0]));
	fnt-&gt;subf = malloc(fnt-&gt;nsubf * sizeof(fnt-&gt;subf[0]));
	if(fnt-&gt;name==0 || fnt-&gt;cache==0 || fnt-&gt;subf==0){
    Err2:
		free(fnt-&gt;name);
		free(fnt-&gt;cache);
		free(fnt-&gt;subf);
		free(fnt-&gt;sub);
		free(fnt);
		return 0;
	}
	fnt-&gt;height = strtol(s, &amp;s, 0);
	s = skip(s);
	fnt-&gt;ascent = strtol(s, &amp;s, 0);
	s = skip(s);
	if(fnt-&gt;height&lt;=0 || fnt-&gt;ascent&lt;=0){
		werrstr("bad height or ascent in font file");
		goto Err2;
	}
	fnt-&gt;width = 0;
	fnt-&gt;nsub = 0;
	fnt-&gt;sub = 0;

	memset(fnt-&gt;subf, 0, fnt-&gt;nsubf * sizeof(fnt-&gt;subf[0]));
	memset(fnt-&gt;cache, 0, fnt-&gt;ncache*sizeof(fnt-&gt;cache[0]));
	fnt-&gt;age = 1;
	do{
		/* must be looking at a number now */
		if(*s&lt;'0' || '9'&lt;*s){
			werrstr(badform, s-buf);
			goto Err3;
		}
		min = strtol(s, &amp;s, 0);
		s = skip(s);
		/* must be looking at a number now */
		if(*s&lt;'0' || '9'&lt;*s){
			werrstr(badform, s-buf);
			goto Err3;
		}
		max = strtol(s, &amp;s, 0);
		s = skip(s);
		if(*s==0 || min&gt;=Runemax || max&gt;=Runemax || min&gt;max){
			werrstr("illegal subfont range");
    Err3:
			freefont(fnt);
			return 0;
		}
		t = s;
		offset = strtol(s, &amp;t, 0);
		if(t&gt;s &amp;&amp; (*t==' ' || *t=='\t' || *t=='\n'))
			s = skip(t);
		else
			offset = 0;
		fnt-&gt;sub = realloc(fnt-&gt;sub, (fnt-&gt;nsub+1)*sizeof(Cachefont*));
		if(fnt-&gt;sub == 0){
			/* realloc manual says fnt-&gt;sub may have been destroyed */
			fnt-&gt;nsub = 0;
			goto Err3;
		}
		c = malloc(sizeof(Cachefont));
		if(c == 0)
			goto Err3;
		fnt-&gt;sub[fnt-&gt;nsub] = c;
		c-&gt;min = min;
		c-&gt;max = max;
		c-&gt;offset = offset;
		t = s;
		while(*s &amp;&amp; *s!=' ' &amp;&amp; *s!='\n' &amp;&amp; *s!='\t')
			s++;
		*s++ = 0;
		c-&gt;subfontname = 0;
		c-&gt;name = strdup(t);
		if(c-&gt;name == 0){
			free(c);
			goto Err3;
		}
		s = skip(s);
		fnt-&gt;nsub++;
	}while(*s);
	return fnt;
}

void
freefont(Font *f)
{
	int i;
	Cachefont *c;
	Subfont *s;

	if(f == 0)
		return;

	for(i=0; i&lt;f-&gt;nsub; i++){
		c = f-&gt;sub[i];
		free(c-&gt;subfontname);
		free(c-&gt;name);
		free(c);
	}
	for(i=0; i&lt;f-&gt;nsubf; i++){
		s = f-&gt;subf[i].f;
		if(s &amp;&amp; display &amp;&amp; s!=display-&gt;defaultsubfont)
			freesubfont(s);
	}
	freeimage(f-&gt;cacheimage);
	free(f-&gt;name);
	free(f-&gt;cache);
	free(f-&gt;subf);
	free(f-&gt;sub);
	free(f);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

