<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/event.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/event.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;cursor.h&gt;
#include &lt;event.h&gt;

typedef struct	Slave Slave;
typedef struct	Ebuf Ebuf;

struct Slave
{
	int	pid;
	Ebuf	*head;		/* queue of messages for this descriptor */
	Ebuf	*tail;
	int	(*fn)(int, Event*, uchar*, int);
};

struct Ebuf
{
	Ebuf	*next;
	int	n;		/* number of bytes in buf */
	uchar	buf[EMAXMSG];
};

static	Slave	eslave[MAXSLAVE];
static	int	Skeyboard = -1;
static	int	Smouse = -1;
static	int	Stimer = -1;
static	int	logfid;

static	int	nslave;
static	int	parentpid;
static	int	epipe[2];

static	int	eforkslave(ulong);
static	void	extract(void);
static	void	ekill(void);
static	int	enote(void *, char *);

static	int	mousefd;
static	int	cursorfd;

static
Ebuf*
ebread(Slave *s)
{
	Ebuf *eb;
	Dir *d;
	ulong l;

	for(;;){
		d = dirfstat(epipe[0]);
		if(d == nil)
			drawerror(display, "events: eread stat error");
		l = d-&gt;length;
		free(d);
		if(s-&gt;head &amp;&amp; l==0)
			break;
		extract();
	}
	eb = s-&gt;head;
	s-&gt;head = s-&gt;head-&gt;next;
	if(s-&gt;head == 0)
		s-&gt;tail = 0;
	return eb;
}

ulong
event(Event *e)
{
	return eread(~0UL, e);
}

ulong
eread(ulong keys, Event *e)
{
	Ebuf *eb;
	int i, id;

	if(keys == 0)
		return 0;
	for(;;){
		for(i=0; i&lt;nslave; i++)
			if((keys &amp; (1&lt;&lt;i)) &amp;&amp; eslave[i].head){
				id = 1&lt;&lt;i;
				if(i == Smouse)
					e-&gt;mouse = emouse();
				else if(i == Skeyboard)
					e-&gt;kbdc = ekbd();
				else if(i == Stimer)
					eslave[i].head = 0;
				else{
					eb = ebread(&amp;eslave[i]);
					e-&gt;n = eb-&gt;n;
					if(eslave[i].fn)
						id = (*eslave[i].fn)(id, e, eb-&gt;buf, eb-&gt;n);
					else
						memmove(e-&gt;data, eb-&gt;buf, eb-&gt;n);
					free(eb);
				}
				return id;
			}
		extract();
	}
}

int
ecanmouse(void)
{
	if(Smouse &lt; 0)
		drawerror(display, "events: mouse not initialized");
	return ecanread(Emouse);
}

int
ecankbd(void)
{
	if(Skeyboard &lt; 0)
		drawerror(display, "events: keyboard not initialzed");
	return ecanread(Ekeyboard);
}

int
ecanread(ulong keys)
{
	Dir *d;
	int i;
	ulong l;

	for(;;){
		for(i=0; i&lt;nslave; i++)
			if((keys &amp; (1&lt;&lt;i)) &amp;&amp; eslave[i].head)
				return 1;
		d = dirfstat(epipe[0]);
		if(d == nil)
			drawerror(display, "events: ecanread stat error");
		l = d-&gt;length;
		free(d);
		if(l == 0)
			return 0;
		extract();
	}
}

ulong
estartfn(ulong key, int fd, int n, int (*fn)(int, Event*, uchar*, int))
{
	char buf[EMAXMSG+1];
	int i, r;

	if(fd &lt; 0)
		drawerror(display, "events: bad file descriptor");
	if(n &lt;= 0 || n &gt; EMAXMSG)
		n = EMAXMSG;
	i = eforkslave(key);
	if(i &lt; MAXSLAVE){
		eslave[i].fn = fn;
		return 1&lt;&lt;i;
	}
	buf[0] = i - MAXSLAVE;
	while((r = read(fd, buf+1, n))&gt;0)
		if(write(epipe[1], buf, r+1)!=r+1)
			break;
	buf[0] = MAXSLAVE;
	write(epipe[1], buf, 1);
	_exits(0);
	return 0;
}

ulong
estart(ulong key, int fd, int n)
{
	return estartfn(key, fd, n, nil);
}

ulong
etimer(ulong key, int n)
{
	char t[2];

	if(Stimer != -1)
		drawerror(display, "events: timer started twice");
	Stimer = eforkslave(key);
	if(Stimer &lt; MAXSLAVE)
		return 1&lt;&lt;Stimer;
	if(n &lt;= 0)
		n = 1000;
	t[0] = t[1] = Stimer - MAXSLAVE;
	do
		sleep(n);
	while(write(epipe[1], t, 2) == 2);
	t[0] = MAXSLAVE;
	write(epipe[1], t, 1);
	_exits(0);
	return 0;
}

static void
ekeyslave(int fd)
{
	Rune r;
	char t[3], k[10];
	int kr, kn, w;

	if(eforkslave(Ekeyboard) &lt; MAXSLAVE)
		return;
	kn = 0;
	t[0] = Skeyboard;
	for(;;){
		while(!fullrune(k, kn)){
			kr = read(fd, k+kn, sizeof k - kn);
			if(kr &lt;= 0)
				goto breakout;
			kn += kr;
		}
		w = chartorune(&amp;r, k);
		kn -= w;
		memmove(k, &amp;k[w], kn);
		t[1] = r;
		t[2] = r&gt;&gt;8;
		if(write(epipe[1], t, 3) != 3)
			break;
	}
breakout:;
	t[0] = MAXSLAVE;
	write(epipe[1], t, 1);
	_exits(0);
}

void
einit(ulong keys)
{
	int ctl, fd;
	char buf[256];

	parentpid = getpid();
	if(pipe(epipe) &lt; 0)
		drawerror(display, "events: einit pipe");
	atexit(ekill);
	atnotify(enote, 1);
	snprint(buf, sizeof buf, "%s/mouse", display-&gt;devdir);
	mousefd = open(buf, ORDWR|OCEXEC);
	if(mousefd &lt; 0)
		drawerror(display, "einit: can't open mouse\n");
	snprint(buf, sizeof buf, "%s/cursor", display-&gt;devdir);
	cursorfd = open(buf, ORDWR|OCEXEC);
	if(cursorfd &lt; 0)
		drawerror(display, "einit: can't open cursor\n");
	if(keys&amp;Ekeyboard){
		snprint(buf, sizeof buf, "%s/cons", display-&gt;devdir);
		fd = open(buf, OREAD);
		if(fd &lt; 0)
			drawerror(display, "events: can't open console");
		snprint(buf, sizeof buf, "%s/consctl", display-&gt;devdir);
		ctl = open("/dev/consctl", OWRITE|OCEXEC);
		if(ctl &lt; 0)
			drawerror(display, "events: can't open consctl");
		write(ctl, "rawon", 5);
		for(Skeyboard=0; Ekeyboard &amp; ~(1&lt;&lt;Skeyboard); Skeyboard++)
			;
		ekeyslave(fd);
	}
	if(keys&amp;Emouse){
		estart(Emouse, mousefd, 1+4*12);
		for(Smouse=0; Emouse &amp; ~(1&lt;&lt;Smouse); Smouse++)
			;
	}
}

static void
extract(void)
{
	Slave *s;
	Ebuf *eb;
	int i, n;
	uchar ebuf[EMAXMSG+1];

	/* avoid generating a message if there's nothing to show. */
	/* this test isn't perfect, though; could do flushimage(display, 0) then call extract */
	/* also: make sure we don't interfere if we're multiprocessing the display */
	if(display-&gt;locking){
		/* if locking is being done by program, this means it can't depend on automatic flush in emouse() etc. */
		if(canqlock(&amp;display-&gt;qlock)){
			if(display-&gt;bufp &gt; display-&gt;buf)
				flushimage(display, 1);
			unlockdisplay(display);
		}
	}else
		if(display-&gt;bufp &gt; display-&gt;buf)
			flushimage(display, 1);
loop:
	if((n=read(epipe[0], ebuf, EMAXMSG+1)) &lt; 0
	|| ebuf[0] &gt;= MAXSLAVE)
		drawerror(display, "eof on event pipe");
	if(n == 0)
		goto loop;
	i = ebuf[0];
	if(i &gt;= nslave || n &lt;= 1)
		drawerror(display, "events: protocol error: short read");
	s = &amp;eslave[i];
	if(i == Stimer){
		s-&gt;head = (Ebuf *)1;
		return;
	}
	if(i == Skeyboard &amp;&amp; n != 3)
		drawerror(display, "events: protocol error: keyboard");
	if(i == Smouse){
		if(n &lt; 1+1+2*12)
			drawerror(display, "events: protocol error: mouse");
		if(ebuf[1] == 'r')
			eresized(1);
		/* squash extraneous mouse events */
		if((eb=s-&gt;tail) &amp;&amp; memcmp(eb-&gt;buf+1+2*12, ebuf+1+1+2*12, 12)==0){
			memmove(eb-&gt;buf, &amp;ebuf[1], n - 1);
			return;
		}
	}
	/* try to save space by only allocating as much buffer as we need */
	eb = malloc(sizeof(*eb) - sizeof(eb-&gt;buf) + n - 1);
	if(eb == 0)
		drawerror(display, "events: protocol error 4");
	eb-&gt;n = n - 1;
	memmove(eb-&gt;buf, &amp;ebuf[1], n - 1);
	eb-&gt;next = 0;
	if(s-&gt;head)
		s-&gt;tail = s-&gt;tail-&gt;next = eb;
	else
		s-&gt;head = s-&gt;tail = eb;
}

static int
eforkslave(ulong key)
{
	int i, pid;

	for(i=0; i&lt;MAXSLAVE; i++)
		if((key &amp; ~(1&lt;&lt;i)) == 0 &amp;&amp; eslave[i].pid == 0){
			if(nslave &lt;= i)
				nslave = i + 1;
			/*
			 * share the file descriptors so the last child
			 * out closes all connections to the window server.
			 */
			switch(pid = rfork(RFPROC)){
			case 0:
				return MAXSLAVE+i;
			case -1:
				fprint(2, "events: fork error\n");
				exits("fork");
			}
			eslave[i].pid = pid;
			eslave[i].head = eslave[i].tail = 0;
			return i;
		}
	drawerror(display, "events: bad slave assignment");
	return 0;
}

static int
enote(void *v, char *s)
{
	char t[1];
	int i, pid;

	USED(v, s);
	pid = getpid();
	if(pid != parentpid){
		for(i=0; i&lt;nslave; i++){
			if(pid == eslave[i].pid){
				t[0] = MAXSLAVE;
				write(epipe[1], t, 1);
				break;
			}
		}
		return 0;
	}
	close(epipe[0]);
	epipe[0] = -1;
	close(epipe[1]);
	epipe[1] = -1;
	for(i=0; i&lt;nslave; i++){
		if(pid == eslave[i].pid)
			continue;	/* don't kill myself */
		postnote(PNPROC, eslave[i].pid, "die");
	}
	return 0;
}

static void
ekill(void)
{
	enote(0, 0);
}

Mouse
emouse(void)
{
	Mouse m;
	Ebuf *eb;
	static but[2];
	int b;

	if(Smouse &lt; 0)
		drawerror(display, "events: mouse not initialized");
	eb = ebread(&amp;eslave[Smouse]);
	m.xy.x = atoi((char*)eb-&gt;buf+1+0*12);
	m.xy.y = atoi((char*)eb-&gt;buf+1+1*12);
	b = atoi((char*)eb-&gt;buf+1+2*12);
	m.buttons = b;
	m.msec = atoi((char*)eb-&gt;buf+1+3*12);
	if (logfid)
		fprint(logfid, "b: %d xy: %P\n", m.buttons, m.xy);
	free(eb);
	return m;
}

int
ekbd(void)
{
	Ebuf *eb;
	int c;

	if(Skeyboard &lt; 0)
		drawerror(display, "events: keyboard not initialzed");
	eb = ebread(&amp;eslave[Skeyboard]);
	c = eb-&gt;buf[0] + (eb-&gt;buf[1]&lt;&lt;8);
	free(eb);
	return c;
}

void
emoveto(Point pt)
{
	char buf[2*12+2];
	int n;

	n = sprint(buf, "m%d %d", pt.x, pt.y);
	write(mousefd, buf, n);
}

void
esetcursor(Cursor *c)
{
	uchar curs[2*4+2*2*16];

	if(c == 0)
		write(cursorfd, curs, 0);
	else{
		BPLONG(curs+0*4, c-&gt;offset.x);
		BPLONG(curs+1*4, c-&gt;offset.y);
		memmove(curs+2*4, c-&gt;clr, 2*2*16);
		write(cursorfd, curs, sizeof curs);
	}
}

int
ereadmouse(Mouse *m)
{
	int n;
	char buf[128];

	do{
		n = read(mousefd, buf, sizeof(buf));
		if(n &lt; 0)	/* probably interrupted */
			return -1;
		n = eatomouse(m, buf, n);
	}while(n == 0);
	return n;
}

int
eatomouse(Mouse *m, char *buf, int n)
{
	if(n != 1+4*12){
		werrstr("atomouse: bad count");
		return -1;
	}

	if(buf[0] == 'r')
		eresized(1);
	m-&gt;xy.x = atoi(buf+1+0*12);
	m-&gt;xy.y = atoi(buf+1+1*12);
	m-&gt;buttons = atoi(buf+1+2*12);
	m-&gt;msec = atoi(buf+1+3*12);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

