<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libdraw/mouse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libdraw/mouse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;cursor.h&gt;
#include &lt;mouse.h&gt;

void
moveto(Mousectl *m, Point pt)
{
	fprint(m-&gt;mfd, "m%d %d", pt.x, pt.y);
	m-&gt;xy = pt;
}

void
closemouse(Mousectl *mc)
{
	if(mc == nil)
		return;

	postnote(PNPROC, mc-&gt;pid, "kill");

	do; while(nbrecv(mc-&gt;c, &amp;mc-&gt;Mouse) &gt; 0);

	close(mc-&gt;mfd);
	close(mc-&gt;cfd);
	free(mc-&gt;file);
	free(mc-&gt;c);
	free(mc-&gt;resizec);
	free(mc);
}

int
readmouse(Mousectl *mc)
{
	if(mc-&gt;image)
		flushimage(mc-&gt;image-&gt;display, 1);
	if(recv(mc-&gt;c, &amp;mc-&gt;Mouse) &lt; 0){
		fprint(2, "readmouse: %r\n");
		return -1;
	}
	return 0;
}

static
void
_ioproc(void *arg)
{
	int n, nerr, one;
	char buf[1+5*12];
	Mouse m;
	Mousectl *mc;

	mc = arg;
	threadsetname("mouseproc");
	one = 1;
	memset(&amp;m, 0, sizeof m);
	mc-&gt;pid = getpid();
	nerr = 0;
	for(;;){
		n = read(mc-&gt;mfd, buf, sizeof buf);
		if(n != 1+4*12){
			yield();	/* if error is due to exiting, we'll exit here */
			fprint(2, "mouse: bad count %d not 49: %r\n", n);
			if(n&lt;0 || ++nerr&gt;10)
				threadexits("read error");
			continue;
		}
		nerr = 0;
		switch(buf[0]){
		case 'r':
			send(mc-&gt;resizec, &amp;one);
			/* fall through */
		case 'm':
			m.xy.x = atoi(buf+1+0*12);
			m.xy.y = atoi(buf+1+1*12);
			m.buttons = atoi(buf+1+2*12);
			m.msec = atoi(buf+1+3*12);
			send(mc-&gt;c, &amp;m);
			/*
			 * mc-&gt;Mouse is updated after send so it doesn't have wrong value if we block during send.
			 * This means that programs should receive into mc-&gt;Mouse (see readmouse() above) if
			 * they want full synchrony.
			 */
			mc-&gt;Mouse = m;
			break;
		}
	}
}

Mousectl*
initmouse(char *file, Image *i)
{
	Mousectl *mc;
	char *t, *sl;

	mc = mallocz(sizeof(Mousectl), 1);
	if(file == nil)
		file = "/dev/mouse";
	mc-&gt;file = strdup(file);
	mc-&gt;mfd = open(file, ORDWR|OCEXEC);
	if(mc-&gt;mfd&lt;0 &amp;&amp; strcmp(file, "/dev/mouse")==0){
		bind("#m", "/dev", MAFTER);
		mc-&gt;mfd = open(file, ORDWR|OCEXEC);
	}
	if(mc-&gt;mfd &lt; 0){
		free(mc);
		return nil;
	}
	t = malloc(strlen(file)+16);
	if (t == nil) {
		close(mc-&gt;mfd);
		free(mc);
		return nil;
	}
	strcpy(t, file);
	sl = utfrrune(t, '/');
	if(sl)
		strcpy(sl, "/cursor");
	else
		strcpy(t, "/dev/cursor");
	mc-&gt;cfd = open(t, ORDWR|OCEXEC);
	free(t);
	mc-&gt;image = i;
	mc-&gt;c = chancreate(sizeof(Mouse), 0);
	mc-&gt;resizec = chancreate(sizeof(int), 2);
	proccreate(_ioproc, mc, 4096);
	return mc;
}

void
setcursor(Mousectl *mc, Cursor *c)
{
	char curs[2*4+2*2*16];

	if(c == nil)
		write(mc-&gt;cfd, curs, 0);
	else{
		BPLONG(curs+0*4, c-&gt;offset.x);
		BPLONG(curs+1*4, c-&gt;offset.y);
		memmove(curs+2*4, c-&gt;clr, 2*2*16);
		write(mc-&gt;cfd, curs, sizeof curs);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

