<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libframe/frdelete.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libframe/frdelete.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;frame.h&gt;

int
frdelete(Frame *f, ulong p0, ulong p1)
{
	Point pt0, pt1, ppt0;
	Frbox *b;
	int n0, n1, n;
	ulong cn1;
	Rectangle r;
	int nn0;
	Image *col;

	if(p0&gt;=f-&gt;nchars || p0==p1 || f-&gt;b==nil)
		return 0;
	if(p1 &gt; f-&gt;nchars)
		p1 = f-&gt;nchars;
	n0 = _frfindbox(f, 0, 0, p0);
	if(n0 == f-&gt;nbox)
		drawerror(f-&gt;display, "off end in frdelete");
	n1 = _frfindbox(f, n0, p0, p1);
	pt0 = _frptofcharnb(f, p0, n0);
	pt1 = frptofchar(f, p1);
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 0);
	nn0 = n0;
	ppt0 = pt0;
	_frfreebox(f, n0, n1-1);
	f-&gt;modified = 1;

	/*
	 * Invariants:
	 *  - pt0 points to beginning, pt1 points to end
	 *  - n0 is box containing beginning of stuff being deleted
	 *  - n1, b are box containing beginning of stuff to be kept after deletion
	 *  - cn1 is char position of n1
	 *  - f-&gt;p0 and f-&gt;p1 are not adjusted until after all deletion is done
	 */
	b = &amp;f-&gt;box[n1];
	cn1 = p1;
	while(pt1.x!=pt0.x &amp;&amp; n1&lt;f-&gt;nbox){
		_frcklinewrap0(f, &amp;pt0, b);
		_frcklinewrap(f, &amp;pt1, b);
		n = _frcanfit(f, pt0, b);
		if(n==0)
			drawerror(f-&gt;display, "_frcanfit==0");
		r.min = pt0;
		r.max = pt0;
		r.max.y += f-&gt;font-&gt;height;
		if(b-&gt;nrune &gt; 0){
			if(n != b-&gt;nrune){
				_frsplitbox(f, n1, n);
				b = &amp;f-&gt;box[n1];
			}
			r.max.x += b-&gt;wid;
			draw(f-&gt;b, r, f-&gt;b, nil, pt1);
			cn1 += b-&gt;nrune;
		}else{
			r.max.x += _frnewwid0(f, pt0, b);
			if(r.max.x &gt; f-&gt;r.max.x)
				r.max.x = f-&gt;r.max.x;
			col = f-&gt;cols[BACK];
			if(f-&gt;p0&lt;=cn1 &amp;&amp; cn1&lt;f-&gt;p1)
				col = f-&gt;cols[HIGH];
			draw(f-&gt;b, r, col, nil, pt0);
			cn1++;
		}
		_fradvance(f, &amp;pt1, b);
		pt0.x += _frnewwid(f, pt0, b);
		f-&gt;box[n0++] = f-&gt;box[n1++];
		b++;
	}
	if(n1==f-&gt;nbox &amp;&amp; pt0.x!=pt1.x)	/* deleting last thing in window; must clean up */
		frselectpaint(f, pt0, pt1, f-&gt;cols[BACK]);
	if(pt1.y != pt0.y){
		Point pt2;

		pt2 = _frptofcharptb(f, 32767, pt1, n1);
		if(pt2.y &gt; f-&gt;r.max.y)
			drawerror(f-&gt;display, "frptofchar in frdelete");
		if(n1 &lt; f-&gt;nbox){
			int q0, q1, q2;

			q0 = pt0.y+f-&gt;font-&gt;height;
			q1 = pt1.y+f-&gt;font-&gt;height;
			q2 = pt2.y+f-&gt;font-&gt;height;
			if(q2 &gt; f-&gt;r.max.y)
				q2 = f-&gt;r.max.y;
			draw(f-&gt;b, Rect(pt0.x, pt0.y, pt0.x+(f-&gt;r.max.x-pt1.x), q0),
				f-&gt;b, nil, pt1);
			draw(f-&gt;b, Rect(f-&gt;r.min.x, q0, f-&gt;r.max.x, q0+(q2-q1)),
				f-&gt;b, nil, Pt(f-&gt;r.min.x, q1));
			frselectpaint(f, Pt(pt2.x, pt2.y-(pt1.y-pt0.y)), pt2, f-&gt;cols[BACK]);
		}else
			frselectpaint(f, pt0, pt2, f-&gt;cols[BACK]);
	}
	_frclosebox(f, n0, n1-1);
	if(nn0&gt;0 &amp;&amp; f-&gt;box[nn0-1].nrune&gt;=0 &amp;&amp; ppt0.x-f-&gt;box[nn0-1].wid&gt;=(int)f-&gt;r.min.x){
		--nn0;
		ppt0.x -= f-&gt;box[nn0].wid;
	}
	_frclean(f, ppt0, nn0, n0&lt;f-&gt;nbox-1? n0+1 : n0);
	if(f-&gt;p1 &gt; p1)
		f-&gt;p1 -= p1-p0;
	else if(f-&gt;p1 &gt; p0)
		f-&gt;p1 = p0;
	if(f-&gt;p0 &gt; p1)
		f-&gt;p0 -= p1-p0;
	else if(f-&gt;p0 &gt; p0)
		f-&gt;p0 = p0;
	f-&gt;nchars -= p1-p0;
	if(f-&gt;p0 == f-&gt;p1)
		frtick(f, frptofchar(f, f-&gt;p0), 1);
	pt0 = frptofchar(f, f-&gt;nchars);
	n = f-&gt;nlines;
	f-&gt;nlines = (pt0.y-f-&gt;r.min.y)/f-&gt;font-&gt;height+(pt0.x&gt;f-&gt;r.min.x);
	return n - f-&gt;nlines;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

