<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libframe/frdraw.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libframe/frdraw.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;frame.h&gt;

void
_frdrawtext(Frame *f, Point pt, Image *text, Image *back)
{
	Frbox *b;
	int nb;
	static int x;

	for(nb=0,b=f-&gt;box; nb&lt;f-&gt;nbox; nb++, b++){
		_frcklinewrap(f, &amp;pt, b);
		if(b-&gt;nrune &gt;= 0){
			stringbg(f-&gt;b, pt, text, ZP, f-&gt;font, (char*)b-&gt;ptr, back, ZP);
		}
		pt.x += b-&gt;wid;
	}
}

static int
nbytes(char *s0, int nr)
{
	char *s;
	Rune r;

	s = s0;
	while(--nr &gt;= 0)
		s += chartorune(&amp;r, s);
	return s-s0;
}

void
frdrawsel(Frame *f, Point pt, ulong p0, ulong p1, int issel)
{
	Image *back, *text;

	if(f-&gt;ticked)
		frtick(f, frptofchar(f, f-&gt;p0), 0);

	if(p0 == p1){
		frtick(f, pt, issel);
		return;
	}

	if(issel){
		back = f-&gt;cols[HIGH];
		text = f-&gt;cols[HTEXT];
	}else{
		back = f-&gt;cols[BACK];
		text = f-&gt;cols[TEXT];
	}

	frdrawsel0(f, pt, p0, p1, back, text);
}

Point
frdrawsel0(Frame *f, Point pt, ulong p0, ulong p1, Image *back, Image *text)
{
	Frbox *b;
	int nb, nr, w, x, trim;
	Point qt;
	uint p;
	char *ptr;

	p = 0;
	b = f-&gt;box;
	trim = 0;
	for(nb=0; nb&lt;f-&gt;nbox &amp;&amp; p&lt;p1; nb++){
		nr = b-&gt;nrune;
		if(nr &lt; 0)
			nr = 1;
		if(p+nr &lt;= p0)
			goto Continue;
		if(p &gt;= p0){
			qt = pt;
			_frcklinewrap(f, &amp;pt, b);
			/* fill in the end of a wrapped line */
			if(pt.y &gt; qt.y)
				draw(f-&gt;b, Rect(qt.x, qt.y, f-&gt;r.max.x, pt.y), back, nil, qt);
		}
		ptr = (char*)b-&gt;ptr;
		if(p &lt; p0){	/* beginning of region: advance into box */
			ptr += nbytes(ptr, p0-p);
			nr -= (p0-p);
			p = p0;
		}
		trim = 0;
		if(p+nr &gt; p1){	/* end of region: trim box */
			nr -= (p+nr)-p1;
			trim = 1;
		}
		if(b-&gt;nrune&lt;0 || nr==b-&gt;nrune)
			w = b-&gt;wid;
		else
			w = stringnwidth(f-&gt;font, ptr, nr);
		x = pt.x+w;
		if(x &gt; f-&gt;r.max.x)
			x = f-&gt;r.max.x;
		draw(f-&gt;b, Rect(pt.x, pt.y, x, pt.y+f-&gt;font-&gt;height), back, nil, pt);
		if(b-&gt;nrune &gt;= 0)
			stringnbg(f-&gt;b, pt, text, ZP, f-&gt;font, ptr, nr, back, ZP);
		pt.x += w;
	    Continue:
		b++;
		p += nr;
	}
	/* if this is end of last plain text box on wrapped line, fill to end of line */
	if(p1&gt;p0 &amp;&amp;  b&gt;f-&gt;box &amp;&amp; b&lt;f-&gt;box+f-&gt;nbox &amp;&amp; b[-1].nrune&gt;0 &amp;&amp; !trim){
		qt = pt;
		_frcklinewrap(f, &amp;pt, b);
		if(pt.y &gt; qt.y)
			draw(f-&gt;b, Rect(qt.x, qt.y, f-&gt;r.max.x, pt.y), back, nil, qt);
	}
	return pt;
}

void
frredraw(Frame *f)
{
	int ticked;
	Point pt;

	if(f-&gt;p0 == f-&gt;p1){
		ticked = f-&gt;ticked;
		if(ticked)
			frtick(f, frptofchar(f, f-&gt;p0), 0);
		frdrawsel0(f, frptofchar(f, 0), 0, f-&gt;nchars, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
		if(ticked)
			frtick(f, frptofchar(f, f-&gt;p0), 1);
		return;
	}

	pt = frptofchar(f, 0);
	pt = frdrawsel0(f, pt, 0, f-&gt;p0, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
	pt = frdrawsel0(f, pt, f-&gt;p0, f-&gt;p1, f-&gt;cols[HIGH], f-&gt;cols[HTEXT]);
	pt = frdrawsel0(f, pt, f-&gt;p1, f-&gt;nchars, f-&gt;cols[BACK], f-&gt;cols[TEXT]);
}

void
frtick(Frame *f, Point pt, int ticked)
{
	Rectangle r;

	if(f-&gt;ticked==ticked || f-&gt;tick==0 || !ptinrect(pt, f-&gt;r))
		return;
	pt.x--;	/* looks best just left of where requested */
	r = Rect(pt.x, pt.y, pt.x+FRTICKW, pt.y+f-&gt;font-&gt;height);
	/* can go into left border but not right */
	if(r.max.x &gt; f-&gt;r.max.x)
		r.max.x = f-&gt;r.max.x;
	if(ticked){
		draw(f-&gt;tickback, f-&gt;tickback-&gt;r, f-&gt;b, nil, pt);
		draw(f-&gt;b, r, f-&gt;tick, nil, ZP);
	}else
		draw(f-&gt;b, r, f-&gt;tickback, nil, ZP);
	f-&gt;ticked = ticked;
}

Point
_frdraw(Frame *f, Point pt)
{
	Frbox *b;
	int nb, n;

	for(b=f-&gt;box,nb=0; nb&lt;f-&gt;nbox; nb++, b++){
		_frcklinewrap0(f, &amp;pt, b);
		if(pt.y == f-&gt;r.max.y){
			f-&gt;nchars -= _frstrlen(f, nb);
			_frdelbox(f, nb, f-&gt;nbox-1);
			break;
		}
		if(b-&gt;nrune &gt; 0){
			n = _frcanfit(f, pt, b);
			if(n == 0)
				drawerror(f-&gt;display, "_frcanfit==0");
			if(n != b-&gt;nrune){
				_frsplitbox(f, nb, n);
				b = &amp;f-&gt;box[nb];
			}
			pt.x += b-&gt;wid;
		}else{
			if(b-&gt;bc == '\n'){
				pt.x = f-&gt;r.min.x;
				pt.y+=f-&gt;font-&gt;height;
			}else
				pt.x += _frnewwid(f, pt, b);
		}
	}
	return pt;
}

int
_frstrlen(Frame *f, int nb)
{
	int n;

	for(n=0; nb&lt;f-&gt;nbox; nb++)
		n += NRUNE(&amp;f-&gt;box[nb]);
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

