<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libframe/frselect.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libframe/frselect.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;thread.h&gt;
#include &lt;mouse.h&gt;
#include &lt;frame.h&gt;

static
int
region(int a, int b)
{
	if(a &lt; b)
		return -1;
	if(a == b)
		return 0;
	return 1;
}

void
frselect(Frame *f, Mousectl *mc)	/* when called, button 1 is down */
{
	ulong p0, p1, q;
	Point mp, pt0, pt1, qt;
	int reg, b, scrled;

	mp = mc-&gt;xy;
	b = mc-&gt;buttons;

	f-&gt;modified = 0;
	frdrawsel(f, frptofchar(f, f-&gt;p0), f-&gt;p0, f-&gt;p1, 0);
	p0 = p1 = frcharofpt(f, mp);
	f-&gt;p0 = p0;
	f-&gt;p1 = p1;
	pt0 = frptofchar(f, p0);
	pt1 = frptofchar(f, p1);
	frdrawsel(f, pt0, p0, p1, 1);
	reg = 0;
	do{
		scrled = 0;
		if(f-&gt;scroll){
			if(mp.y &lt; f-&gt;r.min.y){
				(*f-&gt;scroll)(f, -(f-&gt;r.min.y-mp.y)/(int)f-&gt;font-&gt;height-1);
				p0 = f-&gt;p1;
				p1 = f-&gt;p0;
				scrled = 1;
			}else if(mp.y &gt; f-&gt;r.max.y){
				(*f-&gt;scroll)(f, (mp.y-f-&gt;r.max.y)/(int)f-&gt;font-&gt;height+1);
				p0 = f-&gt;p0;
				p1 = f-&gt;p1;
				scrled = 1;
			}
			if(scrled){
				if(reg != region(p1, p0))
					q = p0, p0 = p1, p1 = q;	/* undo the swap that will happen below */
				pt0 = frptofchar(f, p0);
				pt1 = frptofchar(f, p1);
				reg = region(p1, p0);
			}
		}
		q = frcharofpt(f, mp);
		if(p1 != q){
			if(reg != region(q, p0)){	/* crossed starting point; reset */
				if(reg &gt; 0)
					frdrawsel(f, pt0, p0, p1, 0);
				else if(reg &lt; 0)
					frdrawsel(f, pt1, p1, p0, 0);
				p1 = p0;
				pt1 = pt0;
				reg = region(q, p0);
				if(reg == 0)
					frdrawsel(f, pt0, p0, p1, 1);
			}
			qt = frptofchar(f, q);
			if(reg &gt; 0){
				if(q &gt; p1)
					frdrawsel(f, pt1, p1, q, 1);
				else if(q &lt; p1)
					frdrawsel(f, qt, q, p1, 0);
			}else if(reg &lt; 0){
				if(q &gt; p1)
					frdrawsel(f, pt1, p1, q, 0);
				else
					frdrawsel(f, qt, q, p1, 1);
			}
			p1 = q;
			pt1 = qt;
		}
		f-&gt;modified = 0;
		if(p0 &lt; p1) {
			f-&gt;p0 = p0;
			f-&gt;p1 = p1;
		}
		else {
			f-&gt;p0 = p1;
			f-&gt;p1 = p0;
		}
		if(scrled)
			(*f-&gt;scroll)(f, 0);
		flushimage(f-&gt;display, 1);
		if(!scrled)
			readmouse(mc);
		mp = mc-&gt;xy;
	}while(mc-&gt;buttons == b);
}

void
frselectpaint(Frame *f, Point p0, Point p1, Image *col)
{
	int n;
	Point q0, q1;

	q0 = p0;
	q1 = p1;
	q0.y += f-&gt;font-&gt;height;
	q1.y += f-&gt;font-&gt;height;
	n = (p1.y-p0.y)/f-&gt;font-&gt;height;
	if(f-&gt;b == nil)
		drawerror(f-&gt;display, "frselectpaint b==0");
	if(p0.y == f-&gt;r.max.y)
		return;
	if(n == 0)
		draw(f-&gt;b, Rpt(p0, q1), col, nil, ZP);
	else{
		if(p0.x &gt;= f-&gt;r.max.x)
			p0.x = f-&gt;r.max.x-1;
		draw(f-&gt;b, Rect(p0.x, p0.y, f-&gt;r.max.x, q0.y), col, nil, ZP);
		if(n &gt; 1)
			draw(f-&gt;b, Rect(f-&gt;r.min.x, q0.y, f-&gt;r.max.x, p1.y),
				col, nil, ZP);
		draw(f-&gt;b, Rect(f-&gt;r.min.x, p1.y, q1.x, q1.y),
			col, nil, ZP);
	}
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

