<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libhttpd/date.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libhttpd/date.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;httpd.h&gt;

/*
 * print dates in the format
 * Wkd, DD Mon YYYY HH:MM:SS GMT
 * parse dates of formats
 * Wkd, DD Mon YYYY HH:MM:SS GMT
 * Weekday, DD-Mon-YY HH:MM:SS GMT
 * Wkd Mon ( D|DD) HH:MM:SS YYYY
 * plus anything similar
 */
static char *
weekdayname[7] =
{
	"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
};
static char *
wdayname[7] =
{
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

static char *
monname[12] =
{
	"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

static	int	dateindex(char*, char**, int);

static int
dtolower(int c)
{
	if(c &gt;= 'A' &amp;&amp; c &lt;= 'Z')
		return c - 'A' + 'a';
	return c;
}

static int
disalpha(int c)
{
	return c &gt;= 'A' &amp;&amp; c &lt;= 'Z' || c &gt;= 'a' &amp;&amp; c &lt;= 'z';
}

static int
disdig(int c)
{
	return c &gt;= '0' &amp;&amp; c &lt;= '9';
}

int
hdatefmt(Fmt *f)
{
	Tm *tm;
	ulong t;

	t = va_arg(f-&gt;args, ulong);
	tm = gmtime(t);
	return fmtprint(f, "%s, %.2d %s %.4d %.2d:%.2d:%.2d GMT",
		wdayname[tm-&gt;wday], tm-&gt;mday, monname[tm-&gt;mon], tm-&gt;year+1900,
		tm-&gt;hour, tm-&gt;min, tm-&gt;sec);
}

static char*
dateword(char *date, char *buf)
{
	char *p;
	int c;

	p = buf;
	while(!disalpha(c = *date) &amp;&amp; !disdig(c) &amp;&amp; c)
		date++;
	while(disalpha(c = *date)){
		if(p - buf &lt; 30)
			*p++ = dtolower(c);
		date++;
	}
	*p = 0;
	return date;
}

static int
datenum(char **d)
{
	char *date;
	int c, n;

	date = *d;
	while(!disdig(c = *date) &amp;&amp; c)
		date++;
	if(c == 0){
		*d = date;
		return -1;
	}
	n = 0;
	while(disdig(c = *date)){
		n = n * 10 + c - '0';
		date++;
	}
	*d = date;
	return n;
}

/*
 * parse a date and return the seconds since the epoch
 * return 0 for a failure
 */
ulong
hdate2sec(char *date)
{
	Tm tm;
	char buf[32];

	/*
	 * Weekday|Wday
	 */
	date = dateword(date, buf);
	tm.wday = dateindex(buf, wdayname, 7);
	if(tm.wday &lt; 0)
		tm.wday = dateindex(buf, weekdayname, 7);
	if(tm.wday &lt; 0)
		return 0;

	/*
	 * check for the two major formats
	 */
	date = dateword(date, buf);
	tm.mon = dateindex(buf, monname, 12);
	if(tm.mon &gt;= 0){
		/*
		 * MM
		 */
		tm.mday = datenum(&amp;date);
		if(tm.mday &lt; 1 || tm.mday &gt; 31)
			return 0;

		/*
		 * HH:MM:SS
		 */
		tm.hour = datenum(&amp;date);
		if(tm.hour &lt; 0 || tm.hour &gt;= 24)
			return 0;
		tm.min = datenum(&amp;date);
		if(tm.min &lt; 0 || tm.min &gt;= 60)
			return 0;
		tm.sec = datenum(&amp;date);
		if(tm.sec &lt; 0 || tm.sec &gt;= 60)
			return 0;

		/*
		 * YYYY
		 */
		tm.year = datenum(&amp;date);
		if(tm.year &lt; 70 || tm.year &gt; 99 &amp;&amp; tm.year &lt; 1970)
			return 0;
		if(tm.year &gt;= 1970)
			tm.year -= 1900;
	}else{
		/*
		 * MM-Mon-(YY|YYYY)
		 */
		tm.mday = datenum(&amp;date);
		if(tm.mday &lt; 1 || tm.mday &gt; 31)
			return 0;
		date = dateword(date, buf);
		tm.mon = dateindex(buf, monname, 12);
		if(tm.mon &lt; 0 || tm.mon &gt;= 12)
			return 0;
		tm.year = datenum(&amp;date);
		if(tm.year &lt; 70 || tm.year &gt; 99 &amp;&amp; tm.year &lt; 1970)
			return 0;
		if(tm.year &gt;= 1970)
			tm.year -= 1900;

		/*
		 * HH:MM:SS
		 */
		tm.hour = datenum(&amp;date);
		if(tm.hour &lt; 0 || tm.hour &gt;= 24)
			return 0;
		tm.min = datenum(&amp;date);
		if(tm.min &lt; 0 || tm.min &gt;= 60)
			return 0;
		tm.sec = datenum(&amp;date);
		if(tm.sec &lt; 0 || tm.sec &gt;= 60)
			return 0;

		/*
		 * timezone
		 */
		dateword(date, buf);
		if(strncmp(buf, "gmt", 3) != 0)
			return 0;
	}

	strcpy(tm.zone, "GMT");
	tm.tzoff = 0;
	tm.yday = 0;
	return tm2sec(&amp;tm);
}

static int
dateindex(char *d, char **tab, int n)
{
	int i;

	for(i = 0; i &lt; n; i++)
		if(cistrcmp(d, tab[i]) == 0)
			return i;
	return -1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

