<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libhttpd/fail.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libhttpd/fail.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bin.h&gt;
#include &lt;httpd.h&gt;

typedef struct Error	Error;

struct Error
{
	char	*num;
	char	*concise;
	char	*verbose;
};

Error errormsg[] =
{
	[HInternal]	{"500 Internal Error", "Internal Error",
		"This server could not process your request due to an internal error."},
	[HTempFail]	{"500 Internal Error", "Temporary Failure",
		"The object %s is currently inaccessible.&lt;p&gt;Please try again later."},
	[HUnimp]	{"501 Not implemented", "Command not implemented",
		"This server does not implement the %s command."},
	[HUnkVers]	{"501 Not Implemented", "Unknown http version",
		"This server does not know how to respond to http version %s."},
	[HBadCont]	{"501 Not Implemented", "Impossible format",
		"This server cannot produce %s in any of the formats your client accepts."},
	[HBadReq]	{"400 Bad Request", "Strange Request",
		"Your client sent a query that this server could not understand."},
	[HSyntax]	{"400 Bad Request", "Garbled Syntax",
		"Your client sent a query with incoherent syntax."},
	[HBadSearch]	{"400 Bad Request", "Inapplicable Search",
		"Your client sent a search that cannot be applied to %s."},
	[HNotFound]	{"404 Not Found", "Object not found",
		"The object %s does not exist on this server."},
	[HNoSearch]	{"403 Forbidden", "Search not supported",
		"The object %s does not support the search command."},
	[HNoData]	{"403 Forbidden", "No data supplied",
		"Search or forms data must be supplied to %s."},
	[HExpectFail]	{"403 Expectation Failed", "Expectation Failed",
		"This server does not support some of your request's expectations."},
	[HUnauth]	{"403 Forbidden", "Forbidden",
		"You are not allowed to see the object %s."},
	[HOK]		{"200 OK", "everything is fine"},
};

/*
 * write a failure message to the net and exit
 */
int
hfail(HConnect *c, int reason, ...)
{
	Hio *hout;
	char makeup[HBufSize], err[ERRMAX];
	va_list arg;
	int n;

	rerrstr(err, sizeof err);
	hout = &amp;c-&gt;hout;
	va_start(arg, reason);
	vseprint(makeup, makeup+HBufSize, errormsg[reason].verbose, arg);
	va_end(arg);
	/*
	 * this additional information has proved useful when debugging
	 * complex http configuration problems.
	 */
	n = snprint(c-&gt;xferbuf, HBufSize, "&lt;head&gt;&lt;title&gt;%s&lt;/title&gt;&lt;/head&gt;\n"
		"&lt;body&gt;&lt;h1&gt;%s&lt;/h1&gt;\n%s&lt;p&gt;\n"
		"errstr: %s&lt;br&gt;\n"
		"uri host: %s&lt;br&gt;\n"
		"header host: %s&lt;br&gt;\nactual host: %s\n&lt;/body&gt;\n",
		errormsg[reason].concise, errormsg[reason].concise, makeup,
		err,
		(c-&gt;req.urihost? c-&gt;req.urihost: ""),
		c-&gt;head.host, hmydomain);

	hprint(hout, "%s %s\r\n", hversion, errormsg[reason].num);
	hprint(hout, "Date: %D\r\n", time(nil));
	hprint(hout, "Server: Plan9\r\n");
	hprint(hout, "Content-Type: text/html\r\n");
	hprint(hout, "Content-Length: %d\r\n", n);
	if(c-&gt;head.closeit)
		hprint(hout, "Connection: close\r\n");
	else if(!http11(c))
		hprint(hout, "Connection: Keep-Alive\r\n");
	hprint(hout, "\r\n");

	if(c-&gt;req.meth == nil || strcmp(c-&gt;req.meth, "HEAD") != 0)
		hwrite(hout, c-&gt;xferbuf, n);

	if(c-&gt;replog)
		c-&gt;replog(c, "Reply: %s\nReason: %s\n", errormsg[reason].num, errormsg[reason].concise);
	return hflush(hout);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

