<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libhttpd/hio.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libhttpd/hio.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;httpd.h&gt;

static	char	hstates[] = "nrewE";
static	char	hxfers[] = " x";
static int _hflush(Hio*, int, int);

int
hinit(Hio *h, int fd, int mode)
{
	if(fd == -1 || mode != Hread &amp;&amp; mode != Hwrite)
		return -1;
	h-&gt;hh = nil;
	h-&gt;fd = fd;
	h-&gt;seek = 0;
	h-&gt;state = mode;
	h-&gt;start = h-&gt;buf + 16;		/* leave space for chunk length */
	h-&gt;stop = h-&gt;pos = h-&gt;start;
	if(mode == Hread){
		h-&gt;bodylen = ~0UL;
		*h-&gt;pos = '\0';
	}else
		h-&gt;stop = h-&gt;start + Hsize;
	return 0;
}

int
hiserror(Hio *h)
{
	return h-&gt;state == Herr;
}

int
hgetc(Hio *h)
{
	uchar *p;

	p = h-&gt;pos;
	if(p &lt; h-&gt;stop){
		h-&gt;pos = p + 1;
		return *p;
	}
	p -= UTFmax;
	if(p &lt; h-&gt;start)
		p = h-&gt;start;
	if(!hreadbuf(h, p) || h-&gt;pos == h-&gt;stop)
		return -1;
	return *h-&gt;pos++;
}

int
hungetc(Hio *h)
{
	if(h-&gt;state == Hend)
		h-&gt;state = Hread;
	else if(h-&gt;state == Hread)
		h-&gt;pos--;
	if(h-&gt;pos &lt; h-&gt;start || h-&gt;state != Hread){
		h-&gt;state = Herr;
		h-&gt;pos = h-&gt;stop;
		return -1;
	}
	return 0;
}

/*
 * fill the buffer, saving contents from vsave onwards.
 * nothing is saved if vsave is nil.
 * returns the beginning of the buffer.
 *
 * understands message body sizes and chunked transfer encoding
 */
void *
hreadbuf(Hio *h, void *vsave)
{
	Hio *hh;
	uchar *save;
	int c, in, cpy, dpos;

	save = vsave;
	if(save &amp;&amp; (save &lt; h-&gt;start || save &gt; h-&gt;stop)
	|| h-&gt;state != Hread &amp;&amp; h-&gt;state != Hend){
		h-&gt;state = Herr;
		h-&gt;pos = h-&gt;stop;
		return nil;
	}

	dpos = 0;
	if(save &amp;&amp; h-&gt;pos &gt; save)
		dpos = h-&gt;pos - save;
	cpy = 0;
	if(save){
		cpy = h-&gt;stop - save;
		memmove(h-&gt;start, save, cpy);
	}
	h-&gt;seek += h-&gt;stop - h-&gt;start - cpy;
	h-&gt;pos = h-&gt;start + dpos;

	in = Hsize - cpy;
	if(h-&gt;state == Hend)
		in = 0;
	else if(in &gt; h-&gt;bodylen)
		in = h-&gt;bodylen;

	/*
	 * for chunked encoding, fill buffer,
	 * then read in new chunk length and wipe out that line
	 */
	hh = h-&gt;hh;
	if(hh != nil){
		if(!in &amp;&amp; h-&gt;xferenc &amp;&amp; h-&gt;state != Hend){
			if(h-&gt;xferenc == 2){
				c = hgetc(hh);
				if(c == '\r')
					c = hgetc(hh);
				if(c != '\n'){
					h-&gt;pos = h-&gt;stop;
					h-&gt;state = Herr;
					return nil;
				}
			}
			h-&gt;xferenc = 2;
			in = 0;
			while((c = hgetc(hh)) != '\n'){
				if(c &gt;= '0' &amp;&amp; c &lt;= '9')
					c -= '0';
				else if(c &gt;= 'a' &amp;&amp; c &lt;= 'f')
					c -= 'a' - 10;
				else if(c &gt;= 'A' &amp;&amp; c &lt;= 'F')
					c -= 'A' - 10;
				else
					break;
				in = in * 16 + c;
			}
			while(c != '\n'){
				if(c &lt; 0){
					h-&gt;pos = h-&gt;stop;
					h-&gt;state = Herr;
					return nil;
				}
				c = hgetc(hh);
			}
			h-&gt;bodylen = in;

			in = Hsize - cpy;
			if(in &gt; h-&gt;bodylen)
				in = h-&gt;bodylen;
		}
		if(in){
			while(hh-&gt;pos + in &gt; hh-&gt;stop){
				if(hreadbuf(hh, hh-&gt;pos) == nil){
					h-&gt;pos = h-&gt;stop;
					h-&gt;state = Herr;
					return nil;
				}
			}
			memmove(h-&gt;start + cpy, hh-&gt;pos, in);
			hh-&gt;pos += in;
		}
	}else if(in){
		if((in = read(h-&gt;fd, h-&gt;start + cpy, in)) &lt; 0){
			h-&gt;state = Herr;
			h-&gt;pos = h-&gt;stop;
			return nil;
		}
	}
	if(in == 0)
		h-&gt;state = Hend;

	h-&gt;bodylen -= in;

	h-&gt;stop = h-&gt;start + cpy + in;
	*h-&gt;stop = '\0';
	if(h-&gt;pos == h-&gt;stop)
		return nil;
	return h-&gt;start;
}

int
hbuflen(Hio *h, void *p)
{
	return h-&gt;stop - (uchar*)p;
}

/*
 * prepare to receive a message body
 * len is the content length (~0 =&gt; unspecified)
 * te is the transfer encoding
 * returns &lt; 0 if setup failed
 */
Hio*
hbodypush(Hio *hh, ulong len, HFields *te)
{
	Hio *h;
	int xe;

	if(hh-&gt;state != Hread)
		return nil;
	xe = 0;
	if(te != nil){
		if(te-&gt;params != nil || te-&gt;next != nil)
			return nil;
		if(cistrcmp(te-&gt;s, "chunked") == 0){
			xe = 1;
			len = 0;
		}else if(cistrcmp(te-&gt;s, "identity") == 0){
			;
		}else
			return nil;
	}

	h = malloc(sizeof *h);
	if(h == nil)
		return nil;

	h-&gt;hh = hh;
	h-&gt;fd = -1;
	h-&gt;seek = 0;
	h-&gt;state = Hread;
	h-&gt;xferenc = xe;
	h-&gt;start = h-&gt;buf + 16;		/* leave space for chunk length */
	h-&gt;stop = h-&gt;pos = h-&gt;start;
	*h-&gt;pos = '\0';
	h-&gt;bodylen = len;
	return h;
}

/*
 * dump the state of the io buffer into a string
 */
char *
hunload(Hio *h)
{
	uchar *p, *t, *stop, *buf;
	int ne, n, c;

	stop = h-&gt;stop;
	ne = 0;
	for(p = h-&gt;pos; p &lt; stop; p++){
		c = *p;
		if(c == 0x80)
			ne++;
	}
	p = h-&gt;pos;

	n = (stop - p) + ne + 3;
	buf = mallocz(n, 1);
	if(buf == nil)
		return nil;
	buf[0] = hstates[h-&gt;state];
	buf[1] = hxfers[h-&gt;xferenc];

	t = &amp;buf[2];
	for(; p &lt; stop; p++){
		c = *p;
		if(c == 0 || c == 0x80){
			*t++ = 0x80;
			if(c == 0x80)
				*t++ = 0x80;
		}else
			*t++ = c;
	}
	*t++ = '\0';
	if(t != buf + n)
		return nil;
	return (char*)buf;
}

/*
 * read the io buffer state from a string
 */
int
hload(Hio *h, char *buf)
{
	uchar *p, *t, *stop;
	char *s;
	int c;

	s = strchr(hstates, buf[0]);
	if(s == nil)
		return -1;
	h-&gt;state = s - hstates;

	s = strchr(hxfers, buf[1]);
	if(s == nil)
		return -1;
	h-&gt;xferenc = s - hxfers;

	t = h-&gt;start;
	stop = t + Hsize;
	for(p = (uchar*)&amp;buf[2]; c = *p; p++){
		if(c == 0x80){
			if(p[1] != 0x80)
				c = 0;
			else
				p++;
		}
		*t++ = c;
		if(t &gt;= stop)
			return -1;
	}
	*t = '\0';
	h-&gt;pos = h-&gt;start;
	h-&gt;stop = t;
	h-&gt;seek = 0;
	return 0;
}

void
hclose(Hio *h)
{
	if(h-&gt;fd &gt;= 0){
		if(h-&gt;state == Hwrite)
			hxferenc(h, 0);
		close(h-&gt;fd);
	}
	h-&gt;stop = h-&gt;pos = nil;
	h-&gt;fd = -1;
}

/*
 * flush the buffer and possibly change encoding modes
 */
int
hxferenc(Hio *h, int on)
{
	if(h-&gt;xferenc &amp;&amp; !on &amp;&amp; h-&gt;pos != h-&gt;start)
		hflush(h);
	if(_hflush(h, 1, 0) &lt; 0)
		return -1;
	h-&gt;xferenc = !!on;
	return 0;
}

int
hputc(Hio *h, int c)
{
	uchar *p;

	p = h-&gt;pos;
	if(p &lt; h-&gt;stop){
		h-&gt;pos = p + 1;
		return *p = c;
	}
	if(hflush(h) &lt; 0)
		return -1;
	return *h-&gt;pos++ = c;
}

static int
fmthflush(Fmt *f)
{
	Hio *h;

	h = f-&gt;farg;
	h-&gt;pos = f-&gt;to;
	if(hflush(h) &lt; 0)
		return 0;
	f-&gt;stop = h-&gt;stop;
	f-&gt;to = h-&gt;pos;
	f-&gt;start = h-&gt;pos;
	return 1;
}

int
hvprint(Hio *h, char *fmt, va_list args)
{
	int n;
	Fmt f;

	f.runes = 0;
	f.stop = h-&gt;stop;
	f.to = h-&gt;pos;
	f.start = h-&gt;pos;
	f.flush = fmthflush;
	f.farg = h;
	f.nfmt = 0;
//	fmtlocaleinit(&amp;f, nil, nil, nil);
	n = fmtvprint(&amp;f, fmt, args);
	h-&gt;pos = f.to;
	return n;
}

int
hprint(Hio *h, char *fmt, ...)
{
	int n;
	va_list arg;

	va_start(arg, fmt);
	n = hvprint(h, fmt, arg);
	va_end(arg);
	return n;
}

static int
_hflush(Hio *h, int force, int dolength)
{
	uchar *s;
	int w;

	if(h == nil)
		return -1;
	if(h-&gt;state != Hwrite){
		h-&gt;state = Herr;
		h-&gt;stop = h-&gt;pos;
		return -1;
	}
	s = h-&gt;start;
	w = h-&gt;pos - s;
	if(w == 0 &amp;&amp; !force)
		return 0;
	if(h-&gt;xferenc){
		*--s = '\n';
		*--s = '\r';
		do{
			*--s = "0123456789abcdef"[w &amp; 0xf];
			w &gt;&gt;= 4;
		}while(w);
		h-&gt;pos[0] = '\r';
		h-&gt;pos[1] = '\n';
		w = &amp;h-&gt;pos[2] - s;
	}
	if(dolength)
		fprint(h-&gt;fd, "Content-Length: %d\r\n\r\n", w);
	if(write(h-&gt;fd, s, w) != w){
		h-&gt;state = Herr;
		h-&gt;stop = h-&gt;pos;
		return -1;
	}
	h-&gt;seek += w;
	h-&gt;pos = h-&gt;start;
	return 0;
}

int
hflush(Hio *h)
{
	return _hflush(h, 0, 0);
}

int
hlflush(Hio* h)
{
	return _hflush(h, 0, 1);
}

int
hwrite(Hio *h, void *vbuf, int len)
{
	uchar *buf;
	int n, m;

	buf = vbuf;
	n = len;
	if(n &lt; 0 || h-&gt;state != Hwrite){
		h-&gt;state = Herr;
		h-&gt;stop = h-&gt;pos;
		return -1;
	}
	if(h-&gt;pos + n &gt;= h-&gt;stop){
		if(h-&gt;start != h-&gt;pos)
			if(hflush(h) &lt; 0)
				return -1;
		while(h-&gt;pos + n &gt;= h-&gt;stop){
			m = h-&gt;stop - h-&gt;pos;
			if(h-&gt;xferenc){
				memmove(h-&gt;pos, buf, m);
				h-&gt;pos += m;
				if(hflush(h) &lt; 0)
					return -1;
			}else{
				if(write(h-&gt;fd, buf, m) != m){
					h-&gt;state = Herr;
					h-&gt;stop = h-&gt;pos;
					return -1;
				}
				h-&gt;seek += m;
			}
			n -= m;
			buf += m;
		}
	}
	memmove(h-&gt;pos, buf, n);
	h-&gt;pos += n;
	return len;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

