<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libhttpd/parse.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libhttpd/parse.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;ctype.h&gt;
#include &lt;libsec.h&gt;
#include &lt;bin.h&gt;
#include &lt;httpd.h&gt;
#include "escape.h"

typedef struct Hlex	Hlex;
typedef struct MimeHead	MimeHead;

enum
{
	/*
	 * tokens
	 */
	Word	= 1,
	QString,
};

#define UlongMax	4294967295UL

struct Hlex
{
	int	tok;
	int	eoh;
	int	eol;			/* end of header line encountered? */
	uchar	*hstart;		/* start of header */
	jmp_buf	jmp;			/* jmp here to parse header */
	char	wordval[HMaxWord];
	HConnect *c;
};

struct MimeHead
{
	char	*name;
	void	(*parse)(Hlex*, char*);
	uchar	seen;
	uchar	ignore;
};

static void	mimeaccept(Hlex*, char*);
static void	mimeacceptchar(Hlex*, char*);
static void	mimeacceptenc(Hlex*, char*);
static void	mimeacceptlang(Hlex*, char*);
static void	mimeagent(Hlex*, char*);
static void	mimeauthorization(Hlex*, char*);
static void	mimeconnection(Hlex*, char*);
static void	mimecontlen(Hlex*, char*);
static void	mimecookie(Hlex*, char*);
static void	mimeexpect(Hlex*, char*);
static void	mimefresh(Hlex*, char*);
static void	mimefrom(Hlex*, char*);
static void	mimehost(Hlex*, char*);
static void	mimeifrange(Hlex*, char*);
static void	mimeignore(Hlex*, char*);
static void	mimematch(Hlex*, char*);
static void	mimemodified(Hlex*, char*);
static void	mimenomatch(Hlex*, char*);
static void	mimerange(Hlex*, char*);
static void	mimetransenc(Hlex*, char*);
static void	mimeunmodified(Hlex*, char*);

/*
 * headers seen also include
 * allow  cache-control chargeto
 * content-encoding content-language content-location content-md5 content-range content-type
 * date etag expires forwarded last-modified max-forwards pragma
 * proxy-agent proxy-authorization proxy-connection
 * ua-color ua-cpu ua-os ua-pixels
 * upgrade via x-afs-tokens x-serial-number
 */
static MimeHead	mimehead[] =
{
	{"accept",		mimeaccept},
	{"accept-charset",	mimeacceptchar},
	{"accept-encoding",	mimeacceptenc},
	{"accept-language",	mimeacceptlang},
	{"authorization",	mimeauthorization},
	{"connection",		mimeconnection},
	{"content-length",	mimecontlen},
	{"cookie",		mimecookie},
	{"expect",		mimeexpect},
	{"fresh",		mimefresh},
	{"from",		mimefrom},
	{"host",		mimehost},
	{"if-match",		mimematch},
	{"if-modified-since",	mimemodified},
	{"if-none-match",	mimenomatch},
	{"if-range",		mimeifrange},
	{"if-unmodified-since",	mimeunmodified},
	{"range",		mimerange},
	{"transfer-encoding",	mimetransenc},
	{"user-agent",		mimeagent},
};

char*		hmydomain;
char*		hversion = "HTTP/1.1";

static	void	lexhead(Hlex*);
static	void	parsejump(Hlex*, char*);
static	int	getc(Hlex*);
static	void	ungetc(Hlex*);
static	int	wordcr(Hlex*);
static	int	wordnl(Hlex*);
static	void	word(Hlex*, char*);
static	int	lex1(Hlex*, int);
static	int	lex(Hlex*);
static	int	lexbase64(Hlex*);
static	ulong	digtoul(char *s, char **e);

/*
 * flush and clean up junk from a request
 */
void
hreqcleanup(HConnect *c)
{
	int i;

	hxferenc(&amp;c-&gt;hout, 0);
	memset(&amp;c-&gt;req, 0, sizeof(c-&gt;req));
	memset(&amp;c-&gt;head, 0, sizeof(c-&gt;head));
	c-&gt;hpos = c-&gt;header;
	c-&gt;hstop = c-&gt;header;
	binfree(&amp;c-&gt;bin);
	for(i = 0; i &lt; nelem(mimehead); i++){
		mimehead[i].seen = 0;
		mimehead[i].ignore = 0;
	}
}

/*
 * list of tokens
 * if the client is HTTP/1.0,
 * ignore headers which match one of the tokens.
 * restarts parsing if necessary.
 */
static void
mimeconnection(Hlex *h, char *)
{
	char *u, *p;
	int reparse, i;

	reparse = 0;
	for(;;){
		while(lex(h) != Word)
			if(h-&gt;tok != ',')
				goto breakout;

		if(cistrcmp(h-&gt;wordval, "keep-alive") == 0)
			h-&gt;c-&gt;head.persist = 1;
		else if(cistrcmp(h-&gt;wordval, "close") == 0)
			h-&gt;c-&gt;head.closeit = 1;
		else if(!http11(h-&gt;c)){
			for(i = 0; i &lt; nelem(mimehead); i++){
				if(cistrcmp(mimehead[i].name, h-&gt;wordval) == 0){
					reparse = mimehead[i].seen &amp;&amp; !mimehead[i].ignore;
					mimehead[i].ignore = 1;
					if(cistrcmp(mimehead[i].name, "authorization") == 0){
						h-&gt;c-&gt;head.authuser = nil;
						h-&gt;c-&gt;head.authpass = nil;
					}
				}
			}
		}

		if(lex(h) != ',')
			break;
	}

breakout:;
	/*
	 * if need to ignore headers we've already parsed,
	 * reset &amp; start over.  need to save authorization
	 * info because it's written over when parsed.
	 */
	if(reparse){
		u = h-&gt;c-&gt;head.authuser;
		p = h-&gt;c-&gt;head.authpass;
		memset(&amp;h-&gt;c-&gt;head, 0, sizeof(h-&gt;c-&gt;head));
		h-&gt;c-&gt;head.authuser = u;
		h-&gt;c-&gt;head.authpass = p;

		h-&gt;c-&gt;hpos = h-&gt;hstart;
		longjmp(h-&gt;jmp, 1);
	}
}

int
hparseheaders(HConnect *c, int timeout)
{
	Hlex h;

	c-&gt;head.fresh_thresh = 0;
	c-&gt;head.fresh_have = 0;
	c-&gt;head.persist = 0;
	if(c-&gt;req.vermaj == 0){
		c-&gt;head.host = hmydomain;
		return 1;
	}

	memset(&amp;h, 0, sizeof(h));
	h.c = c;
	if(timeout)
		alarm(timeout);
	if(hgethead(c, 1) &lt; 0)
		return -1;
	if(timeout)
		alarm(0);
	h.hstart = c-&gt;hpos;

	if(setjmp(h.jmp) == -1)
		return -1;

	h.eol = 0;
	h.eoh = 0;
	h.tok = '\n';
	while(lex(&amp;h) != '\n'){
		if(h.tok == Word &amp;&amp; lex(&amp;h) == ':')
			parsejump(&amp;h, hstrdup(c, h.wordval));
		while(h.tok != '\n')
			lex(&amp;h);
		h.eol = h.eoh;
	}

	if(http11(c)){
		/*
		 * according to the http/1.1 spec,
		 * these rules must be followed
		 */
		if(c-&gt;head.host == nil){
			hfail(c, HBadReq, nil);
			return -1;
		}
		if(c-&gt;req.urihost != nil)
			c-&gt;head.host = c-&gt;req.urihost;
		/*
		 * also need to check host is actually this one
		 */
	}else if(c-&gt;head.host == nil)
		c-&gt;head.host = hmydomain;
	return 1;
}

/*
 * mimeparams	: | mimeparams ";" mimepara
 * mimeparam	: token "=" token | token "=" qstring
 */
static HSPairs*
mimeparams(Hlex *h)
{
	HSPairs *p;
	char *s;

	p = nil;
	for(;;){
		if(lex(h) != Word)
			break;
		s = hstrdup(h-&gt;c, h-&gt;wordval);
		if(lex(h) != Word &amp;&amp; h-&gt;tok != QString)
			break;
		p = hmkspairs(h-&gt;c, s, hstrdup(h-&gt;c, h-&gt;wordval), p);
	}
	return hrevspairs(p);
}

/*
 * mimehfields	: mimehfield | mimehfields commas mimehfield
 * mimehfield	: token mimeparams
 * commas	: "," | commas ","
 */
static HFields*
mimehfields(Hlex *h)
{
	HFields *f;

	f = nil;
	for(;;){
		while(lex(h) != Word)
			if(h-&gt;tok != ',')
				goto breakout;

		f = hmkhfields(h-&gt;c, hstrdup(h-&gt;c, h-&gt;wordval), nil, f);

		if(lex(h) == ';')
			f-&gt;params = mimeparams(h);
		if(h-&gt;tok != ',')
			break;
	}
breakout:;
	return hrevhfields(f);
}

/*
 * parse a list of acceptable types, encodings, languages, etc.
 */
static HContent*
mimeok(Hlex *h, char *name, int multipart, HContent *head)
{
	char *generic, *specific, *s;
	float v;

	/*
	 * each type is separated by one or more commas
	 */
	while(lex(h) != Word)
		if(h-&gt;tok != ',')
			return head;

	generic = hstrdup(h-&gt;c, h-&gt;wordval);
	lex(h);
	if(h-&gt;tok == '/' || multipart){
		/*
		 * at one time, IE5 improperly said '*' for single types
		 */
		if(h-&gt;tok != '/')
			return nil;
		if(lex(h) != Word)
			return head;
		specific = hstrdup(h-&gt;c, h-&gt;wordval);
		if(!multipart &amp;&amp; strcmp(specific, "*") != 0)
			return head;
		lex(h);
	}else
		specific = nil;
	head = hmkcontent(h-&gt;c, generic, specific, head);

	for(;;){
		switch(h-&gt;tok){
		case ';':
			/*
			 * should make a list of these params
			 * for accept, they fall into two classes:
			 *	up to a q=..., they modify the media type.
			 *	afterwards, they acceptance criteria
			 */
			if(lex(h) == Word){
				s = hstrdup(h-&gt;c, h-&gt;wordval);
				if(lex(h) != '=' || lex(h) != Word &amp;&amp; h-&gt;tok != QString)
					return head;
				v = strtod(h-&gt;wordval, nil);
				if(strcmp(s, "q") == 0)
					head-&gt;q = v;
				else if(strcmp(s, "mxb") == 0)
					head-&gt;mxb = v;
				else{
					/* cope with accept: application/xhtml+xml; profile=http://www.wapforum.org/xhtml, */
					while(lex(h) == Word || (h-&gt;tok != ',' &amp;&amp; h-&gt;eol == 0) )
						;
					return mimeok(h, name, multipart, head);
				}
			}
			break;
		case ',':
			return  mimeok(h, name, multipart, head);
		default:
			return head;
		}
		lex(h);
	}
}

/*
 * parse a list of entity tags
 * 1#entity-tag
 * entity-tag = [weak] opaque-tag
 * weak = "W/"
 * opaque-tag = quoted-string
 */
static HETag*
mimeetag(Hlex *h, HETag *head)
{
	HETag *e;
	int weak;

	for(;;){
		while(lex(h) != Word &amp;&amp; h-&gt;tok != QString)
			if(h-&gt;tok != ',')
				return head;

		weak = 0;
		if(h-&gt;tok == Word &amp;&amp; strcmp(h-&gt;wordval, "*") != 0){
			if(strcmp(h-&gt;wordval, "W") != 0)
				return head;
			if(lex(h) != '/' || lex(h) != QString)
				return head;
			weak = 1;
		}

		e = halloc(h-&gt;c, sizeof(HETag));
		e-&gt;etag = hstrdup(h-&gt;c, h-&gt;wordval);
		e-&gt;weak = weak;
		e-&gt;next = head;
		head = e;

		if(lex(h) != ',')
			return head;
	}
}

/*
 * ranges-specifier = byte-ranges-specifier
 * byte-ranges-specifier = "bytes" "=" byte-range-set
 * byte-range-set = 1#(byte-range-spec|suffix-byte-range-spec)
 * byte-range-spec = byte-pos "-" [byte-pos]
 * byte-pos = 1*DIGIT
 * suffix-byte-range-spec = "-" suffix-length
 * suffix-length = 1*DIGIT
 *
 * syntactically invalid range specifiers cause the
 * entire header field to be ignored.
 * it is syntactically incorrect for the second byte pos
 * to be smaller than the first byte pos
 */
static HRange*
mimeranges(Hlex *h, HRange *head)
{
	HRange *r, *rh, *tail;
	char *w;
	ulong start, stop;
	int suf;

	if(lex(h) != Word || strcmp(h-&gt;wordval, "bytes") != 0 || lex(h) != '=')
		return head;

	rh = nil;
	tail = nil;
	for(;;){
		while(lex(h) != Word){
			if(h-&gt;tok != ','){
				if(h-&gt;tok == '\n')
					goto breakout;
				return head;
			}
		}

		w = h-&gt;wordval;
		start = 0;
		suf = 1;
		if(w[0] != '-'){
			suf = 0;
			start = digtoul(w, &amp;w);
			if(w[0] != '-')
				return head;
		}
		w++;
		stop = ~0UL;
		if(w[0] != '\0'){
			stop = digtoul(w, &amp;w);
			if(w[0] != '\0')
				return head;
			if(!suf &amp;&amp; stop &lt; start)
				return head;
		}

		r = halloc(h-&gt;c, sizeof(HRange));
		r-&gt;suffix = suf;
		r-&gt;start = start;
		r-&gt;stop = stop;
		r-&gt;next = nil;
		if(rh == nil)
			rh = r;
		else
			tail-&gt;next = r;
		tail = r;

		if(lex(h) != ','){
			if(h-&gt;tok == '\n')
				break;
			return head;
		}
	}
breakout:;

	if(head == nil)
		return rh;

	for(tail = head; tail-&gt;next != nil; tail = tail-&gt;next)
		;
	tail-&gt;next = rh;
	return head;
}

static void
mimeaccept(Hlex *h, char *name)
{
	h-&gt;c-&gt;head.oktype = mimeok(h, name, 1, h-&gt;c-&gt;head.oktype);
}

static void
mimeacceptchar(Hlex *h, char *name)
{
	h-&gt;c-&gt;head.okchar = mimeok(h, name, 0, h-&gt;c-&gt;head.okchar);
}

static void
mimeacceptenc(Hlex *h, char *name)
{
	h-&gt;c-&gt;head.okencode = mimeok(h, name, 0, h-&gt;c-&gt;head.okencode);
}

static void
mimeacceptlang(Hlex *h, char *name)
{
	h-&gt;c-&gt;head.oklang = mimeok(h, name, 0, h-&gt;c-&gt;head.oklang);
}

static void
mimemodified(Hlex *h, char *)
{
	lexhead(h);
	h-&gt;c-&gt;head.ifmodsince = hdate2sec(h-&gt;wordval);
}

static void
mimeunmodified(Hlex *h, char *)
{
	lexhead(h);
	h-&gt;c-&gt;head.ifunmodsince = hdate2sec(h-&gt;wordval);
}

static void
mimematch(Hlex *h, char *)
{
	h-&gt;c-&gt;head.ifmatch = mimeetag(h, h-&gt;c-&gt;head.ifmatch);
}

static void
mimenomatch(Hlex *h, char *)
{
	h-&gt;c-&gt;head.ifnomatch = mimeetag(h, h-&gt;c-&gt;head.ifnomatch);
}

/*
 * argument is either etag or date
 */
static void
mimeifrange(Hlex *h, char *)
{
	int c, d, et;

	et = 0;
	c = getc(h);
	while(c == ' ' || c == '\t')
		c = getc(h);
	if(c == '"')
		et = 1;
	else if(c == 'W'){
		d = getc(h);
		if(d == '/')
			et = 1;
		ungetc(h);
	}
	ungetc(h);
	if(et){
		h-&gt;c-&gt;head.ifrangeetag = mimeetag(h, h-&gt;c-&gt;head.ifrangeetag);
	}else{
		lexhead(h);
		h-&gt;c-&gt;head.ifrangedate = hdate2sec(h-&gt;wordval);
	}
}

static void
mimerange(Hlex *h, char *)
{
	h-&gt;c-&gt;head.range = mimeranges(h, h-&gt;c-&gt;head.range);
}

/*
 * parse it like cookies
 */
static void
authdigest(Hlex *h, char *)
{
	char *s;
	HSPairs *p;

	p = nil;
	for(;;){
		while(lex(h) != Word)
			if(h-&gt;tok != ';' &amp;&amp; h-&gt;tok != ',')
				goto breakout;
		s = hstrdup(h-&gt;c, h-&gt;wordval);
		while (lex(h) != Word &amp;&amp; h-&gt;tok != QString)
			if (h-&gt;tok != '=')
				goto breakout;
		p = hmkspairs(h-&gt;c, s, hstrdup(h-&gt;c, h-&gt;wordval), p);
	}
breakout:
	h-&gt;c-&gt;head.authinfo = hrevspairs(p);
}

/*
 * note: netscape and ie through versions 4.7 and 4
 * support only basic authorization, so that is all that is supported here
 *
 * "Authorization" ":" "Basic" base64-user-pass
 * where base64-user-pass is the base64 encoding of
 * username ":" password
 */
static void
authbasic(Hlex *h, char *)
{
	char *up, *p;
	int n;

	n = lexbase64(h);
	if(!n)
		return;

	/*
	 * wipe out source for password, so it won't be logged.
	 * it is replaced by a single =,
	 * which is valid base64, but not ok for an auth reponse.
	 * therefore future parses of the header field will not overwrite
	 * authuser and authpass.
	 */
	memmove(h-&gt;c-&gt;hpos - (n - 1), h-&gt;c-&gt;hpos, h-&gt;c-&gt;hstop - h-&gt;c-&gt;hpos);
	h-&gt;c-&gt;hstop -= n - 1;
	*h-&gt;c-&gt;hstop = '\0';
	h-&gt;c-&gt;hpos -= n - 1;
	h-&gt;c-&gt;hpos[-1] = '=';

	up = halloc(h-&gt;c, n + 1);
	n = dec64((uchar*)up, n, h-&gt;wordval, n);
	up[n] = '\0';
	p = strchr(up, ':');
	if(p != nil){
		*p++ = '\0';
		h-&gt;c-&gt;head.authuser = hstrdup(h-&gt;c, up);
		h-&gt;c-&gt;head.authpass = hstrdup(h-&gt;c, p);
	}
}

/*
 * "Authorization" ":" "Basic" | "Digest" ...
 */
static void
mimeauthorization(Hlex *h, char *)
{
	int i;
	static MimeHead authparser[] = {
		{ "basic", authbasic },
		{ "digest", authdigest },
	};

	if(lex(h) != Word)
		return;

	for (i = 0; i &lt; nelem(authparser); i++)
		if (cistrcmp(h-&gt;wordval, authparser[i].name) == 0) {
			(*authparser[i].parse)(h, nil);
			break;
		}
}

static void
mimeagent(Hlex *h, char *)
{
	lexhead(h);
	h-&gt;c-&gt;head.client = hstrdup(h-&gt;c, h-&gt;wordval);
}

static void
mimefrom(Hlex *h, char *)
{
	lexhead(h);
}

static void
mimehost(Hlex *h, char *)
{
	char *hd;

	lexhead(h);
	for(hd = h-&gt;wordval; *hd == ' ' || *hd == '\t'; hd++)
		;
	h-&gt;c-&gt;head.host = hlower(hstrdup(h-&gt;c, hd));
}

/*
 * if present, implies that a message body follows the headers
 * "content-length" ":" digits
 */
static void
mimecontlen(Hlex *h, char *)
{
	char *e;
	ulong v;

	if(lex(h) != Word)
		return;
	e = h-&gt;wordval;
	v = digtoul(e, &amp;e);
	if(v == ~0UL || *e != '\0')
		return;
	h-&gt;c-&gt;head.contlen = v;
}

/*
 * mimexpect	: "expect" ":" expects
 * expects	: | expects "," expect
 * expect	: "100-continue" | token | token "=" token expectparams | token "=" qstring expectparams
 * expectparams	: ";" token | ";" token "=" token | token "=" qstring
 * for now, we merely parse "100-continue" or anything else.
 */
static void
mimeexpect(Hlex *h, char *)
{
	if(lex(h) != Word || cistrcmp(h-&gt;wordval, "100-continue") != 0 || lex(h) != '\n')
		h-&gt;c-&gt;head.expectother = 1;
	h-&gt;c-&gt;head.expectcont = 1;
}

static void
mimetransenc(Hlex *h, char *)
{
	h-&gt;c-&gt;head.transenc = mimehfields(h);
}

static void
mimecookie(Hlex *h, char *)
{
	char *s;
	HSPairs *p;

	p = nil;
	for(;;){
		while(lex(h) != Word)
			if(h-&gt;tok != ';' &amp;&amp; h-&gt;tok != ',')
				goto breakout;
		s = hstrdup(h-&gt;c, h-&gt;wordval);
		while (lex(h) != Word &amp;&amp; h-&gt;tok != QString)
			if (h-&gt;tok != '=')
				goto breakout;
		p = hmkspairs(h-&gt;c, s, hstrdup(h-&gt;c, h-&gt;wordval), p);
	}
breakout:
	h-&gt;c-&gt;head.cookie = hrevspairs(p);
}

static void
mimefresh(Hlex *h, char *)
{
	char *s;

	lexhead(h);
	for(s = h-&gt;wordval; *s &amp;&amp; (*s==' ' || *s=='\t'); s++)
		;
	if(strncmp(s, "pathstat/", 9) == 0)
		h-&gt;c-&gt;head.fresh_thresh = atoi(s+9);
	else if(strncmp(s, "have/", 5) == 0)
		h-&gt;c-&gt;head.fresh_have = atoi(s+5);
}

static void
mimeignore(Hlex *h, char *)
{
	lexhead(h);
}

static void
parsejump(Hlex *h, char *k)
{
	int l, r, m;

	l = 1;
	r = nelem(mimehead) - 1;
	while(l &lt;= r){
		m = (r + l) &gt;&gt; 1;
		if(cistrcmp(mimehead[m].name, k) &lt;= 0)
			l = m + 1;
		else
			r = m - 1;
	}
	m = l - 1;
	if(cistrcmp(mimehead[m].name, k) == 0 &amp;&amp; !mimehead[m].ignore){
		mimehead[m].seen = 1;
		(*mimehead[m].parse)(h, k);
	}else
		mimeignore(h, k);
}

static int
lex(Hlex *h)
{
	return h-&gt;tok = lex1(h, 0);
}

static int
lexbase64(Hlex *h)
{
	int c, n;

	n = 0;
	lex1(h, 1);

	while((c = getc(h)) &gt;= 0){
		if(!isalnum(c) &amp;&amp; c != '+' &amp;&amp; c != '/'){
			ungetc(h);
			break;
		}
		if(n &lt; HMaxWord-1)
			h-&gt;wordval[n++] = c;
	}
	h-&gt;wordval[n] = '\0';
	return n;
}

/*
 * rfc 822/rfc 1521 lexical analyzer
 */
static int
lex1(Hlex *h, int skipwhite)
{
	int level, c;

	if(h-&gt;eol)
		return '\n';

top:
	c = getc(h);
	switch(c){
	case '(':
		level = 1;
		while((c = getc(h)) &gt;= 0){
			if(c == '\\'){
				c = getc(h);
				if(c &lt; 0)
					return '\n';
				continue;
			}
			if(c == '(')
				level++;
			else if(c == ')' &amp;&amp; --level == 0)
				break;
			else if(c == '\n'){
				c = getc(h);
				if(c &lt; 0)
					return '\n';
				if(c == ')' &amp;&amp; --level == 0)
					break;
				if(c != ' ' &amp;&amp; c != '\t'){
					ungetc(h);
					return '\n';
				}
			}
		}
		goto top;

	case ' ': case '\t':
		goto top;

	case '\r':
		c = getc(h);
		if(c != '\n'){
			ungetc(h);
			goto top;
		}

	case '\n':
		if(h-&gt;tok == '\n'){
			h-&gt;eol = 1;
			h-&gt;eoh = 1;
			return '\n';
		}
		c = getc(h);
		if(c &lt; 0){
			h-&gt;eol = 1;
			return '\n';
		}
		if(c != ' ' &amp;&amp; c != '\t'){
			ungetc(h);
			h-&gt;eol = 1;
			return '\n';
		}
		goto top;

	case ')':
	case '&lt;': case '&gt;':
	case '[': case ']':
	case '@': case '/':
	case ',': case ';': case ':': case '?': case '=':
		if(skipwhite){
			ungetc(h);
			return c;
		}
		return c;

	case '"':
		if(skipwhite){
			ungetc(h);
			return c;
		}
		word(h, "\"");
		getc(h);		/* skip the closing quote */
		return QString;

	default:
		ungetc(h);
		if(skipwhite)
			return c;
		word(h, "\"(){}&lt;&gt;@,;:/[]?=\r\n \t");
		if(h-&gt;wordval[0] == '\0'){
			h-&gt;c-&gt;head.closeit = 1;
			hfail(h-&gt;c, HSyntax);
			longjmp(h-&gt;jmp, -1);
		}
		return Word;
	}
	/* not reached */
}

/*
 * return the rest of an rfc 822, including \n
 * do not map to lower case
 */
static void
lexhead(Hlex *h)
{
	int c, n;

	n = 0;
	while((c = getc(h)) &gt;= 0){
		if(c == '\r')
			c = wordcr(h);
		else if(c == '\n')
			c = wordnl(h);
		if(c == '\n')
			break;
		if(c == '\\'){
			c = getc(h);
			if(c &lt; 0)
				break;
		}

		if(n &lt; HMaxWord-1)
			h-&gt;wordval[n++] = c;
	}
	h-&gt;tok = '\n';
	h-&gt;eol = 1;
	h-&gt;wordval[n] = '\0';
}

static void
word(Hlex *h, char *stop)
{
	int c, n;

	n = 0;
	while((c = getc(h)) &gt;= 0){
		if(c == '\r')
			c = wordcr(h);
		else if(c == '\n')
			c = wordnl(h);
		if(c == '\\'){
			c = getc(h);
			if(c &lt; 0)
				break;
		}else if(c &lt; 32 || strchr(stop, c) != nil){
			ungetc(h);
			break;
		}

		if(n &lt; HMaxWord-1)
			h-&gt;wordval[n++] = c;
	}
	h-&gt;wordval[n] = '\0';
}

static int
wordcr(Hlex *h)
{
	int c;

	c = getc(h);
	if(c == '\n')
		return wordnl(h);
	ungetc(h);
	return ' ';
}

static int
wordnl(Hlex *h)
{
	int c;

	c = getc(h);
	if(c == ' ' || c == '\t')
		return c;
	ungetc(h);

	return '\n';
}

static int
getc(Hlex *h)
{
	if(h-&gt;eoh)
		return -1;
	if(h-&gt;c-&gt;hpos &lt; h-&gt;c-&gt;hstop)
		return *h-&gt;c-&gt;hpos++;
	h-&gt;eoh = 1;
	h-&gt;eol = 1;
	return -1;
}

static void
ungetc(Hlex *h)
{
	if(h-&gt;eoh)
		return;
	h-&gt;c-&gt;hpos--;
}

static ulong
digtoul(char *s, char **e)
{
	ulong v;
	int c, ovfl;

	v = 0;
	ovfl = 0;
	for(;;){
		c = *s;
		if(c &lt; '0' || c &gt; '9')
			break;
		s++;
		c -= '0';
		if(v &gt; UlongMax/10 || v == UlongMax/10 &amp;&amp; c &gt;= UlongMax%10)
			ovfl = 1;
		v = v * 10 + c;
	}

	if(e)
		*e = s;
	if(ovfl)
		return UlongMax;
	return v;
}

int
http11(HConnect *c)
{
	return c-&gt;req.vermaj &gt; 1 || c-&gt;req.vermaj == 1 &amp;&amp; c-&gt;req.vermin &gt; 0;
}

char*
hmkmimeboundary(HConnect *c)
{
	char buf[32];
	int i;

	srand((time(0)&lt;&lt;16)|getpid());
	strcpy(buf, "upas-");
	for(i = 5; i &lt; sizeof(buf)-1; i++)
		buf[i] = 'a' + nrand(26);
	buf[i] = 0;
	return hstrdup(c, buf);
}

HSPairs*
hmkspairs(HConnect *c, char *s, char *t, HSPairs *next)
{
	HSPairs *sp;

	sp = halloc(c, sizeof *sp);
	sp-&gt;s = s;
	sp-&gt;t = t;
	sp-&gt;next = next;
	return sp;
}

HSPairs*
hrevspairs(HSPairs *sp)
{
	HSPairs *last, *next;

	last = nil;
	for(; sp != nil; sp = next){
		next = sp-&gt;next;
		sp-&gt;next = last;
		last = sp;
	}
	return last;
}

HFields*
hmkhfields(HConnect *c, char *s, HSPairs *p, HFields *next)
{
	HFields *hf;

	hf = halloc(c, sizeof *hf);
	hf-&gt;s = s;
	hf-&gt;params = p;
	hf-&gt;next = next;
	return hf;
}

HFields*
hrevhfields(HFields *hf)
{
	HFields *last, *next;

	last = nil;
	for(; hf != nil; hf = next){
		next = hf-&gt;next;
		hf-&gt;next = last;
		last = hf;
	}
	return last;
}

HContent*
hmkcontent(HConnect *c, char *generic, char *specific, HContent *next)
{
	HContent *ct;

	ct = halloc(c, sizeof(HContent));
	ct-&gt;generic = generic;
	ct-&gt;specific = specific;
	ct-&gt;next = next;
	ct-&gt;q = 1;
	ct-&gt;mxb = 0;
	return ct;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

