<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/5db.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/5db.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

static int debug = 0;

#define	BITS(a, b)	((1&lt;&lt;(b+1))-(1&lt;&lt;a))

#define LSR(v, s)	((ulong)(v) &gt;&gt; (s))
#define ASR(v, s)	((long)(v) &gt;&gt; (s))
#define ROR(v, s)	(LSR((v), (s)) | (((v) &amp; ((1 &lt;&lt; (s))-1)) &lt;&lt; (32 - (s))))



typedef struct	Instr	Instr;
struct	Instr
{
	Map	*map;
	ulong	w;
	uvlong	addr;
	uchar	op;			/* super opcode */

	uchar	cond;			/* bits 28-31 */
	uchar	store;			/* bit 20 */

	uchar	rd;			/* bits 12-15 */
	uchar	rn;			/* bits 16-19 */
	uchar	rs;			/* bits 0-11 (shifter operand) */

	long	imm;			/* rotated imm */
	char*	curr;			/* fill point in buffer */
	char*	end;			/* end of buffer */
	char*	err;			/* error message */
};

typedef struct Opcode Opcode;
struct Opcode
{
	char*	o;
	void	(*fmt)(Opcode*, Instr*);
	uvlong	(*foll)(Map*, Rgetter, Instr*, uvlong);
	char*	a;
};

static	void	format(char*, Instr*, char*);
static	char	FRAMENAME[] = ".frame";

/*
 * Arm-specific debugger interface
 */

static	char	*armexcep(Map*, Rgetter);
static	int	armfoll(Map*, uvlong, Rgetter, uvlong*);
static	int	arminst(Map*, uvlong, char, char*, int);
static	int	armdas(Map*, uvlong, char*, int);
static	int	arminstlen(Map*, uvlong);

/*
 *	Debugger interface
 */
Machdata armmach =
{
	{0x70, 0x00, 0x20, 0xE1},		/* break point */	/* E1200070 */
	4,			/* break point size */

	leswab,			/* short to local byte order */
	leswal,			/* long to local byte order */
	leswav,			/* long to local byte order */
	risctrace,		/* C traceback */
	riscframe,		/* Frame finder */
	armexcep,			/* print exception */
	0,			/* breakpoint fixup */
	0,			/* single precision float printer */
	0,			/* double precision float printer */
	armfoll,		/* following addresses */
	arminst,		/* print instruction */
	armdas,			/* dissembler */
	arminstlen,		/* instruction size */
};

static char*
armexcep(Map *map, Rgetter rget)
{
	uvlong c;

	c = (*rget)(map, "TYPE");
	switch ((int)c&amp;0x1f) {
	case 0x11:
		return "Fiq interrupt";
	case 0x12:
		return "Mirq interrupt";
	case 0x13:
		return "SVC/SWI Exception";
	case 0x17:
		return "Prefetch Abort/Breakpoint";
	case 0x18:
		return "Data Abort";
	case 0x1b:
		return "Undefined instruction/Breakpoint";
	case 0x1f:
		return "Sys trap";
	default:
		return "Undefined trap";
	}
}

static
char*	cond[16] =
{
	"EQ",	"NE",	"CS",	"CC",
	"MI",	"PL",	"VS",	"VC",
	"HI",	"LS",	"GE",	"LT",
	"GT",	"LE",	0,	"NV"
};

static
char*	shtype[4] =
{
	"&lt;&lt;",	"&gt;&gt;",	"-&gt;",	"@&gt;"
};

static
char *hb[4] =
{
	"???",	"HU", "B", "H"
};

static
char*	addsub[2] =
{
	"-",	"+",
};

int
armclass(long w)
{
	int op, done, cp;

	op = (w &gt;&gt; 25) &amp; 0x7;
	switch(op) {
	case 0:	/* data processing r,r,r */
		if((w &amp; 0x0ff00080) == 0x01200000) {
			op = (w &gt;&gt; 4) &amp; 0x7;
			if(op == 7)
				op = 124;	/* bkpt */
			else if (op &gt; 0 &amp;&amp; op &lt; 4)
				op += 124;	/* bx, blx */
			else
				op = 92;	/* unk */
			break;
		}
		op = ((w &gt;&gt; 4) &amp; 0xf);
		if(op == 0x9) {
			op = 48+16;		/* mul, swp or *rex */
			if((w &amp; 0x0ff00fff) == 0x01900f9f) {
				op = 93;	/* ldrex */
				break;
			}
			if((w &amp; 0x0ff00ff0) == 0x01800f90) {
				op = 94;	/* strex */
				break;
			}
			if(w &amp; (1&lt;&lt;24)) {
				op += 2;
				if(w &amp; (1&lt;&lt;22))
					op++;	/* swpb */
				break;
			}
			if(w &amp; (1&lt;&lt;23)) {	/* mullu */
				op = (48+24+4+4+2+2+4);
				if(w &amp; (1&lt;&lt;22))	/* mull */
					op += 2;
			}
			if(w &amp; (1&lt;&lt;21))
				op++;		/* mla */
			break;
		}
		if((op &amp; 0x9) == 0x9)		/* ld/st byte/half s/u */
		{
			op = (48+16+4) + ((w &gt;&gt; 22) &amp; 0x1) + ((w &gt;&gt; 19) &amp; 0x2);
			break;
		}
		op = (w &gt;&gt; 21) &amp; 0xf;
		if(w &amp; (1&lt;&lt;4))
			op += 32;
		else
		if((w &amp; (31&lt;&lt;7)) || (w &amp; (1&lt;&lt;5)))
			op += 16;
		break;
	case 1:	/* data processing i,r,r */
		op = (48) + ((w &gt;&gt; 21) &amp; 0xf);
		break;
	case 2:	/* load/store byte/word i(r) */
		if ((w &amp; 0xffffff8f) == 0xf57ff00f) {	/* barriers, clrex */
			done = 1;
			switch ((w &gt;&gt; 4) &amp; 7) {
			case 1:
				op = 95;	/* clrex */
				break;
			case 4:
				op = 96;	/* dsb */
				break;
			case 5:
				op = 97;	/* dmb */
				break;
			case 6:
				op = 98;	/* isb */
				break;
			default:
				done = 0;
				break;
			}
			if (done)
				break;
		}
		op = (48+24) + ((w &gt;&gt; 22) &amp; 0x1) + ((w &gt;&gt; 19) &amp; 0x2);
		break;
	case 3:	/* load/store byte/word (r)(r) */
		op = (48+24+4) + ((w &gt;&gt; 22) &amp; 0x1) + ((w &gt;&gt; 19) &amp; 0x2);
		break;
	case 4:	/* block data transfer (r)(r) */
		if ((w &amp; 0xfe50ffff) == 0xf8100a00) {	/* v7 RFE */
			op = 99;
			break;
		}
		op = (48+24+4+4) + ((w &gt;&gt; 20) &amp; 0x1);
		break;
	case 5:	/* branch / branch link */
		op = (48+24+4+4+2) + ((w &gt;&gt; 24) &amp; 0x1);
		break;
	case 7:	/* coprocessor crap */
		cp = (w &gt;&gt; 8) &amp; 0xF;
		if(cp == 10 || cp == 11){	/* vfp */
			if((w &gt;&gt; 4) &amp; 0x1){
				/* vfp register transfer */
				switch((w &gt;&gt; 21) &amp; 0x7){
				case 0:
					op = 118 + ((w &gt;&gt; 20) &amp; 0x1);
					break;
				case 7:
					op = 118+2 + ((w &gt;&gt; 20) &amp; 0x1);
					break;
				default:
					op = (48+24+4+4+2+2+4+4);
					break;
				}
				break;
			}
			/* vfp data processing */
			if(((w &gt;&gt; 23) &amp; 0x1) == 0){
				op = 100 + ((w &gt;&gt; 19) &amp; 0x6) + ((w &gt;&gt; 6) &amp; 0x1);
				break;
			}
			switch(((w &gt;&gt; 19) &amp; 0x6) + ((w &gt;&gt; 6) &amp; 0x1)){
			case 0:
				op = 108;
				break;
			case 7:
				if(((w &gt;&gt; 19) &amp; 0x1) == 0){
					if(((w &gt;&gt; 17) &amp; 0x1) == 0)
						op = 109 + ((w &gt;&gt; 16) &amp; 0x4) +
							((w &gt;&gt; 15) &amp; 0x2) +
							((w &gt;&gt; 7) &amp; 0x1);
					else if(((w &gt;&gt; 16) &amp; 0x7) == 0x7)
						op = 117;
				}else
					switch((w &gt;&gt; 16) &amp; 0x7){
					case 0:
					case 4:
					case 5:
						op = 117;
						break;
					}
				break;
			}
			if(op == 7)
				op = (48+24+4+4+2+2+4+4);
			break;
		}
		op = (48+24+4+4+2+2) + ((w &gt;&gt; 3) &amp; 0x2) + ((w &gt;&gt; 20) &amp; 0x1);
		break;
	case 6:	/* vfp load / store */
		if(((w &gt;&gt; 21) &amp;0x9) == 0x8){
			op = 122 + ((w &gt;&gt; 20) &amp; 0x1);
			break;
		}
		/* fall through */
	default:	  
		op = (48+24+4+4+2+2+4+4);
		break;
	}
	return op;
}

static int
decode(Map *map, uvlong pc, Instr *i)
{
	ulong w;

	if(get4(map, pc, &amp;w) &lt; 0) {
		werrstr("can't read instruction: %r");
		return -1;
	}
	i-&gt;w = w;
	i-&gt;addr = pc;
	i-&gt;cond = (w &gt;&gt; 28) &amp; 0xF;
	i-&gt;op = armclass(w);
	i-&gt;map = map;
	return 1;
}

#pragma	varargck	argpos	bprint		2

static void
bprint(Instr *i, char *fmt, ...)
{
	va_list arg;

	va_start(arg, fmt);
	i-&gt;curr = vseprint(i-&gt;curr, i-&gt;end, fmt, arg);
	va_end(arg);
}

static int
plocal(Instr *i)
{
	char *reg;
	Symbol s;
	char *fn;
	int class;
	int offset;

	if(!findsym(i-&gt;addr, CTEXT, &amp;s)) {
		if(debug)fprint(2,"fn not found @%llux: %r\n", i-&gt;addr);
		return 0;
	}
	fn = s.name;
	if (!findlocal(&amp;s, FRAMENAME, &amp;s)) {
		if(debug)fprint(2,"%s.%s not found @%s: %r\n", fn, FRAMENAME, s.name);
			return 0;
	}
	if(s.value &gt; i-&gt;imm) {
		class = CAUTO;
		offset = s.value-i-&gt;imm;
		reg = "(SP)";
	} else {
		class = CPARAM;
		offset = i-&gt;imm-s.value-4;
		reg = "(FP)";
	}
	if(!getauto(&amp;s, offset, class, &amp;s)) {
		if(debug)fprint(2,"%s %s not found @%ux: %r\n", fn,
			class == CAUTO ? " auto" : "param", offset);
		return 0;
	}
	bprint(i, "%s%c%lld%s", s.name, class == CPARAM ? '+' : '-', s.value, reg);
	return 1;
}

/*
 * Print value v as name[+offset]
 */
static int
gsymoff(char *buf, int n, ulong v, int space)
{
	Symbol s;
	int r;
	long delta;

	r = delta = 0;		/* to shut compiler up */
	if (v) {
		r = findsym(v, space, &amp;s);
		if (r)
			delta = v-s.value;
		if (delta &lt; 0)
			delta = -delta;
	}
	if (v == 0 || r == 0 || delta &gt;= 4096)
		return snprint(buf, n, "#%lux", v);
	if (strcmp(s.name, ".string") == 0)
		return snprint(buf, n, "#%lux", v);
	if (!delta)
		return snprint(buf, n, "%s", s.name);
	if (s.type != 't' &amp;&amp; s.type != 'T')
		return snprint(buf, n, "%s+%llux", s.name, v-s.value);
	else
		return snprint(buf, n, "#%lux", v);
}

static void
armdps(Opcode *o, Instr *i)
{
	i-&gt;store = (i-&gt;w &gt;&gt; 20) &amp; 1;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	i-&gt;rs = (i-&gt;w &gt;&gt; 0) &amp; 0xf;
	if(i-&gt;rn == 15 &amp;&amp; i-&gt;rs == 0) {
		if(i-&gt;op == 8) {
			format("MOVW", i,"CPSR, R%d");
			return;
		} else
		if(i-&gt;op == 10) {
			format("MOVW", i,"SPSR, R%d");
			return;
		}
	} else
	if(i-&gt;rn == 9 &amp;&amp; i-&gt;rd == 15) {
		if(i-&gt;op == 9) {
			format("MOVW", i, "R%s, CPSR");
			return;
		} else
		if(i-&gt;op == 11) {
			format("MOVW", i, "R%s, SPSR");
			return;
		}
	}
	if(i-&gt;rd == 15) {
		if(i-&gt;op == 120) {
			format("MOVW", i, "PSR, %x");
			return;
		} else
		if(i-&gt;op == 121) {
			format("MOVW", i, "%x, PSR");
			return;
		}
	}
	format(o-&gt;o, i, o-&gt;a);
}

static void
armdpi(Opcode *o, Instr *i)
{
	ulong v;
	int c;

	v = (i-&gt;w &gt;&gt; 0) &amp; 0xff;
	c = (i-&gt;w &gt;&gt; 8) &amp; 0xf;
	while(c) {
		v = (v&lt;&lt;30) | (v&gt;&gt;2);
		c--;
	}
	i-&gt;imm = v;
	i-&gt;store = (i-&gt;w &gt;&gt; 20) &amp; 1;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	i-&gt;rs = i-&gt;w&amp;0x0f;

		/* RET is encoded as ADD #0,R14,R15 */
	if((i-&gt;w &amp; 0x0fffffff) == 0x028ef000){
		format("RET%C", i, "");
		return;
	}
	if((i-&gt;w &amp; 0x0ff0ffff) == 0x0280f000){
		format("B%C", i, "0(R%n)");
		return;
	}
	format(o-&gt;o, i, o-&gt;a);
}

static void
armsdti(Opcode *o, Instr *i)
{
	ulong v;

	v = i-&gt;w &amp; 0xfff;
	if(!(i-&gt;w &amp; (1&lt;&lt;23)))
		v = -v;
	i-&gt;store = ((i-&gt;w &gt;&gt; 23) &amp; 0x2) | ((i-&gt;w &gt;&gt;21) &amp; 0x1);
	i-&gt;imm = v;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
		/* RET is encoded as LW.P x,R13,R15 */
	if ((i-&gt;w &amp; 0x0ffff000) == 0x049df000)
	{
		format("RET%C%p", i, "%I");
		return;
	}
	format(o-&gt;o, i, o-&gt;a);
}

static void
armvstdi(Opcode *o, Instr *i)
{
	ulong v;

	v = (i-&gt;w &amp; 0xff) &lt;&lt; 2;
	if(!(i-&gt;w &amp; (1&lt;&lt;23)))
		v = -v;
	i-&gt;imm = v;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	format(o-&gt;o, i, o-&gt;a);
}

/* arm V4 ld/st halfword, signed byte */
static void
armhwby(Opcode *o, Instr *i)
{
	i-&gt;store = ((i-&gt;w &gt;&gt; 23) &amp; 0x2) | ((i-&gt;w &gt;&gt;21) &amp; 0x1);
	i-&gt;imm = (i-&gt;w &amp; 0xf) | ((i-&gt;w &gt;&gt; 8) &amp; 0xf);
	if (!(i-&gt;w &amp; (1 &lt;&lt; 23)))
		i-&gt;imm = - i-&gt;imm;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	i-&gt;rs = (i-&gt;w &gt;&gt; 0) &amp; 0xf;
	format(o-&gt;o, i, o-&gt;a);
}

static void
armsdts(Opcode *o, Instr *i)
{
	i-&gt;store = ((i-&gt;w &gt;&gt; 23) &amp; 0x2) | ((i-&gt;w &gt;&gt;21) &amp; 0x1);
	i-&gt;rs = (i-&gt;w &gt;&gt; 0) &amp; 0xf;
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	format(o-&gt;o, i, o-&gt;a);
}

static void
armbdt(Opcode *o, Instr *i)
{
	i-&gt;store = (i-&gt;w &gt;&gt; 21) &amp; 0x3;		/* S &amp; W bits */
	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;imm = i-&gt;w &amp; 0xffff;
	if(i-&gt;w == 0xe8fd8000)
		format("RFE", i, "");
	else
		format(o-&gt;o, i, o-&gt;a);
}

static void
armund(Opcode *o, Instr *i)
{
	format(o-&gt;o, i, o-&gt;a);
}

static void
armcdt(Opcode *o, Instr *i)
{
	format(o-&gt;o, i, o-&gt;a);
}

static void
armunk(Opcode *o, Instr *i)
{
	format(o-&gt;o, i, o-&gt;a);
}

static void
armb(Opcode *o, Instr *i)
{
	ulong v;

	v = i-&gt;w &amp; 0xffffff;
	if(v &amp; 0x800000)
		v |= ~0xffffff;
	i-&gt;imm = (v&lt;&lt;2) + i-&gt;addr + 8;
	format(o-&gt;o, i, o-&gt;a);
}

static void
armbpt(Opcode *o, Instr *i)
{
	i-&gt;imm = ((i-&gt;w &gt;&gt; 4) &amp; 0xfff0) | (i-&gt;w &amp;0xf);
	format(o-&gt;o, i, o-&gt;a);
}

static void
armco(Opcode *o, Instr *i)		/* coprocessor instructions */
{
	int op, p, cp;

	char buf[1024];

	i-&gt;rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	i-&gt;rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	i-&gt;rs = i-&gt;w&amp;0xf;
	cp = (i-&gt;w &gt;&gt; 8) &amp; 0xf;
	p = (i-&gt;w &gt;&gt; 5) &amp; 0x7;
	if(i-&gt;w&amp;(1&lt;&lt;4)) {
		op = (i-&gt;w &gt;&gt; 21) &amp; 0x07;
		snprint(buf, sizeof(buf), "#%x, #%x, R%d, C(%d), C(%d), #%x", cp, op, i-&gt;rd, i-&gt;rn, i-&gt;rs, p);
	} else {
		op = (i-&gt;w &gt;&gt; 20) &amp; 0x0f;
		snprint(buf, sizeof(buf), "#%x, #%x, C(%d), C(%d), C(%d), #%x", cp, op, i-&gt;rd, i-&gt;rn, i-&gt;rs, p);
	}
	format(o-&gt;o, i, buf);
}

static int
armcondpass(Map *map, Rgetter rget, uchar cond)
{
	uvlong psr;
	uchar n;
	uchar z;
	uchar c;
	uchar v;

	psr = rget(map, "PSR");
	n = (psr &gt;&gt; 31) &amp; 1;
	z = (psr &gt;&gt; 30) &amp; 1;
	c = (psr &gt;&gt; 29) &amp; 1;
	v = (psr &gt;&gt; 28) &amp; 1;

	switch(cond) {
	default:
	case 0:		return z;
	case 1:		return !z;
	case 2:		return c;
	case 3:		return !c;
	case 4:		return n;
	case 5:		return !n;
	case 6:		return v;
	case 7:		return !v;
	case 8:		return c &amp;&amp; !z;
	case 9:		return !c || z;
	case 10:	return n == v;
	case 11:	return n != v;
	case 12:	return !z &amp;&amp; (n == v);
	case 13:	return z || (n != v);
	case 14:	return 1;
	case 15:	return 0;
	}
}

static ulong
armshiftval(Map *map, Rgetter rget, Instr *i)
{
	if(i-&gt;w &amp; (1 &lt;&lt; 25)) {				/* immediate */
		ulong imm = i-&gt;w &amp; BITS(0, 7);
		ulong s = (i-&gt;w &amp; BITS(8, 11)) &gt;&gt; 7; /* this contains the *2 */
		return ROR(imm, s);
	} else {
		char buf[8];
		ulong v;
		ulong s = (i-&gt;w &amp; BITS(7,11)) &gt;&gt; 7;

		sprint(buf, "R%ld", i-&gt;w &amp; 0xf);
		v = rget(map, buf);

		switch((i-&gt;w &amp; BITS(4, 6)) &gt;&gt; 4) {
		default:
		case 0:					/* LSLIMM */
			return v &lt;&lt; s;
		case 1:					/* LSLREG */
			sprint(buf, "R%lud", s &gt;&gt; 1);
			s = rget(map, buf) &amp; 0xFF;
			if(s &gt;= 32) return 0;
			return v &lt;&lt; s;
		case 2:					/* LSRIMM */
			return LSR(v, s);
		case 3:					/* LSRREG */
			sprint(buf, "R%ld", s &gt;&gt; 1);
			s = rget(map, buf) &amp; 0xFF;
			if(s &gt;= 32) return 0;
			return LSR(v, s);
		case 4:					/* ASRIMM */
			if(s == 0) {
				if((v &amp; (1U&lt;&lt;31)) == 0)
					return 0;
				return 0xFFFFFFFF;
			}
			return ASR(v, s);
		case 5:					/* ASRREG */
			sprint(buf, "R%ld", s &gt;&gt; 1);
			s = rget(map, buf) &amp; 0xFF;
			if(s &gt;= 32) {
				if((v &amp; (1U&lt;&lt;31)) == 0)
					return 0;
				return 0xFFFFFFFF;
			}
			return ASR(v, s);
		case 6:					/* RORIMM */
			if(s == 0) {
				ulong c = (rget(map, "PSR") &gt;&gt; 29) &amp; 1;

				return (c &lt;&lt; 31) | LSR(v, 1);
			}
			return ROR(v, s);
		case 7:					/* RORREG */
			sprint(buf, "R%ld", (s&gt;&gt;1)&amp;0xF);
			s = rget(map, buf);
			if(s == 0 || (s &amp; 0xF) == 0)
				return v;
			return ROR(v, s &amp; 0xF);
		}
	}
}

static int
nbits(ulong v)
{
	int n = 0;
	int i;

	for(i=0; i &lt; 32 ; i++) {
		if(v &amp; 1) ++n;
		v &gt;&gt;= 1;
	}

	return n;
}

static ulong
armmaddr(Map *map, Rgetter rget, Instr *i)
{
	ulong v;
	ulong nb;
	char buf[8];
	ulong rn;

	rn = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	sprint(buf,"R%ld", rn);

	v = rget(map, buf);
	nb = nbits(i-&gt;w &amp; ((1 &lt;&lt; 15) - 1));

	switch((i-&gt;w &gt;&gt; 23) &amp; 3) {
	default:
	case 0: return (v - (nb*4)) + 4;
	case 1: return v;
	case 2: return v - (nb*4);
	case 3: return v + 4;
	}
}

static uvlong
armaddr(Map *map, Rgetter rget, Instr *i)
{
	char buf[8];
	ulong rn;

	snprint(buf, sizeof(buf), "R%ld", (i-&gt;w &gt;&gt; 16) &amp; 0xf);
	rn = rget(map, buf);

	if((i-&gt;w &amp; (1&lt;&lt;24)) == 0)			/* POSTIDX */
		return rn;

	if((i-&gt;w &amp; (1&lt;&lt;25)) == 0) {			/* OFFSET */
		if(i-&gt;w &amp; (1U&lt;&lt;23))
			return rn + (i-&gt;w &amp; BITS(0,11));
		return rn - (i-&gt;w &amp; BITS(0,11));
	} else {					/* REGOFF */
		ulong index = 0;
		uchar c;
		uchar rm;

		sprint(buf, "R%ld", i-&gt;w &amp; 0xf);
		rm = rget(map, buf);

		switch((i-&gt;w &amp; BITS(5,6)) &gt;&gt; 5) {
		case 0: index = rm &lt;&lt; ((i-&gt;w &amp; BITS(7,11)) &gt;&gt; 7);	break;
		case 1: index = LSR(rm, ((i-&gt;w &amp; BITS(7,11)) &gt;&gt; 7));	break;
		case 2: index = ASR(rm, ((i-&gt;w &amp; BITS(7,11)) &gt;&gt; 7));	break;
		case 3:
			if((i-&gt;w &amp; BITS(7,11)) == 0) {
				c = (rget(map, "PSR") &gt;&gt; 29) &amp; 1;
				index = c &lt;&lt; 31 | LSR(rm, 1);
			} else {
				index = ROR(rm, ((i-&gt;w &amp; BITS(7,11)) &gt;&gt; 7));
			}
			break;
		}
		if(i-&gt;w &amp; (1&lt;&lt;23))
			return rn + index;
		return rn - index;
	}
}

static uvlong
armfadd(Map *map, Rgetter rget, Instr *i, uvlong pc)
{
	char buf[8];
	int r;

	r = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	if(r != 15 || !armcondpass(map, rget, (i-&gt;w &gt;&gt; 28) &amp; 0xf))
		return pc+4;

	r = (i-&gt;w &gt;&gt; 16) &amp; 0xf;
	sprint(buf, "R%d", r);

	return rget(map, buf) + armshiftval(map, rget, i);
}

static uvlong
armfbx(Map *map, Rgetter rget, Instr *i, uvlong pc)
{
	char buf[8];
	int r;

	if(!armcondpass(map, rget, (i-&gt;w&gt;&gt;28)&amp;0xf))
		return pc+4;
	r = (i-&gt;w &gt;&gt; 0) &amp; 0xf;
	sprint(buf, "R%d", r);
	return rget(map, buf);
}

static uvlong
armfmovm(Map *map, Rgetter rget, Instr *i, uvlong pc)
{
	ulong v;
	ulong addr;

	v = i-&gt;w &amp; 1&lt;&lt;15;
	if(!v || !armcondpass(map, rget, (i-&gt;w&gt;&gt;28)&amp;0xf))
		return pc+4;

	addr = armmaddr(map, rget, i) + nbits(i-&gt;w &amp; BITS(0,15));
	if(get4(map, addr, &amp;v) &lt; 0) {
		werrstr("can't read addr: %r");
		return -1;
	}
	return v;
}

static uvlong
armfbranch(Map *map, Rgetter rget, Instr *i, uvlong pc)
{
	if(!armcondpass(map, rget, (i-&gt;w &gt;&gt; 28) &amp; 0xf))
		return pc+4;

	return pc + (((signed long)i-&gt;w &lt;&lt; 8) &gt;&gt; 6) + 8;
}

static uvlong
armfmov(Map *map, Rgetter rget, Instr *i, uvlong pc)
{
	ulong rd, v;

	rd = (i-&gt;w &gt;&gt; 12) &amp; 0xf;
	if(rd != 15 || !armcondpass(map, rget, (i-&gt;w&gt;&gt;28)&amp;0xf))
		return pc+4;

	 /* LDR */
	/* BUG: Needs LDH/B, too */
	if(((i-&gt;w&gt;&gt;26)&amp;0x3) == 1) {
		if(get4(map, armaddr(map, rget, i), &amp;v) &lt; 0) {
			werrstr("can't read instruction: %r");
			return pc+4;
		}
		return v;
	}

	 /* MOV */
	v = armshiftval(map, rget, i);

	return v;
}

static Opcode opcodes[] =
{
	"AND%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"EOR%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"SUB%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"RSB%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"ADD%C%S",	armdps, armfadd,	"R%s,R%n,R%d",
	"ADC%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"SBC%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"RSC%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"TST%C%S",	armdps, 0,	"R%s,R%n",
	"TEQ%C%S",	armdps, 0,	"R%s,R%n",
	"CMP%C%S",	armdps, 0,	"R%s,R%n",
	"CMN%C%S",	armdps, 0,	"R%s,R%n",
	"ORR%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"MOVW%C%S",	armdps, armfmov,	"R%s,R%d",
	"BIC%C%S",	armdps, 0,	"R%s,R%n,R%d",
	"MVN%C%S",	armdps, 0,	"R%s,R%d",

/* 16 */
	"AND%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"EOR%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"SUB%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"RSB%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"ADD%C%S",	armdps, armfadd,	"(R%s%h%m),R%n,R%d",
	"ADC%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"SBC%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"RSC%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"TST%C%S",	armdps, 0,	"(R%s%h%m),R%n",
	"TEQ%C%S",	armdps, 0,	"(R%s%h%m),R%n",
	"CMP%C%S",	armdps, 0,	"(R%s%h%m),R%n",
	"CMN%C%S",	armdps, 0,	"(R%s%h%m),R%n",
	"ORR%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"MOVW%C%S",	armdps, armfmov,	"(R%s%h%m),R%d",
	"BIC%C%S",	armdps, 0,	"(R%s%h%m),R%n,R%d",
	"MVN%C%S",	armdps, 0,	"(R%s%h%m),R%d",

/* 32 */
	"AND%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"EOR%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"SUB%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"RSB%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"ADD%C%S",	armdps, armfadd,	"(R%s%hR%M),R%n,R%d",
	"ADC%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"SBC%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"RSC%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"TST%C%S",	armdps, 0,	"(R%s%hR%M),R%n",
	"TEQ%C%S",	armdps, 0,	"(R%s%hR%M),R%n",
	"CMP%C%S",	armdps, 0,	"(R%s%hR%M),R%n",
	"CMN%C%S",	armdps, 0,	"(R%s%hR%M),R%n",
	"ORR%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"MOVW%C%S",	armdps, armfmov,	"(R%s%hR%M),R%d",
	"BIC%C%S",	armdps, 0,	"(R%s%hR%M),R%n,R%d",
	"MVN%C%S",	armdps, 0,	"(R%s%hR%M),R%d",

/* 48 */
	"AND%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"EOR%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"SUB%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"RSB%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"ADD%C%S",	armdpi, armfadd,	"$#%i,R%n,R%d",
	"ADC%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"SBC%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"RSC%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"TST%C%S",	armdpi, 0,	"$#%i,R%n",
	"TEQ%C%S",	armdpi, 0,	"$#%i,R%n",
	"CMP%C%S",	armdpi, 0,	"$#%i,R%n",
	"CMN%C%S",	armdpi, 0,	"$#%i,R%n",
	"ORR%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"MOVW%C%S",	armdpi, armfmov,	"$#%i,R%d",
	"BIC%C%S",	armdpi, 0,	"$#%i,R%n,R%d",
	"MVN%C%S",	armdpi, 0,	"$#%i,R%d",

/* 48+16 */
	"MUL%C%S",	armdpi, 0,	"R%M,R%s,R%n",
	"MULA%C%S",	armdpi, 0,	"R%M,R%s,R%n,R%d",
	"SWPW",		armdpi, 0,	"R%s,(R%n),R%d",
	"SWPB",		armdpi, 0,	"R%s,(R%n),R%d",

/* 48+16+4 */
	"MOV%u%C%p",	armhwby, 0,	"R%d,(R%n%UR%M)",
	"MOV%u%C%p",	armhwby, 0,	"R%d,%I",
	"MOV%u%C%p",	armhwby, armfmov,	"(R%n%UR%M),R%d",
	"MOV%u%C%p",	armhwby, armfmov,	"%I,R%d",

/* 48+24 */
	"MOVW%C%p",	armsdti, 0,	"R%d,%I",
	"MOVB%C%p",	armsdti, 0,	"R%d,%I",
	"MOVW%C%p",	armsdti, armfmov,	"%I,R%d",
	"MOVBU%C%p",	armsdti, armfmov,	"%I,R%d",

	"MOVW%C%p",	armsdts, 0,	"R%d,(R%s%h%m)(R%n)",
	"MOVB%C%p",	armsdts, 0,	"R%d,(R%s%h%m)(R%n)",
	"MOVW%C%p",	armsdts, armfmov,	"(R%s%h%m)(R%n),R%d",
	"MOVBU%C%p",	armsdts, armfmov,	"(R%s%h%m)(R%n),R%d",

	"MOVM%C%P%a",	armbdt, armfmovm,		"[%r],(R%n)",
	"MOVM%C%P%a",	armbdt, armfmovm,		"(R%n),[%r]",

	"B%C",		armb, armfbranch,		"%b",
	"BL%C",		armb, armfbranch,		"%b",

	"CDP%C",	armco, 0,		"",
	"CDP%C",	armco, 0,		"",
	"MCR%C",	armco, 0,		"",
	"MRC%C",	armco, 0,		"",

/* 48+24+4+4+2+2+4 */
	"MULLU%C%S",	armdpi, 0,	"R%M,R%s,(R%n,R%d)",
	"MULALU%C%S",	armdpi, 0,	"R%M,R%s,(R%n,R%d)",
	"MULL%C%S",	armdpi, 0,	"R%M,R%s,(R%n,R%d)",
	"MULAL%C%S",	armdpi, 0,	"R%M,R%s,(R%n,R%d)",

/* 48+24+4+4+2+2+4+4 = 92 */
	"UNK",		armunk, 0,	"",

	/* new v7 arch instructions */
/* 93 */
	"LDREX",	armdpi, 0,	"(R%n),R%d",
	"STREX",	armdpi, 0,	"R%s,(R%n),R%d",
	"CLREX",	armunk, 0,	"",

/* 96 */
	"DSB",		armunk, 0,	"",
	"DMB",		armunk, 0,	"",
	"ISB",		armunk, 0,	"",

/* 99 */
	"RFEV7%P%a",	armbdt, 0,	"(R%n)",

/* 100 */
	"MLA%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"MLS%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"NMLS%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"NMLA%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"MUL%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"NMUL%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"ADD%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"SUB%f%C",	armdps,	0,	"F%s,F%n,F%d",
	"DIV%f%C",	armdps,	0,	"F%s,F%n,F%d",

/* 109 */
	"MOV%f%C",	armdps,	0,	"F%s,F%d",
	"ABS%f%C",	armdps,	0,	"F%s,F%d",
	"NEG%f%C",	armdps,	0,	"F%s,F%d",
	"SQRT%f%C",	armdps,	0,	"F%s,F%d",
	"CMP%f%C",	armdps,	0,	"F%s,F%d",
	"CMPE%f%C",	armdps,	0,	"F%s,F%d",
	"CMP%f%C",	armdps,	0,	"$0.0,F%d",
	"CMPE%f%C",	armdps,	0,	"$0.0,F%d",

/* 117 */
	"MOV%F%R%C",	armdps, 0,	"F%s,F%d",

/* 118 */
	"MOVW%C",	armdps, 0,	"R%d,F%n",
	"MOVW%C",	armdps, 0,	"F%n,R%d",
	"MOVW%C",	armdps, 0,	"R%d,%x",
	"MOVW%C",	armdps, 0,	"%x,R%d",

/* 122 */
	"MOV%f%C",	armvstdi,	0,	"F%d,%I",
	"MOV%f%C",	armvstdi,	0,	"%I,F%d",

/* 124 */
	"BKPT%C",	armbpt,	0,		"$#%i",
	"BX%C",		armdps,	armfbx,	"(R%s)",
	"BXJ%C",	armdps,	armfbx,	"(R%s)",
	"BLX%C",	armdps,	armfbx,	"(R%s)",
};

static void
gaddr(Instr *i)
{
	*i-&gt;curr++ = '$';
	i-&gt;curr += gsymoff(i-&gt;curr, i-&gt;end-i-&gt;curr, i-&gt;imm, CANY);
}

static	char *mode[] = { 0, "IA", "DB", "IB" };
static	char *pw[] = { "P", "PW", 0, "W" };
static	char *sw[] = { 0, "W", "S", "SW" };

static void
format(char *mnemonic, Instr *i, char *f)
{
	int j, k, m, n;
	int g;
	char *fmt;

	if(mnemonic)
		format(0, i, mnemonic);
	if(f == 0)
		return;
	if(mnemonic)
		if(i-&gt;curr &lt; i-&gt;end)
			*i-&gt;curr++ = '\t';
	for ( ; *f &amp;&amp; i-&gt;curr &lt; i-&gt;end; f++) {
		if(*f != '%') {
			*i-&gt;curr++ = *f;
			continue;
		}
		switch (*++f) {

		case 'C':	/* .CONDITION */
			if(cond[i-&gt;cond])
				bprint(i, ".%s", cond[i-&gt;cond]);
			break;

		case 'S':	/* .STORE */
			if(i-&gt;store)
				bprint(i, ".S");
			break;

		case 'P':	/* P &amp; U bits for block move */
			n = (i-&gt;w &gt;&gt;23) &amp; 0x3;
			if (mode[n])
				bprint(i, ".%s", mode[n]);
			break;

		case 'p':	/* P &amp; W bits for single data xfer*/
			if (pw[i-&gt;store])
				bprint(i, ".%s", pw[i-&gt;store]);
			break;

		case 'a':	/* S &amp; W bits for single data xfer*/
			if (sw[i-&gt;store])
				bprint(i, ".%s", sw[i-&gt;store]);
			break;

		case 's':
			bprint(i, "%d", i-&gt;rs &amp; 0xf);
			break;
				
		case 'M':
			bprint(i, "%lud", (i-&gt;w&gt;&gt;8) &amp; 0xf);
			break;
				
		case 'm':
			bprint(i, "%lud", (i-&gt;w&gt;&gt;7) &amp; 0x1f);
			break;

		case 'h':
			bprint(i, shtype[(i-&gt;w&gt;&gt;5) &amp; 0x3]);
			break;

		case 'u':		/* Signed/unsigned Byte/Halfword */
			bprint(i, hb[(i-&gt;w&gt;&gt;5) &amp; 0x3]);
			break;

		case 'I':
			if (i-&gt;rn == 13) {
				if (plocal(i))
					break;
			}
			g = 0;
			fmt = "#%lx(R%d)";
			if (i-&gt;rn == 15) {
				/* convert load of offset(PC) to a load immediate */
				if (get4(i-&gt;map, i-&gt;addr+i-&gt;imm+8, (ulong*)&amp;i-&gt;imm) &gt; 0)
				{
					g = 1;
					fmt = "";
				}
			}
			if (mach-&gt;sb)
			{
				if (i-&gt;rd == 11) {
					ulong nxti;

					if (get4(i-&gt;map, i-&gt;addr+4, &amp;nxti) &gt; 0) {
						if ((nxti &amp; 0x0e0f0fff) == 0x060c000b) {
							i-&gt;imm += mach-&gt;sb;
							g = 1;
							fmt = "-SB";
						}
					}
				}
				if (i-&gt;rn == 12)
				{
					i-&gt;imm += mach-&gt;sb;
					g = 1;
					fmt = "-SB(SB)";
				}
			}
			if (g)
			{
				gaddr(i);
				bprint(i, fmt, i-&gt;rn);
			}
			else
				bprint(i, fmt, i-&gt;imm, i-&gt;rn);
			break;
		case 'U':		/* Add/subtract from base */
			bprint(i, addsub[(i-&gt;w &gt;&gt; 23) &amp; 1]);
			break;

		case 'n':
			bprint(i, "%d", i-&gt;rn);
			break;

		case 'd':
			bprint(i, "%d", i-&gt;rd);
			break;

		case 'i':
			bprint(i, "%lux", i-&gt;imm);
			break;

		case 'b':
			i-&gt;curr += symoff(i-&gt;curr, i-&gt;end-i-&gt;curr,
				(ulong)i-&gt;imm, CTEXT);
			break;

		case 'g':
			i-&gt;curr += gsymoff(i-&gt;curr, i-&gt;end-i-&gt;curr,
				i-&gt;imm, CANY);
			break;

		case 'f':
			switch((i-&gt;w &gt;&gt; 8) &amp; 0xF){
			case 10:
				bprint(i, "F");
				break;
			case 11:
				bprint(i, "D");
				break;
			}
			break;

		case 'F':
			switch(((i-&gt;w &gt;&gt; 15) &amp; 0xE) + ((i-&gt;w &gt;&gt; 8) &amp; 0x1)){
			case 0x0:
				bprint(i, ((i-&gt;w &gt;&gt; 7) &amp; 0x1)? "WF" : "WF.U");
				break;
			case 0x1:
				bprint(i, ((i-&gt;w &gt;&gt; 7) &amp; 0x1)? "WD" : "WD.U");
				break;
			case 0x8:
				bprint(i, "FW.U");
				break;
			case 0x9:
				bprint(i, "DW.U");
				break;
			case 0xA:
				bprint(i, "FW");
				break;
			case 0xB:
				bprint(i, "DW");
				break;
			case 0xE:
				bprint(i, "FD");
				break;
			case 0xF:
				bprint(i, "DF");
				break;
			}
			break;

		case 'R':
			if(((i-&gt;w &gt;&gt; 7) &amp; 0x1) == 0)
				bprint(i, "R");
			break;

		case 'x':
			switch(i-&gt;rn){
			case 0:
				bprint(i, "FPSID");
				break;
			case 1:
				bprint(i, "FPSCR");
				break;
			case 2:
				bprint(i, "FPEXC");
				break;
			default:
				bprint(i, "FPS(%d)", i-&gt;rn);
				break;
			}
			break;

		case 'r':
			n = i-&gt;imm&amp;0xffff;
			j = 0;
			k = 0;
			while(n) {
				m = j;
				while(n&amp;0x1) {
					j++;
					n &gt;&gt;= 1;
				}
				if(j != m) {
					if(k)
						bprint(i, ",");
					if(j == m+1)
						bprint(i, "R%d", m);
					else
						bprint(i, "R%d-R%d", m, j-1);
					k = 1;
				}
				j++;
				n &gt;&gt;= 1;
			}
			break;

		case '\0':
			*i-&gt;curr++ = '%';
			return;

		default:
			bprint(i, "%%%c", *f);
			break;
		}
	}
	*i-&gt;curr = 0;
}

static int
printins(Map *map, uvlong pc, char *buf, int n)
{
	Instr i;

	i.curr = buf;
	i.end = buf+n-1;
	if(decode(map, pc, &amp;i) &lt; 0)
		return -1;

	(*opcodes[i.op].fmt)(&amp;opcodes[i.op], &amp;i);
	return 4;
}

static int
arminst(Map *map, uvlong pc, char modifier, char *buf, int n)
{
	USED(modifier);
	return printins(map, pc, buf, n);
}

static int
armdas(Map *map, uvlong pc, char *buf, int n)
{
	Instr i;

	i.curr = buf;
	i.end = buf+n;
	if(decode(map, pc, &amp;i) &lt; 0)
		return -1;
	if(i.end-i.curr &gt; 8)
		i.curr = _hexify(buf, i.w, 7);
	*i.curr = 0;
	return 4;
}

static int
arminstlen(Map *map, uvlong pc)
{
	Instr i;

	if(decode(map, pc, &amp;i) &lt; 0)
		return -1;
	return 4;
}

static int
armfoll(Map *map, uvlong pc, Rgetter rget, uvlong *foll)
{
	uvlong d;
	Instr i;

	if(decode(map, pc, &amp;i) &lt; 0)
		return -1;

	if(opcodes[i.op].foll) {
		d = (*opcodes[i.op].foll)(map, rget, &amp;i, pc);
		if(d == -1)
			return -1;
	} else
		d = pc+4;

	foll[0] = d;
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

