<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/machdata.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/machdata.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Debugger utilities shared by at least two architectures
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

#define STARTSYM	"_main"
#define PROFSYM		"_mainp"
#define	FRAMENAME	".frame"

extern	Machdata	mipsmach;

int	asstype = AMIPS;		/* disassembler type */
Machdata *machdata;		/* machine-dependent functions */

int
localaddr(Map *map, char *fn, char *var, uvlong *r, Rgetter rget)
{
	Symbol s;
	uvlong fp, pc, sp, link;

	if (!lookup(fn, 0, &amp;s)) {
		werrstr("function not found");
		return -1;
	}
	pc = rget(map, mach-&gt;pc);
	sp = rget(map, mach-&gt;sp);
	if(mach-&gt;link)
		link = rget(map, mach-&gt;link);
	else
		link = 0;
	fp = machdata-&gt;findframe(map, s.value, pc, sp, link);
	if (fp == 0) {
		werrstr("stack frame not found");
		return -1;
	}

	if (!var || !var[0]) {
		*r = fp;
		return 1;
	}

	if (findlocal(&amp;s, var, &amp;s) == 0) {
		werrstr("local variable not found");
		return -1;
	}

	switch (s.class) {
	case CAUTO:
		*r = fp - s.value;
		break;
	case CPARAM:		/* assume address size is stack width */
		*r = fp + s.value + mach-&gt;szaddr;
		break;
	default:
		werrstr("local variable not found: %d", s.class);
		return -1;
	}
	return 1;
}

/*
 * Print value v as s.name[+offset] if possible, or just v.
 */
int
symoff(char *buf, int n, uvlong v, int space)
{
	Symbol s;
	int r;
	long delta;

	r = delta = 0;		/* to shut compiler up */
	if (v) {
		r = findsym(v, space, &amp;s);
		if (r)
			delta = v-s.value;
		if (delta &lt; 0)
			delta = -delta;
	}
	if (v == 0 || r == 0)
		return snprint(buf, n, "%llux", v);
	if (s.type != 't' &amp;&amp; s.type != 'T' &amp;&amp; delta &gt;= 4096)
		return snprint(buf, n, "%llux", v);
	else if (delta)
		return snprint(buf, n, "%s+%lux", s.name, delta);
	else
		return snprint(buf, n, "%s", s.name);
}

/*
 *	Format floating point registers
 *
 *	Register codes in format field:
 *	'X' - print as 32-bit hexadecimal value
 *	'F' - 64-bit double register when modif == 'F'; else 32-bit single reg
 *	'f' - 32-bit ieee float
 *	'8' - big endian 80-bit ieee extended float
 *	'3' - little endian 80-bit ieee extended float with hole in bytes 8&amp;9
 */
int
fpformat(Map *map, Reglist *rp, char *buf, int n, int modif)
{
	char reg[12];
	ulong r;

	switch(rp-&gt;rformat)
	{
	case 'X':
		if (get4(map, rp-&gt;roffs, &amp;r) &lt; 0)
			return -1;
		snprint(buf, n, "%lux", r);
		break;
	case 'F':	/* first reg of double reg pair */
		if (modif == 'F')
		if ((rp-&gt;rformat=='F') || (((rp+1)-&gt;rflags&amp;RFLT) &amp;&amp; (rp+1)-&gt;rformat == 'f')) {
			if (get1(map, rp-&gt;roffs, (uchar *)reg, 8) &lt; 0)
				return -1;
			machdata-&gt;dftos(buf, n, reg);
			if (rp-&gt;rformat == 'F')
				return 1;
			return 2;
		}	
			/* treat it like 'f' */
		if (get1(map, rp-&gt;roffs, (uchar *)reg, 4) &lt; 0)
			return -1;
		machdata-&gt;sftos(buf, n, reg);
		break;
	case 'f':	/* 32 bit float */
		if (get1(map, rp-&gt;roffs, (uchar *)reg, 4) &lt; 0)
			return -1;
		machdata-&gt;sftos(buf, n, reg);
		break;
	case '3':	/* little endian ieee 80 with hole in bytes 8&amp;9 */
		if (get1(map, rp-&gt;roffs, (uchar *)reg, 10) &lt; 0)
			return -1;
		memmove(reg+10, reg+8, 2);	/* open hole */
		memset(reg+8, 0, 2);		/* fill it */
		leieee80ftos(buf, n, reg);
		break;
	case '8':	/* big-endian ieee 80 */
		if (get1(map, rp-&gt;roffs, (uchar *)reg, 10) &lt; 0)
			return -1;
		beieee80ftos(buf, n, reg);
		break;
	default:	/* unknown */
		break;
	}
	return 1;
}

char *
_hexify(char *buf, ulong p, int zeros)
{
	ulong d;

	d = p/16;
	if(d)
		buf = _hexify(buf, d, zeros-1);
	else
		while(zeros--)
			*buf++ = '0';
	*buf++ = "0123456789abcdef"[p&amp;0x0f];
	return buf;
}

/*
 * These routines assume that if the number is representable
 * in IEEE floating point, it will be representable in the native
 * double format.  Naive but workable, probably.
 */
int
ieeedftos(char *buf, int n, ulong h, ulong l)
{
	double fr;
	int exp;

	if (n &lt;= 0)
		return 0;


	if(h &amp; (1L&lt;&lt;31)){
		*buf++ = '-';
		h &amp;= ~(1L&lt;&lt;31);
	}else
		*buf++ = ' ';
	n--;
	if(l == 0 &amp;&amp; h == 0)
		return snprint(buf, n, "0.");
	exp = (h&gt;&gt;20) &amp; ((1L&lt;&lt;11)-1L);
	if(exp == 0)
		return snprint(buf, n, "DeN(%.8lux%.8lux)", h, l);
	if(exp == ((1L&lt;&lt;11)-1L)){
		if(l==0 &amp;&amp; (h&amp;((1L&lt;&lt;20)-1L)) == 0)
			return snprint(buf, n, "Inf");
		else
			return snprint(buf, n, "NaN(%.8lux%.8lux)", h&amp;((1L&lt;&lt;20)-1L), l);
	}
	exp -= (1L&lt;&lt;10) - 2L;
	fr = l &amp; ((1L&lt;&lt;16)-1L);
	fr /= 1L&lt;&lt;16;
	fr += (l&gt;&gt;16) &amp; ((1L&lt;&lt;16)-1L);
	fr /= 1L&lt;&lt;16;
	fr += (h &amp; (1L&lt;&lt;20)-1L) | (1L&lt;&lt;20);
	fr /= 1L&lt;&lt;21;
	fr = ldexp(fr, exp);
	return snprint(buf, n, "%.18g", fr);
}

int
ieeesftos(char *buf, int n, ulong h)
{
	double fr;
	int exp;

	if (n &lt;= 0)
		return 0;

	if(h &amp; (1L&lt;&lt;31)){
		*buf++ = '-';
		h &amp;= ~(1L&lt;&lt;31);
	}else
		*buf++ = ' ';
	n--;
	if(h == 0)
		return snprint(buf, n, "0.");
	exp = (h&gt;&gt;23) &amp; ((1L&lt;&lt;8)-1L);
	if(exp == 0)
		return snprint(buf, n, "DeN(%.8lux)", h);
	if(exp == ((1L&lt;&lt;8)-1L)){
		if((h&amp;((1L&lt;&lt;23)-1L)) == 0)
			return snprint(buf, n, "Inf");
		else
			return snprint(buf, n, "NaN(%.8lux)", h&amp;((1L&lt;&lt;23)-1L));
	}
	exp -= (1L&lt;&lt;7) - 2L;
	fr = (h &amp; ((1L&lt;&lt;23)-1L)) | (1L&lt;&lt;23);
	fr /= 1L&lt;&lt;24;
	fr = ldexp(fr, exp);
	return snprint(buf, n, "%.9g", fr);
}

int
beieeesftos(char *buf, int n, void *s)
{
	return ieeesftos(buf, n, beswal(*(ulong*)s));
}

int
beieeedftos(char *buf, int n, void *s)
{
	return ieeedftos(buf, n, beswal(*(ulong*)s), beswal(((ulong*)(s))[1]));
}

int
leieeesftos(char *buf, int n, void *s)
{
	return ieeesftos(buf, n, leswal(*(ulong*)s));
}

int
leieeedftos(char *buf, int n, void *s)
{
	return ieeedftos(buf, n, leswal(((ulong*)(s))[1]), leswal(*(ulong*)s));
}

/* packed in 12 bytes, with s[2]==s[3]==0; mantissa starts at s[4]*/
int
beieee80ftos(char *buf, int n, void *s)
{
	uchar *reg = (uchar*)s;
	int i;
	ulong x;
	uchar ieee[8+8];	/* room for slop */
	uchar *p, *q;

	memset(ieee, 0, sizeof(ieee));
	/* sign */
	if(reg[0] &amp; 0x80)
		ieee[0] |= 0x80;

	/* exponent */
	x = ((reg[0]&amp;0x7F)&lt;&lt;8) | reg[1];
	if(x == 0)		/* number is ±0 */
		goto done;
	if(x == 0x7FFF){
		if(memcmp(reg+4, ieee+1, 8) == 0){ /* infinity */
			x = 2047;
		}else{				/* NaN */
			x = 2047;
			ieee[7] = 0x1;		/* make sure */
		}
		ieee[0] |= x&gt;&gt;4;
		ieee[1] |= (x&amp;0xF)&lt;&lt;4;
		goto done;
	}
	x -= 0x3FFF;		/* exponent bias */
	x += 1023;
	if(x &gt;= (1&lt;&lt;11) || ((reg[4]&amp;0x80)==0 &amp;&amp; x!=0))
		return snprint(buf, n, "not in range");
	ieee[0] |= x&gt;&gt;4;
	ieee[1] |= (x&amp;0xF)&lt;&lt;4;

	/* mantissa */
	p = reg+4;
	q = ieee+1;
	for(i=0; i&lt;56; i+=8, p++, q++){	/* move one byte */
		x = (p[0]&amp;0x7F) &lt;&lt; 1;
		if(p[1] &amp; 0x80)
			x |= 1;
		q[0] |= x&gt;&gt;4;
		q[1] |= (x&amp;0xF)&lt;&lt;4;
	}
    done:
	return beieeedftos(buf, n, (void*)ieee);
}

int
leieee80ftos(char *buf, int n, void *s)
{
	int i;
	char *cp;
	char b[12];

	cp = (char*) s;
	for(i=0; i&lt;12; i++)
		b[11-i] = *cp++;
	return beieee80ftos(buf, n, b);
}

int
cisctrace(Map *map, uvlong pc, uvlong sp, uvlong link, Tracer trace)
{
	Symbol s;
	int found, i;
	uvlong opc, moved;

	USED(link);
	i = 0;
	opc = 0;
	while(pc &amp;&amp; opc != pc) {
		moved = pc2sp(pc);
		if (moved == ~0)
			break;
		found = findsym(pc, CTEXT, &amp;s);
		if (!found)
			break;
		if(strcmp(STARTSYM, s.name) == 0 || strcmp(PROFSYM, s.name) == 0)
			break;

		sp += moved;
		opc = pc;
		if (geta(map, sp, &amp;pc) &lt; 0)
			break;
		(*trace)(map, pc, sp, &amp;s);
		sp += mach-&gt;szaddr;	/*assumes address size = stack width*/
		if(++i &gt; 40)
			break;
	}
	return i;
}

int
risctrace(Map *map, uvlong pc, uvlong sp, uvlong link, Tracer trace)
{
	int i;
	Symbol s, f;
	uvlong oldpc;

	i = 0;
	while(findsym(pc, CTEXT, &amp;s)) {
		if(strcmp(STARTSYM, s.name) == 0 || strcmp(PROFSYM, s.name) == 0)
			break;

		if(pc == s.value)	/* at first instruction */
			f.value = 0;
		else if(findlocal(&amp;s, FRAMENAME, &amp;f) == 0)
			break;

		oldpc = pc;
		if(s.type == 'L' || s.type == 'l' || pc &lt;= s.value+mach-&gt;pcquant)
			pc = link;
		else
			if (geta(map, sp, &amp;pc) &lt; 0)
				break;

		if(pc == 0 || (pc == oldpc &amp;&amp; f.value == 0))
			break;

		sp += f.value;
		(*trace)(map, pc-8, sp, &amp;s);

		if(++i &gt; 40)
			break;
	}
	return i;
}

uvlong
ciscframe(Map *map, uvlong addr, uvlong pc, uvlong sp, uvlong link)
{
	Symbol s;
	uvlong moved;

	USED(link);
	for(;;) {
		moved = pc2sp(pc);
		if (moved  == ~0)
			break;
		sp += moved;
		findsym(pc, CTEXT, &amp;s);
		if (addr == s.value)
			return sp;
		if (geta(map, sp, &amp;pc) &lt; 0)
			break;
		sp += mach-&gt;szaddr;	/*assumes sizeof(addr) = stack width*/
	}
	return 0;
}

uvlong
riscframe(Map *map, uvlong addr, uvlong pc, uvlong sp, uvlong link)
{
	Symbol s, f;

	while (findsym(pc, CTEXT, &amp;s)) {
		if(strcmp(STARTSYM, s.name) == 0 || strcmp(PROFSYM, s.name) == 0)
			break;

		if(pc == s.value)	/* at first instruction */
			f.value = 0;
		else
		if(findlocal(&amp;s, FRAMENAME, &amp;f) == 0)
			break;

		sp += f.value;
		if (s.value == addr)
			return sp;

		if (s.type == 'L' || s.type == 'l' || pc-s.value &lt;= mach-&gt;szaddr*2)
			pc = link;
		else
		if (geta(map, sp-f.value, &amp;pc) &lt; 0)
			break;
	}
	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

