<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmach/map.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmach/map.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * file map routines
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;mach.h&gt;

Map *
newmap(Map *map, int n)
{
	int size;

	size = sizeof(Map)+(n-1)*sizeof(struct segment);
	if (map == 0)
		map = malloc(size);
	else
		map = realloc(map, size);
	if (map == 0) {
		werrstr("out of memory: %r");
		return 0;
	}
	memset(map, 0, size);
	map-&gt;nsegs = n;
	return map;
}

int
setmap(Map *map, int fd, uvlong b, uvlong e, vlong f, char *name)
{
	int i;

	if (map == 0)
		return 0;
	for (i = 0; i &lt; map-&gt;nsegs; i++)
		if (!map-&gt;seg[i].inuse)
			break;
	if (i &gt;= map-&gt;nsegs)
		return 0;
	map-&gt;seg[i].b = b;
	map-&gt;seg[i].e = e;
	map-&gt;seg[i].f = f;
	map-&gt;seg[i].inuse = 1;
	map-&gt;seg[i].name = name;
	map-&gt;seg[i].fd = fd;
	return 1;
}

static uvlong
stacktop(int pid)
{
	char buf[64];
	int fd;
	int n;
	char *cp;

	snprint(buf, sizeof(buf), "/proc/%d/segment", pid);
	fd = open(buf, 0);
	if (fd &lt; 0)
		return 0;
	n = read(fd, buf, sizeof(buf)-1);
	close(fd);
	buf[n] = 0;
	if (strncmp(buf, "Stack", 5))
		return 0;
	for (cp = buf+5; *cp &amp;&amp; *cp == ' '; cp++)
		;
	if (!*cp)
		return 0;
	cp = strchr(cp, ' ');
	if (!cp)
		return 0;
	while (*cp &amp;&amp; *cp == ' ')
		cp++;
	if (!*cp)
		return 0;
	return strtoull(cp, 0, 16);
}

Map*
attachproc(int pid, int kflag, int corefd, Fhdr *fp)
{
	char buf[64], *regs;
	int fd;
	Map *map;
	uvlong n;

	map = newmap(0, 4);
	if (!map)
		return 0;
	if(kflag)
		regs = "kregs";
	else
		regs = "regs";
	if (mach-&gt;regsize) {
		sprint(buf, "/proc/%d/%s", pid, regs);
		fd = open(buf, ORDWR);
		if(fd &lt; 0)
			fd = open(buf, OREAD);
		if(fd &lt; 0) {
			free(map);
			return 0;
		}
		setmap(map, fd, 0, mach-&gt;regsize, 0, "regs");
	}
	if (mach-&gt;fpregsize) {
		sprint(buf, "/proc/%d/fpregs", pid);
		fd = open(buf, ORDWR);
		if(fd &lt; 0)
			fd = open(buf, OREAD);
		if(fd &lt; 0) {
			close(map-&gt;seg[0].fd);
			free(map);
			return 0;
		}
		setmap(map, fd, mach-&gt;regsize, mach-&gt;regsize+mach-&gt;fpregsize, 0, "fpregs");
	}
	setmap(map, corefd, fp-&gt;txtaddr, fp-&gt;txtaddr+fp-&gt;txtsz, fp-&gt;txtaddr, "text");
	if(kflag || fp-&gt;dataddr &gt;= mach-&gt;utop) {
		setmap(map, corefd, fp-&gt;dataddr, ~0, fp-&gt;dataddr, "data");
		return map;
	}
	n = stacktop(pid);
	if (n == 0) {
		setmap(map, corefd, fp-&gt;dataddr, mach-&gt;utop, fp-&gt;dataddr, "data");
		return map;
	}
	setmap(map, corefd, fp-&gt;dataddr, n, fp-&gt;dataddr, "data");
	return map;
}
	
int
findseg(Map *map, char *name)
{
	int i;

	if (!map)
		return -1;
	for (i = 0; i &lt; map-&gt;nsegs; i++)
		if (map-&gt;seg[i].inuse &amp;&amp; !strcmp(map-&gt;seg[i].name, name))
			return i;
	return -1;
}

void
unusemap(Map *map, int i)
{
	if (map != 0 &amp;&amp; 0 &lt;= i &amp;&amp; i &lt; map-&gt;nsegs)
		map-&gt;seg[i].inuse = 0;
}

Map*
loadmap(Map *map, int fd, Fhdr *fp)
{
	map = newmap(map, 2);
	if (map == 0)
		return 0;

	map-&gt;seg[0].b = fp-&gt;txtaddr;
	map-&gt;seg[0].e = fp-&gt;txtaddr+fp-&gt;txtsz;
	map-&gt;seg[0].f = fp-&gt;txtoff;
	map-&gt;seg[0].fd = fd;
	map-&gt;seg[0].inuse = 1;
	map-&gt;seg[0].name = "text";
	map-&gt;seg[1].b = fp-&gt;dataddr;
	map-&gt;seg[1].e = fp-&gt;dataddr+fp-&gt;datsz;
	map-&gt;seg[1].f = fp-&gt;datoff;
	map-&gt;seg[1].fd = fd;
	map-&gt;seg[1].inuse = 1;
	map-&gt;seg[1].name = "data";
	return map;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

