<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libmp/port/mpaux.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libmp/port/mpaux.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "os.h"
#include &lt;mp.h&gt;
#include "dat.h"

static mpdigit _mptwodata[1] = { 2 };
static mpint _mptwo =
{
	1,
	1,
	1,
	_mptwodata,
	MPstatic
};
mpint *mptwo = &amp;_mptwo;

static mpdigit _mponedata[1] = { 1 };
static mpint _mpone =
{
	1,
	1,
	1,
	_mponedata,
	MPstatic
};
mpint *mpone = &amp;_mpone;

static mpdigit _mpzerodata[1] = { 0 };
static mpint _mpzero =
{
	1,
	1,
	0,
	_mpzerodata,
	MPstatic
};
mpint *mpzero = &amp;_mpzero;

static int mpmindigits = 33;

// set minimum digit allocation
void
mpsetminbits(int n)
{
	if(n &lt; 0)
		sysfatal("mpsetminbits: n &lt; 0");
	if(n == 0)
		n = 1;
	mpmindigits = DIGITS(n);
}

// allocate an n bit 0'd number 
mpint*
mpnew(int n)
{
	mpint *b;

	if(n &lt; 0)
		sysfatal("mpsetminbits: n &lt; 0");

	b = mallocz(sizeof(mpint), 1);
	setmalloctag(b, getcallerpc(&amp;n));
	if(b == nil)
		sysfatal("mpnew: %r");
	n = DIGITS(n);
	if(n &lt; mpmindigits)
		n = mpmindigits;
	b-&gt;p = (mpdigit*)mallocz(n*Dbytes, 1);
	if(b-&gt;p == nil)
		sysfatal("mpnew: %r");
	b-&gt;size = n;
	b-&gt;sign = 1;

	return b;
}

// guarantee at least n significant bits
void
mpbits(mpint *b, int m)
{
	int n;

	n = DIGITS(m);
	if(b-&gt;size &gt;= n){
		if(b-&gt;top &gt;= n)
			return;
		memset(&amp;b-&gt;p[b-&gt;top], 0, Dbytes*(n - b-&gt;top));
		b-&gt;top = n;
		return;
	}
	b-&gt;p = (mpdigit*)realloc(b-&gt;p, n*Dbytes);
	if(b-&gt;p == nil)
		sysfatal("mpbits: %r");
	memset(&amp;b-&gt;p[b-&gt;top], 0, Dbytes*(n - b-&gt;top));
	b-&gt;size = n;
	b-&gt;top = n;
}

void
mpfree(mpint *b)
{
	if(b == nil)
		return;
	if(b-&gt;flags &amp; MPstatic)
		sysfatal("freeing mp constant");
	memset(b-&gt;p, 0, b-&gt;size*Dbytes);	// information hiding
	free(b-&gt;p);
	free(b);
}

void
mpnorm(mpint *b)
{
	int i;

	for(i = b-&gt;top-1; i &gt;= 0; i--)
		if(b-&gt;p[i] != 0)
			break;
	b-&gt;top = i+1;
	if(b-&gt;top == 0)
		b-&gt;sign = 1;
}

mpint*
mpcopy(mpint *old)
{
	mpint *new;

	new = mpnew(Dbits*old-&gt;size);
	new-&gt;top = old-&gt;top;
	new-&gt;sign = old-&gt;sign;
	memmove(new-&gt;p, old-&gt;p, Dbytes*old-&gt;top);
	return new;
}

void
mpassign(mpint *old, mpint *new)
{
	mpbits(new, Dbits*old-&gt;top);
	new-&gt;sign = old-&gt;sign;
	new-&gt;top = old-&gt;top;
	memmove(new-&gt;p, old-&gt;p, Dbytes*old-&gt;top);
}

// number of significant bits in mantissa
int
mpsignif(mpint *n)
{
	int i, j;
	mpdigit d;

	if(n-&gt;top == 0)
		return 0;
	for(i = n-&gt;top-1; i &gt;= 0; i--){
		d = n-&gt;p[i];
		for(j = Dbits-1; j &gt;= 0; j--){
			if(d &amp; (((mpdigit)1)&lt;&lt;j))
				return i*Dbits + j + 1;
		}
	}
	return 0;
}

// k, where n = 2**k * q for odd q
int
mplowbits0(mpint *n)
{
	int k, bit, digit;
	mpdigit d;

	if(n-&gt;top==0)
		return 0;
	k = 0;
	bit = 0;
	digit = 0;
	d = n-&gt;p[0];
	for(;;){
		if(d &amp; (1&lt;&lt;bit))
			break;
		k++;
		bit++;
		if(bit==Dbits){
			if(++digit &gt;= n-&gt;top)
				return 0;
			d = n-&gt;p[digit];
			bit = 0;
		}
	}
	return k;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

