<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libndb/ndbhash.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libndb/ndbhash.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include "ndb.h"
#include "ndbhf.h"

enum {
	Dptr,	/* pointer to database file */
	Cptr,	/* pointer to first chain entry */
	Cptr1,	/* pointer to second chain entry */
};

/*
 *  generate a hash value for an ascii string (val) given
 *  a hash table length (hlen)
 */
ulong
ndbhash(char *vp, int hlen)
{
	ulong hash;
	uchar *val = (uchar*)vp;

	for(hash = 0; *val; val++)
		hash = (hash*13) + *val-'a';
	return hash % hlen;
}

/*
 *  read a hash file with buffering
 */
static uchar*
hfread(Ndbhf *hf, long off, int len)
{
	if(off &lt; hf-&gt;off || off + len &gt; hf-&gt;off + hf-&gt;len){
		if(seek(hf-&gt;fd, off, 0) &lt; 0
		|| (hf-&gt;len = read(hf-&gt;fd, hf-&gt;buf, sizeof(hf-&gt;buf))) &lt; len){
			hf-&gt;off = -1;
			return 0;
		}
		hf-&gt;off = off;
	}
	return &amp;hf-&gt;buf[off-hf-&gt;off];
}

/*
 *  return an opened hash file if one exists for the
 *  attribute and if it is current vis-a-vis the data
 *  base file
 */
static Ndbhf*
hfopen(Ndb *db, char *attr)
{
	Ndbhf *hf;
	char buf[sizeof(hf-&gt;attr)+sizeof(db-&gt;file)+2];
	uchar *p;
	Dir *d;

	/* try opening the data base if it's closed */
	if(db-&gt;mtime==0 &amp;&amp; ndbreopen(db) &lt; 0)
		return 0;

	/* if the database has changed, throw out hash files and reopen db */
	if((d = dirfstat(Bfildes(&amp;db-&gt;b))) == nil || db-&gt;qid.path != d-&gt;qid.path
	|| db-&gt;qid.vers != d-&gt;qid.vers){
		if(ndbreopen(db) &lt; 0){
			free(d);
			return 0;
		}
	}
	free(d);

	if(db-&gt;nohash)
		return 0;

	/* see if a hash file exists for this attribute */
	for(hf = db-&gt;hf; hf; hf= hf-&gt;next){
		if(strcmp(hf-&gt;attr, attr) == 0)
			return hf;
	}

	/* create a new one */
	hf = (Ndbhf*)malloc(sizeof(Ndbhf));
	if(hf == 0)
		return 0;
	memset(hf, 0, sizeof(Ndbhf));

	/* compare it to the database file */
	strncpy(hf-&gt;attr, attr, sizeof(hf-&gt;attr)-1);
	sprint(buf, "%s.%s", db-&gt;file, hf-&gt;attr);
	hf-&gt;fd = open(buf, OREAD);
	if(hf-&gt;fd &gt;= 0){
		hf-&gt;len = 0;
		hf-&gt;off = 0;
		p = hfread(hf, 0, 2*NDBULLEN);
		if(p){
			hf-&gt;dbmtime = NDBGETUL(p);
			hf-&gt;hlen = NDBGETUL(p+NDBULLEN);
			if(hf-&gt;dbmtime == db-&gt;mtime){
				hf-&gt;next = db-&gt;hf;
				db-&gt;hf = hf;
				return hf;
			}
		}
		close(hf-&gt;fd);
	}

	free(hf);
	return 0;
}

/*
 *  return the first matching entry
 */
Ndbtuple*
ndbsearch(Ndb *db, Ndbs *s, char *attr, char *val)
{
	uchar *p;
	Ndbtuple *t;
	Ndbhf *hf;

	hf = hfopen(db, attr);

	memset(s, 0, sizeof(*s));
	if(_ndbcachesearch(db, s, attr, val, &amp;t) == 0){
		/* found in cache */
		if(t != nil){
			ndbsetmalloctag(t, getcallerpc(&amp;db));
			return t;	/* answer from this file */
		}
		if(db-&gt;next == nil)
			return nil;
		t = ndbsearch(db-&gt;next, s, attr, val);
		ndbsetmalloctag(t, getcallerpc(&amp;db));
		return t;
	}

	s-&gt;db = db;
	s-&gt;hf = hf;
	if(s-&gt;hf){
		s-&gt;ptr = ndbhash(val, s-&gt;hf-&gt;hlen)*NDBPLEN;
		p = hfread(s-&gt;hf, s-&gt;ptr+NDBHLEN, NDBPLEN);
		if(p == 0){
			t = _ndbcacheadd(db, s, attr, val, nil);
			ndbsetmalloctag(t, getcallerpc(&amp;db));
			return t;
		}
		s-&gt;ptr = NDBGETP(p);
		s-&gt;type = Cptr1;
	} else if(db-&gt;length &gt; 128*1024){
		print("Missing or out of date hash file %s.%s.\n", db-&gt;file, attr);
		syslog(0, "ndb", "Missing or out of date hash file %s.%s.", db-&gt;file, attr);

		/* advance search to next db file */
		s-&gt;ptr = NDBNAP;
		_ndbcacheadd(db, s, attr, val, nil);
		if(db-&gt;next == 0)
			return nil;
		t = ndbsearch(db-&gt;next, s, attr, val);
		ndbsetmalloctag(t, getcallerpc(&amp;db));
		return t;
	} else {
		s-&gt;ptr = 0;
		s-&gt;type = Dptr;
	}
	t = ndbsnext(s, attr, val);
	_ndbcacheadd(db, s, attr, val, (t != nil &amp;&amp; s-&gt;db == db)?t:nil);
	ndbsetmalloctag(t, getcallerpc(&amp;db));
	return t;
}

static Ndbtuple*
match(Ndbtuple *t, char *attr, char *val)
{
	Ndbtuple *nt;

	for(nt = t; nt; nt = nt-&gt;entry)
		if(strcmp(attr, nt-&gt;attr) == 0
		&amp;&amp; strcmp(val, nt-&gt;val) == 0)
			return nt;
	return 0;
}

/*
 *  return the next matching entry in the hash chain
 */
Ndbtuple*
ndbsnext(Ndbs *s, char *attr, char *val)
{
	Ndbtuple *t;
	Ndb *db;
	uchar *p;

	db = s-&gt;db;
	if(s-&gt;ptr == NDBNAP)
		goto nextfile;

	for(;;){
		if(s-&gt;type == Dptr){
			if(Bseek(&amp;db-&gt;b, s-&gt;ptr, 0) &lt; 0)
				break;
			t = ndbparse(db);
			s-&gt;ptr = Boffset(&amp;db-&gt;b);
			if(t == 0)
				break;
			if(s-&gt;t = match(t, attr, val)){
				ndbsetmalloctag(t, getcallerpc(&amp;s));
				return t;
			}
			ndbfree(t);
		} else if(s-&gt;type == Cptr){
			if(Bseek(&amp;db-&gt;b, s-&gt;ptr, 0) &lt; 0)
				break; 
			s-&gt;ptr = s-&gt;ptr1;
			s-&gt;type = Cptr1;
			t = ndbparse(db);
			if(t == 0)
				break;
			if(s-&gt;t = match(t, attr, val)){
				ndbsetmalloctag(t, getcallerpc(&amp;s));
				return t;
			}
			ndbfree(t);
		} else if(s-&gt;type == Cptr1){
			if(s-&gt;ptr &amp; NDBCHAIN){	/* hash chain continuation */
				s-&gt;ptr &amp;= ~NDBCHAIN;
				p = hfread(s-&gt;hf, s-&gt;ptr+NDBHLEN, 2*NDBPLEN);
				if(p == 0)
					break;
				s-&gt;ptr = NDBGETP(p);
				s-&gt;ptr1 = NDBGETP(p+NDBPLEN);
				s-&gt;type = Cptr;
			} else {		/* end of hash chain */
				if(Bseek(&amp;db-&gt;b, s-&gt;ptr, 0) &lt; 0)
					break; 
				s-&gt;ptr = NDBNAP;
				t = ndbparse(db);
				if(t == 0)
					break;
				if(s-&gt;t = match(t, attr, val)){
					ndbsetmalloctag(t, getcallerpc(&amp;s));
					return t;
				}
				ndbfree(t);
				break;
			}
		}
	}

nextfile:

	/* nothing left to search? */
	s-&gt;ptr = NDBNAP;
	if(db-&gt;next == 0)
		return 0;

	/* advance search to next db file */
	t = ndbsearch(db-&gt;next, s, attr, val);
	ndbsetmalloctag(t, getcallerpc(&amp;s));
	return t;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

