<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/liboventi/packet.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/liboventi/packet.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;oventi.h&gt;
#include "packet.h"

static Frag *fragAlloc(Packet*, int n, int pos, Frag *next);
static Frag *fragDup(Packet*, Frag*);
static void fragFree(Frag*);

static Mem *memAlloc(int, int);
static void memFree(Mem*);
static int memHead(Mem *m, uchar *rp, int n);
static int memTail(Mem *m, uchar *wp, int n);

static char EPacketSize[] = "bad packet size";
static char EPacketOffset[] = "bad packet offset";
static char EBadSize[] = "bad size";

static struct {
	Lock lk;
	Packet *packet;
	int npacket;
	Frag *frag;
	int nfrag;
	Mem *bigMem;
	int nbigMem;
	Mem *smallMem;
	int nsmallMem;
} freeList;

#define FRAGSIZE(f) ((f)-&gt;wp - (f)-&gt;rp)
#define FRAGASIZE(f) ((f)-&gt;mem-&gt;ep - (f)-&gt;mem-&gt;bp)

#define NOTFREE(p) assert((p)-&gt;size&gt;=0)

Packet *
packetAlloc(void)
{
	Packet *p;
	
	lock(&amp;freeList.lk);
	p = freeList.packet;
	if(p != nil)
		freeList.packet = p-&gt;next;
	else
		freeList.npacket++;
	unlock(&amp;freeList.lk);

	if(p == nil)
		p = vtMemBrk(sizeof(Packet));
	else
		assert(p-&gt;size == -1);
	p-&gt;size = 0;
	p-&gt;asize = 0;
	p-&gt;first = nil;
	p-&gt;last = nil;
	p-&gt;next = nil;

	return p;
}

void
packetFree(Packet *p)
{
	Frag *f, *ff;

if(0)fprint(2, "packetFree %p\n", p);

	NOTFREE(p);
	p-&gt;size = -1;

	for(f=p-&gt;first; f!=nil; f=ff) {
		ff = f-&gt;next;
		fragFree(f);
	}
	p-&gt;first = nil;
	p-&gt;last = nil;

	lock(&amp;freeList.lk);
	p-&gt;next = freeList.packet;
	freeList.packet = p;
	unlock(&amp;freeList.lk);
}

Packet *
packetDup(Packet *p, int offset, int n)
{	
	Frag *f, *ff;
	Packet *pp;

	NOTFREE(p);
	if(offset &lt; 0 || n &lt; 0 || offset+n &gt; p-&gt;size) {
		vtSetError(EBadSize);
		return nil;
	}

	pp = packetAlloc();
	if(n == 0)
		return pp;

	pp-&gt;size = n;

	/* skip offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);
	
	/* first frag */
	ff = fragDup(pp, f);
	ff-&gt;rp += offset;
	pp-&gt;first = ff;
	n -= FRAGSIZE(ff);
	pp-&gt;asize += FRAGASIZE(ff);

	/* the remaining */
	while(n &gt; 0) {
		f = f-&gt;next;
		ff-&gt;next = fragDup(pp, f);
		ff = ff-&gt;next;
		n -= FRAGSIZE(ff);
		pp-&gt;asize += FRAGASIZE(ff);
	}
	
	/* fix up last frag: note n &lt;= 0 */
	ff-&gt;wp += n;
	ff-&gt;next = nil;
	pp-&gt;last = ff;

	return pp;
}

Packet *
packetSplit(Packet *p, int n)
{
	Packet *pp;
	Frag *f, *ff;

	NOTFREE(p);
	if(n &lt; 0 || n &gt; p-&gt;size) {
		vtSetError(EPacketSize);
		return nil;
	}

	pp = packetAlloc();
	if(n == 0)
		return pp;

	pp-&gt;size = n;
	p-&gt;size -= n;
	ff = nil;
	for(f=p-&gt;first; n &gt; 0 &amp;&amp; n &gt;= FRAGSIZE(f); f=f-&gt;next) {
		n -= FRAGSIZE(f);
		p-&gt;asize -= FRAGASIZE(f);
		pp-&gt;asize += FRAGASIZE(f);
		ff = f;
	}

	/* split shared frag */
	if(n &gt; 0) {
		ff = f;
		f = fragDup(pp, ff);
		pp-&gt;asize += FRAGASIZE(ff);
		ff-&gt;next = nil;
		ff-&gt;wp = ff-&gt;rp + n;
		f-&gt;rp += n;
	}

	pp-&gt;first = p-&gt;first;
	pp-&gt;last = ff;
	p-&gt;first = f;
	return pp;
}

int
packetConsume(Packet *p, uchar *buf, int n)
{
	NOTFREE(p);
	if(buf &amp;&amp; !packetCopy(p, buf, 0, n))
		return 0;
	return packetTrim(p, n, p-&gt;size-n);
}

int
packetTrim(Packet *p, int offset, int n)
{
	Frag *f, *ff;

	NOTFREE(p);
	if(offset &lt; 0 || offset &gt; p-&gt;size) {
		vtSetError(EPacketOffset);
		return 0;
	}

	if(n &lt; 0 || offset + n &gt; p-&gt;size) {
		vtSetError(EPacketOffset);
		return 0;
	}

	p-&gt;size = n;

	/* easy case */
	if(n == 0) {
		for(f=p-&gt;first; f != nil; f=ff) {
			ff = f-&gt;next;
			fragFree(f);
		}
		p-&gt;first = p-&gt;last = nil;
		p-&gt;asize = 0;
		return 1;
	}
	
	/* free before offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=ff) {
		p-&gt;asize -= FRAGASIZE(f);
		offset -= FRAGSIZE(f);
		ff = f-&gt;next;
		fragFree(f);
	}

	/* adjust frag */
	f-&gt;rp += offset;
	p-&gt;first = f;

	/* skip middle */
	for(; n &gt; 0 &amp;&amp; n &gt; FRAGSIZE(f); f=f-&gt;next)
		n -= FRAGSIZE(f);

	/* adjust end */
	f-&gt;wp = f-&gt;rp + n;
	p-&gt;last = f;
	ff = f-&gt;next;
	f-&gt;next = nil;

	/* free after */
	for(f=ff; f != nil; f=ff) {
		p-&gt;asize -= FRAGASIZE(f);
		ff = f-&gt;next;
		fragFree(f);
	}
	return 1;
}

uchar *
packetHeader(Packet *p, int n)
{
	Frag *f;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0 || n &gt; MaxFragSize) {
		vtSetError(EPacketSize);
		return 0;
	}

	p-&gt;size += n;
	
	/* try and fix in current frag */
	f = p-&gt;first;
	if(f != nil) {
		m = f-&gt;mem;
		if(n &lt;= f-&gt;rp - m-&gt;bp)
		if(m-&gt;ref == 1 || memHead(m, f-&gt;rp, n)) {
			f-&gt;rp -= n;
			return f-&gt;rp;
		}
	}

	/* add frag to front */
	f = fragAlloc(p, n, PEnd, p-&gt;first);
	p-&gt;asize += FRAGASIZE(f);
	if(p-&gt;first == nil)
		p-&gt;last = f;
	p-&gt;first = f;
	return f-&gt;rp;
}

uchar *
packetTrailer(Packet *p, int n)
{
	Mem *m;
	Frag *f;

	NOTFREE(p);
	if(n &lt;= 0 || n &gt; MaxFragSize) {
		vtSetError(EPacketSize);
		return 0;
	}

	p-&gt;size += n;
	
	/* try and fix in current frag */
	if(p-&gt;first != nil) {
		f = p-&gt;last;
		m = f-&gt;mem;
		if(n &lt;= m-&gt;ep - f-&gt;wp)
		if(m-&gt;ref == 1 || memTail(m, f-&gt;wp, n)) {
			f-&gt;wp += n;
			return f-&gt;wp - n;
		}
	}

	/* add frag to end */
	f = fragAlloc(p, n, (p-&gt;first == nil)?PMiddle:PFront, nil);
	p-&gt;asize += FRAGASIZE(f);
	if(p-&gt;first == nil)
		p-&gt;first = f;
	else
		p-&gt;last-&gt;next = f;
	p-&gt;last = f;
	return f-&gt;rp;
}

int
packetPrefix(Packet *p, uchar *buf, int n)
{
	Frag *f;
	int nn;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0)
		return 1;

	p-&gt;size += n;

	/* try and fix in current frag */
	f = p-&gt;first;
	if(f != nil) {
		m = f-&gt;mem;
		nn = f-&gt;rp - m-&gt;bp;
		if(nn &gt; n)
			nn = n;
		if(m-&gt;ref == 1 || memHead(m, f-&gt;rp, nn)) {
			f-&gt;rp -= nn;
			n -= nn;
			memmove(f-&gt;rp, buf+n, nn);
		}
	}

	while(n &gt; 0) {
		nn = n;
		if(nn &gt; MaxFragSize)
			nn = MaxFragSize;
		f = fragAlloc(p, nn, PEnd, p-&gt;first);	
		p-&gt;asize += FRAGASIZE(f);
		if(p-&gt;first == nil)
			p-&gt;last = f;
		p-&gt;first = f;
		n -= nn;
		memmove(f-&gt;rp, buf+n, nn);
	}
	return 1;
}

int
packetAppend(Packet *p, uchar *buf, int n)
{
	Frag *f;
	int nn;
	Mem *m;

	NOTFREE(p);
	if(n &lt;= 0)
		return 1;

	p-&gt;size += n;
	/* try and fix in current frag */
	if(p-&gt;first != nil) {
		f = p-&gt;last;
		m = f-&gt;mem;
		nn = m-&gt;ep - f-&gt;wp;
		if(nn &gt; n)
			nn = n;
		if(m-&gt;ref == 1 || memTail(m, f-&gt;wp, nn)) {
			memmove(f-&gt;wp, buf, nn);
			f-&gt;wp += nn;
			buf += nn;
			n -= nn;
		}
	}
	
	while(n &gt; 0) {
		nn = n;
		if(nn &gt; MaxFragSize)
			nn = MaxFragSize;
		f = fragAlloc(p, nn, (p-&gt;first == nil)?PMiddle:PFront, nil);
		p-&gt;asize += FRAGASIZE(f);
		if(p-&gt;first == nil)
			p-&gt;first = f;
		else
			p-&gt;last-&gt;next = f;
		p-&gt;last = f;
		memmove(f-&gt;rp, buf, nn);
		buf += nn;
		n -= nn;
	}
	return 1;
}

int
packetConcat(Packet *p, Packet *pp)
{
	NOTFREE(p);
	NOTFREE(pp);
	if(pp-&gt;size == 0)
		return 1;
	p-&gt;size += pp-&gt;size;
	p-&gt;asize += pp-&gt;asize;

	if(p-&gt;first != nil)
		p-&gt;last-&gt;next = pp-&gt;first;
	else
		p-&gt;first = pp-&gt;first;
	p-&gt;last = pp-&gt;last;
	pp-&gt;size = 0;
	pp-&gt;asize = 0;
	pp-&gt;first = nil;
	pp-&gt;last = nil;
	return 1;
}

uchar *
packetPeek(Packet *p, uchar *buf, int offset, int n)
{
	Frag *f;
	int nn;
	uchar *b;

	NOTFREE(p);
	if(n == 0)
		return buf;

	if(offset &lt; 0 || offset &gt;= p-&gt;size) {
		vtSetError(EPacketOffset);
		return 0;
	}

	if(n &lt; 0 || offset + n &gt; p-&gt;size) {
		vtSetError(EPacketSize);
		return 0;
	}
	
	/* skip up to offset */
	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);

	/* easy case */
	if(offset + n &lt;= FRAGSIZE(f))
		return f-&gt;rp + offset;

	for(b=buf; n&gt;0; n -= nn) {
		nn = FRAGSIZE(f) - offset;
		if(nn &gt; n)
			nn = n;
		memmove(b, f-&gt;rp+offset, nn);
		offset = 0;
		f = f-&gt;next;
		b += nn;
	}

	return buf;
}

int
packetCopy(Packet *p, uchar *buf, int offset, int n)
{
	uchar *b;

	NOTFREE(p);
	b = packetPeek(p, buf, offset, n);
	if(b == nil)
		return 0;
	if(b != buf)
		memmove(buf, b, n);
	return 1;
}

int
packetFragments(Packet *p, IOchunk *io, int nio, int offset)
{
	Frag *f;
	int size;
	IOchunk *eio;

	NOTFREE(p);
	if(p-&gt;size == 0 || nio &lt;= 0)
		return 0;
	
	if(offset &lt; 0 || offset &gt; p-&gt;size) {
		vtSetError(EPacketOffset);
		return -1;
	}

	for(f=p-&gt;first; offset &gt;= FRAGSIZE(f); f=f-&gt;next)
		offset -= FRAGSIZE(f);

	size = 0;
	eio = io + nio;
	for(; f != nil &amp;&amp; io &lt; eio; f=f-&gt;next) {
		io-&gt;addr = f-&gt;rp + offset;
		io-&gt;len = f-&gt;wp - (f-&gt;rp + offset);	
		offset = 0;
		size += io-&gt;len;
		io++;
	}

	return size;
}

void
packetStats(void)
{
	Packet *p;
	Frag *f;
	Mem *m;

	int np, nf, nsm, nbm;

	lock(&amp;freeList.lk);
	np = 0;
	for(p=freeList.packet; p; p=p-&gt;next)
		np++;
	nf = 0;
	for(f=freeList.frag; f; f=f-&gt;next)
		nf++;
	nsm = 0;
	for(m=freeList.smallMem; m; m=m-&gt;next)
		nsm++;
	nbm = 0;
	for(m=freeList.bigMem; m; m=m-&gt;next)
		nbm++;
	
	fprint(2, "packet: %d/%d frag: %d/%d small mem: %d/%d big mem: %d/%d\n",
		np, freeList.npacket,
		nf, freeList.nfrag,
		nsm, freeList.nsmallMem,
		nbm, freeList.nbigMem);

	unlock(&amp;freeList.lk);
}


int
packetSize(Packet *p)
{
	NOTFREE(p);
	if(0) {
		Frag *f;
		int size = 0;
	
		for(f=p-&gt;first; f; f=f-&gt;next)
			size += FRAGSIZE(f);
		if(size != p-&gt;size)
			fprint(2, "packetSize %d %d\n", size, p-&gt;size);
		assert(size == p-&gt;size);
	}
	return p-&gt;size;
}

int
packetAllocatedSize(Packet *p)
{
	NOTFREE(p);
	if(0) {
		Frag *f;
		int asize = 0;
	
		for(f=p-&gt;first; f; f=f-&gt;next)
			asize += FRAGASIZE(f);
		if(asize != p-&gt;asize)
			fprint(2, "packetAllocatedSize %d %d\n", asize, p-&gt;asize);
		assert(asize == p-&gt;asize);
	}
	return p-&gt;asize;
}

void
packetSha1(Packet *p, uchar sha1[VtScoreSize])
{
	Frag *f;
	VtSha1 *s;
	int size;

	NOTFREE(p);
	s = vtSha1Alloc();
	size = p-&gt;size;
	for(f=p-&gt;first; f; f=f-&gt;next) {
		vtSha1Update(s, f-&gt;rp, FRAGSIZE(f));
		size -= FRAGSIZE(f);
	}
	assert(size == 0);
	vtSha1Final(s, sha1);
	vtSha1Free(s);
}

int
packetCmp(Packet *pkt0, Packet *pkt1)
{
	Frag *f0, *f1;
	int n0, n1, x;

	NOTFREE(pkt0);
	NOTFREE(pkt1);
	f0 = pkt0-&gt;first;
	f1 = pkt1-&gt;first;

	if(f0 == nil)
		return (f1 == nil)?0:-1;
	if(f1 == nil)
		return 1;
	n0 = FRAGSIZE(f0);
	n1 = FRAGSIZE(f1);

	for(;;) {
		if(n0 &lt; n1) {
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n0);
			if(x != 0)
				return x;
			n1 -= n0;
			f0 = f0-&gt;next;
			if(f0 == nil)
				return -1;
			n0 = FRAGSIZE(f0);
		} else if (n0 &gt; n1) {
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n1);
			if(x != 0)
				return x;
			n0 -= n1;
			f1 = f1-&gt;next;
			if(f1 == nil)
				return 1;
			n1 = FRAGSIZE(f1);
		} else { /* n0 == n1 */
			x = memcmp(f0-&gt;wp - n0, f1-&gt;wp - n1, n0);
			if(x != 0)
				return x;
			f0 = f0-&gt;next;
			f1 = f1-&gt;next;
			if(f0 == nil)
				return (f1 == nil)?0:-1;
			if(f1 == nil)
				return 1;
			n0 = FRAGSIZE(f0);
			n1 = FRAGSIZE(f1);
		}
	}
}
	

static Frag *
fragAlloc(Packet *p, int n, int pos, Frag *next)
{
	Frag *f, *ef;
	Mem *m;

	/* look for local frag */
	f = &amp;p-&gt;local[0];
	ef = &amp;p-&gt;local[NLocalFrag];
	for(;f&lt;ef; f++) {
		if(f-&gt;state == FragLocalFree) {
			f-&gt;state = FragLocalAlloc;
			goto Found;
		}
	}
	lock(&amp;freeList.lk);	
	f = freeList.frag;
	if(f != nil)
		freeList.frag = f-&gt;next;
	else
		freeList.nfrag++;
	unlock(&amp;freeList.lk);

	if(f == nil) {
		f = vtMemBrk(sizeof(Frag));
		f-&gt;state = FragGlobal;
	}

Found:
	if(n == 0)
		return f;

	if(pos == PEnd &amp;&amp; next == nil)
		pos = PMiddle;
	m = memAlloc(n, pos);
	f-&gt;mem = m;
	f-&gt;rp = m-&gt;rp;
	f-&gt;wp = m-&gt;wp;
	f-&gt;next = next;

	return f;
}

static Frag *
fragDup(Packet *p, Frag *f)
{
	Frag *ff;
	Mem *m;

	m = f-&gt;mem;	

	/*
	 * m-&gt;rp &amp;&amp; m-&gt;wp can be out of date when ref == 1
	 * also, potentially reclaims space from previous frags
	 */
	if(m-&gt;ref == 1) {
		m-&gt;rp = f-&gt;rp;
		m-&gt;wp = f-&gt;wp;
	}

	ff = fragAlloc(p, 0, 0, nil);
	*ff = *f;
	lock(&amp;m-&gt;lk);
	m-&gt;ref++;
	unlock(&amp;m-&gt;lk);
	return ff;
}


static void
fragFree(Frag *f)
{
	memFree(f-&gt;mem);

	if(f-&gt;state == FragLocalAlloc) {
		f-&gt;state = FragLocalFree;
		return;
	}

	lock(&amp;freeList.lk);
	f-&gt;next = freeList.frag;
	freeList.frag = f;
	unlock(&amp;freeList.lk);	
}

static Mem *
memAlloc(int n, int pos)
{
	Mem *m;
	int nn;

	if(n &lt; 0 || n &gt; MaxFragSize) {
		vtSetError(EPacketSize);
		return 0;
	}
	if(n &lt;= SmallMemSize) {
		lock(&amp;freeList.lk);
		m = freeList.smallMem;
		if(m != nil)
			freeList.smallMem = m-&gt;next;
		else
			freeList.nsmallMem++;
		unlock(&amp;freeList.lk);
		nn = SmallMemSize;
	} else {
		lock(&amp;freeList.lk);
		m = freeList.bigMem;
		if(m != nil)
			freeList.bigMem = m-&gt;next;
		else
			freeList.nbigMem++;
		unlock(&amp;freeList.lk);
		nn = BigMemSize;
	}

	if(m == nil) {
		m = vtMemBrk(sizeof(Mem));
		m-&gt;bp = vtMemBrk(nn);
		m-&gt;ep = m-&gt;bp + nn;
	}
	assert(m-&gt;ref == 0);	
	m-&gt;ref = 1;

	switch(pos) {
	default:
		assert(0);
	case PFront:
		m-&gt;rp = m-&gt;bp;
		break;
	case PMiddle:
		/* leave a little bit at end */
		m-&gt;rp = m-&gt;ep - n - 32;
		break;
	case PEnd:
		m-&gt;rp = m-&gt;ep - n;
		break; 
	}
	/* check we did not blow it */
	if(m-&gt;rp &lt; m-&gt;bp)
		m-&gt;rp = m-&gt;bp;
	m-&gt;wp = m-&gt;rp + n;
	assert(m-&gt;rp &gt;= m-&gt;bp &amp;&amp; m-&gt;wp &lt;= m-&gt;ep);
	return m;
}

static void
memFree(Mem *m)
{
	lock(&amp;m-&gt;lk);
	m-&gt;ref--;
	if(m-&gt;ref &gt; 0) {
		unlock(&amp;m-&gt;lk);
		return;
	}
	unlock(&amp;m-&gt;lk);
	assert(m-&gt;ref == 0);

	switch(m-&gt;ep - m-&gt;bp) {
	default:
		assert(0);
	case SmallMemSize:
		lock(&amp;freeList.lk);
		m-&gt;next = freeList.smallMem;
		freeList.smallMem = m;
		unlock(&amp;freeList.lk);
		break;
	case BigMemSize:
		lock(&amp;freeList.lk);
		m-&gt;next = freeList.bigMem;
		freeList.bigMem = m;
		unlock(&amp;freeList.lk);
		break;
	}
}

static int
memHead(Mem *m, uchar *rp, int n)
{
	lock(&amp;m-&gt;lk);
	if(m-&gt;rp != rp) {
		unlock(&amp;m-&gt;lk);
		return 0;
	}
	m-&gt;rp -= n;
	unlock(&amp;m-&gt;lk);
	return 1;
}

static int
memTail(Mem *m, uchar *wp, int n)
{
	lock(&amp;m-&gt;lk);
	if(m-&gt;wp != wp) {
		unlock(&amp;m-&gt;lk);
		return 0;
	}
	m-&gt;wp += n;
	unlock(&amp;m-&gt;lk);
	return 1;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

