<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/liboventi/rpc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/liboventi/rpc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;oventi.h&gt;
#include "session.h"

struct {
	int version;
	char *s;
} vtVersions[] = {
	VtVersion02, "02",
	0, 0,
};

static char EBigString[] = "string too long";
static char EBigPacket[] = "packet too long";
static char ENullString[] = "missing string";
static char EBadVersion[] = "bad format in version string";

static Packet *vtRPC(VtSession *z, int op, Packet *p);


VtSession *
vtAlloc(void)
{
	VtSession *z;

	z = vtMemAllocZ(sizeof(VtSession));
	z-&gt;lk = vtLockAlloc();
//	z-&gt;inHash = vtSha1Alloc();
	z-&gt;inLock = vtLockAlloc();
	z-&gt;part = packetAlloc();
//	z-&gt;outHash = vtSha1Alloc();
	z-&gt;outLock = vtLockAlloc();
	z-&gt;fd = -1;
	z-&gt;uid = vtStrDup("anonymous");
	z-&gt;sid = vtStrDup("anonymous");
	return z;
}

void
vtReset(VtSession *z)
{
	vtLock(z-&gt;lk);
	z-&gt;cstate = VtStateAlloc;
	if(z-&gt;fd &gt;= 0){
		vtFdClose(z-&gt;fd);
		z-&gt;fd = -1;
	}
	vtUnlock(z-&gt;lk);
}

int
vtConnected(VtSession *z)
{
	return z-&gt;cstate == VtStateConnected;
}

void
vtDisconnect(VtSession *z, int error)
{
	Packet *p;
	uchar *b;

vtDebug(z, "vtDisconnect\n");
	vtLock(z-&gt;lk);
	if(z-&gt;cstate == VtStateConnected &amp;&amp; !error &amp;&amp; z-&gt;vtbl == nil) {
		/* clean shutdown */
		p = packetAlloc();
		b = packetHeader(p, 2);
		b[0] = VtQGoodbye;
		b[1] = 0;
		vtSendPacket(z, p);
	}
	if(z-&gt;fd &gt;= 0)
		vtFdClose(z-&gt;fd);
	z-&gt;fd = -1;
	z-&gt;cstate = VtStateClosed;
	vtUnlock(z-&gt;lk);
}

void
vtClose(VtSession *z)
{
	vtDisconnect(z, 0);
}

void
vtFree(VtSession *z)
{
	if(z == nil)
		return;
	vtLockFree(z-&gt;lk);
	vtSha1Free(z-&gt;inHash);
	vtLockFree(z-&gt;inLock);
	packetFree(z-&gt;part);
	vtSha1Free(z-&gt;outHash);
	vtLockFree(z-&gt;outLock);
	vtMemFree(z-&gt;uid);
	vtMemFree(z-&gt;sid);
	vtMemFree(z-&gt;vtbl);

	memset(z, 0, sizeof(VtSession));
	z-&gt;fd = -1;

	vtMemFree(z);
}

char *
vtGetUid(VtSession *s)
{
	return s-&gt;uid;
}

char *
vtGetSid(VtSession *z)
{
	return z-&gt;sid;
}

int
vtSetDebug(VtSession *z, int debug)
{
	int old;
	vtLock(z-&gt;lk);
	old = z-&gt;debug;
	z-&gt;debug = debug;
	vtUnlock(z-&gt;lk);
	return old;
}

int
vtSetFd(VtSession *z, int fd)
{
	vtLock(z-&gt;lk);
	if(z-&gt;cstate != VtStateAlloc) {
		vtSetError("bad state");
		vtUnlock(z-&gt;lk);
		return 0;
	}
	if(z-&gt;fd &gt;= 0)
		vtFdClose(z-&gt;fd);
	z-&gt;fd = fd;
	vtUnlock(z-&gt;lk);
	return 1;
}

int
vtGetFd(VtSession *z)
{
	return z-&gt;fd;
}

int
vtSetCryptoStrength(VtSession *z, int c)
{
	if(z-&gt;cstate != VtStateAlloc) {
		vtSetError("bad state");
		return 0;
	}
	if(c != VtCryptoStrengthNone) {
		vtSetError("not supported yet");
		return 0;
	}
	return 1;
}

int
vtGetCryptoStrength(VtSession *s)
{
	return s-&gt;cryptoStrength;
}

int
vtSetCompression(VtSession *z, int fd)
{
	vtLock(z-&gt;lk);
	if(z-&gt;cstate != VtStateAlloc) {
		vtSetError("bad state");
		vtUnlock(z-&gt;lk);
		return 0;
	}
	z-&gt;fd = fd;
	vtUnlock(z-&gt;lk);
	return 1;
}

int
vtGetCompression(VtSession *s)
{
	return s-&gt;compression;
}

int
vtGetCrypto(VtSession *s)
{
	return s-&gt;crypto;
}

int
vtGetCodec(VtSession *s)
{
	return s-&gt;codec;
}

char *
vtGetVersion(VtSession *z)
{
	int v, i;
	
	v = z-&gt;version;
	if(v == 0)
		return "unknown";
	for(i=0; vtVersions[i].version; i++)
		if(vtVersions[i].version == v)
			return vtVersions[i].s;
	assert(0);
	return 0;
}

/* hold z-&gt;inLock */
static int
vtVersionRead(VtSession *z, char *prefix, int *ret)
{
	char c;
	char buf[VtMaxStringSize];
	char *q, *p, *pp;
	int i;

	q = prefix;
	p = buf;
	for(;;) {
		if(p &gt;= buf + sizeof(buf)) {
			vtSetError(EBadVersion);
			return 0;
		}
		if(!vtFdReadFully(z-&gt;fd, (uchar*)&amp;c, 1))
			return 0;
		if(z-&gt;inHash)
			vtSha1Update(z-&gt;inHash, (uchar*)&amp;c, 1);
		if(c == '\n') {
			*p = 0;
			break;
		}
		if(c &lt; ' ' || *q &amp;&amp; c != *q) {
			vtSetError(EBadVersion);
			return 0;
		}
		*p++ = c;
		if(*q)
			q++;
	}
		
	vtDebug(z, "version string in: %s\n", buf);

	p = buf + strlen(prefix);
	for(;;) {
		for(pp=p; *pp &amp;&amp; *pp != ':'  &amp;&amp; *pp != '-'; pp++)
			;
		for(i=0; vtVersions[i].version; i++) {
			if(strlen(vtVersions[i].s) != pp-p)
				continue;
			if(memcmp(vtVersions[i].s, p, pp-p) == 0) {
				*ret = vtVersions[i].version;
				return 1;
			}
		}
		p = pp;
		if(*p != ':')
			return 0;
		p++;
	}	
}

Packet*
vtRecvPacket(VtSession *z)
{
	uchar buf[10], *b;
	int n;
	Packet *p;
	int size, len;

	if(z-&gt;cstate != VtStateConnected) {
		vtSetError("session not connected");
		return 0;
	}

	vtLock(z-&gt;inLock);
	p = z-&gt;part;
	/* get enough for head size */
	size = packetSize(p);
	while(size &lt; 2) {
		b = packetTrailer(p, MaxFragSize);
		assert(b != nil);
		n = vtFdRead(z-&gt;fd, b, MaxFragSize);
		if(n &lt;= 0)
			goto Err;
		size += n;
		packetTrim(p, 0, size);
	}

	if(!packetConsume(p, buf, 2))
		goto Err;
	len = (buf[0] &lt;&lt; 8) | buf[1];
	size -= 2;

	while(size &lt; len) {
		n = len - size;
		if(n &gt; MaxFragSize)
			n = MaxFragSize;
		b = packetTrailer(p, n);
		if(!vtFdReadFully(z-&gt;fd, b, n))
			goto Err;
		size += n;
	}
	p = packetSplit(p, len);
	vtUnlock(z-&gt;inLock);
	return p;
Err:	
	vtUnlock(z-&gt;inLock);
	return nil;	
}

int
vtSendPacket(VtSession *z, Packet *p)
{
	IOchunk ioc;
	int n;
	uchar buf[2];
	
	/* add framing */
	n = packetSize(p);
	if(n &gt;= (1&lt;&lt;16)) {
		vtSetError(EBigPacket);
		packetFree(p);
		return 0;
	}
	buf[0] = n&gt;&gt;8;
	buf[1] = n;
	packetPrefix(p, buf, 2);

	for(;;) {
		n = packetFragments(p, &amp;ioc, 1, 0);
		if(n == 0)
			break;
		if(!vtFdWrite(z-&gt;fd, ioc.addr, ioc.len)) {
			packetFree(p);
			return 0;
		}
		packetConsume(p, nil, n);
	}
	packetFree(p);
	return 1;
}


int
vtGetString(Packet *p, char **ret)
{
	uchar buf[2];
	int n;
	char *s;

	if(!packetConsume(p, buf, 2))
		return 0;
	n = (buf[0]&lt;&lt;8) + buf[1];
	if(n &gt; VtMaxStringSize) {
		vtSetError(EBigString);
		return 0;
	}
	s = vtMemAlloc(n+1);
	setmalloctag(s, getcallerpc(&amp;p));
	if(!packetConsume(p, (uchar*)s, n)) {
		vtMemFree(s);
		return 0;
	}
	s[n] = 0;
	*ret = s;
	return 1;
}

int
vtAddString(Packet *p, char *s)
{
	uchar buf[2];
	int n;

	if(s == nil) {
		vtSetError(ENullString);
		return 0;
	}
	n = strlen(s);
	if(n &gt; VtMaxStringSize) {
		vtSetError(EBigString);
		return 0;
	}
	buf[0] = n&gt;&gt;8;
	buf[1] = n;
	packetAppend(p, buf, 2);
	packetAppend(p, (uchar*)s, n);
	return 1;
}

int
vtConnect(VtSession *z, char *password)
{
	char buf[VtMaxStringSize], *p, *ep, *prefix;
	int i;

	USED(password);
	vtLock(z-&gt;lk);
	if(z-&gt;cstate != VtStateAlloc) {
		vtSetError("bad session state");
		vtUnlock(z-&gt;lk);
		return 0;
	}
	if(z-&gt;fd &lt; 0){
		vtSetError("%s", z-&gt;fderror);
		vtUnlock(z-&gt;lk);
		return 0;
	}

	/* be a little anal */
	vtLock(z-&gt;inLock);
	vtLock(z-&gt;outLock);

	prefix = "venti-";
	p = buf;
	ep = buf + sizeof(buf);
	p = seprint(p, ep, "%s", prefix);
	p += strlen(p);
	for(i=0; vtVersions[i].version; i++) {
		if(i != 0)
			*p++ = ':';
		p = seprint(p, ep, "%s", vtVersions[i].s);
	}
	p = seprint(p, ep, "-libventi\n");
	assert(p-buf &lt; sizeof(buf));
	if(z-&gt;outHash)
		vtSha1Update(z-&gt;outHash, (uchar*)buf, p-buf);
	if(!vtFdWrite(z-&gt;fd, (uchar*)buf, p-buf))
		goto Err;
	
	vtDebug(z, "version string out: %s", buf);

	if(!vtVersionRead(z, prefix, &amp;z-&gt;version))
		goto Err;
		
	vtDebug(z, "version = %d: %s\n", z-&gt;version, vtGetVersion(z));

	vtUnlock(z-&gt;inLock);
	vtUnlock(z-&gt;outLock);
	z-&gt;cstate = VtStateConnected;
	vtUnlock(z-&gt;lk);

	if(z-&gt;vtbl)
		return 1;

	if(!vtHello(z))
		goto Err;
	return 1;	
Err:
	if(z-&gt;fd &gt;= 0)
		vtFdClose(z-&gt;fd);
	z-&gt;fd = -1;
	vtUnlock(z-&gt;inLock);
	vtUnlock(z-&gt;outLock);
	z-&gt;cstate = VtStateClosed;
	vtUnlock(z-&gt;lk);
	return 0;	
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

