<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libscribble/graffiti.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libscribble/graffiti.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Graffiti.c is based on the file Scribble.c copyrighted
 * by Keith Packard:
 *
 * Copyright © 1999 Keith Packard
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Keith Packard not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  Keith Packard makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * KEITH PACKARD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL KEITH PACKARD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;draw.h&gt;
#include &lt;scribble.h&gt;

#include "scribbleimpl.h"
#include "graffiti.h"

int ScribbleDebug;

char *cl_name[3] = {
	DEFAULT_LETTERS_FILE,
	DEFAULT_DIGITS_FILE,
	DEFAULT_PUNC_FILE
};

Rune
recognize (Scribble *s)
{
	struct graffiti *graf = s-&gt;graf;
	Stroke	    *ps = &amp;s-&gt;ps;
	Rune		    rune;
	int		    	c;
	int				nr;
	rec_alternative	*ret;

	if (ps-&gt;npts == 0)
		return '\0';

	c = recognizer_translate(
		graf-&gt;rec[s-&gt;puncShift ? CS_PUNCTUATION : s-&gt;curCharSet],
		1, ps, false, &amp;nr, &amp;ret);
	if (c != -1)
		delete_rec_alternative_array(nr, ret, false);

	rune = '\0';

	switch (c) {
	case '\0':
		if(ScribbleDebug)fprint(2, "(case '\\0')\n");
		break;
	case 'A':	/* space */
		rune = ' ';
		if(ScribbleDebug)fprint(2, "(case A) character = ' %C' (0x%x)\n", rune, rune);
		break;
	case 'B':	/* backspace */
		rune = '\b';
		if(ScribbleDebug)fprint(2, "(case B) character = \\b (0x%x)\n", rune);
		break;
	case 'N': /* numlock */
		if(ScribbleDebug)fprint(2, "(case N)\n");
		if (s-&gt;curCharSet == CS_DIGITS) {
			s-&gt;curCharSet = CS_LETTERS;
		} else {
			s-&gt;curCharSet = CS_DIGITS;
		}
		s-&gt;tmpShift = 0;
		s-&gt;puncShift = 0;
		s-&gt;ctrlShift = 0;
		break;
	case 'P': /* usually puncshift, but we'll make it CTRL */
		if(ScribbleDebug)fprint(2, "(case P)\n");
		s-&gt;ctrlShift = !s-&gt;ctrlShift;
		s-&gt;tmpShift = 0;
		s-&gt;puncShift = 0;
		break;
	case 'R':	/* newline */
		rune = '\n';
		if(ScribbleDebug)fprint(2, "(case R) character = \\n (0x%x)\n", rune);
		break;
	case 'S': /* shift */
		if(ScribbleDebug)fprint(2, "(case S)\n");
		s-&gt;puncShift = 0;
		s-&gt;ctrlShift = 0;
		if (s-&gt;capsLock) {
			s-&gt;capsLock = 0;
			s-&gt;tmpShift = 0;
			break;
		}
		if (s-&gt;tmpShift == 0) {
			s-&gt;tmpShift++;
			break;
		}
		/* fall through */
	case 'L': /* caps lock */
		if(ScribbleDebug)fprint(2, "(case L)\n");
		s-&gt;capsLock = !s-&gt;capsLock;
		break;
	case '.':	/* toggle punctuation mode */
		if (s-&gt;puncShift) {
			s-&gt;puncShift = 0;
		} else {
			s-&gt;puncShift = 1;
			s-&gt;ctrlShift = 0;
			s-&gt;tmpShift = 0;
			return rune;
		}		  	
		rune = '.';
		if(0)fprint(2, "(case .) character = %c (0x%x)\n", rune, rune);
		break;
	default:
		if ('A' &lt;= c &amp;&amp; c &lt;= 'Z') {
			if(ScribbleDebug)fprint(2, "(bad case?) character = %c (0x%x)\n", c, c);
			return rune;
		}
		rune = c;
		if (s-&gt;ctrlShift) 
		{
			if (c &lt; 'a' || 'z' &lt; c)
			{
				if(ScribbleDebug)fprint(2, "(default) character = %c (0x%x)\n", rune, rune);
				return rune;
			}
			rune = rune &amp; 0x1f;
		} else if ((s-&gt;capsLock &amp;&amp; !s-&gt;tmpShift) || 
				 (!s-&gt;capsLock &amp;&amp; s-&gt;tmpShift)) 
		{
			if (rune &lt; 0xff)
				rune = toupper(rune);
		} 
		s-&gt;tmpShift = 0;
		s-&gt;puncShift = 0;
		s-&gt;ctrlShift = 0;
		if(ScribbleDebug)fprint(2, "(default) character = %c (0x%x)\n", rune, rune);
	}
	return rune;
}

/* This procedure is called to initialize pg by loading the three
 * recognizers, loading the initial set of three classifiers, and
 * loading &amp; verifying the recognizer extension functions.  If the
 * directory $HOME/.recognizers exists, the classifier files will be
 * loaded from that directory.  If not, or if there is an error, the
 * default files (directory specified in Makefile) will be loaded
 * instead.  Returns non-zero on success, 0 on failure.  (Adapted from
 * package tkgraf/src/GraffitiPkg.c.
 */

static int
graffiti_load_recognizers(struct graffiti *pg)
{
	bool usingDefault;
	char* homedir;
	int i;
	rec_fn *fns;

	/* First, load the recognizers... */
	/* call recognizer_unload if an error ? */
	for (i = 0; i &lt; NUM_RECS; i++) {
		/* Load the recognizer itself... */
		pg-&gt;rec[i] = recognizer_load(DEFAULT_REC_DIR, "", nil);
		if (pg-&gt;rec[i] == nil) {
			fprint(2,"Error loading recognizer from %s.", DEFAULT_REC_DIR);
			return 0;
		}
		if ((* (int *)(pg-&gt;rec[i])) != 0xfeed) {
			fprint(2,"Error in recognizer_magic.");
			return 0;
		}
	}

	/* ...then figure out where the classifiers are... */
	if ( (homedir = (char*)getenv("home")) == nil ) {
		if(0)fprint(2, "no homedir, using = %s\n", REC_DEFAULT_USER_DIR);
		strecpy(pg-&gt;cldir, pg-&gt;cldir+sizeof pg-&gt;cldir, REC_DEFAULT_USER_DIR);
		usingDefault = true;
	} else {
		if(0)fprint(2, "homedir = %s\n", homedir);
		snprint(pg-&gt;cldir, sizeof pg-&gt;cldir, "%s/%s", homedir, CLASSIFIER_DIR);
		usingDefault = false;
	}

	/* ...then load the classifiers... */
	for (i = 0; i &lt; NUM_RECS; i++) {
		int rec_return;
		char *s;

		rec_return = recognizer_load_state(pg-&gt;rec[i], pg-&gt;cldir, cl_name[i]);
		if ((rec_return == -1) &amp;&amp; (usingDefault == false)) {
			if(0)fprint(2, "Unable to load custom classifier file %s/%s.\nTrying default classifier file instead.\nOriginal error: %s\n ", 
				pg-&gt;cldir, cl_name[i], 
				(s = recognizer_error(pg-&gt;rec[i])) ? s : "(none)");
			rec_return = recognizer_load_state(pg-&gt;rec[i],
						REC_DEFAULT_USER_DIR, cl_name[i]);
		}
		if (rec_return == -1) {
			fprint(2, "Unable to load default classifier file %s.\nOriginal error: %s\n",
				cl_name[i], 
				(s = recognizer_error(pg-&gt;rec[i])) ? s : "(none)");
			return 0;
		}
	}

	/* We have recognizers and classifiers now.   */
	/* Get the vector of LIextension functions..     */
	fns = recognizer_get_extension_functions(pg-&gt;rec[CS_LETTERS]);
	if (fns == nil) {
		fprint(2, "LI Recognizer Training:No extension functions!");
		return 0;
	}
	
	/* ... and make sure the training &amp; get-classes functions are okay. */
	if( (pg-&gt;rec_train = (li_recognizer_train)fns[LI_TRAIN]) == nil ) {
		fprint(2,
			"LI Recognizer Training:li_recognizer_train() not found!");
		if (fns != nil) {
			free(fns);
		}
		return 0;
	}
  
	if( (pg-&gt;rec_getClasses = (li_recognizer_getClasses)fns[LI_GET_CLASSES]) == nil ) {
		fprint(2,
			"LI Recognizer Training:li_recognizer_getClasses() not found!");
		if (fns != nil) {
			free(fns);
		}
		return 0;
	}
	free(fns);
	return 1;
}

Scribble *
scribblealloc(void)
{
	Scribble *s;

	s = mallocz(sizeof(Scribble), 1);
	if (s == nil)
		sysfatal("Initialize: %r");
	s-&gt;curCharSet = CS_LETTERS;

	s-&gt;graf = mallocz(sizeof(struct graffiti), 1);
	if (s-&gt;graf == nil)
		sysfatal("Initialize: %r");

	graffiti_load_recognizers(s-&gt;graf);

	return s;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

