<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libscribble/li_recognizer.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libscribble/li_recognizer.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 *  li_recognizer.c
 *
 *	Copyright 2000 Compaq Computer Corporation.
 *	Copying or modifying this code for any purpose is permitted,
 *	provided that this copyright notice is preserved in its entirety
 *	in all copies or modifications.
 *	COMPAQ COMPUTER CORPORATION MAKES NO WARRANTIES, EXPRESSED OR
 *	IMPLIED, AS TO THE USEFULNESS OR CORRECTNESS OF THIS CODE OR
 *
 *
 *  Adapted from cmu_recognizer.c by Jay Kistler.
 *  
 *  Where is the CMU copyright???? Gotta track it down - Jim Gettys
 *
 *  Credit to Dean Rubine, Jim Kempf, and Ari Rapkin.
 */

#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;stdio.h&gt;
#include &lt;draw.h&gt;
#include &lt;scribble.h&gt;
#include "scribbleimpl.h"

#include "hre_internal.h"
#include "li_recognizer_internal.h"

int lidebug = 0;

#define LI_MAGIC 0xACCBADDD

#define CHECK_LI_MAGIC(_a) \
  ((_a) != nil &amp;&amp; ((li_recognizer*)(_a))-&gt;li_magic == LI_MAGIC)


static void lialg_initialize(rClassifier *);
static int lialg_read_classifier_digest(rClassifier *);
static int lialg_canonicalize_examples(rClassifier *);
static char *lialg_recognize_stroke(rClassifier *, point_list *);
static void lialg_compute_lpf_parameters(void);


char* li_err_msg = nil;

#define bcopy(s1,s2,n) memmove(s2,s1,n)

/*Freeing classifier*/

static void
free_rClassifier(rClassifier* rc);

/*
 * Point List Support
*/

static point_list*
add_example(point_list* l,int npts,pen_point* pts)
{
	pen_point* lpts = mallocz(npts*sizeof(pen_point), 1);
	point_list *p = malloc(sizeof(point_list));

	p-&gt;npts = npts;
	p-&gt;pts = lpts;
	p-&gt;next = l;       /*Order doesn't matter, so we stick on end.*/

	/*Copy points.*/

	bcopy(pts, lpts, npts * sizeof(pen_point));

	return(p);
}
	

static void
delete_examples(point_list* l)
{
	point_list* p;

	for( ; l != nil; l = p ) {
		p = l-&gt;next;
		free(l-&gt;pts);
		free(l);
	}
}

/*
 * Local functions
 */

/*
 * recognize_internal-Form Vector, use Classifier to classify, return char.
 */

static char*
recognize_internal(rClassifier* rec, Stroke* str, int*)
{
	char *res;
	point_list *stroke;

	stroke = add_example(nil, str-&gt;npts, str-&gt;pts);
	if (stroke == nil) return(nil);

	res = lialg_recognize_stroke(rec, stroke);

	delete_examples(stroke);
	return(res);
}

/*
 * file_path-Construct pathname, check for proper extension.
 */

static int
  file_path(char* dir,char* filename,char* pathname)
{
	char* dot;
	
	/*Check for proper extension on file name.*/
	
	dot = strrchr(filename,'.');
	
	if( dot == nil ) {
		return(-1);
	}

	/*Determine whether a gesture or character classifier.*/

	if( strcmp(dot,LI_CLASSIFIER_EXTENSION) != 0 ) {
		return(-1);
	}

	/*Concatenate directory and filename into pathname.*/
	
	strcpy(pathname,dir);
	strcat(pathname,"/");
	strcat(pathname,filename);
	
	return(0);
}

/*read_classifier_points-Read points so classifier can be extended.*/

static int 
read_classifier_points(FILE* fd,int nclss,point_list** ex,char** cnames)
{
	int i,j,k;
	char buf[BUFSIZ];
	int nex = 0;
	char* names[MAXSCLASSES];
	point_list* examples[MAXSCLASSES];
	pen_point* pts;
	int npts;

	/*Initialize*/

		for( i = 0; i &lt; MAXSCLASSES; i++ ) {
				names[i] = nil;
				examples[i] = nil;
		}

		/*Go thru classes.*/

		for( k = 0; k &lt; nclss; k++ ) {

				/*Read class name and number of examples.*/
		
				if( fscanf(fd,"%d %s",&amp;nex,buf) != 2 )
					goto unallocate;
		
				/*Save class name*/
		
				names[k] = strdup(buf);
		
				/*Read examples.*/
				
				for( i = 0; i &lt; nex; i++ ) {
					
					/*Read number of points.*/
					
					if( fscanf(fd,"%d",&amp;npts) != 1 )
								goto unallocate; /*Boy would I like exceptions!*/
					
					/*Allocate array for points.*/
					
					if( (pts = mallocz(npts*sizeof(pen_point), 1)) == nil )
								goto unallocate;
					
					/*Read in points.*/
					
					for( j = 0; j &lt; npts; j++ ) {
								int x,y;
								if( fscanf(fd,"%d %d",&amp;x,&amp;y) != 2 ) {
									delete_pen_point_array(pts);
									goto unallocate;
								}
								pts[j].Point = Pt(x, y);
					}
					
					/*Add example*/
					
					if( (examples[k] = add_example(examples[k],npts,pts)) == nil ) {
								delete_pen_point_array(pts);
								goto unallocate;
					}
					
					delete_pen_point_array(pts);
			
				}
		}

/* ari -- end of list of classes */
/* fprint(2, "]\n"); */

		/*Transfer to recognizer.*/

		bcopy(examples,ex,sizeof(examples));
		bcopy(names,cnames,sizeof(names));

		return(0);

		/*Error. Deallocate memory and return.*/

unallocate:
		for( ; k &gt;= 0; k-- ) {
				delete_examples(examples[k]);
				free(names[k]);
		}

		return(-1);
}

/*read_classifier-Read a classifier file.*/

static int read_classifier(FILE* fd,rClassifier* rc)
{
	
	li_err_msg = nil;

	/*Read in classifier file.*/

	if(fscanf(fd, "%d", &amp;rc-&gt;nclasses) != 1)
		return -1;

	/*Read in the example points, so classifier can be extended.*/

	if( read_classifier_points(fd,rc-&gt;nclasses,rc-&gt;ex,rc-&gt;cnames) != 0 )
		return -1;

	return(0);
}

/*
 * Extension Functions
*/

/* getClasses and clearState are by Ari */

static int
recognizer_getClasses (recognizer r, char ***list, int *nc)
{
	int i, nclasses;
	li_recognizer* rec;
	char **ret;

		rec = (li_recognizer*)r-&gt;recognizer_specific;

		/*Check for LI recognizer.*/

		if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return(-1);
	}
	
	*nc = nclasses = rec-&gt;li_rc.nclasses;
	ret = malloc(nclasses*sizeof(char*));

	for (i = 0; i &lt; nclasses; i++)
				ret[i] = rec-&gt;li_rc.cnames[i];   /* only the 1st char of the cname */
	*list = ret;
		return 0;
}

static int
recognizer_clearState (recognizer)
{
  /*This operation isn't supported by the LI recognizer.*/

  li_err_msg = "Clearing state is not supported by the LI recognizer";

  return(-1);
}

static bool isa_li(recognizer r)
{ return(CHECK_LI_MAGIC(r)); }

static int
recognizer_train(recognizer, rc*, uint, Stroke*, rec_element*, bool)
{
  /*This operation isn't supported by the LI recognizer.*/

  li_err_msg = "Training is not supported by the LI recognizer";

  return(-1);
}

int
li_recognizer_get_example (recognizer r,
						   int		class, 
						   int		instance,
						   char		**name, 
						   pen_point	**points,
						   int		*npts)
{
	li_recognizer   *rec = (li_recognizer*)r-&gt;recognizer_specific;
	int nclasses = rec-&gt;li_rc.nclasses;
	point_list	    *pl;
	
		if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return(-1);
		}
		if (class &gt; nclasses)
				return -1;
		pl = rec-&gt;li_rc.canonex[class];
		while (instance &amp;&amp; pl)
		{
				pl = pl-&gt;next;
				instance--;
		}
		if (!pl)
				return -1;
		*name = rec-&gt;li_rc.cnames[class];
		*points = pl-&gt;pts;
		*npts = pl-&gt;npts;
		return pl-&gt;npts; /* I hope [sjm] */
}

/*
 * API Functions
 */


/*li_recognizer_load-Load a classifier file.*/

static int li_recognizer_load(recognizer r, char* dir, char* filename)
{
		FILE *fd;
		char* pathname;
		li_recognizer* rec;
		rClassifier* rc;
		
		rec = (li_recognizer*)r-&gt;recognizer_specific;

		/*Make sure recognizer's OK*/

		if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return(-1);
		}

		rc = &amp;(rec-&gt;li_rc);

		/*Check parameters.*/

		if( filename == nil ) {
				li_err_msg = "Invalid parameters";
				return(-1);
		}

		/*We let the directory be null.*/

		if( dir == nil || (int)strlen(dir) &lt;= 0 ) {
				dir = ".";
		}

		if(0)fprint(2, "dir = %s, filename = %s\n",
				dir, filename);

		/*Make full pathname and check filename*/

		pathname = malloc((strlen(dir) + strlen(filename) + 2)*sizeof(char));
		if( file_path(dir, filename, pathname) == -1 ) {
				free(pathname);
				li_err_msg = "Not a LI recognizer classifier file";
				return -1;
		}

		/* Try to short-circuit the full classifier-file processing. */
		rc-&gt;file_name = pathname;
		if (lialg_read_classifier_digest(rc) == 0)
				return(0);
		rc-&gt;file_name = nil;

		/*Open the file*/

		if( (fd = fopen(pathname,"r")) == nil ) {
				li_err_msg = "Can't open classifier file";
				if(0)fprint(2, "Can't open %s.\n", pathname);
				free(pathname);
				return(-1);
		}

		/*If rClassifier is OK, then delete it first.*/

		if( rc-&gt;file_name != nil ) {
				free_rClassifier(rc);
		}

		/*Read classifier.*/
		
		if( read_classifier(fd,rc) &lt; 0 ) {
				free(pathname);
				return(-1);
		}

		/*Close file.*/

		fclose(fd);

		/*Add classifier name.*/

		rc-&gt;file_name = pathname;

		/* Canonicalize examples. */
		if (lialg_canonicalize_examples(rc) != 0) {
				free(pathname);
				rc-&gt;file_name = nil;
				return -1;
		}

		return(0);
}

/*li_recognizer_save-Save a classifier file.*/

static int li_recognizer_save(recognizer, char*, char*)
{ 
		/*This operation isn't supported by the LI recognizer.*/

		li_err_msg = "Saving is not supported by the LI recognizer";
		return -1;
}

static wordset
li_recognizer_load_dictionary(recognizer, char*, char*)
{
		/*This operation isn't supported by the LI recognizer.*/

		li_err_msg = "Dictionaries are not supported by the LI recognizer";
		return nil;
}

static int
li_recognizer_save_dictionary(recognizer, char*, char*, wordset)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Dictionaries are not supported by the LI recognizer";
		return -1;
}

static int
li_recognizer_free_dictionary(recognizer, wordset)
{
  /*This operation isn't supported by the LI recognizer.*/

  li_err_msg = "Dictionaries are not supported by the LI recognizer";

  return -1;

}

static int
li_recognizer_add_to_dictionary(recognizer, letterset*, wordset)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Dictionaries are not supported by the LI recognizer";
		return -1;
}

static int
li_recognizer_delete_from_dictionary(recognizer, letterset*, wordset)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Dictionaries are not supported by the LI recognizer";
		return -1;
}

static char*
li_recognizer_error(recognizer rec)
{
	char* ret = li_err_msg;

	/*Check for LI recognizer.*/

	if( !CHECK_LI_MAGIC(rec-&gt;recognizer_specific) ) {
				li_err_msg = "Not a LI recognizer";
				return nil;
	}
	li_err_msg = nil;
	return ret;
}

static int 
li_recognizer_clear(recognizer r, bool)
{
		li_recognizer* rec; 

		rec = (li_recognizer*)r-&gt;recognizer_specific;
		/*Check for LI recognizer.*/
		if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return 0;
		}
		return 0;
}

static int 
li_recognizer_set_context(recognizer, rc*)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Contexts are not supported by the LI recognizer";
		return -1;
}

static rc*
li_recognizer_get_context(recognizer)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Contexts are not supported by the LI recognizer";
		return nil;
}

static int 
li_recognizer_get_buffer(recognizer, uint*, Stroke**)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Buffer get/set are not supported by the LI recognizer";
		return -1;
}

static int 
li_recognizer_set_buffer(recognizer, uint, Stroke*)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Buffer get/set are not supported by the LI recognizer";
		return -1;
}

static int
li_recognizer_translate(recognizer r, uint ncs, Stroke* tps, bool, int* nret, rec_alternative** ret)
{
	char* clss;
	li_recognizer* rec; 
	int conf;
	rClassifier* rc;
	  
	rec = (li_recognizer*)r-&gt;recognizer_specific;

	*nret = 0;
	*ret = nil;

	/*Check for LI recognizer.*/

	if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return(-1);
	}

		rc = &amp;(rec-&gt;li_rc);

	/*Check for valid parameters.*/
	if (ncs &lt; 1) {
				li_err_msg = "Invalid parameters: ncs";
				return(-1);
	}
	if( tps == nil) {
				li_err_msg = "Invalid parameters: tps";
				return(-1);
	}
	if( nret == nil) {
				li_err_msg = "Invalid parameters: nret";
				return(-1);
	}
	if( ret == nil) {
				li_err_msg = "Invalid parameters: ret";
				return(-1);
	}

	/*
	 * Go through the stroke array and recognize. Since this is a single
	 *   stroke recognizer, each stroke is treated as a separate
	 *   character or gesture. We allow only characters or gestures
	 *   to be recognized at one time, since otherwise, handling
	 *   the display of segmentation would be difficult. 
	*/
	clss = recognize_internal(rc,tps,&amp;conf);
	if (clss == nil) {
				*nret = 1;
				return(0);
	}

	/*Return values.*/
	*nret = 1;
	return(*clss);
}


static rec_fn*
li_recognizer_get_extension_functions(recognizer rec)
{
	rec_fn* ret;

	/*Check for LI recognizer.*/

	if( !CHECK_LI_MAGIC(rec-&gt;recognizer_specific) ) {
				li_err_msg = "Not a LI recognizer";
				return(nil);
	}

	ret = make_rec_fn_array(LI_NUM_EX_FNS);

/* ari -- clearState &amp; getClasses are mine */
	ret[LI_GET_CLASSES] =	(rec_fn)recognizer_getClasses;
	ret[LI_CLEAR] =			(rec_fn)recognizer_clearState;
	ret[LI_ISA_LI] =		(rec_fn)isa_li;
	ret[LI_TRAIN] =			(rec_fn)recognizer_train;

	return(ret);
}

static char**
li_recognizer_get_gesture_names(recognizer)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Gestures are not supported by the LI recognizer";
		return nil;
}

static xgesture
li_recognizer_set_gesture_action(recognizer, char*, xgesture, void*)
{
		/*This operation isn't supported by the LI recognizer.*/
		li_err_msg = "Gestures are not supported by the LI recognizer";
		return nil;
}

/*
 * Exported Functions
*/

/*RECOGNIZER_INITIALIZE-Initialize the recognizer.*/

/* note from ari:  this expands via pre-processor to
 *
 * recognizer __recognizer_internal_initialize(rec_info* ri)
 */

RECOGNIZER_INITIALIZE(ri)
{
	recognizer r;
	li_recognizer* rec;
	int i;

	/*Check that locale matches.*/

	if( strcmp(ri-&gt;ri_locale,LI_SUPPORTED_LOCALE) != 0 ) {
		li_err_msg = "Not a supported locale";
/* fprint(2, "Locale error.\n");*/
		return(nil);
	}

	/*
	 * Check that character sets match. Note that this is only approximate,
	 * since the classifier file will have more information.
	*/

	if( ri-&gt;ri_subset != nil ) {
	  for(i = 0; ri-&gt;ri_subset[i] != nil; i++ ) {

		if( strcmp(ri-&gt;ri_subset[i],UPPERCASE) != 0 &amp;&amp;
			strcmp(ri-&gt;ri_subset[i],LOWERCASE) != 0  &amp;&amp;
			strcmp(ri-&gt;ri_subset[i],DIGITS) != 0 &amp;&amp;
			strcmp(ri-&gt;ri_subset[i],GESTURE) != 0 ) {
		  li_err_msg = "Not a supported character set";
/* fprint(2, "charset error.\n"); */

		  return(nil);
		}
	  }
	}
			 
/* ari */
	r = make_recognizer(ri);
/* fprint(2, "past make_recognizer.\n"); */

	if( r == nil ) {
		li_err_msg = "Can't allocate storage";

		return(nil);
	}

	/*Make a LI recognizer structure.*/


	/* rec = (li_recognizer*)safe_malloc(sizeof(li_recognizer))) == nil ); */

	rec = malloc(sizeof(li_recognizer));

	r-&gt;recognizer_specific = rec;

	rec-&gt;li_rc.file_name = nil;
	rec-&gt;li_rc.nclasses = 0;

	/*Initialize the recognizer struct.*/

	r-&gt;recognizer_load_state = li_recognizer_load;
	r-&gt;recognizer_save_state = li_recognizer_save;
	r-&gt;recognizer_load_dictionary = li_recognizer_load_dictionary;
	r-&gt;recognizer_save_dictionary = li_recognizer_save_dictionary;
	r-&gt;recognizer_free_dictionary = li_recognizer_free_dictionary;
	r-&gt;recognizer_add_to_dictionary = li_recognizer_add_to_dictionary;
	r-&gt;recognizer_delete_from_dictionary = li_recognizer_delete_from_dictionary;
	r-&gt;recognizer_error = li_recognizer_error;
	r-&gt;recognizer_translate = li_recognizer_translate;
	r-&gt;recognizer_get_context = li_recognizer_get_context;
	r-&gt;recognizer_set_context = li_recognizer_set_context;
	r-&gt;recognizer_get_buffer = li_recognizer_get_buffer;
	r-&gt;recognizer_set_buffer = li_recognizer_set_buffer;
	r-&gt;recognizer_clear = li_recognizer_clear;
	r-&gt;recognizer_get_extension_functions = 
	  li_recognizer_get_extension_functions;
	r-&gt;recognizer_get_gesture_names = li_recognizer_get_gesture_names;
	r-&gt;recognizer_set_gesture_action = 
	  li_recognizer_set_gesture_action;

	/*Initialize LI Magic Number.*/

	rec-&gt;li_magic = LI_MAGIC;

	/*Initialize rClassifier.*/

	rec-&gt;li_rc.file_name = nil;

	for( i = 0; i &lt; MAXSCLASSES; i++ ) {
		rec-&gt;li_rc.ex[i] = nil;
		rec-&gt;li_rc.cnames[i] = nil;
	}

	lialg_initialize(&amp;rec-&gt;li_rc);

	/*Get rid of error message. Not needed here.*/
	li_err_msg = nil;

	return(r);
}

/*free_rClassifier-Free the rClassifier.*/

static void
free_rClassifier(rClassifier* rc)
{
	int i;

	if( rc-&gt;file_name != nil) {
		free(rc-&gt;file_name);
	}

	for( i = 0; rc-&gt;ex[i] != nil; i++) {
		delete_examples(rc-&gt;ex[i]);
		free(rc-&gt;cnames[i]);
	}

}

/*RECOGNIZER_FINALIZE-Deallocate the recognizer, finalize.*/

RECOGNIZER_FINALIZE(r)
{
		li_recognizer* rec = (li_recognizer*)r-&gt;recognizer_specific;

		/*Make sure this is a li_recognizer first*/
		if( !CHECK_LI_MAGIC(rec) ) {
				li_err_msg = "Not a LI recognizer";
				return(-1);
	}

		/*Deallocate rClassifier resources.*/

		free_rClassifier(&amp;(rec-&gt;li_rc));

		/*Deallocate the li_recognizer struct.*/
		free(rec);

		/*Deallocate the recognizer*/
		delete_recognizer(r);

		return(0);
}


/* **************************************************

  Implementation of the Li/Yeung recognition algorithm

************************************************** */

#define	WORST_SCORE	0x7fffffff

/* Dynamic programming parameters */
#define	DP_BAND		3
#define	MIN_SIM		0
#define	MAX_DIST	0x7fffffff
#define	SIM_THLD	60	/* x 100 */
#define	DIST_THLD	3200	/* x 100 */

/* Low-pass filter parameters -- empirically derived */
#define	LP_FILTER_WIDTH	6
#define	LP_FILTER_ITERS	8
#define	LP_FILTER_THLD	250	/* x 100 */
#define	LP_FILTER_MIN	5

/* Pseudo-extrema parameters -- empirically derived */
#define	PE_AL_THLD	1500	/* x 100 */
#define	PE_ATCR_THLD	135	/* x 100 */

/* Contour-angle derivation parameters */
#define	T_ONE		1
#define	T_TWO		20

/* Pre-processing and canonicalization parameters */
#define	CANONICAL_X	108
#define	CANONICAL_Y	128
#define	DIST_SQ_THRESHOLD   (3*3)	/* copied from fv.h */
#define	NCANONICAL	50

/* Tap-handling parameters */
#define	TAP_CHAR	"."
#define	TAP_TIME_THLD	150	    /* msec */
#define	TAP_DIST_THLD	75	    /* dx * dx + dy * dy */
#define	TAP_PATHLEN	1000	    /* x 100 */


/* region types */
#define	RGN_CONVEX  0
#define	RGN_CONCAVE 1
#define	RGN_PLAIN   2
#define	RGN_PSEUDO  3


typedef struct RegionList {
	int start;
	int end;
	int type;
	struct RegionList *next;
} region_list;


/* direction-code table; indexed by dx, dy */
static int lialg_dctbl[3][3] = {{1, 0, 7}, {2, 0x7FFFFFFF, 6}, {3, 4, 5}};

/* low-pass filter weights */
static int lialg_lpfwts[2 * LP_FILTER_WIDTH + 1];
static int lialg_lpfconst = -1;


static int lialg_preprocess_stroke(point_list *);
static point_list *lialg_compute_dominant_points(point_list *);
static point_list *lialg_interpolate_points(point_list *);
static void lialg_bresline(pen_point *, pen_point *, point_list *, int *);
static void lialg_compute_chain_code(point_list *);
static void lialg_compute_unit_chain_code(point_list *);
static region_list *lialg_compute_regions(point_list *);
static point_list *lialg_compute_dompts(point_list *, region_list *);
static int *lialg_compute_contour_angle_set(point_list *, region_list *);
static void lialg_score_stroke(point_list *, point_list *, int *, int *);
static int lialg_compute_similarity(point_list *, point_list *);
static int lialg_compute_distance(point_list *, point_list *);

static int lialg_read_classifier_digest(rClassifier *);

static int lialg_canonicalize_examples(rClassifier *);
static int lialg_canonicalize_example_stroke(point_list *);
static int lialg_compute_equipoints(point_list *);

static int lialg_compute_pathlen(point_list *);
static int lialg_compute_pathlen_subset(point_list *, int, int);
static int lialg_filter_points(point_list *);
static int lialg_translate_points(point_list *, int, int, int, int);
static void lialg_get_bounding_box(point_list *, int *, int *, int *, int *);
static void lialg_compute_lpf_parameters();
static int isqrt(int);
static int likeatan(int, int);
static int quadr(int);


/*************************************************************

  Core routines for the Li/Yeung recognition algorithm

 *************************************************************/

static void lialg_initialize(rClassifier *rec) {
	int i;

	/* Initialize the dompts arrays. */
	for (i = 0; i &lt; MAXSCLASSES; i++) {
		rec-&gt;dompts[i] = nil;
	}
}


/*
 *  Main recognition routine -- called by HRE API.
 */
static char *lialg_recognize_stroke(rClassifier *rec, point_list *stroke) {
		int i;
		char *name = nil;
		point_list *input_dompts = nil;
		char *best_name = nil;
		int best_score = WORST_SCORE;
		char *curr_name;
		point_list *curr_dompts;

		/*    (void)gettimeofday(&amp;stv, nil);*/

		if (stroke-&gt;npts &lt; 1) goto done;

		/* Check for tap. */

		/* First thing is to filter out ``close points.'' */
		if (lialg_filter_points(stroke) != 0) return(nil);

		/* Unfortunately, we don't have the actual time that each point */
		/* was recorded (i.e., dt is invalid).  Hence, we have to use a */
		/* heuristic based on total distance and the number of points. */
		if (stroke-&gt;npts == 1 || lialg_compute_pathlen(stroke) &lt; TAP_PATHLEN)
			return(TAP_CHAR);

		/* Pre-process input stroke. */
		if (lialg_preprocess_stroke(stroke) != 0) goto done;

		/* Compute its dominant points. */
		input_dompts = lialg_compute_dominant_points(stroke);
		if (input_dompts == nil) goto done;

		/* Score input stroke against every class in classifier. */
		for (i = 0, curr_name = rec-&gt;cnames[i], curr_dompts = rec-&gt;dompts[i];
				i &lt; MAXSCLASSES &amp;&amp; curr_name != nil &amp;&amp; curr_dompts != nil;
				i++, curr_name = rec-&gt;cnames[i], curr_dompts = rec-&gt;dompts[i]) {
				int sim;
				int dist;
				int curr_score;

				lialg_score_stroke(input_dompts, curr_dompts, &amp;sim, &amp;dist);
				curr_score = dist;

				if (lidebug &amp;&amp; curr_score &lt; DIST_THLD)
				fprint(2, "(%s, %d, %d) ", curr_name, sim, dist);

				/* Is it the best so far? */
				if (curr_score &lt; best_score &amp;&amp; curr_score &lt;= DIST_THLD) {
				best_score = curr_score;
				best_name = curr_name;
				}
		}

		if (lidebug)
				fprint(2, "\n");

		/* No errors. */
		name = best_name;

done:
		delete_examples(input_dompts);
		return(name);
}


static int lialg_preprocess_stroke(point_list *points) {
	int minx, miny, maxx, maxy, xrange, yrange, scale, xoff, yoff;

	/* Filter out points that are too close. */
	/* We did this earlier, when we checked for a tap. */
/*
	if (lialg_filter_points(points) != 0) return(-1);
*/

/*    assert(points-&gt;npts &gt; 0);*/

	/* Scale up to avoid conversion errors. */
	lialg_get_bounding_box(points, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
	xrange = maxx - minx;
	yrange = maxy - miny;
	scale = ( ((100 * xrange + CANONICAL_X / 2) / CANONICAL_X) &gt; 
			  ((100 * yrange + CANONICAL_Y / 2) / CANONICAL_Y))
	  ? (100 * CANONICAL_X + xrange / 2) / xrange
	  : (100 * CANONICAL_Y + yrange / 2) / yrange;
	if (lialg_translate_points(points, minx, miny, scale, scale) != 0)
		return(-1);

	/* Center the stroke. */
	lialg_get_bounding_box(points, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
	xrange = maxx - minx;
	yrange = maxy - miny;
	xoff = -((CANONICAL_X - xrange + 1) / 2);
	yoff = -((CANONICAL_Y - yrange + 1) / 2);
	if (lialg_translate_points(points, xoff, yoff, 100, 100) != 0) return(-1);

	/* Store the x and y ranges in the point list. */
	xrange = maxx - minx;
	yrange = maxy - miny;
	points-&gt;xrange = xrange;
	points-&gt;yrange = yrange;

	if (lidebug) {
		int i;
		fprint(2, "After pre-processing:   %d %d %d %d\n",
				minx, miny, maxx, maxy);
		for (i = 0; i &lt; points-&gt;npts; i++)
			fprint(2, "      (%P)\n", points-&gt;pts[i].Point);
		fflush(stderr);
	}

	return(0);
}


static point_list *lialg_compute_dominant_points(point_list *points) {
	point_list *ipts;
	region_list *regions;
	point_list *dpts;

	/* Interpolate points. */
	ipts = lialg_interpolate_points(points);
	if (ipts == nil) return(nil);
	if (lidebug) {
				int j;
				fprint(2, "After interpolation:  %d ipts\n", ipts-&gt;npts);
				for (j = 0; j &lt; ipts-&gt;npts; j++) {
					fprint(2, "  (%P), %lud\n", ipts-&gt;pts[j].Point, ipts-&gt;pts[j].chaincode);
				}
				fflush(stderr);
	}

	/* Compute regions. */
	regions = lialg_compute_regions(ipts);
/*    assert(regions != nil);*/

	/* Compute dominant points. */
	dpts = lialg_compute_dompts(ipts, regions);
	if (lidebug) {
				int j;
				fprint(2, "Dominant points:  ");
				for (j = 0; j &lt; dpts-&gt;npts; j++) {
					fprint(2, "%P (%lud)  ", dpts-&gt;pts[j].Point, dpts-&gt;pts[j].chaincode);
				}
				fprint(2, "\n");
				fflush(stderr);
	}

	/* Delete region data structure. */
	{
				region_list *curr, *next;
				for (curr = regions; curr != nil; ) {
					next = curr-&gt;next;
					free(curr);
					curr = next;
				}
	}
	delete_examples(ipts);
	return(dpts);
}

/* Input points are assumed to be integer-valued! */
static point_list *lialg_interpolate_points(point_list *points) {
	int i, j;
	int maxpts;
	point_list *newpts;

	/* Compute an upper-bound on the number of interpolated points. */
	maxpts = 0;
	for (i = 0; i &lt; (points-&gt;npts - 1); i++) {
				pen_point *pta = &amp;(points-&gt;pts[i]);
				pen_point *ptb = &amp;(points-&gt;pts[i+1]);
				maxpts += abs(pta-&gt;x - ptb-&gt;x) + abs(pta-&gt;y - ptb-&gt;y);
	}

	/* Allocate an array of the requisite size. */
	maxpts += points-&gt;npts;
	/* newpts = (point_list *)safe_malloc(sizeof(point_list)); */
	newpts = malloc(sizeof(point_list));
	newpts-&gt;pts = mallocz(maxpts*sizeof(pen_point), 1);
	if (newpts-&gt;pts == nil) {
				free(newpts);
				return(nil);
	}
	newpts-&gt;npts = maxpts;
	newpts-&gt;next = nil;

	/* Interpolate each of the segments. */
	j = 0;
	for (i = 0; i &lt; (points-&gt;npts - 1); i++) {
				pen_point *startpt = &amp;(points-&gt;pts[i]);
				pen_point *endpt = &amp;(points-&gt;pts[i+1]);

				lialg_bresline(startpt, endpt, newpts, &amp;j);

				j--;	/* end point gets recorded as start point of next segment! */
	}

	/* Add-in last point. */
	newpts-&gt;pts[j++] = points-&gt;pts[points-&gt;npts - 1];
	newpts-&gt;npts = j;

	/* Compute the chain code for P (the list of points). */
	lialg_compute_unit_chain_code(newpts);

	return(newpts);
}


/* This implementation is due to Kenny Hoff. */
static void lialg_bresline(pen_point *startpt, pen_point *endpt,
							point_list *newpts, int *j) {
	int Ax, Ay, Bx, By, dX, dY, Xincr, Yincr;

	Ax = startpt-&gt;x;
	Ay = startpt-&gt;y;
	Bx = endpt-&gt;x;
	By = endpt-&gt;y;

	/* INITIALIZE THE COMPONENTS OF THE ALGORITHM THAT ARE NOT AFFECTED */
	/* BY THE SLOPE OR DIRECTION OF THE	LINE */
	dX = abs(Bx-Ax);	/* store the change in X and Y of the line endpoints */
	dY = abs(By-Ay);

	/* DETERMINE "DIRECTIONS" TO INCREMENT X AND Y (REGARDLESS OF DECISION) */
	if (Ax &gt; Bx) { Xincr=-1; } else { Xincr=1; }    /* which direction in X? */
	if (Ay &gt; By) { Yincr=-1; } else { Yincr=1; }    /* which direction in Y? */

	/* DETERMINE INDEPENDENT VARIABLE (ONE THAT ALWAYS INCREMENTS BY 1 (OR -1) ) */
	/* AND INITIATE APPROPRIATE LINE DRAWING ROUTINE (BASED ON FIRST OCTANT */
	/* ALWAYS). THE X AND Y'S MAY BE FLIPPED IF Y IS THE INDEPENDENT VARIABLE. */
	if (dX &gt;= dY) {	    /* if X is the independent variable */
				int dPr	= dY&lt;&lt;1;	    /* amount to increment decision if right is chosen (always) */
				int dPru = dPr - (dX&lt;&lt;1);   /* amount to increment decision if up is chosen */
				int P =	dPr - dX;	    /* decision variable start value */
		
				/* process each point in the line one at a time (just use dX) */
				for (; dX&gt;=0; dX--) {
					newpts-&gt;pts[*j].x = Ax;
					newpts-&gt;pts[*j].y = Ay;
					(*j)++;
		
					if (P &gt; 0) {	/* is the pixel	going right AND	up? */
								Ax+=Xincr;	/* increment independent variable */
								Ay+=Yincr;	/* increment dependent variable */
								P+=dPru;	/* increment decision (for up) */
					} else {		/* is the pixel just going right? */
								Ax+=Xincr;	/* increment independent variable */
								P+=dPr;		/* increment decision (for right) */
					}
				}
	} else {		    /* if Y is the independent variable */
				int dPr	= dX&lt;&lt;1;	    /* amount to increment decision if right is chosen (always) */
				int dPru = dPr - (dY&lt;&lt;1);   /* amount to increment decision if up is chosen */
				int P  = dPr - dY;	    /* decision variable start value */
		
				/* process each point in the line one at a time (just use dY) */
				for (; dY&gt;=0; dY--) {
					newpts-&gt;pts[*j].x = Ax;
					newpts-&gt;pts[*j].y = Ay;
					(*j)++;
		
					if (P &gt; 0) {	/* is the pixel going up AND right? */
								Ax+=Xincr;	/* increment dependent variable */
								Ay+=Yincr;	/* increment independent variable */
								P+=dPru;	/* increment decision (for up) */
					} else {		/* is the pixel just going up? */
								Ay+=Yincr;	/* increment independent variable */
								P+=dPr;		/* increment decision (for right) */
					}
				}
	}
}

static void lialg_compute_chain_code(point_list *pts) {
	int i;

	for (i = 0; i &lt; (pts-&gt;npts - 1); i++) {
				pen_point *startpt = &amp;(pts-&gt;pts[i]);
				pen_point *endpt = &amp;(pts-&gt;pts[i+1]);
				int dx = endpt-&gt;x - startpt-&gt;x;
				int dy = endpt-&gt;y - startpt-&gt;y;
				int tmp = quadr(likeatan(dy, dx));
				int dircode = (12 - tmp) % 8;
		
				startpt-&gt;chaincode = dircode;
	}
}


static void lialg_compute_unit_chain_code(point_list *pts) {
	int i;

	for (i = 0; i &lt; (pts-&gt;npts - 1); i++) {
				pen_point *startpt = &amp;(pts-&gt;pts[i]);
				pen_point *endpt = &amp;(pts-&gt;pts[i+1]);
				int dx = endpt-&gt;x - startpt-&gt;x;
				int dy = endpt-&gt;y - startpt-&gt;y;
				int dircode = lialg_dctbl[dx+1][dy+1];

				startpt-&gt;chaincode = dircode;
	}
}


static region_list *lialg_compute_regions(point_list *pts) {
		region_list *regions;
		region_list *curr_reg;
		int *R[2 + LP_FILTER_ITERS];
		int *junk;
		int *curr, *next;
		int i, j;

		/* Initialize low-pass filter parameters if necessary. */
		if (lialg_lpfconst == -1)
				lialg_compute_lpf_parameters();

	/* Allocate a 2 x pts-&gt;npts array for use in computing the (filtered) Angle set, A_n. */
	junk = malloc((2 + LP_FILTER_ITERS) * pts-&gt;npts*sizeof(int));
	for (i = 0; i &lt; (2 + LP_FILTER_ITERS); i++)
		R[i] = junk + (i * pts-&gt;npts);
	curr = R[0];

	/* Compute the Angle set, A, in the first element of array R. */
	/* Values in R are in degrees, x 100. */
	curr[0] = 18000;				/* a_0 */
	for (i = 1; i &lt; (pts-&gt;npts - 1); i++) {
				int d_i = pts-&gt;pts[i].chaincode;
				int d_iminusone = pts-&gt;pts[i-1].chaincode;
				int a_i;
		
				if (d_iminusone &lt; d_i)
					d_iminusone += 8;
		
				a_i = (d_iminusone - d_i) % 8;
		
				/* convert to degrees, x 100 */
				curr[i] = ((12 - a_i) % 8) * 45 * 100;
	}
	curr[pts-&gt;npts - 1]	= 18000;		/* a_L-1 */

	/* Perform a number of filtering iterations. */
	next = R[1];
	for (j = 0; j &lt; LP_FILTER_ITERS; j++, curr = R[j], next = R[j+1]) {
				for (i = 0; i &lt; pts-&gt;npts; i++) {
					int k;
		
					next[i] = 0;
		
					for (k = i - LP_FILTER_WIDTH; k &lt;= i + LP_FILTER_WIDTH; k++) {
						int oldval = (k &lt; 0 || k &gt;= pts-&gt;npts) ? 18000 : curr[k];
						next[i]	+= oldval * lialg_lpfwts[k - (i	- LP_FILTER_WIDTH)];	/* overflow? */
					}
		
					next[i] /= lialg_lpfconst;
				}
	}

	/* Do final thresholding around PI. */
	/* curr and next are set-up correctly at end of previous loop! */
	for (i = 0; i &lt; pts-&gt;npts; i++)
				next[i] = (abs(curr[i] - 18000) &lt; LP_FILTER_THLD) ? 18000 : curr[i];
	curr = next;

	/* Debugging. */
	if (lidebug &gt; 1) {
				for (i = 0; i &lt; pts-&gt;npts; i++) {
					fprint(2, "%3d:  (%P)  %lud  ",
								i, pts-&gt;pts[i].Point, pts-&gt;pts[i].chaincode);
					for (j = 0; j &lt; 2 + LP_FILTER_ITERS; j++)
						fprint(2, "%d  ", R[j][i]);
					fprint(2, "\n");
				}
	}

	/* Do the region segmentation. */
	{
				int start, end;
				int currtype;
		
#define	RGN_TYPE(val) (((val)==18000)?RGN_PLAIN:((val)&lt;18000?RGN_CONCAVE:RGN_CONVEX))
		
				start = 0;
				currtype = RGN_TYPE(curr[0]);
				regions = malloc(sizeof(region_list));
				curr_reg = regions;
				curr_reg-&gt;start = start;
				curr_reg-&gt;end = 0;
				curr_reg-&gt;type = currtype;
				curr_reg-&gt;next = nil;
				for (i = 1; i &lt; pts-&gt;npts; i++) {
					int nexttype = RGN_TYPE(curr[i]);
		
					if (nexttype != currtype) {
								region_list *next_reg;
				
								end = i - 1;
								curr_reg-&gt;end = end;
								if (lidebug &gt; 1)
									fprint(2, "  (%d, %d), %d\n", start, end, currtype);
				
								start = i;
								currtype = nexttype;
								next_reg = malloc(sizeof(region_list));
								next_reg-&gt;start = start;
								next_reg-&gt;end = 0;
								next_reg-&gt;type = nexttype;
								next_reg-&gt;next = nil;
				
								curr_reg-&gt;next = next_reg;
								curr_reg = next_reg;
					}
				}
				end = i - 1;
				curr_reg-&gt;end = end;
				if (lidebug &gt; 1)
					fprint(2, "  (%d, %d), %d\n", start, end, currtype);

				/* Filter out convex/concave regions that are too short. */
				for (curr_reg = regions; curr_reg; curr_reg = curr_reg-&gt;next)
					if (curr_reg-&gt;type == RGN_PLAIN) {
								region_list *next_reg;
				
								for (next_reg = curr_reg-&gt;next;
									 next_reg != nil &amp;&amp;
									   (next_reg-&gt;end - next_reg-&gt;start) &lt; LP_FILTER_MIN;
									 next_reg = curr_reg-&gt;next) {
									/* next_reg must not be plain, and it must be followed by a plain */
									/* assert(next_reg-&gt;type != RGN_PLAIN); */
									/* assert(next_reg-&gt;next != nil &amp;&amp; (next_reg-&gt;next)-&gt;type == RGN_PLAIN); */
				
									curr_reg-&gt;next = (next_reg-&gt;next)-&gt;next;
									curr_reg-&gt;end = (next_reg-&gt;next)-&gt;end;
				
									free(next_reg-&gt;next);
									free(next_reg);
								}
					}
		
				/* Add-in pseudo-extremes. */
				{
					region_list *tmp, *prev_reg;
		
					tmp = regions;
					regions = nil;
					prev_reg = nil;
					for (curr_reg = tmp; curr_reg; curr_reg = curr_reg-&gt;next) {
						if (curr_reg-&gt;type == RGN_PLAIN) {
							int arclen = lialg_compute_pathlen_subset(pts,
																		curr_reg-&gt;start,
																		curr_reg-&gt;end);
							int dx = pts-&gt;pts[curr_reg-&gt;end].x -
							  pts-&gt;pts[curr_reg-&gt;start].x;
							int dy = pts-&gt;pts[curr_reg-&gt;end].y -
							  pts-&gt;pts[curr_reg-&gt;start].y;
							int chordlen = isqrt(10000 * (dx * dx + dy * dy));
							int atcr = (chordlen == 0) ? 0 : (100 * arclen + chordlen / 2) / chordlen;

							if (lidebug)
								fprint(2, "%d, %d, %d\n", arclen, chordlen, atcr);
		
							/* Split region if necessary. */
							if (arclen &gt;= PE_AL_THLD &amp;&amp; atcr &gt;= PE_ATCR_THLD) {
								int mid = curr_reg-&gt;start + (curr_reg-&gt;end - curr_reg-&gt;start) / 2;
								int end = curr_reg-&gt;end;
								region_list *saved_next = curr_reg-&gt;next;
		
								curr_reg-&gt;end = mid - 1;
								if (prev_reg == nil)
									regions = curr_reg;
								else
									prev_reg-&gt;next = curr_reg;
								prev_reg = curr_reg;
		
								/* curr_reg = (region_list *)safe_malloc(sizeof(region_list));*/
								curr_reg = malloc(sizeof(region_list));
								curr_reg-&gt;start = mid;
								curr_reg-&gt;end = mid;
								curr_reg-&gt;type = RGN_PSEUDO;
								curr_reg-&gt;next = nil;
								prev_reg-&gt;next = curr_reg;
								prev_reg = curr_reg;
		
								/* curr_reg = (region_list *)malloc(sizeof(region_list)); */
								curr_reg = malloc(sizeof(region_list));
								curr_reg-&gt;start = mid + 1;
								curr_reg-&gt;end = end;
								curr_reg-&gt;type = RGN_PLAIN;
								curr_reg-&gt;next = nil;
								prev_reg-&gt;next = curr_reg;
								prev_reg = curr_reg;
		
								curr_reg-&gt;next = saved_next;
								continue;
							}
						}
		
						if (prev_reg == nil)
							regions = curr_reg;
						else
							prev_reg-&gt;next = curr_reg;
						prev_reg = curr_reg;
					}
				}
		}

	free(junk);
	return(regions);
}


static point_list *lialg_compute_dompts(point_list *pts, region_list *regions) {
	point_list *dpts;
	int ndpts;
	int *cas;
	int nonplain;
	region_list *r;
		region_list *curr;
		int dp;
		int previx;
		int currix;

	/* Compute contour angle set. */
	cas = lialg_compute_contour_angle_set(pts, regions);

	/* Dominant points include:  start_pt, end_pt, extrema_of_non_plain_regions, midpts of the preceding. */
	nonplain = 0;
	for (r = regions; r != nil; r = r-&gt;next)
				if (r-&gt;type != RGN_PLAIN)
						nonplain++;
	ndpts = 2 * (2 + nonplain) - 1;
	/* dpts = (point_list *)safe_malloc(sizeof(point_list)); */
	dpts = malloc(sizeof(point_list));
	dpts-&gt;pts = mallocz(ndpts*sizeof(pen_point), 1);
	if (dpts-&gt;pts == nil) {
				free(dpts);
				return(nil);
	}
	dpts-&gt;npts = ndpts;
	dpts-&gt;next = nil;

	/* Pick out dominant points. */

		/* Record start point. */
		dp = 0;
		previx = 0;
		dpts-&gt;pts[dp++] = pts-&gt;pts[previx];

		for (curr = regions; curr != nil; curr = curr-&gt;next)
			if (curr-&gt;type != RGN_PLAIN) {
						int max_v = 0;
						int min_v = 0x7fffffff;	/* maxint */
						int max_ix = -1;
						int min_ix = -1;
						int i;
		
						for (i = curr-&gt;start; i &lt;= curr-&gt;end; i++) {
							int v = cas[i];
							if (v &gt; max_v) { max_v = v; max_ix = i; }
							if (v &lt; min_v) { min_v = v; min_ix = i; }
							if (lidebug &gt; 1)
								fprint(2, "  %d\n", v);
						}
		
						currix = (curr-&gt;type == RGN_CONVEX ? max_ix : min_ix);
		
						/* Record midpoint. */
						dpts-&gt;pts[dp++] = pts-&gt;pts[previx + (currix - previx) / 2];
		
						/* Record extreme point. */
						dpts-&gt;pts[dp++] = pts-&gt;pts[currix];
		
						previx = currix;
			}

		/* Record last mid-point and end point. */
		currix = pts-&gt;npts - 1;
		dpts-&gt;pts[dp++] = pts-&gt;pts[previx + (currix - previx) / 2];
		dpts-&gt;pts[dp] = pts-&gt;pts[currix];

	/* Compute chain-code. */
	lialg_compute_chain_code(dpts);

	free(cas);
	return(dpts);
}


static int *lialg_compute_contour_angle_set(point_list *pts,
											   region_list *regions) {
		int *V;
		region_list *curr_reg;
		int i;

		V = malloc(pts-&gt;npts*sizeof(int));

		V[0] = 18000;
		for (curr_reg = regions; curr_reg != nil; curr_reg = curr_reg-&gt;next) {
				for (i = curr_reg-&gt;start; i &lt;= curr_reg-&gt;end; i++) {
					if (curr_reg-&gt;type == RGN_PLAIN) {
								V[i] = 18000;
					} else {
								/* For now, simply choose the mid-point. */
								int isMidPt = i == (curr_reg-&gt;start +
													 (curr_reg-&gt;end - curr_reg-&gt;start) / 2);
								V[i] = (curr_reg-&gt;type == RGN_CONVEX)
								  ? (isMidPt ? 18000 : 0)
								  : (isMidPt ? 0 : 18000);
					}
				}
	}
	V[pts-&gt;npts - 1] = 18000;

	return(V);
}


/*
 *  First compute the similarity between the two strings.
 *  If it's above a threshold, compute the distance between
 *  the two and return it as the ``score.''
 *  Otherwise, return the constant WORST_SCORE.
 *
 */
static void lialg_score_stroke(point_list *input_dompts, point_list *curr_dompts, int *sim, int *dist) {
	*sim = MIN_SIM;
	*dist = MAX_DIST;

	*sim = lialg_compute_similarity(input_dompts, curr_dompts);
	if (*sim &lt; SIM_THLD) goto done;

	*dist = lialg_compute_distance(input_dompts, curr_dompts);

done:
	if (lidebug)
		fprint(2, "%d, %d\n", *sim, *dist);
}


static int lialg_compute_similarity(point_list *input_dompts, point_list *curr_dompts) {
	int sim;
	point_list *A, *B;
	int N, M;
	int **G;
	int *junk;
	int i, j;

	/* A is the	longer sequence, length	N. */
	/* B is the shorter sequence, length M. */
		if (input_dompts-&gt;npts &gt;= curr_dompts-&gt;npts) {
				A = input_dompts;
				N = input_dompts-&gt;npts;
				B = curr_dompts;
				M = curr_dompts-&gt;npts;
	} else {
				A = curr_dompts;
				N = curr_dompts-&gt;npts;
				B = input_dompts;
				M = input_dompts-&gt;npts;
		}

		/* Allocate and initialize the Gain matrix, G. */
		/* The size of G is M x (N + 1). */
		/* Note that row 0 is unused. */
		/* Similarities are x 10. */
		G = malloc(M*sizeof(int *));
		junk = malloc(M * (N + 1) * sizeof(int));
		for (i = 0; i &lt; M; i++)
			G[i] = junk + (i * (N + 1));

		for (i = 1; i &lt; M; i++) {
			int bval = B-&gt;pts[i-1].chaincode;

			/* Source column. */
			G[i][0] = 0;

			for (j = 1; j &lt; N; j++) {
				int aval = A-&gt;pts[j-1].chaincode;
				int diff = abs(bval - aval);
				if (diff &gt; 4) diff = 8 - diff;

				G[i][j] = (diff == 0)
				  ? 10
				  : (diff == 1)
				  ? 6
				  : 0;
			}

			/* Sink column. */
			G[i][N] = 0;
		}

	/* Do the DP algorithm. */
	/* Proceed in column order, from highest column to the lowest. */
	/* Within each column, proceed from the highest row to the lowest. */
	/* Skip the highest column. */
		for (j = N - 1; j &gt;= 0; j--)
			for (i = M - 1; i &gt; 0; i--) {
				int max = G[i][j + 1];

				if (i &lt; (M - 1)) {
					int tmp = G[i + 1][j + 1];
					if (tmp &gt; max) max = tmp;
				}

				G[i][j] += max;
		}

		sim = (10 * G[1][0] + (N - 1) / 2) / (N - 1);

		if (G != nil)
				free(G);
		if (junk != nil)
				free(junk);
		return(sim);
}


static int lialg_compute_distance(point_list *input_dompts,
								   point_list *curr_dompts) {
		int dist;
		point_list *A, *B;
		int N, M;
		int **C;
		int *junk;
		int *BE;
		int *TE;
		int i, j;

		/* A is the	longer sequence, length	N. */
		/* B is the shorter sequence, length M. */
		if (input_dompts-&gt;npts &gt;= curr_dompts-&gt;npts) {
				A = input_dompts;
				N = input_dompts-&gt;npts;
				B = curr_dompts;
				M = curr_dompts-&gt;npts;
		}
		else {
				A = curr_dompts;
				N = curr_dompts-&gt;npts;
				B = input_dompts;
				M = input_dompts-&gt;npts;
		}

		/* Construct the helper vectors, BE and TE, which say for each column */
		/* what are the ``bottom'' and ``top'' rows of interest. */
		BE = malloc((N + 1)*sizeof(int));
		TE = malloc((N + 1)*sizeof(int));

		for (j = 1; j &lt;= N; j++) {
				int bot, top;

				bot = j + (M - DP_BAND);
				if (bot &gt; M) bot = M;
				BE[j] = bot;

				top = j - (N - DP_BAND);
				if (top &lt; 1) top = 1;
				TE[j] = top;
		}

		/* Allocate and initialize the Cost matrix, C. */
		/* The size of C is (M + 1) x (N + 1). */
		/* Note that row and column 0 are unused. */
		/* Costs are x 100. */
		/*	C = (int **)safe_malloc((M + 1) * sizeof(int *)); */
		C = malloc((M + 1)*sizeof( int *));
		junk = malloc((M + 1) * (N + 1)*sizeof(int));
		for (i = 0; i &lt;= M; i++)
				C[i] = junk + (i * (N + 1));

		for (i = 1; i &lt;= M; i++) {
				int bx = B-&gt;pts[i-1].x;
				int by = B-&gt;pts[i-1].y;

				for (j = 1; j &lt;= N; j++) {
						int ax = A-&gt;pts[j-1].x;
						int ay = A-&gt;pts[j-1].y;
						int dx = bx - ax;
						int dy = by - ay;
						int dist = isqrt(10000 * (dx * dx + dy * dy));
				
						C[i][j] = dist;
				}
		}

		/* Do the DP algorithm. */
		/* Proceed in column order, from highest column to the lowest. */
		/* Within each column, proceed from the highest row to the lowest. */
		for (j = N; j &gt; 0; j--)
				for (i = M; i &gt; 0; i--) {
						int min = MAX_DIST;
		
						if (i &gt; BE[j] || i &lt; TE[j] || (j == N &amp;&amp; i == M))
								continue;
		
						if (j &lt; N) {
								if (i &gt;= TE[j+1]) {
										int tmp = C[i][j+1];
										if (tmp &lt; min)
												min = tmp;
								}
		
								if (i &lt; M) {
										int tmp = C[i+1][j+1];
										if (tmp &lt; min)
												min = tmp;
								}
						}
		
						if (i &lt; BE[j]) {
								int tmp = C[i+1][j];
								if (tmp &lt; min) min = tmp;
						}
		
						C[i][j] += min;
				}

		dist = (C[1][1] + N / 2) / N;

		if (C != nil) free(C);
		if (junk != nil) free(junk);
		if (BE != nil) free(BE);
		if (TE != nil) free(TE);
		return(dist);
}


/*************************************************************

  Digest-processing routines

 *************************************************************/

static int lialg_read_classifier_digest(rClassifier *rec) {
	int nclasses;
	FILE *fp;

	/* Try to open the corresponding digest file. */
	{
				char *clx_path;
				char *dot;
		
				/* Get a copy of the filename, with some room on the end. */
				/*	clx_path = safe_malloc(strlen(rec-&gt;file_name) + 5); */
				clx_path = malloc((strlen(rec-&gt;file_name) + 5) *sizeof(char));
				strcpy(clx_path, rec-&gt;file_name);
		
				/* Truncate the path after the last dot. */
				dot = strrchr(clx_path, '.');
				if (dot == nil) { free(clx_path); return(-1); }
				*(dot + 1) = 0;
		
				/* Append the classifier-digest extension. */
				strcat(clx_path, "clx");
		
				fp = fopen(clx_path, "r");
				if (fp == nil) {
						free(clx_path);
						return(-1);
				}
		
				free(clx_path);
	}

	/* Read-in the name and dominant points for each class. */
	for (nclasses = 0; !feof(fp); nclasses++) {
		point_list *dpts = nil;
		char class[BUFSIZ];
		int npts;
		int j;

		if (fscanf(fp, "%s %d", class, &amp;npts) != 2) {
			if (feof(fp)) break;

			goto failed;
		}
		rec-&gt;cnames[nclasses] = strdup(class);

		/* Allocate a dominant-points list. */
		/* dpts = (point_list *)safe_malloc(sizeof(point_list)); */
		dpts = malloc(sizeof(point_list));
		dpts-&gt;pts = mallocz(npts*sizeof(pen_point), 1);
		if (dpts-&gt;pts == nil) goto failed;
		dpts-&gt;npts = npts;
		dpts-&gt;next = nil;

		/* Read in each point. */
		for (j = 0; j &lt; npts; j++) {
			int x, y;

			if (fscanf(fp, "%d %d", &amp;x, &amp;y) != 2) goto failed;
			dpts-&gt;pts[j].x = x;
			dpts-&gt;pts[j].y = y;
		}

		/* Compute the chain-code. */
		lialg_compute_chain_code(dpts);

		/* Store the list in the rec data structure. */
		rec-&gt;dompts[nclasses] = dpts;

		continue;

failed:
		fprint(2, "read_classifier_digest failed...\n");
		for (; nclasses &gt;= 0; nclasses--) {
			if (rec-&gt;cnames[nclasses] != nil) {
				free(rec-&gt;cnames[nclasses]);
				rec-&gt;cnames[nclasses] = nil;
			}
			if (rec-&gt;dompts[nclasses] != nil) {
				delete_examples(rec-&gt;dompts[nclasses]);
				rec-&gt;dompts[nclasses] = nil;
			}
		}
		if (dpts != nil)
			delete_examples(dpts);
		fclose(fp);
		return(-1);
	}

	fclose(fp);
	return(0);
}


/*************************************************************

  Canonicalization routines

 *************************************************************/

static int lialg_canonicalize_examples(rClassifier *rec) {
	int i;
	int nclasses;

	if (lidebug) {
		fprint(2, "lialg_canonicalize_examples working on %s\n",
				rec-&gt;file_name);
	}
	/* Initialize canonical-example arrays. */
	for (i = 0; i &lt; MAXSCLASSES; i++) {
		rec-&gt;canonex[i] = nil;
	}

	/* Figure out number of classes. */
	for (nclasses = 0;
		  nclasses &lt; MAXSCLASSES &amp;&amp; rec-&gt;cnames[nclasses] != nil;
		  nclasses++)
		;

	/* Canonicalize the examples for each class. */
	for (i = 0; i &lt; nclasses; i++) {
		int j, k;
		int nex;
		point_list *pts, *tmp, *avg;
		int maxxrange, maxyrange;
		int minx, miny, maxx, maxy;
		int avgxrange, avgyrange, avgxoff, avgyoff, avgscale;

		
		if (lidebug) {
			fprint(2, "lialg_canonicalize_examples working on class %s\n",
					rec-&gt;cnames[i]);
		}
		/* Make a copy of the examples. */
		pts = nil;
		tmp = rec-&gt;ex[i];
		for (nex = 0; tmp != nil; nex++, tmp = tmp-&gt;next) {
			if ((pts = add_example(pts, tmp-&gt;npts, tmp-&gt;pts)) == nil) {
				delete_examples(pts);
				return(-1);
			}
		}

		/* Canonicalize each example, and derive the max x and y ranges. */
		maxxrange = 0;
		maxyrange = 0;
		for (j = 0, tmp = pts; j &lt; nex; j++, tmp = tmp-&gt;next) {
			if (lialg_canonicalize_example_stroke(tmp) != 0) {
  	        if (lidebug) {
					fprint(2, "lialg_canonicalize_example_stroke returned error\n");
				}
				return(-1);
			}

			if (tmp-&gt;xrange &gt; maxxrange) maxxrange = tmp-&gt;xrange;
			if (tmp-&gt;yrange &gt; maxyrange) maxyrange = tmp-&gt;yrange;
		}

		/* Normalize max ranges. */
		if (((100 * maxxrange + CANONICAL_X / 2) / CANONICAL_X) &gt;
			((100 * maxyrange + CANONICAL_Y / 2) / CANONICAL_Y)) {
			maxyrange = (maxyrange * CANONICAL_X + maxxrange / 2) / maxxrange;
			maxxrange = CANONICAL_X;
		}
		else {
			maxxrange = (maxxrange * CANONICAL_Y + maxyrange / 2) / maxyrange;
			maxyrange = CANONICAL_Y;
		}

		/* Re-scale each example to max ranges. */
		for (j = 0, tmp = pts; j &lt; nex; j++, tmp = tmp-&gt;next) {
			int scalex = (tmp-&gt;xrange == 0) ? 100 : (100 * maxxrange + tmp-&gt;xrange / 2) / tmp-&gt;xrange;
			int scaley = (tmp-&gt;yrange == 0) ? 100 : (100 * maxyrange + tmp-&gt;yrange / 2) / tmp-&gt;yrange;
			if (lialg_translate_points(tmp, 0, 0, scalex, scaley) != 0) {
				delete_examples(pts);
				return(-1);
			}
		}

		/* Average the examples; leave average in first example. */
		avg = pts;				/* careful aliasing!! */
		for (k = 0; k &lt; NCANONICAL; k++) {
			int xsum = 0;
			int ysum = 0;

			for (j = 0, tmp = pts; j &lt; nex; j++, tmp = tmp-&gt;next) {
						xsum += tmp-&gt;pts[k].x;
						ysum += tmp-&gt;pts[k].y;
			}

			avg-&gt;pts[k].x = (xsum + j / 2) / j;
			avg-&gt;pts[k].y = (ysum + j / 2) / j;
		}

		/* Compute BB of averaged stroke and re-scale. */
		lialg_get_bounding_box(avg, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
		avgxrange = maxx - minx;
		avgyrange = maxy - miny;
		avgscale = (((100 * avgxrange + CANONICAL_X / 2) / CANONICAL_X) &gt;
					((100 * avgyrange + CANONICAL_Y / 2) / CANONICAL_Y))
		  ? (100 * CANONICAL_X + avgxrange / 2) / avgxrange
		  : (100 * CANONICAL_Y + avgyrange / 2) / avgyrange;
		if (lialg_translate_points(avg, minx, miny, avgscale, avgscale) != 0) {
			delete_examples(pts);
			return(-1);
		}

		/* Re-compute the x and y ranges and center the stroke. */
		lialg_get_bounding_box(avg, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
		avgxrange = maxx - minx;
		avgyrange = maxy - miny;
		avgxoff = -((CANONICAL_X - avgxrange + 1) / 2);
		avgyoff = -((CANONICAL_Y - avgyrange + 1) / 2);
		if (lialg_translate_points(avg, avgxoff, avgyoff, 100, 100) != 0) {
			delete_examples(pts);
			return(-1);
		}

		/* Create a point list to serve as the ``canonical representation. */
		if ((rec-&gt;canonex[i] = add_example(nil, avg-&gt;npts, avg-&gt;pts)) == nil) {
			delete_examples(pts);
			return(-1);
		}
		(rec-&gt;canonex[i])-&gt;xrange = maxx - minx;
		(rec-&gt;canonex[i])-&gt;yrange = maxy - miny;

		if (lidebug) {
			fprint(2, "%s, avgpts = %d\n", rec-&gt;cnames[i], avg-&gt;npts);
			for (j = 0; j &lt; avg-&gt;npts; j++) {
						fprint(2, "  (%P)\n", avg-&gt;pts[j].Point);
			}
		}

		/* Compute dominant points of canonical representation. */
		rec-&gt;dompts[i] = lialg_compute_dominant_points(avg);

		/* Clean up. */
		delete_examples(pts);
	}

	/* Sanity check. */
	for (i = 0; i &lt; nclasses; i++) {
		char *best_name = lialg_recognize_stroke(rec, rec-&gt;canonex[i]);

		if (best_name != rec-&gt;cnames[i])
			fprint(2, "%s, best = %s\n", rec-&gt;cnames[i], best_name);
	}

	return(0);
}


static int lialg_canonicalize_example_stroke(point_list *points) {
	int minx, miny, maxx, maxy, xrange, yrange, scale;

	/* Filter out points that are too close. */
	if (lialg_filter_points(points) != 0) return(-1);

	/* Must be at least two points! */
	if (points-&gt;npts &lt; 2) {
		if (lidebug) {
			fprint(2, "lialg_canonicalize_example_stroke: npts=%d\n",
					points-&gt;npts);
		}
		return(-1);
	}

	/* Scale up to avoid conversion errors. */
	lialg_get_bounding_box(points, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
	xrange = maxx - minx;
	yrange = maxy - miny;
	scale = (((100 * xrange + CANONICAL_X / 2) / CANONICAL_X) &gt;
			 ((100 * yrange + CANONICAL_Y / 2) / CANONICAL_Y))
	  ? (100 * CANONICAL_X + xrange / 2) / xrange
	  : (100 * CANONICAL_Y + yrange / 2) / yrange;
	if (lialg_translate_points(points, minx, miny, scale, scale) != 0) {
		if (lidebug) {
			fprint(2, "lialg_translate_points (minx=%d,miny=%d,scale=%d) returned error\n", minx, miny, scale);
		}
		return(-1);
	}

	/* Compute an equivalent stroke with equi-distant points. */
	if (lialg_compute_equipoints(points) != 0) return(-1);

	/* Re-translate the points to the origin. */
	lialg_get_bounding_box(points, &amp;minx, &amp;miny, &amp;maxx, &amp;maxy);
	if (lialg_translate_points(points, minx, miny, 100, 100) != 0) {
		if (lidebug) {
			fprint(2, "lialg_translate_points (minx=%d,miny=%d) returned error\n", minx, miny);
		}
		return(-1);
	}

	/* Store the x and y ranges in the point list. */
	xrange = maxx - minx;
	yrange = maxy - miny;
	points-&gt;xrange = xrange;
	points-&gt;yrange = yrange;

	if (lidebug) {
		int i;
		fprint(2, "Canonicalized:   %d, %d, %d, %d\n", minx, miny, maxx, maxy);
		for (i = 0; i &lt; points-&gt;npts; i++)
			fprint(2, "      (%P)\n", points-&gt;pts[i].Point);
		fflush(stderr);
	}

	return(0);
}


static int lialg_compute_equipoints(point_list *points) {
	pen_point *equipoints = mallocz(NCANONICAL*sizeof(pen_point), 1);
	int nequipoints = 0;
	int pathlen = lialg_compute_pathlen(points);
	int equidist = (pathlen + (NCANONICAL - 1) / 2) / (NCANONICAL - 1);
	int i;
	int dist_since_last_eqpt;
	int remaining_seglen;
	int dist_to_next_eqpt;

	if (equipoints == nil) {
		fprint(2, "can't allocate memory in lialg_compute_equipoints");
		return(-1);
	}

	if (lidebug) {
		fprint(2, "compute_equipoints:  npts = %d, pathlen = %d, equidist = %d\n",
				points-&gt;npts, pathlen, equidist);
		fflush(stderr);
	}

	/* First original point is an equipoint. */
	equipoints[0] = points-&gt;pts[0];
	nequipoints++;
	dist_since_last_eqpt = 0;

	for (i = 1; i &lt; points-&gt;npts; i++) {
		int dx1 = points-&gt;pts[i].x - points-&gt;pts[i-1].x;
		int dy1 = points-&gt;pts[i].y - points-&gt;pts[i-1].y;
		int endx = 100 * points-&gt;pts[i-1].x;
		int endy = 100 * points-&gt;pts[i-1].y;
		remaining_seglen = isqrt(10000 * (dx1 * dx1 + dy1 * dy1));
		dist_to_next_eqpt = equidist - dist_since_last_eqpt;

		while (remaining_seglen &gt;= dist_to_next_eqpt) {
			if (dx1 == 0) {
				/* x-coordinate stays the same */
				if (dy1 &gt;= 0)
					endy += dist_to_next_eqpt;
				else
					endy -= dist_to_next_eqpt;
			}
			else {
				int slope = (100 * dy1 + dx1 / 2) / dx1;
				int tmp = isqrt(10000 + slope * slope);
				int dx = (100 * dist_to_next_eqpt + tmp / 2) / tmp;
				int dy = (slope * dx + 50) / 100;

				if (dy &lt; 0) dy = -dy;
				if (dx1 &gt;= 0)
					endx += dx;
				else
					endx -= dx;
				if (dy1 &gt;= 0)
					endy += dy;
				else
					endy -= dy;
			}

			equipoints[nequipoints].x = (endx + 50) / 100;
			equipoints[nequipoints].y = (endy + 50) / 100;
			nequipoints++;
/*	    assert(nequipoints &lt;= NCANONICAL);*/
			dist_since_last_eqpt = 0;
			remaining_seglen -= dist_to_next_eqpt;
			dist_to_next_eqpt = equidist;
		}

		dist_since_last_eqpt += remaining_seglen;
	}

	/* Take care of last equipoint. */
	if (nequipoints == NCANONICAL) {
		/* Good. */
	} else if (nequipoints == (NCANONICAL - 1)) {
		/* Make last original point the last equipoint. */
		equipoints[nequipoints] = points-&gt;pts[points-&gt;npts - 1];
	} else {
	  if (lidebug) {
		fprint(2,"lialg_compute_equipoints: nequipoints = %d\n", 
				nequipoints);
	  }
/*	assert(false);*/
		return(-1);
	}

	points-&gt;npts = NCANONICAL;
	delete_pen_point_array(points-&gt;pts);
	points-&gt;pts = equipoints;
	return(0);
}


/*************************************************************

  Utility routines

 *************************************************************/

/* Result is x 100. */
static int lialg_compute_pathlen(point_list *points) {
	return(lialg_compute_pathlen_subset(points, 0, points-&gt;npts - 1));
}


/* Result is x 100. */
static int lialg_compute_pathlen_subset(point_list *points,
										   int start, int end) {
	int pathlen;
	int i;

	pathlen = 0;
	for (i = start + 1; i &lt;= end; i++) {
		int dx = points-&gt;pts[i].x - points-&gt;pts[i-1].x;
		int dy = points-&gt;pts[i].y - points-&gt;pts[i-1].y;
		int dist = isqrt(10000 * (dx * dx + dy * dy));
		pathlen += dist;
	}

	return(pathlen);
}


/* Note that this does NOT update points-&gt;xrange and points-&gt;yrange! */
static int lialg_filter_points(point_list *points) {
	int filtered_npts;
	pen_point *filtered_pts = mallocz(points-&gt;npts*sizeof(pen_point), 1);
	int i;

	if (filtered_pts == nil) {
		fprint(2, "can't allocate memory in lialg_filter_points");
		return(-1);
	}

	filtered_pts[0] = points-&gt;pts[0];
	filtered_npts = 1;
	for (i = 1; i &lt; points-&gt;npts; i++) {
		int j = filtered_npts - 1;
		int dx = points-&gt;pts[i].x - filtered_pts[j].x;
		int dy = points-&gt;pts[i].y - filtered_pts[j].y;
		int magsq = dx * dx + dy * dy;

		if (magsq &gt;= DIST_SQ_THRESHOLD) {
			filtered_pts[filtered_npts] = points-&gt;pts[i];
			filtered_npts++;
		}
	}

	points-&gt;npts = filtered_npts;
	delete_pen_point_array(points-&gt;pts);
	points-&gt;pts = filtered_pts;
	return(0);
}


/* scalex and scaley are x 100. */
/* Note that this does NOT update points-&gt;xrange and points-&gt;yrange! */
static int lialg_translate_points(point_list *points,
								   int minx, int miny,
								   int scalex, int scaley) {
	int i;

	for (i = 0; i &lt; points-&gt;npts; i++) {
				points-&gt;pts[i].x = ((points-&gt;pts[i].x - minx) * scalex + 50) / 100;
				points-&gt;pts[i].y = ((points-&gt;pts[i].y - miny) * scaley + 50) / 100;
	}

	return(0);
}


static void lialg_get_bounding_box(point_list *points,
									int *pminx, int *pminy,
									int *pmaxx, int *pmaxy) {
	int minx, miny, maxx, maxy;
	int i;

	minx = maxx = points-&gt;pts[0].x;
	miny = maxy = points-&gt;pts[0].y;
	for (i = 1; i &lt; points-&gt;npts; i++) {
				pen_point *pt = &amp;(points-&gt;pts[i]);
				if (pt-&gt;x &lt; minx) minx = pt-&gt;x;
				else if (pt-&gt;x &gt; maxx) maxx = pt-&gt;x;
				if (pt-&gt;y &lt; miny) miny = pt-&gt;y;
				else if (pt-&gt;y &gt; maxy) maxy = pt-&gt;y;
	}

	*pminx = minx;
	*pminy = miny;
	*pmaxx = maxx;
	*pmaxy = maxy;
}


int wtvals[] = {100, 104, 117, 143, 189, 271, 422};

static void lialg_compute_lpf_parameters(void) {
	int i;

		for (i = LP_FILTER_WIDTH; i &gt;= 0; i--) {
//		double x = 0.04 * (i * i);
//		double tmp = 100.0 * exp(x);
//		int wt = floor((double)tmp);
				int wt = wtvals[i];
				lialg_lpfwts[LP_FILTER_WIDTH - i] = wt;
				lialg_lpfwts[LP_FILTER_WIDTH + i] = wt;
		}
		lialg_lpfconst = 0;
		for (i = 0; i &lt; (2 * LP_FILTER_WIDTH + 1); i++) {
				lialg_lpfconst += lialg_lpfwts[i];
		}
}


/* Code from Joseph Hall (jnhall@sat.mot.com). */
static int isqrt(int n) {
		register int i;
		register long k0, k1, nn;

		for (nn = i = n, k0 = 2; i &gt; 0; i &gt;&gt;= 2, k0 &lt;&lt;= 1)
				;
		nn &lt;&lt;= 2;
	for (;;) {
				k1 = (nn / k0 + k0) &gt;&gt; 1;
				if (((k0 ^ k1) &amp; ~1) == 0)
				break;
				k0 = k1;
		}
		return (int) ((k1 + 1) &gt;&gt; 1);
}


/* Helper routines from Mark Hayter. */
static int likeatan(int tantop, int tanbot) { 
		int t;
		/* Use tan(theta)=top/bot --&gt; order for t */
		/* t in range 0..0x40000 */

		if ((tantop == 0) &amp;&amp; (tanbot == 0)) 
				t = 0;
	else
		{
				t = (tantop &lt;&lt; 16) / (abs(tantop) + abs(tanbot));
				if (tanbot &lt; 0) 
						t = 0x20000 - t;
				else 
						if (tantop &lt; 0) t = 0x40000 + t;
		}
		return t;
}


static int quadr(int t) {
	return (8 - (((t + 0x4000) &gt;&gt; 15) &amp; 7)) &amp; 7;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

