<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsec/port/sha1.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsec/port/sha1.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include "os.h"
#include &lt;libsec.h&gt;

static void encode(uchar*, u32int*, ulong);

extern void _sha1block(uchar*, ulong, u32int*);

/*
 *  we require len to be a multiple of 64 for all but
 *  the last call.  There must be room in the input buffer
 *  to pad.
 */
SHA1state*
sha1(uchar *p, ulong len, uchar *digest, SHA1state *s)
{
	uchar buf[128];
	u32int x[16];
	int i;
	uchar *e;

	if(s == nil){
		s = malloc(sizeof(*s));
		if(s == nil)
			return nil;
		memset(s, 0, sizeof(*s));
		s-&gt;malloced = 1;
	}

	if(s-&gt;seeded == 0){
		/* seed the state, these constants would look nicer big-endian */
		s-&gt;state[0] = 0x67452301;
		s-&gt;state[1] = 0xefcdab89;
		s-&gt;state[2] = 0x98badcfe;
		s-&gt;state[3] = 0x10325476;
		s-&gt;state[4] = 0xc3d2e1f0;
		s-&gt;seeded = 1;
	}

	/* fill out the partial 64 byte block from previous calls */
	if(s-&gt;blen){
		i = 64 - s-&gt;blen;
		if(len &lt; i)
			i = len;
		memmove(s-&gt;buf + s-&gt;blen, p, i);
		len -= i;
		s-&gt;blen += i;
		p += i;
		if(s-&gt;blen == 64){
			_sha1block(s-&gt;buf, s-&gt;blen, s-&gt;state);
			s-&gt;len += s-&gt;blen;
			s-&gt;blen = 0;
		}
	}

	/* do 64 byte blocks */
	i = len &amp; ~0x3f;
	if(i){
		_sha1block(p, i, s-&gt;state);
		s-&gt;len += i;
		len -= i;
		p += i;
	}

	/* save the left overs if not last call */
	if(digest == 0){
		if(len){
			memmove(s-&gt;buf, p, len);
			s-&gt;blen += len;
		}
		return s;
	}

	/*
	 *  this is the last time through, pad what's left with 0x80,
	 *  0's, and the input count to create a multiple of 64 bytes
	 */
	if(s-&gt;blen){
		p = s-&gt;buf;
		len = s-&gt;blen;
	} else {
		memmove(buf, p, len);
		p = buf;
	}
	s-&gt;len += len;
	e = p + len;
	if(len &lt; 56)
		i = 56 - len;
	else
		i = 120 - len;
	memset(e, 0, i);
	*e = 0x80;
	len += i;

	/* append the count */
	x[0] = s-&gt;len&gt;&gt;29;
	x[1] = s-&gt;len&lt;&lt;3;
	encode(p+len, x, 8);

	/* digest the last part */
	_sha1block(p, len+8, s-&gt;state);
	s-&gt;len += len+8;

	/* return result and free state */
	encode(digest, s-&gt;state, SHA1dlen);
	if(s-&gt;malloced == 1)
		free(s);
	return nil;
}

/*
 *	encodes input (ulong) into output (uchar). Assumes len is
 *	a multiple of 4.
 */
static void
encode(uchar *output, u32int *input, ulong len)
{
	u32int x;
	uchar *e;

	for(e = output + len; output &lt; e;) {
		x = *input++;
		*output++ = x &gt;&gt; 24;
		*output++ = x &gt;&gt; 16;
		*output++ = x &gt;&gt; 8;
		*output++ = x;
	}
}

DigestState*
hmac_sha1(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest,
	DigestState *s)
{
	return hmac_x(p, len, key, klen, digest, s, sha1, SHA1dlen);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

