<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsec/port/sha2_128.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsec/port/sha2_128.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sha2 128-bit
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;libsec.h&gt;

static void encode64(uchar*, u64int*, ulong);
static DigestState* sha2_128(uchar *, ulong, uchar *, SHA2_256state *, int);

extern void _sha2block128(uchar*, ulong, u64int*);

/*
 *  for sha2_384 and sha2_512, len must be multiple of 128 for all but
 *  the last call.  There must be room in the input buffer to pad.
 *
 *  Note: sha2_384 calls sha2_512block as sha2_384; it just uses a different
 *  initial seed to produce a truncated 384b hash result.  otherwise
 *  it's the same as sha2_512.
 */
SHA2_384state*
sha2_384(uchar *p, ulong len, uchar *digest, SHA2_384state *s)
{
	if(s == nil) {
		s = mallocz(sizeof(*s), 1);
		if(s == nil)
			return nil;
		s-&gt;malloced = 1;
	}
	if(s-&gt;seeded == 0){
		/*
		 * seed the state with the first 64 bits of the fractional
		 * parts of the square roots of the 9th thru 16th primes.
		 */
 		s-&gt;bstate[0] = 0xcbbb9d5dc1059ed8LL;
		s-&gt;bstate[1] = 0x629a292a367cd507LL;
		s-&gt;bstate[2] = 0x9159015a3070dd17LL;
		s-&gt;bstate[3] = 0x152fecd8f70e5939LL;
		s-&gt;bstate[4] = 0x67332667ffc00b31LL;
		s-&gt;bstate[5] = 0x8eb44a8768581511LL;
		s-&gt;bstate[6] = 0xdb0c2e0d64f98fa7LL;
		s-&gt;bstate[7] = 0x47b5481dbefa4fa4LL;
		s-&gt;seeded = 1;
	}
	return sha2_128(p, len, digest, s, SHA2_384dlen);
}

SHA2_512state*
sha2_512(uchar *p, ulong len, uchar *digest, SHA2_512state *s)
{

	if(s == nil) {
		s = mallocz(sizeof(*s), 1);
		if(s == nil)
			return nil;
		s-&gt;malloced = 1;
	}
	if(s-&gt;seeded == 0){
		/*
		 * seed the state with the first 64 bits of the fractional
		 * parts of the square roots of the first 8 primes 2..19).
		 */
 		s-&gt;bstate[0] = 0x6a09e667f3bcc908LL;
		s-&gt;bstate[1] = 0xbb67ae8584caa73bLL;
		s-&gt;bstate[2] = 0x3c6ef372fe94f82bLL;
		s-&gt;bstate[3] = 0xa54ff53a5f1d36f1LL;
		s-&gt;bstate[4] = 0x510e527fade682d1LL;
		s-&gt;bstate[5] = 0x9b05688c2b3e6c1fLL;
		s-&gt;bstate[6] = 0x1f83d9abfb41bd6bLL;
		s-&gt;bstate[7] = 0x5be0cd19137e2179LL;
		s-&gt;seeded = 1;
	}
	return sha2_128(p, len, digest, s, SHA2_512dlen);
}

/* common 128 byte block padding and count code for SHA2_384 and SHA2_512 */
static DigestState*
sha2_128(uchar *p, ulong len, uchar *digest, SHA2_512state *s, int dlen)
{
	int i;
	u64int x[16];
	uchar buf[256];
	uchar *e;

	/* fill out the partial 128 byte block from previous calls */
	if(s-&gt;blen){
		i = 128 - s-&gt;blen;
		if(len &lt; i)
			i = len;
		memmove(s-&gt;buf + s-&gt;blen, p, i);
		len -= i;
		s-&gt;blen += i;
		p += i;
		if(s-&gt;blen == 128){
			_sha2block128(s-&gt;buf, s-&gt;blen, s-&gt;bstate);
			s-&gt;len += s-&gt;blen;
			s-&gt;blen = 0;
		}
	}

	/* do 128 byte blocks */
	i = len &amp; ~(128-1);
	if(i){
		_sha2block128(p, i, s-&gt;bstate);
		s-&gt;len += i;
		len -= i;
		p += i;
	}

	/* save the left overs if not last call */
	if(digest == 0){
		if(len){
			memmove(s-&gt;buf, p, len);
			s-&gt;blen += len;
		}
		return s;
	}

	/*
	 *  this is the last time through, pad what's left with 0x80,
	 *  0's, and the input count to create a multiple of 128 bytes.
	 */
	if(s-&gt;blen){
		p = s-&gt;buf;
		len = s-&gt;blen;
	} else {
		memmove(buf, p, len);
		p = buf;
	}
	s-&gt;len += len;
	e = p + len;
	if(len &lt; 112)
		i = 112 - len;
	else
		i = 240 - len;
	memset(e, 0, i);
	*e = 0x80;
	len += i;

	/* append the count */
	x[0] = 0;			/* assume 32b length, i.e. &lt; 4GB */
	x[1] = s-&gt;len&lt;&lt;3;
	encode64(p+len, x, 16);

	/* digest the last part */
	_sha2block128(p, len+16, s-&gt;bstate);
	s-&gt;len += len+16;

	/* return result and free state */
	encode64(digest, s-&gt;bstate, dlen);
	if(s-&gt;malloced == 1)
		free(s);
	return nil;
}

/*
 * Encodes input (ulong long) into output (uchar).
 * Assumes len is a multiple of 8.
 */
static void
encode64(uchar *output, u64int *input, ulong len)
{
	u64int x;
	uchar *e;

	for(e = output + len; output &lt; e;) {
		x = *input++;
		*output++ = x &gt;&gt; 56;
		*output++ = x &gt;&gt; 48;
		*output++ = x &gt;&gt; 40;
		*output++ = x &gt;&gt; 32;
		*output++ = x &gt;&gt; 24;
		*output++ = x &gt;&gt; 16;
		*output++ = x &gt;&gt; 8;
		*output++ = x;
	}
}

DigestState*
hmac_sha2_384(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest,
	DigestState *s)
{
	return hmac_x(p, len, key, klen, digest, s, sha2_384, SHA2_384dlen);
}

DigestState*
hmac_sha2_512(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest,
	DigestState *s)
{
	return hmac_x(p, len, key, klen, digest, s, sha2_512, SHA2_512dlen);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

