<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsec/port/sha2_64.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsec/port/sha2_64.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * sha2 64-bit
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;libsec.h&gt;

static void encode32(uchar*, u32int*, ulong);
static DigestState* sha2_64(uchar *, ulong, uchar *, SHA2_256state *, int);

extern void _sha2block64(uchar*, ulong, u32int*);

/*
 *  for sha2_224 and sha2_256, len must be multiple of 64 for all but
 *  the last call.  There must be room in the input buffer to pad.
 *
 *  Note: sha2_224 calls sha2_256block as sha2_224, just uses different
 *  initial seed and produces a 224b hash result.  otherwise it's
 *  the same as sha2_256.
 */

SHA2_224state*
sha2_224(uchar *p, ulong len, uchar *digest, SHA2_224state *s)
{
	if(s == nil) {
		s = mallocz(sizeof(*s), 1);
		if(s == nil)
			return nil;
		s-&gt;malloced = 1;
	}
	if(s-&gt;seeded == 0){
		/*
		 * seed the state with the first 32 bits of the fractional
		 * parts of the square roots of the first 8 primes 2..19).
		 */
		s-&gt;state[0] = 0xc1059ed8;
		s-&gt;state[1] = 0x367cd507;
		s-&gt;state[2] = 0x3070dd17;
		s-&gt;state[3] = 0xf70e5939;
		s-&gt;state[4] = 0xffc00b31;
		s-&gt;state[5] = 0x68581511;
		s-&gt;state[6] = 0x64f98fa7;
		s-&gt;state[7] = 0xbefa4fa4;
		s-&gt;seeded = 1;
	}
	return sha2_64(p, len, digest, s, SHA2_224dlen);
}

SHA2_256state*
sha2_256(uchar *p, ulong len, uchar *digest, SHA2_256state *s)
{
	if(s == nil) {
		s = mallocz(sizeof(*s), 1);
		if(s == nil)
			return nil;
		s-&gt;malloced = 1;
	}
	if(s-&gt;seeded == 0){
		/*
		 * seed the state with the first 32 bits of the fractional
		 * parts of the square roots of the first 8 primes 2..19).
		 */
		s-&gt;state[0] = 0x6a09e667;
		s-&gt;state[1] = 0xbb67ae85;
		s-&gt;state[2] = 0x3c6ef372;
		s-&gt;state[3] = 0xa54ff53a;
		s-&gt;state[4] = 0x510e527f;
		s-&gt;state[5] = 0x9b05688c;
		s-&gt;state[6] = 0x1f83d9ab;
		s-&gt;state[7] = 0x5be0cd19;
		s-&gt;seeded = 1;
	}
	return sha2_64(p, len, digest, s, SHA2_256dlen);
}

/* common 64 byte block padding and count code for SHA2_224 and SHA2_256 */
static DigestState*
sha2_64(uchar *p, ulong len, uchar *digest, SHA2_256state *s, int dlen)
{
	int i;
	u32int x[16];
	uchar buf[128];
	uchar *e;

	/* fill out the partial 64 byte block from previous calls */
	if(s-&gt;blen){
		i = 64 - s-&gt;blen;
		if(len &lt; i)
			i = len;
		memmove(s-&gt;buf + s-&gt;blen, p, i);
		len -= i;
		s-&gt;blen += i;
		p += i;
		if(s-&gt;blen == 64){
			_sha2block64(s-&gt;buf, s-&gt;blen, s-&gt;state);
			s-&gt;len += s-&gt;blen;
			s-&gt;blen = 0;
		}
	}

	/* do 64 byte blocks */
	i = len &amp; ~(64-1);
	if(i){
		_sha2block64(p, i, s-&gt;state);
		s-&gt;len += i;
		len -= i;
		p += i;
	}

	/* save the left overs if not last call */
	if(digest == 0){
		if(len){
			memmove(s-&gt;buf, p, len);
			s-&gt;blen += len;
		}
		return s;
	}

	/*
	 *  this is the last time through, pad what's left with 0x80,
	 *  0's, and the input count to create a multiple of 64 bytes.
	 */
	if(s-&gt;blen){
		p = s-&gt;buf;
		len = s-&gt;blen;
	} else {
		memmove(buf, p, len);
		p = buf;
	}
	s-&gt;len += len;
	e = p + len;
	if(len &lt; 56)
		i = 56 - len;
	else
		i = 120 - len;
	memset(e, 0, i);
	*e = 0x80;
	len += i;

	/* append the count */
	x[0] = s-&gt;len&gt;&gt;29;
	x[1] = s-&gt;len&lt;&lt;3;
	encode32(p+len, x, 8);

	/* digest the last part */
	_sha2block64(p, len+8, s-&gt;state);
	s-&gt;len += len+8;

	/* return result and free state */
	encode32(digest, s-&gt;state, dlen);
	if(s-&gt;malloced == 1)
		free(s);
	return nil;
}

/*
 * Encodes input (ulong) into output (uchar).
 * Assumes len is a multiple of 4.
 */
static void
encode32(uchar *output, u32int *input, ulong len)
{
	u32int x;
	uchar *e;

	for(e = output + len; output &lt; e;) {
		x = *input++;
		*output++ = x &gt;&gt; 24;
		*output++ = x &gt;&gt; 16;
		*output++ = x &gt;&gt; 8;
		*output++ = x;
	}
}

DigestState*
hmac_sha2_224(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest,
	DigestState *s)
{
	return hmac_x(p, len, key, klen, digest, s, sha2_224, SHA2_224dlen);
}

DigestState*
hmac_sha2_256(uchar *p, ulong len, uchar *key, ulong klen, uchar *digest,
	DigestState *s)
{
	return hmac_x(p, len, key, klen, digest, s, sha2_256, SHA2_256dlen);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

