<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsunrpc/client.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsunrpc/client.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
/*
 * Sun RPC client.
 */
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;

typedef struct Out Out;
struct Out
{
	char err[ERRMAX];	/* error string */
	Channel *creply;	/* send to finish rpc */
	uchar *p;			/* pending request packet */
	int n;				/* size of request */
	ulong tag;			/* flush tag of pending request */
	ulong xid;			/* xid of pending request */
	ulong st;			/* first send time */
	ulong t;			/* resend time */
	int nresend;		/* number of resends */
	SunRpc rpc;		/* response rpc */
};

static void
udpThread(void *v)
{
	uchar *p, *buf;
	Ioproc *io;
	int n;
	SunClient *cli;
	enum { BufSize = 65536 };

	cli = v;
	buf = emalloc(BufSize);
	io = ioproc();
	p = nil;
	for(;;){
		n = ioread(io, cli-&gt;fd, buf, BufSize);
		if(n &lt;= 0)
			break;
		p = emalloc(4+n);
		memmove(p+4, buf, n);
		p[0] = n&gt;&gt;24;
		p[1] = n&gt;&gt;16;
		p[2] = n&gt;&gt;8;
		p[3] = n;
		if(sendp(cli-&gt;readchan, p) == 0)
			break;
		p = nil;
	}
	free(p);
	closeioproc(io);
	while(send(cli-&gt;dying, nil) == -1)
		;
}

static void
netThread(void *v)
{
	uchar *p, buf[4];
	Ioproc *io;
	uint n, tot;
	int done;
	SunClient *cli;

	cli = v;
	io = ioproc();
	tot = 0;
	p = nil;
	for(;;){
		n = ioreadn(io, cli-&gt;fd, buf, 4);
		if(n != 4)
			break;
		n = (buf[0]&lt;&lt;24)|(buf[1]&lt;&lt;16)|(buf[2]&lt;&lt;8)|buf[3];
		if(cli-&gt;chatty)
			fprint(2, "%.8ux...", n);
		done = n&amp;0x80000000;
		n &amp;= ~0x80000000;
		if(tot == 0){
			p = emalloc(4+n);
			tot = 4;
		}else
			p = erealloc(p, tot+n);
		if(ioreadn(io, cli-&gt;fd, p+tot, n) != n)
			break;
		tot += n;
		if(done){
			p[0] = tot&gt;&gt;24;
			p[1] = tot&gt;&gt;16;
			p[2] = tot&gt;&gt;8;
			p[3] = tot;
			if(sendp(cli-&gt;readchan, p) == 0)
				break;
			p = nil;
			tot = 0;
		}
	}
	free(p);
	closeioproc(io);
	while(send(cli-&gt;dying, 0) == -1)
		;
}

static void
timerThread(void *v)
{
	Ioproc *io;
	SunClient *cli;

	cli = v;
	io = ioproc();
	for(;;){
		if(iosleep(io, 200) &lt; 0)
			break;
		if(sendul(cli-&gt;timerchan, 0) == 0)
			break;
	}
	closeioproc(io);
	while(send(cli-&gt;dying, 0) == -1)
		;
}

static ulong
msec(void)
{
	return nsec()/1000000;
}

static ulong
twait(ulong rtt, int nresend)
{
	ulong t;

	t = rtt;
	if(nresend &lt;= 1)
		{}
	else if(nresend &lt;= 3)
		t *= 2;
	else if(nresend &lt;= 18)
		t &lt;&lt;= nresend-2;
	else
		t = 60*1000;
	if(t &gt; 60*1000)
		t = 60*1000;

	return t;
}

static void
rpcMuxThread(void *v)
{
	uchar *buf, *p, *ep;
	int i, n, nout, mout;
	ulong t, xidgen, tag;
	Alt a[5];
	Out *o, **out;
	SunRpc rpc;
	SunClient *cli;

	cli = v;
	mout = 16;
	nout = 0;
	out = emalloc(mout*sizeof(out[0]));
	xidgen = truerand();

	a[0].op = CHANRCV;
	a[0].c = cli-&gt;rpcchan;
	a[0].v = &amp;o;
	a[1].op = CHANNOP;
	a[1].c = cli-&gt;timerchan;
	a[1].v = nil;
	a[2].op = CHANRCV;
	a[2].c = cli-&gt;flushchan;
	a[2].v = &amp;tag;
	a[3].op = CHANRCV;
	a[3].c = cli-&gt;readchan;
	a[3].v = &amp;buf;
	a[4].op = CHANEND;

	for(;;){
		switch(alt(a)){
		case 0:	/* o = &lt;-rpcchan */
			if(o == nil)
				goto Done;
			cli-&gt;nsend++;
			/* set xid */
			o-&gt;xid = ++xidgen;
			if(cli-&gt;needcount)
				p = o-&gt;p+4;
			else
				p = o-&gt;p;
			p[0] = xidgen&gt;&gt;24;
			p[1] = xidgen&gt;&gt;16;
			p[2] = xidgen&gt;&gt;8;
			p[3] = xidgen;
			if(write(cli-&gt;fd, o-&gt;p, o-&gt;n) != o-&gt;n){
				free(o-&gt;p);
				o-&gt;p = nil;
				snprint(o-&gt;err, sizeof o-&gt;err, "write: %r");
				sendp(o-&gt;creply, 0);
				break;
			}
			if(nout &gt;= mout){
				mout *= 2;
				out = erealloc(out, mout*sizeof(out[0]));
			}
			o-&gt;st = msec();
			o-&gt;nresend = 0;
			o-&gt;t = o-&gt;st + twait(cli-&gt;rtt.avg, 0);
if(cli-&gt;chatty) fprint(2, "send %lux %lud %lud\n", o-&gt;xid, o-&gt;st, o-&gt;t);
			out[nout++] = o;
			a[1].op = CHANRCV;
			break;

		case 1:	/* &lt;-timerchan */
			t = msec();
			for(i=0; i&lt;nout; i++){
				o = out[i];
				if((int)(t - o-&gt;t) &gt; 0){
if(cli-&gt;chatty) fprint(2, "resend %lux %lud %lud\n", o-&gt;xid, t, o-&gt;t);
					if(cli-&gt;maxwait &amp;&amp; t - o-&gt;st &gt;= cli-&gt;maxwait){
						free(o-&gt;p);
						o-&gt;p = nil;
						strcpy(o-&gt;err, "timeout");
						sendp(o-&gt;creply, 0);
						out[i--] = out[--nout];
						continue;
					}
					cli-&gt;nresend++;
					o-&gt;nresend++;
					o-&gt;t = t + twait(cli-&gt;rtt.avg, o-&gt;nresend);
					if(write(cli-&gt;fd, o-&gt;p, o-&gt;n) != o-&gt;n){
						free(o-&gt;p);
						o-&gt;p = nil;
						snprint(o-&gt;err, sizeof o-&gt;err, "rewrite: %r");
						sendp(o-&gt;creply, 0);
						out[i--] = out[--nout];
						continue;
					}
				}
			}
			/* stop ticking if no work; rpcchan will turn it back on */
			if(nout == 0)
				a[1].op = CHANNOP;
			break;
			
		case 2:	/* tag = &lt;-flushchan */
			for(i=0; i&lt;nout; i++){
				o = out[i];
				if(o-&gt;tag == tag){
					out[i--] = out[--nout];
					strcpy(o-&gt;err, "flushed");
					free(o-&gt;p);
					o-&gt;p = nil;
					sendp(o-&gt;creply, 0);
				}
			}
			break;

		case 3:	/* buf = &lt;-readchan */
			p = buf;
			n = (p[0]&lt;&lt;24)|(p[1]&lt;&lt;16)|(p[2]&lt;&lt;8)|p[3];
			p += 4;
			ep = p+n;
			if(sunRpcUnpack(p, ep, &amp;p, &amp;rpc) &lt; 0){
				fprint(2, "in: %.*H unpack failed\n", n, buf+4);
				free(buf);
				break;
			}
			if(cli-&gt;chatty)
				fprint(2, "in: %B\n", &amp;rpc);
			if(rpc.iscall){
				fprint(2, "did not get reply\n");
				free(buf);
				break;
			}
			o = nil;
			for(i=0; i&lt;nout; i++){
				o = out[i];
				if(o-&gt;xid == rpc.xid)
					break;
			}
			if(i==nout){
				if(cli-&gt;chatty) fprint(2, "did not find waiting request\n");
				free(buf);
				break;
			}
			out[i] = out[--nout];
			free(o-&gt;p);
			o-&gt;p = nil;
			if(rpc.status == SunSuccess){
				o-&gt;p = buf;
				o-&gt;rpc = rpc;
			}else{
				o-&gt;p = nil;
				free(buf);
				sunErrstr(rpc.status);
				rerrstr(o-&gt;err, sizeof o-&gt;err);
			}
			sendp(o-&gt;creply, 0);
			break;
		}
	}
Done:
	free(out);
	sendp(cli-&gt;dying, 0);
}

SunClient*
sunDial(char *address)
{
	int fd;
	SunClient *cli;

	if((fd = dial(address, 0, 0, 0)) &lt; 0)
		return nil;

	cli = emalloc(sizeof(SunClient));
	cli-&gt;fd = fd;
	cli-&gt;maxwait = 15000;
	cli-&gt;rtt.avg = 1000;
	cli-&gt;dying = chancreate(sizeof(void*), 0);
	cli-&gt;rpcchan = chancreate(sizeof(Out*), 0);
	cli-&gt;timerchan = chancreate(sizeof(ulong), 0);
	cli-&gt;flushchan = chancreate(sizeof(ulong), 0);
	cli-&gt;readchan = chancreate(sizeof(uchar*), 0);
	if(strstr(address, "udp!")){
		cli-&gt;needcount = 0;
		cli-&gt;nettid = threadcreate(udpThread, cli, SunStackSize);
		cli-&gt;timertid = threadcreate(timerThread, cli, SunStackSize);
	}else{
		cli-&gt;needcount = 1;
		cli-&gt;nettid = threadcreate(netThread, cli, SunStackSize);
		/* assume reliable: don't need timer */
		/* BUG: netThread should know how to redial */
	}
	threadcreate(rpcMuxThread, cli, SunStackSize);

	return cli;
}

void
sunClientClose(SunClient *cli)
{
	int n;

	/*
	 * Threadints get you out of any stuck system calls
	 * or thread rendezvouses, but do nothing if the thread
	 * is in the ready state.  Keep interrupting until it takes.
	 */
	n = 0;
	if(!cli-&gt;timertid)
		n++;
	while(n &lt; 2){
		threadint(cli-&gt;nettid);
		if(cli-&gt;timertid)
			threadint(cli-&gt;timertid);
		yield();
		while(nbrecv(cli-&gt;dying, nil) == 1)
			n++;
	}

	sendp(cli-&gt;rpcchan, 0);
	recvp(cli-&gt;dying);

	/* everyone's gone: clean up */
	close(cli-&gt;fd);
	chanfree(cli-&gt;flushchan);
	chanfree(cli-&gt;readchan);
	chanfree(cli-&gt;timerchan);
	free(cli);
}
	
void
sunClientFlushRpc(SunClient *cli, ulong tag)
{
	sendul(cli-&gt;flushchan, tag);
}

void
sunClientProg(SunClient *cli, SunProg *p)
{
	if(cli-&gt;nprog%16 == 0)
		cli-&gt;prog = erealloc(cli-&gt;prog, (cli-&gt;nprog+16)*sizeof(cli-&gt;prog[0]));
	cli-&gt;prog[cli-&gt;nprog++] = p;
}

int
sunClientRpc(SunClient *cli, ulong tag, SunCall *tx, SunCall *rx, uchar **tofree)
{
	uchar *bp, *p, *ep;
	int i, n1, n2, n, nn;
	Out o;
	SunProg *prog;
	SunStatus ok;

	for(i=0; i&lt;cli-&gt;nprog; i++)
		if(cli-&gt;prog[i]-&gt;prog == tx-&gt;rpc.prog &amp;&amp; cli-&gt;prog[i]-&gt;vers == tx-&gt;rpc.vers)
			break;
	if(i==cli-&gt;nprog){
		werrstr("unknown sun rpc program %d version %d", tx-&gt;rpc.prog, tx-&gt;rpc.vers);
		return -1;
	}
	prog = cli-&gt;prog[i];

	if(cli-&gt;chatty){
		fprint(2, "out: %B\n", &amp;tx-&gt;rpc);
		fprint(2, "\t%C\n", tx);
	}

	n1 = sunRpcSize(&amp;tx-&gt;rpc);
	n2 = sunCallSize(prog, tx);

	n = n1+n2;
	if(cli-&gt;needcount)
		n += 4;

	bp = emalloc(n);
	ep = bp+n;
	p = bp;
	if(cli-&gt;needcount){
		nn = n-4;
		p[0] = (nn&gt;&gt;24)|0x80;
		p[1] = nn&gt;&gt;16;
		p[2] = nn&gt;&gt;8;
		p[3] = nn;
		p += 4;
	}
	if((ok = sunRpcPack(p, ep, &amp;p, &amp;tx-&gt;rpc)) != SunSuccess
	|| (ok = sunCallPack(prog, p, ep, &amp;p, tx)) != SunSuccess){
		sunErrstr(ok);
		free(bp);
		return -1;
	}
	if(p != ep){
		werrstr("rpc: packet size mismatch");
		free(bp);
		return -1;
	}

	memset(&amp;o, 0, sizeof o);
	o.creply = chancreate(sizeof(void*), 0);
	o.tag = tag;
	o.p = bp;
	o.n = n;

	sendp(cli-&gt;rpcchan, &amp;o);
	recvp(o.creply);
	chanfree(o.creply);

	if(o.p == nil){
		werrstr("%s", o.err);
		return -1;
	}

	p = o.rpc.data;
	ep = p+o.rpc.ndata;
	rx-&gt;rpc = o.rpc;
	rx-&gt;rpc.proc = tx-&gt;rpc.proc;
	rx-&gt;rpc.prog = tx-&gt;rpc.prog;
	rx-&gt;rpc.vers = tx-&gt;rpc.vers;
	rx-&gt;type = (rx-&gt;rpc.proc&lt;&lt;1)|1;
	if((ok = sunCallUnpack(prog, p, ep, &amp;p, rx)) != SunSuccess){
		sunErrstr(ok);
		werrstr("unpack: %r");
		free(o.p);
		return -1;
	}

	if(cli-&gt;chatty){
		fprint(2, "in: %B\n", &amp;rx-&gt;rpc);
		fprint(2, "in:\t%C\n", rx);
	}

	if(tofree)
		*tofree = o.p;
	else
		free(o.p);

	return 0;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

