<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libsunrpc/rpc.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libsunrpc/rpc.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include &lt;sunrpc.h&gt;

/*
 * RPC protocol constants
 */
enum
{
	RpcVersion = 2,

	/* msg type */
	MsgCall = 0,
	MsgReply = 1,

	/* reply stat */
	MsgAccepted = 0,
	MsgDenied = 1,

	/* accept stat */
	MsgSuccess = 0,
	MsgProgUnavail = 1,
	MsgProgMismatch = 2,
	MsgProcUnavail = 3,
	MsgGarbageArgs = 4,
	MsgSystemErr = 5,

	/* reject stat */
	MsgRpcMismatch = 0,
	MsgAuthError = 1,

	/* msg auth xxx */
	MsgAuthOk = 0,
	MsgAuthBadCred = 1,
	MsgAuthRejectedCred = 2,
	MsgAuthBadVerf = 3,
	MsgAuthRejectedVerf = 4,
	MsgAuthTooWeak = 5,
	MsgAuthInvalidResp = 6,
	MsgAuthFailed = 7,
};

SunStatus
sunRpcPack(uchar *a, uchar *ea, uchar **pa, SunRpc *rpc)
{
	u32int x;

	if(sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;xid) &lt; 0)
		goto Err;
	if(rpc-&gt;iscall){
		if(sunUint32Pack(a, ea, &amp;a, (x=MsgCall, &amp;x)) &lt; 0
		|| sunUint32Pack(a, ea, &amp;a, (x=RpcVersion, &amp;x)) &lt; 0
		|| sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;prog) &lt; 0
		|| sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;vers) &lt; 0
		|| sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;proc) &lt; 0
		|| sunAuthInfoPack(a, ea, &amp;a, &amp;rpc-&gt;cred) &lt; 0
		|| sunAuthInfoPack(a, ea, &amp;a, &amp;rpc-&gt;verf) &lt; 0
		|| sunFixedOpaquePack(a, ea, &amp;a, rpc-&gt;data, rpc-&gt;ndata) &lt; 0)
			goto Err;
	}else{
		if(sunUint32Pack(a, ea, &amp;a, (x=MsgReply, &amp;x)) &lt; 0)
			goto Err;
		switch(rpc-&gt;status&amp;0xF0000){
		case 0:
		case SunAcceptError:
			if(sunUint32Pack(a, ea, &amp;a, (x=MsgAccepted, &amp;x)) &lt; 0
			|| sunAuthInfoPack(a, ea, &amp;a, &amp;rpc-&gt;verf) &lt; 0)
				goto Err;
			break;
		default:
			if(sunUint32Pack(a, ea, &amp;a, (x=MsgDenied, &amp;x)) &lt; 0)
				goto Err;
			break;
		}

		switch(rpc-&gt;status){
		case SunSuccess:
			if(sunUint32Pack(a, ea, &amp;a, (x=MsgSuccess, &amp;x)) &lt; 0
			|| sunFixedOpaquePack(a, ea, &amp;a, rpc-&gt;data, rpc-&gt;ndata) &lt; 0)
				goto Err;
			break;
		case SunRpcMismatch:
		case SunProgMismatch:
			if(sunUint32Pack(a, ea, &amp;a, (x=rpc-&gt;status&amp;0xFFFF, &amp;x)) &lt; 0
			|| sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;low) &lt; 0
			|| sunUint32Pack(a, ea, &amp;a, &amp;rpc-&gt;high) &lt; 0)
				goto Err;
			break;
		default:
			if(sunUint32Pack(a, ea, &amp;a, (x=rpc-&gt;status&amp;0xFFFF, &amp;x)) &lt; 0)
				goto Err;
			break;
		}
	}
	*pa = a;
	return SunSuccess;

Err:
	*pa = ea;
	return SunGarbageArgs;
}

uint
sunRpcSize(SunRpc *rpc)
{
	uint a;

	a = 4;
	if(rpc-&gt;iscall){
		a += 5*4;
		a += sunAuthInfoSize(&amp;rpc-&gt;cred);
		a += sunAuthInfoSize(&amp;rpc-&gt;verf);
		a += sunFixedOpaqueSize(rpc-&gt;ndata);
	}else{
		a += 4;
		switch(rpc-&gt;status&amp;0xF0000){
		case 0:
		case SunAcceptError:
			a += 4+sunAuthInfoSize(&amp;rpc-&gt;verf);
			break;
		default:
			a += 4;
			break;
		}

		switch(rpc-&gt;status){
		case SunSuccess:
			a += 4+sunFixedOpaqueSize(rpc-&gt;ndata);
			break;
		case SunRpcMismatch:
		case SunProgMismatch:
			a += 3*4;
		default:
			a += 4;
		}
	}
	return a;
}

SunStatus
sunRpcUnpack(uchar *a, uchar *ea, uchar **pa, SunRpc *rpc)
{
	u32int x;

	memset(rpc, 0, sizeof *rpc);
	if(sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;xid) &lt; 0
	|| sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0)
		goto Err;

	switch(x){
	default:
		goto Err;
	case MsgCall:
		rpc-&gt;iscall = 1;
		if(sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0 || x != RpcVersion
		|| sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;prog) &lt; 0
		|| sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;vers) &lt; 0
		|| sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;proc) &lt; 0
		|| sunAuthInfoUnpack(a, ea, &amp;a, &amp;rpc-&gt;cred) &lt; 0
		|| sunAuthInfoUnpack(a, ea, &amp;a, &amp;rpc-&gt;verf) &lt; 0)
			goto Err;
		rpc-&gt;ndata = ea-a;
		rpc-&gt;data = a;
		a = ea;
		break;

	case MsgReply:
		rpc-&gt;iscall = 0;
		if(sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0)
			goto Err;
		switch(x){
		default:
			goto Err;
		case MsgAccepted:
			if(sunAuthInfoUnpack(a, ea, &amp;a, &amp;rpc-&gt;verf) &lt; 0
			|| sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0)
				goto Err;
			switch(x){
			case MsgSuccess:
				rpc-&gt;status = SunSuccess;
				rpc-&gt;ndata = ea-a;
				rpc-&gt;data = a;
				a = ea;
				break;
			case MsgProgUnavail:
			case MsgProcUnavail:
			case MsgGarbageArgs:
			case MsgSystemErr:
				rpc-&gt;status = SunAcceptError | x;
				break;
			case MsgProgMismatch:
				rpc-&gt;status = SunAcceptError | x;
				if(sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;low) &lt; 0
				|| sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;high) &lt; 0)
					goto Err;
				break;
			}
			break;
		case MsgDenied:
			if(sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0)
				goto Err;
			switch(x){
			default:
				goto Err;
			case MsgAuthError:
				if(sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0)
					goto Err;
				rpc-&gt;status = SunAuthError | x;
				break;
			case MsgRpcMismatch:
				rpc-&gt;status = SunRejectError | x;
				if(sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;low) &lt; 0
				|| sunUint32Unpack(a, ea, &amp;a, &amp;rpc-&gt;high) &lt; 0)
					goto Err;
				break;
			}
			break;
		}
	}
	*pa = a;
	return SunSuccess;

Err:
	*pa = ea;
	return SunGarbageArgs;
}

void
sunRpcPrint(Fmt *fmt, SunRpc *rpc)
{
	fmtprint(fmt, "xid=%#ux", rpc-&gt;xid);
	if(rpc-&gt;iscall){
		fmtprint(fmt, " prog %#ux vers %#ux proc %#ux [", rpc-&gt;prog, rpc-&gt;vers, rpc-&gt;proc);
		sunAuthInfoPrint(fmt, &amp;rpc-&gt;cred);
		fmtprint(fmt, "] [");
		sunAuthInfoPrint(fmt, &amp;rpc-&gt;verf);
		fmtprint(fmt, "]");
	}else{
		fmtprint(fmt, " status %#ux [", rpc-&gt;status);
		sunAuthInfoPrint(fmt, &amp;rpc-&gt;verf);
		fmtprint(fmt, "] low %#ux high %#ux", rpc-&gt;low, rpc-&gt;high);
	}
}

void
sunAuthInfoPrint(Fmt *fmt, SunAuthInfo *ai)
{
	switch(ai-&gt;flavor){
	case SunAuthNone:
		fmtprint(fmt, "none");
		break;
	case SunAuthShort:
		fmtprint(fmt, "short");
		break;
	case SunAuthSys:
		fmtprint(fmt, "sys");
		break;
	default:
		fmtprint(fmt, "%#ux", ai-&gt;flavor);
		break;
	}
//	if(ai-&gt;ndata)
//		fmtprint(fmt, " %.*H", ai-&gt;ndata, ai-&gt;data);
}

uint
sunAuthInfoSize(SunAuthInfo *ai)
{
	return 4 + sunVarOpaqueSize(ai-&gt;ndata);
}

int
sunAuthInfoPack(uchar *a, uchar *ea, uchar **pa, SunAuthInfo *ai)
{
	if(sunUint32Pack(a, ea, &amp;a, &amp;ai-&gt;flavor) &lt; 0
	|| sunVarOpaquePack(a, ea, &amp;a, &amp;ai-&gt;data, &amp;ai-&gt;ndata, 400) &lt; 0)
		goto Err;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunAuthInfoUnpack(uchar *a, uchar *ea, uchar **pa, SunAuthInfo *ai)
{
	if(sunUint32Unpack(a, ea, &amp;a, &amp;ai-&gt;flavor) &lt; 0
	|| sunVarOpaqueUnpack(a, ea, &amp;a, &amp;ai-&gt;data, &amp;ai-&gt;ndata, 400) &lt; 0)
		goto Err;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunEnumPack(uchar *a, uchar *ea, uchar **pa, int *e)
{
	u32int x;

	x = *e;
	return sunUint32Pack(a, ea, pa, &amp;x);
}

int
sunUint1Pack(uchar *a, uchar *ea, uchar **pa, u1int *u)
{
	u32int x;

	x = *u;
	return sunUint32Pack(a, ea, pa, &amp;x);
}

int
sunUint32Pack(uchar *a, uchar *ea, uchar **pa, u32int *u)
{
	u32int x;

	if(ea-a &lt; 4)
		goto Err;

	x = *u;
	*a++ = x&gt;&gt;24;
	*a++ = x&gt;&gt;16;
	*a++ = x&gt;&gt;8;
	*a++ = x;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunEnumUnpack(uchar *a, uchar *ea, uchar **pa, int *e)
{
	u32int x;
	if(sunUint32Unpack(a, ea, pa, &amp;x) &lt; 0)
		return -1;
	*e = x;
	return 0;
}

int
sunUint1Unpack(uchar *a, uchar *ea, uchar **pa, u1int *u)
{
	u32int x;
	if(sunUint32Unpack(a, ea, pa, &amp;x) &lt; 0 || (x!=0 &amp;&amp; x!=1)){
		*pa = ea;
		return -1;
	}
	*u = x;
	return 0;
}

int
sunUint32Unpack(uchar *a, uchar *ea, uchar **pa, u32int *u)
{
	u32int x;

	if(ea-a &lt; 4)
		goto Err;
	x = *a++ &lt;&lt; 24;
	x |= *a++ &lt;&lt; 16;
	x |= *a++ &lt;&lt; 8;
	x |= *a++;
	*pa = a;
	*u = x;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunUint64Unpack(uchar *a, uchar *ea, uchar **pa, u64int *u)
{
	u32int x, y;

	if(sunUint32Unpack(a, ea, &amp;a, &amp;x) &lt; 0
	|| sunUint32Unpack(a, ea, &amp;a, &amp;y) &lt; 0)
		goto Err;
	*u = ((uvlong)x&lt;&lt;32) | y;
	*pa = a;
	return 0;
Err:
	*pa = ea;
	return -1;
}

int
sunUint64Pack(uchar *a, uchar *ea, uchar **pa, u64int *u)
{
	u32int x, y;

	x = *u &gt;&gt; 32;
	y = *u;
	if(sunUint32Pack(a, ea, &amp;a, &amp;x) &lt; 0
	|| sunUint32Pack(a, ea, &amp;a, &amp;y) &lt; 0)
		goto Err;
	*pa = a;
	return 0;
Err:
	*pa = ea;
	return -1;
}

uint
sunStringSize(char *s)
{
	return (4+strlen(s)+3) &amp; ~3;
}

int
sunStringUnpack(uchar *a, uchar *ea, uchar **pa, char **s, u32int max)
{
	uchar *dat;
	u32int n;

	if(sunVarOpaqueUnpack(a, ea, pa, &amp;dat, &amp;n, max) &lt; 0)
		goto Err;
	/* slide string down over length to make room for NUL */
	memmove(dat-1, dat, n);
	dat[-1+n] = 0;
	*s = (char*)(dat-1);
	return 0;
Err:
	return -1;
}

int
sunStringPack(uchar *a, uchar *ea, uchar **pa, char **s, u32int max)
{
	u32int n;

	n = strlen(*s);
	return sunVarOpaquePack(a, ea, pa, (uchar**)s, &amp;n, max);
}

uint
sunVarOpaqueSize(u32int n)
{
	return (4+n+3) &amp; ~3;
}

int
sunVarOpaquePack(uchar *a, uchar *ea, uchar **pa, uchar **dat, u32int *ndat, u32int max)
{
	if(*ndat &gt; max || sunUint32Pack(a, ea, &amp;a, ndat) &lt; 0
	|| sunFixedOpaquePack(a, ea, &amp;a, *dat, *ndat) &lt; 0)
		goto Err;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunVarOpaqueUnpack(uchar *a, uchar *ea, uchar **pa, uchar **dat, u32int *ndat, u32int max)
{
	if(sunUint32Unpack(a, ea, &amp;a, ndat) &lt; 0
	|| *ndat &gt; max)
		goto Err;
	*dat = a;
	a += (*ndat+3)&amp;~3;
	if(a &gt; ea)
		goto Err;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

uint
sunFixedOpaqueSize(u32int n)
{
	return (n+3) &amp; ~3;
}

int
sunFixedOpaquePack(uchar *a, uchar *ea, uchar **pa, uchar *dat, u32int n)
{
	uint nn;

	nn = (n+3)&amp;~3;
	if(a+nn &gt; ea)
		goto Err;
	memmove(a, dat, n);
	if(nn &gt; n)
		memset(a+n, 0, nn-n);
	a += nn;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

int
sunFixedOpaqueUnpack(uchar *a, uchar *ea, uchar **pa, uchar *dat, u32int n)
{
	uint nn;

	nn = (n+3)&amp;~3;
	if(a+nn &gt; ea)
		goto Err;
	memmove(dat, a, n);
	a += nn;
	*pa = a;
	return 0;

Err:
	*pa = ea;
	return -1;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

