<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libthread/rendez.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libthread/rendez.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;thread.h&gt;
#include "threadimpl.h"

Rgrp _threadrgrp;
static int isdirty;

static void*
finish(Thread *t, void *val)
{
	void *ret;

	ret = t-&gt;rendval;
	t-&gt;rendval = val;
	while(t-&gt;state == Running)
		sleep(0);
	lock(&amp;t-&gt;proc-&gt;lock);
	if(t-&gt;state == Rendezvous){	/* not always true: might be Dead */
		t-&gt;state = Ready;
		_threadready(t);
	}
	unlock(&amp;t-&gt;proc-&gt;lock);
	return ret;
}

void*
_threadrendezvous(void *tag, void *val)
{
	void *ret;
	Thread *t, **l;

	lock(&amp;_threadrgrp.lock);
	l = &amp;_threadrgrp.hash[((uintptr)tag)%nelem(_threadrgrp.hash)];
	for(t=*l; t; l=&amp;t-&gt;rendhash, t=*l){
		if(t-&gt;rendtag==tag){
			_threaddebug(DBGREND, "Rendezvous with thread %d.%d", t-&gt;proc-&gt;pid, t-&gt;id);
			*l = t-&gt;rendhash;
			ret = finish(t, val);
			unlock(&amp;_threadrgrp.lock);
			return ret;
		}
	}

	/* Going to sleep here. */
	t = _threadgetproc()-&gt;thread;
	t-&gt;rendbreak = 0;
	t-&gt;inrendez = 1;
	t-&gt;rendtag = tag;
	t-&gt;rendval = val;
	t-&gt;rendhash = *l;
	*l = t;
	t-&gt;nextstate = Rendezvous;
	_threaddebug(DBGREND, "Rendezvous for tag %p", t-&gt;rendtag);
	unlock(&amp;_threadrgrp.lock);
	_sched();
	t-&gt;inrendez = 0;
	_threaddebug(DBGREND, "Woke after rendezvous; val is %p", t-&gt;rendval);
	return t-&gt;rendval;
}

/*
 * This is called while holding _threadpq.lock and p-&gt;lock,
 * so we can't lock _threadrgrp.lock.  Instead our caller has 
 * to call _threadbreakrendez after dropping those locks.
 */
void
_threadflagrendez(Thread *t)
{
	t-&gt;rendbreak = 1;
	isdirty = 1;
}

void
_threadbreakrendez(void)
{
	int i;
	Thread *t, **l;

	if(isdirty == 0)
		return;
	lock(&amp;_threadrgrp.lock);
	if(isdirty == 0){
		unlock(&amp;_threadrgrp.lock);
		return;
	}
	isdirty = 0;
	for(i=0; i&lt;nelem(_threadrgrp.hash); i++){
		l = &amp;_threadrgrp.hash[i];
		for(t=*l; t; t=*l){
			if(t-&gt;rendbreak){
				*l = t-&gt;rendhash;
				finish(t, (void*)~0);
			}else
				 l=&amp;t-&gt;rendhash;
		}
	}
	unlock(&amp;_threadrgrp.lock);
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

