<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/log.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/log.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;

char *VtServerLog = "libventi/server";

int ventilogging;
#define log	not_the_log_library_call

static char Eremoved[] = "[removed]";

enum
{	/* defaults */
	LogChunkSize = 8192,
	LogSize = 65536
};

static struct {
	QLock lk;
	VtLog *hash[1024];
} vl;

static uint
hash(char *s)
{
	uint h;
	uchar *p;

	h = 0;
	for(p=(uchar*)s; *p; p++)
		h = h*37 + *p;
	return h;
}

char**
vtlognames(int *pn)
{
	int i, nname, size;
	VtLog *l;
	char **s, *a, *e;
	
	qlock(&amp;vl.lk);
	size = 0;
	nname = 0;
	for(i=0; i&lt;nelem(vl.hash); i++)
	for(l=vl.hash[i]; l; l=l-&gt;next){
		nname++;
		size += strlen(l-&gt;name)+1;
	}
	
	s = vtmalloc(nname*sizeof(char*)+size);
	a = (char*)(s+nname);
	e = (char*)s+nname*sizeof(char*)+size;

	nname = 0;
	for(i=0; i&lt;nelem(vl.hash); i++)
	for(l=vl.hash[i]; l; l=l-&gt;next){
		strcpy(a, l-&gt;name);
		s[nname++] = a;
		a += strlen(a)+1;
	}
	*pn = nname;
	assert(a == e);
	qunlock(&amp;vl.lk);

	return s;
}

VtLog*
vtlogopen(char *name, uint size)
{
	uint h;
	int i, nc;
	char *p;
	VtLog *l, *last;

	if(!ventilogging)
		return nil;

	h = hash(name)%nelem(vl.hash);
	qlock(&amp;vl.lk);
	last = nil;
	for(l=vl.hash[h]; l; last=l, l=l-&gt;next)
		if(strcmp(l-&gt;name, name) == 0){
			if(last){	/* move to front */
				last-&gt;next = l-&gt;next;
				l-&gt;next = vl.hash[h];
				vl.hash[h] = l;
			}
			l-&gt;ref++;
			qunlock(&amp;vl.lk);
			return l;
		}

	if(size == 0){
		qunlock(&amp;vl.lk);
		return nil;
	}

	/* allocate */
	nc = (size+LogChunkSize-1)/LogChunkSize;
	l = vtmalloc(sizeof *l + nc*(sizeof(*l-&gt;chunk)+LogChunkSize) + strlen(name)+1);
	memset(l, 0, sizeof *l);
	l-&gt;chunk = (VtLogChunk*)(l+1);
	l-&gt;nchunk = nc;
	l-&gt;w = l-&gt;chunk;
	p = (char*)(l-&gt;chunk+nc);
	for(i=0; i&lt;nc; i++){
		l-&gt;chunk[i].p = p;
		l-&gt;chunk[i].wp = p;
		p += LogChunkSize;
		l-&gt;chunk[i].ep = p;
	}
	strcpy(p, name);
	l-&gt;name = p;
	
	/* insert */
	l-&gt;next = vl.hash[h];
	vl.hash[h] = l;
	l-&gt;ref++;
	
	l-&gt;ref++;
	qunlock(&amp;vl.lk);
	return l;
}

void
vtlogclose(VtLog *l)
{
	if(l == nil)
		return;

	qlock(&amp;vl.lk);
	if(--l-&gt;ref == 0){
		/* must not be in hash table */
		assert(l-&gt;name == Eremoved);
		free(l);
	}else
		assert(l-&gt;ref &gt; 0);
	qunlock(&amp;vl.lk);
}

void
vtlogremove(char *name)
{
	uint h;
	VtLog *last, *l;

	h = hash(name)%nelem(vl.hash);
	qlock(&amp;vl.lk);
	last = nil;
	for(l=vl.hash[h]; l; last=l, l=l-&gt;next)
		if(strcmp(l-&gt;name, name) == 0){
			if(last)
				last-&gt;next = l-&gt;next;
			else
				vl.hash[h] = l-&gt;next;
			l-&gt;name = Eremoved;
			l-&gt;next = nil;
			qunlock(&amp;vl.lk);
			vtlogclose(l);
			return;
		}
	qunlock(&amp;vl.lk);
}

static int
timefmt(Fmt *fmt)
{
	static uvlong t0;
	uvlong t;

	if(t0 == 0)
		t0 = nsec();
	t = nsec()-t0;
	return fmtprint(fmt, "T+%d.%04d", (uint)(t/1000000000), (uint)(t%1000000000)/100000);
}

void
vtlogvprint(VtLog *l, char *fmt, va_list arg)
{
	int n;
	char *p;
	VtLogChunk *c;
	static int first = 1;

	if(l == nil)
		return;
		
	if(first){
		fmtinstall('T', timefmt);
		first = 0;
	}
		
	
	qlock(&amp;l-&gt;lk);
	c = l-&gt;w;
	n = c-&gt;ep - c-&gt;wp;
	if(n &lt; 512){
		c++;
		if(c == l-&gt;chunk+l-&gt;nchunk)
			c = l-&gt;chunk;
		c-&gt;wp = c-&gt;p;
		l-&gt;w = c;
	}
	p = vseprint(c-&gt;wp, c-&gt;ep, fmt, arg);
	if(p)
		c-&gt;wp = p;
	qunlock(&amp;l-&gt;lk);
}

void
vtlogprint(VtLog *l, char *fmt, ...)
{
	va_list arg;
	
	if(l == nil)
		return;
		
	va_start(arg, fmt);
	vtlogvprint(l, fmt, arg);
	va_end(arg);
}

void
vtlog(char *name, char *fmt, ...)
{
	VtLog *l;
	va_list arg;

	l = vtlogopen(name, LogSize);
	if(l == nil)
		return;
	va_start(arg, fmt);
	vtlogvprint(l, fmt, arg);
	va_end(arg);
	vtlogclose(l);
}

void
vtlogdump(int fd, VtLog *l)
{
	int i;
	VtLogChunk *c;

	if(l == nil)
		return;
		
	c = l-&gt;w;
	for(i=0; i&lt;l-&gt;nchunk; i++){
		if(++c == l-&gt;chunk+l-&gt;nchunk)
			c = l-&gt;chunk;
		write(fd, c-&gt;p, c-&gt;wp-c-&gt;p);
	}
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

