<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/send.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/send.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;
#include "queue.h"

long ventisendbytes, ventisendpackets;
long ventirecvbytes, ventirecvpackets;

static int
_vtsend(VtConn *z, Packet *p)
{
	IOchunk ioc;
	int n, tot;
	uchar buf[2];

	if(z-&gt;state != VtStateConnected) {
		werrstr("session not connected");
		return -1;
	}

	/* add framing */
	n = packetsize(p);
	if(n &gt;= (1&lt;&lt;16)) {
		werrstr("packet too large");
		packetfree(p);
		return -1;
	}
	buf[0] = n&gt;&gt;8;
	buf[1] = n;
	packetprefix(p, buf, 2);
	ventisendbytes += n+2;
	ventisendpackets++;

	tot = 0;
	for(;;){
		n = packetfragments(p, &amp;ioc, 1, 0);
		if(n == 0)
			break;
		if(write(z-&gt;outfd, ioc.addr, ioc.len) &lt; ioc.len){
			vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; sending packet %p: %r&lt;br&gt;\n", z-&gt;addr, p);
			packetfree(p);
			return -1;
		}
		packetconsume(p, nil, ioc.len);
		tot += ioc.len;
	}
	vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; sent packet %p (%d bytes)&lt;br&gt;\n", z-&gt;addr, p, tot);
	packetfree(p);
	return 1;
}

static int
interrupted(void)
{
	char e[ERRMAX];

	rerrstr(e, sizeof e);
	return strstr(e, "interrupted") != nil;
}


static Packet*
_vtrecv(VtConn *z)
{
	uchar buf[10], *b;
	int n;
	Packet *p;
	int size, len;

	if(z-&gt;state != VtStateConnected) {
		werrstr("session not connected");
		return nil;
	}

	p = z-&gt;part;
	/* get enough for head size */
	size = packetsize(p);
	while(size &lt; 2) {
		b = packettrailer(p, 2);
		assert(b != nil);
		if(0) fprint(2, "%d read hdr\n", getpid());
		n = read(z-&gt;infd, b, 2);
		if(0) fprint(2, "%d got %d (%r)\n", getpid(), n);
		if(n==0 || (n&lt;0 &amp;&amp; !interrupted()))
			goto Err;
		size += n;
		packettrim(p, 0, size);
	}

	if(packetconsume(p, buf, 2) &lt; 0)
		goto Err;
	len = (buf[0] &lt;&lt; 8) | buf[1];
	size -= 2;

	while(size &lt; len) {
		n = len - size;
		if(n &gt; MaxFragSize)
			n = MaxFragSize;
		b = packettrailer(p, n);
		if(0) fprint(2, "%d read body %d\n", getpid(), n);
		n = read(z-&gt;infd, b, n);
		if(0) fprint(2, "%d got %d (%r)\n", getpid(), n);
		if(n &gt; 0)
			size += n;
		packettrim(p, 0, size);
		if(n==0 || (n&lt;0 &amp;&amp; !interrupted()))
			goto Err;
	}
	ventirecvbytes += len;
	ventirecvpackets++;
	p = packetsplit(p, len);
	vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; read packet %p len %d&lt;br&gt;\n", z-&gt;addr, p, len);
	return p;
Err:	
	vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; error reading packet: %r&lt;br&gt;\n", z-&gt;addr);
	return nil;	
}

/*
 * If you fork off two procs running vtrecvproc and vtsendproc,
 * then vtrecv/vtsend (and thus vtrpc) will never block except on 
 * rendevouses, which is nice when it's running in one thread of many.
 */
void
vtrecvproc(void *v)
{
	Packet *p;
	VtConn *z;
	Queue *q;

	z = v;
	q = _vtqalloc();

	qlock(&amp;z-&gt;lk);
	z-&gt;readq = q;
	qlock(&amp;z-&gt;inlk);
	rwakeup(&amp;z-&gt;rpcfork);
	qunlock(&amp;z-&gt;lk);

	while((p = _vtrecv(z)) != nil)
		if(_vtqsend(q, p) &lt; 0){
			packetfree(p);
			break;
		}
	qunlock(&amp;z-&gt;inlk);
	qlock(&amp;z-&gt;lk);
	_vtqhangup(q);
	while((p = _vtnbqrecv(q)) != nil)
		packetfree(p);
	_vtqdecref(q);
	z-&gt;readq = nil;
	rwakeup(&amp;z-&gt;rpcfork);
	qunlock(&amp;z-&gt;lk);
	vthangup(z);
}

void
vtsendproc(void *v)
{
	Queue *q;
	Packet *p;
	VtConn *z;

	z = v;
	q = _vtqalloc();

	qlock(&amp;z-&gt;lk);
	z-&gt;writeq = q;
	qlock(&amp;z-&gt;outlk);
	rwakeup(&amp;z-&gt;rpcfork);
	qunlock(&amp;z-&gt;lk);

	while((p = _vtqrecv(q)) != nil)
		if(_vtsend(z, p) &lt; 0)
			break;
	qunlock(&amp;z-&gt;outlk);
	qlock(&amp;z-&gt;lk);
	_vtqhangup(q);
	while((p = _vtnbqrecv(q)) != nil)
		packetfree(p);
	_vtqdecref(q);
	z-&gt;writeq = nil;
	rwakeup(&amp;z-&gt;rpcfork);
	qunlock(&amp;z-&gt;lk);
	return;
}

Packet*
vtrecv(VtConn *z)
{
	Packet *p;
	Queue *q;

	qlock(&amp;z-&gt;lk);
	if(z-&gt;state != VtStateConnected){
		werrstr("not connected");
		qunlock(&amp;z-&gt;lk);
		return nil;
	}
	if(z-&gt;readq){
		q = _vtqincref(z-&gt;readq);
		qunlock(&amp;z-&gt;lk);
		p = _vtqrecv(q);
		_vtqdecref(q);
		return p;
	}

	qlock(&amp;z-&gt;inlk);
	qunlock(&amp;z-&gt;lk);
	p = _vtrecv(z);
	qunlock(&amp;z-&gt;inlk);
	if(!p)
		vthangup(z);
	return p;
}

int
vtsend(VtConn *z, Packet *p)
{
	Queue *q;

	qlock(&amp;z-&gt;lk);
	if(z-&gt;state != VtStateConnected){
		packetfree(p);
		werrstr("not connected");
		qunlock(&amp;z-&gt;lk);
		return -1;
	}
	if(z-&gt;writeq){
		q = _vtqincref(z-&gt;writeq);
		qunlock(&amp;z-&gt;lk);
		if(_vtqsend(q, p) &lt; 0){
			_vtqdecref(q);
			packetfree(p);
			return -1;
		}
		_vtqdecref(q);
		return 0;
	}

	qlock(&amp;z-&gt;outlk);
	qunlock(&amp;z-&gt;lk);
	if(_vtsend(z, p) &lt; 0){
		qunlock(&amp;z-&gt;outlk);
		vthangup(z);
		return -1;	
	}
	qunlock(&amp;z-&gt;outlk);
	return 0;
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

