<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/libventi/server.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/libventi/server.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;venti.h&gt;
#include &lt;thread.h&gt;
#include "queue.h"

enum
{
	STACK = 8192
};

typedef struct VtSconn VtSconn;
struct VtSconn
{
	int ctl;
	int ref;
	QLock lk;
	char dir[NETPATHLEN];
	VtSrv *srv;
	VtConn *c;
};

struct VtSrv
{
	int afd;
	int dead;
	char adir[NETPATHLEN];
	Queue *q;	/* Queue(VtReq*) */
};

static void listenproc(void*);
static void connproc(void*);

static void
scincref(VtSconn *sc)
{
	qlock(&amp;sc-&gt;lk);
	sc-&gt;ref++;
	qunlock(&amp;sc-&gt;lk);
}

static void
scdecref(VtSconn *sc)
{
	qlock(&amp;sc-&gt;lk);
	if(--sc-&gt;ref &gt; 0){
		qunlock(&amp;sc-&gt;lk);
		return;
	}
	if(sc-&gt;c)
		vtfreeconn(sc-&gt;c);
	vtfree(sc);
}

VtSrv*
vtlisten(char *addr)
{
	VtSrv *s;

	s = vtmallocz(sizeof(VtSrv));
	s-&gt;afd = announce(addr, s-&gt;adir);
	if(s-&gt;afd &lt; 0){
		free(s);
		return nil;
	}
	s-&gt;q = _vtqalloc();
	proccreate(listenproc, s, STACK);
	return s;
}

static void
listenproc(void *v)
{
	int ctl;
	char dir[NETPATHLEN];
	VtSrv *srv;
	VtSconn *sc;

	srv = v;
	for(;;){
		ctl = listen(srv-&gt;adir, dir);
		if(ctl &lt; 0){
			srv-&gt;dead = 1;
			break;
		}
		sc = vtmallocz(sizeof(VtSconn));
		sc-&gt;ref = 1;
		sc-&gt;ctl = ctl;
		sc-&gt;srv = srv;
		strcpy(sc-&gt;dir, dir);
		proccreate(connproc, sc, STACK);
	}

	/* hangup */
}

static void
connproc(void *v)
{
	VtSconn *sc;
	VtConn *c;
	Packet *p;
	VtReq *r;
	int fd;
static int first=1;

if(first &amp;&amp; chattyventi){
	first=0;
	fmtinstall('F', vtfcallfmt);
}
	r = nil;
	sc = v;
	sc-&gt;c = nil;
	if(0) fprint(2, "new call %s on %d\n", sc-&gt;dir, sc-&gt;ctl);
	fd = accept(sc-&gt;ctl, sc-&gt;dir);
	close(sc-&gt;ctl);
	if(fd &lt; 0){
		fprint(2, "accept %s: %r\n", sc-&gt;dir);
		goto out;
	}

	c = vtconn(fd, fd);
	sc-&gt;c = c;
	if(vtversion(c) &lt; 0){
		fprint(2, "vtversion %s: %r\n", sc-&gt;dir);
		goto out;
	}
	if(vtsrvhello(c) &lt; 0){
		fprint(2, "vtsrvhello %s: %r\n", sc-&gt;dir);
		goto out;
	}

	if(0) fprint(2, "new proc %s\n", sc-&gt;dir);
	proccreate(vtsendproc, c, STACK);
	qlock(&amp;c-&gt;lk);
	while(!c-&gt;writeq)
		rsleep(&amp;c-&gt;rpcfork);
	qunlock(&amp;c-&gt;lk);

	while((p = vtrecv(c)) != nil){
		r = vtmallocz(sizeof(VtReq));
		if(vtfcallunpack(&amp;r-&gt;tx, p) &lt; 0){
			vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; recv bad packet %p: %r&lt;br&gt;\n", c-&gt;addr, p);
			fprint(2, "bad packet on %s: %r\n", sc-&gt;dir);
			packetfree(p);
			continue;
		}
		vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; recv packet %p (%F)&lt;br&gt;\n", c-&gt;addr, p, &amp;r-&gt;tx);
		if(chattyventi)
			fprint(2, "%s &lt;- %F\n", argv0, &amp;r-&gt;tx);
		packetfree(p);
		if(r-&gt;tx.msgtype == VtTgoodbye)
			break;
		r-&gt;rx.tag = r-&gt;tx.tag;
		r-&gt;sc = sc;
		scincref(sc);
		if(_vtqsend(sc-&gt;srv-&gt;q, r) &lt; 0){
			scdecref(sc);
			fprint(2, "hungup queue\n");
			break;
		}
		r = nil;
	}

	if(0) fprint(2, "eof on %s\n", sc-&gt;dir);

out:
	if(r){
		vtfcallclear(&amp;r-&gt;tx);
		vtfree(r);
	}
	if(0) fprint(2, "freed %s\n", sc-&gt;dir);
	scdecref(sc);
	return;
}

VtReq*
vtgetreq(VtSrv *srv)
{
	VtReq *r;
	
	r = _vtqrecv(srv-&gt;q);
	if (r != nil)
		vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; vtgetreq %F&lt;br&gt;\n",
			((VtSconn*)r-&gt;sc)-&gt;c-&gt;addr, &amp;r-&gt;tx);
	return r;
}

void
vtrespond(VtReq *r)
{
	Packet *p;
	VtSconn *sc;

	sc = r-&gt;sc;
	if(r-&gt;rx.tag != r-&gt;tx.tag)
		abort();
	if(r-&gt;rx.msgtype != r-&gt;tx.msgtype+1 &amp;&amp; r-&gt;rx.msgtype != VtRerror)
		abort();
	if(chattyventi)
		fprint(2, "%s -&gt; %F\n", argv0, &amp;r-&gt;rx);
	if((p = vtfcallpack(&amp;r-&gt;rx)) == nil){
		vtlog(VtServerLog, "%s: vtfcallpack %F: %r&lt;br&gt;\n", sc-&gt;c-&gt;addr, &amp;r-&gt;rx);
		fprint(2, "fcallpack on %s: %r\n", sc-&gt;dir);
		packetfree(p);
		vtfcallclear(&amp;r-&gt;rx);
		return;
	}
	vtlog(VtServerLog, "&lt;font size=-1&gt;%T %s:&lt;/font&gt; send packet %p (%F)&lt;br&gt;\n", sc-&gt;c-&gt;addr, p, &amp;r-&gt;rx);
	if(vtsend(sc-&gt;c, p) &lt; 0)
		fprint(2, "vtsend %F: %r\n", &amp;r-&gt;rx);
	scdecref(sc);
	vtfcallclear(&amp;r-&gt;tx);
	vtfcallclear(&amp;r-&gt;rx);
	vtfree(r);
}

<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

