<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf8">
<title>/n/sources/plan9/sys/src/cmd/ip/imap4d/fetch.c - Plan 9 from Bell Labs</title>
<!-- THIS FILE IS AUTOMATICALLY GENERATED. -->
<!-- EDIT sources.tr INSTEAD. -->
</meta>
</head>
<body>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"><a href="http://plan9.bell-labs.com/plan9/">Plan 9 from Bell Labs</a>&rsquo;s /n/sources/plan9/sys/src/cmd/ip/imap4d/fetch.c</span></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
Copyright © 2009 Alcatel-Lucent.<br />
Distributed under the
<a href="http://plan9.bell-labs.com/plan9/license.html">Lucent Public License version 1.02</a>.
<br />
<a href="http://plan9.bell-labs.com/plan9/download.html">Download the Plan 9 distribution.</a>
</font>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<table width="100%" cellspacing=0 border=0><tr><td align="center">
<table cellspacing=0 cellpadding=5 bgcolor="#eeeeff"><tr><td align="left">
<pre>
<!-- END HEADER -->
#include &lt;u.h&gt;
#include &lt;libc.h&gt;
#include &lt;bio.h&gt;
#include &lt;auth.h&gt;
#include "imap4d.h"

char *fetchPartNames[FPMax] =
{
	"",
	"HEADER",
	"HEADER.FIELDS",
	"HEADER.FIELDS.NOT",
	"MIME",
	"TEXT",
};

/*
 * implicitly set the \seen flag.  done in a separate pass
 * so the .imp file doesn't need to be open while the
 * messages are sent to the client.
 */
int
fetchSeen(Box *box, Msg *m, int uids, void *vf)
{
	Fetch *f;

	USED(uids);

	if(m-&gt;expunged)
		return uids;
	for(f = vf; f != nil; f = f-&gt;next){
		switch(f-&gt;op){
		case FRfc822:
		case FRfc822Text:
		case FBodySect:
			msgSeen(box, m);
			goto breakout;
		}
	}
breakout:

	return 1;
}

/*
 * fetch messages
 *
 * imap4 body[] requestes get translated to upas/fs files as follows
 *	body[id.header] == id/rawheader file + extra \r\n
 *	body[id.text] == id/rawbody
 *	body[id.mime] == id/mimeheader + extra \r\n
 *	body[id] === body[id.header] + body[id.text]
*/
int
fetchMsg(Box *, Msg *m, int uids, void *vf)
{
	Tm tm;
	Fetch *f;
	char *sep;
	int todo;

	if(m-&gt;expunged)
		return uids;

	todo = 0;
	for(f = vf; f != nil; f = f-&gt;next){
		switch(f-&gt;op){
		case FFlags:
			todo = 1;
			break;
		case FUid:
			todo = 1;
			break;
		case FInternalDate:
		case FEnvelope:
		case FRfc822:
		case FRfc822Head:
		case FRfc822Size:
		case FRfc822Text:
		case FBodySect:
		case FBodyPeek:
		case FBody:
		case FBodyStruct:
			todo = 1;
			if(!msgStruct(m, 1)){
				msgDead(m);
				return uids;
			}
			break;
		default:
			bye("bad implementation of fetch");
			return 0;
		}
	}

	if(m-&gt;expunged)
		return uids;
	if(!todo)
		return 1;

	/*
	 * note: it is allowed to send back the responses one at a time
	 * rather than all together.  this is exploited to send flags elsewhere.
	 */
	Bprint(&amp;bout, "* %lud FETCH (", m-&gt;seq);
	sep = "";
	if(uids){
		Bprint(&amp;bout, "UID %lud", m-&gt;uid);
		sep = " ";
	}
	for(f = vf; f != nil; f = f-&gt;next){
		switch(f-&gt;op){
		default:
			bye("bad implementation of fetch");
			break;
		case FFlags:
			Bprint(&amp;bout, "%sFLAGS (", sep);
			writeFlags(&amp;bout, m, 1);
			Bprint(&amp;bout, ")");
			break;
		case FUid:
			if(uids)
				continue;
			Bprint(&amp;bout, "%sUID %lud", sep, m-&gt;uid);
			break;
		case FEnvelope:
			Bprint(&amp;bout, "%sENVELOPE ", sep);
			fetchEnvelope(m);
			break;
		case FInternalDate:
			Bprint(&amp;bout, "%sINTERNALDATE ", sep);
			Bimapdate(&amp;bout, date2tm(&amp;tm, m-&gt;unixDate));
			break;
		case FBody:
			Bprint(&amp;bout, "%sBODY ", sep);
			fetchBodyStruct(m, &amp;m-&gt;head, 0);
			break;
		case FBodyStruct:
			Bprint(&amp;bout, "%sBODYSTRUCTURE ", sep);
			fetchBodyStruct(m, &amp;m-&gt;head, 1);
			break;
		case FRfc822Size:
			Bprint(&amp;bout, "%sRFC822.SIZE %lud", sep, msgSize(m));
			break;
		case FRfc822:
			f-&gt;part = FPAll;
			Bprint(&amp;bout, "%sRFC822", sep);
			fetchBody(m, f);
			break;
		case FRfc822Head:
			f-&gt;part = FPHead;
			Bprint(&amp;bout, "%sRFC822.HEADER", sep);
			fetchBody(m, f);
			break;
		case FRfc822Text:
			f-&gt;part = FPText;
			Bprint(&amp;bout, "%sRFC822.TEXT", sep);
			fetchBody(m, f);
			break;
		case FBodySect:
		case FBodyPeek:
			Bprint(&amp;bout, "%sBODY", sep);
			fetchBody(fetchSect(m, f), f);
			break;
		}
		sep = " ";
	}
	Bprint(&amp;bout, ")\r\n");

	return 1;
}

/*
 * print out section, part, headers;
 * find and return message section
 */
Msg *
fetchSect(Msg *m, Fetch *f)
{
	Bputc(&amp;bout, '[');
	BNList(&amp;bout, f-&gt;sect, ".");
	if(f-&gt;part != FPAll){
		if(f-&gt;sect != nil)
			Bputc(&amp;bout, '.');
		Bprint(&amp;bout, "%s", fetchPartNames[f-&gt;part]);
		if(f-&gt;hdrs != nil){
			Bprint(&amp;bout, " (");
			BSList(&amp;bout, f-&gt;hdrs, " ");
			Bputc(&amp;bout, ')');
		}
	}
	Bprint(&amp;bout, "]");
	return findMsgSect(m, f-&gt;sect);
}

/*
 * actually return the body pieces
 */
void
fetchBody(Msg *m, Fetch *f)
{
	Pair p;
	char *s, *t, *e, buf[BufSize + 2];
	ulong n, start, stop, pos;
	int fd, nn;

	if(m == nil){
		fetchBodyStr(f, "", 0);
		return;
	}
	switch(f-&gt;part){
	case FPHeadFields:
	case FPHeadFieldsNot:
		n = m-&gt;head.size + 3;
		s = emalloc(n);
		n = selectFields(s, n, m-&gt;head.buf, f-&gt;hdrs, f-&gt;part == FPHeadFields);
		fetchBodyStr(f, s, n);
		free(s);
		return;
	case FPHead:
		fetchBodyStr(f, m-&gt;head.buf, m-&gt;head.size);
		return;
	case FPMime:
		fetchBodyStr(f, m-&gt;mime.buf, m-&gt;mime.size);
		return;
	case FPAll:
		fd = msgFile(m, "rawbody");
		if(fd &lt; 0){
			msgDead(m);
			fetchBodyStr(f, "", 0);
			return;
		}
		p = fetchBodyPart(f, msgSize(m));
		start = p.start;
		if(start &lt; m-&gt;head.size){
			stop = p.stop;
			if(stop &gt; m-&gt;head.size)
				stop = m-&gt;head.size;
			Bwrite(&amp;bout, &amp;m-&gt;head.buf[start], stop - start);
			start = 0;
			stop = p.stop;
			if(stop &lt;= m-&gt;head.size){
				close(fd);
				return;
			}
		}else
			start -= m-&gt;head.size;
		stop = p.stop - m-&gt;head.size;
		break;
	case FPText:
		fd = msgFile(m, "rawbody");
		if(fd &lt; 0){
			msgDead(m);
			fetchBodyStr(f, "", 0);
			return;
		}
		p = fetchBodyPart(f, m-&gt;size);
		start = p.start;
		stop = p.stop;
		break;
	default:
		fetchBodyStr(f, "", 0);
		return;
	}

	/*
	 * read in each block, convert \n without \r to \r\n.
	 * this means partial fetch requires fetching everything
	 * through stop, since we don't know how many \r's will be added
	 */
	buf[0] = ' ';
	for(pos = 0; pos &lt; stop; ){
		n = BufSize;
		if(n &gt; stop - pos)
			n = stop - pos;
		n = read(fd, &amp;buf[1], n);
		if(n &lt;= 0){
			fetchBodyFill(stop - pos);
			break;
		}
		e = &amp;buf[n + 1];
		*e = '\0';
		for(s = &amp;buf[1]; s &lt; e &amp;&amp; pos &lt; stop; s = t + 1){
			t = memchr(s, '\n', e - s);
			if(t == nil)
				t = e;
			n = t - s;
			if(pos &lt; start){
				if(pos + n &lt;= start){
					s = t;
					pos += n;
				}else{
					s += start - pos;
					pos = start;
				}
				n = t - s;
			}
			nn = n;
			if(pos + nn &gt; stop)
				nn = stop - pos;
			if(Bwrite(&amp;bout, s, nn) != nn)
				writeErr();
			pos += n;
			if(*t == '\n'){
				if(t[-1] != '\r'){
					if(pos &gt;= start &amp;&amp; pos &lt; stop)
						Bputc(&amp;bout, '\r');
					pos++;
				}
				if(pos &gt;= start &amp;&amp; pos &lt; stop)
					Bputc(&amp;bout, '\n');
				pos++;
			}
		}
		buf[0] = e[-1];
	}
	close(fd);
}

/*
 * resolve the actual bounds of any partial fetch,
 * and print out the bounds &amp; size of string returned
 */
Pair
fetchBodyPart(Fetch *f, ulong size)
{
	Pair p;
	ulong start, stop;

	start = 0;
	stop = size;
	if(f-&gt;partial){
		start = f-&gt;start;
		if(start &gt; size)
			start = size;
		stop = start + f-&gt;size;
		if(stop &gt; size)
			stop = size;
		Bprint(&amp;bout, "&lt;%lud&gt;", start);
	}
	Bprint(&amp;bout, " {%lud}\r\n", stop - start);
	p.start = start;
	p.stop = stop;
	return p;
}

/*
 * something went wrong fetching data
 * produce fill bytes for what we've committed to produce
 */
void
fetchBodyFill(ulong n)
{
	while(n-- &gt; 0)
		if(Bputc(&amp;bout, ' ') &lt; 0)
			writeErr();
}

/*
 * return a simple string
 */
void
fetchBodyStr(Fetch *f, char *buf, ulong size)
{
	Pair p;

	p = fetchBodyPart(f, size);
	Bwrite(&amp;bout, &amp;buf[p.start], p.stop-p.start);
}

char*
printnlist(NList *sect)
{
	static char buf[100];
	char *p;

	for(p= buf; sect; sect=sect-&gt;next){
		p += sprint(p, "%ld", sect-&gt;n);
		if(sect-&gt;next)
			*p++ = '.';
	}
	*p = '\0';
	return buf;
}

/*
 * find the numbered sub-part of the message
 */
Msg*
findMsgSect(Msg *m, NList *sect)
{
	ulong id;

	for(; sect != nil; sect = sect-&gt;next){
		id = sect-&gt;n;
#ifdef HACK
		/* HACK to solve extra level of structure not visible from upas/fs  */
		if(m-&gt;kids == 0 &amp;&amp; id == 1 &amp;&amp; sect-&gt;next == nil){
			if(m-&gt;mime.type-&gt;s &amp;&amp; strcmp(m-&gt;mime.type-&gt;s, "message")==0)
			if(m-&gt;mime.type-&gt;t &amp;&amp; strcmp(m-&gt;mime.type-&gt;t, "rfc822")==0)
			if(m-&gt;head.type-&gt;s &amp;&amp; strcmp(m-&gt;head.type-&gt;s, "text")==0)
			if(m-&gt;head.type-&gt;t &amp;&amp; strcmp(m-&gt;head.type-&gt;t, "plain")==0)
				break;
		}
		/* end of HACK */
#endif HACK
		for(m = m-&gt;kids; m != nil; m = m-&gt;next)
			if(m-&gt;id == id)
				break;
		if(m == nil)
			return nil;
	}
	return m;
}

void
fetchEnvelope(Msg *m)
{
	Tm tm;

	Bputc(&amp;bout, '(');
	Brfc822date(&amp;bout, date2tm(&amp;tm, m-&gt;info[IDate]));
	Bputc(&amp;bout, ' ');
	Bimapstr(&amp;bout, m-&gt;info[ISubject]);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;from);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;sender);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;replyTo);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;to);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;cc);
	Bputc(&amp;bout, ' ');
	Bimapaddr(&amp;bout, m-&gt;bcc);
	Bputc(&amp;bout, ' ');
	Bimapstr(&amp;bout, m-&gt;info[IInReplyTo]);
	Bputc(&amp;bout, ' ');
	Bimapstr(&amp;bout, m-&gt;info[IMessageId]);
	Bputc(&amp;bout, ')');
}

void
fetchBodyStruct(Msg *m, Header *h, int extensions)
{
	Msg *k;
	ulong len;

	if(msgIsMulti(h)){
		Bputc(&amp;bout, '(');
		for(k = m-&gt;kids; k != nil; k = k-&gt;next)
			fetchBodyStruct(k, &amp;k-&gt;mime, extensions);

		Bputc(&amp;bout, ' ');
		Bimapstr(&amp;bout, h-&gt;type-&gt;t);

		if(extensions){
			Bputc(&amp;bout, ' ');
			BimapMimeParams(&amp;bout, h-&gt;type-&gt;next);
			fetchStructExt(h);
		}

		Bputc(&amp;bout, ')');
		return;
	}

	Bputc(&amp;bout, '(');
	if(h-&gt;type != nil){
		Bimapstr(&amp;bout, h-&gt;type-&gt;s);
		Bputc(&amp;bout, ' ');
		Bimapstr(&amp;bout, h-&gt;type-&gt;t);
		Bputc(&amp;bout, ' ');
		BimapMimeParams(&amp;bout, h-&gt;type-&gt;next);
	}else
		Bprint(&amp;bout, "\"text\" \"plain\" NIL");

	Bputc(&amp;bout, ' ');
	if(h-&gt;id != nil)
		Bimapstr(&amp;bout, h-&gt;id-&gt;s);
	else
		Bprint(&amp;bout, "NIL");

	Bputc(&amp;bout, ' ');
	if(h-&gt;description != nil)
		Bimapstr(&amp;bout, h-&gt;description-&gt;s);
	else
		Bprint(&amp;bout, "NIL");

	Bputc(&amp;bout, ' ');
	if(h-&gt;encoding != nil)
		Bimapstr(&amp;bout, h-&gt;encoding-&gt;s);
	else
		Bprint(&amp;bout, "NIL");

	/*
	 * this is so strange: return lengths for a body[text] response,
	 * except in the case of a multipart message, when return lengths for a body[] response
	 */
	len = m-&gt;size;
	if(h == &amp;m-&gt;mime)
		len += m-&gt;head.size;
	Bprint(&amp;bout, " %lud", len);

	len = m-&gt;lines;
	if(h == &amp;m-&gt;mime)
		len += m-&gt;head.lines;

	if(h-&gt;type == nil || cistrcmp(h-&gt;type-&gt;s, "text") == 0){
		Bprint(&amp;bout, " %lud", len);
	}else if(msgIsRfc822(h)){
		Bputc(&amp;bout, ' ');
		k = m;
		if(h != &amp;m-&gt;mime)
			k = m-&gt;kids;
		if(k == nil)
			Bprint(&amp;bout, "(NIL NIL NIL NIL NIL NIL NIL NIL NIL NIL) (\"text\" \"plain\" NIL NIL NIL NIL 0 0) 0");
		else{
			fetchEnvelope(k);
			Bputc(&amp;bout, ' ');
			fetchBodyStruct(k, &amp;k-&gt;head, extensions);
			Bprint(&amp;bout, " %lud", len);
		}
	}

	if(extensions){
		Bputc(&amp;bout, ' ');

		/*
		 * don't have the md5 laying around,
		 * since the header &amp; body have added newlines.
		 */
		Bprint(&amp;bout, "NIL");

		fetchStructExt(h);
	}
	Bputc(&amp;bout, ')');
}

/*
 * common part of bodystructure extensions
 */
void
fetchStructExt(Header *h)
{
	Bputc(&amp;bout, ' ');
	if(h-&gt;disposition != nil){
		Bputc(&amp;bout, '(');
		Bimapstr(&amp;bout, h-&gt;disposition-&gt;s);
		Bputc(&amp;bout, ' ');
		BimapMimeParams(&amp;bout, h-&gt;disposition-&gt;next);
		Bputc(&amp;bout, ')');
	}else
		Bprint(&amp;bout, "NIL");
	Bputc(&amp;bout, ' ');
	if(h-&gt;language != nil){
		if(h-&gt;language-&gt;next != nil)
			BimapMimeParams(&amp;bout, h-&gt;language-&gt;next);
		else
			Bimapstr(&amp;bout, h-&gt;language-&gt;s);
	}else
		Bprint(&amp;bout, "NIL");
}

int
BimapMimeParams(Biobuf *b, MimeHdr *mh)
{
	char *sep;
	int n;

	if(mh == nil)
		return Bprint(b, "NIL");

	n = Bputc(b, '(');

	sep = "";
	for(; mh != nil; mh = mh-&gt;next){
		n += Bprint(b, sep);
		n += Bimapstr(b, mh-&gt;s);
		n += Bputc(b, ' ');
		n += Bimapstr(b, mh-&gt;t);
		sep = " ";
	}

	n += Bputc(b, ')');
	return n;
}

/*
 * print a list of addresses;
 * each address is printed as '(' personalName AtDomainList mboxName hostName ')'
 * the AtDomainList is always NIL
 */
int
Bimapaddr(Biobuf *b, MAddr *a)
{
	char *host, *sep;
	int n;

	if(a == nil)
		return Bprint(b, "NIL");

	n = Bputc(b, '(');
	sep = "";
	for(; a != nil; a = a-&gt;next){
		n += Bprint(b, "%s(", sep);
		n += Bimapstr(b, a-&gt;personal);
		n += Bprint(b," NIL ");
		n += Bimapstr(b, a-&gt;box);
		n += Bputc(b, ' ');

		/*
		 * can't send NIL as hostName, since that is code for a group
		 */
		host = a-&gt;host;
		if(host == nil)
			host = "";
		n += Bimapstr(b, host);

		n += Bputc(b, ')');
		sep = " ";
	}
	n += Bputc(b, ')');
	return n;
}
<!-- BEGIN TAIL -->
</pre>
</td></tr></table>
</td></tr></table>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<p style="line-height: 1.2em; margin-left: 1.00in; text-indent: 0.00in; margin-right: 1.00in; margin-top: 0; margin-bottom: 0; text-align: center;">
<span style="font-size: 10pt"></span></p>
<p style="margin-top: 0; margin-bottom: 0.50in"></p>
<p style="margin-top: 0; margin-bottom: 0.33in"></p>
<center><table border="0"><tr>
<td valign="middle"><a href="http://www.alcatel-lucent.com/"><img border="0" src="/plan9/img/logo_ft.gif" alt="Bell Labs" />
</a></td>
<td valign="middle"><a href="http://www.opensource.org"><img border="0" alt="OSI certified" src="/plan9/img/osi-certified-60x50.gif" />
</a></td>
<td><img style="padding-right: 45px;" alt="Powered by Plan 9" src="/plan9/img/power36.gif" />
</td>
</tr></table></center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center>
<span style="font-size: 10pt">(<a href="/plan9/">Return to Plan 9 Home Page</a>)</span>
</center>
<p style="margin-top: 0; margin-bottom: 0.17in"></p>
<center><font size=-1>
<span style="font-size: 10pt"><a href="http://www.lucent.com/copyright.html">Copyright</a></span>
<span style="font-size: 10pt">© 2009 Alcatel-Lucent.</span>
<span style="font-size: 10pt">All Rights Reserved.</span>
<br />
<span style="font-size: 10pt">Comments to</span>
<span style="font-size: 10pt"><a href="mailto:webmaster@plan9.bell-labs.com">webmaster@plan9.bell-labs.com</a>.</span>
</font></center>
</body>
</html>

